// @ts-nocheck
"use strict";
export function semanticAnalysis(queryText){
    var main;
    (function($rt_globals) {
    var $rt_seed = 2463534242;
    function $rt_nextId() {
        var x = $rt_seed;
        x ^= x << 13;
        x ^= x >> 17;
        x ^= x << 5;
        $rt_seed = x;
        return x;
    }
    function $rt_compare(a, b) {
        return a > b ? 1 : a < b ?  -1 : a === b ? 0 : 1;
    }
    function $rt_isInstance(obj, cls) {
        return obj !== null && !!obj.constructor.$meta && $rt_isAssignable(obj.constructor, cls);
    }
    function $rt_isAssignable(from, to) {
        if (from === to) {
            return true;
        }
        if (to.$meta.item !== null) {
            return from.$meta.item !== null && $rt_isAssignable(from.$meta.item, to.$meta.item);
        }
        var supertypes = from.$meta.supertypes;
        for (var i = 0;i < supertypes.length;i = i + 1 | 0) {
            if ($rt_isAssignable(supertypes[i], to)) {
                return true;
            }
        }
        return false;
    }
    function $rt_castToInterface(obj, cls) {
        if (obj !== null && !$rt_isInstance(obj, cls)) {
            $rt_throwCCE();
        }
        return obj;
    }
    function $rt_castToClass(obj, cls) {
        if (obj !== null && !(obj instanceof cls)) {
            $rt_throwCCE();
        }
        return obj;
    }
    $rt_globals.Array.prototype.fill = $rt_globals.Array.prototype.fill || function(value, start, end) {
        var len = this.length;
        if (!len) return this;
        start = start | 0;
        var i = start < 0 ? $rt_globals.Math.max(len + start, 0) : $rt_globals.Math.min(start, len);
        end = end === $rt_globals.undefined ? len : end | 0;
        end = end < 0 ? $rt_globals.Math.max(len + end, 0) : $rt_globals.Math.min(end, len);
        for (;i < end;i++) {
            this[i] = value;
        }
        return this;
    };
    function $rt_createArray(cls, sz) {
        var data = new $rt_globals.Array(sz);
        data.fill(null);
        return new $rt_array(cls, data);
    }
    function $rt_createArrayFromData(cls, init) {
        return $rt_wrapArray(cls, init);
    }
    function $rt_wrapArray(cls, data) {
        return new $rt_array(cls, data);
    }
    function $rt_createUnfilledArray(cls, sz) {
        return new $rt_array(cls, new $rt_globals.Array(sz));
    }
    function $rt_createNumericArray(cls, nativeArray) {
        return new $rt_array(cls, nativeArray);
    }
    var $rt_createLongArray;
    var $rt_createLongArrayFromData;
    if (typeof $rt_globals.BigInt64Array !== 'function') {
        $rt_createLongArray = function(sz) {
            var data = new $rt_globals.Array(sz);
            var arr = new $rt_array($rt_longcls(), data);
            data.fill(Long_ZERO);
            return arr;
        };
        $rt_createLongArrayFromData = function(init) {
            return new $rt_array($rt_longcls(), init);
        };
    } else {
        $rt_createLongArray = function(sz) {
            return $rt_createNumericArray($rt_longcls(), new $rt_globals.BigInt64Array(sz));
        };
        $rt_createLongArrayFromData = function(data) {
            var buffer = new $rt_globals.BigInt64Array(data.length);
            buffer.set(data);
            return $rt_createNumericArray($rt_longcls(), buffer);
        };
    }
    function $rt_createCharArray(sz) {
        return $rt_createNumericArray($rt_charcls(), new $rt_globals.Uint16Array(sz));
    }
    function $rt_createCharArrayFromData(data) {
        var buffer = new $rt_globals.Uint16Array(data.length);
        buffer.set(data);
        return $rt_createNumericArray($rt_charcls(), buffer);
    }
    function $rt_createByteArray(sz) {
        return $rt_createNumericArray($rt_bytecls(), new $rt_globals.Int8Array(sz));
    }
    function $rt_createByteArrayFromData(data) {
        var buffer = new $rt_globals.Int8Array(data.length);
        buffer.set(data);
        return $rt_createNumericArray($rt_bytecls(), buffer);
    }
    function $rt_createShortArray(sz) {
        return $rt_createNumericArray($rt_shortcls(), new $rt_globals.Int16Array(sz));
    }
    function $rt_createShortArrayFromData(data) {
        var buffer = new $rt_globals.Int16Array(data.length);
        buffer.set(data);
        return $rt_createNumericArray($rt_shortcls(), buffer);
    }
    function $rt_createIntArray(sz) {
        return $rt_createNumericArray($rt_intcls(), new $rt_globals.Int32Array(sz));
    }
    function $rt_createIntArrayFromData(data) {
        var buffer = new $rt_globals.Int32Array(data.length);
        buffer.set(data);
        return $rt_createNumericArray($rt_intcls(), buffer);
    }
    function $rt_createBooleanArray(sz) {
        return $rt_createNumericArray($rt_booleancls(), new $rt_globals.Int8Array(sz));
    }
    function $rt_createBooleanArrayFromData(data) {
        var buffer = new $rt_globals.Int8Array(data.length);
        buffer.set(data);
        return $rt_createNumericArray($rt_booleancls(), buffer);
    }
    function $rt_createFloatArray(sz) {
        return $rt_createNumericArray($rt_floatcls(), new $rt_globals.Float32Array(sz));
    }
    function $rt_createFloatArrayFromData(data) {
        var buffer = new $rt_globals.Float32Array(data.length);
        buffer.set(data);
        return $rt_createNumericArray($rt_floatcls(), buffer);
    }
    function $rt_createDoubleArray(sz) {
        return $rt_createNumericArray($rt_doublecls(), new $rt_globals.Float64Array(sz));
    }
    function $rt_createDoubleArrayFromData(data) {
        var buffer = new $rt_globals.Float64Array(data.length);
        buffer.set(data);
        return $rt_createNumericArray($rt_doublecls(), buffer);
    }
    function $rt_arraycls(cls) {
        var result = cls.$array;
        if (result === null) {
            var arraycls = {  };
            var name = "[" + cls.$meta.binaryName;
            arraycls.$meta = { item : cls, supertypes : [$rt_objcls()], primitive : false, superclass : $rt_objcls(), name : name, binaryName : name, enum : false, simpleName : null, declaringClass : null, enclosingClass : null };
            arraycls.classObject = null;
            arraycls.$array = null;
            result = arraycls;
            cls.$array = arraycls;
        }
        return result;
    }
    function $rt_createcls() {
        return { $array : null, classObject : null, $meta : { supertypes : [], superclass : null } };
    }
    function $rt_createPrimitiveCls(name, binaryName) {
        var cls = $rt_createcls();
        cls.$meta.primitive = true;
        cls.$meta.name = name;
        cls.$meta.binaryName = binaryName;
        cls.$meta.enum = false;
        cls.$meta.item = null;
        cls.$meta.simpleName = null;
        cls.$meta.declaringClass = null;
        cls.$meta.enclosingClass = null;
        return cls;
    }
    var $rt_booleanclsCache = null;
    function $rt_booleancls() {
        if ($rt_booleanclsCache === null) {
            $rt_booleanclsCache = $rt_createPrimitiveCls("boolean", "Z");
        }
        return $rt_booleanclsCache;
    }
    var $rt_charclsCache = null;
    function $rt_charcls() {
        if ($rt_charclsCache === null) {
            $rt_charclsCache = $rt_createPrimitiveCls("char", "C");
        }
        return $rt_charclsCache;
    }
    var $rt_byteclsCache = null;
    function $rt_bytecls() {
        if ($rt_byteclsCache === null) {
            $rt_byteclsCache = $rt_createPrimitiveCls("byte", "B");
        }
        return $rt_byteclsCache;
    }
    var $rt_shortclsCache = null;
    function $rt_shortcls() {
        if ($rt_shortclsCache === null) {
            $rt_shortclsCache = $rt_createPrimitiveCls("short", "S");
        }
        return $rt_shortclsCache;
    }
    var $rt_intclsCache = null;
    function $rt_intcls() {
        if ($rt_intclsCache === null) {
            $rt_intclsCache = $rt_createPrimitiveCls("int", "I");
        }
        return $rt_intclsCache;
    }
    var $rt_longclsCache = null;
    function $rt_longcls() {
        if ($rt_longclsCache === null) {
            $rt_longclsCache = $rt_createPrimitiveCls("long", "J");
        }
        return $rt_longclsCache;
    }
    var $rt_floatclsCache = null;
    function $rt_floatcls() {
        if ($rt_floatclsCache === null) {
            $rt_floatclsCache = $rt_createPrimitiveCls("float", "F");
        }
        return $rt_floatclsCache;
    }
    var $rt_doubleclsCache = null;
    function $rt_doublecls() {
        if ($rt_doubleclsCache === null) {
            $rt_doubleclsCache = $rt_createPrimitiveCls("double", "D");
        }
        return $rt_doubleclsCache;
    }
    var $rt_voidclsCache = null;
    function $rt_voidcls() {
        if ($rt_voidclsCache === null) {
            $rt_voidclsCache = $rt_createPrimitiveCls("void", "V");
        }
        return $rt_voidclsCache;
    }
    function $rt_throw(ex) {
        throw $rt_exception(ex);
    }
    var $rt_javaExceptionProp = $rt_globals.Symbol("javaException");
    function $rt_exception(ex) {
        var err = ex.$jsException;
        if (!err) {
            var javaCause = $rt_throwableCause(ex);
            var jsCause = javaCause !== null ? javaCause.$jsException : $rt_globals.undefined;
            var cause = typeof jsCause === "object" ? { cause : jsCause } : $rt_globals.undefined;
            err = new JavaError("Java exception thrown", cause);
            if (typeof $rt_globals.Error.captureStackTrace === "function") {
                $rt_globals.Error.captureStackTrace(err);
            }
            err[$rt_javaExceptionProp] = ex;
            ex.$jsException = err;
            $rt_fillStack(err, ex);
        }
        return err;
    }
    function $rt_fillStack(err, ex) {
        if (typeof $rt_decodeStack === "function" && err.stack) {
            var stack = $rt_decodeStack(err.stack);
            var javaStack = $rt_createArray($rt_stecls(), stack.length);
            var elem;
            var noStack = false;
            for (var i = 0;i < stack.length;++i) {
                var element = stack[i];
                elem = $rt_createStackElement($rt_str(element.className), $rt_str(element.methodName), $rt_str(element.fileName), element.lineNumber);
                if (elem == null) {
                    noStack = true;
                    break;
                }
                javaStack.data[i] = elem;
            }
            if (!noStack) {
                $rt_setStack(ex, javaStack);
            }
        }
    }
    function $rt_createMultiArray(cls, dimensions) {
        var first = 0;
        for (var i = dimensions.length - 1;i >= 0;i = i - 1 | 0) {
            if (dimensions[i] === 0) {
                first = i;
                break;
            }
        }
        if (first > 0) {
            for (i = 0;i < first;i = i + 1 | 0) {
                cls = $rt_arraycls(cls);
            }
            if (first === dimensions.length - 1) {
                return $rt_createArray(cls, dimensions[first]);
            }
        }
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, first));
        var firstDim = dimensions[first] | 0;
        for (i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createArray(cls, firstDim);
        }
        return $rt_createMultiArrayImpl(cls, arrays, dimensions, first);
    }
    function $rt_createByteMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_bytecls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createByteArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_bytecls(), arrays, dimensions);
    }
    function $rt_createCharMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_charcls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createCharArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_charcls(), arrays, dimensions, 0);
    }
    function $rt_createBooleanMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_booleancls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createBooleanArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_booleancls(), arrays, dimensions, 0);
    }
    function $rt_createShortMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_shortcls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createShortArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_shortcls(), arrays, dimensions, 0);
    }
    function $rt_createIntMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_intcls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createIntArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_intcls(), arrays, dimensions, 0);
    }
    function $rt_createLongMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_longcls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createLongArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_longcls(), arrays, dimensions, 0);
    }
    function $rt_createFloatMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_floatcls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createFloatArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_floatcls(), arrays, dimensions, 0);
    }
    function $rt_createDoubleMultiArray(dimensions) {
        var arrays = new $rt_globals.Array($rt_primitiveArrayCount(dimensions, 0));
        if (arrays.length === 0) {
            return $rt_createMultiArray($rt_doublecls(), dimensions);
        }
        var firstDim = dimensions[0] | 0;
        for (var i = 0;i < arrays.length;i = i + 1 | 0) {
            arrays[i] = $rt_createDoubleArray(firstDim);
        }
        return $rt_createMultiArrayImpl($rt_doublecls(), arrays, dimensions, 0);
    }
    function $rt_primitiveArrayCount(dimensions, start) {
        var val = dimensions[start + 1] | 0;
        for (var i = start + 2;i < dimensions.length;i = i + 1 | 0) {
            val = val * (dimensions[i] | 0) | 0;
            if (val === 0) {
                break;
            }
        }
        return val;
    }
    function $rt_createMultiArrayImpl(cls, arrays, dimensions, start) {
        var limit = arrays.length;
        for (var i = start + 1 | 0;i < dimensions.length;i = i + 1 | 0) {
            cls = $rt_arraycls(cls);
            var dim = dimensions[i];
            var index = 0;
            var packedIndex = 0;
            while (index < limit) {
                var arr = $rt_createUnfilledArray(cls, dim);
                for (var j = 0;j < dim;j = j + 1 | 0) {
                    arr.data[j] = arrays[index];
                    index = index + 1 | 0;
                }
                arrays[packedIndex] = arr;
                packedIndex = packedIndex + 1 | 0;
            }
            limit = packedIndex;
        }
        return arrays[0];
    }
    function $rt_assertNotNaN(value) {
        if (typeof value === 'number' && $rt_globals.isNaN(value)) {
            throw "NaN";
        }
        return value;
    }
    function $rt_createOutputFunction(printFunction) {
        var buffer = "";
        var utf8Buffer = 0;
        var utf8Remaining = 0;
        function putCodePoint(ch) {
            if (ch === 0xA) {
                printFunction(buffer);
                buffer = "";
            } else if (ch < 0x10000) {
                buffer += $rt_globals.String.fromCharCode(ch);
            } else {
                ch = ch - 0x10000 | 0;
                var hi = (ch >> 10) + 0xD800;
                var lo = (ch & 0x3FF) + 0xDC00;
                buffer += $rt_globals.String.fromCharCode(hi, lo);
            }
        }
        return function(ch) {
            if ((ch & 0x80) === 0) {
                putCodePoint(ch);
            } else if ((ch & 0xC0) === 0x80) {
                if (utf8Buffer > 0) {
                    utf8Remaining <<= 6;
                    utf8Remaining |= ch & 0x3F;
                    if ( --utf8Buffer === 0) {
                        putCodePoint(utf8Remaining);
                    }
                }
            } else if ((ch & 0xE0) === 0xC0) {
                utf8Remaining = ch & 0x1F;
                utf8Buffer = 1;
            } else if ((ch & 0xF0) === 0xE0) {
                utf8Remaining = ch & 0x0F;
                utf8Buffer = 2;
            } else if ((ch & 0xF8) === 0xF0) {
                utf8Remaining = ch & 0x07;
                utf8Buffer = 3;
            }
        };
    }
    var $rt_putStdout = typeof $rt_putStdoutCustom === "function" ? $rt_putStdoutCustom : typeof $rt_globals.console === "object" ? $rt_createOutputFunction(function(msg) {
        $rt_globals.console.info(msg);
    }) : function() {
    };
    var $rt_putStderr = typeof $rt_putStderrCustom === "function" ? $rt_putStderrCustom : typeof $rt_globals.console === "object" ? $rt_createOutputFunction(function(msg) {
        $rt_globals.console.error(msg);
    }) : function() {
    };
    var $rt_packageData = null;
    function $rt_packages(data) {
        var i = 0;
        var packages = new $rt_globals.Array(data.length);
        for (var j = 0;j < data.length;++j) {
            var prefixIndex = data[i++];
            var prefix = prefixIndex >= 0 ? packages[prefixIndex] : "";
            packages[j] = prefix + data[i++] + ".";
        }
        $rt_packageData = packages;
    }
    function $rt_metadata(data) {
        var packages = $rt_packageData;
        var i = 0;
        while (i < data.length) {
            var cls = data[i++];
            cls.$meta = {  };
            var m = cls.$meta;
            var className = data[i++];
            m.name = className !== 0 ? className : null;
            if (m.name !== null) {
                var packageIndex = data[i++];
                if (packageIndex >= 0) {
                    m.name = packages[packageIndex] + m.name;
                }
            }
            m.binaryName = "L" + m.name + ";";
            var superclass = data[i++];
            m.superclass = superclass !== 0 ? superclass : null;
            m.supertypes = data[i++];
            if (m.superclass) {
                m.supertypes.push(m.superclass);
                cls.prototype = $rt_globals.Object.create(m.superclass.prototype);
            } else {
                cls.prototype = {  };
            }
            var flags = data[i++];
            m.enum = (flags & 8) !== 0;
            m.flags = flags;
            m.primitive = false;
            m.item = null;
            cls.prototype.constructor = cls;
            cls.classObject = null;
            m.accessLevel = data[i++];
            var innerClassInfo = data[i++];
            if (innerClassInfo === 0) {
                m.simpleName = null;
                m.declaringClass = null;
                m.enclosingClass = null;
            } else {
                var enclosingClass = innerClassInfo[0];
                m.enclosingClass = enclosingClass !== 0 ? enclosingClass : null;
                var declaringClass = innerClassInfo[1];
                m.declaringClass = declaringClass !== 0 ? declaringClass : null;
                var simpleName = innerClassInfo[2];
                m.simpleName = simpleName !== 0 ? simpleName : null;
            }
            var clinit = data[i++];
            cls.$clinit = clinit !== 0 ? clinit : function() {
            };
            var virtualMethods = data[i++];
            if (virtualMethods !== 0) {
                for (var j = 0;j < virtualMethods.length;j += 2) {
                    var name = virtualMethods[j];
                    var func = virtualMethods[j + 1];
                    if (typeof name === 'string') {
                        name = [name];
                    }
                    for (var k = 0;k < name.length;++k) {
                        cls.prototype[name[k]] = func;
                    }
                }
            }
            cls.$array = null;
        }
    }
    function $rt_wrapFunction0(f) {
        return function() {
            return f(this);
        };
    }
    function $rt_wrapFunction1(f) {
        return function(p1) {
            return f(this, p1);
        };
    }
    function $rt_wrapFunction2(f) {
        return function(p1, p2) {
            return f(this, p1, p2);
        };
    }
    function $rt_wrapFunction3(f) {
        return function(p1, p2, p3) {
            return f(this, p1, p2, p3, p3);
        };
    }
    function $rt_wrapFunction4(f) {
        return function(p1, p2, p3, p4) {
            return f(this, p1, p2, p3, p4);
        };
    }
    function $rt_threadStarter(f) {
        return function() {
            var args = $rt_globals.Array.prototype.slice.apply(arguments);
            $rt_startThread(function() {
                f.apply(this, args);
            });
        };
    }
    function $rt_mainStarter(f) {
        return function(args, callback) {
            if (!args) {
                args = [];
            }
            var javaArgs = $rt_createArray($rt_objcls(), args.length);
            for (var i = 0;i < args.length;++i) {
                javaArgs.data[i] = $rt_str(args[i]);
            }
            return f.call(null, javaArgs);
        };
    }
    var $rt_stringPool_instance;
    function $rt_stringPool(strings) {
        $rt_stringPool_instance = new $rt_globals.Array(strings.length);
        for (var i = 0;i < strings.length;++i) {
            $rt_stringPool_instance[i] = $rt_intern($rt_str(strings[i]));
        }
    }
    function $rt_s(index) {
        return $rt_stringPool_instance[index];
    }
    function $rt_eraseClinit(target) {
        return target.$clinit = function() {
        };
    }
    var $rt_numberConversionView = new $rt_globals.DataView(new $rt_globals.ArrayBuffer(8));
    var $rt_doubleToLongBits;
    var $rt_longBitsToDouble;
    if (typeof $rt_globals.BigInt !== 'function') {
        $rt_doubleToLongBits = function(n) {
            $rt_numberConversionView.setFloat64(0, n, true);
            return new Long($rt_numberConversionView.getInt32(0, true), $rt_numberConversionView.getInt32(4, true));
        };
        $rt_longBitsToDouble = function(n) {
            $rt_numberConversionView.setInt32(0, n.lo, true);
            $rt_numberConversionView.setInt32(4, n.hi, true);
            return $rt_numberConversionView.getFloat64(0, true);
        };
    } else {
        $rt_doubleToLongBits = function(n) {
            $rt_numberConversionView.setFloat64(0, n, true);
            var lo = $rt_numberConversionView.getInt32(0, true);
            var hi = $rt_numberConversionView.getInt32(4, true);
            return $rt_globals.BigInt.asIntN(64, $rt_globals.BigInt.asUintN(32, $rt_globals.BigInt(lo)) | $rt_globals.BigInt(hi) << $rt_globals.BigInt(32));
        };
        $rt_longBitsToDouble = function(n) {
            var hi = $rt_globals.Number($rt_globals.BigInt.asIntN(32, n >> $rt_globals.BigInt(32)));
            var lo = $rt_globals.Number($rt_globals.BigInt.asIntN(32, n & $rt_globals.BigInt(0xFFFFFFFF)));
            $rt_numberConversionView.setInt32(0, lo, true);
            $rt_numberConversionView.setInt32(4, hi, true);
            return $rt_numberConversionView.getFloat64(0, true);
        };
    }
    function $rt_floatToIntBits(n) {
        $rt_numberConversionView.setFloat32(0, n);
        return $rt_numberConversionView.getInt32(0);
    }
    function $rt_intBitsToFloat(n) {
        $rt_numberConversionView.setInt32(0, n);
        return $rt_numberConversionView.getFloat32(0);
    }
    var JavaError;
    if (typeof $rt_globals.Reflect === 'object') {
        var defaultMessage = $rt_globals.Symbol("defaultMessage");
        JavaError = function JavaError(message, cause) {
            var self = $rt_globals.Reflect.construct($rt_globals.Error, [$rt_globals.undefined, cause], JavaError);
            $rt_globals.Object.setPrototypeOf(self, JavaError.prototype);
            self[defaultMessage] = message;
            return self;
        };
        JavaError.prototype = $rt_globals.Object.create($rt_globals.Error.prototype, { constructor : { configurable : true, writable : true, value : JavaError }, message : { get : function() {
            var javaException = this[$rt_javaExceptionProp];
            if (typeof javaException === 'object') {
                var javaMessage = $rt_throwableMessage(javaException);
                if (typeof javaMessage === "object") {
                    return javaMessage.toString();
                }
            }
            return this[defaultMessage];
        } } });
    } else {
        JavaError = $rt_globals.Error;
    }
    function $rt_javaException(e) {
        return e instanceof $rt_globals.Error && typeof e[$rt_javaExceptionProp] === 'object' ? e[$rt_javaExceptionProp] : null;
    }
    function $rt_jsException(e) {
        return typeof e.$jsException === 'object' ? e.$jsException : null;
    }
    function $rt_wrapException(err) {
        var ex = err[$rt_javaExceptionProp];
        if (!ex) {
            ex = $rt_createException($rt_str("(JavaScript) " + err.toString()));
            err[$rt_javaExceptionProp] = ex;
            ex.$jsException = err;
            $rt_fillStack(err, ex);
        }
        return ex;
    }
    function $dbg_class(obj) {
        var cls = obj.constructor;
        var arrayDegree = 0;
        while (cls.$meta && cls.$meta.item) {
            ++arrayDegree;
            cls = cls.$meta.item;
        }
        var clsName = "";
        if (cls === $rt_booleancls()) {
            clsName = "boolean";
        } else if (cls === $rt_bytecls()) {
            clsName = "byte";
        } else if (cls === $rt_shortcls()) {
            clsName = "short";
        } else if (cls === $rt_charcls()) {
            clsName = "char";
        } else if (cls === $rt_intcls()) {
            clsName = "int";
        } else if (cls === $rt_longcls()) {
            clsName = "long";
        } else if (cls === $rt_floatcls()) {
            clsName = "float";
        } else if (cls === $rt_doublecls()) {
            clsName = "double";
        } else {
            clsName = cls.$meta ? cls.$meta.name || "a/" + cls.name : "@" + cls.name;
        }
        while (arrayDegree-- > 0) {
            clsName += "[]";
        }
        return clsName;
    }
    function Long(lo, hi) {
        this.lo = lo | 0;
        this.hi = hi | 0;
    }
    Long.prototype.__teavm_class__ = function() {
        return "long";
    };
    function Long_isPositive(a) {
        return (a.hi & 0x80000000) === 0;
    }
    function Long_isNegative(a) {
        return (a.hi & 0x80000000) !== 0;
    }
    var Long_MAX_NORMAL = 1 << 18;
    var Long_ZERO;
    var Long_create;
    var Long_fromInt;
    var Long_fromNumber;
    var Long_toNumber;
    var Long_hi;
    var Long_lo;
    if (typeof $rt_globals.BigInt !== "function") {
        Long.prototype.toString = function() {
            var result = [];
            var n = this;
            var positive = Long_isPositive(n);
            if (!positive) {
                n = Long_neg(n);
            }
            var radix = new Long(10, 0);
            do  {
                var divRem = Long_divRem(n, radix);
                result.push($rt_globals.String.fromCharCode(48 + divRem[1].lo));
                n = divRem[0];
            }while (n.lo !== 0 || n.hi !== 0);
            result = (result.reverse()).join('');
            return positive ? result : "-" + result;
        };
        Long.prototype.valueOf = function() {
            return Long_toNumber(this);
        };
        Long_ZERO = new Long(0, 0);
        Long_fromInt = function(val) {
            return new Long(val,  -(val < 0) | 0);
        };
        Long_fromNumber = function(val) {
            if (val >= 0) {
                return new Long(val | 0, val / 0x100000000 | 0);
            } else {
                return Long_neg(new Long( -val | 0,  -val / 0x100000000 | 0));
            }
        };
        Long_create = function(lo, hi) {
            return new Long(lo, hi);
        };
        Long_toNumber = function(val) {
            return 0x100000000 * val.hi + (val.lo >>> 0);
        };
        Long_hi = function(val) {
            return val.hi;
        };
        Long_lo = function(val) {
            return val.lo;
        };
    } else {
        Long_ZERO = $rt_globals.BigInt(0);
        Long_create = function(lo, hi) {
            return $rt_globals.BigInt.asIntN(64, $rt_globals.BigInt.asUintN(32, $rt_globals.BigInt(lo)) | $rt_globals.BigInt(hi) << $rt_globals.BigInt(32));
        };
        Long_fromInt = function(val) {
            return $rt_globals.BigInt(val);
        };
        Long_fromNumber = function(val) {
            return $rt_globals.BigInt(val >= 0 ? $rt_globals.Math.floor(val) : $rt_globals.Math.ceil(val));
        };
        Long_toNumber = function(val) {
            return $rt_globals.Number(val);
        };
        Long_hi = function(val) {
            return $rt_globals.Number($rt_globals.BigInt.asIntN(64, val >> $rt_globals.BigInt(32))) | 0;
        };
        Long_lo = function(val) {
            return $rt_globals.Number($rt_globals.BigInt.asIntN(32, val)) | 0;
        };
    }
    var $rt_imul = $rt_globals.Math.imul || function(a, b) {
        var ah = a >>> 16 & 0xFFFF;
        var al = a & 0xFFFF;
        var bh = b >>> 16 & 0xFFFF;
        var bl = b & 0xFFFF;
        return al * bl + (ah * bl + al * bh << 16 >>> 0) | 0;
    };
    var $rt_udiv = function(a, b) {
        return (a >>> 0) / (b >>> 0) >>> 0;
    };
    var $rt_umod = function(a, b) {
        return (a >>> 0) % (b >>> 0) >>> 0;
    };
    function $rt_checkBounds(index, array) {
        if (index < 0 || index >= array.length) {
            $rt_throwAIOOBE();
        }
        return index;
    }
    function $rt_checkUpperBound(index, array) {
        if (index >= array.length) {
            $rt_throwAIOOBE();
        }
        return index;
    }
    function $rt_checkLowerBound(index) {
        if (index < 0) {
            $rt_throwAIOOBE();
        }
        return index;
    }
    function $rt_classWithoutFields(superclass) {
        if (superclass === 0) {
            return function() {
            };
        }
        if (superclass === void 0) {
            superclass = $rt_objcls();
        }
        return function() {
            superclass.call(this);
        };
    }
    function $rt_setCloneMethod(target, f) {
        target.$clone = f;
    }
    function $rt_cls(cls) {
        return jl_Class_getClass(cls);
    }
    function $rt_str(str) {
        if (str === null) {
            return null;
        }
        var characters = $rt_createCharArray(str.length);
        var charsBuffer = characters.data;
        for (var i = 0; i < str.length; i = (i + 1) | 0) {
            charsBuffer[i] = str.charCodeAt(i) & 0xFFFF;
        }
        return jl_String__init_(characters);
    }
    function $rt_ustr(str) {
        if (str === null) {
            return null;
        }
        var data = str.$characters.data;
        var result = "";
        for (var i = 0; i < data.length; i = (i + 1) | 0) {
            result += String.fromCharCode(data[i]);
        }
        return result;
    }
    function $rt_objcls() { return jl_Object; }
    function $rt_stecls() {
        return jl_Object;
    }
    function $rt_throwableMessage(t) {
        return jl_Throwable_getMessage(t);
    }
    function $rt_throwableCause(t) {
        return jl_Throwable_getCause(t);
    }
    function $rt_nullCheck(val) {
        if (val === null) {
            $rt_throw(jl_NullPointerException__init_());
        }
        return val;
    }
    function $rt_intern(str) {
        return str;
    }
    function $rt_getThread() {
        return jl_Thread_currentThread();
    }
    function $rt_setThread(t) {
        return jl_Thread_setCurrentThread(t);
    }
    function $rt_createException(message) {
        return jl_RuntimeException__init_(message);
    }
    function $rt_createStackElement(className, methodName, fileName, lineNumber) {
        return null;
    }
    function $rt_setStack(e, stack) {
    }
    function $rt_throwAIOOBE() {
        $rt_throw(jl_ArrayIndexOutOfBoundsException__init_());
    }
    function $rt_throwCCE() {
    }
    var $java = Object.create(null);
    function jl_Object() {
        this.$monitor = null;
        this.$id$ = 0;
    }
    function jl_Object__init_() {
        var var_0 = new jl_Object();
        jl_Object__init_0(var_0);
        return var_0;
    }
    function jl_Object_monitorEnterSync($o) {
        var var$2, var$3;
        if ($o.$monitor === null)
            jl_Object_createMonitor($o);
        var$2 = $o.$monitor;
        var$3 = var$2.$owner;
        if (var$3 === null)
            var$2.$owner = jl_Thread_currentThread();
        else if (var$3 !== jl_Thread_currentThread()) {
            var$2 = new jl_IllegalStateException;
            jl_Throwable__init_(var$2, $rt_s(0));
            $rt_throw(var$2);
        }
        $o = $o.$monitor;
        $o.$count = $o.$count + 1 | 0;
    }
    function jl_Object_monitorExitSync($o) {
        var var$2, var$3;
        if (!jl_Object_isEmptyMonitor($o) && $o.$monitor.$owner === jl_Thread_currentThread()) {
            var$2 = $o.$monitor;
            var$3 = var$2.$count - 1 | 0;
            var$2.$count = var$3;
            if (!var$3)
                var$2.$owner = null;
            jl_Object_isEmptyMonitor($o);
            return;
        }
        $o = new jl_IllegalMonitorStateException;
        jl_Throwable__init_0($o);
        $rt_throw($o);
    }
    function jl_Object_monitorEnter($o) {
        var var$2;
        if ($o.$monitor === null)
            jl_Object_createMonitor($o);
        var$2 = $o.$monitor;
        if (var$2.$owner === null)
            var$2.$owner = jl_Thread_currentThread();
        if ($o.$monitor.$owner !== jl_Thread_currentThread())
            jl_Object_monitorEnterWait($o, 1);
        else {
            $o = $o.$monitor;
            $o.$count = $o.$count + 1 | 0;
        }
    }
    function jl_Object_createMonitor($o) {
        var var$2;
        var$2 = new jl_Object$Monitor;
        var$2.$owner = jl_Thread_currentThread();
        $o.$monitor = var$2;
    }
    function jl_Object_monitorEnterWait(var$1, var$2) {
        var thread = $rt_nativeThread();
        var javaThread = $rt_getThread();
        if (thread.isResuming()) {
            thread.status = 0;
            var result = thread.attribute;
            if (result instanceof Error) {
                throw result;
            }
            return result;
        }
        var callback = function() {};
        callback.$complete = function(val) {
            thread.attribute = val;
            $rt_setThread(javaThread);
            thread.resume();
        };
        callback.$error = function(e) {
            thread.attribute = $rt_exception(e);
            $rt_setThread(javaThread);
            thread.resume();
        };
        callback = otpp_AsyncCallbackWrapper_create(callback);
        return thread.suspend(function() {
            try {
                jl_Object_monitorEnterWait0(var$1, var$2, callback);
            } catch($e) {
                callback.$error($rt_exception($e));
            }
        });
    }
    function jl_Object_monitorEnterWait0($o, $count, $callback) {
        var $thread_0, $monitor, var$6;
        $thread_0 = jl_Thread_currentThread();
        $monitor = $o.$monitor;
        if ($monitor === null) {
            jl_Object_createMonitor($o);
            jl_Thread_setCurrentThread($thread_0);
            $o = $o.$monitor;
            $o.$count = $o.$count + $count | 0;
            otpp_AsyncCallbackWrapper_complete($callback, null);
            return;
        }
        if ($monitor.$owner === null) {
            $monitor.$owner = $thread_0;
            jl_Thread_setCurrentThread($thread_0);
            $o = $o.$monitor;
            $o.$count = $o.$count + $count | 0;
            otpp_AsyncCallbackWrapper_complete($callback, null);
            return;
        }
        if ($monitor.$enteringThreads === null)
            $monitor.$enteringThreads = otp_Platform_createQueueJs$js_body$_30();
        $monitor = $monitor.$enteringThreads;
        var$6 = new jl_Object$monitorEnterWait$lambda$_6_0;
        var$6.$_0 = $thread_0;
        var$6.$_1 = $o;
        var$6.$_2 = $count;
        var$6.$_3 = $callback;
        $callback = var$6;
        $monitor.push($callback);
    }
    function jl_Object_monitorExit($o) {
        var var$2, var$3;
        if (!jl_Object_isEmptyMonitor($o) && $o.$monitor.$owner === jl_Thread_currentThread()) {
            var$2 = $o.$monitor;
            var$3 = var$2.$count - 1 | 0;
            var$2.$count = var$3;
            if (var$3 <= 0) {
                var$2.$owner = null;
                var$2 = var$2.$enteringThreads;
                if (var$2 !== null && !otp_PlatformQueue_isEmpty$static(var$2)) {
                    var$2 = new jl_Object$monitorExit$lambda$_8_0;
                    var$2.$_00 = $o;
                    otp_Platform_schedule(var$2, 0);
                } else
                    jl_Object_isEmptyMonitor($o);
            }
            return;
        }
        $o = new jl_IllegalMonitorStateException;
        jl_Throwable__init_0($o);
        $rt_throw($o);
    }
    function jl_Object_isEmptyMonitor($this) {
        var $monitor, var$2;
        $monitor = $this.$monitor;
        if ($monitor === null)
            return 1;
        a: {
            if ($monitor.$owner === null) {
                var$2 = $monitor.$enteringThreads;
                if (!(var$2 !== null && !otp_PlatformQueue_isEmpty$static(var$2))) {
                    $monitor = $monitor.$notifyListeners;
                    if ($monitor === null)
                        break a;
                    if (otp_PlatformQueue_isEmpty$static($monitor))
                        break a;
                }
            }
            return 0;
        }
        $this.$monitor = null;
        return 1;
    }
    function jl_Object__init_0($this) {}
    function jl_Object_getClass($this) {
        return jl_Class_getClass($this.constructor);
    }
    function jl_Object_hashCode($this) {
        return jl_Object_identity($this);
    }
    function jl_Object_equals($this, $other) {
        return $this !== $other ? 0 : 1;
    }
    function jl_Object_toString($this) {
        var var$1, var$2, var$3;
        var$1 = jl_Class_getName(jl_Object_getClass($this));
        var$2 = jl_Integer_toHexString(jl_Object_identity($this));
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$1 = jl_StringBuilder_append(var$3, var$1);
        jl_AbstractStringBuilder_append(var$1, 64);
        jl_StringBuilder_append(var$1, var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function jl_Object_identity($this) {
        var $platformThis, var$2;
        $platformThis = $this;
        if (!$platformThis.$id$) {
            var$2 = $rt_nextId();
            $platformThis.$id$ = var$2;
        }
        return $this.$id$;
    }
    function jl_Object_clone($this) {
        var $result, var$2, var$3;
        if (!$rt_isInstance($this, jl_Cloneable) && $this.constructor.$meta.item === null) {
            $result = new jl_CloneNotSupportedException;
            jl_Throwable__init_0($result);
            $rt_throw($result);
        }
        $result = otp_Platform_clone($this);
        var$2 = $result;
        var$3 = $rt_nextId();
        var$2.$id$ = var$3;
        return $result;
    }
    var ons_MainNodejs = $rt_classWithoutFields();
    function ons_MainNodejs_main($args) {
        jl_String__clinit_();
        jl_Integer__clinit_();
        jl_Character__clinit_();
        oncias_SemanticFeature$MultipleDatabases$__clinit_();
        oncias_SemanticFeature$MultipleGraphs$__clinit_();
        oncias_SemanticFeature$UseAsSingleGraphSelector$__clinit_();
        sci_Nil$__clinit_();
        sr_Statics__clinit_();
        oncifp_CompilationPhases$ParsingConfig$__clinit_();
        sci_Map$__clinit_();
        sci_Set$__clinit_();
        s_Tuple2$__clinit_();
        s_None$__clinit_();
        sr_NoManifest$__clinit_();
        sci_Map$EmptyMap$__clinit_();
        onciap_ExpressionStringifier$__clinit_();
        onciap_ExpressionStringifier$Extension$__clinit_();
        onciap_PatternStringifier$__clinit_();
        onciap_PathStepStringifier$__clinit_();
        onciap_Prettifier$__clinit_();
        onciap_Prettifier$EmptyExtension$__clinit_();
        sc_StringOps$__clinit_();
        sr_ScalaRunTime$__clinit_();
        oncirr_normalizeWithAndReturnClauses$__clinit_();
        onciu_topDown$__clinit_();
        s_PartialFunction$__clinit_();
        onciu_RewriterStopper$__clinit_();
        onciu_CancellationChecker$NeverCancelled$__clinit_();
        onciu_bottomUp$__clinit_();
        oncirr_rewriteShortestPathWithFixedLengthRelationship$__clinit_();
        sci_ArraySeq$__clinit_();
        jl_Boolean__clinit_();
        ju_Hashtable__clinit_();
        sci_LazyList$State$Empty$__clinit_();
        sc_Iterator$__clinit_();
        sci_Node$__clinit_();
        sci_VectorStatics$__clinit_();
        scm_RedBlackTree$__clinit_();
        onciu_StepSequencer$__clinit_();
        oncirc_package$PatternExpressionsHaveSemanticInfo$__clinit_();
        oncirr_ProjectionClausesHaveSemanticInfo$__clinit_();
        sci_Set$EmptySet$__clinit_();
        sc_View$__clinit_();
        sj_CollectionConverters$__clinit_();
        ju_Collections__clinit_();
        sjj_CollectionConverters$__clinit_();
        scm_ArrayBuffer$__clinit_();
        scm_MutationTracker$__clinit_();
        sci_Stream$Empty$__clinit_();
        sci_Stream$__clinit_();
        jl_Double__clinit_();
        jl_Long__clinit_();
        jl_Float__clinit_();
        jl_Byte__clinit_();
        jl_Short__clinit_();
        scm_HashSet$__clinit_();
        scm_ListBuffer$__clinit_();
        scm_Queue$__clinit_();
        scm_Stack$__clinit_();
        sci_ListSet$__clinit_();
        scm_ArraySeq$__clinit_();
        s_Array$__clinit_();
        sr_BoxedUnit__clinit_();
        sc_Hashing$__clinit_();
        sc_ArrayOps$__clinit_();
        jur_AbstractSet__clinit_();
        jur_AbstractCharClass$PredefinedCharacterClasses__clinit_();
        jur_AbstractCharClass__clinit_();
        onciuh_fixedPoint$__clinit_();
        onciu_Foldable$__clinit_();
        scm_ArrayDeque$__clinit_();
        oncirc_containsNoReturnAll$__clinit_();
        jl_AbstractStringBuilder$Constants__clinit_();
        otcit_DoubleAnalyzer__clinit_();
        otcit_FloatAnalyzer__clinit_();
        onciu_Ref$__clinit_();
        sm_Ordering$String$__clinit_();
        sci_ListSet$EmptyListSet$__clinit_();
        oncius_CypherType$__clinit_();
        sm_Ordering$Boolean$__clinit_();
        oncief_UnresolvedFunction$__clinit_();
        oncias_ExpressionTypeInfo$__clinit_();
        sci_$colon$colon$__clinit_();
        sc_package$$plus$colon$__clinit_();
        sc_package$$colon$plus$__clinit_();
        scm_StringBuilder$__clinit_();
        sci_Range$__clinit_();
        sm_Equiv$__clinit_();
        sm_Fractional$__clinit_();
        sm_Integral$__clinit_();
        sm_Numeric$__clinit_();
        sm_Ordered$__clinit_();
        sm_Ordering$__clinit_();
        su_Either$__clinit_();
        su_Left$__clinit_();
        su_Right$__clinit_();
        oncil_SolvableLabelExpression$__clinit_();
        oncil_NodeLabels$SomeUnknownLabels$__clinit_();
        scm_HashMap$__clinit_();
        scm_TreeSet$__clinit_();
        scm_RedBlackTree$Tree$__clinit_();
        oncirr_ReturnItemsAreAliased$__clinit_();
        oncirr_ExpressionsInOrderByAndWhereUseAliases$__clinit_();
        oncirr_WithBetweenOptionalMatchAndMatchInserted$__clinit_();
        oncirr_WithBetweenCallAndWhereInserted$__clinit_();
        oncirr_WithBetweenShowAndWhereInserted$__clinit_();
        oncirr_ShowRewrittenToShowYieldWhereReturn$__clinit_();
        oncirr_MultipleInPredicatesAreMerged$__clinit_();
        oncirr_TimestampRewritten$__clinit_();
        oncirr_NoShortestPathWithFixedLength$__clinit_();
        oncirc_package$LiteralsExtracted$__clinit_();
        oncirc_package$SensitiveLiteralsExtracted$__clinit_();
        oncirc_package$FunctionInvocationsResolved$__clinit_();
        onciu_Rewritable$__clinit_();
        onciu_Foldable$TreeAny$__clinit_();
        s_Predef$ArrowAssoc$__clinit_();
        onciu_StepSequencer$RepeatedSteps$Permitted$__clinit_();
        onciu_StepSequencer$RepeatedSteps$Forbidden$__clinit_();
        onciu_StepSequencer$MutableDirectedGraph$__clinit_();
        oncir_RewriterStep$__clinit_();
        onciuh_Math$__clinit_();
        oncia_ShowServers$__clinit_();
        oncia_ShowTransactionsClause$__clinit_();
        oncia_DefaultOrAllShowColumns$__clinit_();
        onciu_Rewritable$RewritableAny$__clinit_();
        jt_DecimalFormat__clinit_();
        oncias_SemanticState$ScopeLocation$__clinit_();
        s_$less$colon$less$__clinit_();
        oncie_TypeSignature$__clinit_();
        oncief_Category$__clinit_();
        oncie_FunctionTypeSignature$__clinit_();
        oncia_ReturnItems$__clinit_();
        oncias_SemanticCheck$__clinit_();
        oncia_ASTAnnotationMap$__clinit_();
        onciafn_TupleConverter$__clinit_();
        s_Option$__clinit_();
        oncia_ReadOnlyAccess$__clinit_();
        oncia_ReadWriteAccess$__clinit_();
        oncie_containsAggregate$__clinit_();
        oncias_SemanticFunctionCheck$__clinit_();
        oncir_Deprecations$semanticallyDeprecatedFeatures$__clinit_();
        oncifp_CreatePatternSelfReferenceCheck$__clinit_();
        sm_Ordering$Long$__clinit_();
        sm_Ordering$Char$__clinit_();
        sm_Ordering$Byte$__clinit_();
        sm_Ordering$Short$__clinit_();
        su_Sorting$__clinit_();
        onciu_devNullLogger$__clinit_();
        onciu_StepSequencer$ByInitialCondition$__clinit_();
        oncias_SemanticExpressionCheck$FilteringExpressions$__clinit_();
        oncie_Expression$TreeAcc$__clinit_();
        oncia_SubqueryCall$__clinit_();
        oncia_ASTSlicingPhrase$__clinit_();
        oncias_OptionSemanticChecking$__clinit_();
        oncias_package$__clinit_();
        oncie_Expression$SemanticContext$Results$__clinit_();
        oncia_ReadAction$__clinit_();
        oncia_TraverseAction$__clinit_();
        oncia_MatchAction$__clinit_();
        sc_SeqFactory$UnapplySeqWrapper$__clinit_();
        oncifp_ValidSymbolicNamesInLabelExpressions$__clinit_();
        oncie_LogicalProperty$__clinit_();
        oncie_LogicalVariable$__clinit_();
        oncia_ASTAnnotationMap$PositionedNode$__clinit_();
        oncias_ScopeTreeVerifier$__clinit_();
        oncia_With$__clinit_();
        oncia_DefaultWith$__clinit_();
        oncie_Expression$__clinit_();
        oncia_Where$__clinit_();
        oncias_SemanticCheckResult$__clinit_();
        oncie_ReduceExpression$__clinit_();
        oncia_ProjectionClause$__clinit_();
        oncia_Order$__clinit_();
        oncia_AmbiguousAggregation$__clinit_();
        oncius_TypeRange$__clinit_();
        oncie_NODE_TYPE$__clinit_();
        oncie_RELATIONSHIP_TYPE$__clinit_();
        oncie_Pattern$SemanticContext$Merge$__clinit_();
        oncie_Pattern$SemanticContext$Create$__clinit_();
        oncie_Pattern$SemanticContext$__clinit_();
        oncie_Pattern$SemanticContext$Match$__clinit_();
        oncie_Pattern$SemanticContext$Expression$__clinit_();
        oncie_SemanticDirection$OUTGOING$__clinit_();
        oncie_SemanticDirection$INCOMING$__clinit_();
        oncie_SemanticDirection$BOTH$__clinit_();
        oncias_IterableOnceSemanticChecking$__clinit_();
        sc_IterableOnceExtensionMethods$__clinit_();
        oncias_SemanticCheckableIterableOnce$__clinit_();
        onciuh_StringHelper$RichString$__clinit_();
        onciu_NotImplementedErrorMessageProvider$__clinit_();
        oncia_UsingAnyIndexType$__clinit_();
        oncia_UsingTextIndexType$__clinit_();
        oncia_SeekOnly$__clinit_();
        oncia_UsingRangeIndexType$__clinit_();
        oncia_UsingPointIndexType$__clinit_();
        sc_IterableFactory$__clinit_();
        oncie_Expression$SemanticContext$Simple$__clinit_();
        oncias_SemanticCheckableOption$__clinit_();
        oncia_BtreeIndexes$__clinit_();
        oncia_RemovedSyntax$__clinit_();
        oncias_SemanticFeature$ShowSetting$__clinit_();
        oncias_checkNoParamMapsWhenMatching$__clinit_();
        oncias_checkValidPropertyKeyNamesInPattern$__clinit_();
        oncia_ReturnItems$ReturnVariables$__clinit_();
        oncia_GraphReference$__clinit_();
        oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$__clinit_();
        oncia_AddedInRewrite$__clinit_();
        oncifp_ListCoercedToBooleanCheck$__clinit_();
        oncias_SymbolUse$__clinit_();
        oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$__clinit_();
        oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$__clinit_();
        oncias_SemanticFeature$MatchModes$__clinit_();
        oncia_ParsedAsYield$__clinit_();
        oncia_AllIndexes$__clinit_();
        oncia_RangeIndexes$__clinit_();
        oncia_FulltextIndexes$__clinit_();
        oncia_TextIndexes$__clinit_();
        oncia_PointIndexes$__clinit_();
        oncia_LookupIndexes$__clinit_();
        oncia_AllConstraints$__clinit_();
        oncia_UniqueConstraints$__clinit_();
        oncia_NodeUniqueConstraints$__clinit_();
        oncia_RelUniqueConstraints$__clinit_();
        oncia_KeyConstraints$__clinit_();
        oncia_NodeKeyConstraints$__clinit_();
        oncia_RelKeyConstraints$__clinit_();
        oncia_PropTypeConstraints$__clinit_();
        oncia_NodePropTypeConstraints$__clinit_();
        oncia_RelPropTypeConstraints$__clinit_();
        oncia_CurrentUser$__clinit_();
        oncia_AllFunctions$__clinit_();
        oncia_BuiltInFunctions$__clinit_();
        oncia_UserDefinedFunctions$__clinit_();
        oncie_Parameter$__clinit_();
        oncia_IfExistsDoNothing$__clinit_();
        oncia_IfExistsInvalidSyntax$__clinit_();
        oncia_IfExistsReplace$__clinit_();
        oncia_IfExistsThrowError$__clinit_();
        oncia_NoOptions$__clinit_();
        oncia_ConstraintVersion2$__clinit_();
        oncia_ConstraintVersion0$__clinit_();
        s_DummyImplicit$__clinit_();
        oncia_DestroyData$__clinit_();
        oncia_DumpData$__clinit_();
        oncie_ElementIdToLongId$Mode$Single$__clinit_();
        oncie_ElementIdToLongId$Mode$Many$__clinit_();
        oncia_Return$__clinit_();
        oncias_SemanticFeature$UseAsMultipleGraphsSelector$__clinit_();
        oncias_SemanticFeature$GpmShortestPath$__clinit_();
        oncias_SemanticCheckContext$default$__clinit_();
        oncias_SemanticCheckInterpreter$__clinit_();
        oncias_SemanticCheckInterpreter$ExecutableCheck$__clinit_();
        oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$__clinit_();
        oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$__clinit_();
        onciuh_Try$__clinit_();
        onciuh_Failure$__clinit_();
        otcic_StdoutOutputStream__clinit_();
        jnci_UTF8Charset__clinit_();
        otcic_StderrOutputStream__clinit_();
        jnc_CodingErrorAction__clinit_();
        jn_ByteOrder__clinit_();
        jnc_CoderResult__clinit_();
        oncifp_PatternExpressionInNonExistenceCheck$__clinit_();
        onciut_TailCallsUtil$__clinit_();
        suc_TailCalls$__clinit_();
        oncil_LabelExpression$Disjunctions$__clinit_();
        oncil_LabelExpression$Conjunctions$__clinit_();
        oncia_UsingJoinHint$__clinit_();
        oncia_ShowColumn$__clinit_();
        oncir_Deprecations$__clinit_();
        oncie_QuantifiedPath$__clinit_();
        oncm_MessageUtilProvider$__clinit_();
        oncias_SemanticFeature$PropertyValueAccessRules$__clinit_();
        oncie_SingleIterablePredicate$__clinit_();
        oncie_AllIterablePredicate$__clinit_();
        oncie_NoneIterablePredicate$__clinit_();
        oncie_AnyIterablePredicate$__clinit_();
        jlr_Modifier__clinit_();
        oncie_Namespace$__clinit_();
        oncie_IsAggregate$__clinit_();
        oncil_LabelExpression$__clinit_();
        oncia_AliasDriverSettingsCheck$__clinit_();
        sc_EvidenceIterableFactory$__clinit_();
        sc_BuildFrom$__clinit_();
        oncifp_extractSensitiveLiterals$__clinit_();
        oncifp_SemanticAnalyzer$IDPPlannerName$__clinit_();
        oncifp_InitialState$__clinit_();
        oncifp_SemanticAnalyzer$NoErrors$__clinit_();
        oncifh_package$__clinit_();
        oncifp_DeprecatedSyntaxReplaced$__clinit_();
        oncifp_DeprecatedSemanticsReplaced$__clinit_();
        oncifp_SemanticAnalysis$__clinit_();
        oncifp_PreparatoryRewriting$SemanticAnalysisPossible$__clinit_();
        oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$__clinit_();
        oncifp_CompilationPhaseTracer__clinit_();
        oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$__clinit_();
        onciafn_JavaCCParser$__clinit_();
        oncias_SemanticChecker$__clinit_();
        oncias_SemanticTable$__clinit_();
        onciu_inSequence$__clinit_();
        oncipj_CypherCharStream__clinit_();
        oncipj_CypherConstants__clinit_();
        s_Function$__clinit_();
        ju_Vector__clinit_();
        oncipj_CypherTokenManager__clinit_();
        oncipj_ParseException__clinit_();
        onciaf_ParserCypherTypeName__clinit_();
        oncia_CreateNodePropertyUniquenessConstraint$__clinit_();
        oncia_CreateRelationshipPropertyUniquenessConstraint$__clinit_();
        oncia_CreateNodeKeyConstraint$__clinit_();
        oncia_CreateRelationshipKeyConstraint$__clinit_();
        oncia_CreateNodePropertyExistenceConstraint$__clinit_();
        oncia_CreateRelationshipPropertyExistenceConstraint$__clinit_();
        oncia_CreateNodePropertyTypeConstraint$__clinit_();
        oncia_CreateRelationshipPropertyTypeConstraint$__clinit_();
        oncia_ConstraintVersion1$__clinit_();
        oncia_CreateRangeNodeIndex$__clinit_();
        oncia_CreateRangeRelationshipIndex$__clinit_();
        oncia_CreateBtreeNodeIndex$__clinit_();
        oncia_CreateBtreeRelationshipIndex$__clinit_();
        oncia_CreateTextNodeIndex$__clinit_();
        oncia_CreateTextRelationshipIndex$__clinit_();
        oncia_CreatePointNodeIndex$__clinit_();
        oncia_CreatePointRelationshipIndex$__clinit_();
        oncia_CreateFulltextRelationshipIndex$__clinit_();
        oncia_CreateFulltextNodeIndex$__clinit_();
        oncie_FunctionInvocation$__clinit_();
        oncia_CreateLookupIndex$__clinit_();
        oncia_CreateIndexOldSyntax$__clinit_();
        oncia_ShowAliases$__clinit_();
        oncia_ShowIndexesClause$__clinit_();
        oncia_ShowFunctionsClause$__clinit_();
        oncia_ShowConstraintsClause$__clinit_();
        oncia_ValidSyntax$__clinit_();
        oncia_ShowCurrentUser$__clinit_();
        oncia_ShowDatabase$__clinit_();
        oncia_ShowPrivileges$__clinit_();
        oncia_ShowPrivilegeCommands$__clinit_();
        oncia_ShowProceduresClause$__clinit_();
        oncia_ShowSettingsClause$__clinit_();
        oncia_ShowSupportedPrivilegeCommand$__clinit_();
        oncia_ShowUsers$__clinit_();
        oncia_ShowRoles$__clinit_();
        oncia_TerminateTransactionsClause$__clinit_();
        oncie_MatchMode$__clinit_();
        oncia_Merge$__clinit_();
        oncie_ExplicitParameter$__clinit_();
        oncia_TransactionColumn$__clinit_();
        onciu_UnknownSize$__clinit_();
        oncia_NamespacedName$__clinit_();
        oncia_RemoveHomeDatabaseAction$__clinit_();
        oncia_AllDatabaseAction$__clinit_();
        oncia_AccessDatabaseAction$__clinit_();
        oncia_StartDatabaseAction$__clinit_();
        oncia_StopDatabaseAction$__clinit_();
        oncia_AllIndexActions$__clinit_();
        oncia_CreateIndexAction$__clinit_();
        oncia_DropIndexAction$__clinit_();
        oncia_ShowIndexAction$__clinit_();
        oncia_AllConstraintActions$__clinit_();
        oncia_CreateConstraintAction$__clinit_();
        oncia_DropConstraintAction$__clinit_();
        oncia_ShowConstraintAction$__clinit_();
        oncia_AllTokenActions$__clinit_();
        oncia_CreatePropertyKeyAction$__clinit_();
        oncia_CreateNodeLabelAction$__clinit_();
        oncia_CreateRelationshipTypeAction$__clinit_();
        oncia_AllTransactionActions$__clinit_();
        oncia_ShowTransactionAction$__clinit_();
        oncia_TerminateTransactionAction$__clinit_();
        oncia_AllDbmsAction$__clinit_();
        oncia_AllUserActions$__clinit_();
        oncia_ShowUserAction$__clinit_();
        oncia_AlterUserAction$__clinit_();
        oncia_CreateUserAction$__clinit_();
        oncia_DropUserAction$__clinit_();
        oncia_RenameUserAction$__clinit_();
        oncia_SetPasswordsAction$__clinit_();
        oncia_SetUserStatusAction$__clinit_();
        oncia_SetUserHomeDatabaseAction$__clinit_();
        oncia_ImpersonateUserAction$__clinit_();
        oncia_AllRoleActions$__clinit_();
        oncia_ShowRoleAction$__clinit_();
        oncia_CreateRoleAction$__clinit_();
        oncia_DropRoleAction$__clinit_();
        oncia_RenameRoleAction$__clinit_();
        oncia_AssignRoleAction$__clinit_();
        oncia_RemoveRoleAction$__clinit_();
        oncia_AllDatabaseManagementActions$__clinit_();
        oncia_CreateDatabaseAction$__clinit_();
        oncia_DropDatabaseAction$__clinit_();
        oncia_CompositeDatabaseManagementActions$__clinit_();
        oncia_CreateCompositeDatabaseAction$__clinit_();
        oncia_DropCompositeDatabaseAction$__clinit_();
        oncia_AlterDatabaseAction$__clinit_();
        oncia_SetDatabaseAccessAction$__clinit_();
        oncia_AllAliasManagementActions$__clinit_();
        oncia_CreateAliasAction$__clinit_();
        oncia_DropAliasAction$__clinit_();
        oncia_AlterAliasAction$__clinit_();
        oncia_ShowAliasAction$__clinit_();
        oncia_AllPrivilegeActions$__clinit_();
        oncia_AssignPrivilegeAction$__clinit_();
        oncia_RemovePrivilegeAction$__clinit_();
        oncia_ShowPrivilegeAction$__clinit_();
        oncia_ExecuteFunctionAction$__clinit_();
        oncia_ExecuteBoostedFunctionAction$__clinit_();
        oncia_ExecuteProcedureAction$__clinit_();
        oncia_ExecuteBoostedProcedureAction$__clinit_();
        oncia_ExecuteAdminProcedureAction$__clinit_();
        oncia_ShowServerAction$__clinit_();
        oncia_ServerManagementAction$__clinit_();
        oncia_ShowSettingAction$__clinit_();
        oncia_AllGraphAction$__clinit_();
        oncia_WriteAction$__clinit_();
        oncia_CreateElementAction$__clinit_();
        oncia_MergeAdminAction$__clinit_();
        oncia_DeleteElementAction$__clinit_();
        oncia_SetLabelAction$__clinit_();
        oncia_RemoveLabelAction$__clinit_();
        oncia_SetPropertyAction$__clinit_();
        oncia_DropPropertyUniquenessConstraint$__clinit_();
        oncia_DropNodeKeyConstraint$__clinit_();
        oncia_DropNodePropertyExistenceConstraint$__clinit_();
        oncia_DropRelationshipPropertyExistenceConstraint$__clinit_();
        oncia_DropConstraintOnName$__clinit_();
        oncia_DropIndex$__clinit_();
        oncia_DropIndexOnName$__clinit_();
        oncie_MatchMode$DifferentRelationships$__clinit_();
        oncia_ProcedureResultItem$__clinit_();
        oncia_SubqueryCall$InTransactionsParameters$__clinit_();
        onciu_NonEmptyList$__clinit_();
        oncia_LoadAction$__clinit_();
        oncia_SeekOrScan$__clinit_();
        oncie_Ands$__clinit_();
        sci_TreeSeqMap$Ordering$Zero$__clinit_();
        sci_TreeSeqMap$OrderBy$Insertion$__clinit_();
        sci_TreeSeqMap$OrderBy$Modification$__clinit_();
        oncie_ListComprehension$__clinit_();
        return ons_MainNodejs_analyzeQuery($args.data[0]);
    }
    function ons_MainNodejs_analyzeQuery($queryText) {
        var $result, $semanticErrors, var$4, var$5, var$6, var$7, var$8, $$je;
        oncifp_SemanticAnalyzer$_$callClinit();
        $result = oncifp_SemanticAnalyzer$_MODULE$;
        $semanticErrors = new oncifp_InitialState;
        var$4 = s_None$_MODULE$;
        var$5 = oncifp_SemanticAnalyzer$IDPPlannerName$_MODULE$;
        var$6 = new onciu_AnonymousVariableNameGenerator;
        var$6.$counter = 0;
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        var$7 = sci_Set$EmptySet$_MODULE$;
        var$8 = s_None$_MODULE$;
        oncifp_InitialState__init_($semanticErrors, $queryText, var$4, var$5, var$6, var$4, var$4, var$4, var$4, var$4, var$7, var$8, var$8);
        a: {
            try {
                oncifp_PipeLine_transform(oncifp_SemanticAnalyzer$_parsing($result), $semanticErrors, oncifp_SemanticAnalyzer$_context($result));
                $queryText = oncifp_SemanticAnalyzer$NoErrors$_MODULE$;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_Throwable) {
                    $queryText = $$je;
                } else {
                    throw $$e;
                }
            }
            if (!$rt_isInstance($queryText, oncifp_SemanticAnalyzer$SemanticErrors))
                $rt_throw($queryText);
            $queryText = $queryText;
        }
        $result = ju_ArrayList__init_();
        if ($queryText instanceof oncifp_SemanticAnalyzer$SomeErrors) {
            $semanticErrors = $queryText.$errs;
            $queryText = new ons_MainNodejs$analyzeQuery$lambda$_2_0;
            $queryText.$_01 = $result;
            $semanticErrors.$foreach($queryText);
        }
        return $result;
    }
    var jlr_AnnotatedElement = $rt_classWithoutFields(0);
    var jlr_Type = $rt_classWithoutFields(0);
    function jl_Class() {
        var a = this; jl_Object.call(a);
        a.$name = null;
        a.$simpleName = null;
        a.$platformClass = null;
        a.$declaredFields = null;
        a.$declaredMethods = null;
    }
    var jl_Class_reflectionInitialized = 0;
    function jl_Class_getClass($cls) {
        var $result, var$3;
        if ($cls === null)
            return null;
        $result = $cls.classObject;
        if ($result === null) {
            $result = new jl_Class;
            $result.$platformClass = $cls;
            var$3 = $result;
            $cls.classObject = var$3;
        }
        return $result;
    }
    function jl_Class_toString($this) {
        var var$1, var$2, var$3;
        var$1 = jl_Class_isInterface($this) ? $rt_s(1) : !jl_Class_isPrimitive($this) ? $rt_s(2) : $rt_s(3);
        var$2 = jl_Class_getName($this);
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$1), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function jl_Class_isInstance($this, $obj) {
        var var$2;
        $obj = $obj;
        var$2 = $this.$platformClass;
        return $obj !== null && !(typeof $obj.constructor.$meta === 'undefined' ? 1 : 0) && otp_Platform_isAssignable($obj.constructor, var$2) ? 1 : 0;
    }
    function jl_Class_isAssignableFrom($this, $obj) {
        return otp_Platform_isAssignable($obj.$platformClass, $this.$platformClass);
    }
    function jl_Class_getName($this) {
        if ($this.$name === null)
            $this.$name = otp_Platform_getName($this.$platformClass);
        return $this.$name;
    }
    function jl_Class_getSimpleName($this) {
        var $simpleName, var$2, $lastDollar, $lastDot;
        $simpleName = $this.$simpleName;
        if ($simpleName === null) {
            if (jl_Class_isArray($this)) {
                $simpleName = jl_Class_getSimpleName(jl_Class_getComponentType($this));
                var$2 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$2);
                jl_StringBuilder_append(jl_StringBuilder_append(var$2, $simpleName), $rt_s(4));
                $simpleName = jl_AbstractStringBuilder_toString(var$2);
            } else {
                $simpleName = $this.$platformClass.$meta.enclosingClass;
                if (($simpleName === null ? null : jl_Class_getClass($simpleName)) !== null) {
                    $simpleName = $rt_str($this.$platformClass.$meta.simpleName);
                    if ($simpleName === null)
                        $simpleName = $rt_s(3);
                } else {
                    $simpleName = otp_Platform_getName($this.$platformClass);
                    $lastDollar = jl_String_lastIndexOf($simpleName, 36);
                    if ($lastDollar == (-1)) {
                        $lastDot = jl_String_lastIndexOf($simpleName, 46);
                        if ($lastDot != (-1))
                            $simpleName = jl_String_substring($simpleName, $lastDot + 1 | 0);
                    } else {
                        $simpleName = jl_String_substring($simpleName, $lastDollar + 1 | 0);
                        if (jl_String_charAt($simpleName, 0) >= 48 && jl_String_charAt($simpleName, 0) <= 57)
                            $simpleName = $rt_s(3);
                    }
                }
            }
            $this.$simpleName = $simpleName;
        }
        return $simpleName;
    }
    function jl_Class_isPrimitive($this) {
        return $this.$platformClass.$meta.primitive ? 1 : 0;
    }
    function jl_Class_isArray($this) {
        return otp_Platform_getArrayItem($this.$platformClass) === null ? 0 : 1;
    }
    function jl_Class_isInterface($this) {
        return !($this.$platformClass.$meta.flags & 2) ? 0 : 1;
    }
    function jl_Class_getComponentType($this) {
        return jl_Class_getClass(otp_Platform_getArrayItem($this.$platformClass));
    }
    function jl_Class_getDeclaredFields($this) {
        var $jsFields, $i, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11;
        if (!jl_Class_isPrimitive($this) && !jl_Class_isArray($this)) {
            a: {
                if ($this.$declaredFields === null) {
                    jl_Class_initReflection();
                    $jsFields = $this.$platformClass.$meta.fields;
                    $this.$declaredFields = $rt_createArray(jlr_Field, $jsFields.length);
                    $i = 0;
                    while (true) {
                        if ($i >= $jsFields.length)
                            break a;
                        var$3 = $jsFields[$i];
                        var$4 = $this.$declaredFields.data;
                        var$5 = new jlr_Field;
                        var$6 = $rt_str(var$3.name);
                        var$7 = var$3.modifiers;
                        var$8 = var$3.accessLevel;
                        var$9 = jl_Class_getClass(var$3.type);
                        var$10 = otji_JS_functionAsObject(var$3.getter, "get");
                        var$11 = otji_JS_functionAsObject(var$3.setter, "set");
                        var$5.$declaringClass = $this;
                        var$5.$name0 = var$6;
                        var$5.$modifiers = var$7;
                        var$5.$accessLevel = var$8;
                        var$5.$type = var$9;
                        var$5.$getter = var$10;
                        var$5.$setter = var$11;
                        var$4[$i] = var$5;
                        $i = $i + 1 | 0;
                    }
                }
            }
            return $this.$declaredFields.$clone();
        }
        return $rt_createArray(jlr_Field, 0);
    }
    function jl_Class_initReflection() {
        if (!jl_Class_reflectionInitialized) {
            jl_Class_reflectionInitialized = 1;
            jl_Class_createMetadata();
        }
    }
    function jl_Class_createMetadata() {
        oncius_CypherTypeOrder$.$meta.fields = [
            {
                name : "MODULE$",
                modifiers : 516,
                accessLevel : 3,
                type : oncius_CypherTypeOrder$,
                getter : null,
                setter : null
            }, {
                name : "NOTHING",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "NULL",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "BOOLEAN",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "STRING",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "INTEGER",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "FLOAT",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "DATE",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "LOCAL_TIME",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "ZONED_TIME",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "LOCAL_DATETIME",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "ZONED_DATETIME",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "DURATION",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "POINT",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "NODE",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "RELATIONSHIP",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "MAP",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "LIST",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "PATH",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "CLOSED_DYNAMIC_UNION",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }, {
                name : "ANY",
                modifiers : 516,
                accessLevel : 1,
                type : s_Enumeration$Value,
                getter : null,
                setter : null
            }];
        s_Enumeration.$meta.fields = [
            {
                name : "scala$Enumeration$$vmap",
                modifiers : 4,
                accessLevel : 1,
                type : scm_Map,
                getter : null,
                setter : null
            }, {
                name : "vset",
                modifiers : 12288,
                accessLevel : 1,
                type : s_Enumeration$ValueSet,
                getter : null,
                setter : null
            }, {
                name : "scala$Enumeration$$vsetDefined",
                modifiers : 28672,
                accessLevel : 1,
                type : $rt_booleancls(),
                getter : null,
                setter : null
            }, {
                name : "nmap",
                modifiers : 4,
                accessLevel : 1,
                type : scm_Map,
                getter : null,
                setter : null
            }, {
                name : "nextId",
                modifiers : 0,
                accessLevel : 1,
                type : $rt_intcls(),
                getter : null,
                setter : null
            }, {
                name : "nextName",
                modifiers : 0,
                accessLevel : 1,
                type : sc_Iterator,
                getter : null,
                setter : null
            }, {
                name : "scala$Enumeration$$topId",
                modifiers : 0,
                accessLevel : 3,
                type : $rt_intcls(),
                getter : null,
                setter : null
            }, {
                name : "scala$Enumeration$$bottomId",
                modifiers : 0,
                accessLevel : 3,
                type : $rt_intcls(),
                getter : null,
                setter : null
            }];
        jl_Object.$meta.fields = [
            {
                name : "monitor",
                modifiers : 0,
                accessLevel : 0,
                type : jl_Object$Monitor,
                getter : null,
                setter : null
            }];
        oncius_CypherTypeOrder$.$meta.methods = [
            {
                name : "<clinit>",
                modifiers : 512,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "NOTHING",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "NULL",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "BOOLEAN",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "STRING",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "INTEGER",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "FLOAT",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "DATE",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "LOCAL_TIME",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "ZONED_TIME",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "LOCAL_DATETIME",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "ZONED_DATETIME",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "DURATION",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "POINT",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "NODE",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "RELATIONSHIP",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "MAP",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "LIST",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "PATH",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "CLOSED_DYNAMIC_UNION",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "ANY",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "writeReplace",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : jl_Object,
                callable : null
            }, {
                name : "<init>",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }];
        s_Enumeration.$meta.methods = [
            {
                name : "ValueOrdering",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$ValueOrdering$,
                callable : null
            }, {
                name : "ValueSet",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$ValueSet$,
                callable : null
            }, {
                name : "readResolve",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : jl_Object,
                callable : null
            }, {
                name : "toString",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : jl_String,
                callable : null
            }, {
                name : "scala$Enumeration$$vmap",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : scm_Map,
                callable : null
            }, {
                name : "vset",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : s_Enumeration$ValueSet,
                callable : null
            }, {
                name : "vset_$eq",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [s_Enumeration$ValueSet],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "vsetDefined",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_booleancls(),
                callable : null
            }, {
                name : "scala$Enumeration$$vsetDefined_$eq",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [$rt_booleancls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "values",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$ValueSet,
                callable : null
            }, {
                name : "nextId",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "nextId_$eq",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [$rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "nextName",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : sc_Iterator,
                callable : null
            }, {
                name : "nextName_$eq",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [sc_Iterator],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "scala$Enumeration$$nextNameOrNull",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : jl_String,
                callable : null
            }, {
                name : "maxId",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "apply",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [$rt_intcls()],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "withName",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [jl_String],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "Value",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "Value",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [$rt_intcls()],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "Value",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [jl_String],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "Value",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [$rt_intcls(), jl_String],
                returnType : s_Enumeration$Value,
                callable : null
            }, {
                name : "populateNameMap",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "scala$Enumeration$$nameOf",
                modifiers : 2048,
                accessLevel : 3,
                parameterTypes : [$rt_intcls()],
                returnType : jl_String,
                callable : null
            }, {
                name : "ValueOrdering$lzycompute$1",
                modifiers : 4,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "ValueSet$lzycompute$1",
                modifiers : 4,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "$anonfun$withName$1",
                modifiers : 548,
                accessLevel : 3,
                parameterTypes : [jl_String],
                returnType : sr_Nothing$,
                callable : null
            }, {
                name : "getFields$1",
                modifiers : 4,
                accessLevel : 1,
                parameterTypes : [jl_Class, $rt_arraycls(jlr_Field)],
                returnType : $rt_arraycls(jlr_Field),
                callable : null
            }, {
                name : "$anonfun$populateNameMap$1",
                modifiers : 548,
                accessLevel : 3,
                parameterTypes : [jlr_Method, jlr_Field],
                returnType : $rt_booleancls(),
                callable : null
            }, {
                name : "isValDef$1",
                modifiers : 516,
                accessLevel : 1,
                parameterTypes : [jlr_Method, $rt_arraycls(jlr_Field)],
                returnType : $rt_booleancls(),
                callable : null
            }, {
                name : "$anonfun$populateNameMap$2",
                modifiers : 548,
                accessLevel : 3,
                parameterTypes : [$rt_arraycls(jlr_Field), jlr_Method],
                returnType : $rt_booleancls(),
                callable : null
            }, {
                name : "$anonfun$populateNameMap$3",
                modifiers : 548,
                accessLevel : 3,
                parameterTypes : [s_Enumeration, jlr_Method],
                returnType : jl_Object,
                callable : null
            }, {
                name : "$anonfun$nameOf$1",
                modifiers : 548,
                accessLevel : 3,
                parameterTypes : [s_Enumeration, $rt_intcls()],
                returnType : jl_String,
                callable : null
            }, {
                name : "<init>",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [$rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "<init>",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "$anonfun$populateNameMap$2$adapted",
                modifiers : 548,
                accessLevel : 3,
                parameterTypes : [$rt_arraycls(jlr_Field), jlr_Method],
                returnType : jl_Object,
                callable : null
            }, {
                name : "$anonfun$populateNameMap$1$adapted",
                modifiers : 548,
                accessLevel : 3,
                parameterTypes : [jlr_Method, jlr_Field],
                returnType : jl_Object,
                callable : null
            }, {
                name : "$deserializeLambda$",
                modifiers : 544,
                accessLevel : 1,
                parameterTypes : [jli_SerializedLambda],
                returnType : jl_Object,
                callable : null
            }];
        jl_Object.$meta.methods = [
            {
                name : "monitorEnterSync",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "monitorExitSync",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "monitorEnter",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "monitorEnter",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object, $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "createMonitor",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "monitorEnterWait",
                modifiers : 768,
                accessLevel : 0,
                parameterTypes : [jl_Object, $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "monitorEnterWait",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object, $rt_intcls(), oti_AsyncCallback],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "monitorExit",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "monitorExit",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object, $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "waitForOtherThreads",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "isEmptyMonitor",
                modifiers : 4,
                accessLevel : 0,
                parameterTypes : [],
                returnType : $rt_booleancls(),
                callable : null
            }, {
                name : "deleteMonitor",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "holdsLock",
                modifiers : 512,
                accessLevel : 0,
                parameterTypes : [jl_Object],
                returnType : $rt_booleancls(),
                callable : null
            }, {
                name : "fakeInit",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "<init>",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "getClass",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [],
                returnType : jl_Class,
                callable : null
            }, {
                name : "hashCode",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "equals",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [jl_Object],
                returnType : $rt_booleancls(),
                callable : null
            }, {
                name : "toString",
                modifiers : 0,
                accessLevel : 3,
                parameterTypes : [],
                returnType : jl_String,
                callable : null
            }, {
                name : "obfuscatedToString",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [],
                returnType : jl_String,
                callable : null
            }, {
                name : "identity",
                modifiers : 4,
                accessLevel : 0,
                parameterTypes : [],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "hashCodeLowLevel",
                modifiers : 768,
                accessLevel : 1,
                parameterTypes : [jl_Object],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "hashCodeLowLevelImpl",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [otr_RuntimeObject],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "setHashCodeLowLevel",
                modifiers : 768,
                accessLevel : 1,
                parameterTypes : [jl_Object, $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "setHashCodeLowLevelImpl",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [otr_RuntimeObject, $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "identityLowLevel",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "identityOrMonitor",
                modifiers : 256,
                accessLevel : 1,
                parameterTypes : [],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "identityOrMonitorLowLevel",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [otr_RuntimeObject],
                returnType : $rt_intcls(),
                callable : null
            }, {
                name : "setIdentity",
                modifiers : 256,
                accessLevel : 0,
                parameterTypes : [$rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "setIdentityLowLevel",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [otr_RuntimeObject, $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "clone",
                modifiers : 0,
                accessLevel : 2,
                parameterTypes : [],
                returnType : jl_Object,
                callable : null
            }, {
                name : "cloneLowLevel",
                modifiers : 512,
                accessLevel : 1,
                parameterTypes : [otr_RuntimeObject],
                returnType : otr_RuntimeObject,
                callable : null
            }, {
                name : "notify",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "notifyAll",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "wait",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [$rt_longcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "wait",
                modifiers : 0,
                accessLevel : 1,
                parameterTypes : [$rt_longcls(), $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "waitImpl",
                modifiers : 256,
                accessLevel : 1,
                parameterTypes : [$rt_longcls(), $rt_intcls()],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "waitImpl",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [$rt_longcls(), $rt_intcls(), oti_AsyncCallback],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "wait",
                modifiers : 4,
                accessLevel : 3,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "finalize",
                modifiers : 0,
                accessLevel : 2,
                parameterTypes : [],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "lambda$monitorExit$2",
                modifiers : 544,
                accessLevel : 1,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "lambda$monitorExit$1",
                modifiers : 544,
                accessLevel : 1,
                parameterTypes : [jl_Object],
                returnType : $rt_voidcls(),
                callable : null
            }, {
                name : "lambda$monitorEnterWait$0",
                modifiers : 544,
                accessLevel : 1,
                parameterTypes : [jl_Thread, jl_Object, $rt_intcls(), oti_AsyncCallback],
                returnType : $rt_voidcls(),
                callable : null
            }];
    }
    function jl_Class_getDeclaredMethods($this) {
        var $jsMethods, $count, $i, var$4, $jsParameterTypes, $parameterTypes, var$7, $j, var$9, $returnType, var$11, var$12, var$13;
        if (!jl_Class_isPrimitive($this) && !jl_Class_isArray($this)) {
            if ($this.$declaredMethods === null) {
                jl_Class_initReflection();
                $jsMethods = $this.$platformClass.$meta.methods;
                $this.$declaredMethods = $rt_createArray(jlr_Method, $jsMethods.length);
                $count = 0;
                $i = 0;
                while ($i < $jsMethods.length) {
                    var$4 = $jsMethods[$i];
                    if (!jl_String_equals($rt_str(var$4.name), $rt_s(5)) && !jl_String_equals($rt_str(var$4.name), $rt_s(6))) {
                        $jsParameterTypes = var$4.parameterTypes;
                        $parameterTypes = $rt_createArray(jl_Class, $jsParameterTypes.length);
                        var$7 = $parameterTypes.data;
                        $j = 0;
                        var$9 = var$7.length;
                        while ($j < var$9) {
                            var$7[$j] = jl_Class_getClass($jsParameterTypes[$j]);
                            $j = $j + 1 | 0;
                        }
                        $returnType = jl_Class_getClass(var$4.returnType);
                        var$7 = $this.$declaredMethods.data;
                        var$11 = $count + 1 | 0;
                        var$12 = new jlr_Method;
                        var$13 = $rt_str(var$4.name);
                        $j = var$4.modifiers;
                        var$9 = var$4.accessLevel;
                        $jsParameterTypes = otji_JS_functionAsObject(var$4.callable, "call");
                        var$12.$declaringClass0 = $this;
                        var$12.$name1 = var$13;
                        var$12.$flags = $j;
                        var$12.$accessLevel0 = var$9;
                        var$12.$returnType = $returnType;
                        var$12.$parameterTypes = $parameterTypes;
                        var$12.$callable = $jsParameterTypes;
                        var$7[$count] = var$12;
                        $count = var$11;
                    }
                    $i = $i + 1 | 0;
                }
                $this.$declaredMethods = ju_Arrays_copyOf($this.$declaredMethods, $count);
            }
            return $this.$declaredMethods.$clone();
        }
        return $rt_createArray(jlr_Method, 0);
    }
    function jl_Class_findMethods($cls, $methods) {
        var var$3, var$4, var$5, $method, $signature, $superclass, var$9, $iface, var$11;
        var$3 = (jl_Class_getDeclaredMethods($cls)).data;
        var$4 = var$3.length;
        var$5 = 0;
        while (var$5 < var$4) {
            $method = var$3[var$5];
            if (!(jlr_Method_getModifiers($method) & 1) ? 0 : 1) {
                $signature = new jl_Class$MethodSignature;
                $superclass = $method.$name1;
                var$9 = jlr_Method_getParameterTypes($method);
                $iface = $method.$returnType;
                $signature.$name2 = $superclass;
                $signature.$parameterTypes0 = var$9;
                $signature.$returnType0 = $iface;
                if (!ju_HashMap_containsKey($methods, $signature))
                    ju_HashMap_put($methods, $signature, $method);
            }
            var$5 = var$5 + 1 | 0;
        }
        if (!jl_Class_isInterface($cls)) {
            $superclass = jl_Class_getSuperclass($cls);
            if ($superclass !== null)
                jl_Class_findMethods($superclass, $methods);
        }
        var$3 = (jl_Class_getInterfaces($cls)).data;
        var$4 = var$3.length;
        var$11 = 0;
        while (var$11 < var$4) {
            jl_Class_findMethods(var$3[var$11], $methods);
            var$11 = var$11 + 1 | 0;
        }
    }
    function jl_Class_getSuperclass($this) {
        return jl_Class_getClass($this.$platformClass.$meta.superclass);
    }
    function jl_Class_getInterfaces($this) {
        var $supertypes, $filteredSupertypes, var$3, $j, $i, var$6;
        $supertypes = $this.$platformClass.$meta.supertypes;
        $filteredSupertypes = $rt_createArray(jl_Class, $supertypes.length);
        var$3 = $filteredSupertypes.data;
        $j = 0;
        $i = 0;
        while ($i < $supertypes.length) {
            if ($supertypes[$i] !== $this.$platformClass.$meta.superclass) {
                var$6 = $j + 1 | 0;
                var$3[$j] = jl_Class_getClass($supertypes[$i]);
                $j = var$6;
            }
            $i = $i + 1 | 0;
        }
        if (var$3.length > $j)
            $filteredSupertypes = ju_Arrays_copyOf($filteredSupertypes, $j);
        return $filteredSupertypes;
    }
    function jl_Class_getClassLoader($this) {
        jl_ClassLoader_$callClinit();
        return jl_ClassLoader_systemClassLoader;
    }
    function jl_Class_initialize($this) {
        $this.$platformClass.$clinit();
    }
    var otji_JS = $rt_classWithoutFields();
    function otji_JS_functionAsObject(var$1, var$2) {
        if (typeof var$1 !== "function") return var$1;
        var result = {};
        result[var$2] = var$1;
        return result;
    }
    var otp_Platform = $rt_classWithoutFields();
    function otp_Platform_clone(var$1) {
        var copy = new var$1.constructor();
        for (var field in var$1) {
            if (!var$1.hasOwnProperty(field)) {
                continue;
            }
            copy[field] = var$1[field];
        }
        return copy;
    }
    function otp_Platform_isAssignable($from, $to) {
        var $supertypes, $i;
        if ($from === $to)
            return 1;
        $supertypes = $from.$meta.supertypes;
        $i = 0;
        while ($i < $supertypes.length) {
            if (otp_Platform_isAssignable($supertypes[$i], $to))
                return 1;
            $i = $i + 1 | 0;
        }
        return 0;
    }
    function otp_Platform_getEnumConstants(var$1) {
        var c = '$$enumConstants$$';
        oncifp_CompilationPhaseTracer$CompilationPhase[c] = oncifp_CompilationPhaseTracer$CompilationPhase_values;
        jm_RoundingMode[c] = jm_RoundingMode_values;
        oncipj_ExpectBar[c] = oncipj_ExpectBar_values;
        onciaf_CreateIndexTypes[c] = onciaf_CreateIndexTypes_values;
        onciaf_ConstraintVersion[c] = onciaf_ConstraintVersion_values;
        onciaf_ConstraintType[c] = onciaf_ConstraintType_values;
        onciaf_ShowCommandFilterTypes[c] = onciaf_ShowCommandFilterTypes_values;
        onciaf_ParameterType[c] = onciaf_ParameterType_values;
        onciaf_ASTFactory$MergeActionType[c] = onciaf_ASTFactory$MergeActionType_values;
        onciaf_AccessType[c] = onciaf_AccessType_values;
        onciaf_ActionType[c] = onciaf_ActionType_values;
        onciaf_HintIndexType[c] = onciaf_HintIndexType_values;
        onciaf_ScopeType[c] = onciaf_ScopeType_values;
        onciaf_CallInTxsOnErrorBehaviourType[c] = onciaf_CallInTxsOnErrorBehaviourType_values;
        jus_Collector$Characteristics[c] = jus_Collector$Characteristics_values;
        oncipj_EntityType[c] = oncipj_EntityType_values;
        otp_Platform_getEnumConstants = function(cls) {
            if (!cls.hasOwnProperty(c)) {
                return null;
            }
            if (typeof cls[c] === "function") {
                cls[c] = cls[c]();
            }
            return cls[c];
        };
        return otp_Platform_getEnumConstants(var$1);
    }
    function otp_Platform_launchThread($runnable) {
        var var$2, var$3, var$4;
        $runnable = $runnable.$_00;
        if (!jl_Object_isEmptyMonitor($runnable)) {
            var$2 = $runnable.$monitor;
            if (var$2.$owner === null) {
                $runnable = var$2.$enteringThreads;
                if ($runnable !== null && !otp_PlatformQueue_isEmpty$static($runnable)) {
                    var$3 = var$2.$enteringThreads.shift();
                    var$2.$enteringThreads = null;
                    $runnable = var$3.$_0;
                    var$2 = var$3.$_1;
                    var$4 = var$3.$_2;
                    var$3 = var$3.$_3;
                    jl_Thread_setCurrentThread($runnable);
                    var$2 = var$2.$monitor;
                    var$2.$owner = $runnable;
                    var$2.$count = var$2.$count + var$4 | 0;
                    otpp_AsyncCallbackWrapper_complete(var$3, null);
                }
            }
        }
    }
    function otp_Platform_schedule(var$1, var$2) {
        return setTimeout(function() {
            otp_Platform_launchThread(var$1);
        }, var$2);
    }
    function otp_Platform_getArrayItem($cls) {
        return $cls.$meta.item;
    }
    function otp_Platform_getName($cls) {
        return $rt_str($cls.$meta.name);
    }
    function otp_Platform_createQueueJs$js_body$_30() {
        return [];
    }
    var ji_Serializable = $rt_classWithoutFields(0);
    var jl_Comparable = $rt_classWithoutFields(0);
    var jl_CharSequence = $rt_classWithoutFields(0);
    function jl_String() {
        var a = this; jl_Object.call(a);
        a.$characters = null;
        a.$hashCode = 0;
    }
    var jl_String_CASE_INSENSITIVE_ORDER = null;
    function jl_String__init_(var_0) {
        var var_1 = new jl_String();
        jl_String__init_0(var_1, var_0);
        return var_1;
    }
    function jl_String__init_1(var_0, var_1, var_2) {
        var var_3 = new jl_String();
        jl_String__init_2(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function jl_String__init_3(var_0, var_1, var_2) {
        var var_3 = new jl_String();
        jl_String__init_4(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function jl_String__init_0($this, $characters) {
        var var$2, var$3, var$4, $i;
        $characters = $characters.data;
        var$2 = $characters.length;
        var$3 = $rt_createCharArray(var$2);
        var$4 = var$3.data;
        $this.$characters = var$3;
        $i = 0;
        while ($i < var$2) {
            var$4[$i] = $characters[$i];
            $i = $i + 1 | 0;
        }
    }
    function jl_String__init_2($this, $value, $offset, $count) {
        var var$4, var$5, $i;
        var$4 = $rt_createCharArray($count);
        var$5 = var$4.data;
        $this.$characters = var$4;
        $i = 0;
        while ($i < $count) {
            var$5[$i] = $value.data[$i + $offset | 0];
            $i = $i + 1 | 0;
        }
    }
    function jl_String__init_4($this, $codePoints, $offset, $count) {
        var $charCount, $i, var$6, var$7, $codePoint, var$9;
        $this.$characters = $rt_createCharArray($count * 2 | 0);
        $charCount = 0;
        $i = 0;
        while ($i < $count) {
            var$6 = $codePoints.data;
            var$7 = $offset + 1 | 0;
            $codePoint = var$6[$offset];
            if ($codePoint < 65536) {
                var$6 = $this.$characters.data;
                var$9 = $charCount + 1 | 0;
                var$6[$charCount] = $codePoint & 65535;
            } else {
                var$6 = $this.$characters.data;
                $offset = $charCount + 1 | 0;
                var$6[$charCount] = jl_Character_highSurrogate($codePoint);
                var$6 = $this.$characters.data;
                var$9 = $offset + 1 | 0;
                var$6[$offset] = jl_Character_lowSurrogate($codePoint);
            }
            $i = $i + 1 | 0;
            $offset = var$7;
            $charCount = var$9;
        }
        $codePoints = $this.$characters;
        if ($charCount < $codePoints.data.length)
            $this.$characters = ju_Arrays_copyOf0($codePoints, $charCount);
    }
    function jl_String_charAt($this, $index) {
        var var$2, var$3;
        if ($index >= 0) {
            var$2 = $this.$characters.data;
            if ($index < var$2.length)
                return var$2[$index];
        }
        var$3 = new jl_StringIndexOutOfBoundsException;
        jl_Throwable__init_0(var$3);
        $rt_throw(var$3);
    }
    function jl_String_length($this) {
        return $this.$characters.data.length;
    }
    function jl_String_isEmpty($this) {
        return $this.$characters.data.length ? 0 : 1;
    }
    function jl_String_startsWith($this, $prefix, $toffset) {
        var $i, var$4, var$5;
        if (($toffset + jl_String_length($prefix) | 0) > jl_String_length($this))
            return 0;
        $i = 0;
        while ($i < jl_String_length($prefix)) {
            var$4 = jl_String_charAt($prefix, $i);
            var$5 = $toffset + 1 | 0;
            if (var$4 != jl_String_charAt($this, $toffset))
                return 0;
            $i = $i + 1 | 0;
            $toffset = var$5;
        }
        return 1;
    }
    function jl_String_startsWith0($this, $prefix) {
        if ($this === $prefix)
            return 1;
        return jl_String_startsWith($this, $prefix, 0);
    }
    function jl_String_indexOf($this, $ch, $fromIndex) {
        var $i, $bmpChar, var$5, $hi, $lo;
        $i = jl_Math_max(0, $fromIndex);
        if ($ch < 65536) {
            $bmpChar = $ch & 65535;
            while (true) {
                var$5 = $this.$characters.data;
                if ($i >= var$5.length)
                    return (-1);
                if (var$5[$i] == $bmpChar)
                    break;
                $i = $i + 1 | 0;
            }
            return $i;
        }
        $hi = jl_Character_highSurrogate($ch);
        $lo = jl_Character_lowSurrogate($ch);
        while (true) {
            var$5 = $this.$characters.data;
            if ($i >= (var$5.length - 1 | 0))
                return (-1);
            if (var$5[$i] == $hi && var$5[$i + 1 | 0] == $lo)
                break;
            $i = $i + 1 | 0;
        }
        return $i;
    }
    function jl_String_indexOf0($this, $ch) {
        return jl_String_indexOf($this, $ch, 0);
    }
    function jl_String_lastIndexOf0($this, $ch, $fromIndex) {
        var $i, $bmpChar, $hi, $lo, var$7;
        $i = jl_Math_min($fromIndex, jl_String_length($this) - 1 | 0);
        if ($ch < 65536) {
            $bmpChar = $ch & 65535;
            while (true) {
                if ($i < 0)
                    return (-1);
                if ($this.$characters.data[$i] == $bmpChar)
                    break;
                $i = $i + (-1) | 0;
            }
            return $i;
        }
        $hi = jl_Character_highSurrogate($ch);
        $lo = jl_Character_lowSurrogate($ch);
        while (true) {
            if ($i < 1)
                return (-1);
            var$7 = $this.$characters.data;
            if (var$7[$i] == $lo) {
                $ch = $i - 1 | 0;
                if (var$7[$ch] == $hi)
                    break;
            }
            $i = $i + (-1) | 0;
        }
        return $ch;
    }
    function jl_String_lastIndexOf($this, $ch) {
        return jl_String_lastIndexOf0($this, $ch, jl_String_length($this) - 1 | 0);
    }
    function jl_String_indexOf1($this, $str, $fromIndex) {
        var $i, $toIndex, $j;
        $i = jl_Math_max(0, $fromIndex);
        $toIndex = jl_String_length($this) - jl_String_length($str) | 0;
        a: while (true) {
            if ($i > $toIndex)
                return (-1);
            $j = 0;
            while (true) {
                if ($j >= jl_String_length($str))
                    break a;
                if (jl_String_charAt($this, $i + $j | 0) != jl_String_charAt($str, $j))
                    break;
                $j = $j + 1 | 0;
            }
            $i = $i + 1 | 0;
        }
        return $i;
    }
    function jl_String_substring0($this, $beginIndex, $endIndex) {
        var var$3;
        if ($beginIndex <= $endIndex)
            return jl_String__init_1($this.$characters, $beginIndex, $endIndex - $beginIndex | 0);
        var$3 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$3);
        $rt_throw(var$3);
    }
    function jl_String_substring($this, $beginIndex) {
        return jl_String_substring0($this, $beginIndex, jl_String_length($this));
    }
    function jl_String_contains($this, $s) {
        var $sz, $i, $j;
        $sz = jl_String_length($this) - jl_String_length($s) | 0;
        $i = 0;
        while ($i <= $sz) {
            $j = 0;
            while (true) {
                if ($j >= jl_String_length($s))
                    return 1;
                if (jl_String_charAt($this, $i + $j | 0) != jl_String_charAt($s, $j))
                    break;
                $j = $j + 1 | 0;
            }
            $i = $i + 1 | 0;
        }
        return 0;
    }
    function jl_String_trim($this) {
        var $lower, $upper;
        $lower = 0;
        $upper = jl_String_length($this) - 1 | 0;
        a: {
            while ($lower <= $upper) {
                if (jl_String_charAt($this, $lower) > 32)
                    break a;
                $lower = $lower + 1 | 0;
            }
        }
        while ($lower <= $upper && jl_String_charAt($this, $upper) <= 32) {
            $upper = $upper + (-1) | 0;
        }
        return jl_String_substring0($this, $lower, $upper + 1 | 0);
    }
    function jl_String_toString($this) {
        return $this;
    }
    function jl_String_toCharArray($this) {
        var var$1, $array, var$3, $i, var$5;
        var$1 = $this.$characters.data;
        $array = $rt_createCharArray(var$1.length);
        var$3 = $array.data;
        $i = 0;
        var$5 = var$3.length;
        while ($i < var$5) {
            var$3[$i] = var$1[$i];
            $i = $i + 1 | 0;
        }
        return $array;
    }
    function jl_String_valueOf($obj) {
        return $obj === null ? $rt_s(7) : $obj.$toString();
    }
    function jl_String_valueOf0($c) {
        var var$2, var$3;
        var$2 = new jl_String;
        var$3 = $rt_createCharArray(1);
        var$3.data[0] = $c;
        jl_String__init_0(var$2, var$3);
        return var$2;
    }
    function jl_String_valueOf1($i) {
        var var$2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$2, $i));
    }
    function jl_String_equals($this, $other) {
        var $str, $i;
        if ($this === $other)
            return 1;
        if (!($other instanceof jl_String))
            return 0;
        $str = $other;
        if (jl_String_length($str) != jl_String_length($this))
            return 0;
        $i = 0;
        while ($i < jl_String_length($str)) {
            if (jl_String_charAt($this, $i) != jl_String_charAt($str, $i))
                return 0;
            $i = $i + 1 | 0;
        }
        return 1;
    }
    function jl_String_equalsIgnoreCase($this, $other) {
        var $i;
        if ($this === $other)
            return 1;
        if ($other === null)
            return 0;
        if (jl_String_length($this) != jl_String_length($other))
            return 0;
        $i = 0;
        while ($i < jl_String_length($this)) {
            if (jl_Character_toLowerCase(jl_String_charAt($this, $i)) != jl_Character_toLowerCase(jl_String_charAt($other, $i)))
                return 0;
            $i = $i + 1 | 0;
        }
        return 1;
    }
    function jl_String_hashCode($this) {
        var var$1, var$2, var$3, $c;
        a: {
            if (!$this.$hashCode) {
                var$1 = $this.$characters.data;
                var$2 = var$1.length;
                var$3 = 0;
                while (true) {
                    if (var$3 >= var$2)
                        break a;
                    $c = var$1[var$3];
                    $this.$hashCode = (31 * $this.$hashCode | 0) + $c | 0;
                    var$3 = var$3 + 1 | 0;
                }
            }
        }
        return $this.$hashCode;
    }
    function jl_String_toLowerCase($this) {
        var $codePoints, var$2, $codePointCount, $i, var$5, var$6, var$7;
        if (jl_String_isEmpty($this))
            return $this;
        $codePoints = $rt_createIntArray($this.$characters.data.length);
        var$2 = $codePoints.data;
        $codePointCount = 0;
        $i = 0;
        while (true) {
            var$5 = $this.$characters.data;
            var$6 = var$5.length;
            if ($i >= var$6)
                break;
            a: {
                if ($i != (var$6 - 1 | 0) && jl_Character_isHighSurrogate(var$5[$i])) {
                    var$5 = $this.$characters.data;
                    var$6 = $i + 1 | 0;
                    if (jl_Character_isLowSurrogate(var$5[var$6])) {
                        var$7 = $codePointCount + 1 | 0;
                        var$5 = $this.$characters.data;
                        var$2[$codePointCount] = jl_Character_toLowerCase0(jl_Character_toCodePoint(var$5[$i], var$5[var$6]));
                        $i = var$6;
                        break a;
                    }
                }
                var$7 = $codePointCount + 1 | 0;
                var$2[$codePointCount] = jl_Character_toLowerCase($this.$characters.data[$i]);
            }
            $i = $i + 1 | 0;
            $codePointCount = var$7;
        }
        return jl_String__init_3($codePoints, 0, $codePointCount);
    }
    function jl_String_toLowerCase0($this, $locale) {
        return jl_String_toLowerCase($this);
    }
    function jl_String_toUpperCase($this) {
        var $codePoints, var$2, $codePointCount, $i, var$5, var$6, var$7;
        if (jl_String_isEmpty($this))
            return $this;
        $codePoints = $rt_createIntArray($this.$characters.data.length);
        var$2 = $codePoints.data;
        $codePointCount = 0;
        $i = 0;
        while (true) {
            var$5 = $this.$characters.data;
            var$6 = var$5.length;
            if ($i >= var$6)
                break;
            a: {
                if ($i != (var$6 - 1 | 0) && jl_Character_isHighSurrogate(var$5[$i])) {
                    var$5 = $this.$characters.data;
                    var$6 = $i + 1 | 0;
                    if (jl_Character_isLowSurrogate(var$5[var$6])) {
                        var$7 = $codePointCount + 1 | 0;
                        var$5 = $this.$characters.data;
                        var$2[$codePointCount] = jl_Character_toUpperCase(jl_Character_toCodePoint(var$5[$i], var$5[var$6]));
                        $i = var$6;
                        break a;
                    }
                }
                var$7 = $codePointCount + 1 | 0;
                var$2[$codePointCount] = jl_Character_toUpperCase0($this.$characters.data[$i]);
            }
            $i = $i + 1 | 0;
            $codePointCount = var$7;
        }
        return jl_String__init_3($codePoints, 0, $codePointCount);
    }
    function jl_String_matches($this, $regex) {
        return jur_Matcher_matches(jur_Pattern_matcher(jur_Pattern_compile($regex), $this));
    }
    function jl_String_replaceAll($this, $regex, $replacement) {
        var var$3, var$4;
        $regex = jur_Pattern_matcher(jur_Pattern_compile($regex), $this);
        var$3 = new jl_StringBuffer;
        jl_AbstractStringBuilder__init_(var$3);
        $regex.$leftBound = 0;
        var$4 = jl_String_length($regex.$string);
        $regex.$rightBound = var$4;
        jur_MatchResultImpl_reset($regex.$matchResult, $regex.$string, $regex.$leftBound, var$4);
        $regex.$appendPos = 0;
        $regex.$replacement = null;
        $regex.$matchResult.$previousMatch = (-1);
        while (jur_Matcher_find($regex)) {
            $regex.$processedRepl = jur_Matcher_processReplacement($regex, $replacement);
            jl_AbstractStringBuilder_append0(var$3, jl_String_substring0($regex.$string, $regex.$appendPos, jur_Matcher_start($regex)));
            jl_AbstractStringBuilder_append1(var$3, $regex.$processedRepl);
            $regex.$appendPos = jur_Matcher_end($regex);
        }
        $replacement = $regex.$string;
        jl_AbstractStringBuilder_append0(var$3, jl_String_substring0($replacement, $regex.$appendPos, jl_String_length($replacement)));
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function jl_String_format($format, $args) {
        var var$3, var$4, var$5, $$je;
        var$3 = new ju_Formatter;
        var$4 = ju_Locale_getDefault();
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        var$3.$out = var$5;
        var$3.$locale = var$4;
        ju_Formatter_requireOpen(var$3);
        a: {
            try {
                if ($args === null)
                    $args = $rt_createArray(jl_Object, 1);
                ju_Formatter$FormatWriter_write(ju_Formatter$FormatWriter__init_(var$3, var$3.$out, var$4, $format, $args));
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                    $format = $$je;
                } else {
                    throw $$e;
                }
            }
            var$3.$ioException = $format;
        }
        ju_Formatter_requireOpen(var$3);
        return jl_AbstractStringBuilder_toString(var$3.$out);
    }
    function jl_String_join($delimiter, $elements) {
        var $iter, $sb;
        $iter = $elements.$iterator();
        if (!$iter.$hasNext())
            return $rt_s(3);
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        jl_AbstractStringBuilder_append0($sb, $iter.$next());
        while ($iter.$hasNext()) {
            jl_AbstractStringBuilder_append0($sb, $delimiter);
            jl_AbstractStringBuilder_append0($sb, $iter.$next());
        }
        return jl_AbstractStringBuilder_toString($sb);
    }
    function jl_String__clinit_() {
        jl_String_CASE_INSENSITIVE_ORDER = new jl_String$_clinit_$lambda$_84_0;
    }
    function jl_Throwable() {
        var a = this; jl_Object.call(a);
        a.$message = null;
        a.$cause = null;
        a.$suppressionEnabled = 0;
        a.$writableStackTrace = 0;
        a.$suppressed = null;
    }
    function jl_Throwable__init_1() {
        var var_0 = new jl_Throwable();
        jl_Throwable__init_0(var_0);
        return var_0;
    }
    function jl_Throwable__init_2(var_0) {
        var var_1 = new jl_Throwable();
        jl_Throwable__init_(var_1, var_0);
        return var_1;
    }
    function jl_Throwable__init_3(var_0, var_1) {
        var var_2 = new jl_Throwable();
        jl_Throwable__init_4(var_2, var_0, var_1);
        return var_2;
    }
    function jl_Throwable__init_0($this) {
        $this.$suppressionEnabled = 1;
        $this.$writableStackTrace = 1;
    }
    function jl_Throwable__init_($this, $message) {
        $this.$suppressionEnabled = 1;
        $this.$writableStackTrace = 1;
        $this.$message = $message;
    }
    function jl_Throwable__init_4($this, $message, $cause) {
        $this.$suppressionEnabled = 1;
        $this.$writableStackTrace = 1;
        $this.$message = $message;
        $this.$cause = $cause;
    }
    function jl_Throwable_fillInStackTrace($this) {
        return $this;
    }
    function jl_Throwable_getMessage($this) {
        return $this.$message;
    }
    function jl_Throwable_getCause($this) {
        var var$1;
        var$1 = $this.$cause;
        if (var$1 === $this)
            var$1 = null;
        return var$1;
    }
    function jl_Throwable_addSuppressed($this, $exception) {
        var var$2, var$3;
        if (!$this.$suppressionEnabled)
            return;
        var$2 = $this.$suppressed;
        var$2 = ju_Arrays_copyOf(var$2, var$2.data.length + 1 | 0);
        var$3 = var$2.data;
        $this.$suppressed = var$2;
        var$3[var$3.length - 1 | 0] = $exception;
    }
    var jl_Error = $rt_classWithoutFields(jl_Throwable);
    function jl_Error__init_(var_0) {
        var var_1 = new jl_Error();
        jl_Error__init_0(var_1, var_0);
        return var_1;
    }
    function jl_Error__init_0($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var jl_LinkageError = $rt_classWithoutFields(jl_Error);
    var jl_NoClassDefFoundError = $rt_classWithoutFields(jl_LinkageError);
    var jl_Number = $rt_classWithoutFields();
    function jl_Integer() {
        jl_Number.call(this);
        this.$value = 0;
    }
    var jl_Integer_TYPE = null;
    var jl_Integer_integerCache = null;
    function jl_Integer__init_(var_0) {
        var var_1 = new jl_Integer();
        jl_Integer__init_0(var_1, var_0);
        return var_1;
    }
    function jl_Integer__init_0($this, $value) {
        $this.$value = $value;
    }
    function jl_Integer_toString($i, $radix) {
        if (!($radix >= 2 && $radix <= 36))
            $radix = 10;
        return (jl_AbstractStringBuilder_append2(jl_AbstractStringBuilder__init_0(20), $i, $radix)).$toString();
    }
    function jl_Integer_toHexString($i) {
        return otci_IntegerUtil_toUnsignedLogRadixString($i, 4);
    }
    function jl_Integer_toString0($i) {
        return jl_Integer_toString($i, 10);
    }
    function jl_Integer_parseInt($s, $radix) {
        var $negative, $index, $value, var$6, $digit, var$8, var$9;
        if ($radix >= 2 && $radix <= 36) {
            if ($s !== null && !jl_String_isEmpty($s)) {
                a: {
                    $negative = 0;
                    $index = 0;
                    switch (jl_String_charAt($s, 0)) {
                        case 43:
                            $index = 1;
                            break a;
                        case 45:
                            $negative = 1;
                            $index = 1;
                            break a;
                        default:
                    }
                }
                $value = 0;
                if ($index == jl_String_length($s)) {
                    $s = new jl_NumberFormatException;
                    jl_Throwable__init_0($s);
                    $rt_throw($s);
                }
                while ($index < jl_String_length($s)) {
                    var$6 = $index + 1 | 0;
                    $digit = jl_Character_getNumericValue(jl_String_charAt($s, $index));
                    if ($digit < 0) {
                        var$8 = new jl_NumberFormatException;
                        var$9 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_(var$9);
                        jl_StringBuilder_append(jl_StringBuilder_append(var$9, $rt_s(8)), $s);
                        jl_Throwable__init_(var$8, jl_AbstractStringBuilder_toString(var$9));
                        $rt_throw(var$8);
                    }
                    if ($digit >= $radix) {
                        var$8 = new jl_NumberFormatException;
                        var$9 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_(var$9);
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$9, $rt_s(9)), $radix), $rt_s(10)), $s);
                        jl_Throwable__init_(var$8, jl_AbstractStringBuilder_toString(var$9));
                        $rt_throw(var$8);
                    }
                    $value = $rt_imul($radix, $value) + $digit | 0;
                    if ($value < 0) {
                        if (var$6 == jl_String_length($s) && $value == (-2147483648) && $negative)
                            return (-2147483648);
                        var$8 = new jl_NumberFormatException;
                        var$9 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_(var$9);
                        jl_StringBuilder_append(jl_StringBuilder_append(var$9, $rt_s(11)), $s);
                        jl_Throwable__init_(var$8, jl_AbstractStringBuilder_toString(var$9));
                        $rt_throw(var$8);
                    }
                    $index = var$6;
                }
                if ($negative)
                    $value =  -$value | 0;
                return $value;
            }
            $s = new jl_NumberFormatException;
            jl_Throwable__init_($s, $rt_s(12));
            $rt_throw($s);
        }
        $s = new jl_NumberFormatException;
        var$8 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$8);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$8, $rt_s(13)), $radix);
        jl_Throwable__init_($s, jl_AbstractStringBuilder_toString(var$8));
        $rt_throw($s);
    }
    function jl_Integer_parseInt0($s) {
        return jl_Integer_parseInt($s, 10);
    }
    function jl_Integer_valueOf($i) {
        var var$2, var$3;
        if ($i >= (-128) && $i <= 127) {
            a: {
                if (jl_Integer_integerCache === null) {
                    jl_Integer_integerCache = $rt_createArray(jl_Integer, 256);
                    var$2 = 0;
                    while (true) {
                        var$3 = jl_Integer_integerCache.data;
                        if (var$2 >= var$3.length)
                            break a;
                        var$3[var$2] = jl_Integer__init_(var$2 - 128 | 0);
                        var$2 = var$2 + 1 | 0;
                    }
                }
            }
            return jl_Integer_integerCache.data[$i + 128 | 0];
        }
        return jl_Integer__init_($i);
    }
    function jl_Integer_intValue($this) {
        return $this.$value;
    }
    function jl_Integer_longValue($this) {
        return Long_fromInt($this.$value);
    }
    function jl_Integer_floatValue($this) {
        return $this.$value;
    }
    function jl_Integer_doubleValue($this) {
        return $this.$value;
    }
    function jl_Integer_toString1($this) {
        return jl_Integer_toString0($this.$value);
    }
    function jl_Integer_hashCode($this) {
        var var$1;
        var$1 = $this.$value;
        return var$1 >>> 4 ^ var$1 << 28 ^ var$1 << 8 ^ var$1 >>> 24;
    }
    function jl_Integer_equals($this, $other) {
        if ($this === $other)
            return 1;
        return $other instanceof jl_Integer && $other.$value == $this.$value ? 1 : 0;
    }
    function jl_Integer_numberOfLeadingZeros($i) {
        var $n, var$3;
        if (!$i)
            return 32;
        $n = 0;
        var$3 = $i >>> 16;
        if (var$3)
            $n = 16;
        else
            var$3 = $i;
        $i = var$3 >>> 8;
        if (!$i)
            $i = var$3;
        else
            $n = $n | 8;
        var$3 = $i >>> 4;
        if (!var$3)
            var$3 = $i;
        else
            $n = $n | 4;
        $i = var$3 >>> 2;
        if (!$i)
            $i = var$3;
        else
            $n = $n | 2;
        if ($i >>> 1)
            $n = $n | 1;
        return (32 - $n | 0) - 1 | 0;
    }
    function jl_Integer_numberOfTrailingZeros($i) {
        var $n, var$3;
        if (!$i)
            return 32;
        $n = 0;
        var$3 = $i << 16;
        if (var$3)
            $n = 16;
        else
            var$3 = $i;
        $i = var$3 << 8;
        if (!$i)
            $i = var$3;
        else
            $n = $n | 8;
        var$3 = $i << 4;
        if (!var$3)
            var$3 = $i;
        else
            $n = $n | 4;
        $i = var$3 << 2;
        if (!$i)
            $i = var$3;
        else
            $n = $n | 2;
        if ($i << 1)
            $n = $n | 1;
        return (32 - $n | 0) - 1 | 0;
    }
    function jl_Integer_highestOneBit($i) {
        return (-2147483648) >>> jl_Integer_numberOfLeadingZeros($i);
    }
    function jl_Integer_bitCount($i) {
        $i = (($i & (-1431655766)) >>> 1) + ($i & 1431655765) | 0;
        $i = (($i & (-858993460)) >>> 2) + ($i & 858993459) | 0;
        $i = (($i & 1886417008) >>> 4) + ($i & 117901063) | 0;
        $i = (($i & 251662080) >>> 8) + ($i & 983055) | 0;
        return (($i & 2031616) >>> 16) + ($i & 31) | 0;
    }
    function jl_Integer_rotateLeft($i, $distance) {
        var var$3;
        var$3 = $distance & 31;
        return $i << var$3 | $i >>> (32 - var$3 | 0);
    }
    function jl_Integer__clinit_() {
        jl_Integer_TYPE = $rt_cls($rt_intcls());
    }
    function jl_AbstractStringBuilder() {
        var a = this; jl_Object.call(a);
        a.$buffer = null;
        a.$length0 = 0;
    }
    function jl_AbstractStringBuilder__init_1() {
        var var_0 = new jl_AbstractStringBuilder();
        jl_AbstractStringBuilder__init_(var_0);
        return var_0;
    }
    function jl_AbstractStringBuilder__init_0(var_0) {
        var var_1 = new jl_AbstractStringBuilder();
        jl_AbstractStringBuilder__init_2(var_1, var_0);
        return var_1;
    }
    function jl_AbstractStringBuilder__init_($this) {
        jl_AbstractStringBuilder__init_2($this, 16);
    }
    function jl_AbstractStringBuilder__init_2($this, $capacity) {
        $this.$buffer = $rt_createCharArray($capacity);
    }
    function jl_AbstractStringBuilder_append1($this, $string) {
        return $this.$insert($this.$length0, $string);
    }
    function jl_AbstractStringBuilder_insert($this, $index, $string) {
        var $i, var$4, var$5;
        if ($index >= 0 && $index <= $this.$length0) {
            if ($string === null)
                $string = $rt_s(7);
            else if (jl_String_isEmpty($string))
                return $this;
            $this.$ensureCapacity($this.$length0 + jl_String_length($string) | 0);
            $i = $this.$length0 - 1 | 0;
            while ($i >= $index) {
                $this.$buffer.data[$i + jl_String_length($string) | 0] = $this.$buffer.data[$i];
                $i = $i + (-1) | 0;
            }
            $this.$length0 = $this.$length0 + jl_String_length($string) | 0;
            $i = 0;
            while ($i < jl_String_length($string)) {
                var$4 = $this.$buffer.data;
                var$5 = $index + 1 | 0;
                var$4[$index] = jl_String_charAt($string, $i);
                $i = $i + 1 | 0;
                $index = var$5;
            }
            return $this;
        }
        $string = new jl_StringIndexOutOfBoundsException;
        jl_Throwable__init_0($string);
        $rt_throw($string);
    }
    function jl_AbstractStringBuilder_append2($this, $value, $radix) {
        return jl_AbstractStringBuilder_insert0($this, $this.$length0, $value, $radix);
    }
    function jl_AbstractStringBuilder_insert0($this, $target, $value, $radix) {
        var $positive, var$5, var$6, $pos, $sz, $posLimit, var$10;
        $positive = 1;
        if ($value < 0) {
            $positive = 0;
            $value =  -$value | 0;
        }
        a: {
            if ($value < $radix) {
                if ($positive)
                    jl_AbstractStringBuilder_insertSpace($this, $target, $target + 1 | 0);
                else {
                    jl_AbstractStringBuilder_insertSpace($this, $target, $target + 2 | 0);
                    var$5 = $this.$buffer.data;
                    var$6 = $target + 1 | 0;
                    var$5[$target] = 45;
                    $target = var$6;
                }
                $this.$buffer.data[$target] = jl_Character_forDigit($value, $radix);
            } else {
                $pos = 1;
                $sz = 1;
                $posLimit = 2147483647 / $radix | 0;
                b: {
                    while (true) {
                        var$10 = $rt_imul($pos, $radix);
                        if (var$10 > $value) {
                            var$10 = $pos;
                            break b;
                        }
                        $sz = $sz + 1 | 0;
                        if (var$10 > $posLimit)
                            break;
                        $pos = var$10;
                    }
                }
                if (!$positive)
                    $sz = $sz + 1 | 0;
                jl_AbstractStringBuilder_insertSpace($this, $target, $target + $sz | 0);
                if ($positive)
                    $positive = $target;
                else {
                    var$5 = $this.$buffer.data;
                    $positive = $target + 1 | 0;
                    var$5[$target] = 45;
                }
                while (true) {
                    if (var$10 <= 0)
                        break a;
                    var$5 = $this.$buffer.data;
                    $target = $positive + 1 | 0;
                    var$5[$positive] = jl_Character_forDigit($value / var$10 | 0, $radix);
                    $value = $value % var$10 | 0;
                    var$10 = var$10 / $radix | 0;
                    $positive = $target;
                }
            }
        }
        return $this;
    }
    function jl_AbstractStringBuilder_insert1($this, $target, $value) {
        var $mantissa, var$4, $number, $exp, $negative, $intPart, $sz, $digits, $zeros, $pos, $i, $intDigit;
        $mantissa = $rt_compare($value, 0.0);
        if (!$mantissa) {
            jl_AbstractStringBuilder_insertSpace($this, $target, $target + 3 | 0);
            var$4 = $this.$buffer.data;
            $mantissa = $target + 1 | 0;
            var$4[$target] = 48;
            $target = $mantissa + 1 | 0;
            var$4[$mantissa] = 46;
            var$4[$target] = 48;
            return $this;
        }
        if (!$mantissa) {
            jl_AbstractStringBuilder_insertSpace($this, $target, $target + 4 | 0);
            var$4 = $this.$buffer.data;
            $mantissa = $target + 1 | 0;
            var$4[$target] = 45;
            $target = $mantissa + 1 | 0;
            var$4[$mantissa] = 48;
            $mantissa = $target + 1 | 0;
            var$4[$target] = 46;
            var$4[$mantissa] = 48;
            return $this;
        }
        if ($rt_globals.isNaN($value) ? 1 : 0) {
            jl_AbstractStringBuilder_insertSpace($this, $target, $target + 3 | 0);
            var$4 = $this.$buffer.data;
            $mantissa = $target + 1 | 0;
            var$4[$target] = 78;
            $target = $mantissa + 1 | 0;
            var$4[$mantissa] = 97;
            var$4[$target] = 78;
            return $this;
        }
        if (!$rt_globals.isFinite($value) ? 1 : 0) {
            if ($mantissa > 0) {
                jl_AbstractStringBuilder_insertSpace($this, $target, $target + 8 | 0);
                $mantissa = $target;
            } else {
                jl_AbstractStringBuilder_insertSpace($this, $target, $target + 9 | 0);
                var$4 = $this.$buffer.data;
                $mantissa = $target + 1 | 0;
                var$4[$target] = 45;
            }
            var$4 = $this.$buffer.data;
            $target = $mantissa + 1 | 0;
            var$4[$mantissa] = 73;
            $mantissa = $target + 1 | 0;
            var$4[$target] = 110;
            $target = $mantissa + 1 | 0;
            var$4[$mantissa] = 102;
            $mantissa = $target + 1 | 0;
            var$4[$target] = 105;
            $target = $mantissa + 1 | 0;
            var$4[$mantissa] = 110;
            $mantissa = $target + 1 | 0;
            var$4[$target] = 105;
            $target = $mantissa + 1 | 0;
            var$4[$mantissa] = 116;
            var$4[$target] = 121;
            return $this;
        }
        $number = jl_AbstractStringBuilder$Constants_floatAnalysisResult;
        otcit_FloatAnalyzer_analyze($value, $number);
        $mantissa = $number.$mantissa;
        $exp = $number.$exponent;
        $negative = $number.$sign;
        $intPart = 1;
        $sz = 1;
        if ($negative)
            $sz = 2;
        $digits = 9;
        $zeros = jl_AbstractStringBuilder_trailingDecimalZeros($mantissa);
        if ($zeros > 0)
            $digits = $digits - $zeros | 0;
        if ($exp < 7 && $exp >= (-3)) {
            if ($exp >= 0) {
                $intPart = $exp + 1 | 0;
                $digits = jl_Math_max($digits, $intPart + 1 | 0);
                $exp = 0;
            } else {
                $mantissa = $mantissa / jl_AbstractStringBuilder$Constants_intPowersOfTen.data[ -$exp | 0] | 0;
                $digits = $digits - $exp | 0;
                $exp = 0;
            }
        }
        if ($exp) {
            $sz = $sz + 2 | 0;
            if (!($exp > (-10) && $exp < 10))
                $sz = $sz + 1 | 0;
            if ($exp < 0)
                $sz = $sz + 1 | 0;
        }
        if ($exp && $digits == $intPart)
            $digits = $digits + 1 | 0;
        jl_AbstractStringBuilder_insertSpace($this, $target, $target + ($sz + $digits | 0) | 0);
        if (!$negative)
            $sz = $target;
        else {
            var$4 = $this.$buffer.data;
            $sz = $target + 1 | 0;
            var$4[$target] = 45;
        }
        $pos = 100000000;
        $i = 0;
        while ($i < $digits) {
            if ($pos <= 0)
                $intDigit = 0;
            else {
                $intDigit = $mantissa / $pos | 0;
                $mantissa = $mantissa % $pos | 0;
            }
            var$4 = $this.$buffer.data;
            $target = $sz + 1 | 0;
            var$4[$sz] = (48 + $intDigit | 0) & 65535;
            $intPart = $intPart + (-1) | 0;
            if ($intPart)
                $sz = $target;
            else {
                $sz = $target + 1 | 0;
                var$4[$target] = 46;
            }
            $pos = $pos / 10 | 0;
            $i = $i + 1 | 0;
        }
        if ($exp) {
            var$4 = $this.$buffer.data;
            $intDigit = $sz + 1 | 0;
            var$4[$sz] = 69;
            if ($exp >= 0)
                $target = $intDigit;
            else {
                $exp =  -$exp | 0;
                $target = $intDigit + 1 | 0;
                var$4[$intDigit] = 45;
            }
            if ($exp < 10)
                $mantissa = $target;
            else {
                $mantissa = $target + 1 | 0;
                var$4[$target] = (48 + ($exp / 10 | 0) | 0) & 65535;
            }
            var$4[$mantissa] = (48 + ($exp % 10 | 0) | 0) & 65535;
        }
        return $this;
    }
    function jl_AbstractStringBuilder_insert2($this, $target, $value) {
        var $intDigit, var$4, $number, $mantissa, $exp, $negative, $intPart, $sz, $digits, $zeros, $pos, $i;
        $intDigit = $rt_compare($value, 0.0);
        if (!$intDigit) {
            jl_AbstractStringBuilder_insertSpace($this, $target, $target + 3 | 0);
            var$4 = $this.$buffer.data;
            $intDigit = $target + 1 | 0;
            var$4[$target] = 48;
            $target = $intDigit + 1 | 0;
            var$4[$intDigit] = 46;
            var$4[$target] = 48;
            return $this;
        }
        if (!$intDigit) {
            jl_AbstractStringBuilder_insertSpace($this, $target, $target + 4 | 0);
            var$4 = $this.$buffer.data;
            $intDigit = $target + 1 | 0;
            var$4[$target] = 45;
            $target = $intDigit + 1 | 0;
            var$4[$intDigit] = 48;
            $intDigit = $target + 1 | 0;
            var$4[$target] = 46;
            var$4[$intDigit] = 48;
            return $this;
        }
        if ($rt_globals.isNaN($value) ? 1 : 0) {
            jl_AbstractStringBuilder_insertSpace($this, $target, $target + 3 | 0);
            var$4 = $this.$buffer.data;
            $intDigit = $target + 1 | 0;
            var$4[$target] = 78;
            $target = $intDigit + 1 | 0;
            var$4[$intDigit] = 97;
            var$4[$target] = 78;
            return $this;
        }
        if (!$rt_globals.isFinite($value) ? 1 : 0) {
            if ($intDigit > 0) {
                jl_AbstractStringBuilder_insertSpace($this, $target, $target + 8 | 0);
                $intDigit = $target;
            } else {
                jl_AbstractStringBuilder_insertSpace($this, $target, $target + 9 | 0);
                var$4 = $this.$buffer.data;
                $intDigit = $target + 1 | 0;
                var$4[$target] = 45;
            }
            var$4 = $this.$buffer.data;
            $target = $intDigit + 1 | 0;
            var$4[$intDigit] = 73;
            $intDigit = $target + 1 | 0;
            var$4[$target] = 110;
            $target = $intDigit + 1 | 0;
            var$4[$intDigit] = 102;
            $intDigit = $target + 1 | 0;
            var$4[$target] = 105;
            $target = $intDigit + 1 | 0;
            var$4[$intDigit] = 110;
            $intDigit = $target + 1 | 0;
            var$4[$target] = 105;
            $target = $intDigit + 1 | 0;
            var$4[$intDigit] = 116;
            var$4[$target] = 121;
            return $this;
        }
        $number = jl_AbstractStringBuilder$Constants_doubleAnalysisResult;
        otcit_DoubleAnalyzer_analyze($value, $number);
        $mantissa = $number.$mantissa0;
        $exp = $number.$exponent0;
        $negative = $number.$sign0;
        $intPart = 1;
        $sz = 1;
        if ($negative)
            $sz = 2;
        $digits = 18;
        $zeros = jl_AbstractStringBuilder_trailingDecimalZeros0($mantissa);
        if ($zeros > 0)
            $digits = $digits - $zeros | 0;
        if ($exp < 7 && $exp >= (-3)) {
            if ($exp >= 0) {
                $intPart = $exp + 1 | 0;
                $digits = jl_Math_max($digits, $intPart + 1 | 0);
                $exp = 0;
            } else {
                $mantissa = Long_div($mantissa, jl_AbstractStringBuilder$Constants_longPowersOfTen.data[ -$exp | 0]);
                $digits = $digits - $exp | 0;
                $exp = 0;
            }
        }
        if ($exp) {
            $sz = $sz + 2 | 0;
            if (!($exp > (-10) && $exp < 10))
                $sz = $sz + 1 | 0;
            if (!($exp > (-100) && $exp < 100))
                $sz = $sz + 1 | 0;
            if ($exp < 0)
                $sz = $sz + 1 | 0;
        }
        if ($exp && $digits == $intPart)
            $digits = $digits + 1 | 0;
        jl_AbstractStringBuilder_insertSpace($this, $target, $target + ($sz + $digits | 0) | 0);
        if (!$negative)
            $sz = $target;
        else {
            var$4 = $this.$buffer.data;
            $sz = $target + 1 | 0;
            var$4[$target] = 45;
        }
        $pos = Long_create(1569325056, 23283064);
        $i = 0;
        while ($i < $digits) {
            if (Long_le($pos, Long_ZERO))
                $intDigit = 0;
            else {
                $intDigit = Long_lo(Long_div($mantissa, $pos));
                $mantissa = Long_rem($mantissa, $pos);
            }
            var$4 = $this.$buffer.data;
            $target = $sz + 1 | 0;
            var$4[$sz] = (48 + $intDigit | 0) & 65535;
            $intPart = $intPart + (-1) | 0;
            if ($intPart)
                $sz = $target;
            else {
                $sz = $target + 1 | 0;
                var$4[$target] = 46;
            }
            $pos = Long_div($pos, Long_fromInt(10));
            $i = $i + 1 | 0;
        }
        if ($exp) {
            var$4 = $this.$buffer.data;
            $intDigit = $sz + 1 | 0;
            var$4[$sz] = 69;
            if ($exp >= 0)
                $intPart = $intDigit;
            else {
                $exp =  -$exp | 0;
                $intPart = $intDigit + 1 | 0;
                var$4[$intDigit] = 45;
            }
            if ($exp >= 100) {
                $target = $intPart + 1 | 0;
                var$4[$intPart] = (48 + ($exp / 100 | 0) | 0) & 65535;
                $exp = $exp % 100 | 0;
                $digits = $target + 1 | 0;
                var$4[$target] = (48 + ($exp / 10 | 0) | 0) & 65535;
            } else if ($exp < 10)
                $digits = $intPart;
            else {
                $digits = $intPart + 1 | 0;
                var$4[$intPart] = (48 + ($exp / 10 | 0) | 0) & 65535;
            }
            var$4[$digits] = (48 + ($exp % 10 | 0) | 0) & 65535;
        }
        return $this;
    }
    function jl_AbstractStringBuilder_trailingDecimalZeros($n) {
        var $result, $zeros, var$4;
        if (!($n % 1000000000 | 0))
            return 9;
        $result = 0;
        $zeros = 1;
        if (!($n % 100000000 | 0)) {
            $result = 8;
            $zeros = 100000000;
        }
        var$4 = $zeros * 10000 | 0;
        if ($n % var$4 | 0)
            var$4 = $zeros;
        else
            $result = $result | 4;
        $zeros = var$4 * 100 | 0;
        if ($n % $zeros | 0)
            $zeros = var$4;
        else
            $result = $result | 2;
        if (!($n % ($zeros * 10 | 0) | 0))
            $result = $result | 1;
        return $result;
    }
    function jl_AbstractStringBuilder_trailingDecimalZeros0($n) {
        var $zeros, $result, $bit, var$5, $i;
        $zeros = Long_fromInt(1);
        $result = 0;
        $bit = 16;
        var$5 = jl_AbstractStringBuilder$Constants_longLogPowersOfTen.data;
        $i = var$5.length - 1 | 0;
        while ($i >= 0) {
            if (Long_eq(Long_rem($n, Long_mul($zeros, var$5[$i])), Long_ZERO)) {
                $result = $result | $bit;
                $zeros = Long_mul($zeros, var$5[$i]);
            }
            $bit = $bit >>> 1;
            $i = $i + (-1) | 0;
        }
        return $result;
    }
    function jl_AbstractStringBuilder_append($this, $c) {
        return $this.$insert1($this.$length0, $c);
    }
    function jl_AbstractStringBuilder_insert3($this, $index, $c) {
        jl_AbstractStringBuilder_insertSpace($this, $index, $index + 1 | 0);
        $this.$buffer.data[$index] = $c;
        return $this;
    }
    function jl_AbstractStringBuilder_ensureCapacity($this, $capacity) {
        var var$2, $newLength;
        var$2 = $this.$buffer.data.length;
        if (var$2 >= $capacity)
            return;
        $newLength = var$2 >= 1073741823 ? 2147483647 : jl_Math_max($capacity, jl_Math_max(var$2 * 2 | 0, 5));
        $this.$buffer = ju_Arrays_copyOf0($this.$buffer, $newLength);
    }
    function jl_AbstractStringBuilder_toString($this) {
        return jl_String__init_1($this.$buffer, 0, $this.$length0);
    }
    function jl_AbstractStringBuilder_charAt($this, $index) {
        var var$2;
        if ($index >= 0 && $index < $this.$length0)
            return $this.$buffer.data[$index];
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$2);
        $rt_throw(var$2);
    }
    function jl_AbstractStringBuilder_append3($this, $s, $start, $end) {
        return $this.$insert2($this.$length0, $s, $start, $end);
    }
    function jl_AbstractStringBuilder_insert4($this, $index, $s, $i, $end) {
        var var$5, var$6;
        if ($i <= $end && $end <= $s.$length() && $i >= 0) {
            jl_AbstractStringBuilder_insertSpace($this, $index, ($index + $end | 0) - $i | 0);
            while ($i < $end) {
                var$5 = $this.$buffer.data;
                var$6 = $index + 1 | 0;
                var$5[$index] = $s.$charAt($i);
                $i = $i + 1 | 0;
                $index = var$6;
            }
            return $this;
        }
        $s = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0($s);
        $rt_throw($s);
    }
    function jl_AbstractStringBuilder_append0($this, $s) {
        return $this.$append5($s, 0, $s.$length());
    }
    function jl_AbstractStringBuilder_append4($this, $chars, $offset, $len) {
        return $this.$insert3($this.$length0, $chars, $offset, $len);
    }
    function jl_AbstractStringBuilder_insert5($this, $index, $chars, $offset, $len) {
        var var$5, var$6, var$7, var$8;
        jl_AbstractStringBuilder_insertSpace($this, $index, $index + $len | 0);
        var$5 = $len + $offset | 0;
        while ($offset < var$5) {
            var$6 = $chars.data;
            var$7 = $this.$buffer.data;
            $len = $index + 1 | 0;
            var$8 = $offset + 1 | 0;
            var$7[$index] = var$6[$offset];
            $index = $len;
            $offset = var$8;
        }
        return $this;
    }
    function jl_AbstractStringBuilder_append5($this, $chars) {
        return $this.$append6($chars, 0, $chars.data.length);
    }
    function jl_AbstractStringBuilder_insertSpace($this, $start, $end) {
        var var$3, $sz, $i, var$6;
        var$3 = $this.$length0;
        $sz = var$3 - $start | 0;
        $this.$ensureCapacity((var$3 + $end | 0) - $start | 0);
        $i = $sz - 1 | 0;
        while ($i >= 0) {
            var$6 = $this.$buffer.data;
            var$6[$end + $i | 0] = var$6[$start + $i | 0];
            $i = $i + (-1) | 0;
        }
        $this.$length0 = $this.$length0 + ($end - $start | 0) | 0;
    }
    var jl_Appendable = $rt_classWithoutFields(0);
    var jl_StringBuilder = $rt_classWithoutFields(jl_AbstractStringBuilder);
    function jl_StringBuilder__init_(var_0) {
        var var_1 = new jl_StringBuilder();
        jl_StringBuilder__init_0(var_1, var_0);
        return var_1;
    }
    function jl_StringBuilder__init_1() {
        var var_0 = new jl_StringBuilder();
        jl_StringBuilder__init_2(var_0);
        return var_0;
    }
    function jl_StringBuilder__init_3(var_0) {
        var var_1 = new jl_StringBuilder();
        jl_StringBuilder__init_4(var_1, var_0);
        return var_1;
    }
    function jl_StringBuilder__init_0($this, $capacity) {
        jl_AbstractStringBuilder__init_2($this, $capacity);
    }
    function jl_StringBuilder__init_2($this) {
        jl_AbstractStringBuilder__init_($this);
    }
    function jl_StringBuilder__init_4($this, $value) {
        var var$2, var$3;
        $this.$buffer = $rt_createCharArray(jl_String_length($value));
        var$2 = 0;
        while (true) {
            var$3 = $this.$buffer.data;
            if (var$2 >= var$3.length)
                break;
            var$3[var$2] = jl_String_charAt($value, var$2);
            var$2 = var$2 + 1 | 0;
        }
        $this.$length0 = jl_String_length($value);
    }
    function jl_StringBuilder_append($this, $obj) {
        jl_AbstractStringBuilder_insert($this, $this.$length0, $obj === null ? $rt_s(7) : $obj.$toString());
        return $this;
    }
    function jl_StringBuilder_append1($this, $string) {
        jl_AbstractStringBuilder_append1($this, $string);
        return $this;
    }
    function jl_StringBuilder_append0($this, $value) {
        jl_AbstractStringBuilder_append2($this, $value, 10);
        return $this;
    }
    function jl_StringBuilder_append2($this, $value) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$2 = $this.$length0;
        var$3 = 1;
        if (Long_lt($value, Long_ZERO)) {
            var$3 = 0;
            $value = Long_neg($value);
        }
        a: {
            if (Long_lt($value, Long_fromInt(10))) {
                if (var$3)
                    jl_AbstractStringBuilder_insertSpace($this, var$2, var$2 + 1 | 0);
                else {
                    jl_AbstractStringBuilder_insertSpace($this, var$2, var$2 + 2 | 0);
                    var$4 = $this.$buffer.data;
                    var$5 = var$2 + 1 | 0;
                    var$4[var$2] = 45;
                    var$2 = var$5;
                }
                $this.$buffer.data[var$2] = jl_Character_forDigit(Long_lo($value), 10);
            } else {
                var$6 = 1;
                var$7 = Long_fromInt(1);
                while (true) {
                    var$8 = Long_mul(var$7, Long_fromInt(10));
                    if (Long_le(var$8, var$7))
                        break;
                    if (Long_gt(var$8, $value))
                        break;
                    var$6 = var$6 + 1 | 0;
                    var$7 = var$8;
                }
                if (!var$3)
                    var$6 = var$6 + 1 | 0;
                jl_AbstractStringBuilder_insertSpace($this, var$2, var$2 + var$6 | 0);
                if (var$3)
                    var$5 = var$2;
                else {
                    var$4 = $this.$buffer.data;
                    var$5 = var$2 + 1 | 0;
                    var$4[var$2] = 45;
                }
                while (true) {
                    if (Long_le(var$7, Long_ZERO))
                        break a;
                    var$4 = $this.$buffer.data;
                    var$2 = var$5 + 1 | 0;
                    var$4[var$5] = jl_Character_forDigit(Long_lo(Long_div($value, var$7)), 10);
                    $value = Long_rem($value, var$7);
                    var$7 = Long_div(var$7, Long_fromInt(10));
                    var$5 = var$2;
                }
            }
        }
        return $this;
    }
    function jl_StringBuilder_append3($this, $value) {
        jl_AbstractStringBuilder_insert1($this, $this.$length0, $value);
        return $this;
    }
    function jl_StringBuilder_append4($this, $c) {
        jl_AbstractStringBuilder_append($this, $c);
        return $this;
    }
    function jl_StringBuilder_append5($this, $chars) {
        jl_AbstractStringBuilder_append5($this, $chars);
        return $this;
    }
    function jl_StringBuilder_append6($this, $s) {
        jl_AbstractStringBuilder_append0($this, $s);
        return $this;
    }
    function jl_StringBuilder_delete($this, $start, $end) {
        var var$3, var$4, var$5, var$6, var$7, var$8;
        var$3 = $rt_compare($start, $end);
        if (var$3 <= 0) {
            var$4 = $this.$length0;
            if ($start <= var$4) {
                if (var$3) {
                    var$5 = var$4 - $end | 0;
                    $this.$length0 = var$4 - ($end - $start | 0) | 0;
                    var$6 = 0;
                    while (var$6 < var$5) {
                        var$7 = $this.$buffer.data;
                        var$4 = $start + 1 | 0;
                        var$3 = $end + 1 | 0;
                        var$7[$start] = var$7[$end];
                        var$6 = var$6 + 1 | 0;
                        $start = var$4;
                        $end = var$3;
                    }
                }
                return $this;
            }
        }
        var$8 = new jl_StringIndexOutOfBoundsException;
        jl_Throwable__init_0(var$8);
        $rt_throw(var$8);
    }
    function jl_StringBuilder_deleteCharAt($this, $index) {
        var var$2, var$3, var$4, var$5;
        if ($index >= 0) {
            var$2 = $this.$length0;
            if ($index < var$2) {
                var$2 = var$2 - 1 | 0;
                $this.$length0 = var$2;
                while ($index < var$2) {
                    var$3 = $this.$buffer.data;
                    var$4 = $index + 1 | 0;
                    var$3[$index] = var$3[var$4];
                    $index = var$4;
                }
                return $this;
            }
        }
        var$5 = new jl_StringIndexOutOfBoundsException;
        jl_Throwable__init_0(var$5);
        $rt_throw(var$5);
    }
    function jl_StringBuilder_substring($this, var$1, var$2) {
        var var$3;
        if (var$1 <= var$2 && var$1 >= 0 && var$2 <= $this.$length0)
            return jl_String__init_1($this.$buffer, var$1, var$2 - var$1 | 0);
        var$3 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$3);
        $rt_throw(var$3);
    }
    function jl_StringBuilder_setLength($this, var$1) {
        $this.$length0 = var$1;
    }
    function jl_StringBuilder_subSequence($this, var$1, var$2) {
        return jl_StringBuilder_substring($this, var$1, var$2);
    }
    function jl_StringBuilder_insert($this, var$1, var$2, var$3, var$4) {
        jl_AbstractStringBuilder_insert5($this, var$1, var$2, var$3, var$4);
        return $this;
    }
    function jl_StringBuilder_append7($this, var$1, var$2, var$3) {
        jl_AbstractStringBuilder_append4($this, var$1, var$2, var$3);
        return $this;
    }
    function jl_StringBuilder_insert0($this, var$1, var$2, var$3, var$4) {
        jl_AbstractStringBuilder_insert4($this, var$1, var$2, var$3, var$4);
        return $this;
    }
    function jl_StringBuilder_append8($this, var$1, var$2, var$3) {
        jl_AbstractStringBuilder_append3($this, var$1, var$2, var$3);
        return $this;
    }
    function jl_StringBuilder_charAt($this, var$1) {
        return jl_AbstractStringBuilder_charAt($this, var$1);
    }
    function jl_StringBuilder_length($this) {
        return $this.$length0;
    }
    function jl_StringBuilder_toString($this) {
        return jl_AbstractStringBuilder_toString($this);
    }
    function jl_StringBuilder_ensureCapacity($this, var$1) {
        jl_AbstractStringBuilder_ensureCapacity($this, var$1);
    }
    function jl_StringBuilder_insert1($this, var$1, var$2) {
        jl_AbstractStringBuilder_insert3($this, var$1, var$2);
        return $this;
    }
    function jl_StringBuilder_insert2($this, var$1, var$2) {
        jl_AbstractStringBuilder_insert($this, var$1, var$2);
        return $this;
    }
    var jl_IncompatibleClassChangeError = $rt_classWithoutFields(jl_LinkageError);
    var jl_NoSuchFieldError = $rt_classWithoutFields(jl_IncompatibleClassChangeError);
    function jl_NoSuchFieldError__init_(var_0) {
        var var_1 = new jl_NoSuchFieldError();
        jl_NoSuchFieldError__init_0(var_1, var_0);
        return var_1;
    }
    function jl_NoSuchFieldError__init_0($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var jl_NoSuchMethodError = $rt_classWithoutFields(jl_IncompatibleClassChangeError);
    function jl_NoSuchMethodError__init_(var_0) {
        var var_1 = new jl_NoSuchMethodError();
        jl_NoSuchMethodError__init_0(var_1, var_0);
        return var_1;
    }
    function jl_NoSuchMethodError__init_0($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var jl_Exception = $rt_classWithoutFields(jl_Throwable);
    function jl_Exception__init_() {
        var var_0 = new jl_Exception();
        jl_Exception__init_0(var_0);
        return var_0;
    }
    function jl_Exception__init_1(var_0) {
        var var_1 = new jl_Exception();
        jl_Exception__init_2(var_1, var_0);
        return var_1;
    }
    function jl_Exception__init_0($this) {
        jl_Throwable__init_0($this);
    }
    function jl_Exception__init_2($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var jl_RuntimeException = $rt_classWithoutFields(jl_Exception);
    function jl_RuntimeException__init_(var_0) {
        var var_1 = new jl_RuntimeException();
        jl_RuntimeException__init_0(var_1, var_0);
        return var_1;
    }
    function jl_RuntimeException__init_0($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var otci_IntegerUtil = $rt_classWithoutFields();
    function otci_IntegerUtil_toUnsignedLogRadixString($value, $radixLog2) {
        var $radix, $mask, $sz, $chars, var$7, $pos, $target, $target_0;
        if (!$value)
            return $rt_s(14);
        $radix = 1 << $radixLog2;
        $mask = $radix - 1 | 0;
        $sz = (((32 - jl_Integer_numberOfLeadingZeros($value) | 0) + $radixLog2 | 0) - 1 | 0) / $radixLog2 | 0;
        $chars = $rt_createCharArray($sz);
        var$7 = $chars.data;
        $pos = $rt_imul($sz - 1 | 0, $radixLog2);
        $target = 0;
        while ($pos >= 0) {
            $target_0 = $target + 1 | 0;
            var$7[$target] = jl_Character_forDigit($value >>> $pos & $mask, $radix);
            $pos = $pos - $radixLog2 | 0;
            $target = $target_0;
        }
        return jl_String__init_($chars);
    }
    var oncifp_SemanticAnalyzer = $rt_classWithoutFields();
    var jl_Iterable = $rt_classWithoutFields(0);
    var ju_Collection = $rt_classWithoutFields(0);
    function ju_Collection_stream($this) {
        var var$1, var$2;
        var$1 = new jusi_StreamOverSpliterator;
        var$2 = new jusi_SpliteratorOverCollection;
        var$2.$collection = $this;
        var$1.$spliterator = var$2;
        return var$1;
    }
    var ju_AbstractCollection = $rt_classWithoutFields();
    function ju_AbstractCollection__init_($this) {}
    function ju_AbstractCollection_isEmpty($this) {
        return $this.$size() ? 0 : 1;
    }
    function ju_AbstractCollection_toArray($this, $a) {
        var var$2, $i, var$4, $iter;
        var$2 = $a.data;
        $i = $this.$size();
        var$4 = var$2.length;
        if (var$4 < $i)
            $a = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($a)), $i);
        else
            while ($i < var$4) {
                var$2[$i] = null;
                $i = $i + 1 | 0;
            }
        $i = 0;
        $iter = $this.$iterator();
        while ($iter.$hasNext()) {
            var$2 = $a.data;
            var$4 = $i + 1 | 0;
            var$2[$i] = $iter.$next();
            $i = var$4;
        }
        return $a;
    }
    function ju_AbstractCollection_addAll($this, $c) {
        var $changed, $iter;
        $changed = 0;
        $iter = $c.$iterator();
        while ($iter.$hasNext()) {
            if (!$this.$add($iter.$next()))
                continue;
            $changed = 1;
        }
        return $changed;
    }
    function ju_AbstractCollection_toString($this) {
        var $sb, $iter, $e;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        jl_AbstractStringBuilder_append($sb, 91);
        $iter = $this.$iterator();
        if ($iter.$hasNext()) {
            $e = $iter.$next();
            if ($e === $this)
                $e = $rt_s(15);
            jl_StringBuilder_append($sb, $e);
        }
        while ($iter.$hasNext()) {
            $e = $iter.$next();
            jl_AbstractStringBuilder_append1($sb, $rt_s(16));
            if ($e === $this)
                $e = $rt_s(15);
            jl_StringBuilder_append($sb, $e);
        }
        jl_AbstractStringBuilder_append($sb, 93);
        return jl_AbstractStringBuilder_toString($sb);
    }
    var ju_List = $rt_classWithoutFields(0);
    function ju_List_of($e) {
        var var$2;
        var$2 = new ju_TemplateCollections$SingleElementList;
        var$2.$value0 = $e;
        return var$2;
    }
    function ju_AbstractList() {
        ju_AbstractCollection.call(this);
        this.$modCount = 0;
    }
    function ju_AbstractList_add($this, $e) {
        ju_AbstractSequentialList_add($this, $this.$size0, $e);
        return 1;
    }
    function ju_AbstractList_iterator($this) {
        var var$1;
        var$1 = new ju_AbstractList$1;
        var$1.$this$0 = $this;
        var$1.$modCount0 = $this.$modCount;
        var$1.$size1 = $this.$size();
        var$1.$removeIndex = (-1);
        return var$1;
    }
    function ju_AbstractList_hashCode($this) {
        var $hashCode, $iter, $elem;
        $hashCode = 1;
        $iter = ju_AbstractList_iterator($this);
        while (ju_AbstractList$1_hasNext($iter)) {
            $elem = ju_AbstractList$1_next($iter);
            $hashCode = (31 * $hashCode | 0) + ($elem === null ? 0 : $elem.$hashCode0()) | 0;
        }
        return $hashCode;
    }
    function ju_AbstractList_equals($this, $other) {
        var $list, $i;
        if (!$rt_isInstance($other, ju_List))
            return 0;
        $list = $other;
        if ($this.$size2 != $list.$size2)
            return 0;
        $i = 0;
        while ($i < $list.$size2) {
            if (!ju_Objects_equals(ju_ArrayList_get($this, $i), ju_ArrayList_get($list, $i)))
                return 0;
            $i = $i + 1 | 0;
        }
        return 1;
    }
    var jl_Cloneable = $rt_classWithoutFields(0);
    var ju_RandomAccess = $rt_classWithoutFields(0);
    function ju_ArrayList() {
        var a = this; ju_AbstractList.call(a);
        a.$array = null;
        a.$size2 = 0;
    }
    function ju_ArrayList__init_() {
        var var_0 = new ju_ArrayList();
        ju_ArrayList__init_0(var_0);
        return var_0;
    }
    function ju_ArrayList__init_0($this) {
        $this.$array = $rt_createArray(jl_Object, 10);
    }
    function ju_ArrayList_ensureCapacity($this, $minCapacity) {
        var var$2, $newLength;
        var$2 = $this.$array.data.length;
        if (var$2 < $minCapacity) {
            $newLength = var$2 >= 1073741823 ? 2147483647 : jl_Math_max($minCapacity, jl_Math_max(var$2 * 2 | 0, 5));
            $this.$array = ju_Arrays_copyOf($this.$array, $newLength);
        }
    }
    function ju_ArrayList_get($this, $index) {
        ju_ArrayList_checkIndex($this, $index);
        return $this.$array.data[$index];
    }
    function ju_ArrayList_size($this) {
        return $this.$size2;
    }
    function ju_ArrayList_add($this, $element) {
        var var$2, var$3;
        ju_ArrayList_ensureCapacity($this, $this.$size2 + 1 | 0);
        var$2 = $this.$array.data;
        var$3 = $this.$size2;
        $this.$size2 = var$3 + 1 | 0;
        var$2[var$3] = $element;
        $this.$modCount = $this.$modCount + 1 | 0;
        return 1;
    }
    function ju_ArrayList_remove($this, $i) {
        var var$2, $old, var$4, $i_0;
        ju_ArrayList_checkIndex($this, $i);
        var$2 = $this.$array.data;
        $old = var$2[$i];
        var$4 = $this.$size2 - 1 | 0;
        $this.$size2 = var$4;
        while ($i < var$4) {
            $i_0 = $i + 1 | 0;
            var$2[$i] = var$2[$i_0];
            $i = $i_0;
        }
        var$2[var$4] = null;
        $this.$modCount = $this.$modCount + 1 | 0;
        return $old;
    }
    function ju_ArrayList_checkIndex($this, $index) {
        var var$2;
        if ($index >= 0 && $index < $this.$size2)
            return;
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$2);
        $rt_throw(var$2);
    }
    function ju_ArrayList_forEach($this, $action) {
        var $i;
        $i = 0;
        while ($i < $this.$size2) {
            $action.$accept($this.$array.data[$i]);
            $i = $i + 1 | 0;
        }
    }
    function ju_ArrayList_toString($this) {
        var $i, $length, $buffer, var$4;
        $i = $this.$size2;
        if (!$i)
            return $rt_s(4);
        $length = $i - 1 | 0;
        $buffer = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($buffer, $i * 16 | 0);
        jl_AbstractStringBuilder_append($buffer, 91);
        $i = 0;
        while ($i < $length) {
            var$4 = $this.$array.data;
            jl_AbstractStringBuilder_append1(jl_StringBuilder_append($buffer, var$4[$i] !== $this ? var$4[$i] : $rt_s(15)), $rt_s(16));
            $i = $i + 1 | 0;
        }
        var$4 = $this.$array.data;
        jl_StringBuilder_append($buffer, var$4[$length] !== $this ? var$4[$length] : $rt_s(15));
        jl_AbstractStringBuilder_append($buffer, 93);
        return jl_AbstractStringBuilder_toString($buffer);
    }
    var oncifp_SemanticAnalyzer$SemanticErrors = $rt_classWithoutFields(0);
    var s_Equals = $rt_classWithoutFields(0);
    var s_Product = $rt_classWithoutFields(0);
    function oncifp_SemanticAnalyzer$SomeErrors() {
        jl_Exception.call(this);
        this.$errs = null;
    }
    var s_Function1 = $rt_classWithoutFields(0);
    function s_Function1_toString($this) {
        return $rt_s(17);
    }
    function ons_MainNodejs$analyzeQuery$lambda$_2_0() {
        jl_Object.call(this);
        this.$_01 = null;
    }
    function ons_MainNodejs$analyzeQuery$lambda$_2_0_apply(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(ju_ArrayList_add(var$0.$_01, var$1));
    }
    var ju_Comparator = $rt_classWithoutFields(0);
    var jl_String$_clinit_$lambda$_84_0 = $rt_classWithoutFields();
    function jl_Character() {
        jl_Object.call(this);
        this.$value1 = 0;
    }
    var jl_Character_TYPE = null;
    var jl_Character_digitMapping = null;
    var jl_Character_upperCaseMapping = null;
    var jl_Character_lowerCaseMapping = null;
    var jl_Character_classMapping = null;
    var jl_Character_characterCache = null;
    var jl_Character_$$metadata$$0 = null;
    var jl_Character_$$metadata$$1 = null;
    var jl_Character_$$metadata$$3 = null;
    var jl_Character_$$metadata$$4 = null;
    function jl_Character__init_(var_0) {
        var var_1 = new jl_Character();
        jl_Character__init_0(var_1, var_0);
        return var_1;
    }
    function jl_Character__init_0($this, $value) {
        $this.$value1 = $value;
    }
    function jl_Character_valueOf($value) {
        var var$2, $result;
        var$2 = jl_Character_characterCache.data;
        if ($value >= var$2.length)
            return jl_Character__init_($value);
        $result = var$2[$value];
        if ($result === null) {
            $result = jl_Character__init_($value);
            jl_Character_characterCache.data[$value] = $result;
        }
        return $result;
    }
    function jl_Character_toString($this) {
        return jl_Character_toString0($this.$value1);
    }
    function jl_Character_equals($this, $other) {
        if ($this === $other)
            return 1;
        return $other instanceof jl_Character && $other.$value1 == $this.$value1 ? 1 : 0;
    }
    function jl_Character_hashCode($this) {
        return $this.$value1;
    }
    function jl_Character_toString0($c) {
        var var$2, var$3;
        var$2 = new jl_String;
        var$3 = $rt_createCharArray(1);
        var$3.data[0] = $c;
        jl_String__init_0(var$2, var$3);
        return var$2;
    }
    function jl_Character_isSupplementaryCodePoint($codePoint) {
        return $codePoint >= 65536 && $codePoint <= 1114111 ? 1 : 0;
    }
    function jl_Character_isHighSurrogate($ch) {
        return ($ch & 64512) != 55296 ? 0 : 1;
    }
    function jl_Character_isLowSurrogate($ch) {
        return ($ch & 64512) != 56320 ? 0 : 1;
    }
    function jl_Character_isSurrogate($ch) {
        return !jl_Character_isHighSurrogate($ch) && !jl_Character_isLowSurrogate($ch) ? 0 : 1;
    }
    function jl_Character_isSurrogatePair($high, $low) {
        return jl_Character_isHighSurrogate($high) && jl_Character_isLowSurrogate($low) ? 1 : 0;
    }
    function jl_Character_toCodePoint($high, $low) {
        return (($high & 1023) << 10 | $low & 1023) + 65536 | 0;
    }
    function jl_Character_highSurrogate($codePoint) {
        return (55296 | ($codePoint - 65536 | 0) >> 10 & 1023) & 65535;
    }
    function jl_Character_lowSurrogate($codePoint) {
        return (56320 | $codePoint & 1023) & 65535;
    }
    function jl_Character_toLowerCase($ch) {
        return jl_Character_toLowerCase0($ch) & 65535;
    }
    function jl_Character_toLowerCase0($ch) {
        if (jl_Character_lowerCaseMapping === null) {
            if (jl_Character_$$metadata$$0 === null)
                jl_Character_$$metadata$$0 = jl_Character_acquireLowerCaseMapping$$create();
            jl_Character_lowerCaseMapping = otciu_UnicodeHelper_decodeCaseMapping((jl_Character_$$metadata$$0.value !== null ? $rt_str(jl_Character_$$metadata$$0.value) : null));
        }
        return jl_Character_mapChar(jl_Character_lowerCaseMapping, $ch);
    }
    function jl_Character_toUpperCase0($ch) {
        return jl_Character_toUpperCase($ch) & 65535;
    }
    function jl_Character_toUpperCase($codePoint) {
        if (jl_Character_upperCaseMapping === null) {
            if (jl_Character_$$metadata$$1 === null)
                jl_Character_$$metadata$$1 = jl_Character_acquireUpperCaseMapping$$create();
            jl_Character_upperCaseMapping = otciu_UnicodeHelper_decodeCaseMapping((jl_Character_$$metadata$$1.value !== null ? $rt_str(jl_Character_$$metadata$$1.value) : null));
        }
        return jl_Character_mapChar(jl_Character_upperCaseMapping, $codePoint);
    }
    function jl_Character_mapChar($table, $codePoint) {
        var var$3, var$4, var$5, $index, var$7;
        $table = $table.data;
        var$3 = 0;
        var$4 = $table.length / 2 | 0;
        var$5 = var$4 - 1 | 0;
        a: {
            while (true) {
                $index = (var$3 + var$5 | 0) / 2 | 0;
                var$7 = $rt_compare($table[$index * 2 | 0], $codePoint);
                if (!var$7)
                    break;
                if (var$7 <= 0) {
                    var$3 = $index + 1 | 0;
                    if (var$3 > var$5)
                        break a;
                } else {
                    $index = $index - 1 | 0;
                    if ($index < var$3)
                        break a;
                    var$5 = $index;
                }
            }
        }
        if ($index >= 0 && $index < var$4)
            return $codePoint + $table[($index * 2 | 0) + 1 | 0] | 0;
        return 0;
    }
    function jl_Character_digit($ch, $radix) {
        if ($radix >= 2 && $radix <= 36) {
            $ch = jl_Character_getNumericValue($ch);
            if ($ch >= $radix)
                $ch = (-1);
        } else
            $ch = (-1);
        return $ch;
    }
    function jl_Character_getNumericValue($codePoint) {
        var var$2, var$3, var$4, var$5, $digitMapping, $u, $idx, $val, var$10, $l;
        if (jl_Character_digitMapping === null) {
            if (jl_Character_$$metadata$$3 === null)
                jl_Character_$$metadata$$3 = jl_Character_obtainDigitMapping$$create();
            var$2 = (jl_Character_$$metadata$$3.value !== null ? $rt_str(jl_Character_$$metadata$$3.value) : null);
            var$3 = otci_CharFlow__init_(jl_String_toCharArray(var$2));
            var$4 = otci_Base46_decodeUnsigned(var$3);
            var$5 = $rt_createIntArray(var$4 * 2 | 0);
            $digitMapping = var$5.data;
            $u = 0;
            $idx = 0;
            $val = 0;
            var$10 = 0;
            while (var$10 < var$4) {
                $idx = $idx + otci_Base46_decode(var$3) | 0;
                $val = $val + otci_Base46_decode(var$3) | 0;
                $l = $u + 1 | 0;
                $digitMapping[$u] = $idx;
                $u = $l + 1 | 0;
                $digitMapping[$l] = $val;
                var$10 = var$10 + 1 | 0;
            }
            jl_Character_digitMapping = var$5;
        }
        $digitMapping = jl_Character_digitMapping.data;
        $l = 0;
        $u = ($digitMapping.length / 2 | 0) - 1 | 0;
        while ($u >= $l) {
            $idx = ($l + $u | 0) / 2 | 0;
            var$4 = $idx * 2 | 0;
            $val = $rt_compare($codePoint, $digitMapping[var$4]);
            if ($val > 0)
                $l = $idx + 1 | 0;
            else {
                if ($val >= 0)
                    return $digitMapping[var$4 + 1 | 0];
                $u = $idx - 1 | 0;
            }
        }
        return (-1);
    }
    function jl_Character_forDigit($digit, $radix) {
        if ($radix >= 2 && $radix <= 36 && $digit < $radix)
            return $digit < 10 ? (48 + $digit | 0) & 65535 : ((97 + $digit | 0) - 10 | 0) & 65535;
        return 0;
    }
    function jl_Character_toChars($codePoint) {
        var var$2;
        if ($codePoint < 65536) {
            var$2 = $rt_createCharArray(1);
            var$2.data[0] = $codePoint & 65535;
            return var$2;
        }
        return $rt_createCharArrayFromData([jl_Character_highSurrogate($codePoint), jl_Character_lowSurrogate($codePoint)]);
    }
    function jl_Character_isISOControl($codePoint) {
        a: {
            b: {
                if (!($codePoint >= 0 && $codePoint <= 31)) {
                    if ($codePoint < 127)
                        break b;
                    if ($codePoint > 159)
                        break b;
                }
                $codePoint = 1;
                break a;
            }
            $codePoint = 0;
        }
        return $codePoint;
    }
    function jl_Character_getType($codePoint) {
        var $u, $range, $classes, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13, $l, $i;
        $u = $codePoint > 0 && $codePoint <= 65535 ? 1 : 0;
        if ($u && jl_Character_isSurrogate($codePoint & 65535))
            return 19;
        if (jl_Character_classMapping === null) {
            if (jl_Character_$$metadata$$4 === null)
                jl_Character_$$metadata$$4 = jl_Character_obtainClasses$$create();
            $range = (jl_Character_$$metadata$$4.value !== null ? $rt_str(jl_Character_$$metadata$$4.value) : null);
            $classes = $rt_createArray(otciu_UnicodeHelper$Range, 16384);
            var$5 = $classes.data;
            var$6 = $rt_createByteArray(16384);
            var$7 = var$6.data;
            var$8 = 0;
            var$9 = 0;
            var$10 = 0;
            var$11 = 0;
            while (var$11 < jl_String_length($range)) {
                var$12 = otciu_UnicodeHelper_decodeByte(jl_String_charAt($range, var$11));
                if (var$12 == 64) {
                    var$11 = var$11 + 1 | 0;
                    var$12 = otciu_UnicodeHelper_decodeByte(jl_String_charAt($range, var$11));
                    var$13 = 0;
                    $u = 1;
                    $l = 0;
                    while ($l < 3) {
                        var$11 = var$11 + 1 | 0;
                        var$13 = var$13 | $rt_imul($u, otciu_UnicodeHelper_decodeByte(jl_String_charAt($range, var$11)));
                        $u = $u * 64 | 0;
                        $l = $l + 1 | 0;
                    }
                } else if (var$12 < 32)
                    var$13 = 1;
                else {
                    var$12 = (var$12 - 32 | 0) << 24 >> 24;
                    var$11 = var$11 + 1 | 0;
                    var$13 = otciu_UnicodeHelper_decodeByte(jl_String_charAt($range, var$11));
                }
                if (!var$12 && var$13 >= 128) {
                    if (var$8 > 0) {
                        $u = var$9 + 1 | 0;
                        var$5[var$9] = otciu_UnicodeHelper$Range__init_(var$10, var$10 + var$8 | 0, ju_Arrays_copyOf1(var$6, var$8));
                        var$9 = $u;
                    }
                    var$10 = var$10 + (var$8 + var$13 | 0) | 0;
                    var$8 = 0;
                } else {
                    $u = var$8 + var$13 | 0;
                    if ($u < var$7.length)
                        $l = var$9;
                    else {
                        $l = var$9 + 1 | 0;
                        var$5[var$9] = otciu_UnicodeHelper$Range__init_(var$10, var$10 + var$8 | 0, ju_Arrays_copyOf1(var$6, var$8));
                        var$10 = var$10 + $u | 0;
                        var$8 = 0;
                    }
                    while (true) {
                        $u = var$13 + (-1) | 0;
                        if (var$13 <= 0)
                            break;
                        $i = var$8 + 1 | 0;
                        var$7[var$8] = var$12;
                        var$8 = $i;
                        var$13 = $u;
                    }
                    var$9 = $l;
                }
                var$11 = var$11 + 1 | 0;
            }
            jl_Character_classMapping = ju_Arrays_copyOf($classes, var$9);
        }
        $classes = jl_Character_classMapping.data;
        $l = 0;
        $u = $classes.length - 1 | 0;
        while ($l <= $u) {
            $i = ($l + $u | 0) / 2 | 0;
            $range = $classes[$i];
            if ($codePoint >= $range.$end0)
                $l = $i + 1 | 0;
            else {
                $u = $range.$start0;
                if ($codePoint >= $u)
                    return $range.$data.data[$codePoint - $u | 0];
                $u = $i - 1 | 0;
            }
        }
        return 0;
    }
    function jl_Character_isDefined($codePoint) {
        return !jl_Character_getType($codePoint) ? 0 : 1;
    }
    function jl_Character_isLetterOrDigit($codePoint) {
        a: {
            switch (jl_Character_getType($codePoint)) {
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 9:
                    break;
                case 6:
                case 7:
                case 8:
                    break a;
                default:
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function jl_Character_isIdentifierIgnorable($codePoint) {
        a: {
            if (!($codePoint >= 0 && $codePoint <= 8) && !($codePoint >= 14 && $codePoint <= 27)) {
                if ($codePoint < 127)
                    break a;
                if ($codePoint > 159)
                    break a;
            }
            return 1;
        }
        return jl_Character_getType($codePoint) != 16 ? 0 : 1;
    }
    function jl_Character_isSpaceChar($codePoint) {
        switch (jl_Character_getType($codePoint)) {
            case 12:
            case 13:
            case 14:
                break;
            default:
                return 0;
        }
        return 1;
    }
    function jl_Character_isWhitespace($codePoint) {
        switch ($codePoint) {
            case 9:
            case 10:
            case 11:
            case 12:
            case 13:
            case 28:
            case 29:
            case 30:
            case 31:
                break;
            case 160:
            case 8199:
            case 8239:
                return 0;
            default:
                return jl_Character_isSpaceChar($codePoint);
        }
        return 1;
    }
    function jl_Character__clinit_() {
        jl_Character_TYPE = $rt_cls($rt_charcls());
        jl_Character_characterCache = $rt_createArray(jl_Character, 128);
    }
    function jl_Character_acquireLowerCaseMapping$$create() {
        return {"value" : ">W  H#F#U 4%F#O #F#/ d%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #a1# #%# #%# #%# %%# #%# #%# #%# #%# #%# #%# #%# %%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #<+#%# #%# #%# \'.3#%# #%# #{1#%# #w1%%# %J\'#k1#o1#%# #w1#!3# #23#*3#%# \'23#:3# #>3#%# #%# #%# #N3#%# #N3# %%# #N3#%# #J3%%# #%# #R3#%# \'%# /)#%# #)#%# #)#%# #%# #%# #%# #%# #%# #%# #%# #%# %%# #%# #%# #%# #%# #%# #%# #%# #%# %)#%# #%# #8)#L%#%# #%# #%# #"
        + "%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #a+# #%# #%# #%# #%# #%# #%# #%# #%# #%# /B45#%# #,/#645# %%# #P1#!\'#*\'#%# #%# #%# #%# #%# <-%# #%# \'%# 1&++ %_## #Z#)k%%g%% #F#W hA# 1%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# +]%# %%# #?#%# %a+\'N\'AF#b &#%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# 3%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #^#%# #%# #%# #%# #%# #%# #%# %%# #%# #%# #%# #%# #%# #%# #%"
        + "# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# %*%r iB#oq-&# _?gejg#A1 o$#mo%&# {-%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# 3,4/# #%# #%# #%"
        + "# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# 3C1 1C1 1C1 1C1 1C1 3C/ 1C1 QC1 1C1 1C1 1C%8\'%G# 7i\')G# 7C%D)\' 7C%u)%?# 7X+%P+%G# L-q*/# \'Pw/#8m/# -6## |bA G%# kC.#U !r*%&# &#%# #,05#qX\'#H.5# %%# #%# #%# #e25#D05#q25#m25# #%# %%# 1865%%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# "
        + "#%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# 1%# #%# )%# (a=%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# G%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# y%%# #%# #%# #%# #%# #%# #%# \'%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #%# 5%# #%# #4Fd#%# #%# #%# #%# #%# )%# #<{p# %%# #%# \'%# #%# #%# #%# #%# #%# #%# #%# #%# #%# #P}p#}}p#m}p#D}p#P}p# #@yp#D{p#Lyp#Br#%# #%# #%# #%"
        + "# #%# #%# #%# #%# #,%#L}p#LJd#%# #%# -%# +%# #%# Y%# ,T5F#U TUg#r {%g#r >\'c#p Lnk%F# *J#F#b o@5F#b Jo=N#f "};
    }
    function jl_Character_acquireUpperCaseMapping$$create() {
        return {"value" : "<Y  ,%H#U :#>b# vH#O #H#/:+# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #,5# #\'# #\'# #\'# %\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# %\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# %\'# #\'# #\'#(;#N1# %\'# #\'# %\'# \'\'# +\'# %6)# \'\'#*/# \'_+# %\'# #\'# #\'# %\'# )\'# %\'# \'\'# #\'# %\'# \'\'# #J%# +\'#+# #\'#+# #\'#+# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'#L\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# %\'#+# #\'# \'\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'#"
        + " #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# \'\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# 1\'# %665% #\'# )\'# #\'# #\'# #\'# #\'#o25#c25#k25#03#}1# #y1% #m1# #q1#{}p# \'y1#k}p# #$3# #:{p#N}p# #,3#43#N}p#*05#B}p# %43# #B05#<3# %@3# /F.5# %P3# #J}p#P3# \'B{p#P3#$\'#L3%,\'# +T3# 5Jyp#>yp# Z\'_\'# x\'# #\'# \'\'\' #_+\' !#a##]#\' #H#CD##H#3m%#i%% #e%#P%# \'(%#D%#C# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'#i\'#P\'#=#(+# #4)# %\'# %\'# .#H#bP\'A #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# 3\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# "
        + "#\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# %\'# #\'# #\'# #\'# #\'# #\'# #\'#`# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'% &#,%n mB#ko%x %ko%\' RAC1 >$#yu+#uu+#Pu+#Hu+%Lu+#0u+#io+#>@d1 (+2Fd# \'oX\'# AJJd# N%\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #"
        + "\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# +X%# +\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'#A1 1A1 1A1 1A1 1A1 3A# #A# #A# #A% /A1 16\'%g\')B)%V+%s)%N+)A1 1A1 1A1 1A% #E# 5<m-# )E# 9A% =A% \'=# ;E# R/8## ddA )\'# @E0#U Nr,%&# #\'# \'D45#845# #\'# #\'# #\'# -"
        + "\'# %\'# 5\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# 1\'# #\'# )\'- /qq-&# i]=\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# G\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# y%\'# #\'# #\'# #\'# #\'# #\'# #\'# \'\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'#"
        + " #\'# #\'# #\'# #\'# 5\'# #\'# %\'# #\'# #\'# #\'# #\'# )\'# )\'# #\'#*%# %\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# 7\'# #\'# #\'# #\'# #\'# #\'# #\'# #\'# )\'# #\'- #\'% )\'# #\'S )\'# cEDr# Yiejg# e*5H#U eUi#r {%i#r <\'e#<% Vlm%:# RH#H#b o@5H#b No=P#f "};
    }
    function jl_Character_obtainDigitMapping$$create() {
        return {"value" : "&C*% %%%%%%%%%%%%%%%%%%A%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%=,#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%_H#T#%%%%%%%%%%%%%%%%%%s+G%%%%%%%%%%%%%%%%%%_1G%%%%%%%%%%%%%%%%%%{CG%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%6)G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%*\'G%%%%%%%%%%%%%%%%%%.9G%%%%%%%%%%%%%%%%%%*\'G%%%%%%%%%%%%%%%%%%!i#G"
        + "%%%%%%%%%%%%%%%%%%c#G%%%%%%%%%%%%%%%%%%*;G%%%%%%%%%%%%%%%%%%Z+G%%%%%%%%%%%%%%%%%%:/G%%%%%%%%%%%%%%%%%%=G%%%%%%%%%%%%%%%%%%{/G%%%%%%%%%%%%%%%%%%k\'G%%%%%%%%%%%%%%%%%%s+G%%%%%%%%%%%%%%%%%%=G%%%%%%%%%%%%%%%%%%R@dG%%%%%%%%%%%%%%%%%%R[G%%%%%%%%%%%%%%%%%%c#G%%%%%%%%%%%%%%%%%%_1G%%%%%%%%%%%%%%%%%%!#G%%%%%%%%%%%%%%%%%%k\'G%%%%%%%%%%%%%%%%%%cCG%%%%%%%%%%%%%%%%%%o*IG%%%%%%%%%%%%%%%%%%A%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%=,#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%c:#T#%%%%%%%%%%%%%%%%%%w&%G%%%%%"
        + "%%%%%%%%%%%%%BhG%%%%%%%%%%%%%%%%%%Z+G%%%%%%%%%%%%%%%%%%_%G%%%%%%%%%%%%%%%%%%>-G%%%%%%%%%%%%%%%%%%.9G%%%%%%%%%%%%%%%%%%w=G%%%%%%%%%%%%%%%%%%2+G%%%%%%%%%%%%%%%%%%>AG%%%%%%%%%%%%%%%%%%N)G%%%%%%%%%%%%%%%%%%N)G%%%%%%%%%%%%%%%%%%FEG%%%%%%%%%%%%%%%%%%N)G%%%%%%%%%%%%%%%%%%!dG%%%%%%%%%%%%%%%%%%g5G%%%%%%%%%%%%%%%%%%*\'G%%%%%%%%%%%%%%%%%%FEG%%%%%%%%%%%%%%%%%%*0EG%%%%%%%%%%%%%%%%%%k\'G%%%%%%%%%%%%%%%%%%s+G%%%%%%%%%%%%%%%%%%28UG%%%%%%%%%%%%%%%%%%%G%%%%%%%%%%%%%%%%%%%G%%%%%%%%%%%%%%%%%%%G%%%%%%%%%%%%%%%%%%%G%%%%%%%%%%%%%%%"
        + "%%%!8%G%%%%%%%%%%%%%%%%%%FEG%%%%%%%%%%%%%%%%%%sKG%%%%%%%%%%%%%%%%%%>&#G%%%%%%%%%%%%%%%%%%wN)G%%%%%%%%%%%%%%%%%%"};
    }
    function jl_Character_obtainClasses$$create() {
        return {"value" : "PA-Y$;Y$679:95Y#J+Y#Z$Y#B;697<8<C;6:7:PB-9[%=9<=&>:1=<=:L#<#Y#<,&?L$9B8:B(C9:C)!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!C#!#!#!#!#!#!#!#!C#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#B##!#!C$B##!#B##B$C#B%#B##B$C$B##B##!#!#B##!C#!#B##B$#!#B#C#&!C$F%!$#!$#!$#!#!#!#!#!#!#!#!C#!#!#!#!#!#!#!#!#!C#!$#!#B$#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!C(B##B#C#!#B%#!#!#!#!Cg&C<E3]%E-]/E&](%<%]2b\'Q! !#!#%<!#A#%C$9!A%]#!9B$ ! B##B2 B*CD!C#B$C$!#!#!#!#!#!#!#!#!#!#!#!C&!#:!#B#C#BTCQ!#!#!#!#"
        + "!#!#!#!#!#!#!#!#!#!#!#!#!#=G&H#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#B##!#!#!#!#!#!C#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!# BGA#%Y\'CJ95A#^#; GN5\'9G#9G#9\'A)F<A%F%Y#A,Q\'Z$Y#;Y#^#G,91Y$FA%F+G6J+Y%F#\'b&D! 9&G(1=G\'E#G#=G%F#J+F$^#&Y/ 1&\'F?G<A#b&:! G,&A/J+FBG*E#=Y$%A#\'[#F7G%%G*%G$%G&A#Y0 F:G$A#9 F,A&F9<F\' Q#A\'G)FJ%G91GA)FW\')\'&I$G)I%\'I#&G(F+G#Y#J+9%F0\'I# F)A#F#A#F7 F( &A$F%A#\'&I$G%A#I#A#I#\'&A))A%F# F$G#A#J+F#[#L\'=;&9\'A#G#) F\'A%F#A#F7 F( F# F#"
        + " F#A#\' I$G#A%G#A#G$A$\'A(F% &A(J+G#F$\'9A+G#) F* F$ F7 F( F# F&A#\'&I$G& G#) I#\'A#&A0F#G#A#J+9;A(&G\' \'I# F)A#F#A#F7 F( F# F&A#\'&)\')G%A#I#A#I#\'A(G#)A%F# F$G#A#J+=&L\'A+\'& F\'A$F$ F%A$F# & F#A$F#A$F$A$F-A%I#\'I#A$I$ I$\'A#&A\')A/J+L$^\';=A&\'I$\'F) F$ F8 F1A#\'&G$I% G$ G%A(G# F$A#&A#F#G#A#J+A(9L(=&\'I#9F) F$ F8 F+ F&A#\'&)\'I& \'I# I#G#A(I#A\'F# F#G#A#J+ F#)A-G#I#F* F$ FJG#&I$G% I$ I$\'&=A%F$)L(F$G#A#J+L*=F\' \'I# F3A$F9 F* &A#F(A$\'A%I$G$ \' I)A\'J+A#I#9A-FQ\'F#G(A%;F\'%G)9J+Y#AFF# & F& F9 & F+\'F#G*&A#F& % G( J+A#F%AA&^$Y0=9^$G#^\'J+"
        + "L+=\'=\'=\'6767I#F) FEA%G/)G&9G#F&G, GE ^)\'^\' ^#Y&^%Y#AFFLI#G%)G\')G#I#G#&J+Y\'F\'I#G#F%G$&I$F#I(F$G%F.\'I#G#I\'\'&)J+I$\'^#BG !A&!A#CL9%C$b&*&  F%A#F( & F%A#FJ F%A#FB F%A#F( & F%A#F0 FZ F%A#FeA#G$Y*L5A$F1^+A\'b!7! A#C\'A#5b&M* =9F2-F;67A$FmY$K$F)A(F3G$)A*F4G#)Y#A*F3G#A-F. F$ G#A-FUG#)G(I)\'I#G,Y$%Y$;&\'A#J+A\'L+A\'Y\'5Y%G$1\'J+A\'FD%FVA(F&G#FC\'&A&FhA+F@ G$I%G#I$A%I#\'I\'G$A%=A$Y#J+F?A#F&A,FMA%F;A\'J+,A$^CF8G#I#\'A#Y#FV)\')G( \')\'I#G)I\'G+A#\'J+A\'J+A\'Y(%Y\'A#G/(G1ARG%)FP\')G&)\'I&\'I#F)A$J+Y(^+G*^*Y# G#)F?)G%I#G#)G$F#J+FM\')G#I$\')G$I#A)Y%"
        + "FEI)G)I#G#A$Y&J+A$F$J+F?E\'Y#C*A(BLA#B$Y)A)G$9G.)G(F%\'F\'\'F#)G#&A&CMEaC.%CCEFGb!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!C*!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!C*B)C\'A#B\'A#C)B)C)B)C\'A#B\'A#C) ! ! ! !C)B)C/A#C)D)C)D)C)D)C& C#B%$<#]$C$ C#B%$]$C%A#C#B% ]$C)B&]$A#C$ C#B%$]# M,Q&U\'Y#>?6_#?6>Y)./Q&-Y*>?Y%X#Y$:67Y,:98Y+-Q& Q+,%A#L\'Z$67%L+Z$67 E.A$[BA0G."
        + "H%\'H$G-A0^#!^%!^##B$C#B$#=!^#:B&^\'!=!=!=B%=#B%#F%#^#C#B#Z&!C%=:^##=L1KD!#K%,^#A%Z&^&Z#^%:^#:^#:^(:^@Z#^#:=:^@b:-% ^)6767^5Z#^(67b=2! :^?Z:^IZ\'^gA:^,A6L^^pL7b=X# :^*:^WZ)b=P! :b=Y$ 67676767676767L?^MZ&67Z@6767676767Z1b= % b:$# 6767676767676767676767Za6767ZA67b:#% ^QZ6^#Z\'^HA#^A b=J! BQCQ!#B$C#!#!#!#B%#!C#!C\'E#B$#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!C#^\'!#!#G$!#A&Y%,Y#CG #A&#A#FYA(%9A/\'F8A*F( F( F( F( F( F( F( F( GAY#>?>?Y$>?9>?Y*5Y#59>?Y#>?67676767Y"
        + "&%Y+U#Y%596Y.^#Y$676767675AC^; b=:! A-b=7$ A;^-A%-Y$=%&+6767676767^#6767676756W#=K*G%I#5E&^#K$%&9^# b&7! A#G#]#E#&5b&;! 9E$&A&FL b&?!  ^#L%^+FA^EA-F1^@ L+^?L)=L0^AL+^HL0b= & &b `G!&^b&b   %b `(!F7%b&X2 A$^XA*FIE\'Y#b&-% %Y$F1J+F#A5!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#&\'H$9G+9%!#!#!#!#!#!#!#!#!#!#!#!#!#!#E#G#FhK+G#Y\'A)]8E*]#!#!#!#!#!#!#!C$!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#!#%C)!#!#B##!#!#!#!#%]#!#!#&!#!C$!#!#!#!#!#!#!#!#!#!#B&#B&#!#!#!#!#!#!#!#B%#!#A&!# # #!#!#A9E$!#&E##F(\'F"
        + "$\'F%\'F8I#G#)^%\'A$L\'^#;=A\'FUY%A)I#FSI1G#A)Y#J+A\'G3F\'Y$&9F#\'J+F=G)Y#F8G,I#A,9F>A$G$)FP\'I#G%I#G#I$Y. %J+A%Y#F&\'%F*J+F& FJG\'I#G#I#G#A*F$\'F)\')A#J+A#Y%F1%F\'^$&)\')FS\'&G$F#G#F&G#&\'&A9F#%Y#F,)G#I#Y#&E#)\'A+F\'A#F\'A#F\'A*F( F( CL<E%C*%]#A%b#1! FDI#\'I#\'I#9)\'A#J+A\'&b CO#&A-F8A%FRA%4b `. T#b `! T#b `0 43b `D!3b&O& A#b&K! AGC(A-C&A&&\'F+:F. F& & F# F# b&M! ]2A1b&L& 76^1FbA#FWA(=AAF-;^$G1Y(679A\'G19U#X#6767676767676767Y#67Y%X$Y$ Y%5676767Y$:5Z$ 9;Y#A%F& b&(# A#1 Y$;Y$679:95Y#J+Y#Z$Y#B;697<8<C;6:7:67967Y#F+%FNE#F@A$F\'A#F\'A#F\'A#"
        + "F$A$[#:<=[# =Z%^#A+Q$^#A#F- F; F4 F# F0A#F/ACb&]! A&Y$A%LNA$^*KVL%^2L#^$ ^.A$=AP^N\'b ## F>A$FRA0\'L<A%FAL%A*F5+F)+A&FGG&A&F? 9FEA%F)9K&AKBICIFpA#J+A\'BEA%CEA%FIA)FUA,9B, B0 B( B# C, C0 C( C#Aeb&X% A*F7A+F)A9E\' EK E*AgF\'A#& FM F#A$&A#F8 9L)F8^#L(F@A)L*AQF4 F#A&L&F7L\'A$9F;A&9AbFYA%L#F#L1A#LO&G$ G#A&G%F% F$ F>A#G$A%\'L*A(Y*A(F>L#9F>L$AAF)=F=G#A%L&Y(A*FWA$Y(F7A#L)F4A&L)F3A(Y%A-L(b 1! FkAXBTA.CTA(L\'FEG%A)J+b G% L@ FK G#5A#F#AmG$F>L+&A)F7G,L%Y&A7F3G%Y%AGF6L(A5F8A*)\')FVG0Y(A%L5J+\'F#G#&A*G$)FNI$G%I#G#Y#1Y%\'A+1A#F:A(J+"
        + "A\'G$FEG&)G) J+Y%&I#&A)FD\'Y#&A*G#)FQI$G*I#F%Y%G%9)\'J+&9&Y$ L5A,F3 F:I$G$I#\')G#Y\'\'F#\'A`F( & F% F0 F+9A\'FP\'I$G)A&J+A\'G#I# F)A#F#A#F7 F( F# F& G#&I#\'I%A#I#A#I$A#&A\')A&F&I#A#G(A$G&b ,# FVI$G)I#G$)\'F%Y&J+Y# 9\'F$A?FQI$G\')\'I%G#)G#F#9&A)J+b G# FPI$G%A#I%G#)G#Y8F%G#ACFQI$G)I#\')G#Y$&A,J+A\'Y.A4FL\')\'I#G\')\'&9A\'J+AWF<A#G$I#G%)G&A%J+L#Y$=F(b Z# FMI$G*)G#9b E! BACAJ+L*A-F)A#&A#F) F# F9I\' I#A#G#)\'&)&)\'Y$A*J+AhF)A#FHI$G%A#G#I%\'&9&)A<&G+FIG\')&G%Y)\'A)&G\'I#G$FOG.)G#Y$&Y&A.FkA(Y+b W$ F* FF)G( G\')\'&Y&A+J+L4A$Y#F?A#G7 )G()G#)G#AkF("
        + " F# FGG\'A$\' G# G(&\'A)J+A\'F\' F# FAI& G# I#\')\'&A(J+b W% F4G#I#Y#A(G#&)F. FCI#G&A$I#\')\'Y.J+b 7! &A0L6^)[%^2A.9b&;/ b G! b+P!  Y&A,b&%$ b -J b&B! Y#A.b&Q1 Q1\'F\'G0b K` b&(* b Z\'#b&Z) A(F@ J+A%Y#Fq J+A\'F?A#G&9A+FQG(Y&^%E%9=A+J+ L( F6A&F4b Q+ BACAL8Y%b F! FmA%\'&IXA(G%E.AbE#9%\'A,I#A/&b W@!&A)b&74 AK&A(&b H,#E% E( E# b&D% A0&A>F$A#&A/F%A)b&-\' b %E b&L! A&F.A$F*A(F+A#=G#9Q%b =*!GOA#G8A*b=U! A^b=W$ A+^HA#^^I#G$^$I\'Q)G)^#G(^?G%^_A6^dG$=b [! L5A-L5A-b=8! A*L:b (# B;C;B;C( C3B;C;! B#A#!A#B#A#B% B)C% # C( C,B;C;B# B%A#B) "
        + "B( C;B# B% B& !A$B( C;B;C;B;C;B;C;B;C;B;C;B;C=A#B::C::C\'B::C::C\'B::C::C\'B::C::C\'B::C::C\'!#A#JSb= ) GX^%GS^)\'^/\'^#Y&A0G& G0b 12 C+&C5A\'C\'b 6$ G( G2A#G( G# G&A&E`AB\'b Q! FNA$G(E(A#J+A%&=b  & F?\'A2FMG%J+A&;b 1( F<%G%J+b G, F( F% F# F0 b&&$ A#L*G(AJBCCCG(%A%J+A%Y#b 2- L]=L$;L%AnLN=L0b #$ F% F< F# &A#& F+ F% & &A\'&A%& & & F$ F# &A#& & & & & F# &A#F% F( F% F% & F+ F2A&F$ F& F2AUZ#b /% ^MA%b=E! A-^0A#^0 ^0 ^FA+L.b=B# AY^>A.^MA%^*A(^#A/^\'b ;# b=]$ ]&b=9, A%^2A$^.A$b=X! A%b=@! A\'^-A%=A0^-A%^YA)^+A\'^IA)^?A#^#Apb=5& A"
        + "-^/A#^.A$^*A(^O ^(A)^/A%^*A(^*A(b=4#  ^XAFJ+b \'1 &b   %b   %b ?<#&AA&b Y !&A\'&b =$ &A#&b  ;!&A/&b PU!&b @Q b&?) b C8 &b *.!&A&&b ?!!&b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b   %b 2R!1A?b1A! b  # b\'Q$ b   %b   %b   %b 1Y$3b   %b   %b   %b ^a$3A#3b   %b   %b   %b ^a$3"};
    }
    var oncifp_SemanticAnalyzer$ = $rt_classWithoutFields();
    var oncifp_SemanticAnalyzer$_MODULE$ = null;
    var oncifp_SemanticAnalyzer$_parsing0 = null;
    var oncifp_SemanticAnalyzer$_context0 = null;
    function oncifp_SemanticAnalyzer$_$callClinit() {
        oncifp_SemanticAnalyzer$_$callClinit = $rt_eraseClinit(oncifp_SemanticAnalyzer$);
        oncifp_SemanticAnalyzer$__clinit_();
    }
    function oncifp_SemanticAnalyzer$__clinit_() {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = new oncifp_SemanticAnalyzer$;
        oncifp_SemanticAnalyzer$_$callClinit();
        oncifp_SemanticAnalyzer$_MODULE$ = var$1;
        oncifp_CompilationPhases$_$callClinit();
        var$1 = new oncifp_CompilationPhases$ParsingConfig;
        s_Predef$_$callClinit();
        s_Predef$_Map(s_Predef$_MODULE$);
        var$2 = sci_Map$EmptyMap$_MODULE$;
        var$3 = oncifp_CompilationPhases$_defaultSemanticFeatures;
        var$1.$parameterTypeMapping = var$2;
        var$1.$semanticFeatures = var$3;
        var$1.$obfuscateLiterals = 0;
        oncifp_Parse$_$callClinit();
        var$3 = oncifp_Parse$_MODULE$;
        var$2 = new oncifp_SyntaxDeprecationWarningsAndReplacements;
        oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
        oncifp_SyntaxDeprecationWarningsAndReplacements__init_(var$2, oncir_Deprecations$syntacticallyDeprecatedFeatures$_MODULE$);
        var$2 = oncifp_Transformer_andThen$(var$3, var$2);
        oncifp_PreparatoryRewriting$_$callClinit();
        var$4 = oncifp_Transformer_andThen$(var$2, oncifp_PreparatoryRewriting$_MODULE$);
        var$2 = new oncifp_If;
        var$5 = new oncifp_CompilationPhases$$parsingBase$lambda$_3_0;
        var$5.$_02 = var$1;
        var$3 = oncifp_extractSensitiveLiterals$_MODULE$;
        var$2.$f = var$5;
        var$2.$thenT = var$3;
        var$5 = oncifp_Transformer_andThen$(var$4, var$2);
        var$3 = new oncifp_SemanticAnalysis;
        var$2 = var$1.$semanticFeatures;
        var$3.$warn = 1;
        var$3.$features = var$2;
        var$2 = oncifp_Transformer_andThen$(var$5, var$3);
        oncifp_SemanticTypeCheck$_$callClinit();
        var$2 = oncifp_Transformer_andThen$(var$2, oncifp_SemanticTypeCheck$_MODULE$);
        var$3 = new oncifp_AmbiguousAggregationAnalysis;
        var$3.$features0 = var$1.$semanticFeatures;
        oncifp_SemanticAnalyzer$_parsing0 = oncifp_Transformer_andThen$(oncifp_Transformer_andThen$(var$2, var$3), oncifp_SyntaxDeprecationWarningsAndReplacements__init_0(oncir_Deprecations$semanticallyDeprecatedFeatures$_MODULE$));
        var$1 = new oncifp_SemanticAnalyzer$$anon$1;
        var$1.$errorMessageProvider = oncm_MessageUtilProvider$_MODULE$;
        oncifp_SemanticAnalyzer$_context0 = var$1;
    }
    function oncifp_SemanticAnalyzer$_parsing($this) {
        oncifp_SemanticAnalyzer$_$callClinit();
        return oncifp_SemanticAnalyzer$_parsing0;
    }
    function oncifp_SemanticAnalyzer$_context($this) {
        oncifp_SemanticAnalyzer$_$callClinit();
        return oncifp_SemanticAnalyzer$_context0;
    }
    var oncifp_CompilationPhases$ = $rt_classWithoutFields();
    var oncifp_CompilationPhases$_MODULE$ = null;
    var oncifp_CompilationPhases$_defaultSemanticFeatures = null;
    function oncifp_CompilationPhases$_$callClinit() {
        oncifp_CompilationPhases$_$callClinit = $rt_eraseClinit(oncifp_CompilationPhases$);
        oncifp_CompilationPhases$__clinit_();
    }
    function oncifp_CompilationPhases$__clinit_() {
        var var$1;
        var$1 = new oncifp_CompilationPhases$;
        oncifp_CompilationPhases$_$callClinit();
        oncifp_CompilationPhases$_MODULE$ = var$1;
        oncifp_CompilationPhases$_defaultSemanticFeatures = sci_$colon$colon__init_(oncias_SemanticFeature$MultipleDatabases$_MODULE$, sci_$colon$colon__init_(oncias_SemanticFeature$MultipleGraphs$_MODULE$, sci_$colon$colon__init_(oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$, sci_Nil$_MODULE$)));
    }
    function oncifp_CompilationPhases$ParsingConfig() {
        var a = this; jl_Object.call(a);
        a.$parameterTypeMapping = null;
        a.$semanticFeatures = null;
        a.$obfuscateLiterals = 0;
    }
    var s_Function3 = $rt_classWithoutFields(0);
    var sr_AbstractFunction3 = $rt_classWithoutFields();
    var oncifp_CompilationPhases$ParsingConfig$ = $rt_classWithoutFields(sr_AbstractFunction3);
    var oncifp_CompilationPhases$ParsingConfig$_MODULE$ = null;
    function oncifp_CompilationPhases$ParsingConfig$__clinit_() {
        oncifp_CompilationPhases$ParsingConfig$_MODULE$ = new oncifp_CompilationPhases$ParsingConfig$;
    }
    var oncifp_BaseContext = $rt_classWithoutFields(0);
    function oncifp_SemanticAnalyzer$$anon$1() {
        jl_Object.call(this);
        this.$errorMessageProvider = null;
    }
    function oncifp_SemanticAnalyzer$$anon$1_cypherExceptionFactory($this) {
        var var$1;
        var$1 = new onciu_OpenCypherExceptionFactory;
        var$1.$preParserOffset = null;
        return var$1;
    }
    function oncifp_SemanticAnalyzer$$anon$1_errorHandler($this) {
        return new oncifp_SemanticAnalyzer$$anon$1$errorHandler$lambda$_4_0;
    }
    var onciu_ErrorMessageProvider = $rt_classWithoutFields(0);
    var oncm_MessageUtilProvider$ = $rt_classWithoutFields();
    var oncm_MessageUtilProvider$_MODULE$ = null;
    function oncm_MessageUtilProvider$__clinit_() {
        oncm_MessageUtilProvider$_MODULE$ = new oncm_MessageUtilProvider$;
    }
    function oncm_MessageUtilProvider$_createMissingPropertyLabelHintError($this, $operatorDescription, $hintStringification, $missingThingDescription, $foundThingsDescription, $entityDescription, $entityName, $additionalInfo) {
        return jl_String_format($rt_s(18), $rt_createArrayFromData(jl_Object, [$operatorDescription, $hintStringification, jl_String_format($rt_s(19), $rt_createArrayFromData(jl_Object, [$missingThingDescription, $foundThingsDescription, $entityDescription, $entityName, $additionalInfo]))]));
    }
    function oncm_MessageUtilProvider$_createUseClauseUnsupportedError($this) {
        return $rt_s(20);
    }
    function oncm_MessageUtilProvider$_createDynamicGraphReferenceUnsupportedError($this) {
        return $rt_s(21);
    }
    function oncm_MessageUtilProvider$_createMultipleGraphReferencesError($this) {
        return $rt_s(22);
    }
    var sc_IterableOnce = $rt_classWithoutFields(0);
    var sc_IterableOnceOps = $rt_classWithoutFields(0);
    function sc_IterableOnceOps_foreach$($$this, $f) {
        $$this = $$this.$iterator0();
        while ($$this.$hasNext()) {
            $f.$apply($$this.$next());
        }
    }
    function sc_IterableOnceOps_forall$($$this, $p) {
        var var$3;
        var$3 = 1;
        $$this = $$this.$iterator0();
        while (var$3 && $$this.$hasNext()) {
            var$3 = sr_BoxesRunTime_unboxToBoolean($p.$apply($$this.$next()));
        }
        return var$3;
    }
    function sc_IterableOnceOps_exists$($$this, $p) {
        var var$3;
        var$3 = 0;
        $$this = $$this.$iterator0();
        while (!var$3 && $$this.$hasNext()) {
            var$3 = sr_BoxesRunTime_unboxToBoolean($p.$apply($$this.$next()));
        }
        return var$3;
    }
    function sc_IterableOnceOps_find$($$this, $p) {
        var var$3;
        $$this = $$this.$iterator0();
        a: {
            while ($$this.$hasNext()) {
                var$3 = $$this.$next();
                if (!sr_BoxesRunTime_unboxToBoolean($p.$apply(var$3)))
                    continue;
                else {
                    $$this = s_Some__init_(var$3);
                    break a;
                }
            }
            $$this = s_None$_MODULE$;
        }
        return $$this;
    }
    function sc_IterableOnceOps_foldLeft$($$this, $z, $op) {
        var var$4, var$5, var$6;
        if (!$rt_isInstance($$this, sc_IndexedSeq)) {
            $$this = $$this.$iterator0();
            while ($$this.$hasNext()) {
                $z = $op.$apply0($z, $$this.$next());
            }
        } else {
            $$this = $$this;
            var$4 = 0;
            var$5 = $$this.$length();
            while (var$4 != var$5) {
                var$6 = var$4 + 1 | 0;
                $z = $op.$apply0($z, $$this.$apply1(var$4));
                var$4 = var$6;
            }
        }
        return $z;
    }
    function sc_IterableOnceOps_reduceLeft$($$this, $op) {
        var var$3, var$4, var$5, var$6;
        a: {
            if ($rt_isInstance($$this, sc_IndexedSeq)) {
                var$3 = $$this;
                if (var$3.$length() > 0) {
                    var$4 = 1;
                    $$this = var$3.$apply1(0);
                    var$5 = var$3.$length();
                    while (var$4 != var$5) {
                        var$6 = var$4 + 1 | 0;
                        $$this = $op.$apply0($$this, var$3.$apply1(var$4));
                        var$4 = var$6;
                    }
                    break a;
                }
            }
            if (!$$this.$knownSize()) {
                $$this = new jl_UnsupportedOperationException;
                jl_Throwable__init_($$this, $rt_s(23));
                $rt_throw($$this);
            }
            var$3 = $$this.$iterator0();
            if (!var$3.$hasNext()) {
                $op = new jl_UnsupportedOperationException;
                jl_Throwable__init_($op, $rt_s(23));
                $rt_throw($op);
            }
            $$this = var$3.$next();
            while (var$3.$hasNext()) {
                $$this = $op.$apply0($$this, var$3.$next());
            }
        }
        return $$this;
    }
    function sc_IterableOnceOps_nonEmpty$($$this) {
        return $$this.$isEmpty() ? 0 : 1;
    }
    function sc_IterableOnceOps_size$($$this) {
        var var$2;
        if ($$this.$knownSize() >= 0)
            var$2 = $$this.$knownSize();
        else {
            $$this = $$this.$iterator0();
            var$2 = 0;
            while ($$this.$hasNext()) {
                var$2 = var$2 + 1 | 0;
                $$this.$next();
            }
        }
        return var$2;
    }
    function sc_IterableOnceOps_copyToArray$($$this, $xs) {
        return $$this.$copyToArray($xs, 0, 2147483647);
    }
    function sc_IterableOnceOps_copyToArray$0($$this, $xs, $start) {
        return $$this.$copyToArray($xs, $start, 2147483647);
    }
    function sc_IterableOnceOps_copyToArray$1($$this, $xs, $start, $len) {
        var var$5;
        $$this = $$this.$iterator0();
        $len = $start + jl_Math_min($len, jlr_Array_getLength($xs) - $start | 0) | 0;
        var$5 = $start;
        while (var$5 < $len && $$this.$hasNext()) {
            sr_ScalaRunTime$_array_update(sr_ScalaRunTime$_MODULE$, $xs, var$5, $$this.$next());
            var$5 = var$5 + 1 | 0;
        }
        return var$5 - $start | 0;
    }
    function sc_IterableOnceOps_mkString$($$this, $start, $sep, $end) {
        if ($$this.$knownSize())
            $$this = scm_StringBuilder_result($$this.$addString(scm_StringBuilder__init_(), $start, $sep, $end));
        else {
            $$this = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2($$this, 0);
            jl_AbstractStringBuilder_append1($$this, $start);
            jl_AbstractStringBuilder_append1($$this, $end);
            $$this = jl_AbstractStringBuilder_toString($$this);
        }
        return $$this;
    }
    function sc_IterableOnceOps_addString$($$this, $b, $start, $sep, $end) {
        var var$6;
        var$6 = $b.$underlying;
        if (jl_String_length($start))
            jl_AbstractStringBuilder_append1(var$6, $start);
        a: {
            $start = $$this.$iterator0();
            if ($start.$hasNext()) {
                jl_StringBuilder_append(var$6, $start.$next());
                while (true) {
                    if (!$start.$hasNext())
                        break a;
                    jl_AbstractStringBuilder_append1(var$6, $sep);
                    jl_StringBuilder_append(var$6, $start.$next());
                }
            }
        }
        if (jl_String_length($end))
            jl_AbstractStringBuilder_append1(var$6, $end);
        return $b;
    }
    function sc_IterableOnceOps_toList$($$this) {
        return sci_List_prependedAll(sci_Nil$_MODULE$, $$this);
    }
    function sc_IterableOnceOps_toSeq$($$this) {
        sci_Seq$_$callClinit();
        return sci_Seq$_from(sci_Seq$_MODULE$, $$this);
    }
    function sc_IterableOnceOps_toArray$($$this, $evidence$2) {
        return sc_IterableOnceOps_toArray($$this, $evidence$2);
    }
    function sc_IterableOnceOps_toArray($this, $evidence$2) {
        var $destination;
        if ($this.$knownSize() >= 0) {
            $destination = $evidence$2.$newArray($this.$knownSize());
            $this.$copyToArray0($destination, 0);
            return $destination;
        }
        a: {
            $destination = $evidence$2.$runtimeClass();
            if (jl_Object_equals($rt_cls($rt_bytecls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofByte;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_shortcls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofShort;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_charcls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofChar;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_intcls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofInt;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_longcls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofLong;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_floatcls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofFloat;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_doublecls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofDouble;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_booleancls()), $destination)) {
                $destination = new scm_ArrayBuilder$ofBoolean;
                scm_ArrayBuilder__init_($destination);
                break a;
            }
            if (!jl_Object_equals($rt_cls($rt_voidcls()), $destination)) {
                $destination = scm_ArrayBuilder$ofRef__init_($evidence$2);
                break a;
            }
            $destination = new scm_ArrayBuilder$ofUnit;
            scm_ArrayBuilder__init_($destination);
        }
        return ($destination.$addAll($this)).$result0();
    }
    var sc_IterableOps = $rt_classWithoutFields(0);
    function sc_IterableOps_sizeCompare$($$this, $otherSize) {
        var var$3;
        a: {
            if ($otherSize < 0)
                $otherSize = 1;
            else {
                var$3 = $$this.$knownSize();
                if (var$3 >= 0)
                    $otherSize = $rt_compare(var$3, $otherSize);
                else {
                    var$3 = 0;
                    $$this = $$this.$iterator0();
                    while ($$this.$hasNext()) {
                        if (var$3 == $otherSize) {
                            $otherSize = 1;
                            break a;
                        }
                        $$this.$next();
                        var$3 = var$3 + 1 | 0;
                    }
                    $otherSize = var$3 - $otherSize | 0;
                }
            }
        }
        return $otherSize;
    }
    function sc_IterableOps_drop$($$this, $n) {
        var var$3;
        var$3 = new sc_View$Drop;
        var$3.$underlying0 = $$this;
        var$3.$n = $n;
        var$3.$normN = jl_Math_max($n, 0);
        return $$this.$fromSpecific(var$3);
    }
    function sc_IterableOps_concat$($$this, $suffix) {
        var var$3, var$4;
        var$3 = $$this.$iterableFactory();
        if ($rt_isInstance($suffix, sc_Iterable))
            $suffix = sc_View$Concat__init_($$this, $suffix);
        else {
            $$this = $$this.$iterator0();
            var$4 = new sc_IterableOps$concat$lambda$_94_0;
            var$4.$_03 = $suffix;
            if ($$this === null)
                $rt_throw(null);
            $suffix = $$this.$concat(var$4);
        }
        return var$3.$from0($suffix);
    }
    var sc_IterableFactoryDefaults = $rt_classWithoutFields(0);
    var sc_Iterable = $rt_classWithoutFields(0);
    function sc_Iterable_toString$($$this) {
        var var$2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$2, 1);
        jl_AbstractStringBuilder_append1(var$2, $$this.$className());
        jl_AbstractStringBuilder_append1(var$2, $rt_s(24));
        return sc_IterableOnceOps_mkString$($$this, jl_AbstractStringBuilder_toString(var$2), $rt_s(16), $rt_s(25));
    }
    var sc_AbstractIterable = $rt_classWithoutFields();
    function sc_AbstractIterable_coll($this) {
        return $this;
    }
    function sc_AbstractIterable_iterableFactory($this) {
        sc_Iterable$_$callClinit();
        return sc_Iterable$_MODULE$;
    }
    function sc_AbstractIterable_className($this) {
        return $this.$stringPrefix();
    }
    function sc_AbstractIterable_fromSpecific($this, $coll) {
        return ($this.$iterableFactory()).$from0($coll);
    }
    function sc_AbstractIterable_newSpecificBuilder($this) {
        return ($this.$iterableFactory()).$newBuilder();
    }
    function sc_AbstractIterable_empty($this) {
        return ($this.$iterableFactory()).$empty();
    }
    function sc_AbstractIterable_head($this) {
        return ($this.$iterator0()).$next();
    }
    function sc_AbstractIterable_headOption($this) {
        var var$1;
        var$1 = $this.$iterator0();
        return !var$1.$hasNext() ? s_None$_MODULE$ : s_Some__init_(var$1.$next());
    }
    function sc_AbstractIterable_last($this) {
        var var$1, var$2;
        var$1 = sci_ListSet_iterator($this);
        var$2 = var$1.$next();
        while (var$1.$hasNext()) {
            var$2 = var$1.$next();
        }
        return var$2;
    }
    function sc_AbstractIterable_sizeCompare($this, $otherSize) {
        return sc_IterableOps_sizeCompare$($this, $otherSize);
    }
    function sc_AbstractIterable_filter($this, $pred) {
        return $this.$fromSpecific(sc_View$Filter__init_($this, $pred, 0));
    }
    function sc_AbstractIterable_filterNot($this, $pred) {
        return $this.$fromSpecific(sc_View$Filter__init_($this, $pred, 1));
    }
    function sc_AbstractIterable_withFilter($this, $p) {
        var var$2;
        var$2 = new sc_IterableOps$WithFilter;
        var$2.$self = $this;
        var$2.$p = $p;
        return var$2;
    }
    function sc_AbstractIterable_partition($this, $p) {
        var var$2, var$3;
        var$2 = sc_View$Filter__init_($this, $p, 0);
        var$3 = sc_View$Filter__init_($this, $p, 1);
        return s_Tuple2__init_($this.$fromSpecific0(var$2), $this.$fromSpecific0(var$3));
    }
    function sc_AbstractIterable_takeWhile($this, $p) {
        var var$2;
        var$2 = new sc_View$TakeWhile;
        var$2.$underlying1 = $this;
        var$2.$p0 = $p;
        return $this.$fromSpecific(var$2);
    }
    function sc_AbstractIterable_span($this, $p) {
        return s_Tuple2__init_($this.$takeWhile($p), $this.$dropWhile($p));
    }
    function sc_AbstractIterable_drop($this, $n) {
        return sc_IterableOps_drop$($this, $n);
    }
    function sc_AbstractIterable_dropRight($this, $n) {
        var var$2;
        var$2 = new sc_View$DropRight;
        var$2.$underlying2 = $this;
        var$2.$n0 = $n;
        var$2.$normN0 = jl_Math_max($n, 0);
        return $this.$fromSpecific(var$2);
    }
    function sc_AbstractIterable_dropWhile($this, $p) {
        var var$2;
        var$2 = new sc_View$DropWhile;
        var$2.$underlying3 = $this;
        var$2.$p1 = $p;
        return $this.$fromSpecific(var$2);
    }
    function sc_AbstractIterable_sliding($this, $size) {
        return $this.$sliding($size, 1);
    }
    function sc_AbstractIterable_sliding0($this, $size, $step) {
        var var$3, var$4;
        var$3 = ($this.$iterator0()).$sliding0($size, $step);
        var$4 = new sc_IterableOps$sliding$lambda$_64_0;
        var$4.$_04 = $this;
        return sc_Iterator_map$(var$3, var$4);
    }
    function sc_AbstractIterable_tail($this) {
        var var$1;
        if (!$this.$isEmpty())
            return $this.$drop(1);
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    function sc_AbstractIterable_init($this) {
        var var$1;
        if (!$this.$isEmpty())
            return $this.$dropRight(1);
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    function sc_AbstractIterable_groupBy($this, $f) {
        var var$2, var$3, var$4, var$5, var$6;
        scm_Map$_$callClinit();
        var$2 = sc_MapFactory$Delegate_empty(scm_Map$_MODULE$);
        var$3 = $this.$iterator0();
        while (true) {
            if (!var$3.$hasNext()) {
                sci_HashMap$_$callClinit();
                $f = sci_HashMap$_empty(sci_HashMap$_MODULE$);
                var$2 = scm_HashMap_iterator(var$2);
                while (var$2.$hasNext()) {
                    var$3 = var$2.$next();
                    if (var$3 === null)
                        $rt_throw(s_MatchError__init_(null));
                    $f = sci_HashMap_updated($f, var$3.$_10, var$3.$_20.$result0());
                }
                return $f;
            }
            var$4 = var$3.$next();
            var$5 = $f.$apply(var$4);
            var$6 = new sc_IterableOps$groupBy$lambda$_72_0;
            var$6.$_05 = $this;
            var$5 = scm_HashMap_getOrElseUpdate(var$2, var$5, var$6);
            if (var$5 === null)
                break;
            var$5.$addOne(var$4);
        }
        $rt_throw(null);
    }
    function sc_AbstractIterable_groupMap($this, $key, $f) {
        var var$3, var$4;
        scm_Map$_$callClinit();
        var$3 = sc_MapFactory$Delegate_empty(scm_Map$_MODULE$);
        var$4 = new sc_IterableOps$groupMap$lambda$_74_0;
        var$4.$_06 = $this;
        var$4.$_11 = $key;
        var$4.$_21 = var$3;
        var$4.$_30 = $f;
        sci_List_foreach($this, var$4);
        $key = new sc_IterableOps$Result$1;
        $key.$built = sci_Map$EmptyMap$_MODULE$;
        scm_HashMap_foreach(var$3, $key);
        return $key.$built;
    }
    function sc_AbstractIterable_groupMapReduce($this, $key, $f, $reduce) {
        var var$4, var$5;
        scm_Map$_$callClinit();
        var$4 = sc_MapFactory$Delegate_empty(scm_Map$_MODULE$);
        var$5 = new sc_IterableOps$groupMapReduce$lambda$_76_0;
        var$5.$_07 = $key;
        var$5.$_12 = var$4;
        var$5.$_22 = $reduce;
        var$5.$_31 = $f;
        $this.$foreach(var$5);
        $key = sci_Map$_MODULE$;
        $f = new sc_MapFactory$ToFactory;
        $f.$factory = $key;
        return $f.$fromSpecific(var$4);
    }
    function sc_AbstractIterable_map($this, $f) {
        return ($this.$iterableFactory()).$from0(sc_View$Map__init_($this, $f));
    }
    function sc_AbstractIterable_flatMap($this, $f) {
        return ($this.$iterableFactory()).$from0(sc_View$FlatMap__init_($this, $f));
    }
    function sc_AbstractIterable_flatten($this, $asIterable) {
        return $this.$flatMap($asIterable);
    }
    function sc_AbstractIterable_collect($this, $pf) {
        return ($this.$iterableFactory()).$from0(sc_View$Collect__init_($this, $pf));
    }
    function sc_AbstractIterable_concat($this, $suffix) {
        return sc_IterableOps_concat$($this, $suffix);
    }
    function sc_AbstractIterable_$plus$plus($this, $suffix) {
        return $this.$concat0($suffix);
    }
    function sc_AbstractIterable_foreach($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    }
    function sc_AbstractIterable_forall($this, $p) {
        return sc_IterableOnceOps_forall$($this, $p);
    }
    function sc_AbstractIterable_exists($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    }
    function sc_AbstractIterable_count($this, $p) {
        var var$2;
        var$2 = 0;
        $p = $this.$iterator0();
        while ($p.$hasNext()) {
            if (!sr_BoxesRunTime_unboxToBoolean(jl_Boolean_valueOf($rt_isInstance($p.$next(), oncia_CommandClause))))
                continue;
            var$2 = var$2 + 1 | 0;
        }
        return var$2;
    }
    function sc_AbstractIterable_find($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    }
    function sc_AbstractIterable_foldLeft($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    }
    function sc_AbstractIterable_reduce($this, $op) {
        return $this.$reduceLeft($op);
    }
    function sc_AbstractIterable_reduceLeft($this, $op) {
        return sc_IterableOnceOps_reduceLeft$($this, $op);
    }
    function sc_AbstractIterable_isEmpty($this) {
        var var$1;
        a: {
            switch ($this.$knownSize()) {
                case -1:
                    if (($this.$iterator0()).$hasNext()) {
                        var$1 = 0;
                        break a;
                    }
                    var$1 = 1;
                    break a;
                case 0:
                    break;
                default:
                    var$1 = 0;
                    break a;
            }
            var$1 = 1;
        }
        return var$1;
    }
    function sc_AbstractIterable_nonEmpty($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    }
    function sc_AbstractIterable_size($this) {
        return sc_IterableOnceOps_size$($this);
    }
    function sc_AbstractIterable_copyToArray($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    }
    function sc_AbstractIterable_copyToArray0($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    }
    function sc_AbstractIterable_copyToArray1($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    }
    function sc_AbstractIterable_min($this, $ord) {
        var var$2, var$3;
        a: {
            switch ($this.$knownSize()) {
                case -1:
                    var$2 = $this.$iterator0();
                    if (!var$2.$hasNext()) {
                        var$3 = new jl_UnsupportedOperationException;
                        jl_Throwable__init_(var$3, $rt_s(26));
                        $rt_throw(var$3);
                    }
                    var$3 = var$2.$next();
                    while (var$2.$hasNext()) {
                        var$3 = $ord.$min0(var$3, var$2.$next());
                    }
                    break a;
                case 0:
                    break;
                default:
                    var$3 = new sc_IterableOnceOps$min$lambda$_77_0;
                    var$3.$_08 = $ord;
                    var$3 = sc_IterableOnceOps_reduceLeft$($this, var$3);
                    break a;
            }
            $ord = new jl_UnsupportedOperationException;
            jl_Throwable__init_($ord, $rt_s(26));
            $rt_throw($ord);
        }
        return var$3;
    }
    function sc_AbstractIterable_max($this, $ord) {
        var var$2, var$3;
        a: {
            switch ($this.$knownSize()) {
                case -1:
                    var$2 = $this.$iterator0();
                    if (!var$2.$hasNext()) {
                        var$3 = new jl_UnsupportedOperationException;
                        jl_Throwable__init_(var$3, $rt_s(27));
                        $rt_throw(var$3);
                    }
                    var$3 = var$2.$next();
                    while (var$2.$hasNext()) {
                        var$3 = $ord.$max0(var$3, var$2.$next());
                    }
                    break a;
                case 0:
                    break;
                default:
                    var$3 = new sc_IterableOnceOps$max$lambda$_81_0;
                    var$3.$_09 = $ord;
                    var$3 = sc_IterableOnceOps_reduceLeft$($this, var$3);
                    break a;
            }
            $ord = new jl_UnsupportedOperationException;
            jl_Throwable__init_($ord, $rt_s(27));
            $rt_throw($ord);
        }
        return var$3;
    }
    function sc_AbstractIterable_minBy($this, $f, $ord) {
        var var$3, var$4, var$5;
        switch ($this.$knownSize()) {
            case 0:
                break;
            default:
                var$3 = new sc_IterableOnceOps$Maximized;
                var$4 = new sc_IterableOnceOps$minBy$lambda$_89_0;
                var$4.$_010 = $ord;
                var$3.$descriptor = $rt_s(28);
                var$3.$f0 = $f;
                var$3.$cmp = var$4;
                var$3.$$outer = $this;
                var$3.$maxElem = null;
                var$3.$maxF = null;
                var$3.$nonEmpty = 0;
                $f = $this.$foldLeft(var$3, new sc_IterableOnceOps$minBy$lambda$_89_1);
                if ($f.$nonEmpty)
                    return $f.$maxElem;
                var$5 = new jl_UnsupportedOperationException;
                $ord = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_2($ord, 6);
                jl_AbstractStringBuilder_append1($ord, $rt_s(29));
                jl_AbstractStringBuilder_append1($ord, $f.$descriptor);
                jl_Throwable__init_(var$5, jl_AbstractStringBuilder_toString($ord));
                $rt_throw(var$5);
        }
        $ord = new jl_UnsupportedOperationException;
        jl_Throwable__init_($ord, $rt_s(30));
        $rt_throw($ord);
    }
    function sc_AbstractIterable_collectFirst($this, $pf) {
        var var$2, var$3, var$4;
        var$2 = new sc_IterableOnceOps$$anon$1;
        var$3 = $this.$iterator0();
        a: {
            while (var$3.$hasNext()) {
                var$4 = $pf.$applyOrElse(var$3.$next(), var$2);
                if (var$4 === var$2)
                    continue;
                else {
                    $pf = s_Some__init_(var$4);
                    break a;
                }
            }
            $pf = s_None$_MODULE$;
        }
        return $pf;
    }
    function sc_AbstractIterable_mkString($this, $start, $sep, $end) {
        return sc_IterableOnceOps_mkString$($this, $start, $sep, $end);
    }
    function sc_AbstractIterable_mkString0($this, $sep) {
        return sc_IterableOnceOps_mkString$($this, $rt_s(3), $sep, $rt_s(3));
    }
    function sc_AbstractIterable_mkString1($this) {
        return sc_IterableOnceOps_mkString$($this, $rt_s(3), $rt_s(3), $rt_s(3));
    }
    function sc_AbstractIterable_addString($this, $b, $start, $sep, $end) {
        return sc_IterableOnceOps_addString$($this, $b, $start, $sep, $end);
    }
    function sc_AbstractIterable_to($this, $factory) {
        return $factory.$fromSpecific($this);
    }
    function sc_AbstractIterable_toList($this) {
        return sc_IterableOnceOps_toList$($this);
    }
    function sc_AbstractIterable_toVector($this) {
        sci_Vector$_$callClinit();
        return sci_Vector$_from(sci_Vector$_MODULE$, $this);
    }
    function sc_AbstractIterable_toMap($this, $ev) {
        return sci_Map$_from(sci_Map$_MODULE$, $this);
    }
    function sc_AbstractIterable_toSet($this) {
        return sci_Set$_from(sci_Set$_MODULE$, $this);
    }
    function sc_AbstractIterable_toSeq($this) {
        return sc_IterableOnceOps_toSeq$($this);
    }
    function sc_AbstractIterable_toIndexedSeq($this) {
        var var$1;
        sci_IndexedSeq$_$callClinit();
        var$1 = sci_IndexedSeq$_MODULE$;
        return $rt_isInstance($this, sci_IndexedSeq) ? $this : sc_SeqFactory$Delegate_from(var$1, $this);
    }
    function sc_AbstractIterable_toStream($this) {
        return (sc_IterableFactory$ToFactory__init_(sci_Stream$_MODULE$)).$fromSpecific($this);
    }
    function sc_AbstractIterable_toArray($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    }
    function sc_AbstractIterable_reversed($this) {
        var var$1, var$2;
        var$1 = sci_Nil$_MODULE$;
        var$2 = $this.$iterator0();
        while (var$2.$hasNext()) {
            var$1 = sci_List_$colon$colon(var$1, var$2.$next());
        }
        return var$1;
    }
    function sc_AbstractIterable_knownSize($this) {
        return (-1);
    }
    function sc_AbstractIterable_empty0($this) {
        return $this.$empty1();
    }
    function sc_AbstractIterable_fromSpecific0($this, $coll) {
        return $this.$fromSpecific0($coll);
    }
    function sc_AbstractIterable_coll0($this) {
        return $this;
    }
    var s_PartialFunction = $rt_classWithoutFields(0);
    function s_PartialFunction_lift$($$this) {
        var var$2;
        var$2 = new s_PartialFunction$Lifted;
        var$2.$pf = $$this;
        return var$2;
    }
    var sc_SeqOps = $rt_classWithoutFields(0);
    function sc_SeqOps_distinct$($$this) {
        return $$this.$distinctBy(new sc_SeqOps$distinct$lambda$_30_0);
    }
    function sc_SeqOps_distinctBy$($$this, $f) {
        var var$3;
        var$3 = new sc_View$DistinctBy;
        var$3.$underlying4 = $$this;
        var$3.$f1 = $f;
        return $$this.$fromSpecific(var$3);
    }
    function sc_SeqOps_sorted$($$this, $ord) {
        var var$3, var$4, var$5, var$6, var$7;
        a: {
            var$3 = $$this.$length();
            var$4 = $$this.$newSpecificBuilder();
            var$5 = $rt_compare(var$3, 1);
            if (!var$5) {
                $$this = $$this.$head();
                if (var$4 === null)
                    $rt_throw(null);
                var$4.$addOne($$this);
            } else if (var$5 > 0) {
                var$4.$sizeHint(var$3);
                var$6 = $rt_createArray(jl_Object, var$3);
                var$7 = var$6.data;
                sc_IterableOnceOps_copyToArray$($$this, var$6);
                ju_Arrays_sort(var$6, $ord);
                var$5 = 0;
                while (true) {
                    if (var$5 >= var$3)
                        break a;
                    var$4.$addOne(var$7[var$5]);
                    var$5 = var$5 + 1 | 0;
                }
            }
        }
        return var$4.$result0();
    }
    function sc_SeqOps_isEmpty$($$this) {
        return $$this.$lengthCompare(0) ? 0 : 1;
    }
    function sc_SeqOps_sameElements$($$this, $that) {
        var var$3, var$4;
        a: {
            var$3 = $$this.$knownSize();
            if (var$3 != (-1)) {
                var$4 = $that.$knownSize();
                if (var$4 != (-1) && var$3 != var$4) {
                    var$4 = 1;
                    break a;
                }
            }
            var$4 = 0;
        }
        return !var$4 && ($$this.$iterator0()).$sameElements($that) ? 1 : 0;
    }
    function sc_SeqOps_intersect$($$this, $that) {
        var var$3, var$4;
        $that = sc_AbstractSeq_occCounts($$this, $that);
        var$3 = $$this.$iterator0();
        var$4 = new sc_SeqOps$intersect$lambda$_118_0;
        var$4.$_011 = $that;
        return $$this.$fromSpecific(var$3.$filter(var$4));
    }
    var sc_Seq = $rt_classWithoutFields(0);
    function sc_Seq_equals$($$this, $o) {
        var var$3;
        a: {
            if ($$this !== $o) {
                b: {
                    if ($rt_isInstance($o, sc_Seq)) {
                        $o = $o;
                        if ($o.$canEqual($$this)) {
                            var$3 = $$this.$sameElements($o);
                            break b;
                        }
                    }
                    var$3 = 0;
                }
                if (!var$3) {
                    var$3 = 0;
                    break a;
                }
            }
            var$3 = 1;
        }
        return var$3;
    }
    var sc_AbstractSeq = $rt_classWithoutFields(sc_AbstractIterable);
    function sc_AbstractSeq_canEqual($this, $that) {
        return 1;
    }
    function sc_AbstractSeq_equals($this, $o) {
        return sc_Seq_equals$($this, $o);
    }
    function sc_AbstractSeq_hashCode($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        suh_MurmurHash3$_$callClinit();
        var$1 = suh_MurmurHash3$_MODULE$;
        if ($rt_isInstance($this, sc_IndexedSeq))
            a: {
                var$2 = $this;
                var$3 = suh_MurmurHash3$_seqSeed(var$1);
                var$4 = var$2.$length();
                switch (var$4) {
                    case 0:
                        break;
                    case 1:
                        var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, suh_MurmurHash3_mix(var$1, var$3, sr_Statics_anyHash(var$2.$apply1(0))) ^ 1);
                        break a;
                    default:
                        var$5 = sr_Statics_anyHash(var$2.$apply1(0));
                        var$3 = suh_MurmurHash3_mix(var$1, var$3, var$5);
                        var$6 = sr_Statics_anyHash(var$2.$apply1(1));
                        var$5 = var$6 - var$5 | 0;
                        var$7 = 2;
                        var$8 = var$3;
                        while (var$7 < var$4) {
                            var$8 = suh_MurmurHash3_mix(var$1, var$8, var$6);
                            var$9 = sr_Statics_anyHash(var$2.$apply1(var$7));
                            if (var$5 != (var$9 - var$6 | 0)) {
                                var$3 = suh_MurmurHash3_mix(var$1, var$8, var$9);
                                var$5 = var$7 + 1 | 0;
                                while (var$5 < var$4) {
                                    var$3 = suh_MurmurHash3_mix(var$1, var$3, sr_Statics_anyHash(var$2.$apply1(var$5)));
                                    var$5 = var$5 + 1 | 0;
                                }
                                var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, var$3 ^ var$4);
                                break a;
                            }
                            var$7 = var$7 + 1 | 0;
                            var$6 = var$9;
                        }
                        var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, suh_MurmurHash3_mix(var$1, suh_MurmurHash3_mix(var$1, var$3, var$5), var$6));
                        break a;
                }
                var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, var$3 ^ 0);
            }
        else if (!($this instanceof sci_List))
            b: {
                var$3 = suh_MurmurHash3$_seqSeed(var$1);
                var$2 = $this.$iterator0();
                if (!var$2.$hasNext())
                    var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, var$3 ^ 0);
                else {
                    var$10 = var$2.$next();
                    if (!var$2.$hasNext())
                        var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, suh_MurmurHash3_mix(var$1, var$3, sr_Statics_anyHash(var$10)) ^ 1);
                    else {
                        var$11 = var$2.$next();
                        var$4 = sr_Statics_anyHash(var$10);
                        var$3 = suh_MurmurHash3_mix(var$1, var$3, var$4);
                        var$5 = sr_Statics_anyHash(var$11);
                        var$4 = var$5 - var$4 | 0;
                        var$6 = 2;
                        var$7 = var$3;
                        while (var$2.$hasNext()) {
                            var$7 = suh_MurmurHash3_mix(var$1, var$7, var$5);
                            var$8 = sr_Statics_anyHash(var$2.$next());
                            if (var$4 != (var$8 - var$5 | 0)) {
                                var$3 = suh_MurmurHash3_mix(var$1, var$7, var$8);
                                var$4 = var$6 + 1 | 0;
                                while (var$2.$hasNext()) {
                                    var$3 = suh_MurmurHash3_mix(var$1, var$3, sr_Statics_anyHash(var$2.$next()));
                                    var$4 = var$4 + 1 | 0;
                                }
                                var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, var$3 ^ var$4);
                                break b;
                            }
                            var$6 = var$6 + 1 | 0;
                            var$5 = var$8;
                        }
                        var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, suh_MurmurHash3_mix(var$1, suh_MurmurHash3_mix(var$1, var$3, var$4), var$5));
                    }
                }
            }
        else {
            var$2 = $this;
            var$3 = suh_MurmurHash3$_seqSeed(var$1);
            var$4 = 0;
            var$6 = 0;
            var$7 = 0;
            var$8 = 0;
            var$9 = 0;
            var$12 = var$3;
            while (!sci_List_isEmpty(var$2)) {
                c: {
                    var$10 = var$2.$head();
                    var$2 = var$2.$tail();
                    var$5 = sr_Statics_anyHash(var$10);
                    var$12 = suh_MurmurHash3_mix(var$1, var$12, var$5);
                    switch (var$6) {
                        case 0:
                            var$6 = 1;
                            var$9 = var$5;
                            break c;
                        case 1:
                            var$7 = var$5 - var$8 | 0;
                            var$6 = 2;
                            break c;
                        case 2:
                            if (var$7 == (var$5 - var$8 | 0))
                                break c;
                            var$6 = 3;
                            break c;
                        default:
                    }
                }
                var$4 = var$4 + 1 | 0;
                var$8 = var$5;
            }
            var$3 = var$6 != 2 ? suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, var$12 ^ var$4) : suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, suh_MurmurHash3_mix(var$1, suh_MurmurHash3_mix(var$1, suh_MurmurHash3_mix(var$1, var$3, var$9), var$7), var$8));
        }
        return var$3;
    }
    function sc_AbstractSeq_toString($this) {
        return sc_Iterable_toString$($this);
    }
    function sc_AbstractSeq_scala$collection$SeqOps$$super$concat($this, $suffix) {
        return sc_IterableOps_concat$($this, $suffix);
    }
    function sc_AbstractSeq_scala$collection$SeqOps$$super$sizeCompare($this, $otherSize) {
        return sc_IterableOps_sizeCompare$($this, $otherSize);
    }
    function sc_AbstractSeq_view($this) {
        return sc_SeqView$Id__init_($this);
    }
    function sc_AbstractSeq_$plus$colon($this, $elem) {
        return $this.$prepended($elem);
    }
    function sc_AbstractSeq_appended($this, $elem) {
        return ($this.$iterableFactory()).$from0(sc_View$Appended__init_($this, $elem));
    }
    function sc_AbstractSeq_$colon$plus($this, $elem) {
        return $this.$appended($elem);
    }
    function sc_AbstractSeq_appendedAll($this, $suffix) {
        return $this.$scala$collection$SeqOps$$super$concat($suffix);
    }
    function sc_AbstractSeq_concat($this, $suffix) {
        return $this.$appendedAll($suffix);
    }
    function sc_AbstractSeq_size($this) {
        return $this.$length();
    }
    function sc_AbstractSeq_distinct($this) {
        return sc_SeqOps_distinct$($this);
    }
    function sc_AbstractSeq_distinctBy($this, $f) {
        return sc_SeqOps_distinctBy$($this, $f);
    }
    function sc_AbstractSeq_reverseIterator($this) {
        return ($this.$reversed()).$iterator0();
    }
    function sc_AbstractSeq_indexWhere($this, $p, $from) {
        return ($this.$iterator0()).$indexWhere($p, $from);
    }
    function sc_AbstractSeq_indexOf($this, $elem, $from) {
        var var$3;
        var$3 = new sc_SeqOps$indexOf$lambda$_58_0;
        var$3.$_012 = $elem;
        return $this.$indexWhere(var$3, $from);
    }
    function sc_AbstractSeq_indexOf0($this, $elem) {
        return sc_AbstractSeq_indexOf($this, $elem, 0);
    }
    function sc_AbstractSeq_contains($this, $elem) {
        var var$2;
        var$2 = new sc_SeqOps$contains$lambda$_84_0;
        var$2.$_013 = $elem;
        return $this.$exists(var$2);
    }
    function sc_AbstractSeq_sorted($this, $ord) {
        return sc_SeqOps_sorted$($this, $ord);
    }
    function sc_AbstractSeq_sizeCompare($this, $otherSize) {
        return $this.$lengthCompare($otherSize);
    }
    function sc_AbstractSeq_lengthCompare($this, $len) {
        return $this.$scala$collection$SeqOps$$super$sizeCompare($len);
    }
    function sc_AbstractSeq_isEmpty($this) {
        return sc_SeqOps_isEmpty$($this);
    }
    function sc_AbstractSeq_sameElements($this, $that) {
        return sc_SeqOps_sameElements$($this, $that);
    }
    function sc_AbstractSeq_intersect($this, $that) {
        return sc_SeqOps_intersect$($this, $that);
    }
    function sc_AbstractSeq_occCounts($this, $sq) {
        var var$2, var$3;
        var$2 = scm_HashMap__init_();
        var$3 = new sc_SeqOps$occCounts$lambda$_124_0;
        var$3.$_014 = var$2;
        $sq.$foreach(var$3);
        return var$2;
    }
    var sci_Iterable = $rt_classWithoutFields(0);
    var sci_SeqOps = $rt_classWithoutFields(0);
    var sci_Seq = $rt_classWithoutFields(0);
    var sci_AbstractSeq = $rt_classWithoutFields(sc_AbstractSeq);
    function sci_AbstractSeq_toSeq($this) {
        return $this;
    }
    var sc_LinearSeqOps = $rt_classWithoutFields(0);
    function sc_LinearSeqOps_headOption$($$this) {
        return $$this.$isEmpty() ? s_None$_MODULE$ : s_Some__init_($$this.$head());
    }
    function sc_LinearSeqOps_length$($$this) {
        var var$2;
        $$this = $$this;
        var$2 = 0;
        while (sc_IterableOnceOps_nonEmpty$($$this)) {
            var$2 = var$2 + 1 | 0;
            $$this = $$this.$tail();
        }
        return var$2;
    }
    function sc_LinearSeqOps_last$($$this) {
        var var$2, var$3;
        if ($$this.$isEmpty()) {
            var$2 = new ju_NoSuchElementException;
            jl_Throwable__init_(var$2, $rt_s(31));
            $rt_throw(var$2);
        }
        var$2 = $$this;
        $$this = $$this.$tail();
        while (sc_IterableOnceOps_nonEmpty$($$this)) {
            var$3 = $$this.$tail();
            var$2 = $$this;
            $$this = var$3;
        }
        return var$2.$head();
    }
    function sc_LinearSeqOps_lengthCompare$($$this, $len) {
        var var$3;
        if ($len < 0)
            $len = 1;
        else {
            var$3 = 0;
            $$this = $$this;
            a: {
                while (true) {
                    if (var$3 == $len) {
                        if (!$$this.$isEmpty()) {
                            $len = 1;
                            break a;
                        }
                        $len = 0;
                        break a;
                    }
                    if ($$this.$isEmpty())
                        break;
                    var$3 = var$3 + 1 | 0;
                    $$this = $$this.$tail();
                }
                $len = (-1);
            }
        }
        return $len;
    }
    function sc_LinearSeqOps_apply$($$this, $n) {
        if ($n < 0) {
            $$this = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_($$this, jl_Integer_toString0($n));
            $rt_throw($$this);
        }
        $$this = $$this.$drop($n);
        if (!$$this.$isEmpty())
            return $$this.$head();
        $$this = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_($$this, jl_Integer_toString0($n));
        $rt_throw($$this);
    }
    function sc_LinearSeqOps_forall$($$this, $p) {
        var var$3;
        $$this = $$this;
        a: {
            while (!$$this.$isEmpty()) {
                if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($$this.$head()))) {
                    var$3 = 0;
                    break a;
                }
                $$this = $$this.$tail();
            }
            var$3 = 1;
        }
        return var$3;
    }
    function sc_LinearSeqOps_exists$($$this, $p) {
        var var$3;
        $$this = $$this;
        a: {
            while (!$$this.$isEmpty()) {
                if (sr_BoxesRunTime_unboxToBoolean($p.$apply($$this.$head()))) {
                    var$3 = 1;
                    break a;
                }
                $$this = $$this.$tail();
            }
            var$3 = 0;
        }
        return var$3;
    }
    function sc_LinearSeqOps_contains$($$this, $elem) {
        var var$3;
        $$this = $$this;
        a: {
            while (!$$this.$isEmpty()) {
                if (sr_BoxesRunTime_equals($$this.$head(), $elem)) {
                    var$3 = 1;
                    break a;
                }
                $$this = $$this.$tail();
            }
            var$3 = 0;
        }
        return var$3;
    }
    function sc_LinearSeqOps_foldLeft$($$this, $z, $op) {
        $$this = $$this;
        while (!$$this.$isEmpty()) {
            $z = $op.$apply0($z, $$this.$head());
            $$this = $$this.$tail();
        }
        return $z;
    }
    function sc_LinearSeqOps_sameElements$($$this, $that) {
        var var$3;
        if (!$rt_isInstance($that, sc_LinearSeq))
            var$3 = $$this.$scala$collection$LinearSeqOps$$super$sameElements($that);
        else {
            $that = $that;
            $$this = $$this;
            a: {
                b: {
                    c: {
                        while (true) {
                            if ($$this === $that)
                                break c;
                            if (!sc_IterableOnceOps_nonEmpty$($$this))
                                break;
                            if (!sc_IterableOnceOps_nonEmpty$($that))
                                break;
                            if (!sr_BoxesRunTime_equals($$this.$head(), $that.$head()))
                                break;
                            $$this = $$this.$tail();
                            $that = $that.$tail();
                        }
                        if (!$$this.$isEmpty())
                            break b;
                        if (!$that.$isEmpty())
                            break b;
                    }
                    var$3 = 1;
                    break a;
                }
                var$3 = 0;
            }
        }
        return var$3;
    }
    function sc_LinearSeqOps_indexWhere$($$this, $p, $from) {
        var var$4;
        var$4 = jl_Math_max($from, 0);
        $$this = $$this.$drop($from);
        a: {
            while (true) {
                if (!sc_IterableOnceOps_nonEmpty$($$this)) {
                    var$4 = (-1);
                    break a;
                }
                if (sr_BoxesRunTime_unboxToBoolean(sc_SeqOps$indexOf$lambda$_58_0_apply($p, $$this.$head())))
                    break;
                var$4 = var$4 + 1 | 0;
                $$this = $$this.$tail();
            }
        }
        return var$4;
    }
    var sc_LinearSeq = $rt_classWithoutFields(0);
    var sci_LinearSeqOps = $rt_classWithoutFields(0);
    var sci_LinearSeq = $rt_classWithoutFields(0);
    var sc_StrictOptimizedIterableOps = $rt_classWithoutFields(0);
    function sc_StrictOptimizedIterableOps_partition$($$this, $p) {
        var var$3, var$4, var$5;
        var$3 = sc_AbstractIterable_newSpecificBuilder($$this);
        var$4 = sc_AbstractIterable_newSpecificBuilder($$this);
        $$this = $$this.$iterator0();
        var$5 = new sc_StrictOptimizedIterableOps$partition$lambda$_1_0;
        var$5.$_015 = $p;
        var$5.$_13 = var$3;
        var$5.$_23 = var$4;
        $$this.$foreach(var$5);
        return s_Tuple2__init_(var$3.$result0(), var$4.$result0());
    }
    function sc_StrictOptimizedIterableOps_span$($$this, $p) {
        var var$3, var$4, var$5, var$6;
        var$3 = $$this.$newSpecificBuilder();
        var$4 = $$this.$newSpecificBuilder();
        $$this = $$this.$iterator0();
        var$5 = 1;
        a: {
            while (true) {
                if (!$$this.$hasNext())
                    break a;
                if (!var$5)
                    break a;
                var$6 = $$this.$next();
                if (sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply($p, var$6))) {
                    if (var$3 === null)
                        $rt_throw(null);
                    var$3.$addOne(var$6);
                    continue;
                }
                if (var$4 === null)
                    break;
                var$4.$addOne(var$6);
                var$5 = 0;
            }
            $rt_throw(null);
        }
        while (true) {
            if (!$$this.$hasNext())
                return s_Tuple2__init_(var$3.$result0(), var$4.$result0());
            $p = $$this.$next();
            if (var$4 === null)
                break;
            var$4.$addOne($p);
        }
        $rt_throw(null);
    }
    function sc_StrictOptimizedIterableOps_map$($$this, $f) {
        var var$3, var$4;
        var$3 = ($$this.$iterableFactory()).$newBuilder();
        $$this = $$this.$iterator0();
        while ($$this.$hasNext()) {
            var$4 = $f.$apply($$this.$next());
            if (var$3 === null)
                $rt_throw(null);
            var$3.$addOne(var$4);
        }
        return var$3.$result0();
    }
    function sc_StrictOptimizedIterableOps_flatMap$($$this, $f) {
        var var$3, var$4;
        var$3 = ($$this.$iterableFactory()).$newBuilder();
        $$this = $$this.$iterator0();
        while ($$this.$hasNext()) {
            var$4 = $f.$apply($$this.$next());
            if (var$3 === null)
                $rt_throw(null);
            var$3.$addAll0(var$4);
        }
        return var$3.$result0();
    }
    function sc_StrictOptimizedIterableOps_collect$($$this, $pf) {
        var var$3, var$4, var$5, var$6;
        var$3 = ($$this.$iterableFactory()).$newBuilder();
        var$4 = sr_Statics_pfMarker;
        $$this = $$this.$iterator0();
        while ($$this.$hasNext()) {
            var$5 = $$this.$next();
            var$6 = new sc_StrictOptimizedIterableOps$collect$lambda$_19_0;
            var$6.$_016 = var$4;
            var$5 = $pf.$applyOrElse(var$5, var$6);
            if (var$4 === var$5)
                continue;
            if (var$3 === null)
                $rt_throw(null);
            var$3.$addOne(var$5);
        }
        return var$3.$result0();
    }
    function sc_StrictOptimizedIterableOps_flatten$($$this, $toIterableOnce) {
        var var$3;
        $toIterableOnce = ($$this.$iterableFactory()).$newBuilder();
        $$this = $$this.$iterator0();
        while ($$this.$hasNext()) {
            var$3 = $$this.$next();
            if ($toIterableOnce === null)
                $rt_throw(null);
            $toIterableOnce.$addAll0(var$3);
        }
        return $toIterableOnce.$result0();
    }
    function sc_StrictOptimizedIterableOps_zip$($$this, $that) {
        var var$3, var$4;
        var$3 = ($$this.$iterableFactory()).$newBuilder();
        $$this = $$this.$iterator0();
        var$4 = $that.$iterator0();
        while ($$this.$hasNext() && var$4.$hasNext()) {
            $that = s_Tuple2__init_($$this.$next(), var$4.$next());
            if (var$3 === null)
                $rt_throw(null);
            var$3.$addOne($that);
        }
        return var$3.$result0();
    }
    function sc_StrictOptimizedIterableOps_zipWithIndex$($$this) {
        var var$2, var$3, var$4;
        var$2 = ($$this.$iterableFactory()).$newBuilder();
        var$3 = 0;
        var$4 = $$this.$iterator0();
        while (var$4.$hasNext()) {
            $$this = s_Tuple2__init_(var$4.$next(), jl_Integer_valueOf(var$3));
            if (var$2 === null)
                $rt_throw(null);
            var$2.$addOne($$this);
            var$3 = var$3 + 1 | 0;
        }
        return var$2.$result0();
    }
    function sc_StrictOptimizedIterableOps_filter$($$this, $pred) {
        return $$this.$filterImpl($pred, 0);
    }
    function sc_StrictOptimizedIterableOps_filterNot$($$this, $pred) {
        return $$this.$filterImpl($pred, 1);
    }
    function sc_StrictOptimizedIterableOps_filterImpl$($$this, $pred, $isFlipped) {
        var var$4, var$5;
        var$4 = $$this.$newSpecificBuilder();
        $$this = $$this.$iterator0();
        while ($$this.$hasNext()) {
            var$5 = $$this.$next();
            if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(var$5)) == $isFlipped)
                continue;
            if (var$4 === null)
                $rt_throw(null);
            var$4.$addOne(var$5);
        }
        return var$4.$result0();
    }
    function sc_StrictOptimizedIterableOps_dropRight$($$this, $n) {
        var var$3, var$4, var$5;
        var$3 = sc_AbstractIterable_newSpecificBuilder($$this);
        if ($n >= 0)
            var$3.$sizeHint0($$this,  -$n | 0);
        var$4 = sc_Iterator_drop$($$this.$iterator0(), $n);
        $$this = $$this.$iterator0();
        while (var$4.$hasNext()) {
            var$5 = $$this.$next();
            if (var$3 === null)
                $rt_throw(null);
            var$3.$addOne(var$5);
            var$4.$next();
        }
        return var$3.$result0();
    }
    function sc_StrictOptimizedIterableOps_$anonfun$partition$1($p$1, $l$1, $r$1, $x) {
        if (sr_BoxesRunTime_unboxToBoolean($p$1.$apply($x)))
            $r$1 = $l$1;
        if ($r$1 !== null)
            return $r$1.$addOne($x);
        $rt_throw(null);
    }
    var sc_StrictOptimizedSeqOps = $rt_classWithoutFields(0);
    function sc_StrictOptimizedSeqOps_distinctBy$($$this, $f) {
        var var$3, var$4, var$5;
        var$3 = $$this.$newSpecificBuilder();
        var$4 = scm_HashSet__init_();
        $$this = $$this.$iterator0();
        while ($$this.$hasNext()) {
            var$5 = $$this.$next();
            if (!scm_HashSet_add(var$4, sc_SeqOps$distinct$lambda$_30_0_apply($f, var$5)))
                continue;
            if (var$3 === null)
                $rt_throw(null);
            var$3.$addOne(var$5);
        }
        return var$3.$result0();
    }
    function sc_StrictOptimizedSeqOps_prepended$($$this, $elem) {
        var var$3;
        var$3 = ($$this.$iterableFactory()).$newBuilder();
        if ($$this.$knownSize() >= 0)
            var$3.$sizeHint($$this.$length() + 1 | 0);
        if (var$3 === null)
            $rt_throw(null);
        var$3.$addOne($elem);
        var$3.$addAll0($$this);
        return var$3.$result0();
    }
    function sc_StrictOptimizedSeqOps_appended$($$this, $elem) {
        var var$3;
        var$3 = ($$this.$iterableFactory()).$newBuilder();
        if ($$this.$knownSize() >= 0)
            var$3.$sizeHint($$this.$length() + 1 | 0);
        if (var$3 === null)
            $rt_throw(null);
        var$3.$addAll0($$this);
        var$3.$addOne($elem);
        return var$3.$result0();
    }
    function sc_StrictOptimizedSeqOps_appendedAll$($$this, $suffix) {
        var var$3;
        var$3 = ($$this.$iterableFactory()).$newBuilder();
        if (var$3 === null)
            $rt_throw(null);
        var$3.$addAll0($$this);
        var$3.$addAll0($suffix);
        return var$3.$result0();
    }
    function sc_StrictOptimizedSeqOps_intersect$($$this, $that) {
        var var$3, var$4;
        if (!$$this.$isEmpty() && !$that.$isEmpty()) {
            $that = sc_AbstractSeq_occCounts($$this, $that);
            var$3 = $$this.$newSpecificBuilder();
            var$4 = new sc_StrictOptimizedSeqOps$intersect$lambda$_15_0;
            var$4.$_017 = $that;
            var$4.$_14 = var$3;
            $$this.$foreach(var$4);
            $$this = var$3.$result0();
        } else
            $$this = $$this.$empty();
        return $$this;
    }
    var sc_StrictOptimizedLinearSeqOps = $rt_classWithoutFields(0);
    var sci_StrictOptimizedSeqOps = $rt_classWithoutFields(0);
    function sci_StrictOptimizedSeqOps_distinctBy$($$this, $f) {
        var var$3, var$4, var$5, var$6, var$7;
        a: {
            if ($$this.$lengthCompare(1) > 0) {
                var$3 = $$this.$newSpecificBuilder();
                var$4 = scm_HashSet__init_();
                var$5 = $$this.$iterator0();
                var$6 = 0;
                while (true) {
                    if (!var$5.$hasNext()) {
                        if (var$6) {
                            $$this = var$3.$result0();
                            break a;
                        }
                        break a;
                    }
                    var$7 = var$5.$next();
                    if (!scm_HashSet_add(var$4, sc_SeqOps$distinct$lambda$_30_0_apply($f, var$7))) {
                        var$6 = 1;
                        continue;
                    }
                    if (var$3 === null)
                        break;
                    var$3.$addOne(var$7);
                }
                $rt_throw(null);
            }
        }
        return $$this;
    }
    var scg_DefaultSerializable = $rt_classWithoutFields(0);
    var sci_List = $rt_classWithoutFields(sci_AbstractSeq);
    function sci_List_scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted($this, $ord) {
        return sc_SeqOps_sorted$($this, $ord);
    }
    function sci_List_distinctBy($this, $f) {
        return sci_StrictOptimizedSeqOps_distinctBy$($this, $f);
    }
    function sci_List_sorted($this, $ord) {
        return $this.$scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted($ord);
    }
    function sci_List_iterator($this) {
        var var$1;
        var$1 = new sc_StrictOptimizedLinearSeqOps$$anon$1;
        var$1.$current = $this;
        return var$1;
    }
    function sci_List_drop($this, $n) {
        var var$2;
        var$2 = $this;
        while ($n > 0 && !var$2.$isEmpty()) {
            $n = $n - 1 | 0;
            var$2 = var$2.$tail();
        }
        return var$2;
    }
    function sci_List_dropWhile($this, $p) {
        var var$2;
        var$2 = $this;
        while (sc_IterableOnceOps_nonEmpty$(var$2) && sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply($p, var$2.$head()))) {
            var$2 = var$2.$tail();
        }
        return var$2;
    }
    function sci_List_appended($this, $elem) {
        return sc_StrictOptimizedSeqOps_appended$($this, $elem);
    }
    function sci_List_intersect($this, $that) {
        return sc_StrictOptimizedSeqOps_intersect$($this, $that);
    }
    function sci_List_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_List_zip($this, $that) {
        return sc_StrictOptimizedIterableOps_zip$($this, $that);
    }
    function sci_List_zipWithIndex($this) {
        return sc_StrictOptimizedIterableOps_zipWithIndex$($this);
    }
    function sci_List_dropRight($this, $n) {
        return sc_StrictOptimizedIterableOps_dropRight$($this, $n);
    }
    function sci_List_stringPrefix($this) {
        return $rt_s(32);
    }
    function sci_List_scala$collection$LinearSeqOps$$super$sameElements($this, $that) {
        return sc_SeqOps_sameElements$($this, $that);
    }
    function sci_List_apply($this, $n) {
        return sc_LinearSeqOps_apply$($this, $n);
    }
    function sci_List_foldLeft($this, $z, $op) {
        return sc_LinearSeqOps_foldLeft$($this, $z, $op);
    }
    function sci_List_sameElements($this, $that) {
        return sc_LinearSeqOps_sameElements$($this, $that);
    }
    function sci_List_indexWhere($this, $p, $from) {
        return sc_LinearSeqOps_indexWhere$($this, $p, $from);
    }
    function sci_List_iterableFactory($this) {
        sci_List$_$callClinit();
        return sci_List$_MODULE$;
    }
    function sci_List_$colon$colon($this, $elem) {
        return sci_$colon$colon__init_($elem, $this);
    }
    function sci_List_$colon$colon$colon($this, $prefix) {
        var $result, $that, $temp;
        if (sci_List_isEmpty($this))
            return $prefix;
        if (sci_List_isEmpty($prefix))
            return $this;
        $result = sci_$colon$colon__init_($prefix.$head(), $this);
        $that = $prefix.$tail();
        $prefix = $result;
        while (!sci_List_isEmpty($that)) {
            $temp = sci_$colon$colon__init_($that.$head(), $this);
            $prefix.$next0 = $temp;
            $that = $that.$tail();
            $prefix = $temp;
        }
        return $result;
    }
    function sci_List_isEmpty($this) {
        if ($this !== sci_Nil$_MODULE$)
            return 0;
        return 1;
    }
    function sci_List_prepended($this, $elem) {
        return sci_$colon$colon__init_($elem, $this);
    }
    function sci_List_prependedAll($this, $prefix) {
        var $iter, $result, $curr, $curr_0;
        if ($prefix instanceof sci_List)
            return sci_List_$colon$colon$colon($this, $prefix);
        if (!$prefix.$knownSize())
            return $this;
        if ($prefix instanceof scm_ListBuffer) {
            $iter = $prefix;
            if (sci_List_isEmpty($this))
                return scm_ListBuffer_toList($iter);
        }
        $iter = $prefix.$iterator0();
        if (!$iter.$hasNext())
            return $this;
        $result = sci_$colon$colon__init_($iter.$next(), $this);
        $curr = $result;
        while ($iter.$hasNext()) {
            $curr_0 = sci_$colon$colon__init_($iter.$next(), $this);
            $curr.$next0 = $curr_0;
            $curr = $curr_0;
        }
        return $result;
    }
    function sci_List_appendedAll($this, $suffix) {
        if (!($suffix instanceof sci_List))
            return sc_StrictOptimizedSeqOps_appendedAll$($this, $suffix);
        return sci_List_$colon$colon$colon($suffix, $this);
    }
    function sci_List_map($this, $f) {
        var $h, $rest, var$4, $nx;
        $h = sci_Nil$_MODULE$;
        if ($this === $h)
            return $h;
        $h = sci_$colon$colon__init_($f.$apply($this.$head()), sci_Nil$_MODULE$);
        $rest = $this.$tail();
        var$4 = $h;
        while ($rest !== sci_Nil$_MODULE$) {
            $nx = sci_$colon$colon__init_($f.$apply($rest.$head()), sci_Nil$_MODULE$);
            var$4.$next0 = $nx;
            $rest = $rest.$tail();
            var$4 = $nx;
        }
        return $h;
    }
    function sci_List_collect($this, $pf) {
        var var$2, $h, $t, var$5, $nx;
        var$2 = sci_Nil$_MODULE$;
        if ($this === var$2)
            return var$2;
        $h = null;
        while (true) {
            if ($h !== null) {
                $t = $h;
                while ($this !== sci_Nil$_MODULE$) {
                    var$5 = $this.$head();
                    sci_List$_$callClinit();
                    var$5 = $pf.$applyOrElse(var$5, sci_List$_partialNotApplied(sci_List$_MODULE$));
                    if (var$5 !== sci_List$_partialNotApplied(sci_List$_MODULE$)) {
                        $nx = sci_$colon$colon__init_(var$5, sci_Nil$_MODULE$);
                        $t.$next0 = $nx;
                        $t = $nx;
                    }
                    $this = $this.$tail();
                }
                return $h;
            }
            var$2 = $this.$head();
            sci_List$_$callClinit();
            var$2 = $pf.$applyOrElse(var$2, sci_List$_partialNotApplied(sci_List$_MODULE$));
            if (var$2 !== sci_List$_partialNotApplied(sci_List$_MODULE$))
                $h = sci_$colon$colon__init_(var$2, sci_Nil$_MODULE$);
            $this = $this.$tail();
            var$2 = sci_Nil$_MODULE$;
            if ($this === var$2)
                break;
        }
        if ($h !== null)
            return $h;
        return var$2;
    }
    function sci_List_flatMap($this, $f) {
        var $h, $t, var$4, $it, $nx;
        $h = null;
        $t = null;
        while (true) {
            var$4 = sci_Nil$_MODULE$;
            if ($this === var$4)
                break;
            $it = ($f.$apply($this.$head())).$iterator0();
            while ($it.$hasNext()) {
                $nx = sci_$colon$colon__init_($it.$next(), sci_Nil$_MODULE$);
                if ($t === null)
                    $h = $nx;
                else
                    $t.$next0 = $nx;
                $t = $nx;
            }
            $this = $this.$tail();
        }
        if ($h !== null)
            return $h;
        return var$4;
    }
    function sci_List_takeWhile($these, $p) {
        var $b;
        $b = scm_ListBuffer__init_();
        while (!sci_List_isEmpty($these) && sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply($p, $these.$head()))) {
            scm_ListBuffer_addOne($b, $these.$head());
            $these = $these.$tail();
        }
        return scm_ListBuffer_toList($b);
    }
    function sci_List_span($these, $p) {
        var $b;
        $b = scm_ListBuffer__init_();
        while (!sci_List_isEmpty($these) && sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply($p, $these.$head()))) {
            scm_ListBuffer_addOne($b, $these.$head());
            $these = $these.$tail();
        }
        return s_Tuple2__init_(scm_ListBuffer_toList($b), $these);
    }
    function sci_List_foreach($these, $f) {
        while (!sci_List_isEmpty($these)) {
            $f.$apply($these.$head());
            $these = $these.$tail();
        }
    }
    function sci_List_reverse($these) {
        var $result;
        $result = sci_Nil$_MODULE$;
        while (!sci_List_isEmpty($these)) {
            $result = sci_List_$colon$colon($result, $these.$head());
            $these = $these.$tail();
        }
        return $result;
    }
    function sci_List_length($this) {
        var $len;
        $len = 0;
        while (!sci_List_isEmpty($this)) {
            $len = $len + 1 | 0;
            $this = $this.$tail();
        }
        return $len;
    }
    function sci_List_lengthCompare($this, $len) {
        var var$2;
        if ($len < 0)
            return 1;
        var$2 = 0;
        a: {
            while (true) {
                if (var$2 == $len) {
                    if (!sci_List_isEmpty($this)) {
                        $len = 1;
                        break a;
                    }
                    $len = 0;
                    break a;
                }
                if (sci_List_isEmpty($this))
                    break;
                var$2 = var$2 + 1 | 0;
                $this = $this.$tail();
            }
            $len = (-1);
        }
        return $len;
    }
    function sci_List_forall($these, $p) {
        while (!sci_List_isEmpty($these)) {
            if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($these.$head())))
                return 0;
            $these = $these.$tail();
        }
        return 1;
    }
    function sci_List_exists($these, $p) {
        while (!sci_List_isEmpty($these)) {
            if (sr_BoxesRunTime_unboxToBoolean($p.$apply($these.$head())))
                return 1;
            $these = $these.$tail();
        }
        return 0;
    }
    function sci_List_contains($these, $elem) {
        while (!sci_List_isEmpty($these)) {
            if (sr_BoxesRunTime_equals($these.$head(), $elem))
                return 1;
            $these = $these.$tail();
        }
        return 0;
    }
    function sci_List_find($these, $p) {
        while (!sci_List_isEmpty($these)) {
            if (sr_BoxesRunTime_unboxToBoolean($p.$apply($these.$head())))
                return s_Some__init_($these.$head());
            $these = $these.$tail();
        }
        return s_None$_MODULE$;
    }
    function sci_List_last($this) {
        var $scout, $scout_0;
        if (sci_List_isEmpty($this)) {
            $scout = new ju_NoSuchElementException;
            jl_Throwable__init_($scout, $rt_s(33));
            $rt_throw($scout);
        }
        $scout_0 = $this.$tail();
        while (!sci_List_isEmpty($scout_0)) {
            $scout = $scout_0.$tail();
            $this = $scout_0;
            $scout_0 = $scout;
        }
        return $this.$head();
    }
    function sci_List_className($this) {
        return $rt_s(34);
    }
    function sci_List_filter($filterCommon_noneIn$1_l, $p) {
        var $filterCommon_noneIn$1_h, $filterCommon_noneIn$1_l_0, $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead, $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess, $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast, $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0, $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy, $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem;
        a: {
            while (!sci_List_isEmpty($filterCommon_noneIn$1_l)) {
                $filterCommon_noneIn$1_h = $filterCommon_noneIn$1_l.$head();
                $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l.$tail();
                if (sr_BoxesRunTime_unboxToBoolean($p.$apply($filterCommon_noneIn$1_h))) {
                    b: {
                        while (!sci_List_isEmpty($filterCommon_noneIn$1_l_0)) {
                            if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($filterCommon_noneIn$1_l_0.$head()))) {
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead = sci_$colon$colon__init_($filterCommon_noneIn$1_l.$head(), sci_Nil$_MODULE$);
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess = $filterCommon_noneIn$1_l.$tail();
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast = $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead;
                                while ($filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess !== $filterCommon_noneIn$1_l_0) {
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0 = sci_$colon$colon__init_($filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess.$head(), sci_Nil$_MODULE$);
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast.$next0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0;
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess = $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess.$tail();
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast = $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0;
                                }
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy = $filterCommon_noneIn$1_l_0.$tail();
                                $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy;
                                while (!sci_List_isEmpty($filterCommon_noneIn$1_l_0)) {
                                    if (sr_BoxesRunTime_unboxToBoolean($p.$apply($filterCommon_noneIn$1_l_0.$head()))) {
                                        $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l_0.$tail();
                                        continue;
                                    }
                                    while ($filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy !== $filterCommon_noneIn$1_l_0) {
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem = sci_$colon$colon__init_($filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy.$head(), sci_Nil$_MODULE$);
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast.$next0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem;
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy = $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy.$tail();
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast = $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem;
                                    }
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy = $filterCommon_noneIn$1_l_0.$tail();
                                    $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l_0.$tail();
                                }
                                if (!sci_List_isEmpty($filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy))
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast.$next0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy;
                                $filterCommon_noneIn$1_l = $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead;
                                break b;
                            }
                            $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l_0.$tail();
                        }
                    }
                    break a;
                }
                $filterCommon_noneIn$1_l = $filterCommon_noneIn$1_l_0;
            }
            $filterCommon_noneIn$1_l = sci_Nil$_MODULE$;
        }
        return $filterCommon_noneIn$1_l;
    }
    function sci_List_filterNot($filterCommon_noneIn$1_l, $p) {
        var $filterCommon_noneIn$1_h, $filterCommon_noneIn$1_l_0, $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead, $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess, $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast, $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0, $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy, $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem;
        a: {
            while (!sci_List_isEmpty($filterCommon_noneIn$1_l)) {
                $filterCommon_noneIn$1_h = $filterCommon_noneIn$1_l.$head();
                $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l.$tail();
                if (sr_BoxesRunTime_unboxToBoolean($p.$apply($filterCommon_noneIn$1_h)) != 1) {
                    b: {
                        while (!sci_List_isEmpty($filterCommon_noneIn$1_l_0)) {
                            if (sr_BoxesRunTime_unboxToBoolean($p.$apply($filterCommon_noneIn$1_l_0.$head())) == 1) {
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead = sci_$colon$colon__init_($filterCommon_noneIn$1_l.$head(), sci_Nil$_MODULE$);
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess = $filterCommon_noneIn$1_l.$tail();
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast = $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead;
                                while ($filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess !== $filterCommon_noneIn$1_l_0) {
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0 = sci_$colon$colon__init_($filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess.$head(), sci_Nil$_MODULE$);
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast.$next0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0;
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess = $filterCommon_noneIn$1_allIn$1_partialFill$1_toProcess.$tail();
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast = $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast_0;
                                }
                                $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy = $filterCommon_noneIn$1_l_0.$tail();
                                $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy;
                                while (!sci_List_isEmpty($filterCommon_noneIn$1_l_0)) {
                                    if (sr_BoxesRunTime_unboxToBoolean($p.$apply($filterCommon_noneIn$1_l_0.$head())) != 1) {
                                        $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l_0.$tail();
                                        continue;
                                    }
                                    while ($filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy !== $filterCommon_noneIn$1_l_0) {
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem = sci_$colon$colon__init_($filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy.$head(), sci_Nil$_MODULE$);
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast.$next0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem;
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy = $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy.$tail();
                                        $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast = $filterCommon_noneIn$1_allIn$1_partialFill$1_newElem;
                                    }
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy = $filterCommon_noneIn$1_l_0.$tail();
                                    $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l_0.$tail();
                                }
                                if (!sci_List_isEmpty($filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy))
                                    $filterCommon_noneIn$1_allIn$1_partialFill$1_currentLast.$next0 = $filterCommon_noneIn$1_allIn$1_partialFill$1_nextToCopy;
                                $filterCommon_noneIn$1_l = $filterCommon_noneIn$1_allIn$1_partialFill$1_newHead;
                                break b;
                            }
                            $filterCommon_noneIn$1_l_0 = $filterCommon_noneIn$1_l_0.$tail();
                        }
                    }
                    break a;
                }
                $filterCommon_noneIn$1_l = $filterCommon_noneIn$1_l_0;
            }
            $filterCommon_noneIn$1_l = sci_Nil$_MODULE$;
        }
        return $filterCommon_noneIn$1_l;
    }
    function sci_List_partition($this, $p) {
        var $partition_l, $partition_r, var$4, var$5;
        if (sci_List_isEmpty($this)) {
            sci_List$_$callClinit();
            return sci_List$_scala$collection$immutable$List$$TupleOfNil;
        }
        $partition_l = sc_AbstractIterable_newSpecificBuilder($this);
        $partition_r = sc_AbstractIterable_newSpecificBuilder($this);
        var$4 = $this.$iterator0();
        var$5 = new sci_List$partition$lambda$_92_0;
        var$5.$_018 = $p;
        var$5.$_15 = $partition_l;
        var$5.$_24 = $partition_r;
        sc_IterableOnceOps_foreach$(var$4, var$5);
        $p = new s_Tuple2;
        $partition_l = $partition_l.$result0();
        $partition_r = $partition_r.$result0();
        s_Tuple2__init_0($p, $partition_l, $partition_r);
        $partition_l = $partition_l;
        if (sci_List_equals(sci_Nil$_MODULE$, $partition_l))
            return s_Tuple2__init_(sci_Nil$_MODULE$, $this);
        $partition_l = $partition_r;
        if (!sci_List_equals(sci_Nil$_MODULE$, $partition_l))
            return $p;
        return s_Tuple2__init_($this, sci_Nil$_MODULE$);
    }
    function sci_List_toList($this) {
        return $this;
    }
    function sci_List_equals($this, $o) {
        var var$2, var$3;
        if (!($o instanceof sci_List))
            return sc_Seq_equals$($this, $o);
        $o = $o;
        a: {
            b: {
                c: {
                    while (true) {
                        if ($this === $o)
                            break c;
                        var$2 = sci_List_isEmpty($this);
                        var$3 = sci_List_isEmpty($o);
                        if (var$2)
                            break;
                        if (var$3)
                            break;
                        if (!sr_BoxesRunTime_equals($this.$head(), $o.$head()))
                            break;
                        $this = $this.$tail();
                        $o = $o.$tail();
                    }
                    if (!var$2)
                        break b;
                    if (!var$3)
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    }
    function sci_List_apply0($this, $v1) {
        return sc_LinearSeqOps_apply$($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_List_dropWhile0($this, $p) {
        return sci_List_dropWhile($this, $p);
    }
    function sci_List_drop0($this, $n) {
        return sci_List_drop($this, $n);
    }
    function sci_List_filterNot0($this, $pred) {
        return sci_List_filterNot($this, $pred);
    }
    function sci_List_filter0($this, $pred) {
        return sci_List_filter($this, $pred);
    }
    function sci_List_takeWhile0($this, $p) {
        return sci_List_takeWhile($this, $p);
    }
    function sci_List_flatMap0($this, $f) {
        return sci_List_flatMap($this, $f);
    }
    function sci_List_collect0($this, $pf) {
        return sci_List_collect($this, $pf);
    }
    function sci_List_map0($this, $f) {
        return sci_List_map($this, $f);
    }
    function sci_List_appendedAll0($this, $suffix) {
        return sci_List_appendedAll($this, $suffix);
    }
    function sci_List_prepended0($this, $elem) {
        return sci_List_prepended($this, $elem);
    }
    function sci_List_iterableFactory0($this) {
        return sci_List_iterableFactory($this);
    }
    function sci_$colon$colon() {
        var a = this; sci_List.call(a);
        a.$head0 = null;
        a.$next0 = null;
    }
    function sci_$colon$colon__init_(var_0, var_1) {
        var var_2 = new sci_$colon$colon();
        sci_$colon$colon__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function sci_$colon$colon_next$access$1($this) {
        return $this.$next0;
    }
    function sci_$colon$colon_head($this) {
        return $this.$head0;
    }
    function sci_$colon$colon_productArity($this) {
        return 2;
    }
    function sci_$colon$colon_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$head0;
            case 1:
                return $this.$next0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function sci_$colon$colon_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function sci_$colon$colon_tail($this) {
        return $this.$next0;
    }
    function sci_$colon$colon_headOption($this) {
        return s_Some__init_($this.$head0);
    }
    function sci_$colon$colon__init_0($this, $head, $next) {
        $this.$head0 = $head;
        $this.$next0 = $next;
    }
    var oncias_SemanticFeature = $rt_classWithoutFields(0);
    var oncias_FeatureToString = $rt_classWithoutFields(0);
    var oncias_SemanticFeature$MultipleDatabases$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$MultipleDatabases$_MODULE$ = null;
    function oncias_SemanticFeature$MultipleDatabases$__clinit_() {
        oncias_SemanticFeature$MultipleDatabases$_MODULE$ = new oncias_SemanticFeature$MultipleDatabases$;
    }
    function oncias_SemanticFeature$MultipleDatabases$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$MultipleDatabases$_name($this) {
        return $rt_s(35);
    }
    function oncias_SemanticFeature$MultipleDatabases$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$MultipleDatabases$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$MultipleDatabases$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$MultipleDatabases$_hashCode($this) {
        return 1621666312;
    }
    var oncias_SemanticFeature$MultipleGraphs$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$MultipleGraphs$_MODULE$ = null;
    function oncias_SemanticFeature$MultipleGraphs$__clinit_() {
        oncias_SemanticFeature$MultipleGraphs$_MODULE$ = new oncias_SemanticFeature$MultipleGraphs$;
    }
    function oncias_SemanticFeature$MultipleGraphs$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$MultipleGraphs$_name($this) {
        return $rt_s(36);
    }
    function oncias_SemanticFeature$MultipleGraphs$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$MultipleGraphs$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$MultipleGraphs$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$MultipleGraphs$_hashCode($this) {
        return (-374670539);
    }
    var oncias_SemanticFeature$UseAsSingleGraphSelector$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$ = null;
    function oncias_SemanticFeature$UseAsSingleGraphSelector$__clinit_() {
        oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$ = new oncias_SemanticFeature$UseAsSingleGraphSelector$;
    }
    function oncias_SemanticFeature$UseAsSingleGraphSelector$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$UseAsSingleGraphSelector$_name($this) {
        return $rt_s(37);
    }
    function oncias_SemanticFeature$UseAsSingleGraphSelector$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$UseAsSingleGraphSelector$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$UseAsSingleGraphSelector$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$UseAsSingleGraphSelector$_hashCode($this) {
        return 1993613100;
    }
    var sci_Nil$ = $rt_classWithoutFields(sci_List);
    var sci_Nil$_MODULE$ = null;
    var sci_Nil$_EmptyUnzip = null;
    function sci_Nil$__clinit_() {
        var var$1;
        var$1 = new sci_Nil$;
        sci_Nil$_MODULE$ = var$1;
        sci_Nil$_EmptyUnzip = s_Tuple2__init_(var$1, var$1);
    }
    function sci_Nil$_knownSize($this) {
        return 0;
    }
    function sci_Nil$_iterator($this) {
        return sc_Iterator$_scala$collection$Iterator$$_empty;
    }
    function sci_Nil$_productArity($this) {
        return 0;
    }
    function sci_Nil$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function sci_Nil$_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function sci_Nil$_init($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(38));
        $rt_throw(var$1);
    }
    function sci_Nil$_last($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(39));
        $rt_throw(var$1);
    }
    function sci_Nil$_tail($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(40));
        $rt_throw(var$1);
    }
    function sci_Nil$_headOption($this) {
        return s_None$_MODULE$;
    }
    function sci_Nil$_head($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(41));
        $rt_throw(var$1);
    }
    var sr_Statics = $rt_classWithoutFields();
    var sr_Statics_pfMarker = null;
    function sr_Statics_mix($hash, $data) {
        return (jl_Integer_rotateLeft($hash ^ $rt_imul(jl_Integer_rotateLeft($rt_imul($data, (-862048943)), 15), 461845907), 13) * 5 | 0) + (-430675100) | 0;
    }
    function sr_Statics_finalizeHash($hash, $length) {
        $hash = $hash ^ $length;
        $hash = $rt_imul($hash ^ $hash >>> 16, (-2048144789));
        $hash = $rt_imul($hash ^ $hash >>> 13, (-1028477387));
        return $hash ^ $hash >>> 16;
    }
    function sr_Statics_longHash($lv) {
        var $iv;
        $iv = Long_lo($lv);
        if (Long_eq(Long_fromInt($iv), $lv))
            return $iv;
        return jl_Long_hashCode($lv);
    }
    function sr_Statics_doubleHash($dv) {
        var $iv, $lv, $fv;
        $iv = $dv | 0;
        if ($iv === $dv)
            return $iv;
        $lv = Long_fromNumber($dv);
        if (Long_toNumber($lv) === $dv)
            return jl_Long_hashCode($lv);
        $fv = $dv;
        if ($fv !== $dv)
            return jl_Double_hashCode($dv);
        return jl_Float_hashCode($fv);
    }
    function sr_Statics_floatHash($fv) {
        var $iv, $lv;
        $iv = $fv | 0;
        if ($iv === $fv)
            return $iv;
        $lv = Long_fromNumber($fv);
        if (Long_toNumber($lv) !== $fv)
            return jl_Float_hashCode($fv);
        return jl_Long_hashCode($lv);
    }
    function sr_Statics_anyHash($x) {
        if ($x === null)
            return 0;
        if (!($x instanceof jl_Number))
            return $x.$hashCode0();
        $x = $x;
        return $x instanceof jl_Long ? sr_Statics_longHash($x.$value2) : $x instanceof jl_Double ? sr_Statics_doubleHash($x.$value3) : !($x instanceof jl_Float) ? $x.$hashCode0() : sr_Statics_floatHash($x.$value4);
    }
    function sr_Statics_ioobe($n) {
        var var$2;
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_(var$2, jl_String_valueOf1($n));
        $rt_throw(var$2);
    }
    function sr_Statics__clinit_() {
        sr_Statics_pfMarker = new jl_Object;
    }
    var s_Product2 = $rt_classWithoutFields(0);
    function s_Tuple2() {
        var a = this; jl_Object.call(a);
        a.$_10 = null;
        a.$_20 = null;
    }
    function s_Tuple2__init_(var_0, var_1) {
        var var_2 = new s_Tuple2();
        s_Tuple2__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function s_Tuple2_productArity($this) {
        return 2;
    }
    function s_Tuple2_productElement($this, $n) {
        var var$2, var$3;
        a: {
            switch ($n) {
                case 0:
                    break;
                case 1:
                    var$2 = $this.$_20;
                    break a;
                default:
                    var$3 = new jl_IndexOutOfBoundsException;
                    var$2 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_2(var$2, 32);
                    var$2 = jl_StringBuilder_append0(var$2, $n);
                    jl_AbstractStringBuilder_append1(var$2, $rt_s(42));
                    jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$2));
                    $rt_throw(var$3);
            }
            var$2 = $this.$_10;
        }
        return var$2;
    }
    function s_Tuple2__1($this) {
        return $this.$_10;
    }
    function s_Tuple2__2($this) {
        return $this.$_20;
    }
    function s_Tuple2_toString($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 3);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(24));
        var$1 = jl_StringBuilder_append(var$1, $this.$_16());
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_25());
        jl_AbstractStringBuilder_append1(var$1, $rt_s(25));
        return jl_AbstractStringBuilder_toString(var$1);
    }
    function s_Tuple2_productPrefix($this) {
        return $rt_s(44);
    }
    function s_Tuple2_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function s_Tuple2_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    }
    function s_Tuple2_equals($this, $x$1) {
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof s_Tuple2) ? 0 : 1))
                    break a;
                $x$1 = $x$1;
                if (!sr_BoxesRunTime_equals($this.$_10, $x$1.$_10))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_20, $x$1.$_20))
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function s_Tuple2__1$mcZ$sp($this) {
        return sr_BoxesRunTime_unboxToBoolean($this.$_10);
    }
    function s_Tuple2__1$mcI$sp($this) {
        return sr_BoxesRunTime_unboxToInt($this.$_10);
    }
    function s_Tuple2__2$mcZ$sp($this) {
        return sr_BoxesRunTime_unboxToBoolean($this.$_20);
    }
    function s_Tuple2__2$mcI$sp($this) {
        return sr_BoxesRunTime_unboxToInt($this.$_20);
    }
    function s_Tuple2__init_0($this, $_1, $_2) {
        $this.$_10 = $_1;
        $this.$_20 = $_2;
    }
    var oncifp_BaseState = $rt_classWithoutFields(0);
    function oncifp_InitialState() {
        var a = this; jl_Object.call(a);
        a.$queryText = null;
        a.$startPosition = null;
        a.$plannerName = null;
        a.$anonymousVariableNameGenerator = null;
        a.$maybeProcedureSignatureVersion = null;
        a.$maybeStatement = null;
        a.$maybeSemantics = null;
        a.$maybeExtractedParams = null;
        a.$maybeSemanticTable = null;
        a.$accumulatedConditions = null;
        a.$maybeReturnColumns = null;
        a.$maybeObfuscationMetadata = null;
    }
    function oncifp_InitialState__init_0(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10, var_11) {
        var var_12 = new oncifp_InitialState();
        oncifp_InitialState__init_(var_12, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10, var_11);
        return var_12;
    }
    function oncifp_InitialState_statement($this) {
        var var$1, var$2;
        var$1 = $this.$maybeStatement;
        var$2 = new oncifp_BaseState$statement$lambda$_13_0;
        var$2.$_019 = $this;
        return s_Option_getOrElse(var$1, var$2);
    }
    function oncifp_InitialState_semanticTable($this) {
        var var$1, var$2;
        var$1 = $this.$maybeSemanticTable;
        var$2 = new oncifp_BaseState$semanticTable$lambda$_19_0;
        var$2.$_020 = $this;
        return s_Option_getOrElse(var$1, var$2);
    }
    function oncifp_InitialState_fail($this, $what) {
        var var$2, var$3;
        var$2 = new jl_IllegalStateException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, $what), $rt_s(45));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    function oncifp_InitialState_copy($this, $queryText, $startPosition, $plannerName, $anonymousVariableNameGenerator, $maybeProcedureSignatureVersion, $maybeStatement, $maybeSemantics, $maybeExtractedParams, $maybeSemanticTable, $accumulatedConditions, $maybeReturnColumns, $maybeObfuscationMetadata) {
        return oncifp_InitialState__init_0($queryText, $startPosition, $plannerName, $anonymousVariableNameGenerator, $maybeProcedureSignatureVersion, $maybeStatement, $maybeSemantics, $maybeExtractedParams, $maybeSemanticTable, $accumulatedConditions, $maybeReturnColumns, $maybeObfuscationMetadata);
    }
    function oncifp_InitialState_copy$default$10($this) {
        return $this.$accumulatedConditions;
    }
    function oncifp_InitialState_copy$default$11($this) {
        return $this.$maybeReturnColumns;
    }
    function oncifp_InitialState_copy$default$12($this) {
        return $this.$maybeObfuscationMetadata;
    }
    function oncifp_InitialState_copy$default$5($this) {
        return $this.$maybeProcedureSignatureVersion;
    }
    function oncifp_InitialState_copy$default$6($this) {
        return $this.$maybeStatement;
    }
    function oncifp_InitialState_copy$default$7($this) {
        return $this.$maybeSemantics;
    }
    function oncifp_InitialState_copy$default$8($this) {
        return $this.$maybeExtractedParams;
    }
    function oncifp_InitialState_productPrefix($this) {
        return $rt_s(46);
    }
    function oncifp_InitialState_productArity($this) {
        return 12;
    }
    function oncifp_InitialState_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$queryText;
            case 1:
                return $this.$startPosition;
            case 2:
                return $this.$plannerName;
            case 3:
                return $this.$anonymousVariableNameGenerator;
            case 4:
                return $this.$maybeProcedureSignatureVersion;
            case 5:
                return $this.$maybeStatement;
            case 6:
                return $this.$maybeSemantics;
            case 7:
                return $this.$maybeExtractedParams;
            case 8:
                return $this.$maybeSemanticTable;
            case 9:
                return $this.$accumulatedConditions;
            case 10:
                return $this.$maybeReturnColumns;
            case 11:
                return $this.$maybeObfuscationMetadata;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_InitialState_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_InitialState_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_InitialState_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_InitialState_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncifp_InitialState) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$queryText;
                        var$3 = $x$1.$queryText;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$startPosition;
                        var$3 = $x$1.$startPosition;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$plannerName;
                        var$3 = $x$1.$plannerName;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$anonymousVariableNameGenerator;
                        var$3 = $x$1.$anonymousVariableNameGenerator;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$maybeProcedureSignatureVersion;
                        var$3 = $x$1.$maybeProcedureSignatureVersion;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$maybeStatement;
                        var$3 = $x$1.$maybeStatement;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$maybeSemantics;
                        var$3 = $x$1.$maybeSemantics;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$2 = $this.$maybeExtractedParams;
                        var$3 = $x$1.$maybeExtractedParams;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break j;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    k: {
                        var$2 = $this.$maybeSemanticTable;
                        var$3 = $x$1.$maybeSemanticTable;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break k;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    l: {
                        var$2 = $this.$accumulatedConditions;
                        var$3 = $x$1.$accumulatedConditions;
                        if (var$2 === null) {
                            if (var$3 === null)
                                break l;
                            break b;
                        }
                        if (!sc_Set_equals$(var$2, var$3))
                            break b;
                    }
                    m: {
                        var$2 = $this.$maybeReturnColumns;
                        var$3 = $x$1.$maybeReturnColumns;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break m;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    n: {
                        var$3 = $this.$maybeObfuscationMetadata;
                        $x$1 = $x$1.$maybeObfuscationMetadata;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break n;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncifp_InitialState))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncifp_InitialState_withStatement($this, $s) {
        var var$2;
        var$2 = s_Some__init_($s);
        return oncifp_InitialState_copy($this, $this.$queryText, $this.$startPosition, $this.$plannerName, $this.$anonymousVariableNameGenerator, $this.$maybeProcedureSignatureVersion, var$2, $this.$maybeSemantics, $this.$maybeExtractedParams, $this.$maybeSemanticTable, $this.$accumulatedConditions, $this.$maybeReturnColumns, $this.$maybeObfuscationMetadata);
    }
    function oncifp_InitialState__init_($this, $queryText, $startPosition, $plannerName, $anonymousVariableNameGenerator, $maybeProcedureSignatureVersion, $maybeStatement, $maybeSemantics, $maybeExtractedParams, $maybeSemanticTable, $accumulatedConditions, $maybeReturnColumns, $maybeObfuscationMetadata) {
        $this.$queryText = $queryText;
        $this.$startPosition = $startPosition;
        $this.$plannerName = $plannerName;
        $this.$anonymousVariableNameGenerator = $anonymousVariableNameGenerator;
        $this.$maybeProcedureSignatureVersion = $maybeProcedureSignatureVersion;
        $this.$maybeStatement = $maybeStatement;
        $this.$maybeSemantics = $maybeSemantics;
        $this.$maybeExtractedParams = $maybeExtractedParams;
        $this.$maybeSemanticTable = $maybeSemanticTable;
        $this.$accumulatedConditions = $accumulatedConditions;
        $this.$maybeReturnColumns = $maybeReturnColumns;
        $this.$maybeObfuscationMetadata = $maybeObfuscationMetadata;
    }
    var s_Option = $rt_classWithoutFields();
    function s_Option_isEmpty($this) {
        if ($this !== s_None$_MODULE$)
            return 0;
        return 1;
    }
    function s_Option_isDefined($this) {
        if (s_Option_isEmpty($this))
            return 0;
        return 1;
    }
    function s_Option_knownSize($this) {
        if (!s_Option_isEmpty($this))
            return 1;
        return 0;
    }
    function s_Option_getOrElse($this, $default) {
        if (!s_Option_isEmpty($this))
            return $this.$get0();
        return $default.$apply2();
    }
    function s_Option_map($this, $f) {
        if (s_Option_isEmpty($this))
            return s_None$_MODULE$;
        return s_Some__init_($f.$apply($this.$get0()));
    }
    function s_Option_fold($this, $ifEmpty, $f) {
        if (s_Option_isEmpty($this))
            return $ifEmpty.$apply2();
        return $f.$apply($this.$get0());
    }
    function s_Option_flatMap($this, $f) {
        if (s_Option_isEmpty($this))
            return s_None$_MODULE$;
        return $f.$apply($this.$get0());
    }
    function s_Option_filter($this, $p) {
        if (!s_Option_isEmpty($this) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$get0())))
            return s_None$_MODULE$;
        return $this;
    }
    function s_Option_filterNot($this, $p) {
        if (!s_Option_isEmpty($this) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$get0())))
            return s_None$_MODULE$;
        return $this;
    }
    function s_Option_nonEmpty($this) {
        return s_Option_isDefined($this);
    }
    function s_Option_contains($this, $elem) {
        if (!s_Option_isEmpty($this) && sr_BoxesRunTime_equals($this.$get0(), $elem))
            return 1;
        return 0;
    }
    function s_Option_exists($this, $p) {
        if (!s_Option_isEmpty($this) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$get0())))
            return 1;
        return 0;
    }
    function s_Option_forall($this, $p) {
        if (!s_Option_isEmpty($this) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$get0())))
            return 0;
        return 1;
    }
    function s_Option_foreach($this, $f) {
        if (s_Option_isEmpty($this))
            return;
        $f.$apply($this.$get0());
    }
    function s_Option_collect($this, $pf) {
        if (s_Option_isEmpty($this))
            return s_None$_MODULE$;
        return s_PartialFunction$Lifted_apply(s_PartialFunction_lift$($pf), $this.$get0());
    }
    function s_Option_orElse($this, $alternative) {
        var var$2, var$3;
        if (!s_Option_isEmpty($this))
            return $this;
        var$2 = $alternative.$_021;
        $alternative = $alternative.$_17;
        var$2 = onciuh_TreeZipper$Location_up(var$2);
        var$3 = new oncias_SemanticState$ScopeLocation$$$anonfun$symbol$extension$1$lambda$_22_0;
        var$3.$_022 = $alternative;
        return s_Option_flatMap(var$2, var$3);
    }
    function s_Option_iterator($this) {
        if (s_Option_isEmpty($this))
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        return sc_Iterator$$anon$20__init_($this.$get0());
    }
    var s_None$ = $rt_classWithoutFields(s_Option);
    var s_None$_MODULE$ = null;
    function s_None$__clinit_() {
        s_None$_MODULE$ = new s_None$;
    }
    function s_None$_productArity($this) {
        return 0;
    }
    function s_None$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function s_None$_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function s_None$_hashCode($this) {
        return 2433880;
    }
    function s_None$_toString($this) {
        return $rt_s(47);
    }
    function s_None$_get($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(48));
        $rt_throw(var$1);
    }
    var oncif_PlannerName = $rt_classWithoutFields(0);
    var oncifp_SemanticAnalyzer$IDPPlannerName$ = $rt_classWithoutFields();
    var oncifp_SemanticAnalyzer$IDPPlannerName$_MODULE$ = null;
    var oncifp_SemanticAnalyzer$IDPPlannerName$_name = null;
    var oncifp_SemanticAnalyzer$IDPPlannerName$_toTextOutput = null;
    var oncifp_SemanticAnalyzer$IDPPlannerName$_version = null;
    function oncifp_SemanticAnalyzer$IDPPlannerName$__clinit_() {
        oncifp_SemanticAnalyzer$IDPPlannerName$_MODULE$ = new oncifp_SemanticAnalyzer$IDPPlannerName$;
        oncifp_SemanticAnalyzer$IDPPlannerName$_name = $rt_s(49);
        oncifp_SemanticAnalyzer$IDPPlannerName$_toTextOutput = $rt_s(50);
        oncifp_SemanticAnalyzer$IDPPlannerName$_version = $rt_s(51);
    }
    function oncifp_SemanticAnalyzer$IDPPlannerName$_productArity($this) {
        return 0;
    }
    function oncifp_SemanticAnalyzer$IDPPlannerName$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_SemanticAnalyzer$IDPPlannerName$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_SemanticAnalyzer$IDPPlannerName$_hashCode($this) {
        return (-10148440);
    }
    function oncifp_SemanticAnalyzer$IDPPlannerName$_toString($this) {
        return $rt_s(52);
    }
    function onciu_AnonymousVariableNameGenerator() {
        jl_Object.call(this);
        this.$counter = 0;
    }
    var s_Function12 = $rt_classWithoutFields(0);
    var sr_AbstractFunction12 = $rt_classWithoutFields();
    var oncifp_InitialState$ = $rt_classWithoutFields(sr_AbstractFunction12);
    var oncifp_InitialState$_MODULE$ = null;
    function oncifp_InitialState$__clinit_() {
        oncifp_InitialState$_MODULE$ = new oncifp_InitialState$;
    }
    var oncifp_SemanticAnalyzer$NoErrors$ = $rt_classWithoutFields(jl_Exception);
    var oncifp_SemanticAnalyzer$NoErrors$_MODULE$ = null;
    function oncifp_SemanticAnalyzer$NoErrors$__clinit_() {
        var var$1;
        var$1 = new oncifp_SemanticAnalyzer$NoErrors$;
        jl_Throwable__init_0(var$1);
        oncifp_SemanticAnalyzer$NoErrors$_MODULE$ = var$1;
    }
    var oncifp_Transformer = $rt_classWithoutFields(0);
    function oncifp_Transformer_andThen$($$this, $other) {
        var var$3;
        var$3 = new oncifp_PipeLine;
        var$3.$first = $$this;
        var$3.$after = $other;
        return var$3;
    }
    function oncifp_Transformer_checkConditions$($$this, $state, $conditions) {
        var var$4;
        var$4 = sc_IterableOnceOps_toSeq$($conditions);
        $conditions = new oncifp_Transformer$$anonfun$1;
        $conditions.$state$1 = $state;
        $state = var$4.$collect0($conditions);
        s_Predef$_$callClinit();
        $state = $state.$flatten(s_Predef$_$conforms(s_Predef$_MODULE$));
        if (!sc_IterableOnceOps_nonEmpty$($state))
            return 1;
        $$this = $$this.$name3();
        $conditions = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($conditions);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($conditions, $rt_s(53)), $$this), 10);
        var$4 = jl_AbstractStringBuilder_toString($conditions);
        $$this = new jl_IllegalStateException;
        $state = sc_AbstractIterable_mkString0($state, $rt_s(16));
        $conditions = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($conditions);
        jl_StringBuilder_append(jl_StringBuilder_append($conditions, var$4), $state);
        jl_Throwable__init_($$this, jl_AbstractStringBuilder_toString($conditions));
        $rt_throw($$this);
    }
    var oncifp_Phase = $rt_classWithoutFields(0);
    function oncifp_Phase_transform$($$this, $from, $context) {
        var var$4, var$5, var$6, $$je;
        $$this.$phase();
        var$4 = oncifp_CompilationPhaseTracer_NONE_PHASE;
        var$5 = new oncifp_Phase$transform$lambda$_2_0;
        var$5.$_023 = $$this;
        var$5.$_18 = $from;
        var$5.$_26 = $context;
        $context = new oncifh_package$$closing$default$3$lambda$_2_0;
        $from = new oncifh_package$$closing$default$4$lambda$_3_0;
        $$this = new oncifh_package$$closing$lambda$_1_0;
        $$this.$_024 = var$5;
        a: {
            b: {
                try {
                    var$6 = 0;
                    $$this = oncifh_package$$closing$lambda$_1_0_apply($$this, var$4);
                    var$6 = 0;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    if ($$je instanceof jl_Throwable) {
                        $$this = $$je;
                        break b;
                    } else{
                        $$this = $$je;
                        break a;
                    }
                }
                c: {
                    try {
                        oncifh_package$$closing$default$3$lambda$_2_0_apply($context, var$4);
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $$this = $$je;
                        break c;

                    }
                    return $$this;
                }
                $rt_throw($$this);
            }
            try {
                var$6 = 0;
                var$6 = 1;
                d: {
                    try {
                        e: {
                            try {
                                var$6 = 1;
                                oncifh_package$$closing$default$4$lambda$_3_0_apply($from, var$4, $$this);
                                break e;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                $from = $$je;

                            }
                            var$6 = 1;
                            oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_0_close(var$4);
                            $rt_throw($from);
                        }
                        var$6 = 1;
                        oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_0_close(var$4);
                        var$6 = 1;
                        break d;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof jl_Throwable) {
                            $from = $$je;
                        } else {
                            throw $$e;
                        }
                    }
                    var$6 = 1;
                    jl_Throwable_addSuppressed($$this, $from);
                }
                var$6 = 1;
                $rt_throw($$this);
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                $$this = $$je;

            }
        }
        if (!var$6)
            f: {
                try {
                    oncifh_package$$closing$default$3$lambda$_2_0_apply($context, var$4);
                    break f;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    $$this = $$je;

                }
                $rt_throw($$this);
            }
        $rt_throw($$this);
    }
    var onciu_StepSequencer$Step = $rt_classWithoutFields(0);
    var oncifpf_ParsePipelineTransformerFactory = $rt_classWithoutFields(0);
    var oncifp_Parse$ = $rt_classWithoutFields();
    var oncifp_Parse$_MODULE$ = null;
    var oncifp_Parse$_phase = null;
    function oncifp_Parse$_$callClinit() {
        oncifp_Parse$_$callClinit = $rt_eraseClinit(oncifp_Parse$);
        oncifp_Parse$__clinit_();
    }
    function oncifp_Parse$__clinit_() {
        var var$1;
        var$1 = new oncifp_Parse$;
        oncifp_Parse$_$callClinit();
        oncifp_Parse$_MODULE$ = var$1;
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        oncifp_Parse$_phase = oncifp_CompilationPhaseTracer$CompilationPhase_PARSING;
    }
    function oncifp_Parse$_transform($this, $from, $context) {
        return oncifp_Phase_transform$($this, $from, $context);
    }
    function oncifp_Parse$_name($this) {
        return $this.$productPrefix();
    }
    function oncifp_Parse$_checkConditions($this, $state, $conditions) {
        return oncifp_Transformer_checkConditions$($this, $state, $conditions);
    }
    function oncifp_Parse$_phase0($this) {
        oncifp_Parse$_$callClinit();
        return oncifp_Parse$_phase;
    }
    function oncifp_Parse$_postConditions($this) {
        var var$1, var$2, var$3, var$4, var$5;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 2);
        var$4 = var$3.data;
        var$5 = new oncifp_BaseContains;
        sr_ClassTag$_$callClinit();
        oncifp_BaseContains__init_(var$5, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncia_Statement)));
        var$4[0] = var$5;
        var$4[1] = oncifp_ValidSymbolicNamesInLabelExpressions$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncifp_Parse$_productPrefix($this) {
        return $rt_s(54);
    }
    function oncifp_Parse$_process($this, $from, $context) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, $$je;
        var$3 = $from.$queryText;
        $context = oncifp_SemanticAnalyzer$$anon$1_cypherExceptionFactory($context);
        var$4 = new oncipj_CypherCharStream;
        var$4.$queryCursor = (-1);
        var$4.$queryCursorLine = 1;
        var$4.$resultCursor = (-1);
        var$4.$tabSize = 1;
        var$4.$query = var$3;
        var$4.$result1 = $rt_createCharArray(jl_String_length(var$3));
        var$4.$lines = $rt_createIntArray(jl_String_length(var$3));
        var$4.$columns = $rt_createIntArray(jl_String_length(var$3));
        var$4.$offsets = $rt_createIntArray(jl_String_length(var$3));
        var$5 = new onciafn_Neo4jASTExceptionFactory;
        var$5.$inner = $context;
        var$6 = new onciafn_Neo4jASTFactory;
        var$6.$query0 = var$3;
        var$6.$astExceptionFactory = var$5;
        var$3 = new oncipj_Cypher;
        oncipj_Cypher_$callClinit();
        var$7 = new ju_Stack;
        ju_AbstractCollection__init_(var$7);
        var$7.$elementData = $rt_createArray(jl_Object, 10);
        var$7.$elementCount = 0;
        var$7.$capacityIncrement = 0;
        var$3.$labelExpressionStack = var$7;
        var$3.$jj_lookingAhead = 0;
        var$3.$jj_la1 = $rt_createIntArray(637);
        var$3.$jj_2_rtns = $rt_createArray(oncipj_Cypher$JJCalls, 145);
        var$3.$jj_rescan = 0;
        var$3.$jj_gc = 0;
        var$7 = new oncipj_Cypher$LookaheadSuccess;
        jl_Throwable__init_0(var$7);
        var$3.$jj_ls = var$7;
        var$3.$jj_expentries = ju_ArrayList__init_();
        var$3.$jj_kind = (-1);
        var$3.$jj_lasttokens = $rt_createIntArray(100);
        var$7 = new oncipj_CypherTokenManager;
        var$7.$curLexState = 0;
        var$7.$defaultLexState = 0;
        var$7.$jjrounds = $rt_createIntArray(74);
        var$7.$jjstateSet = $rt_createIntArray(148);
        var$8 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$8);
        var$7.$jjimage = var$8;
        var$7.$image = var$8;
        var$7.$input_stream = var$4;
        var$3.$token_source = var$7;
        var$3.$token = new oncipj_Token;
        var$3.$jj_ntk = (-1);
        var$3.$jj_gen = 0;
        var$9 = 0;
        while (var$9 < 637) {
            var$3.$jj_la1.data[var$9] = (-1);
            var$9 = var$9 + 1 | 0;
        }
        var$9 = 0;
        while (true) {
            var$10 = var$3.$jj_2_rtns.data;
            if (var$9 >= var$10.length)
                break;
            var$10[var$9] = new oncipj_Cypher$JJCalls;
            var$9 = var$9 + 1 | 0;
        }
        var$3.$astFactory = var$6;
        var$3.$exceptionFactory = var$5;
        var$4 = ju_ArrayList__init_();
        a: {
            b: {
                try {
                    ju_ArrayList_add(var$4, oncipj_Cypher_Statement(var$3));
                    while (oncipj_Cypher_jj_2_1(var$3, 2)) {
                        oncipj_Cypher_jj_consume_token(var$3, 283);
                        ju_ArrayList_add(var$4, oncipj_Cypher_Statement(var$3));
                    }
                    if (oncipj_Cypher_jj_2_2(var$3, 2))
                        oncipj_Cypher_jj_consume_token(var$3, 283);
                    oncipj_Cypher_jj_consume_token(var$3, 0);
                    break b;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    if ($$je instanceof oncipj_ParseException) {
                        $from = $$je;
                        break a;
                    } else if ($$je instanceof oncipj_InvalidUnicodeLiteral) {
                        $from = $$je;
                    } else {
                        throw $$e;
                    }
                }
                $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException(var$3.$exceptionFactory, $from, $from.$offset, $from.$line, $from.$column));
            }
            var$11 = var$4.$size2;
            if (var$11 == 1)
                return oncifp_InitialState_withStatement($from, ju_ArrayList_get(var$4, 0));
            $from = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($from);
            jl_StringBuilder_append0(jl_StringBuilder_append($from, $rt_s(55)), var$11);
            var$4 = jl_AbstractStringBuilder_toString($from);
            onciu_InputPosition$_$callClinit();
            $rt_throw(onciu_OpenCypherExceptionFactory_syntaxException($context, var$4, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)));
        }
        $context = $from.$currentToken.$next1;
        if (!jl_String_contains($from.$message, $rt_s(56)))
            $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException0(var$3.$exceptionFactory, $context.$image0, ju_Collections_EMPTY_LIST, $from, $context.$beginOffset, $context.$beginLine, $context.$beginColumn));
        $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException0(var$3.$exceptionFactory, $context.$image0, ju_Collections_EMPTY_LIST, $from, $context.$endOffset + 1 | 0, $context.$endLine, $context.$endColumn + 1 | 0));
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements() {
        jl_Object.call(this);
        this.$deprecations = null;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements__init_0(var_0) {
        var var_1 = new oncifp_SyntaxDeprecationWarningsAndReplacements();
        oncifp_SyntaxDeprecationWarningsAndReplacements__init_(var_1, var_0);
        return var_1;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements_transform($this, $from, $context) {
        return oncifp_Phase_transform$($this, $from, $context);
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements_name($this) {
        return $this.$productPrefix();
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements_checkConditions($this, $state, $conditions) {
        return oncifp_Transformer_checkConditions$($this, $state, $conditions);
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements_postConditions($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$deprecations;
        if ($rt_isInstance(var$1, oncir_SyntacticDeprecations)) {
            s_Predef$_$callClinit();
            var$2 = s_Predef$_Set(s_Predef$_MODULE$);
            var$1 = sr_ScalaRunTime$_MODULE$;
            var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
            var$3.data[0] = oncifp_DeprecatedSyntaxReplaced$_MODULE$;
            return var$2.$from0(sr_ScalaRunTime$_wrapRefArray(var$1, var$3));
        }
        if (!$rt_isInstance(var$1, oncir_SemanticDeprecations))
            $rt_throw(s_MatchError__init_(var$1));
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncifp_DeprecatedSemanticsReplaced$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$4, var$3));
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements_phase($this) {
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        return oncifp_CompilationPhaseTracer$CompilationPhase_DEPRECATION_WARNINGS;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements_productPrefix($this) {
        return $rt_s(57);
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements_process($this, $from, $context) {
        var var$3, var$4, var$5, var$6;
        $context = $this.$deprecations;
        if ($rt_isInstance($context, oncir_SyntacticDeprecations)) {
            $context = (oncifp_InitialState_statement($from)).$folder();
            s_Predef$_$callClinit();
            s_Predef$_Set(s_Predef$_MODULE$);
            var$3 = sci_Set$EmptySet$_MODULE$;
            oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
            $context = onciu_Foldable$Folder_fold($context, var$3, sr_AbstractPartialFunction_andThen(oncir_Deprecations$syntacticallyDeprecatedFeatures$_find, new oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_0));
            oncifp_InitialState_statement($from);
            s_Predef$_Set(s_Predef$_MODULE$);
            $context = $context.$concat1(sci_Set$EmptySet$_MODULE$);
        } else {
            if (!$rt_isInstance($context, oncir_SemanticDeprecations))
                $rt_throw(s_MatchError__init_($context));
            $context = $context;
            var$4 = $from.$maybeSemanticTable;
            var$5 = new oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_4;
            var$5.$_025 = $context;
            $context = s_Option_getOrElse(var$4, var$5);
            var$5 = (oncifp_InitialState_statement($from)).$folder();
            s_Predef$_$callClinit();
            s_Predef$_Set(s_Predef$_MODULE$);
            var$6 = sci_Set$EmptySet$_MODULE$;
            var$3 = new oncir_Deprecations$semanticallyDeprecatedFeatures$$find$lambda$_4_0;
            var$3.$_026 = $context;
            if (var$3 instanceof s_PartialFunction$Lifted)
                var$4 = var$3.$pf0();
            else {
                var$4 = new s_PartialFunction$Unlifted;
                var$4.$f2 = var$3;
            }
            $context = onciu_Foldable$Folder_fold(var$5, var$6, sr_AbstractPartialFunction_andThen(var$4, new oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_5));
        }
        var$5 = $context.$flatMap(new oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_1);
        $context = ($context.$flatMap(new oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_2)).$toMap(s_$less$colon$less$_singleton);
        var$3 = onciu_devNullLogger$_MODULE$;
        var$4 = new oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_3;
        var$4.$_027 = var$3;
        var$5.$foreach(var$4);
        var$5 = onciu_bottomUp$_MODULE$;
        onciu_Rewriter$_$callClinit();
        var$4 = onciu_Rewriter$_MODULE$;
        var$3 = new oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1;
        var$3.$replacements$1 = $context;
        return oncifp_InitialState_withStatement($from, (onciu_bottomUp$_apply(var$5, onciu_Rewriter$_lift(var$4, var$3), onciu_bottomUp$_apply$default$2(onciu_bottomUp$_MODULE$), onciu_CancellationChecker$NeverCancelled$_MODULE$)).$apply(oncifp_InitialState_statement($from)));
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements__init_($this, $deprecations) {
        $this.$deprecations = $deprecations;
    }
    var oncir_Deprecations = $rt_classWithoutFields(0);
    var oncir_SyntacticDeprecations = $rt_classWithoutFields(0);
    var oncir_Deprecations$syntacticallyDeprecatedFeatures$ = $rt_classWithoutFields();
    var oncir_Deprecations$syntacticallyDeprecatedFeatures$_MODULE$ = null;
    var oncir_Deprecations$syntacticallyDeprecatedFeatures$_stringifier = null;
    var oncir_Deprecations$syntacticallyDeprecatedFeatures$_find = null;
    function oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit() {
        oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit = $rt_eraseClinit(oncir_Deprecations$syntacticallyDeprecatedFeatures$);
        oncir_Deprecations$syntacticallyDeprecatedFeatures$__clinit_();
    }
    function oncir_Deprecations$syntacticallyDeprecatedFeatures$__clinit_() {
        var var$1;
        var$1 = new oncir_Deprecations$syntacticallyDeprecatedFeatures$;
        oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
        oncir_Deprecations$syntacticallyDeprecatedFeatures$_MODULE$ = var$1;
        oncir_Deprecations$syntacticallyDeprecatedFeatures$_stringifier = onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_ExpressionStringifier$_failingExtender, 0, 0, 0, 0);
        oncir_Deprecations$syntacticallyDeprecatedFeatures$_find = new oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1;
    }
    function oncir_Deprecations$syntacticallyDeprecatedFeatures$_stringifier0($this) {
        oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
        return oncir_Deprecations$syntacticallyDeprecatedFeatures$_stringifier;
    }
    function oncir_Deprecations$syntacticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider($this, $options) {
        if (!($options instanceof oncia_OptionsMap))
            return 0;
        return $options.$map0.$exists(new oncir_Deprecations$syntacticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider$lambda$_6_0);
    }
    function oncir_Deprecations$syntacticallyDeprecatedFeatures$_toString($this) {
        return $rt_s(58);
    }
    var oncifp_PreparatoryRewriting$ = $rt_classWithoutFields();
    var oncifp_PreparatoryRewriting$_MODULE$ = null;
    var oncifp_PreparatoryRewriting$_x$1 = null;
    var oncifp_PreparatoryRewriting$_orderedSteps = null;
    var oncifp_PreparatoryRewriting$__postConditions = null;
    var oncifp_PreparatoryRewriting$_phase = null;
    function oncifp_PreparatoryRewriting$_$callClinit() {
        oncifp_PreparatoryRewriting$_$callClinit = $rt_eraseClinit(oncifp_PreparatoryRewriting$);
        oncifp_PreparatoryRewriting$__clinit_();
    }
    function oncifp_PreparatoryRewriting$__clinit_() {
        var $x$1, $_postConditions, var$3, var$4, var$5, $x$4, $x$5, $orderedSteps, var$9, var$10;
        $x$1 = new oncifp_PreparatoryRewriting$;
        oncifp_PreparatoryRewriting$_$callClinit();
        oncifp_PreparatoryRewriting$_MODULE$ = $x$1;
        s_Predef$_$callClinit();
        $x$1 = s_Predef$_Set(s_Predef$_MODULE$);
        $_postConditions = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Step, 8);
        var$4 = var$3.data;
        var$4[0] = oncirr_normalizeWithAndReturnClauses$_MODULE$;
        oncirr_insertWithBetweenOptionalMatchAndMatch$_$callClinit();
        var$4[1] = oncirr_insertWithBetweenOptionalMatchAndMatch$_MODULE$;
        oncirr_expandCallWhere$_$callClinit();
        var$4[2] = oncirr_expandCallWhere$_MODULE$;
        oncirr_expandShowWhere$_$callClinit();
        var$4[3] = oncirr_expandShowWhere$_MODULE$;
        oncirr_rewriteShowQuery$_$callClinit();
        var$4[4] = oncirr_rewriteShowQuery$_MODULE$;
        oncirr_mergeInPredicates$_$callClinit();
        var$4[5] = oncirr_mergeInPredicates$_MODULE$;
        oncirr_timestampRewriter$_$callClinit();
        var$4[6] = oncirr_timestampRewriter$_MODULE$;
        var$4[7] = oncirr_rewriteShortestPathWithFixedLengthRelationship$_MODULE$;
        $x$1 = $x$1.$from0(sr_ScalaRunTime$_wrapRefArray($_postConditions, var$3));
        s_Predef$_Set(s_Predef$_MODULE$);
        var$5 = sci_Set$EmptySet$_MODULE$;
        $x$4 = s_None$_MODULE$;
        $x$5 = onciu_StepSequencer$RepeatedSteps$Permitted$_MODULE$;
        $_postConditions = (sc_IterableOnceOps_toSeq$($x$1)).$map1(new onciu_StepSequencer$orderSteps$lambda$_3_1);
        $orderedSteps = new onciu_StepSequencer$orderSteps$lambda$_3_2;
        $orderedSteps.$_028 = var$5;
        $_postConditions = $_postConditions.$flatMap($orderedSteps);
        sc_IterableOnceOps_foreach$(sc_AbstractMapView_mapValues(sc_AbstractMap_view(sc_StrictOptimizedIterableOps_filter$(sc_AbstractIterable_groupBy($_postConditions, new onciu_StepSequencer$orderSteps$lambda$_3_3), new onciu_StepSequencer$orderSteps$lambda$_3_4)), new onciu_StepSequencer$orderSteps$lambda$_3_5), new onciu_StepSequencer$orderSteps$lambda$_3_6);
        $_postConditions = ($_postConditions.$concat0(sc_AbstractIterable_map(var$5, new onciu_StepSequencer$orderSteps$lambda$_3_7))).$toMap(s_$less$colon$less$_singleton);
        $orderedSteps = sc_AbstractIterable_toMap(sc_AbstractMapView_mapValues(sc_AbstractMap_view(sc_AbstractIterable_groupBy((sc_IterableOnceOps_toSeq$($x$1)).$flatMap(new onciu_StepSequencer$orderSteps$lambda$_3_8), new onciu_StepSequencer$orderSteps$lambda$_3_9)), new onciu_StepSequencer$orderSteps$lambda$_3_10), s_$less$colon$less$_singleton);
        s_Predef$_Set(s_Predef$_MODULE$);
        $orderedSteps = sci_AbstractMap_withDefaultValue($orderedSteps, sci_Set$EmptySet$_MODULE$);
        var$9 = onciu_StepSequencer$MutableDirectedGraph__init_();
        var$10 = new onciu_StepSequencer$orderSteps$lambda$_3_11;
        var$10.$_029 = var$9;
        $x$1.$foreach(var$10);
        var$10 = new onciu_StepSequencer$orderSteps$lambda$_3_12;
        var$10.$_030 = $_postConditions;
        var$10.$_19 = var$9;
        $x$1.$foreach(var$10);
        onciu_StepSequencer$_org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort(onciu_StepSequencer$_MODULE$, var$9, s_None$_MODULE$, new onciu_StepSequencer$orderSteps$lambda$_3_13);
        var$9 = onciu_StepSequencer$MutableDirectedGraph__init_();
        var$10 = new onciu_StepSequencer$orderSteps$lambda$_3_14;
        var$10.$_031 = var$9;
        $x$1.$foreach(var$10);
        var$10 = new onciu_StepSequencer$orderSteps$lambda$_3_15;
        var$10.$_032 = $x$5;
        var$10.$_110 = $_postConditions;
        var$10.$_27 = var$9;
        var$10.$_32 = $orderedSteps;
        $x$1.$foreach(var$10);
        $_postConditions = $_postConditions.$collect1(new onciu_StepSequencer$$anonfun$1);
        $_postConditions = onciu_StepSequencer$_org$neo4j$cypher$internal$util$StepSequencer$$sort(onciu_StepSequencer$_MODULE$, var$9, $_postConditions, sc_IterableOnceOps_toSeq$($x$1), var$5, $x$4);
        if ($_postConditions === null)
            $rt_throw(s_MatchError__init_($_postConditions));
        $orderedSteps = $_postConditions.$steps;
        $_postConditions = $_postConditions.$postConditions;
        $x$1 = s_Tuple2__init_($orderedSteps, $_postConditions);
        oncifp_PreparatoryRewriting$_x$1 = $x$1;
        oncifp_PreparatoryRewriting$_orderedSteps = $x$1.$_10;
        oncifp_PreparatoryRewriting$__postConditions = $x$1.$_20;
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        oncifp_PreparatoryRewriting$_phase = oncifp_CompilationPhaseTracer$CompilationPhase_AST_REWRITE;
    }
    function oncifp_PreparatoryRewriting$_transform($this, $from, $context) {
        return oncifp_Phase_transform$($this, $from, $context);
    }
    function oncifp_PreparatoryRewriting$_name($this) {
        return $this.$productPrefix();
    }
    function oncifp_PreparatoryRewriting$_checkConditions($this, $state, $conditions) {
        return oncifp_Transformer_checkConditions$($this, $state, $conditions);
    }
    function oncifp_PreparatoryRewriting$_phase0($this) {
        oncifp_PreparatoryRewriting$_$callClinit();
        return oncifp_PreparatoryRewriting$_phase;
    }
    function oncifp_PreparatoryRewriting$_postConditions($this) {
        oncifp_PreparatoryRewriting$_$callClinit();
        return oncifp_PreparatoryRewriting$__postConditions.$incl(oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_MODULE$);
    }
    function oncifp_PreparatoryRewriting$_productPrefix($this) {
        return $rt_s(59);
    }
    function oncifp_PreparatoryRewriting$_process($this, $from, $context) {
        var var$3, var$4;
        oncifp_PreparatoryRewriting$_$callClinit();
        var$3 = oncifp_PreparatoryRewriting$_orderedSteps;
        var$4 = new oncifp_PreparatoryRewriting$$process$lambda$_9_0;
        var$4.$_033 = $context;
        $context = var$3.$map1(var$4);
        var$4 = oncifp_InitialState_statement($from);
        var$3 = new onciu_inSequence$InSequenceRewriter;
        var$3.$rewriters = $context;
        return oncifp_InitialState_withStatement($from, var$3.$apply(var$4));
    }
    function oncifp_If() {
        var a = this; jl_Object.call(a);
        a.$f = null;
        a.$thenT = null;
    }
    function oncifp_If_transform($this, $from, $context) {
        var var$3;
        var$3 = $this.$f.$_02;
        oncifp_CompilationPhases$_$callClinit();
        if (!sr_BoxesRunTime_unboxToBoolean(jl_Boolean_valueOf(var$3.$obfuscateLiterals)))
            return $from;
        return oncifp_Phase_transform$($this.$thenT, $from, $context);
    }
    function oncifp_If_name($this) {
        var var$1, var$2;
        var$1 = $this.$thenT.$productPrefix();
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(60)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function oncifp_If_postConditions($this) {
        return oncifp_extractSensitiveLiterals$_postConditions($this.$thenT);
    }
    function oncifp_CompilationPhases$$parsingBase$lambda$_3_0() {
        jl_Object.call(this);
        this.$_02 = null;
    }
    var oncifp_extractSensitiveLiterals$ = $rt_classWithoutFields();
    var oncifp_extractSensitiveLiterals$_MODULE$ = null;
    function oncifp_extractSensitiveLiterals$__clinit_() {
        oncifp_extractSensitiveLiterals$_MODULE$ = new oncifp_extractSensitiveLiterals$;
    }
    function oncifp_extractSensitiveLiterals$_name($this) {
        return $this.$productPrefix();
    }
    function oncifp_extractSensitiveLiterals$_checkConditions($this, $state, $conditions) {
        return oncifp_Transformer_checkConditions$($this, $state, $conditions);
    }
    function oncifp_extractSensitiveLiterals$_phase($this) {
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        return oncifp_CompilationPhaseTracer$CompilationPhase_AST_REWRITE;
    }
    function oncifp_extractSensitiveLiterals$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirc_package$SensitiveLiteralsExtracted$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncifp_extractSensitiveLiterals$_productPrefix($this) {
        return $rt_s(61);
    }
    function oncifp_extractSensitiveLiterals$_process($this, $from, $context) {
        $context = onciu_bottomUp$_MODULE$;
        onciu_Rewriter$_$callClinit();
        return oncifp_InitialState_withStatement($from, (onciu_bottomUp$_apply($context, onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncifp_extractSensitiveLiterals$$anonfun$1), onciu_bottomUp$_apply$default$2(onciu_bottomUp$_MODULE$), onciu_CancellationChecker$NeverCancelled$_MODULE$)).$apply(oncifp_InitialState_statement($from)));
    }
    function oncifp_SemanticAnalysis() {
        var a = this; jl_Object.call(a);
        a.$warn = 0;
        a.$features = null;
    }
    function oncifp_SemanticAnalysis_transform($this, $from, $context) {
        return oncifp_Phase_transform$($this, $from, $context);
    }
    function oncifp_SemanticAnalysis_name($this) {
        return $this.$productPrefix();
    }
    function oncifp_SemanticAnalysis_checkConditions($this, $state, $conditions) {
        return oncifp_Transformer_checkConditions$($this, $state, $conditions);
    }
    function oncifp_SemanticAnalysis_phase($this) {
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        return oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_CHECK;
    }
    function oncifp_SemanticAnalysis_postConditions($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(s_Product, 4);
        var$4 = var$3.data;
        var$5 = new oncifp_BaseContains;
        sr_ClassTag$_$callClinit();
        oncifp_BaseContains__init_(var$5, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncias_SemanticState)));
        var$4[0] = var$5;
        var$6 = new oncifp_StatementCondition;
        var$7 = new oncirc_containsNoNodesOfType;
        var$7.$tag = sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncia_UnaliasedReturnItem));
        var$6.$inner0 = var$7;
        var$4[1] = var$6;
        var$4[2] = oncifp_BaseContains__init_0(sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncias_SemanticTable)));
        var$4[3] = oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_MODULE$;
        var$5 = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
        oncirc_package$_$callClinit();
        return var$5.$concat0(oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$));
    }
    function oncifp_SemanticAnalysis_productPrefix($this) {
        return $rt_s(62);
    }
    function oncifp_SemanticAnalysis_process($this, $from, $context) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        oncias_SemanticState$_$callClinit();
        var$3 = oncias_SemanticState$_clean;
        var$4 = sc_LinearSeqOps_foldLeft$($this.$features, var$3, new oncias_SemanticState$withFeatures$lambda$_40_0);
        var$5 = s_Option_isDefined($from.$maybeSemanticTable);
        var$6 = oncias_SemanticState_copy(var$4, var$4.$currentScope, var$4.$typeTable, var$4.$recordedScopes, var$4.$notifications, var$4.$features1, var$4.$declareVariablesToSuppressDuplicateErrors, var$5);
        var$7 = new oncifp_SemanticAnalysis$$anon$1;
        var$7.$context$1 = $context;
        var$8 = oncifp_InitialState_statement($from);
        oncias_SemanticFeature$_$callClinit();
        var$9 = var$6.$features1;
        if (var$9.$contains0(oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$) && var$9.$contains0(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_MODULE$)) {
            var$7 = new jl_IllegalArgumentException;
            $from = oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$;
            $context = oncias_SemanticFeature$UseAsMultipleGraphsSelector$_MODULE$;
            var$8 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$8);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$8, $rt_s(63)), $from), $rt_s(64)), $context), $rt_s(65));
            jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$8));
            $rt_throw(var$7);
        }
        var$8 = (var$8.$semanticCheck()).$run(var$6, var$7);
        var$9 = (onciuh_TreeZipper$Location_root(var$8.$state.$currentScope)).$elem;
        var$7 = oncias_Scope_allScopes(var$9);
        var$3 = new oncias_ScopeTreeVerifier$$verify$lambda$_1_0;
        var$3.$_034 = var$9;
        var$7 = var$7.$flatMap(var$3);
        if (sc_IterableOnceOps_nonEmpty$(var$7)) {
            $context = new jl_IllegalStateException;
            jl_Throwable__init_($context, sc_AbstractIterable_mkString0(var$7, $rt_s(66)));
            $rt_throw($context);
        }
        var$7 = s_Tuple2__init_(var$8.$state, var$8.$errors);
        var$8 = var$7.$_10;
        var$7 = var$7.$_20;
        if ($this.$warn) {
            var$9 = var$8.$notifications;
            var$3 = onciu_devNullLogger$_MODULE$;
            var$6 = new oncifp_SemanticAnalysis$process$lambda$_13_0;
            var$6.$_035 = var$3;
            var$9.$foreach(var$6);
        }
        oncifp_SemanticAnalyzer$$anon$1$errorHandler$lambda$_4_0_apply(oncifp_SemanticAnalyzer$$anon$1_errorHandler($context), var$7);
        $context = $from.$maybeSemanticTable;
        if (!($context instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, $context))
                $rt_throw(s_MatchError__init_($context));
            var$6 = oncias_SemanticTable$_apply(oncias_SemanticTable$_MODULE$, oncias_SemanticState_typeTable(var$8), sc_AbstractIterable_toMap(sc_AbstractMapView_mapValues(sc_AbstractMap_view(oncias_SemanticState_recordedScopes(var$8)), oncifp_SemanticAnalysis$process$lambda$_13_2__init_()), s_$less$colon$less$_refl(s_$less$colon$less$_MODULE$)));
        } else {
            var$6 = $context.$value5;
            var$9 = var$8.$typeTable;
            var$4 = sc_AbstractIterable_toMap(sc_AbstractMapView_mapValues(sc_AbstractMap_view(var$8.$recordedScopes), new oncifp_SemanticAnalysis$process$lambda$_13_1), s_$less$colon$less$_singleton);
            var$3 = var$6.$resolvedLabelNames;
            $context = var$6.$resolvedPropertyKeyNames;
            var$10 = var$6.$resolvedRelTypeNames;
            var$6 = oncias_SemanticTable__init_(var$9, var$4, scm_AbstractMap_clone(var$3), scm_AbstractMap_clone($context), scm_AbstractMap_clone(var$10));
        }
        if (!var$7.$isEmpty())
            $context = oncifp_InitialState_statement($from);
        else {
            $context = oncifp_InitialState_statement($from);
            var$7 = new oncirr_computeDependenciesForExpressions;
            var$7.$semanticState = var$8;
            var$4 = onciu_topDown$_MODULE$;
            onciu_Rewriter$_$callClinit();
            var$3 = onciu_Rewriter$_MODULE$;
            var$9 = new oncirr_computeDependenciesForExpressions$$anonfun$1;
            var$9.$$outer0 = var$7;
            var$7.$instance = onciu_topDown$_apply(var$4, onciu_Rewriter$_lift(var$3, var$9), onciu_topDown$_apply$default$2(onciu_topDown$_MODULE$), 1, onciu_CancellationChecker$NeverCancelled$_MODULE$);
            $context = var$7.$apply($context);
        }
        $from = oncifp_InitialState_withStatement($from, $context);
        $context = s_Some__init_(var$8);
        $context = oncifp_InitialState_copy($from, $from.$queryText, $from.$startPosition, $from.$plannerName, $from.$anonymousVariableNameGenerator, $from.$maybeProcedureSignatureVersion, $from.$maybeStatement, $context, $from.$maybeExtractedParams, $from.$maybeSemanticTable, $from.$accumulatedConditions, $from.$maybeReturnColumns, $from.$maybeObfuscationMetadata);
        $from = s_Some__init_(var$6);
        return oncifp_InitialState_copy($context, $context.$queryText, $context.$startPosition, $context.$plannerName, $context.$anonymousVariableNameGenerator, oncifp_InitialState_copy$default$5($context), oncifp_InitialState_copy$default$6($context), oncifp_InitialState_copy$default$7($context), oncifp_InitialState_copy$default$8($context), $from, oncifp_InitialState_copy$default$10($context), oncifp_InitialState_copy$default$11($context), oncifp_InitialState_copy$default$12($context));
    }
    var oncifp_VisitorPhase = $rt_classWithoutFields(0);
    var oncifp_SemanticTypeCheck$ = $rt_classWithoutFields();
    var oncifp_SemanticTypeCheck$_MODULE$ = null;
    var oncifp_SemanticTypeCheck$_checks = null;
    var oncifp_SemanticTypeCheck$_phase = null;
    function oncifp_SemanticTypeCheck$_$callClinit() {
        oncifp_SemanticTypeCheck$_$callClinit = $rt_eraseClinit(oncifp_SemanticTypeCheck$);
        oncifp_SemanticTypeCheck$__clinit_();
    }
    function oncifp_SemanticTypeCheck$__clinit_() {
        var var$1;
        var$1 = new oncifp_SemanticTypeCheck$;
        oncifp_SemanticTypeCheck$_$callClinit();
        oncifp_SemanticTypeCheck$_MODULE$ = var$1;
        oncifp_SemanticTypeCheck$_checks = sci_$colon$colon__init_(new oncifp_PatternExpressionInNonExistenceCheck$$patternExpressionInNonExistenceCheck$lambda$_2_0, sci_$colon$colon__init_(new oncifp_CreatePatternSelfReferenceCheck$$check$lambda$_1_0, sci_$colon$colon__init_(new oncifp_ListCoercedToBooleanCheck$$listCoercedToBooleanCheck$lambda$_3_0, sci_Nil$_MODULE$)));
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        oncifp_SemanticTypeCheck$_phase = oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_TYPE_CHECK;
    }
    function oncifp_SemanticTypeCheck$_process($this, $from, $context) {
        $this.$visit($from, $context);
        return $from;
    }
    function oncifp_SemanticTypeCheck$_transform($this, $from, $context) {
        return oncifp_Phase_transform$($this, $from, $context);
    }
    function oncifp_SemanticTypeCheck$_name($this) {
        return $this.$productPrefix();
    }
    function oncifp_SemanticTypeCheck$_checkConditions($this, $state, $conditions) {
        return oncifp_Transformer_checkConditions$($this, $state, $conditions);
    }
    function oncifp_SemanticTypeCheck$_phase0($this) {
        oncifp_SemanticTypeCheck$_$callClinit();
        return oncifp_SemanticTypeCheck$_phase;
    }
    function oncifp_SemanticTypeCheck$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncifp_SemanticTypeCheck$_productPrefix($this) {
        return $rt_s(67);
    }
    function oncifp_SemanticTypeCheck$_visit($this, $value, $context) {
        var var$3, var$4, var$5;
        var$3 = oncifp_SemanticAnalyzer$$anon$1_errorHandler($context);
        oncifp_SemanticTypeCheck$_$callClinit();
        var$4 = oncifp_SemanticTypeCheck$_checks;
        var$5 = new oncifp_SemanticTypeCheck$$visit$lambda$_9_0;
        var$5.$_036 = $value;
        var$5.$_111 = $context;
        oncifp_SemanticAnalyzer$$anon$1$errorHandler$lambda$_4_0_apply(var$3, sci_List_flatMap(var$4, var$5));
    }
    function oncifp_AmbiguousAggregationAnalysis() {
        jl_Object.call(this);
        this.$features0 = null;
    }
    function oncifp_AmbiguousAggregationAnalysis_process($this, $from, $context) {
        $this.$visit($from, $context);
        return $from;
    }
    function oncifp_AmbiguousAggregationAnalysis_postConditions($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncifp_AmbiguousAggregationAnalysis_transform($this, $from, $context) {
        return oncifp_Phase_transform$($this, $from, $context);
    }
    function oncifp_AmbiguousAggregationAnalysis_name($this) {
        return $this.$productPrefix();
    }
    function oncifp_AmbiguousAggregationAnalysis_checkConditions($this, $state, $conditions) {
        return oncifp_Transformer_checkConditions$($this, $state, $conditions);
    }
    function oncifp_AmbiguousAggregationAnalysis_phase($this) {
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        return oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_CHECK;
    }
    function oncifp_AmbiguousAggregationAnalysis_productPrefix($this) {
        return $rt_s(68);
    }
    function oncifp_AmbiguousAggregationAnalysis_visit($this, $value, $context) {
        var var$3;
        var$3 = (oncifp_InitialState_statement($value)).$folder();
        s_package$_$callClinit();
        $value = onciu_Foldable$Folder_fold(var$3, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), new oncifp_AmbiguousAggregationAnalysis$$anonfun$1);
        oncifp_SemanticAnalyzer$$anon$1$errorHandler$lambda$_4_0_apply(oncifp_SemanticAnalyzer$$anon$1_errorHandler($context), $value);
    }
    var oncir_SemanticDeprecations = $rt_classWithoutFields(0);
    var oncir_Deprecations$semanticallyDeprecatedFeatures$ = $rt_classWithoutFields();
    var oncir_Deprecations$semanticallyDeprecatedFeatures$_MODULE$ = null;
    function oncir_Deprecations$semanticallyDeprecatedFeatures$__clinit_() {
        oncir_Deprecations$semanticallyDeprecatedFeatures$_MODULE$ = new oncir_Deprecations$semanticallyDeprecatedFeatures$;
    }
    function oncir_Deprecations$semanticallyDeprecatedFeatures$_toString($this) {
        return $rt_s(69);
    }
    function oncir_Deprecations$semanticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$findAllVariables$1($e) {
        var var$2;
        var$2 = onciu_Foldable_folder$(onciu_Foldable$_FoldableAny(onciu_Foldable$_MODULE$, $e));
        sr_ClassTag$_$callClinit();
        return sc_AbstractIterable_toSet(onciu_Foldable$Folder_findAllByClass(var$2, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_LogicalVariable))));
    }
    function oncir_Deprecations$semanticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1($variable, $allSymbolDefinitions$1) {
        return (($allSymbolDefinitions$1.$apply($variable.$name4)).$map1(new oncir_Deprecations$semanticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1$lambda$_15_0)).$contains0(onciu_Ref$_apply(onciu_Ref$_MODULE$, $variable));
    }
    function oncir_Deprecations$semanticallyDeprecatedFeatures$_$anonfun$find$1($semanticTable$1, $x0$1) {
        var $rhs, $lhs, $rhs_0, $x$4, $x$6, var$8, var$9, $pattern, $x$1, var$12, $x$3, $lhs_0;
        if ($x0$1 instanceof oncia_SetExactPropertiesFromMapItem) {
            $rhs = $x0$1;
            $lhs = $rhs.$variable;
            $rhs_0 = $rhs.$expression;
            if ($lhs !== null && $rhs_0 instanceof oncie_Variable) {
                $x$4 = $rhs_0;
                $x$6 = oncias_SemanticTable_typeFor($semanticTable$1, $x$4);
                $rhs_0 = sr_ScalaRunTime$_MODULE$;
                var$8 = $rt_createArray(oncius_CypherType, 2);
                var$9 = var$8.data;
                oncius_package$_$callClinit();
                var$9[0] = oncius_package$_CTNode(oncius_package$_MODULE$);
                var$9[1] = oncius_package$_CTRelationship(oncius_package$_MODULE$);
                if (oncias_SemanticTable$TypeGetter_isAnyOf($x$6, sr_ScalaRunTime$_wrapRefArray($rhs_0, var$8))) {
                    $pattern = new s_Some;
                    $x$6 = new oncir_Deprecation;
                    $rhs_0 = new s_Some;
                    $semanticTable$1 = s_Predef$ArrowAssoc$_MODULE$;
                    s_Predef$_$callClinit();
                    $x0$1 = onciu_Ref$_apply(onciu_Ref$_MODULE$, $rhs);
                    $x$1 = oncir_Deprecations$_org$neo4j$cypher$internal$rewriting$Deprecations$$functionInvocationForSetProperties(oncir_Deprecations$_MODULE$, $rhs, $x$4);
                    s_Some__init_0($rhs_0, s_Predef$ArrowAssoc$_$minus$greater$extension($semanticTable$1, $x0$1, oncia_SetExactPropertiesFromMapItem_copy($rhs, $rhs.$variable, $x$1, $rhs.$position)));
                    $semanticTable$1 = new s_Some;
                    $x0$1 = new onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification;
                    var$12 = $x$4.$position0;
                    $x$1 = $lhs.$name4;
                    $x$3 = $x$4.$name4;
                    $rhs = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($rhs);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($rhs, $rt_s(70)), $x$1), $rt_s(71)), $x$3);
                    $x$3 = jl_AbstractStringBuilder_toString($rhs);
                    $lhs_0 = $lhs.$name4;
                    $x$1 = $x$4.$name4;
                    $rhs = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($rhs);
                    jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($rhs, $rt_s(70)), $lhs_0), $rt_s(72)), $x$1), 41);
                    onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification__init_($x0$1, var$12, $x$3, jl_AbstractStringBuilder_toString($rhs));
                    s_Some__init_0($semanticTable$1, $x0$1);
                    oncir_Deprecation__init_($x$6, $rhs_0, $semanticTable$1);
                    s_Some__init_0($pattern, $x$6);
                    return $pattern;
                }
            }
        }
        if ($x0$1 instanceof oncia_SetIncludingPropertiesFromMapItem) {
            $pattern = $x0$1;
            $lhs_0 = $pattern.$variable0;
            $rhs = $pattern.$expression0;
            if ($lhs_0 !== null && $rhs instanceof oncie_Variable) {
                $rhs = $rhs;
                $x$4 = oncias_SemanticTable_typeFor($semanticTable$1, $rhs);
                $x$6 = sr_ScalaRunTime$_MODULE$;
                var$8 = $rt_createArray(oncius_CypherType, 2);
                var$9 = var$8.data;
                oncius_package$_$callClinit();
                var$9[0] = oncius_package$_CTNode(oncius_package$_MODULE$);
                var$9[1] = oncius_package$_CTRelationship(oncius_package$_MODULE$);
                if (oncias_SemanticTable$TypeGetter_isAnyOf($x$4, sr_ScalaRunTime$_wrapRefArray($x$6, var$8))) {
                    $x$3 = new s_Some;
                    $lhs = new oncir_Deprecation;
                    var$12 = new s_Some;
                    $rhs_0 = s_Predef$ArrowAssoc$_MODULE$;
                    s_Predef$_$callClinit();
                    $semanticTable$1 = onciu_Ref$_apply(onciu_Ref$_MODULE$, $pattern);
                    $x$4 = oncir_Deprecations$_org$neo4j$cypher$internal$rewriting$Deprecations$$functionInvocationForSetProperties(oncir_Deprecations$_MODULE$, $pattern, $rhs);
                    s_Some__init_0(var$12, s_Predef$ArrowAssoc$_$minus$greater$extension($rhs_0, $semanticTable$1, oncia_SetIncludingPropertiesFromMapItem_copy($pattern, $pattern.$variable0, $x$4, $pattern.$position1)));
                    $semanticTable$1 = new s_Some;
                    $x0$1 = new onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification;
                    $x$1 = $rhs.$position0;
                    $x$6 = $lhs_0.$name4;
                    $rhs_0 = $rhs.$name4;
                    $pattern = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($pattern);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($pattern, $rt_s(70)), $x$6), $rt_s(73)), $rhs_0);
                    $pattern = jl_AbstractStringBuilder_toString($pattern);
                    $x$6 = $lhs_0.$name4;
                    $rhs_0 = $rhs.$name4;
                    $rhs = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($rhs);
                    jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($rhs, $rt_s(70)), $x$6), $rt_s(74)), $rhs_0), 41);
                    onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification__init_($x0$1, $x$1, $pattern, jl_AbstractStringBuilder_toString($rhs));
                    s_Some__init_0($semanticTable$1, $x0$1);
                    oncir_Deprecation__init_($lhs, var$12, $semanticTable$1);
                    s_Some__init_0($x$3, $lhs);
                    return $x$3;
                }
            }
        }
        if (!($x0$1 instanceof oncia_Create))
            return s_None$_MODULE$;
        $pattern = $x0$1.$pattern;
        $x0$1 = oncias_Scope_allSymbolDefinitions($semanticTable$1.$recordedScopes1.$apply(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $pattern)));
        $rhs = onciu_Foldable_folder$($pattern);
        $pattern = new s_Tuple2;
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        $x$4 = sci_Set$EmptySet$_MODULE$;
        s_Predef$_Set(s_Predef$_MODULE$);
        s_Tuple2__init_0($pattern, $x$4, sci_Set$EmptySet$_MODULE$);
        $semanticTable$1 = new oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2;
        $semanticTable$1.$allSymbolDefinitions$1 = $x0$1;
        $semanticTable$1 = onciu_Foldable$Folder_treeFold($rhs, $pattern, $semanticTable$1);
        if ($semanticTable$1 === null)
            $rt_throw(s_MatchError__init_($semanticTable$1));
        $x0$1 = $semanticTable$1.$_10;
        $semanticTable$1 = $semanticTable$1.$_20;
        $pattern = s_Tuple2__init_($x0$1, $semanticTable$1);
        $semanticTable$1 = $pattern.$_10;
        return sc_AbstractIterable_collectFirst($pattern.$_20.$intersect($semanticTable$1), new oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$$nestedInanonfun$find$1$1);
    }
    var s_LowPriorityImplicits2 = $rt_classWithoutFields();
    var s_LowPriorityImplicits = $rt_classWithoutFields(s_LowPriorityImplicits2);
    function s_LowPriorityImplicits_wrapString($this, $s) {
        var var$2;
        if ($s === null)
            return null;
        var$2 = new sci_WrappedString;
        var$2.$scala$collection$immutable$WrappedString$$self = $s;
        return var$2;
    }
    var s_Predef$ = $rt_classWithoutFields(s_LowPriorityImplicits);
    var s_Predef$_MODULE$ = null;
    var s_Predef$_Map0 = null;
    var s_Predef$_Set0 = null;
    var s_Predef$_$minus$greater = null;
    var s_Predef$_Manifest = null;
    var s_Predef$_NoManifest = null;
    function s_Predef$_$callClinit() {
        s_Predef$_$callClinit = $rt_eraseClinit(s_Predef$);
        s_Predef$__clinit_();
    }
    function s_Predef$__clinit_() {
        var var$1;
        var$1 = new s_Predef$;
        s_Predef$_$callClinit();
        s_Predef$_MODULE$ = var$1;
        s_Predef$_Map0 = sci_Map$_MODULE$;
        s_Predef$_Set0 = sci_Set$_MODULE$;
        s_Predef$_$minus$greater = s_Tuple2$_MODULE$;
        sr_Manifest$_$callClinit();
        s_Predef$_Manifest = sr_Manifest$_MODULE$;
        s_Predef$_NoManifest = sr_NoManifest$_MODULE$;
    }
    function s_Predef$_Map($this) {
        s_Predef$_$callClinit();
        return s_Predef$_Map0;
    }
    function s_Predef$_Set($this) {
        s_Predef$_$callClinit();
        return s_Predef$_Set0;
    }
    function s_Predef$_assert($this, $assertion) {
        if ($assertion)
            return;
        $rt_throw(jl_AssertionError__init_($rt_s(75)));
    }
    function s_Predef$_require($this, $requirement) {
        var var$2;
        if ($requirement)
            return;
        var$2 = new jl_IllegalArgumentException;
        jl_Throwable__init_(var$2, $rt_s(76));
        $rt_throw(var$2);
    }
    function s_Predef$_$qmark$qmark$qmark($this) {
        var var$1;
        var$1 = new s_NotImplementedError;
        jl_Throwable__init_(var$1, $rt_s(77));
        $rt_throw(var$1);
    }
    function s_Predef$_ArrowAssoc($this, $self) {
        return $self;
    }
    function s_Predef$_augmentString($this, $x) {
        return $x;
    }
    function s_Predef$_println($this, $x) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        s_Console$_$callClinit();
        var$2 = s_Console$_out(s_Console$_MODULE$);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$2.$sb, $x), 10);
        $x = var$2.$sb;
        var$3 = $x.$length0;
        var$4 = var$2.$buffer0;
        if (var$3 > var$4.data.length)
            var$4 = $rt_createCharArray(var$3);
        var$5 = 0;
        var$6 = 0;
        if (var$5 > var$3) {
            $x = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_($x, $rt_s(78));
            $rt_throw($x);
        }
        while (var$5 < var$3) {
            var$7 = var$4.data;
            var$8 = var$6 + 1 | 0;
            var$9 = $x.$buffer.data;
            var$10 = var$5 + 1 | 0;
            var$7[var$6] = var$9[var$5];
            var$6 = var$8;
            var$5 = var$10;
        }
        ji_PrintStream_print(var$2, var$4, 0, var$3);
        var$2.$sb.$length0 = 0;
    }
    function s_Predef$_long2Long($this, $x) {
        return jl_Long_valueOf($x);
    }
    function s_Predef$_double2Double($this, $x) {
        return jl_Double_valueOf($x);
    }
    function s_Predef$_Integer2int($this, $x) {
        return sr_BoxesRunTime_unboxToInt($x);
    }
    function s_Predef$_Long2long($this, $x) {
        return sr_BoxesRunTime_unboxToLong($x);
    }
    function s_Predef$_$conforms($this) {
        return s_$less$colon$less$_singleton;
    }
    var jl_IndexOutOfBoundsException = $rt_classWithoutFields(jl_RuntimeException);
    function jl_IndexOutOfBoundsException__init_(var_0) {
        var var_1 = new jl_IndexOutOfBoundsException();
        jl_IndexOutOfBoundsException__init_0(var_1, var_0);
        return var_1;
    }
    function jl_IndexOutOfBoundsException__init_0($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var jl_StringIndexOutOfBoundsException = $rt_classWithoutFields(jl_IndexOutOfBoundsException);
    var sc_MapFactory = $rt_classWithoutFields(0);
    var sci_Map$ = $rt_classWithoutFields();
    var sci_Map$_MODULE$ = null;
    function sci_Map$__clinit_() {
        sci_Map$_MODULE$ = new sci_Map$;
    }
    function sci_Map$_from($this, $it) {
        if ($rt_isInstance($it, sci_Iterable) && $it.$isEmpty())
            return sci_Map$EmptyMap$_MODULE$;
        if ($rt_isInstance($it, sci_Map))
            return $it;
        return sci_MapBuilderImpl_result(sci_MapBuilderImpl_addAll(sci_MapBuilderImpl__init_(), $it));
    }
    function sci_Map$_newBuilder($this) {
        return sci_MapBuilderImpl__init_();
    }
    function sci_Map$_from0($this, $it) {
        return sci_Map$_from($this, $it);
    }
    function sci_Map$_empty($this) {
        return sci_Map$EmptyMap$_MODULE$;
    }
    function jl_Enum() {
        var a = this; jl_Object.call(a);
        a.$name5 = null;
        a.$ordinal = 0;
    }
    function jl_Enum__init_($this, $name, $ordinal) {
        $this.$name5 = $name;
        $this.$ordinal = $ordinal;
    }
    function jl_Enum_ordinal($this) {
        return $this.$ordinal;
    }
    function jl_Enum_toString($this) {
        return $this.$name5;
    }
    function jl_Enum_equals($this, $other) {
        return $this !== $other ? 0 : 1;
    }
    function jl_Enum_hashCode($this) {
        return jl_Object_identity($this);
    }
    function jl_Enum_getDeclaringClass($this) {
        var $result;
        $result = jl_Object_getClass($this);
        if (!jl_Object_equals(jl_Class_getSuperclass($result), $rt_cls(jl_Enum)))
            $result = jl_Class_getSuperclass($result);
        return $result;
    }
    var oncifp_CompilationPhaseTracer$CompilationPhase = $rt_classWithoutFields(jl_Enum);
    var oncifp_CompilationPhaseTracer$CompilationPhase_PARSING = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_DEPRECATION_WARNINGS = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_ADDITION_ERRORS = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_CHECK = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_TYPE_CHECK = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_AST_REWRITE = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_LOGICAL_PLANNING = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_CODE_GENERATION = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_PIPE_BUILDING = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_METADATA_COLLECTION = null;
    var oncifp_CompilationPhaseTracer$CompilationPhase_$VALUES = null;
    function oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit() {
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit = $rt_eraseClinit(oncifp_CompilationPhaseTracer$CompilationPhase);
        oncifp_CompilationPhaseTracer$CompilationPhase__clinit_();
    }
    function oncifp_CompilationPhaseTracer$CompilationPhase__init_(var_0, var_1) {
        var var_2 = new oncifp_CompilationPhaseTracer$CompilationPhase();
        oncifp_CompilationPhaseTracer$CompilationPhase__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function oncifp_CompilationPhaseTracer$CompilationPhase_values() {
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        return oncifp_CompilationPhaseTracer$CompilationPhase_$VALUES.$clone();
    }
    function oncifp_CompilationPhaseTracer$CompilationPhase__init_0($this, var$1, var$2) {
        oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    }
    function oncifp_CompilationPhaseTracer$CompilationPhase__clinit_() {
        var var$1;
        oncifp_CompilationPhaseTracer$CompilationPhase_PARSING = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(79), 0);
        oncifp_CompilationPhaseTracer$CompilationPhase_DEPRECATION_WARNINGS = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(80), 1);
        oncifp_CompilationPhaseTracer$CompilationPhase_ADDITION_ERRORS = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(81), 2);
        oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_CHECK = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(82), 3);
        oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_TYPE_CHECK = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(83), 4);
        oncifp_CompilationPhaseTracer$CompilationPhase_AST_REWRITE = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(84), 5);
        oncifp_CompilationPhaseTracer$CompilationPhase_LOGICAL_PLANNING = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(85), 6);
        oncifp_CompilationPhaseTracer$CompilationPhase_CODE_GENERATION = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(86), 7);
        oncifp_CompilationPhaseTracer$CompilationPhase_PIPE_BUILDING = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(87), 8);
        var$1 = oncifp_CompilationPhaseTracer$CompilationPhase__init_($rt_s(88), 9);
        oncifp_CompilationPhaseTracer$CompilationPhase_METADATA_COLLECTION = var$1;
        oncifp_CompilationPhaseTracer$CompilationPhase_$VALUES = $rt_createArrayFromData(oncifp_CompilationPhaseTracer$CompilationPhase, [oncifp_CompilationPhaseTracer$CompilationPhase_PARSING, oncifp_CompilationPhaseTracer$CompilationPhase_DEPRECATION_WARNINGS, oncifp_CompilationPhaseTracer$CompilationPhase_ADDITION_ERRORS, oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_CHECK, oncifp_CompilationPhaseTracer$CompilationPhase_SEMANTIC_TYPE_CHECK, oncifp_CompilationPhaseTracer$CompilationPhase_AST_REWRITE,
        oncifp_CompilationPhaseTracer$CompilationPhase_LOGICAL_PLANNING, oncifp_CompilationPhaseTracer$CompilationPhase_CODE_GENERATION, oncifp_CompilationPhaseTracer$CompilationPhase_PIPE_BUILDING, var$1]);
    }
    var onciap_ExpressionStringifier$ = $rt_classWithoutFields();
    var onciap_ExpressionStringifier$_MODULE$ = null;
    var onciap_ExpressionStringifier$_failingExtender = null;
    function onciap_ExpressionStringifier$__clinit_() {
        onciap_ExpressionStringifier$_MODULE$ = new onciap_ExpressionStringifier$;
        onciap_ExpressionStringifier$_failingExtender = new onciap_ExpressionStringifier$$_clinit_$lambda$_0_0;
    }
    function onciap_ExpressionStringifier$_apply($this, $extender, $alwaysParens, $alwaysBacktick, $preferSingleQuotes, $sensitiveParamsAsParams) {
        var var$6, var$7;
        var$6 = new onciap_DefaultExpressionStringifier;
        var$7 = new onciap_ExpressionStringifier$Extension$$anon$1;
        var$7.$func$1 = $extender;
        var$6.$extension = var$7;
        var$6.$alwaysParens = $alwaysParens;
        var$6.$alwaysBacktick = $alwaysBacktick;
        var$6.$preferSingleQuotes = $preferSingleQuotes;
        var$6.$sensitiveParamsAsParams = $sensitiveParamsAsParams;
        var$6.$patterns = onciap_PatternStringifier$_apply(onciap_PatternStringifier$_MODULE$, var$6);
        $extender = new onciap_DefaultPathStepStringifier;
        $extender.$expr = var$6;
        var$6.$pathSteps = $extender;
        var$6.$prettifier = onciap_Prettifier__init_(var$6, onciap_Prettifier$EmptyExtension$_MODULE$, 1);
        return var$6;
    }
    function onciap_ExpressionStringifier$_apply$default$2($this) {
        return 0;
    }
    function onciap_ExpressionStringifier$_apply$default$3($this) {
        return 0;
    }
    function onciap_ExpressionStringifier$_apply$default$4($this) {
        return 0;
    }
    function onciap_ExpressionStringifier$_apply$default$5($this) {
        return 0;
    }
    function onciap_ExpressionStringifier$_backtick($this, $txt, $alwaysBacktick, $globbing) {
        var var$4;
        var$4 = jl_String_replaceAll($txt, $rt_s(89), $rt_s(90));
        $txt = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($txt);
        jl_AbstractStringBuilder_append($txt, 96);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append($txt, var$4), 96);
        return jl_AbstractStringBuilder_toString($txt);
    }
    var sr_AbstractPartialFunction = $rt_classWithoutFields();
    function sr_AbstractPartialFunction_orElse($this, $that) {
        var var$2;
        var$2 = new s_PartialFunction$OrElse;
        var$2.$f10 = $this;
        var$2.$f20 = $that;
        return var$2;
    }
    function sr_AbstractPartialFunction_andThen($this, $k) {
        var var$2;
        if ($rt_isInstance($k, s_PartialFunction))
            var$2 = sr_AbstractPartialFunction_andThen0($this, $k);
        else {
            var$2 = new s_PartialFunction$AndThen;
            var$2.$pf1 = $this;
            var$2.$k = $k;
        }
        return var$2;
    }
    function sr_AbstractPartialFunction_andThen0($this, $k) {
        var var$2;
        var$2 = new s_PartialFunction$Combined;
        var$2.$pf2 = $this;
        var$2.$k0 = $k;
        return var$2;
    }
    function sr_AbstractPartialFunction_lift($this) {
        return s_PartialFunction_lift$($this);
    }
    function sr_AbstractPartialFunction_runWith($this, $action) {
        var var$2;
        var$2 = new s_PartialFunction$runWith$lambda$_22_0;
        var$2.$_037 = $this;
        var$2.$_112 = $action;
        return var$2;
    }
    function sr_AbstractPartialFunction_apply($this, $x) {
        return $this.$applyOrElse($x, s_PartialFunction$_empty_pf);
    }
    var oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1_applyOrElse($this, $x1, $default) {
        var $lhs, $variable, $labelExpression, $rhs, $relPat, $properties, $rewrittenExpression, $x$1, $single, $predicate, $direction, $newRelPat, $deprecated, $replacement, $nn, $namespace, $name;
        if ($x1 instanceof oncie_RelationshipPattern) {
            $lhs = $x1;
            $variable = oncie_RelationshipPattern_variable($lhs);
            $labelExpression = oncie_RelationshipPattern_labelExpression($lhs);
            $rhs = oncie_RelationshipPattern_length($lhs);
            $relPat = oncie_RelationshipPattern_properties($lhs);
            $properties = oncie_RelationshipPattern_predicate($lhs);
            if ($labelExpression instanceof s_Some) {
                $labelExpression = s_Some_value($labelExpression);
                if (jl_Object_equals(s_None$_MODULE$, $rhs) && jl_Object_equals(s_None$_MODULE$, $relPat) && jl_Object_equals(s_None$_MODULE$, $properties) && s_Option_forall($variable, oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0__init_()) && !$labelExpression.$containsGpmSpecificRelTypeExpression()) {
                    $rhs = $labelExpression.$folder();
                    sr_ClassTag$_$callClinit();
                    if (s_Option_nonEmpty(onciu_Foldable$Folder_treeFindByClass($rhs, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncil_LabelExpression$ColonDisjunction))))) {
                        $rewrittenExpression = $labelExpression.$replaceColonSyntax();
                        $rhs = new oncir_Deprecation;
                        $relPat = new s_Some;
                        $x1 = s_Predef$ArrowAssoc$_MODULE$;
                        s_Predef$_$callClinit();
                        $default = s_Predef$_ArrowAssoc(s_Predef$_MODULE$, onciu_Ref$_apply(onciu_Ref$_MODULE$, $lhs));
                        $x$1 = s_Some__init_($rewrittenExpression);
                        s_Some__init_0($relPat, s_Predef$ArrowAssoc$_$minus$greater$extension($x1, $default, oncie_RelationshipPattern_copy($lhs, oncie_RelationshipPattern_copy$default$1($lhs), $x$1, oncie_RelationshipPattern_copy$default$3($lhs), oncie_RelationshipPattern_copy$default$4($lhs), oncie_RelationshipPattern_copy$default$5($lhs), oncie_RelationshipPattern_copy$default$6($lhs), oncie_RelationshipPattern_position($lhs))));
                        $x1 = new s_Some;
                        $default = new onciu_DeprecatedRelTypeSeparatorNotification;
                        $variable = oncil_LabelExpression$ColonDisjunction_position((onciu_Foldable$Folder_treeFindByClass($labelExpression.$folder(), sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncil_LabelExpression$ColonDisjunction)))).$get0());
                        oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
                        $lhs = onciap_DefaultExpressionStringifier_stringifyLabelExpression(oncir_Deprecations$syntacticallyDeprecatedFeatures$_stringifier0(oncir_Deprecations$syntacticallyDeprecatedFeatures$_MODULE$), $labelExpression);
                        $labelExpression = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append4($labelExpression, 58), $lhs);
                        $labelExpression = jl_StringBuilder_toString($labelExpression);
                        $lhs = onciap_DefaultExpressionStringifier_stringifyLabelExpression(oncir_Deprecations$syntacticallyDeprecatedFeatures$_stringifier0(oncir_Deprecations$syntacticallyDeprecatedFeatures$_MODULE$), $rewrittenExpression);
                        $properties = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append4($properties, 58), $lhs);
                        onciu_DeprecatedRelTypeSeparatorNotification__init_($default, $variable, $labelExpression, jl_StringBuilder_toString($properties));
                        s_Some__init_0($x1, $default);
                        oncir_Deprecation__init_($rhs, $relPat, $x1);
                        return $rhs;
                    }
                }
            }
        }
        if ($x1 instanceof oncia_UnionAll) {
            $variable = $x1;
            $lhs = oncia_UnionAll_lhs($variable);
            $rhs = oncia_UnionAll_rhs($variable);
            if ($lhs !== null && $rhs !== null && oncir_Deprecations$_org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder(oncir_Deprecations$_MODULE$, $lhs, $rhs))
                return oncir_Deprecation__init_0(s_None$_MODULE$, s_Some__init_(onciu_UnionReturnItemsInDifferentOrder__init_($lhs.$position2())));
        }
        if ($x1 instanceof oncia_UnionDistinct) {
            $variable = $x1;
            $lhs = oncia_UnionDistinct_lhs($variable);
            $rhs = oncia_UnionDistinct_rhs($variable);
            if ($lhs !== null && $rhs !== null && oncir_Deprecations$_org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder(oncir_Deprecations$_MODULE$, $lhs, $rhs))
                return oncir_Deprecation__init_0(s_None$_MODULE$, s_Some__init_(onciu_UnionReturnItemsInDifferentOrder__init_($lhs.$position2())));
        }
        if ($x1 instanceof oncie_ShortestPathsPatternPart) {
            $variable = $x1;
            $lhs = oncie_ShortestPathsPatternPart_element($variable);
            $single = oncie_ShortestPathsPatternPart_single($variable);
            if ($lhs instanceof oncie_RelationshipChain) {
                $variable = $lhs;
                $relPat = oncie_RelationshipChain_relationship($variable);
                if (oncie_RelationshipChain_element($variable) instanceof oncie_NodePattern && $relPat !== null) {
                    $variable = oncie_RelationshipPattern_variable($relPat);
                    $labelExpression = oncie_RelationshipPattern_labelExpression($relPat);
                    $lhs = oncie_RelationshipPattern_length($relPat);
                    $properties = oncie_RelationshipPattern_properties($relPat);
                    $predicate = oncie_RelationshipPattern_predicate($relPat);
                    $direction = oncie_RelationshipPattern_direction($relPat);
                    if (jl_Object_equals(s_None$_MODULE$, $lhs)) {
                        $newRelPat = oncie_RelationshipPattern__init_($variable, $labelExpression, s_Some__init_(s_Some__init_(oncie_Range__init_(s_Some__init_(oncie_UnsignedDecimalIntegerLiteral__init_($rt_s(91), oncie_RelationshipPattern_position($relPat))), s_Some__init_(oncie_UnsignedDecimalIntegerLiteral__init_($rt_s(91), oncie_RelationshipPattern_position($relPat))), oncie_RelationshipPattern_position($relPat)))), $properties, $predicate, $direction, oncie_RelationshipPattern_position($relPat));
                        if (!$single) {
                            $x1 = oncie_RelationshipPattern_asCanonicalStringVal($relPat);
                            $default = jl_StringBuilder__init_1();
                            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($default, $rt_s(92)), $x1), 41);
                            $deprecated = jl_StringBuilder_toString($default);
                        } else {
                            $x1 = oncie_RelationshipPattern_asCanonicalStringVal($relPat);
                            $default = jl_StringBuilder__init_1();
                            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($default, $rt_s(93)), $x1), 41);
                            $deprecated = jl_StringBuilder_toString($default);
                        }
                        if (!$single) {
                            $x1 = oncie_RelationshipPattern_asCanonicalStringVal($newRelPat);
                            $default = jl_StringBuilder__init_1();
                            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($default, $rt_s(92)), $x1), 41);
                            $replacement = jl_StringBuilder_toString($default);
                        } else {
                            $x1 = oncie_RelationshipPattern_asCanonicalStringVal($newRelPat);
                            $default = jl_StringBuilder__init_1();
                            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($default, $rt_s(93)), $x1), 41);
                            $replacement = jl_StringBuilder_toString($default);
                        }
                        return oncir_Deprecation__init_0(s_None$_MODULE$, s_Some__init_(onciu_FixedLengthRelationshipInShortestPath__init_(oncie_RelationshipPattern_position($relPat), $deprecated, $replacement)));
                    }
                }
            }
        }
        if ($x1 instanceof oncia_CreateDatabase) {
            $variable = $x1;
            $nn = oncia_CreateDatabase_dbName($variable);
            if ($nn instanceof oncia_NamespacedName) {
                $lhs = $nn;
                if (oncia_NamespacedName_namespace($lhs) instanceof s_Some)
                    return oncir_Deprecation__init_0(s_None$_MODULE$, s_Some__init_(onciu_DeprecatedDatabaseNameNotification__init_(oncia_NamespacedName_toString($lhs), s_Some__init_(oncia_CreateDatabase_position($variable)))));
            }
        }
        if ($x1 instanceof oncia_CreateTextNodeIndex) {
            $variable = $x1;
            oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
            if (oncir_Deprecations$syntacticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider(oncir_Deprecations$syntacticallyDeprecatedFeatures$_MODULE$, oncia_CreateTextNodeIndex_options($variable)))
                return oncir_Deprecation__init_0(s_None$_MODULE$, s_Some__init_(onciu_DeprecatedTextIndexProvider__init_(oncia_CreateTextNodeIndex_position($variable))));
        }
        if ($x1 instanceof oncia_CreateTextRelationshipIndex) {
            $variable = $x1;
            oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
            if (oncir_Deprecations$syntacticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider(oncir_Deprecations$syntacticallyDeprecatedFeatures$_MODULE$, oncia_CreateTextRelationshipIndex_options($variable)))
                return oncir_Deprecation__init_0(s_None$_MODULE$, s_Some__init_(onciu_DeprecatedTextIndexProvider__init_(oncia_CreateTextRelationshipIndex_position($variable))));
        }
        if ($x1 instanceof oncie_FunctionInvocation) {
            $variable = $x1;
            $namespace = oncie_FunctionInvocation_namespace($variable);
            $lhs = oncie_FunctionInvocation_functionName($variable);
            if ($lhs !== null) {
                $name = oncie_FunctionName_name($lhs);
                if (sci_List_isEmpty(oncie_Namespace_parts($namespace)) && jl_String_equalsIgnoreCase($name, $rt_s(94)))
                    return oncir_Deprecation__init_0(s_None$_MODULE$, s_Some__init_(onciu_DeprecatedFunctionNotification__init_(oncie_FunctionInvocation_position($variable), $rt_s(94), null)));
            }
        }
        return s_PartialFunction$$_clinit_$lambda$_0_0_apply($default, $x1);
    }
    var onciu_StepSequencer = $rt_classWithoutFields();
    var sr_ScalaRunTime$ = $rt_classWithoutFields();
    var sr_ScalaRunTime$_MODULE$ = null;
    function sr_ScalaRunTime$__clinit_() {
        sr_ScalaRunTime$_MODULE$ = new sr_ScalaRunTime$;
    }
    function sr_ScalaRunTime$_array_apply($this, $xs, $idx) {
        if ($rt_isInstance($xs, $rt_arraycls(jl_Object)))
            return $xs.data[$idx];
        if ($rt_isInstance($xs, $rt_arraycls($rt_intcls())))
            return jl_Integer_valueOf($xs.data[$idx]);
        if ($rt_isInstance($xs, $rt_arraycls($rt_doublecls())))
            return jl_Double_valueOf($xs.data[$idx]);
        if ($rt_isInstance($xs, $rt_arraycls($rt_longcls())))
            return jl_Long_valueOf($xs.data[$idx]);
        if ($rt_isInstance($xs, $rt_arraycls($rt_floatcls())))
            return jl_Float_valueOf($xs.data[$idx]);
        if ($rt_isInstance($xs, $rt_arraycls($rt_charcls())))
            return jl_Character_valueOf($xs.data[$idx]);
        if ($rt_isInstance($xs, $rt_arraycls($rt_bytecls())))
            return jl_Byte_valueOf($xs.data[$idx]);
        if ($rt_isInstance($xs, $rt_arraycls($rt_shortcls())))
            return jl_Short_valueOf($xs.data[$idx]);
        if ($rt_isInstance($xs, $rt_arraycls($rt_booleancls())))
            return jl_Boolean_valueOf($xs.data[$idx]);
        if ($xs !== null)
            $rt_throw(s_MatchError__init_($xs));
        $xs = new jl_NullPointerException;
        jl_Throwable__init_0($xs);
        $rt_throw($xs);
    }
    function sr_ScalaRunTime$_array_update($this, $xs, $idx, $value) {
        if ($rt_isInstance($xs, $rt_arraycls(jl_Object))) {
            $xs.data[$idx] = $value;
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_intcls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToInt($value);
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_doublecls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToDouble($value);
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_longcls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToLong($value);
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_floatcls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToFloat($value);
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_charcls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToChar($value);
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_bytecls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToByte($value);
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_shortcls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToShort($value);
            return;
        }
        if ($rt_isInstance($xs, $rt_arraycls($rt_booleancls()))) {
            $xs.data[$idx] = sr_BoxesRunTime_unboxToBoolean($value);
            return;
        }
        if ($xs !== null)
            $rt_throw(s_MatchError__init_($xs));
        $xs = new jl_NullPointerException;
        jl_Throwable__init_0($xs);
        $rt_throw($xs);
    }
    function sr_ScalaRunTime$__toString($this, $x) {
        var var$2, var$3;
        var$2 = $x.$productIterator();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 1);
        jl_AbstractStringBuilder_append1(var$3, $x.$productPrefix());
        jl_AbstractStringBuilder_append1(var$3, $rt_s(24));
        return sc_IterableOnceOps_mkString$(var$2, jl_AbstractStringBuilder_toString(var$3), $rt_s(43), $rt_s(25));
    }
    function sr_ScalaRunTime$__hashCode($this, $x) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $x);
    }
    function sr_ScalaRunTime$_typedProductIterator($this, $x) {
        return sr_ScalaRunTime$$anon$1__init_($x);
    }
    function sr_ScalaRunTime$_genericWrapArray($this, $xs) {
        if ($xs === null)
            return null;
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, $xs);
    }
    function sr_ScalaRunTime$_wrapRefArray($this, $xs) {
        var var$2;
        if ($xs === null)
            return null;
        if ($xs.data.length)
            return sci_ArraySeq$ofRef__init_($xs);
        var$2 = sci_ArraySeq$_MODULE$;
        sr_ClassTag$_$callClinit();
        return sci_ArraySeq$_empty(var$2, sr_ClassTag$_AnyRef(sr_ClassTag$_MODULE$));
    }
    var oncirrf_PreparatoryRewritingRewriterFactory = $rt_classWithoutFields(0);
    var oncirr_normalizeWithAndReturnClauses$ = $rt_classWithoutFields();
    var oncirr_normalizeWithAndReturnClauses$_MODULE$ = null;
    function oncirr_normalizeWithAndReturnClauses$__clinit_() {
        oncirr_normalizeWithAndReturnClauses$_MODULE$ = new oncirr_normalizeWithAndReturnClauses$;
    }
    function oncirr_normalizeWithAndReturnClauses$_getRewriter($this, $cypherExceptionFactory) {
        var var$2, var$3, var$4;
        var$2 = new oncirr_normalizeWithAndReturnClauses;
        var$2.$cypherExceptionFactory0 = $cypherExceptionFactory;
        var$3 = onciu_topDown$_MODULE$;
        onciu_Rewriter$_$callClinit();
        $cypherExceptionFactory = onciu_Rewriter$_MODULE$;
        var$4 = new oncirr_normalizeWithAndReturnClauses$$anonfun$1;
        var$4.$$outer1 = var$2;
        var$2.$rewriteProjectionsRecursively = onciu_topDown$_apply(var$3, onciu_Rewriter$_lift($cypherExceptionFactory, var$4), onciu_topDown$_apply$default$2(onciu_topDown$_MODULE$), 1, onciu_CancellationChecker$NeverCancelled$_MODULE$);
        return var$2;
    }
    function oncirr_normalizeWithAndReturnClauses$_preConditions($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncirr_normalizeWithAndReturnClauses$_postConditions($this) {
        s_Predef$_$callClinit();
        return (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(onciu_StepSequencer$Condition, [oncirr_ReturnItemsAreAliased$_MODULE$, oncirr_ExpressionsInOrderByAndWhereUseAliases$_MODULE$])));
    }
    function oncirr_normalizeWithAndReturnClauses$_invalidatedConditions($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$);
    }
    function oncirr_normalizeWithAndReturnClauses$_productArity($this) {
        return 0;
    }
    function oncirr_normalizeWithAndReturnClauses$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_normalizeWithAndReturnClauses$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_normalizeWithAndReturnClauses$_hashCode($this) {
        return 914433168;
    }
    function oncirr_normalizeWithAndReturnClauses$_toString($this) {
        return $rt_s(95);
    }
    var oncirr_insertWithBetweenOptionalMatchAndMatch$ = $rt_classWithoutFields();
    var oncirr_insertWithBetweenOptionalMatchAndMatch$_MODULE$ = null;
    var oncirr_insertWithBetweenOptionalMatchAndMatch$_instance = null;
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_$callClinit() {
        oncirr_insertWithBetweenOptionalMatchAndMatch$_$callClinit = $rt_eraseClinit(oncirr_insertWithBetweenOptionalMatchAndMatch$);
        oncirr_insertWithBetweenOptionalMatchAndMatch$__clinit_();
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$__clinit_() {
        var var$1, var$2;
        var$1 = new oncirr_insertWithBetweenOptionalMatchAndMatch$;
        oncirr_insertWithBetweenOptionalMatchAndMatch$_$callClinit();
        oncirr_insertWithBetweenOptionalMatchAndMatch$_MODULE$ = var$1;
        var$2 = onciu_topDown$_MODULE$;
        onciu_Rewriter$_$callClinit();
        oncirr_insertWithBetweenOptionalMatchAndMatch$_instance = onciu_topDown$_apply(var$2, onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1), onciu_topDown$_apply$default$2(onciu_topDown$_MODULE$), 1, onciu_CancellationChecker$NeverCancelled$_MODULE$);
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_preConditions($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirr_WithBetweenOptionalMatchAndMatchInserted$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_invalidatedConditions($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$);
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_getRewriter($this, $cypherExceptionFactory) {
        oncirr_insertWithBetweenOptionalMatchAndMatch$_$callClinit();
        return oncirr_insertWithBetweenOptionalMatchAndMatch$_instance;
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_productArity($this) {
        return 0;
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_hashCode($this) {
        return (-1180736726);
    }
    function oncirr_insertWithBetweenOptionalMatchAndMatch$_toString($this) {
        return $rt_s(96);
    }
    var oncirr_expandCallWhere$ = $rt_classWithoutFields();
    var oncirr_expandCallWhere$_MODULE$ = null;
    var oncirr_expandCallWhere$_instance = null;
    function oncirr_expandCallWhere$_$callClinit() {
        oncirr_expandCallWhere$_$callClinit = $rt_eraseClinit(oncirr_expandCallWhere$);
        oncirr_expandCallWhere$__clinit_();
    }
    function oncirr_expandCallWhere$__clinit_() {
        var var$1, var$2;
        var$1 = new oncirr_expandCallWhere$;
        oncirr_expandCallWhere$_$callClinit();
        oncirr_expandCallWhere$_MODULE$ = var$1;
        var$2 = onciu_bottomUp$_MODULE$;
        onciu_Rewriter$_$callClinit();
        oncirr_expandCallWhere$_instance = onciu_bottomUp$_apply(var$2, onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncirr_expandCallWhere$$anonfun$1), onciu_bottomUp$_apply$default$2(onciu_bottomUp$_MODULE$), onciu_CancellationChecker$NeverCancelled$_MODULE$);
    }
    function oncirr_expandCallWhere$_preConditions($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncirr_expandCallWhere$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirr_WithBetweenCallAndWhereInserted$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_expandCallWhere$_invalidatedConditions($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$);
    }
    function oncirr_expandCallWhere$_getRewriter($this, $cypherExceptionFactory) {
        oncirr_expandCallWhere$_$callClinit();
        return oncirr_expandCallWhere$_instance;
    }
    function oncirr_expandCallWhere$_productArity($this) {
        return 0;
    }
    function oncirr_expandCallWhere$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_expandCallWhere$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_expandCallWhere$_hashCode($this) {
        return 918629295;
    }
    function oncirr_expandCallWhere$_toString($this) {
        return $rt_s(97);
    }
    var oncirr_expandShowWhere$ = $rt_classWithoutFields();
    var oncirr_expandShowWhere$_MODULE$ = null;
    var oncirr_expandShowWhere$_instance = null;
    function oncirr_expandShowWhere$_$callClinit() {
        oncirr_expandShowWhere$_$callClinit = $rt_eraseClinit(oncirr_expandShowWhere$);
        oncirr_expandShowWhere$__clinit_();
    }
    function oncirr_expandShowWhere$__clinit_() {
        var var$1, var$2;
        var$1 = new oncirr_expandShowWhere$;
        oncirr_expandShowWhere$_$callClinit();
        oncirr_expandShowWhere$_MODULE$ = var$1;
        var$2 = onciu_bottomUp$_MODULE$;
        onciu_Rewriter$_$callClinit();
        oncirr_expandShowWhere$_instance = onciu_bottomUp$_apply(var$2, onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncirr_expandShowWhere$$anonfun$1), onciu_bottomUp$_apply$default$2(onciu_bottomUp$_MODULE$), onciu_CancellationChecker$NeverCancelled$_MODULE$);
    }
    function oncirr_expandShowWhere$_preConditions($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncirr_expandShowWhere$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirr_WithBetweenShowAndWhereInserted$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_expandShowWhere$_invalidatedConditions($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$);
    }
    function oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield($this, $where, $defaultColumns) {
        var var$3, var$4, var$5, var$6, var$7;
        var$3 = new s_Some;
        s_package$_$callClinit();
        var$4 = s_package$_Left(s_package$_MODULE$);
        var$5 = new s_Tuple2;
        var$6 = new oncia_Yield;
        var$7 = oncia_ReturnItems__init_(1, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), s_Some__init_($defaultColumns), $where.$position3);
        $defaultColumns = s_None$_MODULE$;
        oncia_Yield__init_(var$6, var$7, $defaultColumns, $defaultColumns, $defaultColumns, s_Some__init_($where), $where.$position3);
        s_Tuple2__init_0(var$5, var$6, s_None$_MODULE$);
        s_Some__init_0(var$3, su_Left$_apply(var$4, var$5));
        return var$3;
    }
    function oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns($this, $yieldClause, $maybeReturn, $defaultColumns) {
        var $yieldColumns, $newYield, $newReturn;
        $yieldColumns = $yieldClause.$returnItems;
        if (!$yieldColumns.$includeExisting)
            $defaultColumns = s_Tuple2__init_($yieldClause, ($yieldColumns.$items.$map1(new oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_0)).$toList());
        else {
            $newYield = $yieldColumns.$defaultOrderOnColumns;
            $yieldColumns = new oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_1;
            $yieldColumns.$_038 = $defaultColumns;
            $yieldColumns = s_Option_getOrElse($newYield, $yieldColumns);
            $defaultColumns = s_Tuple2__init_(oncia_Yield_copy($yieldClause, oncia_ReturnItems_withDefaultOrderOnColumns($yieldClause.$returnItems, $yieldColumns), $yieldClause.$orderBy, $yieldClause.$skip, $yieldClause.$limit, $yieldClause.$where, $yieldClause.$position4), $yieldColumns);
        }
        $newYield = $defaultColumns.$_10;
        $yieldColumns = $defaultColumns.$_20;
        $yieldClause = s_Tuple2__init_($newYield, $yieldColumns);
        $newYield = $yieldClause.$_10;
        $yieldColumns = $yieldClause.$_20;
        $yieldClause = new oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_2;
        $yieldClause.$_039 = $yieldColumns;
        $newReturn = s_Option_map($maybeReturn, $yieldClause);
        $yieldClause = new s_Some;
        s_package$_$callClinit();
        $maybeReturn = s_package$_Left(s_package$_MODULE$);
        $defaultColumns = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        s_Some__init_0($yieldClause, su_Left$_apply($maybeReturn, s_Predef$ArrowAssoc$_$minus$greater$extension($defaultColumns, $newYield, $newReturn)));
        return $yieldClause;
    }
    function oncirr_expandShowWhere$_getRewriter($this, $cypherExceptionFactory) {
        oncirr_expandShowWhere$_$callClinit();
        return oncirr_expandShowWhere$_instance;
    }
    function oncirr_expandShowWhere$_productArity($this) {
        return 0;
    }
    function oncirr_expandShowWhere$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_expandShowWhere$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_expandShowWhere$_hashCode($this) {
        return 61363824;
    }
    function oncirr_expandShowWhere$_toString($this) {
        return $rt_s(98);
    }
    var oncirr_rewriteShowQuery$ = $rt_classWithoutFields();
    var oncirr_rewriteShowQuery$_MODULE$ = null;
    var oncirr_rewriteShowQuery$_instance = null;
    function oncirr_rewriteShowQuery$_$callClinit() {
        oncirr_rewriteShowQuery$_$callClinit = $rt_eraseClinit(oncirr_rewriteShowQuery$);
        oncirr_rewriteShowQuery$__clinit_();
    }
    function oncirr_rewriteShowQuery$__clinit_() {
        var var$1, var$2;
        var$1 = new oncirr_rewriteShowQuery$;
        oncirr_rewriteShowQuery$_$callClinit();
        oncirr_rewriteShowQuery$_MODULE$ = var$1;
        var$2 = onciu_bottomUp$_MODULE$;
        onciu_Rewriter$_$callClinit();
        oncirr_rewriteShowQuery$_instance = onciu_bottomUp$_apply(var$2, onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncirr_rewriteShowQuery$$anonfun$1), onciu_bottomUp$_apply$default$2(onciu_bottomUp$_MODULE$), onciu_CancellationChecker$NeverCancelled$_MODULE$);
    }
    function oncirr_rewriteShowQuery$_preConditions($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncirr_rewriteShowQuery$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirr_ShowRewrittenToShowYieldWhereReturn$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_rewriteShowQuery$_invalidatedConditions($this) {
        s_Predef$_$callClinit();
        return (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(onciu_StepSequencer$Condition, [oncirc_containsNoReturnAll$_MODULE$, oncirr_ProjectionClausesHaveSemanticInfo$_MODULE$])));
    }
    function oncirr_rewriteShowQuery$_org$neo4j$cypher$internal$rewriting$rewriters$rewriteShowQuery$$rewriteClauses($this, $clauses, $rewrittenClause) {
        var var$3, var$4, $commandClause, $commandClause_0, var$7, var$8, $yieldClause, $returnClause, $c, var$12, $withClause;
        while (true) {
            var$3 = 0;
            var$4 = null;
            if ($clauses instanceof sci_$colon$colon) {
                var$3 = 1;
                var$4 = $clauses;
                $commandClause = var$4.$head0;
                $commandClause_0 = var$4.$next0;
                if ($rt_isInstance($commandClause, oncia_TransactionsCommandClause)) {
                    var$7 = $commandClause;
                    if (sci_List_equals(sci_Nil$_MODULE$, $commandClause_0)) {
                        var$8 = var$7.$where0();
                        $yieldClause = sci_List_map((var$7.$unfilteredColumns()).$columns0, new oncirr_rewriteShowQuery$$rewriteToWithAndReturn$lambda$_12_0);
                        $returnClause = new sci_$colon$colon;
                        $c = var$7.$moveWhereToYield();
                        $clauses = new sci_$colon$colon;
                        $commandClause_0 = new oncia_With;
                        $commandClause = oncia_ReturnItems__init_(1, sci_Nil$_MODULE$, s_Some__init_($yieldClause), var$7.$position2());
                        var$4 = s_None$_MODULE$;
                        oncia_With__init_($commandClause_0, 0, $commandClause, var$4, var$4, var$4, var$8, oncia_AddedInRewrite$_MODULE$, var$7.$position2());
                        sci_$colon$colon__init_0($clauses, $commandClause_0, sci_$colon$colon__init_(oncirr_rewriteShowQuery$_returnClause($this, var$7.$position2(), $yieldClause), sci_Nil$_MODULE$));
                        sci_$colon$colon__init_0($returnClause, $c, $clauses);
                        return $rewrittenClause.$concat0($returnClause);
                    }
                }
            }
            if (var$3) {
                $commandClause = var$4.$head0;
                $commandClause_0 = var$4.$next0;
                if ($rt_isInstance($commandClause, oncia_CommandClause)) {
                    $commandClause = $commandClause;
                    if (sci_List_equals(sci_Nil$_MODULE$, $commandClause_0)) {
                        $commandClause_0 = $commandClause.$where0();
                        $c = sci_List_map(($commandClause.$unfilteredColumns()).$columns0, new oncirr_rewriteShowQuery$$rewriteWithYieldAndReturn$lambda$_11_0);
                        var$12 = new sci_$colon$colon;
                        var$7 = $commandClause.$moveWhereToYield();
                        $clauses = new sci_$colon$colon;
                        var$4 = new oncia_Yield;
                        $withClause = oncia_ReturnItems__init_(1, sci_Nil$_MODULE$, s_Some__init_($c), $commandClause.$position2());
                        $yieldClause = s_None$_MODULE$;
                        oncia_Yield__init_(var$4, $withClause, $yieldClause, $yieldClause, $yieldClause, $commandClause_0, $commandClause.$position2());
                        sci_$colon$colon__init_0($clauses, var$4, sci_$colon$colon__init_(oncirr_rewriteShowQuery$_returnClause($this, $commandClause.$position2(), $c), sci_Nil$_MODULE$));
                        sci_$colon$colon__init_0(var$12, var$7, $clauses);
                        return $rewrittenClause.$concat0(var$12);
                    }
                }
            }
            if (var$3) {
                $commandClause_0 = var$4.$head0;
                $commandClause = var$4.$next0;
                if ($rt_isInstance($commandClause_0, oncia_TransactionsCommandClause)) {
                    $commandClause_0 = $commandClause_0;
                    if ($commandClause instanceof sci_$colon$colon) {
                        $commandClause = $commandClause;
                        $withClause = $commandClause.$head0;
                        $yieldClause = $commandClause.$next0;
                        if ($withClause instanceof oncia_With) {
                            $commandClause = $withClause;
                            if (sci_List_equals(sci_Nil$_MODULE$, $yieldClause))
                                return (($rewrittenClause.$appended($commandClause_0)).$$colon$plus(oncirr_rewriteShowQuery$_updateDefaultOrderOnYield($this, $commandClause, $commandClause_0))).$$colon$plus(oncirr_rewriteShowQuery$_returnClause($this, oncirr_rewriteShowQuery$_lastPosition($this, $commandClause), oncirr_rewriteShowQuery$_getDefaultOrderFromYieldOrCommand($this, $commandClause, $commandClause_0)));
                        }
                    }
                }
            }
            if (var$3) {
                $commandClause_0 = var$4.$head0;
                $commandClause = var$4.$next0;
                if ($rt_isInstance($commandClause_0, oncia_CommandClause)) {
                    $commandClause_0 = $commandClause_0;
                    if ($commandClause instanceof sci_$colon$colon) {
                        $commandClause = $commandClause;
                        $yieldClause = $commandClause.$head0;
                        $returnClause = $commandClause.$next0;
                        if ($yieldClause instanceof oncia_Yield) {
                            $commandClause = $yieldClause;
                            if (sci_List_equals(sci_Nil$_MODULE$, $returnClause))
                                return (($rewrittenClause.$appended($commandClause_0)).$$colon$plus(oncirr_rewriteShowQuery$_updateDefaultOrderOnYield($this, $commandClause, $commandClause_0))).$$colon$plus(oncirr_rewriteShowQuery$_returnClause($this, oncirr_rewriteShowQuery$_lastPosition($this, $commandClause), oncirr_rewriteShowQuery$_getDefaultOrderFromYieldOrCommand($this, $commandClause, $commandClause_0)));
                        }
                    }
                }
            }
            if (var$3) {
                $commandClause_0 = sci_$colon$colon_head(var$4);
                $commandClause = sci_$colon$colon_next$access$1(var$4);
                if ($rt_isInstance($commandClause_0, oncia_TransactionsCommandClause)) {
                    $commandClause_0 = $commandClause_0;
                    if ($commandClause instanceof sci_$colon$colon) {
                        $commandClause = $commandClause;
                        $withClause = sci_$colon$colon_head($commandClause);
                        $commandClause = sci_$colon$colon_next$access$1($commandClause);
                        if ($withClause instanceof oncia_With) {
                            $withClause = $withClause;
                            if ($commandClause instanceof sci_$colon$colon) {
                                $commandClause = $commandClause;
                                $returnClause = sci_$colon$colon_head($commandClause);
                                $commandClause = sci_$colon$colon_next$access$1($commandClause);
                                if ($returnClause instanceof oncia_Return) {
                                    $yieldClause = $returnClause;
                                    if (sci_List_equals(sci_Nil$_MODULE$, $commandClause) && oncia_ReturnItems_includeExisting(oncia_Return_returnItems($yieldClause)))
                                        return ((sc_AbstractSeq_$colon$plus($rewrittenClause, $commandClause_0)).$$colon$plus(oncirr_rewriteShowQuery$_updateDefaultOrderOnYield($this, $withClause, $commandClause_0))).$$colon$plus(oncirr_rewriteShowQuery$_updateDefaultOrderOnReturn($this, $yieldClause, $withClause, $commandClause_0));
                                }
                            }
                        }
                    }
                }
            }
            if (var$3) {
                $commandClause_0 = sci_$colon$colon_head(var$4);
                $commandClause = sci_$colon$colon_next$access$1(var$4);
                if ($rt_isInstance($commandClause_0, oncia_CommandClause)) {
                    $commandClause_0 = $commandClause_0;
                    if ($commandClause instanceof sci_$colon$colon) {
                        $commandClause = $commandClause;
                        $yieldClause = sci_$colon$colon_head($commandClause);
                        $commandClause = sci_$colon$colon_next$access$1($commandClause);
                        if ($yieldClause instanceof oncia_Yield) {
                            $withClause = $yieldClause;
                            if ($commandClause instanceof sci_$colon$colon) {
                                $commandClause = $commandClause;
                                $returnClause = sci_$colon$colon_head($commandClause);
                                $commandClause = sci_$colon$colon_next$access$1($commandClause);
                                if ($returnClause instanceof oncia_Return) {
                                    $yieldClause = $returnClause;
                                    if (sci_List_equals(sci_Nil$_MODULE$, $commandClause) && oncia_ReturnItems_includeExisting(oncia_Return_returnItems($yieldClause)))
                                        return ((sc_AbstractSeq_$colon$plus($rewrittenClause, $commandClause_0)).$$colon$plus(oncirr_rewriteShowQuery$_updateDefaultOrderOnYield($this, $withClause, $commandClause_0))).$$colon$plus(oncirr_rewriteShowQuery$_updateDefaultOrderOnReturn($this, $yieldClause, $withClause, $commandClause_0));
                                }
                            }
                        }
                    }
                }
            }
            if (!var$3)
                break;
            $c = sci_$colon$colon_head(var$4);
            $clauses = sci_$colon$colon_next$access$1(var$4);
            $rewrittenClause = sc_AbstractSeq_$colon$plus($rewrittenClause, $c);
        }
        if (sci_List_equals(sci_Nil$_MODULE$, $clauses))
            return $rewrittenClause;
        $rt_throw(s_MatchError__init_($clauses));
    }
    function oncirr_rewriteShowQuery$_getDefaultOrderFromYieldOrCommand($this, $projClause, $commandClause) {
        var var$3;
        if (!($projClause.$returnItems0()).$includeExisting)
            return (($projClause.$returnItems0()).$items.$map1(new oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_0)).$toList();
        var$3 = ($projClause.$returnItems0()).$defaultOrderOnColumns;
        $projClause = new oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_1;
        $projClause.$_040 = $commandClause;
        return s_Option_getOrElse(var$3, $projClause);
    }
    function oncirr_rewriteShowQuery$_updateDefaultOrderOnReturn($this, $returnClause, $projClause, $commandClause) {
        var var$4, $defaultOrderOnColumns;
        var$4 = $returnClause.$returnItems1.$defaultOrderOnColumns;
        $defaultOrderOnColumns = new oncirr_rewriteShowQuery$$updateDefaultOrderOnReturn$lambda$_9_0;
        $defaultOrderOnColumns.$_041 = $projClause;
        $defaultOrderOnColumns.$_113 = $commandClause;
        $defaultOrderOnColumns = s_Option_getOrElse(var$4, $defaultOrderOnColumns);
        return oncia_Return_withReturnItems($returnClause, oncia_ReturnItems_withDefaultOrderOnColumns($returnClause.$returnItems1, $defaultOrderOnColumns));
    }
    function oncirr_rewriteShowQuery$_updateDefaultOrderOnYield($this, $projClause, $commandClause) {
        var $defaultOrderOnColumns, $x$1;
        $defaultOrderOnColumns = oncirr_rewriteShowQuery$_getDefaultOrderFromYieldOrCommand($this, $projClause, $commandClause);
        $x$1 = oncia_ReturnItems_withDefaultOrderOnColumns($projClause.$returnItems0(), $defaultOrderOnColumns);
        return $projClause.$copyProjection($projClause.$copyProjection$default$1(), $x$1, $projClause.$copyProjection$default$3(), $projClause.$copyProjection$default$4(), $projClause.$copyProjection$default$5(), $projClause.$copyProjection$default$6());
    }
    function oncirr_rewriteShowQuery$_returnClause($this, $position, $defaultOrderOnColumns) {
        var var$3, var$4, $qual$1;
        var$3 = oncia_Return$_MODULE$;
        var$4 = oncia_ReturnItems__init_(1, sci_Nil$_MODULE$, s_Some__init_($defaultOrderOnColumns), $position);
        $qual$1 = new oncia_Return;
        $defaultOrderOnColumns = s_None$_MODULE$;
        oncia_Return__init_($qual$1, 0, var$4, $defaultOrderOnColumns, $defaultOrderOnColumns, $defaultOrderOnColumns, oncia_Return$_apply$default$6(var$3), 0, $position);
        return oncia_Return_copy($qual$1, $qual$1.$distinct, $qual$1.$returnItems1, $qual$1.$orderBy0, $qual$1.$skip0, $qual$1.$limit0, $qual$1.$excludedNames, 1, $position);
    }
    function oncirr_rewriteShowQuery$_lastPosition($this, $c) {
        var var$2;
        var$2 = $c.$folder();
        onciu_InputPosition$_$callClinit();
        return onciu_Foldable$Folder_treeFold(var$2, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$), new oncirr_rewriteShowQuery$$anonfun$lastPosition$1);
    }
    function oncirr_rewriteShowQuery$_getRewriter($this, $cypherExceptionFactory) {
        oncirr_rewriteShowQuery$_$callClinit();
        return oncirr_rewriteShowQuery$_instance;
    }
    function oncirr_rewriteShowQuery$_productArity($this) {
        return 0;
    }
    function oncirr_rewriteShowQuery$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_rewriteShowQuery$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_rewriteShowQuery$_hashCode($this) {
        return 547983263;
    }
    function oncirr_rewriteShowQuery$_toString($this) {
        return $rt_s(99);
    }
    var oncirr_mergeInPredicates$ = $rt_classWithoutFields();
    var oncirr_mergeInPredicates$_MODULE$ = null;
    var oncirr_mergeInPredicates$_instance = null;
    function oncirr_mergeInPredicates$_$callClinit() {
        oncirr_mergeInPredicates$_$callClinit = $rt_eraseClinit(oncirr_mergeInPredicates$);
        oncirr_mergeInPredicates$__clinit_();
    }
    function oncirr_mergeInPredicates$__clinit_() {
        var var$1, var$2;
        var$1 = new oncirr_mergeInPredicates$;
        oncirr_mergeInPredicates$_$callClinit();
        oncirr_mergeInPredicates$_MODULE$ = var$1;
        var$2 = onciu_bottomUp$_MODULE$;
        onciu_Rewriter$_$callClinit();
        oncirr_mergeInPredicates$_instance = onciu_bottomUp$_apply(var$2, onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncirr_mergeInPredicates$$anonfun$1), onciu_bottomUp$_apply$default$2(onciu_bottomUp$_MODULE$), onciu_CancellationChecker$NeverCancelled$_MODULE$);
    }
    function oncirr_mergeInPredicates$_preConditions($this) {
        s_Predef$_$callClinit();
        return (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(onciu_StepSequencer$Condition, [onciu_StepSequencer$Condition_unary_$bang$(oncirc_package$LiteralsExtracted$_MODULE$), onciu_StepSequencer$Condition_unary_$bang$(oncirc_package$SensitiveLiteralsExtracted$_MODULE$)])));
    }
    function oncirr_mergeInPredicates$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirr_MultipleInPredicatesAreMerged$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_mergeInPredicates$_invalidatedConditions($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$);
    }
    function oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots($this, $expressions) {
        return sc_IterableOnceOps_forall$($expressions, new oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots$lambda$_9_0);
    }
    function oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots($this, $expressions) {
        return sc_IterableOnceOps_forall$($expressions, new oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots$lambda$_10_0);
    }
    function oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns($this, $expressions) {
        return sc_IterableOnceOps_forall$($expressions, new oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns$lambda$_11_0);
    }
    function oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$rewriteBinaryOperator($this, $binary, $merge, $copy) {
        var $newLhs, $newRhs, $rewriter;
        a: {
            b: {
                $newLhs = sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression, [$binary.$lhs0(), $binary.$rhs0()]));
                $newRhs = new oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_0;
                $newRhs.$_042 = $merge;
                $newRhs = sci_ArraySeq_map($newLhs, $newRhs);
                $newLhs = new oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_1;
                $newLhs.$_043 = $merge;
                $merge = sc_IterableOnceOps_reduceLeft$($newRhs, $newLhs);
                $newLhs = onciu_bottomUp$_MODULE$;
                onciu_Rewriter$_$callClinit();
                $newRhs = onciu_Rewriter$_MODULE$;
                $rewriter = new oncirr_mergeInPredicates$$anonfun$inRewriter$1;
                $rewriter.$inPredicates$1 = $merge;
                $rewriter = onciu_bottomUp$_apply($newLhs, onciu_Rewriter$_lift($newRhs, $rewriter), onciu_bottomUp$_apply$default$2(onciu_bottomUp$_MODULE$), onciu_CancellationChecker$NeverCancelled$_MODULE$);
                $newLhs = $rewriter.$apply($binary.$lhs0());
                $newRhs = $rewriter.$apply($binary.$rhs0());
                if ($newLhs !== null) {
                    if (!$newLhs.$equals($newRhs))
                        break a;
                    else
                        break b;
                }
                if ($newRhs !== null)
                    break a;
            }
            return $newLhs;
        }
        return $copy.$apply0($newLhs, $newRhs);
    }
    function oncirr_mergeInPredicates$_getRewriter($this, $cypherExceptionFactory) {
        oncirr_mergeInPredicates$_$callClinit();
        return oncirr_mergeInPredicates$_instance;
    }
    function oncirr_mergeInPredicates$_productArity($this) {
        return 0;
    }
    function oncirr_mergeInPredicates$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_mergeInPredicates$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_mergeInPredicates$_hashCode($this) {
        return 1014001913;
    }
    function oncirr_mergeInPredicates$_toString($this) {
        return $rt_s(100);
    }
    var oncirr_timestampRewriter$ = $rt_classWithoutFields();
    var oncirr_timestampRewriter$_MODULE$ = null;
    var oncirr_timestampRewriter$_rewriter = null;
    var oncirr_timestampRewriter$_instance = null;
    function oncirr_timestampRewriter$_$callClinit() {
        oncirr_timestampRewriter$_$callClinit = $rt_eraseClinit(oncirr_timestampRewriter$);
        oncirr_timestampRewriter$__clinit_();
    }
    function oncirr_timestampRewriter$__clinit_() {
        var var$1, var$2;
        var$1 = new oncirr_timestampRewriter$;
        oncirr_timestampRewriter$_$callClinit();
        oncirr_timestampRewriter$_MODULE$ = var$1;
        onciu_Rewriter$_$callClinit();
        var$1 = onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncirr_timestampRewriter$$anonfun$1);
        oncirr_timestampRewriter$_rewriter = var$1;
        var$2 = onciu_topDown$_MODULE$;
        oncirr_timestampRewriter$_instance = onciu_topDown$_apply(var$2, var$1, onciu_topDown$_apply$default$2(var$2), 1, onciu_CancellationChecker$NeverCancelled$_MODULE$);
    }
    function oncirr_timestampRewriter$_getRewriter($this, $cypherExceptionFactory) {
        oncirr_timestampRewriter$_$callClinit();
        return oncirr_timestampRewriter$_instance;
    }
    function oncirr_timestampRewriter$_preConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = onciu_StepSequencer$Condition_unary_$bang$(oncirc_package$FunctionInvocationsResolved$_MODULE$);
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_timestampRewriter$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirr_TimestampRewritten$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_timestampRewriter$_invalidatedConditions($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$);
    }
    function oncirr_timestampRewriter$_productArity($this) {
        return 0;
    }
    function oncirr_timestampRewriter$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_timestampRewriter$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_timestampRewriter$_hashCode($this) {
        return 1416632220;
    }
    function oncirr_timestampRewriter$_toString($this) {
        return $rt_s(101);
    }
    var oncirr_rewriteShortestPathWithFixedLengthRelationship$ = $rt_classWithoutFields();
    var oncirr_rewriteShortestPathWithFixedLengthRelationship$_MODULE$ = null;
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$__clinit_() {
        oncirr_rewriteShortestPathWithFixedLengthRelationship$_MODULE$ = new oncirr_rewriteShortestPathWithFixedLengthRelationship$;
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_preConditions($this) {
        s_Predef$_$callClinit();
        return (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sci_Nil$_MODULE$);
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_postConditions($this) {
        var var$1, var$2, var$3;
        s_Predef$_$callClinit();
        var$1 = s_Predef$_Set(s_Predef$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(onciu_StepSequencer$Condition, 1);
        var$3.data[0] = oncirr_NoShortestPathWithFixedLength$_MODULE$;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_invalidatedConditions($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable(oncirc_package$_MODULE$);
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_getRewriter($this, $cypherExceptionFactory) {
        oncirr_rewriteShortestPathWithFixedLengthRel$_$callClinit();
        return oncirr_rewriteShortestPathWithFixedLengthRel$_MODULE$;
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_productArity($this) {
        return 0;
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_hashCode($this) {
        return (-870356047);
    }
    function oncirr_rewriteShortestPathWithFixedLengthRelationship$_toString($this) {
        return $rt_s(102);
    }
    var sc_SetOps = $rt_classWithoutFields(0);
    function sc_SetOps_intersect$($$this, $that) {
        return $$this.$filter1($that);
    }
    var sc_Set = $rt_classWithoutFields(0);
    function sc_Set_equals$($$this, $that) {
        var var$3, $$je;
        a: {
            if ($$this !== $that) {
                b: {
                    if (!$rt_isInstance($that, sc_Set))
                        var$3 = 0;
                    else {
                        $that = $that;
                        if ($$this.$size() == $that.$size()) {
                            c: {
                                try {
                                    var$3 = $$this.$subsetOf($that);
                                    break c;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof jl_ClassCastException) {
                                    } else {
                                        throw $$e;
                                    }
                                }
                                var$3 = 0;
                            }
                            if (var$3) {
                                var$3 = 1;
                                break b;
                            }
                        }
                        var$3 = 0;
                    }
                }
                if (!var$3) {
                    var$3 = 0;
                    break a;
                }
            }
            var$3 = 1;
        }
        return var$3;
    }
    var sci_SetOps = $rt_classWithoutFields(0);
    var sci_Set = $rt_classWithoutFields(0);
    function s_MatchError() {
        var a = this; jl_RuntimeException.call(a);
        a.$objString = null;
        a.$obj = null;
        a.$bitmap$0 = 0;
    }
    function s_MatchError__init_(var_0) {
        var var_1 = new s_MatchError();
        s_MatchError__init_0(var_1, var_0);
        return var_1;
    }
    function s_MatchError_getMessage($this) {
        var var$1, $$je;
        if ($this.$bitmap$0)
            var$1 = $this.$objString;
        else {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$bitmap$0)
                        break a;
                    $this.$objString = $this.$obj !== null ? s_MatchError_liftedTree1$1($this) : $rt_s(7);
                    $this.$bitmap$0 = 1;
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
            var$1 = $this.$objString;
        }
        return var$1;
    }
    function s_MatchError_ofClass$1($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 9);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(103));
        jl_AbstractStringBuilder_append1(var$1, jl_Class_getName(jl_Object_getClass($this.$obj)));
        return jl_AbstractStringBuilder_toString(var$1);
    }
    function s_MatchError_liftedTree1$1($this) {
        var var$1, $$je;
        a: {
            try {
                var$1 = jl_StringBuilder_toString(jl_StringBuilder_append1(jl_StringBuilder_append1(jl_StringBuilder_append1(jl_StringBuilder_append(jl_StringBuilder__init_(3), $this.$obj), $rt_s(104)), s_MatchError_ofClass$1($this)), $rt_s(25)));
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_Throwable) {
                    break a;
                } else {
                    throw $$e;
                }
            }
            return var$1;
        }
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 12);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(105));
        jl_AbstractStringBuilder_append1(var$1, s_MatchError_ofClass$1($this));
        return jl_AbstractStringBuilder_toString(var$1);
    }
    function s_MatchError__init_0($this, $obj) {
        $this.$obj = $obj;
        jl_Throwable__init_0($this);
    }
    var oncifp_ExpectedBooleanTypeCheck = $rt_classWithoutFields(0);
    function oncifp_ExpectedBooleanTypeCheck_isExpectedTypeBoolean$($$this, $semanticTable, $e) {
        return s_Option_exists(s_Option_flatMap($semanticTable.$types.$get1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $e)), new oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_0), new oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_1);
    }
    var oncifp_PatternExpressionInNonExistenceCheck$ = $rt_classWithoutFields();
    var oncifp_PatternExpressionInNonExistenceCheck$_MODULE$ = null;
    var oncifp_PatternExpressionInNonExistenceCheck$_errorMessage = null;
    var oncifp_PatternExpressionInNonExistenceCheck$_errorMessageForSizeFunction = null;
    function oncifp_PatternExpressionInNonExistenceCheck$__clinit_() {
        oncifp_PatternExpressionInNonExistenceCheck$_MODULE$ = new oncifp_PatternExpressionInNonExistenceCheck$;
        oncifp_PatternExpressionInNonExistenceCheck$_errorMessage = $rt_s(106);
        oncifp_PatternExpressionInNonExistenceCheck$_errorMessageForSizeFunction = $rt_s(107);
    }
    var oncifp_CreatePatternSelfReferenceCheck$ = $rt_classWithoutFields();
    var oncifp_CreatePatternSelfReferenceCheck$_MODULE$ = null;
    function oncifp_CreatePatternSelfReferenceCheck$__clinit_() {
        oncifp_CreatePatternSelfReferenceCheck$_MODULE$ = new oncifp_CreatePatternSelfReferenceCheck$;
    }
    function oncifp_CreatePatternSelfReferenceCheck$_org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1($e, $allSymbolDefinitions$1) {
        var var$3, var$4;
        var$3 = onciu_Foldable_folder$(onciu_Foldable$_FoldableAny(onciu_Foldable$_MODULE$, $e));
        sr_ClassTag$_$callClinit();
        $e = sc_AbstractIterable_toSet(onciu_Foldable$Folder_findAllByClass(var$3, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_LogicalVariable))));
        var$4 = new oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1$lambda$_6_0;
        var$4.$_044 = $allSymbolDefinitions$1;
        return $e.$filter1(var$4);
    }
    function oncifp_CreatePatternSelfReferenceCheck$_org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1($variable, $allSymbolDefinitions$1) {
        return (($allSymbolDefinitions$1.$apply($variable.$name4)).$map1(new oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1$lambda$_8_0)).$contains0(onciu_Ref$_apply(onciu_Ref$_MODULE$, $variable));
    }
    var oncifp_ListCoercedToBooleanCheck$ = $rt_classWithoutFields();
    var oncifp_ListCoercedToBooleanCheck$_MODULE$ = null;
    var oncifp_ListCoercedToBooleanCheck$_errorMessage = null;
    function oncifp_ListCoercedToBooleanCheck$__clinit_() {
        oncifp_ListCoercedToBooleanCheck$_MODULE$ = new oncifp_ListCoercedToBooleanCheck$;
        oncifp_ListCoercedToBooleanCheck$_errorMessage = $rt_s(108);
    }
    var sc_IterableFactory = $rt_classWithoutFields(0);
    function sc_IterableFactory_apply$($$this, $elems) {
        return $$this.$from0($elems);
    }
    var sci_Set$ = $rt_classWithoutFields();
    var sci_Set$_MODULE$ = null;
    function sci_Set$__clinit_() {
        sci_Set$_MODULE$ = new sci_Set$;
    }
    function sci_Set$_apply($this, $elems) {
        return $this.$from0($elems);
    }
    function sci_Set$_from($this, $it) {
        if ($rt_isInstance($it, sci_SortedSet))
            return sci_SetBuilderImpl_result(sci_SetBuilderImpl_addAll(sci_SetBuilderImpl__init_(), $it));
        if (!$it.$knownSize())
            return sci_Set$EmptySet$_MODULE$;
        if ($rt_isInstance($it, sci_Set))
            return $it;
        return sci_SetBuilderImpl_result(sci_SetBuilderImpl_addAll(sci_SetBuilderImpl__init_(), $it));
    }
    function sci_Set$_newBuilder($this) {
        return sci_SetBuilderImpl__init_();
    }
    function sci_Set$_from0($this, $source) {
        return sci_Set$_from($this, $source);
    }
    var s_Tuple2$ = $rt_classWithoutFields();
    var s_Tuple2$_MODULE$ = null;
    function s_Tuple2$__clinit_() {
        s_Tuple2$_MODULE$ = new s_Tuple2$;
    }
    var sr_Manifest$ = $rt_classWithoutFields();
    var sr_Manifest$_MODULE$ = null;
    var sr_Manifest$_Byte = null;
    var sr_Manifest$_Short = null;
    var sr_Manifest$_Char = null;
    var sr_Manifest$_Int = null;
    var sr_Manifest$_Long = null;
    var sr_Manifest$_Float = null;
    var sr_Manifest$_Double = null;
    var sr_Manifest$_Boolean = null;
    var sr_Manifest$_Unit = null;
    var sr_Manifest$_Any = null;
    var sr_Manifest$_Object = null;
    var sr_Manifest$_AnyRef = null;
    var sr_Manifest$_AnyVal = null;
    var sr_Manifest$_Null = null;
    var sr_Manifest$_Nothing = null;
    function sr_Manifest$_$callClinit() {
        sr_Manifest$_$callClinit = $rt_eraseClinit(sr_Manifest$);
        sr_Manifest$__clinit_();
    }
    function sr_Manifest$__clinit_() {
        var var$1;
        var$1 = new sr_Manifest$;
        sr_Manifest$_$callClinit();
        sr_Manifest$_MODULE$ = var$1;
        sr_ManifestFactory$_$callClinit();
        sr_Manifest$_Byte = sr_ManifestFactory$_Byte;
        sr_Manifest$_Short = sr_ManifestFactory$_Short;
        sr_Manifest$_Char = sr_ManifestFactory$_Char;
        sr_Manifest$_Int = sr_ManifestFactory$_Int;
        sr_Manifest$_Long = sr_ManifestFactory$_Long;
        sr_Manifest$_Float = sr_ManifestFactory$_Float;
        sr_Manifest$_Double = sr_ManifestFactory$_Double;
        sr_Manifest$_Boolean = sr_ManifestFactory$_Boolean;
        sr_Manifest$_Unit = sr_ManifestFactory$_Unit;
        sr_Manifest$_Any = sr_ManifestFactory$_Any;
        sr_Manifest$_Object = sr_ManifestFactory$_Object(sr_ManifestFactory$_MODULE$);
        sr_Manifest$_AnyRef = sr_ManifestFactory$_AnyRef;
        sr_Manifest$_AnyVal = sr_ManifestFactory$_AnyVal;
        sr_Manifest$_Null = sr_ManifestFactory$_Null;
        sr_Manifest$_Nothing = sr_ManifestFactory$_Nothing;
    }
    var sr_OptManifest = $rt_classWithoutFields(0);
    var sr_NoManifest$ = $rt_classWithoutFields();
    var sr_NoManifest$_MODULE$ = null;
    function sr_NoManifest$__clinit_() {
        sr_NoManifest$_MODULE$ = new sr_NoManifest$;
    }
    function onciu_StepSequencer$AccumulatedSteps() {
        var a = this; jl_Object.call(a);
        a.$steps = null;
        a.$postConditions = null;
    }
    function onciu_StepSequencer$AccumulatedSteps_productPrefix($this) {
        return $rt_s(109);
    }
    function onciu_StepSequencer$AccumulatedSteps_productArity($this) {
        return 2;
    }
    function onciu_StepSequencer$AccumulatedSteps_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$steps;
            case 1:
                return $this.$postConditions;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function onciu_StepSequencer$AccumulatedSteps_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_StepSequencer$AccumulatedSteps_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    var onciap_ExpressionStringifier$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    function onciap_ExpressionStringifier$$_clinit_$lambda$_0_0_apply(var$0, var$1) {
        var var$2, var$3;
        var$2 = new jl_IllegalStateException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(110)), var$1);
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    var onciu_topDown$ = $rt_classWithoutFields();
    var onciu_topDown$_MODULE$ = null;
    function onciu_topDown$__clinit_() {
        onciu_topDown$_MODULE$ = new onciu_topDown$;
    }
    function onciu_topDown$_apply($this, $rewriter, $stopper, $leftToRight, $cancellation) {
        var var$5;
        var$5 = new onciu_topDown$TopDownRewriter;
        var$5.$rewriter = $rewriter;
        var$5.$stopper = $stopper;
        var$5.$leftToRight = $leftToRight;
        var$5.$cancellation = $cancellation;
        return var$5;
    }
    function onciu_topDown$_apply$default$2($this) {
        return onciu_RewriterStopper$_neverStop;
    }
    var onciu_Rewriter$ = $rt_classWithoutFields();
    var onciu_Rewriter$_MODULE$ = null;
    var onciu_Rewriter$_noop = null;
    function onciu_Rewriter$_$callClinit() {
        onciu_Rewriter$_$callClinit = $rt_eraseClinit(onciu_Rewriter$);
        onciu_Rewriter$__clinit_();
    }
    function onciu_Rewriter$__clinit_() {
        var var$1;
        var$1 = new onciu_Rewriter$;
        onciu_Rewriter$_$callClinit();
        onciu_Rewriter$_MODULE$ = var$1;
        onciu_Rewriter$_noop = onciu_Rewriter$_lift(var$1, s_PartialFunction$_empty_pf);
    }
    function onciu_Rewriter$_lift($this, $f) {
        return $f.$orElse(new onciu_Rewriter$$anonfun$lift$1);
    }
    var oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1_applyOrElse($this, $x1, $default) {
        var var$3, $clauses;
        if ($x1 instanceof oncia_SingleQuery) {
            var$3 = $x1;
            $clauses = var$3.$clauses;
            if (sc_IterableOnceOps_nonEmpty$($clauses)) {
                $default = sc_Iterator_collect$(sc_AbstractIterable_sliding($clauses, 2), new oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1$$anonfun$2);
                s_Predef$_$callClinit();
                return oncia_SingleQuery__init_((sc_IterableOnceOps_toSeq$(sc_Iterator_flatMap$($default, s_Predef$_$conforms(s_Predef$_MODULE$)))).$appended($clauses.$last()), var$3.$position5);
            }
        }
        return $default.$apply($x1);
    }
    var onciu_bottomUp$ = $rt_classWithoutFields();
    var onciu_bottomUp$_MODULE$ = null;
    function onciu_bottomUp$__clinit_() {
        onciu_bottomUp$_MODULE$ = new onciu_bottomUp$;
    }
    function onciu_bottomUp$_apply($this, $rewriter, $stopper, $cancellation) {
        var var$4;
        var$4 = new onciu_bottomUp$BottomUpRewriter;
        var$4.$rewriter0 = $rewriter;
        var$4.$stopper0 = $stopper;
        var$4.$cancellation0 = $cancellation;
        return var$4;
    }
    function onciu_bottomUp$_apply$default$2($this) {
        return onciu_RewriterStopper$_neverStop;
    }
    var oncirr_expandCallWhere$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirr_expandCallWhere$$anonfun$1_applyOrElse($this, $x1, $default) {
        if (!($x1 instanceof oncia_SingleQuery))
            return $default.$apply($x1);
        $x1 = $x1;
        return oncia_SingleQuery_copy($x1, $x1.$clauses.$flatMap(new oncirr_expandCallWhere$$anonfun$1$applyOrElse$lambda$_0_0), $x1.$position5);
    }
    var oncirr_expandShowWhere$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirr_expandShowWhere$$anonfun$1_applyOrElse($this, $x1, $default) {
        var $x$6, $where, $x$7, $yieldClause, var$7, $where_0, var$9, $x$1, $x$28, $x$8, $x$29, $x$9, $x$38, $returnClause, var$17, $x$2, var$19, $x$3, $x$5, $x$10, $x$14, $x$19, $yieldClause_0, $returnClause_0, $x$23, $x$27, $x$32, $x$36, $x$41;
        $x$6 = 0;
        $where = null;
        $x$7 = 0;
        $yieldClause = null;
        var$7 = 0;
        $where_0 = null;
        var$9 = 0;
        $x$1 = null;
        $x$28 = 0;
        $x$8 = null;
        $x$29 = 0;
        $x$9 = null;
        $x$38 = 0;
        $returnClause = null;
        var$17 = 0;
        $x$2 = null;
        var$19 = 0;
        $x$3 = null;
        if ($x1 instanceof oncia_ShowDatabase) {
            $x$6 = 1;
            $where = $x1;
            $x$5 = oncia_ShowDatabase_yieldOrWhere($where);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where_0 = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    $x$1 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where_0, oncia_ShowDatabase_defaultColumnNames($where));
                    return oncia_ShowDatabase_copy($where, oncia_ShowDatabase_copy$default$1($where), $x$1, oncia_ShowDatabase_copy$default$3($where), oncia_ShowDatabase_position($where));
                }
            }
        }
        if ($x1 instanceof oncia_ShowRoles) {
            $x$7 = 1;
            $yieldClause = $x1;
            $x$5 = oncia_ShowRoles_yieldOrWhere($yieldClause);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    $x$5 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowRoles_defaultColumnNames($yieldClause));
                    return oncia_ShowRoles_copy($yieldClause, oncia_ShowRoles_copy$default$1($yieldClause), oncia_ShowRoles_copy$default$2($yieldClause), $x$5, oncia_ShowRoles_copy$default$4($yieldClause), oncia_ShowRoles_position($yieldClause));
                }
            }
        }
        if ($x1 instanceof oncia_ShowPrivileges) {
            var$7 = 1;
            $where_0 = $x1;
            $x$5 = oncia_ShowPrivileges_yieldOrWhere($where_0);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    $x$10 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowPrivileges_defaultColumnNames($where_0));
                    return oncia_ShowPrivileges_copy($where_0, oncia_ShowPrivileges_copy$default$1($where_0), $x$10, oncia_ShowPrivileges_copy$default$3($where_0), oncia_ShowPrivileges_position($where_0));
                }
            }
        }
        if ($x1 instanceof oncia_ShowPrivilegeCommands) {
            var$9 = 1;
            $x$1 = $x1;
            $x$5 = oncia_ShowPrivilegeCommands_yieldOrWhere($x$1);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    $x$14 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowPrivilegeCommands_defaultColumnNames($x$1));
                    return oncia_ShowPrivilegeCommands_copy($x$1, oncia_ShowPrivilegeCommands_copy$default$1($x$1), oncia_ShowPrivilegeCommands_copy$default$2($x$1), $x$14, oncia_ShowPrivilegeCommands_copy$default$4($x$1), oncia_ShowPrivilegeCommands_position($x$1));
                }
            }
        }
        if ($x1 instanceof oncia_ShowSupportedPrivilegeCommand) {
            $x$28 = 1;
            $x$8 = $x1;
            $x$5 = oncia_ShowSupportedPrivilegeCommand_yieldOrWhere($x$8);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    return oncia_ShowSupportedPrivilegeCommand_copy($x$8, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowSupportedPrivilegeCommand_defaultColumnNames($x$8)), oncia_ShowSupportedPrivilegeCommand_copy$default$2($x$8), oncia_ShowSupportedPrivilegeCommand_position($x$8));
                }
            }
        }
        if ($x1 instanceof oncia_ShowUsers) {
            $x$29 = 1;
            $x$9 = $x1;
            $x$5 = oncia_ShowUsers_yieldOrWhere($x$9);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    return oncia_ShowUsers_copy($x$9, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowUsers_defaultColumnNames($x$9)), oncia_ShowUsers_copy$default$2($x$9), oncia_ShowUsers_position($x$9));
                }
            }
        }
        if ($x1 instanceof oncia_ShowCurrentUser) {
            $x$38 = 1;
            $returnClause = $x1;
            $x$5 = oncia_ShowCurrentUser_yieldOrWhere($returnClause);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    return oncia_ShowCurrentUser_copy($returnClause, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowCurrentUser_defaultColumnNames($returnClause)), oncia_ShowCurrentUser_copy$default$2($returnClause), oncia_ShowCurrentUser_position($returnClause));
                }
            }
        }
        if ($x1 instanceof oncia_ShowAliases) {
            var$17 = 1;
            $x$2 = $x1;
            $x$5 = oncia_ShowAliases_yieldOrWhere($x$2);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    $x$19 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowAliases_defaultColumnNames($x$2));
                    return oncia_ShowAliases_copy($x$2, oncia_ShowAliases_copy$default$1($x$2), $x$19, oncia_ShowAliases_copy$default$3($x$2), oncia_ShowAliases_position($x$2));
                }
            }
        }
        if ($x1 instanceof oncia_ShowServers) {
            var$19 = 1;
            $x$3 = $x1;
            $x$5 = oncia_ShowServers_yieldOrWhere($x$3);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Right) {
                    $where = su_Right_value($x$5);
                    oncirr_expandShowWhere$_$callClinit();
                    return oncia_ShowServers_copy($x$3, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$whereToYield(oncirr_expandShowWhere$_MODULE$, $where, oncia_ShowServers_defaultColumnNames($x$3)), oncia_ShowServers_copy$default$2($x$3), oncia_ShowServers_position($x$3));
                }
            }
        }
        if ($x$6) {
            $x$5 = oncia_ShowDatabase_yieldOrWhere($where);
            if ($x$5 instanceof s_Some) {
                $x$5 = s_Some_value($x$5);
                if ($x$5 instanceof su_Left) {
                    $x$5 = su_Left_value($x$5);
                    if ($x$5 !== null) {
                        $yieldClause_0 = s_Tuple2__1($x$5);
                        $returnClause_0 = s_Tuple2__2($x$5);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause_0)) && !s_Option_exists($returnClause_0, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            $x$23 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause_0, $returnClause_0, oncia_ShowDatabase_defaultColumnNames($where));
                            return oncia_ShowDatabase_copy($where, oncia_ShowDatabase_copy$default$1($where), $x$23, oncia_ShowDatabase_copy$default$3($where), oncia_ShowDatabase_position($where));
                        }
                    }
                }
            }
        }
        if ($x$7) {
            $where = oncia_ShowRoles_yieldOrWhere($yieldClause);
            if ($where instanceof s_Some) {
                $where = s_Some_value($where);
                if ($where instanceof su_Left) {
                    $where = su_Left_value($where);
                    if ($where !== null) {
                        $yieldClause_0 = s_Tuple2__1($where);
                        $returnClause_0 = s_Tuple2__2($where);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause_0)) && !s_Option_exists($returnClause_0, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            $x$27 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause_0, $returnClause_0, oncia_ShowRoles_defaultColumnNames($yieldClause));
                            return oncia_ShowRoles_copy($yieldClause, oncia_ShowRoles_copy$default$1($yieldClause), oncia_ShowRoles_copy$default$2($yieldClause), $x$27, oncia_ShowRoles_copy$default$4($yieldClause), oncia_ShowRoles_position($yieldClause));
                        }
                    }
                }
            }
        }
        if (var$7) {
            $where = oncia_ShowPrivileges_yieldOrWhere($where_0);
            if ($where instanceof s_Some) {
                $where = s_Some_value($where);
                if ($where instanceof su_Left) {
                    $where = su_Left_value($where);
                    if ($where !== null) {
                        $yieldClause = s_Tuple2__1($where);
                        $returnClause_0 = s_Tuple2__2($where);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause)) && !s_Option_exists($returnClause_0, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            $x$32 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause, $returnClause_0, oncia_ShowPrivileges_defaultColumnNames($where_0));
                            return oncia_ShowPrivileges_copy($where_0, oncia_ShowPrivileges_copy$default$1($where_0), $x$32, oncia_ShowPrivileges_copy$default$3($where_0), oncia_ShowPrivileges_position($where_0));
                        }
                    }
                }
            }
        }
        if (var$9) {
            $where = oncia_ShowPrivilegeCommands_yieldOrWhere($x$1);
            if ($where instanceof s_Some) {
                $where = s_Some_value($where);
                if ($where instanceof su_Left) {
                    $where = su_Left_value($where);
                    if ($where !== null) {
                        $yieldClause = s_Tuple2__1($where);
                        $returnClause_0 = s_Tuple2__2($where);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause)) && !s_Option_exists($returnClause_0, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            $x$36 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause, $returnClause_0, oncia_ShowPrivilegeCommands_defaultColumnNames($x$1));
                            return oncia_ShowPrivilegeCommands_copy($x$1, oncia_ShowPrivilegeCommands_copy$default$1($x$1), oncia_ShowPrivilegeCommands_copy$default$2($x$1), $x$36, oncia_ShowPrivilegeCommands_copy$default$4($x$1), oncia_ShowPrivilegeCommands_position($x$1));
                        }
                    }
                }
            }
        }
        if ($x$28) {
            $where = oncia_ShowSupportedPrivilegeCommand_yieldOrWhere($x$8);
            if ($where instanceof s_Some) {
                $where = s_Some_value($where);
                if ($where instanceof su_Left) {
                    $where = su_Left_value($where);
                    if ($where !== null) {
                        $yieldClause = s_Tuple2__1($where);
                        $returnClause_0 = s_Tuple2__2($where);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause)) && !s_Option_exists($returnClause_0, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            return oncia_ShowSupportedPrivilegeCommand_copy($x$8, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause, $returnClause_0, oncia_ShowSupportedPrivilegeCommand_defaultColumnNames($x$8)), oncia_ShowSupportedPrivilegeCommand_copy$default$2($x$8), oncia_ShowSupportedPrivilegeCommand_position($x$8));
                        }
                    }
                }
            }
        }
        if ($x$29) {
            $where = oncia_ShowUsers_yieldOrWhere($x$9);
            if ($where instanceof s_Some) {
                $where = s_Some_value($where);
                if ($where instanceof su_Left) {
                    $where = su_Left_value($where);
                    if ($where !== null) {
                        $yieldClause = s_Tuple2__1($where);
                        $returnClause_0 = s_Tuple2__2($where);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause)) && !s_Option_exists($returnClause_0, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            return oncia_ShowUsers_copy($x$9, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause, $returnClause_0, oncia_ShowUsers_defaultColumnNames($x$9)), oncia_ShowUsers_copy$default$2($x$9), oncia_ShowUsers_position($x$9));
                        }
                    }
                }
            }
        }
        if ($x$38) {
            $where = oncia_ShowCurrentUser_yieldOrWhere($returnClause);
            if ($where instanceof s_Some) {
                $where = s_Some_value($where);
                if ($where instanceof su_Left) {
                    $where = su_Left_value($where);
                    if ($where !== null) {
                        $yieldClause = s_Tuple2__1($where);
                        $returnClause_0 = s_Tuple2__2($where);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause)) && !s_Option_exists($returnClause_0, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            return oncia_ShowCurrentUser_copy($returnClause, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause, $returnClause_0, oncia_ShowCurrentUser_defaultColumnNames($returnClause)), oncia_ShowCurrentUser_copy$default$2($returnClause), oncia_ShowCurrentUser_position($returnClause));
                        }
                    }
                }
            }
        }
        if (var$17) {
            $where = oncia_ShowAliases_yieldOrWhere($x$2);
            if ($where instanceof s_Some) {
                $where = s_Some_value($where);
                if ($where instanceof su_Left) {
                    $where = su_Left_value($where);
                    if ($where !== null) {
                        $yieldClause = s_Tuple2__1($where);
                        $returnClause = s_Tuple2__2($where);
                        if (!(!oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause)) && !s_Option_exists($returnClause, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7__init_()))) {
                            oncirr_expandShowWhere$_$callClinit();
                            $x$41 = oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause, $returnClause, oncia_ShowAliases_defaultColumnNames($x$2));
                            return oncia_ShowAliases_copy($x$2, oncia_ShowAliases_copy$default$1($x$2), $x$41, oncia_ShowAliases_copy$default$3($x$2), oncia_ShowAliases_position($x$2));
                        }
                    }
                }
            }
        }
        a: {
            if (var$19) {
                $where = oncia_ShowServers_yieldOrWhere($x$3);
                if ($where instanceof s_Some) {
                    $where = s_Some_value($where);
                    if ($where instanceof su_Left) {
                        $where = su_Left_value($where);
                        if ($where !== null) {
                            $yieldClause = s_Tuple2__1($where);
                            $returnClause = s_Tuple2__2($where);
                            if (oncia_ReturnItems_includeExisting(oncia_Yield_returnItems($yieldClause)))
                                break a;
                            if (s_Option_exists($returnClause, oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8__init_()))
                                break a;
                        }
                    }
                }
            }
            return $default.$apply($x1);
        }
        oncirr_expandShowWhere$_$callClinit();
        return oncia_ShowServers_copy($x$3, oncirr_expandShowWhere$_org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns(oncirr_expandShowWhere$_MODULE$, $yieldClause, $returnClause, oncia_ShowServers_defaultColumnNames($x$3)), oncia_ShowServers_copy$default$2($x$3), oncia_ShowServers_position($x$3));
    }
    var oncirr_rewriteShowQuery$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirr_rewriteShowQuery$$anonfun$1_applyOrElse($this, $x1, $default) {
        var $clauses;
        if (!($x1 instanceof oncia_SingleQuery))
            return $default.$apply($x1);
        $default = $x1;
        $clauses = $default.$clauses;
        oncirr_rewriteShowQuery$_$callClinit();
        return oncia_SingleQuery_copy($default, oncirr_rewriteShowQuery$_org$neo4j$cypher$internal$rewriting$rewriters$rewriteShowQuery$$rewriteClauses(oncirr_rewriteShowQuery$_MODULE$, $clauses.$toList(), sci_Nil$_MODULE$), $default.$position5);
    }
    var oncirr_mergeInPredicates$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirr_mergeInPredicates$$anonfun$1_applyOrElse($this, $x1, $default) {
        var var$3, $lhs, $rhs, var$6, $rhs_0;
        if ($x1 instanceof oncie_And) {
            var$3 = $x1;
            $lhs = var$3.$lhs1;
            $rhs = var$3.$rhs1;
            oncirr_mergeInPredicates$_$callClinit();
            if (sc_IterableOnceOps_forall$(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression, [$lhs, $rhs])), new oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNeitherOrsNorInnerScopes$lambda$_7_0) && oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns(oncirr_mergeInPredicates$_MODULE$, sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression,
            [$lhs, $rhs])))) {
                if (oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots(oncirr_mergeInPredicates$_MODULE$, sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression, [$lhs, $rhs])))) {
                    $x1 = oncirr_mergeInPredicates$_MODULE$;
                    $default = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_0;
                    var$6 = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_1;
                    var$6.$_045 = var$3;
                    return oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$rewriteBinaryOperator($x1, var$3, $default, var$6);
                }
                if (!oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots(oncirr_mergeInPredicates$_MODULE$, sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression, [$lhs, $rhs]))))
                    return var$3;
                $x1 = oncirr_mergeInPredicates$_MODULE$;
                $default = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_2;
                var$6 = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_3;
                var$6.$_046 = var$3;
                return oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$rewriteBinaryOperator($x1, var$3, $default, var$6);
            }
        }
        if ($x1 instanceof oncie_Or) {
            var$6 = $x1;
            $lhs = var$6.$lhs2;
            $rhs_0 = var$6.$rhs2;
            oncirr_mergeInPredicates$_$callClinit();
            if (sc_IterableOnceOps_forall$(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression, [$lhs, $rhs_0])), new oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoAnds$lambda$_8_0) && oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns(oncirr_mergeInPredicates$_MODULE$, sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression,
            [$lhs, $rhs_0])))) {
                if (oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots(oncirr_mergeInPredicates$_MODULE$, sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression, [$lhs, $rhs_0])))) {
                    $x1 = oncirr_mergeInPredicates$_MODULE$;
                    $default = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_4;
                    var$3 = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_5;
                    var$3.$_047 = var$6;
                    return oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$rewriteBinaryOperator($x1, var$6, $default, var$3);
                }
                if (!oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots(oncirr_mergeInPredicates$_MODULE$, sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_Expression, [$lhs, $rhs_0]))))
                    return var$6;
                $x1 = oncirr_mergeInPredicates$_MODULE$;
                $default = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_6;
                var$3 = new oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_7;
                var$3.$_048 = var$6;
                return oncirr_mergeInPredicates$_org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$rewriteBinaryOperator($x1, var$6, $default, var$3);
            }
        }
        return $default.$apply($x1);
    }
    var oncirr_timestampRewriter$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirr_timestampRewriter$$anonfun$1_applyOrElse($this, $x1, $default) {
        var $datetimeFunction, $namespace, $x$1, $name;
        if ($x1 instanceof oncie_FunctionInvocation) {
            $datetimeFunction = $x1;
            $namespace = $datetimeFunction.$namespace1;
            $x$1 = $datetimeFunction.$functionName0;
            if ($x$1 !== null) {
                $name = $x$1.$name6;
                if (sci_List_isEmpty($namespace.$parts0) && jl_String_equalsIgnoreCase($name, $rt_s(111))) {
                    $x$1 = oncie_FunctionName__init_($rt_s(112), $datetimeFunction.$functionName0.$position6);
                    $datetimeFunction = oncie_FunctionInvocation_copy($datetimeFunction, $datetimeFunction.$namespace1, $x$1, $datetimeFunction.$distinct0, $datetimeFunction.$args, $datetimeFunction.$position7);
                    return oncie_Property__init_($datetimeFunction, oncie_PropertyKeyName__init_($rt_s(113), $datetimeFunction.$position7), $datetimeFunction.$position7);
                }
            }
        }
        return $default.$apply($x1);
    }
    var sr_ManifestFactory$ = $rt_classWithoutFields();
    var sr_ManifestFactory$_MODULE$ = null;
    var sr_ManifestFactory$_Byte = null;
    var sr_ManifestFactory$_Short = null;
    var sr_ManifestFactory$_Char = null;
    var sr_ManifestFactory$_Int = null;
    var sr_ManifestFactory$_Long = null;
    var sr_ManifestFactory$_Float = null;
    var sr_ManifestFactory$_Double = null;
    var sr_ManifestFactory$_Boolean = null;
    var sr_ManifestFactory$_Unit = null;
    var sr_ManifestFactory$_scala$reflect$ManifestFactory$$ObjectTYPE = null;
    var sr_ManifestFactory$_scala$reflect$ManifestFactory$$NothingTYPE = null;
    var sr_ManifestFactory$_scala$reflect$ManifestFactory$$NullTYPE = null;
    var sr_ManifestFactory$_Any = null;
    var sr_ManifestFactory$_Object0 = null;
    var sr_ManifestFactory$_AnyRef = null;
    var sr_ManifestFactory$_AnyVal = null;
    var sr_ManifestFactory$_Null = null;
    var sr_ManifestFactory$_Nothing = null;
    function sr_ManifestFactory$_$callClinit() {
        sr_ManifestFactory$_$callClinit = $rt_eraseClinit(sr_ManifestFactory$);
        sr_ManifestFactory$__clinit_();
    }
    function sr_ManifestFactory$__clinit_() {
        var var$1, var$2;
        var$1 = new sr_ManifestFactory$;
        sr_ManifestFactory$_$callClinit();
        sr_ManifestFactory$_MODULE$ = var$1;
        var$1 = new sr_ManifestFactory$ByteManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(114));
        sr_ManifestFactory$_Byte = var$1;
        var$1 = new sr_ManifestFactory$ShortManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(115));
        sr_ManifestFactory$_Short = var$1;
        var$1 = new sr_ManifestFactory$CharManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(116));
        sr_ManifestFactory$_Char = var$1;
        var$1 = new sr_ManifestFactory$IntManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(117));
        sr_ManifestFactory$_Int = var$1;
        var$1 = new sr_ManifestFactory$LongManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(118));
        sr_ManifestFactory$_Long = var$1;
        var$1 = new sr_ManifestFactory$FloatManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(119));
        sr_ManifestFactory$_Float = var$1;
        var$1 = new sr_ManifestFactory$DoubleManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(120));
        sr_ManifestFactory$_Double = var$1;
        var$1 = new sr_ManifestFactory$BooleanManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(121));
        sr_ManifestFactory$_Boolean = var$1;
        var$1 = new sr_ManifestFactory$UnitManifest;
        sr_AnyValManifest__init_(var$1, $rt_s(122));
        sr_ManifestFactory$_Unit = var$1;
        sr_ManifestFactory$_scala$reflect$ManifestFactory$$ObjectTYPE = $rt_cls(jl_Object);
        sr_ManifestFactory$_scala$reflect$ManifestFactory$$NothingTYPE = $rt_cls(sr_Nothing$);
        sr_ManifestFactory$_scala$reflect$ManifestFactory$$NullTYPE = $rt_cls(sr_Null$);
        var$2 = new sr_ManifestFactory$AnyManifest;
        sr_ManifestFactory$PhantomManifest__init_(var$2, $rt_cls(jl_Object), $rt_s(123));
        sr_ManifestFactory$_Any = var$2;
        var$1 = new sr_ManifestFactory$ObjectManifest;
        sr_ManifestFactory$PhantomManifest__init_(var$1, sr_ManifestFactory$_scala$reflect$ManifestFactory$$ObjectTYPE, $rt_s(124));
        sr_ManifestFactory$_Object0 = var$1;
        sr_ManifestFactory$_AnyRef = sr_ManifestFactory$_Object(sr_ManifestFactory$_MODULE$);
        var$1 = new sr_ManifestFactory$AnyValPhantomManifest;
        sr_ManifestFactory$PhantomManifest__init_(var$1, sr_ManifestFactory$_scala$reflect$ManifestFactory$$ObjectTYPE, $rt_s(125));
        sr_ManifestFactory$_AnyVal = var$1;
        var$1 = new sr_ManifestFactory$NullManifest;
        sr_ManifestFactory$PhantomManifest__init_(var$1, sr_ManifestFactory$_scala$reflect$ManifestFactory$$NullTYPE, $rt_s(126));
        sr_ManifestFactory$_Null = var$1;
        var$1 = new sr_ManifestFactory$NothingManifest;
        sr_ManifestFactory$PhantomManifest__init_(var$1, sr_ManifestFactory$_scala$reflect$ManifestFactory$$NothingTYPE, $rt_s(127));
        sr_ManifestFactory$_Nothing = var$1;
    }
    function sr_ManifestFactory$_Object($this) {
        sr_ManifestFactory$_$callClinit();
        return sr_ManifestFactory$_Object0;
    }
    var s_PartialFunction$ = $rt_classWithoutFields();
    var s_PartialFunction$_MODULE$ = null;
    var s_PartialFunction$_fallback_fn = null;
    var s_PartialFunction$_scala$PartialFunction$$constFalse = null;
    var s_PartialFunction$_empty_pf = null;
    function s_PartialFunction$__clinit_() {
        var var$1;
        s_PartialFunction$_MODULE$ = new s_PartialFunction$;
        s_PartialFunction$_fallback_fn = new s_PartialFunction$$_clinit_$lambda$_0_0;
        s_PartialFunction$_scala$PartialFunction$$constFalse = new s_PartialFunction$$_clinit_$lambda$_0_1;
        var$1 = new s_PartialFunction$$anon$1;
        var$1.$lift0 = new s_PartialFunction$$anon$1$_init_$lambda$_41_0;
        s_PartialFunction$_empty_pf = var$1;
    }
    function s_PartialFunction$_scala$PartialFunction$$fallbackOccurred($this, $x) {
        if (s_PartialFunction$_fallback_fn !== $x)
            return 0;
        return 1;
    }
    var sr_ClassManifestDeprecatedApis = $rt_classWithoutFields(0);
    var sr_ClassTag = $rt_classWithoutFields(0);
    function sr_ClassTag_unapply$($$this, $x) {
        return !jl_Class_isInstance($$this.$runtimeClass(), $x) ? s_None$_MODULE$ : s_Some__init_($x);
    }
    var sr_Manifest = $rt_classWithoutFields(0);
    function sr_AnyValManifest() {
        var a = this; jl_Object.call(a);
        a.$toString3 = null;
        a.$hashCode4 = 0;
    }
    function sr_AnyValManifest_equals($this, $that) {
        if ($this !== $that)
            return 0;
        return 1;
    }
    function sr_AnyValManifest_hashCode($this) {
        return $this.$hashCode4;
    }
    function sr_AnyValManifest__init_($this, $toString) {
        $this.$toString3 = $toString;
        $this.$hashCode4 = jl_Object_identity($this);
    }
    var sr_ManifestFactory$ByteManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$ByteManifest_runtimeClass($this) {
        return $rt_cls($rt_bytecls());
    }
    function sr_ManifestFactory$ByteManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Byte))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToByte($x);
        return s_Some__init_(jl_Byte_valueOf(var$2));
    }
    function sr_ManifestFactory$ByteManifest_newArray($this, $len) {
        return $rt_createByteArray($len);
    }
    var sr_ManifestFactory$ShortManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$ShortManifest_runtimeClass($this) {
        return $rt_cls($rt_shortcls());
    }
    function sr_ManifestFactory$ShortManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Short))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToShort($x);
        return s_Some__init_(jl_Short_valueOf(var$2));
    }
    function sr_ManifestFactory$ShortManifest_newArray($this, $len) {
        return $rt_createShortArray($len);
    }
    var sr_ManifestFactory$CharManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$CharManifest_runtimeClass($this) {
        return $rt_cls($rt_charcls());
    }
    function sr_ManifestFactory$CharManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Character))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToChar($x);
        return s_Some__init_(jl_Character_valueOf(var$2));
    }
    function sr_ManifestFactory$CharManifest_newArray($this, $len) {
        return $rt_createCharArray($len);
    }
    var sr_ManifestFactory$IntManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$IntManifest_runtimeClass($this) {
        return $rt_cls($rt_intcls());
    }
    function sr_ManifestFactory$IntManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Integer))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToInt($x);
        return s_Some__init_(jl_Integer_valueOf(var$2));
    }
    function sr_ManifestFactory$IntManifest_newArray($this, $len) {
        return $rt_createIntArray($len);
    }
    var sr_ManifestFactory$LongManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$LongManifest_runtimeClass($this) {
        return $rt_cls($rt_longcls());
    }
    function sr_ManifestFactory$LongManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Long))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToLong($x);
        return s_Some__init_(jl_Long_valueOf(var$2));
    }
    function sr_ManifestFactory$LongManifest_newArray($this, $len) {
        return $rt_createLongArray($len);
    }
    var sr_ManifestFactory$FloatManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$FloatManifest_runtimeClass($this) {
        return $rt_cls($rt_floatcls());
    }
    function sr_ManifestFactory$FloatManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Float))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToFloat($x);
        return s_Some__init_(jl_Float_valueOf(var$2));
    }
    function sr_ManifestFactory$FloatManifest_newArray($this, $len) {
        return $rt_createFloatArray($len);
    }
    var sr_ManifestFactory$DoubleManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$DoubleManifest_runtimeClass($this) {
        return $rt_cls($rt_doublecls());
    }
    function sr_ManifestFactory$DoubleManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Double))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToDouble($x);
        return s_Some__init_(jl_Double_valueOf(var$2));
    }
    function sr_ManifestFactory$DoubleManifest_newArray($this, $len) {
        return $rt_createDoubleArray($len);
    }
    var sr_ManifestFactory$BooleanManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$BooleanManifest_runtimeClass($this) {
        return $rt_cls($rt_booleancls());
    }
    function sr_ManifestFactory$BooleanManifest_unapply($this, $x) {
        var var$2;
        if (!($x instanceof jl_Boolean))
            return s_None$_MODULE$;
        var$2 = sr_BoxesRunTime_unboxToBoolean($x);
        return s_Some__init_(jl_Boolean_valueOf(var$2));
    }
    function sr_ManifestFactory$BooleanManifest_newArray($this, $len) {
        return $rt_createBooleanArray($len);
    }
    var sr_ManifestFactory$UnitManifest = $rt_classWithoutFields(sr_AnyValManifest);
    function sr_ManifestFactory$UnitManifest_runtimeClass($this) {
        return $rt_cls($rt_voidcls());
    }
    function sr_ManifestFactory$UnitManifest_unapply($this, $x) {
        if (!($x instanceof sr_BoxedUnit))
            return s_None$_MODULE$;
        return s_Some__init_(sr_BoxedUnit_UNIT);
    }
    function sr_ManifestFactory$UnitManifest_newArray($this, $len) {
        return $rt_createArray(sr_BoxedUnit, $len);
    }
    var sr_Nothing$ = $rt_classWithoutFields(jl_Throwable);
    var sr_Null$ = $rt_classWithoutFields();
    function sr_ManifestFactory$ClassTypeManifest() {
        var a = this; jl_Object.call(a);
        a.$prefix = null;
        a.$runtimeClass0 = null;
        a.$typeArguments = null;
    }
    function sr_ManifestFactory$ClassTypeManifest_unapply($this, $x) {
        return sr_ClassTag_unapply$($this, $x);
    }
    function sr_ManifestFactory$ClassTypeManifest_runtimeClass($this) {
        return $this.$runtimeClass0;
    }
    function sr_ManifestFactory$PhantomManifest() {
        var a = this; sr_ManifestFactory$ClassTypeManifest.call(a);
        a.$toString4 = null;
        a.$hashCode5 = 0;
    }
    function sr_ManifestFactory$PhantomManifest_equals($this, $that) {
        if ($this !== $that)
            return 0;
        return 1;
    }
    function sr_ManifestFactory$PhantomManifest_hashCode($this) {
        return $this.$hashCode5;
    }
    function sr_ManifestFactory$PhantomManifest__init_($this, $_runtimeClass, $toString) {
        var var$3;
        $this.$toString4 = $toString;
        var$3 = s_None$_MODULE$;
        $toString = sci_Nil$_MODULE$;
        $this.$prefix = var$3;
        $this.$runtimeClass0 = $_runtimeClass;
        $this.$typeArguments = $toString;
        $this.$hashCode5 = jl_Object_identity($this);
    }
    var sr_ManifestFactory$AnyManifest = $rt_classWithoutFields(sr_ManifestFactory$PhantomManifest);
    function sr_ManifestFactory$AnyManifest_newArray($this, $len) {
        return $rt_createArray(jl_Object, $len);
    }
    var sr_ManifestFactory$ObjectManifest = $rt_classWithoutFields(sr_ManifestFactory$PhantomManifest);
    function sr_ManifestFactory$ObjectManifest_newArray($this, $len) {
        return $rt_createArray(jl_Object, $len);
    }
    var sr_ManifestFactory$AnyValPhantomManifest = $rt_classWithoutFields(sr_ManifestFactory$PhantomManifest);
    var sr_ManifestFactory$NullManifest = $rt_classWithoutFields(sr_ManifestFactory$PhantomManifest);
    function sr_ManifestFactory$NullManifest_newArray($this, $len) {
        return $rt_createArray(jl_Object, $len);
    }
    var sr_ManifestFactory$NothingManifest = $rt_classWithoutFields(sr_ManifestFactory$PhantomManifest);
    function sr_ManifestFactory$NothingManifest_newArray($this, $len) {
        return $rt_createArray(jl_Object, $len);
    }
    var s_PartialFunction$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    function s_PartialFunction$$_clinit_$lambda$_0_0_apply(var$0, var$1) {
        return s_PartialFunction$_fallback_fn;
    }
    var s_PartialFunction$$_clinit_$lambda$_0_1 = $rt_classWithoutFields();
    function s_PartialFunction$$anon$1() {
        jl_Object.call(this);
        this.$lift0 = null;
    }
    function s_PartialFunction$$anon$1_applyOrElse($this, $x, $default) {
        return $x.$asCanonicalStringVal();
    }
    function s_PartialFunction$$anon$1_orElse($this, $that) {
        return $that;
    }
    function s_PartialFunction$$anon$1_apply($this, $v1) {
        $rt_throw(s_MatchError__init_($v1));
    }
    var jl_System = $rt_classWithoutFields();
    var jl_System_outCache = null;
    var jl_System_errCache = null;
    var jl_System_inCache = null;
    var jl_System_properties = null;
    function jl_System_arraycopy($src, $srcPos, $dest, $destPos, $length) {
        var $srcType, $targetType, $srcArray, $i, var$10, var$11, var$12;
        if ($src !== null && $dest !== null) {
            if ($srcPos >= 0 && $destPos >= 0 && $length >= 0 && ($srcPos + $length | 0) <= jlr_Array_getLength($src) && ($destPos + $length | 0) <= jlr_Array_getLength($dest)) {
                a: {
                    b: {
                        if ($src !== $dest) {
                            $srcType = jl_Class_getComponentType(jl_Object_getClass($src));
                            $targetType = jl_Class_getComponentType(jl_Object_getClass($dest));
                            if ($srcType !== null && $targetType !== null) {
                                if ($srcType === $targetType)
                                    break b;
                                if (!jl_Class_isPrimitive($srcType) && !jl_Class_isPrimitive($targetType)) {
                                    $srcArray = $src;
                                    $i = 0;
                                    var$10 = $srcPos;
                                    while ($i < $length) {
                                        var$11 = $srcArray.data;
                                        var$12 = var$10 + 1 | 0;
                                        if (!jl_Class_isInstance($targetType, var$11[var$10])) {
                                            jl_System_doArrayCopy($src, $srcPos, $dest, $destPos, $i);
                                            $src = new jl_ArrayStoreException;
                                            jl_Throwable__init_0($src);
                                            $rt_throw($src);
                                        }
                                        $i = $i + 1 | 0;
                                        var$10 = var$12;
                                    }
                                    jl_System_doArrayCopy($src, $srcPos, $dest, $destPos, $length);
                                    return;
                                }
                                if (!jl_Class_isPrimitive($srcType))
                                    break a;
                                if (jl_Class_isPrimitive($targetType))
                                    break b;
                                else
                                    break a;
                            }
                            $src = new jl_ArrayStoreException;
                            jl_Throwable__init_0($src);
                            $rt_throw($src);
                        }
                    }
                    jl_System_doArrayCopy($src, $srcPos, $dest, $destPos, $length);
                    return;
                }
                $src = new jl_ArrayStoreException;
                jl_Throwable__init_0($src);
                $rt_throw($src);
            }
            $src = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_0($src);
            $rt_throw($src);
        }
        $dest = new jl_NullPointerException;
        jl_Throwable__init_($dest, $rt_s(128));
        $rt_throw($dest);
    }
    function jl_System_doArrayCopy(var$1, var$2, var$3, var$4, var$5) {
        if (var$1 !== var$3 || var$4 < var$2) {
            for (var i = 0; i < var$5; i = (i + 1) | 0) {
                var$3.data[var$4++] = var$1.data[var$2++];
            }
        } else {
            var$2 = (var$2 + var$5) | 0;
            var$4 = (var$4 + var$5) | 0;
            for (var i = 0; i < var$5; i = (i + 1) | 0) {
                var$3.data[--var$4] = var$1.data[--var$2];
            }
        }
    }
    function jl_System_currentTimeMillis() {
        return Long_fromNumber(new Date().getTime());
    }
    function jl_System_getProperty($key) {
        var var$2, var$3;
        if (jl_System_properties === null) {
            var$2 = new ju_Properties;
            ju_Hashtable__init_(var$2);
            ju_Hashtable_put(var$2, $rt_s(129), $rt_s(130));
            ju_Hashtable_put(var$2, $rt_s(131), $rt_s(132));
            ju_Hashtable_put(var$2, $rt_s(133), $rt_s(134));
            ju_Hashtable_put(var$2, $rt_s(135), $rt_s(136));
            ju_Hashtable_put(var$2, $rt_s(137), $rt_s(66));
            ju_Hashtable_put(var$2, $rt_s(138), $rt_s(139));
            ju_Hashtable_put(var$2, $rt_s(140), $rt_s(130));
            ju_Hashtable_put(var$2, $rt_s(141), $rt_s(134));
            var$3 = new ju_Properties;
            ju_Hashtable__init_(var$3);
            var$3.$defaults = var$2;
            jl_System_properties = var$3;
        }
        return ju_Properties_getProperty(jl_System_properties, $key);
    }
    function jl_System_getProperty0($key, $def) {
        var $value;
        $value = jl_System_getProperty($key);
        if ($value !== null)
            $def = $value;
        return $def;
    }
    var s_PartialFunction$$anon$1$_init_$lambda$_41_0 = $rt_classWithoutFields();
    var onciap_ExpressionStringifier = $rt_classWithoutFields(0);
    function onciap_DefaultExpressionStringifier() {
        var a = this; jl_Object.call(a);
        a.$Syntactic$module = null;
        a.$extension = null;
        a.$alwaysParens = 0;
        a.$alwaysBacktick = 0;
        a.$preferSingleQuotes = 0;
        a.$sensitiveParamsAsParams = 0;
        a.$patterns = null;
        a.$pathSteps = null;
        a.$prettifier = null;
    }
    function onciap_DefaultExpressionStringifier_Syntactic($this) {
        var var$1, $$je;
        if ($this.$Syntactic$module === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$Syntactic$module !== null)
                        break a;
                    $this.$Syntactic$module = onciap_DefaultExpressionStringifier$Syntactic$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$Syntactic$module;
    }
    function onciap_DefaultExpressionStringifier_patterns($this) {
        return $this.$patterns;
    }
    function onciap_DefaultExpressionStringifier_pathSteps($this) {
        return $this.$pathSteps;
    }
    function onciap_DefaultExpressionStringifier_prettifier($this) {
        return $this.$prettifier;
    }
    function onciap_DefaultExpressionStringifier_apply($this, $ast) {
        return onciap_DefaultExpressionStringifier_stringify($this, $ast);
    }
    function onciap_DefaultExpressionStringifier_apply0($this, $s) {
        return onciap_DefaultExpressionStringifier_backtick($this, $s.$name3());
    }
    function onciap_DefaultExpressionStringifier_apply1($this, $ns) {
        var var$2;
        var$2 = $ns.$parts0;
        $ns = new onciap_DefaultExpressionStringifier$apply$lambda$_7_0;
        $ns.$_049 = $this;
        return sc_AbstractIterable_mkString0(sci_List_map(var$2, $ns), $rt_s(142));
    }
    function onciap_DefaultExpressionStringifier_inner($this, $outer, $inner) {
        var $str, var$4, var$5, var$6;
        $str = onciap_DefaultExpressionStringifier_stringify($this, $inner);
        if (!$this.$alwaysParens) {
            a: {
                var$4 = s_Tuple2__init_(onciap_DefaultExpressionStringifier_binding($this, $outer), onciap_DefaultExpressionStringifier_binding($this, $inner));
                $outer = var$4.$_20;
                if (jl_Object_equals(onciap_DefaultExpressionStringifier_Syntactic($this), $outer))
                    var$5 = 0;
                else {
                    $outer = var$4.$_10;
                    if (jl_Object_equals(onciap_DefaultExpressionStringifier_Syntactic($this), $outer))
                        var$5 = 0;
                    else {
                        $outer = var$4.$_10;
                        $inner = var$4.$_20;
                        if ($outer instanceof onciap_DefaultExpressionStringifier$Precedence) {
                            var$6 = $outer.$level;
                            if ($inner instanceof onciap_DefaultExpressionStringifier$Precedence) {
                                var$5 = $inner.$level < var$6 ? 0 : 1;
                                break a;
                            }
                        }
                        $rt_throw(s_MatchError__init_(var$4));
                    }
                }
            }
            if (!var$5)
                return $str;
        }
        $outer = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($outer);
        jl_AbstractStringBuilder_append($outer, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append($outer, $str), 41);
        return jl_AbstractStringBuilder_toString($outer);
    }
    function onciap_DefaultExpressionStringifier_stringify($this, $ast) {
        var $name, $relChain, $variable, $namespace, $functionName, $distinct, $args, $ns, $np, $ds, $as, $m, $k, $arg, $predicateType, $exp, $idx, $list, $start, $end, $l, $r, $s, $expression, $v, $p, $e, $expr, $predicate, $proj, $w, $b, $itemsText, $allItems, $alternatives, $default, $expressions, $chain, $head, $ands, $pattern, $pathStep, $init, $acc, $identifier, $a, $i, $q, $inner, $rel, $relList, $rel1, $rel2, $relName, $bound, $elementIdExpr, $prefix;
        if ($ast instanceof oncie_StringLiteral)
            return onciap_DefaultExpressionStringifier_quote($this, oncie_StringLiteral_value($ast));
        if ($rt_isInstance($ast, oncie_Literal))
            return $ast.$asCanonicalStringVal();
        if ($rt_isInstance($ast, oncie_BinaryOperatorExpression)) {
            $name = $ast;
            $relChain = onciap_DefaultExpressionStringifier_inner($this, $ast, $name.$lhs0());
            $variable = $ast.$canonicalOperatorSymbol();
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $name.$rhs0());
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($name, $relChain), 32), $variable), 32), $ast);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_Variable)
            return onciap_DefaultExpressionStringifier_backtick($this, oncie_Variable_name($ast));
        if ($ast instanceof oncie_ListLiteral)
            return sc_AbstractIterable_mkString((oncie_ListLiteral_expressions($ast)).$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_0__init_($this)), $rt_s(143), $rt_s(16), $rt_s(144));
        if ($ast instanceof oncie_FunctionInvocation) {
            $name = $ast;
            $namespace = oncie_FunctionInvocation_namespace($name);
            $functionName = oncie_FunctionInvocation_functionName($name);
            $distinct = oncie_FunctionInvocation_distinct($name);
            $args = oncie_FunctionInvocation_args($name);
            $ns = onciap_DefaultExpressionStringifier_apply1($this, $namespace);
            $np = !sci_List_isEmpty(oncie_Namespace_parts($namespace)) ? $rt_s(142) : $rt_s(3);
            $ds = !$distinct ? $rt_s(3) : $rt_s(145);
            $as = sc_AbstractIterable_mkString0($args.$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_1__init_($this, $ast)), $rt_s(16));
            $ast = onciap_DefaultExpressionStringifier_apply0($this, $functionName);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $ns), $np), $ast), 40), $ds), $as), 41);
            return jl_StringBuilder_toString($name);
        }
        if ($rt_isInstance($ast, oncief_UserDefinedFunctionInvocation))
            return onciap_DefaultExpressionStringifier_apply($this, $ast.$asUnresolvedFunction());
        if ($ast instanceof oncie_Property) {
            $name = $ast;
            $m = oncie_Property_map($name);
            $k = oncie_Property_propertyKey($name);
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $m);
            $name = onciap_DefaultExpressionStringifier_apply0($this, $k);
            $relChain = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($relChain, $ast), 46), $name);
            return jl_StringBuilder_toString($relChain);
        }
        if ($ast instanceof oncie_MapExpression)
            return sc_AbstractIterable_mkString((oncie_MapExpression_items($ast)).$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_2__init_($this)), $rt_s(146), $rt_s(16), $rt_s(147));
        if ($rt_isInstance($ast, oncie_Parameter)) {
            $name = $ast;
            $name = oncie_Parameter$_unapply(oncie_Parameter$_MODULE$, $name);
            if (!s_Option_isEmpty($name)) {
                $ast = onciap_DefaultExpressionStringifier_backtick($this, s_Tuple3__1(s_Some_get($name)));
                $name = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append4($name, 36), $ast);
                return jl_StringBuilder_toString($name);
            }
        }
        if ($ast instanceof oncie_CountStar)
            return $rt_s(148);
        if ($ast instanceof oncie_IsNull) {
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, oncie_IsNull_lhs($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $ast), $rt_s(149));
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_IsNotNull) {
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, oncie_IsNotNull_lhs($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $ast), $rt_s(150));
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncia_IsTyped) {
            $name = $ast;
            $arg = oncia_IsTyped_lhs($name);
            $predicateType = oncia_IsTyped_typeName($name);
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $arg);
            $name = oncia_IsTyped_canonicalOperatorSymbol($name);
            $relChain = $predicateType.$description();
            $variable = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($variable, $ast), 32), $name), 32), $relChain);
            return jl_StringBuilder_toString($variable);
        }
        if ($ast instanceof oncia_IsNotTyped) {
            $name = $ast;
            $arg = oncia_IsNotTyped_lhs($name);
            $predicateType = oncia_IsNotTyped_typeName($name);
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $arg);
            $name = oncia_IsNotTyped_canonicalOperatorSymbol($name);
            $relChain = $predicateType.$description();
            $variable = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($variable, $ast), 32), $name), 32), $relChain);
            return jl_StringBuilder_toString($variable);
        }
        if ($ast instanceof oncie_ContainerIndex) {
            $name = $ast;
            $exp = oncie_ContainerIndex_expr($name);
            $idx = oncie_ContainerIndex_idx($name);
            $name = onciap_DefaultExpressionStringifier_inner($this, $ast, $exp);
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $idx);
            $relChain = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($relChain, $name), 91), $ast), 93);
            return jl_StringBuilder_toString($relChain);
        }
        if ($ast instanceof oncie_ListSlice) {
            $name = $ast;
            $list = oncie_ListSlice_list($name);
            $start = oncie_ListSlice_from($name);
            $end = oncie_ListSlice_to($name);
            $l = s_Option_getOrElse(s_Option_map($start, onciap_DefaultExpressionStringifier$stringify$lambda$_9_3__init_($this, $ast)), onciap_DefaultExpressionStringifier$stringify$lambda$_9_4__init_());
            $r = s_Option_getOrElse(s_Option_map($end, onciap_DefaultExpressionStringifier$stringify$lambda$_9_5__init_($this, $ast)), onciap_DefaultExpressionStringifier$stringify$lambda$_9_6__init_());
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $list);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($name, $ast), 91), $l), $rt_s(151)), $r), 93);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_PatternExpression) {
            $name = oncie_PatternExpression_pattern($ast);
            if ($name !== null) {
                $relChain = oncie_RelationshipsPattern_element($name);
                return onciap_DefaultPatternStringifier_apply(onciap_DefaultExpressionStringifier_patterns($this), $relChain);
            }
        }
        if ($ast instanceof oncie_AnyIterablePredicate) {
            $ast = $ast;
            $ast = onciap_DefaultExpressionStringifier_prettyScope($this, oncie_AnyIterablePredicate_scope($ast), oncie_AnyIterablePredicate_expression($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(152)), $ast);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_Not) {
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, oncie_Not_rhs($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(153)), $ast);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_ListComprehension) {
            $name = $ast;
            $s = oncie_ListComprehension_scope($name);
            $expression = oncie_ListComprehension_expression($name);
            $v = onciap_DefaultExpressionStringifier_apply($this, oncie_ExtractScope_variable($s));
            $p = s_Option_getOrElse(s_Option_map(oncie_ExtractScope_innerPredicate($s), onciap_DefaultExpressionStringifier$stringify$lambda$_9_7__init_($this, $ast)), onciap_DefaultExpressionStringifier$stringify$lambda$_9_8__init_());
            $e = s_Option_getOrElse(s_Option_map(oncie_ExtractScope_extractExpression($s), onciap_DefaultExpressionStringifier$stringify$lambda$_9_9__init_($this, $ast)), onciap_DefaultExpressionStringifier$stringify$lambda$_9_10__init_());
            $expr = onciap_DefaultExpressionStringifier_inner($this, $ast, $expression);
            $ast = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4($ast, 91), $v), $rt_s(154)), $expr), $p), $e), 93);
            return jl_StringBuilder_toString($ast);
        }
        if ($ast instanceof oncie_PatternComprehension) {
            $name = $ast;
            $variable = oncie_PatternComprehension_namedPath($name);
            $relChain = oncie_PatternComprehension_pattern($name);
            $predicate = oncie_PatternComprehension_predicate($name);
            $proj = oncie_PatternComprehension_projection($name);
            if ($relChain !== null) {
                $relChain = oncie_RelationshipsPattern_element($relChain);
                $v = s_Option_getOrElse(s_Option_map(s_Option_map($variable, onciap_DefaultExpressionStringifier$stringify$lambda$_9_11__init_($this)), onciap_DefaultExpressionStringifier$stringify$lambda$_9_12__init_()), onciap_DefaultExpressionStringifier$stringify$lambda$_9_13__init_());
                $p = onciap_DefaultPatternStringifier_apply(onciap_DefaultExpressionStringifier_patterns($this), $relChain);
                $w = s_Option_getOrElse(s_Option_map(s_Option_map($predicate, onciap_DefaultExpressionStringifier$stringify$lambda$_9_14__init_($this, $ast)), onciap_DefaultExpressionStringifier$stringify$lambda$_9_15__init_()), onciap_DefaultExpressionStringifier$stringify$lambda$_9_16__init_());
                $b = onciap_DefaultExpressionStringifier_inner($this, $ast, $proj);
                $ast = jl_StringBuilder__init_1();
                jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4($ast, 91), $v), $p), $w), $rt_s(155)), $b), 93);
                return jl_StringBuilder_toString($ast);
            }
        }
        if ($ast instanceof oncie_HasLabelsOrTypes) {
            $name = $ast;
            $arg = $name.$entityExpression();
            $l = (($name.$labelsOrTypes()).$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_17__init_($this))).$mkString0($rt_s(136), $rt_s(136), $rt_s(3));
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $arg);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $ast), $l);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_HasLabels) {
            $name = $ast;
            $arg = $name.$expression1();
            $l = (($name.$labels()).$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_18__init_($this))).$mkString0($rt_s(136), $rt_s(136), $rt_s(3));
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $arg);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $ast), $l);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_HasTypes) {
            $name = $ast;
            $arg = $name.$expression1();
            $l = (($name.$types0()).$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_19__init_($this))).$mkString0($rt_s(136), $rt_s(136), $rt_s(3));
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $arg);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $ast), $l);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncil_LabelExpressionPredicate) {
            $name = $ast;
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, oncil_LabelExpressionPredicate_entity($name));
            $name = onciap_DefaultExpressionStringifier_stringifyLabelExpression($this, oncil_LabelExpressionPredicate_labelExpression($name));
            $relChain = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($relChain, $ast), 58), $name);
            return jl_StringBuilder_toString($relChain);
        }
        if ($ast instanceof oncie_AllIterablePredicate) {
            $ast = $ast;
            $ast = onciap_DefaultExpressionStringifier_prettyScope($this, oncie_AllIterablePredicate_scope($ast), oncie_AllIterablePredicate_expression($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(156)), $ast);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_NoneIterablePredicate) {
            $ast = $ast;
            $ast = onciap_DefaultExpressionStringifier_prettyScope($this, oncie_NoneIterablePredicate_scope($ast), oncie_NoneIterablePredicate_expression($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(157)), $ast);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_SingleIterablePredicate) {
            $ast = $ast;
            $ast = onciap_DefaultExpressionStringifier_prettyScope($this, oncie_SingleIterablePredicate_scope($ast), oncie_SingleIterablePredicate_expression($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(158)), $ast);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_MapProjection) {
            $ast = $ast;
            $variable = oncie_MapProjection_name($ast);
            $itemsText = sc_AbstractIterable_mkString0((oncie_MapProjection_items($ast)).$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_20__init_($this)), $rt_s(16));
            $ast = onciap_DefaultExpressionStringifier_apply($this, $variable);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($name, $ast), 123), $itemsText), 125);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_DesugaredMapProjection) {
            $ast = $ast;
            $variable = $ast.$variable2();
            $allItems = $ast.$items0();
            if ($ast.$includeAllProps()) {
                $ast = new oncie_AllPropertiesSelector;
                onciu_InputPosition$_$callClinit();
                oncie_AllPropertiesSelector__init_($ast, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
                $allItems = $allItems.$$colon$plus($ast);
            }
            $itemsText = ($allItems.$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_21__init_($this))).$mkString($rt_s(16));
            $ast = onciap_DefaultExpressionStringifier_apply($this, $variable);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($name, $ast), 123), $itemsText), 125);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_LiteralEntry) {
            $name = $ast;
            $k = oncie_LiteralEntry_key($name);
            $e = oncie_LiteralEntry_exp($name);
            $name = onciap_DefaultExpressionStringifier_apply0($this, $k);
            $ast = onciap_DefaultExpressionStringifier_inner($this, $ast, $e);
            $relChain = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($relChain, $name), $rt_s(10)), $ast);
            return jl_StringBuilder_toString($relChain);
        }
        if ($ast instanceof oncie_VariableSelector)
            return onciap_DefaultExpressionStringifier_apply($this, oncie_VariableSelector_id($ast));
        if ($ast instanceof oncie_PropertySelector) {
            $ast = onciap_DefaultExpressionStringifier_apply0($this, oncie_PropertySelector_key($ast));
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4($name, 46), $ast);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_AllPropertiesSelector)
            return $rt_s(159);
        if ($ast instanceof oncie_CaseExpression) {
            $name = $ast;
            $expression = oncie_CaseExpression_expression($name);
            $alternatives = oncie_CaseExpression_alternatives($name);
            $default = oncie_CaseExpression_default($name);
            $relChain = sci_$colon$colon__init_(sci_$colon$colon__init_($rt_s(160), sci_Nil$_MODULE$), sci_$colon$colon__init_(((s_Option$_option2Iterable(s_Option$_MODULE$, $expression)).$toSeq()).$flatMap(onciap_DefaultExpressionStringifier$stringify$lambda$_9_22__init_($this, $ast)), sci_$colon$colon__init_(sc_IterableOps$WithFilter_flatMap(sc_AbstractIterable_withFilter($alternatives, onciap_DefaultExpressionStringifier$stringify$lambda$_9_23__init_()), onciap_DefaultExpressionStringifier$stringify$lambda$_9_24__init_($this,
            $ast)), sci_$colon$colon__init_(((s_Option$_option2Iterable(s_Option$_MODULE$, $default)).$toSeq()).$flatMap(onciap_DefaultExpressionStringifier$stringify$lambda$_9_25__init_($this, $ast)), sci_$colon$colon__init_(sci_$colon$colon__init_($rt_s(161), sci_Nil$_MODULE$), sci_Nil$_MODULE$)))));
            s_Predef$_$callClinit();
            return sc_AbstractIterable_mkString0(sci_List_flatten($relChain, s_Predef$_$conforms(s_Predef$_MODULE$)), $rt_s(162));
        }
        if ($ast instanceof oncie_Ands) {
            $expressions = oncie_Ands_exprs($ast);
            $name = onciap_DefaultExpressionStringifier_findChain$1($expressions);
            if (!($name instanceof s_Some)) {
                if (!jl_Object_equals(s_None$_MODULE$, $name))
                    $rt_throw(s_MatchError__init_($name));
                return sc_AbstractIterable_mkString0(sci_ListSet_map($expressions, onciap_DefaultExpressionStringifier$stringify$lambda$_9_27__init_($this, $ast)), $rt_s(163));
            }
            $chain = s_Some_value($name);
            $head = onciap_DefaultExpressionStringifier_apply($this, $chain.$head());
            return sc_AbstractIterable_mkString0(sci_List_$colon$colon(sci_List_flatMap($chain.$tail(), onciap_DefaultExpressionStringifier$stringify$lambda$_9_26__init_($this, $ast)), $head), $rt_s(162));
        }
        if ($ast instanceof oncie_AndsReorderable) {
            $expressions = $ast.$exprs();
            $ands = new oncie_Ands;
            onciu_InputPosition$_$callClinit();
            oncie_Ands__init_($ands, $expressions, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
            $ast = onciap_DefaultExpressionStringifier_apply($this, $ands);
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4($name, 40), $ast), 41);
            return jl_StringBuilder_toString($name);
        }
        if ($ast instanceof oncie_AndedPropertyInequalities)
            return ((($ast.$inequalities()).$map5(onciap_DefaultExpressionStringifier$stringify$lambda$_9_28__init_($this))).$toIndexedSeq()).$mkString($rt_s(163));
        if ($ast instanceof oncie_Ors)
            return (($ast.$exprs()).$map1(onciap_DefaultExpressionStringifier$stringify$lambda$_9_29__init_($this, $ast))).$mkString($rt_s(164));
        if ($ast instanceof oncie_ShortestPathExpression) {
            $pattern = oncie_ShortestPathExpression_pattern($ast);
            return onciap_DefaultPatternStringifier_apply0(onciap_DefaultExpressionStringifier_patterns($this), $pattern);
        }
        if ($ast instanceof oncie_PathExpression) {
            $pathStep = $ast.$step();
            return onciap_DefaultPathStepStringifier_apply(onciap_DefaultExpressionStringifier_pathSteps($this), $pathStep);
        }
        if ($ast instanceof oncie_ReduceExpression) {
            $name = $ast;
            $relChain = oncie_ReduceExpression_scope($name);
            $init = oncie_ReduceExpression_init($name);
            $list = oncie_ReduceExpression_list($name);
            if ($relChain !== null) {
                $name = oncie_ReduceScope_accumulator($relChain);
                $variable = oncie_ReduceScope_variable($relChain);
                $expression = oncie_ReduceScope_expression($relChain);
                if ($name instanceof oncie_Variable) {
                    $acc = oncie_Variable_name($name);
                    if ($variable instanceof oncie_Variable) {
                        $identifier = oncie_Variable_name($variable);
                        $a = onciap_DefaultExpressionStringifier_backtick($this, $acc);
                        $v = onciap_DefaultExpressionStringifier_backtick($this, $identifier);
                        $i = onciap_DefaultExpressionStringifier_inner($this, $ast, $init);
                        $l = onciap_DefaultExpressionStringifier_inner($this, $ast, $list);
                        $e = onciap_DefaultExpressionStringifier_inner($this, $ast, $expression);
                        $ast = jl_StringBuilder__init_1();
                        jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ast, $rt_s(165)), $a), $rt_s(71)), $i), $rt_s(16)), $v), $rt_s(154)), $l), $rt_s(155)), $e), 41);
                        return jl_StringBuilder_toString($ast);
                    }
                }
            }
        }
        if ($ast instanceof oncie_ExtractScope ? 1 : $ast instanceof oncie_FilterScope ? 1 : !($ast instanceof oncie_ReduceScope) ? 0 : 1)
            return $rt_s(3);
        if ($ast instanceof oncia_ExistsExpression) {
            $q = oncia_ExistsExpression_query($ast);
            $p = onciap_Prettifier_asString(onciap_DefaultExpressionStringifier_prettifier($this), $q);
            $ast = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ast, $rt_s(166)), $p), $rt_s(167));
            return jl_StringBuilder_toString($ast);
        }
        if ($ast instanceof oncia_CollectExpression) {
            $q = oncia_CollectExpression_query($ast);
            $p = onciap_Prettifier_asString(onciap_DefaultExpressionStringifier_prettifier($this), $q);
            $ast = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ast, $rt_s(168)), $p), $rt_s(167));
            return jl_StringBuilder_toString($ast);
        }
        if ($ast instanceof oncia_CountExpression) {
            $q = oncia_CountExpression_query($ast);
            $p = onciap_Prettifier_asString(onciap_DefaultExpressionStringifier_prettifier($this), $q);
            $ast = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ast, $rt_s(169)), $p), $rt_s(167));
            return jl_StringBuilder_toString($ast);
        }
        if ($ast instanceof oncie_UnaryAdd) {
            $i = onciap_DefaultExpressionStringifier_inner($this, $ast, oncie_UnaryAdd_rhs($ast));
            $ast = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4($ast, 43), $i);
            return jl_StringBuilder_toString($ast);
        }
        if ($ast instanceof oncie_UnarySubtract) {
            $i = onciap_DefaultExpressionStringifier_inner($this, $ast, oncie_UnarySubtract_rhs($ast));
            $ast = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append4($ast, 45), $i);
            return jl_StringBuilder_toString($ast);
        }
        if ($ast instanceof oncie_CoerceTo)
            return onciap_DefaultExpressionStringifier_apply($this, $ast.$expr0());
        if ($ast instanceof oncilp_CoerceToPredicate) {
            $inner = onciap_DefaultExpressionStringifier_apply($this, $ast.$inner2());
            $ast = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($ast, $rt_s(170)), $inner), 41);
            return jl_StringBuilder_toString($ast);
        }
        if ($ast instanceof oncie_AssertIsNode) {
            $ast = onciap_DefaultExpressionStringifier_apply($this, $ast.$lhs0());
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(171)), $ast), 41);
            return jl_StringBuilder_toString($name);
        }
        if (!($ast instanceof oncie_ElementIdToLongId)) {
            if ($ast instanceof oncie_NoneOfRelationships) {
                $ast = $ast;
                $rel = $ast.$relationship0();
                $relList = $ast.$listOfRelationships();
                $ast = onciap_DefaultExpressionStringifier_apply($this, $rel);
                $name = onciap_DefaultExpressionStringifier_apply($this, $relList);
                $relChain = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($relChain, $rt_s(153)), $ast), $rt_s(154)), $name);
                return jl_StringBuilder_toString($relChain);
            }
            if ($ast instanceof oncie_DifferentRelationships) {
                $ast = $ast;
                $rel1 = $ast.$rel1();
                $rel2 = $ast.$rel2();
                $ast = onciap_DefaultExpressionStringifier_apply($this, $rel1);
                $name = onciap_DefaultExpressionStringifier_apply($this, $rel2);
                $relChain = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($relChain, $rt_s(153)), $ast), $rt_s(71)), $name);
                return jl_StringBuilder_toString($relChain);
            }
            if ($ast instanceof oncie_Disjoint) {
                $ast = $ast;
                $rel1 = $ast.$lhs0();
                $rel2 = $ast.$rhs0();
                $ast = onciap_DefaultExpressionStringifier_apply($this, $rel1);
                $name = onciap_DefaultExpressionStringifier_apply($this, $rel2);
                $relChain = jl_StringBuilder__init_1();
                jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($relChain, $rt_s(172)), $ast), $rt_s(16)), $name), 41);
                return jl_StringBuilder_toString($relChain);
            }
            if ($ast instanceof oncie_Unique) {
                $ast = onciap_DefaultExpressionStringifier_apply($this, $ast.$rhs0());
                $name = jl_StringBuilder__init_1();
                jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(173)), $ast), 41);
                return jl_StringBuilder_toString($name);
            }
            if ($ast instanceof oncie_VarLengthLowerBound) {
                $ast = $ast;
                $relName = $ast.$relName();
                $bound = $ast.$bound();
                $ast = onciap_DefaultExpressionStringifier_apply($this, $relName);
                $name = jl_StringBuilder__init_1();
                jl_StringBuilder_append2(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(174)), $ast), $rt_s(175)), $bound);
                return jl_StringBuilder_toString($name);
            }
            if ($ast instanceof oncie_VarLengthUpperBound) {
                $ast = $ast;
                $relName = $ast.$relName();
                $bound = $ast.$bound();
                $ast = onciap_DefaultExpressionStringifier_apply($this, $relName);
                $name = jl_StringBuilder__init_1();
                jl_StringBuilder_append2(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(174)), $ast), $rt_s(176)), $bound);
                return jl_StringBuilder_toString($name);
            }
            if (!($ast instanceof oncie_IsRepeatTrailUnique))
                return onciap_ExpressionStringifier$Extension$$anon$1_apply($this.$extension, $this, $ast);
            $ast = onciap_DefaultExpressionStringifier_apply($this, $ast.$variableToCheck());
            $name = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(177)), $ast), 41);
            return jl_StringBuilder_toString($name);
        }
        $ast = $ast;
        $elementIdExpr = $ast.$elementIdExpr();
        $name = $ast.$entityType();
        $relChain = $ast.$mode();
        if (jl_Object_equals(oncie_NODE_TYPE$_MODULE$, $name) && jl_Object_equals(oncie_ElementIdToLongId$Mode$Single$_MODULE$, $relChain))
            $prefix = $rt_s(178);
        else {
            $name = $ast.$entityType();
            $relChain = $ast.$mode();
            if (jl_Object_equals(oncie_NODE_TYPE$_MODULE$, $name) && jl_Object_equals(oncie_ElementIdToLongId$Mode$Many$_MODULE$, $relChain))
                $prefix = $rt_s(179);
            else {
                $name = $ast.$entityType();
                $relChain = $ast.$mode();
                if (jl_Object_equals(oncie_RELATIONSHIP_TYPE$_MODULE$, $name) && jl_Object_equals(oncie_ElementIdToLongId$Mode$Single$_MODULE$, $relChain))
                    $prefix = $rt_s(180);
                else {
                    $name = $ast.$entityType();
                    $relChain = $ast.$mode();
                    if (jl_Object_equals(oncie_RELATIONSHIP_TYPE$_MODULE$, $name) && jl_Object_equals(oncie_ElementIdToLongId$Mode$Many$_MODULE$, $relChain))
                        $prefix = $rt_s(181);
                    else
                        $rt_throw(s_MatchError__init_($ast));
                }
            }
        }
        $ast = onciap_DefaultExpressionStringifier_apply($this, $elementIdExpr);
        $name = jl_StringBuilder__init_1();
        jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($name, $prefix), 40), $ast), 41);
        return jl_StringBuilder_toString($name);
    }
    function onciap_DefaultExpressionStringifier_prettyScope($this, $s, $expression) {
        var var$3, var$4, var$5, var$6;
        var$3 = new sci_$colon$colon;
        var$4 = sci_List_map(sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_stringify($this, $s.$variable3), sci_$colon$colon__init_($rt_s(182), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_inner($this, $s, $expression), sci_Nil$_MODULE$))), new onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_0);
        $expression = new sci_$colon$colon;
        var$5 = (s_Option$_option2Iterable(s_Option$_MODULE$, $s.$innerPredicate0)).$toSeq();
        var$6 = new onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_1;
        var$6.$_050 = $this;
        var$6.$_114 = $s;
        sci_$colon$colon__init_0($expression, var$5.$flatMap(var$6), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$3, var$4, $expression);
        s_Predef$_$callClinit();
        return sc_IterableOnceOps_mkString$(sc_StrictOptimizedIterableOps_flatten$(var$3, s_Predef$_$conforms(s_Predef$_MODULE$)), $rt_s(24), $rt_s(162), $rt_s(25));
    }
    function onciap_DefaultExpressionStringifier_binding($this, $in) {
        var var$2;
        if ($in instanceof oncie_Or ? 1 : !($in instanceof oncie_Ors) ? 0 : 1)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 12);
        if ($in instanceof oncie_Xor)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 11);
        if ($in instanceof oncie_And ? 1 : !($in instanceof oncie_Ands) ? 0 : 1)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 10);
        if ($in instanceof oncie_Not)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 9);
        if ($in instanceof oncie_Equals ? 1 : $in instanceof oncie_NotEquals ? 1 : $in instanceof oncie_InvalidNotEquals ? 1 : $in instanceof oncie_GreaterThan ? 1 : $in instanceof oncie_GreaterThanOrEqual ? 1 : $in instanceof oncie_LessThan ? 1 : !($in instanceof oncie_LessThanOrEqual) ? 0 : 1)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 8);
        if ($in instanceof oncie_Add ? 1 : !($in instanceof oncie_Subtract) ? 0 : 1)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 7);
        if ($in instanceof oncie_Multiply ? 1 : $in instanceof oncie_Divide ? 1 : !($in instanceof oncie_Modulo) ? 0 : 1)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 6);
        if ($in instanceof oncie_Pow)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 5);
        if ($in instanceof oncie_UnaryAdd ? 1 : !($in instanceof oncie_UnarySubtract) ? 0 : 1)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 4);
        a: {
            if ($in instanceof oncie_RegexMatch) {
                var$2 = 1;
                break a;
            }
            if ($in instanceof oncie_In) {
                var$2 = 1;
                break a;
            }
            if ($in instanceof oncie_StartsWith) {
                var$2 = 1;
                break a;
            }
            if ($in instanceof oncie_EndsWith) {
                var$2 = 1;
                break a;
            }
            if ($in instanceof oncie_Contains) {
                var$2 = 1;
                break a;
            }
            if ($in instanceof oncie_IsNull) {
                var$2 = 1;
                break a;
            }
            if ($in instanceof oncie_IsNotNull) {
                var$2 = 1;
                break a;
            }
            if ($in instanceof oncia_IsTyped) {
                var$2 = 1;
                break a;
            }
            if (!($in instanceof oncia_IsNotTyped)) {
                var$2 = 0;
                break a;
            }
            var$2 = 1;
        }
        if (var$2)
            return onciap_DefaultExpressionStringifier$Precedence__init_($this, 3);
        if (!($in instanceof oncie_Property ? 1 : $in instanceof oncie_HasLabels ? 1 : $in instanceof oncie_ContainerIndex ? 1 : !($in instanceof oncie_ListSlice) ? 0 : 1))
            return onciap_DefaultExpressionStringifier_Syntactic($this);
        return onciap_DefaultExpressionStringifier$Precedence__init_($this, 2);
    }
    function onciap_DefaultExpressionStringifier_backtick($this, $txt) {
        return onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $txt, $this.$alwaysBacktick, 0);
    }
    function onciap_DefaultExpressionStringifier_quote($this, $txt) {
        var $str, $containsSingle, $containsDouble;
        $str = jl_String_replaceAll($txt, $rt_s(183), $rt_s(184));
        $txt = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        $containsSingle = sc_StringOps$_contains$extension($txt, $str, 39);
        $containsDouble = sc_StringOps$_contains$extension(sc_StringOps$_MODULE$, $str, 34);
        if ($containsDouble && $containsSingle) {
            $txt = jl_String_replaceAll($str, $rt_s(185), $rt_s(186));
            $str = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($str);
            jl_AbstractStringBuilder_append($str, 34);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append($str, $txt), 34);
            return jl_AbstractStringBuilder_toString($str);
        }
        if (!$containsDouble && !$this.$preferSingleQuotes) {
            $txt = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($txt);
            jl_AbstractStringBuilder_append($txt, 34);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append($txt, $str), 34);
            return jl_AbstractStringBuilder_toString($txt);
        }
        $txt = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($txt);
        jl_AbstractStringBuilder_append($txt, 39);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append($txt, $str), 39);
        return jl_AbstractStringBuilder_toString($txt);
    }
    function onciap_DefaultExpressionStringifier_escapePassword($this, $password) {
        var var$2;
        if ($rt_isInstance($password, oncie_SensitiveAutoParameter) && !$this.$sensitiveParamsAsParams)
            return $rt_s(187);
        if ($rt_isInstance($password, oncie_SensitiveLiteral))
            return $rt_s(187);
        if (!$rt_isInstance($password, oncie_Parameter)) {
            var$2 = new jl_InternalError;
            jl_Throwable__init_(var$2, $rt_s(188));
            $rt_throw(var$2);
        }
        $password = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $password.$name3(), 0, 0);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 36);
        jl_StringBuilder_append(var$2, $password);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function onciap_DefaultExpressionStringifier_stringifyLabelExpression($this, $labelExpression) {
        var var$2, var$3;
        if ($labelExpression instanceof oncil_LabelExpression$Disjunctions) {
            var$2 = $labelExpression.$children;
            $labelExpression = new onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_0;
            $labelExpression.$_051 = $this;
            return sc_AbstractIterable_mkString0(var$2.$map1($labelExpression), $rt_s(189));
        }
        if ($labelExpression instanceof oncil_LabelExpression$ColonDisjunction) {
            $labelExpression = $labelExpression;
            var$2 = onciap_DefaultExpressionStringifier_stringifyLabelExpressionInColonDisjunction($this, $labelExpression.$lhs3);
            $labelExpression = onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression.$rhs3);
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$2), $rt_s(190)), $labelExpression);
            return jl_AbstractStringBuilder_toString(var$3);
        }
        if ($labelExpression instanceof oncil_LabelExpression$Conjunctions) {
            var$2 = $labelExpression.$children0;
            $labelExpression = new onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_1;
            $labelExpression.$_052 = $this;
            return sc_AbstractIterable_mkString0(var$2.$map1($labelExpression), $rt_s(191));
        }
        if (!($labelExpression instanceof oncil_LabelExpression$ColonConjunction))
            return jl_String_valueOf(onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression));
        $labelExpression = $labelExpression;
        var$2 = onciap_DefaultExpressionStringifier_stringifyLabelExpressionInColonConjunction($this, $labelExpression.$lhs4);
        $labelExpression = onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression.$rhs4);
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$2 = jl_StringBuilder_append(var$3, var$2);
        jl_AbstractStringBuilder_append(var$2, 58);
        jl_StringBuilder_append(var$2, $labelExpression);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function onciap_DefaultExpressionStringifier_stringifyLabelExpressionInColonDisjunction($this, $labelExpression) {
        var var$2, var$3;
        if (!($labelExpression instanceof oncil_LabelExpression$ColonDisjunction))
            return jl_String_valueOf(onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression));
        $labelExpression = $labelExpression;
        var$2 = onciap_DefaultExpressionStringifier_stringifyLabelExpressionInColonDisjunction($this, $labelExpression.$lhs3);
        $labelExpression = onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression.$rhs3);
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$2), $rt_s(190)), $labelExpression);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function onciap_DefaultExpressionStringifier_stringifyLabelExpressionInColonConjunction($this, $labelExpression) {
        var var$2, var$3;
        if (!($labelExpression instanceof oncil_LabelExpression$ColonConjunction))
            return jl_String_valueOf(onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression));
        $labelExpression = $labelExpression;
        var$2 = onciap_DefaultExpressionStringifier_stringifyLabelExpressionInColonConjunction($this, $labelExpression.$lhs4);
        $labelExpression = onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression.$rhs4);
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$2 = jl_StringBuilder_append(var$3, var$2);
        jl_AbstractStringBuilder_append(var$2, 58);
        jl_StringBuilder_append(var$2, $labelExpression);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression) {
        var var$2;
        if ($labelExpression instanceof oncil_LabelExpression$Negation) {
            $labelExpression = onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom($this, $labelExpression.$e);
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_AbstractStringBuilder_append(var$2, 33);
            jl_StringBuilder_append(var$2, $labelExpression);
            return jl_AbstractStringBuilder_toString(var$2);
        }
        if ($labelExpression instanceof oncil_LabelExpression$Leaf)
            $labelExpression = onciap_DefaultExpressionStringifier_apply0($this, $labelExpression.$name8);
        else if ($labelExpression instanceof oncil_LabelExpression$Wildcard)
            $labelExpression = $rt_s(192);
        else {
            $labelExpression = onciap_DefaultExpressionStringifier_stringifyLabelExpression($this, $labelExpression);
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_AbstractStringBuilder_append(var$2, 40);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$2, $labelExpression), 41);
            $labelExpression = jl_AbstractStringBuilder_toString(var$2);
        }
        return jl_String_valueOf($labelExpression);
    }
    function onciap_DefaultExpressionStringifier_findChain$1($expressions$1) {
        var $chainable, var$3;
        $chainable = sc_StrictOptimizedIterableOps_collect$($expressions$1, new onciap_DefaultExpressionStringifier$$anonfun$1);
        var$3 = $chainable.$size() != $expressions$1.$size() ? 0 : 1;
        if (var$3 && sc_IterableOnceOps_forall$(sc_AbstractIterable_sliding($chainable, 2), new onciap_DefaultExpressionStringifier$formsChain$1$lambda$_55_0))
            return s_Some__init_(sc_IterableOnceOps_toList$($chainable));
        return s_None$_MODULE$;
    }
    var onciap_ExpressionStringifier$Extension$ = $rt_classWithoutFields();
    var onciap_ExpressionStringifier$Extension$_MODULE$ = null;
    function onciap_ExpressionStringifier$Extension$__clinit_() {
        onciap_ExpressionStringifier$Extension$_MODULE$ = new onciap_ExpressionStringifier$Extension$;
    }
    var sc_IndexedSeqOps = $rt_classWithoutFields(0);
    function sc_IndexedSeqOps_iterator$($$this) {
        return ($$this.$view0()).$iterator0();
    }
    function sc_IndexedSeqOps_reverseIterator$($$this) {
        return ($$this.$view0()).$reverseIterator();
    }
    function sc_IndexedSeqOps_view$($$this) {
        var var$2;
        var$2 = new sc_IndexedSeqView$Id;
        sc_SeqView$Id__init_0(var$2, $$this);
        return var$2;
    }
    function sc_IndexedSeqOps_reversed$($$this) {
        return sc_IndexedSeqView$Reverse__init_($$this);
    }
    function sc_IndexedSeqOps_head$($$this) {
        return $$this.$apply1(0);
    }
    function sc_IndexedSeqOps_headOption$($$this) {
        return $$this.$isEmpty() ? s_None$_MODULE$ : s_Some__init_($$this.$head());
    }
    function sc_IndexedSeqOps_lengthCompare$($$this, $len) {
        return $rt_compare($$this.$length(), $len);
    }
    var sc_IndexedSeq = $rt_classWithoutFields(0);
    var sci_IndexedSeqOps = $rt_classWithoutFields(0);
    var sci_IndexedSeq = $rt_classWithoutFields(0);
    function sci_IndexedSeq_canEqual$($$this, $that) {
        var var$3, var$4;
        if (!$rt_isInstance($that, sci_IndexedSeq))
            var$3 = $$this.$scala$collection$immutable$IndexedSeq$$super$canEqual($that);
        else {
            var$4 = $that;
            var$3 = $$this.$length() == var$4.$length() && $$this.$scala$collection$immutable$IndexedSeq$$super$canEqual($that) ? 1 : 0;
        }
        return var$3;
    }
    function sci_IndexedSeq_sameElements$($$this, $o) {
        var var$3, var$4, var$5, var$6, var$7;
        a: {
            if (!$rt_isInstance($o, sci_IndexedSeq))
                var$3 = $$this.$scala$collection$immutable$IndexedSeq$$super$sameElements($o);
            else {
                $o = $o;
                if ($$this !== $o) {
                    var$4 = $$this.$length();
                    var$5 = var$4 != $o.$length() ? 0 : 1;
                    b: {
                        if (var$5) {
                            var$6 = 0;
                            var$7 = jl_Math_min($$this.$applyPreferredMaxLength(), $o.$applyPreferredMaxLength());
                            if (Long_le(Long_fromInt(var$4), Long_shl(Long_fromInt(var$7), 1)))
                                var$7 = var$4;
                            while (var$6 < var$7 && var$5) {
                                var$5 = !sr_BoxesRunTime_equals($$this.$apply1(var$6), $o.$apply1(var$6)) ? 0 : 1;
                                var$6 = var$6 + 1 | 0;
                            }
                            if (var$6 < var$4 && var$5) {
                                $$this = ($$this.$iterator0()).$drop1(var$6);
                                $o = ($o.$iterator0()).$drop1(var$6);
                                while (var$5) {
                                    if (!$$this.$hasNext())
                                        break b;
                                    var$5 = !sr_BoxesRunTime_equals($$this.$next(), $o.$next()) ? 0 : 1;
                                }
                            }
                        }
                    }
                    if (!var$5) {
                        var$3 = 0;
                        break a;
                    }
                }
                var$3 = 1;
            }
        }
        return var$3;
    }
    var sc_EvidenceIterableFactoryDefaults = $rt_classWithoutFields(0);
    var sci_ArraySeq = $rt_classWithoutFields(sci_AbstractSeq);
    function sci_ArraySeq_fromSpecific($this, $coll) {
        return sci_ArraySeq$_from(sci_ArraySeq$_MODULE$, $coll, $this.$elemTag());
    }
    function sci_ArraySeq_newSpecificBuilder($this) {
        return sci_ArraySeq$_newBuilder(sci_ArraySeq$_MODULE$, $this.$elemTag());
    }
    function sci_ArraySeq_empty($this) {
        return sci_ArraySeq$_empty(sci_ArraySeq$_MODULE$, $this.$elemTag());
    }
    function sci_ArraySeq_distinctBy($this, $f) {
        return sci_StrictOptimizedSeqOps_distinctBy$($this, $f);
    }
    function sci_ArraySeq_intersect($this, $that) {
        return sc_StrictOptimizedSeqOps_intersect$($this, $that);
    }
    function sci_ArraySeq_span($this, $p) {
        return sc_StrictOptimizedIterableOps_span$($this, $p);
    }
    function sci_ArraySeq_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_ArraySeq_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_ArraySeq_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_ArraySeq_zipWithIndex($this) {
        return sc_StrictOptimizedIterableOps_zipWithIndex$($this);
    }
    function sci_ArraySeq_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_ArraySeq_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_ArraySeq_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function sci_ArraySeq_scala$collection$immutable$IndexedSeq$$super$canEqual($this, $that) {
        return 1;
    }
    function sci_ArraySeq_scala$collection$immutable$IndexedSeq$$super$sameElements($this, $that) {
        return sc_SeqOps_sameElements$($this, $that);
    }
    function sci_ArraySeq_toIndexedSeq($this) {
        return $this;
    }
    function sci_ArraySeq_canEqual($this, $that) {
        return sci_IndexedSeq_canEqual$($this, $that);
    }
    function sci_ArraySeq_sameElements($this, $o) {
        return sci_IndexedSeq_sameElements$($this, $o);
    }
    function sci_ArraySeq_stringPrefix($this) {
        return $rt_s(193);
    }
    function sci_ArraySeq_reverseIterator($this) {
        return sc_IndexedSeqOps_reverseIterator$($this);
    }
    function sci_ArraySeq_view($this) {
        return sc_IndexedSeqOps_view$($this);
    }
    function sci_ArraySeq_reversed($this) {
        return sc_IndexedSeqOps_reversed$($this);
    }
    function sci_ArraySeq_head($this) {
        return sc_IndexedSeqOps_head$($this);
    }
    function sci_ArraySeq_headOption($this) {
        return sc_IndexedSeqOps_headOption$($this);
    }
    function sci_ArraySeq_last($this) {
        return $this.$apply1($this.$length() - 1 | 0);
    }
    function sci_ArraySeq_lengthCompare($this, $len) {
        return sc_IndexedSeqOps_lengthCompare$($this, $len);
    }
    function sci_ArraySeq_knownSize($this) {
        return $this.$length();
    }
    function sci_ArraySeq_iterableFactory($this) {
        return sci_ArraySeq$_untagged;
    }
    function sci_ArraySeq_evidenceIterableFactory($this) {
        return sci_ArraySeq$_MODULE$;
    }
    function sci_ArraySeq_iterableEvidence($this) {
        return $this.$elemTag();
    }
    function sci_ArraySeq_updated($this, $index, $elem) {
        var $dest, var$4;
        $dest = $rt_createArray(jl_Object, $this.$length());
        var$4 = $dest.data;
        s_Array$_copy(s_Array$_MODULE$, $this.$unsafeArray(), 0, $dest, 0, $this.$length());
        var$4[$index] = $elem;
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, $dest);
    }
    function sci_ArraySeq_map($this, $f) {
        var $a, var$3, $i, var$5;
        $a = $rt_createArray(jl_Object, $this.$length());
        var$3 = $a.data;
        $i = 0;
        var$5 = var$3.length;
        while ($i < var$5) {
            var$3[$i] = $f.$apply($this.$apply1($i));
            $i = $i + 1 | 0;
        }
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, $a);
    }
    function sci_ArraySeq_prepended($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sci_ArraySeq$_MODULE$;
        var$3 = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray();
        sr_ClassTag$_$callClinit();
        return sci_ArraySeq$_unsafeWrapArray(var$2, sc_ArrayOps$_prepended$extension(var$3, var$4, $elem, sr_ClassTag$_Any(sr_ClassTag$_MODULE$)));
    }
    function sci_ArraySeq_appended($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sci_ArraySeq$_MODULE$;
        var$3 = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray();
        sr_ClassTag$_$callClinit();
        return sci_ArraySeq$_unsafeWrapArray(var$2, sc_ArrayOps$_appended$extension(var$3, var$4, $elem, sr_ClassTag$_Any(sr_ClassTag$_MODULE$)));
    }
    function sci_ArraySeq_appendedAll($this, $suffix) {
        var $result, var$3, var$4, var$5, var$6;
        if (!($suffix instanceof sci_ArraySeq))
            return sci_ArraySeq_genericResult$1($this, $suffix);
        $result = $suffix;
        if (!sc_SeqOps_isEmpty$($this)) {
            if (sc_SeqOps_isEmpty$($result))
                $result = $this;
            else {
                var$3 = $rt_isInstance($this.$unsafeArray(), $rt_arraycls(jl_Object));
                if (var$3 == $rt_isInstance($result.$unsafeArray(), $rt_arraycls(jl_Object)) ? 0 : 1)
                    $result = null;
                else if (var$3) {
                    var$4 = $this.$unsafeArray();
                    $result = $result.$unsafeArray();
                    var$5 = $rt_createArray(jl_Object, jlr_Array_getLength(var$4) + jlr_Array_getLength($result) | 0);
                    jl_System_arraycopy(var$4, 0, var$5, 0, jlr_Array_getLength(var$4));
                    jl_System_arraycopy($result, 0, var$5, jlr_Array_getLength(var$4), jlr_Array_getLength($result));
                    $result = sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, var$5);
                } else {
                    var$6 = $this.$unsafeArray();
                    $result = $result.$unsafeArray();
                    var$3 = jlr_Array_getLength(var$6) + jlr_Array_getLength($result) | 0;
                    var$4 = ($this.$elemTag()).$newArray(var$3);
                    jl_System_arraycopy(var$6, 0, var$4, 0, jlr_Array_getLength(var$6));
                    jl_System_arraycopy($result, 0, var$4, jlr_Array_getLength(var$6), jlr_Array_getLength($result));
                    $result = sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, var$4);
                }
            }
        }
        if ($result !== null)
            return $result;
        return sci_ArraySeq_genericResult$1($this, $suffix);
    }
    function sci_ArraySeq_zip($this, $that) {
        var $strictOptimizedZip_b, $strictOptimizedZip_it1, $strictOptimizedZip_it2, $strictOptimizedZip_$plus$eq_elem, $tabulate_this, $tabulate_n, $tabulate_elements, var$9, $tabulate_i;
        if (!($that instanceof sci_ArraySeq)) {
            $strictOptimizedZip_b = sc_ClassTagIterableFactory$AnyIterableDelegate_newBuilder(sci_ArraySeq$_untagged);
            $strictOptimizedZip_it1 = $this.$iterator0();
            $strictOptimizedZip_it2 = $that.$iterator0();
            a: {
                while (true) {
                    if (!sc_ArrayOps$ArrayIterator_hasNext($strictOptimizedZip_it1))
                        break a;
                    if (!$strictOptimizedZip_it2.$hasNext())
                        break a;
                    $strictOptimizedZip_$plus$eq_elem = s_Tuple2__init_($strictOptimizedZip_it1.$next(), $strictOptimizedZip_it2.$next());
                    if ($strictOptimizedZip_b === null)
                        break;
                    scm_Builder$$anon$1_addOne($strictOptimizedZip_b, $strictOptimizedZip_$plus$eq_elem);
                }
                $rt_throw(null);
            }
            return scm_Builder$$anon$1_result($strictOptimizedZip_b);
        }
        $that = $that;
        $tabulate_this = sci_ArraySeq$_MODULE$;
        $tabulate_n = jl_Math_min($this.$length(), $that.$length());
        $tabulate_elements = $rt_createArray(s_Tuple2, jl_Math_max($tabulate_n, 0));
        var$9 = $tabulate_elements.data;
        $tabulate_i = 0;
        while ($tabulate_i < $tabulate_n) {
            var$9[$tabulate_i] = s_Tuple2__init_($this.$apply1($tabulate_i), $that.$apply1($tabulate_i));
            $tabulate_i = $tabulate_i + 1 | 0;
        }
        return sci_ArraySeq$_unsafeWrapArray($tabulate_this, $tabulate_elements);
    }
    function sci_ArraySeq_drop($this, $n) {
        if ($n <= 0)
            return $this;
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, sc_ArrayOps$_drop$extension(sc_ArrayOps$_MODULE$, $this.$unsafeArray(), $n));
    }
    function sci_ArraySeq_dropRight($this, $n) {
        if ($n <= 0)
            return $this;
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, sc_ArrayOps$_dropRight$extension(sc_ArrayOps$_MODULE$, $this.$unsafeArray(), $n));
    }
    function sci_ArraySeq_foldLeft($this, $z, $f) {
        var $array, $i;
        $array = $this.$unsafeArray();
        $i = 0;
        while ($i < jlr_Array_getLength($array)) {
            $z = $f.$apply0($z, sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $array, $i));
            $i = $i + 1 | 0;
        }
        return $z;
    }
    function sci_ArraySeq_tail($this) {
        var var$1, var$2, var$3;
        var$1 = sci_ArraySeq$_MODULE$;
        var$2 = sc_ArrayOps$_MODULE$;
        var$3 = $this.$unsafeArray();
        if (jlr_Array_getLength(var$3))
            return sci_ArraySeq$_unsafeWrapArray(var$1, sc_ArrayOps$_slice$extension(var$2, var$3, 1, jlr_Array_getLength(var$3)));
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(194));
        $rt_throw(var$1);
    }
    function sci_ArraySeq_className($this) {
        return $rt_s(195);
    }
    function sci_ArraySeq_copyToArray($this, $xs, $start, $len) {
        var $elemsToCopyToArray_srcLen, $elemsToCopyToArray_destLen, $copied;
        $elemsToCopyToArray_srcLen = $this.$length();
        $elemsToCopyToArray_destLen = jlr_Array_getLength($xs);
        $copied = jl_Math_max(jl_Math_min(jl_Math_min($len, $elemsToCopyToArray_srcLen), $elemsToCopyToArray_destLen - $start | 0), 0);
        if ($copied > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$unsafeArray(), 0, $xs, $start, $copied);
        return $copied;
    }
    function sci_ArraySeq_applyPreferredMaxLength($this) {
        return 2147483647;
    }
    function sci_ArraySeq_sorted($this, $ord) {
        var var$2, var$3, var$4, $a;
        if (jlr_Array_getLength($this.$unsafeArray()) <= 1)
            return $this;
        var$2 = s_Array$_MODULE$;
        var$3 = $this.$unsafeArray();
        var$4 = $this.$length();
        sr_ClassTag$_$callClinit();
        $a = s_Array$_copyAs(var$2, var$3, var$4, sr_ClassTag$_AnyRef(sr_ClassTag$_MODULE$));
        ju_Arrays_sort($a, $ord);
        return sci_ArraySeq$ofRef__init_($a);
    }
    function sci_ArraySeq_view0($this) {
        return sc_IndexedSeqOps_view$($this);
    }
    function sci_ArraySeq_empty0($this) {
        return sci_ArraySeq_empty($this);
    }
    function sci_ArraySeq_fromSpecific0($this, $coll) {
        return sci_ArraySeq_fromSpecific($this, $coll);
    }
    function sci_ArraySeq_sorted0($this, $ord) {
        return $this.$sorted($ord);
    }
    function sci_ArraySeq_tail0($this) {
        return sci_ArraySeq_tail($this);
    }
    function sci_ArraySeq_dropRight0($this, $n) {
        return sci_ArraySeq_dropRight($this, $n);
    }
    function sci_ArraySeq_drop0($this, $n) {
        return sci_ArraySeq_drop($this, $n);
    }
    function sci_ArraySeq_zip0($this, $that) {
        return sci_ArraySeq_zip($this, $that);
    }
    function sci_ArraySeq_appendedAll0($this, $suffix) {
        return sci_ArraySeq_appendedAll($this, $suffix);
    }
    function sci_ArraySeq_appended0($this, $elem) {
        return $this.$appended0($elem);
    }
    function sci_ArraySeq_prepended0($this, $elem) {
        return $this.$prepended1($elem);
    }
    function sci_ArraySeq_map0($this, $f) {
        return sci_ArraySeq_map($this, $f);
    }
    function sci_ArraySeq_updated0($this, $index, $elem) {
        return $this.$updated0($index, $elem);
    }
    function sci_ArraySeq_iterableEvidence0($this) {
        return $this.$elemTag();
    }
    function sci_ArraySeq_evidenceIterableFactory0($this) {
        return sci_ArraySeq$_MODULE$;
    }
    function sci_ArraySeq_iterableFactory0($this) {
        return sci_ArraySeq_iterableFactory($this);
    }
    function sci_ArraySeq_genericResult$1($this, $suffix$1) {
        var $k, var$3, $make_evidence$1, $b;
        $k = $suffix$1.$knownSize();
        var$3 = $rt_compare($k, 0);
        if (!var$3)
            return $this;
        a: {
            sr_ClassTag$_$callClinit();
            $make_evidence$1 = sr_ClassTag$_Any(sr_ClassTag$_MODULE$);
            $b = $make_evidence$1.$runtimeClass0;
            if (jl_Object_equals($rt_cls($rt_bytecls()), $b)) {
                $b = new scm_ArrayBuilder$ofByte;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_shortcls()), $b)) {
                $b = new scm_ArrayBuilder$ofShort;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_charcls()), $b)) {
                $b = new scm_ArrayBuilder$ofChar;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_intcls()), $b)) {
                $b = new scm_ArrayBuilder$ofInt;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_longcls()), $b)) {
                $b = new scm_ArrayBuilder$ofLong;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_floatcls()), $b)) {
                $b = new scm_ArrayBuilder$ofFloat;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_doublecls()), $b)) {
                $b = new scm_ArrayBuilder$ofDouble;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_booleancls()), $b)) {
                $b = new scm_ArrayBuilder$ofBoolean;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (!jl_Object_equals($rt_cls($rt_voidcls()), $b)) {
                $b = scm_ArrayBuilder$ofRef__init_($make_evidence$1);
                break a;
            }
            $b = new scm_ArrayBuilder$ofUnit;
            scm_ArrayBuilder__init_($b);
        }
        if (var$3 >= 0)
            scm_ArrayBuilder_sizeHint($b, $k + jlr_Array_getLength($this.$unsafeArray()) | 0);
        scm_ArrayBuilder_addAll($b, $this.$unsafeArray());
        $b.$addAll($suffix$1);
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, $b.$result0());
    }
    function sci_ArraySeq$ofRef() {
        sci_ArraySeq.call(this);
        this.$unsafeArray0 = null;
    }
    function sci_ArraySeq$ofRef__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofRef();
        sci_ArraySeq$ofRef__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofRef_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_apply(sr_ClassTag$_MODULE$, jl_Class_getComponentType(jl_Object_getClass($this.$unsafeArray0)));
    }
    function sci_ArraySeq$ofRef_length($this) {
        return $this.$unsafeArray0.data.length;
    }
    function sci_ArraySeq$ofRef_apply($this, $i) {
        return $this.$unsafeArray0.data[$i];
    }
    function sci_ArraySeq$ofRef_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash(suh_MurmurHash3$_MODULE$, $this.$unsafeArray0);
    }
    function sci_ArraySeq$ofRef_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofRef))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return s_Array$_equals(s_Array$_MODULE$, $this.$unsafeArray0, $that.$unsafeArray0);
    }
    function sci_ArraySeq$ofRef_sorted($this, $ord) {
        var var$2, $a;
        var$2 = $this.$unsafeArray0;
        if (var$2.data.length <= 1)
            return $this;
        $a = var$2.$clone();
        ju_Arrays_sort($a, $ord);
        return sci_ArraySeq$ofRef__init_($a);
    }
    function sci_ArraySeq$ofRef_iterator($this) {
        return sc_ArrayOps$ArrayIterator__init_($this.$unsafeArray0);
    }
    function sci_ArraySeq$ofRef_sorted0($this, $ord) {
        return sci_ArraySeq$ofRef_sorted($this, $ord);
    }
    function sci_ArraySeq$ofRef_sorted1($this, $ord) {
        return sci_ArraySeq$ofRef_sorted($this, $ord);
    }
    function sci_ArraySeq$ofRef_apply0($this, $v1) {
        return sci_ArraySeq$ofRef_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_ArraySeq$ofRef_unsafeArray($this) {
        return $this.$unsafeArray0;
    }
    function sci_ArraySeq$ofRef__init_0($this, $unsafeArray) {
        $this.$unsafeArray0 = $unsafeArray;
    }
    var sc_EvidenceIterableFactory = $rt_classWithoutFields(0);
    var sc_ClassTagIterableFactory = $rt_classWithoutFields(0);
    var sc_ClassTagSeqFactory = $rt_classWithoutFields(0);
    var sc_StrictOptimizedClassTagSeqFactory = $rt_classWithoutFields(0);
    var sci_ArraySeq$ = $rt_classWithoutFields();
    var sci_ArraySeq$_MODULE$ = null;
    var sci_ArraySeq$_emptyImpl = null;
    var sci_ArraySeq$_untagged = null;
    var sci_ArraySeq$_bitmap$0 = 0;
    function sci_ArraySeq$__clinit_() {
        var var$1;
        var$1 = new sci_ArraySeq$;
        sci_ArraySeq$_MODULE$ = var$1;
        sci_ArraySeq$_untagged = sc_ClassTagSeqFactory$AnySeqDelegate__init_(var$1);
    }
    function sci_ArraySeq$_empty($this, $evidence$1) {
        var $$je;
        if (sci_ArraySeq$_bitmap$0)
            $evidence$1 = sci_ArraySeq$_emptyImpl;
        else {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if (sci_ArraySeq$_bitmap$0)
                        break a;
                    sci_ArraySeq$_emptyImpl = sci_ArraySeq$ofRef__init_($rt_createArray(jl_Object, 0));
                    sci_ArraySeq$_bitmap$0 = 1;
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    $evidence$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw($evidence$1);
            }
            jl_Object_monitorExitSync($this);
            $evidence$1 = sci_ArraySeq$_emptyImpl;
        }
        return $evidence$1;
    }
    function sci_ArraySeq$_unsafeWrapArray($this, $x) {
        var var$2;
        if ($x === null)
            return null;
        if ($rt_isInstance($x, $rt_arraycls(jl_Object)))
            return sci_ArraySeq$ofRef__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_intcls())))
            return sci_ArraySeq$ofInt__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_doublecls())))
            return sci_ArraySeq$ofDouble__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_longcls())))
            return sci_ArraySeq$ofLong__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_floatcls())))
            return sci_ArraySeq$ofFloat__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_charcls())))
            return sci_ArraySeq$ofChar__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_bytecls())))
            return sci_ArraySeq$ofByte__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_shortcls())))
            return sci_ArraySeq$ofShort__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_booleancls())))
            return sci_ArraySeq$ofBoolean__init_($x);
        if (!$rt_isInstance($x, $rt_arraycls(sr_BoxedUnit)))
            $rt_throw(s_MatchError__init_($x));
        var$2 = $x;
        $x = new sci_ArraySeq$ofUnit;
        $x.$unsafeArray1 = var$2;
        return $x;
    }
    function sci_ArraySeq$_newBuilder($this, $evidence$12) {
        var var$2, var$3;
        var$2 = scm_ArrayBuffer$$anon$1__init_();
        var$3 = new sci_ArraySeq$$newBuilder$lambda$_21_0;
        var$3.$_053 = $evidence$12;
        return scm_Builder_mapResult$(var$2, var$3);
    }
    function sci_ArraySeq$_from($this, $it, $evidence$5) {
        return $it instanceof sci_ArraySeq ? $it : sci_ArraySeq$_unsafeWrapArray($this, s_Array$_from(s_Array$_MODULE$, $it, $evidence$5));
    }
    function sci_ArraySeq$_empty0($this, $evidence$6) {
        return sci_ArraySeq$_empty($this, $evidence$6);
    }
    var sr_ClassTag$ = $rt_classWithoutFields();
    var sr_ClassTag$_MODULE$ = null;
    var sr_ClassTag$_scala$reflect$ClassTag$$ObjectTYPE = null;
    var sr_ClassTag$_scala$reflect$ClassTag$$NothingTYPE = null;
    var sr_ClassTag$_scala$reflect$ClassTag$$NullTYPE = null;
    var sr_ClassTag$_Byte = null;
    var sr_ClassTag$_Short = null;
    var sr_ClassTag$_Char = null;
    var sr_ClassTag$_Int = null;
    var sr_ClassTag$_Long = null;
    var sr_ClassTag$_Float = null;
    var sr_ClassTag$_Double = null;
    var sr_ClassTag$_Boolean = null;
    var sr_ClassTag$_Unit = null;
    var sr_ClassTag$_Any0 = null;
    var sr_ClassTag$_Object = null;
    var sr_ClassTag$_AnyVal = null;
    var sr_ClassTag$_AnyRef0 = null;
    var sr_ClassTag$_Nothing = null;
    var sr_ClassTag$_Null = null;
    var sr_ClassTag$_cacheDisabled = 0;
    function sr_ClassTag$_$callClinit() {
        sr_ClassTag$_$callClinit = $rt_eraseClinit(sr_ClassTag$);
        sr_ClassTag$__clinit_();
    }
    function sr_ClassTag$__clinit_() {
        var var$1;
        var$1 = new sr_ClassTag$;
        sr_ClassTag$_$callClinit();
        sr_ClassTag$_MODULE$ = var$1;
        sr_ClassTag$_scala$reflect$ClassTag$$ObjectTYPE = $rt_cls(jl_Object);
        sr_ClassTag$_scala$reflect$ClassTag$$NothingTYPE = $rt_cls(sr_Nothing$);
        sr_ClassTag$_scala$reflect$ClassTag$$NullTYPE = $rt_cls(sr_Null$);
        sr_Manifest$_$callClinit();
        sr_ClassTag$_Byte = sr_Manifest$_Byte;
        sr_ClassTag$_Short = sr_Manifest$_Short;
        sr_ClassTag$_Char = sr_Manifest$_Char;
        sr_ClassTag$_Int = sr_Manifest$_Int;
        sr_ClassTag$_Long = sr_Manifest$_Long;
        sr_ClassTag$_Float = sr_Manifest$_Float;
        sr_ClassTag$_Double = sr_Manifest$_Double;
        sr_ClassTag$_Boolean = sr_Manifest$_Boolean;
        sr_ClassTag$_Unit = sr_Manifest$_Unit;
        sr_ClassTag$_Any0 = sr_Manifest$_Any;
        sr_ClassTag$_Object = sr_Manifest$_Object;
        sr_ClassTag$_AnyVal = sr_Manifest$_AnyVal;
        sr_ClassTag$_AnyRef0 = sr_Manifest$_AnyRef;
        sr_ClassTag$_Nothing = sr_Manifest$_Nothing;
        sr_ClassTag$_Null = sr_Manifest$_Null;
        var$1 = jl_System_getProperty($rt_s(196));
        sr_ClassTag$_cacheDisabled = var$1 !== null && (jl_Boolean_valueOf(!jl_String_equals(jl_String_toLowerCase(var$1), $rt_s(197)) ? 0 : 1)).$value8 ? 1 : 0;
    }
    function sr_ClassTag$_Byte0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Byte;
    }
    function sr_ClassTag$_Short0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Short;
    }
    function sr_ClassTag$_Char0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Char;
    }
    function sr_ClassTag$_Int0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Int;
    }
    function sr_ClassTag$_Long0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Long;
    }
    function sr_ClassTag$_Float0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Float;
    }
    function sr_ClassTag$_Double0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Double;
    }
    function sr_ClassTag$_Boolean0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Boolean;
    }
    function sr_ClassTag$_Unit0($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Unit;
    }
    function sr_ClassTag$_Any($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Any0;
    }
    function sr_ClassTag$_AnyRef($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_AnyRef0;
    }
    function sr_ClassTag$_apply($this, $runtimeClass1) {
        var var$2;
        sr_ClassTag$_$callClinit();
        if (sr_ClassTag$_cacheDisabled) {
            sr_ClassTag$cache$_$callClinit();
            return sr_ClassTag$cache$_computeTag(sr_ClassTag$cache$_MODULE$, $runtimeClass1);
        }
        sr_ClassTag$cache$_$callClinit();
        var$2 = (sr_ClassTag$cache$_MODULE$.$instance0.$get2($runtimeClass1)).$value9;
        if (var$2 === null)
            var$2 = sr_ClassTag$cache$_computeTag(sr_ClassTag$cache$_MODULE$, $runtimeClass1);
        return var$2;
    }
    var s_Function2 = $rt_classWithoutFields(0);
    function s_Function2_toString($this) {
        return $rt_s(198);
    }
    var oncifp_PatternExpressionInNonExistenceCheck$$patternExpressionInNonExistenceCheck$lambda$_2_0 = $rt_classWithoutFields();
    function oncifp_PatternExpressionInNonExistenceCheck$$patternExpressionInNonExistenceCheck$lambda$_2_0_apply(var$0, var$1, var$2) {
        var var$3, var$4;
        var$3 = (oncifp_InitialState_statement(var$1)).$folder();
        s_package$_$callClinit();
        var$4 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        var$2 = new oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1;
        var$2.$baseState$1 = var$1;
        return onciu_Foldable$Folder_treeFold(var$3, var$4, var$2);
    }
    var oncifp_CreatePatternSelfReferenceCheck$$check$lambda$_1_0 = $rt_classWithoutFields();
    function oncifp_CreatePatternSelfReferenceCheck$$check$lambda$_1_0_apply(var$0, var$1, var$2) {
        var var$3, var$4, var$5;
        var$3 = oncifp_InitialState_semanticTable(var$1);
        var$4 = (oncifp_InitialState_statement(var$1)).$folder();
        s_package$_$callClinit();
        var$5 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        var$1 = new oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1;
        var$1.$semanticTable$1 = var$3;
        var$1.$baseContext$1 = var$2;
        return onciu_Foldable$Folder_treeFold(var$4, var$5, var$1);
    }
    var oncifp_ListCoercedToBooleanCheck$$listCoercedToBooleanCheck$lambda$_3_0 = $rt_classWithoutFields();
    function oncifp_ListCoercedToBooleanCheck$$listCoercedToBooleanCheck$lambda$_3_0_apply(var$0, var$1, var$2) {
        var var$3, var$4;
        var$3 = (oncifp_InitialState_statement(var$1)).$folder();
        s_package$_$callClinit();
        var$4 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        var$2 = new oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1;
        var$2.$baseState$2 = var$1;
        return onciu_Foldable$Folder_treeFold(var$3, var$4, var$2);
    }
    function onciu_topDown$TopDownRewriter() {
        var a = this; jl_Object.call(a);
        a.$rewriter = null;
        a.$stopper = null;
        a.$leftToRight = 0;
        a.$cancellation = null;
    }
    function onciu_topDown$TopDownRewriter_toString($this) {
        return $rt_s(17);
    }
    function onciu_topDown$TopDownRewriter_apply($this, $that) {
        var $initialStack, $result, var$4;
        $initialStack = scm_Stack$_MODULE$;
        $result = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(s_Tuple2, 1);
        var$4.data[0] = s_Tuple2__init_(sci_$colon$colon__init_($that, sci_Nil$_MODULE$), scm_ListBuffer__init_());
        $result = onciu_topDown$TopDownRewriter_rec($this, $initialStack.$from0(sr_ScalaRunTime$_wrapRefArray($result, var$4)));
        s_Predef$_$callClinit();
        s_Predef$_assert(s_Predef$_MODULE$, $result.$length() != 1 ? 0 : 1);
        return sc_AbstractIterable_head($result);
    }
    function onciu_topDown$TopDownRewriter_rec($this, $stack) {
        var $currentJobs, $newJobs, $doneJobs, $newJob, $jobs, $rewrittenJob, $newChildren, $job, $args, $doneJob;
        a: {
            b: {
                while (true) {
                    $currentJobs = sc_IndexedSeqOps_head$($stack);
                    if ($currentJobs === null)
                        $rt_throw(s_MatchError__init_($currentJobs));
                    if (!sci_List_isEmpty($currentJobs.$_10)) {
                        $currentJobs = scm_Stack_pop($stack);
                        if ($currentJobs === null)
                            break b;
                        $newJobs = $currentJobs.$_10;
                        $doneJobs = $currentJobs.$_20;
                        if (!($newJobs instanceof sci_$colon$colon))
                            break b;
                        $currentJobs = $newJobs;
                        $newJob = $currentJobs.$head0;
                        $jobs = $currentJobs.$next0;
                        if ($this.$stopper.$shouldStop($newJob))
                            scm_Stack_push($stack, s_Tuple2__init_($jobs, $doneJobs.$addOne($newJob)));
                        else {
                            $rewrittenJob = $this.$rewriter.$apply($newJob);
                            scm_Stack_push($stack, s_Tuple2__init_(sci_List_$colon$colon($jobs, $rewrittenJob), $doneJobs));
                            scm_Stack_push($stack, s_Tuple2__init_(!$this.$leftToRight ? (onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, $rewrittenJob)).$toList() : (onciu_Foldable$TreeAny$_treeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, $rewrittenJob)).$toList(), scm_ListBuffer__init_()));
                        }
                        continue;
                    }
                    $currentJobs = scm_Stack_pop($stack);
                    if ($currentJobs === null)
                        $rt_throw(s_MatchError__init_($currentJobs));
                    $newChildren = $currentJobs.$_20;
                    if (scm_ArrayDeque_isEmpty($stack))
                        break;
                    $doneJobs = scm_Stack_pop($stack);
                    if ($doneJobs === null)
                        break a;
                    $newJobs = $doneJobs.$_10;
                    $doneJobs = $doneJobs.$_20;
                    if (!($newJobs instanceof sci_$colon$colon))
                        break a;
                    $currentJobs = $newJobs;
                    $job = $currentJobs.$head0;
                    $jobs = $currentJobs.$next0;
                    $args = $this.$leftToRight ? sc_IterableOnceOps_toSeq$($newChildren) : ($newChildren.$fromSpecific0(sc_AbstractIterable_reversed($newChildren))).$toSeq();
                    $doneJob = onciu_Rewritable$_dupAny(onciu_Rewritable$_MODULE$, $job, $args);
                    scm_Stack_push($stack, s_Tuple2__init_($jobs, $doneJobs.$addOne($doneJob)));
                }
                return $newChildren;
            }
            $stack = new jl_IllegalStateException;
            jl_Throwable__init_($stack, $rt_s(199));
            $rt_throw($stack);
        }
        $stack = new jl_IllegalStateException;
        jl_Throwable__init_($stack, $rt_s(199));
        $rt_throw($stack);
    }
    var onciu_RewriterStopper$ = $rt_classWithoutFields();
    var onciu_RewriterStopper$_MODULE$ = null;
    var onciu_RewriterStopper$_neverStop = null;
    function onciu_RewriterStopper$__clinit_() {
        onciu_RewriterStopper$_MODULE$ = new onciu_RewriterStopper$;
        onciu_RewriterStopper$_neverStop = new onciu_RewriterStopper$$_clinit_$lambda$_0_0;
    }
    var onciu_CancellationChecker = $rt_classWithoutFields(0);
    var onciu_CancellationChecker$NeverCancelled$ = $rt_classWithoutFields();
    var onciu_CancellationChecker$NeverCancelled$_MODULE$ = null;
    function onciu_CancellationChecker$NeverCancelled$__clinit_() {
        onciu_CancellationChecker$NeverCancelled$_MODULE$ = new onciu_CancellationChecker$NeverCancelled$;
    }
    var onciu_Rewriter$$anonfun$lift$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function onciu_Rewriter$$anonfun$lift$1_applyOrElse($this, $x1, $default) {
        return $x1;
    }
    function onciu_bottomUp$BottomUpRewriter() {
        var a = this; jl_Object.call(a);
        a.$rewriter0 = null;
        a.$stopper0 = null;
        a.$cancellation0 = null;
    }
    function onciu_bottomUp$BottomUpRewriter_toString($this) {
        return $rt_s(17);
    }
    function onciu_bottomUp$BottomUpRewriter_apply($this, $that) {
        var $initialStack, $result, var$4, var$5, var$6, var$7;
        $initialStack = scm_Stack$_MODULE$;
        $result = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(s_Tuple2, 1);
        var$4.data[0] = s_Tuple2__init_(sci_$colon$colon__init_($that, sci_Nil$_MODULE$), scm_ListBuffer__init_());
        $initialStack = $initialStack.$from0(sr_ScalaRunTime$_wrapRefArray($result, var$4));
        a: {
            while (true) {
                $that = sc_IndexedSeqOps_head$($initialStack);
                if ($that === null)
                    break;
                $that = $that.$_10;
                if (!sci_List_isEmpty($that)) {
                    $result = $that.$head();
                    scm_Stack_push($initialStack, s_Tuple2__init_((onciu_Foldable$TreeAny$_treeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, $result)).$toList(), scm_ListBuffer__init_()));
                    continue;
                }
                $that = scm_Stack_pop($initialStack);
                if ($that === null)
                    $rt_throw(s_MatchError__init_($that));
                $result = $that.$_20;
                if (scm_ArrayDeque_isEmpty($initialStack)) {
                    s_Predef$_$callClinit();
                    s_Predef$_assert(s_Predef$_MODULE$, $result.$length() != 1 ? 0 : 1);
                    return sc_AbstractIterable_head($result);
                }
                $that = scm_Stack_pop($initialStack);
                if ($that === null)
                    break a;
                var$5 = $that.$_10;
                $that = $that.$_20;
                if (!(var$5 instanceof sci_$colon$colon))
                    break a;
                var$5 = var$5;
                var$6 = var$5.$head0;
                var$7 = var$5.$next0;
                $result = onciu_Rewritable$_dupAny(onciu_Rewritable$_MODULE$, var$6, sc_IterableOnceOps_toSeq$($result));
                var$5 = $this.$rewriter0.$apply($result);
                scm_Stack_push($initialStack, s_Tuple2__init_(var$7, $that.$addOne(var$5)));
            }
            $rt_throw(s_MatchError__init_($that));
        }
        $that = new jl_IllegalStateException;
        jl_Throwable__init_($that, $rt_s(200));
        $rt_throw($that);
    }
    var onciu_StepSequencer$RepeatedSteps = $rt_classWithoutFields(0);
    var onciu_StepSequencer$RepeatedSteps$Permitted$ = $rt_classWithoutFields();
    var onciu_StepSequencer$RepeatedSteps$Permitted$_MODULE$ = null;
    function onciu_StepSequencer$RepeatedSteps$Permitted$__clinit_() {
        onciu_StepSequencer$RepeatedSteps$Permitted$_MODULE$ = new onciu_StepSequencer$RepeatedSteps$Permitted$;
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_0 = $rt_classWithoutFields();
    var onciu_StepSequencer$orderSteps$lambda$_3_1 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_1_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        if (!(var$1.$postConditions0()).$isEmpty())
            return s_Tuple2__init_(var$1, sr_BoxedUnit_UNIT);
        var$2 = new jl_IllegalArgumentException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(201)), var$1), $rt_s(202));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_2() {
        jl_Object.call(this);
        this.$_028 = null;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_2_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_028;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$1 = var$1.$_10;
        var$3 = var$1.$postConditions0();
        var$4 = new onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_0;
        var$4.$_054 = var$1;
        var$4.$_115 = var$2;
        var$2 = var$3.$map1(var$4);
        var$3 = new onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_1;
        var$3.$_055 = var$1;
        return var$2.$map1(var$3);
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_3 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_3_apply(var$0, var$1) {
        return var$1.$_10;
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_4 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_4_apply(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$_20.$size() <= 1 ? 0 : 1);
    }
    var sc_MapOps = $rt_classWithoutFields(0);
    function sc_MapOps_concat$($$this, $suffix) {
        var var$3, var$4;
        var$3 = $$this.$mapFactory();
        if ($rt_isInstance($suffix, sc_Iterable))
            var$4 = sc_View$Concat__init_($$this, $suffix);
        else {
            $$this = $$this.$iterator0();
            var$4 = new sc_MapOps$concat$lambda$_45_0;
            var$4.$_056 = $suffix;
            var$4 = $$this.$concat(var$4);
        }
        return var$3.$from0(var$4);
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_5 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_5_apply(var$0, var$1) {
        return var$1.$map1(new onciu_StepSequencer$$anonfun$orderSteps$8$lambda$_26_0);
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_6 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_6_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        var$3 = new jl_IllegalArgumentException;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(203)), var$2), $rt_s(204)), var$1), 46);
        jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$4));
        $rt_throw(var$3);
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_7 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_7_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        s_package$_$callClinit();
        return s_Predef$ArrowAssoc$_$minus$greater$extension(var$2, var$1, su_Left$_apply(s_package$_Left(s_package$_MODULE$), onciu_StepSequencer$ByInitialCondition$_MODULE$));
    }
    var s_$less$colon$less$ = $rt_classWithoutFields();
    var s_$less$colon$less$_MODULE$ = null;
    var s_$less$colon$less$_singleton = null;
    function s_$less$colon$less$__clinit_() {
        s_$less$colon$less$_MODULE$ = new s_$less$colon$less$;
        s_$less$colon$less$_singleton = new s_$less$colon$less$$anon$1;
    }
    function s_$less$colon$less$_refl($this) {
        return s_$less$colon$less$_singleton;
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_8 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_8_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$1.$invalidatedConditions();
        var$3 = new onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_0;
        var$3.$_057 = var$1;
        var$2 = var$2.$map1(var$3);
        var$3 = new onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_1;
        var$3.$_058 = var$1;
        return var$2.$map1(var$3);
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_9 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_9_apply(var$0, var$1) {
        return var$1.$_10;
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_10 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_10_apply(var$0, var$1) {
        return sc_AbstractIterable_toSet(var$1.$map1(new onciu_StepSequencer$$anonfun$orderSteps$16$lambda$_34_0));
    }
    function onciu_StepSequencer$MutableDirectedGraph() {
        jl_Object.call(this);
        this.$elems = null;
    }
    function onciu_StepSequencer$MutableDirectedGraph__init_() {
        var var_0 = new onciu_StepSequencer$MutableDirectedGraph();
        onciu_StepSequencer$MutableDirectedGraph__init_0(var_0);
        return var_0;
    }
    function onciu_StepSequencer$MutableDirectedGraph_add($this, $elem) {
        var var$2, var$3, var$4, var$5, var$6;
        var$2 = $this.$elems;
        var$3 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        var$4 = new onciu_StepSequencer$AdjacencyList;
        scm_Set$_$callClinit();
        var$5 = sc_IterableFactory$Delegate_empty(scm_Set$_MODULE$);
        var$6 = sc_IterableFactory$Delegate_empty(scm_Set$_MODULE$);
        var$4.$outgoing = var$5;
        var$4.$incoming = var$6;
        var$2.$addOne(s_Predef$ArrowAssoc$_$minus$greater$extension(var$3, $elem, var$4));
    }
    function onciu_StepSequencer$MutableDirectedGraph_connect($this, $from, $to) {
        (scm_HashMap_apply($this.$elems, $from)).$outgoing.$addOne($to);
        (scm_HashMap_apply($this.$elems, $to)).$incoming.$addOne($from);
    }
    function onciu_StepSequencer$MutableDirectedGraph_allNodes($this) {
        var var$1, var$2;
        var$1 = $this.$elems;
        var$2 = new sc_MapOps$KeySet;
        if (var$1 === null)
            $rt_throw(null);
        var$2.$$outer2 = var$1;
        return sc_AbstractIterable_toSet(var$2);
    }
    function onciu_StepSequencer$MutableDirectedGraph_outgoing($this, $from) {
        return sc_AbstractIterable_toSet((scm_HashMap_apply($this.$elems, $from)).$outgoing);
    }
    function onciu_StepSequencer$MutableDirectedGraph_incoming($this, $to) {
        return sc_AbstractIterable_toSet((scm_HashMap_apply($this.$elems, $to)).$incoming);
    }
    function onciu_StepSequencer$MutableDirectedGraph_toString($this) {
        var $nodes, var$2, $edges;
        $nodes = sc_AbstractIterable_mkString0((sc_IterableOnceOps_toSeq$(onciu_StepSequencer$MutableDirectedGraph_allNodes($this))).$map1(new onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_0), $rt_s(66));
        var$2 = sc_IterableOnceOps_toSeq$(onciu_StepSequencer$MutableDirectedGraph_allNodes($this));
        $edges = new onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_1;
        $edges.$_059 = $this;
        $edges = sc_AbstractIterable_mkString0(var$2.$map1($edges), $rt_s(66));
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        $nodes = jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(205)), $nodes);
        jl_AbstractStringBuilder_append($nodes, 10);
        jl_StringBuilder_append(jl_StringBuilder_append($nodes, $edges), $rt_s(206));
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function onciu_StepSequencer$MutableDirectedGraph__init_0($this) {
        scm_Map$_$callClinit();
        $this.$elems = sc_MapFactory$Delegate_empty(scm_Map$_MODULE$);
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_11() {
        jl_Object.call(this);
        this.$_029 = null;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_11_apply(var$0, var$1) {
        var$1 = var$1;
        onciu_StepSequencer$MutableDirectedGraph_add(var$0.$_029, var$1);
        return sr_BoxedUnit_UNIT;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_12() {
        var a = this; jl_Object.call(a);
        a.$_030 = null;
        a.$_19 = null;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_12_apply(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_030;
        var$3 = var$0.$_19;
        var$4 = var$1.$invalidatedConditions();
        var$5 = new onciu_StepSequencer$$anonfun$orderSteps$19$lambda$_39_0;
        var$5.$_060 = var$2;
        var$5.$_116 = var$3;
        var$5.$_28 = var$1;
        var$4.$foreach(var$5);
        return sr_BoxedUnit_UNIT;
    }
    var onciu_StepSequencer$ = $rt_classWithoutFields();
    var onciu_StepSequencer$_MODULE$ = null;
    function onciu_StepSequencer$__clinit_() {
        onciu_StepSequencer$_MODULE$ = new onciu_StepSequencer$;
    }
    function onciu_StepSequencer$_org$neo4j$cypher$internal$util$StepSequencer$$sort($this, $graph, $introducingSteps, $allSteps, $initialConditions, $fixedSeed) {
        var $order, $currentConditions, $allPostConditions, $numberOfTimesEachStepIsInvalidated, $workingGraph, $result, var$12, var$13, var$14;
        a: {
            $order = ($allSteps.$iterator0()).$flatMap2(new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_0);
            $currentConditions = sc_IterableFactory$_MODULE$;
            s_Predef$_$callClinit();
            $allPostConditions = (sc_IterableFactory$_toFactory($currentConditions, s_Predef$_Set(s_Predef$_MODULE$))).$fromSpecific($order);
            $order = new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_1;
            $order.$_061 = $introducingSteps;
            $numberOfTimesEachStepIsInvalidated = sci_AbstractMap_withDefaultValue(sc_AbstractIterable_toMap(sc_AbstractMapView_mapValues(sc_AbstractMap_view(sc_AbstractIterable_groupBy($allSteps.$flatMap($order), new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_2)), new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_3), s_$less$colon$less$_singleton), jl_Integer_valueOf(0));
            sr_BoxesRunTime_unboxToLong(s_Option_getOrElse($fixedSeed, new onciu_StepSequencer$$heuristicStepOrdering$lambda$_1_0));
            $workingGraph = su_Random__init_(new ju_Random);
            $result = scm_ArrayBuffer_addAll(scm_ArrayBuffer__init_(), $allSteps);
            var$12 = $result.$size00;
            $fixedSeed = new sci_Range$Inclusive;
            sci_Range__init_($fixedSeed, var$12, 2, 1);
            var$13 = $fixedSeed.$start1;
            var$14 = $fixedSeed.$end1;
            $currentConditions = new sci_Range$Inclusive;
            sci_Range__init_($currentConditions, var$13, var$14, (-1));
            if (!$currentConditions.$isEmpty0) {
                var$12 = $currentConditions.$start1;
                while (true) {
                    $fixedSeed = $workingGraph.$self0;
                    if (var$12 <= 0)
                        break;
                    var$13 = ju_Random_nextDouble($fixedSeed) * var$12 | 0;
                    var$14 = var$12 - 1 | 0;
                    $fixedSeed = scm_ArrayBuffer_apply($result, var$14);
                    scm_ArrayBuffer_update($result, var$14, scm_ArrayBuffer_apply($result, var$13));
                    scm_ArrayBuffer_update($result, var$13, $fixedSeed);
                    if (var$12 == $currentConditions.$scala$collection$immutable$Range$$lastElement)
                        break a;
                    var$12 = var$12 + $currentConditions.$step0 | 0;
                }
                $graph = new jl_IllegalArgumentException;
                jl_Throwable__init_0($graph);
                $rt_throw($graph);
            }
        }
        $fixedSeed = ($allSteps.$iterableFactory()).$newBuilder();
        if ($fixedSeed === null)
            $rt_throw(null);
        $fixedSeed = ($fixedSeed.$addAll0($result)).$result0();
        $order = new onciu_StepSequencer$$anonfun$heuristicStepOrdering$3;
        $order.$numberOfTimesEachStepIsInvalidated$1 = $numberOfTimesEachStepIsInvalidated;
        $order.$allStepsInRandomOrder$1 = $fixedSeed;
        $workingGraph = onciu_StepSequencer$MutableDirectedGraph__init_();
        $fixedSeed = onciu_StepSequencer$MutableDirectedGraph_allNodes($graph);
        $currentConditions = new onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_0;
        $currentConditions.$_062 = $workingGraph;
        $fixedSeed.$foreach($currentConditions);
        $fixedSeed = onciu_StepSequencer$MutableDirectedGraph_allNodes($graph);
        $currentConditions = new onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_1;
        $currentConditions.$_063 = $graph;
        $currentConditions.$_117 = $workingGraph;
        $fixedSeed.$foreach($currentConditions);
        $fixedSeed = sc_IterableFactory$_MODULE$;
        scm_Set$_$callClinit();
        $currentConditions = (sc_IterableFactory$_toFactory($fixedSeed, scm_Set$_MODULE$)).$fromSpecific($initialConditions);
        $initialConditions = s_Some__init_($order);
        $fixedSeed = new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_4;
        $fixedSeed.$_064 = $currentConditions;
        $fixedSeed.$_118 = $introducingSteps;
        $fixedSeed.$_29 = $graph;
        $fixedSeed.$_33 = $workingGraph;
        $result = onciu_StepSequencer$_org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort($this, $workingGraph, $initialConditions, $fixedSeed);
        if (onciu_AssertionRunner_isAssertionsEnabled()) {
            $graph = new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_5;
            $graph.$_065 = $result;
            if ($allSteps.$exists($graph)) {
                $graph = new jl_IllegalStateException;
                $introducingSteps = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($introducingSteps);
                jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($introducingSteps, $rt_s(207)), $result), $rt_s(208)), $allSteps), 46);
                jl_Throwable__init_($graph, jl_AbstractStringBuilder_toString($introducingSteps));
                $rt_throw($graph);
            }
            if (!$allPostConditions.$subsetOf($currentConditions)) {
                $graph = new jl_IllegalStateException;
                $introducingSteps = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($introducingSteps);
                jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($introducingSteps, $rt_s(207)), $result), $rt_s(209)), $allPostConditions), $rt_s(210)), $currentConditions), 46);
                jl_Throwable__init_($graph, jl_AbstractStringBuilder_toString($introducingSteps));
                $rt_throw($graph);
            }
        }
        $graph = new onciu_StepSequencer$AccumulatedSteps;
        $introducingSteps = sc_AbstractIterable_toSet($currentConditions);
        $graph.$steps = $result;
        $graph.$postConditions = $introducingSteps;
        return $graph;
    }
    function onciu_StepSequencer$_org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort($this, $graph, $order, $nextStepChosen) {
        var $result, $nonEmpty, $n, $startPoints, $order_0;
        $result = scm_ArrayBuffer__init_();
        $nonEmpty = onciu_StepSequencer$MutableDirectedGraph_allNodes($graph);
        $n = new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_0;
        $n.$_066 = $graph;
        $nonEmpty = $nonEmpty.$filter1($n);
        if (jl_Object_equals(s_None$_MODULE$, $order)) {
            $order = sc_IterableFactory$_MODULE$;
            scm_Set$_$callClinit();
            $startPoints = (sc_IterableFactory$_toFactory($order, scm_Set$_MODULE$)).$fromSpecific($nonEmpty);
        } else {
            if (!($order instanceof s_Some))
                $rt_throw(s_MatchError__init_($order));
            $order_0 = $order.$value5;
            scm_SortedSet$_$callClinit();
            $n = scm_SortedSet$_MODULE$;
            $order = new sc_EvidenceIterableFactory$ToFactory;
            $order.$factory0 = $n;
            $order.$evidence$15 = $order_0;
            $startPoints = $order.$fromSpecific($nonEmpty);
        }
        while (sc_IterableOnceOps_nonEmpty$($startPoints)) {
            $n = $startPoints.$head();
            $startPoints.$remove($n);
            $result.$addOne($n);
            $order = onciu_StepSequencer$MutableDirectedGraph_outgoing($graph, $n);
            $nonEmpty = new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_3;
            $nonEmpty.$_067 = $graph;
            $nonEmpty.$_119 = $n;
            $nonEmpty.$_210 = $startPoints;
            $order.$foreach($nonEmpty);
            $nextStepChosen.$apply0($n, $startPoints);
        }
        $nextStepChosen = onciu_StepSequencer$MutableDirectedGraph_allNodes($graph);
        $order = new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_1;
        $order.$_068 = $graph;
        if (!($nextStepChosen.$map1($order)).$exists(new onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_2))
            return sc_IterableOnceOps_toSeq$($result);
        $order = new jl_IllegalArgumentException;
        $nextStepChosen = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($nextStepChosen);
        jl_StringBuilder_append(jl_StringBuilder_append($nextStepChosen, $rt_s(211)), $graph);
        jl_Throwable__init_($order, jl_AbstractStringBuilder_toString($nextStepChosen));
        $rt_throw($order);
    }
    var onciu_StepSequencer$orderSteps$lambda$_3_13 = $rt_classWithoutFields();
    function onciu_StepSequencer$orderSteps$lambda$_3_13_apply(var$0, var$1, var$2) {
        return sr_BoxedUnit_UNIT;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_14() {
        jl_Object.call(this);
        this.$_031 = null;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_14_apply(var$0, var$1) {
        var$1 = var$1;
        onciu_StepSequencer$MutableDirectedGraph_add(var$0.$_031, var$1);
        return sr_BoxedUnit_UNIT;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_15() {
        var a = this; jl_Object.call(a);
        a.$_032 = null;
        a.$_110 = null;
        a.$_27 = null;
        a.$_32 = null;
    }
    function onciu_StepSequencer$orderSteps$lambda$_3_15_apply(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_032;
        var$3 = var$0.$_110;
        var$4 = var$0.$_27;
        var$5 = var$0.$_32;
        if (jl_Object_equals(onciu_StepSequencer$RepeatedSteps$Permitted$_MODULE$, var$2))
            var$2 = var$1.$preConditions();
        else {
            if (!jl_Object_equals(onciu_StepSequencer$RepeatedSteps$Forbidden$_MODULE$, var$2))
                $rt_throw(s_MatchError__init_(var$2));
            var$2 = (var$1.$preConditions()).$concat1((var$1.$invalidatedConditions()).$map1(new onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_1));
        }
        var$6 = new onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_0;
        var$6.$_069 = var$3;
        var$6.$_120 = var$1;
        var$6.$_211 = var$4;
        var$6.$_34 = var$5;
        var$2.$foreach(var$6);
        return sr_BoxedUnit_UNIT;
    }
    var onciu_StepSequencer$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function onciu_StepSequencer$$anonfun$1_applyOrElse($this, $x, $default) {
        var var$3, var$4;
        a: {
            $x = $x;
            if ($x !== null) {
                var$3 = $x.$_10;
                var$4 = $x.$_20;
                if (var$4 instanceof su_Right) {
                    $x = var$4.$value10;
                    $default = s_Predef$ArrowAssoc$_MODULE$;
                    s_Predef$_$callClinit();
                    $x = s_Predef$ArrowAssoc$_$minus$greater$extension($default, var$3, $x);
                    break a;
                }
            }
            $x = $default.$apply($x);
        }
        return $x;
    }
    var sc_MapFactoryDefaults = $rt_classWithoutFields(0);
    var sc_Map = $rt_classWithoutFields(0);
    function sc_Map_equals$($$this, $o) {
        var var$3, $$je;
        a: {
            if ($$this !== $o) {
                b: {
                    if (!$rt_isInstance($o, sc_Map))
                        var$3 = 0;
                    else {
                        $o = $o;
                        if ($$this.$size() == $o.$size()) {
                            c: {
                                try {
                                    var$3 = $$this.$forall(sc_Map$equals$lambda$_7_0__init_($o));
                                    break c;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof jl_ClassCastException) {
                                    } else {
                                        throw $$e;
                                    }
                                }
                                var$3 = 0;
                            }
                            if (var$3) {
                                var$3 = 1;
                                break b;
                            }
                        }
                        var$3 = 0;
                    }
                }
                if (!var$3) {
                    var$3 = 0;
                    break a;
                }
            }
            var$3 = 1;
        }
        return var$3;
    }
    var sci_MapOps = $rt_classWithoutFields(0);
    var sci_Map = $rt_classWithoutFields(0);
    var onciap_PatternStringifier$ = $rt_classWithoutFields();
    var onciap_PatternStringifier$_MODULE$ = null;
    function onciap_PatternStringifier$__clinit_() {
        onciap_PatternStringifier$_MODULE$ = new onciap_PatternStringifier$;
    }
    function onciap_PatternStringifier$_apply($this, $expr) {
        var var$2;
        var$2 = new onciap_DefaultPatternStringifier;
        var$2.$expr1 = $expr;
        return var$2;
    }
    var onciap_PathStepStringifier$ = $rt_classWithoutFields();
    var onciap_PathStepStringifier$_MODULE$ = null;
    function onciap_PathStepStringifier$__clinit_() {
        onciap_PathStepStringifier$_MODULE$ = new onciap_PathStepStringifier$;
    }
    function onciap_Prettifier() {
        var a = this; jl_Object.call(a);
        a.$IndentingQueryPrettifier$module = null;
        a.$expr2 = null;
        a.$extension0 = null;
        a.$useInCommands = 0;
        a.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL = null;
        a.$base = null;
    }
    function onciap_Prettifier__init_(var_0, var_1, var_2) {
        var var_3 = new onciap_Prettifier();
        onciap_Prettifier__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function onciap_Prettifier_expr($this) {
        return $this.$expr2;
    }
    function onciap_Prettifier_extension($this) {
        return $this.$extension0;
    }
    function onciap_Prettifier_asString($this, $statement) {
        var var$2, var$3;
        if ($rt_isInstance($statement, oncia_Query))
            return onciap_Prettifier$IndentingQueryPrettifier_query($this.$base, $statement);
        if ($rt_isInstance($statement, oncia_SchemaCommand))
            return onciap_Prettifier_asString0($this, $statement);
        if ($rt_isInstance($statement, oncia_AdministrationCommand))
            return onciap_Prettifier_asString1($this, $statement);
        var$2 = new jl_IllegalStateException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(212)), $statement);
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    function onciap_Prettifier_backtick($this, $s) {
        return onciap_DefaultExpressionStringifier_backtick($this.$expr2, $s);
    }
    function onciap_Prettifier_propertiesMapToString($this, $name, $properties) {
        var var$3, var$4;
        var$3 = 0;
        var$4 = null;
        if ($properties instanceof s_Some) {
            var$3 = 1;
            var$4 = $properties.$value5;
            if (var$4 instanceof su_Left) {
                var$4 = var$4.$value11;
                if (!var$4.$nonEmpty0()) {
                    $properties = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($properties);
                    jl_AbstractStringBuilder_append($properties, 32);
                    jl_StringBuilder_append(jl_StringBuilder_append($properties, $name), $rt_s(213));
                    return jl_AbstractStringBuilder_toString($properties);
                }
                $properties = new onciap_Prettifier$propertiesMapToString$lambda$_30_0;
                $properties.$_070 = $this;
                $properties = (var$4.$map1($properties)).$mkString0($rt_s(146), $rt_s(16), $rt_s(147));
                var$4 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$4);
                jl_AbstractStringBuilder_append(var$4, 32);
                $name = jl_StringBuilder_append(var$4, $name);
                jl_AbstractStringBuilder_append($name, 32);
                jl_StringBuilder_append($name, $properties);
                return jl_AbstractStringBuilder_toString(var$4);
            }
            var$4 = $properties;
        }
        if (var$3) {
            var$4 = var$4.$value5;
            if (var$4 instanceof su_Right) {
                $properties = var$4.$value10;
                var$4 = onciap_DefaultExpressionStringifier_stringify($this.$expr2, $properties);
                $properties = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($properties);
                jl_AbstractStringBuilder_append($properties, 32);
                $name = jl_StringBuilder_append($properties, $name);
                jl_AbstractStringBuilder_append($name, 32);
                jl_StringBuilder_append($name, var$4);
                return jl_AbstractStringBuilder_toString($properties);
            }
        }
        if (jl_Object_equals(s_None$_MODULE$, $properties))
            return $rt_s(3);
        $rt_throw(s_MatchError__init_($properties));
    }
    function onciap_Prettifier_asString0($this, $command) {
        var $useString, $variable, $label, $properties, $name, $ifExistsDo, $options, $fromDefault, $startOfCommand, $commandString, $relType, $isNodeIndex, $function, $pattern, $functionString, $labels, $relTypes, $ifExistsString, $containsOn, $constraintVersion, $forOrOn, $assertOrRequire, $property, $propertyString, $optionsString;
        a: {
            $useString = onciap_Prettifier_asString2($this, $command.$useGraph());
            if ($command instanceof oncia_CreateRangeNodeIndex) {
                $variable = $command.$variable4();
                $label = $command.$label();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                $fromDefault = $command.$fromDefault();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    if ($label !== null) {
                        $label = $label.$name3();
                        $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, !$fromDefault ? $rt_s(214) : $rt_s(215));
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = onciap_Prettifier_backtick($this, $label);
                        $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                        $properties = onciap_Prettifier_asString3($this, $options);
                        $name = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $rt_s(216)), $command), 58), $variable), $rt_s(217)), $label), $properties);
                        $commandString = jl_StringBuilder_toString($name);
                        break a;
                    }
                }
            }
            if ($command instanceof oncia_CreateRangeRelationshipIndex) {
                $variable = $command.$variable4();
                $label = $command.$relType();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                $fromDefault = $command.$fromDefault();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    if ($label !== null) {
                        $relType = $label.$name3();
                        $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, !$fromDefault ? $rt_s(214) : $rt_s(215));
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = onciap_Prettifier_backtick($this, $relType);
                        $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                        $properties = onciap_Prettifier_asString3($this, $options);
                        $name = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $rt_s(218)), $command), 58), $variable), $rt_s(219)), $label), $properties);
                        $commandString = jl_StringBuilder_toString($name);
                        break a;
                    }
                }
            }
            if ($command instanceof oncia_CreateLookupIndex) {
                $variable = $command.$variable4();
                $isNodeIndex = $command.$isNodeIndex();
                $function = $command.$function();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(220));
                    if (!$isNodeIndex) {
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($variable, $rt_s(221)), $command), $rt_s(222));
                        $pattern = jl_StringBuilder_toString($variable);
                    } else {
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = jl_StringBuilder__init_1();
                        jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4($variable, 40), $command), 41);
                        $pattern = jl_StringBuilder_toString($variable);
                    }
                    $command = $function.$name3();
                    $variable = (($function.$args0()).$map1(onciap_Prettifier$asString$lambda$_31_0__init_($this))).$mkString($rt_s(16));
                    $label = jl_StringBuilder__init_1();
                    jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($label, $command), 40), $variable), 41);
                    $functionString = jl_StringBuilder_toString($label);
                    $command = onciap_Prettifier_asString3($this, $options);
                    $variable = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($variable, $startOfCommand), $rt_s(223)), $pattern), $rt_s(224)), $functionString), $command);
                    $commandString = jl_StringBuilder_toString($variable);
                    break a;
                }
            }
            if ($command instanceof oncia_CreateFulltextNodeIndex) {
                $variable = $command.$variable4();
                $labels = $command.$label0();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(225));
                    $pattern = sc_AbstractIterable_mkString(sci_List_map($labels, onciap_Prettifier$asString$lambda$_31_1__init_($this)), $rt_s(136), $rt_s(189), $rt_s(3));
                    $command = onciap_Prettifier_backtick($this, $variable);
                    $variable = onciap_Prettifier_fulltextPropertiesToString$1($this, $properties);
                    $label = onciap_Prettifier_asString3($this, $options);
                    $properties = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($properties, $startOfCommand), $rt_s(216)), $command), $pattern), $rt_s(226)), $variable), $label);
                    $commandString = jl_StringBuilder_toString($properties);
                    break a;
                }
            }
            if ($command instanceof oncia_CreateFulltextRelationshipIndex) {
                $variable = $command.$variable4();
                $relTypes = $command.$relType0();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(225));
                    $pattern = sc_AbstractIterable_mkString(sci_List_map($relTypes, onciap_Prettifier$asString$lambda$_31_2__init_($this)), $rt_s(136), $rt_s(189), $rt_s(3));
                    $command = onciap_Prettifier_backtick($this, $variable);
                    $variable = onciap_Prettifier_fulltextPropertiesToString$1($this, $properties);
                    $label = onciap_Prettifier_asString3($this, $options);
                    $properties = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($properties, $startOfCommand), $rt_s(218)), $command), $pattern), $rt_s(227)), $variable), $label);
                    $commandString = jl_StringBuilder_toString($properties);
                    break a;
                }
            }
            if ($command instanceof oncia_CreateTextNodeIndex) {
                $variable = $command.$variable4();
                $label = $command.$label();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    if ($label !== null) {
                        $label = $label.$name3();
                        $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(228));
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = onciap_Prettifier_backtick($this, $label);
                        $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                        $properties = onciap_Prettifier_asString3($this, $options);
                        $name = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $rt_s(216)), $command), 58), $variable), $rt_s(217)), $label), $properties);
                        $commandString = jl_StringBuilder_toString($name);
                        break a;
                    }
                }
            }
            if ($command instanceof oncia_CreateTextRelationshipIndex) {
                $variable = $command.$variable4();
                $label = $command.$relType();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    if ($label !== null) {
                        $relType = $label.$name3();
                        $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(228));
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = onciap_Prettifier_backtick($this, $relType);
                        $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                        $properties = onciap_Prettifier_asString3($this, $options);
                        $name = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $rt_s(218)), $command), 58), $variable), $rt_s(219)), $label), $properties);
                        $commandString = jl_StringBuilder_toString($name);
                        break a;
                    }
                }
            }
            if ($command instanceof oncia_CreatePointNodeIndex) {
                $variable = $command.$variable4();
                $label = $command.$label();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    if ($label !== null) {
                        $label = $label.$name3();
                        $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(229));
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = onciap_Prettifier_backtick($this, $label);
                        $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                        $properties = onciap_Prettifier_asString3($this, $options);
                        $name = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $rt_s(216)), $command), 58), $variable), $rt_s(217)), $label), $properties);
                        $commandString = jl_StringBuilder_toString($name);
                        break a;
                    }
                }
            }
            if ($command instanceof oncia_CreatePointRelationshipIndex) {
                $variable = $command.$variable4();
                $label = $command.$relType();
                $properties = $command.$properties0();
                $name = $command.$name9();
                $ifExistsDo = $command.$ifExistsDo();
                $options = $command.$options();
                if ($variable !== null) {
                    $variable = $variable.$name3();
                    if ($label !== null) {
                        $relType = $label.$name3();
                        $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(229));
                        $command = onciap_Prettifier_backtick($this, $variable);
                        $variable = onciap_Prettifier_backtick($this, $relType);
                        $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                        $properties = onciap_Prettifier_asString3($this, $options);
                        $name = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $rt_s(218)), $command), 58), $variable), $rt_s(219)), $label), $properties);
                        $commandString = jl_StringBuilder_toString($name);
                        break a;
                    }
                }
            }
            if ($command instanceof oncia_DropIndexOnName) {
                $name = $command.$name3();
                $ifExistsString = !$command.$ifExists() ? $rt_s(3) : $rt_s(230);
                $command = onciap_Prettifier_backtick($this, $name);
                $variable = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($variable, $rt_s(231)), $command), $ifExistsString);
                $commandString = jl_StringBuilder_toString($variable);
            } else {
                if ($command instanceof oncia_CreateNodeKeyConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$label();
                    $properties = $command.$properties1();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $label = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            b: {
                                c: {
                                    d: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break c;
                                            else
                                                break d;
                                        }
                                        if ($command !== null)
                                            break c;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break b;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $label);
                            $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                            $properties = onciap_Prettifier_asString3($this, $options);
                            $name = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $forOrOn), $rt_s(104)), $command), 58), $variable), $rt_s(237)), $assertOrRequire), 32), $label), $rt_s(238)), $properties);
                            $commandString = jl_StringBuilder_toString($name);
                            break a;
                        }
                    }
                }
                if ($command instanceof oncia_CreateRelationshipKeyConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$relType();
                    $properties = $command.$properties1();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $relType = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            e: {
                                f: {
                                    g: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break f;
                                            else
                                                break g;
                                        }
                                        if ($command !== null)
                                            break f;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break e;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $relType);
                            $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                            $properties = onciap_Prettifier_asString3($this, $options);
                            $name = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $forOrOn), $rt_s(239)), $command), 58), $variable), $rt_s(240)), $assertOrRequire), 32), $label), $rt_s(241)), $properties);
                            $commandString = jl_StringBuilder_toString($name);
                            break a;
                        }
                    }
                }
                if ($command instanceof oncia_CreateNodePropertyUniquenessConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$label();
                    $properties = $command.$properties1();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $label = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            h: {
                                i: {
                                    j: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break i;
                                            else
                                                break j;
                                        }
                                        if ($command !== null)
                                            break i;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break h;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $label);
                            $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                            $properties = onciap_Prettifier_asString3($this, $options);
                            $name = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $forOrOn), $rt_s(104)), $command), 58), $variable), $rt_s(237)), $assertOrRequire), 32), $label), $rt_s(242)), $properties);
                            $commandString = jl_StringBuilder_toString($name);
                            break a;
                        }
                    }
                }
                if ($command instanceof oncia_CreateRelationshipPropertyUniquenessConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$relType();
                    $properties = $command.$properties1();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $relType = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            k: {
                                l: {
                                    m: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break l;
                                            else
                                                break m;
                                        }
                                        if ($command !== null)
                                            break l;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break k;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $relType);
                            $label = onciap_Prettifier_propertiesToString$1($this, $properties);
                            $properties = onciap_Prettifier_asString3($this, $options);
                            $name = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $startOfCommand), $forOrOn), $rt_s(239)), $command), 58), $variable), $rt_s(240)), $assertOrRequire), 32), $label), $rt_s(242)), $properties);
                            $commandString = jl_StringBuilder_toString($name);
                            break a;
                        }
                    }
                }
                if ($command instanceof oncia_CreateNodePropertyExistenceConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$label();
                    $property = $command.$property();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $label = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $propertyString = onciap_Prettifier_propertyToStringExistenceConstraint$1($this, $property, $constraintVersion);
                            $optionsString = onciap_Prettifier_asString3($this, $options);
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            n: {
                                o: {
                                    p: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break o;
                                            else
                                                break p;
                                        }
                                        if ($command !== null)
                                            break o;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break n;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $label);
                            $label = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($label, $startOfCommand), $forOrOn), $rt_s(104)), $command), 58), $variable), $rt_s(237)), $assertOrRequire), 32), $propertyString), $optionsString);
                            $commandString = jl_StringBuilder_toString($label);
                            break a;
                        }
                    }
                }
                if ($command instanceof oncia_CreateRelationshipPropertyExistenceConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$relType();
                    $property = $command.$property();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $relType = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $propertyString = onciap_Prettifier_propertyToStringExistenceConstraint$1($this, $property, $constraintVersion);
                            $optionsString = onciap_Prettifier_asString3($this, $options);
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            q: {
                                r: {
                                    s: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break r;
                                            else
                                                break s;
                                        }
                                        if ($command !== null)
                                            break r;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break q;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $relType);
                            $label = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($label, $startOfCommand), $forOrOn), $rt_s(239)), $command), 58), $variable), $rt_s(240)), $assertOrRequire), 32), $propertyString), $optionsString);
                            $commandString = jl_StringBuilder_toString($label);
                            break a;
                        }
                    }
                }
                if ($command instanceof oncia_CreateNodePropertyTypeConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$label();
                    $property = $command.$property();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $label = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $properties = onciap_Prettifier_propertyToString$1($this, $property);
                            $command = ($command.$normalizedPropertyType()).$description();
                            $name = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4($name, 40), $properties), $rt_s(243)), $command);
                            $propertyString = jl_StringBuilder_toString($name);
                            $optionsString = onciap_Prettifier_asString3($this, $options);
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            t: {
                                u: {
                                    v: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break u;
                                            else
                                                break v;
                                        }
                                        if ($command !== null)
                                            break u;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break t;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $label);
                            $label = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($label, $startOfCommand), $forOrOn), $rt_s(104)), $command), 58), $variable), $rt_s(237)), $assertOrRequire), 32), $propertyString), $optionsString);
                            $commandString = jl_StringBuilder_toString($label);
                            break a;
                        }
                    }
                }
                if ($command instanceof oncia_CreateRelationshipPropertyTypeConstraint) {
                    $variable = $command.$variable4();
                    $label = $command.$relType();
                    $property = $command.$property();
                    $name = $command.$name9();
                    $ifExistsDo = $command.$ifExistsDo();
                    $options = $command.$options();
                    $containsOn = $command.$containsOn();
                    $constraintVersion = $command.$constraintVersion();
                    if ($variable !== null) {
                        $variable = $variable.$name3();
                        if ($label !== null) {
                            $relType = $label.$name3();
                            $startOfCommand = onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $rt_s(232));
                            $label = onciap_Prettifier_propertyToString$1($this, $property);
                            $command = ($command.$normalizedPropertyType()).$description();
                            $properties = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4($properties, 40), $label), $rt_s(243)), $command);
                            $propertyString = jl_StringBuilder_toString($properties);
                            $optionsString = onciap_Prettifier_asString3($this, $options);
                            $forOrOn = !$containsOn ? $rt_s(233) : $rt_s(234);
                            w: {
                                x: {
                                    y: {
                                        $command = oncia_ConstraintVersion2$_MODULE$;
                                        if ($constraintVersion !== null) {
                                            if (!$constraintVersion.$equals($command))
                                                break x;
                                            else
                                                break y;
                                        }
                                        if ($command !== null)
                                            break x;
                                    }
                                    $assertOrRequire = $rt_s(235);
                                    break w;
                                }
                                $assertOrRequire = $rt_s(236);
                            }
                            $command = onciap_Prettifier_backtick($this, $variable);
                            $variable = onciap_Prettifier_backtick($this, $relType);
                            $label = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($label, $startOfCommand), $forOrOn), $rt_s(239)), $command), 58), $variable), $rt_s(240)), $assertOrRequire), 32), $propertyString), $optionsString);
                            $commandString = jl_StringBuilder_toString($label);
                            break a;
                        }
                    }
                }
                if (!($command instanceof oncia_DropConstraintOnName)) {
                    $useString = new jl_IllegalStateException;
                    $variable = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append($variable, $rt_s(244)), $command);
                    jl_IllegalStateException__init_($useString, jl_StringBuilder_toString($variable));
                    $rt_throw($useString);
                }
                $name = $command.$name3();
                $ifExistsString = !$command.$ifExists() ? $rt_s(3) : $rt_s(230);
                $command = onciap_Prettifier_backtick($this, $name);
                $variable = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($variable, $rt_s(245)), $command), $ifExistsString);
                $commandString = jl_StringBuilder_toString($variable);
            }
        }
        $command = jl_StringBuilder__init_1();
        jl_StringBuilder_append(jl_StringBuilder_append($command, $useString), $commandString);
        return jl_StringBuilder_toString($command);
    }
    function onciap_Prettifier_asString1($this, $adminCommand) {
        var $useString, $dryRun, $resource, $ifExists, $qualifiers, $asRevoke, $action, $withUsers, $fromRole, $y, $r, $commandString, $userName, $isEncryptedPassword, $initialPassword, $userOptions, $ifExistsDo, $userNameString, $ifNotExists, $setPasswordString, $password, $passwordString, $statusString, $homeDatabaseString, $fromUserName, $toUserName, $isEncryptedPassword_0, $ifExistsString, $passwordModeString, $passwordPrefix, $newPassword, $currentPassword, $roleName, $qualifier, $fromRoleName, $toRoleName,
        $roleNames, $userNames, $start, $qualifiers_0, $dbScope, $resource_0, $graphScope, $qualifierString, $action_0, $scope, $asCommand, $optionalName, $dbName, $options, $waitUntilComplete, $topology, $formattedOptions, $withoutNamespace, $p, $maybeTopologyString, $name, $ifExists_0, $additionalAction, $access, $optionsToRemove, $maybeAccessString, $maybeIfExists, $formattedOptionsToRemove, $aliasName, $targetName, $propertiesString, $url, $username, $driverSettings, $properties, $s, $urlString, $parameter,
        $driverSettingsString, $target, $yields, $an, $serverName, $optionString, $newName, $from, $to, $serverNames, $dryRunString, $targetString, $userString;
        a: {
            $useString = onciap_Prettifier_asString2($this, $adminCommand.$useGraph());
            $dryRun = 0;
            $resource = null;
            $ifExists = 0;
            $qualifiers = null;
            $asRevoke = 0;
            $action = null;
            $withUsers = 0;
            $fromRole = null;
            if ($adminCommand instanceof oncia_ShowUsers) {
                $resource = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowUsers_yieldOrWhere($adminCommand));
                if ($resource !== null) {
                    $y = s_Tuple2__1($resource);
                    $r = s_Tuple2__2($resource);
                    if ($y !== null && $r !== null) {
                        $resource = s_Tuple2__init_($y, $r);
                        $y = s_Tuple2__1($resource);
                        $r = s_Tuple2__2($resource);
                        $adminCommand = oncia_ShowUsers_name($adminCommand);
                        $resource = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $adminCommand), $y), $r);
                        $commandString = jl_StringBuilder_toString($resource);
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_($resource));
            }
            if ($adminCommand instanceof oncia_ShowCurrentUser) {
                $resource = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowCurrentUser_yieldOrWhere($adminCommand));
                if ($resource !== null) {
                    $y = s_Tuple2__1($resource);
                    $r = s_Tuple2__2($resource);
                    if ($y !== null && $r !== null) {
                        $resource = s_Tuple2__init_($y, $r);
                        $y = s_Tuple2__1($resource);
                        $r = s_Tuple2__2($resource);
                        $adminCommand = oncia_ShowCurrentUser_name($adminCommand);
                        $resource = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $adminCommand), $y), $r);
                        $commandString = jl_StringBuilder_toString($resource);
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_($resource));
            }
            if ($adminCommand instanceof oncia_CreateUser) {
                $userName = oncia_CreateUser_userName($adminCommand);
                $isEncryptedPassword = oncia_CreateUser_isEncryptedPassword($adminCommand);
                $initialPassword = oncia_CreateUser_initialPassword($adminCommand);
                $userOptions = oncia_CreateUser_userOptions($adminCommand);
                $ifExistsDo = oncia_CreateUser_ifExistsDo($adminCommand);
                $userNameString = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $userName);
                $ifNotExists = !(jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 0 : 1) ? $rt_s(3) : $rt_s(246);
                $setPasswordString = !$isEncryptedPassword ? $rt_s(247) : $rt_s(248);
                $password = onciap_DefaultExpressionStringifier_escapePassword(onciap_Prettifier_expr($this), $initialPassword);
                $resource = !sr_BoxesRunTime_unboxToBoolean(s_Option_getOrElse(oncia_UserOptions_requirePasswordChange($userOptions), onciap_Prettifier$asString$lambda$_32_0__init_())) ? $rt_s(153) : $rt_s(3);
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $setPasswordString), 32), $password), $rt_s(249)), $resource), $rt_s(250));
                $passwordString = jl_StringBuilder_toString($qualifiers);
                if (!s_Option_isDefined(oncia_UserOptions_suspended($userOptions)))
                    $statusString = $rt_s(3);
                else {
                    $resource = !sr_BoxesRunTime_unboxToBoolean((oncia_UserOptions_suspended($userOptions)).$get0()) ? $rt_s(251) : $rt_s(252);
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(253)), $resource);
                    $statusString = jl_StringBuilder_toString($qualifiers);
                }
                $homeDatabaseString = s_Option_getOrElse(s_Option_map(oncia_UserOptions_homeDatabase($userOptions), onciap_Prettifier$asString$lambda$_32_1__init_()), onciap_Prettifier$asString$lambda$_32_2__init_());
                $adminCommand = oncia_CreateUser_name($adminCommand);
                $resource = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 32), $userNameString), $ifNotExists), 32), $passwordString), $statusString), $homeDatabaseString);
                $commandString = jl_StringBuilder_toString($resource);
                break a;
            }
            if ($adminCommand instanceof oncia_RenameUser) {
                $fromUserName = oncia_RenameUser_fromUserName($adminCommand);
                $toUserName = oncia_RenameUser_toUserName($adminCommand);
                $ifExists = oncia_RenameUser_ifExists($adminCommand);
                $commandString = onciap_Prettifier$_prettifyRename(onciap_Prettifier$_MODULE$, oncia_RenameUser_name($adminCommand), $fromUserName, $toUserName, $ifExists);
                break a;
            }
            if ($adminCommand instanceof oncia_DropUser) {
                $userName = oncia_DropUser_userName($adminCommand);
                if (!oncia_DropUser_ifExists($adminCommand)) {
                    $adminCommand = oncia_DropUser_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $userName);
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource);
                    $commandString = jl_StringBuilder_toString($qualifiers);
                    break a;
                }
                $adminCommand = oncia_DropUser_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $userName);
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(230));
                $commandString = jl_StringBuilder_toString($qualifiers);
                break a;
            }
            if ($adminCommand instanceof oncia_AlterUser) {
                $userName = oncia_AlterUser_userName($adminCommand);
                $isEncryptedPassword_0 = oncia_AlterUser_isEncryptedPassword($adminCommand);
                $initialPassword = oncia_AlterUser_initialPassword($adminCommand);
                $userOptions = oncia_AlterUser_userOptions($adminCommand);
                $ifExists = oncia_AlterUser_ifExists($adminCommand);
                $userNameString = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $userName);
                $ifExistsString = !$ifExists ? $rt_s(3) : $rt_s(230);
                $passwordString = s_Option_getOrElse(s_Option_map($initialPassword, onciap_Prettifier$asString$lambda$_32_3__init_($this)), onciap_Prettifier$asString$lambda$_32_4__init_());
                if (!s_Option_isDefined(oncia_UserOptions_requirePasswordChange($userOptions)))
                    $passwordModeString = $rt_s(3);
                else {
                    $resource = sr_BoxesRunTime_unboxToBoolean((oncia_UserOptions_requirePasswordChange($userOptions)).$get0()) ? $rt_s(3) : $rt_s(153);
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(249)), $resource), $rt_s(250));
                    $passwordModeString = jl_StringBuilder_toString($qualifiers);
                }
                $setPasswordString = !sr_BoxesRunTime_unboxToBoolean(s_Option_getOrElse($isEncryptedPassword_0, onciap_Prettifier$asString$lambda$_32_5__init_())) ? $rt_s(247) : $rt_s(248);
                $resource = sc_StringOps$_MODULE$;
                s_Predef$_$callClinit();
                if (!sc_StringOps$_nonEmpty$extension($resource, s_Predef$_augmentString(s_Predef$_MODULE$, $passwordString)) && !sc_StringOps$_nonEmpty$extension(sc_StringOps$_MODULE$, s_Predef$_augmentString(s_Predef$_MODULE$, $passwordModeString)))
                    $passwordPrefix = $rt_s(3);
                else {
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append4($resource, 32), $setPasswordString);
                    $passwordPrefix = jl_StringBuilder_toString($resource);
                }
                if (!s_Option_isDefined(oncia_UserOptions_suspended($userOptions)))
                    $statusString = $rt_s(3);
                else {
                    $resource = !sr_BoxesRunTime_unboxToBoolean((oncia_UserOptions_suspended($userOptions)).$get0()) ? $rt_s(251) : $rt_s(252);
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(253)), $resource);
                    $statusString = jl_StringBuilder_toString($qualifiers);
                }
                $homeDatabaseString = s_Option_getOrElse(s_Option_map(oncia_UserOptions_homeDatabase($userOptions), onciap_Prettifier$asString$lambda$_32_6__init_()), onciap_Prettifier$asString$lambda$_32_7__init_());
                $adminCommand = oncia_AlterUser_name($adminCommand);
                $resource = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 32), $userNameString), $ifExistsString), $passwordPrefix), $passwordString), $passwordModeString), $statusString), $homeDatabaseString);
                $commandString = jl_StringBuilder_toString($resource);
                break a;
            }
            if ($adminCommand instanceof oncia_SetOwnPassword) {
                $newPassword = oncia_SetOwnPassword_newPassword($adminCommand);
                $currentPassword = oncia_SetOwnPassword_currentPassword($adminCommand);
                $adminCommand = oncia_SetOwnPassword_name($adminCommand);
                $resource = onciap_DefaultExpressionStringifier_escapePassword(onciap_Prettifier_expr($this), $currentPassword);
                $qualifiers = onciap_DefaultExpressionStringifier_escapePassword(onciap_Prettifier_expr($this), $newPassword);
                $action = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($action, $adminCommand), $rt_s(254)), $resource), $rt_s(255)), $qualifiers);
                $commandString = jl_StringBuilder_toString($action);
                break a;
            }
            if ($adminCommand instanceof oncia_ShowRoles) {
                $withUsers = oncia_ShowRoles_withUsers($adminCommand);
                $resource = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowRoles_yieldOrWhere($adminCommand));
                if ($resource !== null) {
                    $y = s_Tuple2__1($resource);
                    $r = s_Tuple2__2($resource);
                    if ($y !== null && $r !== null) {
                        $resource = s_Tuple2__init_($y, $r);
                        $y = s_Tuple2__1($resource);
                        $r = s_Tuple2__2($resource);
                        $adminCommand = oncia_ShowRoles_name($adminCommand);
                        $resource = !$withUsers ? $rt_s(3) : $rt_s(256);
                        $qualifiers = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $adminCommand), $resource), $y), $r);
                        $commandString = jl_StringBuilder_toString($qualifiers);
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_($resource));
            }
            if ($adminCommand instanceof oncia_CreateRole) {
                $dryRun = 1;
                $roleName = oncia_CreateRole_roleName($adminCommand);
                $resource = oncia_CreateRole_from($adminCommand);
                $ifExistsDo = oncia_CreateRole_ifExistsDo($adminCommand);
                if (jl_Object_equals(s_None$_MODULE$, $resource)) {
                    if (!(jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 0 : 1)) {
                        $adminCommand = oncia_CreateRole_name($adminCommand);
                        $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $roleName);
                        $qualifiers = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource);
                        $commandString = jl_StringBuilder_toString($qualifiers);
                        break a;
                    }
                    $adminCommand = oncia_CreateRole_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $roleName);
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(246));
                    $commandString = jl_StringBuilder_toString($qualifiers);
                    break a;
                }
                $resource = $adminCommand;
            }
            if ($dryRun) {
                $roleName = oncia_CreateRole_roleName($resource);
                $qualifier = oncia_CreateRole_from($resource);
                $ifExistsDo = oncia_CreateRole_ifExistsDo($resource);
                if ($qualifier instanceof s_Some) {
                    $fromRole = s_Some_value($qualifier);
                    if (!(jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 0 : 1)) {
                        $adminCommand = oncia_CreateRole_name($resource);
                        $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $roleName);
                        $qualifiers = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $fromRole);
                        $action = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(257)), $qualifiers);
                        $commandString = jl_StringBuilder_toString($action);
                        break a;
                    }
                    $adminCommand = oncia_CreateRole_name($resource);
                    $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $roleName);
                    $qualifiers = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $fromRole);
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(258)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
            }
            if ($adminCommand instanceof oncia_RenameRole) {
                $fromRoleName = oncia_RenameRole_fromRoleName($adminCommand);
                $toRoleName = oncia_RenameRole_toRoleName($adminCommand);
                $ifExists = oncia_RenameRole_ifExists($adminCommand);
                $commandString = onciap_Prettifier$_prettifyRename(onciap_Prettifier$_MODULE$, oncia_RenameRole_name($adminCommand), $fromRoleName, $toRoleName, $ifExists);
                break a;
            }
            if ($adminCommand instanceof oncia_DropRole) {
                $roleName = oncia_DropRole_roleName($adminCommand);
                if (!oncia_DropRole_ifExists($adminCommand)) {
                    $adminCommand = oncia_DropRole_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $roleName);
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource);
                    $commandString = jl_StringBuilder_toString($qualifiers);
                    break a;
                }
                $adminCommand = oncia_DropRole_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $roleName);
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(230));
                $commandString = jl_StringBuilder_toString($qualifiers);
                break a;
            }
            if ($adminCommand instanceof oncia_GrantRolesToUsers) {
                $roleNames = oncia_GrantRolesToUsers_roleNames($adminCommand);
                $userNames = oncia_GrantRolesToUsers_userNames($adminCommand);
                if ($roleNames.$length() <= 1)
                    $start = oncia_GrantRolesToUsers_name($adminCommand);
                else {
                    $adminCommand = oncia_GrantRolesToUsers_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 83);
                    $start = jl_StringBuilder_toString($resource);
                }
                $adminCommand = ($roleNames.$map1(onciap_Prettifier$asString$lambda$_32_8__init_())).$mkString($rt_s(16));
                $resource = ($userNames.$map1(onciap_Prettifier$asString$lambda$_32_9__init_())).$mkString($rt_s(16));
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $start), 32), $adminCommand), $rt_s(255)), $resource);
                $commandString = jl_StringBuilder_toString($qualifiers);
                break a;
            }
            if ($adminCommand instanceof oncia_RevokeRolesFromUsers) {
                $roleNames = oncia_RevokeRolesFromUsers_roleNames($adminCommand);
                $userNames = oncia_RevokeRolesFromUsers_userNames($adminCommand);
                if ($roleNames.$length() <= 1)
                    $start = oncia_RevokeRolesFromUsers_name($adminCommand);
                else {
                    $adminCommand = oncia_RevokeRolesFromUsers_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 83);
                    $start = jl_StringBuilder_toString($resource);
                }
                $adminCommand = ($roleNames.$map1(onciap_Prettifier$asString$lambda$_32_10__init_())).$mkString($rt_s(16));
                $resource = ($userNames.$map1(onciap_Prettifier$asString$lambda$_32_11__init_())).$mkString($rt_s(16));
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $start), 32), $adminCommand), $rt_s(254)), $resource);
                $commandString = jl_StringBuilder_toString($qualifiers);
                break a;
            }
            if ($adminCommand instanceof oncia_GrantPrivilege) {
                $ifExists = 1;
                $resource = oncia_GrantPrivilege_privilege($adminCommand);
                $qualifiers = oncia_GrantPrivilege_qualifier($adminCommand);
                $roleNames = oncia_GrantPrivilege_roleNames($adminCommand);
                if ($resource instanceof oncia_DbmsPrivilege) {
                    $adminCommand = oncia_GrantPrivilege_name($adminCommand);
                    $resource = onciap_Prettifier$_org$neo4j$cypher$internal$ast$prettifier$Prettifier$$extractQualifierString(onciap_Prettifier$_MODULE$, $qualifiers);
                    $qualifiers = onciap_Prettifier$_escapeNames(onciap_Prettifier$_MODULE$, $roleNames);
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($action, $adminCommand), $resource), $rt_s(259)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $qualifiers = $adminCommand;
            }
            if ($adminCommand instanceof oncia_DenyPrivilege) {
                $asRevoke = 1;
                $resource = oncia_DenyPrivilege_privilege($adminCommand);
                $qualifiers_0 = oncia_DenyPrivilege_qualifier($adminCommand);
                $roleNames = oncia_DenyPrivilege_roleNames($adminCommand);
                if ($resource instanceof oncia_DbmsPrivilege) {
                    $adminCommand = oncia_DenyPrivilege_name($adminCommand);
                    $resource = onciap_Prettifier$_org$neo4j$cypher$internal$ast$prettifier$Prettifier$$extractQualifierString(onciap_Prettifier$_MODULE$, $qualifiers_0);
                    $qualifiers = onciap_Prettifier$_escapeNames(onciap_Prettifier$_MODULE$, $roleNames);
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($action, $adminCommand), $resource), $rt_s(259)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $action = $adminCommand;
            }
            if ($adminCommand instanceof oncia_RevokePrivilege) {
                $withUsers = 1;
                $resource = oncia_RevokePrivilege_privilege($adminCommand);
                $qualifiers_0 = oncia_RevokePrivilege_qualifier($adminCommand);
                $roleNames = oncia_RevokePrivilege_roleNames($adminCommand);
                if ($resource instanceof oncia_DbmsPrivilege) {
                    $adminCommand = oncia_RevokePrivilege_name($adminCommand);
                    $resource = onciap_Prettifier$_org$neo4j$cypher$internal$ast$prettifier$Prettifier$$extractQualifierString(onciap_Prettifier$_MODULE$, $qualifiers_0);
                    $qualifiers = onciap_Prettifier$_escapeNames(onciap_Prettifier$_MODULE$, $roleNames);
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($action, $adminCommand), $resource), $rt_s(260)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $fromRole = $adminCommand;
            }
            if ($ifExists) {
                $resource = oncia_GrantPrivilege_privilege($qualifiers);
                $qualifier = oncia_GrantPrivilege_qualifier($qualifiers);
                $roleNames = oncia_GrantPrivilege_roleNames($qualifiers);
                if ($resource instanceof oncia_DatabasePrivilege) {
                    $dbScope = oncia_DatabasePrivilege_scope($resource);
                    $commandString = onciap_Prettifier$_prettifyDatabasePrivilege(onciap_Prettifier$_MODULE$, oncia_GrantPrivilege_name($qualifiers), $dbScope, $qualifier, $rt_s(261), $roleNames);
                    break a;
                }
            }
            if ($asRevoke) {
                $resource = oncia_DenyPrivilege_privilege($action);
                $qualifier = oncia_DenyPrivilege_qualifier($action);
                $roleNames = oncia_DenyPrivilege_roleNames($action);
                if ($resource instanceof oncia_DatabasePrivilege) {
                    $dbScope = oncia_DatabasePrivilege_scope($resource);
                    $commandString = onciap_Prettifier$_prettifyDatabasePrivilege(onciap_Prettifier$_MODULE$, oncia_DenyPrivilege_name($action), $dbScope, $qualifier, $rt_s(261), $roleNames);
                    break a;
                }
            }
            if ($withUsers) {
                $resource = oncia_RevokePrivilege_privilege($fromRole);
                $qualifier = oncia_RevokePrivilege_qualifier($fromRole);
                $roleNames = oncia_RevokePrivilege_roleNames($fromRole);
                if ($resource instanceof oncia_DatabasePrivilege) {
                    $dbScope = oncia_DatabasePrivilege_scope($resource);
                    $commandString = onciap_Prettifier$_prettifyDatabasePrivilege(onciap_Prettifier$_MODULE$, oncia_RevokePrivilege_name($fromRole), $dbScope, $qualifier, $rt_s(262), $roleNames);
                    break a;
                }
            }
            if ($ifExists) {
                $resource = oncia_GrantPrivilege_privilege($qualifiers);
                $resource_0 = oncia_GrantPrivilege_resource($qualifiers);
                $qualifier = oncia_GrantPrivilege_qualifier($qualifiers);
                $roleNames = oncia_GrantPrivilege_roleNames($qualifiers);
                if ($resource instanceof oncia_GraphPrivilege) {
                    $action = oncia_GraphPrivilege_action($resource);
                    $graphScope = oncia_GraphPrivilege_scope($resource);
                    $qualifierString = onciap_Prettifier$_prettifyGraphQualifier(onciap_Prettifier$_MODULE$, $action, $qualifier);
                    $commandString = onciap_Prettifier$_prettifyGraphPrivilege(onciap_Prettifier$_MODULE$, oncia_GrantPrivilege_name($qualifiers), $graphScope, $qualifierString, $resource_0, $rt_s(261), $roleNames);
                    break a;
                }
            }
            if ($asRevoke) {
                $resource = oncia_DenyPrivilege_privilege($action);
                $resource_0 = oncia_DenyPrivilege_resource($action);
                $qualifier = oncia_DenyPrivilege_qualifier($action);
                $roleNames = oncia_DenyPrivilege_roleNames($action);
                if ($resource instanceof oncia_GraphPrivilege) {
                    $action_0 = oncia_GraphPrivilege_action($resource);
                    $graphScope = oncia_GraphPrivilege_scope($resource);
                    $qualifierString = onciap_Prettifier$_prettifyGraphQualifier(onciap_Prettifier$_MODULE$, $action_0, $qualifier);
                    $commandString = onciap_Prettifier$_prettifyGraphPrivilege(onciap_Prettifier$_MODULE$, oncia_DenyPrivilege_name($action), $graphScope, $qualifierString, $resource_0, $rt_s(261), $roleNames);
                    break a;
                }
            }
            if ($withUsers) {
                $qualifiers_0 = oncia_RevokePrivilege_privilege($fromRole);
                $resource = oncia_RevokePrivilege_resource($fromRole);
                $qualifier = oncia_RevokePrivilege_qualifier($fromRole);
                $roleNames = oncia_RevokePrivilege_roleNames($fromRole);
                if ($qualifiers_0 instanceof oncia_GraphPrivilege) {
                    $action = oncia_GraphPrivilege_action($qualifiers_0);
                    $graphScope = oncia_GraphPrivilege_scope($qualifiers_0);
                    $qualifierString = onciap_Prettifier$_prettifyGraphQualifier(onciap_Prettifier$_MODULE$, $action, $qualifier);
                    $commandString = onciap_Prettifier$_prettifyGraphPrivilege(onciap_Prettifier$_MODULE$, oncia_RevokePrivilege_name($fromRole), $graphScope, $qualifierString, $resource, $rt_s(262), $roleNames);
                    break a;
                }
            }
            if ($ifExists) {
                $qualifiers_0 = oncia_GrantPrivilege_qualifier($qualifiers);
                $roleNames = oncia_GrantPrivilege_roleNames($qualifiers);
                if (oncia_GrantPrivilege_privilege($qualifiers) instanceof oncia_LoadPrivilege) {
                    $adminCommand = oncia_GrantPrivilege_name($qualifiers);
                    $resource = sr_AbstractPartialFunction_apply(onciap_Prettifier$_prettifyLoadPrivilegeQualifier(onciap_Prettifier$_MODULE$, onciap_Prettifier_expr($this)), $qualifiers_0);
                    $qualifiers = onciap_Prettifier$_escapeNames(onciap_Prettifier$_MODULE$, $roleNames);
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($action, $adminCommand), $rt_s(263)), $resource), $rt_s(255)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
            }
            if ($asRevoke) {
                $qualifiers = oncia_DenyPrivilege_qualifier($action);
                $roleNames = oncia_DenyPrivilege_roleNames($action);
                if (oncia_DenyPrivilege_privilege($action) instanceof oncia_LoadPrivilege) {
                    $adminCommand = oncia_DenyPrivilege_name($action);
                    $resource = sr_AbstractPartialFunction_apply(onciap_Prettifier$_prettifyLoadPrivilegeQualifier(onciap_Prettifier$_MODULE$, onciap_Prettifier_expr($this)), $qualifiers);
                    $qualifiers = onciap_Prettifier$_escapeNames(onciap_Prettifier$_MODULE$, $roleNames);
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($action, $adminCommand), $rt_s(263)), $resource), $rt_s(255)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
            }
            if ($withUsers) {
                $qualifiers = oncia_RevokePrivilege_qualifier($fromRole);
                $roleNames = oncia_RevokePrivilege_roleNames($fromRole);
                if (oncia_RevokePrivilege_privilege($fromRole) instanceof oncia_LoadPrivilege) {
                    $adminCommand = oncia_RevokePrivilege_name($fromRole);
                    $resource = sr_AbstractPartialFunction_apply(onciap_Prettifier$_prettifyLoadPrivilegeQualifier(onciap_Prettifier$_MODULE$, onciap_Prettifier_expr($this)), $qualifiers);
                    $qualifiers = onciap_Prettifier$_escapeNames(onciap_Prettifier$_MODULE$, $roleNames);
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($action, $adminCommand), $rt_s(263)), $resource), $rt_s(254)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
            }
            if ($adminCommand instanceof oncia_ShowSupportedPrivilegeCommand) {
                $adminCommand = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowSupportedPrivilegeCommand_yieldOrWhere($adminCommand));
                if ($adminCommand !== null) {
                    $y = s_Tuple2__1($adminCommand);
                    $r = s_Tuple2__2($adminCommand);
                    if ($y !== null && $r !== null) {
                        $adminCommand = s_Tuple2__init_($y, $r);
                        $y = s_Tuple2__1($adminCommand);
                        $r = s_Tuple2__2($adminCommand);
                        $adminCommand = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($adminCommand, $rt_s(264)), $y), $r);
                        $commandString = jl_StringBuilder_toString($adminCommand);
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_($adminCommand));
            }
            if ($adminCommand instanceof oncia_ShowPrivileges) {
                $scope = oncia_ShowPrivileges_scope($adminCommand);
                $adminCommand = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowPrivileges_yieldOrWhere($adminCommand));
                if ($adminCommand !== null) {
                    $y = s_Tuple2__1($adminCommand);
                    $r = s_Tuple2__2($adminCommand);
                    if ($y !== null && $r !== null) {
                        $adminCommand = s_Tuple2__init_($y, $r);
                        $y = s_Tuple2__1($adminCommand);
                        $r = s_Tuple2__2($adminCommand);
                        $adminCommand = onciap_Prettifier$_extractScope(onciap_Prettifier$_MODULE$, $scope);
                        $resource = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $rt_s(265)), $adminCommand), $rt_s(266)), $y), $r);
                        $commandString = jl_StringBuilder_toString($resource);
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_($adminCommand));
            }
            if ($adminCommand instanceof oncia_ShowPrivilegeCommands) {
                $scope = oncia_ShowPrivilegeCommands_scope($adminCommand);
                $asRevoke = oncia_ShowPrivilegeCommands_asRevoke($adminCommand);
                $adminCommand = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowPrivilegeCommands_yieldOrWhere($adminCommand));
                if ($adminCommand !== null) {
                    $y = s_Tuple2__1($adminCommand);
                    $r = s_Tuple2__2($adminCommand);
                    if ($y !== null && $r !== null) {
                        $adminCommand = s_Tuple2__init_($y, $r);
                        $y = s_Tuple2__1($adminCommand);
                        $r = s_Tuple2__2($adminCommand);
                        $asCommand = !$asRevoke ? $rt_s(267) : $rt_s(268);
                        $adminCommand = onciap_Prettifier$_extractScope(onciap_Prettifier$_MODULE$, $scope);
                        $resource = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $rt_s(265)), $adminCommand), $rt_s(266)), $asCommand), $y), $r);
                        $commandString = jl_StringBuilder_toString($resource);
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_($adminCommand));
            }
            if ($adminCommand instanceof oncia_ShowDatabase) {
                $scope = oncia_ShowDatabase_scope($adminCommand);
                $resource = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowDatabase_yieldOrWhere($adminCommand));
                if ($resource !== null) {
                    $y = s_Tuple2__1($resource);
                    $r = s_Tuple2__2($resource);
                    if ($y !== null && $r !== null) {
                        $resource = s_Tuple2__init_($y, $r);
                        $y = s_Tuple2__1($resource);
                        $r = s_Tuple2__2($resource);
                        if (!($scope instanceof oncia_SingleNamedDatabaseScope))
                            $optionalName = $rt_s(3);
                        else {
                            $dbName = oncia_SingleNamedDatabaseScope_database($scope);
                            $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                            $qualifiers = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append4($qualifiers, 32), $resource);
                            $optionalName = jl_StringBuilder_toString($qualifiers);
                        }
                        $adminCommand = oncia_ShowDatabase_name($adminCommand);
                        $resource = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $adminCommand), $optionalName), $y), $r);
                        $commandString = jl_StringBuilder_toString($resource);
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_($resource));
            }
            if ($adminCommand instanceof oncia_CreateDatabase) {
                $dbName = oncia_CreateDatabase_dbName($adminCommand);
                $ifExistsDo = oncia_CreateDatabase_ifExistsDo($adminCommand);
                $options = oncia_CreateDatabase_options($adminCommand);
                $waitUntilComplete = oncia_CreateDatabase_waitUntilComplete($adminCommand);
                $topology = oncia_CreateDatabase_topology($adminCommand);
                $formattedOptions = onciap_Prettifier_asString3($this, $options);
                if ($dbName instanceof oncia_NamespacedName) {
                    s_package$_$callClinit();
                    $withoutNamespace = su_Left$_apply(s_package$_Left(s_package$_MODULE$), $dbName.$toString());
                } else {
                    if (!($dbName instanceof oncia_ParameterName))
                        $rt_throw(s_MatchError__init_($dbName));
                    $p = $dbName.$parameter();
                    s_package$_$callClinit();
                    $withoutNamespace = su_Right$_apply(s_package$_Right(s_package$_MODULE$), $p);
                }
                $maybeTopologyString = s_Option_getOrElse(s_Option_map($topology, onciap_Prettifier$asString$lambda$_32_12__init_()), onciap_Prettifier$asString$lambda$_32_13__init_());
                if (!(jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 0 : 1)) {
                    $adminCommand = oncia_CreateDatabase_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $withoutNamespace);
                    $qualifiers = $waitUntilComplete.$name3();
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $maybeTopologyString), $formattedOptions), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $adminCommand = oncia_CreateDatabase_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $withoutNamespace);
                $qualifiers = $waitUntilComplete.$name3();
                $action = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(246)), $maybeTopologyString), $formattedOptions), $qualifiers);
                $commandString = jl_StringBuilder_toString($action);
                break a;
            }
            if ($adminCommand instanceof oncia_CreateCompositeDatabase) {
                $name = oncia_CreateCompositeDatabase_databaseName($adminCommand);
                $ifExistsDo = oncia_CreateCompositeDatabase_ifExistsDo($adminCommand);
                $options = oncia_CreateCompositeDatabase_options($adminCommand);
                $waitUntilComplete = oncia_CreateCompositeDatabase_waitUntilComplete($adminCommand);
                $formattedOptions = onciap_Prettifier_asString3($this, $options);
                $ifExists_0 = !(jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo) ? 0 : 1) ? $rt_s(3) : $rt_s(246);
                $adminCommand = oncia_CreateCompositeDatabase_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $name, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = $waitUntilComplete.$name3();
                $action = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $ifExists_0), $formattedOptions), $qualifiers);
                $commandString = jl_StringBuilder_toString($action);
                break a;
            }
            if ($adminCommand instanceof oncia_DropDatabase) {
                $dbName = oncia_DropDatabase_dbName($adminCommand);
                $ifExists = oncia_DropDatabase_ifExists($adminCommand);
                $additionalAction = oncia_DropDatabase_additionalAction($adminCommand);
                $waitUntilComplete = oncia_DropDatabase_waitUntilComplete($adminCommand);
                $resource = s_Tuple2__init_(sr_BoxesRunTime_boxToBoolean($ifExists), $additionalAction);
                $dryRun = s_Tuple2__1$mcZ$sp($resource);
                $qualifiers = s_Tuple2__2($resource);
                if (0 == $dryRun && jl_Object_equals(oncia_DestroyData$_MODULE$, $qualifiers)) {
                    $adminCommand = oncia_DropDatabase_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = $waitUntilComplete.$name3();
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(269)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $dryRun = s_Tuple2__1$mcZ$sp($resource);
                $qualifiers = s_Tuple2__2($resource);
                if (1 == $dryRun && jl_Object_equals(oncia_DestroyData$_MODULE$, $qualifiers)) {
                    $adminCommand = oncia_DropDatabase_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = $waitUntilComplete.$name3();
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(270)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $dryRun = s_Tuple2__1$mcZ$sp($resource);
                $qualifiers = s_Tuple2__2($resource);
                if (0 == $dryRun && jl_Object_equals(oncia_DumpData$_MODULE$, $qualifiers)) {
                    $adminCommand = oncia_DropDatabase_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = $waitUntilComplete.$name3();
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(271)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $dryRun = s_Tuple2__1$mcZ$sp($resource);
                $qualifiers = s_Tuple2__2($resource);
                if (1 == $dryRun && jl_Object_equals(oncia_DumpData$_MODULE$, $qualifiers)) {
                    $adminCommand = oncia_DropDatabase_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = $waitUntilComplete.$name3();
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(272)), $qualifiers);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $rt_throw(s_MatchError__init_($resource));
            }
            if ($adminCommand instanceof oncia_AlterDatabase) {
                $dbName = oncia_AlterDatabase_dbName($adminCommand);
                $ifExists = oncia_AlterDatabase_ifExists($adminCommand);
                $access = oncia_AlterDatabase_access($adminCommand);
                $topology = oncia_AlterDatabase_topology($adminCommand);
                $options = oncia_AlterDatabase_options($adminCommand);
                $optionsToRemove = oncia_AlterDatabase_optionsToRemove($adminCommand);
                $waitUntilComplete = oncia_AlterDatabase_waitUntilComplete($adminCommand);
                $maybeAccessString = s_Option_getOrElse(s_Option_map($access, onciap_Prettifier$asString$lambda$_32_14__init_()), onciap_Prettifier$asString$lambda$_32_15__init_());
                $maybeIfExists = !$ifExists ? $rt_s(3) : $rt_s(230);
                $maybeTopologyString = s_Option_getOrElse(s_Option_map($topology, onciap_Prettifier$asString$lambda$_32_16__init_()), onciap_Prettifier$asString$lambda$_32_17__init_());
                $formattedOptions = onciap_Prettifier_asIndividualOptions($this, $options);
                $formattedOptionsToRemove = ($optionsToRemove.$map1(onciap_Prettifier$asString$lambda$_32_18__init_($this))).$mkString($rt_s(3));
                $adminCommand = oncia_AlterDatabase_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = $waitUntilComplete.$name3();
                $action = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $maybeIfExists), $maybeAccessString), $maybeTopologyString), $formattedOptions), $formattedOptionsToRemove), $qualifiers);
                $commandString = jl_StringBuilder_toString($action);
                break a;
            }
            if ($adminCommand instanceof oncia_StartDatabase) {
                $dbName = oncia_StartDatabase_dbName($adminCommand);
                $waitUntilComplete = oncia_StartDatabase_waitUntilComplete($adminCommand);
                $adminCommand = oncia_StartDatabase_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = $waitUntilComplete.$name3();
                $action = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $qualifiers);
                $commandString = jl_StringBuilder_toString($action);
                break a;
            }
            if ($adminCommand instanceof oncia_StopDatabase) {
                $dbName = oncia_StopDatabase_dbName($adminCommand);
                $waitUntilComplete = oncia_StopDatabase_waitUntilComplete($adminCommand);
                $adminCommand = oncia_StopDatabase_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $dbName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = $waitUntilComplete.$name3();
                $action = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $qualifiers);
                $commandString = jl_StringBuilder_toString($action);
                break a;
            }
            if ($adminCommand instanceof oncia_CreateLocalDatabaseAlias) {
                $aliasName = oncia_CreateLocalDatabaseAlias_aliasName($adminCommand);
                $targetName = oncia_CreateLocalDatabaseAlias_targetName($adminCommand);
                $ifExistsDo = oncia_CreateLocalDatabaseAlias_ifExistsDo($adminCommand);
                $propertiesString = onciap_Prettifier_propertiesMapToString($this, $rt_s(273), oncia_CreateLocalDatabaseAlias_properties($adminCommand));
                if (!(jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 0 : 1)) {
                    $adminCommand = oncia_CreateLocalDatabaseAlias_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $targetName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $action = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(274)), $qualifiers), $propertiesString);
                    $commandString = jl_StringBuilder_toString($action);
                    break a;
                }
                $adminCommand = oncia_CreateLocalDatabaseAlias_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $targetName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $action = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($action, $adminCommand), 32), $resource), $rt_s(275)), $qualifiers), $propertiesString);
                $commandString = jl_StringBuilder_toString($action);
                break a;
            }
            if ($adminCommand instanceof oncia_CreateRemoteDatabaseAlias) {
                $aliasName = oncia_CreateRemoteDatabaseAlias_aliasName($adminCommand);
                $targetName = oncia_CreateRemoteDatabaseAlias_targetName($adminCommand);
                $ifExistsDo = oncia_CreateRemoteDatabaseAlias_ifExistsDo($adminCommand);
                $url = oncia_CreateRemoteDatabaseAlias_url($adminCommand);
                $username = oncia_CreateRemoteDatabaseAlias_username($adminCommand);
                $password = oncia_CreateRemoteDatabaseAlias_password($adminCommand);
                $driverSettings = oncia_CreateRemoteDatabaseAlias_driverSettings($adminCommand);
                $properties = oncia_CreateRemoteDatabaseAlias_properties($adminCommand);
                if ($url instanceof su_Left) {
                    $s = su_Left_value($url);
                    $urlString = onciap_DefaultExpressionStringifier_quote(onciap_Prettifier_expr($this), $s);
                } else {
                    if (!($url instanceof su_Right))
                        $rt_throw(s_MatchError__init_($url));
                    $parameter = su_Right_value($url);
                    $urlString = onciap_DefaultExpressionStringifier_apply(onciap_Prettifier_expr($this), $parameter);
                }
                $driverSettingsString = onciap_Prettifier_propertiesMapToString($this, $rt_s(276), $driverSettings);
                $propertiesString = onciap_Prettifier_propertiesMapToString($this, $rt_s(273), $properties);
                if (!(jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 0 : 1)) {
                    $adminCommand = oncia_CreateRemoteDatabaseAlias_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $targetName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $action = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $username);
                    $qualifier = onciap_DefaultExpressionStringifier_escapePassword(onciap_Prettifier_expr($this), $password);
                    $roleNames = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($roleNames, $adminCommand), 32), $resource), $rt_s(274)), $qualifiers), $rt_s(277)), $urlString), $rt_s(278)), $action), $rt_s(279)), $qualifier), $driverSettingsString), $propertiesString);
                    $commandString = jl_StringBuilder_toString($roleNames);
                    break a;
                }
                $adminCommand = oncia_CreateRemoteDatabaseAlias_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $targetName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $action = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $username);
                $qualifier = onciap_DefaultExpressionStringifier_escapePassword(onciap_Prettifier_expr($this), $password);
                $roleNames = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($roleNames, $adminCommand), 32), $resource), $rt_s(275)), $qualifiers), $rt_s(277)), $urlString), $rt_s(278)), $action), $rt_s(279)), $qualifier), $driverSettingsString), $propertiesString);
                $commandString = jl_StringBuilder_toString($roleNames);
                break a;
            }
            if ($adminCommand instanceof oncia_DropDatabaseAlias) {
                $aliasName = oncia_DropDatabaseAlias_aliasName($adminCommand);
                if (!oncia_DropDatabaseAlias_ifExists($adminCommand)) {
                    $adminCommand = oncia_DropDatabaseAlias_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(280));
                    $commandString = jl_StringBuilder_toString($qualifiers);
                    break a;
                }
                $adminCommand = oncia_DropDatabaseAlias_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(281));
                $commandString = jl_StringBuilder_toString($qualifiers);
                break a;
            }
            if ($adminCommand instanceof oncia_AlterLocalDatabaseAlias) {
                $aliasName = oncia_AlterLocalDatabaseAlias_aliasName($adminCommand);
                $targetName = oncia_AlterLocalDatabaseAlias_targetName($adminCommand);
                $ifExists = oncia_AlterLocalDatabaseAlias_ifExists($adminCommand);
                $properties = oncia_AlterLocalDatabaseAlias_properties($adminCommand);
                $target = s_Option_getOrElse(s_Option_map($targetName, onciap_Prettifier$asString$lambda$_32_19__init_()), onciap_Prettifier$asString$lambda$_32_20__init_());
                $propertiesString = onciap_Prettifier_propertiesMapToString($this, $rt_s(273), $properties);
                if (!$ifExists) {
                    $adminCommand = oncia_AlterLocalDatabaseAlias_name($adminCommand);
                    $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                    $qualifiers = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(282)), $target), $propertiesString);
                    $commandString = jl_StringBuilder_toString($qualifiers);
                    break a;
                }
                $adminCommand = oncia_AlterLocalDatabaseAlias_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(283)), $target), $propertiesString);
                $commandString = jl_StringBuilder_toString($qualifiers);
                break a;
            }
            if (!($adminCommand instanceof oncia_AlterRemoteDatabaseAlias)) {
                if ($adminCommand instanceof oncia_ShowAliases) {
                    $aliasName = oncia_ShowAliases_aliasName($adminCommand);
                    $yields = oncia_ShowAliases_yieldOrWhere($adminCommand);
                    $an = s_Option_getOrElse(s_Option_map($aliasName, onciap_Prettifier$asString$lambda$_32_21__init_()), onciap_Prettifier$asString$lambda$_32_22__init_());
                    $resource = onciap_Prettifier_showClausesAsString$1($this, $yields);
                    if ($resource !== null) {
                        $y = s_Tuple2__1($resource);
                        $r = s_Tuple2__2($resource);
                        if ($y !== null && $r !== null) {
                            $resource = s_Tuple2__init_($y, $r);
                            $y = s_Tuple2__1($resource);
                            $r = s_Tuple2__2($resource);
                            $adminCommand = oncia_ShowAliases_name($adminCommand);
                            $resource = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $adminCommand), $an), $rt_s(280)), $y), $r);
                            $commandString = jl_StringBuilder_toString($resource);
                            break a;
                        }
                    }
                    $rt_throw(s_MatchError__init_($resource));
                }
                if ($adminCommand instanceof oncia_EnableServer) {
                    $serverName = oncia_EnableServer_serverName($adminCommand);
                    $options = oncia_EnableServer_optionsMap($adminCommand);
                    if ($serverName instanceof su_Left) {
                        $s = su_Left_value($serverName);
                        $name = onciap_DefaultExpressionStringifier_quote(onciap_Prettifier_expr($this), $s);
                    } else {
                        if (!($serverName instanceof su_Right))
                            $rt_throw(s_MatchError__init_($serverName));
                        $parameter = su_Right_value($serverName);
                        $name = onciap_DefaultExpressionStringifier_apply(onciap_Prettifier_expr($this), $parameter);
                    }
                    $optionString = onciap_Prettifier_asString3($this, $options);
                    $adminCommand = oncia_EnableServer_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 32), $name), $optionString);
                    $commandString = jl_StringBuilder_toString($resource);
                    break a;
                }
                if ($adminCommand instanceof oncia_AlterServer) {
                    $serverName = oncia_AlterServer_serverName($adminCommand);
                    $options = oncia_AlterServer_optionsMap($adminCommand);
                    if ($serverName instanceof su_Left) {
                        $s = su_Left_value($serverName);
                        $name = onciap_DefaultExpressionStringifier_quote(onciap_Prettifier_expr($this), $s);
                    } else {
                        if (!($serverName instanceof su_Right))
                            $rt_throw(s_MatchError__init_($serverName));
                        $parameter = su_Right_value($serverName);
                        $name = onciap_DefaultExpressionStringifier_apply(onciap_Prettifier_expr($this), $parameter);
                    }
                    $optionString = onciap_Prettifier_asString3($this, $options);
                    $adminCommand = oncia_AlterServer_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 32), $name), $rt_s(284)), $optionString);
                    $commandString = jl_StringBuilder_toString($resource);
                    break a;
                }
                if ($adminCommand instanceof oncia_RenameServer) {
                    $serverName = oncia_RenameServer_serverName($adminCommand);
                    $newName = oncia_RenameServer_newName($adminCommand);
                    if ($serverName instanceof su_Left) {
                        $s = su_Left_value($serverName);
                        $from = onciap_DefaultExpressionStringifier_quote(onciap_Prettifier_expr($this), $s);
                    } else {
                        if (!($serverName instanceof su_Right))
                            $rt_throw(s_MatchError__init_($serverName));
                        $parameter = su_Right_value($serverName);
                        $from = onciap_DefaultExpressionStringifier_apply(onciap_Prettifier_expr($this), $parameter);
                    }
                    if ($newName instanceof su_Left) {
                        $s = su_Left_value($newName);
                        $to = onciap_DefaultExpressionStringifier_quote(onciap_Prettifier_expr($this), $s);
                    } else {
                        if (!($newName instanceof su_Right))
                            $rt_throw(s_MatchError__init_($newName));
                        $parameter = su_Right_value($newName);
                        $to = onciap_DefaultExpressionStringifier_apply(onciap_Prettifier_expr($this), $parameter);
                    }
                    $adminCommand = oncia_RenameServer_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 32), $from), $rt_s(255)), $to);
                    $commandString = jl_StringBuilder_toString($resource);
                    break a;
                }
                if ($adminCommand instanceof oncia_DropServer) {
                    $serverName = oncia_DropServer_serverName($adminCommand);
                    if ($serverName instanceof su_Left) {
                        $s = su_Left_value($serverName);
                        $name = onciap_DefaultExpressionStringifier_quote(onciap_Prettifier_expr($this), $s);
                    } else {
                        if (!($serverName instanceof su_Right))
                            $rt_throw(s_MatchError__init_($serverName));
                        $parameter = su_Right_value($serverName);
                        $name = onciap_DefaultExpressionStringifier_apply(onciap_Prettifier_expr($this), $parameter);
                    }
                    $adminCommand = oncia_DropServer_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 32), $name);
                    $commandString = jl_StringBuilder_toString($resource);
                    break a;
                }
                if ($adminCommand instanceof oncia_ShowServers) {
                    $resource = onciap_Prettifier_showClausesAsString$1($this, oncia_ShowServers_yieldOrWhere($adminCommand));
                    if ($resource !== null) {
                        $y = s_Tuple2__1($resource);
                        $r = s_Tuple2__2($resource);
                        if ($y !== null && $r !== null) {
                            $resource = s_Tuple2__init_($y, $r);
                            $y = s_Tuple2__1($resource);
                            $r = s_Tuple2__2($resource);
                            $adminCommand = oncia_ShowServers_name($adminCommand);
                            $resource = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $adminCommand), $y), $r);
                            $commandString = jl_StringBuilder_toString($resource);
                            break a;
                        }
                    }
                    $rt_throw(s_MatchError__init_($resource));
                }
                if (!($adminCommand instanceof oncia_DeallocateServers)) {
                    if (!($adminCommand instanceof oncia_ReallocateDatabases)) {
                        $useString = new jl_InternalError;
                        $resource = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append($resource, $rt_s(285)), $adminCommand);
                        jl_InternalError__init_($useString, jl_StringBuilder_toString($resource));
                        $rt_throw($useString);
                    }
                    if (!oncia_ReallocateDatabases_dryRun($adminCommand)) {
                        $commandString = oncia_ReallocateDatabases_name($adminCommand);
                        break a;
                    }
                    $adminCommand = oncia_ReallocateDatabases_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append($resource, $rt_s(286)), $adminCommand);
                    $commandString = jl_StringBuilder_toString($resource);
                    break a;
                }
                $dryRun = oncia_DeallocateServers_dryRun($adminCommand);
                $serverNames = oncia_DeallocateServers_serverNames($adminCommand);
                $dryRunString = !$dryRun ? $rt_s(3) : $rt_s(286);
                if ($serverNames.$length() <= 1)
                    $commandString = oncia_DeallocateServers_name($adminCommand);
                else {
                    $adminCommand = oncia_DeallocateServers_name($adminCommand);
                    $resource = jl_StringBuilder__init_1();
                    jl_StringBuilder_append4(jl_StringBuilder_append($resource, $adminCommand), 83);
                    $commandString = jl_StringBuilder_toString($resource);
                }
                $adminCommand = ($serverNames.$map1(onciap_Prettifier$asString$lambda$_32_23__init_($this))).$mkString($rt_s(16));
                $resource = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append($resource, $dryRunString), $commandString), 32), $adminCommand);
                $commandString = jl_StringBuilder_toString($resource);
                break a;
            }
            $aliasName = oncia_AlterRemoteDatabaseAlias_aliasName($adminCommand);
            $targetName = oncia_AlterRemoteDatabaseAlias_targetName($adminCommand);
            $ifExists = oncia_AlterRemoteDatabaseAlias_ifExists($adminCommand);
            $url = oncia_AlterRemoteDatabaseAlias_url($adminCommand);
            $username = oncia_AlterRemoteDatabaseAlias_username($adminCommand);
            $password = oncia_AlterRemoteDatabaseAlias_password($adminCommand);
            $driverSettings = oncia_AlterRemoteDatabaseAlias_driverSettings($adminCommand);
            $properties = oncia_AlterRemoteDatabaseAlias_properties($adminCommand);
            if (!($targetName instanceof s_Some)) {
                if (!jl_Object_equals(s_None$_MODULE$, $targetName))
                    $rt_throw(s_MatchError__init_($targetName));
                $targetString = $rt_s(3);
            } else {
                b: {
                    $targetName = s_Some_value($targetName);
                    $dryRun = 0;
                    $resource = null;
                    if ($url instanceof s_Some) {
                        $dryRun = 1;
                        $resource = s_Some_value($url);
                        if ($resource instanceof su_Left) {
                            $s = su_Left_value($resource);
                            $resource = onciap_DefaultExpressionStringifier_quote(onciap_Prettifier_expr($this), $s);
                            $qualifiers = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(277)), $resource);
                            $urlString = jl_StringBuilder_toString($qualifiers);
                            break b;
                        }
                        $resource = $url;
                    }
                    if ($dryRun) {
                        $resource = s_Some_value($resource);
                        if ($resource instanceof su_Right) {
                            $parameter = su_Right_value($resource);
                            $resource = onciap_DefaultExpressionStringifier_apply(onciap_Prettifier_expr($this), $parameter);
                            $qualifiers = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(277)), $resource);
                            $urlString = jl_StringBuilder_toString($qualifiers);
                            break b;
                        }
                    }
                    $urlString = $rt_s(3);
                }
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $targetName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(287)), $resource), $urlString);
                $targetString = jl_StringBuilder_toString($qualifiers);
            }
            if (!($username instanceof s_Some)) {
                if (!jl_Object_equals(s_None$_MODULE$, $username))
                    $rt_throw(s_MatchError__init_($username));
                $userString = $rt_s(3);
            } else {
                $username = s_Some_value($username);
                $resource = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $username);
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(278)), $resource);
                $userString = jl_StringBuilder_toString($qualifiers);
            }
            if (!($password instanceof s_Some)) {
                if (!jl_Object_equals(s_None$_MODULE$, $password))
                    $rt_throw(s_MatchError__init_($password));
                $passwordString = $rt_s(3);
            } else {
                $password = s_Some_value($password);
                $resource = onciap_DefaultExpressionStringifier_escapePassword(onciap_Prettifier_expr($this), $password);
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append($qualifiers, $rt_s(279)), $resource);
                $passwordString = jl_StringBuilder_toString($qualifiers);
            }
            $driverSettingsString = onciap_Prettifier_propertiesMapToString($this, $rt_s(276), $driverSettings);
            $propertiesString = onciap_Prettifier_propertiesMapToString($this, $rt_s(273), $properties);
            if (!$ifExists) {
                $adminCommand = oncia_AlterRemoteDatabaseAlias_name($adminCommand);
                $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
                $qualifiers = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(288)), $targetString), $userString), $passwordString), $driverSettingsString), $propertiesString);
                $commandString = jl_StringBuilder_toString($qualifiers);
                break a;
            }
            $adminCommand = oncia_AlterRemoteDatabaseAlias_name($adminCommand);
            $resource = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $aliasName, s_DummyImplicit$_dummyImplicit(s_DummyImplicit$_MODULE$));
            $qualifiers = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4(jl_StringBuilder_append($qualifiers, $adminCommand), 32), $resource), $rt_s(289)), $targetString), $userString), $passwordString), $driverSettingsString), $propertiesString);
            $commandString = jl_StringBuilder_toString($qualifiers);
        }
        $adminCommand = jl_StringBuilder__init_1();
        jl_StringBuilder_append(jl_StringBuilder_append($adminCommand, $useString), $commandString);
        return jl_StringBuilder_toString($adminCommand);
    }
    function onciap_Prettifier_asString2($this, $use) {
        var var$2;
        var$2 = new onciap_Prettifier$asString$lambda$_33_0;
        var$2.$_071 = $this;
        $use = s_Option_filter($use, var$2);
        var$2 = new onciap_Prettifier$asString$lambda$_33_1;
        var$2.$_072 = $this;
        return s_Option_getOrElse(s_Option_map($use, var$2), new onciap_Prettifier$asString$lambda$_33_2);
    }
    function onciap_Prettifier_asString3($this, $options) {
        var $parameter, $map;
        if (jl_Object_equals(oncia_NoOptions$_MODULE$, $options))
            return $rt_s(3);
        if ($options instanceof oncia_OptionsParam) {
            $parameter = $options.$parameter();
            $parameter = onciap_DefaultExpressionStringifier_stringify($this.$expr2, $parameter);
            $options = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($options);
            jl_StringBuilder_append(jl_StringBuilder_append($options, $rt_s(290)), $parameter);
            return jl_AbstractStringBuilder_toString($options);
        }
        if (!($options instanceof oncia_OptionsMap))
            $rt_throw(s_MatchError__init_($options));
        $map = $options.$map6();
        if (!$map.$nonEmpty0())
            $options = $rt_s(291);
        else {
            $options = new onciap_Prettifier$optionsToString$lambda$_35_0;
            $options.$_073 = $this;
            $options = ($map.$map1($options)).$mkString0($rt_s(146), $rt_s(16), $rt_s(147));
            $map = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($map);
            jl_StringBuilder_append(jl_StringBuilder_append($map, $rt_s(290)), $options);
            $options = jl_AbstractStringBuilder_toString($map);
        }
        return $options;
    }
    function onciap_Prettifier_asIndividualOptions($this, $options) {
        var $map;
        if (jl_Object_equals(oncia_NoOptions$_MODULE$, $options))
            return $rt_s(3);
        if ($options instanceof oncia_OptionsMap) {
            $map = $options.$map6();
            $options = new onciap_Prettifier$asIndividualOptions$lambda$_36_0;
            $options.$_074 = $this;
            return ($map.$map1($options)).$mkString($rt_s(3));
        }
        if (!($options instanceof oncia_OptionsParam))
            $rt_throw(s_MatchError__init_($options));
        $options = new jl_InternalError;
        jl_Throwable__init_($options, $rt_s(292));
        $rt_throw($options);
    }
    function onciap_Prettifier_propertiesToString$1($this, $properties) {
        var var$2;
        var$2 = new onciap_Prettifier$propertiesToString$1$lambda$_53_0;
        var$2.$_075 = $this;
        return ($properties.$map1(var$2)).$mkString0($rt_s(24), $rt_s(16), $rt_s(25));
    }
    function onciap_Prettifier_fulltextPropertiesToString$1($this, $properties) {
        var var$2;
        var$2 = new onciap_Prettifier$fulltextPropertiesToString$1$lambda$_55_0;
        var$2.$_076 = $this;
        return ($properties.$map1(var$2)).$mkString0($rt_s(143), $rt_s(16), $rt_s(144));
    }
    function onciap_Prettifier_propertyToString$1($this, $property) {
        var var$2, var$3;
        var$2 = onciap_DefaultExpressionStringifier_stringify($this.$expr2, $property.$map4());
        $property = onciap_Prettifier_backtick($this, ($property.$propertyKey()).$name3());
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$2 = jl_StringBuilder_append(var$3, var$2);
        jl_AbstractStringBuilder_append(var$2, 46);
        jl_StringBuilder_append(var$2, $property);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function onciap_Prettifier_propertyToStringExistenceConstraint$1($this, $property, $constraintVersion) {
        if (!jl_Object_equals(oncia_ConstraintVersion0$_MODULE$, $constraintVersion)) {
            $property = onciap_Prettifier_propertyToString$1($this, $property);
            $constraintVersion = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($constraintVersion);
            jl_AbstractStringBuilder_append($constraintVersion, 40);
            jl_StringBuilder_append(jl_StringBuilder_append($constraintVersion, $property), $rt_s(293));
            return jl_AbstractStringBuilder_toString($constraintVersion);
        }
        $property = onciap_Prettifier_propertyToString$1($this, $property);
        $constraintVersion = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($constraintVersion);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($constraintVersion, $rt_s(294)), $property), 41);
        return jl_AbstractStringBuilder_toString($constraintVersion);
    }
    function onciap_Prettifier_getStartOfCommand$1($this, $name, $ifExistsDo, $schemaType) {
        var $nameString;
        $nameString = new onciap_Prettifier$getStartOfCommand$1$lambda$_60_0;
        $nameString.$_077 = $this;
        $nameString = s_Option_getOrElse(s_Option_map($name, $nameString), new onciap_Prettifier$getStartOfCommand$1$lambda$_60_1);
        if (jl_Object_equals(oncia_IfExistsDoNothing$_MODULE$, $ifExistsDo)) {
            $name = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($name);
            $ifExistsDo = jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(295)), $schemaType);
            jl_AbstractStringBuilder_append($ifExistsDo, 32);
            jl_StringBuilder_append(jl_StringBuilder_append($ifExistsDo, $nameString), $rt_s(296));
            return jl_AbstractStringBuilder_toString($name);
        }
        if (jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo)) {
            $name = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($name);
            $ifExistsDo = jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(297)), $schemaType);
            jl_AbstractStringBuilder_append($ifExistsDo, 32);
            jl_StringBuilder_append(jl_StringBuilder_append($ifExistsDo, $nameString), $rt_s(296));
            return jl_AbstractStringBuilder_toString($name);
        }
        if (jl_Object_equals(oncia_IfExistsReplace$_MODULE$, $ifExistsDo)) {
            $name = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($name);
            $ifExistsDo = jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(297)), $schemaType);
            jl_AbstractStringBuilder_append($ifExistsDo, 32);
            jl_StringBuilder_append($ifExistsDo, $nameString);
            return jl_AbstractStringBuilder_toString($name);
        }
        if (!jl_Object_equals(oncia_IfExistsThrowError$_MODULE$, $ifExistsDo))
            $rt_throw(s_MatchError__init_($ifExistsDo));
        $name = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($name);
        $ifExistsDo = jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(295)), $schemaType);
        jl_AbstractStringBuilder_append($ifExistsDo, 32);
        jl_StringBuilder_append($ifExistsDo, $nameString);
        return jl_AbstractStringBuilder_toString($name);
    }
    function onciap_Prettifier_showClausesAsString$1($this, $yieldOrWhere) {
        var $ind, var$3, $y, $r, var$6, var$7;
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this.$base);
        var$3 = 0;
        $y = null;
        if ($yieldOrWhere instanceof s_Some) {
            var$3 = 1;
            $y = $yieldOrWhere.$value5;
            if (!($y instanceof su_Left))
                $y = $yieldOrWhere;
            else {
                $r = $y.$value11;
                if ($r !== null) {
                    $y = $r.$_16();
                    $r = $r.$_25();
                    $yieldOrWhere = new s_Tuple2;
                    var$6 = $this.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL;
                    $y = onciap_Prettifier$IndentingQueryPrettifier_asString($ind, $y);
                    var$7 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$7);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$7, var$6), $y);
                    var$7 = jl_AbstractStringBuilder_toString(var$7);
                    $y = new onciap_Prettifier$showClausesAsString$1$lambda$_67_0;
                    $y.$_078 = $ind;
                    $ind = s_Option_map($r, $y);
                    $y = new onciap_Prettifier$showClausesAsString$1$lambda$_67_1;
                    $y.$_079 = $this;
                    s_Tuple2__init_0($yieldOrWhere, var$7, s_Option_getOrElse(s_Option_map($ind, $y), new onciap_Prettifier$showClausesAsString$1$lambda$_67_2));
                    return $yieldOrWhere;
                }
                $y = $yieldOrWhere;
            }
        }
        if (var$3) {
            $y = $y.$value5;
            if ($y instanceof su_Right) {
                $r = $y.$value10;
                $yieldOrWhere = new s_Tuple2;
                $y = $this.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL;
                $r = onciap_Prettifier$IndentingQueryPrettifier_asString0($ind, $r);
                $ind = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($ind);
                jl_StringBuilder_append(jl_StringBuilder_append($ind, $y), $r);
                s_Tuple2__init_0($yieldOrWhere, jl_AbstractStringBuilder_toString($ind), $rt_s(3));
                return $yieldOrWhere;
            }
        }
        if (!jl_Object_equals(s_None$_MODULE$, $yieldOrWhere))
            $rt_throw(s_MatchError__init_($yieldOrWhere));
        return s_Tuple2__init_($rt_s(3), $rt_s(3));
    }
    function onciap_Prettifier__init_0($this, $expr, $extension, $useInCommands) {
        var $$je;
        $this.$expr2 = $expr;
        $this.$extension0 = $extension;
        $this.$useInCommands = $useInCommands;
        $this.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL = $rt_s(66);
        $expr = new onciap_Prettifier$IndentingQueryPrettifier;
        if ($this.$IndentingQueryPrettifier$module === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$IndentingQueryPrettifier$module !== null)
                        break a;
                    $this.$IndentingQueryPrettifier$module = onciap_Prettifier$IndentingQueryPrettifier$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    $expr = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw($expr);
            }
            jl_Object_monitorExitSync($this);
        }
        onciap_Prettifier$IndentingQueryPrettifier__init_($expr, $this, 0);
        $this.$base = $expr;
    }
    var onciap_Prettifier$ = $rt_classWithoutFields();
    var onciap_Prettifier$_MODULE$ = null;
    function onciap_Prettifier$__clinit_() {
        onciap_Prettifier$_MODULE$ = new onciap_Prettifier$;
    }
    function onciap_Prettifier$_prettifyRename($this, $commandName, $fromName, $toName, $ifExists) {
        var $maybeIfExists, var$6;
        $maybeIfExists = !$ifExists ? $rt_s(3) : $rt_s(230);
        $fromName = onciap_Prettifier$_escapeName($this, $fromName);
        $toName = onciap_Prettifier$_escapeName($this, $toName);
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        $commandName = jl_StringBuilder_append(var$6, $commandName);
        jl_AbstractStringBuilder_append($commandName, 32);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($commandName, $fromName), $maybeIfExists), $rt_s(255)), $toName);
        return jl_AbstractStringBuilder_toString(var$6);
    }
    function onciap_Prettifier$_extractScope($this, $scope) {
        var $name, $names;
        if ($scope instanceof oncia_ShowUserPrivileges) {
            $name = $scope.$user;
            if (!s_Option_isDefined($name))
                return $rt_s(298);
            $scope = onciap_Prettifier$_escapeName($this, $name.$get0());
            $names = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($names);
            jl_StringBuilder_append(jl_StringBuilder_append($names, $rt_s(299)), $scope);
            return jl_AbstractStringBuilder_toString($names);
        }
        if ($scope instanceof oncia_ShowUsersPrivileges) {
            $names = $scope.$users;
            if ($names.$length() != 1) {
                $scope = onciap_Prettifier$_escapeNames($this, $names);
                $names = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($names);
                jl_StringBuilder_append(jl_StringBuilder_append($names, $rt_s(300)), $scope);
                return jl_AbstractStringBuilder_toString($names);
            }
            $scope = onciap_Prettifier$_escapeName($this, $names.$head());
            $names = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($names);
            jl_StringBuilder_append(jl_StringBuilder_append($names, $rt_s(299)), $scope);
            return jl_AbstractStringBuilder_toString($names);
        }
        if (!($scope instanceof oncia_ShowRolesPrivileges)) {
            if (!($scope instanceof oncia_ShowAllPrivileges))
                return $rt_s(301);
            return $rt_s(302);
        }
        $names = $scope.$roles;
        if ($names.$length() != 1) {
            $scope = onciap_Prettifier$_escapeNames($this, $names);
            $names = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($names);
            jl_StringBuilder_append(jl_StringBuilder_append($names, $rt_s(303)), $scope);
            return jl_AbstractStringBuilder_toString($names);
        }
        $scope = onciap_Prettifier$_escapeName($this, $names.$head());
        $names = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($names);
        jl_StringBuilder_append(jl_StringBuilder_append($names, $rt_s(304)), $scope);
        return jl_AbstractStringBuilder_toString($names);
    }
    function onciap_Prettifier$_prettifyDatabasePrivilege($this, $privilegeName, $dbScope, $qualifier, $preposition, $roleNames) {
        var $multiple, $db, $dbName, var$9, $default;
        a: {
            $multiple = 0;
            $db = null;
            if ($dbScope instanceof oncia_SingleNamedDatabaseScope) {
                $dbName = $dbScope.$database0;
                $db = s_Tuple3__init_(onciap_Prettifier$_escapeName0($this, $dbName, s_DummyImplicit$_dummyImplicit0), jl_Boolean_valueOf(0), jl_Boolean_valueOf(0));
            } else if ($dbScope instanceof oncia_AllDatabasesScope)
                $db = s_Tuple3__init_($rt_s(305), jl_Boolean_valueOf(0), jl_Boolean_valueOf(0));
            else if ($dbScope instanceof oncia_DefaultDatabaseScope)
                $db = s_Tuple3__init_($rt_s(306), jl_Boolean_valueOf(1), jl_Boolean_valueOf(0));
            else if ($dbScope instanceof oncia_HomeDatabaseScope)
                $db = s_Tuple3__init_($rt_s(307), jl_Boolean_valueOf(1), jl_Boolean_valueOf(0));
            else {
                if ($dbScope instanceof oncia_NamedDatabasesScope) {
                    $multiple = 1;
                    $db = $dbScope.$databases;
                    if (!($db instanceof sci_$colon$colon))
                        $db = $dbScope;
                    else {
                        var$9 = $db.$head0;
                        $dbName = $db.$next0;
                        if (sci_List_equals(sci_Nil$_MODULE$, $dbName)) {
                            $db = s_Tuple3__init_(onciap_Prettifier$_escapeName0($this, var$9, s_DummyImplicit$_dummyImplicit0), jl_Boolean_valueOf(0), jl_Boolean_valueOf(0));
                            break a;
                        }
                        $db = $dbScope;
                    }
                }
                if (!$multiple)
                    $rt_throw(s_MatchError__init_($dbScope));
                $dbName = $db.$databases;
                $db = s_Tuple3__init_(onciap_Prettifier$_escapeNames0($this, $dbName, s_DummyImplicit$_dummyImplicit0), jl_Boolean_valueOf(0), jl_Boolean_valueOf(1));
            }
        }
        $dbName = $db.$_121;
        $default = sr_BoxesRunTime_unboxToBoolean($db.$_212);
        $multiple = sr_BoxesRunTime_unboxToBoolean($db.$_35);
        var$9 = s_Tuple3__init_($dbName, jl_Boolean_valueOf($default), jl_Boolean_valueOf($multiple));
        $dbName = var$9.$_121;
        $default = sr_BoxesRunTime_unboxToBoolean(var$9.$_212);
        $multiple = sr_BoxesRunTime_unboxToBoolean(var$9.$_35);
        if ($default) {
            $dbScope = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($dbScope);
            jl_StringBuilder_append(jl_StringBuilder_append($dbScope, $dbName), $rt_s(308));
            $db = jl_AbstractStringBuilder_toString($dbScope);
        } else if (!$multiple) {
            $dbScope = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($dbScope);
            jl_StringBuilder_append(jl_StringBuilder_append($dbScope, $rt_s(309)), $dbName);
            $db = jl_AbstractStringBuilder_toString($dbScope);
        } else {
            $dbScope = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($dbScope);
            jl_StringBuilder_append(jl_StringBuilder_append($dbScope, $rt_s(310)), $dbName);
            $db = jl_AbstractStringBuilder_toString($dbScope);
        }
        $dbScope = onciap_Prettifier$_org$neo4j$cypher$internal$ast$prettifier$Prettifier$$extractQualifierString($this, $qualifier);
        $qualifier = onciap_Prettifier$_escapeNames($this, $roleNames);
        $roleNames = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($roleNames);
        $privilegeName = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($roleNames, $privilegeName), $dbScope), $rt_s(263)), $db);
        jl_AbstractStringBuilder_append($privilegeName, 32);
        $privilegeName = jl_StringBuilder_append($privilegeName, $preposition);
        jl_AbstractStringBuilder_append($privilegeName, 32);
        jl_StringBuilder_append($privilegeName, $qualifier);
        return jl_AbstractStringBuilder_toString($roleNames);
    }
    function onciap_Prettifier$_prettifyGraphPrivilege($this, $privilegeName, $graphScope, $qualifierString, $resource, $preposition, $roleNames) {
        var var$7, $name, $names, $resourceName, $scope;
        a: {
            var$7 = 0;
            $name = null;
            if ($resource instanceof s_Some) {
                var$7 = 1;
                $names = $resource.$value5;
                if ($names instanceof oncia_PropertyResource) {
                    $name = oncia_PropertyResource_property($names);
                    $resource = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $name, 0, 0);
                    $names = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($names);
                    jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($names, $rt_s(311)), $resource), 125);
                    $resourceName = jl_AbstractStringBuilder_toString($names);
                    break a;
                }
                $name = $resource;
            }
            if (var$7) {
                $names = $name.$value5;
                if ($names instanceof oncia_PropertiesResource) {
                    $names = ($names.$properties2.$map1(new onciap_Prettifier$$prettifyGraphPrivilege$lambda$_7_0)).$mkString($rt_s(16));
                    $name = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($name);
                    jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(311)), $names), 125);
                    $resourceName = jl_AbstractStringBuilder_toString($name);
                    break a;
                }
            }
            if (var$7 && $name.$value5 instanceof oncia_AllPropertyResource)
                $resourceName = $rt_s(312);
            else {
                if (var$7) {
                    $names = $name.$value5;
                    if ($names instanceof oncia_LabelResource) {
                        $name = oncia_LabelResource_label($names);
                        $names = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $name, 0, 0);
                        $resource = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($resource);
                        jl_AbstractStringBuilder_append($resource, 32);
                        jl_StringBuilder_append($resource, $names);
                        $resourceName = jl_AbstractStringBuilder_toString($resource);
                        break a;
                    }
                }
                if (var$7) {
                    $names = $name.$value5;
                    if ($names instanceof oncia_LabelsResource) {
                        $names = ($names.$labels0.$map1(new onciap_Prettifier$$prettifyGraphPrivilege$lambda$_7_1)).$mkString($rt_s(16));
                        $resource = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($resource);
                        jl_AbstractStringBuilder_append($resource, 32);
                        jl_StringBuilder_append($resource, $names);
                        $resourceName = jl_AbstractStringBuilder_toString($resource);
                        break a;
                    }
                }
                if (var$7 && $name.$value5 instanceof oncia_AllLabelResource)
                    $resourceName = $rt_s(313);
                else {
                    if (!jl_Object_equals(s_None$_MODULE$, $resource)) {
                        $privilegeName = new jl_IllegalStateException;
                        $graphScope = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($graphScope);
                        jl_StringBuilder_append(jl_StringBuilder_append($graphScope, $rt_s(314)), $resource);
                        jl_Throwable__init_($privilegeName, jl_AbstractStringBuilder_toString($graphScope));
                        $rt_throw($privilegeName);
                    }
                    $resourceName = $rt_s(3);
                }
            }
        }
        b: {
            var$7 = 0;
            $resource = null;
            if ($graphScope instanceof oncia_SingleNamedGraphScope) {
                $graphScope = onciap_Prettifier$_escapeName0($this, oncia_SingleNamedGraphScope_graph($graphScope), s_DummyImplicit$_dummyImplicit0);
                $resource = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($resource);
                jl_StringBuilder_append(jl_StringBuilder_append($resource, $rt_s(315)), $graphScope);
                $graphScope = jl_AbstractStringBuilder_toString($resource);
            } else if ($graphScope instanceof oncia_AllGraphsScope)
                $graphScope = $rt_s(316);
            else if ($graphScope instanceof oncia_DefaultGraphScope)
                $graphScope = $rt_s(317);
            else if ($graphScope instanceof oncia_HomeGraphScope)
                $graphScope = $rt_s(318);
            else {
                if ($graphScope instanceof oncia_NamedGraphsScope) {
                    var$7 = 1;
                    $resource = $graphScope.$graphs;
                    if (!($resource instanceof sci_$colon$colon))
                        $resource = $graphScope;
                    else {
                        $name = $resource.$head0;
                        $names = $resource.$next0;
                        if (sci_List_equals(sci_Nil$_MODULE$, $names)) {
                            $graphScope = onciap_Prettifier$_escapeName0($this, $name, s_DummyImplicit$_dummyImplicit0);
                            $resource = new jl_StringBuilder;
                            jl_AbstractStringBuilder__init_($resource);
                            jl_StringBuilder_append(jl_StringBuilder_append($resource, $rt_s(315)), $graphScope);
                            $graphScope = jl_AbstractStringBuilder_toString($resource);
                            break b;
                        }
                        $resource = $graphScope;
                    }
                }
                if (!var$7)
                    $rt_throw(s_MatchError__init_($graphScope));
                $graphScope = onciap_Prettifier$_escapeNames0($this, $resource.$graphs, s_DummyImplicit$_dummyImplicit0);
                $resource = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($resource);
                jl_StringBuilder_append(jl_StringBuilder_append($resource, $rt_s(319)), $graphScope);
                $graphScope = jl_AbstractStringBuilder_toString($resource);
            }
        }
        $scope = jl_String_valueOf($graphScope);
        $graphScope = onciap_Prettifier$_escapeNames($this, $roleNames);
        $resource = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($resource);
        $privilegeName = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($resource, $privilegeName), $resourceName), $rt_s(263)), $scope), $qualifierString);
        jl_AbstractStringBuilder_append($privilegeName, 32);
        $privilegeName = jl_StringBuilder_append($privilegeName, $preposition);
        jl_AbstractStringBuilder_append($privilegeName, 32);
        jl_StringBuilder_append($privilegeName, $graphScope);
        return jl_AbstractStringBuilder_toString($resource);
    }
    function onciap_Prettifier$_prettifyLoadPrivilegeQualifier($this, $expr) {
        var var$2;
        var$2 = new onciap_Prettifier$$anonfun$prettifyLoadPrivilegeQualifier$1;
        var$2.$expr$1 = $expr;
        return var$2;
    }
    function onciap_Prettifier$_prettifyGraphQualifier($this, $action, $qualifier) {
        if (!($action.$name3()).$equals($rt_s(320)) && !($action.$name3()).$equals($rt_s(321)) && !($action.$name3()).$equals($rt_s(322)))
            return onciap_Prettifier$_org$neo4j$cypher$internal$ast$prettifier$Prettifier$$extractQualifierString($this, $qualifier);
        return $rt_s(3);
    }
    function onciap_Prettifier$_extractQualifierPart($this, $qualifier) {
        var var$2, var$3, var$4, $lqs, $v, $e, $user;
        var$2 = 0;
        var$3 = null;
        if ($qualifier instanceof sci_$colon$colon) {
            var$2 = 1;
            var$3 = sci_$colon$colon_head($qualifier);
            var$4 = sci_$colon$colon_next$access$1($qualifier);
            if (var$3 instanceof oncia_LabelQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4)) {
                var$4 = new s_Some;
                $qualifier = sc_AbstractIterable_mkString0(sci_List_map($qualifier, onciap_Prettifier$_stringify$1()), $rt_s(16));
                var$3 = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(323)), $qualifier);
                s_Some__init_0(var$4, jl_StringBuilder_toString(var$3));
                return var$4;
            }
            var$3 = $qualifier;
        }
        if (var$2 && sci_$colon$colon_head(var$3) instanceof oncia_LabelQualifier) {
            $qualifier = new s_Some;
            var$3 = sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16));
            var$4 = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(324)), var$3);
            s_Some__init_0($qualifier, jl_StringBuilder_toString(var$4));
            return $qualifier;
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_LabelAllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_Some__init_($rt_s(325));
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_RelationshipQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4)) {
                $qualifier = new s_Some;
                var$3 = sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16));
                var$4 = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(326)), var$3);
                s_Some__init_0($qualifier, jl_StringBuilder_toString(var$4));
                return $qualifier;
            }
        }
        if (var$2 && sci_$colon$colon_head(var$3) instanceof oncia_RelationshipQualifier) {
            $qualifier = new s_Some;
            var$3 = sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16));
            var$4 = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(327)), var$3);
            s_Some__init_0($qualifier, jl_StringBuilder_toString(var$4));
            return $qualifier;
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_RelationshipAllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_Some__init_($rt_s(328));
        }
        if (var$2 && sci_$colon$colon_head(var$3) instanceof oncia_ElementQualifier) {
            $qualifier = new s_Some;
            var$3 = sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16));
            var$4 = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(329)), var$3);
            s_Some__init_0($qualifier, jl_StringBuilder_toString(var$4));
            return $qualifier;
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_ElementsAllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_Some__init_($rt_s(330));
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_PatternQualifier) {
                $lqs = oncia_PatternQualifier_labelQualifiers($qualifier);
                $v = oncia_PatternQualifier_variable($qualifier);
                $e = oncia_PatternQualifier_expression($qualifier);
                if (sci_List_equals(sci_Nil$_MODULE$, var$4)) {
                    $qualifier = new s_Some;
                    var$3 = onciap_Prettifier$_extractPropertyRuleExpression$1($lqs, $v, $e);
                    var$4 = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(223)), var$3);
                    s_Some__init_0($qualifier, jl_StringBuilder_toString(var$4));
                    return $qualifier;
                }
            }
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_UserQualifier) {
                $user = oncia_UserQualifier_username($qualifier);
                if (sci_List_equals(sci_Nil$_MODULE$, var$4)) {
                    $qualifier = new s_Some;
                    var$3 = onciap_Prettifier$_escapeName($this, $user);
                    var$4 = jl_StringBuilder__init_1();
                    jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(var$4, 40), var$3), 41);
                    s_Some__init_0($qualifier, jl_StringBuilder_toString(var$4));
                    return $qualifier;
                }
            }
        }
        if (var$2 && sci_$colon$colon_head(var$3) instanceof oncia_UserQualifier) {
            $qualifier = new s_Some;
            var$3 = sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16));
            var$4 = jl_StringBuilder__init_1();
            jl_StringBuilder_append4(jl_StringBuilder_append(jl_StringBuilder_append4(var$4, 40), var$3), 41);
            s_Some__init_0($qualifier, jl_StringBuilder_toString(var$4));
            return $qualifier;
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_UserAllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_Some__init_($rt_s(331));
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_AllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_None$_MODULE$;
        }
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_AllDatabasesQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_None$_MODULE$;
        }
        if (var$2 && sci_$colon$colon_head(var$3) instanceof oncia_ProcedureQualifier)
            return s_Some__init_(sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16)));
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_ProcedureAllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_Some__init_($rt_s(305));
        }
        if (var$2 && sci_$colon$colon_head(var$3) instanceof oncia_FunctionQualifier)
            return s_Some__init_(sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16)));
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$4 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_FunctionAllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$4))
                return s_Some__init_($rt_s(305));
        }
        if (var$2 && sci_$colon$colon_head(var$3) instanceof oncia_SettingQualifier)
            return s_Some__init_(sc_AbstractIterable_mkString0(sci_List_map(var$3, onciap_Prettifier$_stringify$1()), $rt_s(16)));
        if (var$2) {
            $qualifier = sci_$colon$colon_head(var$3);
            var$3 = sci_$colon$colon_next$access$1(var$3);
            if ($qualifier instanceof oncia_SettingAllQualifier && sci_List_equals(sci_Nil$_MODULE$, var$3))
                return s_Some__init_($rt_s(305));
        }
        return s_Some__init_($rt_s(301));
    }
    function onciap_Prettifier$_org$neo4j$cypher$internal$ast$prettifier$Prettifier$$extractQualifierString($this, $qualifier) {
        var $qualifierPart, $string;
        $qualifierPart = onciap_Prettifier$_extractQualifierPart($this, $qualifier);
        if (!($qualifierPart instanceof s_Some))
            return $rt_s(3);
        $string = $qualifierPart.$value5;
        $qualifier = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($qualifier);
        jl_AbstractStringBuilder_append($qualifier, 32);
        jl_StringBuilder_append($qualifier, $string);
        return jl_AbstractStringBuilder_toString($qualifier);
    }
    function onciap_Prettifier$_escapeName($this, $name) {
        var $s, $p;
        if ($name instanceof su_Left) {
            $s = $name.$value11;
            return onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $s, 0, 0);
        }
        if (!($name instanceof su_Right))
            $rt_throw(s_MatchError__init_($name));
        $p = $name.$value10;
        $name = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $p.$name10, 0, 0);
        $p = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($p);
        jl_AbstractStringBuilder_append($p, 36);
        jl_StringBuilder_append($p, $name);
        return jl_AbstractStringBuilder_toString($p);
    }
    function onciap_Prettifier$_escapeName0($this, $name, $d) {
        var var$3, $names, $namespace, $p;
        var$3 = 0;
        $d = null;
        if ($name instanceof oncia_NamespacedName) {
            var$3 = 1;
            $d = $name;
            $names = $d.$nameComponents;
            $namespace = $d.$namespace2;
            if ($namespace instanceof s_Some) {
                $namespace = $namespace.$value5;
                $name = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $namespace, 0, 0);
                $d = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, sc_AbstractIterable_mkString0($names, $rt_s(142)), 0, 0);
                $namespace = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($namespace);
                $name = jl_StringBuilder_append($namespace, $name);
                jl_AbstractStringBuilder_append($name, 46);
                jl_StringBuilder_append($name, $d);
                return jl_AbstractStringBuilder_toString($namespace);
            }
        }
        if (var$3) {
            $names = $d.$nameComponents;
            $namespace = $d.$namespace2;
            if (jl_Object_equals(s_None$_MODULE$, $namespace))
                return onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, sc_AbstractIterable_mkString0($names, $rt_s(142)), 0, 0);
        }
        if (!($name instanceof oncia_ParameterName))
            $rt_throw(s_MatchError__init_($name));
        $p = $name.$parameter0;
        $name = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $p.$name10, 0, 0);
        $d = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($d);
        jl_AbstractStringBuilder_append($d, 36);
        jl_StringBuilder_append($d, $name);
        return jl_AbstractStringBuilder_toString($d);
    }
    function onciap_Prettifier$_escapeNames($this, $names) {
        return ($names.$map1(new onciap_Prettifier$$escapeNames$lambda$_16_0)).$mkString($rt_s(16));
    }
    function onciap_Prettifier$_escapeNames0($this, $names, $d) {
        var var$3;
        var$3 = new onciap_Prettifier$$escapeNames$lambda$_17_0;
        var$3.$_080 = $d;
        return ($names.$map1(var$3)).$mkString($rt_s(16));
    }
    function onciap_Prettifier$_extractTopology($this, $topology) {
        var $primariesString, $maybeSecondariesString;
        $primariesString = s_Option_getOrElse(s_Option_flatMap($topology.$primaries, new onciap_Prettifier$$extractTopology$lambda$_18_0), new onciap_Prettifier$$extractTopology$lambda$_18_1);
        $maybeSecondariesString = s_Option_getOrElse(s_Option_flatMap($topology.$secondaries, new onciap_Prettifier$$extractTopology$lambda$_18_2), new onciap_Prettifier$$extractTopology$lambda$_18_3);
        $topology = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($topology);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($topology, $rt_s(332)), $primariesString), $maybeSecondariesString);
        return jl_AbstractStringBuilder_toString($topology);
    }
    function onciap_Prettifier$_stringify$1() {
        return new onciap_Prettifier$$anonfun$stringify$1$1;
    }
    function onciap_Prettifier$_propertyAndWherePrettifier$1($e, $variableNameString$1, $labels$1) {
        var var$4, var$5;
        var$4 = s_Option_getOrElse($variableNameString$1, new onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_0);
        var$5 = onciap_DefaultExpressionStringifier_stringify(onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, new onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_1, 0, 0, 0, 0), $e);
        $e = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($e);
        jl_AbstractStringBuilder_append($e, 40);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($e, var$4), $labels$1), $rt_s(333)), var$5);
        return jl_AbstractStringBuilder_toString($e);
    }
    function onciap_Prettifier$_extractPropertyRuleExpression$1($labelQualifiers, $variable, $expression) {
        var $labels, $variableNameString, var$6, $propertyKeyName, $value, $innerExpression;
        $labels = s_Option_getOrElse(s_Option_map(s_Option_filterNot(s_Some__init_(($labelQualifiers.$flatMap(new onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_0)).$mkString($rt_s(189))), new onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_1), new onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_2), new onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_3);
        $variableNameString = s_Option_map($variable, new onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_4);
        var$6 = 0;
        $labelQualifiers = null;
        if ($expression instanceof oncie_MapExpression) {
            $variable = $expression.$items0();
            if ($variable !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $variable);
                if (!$variable.$lengthCompare(1)) {
                    $variable = $variable.$apply1(0);
                    if ($variable !== null) {
                        $propertyKeyName = $variable.$_10;
                        $value = $variable.$_20;
                        $labelQualifiers = s_Option_getOrElse($variableNameString, new onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_0);
                        $variable = s_Option_getOrElse($variableNameString, new onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_1);
                        $expression = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $propertyKeyName.$name11, 0, 0);
                        $propertyKeyName = onciap_DefaultExpressionStringifier_stringify(onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, new onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_2, 0, 0, 0, 0), $value);
                        $variableNameString = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($variableNameString);
                        jl_AbstractStringBuilder_append($variableNameString, 40);
                        $labelQualifiers = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($variableNameString, $labelQualifiers), $labels), $rt_s(333)), $variable);
                        jl_AbstractStringBuilder_append($labelQualifiers, 46);
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($labelQualifiers, $expression), $rt_s(71)), $propertyKeyName);
                        return jl_StringBuilder_toString($variableNameString);
                    }
                }
            }
        }
        if ($expression instanceof oncie_Equals)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($expression instanceof oncie_NotEquals)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($expression instanceof oncie_IsNull)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($expression instanceof oncie_IsNotNull)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($expression instanceof oncie_In) {
            var$6 = 1;
            $labelQualifiers = $expression.$rhs0();
            if (!($labelQualifiers instanceof oncie_ListLiteral))
                $labelQualifiers = $expression;
            else {
                $labelQualifiers = $labelQualifiers.$expressions();
                if ($labelQualifiers === null)
                    $labelQualifiers = $expression;
                else {
                    s_package$_$callClinit();
                    $labelQualifiers = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $labelQualifiers);
                    if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $labelQualifiers)) {
                        sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $labelQualifiers);
                        if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $labelQualifiers, 1))
                            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
                    }
                    $labelQualifiers = $expression;
                }
            }
        }
        if (var$6 && $labelQualifiers.$rhs0() instanceof oncie_ExplicitParameter)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($labelQualifiers, $variableNameString, $labels);
        if (!($expression instanceof oncie_Not)) {
            $variable = new jl_IllegalStateException;
            $labelQualifiers = onciap_DefaultExpressionStringifier_apply(onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6__init_(), onciap_ExpressionStringifier$_apply$default$2(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$3(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$4(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$5(onciap_ExpressionStringifier$_MODULE$)),
            $expression);
            $expression = jl_StringBuilder__init_1();
            jl_StringBuilder_append(jl_StringBuilder_append($expression, $rt_s(334)), $labelQualifiers);
            jl_IllegalStateException__init_($variable, jl_StringBuilder_toString($expression));
            $rt_throw($variable);
        }
        $innerExpression = $expression.$rhs0();
        var$6 = 0;
        $labelQualifiers = null;
        if ($innerExpression instanceof oncie_Equals)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($innerExpression instanceof oncie_NotEquals)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($innerExpression instanceof oncie_IsNull)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($innerExpression instanceof oncie_IsNotNull)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
        if ($innerExpression instanceof oncie_In) {
            var$6 = 1;
            $labelQualifiers = $innerExpression.$rhs0();
            if (!($labelQualifiers instanceof oncie_ListLiteral))
                $labelQualifiers = $innerExpression;
            else {
                $labelQualifiers = $labelQualifiers.$expressions();
                if ($labelQualifiers === null)
                    $labelQualifiers = $innerExpression;
                else {
                    s_package$_$callClinit();
                    $labelQualifiers = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $labelQualifiers);
                    if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $labelQualifiers)) {
                        sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $labelQualifiers);
                        if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $labelQualifiers, 1))
                            return onciap_Prettifier$_propertyAndWherePrettifier$1($expression, $variableNameString, $labels);
                    }
                    $labelQualifiers = $innerExpression;
                }
            }
        }
        if (var$6 && $labelQualifiers.$rhs0() instanceof oncie_ExplicitParameter)
            return onciap_Prettifier$_propertyAndWherePrettifier$1($labelQualifiers, $variableNameString, $labels);
        $labelQualifiers = new jl_IllegalStateException;
        $variable = onciap_DefaultExpressionStringifier_apply(onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5__init_(), onciap_ExpressionStringifier$_apply$default$2(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$3(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$4(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$5(onciap_ExpressionStringifier$_MODULE$)),
        $expression);
        $expression = jl_StringBuilder__init_1();
        jl_StringBuilder_append(jl_StringBuilder_append($expression, $rt_s(334)), $variable);
        jl_IllegalStateException__init_($labelQualifiers, jl_StringBuilder_toString($expression));
        $rt_throw($labelQualifiers);
    }
    var sc_View = $rt_classWithoutFields(0);
    var sc_MapView = $rt_classWithoutFields(0);
    function sc_MapFactory$Delegate() {
        jl_Object.call(this);
        this.$delegate = null;
    }
    function sc_MapFactory$Delegate__init_(var_0) {
        var var_1 = new sc_MapFactory$Delegate();
        sc_MapFactory$Delegate__init_0(var_1, var_0);
        return var_1;
    }
    function sc_MapFactory$Delegate_empty($this) {
        return $this.$delegate.$empty();
    }
    function sc_MapFactory$Delegate__init_0($this, $delegate) {
        $this.$delegate = $delegate;
    }
    var scm_Map$ = $rt_classWithoutFields(sc_MapFactory$Delegate);
    var scm_Map$_MODULE$ = null;
    function scm_Map$_$callClinit() {
        scm_Map$_$callClinit = $rt_eraseClinit(scm_Map$);
        scm_Map$__clinit_();
    }
    function scm_Map$__clinit_() {
        var var$1;
        var$1 = new scm_Map$;
        scm_Map$_$callClinit();
        sc_MapFactory$Delegate__init_0(var$1, scm_HashMap$_MODULE$);
        scm_Map$_MODULE$ = var$1;
    }
    var scm_Iterable = $rt_classWithoutFields(0);
    var scm_Cloneable = $rt_classWithoutFields(0);
    var scm_Clearable = $rt_classWithoutFields(0);
    var scm_Growable = $rt_classWithoutFields(0);
    function scm_Growable_addAll$($$this, $xs) {
        a: {
            if ($xs === $$this) {
                scm_Buffer$_$callClinit();
                $$this.$addAll0(sc_SeqFactory$Delegate_from(scm_Buffer$_MODULE$, $xs));
            } else {
                $xs = $xs.$iterator0();
                while (true) {
                    if (!$xs.$hasNext())
                        break a;
                    $$this.$addOne($xs.$next());
                }
            }
        }
        return $$this;
    }
    var scm_Builder = $rt_classWithoutFields(0);
    function scm_Builder_sizeHint$($$this, $coll, $delta) {
        var var$4;
        var$4 = $coll.$knownSize();
        if (var$4 != (-1))
            $$this.$sizeHint(var$4 + $delta | 0);
    }
    function scm_Builder_mapResult$($$this, $f) {
        return scm_Builder$$anon$1__init_($$this, $f);
    }
    var scm_Shrinkable = $rt_classWithoutFields(0);
    function scm_Shrinkable_subtractAll$($$this, $xs) {
        var var$3;
        if ($xs === $$this) {
            if ($rt_isInstance($xs, scm_Clearable))
                $xs.$clear();
            else {
                scm_Buffer$_$callClinit();
                $$this.$subtractAll(sc_SeqFactory$Delegate_from(scm_Buffer$_MODULE$, $xs));
            }
        } else if (!$rt_isInstance($xs, sc_LinearSeq)) {
            $xs = $xs.$iterator0();
            var$3 = new scm_Shrinkable$subtractAll$lambda$_6_0;
            var$3.$_081 = $$this;
            $xs.$foreach(var$3);
        } else {
            $xs = $xs;
            while (sc_IterableOnceOps_nonEmpty$($xs)) {
                $$this.$subtractOne($xs.$head());
                $xs = $xs.$tail();
            }
        }
        return $$this;
    }
    var scm_MapOps = $rt_classWithoutFields(0);
    var scm_Map = $rt_classWithoutFields(0);
    function oncifp_PipeLine() {
        var a = this; jl_Object.call(a);
        a.$first = null;
        a.$after = null;
    }
    function oncifp_PipeLine_postConditions($this) {
        return ($this.$first.$postConditions0()).$concat1($this.$after.$postConditions0());
    }
    function oncifp_PipeLine_transform($this, $from, $context) {
        var $step1, $step2;
        $step1 = $this.$first.$transform($from, $context);
        $step2 = $this.$after.$transform($step1, $context);
        onciu_AssertionRunner_$callClinit();
        if (onciu_AssertionRunner_ASSERTIONS_ENABLED && !oncifp_Transformer_checkConditions$($this, $step2, $this.$first.$postConditions0()))
            $rt_throw(jl_AssertionError__init_($rt_s(75)));
        return $step2;
    }
    function oncifp_PipeLine_name($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$first.$name3();
        var$2 = $this.$after.$name3();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$1), $rt_s(16)), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    var onciap_Prettifier$QueryPrettifier = $rt_classWithoutFields(0);
    function onciap_Prettifier$IndentingQueryPrettifier() {
        var a = this; jl_Object.call(a);
        a.$indentLevel = 0;
        a.$INDENT = null;
        a.$$outer3 = null;
    }
    function onciap_Prettifier$IndentingQueryPrettifier__init_0(var_0, var_1) {
        var var_2 = new onciap_Prettifier$IndentingQueryPrettifier();
        onciap_Prettifier$IndentingQueryPrettifier__init_(var_2, var_0, var_1);
        return var_2;
    }
    function onciap_Prettifier$IndentingQueryPrettifier_indented($this) {
        var var$1;
        var$1 = $this.$indentLevel + 1 | 0;
        return onciap_Prettifier$IndentingQueryPrettifier__init_0($this.$$outer3, var$1);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asNewLine($this, $l) {
        var var$2, var$3;
        var$2 = $this.$$outer3.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$2), $l);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_query($this, $q) {
        var $clauses, $lhs, $rhs, $operation;
        if ($q instanceof oncia_SingleQuery) {
            $clauses = $q.$clauses;
            $q = new onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_0;
            $q.$_082 = $this;
            return sc_AbstractIterable_mkString0(($clauses.$map1($q)).$filter1(new onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_1), $this.$$outer3.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL);
        }
        if (!$rt_isInstance($q, oncia_Union))
            $rt_throw(s_MatchError__init_($q));
        $q = $q;
        $lhs = onciap_Prettifier$IndentingQueryPrettifier_query($this, $q.$lhs());
        $rhs = onciap_Prettifier$IndentingQueryPrettifier_query($this, $q.$rhs());
        if ($q instanceof oncia_UnionAll ? 1 : !($q instanceof oncia_ProjectingUnionAll) ? 0 : 1) {
            $clauses = $this.$INDENT;
            $q = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($q);
            jl_StringBuilder_append(jl_StringBuilder_append($q, $clauses), $rt_s(335));
            $operation = jl_AbstractStringBuilder_toString($q);
        } else {
            if (!($q instanceof oncia_UnionDistinct ? 1 : !($q instanceof oncia_ProjectingUnionDistinct) ? 0 : 1))
                $rt_throw(s_MatchError__init_($q));
            $clauses = $this.$INDENT;
            $q = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($q);
            jl_StringBuilder_append(jl_StringBuilder_append($q, $clauses), $rt_s(336));
            $operation = jl_AbstractStringBuilder_toString($q);
        }
        return sc_AbstractIterable_mkString0(sci_$colon$colon__init_($lhs, sci_$colon$colon__init_($operation, sci_$colon$colon__init_($rhs, sci_Nil$_MODULE$))), $this.$$outer3.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_dispatch($this, $clause) {
        var $ext, var$3, var$4, var$5, var$6, var$7, var$8;
        if ($clause instanceof oncia_UseGraph) {
            $clause = $clause;
            $ext = $this.$INDENT;
            var$3 = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $clause.$expression3);
            $clause = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($clause);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($clause, $ext), $rt_s(337)), var$3);
            return jl_AbstractStringBuilder_toString($clause);
        }
        if ($clause instanceof oncia_Return) {
            $clause = $clause;
            if ($clause.$addedInRewrite)
                $clause = $rt_s(3);
            else {
                $ext = !$clause.$distinct ? $rt_s(3) : $rt_s(338);
                var$4 = onciap_Prettifier$IndentingQueryPrettifier_asString1($this, $clause.$returnItems1);
                var$3 = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
                var$5 = $clause.$orderBy0;
                var$6 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_0;
                var$6.$_083 = var$3;
                var$6 = s_Option_map(var$5, var$6);
                var$5 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_1;
                var$5.$_084 = $this;
                var$6 = s_Option_getOrElse(s_Option_map(var$6, var$5), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_2);
                var$5 = $clause.$limit0;
                var$7 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_3;
                var$7.$_085 = var$3;
                var$5 = s_Option_map(var$5, var$7);
                var$7 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_4;
                var$7.$_086 = $this;
                var$7 = s_Option_getOrElse(s_Option_map(var$5, var$7), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_5);
                $clause = $clause.$skip0;
                var$5 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_6;
                var$5.$_087 = var$3;
                $clause = s_Option_map($clause, var$5);
                var$3 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_7;
                var$3.$_088 = $this;
                var$8 = s_Option_getOrElse(s_Option_map($clause, var$3), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_8);
                var$3 = $this.$INDENT;
                $clause = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($clause);
                $ext = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($clause, var$3), $rt_s(339)), $ext);
                jl_AbstractStringBuilder_append($ext, 32);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ext, var$4), var$6), var$8), var$7);
                $clause = jl_AbstractStringBuilder_toString($clause);
            }
            return $clause;
        }
        if (!($clause instanceof oncia_Match)) {
            if ($clause instanceof oncia_SubqueryCall)
                return onciap_Prettifier$IndentingQueryPrettifier_asString2($this, $clause);
            if ($clause instanceof oncia_With)
                return onciap_Prettifier$IndentingQueryPrettifier_asString3($this, $clause);
            if ($clause instanceof oncia_Yield)
                return onciap_Prettifier$IndentingQueryPrettifier_asString($this, $clause);
            if ($clause instanceof oncia_Create)
                return onciap_Prettifier$IndentingQueryPrettifier_asString4($this, $clause);
            if ($clause instanceof oncia_Unwind)
                return onciap_Prettifier$IndentingQueryPrettifier_asString5($this, $clause);
            if ($clause instanceof oncia_UnresolvedCall)
                return onciap_Prettifier$IndentingQueryPrettifier_asString6($this, $clause);
            if ($clause instanceof oncia_ShowIndexesClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString7($this, $clause);
            if ($clause instanceof oncia_ShowConstraintsClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString8($this, $clause);
            if ($clause instanceof oncia_ShowProceduresClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString9($this, $clause);
            if ($clause instanceof oncia_ShowFunctionsClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString10($this, $clause);
            if ($clause instanceof oncia_ShowTransactionsClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString11($this, $clause);
            if ($clause instanceof oncia_TerminateTransactionsClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString12($this, $clause);
            if ($clause instanceof oncia_ShowSettingsClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString13($this, $clause);
            if ($clause instanceof oncia_SetClause)
                return onciap_Prettifier$IndentingQueryPrettifier_asString14($this, $clause);
            if ($clause instanceof oncia_Remove)
                return onciap_Prettifier$IndentingQueryPrettifier_asString15($this, $clause);
            if ($clause instanceof oncia_Delete)
                return onciap_Prettifier$IndentingQueryPrettifier_asString16($this, $clause);
            if ($clause instanceof oncia_Merge)
                return onciap_Prettifier$IndentingQueryPrettifier_asString17($this, $clause);
            if ($clause instanceof oncia_LoadCSV)
                return onciap_Prettifier$IndentingQueryPrettifier_asString18($this, $clause);
            if ($clause instanceof oncia_Foreach)
                return onciap_Prettifier$IndentingQueryPrettifier_asString19($this, $clause);
            return s_PartialFunction$$anon$1_applyOrElse(onciap_Prettifier$EmptyExtension$_asString(onciap_Prettifier_extension(onciap_Prettifier$IndentingQueryPrettifier_org$neo4j$cypher$internal$ast$prettifier$Prettifier$IndentingQueryPrettifier$$$outer($this)), $this), $clause, onciap_Prettifier$IndentingQueryPrettifier$dispatch$lambda$_8_0__init_($this));
        }
        $clause = $clause;
        $ext = !$clause.$optional ? $rt_s(3) : $rt_s(340);
        var$4 = $clause.$matchMode.$prettified();
        var$3 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        if (sc_StringOps$_nonEmpty$extension(var$3, var$4)) {
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$3, var$4), 32);
            var$4 = jl_AbstractStringBuilder_toString(var$3);
        }
        var$3 = onciap_DefaultPatternStringifier_apply1($this.$$outer3.$expr2.$patterns, $clause.$pattern2);
        var$6 = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        var$7 = $clause.$where1;
        var$5 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_0;
        var$5.$_089 = var$6;
        var$5 = s_Option_map(var$7, var$5);
        var$7 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_1;
        var$7.$_090 = $this;
        var$5 = s_Option_getOrElse(s_Option_map(var$5, var$7), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_2);
        var$7 = $clause.$hints;
        $clause = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_3;
        $clause.$_091 = var$6;
        $clause = sc_AbstractIterable_mkString1((var$7.$map1($clause)).$map1(onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4__init_($this)));
        var$7 = $this.$INDENT;
        var$6 = jl_StringBuilder__init_1();
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, var$7), $ext), $rt_s(341)), var$4), var$3), $clause), var$5);
        return jl_StringBuilder_toString(var$6);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString2($this, $c) {
        var var$2, $inTxParams, var$4, var$5, var$6;
        var$2 = $c.$inTransactionsParameters;
        $inTxParams = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_0;
        $inTxParams.$_092 = $this;
        $inTxParams = s_Option_getOrElse(s_Option_map(var$2, $inTxParams), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_1);
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        var$4 = $this.$INDENT;
        $c = onciap_Prettifier$IndentingQueryPrettifier_query(onciap_Prettifier$IndentingQueryPrettifier_indented($this), $c.$innerQuery);
        var$5 = $this.$INDENT;
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        $c = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, var$4), $rt_s(342)), $c), $rt_s(343)), var$5);
        jl_AbstractStringBuilder_append($c, 125);
        jl_StringBuilder_append($c, $inTxParams);
        return sc_StringOps$_stripMargin$extension(var$2, jl_AbstractStringBuilder_toString(var$6));
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString20($this, $ip) {
        var $size, $ofRows, $onError, var$5, $reportStatus, $statusVar;
        $size = s_Option_map($ip.$batchParams, new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_0);
        if (!($size instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, $size))
                $rt_throw(s_MatchError__init_($size));
            $ofRows = $rt_s(3);
        } else {
            $size = $size.$value5;
            $onError = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $size);
            $size = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($size);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($size, $rt_s(344)), $onError), $rt_s(345));
            $ofRows = jl_AbstractStringBuilder_toString($size);
        }
        a: {
            var$5 = 0;
            $size = null;
            $onError = s_Option_map($ip.$errorParams, new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_1);
            if ($onError instanceof s_Some) {
                var$5 = 1;
                $size = $onError;
                $reportStatus = $size.$value5;
                if (jl_Object_equals(oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_MODULE$, $reportStatus)) {
                    $onError = $rt_s(346);
                    break a;
                }
            }
            if (var$5) {
                $reportStatus = $size.$value5;
                if (jl_Object_equals(oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_MODULE$, $reportStatus)) {
                    $onError = $rt_s(347);
                    break a;
                }
            }
            if (var$5) {
                $size = $size.$value5;
                if (jl_Object_equals(oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_MODULE$, $size)) {
                    $onError = $rt_s(348);
                    break a;
                }
            }
            if (!jl_Object_equals(s_None$_MODULE$, $onError))
                $rt_throw(s_MatchError__init_($onError));
            $onError = $rt_s(3);
        }
        $ip = s_Option_map($ip.$reportParams, new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_2);
        if (!($ip instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, $ip))
                $rt_throw(s_MatchError__init_($ip));
            $reportStatus = $rt_s(3);
        } else {
            $statusVar = $ip.$value5;
            $ip = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $statusVar.$name4, 0, 0);
            $size = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($size);
            jl_StringBuilder_append(jl_StringBuilder_append($size, $rt_s(349)), $ip);
            $reportStatus = jl_AbstractStringBuilder_toString($size);
        }
        $ip = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($ip);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ip, $rt_s(350)), $ofRows), $onError), $reportStatus);
        return jl_AbstractStringBuilder_toString($ip);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString0($this, $w) {
        var var$2, var$3;
        var$2 = $this.$INDENT;
        var$3 = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $w.$expression4);
        $w = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($w);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($w, var$2), $rt_s(351)), var$3);
        return jl_AbstractStringBuilder_toString($w);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString21($this, $m) {
        var $vs, $t, $s, $v, $l, $v_0, $l_0, $ps, var$10, var$11, var$12, var$13, var$14, var$15;
        if (!($m instanceof oncia_UsingIndexHint)) {
            if (!($m instanceof oncia_UsingScanHint)) {
                if (!($m instanceof oncia_UsingJoinHint))
                    $rt_throw(s_MatchError__init_($m));
                $vs = $m.$variables;
                $t = new sci_$colon$colon;
                $s = $this.$INDENT;
                $m = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($m);
                jl_StringBuilder_append(jl_StringBuilder_append($m, $s), $rt_s(352));
                $v = jl_AbstractStringBuilder_toString($m);
                $m = new sci_$colon$colon;
                $s = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_1;
                $s.$_093 = $this;
                sci_$colon$colon__init_0($m, sc_AbstractIterable_mkString0(($vs.$map5($s)).$toIterable(), $rt_s(16)), sci_Nil$_MODULE$);
                sci_$colon$colon__init_0($t, $v, $m);
                return sc_AbstractIterable_mkString1($t);
            }
            $m = $m;
            $v = $m.$variable5;
            $l = $m.$labelOrRelType;
            $s = new sci_$colon$colon;
            $t = $this.$INDENT;
            $m = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($m);
            jl_StringBuilder_append(jl_StringBuilder_append($m, $t), $rt_s(353));
            sci_$colon$colon__init_0($s, jl_AbstractStringBuilder_toString($m), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $v), sci_$colon$colon__init_($rt_s(136), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_apply0($this.$$outer3.$expr2, $l), sci_Nil$_MODULE$))));
            return sc_AbstractIterable_mkString1($s);
        }
        $m = $m;
        $v_0 = $m.$variable6;
        $l_0 = $m.$labelOrRelType0;
        $ps = $m.$properties3;
        $s = $m.$spec;
        $t = $m.$indexType;
        $v = new sci_$colon$colon;
        $vs = $this.$INDENT;
        $m = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($m);
        jl_StringBuilder_append(jl_StringBuilder_append($m, $vs), $rt_s(354));
        var$10 = jl_AbstractStringBuilder_toString($m);
        $vs = new sci_$colon$colon;
        if (jl_Object_equals(oncia_UsingAnyIndexType$_MODULE$, $t))
            $l = $rt_s(355);
        else if (jl_Object_equals(oncia_UsingTextIndexType$_MODULE$, $t))
            $l = $rt_s(356);
        else if (jl_Object_equals(oncia_UsingRangeIndexType$_MODULE$, $t))
            $l = $rt_s(357);
        else {
            if (!jl_Object_equals(oncia_UsingPointIndexType$_MODULE$, $t))
                $rt_throw(s_MatchError__init_($t));
            $l = $rt_s(358);
        }
        a: {
            b: {
                c: {
                    var$11 = new sci_$colon$colon;
                    $m = oncia_SeekOnly$_MODULE$;
                    if ($s !== null) {
                        if (!jl_Object_equals($s, $m))
                            break b;
                        else
                            break c;
                    }
                    if ($m !== null)
                        break b;
                }
                var$12 = $rt_s(359);
                break a;
            }
            var$12 = $rt_s(3);
        }
        var$13 = new sci_$colon$colon;
        var$14 = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $v_0);
        $v_0 = new sci_$colon$colon;
        $t = new sci_$colon$colon;
        $l_0 = onciap_DefaultExpressionStringifier_apply0($this.$$outer3.$expr2, $l_0);
        var$15 = new sci_$colon$colon;
        $s = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_0;
        $s.$_094 = $this;
        sci_$colon$colon__init_0(var$15, sc_IterableOnceOps_mkString$($ps.$map1($s), $rt_s(24), $rt_s(43), $rt_s(25)), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0($t, $l_0, var$15);
        sci_$colon$colon__init_0($v_0, $rt_s(136), $t);
        sci_$colon$colon__init_0(var$13, var$14, $v_0);
        sci_$colon$colon__init_0(var$11, var$12, var$13);
        sci_$colon$colon__init_0($vs, $l, var$11);
        sci_$colon$colon__init_0($v, var$10, $vs);
        return sc_AbstractIterable_mkString1($v);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString17($this, $m) {
        var $p, $ind, $a;
        $p = onciap_DefaultPatternStringifier_apply0($this.$$outer3.$expr2.$patterns, $m.$pattern3);
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        $a = $m.$actions;
        $m = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_0;
        $m.$_095 = $ind;
        $m = $a.$map1($m);
        $ind = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_1;
        $ind.$_096 = $this;
        $a = sc_AbstractIterable_mkString1($m.$map1($ind));
        $ind = $this.$INDENT;
        $m = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($m);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($m, $ind), $rt_s(360)), $p), $a);
        return jl_AbstractStringBuilder_toString($m);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString22($this, $o) {
        var var$2, var$3;
        var$2 = $this.$INDENT;
        var$3 = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $o.$expression5);
        $o = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($o);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($o, var$2), $rt_s(361)), var$3);
        return jl_AbstractStringBuilder_toString($o);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString23($this, $o) {
        var var$2, var$3;
        var$2 = $this.$INDENT;
        var$3 = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $o.$expression6);
        $o = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($o);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($o, var$2), $rt_s(362)), var$3);
        return jl_AbstractStringBuilder_toString($o);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString24($this, $o) {
        var var$2, var$3;
        var$2 = $this.$INDENT;
        var$3 = $o.$sortItems;
        $o = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_20_0;
        $o.$_097 = $this;
        $o = sc_AbstractIterable_mkString0(var$3.$map1($o), $rt_s(16));
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$2), $rt_s(363)), $o);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString1($this, $r) {
        var $as, $is;
        $as = !$r.$includeExisting ? sci_Nil$_MODULE$ : sci_$colon$colon__init_($rt_s(305), sci_Nil$_MODULE$);
        $is = $r.$items;
        $r = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_22_0;
        $r.$_098 = $this;
        return sc_AbstractIterable_mkString0($as.$concat0($is.$map1($r)), $rt_s(16));
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString3($this, $w) {
        var $ind, $rewrittenClauses, $i, $d, var$6, var$7, var$8, var$9, var$10, var$11;
        a: {
            b: {
                c: {
                    $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
                    $rewrittenClauses = new sci_$colon$colon;
                    $i = $w.$orderBy1;
                    $d = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_0;
                    $d.$_099 = $ind;
                    $d = s_Option_map($i, $d);
                    $i = new sci_$colon$colon;
                    var$6 = $w.$skip1;
                    var$7 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_1;
                    var$7.$_0100 = $ind;
                    var$8 = s_Option_map(var$6, var$7);
                    var$9 = new sci_$colon$colon;
                    var$6 = $w.$limit1;
                    var$7 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_2;
                    var$7.$_0101 = $ind;
                    var$10 = s_Option_map(var$6, var$7);
                    var$11 = new sci_$colon$colon;
                    var$6 = $w.$where2;
                    var$7 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_3;
                    var$7.$_0102 = $ind;
                    sci_$colon$colon__init_0(var$11, s_Option_map(var$6, var$7), sci_Nil$_MODULE$);
                    sci_$colon$colon__init_0(var$9, var$10, var$11);
                    sci_$colon$colon__init_0($i, var$8, var$9);
                    sci_$colon$colon__init_0($rewrittenClauses, $d, $i);
                    s_Predef$_$callClinit();
                    $rewrittenClauses = sc_StrictOptimizedIterableOps_flatten$($rewrittenClauses, s_Predef$_$conforms(s_Predef$_MODULE$));
                    $d = $w.$withType;
                    $ind = oncia_ParsedAsYield$_MODULE$;
                    if ($d !== null) {
                        if (jl_Object_equals($d, $ind))
                            break b;
                        else
                            break c;
                    }
                    if ($ind === null)
                        break b;
                }
                $d = $w.$withType;
                $ind = oncia_AddedInRewrite$_MODULE$;
                if ($d !== null) {
                    if (!jl_Object_equals($d, $ind))
                        break a;
                    else
                        break b;
                }
                if ($ind !== null)
                    break a;
            }
            if (!sc_IterableOnceOps_nonEmpty$($rewrittenClauses))
                return $rt_s(3);
            $ind = $this.$INDENT;
            $w = $rewrittenClauses.$head();
            $rewrittenClauses = $rewrittenClauses.$tail();
            $d = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_5;
            $d.$_0103 = $this;
            $rewrittenClauses = sc_AbstractIterable_mkString1(sci_List_map($rewrittenClauses, $d));
            $d = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($d);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($d, $ind), $w), $rewrittenClauses);
            return jl_AbstractStringBuilder_toString($d);
        }
        $d = !$w.$distinct2 ? $rt_s(3) : $rt_s(338);
        $i = onciap_Prettifier$IndentingQueryPrettifier_asString1($this, $w.$returnItems2);
        $ind = $this.$INDENT;
        $w = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_4;
        $w.$_0104 = $this;
        $w = sc_AbstractIterable_mkString1(sci_List_map($rewrittenClauses, $w));
        $rewrittenClauses = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($rewrittenClauses);
        $ind = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($rewrittenClauses, $ind), $rt_s(364)), $d);
        jl_AbstractStringBuilder_append($ind, 32);
        jl_StringBuilder_append(jl_StringBuilder_append($ind, $i), $w);
        return jl_AbstractStringBuilder_toString($rewrittenClauses);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString($this, $y) {
        var $i, $ind, $s, $o, $l, $wh;
        $i = onciap_Prettifier$IndentingQueryPrettifier_asString1($this, $y.$returnItems);
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        $s = $y.$orderBy;
        $o = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_0;
        $o.$_0105 = $ind;
        $o = s_Option_map($s, $o);
        $s = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_1;
        $s.$_0106 = $this;
        $o = s_Option_getOrElse(s_Option_map($o, $s), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_2);
        $s = $y.$limit;
        $l = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_3;
        $l.$_0107 = $ind;
        $s = s_Option_map($s, $l);
        $l = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_4;
        $l.$_0108 = $this;
        $l = s_Option_getOrElse(s_Option_map($s, $l), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_5);
        $s = $y.$skip;
        $wh = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_6;
        $wh.$_0109 = $ind;
        $s = s_Option_map($s, $wh);
        $wh = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_7;
        $wh.$_0110 = $this;
        $s = s_Option_getOrElse(s_Option_map($s, $wh), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_8);
        $y = $y.$where;
        $wh = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_9;
        $wh.$_0111 = $ind;
        $y = s_Option_map($y, $wh);
        $wh = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_10;
        $wh.$_0112 = $this;
        $wh = s_Option_getOrElse(s_Option_map($y, $wh), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_11);
        $y = $this.$INDENT;
        $ind = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($ind);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ind, $y), $rt_s(365)), $i), $o), $s), $l), $wh);
        return jl_AbstractStringBuilder_toString($ind);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString4($this, $c) {
        var $p, var$3;
        $p = onciap_DefaultPatternStringifier_apply1($this.$$outer3.$expr2.$patterns, $c.$pattern);
        var$3 = $this.$INDENT;
        $c = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($c);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($c, var$3), $rt_s(295)), $p);
        return jl_AbstractStringBuilder_toString($c);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString5($this, $u) {
        var var$2, var$3, var$4;
        var$2 = $this.$INDENT;
        var$3 = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $u.$expression7);
        var$4 = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $u.$variable7);
        $u = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($u);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($u, var$2), $rt_s(366)), var$3), $rt_s(367)), var$4);
        return jl_AbstractStringBuilder_toString($u);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString6($this, $u) {
        var $namespace, $prefix, $args, $arguments, $ind, $yields;
        $namespace = onciap_DefaultExpressionStringifier_apply1($this.$$outer3.$expr2, $u.$procedureNamespace);
        if (jl_String_isEmpty($namespace))
            $prefix = $rt_s(3);
        else {
            $prefix = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($prefix);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append($prefix, $namespace), 46);
            $prefix = jl_AbstractStringBuilder_toString($prefix);
        }
        $args = s_Option_map($u.$declaredArguments, new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_0);
        $namespace = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_1;
        $namespace.$_0113 = $this;
        $arguments = s_Option_getOrElse(s_Option_map($args, $namespace), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_2);
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        if ($u.$yieldAll) {
            $namespace = (onciap_Prettifier$IndentingQueryPrettifier_indented($this)).$INDENT;
            $ind = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($ind);
            jl_StringBuilder_append(jl_StringBuilder_append($ind, $namespace), $rt_s(368));
            $yields = onciap_Prettifier$IndentingQueryPrettifier_asNewLine($this, jl_AbstractStringBuilder_toString($ind));
        } else {
            $namespace = s_Option_filter($u.$declaredResult, new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_3);
            $yields = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_4;
            $yields.$_0114 = $ind;
            $namespace = s_Option_map($namespace, $yields);
            $ind = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_5;
            $ind.$_0115 = $this;
            $yields = s_Option_getOrElse(s_Option_map($namespace, $ind), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_6);
        }
        $ind = $this.$INDENT;
        $u = onciap_DefaultExpressionStringifier_apply0($this.$$outer3.$expr2, $u.$procedureName);
        $namespace = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($namespace);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($namespace, $ind), $rt_s(369)), $prefix), $u), $arguments), $yields);
        return jl_AbstractStringBuilder_toString($namespace);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString7($this, $s) {
        var $indexType, $ind, $where;
        $indexType = $s.$indexType0.$prettyPrint();
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        $where = $s.$where3;
        $s = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_0;
        $s.$_0116 = $ind;
        $s = s_Option_map($where, $s);
        $ind = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_1;
        $ind.$_0117 = $this;
        $where = s_Option_getOrElse(s_Option_map($s, $ind), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_2);
        $s = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($s);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($s, $rt_s(265)), $indexType), $rt_s(370)), $where);
        return jl_AbstractStringBuilder_toString($s);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString8($this, $s) {
        var $ind, var$3, $where;
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        var$3 = $s.$where4;
        $where = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_0;
        $where.$_0118 = $ind;
        $ind = s_Option_map(var$3, $where);
        $where = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_1;
        $where.$_0119 = $this;
        $where = s_Option_getOrElse(s_Option_map($ind, $where), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_2);
        $s = $s.$constraintType.$prettyPrint();
        $ind = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($ind);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ind, $rt_s(265)), $s), $rt_s(371)), $where);
        return jl_AbstractStringBuilder_toString($ind);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString9($this, $s) {
        var $executable, $ind, $where;
        $executable = onciap_Prettifier$IndentingQueryPrettifier_getExecutablePart($this, $s.$executable);
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        $where = $s.$where5;
        $s = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_0;
        $s.$_0120 = $ind;
        $s = s_Option_map($where, $s);
        $ind = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_1;
        $ind.$_0121 = $this;
        $where = s_Option_getOrElse(s_Option_map($s, $ind), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_2);
        $s = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($s);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($s, $rt_s(372)), $executable), $where);
        return jl_AbstractStringBuilder_toString($s);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString10($this, $s) {
        var $functionType, $executable, $ind, $where;
        $functionType = $s.$functionType.$prettyPrint();
        $executable = onciap_Prettifier$IndentingQueryPrettifier_getExecutablePart($this, $s.$executable0);
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        $where = $s.$where6;
        $s = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_0;
        $s.$_0122 = $ind;
        $s = s_Option_map($where, $s);
        $ind = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_1;
        $ind.$_0123 = $this;
        $where = s_Option_getOrElse(s_Option_map($s, $ind), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_2);
        $s = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($s);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($s, $rt_s(265)), $functionType), $rt_s(373)), $executable), $where);
        return jl_AbstractStringBuilder_toString($s);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_getExecutablePart($this, $executable) {
        var var$2, $name, var$4;
        var$2 = 0;
        $name = null;
        if ($executable instanceof s_Some) {
            var$2 = 1;
            $name = $executable;
            var$4 = $name.$value5;
            if (jl_Object_equals(oncia_CurrentUser$_MODULE$, var$4))
                return $rt_s(374);
        }
        if (var$2) {
            $name = $name.$value5;
            if ($name instanceof oncia_User) {
                $name = $name.$name12;
                $executable = onciap_ExpressionStringifier$_backtick(onciap_ExpressionStringifier$_MODULE$, $name, 0, 0);
                $name = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($name);
                jl_StringBuilder_append(jl_StringBuilder_append($name, $rt_s(375)), $executable);
                return jl_AbstractStringBuilder_toString($name);
            }
        }
        if (jl_Object_equals(s_None$_MODULE$, $executable))
            return $rt_s(3);
        $rt_throw(s_MatchError__init_($executable));
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString11($this, $s) {
        var $ids, $ind, $yielded, $where;
        $ids = onciap_Prettifier$IndentingQueryPrettifier_namesAsString($this, $s.$ids);
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        $yielded = $s.$where7;
        $where = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_0;
        $where.$_0124 = $ind;
        $ind = s_Option_map($yielded, $where);
        $where = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_1;
        $where.$_0125 = $this;
        $where = s_Option_getOrElse(s_Option_map($ind, $where), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_2);
        $yielded = onciap_Prettifier$IndentingQueryPrettifier_partialYieldAsString($this, $s.$yieldItems, $s.$yieldAll0);
        $s = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($s);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($s, $rt_s(376)), $ids), $where), $yielded);
        return jl_AbstractStringBuilder_toString($s);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString12($this, $s) {
        var $ids, $yielded;
        $ids = onciap_Prettifier$IndentingQueryPrettifier_namesAsString($this, $s.$ids0);
        $yielded = onciap_Prettifier$IndentingQueryPrettifier_partialYieldAsString($this, $s.$yieldItems0, $s.$yieldAll1);
        $s = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($s);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($s, $rt_s(377)), $ids), $yielded);
        return jl_AbstractStringBuilder_toString($s);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_namesAsString($this, $ids) {
        var $s, $e;
        if ($ids instanceof su_Left) {
            $s = $ids.$value11;
            if (!sc_IterableOnceOps_nonEmpty$($s))
                return $rt_s(3);
            $ids = new onciap_Prettifier$IndentingQueryPrettifier$namesAsString$lambda$_37_0;
            $ids.$_0126 = $this;
            return sc_IterableOnceOps_mkString$(sci_List_map($s, $ids), $rt_s(162), $rt_s(16), $rt_s(3));
        }
        if (!($ids instanceof su_Right))
            $rt_throw(s_MatchError__init_($ids));
        $e = $ids.$value10;
        $e = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $e);
        $ids = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($ids);
        jl_AbstractStringBuilder_append($ids, 32);
        jl_StringBuilder_append($ids, $e);
        return jl_AbstractStringBuilder_toString($ids);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_partialYieldAsString($this, $yieldItems, $yieldAll) {
        var $items, var$4;
        if (!sc_IterableOnceOps_nonEmpty$($yieldItems)) {
            if (!$yieldAll)
                return $rt_s(3);
            $items = $this.$INDENT;
            $yieldItems = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($yieldItems);
            jl_StringBuilder_append(jl_StringBuilder_append($yieldItems, $items), $rt_s(368));
            return onciap_Prettifier$IndentingQueryPrettifier_asNewLine($this, jl_AbstractStringBuilder_toString($yieldItems));
        }
        $items = new onciap_Prettifier$IndentingQueryPrettifier$partialYieldAsString$lambda$_38_0;
        $items.$_0127 = $this;
        $items = sc_AbstractIterable_mkString0(sci_List_map($yieldItems, $items), $rt_s(16));
        var$4 = $this.$INDENT;
        $yieldItems = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($yieldItems);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($yieldItems, var$4), $rt_s(365)), $items);
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine($this, jl_AbstractStringBuilder_toString($yieldItems));
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString13($this, $s) {
        var $names, $ind, $where;
        $names = onciap_Prettifier$IndentingQueryPrettifier_namesAsString($this, $s.$names);
        $ind = onciap_Prettifier$IndentingQueryPrettifier_indented($this);
        $where = $s.$where8;
        $s = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_0;
        $s.$_0128 = $ind;
        $s = s_Option_map($where, $s);
        $ind = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_1;
        $ind.$_0129 = $this;
        $where = s_Option_getOrElse(s_Option_map($s, $ind), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_2);
        $s = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($s);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($s, $rt_s(378)), $names), $where);
        return jl_AbstractStringBuilder_toString($s);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString14($this, $s) {
        var var$2, $items;
        var$2 = $s.$items1;
        $items = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_40_0;
        $items.$_0130 = $this;
        $items.$_122 = $s;
        $items = var$2.$map1($items);
        var$2 = $this.$INDENT;
        $s = sc_AbstractIterable_mkString0($items, $rt_s(16));
        $items = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($items);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($items, var$2), $rt_s(70)), $s);
        return jl_AbstractStringBuilder_toString($items);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString15($this, $r) {
        var var$2, $items;
        var$2 = $r.$items2;
        $items = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_41_0;
        $items.$_0131 = $this;
        $items.$_123 = $r;
        $items = var$2.$map1($items);
        var$2 = $this.$INDENT;
        $r = sc_AbstractIterable_mkString0($items, $rt_s(16));
        $items = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($items);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($items, var$2), $rt_s(379)), $r);
        return jl_AbstractStringBuilder_toString($items);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString18($this, $v) {
        var $withHeaders, $url, $varName, $fieldTerminator, var$6;
        $withHeaders = !$v.$withHeaders ? $rt_s(3) : $rt_s(380);
        $url = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $v.$urlString);
        $varName = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $v.$variable8);
        $fieldTerminator = $v.$fieldTerminator;
        $v = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_0;
        $v.$_0132 = $this;
        $fieldTerminator = s_Option_getOrElse(s_Option_map($fieldTerminator, $v), new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_1);
        var$6 = $this.$INDENT;
        $v = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($v);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($v, var$6), $rt_s(381)), $withHeaders), $rt_s(254)), $url), $rt_s(367)), $varName), $fieldTerminator);
        return jl_AbstractStringBuilder_toString($v);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString16($this, $delete) {
        var $detach, var$3, var$4;
        $detach = !$delete.$forced ? $rt_s(3) : $rt_s(382);
        var$3 = $this.$INDENT;
        var$4 = $delete.$expressions0;
        $delete = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_43_0;
        $delete.$_0133 = $this;
        $delete = sc_AbstractIterable_mkString0(var$4.$map1($delete), $rt_s(16));
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, var$3), $detach), $rt_s(383)), $delete);
        return jl_AbstractStringBuilder_toString(var$4);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_asString19($this, $foreach) {
        var $varName, $list, $updates, var$5, var$6;
        $varName = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $foreach.$variable9);
        $list = onciap_DefaultExpressionStringifier_stringify($this.$$outer3.$expr2, $foreach.$expression8);
        $updates = $foreach.$updates;
        $foreach = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_44_0;
        $foreach.$_0134 = $this;
        $foreach = $updates.$map1($foreach);
        var$5 = $this.$$outer3.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL;
        $updates = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($updates);
        jl_StringBuilder_append(jl_StringBuilder_append($updates, var$5), $rt_s(384));
        var$6 = jl_AbstractStringBuilder_toString($updates);
        var$5 = $this.$$outer3.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL;
        $updates = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($updates);
        jl_StringBuilder_append(jl_StringBuilder_append($updates, var$5), $rt_s(384));
        $updates = sc_IterableOnceOps_mkString$($foreach, var$6, jl_AbstractStringBuilder_toString($updates), $this.$$outer3.$org$neo4j$cypher$internal$ast$prettifier$Prettifier$$NL);
        var$5 = $this.$INDENT;
        $foreach = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($foreach);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($foreach, var$5), $rt_s(385)), $varName), $rt_s(154)), $list), $rt_s(386)), $updates), 41);
        return jl_AbstractStringBuilder_toString($foreach);
    }
    function onciap_Prettifier$IndentingQueryPrettifier_org$neo4j$cypher$internal$ast$prettifier$Prettifier$IndentingQueryPrettifier$$$outer($this) {
        return $this.$$outer3;
    }
    function onciap_Prettifier$IndentingQueryPrettifier__init_($this, $$outer, $indentLevel) {
        var var$3, var$4;
        $this.$indentLevel = $indentLevel;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer3 = $$outer;
        s_Predef$_$callClinit();
        if ($indentLevel <= 0)
            $$outer = $rt_s(3);
        else {
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$3, $rt_imul(jl_String_length($rt_s(384)), $indentLevel));
            var$4 = 0;
            while (var$4 < $indentLevel) {
                jl_AbstractStringBuilder_append1(var$3, $rt_s(384));
                var$4 = var$4 + 1 | 0;
            }
            $$outer = jl_AbstractStringBuilder_toString(var$3);
        }
        $this.$INDENT = $$outer;
    }
    function sc_ClassTagIterableFactory$AnyIterableDelegate() {
        jl_Object.call(this);
        this.$delegate0 = null;
    }
    function sc_ClassTagIterableFactory$AnyIterableDelegate_empty($this) {
        var var$1;
        var$1 = $this.$delegate0;
        sr_ClassTag$_$callClinit();
        return var$1.$empty4(sr_ClassTag$_Any(sr_ClassTag$_MODULE$));
    }
    function sc_ClassTagIterableFactory$AnyIterableDelegate_from($this, $it) {
        var var$2;
        var$2 = $this.$delegate0;
        sr_ClassTag$_$callClinit();
        return var$2.$from6($it, sr_ClassTag$_Any(sr_ClassTag$_MODULE$));
    }
    function sc_ClassTagIterableFactory$AnyIterableDelegate_newBuilder($this) {
        var var$1;
        var$1 = $this.$delegate0;
        sr_ClassTag$_$callClinit();
        return var$1.$newBuilder0(sr_ClassTag$_Any(sr_ClassTag$_MODULE$));
    }
    var sc_SeqFactory = $rt_classWithoutFields(0);
    var sc_ClassTagSeqFactory$AnySeqDelegate = $rt_classWithoutFields(sc_ClassTagIterableFactory$AnyIterableDelegate);
    function sc_ClassTagSeqFactory$AnySeqDelegate__init_(var_0) {
        var var_1 = new sc_ClassTagSeqFactory$AnySeqDelegate();
        sc_ClassTagSeqFactory$AnySeqDelegate__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ClassTagSeqFactory$AnySeqDelegate__init_0($this, $delegate) {
        $this.$delegate0 = $delegate;
    }
    function jl_Boolean() {
        jl_Object.call(this);
        this.$value8 = 0;
    }
    var jl_Boolean_TRUE = null;
    var jl_Boolean_FALSE = null;
    var jl_Boolean_TYPE = null;
    function jl_Boolean__init_(var_0) {
        var var_1 = new jl_Boolean();
        jl_Boolean__init_0(var_1, var_0);
        return var_1;
    }
    function jl_Boolean__init_0($this, $value) {
        $this.$value8 = $value;
    }
    function jl_Boolean_valueOf($value) {
        return !$value ? jl_Boolean_FALSE : jl_Boolean_TRUE;
    }
    function jl_Boolean_toString($value) {
        return !$value ? $rt_s(387) : $rt_s(197);
    }
    function jl_Boolean_toString0($this) {
        return jl_Boolean_toString($this.$value8);
    }
    function jl_Boolean_hashCode($this) {
        return !$this.$value8 ? 1237 : 1231;
    }
    function jl_Boolean_equals($this, $obj) {
        if ($this === $obj)
            return 1;
        return $obj instanceof jl_Boolean && $obj.$value8 == $this.$value8 ? 1 : 0;
    }
    function jl_Boolean__clinit_() {
        jl_Boolean_TRUE = jl_Boolean__init_(1);
        jl_Boolean_FALSE = jl_Boolean__init_(0);
        jl_Boolean_TYPE = $rt_cls($rt_booleancls());
    }
    var onciu_RewriterStopper = $rt_classWithoutFields(0);
    var onciu_RewriterStopper$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    function onciu_RewriterStopper$$_clinit_$lambda$_0_0_shouldStop(var$0, var$1) {
        return 0;
    }
    var s_$less$colon$less = $rt_classWithoutFields();
    var s_$eq$colon$eq = $rt_classWithoutFields(s_$less$colon$less);
    var s_$less$colon$less$$anon$1 = $rt_classWithoutFields(s_$eq$colon$eq);
    function s_$less$colon$less$$anon$1_apply($this, $x) {
        return $x;
    }
    var sr_AbstractFunction1 = $rt_classWithoutFields();
    function sr_AbstractFunction1_toString($this) {
        return $rt_s(17);
    }
    function onciap_Prettifier$IndentingQueryPrettifier$() {
        sr_AbstractFunction1.call(this);
        this.$$outer4 = null;
    }
    function onciap_Prettifier$IndentingQueryPrettifier$__init_(var_0) {
        var var_1 = new onciap_Prettifier$IndentingQueryPrettifier$();
        onciap_Prettifier$IndentingQueryPrettifier$__init_0(var_1, var_0);
        return var_1;
    }
    function onciap_Prettifier$IndentingQueryPrettifier$__init_0($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer4 = $$outer;
    }
    var sc_StringOps$ = $rt_classWithoutFields();
    var sc_StringOps$_MODULE$ = null;
    var sc_StringOps$_fallback = null;
    function sc_StringOps$__clinit_() {
        sc_StringOps$_MODULE$ = new sc_StringOps$;
        sc_StringOps$_fallback = new sc_StringOps$$_clinit_$lambda$_0_0;
    }
    function sc_StringOps$_contains$extension($this, $$this, $elem) {
        if (jl_String_indexOf0($$this, $elem) < 0)
            return 0;
        return 1;
    }
    function sc_StringOps$_stripMargin$extension($this, $$this) {
        var var$2, var$3;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$2, jl_String_length($$this));
        var$3 = new sc_StringOps$$anon$1;
        var$3.$$this$2 = $$this;
        var$3.$stripped$1 = 0;
        var$3.$scala$collection$StringOps$$anon$$len = jl_String_length($$this);
        var$3.$scala$collection$StringOps$$anon$$index = 0;
        $$this = new sc_StringOps$$stripMargin$extension$lambda$_68_0;
        $$this.$_0135 = 124;
        $$this.$_124 = var$2;
        sc_IterableOnceOps_foreach$(var$3, $$this);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function sc_StringOps$_r$extension($this, $$this) {
        var var$2, var$3;
        var$2 = new sum_Regex;
        var$3 = sci_Nil$_MODULE$;
        var$2.$pattern4 = jur_Pattern_compile($$this);
        var$2.$scala$util$matching$Regex$$groupNames = var$3;
        return var$2;
    }
    function sc_StringOps$_nonEmpty$extension($this, $$this) {
        if (jl_String_isEmpty($$this))
            return 0;
        return 1;
    }
    var scm_HashMap$ = $rt_classWithoutFields();
    var scm_HashMap$_MODULE$ = null;
    function scm_HashMap$__clinit_() {
        scm_HashMap$_MODULE$ = new scm_HashMap$;
    }
    function scm_HashMap$_newBuilder($this) {
        var var$1;
        var$1 = new scm_HashMap$$anon$6;
        scm_GrowableBuilder__init_(var$1, scm_HashMap__init_0(16, 0.75));
        return var$1;
    }
    function scm_HashMap$_from($this, $it) {
        var var$2;
        var$2 = $it.$knownSize();
        return scm_HashMap_addAll(scm_HashMap__init_0(var$2 <= 0 ? 16 : (var$2 + 1 | 0) / 0.75 | 0, 0.75), $it);
    }
    function scm_HashMap$_empty($this) {
        return scm_HashMap__init_();
    }
    var sc_StringOps$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    var ju_Dictionary = $rt_classWithoutFields();
    var ju_Map = $rt_classWithoutFields(0);
    function ju_Map_getOrDefault($this, $key, $defaultValue) {
        if (ju_HashMap_containsKey($this, $key))
            $defaultValue = ju_LinkedHashMap_get($this, $key);
        return $defaultValue;
    }
    function ju_Hashtable() {
        var a = this; ju_Dictionary.call(a);
        a.$elementCount0 = 0;
        a.$elementData0 = null;
        a.$loadFactor = 0.0;
        a.$threshold = 0;
        a.$firstSlot = 0;
        a.$lastSlot = 0;
        a.$modCount1 = 0;
    }
    var ju_Hashtable_EMPTY_ENUMERATION = null;
    var ju_Hashtable_EMPTY_ITERATOR = null;
    function ju_Hashtable__init_0() {
        var var_0 = new ju_Hashtable();
        ju_Hashtable__init_(var_0);
        return var_0;
    }
    function ju_Hashtable__init_($this) {
        var var$1, var$2;
        $this.$lastSlot = (-1);
        $this.$elementCount0 = 0;
        var$1 = $rt_createArray(ju_Hashtable$Entry, 11);
        var$2 = var$1.data;
        $this.$elementData0 = var$1;
        $this.$firstSlot = var$2.length;
        $this.$loadFactor = 0.75;
        ju_Hashtable_computeMaxSize($this);
    }
    function ju_Hashtable_computeMaxSize($this) {
        $this.$threshold = $this.$elementData0.data.length * $this.$loadFactor | 0;
    }
    function ju_Hashtable_get($this, $key) {
        var $hash, $index, var$4, $entry;
        jl_Object_monitorEnterSync($this);
        try {
            $hash = jl_String_hashCode($key);
            $index = $hash & 2147483647;
            var$4 = $this.$elementData0.data;
            $entry = var$4[$index % var$4.length | 0];
            while ($entry !== null) {
                if (ju_Hashtable$Entry_equalsKey($entry, $key, $hash))
                    return $entry.$value12;
                $entry = $entry.$next2;
            }
            return null;
        } finally {
            jl_Object_monitorExitSync($this);
        }
    }
    function ju_Hashtable_put($this, $key, $value) {
        var $hash, var$4, var$5, $index, $entry, $result, var$9, var$10, var$11, var$12;
        jl_Object_monitorEnterSync($this);
        try {
            if ($key !== null && $value !== null) {
                $hash = jl_String_hashCode($key);
                var$4 = $hash & 2147483647;
                var$5 = $this.$elementData0.data;
                $index = var$4 % var$5.length | 0;
                $entry = var$5[$index];
                while ($entry !== null && !ju_Hashtable$Entry_equalsKey($entry, $key, $hash)) {
                    $entry = $entry.$next2;
                }
                if ($entry !== null) {
                    $result = $entry.$value12;
                    $entry.$value12 = $value;
                    return $result;
                }
                $this.$modCount1 = $this.$modCount1 + 1 | 0;
                var$9 = $this.$elementCount0 + 1 | 0;
                $this.$elementCount0 = var$9;
                if (var$9 > $this.$threshold) {
                    var$9 = ($this.$elementData0.data.length << 1) + 1 | 0;
                    if (!var$9)
                        var$9 = 1;
                    $index = (-1);
                    var$10 = $rt_createArray(ju_Hashtable$Entry, var$9);
                    var$5 = var$10.data;
                    $hash = $this.$lastSlot + 1 | 0;
                    var$11 = var$9;
                    while (true) {
                        $hash = $hash + (-1) | 0;
                        if ($hash < $this.$firstSlot)
                            break;
                        $result = $this.$elementData0.data[$hash];
                        while ($result !== null) {
                            var$12 = ($result.$key0.$hashCode0() & 2147483647) % var$9 | 0;
                            if (var$12 < var$11)
                                var$11 = var$12;
                            if (var$12 > $index)
                                $index = var$12;
                            $entry = $result.$next2;
                            $result.$next2 = var$5[var$12];
                            var$5[var$12] = $result;
                            $result = $entry;
                        }
                    }
                    $this.$firstSlot = var$11;
                    $this.$lastSlot = $index;
                    $this.$elementData0 = var$10;
                    ju_Hashtable_computeMaxSize($this);
                    $index = var$4 % $this.$elementData0.data.length | 0;
                }
                if ($index < $this.$firstSlot)
                    $this.$firstSlot = $index;
                if ($index > $this.$lastSlot)
                    $this.$lastSlot = $index;
                $entry = new ju_Hashtable$Entry;
                ju_MapEntry__init_($entry, $key, $value);
                $entry.$hashcode = jl_String_hashCode($key);
                var$5 = $this.$elementData0.data;
                $entry.$next2 = var$5[$index];
                var$5[$index] = $entry;
                return null;
            }
            $key = new jl_NullPointerException;
            jl_Throwable__init_0($key);
            $rt_throw($key);
        } finally {
            jl_Object_monitorExitSync($this);
        }
    }
    function ju_Hashtable__clinit_() {
        ju_Hashtable_EMPTY_ENUMERATION = new ju_Hashtable$1;
        ju_Hashtable_EMPTY_ITERATOR = new ju_Hashtable$2;
    }
    function ju_Properties() {
        ju_Hashtable.call(this);
        this.$defaults = null;
    }
    function ju_Properties_getProperty($this, $name) {
        var $result, $property;
        $result = ju_Hashtable_get($this, $name);
        $property = !($result instanceof jl_String) ? null : $result;
        if ($property === null) {
            $result = $this.$defaults;
            if ($result !== null)
                $property = ju_Properties_getProperty($result, $name);
        }
        return $property;
    }
    var jl_IllegalArgumentException = $rt_classWithoutFields(jl_RuntimeException);
    function jl_IllegalArgumentException__init_() {
        var var_0 = new jl_IllegalArgumentException();
        jl_IllegalArgumentException__init_0(var_0);
        return var_0;
    }
    function jl_IllegalArgumentException__init_1(var_0) {
        var var_1 = new jl_IllegalArgumentException();
        jl_IllegalArgumentException__init_2(var_1, var_0);
        return var_1;
    }
    function jl_IllegalArgumentException__init_0($this) {
        jl_Throwable__init_0($this);
    }
    function jl_IllegalArgumentException__init_2($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var ju_Enumeration = $rt_classWithoutFields(0);
    var ju_Hashtable$1 = $rt_classWithoutFields();
    var ju_Iterator = $rt_classWithoutFields(0);
    var ju_Hashtable$2 = $rt_classWithoutFields();
    var ju_Map$Entry = $rt_classWithoutFields(0);
    function ju_MapEntry() {
        var a = this; jl_Object.call(a);
        a.$key0 = null;
        a.$value12 = null;
    }
    function ju_MapEntry__init_0(var_0, var_1) {
        var var_2 = new ju_MapEntry();
        ju_MapEntry__init_(var_2, var_0, var_1);
        return var_2;
    }
    function ju_MapEntry__init_($this, $theKey, $theValue) {
        $this.$key0 = $theKey;
        $this.$value12 = $theValue;
    }
    function ju_Hashtable$Entry() {
        var a = this; ju_MapEntry.call(a);
        a.$next2 = null;
        a.$hashcode = 0;
    }
    function ju_Hashtable$Entry_equalsKey($this, $aKey, $hash) {
        return $this.$hashcode == jl_String_hashCode($aKey) && $this.$key0.$equals($aKey) ? 1 : 0;
    }
    var sc_AbstractMap = $rt_classWithoutFields(sc_AbstractIterable);
    function sc_AbstractMap_canEqual($this, $that) {
        return 1;
    }
    function sc_AbstractMap_equals($this, $o) {
        return sc_Map_equals$($this, $o);
    }
    function sc_AbstractMap_hashCode($this) {
        var var$1, var$2, var$3;
        suh_MurmurHash3$_$callClinit();
        var$1 = suh_MurmurHash3$_MODULE$;
        if ($this.$isEmpty())
            var$2 = suh_MurmurHash3$_emptyMapHash(var$1);
        else {
            var$3 = new suh_MurmurHash3$accum$1;
            var$3.$a = 0;
            var$3.$b = 0;
            var$3.$n1 = 0;
            var$3.$c = 1;
            var$2 = suh_MurmurHash3$_mapSeed(var$1);
            $this.$foreachEntry(var$3);
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(var$1, suh_MurmurHash3_mixLast(var$1, suh_MurmurHash3_mix(var$1, suh_MurmurHash3_mix(var$1, var$2, var$3.$a), var$3.$b), var$3.$c) ^ var$3.$n1);
        }
        return var$2;
    }
    function sc_AbstractMap_stringPrefix($this) {
        return $rt_s(388);
    }
    function sc_AbstractMap_toString($this) {
        return sc_Iterable_toString$($this);
    }
    function sc_AbstractMap_fromSpecific($this, $coll) {
        return ($this.$mapFactory()).$from0($coll);
    }
    function sc_AbstractMap_newSpecificBuilder($this) {
        return ($this.$mapFactory()).$newBuilder();
    }
    function sc_AbstractMap_view($this) {
        var var$1;
        var$1 = new sc_MapView$Id;
        var$1.$underlying5 = $this;
        return var$1;
    }
    function sc_AbstractMap_getOrElse($this, $key, $default) {
        $key = $this.$get1($key);
        if ($key instanceof s_Some)
            $key = $key.$value5;
        else {
            if (!jl_Object_equals(s_None$_MODULE$, $key))
                $rt_throw(s_MatchError__init_($key));
            $key = $default.$apply2();
        }
        return $key;
    }
    function sc_AbstractMap_apply($this, $key) {
        var var$2;
        var$2 = $this.$get1($key);
        if (jl_Object_equals(s_None$_MODULE$, var$2))
            $key = $this.$default0($key);
        else {
            if (!(var$2 instanceof s_Some))
                $rt_throw(s_MatchError__init_(var$2));
            $key = var$2.$value5;
        }
        return $key;
    }
    function sc_AbstractMap_keys($this) {
        return $this.$keySet();
    }
    function sc_AbstractMap_values($this) {
        var var$1;
        var$1 = new sc_MapOps$$anon$1;
        var$1.$$outer5 = $this;
        return var$1;
    }
    function sc_AbstractMap_keysIterator($this) {
        var var$1;
        var$1 = new sc_MapOps$$anon$2;
        var$1.$iter = $this.$iterator0();
        return var$1;
    }
    function sc_AbstractMap_valuesIterator($this) {
        var var$1;
        var$1 = new sc_MapOps$$anon$3;
        var$1.$iter0 = $this.$iterator0();
        return var$1;
    }
    function sc_AbstractMap_foreachEntry($this, $f) {
        var var$2, var$3;
        var$2 = $this.$iterator0();
        while (var$2.$hasNext()) {
            var$3 = var$2.$next();
            $f.$apply0(var$3.$_10, var$3.$_20);
        }
    }
    function sc_AbstractMap_default($this, $key) {
        var var$2, var$3;
        var$2 = new ju_NoSuchElementException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 15);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(389));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$3, $key)));
        $rt_throw(var$2);
    }
    function sc_AbstractMap_contains($this, $key) {
        return s_Option_isDefined($this.$get1($key));
    }
    function sc_AbstractMap_map($this, $f) {
        return ($this.$mapFactory()).$from0(sc_View$Map__init_($this, $f));
    }
    function sc_AbstractMap_collect($this, $pf) {
        return ($this.$mapFactory()).$from0(sc_View$Collect__init_($this, $pf));
    }
    function sc_AbstractMap_concat($this, $suffix) {
        return sc_MapOps_concat$($this, $suffix);
    }
    function sc_AbstractMap_$plus$plus($this, $xs) {
        return $this.$concat2($xs);
    }
    function sc_AbstractMap_addString($this, $sb, $start, $sep, $end) {
        return sc_IterableOnceOps_addString$(($this.$iterator0()).$map7(new sc_MapOps$addString$lambda$_49_0), $sb, $start, $sep, $end);
    }
    function sc_AbstractMap_fromSpecific0($this, $coll) {
        return $this.$fromSpecific0($coll);
    }
    var sci_AbstractMap = $rt_classWithoutFields(sc_AbstractMap);
    function sci_AbstractMap_mapFactory($this) {
        return sci_Map$_MODULE$;
    }
    function sci_AbstractMap_toMap($this, $ev) {
        return $this;
    }
    function sci_AbstractMap_withDefaultValue($this, $d) {
        var var$2, var$3;
        var$2 = new sci_Map$WithDefault;
        var$3 = new sci_Map$withDefaultValue$lambda$_9_0;
        var$3.$_0136 = $d;
        sci_Map$WithDefault__init_(var$2, $this, var$3);
        return var$2;
    }
    function sci_AbstractMap_$minus($this, $key) {
        return $this.$removed($key);
    }
    function sci_AbstractMap_removedAll($this, $keys) {
        return ($keys.$iterator0()).$foldLeft($this, new sci_MapOps$removedAll$lambda$_7_0);
    }
    function sci_AbstractMap_$minus$minus($this, $keys) {
        return $this.$removedAll($keys);
    }
    function sci_AbstractMap_$plus($this, $kv) {
        return $this.$updated1($kv.$_10, $kv.$_20);
    }
    function sci_AbstractMap_keySet($this) {
        return sci_MapOps$ImmutableKeySet__init_($this);
    }
    function sci_AbstractMap_iterableFactory($this) {
        sci_Iterable$_$callClinit();
        return sci_Iterable$_MODULE$;
    }
    function sci_AbstractMap_coll($this) {
        return $this;
    }
    function sci_AbstractMap_keySet0($this) {
        return $this.$keySet0();
    }
    var sci_Map$EmptyMap$ = $rt_classWithoutFields(sci_AbstractMap);
    var sci_Map$EmptyMap$_MODULE$ = null;
    function sci_Map$EmptyMap$__clinit_() {
        sci_Map$EmptyMap$_MODULE$ = new sci_Map$EmptyMap$;
    }
    function sci_Map$EmptyMap$_size($this) {
        return 0;
    }
    function sci_Map$EmptyMap$_knownSize($this) {
        return 0;
    }
    function sci_Map$EmptyMap$_isEmpty($this) {
        return 1;
    }
    function sci_Map$EmptyMap$_contains($this, $key) {
        return 0;
    }
    function sci_Map$EmptyMap$_get($this, $key) {
        return s_None$_MODULE$;
    }
    function sci_Map$EmptyMap$_getOrElse($this, $key, $default) {
        return $default.$apply2();
    }
    function sci_Map$EmptyMap$_iterator($this) {
        return sc_Iterator$_scala$collection$Iterator$$_empty;
    }
    function sci_Map$EmptyMap$_keysIterator($this) {
        return sc_Iterator$_scala$collection$Iterator$$_empty;
    }
    function sci_Map$EmptyMap$_valuesIterator($this) {
        return sc_Iterator$_scala$collection$Iterator$$_empty;
    }
    function sci_Map$EmptyMap$_concat($this, $suffix) {
        return !$rt_isInstance($suffix, sci_Map) ? sc_MapOps_concat$($this, $suffix) : $suffix;
    }
    function sci_Map$EmptyMap$_removed($this, $key) {
        return $this;
    }
    function sci_Map$EmptyMap$_updated($this, $key, $value) {
        return sci_Map$Map1__init_($key, $value);
    }
    function sci_Map$EmptyMap$_apply($this, $key) {
        var var$2, var$3;
        var$2 = new ju_NoSuchElementException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 15);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(389));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$3, $key)));
        $rt_throw(var$2);
    }
    var onciap_ExpressionStringifier$Extension = $rt_classWithoutFields(0);
    function onciap_ExpressionStringifier$Extension$$anon$1() {
        jl_Object.call(this);
        this.$func$1 = null;
    }
    function onciap_ExpressionStringifier$Extension$$anon$1_apply($this, $ctx, $expression) {
        return $this.$func$1.$apply($expression);
    }
    var scm_SeqOps = $rt_classWithoutFields(0);
    var scm_Seq = $rt_classWithoutFields(0);
    var scm_AbstractSeq = $rt_classWithoutFields(sc_AbstractSeq);
    var scm_Buffer = $rt_classWithoutFields(0);
    var scm_AbstractBuffer = $rt_classWithoutFields(scm_AbstractSeq);
    function scm_AbstractBuffer_$plus$eq($this, $elem) {
        return $this.$addOne($elem);
    }
    var scm_IndexedSeqOps = $rt_classWithoutFields(0);
    var scm_IndexedSeq = $rt_classWithoutFields(0);
    var scm_IndexedBuffer = $rt_classWithoutFields(0);
    function scm_ArrayBuffer() {
        var a = this; scm_AbstractBuffer.call(a);
        a.$mutationCount = 0;
        a.$array0 = null;
        a.$size00 = 0;
    }
    function scm_ArrayBuffer__init_0(var_0, var_1) {
        var var_2 = new scm_ArrayBuffer();
        scm_ArrayBuffer__init_1(var_2, var_0, var_1);
        return var_2;
    }
    function scm_ArrayBuffer__init_() {
        var var_0 = new scm_ArrayBuffer();
        scm_ArrayBuffer__init_2(var_0);
        return var_0;
    }
    function scm_ArrayBuffer_distinctBy($this, $f) {
        return sc_StrictOptimizedSeqOps_distinctBy$($this, $f);
    }
    function scm_ArrayBuffer_prepended($this, $elem) {
        return sc_StrictOptimizedSeqOps_prepended$($this, $elem);
    }
    function scm_ArrayBuffer_appended($this, $elem) {
        return sc_StrictOptimizedSeqOps_appended$($this, $elem);
    }
    function scm_ArrayBuffer_appendedAll($this, $suffix) {
        return sc_StrictOptimizedSeqOps_appendedAll$($this, $suffix);
    }
    function scm_ArrayBuffer_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function scm_ArrayBuffer_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function scm_ArrayBuffer_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function scm_ArrayBuffer_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function scm_ArrayBuffer_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function scm_ArrayBuffer_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function scm_ArrayBuffer_iterator($this) {
        return sc_IndexedSeqOps_iterator$($this);
    }
    function scm_ArrayBuffer_reverseIterator($this) {
        return sc_IndexedSeqOps_reverseIterator$($this);
    }
    function scm_ArrayBuffer_reversed($this) {
        return sc_IndexedSeqOps_reversed$($this);
    }
    function scm_ArrayBuffer_head($this) {
        return sc_IndexedSeqOps_head$($this);
    }
    function scm_ArrayBuffer_headOption($this) {
        return sc_IndexedSeqOps_headOption$($this);
    }
    function scm_ArrayBuffer_lengthCompare($this, $len) {
        return sc_IndexedSeqOps_lengthCompare$($this, $len);
    }
    function scm_ArrayBuffer_knownSize($this) {
        return $this.$length();
    }
    function scm_ArrayBuffer_ensureAdditionalSize($this, $n) {
        var var$2, var$3, var$4;
        var$2 = scm_ArrayBuffer$_MODULE$;
        var$3 = $this.$array0;
        var$4 = $this.$size00;
        $this.$array0 = scm_ArrayBuffer$_scala$collection$mutable$ArrayBuffer$$ensureSize(var$2, var$3, var$4, Long_add(Long_fromInt(var$4), Long_fromInt($n)));
    }
    function scm_ArrayBuffer_apply($this, $n) {
        var $checkWithinBounds_hi, var$3, var$4;
        $checkWithinBounds_hi = $n + 1 | 0;
        if ($n < 0) {
            var$3 = new jl_IndexOutOfBoundsException;
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$4, 31);
            var$4 = jl_StringBuilder_append0(var$4, $n);
            jl_AbstractStringBuilder_append1(var$4, $rt_s(390));
            var$4 = jl_StringBuilder_append0(var$4, $this.$size00 - 1 | 0);
            jl_AbstractStringBuilder_append1(var$4, $rt_s(25));
            jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$4));
            $rt_throw(var$3);
        }
        if ($checkWithinBounds_hi <= $this.$size00)
            return $this.$array0.data[$n];
        var$4 = new jl_IndexOutOfBoundsException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 31);
        var$3 = jl_StringBuilder_append0(var$3, $checkWithinBounds_hi - 1 | 0);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(390));
        var$3 = jl_StringBuilder_append0(var$3, $this.$size00 - 1 | 0);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(25));
        jl_Throwable__init_(var$4, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$4);
    }
    function scm_ArrayBuffer_update($this, $index, $elem) {
        var $checkWithinBounds_hi, var$4;
        $checkWithinBounds_hi = $index + 1 | 0;
        if ($index < 0) {
            $elem = new jl_IndexOutOfBoundsException;
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$4, 31);
            var$4 = jl_StringBuilder_append0(var$4, $index);
            jl_AbstractStringBuilder_append1(var$4, $rt_s(390));
            var$4 = jl_StringBuilder_append0(var$4, $this.$size00 - 1 | 0);
            jl_AbstractStringBuilder_append1(var$4, $rt_s(25));
            jl_Throwable__init_($elem, jl_AbstractStringBuilder_toString(var$4));
            $rt_throw($elem);
        }
        if ($checkWithinBounds_hi <= $this.$size00) {
            $this.$mutationCount = $this.$mutationCount + 1 | 0;
            $this.$array0.data[$index] = $elem;
            return;
        }
        $elem = new jl_IndexOutOfBoundsException;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$4, 31);
        var$4 = jl_StringBuilder_append0(var$4, $checkWithinBounds_hi - 1 | 0);
        jl_AbstractStringBuilder_append1(var$4, $rt_s(390));
        var$4 = jl_StringBuilder_append0(var$4, $this.$size00 - 1 | 0);
        jl_AbstractStringBuilder_append1(var$4, $rt_s(25));
        jl_Throwable__init_($elem, jl_AbstractStringBuilder_toString(var$4));
        $rt_throw($elem);
    }
    function scm_ArrayBuffer_length($this) {
        return $this.$size00;
    }
    function scm_ArrayBuffer_clear($this) {
        $this.$mutationCount = $this.$mutationCount + 1 | 0;
        ju_Arrays_fill($this.$array0, 0, $this.$size00, null);
        $this.$size00 = 0;
    }
    function scm_ArrayBuffer_addOne($this, $elem) {
        var $oldSize;
        $this.$mutationCount = $this.$mutationCount + 1 | 0;
        scm_ArrayBuffer_ensureAdditionalSize($this, 1);
        $oldSize = $this.$size00;
        $this.$size00 = $oldSize + 1 | 0;
        scm_ArrayBuffer_update($this, $oldSize, $elem);
        return $this;
    }
    function scm_ArrayBuffer_stringPrefix($this) {
        return $rt_s(391);
    }
    function scm_ArrayBuffer_copyToArray($this, $xs, $start, $len) {
        var $copied, $elemsToCopyToArray_destLen;
        $copied = $this.$size00;
        $elemsToCopyToArray_destLen = jlr_Array_getLength($xs);
        $copied = jl_Math_max(jl_Math_min(jl_Math_min($len, $copied), $elemsToCopyToArray_destLen - $start | 0), 0);
        if ($copied > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$array0, 0, $xs, $start, $copied);
        return $copied;
    }
    function scm_ArrayBuffer_foldLeft($this, $foldl_z, $op) {
        var $foldl_start, $foldl_end, $foldl_start_0;
        $foldl_start = 0;
        $foldl_end = $this.$size00;
        while ($foldl_start != $foldl_end) {
            $foldl_start_0 = $foldl_start + 1 | 0;
            $foldl_z = $op.$apply0($foldl_z, $this.$array0.data[$foldl_start]);
            $foldl_start = $foldl_start_0;
        }
        return $foldl_z;
    }
    function scm_ArrayBuffer_reduceLeft($this, $op) {
        var $foldl_end, $reduceLeft_foldl_loop$1_at, $foldl_start, $foldl_z, $foldl_start_0, $reduceLeft_foldl_loop$1_acc, $reduceLeft_foldl_loop$1_end, $reduceLeft_foldl_loop$1_at_0, $reduceLeft_reduceLeftIterator_it, $reduceLeft_reduceLeftIterator_acc;
        $foldl_end = $this.$size00;
        $reduceLeft_foldl_loop$1_at = $rt_compare($foldl_end, 0);
        if ($reduceLeft_foldl_loop$1_at > 0) {
            $foldl_start = 1;
            $foldl_z = $this.$array0.data[0];
            while ($foldl_start != $foldl_end) {
                $foldl_start_0 = $foldl_start + 1 | 0;
                $foldl_z = $op.$apply0($foldl_z, $this.$array0.data[$foldl_start]);
                $foldl_start = $foldl_start_0;
            }
            return $foldl_z;
        }
        if ($reduceLeft_foldl_loop$1_at > 0) {
            $reduceLeft_foldl_loop$1_at = 1;
            $reduceLeft_foldl_loop$1_acc = scm_ArrayBuffer_apply($this, 0);
            $reduceLeft_foldl_loop$1_end = $this.$size00;
            while ($reduceLeft_foldl_loop$1_at != $reduceLeft_foldl_loop$1_end) {
                $reduceLeft_foldl_loop$1_at_0 = $reduceLeft_foldl_loop$1_at + 1 | 0;
                $reduceLeft_foldl_loop$1_acc = $op.$apply0($reduceLeft_foldl_loop$1_acc, scm_ArrayBuffer_apply($this, $reduceLeft_foldl_loop$1_at));
                $reduceLeft_foldl_loop$1_at = $reduceLeft_foldl_loop$1_at_0;
            }
            return $reduceLeft_foldl_loop$1_acc;
        }
        if (!$this.$length()) {
            $op = new jl_UnsupportedOperationException;
            jl_Throwable__init_($op, $rt_s(23));
            $rt_throw($op);
        }
        $reduceLeft_reduceLeftIterator_it = sc_IndexedSeqOps_iterator$($this);
        if (!$reduceLeft_reduceLeftIterator_it.$hasNext()) {
            $reduceLeft_foldl_loop$1_acc = new jl_UnsupportedOperationException;
            jl_Throwable__init_($reduceLeft_foldl_loop$1_acc, $rt_s(23));
            $rt_throw($reduceLeft_foldl_loop$1_acc);
        }
        $reduceLeft_reduceLeftIterator_acc = sc_IndexedSeqView$IndexedSeqViewIterator_next($reduceLeft_reduceLeftIterator_it);
        while ($reduceLeft_reduceLeftIterator_it.$hasNext()) {
            $reduceLeft_reduceLeftIterator_acc = $op.$apply0($reduceLeft_reduceLeftIterator_acc, sc_IndexedSeqView$IndexedSeqViewIterator_next($reduceLeft_reduceLeftIterator_it));
        }
        return $reduceLeft_reduceLeftIterator_acc;
    }
    function scm_ArrayBuffer_addAll($this, $xs) {
        var var$2;
        if (!($xs instanceof scm_ArrayBuffer))
            scm_Growable_addAll$($this, $xs);
        else {
            $xs = $xs;
            var$2 = $xs.$size00;
            if (var$2 > 0) {
                $this.$mutationCount = $this.$mutationCount + 1 | 0;
                scm_ArrayBuffer_ensureAdditionalSize($this, var$2);
                s_Array$_copy(s_Array$_MODULE$, $xs.$array0, 0, $this.$array0, $this.$size00, var$2);
                $this.$size00 = $this.$size00 + var$2 | 0;
            }
        }
        return $this;
    }
    function scm_ArrayBuffer_addOne0($this, $elem) {
        return scm_ArrayBuffer_addOne($this, $elem);
    }
    function scm_ArrayBuffer_iterableFactory($this) {
        return scm_ArrayBuffer$_MODULE$;
    }
    function scm_ArrayBuffer_view($this) {
        var var$1, var$2;
        var$1 = new scm_ArrayBufferView;
        var$2 = new scm_ArrayBuffer$view$lambda$_88_0;
        var$2.$_0137 = $this;
        var$1.$underlying6 = $this;
        var$1.$mutationCount0 = var$2;
        return var$1;
    }
    function scm_ArrayBuffer_apply0($this, $v1) {
        return scm_ArrayBuffer_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function scm_ArrayBuffer__init_1($this, $initialElements, $initialSize) {
        $this.$mutationCount = 0;
        $this.$array0 = $initialElements;
        $this.$size00 = $initialSize;
    }
    function scm_ArrayBuffer__init_2($this) {
        scm_ArrayBuffer__init_1($this, $rt_createArray(jl_Object, 16), 0);
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_0() {
        jl_Object.call(this);
        this.$_066 = null;
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_0_apply(var$0, var$1) {
        return jl_Boolean_valueOf((onciu_StepSequencer$MutableDirectedGraph_incoming(var$0.$_066, var$1)).$isEmpty());
    }
    function s_Some() {
        s_Option.call(this);
        this.$value5 = null;
    }
    function s_Some__init_(var_0) {
        var var_1 = new s_Some();
        s_Some__init_0(var_1, var_0);
        return var_1;
    }
    function s_Some_value($this) {
        return $this.$value5;
    }
    function s_Some_get($this) {
        return $this.$value5;
    }
    function s_Some_productPrefix($this) {
        return $rt_s(392);
    }
    function s_Some_productArity($this) {
        return 1;
    }
    function s_Some_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function s_Some_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function s_Some_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    }
    function s_Some_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function s_Some_equals($this, $x$1) {
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof s_Some) ? 0 : 1))
                    break a;
                $x$1 = $x$1;
                if (!sr_BoxesRunTime_equals($this.$value5, $x$1.$value5))
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function s_Some__init_0($this, $value) {
        $this.$value5 = $value;
    }
    var sc_IterableFactory$ = $rt_classWithoutFields();
    var sc_IterableFactory$_MODULE$ = null;
    function sc_IterableFactory$__clinit_() {
        sc_IterableFactory$_MODULE$ = new sc_IterableFactory$;
    }
    function sc_IterableFactory$_toFactory($this, $factory) {
        return sc_IterableFactory$ToFactory__init_($factory);
    }
    function sc_IterableFactory$Delegate() {
        jl_Object.call(this);
        this.$delegate1 = null;
    }
    function sc_IterableFactory$Delegate__init_(var_0) {
        var var_1 = new sc_IterableFactory$Delegate();
        sc_IterableFactory$Delegate__init_0(var_1, var_0);
        return var_1;
    }
    function sc_IterableFactory$Delegate_empty($this) {
        return $this.$delegate1.$empty();
    }
    function sc_IterableFactory$Delegate_from($this, $it) {
        return $this.$delegate1.$from0($it);
    }
    function sc_IterableFactory$Delegate_newBuilder($this) {
        return $this.$delegate1.$newBuilder();
    }
    function sc_IterableFactory$Delegate__init_0($this, $delegate) {
        $this.$delegate1 = $delegate;
    }
    var scm_Set$ = $rt_classWithoutFields(sc_IterableFactory$Delegate);
    var scm_Set$_MODULE$ = null;
    function scm_Set$_$callClinit() {
        scm_Set$_$callClinit = $rt_eraseClinit(scm_Set$);
        scm_Set$__clinit_();
    }
    function scm_Set$__clinit_() {
        var var$1;
        var$1 = new scm_Set$;
        scm_Set$_$callClinit();
        sc_IterableFactory$Delegate__init_0(var$1, scm_HashSet$_MODULE$);
        scm_Set$_MODULE$ = var$1;
    }
    var scm_SetOps = $rt_classWithoutFields(0);
    var scm_Set = $rt_classWithoutFields(0);
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_1() {
        jl_Object.call(this);
        this.$_068 = null;
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_1_apply(var$0, var$1) {
        return onciu_StepSequencer$MutableDirectedGraph_outgoing(var$0.$_068, var$1);
    }
    var onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_2 = $rt_classWithoutFields();
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_2_apply(var$0, var$1) {
        return jl_Boolean_valueOf(sc_IterableOnceOps_nonEmpty$(var$1));
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_3() {
        var a = this; jl_Object.call(a);
        a.$_067 = null;
        a.$_119 = null;
        a.$_210 = null;
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_3_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_067;
        var$3 = var$0.$_119;
        var$4 = var$0.$_210;
        scm_HashSet_remove((scm_HashMap_apply(var$2.$elems, var$3)).$outgoing, var$1);
        scm_HashSet_remove((scm_HashMap_apply(var$2.$elems, var$1)).$incoming, var$3);
        return !(onciu_StepSequencer$MutableDirectedGraph_incoming(var$2, var$1)).$isEmpty() ? sr_BoxedUnit_UNIT : var$4.$addOne(var$1);
    }
    var sm_Equiv = $rt_classWithoutFields(0);
    var sm_PartialOrdering = $rt_classWithoutFields(0);
    var sm_Ordering = $rt_classWithoutFields(0);
    function sm_Ordering_max$($$this, $x, $y) {
        if ($$this.$gteq($x, $y))
            $y = $x;
        return $y;
    }
    function sm_Ordering_min$($$this, $x, $y) {
        if ($$this.$lteq($x, $y))
            $y = $x;
        return $y;
    }
    var sc_EvidenceIterableFactory$ = $rt_classWithoutFields();
    var sc_EvidenceIterableFactory$_MODULE$ = null;
    function sc_EvidenceIterableFactory$__clinit_() {
        sc_EvidenceIterableFactory$_MODULE$ = new sc_EvidenceIterableFactory$;
    }
    function sc_EvidenceIterableFactory$Delegate() {
        jl_Object.call(this);
        this.$delegate2 = null;
    }
    var sc_SortedIterableFactory = $rt_classWithoutFields(0);
    var sc_SortedIterableFactory$Delegate = $rt_classWithoutFields(sc_EvidenceIterableFactory$Delegate);
    var scm_SortedSet$ = $rt_classWithoutFields(sc_SortedIterableFactory$Delegate);
    var scm_SortedSet$_MODULE$ = null;
    function scm_SortedSet$_$callClinit() {
        scm_SortedSet$_$callClinit = $rt_eraseClinit(scm_SortedSet$);
        scm_SortedSet$__clinit_();
    }
    function scm_SortedSet$__clinit_() {
        var var$1;
        var$1 = new scm_SortedSet$;
        scm_SortedSet$_$callClinit();
        var$1.$delegate2 = scm_TreeSet$_MODULE$;
        scm_SortedSet$_MODULE$ = var$1;
    }
    var onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_0 = $rt_classWithoutFields();
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_0_apply(var$0, var$1) {
        return var$1.$postConditions0();
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_1() {
        jl_Object.call(this);
        this.$_061 = null;
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_1_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_061;
        var$3 = var$1.$invalidatedConditions();
        var$1 = new onciu_StepSequencer$$anonfun$$nestedInanonfun$sort$2$1;
        var$1.$introducingSteps$2 = var$2;
        return var$3.$collect0(var$1);
    }
    var onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_2 = $rt_classWithoutFields();
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_2_apply(var$0, var$1) {
        var$1 = var$1;
        s_Predef$_$callClinit();
        return var$1;
    }
    var onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_3 = $rt_classWithoutFields();
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_3_apply(var$0, var$1) {
        return jl_Integer_valueOf(var$1.$length());
    }
    var sr_BoxesRunTime = $rt_classWithoutFields();
    function sr_BoxesRunTime_typeCode($a) {
        if ($a instanceof jl_Integer)
            return 3;
        if ($a instanceof jl_Double)
            return 6;
        if ($a instanceof jl_Long)
            return 4;
        if ($a instanceof jl_Character)
            return 0;
        if ($a instanceof jl_Float)
            return 5;
        if (!($a instanceof jl_Byte) && !($a instanceof jl_Short))
            return 7;
        return 3;
    }
    function sr_BoxesRunTime_boxToBoolean($b) {
        return jl_Boolean_valueOf($b);
    }
    function sr_BoxesRunTime_boxToInteger($i) {
        return jl_Integer_valueOf($i);
    }
    function sr_BoxesRunTime_unboxToBoolean($b) {
        return $b === null ? 0 : $b.$value8;
    }
    function sr_BoxesRunTime_unboxToChar($c) {
        return $c === null ? 0 : $c.$value1;
    }
    function sr_BoxesRunTime_unboxToByte($b) {
        return $b === null ? 0 : $b.$value13;
    }
    function sr_BoxesRunTime_unboxToShort($s) {
        return $s === null ? 0 : $s.$value14;
    }
    function sr_BoxesRunTime_unboxToInt($i) {
        return $i === null ? 0 : $i.$value;
    }
    function sr_BoxesRunTime_unboxToLong($l) {
        return $l === null ? Long_ZERO : $l.$value2;
    }
    function sr_BoxesRunTime_unboxToFloat($f) {
        return $f === null ? 0.0 : $f.$value4;
    }
    function sr_BoxesRunTime_unboxToDouble($d) {
        return $d === null ? 0.0 : $d.$value3;
    }
    function sr_BoxesRunTime_equals($x, $y) {
        var var$3;
        if ($x === $y)
            return 1;
        if ($x instanceof jl_Number)
            var$3 = sr_BoxesRunTime_equalsNumObject($x, $y);
        else if (!($x instanceof jl_Character))
            var$3 = $x !== null ? $x.$equals($y) : $y !== null ? 0 : 1;
        else {
            $x = $x;
            var$3 = $y instanceof jl_Character ? ($x.$value1 != $y.$value1 ? 0 : 1) : $y instanceof jl_Number ? sr_BoxesRunTime_equalsNumChar($y, $x) : $x !== null ? jl_Character_equals($x, $y) : $y !== null ? 0 : 1;
        }
        return var$3;
    }
    function sr_BoxesRunTime_equalsNumObject($xn, $y) {
        var var$3, var$4;
        if (!($y instanceof jl_Number)) {
            if ($y instanceof jl_Character)
                return sr_BoxesRunTime_equalsNumChar($xn, $y);
            if ($xn !== null)
                return $xn.$equals($y);
            return $y !== null ? 0 : 1;
        }
        $y = $y;
        var$3 = sr_BoxesRunTime_typeCode($xn);
        var$4 = sr_BoxesRunTime_typeCode($y);
        if (var$4 > var$3)
            var$3 = var$4;
        a: {
            switch (var$3) {
                case 3:
                    break;
                case 4:
                    var$3 = Long_ne($xn.$longValue(), $y.$longValue()) ? 0 : 1;
                    break a;
                case 5:
                    var$3 = $xn.$floatValue() !== $y.$floatValue() ? 0 : 1;
                    break a;
                case 6:
                    var$3 = $xn.$doubleValue() !== $y.$doubleValue() ? 0 : 1;
                    break a;
                default:
                    if ($y instanceof sm_ScalaNumber && !($xn instanceof sm_ScalaNumber)) {
                        var$3 = $y.$equals($xn);
                        break a;
                    }
                    if ($xn !== null) {
                        var$3 = $xn.$equals($y);
                        break a;
                    }
                    var$3 = $y !== null ? 0 : 1;
                    break a;
            }
            var$3 = $xn.$intValue() != $y.$intValue() ? 0 : 1;
        }
        return var$3;
    }
    function sr_BoxesRunTime_equalsNumChar($xn, $yc) {
        var $ch;
        if ($yc === null)
            return $xn !== null ? 0 : 1;
        $ch = $yc.$value1;
        switch (sr_BoxesRunTime_typeCode($xn)) {
            case 3:
                return $xn.$intValue() != $ch ? 0 : 1;
            case 4:
                return Long_ne($xn.$longValue(), Long_fromInt($ch)) ? 0 : 1;
            case 5:
                return $xn.$floatValue() !== $ch ? 0 : 1;
            case 6:
                return $xn.$doubleValue() !== $ch ? 0 : 1;
            default:
        }
        return $xn.$equals($yc);
    }
    var onciu_StepSequencer$MutableDirectedGraph$ = $rt_classWithoutFields();
    var onciu_StepSequencer$MutableDirectedGraph$_MODULE$ = null;
    function onciu_StepSequencer$MutableDirectedGraph$__clinit_() {
        onciu_StepSequencer$MutableDirectedGraph$_MODULE$ = new onciu_StepSequencer$MutableDirectedGraph$;
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_4() {
        var a = this; jl_Object.call(a);
        a.$_064 = null;
        a.$_118 = null;
        a.$_29 = null;
        a.$_33 = null;
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_4_apply(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        var$1 = var$1;
        var$3 = var$0.$_064;
        var$4 = var$0.$_118;
        var$5 = var$0.$_29;
        var$6 = var$0.$_33;
        var$3.$addAll0(var$1.$postConditions0());
        if (sc_IterableOnceOps_nonEmpty$(var$1.$invalidatedConditions())) {
            scm_Set$_$callClinit();
            var$7 = sc_IterableFactory$Delegate_empty(scm_Set$_MODULE$);
            var$8 = (var$1.$invalidatedConditions()).$filter1(var$3);
            var$9 = new onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_0;
            var$9.$_0138 = var$4;
            var$8 = var$8.$flatMap(var$9);
            var$3.$subtractAll(var$1.$invalidatedConditions());
            var$1 = new onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_1;
            var$1.$_0139 = var$5;
            var$1.$_125 = var$3;
            var$1.$_213 = var$6;
            var$1.$_36 = var$7;
            var$8.$foreach(var$1);
            var$2.$addAll0(var$8);
            var$2.$subtractAll(var$7);
        }
        return sr_BoxedUnit_UNIT;
    }
    var onciu_AssertionRunner = $rt_classWithoutFields();
    var onciu_AssertionRunner_ASSERTIONS_ENABLED = 0;
    var onciu_AssertionRunner_$assertionsDisabled = 0;
    function onciu_AssertionRunner_$callClinit() {
        onciu_AssertionRunner_$callClinit = $rt_eraseClinit(onciu_AssertionRunner);
        onciu_AssertionRunner__clinit_();
    }
    function onciu_AssertionRunner_isAssertionsEnabled() {
        var $assertionsEnabled;
        onciu_AssertionRunner_$callClinit();
        $assertionsEnabled = 0;
        if (!onciu_AssertionRunner_$assertionsDisabled)
            $assertionsEnabled = 1;
        return $assertionsEnabled;
    }
    function onciu_AssertionRunner__clinit_() {
        onciu_AssertionRunner_$assertionsDisabled = 0;
        onciu_AssertionRunner_ASSERTIONS_ENABLED = onciu_AssertionRunner_isAssertionsEnabled();
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_5() {
        jl_Object.call(this);
        this.$_065 = null;
    }
    function onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_5_apply(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$0.$_065.$contains0(var$1) ? 0 : 1);
    }
    var jl_IllegalStateException = $rt_classWithoutFields(jl_RuntimeException);
    function jl_IllegalStateException__init_0(var_0) {
        var var_1 = new jl_IllegalStateException();
        jl_IllegalStateException__init_(var_1, var_0);
        return var_1;
    }
    function jl_IllegalStateException__init_($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var onciap_PatternStringifier = $rt_classWithoutFields(0);
    function onciap_DefaultPatternStringifier() {
        jl_Object.call(this);
        this.$expr1 = null;
    }
    function onciap_DefaultPatternStringifier_apply1($this, $p) {
        var var$2;
        $p = $p.$patternParts();
        var$2 = new onciap_DefaultPatternStringifier$apply$lambda$_0_0;
        var$2.$_0140 = $this;
        return sc_AbstractIterable_mkString0($p.$map1(var$2), $rt_s(16));
    }
    function onciap_DefaultPatternStringifier_apply0($this, $p) {
        var $variable, $patternPart, var$4;
        if ($p instanceof oncie_PathPatternPart)
            return onciap_DefaultPatternStringifier_apply2($this, $p.$element2);
        if (!($p instanceof oncie_PatternPartWithSelector)) {
            if ($p instanceof oncie_ShortestPathsPatternPart) {
                $p = $p;
                $variable = $p.$name13;
                $p = onciap_DefaultPatternStringifier_apply2($this, $p.$element3);
                $patternPart = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($patternPart);
                $variable = jl_StringBuilder_append($patternPart, $variable);
                jl_AbstractStringBuilder_append($variable, 40);
                jl_AbstractStringBuilder_append(jl_StringBuilder_append($variable, $p), 41);
                return jl_AbstractStringBuilder_toString($patternPart);
            }
            if (!($p instanceof oncie_NamedPatternPart))
                $rt_throw(s_MatchError__init_($p));
            $p = $p;
            $variable = onciap_DefaultExpressionStringifier_stringify($this.$expr1, $p.$variable10);
            $p = onciap_DefaultPatternStringifier_apply0($this, $p.$patternPart);
            $patternPart = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($patternPart);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($patternPart, $variable), $rt_s(71)), $p);
            return jl_AbstractStringBuilder_toString($patternPart);
        }
        $p = $p;
        var$4 = $p.$selector;
        if (var$4 instanceof oncie_PatternPart$AllPaths)
            return onciap_DefaultPatternStringifier_apply0($this, $p.$part);
        $p = $p.$part;
        if (!($p instanceof oncie_NamedPatternPart)) {
            if (!$rt_isInstance($p, oncie_AnonymousPatternPart))
                $rt_throw(s_MatchError__init_($p));
            $p = $p;
            $variable = var$4.$prettified();
            $p = onciap_DefaultPatternStringifier_apply0($this, $p);
            $patternPart = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($patternPart);
            $variable = jl_StringBuilder_append($patternPart, $variable);
            jl_AbstractStringBuilder_append($variable, 32);
            jl_StringBuilder_append($variable, $p);
            return jl_AbstractStringBuilder_toString($patternPart);
        }
        $p = $p;
        $variable = $p.$variable10;
        $patternPart = $p.$patternPart;
        $variable = onciap_DefaultExpressionStringifier_stringify($this.$expr1, $variable);
        $p = var$4.$prettified();
        $patternPart = onciap_DefaultPatternStringifier_apply0($this, $patternPart);
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        $p = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $variable), $rt_s(71)), $p);
        jl_AbstractStringBuilder_append($p, 32);
        jl_StringBuilder_append($p, $patternPart);
        return jl_AbstractStringBuilder_toString(var$4);
    }
    function onciap_DefaultPatternStringifier_apply2($this, $element) {
        var var$2, var$3, var$4, var$5;
        if ($element instanceof oncie_RelationshipChain)
            return onciap_DefaultPatternStringifier_apply($this, $element);
        if ($element instanceof oncie_NodePattern)
            return onciap_DefaultPatternStringifier_apply3($this, $element);
        if ($element instanceof oncie_PathConcatenation) {
            var$2 = $element.$factors;
            $element = new onciap_DefaultPatternStringifier$apply$lambda$_6_0;
            $element.$_0141 = $this;
            return sc_AbstractIterable_mkString0(var$2.$map1($element), $rt_s(162));
        }
        if ($element instanceof oncie_QuantifiedPath)
            return onciap_DefaultPatternStringifier_apply4($this, $element);
        if (!($element instanceof oncie_ParenthesizedPath))
            $rt_throw(s_MatchError__init_($element));
        $element = $element;
        var$2 = new sci_$colon$colon;
        var$3 = s_Some__init_(onciap_DefaultPatternStringifier_apply0($this, $element.$part0));
        var$4 = new sci_$colon$colon;
        var$5 = $element.$optionalWhereClause;
        $element = new onciap_DefaultPatternStringifier$apply$lambda$_8_0;
        $element.$_0142 = $this;
        sci_$colon$colon__init_0(var$4, s_Option_map(var$5, $element), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$2, var$3, var$4);
        s_Predef$_$callClinit();
        return sc_IterableOnceOps_mkString$(sc_StrictOptimizedIterableOps_flatten$(var$2, s_Predef$_$conforms(s_Predef$_MODULE$)), $rt_s(24), $rt_s(162), $rt_s(25));
    }
    function onciap_DefaultPatternStringifier_apply3($this, $nodePattern) {
        var var$2, $body, $variable, $labelExpression, var$6, var$7, var$8;
        var$2 = $nodePattern.$variable11;
        $body = new onciap_DefaultPatternStringifier$apply$lambda$_3_0;
        $body.$_0143 = $this;
        $variable = s_Option_map(var$2, $body);
        var$2 = $nodePattern.$labelExpression1;
        $body = new onciap_DefaultPatternStringifier$apply$lambda$_3_1;
        $body.$_0144 = $this;
        $labelExpression = s_Option_map(var$2, $body);
        $body = new sci_$colon$colon;
        var$2 = onciap_DefaultPatternStringifier_concatenate($this, $rt_s(3), sci_$colon$colon__init_($variable, sci_$colon$colon__init_($labelExpression, sci_Nil$_MODULE$)));
        var$6 = new sci_$colon$colon;
        $labelExpression = $nodePattern.$properties4;
        var$7 = new onciap_DefaultPatternStringifier$apply$lambda$_3_2;
        var$7.$_0145 = $this;
        var$7 = s_Option_map($labelExpression, var$7);
        $labelExpression = new sci_$colon$colon;
        var$8 = $nodePattern.$predicate0;
        $nodePattern = new onciap_DefaultPatternStringifier$apply$lambda$_3_3;
        $nodePattern.$_0146 = $this;
        sci_$colon$colon__init_0($labelExpression, s_Option_map(var$8, $nodePattern), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$6, var$7, $labelExpression);
        sci_$colon$colon__init_0($body, var$2, var$6);
        $body = s_Option_getOrElse(onciap_DefaultPatternStringifier_concatenate($this, $rt_s(162), $body), new onciap_DefaultPatternStringifier$apply$lambda$_3_4);
        $nodePattern = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($nodePattern);
        jl_AbstractStringBuilder_append($nodePattern, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append($nodePattern, $body), 41);
        return jl_AbstractStringBuilder_toString($nodePattern);
    }
    function onciap_DefaultPatternStringifier_apply($this, $relationshipChain) {
        var $r, $middle, $l;
        $r = onciap_DefaultPatternStringifier_apply3($this, $relationshipChain.$rightNode);
        $middle = onciap_DefaultPatternStringifier_apply5($this, $relationshipChain.$relationship1);
        $l = onciap_DefaultPatternStringifier_apply2($this, $relationshipChain.$element4);
        $relationshipChain = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($relationshipChain);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($relationshipChain, $l), $middle), $r);
        return jl_AbstractStringBuilder_toString($relationshipChain);
    }
    function onciap_DefaultPatternStringifier_apply5($this, $relationship) {
        var var$2, $body, $variable, $labelExpression, var$6, $range, $length, var$9, var$10, var$11;
        a: {
            var$2 = $relationship.$variable12;
            $body = new onciap_DefaultPatternStringifier$apply$lambda$_5_0;
            $body.$_0147 = $this;
            $variable = s_Option_map(var$2, $body);
            $body = $relationship.$labelExpression2;
            var$2 = new onciap_DefaultPatternStringifier$apply$lambda$_5_1;
            var$2.$_0148 = $this;
            $labelExpression = s_Option_map($body, var$2);
            var$6 = 0;
            $range = null;
            var$2 = $relationship.$length2;
            if (jl_Object_equals(s_None$_MODULE$, var$2))
                $length = s_None$_MODULE$;
            else {
                if (var$2 instanceof s_Some) {
                    var$6 = 1;
                    $range = var$2;
                    $body = $range.$value5;
                    if (jl_Object_equals(s_None$_MODULE$, $body)) {
                        $length = s_Some__init_($rt_s(305));
                        break a;
                    }
                }
                if (var$6) {
                    $body = $range.$value5;
                    if ($body instanceof s_Some) {
                        $range = $body.$value5;
                        $length = new s_Some;
                        var$2 = s_Option_fold($range.$lower, new onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_0, new onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_1);
                        $range = s_Option_fold($range.$upper, new onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_2, new onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_3);
                        var$9 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_(var$9);
                        jl_AbstractStringBuilder_append(var$9, 42);
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$9, var$2), $rt_s(151)), $range);
                        s_Some__init_0($length, jl_AbstractStringBuilder_toString(var$9));
                        break a;
                    }
                }
                $rt_throw(s_MatchError__init_(var$2));
            }
        }
        var$10 = new sci_$colon$colon;
        $body = onciap_DefaultPatternStringifier_concatenate($this, $rt_s(3), sci_$colon$colon__init_($variable, sci_$colon$colon__init_($labelExpression, sci_$colon$colon__init_($length, sci_Nil$_MODULE$))));
        var$2 = new sci_$colon$colon;
        var$9 = $relationship.$properties5;
        $range = new onciap_DefaultPatternStringifier$apply$lambda$_5_2;
        $range.$_0149 = $this;
        $range = s_Option_map(var$9, $range);
        var$9 = new sci_$colon$colon;
        $variable = $relationship.$predicate1;
        var$11 = new onciap_DefaultPatternStringifier$apply$lambda$_5_3;
        var$11.$_0150 = $this;
        sci_$colon$colon__init_0(var$9, s_Option_map($variable, var$11), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$2, $range, var$9);
        sci_$colon$colon__init_0(var$10, $body, var$2);
        $body = s_Option_fold(onciap_DefaultPatternStringifier_concatenate($this, $rt_s(162), var$10), new onciap_DefaultPatternStringifier$apply$lambda$_5_4, new onciap_DefaultPatternStringifier$apply$lambda$_5_5);
        var$2 = $relationship.$direction0;
        if (jl_Object_equals(oncie_SemanticDirection$OUTGOING$_MODULE$, var$2)) {
            $relationship = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($relationship);
            jl_AbstractStringBuilder_append($relationship, 45);
            jl_StringBuilder_append(jl_StringBuilder_append($relationship, $body), $rt_s(393));
            return jl_AbstractStringBuilder_toString($relationship);
        }
        if (jl_Object_equals(oncie_SemanticDirection$INCOMING$_MODULE$, var$2)) {
            $relationship = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($relationship);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($relationship, $rt_s(394)), $body), 45);
            return jl_AbstractStringBuilder_toString($relationship);
        }
        if (!jl_Object_equals(oncie_SemanticDirection$BOTH$_MODULE$, var$2))
            $rt_throw(s_MatchError__init_(var$2));
        $relationship = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($relationship);
        jl_AbstractStringBuilder_append($relationship, 45);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append($relationship, $body), 45);
        return jl_AbstractStringBuilder_toString($relationship);
    }
    function onciap_DefaultPatternStringifier_apply4($this, $quantified) {
        var $pattern, $quantifier, $where, $lower, $upper, $value;
        $pattern = onciap_DefaultPatternStringifier_apply0($this, $quantified.$part1);
        $quantifier = $quantified.$optionalWhereExpression;
        $where = new onciap_DefaultPatternStringifier$apply$lambda$_7_0;
        $where.$_0151 = $this;
        $where = s_Option_getOrElse(s_Option_map(s_Option_map($quantifier, $where), new onciap_DefaultPatternStringifier$apply$lambda$_7_1), new onciap_DefaultPatternStringifier$apply$lambda$_7_2);
        $quantified = $quantified.$quantifier;
        if ($quantified instanceof oncie_StarQuantifier)
            $quantifier = $rt_s(305);
        else if ($quantified instanceof oncie_PlusQuantifier)
            $quantifier = $rt_s(395);
        else if (!($quantified instanceof oncie_IntervalQuantifier)) {
            if (!($quantified instanceof oncie_FixedQuantifier))
                $rt_throw(s_MatchError__init_($quantified));
            $quantifier = $quantified.$value15.$stringVal;
            $quantified = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($quantified);
            jl_AbstractStringBuilder_append($quantified, 123);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append($quantified, $quantifier), 125);
            $quantifier = jl_AbstractStringBuilder_toString($quantified);
        } else {
            $quantified = $quantified;
            $lower = $quantified.$lower0;
            $upper = $quantified.$upper0;
            $quantified = s_Option_getOrElse(s_Option_map($lower, new onciap_DefaultPatternStringifier$apply$lambda$_7_3), new onciap_DefaultPatternStringifier$apply$lambda$_7_4);
            $quantifier = s_Option_getOrElse(s_Option_map($upper, new onciap_DefaultPatternStringifier$apply$lambda$_7_5), new onciap_DefaultPatternStringifier$apply$lambda$_7_6);
            $value = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($value);
            jl_AbstractStringBuilder_append($value, 123);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($value, $quantified), $rt_s(16)), $quantifier), 125);
            $quantifier = jl_AbstractStringBuilder_toString($value);
        }
        $quantified = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($quantified);
        jl_AbstractStringBuilder_append($quantified, 40);
        $pattern = jl_StringBuilder_append(jl_StringBuilder_append($quantified, $pattern), $where);
        jl_AbstractStringBuilder_append($pattern, 41);
        jl_StringBuilder_append($pattern, $quantifier);
        return jl_AbstractStringBuilder_toString($quantified);
    }
    function onciap_DefaultPatternStringifier_concatenate($this, $separator, $fragments) {
        var var$3;
        var$3 = new s_Some;
        s_Predef$_$callClinit();
        s_Some__init_0(var$3, sc_StrictOptimizedIterableOps_flatten$($fragments, s_Predef$_$conforms(s_Predef$_MODULE$)));
        $fragments = s_Option_filter(var$3, new onciap_DefaultPatternStringifier$concatenate$lambda$_9_0);
        var$3 = new onciap_DefaultPatternStringifier$concatenate$lambda$_9_1;
        var$3.$_0152 = $separator;
        return s_Option_map($fragments, var$3);
    }
    function onciap_DefaultPatternStringifier_stringifyPredicate($this, $predicate) {
        var var$2;
        var$2 = onciap_DefaultExpressionStringifier_stringify($this.$expr1, $predicate);
        $predicate = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($predicate);
        jl_StringBuilder_append(jl_StringBuilder_append($predicate, $rt_s(351)), var$2);
        return jl_AbstractStringBuilder_toString($predicate);
    }
    var onciap_PathStepStringifier = $rt_classWithoutFields(0);
    function onciap_DefaultPathStepStringifier() {
        jl_Object.call(this);
        this.$expr = null;
    }
    function onciap_DefaultPathStepStringifier_apply($this, $pathStep) {
        var $node, $next, $variables, $toNode;
        if ($pathStep instanceof oncie_SingleRelationshipPathStep)
            return onciap_DefaultPathStepStringifier_relationshipPathStep($this, oncie_SingleRelationshipPathStep_rel($pathStep), oncie_SingleRelationshipPathStep_direction($pathStep), oncie_SingleRelationshipPathStep_toNode($pathStep), oncie_SingleRelationshipPathStep_next($pathStep), 0);
        if ($pathStep instanceof oncie_NodePathStep) {
            $node = oncie_NodePathStep_node($pathStep);
            $next = oncie_NodePathStep_next($pathStep);
            $pathStep = onciap_DefaultExpressionStringifier_stringify($this.$expr, $node);
            $variables = onciap_DefaultPathStepStringifier_apply($this, $next);
            $toNode = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($toNode);
            jl_AbstractStringBuilder_append($toNode, 40);
            $pathStep = jl_StringBuilder_append($toNode, $pathStep);
            jl_AbstractStringBuilder_append($pathStep, 41);
            jl_StringBuilder_append($pathStep, $variables);
            return jl_AbstractStringBuilder_toString($toNode);
        }
        if ($pathStep instanceof oncie_MultiRelationshipPathStep)
            return onciap_DefaultPathStepStringifier_relationshipPathStep($this, oncie_MultiRelationshipPathStep_rel($pathStep), oncie_MultiRelationshipPathStep_direction($pathStep), oncie_MultiRelationshipPathStep_toNode($pathStep), oncie_MultiRelationshipPathStep_next($pathStep), 1);
        if (!($pathStep instanceof oncie_RepeatPathStep)) {
            if ($pathStep instanceof oncie_NilPathStep)
                return $rt_s(3);
            $rt_throw(s_MatchError__init_($pathStep));
        }
        $variables = oncie_RepeatPathStep_variables($pathStep);
        $toNode = oncie_RepeatPathStep_toNode($pathStep);
        $next = oncie_RepeatPathStep_next($pathStep);
        $pathStep = (((($variables.$flatMap(new onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_0)).$map1(new onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_1)).$zipWithIndex()).$map1(new onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_2)).$mkString($rt_s(3));
        $variables = $toNode.$name3();
        $toNode = onciap_DefaultPathStepStringifier_apply($this, $next);
        $next = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($next);
        $pathStep = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($next, $rt_s(104)), $pathStep), $rt_s(396)), $variables);
        jl_AbstractStringBuilder_append($pathStep, 41);
        jl_StringBuilder_append($pathStep, $toNode);
        return jl_AbstractStringBuilder_toString($next);
    }
    function onciap_DefaultPathStepStringifier_relationshipPathStep($this, $rel, $direction, $toNode, $next, $isMultiRel) {
        var $stringifiedRel, $lArrow, $rArrow, $stringifiedToNode, $multiRel;
        a: {
            b: {
                c: {
                    $stringifiedRel = oncie_SemanticDirection$INCOMING$_MODULE$;
                    if ($direction !== null) {
                        if (!$direction.$equals($stringifiedRel))
                            break b;
                        else
                            break c;
                    }
                    if ($stringifiedRel !== null)
                        break b;
                }
                $lArrow = $rt_s(397);
                break a;
            }
            $lArrow = $rt_s(3);
        }
        d: {
            e: {
                f: {
                    $stringifiedRel = oncie_SemanticDirection$OUTGOING$_MODULE$;
                    if ($direction !== null) {
                        if (!$direction.$equals($stringifiedRel))
                            break e;
                        else
                            break f;
                    }
                    if ($stringifiedRel !== null)
                        break e;
                }
                $rArrow = $rt_s(398);
                break d;
            }
            $rArrow = $rt_s(3);
        }
        $direction = new onciap_DefaultPathStepStringifier$relationshipPathStep$lambda$_1_0;
        $direction.$_0153 = $this;
        $stringifiedToNode = s_Option_getOrElse(s_Option_map($toNode, $direction), new onciap_DefaultPathStepStringifier$relationshipPathStep$lambda$_1_1);
        $stringifiedRel = onciap_DefaultExpressionStringifier_stringify($this.$expr, $rel);
        $multiRel = !$isMultiRel ? $rt_s(3) : $rt_s(305);
        $rel = onciap_DefaultPathStepStringifier_apply($this, $next);
        $direction = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($direction);
        $toNode = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($direction, $lArrow), $rt_s(399)), $stringifiedRel), $multiRel), $rt_s(400)), $rArrow);
        jl_AbstractStringBuilder_append($toNode, 40);
        $toNode = jl_StringBuilder_append($toNode, $stringifiedToNode);
        jl_AbstractStringBuilder_append($toNode, 41);
        jl_StringBuilder_append($toNode, $rel);
        return jl_AbstractStringBuilder_toString($direction);
    }
    var onciap_Prettifier$ClausePrettifier = $rt_classWithoutFields(0);
    var onciap_Prettifier$EmptyExtension$ = $rt_classWithoutFields();
    var onciap_Prettifier$EmptyExtension$_MODULE$ = null;
    function onciap_Prettifier$EmptyExtension$__clinit_() {
        onciap_Prettifier$EmptyExtension$_MODULE$ = new onciap_Prettifier$EmptyExtension$;
    }
    function onciap_Prettifier$EmptyExtension$_asString($this, $ctx) {
        return s_PartialFunction$_empty_pf;
    }
    var sc_AbstractSet = $rt_classWithoutFields(sc_AbstractIterable);
    function sc_AbstractSet_canEqual($this, $that) {
        return 1;
    }
    function sc_AbstractSet_equals($this, $that) {
        return sc_Set_equals$($this, $that);
    }
    function sc_AbstractSet_hashCode($this) {
        var var$1;
        suh_MurmurHash3$_$callClinit();
        var$1 = suh_MurmurHash3$_MODULE$;
        return suh_MurmurHash3_unorderedHash(var$1, $this, suh_MurmurHash3$_setSeed(var$1));
    }
    function sc_AbstractSet_stringPrefix($this) {
        return $rt_s(401);
    }
    function sc_AbstractSet_toString($this) {
        return sc_Iterable_toString$($this);
    }
    function sc_AbstractSet_apply($this, $elem) {
        return $this.$contains0($elem);
    }
    function sc_AbstractSet_subsetOf($this, $that) {
        return $this.$forall($that);
    }
    function sc_AbstractSet_intersect($this, $that) {
        return sc_SetOps_intersect$($this, $that);
    }
    function sc_AbstractSet_concat($this, $that) {
        var var$2, var$3;
        if ($this instanceof sci_Set$Set1 ? 1 : $this instanceof sci_Set$Set2 ? 1 : $this instanceof sci_Set$Set3 ? 1 : !($this instanceof sci_Set$Set4) ? 0 : 1) {
            var$2 = $this;
            $that = $that.$iterator0();
            while ($that.$hasNext()) {
                var$3 = $that.$next();
                if (var$2 === null)
                    $rt_throw(null);
                var$2 = var$2.$incl(var$3);
            }
        } else {
            if ($rt_isInstance($that, sc_Iterable))
                $that = sc_View$Concat__init_($this, $that);
            else {
                var$2 = $this.$iterator0();
                var$3 = new sc_SetOps$concat$lambda$_23_0;
                var$3.$_0154 = $that;
                $that = var$2.$concat(var$3);
            }
            var$2 = $this.$fromSpecific($that);
        }
        return var$2;
    }
    function sc_AbstractSet_$plus$plus($this, $that) {
        return $this.$concat1($that);
    }
    function sc_AbstractSet_union($this, $that) {
        return $this.$concat1($that);
    }
    function sc_AbstractSet_apply0($this, $v1) {
        return jl_Boolean_valueOf($this.$contains0($v1));
    }
    var sci_AbstractSet = $rt_classWithoutFields(sc_AbstractSet);
    function sci_AbstractSet_iterableFactory($this) {
        return sci_Set$_MODULE$;
    }
    function sci_AbstractSet_$plus($this, $elem) {
        return $this.$incl($elem);
    }
    function sci_AbstractSet_$minus($this, $elem) {
        return $this.$excl($elem);
    }
    function sci_AbstractSet_removedAll($this, $that) {
        return ($that.$iterator0()).$foldLeft($this, new sci_SetOps$removedAll$lambda$_9_0);
    }
    function sci_AbstractSet_$minus$minus($this, $that) {
        return $this.$removedAll0($that);
    }
    var sci_Set$EmptySet$ = $rt_classWithoutFields(sci_AbstractSet);
    var sci_Set$EmptySet$_MODULE$ = null;
    function sci_Set$EmptySet$__clinit_() {
        sci_Set$EmptySet$_MODULE$ = new sci_Set$EmptySet$;
    }
    function sci_Set$EmptySet$_size($this) {
        return 0;
    }
    function sci_Set$EmptySet$_isEmpty($this) {
        return 1;
    }
    function sci_Set$EmptySet$_knownSize($this) {
        return 0;
    }
    function sci_Set$EmptySet$_subsetOf($this, $that) {
        return 1;
    }
    function sci_Set$EmptySet$_contains($this, $elem) {
        return 0;
    }
    function sci_Set$EmptySet$_iterator($this) {
        return sc_Iterator$_scala$collection$Iterator$$_empty;
    }
    function sci_Set$EmptySet$_foreach($this, $f) {}
    function sci_Set$EmptySet$_excl($this, $elem) {
        return $this;
    }
    function sci_Set$EmptySet$_incl($this, $elem) {
        return sci_Set$Set1__init_($elem);
    }
    function sci_Set$EmptySet$_intersect($this, $that) {
        return $this;
    }
    function sci_Set$EmptySet$_removedAll($this, $that) {
        return $this;
    }
    function sci_Set$EmptySet$_filterNot($this, $pred) {
        return $this;
    }
    function sci_Set$EmptySet$_filter($this, $pred) {
        return $this;
    }
    var si_AnsiColor = $rt_classWithoutFields(0);
    var s_Console$ = $rt_classWithoutFields();
    var s_Console$_MODULE$ = null;
    var s_Console$_outVar = null;
    var s_Console$_errVar = null;
    var s_Console$_inVar = null;
    function s_Console$_$callClinit() {
        s_Console$_$callClinit = $rt_eraseClinit(s_Console$);
        s_Console$__clinit_();
    }
    function s_Console$__clinit_() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new s_Console$;
        s_Console$_$callClinit();
        s_Console$_MODULE$ = var$1;
        var$1 = new su_DynamicVariable;
        if (jl_System_outCache === null)
            jl_System_outCache = ji_PrintStream__init_(otcic_StdoutOutputStream_INSTANCE, 0);
        su_DynamicVariable__init_(var$1, jl_System_outCache);
        s_Console$_outVar = var$1;
        var$1 = new su_DynamicVariable;
        if (jl_System_errCache === null)
            jl_System_errCache = ji_PrintStream__init_(otcic_StderrOutputStream_INSTANCE, 0);
        su_DynamicVariable__init_(var$1, jl_System_errCache);
        s_Console$_errVar = var$1;
        var$2 = new su_DynamicVariable;
        var$3 = new ji_BufferedReader;
        var$1 = new ji_InputStreamReader;
        if (jl_System_inCache === null)
            jl_System_inCache = new jl_ConsoleInputStream;
        var$4 = jl_System_inCache;
        var$5 = jnci_UTF8Charset_INSTANCE;
        var$6 = new jnci_UTF8Decoder;
        var$6.$replacement0 = $rt_s(402);
        var$7 = jnc_CodingErrorAction_REPORT;
        var$6.$malformedAction = var$7;
        var$6.$unmappableAction = var$7;
        var$6.$charset = var$5;
        var$6.$averageCharsPerByte = 0.3333333432674408;
        var$6.$maxCharsPerByte = 0.5;
        var$6.$inArray = $rt_createByteArray(512);
        var$6.$outArray = $rt_createCharArray(512);
        var$5 = jnc_CodingErrorAction_REPLACE;
        if (var$5 === null) {
            var$2 = new jl_IllegalArgumentException;
            jl_Throwable__init_(var$2, $rt_s(403));
            $rt_throw(var$2);
        }
        var$6.$malformedAction = var$5;
        var$6.$unmappableAction = var$5;
        ji_Reader__init_(var$1);
        var$8 = $rt_createByteArray(8192);
        var$1.$inData = var$8;
        var$1.$inBuffer = jn_ByteBuffer_wrap(var$8);
        var$8 = $rt_createCharArray(1024);
        var$1.$outData = var$8;
        var$5 = jn_CharBuffer_wrap(var$8);
        var$1.$outBuffer = var$5;
        var$1.$stream = var$4;
        var$1.$decoder = var$6;
        jn_Buffer_position(var$5, var$5.$limit2);
        var$5 = var$1.$inBuffer;
        jn_Buffer_position(var$5, var$5.$limit2);
        ji_Reader__init_(var$3);
        var$3.$mark = (-1);
        var$3.$innerReader = var$1;
        var$3.$buffer1 = $rt_createCharArray(jl_Math_max(64, 1024));
        su_DynamicVariable__init_(var$2, var$3);
        s_Console$_inVar = var$2;
    }
    function s_Console$_out($this) {
        var var$1;
        s_Console$_$callClinit();
        var$1 = s_Console$_outVar.$tl;
        if (!var$1.$initialized) {
            var$1.$value16 = var$1.$$outer6.$scala$util$DynamicVariable$$init;
            var$1.$initialized = 1;
        }
        return var$1.$value16;
    }
    var jl_NullPointerException = $rt_classWithoutFields(jl_RuntimeException);
    var sc_Iterator = $rt_classWithoutFields(0);
    function sc_Iterator_contains$($$this, $elem) {
        var var$3;
        var$3 = new sc_Iterator$contains$lambda$_35_0;
        var$3.$_0155 = $elem;
        return $$this.$exists(var$3);
    }
    function sc_Iterator_grouped$($$this, $size) {
        return sc_Iterator$GroupedIterator__init_($$this, $$this, $size, $size);
    }
    function sc_Iterator_sliding$($$this, $size, $step) {
        return sc_Iterator$GroupedIterator__init_($$this, $$this, $size, $step);
    }
    function sc_Iterator_indexWhere$($$this, $p, $from) {
        var var$4;
        var$4 = jl_Math_max($from, 0);
        $$this = $$this.$drop1($from);
        a: {
            while (true) {
                if (!$$this.$hasNext()) {
                    var$4 = (-1);
                    break a;
                }
                if (sr_BoxesRunTime_unboxToBoolean(sc_SeqOps$indexOf$lambda$_58_0_apply($p, $$this.$next())))
                    break;
                var$4 = var$4 + 1 | 0;
            }
        }
        return var$4;
    }
    function sc_Iterator_isEmpty$($$this) {
        return $$this.$hasNext() ? 0 : 1;
    }
    function sc_Iterator_filter$($$this, $p) {
        return $$this.$filterImpl0($p, 0);
    }
    function sc_Iterator_filterImpl$($$this, $p, $isFlipped) {
        var var$4;
        var$4 = new sc_Iterator$$anon$6;
        if ($$this === null)
            $rt_throw(null);
        var$4.$$outer7 = $$this;
        var$4.$p$1 = $p;
        var$4.$isFlipped$1 = $isFlipped;
        var$4.$hdDefined = 0;
        return var$4;
    }
    function sc_Iterator_collect$($$this, $pf) {
        var var$3;
        var$3 = new sc_Iterator$$anon$7;
        if ($$this === null)
            $rt_throw(null);
        var$3.$$outer8 = $$this;
        var$3.$pf$1 = $pf;
        var$3.$status = 0;
        return var$3;
    }
    function sc_Iterator_distinctBy$($$this, $f) {
        var var$3;
        var$3 = new sc_Iterator$$anon$8;
        if ($$this === null)
            $rt_throw(null);
        var$3.$$outer9 = $$this;
        var$3.$f$1 = $f;
        var$3.$traversedValues = scm_HashSet__init_();
        var$3.$nextElementDefined = 0;
        return var$3;
    }
    function sc_Iterator_map$($$this, $f) {
        var var$3;
        var$3 = new sc_Iterator$$anon$9;
        if ($$this === null)
            $rt_throw(null);
        var$3.$$outer10 = $$this;
        var$3.$f$2 = $f;
        return var$3;
    }
    function sc_Iterator_flatMap$($$this, $f) {
        var var$3;
        var$3 = new sc_Iterator$$anon$10;
        if ($$this === null)
            $rt_throw(null);
        var$3.$$outer11 = $$this;
        var$3.$f$3 = $f;
        var$3.$cur = sc_Iterator$_scala$collection$Iterator$$_empty;
        var$3.$_hasNext = (-1);
        return var$3;
    }
    function sc_Iterator_concat$($$this, $xs) {
        var var$3;
        var$3 = new sc_Iterator$ConcatIterator;
        var$3.$current0 = $$this;
        var$3.$tail1 = null;
        var$3.$last0 = null;
        var$3.$currentHasNextChecked = 0;
        return sc_Iterator$ConcatIterator_concat(var$3, $xs);
    }
    function sc_Iterator_takeWhile$($$this, $p) {
        var var$3;
        var$3 = new sc_Iterator$$anon$11;
        var$3.$p$2 = $p;
        var$3.$hdDefined0 = 0;
        var$3.$tail2 = $$this;
        return var$3;
    }
    function sc_Iterator_drop$($$this, $n) {
        return $$this.$sliceIterator($n, (-1));
    }
    function sc_Iterator_dropWhile$($$this, $p) {
        var var$3;
        var$3 = new sc_Iterator$$anon$12;
        if ($$this === null)
            $rt_throw(null);
        var$3.$$outer12 = $$this;
        var$3.$p$3 = $p;
        var$3.$status0 = (-1);
        return var$3;
    }
    function sc_Iterator_sliceIterator$($$this, $from, $until) {
        var var$4;
        $from = jl_Math_max($from, 0);
        $until = $until < 0 ? (-1) : $until > $from ? $until - $from | 0 : 0;
        if (!$until)
            var$4 = sc_Iterator$_scala$collection$Iterator$$_empty;
        else {
            var$4 = new sc_Iterator$SliceIterator;
            var$4.$underlying7 = $$this;
            var$4.$scala$collection$Iterator$SliceIterator$$remaining = $until;
            var$4.$dropping = $from;
        }
        return var$4;
    }
    function sc_Iterator_sameElements$($$this, $that) {
        var var$3;
        $that = $that.$iterator0();
        a: {
            b: {
                while (true) {
                    if (!$$this.$hasNext())
                        break b;
                    if (!$that.$hasNext())
                        break b;
                    if (sr_BoxesRunTime_equals($$this.$next(), $that.$next()))
                        continue;
                    else
                        break;
                }
                var$3 = 0;
                break a;
            }
            if ($$this.$hasNext() != $that.$hasNext())
                var$3 = 0;
            else
                var$3 = 1;
        }
        return var$3;
    }
    var s_Function0 = $rt_classWithoutFields(0);
    function s_Function0_toString($this) {
        return $rt_s(404);
    }
    var srj_JFunction0$mcJ$sp = $rt_classWithoutFields(0);
    function srj_JFunction0$mcJ$sp_apply($this) {
        return jl_Long_valueOf($this.$apply$mcJ$sp());
    }
    var onciu_StepSequencer$$heuristicStepOrdering$lambda$_1_0 = $rt_classWithoutFields();
    function onciu_StepSequencer$$heuristicStepOrdering$lambda$_1_0_apply$mcJ$sp(var$0) {
        var var$1, var$2;
        if (!onciu_AssertionRunner_isAssertionsEnabled())
            var$1 = Long_fromInt(42);
        else {
            var$2 = (su_Random__init_(new ju_Random)).$self0;
            var$1 = Long_or(Long_shl(Long_fromInt(ju_Random_nextInt(var$2)), 32), Long_fromInt(ju_Random_nextInt(var$2)));
        }
        return var$1;
    }
    function su_Random() {
        jl_Object.call(this);
        this.$self0 = null;
    }
    function su_Random__init_(var_0) {
        var var_1 = new su_Random();
        su_Random__init_0(var_1, var_0);
        return var_1;
    }
    function su_Random__init_0($this, $self) {
        $this.$self0 = $self;
    }
    var sc_BuildFromLowPriority2 = $rt_classWithoutFields(0);
    var sc_BuildFromLowPriority1 = $rt_classWithoutFields(0);
    var sc_BuildFrom$ = $rt_classWithoutFields();
    var sc_BuildFrom$_MODULE$ = null;
    var sc_BuildFrom$_buildFromString = null;
    var sc_BuildFrom$_buildFromWrappedString = null;
    function sc_BuildFrom$__clinit_() {
        sc_BuildFrom$_MODULE$ = new sc_BuildFrom$;
        sc_BuildFrom$_buildFromString = new sc_BuildFrom$$anon$5;
        sc_BuildFrom$_buildFromWrappedString = new sc_BuildFrom$$anon$6;
    }
    function onciu_StepSequencer$$anonfun$heuristicStepOrdering$3() {
        var a = this; jl_Object.call(a);
        a.$numberOfTimesEachStepIsInvalidated$1 = null;
        a.$allStepsInRandomOrder$1 = null;
    }
    function onciu_StepSequencer$$anonfun$heuristicStepOrdering$3_compare($this, $x, $y) {
        var var$3, var$4, var$5;
        $x = $x;
        $y = $y;
        var$3 = $this.$numberOfTimesEachStepIsInvalidated$1;
        var$4 = $this.$allStepsInRandomOrder$1;
        var$5 = (($y.$invalidatedConditions()).$size() - ($x.$invalidatedConditions()).$size() | 0) + (sr_BoxesRunTime_unboxToInt(sc_AbstractMap_apply(var$3, $x)) - sr_BoxesRunTime_unboxToInt(sc_AbstractMap_apply(var$3, $y)) | 0) | 0;
        if (!var$5)
            var$5 = sc_AbstractSeq_indexOf0(var$4, $x) - sc_AbstractSeq_indexOf0(var$4, $y) | 0;
        return var$5;
    }
    var jl_AssertionError = $rt_classWithoutFields(jl_Error);
    function jl_AssertionError__init_(var_0) {
        var var_1 = new jl_AssertionError();
        jl_AssertionError__init_0(var_1, var_0);
        return var_1;
    }
    function jl_AssertionError__init_0($this, $message) {
        jl_Throwable__init_($this, jl_String_valueOf($message));
    }
    var jl_Math = $rt_classWithoutFields();
    function jl_Math_ceil(var$1) {
        return Math.ceil(var$1);
    }
    function jl_Math_min($a, $b) {
        if ($a < $b)
            $b = $a;
        return $b;
    }
    function jl_Math_max($a, $b) {
        if ($a > $b)
            $b = $a;
        return $b;
    }
    function jl_Math_max0($a, $b) {
        if (Long_gt($a, $b))
            $b = $a;
        return $b;
    }
    function jl_Math_abs($n) {
        if ($n <= 0)
            $n =  -$n | 0;
        return $n;
    }
    var ju_Arrays = $rt_classWithoutFields();
    function ju_Arrays_copyOf0($array, $length) {
        var $result, var$4, $sz, $i;
        $array = $array.data;
        $result = $rt_createCharArray($length);
        var$4 = $result.data;
        $sz = jl_Math_min($length, $array.length);
        $i = 0;
        while ($i < $sz) {
            var$4[$i] = $array[$i];
            $i = $i + 1 | 0;
        }
        return $result;
    }
    function ju_Arrays_copyOf1($array, $length) {
        var $result, var$4, $sz, $i;
        $array = $array.data;
        $result = $rt_createByteArray($length);
        var$4 = $result.data;
        $sz = jl_Math_min($length, $array.length);
        $i = 0;
        while ($i < $sz) {
            var$4[$i] = $array[$i];
            $i = $i + 1 | 0;
        }
        return $result;
    }
    function ju_Arrays_copyOf2($array, $length) {
        var $result, var$4, $sz, $i;
        $array = $array.data;
        $result = $rt_createIntArray($length);
        var$4 = $result.data;
        $sz = jl_Math_min($length, $array.length);
        $i = 0;
        while ($i < $sz) {
            var$4[$i] = $array[$i];
            $i = $i + 1 | 0;
        }
        return $result;
    }
    function ju_Arrays_copyOf($original, $newLength) {
        var var$3, $result, $sz, $i;
        var$3 = $original.data;
        $result = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($original)), $newLength);
        $sz = jl_Math_min($newLength, var$3.length);
        $i = 0;
        while ($i < $sz) {
            $result.data[$i] = var$3[$i];
            $i = $i + 1 | 0;
        }
        return $result;
    }
    function ju_Arrays_copyOfRange($original, $from, $to) {
        var var$4, $result, $i;
        var$4 = $original.data;
        $result = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($original)), $to - $from | 0);
        $i = $from;
        while ($i < $to) {
            $result.data[$i - $from | 0] = var$4[$i];
            $i = $i + 1 | 0;
        }
        return $result;
    }
    function ju_Arrays_fill0($a, $val) {
        var var$3, var$4, var$5, var$6;
        $a = $a.data;
        var$3 = 0;
        var$4 = $a.length;
        if (var$3 > var$4) {
            var$5 = new jl_IllegalArgumentException;
            jl_Throwable__init_0(var$5);
            $rt_throw(var$5);
        }
        while (var$3 < var$4) {
            var$6 = var$3 + 1 | 0;
            $a[var$3] = $val;
            var$3 = var$6;
        }
    }
    function ju_Arrays_fill($a, $fromIndex, $toIndex, $val) {
        var var$5, var$6;
        if ($fromIndex > $toIndex) {
            $val = new jl_IllegalArgumentException;
            jl_Throwable__init_0($val);
            $rt_throw($val);
        }
        while ($fromIndex < $toIndex) {
            var$5 = $a.data;
            var$6 = $fromIndex + 1 | 0;
            var$5[$fromIndex] = $val;
            $fromIndex = var$6;
        }
    }
    function ju_Arrays_fill1($a, $val) {
        ju_Arrays_fill($a, 0, $a.data.length, $val);
    }
    function ju_Arrays_sort0($a) {
        var var$2, $second, $chunkSize, var$5, $i, var$7, var$8, var$9, $i_0, var$11, var$12, var$13, var$14, var$15, var$16, var$17;
        var$2 = $a.data.length;
        if (!var$2)
            return;
        $second = $rt_createIntArray(var$2);
        $chunkSize = 1;
        var$5 = $a;
        while ($chunkSize < var$2) {
            $i = 0;
            while (true) {
                var$7 = var$5.data;
                var$8 = var$7.length;
                if ($i >= var$8)
                    break;
                var$9 = jl_Math_min(var$8, $i + $chunkSize | 0);
                $i_0 = $i + (2 * $chunkSize | 0) | 0;
                var$8 = jl_Math_min(var$8, $i_0);
                var$11 = $i;
                var$12 = var$9;
                a: {
                    b: {
                        while ($i != var$9) {
                            if (var$12 == var$8)
                                break b;
                            var$13 = var$7[$i];
                            var$14 = var$7[var$12];
                            if (var$13 > var$14) {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$14;
                                var$12 = var$12 + 1 | 0;
                            } else {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$13;
                                $i = $i + 1 | 0;
                            }
                            var$11 = var$16;
                        }
                        while (true) {
                            if (var$12 >= var$8)
                                break a;
                            var$15 = $second.data;
                            var$17 = var$11 + 1 | 0;
                            $i = var$12 + 1 | 0;
                            var$15[var$11] = var$7[var$12];
                            var$11 = var$17;
                            var$12 = $i;
                        }
                    }
                    while (true) {
                        if ($i >= var$9)
                            break a;
                        var$15 = $second.data;
                        var$17 = var$11 + 1 | 0;
                        var$8 = $i + 1 | 0;
                        var$15[var$11] = var$7[$i];
                        var$11 = var$17;
                        $i = var$8;
                    }
                }
                $i = $i_0;
            }
            $chunkSize = $chunkSize * 2 | 0;
            var$15 = var$5;
            var$5 = $second;
            $second = var$15;
        }
        c: {
            if (var$5 !== $a) {
                $i_0 = 0;
                while (true) {
                    $a = var$5.data;
                    if ($i_0 >= $a.length)
                        break c;
                    $second.data[$i_0] = $a[$i_0];
                    $i_0 = $i_0 + 1 | 0;
                }
            }
        }
    }
    function ju_Arrays_sort1($a) {
        var var$2, $second, $chunkSize, var$5, $i, var$7, var$8, var$9, $i_0, var$11, var$12, var$13, var$14, var$15, var$16;
        var$2 = $a.data.length;
        if (!var$2)
            return;
        $second = $rt_createLongArray(var$2);
        $chunkSize = 1;
        var$5 = $a;
        while ($chunkSize < var$2) {
            $i = 0;
            while (true) {
                var$7 = var$5.data;
                var$8 = var$7.length;
                if ($i >= var$8)
                    break;
                var$9 = jl_Math_min(var$8, $i + $chunkSize | 0);
                $i_0 = $i + (2 * $chunkSize | 0) | 0;
                var$8 = jl_Math_min(var$8, $i_0);
                var$11 = $i;
                var$12 = var$9;
                a: {
                    b: {
                        while ($i != var$9) {
                            if (var$12 == var$8)
                                break b;
                            var$13 = var$7[$i];
                            var$14 = var$7[var$12];
                            if (Long_gt(var$13, var$14)) {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$14;
                                var$12 = var$12 + 1 | 0;
                            } else {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$13;
                                $i = $i + 1 | 0;
                            }
                            var$11 = var$16;
                        }
                        while (true) {
                            if (var$12 >= var$8)
                                break a;
                            var$15 = $second.data;
                            var$16 = var$11 + 1 | 0;
                            $i = var$12 + 1 | 0;
                            var$15[var$11] = var$7[var$12];
                            var$11 = var$16;
                            var$12 = $i;
                        }
                    }
                    while (true) {
                        if ($i >= var$9)
                            break a;
                        var$15 = $second.data;
                        var$16 = var$11 + 1 | 0;
                        var$8 = $i + 1 | 0;
                        var$15[var$11] = var$7[$i];
                        var$11 = var$16;
                        $i = var$8;
                    }
                }
                $i = $i_0;
            }
            $chunkSize = $chunkSize * 2 | 0;
            var$15 = var$5;
            var$5 = $second;
            $second = var$15;
        }
        c: {
            if (var$5 !== $a) {
                $i_0 = 0;
                while (true) {
                    $a = var$5.data;
                    if ($i_0 >= $a.length)
                        break c;
                    $second.data[$i_0] = $a[$i_0];
                    $i_0 = $i_0 + 1 | 0;
                }
            }
        }
    }
    function ju_Arrays_sort2($a, $fromIndex, $toIndex) {
        var $subarray, var$5, $i, var$7, $i_0;
        $subarray = $rt_createShortArray($toIndex - $fromIndex | 0);
        var$5 = $subarray.data;
        $i = $fromIndex;
        while ($i < $toIndex) {
            var$7 = $a.data;
            var$5[$i - $fromIndex | 0] = var$7[$i];
            $i = $i + 1 | 0;
        }
        ju_Arrays_sort3($subarray);
        $i_0 = $fromIndex;
        while ($i_0 < $toIndex) {
            $a.data[$i_0] = var$5[$i_0 - $fromIndex | 0];
            $i_0 = $i_0 + 1 | 0;
        }
    }
    function ju_Arrays_sort3($a) {
        var var$2, $second, $chunkSize, var$5, $i, var$7, var$8, var$9, $i_0, var$11, var$12, var$13, var$14, var$15, var$16;
        var$2 = $a.data.length;
        if (!var$2)
            return;
        $second = $rt_createShortArray(var$2);
        $chunkSize = 1;
        var$5 = $a;
        while ($chunkSize < var$2) {
            $i = 0;
            while (true) {
                var$7 = var$5.data;
                var$8 = var$7.length;
                if ($i >= var$8)
                    break;
                var$9 = jl_Math_min(var$8, $i + $chunkSize | 0);
                $i_0 = $i + (2 * $chunkSize | 0) | 0;
                var$8 = jl_Math_min(var$8, $i_0);
                var$11 = $i;
                var$12 = var$9;
                a: {
                    b: {
                        while ($i != var$9) {
                            if (var$12 == var$8)
                                break b;
                            var$13 = var$7[$i];
                            var$14 = var$7[var$12];
                            if (var$13 > var$14) {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$14;
                                var$12 = var$12 + 1 | 0;
                            } else {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$13;
                                $i = $i + 1 | 0;
                            }
                            var$11 = var$16;
                        }
                        while (true) {
                            if (var$12 >= var$8)
                                break a;
                            var$15 = $second.data;
                            var$13 = var$11 + 1 | 0;
                            var$14 = var$12 + 1 | 0;
                            var$15[var$11] = var$7[var$12];
                            var$11 = var$13;
                            var$12 = var$14;
                        }
                    }
                    while (true) {
                        if ($i >= var$9)
                            break a;
                        var$15 = $second.data;
                        var$13 = var$11 + 1 | 0;
                        var$8 = $i + 1 | 0;
                        var$15[var$11] = var$7[$i];
                        var$11 = var$13;
                        $i = var$8;
                    }
                }
                $i = $i_0;
            }
            $chunkSize = $chunkSize * 2 | 0;
            var$15 = var$5;
            var$5 = $second;
            $second = var$15;
        }
        c: {
            if (var$5 !== $a) {
                $i_0 = 0;
                while (true) {
                    $a = var$5.data;
                    if ($i_0 >= $a.length)
                        break c;
                    $second.data[$i_0] = $a[$i_0];
                    $i_0 = $i_0 + 1 | 0;
                }
            }
        }
    }
    function ju_Arrays_sort4($a, $fromIndex, $toIndex) {
        var $subarray, var$5, $i, var$7, $i_0;
        $subarray = $rt_createCharArray($toIndex - $fromIndex | 0);
        var$5 = $subarray.data;
        $i = $fromIndex;
        while ($i < $toIndex) {
            var$7 = $a.data;
            var$5[$i - $fromIndex | 0] = var$7[$i];
            $i = $i + 1 | 0;
        }
        ju_Arrays_sort5($subarray);
        $i_0 = $fromIndex;
        while ($i_0 < $toIndex) {
            $a.data[$i_0] = var$5[$i_0 - $fromIndex | 0];
            $i_0 = $i_0 + 1 | 0;
        }
    }
    function ju_Arrays_sort5($a) {
        var var$2, $second, $chunkSize, var$5, $i, var$7, var$8, var$9, $i_0, var$11, var$12, var$13, var$14, var$15, var$16;
        var$2 = $a.data.length;
        if (!var$2)
            return;
        $second = $rt_createCharArray(var$2);
        $chunkSize = 1;
        var$5 = $a;
        while ($chunkSize < var$2) {
            $i = 0;
            while (true) {
                var$7 = var$5.data;
                var$8 = var$7.length;
                if ($i >= var$8)
                    break;
                var$9 = jl_Math_min(var$8, $i + $chunkSize | 0);
                $i_0 = $i + (2 * $chunkSize | 0) | 0;
                var$8 = jl_Math_min(var$8, $i_0);
                var$11 = $i;
                var$12 = var$9;
                a: {
                    b: {
                        while ($i != var$9) {
                            if (var$12 == var$8)
                                break b;
                            var$13 = var$7[$i];
                            var$14 = var$7[var$12];
                            if (var$13 > var$14) {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$14;
                                var$12 = var$12 + 1 | 0;
                            } else {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$13;
                                $i = $i + 1 | 0;
                            }
                            var$11 = var$16;
                        }
                        while (true) {
                            if (var$12 >= var$8)
                                break a;
                            var$15 = $second.data;
                            var$13 = var$11 + 1 | 0;
                            var$14 = var$12 + 1 | 0;
                            var$15[var$11] = var$7[var$12];
                            var$11 = var$13;
                            var$12 = var$14;
                        }
                    }
                    while (true) {
                        if ($i >= var$9)
                            break a;
                        var$15 = $second.data;
                        var$13 = var$11 + 1 | 0;
                        var$8 = $i + 1 | 0;
                        var$15[var$11] = var$7[$i];
                        var$11 = var$13;
                        $i = var$8;
                    }
                }
                $i = $i_0;
            }
            $chunkSize = $chunkSize * 2 | 0;
            var$15 = var$5;
            var$5 = $second;
            $second = var$15;
        }
        c: {
            if (var$5 !== $a) {
                $i_0 = 0;
                while (true) {
                    $a = var$5.data;
                    if ($i_0 >= $a.length)
                        break c;
                    $second.data[$i_0] = $a[$i_0];
                    $i_0 = $i_0 + 1 | 0;
                }
            }
        }
    }
    function ju_Arrays_sort6($a, $fromIndex, $toIndex) {
        var $subarray, var$5, $i, var$7, $i_0;
        $subarray = $rt_createByteArray($toIndex - $fromIndex | 0);
        var$5 = $subarray.data;
        $i = $fromIndex;
        while ($i < $toIndex) {
            var$7 = $a.data;
            var$5[$i - $fromIndex | 0] = var$7[$i];
            $i = $i + 1 | 0;
        }
        ju_Arrays_sort7($subarray);
        $i_0 = $fromIndex;
        while ($i_0 < $toIndex) {
            $a.data[$i_0] = var$5[$i_0 - $fromIndex | 0];
            $i_0 = $i_0 + 1 | 0;
        }
    }
    function ju_Arrays_sort7($a) {
        var var$2, $second, $chunkSize, var$5, $i, var$7, var$8, var$9, $i_0, var$11, var$12, var$13, var$14, var$15, var$16;
        var$2 = $a.data.length;
        if (!var$2)
            return;
        $second = $rt_createByteArray(var$2);
        $chunkSize = 1;
        var$5 = $a;
        while ($chunkSize < var$2) {
            $i = 0;
            while (true) {
                var$7 = var$5.data;
                var$8 = var$7.length;
                if ($i >= var$8)
                    break;
                var$9 = jl_Math_min(var$8, $i + $chunkSize | 0);
                $i_0 = $i + (2 * $chunkSize | 0) | 0;
                var$8 = jl_Math_min(var$8, $i_0);
                var$11 = $i;
                var$12 = var$9;
                a: {
                    b: {
                        while ($i != var$9) {
                            if (var$12 == var$8)
                                break b;
                            var$13 = var$7[$i];
                            var$14 = var$7[var$12];
                            if (var$13 > var$14) {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$14;
                                var$12 = var$12 + 1 | 0;
                            } else {
                                var$15 = $second.data;
                                var$16 = var$11 + 1 | 0;
                                var$15[var$11] = var$13;
                                $i = $i + 1 | 0;
                            }
                            var$11 = var$16;
                        }
                        while (true) {
                            if (var$12 >= var$8)
                                break a;
                            var$15 = $second.data;
                            var$13 = var$11 + 1 | 0;
                            var$14 = var$12 + 1 | 0;
                            var$15[var$11] = var$7[var$12];
                            var$11 = var$13;
                            var$12 = var$14;
                        }
                    }
                    while (true) {
                        if ($i >= var$9)
                            break a;
                        var$15 = $second.data;
                        var$13 = var$11 + 1 | 0;
                        var$8 = $i + 1 | 0;
                        var$15[var$11] = var$7[$i];
                        var$11 = var$13;
                        $i = var$8;
                    }
                }
                $i = $i_0;
            }
            $chunkSize = $chunkSize * 2 | 0;
            var$15 = var$5;
            var$5 = $second;
            $second = var$15;
        }
        c: {
            if (var$5 !== $a) {
                $i_0 = 0;
                while (true) {
                    $a = var$5.data;
                    if ($i_0 >= $a.length)
                        break c;
                    $second.data[$i_0] = $a[$i_0];
                    $i_0 = $i_0 + 1 | 0;
                }
            }
        }
    }
    function ju_Arrays_sort($a, $c) {
        var var$3, $second, $chunkSize, var$6, $i, var$8, var$9, var$10, $i_0, var$12, $i_1, var$14, var$15, var$16, var$17;
        var$3 = $a.data.length;
        if (!var$3)
            return;
        $second = $rt_createArray(jl_Object, var$3);
        $chunkSize = 1;
        var$6 = $a;
        while ($chunkSize < var$3) {
            $i = 0;
            while (true) {
                var$8 = var$6.data;
                var$9 = var$8.length;
                if ($i >= var$9)
                    break;
                var$10 = jl_Math_min(var$9, $i + $chunkSize | 0);
                $i_0 = $i + (2 * $chunkSize | 0) | 0;
                var$12 = jl_Math_min(var$9, $i_0);
                $i_1 = $i;
                var$9 = var$10;
                a: {
                    b: {
                        while ($i != var$10) {
                            if (var$9 == var$12)
                                break b;
                            var$14 = var$8[$i];
                            var$15 = var$8[var$9];
                            if ($c.$compare(var$14, var$15) > 0) {
                                var$16 = $second.data;
                                var$17 = $i_1 + 1 | 0;
                                var$16[$i_1] = var$15;
                                var$9 = var$9 + 1 | 0;
                            } else {
                                var$16 = $second.data;
                                var$17 = $i_1 + 1 | 0;
                                var$16[$i_1] = var$14;
                                $i = $i + 1 | 0;
                            }
                            $i_1 = var$17;
                        }
                        while (true) {
                            if (var$9 >= var$12)
                                break a;
                            var$16 = $second.data;
                            $i = $i_1 + 1 | 0;
                            var$17 = var$9 + 1 | 0;
                            var$16[$i_1] = var$8[var$9];
                            $i_1 = $i;
                            var$9 = var$17;
                        }
                    }
                    while (true) {
                        if ($i >= var$10)
                            break a;
                        var$16 = $second.data;
                        var$9 = $i_1 + 1 | 0;
                        var$17 = $i + 1 | 0;
                        var$16[$i_1] = var$8[$i];
                        $i_1 = var$9;
                        $i = var$17;
                    }
                }
                $i = $i_0;
            }
            $chunkSize = $chunkSize * 2 | 0;
            var$8 = var$6;
            var$6 = $second;
            $second = var$8;
        }
        c: {
            if (var$6 !== $a) {
                $i_1 = 0;
                while (true) {
                    $a = var$6.data;
                    if ($i_1 >= $a.length)
                        break c;
                    $second.data[$i_1] = $a[$i_1];
                    $i_1 = $i_1 + 1 | 0;
                }
            }
        }
    }
    function ju_Arrays_binarySearch($a, $key) {
        var var$3, var$4, var$5, var$6, var$7;
        $a = $a.data;
        var$3 = 0;
        var$4 = $a.length;
        var$5 = $rt_compare(var$3, var$4);
        if (var$5 > 0) {
            var$6 = new jl_IllegalArgumentException;
            jl_Throwable__init_0(var$6);
            $rt_throw(var$6);
        }
        a: {
            if (!var$5)
                var$4 = (-1);
            else {
                var$5 = var$4 - 1 | 0;
                while (true) {
                    var$4 = (var$3 + var$5 | 0) / 2 | 0;
                    var$7 = $a[var$4];
                    if (var$7 == $key)
                        break;
                    if ($key >= var$7) {
                        var$3 = var$4 + 1 | 0;
                        if (var$3 > var$5) {
                            var$4 = ( -var$4 | 0) - 2 | 0;
                            break a;
                        }
                    } else {
                        var$5 = var$4 - 1 | 0;
                        if (var$5 < var$3) {
                            var$4 = ( -var$4 | 0) - 1 | 0;
                            break a;
                        }
                    }
                }
            }
        }
        return var$4;
    }
    function ju_Arrays_equals($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if (Long_ne($a[$i], $a2[$i]))
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_equals0($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if ($a[$i] != $a2[$i])
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_equals1($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if ($a[$i] != $a2[$i])
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_equals2($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if ($a[$i] != $a2[$i])
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_equals3($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if ($a[$i] != $a2[$i])
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_equals4($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if ($a[$i] !== $a2[$i])
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_equals5($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if ($a[$i] !== $a2[$i])
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_equals6($a, $a2) {
        var var$3, $i;
        if ($a === $a2)
            return 1;
        if ($a !== null && $a2 !== null) {
            $a2 = $a2.data;
            $a = $a.data;
            var$3 = $a.length;
            if (var$3 == $a2.length) {
                $i = 0;
                while ($i < var$3) {
                    if ($a[$i] != $a2[$i])
                        return 0;
                    $i = $i + 1 | 0;
                }
                return 1;
            }
        }
        return 0;
    }
    function ju_Arrays_hashCode($a) {
        var $hash, $i, var$4, var$5, $h;
        if ($a === null)
            return 0;
        $hash = (-1515898884);
        $i = 0;
        while (true) {
            var$4 = $a.data;
            if ($i >= var$4.length)
                break;
            var$5 = var$4[$i];
            $h = (var$5 !== null ? var$5.$hashCode0() : 0) ^ 528111840;
            $hash = jl_Integer_rotateLeft($h, 4) ^ ($h >>> 7 | $h << 25) ^ jl_Integer_rotateLeft($hash, 13);
            $i = $i + 1 | 0;
        }
        return $hash;
    }
    function jl_Object$Monitor() {
        var a = this; jl_Object.call(a);
        a.$enteringThreads = null;
        a.$notifyListeners = null;
        a.$owner = null;
        a.$count = 0;
    }
    var jl_Runnable = $rt_classWithoutFields(0);
    function jl_Thread() {
        var a = this; jl_Object.call(a);
        a.$id0 = Long_ZERO;
        a.$timeSliceStart = Long_ZERO;
        a.$finishedLock = null;
        a.$name14 = null;
        a.$alive = 0;
        a.$target = null;
    }
    var jl_Thread_mainThread = null;
    var jl_Thread_currentThread0 = null;
    var jl_Thread_nextId = 0;
    var jl_Thread_activeCount = 0;
    var jl_Thread_defaultUncaughtExceptionHandler = null;
    function jl_Thread_$callClinit() {
        jl_Thread_$callClinit = $rt_eraseClinit(jl_Thread);
        jl_Thread__clinit_();
    }
    function jl_Thread_setCurrentThread($thread_0) {
        jl_Thread_$callClinit();
        if (jl_Thread_currentThread0 !== $thread_0)
            jl_Thread_currentThread0 = $thread_0;
        jl_Thread_currentThread0.$timeSliceStart = jl_System_currentTimeMillis();
    }
    function jl_Thread_currentThread() {
        jl_Thread_$callClinit();
        return jl_Thread_currentThread0;
    }
    function jl_Thread__clinit_() {
        var var$1, var$2, var$3;
        var$1 = new jl_Thread;
        jl_Thread_$callClinit();
        var$2 = null;
        var$1.$finishedLock = new jl_Object;
        var$1.$alive = 1;
        var$1.$name14 = $rt_s(405);
        var$1.$target = var$2;
        var$3 = jl_Thread_nextId;
        jl_Thread_nextId = var$3 + 1 | 0;
        var$1.$id0 = Long_fromInt(var$3);
        jl_Thread_mainThread = var$1;
        jl_Thread_currentThread0 = var$1;
        jl_Thread_nextId = 1;
        jl_Thread_activeCount = 1;
        jl_Thread_defaultUncaughtExceptionHandler = new jl_DefaultUncaughtExceptionHandler;
    }
    var jl_IllegalMonitorStateException = $rt_classWithoutFields(jl_RuntimeException);
    function jl_Long() {
        jl_Number.call(this);
        this.$value2 = Long_ZERO;
    }
    var jl_Long_TYPE = null;
    function jl_Long_valueOf($value) {
        var var$2;
        var$2 = new jl_Long;
        var$2.$value2 = $value;
        return var$2;
    }
    function jl_Long_parseLong($s) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        if ($s !== null && !jl_String_isEmpty($s)) {
            a: {
                var$2 = 0;
                var$3 = 0;
                switch (jl_String_charAt($s, 0)) {
                    case 43:
                        var$3 = 1;
                        break a;
                    case 45:
                        var$2 = 1;
                        var$3 = 1;
                        break a;
                    default:
                }
            }
            var$4 = Long_ZERO;
            b: {
                c: {
                    while (var$3 < jl_String_length($s)) {
                        var$5 = var$3 + 1 | 0;
                        var$6 = jl_Character_getNumericValue(jl_String_charAt($s, var$3));
                        if (var$6 < 0) {
                            var$7 = new jl_NumberFormatException;
                            var$8 = new jl_StringBuilder;
                            jl_AbstractStringBuilder__init_(var$8);
                            jl_StringBuilder_append(jl_StringBuilder_append(var$8, $rt_s(8)), $s);
                            jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$8));
                            $rt_throw(var$7);
                        }
                        if (var$6 >= 10) {
                            var$7 = new jl_NumberFormatException;
                            var$8 = new jl_StringBuilder;
                            jl_AbstractStringBuilder__init_(var$8);
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$8, $rt_s(9)), 10), $rt_s(10)), $s);
                            jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$8));
                            $rt_throw(var$7);
                        }
                        var$4 = Long_add(Long_mul(Long_fromInt(10), var$4), Long_fromInt(var$6));
                        if (Long_lt(var$4, Long_ZERO)) {
                            if (var$5 != jl_String_length($s))
                                break b;
                            if (Long_ne(var$4, Long_create(0, 2147483648)))
                                break b;
                            if (!var$2)
                                break b;
                            var$4 = Long_create(0, 2147483648);
                            break c;
                        }
                        var$3 = var$5;
                    }
                    if (var$2)
                        var$4 = Long_neg(var$4);
                }
                return var$4;
            }
            var$7 = new jl_NumberFormatException;
            var$8 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$8);
            jl_StringBuilder_append(jl_StringBuilder_append(var$8, $rt_s(11)), $s);
            jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$8));
            $rt_throw(var$7);
        }
        $s = new jl_NumberFormatException;
        jl_Throwable__init_($s, $rt_s(12));
        $rt_throw($s);
    }
    function jl_Long_decode($nm) {
        var $index, $negaive, $radix, $value, var$6, $digit, var$8;
        if ($nm !== null && !jl_String_isEmpty($nm)) {
            $index = 0;
            $negaive = 0;
            if (jl_String_charAt($nm, $index) == 43)
                $index = 1;
            else if (jl_String_charAt($nm, $index) == 45) {
                $index = 1;
                $negaive = 1;
            }
            if ($index >= jl_String_length($nm)) {
                $nm = new jl_NumberFormatException;
                jl_Throwable__init_($nm, $rt_s(406));
                $rt_throw($nm);
            }
            $radix = 10;
            if (jl_String_charAt($nm, $index) == 35) {
                $radix = 16;
                $index = $index + 1 | 0;
            } else if (jl_String_charAt($nm, $index) == 48) {
                $index = $index + 1 | 0;
                if ($index == jl_String_length($nm))
                    return jl_Long_valueOf(Long_ZERO);
                if (jl_String_charAt($nm, $index) != 120 && jl_String_charAt($nm, $index) != 88)
                    $radix = 8;
                else {
                    $radix = 16;
                    $index = $index + 1 | 0;
                }
            }
            if ($index >= jl_String_length($nm)) {
                $nm = new jl_NumberFormatException;
                jl_Throwable__init_($nm, $rt_s(406));
                $rt_throw($nm);
            }
            $value = Long_ZERO;
            while ($index < jl_String_length($nm)) {
                var$6 = $index + 1 | 0;
                $digit = jl_String_charAt($nm, $index);
                $digit = $digit >= 48 && $digit <= 57 ? $digit - 48 | 0 : $digit >= 97 && $digit <= 122 ? ($digit - 97 | 0) + 10 | 0 : $digit >= 65 && $digit <= 90 ? ($digit - 65 | 0) + 10 | 0 : 255;
                if ($digit >= $radix) {
                    $nm = new jl_NumberFormatException;
                    jl_Throwable__init_($nm, $rt_s(406));
                    $rt_throw($nm);
                }
                $value = Long_add(Long_mul($value, Long_fromInt($radix)), Long_fromInt($digit));
                if (Long_lt($value, Long_ZERO)) {
                    if ($negaive && Long_eq($value, Long_create(0, 2147483648)) && var$6 == jl_String_length($nm))
                        return jl_Long_valueOf(Long_create(0, 2147483648));
                    $nm = new jl_NumberFormatException;
                    jl_Throwable__init_($nm, $rt_s(407));
                    $rt_throw($nm);
                }
                $index = var$6;
            }
            if ($negaive)
                $value = Long_neg($value);
            return jl_Long_valueOf($value);
        }
        var$8 = new jl_NumberFormatException;
        jl_Throwable__init_(var$8, $rt_s(408));
        $rt_throw(var$8);
    }
    function jl_Long_intValue($this) {
        return Long_lo($this.$value2);
    }
    function jl_Long_longValue($this) {
        return $this.$value2;
    }
    function jl_Long_floatValue($this) {
        return Long_toNumber($this.$value2);
    }
    function jl_Long_doubleValue($this) {
        return Long_toNumber($this.$value2);
    }
    function jl_Long_toString($value) {
        var var$2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append2(var$2, $value));
    }
    function jl_Long_toString0($this) {
        return jl_Long_toString($this.$value2);
    }
    function jl_Long_hashCode0($this) {
        return jl_Long_hashCode($this.$value2);
    }
    function jl_Long_hashCode($value) {
        return Long_lo($value) ^ Long_hi($value);
    }
    function jl_Long_equals($this, $other) {
        if ($this === $other)
            return 1;
        return $other instanceof jl_Long && Long_eq($other.$value2, $this.$value2) ? 1 : 0;
    }
    function jl_Long_divideUnsigned(var$1, var$2) {
        return Long_udiv(var$1, var$2);
    }
    function jl_Long_remainderUnsigned(var$1, var$2) {
        return Long_urem(var$1, var$2);
    }
    function jl_Long__clinit_() {
        jl_Long_TYPE = $rt_cls($rt_longcls());
    }
    var ju_Random = $rt_classWithoutFields();
    function ju_Random_nextInt($this) {
        return ju_Random_nextDouble($this) * 4.294967295E9 + (-2.147483648E9) | 0;
    }
    function ju_Random_nextDouble($this) {
        return $rt_globals.Math.random();
    }
    function s_PartialFunction$OrElse() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$f10 = null;
        a.$f20 = null;
    }
    function s_PartialFunction$OrElse_apply($this, $x) {
        return $this.$f10.$applyOrElse($x, $this.$f20);
    }
    function s_PartialFunction$OrElse_applyOrElse($this, $x, $default) {
        var $z;
        $z = $this.$f10.$applyOrElse($x, s_PartialFunction$_fallback_fn);
        if (!s_PartialFunction$_scala$PartialFunction$$fallbackOccurred(s_PartialFunction$_MODULE$, $z))
            return $z;
        return $x;
    }
    function su_DynamicVariable() {
        var a = this; jl_Object.call(a);
        a.$scala$util$DynamicVariable$$init = null;
        a.$tl = null;
    }
    function su_DynamicVariable__init_0(var_0) {
        var var_1 = new su_DynamicVariable();
        su_DynamicVariable__init_(var_1, var_0);
        return var_1;
    }
    function su_DynamicVariable__init_($this, $init) {
        $this.$scala$util$DynamicVariable$$init = $init;
        $init = new su_DynamicVariable$$anon$1;
        $init.$$outer6 = $this;
        $this.$tl = $init;
    }
    var jl_AutoCloseable = $rt_classWithoutFields(0);
    var ji_Closeable = $rt_classWithoutFields(0);
    function ji_Reader() {
        jl_Object.call(this);
        this.$lock = null;
    }
    function ji_Reader__init_($this) {
        $this.$lock = new jl_Object;
    }
    function ji_BufferedReader() {
        var a = this; ji_Reader.call(a);
        a.$innerReader = null;
        a.$buffer1 = null;
        a.$mark = 0;
    }
    function ji_InputStreamReader() {
        var a = this; ji_Reader.call(a);
        a.$stream = null;
        a.$decoder = null;
        a.$inData = null;
        a.$inBuffer = null;
        a.$outData = null;
        a.$outBuffer = null;
    }
    var otj_JSObject = $rt_classWithoutFields(0);
    var otp_PlatformQueue = $rt_classWithoutFields();
    function otp_PlatformQueue_isEmpty$static($this) {
        return $this.length ? 0 : 1;
    }
    var otp_PlatformRunnable = $rt_classWithoutFields(0);
    function jl_Object$monitorExit$lambda$_8_0() {
        jl_Object.call(this);
        this.$_00 = null;
    }
    var scm_HashSet$ = $rt_classWithoutFields();
    var scm_HashSet$_MODULE$ = null;
    function scm_HashSet$__clinit_() {
        scm_HashSet$_MODULE$ = new scm_HashSet$;
    }
    function scm_HashSet$_newBuilder($this) {
        var var$1;
        var$1 = new scm_HashSet$$anon$4;
        scm_GrowableBuilder__init_(var$1, scm_HashSet__init_0(16, 0.75));
        return var$1;
    }
    function scm_HashSet$_empty($this) {
        return scm_HashSet__init_();
    }
    function scm_HashSet$_from($this, $source) {
        var var$2;
        var$2 = $source.$knownSize();
        return scm_HashSet_addAll(scm_HashSet__init_0(var$2 <= 0 ? 16 : (var$2 + 1 | 0) / 0.75 | 0, 0.75), $source);
    }
    var scm_TreeSet$ = $rt_classWithoutFields();
    var scm_TreeSet$_MODULE$ = null;
    function scm_TreeSet$__clinit_() {
        scm_TreeSet$_MODULE$ = new scm_TreeSet$;
    }
    function scm_TreeSet$_from($this, $it, $evidence$5) {
        var var$3, var$4, var$5;
        a: {
            b: {
                if ($it instanceof scm_TreeSet) {
                    c: {
                        var$3 = $it;
                        var$4 = var$3.$ordering;
                        if ($evidence$5 !== null) {
                            if (!jl_Object_equals($evidence$5, var$4))
                                break b;
                            else
                                break c;
                        }
                        if (var$4 !== null)
                            break b;
                    }
                    $it = new scm_TreeSet;
                    var$5 = var$3.$scala$collection$mutable$TreeSet$$tree;
                    scm_TreeSet__init_($it, scm_RedBlackTree$Tree__init_(scm_RedBlackTree$_copyTree(scm_RedBlackTree$_MODULE$, var$5.$root0), var$5.$size3), $evidence$5);
                    break a;
                }
            }
            d: {
                if ($rt_isInstance($it, sc_SortedSet)) {
                    e: {
                        var$3 = $it;
                        var$4 = var$3.$ordering;
                        if ($evidence$5 !== null) {
                            if (!jl_Object_equals($evidence$5, var$4))
                                break d;
                            else
                                break e;
                        }
                        if (var$4 !== null)
                            break d;
                    }
                    $it = scm_TreeSet__init_0(scm_RedBlackTree$_fromOrderedKeys(scm_RedBlackTree$_MODULE$, scm_TreeSet_iterator(var$3), scm_TreeSet_size(var$3)), $evidence$5);
                    break a;
                }
            }
            f: {
                if ($it instanceof sci_Range) {
                    var$3 = $it;
                    sm_Ordering$Int$_$callClinit();
                    var$4 = sm_Ordering$Int$_MODULE$;
                    if ($evidence$5 === var$4)
                        break f;
                    if ($evidence$5 === sm_Ordering$Int$_scala$math$Ordering$CachedReverse$$_reverse)
                        break f;
                }
                var$3 = scm_RedBlackTree$Tree$_empty(scm_RedBlackTree$Tree$_MODULE$);
                $it = $it.$iterator0();
                while ($it.$hasNext()) {
                    scm_RedBlackTree$_insert(scm_RedBlackTree$_MODULE$, var$3, $it.$next(), null, $evidence$5);
                }
                $it = scm_TreeSet__init_0(var$3, $evidence$5);
                break a;
            }
            var$4 = ($evidence$5 !== var$4 ? 0 : 1) != (var$3.$step1() <= 0 ? 0 : 1) ? sc_IndexedSeqOps_reverseIterator$(var$3) : sci_Range_iterator(var$3);
            $it = scm_TreeSet__init_0(scm_RedBlackTree$_fromOrderedKeys(scm_RedBlackTree$_MODULE$, var$4, var$3.$length()), $evidence$5);
        }
        return $it;
    }
    var sc_BuildFrom = $rt_classWithoutFields(0);
    var sc_BuildFrom$$anon$5 = $rt_classWithoutFields();
    var sc_BuildFrom$$anon$6 = $rt_classWithoutFields();
    var ji_Flushable = $rt_classWithoutFields(0);
    var ji_OutputStream = $rt_classWithoutFields();
    function ji_FilterOutputStream() {
        ji_OutputStream.call(this);
        this.$out1 = null;
    }
    function ji_PrintStream() {
        var a = this; ji_FilterOutputStream.call(a);
        a.$autoFlush = 0;
        a.$errorState = 0;
        a.$sb = null;
        a.$buffer0 = null;
        a.$charset0 = null;
    }
    function ji_PrintStream__init_(var_0, var_1) {
        var var_2 = new ji_PrintStream();
        ji_PrintStream__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function ji_PrintStream__init_0($this, $out, $autoFlush) {
        $this.$out1 = $out;
        $out = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($out);
        $this.$sb = $out;
        $this.$buffer0 = $rt_createCharArray(32);
        $this.$autoFlush = $autoFlush;
        $this.$charset0 = jnci_UTF8Charset_INSTANCE;
    }
    function ji_PrintStream_write($this, $b, $off, $len) {
        var var$4, $$je;
        var$4 = $this.$out1;
        if (var$4 === null)
            $this.$errorState = 1;
        if (!($this.$errorState ? 0 : 1))
            return;
        a: {
            try {
                var$4.$write0($b, $off, $len);
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            $this.$errorState = 1;
        }
    }
    function ji_PrintStream_print($this, $s, $begin, $end) {
        var $destBytes, $src, $dest, $encoder, $overflow;
        $destBytes = $s.data;
        $src = jn_CharBuffer_wrap0($s, $begin, $end - $begin | 0);
        $destBytes = $rt_createByteArray(jl_Math_max(16, jl_Math_min($destBytes.length, 1024)));
        $dest = jn_ByteBuffer_wrap($destBytes);
        $encoder = jnc_CharsetEncoder_onUnmappableCharacter(jnc_CharsetEncoder_onMalformedInput(jnci_UTF8Charset_newEncoder($this.$charset0), jnc_CodingErrorAction_REPLACE), jnc_CodingErrorAction_REPLACE);
        while (true) {
            $overflow = jnc_CoderResult_isOverflow(jnc_CharsetEncoder_encode($encoder, $src, $dest, 1));
            ji_PrintStream_write($this, $destBytes, 0, $dest.$position9);
            jn_ByteBuffer_clear($dest);
            if (!$overflow)
                break;
        }
        while (true) {
            $overflow = jnc_CoderResult_isOverflow(jnc_CharsetEncoder_flush($encoder, $dest));
            ji_PrintStream_write($this, $destBytes, 0, $dest.$position9);
            jn_ByteBuffer_clear($dest);
            if (!$overflow)
                break;
        }
    }
    function otcic_ConsoleOutputStream() {
        ji_OutputStream.call(this);
        this.$buffer2 = null;
    }
    function otcic_ConsoleOutputStream__init_($this) {
        $this.$buffer2 = $rt_createByteArray(1);
    }
    var otcic_StdoutOutputStream = $rt_classWithoutFields(otcic_ConsoleOutputStream);
    var otcic_StdoutOutputStream_INSTANCE = null;
    function otcic_StdoutOutputStream_write($this, $b, $off, $len) {
        var var$4;
        var$4 = 0;
        while (var$4 < $len) {
            $rt_putStdout($b.data[var$4 + $off | 0] & 255);
            var$4 = var$4 + 1 | 0;
        }
    }
    function otcic_StdoutOutputStream__clinit_() {
        var var$1;
        var$1 = new otcic_StdoutOutputStream;
        otcic_ConsoleOutputStream__init_(var$1);
        otcic_StdoutOutputStream_INSTANCE = var$1;
    }
    function jl_ThreadLocal() {
        var a = this; jl_Object.call(a);
        a.$initialized = 0;
        a.$value16 = null;
    }
    var jl_InheritableThreadLocal = $rt_classWithoutFields(jl_ThreadLocal);
    function su_DynamicVariable$$anon$1() {
        jl_InheritableThreadLocal.call(this);
        this.$$outer6 = null;
    }
    var otcic_StderrOutputStream = $rt_classWithoutFields(otcic_ConsoleOutputStream);
    var otcic_StderrOutputStream_INSTANCE = null;
    function otcic_StderrOutputStream_write($this, $b, $off, $len) {
        var var$4;
        var$4 = 0;
        while (var$4 < $len) {
            $rt_putStderr($b.data[var$4 + $off | 0] & 255);
            var$4 = var$4 + 1 | 0;
        }
    }
    function otcic_StderrOutputStream__clinit_() {
        var var$1;
        var$1 = new otcic_StderrOutputStream;
        otcic_ConsoleOutputStream__init_(var$1);
        otcic_StderrOutputStream_INSTANCE = var$1;
    }
    var ji_InputStream = $rt_classWithoutFields();
    var jl_ConsoleInputStream = $rt_classWithoutFields(ji_InputStream);
    function jnc_Charset() {
        var a = this; jl_Object.call(a);
        a.$canonicalName = null;
        a.$aliases = null;
    }
    function jnc_Charset__init_($this, $canonicalName, $aliases) {
        var var$3, var$4, var$5;
        var$3 = $aliases.data;
        jnc_Charset_checkCanonicalName($canonicalName);
        var$4 = var$3.length;
        var$5 = 0;
        while (var$5 < var$4) {
            jnc_Charset_checkCanonicalName(var$3[var$5]);
            var$5 = var$5 + 1 | 0;
        }
        $this.$canonicalName = $canonicalName;
        $this.$aliases = $aliases.$clone();
    }
    function jnc_Charset_checkCanonicalName($name) {
        var $i, $c;
        if (jl_String_isEmpty($name))
            $rt_throw(jnc_IllegalCharsetNameException__init_($name));
        if (!jnc_Charset_isValidCharsetStart(jl_String_charAt($name, 0)))
            $rt_throw(jnc_IllegalCharsetNameException__init_($name));
        $i = 1;
        while ($i < jl_String_length($name)) {
            a: {
                $c = jl_String_charAt($name, $i);
                switch ($c) {
                    case 43:
                    case 45:
                    case 46:
                    case 58:
                    case 95:
                        break;
                    default:
                        if (jnc_Charset_isValidCharsetStart($c))
                            break a;
                        else
                            $rt_throw(jnc_IllegalCharsetNameException__init_($name));
                }
            }
            $i = $i + 1 | 0;
        }
    }
    function jnc_Charset_isValidCharsetStart($c) {
        a: {
            b: {
                if (!($c >= 48 && $c <= 57) && !($c >= 97 && $c <= 122)) {
                    if ($c < 65)
                        break b;
                    if ($c > 90)
                        break b;
                }
                $c = 1;
                break a;
            }
            $c = 0;
        }
        return $c;
    }
    var jnci_UTF8Charset = $rt_classWithoutFields(jnc_Charset);
    var jnci_UTF8Charset_INSTANCE = null;
    function jnci_UTF8Charset_newEncoder($this) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = new jnci_UTF8Encoder;
        var$2 = $rt_createByteArray(1);
        var$3 = var$2.data;
        var$3[0] = 63;
        var$4 = jnc_CodingErrorAction_REPORT;
        var$1.$malformedAction0 = var$4;
        var$1.$unmappableAction0 = var$4;
        var$5 = var$3.length;
        if (var$5 && var$5 >= var$1.$maxBytesPerChar) {
            var$1.$charset1 = $this;
            var$1.$replacement1 = var$2.$clone();
            var$1.$averageBytesPerChar = 2.0;
            var$1.$maxBytesPerChar = 4.0;
            var$1.$inArray0 = $rt_createCharArray(512);
            var$1.$outArray0 = $rt_createByteArray(512);
            return var$1;
        }
        var$4 = new jl_IllegalArgumentException;
        jl_Throwable__init_(var$4, $rt_s(409));
        $rt_throw(var$4);
    }
    function jnci_UTF8Charset__clinit_() {
        var var$1;
        var$1 = new jnci_UTF8Charset;
        jnc_Charset__init_(var$1, $rt_s(410), $rt_createArray(jl_String, 0));
        jnci_UTF8Charset_INSTANCE = var$1;
    }
    var oti_AsyncCallback = $rt_classWithoutFields(0);
    function otpp_AsyncCallbackWrapper() {
        jl_Object.call(this);
        this.$realAsyncCallback = null;
    }
    function otpp_AsyncCallbackWrapper_create($realAsyncCallback) {
        var var$2;
        var$2 = new otpp_AsyncCallbackWrapper;
        var$2.$realAsyncCallback = $realAsyncCallback;
        return var$2;
    }
    function otpp_AsyncCallbackWrapper_complete($this, $result) {
        $this.$realAsyncCallback.$complete($result);
    }
    function otpp_AsyncCallbackWrapper_error($this, $e) {
        $this.$realAsyncCallback.$error($e);
    }
    function jl_Object$monitorEnterWait$lambda$_6_0() {
        var a = this; jl_Object.call(a);
        a.$_0 = null;
        a.$_1 = null;
        a.$_2 = 0;
        a.$_3 = null;
    }
    var jl_Thread$UncaughtExceptionHandler = $rt_classWithoutFields(0);
    var jl_DefaultUncaughtExceptionHandler = $rt_classWithoutFields();
    function jnc_CodingErrorAction() {
        jl_Object.call(this);
        this.$name15 = null;
    }
    var jnc_CodingErrorAction_IGNORE = null;
    var jnc_CodingErrorAction_REPLACE = null;
    var jnc_CodingErrorAction_REPORT = null;
    function jnc_CodingErrorAction__init_(var_0) {
        var var_1 = new jnc_CodingErrorAction();
        jnc_CodingErrorAction__init_0(var_1, var_0);
        return var_1;
    }
    function jnc_CodingErrorAction__init_0($this, $name) {
        $this.$name15 = $name;
    }
    function jnc_CodingErrorAction__clinit_() {
        jnc_CodingErrorAction_IGNORE = jnc_CodingErrorAction__init_($rt_s(411));
        jnc_CodingErrorAction_REPLACE = jnc_CodingErrorAction__init_($rt_s(412));
        jnc_CodingErrorAction_REPORT = jnc_CodingErrorAction__init_($rt_s(413));
    }
    function jnc_CharsetDecoder() {
        var a = this; jl_Object.call(a);
        a.$charset = null;
        a.$averageCharsPerByte = 0.0;
        a.$maxCharsPerByte = 0.0;
        a.$replacement0 = null;
        a.$malformedAction = null;
        a.$unmappableAction = null;
    }
    function jn_Buffer() {
        var a = this; jl_Object.call(a);
        a.$capacity = 0;
        a.$position9 = 0;
        a.$limit2 = 0;
        a.$mark0 = 0;
    }
    function jn_Buffer__init_($this, $capacity) {
        $this.$mark0 = (-1);
        $this.$capacity = $capacity;
        $this.$limit2 = $capacity;
    }
    function jn_Buffer_position($this, $newPosition) {
        var var$2, var$3, var$4;
        if ($newPosition >= 0 && $newPosition <= $this.$limit2) {
            $this.$position9 = $newPosition;
            if ($newPosition < $this.$mark0)
                $this.$mark0 = 0;
            return $this;
        }
        var$2 = new jl_IllegalArgumentException;
        var$3 = $this.$limit2;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$4, $rt_s(414)), $newPosition), $rt_s(415)), var$3), 93);
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$4));
        $rt_throw(var$2);
    }
    function jn_Buffer_remaining($this) {
        return $this.$limit2 - $this.$position9 | 0;
    }
    function jn_Buffer_hasRemaining($this) {
        return $this.$position9 >= $this.$limit2 ? 0 : 1;
    }
    function jn_ByteBuffer() {
        var a = this; jn_Buffer.call(a);
        a.$start2 = 0;
        a.$array1 = null;
        a.$order = null;
    }
    function jn_ByteBuffer_allocate($capacity) {
        var var$2, var$3;
        if ($capacity >= 0)
            return jn_ByteBufferImpl__init_(0, $capacity, $rt_createByteArray($capacity), 0, $capacity, 0, 0);
        var$2 = new jl_IllegalArgumentException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$3, $rt_s(416)), $capacity);
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    function jn_ByteBuffer_wrap($array) {
        var var$2;
        var$2 = $array.data.length;
        return jn_ByteBufferImpl__init_(0, var$2, $array, 0, 0 + var$2 | 0, 0, 0);
    }
    function jn_ByteBuffer_put($this, $src, $offset, $length) {
        var var$4, var$5, var$6, var$7, var$8, var$9, $pos, $i, var$12;
        if (!$length)
            return $this;
        if ($this.$readOnly) {
            var$4 = new jn_ReadOnlyBufferException;
            jl_Throwable__init_0(var$4);
            $rt_throw(var$4);
        }
        if (jn_Buffer_remaining($this) < $length) {
            var$4 = new jn_BufferOverflowException;
            jl_Throwable__init_0(var$4);
            $rt_throw(var$4);
        }
        if ($offset >= 0) {
            var$5 = $src.data;
            var$6 = var$5.length;
            if ($offset < var$6) {
                var$7 = $offset + $length | 0;
                if (var$7 > var$6) {
                    var$8 = new jl_IndexOutOfBoundsException;
                    var$9 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$9);
                    jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$9, $rt_s(417)), var$7), $rt_s(418)), var$6);
                    jl_Throwable__init_(var$8, jl_AbstractStringBuilder_toString(var$9));
                    $rt_throw(var$8);
                }
                if ($length < 0) {
                    var$4 = new jl_IndexOutOfBoundsException;
                    var$8 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$8);
                    jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$8, $rt_s(419)), $length), $rt_s(420));
                    jl_Throwable__init_(var$4, jl_AbstractStringBuilder_toString(var$8));
                    $rt_throw(var$4);
                }
                var$7 = $this.$position9;
                $pos = var$7 + $this.$start2 | 0;
                $i = 0;
                while ($i < $length) {
                    $src = $this.$array1.data;
                    var$12 = $pos + 1 | 0;
                    var$6 = $offset + 1 | 0;
                    $src[$pos] = var$5[$offset];
                    $i = $i + 1 | 0;
                    $pos = var$12;
                    $offset = var$6;
                }
                $this.$position9 = var$7 + $length | 0;
                return $this;
            }
        }
        $src = $src.data;
        var$4 = new jl_IndexOutOfBoundsException;
        $length = $src.length;
        var$8 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$8);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$8, $rt_s(421)), $offset), $rt_s(415)), $length), 41);
        jl_Throwable__init_(var$4, jl_AbstractStringBuilder_toString(var$8));
        $rt_throw(var$4);
    }
    function jn_ByteBuffer_clear($this) {
        $this.$position9 = 0;
        $this.$limit2 = $this.$capacity;
        $this.$mark0 = (-1);
        return $this;
    }
    var jl_Readable = $rt_classWithoutFields(0);
    var jn_CharBuffer = $rt_classWithoutFields(jn_Buffer);
    function jn_CharBuffer_wrap0($array, $offset, $length) {
        var var$4, var$5, var$6;
        var$4 = $array.data;
        var$5 = new jn_CharBufferOverArray;
        var$6 = var$4.length;
        $length = $offset + $length | 0;
        jn_Buffer__init_(var$5, var$6);
        var$5.$position9 = $offset;
        var$5.$limit2 = $length;
        var$5.$start3 = 0;
        var$5.$readOnly0 = 0;
        var$5.$array2 = $array;
        return var$5;
    }
    function jn_CharBuffer_wrap($array) {
        return jn_CharBuffer_wrap0($array, 0, $array.data.length);
    }
    function jn_ByteBufferImpl() {
        var a = this; jn_ByteBuffer.call(a);
        a.$direct = 0;
        a.$readOnly = 0;
    }
    function jn_ByteBufferImpl__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new jn_ByteBufferImpl();
        jn_ByteBufferImpl__init_0(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    }
    function jn_ByteBufferImpl__init_0($this, $start, $capacity, $array, $position, $limit, $direct, $readOnly) {
        jn_Buffer__init_($this, $capacity);
        $this.$order = jn_ByteOrder_BIG_ENDIAN;
        $this.$start2 = $start;
        $this.$array1 = $array;
        $this.$position9 = $position;
        $this.$limit2 = $limit;
        $this.$direct = $direct;
        $this.$readOnly = $readOnly;
    }
    var jn_CharBufferImpl = $rt_classWithoutFields(jn_CharBuffer);
    function jn_CharBufferOverArray() {
        var a = this; jn_CharBufferImpl.call(a);
        a.$readOnly0 = 0;
        a.$start3 = 0;
        a.$array2 = null;
    }
    function jnc_IllegalCharsetNameException() {
        jl_IllegalArgumentException.call(this);
        this.$charsetName = null;
    }
    function jnc_IllegalCharsetNameException__init_(var_0) {
        var var_1 = new jnc_IllegalCharsetNameException();
        jnc_IllegalCharsetNameException__init_0(var_1, var_0);
        return var_1;
    }
    function jnc_IllegalCharsetNameException__init_0($this, $charsetName) {
        jl_Throwable__init_0($this);
        $this.$charsetName = $charsetName;
    }
    var jl_CloneNotSupportedException = $rt_classWithoutFields(jl_Exception);
    function jn_ByteOrder() {
        jl_Object.call(this);
        this.$name16 = null;
    }
    var jn_ByteOrder_BIG_ENDIAN = null;
    var jn_ByteOrder_LITTLE_ENDIAN = null;
    function jn_ByteOrder__init_(var_0) {
        var var_1 = new jn_ByteOrder();
        jn_ByteOrder__init_0(var_1, var_0);
        return var_1;
    }
    function jn_ByteOrder__init_0($this, $name) {
        $this.$name16 = $name;
    }
    function jn_ByteOrder__clinit_() {
        jn_ByteOrder_BIG_ENDIAN = jn_ByteOrder__init_($rt_s(422));
        jn_ByteOrder_LITTLE_ENDIAN = jn_ByteOrder__init_($rt_s(423));
    }
    var onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_0 = $rt_classWithoutFields();
    function onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_0_apply(var$0, var$1) {
        var var$2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(424)), var$1), $rt_s(425));
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_1() {
        jl_Object.call(this);
        this.$_059 = null;
    }
    function onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_1_apply(var$0, var$1) {
        var var$2, var$3;
        var$2 = sc_IterableOnceOps_toSeq$(onciu_StepSequencer$MutableDirectedGraph_outgoing(var$0.$_059, var$1));
        var$3 = new onciu_StepSequencer$MutableDirectedGraph$$anonfun$toString$2$lambda$_10_0;
        var$3.$_0156 = var$1;
        return sc_AbstractIterable_mkString0(var$2.$map1(var$3), $rt_s(66));
    }
    var sc_Factory = $rt_classWithoutFields(0);
    function sc_IterableFactory$ToFactory() {
        jl_Object.call(this);
        this.$factory1 = null;
    }
    function sc_IterableFactory$ToFactory__init_(var_0) {
        var var_1 = new sc_IterableFactory$ToFactory();
        sc_IterableFactory$ToFactory__init_0(var_1, var_0);
        return var_1;
    }
    function sc_IterableFactory$ToFactory_fromSpecific($this, $it) {
        return $this.$factory1.$from0($it);
    }
    function sc_IterableFactory$ToFactory__init_0($this, $factory) {
        $this.$factory1 = $factory;
    }
    function sc_EvidenceIterableFactory$ToFactory() {
        var a = this; jl_Object.call(a);
        a.$factory0 = null;
        a.$evidence$15 = null;
    }
    function sc_EvidenceIterableFactory$ToFactory_fromSpecific($this, $it) {
        var var$2, var$3;
        var$2 = $this.$factory0;
        var$3 = $this.$evidence$15;
        return scm_TreeSet$_from(var$2.$delegate2, $it, var$3);
    }
    function onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_0() {
        jl_Object.call(this);
        this.$_062 = null;
    }
    function onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_0_apply(var$0, var$1) {
        onciu_StepSequencer$MutableDirectedGraph_add(var$0.$_062, var$1);
        return sr_BoxedUnit_UNIT;
    }
    function onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_1() {
        var a = this; jl_Object.call(a);
        a.$_063 = null;
        a.$_117 = null;
    }
    function onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_1_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_063;
        var$3 = var$0.$_117;
        var$2 = onciu_StepSequencer$MutableDirectedGraph_outgoing(var$2, var$1);
        var$4 = new onciu_StepSequencer$MutableDirectedGraph$$$anonfun$copyOf$2$lambda$_4_0;
        var$4.$_0157 = var$3;
        var$4.$_126 = var$1;
        var$2.$foreach(var$4);
        return sr_BoxedUnit_UNIT;
    }
    function jnci_BufferedDecoder() {
        var a = this; jnc_CharsetDecoder.call(a);
        a.$inArray = null;
        a.$outArray = null;
    }
    var jnci_UTF8Decoder = $rt_classWithoutFields(jnci_BufferedDecoder);
    function onciu_StepSequencer$AdjacencyList() {
        var a = this; jl_Object.call(a);
        a.$outgoing = null;
        a.$incoming = null;
    }
    function onciu_StepSequencer$AdjacencyList_productPrefix($this) {
        return $rt_s(426);
    }
    function onciu_StepSequencer$AdjacencyList_productArity($this) {
        return 2;
    }
    function onciu_StepSequencer$AdjacencyList_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$outgoing;
            case 1:
                return $this.$incoming;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function onciu_StepSequencer$AdjacencyList_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_StepSequencer$AdjacencyList_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_StepSequencer$AdjacencyList_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_StepSequencer$AdjacencyList_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_StepSequencer$AdjacencyList) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$outgoing;
                        var$3 = $x$1.$outgoing;
                        if (var$2 === null) {
                            if (var$3 === null)
                                break c;
                            break b;
                        }
                        if (!sc_Set_equals$(var$2, var$3))
                            break b;
                    }
                    d: {
                        var$3 = $this.$incoming;
                        $x$1 = $x$1.$incoming;
                        if (var$3 === null) {
                            if ($x$1 === null)
                                break d;
                            break b;
                        }
                        if (!sc_Set_equals$(var$3, $x$1))
                            break b;
                    }
                    if (!($this instanceof onciu_StepSequencer$AdjacencyList))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function sci_Range() {
        var a = this; sci_AbstractSeq.call(a);
        a.$start1 = 0;
        a.$end1 = 0;
        a.$step0 = 0;
        a.$isEmpty0 = 0;
        a.$scala$collection$immutable$Range$$numRangeElements = 0;
        a.$scala$collection$immutable$Range$$lastElement = 0;
    }
    function sci_Range_start($this) {
        return $this.$start1;
    }
    function sci_Range_end($this) {
        return $this.$end1;
    }
    function sci_Range_step($this) {
        return $this.$step0;
    }
    function sci_Range_gap($this) {
        return Long_sub(Long_fromInt($this.$end1), Long_fromInt($this.$start1));
    }
    function sci_Range_isEmpty($this) {
        return $this.$isEmpty0;
    }
    function sci_Range__init_($this, $start, $end, $step) {
        var $remainder, var$5, $len;
        a: {
            b: {
                $this.$start1 = $start;
                $this.$end1 = $end;
                $this.$step0 = $step;
                $start = $rt_compare($start, $end);
                if (!($start > 0 && $step > 0) && !($start < 0 && $step < 0)) {
                    if ($start)
                        break b;
                    if ($this.$isInclusive())
                        break b;
                }
                $remainder = 1;
                break a;
            }
            $remainder = 0;
        }
        $this.$isEmpty0 = $remainder;
        if (!$step) {
            var$5 = new jl_IllegalArgumentException;
            jl_Throwable__init_(var$5, $rt_s(427));
            $rt_throw(var$5);
        }
        if ($remainder)
            $start = 0;
        else {
            $len = Long_add(Long_div(sci_Range_gap($this), Long_fromInt($this.$step0)), Long_fromInt(!(!$this.$isInclusive() && (Long_ne(Long_rem(sci_Range_gap($this), Long_fromInt($this.$step0)), Long_ZERO) ? 0 : 1) ? 0 : 1) ? 0 : 1));
            $start = Long_le($len, Long_fromInt(2147483647)) ? Long_lo($len) : (-1);
        }
        c: {
            $this.$scala$collection$immutable$Range$$numRangeElements = $start;
            switch ($step) {
                case -1:
                    break;
                case 1:
                    if ($this.$isInclusive())
                        break c;
                    $end = $end - 1 | 0;
                    break c;
                default:
                    $remainder = Long_lo(Long_rem(sci_Range_gap($this), Long_fromInt($step)));
                    if ($remainder) {
                        $end = $end - $remainder | 0;
                        break c;
                    }
                    if ($this.$isInclusive())
                        break c;
                    $end = $end - $step | 0;
                    break c;
            }
            if (!$this.$isInclusive())
                $end = $end + 1 | 0;
        }
        $this.$scala$collection$immutable$Range$$lastElement = $end;
    }
    var sci_Range$Inclusive = $rt_classWithoutFields(sci_Range);
    function sci_Range$Inclusive_isInclusive($this) {
        return 1;
    }
    var otpp_ResourceAccessor = $rt_classWithoutFields();
    var otciu_UnicodeHelper = $rt_classWithoutFields();
    function otciu_UnicodeHelper_decodeCaseMapping($text) {
        var $flow, $sz, $data, var$5, $last, $i, var$8;
        $flow = otci_CharFlow__init_(jl_String_toCharArray($text));
        $sz = otci_Base46_decodeUnsigned($flow);
        $data = $rt_createIntArray($sz * 2 | 0);
        var$5 = $data.data;
        $last = 0;
        $i = 0;
        while ($i < $sz) {
            $last = $last + otci_Base46_decodeUnsigned($flow) | 0;
            var$8 = $i * 2 | 0;
            var$5[var$8] = $last;
            var$5[var$8 + 1 | 0] = otci_Base46_decode($flow);
            $i = $i + 1 | 0;
        }
        return $data;
    }
    function otciu_UnicodeHelper_decodeByte($c) {
        if ($c > 92)
            return (($c - 32 | 0) - 2 | 0) << 24 >> 24;
        if ($c <= 34)
            return ($c - 32 | 0) << 24 >> 24;
        return (($c - 32 | 0) - 1 | 0) << 24 >> 24;
    }
    var sc_AbstractView = $rt_classWithoutFields(sc_AbstractIterable);
    function sc_AbstractView_iterableFactory($this) {
        return sc_View$_MODULE$;
    }
    function sc_AbstractView_toString($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 16);
        jl_AbstractStringBuilder_append1(var$1, $this.$stringPrefix());
        jl_AbstractStringBuilder_append1(var$1, $rt_s(428));
        return jl_AbstractStringBuilder_toString(var$1);
    }
    function sc_AbstractView_stringPrefix($this) {
        return $rt_s(429);
    }
    function sc_View$Map() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying8 = null;
        a.$f3 = null;
    }
    function sc_View$Map__init_(var_0, var_1) {
        var var_2 = new sc_View$Map();
        sc_View$Map__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function sc_View$Map_iterator($this) {
        return ($this.$underlying8.$iterator0()).$map7($this.$f3);
    }
    function sc_View$Map_knownSize($this) {
        return $this.$underlying8.$knownSize();
    }
    function sc_View$Map_isEmpty($this) {
        return $this.$underlying8.$isEmpty();
    }
    function sc_View$Map__init_0($this, $underlying, $f) {
        $this.$underlying8 = $underlying;
        $this.$f3 = $f;
    }
    var sc_BuildFromLowPriority2$$anon$11 = $rt_classWithoutFields();
    var sr_BoxedUnit = $rt_classWithoutFields();
    var sr_BoxedUnit_UNIT = null;
    var sr_BoxedUnit_TYPE = null;
    function sr_BoxedUnit_equals($this, $other) {
        return $this !== $other ? 0 : 1;
    }
    function sr_BoxedUnit_hashCode($this) {
        return 0;
    }
    function sr_BoxedUnit_toString($this) {
        return $rt_s(430);
    }
    function sr_BoxedUnit__clinit_() {
        sr_BoxedUnit_UNIT = new sr_BoxedUnit;
        sr_BoxedUnit_TYPE = $rt_cls($rt_voidcls());
    }
    function sc_SeqFactory$Delegate() {
        jl_Object.call(this);
        this.$delegate3 = null;
    }
    function sc_SeqFactory$Delegate__init_(var_0) {
        var var_1 = new sc_SeqFactory$Delegate();
        sc_SeqFactory$Delegate__init_0(var_1, var_0);
        return var_1;
    }
    function sc_SeqFactory$Delegate_unapplySeq($this, $x) {
        return $x;
    }
    function sc_SeqFactory$Delegate_apply($this, $elems) {
        return $this.$delegate3.$apply24($elems);
    }
    function sc_SeqFactory$Delegate_empty($this) {
        return $this.$delegate3.$empty();
    }
    function sc_SeqFactory$Delegate_from($this, $it) {
        return $this.$delegate3.$from0($it);
    }
    function sc_SeqFactory$Delegate_from0($this, $source) {
        return sc_SeqFactory$Delegate_from($this, $source);
    }
    function sc_SeqFactory$Delegate_empty0($this) {
        return sc_SeqFactory$Delegate_empty($this);
    }
    function sc_SeqFactory$Delegate_apply0($this, $elems) {
        return sc_SeqFactory$Delegate_apply($this, $elems);
    }
    function sc_SeqFactory$Delegate__init_0($this, $delegate) {
        $this.$delegate3 = $delegate;
    }
    var sci_Seq$ = $rt_classWithoutFields(sc_SeqFactory$Delegate);
    var sci_Seq$_MODULE$ = null;
    function sci_Seq$_$callClinit() {
        sci_Seq$_$callClinit = $rt_eraseClinit(sci_Seq$);
        sci_Seq$__clinit_();
    }
    function sci_Seq$__clinit_() {
        var var$1;
        var$1 = new sci_Seq$;
        sci_Seq$_$callClinit();
        sci_List$_$callClinit();
        sc_SeqFactory$Delegate__init_0(var$1, sci_List$_MODULE$);
        sci_Seq$_MODULE$ = var$1;
    }
    function sci_Seq$_from($this, $it) {
        if ($rt_isInstance($it, sci_Seq))
            return $it;
        return sc_SeqFactory$Delegate_from($this, $it);
    }
    function sci_Seq$_from0($this, $source) {
        return sci_Seq$_from($this, $source);
    }
    function otci_CharFlow() {
        var a = this; jl_Object.call(a);
        a.$characters0 = null;
        a.$pointer = 0;
    }
    function otci_CharFlow__init_(var_0) {
        var var_1 = new otci_CharFlow();
        otci_CharFlow__init_0(var_1, var_0);
        return var_1;
    }
    function otci_CharFlow__init_0($this, $characters) {
        $this.$characters0 = $characters;
    }
    var otci_Base46 = $rt_classWithoutFields();
    function otci_Base46_decodeUnsigned($seq) {
        var $number, $pos, var$4, $hasMore, $digit;
        $number = 0;
        $pos = 1;
        while (true) {
            var$4 = $seq.$characters0.data;
            $hasMore = $seq.$pointer;
            $seq.$pointer = $hasMore + 1 | 0;
            $digit = var$4[$hasMore];
            $digit = $digit < 34 ? $digit - 32 | 0 : $digit >= 92 ? ($digit - 32 | 0) - 2 | 0 : ($digit - 32 | 0) - 1 | 0;
            $hasMore = ($digit % 2 | 0) != 1 ? 0 : 1;
            $number = $number + $rt_imul($pos, $digit / 2 | 0) | 0;
            $pos = $pos * 46 | 0;
            if (!$hasMore)
                break;
        }
        return $number;
    }
    function otci_Base46_decode($seq) {
        var $number, $result;
        $number = otci_Base46_decodeUnsigned($seq);
        $result = $number / 2 | 0;
        if ($number % 2 | 0)
            $result =  -$result | 0;
        return $result;
    }
    function onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_0() {
        jl_Object.call(this);
        this.$_0138 = null;
    }
    function onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_0_apply(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0138.$get1(var$1);
    }
    function onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_1() {
        var a = this; jl_Object.call(a);
        a.$_0139 = null;
        a.$_125 = null;
        a.$_213 = null;
        a.$_36 = null;
    }
    function onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_1_apply(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$0.$_0139;
        var$3 = var$0.$_125;
        var$4 = var$0.$_213;
        var$5 = var$0.$_36;
        var$6 = onciu_StepSequencer$MutableDirectedGraph_outgoing(var$2, var$1);
        var$7 = new onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_0;
        var$7.$_0158 = var$3;
        var$7 = var$6.$filterNot1(var$7);
        var$6 = new onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_1;
        var$6.$_0159 = var$3;
        var$7 = var$7.$filterNot1(var$6);
        var$6 = new onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_2;
        var$6.$_0160 = var$4;
        var$6.$_127 = var$1;
        var$6.$_214 = var$5;
        var$7.$foreach(var$6);
        if (!(var$1.$preConditions()).$subsetOf(var$3)) {
            var$7 = (var$1.$preConditions()).$removedAll0(var$3);
            var$2 = onciu_StepSequencer$MutableDirectedGraph_incoming(var$2, var$1);
            var$3 = new onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_3;
            var$3.$_0161 = var$7;
            var$2 = var$2.$filter1(var$3);
            var$3 = new onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_4;
            var$3.$_0162 = var$4;
            var$3.$_128 = var$1;
            var$3.$_215 = var$5;
            var$2.$foreach(var$3);
        }
        return sr_BoxedUnit_UNIT;
    }
    var sc_StrictOptimizedSeqFactory = $rt_classWithoutFields(0);
    var sci_List$ = $rt_classWithoutFields();
    var sci_List$_MODULE$ = null;
    var sci_List$_scala$collection$immutable$List$$TupleOfNil = null;
    var sci_List$_partialNotApplied0 = null;
    function sci_List$_$callClinit() {
        sci_List$_$callClinit = $rt_eraseClinit(sci_List$);
        sci_List$__clinit_();
    }
    function sci_List$__clinit_() {
        var var$1, var$2;
        var$1 = new sci_List$;
        sci_List$_$callClinit();
        sci_List$_MODULE$ = var$1;
        var$2 = new s_Tuple2;
        var$1 = sci_Nil$_MODULE$;
        s_Tuple2__init_0(var$2, var$1, var$1);
        sci_List$_scala$collection$immutable$List$$TupleOfNil = var$2;
        sci_List$_partialNotApplied0 = new sci_List$$anon$1;
    }
    function sci_List$_unapplySeq($this, $x) {
        return $x;
    }
    function sci_List$_apply($this, $elems) {
        return $this.$from0($elems);
    }
    function sci_List$_newBuilder($this) {
        return scm_ListBuffer__init_();
    }
    function sci_List$_empty($this) {
        return sci_Nil$_MODULE$;
    }
    function sci_List$_partialNotApplied($this) {
        sci_List$_$callClinit();
        return sci_List$_partialNotApplied0;
    }
    function sci_List$_empty0($this) {
        return sci_Nil$_MODULE$;
    }
    function sci_List$_from($this, $source) {
        return sci_List_prependedAll(sci_Nil$_MODULE$, $source);
    }
    var sci_List$$anon$1 = $rt_classWithoutFields();
    function sci_List$$anon$1_toString($this) {
        return $rt_s(17);
    }
    function sci_List$$anon$1_apply($this, $x) {
        return $this;
    }
    var onciu_StepSequencer$Condition = $rt_classWithoutFields(0);
    function onciu_StepSequencer$Condition_unary_$bang$($$this) {
        var var$2;
        var$2 = new onciu_StepSequencer$NegatedCondition;
        var$2.$inner3 = $$this;
        return var$2;
    }
    var oncir_ValidatingCondition = $rt_classWithoutFields(0);
    function oncifp_BaseContains() {
        var a = this; jl_Object.call(a);
        a.$tag0 = null;
        a.$acceptableTypes = null;
    }
    function oncifp_BaseContains__init_0(var_0) {
        var var_1 = new oncifp_BaseContains();
        oncifp_BaseContains__init_(var_1, var_0);
        return var_1;
    }
    function oncifp_BaseContains_toString($this) {
        return $this.$name3();
    }
    function oncifp_BaseContains_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncifp_BaseContains_name($this) {
        var var$1, var$2, var$3;
        var$1 = jl_Class_getSimpleName($this.$tag0.$runtimeClass());
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        var$3 = jl_StringBuilder_append(var$2, $rt_s(431));
        jl_AbstractStringBuilder_append(var$3, 91);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$3, var$1), 93);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function oncifp_BaseContains_hashCode($this) {
        return $this.$tag0.$hashCode0();
    }
    function oncifp_BaseContains_equals($this, $obj) {
        if (!($obj instanceof oncifp_BaseContains))
            return 0;
        $obj = $obj;
        return $this.$tag0.$equals($obj.$tag0);
    }
    function oncifp_BaseContains_productArity($this) {
        return 0;
    }
    function oncifp_BaseContains_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_BaseContains_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_BaseContains_apply($this, $v1) {
        var var$2, var$3;
        if (!$rt_isInstance($v1, oncifp_BaseState)) {
            var$2 = new jl_IllegalStateException;
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(432)), $v1);
            jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
            $rt_throw(var$2);
        }
        $v1 = $v1;
        var$2 = $this.$tag0.$runtimeClass();
        if (jl_Object_equals($rt_cls(oncia_Statement), var$2) && s_Option_isEmpty($v1.$maybeStatement))
            $v1 = sci_$colon$colon__init_($rt_s(433), sci_Nil$_MODULE$);
        else if (jl_Object_equals($rt_cls(oncias_SemanticState), var$2) && s_Option_isEmpty($v1.$maybeSemantics))
            $v1 = sci_$colon$colon__init_($rt_s(434), sci_Nil$_MODULE$);
        else if (jl_Object_equals($rt_cls(oncias_SemanticTable), var$2) && s_Option_isEmpty($v1.$maybeSemanticTable))
            $v1 = sci_$colon$colon__init_($rt_s(435), sci_Nil$_MODULE$);
        else {
            s_package$_$callClinit();
            $v1 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        }
        return $v1;
    }
    function oncifp_BaseContains__init_($this, $tag) {
        var var$2;
        $this.$tag0 = $tag;
        s_Predef$_$callClinit();
        var$2 = (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_Class, [$rt_cls(oncia_Statement), $rt_cls(oncias_SemanticState), $rt_cls(oncias_SemanticTable)])));
        $this.$acceptableTypes = var$2;
        s_Predef$_assert(s_Predef$_MODULE$, var$2.$contains0($tag.$runtimeClass()));
    }
    var onciu_Foldable = $rt_classWithoutFields(0);
    function onciu_Foldable_folder$($$this) {
        var var$2, var$3;
        var$2 = new onciu_Foldable$Folder;
        var$3 = $$this.$foldedOver();
        $$this = onciu_CancellationChecker$NeverCancelled$_MODULE$;
        var$2.$foldedOver0 = var$3;
        var$2.$cancellation1 = $$this;
        return var$2;
    }
    var onciu_RewritableUniversal = $rt_classWithoutFields(0);
    var onciu_Rewritable = $rt_classWithoutFields(0);
    var onciu_ASTNode = $rt_classWithoutFields(0);
    function onciu_ASTNode_dup$($$this, $children) {
        var var$3, var$4, var$5;
        if (!onciu_Rewritable$IteratorEq_eqElements(onciu_Rewritable$_IteratorEq(onciu_Rewritable$_MODULE$, $children.$iterator0()), onciu_Foldable$TreeAny$_treeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, $$this))) {
            var$3 = jl_Object_getClass($$this);
            var$4 = onciu_RewritableCompat_paramsLength(var$3) != ($children.$length() + 1 | 0) ? 0 : 1;
            var$5 = onciu_RewritableCompat_lastParamIsPosition(var$3);
            if (var$4 && var$5)
                $children = $children.$appended($$this.$position2());
            sr_ClassTag$_$callClinit();
            $$this = onciu_RewritableCompat_copyConstructor(var$3, $$this, sc_IterableOnceOps_toArray$($children, sr_ClassTag$_AnyRef(sr_ClassTag$_MODULE$)));
        }
        return $$this;
    }
    var oncia_Statement = $rt_classWithoutFields(0);
    var oncifp_ValidSymbolicNamesInLabelExpressions$ = $rt_classWithoutFields();
    var oncifp_ValidSymbolicNamesInLabelExpressions$_MODULE$ = null;
    function oncifp_ValidSymbolicNamesInLabelExpressions$__clinit_() {
        oncifp_ValidSymbolicNamesInLabelExpressions$_MODULE$ = new oncifp_ValidSymbolicNamesInLabelExpressions$;
    }
    function oncifp_ValidSymbolicNamesInLabelExpressions$_toString($this) {
        return $this.$name3();
    }
    function oncifp_ValidSymbolicNamesInLabelExpressions$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncifp_ValidSymbolicNamesInLabelExpressions$_name($this) {
        return $rt_s(436);
    }
    function oncifp_ValidSymbolicNamesInLabelExpressions$_org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames($this, $context, $labelExpression, $symbolicNamePredicate, $errors) {
        var var$5;
        var$5 = $labelExpression.$folder();
        sr_ClassTag$_$callClinit();
        $labelExpression = s_Option_filterNot(onciu_Foldable$Folder_treeFindByClass(var$5, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_SymbolicName))), $symbolicNamePredicate);
        $symbolicNamePredicate = new oncifp_ValidSymbolicNamesInLabelExpressions$$org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames$lambda$_31_0;
        $symbolicNamePredicate.$_0163 = $context;
        return scm_ListBuffer_addAll($errors, s_Option_map($labelExpression, $symbolicNamePredicate));
    }
    function oncifp_ValidSymbolicNamesInLabelExpressions$_apply($this, $v1) {
        return (onciu_Foldable$Folder_fold(onciu_Foldable_folder$(onciu_Foldable$_FoldableAny(onciu_Foldable$_MODULE$, $v1)), scm_ListBuffer__init_(), new oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1)).$toSeq();
    }
    var scm_AbstractMap = $rt_classWithoutFields(sc_AbstractMap);
    function scm_AbstractMap_clone($this) {
        var var$1, var$2, var$3;
        if (!($this instanceof sci_TreeSeqMap))
            var$1 = scm_HashMap$_empty(scm_HashMap$_MODULE$);
        else {
            var$1 = $this;
            sci_TreeSeqMap$_$callClinit();
            var$2 = sci_TreeSeqMap$_MODULE$;
            var$1 = sci_TreeSeqMap_orderedBy(var$1);
            var$3 = sci_TreeSeqMap$OrderBy$Modification$_MODULE$;
            var$1 = var$1 !== null && var$1.$equals(var$3) ? sci_TreeSeqMap$_EmptyByModification : sci_TreeSeqMap$_EmptyByInsertion(var$2);
        }
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(null);
        return scm_HashMap_addAll(var$1, $this);
    }
    function scm_AbstractMap_iterableFactory($this) {
        scm_Iterable$_$callClinit();
        return scm_Iterable$_MODULE$;
    }
    function scm_AbstractMap_result($this) {
        return $this;
    }
    var sc_StrictOptimizedMapOps = $rt_classWithoutFields(0);
    function scm_HashMap() {
        var a = this; scm_AbstractMap.call(a);
        a.$loadFactor0 = 0.0;
        a.$scala$collection$mutable$HashMap$$table = null;
        a.$threshold0 = 0;
        a.$contentSize = 0;
    }
    function scm_HashMap__init_0(var_0, var_1) {
        var var_2 = new scm_HashMap();
        scm_HashMap__init_1(var_2, var_0, var_1);
        return var_2;
    }
    function scm_HashMap__init_() {
        var var_0 = new scm_HashMap();
        scm_HashMap__init_2(var_0);
        return var_0;
    }
    function scm_HashMap_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function scm_HashMap_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function scm_HashMap_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function scm_HashMap_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function scm_HashMap_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function scm_HashMap_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function scm_HashMap_size($this) {
        return $this.$contentSize;
    }
    function scm_HashMap_unimproveHash($this, $improvedHash) {
        return $improvedHash ^ $improvedHash >>> 16;
    }
    function scm_HashMap_addAll($this, $xs) {
        var $foreachWithHash_foreachWithHash_i, $iter, $next, $entry, $foreachWithHash_f, $foreachWithHash_foreachWithHash_this, $foreachWithHash_foreachWithHash_iN, var$9, $foreachWithHash_foreachWithHash_jN, $foreachWithHash_foreachWithHash_j;
        $foreachWithHash_foreachWithHash_i = scm_HashMap_tableSizeFor($this, ($xs.$knownSize() + 1 | 0) / $this.$loadFactor0 | 0);
        if ($foreachWithHash_foreachWithHash_i > $this.$scala$collection$mutable$HashMap$$table.data.length)
            scm_HashMap_growTable($this, $foreachWithHash_foreachWithHash_i);
        if (!($xs instanceof sci_HashMap)) {
            if ($xs instanceof scm_HashMap) {
                $iter = scm_HashMap_nodeIterator($xs);
                while ($iter.$hasNext()) {
                    $next = $iter.$next();
                    scm_HashMap_put0($this, $next.$_key, $next.$_value, $next.$_hash, 0);
                }
                return $this;
            }
            if (!($xs instanceof scm_LinkedHashMap)) {
                if (!$rt_isInstance($xs, scm_Map))
                    return scm_Growable_addAll$($this, $xs);
                $xs = $xs;
                $iter = new scm_HashMap$addAll$lambda$_42_1;
                $iter.$_0164 = $this;
                scm_HashMap_foreachEntry($xs, $iter);
                return $this;
            }
            $iter = $xs.$entryIterator();
            while ($iter.$hasNext()) {
                $entry = $iter.$next();
                scm_HashMap_put0($this, scm_LinkedHashMap$LinkedEntry_key($entry), scm_LinkedHashMap$LinkedEntry_value($entry), scm_LinkedHashMap$LinkedEntry_hash($entry), 0);
            }
            return $this;
        }
        $xs = $xs;
        $foreachWithHash_f = new scm_HashMap$addAll$lambda$_42_0;
        $foreachWithHash_f.$_0165 = $this;
        $foreachWithHash_foreachWithHash_this = $xs.$rootNode;
        if ($foreachWithHash_foreachWithHash_this === null)
            $rt_throw(null);
        $foreachWithHash_foreachWithHash_i = 0;
        $foreachWithHash_foreachWithHash_iN = sci_BitmapIndexedMapNode_payloadArity($foreachWithHash_foreachWithHash_this);
        while ($foreachWithHash_foreachWithHash_i < $foreachWithHash_foreachWithHash_iN) {
            var$9 = $foreachWithHash_foreachWithHash_this.$content.data;
            $foreachWithHash_foreachWithHash_jN = 2 * $foreachWithHash_foreachWithHash_i | 0;
            scm_HashMap_$anonfun$addAll$1($this, var$9[$foreachWithHash_foreachWithHash_jN], var$9[$foreachWithHash_foreachWithHash_jN + 1 | 0], $foreachWithHash_foreachWithHash_this.$originalHashes.data[$foreachWithHash_foreachWithHash_i]);
            $foreachWithHash_foreachWithHash_i = $foreachWithHash_foreachWithHash_i + 1 | 0;
        }
        $foreachWithHash_foreachWithHash_jN = sci_BitmapIndexedMapNode_nodeArity($foreachWithHash_foreachWithHash_this);
        $foreachWithHash_foreachWithHash_j = 0;
        while ($foreachWithHash_foreachWithHash_j < $foreachWithHash_foreachWithHash_jN) {
            (sci_BitmapIndexedMapNode_getNode($foreachWithHash_foreachWithHash_this, $foreachWithHash_foreachWithHash_j)).$foreachWithHash($foreachWithHash_f);
            $foreachWithHash_foreachWithHash_j = $foreachWithHash_foreachWithHash_j + 1 | 0;
        }
        return $this;
    }
    function scm_HashMap_updateWith($this, $key, $remappingFunction) {
        var $nextValue, $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash, $hash, var$6, $newIndexedHash, $previousValue, $findNode$1_nd, $findNode$1_prev, $findNode$1_nd_0, $newValue, var$13, $value, $updateWith_previousValue, $updateWith_nextValue;
        $nextValue = jl_Object_getClass($this);
        if ($nextValue !== null && jl_Object_equals($nextValue, $rt_cls(scm_HashMap))) {
            $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = sr_Statics_anyHash($key);
            $hash = $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash ^ $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash >>> 16;
            var$6 = $this.$scala$collection$mutable$HashMap$$table.data;
            $newIndexedHash = $hash & (var$6.length - 1 | 0);
            $previousValue = null;
            $nextValue = null;
            $findNode$1_nd = var$6[$newIndexedHash];
            if ($findNode$1_nd === null) {
                $findNode$1_prev = $nextValue;
                $findNode$1_nd = $previousValue;
            } else {
                $findNode$1_prev = null;
                a: {
                    while (!($hash == $findNode$1_nd.$_hash && sr_BoxesRunTime_equals($key, $findNode$1_nd.$_key))) {
                        $findNode$1_nd_0 = $findNode$1_nd.$_next;
                        if ($findNode$1_nd_0 === null) {
                            $findNode$1_prev = $nextValue;
                            $findNode$1_nd = $previousValue;
                            break a;
                        }
                        if ($findNode$1_nd.$_hash > $hash) {
                            $findNode$1_prev = $nextValue;
                            $findNode$1_nd = $previousValue;
                            break a;
                        }
                        $findNode$1_prev = $findNode$1_nd;
                        $findNode$1_nd = $findNode$1_nd_0;
                    }
                }
            }
            $previousValue = $findNode$1_nd === null ? s_None$_MODULE$ : s_Some__init_($findNode$1_nd.$_value);
            $nextValue = $remappingFunction.$apply($previousValue);
            $newValue = s_Tuple2__init_($previousValue, $nextValue);
            if (!(jl_Object_equals(s_None$_MODULE$, $previousValue) && jl_Object_equals(s_None$_MODULE$, $nextValue))) {
                var$13 = $previousValue instanceof s_Some;
                if (var$13 && jl_Object_equals(s_None$_MODULE$, $nextValue)) {
                    if ($findNode$1_prev !== null)
                        $findNode$1_prev.$_next = $findNode$1_nd.$_next;
                    else
                        $this.$scala$collection$mutable$HashMap$$table.data[$newIndexedHash] = $findNode$1_nd.$_next;
                    $this.$contentSize = $this.$contentSize - 1 | 0;
                } else if (jl_Object_equals(s_None$_MODULE$, $previousValue) && $nextValue instanceof s_Some) {
                    $value = $nextValue.$value5;
                    if (($this.$contentSize + 1 | 0) >= $this.$threshold0) {
                        scm_HashMap_growTable($this, $this.$scala$collection$mutable$HashMap$$table.data.length * 2 | 0);
                        $newIndexedHash = $hash & ($this.$scala$collection$mutable$HashMap$$table.data.length - 1 | 0);
                    }
                    scm_HashMap_put00($this, $key, $value, 0, $hash, $newIndexedHash);
                } else if (var$13 && $nextValue instanceof s_Some)
                    $findNode$1_nd.$_value = $nextValue.$value5;
                else
                    $rt_throw(s_MatchError__init_($newValue));
            }
            return $nextValue;
        }
        $updateWith_previousValue = scm_HashMap_get($this, $key);
        $updateWith_nextValue = $remappingFunction.$apply($updateWith_previousValue);
        $remappingFunction = s_Tuple2__init_($updateWith_previousValue, $updateWith_nextValue);
        if (!(jl_Object_equals(s_None$_MODULE$, $updateWith_previousValue) && jl_Object_equals(s_None$_MODULE$, $updateWith_nextValue))) {
            if ($updateWith_previousValue instanceof s_Some && jl_Object_equals(s_None$_MODULE$, $updateWith_nextValue)) {
                $key = scm_HashMap_remove0($this, $key);
                if ($key !== null)
                    s_Some__init_0(new s_Some, $key.$_value);
            } else {
                if (!($updateWith_nextValue instanceof s_Some))
                    $rt_throw(s_MatchError__init_($remappingFunction));
                scm_HashMap_update($this, $key, $updateWith_nextValue.$value5);
            }
        }
        return $updateWith_nextValue;
    }
    function scm_HashMap_put0($this, $key, $value, $hash, $getOld) {
        if (($this.$contentSize + 1 | 0) >= $this.$threshold0)
            scm_HashMap_growTable($this, $this.$scala$collection$mutable$HashMap$$table.data.length * 2 | 0);
        return scm_HashMap_put00($this, $key, $value, $getOld, $hash, $hash & ($this.$scala$collection$mutable$HashMap$$table.data.length - 1 | 0));
    }
    function scm_HashMap_put01($this, $key, $value, $getOld) {
        var $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash, $hash;
        if (($this.$contentSize + 1 | 0) >= $this.$threshold0)
            scm_HashMap_growTable($this, $this.$scala$collection$mutable$HashMap$$table.data.length * 2 | 0);
        $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = sr_Statics_anyHash($key);
        $hash = $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash ^ $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash >>> 16;
        return scm_HashMap_put00($this, $key, $value, $getOld, $hash, $hash & ($this.$scala$collection$mutable$HashMap$$table.data.length - 1 | 0));
    }
    function scm_HashMap_put00($this, $key, $value, $getOld, $hash, $idx) {
        var var$6, var$7, $prev, $n, var$10, $n_0, $old;
        var$6 = $this.$scala$collection$mutable$HashMap$$table.data;
        var$7 = var$6[$idx];
        if (var$7 === null)
            var$6[$idx] = scm_HashMap$Node__init_($key, $hash, $value, null);
        else {
            $prev = null;
            $n = var$7;
            a: {
                while (true) {
                    if ($n === null)
                        break a;
                    var$10 = $rt_compare($n.$_hash, $hash);
                    if (var$10 > 0)
                        break a;
                    if (!var$10 && sr_BoxesRunTime_equals($key, $n.$_key))
                        break;
                    $n_0 = $n.$_next;
                    $prev = $n;
                    $n = $n_0;
                }
                $old = $n.$_value;
                $n.$_value = $value;
                if (!$getOld)
                    return null;
                return s_Some__init_($old);
            }
            if ($prev === null)
                $this.$scala$collection$mutable$HashMap$$table.data[$idx] = scm_HashMap$Node__init_($key, $hash, $value, var$7);
            else
                $prev.$_next = scm_HashMap$Node__init_($key, $hash, $value, $prev.$_next);
        }
        $this.$contentSize = $this.$contentSize + 1 | 0;
        return null;
    }
    function scm_HashMap_remove0($this, $elem) {
        var $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash, var$3, var$4, var$5, var$6, var$7;
        a: {
            $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = sr_Statics_anyHash($elem);
            var$3 = $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash ^ $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash >>> 16;
            var$4 = $this.$scala$collection$mutable$HashMap$$table.data;
            $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = var$3 & (var$4.length - 1 | 0);
            var$5 = var$4[$scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash];
            if (var$5 === null)
                var$5 = null;
            else if (var$5.$_hash == var$3 && sr_BoxesRunTime_equals(var$5.$_key, $elem)) {
                $this.$scala$collection$mutable$HashMap$$table.data[$scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash] = var$5.$_next;
                $this.$contentSize = $this.$contentSize - 1 | 0;
            } else {
                var$6 = var$5.$_next;
                while (var$6 !== null) {
                    $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = $rt_compare(var$6.$_hash, var$3);
                    if ($scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash > 0)
                        break;
                    if (!$scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash && sr_BoxesRunTime_equals(var$6.$_key, $elem)) {
                        var$5.$_next = var$6.$_next;
                        $this.$contentSize = $this.$contentSize - 1 | 0;
                        var$5 = var$6;
                        break a;
                    }
                    var$7 = var$6.$_next;
                    var$5 = var$6;
                    var$6 = var$7;
                }
                var$5 = null;
            }
        }
        return var$5;
    }
    function scm_HashMap_iterator($this) {
        var var$1;
        if (!$this.$contentSize)
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new scm_HashMap$$anon$1;
        scm_HashMap$HashMapIterator__init_(var$1, $this);
        return var$1;
    }
    function scm_HashMap_keysIterator($this) {
        var var$1;
        if (!$this.$contentSize)
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new scm_HashMap$$anon$2;
        scm_HashMap$HashMapIterator__init_(var$1, $this);
        return var$1;
    }
    function scm_HashMap_valuesIterator($this) {
        var var$1;
        if (!$this.$contentSize)
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new scm_HashMap$$anon$3;
        scm_HashMap$HashMapIterator__init_(var$1, $this);
        return var$1;
    }
    function scm_HashMap_nodeIterator($this) {
        var var$1;
        if (!$this.$contentSize)
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new scm_HashMap$$anon$4;
        scm_HashMap$HashMapIterator__init_(var$1, $this);
        return var$1;
    }
    function scm_HashMap_growTable($this, $newlen) {
        var $old, $n, $oldlen, $preLow, $preHigh, $i, var$8, var$9, var$10, $n_0;
        if ($newlen < 0) {
            $old = new jl_RuntimeException;
            $n = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2($n, 39);
            jl_AbstractStringBuilder_append1($n, $rt_s(437));
            $n = jl_StringBuilder_append0($n, $newlen);
            jl_AbstractStringBuilder_append1($n, $rt_s(438));
            jl_Throwable__init_($old, jl_AbstractStringBuilder_toString($n));
            $rt_throw($old);
        }
        $oldlen = $this.$scala$collection$mutable$HashMap$$table.data.length;
        $this.$threshold0 = scm_HashMap_newThreshold($this, $newlen);
        if (!$this.$contentSize) {
            $this.$scala$collection$mutable$HashMap$$table = $rt_createArray(scm_HashMap$Node, $newlen);
            return;
        }
        $this.$scala$collection$mutable$HashMap$$table = ju_Arrays_copyOf($this.$scala$collection$mutable$HashMap$$table, $newlen);
        $preLow = scm_HashMap$Node__init_(null, 0, null, null);
        $preHigh = scm_HashMap$Node__init_(null, 0, null, null);
        while ($oldlen < $newlen) {
            $i = 0;
            while ($i < $oldlen) {
                var$8 = $this.$scala$collection$mutable$HashMap$$table.data;
                $old = var$8[$i];
                if ($old !== null) {
                    $preLow.$_next = null;
                    $preHigh.$_next = null;
                    $n = $old;
                    var$9 = $preLow;
                    var$10 = $preHigh;
                    while ($n !== null) {
                        $n_0 = $n.$_next;
                        if ($n.$_hash & $oldlen)
                            var$10.$_next = $n;
                        else {
                            var$9.$_next = $n;
                            var$9 = $n;
                            $n = var$10;
                        }
                        var$10 = $n;
                        $n = $n_0;
                    }
                    var$9.$_next = null;
                    $n = $preLow.$_next;
                    if ($old !== $n)
                        var$8[$i] = $n;
                    $old = $preHigh.$_next;
                    if ($old !== null) {
                        var$8[$i + $oldlen | 0] = $old;
                        var$10.$_next = null;
                    }
                }
                $i = $i + 1 | 0;
            }
            $oldlen = $oldlen * 2 | 0;
        }
    }
    function scm_HashMap_tableSizeFor($this, $capacity) {
        return jl_Math_min(jl_Integer_highestOneBit(jl_Math_max($capacity - 1 | 0, 4)) * 2 | 0, 1073741824);
    }
    function scm_HashMap_newThreshold($this, $size) {
        return $size * $this.$loadFactor0 | 0;
    }
    function scm_HashMap_get($this, $key) {
        var $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash, $findNode_hash, var$4, var$5;
        $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = sr_Statics_anyHash($key);
        $findNode_hash = $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash ^ $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash >>> 16;
        var$4 = $this.$scala$collection$mutable$HashMap$$table.data;
        var$5 = var$4[$findNode_hash & (var$4.length - 1 | 0)];
        $key = var$5 !== null ? scm_HashMap$Node_findNode(var$5, $key, $findNode_hash) : null;
        if ($key === null)
            return s_None$_MODULE$;
        return s_Some__init_($key.$_value);
    }
    function scm_HashMap_apply($this, $key) {
        var $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash, $findNode_hash, var$4, var$5;
        $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = sr_Statics_anyHash($key);
        $findNode_hash = $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash ^ $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash >>> 16;
        var$4 = $this.$scala$collection$mutable$HashMap$$table.data;
        var$5 = var$4[$findNode_hash & (var$4.length - 1 | 0)];
        var$5 = var$5 !== null ? scm_HashMap$Node_findNode(var$5, $key, $findNode_hash) : null;
        if (var$5 === null)
            return sc_AbstractMap_default($this, $key);
        return var$5.$_value;
    }
    function scm_HashMap_getOrElse($this, $key, $default) {
        var var$3, $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash, $findNode_hash, var$6, $nd;
        var$3 = jl_Object_getClass($this);
        if (var$3 !== null && jl_Object_equals(var$3, $rt_cls(scm_HashMap))) {
            $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = sr_Statics_anyHash($key);
            $findNode_hash = $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash ^ $findNode_scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash >>> 16;
            var$6 = $this.$scala$collection$mutable$HashMap$$table.data;
            $nd = var$6[$findNode_hash & (var$6.length - 1 | 0)];
            $nd = $nd !== null ? scm_HashMap$Node_findNode($nd, $key, $findNode_hash) : null;
            if ($nd === null)
                return $default.$apply2();
            return $nd.$_value;
        }
        $key = scm_HashMap_get($this, $key);
        if ($key instanceof s_Some)
            return $key.$value5;
        if (jl_Object_equals(s_None$_MODULE$, $key))
            return $default.$apply2();
        $rt_throw(s_MatchError__init_($key));
    }
    function scm_HashMap_getOrElseUpdate($this, $key, $defaultValue) {
        var $default, $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash, $hash, $table0, $newIdx, $nd, var$9, $getOrElseUpdate_d;
        $default = jl_Object_getClass($this);
        if ($default !== null && jl_Object_equals($default, $rt_cls(scm_HashMap))) {
            $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash = sr_Statics_anyHash($key);
            $hash = $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash ^ $scala$collection$mutable$HashMap$$computeHash_scala$collection$mutable$HashMap$$improveHash_originalHash >>> 16;
            $table0 = $this.$scala$collection$mutable$HashMap$$table.data;
            $newIdx = $hash & ($table0.length - 1 | 0);
            $nd = $table0[$newIdx];
            $nd = $nd !== null ? scm_HashMap$Node_findNode($nd, $key, $hash) : null;
            if ($nd !== null)
                return $nd.$_value;
            $table0 = $this.$scala$collection$mutable$HashMap$$table;
            $default = $defaultValue.$apply2();
            if (($this.$contentSize + 1 | 0) >= $this.$threshold0)
                scm_HashMap_growTable($this, $this.$scala$collection$mutable$HashMap$$table.data.length * 2 | 0);
            var$9 = $this.$scala$collection$mutable$HashMap$$table;
            if ($table0 !== var$9)
                $newIdx = $hash & (var$9.data.length - 1 | 0);
            scm_HashMap_put00($this, $key, $default, 0, $hash, $newIdx);
            return $default;
        }
        $nd = scm_HashMap_get($this, $key);
        if ($nd instanceof s_Some)
            return $nd.$value5;
        if (!jl_Object_equals(s_None$_MODULE$, $nd))
            $rt_throw(s_MatchError__init_($nd));
        $getOrElseUpdate_d = $defaultValue.$apply2();
        scm_HashMap_update($this, $key, $getOrElseUpdate_d);
        return $getOrElseUpdate_d;
    }
    function scm_HashMap_update($this, $key, $value) {
        scm_HashMap_put01($this, $key, $value, 0);
    }
    function scm_HashMap_knownSize($this) {
        return $this.$contentSize;
    }
    function scm_HashMap_isEmpty($this) {
        if ($this.$contentSize)
            return 0;
        return 1;
    }
    function scm_HashMap_foreach($this, $f) {
        var $len, $i, $n, var$5;
        $len = $this.$scala$collection$mutable$HashMap$$table.data.length;
        $i = 0;
        while ($i < $len) {
            $n = $this.$scala$collection$mutable$HashMap$$table.data[$i];
            if ($n !== null) {
                var$5 = $f;
                while (true) {
                    var$5.$apply(s_Tuple2__init_($n.$_key, $n.$_value));
                    $n = $n.$_next;
                    if ($n === null)
                        break;
                }
            }
            $i = $i + 1 | 0;
        }
    }
    function scm_HashMap_foreachEntry($this, $f) {
        var $len, $i, $n, var$5;
        $len = $this.$scala$collection$mutable$HashMap$$table.data.length;
        $i = 0;
        while ($i < $len) {
            $n = $this.$scala$collection$mutable$HashMap$$table.data[$i];
            if ($n !== null) {
                var$5 = $f;
                while (true) {
                    var$5.$apply0($n.$_key, $n.$_value);
                    $n = $n.$_next;
                    if ($n === null)
                        break;
                }
            }
            $i = $i + 1 | 0;
        }
    }
    function scm_HashMap_mapFactory($this) {
        return scm_HashMap$_MODULE$;
    }
    function scm_HashMap_stringPrefix($this) {
        return $rt_s(439);
    }
    function scm_HashMap_hashCode($this) {
        var $tupleHashIterator, var$2;
        if (scm_HashMap_isEmpty($this)) {
            suh_MurmurHash3$_$callClinit();
            return suh_MurmurHash3$_emptyMapHash(suh_MurmurHash3$_MODULE$);
        }
        $tupleHashIterator = new scm_HashMap$$anon$5;
        $tupleHashIterator.$$outer13 = $this;
        scm_HashMap$HashMapIterator__init_($tupleHashIterator, $this);
        $tupleHashIterator.$hash0 = 0;
        suh_MurmurHash3$_$callClinit();
        var$2 = suh_MurmurHash3$_MODULE$;
        return suh_MurmurHash3_unorderedHash(var$2, $tupleHashIterator, suh_MurmurHash3$_mapSeed(var$2));
    }
    function scm_HashMap_subtractOne($this, $elem) {
        scm_HashMap_remove0($this, $elem);
        return $this;
    }
    function scm_HashMap_addOne($this, $elem) {
        $elem = $elem;
        scm_HashMap_put01($this, $elem.$_10, $elem.$_20, 0);
        return $this;
    }
    function scm_HashMap_addAll0($this, $xs) {
        return scm_HashMap_addAll($this, $xs);
    }
    function scm_HashMap_$anonfun$addAll$1($$this, $k, $v, $h) {
        scm_HashMap_put0($$this, $k, $v, $h ^ $h >>> 16, 0);
    }
    function scm_HashMap__init_1($this, $initialCapacity, $loadFactor) {
        var var$3, var$4;
        $this.$loadFactor0 = $loadFactor;
        var$3 = $rt_createArray(scm_HashMap$Node, scm_HashMap_tableSizeFor($this, $initialCapacity));
        var$4 = var$3.data;
        $this.$scala$collection$mutable$HashMap$$table = var$3;
        $this.$threshold0 = scm_HashMap_newThreshold($this, var$4.length);
        $this.$contentSize = 0;
    }
    function scm_HashMap__init_2($this) {
        scm_HashMap__init_1($this, 16, 0.75);
    }
    var sc_SortedOps = $rt_classWithoutFields(0);
    var sc_SortedSetOps = $rt_classWithoutFields(0);
    var sc_SortedSetFactoryDefaults = $rt_classWithoutFields(0);
    var sc_SortedSet = $rt_classWithoutFields(0);
    var sci_SortedSetOps = $rt_classWithoutFields(0);
    var sci_SortedSet = $rt_classWithoutFields(0);
    var scm_ReusableBuilder = $rt_classWithoutFields(0);
    function sci_SetBuilderImpl() {
        var a = this; jl_Object.call(a);
        a.$elems0 = null;
        a.$switchedToHashSetBuilder = 0;
        a.$hashSetBuilder = null;
    }
    function sci_SetBuilderImpl__init_() {
        var var_0 = new sci_SetBuilderImpl();
        sci_SetBuilderImpl__init_0(var_0);
        return var_0;
    }
    function sci_SetBuilderImpl_sizeHint($this, $size) {}
    function sci_SetBuilderImpl_sizeHint0($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    }
    function sci_SetBuilderImpl_addAll($this, $xs) {
        if (!$this.$switchedToHashSetBuilder)
            return scm_Growable_addAll$($this, $xs);
        sci_HashSetBuilder_addAll($this.$hashSetBuilder, $xs);
        return $this;
    }
    function sci_SetBuilderImpl_addAll0($this, $xs) {
        return sci_SetBuilderImpl_addAll($this, $xs);
    }
    function sci_SetBuilderImpl_addOne($this, $elem) {
        var var$2;
        if ($this.$switchedToHashSetBuilder)
            sci_HashSetBuilder_addOne($this.$hashSetBuilder, $elem);
        else if ($this.$elems0.$size() < 4) {
            var$2 = $this.$elems0;
            if (var$2 === null)
                $rt_throw(null);
            $this.$elems0 = var$2.$incl($elem);
        } else if (!$this.$elems0.$contains0($elem)) {
            $this.$switchedToHashSetBuilder = 1;
            if ($this.$hashSetBuilder === null)
                $this.$hashSetBuilder = sci_HashSetBuilder__init_();
            var$2 = $this.$elems0;
            sci_HashSetBuilder_addOne(sci_HashSetBuilder_addOne(sci_HashSetBuilder_addOne(sci_HashSetBuilder_addOne($this.$hashSetBuilder, var$2.$elem1), var$2.$elem2), var$2.$elem3), var$2.$elem4);
            sci_HashSetBuilder_addOne($this.$hashSetBuilder, $elem);
        }
        return $this;
    }
    function sci_SetBuilderImpl_result($this) {
        return !$this.$switchedToHashSetBuilder ? $this.$elems0 : sci_HashSetBuilder_result($this.$hashSetBuilder);
    }
    function sci_SetBuilderImpl__init_0($this) {
        $this.$elems0 = sci_Set$EmptySet$_MODULE$;
        $this.$switchedToHashSetBuilder = 0;
    }
    function oncias_SemanticState() {
        var a = this; jl_Object.call(a);
        a.$currentScope = null;
        a.$typeTable = null;
        a.$recordedScopes = null;
        a.$notifications = null;
        a.$features1 = null;
        a.$declareVariablesToSuppressDuplicateErrors = 0;
        a.$semanticCheckHasRunOnce = 0;
    }
    function oncias_SemanticState__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncias_SemanticState();
        oncias_SemanticState__init_0(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    }
    function oncias_SemanticState_typeTable($this) {
        return $this.$typeTable;
    }
    function oncias_SemanticState_recordedScopes($this) {
        return $this.$recordedScopes;
    }
    function oncias_SemanticState_newChildScope($this) {
        return oncias_SemanticState_copy($this, oncias_SemanticState$ScopeLocation$_newChildScope$extension(oncias_SemanticState$ScopeLocation$_MODULE$, $this.$currentScope), $this.$typeTable, $this.$recordedScopes, $this.$notifications, $this.$features1, $this.$declareVariablesToSuppressDuplicateErrors, $this.$semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_newSiblingScope($this) {
        var var$1;
        var$1 = $this.$currentScope;
        oncias_SemanticState$_$callClinit();
        oncias_Scope$_$callClinit();
        return oncias_SemanticState_copy($this, (onciuh_TreeZipper$Location_insertRight(var$1, oncias_Scope$_empty(oncias_Scope$_MODULE$))).$get0(), $this.$typeTable, $this.$recordedScopes, $this.$notifications, $this.$features1, $this.$declareVariablesToSuppressDuplicateErrors, $this.$semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_popScope($this) {
        return oncias_SemanticState_copy($this, ((oncias_SemanticState$ScopeLocation$_parent$extension(oncias_SemanticState$ScopeLocation$_MODULE$, $this.$currentScope)).$get0()).$location, $this.$typeTable, $this.$recordedScopes, $this.$notifications, $this.$features1, $this.$declareVariablesToSuppressDuplicateErrors, $this.$semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_symbol($this, $name) {
        return oncias_SemanticState$ScopeLocation$_symbol$extension(oncias_SemanticState$ScopeLocation$_MODULE$, $this.$currentScope, $name);
    }
    function oncias_SemanticState_isNode($this, $name) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    var$2 = s_Option_getOrElse(s_Option_map(oncias_SemanticState_symbol($this, $name), new oncias_SemanticState$symbolTypes$lambda$_27_0), new oncias_SemanticState$symbolTypes$lambda$_27_1);
                    oncius_package$_$callClinit();
                    $name = oncius_NodeType_invariant(oncius_package$_CTNode(oncius_package$_MODULE$));
                    if (var$2 !== null) {
                        if (!oncius_TypeSpec_equals(var$2, $name))
                            break b;
                        else
                            break c;
                    }
                    if ($name !== null)
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    }
    function oncias_SemanticState_importValuesFromScope($this, $scope, $exclude) {
        var var$3, var$4;
        var$3 = $this.$currentScope;
        oncias_SemanticState$_$callClinit();
        var$4 = var$3.$elem;
        $exclude = $scope.$symbolTable.$removedAll($exclude);
        return oncias_SemanticState_copy($this, onciuh_TreeZipper$Location_replace(var$3, oncias_Scope_copy(var$4, var$4.$symbolTable.$concat2($exclude), var$4.$children1)), $this.$typeTable, $this.$recordedScopes, $this.$notifications, $this.$features1, $this.$declareVariablesToSuppressDuplicateErrors, $this.$semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_importValuesFromScope$default$2($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncias_SemanticState_declareVariable($this, $variable, $possibleTypes, $maybePreviousDeclaration, $overriding, $unionVariable) {
        var var$6, $definition, $previousDeclaration, $uses, var$10, var$11;
        if (oncias_SemanticState$ScopeLocation$_localSymbol$extension(oncias_SemanticState$ScopeLocation$_MODULE$, $this.$currentScope, $variable.$name4) instanceof s_Some && !$overriding) {
            s_package$_$callClinit();
            $possibleTypes = s_package$_Left(s_package$_MODULE$);
            $maybePreviousDeclaration = new oncias_SemanticError;
            var$6 = $variable.$name4;
            $definition = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($definition);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($definition, $rt_s(440)), var$6), $rt_s(441));
            oncias_SemanticError__init_($maybePreviousDeclaration, jl_AbstractStringBuilder_toString($definition), $variable.$position0);
            return su_Left$_apply($possibleTypes, $maybePreviousDeclaration);
        }
        if (!($maybePreviousDeclaration instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, $maybePreviousDeclaration))
                $rt_throw(s_MatchError__init_($maybePreviousDeclaration));
            var$6 = new s_Tuple2;
            $definition = oncias_SymbolUse$_apply(oncias_SymbolUse$_MODULE$, $variable);
            s_Predef$_$callClinit();
            s_Predef$_Set(s_Predef$_MODULE$);
            s_Tuple2__init_0(var$6, $definition, sci_Set$EmptySet$_MODULE$);
        } else {
            $previousDeclaration = $maybePreviousDeclaration.$value5;
            var$6 = new s_Tuple2;
            $uses = $previousDeclaration.$definition;
            $definition = $previousDeclaration.$uses;
            s_Predef$_$callClinit();
            var$10 = s_Predef$_Set(s_Predef$_MODULE$);
            $maybePreviousDeclaration = sr_ScalaRunTime$_MODULE$;
            var$11 = $rt_createArray(oncias_SymbolUse, 1);
            var$11.data[0] = oncias_SymbolUse$_apply(oncias_SymbolUse$_MODULE$, $variable);
            s_Tuple2__init_0(var$6, $uses, $definition.$concat1(var$10.$from0(sr_ScalaRunTime$_wrapRefArray($maybePreviousDeclaration, var$11))));
        }
        $definition = var$6.$_10;
        $uses = var$6.$_20;
        $maybePreviousDeclaration = s_Tuple2__init_($definition, $uses);
        $definition = $maybePreviousDeclaration.$_10;
        $uses = $maybePreviousDeclaration.$_20;
        s_package$_$callClinit();
        return su_Right$_apply(s_package$_Right(s_package$_MODULE$), oncias_SemanticState_updateVariable($this, $variable, $possibleTypes, $definition, $uses, $unionVariable));
    }
    function oncias_SemanticState_addNotification($this, $notification) {
        var var$2;
        var$2 = $this.$notifications.$incl($notification);
        return oncias_SemanticState_copy($this, $this.$currentScope, $this.$typeTable, $this.$recordedScopes, var$2, $this.$features1, $this.$declareVariablesToSuppressDuplicateErrors, $this.$semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_implicitVariable($this, $variable, $possibleTypes) {
        var $symbol, $existingTypes, $inferredTypes, $expectedTypes, var$7;
        $symbol = oncias_SemanticState_symbol($this, $variable.$name4);
        if (jl_Object_equals(s_None$_MODULE$, $symbol)) {
            s_package$_$callClinit();
            $symbol = s_package$_Right(s_package$_MODULE$);
            $existingTypes = oncias_SymbolUse$_apply(oncias_SymbolUse$_MODULE$, $variable);
            s_Predef$_$callClinit();
            s_Predef$_Set(s_Predef$_MODULE$);
            return su_Right$_apply($symbol, oncias_SemanticState_updateVariable($this, $variable, $possibleTypes, $existingTypes, sci_Set$EmptySet$_MODULE$, 0));
        }
        if (!($symbol instanceof s_Some))
            $rt_throw(s_MatchError__init_($symbol));
        $symbol = $symbol.$value5;
        $inferredTypes = oncius_TypeSpec_intersect($symbol.$types1, $possibleTypes);
        if (oncius_TypeSpec_nonEmpty($inferredTypes)) {
            s_package$_$callClinit();
            return su_Right$_apply(s_package$_Right(s_package$_MODULE$), oncias_SemanticState_updateVariable($this, $variable, $inferredTypes, $symbol.$definition, $symbol.$uses.$incl(oncias_SymbolUse$_apply(oncias_SymbolUse$_MODULE$, $variable)), 0));
        }
        $existingTypes = oncius_TypeSpec_mkString($symbol.$types1, $rt_s(16), $rt_s(442));
        $expectedTypes = oncius_TypeSpec_mkString($possibleTypes, $rt_s(16), $rt_s(442));
        s_package$_$callClinit();
        $possibleTypes = s_package$_Left(s_package$_MODULE$);
        $symbol = new oncias_SemanticError;
        var$7 = $variable.$name4;
        $inferredTypes = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($inferredTypes);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($inferredTypes, $rt_s(443)), var$7), $rt_s(444)), $existingTypes), $rt_s(445)), $expectedTypes), 41);
        oncias_SemanticError__init_($symbol, jl_AbstractStringBuilder_toString($inferredTypes), $variable.$position0);
        return su_Left$_apply($possibleTypes, $symbol);
    }
    function oncias_SemanticState_ensureVariableDefined($this, $variable) {
        var $symbol, var$3, var$4, var$5;
        $symbol = oncias_SemanticState_symbol($this, $variable.$name4);
        if (jl_Object_equals(s_None$_MODULE$, $symbol)) {
            s_package$_$callClinit();
            $symbol = s_package$_Left(s_package$_MODULE$);
            var$3 = new oncias_SemanticError;
            var$4 = $variable.$name4;
            var$5 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$5);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(440)), var$4), $rt_s(446));
            oncias_SemanticError__init_(var$3, jl_AbstractStringBuilder_toString(var$5), $variable.$position0);
            return su_Left$_apply($symbol, var$3);
        }
        if (!($symbol instanceof s_Some))
            $rt_throw(s_MatchError__init_($symbol));
        $symbol = $symbol.$value5;
        s_package$_$callClinit();
        return su_Right$_apply(s_package$_Right(s_package$_MODULE$), oncias_SemanticState_updateVariable($this, $variable, $symbol.$types1, $symbol.$definition, $symbol.$uses.$incl(oncias_SymbolUse$_apply(oncias_SymbolUse$_MODULE$, $variable)), 0));
    }
    function oncias_SemanticState_expressionType($this, $expression) {
        return $this.$typeTable.$getOrElse0(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $expression), new oncias_SemanticState$expressionType$lambda$_42_0);
    }
    function oncias_SemanticState_updateVariable($this, $variable, $types, $definition, $uses, $unionVariable) {
        var var$6, var$7, var$8, var$9, var$10;
        var$6 = $this.$currentScope;
        var$7 = $variable.$name4;
        oncias_SemanticState$_$callClinit();
        var$8 = var$6.$elem;
        var$9 = var$8.$symbolTable;
        var$10 = new oncias_Symbol;
        var$10.$name17 = var$7;
        var$10.$types1 = $types;
        var$10.$definition = $definition;
        var$10.$uses = $uses;
        var$10.$unionSymbol = $unionVariable;
        return oncias_SemanticState_copy($this, onciuh_TreeZipper$Location_replace(var$6, oncias_Scope_copy(var$8, var$9.$updated1(var$7, var$10), var$8.$children1)), $this.$typeTable.$updated1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $variable), oncias_ExpressionTypeInfo$_apply(oncias_ExpressionTypeInfo$_MODULE$, $types, s_None$_MODULE$)), $this.$recordedScopes, $this.$notifications, $this.$features1, $this.$declareVariablesToSuppressDuplicateErrors,
        $this.$semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_recordCurrentScope($this, $astNode) {
        var $x$1;
        $x$1 = $this.$recordedScopes.$updated1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $astNode), oncias_SemanticState$ScopeLocation__init_($this.$currentScope));
        return oncias_SemanticState_copy($this, $this.$currentScope, $this.$typeTable, $x$1, $this.$notifications, $this.$features1, $this.$declareVariablesToSuppressDuplicateErrors, $this.$semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_scope($this, $astNode) {
        return s_Option_map($this.$recordedScopes.$get1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $astNode)), new oncias_SemanticState$scope$lambda$_46_0);
    }
    function oncias_SemanticState_copy($this, $currentScope, $typeTable, $recordedScopes, $notifications, $features, $declareVariablesToSuppressDuplicateErrors, $semanticCheckHasRunOnce) {
        return oncias_SemanticState__init_($currentScope, $typeTable, $recordedScopes, $notifications, $features, $declareVariablesToSuppressDuplicateErrors, $semanticCheckHasRunOnce);
    }
    function oncias_SemanticState_productPrefix($this) {
        return $rt_s(447);
    }
    function oncias_SemanticState_productArity($this) {
        return 7;
    }
    function oncias_SemanticState_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return oncias_SemanticState$ScopeLocation__init_($this.$currentScope);
            case 1:
                return $this.$typeTable;
            case 2:
                return $this.$recordedScopes;
            case 3:
                return $this.$notifications;
            case 4:
                return $this.$features1;
            case 5:
                return jl_Boolean_valueOf($this.$declareVariablesToSuppressDuplicateErrors);
            case 6:
                return jl_Boolean_valueOf($this.$semanticCheckHasRunOnce);
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticState_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticState_hashCode($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(447))), sr_Statics_anyHash(oncias_SemanticState$ScopeLocation__init_($this.$currentScope))), sr_Statics_anyHash($this.$typeTable)), sr_Statics_anyHash($this.$recordedScopes)), sr_Statics_anyHash($this.$notifications)), sr_Statics_anyHash($this.$features1)), !$this.$declareVariablesToSuppressDuplicateErrors ? 1237 : 1231),
        !$this.$semanticCheckHasRunOnce ? 1237 : 1231), 7);
    }
    function oncias_SemanticState_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticState_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncias_SemanticState) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$declareVariablesToSuppressDuplicateErrors != $x$1.$declareVariablesToSuppressDuplicateErrors)
                        break b;
                    if ($this.$semanticCheckHasRunOnce != $x$1.$semanticCheckHasRunOnce)
                        break b;
                    c: {
                        var$2 = $this.$currentScope;
                        var$3 = $x$1.$currentScope;
                        if (var$2 !== null) {
                            if (!onciuh_TreeZipper$Location_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$typeTable;
                        var$3 = $x$1.$typeTable;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$recordedScopes;
                        var$3 = $x$1.$recordedScopes;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$notifications;
                        var$3 = $x$1.$notifications;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$3 = $this.$features1;
                        $x$1 = $x$1.$features1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break g;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncias_SemanticState))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncias_SemanticState__init_0($this, $currentScope, $typeTable, $recordedScopes, $notifications, $features, $declareVariablesToSuppressDuplicateErrors, $semanticCheckHasRunOnce) {
        $this.$currentScope = $currentScope;
        $this.$typeTable = $typeTable;
        $this.$recordedScopes = $recordedScopes;
        $this.$notifications = $notifications;
        $this.$features1 = $features;
        $this.$declareVariablesToSuppressDuplicateErrors = $declareVariablesToSuppressDuplicateErrors;
        $this.$semanticCheckHasRunOnce = $semanticCheckHasRunOnce;
    }
    function oncias_SemanticTable() {
        var a = this; jl_Object.call(a);
        a.$types = null;
        a.$recordedScopes1 = null;
        a.$resolvedLabelNames = null;
        a.$resolvedPropertyKeyNames = null;
        a.$resolvedRelTypeNames = null;
    }
    function oncias_SemanticTable__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncias_SemanticTable();
        oncias_SemanticTable__init_0(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    function oncias_SemanticTable_typeFor($this, $expr) {
        var var$2;
        var$2 = new oncias_SemanticTable$TypeGetter;
        var$2.$typeInfo = s_Option_map($this.$types.$get1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $expr)), new oncias_SemanticTable$typeFor$lambda$_18_0);
        return var$2;
    }
    function oncias_SemanticTable__init_0($this, $types, $recordedScopes, $resolvedLabelNames, $resolvedPropertyKeyNames, $resolvedRelTypeNames) {
        $this.$types = $types;
        $this.$recordedScopes1 = $recordedScopes;
        $this.$resolvedLabelNames = $resolvedLabelNames;
        $this.$resolvedPropertyKeyNames = $resolvedPropertyKeyNames;
        $this.$resolvedRelTypeNames = $resolvedRelTypeNames;
    }
    function oncifp_Phase$transform$lambda$_2_0() {
        var a = this; jl_Object.call(a);
        a.$_023 = null;
        a.$_18 = null;
        a.$_26 = null;
    }
    var oncifh_package$ = $rt_classWithoutFields();
    var oncifh_package$_MODULE$ = null;
    function oncifh_package$__clinit_() {
        oncifh_package$_MODULE$ = new oncifh_package$;
    }
    function oncifp_Transformer$$anonfun$1() {
        sr_AbstractPartialFunction.call(this);
        this.$state$1 = null;
    }
    function oncifp_Transformer$$anonfun$1_applyOrElse($this, $x, $default) {
        $x = $x;
        return !$rt_isInstance($x, oncir_ValidatingCondition) ? $default.$apply($x) : $x.$apply($this.$state$1);
    }
    function scm_HashMap$Node() {
        var a = this; jl_Object.call(a);
        a.$_key = null;
        a.$_hash = 0;
        a.$_value = null;
        a.$_next = null;
    }
    function scm_HashMap$Node__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new scm_HashMap$Node();
        scm_HashMap$Node__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function scm_HashMap$Node_findNode($this, $k, $h) {
        var $this_0;
        a: {
            while (!($h == $this.$_hash && sr_BoxesRunTime_equals($k, $this.$_key))) {
                $this_0 = $this.$_next;
                if ($this_0 === null)
                    break a;
                if ($this.$_hash > $h)
                    break a;
                $this = $this_0;
            }
            return $this;
        }
        return null;
    }
    function scm_HashMap$Node_toString($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 14);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(448));
        var$1 = jl_StringBuilder_append(var$1, $this.$_key);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(16));
        var$1 = jl_StringBuilder_append(var$1, $this.$_value);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(16));
        var$1 = jl_StringBuilder_append0(var$1, $this.$_hash);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(449));
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$1, $this.$_next));
    }
    function scm_HashMap$Node__init_0($this, $_key, $_hash, $_value, $_next) {
        $this.$_key = $_key;
        $this.$_hash = $_hash;
        $this.$_value = $_value;
        $this.$_next = $_next;
    }
    var oncifh_package$$closing$default$3$lambda$_2_0 = $rt_classWithoutFields();
    function oncifh_package$$closing$default$3$lambda$_2_0_apply(var$0, var$1) {
        return sr_BoxedUnit_UNIT;
    }
    var oncifh_package$$closing$default$4$lambda$_3_0 = $rt_classWithoutFields();
    function oncifh_package$$closing$default$4$lambda$_3_0_apply(var$0, var$1, var$2) {
        return sr_BoxedUnit_UNIT;
    }
    function oncifh_package$$closing$lambda$_1_0() {
        jl_Object.call(this);
        this.$_024 = null;
    }
    function oncifh_package$$closing$lambda$_1_0_apply(var$0, var$1) {
        var var$2;
        var$1 = var$0.$_024;
        var$2 = var$1.$_023;
        var$1 = var$2.$process(var$1.$_18, var$1.$_26);
        onciu_AssertionRunner_$callClinit();
        if (onciu_AssertionRunner_ASSERTIONS_ENABLED && !var$2.$checkConditions(var$1, var$2.$postConditions0()))
            $rt_throw(jl_AssertionError__init_($rt_s(75)));
        return var$1;
    }
    var sr_ClassValueCompat$ClassValueInterface = $rt_classWithoutFields(0);
    function sr_ClassValueCompat() {
        jl_Object.call(this);
        this.$instance0 = null;
    }
    var sr_ClassTag$cache$ = $rt_classWithoutFields(sr_ClassValueCompat);
    var sr_ClassTag$cache$_MODULE$ = null;
    function sr_ClassTag$cache$_$callClinit() {
        sr_ClassTag$cache$_$callClinit = $rt_eraseClinit(sr_ClassTag$cache$);
        sr_ClassTag$cache$__clinit_();
    }
    function sr_ClassTag$cache$__clinit_() {
        var var$1, var$2;
        var$1 = new sr_ClassTag$cache$;
        sr_ClassTag$cache$_$callClinit();
        sr_ClassValueCompat$_$callClinit();
        if (!sr_ClassValueCompat$_scala$runtime$ClassValueCompat$$classValueAvailable) {
            var$2 = new sr_ClassValueCompat$FallbackClassValue;
            var$2.$$outer14 = var$1;
        } else {
            var$2 = new sr_ClassValueCompat$JavaClassValue;
            var$2.$$outer15 = var$1;
        }
        var$1.$instance0 = var$2;
        sr_ClassTag$cache$_MODULE$ = var$1;
    }
    function sr_ClassTag$cache$_computeTag($this, $runtimeClass) {
        var var$2;
        if (jl_Class_isPrimitive($runtimeClass))
            return sr_ClassTag$cache$_primitiveClassTag($this, $runtimeClass);
        sr_ClassTag$_$callClinit();
        var$2 = sr_ClassTag$_scala$reflect$ClassTag$$ObjectTYPE;
        if (var$2 !== null && jl_Object_equals(var$2, $runtimeClass))
            return sr_ClassTag$_Object;
        var$2 = sr_ClassTag$_scala$reflect$ClassTag$$NothingTYPE;
        if (var$2 !== null && jl_Object_equals(var$2, $runtimeClass))
            return sr_ClassTag$_Nothing;
        var$2 = sr_ClassTag$_scala$reflect$ClassTag$$NullTYPE;
        if (var$2 !== null && jl_Object_equals(var$2, $runtimeClass))
            return sr_ClassTag$_Null;
        var$2 = new sr_ClassTag$GenericClassTag;
        var$2.$runtimeClass1 = $runtimeClass;
        return var$2;
    }
    function sr_ClassTag$cache$_primitiveClassTag($this, $runtimeClass) {
        if (jl_Object_equals($rt_cls($rt_bytecls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Byte0(sr_ClassTag$_MODULE$);
        }
        if (jl_Object_equals($rt_cls($rt_shortcls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Short0(sr_ClassTag$_MODULE$);
        }
        if (jl_Object_equals($rt_cls($rt_charcls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Char0(sr_ClassTag$_MODULE$);
        }
        if (jl_Object_equals($rt_cls($rt_intcls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Int0(sr_ClassTag$_MODULE$);
        }
        if (jl_Object_equals($rt_cls($rt_longcls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Long0(sr_ClassTag$_MODULE$);
        }
        if (jl_Object_equals($rt_cls($rt_floatcls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Float0(sr_ClassTag$_MODULE$);
        }
        if (jl_Object_equals($rt_cls($rt_doublecls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Double0(sr_ClassTag$_MODULE$);
        }
        if (jl_Object_equals($rt_cls($rt_booleancls()), $runtimeClass)) {
            sr_ClassTag$_$callClinit();
            return sr_ClassTag$_Boolean0(sr_ClassTag$_MODULE$);
        }
        if (!jl_Object_equals($rt_cls($rt_voidcls()), $runtimeClass))
            $rt_throw(s_MatchError__init_($runtimeClass));
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Unit0(sr_ClassTag$_MODULE$);
    }
    function sr_ClassTag$cache$_computeValue($this, $cls) {
        var var$2;
        var$2 = new jlr_WeakReference;
        var$2.$value9 = sr_ClassTag$cache$_computeTag($this, $cls);
        return var$2;
    }
    var jlr_Reference = $rt_classWithoutFields();
    function jlr_WeakReference() {
        jlr_Reference.call(this);
        this.$value9 = null;
    }
    var oncifp_DeprecatedSyntaxReplaced$ = $rt_classWithoutFields();
    var oncifp_DeprecatedSyntaxReplaced$_MODULE$ = null;
    function oncifp_DeprecatedSyntaxReplaced$__clinit_() {
        oncifp_DeprecatedSyntaxReplaced$_MODULE$ = new oncifp_DeprecatedSyntaxReplaced$;
    }
    function oncifp_DeprecatedSyntaxReplaced$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncifp_DeprecatedSyntaxReplaced$_productArity($this) {
        return 0;
    }
    function oncifp_DeprecatedSyntaxReplaced$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_DeprecatedSyntaxReplaced$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_DeprecatedSyntaxReplaced$_hashCode($this) {
        return 1874952678;
    }
    function oncifp_DeprecatedSyntaxReplaced$_toString($this) {
        return $rt_s(450);
    }
    var oncifp_DeprecatedSemanticsReplaced$ = $rt_classWithoutFields();
    var oncifp_DeprecatedSemanticsReplaced$_MODULE$ = null;
    function oncifp_DeprecatedSemanticsReplaced$__clinit_() {
        oncifp_DeprecatedSemanticsReplaced$_MODULE$ = new oncifp_DeprecatedSemanticsReplaced$;
    }
    function oncifp_DeprecatedSemanticsReplaced$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncifp_DeprecatedSemanticsReplaced$_productArity($this) {
        return 0;
    }
    function oncifp_DeprecatedSemanticsReplaced$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_DeprecatedSemanticsReplaced$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_DeprecatedSemanticsReplaced$_hashCode($this) {
        return (-85453526);
    }
    function oncifp_DeprecatedSemanticsReplaced$_toString($this) {
        return $rt_s(451);
    }
    var oncifpf_PlanPipelineTransformerFactory = $rt_classWithoutFields(0);
    var oncifp_SemanticAnalysis$ = $rt_classWithoutFields();
    var oncifp_SemanticAnalysis$_MODULE$ = null;
    function oncifp_SemanticAnalysis$__clinit_() {
        oncifp_SemanticAnalysis$_MODULE$ = new oncifp_SemanticAnalysis$;
    }
    var oncifp_PreparatoryRewriting$SemanticAnalysisPossible$ = $rt_classWithoutFields();
    var oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_MODULE$ = null;
    function oncifp_PreparatoryRewriting$SemanticAnalysisPossible$__clinit_() {
        oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_MODULE$ = new oncifp_PreparatoryRewriting$SemanticAnalysisPossible$;
    }
    function oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_productArity($this) {
        return 0;
    }
    function oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_hashCode($this) {
        return 727969395;
    }
    function oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_toString($this) {
        return $rt_s(452);
    }
    var oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$ = $rt_classWithoutFields();
    var oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_MODULE$ = null;
    function oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$__clinit_() {
        oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_MODULE$ = new oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$;
    }
    function oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_productArity($this) {
        return 0;
    }
    function oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_hashCode($this) {
        return 1592000654;
    }
    function oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_toString($this) {
        return $rt_s(453);
    }
    var ju_NoSuchElementException = $rt_classWithoutFields(jl_RuntimeException);
    var s_Array$ = $rt_classWithoutFields();
    var s_Array$_MODULE$ = null;
    var s_Array$_emptyBooleanArray = null;
    var s_Array$_emptyByteArray = null;
    var s_Array$_emptyCharArray = null;
    var s_Array$_emptyDoubleArray = null;
    var s_Array$_emptyFloatArray = null;
    var s_Array$_emptyIntArray = null;
    var s_Array$_emptyLongArray = null;
    var s_Array$_emptyShortArray = null;
    var s_Array$_emptyObjectArray = null;
    function s_Array$__clinit_() {
        s_Array$_MODULE$ = new s_Array$;
        s_Array$_emptyBooleanArray = $rt_createBooleanArray(0);
        s_Array$_emptyByteArray = $rt_createByteArray(0);
        s_Array$_emptyCharArray = $rt_createCharArray(0);
        s_Array$_emptyDoubleArray = $rt_createDoubleArray(0);
        s_Array$_emptyFloatArray = $rt_createFloatArray(0);
        s_Array$_emptyIntArray = $rt_createIntArray(0);
        s_Array$_emptyLongArray = $rt_createLongArray(0);
        s_Array$_emptyShortArray = $rt_createShortArray(0);
        s_Array$_emptyObjectArray = $rt_createArray(jl_Object, 0);
    }
    function s_Array$_from($this, $it, $evidence$3) {
        if (!$rt_isInstance($it, sc_Iterable))
            return ($it.$iterator0()).$toArray($evidence$3);
        return $it.$toArray($evidence$3);
    }
    function s_Array$_copy($this, $src, $srcPos, $dest, $destPos, $length) {
        var $srcClass, var$7;
        $srcClass = jl_Object_getClass($src);
        if (jl_Class_isArray($srcClass) && jl_Class_isAssignableFrom(jl_Object_getClass($dest), $srcClass)) {
            jl_System_arraycopy($src, $srcPos, $dest, $destPos, $length);
            return;
        }
        $length = $srcPos + $length | 0;
        while ($srcPos < $length) {
            var$7 = sr_ScalaRunTime$_MODULE$;
            sr_ScalaRunTime$_array_update(var$7, $dest, $destPos, sr_ScalaRunTime$_array_apply(var$7, $src, $srcPos));
            $srcPos = $srcPos + 1 | 0;
            $destPos = $destPos + 1 | 0;
        }
    }
    function s_Array$_copyOf($this, $original, $newLength) {
        var $newUnitArray_result, var$4, var$5, var$6;
        if ($rt_isInstance($original, $rt_arraycls(sr_BoxedUnit))) {
            $newUnitArray_result = $rt_createArray(sr_BoxedUnit, $newLength);
            ju_Arrays_fill1($newUnitArray_result, sr_BoxedUnit_UNIT);
            return $newUnitArray_result;
        }
        if ($rt_isInstance($original, $rt_arraycls(jl_Object)))
            return ju_Arrays_copyOf($original, $newLength);
        if ($rt_isInstance($original, $rt_arraycls($rt_intcls())))
            return ju_Arrays_copyOf2($original, $newLength);
        if ($rt_isInstance($original, $rt_arraycls($rt_doublecls()))) {
            var$4 = $original.data;
            $newUnitArray_result = $rt_createDoubleArray($newLength);
            var$5 = $newUnitArray_result.data;
            $newLength = jl_Math_min($newLength, var$4.length);
            var$6 = 0;
            while (var$6 < $newLength) {
                var$5[var$6] = var$4[var$6];
                var$6 = var$6 + 1 | 0;
            }
            return $newUnitArray_result;
        }
        if ($rt_isInstance($original, $rt_arraycls($rt_longcls()))) {
            var$4 = $original.data;
            $newUnitArray_result = $rt_createLongArray($newLength);
            var$5 = $newUnitArray_result.data;
            $newLength = jl_Math_min($newLength, var$4.length);
            var$6 = 0;
            while (var$6 < $newLength) {
                var$5[var$6] = var$4[var$6];
                var$6 = var$6 + 1 | 0;
            }
            return $newUnitArray_result;
        }
        if ($rt_isInstance($original, $rt_arraycls($rt_floatcls()))) {
            var$4 = $original.data;
            $newUnitArray_result = $rt_createFloatArray($newLength);
            var$5 = $newUnitArray_result.data;
            $newLength = jl_Math_min($newLength, var$4.length);
            var$6 = 0;
            while (var$6 < $newLength) {
                var$5[var$6] = var$4[var$6];
                var$6 = var$6 + 1 | 0;
            }
            return $newUnitArray_result;
        }
        if ($rt_isInstance($original, $rt_arraycls($rt_charcls())))
            return ju_Arrays_copyOf0($original, $newLength);
        if ($rt_isInstance($original, $rt_arraycls($rt_bytecls())))
            return ju_Arrays_copyOf1($original, $newLength);
        if ($rt_isInstance($original, $rt_arraycls($rt_shortcls()))) {
            var$4 = $original.data;
            $newUnitArray_result = $rt_createShortArray($newLength);
            var$5 = $newUnitArray_result.data;
            $newLength = jl_Math_min($newLength, var$4.length);
            var$6 = 0;
            while (var$6 < $newLength) {
                var$5[var$6] = var$4[var$6];
                var$6 = var$6 + 1 | 0;
            }
            return $newUnitArray_result;
        }
        if (!$rt_isInstance($original, $rt_arraycls($rt_booleancls())))
            $rt_throw(s_MatchError__init_($original));
        var$4 = $original.data;
        $newUnitArray_result = $rt_createBooleanArray($newLength);
        var$5 = $newUnitArray_result.data;
        $newLength = jl_Math_min($newLength, var$4.length);
        var$6 = 0;
        while (var$6 < $newLength) {
            var$5[var$6] = var$4[var$6];
            var$6 = var$6 + 1 | 0;
        }
        return $newUnitArray_result;
    }
    function s_Array$_copyAs($this, $original, $newLength, $ct) {
        var $runtimeClass, $newUnitArray_result, $dest, $destArrayClass, var$8, var$9;
        $runtimeClass = $ct.$runtimeClass();
        if ($runtimeClass !== null && jl_Object_equals($runtimeClass, $rt_cls($rt_voidcls()))) {
            $newUnitArray_result = $rt_createArray(sr_BoxedUnit, $newLength);
            ju_Arrays_fill1($newUnitArray_result, sr_BoxedUnit_UNIT);
            return $newUnitArray_result;
        }
        if (!jl_Class_isAssignableFrom($runtimeClass, jl_Class_getComponentType(jl_Object_getClass($original)))) {
            $dest = $ct.$newArray($newLength);
            s_Array$_copy($this, $original, 0, $dest, 0, jlr_Array_getLength($original));
            return $dest;
        }
        if (jl_Class_isPrimitive($runtimeClass))
            return s_Array$_copyOf($this, $original, $newLength);
        $destArrayClass = jl_Object_getClass(jlr_Array_newInstance($runtimeClass, 0));
        var$8 = $original.data;
        $original = jl_Class_getComponentType($destArrayClass);
        $newUnitArray_result = jlr_Array_newInstance($original, $newLength);
        $newLength = jl_Math_min($newLength, var$8.length);
        var$9 = 0;
        while (var$9 < $newLength) {
            $ct = var$8[var$9];
            if ($ct !== null && !jl_Class_isAssignableFrom($original, jl_Object_getClass($ct))) {
                $dest = new jl_ClassCastException;
                $ct = jl_Class_getName(jl_Object_getClass($ct));
                $original = jl_Class_getName($original);
                $runtimeClass = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($runtimeClass);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($runtimeClass, $ct), $rt_s(454)), $original);
                jl_Throwable__init_($dest, jl_AbstractStringBuilder_toString($runtimeClass));
                $rt_throw($dest);
            }
            $newUnitArray_result.data[var$9] = $ct;
            var$9 = var$9 + 1 | 0;
        }
        return $newUnitArray_result;
    }
    function s_Array$_equals($this, $xs, $ys) {
        var var$3, $i, var$5;
        a: {
            if ($xs !== $ys) {
                $ys = $ys.data;
                $xs = $xs.data;
                var$3 = $xs.length;
                if (var$3 != $ys.length)
                    break a;
                $i = 0;
                while (true) {
                    var$5 = $rt_compare($i, var$3);
                    if (var$5 >= 0)
                        break;
                    if (!sr_BoxesRunTime_equals($xs[$i], $ys[$i]))
                        break;
                    $i = $i + 1 | 0;
                }
                if (var$5 < 0)
                    break a;
            }
            return 1;
        }
        return 0;
    }
    var sci_Range$Exclusive = $rt_classWithoutFields(sci_Range);
    function sci_Range$Exclusive_isInclusive($this) {
        return 0;
    }
    var oncifp_CompilationPhaseTracer = $rt_classWithoutFields(0);
    var oncifp_CompilationPhaseTracer_NONE_PHASE = null;
    var oncifp_CompilationPhaseTracer_NO_TRACING = null;
    function oncifp_CompilationPhaseTracer__clinit_() {
        oncifp_CompilationPhaseTracer_NONE_PHASE = new oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_0;
        oncifp_CompilationPhaseTracer_NO_TRACING = new oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_1;
    }
    function sci_HashSetBuilder() {
        var a = this; jl_Object.call(a);
        a.$aliased = null;
        a.$scala$collection$immutable$HashSetBuilder$$rootNode = null;
    }
    function sci_HashSetBuilder__init_() {
        var var_0 = new sci_HashSetBuilder();
        sci_HashSetBuilder__init_0(var_0);
        return var_0;
    }
    function sci_HashSetBuilder_sizeHint($this, $size) {}
    function sci_HashSetBuilder_sizeHint0($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    }
    function sci_HashSetBuilder_update($this, $setNode, $element, $originalHash, $elementHash, $shift) {
        var $index, $mask, $bitpos, $element0, $element0UnimprovedHash, $element0Hash, $subNode, $beforeSize, $beforeHashCode, var$15, var$16, var$17, var$18;
        if (!($setNode instanceof sci_BitmapIndexedSetNode)) {
            if (!($setNode instanceof sci_HashCollisionSetNode))
                $rt_throw(s_MatchError__init_($setNode));
            $setNode = $setNode;
            $index = sc_AbstractSeq_indexOf0($setNode.$content0, $element);
            if ($index >= 0) {
                $setNode.$content0 = $setNode.$content0.$updated2($index, $element);
                return;
            }
            $setNode.$content0 = $setNode.$content0.$appended1($element);
            return;
        }
        $setNode = $setNode;
        $mask = $elementHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $index = $setNode.$dataMap;
        if ($index & $bitpos) {
            $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos);
            $element0 = $setNode.$content1.data[$index];
            $element0UnimprovedHash = $setNode.$originalHashes0.data[$index];
            if ($element0UnimprovedHash == $originalHash && sr_BoxesRunTime_equals($element0, $element)) {
                $originalHash = 1 * sci_BitmapIndexedSetNode_dataIndex($setNode, $bitpos) | 0;
                $setNode.$content1.data[$originalHash] = $element0;
                return;
            }
            $element0Hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $element0UnimprovedHash);
            sci_BitmapIndexedSetNode_migrateFromInlineToNodeInPlace($setNode, $bitpos, $element0Hash, sci_BitmapIndexedSetNode_mergeTwoKeyValPairs($setNode, $element0, $element0UnimprovedHash, $element0Hash, $element, $originalHash, $elementHash, $shift + 5 | 0));
            return;
        }
        $index = $setNode.$nodeMap;
        if ($index & $bitpos) {
            $subNode = sci_BitmapIndexedSetNode_getNode($setNode, sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos));
            $beforeSize = $subNode.$size();
            $beforeHashCode = $subNode.$cachedJavaKeySetHashCode();
            sci_HashSetBuilder_update($this, $subNode, $element, $originalHash, $elementHash, $shift + 5 | 0);
            $setNode.$size4 = $setNode.$size4 + ($subNode.$size() - $beforeSize | 0) | 0;
            $setNode.$cachedJavaKeySetHashCode0 = $setNode.$cachedJavaKeySetHashCode0 + ($subNode.$cachedJavaKeySetHashCode() - $beforeHashCode | 0) | 0;
            return;
        }
        $beforeSize = sci_BitmapIndexedSetNode_dataIndex($setNode, $bitpos);
        $mask = 1 * $beforeSize | 0;
        var$15 = $setNode.$content1;
        $beforeHashCode = var$15.data.length;
        var$16 = $rt_createArray(jl_Object, $beforeHashCode + 1 | 0);
        var$17 = var$16.data;
        jl_System_arraycopy(var$15, 0, var$16, 0, $mask);
        var$17[$mask] = $element;
        jl_System_arraycopy(var$15, $mask, var$16, $mask + 1 | 0, $beforeHashCode - $mask | 0);
        var$18 = $setNode.$originalHashes0;
        if ($beforeSize < 0) {
            $setNode = new jl_ArrayIndexOutOfBoundsException;
            jl_Throwable__init_0($setNode);
            $rt_throw($setNode);
        }
        $mask = var$18.data.length;
        if ($beforeSize > $mask) {
            $setNode = new jl_ArrayIndexOutOfBoundsException;
            jl_Throwable__init_0($setNode);
            $rt_throw($setNode);
        }
        var$15 = $rt_createIntArray($mask + 1 | 0);
        var$17 = var$15.data;
        jl_System_arraycopy(var$18, 0, var$15, 0, $beforeSize);
        var$17[$beforeSize] = $originalHash;
        jl_System_arraycopy(var$18, $beforeSize, var$15, $beforeSize + 1 | 0, $mask - $beforeSize | 0);
        $setNode.$dataMap = $setNode.$dataMap | $bitpos;
        $setNode.$content1 = var$16;
        $setNode.$originalHashes0 = var$15;
        $setNode.$size4 = $setNode.$size4 + 1 | 0;
        $setNode.$cachedJavaKeySetHashCode0 = $setNode.$cachedJavaKeySetHashCode0 + $elementHash | 0;
    }
    function sci_HashSetBuilder_ensureUnaliased($this) {
        if ($this.$aliased === null ? 0 : 1)
            $this.$scala$collection$immutable$HashSetBuilder$$rootNode = sci_BitmapIndexedSetNode_copy($this.$scala$collection$immutable$HashSetBuilder$$rootNode);
        $this.$aliased = null;
    }
    function sci_HashSetBuilder_result($this) {
        var var$1, var$2;
        var$1 = $this.$scala$collection$immutable$HashSetBuilder$$rootNode;
        if (!var$1.$size4) {
            sci_HashSet$_$callClinit();
            return sci_HashSet$_empty(sci_HashSet$_MODULE$);
        }
        var$2 = $this.$aliased;
        if (var$2 !== null)
            return var$2;
        var$2 = sci_HashSet__init_(var$1);
        $this.$aliased = var$2;
        return var$2;
    }
    function sci_HashSetBuilder_addOne($this, $elem) {
        var $h, $im;
        sci_HashSetBuilder_ensureUnaliased($this);
        $h = sr_Statics_anyHash($elem);
        $im = sc_Hashing$_improve(sc_Hashing$_MODULE$, $h);
        sci_HashSetBuilder_update($this, $this.$scala$collection$immutable$HashSetBuilder$$rootNode, $elem, $h, $im, 0);
        return $this;
    }
    function sci_HashSetBuilder_addAll($this, $xs) {
        var $it, var$3;
        a: {
            sci_HashSetBuilder_ensureUnaliased($this);
            if (!($xs instanceof sci_HashSet)) {
                $it = $xs.$iterator0();
                while (true) {
                    if (!$it.$hasNext())
                        break a;
                    sci_HashSetBuilder_addOne($this, $it.$next());
                }
            }
            $xs = $xs;
            $it = new sci_HashSetBuilder$$anon$1;
            sci_ChampBaseIterator__init_($it, $xs.$rootNode0);
            while (sci_ChampBaseIterator_hasNext($it)) {
                var$3 = $it.$currentValueNode.$getHash($it.$currentValueCursor);
                sci_HashSetBuilder_update($this, $this.$scala$collection$immutable$HashSetBuilder$$rootNode, $it.$currentValueNode.$getPayload($it.$currentValueCursor), var$3, sc_Hashing$_improve(sc_Hashing$_MODULE$, var$3), 0);
                $it.$currentValueCursor = $it.$currentValueCursor + 1 | 0;
            }
        }
        return $this;
    }
    function sci_HashSetBuilder_addAll0($this, $xs) {
        return sci_HashSetBuilder_addAll($this, $xs);
    }
    function sci_HashSetBuilder_addOne0($this, $elem) {
        return sci_HashSetBuilder_addOne($this, $elem);
    }
    function sci_HashSetBuilder_result0($this) {
        return sci_HashSetBuilder_result($this);
    }
    function sci_HashSetBuilder__init_0($this) {
        $this.$scala$collection$immutable$HashSetBuilder$$rootNode = sci_BitmapIndexedSetNode__init_(0, 0, s_Array$_emptyObjectArray, s_Array$_emptyIntArray, 0, 0);
    }
    function jl_Float() {
        jl_Number.call(this);
        this.$value4 = 0.0;
    }
    var jl_Float_NaN = 0.0;
    var jl_Float_TYPE = null;
    function jl_Float_intValue($this) {
        return $this.$value4 | 0;
    }
    function jl_Float_longValue($this) {
        return Long_fromNumber($this.$value4);
    }
    function jl_Float_floatValue($this) {
        return $this.$value4;
    }
    function jl_Float_doubleValue($this) {
        return $this.$value4;
    }
    function jl_Float_valueOf($d) {
        var var$2;
        var$2 = new jl_Float;
        var$2.$value4 = $d;
        return var$2;
    }
    function jl_Float_toString($this) {
        var var$1, var$2;
        var$1 = $this.$value4;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append3(var$2, var$1));
    }
    function jl_Float_equals($this, $other) {
        if ($this === $other)
            return 1;
        return $other instanceof jl_Float && $other.$value4 === $this.$value4 ? 1 : 0;
    }
    function jl_Float_hashCode0($this) {
        return jl_Float_hashCode($this.$value4);
    }
    function jl_Float_hashCode($f) {
        return $rt_floatToIntBits($f);
    }
    function jl_Float__clinit_() {
        jl_Float_NaN = $rt_globals.NaN;
        jl_Float_TYPE = $rt_cls($rt_floatcls());
    }
    var jl_AbstractStringBuilder$Constants = $rt_classWithoutFields();
    var jl_AbstractStringBuilder$Constants_intPowersOfTen = null;
    var jl_AbstractStringBuilder$Constants_longPowersOfTen = null;
    var jl_AbstractStringBuilder$Constants_longLogPowersOfTen = null;
    var jl_AbstractStringBuilder$Constants_doubleAnalysisResult = null;
    var jl_AbstractStringBuilder$Constants_floatAnalysisResult = null;
    function jl_AbstractStringBuilder$Constants__clinit_() {
        jl_AbstractStringBuilder$Constants_intPowersOfTen = $rt_createIntArrayFromData([1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000]);
        jl_AbstractStringBuilder$Constants_longPowersOfTen = $rt_createLongArrayFromData([Long_fromInt(1), Long_fromInt(10), Long_fromInt(100), Long_fromInt(1000), Long_fromInt(10000), Long_fromInt(100000), Long_fromInt(1000000), Long_fromInt(10000000), Long_fromInt(100000000), Long_fromInt(1000000000), Long_create(1410065408, 2), Long_create(1215752192, 23), Long_create(3567587328, 232), Long_create(1316134912, 2328), Long_create(276447232, 23283), Long_create(2764472320, 232830), Long_create(1874919424, 2328306),
        Long_create(1569325056, 23283064), Long_create(2808348672, 232830643)]);
        jl_AbstractStringBuilder$Constants_longLogPowersOfTen = $rt_createLongArrayFromData([Long_fromInt(1), Long_fromInt(10), Long_fromInt(100), Long_fromInt(10000), Long_fromInt(100000000), Long_create(1874919424, 2328306)]);
        jl_AbstractStringBuilder$Constants_doubleAnalysisResult = new otcit_DoubleAnalyzer$Result;
        jl_AbstractStringBuilder$Constants_floatAnalysisResult = new otcit_FloatAnalyzer$Result;
    }
    var otcit_FloatAnalyzer = $rt_classWithoutFields();
    var otcit_FloatAnalyzer_mantissa10Table = null;
    var otcit_FloatAnalyzer_exp10Table = null;
    function otcit_FloatAnalyzer_analyze($d, $result) {
        var $bits, $mantissa, $exponent, $errorShift, $decExponent, var$8, $mantissaShift, var$10, var$11, $decMantissa, $error, $upError, $downError, $lowerPos, $upperPos;
        $bits = $rt_floatToIntBits($d);
        $result.$sign = !($bits & (-2147483648)) ? 0 : 1;
        $mantissa = $bits & 8388607;
        $exponent = $bits >> 23 & 255;
        if (!$mantissa && !$exponent) {
            $result.$mantissa = 0;
            $result.$exponent = 0;
            return;
        }
        $errorShift = 0;
        if ($exponent)
            $mantissa = $mantissa | 8388608;
        else {
            $mantissa = $mantissa << 1;
            while (Long_eq(Long_and(Long_fromInt($mantissa), Long_fromInt(8388608)), Long_ZERO)) {
                $mantissa = $mantissa << 1;
                $exponent = $exponent + (-1) | 0;
                $errorShift = $errorShift + 1 | 0;
            }
        }
        $decExponent = ju_Arrays_binarySearch(otcit_FloatAnalyzer_exp10Table, $exponent);
        if ($decExponent < 0)
            $decExponent = ( -$decExponent | 0) - 2 | 0;
        var$8 = otcit_FloatAnalyzer_exp10Table.data;
        $mantissaShift = 9 + ($exponent - var$8[$decExponent] | 0) | 0;
        var$10 = Long_fromInt($mantissa);
        var$11 = otcit_FloatAnalyzer_mantissa10Table.data;
        $decMantissa = Long_lo(Long_shru(Long_mul(var$10, Long_fromInt(var$11[$decExponent])), 32 - $mantissaShift | 0));
        if ($decMantissa >= 1000000000) {
            $decExponent = $decExponent + 1 | 0;
            $mantissaShift = 9 + ($exponent - var$8[$decExponent] | 0) | 0;
            $decMantissa = Long_lo(Long_shru(Long_mul(var$10, Long_fromInt(var$11[$decExponent])), 32 - $mantissaShift | 0));
        }
        $errorShift = (31 - $mantissaShift | 0) - $errorShift | 0;
        $error = $errorShift >= 0 ? var$11[$decExponent] >>> $errorShift : var$11[$decExponent] << ( -$errorShift | 0);
        $upError = ($error + 1 | 0) >> 1;
        $downError = $error >> 1;
        if ($mantissa == 4194304)
            $downError = $downError >> 2;
        $lowerPos = 10;
        while ($lowerPos <= $downError) {
            $lowerPos = $lowerPos * 10 | 0;
        }
        if (($decMantissa % $lowerPos | 0) >= ($downError / 2 | 0))
            $lowerPos = $lowerPos / 10 | 0;
        $upperPos = 10;
        while ($upperPos <= $upError) {
            $upperPos = $upperPos * 10 | 0;
        }
        if (($upperPos - ($decMantissa % $upperPos | 0) | 0) > ($upError / 2 | 0))
            $upperPos = $upperPos / 10 | 0;
        $mantissa = $rt_compare($lowerPos, $upperPos);
        $mantissa = $mantissa > 0 ? $rt_imul($decMantissa / $lowerPos | 0, $lowerPos) : $mantissa < 0 ? $rt_imul($decMantissa / $upperPos | 0, $upperPos) + $upperPos | 0 : $rt_imul(($decMantissa + ($upperPos / 2 | 0) | 0) / $upperPos | 0, $upperPos);
        if ($mantissa >= 1000000000) {
            $decExponent = $decExponent + 1 | 0;
            $mantissa = $mantissa / 10 | 0;
        } else if ($mantissa < 100000000) {
            $decExponent = $decExponent + (-1) | 0;
            $mantissa = $mantissa * 10 | 0;
        }
        $result.$mantissa = $mantissa;
        $result.$exponent = $decExponent - 50 | 0;
    }
    function otcit_FloatAnalyzer__clinit_() {
        var $decMantissaOne, $exponent, $i, $maxMantissa, var$5, var$6, $remainder, $shift;
        otcit_FloatAnalyzer_mantissa10Table = $rt_createIntArray(100);
        otcit_FloatAnalyzer_exp10Table = $rt_createIntArray(100);
        $decMantissaOne = 2000000000;
        $exponent = 127;
        $i = 0;
        $maxMantissa = $decMantissaOne;
        while ($i < 50) {
            var$5 = otcit_FloatAnalyzer_mantissa10Table.data;
            var$6 = $i + 50 | 0;
            var$5[var$6] = $rt_udiv($maxMantissa, 20);
            otcit_FloatAnalyzer_exp10Table.data[var$6] = $exponent;
            var$6 = $rt_udiv($maxMantissa, 10);
            $remainder = $rt_umod(var$6, 10);
            while (var$6 <= $decMantissaOne && !(var$6 & (-2147483648))) {
                var$6 = var$6 << 1;
                $exponent = $exponent + 1 | 0;
                $remainder = $remainder << 1;
            }
            $maxMantissa = var$6 + ($remainder / 10 | 0) | 0;
            $i = $i + 1 | 0;
        }
        $exponent = 127;
        $i = 0;
        while ($i < 50) {
            $shift = 0;
            $remainder = $decMantissaOne;
            while ($remainder > 214748364) {
                $remainder = $remainder >> 1;
                $shift = $shift + 1 | 0;
                $exponent = $exponent + (-1) | 0;
            }
            $remainder = $remainder * 10 | 0;
            $decMantissaOne = $shift <= 0 ? $remainder : Long_lo(Long_add(Long_fromInt($remainder), Long_shr(Long_mul(Long_fromInt($decMantissaOne & ((1 << $shift) - 1 | 0)), Long_fromInt(10)), $shift)));
            var$5 = otcit_FloatAnalyzer_mantissa10Table.data;
            $shift = (50 - $i | 0) - 1 | 0;
            var$5[$shift] = $rt_udiv($decMantissaOne, 20);
            otcit_FloatAnalyzer_exp10Table.data[$shift] = $exponent;
            $i = $i + 1 | 0;
        }
    }
    function otcit_FloatAnalyzer$Result() {
        var a = this; jl_Object.call(a);
        a.$mantissa = 0;
        a.$exponent = 0;
        a.$sign = 0;
    }
    var sc_MapOps$GenKeySet = $rt_classWithoutFields(0);
    function sc_MapOps$GenKeySet_iterator$($$this) {
        return ($$this.$scala$collection$MapOps$GenKeySet$$$outer()).$keysIterator();
    }
    function sc_MapOps$GenKeySet_knownSize$($$this) {
        return ($$this.$scala$collection$MapOps$GenKeySet$$$outer()).$knownSize();
    }
    function sc_MapOps$KeySet() {
        sc_AbstractSet.call(this);
        this.$$outer2 = null;
    }
    function sc_MapOps$KeySet_iterator($this) {
        return sc_MapOps$GenKeySet_iterator$($this);
    }
    function sc_MapOps$KeySet_knownSize($this) {
        return sc_MapOps$GenKeySet_knownSize$($this);
    }
    function sc_MapOps$KeySet_scala$collection$MapOps$GenKeySet$$$outer($this) {
        return $this.$$outer2;
    }
    function jl_Double() {
        jl_Number.call(this);
        this.$value3 = 0.0;
    }
    var jl_Double_NaN = 0.0;
    var jl_Double_TYPE = null;
    function jl_Double_doubleValue($this) {
        return $this.$value3;
    }
    function jl_Double_intValue($this) {
        return $this.$value3 | 0;
    }
    function jl_Double_longValue($this) {
        return Long_fromNumber($this.$value3);
    }
    function jl_Double_floatValue($this) {
        return $this.$value3;
    }
    function jl_Double_valueOf($d) {
        var var$2;
        var$2 = new jl_Double;
        var$2.$value3 = $d;
        return var$2;
    }
    function jl_Double_parseDouble($string) {
        var $start, $end, $negative, $c, $mantissa, $exp, $hasOneDigit, var$9, $negativeExp, $numExp, var$12, var$13, var$14;
        if (jl_String_isEmpty($string)) {
            $string = new jl_NumberFormatException;
            jl_Throwable__init_0($string);
            $rt_throw($string);
        }
        $start = 0;
        $end = jl_String_length($string);
        while (true) {
            if (jl_String_charAt($string, $start) > 32) {
                while (jl_String_charAt($string, $end - 1 | 0) <= 32) {
                    $end = $end + (-1) | 0;
                }
                $negative = 0;
                if (jl_String_charAt($string, $start) == 45) {
                    $start = $start + 1 | 0;
                    $negative = 1;
                } else if (jl_String_charAt($string, $start) == 43)
                    $start = $start + 1 | 0;
                if ($start == $end) {
                    $string = new jl_NumberFormatException;
                    jl_Throwable__init_0($string);
                    $rt_throw($string);
                }
                a: {
                    $c = jl_String_charAt($string, $start);
                    $mantissa = Long_ZERO;
                    $exp = 0;
                    $hasOneDigit = 0;
                    if ($c != 46) {
                        $hasOneDigit = 1;
                        if ($c >= 48 && $c <= 57) {
                            b: {
                                while ($start < $end) {
                                    if (jl_String_charAt($string, $start) != 48)
                                        break b;
                                    $start = $start + 1 | 0;
                                }
                            }
                            while ($start < $end) {
                                var$9 = jl_String_charAt($string, $start);
                                if (var$9 < 48)
                                    break a;
                                if (var$9 > 57)
                                    break a;
                                if (Long_ge($mantissa, Long_create(3435973827, 214748364)))
                                    $exp = $exp + 1 | 0;
                                else
                                    $mantissa = Long_add(Long_mul($mantissa, Long_fromInt(10)), Long_fromInt(var$9 - 48 | 0));
                                $start = $start + 1 | 0;
                            }
                        } else {
                            $string = new jl_NumberFormatException;
                            jl_Throwable__init_0($string);
                            $rt_throw($string);
                        }
                    }
                }
                if ($start < $end && jl_String_charAt($string, $start) == 46) {
                    $start = $start + 1 | 0;
                    c: {
                        while (true) {
                            if ($start >= $end)
                                break c;
                            $negativeExp = jl_String_charAt($string, $start);
                            if ($negativeExp < 48)
                                break c;
                            if ($negativeExp > 57)
                                break;
                            if (Long_lt($mantissa, Long_create(3435973827, 214748364))) {
                                $mantissa = Long_add(Long_mul($mantissa, Long_fromInt(10)), Long_fromInt($negativeExp - 48 | 0));
                                $exp = $exp + (-1) | 0;
                            }
                            $start = $start + 1 | 0;
                            $hasOneDigit = 1;
                        }
                    }
                    if (!$hasOneDigit) {
                        $string = new jl_NumberFormatException;
                        jl_Throwable__init_0($string);
                        $rt_throw($string);
                    }
                }
                if ($start < $end) {
                    $negativeExp = jl_String_charAt($string, $start);
                    if ($negativeExp != 101 && $negativeExp != 69) {
                        $string = new jl_NumberFormatException;
                        jl_Throwable__init_0($string);
                        $rt_throw($string);
                    }
                    var$9 = $start + 1 | 0;
                    $negativeExp = 0;
                    if (var$9 == $end) {
                        $string = new jl_NumberFormatException;
                        jl_Throwable__init_0($string);
                        $rt_throw($string);
                    }
                    if (jl_String_charAt($string, var$9) == 45) {
                        var$9 = var$9 + 1 | 0;
                        $negativeExp = 1;
                    } else if (jl_String_charAt($string, var$9) == 43)
                        var$9 = var$9 + 1 | 0;
                    $numExp = 0;
                    $start = 0;
                    d: {
                        while (true) {
                            if (var$9 >= $end)
                                break d;
                            $hasOneDigit = jl_String_charAt($string, var$9);
                            if ($hasOneDigit < 48)
                                break d;
                            if ($hasOneDigit > 57)
                                break;
                            $numExp = (10 * $numExp | 0) + ($hasOneDigit - 48 | 0) | 0;
                            $start = 1;
                            var$9 = var$9 + 1 | 0;
                        }
                    }
                    if (!$start) {
                        $string = new jl_NumberFormatException;
                        jl_Throwable__init_0($string);
                        $rt_throw($string);
                    }
                    if ($negativeExp)
                        $numExp =  -$numExp | 0;
                    $exp = $exp + $numExp | 0;
                }
                e: {
                    var$9 = $rt_compare($exp, 308);
                    if (var$9 <= 0) {
                        if (var$9)
                            break e;
                        if (Long_le($mantissa, Long_create(2133831477, 4185580)))
                            break e;
                    }
                    return $negative ? (-Infinity) : Infinity;
                }
                if ($negative)
                    $mantissa = Long_neg($mantissa);
                var$12 = Long_toNumber($mantissa);
                if ($exp >= 0)
                    var$13 = 10.0;
                else {
                    var$13 = 0.1;
                    $exp =  -$exp | 0;
                }
                var$14 = 1.0;
                while ($exp) {
                    if ($exp % 2 | 0)
                        var$14 = var$14 * var$13;
                    var$13 = var$13 * var$13;
                    $exp = $exp / 2 | 0;
                }
                return var$12 * var$14;
            }
            $start = $start + 1 | 0;
            if ($start == $end)
                break;
        }
        $string = new jl_NumberFormatException;
        jl_Throwable__init_0($string);
        $rt_throw($string);
    }
    function jl_Double_toString($this) {
        var var$1, var$2;
        var$1 = $this.$value3;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_insert2(var$2, var$2.$length0, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function jl_Double_equals($this, $other) {
        if ($this === $other)
            return 1;
        return $other instanceof jl_Double && $other.$value3 === $this.$value3 ? 1 : 0;
    }
    function jl_Double_hashCode0($this) {
        return jl_Double_hashCode($this.$value3);
    }
    function jl_Double_hashCode($d) {
        var $h;
        $h = $rt_doubleToLongBits($d);
        return Long_hi($h) ^ Long_lo($h);
    }
    function jl_Double__clinit_() {
        jl_Double_NaN = $rt_globals.NaN;
        jl_Double_TYPE = $rt_cls($rt_doublecls());
    }
    var scm_Buffer$ = $rt_classWithoutFields(sc_SeqFactory$Delegate);
    var scm_Buffer$_MODULE$ = null;
    function scm_Buffer$_$callClinit() {
        scm_Buffer$_$callClinit = $rt_eraseClinit(scm_Buffer$);
        scm_Buffer$__clinit_();
    }
    function scm_Buffer$__clinit_() {
        var var$1;
        var$1 = new scm_Buffer$;
        scm_Buffer$_$callClinit();
        sc_SeqFactory$Delegate__init_0(var$1, scm_ArrayBuffer$_MODULE$);
        scm_Buffer$_MODULE$ = var$1;
    }
    var oncifp_CompilationPhaseTracer$CompilationPhaseEvent = $rt_classWithoutFields(0);
    var oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_0 = $rt_classWithoutFields();
    function oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_0_close(var$0) {}
    var oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_1 = $rt_classWithoutFields();
    function otcit_DoubleAnalyzer$Result() {
        var a = this; jl_Object.call(a);
        a.$mantissa0 = Long_ZERO;
        a.$exponent0 = 0;
        a.$sign0 = 0;
    }
    var sr_ClassValueCompat$ = $rt_classWithoutFields();
    var sr_ClassValueCompat$_MODULE$ = null;
    var sr_ClassValueCompat$_scala$runtime$ClassValueCompat$$classValueAvailable = 0;
    function sr_ClassValueCompat$_$callClinit() {
        sr_ClassValueCompat$_$callClinit = $rt_eraseClinit(sr_ClassValueCompat$);
        sr_ClassValueCompat$__clinit_();
    }
    function sr_ClassValueCompat$__clinit_() {
        var var$1, var$2, $$je;
        var$1 = new sr_ClassValueCompat$;
        sr_ClassValueCompat$_$callClinit();
        sr_ClassValueCompat$_MODULE$ = var$1;
        a: {
            try {
                jl_Class_getClassLoader($rt_cls(jl_Object));
                jl_Class_initialize($rt_cls(jl_ClassValue));
                var$2 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_ClassNotFoundException) {
                } else {
                    throw $$e;
                }
            }
            var$2 = 0;
        }
        sr_ClassValueCompat$_scala$runtime$ClassValueCompat$$classValueAvailable = var$2;
    }
    function sr_ClassValueCompat$FallbackClassValue() {
        jl_Object.call(this);
        this.$$outer14 = null;
    }
    function sr_ClassValueCompat$FallbackClassValue_get($this, $cls) {
        return sr_ClassTag$cache$_computeValue($this.$$outer14, $cls);
    }
    function jl_ClassValue() {
        jl_Object.call(this);
        this.$items3 = null;
    }
    function jl_ClassValue_get($this, $clazz) {
        var $it, $value, var$4;
        $it = $this.$items3;
        while (true) {
            if ($it === null) {
                $value = sr_ClassTag$cache$_computeValue($this.$$outer15, $clazz);
                $it = new jl_ClassValue$Item;
                var$4 = $this.$items3;
                $it.$this$00 = $this;
                $it.$clazz = $clazz;
                $it.$value17 = $value;
                $it.$next4 = var$4;
                $this.$items3 = $it;
                return $value;
            }
            if ($it.$clazz === $clazz)
                break;
            $it = $it.$next4;
        }
        return $it.$value17;
    }
    function sr_ClassValueCompat$JavaClassValue() {
        jl_ClassValue.call(this);
        this.$$outer15 = null;
    }
    var scm_ArrayBuffer$ = $rt_classWithoutFields();
    var scm_ArrayBuffer$_MODULE$ = null;
    var scm_ArrayBuffer$_emptyArray = null;
    function scm_ArrayBuffer$__clinit_() {
        scm_ArrayBuffer$_MODULE$ = new scm_ArrayBuffer$;
        scm_ArrayBuffer$_emptyArray = $rt_createArray(jl_Object, 0);
    }
    function scm_ArrayBuffer$_apply($this, $elems) {
        return $this.$from0($elems);
    }
    function scm_ArrayBuffer$_newBuilder($this) {
        return scm_ArrayBuffer$$anon$1__init_();
    }
    function scm_ArrayBuffer$_scala$collection$mutable$ArrayBuffer$$ensureSize($this, $array, $curSize, $targetSize) {
        var var$4, $newLen, var$6, var$7, $res;
        var$4 = Long_fromInt($array.data.length);
        if (Long_le($targetSize, var$4))
            $newLen = (-1);
        else {
            if (Long_gt($targetSize, Long_fromInt(2147483647))) {
                var$6 = new jl_Exception;
                var$7 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_2(var$7, 63);
                jl_AbstractStringBuilder_append1(var$7, $rt_s(455));
                var$7 = jl_StringBuilder_append0(var$7, 2147483647);
                jl_AbstractStringBuilder_append1(var$7, $rt_s(456));
                jl_Throwable__init_(var$6, jl_AbstractStringBuilder_toString(var$7));
                $rt_throw(var$6);
            }
            if (Long_lo($targetSize) > 2147483645) {
                var$6 = new jl_Exception;
                var$7 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_2(var$7, 83);
                jl_AbstractStringBuilder_append1(var$7, $rt_s(457));
                jl_Throwable__init_(var$6, jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$7, 2147483645)));
                $rt_throw(var$6);
            }
            $targetSize = jl_Math_max0($targetSize, jl_Math_max0(Long_mul(var$4, Long_fromInt(2)), Long_fromInt(16)));
            var$4 = Long_fromInt(2147483645);
            if (Long_lt($targetSize, var$4))
                var$4 = $targetSize;
            $newLen = Long_lo(var$4);
        }
        if ($newLen < 0)
            return $array;
        $res = $rt_createArray(jl_Object, $newLen);
        jl_System_arraycopy($array, 0, $res, 0, $curSize);
        return $res;
    }
    function scm_ArrayBuffer$_empty($this) {
        return scm_ArrayBuffer__init_();
    }
    function scm_ArrayBuffer$_from($this, $source) {
        var var$2, var$3, var$4, var$5;
        var$2 = $source.$knownSize();
        if (var$2 < 0)
            $source = scm_ArrayBuffer_addAll(scm_ArrayBuffer__init_(), $source);
        else {
            var$3 = scm_ArrayBuffer$_scala$collection$mutable$ArrayBuffer$$ensureSize($this, scm_ArrayBuffer$_emptyArray, 0, Long_fromInt(var$2));
            var$4 = !$rt_isInstance($source, sc_Iterable) ? ($source.$iterator0()).$copyToArray(var$3, 0, 2147483647) : $source.$copyToArray(var$3, 0, 2147483647);
            if (var$4 != var$2) {
                $source = new jl_IllegalStateException;
                var$5 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_2(var$5, 11);
                jl_AbstractStringBuilder_append1(var$5, $rt_s(458));
                var$5 = jl_StringBuilder_append0(var$5, var$4);
                jl_AbstractStringBuilder_append1(var$5, $rt_s(459));
                jl_Throwable__init_($source, jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$5, var$2)));
                $rt_throw($source);
            }
            $source = scm_ArrayBuffer__init_0(var$3, var$2);
        }
        return $source;
    }
    var jl_ReflectiveOperationException = $rt_classWithoutFields(jl_Exception);
    var jl_ClassNotFoundException = $rt_classWithoutFields(jl_ReflectiveOperationException);
    function sr_ClassTag$GenericClassTag() {
        jl_Object.call(this);
        this.$runtimeClass1 = null;
    }
    function sr_ClassTag$GenericClassTag_unapply($this, $x) {
        return sr_ClassTag_unapply$($this, $x);
    }
    function sr_ClassTag$GenericClassTag_equals($this, $x) {
        var var$2, var$3;
        a: {
            b: {
                if ($rt_isInstance($x, sr_ClassTag)) {
                    c: {
                        var$2 = $this.$runtimeClass1;
                        $x = $x.$runtimeClass();
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x))
                                break b;
                            else
                                break c;
                        }
                        if ($x !== null)
                            break b;
                    }
                    var$3 = 1;
                    break a;
                }
            }
            var$3 = 0;
        }
        return var$3;
    }
    function sr_ClassTag$GenericClassTag_hashCode($this) {
        return sr_Statics_anyHash($this.$runtimeClass1);
    }
    function sr_ClassTag$GenericClassTag_runtimeClass($this) {
        return $this.$runtimeClass1;
    }
    function sr_ClassTag$GenericClassTag_newArray($this, $len) {
        return jlr_Array_newInstance($this.$runtimeClass1, $len);
    }
    function oncifp_StatementCondition() {
        jl_Object.call(this);
        this.$inner0 = null;
    }
    function oncifp_StatementCondition_toString($this) {
        return $this.$name3();
    }
    function oncifp_StatementCondition_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncifp_StatementCondition_name($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$inner0;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        var$3 = jl_StringBuilder_append(var$2, $rt_s(460));
        jl_AbstractStringBuilder_append(var$3, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$3, var$1), 41);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function oncifp_StatementCondition_productPrefix($this) {
        return $rt_s(460);
    }
    function oncifp_StatementCondition_productArity($this) {
        return 1;
    }
    function oncifp_StatementCondition_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$inner0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncifp_StatementCondition_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_StatementCondition_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncifp_StatementCondition_equals($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncifp_StatementCondition) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$inner0;
                        $x$1 = $x$1.$inner0;
                        if (var$2 !== null) {
                            if (!oncirc_containsNoNodesOfType_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncifp_StatementCondition))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    }
    function oncifp_StatementCondition_apply($this, $v1) {
        var var$2, var$3;
        if ($rt_isInstance($v1, oncifp_BaseState)) {
            $v1 = $v1;
            return oncirc_containsNoNodesOfType_apply($this.$inner0, oncifp_InitialState_statement($v1));
        }
        var$2 = new jl_IllegalStateException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(432)), $v1);
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    function oncirc_containsNoNodesOfType() {
        jl_Object.call(this);
        this.$tag = null;
    }
    function oncirc_containsNoNodesOfType_toString($this) {
        return $this.$name3();
    }
    function oncirc_containsNoNodesOfType_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirc_containsNoNodesOfType_name($this) {
        var var$1, var$2, var$3;
        var$1 = jl_Class_getSimpleName($this.$tag.$runtimeClass());
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        var$3 = jl_StringBuilder_append(var$2, $rt_s(461));
        jl_AbstractStringBuilder_append(var$3, 91);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$3, var$1), 93);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function oncirc_containsNoNodesOfType_hashCode($this) {
        return $this.$tag.$hashCode0();
    }
    function oncirc_containsNoNodesOfType_equals($this, $obj) {
        if (!($obj instanceof oncirc_containsNoNodesOfType))
            return 0;
        $obj = $obj;
        return $this.$tag.$equals($obj.$tag);
    }
    function oncirc_containsNoNodesOfType_productArity($this) {
        return 0;
    }
    function oncirc_containsNoNodesOfType_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirc_containsNoNodesOfType_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirc_containsNoNodesOfType_apply($this, $v1) {
        return (s_Option$_option2Iterable(s_Option$_MODULE$, s_Option_map(onciu_Foldable$Folder_treeFindByClass(onciu_Foldable_folder$(onciu_Foldable$_FoldableAny(onciu_Foldable$_MODULE$, $v1)), $this.$tag), new oncirc_containsNoNodesOfType$apply$lambda$_31_0))).$toSeq();
    }
    var oncias_SemanticCheckable = $rt_classWithoutFields(0);
    var oncia_ReturnItem = $rt_classWithoutFields(0);
    function oncia_ReturnItem_isPassThrough$($$this) {
        return s_Option_contains($$this.$alias(), $$this.$expression1());
    }
    function oncia_ReturnItem_semanticCheck$($$this) {
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, oncie_Expression$SemanticContext$Results$_MODULE$, $$this.$expression1());
    }
    function oncia_UnaliasedReturnItem() {
        var a = this; jl_Object.call(a);
        a.$expression9 = null;
        a.$inputText = null;
        a.$position10 = null;
        a.$alias0 = null;
        a.$name18 = null;
    }
    function oncia_UnaliasedReturnItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_UnaliasedReturnItem();
        oncia_UnaliasedReturnItem__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_UnaliasedReturnItem_isPassThrough($this) {
        return oncia_ReturnItem_isPassThrough$($this);
    }
    function oncia_UnaliasedReturnItem_semanticCheck($this) {
        return oncia_ReturnItem_semanticCheck$($this);
    }
    function oncia_UnaliasedReturnItem_expression($this) {
        return $this.$expression9;
    }
    function oncia_UnaliasedReturnItem_position($this) {
        return $this.$position10;
    }
    function oncia_UnaliasedReturnItem_alias($this) {
        return $this.$alias0;
    }
    function oncia_UnaliasedReturnItem_name($this) {
        return $this.$name18;
    }
    function oncia_UnaliasedReturnItem_productPrefix($this) {
        return $rt_s(462);
    }
    function oncia_UnaliasedReturnItem_productArity($this) {
        return 2;
    }
    function oncia_UnaliasedReturnItem_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression9;
            case 1:
                return $this.$inputText;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_UnaliasedReturnItem_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_UnaliasedReturnItem_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_UnaliasedReturnItem_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_UnaliasedReturnItem_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_UnaliasedReturnItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression9;
                        var$3 = $x$1.$expression9;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$inputText;
                        $x$1 = $x$1.$inputText;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_UnaliasedReturnItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_UnaliasedReturnItem_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_UnaliasedReturnItem__init_0($this, $expression, $inputText, $position) {
        $this.$expression9 = $expression;
        $this.$inputText = $inputText;
        $this.$position10 = $position;
        if ($expression instanceof oncie_LogicalVariable) {
            $inputText = $expression;
            $expression = s_Some__init_(oncie_Variable_copyId($inputText));
        } else if (!($expression instanceof oncie_MapProjection))
            $expression = s_None$_MODULE$;
        else {
            $inputText = $expression;
            $expression = s_Some__init_(oncie_Variable_copyId($inputText.$name19));
        }
        $this.$alias0 = $expression;
        $expression = s_Option_map($expression, new oncia_UnaliasedReturnItem$_init_$lambda$_31_0);
        $inputText = new oncia_UnaliasedReturnItem$_init_$lambda$_31_1;
        $inputText.$_0166 = $this;
        $this.$name18 = s_Option_getOrElse($expression, $inputText);
    }
    var oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$ = $rt_classWithoutFields();
    var oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_MODULE$ = null;
    function oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$__clinit_() {
        oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_MODULE$ = new oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$;
    }
    function oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_productArity($this) {
        return 0;
    }
    function oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_hashCode($this) {
        return (-85286343);
    }
    function oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_toString($this) {
        return $rt_s(463);
    }
    var oncirc_package$ = $rt_classWithoutFields();
    var oncirc_package$_MODULE$ = null;
    var oncirc_package$_SemanticInfoAvailable0 = null;
    function oncirc_package$_$callClinit() {
        oncirc_package$_$callClinit = $rt_eraseClinit(oncirc_package$);
        oncirc_package$__clinit_();
    }
    function oncirc_package$__clinit_() {
        var var$1;
        var$1 = new oncirc_package$;
        oncirc_package$_$callClinit();
        oncirc_package$_MODULE$ = var$1;
        s_Predef$_$callClinit();
        oncirc_package$_SemanticInfoAvailable0 = (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(onciu_StepSequencer$Condition, [oncirc_package$PatternExpressionsHaveSemanticInfo$_MODULE$, oncirr_ProjectionClausesHaveSemanticInfo$_MODULE$])));
    }
    function oncirc_package$_SemanticInfoAvailable($this) {
        oncirc_package$_$callClinit();
        return oncirc_package$_SemanticInfoAvailable0;
    }
    var oncirc_package$SensitiveLiteralsExtracted$ = $rt_classWithoutFields();
    var oncirc_package$SensitiveLiteralsExtracted$_MODULE$ = null;
    function oncirc_package$SensitiveLiteralsExtracted$__clinit_() {
        oncirc_package$SensitiveLiteralsExtracted$_MODULE$ = new oncirc_package$SensitiveLiteralsExtracted$;
    }
    function oncirc_package$SensitiveLiteralsExtracted$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirc_package$SensitiveLiteralsExtracted$_productArity($this) {
        return 0;
    }
    function oncirc_package$SensitiveLiteralsExtracted$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirc_package$SensitiveLiteralsExtracted$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirc_package$SensitiveLiteralsExtracted$_hashCode($this) {
        return (-53945402);
    }
    function oncirc_package$SensitiveLiteralsExtracted$_toString($this) {
        return $rt_s(464);
    }
    var scm_AbstractSet = $rt_classWithoutFields(sc_AbstractSet);
    function scm_AbstractSet_iterableFactory($this) {
        scm_Set$_$callClinit();
        return scm_Set$_MODULE$;
    }
    function scm_AbstractSet_result($this) {
        return $this;
    }
    function scm_AbstractSet_remove($this, $elem) {
        var var$2, var$3;
        var$2 = $this.$contains0($elem);
        var$3 = $this;
        if (var$3 !== null) {
            var$3.$subtractOne($elem);
            return var$2;
        }
        $rt_throw(null);
    }
    function scm_AbstractSet_subtractAll($this, $xs) {
        return scm_Shrinkable_subtractAll$($this, $xs);
    }
    function scm_AbstractSet_$minus$minus$eq($this, $xs) {
        return $this.$subtractAll($xs);
    }
    function scm_AbstractSet_$plus$eq($this, $elem) {
        return $this.$addOne($elem);
    }
    function scm_AbstractSet_addAll($this, $xs) {
        return scm_Growable_addAll$($this, $xs);
    }
    function scm_AbstractSet_$plus$plus$eq($this, $xs) {
        return $this.$addAll0($xs);
    }
    function scm_AbstractSet_result0($this) {
        return scm_AbstractSet_result($this);
    }
    function scm_HashSet() {
        var a = this; scm_AbstractSet.call(a);
        a.$loadFactor1 = 0.0;
        a.$scala$collection$mutable$HashSet$$table = null;
        a.$threshold1 = 0;
        a.$contentSize0 = 0;
    }
    function scm_HashSet__init_0(var_0, var_1) {
        var var_2 = new scm_HashSet();
        scm_HashSet__init_1(var_2, var_0, var_1);
        return var_2;
    }
    function scm_HashSet__init_() {
        var var_0 = new scm_HashSet();
        scm_HashSet__init_2(var_0);
        return var_0;
    }
    function scm_HashSet_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function scm_HashSet_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function scm_HashSet_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function scm_HashSet_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function scm_HashSet_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function scm_HashSet_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function scm_HashSet_size($this) {
        return $this.$contentSize0;
    }
    function scm_HashSet_contains($this, $elem) {
        var $findNode_scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash, $findNode_hash, var$4, var$5, var$6;
        $findNode_scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash = sr_Statics_anyHash($elem);
        $findNode_hash = $findNode_scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash ^ $findNode_scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash >>> 16;
        var$4 = $this.$scala$collection$mutable$HashSet$$table.data;
        var$5 = var$4[$findNode_hash & (var$4.length - 1 | 0)];
        if (var$5 === null)
            var$5 = null;
        else
            a: {
                b: {
                    while (!($findNode_hash == var$5.$_hash0 && sr_BoxesRunTime_equals($elem, var$5.$_key0))) {
                        var$6 = var$5.$_next0;
                        if (var$6 === null)
                            break b;
                        if (var$5.$_hash0 > $findNode_hash)
                            break b;
                        var$5 = var$6;
                    }
                    break a;
                }
                var$5 = null;
            }
        if (var$5 === null)
            return 0;
        return 1;
    }
    function scm_HashSet_sizeHint($this, $size) {
        var $target;
        $target = scm_HashSet_tableSizeFor($this, ($size + 1 | 0) / $this.$loadFactor1 | 0);
        if ($target <= $this.$scala$collection$mutable$HashSet$$table.data.length)
            return;
        scm_HashSet_growTable($this, $target);
    }
    function scm_HashSet_add($this, $elem) {
        var $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash;
        if (($this.$contentSize0 + 1 | 0) >= $this.$threshold1)
            scm_HashSet_growTable($this, $this.$scala$collection$mutable$HashSet$$table.data.length * 2 | 0);
        $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash = sr_Statics_anyHash($elem);
        return scm_HashSet_addElem($this, $elem, $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash ^ $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash >>> 16);
    }
    function scm_HashSet_addAll($this, $xs) {
        var $iter, $next, $foreachWithHash_f, $foreachWithHash_foreachWithHash_this, $foreachWithHash_foreachWithHash_iN, $foreachWithHash_foreachWithHash_i, $foreachWithHash_foreachWithHash_jN, $foreachWithHash_foreachWithHash_j;
        scm_HashSet_sizeHint($this, $xs.$knownSize());
        if (!($xs instanceof sci_HashSet)) {
            if (!($xs instanceof scm_HashSet)) {
                if (!($xs instanceof scm_LinkedHashSet))
                    return scm_Growable_addAll$($this, $xs);
                $iter = $xs.$entryIterator();
                while ($iter.$hasNext()) {
                    $next = $iter.$next();
                    scm_HashSet_addElem($this, scm_LinkedHashSet$Entry_key($next), scm_LinkedHashSet$Entry_hash($next));
                }
                return $this;
            }
            $xs = $xs;
            $iter = new scm_HashSet$$anon$2;
            scm_HashSet$HashSetIterator__init_($iter, $xs);
            while (scm_HashSet$HashSetIterator_hasNext($iter)) {
                $next = scm_HashSet$HashSetIterator_next($iter);
                scm_HashSet_addElem($this, $next.$_key0, $next.$_hash0);
            }
            return $this;
        }
        $xs = $xs;
        $foreachWithHash_f = new scm_HashSet$addAll$lambda$_52_0;
        $foreachWithHash_f.$_0167 = $this;
        $foreachWithHash_foreachWithHash_this = $xs.$rootNode0;
        if ($foreachWithHash_foreachWithHash_this === null)
            $rt_throw(null);
        $foreachWithHash_foreachWithHash_iN = sci_BitmapIndexedSetNode_payloadArity($foreachWithHash_foreachWithHash_this);
        $foreachWithHash_foreachWithHash_i = 0;
        while ($foreachWithHash_foreachWithHash_i < $foreachWithHash_foreachWithHash_iN) {
            scm_HashSet_$anonfun$addAll$1($this, $foreachWithHash_foreachWithHash_this.$content1.data[$foreachWithHash_foreachWithHash_i], $foreachWithHash_foreachWithHash_this.$originalHashes0.data[$foreachWithHash_foreachWithHash_i]);
            $foreachWithHash_foreachWithHash_i = $foreachWithHash_foreachWithHash_i + 1 | 0;
        }
        $foreachWithHash_foreachWithHash_jN = sci_BitmapIndexedSetNode_nodeArity($foreachWithHash_foreachWithHash_this);
        $foreachWithHash_foreachWithHash_j = 0;
        while ($foreachWithHash_foreachWithHash_j < $foreachWithHash_foreachWithHash_jN) {
            (sci_BitmapIndexedSetNode_getNode($foreachWithHash_foreachWithHash_this, $foreachWithHash_foreachWithHash_j)).$foreachWithHash0($foreachWithHash_f);
            $foreachWithHash_foreachWithHash_j = $foreachWithHash_foreachWithHash_j + 1 | 0;
        }
        return $this;
    }
    function scm_HashSet_addElem($this, $elem, $hash) {
        var var$3, $idx, var$5, $prev, $n, var$8, $n_0;
        var$3 = $this.$scala$collection$mutable$HashSet$$table.data;
        $idx = $hash & (var$3.length - 1 | 0);
        var$5 = var$3[$idx];
        if (var$5 === null)
            var$3[$idx] = scm_HashSet$Node__init_($elem, $hash, null);
        else {
            $prev = null;
            $n = var$5;
            a: {
                while (true) {
                    if ($n === null)
                        break a;
                    var$8 = $rt_compare($n.$_hash0, $hash);
                    if (var$8 > 0)
                        break a;
                    if (!var$8 && sr_BoxesRunTime_equals($elem, $n.$_key0))
                        break;
                    $n_0 = $n.$_next0;
                    $prev = $n;
                    $n = $n_0;
                }
                return 0;
            }
            if ($prev === null)
                $this.$scala$collection$mutable$HashSet$$table.data[$idx] = scm_HashSet$Node__init_($elem, $hash, var$5);
            else
                $prev.$_next0 = scm_HashSet$Node__init_($elem, $hash, $prev.$_next0);
        }
        $this.$contentSize0 = $this.$contentSize0 + 1 | 0;
        return 1;
    }
    function scm_HashSet_remove0($this, $elem, $hash) {
        var var$3, $idx, var$5, $next, $next_0;
        var$3 = $this.$scala$collection$mutable$HashSet$$table.data;
        $idx = $hash & (var$3.length - 1 | 0);
        var$5 = var$3[$idx];
        if (var$5 === null)
            return 0;
        if (var$5.$_hash0 == $hash && sr_BoxesRunTime_equals(var$5.$_key0, $elem)) {
            $this.$scala$collection$mutable$HashSet$$table.data[$idx] = var$5.$_next0;
            $this.$contentSize0 = $this.$contentSize0 - 1 | 0;
            return 1;
        }
        $next = var$5.$_next0;
        while ($next !== null) {
            $idx = $rt_compare($next.$_hash0, $hash);
            if ($idx > 0)
                break;
            if (!$idx && sr_BoxesRunTime_equals($next.$_key0, $elem)) {
                var$5.$_next0 = $next.$_next0;
                $this.$contentSize0 = $this.$contentSize0 - 1 | 0;
                return 1;
            }
            $next_0 = $next.$_next0;
            var$5 = $next;
            $next = $next_0;
        }
        return 0;
    }
    function scm_HashSet_remove($this, $elem) {
        var $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash;
        $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash = sr_Statics_anyHash($elem);
        return scm_HashSet_remove0($this, $elem, $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash ^ $scala$collection$mutable$HashSet$$computeHash_scala$collection$mutable$HashSet$$improveHash_originalHash >>> 16);
    }
    function scm_HashSet_iterator($this) {
        var var$1;
        var$1 = new scm_HashSet$$anon$1;
        scm_HashSet$HashSetIterator__init_(var$1, $this);
        return var$1;
    }
    function scm_HashSet_growTable($this, $newlen) {
        var $oldlen, $preLow, $preHigh, $i, var$6, $old, $n, var$9, var$10, $n_0;
        $oldlen = $this.$scala$collection$mutable$HashSet$$table.data.length;
        $this.$threshold1 = scm_HashSet_newThreshold($this, $newlen);
        if (!$this.$contentSize0) {
            $this.$scala$collection$mutable$HashSet$$table = $rt_createArray(scm_HashSet$Node, $newlen);
            return;
        }
        $this.$scala$collection$mutable$HashSet$$table = ju_Arrays_copyOf($this.$scala$collection$mutable$HashSet$$table, $newlen);
        $preLow = scm_HashSet$Node__init_(null, 0, null);
        $preHigh = scm_HashSet$Node__init_(null, 0, null);
        while ($oldlen < $newlen) {
            $i = 0;
            while ($i < $oldlen) {
                var$6 = $this.$scala$collection$mutable$HashSet$$table.data;
                $old = var$6[$i];
                if ($old !== null) {
                    $preLow.$_next0 = null;
                    $preHigh.$_next0 = null;
                    $n = $old;
                    var$9 = $preLow;
                    var$10 = $preHigh;
                    while ($n !== null) {
                        $n_0 = $n.$_next0;
                        if ($n.$_hash0 & $oldlen)
                            var$10.$_next0 = $n;
                        else {
                            var$9.$_next0 = $n;
                            var$9 = $n;
                            $n = var$10;
                        }
                        var$10 = $n;
                        $n = $n_0;
                    }
                    var$9.$_next0 = null;
                    $n_0 = $preLow.$_next0;
                    if ($old !== $n_0)
                        var$6[$i] = $n_0;
                    $n_0 = $preHigh.$_next0;
                    if ($n_0 !== null) {
                        var$6[$i + $oldlen | 0] = $n_0;
                        var$10.$_next0 = null;
                    }
                }
                $i = $i + 1 | 0;
            }
            $oldlen = $oldlen * 2 | 0;
        }
    }
    function scm_HashSet_tableSizeFor($this, $capacity) {
        return jl_Math_min(jl_Integer_highestOneBit(jl_Math_max($capacity - 1 | 0, 4)) * 2 | 0, 1073741824);
    }
    function scm_HashSet_newThreshold($this, $size) {
        return $size * $this.$loadFactor1 | 0;
    }
    function scm_HashSet_clear($this) {
        ju_Arrays_fill1($this.$scala$collection$mutable$HashSet$$table, null);
        $this.$contentSize0 = 0;
    }
    function scm_HashSet_iterableFactory($this) {
        return scm_HashSet$_MODULE$;
    }
    function scm_HashSet_knownSize($this) {
        return $this.$contentSize0;
    }
    function scm_HashSet_isEmpty($this) {
        if ($this.$contentSize0)
            return 0;
        return 1;
    }
    function scm_HashSet_foreach($this, $f) {
        var $len, $i, $n, var$5;
        $len = $this.$scala$collection$mutable$HashSet$$table.data.length;
        $i = 0;
        while ($i < $len) {
            $n = $this.$scala$collection$mutable$HashSet$$table.data[$i];
            if ($n !== null) {
                var$5 = $f;
                while (true) {
                    var$5.$apply($n.$_key0);
                    $n = $n.$_next0;
                    if ($n === null)
                        break;
                }
            }
            $i = $i + 1 | 0;
        }
    }
    function scm_HashSet_className($this) {
        return $rt_s(465);
    }
    function scm_HashSet_hashCode($this) {
        var $hashIterator, var$2;
        $hashIterator = new scm_HashSet$$anon$1;
        scm_HashSet$HashSetIterator__init_($hashIterator, $this);
        if (!sc_Iterator_isEmpty$($hashIterator)) {
            $hashIterator = new scm_HashSet$$anon$3;
            $hashIterator.$$outer16 = $this;
            scm_HashSet$HashSetIterator__init_($hashIterator, $this);
            $hashIterator.$hash1 = 0;
        }
        suh_MurmurHash3$_$callClinit();
        var$2 = suh_MurmurHash3$_MODULE$;
        return suh_MurmurHash3_unorderedHash(var$2, $hashIterator, suh_MurmurHash3$_setSeed(var$2));
    }
    function scm_HashSet_subtractOne($this, $elem) {
        scm_HashSet_remove($this, $elem);
        return $this;
    }
    function scm_HashSet_addOne($this, $elem) {
        scm_HashSet_add($this, $elem);
        return $this;
    }
    function scm_HashSet_subtractAll($this, $xs) {
        var var$2, var$3, var$4, var$5, var$6;
        a: {
            if ($this.$contentSize0) {
                if (!($xs instanceof sci_HashSet)) {
                    if (!($xs instanceof scm_HashSet)) {
                        if (!($xs instanceof scm_LinkedHashSet))
                            $this = scm_Shrinkable_subtractAll$($this, $xs);
                        else {
                            $xs = $xs.$entryIterator();
                            while ($xs.$hasNext()) {
                                var$2 = $xs.$next();
                                scm_HashSet_remove0($this, scm_LinkedHashSet$Entry_key(var$2), scm_LinkedHashSet$Entry_hash(var$2));
                                if ($this.$contentSize0)
                                    continue;
                                else
                                    break a;
                            }
                        }
                    } else {
                        $xs = $xs;
                        if ($xs === null)
                            $rt_throw(null);
                        var$2 = new scm_HashSet$$anon$2;
                        scm_HashSet$HashSetIterator__init_(var$2, $xs);
                        while (scm_HashSet$HashSetIterator_hasNext(var$2)) {
                            $xs = scm_HashSet$HashSetIterator_next(var$2);
                            scm_HashSet_remove0($this, $xs.$_key0, $xs.$_hash0);
                            if ($this.$contentSize0)
                                continue;
                            else
                                break a;
                        }
                    }
                } else {
                    $xs = $xs;
                    var$2 = new scm_HashSet$subtractAll$lambda$_53_0;
                    var$2.$_0168 = $this;
                    if ($xs === null)
                        $rt_throw(null);
                    var$3 = $xs.$rootNode0;
                    if (var$3 === null)
                        $rt_throw(null);
                    var$4 = sci_BitmapIndexedSetNode_payloadArity(var$3);
                    var$5 = 1;
                    var$6 = 0;
                    while (var$6 < var$4 && var$5) {
                        var$5 = var$5 && scm_HashSet_$anonfun$subtractAll$1($this, var$3.$content1.data[var$6], var$3.$originalHashes0.data[var$6]) ? 1 : 0;
                        var$6 = var$6 + 1 | 0;
                    }
                    var$4 = sci_BitmapIndexedSetNode_nodeArity(var$3);
                    var$6 = 0;
                    while (var$6 < var$4 && var$5) {
                        var$5 = var$5 && (sci_BitmapIndexedSetNode_getNode(var$3, var$6)).$foreachWithHashWhile(var$2) ? 1 : 0;
                        var$6 = var$6 + 1 | 0;
                    }
                }
            }
        }
        return $this;
    }
    function scm_HashSet_addAll0($this, $xs) {
        return scm_HashSet_addAll($this, $xs);
    }
    function scm_HashSet_$anonfun$addAll$1($$this, $k, $h) {
        scm_HashSet_addElem($$this, $k, $h ^ $h >>> 16);
    }
    function scm_HashSet_$anonfun$subtractAll$1($$this, $k, $h) {
        scm_HashSet_remove0($$this, $k, $h ^ $h >>> 16);
        if ($$this.$contentSize0 <= 0)
            return 0;
        return 1;
    }
    function scm_HashSet__init_1($this, $initialCapacity, $loadFactor) {
        var var$3, var$4;
        $this.$loadFactor1 = $loadFactor;
        var$3 = $rt_createArray(scm_HashSet$Node, scm_HashSet_tableSizeFor($this, $initialCapacity));
        var$4 = var$3.data;
        $this.$scala$collection$mutable$HashSet$$table = var$3;
        $this.$threshold1 = scm_HashSet_newThreshold($this, var$4.length);
        $this.$contentSize0 = 0;
    }
    function scm_HashSet__init_2($this) {
        scm_HashSet__init_1($this, 16, 0.75);
    }
    var sc_AbstractIterator = $rt_classWithoutFields();
    function sc_AbstractIterator_iterator($this) {
        return $this;
    }
    function sc_AbstractIterator_contains($this, $elem) {
        return sc_Iterator_contains$($this, $elem);
    }
    function sc_AbstractIterator_grouped($this, $size) {
        return sc_Iterator_grouped$($this, $size);
    }
    function sc_AbstractIterator_sliding($this, $size, $step) {
        return sc_Iterator_sliding$($this, $size, $step);
    }
    function sc_AbstractIterator_indexWhere($this, $p, $from) {
        return sc_Iterator_indexWhere$($this, $p, $from);
    }
    function sc_AbstractIterator_isEmpty($this) {
        return sc_Iterator_isEmpty$($this);
    }
    function sc_AbstractIterator_filter($this, $p) {
        return sc_Iterator_filter$($this, $p);
    }
    function sc_AbstractIterator_filterImpl($this, $p, $isFlipped) {
        return sc_Iterator_filterImpl$($this, $p, $isFlipped);
    }
    function sc_AbstractIterator_collect($this, $pf) {
        return sc_Iterator_collect$($this, $pf);
    }
    function sc_AbstractIterator_distinctBy($this, $f) {
        return sc_Iterator_distinctBy$($this, $f);
    }
    function sc_AbstractIterator_map($this, $f) {
        return sc_Iterator_map$($this, $f);
    }
    function sc_AbstractIterator_flatMap($this, $f) {
        return sc_Iterator_flatMap$($this, $f);
    }
    function sc_AbstractIterator_concat($this, $xs) {
        return sc_Iterator_concat$($this, $xs);
    }
    function sc_AbstractIterator_take($this, $n) {
        return $this.$sliceIterator(0, jl_Math_max($n, 0));
    }
    function sc_AbstractIterator_takeWhile($this, $p) {
        return sc_Iterator_takeWhile$($this, $p);
    }
    function sc_AbstractIterator_drop($this, $n) {
        return sc_Iterator_drop$($this, $n);
    }
    function sc_AbstractIterator_dropWhile($this, $p) {
        return sc_Iterator_dropWhile$($this, $p);
    }
    function sc_AbstractIterator_sliceIterator($this, $from, $until) {
        return sc_Iterator_sliceIterator$($this, $from, $until);
    }
    function sc_AbstractIterator_sameElements($this, $that) {
        return sc_Iterator_sameElements$($this, $that);
    }
    function sc_AbstractIterator_toString($this) {
        return $rt_s(466);
    }
    function sc_AbstractIterator_foreach($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    }
    function sc_AbstractIterator_forall($this, $p) {
        return sc_IterableOnceOps_forall$($this, $p);
    }
    function sc_AbstractIterator_exists($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    }
    function sc_AbstractIterator_find($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    }
    function sc_AbstractIterator_foldLeft($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    }
    function sc_AbstractIterator_reduceLeft($this, $op) {
        return sc_IterableOnceOps_reduceLeft$($this, $op);
    }
    function sc_AbstractIterator_nonEmpty($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    }
    function sc_AbstractIterator_size($this) {
        return sc_IterableOnceOps_size$($this);
    }
    function sc_AbstractIterator_copyToArray($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    }
    function sc_AbstractIterator_copyToArray0($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    }
    function sc_AbstractIterator_copyToArray1($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    }
    function sc_AbstractIterator_addString($this, $b, $start, $sep, $end) {
        return sc_IterableOnceOps_addString$($this, $b, $start, $sep, $end);
    }
    function sc_AbstractIterator_to($this, $factory) {
        return $factory.$fromSpecific($this);
    }
    function sc_AbstractIterator_toList($this) {
        return sc_IterableOnceOps_toList$($this);
    }
    function sc_AbstractIterator_toSeq($this) {
        return sc_IterableOnceOps_toSeq$($this);
    }
    function sc_AbstractIterator_toArray($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    }
    function sc_AbstractIterator_knownSize($this) {
        return (-1);
    }
    function sc_ArrayOps$ArrayIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$xs = null;
        a.$scala$collection$ArrayOps$ArrayIterator$$pos = 0;
        a.$len = 0;
    }
    function sc_ArrayOps$ArrayIterator__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator();
        sc_ArrayOps$ArrayIterator__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator_knownSize($this) {
        return $this.$len - $this.$scala$collection$ArrayOps$ArrayIterator$$pos | 0;
    }
    function sc_ArrayOps$ArrayIterator_hasNext($this) {
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$len)
            return 0;
        return 1;
    }
    function sc_ArrayOps$ArrayIterator_next($this) {
        var $r;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= jlr_Array_getLength($this.$xs))
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $r = sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $this.$xs, $this.$scala$collection$ArrayOps$ArrayIterator$$pos);
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = $this.$scala$collection$ArrayOps$ArrayIterator$$pos + 1 | 0;
        return $r;
    }
    function sc_ArrayOps$ArrayIterator_drop($this, $n) {
        var $newPos;
        if ($n > 0) {
            $newPos = $this.$scala$collection$ArrayOps$ArrayIterator$$pos + $n | 0;
            $this.$scala$collection$ArrayOps$ArrayIterator$$pos = $newPos < 0 ? $this.$len : jl_Math_min($this.$len, $newPos);
        }
        return $this;
    }
    function sc_ArrayOps$ArrayIterator__init_0($this, $xs) {
        $this.$xs = $xs;
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = 0;
        $this.$len = jlr_Array_getLength($xs);
    }
    var sc_Iterator$ = $rt_classWithoutFields();
    var sc_Iterator$_MODULE$ = null;
    var sc_Iterator$_scala$collection$Iterator$$_empty = null;
    function sc_Iterator$__clinit_() {
        sc_Iterator$_MODULE$ = new sc_Iterator$;
        sc_Iterator$_scala$collection$Iterator$$_empty = new sc_Iterator$$anon$19;
    }
    function jl_ClassLoader() {
        jl_Object.call(this);
        this.$parent = null;
    }
    var jl_ClassLoader_systemClassLoader = null;
    function jl_ClassLoader_$callClinit() {
        jl_ClassLoader_$callClinit = $rt_eraseClinit(jl_ClassLoader);
        jl_ClassLoader__clinit_();
    }
    function jl_ClassLoader__clinit_() {
        var var$1;
        var$1 = new jl_SystemClassLoader;
        jl_ClassLoader_$callClinit();
        var$1.$parent = null;
        jl_ClassLoader_systemClassLoader = var$1;
    }
    var jlr_Array = $rt_classWithoutFields();
    function jlr_Array_getLength(var$1) {
        if (var$1 === null || var$1.constructor.$meta.item === undefined) {
            $rt_throw(jl_IllegalArgumentException__init_());
        }
        return var$1.data.length;
    }
    function jlr_Array_newInstance($componentType, $length) {
        if ($componentType === null) {
            $componentType = new jl_NullPointerException;
            jl_Throwable__init_0($componentType);
            $rt_throw($componentType);
        }
        if ($componentType === $rt_cls($rt_voidcls())) {
            $componentType = new jl_IllegalArgumentException;
            jl_Throwable__init_0($componentType);
            $rt_throw($componentType);
        }
        if ($length >= 0)
            return jlr_Array_newInstanceImpl($componentType.$platformClass, $length);
        $componentType = new jl_NegativeArraySizeException;
        jl_Throwable__init_0($componentType);
        $rt_throw($componentType);
    }
    function jlr_Array_newInstanceImpl(var$1, var$2) {
        if (var$1.$meta.primitive) {
            if (var$1 == $rt_bytecls()) {
                return $rt_createByteArray(var$2);
            }
            if (var$1 == $rt_shortcls()) {
                return $rt_createShortArray(var$2);
            }
            if (var$1 == $rt_charcls()) {
                return $rt_createCharArray(var$2);
            }
            if (var$1 == $rt_intcls()) {
                return $rt_createIntArray(var$2);
            }
            if (var$1 == $rt_longcls()) {
                return $rt_createLongArray(var$2);
            }
            if (var$1 == $rt_floatcls()) {
                return $rt_createFloatArray(var$2);
            }
            if (var$1 == $rt_doublecls()) {
                return $rt_createDoubleArray(var$2);
            }
            if (var$1 == $rt_booleancls()) {
                return $rt_createBooleanArray(var$2);
            }
        } else {
            return $rt_createArray(var$1, var$2)
        }
    }
    var jl_ArrayStoreException = $rt_classWithoutFields(jl_RuntimeException);
    var oncirc_package$PatternExpressionsHaveSemanticInfo$ = $rt_classWithoutFields();
    var oncirc_package$PatternExpressionsHaveSemanticInfo$_MODULE$ = null;
    function oncirc_package$PatternExpressionsHaveSemanticInfo$__clinit_() {
        oncirc_package$PatternExpressionsHaveSemanticInfo$_MODULE$ = new oncirc_package$PatternExpressionsHaveSemanticInfo$;
    }
    function oncirc_package$PatternExpressionsHaveSemanticInfo$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirc_package$PatternExpressionsHaveSemanticInfo$_productArity($this) {
        return 0;
    }
    function oncirc_package$PatternExpressionsHaveSemanticInfo$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirc_package$PatternExpressionsHaveSemanticInfo$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirc_package$PatternExpressionsHaveSemanticInfo$_hashCode($this) {
        return 748739207;
    }
    function oncirc_package$PatternExpressionsHaveSemanticInfo$_toString($this) {
        return $rt_s(467);
    }
    var oncirr_ProjectionClausesHaveSemanticInfo$ = $rt_classWithoutFields();
    var oncirr_ProjectionClausesHaveSemanticInfo$_MODULE$ = null;
    function oncirr_ProjectionClausesHaveSemanticInfo$__clinit_() {
        oncirr_ProjectionClausesHaveSemanticInfo$_MODULE$ = new oncirr_ProjectionClausesHaveSemanticInfo$;
    }
    function oncirr_ProjectionClausesHaveSemanticInfo$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_ProjectionClausesHaveSemanticInfo$_productArity($this) {
        return 0;
    }
    function oncirr_ProjectionClausesHaveSemanticInfo$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_ProjectionClausesHaveSemanticInfo$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_ProjectionClausesHaveSemanticInfo$_hashCode($this) {
        return (-2083017039);
    }
    function oncirr_ProjectionClausesHaveSemanticInfo$_toString($this) {
        return $rt_s(468);
    }
    function scm_HashSet$Node() {
        var a = this; jl_Object.call(a);
        a.$_key0 = null;
        a.$_hash0 = 0;
        a.$_next0 = null;
    }
    function scm_HashSet$Node__init_(var_0, var_1, var_2) {
        var var_3 = new scm_HashSet$Node();
        scm_HashSet$Node__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function scm_HashSet$Node_toString($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 12);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(448));
        var$1 = jl_StringBuilder_append(var$1, $this.$_key0);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(16));
        var$1 = jl_StringBuilder_append0(var$1, $this.$_hash0);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(449));
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$1, $this.$_next0));
    }
    function scm_HashSet$Node__init_0($this, $_key, $_hash, $_next) {
        $this.$_key0 = $_key;
        $this.$_hash0 = $_hash;
        $this.$_next0 = $_next;
    }
    function sci_Set$Set1() {
        sci_AbstractSet.call(this);
        this.$elem10 = null;
    }
    function sci_Set$Set1__init_(var_0) {
        var var_1 = new sci_Set$Set1();
        sci_Set$Set1__init_0(var_1, var_0);
        return var_1;
    }
    function sci_Set$Set1_partition($this, $p) {
        return sc_StrictOptimizedIterableOps_partition$($this, $p);
    }
    function sci_Set$Set1_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function sci_Set$Set1_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_Set$Set1_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_Set$Set1_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_Set$Set1_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_Set$Set1_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_Set$Set1_size($this) {
        return 1;
    }
    function sci_Set$Set1_isEmpty($this) {
        return 0;
    }
    function sci_Set$Set1_knownSize($this) {
        return 1;
    }
    function sci_Set$Set1_contains($this, $elem) {
        if (!sr_BoxesRunTime_equals($elem, $this.$elem10))
            return 0;
        return 1;
    }
    function sci_Set$Set1_iterator($this) {
        return sc_Iterator$$anon$20__init_($this.$elem10);
    }
    function sci_Set$Set1_foreach($this, $f) {
        $f.$apply($this.$elem10);
    }
    function sci_Set$Set1_exists($this, $p) {
        return sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem10));
    }
    function sci_Set$Set1_forall($this, $p) {
        return sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem10));
    }
    function sci_Set$Set1_find($this, $p) {
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem10)))
            return s_None$_MODULE$;
        return s_Some__init_($this.$elem10);
    }
    function sci_Set$Set1_head($this) {
        return $this.$elem10;
    }
    function sci_Set$Set1_tail($this) {
        return sci_Set$EmptySet$_MODULE$;
    }
    function sci_Set$Set1_filterImpl($this, $pred, $isFlipped) {
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem10)) == $isFlipped)
            $this = sci_Set$EmptySet$_MODULE$;
        return $this;
    }
    function sci_Set$Set1_excl($this, $elem) {
        if (sr_BoxesRunTime_equals($elem, $this.$elem10))
            $this = sci_Set$EmptySet$_MODULE$;
        return $this;
    }
    function sci_Set$Set1_incl($this, $elem) {
        return sci_Set$Set1_contains($this, $elem) ? $this : sci_Set$Set2__init_($this.$elem10, $elem);
    }
    function sci_Set$Set1__init_0($this, $elem1) {
        $this.$elem10 = $elem1;
    }
    function sci_Set$Set2() {
        var a = this; sci_AbstractSet.call(a);
        a.$elem11 = null;
        a.$elem20 = null;
    }
    function sci_Set$Set2__init_(var_0, var_1) {
        var var_2 = new sci_Set$Set2();
        sci_Set$Set2__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function sci_Set$Set2_partition($this, $p) {
        return sc_StrictOptimizedIterableOps_partition$($this, $p);
    }
    function sci_Set$Set2_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function sci_Set$Set2_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_Set$Set2_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_Set$Set2_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_Set$Set2_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_Set$Set2_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_Set$Set2_size($this) {
        return 2;
    }
    function sci_Set$Set2_isEmpty($this) {
        return 0;
    }
    function sci_Set$Set2_knownSize($this) {
        return 2;
    }
    function sci_Set$Set2_contains($this, $elem) {
        if (!sr_BoxesRunTime_equals($elem, $this.$elem11) && !sr_BoxesRunTime_equals($elem, $this.$elem20))
            return 0;
        return 1;
    }
    function sci_Set$Set2_iterator($this) {
        var var$1;
        var$1 = new sci_Set$Set2$$anon$1;
        var$1.$$outer17 = $this;
        sci_Set$SetNIterator__init_(var$1, 2);
        return var$1;
    }
    function sci_Set$Set2_foreach($this, $f) {
        $f.$apply($this.$elem11);
        $f.$apply($this.$elem20);
    }
    function sci_Set$Set2_exists($this, $p) {
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem11)) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem20)))
            return 0;
        return 1;
    }
    function sci_Set$Set2_forall($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem11)) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem20)))
            return 1;
        return 0;
    }
    function sci_Set$Set2_find($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem11)))
            return s_Some__init_($this.$elem11);
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem20)))
            return s_None$_MODULE$;
        return s_Some__init_($this.$elem20);
    }
    function sci_Set$Set2_head($this) {
        return $this.$elem11;
    }
    function sci_Set$Set2_tail($this) {
        return sci_Set$Set1__init_($this.$elem20);
    }
    function sci_Set$Set2_filterImpl($this, $pred, $isFlipped) {
        var var$3, var$4;
        var$3 = null;
        var$4 = 0;
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem11)) != $isFlipped) {
            var$3 = $this.$elem11;
            var$4 = 1;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem20)) != $isFlipped) {
            if (!var$4)
                var$3 = $this.$elem20;
            var$4 = var$4 + 1 | 0;
        }
        a: {
            switch (var$4) {
                case 0:
                    $this = sci_Set$EmptySet$_MODULE$;
                    break a;
                case 1:
                    $this = sci_Set$Set1__init_(var$3);
                    break a;
                case 2:
                    break;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf(var$4)));
            }
        }
        return $this;
    }
    function sci_Set$Set2_excl($this, $elem) {
        return sr_BoxesRunTime_equals($elem, $this.$elem11) ? sci_Set$Set1__init_($this.$elem20) : !sr_BoxesRunTime_equals($elem, $this.$elem20) ? $this : sci_Set$Set1__init_($this.$elem11);
    }
    function sci_Set$Set2_incl($this, $elem) {
        return sci_Set$Set2_contains($this, $elem) ? $this : sci_Set$Set3__init_($this.$elem11, $this.$elem20, $elem);
    }
    function sci_Set$Set2__init_0($this, $elem1, $elem2) {
        $this.$elem11 = $elem1;
        $this.$elem20 = $elem2;
    }
    function sc_SetOps$concat$lambda$_23_0() {
        jl_Object.call(this);
        this.$_0154 = null;
    }
    function sc_SetOps$concat$lambda$_23_0_apply(var$0) {
        return var$0.$_0154.$iterator0();
    }
    function sc_View$Concat() {
        var a = this; sc_AbstractView.call(a);
        a.$prefix0 = null;
        a.$suffix = null;
    }
    function sc_View$Concat__init_(var_0, var_1) {
        var var_2 = new sc_View$Concat();
        sc_View$Concat__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function sc_View$Concat_iterator($this) {
        var var$1, $$plus$plus_xs;
        var$1 = $this.$prefix0.$iterator0();
        $$plus$plus_xs = new sc_View$Concat$iterator$lambda$_0_0;
        $$plus$plus_xs.$_0169 = $this;
        if (var$1 === null)
            $rt_throw(null);
        return var$1.$concat($$plus$plus_xs);
    }
    function sc_View$Concat_knownSize($this) {
        var $prefixSize, $suffixSize;
        $prefixSize = $this.$prefix0.$knownSize();
        if ($prefixSize < 0)
            return (-1);
        $suffixSize = $this.$suffix.$knownSize();
        if ($suffixSize < 0)
            return (-1);
        return $prefixSize + $suffixSize | 0;
    }
    function sc_View$Concat_isEmpty($this) {
        if ($this.$prefix0.$isEmpty() && $this.$suffix.$isEmpty())
            return 1;
        return 0;
    }
    function sc_View$Concat__init_0($this, $prefix, $suffix) {
        $this.$prefix0 = $prefix;
        $this.$suffix = $suffix;
    }
    function sci_Set$Set3() {
        var a = this; sci_AbstractSet.call(a);
        a.$elem12 = null;
        a.$elem21 = null;
        a.$elem30 = null;
    }
    function sci_Set$Set3__init_(var_0, var_1, var_2) {
        var var_3 = new sci_Set$Set3();
        sci_Set$Set3__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function sci_Set$Set3_partition($this, $p) {
        return sc_StrictOptimizedIterableOps_partition$($this, $p);
    }
    function sci_Set$Set3_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function sci_Set$Set3_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_Set$Set3_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_Set$Set3_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_Set$Set3_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_Set$Set3_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_Set$Set3_size($this) {
        return 3;
    }
    function sci_Set$Set3_isEmpty($this) {
        return 0;
    }
    function sci_Set$Set3_knownSize($this) {
        return 3;
    }
    function sci_Set$Set3_contains($this, $elem) {
        if (!sr_BoxesRunTime_equals($elem, $this.$elem12) && !sr_BoxesRunTime_equals($elem, $this.$elem21) && !sr_BoxesRunTime_equals($elem, $this.$elem30))
            return 0;
        return 1;
    }
    function sci_Set$Set3_iterator($this) {
        var var$1;
        var$1 = new sci_Set$Set3$$anon$2;
        var$1.$$outer18 = $this;
        sci_Set$SetNIterator__init_(var$1, 3);
        return var$1;
    }
    function sci_Set$Set3_foreach($this, $f) {
        $f.$apply($this.$elem12);
        $f.$apply($this.$elem21);
        $f.$apply($this.$elem30);
    }
    function sci_Set$Set3_exists($this, $p) {
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem12)) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem21)) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem30)))
            return 0;
        return 1;
    }
    function sci_Set$Set3_forall($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem12)) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem21)) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem30)))
            return 1;
        return 0;
    }
    function sci_Set$Set3_find($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem12)))
            return s_Some__init_($this.$elem12);
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem21)))
            return s_Some__init_($this.$elem21);
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem30)))
            return s_None$_MODULE$;
        return s_Some__init_($this.$elem30);
    }
    function sci_Set$Set3_head($this) {
        return $this.$elem12;
    }
    function sci_Set$Set3_tail($this) {
        return sci_Set$Set2__init_($this.$elem21, $this.$elem30);
    }
    function sci_Set$Set3_filterImpl($this, $pred, $isFlipped) {
        var var$3, var$4, var$5;
        var$3 = null;
        var$4 = null;
        var$5 = 0;
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem12)) != $isFlipped) {
            var$3 = $this.$elem12;
            var$5 = 1;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem21)) != $isFlipped) {
            if (var$5)
                var$4 = $this.$elem21;
            else
                var$3 = $this.$elem21;
            var$5 = var$5 + 1 | 0;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem30)) != $isFlipped) {
            if (!var$5)
                var$3 = $this.$elem30;
            else if (var$5 == 1)
                var$4 = $this.$elem30;
            var$5 = var$5 + 1 | 0;
        }
        a: {
            switch (var$5) {
                case 0:
                    $this = sci_Set$EmptySet$_MODULE$;
                    break a;
                case 1:
                    $this = sci_Set$Set1__init_(var$3);
                    break a;
                case 2:
                    $this = sci_Set$Set2__init_(var$3, var$4);
                    break a;
                case 3:
                    break;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf(var$5)));
            }
        }
        return $this;
    }
    function sci_Set$Set3_excl($this, $elem) {
        return sr_BoxesRunTime_equals($elem, $this.$elem12) ? sci_Set$Set2__init_($this.$elem21, $this.$elem30) : sr_BoxesRunTime_equals($elem, $this.$elem21) ? sci_Set$Set2__init_($this.$elem12, $this.$elem30) : !sr_BoxesRunTime_equals($elem, $this.$elem30) ? $this : sci_Set$Set2__init_($this.$elem12, $this.$elem21);
    }
    function sci_Set$Set3_incl($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (sci_Set$Set3_contains($this, $elem))
            var$2 = $this;
        else {
            var$2 = new sci_Set$Set4;
            var$3 = $this.$elem12;
            var$4 = $this.$elem21;
            var$5 = $this.$elem30;
            var$2.$elem1 = var$3;
            var$2.$elem2 = var$4;
            var$2.$elem3 = var$5;
            var$2.$elem4 = $elem;
        }
        return var$2;
    }
    function sci_Set$Set3__init_0($this, $elem1, $elem2, $elem3) {
        $this.$elem12 = $elem1;
        $this.$elem21 = $elem2;
        $this.$elem30 = $elem3;
    }
    function sci_Set$Set4() {
        var a = this; sci_AbstractSet.call(a);
        a.$elem1 = null;
        a.$elem2 = null;
        a.$elem3 = null;
        a.$elem4 = null;
    }
    function sci_Set$Set4_partition($this, $p) {
        return sc_StrictOptimizedIterableOps_partition$($this, $p);
    }
    function sci_Set$Set4_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function sci_Set$Set4_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_Set$Set4_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_Set$Set4_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_Set$Set4_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_Set$Set4_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_Set$Set4_size($this) {
        return 4;
    }
    function sci_Set$Set4_isEmpty($this) {
        return 0;
    }
    function sci_Set$Set4_knownSize($this) {
        return 4;
    }
    function sci_Set$Set4_contains($this, $elem) {
        if (!sr_BoxesRunTime_equals($elem, $this.$elem1) && !sr_BoxesRunTime_equals($elem, $this.$elem2) && !sr_BoxesRunTime_equals($elem, $this.$elem3) && !sr_BoxesRunTime_equals($elem, $this.$elem4))
            return 0;
        return 1;
    }
    function sci_Set$Set4_iterator($this) {
        var var$1;
        var$1 = new sci_Set$Set4$$anon$3;
        var$1.$$outer19 = $this;
        sci_Set$SetNIterator__init_(var$1, 4);
        return var$1;
    }
    function sci_Set$Set4_foreach($this, $f) {
        $f.$apply($this.$elem1);
        $f.$apply($this.$elem2);
        $f.$apply($this.$elem3);
        $f.$apply($this.$elem4);
    }
    function sci_Set$Set4_exists($this, $p) {
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem1)) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem2)) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem3)) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem4)))
            return 0;
        return 1;
    }
    function sci_Set$Set4_forall($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem1)) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem2)) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem3)) && sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem4)))
            return 1;
        return 0;
    }
    function sci_Set$Set4_find($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem1)))
            return s_Some__init_($this.$elem1);
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem2)))
            return s_Some__init_($this.$elem2);
        if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem3)))
            return s_Some__init_($this.$elem3);
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$elem4)))
            return s_None$_MODULE$;
        return s_Some__init_($this.$elem4);
    }
    function sci_Set$Set4_head($this) {
        return $this.$elem1;
    }
    function sci_Set$Set4_tail($this) {
        return sci_Set$Set3__init_($this.$elem2, $this.$elem3, $this.$elem4);
    }
    function sci_Set$Set4_filterImpl($this, $pred, $isFlipped) {
        var var$3, var$4, var$5, var$6;
        var$3 = null;
        var$4 = null;
        var$5 = null;
        var$6 = 0;
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem1)) != $isFlipped) {
            var$3 = $this.$elem1;
            var$6 = 1;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem2)) != $isFlipped) {
            if (var$6)
                var$4 = $this.$elem2;
            else
                var$3 = $this.$elem2;
            var$6 = var$6 + 1 | 0;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem3)) != $isFlipped) {
            if (!var$6)
                var$3 = $this.$elem3;
            else if (var$6 != 1)
                var$5 = $this.$elem3;
            else
                var$4 = $this.$elem3;
            var$6 = var$6 + 1 | 0;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$elem4)) != $isFlipped) {
            if (!var$6)
                var$3 = $this.$elem4;
            else if (var$6 == 1)
                var$4 = $this.$elem4;
            else if (var$6 == 2)
                var$5 = $this.$elem4;
            var$6 = var$6 + 1 | 0;
        }
        a: {
            switch (var$6) {
                case 0:
                    $this = sci_Set$EmptySet$_MODULE$;
                    break a;
                case 1:
                    $this = sci_Set$Set1__init_(var$3);
                    break a;
                case 2:
                    $this = sci_Set$Set2__init_(var$3, var$4);
                    break a;
                case 3:
                    $this = sci_Set$Set3__init_(var$3, var$4, var$5);
                    break a;
                case 4:
                    break;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf(var$6)));
            }
        }
        return $this;
    }
    function sci_Set$Set4_excl($this, $elem) {
        return sr_BoxesRunTime_equals($elem, $this.$elem1) ? sci_Set$Set3__init_($this.$elem2, $this.$elem3, $this.$elem4) : sr_BoxesRunTime_equals($elem, $this.$elem2) ? sci_Set$Set3__init_($this.$elem1, $this.$elem3, $this.$elem4) : sr_BoxesRunTime_equals($elem, $this.$elem3) ? sci_Set$Set3__init_($this.$elem1, $this.$elem2, $this.$elem4) : !sr_BoxesRunTime_equals($elem, $this.$elem4) ? $this : sci_Set$Set3__init_($this.$elem1, $this.$elem2, $this.$elem3);
    }
    function sci_Set$Set4_incl($this, $elem) {
        var var$2, var$3;
        if (!sci_Set$Set4_contains($this, $elem)) {
            sci_HashSet$_$callClinit();
            var$2 = sci_HashSet$_empty(sci_HashSet$_MODULE$);
            var$3 = $this.$elem1;
            if (var$2 === null)
                $rt_throw(null);
            var$2 = sci_HashSet_incl(var$2, var$3);
            var$3 = $this.$elem2;
            if (var$2 === null)
                $rt_throw(null);
            var$2 = sci_HashSet_incl(var$2, var$3);
            var$3 = $this.$elem3;
            if (var$2 === null)
                $rt_throw(null);
            var$2 = sci_HashSet_incl(var$2, var$3);
            var$3 = $this.$elem4;
            if (var$2 === null)
                $rt_throw(null);
            var$2 = sci_HashSet_incl(var$2, var$3);
            if (var$2 === null)
                $rt_throw(null);
            $this = sci_HashSet_incl(var$2, $elem);
        }
        return $this;
    }
    var sc_Iterator$$anon$19 = $rt_classWithoutFields(sc_AbstractIterator);
    function sc_Iterator$$anon$19_hasNext($this) {
        return 0;
    }
    function sc_Iterator$$anon$19_knownSize($this) {
        return 0;
    }
    function sc_Iterator$$anon$19_sliceIterator($this, $from, $until) {
        return $this;
    }
    function sc_Iterator$$anon$19_next($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(469));
        $rt_throw(var$1);
    }
    var jl_SystemClassLoader = $rt_classWithoutFields(jl_ClassLoader);
    function jl_ClassValue$Item() {
        var a = this; jl_Object.call(a);
        a.$clazz = null;
        a.$value17 = null;
        a.$next4 = null;
        a.$this$00 = null;
    }
    function scm_ListBuffer() {
        var a = this; scm_AbstractBuffer.call(a);
        a.$mutationCount1 = 0;
        a.$first0 = null;
        a.$last00 = null;
        a.$aliased0 = 0;
        a.$len0 = 0;
    }
    function scm_ListBuffer__init_() {
        var var_0 = new scm_ListBuffer();
        scm_ListBuffer__init_0(var_0);
        return var_0;
    }
    function scm_ListBuffer_sizeHint($this, $size) {}
    function scm_ListBuffer_sizeHint0($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    }
    function scm_ListBuffer_distinctBy($this, $f) {
        return sc_StrictOptimizedSeqOps_distinctBy$($this, $f);
    }
    function scm_ListBuffer_prepended($this, $elem) {
        return sc_StrictOptimizedSeqOps_prepended$($this, $elem);
    }
    function scm_ListBuffer_appended($this, $elem) {
        return sc_StrictOptimizedSeqOps_appended$($this, $elem);
    }
    function scm_ListBuffer_appendedAll($this, $suffix) {
        return sc_StrictOptimizedSeqOps_appendedAll$($this, $suffix);
    }
    function scm_ListBuffer_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function scm_ListBuffer_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function scm_ListBuffer_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function scm_ListBuffer_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function scm_ListBuffer_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function scm_ListBuffer_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function scm_ListBuffer_iterator($this) {
        var var$1, var$2, var$3;
        var$1 = new scm_MutationTracker$CheckedIterator;
        var$2 = $this.$first0.$iterator0();
        var$3 = new scm_ListBuffer$iterator$lambda$_59_0;
        var$3.$_0170 = $this;
        var$1.$underlying9 = var$2;
        var$1.$mutationCount2 = var$3;
        var$1.$expectedCount = scm_ListBuffer$iterator$lambda$_59_0_apply$mcI$sp(var$3);
        return var$1;
    }
    function scm_ListBuffer_apply($this, $i) {
        var var$2;
        var$2 = $this.$first0;
        if (var$2 !== null)
            return sc_LinearSeqOps_apply$(var$2, $i);
        $rt_throw(null);
    }
    function scm_ListBuffer_length($this) {
        return $this.$len0;
    }
    function scm_ListBuffer_knownSize($this) {
        return $this.$len0;
    }
    function scm_ListBuffer_isEmpty($this) {
        if ($this.$len0)
            return 0;
        return 1;
    }
    function scm_ListBuffer_ensureUnaliased($this) {
        var var$1;
        $this.$mutationCount1 = $this.$mutationCount1 + 1 | 0;
        if (!$this.$aliased0)
            return;
        var$1 = scm_ListBuffer_scala$collection$mutable$ListBuffer$$freshFrom(scm_ListBuffer__init_(), $this);
        $this.$first0 = var$1.$first0;
        $this.$last00 = var$1.$last00;
        $this.$aliased0 = 0;
    }
    function scm_ListBuffer_toList($this) {
        $this.$aliased0 = sc_IterableOnceOps_nonEmpty$($this);
        return $this.$first0;
    }
    function scm_ListBuffer_scala$collection$mutable$ListBuffer$$freshFrom($this, $xs) {
        var $it, $len, $last0, $last1;
        $it = $xs.$iterator0();
        if ($it.$hasNext()) {
            $len = 1;
            $last0 = sci_$colon$colon__init_($it.$next(), sci_Nil$_MODULE$);
            $this.$first0 = $last0;
            while ($it.$hasNext()) {
                $last1 = sci_$colon$colon__init_($it.$next(), sci_Nil$_MODULE$);
                $last0.$next0 = $last1;
                $len = $len + 1 | 0;
                $last0 = $last1;
            }
            $this.$len0 = $len;
            $this.$last00 = $last0;
        }
        return $this;
    }
    function scm_ListBuffer_addAll($this, $xs) {
        var $it, $fresh, var$4;
        $it = $xs.$iterator0();
        if ($it.$hasNext()) {
            $fresh = scm_ListBuffer_scala$collection$mutable$ListBuffer$$freshFrom(scm_ListBuffer__init_(), $it);
            scm_ListBuffer_ensureUnaliased($this);
            var$4 = $this.$len0;
            if (!var$4)
                $this.$first0 = $fresh.$first0;
            else
                $this.$last00.$next0 = $fresh.$first0;
            $this.$last00 = $fresh.$last00;
            $this.$len0 = var$4 + $fresh.$len0 | 0;
        }
        return $this;
    }
    function scm_ListBuffer_stringPrefix($this) {
        return $rt_s(470);
    }
    function scm_ListBuffer_addAll0($this, $xs) {
        return scm_ListBuffer_addAll($this, $xs);
    }
    function scm_ListBuffer_addOne($this, $elem) {
        var var$2, var$3;
        scm_ListBuffer_ensureUnaliased($this);
        var$2 = sci_$colon$colon__init_($elem, sci_Nil$_MODULE$);
        var$3 = $this.$len0;
        if (!var$3)
            $this.$first0 = var$2;
        else
            $this.$last00.$next0 = var$2;
        $this.$last00 = var$2;
        $this.$len0 = var$3 + 1 | 0;
        return $this;
    }
    function scm_ListBuffer_result($this) {
        return scm_ListBuffer_toList($this);
    }
    function scm_ListBuffer_apply0($this, $v1) {
        return scm_ListBuffer_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function scm_ListBuffer_iterableFactory($this) {
        return scm_ListBuffer$_MODULE$;
    }
    function scm_ListBuffer__init_0($this) {
        $this.$mutationCount1 = 0;
        $this.$first0 = sci_Nil$_MODULE$;
        $this.$last00 = null;
        $this.$aliased0 = 0;
        $this.$len0 = 0;
    }
    function jl_Byte() {
        jl_Number.call(this);
        this.$value13 = 0;
    }
    var jl_Byte_TYPE = null;
    function jl_Byte_intValue($this) {
        return $this.$value13;
    }
    function jl_Byte_longValue($this) {
        return Long_fromInt($this.$value13);
    }
    function jl_Byte_floatValue($this) {
        return $this.$value13;
    }
    function jl_Byte_doubleValue($this) {
        return $this.$value13;
    }
    function jl_Byte_valueOf($value) {
        var var$2;
        var$2 = new jl_Byte;
        var$2.$value13 = $value;
        return var$2;
    }
    function jl_Byte_toString($this) {
        var var$1, var$2;
        var$1 = $this.$value13;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$2, var$1));
    }
    function jl_Byte_equals($this, $other) {
        return $other instanceof jl_Byte && $other.$value13 == $this.$value13 ? 1 : 0;
    }
    function jl_Byte_hashCode($this) {
        return $this.$value13;
    }
    function jl_Byte__clinit_() {
        jl_Byte_TYPE = $rt_cls($rt_bytecls());
    }
    function jl_Short() {
        jl_Number.call(this);
        this.$value14 = 0;
    }
    var jl_Short_TYPE = null;
    function jl_Short_intValue($this) {
        return $this.$value14;
    }
    function jl_Short_longValue($this) {
        return Long_fromInt($this.$value14);
    }
    function jl_Short_floatValue($this) {
        return $this.$value14;
    }
    function jl_Short_doubleValue($this) {
        return $this.$value14;
    }
    function jl_Short_valueOf($value) {
        var var$2;
        var$2 = new jl_Short;
        var$2.$value14 = $value;
        return var$2;
    }
    function jl_Short_toString($this) {
        var var$1, var$2;
        var$1 = $this.$value14;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$2, var$1));
    }
    function jl_Short_equals($this, $other) {
        return $other instanceof jl_Short && $other.$value14 == $this.$value14 ? 1 : 0;
    }
    function jl_Short_hashCode($this) {
        return $this.$value14;
    }
    function jl_Short__clinit_() {
        jl_Short_TYPE = $rt_cls($rt_shortcls());
    }
    var sci_Node = $rt_classWithoutFields();
    function sci_Node_arrayIndexOutOfBounds($this, $as, $ix) {
        var var$3, var$4;
        var$3 = new jl_ArrayIndexOutOfBoundsException;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$4, 30);
        var$4 = jl_StringBuilder_append0(var$4, $ix);
        jl_AbstractStringBuilder_append1(var$4, $rt_s(390));
        jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$4, jlr_Array_getLength($as) - 1 | 0)));
        return var$3;
    }
    function sci_Node_removeElement($this, $as, $ix) {
        var var$3, var$4, $result;
        if ($ix < 0)
            $rt_throw(sci_Node_arrayIndexOutOfBounds($this, $as, $ix));
        var$3 = $as.data.length;
        var$4 = var$3 - 1 | 0;
        if ($ix > var$4)
            $rt_throw(sci_Node_arrayIndexOutOfBounds($this, $as, $ix));
        $result = $rt_createIntArray(var$4);
        jl_System_arraycopy($as, 0, $result, 0, $ix);
        jl_System_arraycopy($as, $ix + 1 | 0, $result, $ix, (var$3 - $ix | 0) - 1 | 0);
        return $result;
    }
    function sci_Node_insertElement($this, $as, $ix, $elem) {
        var var$4, $result, var$6;
        if ($ix < 0)
            $rt_throw(sci_Node_arrayIndexOutOfBounds($this, $as, $ix));
        var$4 = $as.data.length;
        if ($ix > var$4)
            $rt_throw(sci_Node_arrayIndexOutOfBounds($this, $as, $ix));
        $result = $rt_createIntArray(var$4 + 1 | 0);
        var$6 = $result.data;
        jl_System_arraycopy($as, 0, $result, 0, $ix);
        var$6[$ix] = $elem;
        jl_System_arraycopy($as, $ix, $result, $ix + 1 | 0, var$4 - $ix | 0);
        return $result;
    }
    var sci_SetNode = $rt_classWithoutFields(sci_Node);
    function sci_BitmapIndexedSetNode() {
        var a = this; sci_SetNode.call(a);
        a.$dataMap = 0;
        a.$nodeMap = 0;
        a.$content1 = null;
        a.$originalHashes0 = null;
        a.$size4 = 0;
        a.$cachedJavaKeySetHashCode0 = 0;
    }
    function sci_BitmapIndexedSetNode__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new sci_BitmapIndexedSetNode();
        sci_BitmapIndexedSetNode__init_0(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    function sci_BitmapIndexedSetNode_dataMap($this) {
        return $this.$dataMap;
    }
    function sci_BitmapIndexedSetNode_nodeMap($this) {
        return $this.$nodeMap;
    }
    function sci_BitmapIndexedSetNode_originalHashes($this) {
        return $this.$originalHashes0;
    }
    function sci_BitmapIndexedSetNode_size($this) {
        return $this.$size4;
    }
    function sci_BitmapIndexedSetNode_cachedJavaKeySetHashCode($this) {
        return $this.$cachedJavaKeySetHashCode0;
    }
    function sci_BitmapIndexedSetNode_getPayload($this, $index) {
        return $this.$content1.data[$index];
    }
    function sci_BitmapIndexedSetNode_getHash($this, $index) {
        return $this.$originalHashes0.data[$index];
    }
    function sci_BitmapIndexedSetNode_getNode($this, $index) {
        var var$2;
        var$2 = $this.$content1.data;
        return var$2[(var$2.length - 1 | 0) - $index | 0];
    }
    function sci_BitmapIndexedSetNode_contains($this, $element, $originalHash, $elementHash, $shift) {
        var $mask, $bitpos, $index;
        $mask = $elementHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $index = $this.$dataMap;
        if (!($index & $bitpos)) {
            $index = $this.$nodeMap;
            if (!($index & $bitpos))
                return 0;
            return (sci_BitmapIndexedSetNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos))).$contains1($element, $originalHash, $elementHash, $shift + 5 | 0);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos);
        if ($this.$originalHashes0.data[$index] == $originalHash && sr_BoxesRunTime_equals($element, $this.$content1.data[$index]))
            return 1;
        return 0;
    }
    function sci_BitmapIndexedSetNode_updated($this, $element, $originalHash, $elementHash, $shift) {
        var $mask, $bitpos, $element0Hash, $subNode, $subNodeNew, $index, var$11, $element0UnimprovedHash, var$13, var$14, $element0;
        $mask = $elementHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $element0Hash = $this.$dataMap;
        if (!($element0Hash & $bitpos)) {
            $element0Hash = $this.$nodeMap;
            if ($element0Hash & $bitpos) {
                $subNode = sci_BitmapIndexedSetNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $element0Hash, $mask, $bitpos));
                $subNodeNew = $subNode.$updated3($element, $originalHash, $elementHash, $shift + 5 | 0);
                if ($subNode === $subNodeNew)
                    return $this;
                return sci_BitmapIndexedSetNode_copyAndSetNode($this, $bitpos, $subNode, $subNodeNew);
            }
            $element0Hash = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
            $index = 1 * $element0Hash | 0;
            var$11 = $this.$content1;
            $element0UnimprovedHash = var$11.data.length;
            var$13 = $rt_createArray(jl_Object, $element0UnimprovedHash + 1 | 0);
            var$14 = var$13.data;
            jl_System_arraycopy(var$11, 0, var$13, 0, $index);
            var$14[$index] = $element;
            jl_System_arraycopy(var$11, $index, var$13, $index + 1 | 0, $element0UnimprovedHash - $index | 0);
            var$14 = sci_Node_insertElement($this, $this.$originalHashes0, $element0Hash, $originalHash);
            return sci_BitmapIndexedSetNode__init_($this.$dataMap | $bitpos, $this.$nodeMap, var$13, var$14, $this.$size4 + 1 | 0, $this.$cachedJavaKeySetHashCode0 + $elementHash | 0);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $element0Hash, $mask, $bitpos);
        $element0 = $this.$content1.data[$index];
        if ($element0 === $element)
            return $this;
        $element0UnimprovedHash = $this.$originalHashes0.data[$index];
        $element0Hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $element0UnimprovedHash);
        if ($originalHash == $element0UnimprovedHash && sr_BoxesRunTime_equals($element0, $element))
            return $this;
        $subNodeNew = sci_BitmapIndexedSetNode_mergeTwoKeyValPairs($this, $element0, $element0UnimprovedHash, $element0Hash, $element, $originalHash, $elementHash, $shift + 5 | 0);
        $elementHash = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
        $shift = 1 * $elementHash | 0;
        $index = ($this.$content1.data.length - 1 | 0) - sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) | 0;
        var$11 = $this.$content1;
        $element0UnimprovedHash = var$11.data.length;
        var$13 = $rt_createArray(jl_Object, ($element0UnimprovedHash - 1 | 0) + 1 | 0);
        var$14 = var$13.data;
        jl_System_arraycopy(var$11, 0, var$13, 0, $shift);
        jl_System_arraycopy(var$11, $shift + 1 | 0, var$13, $shift, $index - $shift | 0);
        var$14[$index] = $subNodeNew;
        $originalHash = $index + 1 | 0;
        jl_System_arraycopy(var$11, $originalHash, var$13, $originalHash, ($element0UnimprovedHash - $index | 0) - 1 | 0);
        var$14 = sci_Node_removeElement($this, $this.$originalHashes0, $elementHash);
        return sci_BitmapIndexedSetNode__init_($this.$dataMap ^ $bitpos, $this.$nodeMap | $bitpos, var$13, var$14, ($this.$size4 - 1 | 0) + $subNodeNew.$size() | 0, ($this.$cachedJavaKeySetHashCode0 - $element0Hash | 0) + $subNodeNew.$cachedJavaKeySetHashCode() | 0);
    }
    function sci_BitmapIndexedSetNode_updateWithShallowMutations($this, $element, $originalHash, $elementHash, $shift, $shallowlyMutableNodeMap) {
        var $mask, $bitpos, $index, $element0, $element0UnimprovedHash, $element0Hash, $dataIx, $src, $dst, $dstHashes, $subNode, $subNodeSize, $subNodeCachedJavaKeySetHashCode, $subNodeNew;
        $mask = $elementHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $index = $this.$dataMap;
        if ($index & $bitpos) {
            $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos);
            $element0 = $this.$content1.data[$index];
            $element0UnimprovedHash = $this.$originalHashes0.data[$index];
            if ($element0UnimprovedHash == $originalHash && sr_BoxesRunTime_equals($element0, $element))
                return $shallowlyMutableNodeMap;
            $element0Hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $element0UnimprovedHash);
            sci_BitmapIndexedSetNode_migrateFromInlineToNodeInPlace($this, $bitpos, $element0Hash, sci_BitmapIndexedSetNode_mergeTwoKeyValPairs($this, $element0, $element0UnimprovedHash, $element0Hash, $element, $originalHash, $elementHash, $shift + 5 | 0));
            return $shallowlyMutableNodeMap | $bitpos;
        }
        $index = $this.$nodeMap;
        if (!($index & $bitpos)) {
            $dataIx = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
            $src = $this.$content1;
            $index = $src.data.length;
            $dst = $rt_createArray(jl_Object, $index + 1 | 0);
            $dstHashes = $dst.data;
            jl_System_arraycopy($src, 0, $dst, 0, $dataIx);
            $dstHashes[$dataIx] = $element;
            jl_System_arraycopy($src, $dataIx, $dst, $dataIx + 1 | 0, $index - $dataIx | 0);
            $dstHashes = sci_Node_insertElement($this, $this.$originalHashes0, $dataIx, $originalHash);
            $this.$dataMap = $this.$dataMap | $bitpos;
            $this.$content1 = $dst;
            $this.$originalHashes0 = $dstHashes;
            $this.$size4 = $this.$size4 + 1 | 0;
            $this.$cachedJavaKeySetHashCode0 = $this.$cachedJavaKeySetHashCode0 + $elementHash | 0;
            return $shallowlyMutableNodeMap;
        }
        a: {
            $subNode = sci_BitmapIndexedSetNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos));
            $subNodeSize = $subNode.$size();
            $subNodeCachedJavaKeySetHashCode = $subNode.$cachedJavaKeySetHashCode();
            if ($subNode instanceof sci_BitmapIndexedSetNode) {
                $subNodeNew = $subNode;
                if ($bitpos & $shallowlyMutableNodeMap) {
                    sci_BitmapIndexedSetNode_updateWithShallowMutations($subNodeNew, $element, $originalHash, $elementHash, $shift + 5 | 0, 0);
                    break a;
                }
            }
            $subNodeNew = $subNode.$updated3($element, $originalHash, $elementHash, $shift + 5 | 0);
            if ($subNodeNew !== $subNode)
                $shallowlyMutableNodeMap = $shallowlyMutableNodeMap | $bitpos;
        }
        $src = $this.$content1.data;
        $src[($src.length - 1 | 0) - sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) | 0] = $subNodeNew;
        $this.$size4 = ($this.$size4 - $subNodeSize | 0) + $subNodeNew.$size() | 0;
        $this.$cachedJavaKeySetHashCode0 = ($this.$cachedJavaKeySetHashCode0 - $subNodeCachedJavaKeySetHashCode | 0) + $subNodeNew.$cachedJavaKeySetHashCode() | 0;
        return $shallowlyMutableNodeMap;
    }
    function sci_BitmapIndexedSetNode_removed($this, $element, $originalHash, $elementHash, $shift) {
        var $mask, $bitpos, $getPayload_index, $subNode, $subNodeNew, $index, var$11, var$12, var$13, $newDataMap, var$15;
        $mask = $elementHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $getPayload_index = $this.$dataMap;
        if (!($getPayload_index & $bitpos)) {
            $getPayload_index = $this.$nodeMap;
            if ($getPayload_index & $bitpos) {
                $subNode = sci_BitmapIndexedSetNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $getPayload_index, $mask, $bitpos));
                $subNodeNew = $subNode.$removed0($element, $originalHash, $elementHash, $shift + 5 | 0);
                if ($subNodeNew === $subNode)
                    return $this;
                $originalHash = $rt_compare($subNodeNew.$size(), 1);
                if (!$originalHash) {
                    if ($this.$size4 == $subNode.$size())
                        return $subNodeNew;
                    $shift = ($this.$content1.data.length - 1 | 0) - sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) | 0;
                    $mask = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
                    $index = 1 * $mask | 0;
                    var$11 = $this.$content1;
                    $getPayload_index = var$11.data.length;
                    var$12 = $rt_createArray(jl_Object, ($getPayload_index - 1 | 0) + 1 | 0);
                    var$13 = var$12.data;
                    jl_System_arraycopy(var$11, 0, var$12, 0, $index);
                    var$13[$index] = $subNodeNew.$getPayload(0);
                    jl_System_arraycopy(var$11, $index, var$12, $index + 1 | 0, $shift - $index | 0);
                    $originalHash = $shift + 1 | 0;
                    jl_System_arraycopy(var$11, $originalHash, var$12, $originalHash, ($getPayload_index - $shift | 0) - 1 | 0);
                    $originalHash = $subNodeNew.$getHash(0);
                    var$13 = sci_Node_insertElement($this, $this.$originalHashes0, $mask, $originalHash);
                    return sci_BitmapIndexedSetNode__init_($this.$dataMap | $bitpos, $this.$nodeMap ^ $bitpos, var$12, var$13, ($this.$size4 - $subNode.$size() | 0) + 1 | 0, ($this.$cachedJavaKeySetHashCode0 - $subNode.$cachedJavaKeySetHashCode() | 0) + $subNodeNew.$cachedJavaKeySetHashCode() | 0);
                }
                if ($originalHash > 0)
                    return sci_BitmapIndexedSetNode_copyAndSetNode($this, $bitpos, $subNode, $subNodeNew);
            }
            return $this;
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $getPayload_index, $mask, $bitpos);
        if (!sr_BoxesRunTime_equals($this.$content1.data[$index], $element))
            return $this;
        if (sci_BitmapIndexedSetNode_payloadArity($this) == 2 && !sci_BitmapIndexedSetNode_nodeArity($this)) {
            $newDataMap = !$shift ? $this.$dataMap ^ $bitpos : 1 << ($elementHash >>> 0 & 31);
            if ($index) {
                $element = new sci_BitmapIndexedSetNode;
                var$12 = $rt_createArray(jl_Object, 1);
                var$12.data[0] = $this.$content1.data[0];
                var$13 = $rt_createIntArray(1);
                var$15 = var$13.data;
                var$11 = $this.$originalHashes0.data;
                var$15[0] = var$11[0];
                sci_BitmapIndexedSetNode__init_0($element, $newDataMap, 0, var$12, var$13, $this.$size4 - 1 | 0, sc_Hashing$_improve(sc_Hashing$_MODULE$, var$11[0]));
                return $element;
            }
            $element = new sci_BitmapIndexedSetNode;
            var$12 = $rt_createArray(jl_Object, 1);
            var$12.data[0] = $this.$content1.data[1];
            var$13 = $rt_createIntArray(1);
            var$15 = var$13.data;
            var$11 = $this.$originalHashes0.data;
            var$15[0] = var$11[1];
            sci_BitmapIndexedSetNode__init_0($element, $newDataMap, 0, var$12, var$13, $this.$size4 - 1 | 0, sc_Hashing$_improve(sc_Hashing$_MODULE$, var$11[1]));
            return $element;
        }
        $shift = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
        $getPayload_index = 1 * $shift | 0;
        var$13 = $this.$content1;
        $mask = var$13.data.length;
        var$12 = $rt_createArray(jl_Object, $mask - 1 | 0);
        jl_System_arraycopy(var$13, 0, var$12, 0, $getPayload_index);
        jl_System_arraycopy(var$13, $getPayload_index + 1 | 0, var$12, $getPayload_index, ($mask - $getPayload_index | 0) - 1 | 0);
        var$13 = sci_Node_removeElement($this, $this.$originalHashes0, $shift);
        return sci_BitmapIndexedSetNode__init_($this.$dataMap ^ $bitpos, $this.$nodeMap, var$12, var$13, $this.$size4 - 1 | 0, $this.$cachedJavaKeySetHashCode0 - $elementHash | 0);
    }
    function sci_BitmapIndexedSetNode_removeWithShallowMutations($this, $element, $originalHash, $elementHash) {
        var $mask, $bitpos, $maskFrom_shift, $subNode, $subNodeNew, $src, $index, $newDataMap, $newContent, $newOriginalHashes, $dst, $newCachedJavaKeySetHashCode, $dataIx, $idx, $dstHashes;
        $mask = $elementHash >>> 0 & 31;
        $bitpos = 1 << $mask;
        $maskFrom_shift = $this.$dataMap;
        if (!($maskFrom_shift & $bitpos)) {
            $maskFrom_shift = $this.$nodeMap;
            if (!($maskFrom_shift & $bitpos))
                return $this;
            $subNode = sci_BitmapIndexedSetNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $maskFrom_shift, $mask, $bitpos));
            $subNodeNew = $subNode.$removed0($element, $originalHash, $elementHash, 5);
            if ($subNodeNew === $subNode)
                return $this;
            if ($subNodeNew.$size4 != 1) {
                $src = $this.$content1.data;
                $src[($src.length - 1 | 0) - sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) | 0] = $subNodeNew;
                $this.$size4 = $this.$size4 - 1 | 0;
                $this.$cachedJavaKeySetHashCode0 = ($this.$cachedJavaKeySetHashCode0 - $subNode.$cachedJavaKeySetHashCode() | 0) + $subNodeNew.$cachedJavaKeySetHashCode0 | 0;
                return $this;
            }
            if (!sci_BitmapIndexedSetNode_payloadArity($this) && sci_BitmapIndexedSetNode_nodeArity($this) == 1) {
                $this.$dataMap = $subNodeNew.$dataMap;
                $this.$nodeMap = $subNodeNew.$nodeMap;
                $this.$content1 = $subNodeNew.$content1;
                $this.$originalHashes0 = $subNodeNew.$originalHashes0;
                $this.$size4 = $subNodeNew.$size4;
                $this.$cachedJavaKeySetHashCode0 = $subNodeNew.$cachedJavaKeySetHashCode0;
                return $this;
            }
            $maskFrom_shift = ($this.$content1.data.length - 1 | 0) - sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) | 0;
            $originalHash = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
            $element = sci_BitmapIndexedSetNode_getPayload($subNodeNew, 0);
            $src = $this.$content1;
            jl_System_arraycopy($src, $originalHash, $src, $originalHash + 1 | 0, $maskFrom_shift - $originalHash | 0);
            $this.$content1.data[$originalHash] = $element;
            $elementHash = sci_BitmapIndexedSetNode_getHash($subNodeNew, 0);
            $src = sci_Node_insertElement($this, $this.$originalHashes0, $originalHash, $elementHash);
            $this.$dataMap = $this.$dataMap | $bitpos;
            $this.$nodeMap = $this.$nodeMap ^ $bitpos;
            $this.$originalHashes0 = $src;
            $this.$size4 = ($this.$size4 - $subNode.$size() | 0) + 1 | 0;
            $this.$cachedJavaKeySetHashCode0 = ($this.$cachedJavaKeySetHashCode0 - $subNode.$cachedJavaKeySetHashCode() | 0) + $subNodeNew.$cachedJavaKeySetHashCode0 | 0;
            return $this;
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $maskFrom_shift, $mask, $bitpos);
        if (!sr_BoxesRunTime_equals($this.$content1.data[$index], $element))
            return $this;
        if (sci_BitmapIndexedSetNode_payloadArity($this) == 2 && !sci_BitmapIndexedSetNode_nodeArity($this)) {
            $newDataMap = $this.$dataMap ^ $bitpos;
            if ($index) {
                $newContent = $rt_createArray(jl_Object, 1);
                $newContent.data[0] = $this.$content1.data[0];
                $newOriginalHashes = $rt_createIntArray(1);
                $dst = $newOriginalHashes.data;
                $src = $this.$originalHashes0.data;
                $dst[0] = $src[0];
                $newCachedJavaKeySetHashCode = sc_Hashing$_improve(sc_Hashing$_MODULE$, $src[0]);
                $this.$content1 = $newContent;
                $this.$originalHashes0 = $newOriginalHashes;
                $this.$cachedJavaKeySetHashCode0 = $newCachedJavaKeySetHashCode;
            } else {
                $newContent = $rt_createArray(jl_Object, 1);
                $newContent.data[0] = $this.$content1.data[1];
                $newOriginalHashes = $rt_createIntArray(1);
                $dst = $newOriginalHashes.data;
                $src = $this.$originalHashes0.data;
                $dst[0] = $src[1];
                $newCachedJavaKeySetHashCode = sc_Hashing$_improve(sc_Hashing$_MODULE$, $src[1]);
                $this.$content1 = $newContent;
                $this.$originalHashes0 = $newOriginalHashes;
                $this.$cachedJavaKeySetHashCode0 = $newCachedJavaKeySetHashCode;
            }
            $this.$dataMap = $newDataMap;
            $this.$nodeMap = 0;
            $this.$size4 = 1;
            return $this;
        }
        $dataIx = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
        $idx = 1 * $dataIx | 0;
        $src = $this.$content1;
        $originalHash = $src.data.length;
        $dst = $rt_createArray(jl_Object, $originalHash - 1 | 0);
        jl_System_arraycopy($src, 0, $dst, 0, $idx);
        jl_System_arraycopy($src, $idx + 1 | 0, $dst, $idx, ($originalHash - $idx | 0) - 1 | 0);
        $dstHashes = sci_Node_removeElement($this, $this.$originalHashes0, $dataIx);
        $this.$dataMap = $this.$dataMap ^ $bitpos;
        $this.$content1 = $dst;
        $this.$originalHashes0 = $dstHashes;
        $this.$size4 = $this.$size4 - 1 | 0;
        $this.$cachedJavaKeySetHashCode0 = $this.$cachedJavaKeySetHashCode0 - $elementHash | 0;
        return $this;
    }
    function sci_BitmapIndexedSetNode_mergeTwoKeyValPairs($this, $key0, $originalKeyHash0, $keyHash0, $key1, $originalKeyHash1, $keyHash1, $shift) {
        var $node, $mask0, $mask1, $nodeMap, var$12, $dataMap, $newCachedHashCode;
        if ($shift >= 32) {
            $node = new sci_HashCollisionSetNode;
            sci_Vector$_$callClinit();
            sci_HashCollisionSetNode__init_($node, $originalKeyHash0, $keyHash0, sci_Vector$_from(sci_Vector$_MODULE$, sr_ScalaRunTime$_genericWrapArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_Object, [$key0, $key1]))));
            return $node;
        }
        $mask0 = $keyHash0 >>> $shift & 31;
        $mask1 = $keyHash1 >>> $shift & 31;
        $nodeMap = $rt_compare($mask0, $mask1);
        if (!$nodeMap) {
            $nodeMap = 1 << $mask0;
            $node = sci_BitmapIndexedSetNode_mergeTwoKeyValPairs($this, $key0, $originalKeyHash0, $keyHash0, $key1, $originalKeyHash1, $keyHash1, $shift + 5 | 0);
            $key0 = new sci_BitmapIndexedSetNode;
            var$12 = $rt_createArray(jl_Object, 1);
            var$12.data[0] = $node;
            sci_BitmapIndexedSetNode__init_0($key0, 0, $nodeMap, var$12, s_Array$_emptyIntArray, $node.$size(), $node.$cachedJavaKeySetHashCode());
            return $key0;
        }
        $dataMap = 1 << $mask0 | 1 << $mask1;
        $newCachedHashCode = $keyHash0 + $keyHash1 | 0;
        if ($nodeMap >= 0)
            return sci_BitmapIndexedSetNode__init_($dataMap, 0, $rt_createArrayFromData(jl_Object, [$key1, $key0]), $rt_createIntArrayFromData([$originalKeyHash1, $originalKeyHash0]), 2, $newCachedHashCode);
        return sci_BitmapIndexedSetNode__init_($dataMap, 0, $rt_createArrayFromData(jl_Object, [$key0, $key1]), $rt_createIntArrayFromData([$originalKeyHash0, $originalKeyHash1]), 2, $newCachedHashCode);
    }
    function sci_BitmapIndexedSetNode_hasPayload($this) {
        if (!$this.$dataMap)
            return 0;
        return 1;
    }
    function sci_BitmapIndexedSetNode_payloadArity($this) {
        return jl_Integer_bitCount($this.$dataMap);
    }
    function sci_BitmapIndexedSetNode_hasNodes($this) {
        if (!$this.$nodeMap)
            return 0;
        return 1;
    }
    function sci_BitmapIndexedSetNode_nodeArity($this) {
        return jl_Integer_bitCount($this.$nodeMap);
    }
    function sci_BitmapIndexedSetNode_dataIndex($this, $bitpos) {
        return jl_Integer_bitCount($this.$dataMap & ($bitpos - 1 | 0));
    }
    function sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) {
        return jl_Integer_bitCount($this.$nodeMap & ($bitpos - 1 | 0));
    }
    function sci_BitmapIndexedSetNode_copyAndSetNode($this, $bitpos, $oldNode, $newNode) {
        var $idx, $src, var$6, $dst, var$8;
        $idx = ($this.$content1.data.length - 1 | 0) - sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) | 0;
        $src = $this.$content1;
        var$6 = $src.data.length;
        $dst = $rt_createArray(jl_Object, var$6);
        var$8 = $dst.data;
        jl_System_arraycopy($src, 0, $dst, 0, var$6);
        var$8[$idx] = $newNode;
        return sci_BitmapIndexedSetNode__init_($this.$dataMap, $this.$nodeMap, $dst, $this.$originalHashes0, ($this.$size4 - $oldNode.$size() | 0) + $newNode.$size() | 0, ($this.$cachedJavaKeySetHashCode0 - $oldNode.$cachedJavaKeySetHashCode() | 0) + $newNode.$cachedJavaKeySetHashCode() | 0);
    }
    function sci_BitmapIndexedSetNode_migrateFromInlineToNodeInPlace($this, $bitpos, $keyHash, $node) {
        var $dataIx, $idxOld, $idxNew, var$7;
        $dataIx = sci_BitmapIndexedSetNode_dataIndex($this, $bitpos);
        $idxOld = 1 * $dataIx | 0;
        $idxNew = ($this.$content1.data.length - 1 | 0) - sci_BitmapIndexedSetNode_nodeIndex($this, $bitpos) | 0;
        var$7 = $this.$content1;
        jl_System_arraycopy(var$7, $idxOld + 1 | 0, var$7, $idxOld, $idxNew - $idxOld | 0);
        $this.$content1.data[$idxNew] = $node;
        $this.$dataMap = $this.$dataMap ^ $bitpos;
        $this.$nodeMap = $this.$nodeMap | $bitpos;
        $this.$originalHashes0 = sci_Node_removeElement($this, $this.$originalHashes0, $dataIx);
        $this.$size4 = ($this.$size4 - 1 | 0) + $node.$size() | 0;
        $this.$cachedJavaKeySetHashCode0 = ($this.$cachedJavaKeySetHashCode0 - $keyHash | 0) + $node.$cachedJavaKeySetHashCode() | 0;
        return $this;
    }
    function sci_BitmapIndexedSetNode_foreach($this, $f) {
        var $thisPayloadArity, $i, $thisNodeArity, $j;
        $thisPayloadArity = sci_BitmapIndexedSetNode_payloadArity($this);
        $i = 0;
        while ($i < $thisPayloadArity) {
            $f.$apply($this.$content1.data[$i]);
            $i = $i + 1 | 0;
        }
        $thisNodeArity = sci_BitmapIndexedSetNode_nodeArity($this);
        $j = 0;
        while ($j < $thisNodeArity) {
            (sci_BitmapIndexedSetNode_getNode($this, $j)).$foreach($f);
            $j = $j + 1 | 0;
        }
    }
    function sci_BitmapIndexedSetNode_filterImpl($this, $pred, $flipped) {
        var $maximumIndex, $i, $newDataMap, $newCachedHashCode, $dataIndex, $bitpos, $newSize, $newContent, var$11, $newOriginalHashCodes, var$13, $newMaximumIndex, $j, $newDataIndex, $oldIndex, $allMap, $minimumIndex, $oldDataPassThrough, $nodeMigrateToDataTargetMap, $nodesToMigrateToData, $nodesToPassThroughMap, $mapOfNewNodes, $newNodes, $newDataMap_0, $newNodeMap, $nodeIndex, $i_0, $oldSubNode, $newSubNode;
        $maximumIndex = $this.$size4;
        if (!$maximumIndex)
            return $this;
        if ($maximumIndex == 1) {
            if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$content1.data[0])) != $flipped)
                return $this;
            sci_SetNode$_$callClinit();
            return sci_SetNode$_empty(sci_SetNode$_MODULE$);
        }
        $maximumIndex = $this.$nodeMap;
        if (!$maximumIndex) {
            $i = jl_Integer_numberOfTrailingZeros($this.$dataMap);
            $maximumIndex = 32 - jl_Integer_numberOfLeadingZeros($this.$dataMap) | 0;
            $newDataMap = 0;
            $newCachedHashCode = 0;
            $dataIndex = 0;
            while ($i < $maximumIndex) {
                $bitpos = 1 << $i;
                if ($bitpos & $this.$dataMap) {
                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$content1.data[$dataIndex])) == $flipped ? 0 : 1) {
                        $newDataMap = $newDataMap | $bitpos;
                        $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $this.$originalHashes0.data[$dataIndex]) | 0;
                    }
                    $dataIndex = $dataIndex + 1 | 0;
                }
                $i = $i + 1 | 0;
            }
            if (!$newDataMap) {
                sci_SetNode$_$callClinit();
                return sci_SetNode$_empty(sci_SetNode$_MODULE$);
            }
            if ($newDataMap == $this.$dataMap)
                return $this;
            $newSize = jl_Integer_bitCount($newDataMap);
            $newContent = $rt_createArray(jl_Object, $newSize);
            var$11 = $newContent.data;
            $newOriginalHashCodes = $rt_createIntArray($newSize);
            var$13 = $newOriginalHashCodes.data;
            $newMaximumIndex = 32 - jl_Integer_numberOfLeadingZeros($newDataMap) | 0;
            $j = jl_Integer_numberOfTrailingZeros($newDataMap);
            $newDataIndex = 0;
            while ($j < $newMaximumIndex) {
                $bitpos = 1 << $j;
                if ($bitpos & $newDataMap) {
                    $oldIndex = jl_Integer_bitCount($this.$dataMap & ($bitpos - 1 | 0));
                    var$11[$newDataIndex] = $this.$content1.data[$oldIndex];
                    var$13[$newDataIndex] = $this.$originalHashes0.data[$oldIndex];
                    $newDataIndex = $newDataIndex + 1 | 0;
                }
                $j = $j + 1 | 0;
            }
            return sci_BitmapIndexedSetNode__init_($newDataMap, 0, $newContent, $newOriginalHashCodes, $newSize, $newCachedHashCode);
        }
        $allMap = $this.$dataMap | $maximumIndex;
        $minimumIndex = jl_Integer_numberOfTrailingZeros($allMap);
        $maximumIndex = 32 - jl_Integer_numberOfLeadingZeros($allMap) | 0;
        $oldDataPassThrough = 0;
        $nodeMigrateToDataTargetMap = 0;
        $nodesToMigrateToData = null;
        $nodesToPassThroughMap = 0;
        $mapOfNewNodes = 0;
        $newNodes = null;
        $newDataMap_0 = 0;
        $newNodeMap = 0;
        $newSize = 0;
        $newCachedHashCode = 0;
        $dataIndex = 0;
        $nodeIndex = 0;
        $i_0 = $minimumIndex;
        while ($i_0 < $maximumIndex) {
            $bitpos = 1 << $i_0;
            if ($bitpos & $this.$dataMap) {
                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$content1.data[$dataIndex])) == $flipped ? 0 : 1) {
                    $newDataMap_0 = $newDataMap_0 | $bitpos;
                    $oldDataPassThrough = $oldDataPassThrough | $bitpos;
                    $newSize = $newSize + 1 | 0;
                    $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $this.$originalHashes0.data[$dataIndex]) | 0;
                }
                $dataIndex = $dataIndex + 1 | 0;
            } else if ($bitpos & $this.$nodeMap) {
                $oldSubNode = sci_BitmapIndexedSetNode_getNode($this, $nodeIndex);
                $newSubNode = $oldSubNode.$filterImpl1($pred, $flipped);
                $newSize = $newSize + $newSubNode.$size() | 0;
                $newCachedHashCode = $newCachedHashCode + $newSubNode.$cachedJavaKeySetHashCode() | 0;
                if ($newSubNode.$size() > 1) {
                    $newNodeMap = $newNodeMap | $bitpos;
                    if ($oldSubNode === $newSubNode)
                        $nodesToPassThroughMap = $nodesToPassThroughMap | $bitpos;
                    else {
                        $mapOfNewNodes = $mapOfNewNodes | $bitpos;
                        if ($newNodes === null)
                            $newNodes = scm_Queue$_empty(scm_Queue$_MODULE$);
                        $newNodes.$addOne($newSubNode);
                    }
                } else if ($newSubNode.$size() == 1) {
                    $newDataMap_0 = $newDataMap_0 | $bitpos;
                    $nodeMigrateToDataTargetMap = $nodeMigrateToDataTargetMap | $bitpos;
                    if ($nodesToMigrateToData === null)
                        $nodesToMigrateToData = scm_Queue$_empty(scm_Queue$_MODULE$);
                    $nodesToMigrateToData.$addOne($newSubNode);
                }
                $nodeIndex = $nodeIndex + 1 | 0;
            }
            $i_0 = $i_0 + 1 | 0;
        }
        return sci_BitmapIndexedSetNode_newNodeFrom($this, $newSize, $newDataMap_0, $newNodeMap, $minimumIndex, $oldDataPassThrough, $nodesToPassThroughMap, $nodeMigrateToDataTargetMap, $nodesToMigrateToData, $mapOfNewNodes, $newNodes, $newCachedHashCode);
    }
    function sci_BitmapIndexedSetNode_diff($this, $that, $shift) {
        var var$3, $minimumIndex, $h, $allMap, $maximumIndex, $oldDataPassThrough, $nodeMigrateToDataTargetMap, $nodesToMigrateToData, $nodesToPassThroughMap, $mapOfNewNodes, $newNodes, $newDataMap, $newNodeMap, $newSize, $newCachedHashCode, $dataIndex, $nodeIndex, $getHash_index, $i, $bitpos, $payload, $originalHash, $hash, $oldSubNode, $thatDataIndex, $thatPayload, $thatOriginalHash, $newSubNode;
        if (!($that instanceof sci_BitmapIndexedSetNode)) {
            if (!($that instanceof sci_HashCollisionSetNode))
                $rt_throw(s_MatchError__init_($that));
            $that = new jl_RuntimeException;
            jl_Throwable__init_($that, $rt_s(471));
            $rt_throw($that);
        }
        var$3 = $that;
        $minimumIndex = $this.$size4;
        if (!$minimumIndex)
            return $this;
        if ($minimumIndex == 1) {
            $h = $this.$originalHashes0.data[0];
            if (!$that.$contains1($this.$content1.data[0], $h, sc_Hashing$_improve(sc_Hashing$_MODULE$, $h), $shift))
                return $this;
            sci_SetNode$_$callClinit();
            return sci_SetNode$_empty(sci_SetNode$_MODULE$);
        }
        $allMap = $this.$dataMap | $this.$nodeMap;
        $minimumIndex = jl_Integer_numberOfTrailingZeros($allMap);
        $maximumIndex = 32 - jl_Integer_numberOfLeadingZeros($allMap) | 0;
        $oldDataPassThrough = 0;
        $nodeMigrateToDataTargetMap = 0;
        $nodesToMigrateToData = null;
        $nodesToPassThroughMap = 0;
        $mapOfNewNodes = 0;
        $newNodes = null;
        $newDataMap = 0;
        $newNodeMap = 0;
        $newSize = 0;
        $newCachedHashCode = 0;
        $dataIndex = 0;
        $nodeIndex = 0;
        $getHash_index = $shift + 5 | 0;
        $i = $minimumIndex;
        while ($i < $maximumIndex) {
            $bitpos = 1 << $i;
            if ($bitpos & $this.$dataMap) {
                $payload = $this.$content1.data[$dataIndex];
                $originalHash = $this.$originalHashes0.data[$dataIndex];
                $hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
                if (!sci_BitmapIndexedSetNode_contains(var$3, $payload, $originalHash, $hash, $shift)) {
                    $newDataMap = $newDataMap | $bitpos;
                    $oldDataPassThrough = $oldDataPassThrough | $bitpos;
                    $newSize = $newSize + 1 | 0;
                    $newCachedHashCode = $newCachedHashCode + $hash | 0;
                }
                $dataIndex = $dataIndex + 1 | 0;
            } else if ($bitpos & $this.$nodeMap) {
                $oldSubNode = sci_BitmapIndexedSetNode_getNode($this, $nodeIndex);
                $allMap = var$3.$dataMap;
                if ($bitpos & $allMap) {
                    $thatDataIndex = jl_Integer_bitCount($allMap & ($bitpos - 1 | 0));
                    $thatPayload = var$3.$content1.data[$thatDataIndex];
                    $thatOriginalHash = var$3.$originalHashes0.data[$thatDataIndex];
                    $newSubNode = $oldSubNode.$removed0($thatPayload, $thatOriginalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $thatOriginalHash), $getHash_index);
                } else {
                    $allMap = var$3.$nodeMap;
                    $newSubNode = !($bitpos & $allMap) ? $oldSubNode : $oldSubNode.$diff(sci_BitmapIndexedSetNode_getNode(var$3, jl_Integer_bitCount($allMap & ($bitpos - 1 | 0))), $getHash_index);
                }
                $newSize = $newSize + $newSubNode.$size() | 0;
                $newCachedHashCode = $newCachedHashCode + $newSubNode.$cachedJavaKeySetHashCode() | 0;
                if ($newSubNode.$size() > 1) {
                    $newNodeMap = $newNodeMap | $bitpos;
                    if ($oldSubNode === $newSubNode)
                        $nodesToPassThroughMap = $nodesToPassThroughMap | $bitpos;
                    else {
                        $mapOfNewNodes = $mapOfNewNodes | $bitpos;
                        if ($newNodes === null)
                            $newNodes = scm_Queue$_empty(scm_Queue$_MODULE$);
                        $newNodes.$addOne($newSubNode);
                    }
                } else if ($newSubNode.$size() == 1) {
                    $newDataMap = $newDataMap | $bitpos;
                    $nodeMigrateToDataTargetMap = $nodeMigrateToDataTargetMap | $bitpos;
                    if ($nodesToMigrateToData === null)
                        $nodesToMigrateToData = scm_Queue$_empty(scm_Queue$_MODULE$);
                    $nodesToMigrateToData.$addOne($newSubNode);
                }
                $nodeIndex = $nodeIndex + 1 | 0;
            }
            $i = $i + 1 | 0;
        }
        return sci_BitmapIndexedSetNode_newNodeFrom($this, $newSize, $newDataMap, $newNodeMap, $minimumIndex, $oldDataPassThrough, $nodesToPassThroughMap, $nodeMigrateToDataTargetMap, $nodesToMigrateToData, $mapOfNewNodes, $newNodes, $newCachedHashCode);
    }
    function sci_BitmapIndexedSetNode_newNodeFrom($this, $newSize, $newDataMap, $newNodeMap, $minimumIndex, $oldDataPassThrough, $nodesToPassThroughMap, $nodeMigrateToDataTargetMap, $nodesToMigrateToData, $mapOfNewNodes, $newNodes, $newCachedHashCode) {
        var $newDataSize, $newContentSize, $newContent, var$15, $newOriginalHashes, var$17, $maxIndex, $oldDataIndex, $oldNodeIndex, $newDataIndex, $newNodeIndex, $bitpos, $node;
        if (!$newSize) {
            sci_SetNode$_$callClinit();
            return sci_SetNode$_empty(sci_SetNode$_MODULE$);
        }
        if ($newSize == $this.$size4)
            return $this;
        $newDataSize = jl_Integer_bitCount($newDataMap);
        $newContentSize = $newDataSize + jl_Integer_bitCount($newNodeMap) | 0;
        $newContent = $rt_createArray(jl_Object, $newContentSize);
        var$15 = $newContent.data;
        $newOriginalHashes = $rt_createIntArray($newDataSize);
        var$17 = $newOriginalHashes.data;
        $maxIndex = 32 - jl_Integer_numberOfLeadingZeros($newDataMap | $newNodeMap) | 0;
        $oldDataIndex = 0;
        $oldNodeIndex = 0;
        $newDataIndex = 0;
        $newNodeIndex = 0;
        while ($minimumIndex < $maxIndex) {
            $bitpos = 1 << $minimumIndex;
            if ($bitpos & $oldDataPassThrough) {
                var$15[$newDataIndex] = $this.$content1.data[$oldDataIndex];
                var$17[$newDataIndex] = $this.$originalHashes0.data[$oldDataIndex];
                $newDataIndex = $newDataIndex + 1 | 0;
                $oldDataIndex = $oldDataIndex + 1 | 0;
            } else if ($bitpos & $nodesToPassThroughMap) {
                var$15[($newContentSize - $newNodeIndex | 0) - 1 | 0] = sci_BitmapIndexedSetNode_getNode($this, $oldNodeIndex);
                $newNodeIndex = $newNodeIndex + 1 | 0;
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            } else if ($bitpos & $nodeMigrateToDataTargetMap) {
                $node = scm_Queue_dequeue($nodesToMigrateToData);
                var$15[$newDataIndex] = $node.$getPayload(0);
                var$17[$newDataIndex] = $node.$getHash(0);
                $newDataIndex = $newDataIndex + 1 | 0;
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            } else if ($bitpos & $mapOfNewNodes) {
                var$15[($newContentSize - $newNodeIndex | 0) - 1 | 0] = scm_Queue_dequeue($newNodes);
                $newNodeIndex = $newNodeIndex + 1 | 0;
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            } else if ($bitpos & $this.$dataMap)
                $oldDataIndex = $oldDataIndex + 1 | 0;
            else if ($bitpos & $this.$nodeMap)
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            $minimumIndex = $minimumIndex + 1 | 0;
        }
        return sci_BitmapIndexedSetNode__init_($newDataMap, $newNodeMap, $newContent, $newOriginalHashes, $newSize, $newCachedHashCode);
    }
    function sci_BitmapIndexedSetNode_equals($this, $that) {
        var $deepContentEquality_a1, var$3, $deepContentEquality_a2, $deepContentEquality_length, $deepContentEquality_isEqual, $deepContentEquality_i;
        if (!($that instanceof sci_BitmapIndexedSetNode))
            return 0;
        a: {
            $that = $that;
            if ($this !== $that) {
                if ($this.$cachedJavaKeySetHashCode0 != $that.$cachedJavaKeySetHashCode0)
                    break a;
                if ($this.$nodeMap != $that.$nodeMap)
                    break a;
                if ($this.$dataMap != $that.$dataMap)
                    break a;
                if ($this.$size4 != $that.$size4)
                    break a;
                if (!ju_Arrays_equals0($this.$originalHashes0, $that.$originalHashes0))
                    break a;
                $deepContentEquality_a1 = $this.$content1;
                var$3 = $deepContentEquality_a1.data;
                $deepContentEquality_a2 = $that.$content1;
                $deepContentEquality_length = var$3.length;
                if ($deepContentEquality_a1 === $deepContentEquality_a2)
                    $deepContentEquality_isEqual = 1;
                else {
                    $deepContentEquality_isEqual = 1;
                    $deepContentEquality_i = 0;
                    while ($deepContentEquality_isEqual && $deepContentEquality_i < $deepContentEquality_length) {
                        $deepContentEquality_a1 = $deepContentEquality_a2.data;
                        $deepContentEquality_isEqual = !sr_BoxesRunTime_equals(var$3[$deepContentEquality_i], $deepContentEquality_a1[$deepContentEquality_i]) ? 0 : 1;
                        $deepContentEquality_i = $deepContentEquality_i + 1 | 0;
                    }
                }
                if (!$deepContentEquality_isEqual)
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function sci_BitmapIndexedSetNode_hashCode($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(472));
        $rt_throw(var$1);
    }
    function sci_BitmapIndexedSetNode_copy($this) {
        var $contentClone, var$2, $contentLength, $i;
        $contentClone = $this.$content1.$clone();
        var$2 = $contentClone.data;
        $contentLength = var$2.length;
        $i = jl_Integer_bitCount($this.$dataMap);
        while ($i < $contentLength) {
            var$2[$i] = var$2[$i].$copy20();
            $i = $i + 1 | 0;
        }
        return sci_BitmapIndexedSetNode__init_($this.$dataMap, $this.$nodeMap, $contentClone, $this.$originalHashes0.$clone(), $this.$size4, $this.$cachedJavaKeySetHashCode0);
    }
    function sci_BitmapIndexedSetNode_concat($this, $that, $shift) {
        var $originalHash, $anyChangesMadeSoFar, $allMap, $minimumBitPos, $maximumBitPos, $leftNodeRightNode, $leftDataRightNode, $leftNodeRightData, $leftDataOnly, $rightDataOnly, $leftNodeOnly, $rightNodeOnly, $leftDataRightDataMigrateToNode, $leftDataRightDataLeftOverwrites, $dataToNodeMigrationTargets, $leftIdx, $rightIdx, $finished, $compressedNodeIdx, $leftNode, $newDataMap, $newNodeMap, $newDataSize, $newContentSize, $newContent, var$28, $newOriginalHashes, var$30, $newSize, $newCachedHashCode, $leftDataIdx,
        $rightDataIdx, $leftNodeIdx, $rightNodeIdx, $nextShift, $compressedDataIdx, $newNode, $n, $leftPayload, $leftOriginalHash, $rightOriginalHash, $updated;
        if (!($that instanceof sci_BitmapIndexedSetNode))
            $rt_throw(jl_UnsupportedOperationException__init_($rt_s(473)));
        $that = $that;
        if (!sci_BitmapIndexedSetNode_size($this))
            return $that;
        if (sci_BitmapIndexedSetNode_size($that) && $that !== $this) {
            if (sci_BitmapIndexedSetNode_size($that) == 1) {
                $originalHash = sci_BitmapIndexedSetNode_getHash($that, 0);
                return sci_BitmapIndexedSetNode_updated($this, sci_BitmapIndexedSetNode_getPayload($that, 0), $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), $shift);
            }
            $anyChangesMadeSoFar = 0;
            $allMap = sci_BitmapIndexedSetNode_dataMap($this) | sci_BitmapIndexedSetNode_dataMap($that) | sci_BitmapIndexedSetNode_nodeMap($this) | sci_BitmapIndexedSetNode_nodeMap($that);
            $minimumBitPos = sci_Node$_bitposFrom(sci_Node$_MODULE$, jl_Integer_numberOfTrailingZeros($allMap));
            $maximumBitPos = sci_Node$_bitposFrom(sci_Node$_MODULE$, (32 - jl_Integer_numberOfLeadingZeros($allMap) | 0) - 1 | 0);
            $leftNodeRightNode = 0;
            $leftDataRightNode = 0;
            $leftNodeRightData = 0;
            $leftDataOnly = 0;
            $rightDataOnly = 0;
            $leftNodeOnly = 0;
            $rightNodeOnly = 0;
            $leftDataRightDataMigrateToNode = 0;
            $leftDataRightDataLeftOverwrites = 0;
            $dataToNodeMigrationTargets = 0;
            $leftIdx = 0;
            $rightIdx = 0;
            $finished = 0;
            $compressedNodeIdx = $minimumBitPos;
            while (!$finished) {
                if (!($compressedNodeIdx & sci_BitmapIndexedSetNode_dataMap($this))) {
                    if (!($compressedNodeIdx & sci_BitmapIndexedSetNode_nodeMap($this))) {
                        if ($compressedNodeIdx & sci_BitmapIndexedSetNode_dataMap($that)) {
                            $rightDataOnly = $rightDataOnly | $compressedNodeIdx;
                            $rightIdx = $rightIdx + 1 | 0;
                        } else if ($compressedNodeIdx & sci_BitmapIndexedSetNode_nodeMap($that))
                            $rightNodeOnly = $rightNodeOnly | $compressedNodeIdx;
                    } else if ($compressedNodeIdx & sci_BitmapIndexedSetNode_dataMap($that)) {
                        $leftNodeRightData = $leftNodeRightData | $compressedNodeIdx;
                        $rightIdx = $rightIdx + 1 | 0;
                    } else if (!($compressedNodeIdx & sci_BitmapIndexedSetNode_nodeMap($that)))
                        $leftNodeOnly = $leftNodeOnly | $compressedNodeIdx;
                    else
                        $leftNodeRightNode = $leftNodeRightNode | $compressedNodeIdx;
                } else {
                    if (!($compressedNodeIdx & sci_BitmapIndexedSetNode_dataMap($that))) {
                        if (!($compressedNodeIdx & sci_BitmapIndexedSetNode_nodeMap($that)))
                            $leftDataOnly = $leftDataOnly | $compressedNodeIdx;
                        else
                            $leftDataRightNode = $leftDataRightNode | $compressedNodeIdx;
                    } else {
                        if (sci_BitmapIndexedSetNode_getHash($this, $leftIdx) == sci_BitmapIndexedSetNode_getHash($that, $rightIdx) && sr_BoxesRunTime_equals(sci_BitmapIndexedSetNode_getPayload($this, $leftIdx), sci_BitmapIndexedSetNode_getPayload($that, $rightIdx)))
                            $leftDataRightDataLeftOverwrites = $leftDataRightDataLeftOverwrites | $compressedNodeIdx;
                        else {
                            $leftDataRightDataMigrateToNode = $leftDataRightDataMigrateToNode | $compressedNodeIdx;
                            $leftNode = sci_Node$_MODULE$;
                            $dataToNodeMigrationTargets = $dataToNodeMigrationTargets | sci_Node$_bitposFrom($leftNode, sci_Node$_maskFrom($leftNode, sc_Hashing$_improve(sc_Hashing$_MODULE$, sci_BitmapIndexedSetNode_getHash($this, $leftIdx)), $shift));
                        }
                        $rightIdx = $rightIdx + 1 | 0;
                    }
                    $leftIdx = $leftIdx + 1 | 0;
                }
                if ($compressedNodeIdx == $maximumBitPos) {
                    $finished = 1;
                    continue;
                }
                $compressedNodeIdx = $compressedNodeIdx << 1;
            }
            $newDataMap = $leftDataOnly | $rightDataOnly | $leftDataRightDataLeftOverwrites;
            $newNodeMap = $leftNodeRightNode | $leftDataRightNode | $leftNodeRightData | $leftNodeOnly | $rightNodeOnly | $dataToNodeMigrationTargets;
            if ($newDataMap == ($leftDataOnly | $leftDataRightDataLeftOverwrites) && $newNodeMap == $leftNodeOnly)
                return $this;
            $newDataSize = jl_Integer_bitCount($newDataMap);
            $newContentSize = $newDataSize + jl_Integer_bitCount($newNodeMap) | 0;
            $newContent = $rt_createArray(jl_Object, $newContentSize);
            var$28 = $newContent.data;
            $newOriginalHashes = $rt_createIntArray($newDataSize);
            var$30 = $newOriginalHashes.data;
            $newSize = 0;
            $newCachedHashCode = 0;
            $leftDataIdx = 0;
            $rightDataIdx = 0;
            $leftNodeIdx = 0;
            $rightNodeIdx = 0;
            $nextShift = $shift + 5 | 0;
            $compressedDataIdx = 0;
            $compressedNodeIdx = 0;
            $finished = 0;
            while (!$finished) {
                a: {
                    if ($minimumBitPos & $leftNodeRightNode) {
                        $leftNode = sci_BitmapIndexedSetNode_getNode($this, $leftNodeIdx);
                        $newNode = $leftNode.$concat3(sci_BitmapIndexedSetNode_getNode($that, $rightNodeIdx), $nextShift);
                        if ($leftNode !== $newNode)
                            $anyChangesMadeSoFar = 1;
                        var$28[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $rightNodeIdx = $rightNodeIdx + 1 | 0;
                        $leftNodeIdx = $leftNodeIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftDataRightNode) {
                        $anyChangesMadeSoFar = 1;
                        $n = sci_BitmapIndexedSetNode_getNode($that, $rightNodeIdx);
                        $leftPayload = sci_BitmapIndexedSetNode_getPayload($this, $leftDataIdx);
                        $leftOriginalHash = sci_BitmapIndexedSetNode_getHash($this, $leftDataIdx);
                        $newNode = $n.$updated3($leftPayload, $leftOriginalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $leftOriginalHash), $nextShift);
                        var$28[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $rightNodeIdx = $rightNodeIdx + 1 | 0;
                        $leftDataIdx = $leftDataIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftNodeRightData) {
                        $rightOriginalHash = sci_BitmapIndexedSetNode_getHash($that, $rightDataIdx);
                        $leftNode = sci_BitmapIndexedSetNode_getNode($this, $leftNodeIdx);
                        $updated = $leftNode.$updated3(sci_BitmapIndexedSetNode_getPayload($that, $rightDataIdx), sci_BitmapIndexedSetNode_getHash($that, $rightDataIdx), sc_Hashing$_improve(sc_Hashing$_MODULE$, $rightOriginalHash), $nextShift);
                        if ($updated !== $leftNode)
                            $anyChangesMadeSoFar = 1;
                        var$28[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $updated;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $leftNodeIdx = $leftNodeIdx + 1 | 0;
                        $rightDataIdx = $rightDataIdx + 1 | 0;
                        $newSize = $newSize + $updated.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $updated.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftDataOnly) {
                        $originalHash = (sci_BitmapIndexedSetNode_originalHashes($this)).data[$leftDataIdx];
                        var$28[$compressedDataIdx] = sci_BitmapIndexedSetNode_getPayload($this, $leftDataIdx);
                        var$30[$compressedDataIdx] = $originalHash;
                        $compressedDataIdx = $compressedDataIdx + 1 | 0;
                        $leftDataIdx = $leftDataIdx + 1 | 0;
                        $newSize = $newSize + 1 | 0;
                        $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash) | 0;
                        break a;
                    }
                    if ($minimumBitPos & $rightDataOnly) {
                        $anyChangesMadeSoFar = 1;
                        $originalHash = (sci_BitmapIndexedSetNode_originalHashes($that)).data[$rightDataIdx];
                        var$28[$compressedDataIdx] = sci_BitmapIndexedSetNode_getPayload($that, $rightDataIdx);
                        var$30[$compressedDataIdx] = $originalHash;
                        $compressedDataIdx = $compressedDataIdx + 1 | 0;
                        $rightDataIdx = $rightDataIdx + 1 | 0;
                        $newSize = $newSize + 1 | 0;
                        $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash) | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftNodeOnly) {
                        $newNode = sci_BitmapIndexedSetNode_getNode($this, $leftNodeIdx);
                        var$28[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $leftNodeIdx = $leftNodeIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $rightNodeOnly) {
                        $anyChangesMadeSoFar = 1;
                        $newNode = sci_BitmapIndexedSetNode_getNode($that, $rightNodeIdx);
                        var$28[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $rightNodeIdx = $rightNodeIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftDataRightDataMigrateToNode) {
                        $anyChangesMadeSoFar = 1;
                        $leftOriginalHash = sci_BitmapIndexedSetNode_getHash($this, $leftDataIdx);
                        $rightOriginalHash = sci_BitmapIndexedSetNode_getHash($that, $rightDataIdx);
                        $newNode = sci_BitmapIndexedSetNode_mergeTwoKeyValPairs($that, sci_BitmapIndexedSetNode_getPayload($this, $leftDataIdx), $leftOriginalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $leftOriginalHash), sci_BitmapIndexedSetNode_getPayload($that, $rightDataIdx), $rightOriginalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $rightOriginalHash), $nextShift);
                        var$28[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $leftDataIdx = $leftDataIdx + 1 | 0;
                        $rightDataIdx = $rightDataIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if (!($minimumBitPos & $leftDataRightDataLeftOverwrites))
                        break a;
                    $originalHash = (sci_BitmapIndexedSetNode_originalHashes($that)).data[$rightDataIdx];
                    var$28[$compressedDataIdx] = sci_BitmapIndexedSetNode_getPayload($that, $rightDataIdx);
                    var$30[$compressedDataIdx] = $originalHash;
                    $compressedDataIdx = $compressedDataIdx + 1 | 0;
                    $rightDataIdx = $rightDataIdx + 1 | 0;
                    $newSize = $newSize + 1 | 0;
                    $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash) | 0;
                    $leftDataIdx = $leftDataIdx + 1 | 0;
                }
                if ($minimumBitPos == $maximumBitPos) {
                    $finished = 1;
                    continue;
                }
                $minimumBitPos = $minimumBitPos << 1;
            }
            if (!$anyChangesMadeSoFar)
                return $this;
            return sci_BitmapIndexedSetNode__init_($newDataMap, $newNodeMap, $newContent, $newOriginalHashes, $newSize, $newCachedHashCode);
        }
        return $this;
    }
    function sci_BitmapIndexedSetNode_foreachWithHash($this, $f) {
        var $iN, $i, $jN, $j;
        $iN = sci_BitmapIndexedSetNode_payloadArity($this);
        $i = 0;
        while ($i < $iN) {
            scm_HashSet$addAll$lambda$_52_0_apply($f, $this.$content1.data[$i], jl_Integer_valueOf($this.$originalHashes0.data[$i]));
            $i = $i + 1 | 0;
        }
        $jN = sci_BitmapIndexedSetNode_nodeArity($this);
        $j = 0;
        while ($j < $jN) {
            (sci_BitmapIndexedSetNode_getNode($this, $j)).$foreachWithHash0($f);
            $j = $j + 1 | 0;
        }
    }
    function sci_BitmapIndexedSetNode_foreachWithHashWhile($this, $f) {
        var $thisPayloadArity, $pass, $i, $thisNodeArity, $j;
        $thisPayloadArity = sci_BitmapIndexedSetNode_payloadArity($this);
        $pass = 1;
        $i = 0;
        while ($i < $thisPayloadArity && $pass) {
            $pass = $pass && sr_BoxesRunTime_unboxToBoolean(scm_HashSet$subtractAll$lambda$_53_0_apply($f, $this.$content1.data[$i], jl_Integer_valueOf($this.$originalHashes0.data[$i]))) ? 1 : 0;
            $i = $i + 1 | 0;
        }
        $thisNodeArity = sci_BitmapIndexedSetNode_nodeArity($this);
        $j = 0;
        while ($j < $thisNodeArity && $pass) {
            $pass = $pass && (sci_BitmapIndexedSetNode_getNode($this, $j)).$foreachWithHashWhile($f) ? 1 : 0;
            $j = $j + 1 | 0;
        }
        return $pass;
    }
    function sci_BitmapIndexedSetNode_concat0($this, $that, $shift) {
        return sci_BitmapIndexedSetNode_concat($this, $that, $shift);
    }
    function sci_BitmapIndexedSetNode_copy0($this) {
        return sci_BitmapIndexedSetNode_copy($this);
    }
    function sci_BitmapIndexedSetNode_diff0($this, $that, $shift) {
        return sci_BitmapIndexedSetNode_diff($this, $that, $shift);
    }
    function sci_BitmapIndexedSetNode_filterImpl0($this, $pred, $flipped) {
        return sci_BitmapIndexedSetNode_filterImpl($this, $pred, $flipped);
    }
    function sci_BitmapIndexedSetNode_removed0($this, $element, $originalHash, $hash, $shift) {
        return sci_BitmapIndexedSetNode_removed($this, $element, $originalHash, $hash, $shift);
    }
    function sci_BitmapIndexedSetNode_updated0($this, $element, $originalHash, $hash, $shift) {
        return sci_BitmapIndexedSetNode_updated($this, $element, $originalHash, $hash, $shift);
    }
    function sci_BitmapIndexedSetNode_getNode0($this, $index) {
        return sci_BitmapIndexedSetNode_getNode($this, $index);
    }
    function sci_BitmapIndexedSetNode__init_0($this, $dataMap, $nodeMap, $content, $originalHashes, $size, $cachedJavaKeySetHashCode) {
        $this.$dataMap = $dataMap;
        $this.$nodeMap = $nodeMap;
        $this.$content1 = $content;
        $this.$originalHashes0 = $originalHashes;
        $this.$size4 = $size;
        $this.$cachedJavaKeySetHashCode0 = $cachedJavaKeySetHashCode;
    }
    function sc_Iterator$$anon$9() {
        var a = this; sc_AbstractIterator.call(a);
        a.$$outer10 = null;
        a.$f$2 = null;
    }
    function sc_Iterator$$anon$9_knownSize($this) {
        return $this.$$outer10.$knownSize();
    }
    function sc_Iterator$$anon$9_hasNext($this) {
        return $this.$$outer10.$hasNext();
    }
    function sc_Iterator$$anon$9_next($this) {
        return $this.$f$2.$apply($this.$$outer10.$next());
    }
    function sc_Iterator$ConcatIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$current0 = null;
        a.$tail1 = null;
        a.$last0 = null;
        a.$currentHasNextChecked = 0;
    }
    function sc_Iterator$ConcatIterator_hasNext($this) {
        var var$1, var$2, var$3, var$4;
        if ($this.$currentHasNextChecked)
            return 1;
        var$1 = $this.$current0;
        if (var$1 === null)
            return 0;
        if (var$1.$hasNext()) {
            $this.$currentHasNextChecked = 1;
            return 1;
        }
        a: {
            while (true) {
                var$1 = $this.$tail1;
                if (var$1 === null) {
                    $this.$current0 = null;
                    $this.$last0 = null;
                    var$2 = 0;
                    break a;
                }
                $this.$current0 = (var$1.$head1.$apply2()).$iterator0();
                var$1 = $this.$last0;
                var$3 = $this.$tail1;
                if (var$1 === var$3)
                    $this.$last0 = var$1.$tail3;
                $this.$tail1 = var$3.$tail3;
                while (true) {
                    var$1 = $this.$current0;
                    if (!(var$1 instanceof sc_Iterator$ConcatIterator))
                        break;
                    var$1 = var$1;
                    $this.$current0 = var$1.$current0;
                    $this.$currentHasNextChecked = var$1.$currentHasNextChecked;
                    var$4 = var$1.$tail1;
                    if (var$4 === null)
                        continue;
                    if ($this.$last0 === null)
                        $this.$last0 = var$1.$last0;
                    var$1.$last0.$tail3 = $this.$tail1;
                    $this.$tail1 = var$4;
                }
                if ($this.$currentHasNextChecked)
                    break;
                if (var$1 === null)
                    continue;
                if (!var$1.$hasNext())
                    continue;
                else {
                    $this.$currentHasNextChecked = 1;
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 1;
        }
        return var$2;
    }
    function sc_Iterator$ConcatIterator_next($this) {
        if (!sc_Iterator$ConcatIterator_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $this.$currentHasNextChecked = 0;
        return $this.$current0.$next();
    }
    function sc_Iterator$ConcatIterator_concat($this, $that) {
        var $c, var$3;
        $c = new sc_Iterator$ConcatIteratorCell;
        var$3 = null;
        $c.$head1 = $that;
        $c.$tail3 = var$3;
        if ($this.$tail1 === null) {
            $this.$tail1 = $c;
            $this.$last0 = $c;
        } else {
            $this.$last0.$tail3 = $c;
            $this.$last0 = $c;
        }
        if ($this.$current0 === null)
            $this.$current0 = sc_Iterator$_scala$collection$Iterator$$_empty;
        return $this;
    }
    var sc_StrictOptimizedSetOps = $rt_classWithoutFields(0);
    var sci_StrictOptimizedSetOps = $rt_classWithoutFields(0);
    function sci_HashSet() {
        sci_AbstractSet.call(this);
        this.$rootNode0 = null;
    }
    function sci_HashSet__init_(var_0) {
        var var_1 = new sci_HashSet();
        sci_HashSet__init_0(var_1, var_0);
        return var_1;
    }
    function sci_HashSet_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function sci_HashSet_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_HashSet_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_HashSet_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_HashSet_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_HashSet_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_HashSet_newHashSetOrThis($this, $newRootNode) {
        if ($this.$rootNode0 === $newRootNode)
            return $this;
        return sci_HashSet__init_($newRootNode);
    }
    function sci_HashSet_iterableFactory($this) {
        sci_HashSet$_$callClinit();
        return sci_HashSet$_MODULE$;
    }
    function sci_HashSet_knownSize($this) {
        return $this.$rootNode0.$size4;
    }
    function sci_HashSet_size($this) {
        return $this.$rootNode0.$size4;
    }
    function sci_HashSet_isEmpty($this) {
        if ($this.$rootNode0.$size4)
            return 0;
        return 1;
    }
    function sci_HashSet_iterator($this) {
        var var$1;
        if (sci_HashSet_isEmpty($this))
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new sci_SetIterator;
        sci_ChampBaseIterator__init_(var$1, $this.$rootNode0);
        return var$1;
    }
    function sci_HashSet_contains($this, $element) {
        var $elementUnimprovedHash, $elementHash;
        $elementUnimprovedHash = sr_Statics_anyHash($element);
        $elementHash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $elementUnimprovedHash);
        return sci_BitmapIndexedSetNode_contains($this.$rootNode0, $element, $elementUnimprovedHash, $elementHash, 0);
    }
    function sci_HashSet_incl($this, $element) {
        var $elementUnimprovedHash, $elementHash;
        $elementUnimprovedHash = sr_Statics_anyHash($element);
        $elementHash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $elementUnimprovedHash);
        return sci_HashSet_newHashSetOrThis($this, sci_BitmapIndexedSetNode_updated($this.$rootNode0, $element, $elementUnimprovedHash, $elementHash, 0));
    }
    function sci_HashSet_excl($this, $element) {
        var $elementUnimprovedHash, $elementHash;
        $elementUnimprovedHash = sr_Statics_anyHash($element);
        $elementHash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $elementUnimprovedHash);
        return sci_HashSet_newHashSetOrThis($this, sci_BitmapIndexedSetNode_removed($this.$rootNode0, $element, $elementUnimprovedHash, $elementHash, 0));
    }
    function sci_HashSet_concat($this, $that) {
        var $newNode, $iter, $current, $next, $unimproveHash_improvedHash, $originalHash, $improved, $shallowlyMutableNodeMap, $element, $originalHash_0;
        if ($that instanceof sci_HashSet) {
            $that = $that;
            if (sci_HashSet_isEmpty($this))
                return $that;
            $newNode = sci_BitmapIndexedSetNode_concat($this.$rootNode0, $that.$rootNode0, 0);
            if ($newNode === $that.$rootNode0)
                return $that;
            return sci_HashSet_newHashSetOrThis($this, $newNode);
        }
        if ($that instanceof scm_HashSet) {
            $that = $that;
            if ($that === null)
                $rt_throw(null);
            $iter = new scm_HashSet$$anon$2;
            scm_HashSet$HashSetIterator__init_($iter, $that);
            $current = $this.$rootNode0;
            while (scm_HashSet$HashSetIterator_hasNext($iter)) {
                $next = scm_HashSet$HashSetIterator_next($iter);
                $unimproveHash_improvedHash = $next.$_hash0;
                $originalHash = $unimproveHash_improvedHash ^ $unimproveHash_improvedHash >>> 16;
                $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
                $current = sci_BitmapIndexedSetNode_updated($current, $next.$_key0, $originalHash, $improved, 0);
                if ($current !== $this.$rootNode0) {
                    $shallowlyMutableNodeMap = 1 << ($improved >>> 0 & 31);
                    while (scm_HashSet$HashSetIterator_hasNext($iter)) {
                        $next = scm_HashSet$HashSetIterator_next($iter);
                        $unimproveHash_improvedHash = $next.$_hash0;
                        $originalHash = $unimproveHash_improvedHash ^ $unimproveHash_improvedHash >>> 16;
                        $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
                        $shallowlyMutableNodeMap = sci_BitmapIndexedSetNode_updateWithShallowMutations($current, $next.$_key0, $originalHash, $improved, 0, $shallowlyMutableNodeMap);
                    }
                    return sci_HashSet__init_($current);
                }
            }
            return $this;
        }
        if (!($that instanceof scm_LinkedHashSet)) {
            $iter = $that.$iterator0();
            $current = $this.$rootNode0;
            while ($iter.$hasNext()) {
                $element = $iter.$next();
                $originalHash_0 = sr_Statics_anyHash($element);
                $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash_0);
                $current = sci_BitmapIndexedSetNode_updated($current, $element, $originalHash_0, $improved, 0);
                if ($current !== $this.$rootNode0) {
                    $shallowlyMutableNodeMap = 1 << ($improved >>> 0 & 31);
                    while ($iter.$hasNext()) {
                        $element = $iter.$next();
                        $originalHash = sr_Statics_anyHash($element);
                        $shallowlyMutableNodeMap = sci_BitmapIndexedSetNode_updateWithShallowMutations($current, $element, $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0, $shallowlyMutableNodeMap);
                    }
                    return sci_HashSet__init_($current);
                }
            }
            return $this;
        }
        $that = $that;
        $iter = $that.$entryIterator();
        $current = $this.$rootNode0;
        while ($iter.$hasNext()) {
            $next = $iter.$next();
            $originalHash = $that.$unimproveHash(scm_LinkedHashSet$Entry_hash($next));
            $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
            $current = sci_BitmapIndexedSetNode_updated($current, scm_LinkedHashSet$Entry_key($next), $originalHash, $improved, 0);
            if ($current !== $this.$rootNode0) {
                $shallowlyMutableNodeMap = 1 << ($improved >>> 0 & 31);
                while ($iter.$hasNext()) {
                    $next = $iter.$next();
                    $originalHash = $that.$unimproveHash(scm_LinkedHashSet$Entry_hash($next));
                    $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
                    $shallowlyMutableNodeMap = sci_BitmapIndexedSetNode_updateWithShallowMutations($current, scm_LinkedHashSet$Entry_key($next), $originalHash, $improved, 0, $shallowlyMutableNodeMap);
                }
                return sci_HashSet__init_($current);
            }
        }
        return $this;
    }
    function sci_HashSet_head($this) {
        return (sci_HashSet_iterator($this)).$next();
    }
    function sci_HashSet_foreach($this, $f) {
        var $foreach_this, $foreach_thisPayloadArity, $foreach_i, $foreach_thisNodeArity, $foreach_j;
        $foreach_this = $this.$rootNode0;
        if ($foreach_this === null)
            $rt_throw(null);
        $foreach_thisPayloadArity = sci_BitmapIndexedSetNode_payloadArity($foreach_this);
        $foreach_i = 0;
        while ($foreach_i < $foreach_thisPayloadArity) {
            $f.$apply($foreach_this.$content1.data[$foreach_i]);
            $foreach_i = $foreach_i + 1 | 0;
        }
        $foreach_thisNodeArity = sci_BitmapIndexedSetNode_nodeArity($foreach_this);
        $foreach_j = 0;
        while ($foreach_j < $foreach_thisNodeArity) {
            (sci_BitmapIndexedSetNode_getNode($foreach_this, $foreach_j)).$foreach($f);
            $foreach_j = $foreach_j + 1 | 0;
        }
    }
    function sci_HashSet_equals($this, $that) {
        var var$2;
        if (!($that instanceof sci_HashSet))
            return sc_Set_equals$($this, $that);
        a: {
            b: {
                $that = $that;
                if ($this !== $that) {
                    var$2 = $this.$rootNode0;
                    $that = $that.$rootNode0;
                    if (var$2 !== null) {
                        if (!sci_BitmapIndexedSetNode_equals(var$2, $that))
                            break a;
                        else
                            break b;
                    }
                    if ($that !== null)
                        break a;
                }
            }
            return 1;
        }
        return 0;
    }
    function sci_HashSet_className($this) {
        return $rt_s(465);
    }
    function sci_HashSet_hashCode($this) {
        var $it, var$2;
        $it = new sci_SetHashIterator;
        sci_ChampBaseIterator__init_($it, $this.$rootNode0);
        $it.$hash2 = 0;
        suh_MurmurHash3$_$callClinit();
        var$2 = suh_MurmurHash3$_MODULE$;
        return suh_MurmurHash3_unorderedHash(var$2, $it, suh_MurmurHash3$_setSeed(var$2));
    }
    function sci_HashSet_diff($this, $that) {
        var $thatKnownSize, $filterNot_pred, $filterImpl_newRootNode, $iter, $curr, $next, $unimproveHash_improvedHash, $originalHash, $improved;
        if (sci_HashSet_isEmpty($this))
            return $this;
        if ($that instanceof sci_HashSet) {
            $that = $that;
            if (sci_HashSet_isEmpty($that))
                return $this;
            if (!(sci_BitmapIndexedSetNode_diff($this.$rootNode0, $that.$rootNode0, 0)).$size4) {
                sci_HashSet$_$callClinit();
                return sci_HashSet$_empty(sci_HashSet$_MODULE$);
            }
            return sci_HashSet_newHashSetOrThis($this, sci_BitmapIndexedSetNode_diff($this.$rootNode0, $that.$rootNode0, 0));
        }
        if (!($that instanceof scm_HashSet)) {
            $thatKnownSize = $that.$knownSize();
            if (!$thatKnownSize)
                return $this;
            if ($thatKnownSize <= sci_HashSet_size($this))
                return sci_HashSet_removedAllWithShallowMutations($this, $that);
            $filterNot_pred = new sci_HashSet$diff$lambda$_60_0;
            $filterNot_pred.$_0171 = $that;
            $filterImpl_newRootNode = sci_BitmapIndexedSetNode_filterImpl($this.$rootNode0, $filterNot_pred, 1);
            if ($filterImpl_newRootNode === $this.$rootNode0)
                return $this;
            if ($filterImpl_newRootNode.$size4)
                return sci_HashSet__init_($filterImpl_newRootNode);
            sci_HashSet$_$callClinit();
            return sci_HashSet$_empty(sci_HashSet$_MODULE$);
        }
        $that = $that;
        if ($that === null)
            $rt_throw(null);
        $iter = new scm_HashSet$$anon$2;
        scm_HashSet$HashSetIterator__init_($iter, $that);
        $curr = $this.$rootNode0;
        while (scm_HashSet$HashSetIterator_hasNext($iter)) {
            $next = scm_HashSet$HashSetIterator_next($iter);
            $unimproveHash_improvedHash = $next.$_hash0;
            $originalHash = $unimproveHash_improvedHash ^ $unimproveHash_improvedHash >>> 16;
            $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
            $curr = sci_BitmapIndexedSetNode_removed($curr, $next.$_key0, $originalHash, $improved, 0);
            if ($curr !== $this.$rootNode0) {
                if (!$curr.$size4) {
                    sci_HashSet$_$callClinit();
                    return sci_HashSet$_empty(sci_HashSet$_MODULE$);
                }
                while (scm_HashSet$HashSetIterator_hasNext($iter)) {
                    $next = scm_HashSet$HashSetIterator_next($iter);
                    $unimproveHash_improvedHash = $next.$_hash0;
                    $originalHash = $unimproveHash_improvedHash ^ $unimproveHash_improvedHash >>> 16;
                    $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
                    sci_BitmapIndexedSetNode_removeWithShallowMutations($curr, $next.$_key0, $originalHash, $improved);
                    if ($curr.$size4)
                        continue;
                    else {
                        sci_HashSet$_$callClinit();
                        return sci_HashSet$_empty(sci_HashSet$_MODULE$);
                    }
                }
                return sci_HashSet__init_($curr);
            }
        }
        return $this;
    }
    function sci_HashSet_removedAllWithShallowMutations($this, $that) {
        var $iter, $curr, $next, $originalHash, $originalHash_0;
        $iter = $that.$iterator0();
        $curr = $this.$rootNode0;
        while ($iter.$hasNext()) {
            $next = $iter.$next();
            $originalHash = sr_Statics_anyHash($next);
            $curr = sci_BitmapIndexedSetNode_removed($curr, $next, $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0);
            if ($curr !== $this.$rootNode0) {
                if (!$curr.$size4) {
                    sci_HashSet$_$callClinit();
                    return sci_HashSet$_empty(sci_HashSet$_MODULE$);
                }
                while ($iter.$hasNext()) {
                    $next = $iter.$next();
                    $originalHash_0 = sr_Statics_anyHash($next);
                    sci_BitmapIndexedSetNode_removeWithShallowMutations($curr, $next, $originalHash_0, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash_0));
                    if ($curr.$size4)
                        continue;
                    else {
                        sci_HashSet$_$callClinit();
                        return sci_HashSet$_empty(sci_HashSet$_MODULE$);
                    }
                }
                return sci_HashSet__init_($curr);
            }
        }
        return $this;
    }
    function sci_HashSet_partition($this, $p) {
        return sc_StrictOptimizedIterableOps_partition$($this, $p);
    }
    function sci_HashSet_drop($this, $n) {
        return sc_IterableOps_drop$($this, $n);
    }
    function sci_HashSet_intersect($this, $that) {
        return sc_SetOps_intersect$($this, $that);
    }
    function sci_HashSet_filterImpl($this, $pred, $isFlipped) {
        $pred = sci_BitmapIndexedSetNode_filterImpl($this.$rootNode0, $pred, $isFlipped);
        if ($pred !== $this.$rootNode0) {
            if ($pred.$size4)
                $this = sci_HashSet__init_($pred);
            else {
                sci_HashSet$_$callClinit();
                $this = sci_HashSet$_empty(sci_HashSet$_MODULE$);
            }
        }
        return $this;
    }
    function sci_HashSet_removedAll($this, $that) {
        var var$2;
        a: {
            if ($rt_isInstance($that, sc_Set))
                $this = sci_HashSet_diff($this, $that);
            else {
                if ($that instanceof sci_Range) {
                    var$2 = $that;
                    if (sci_Range_length(var$2) > sci_HashSet_size($this)) {
                        $that = new sci_HashSet$removedAll$lambda$_62_0;
                        $that.$_0172 = var$2;
                        $that = sci_BitmapIndexedSetNode_filterImpl($this.$rootNode0, $that, 0);
                        if ($that === $this.$rootNode0)
                            break a;
                        if ($that.$size4) {
                            $this = sci_HashSet__init_($that);
                            break a;
                        }
                        sci_HashSet$_$callClinit();
                        $this = sci_HashSet$_empty(sci_HashSet$_MODULE$);
                        break a;
                    }
                }
                $this = sci_HashSet_removedAllWithShallowMutations($this, $that);
            }
        }
        return $this;
    }
    function sci_HashSet_tail($this) {
        return sci_HashSet_excl($this, sci_HashSet_head($this));
    }
    function sci_HashSet_concat0($this, $that) {
        return sci_HashSet_concat($this, $that);
    }
    function sci_HashSet_excl0($this, $elem) {
        return sci_HashSet_excl($this, $elem);
    }
    function sci_HashSet_incl0($this, $elem) {
        return sci_HashSet_incl($this, $elem);
    }
    function sci_HashSet__init_0($this, $rootNode) {
        $this.$rootNode0 = $rootNode;
    }
    function sci_ChampBaseIterator() {
        var a = this; jl_Object.call(a);
        a.$currentValueCursor = 0;
        a.$currentValueLength = 0;
        a.$currentValueNode = null;
        a.$currentStackLevel = 0;
        a.$nodeCursorsAndLengths = null;
        a.$nodes = null;
    }
    function sci_ChampBaseIterator_currentValueCursor($this) {
        return $this.$currentValueCursor;
    }
    function sci_ChampBaseIterator_currentValueCursor_$eq($this, $x$1) {
        $this.$currentValueCursor = $x$1;
    }
    function sci_ChampBaseIterator_currentValueLength($this) {
        return $this.$currentValueLength;
    }
    function sci_ChampBaseIterator_currentValueLength_$eq($this, $x$1) {
        $this.$currentValueLength = $x$1;
    }
    function sci_ChampBaseIterator_currentValueNode_$eq($this, $x$1) {
        $this.$currentValueNode = $x$1;
    }
    function sci_ChampBaseIterator_setupPayloadNode($this, $node) {
        $this.$currentValueNode = $node;
        $this.$currentValueCursor = 0;
        $this.$currentValueLength = $node.$payloadArity();
    }
    function sci_ChampBaseIterator_pushNode($this, $node) {
        var $cursorIndex, var$3, $lengthIndex, var$5;
        if ($this.$nodeCursorsAndLengths === null) {
            $cursorIndex = sci_Node$_MaxDepth;
            $this.$nodeCursorsAndLengths = $rt_createIntArray($cursorIndex * 2 | 0);
            $this.$nodes = $rt_createArray(sci_Node, $cursorIndex);
        }
        var$3 = $this.$currentStackLevel + 1 | 0;
        $this.$currentStackLevel = var$3;
        $cursorIndex = var$3 * 2 | 0;
        $lengthIndex = $cursorIndex + 1 | 0;
        $this.$nodes.data[var$3] = $node;
        var$5 = $this.$nodeCursorsAndLengths.data;
        var$5[$cursorIndex] = 0;
        var$5[$lengthIndex] = $node.$nodeArity();
    }
    function sci_ChampBaseIterator_hasNext($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        if ($this.$currentValueCursor >= $this.$currentValueLength) {
            a: {
                while (true) {
                    var$1 = $this.$currentStackLevel;
                    if (var$1 < 0)
                        break;
                    var$2 = var$1 * 2 | 0;
                    var$3 = var$2 + 1 | 0;
                    var$4 = $this.$nodeCursorsAndLengths.data;
                    var$5 = var$4[var$2];
                    if (var$5 >= var$4[var$3]) {
                        $this.$currentStackLevel = var$1 - 1 | 0;
                        continue;
                    }
                    var$4[var$2] = var$4[var$2] + 1 | 0;
                    var$6 = $this.$nodes.data[var$1].$getNode1(var$5);
                    if (var$6.$hasNodes())
                        sci_ChampBaseIterator_pushNode($this, var$6);
                    if (!var$6.$hasPayload())
                        continue;
                    else {
                        sci_ChampBaseIterator_setupPayloadNode($this, var$6);
                        var$2 = 1;
                        break a;
                    }
                }
                var$2 = 0;
            }
            if (!var$2)
                return 0;
        }
        return 1;
    }
    function sci_ChampBaseIterator__init_($this, $rootNode) {
        $this.$currentValueCursor = 0;
        $this.$currentValueLength = 0;
        $this.$currentStackLevel = (-1);
        if ($rootNode.$hasNodes())
            sci_ChampBaseIterator_pushNode($this, $rootNode);
        if ($rootNode.$hasPayload())
            sci_ChampBaseIterator_setupPayloadNode($this, $rootNode);
    }
    var sci_HashSetBuilder$$anon$1 = $rt_classWithoutFields(sci_ChampBaseIterator);
    var sc_Hashing$ = $rt_classWithoutFields();
    var sc_Hashing$_MODULE$ = null;
    function sc_Hashing$__clinit_() {
        sc_Hashing$_MODULE$ = new sc_Hashing$;
    }
    function sc_Hashing$_improve($this, $hcode) {
        var $h;
        $h = $hcode + ($hcode << 9 ^ (-1)) | 0;
        $hcode = $h ^ $h >>> 14;
        $hcode = $hcode + ($hcode << 4) | 0;
        return $hcode ^ $hcode >>> 10;
    }
    var sci_HashSet$ = $rt_classWithoutFields();
    var sci_HashSet$_MODULE$ = null;
    var sci_HashSet$_EmptySet = null;
    function sci_HashSet$_$callClinit() {
        sci_HashSet$_$callClinit = $rt_eraseClinit(sci_HashSet$);
        sci_HashSet$__clinit_();
    }
    function sci_HashSet$__clinit_() {
        var var$1, var$2;
        var$1 = new sci_HashSet$;
        sci_HashSet$_$callClinit();
        sci_HashSet$_MODULE$ = var$1;
        var$2 = new sci_HashSet;
        sci_SetNode$_$callClinit();
        sci_HashSet__init_0(var$2, sci_SetNode$_empty(sci_SetNode$_MODULE$));
        sci_HashSet$_EmptySet = var$2;
    }
    function sci_HashSet$_empty($this) {
        sci_HashSet$_$callClinit();
        return sci_HashSet$_EmptySet;
    }
    function sci_HashSet$_newBuilder($this) {
        return sci_HashSetBuilder__init_();
    }
    function sci_HashSet$_from($this, $source) {
        return $source instanceof sci_HashSet ? $source : !$source.$knownSize() ? sci_HashSet$_empty($this) : sci_HashSetBuilder_result(sci_HashSetBuilder_addAll(sci_HashSetBuilder__init_(), $source));
    }
    function scm_HashSet$addAll$lambda$_52_0() {
        jl_Object.call(this);
        this.$_0167 = null;
    }
    function scm_HashSet$addAll$lambda$_52_0_apply(var$0, var$1, var$2) {
        scm_HashSet_$anonfun$addAll$1(var$0.$_0167, var$1, sr_BoxesRunTime_unboxToInt(var$2));
        return sr_BoxedUnit_UNIT;
    }
    var scm_LinkedHashSet = $rt_classWithoutFields(scm_AbstractSet);
    function scm_HashSet$HashSetIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$i = 0;
        a.$node0 = null;
        a.$len1 = 0;
        a.$$outer20 = null;
    }
    function scm_HashSet$HashSetIterator_hasNext($this) {
        var var$1, $n;
        if ($this.$node0 !== null)
            return 1;
        while (true) {
            var$1 = $this.$i;
            if (var$1 >= $this.$len1)
                break;
            $n = $this.$$outer20.$scala$collection$mutable$HashSet$$table.data[var$1];
            $this.$i = var$1 + 1 | 0;
            if ($n === null)
                continue;
            else {
                $this.$node0 = $n;
                return 1;
            }
        }
        return 0;
    }
    function scm_HashSet$HashSetIterator_next($this) {
        var $r;
        if (!scm_HashSet$HashSetIterator_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $r = $this.$extract($this.$node0);
        $this.$node0 = $this.$node0.$_next0;
        return $r;
    }
    function scm_HashSet$HashSetIterator_scala$collection$mutable$HashSet$HashSetIterator$$$outer($this) {
        return $this.$$outer20;
    }
    function scm_HashSet$HashSetIterator__init_($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer20 = $$outer;
        $this.$i = 0;
        $this.$node0 = null;
        $this.$len1 = $$outer.$scala$collection$mutable$HashSet$$table.data.length;
    }
    var scm_HashSet$$anon$2 = $rt_classWithoutFields(scm_HashSet$HashSetIterator);
    function scm_HashSet$$anon$2_extract($this, $nd) {
        return $nd;
    }
    var scm_LinkedHashSet$Entry = $rt_classWithoutFields();
    function sc_Iterator$ConcatIteratorCell() {
        var a = this; jl_Object.call(a);
        a.$head1 = null;
        a.$tail3 = null;
    }
    function scm_StringBuilder() {
        scm_AbstractSeq.call(this);
        this.$underlying = null;
    }
    function scm_StringBuilder__init_0(var_0) {
        var var_1 = new scm_StringBuilder();
        scm_StringBuilder__init_1(var_1, var_0);
        return var_1;
    }
    function scm_StringBuilder__init_() {
        var var_0 = new scm_StringBuilder();
        scm_StringBuilder__init_2(var_0);
        return var_0;
    }
    function scm_StringBuilder_$plus$plus$eq($this, $s) {
        jl_AbstractStringBuilder_append1($this.$underlying, $s);
        return $this;
    }
    function scm_StringBuilder_result($this) {
        return jl_AbstractStringBuilder_toString($this.$underlying);
    }
    function scm_StringBuilder_append($this, $s) {
        jl_AbstractStringBuilder_append1($this.$underlying, $s);
        return $this;
    }
    function scm_StringBuilder__init_1($this, $underlying) {
        $this.$underlying = $underlying;
    }
    function scm_StringBuilder__init_2($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        scm_StringBuilder__init_1($this, var$1);
    }
    function sc_StrictOptimizedLinearSeqOps$$anon$1() {
        sc_AbstractIterator.call(this);
        this.$current = null;
    }
    function sc_StrictOptimizedLinearSeqOps$$anon$1_hasNext($this) {
        if (sci_List_isEmpty($this.$current))
            return 0;
        return 1;
    }
    function sc_StrictOptimizedLinearSeqOps$$anon$1_next($this) {
        var $r;
        $r = $this.$current.$head();
        $this.$current = $this.$current.$tail();
        return $r;
    }
    var sci_SetNode$ = $rt_classWithoutFields();
    var sci_SetNode$_MODULE$ = null;
    var sci_SetNode$_EmptySetNode = null;
    function sci_SetNode$_$callClinit() {
        sci_SetNode$_$callClinit = $rt_eraseClinit(sci_SetNode$);
        sci_SetNode$__clinit_();
    }
    function sci_SetNode$__clinit_() {
        var var$1, var$2;
        var$1 = new sci_SetNode$;
        sci_SetNode$_$callClinit();
        sci_SetNode$_MODULE$ = var$1;
        var$2 = new sci_BitmapIndexedSetNode;
        sr_ClassTag$_$callClinit();
        sr_ClassTag$_Any(sr_ClassTag$_MODULE$);
        sci_BitmapIndexedSetNode__init_0(var$2, 0, 0, $rt_createArray(jl_Object, 0), $rt_createIntArray(0), 0, 0);
        sci_SetNode$_EmptySetNode = var$2;
    }
    function sci_SetNode$_empty($this) {
        sci_SetNode$_$callClinit();
        return sci_SetNode$_EmptySetNode;
    }
    function sc_IterableOps$concat$lambda$_94_0() {
        jl_Object.call(this);
        this.$_03 = null;
    }
    function sc_IterableOps$concat$lambda$_94_0_apply(var$0) {
        return var$0.$_03.$iterator0();
    }
    function jnc_CharsetEncoder() {
        var a = this; jl_Object.call(a);
        a.$charset1 = null;
        a.$replacement1 = null;
        a.$averageBytesPerChar = 0.0;
        a.$maxBytesPerChar = 0.0;
        a.$malformedAction0 = null;
        a.$unmappableAction0 = null;
        a.$status1 = 0;
    }
    function jnc_CharsetEncoder_onMalformedInput($this, $newAction) {
        var var$2;
        if ($newAction !== null) {
            $this.$malformedAction0 = $newAction;
            return $this;
        }
        var$2 = new jl_IllegalArgumentException;
        jl_Throwable__init_(var$2, $rt_s(474));
        $rt_throw(var$2);
    }
    function jnc_CharsetEncoder_onUnmappableCharacter($this, $newAction) {
        var var$2;
        if ($newAction !== null) {
            $this.$unmappableAction0 = $newAction;
            return $this;
        }
        var$2 = new jl_IllegalArgumentException;
        jl_Throwable__init_(var$2, $rt_s(474));
        $rt_throw(var$2);
    }
    function jnc_CharsetEncoder_encode($this, $in, $out, $endOfInput) {
        var var$4, $result, $e, $remaining, $action, var$9, $$je;
        a: {
            var$4 = $this.$status1;
            if (var$4 != 3) {
                if ($endOfInput)
                    break a;
                if (var$4 != 2)
                    break a;
            }
            $in = new jl_IllegalStateException;
            jl_Throwable__init_0($in);
            $rt_throw($in);
        }
        $this.$status1 = !$endOfInput ? 1 : 2;
        while (true) {
            try {
                $result = jnci_BufferedEncoder_encodeLoop($this, $in, $out);
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_RuntimeException) {
                    $e = $$je;
                    $in = new jnc_CoderMalfunctionError;
                    $in.$suppressionEnabled = 1;
                    $in.$writableStackTrace = 1;
                    $in.$cause = $e;
                    $rt_throw($in);
                } else {
                    throw $$e;
                }
            }
            if (jnc_CoderResult_isUnderflow($result)) {
                if (!$endOfInput)
                    return $result;
                $remaining = jn_Buffer_remaining($in);
                if ($remaining <= 0)
                    return $result;
                $result = jnc_CoderResult_malformedForLength($remaining);
            } else if (jnc_CoderResult_isOverflow($result))
                break;
            $action = !jnc_CoderResult_isUnmappable($result) ? $this.$malformedAction0 : $this.$unmappableAction0;
            b: {
                if ($action !== jnc_CodingErrorAction_REPLACE) {
                    if ($action === jnc_CodingErrorAction_IGNORE)
                        break b;
                    else
                        return $result;
                }
                $remaining = jn_Buffer_remaining($out);
                var$9 = $this.$replacement1;
                var$4 = var$9.data.length;
                if ($remaining < var$4)
                    return jnc_CoderResult_OVERFLOW;
                jn_ByteBuffer_put($out, var$9, 0, var$4);
            }
            var$4 = $in.$position9;
            if (!jnc_CoderResult_isError($result)) {
                $in = new jl_UnsupportedOperationException;
                jl_Throwable__init_0($in);
                $rt_throw($in);
            }
            jn_Buffer_position($in, var$4 + $result.$length3 | 0);
        }
        return $result;
    }
    function jnc_CharsetEncoder_encode0($this, $in) {
        var $output, $result;
        if (!jn_Buffer_remaining($in))
            return jn_ByteBuffer_allocate(0);
        $this.$status1 = 0;
        $output = jn_ByteBuffer_allocate(jn_Buffer_remaining($in) * $this.$averageBytesPerChar | 0);
        while (true) {
            $result = jnc_CharsetEncoder_encode($this, $in, $output, 0);
            if ($result === jnc_CoderResult_UNDERFLOW)
                break;
            if ($result === jnc_CoderResult_OVERFLOW) {
                $output = jnc_CharsetEncoder_allocateMore($this, $output);
                continue;
            }
            if (!jnc_CoderResult_isError($result))
                continue;
            jnc_CoderResult_throwException($result);
        }
        $in = jnc_CharsetEncoder_encode($this, $in, $output, 1);
        if (jnc_CoderResult_isError($in))
            jnc_CoderResult_throwException($in);
        while (true) {
            $in = jnc_CharsetEncoder_flush($this, $output);
            if (jnc_CoderResult_isUnderflow($in))
                break;
            if (!jnc_CoderResult_isOverflow($in))
                continue;
            $output = jnc_CharsetEncoder_allocateMore($this, $output);
        }
        $output.$limit2 = $output.$position9;
        $output.$position9 = 0;
        $output.$mark0 = (-1);
        return $output;
    }
    function jnc_CharsetEncoder_allocateMore($this, $buffer) {
        var $array, $result;
        $array = $buffer.$array1;
        $result = jn_ByteBuffer_wrap(ju_Arrays_copyOf1($array, $array.data.length * 2 | 0));
        jn_Buffer_position($result, $buffer.$position9);
        return $result;
    }
    function jnc_CharsetEncoder_flush($this, $out) {
        var var$2, $result;
        var$2 = $this.$status1;
        if (var$2 != 2 && var$2 != 4) {
            $out = new jl_IllegalStateException;
            jl_Throwable__init_0($out);
            $rt_throw($out);
        }
        $result = jnc_CoderResult_UNDERFLOW;
        if ($result === $result)
            $this.$status1 = 3;
        return $result;
    }
    function jnc_CoderResult() {
        var a = this; jl_Object.call(a);
        a.$kind = 0;
        a.$length3 = 0;
    }
    var jnc_CoderResult_UNDERFLOW = null;
    var jnc_CoderResult_OVERFLOW = null;
    function jnc_CoderResult__init_(var_0, var_1) {
        var var_2 = new jnc_CoderResult();
        jnc_CoderResult__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function jnc_CoderResult__init_0($this, $kind, $length) {
        $this.$kind = $kind;
        $this.$length3 = $length;
    }
    function jnc_CoderResult_isUnderflow($this) {
        return $this.$kind ? 0 : 1;
    }
    function jnc_CoderResult_isOverflow($this) {
        return $this.$kind != 1 ? 0 : 1;
    }
    function jnc_CoderResult_isError($this) {
        var var$1;
        var$1 = $this.$kind != 2 ? 0 : 1;
        return !var$1 && !jnc_CoderResult_isUnmappable($this) ? 0 : 1;
    }
    function jnc_CoderResult_isUnmappable($this) {
        return $this.$kind != 3 ? 0 : 1;
    }
    function jnc_CoderResult_malformedForLength($length) {
        return jnc_CoderResult__init_(2, $length);
    }
    function jnc_CoderResult_throwException($this) {
        var var$1, var$2;
        switch ($this.$kind) {
            case 0:
                var$1 = new jnc_BufferUnderflowException;
                jl_Throwable__init_0(var$1);
                $rt_throw(var$1);
            case 1:
                var$1 = new jnc_BufferOverflowException;
                jl_Throwable__init_0(var$1);
                $rt_throw(var$1);
            case 2:
                var$1 = new jnc_MalformedInputException;
                var$2 = $this.$length3;
                jl_Throwable__init_0(var$1);
                var$1.$length4 = var$2;
                $rt_throw(var$1);
            case 3:
                var$1 = new jnc_UnmappableCharacterException;
                var$2 = $this.$length3;
                jl_Throwable__init_0(var$1);
                var$1.$length5 = var$2;
                $rt_throw(var$1);
            default:
        }
    }
    function jnc_CoderResult__clinit_() {
        jnc_CoderResult_UNDERFLOW = jnc_CoderResult__init_(0, 0);
        jnc_CoderResult_OVERFLOW = jnc_CoderResult__init_(1, 0);
    }
    var sc_SeqView = $rt_classWithoutFields(0);
    function sc_SeqView_map$($$this, $f) {
        var var$3;
        var$3 = new sc_SeqView$Map;
        var$3.$underlying10 = $$this;
        var$3.$f4 = $f;
        sc_View$Map__init_0(var$3, $$this, $f);
        return var$3;
    }
    function sc_SeqView_appended$($$this, $elem) {
        var var$3;
        var$3 = new sc_SeqView$Appended;
        var$3.$underlying11 = $$this;
        var$3.$elem0 = $elem;
        sc_View$Appended__init_0(var$3, $$this, $elem);
        return var$3;
    }
    var sc_IndexedSeqView = $rt_classWithoutFields(0);
    function sc_IndexedSeqView_iterator$($$this) {
        return sc_IndexedSeqView$IndexedSeqViewIterator__init_($$this);
    }
    var sci_Node$ = $rt_classWithoutFields();
    var sci_Node$_MODULE$ = null;
    var sci_Node$_MaxDepth = 0;
    function sci_Node$__clinit_() {
        sci_Node$_MODULE$ = new sci_Node$;
        sci_Node$_MaxDepth = jl_Math_ceil(6.4) | 0;
    }
    function sci_Node$_maskFrom($this, $hash, $shift) {
        return $hash >>> $shift & 31;
    }
    function sci_Node$_bitposFrom($this, $mask) {
        return 1 << $mask;
    }
    function sci_Node$_indexFrom($this, $bitmap, $mask, $bitpos) {
        if ($bitmap == (-1))
            return $mask;
        return jl_Integer_bitCount($bitmap & ($bitpos - 1 | 0));
    }
    var sm_ScalaNumber = $rt_classWithoutFields(jl_Number);
    var scm_HashSet$$anon$1 = $rt_classWithoutFields(scm_HashSet$HashSetIterator);
    function scm_HashSet$$anon$1_extract($this, $nd) {
        return $nd.$_key0;
    }
    function sc_View$Concat$iterator$lambda$_0_0() {
        jl_Object.call(this);
        this.$_0169 = null;
    }
    function sc_View$Concat$iterator$lambda$_0_0_apply(var$0) {
        return var$0.$_0169.$suffix.$iterator0();
    }
    function sc_Iterator$$anon$20() {
        var a = this; sc_AbstractIterator.call(a);
        a.$consumed = 0;
        a.$a$1 = null;
    }
    function sc_Iterator$$anon$20__init_(var_0) {
        var var_1 = new sc_Iterator$$anon$20();
        sc_Iterator$$anon$20__init_0(var_1, var_0);
        return var_1;
    }
    function sc_Iterator$$anon$20_hasNext($this) {
        if ($this.$consumed)
            return 0;
        return 1;
    }
    function sc_Iterator$$anon$20_next($this) {
        if ($this.$consumed)
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $this.$consumed = 1;
        return $this.$a$1;
    }
    function sc_Iterator$$anon$20_sliceIterator($this, $from, $until) {
        if (!$this.$consumed && $from <= 0 && $until)
            return $this;
        return sc_Iterator$_scala$collection$Iterator$$_empty;
    }
    function sc_Iterator$$anon$20__init_0($this, $a$1) {
        $this.$a$1 = $a$1;
        $this.$consumed = 0;
    }
    var sci_SetIterator = $rt_classWithoutFields(sci_ChampBaseIterator);
    function sci_SetIterator_iterator($this) {
        return $this;
    }
    function sci_SetIterator_isEmpty($this) {
        return sc_Iterator_isEmpty$($this);
    }
    function sci_SetIterator_filterImpl($this, $p, $isFlipped) {
        return sc_Iterator_filterImpl$($this, $p, $isFlipped);
    }
    function sci_SetIterator_collect($this, $pf) {
        return sc_Iterator_collect$($this, $pf);
    }
    function sci_SetIterator_map($this, $f) {
        return sc_Iterator_map$($this, $f);
    }
    function sci_SetIterator_flatMap($this, $f) {
        return sc_Iterator_flatMap$($this, $f);
    }
    function sci_SetIterator_concat($this, $xs) {
        return sc_Iterator_concat$($this, $xs);
    }
    function sci_SetIterator_drop($this, $n) {
        return sc_Iterator_drop$($this, $n);
    }
    function sci_SetIterator_sliceIterator($this, $from, $until) {
        return sc_Iterator_sliceIterator$($this, $from, $until);
    }
    function sci_SetIterator_toString($this) {
        return $rt_s(466);
    }
    function sci_SetIterator_foreach($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    }
    function sci_SetIterator_exists($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    }
    function sci_SetIterator_find($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    }
    function sci_SetIterator_foldLeft($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    }
    function sci_SetIterator_nonEmpty($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    }
    function sci_SetIterator_size($this) {
        return sc_IterableOnceOps_size$($this);
    }
    function sci_SetIterator_copyToArray($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    }
    function sci_SetIterator_copyToArray0($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    }
    function sci_SetIterator_copyToArray1($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    }
    function sci_SetIterator_to($this, $factory) {
        return $factory.$fromSpecific($this);
    }
    function sci_SetIterator_toList($this) {
        return sc_IterableOnceOps_toList$($this);
    }
    function sci_SetIterator_toSeq($this) {
        return sc_IterableOnceOps_toSeq$($this);
    }
    function sci_SetIterator_toArray($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    }
    function sci_SetIterator_knownSize($this) {
        return (-1);
    }
    function sci_SetIterator_next($this) {
        var $payload;
        if (!sci_ChampBaseIterator_hasNext($this)) {
            $payload = new ju_NoSuchElementException;
            jl_Throwable__init_0($payload);
            $rt_throw($payload);
        }
        $payload = $this.$currentValueNode.$getPayload($this.$currentValueCursor);
        $this.$currentValueCursor = $this.$currentValueCursor + 1 | 0;
        return $payload;
    }
    function sci_HashCollisionSetNode() {
        var a = this; sci_SetNode.call(a);
        a.$originalHash = 0;
        a.$hash3 = 0;
        a.$content0 = null;
    }
    function sci_HashCollisionSetNode__init_0(var_0, var_1, var_2) {
        var var_3 = new sci_HashCollisionSetNode();
        sci_HashCollisionSetNode__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function sci_HashCollisionSetNode_originalHash($this) {
        return $this.$originalHash;
    }
    function sci_HashCollisionSetNode_hash($this) {
        return $this.$hash3;
    }
    function sci_HashCollisionSetNode_content($this) {
        return $this.$content0;
    }
    function sci_HashCollisionSetNode_contains($this, $element, $originalHash, $hash, $shift) {
        if ($this.$hash3 == $hash && sc_AbstractSeq_contains($this.$content0, $element))
            return 1;
        return 0;
    }
    function sci_HashCollisionSetNode_updated($this, $element, $originalHash, $hash, $shift) {
        if (sci_HashCollisionSetNode_contains($this, $element, $originalHash, $hash, $shift))
            return $this;
        return sci_HashCollisionSetNode__init_0($originalHash, $hash, $this.$content0.$appended1($element));
    }
    function sci_HashCollisionSetNode_removed($this, $element, $originalHash, $hash, $shift) {
        var var$5, $updatedContent, $bitposFrom_mask, var$8, var$9;
        if (!sci_HashCollisionSetNode_contains($this, $element, $originalHash, $hash, $shift))
            return $this;
        var$5 = $this.$content0;
        $updatedContent = new sci_HashCollisionSetNode$removed$lambda$_6_0;
        $updatedContent.$_0173 = $element;
        $updatedContent = sc_StrictOptimizedIterableOps_filterNot$(var$5, $updatedContent);
        if ($updatedContent === null)
            $rt_throw(null);
        switch (sci_Vector_length($updatedContent)) {
            case 1:
                $element = new sci_BitmapIndexedSetNode;
                $bitposFrom_mask = 1 << ($hash >>> 0 & 31);
                var$8 = $rt_createArray(jl_Object, 1);
                var$8.data[0] = $updatedContent.$apply1(0);
                var$9 = $rt_createIntArray(1);
                var$9.data[0] = $originalHash;
                sci_BitmapIndexedSetNode__init_0($element, $bitposFrom_mask, 0, var$8, var$9, 1, $hash);
                return $element;
            default:
        }
        return sci_HashCollisionSetNode__init_0($originalHash, $hash, $updatedContent);
    }
    function sci_HashCollisionSetNode_hasNodes($this) {
        return 0;
    }
    function sci_HashCollisionSetNode_nodeArity($this) {
        return 0;
    }
    function sci_HashCollisionSetNode_hasPayload($this) {
        return 1;
    }
    function sci_HashCollisionSetNode_payloadArity($this) {
        return sci_Vector_length($this.$content0);
    }
    function sci_HashCollisionSetNode_getPayload($this, $index) {
        return $this.$content0.$apply1($index);
    }
    function sci_HashCollisionSetNode_getHash($this, $index) {
        return $this.$originalHash;
    }
    function sci_HashCollisionSetNode_size($this) {
        return sci_Vector_length($this.$content0);
    }
    function sci_HashCollisionSetNode_foreach($this, $f) {
        var $iter;
        $iter = sci_Vector_iterator($this.$content0);
        while (sci_NewVectorIterator_hasNext($iter)) {
            $f.$apply(sci_NewVectorIterator_next($iter));
        }
    }
    function sci_HashCollisionSetNode_cachedJavaKeySetHashCode($this) {
        return $rt_imul(sci_HashCollisionSetNode_size($this), $this.$hash3);
    }
    function sci_HashCollisionSetNode_filterImpl($this, $pred, $flipped) {
        var $newContent, $filterImpl_i, $filterImpl_len, $filterImpl_bitmap, $filterImpl_k, $filterImpl_j, $filterImpl_newLen, $filterImpl_newData, $foreachRec_a, $filterImpl_b, $filterImpl_k_0, $filterImpl_foreachRest_this, $filterImpl_foreachRest_f, $filterImpl_foreachRest_c, $filterImpl_foreachRest_i, $filterImpl_foreachRest_foreachRec_this, $filterImpl_foreachRest_vectorSliceDim_c, $filterImpl_foreachRest_foreachRec_level, $filterImpl_foreachRest_foreachRec_a, $filterImpl_foreachRest_foreachRec_i, $filterImpl_foreachRest_foreachRec_len,
        $filterImpl_foreachRest_foreachRec_l, $foreachRec_l, $foreachRec_i, $foreachRec_len, $filterImpl_foreachRest_f_0, $newContentLength;
        $newContent = sci_HashCollisionSetNode_content($this);
        if ($newContent === null)
            $rt_throw(null);
        $filterImpl_i = 0;
        $filterImpl_len = (sci_Vector_prefix1($newContent)).data.length;
        a: {
            while ($filterImpl_i != $filterImpl_len) {
                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply((sci_Vector_prefix1($newContent)).data[$filterImpl_i])) == $flipped) {
                    $filterImpl_bitmap = 0;
                    $filterImpl_k = $filterImpl_i + 1 | 0;
                    $filterImpl_j = $filterImpl_k;
                    while ($filterImpl_j < $filterImpl_len) {
                        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply((sci_Vector_prefix1($newContent)).data[$filterImpl_j])) != $flipped)
                            $filterImpl_bitmap = $filterImpl_bitmap | 1 << $filterImpl_j;
                        $filterImpl_j = $filterImpl_j + 1 | 0;
                    }
                    $filterImpl_newLen = $filterImpl_i + jl_Integer_bitCount($filterImpl_bitmap) | 0;
                    if (!($newContent instanceof sci_BigVector)) {
                        if (!$filterImpl_newLen) {
                            sci_Vector0$_$callClinit();
                            $newContent = sci_Vector0$_MODULE$;
                            break a;
                        }
                        $filterImpl_newData = $rt_createArray(jl_Object, $filterImpl_newLen);
                        $foreachRec_a = $filterImpl_newData.data;
                        jl_System_arraycopy(sci_Vector_prefix1($newContent), 0, $filterImpl_newData, 0, $filterImpl_i);
                        while ($filterImpl_i != $filterImpl_newLen) {
                            if (1 << $filterImpl_k & $filterImpl_bitmap) {
                                $foreachRec_a[$filterImpl_i] = (sci_Vector_prefix1($newContent)).data[$filterImpl_k];
                                $filterImpl_i = $filterImpl_i + 1 | 0;
                            }
                            $filterImpl_k = $filterImpl_k + 1 | 0;
                        }
                        $newContent = sci_Vector1__init_($filterImpl_newData);
                        break a;
                    }
                    $filterImpl_b = sci_VectorBuilder__init_();
                    $filterImpl_k_0 = 0;
                    while ($filterImpl_k_0 < $filterImpl_i) {
                        sci_VectorBuilder_addOne($filterImpl_b, (sci_Vector_prefix1($newContent)).data[$filterImpl_k_0]);
                        $filterImpl_k_0 = $filterImpl_k_0 + 1 | 0;
                    }
                    while ($filterImpl_i != $filterImpl_newLen) {
                        if (1 << $filterImpl_k & $filterImpl_bitmap) {
                            sci_VectorBuilder_addOne($filterImpl_b, (sci_Vector_prefix1($newContent)).data[$filterImpl_k]);
                            $filterImpl_i = $filterImpl_i + 1 | 0;
                        }
                        $filterImpl_k = $filterImpl_k + 1 | 0;
                    }
                    $filterImpl_foreachRest_this = $newContent;
                    $filterImpl_foreachRest_f = sci_HashCollisionSetNode$filterImpl$lambda$_18_0__init_($pred, $flipped, $filterImpl_b);
                    $filterImpl_foreachRest_c = $filterImpl_foreachRest_this.$vectorSliceCount();
                    $filterImpl_foreachRest_i = 1;
                    while ($filterImpl_foreachRest_i < $filterImpl_foreachRest_c) {
                        b: {
                            $filterImpl_foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                            $filterImpl_foreachRest_vectorSliceDim_c = $filterImpl_foreachRest_c / 2 | 0;
                            $filterImpl_foreachRest_foreachRec_level = (($filterImpl_foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($filterImpl_foreachRest_i - $filterImpl_foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                            $filterImpl_foreachRest_foreachRec_a = ($filterImpl_foreachRest_this.$vectorSlice($filterImpl_foreachRest_i)).data;
                            $filterImpl_foreachRest_foreachRec_i = 0;
                            $filterImpl_foreachRest_foreachRec_len = $filterImpl_foreachRest_foreachRec_a.length;
                            if (!$filterImpl_foreachRest_foreachRec_level)
                                while (true) {
                                    if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                        break b;
                                    $filterImpl_foreachRest_foreachRec_this = $filterImpl_foreachRest_foreachRec_a[$filterImpl_foreachRest_foreachRec_i];
                                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_foreachRest_foreachRec_this)) != $flipped)
                                        sci_VectorBuilder_addOne($filterImpl_b, $filterImpl_foreachRest_foreachRec_this);
                                    $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                                }
                            $filterImpl_foreachRest_foreachRec_l = $filterImpl_foreachRest_foreachRec_level - 1 | 0;
                            $filterImpl_k = $rt_compare($filterImpl_foreachRest_foreachRec_l, 0);
                            $foreachRec_l = $filterImpl_foreachRest_foreachRec_l - 1 | 0;
                            while (true) {
                                if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                    break b;
                                c: {
                                    $foreachRec_a = $filterImpl_foreachRest_foreachRec_a[$filterImpl_foreachRest_foreachRec_i].data;
                                    $foreachRec_i = 0;
                                    $foreachRec_len = $foreachRec_a.length;
                                    if ($filterImpl_k)
                                        while (true) {
                                            if ($foreachRec_i >= $foreachRec_len)
                                                break c;
                                            sci_VectorStatics$_foreachRec($filterImpl_foreachRest_foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $filterImpl_foreachRest_f);
                                            $foreachRec_i = $foreachRec_i + 1 | 0;
                                        }
                                    while (true) {
                                        if ($foreachRec_i >= $foreachRec_len)
                                            break c;
                                        $newContent = $foreachRec_a[$foreachRec_i];
                                        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($newContent)) != $flipped)
                                            sci_VectorBuilder_addOne($filterImpl_b, $newContent);
                                        $foreachRec_i = $foreachRec_i + 1 | 0;
                                    }
                                }
                                $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                            }
                        }
                        $filterImpl_foreachRest_i = $filterImpl_foreachRest_i + 1 | 0;
                    }
                    $newContent = sci_VectorBuilder_result($filterImpl_b);
                    break a;
                }
                $filterImpl_i = $filterImpl_i + 1 | 0;
            }
            if ($newContent instanceof sci_BigVector) {
                $filterImpl_b = sci_VectorBuilder__init_();
                sci_VectorBuilder_initFrom($filterImpl_b, sci_Vector_prefix1($newContent));
                $filterImpl_foreachRest_this = $newContent;
                $filterImpl_foreachRest_f_0 = sci_HashCollisionSetNode$filterImpl$lambda$_18_1__init_($pred, $flipped, $filterImpl_b);
                $filterImpl_foreachRest_c = $filterImpl_foreachRest_this.$vectorSliceCount();
                $filterImpl_foreachRest_i = 1;
                while ($filterImpl_foreachRest_i < $filterImpl_foreachRest_c) {
                    d: {
                        $filterImpl_foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                        $filterImpl_foreachRest_vectorSliceDim_c = $filterImpl_foreachRest_c / 2 | 0;
                        $filterImpl_foreachRest_foreachRec_level = (($filterImpl_foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($filterImpl_foreachRest_i - $filterImpl_foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                        $filterImpl_foreachRest_foreachRec_a = ($filterImpl_foreachRest_this.$vectorSlice($filterImpl_foreachRest_i)).data;
                        $filterImpl_foreachRest_foreachRec_i = 0;
                        $filterImpl_foreachRest_foreachRec_len = $filterImpl_foreachRest_foreachRec_a.length;
                        if (!$filterImpl_foreachRest_foreachRec_level)
                            while (true) {
                                if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                    break d;
                                $filterImpl_foreachRest_f = $filterImpl_foreachRest_foreachRec_a[$filterImpl_foreachRest_foreachRec_i];
                                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_foreachRest_f)) != $flipped)
                                    sci_VectorBuilder_addOne($filterImpl_b, $filterImpl_foreachRest_f);
                                $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                            }
                        $filterImpl_foreachRest_foreachRec_l = $filterImpl_foreachRest_foreachRec_level - 1 | 0;
                        $filterImpl_k = $rt_compare($filterImpl_foreachRest_foreachRec_l, 0);
                        $foreachRec_l = $filterImpl_foreachRest_foreachRec_l - 1 | 0;
                        while (true) {
                            if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                break d;
                            e: {
                                $foreachRec_a = $filterImpl_foreachRest_foreachRec_a[$filterImpl_foreachRest_foreachRec_i].data;
                                $foreachRec_i = 0;
                                $foreachRec_len = $foreachRec_a.length;
                                if ($filterImpl_k)
                                    while (true) {
                                        if ($foreachRec_i >= $foreachRec_len)
                                            break e;
                                        sci_VectorStatics$_foreachRec($filterImpl_foreachRest_foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $filterImpl_foreachRest_f_0);
                                        $foreachRec_i = $foreachRec_i + 1 | 0;
                                    }
                                while (true) {
                                    if ($foreachRec_i >= $foreachRec_len)
                                        break e;
                                    $filterImpl_foreachRest_f = $foreachRec_a[$foreachRec_i];
                                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_foreachRest_f)) != $flipped)
                                        sci_VectorBuilder_addOne($filterImpl_b, $filterImpl_foreachRest_f);
                                    $foreachRec_i = $foreachRec_i + 1 | 0;
                                }
                            }
                            $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                        }
                    }
                    $filterImpl_foreachRest_i = $filterImpl_foreachRest_i + 1 | 0;
                }
                $newContent = sci_VectorBuilder_result($filterImpl_b);
            }
        }
        $newContentLength = sci_Vector_length($newContent);
        if (!$newContentLength) {
            sci_SetNode$_$callClinit();
            return sci_SetNode$_empty(sci_SetNode$_MODULE$);
        }
        if ($newContentLength != 1) {
            if (sci_Vector_length($newContent) == sci_Vector_length(sci_HashCollisionSetNode_content($this)))
                return $this;
            return sci_HashCollisionSetNode__init_0(sci_HashCollisionSetNode_originalHash($this), sci_HashCollisionSetNode_hash($this), $newContent);
        }
        $pred = new sci_BitmapIndexedSetNode;
        $filterImpl_bitmap = 1 << (sci_HashCollisionSetNode_hash($this) >>> 0 & 31);
        $filterImpl_foreachRest_foreachRec_a = $rt_createArray(jl_Object, 1);
        $filterImpl_foreachRest_foreachRec_a.data[0] = sci_Vector_head($newContent);
        $foreachRec_a = $rt_createIntArray(1);
        $foreachRec_a.data[0] = sci_HashCollisionSetNode_originalHash($this);
        sci_BitmapIndexedSetNode__init_0($pred, $filterImpl_bitmap, 0, $filterImpl_foreachRest_foreachRec_a, $foreachRec_a, 1, sci_HashCollisionSetNode_hash($this));
        return $pred;
    }
    function sci_HashCollisionSetNode_diff($this, $that, $shift) {
        var $filterImpl_pred, $filterImpl_newContent, $filterImpl_filterImpl_i, $filterImpl_filterImpl_len, $filterImpl_filterImpl_bitmap, $filterImpl_filterImpl_k, $filterImpl_filterImpl_j, $filterImpl_filterImpl_newLen, $filterImpl_filterImpl_newData, $filterImpl_filterImpl_foreachRest_foreachRec_a, $filterImpl_filterImpl_b, $filterImpl_filterImpl_k_0, $filterImpl_filterImpl_foreachRest_this, $filterImpl_filterImpl_foreachRest_f, $filterImpl_filterImpl_foreachRest_c, $filterImpl_filterImpl_foreachRest_i, $filterImpl_filterImpl_foreachRest_foreachRec_this,
        $filterImpl_filterImpl_foreachRest_vectorSliceDim_c, $filterImpl_filterImpl_foreachRest_foreachRec_level, $foreachRec_a, $filterImpl_filterImpl_foreachRest_foreachRec_i, $filterImpl_filterImpl_foreachRest_foreachRec_len, $filterImpl_filterImpl_foreachRest_foreachRec_l, $foreachRec_l, $foreachRec_a_0, $foreachRec_i, $foreachRec_len, $filterImpl_newContentLength;
        $filterImpl_pred = sci_HashCollisionSetNode$diff$lambda$_19_0__init_($this, $that, $shift);
        $filterImpl_newContent = sci_HashCollisionSetNode_content($this);
        if ($filterImpl_newContent === null)
            $rt_throw(null);
        $filterImpl_filterImpl_i = 0;
        $filterImpl_filterImpl_len = (sci_Vector_prefix1($filterImpl_newContent)).data.length;
        a: {
            while ($filterImpl_filterImpl_i != $filterImpl_filterImpl_len) {
                if (sci_HashCollisionSetNode_$anonfun$diff$2($this, $that, $shift, (sci_Vector_prefix1($filterImpl_newContent)).data[$filterImpl_filterImpl_i]) == 1) {
                    $filterImpl_filterImpl_bitmap = 0;
                    $filterImpl_filterImpl_k = $filterImpl_filterImpl_i + 1 | 0;
                    $filterImpl_filterImpl_j = $filterImpl_filterImpl_k;
                    while ($filterImpl_filterImpl_j < $filterImpl_filterImpl_len) {
                        if (sci_HashCollisionSetNode_$anonfun$diff$2($this, $that, $shift, (sci_Vector_prefix1($filterImpl_newContent)).data[$filterImpl_filterImpl_j]) != 1)
                            $filterImpl_filterImpl_bitmap = $filterImpl_filterImpl_bitmap | 1 << $filterImpl_filterImpl_j;
                        $filterImpl_filterImpl_j = $filterImpl_filterImpl_j + 1 | 0;
                    }
                    $filterImpl_filterImpl_newLen = $filterImpl_filterImpl_i + jl_Integer_bitCount($filterImpl_filterImpl_bitmap) | 0;
                    if (!($filterImpl_newContent instanceof sci_BigVector)) {
                        if (!$filterImpl_filterImpl_newLen) {
                            sci_Vector0$_$callClinit();
                            $filterImpl_newContent = sci_Vector0$_MODULE$;
                            break a;
                        }
                        $filterImpl_filterImpl_newData = $rt_createArray(jl_Object, $filterImpl_filterImpl_newLen);
                        $filterImpl_filterImpl_foreachRest_foreachRec_a = $filterImpl_filterImpl_newData.data;
                        jl_System_arraycopy(sci_Vector_prefix1($filterImpl_newContent), 0, $filterImpl_filterImpl_newData, 0, $filterImpl_filterImpl_i);
                        while ($filterImpl_filterImpl_i != $filterImpl_filterImpl_newLen) {
                            if (1 << $filterImpl_filterImpl_k & $filterImpl_filterImpl_bitmap) {
                                $filterImpl_filterImpl_foreachRest_foreachRec_a[$filterImpl_filterImpl_i] = (sci_Vector_prefix1($filterImpl_newContent)).data[$filterImpl_filterImpl_k];
                                $filterImpl_filterImpl_i = $filterImpl_filterImpl_i + 1 | 0;
                            }
                            $filterImpl_filterImpl_k = $filterImpl_filterImpl_k + 1 | 0;
                        }
                        $filterImpl_newContent = sci_Vector1__init_($filterImpl_filterImpl_newData);
                        break a;
                    }
                    $filterImpl_filterImpl_b = sci_VectorBuilder__init_();
                    $filterImpl_filterImpl_k_0 = 0;
                    while ($filterImpl_filterImpl_k_0 < $filterImpl_filterImpl_i) {
                        sci_VectorBuilder_addOne($filterImpl_filterImpl_b, (sci_Vector_prefix1($filterImpl_newContent)).data[$filterImpl_filterImpl_k_0]);
                        $filterImpl_filterImpl_k_0 = $filterImpl_filterImpl_k_0 + 1 | 0;
                    }
                    while ($filterImpl_filterImpl_i != $filterImpl_filterImpl_newLen) {
                        if (1 << $filterImpl_filterImpl_k & $filterImpl_filterImpl_bitmap) {
                            sci_VectorBuilder_addOne($filterImpl_filterImpl_b, (sci_Vector_prefix1($filterImpl_newContent)).data[$filterImpl_filterImpl_k]);
                            $filterImpl_filterImpl_i = $filterImpl_filterImpl_i + 1 | 0;
                        }
                        $filterImpl_filterImpl_k = $filterImpl_filterImpl_k + 1 | 0;
                    }
                    $filterImpl_filterImpl_foreachRest_this = $filterImpl_newContent;
                    $filterImpl_filterImpl_foreachRest_f = sci_HashCollisionSetNode$diff$lambda$_19_1__init_($filterImpl_pred, 1, $filterImpl_filterImpl_b);
                    $filterImpl_filterImpl_foreachRest_c = $filterImpl_filterImpl_foreachRest_this.$vectorSliceCount();
                    $filterImpl_filterImpl_foreachRest_i = 1;
                    while ($filterImpl_filterImpl_foreachRest_i < $filterImpl_filterImpl_foreachRest_c) {
                        b: {
                            $filterImpl_filterImpl_foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                            $filterImpl_filterImpl_foreachRest_vectorSliceDim_c = $filterImpl_filterImpl_foreachRest_c / 2 | 0;
                            $filterImpl_filterImpl_foreachRest_foreachRec_level = (($filterImpl_filterImpl_foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($filterImpl_filterImpl_foreachRest_i - $filterImpl_filterImpl_foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                            $foreachRec_a = ($filterImpl_filterImpl_foreachRest_this.$vectorSlice($filterImpl_filterImpl_foreachRest_i)).data;
                            $filterImpl_filterImpl_foreachRest_foreachRec_i = 0;
                            $filterImpl_filterImpl_foreachRest_foreachRec_len = $foreachRec_a.length;
                            if (!$filterImpl_filterImpl_foreachRest_foreachRec_level)
                                while (true) {
                                    if ($filterImpl_filterImpl_foreachRest_foreachRec_i >= $filterImpl_filterImpl_foreachRest_foreachRec_len)
                                        break b;
                                    $filterImpl_pred = $foreachRec_a[$filterImpl_filterImpl_foreachRest_foreachRec_i];
                                    if (sci_HashCollisionSetNode_$anonfun$diff$2($this, $that, $shift, $filterImpl_pred) != 1)
                                        sci_VectorBuilder_addOne($filterImpl_filterImpl_b, $filterImpl_pred);
                                    $filterImpl_filterImpl_foreachRest_foreachRec_i = $filterImpl_filterImpl_foreachRest_foreachRec_i + 1 | 0;
                                }
                            $filterImpl_filterImpl_foreachRest_foreachRec_l = $filterImpl_filterImpl_foreachRest_foreachRec_level - 1 | 0;
                            $filterImpl_filterImpl_k = $rt_compare($filterImpl_filterImpl_foreachRest_foreachRec_l, 0);
                            $foreachRec_l = $filterImpl_filterImpl_foreachRest_foreachRec_l - 1 | 0;
                            while (true) {
                                if ($filterImpl_filterImpl_foreachRest_foreachRec_i >= $filterImpl_filterImpl_foreachRest_foreachRec_len)
                                    break b;
                                c: {
                                    $foreachRec_a_0 = $foreachRec_a[$filterImpl_filterImpl_foreachRest_foreachRec_i].data;
                                    $foreachRec_i = 0;
                                    $foreachRec_len = $foreachRec_a_0.length;
                                    if ($filterImpl_filterImpl_k)
                                        while (true) {
                                            if ($foreachRec_i >= $foreachRec_len)
                                                break c;
                                            sci_VectorStatics$_foreachRec($filterImpl_filterImpl_foreachRest_foreachRec_this, $foreachRec_l, $foreachRec_a_0[$foreachRec_i], $filterImpl_filterImpl_foreachRest_f);
                                            $foreachRec_i = $foreachRec_i + 1 | 0;
                                        }
                                    while (true) {
                                        if ($foreachRec_i >= $foreachRec_len)
                                            break c;
                                        $filterImpl_pred = $foreachRec_a_0[$foreachRec_i];
                                        if (sci_HashCollisionSetNode_$anonfun$diff$2($this, $that, $shift, $filterImpl_pred) != 1)
                                            sci_VectorBuilder_addOne($filterImpl_filterImpl_b, $filterImpl_pred);
                                        $foreachRec_i = $foreachRec_i + 1 | 0;
                                    }
                                }
                                $filterImpl_filterImpl_foreachRest_foreachRec_i = $filterImpl_filterImpl_foreachRest_foreachRec_i + 1 | 0;
                            }
                        }
                        $filterImpl_filterImpl_foreachRest_i = $filterImpl_filterImpl_foreachRest_i + 1 | 0;
                    }
                    $filterImpl_newContent = sci_VectorBuilder_result($filterImpl_filterImpl_b);
                    break a;
                }
                $filterImpl_filterImpl_i = $filterImpl_filterImpl_i + 1 | 0;
            }
            if ($filterImpl_newContent instanceof sci_BigVector) {
                $filterImpl_filterImpl_b = sci_VectorBuilder__init_();
                sci_VectorBuilder_initFrom($filterImpl_filterImpl_b, sci_Vector_prefix1($filterImpl_newContent));
                $filterImpl_filterImpl_foreachRest_this = $filterImpl_newContent;
                $filterImpl_filterImpl_foreachRest_f = sci_HashCollisionSetNode$diff$lambda$_19_2__init_($filterImpl_pred, 1, $filterImpl_filterImpl_b);
                $filterImpl_filterImpl_foreachRest_c = $filterImpl_filterImpl_foreachRest_this.$vectorSliceCount();
                $filterImpl_filterImpl_foreachRest_i = 1;
                while ($filterImpl_filterImpl_foreachRest_i < $filterImpl_filterImpl_foreachRest_c) {
                    d: {
                        $filterImpl_filterImpl_foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                        $filterImpl_filterImpl_foreachRest_vectorSliceDim_c = $filterImpl_filterImpl_foreachRest_c / 2 | 0;
                        $filterImpl_filterImpl_foreachRest_foreachRec_level = (($filterImpl_filterImpl_foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($filterImpl_filterImpl_foreachRest_i - $filterImpl_filterImpl_foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                        $foreachRec_a_0 = ($filterImpl_filterImpl_foreachRest_this.$vectorSlice($filterImpl_filterImpl_foreachRest_i)).data;
                        $filterImpl_filterImpl_foreachRest_foreachRec_i = 0;
                        $filterImpl_filterImpl_foreachRest_foreachRec_len = $foreachRec_a_0.length;
                        if (!$filterImpl_filterImpl_foreachRest_foreachRec_level)
                            while (true) {
                                if ($filterImpl_filterImpl_foreachRest_foreachRec_i >= $filterImpl_filterImpl_foreachRest_foreachRec_len)
                                    break d;
                                $filterImpl_pred = $foreachRec_a_0[$filterImpl_filterImpl_foreachRest_foreachRec_i];
                                if (sci_HashCollisionSetNode_$anonfun$diff$2($this, $that, $shift, $filterImpl_pred) != 1)
                                    sci_VectorBuilder_addOne($filterImpl_filterImpl_b, $filterImpl_pred);
                                $filterImpl_filterImpl_foreachRest_foreachRec_i = $filterImpl_filterImpl_foreachRest_foreachRec_i + 1 | 0;
                            }
                        $filterImpl_filterImpl_foreachRest_foreachRec_l = $filterImpl_filterImpl_foreachRest_foreachRec_level - 1 | 0;
                        $filterImpl_filterImpl_j = $rt_compare($filterImpl_filterImpl_foreachRest_foreachRec_l, 0);
                        $foreachRec_l = $filterImpl_filterImpl_foreachRest_foreachRec_l - 1 | 0;
                        while (true) {
                            if ($filterImpl_filterImpl_foreachRest_foreachRec_i >= $filterImpl_filterImpl_foreachRest_foreachRec_len)
                                break d;
                            e: {
                                $filterImpl_filterImpl_foreachRest_foreachRec_a = $foreachRec_a_0[$filterImpl_filterImpl_foreachRest_foreachRec_i].data;
                                $foreachRec_i = 0;
                                $foreachRec_len = $filterImpl_filterImpl_foreachRest_foreachRec_a.length;
                                if ($filterImpl_filterImpl_j)
                                    while (true) {
                                        if ($foreachRec_i >= $foreachRec_len)
                                            break e;
                                        sci_VectorStatics$_foreachRec($filterImpl_filterImpl_foreachRest_foreachRec_this, $foreachRec_l, $filterImpl_filterImpl_foreachRest_foreachRec_a[$foreachRec_i], $filterImpl_filterImpl_foreachRest_f);
                                        $foreachRec_i = $foreachRec_i + 1 | 0;
                                    }
                                while (true) {
                                    if ($foreachRec_i >= $foreachRec_len)
                                        break e;
                                    $filterImpl_pred = $filterImpl_filterImpl_foreachRest_foreachRec_a[$foreachRec_i];
                                    if (sci_HashCollisionSetNode_$anonfun$diff$2($this, $that, $shift, $filterImpl_pred) != 1)
                                        sci_VectorBuilder_addOne($filterImpl_filterImpl_b, $filterImpl_pred);
                                    $foreachRec_i = $foreachRec_i + 1 | 0;
                                }
                            }
                            $filterImpl_filterImpl_foreachRest_foreachRec_i = $filterImpl_filterImpl_foreachRest_foreachRec_i + 1 | 0;
                        }
                    }
                    $filterImpl_filterImpl_foreachRest_i = $filterImpl_filterImpl_foreachRest_i + 1 | 0;
                }
                $filterImpl_newContent = sci_VectorBuilder_result($filterImpl_filterImpl_b);
            }
        }
        $filterImpl_newContentLength = sci_Vector_length($filterImpl_newContent);
        if (!$filterImpl_newContentLength) {
            sci_SetNode$_$callClinit();
            return sci_SetNode$_empty(sci_SetNode$_MODULE$);
        }
        if ($filterImpl_newContentLength != 1) {
            if (sci_Vector_length($filterImpl_newContent) == sci_Vector_length(sci_HashCollisionSetNode_content($this)))
                return $this;
            return sci_HashCollisionSetNode__init_0(sci_HashCollisionSetNode_originalHash($this), sci_HashCollisionSetNode_hash($this), $filterImpl_newContent);
        }
        $that = new sci_BitmapIndexedSetNode;
        $filterImpl_filterImpl_k = 1 << (sci_HashCollisionSetNode_hash($this) >>> 0 & 31);
        $foreachRec_a_0 = $rt_createArray(jl_Object, 1);
        $foreachRec_a_0.data[0] = sci_Vector_head($filterImpl_newContent);
        $filterImpl_filterImpl_foreachRest_foreachRec_a = $rt_createIntArray(1);
        $filterImpl_filterImpl_foreachRest_foreachRec_a.data[0] = sci_HashCollisionSetNode_originalHash($this);
        sci_BitmapIndexedSetNode__init_0($that, $filterImpl_filterImpl_k, 0, $foreachRec_a_0, $filterImpl_filterImpl_foreachRest_foreachRec_a, 1, sci_HashCollisionSetNode_hash($this));
        return $that;
    }
    function sci_HashCollisionSetNode_equals($this, $that) {
        var var$2, var$3, var$4;
        if (!($that instanceof sci_HashCollisionSetNode))
            return 0;
        a: {
            $that = $that;
            if ($this !== $that) {
                if ($this.$hash3 != $that.$hash3)
                    break a;
                var$2 = $this.$content0;
                if (var$2 === null)
                    $rt_throw(null);
                var$3 = sci_Vector_length(var$2);
                var$2 = $that.$content0;
                if (var$2 === null)
                    $rt_throw(null);
                if (var$3 != sci_Vector_length(var$2))
                    break a;
                var$2 = $this.$content0;
                var$4 = $that.$content0;
                $that = new sci_HashCollisionSetNode$equals$lambda$_20_0;
                $that.$_0174 = var$4;
                if (!sc_IterableOnceOps_forall$(var$2, $that))
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function sci_HashCollisionSetNode_hashCode($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(472));
        $rt_throw(var$1);
    }
    function sci_HashCollisionSetNode_concat($this, $that, $shift) {
        var $newContent, $iter, $nextPayload;
        if (!($that instanceof sci_HashCollisionSetNode)) {
            if (!($that instanceof sci_BitmapIndexedSetNode))
                $rt_throw(s_MatchError__init_($that));
            $that = new jl_UnsupportedOperationException;
            jl_Throwable__init_($that, $rt_s(473));
            $rt_throw($that);
        }
        $that = $that;
        if ($that === $this)
            return $this;
        $newContent = null;
        $iter = sci_Vector_iterator($that.$content0);
        while (sci_NewVectorIterator_hasNext($iter)) {
            $nextPayload = sci_NewVectorIterator_next($iter);
            if (sc_AbstractSeq_contains($this.$content0, $nextPayload))
                continue;
            if ($newContent === null) {
                $newContent = sci_VectorBuilder__init_();
                sci_VectorBuilder_addAll($newContent, $this.$content0);
            }
            sci_VectorBuilder_addOne($newContent, $nextPayload);
        }
        if ($newContent === null)
            return $this;
        return sci_HashCollisionSetNode__init_0($this.$originalHash, $this.$hash3, sci_VectorBuilder_result($newContent));
    }
    function sci_HashCollisionSetNode_foreachWithHash($this, $f) {
        var $iter;
        $iter = sci_Vector_iterator($this.$content0);
        while (sci_NewVectorIterator_hasNext($iter)) {
            scm_HashSet$addAll$lambda$_52_0_apply($f, sci_NewVectorIterator_next($iter), jl_Integer_valueOf($this.$originalHash));
        }
    }
    function sci_HashCollisionSetNode_foreachWithHashWhile($this, $f) {
        var $stillGoing, $iter, $next;
        $stillGoing = 1;
        $iter = sci_Vector_iterator($this.$content0);
        while (sci_NewVectorIterator_hasNext($iter) && $stillGoing) {
            $next = sci_NewVectorIterator_next($iter);
            $stillGoing = $stillGoing && sr_BoxesRunTime_unboxToBoolean(scm_HashSet$subtractAll$lambda$_53_0_apply($f, $next, jl_Integer_valueOf($this.$originalHash))) ? 1 : 0;
        }
        return $stillGoing;
    }
    function sci_HashCollisionSetNode_copy($this) {
        return sci_HashCollisionSetNode__init_0($this.$originalHash, $this.$hash3, $this.$content0);
    }
    function sci_HashCollisionSetNode_getNode($this, $index) {
        var var$2;
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_(var$2, $rt_s(475));
        $rt_throw(var$2);
    }
    function sci_HashCollisionSetNode_$anonfun$diff$2($$this, $that$1, $shift$1, $x$1) {
        return $that$1.$contains1($x$1, $$this.$originalHash, $$this.$hash3, $shift$1);
    }
    function sci_HashCollisionSetNode__init_($this, $originalHash, $hash, $content) {
        $this.$originalHash = $originalHash;
        $this.$hash3 = $hash;
        $this.$content0 = $content;
        s_Predef$_$callClinit();
        s_Predef$_require(s_Predef$_MODULE$, sci_Vector_length($content) < 2 ? 0 : 1);
    }
    function jnci_BufferedEncoder() {
        var a = this; jnc_CharsetEncoder.call(a);
        a.$inArray0 = null;
        a.$outArray0 = null;
    }
    function jnci_BufferedEncoder_encodeLoop($this, $in, $out) {
        var $inArray, $inPos, $inSize, $outArray, $i, var$8, $outPos, $outSize, $result, var$12, var$13, var$14, $controller;
        $inArray = $this.$inArray0;
        $inPos = 0;
        $inSize = 0;
        $outArray = $this.$outArray0;
        a: {
            b: {
                while (true) {
                    if (($inPos + 32 | 0) > $inSize && jn_Buffer_hasRemaining($in)) {
                        $i = $inPos;
                        while ($i < $inSize) {
                            var$8 = $inArray.data;
                            var$8[$i - $inPos | 0] = var$8[$i];
                            $i = $i + 1 | 0;
                        }
                        var$8 = $inArray.data;
                        $outPos = $inSize - $inPos | 0;
                        $outSize = jn_Buffer_remaining($in) + $outPos | 0;
                        $i = var$8.length;
                        $inSize = jl_Math_min($outSize, $i);
                        $inPos = $inSize - $outPos | 0;
                        if ($outPos < 0)
                            break b;
                        if ($outPos >= $i)
                            break b;
                        $outSize = $outPos + $inPos | 0;
                        if ($outSize > $i) {
                            $result = new jl_IndexOutOfBoundsException;
                            $in = new jl_StringBuilder;
                            jl_AbstractStringBuilder__init_($in);
                            jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($in, $rt_s(476)), $outSize), $rt_s(418)), $i);
                            jl_Throwable__init_($result, jl_AbstractStringBuilder_toString($in));
                            $rt_throw($result);
                        }
                        if (jn_Buffer_remaining($in) < $inPos)
                            break;
                        if ($inPos < 0) {
                            $in = new jl_IndexOutOfBoundsException;
                            $out = new jl_StringBuilder;
                            jl_AbstractStringBuilder__init_($out);
                            jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($out, $rt_s(419)), $inPos), $rt_s(420));
                            jl_Throwable__init_($in, jl_AbstractStringBuilder_toString($out));
                            $rt_throw($in);
                        }
                        $i = $in.$position9;
                        var$12 = 0;
                        var$13 = $i;
                        while (var$12 < $inPos) {
                            var$14 = $outPos + 1 | 0;
                            $outSize = var$13 + 1 | 0;
                            var$8[$outPos] = $in.$array2.data[var$13 + $in.$start3 | 0];
                            var$12 = var$12 + 1 | 0;
                            $outPos = var$14;
                            var$13 = $outSize;
                        }
                        $in.$position9 = $i + $inPos | 0;
                        $inPos = 0;
                    }
                    if (!jn_Buffer_hasRemaining($out)) {
                        $result = !jn_Buffer_hasRemaining($in) && $inPos >= $inSize ? jnc_CoderResult_UNDERFLOW : jnc_CoderResult_OVERFLOW;
                        break a;
                    }
                    var$8 = $outArray.data;
                    $outSize = jl_Math_min(jn_Buffer_remaining($out), var$8.length);
                    $controller = new jnci_BufferedEncoder$Controller;
                    $controller.$in = $in;
                    $controller.$out2 = $out;
                    $result = jnci_UTF8Encoder_arrayEncode($this, $inArray, $inPos, $inSize, $outArray, 0, $outSize, $controller);
                    $inPos = $controller.$inPosition;
                    $outPos = $controller.$outPosition;
                    if ($result === null) {
                        if (!jn_Buffer_hasRemaining($in) && $inPos >= $inSize)
                            $result = jnc_CoderResult_UNDERFLOW;
                        else if (!jn_Buffer_hasRemaining($out) && $inPos >= $inSize)
                            $result = jnc_CoderResult_OVERFLOW;
                    }
                    jn_ByteBuffer_put($out, $outArray, 0, $outPos);
                    if ($result !== null)
                        break a;
                }
                $in = new jn_BufferUnderflowException;
                jl_Throwable__init_0($in);
                $rt_throw($in);
            }
            $controller = new jl_IndexOutOfBoundsException;
            $result = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($result);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($result, $rt_s(421)), $outPos), $rt_s(415)), $i), 41);
            jl_Throwable__init_($controller, jl_AbstractStringBuilder_toString($result));
            $rt_throw($controller);
        }
        jn_Buffer_position($in, $in.$position9 - ($inSize - $inPos | 0) | 0);
        return $result;
    }
    var jnci_UTF8Encoder = $rt_classWithoutFields(jnci_BufferedEncoder);
    function jnci_UTF8Encoder_arrayEncode($this, $inArray, $inPos, $inSize, $outArray, $outPos, $outSize, $controller) {
        var $result, var$9, var$10, $ch, $low, var$13, $codePoint;
        $result = null;
        a: {
            while ($inPos < $inSize) {
                if ($outPos >= $outSize) {
                    var$9 = $inPos;
                    break a;
                }
                var$10 = $inArray.data;
                var$9 = $inPos + 1 | 0;
                $ch = var$10[$inPos];
                if ($ch < 128) {
                    var$10 = $outArray.data;
                    $low = $outPos + 1 | 0;
                    var$10[$outPos] = $ch << 24 >> 24;
                } else if ($ch < 2048) {
                    if (($outPos + 2 | 0) > $outSize) {
                        var$9 = var$9 + (-1) | 0;
                        if (jnci_BufferedEncoder$Controller_hasMoreOutput($controller, 2))
                            break a;
                        $result = jnc_CoderResult_OVERFLOW;
                        break a;
                    }
                    var$10 = $outArray.data;
                    $inPos = $outPos + 1 | 0;
                    var$10[$outPos] = (192 | $ch >> 6) << 24 >> 24;
                    $low = $inPos + 1 | 0;
                    var$10[$inPos] = (128 | $ch & 63) << 24 >> 24;
                } else if (!jl_Character_isSurrogate($ch)) {
                    if (($outPos + 3 | 0) > $outSize) {
                        var$9 = var$9 + (-1) | 0;
                        if (jnci_BufferedEncoder$Controller_hasMoreOutput($controller, 3))
                            break a;
                        $result = jnc_CoderResult_OVERFLOW;
                        break a;
                    }
                    var$10 = $outArray.data;
                    var$13 = $outPos + 1 | 0;
                    var$10[$outPos] = (224 | $ch >> 12) << 24 >> 24;
                    $inPos = var$13 + 1 | 0;
                    var$10[var$13] = (128 | $ch >> 6 & 63) << 24 >> 24;
                    $low = $inPos + 1 | 0;
                    var$10[$inPos] = (128 | $ch & 63) << 24 >> 24;
                } else {
                    if (!jl_Character_isHighSurrogate($ch)) {
                        $result = jnc_CoderResult_malformedForLength(1);
                        break a;
                    }
                    if (var$9 >= $inSize) {
                        if (jn_Buffer_hasRemaining($controller.$in))
                            break a;
                        $result = jnc_CoderResult_UNDERFLOW;
                        break a;
                    }
                    $inPos = var$9 + 1 | 0;
                    $low = var$10[var$9];
                    if (!jl_Character_isLowSurrogate($low)) {
                        var$9 = $inPos + (-2) | 0;
                        $result = jnc_CoderResult_malformedForLength(1);
                        break a;
                    }
                    if (($outPos + 4 | 0) > $outSize) {
                        var$9 = $inPos + (-2) | 0;
                        if (jnci_BufferedEncoder$Controller_hasMoreOutput($controller, 4))
                            break a;
                        $result = jnc_CoderResult_OVERFLOW;
                        break a;
                    }
                    var$10 = $outArray.data;
                    $codePoint = jl_Character_toCodePoint($ch, $low);
                    $low = $outPos + 1 | 0;
                    var$10[$outPos] = (240 | $codePoint >> 18) << 24 >> 24;
                    var$13 = $low + 1 | 0;
                    var$10[$low] = (128 | $codePoint >> 12 & 63) << 24 >> 24;
                    $outPos = var$13 + 1 | 0;
                    var$10[var$13] = (128 | $codePoint >> 6 & 63) << 24 >> 24;
                    $low = $outPos + 1 | 0;
                    var$10[$outPos] = (128 | $codePoint & 63) << 24 >> 24;
                    var$9 = $inPos;
                }
                $inPos = var$9;
                $outPos = $low;
            }
            var$9 = $inPos;
        }
        $controller.$inPosition = var$9;
        $controller.$outPosition = $outPos;
        return $result;
    }
    var ji_IOException = $rt_classWithoutFields(jl_Exception);
    function sci_Vector() {
        sci_AbstractSeq.call(this);
        this.$prefix10 = null;
    }
    function sci_Vector_scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted($this, $ord) {
        return sc_SeqOps_sorted$($this, $ord);
    }
    function sci_Vector_distinctBy($this, $f) {
        return sci_StrictOptimizedSeqOps_distinctBy$($this, $f);
    }
    function sci_Vector_sorted($this, $ord) {
        return $this.$scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted($ord);
    }
    function sci_Vector_intersect($this, $that) {
        return sc_StrictOptimizedSeqOps_intersect$($this, $that);
    }
    function sci_Vector_partition($this, $p) {
        return sc_StrictOptimizedIterableOps_partition$($this, $p);
    }
    function sci_Vector_span($this, $p) {
        return sc_StrictOptimizedIterableOps_span$($this, $p);
    }
    function sci_Vector_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_Vector_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_Vector_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_Vector_zip($this, $that) {
        return sc_StrictOptimizedIterableOps_zip$($this, $that);
    }
    function sci_Vector_zipWithIndex($this) {
        return sc_StrictOptimizedIterableOps_zipWithIndex$($this);
    }
    function sci_Vector_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_Vector_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_Vector_scala$collection$immutable$IndexedSeq$$super$canEqual($this, $that) {
        return 1;
    }
    function sci_Vector_scala$collection$immutable$IndexedSeq$$super$sameElements($this, $that) {
        return sc_SeqOps_sameElements$($this, $that);
    }
    function sci_Vector_toIndexedSeq($this) {
        return $this;
    }
    function sci_Vector_canEqual($this, $that) {
        return sci_IndexedSeq_canEqual$($this, $that);
    }
    function sci_Vector_sameElements($this, $o) {
        return sci_IndexedSeq_sameElements$($this, $o);
    }
    function sci_Vector_stringPrefix($this) {
        return $rt_s(193);
    }
    function sci_Vector_reverseIterator($this) {
        return sc_IndexedSeqOps_reverseIterator$($this);
    }
    function sci_Vector_view($this) {
        return sc_IndexedSeqOps_view$($this);
    }
    function sci_Vector_reversed($this) {
        return sc_IndexedSeqOps_reversed$($this);
    }
    function sci_Vector_headOption($this) {
        return sc_IndexedSeqOps_headOption$($this);
    }
    function sci_Vector_lengthCompare($this, $len) {
        return sc_IndexedSeqOps_lengthCompare$($this, $len);
    }
    function sci_Vector_knownSize($this) {
        return $this.$length();
    }
    function sci_Vector_prefix1($this) {
        return $this.$prefix10;
    }
    function sci_Vector_iterableFactory($this) {
        sci_Vector$_$callClinit();
        return sci_Vector$_MODULE$;
    }
    function sci_Vector_length($this) {
        if ($this instanceof sci_BigVector)
            return $this.$length00;
        return $this.$prefix10.data.length;
    }
    function sci_Vector_iterator($this) {
        sci_Vector0$_$callClinit();
        if (sci_Vector0$_MODULE$ === $this) {
            sci_Vector$_$callClinit();
            return sci_Vector$_scala$collection$immutable$Vector$$emptyIterator;
        }
        return sci_NewVectorIterator__init_($this, sci_Vector_length($this), $this.$vectorSliceCount());
    }
    function sci_Vector_filterImpl($this, $pred, $isFlipped) {
        var $i, $len, $bitmap, $k, $j, $newLen, $newData, $foreachRec_a, $b, $k_0, $foreachRest_this, $foreachRest_f, $foreachRest_c, $foreachRest_i, $foreachRest_foreachRec_this, $foreachRest_vectorSliceDim_c, $foreachRest_foreachRec_level, $foreachRest_foreachRec_a, $foreachRest_foreachRec_i, $foreachRest_foreachRec_len, $foreachRest_foreachRec_l, $foreachRec_l, $foreachRec_i, $foreachRec_len, $foreachRest_this_0;
        $i = 0;
        $len = $this.$prefix10.data.length;
        while ($i != $len) {
            if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$prefix10.data[$i])) == $isFlipped) {
                $bitmap = 0;
                $k = $i + 1 | 0;
                $j = $k;
                while ($j < $len) {
                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($this.$prefix10.data[$j])) != $isFlipped)
                        $bitmap = $bitmap | 1 << $j;
                    $j = $j + 1 | 0;
                }
                $newLen = $i + jl_Integer_bitCount($bitmap) | 0;
                if (!($this instanceof sci_BigVector)) {
                    if (!$newLen) {
                        sci_Vector0$_$callClinit();
                        return sci_Vector0$_MODULE$;
                    }
                    $newData = $rt_createArray(jl_Object, $newLen);
                    $foreachRec_a = $newData.data;
                    jl_System_arraycopy($this.$prefix10, 0, $newData, 0, $i);
                    while ($i != $newLen) {
                        if (1 << $k & $bitmap) {
                            $foreachRec_a[$i] = $this.$prefix10.data[$k];
                            $i = $i + 1 | 0;
                        }
                        $k = $k + 1 | 0;
                    }
                    $pred = new sci_Vector1;
                    sci_VectorImpl__init_($pred, $newData);
                    return $pred;
                }
                $b = sci_VectorBuilder__init_();
                $k_0 = 0;
                while ($k_0 < $i) {
                    sci_VectorBuilder_addOne($b, $this.$prefix10.data[$k_0]);
                    $k_0 = $k_0 + 1 | 0;
                }
                while ($i != $newLen) {
                    if (1 << $k & $bitmap) {
                        sci_VectorBuilder_addOne($b, $this.$prefix10.data[$k]);
                        $i = $i + 1 | 0;
                    }
                    $k = $k + 1 | 0;
                }
                $foreachRest_this = $this;
                $foreachRest_f = new sci_Vector$filterImpl$lambda$_70_0;
                $foreachRest_f.$_0175 = $pred;
                $foreachRest_f.$_129 = $isFlipped;
                $foreachRest_f.$_216 = $b;
                $foreachRest_c = $foreachRest_this.$vectorSliceCount();
                $foreachRest_i = 1;
                while ($foreachRest_i < $foreachRest_c) {
                    a: {
                        $foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                        $foreachRest_vectorSliceDim_c = $foreachRest_c / 2 | 0;
                        $foreachRest_foreachRec_level = (($foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($foreachRest_i - $foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                        $foreachRest_foreachRec_a = ($foreachRest_this.$vectorSlice($foreachRest_i)).data;
                        $foreachRest_foreachRec_i = 0;
                        $foreachRest_foreachRec_len = $foreachRest_foreachRec_a.length;
                        if (!$foreachRest_foreachRec_level)
                            while (true) {
                                if ($foreachRest_foreachRec_i >= $foreachRest_foreachRec_len)
                                    break a;
                                $foreachRest_foreachRec_this = $foreachRest_foreachRec_a[$foreachRest_foreachRec_i];
                                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($foreachRest_foreachRec_this)) != $isFlipped)
                                    sci_VectorBuilder_addOne($b, $foreachRest_foreachRec_this);
                                $foreachRest_foreachRec_i = $foreachRest_foreachRec_i + 1 | 0;
                            }
                        $foreachRest_foreachRec_l = $foreachRest_foreachRec_level - 1 | 0;
                        $i = $rt_compare($foreachRest_foreachRec_l, 0);
                        $foreachRec_l = $foreachRest_foreachRec_l - 1 | 0;
                        while (true) {
                            if ($foreachRest_foreachRec_i >= $foreachRest_foreachRec_len)
                                break a;
                            b: {
                                $foreachRec_a = $foreachRest_foreachRec_a[$foreachRest_foreachRec_i].data;
                                $foreachRec_i = 0;
                                $foreachRec_len = $foreachRec_a.length;
                                if ($i)
                                    while (true) {
                                        if ($foreachRec_i >= $foreachRec_len)
                                            break b;
                                        sci_VectorStatics$_foreachRec($foreachRest_foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $foreachRest_f);
                                        $foreachRec_i = $foreachRec_i + 1 | 0;
                                    }
                                while (true) {
                                    if ($foreachRec_i >= $foreachRec_len)
                                        break b;
                                    $foreachRest_this_0 = $foreachRec_a[$foreachRec_i];
                                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($foreachRest_this_0)) != $isFlipped)
                                        sci_VectorBuilder_addOne($b, $foreachRest_this_0);
                                    $foreachRec_i = $foreachRec_i + 1 | 0;
                                }
                            }
                            $foreachRest_foreachRec_i = $foreachRest_foreachRec_i + 1 | 0;
                        }
                    }
                    $foreachRest_i = $foreachRest_i + 1 | 0;
                }
                return sci_VectorBuilder_result($b);
            }
            $i = $i + 1 | 0;
        }
        if (!($this instanceof sci_BigVector))
            return $this;
        $b = sci_VectorBuilder__init_();
        sci_VectorBuilder_initFrom($b, $this.$prefix10);
        $foreachRest_this_0 = $this;
        $foreachRest_f = new sci_Vector$filterImpl$lambda$_70_1;
        $foreachRest_f.$_0176 = $pred;
        $foreachRest_f.$_130 = $isFlipped;
        $foreachRest_f.$_217 = $b;
        $foreachRest_c = $foreachRest_this_0.$vectorSliceCount();
        $foreachRest_i = 1;
        while ($foreachRest_i < $foreachRest_c) {
            c: {
                $foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                $foreachRest_vectorSliceDim_c = $foreachRest_c / 2 | 0;
                $foreachRest_foreachRec_level = (($foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($foreachRest_i - $foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                $foreachRest_foreachRec_a = ($foreachRest_this_0.$vectorSlice($foreachRest_i)).data;
                $foreachRest_foreachRec_i = 0;
                $foreachRest_foreachRec_len = $foreachRest_foreachRec_a.length;
                if (!$foreachRest_foreachRec_level)
                    while (true) {
                        if ($foreachRest_foreachRec_i >= $foreachRest_foreachRec_len)
                            break c;
                        $foreachRest_foreachRec_this = $foreachRest_foreachRec_a[$foreachRest_foreachRec_i];
                        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($foreachRest_foreachRec_this)) != $isFlipped)
                            sci_VectorBuilder_addOne($b, $foreachRest_foreachRec_this);
                        $foreachRest_foreachRec_i = $foreachRest_foreachRec_i + 1 | 0;
                    }
                $foreachRest_foreachRec_l = $foreachRest_foreachRec_level - 1 | 0;
                $i = $rt_compare($foreachRest_foreachRec_l, 0);
                $foreachRec_l = $foreachRest_foreachRec_l - 1 | 0;
                while (true) {
                    if ($foreachRest_foreachRec_i >= $foreachRest_foreachRec_len)
                        break c;
                    d: {
                        $foreachRec_a = $foreachRest_foreachRec_a[$foreachRest_foreachRec_i].data;
                        $foreachRec_i = 0;
                        $foreachRec_len = $foreachRec_a.length;
                        if ($i)
                            while (true) {
                                if ($foreachRec_i >= $foreachRec_len)
                                    break d;
                                sci_VectorStatics$_foreachRec($foreachRest_foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $foreachRest_f);
                                $foreachRec_i = $foreachRec_i + 1 | 0;
                            }
                        while (true) {
                            if ($foreachRec_i >= $foreachRec_len)
                                break d;
                            $foreachRest_this = $foreachRec_a[$foreachRec_i];
                            if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($foreachRest_this)) != $isFlipped)
                                sci_VectorBuilder_addOne($b, $foreachRest_this);
                            $foreachRec_i = $foreachRec_i + 1 | 0;
                        }
                    }
                    $foreachRest_foreachRec_i = $foreachRest_foreachRec_i + 1 | 0;
                }
            }
            $foreachRest_i = $foreachRest_i + 1 | 0;
        }
        return sci_VectorBuilder_result($b);
    }
    function sci_Vector_appendedAll($this, $suffix) {
        var $k, var$3;
        $k = $suffix.$knownSize();
        var$3 = $rt_compare($k, 0);
        if (!var$3)
            return $this;
        if (var$3 >= 0)
            return $this.$appendedAll00($suffix, $k);
        return sc_StrictOptimizedSeqOps_appendedAll$($this, $suffix);
    }
    function sci_Vector_appendedAll0($this, $suffix, $k) {
        var $v, $ri, var$5, $tinyAppendLimit;
        if ($k < (4 + $this.$vectorSliceCount() | 0)) {
            $v = sr_ObjectRef__init_($this);
            if (!$rt_isInstance($suffix, sci_Iterable)) {
                $suffix = $suffix.$iterator0();
                $ri = new sci_Vector$appendedAll0$lambda$_77_0;
                $ri.$_0177 = $v;
                $suffix.$foreach($ri);
            } else {
                $suffix = $suffix;
                $ri = new sci_Vector$appendedAll0$lambda$_77_1;
                $ri.$_0178 = $v;
                $suffix.$foreach($ri);
            }
            return $v.$elem5;
        }
        if (sci_Vector_length($this) < $k >>> 5 && $suffix instanceof sci_Vector) {
            $v = $suffix;
            $ri = sc_IndexedSeqOps_reverseIterator$($this);
            while ($ri.$hasNext()) {
                $v = $v.$prepended2(sc_IndexedSeqView$IndexedSeqViewReverseIterator_next($ri));
            }
            return $v;
        }
        if (sci_Vector_length($this) < ($k - 64 | 0) && $suffix instanceof sci_Vector) {
            $v = $suffix;
            $suffix = sci_VectorBuilder__init_();
            $k = sci_Vector_length($this);
            if (!$suffix.$scala$collection$immutable$VectorBuilder$$len1 && !$suffix.$scala$collection$immutable$VectorBuilder$$lenRest) {
                sci_Vector0$_$callClinit();
                if (sci_Vector0$_equals(sci_Vector0$_MODULE$, $v)) {
                    var$5 = 0;
                    $tinyAppendLimit = 1;
                } else if ($v instanceof sci_Vector1) {
                    var$5 = 0;
                    $tinyAppendLimit = 1;
                } else if ($v instanceof sci_Vector2) {
                    var$5 = $v.$len10;
                    $tinyAppendLimit = 32;
                } else if ($v instanceof sci_Vector3) {
                    var$5 = $v.$len12;
                    $tinyAppendLimit = 1024;
                } else if ($v instanceof sci_Vector4) {
                    var$5 = $v.$len123;
                    $tinyAppendLimit = 32768;
                } else if ($v instanceof sci_Vector5) {
                    var$5 = $v.$len1234;
                    $tinyAppendLimit = 1048576;
                } else {
                    if (!($v instanceof sci_Vector6))
                        $rt_throw(s_MatchError__init_($v));
                    var$5 = $v.$len12345;
                    $tinyAppendLimit = 33554432;
                }
                if ($tinyAppendLimit != 1) {
                    $k = ($tinyAppendLimit - (($k + var$5 | 0) % $tinyAppendLimit | 0) | 0) % $tinyAppendLimit | 0;
                    $suffix.$scala$collection$immutable$VectorBuilder$$offset = $k;
                    sci_VectorBuilder_advanceN($suffix, $k & (-32));
                    $suffix.$scala$collection$immutable$VectorBuilder$$len1 = $suffix.$scala$collection$immutable$VectorBuilder$$offset & 31;
                    $suffix.$prefixIsRightAligned = 1;
                }
                return sci_VectorBuilder_result(sci_VectorBuilder_addAll(sci_VectorBuilder_addAll($suffix, $this), $v));
            }
            $v = new jl_UnsupportedOperationException;
            jl_Throwable__init_($v, $rt_s(477));
            $rt_throw($v);
        }
        return sci_VectorBuilder_result(sci_VectorBuilder_addAll(sci_VectorBuilder_initFrom0(sci_VectorBuilder__init_(), $this), $suffix));
    }
    function sci_Vector_className($this) {
        return $rt_s(478);
    }
    function sci_Vector_drop($this, $n) {
        return sci_VectorImpl_slice($this, $n, sci_Vector_length($this));
    }
    function sci_Vector_dropRight($this, $n) {
        return sci_VectorImpl_slice($this, 0, sci_Vector_length($this) - jl_Math_max($n, 0) | 0);
    }
    function sci_Vector_copyToArray($this, $xs, $start, $len) {
        return sci_NewVectorIterator_copyToArray(sci_Vector_iterator($this), $xs, $start, $len);
    }
    function sci_Vector_toVector($this) {
        return $this;
    }
    function sci_Vector_applyPreferredMaxLength($this) {
        sci_Vector$_$callClinit();
        return sci_Vector$_scala$collection$immutable$Vector$$defaultApplyPreferredMaxLength;
    }
    function sci_Vector_ioob($this, $index) {
        var var$2, var$3;
        var$2 = new jl_IndexOutOfBoundsException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 31);
        var$3 = jl_StringBuilder_append0(var$3, $index);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(390));
        var$3 = jl_StringBuilder_append0(var$3, sci_Vector_length($this) - 1 | 0);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(25));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        return var$2;
    }
    function sci_Vector_head($this) {
        var var$1, var$2;
        var$1 = $this.$prefix10.data;
        if (var$1.length)
            return var$1[0];
        var$2 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$2, $rt_s(479));
        $rt_throw(var$2);
    }
    function sci_Vector_last($this) {
        var $suffix, var$2, var$3;
        if (!($this instanceof sci_BigVector)) {
            $suffix = $this.$prefix10.data;
            return $suffix[$suffix.length - 1 | 0];
        }
        $suffix = $this.$suffix1.data;
        var$2 = $suffix.length;
        if (var$2)
            return $suffix[var$2 - 1 | 0];
        var$3 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$3, $rt_s(480));
        $rt_throw(var$3);
    }
    function sci_Vector_foreach($this, $f) {
        var $c, $i, $foreachRec_this, $vectorSliceDim_c, $foreachRec_level, $foreachRec_a, $foreachRec_i, $foreachRec_len, $foreachRec_l;
        $c = $this.$vectorSliceCount();
        $i = 0;
        while ($i < $c) {
            a: {
                $foreachRec_this = sci_VectorStatics$_MODULE$;
                $vectorSliceDim_c = $c / 2 | 0;
                $foreachRec_level = (($vectorSliceDim_c + 1 | 0) - jl_Math_abs($i - $vectorSliceDim_c | 0) | 0) - 1 | 0;
                $foreachRec_a = ($this.$vectorSlice($i)).data;
                $foreachRec_i = 0;
                $foreachRec_len = $foreachRec_a.length;
                if (!$foreachRec_level)
                    while (true) {
                        if ($foreachRec_i >= $foreachRec_len)
                            break a;
                        $f.$apply($foreachRec_a[$foreachRec_i]);
                        $foreachRec_i = $foreachRec_i + 1 | 0;
                    }
                $foreachRec_l = $foreachRec_level - 1 | 0;
                while (true) {
                    if ($foreachRec_i >= $foreachRec_len)
                        break a;
                    sci_VectorStatics$_foreachRec($foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $f);
                    $foreachRec_i = $foreachRec_i + 1 | 0;
                }
            }
            $i = $i + 1 | 0;
        }
    }
    function sci_Vector_view0($this) {
        return sc_IndexedSeqOps_view$($this);
    }
    function sci_Vector_dropRight0($this, $n) {
        return sci_Vector_dropRight($this, $n);
    }
    function sci_Vector_drop0($this, $n) {
        return sci_Vector_drop($this, $n);
    }
    function sci_Vector_appendedAll1($this, $suffix) {
        return sci_Vector_appendedAll($this, $suffix);
    }
    function sci_Vector_filterImpl0($this, $pred, $isFlipped) {
        return sci_Vector_filterImpl($this, $pred, $isFlipped);
    }
    function sci_Vector_iterableFactory0($this) {
        return sci_Vector_iterableFactory($this);
    }
    function sci_Vector_$anonfun$filterImpl$1($pred$1, $isFlipped$1, $b$1, $v) {
        if (sr_BoxesRunTime_unboxToBoolean($pred$1.$apply($v)) == $isFlipped$1)
            return sr_BoxedUnit_UNIT;
        return sci_VectorBuilder_addOne($b$1, $v);
    }
    function sci_Vector_$anonfun$filterImpl$2($pred$1, $isFlipped$1, $b$2, $v) {
        if (sr_BoxesRunTime_unboxToBoolean($pred$1.$apply($v)) == $isFlipped$1)
            return sr_BoxedUnit_UNIT;
        return sci_VectorBuilder_addOne($b$2, $v);
    }
    function sc_Iterator$$anon$10() {
        var a = this; sc_AbstractIterator.call(a);
        a.$cur = null;
        a.$_hasNext = 0;
        a.$$outer11 = null;
        a.$f$3 = null;
    }
    function sc_Iterator$$anon$10_hasNext($this) {
        var var$1;
        var$1 = $this.$_hasNext;
        if (var$1 != (-1)) {
            if (var$1 != 1)
                return 0;
            return 1;
        }
        while (!$this.$cur.$hasNext()) {
            if (!$this.$$outer11.$hasNext()) {
                $this.$_hasNext = 0;
                $this.$cur = sc_Iterator$_scala$collection$Iterator$$_empty;
                return 0;
            }
            $this.$cur = null;
            $this.$cur = ($this.$f$3.$apply($this.$$outer11.$next())).$iterator0();
            $this.$_hasNext = (-1);
        }
        $this.$_hasNext = 1;
        return 1;
    }
    function sc_Iterator$$anon$10_next($this) {
        if (sc_Iterator$$anon$10_hasNext($this))
            $this.$_hasNext = (-1);
        return $this.$cur.$next();
    }
    var jl_ArrayIndexOutOfBoundsException = $rt_classWithoutFields(jl_IndexOutOfBoundsException);
    var s_Predef$ArrowAssoc$ = $rt_classWithoutFields();
    var s_Predef$ArrowAssoc$_MODULE$ = null;
    function s_Predef$ArrowAssoc$__clinit_() {
        s_Predef$ArrowAssoc$_MODULE$ = new s_Predef$ArrowAssoc$;
    }
    function s_Predef$ArrowAssoc$_$minus$greater$extension($this, $$this, $y) {
        return s_Tuple2__init_($$this, $y);
    }
    var s_package$ = $rt_classWithoutFields();
    var s_package$_MODULE$ = null;
    var s_package$_AnyRef = null;
    var s_package$_Traversable = null;
    var s_package$_Iterable = null;
    var s_package$_Seq0 = null;
    var s_package$_IndexedSeq = null;
    var s_package$_Iterator = null;
    var s_package$_List = null;
    var s_package$_Nil = null;
    var s_package$_$colon$colon = null;
    var s_package$_$plus$colon = null;
    var s_package$_$colon$plus = null;
    var s_package$_Stream = null;
    var s_package$_LazyList = null;
    var s_package$_Vector = null;
    var s_package$_StringBuilder = null;
    var s_package$_Range = null;
    var s_package$_BigDecimal = null;
    var s_package$_BigInt = null;
    var s_package$_Equiv = null;
    var s_package$_Fractional = null;
    var s_package$_Integral = null;
    var s_package$_Numeric = null;
    var s_package$_Ordered = null;
    var s_package$_Ordering = null;
    var s_package$_Either = null;
    var s_package$_Left0 = null;
    var s_package$_Right0 = null;
    function s_package$_$callClinit() {
        s_package$_$callClinit = $rt_eraseClinit(s_package$);
        s_package$__clinit_();
    }
    function s_package$__clinit_() {
        var var$1;
        var$1 = new s_package$;
        s_package$_$callClinit();
        s_package$_MODULE$ = var$1;
        s_package$_AnyRef = new s_package$$anon$1;
        sc_Iterable$_$callClinit();
        var$1 = sc_Iterable$_MODULE$;
        s_package$_Traversable = var$1;
        s_package$_Iterable = var$1;
        sci_Seq$_$callClinit();
        s_package$_Seq0 = sci_Seq$_MODULE$;
        sci_IndexedSeq$_$callClinit();
        s_package$_IndexedSeq = sci_IndexedSeq$_MODULE$;
        s_package$_Iterator = sc_Iterator$_MODULE$;
        sci_List$_$callClinit();
        s_package$_List = sci_List$_MODULE$;
        s_package$_Nil = sci_Nil$_MODULE$;
        s_package$_$colon$colon = sci_$colon$colon$_MODULE$;
        s_package$_$plus$colon = sc_package$$plus$colon$_MODULE$;
        s_package$_$colon$plus = sc_package$$colon$plus$_MODULE$;
        s_package$_Stream = sci_Stream$_MODULE$;
        sci_LazyList$_$callClinit();
        s_package$_LazyList = sci_LazyList$_MODULE$;
        sci_Vector$_$callClinit();
        s_package$_Vector = sci_Vector$_MODULE$;
        s_package$_StringBuilder = scm_StringBuilder$_MODULE$;
        s_package$_Range = sci_Range$_MODULE$;
        sm_BigDecimal$_$callClinit();
        s_package$_BigDecimal = sm_BigDecimal$_MODULE$;
        sm_BigInt$_$callClinit();
        s_package$_BigInt = sm_BigInt$_MODULE$;
        s_package$_Equiv = sm_Equiv$_MODULE$;
        s_package$_Fractional = sm_Fractional$_MODULE$;
        s_package$_Integral = sm_Integral$_MODULE$;
        s_package$_Numeric = sm_Numeric$_MODULE$;
        s_package$_Ordered = sm_Ordered$_MODULE$;
        s_package$_Ordering = sm_Ordering$_MODULE$;
        s_package$_Either = su_Either$_MODULE$;
        s_package$_Left0 = su_Left$_MODULE$;
        s_package$_Right0 = su_Right$_MODULE$;
    }
    function s_package$_Iterable0($this) {
        s_package$_$callClinit();
        return s_package$_Iterable;
    }
    function s_package$_Seq($this) {
        s_package$_$callClinit();
        return s_package$_Seq0;
    }
    function s_package$_IndexedSeq0($this) {
        s_package$_$callClinit();
        return s_package$_IndexedSeq;
    }
    function s_package$_Iterator0($this) {
        s_package$_$callClinit();
        return s_package$_Iterator;
    }
    function s_package$_List0($this) {
        s_package$_$callClinit();
        return s_package$_List;
    }
    function s_package$_Vector0($this) {
        s_package$_$callClinit();
        return s_package$_Vector;
    }
    function s_package$_Left($this) {
        s_package$_$callClinit();
        return s_package$_Left0;
    }
    function s_package$_Right($this) {
        s_package$_$callClinit();
        return s_package$_Right0;
    }
    var onciu_StepSequencer$ByInitialCondition$ = $rt_classWithoutFields();
    var onciu_StepSequencer$ByInitialCondition$_MODULE$ = null;
    function onciu_StepSequencer$ByInitialCondition$__clinit_() {
        onciu_StepSequencer$ByInitialCondition$_MODULE$ = new onciu_StepSequencer$ByInitialCondition$;
    }
    function onciu_StepSequencer$ByInitialCondition$_productArity($this) {
        return 0;
    }
    function onciu_StepSequencer$ByInitialCondition$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function onciu_StepSequencer$ByInitialCondition$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_StepSequencer$ByInitialCondition$_hashCode($this) {
        return 1505272014;
    }
    function onciu_StepSequencer$ByInitialCondition$_toString($this) {
        return $rt_s(481);
    }
    var jl_NegativeArraySizeException = $rt_classWithoutFields(jl_RuntimeException);
    var su_Left$ = $rt_classWithoutFields();
    var su_Left$_MODULE$ = null;
    function su_Left$__clinit_() {
        su_Left$_MODULE$ = new su_Left$;
    }
    function su_Left$_apply($this, $value) {
        return su_Left__init_($value);
    }
    var s_Specializable = $rt_classWithoutFields(0);
    var s_package$$anon$1 = $rt_classWithoutFields();
    var sc_Iterable$ = $rt_classWithoutFields(sc_IterableFactory$Delegate);
    var sc_Iterable$_MODULE$ = null;
    function sc_Iterable$_$callClinit() {
        sc_Iterable$_$callClinit = $rt_eraseClinit(sc_Iterable$);
        sc_Iterable$__clinit_();
    }
    function sc_Iterable$__clinit_() {
        var var$1;
        var$1 = new sc_Iterable$;
        sc_Iterable$_$callClinit();
        sci_Iterable$_$callClinit();
        sc_IterableFactory$Delegate__init_0(var$1, sci_Iterable$_MODULE$);
        sc_Iterable$_MODULE$ = var$1;
    }
    var sci_IndexedSeq$ = $rt_classWithoutFields(sc_SeqFactory$Delegate);
    var sci_IndexedSeq$_MODULE$ = null;
    function sci_IndexedSeq$_$callClinit() {
        sci_IndexedSeq$_$callClinit = $rt_eraseClinit(sci_IndexedSeq$);
        sci_IndexedSeq$__clinit_();
    }
    function sci_IndexedSeq$__clinit_() {
        var var$1;
        var$1 = new sci_IndexedSeq$;
        sci_IndexedSeq$_$callClinit();
        sci_Vector$_$callClinit();
        sc_SeqFactory$Delegate__init_0(var$1, sci_Vector$_MODULE$);
        sci_IndexedSeq$_MODULE$ = var$1;
    }
    var sci_$colon$colon$ = $rt_classWithoutFields();
    var sci_$colon$colon$_MODULE$ = null;
    function sci_$colon$colon$__clinit_() {
        sci_$colon$colon$_MODULE$ = new sci_$colon$colon$;
    }
    var sc_package$$plus$colon$ = $rt_classWithoutFields();
    var sc_package$$plus$colon$_MODULE$ = null;
    function sc_package$$plus$colon$__clinit_() {
        sc_package$$plus$colon$_MODULE$ = new sc_package$$plus$colon$;
    }
    var sc_package$$colon$plus$ = $rt_classWithoutFields();
    var sc_package$$colon$plus$_MODULE$ = null;
    function sc_package$$colon$plus$__clinit_() {
        sc_package$$colon$plus$_MODULE$ = new sc_package$$colon$plus$;
    }
    var sci_Stream$ = $rt_classWithoutFields();
    var sci_Stream$_MODULE$ = null;
    function sci_Stream$__clinit_() {
        sci_Stream$_MODULE$ = new sci_Stream$;
    }
    function sci_Stream$_from($this, $coll) {
        if ($coll instanceof sci_Stream)
            return $coll;
        return sci_Stream$_fromIterator($this, $coll.$iterator0());
    }
    function sci_Stream$_fromIterator($this, $it) {
        var var$2, var$3, var$4;
        if (!$it.$hasNext())
            return sci_Stream$Empty$_MODULE$;
        var$2 = new sci_Stream$Cons;
        var$3 = $it.$next();
        var$4 = new sci_Stream$$fromIterator$lambda$_21_0;
        var$4.$_0179 = $it;
        sci_Stream$Cons__init_(var$2, var$3, var$4);
        return var$2;
    }
    function sci_Stream$_newBuilder($this) {
        return scm_Builder_mapResult$(scm_ArrayBuffer$$anon$1__init_(), new sci_Stream$$newBuilder$lambda$_23_0);
    }
    function sci_Stream$_from0($this, $source) {
        return sci_Stream$_from($this, $source);
    }
    function sci_Stream$_$anonfun$filteredTail$1($stream$1, $p$2, $isFlipped$1) {
        var $filterImpl_rest, $filterImpl_filteredTail_apply_hd, $filterImpl_filteredTail_apply_tl;
        $filterImpl_rest = $stream$1.$tail();
        if ($filterImpl_rest === null)
            $rt_throw(null);
        while (sc_IterableOnceOps_nonEmpty$($filterImpl_rest) && sr_BoxesRunTime_unboxToBoolean($p$2.$apply($filterImpl_rest.$head())) == $isFlipped$1) {
            $filterImpl_rest = $filterImpl_rest.$tail();
        }
        if (!sc_IterableOnceOps_nonEmpty$($filterImpl_rest))
            return sci_Stream$Empty$_MODULE$;
        $filterImpl_filteredTail_apply_hd = $filterImpl_rest.$head();
        $filterImpl_filteredTail_apply_tl = new sci_Stream$$$anonfun$filteredTail$1$lambda$_39_0;
        $filterImpl_filteredTail_apply_tl.$_0180 = $filterImpl_rest;
        $filterImpl_filteredTail_apply_tl.$_131 = $p$2;
        $filterImpl_filteredTail_apply_tl.$_218 = $isFlipped$1;
        return sci_Stream$Cons__init_0($filterImpl_filteredTail_apply_hd, $filterImpl_filteredTail_apply_tl);
    }
    var sci_LazyList$ = $rt_classWithoutFields();
    var sci_LazyList$_MODULE$ = null;
    var sci_LazyList$__empty = null;
    var sci_LazyList$_scala$collection$immutable$LazyList$$anyToMarker = null;
    function sci_LazyList$_$callClinit() {
        sci_LazyList$_$callClinit = $rt_eraseClinit(sci_LazyList$);
        sci_LazyList$__clinit_();
    }
    function sci_LazyList$__clinit_() {
        var var$1;
        var$1 = new sci_LazyList$;
        sci_LazyList$_$callClinit();
        sci_LazyList$_MODULE$ = var$1;
        sci_LazyList$__empty = sci_LazyList_force(sci_LazyList__init_(new sci_LazyList$$_clinit_$lambda$_0_0));
        sci_LazyList$_scala$collection$immutable$LazyList$$anyToMarker = new sci_LazyList$$_clinit_$lambda$_0_1;
    }
    function sci_LazyList$_scala$collection$immutable$LazyList$$anyToMarker0($this) {
        sci_LazyList$_$callClinit();
        return sci_LazyList$_scala$collection$immutable$LazyList$$anyToMarker;
    }
    function sci_LazyList$_scala$collection$immutable$LazyList$$collectImpl($this, $ll, $pf) {
        var var$3, $scala$collection$immutable$LazyList$$newLL_state;
        var$3 = sr_ObjectRef__init_($ll);
        $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$scala$collection$immutable$LazyList$$collectImpl$lambda$_19_0;
        $scala$collection$immutable$LazyList$$newLL_state.$_0181 = var$3;
        $scala$collection$immutable$LazyList$$newLL_state.$_132 = $pf;
        return sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state);
    }
    function sci_LazyList$_from($this, $coll) {
        var $scala$collection$immutable$LazyList$$newLL_state;
        if ($coll instanceof sci_LazyList)
            return $coll;
        if (!$coll.$knownSize())
            return sci_LazyList$_empty($this);
        $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$from$lambda$_25_0;
        $scala$collection$immutable$LazyList$$newLL_state.$_0182 = $coll;
        return sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state);
    }
    function sci_LazyList$_empty($this) {
        sci_LazyList$_$callClinit();
        return sci_LazyList$__empty;
    }
    function sci_LazyList$_scala$collection$immutable$LazyList$$stateFromIterator($this, $it) {
        var $scala$collection$immutable$LazyList$$sCons_hd, $scala$collection$immutable$LazyList$$newLL_state;
        if (!$it.$hasNext())
            return sci_LazyList$State$Empty$_MODULE$;
        $scala$collection$immutable$LazyList$$sCons_hd = $it.$next();
        $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIterator$lambda$_28_0;
        $scala$collection$immutable$LazyList$$newLL_state.$_0183 = $it;
        return sci_LazyList$State$Cons__init_($scala$collection$immutable$LazyList$$sCons_hd, sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state));
    }
    function sci_LazyList$_from0($this, $start, $step) {
        var $scala$collection$immutable$LazyList$$newLL_state;
        $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$from$lambda$_32_0;
        $scala$collection$immutable$LazyList$$newLL_state.$_0184 = $start;
        $scala$collection$immutable$LazyList$$newLL_state.$_133 = $step;
        return sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state);
    }
    function sci_LazyList$_newBuilder($this) {
        var var$1, var$2, var$3;
        var$1 = new sci_LazyList$LazyBuilder;
        var$2 = new sci_LazyList$LazyBuilder$DeferredState;
        var$3 = new sci_LazyList$LazyBuilder$clear$lambda$_9_0;
        var$3.$_0185 = var$2;
        var$1.$list0 = sci_LazyList__init_(var$3);
        var$1.$next5 = var$2;
        return var$1;
    }
    function sci_LazyList$_from1($this, $source) {
        return sci_LazyList$_from($this, $source);
    }
    function sci_LazyList$_$anonfun$filterImpl$1($restRef$1, $p$2, $isFlipped$1) {
        var $elem, $found, $rest, $scala$collection$immutable$LazyList$$filterImpl_restRef, $scala$collection$immutable$LazyList$$filterImpl_scala$collection$immutable$LazyList$$newLL_state;
        sci_LazyList$_$callClinit();
        $elem = null;
        $found = 0;
        $rest = $restRef$1.$elem5;
        while (!$found && !sci_LazyList_isEmpty($rest)) {
            $elem = sci_LazyList_head($rest);
            $found = sr_BoxesRunTime_unboxToBoolean($p$2.$apply($elem)) == $isFlipped$1 ? 0 : 1;
            $rest = sci_LazyList_tail($rest);
            $restRef$1.$elem5 = $rest;
        }
        if (!$found)
            return sci_LazyList$State$Empty$_MODULE$;
        $scala$collection$immutable$LazyList$$filterImpl_restRef = sr_ObjectRef__init_($rest);
        $scala$collection$immutable$LazyList$$filterImpl_scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$$anonfun$filterImpl$1$lambda$_48_0;
        $scala$collection$immutable$LazyList$$filterImpl_scala$collection$immutable$LazyList$$newLL_state.$_0186 = $scala$collection$immutable$LazyList$$filterImpl_restRef;
        $scala$collection$immutable$LazyList$$filterImpl_scala$collection$immutable$LazyList$$newLL_state.$_134 = $p$2;
        $scala$collection$immutable$LazyList$$filterImpl_scala$collection$immutable$LazyList$$newLL_state.$_219 = $isFlipped$1;
        return sci_LazyList$State$Cons__init_($elem, sci_LazyList__init_($scala$collection$immutable$LazyList$$filterImpl_scala$collection$immutable$LazyList$$newLL_state));
    }
    function sci_LazyList$_$anonfun$flatMapImpl$1($restRef$3, $f$3) {
        var $it, $itHasNext, $create_e, $rest, $scala$collection$immutable$LazyList$$newLL_state, $head;
        sci_LazyList$_$callClinit();
        $it = sr_ObjectRef__init_(null);
        $itHasNext = 0;
        $create_e = $restRef$3.$elem5;
        $rest = sr_ObjectRef__init_($create_e);
        while (!$itHasNext && !sci_LazyList_isEmpty($rest.$elem5)) {
            $scala$collection$immutable$LazyList$$newLL_state = ($f$3.$apply(sci_LazyList_head($rest.$elem5))).$iterator0();
            $it.$elem5 = $scala$collection$immutable$LazyList$$newLL_state;
            $itHasNext = $scala$collection$immutable$LazyList$$newLL_state.$hasNext();
            if ($itHasNext)
                continue;
            $scala$collection$immutable$LazyList$$newLL_state = sci_LazyList_tail($rest.$elem5);
            $rest.$elem5 = $scala$collection$immutable$LazyList$$newLL_state;
            $restRef$3.$elem5 = $scala$collection$immutable$LazyList$$newLL_state;
        }
        if (!$itHasNext)
            return sci_LazyList$State$Empty$_MODULE$;
        $head = $it.$elem5.$next();
        $scala$collection$immutable$LazyList$$newLL_state = sci_LazyList_tail($rest.$elem5);
        $rest.$elem5 = $scala$collection$immutable$LazyList$$newLL_state;
        $restRef$3.$elem5 = $scala$collection$immutable$LazyList$$newLL_state;
        $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$$anonfun$flatMapImpl$1$lambda$_52_0;
        $scala$collection$immutable$LazyList$$newLL_state.$_0187 = $it;
        $scala$collection$immutable$LazyList$$newLL_state.$_135 = $rest;
        $scala$collection$immutable$LazyList$$newLL_state.$_220 = $f$3;
        return sci_LazyList$State$Cons__init_($head, sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state));
    }
    function sci_LazyList$_$anonfun$stateFromIteratorConcatSuffix$1($it$4, $suffix$3) {
        var var$3, var$4;
        sci_LazyList$_$callClinit();
        if (!$it$4.$hasNext())
            $it$4 = $suffix$3.$apply2();
        else {
            var$3 = $it$4.$next();
            var$4 = new sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIteratorConcatSuffix$lambda$_27_0;
            var$4.$_0188 = $it$4;
            var$4.$_136 = $suffix$3;
            $it$4 = sci_LazyList$State$Cons__init_(var$3, sci_LazyList__init_(var$4));
        }
        return $it$4;
    }
    var sci_Vector$ = $rt_classWithoutFields();
    var sci_Vector$_MODULE$ = null;
    var sci_Vector$_scala$collection$immutable$Vector$$defaultApplyPreferredMaxLength = 0;
    var sci_Vector$_scala$collection$immutable$Vector$$emptyIterator = null;
    function sci_Vector$_$callClinit() {
        sci_Vector$_$callClinit = $rt_eraseClinit(sci_Vector$);
        sci_Vector$__clinit_();
    }
    function sci_Vector$__clinit_() {
        var var$1, var$2, var$3, $$je;
        var$1 = new sci_Vector$;
        sci_Vector$_$callClinit();
        sci_Vector$_MODULE$ = var$1;
        a: {
            try {
                var$2 = jl_Integer_parseInt0(jl_System_getProperty0($rt_s(482), $rt_s(483)));
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_SecurityException) {
                } else {
                    throw $$e;
                }
            }
            var$2 = 250;
        }
        sci_Vector$_scala$collection$immutable$Vector$$defaultApplyPreferredMaxLength = var$2;
        var$3 = new sci_NewVectorIterator;
        sci_Vector0$_$callClinit();
        sci_NewVectorIterator__init_0(var$3, sci_Vector0$_MODULE$, 0, 0);
        sci_Vector$_scala$collection$immutable$Vector$$emptyIterator = var$3;
    }
    function sci_Vector$_apply($this, $elems) {
        return $this.$from0($elems);
    }
    function sci_Vector$_empty($this) {
        sci_Vector0$_$callClinit();
        return sci_Vector0$_MODULE$;
    }
    function sci_Vector$_from($this, $it) {
        var $knownSize, var$3, var$4, var$5, $a1;
        if ($it instanceof sci_Vector)
            return $it;
        $knownSize = $it.$knownSize();
        var$3 = $rt_compare($knownSize, 0);
        if (!var$3) {
            sci_Vector0$_$callClinit();
            return sci_Vector0$_MODULE$;
        }
        if (var$3 > 0 && $knownSize <= 32) {
            a: {
                if ($it instanceof sci_ArraySeq$ofRef) {
                    var$4 = $it;
                    var$5 = (sci_ArraySeq$ofRef_elemTag(var$4)).$runtimeClass();
                    if (var$5 !== null && jl_Object_equals(var$5, $rt_cls(jl_Object))) {
                        $a1 = var$4.$unsafeArray0;
                        break a;
                    }
                }
                if (!$rt_isInstance($it, sci_Iterable)) {
                    $a1 = $rt_createArray(jl_Object, $knownSize);
                    ($it.$iterator0()).$copyToArray1($a1);
                } else {
                    $it = $it;
                    $a1 = $rt_createArray(jl_Object, $knownSize);
                    sc_IterableOnceOps_copyToArray$($it, $a1);
                }
            }
            $it = new sci_Vector1;
            sci_VectorImpl__init_($it, $a1);
            return $it;
        }
        return sci_VectorBuilder_result(sci_VectorBuilder_addAll(sci_VectorBuilder__init_(), $it));
    }
    function sci_Vector$_newBuilder($this) {
        return sci_VectorBuilder__init_();
    }
    function sci_Vector$_from0($this, $source) {
        return sci_Vector$_from($this, $source);
    }
    function sci_Vector$_empty0($this) {
        return sci_Vector$_empty($this);
    }
    var scm_StringBuilder$ = $rt_classWithoutFields();
    var scm_StringBuilder$_MODULE$ = null;
    function scm_StringBuilder$__clinit_() {
        scm_StringBuilder$_MODULE$ = new scm_StringBuilder$;
    }
    var sci_Range$ = $rt_classWithoutFields();
    var sci_Range$_MODULE$ = null;
    function sci_Range$__clinit_() {
        sci_Range$_MODULE$ = new sci_Range$;
    }
    var sm_BigDecimal$ = $rt_classWithoutFields();
    var sm_BigDecimal$_MODULE$ = null;
    var sm_BigDecimal$_minCached = 0;
    var sm_BigDecimal$_maxCached = 0;
    var sm_BigDecimal$_defaultMathContext = null;
    function sm_BigDecimal$_$callClinit() {
        sm_BigDecimal$_$callClinit = $rt_eraseClinit(sm_BigDecimal$);
        sm_BigDecimal$__clinit_();
    }
    function sm_BigDecimal$__clinit_() {
        var var$1;
        var$1 = new sm_BigDecimal$;
        sm_BigDecimal$_$callClinit();
        sm_BigDecimal$_MODULE$ = var$1;
        sm_BigDecimal$_minCached = (-512);
        sm_BigDecimal$_maxCached = 512;
        jm_MathContext_$callClinit();
        sm_BigDecimal$_defaultMathContext = jm_MathContext_DECIMAL128;
    }
    var sm_BigInt$ = $rt_classWithoutFields();
    var sm_BigInt$_MODULE$ = null;
    var sm_BigInt$_scala$math$BigInt$$longMinValueBigInteger = null;
    var sm_BigInt$_longMinValue = null;
    var sm_BigInt$_minCached = 0;
    var sm_BigInt$_maxCached = 0;
    var sm_BigInt$_cache = null;
    var sm_BigInt$_scala$math$BigInt$$minusOne = null;
    function sm_BigInt$_$callClinit() {
        sm_BigInt$_$callClinit = $rt_eraseClinit(sm_BigInt$);
        sm_BigInt$__clinit_();
    }
    function sm_BigInt$__clinit_() {
        var var$1, var$2;
        var$1 = new sm_BigInt$;
        sm_BigInt$_$callClinit();
        sm_BigInt$_MODULE$ = var$1;
        var$1 = jm_BigInteger_valueOf(Long_create(0, 2147483648));
        sm_BigInt$_scala$math$BigInt$$longMinValueBigInteger = var$1;
        var$2 = new sm_BigInt;
        var$2.$_bigInteger = var$1;
        var$2.$_long = Long_create(0, 2147483648);
        sm_BigInt$_longMinValue = var$2;
        sm_BigInt$_minCached = (-1024);
        sm_BigInt$_maxCached = 1024;
        sm_BigInt$_cache = $rt_createArray(sm_BigInt, 2049);
        sm_BigInt$_scala$math$BigInt$$minusOne = jm_BigInteger_valueOf(Long_fromInt(-1));
    }
    var sm_LowPriorityEquiv = $rt_classWithoutFields(0);
    var sm_Equiv$ = $rt_classWithoutFields();
    var sm_Equiv$_MODULE$ = null;
    function sm_Equiv$__clinit_() {
        sm_Equiv$_MODULE$ = new sm_Equiv$;
    }
    var sm_Fractional$ = $rt_classWithoutFields();
    var sm_Fractional$_MODULE$ = null;
    function sm_Fractional$__clinit_() {
        sm_Fractional$_MODULE$ = new sm_Fractional$;
    }
    var sm_Integral$ = $rt_classWithoutFields();
    var sm_Integral$_MODULE$ = null;
    function sm_Integral$__clinit_() {
        sm_Integral$_MODULE$ = new sm_Integral$;
    }
    var sm_Numeric$ = $rt_classWithoutFields();
    var sm_Numeric$_MODULE$ = null;
    function sm_Numeric$__clinit_() {
        sm_Numeric$_MODULE$ = new sm_Numeric$;
    }
    var sm_Ordered$ = $rt_classWithoutFields();
    var sm_Ordered$_MODULE$ = null;
    function sm_Ordered$__clinit_() {
        sm_Ordered$_MODULE$ = new sm_Ordered$;
    }
    var sm_LowPriorityOrderingImplicits = $rt_classWithoutFields(0);
    var sm_Ordering$ = $rt_classWithoutFields();
    var sm_Ordering$_MODULE$ = null;
    function sm_Ordering$__clinit_() {
        sm_Ordering$_MODULE$ = new sm_Ordering$;
    }
    var su_Either$ = $rt_classWithoutFields();
    var su_Either$_MODULE$ = null;
    function su_Either$__clinit_() {
        su_Either$_MODULE$ = new su_Either$;
    }
    var su_Right$ = $rt_classWithoutFields();
    var su_Right$_MODULE$ = null;
    function su_Right$__clinit_() {
        su_Right$_MODULE$ = new su_Right$;
    }
    function su_Right$_apply($this, $value) {
        var var$2;
        var$2 = new su_Right;
        var$2.$value10 = $value;
        return var$2;
    }
    var sci_LazyList$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    function sci_LazyList$$_clinit_$lambda$_0_0_apply(var$0) {
        sci_LazyList$_$callClinit();
        return sci_LazyList$State$Empty$_MODULE$;
    }
    function sci_LazyList() {
        var a = this; sci_AbstractSeq.call(a);
        a.$scala$collection$immutable$LazyList$$state = null;
        a.$lazyState = null;
        a.$scala$collection$immutable$LazyList$$stateEvaluated = 0;
        a.$midEvaluation = 0;
        a.$bitmap$00 = 0;
    }
    function sci_LazyList__init_(var_0) {
        var var_1 = new sci_LazyList();
        sci_LazyList__init_0(var_1, var_0);
        return var_1;
    }
    function sci_LazyList_stringPrefix($this) {
        return $rt_s(32);
    }
    function sci_LazyList_scala$collection$LinearSeqOps$$super$sameElements($this, $that) {
        return sc_SeqOps_sameElements$($this, $that);
    }
    function sci_LazyList_headOption($this) {
        return sc_LinearSeqOps_headOption$($this);
    }
    function sci_LazyList_length($this) {
        return sc_LinearSeqOps_length$($this);
    }
    function sci_LazyList_last($this) {
        return sc_LinearSeqOps_last$($this);
    }
    function sci_LazyList_lengthCompare($this, $len) {
        return sc_LinearSeqOps_lengthCompare$($this, $len);
    }
    function sci_LazyList_apply($this, $n) {
        return sc_LinearSeqOps_apply$($this, $n);
    }
    function sci_LazyList_forall($this, $p) {
        return sc_LinearSeqOps_forall$($this, $p);
    }
    function sci_LazyList_exists($this, $p) {
        return sc_LinearSeqOps_exists$($this, $p);
    }
    function sci_LazyList_contains($this, $elem) {
        return sc_LinearSeqOps_contains$($this, $elem);
    }
    function sci_LazyList_sameElements($this, $that) {
        return sc_LinearSeqOps_sameElements$($this, $that);
    }
    function sci_LazyList_indexWhere($this, $p, $from) {
        return sc_LinearSeqOps_indexWhere$($this, $p, $from);
    }
    function sci_LazyList_scala$collection$immutable$LazyList$$state($this) {
        var var$1, $$je;
        if ($this.$bitmap$00)
            return $this.$scala$collection$immutable$LazyList$$state;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$00)
                    break a;
                if ($this.$midEvaluation)
                    $rt_throw(jl_RuntimeException__init_($rt_s(484)));
                $this.$midEvaluation = 1;
                b: {
                    try {
                        var$1 = $this.$lazyState.$apply2();
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        var$1 = $$je;

                    }
                    $this.$midEvaluation = 0;
                    $rt_throw(var$1);
                }
                $this.$midEvaluation = 0;
                $this.$scala$collection$immutable$LazyList$$stateEvaluated = 1;
                $this.$lazyState = null;
                $this.$scala$collection$immutable$LazyList$$state = var$1;
                $this.$bitmap$00 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$scala$collection$immutable$LazyList$$state;
    }
    function sci_LazyList_isEmpty($this) {
        if (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$)
            return 0;
        return 1;
    }
    function sci_LazyList_knownSize($this) {
        if (!($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0))
            return (-1);
        return 0;
    }
    function sci_LazyList_head($this) {
        return (sci_LazyList_scala$collection$immutable$LazyList$$state($this)).$head();
    }
    function sci_LazyList_tail($this) {
        return (sci_LazyList_scala$collection$immutable$LazyList$$state($this)).$tail4();
    }
    function sci_LazyList_force($this) {
        var var$1, var$2;
        if (!sci_LazyList_isEmpty($this)) {
            var$1 = sci_LazyList_tail($this);
            var$2 = $this;
        } else {
            var$1 = $this;
            var$2 = $this;
        }
        while (var$2 !== var$1) {
            if (sci_LazyList_isEmpty(var$1))
                return $this;
            var$1 = sci_LazyList_tail(var$1);
            if (sci_LazyList_isEmpty(var$1))
                return $this;
            var$1 = sci_LazyList_tail(var$1);
            if (var$1 === var$2)
                return $this;
            var$2 = sci_LazyList_tail(var$2);
        }
        return $this;
    }
    function sci_LazyList_iterator($this) {
        var var$1;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0)
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new sci_LazyList$LazyIterator;
        var$1.$lazyList = $this;
        return var$1;
    }
    function sci_LazyList_foreach($this, $f) {
        while (!sci_LazyList_isEmpty($this)) {
            $f.$apply(sci_LazyList_head($this));
            $this = sci_LazyList_tail($this);
        }
    }
    function sci_LazyList_foldLeft($this, $z, $op) {
        var $this_0;
        while (!sci_LazyList_isEmpty($this)) {
            $this_0 = sci_LazyList_tail($this);
            $z = $op.$apply0($z, sci_LazyList_head($this));
            $this = $this_0;
        }
        return $z;
    }
    function sci_LazyList_className($this) {
        return $rt_s(485);
    }
    function sci_LazyList_reduceLeft($this, $f) {
        var $reducedRes, $left;
        if (sci_LazyList_isEmpty($this)) {
            $f = new jl_UnsupportedOperationException;
            jl_Throwable__init_($f, $rt_s(23));
            $rt_throw($f);
        }
        $reducedRes = sci_LazyList_head($this);
        $left = sci_LazyList_tail($this);
        while (!sci_LazyList_isEmpty($left)) {
            $reducedRes = $f.$apply0($reducedRes, sci_LazyList_head($left));
            $left = sci_LazyList_tail($left);
        }
        return $reducedRes;
    }
    function sci_LazyList_collectFirst($this, $pf) {
        var var$2, $res;
        while (!sci_LazyList_isEmpty($this)) {
            var$2 = sci_LazyList_head($this);
            sci_LazyList$_$callClinit();
            $res = $pf.$applyOrElse(var$2, sci_LazyList$_scala$collection$immutable$LazyList$$anyToMarker0(sci_LazyList$_MODULE$));
            if ($res !== sr_Statics_pfMarker)
                return s_Some__init_($res);
            $this = sci_LazyList_tail($this);
        }
        return s_None$_MODULE$;
    }
    function sci_LazyList_find($this, $p) {
        var $elem;
        while (!sci_LazyList_isEmpty($this)) {
            $elem = sci_LazyList_head($this);
            if (sr_BoxesRunTime_unboxToBoolean($p.$apply($elem)))
                return s_Some__init_($elem);
            $this = sci_LazyList_tail($this);
        }
        return s_None$_MODULE$;
    }
    function sci_LazyList_zip($this, $that) {
        var var$2, $scala$collection$immutable$LazyList$$newLL_state;
        var$2 = $this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0;
        if (!var$2 && $that.$knownSize()) {
            $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$zip$lambda$_77_0;
            $scala$collection$immutable$LazyList$$newLL_state.$_0189 = $this;
            $scala$collection$immutable$LazyList$$newLL_state.$_137 = $that;
            return sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state);
        }
        sci_LazyList$_$callClinit();
        return sci_LazyList$_empty(sci_LazyList$_MODULE$);
    }
    function sci_LazyList_zipState($this, $it) {
        var $scala$collection$immutable$LazyList$$sCons_hd, $scala$collection$immutable$LazyList$$newLL_state;
        if (!sci_LazyList_isEmpty($this) && $it.$hasNext()) {
            $scala$collection$immutable$LazyList$$sCons_hd = s_Tuple2__init_(sci_LazyList_head($this), $it.$next());
            $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$zipState$lambda$_78_0;
            $scala$collection$immutable$LazyList$$newLL_state.$_0190 = $this;
            $scala$collection$immutable$LazyList$$newLL_state.$_138 = $it;
            return sci_LazyList$State$Cons__init_($scala$collection$immutable$LazyList$$sCons_hd, sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state));
        }
        return sci_LazyList$State$Empty$_MODULE$;
    }
    function sci_LazyList_drop($this, $n) {
        var var$2, var$3, var$4;
        if ($n <= 0)
            return $this;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            return sci_LazyList$_empty(sci_LazyList$_MODULE$);
        }
        sci_LazyList$_$callClinit();
        var$2 = sr_ObjectRef__init_($this);
        var$3 = new sr_IntRef;
        var$3.$elem6 = $n;
        var$4 = new sci_LazyList$$scala$collection$immutable$LazyList$$dropImpl$lambda$_21_0;
        var$4.$_0191 = var$2;
        var$4.$_139 = var$3;
        return sci_LazyList__init_(var$4);
    }
    function sci_LazyList_dropRightState($this, $scout) {
        var $scala$collection$immutable$LazyList$$sCons_hd, $scala$collection$immutable$LazyList$$newLL_state;
        if (sci_LazyList_isEmpty($scout))
            return sci_LazyList$State$Empty$_MODULE$;
        $scala$collection$immutable$LazyList$$sCons_hd = sci_LazyList_head($this);
        $scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$dropRightState$lambda$_88_0;
        $scala$collection$immutable$LazyList$$newLL_state.$_0192 = $this;
        $scala$collection$immutable$LazyList$$newLL_state.$_140 = $scout;
        return sci_LazyList$State$Cons__init_($scala$collection$immutable$LazyList$$sCons_hd, sci_LazyList__init_($scala$collection$immutable$LazyList$$newLL_state));
    }
    function sci_LazyList_sliding($this, $size, $step) {
        var var$3, var$4, var$5;
        if (!($size > 0 && $step > 0 ? 1 : 0)) {
            var$3 = new jl_IllegalArgumentException;
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$4, 20);
            jl_AbstractStringBuilder_append1(var$4, $rt_s(486));
            var$5 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$5, 42);
            jl_AbstractStringBuilder_append1(var$5, $rt_s(487));
            var$5 = jl_StringBuilder_append0(var$5, $size);
            jl_AbstractStringBuilder_append1(var$5, $rt_s(488));
            var$5 = jl_StringBuilder_append0(var$5, $step);
            jl_AbstractStringBuilder_append1(var$5, $rt_s(489));
            jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$4, jl_AbstractStringBuilder_toString(var$5))));
            $rt_throw(var$3);
        }
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0)
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$3 = new sci_LazyList$SlidingIterator;
        var$3.$lazyList0 = $this;
        var$3.$size5 = $size;
        var$3.$step2 = $step;
        var$3.$minLen = jl_Math_max($size - $step | 0, 0);
        var$3.$first1 = 1;
        return var$3;
    }
    function sci_LazyList_addString($this, $sb, $start, $sep, $end) {
        sci_LazyList_force($this);
        sci_LazyList_addStringNoForce($this, $sb.$underlying, $start, $sep, $end);
        return $sb;
    }
    function sci_LazyList_addStringNoForce($this, $b, $start, $sep, $end) {
        var var$5, var$6, $k, var$8;
        jl_AbstractStringBuilder_append1($b, $start);
        if (!$this.$scala$collection$immutable$LazyList$$stateEvaluated)
            jl_AbstractStringBuilder_append1($b, $rt_s(490));
        else if (!sci_LazyList_isEmpty($this)) {
            a: {
                jl_StringBuilder_append($b, sci_LazyList_head($this));
                var$5 = sci_LazyList_tail($this);
                if ($this === var$5)
                    var$6 = $this;
                else {
                    if (var$5 === null)
                        $rt_throw(null);
                    if (var$5.$scala$collection$immutable$LazyList$$stateEvaluated && sci_LazyList_scala$collection$immutable$LazyList$$state($this) === sci_LazyList_scala$collection$immutable$LazyList$$state(var$5))
                        var$6 = $this;
                    else if (!(var$5.$scala$collection$immutable$LazyList$$stateEvaluated && !sci_LazyList_isEmpty(var$5) ? 1 : 0))
                        var$6 = var$5;
                    else {
                        $start = sci_LazyList_tail(var$5);
                        while (true) {
                            if (var$5 === $start) {
                                var$6 = var$5;
                                var$5 = $start;
                                break a;
                            }
                            if ($start === null)
                                $rt_throw(null);
                            if (!($start.$scala$collection$immutable$LazyList$$stateEvaluated && !sci_LazyList_isEmpty($start) ? 1 : 0)) {
                                var$6 = var$5;
                                var$5 = $start;
                                break a;
                            }
                            if (sci_LazyList_scala$collection$immutable$LazyList$$state(var$5) === sci_LazyList_scala$collection$immutable$LazyList$$state($start)) {
                                var$6 = var$5;
                                var$5 = $start;
                                break a;
                            }
                            jl_AbstractStringBuilder_append1($b, $sep);
                            jl_StringBuilder_append($b, sci_LazyList_head(var$5));
                            var$5 = sci_LazyList_tail(var$5);
                            $start = sci_LazyList_tail($start);
                            if ($start === null)
                                break;
                            if (!($start.$scala$collection$immutable$LazyList$$stateEvaluated && !sci_LazyList_isEmpty($start) ? 1 : 0))
                                continue;
                            $start = sci_LazyList_tail($start);
                        }
                        $rt_throw(null);
                    }
                }
            }
            if (var$5 === null)
                $rt_throw(null);
            if (!(var$5.$scala$collection$immutable$LazyList$$stateEvaluated && !sci_LazyList_isEmpty(var$5) ? 1 : 0)) {
                while (var$6 !== var$5) {
                    jl_AbstractStringBuilder_append1($b, $sep);
                    jl_StringBuilder_append($b, sci_LazyList_head(var$6));
                    var$6 = sci_LazyList_tail(var$6);
                }
                if (var$6 === null)
                    $rt_throw(null);
                if (!var$6.$scala$collection$immutable$LazyList$$stateEvaluated) {
                    jl_AbstractStringBuilder_append1($b, $sep);
                    jl_AbstractStringBuilder_append1($b, $rt_s(490));
                }
            } else {
                $k = 0;
                while (!($this !== var$5 && sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList_scala$collection$immutable$LazyList$$state(var$5) ? 0 : 1)) {
                    $this = sci_LazyList_tail($this);
                    var$5 = sci_LazyList_tail(var$5);
                    $k = $k + 1 | 0;
                }
                var$8 = var$6 !== var$5 && sci_LazyList_scala$collection$immutable$LazyList$$state(var$6) !== sci_LazyList_scala$collection$immutable$LazyList$$state(var$5) ? 0 : 1;
                if (var$8 && $k > 0) {
                    jl_AbstractStringBuilder_append1($b, $sep);
                    jl_StringBuilder_append($b, sci_LazyList_head(var$6));
                    var$6 = sci_LazyList_tail(var$6);
                }
                while (!(var$6 !== var$5 && sci_LazyList_scala$collection$immutable$LazyList$$state(var$6) !== sci_LazyList_scala$collection$immutable$LazyList$$state(var$5) ? 0 : 1)) {
                    jl_AbstractStringBuilder_append1($b, $sep);
                    jl_StringBuilder_append($b, sci_LazyList_head(var$6));
                    var$6 = sci_LazyList_tail(var$6);
                }
                jl_AbstractStringBuilder_append1($b, $sep);
                jl_AbstractStringBuilder_append1($b, $rt_s(491));
            }
        }
        jl_AbstractStringBuilder_append1($b, $end);
        return $b;
    }
    function sci_LazyList_toString($this) {
        return jl_AbstractStringBuilder_toString(sci_LazyList_addStringNoForce($this, jl_StringBuilder__init_3($rt_s(485)), $rt_s(24), $rt_s(16), $rt_s(25)));
    }
    function sci_LazyList_apply0($this, $v1) {
        return sc_LinearSeqOps_apply$($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_LazyList_intersect($this, $that) {
        if (!($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0))
            $that = sc_SeqOps_intersect$($this, $that);
        else {
            sci_LazyList$_$callClinit();
            $that = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        }
        return $that;
    }
    function sci_LazyList_takeWhile($this, $p) {
        var var$2;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            $p = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$2 = new sci_LazyList$takeWhile$lambda$_91_0;
            var$2.$_0193 = $this;
            var$2.$_141 = $p;
            $p = sci_LazyList__init_(var$2);
        }
        return $p;
    }
    function sci_LazyList_dropRight($this, $n) {
        var var$2;
        if ($n > 0) {
            if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
                sci_LazyList$_$callClinit();
                $this = sci_LazyList$_empty(sci_LazyList$_MODULE$);
            } else {
                var$2 = new sci_LazyList$dropRight$lambda$_87_0;
                var$2.$_0194 = $this;
                var$2.$_142 = $n;
                $this = sci_LazyList__init_(var$2);
            }
        }
        return $this;
    }
    function sci_LazyList_dropWhile($this, $p) {
        var var$2, var$3;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            $p = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$2 = sr_ObjectRef__init_($this);
            var$3 = new sci_LazyList$dropWhile$lambda$_86_0;
            var$3.$_0195 = var$2;
            var$3.$_143 = $p;
            $p = sci_LazyList__init_(var$3);
        }
        return $p;
    }
    function sci_LazyList_drop0($this, $n) {
        return sci_LazyList_drop($this, $n);
    }
    function sci_LazyList_zipWithIndex($this) {
        sci_LazyList$_$callClinit();
        return sci_LazyList_zip($this, sci_LazyList$_from0(sci_LazyList$_MODULE$, 0, 1));
    }
    function sci_LazyList_zip0($this, $that) {
        return sci_LazyList_zip($this, $that);
    }
    function sci_LazyList_flatten($this, $asIterable) {
        var var$2, var$3;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            $asIterable = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$2 = sr_ObjectRef__init_($this);
            var$3 = new sci_LazyList$flatten$lambda$_76_0;
            var$3.$_0196 = var$2;
            var$3.$_144 = $asIterable;
            $asIterable = sci_LazyList__init_(var$3);
        }
        return $asIterable;
    }
    function sci_LazyList_flatMap($this, $f) {
        var var$2, var$3;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            $f = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$2 = sr_ObjectRef__init_($this);
            var$3 = new sci_LazyList$flatMap$lambda$_75_0;
            var$3.$_0197 = var$2;
            var$3.$_145 = $f;
            $f = sci_LazyList__init_(var$3);
        }
        return $f;
    }
    function sci_LazyList_collect($this, $pf) {
        if (!($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0)) {
            sci_LazyList$_$callClinit();
            $pf = sci_LazyList$_scala$collection$immutable$LazyList$$collectImpl(sci_LazyList$_MODULE$, $this, $pf);
        } else {
            sci_LazyList$_$callClinit();
            $pf = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        }
        return $pf;
    }
    function sci_LazyList_map($this, $f) {
        var var$2;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            $f = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$2 = new sci_LazyList$map$lambda$_69_0;
            var$2.$_0198 = $this;
            var$2.$_146 = $f;
            $f = sci_LazyList__init_(var$2);
        }
        return $f;
    }
    function sci_LazyList_prepended($this, $elem) {
        var var$2;
        var$2 = new sci_LazyList$prepended$lambda$_67_0;
        var$2.$_0199 = $this;
        var$2.$_147 = $elem;
        return sci_LazyList__init_(var$2);
    }
    function sci_LazyList_filterNot($this, $pred) {
        var var$2, var$3;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            $pred = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$2 = sr_ObjectRef__init_($this);
            var$3 = new sci_LazyList$filterNot$lambda$_65_0;
            var$3.$_0200 = var$2;
            var$3.$_148 = $pred;
            var$3.$_221 = 1;
            $pred = sci_LazyList__init_(var$3);
        }
        return $pred;
    }
    function sci_LazyList_filter($this, $pred) {
        var var$2, var$3;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            $pred = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$2 = sr_ObjectRef__init_($this);
            var$3 = new sci_LazyList$filter$lambda$_64_0;
            var$3.$_0201 = var$2;
            var$3.$_149 = $pred;
            var$3.$_222 = 0;
            $pred = sci_LazyList__init_(var$3);
        }
        return $pred;
    }
    function sci_LazyList_appended($this, $elem) {
        var var$2, var$3;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            var$2 = new sci_LazyList$appended$lambda$_58_2;
            var$2.$_0202 = $elem;
            var$3 = sci_LazyList__init_(var$2);
        } else {
            var$2 = new sci_LazyList$appended$lambda$_58_0;
            var$2.$_0203 = $elem;
            $elem = new sci_LazyList$appended$lambda$_58_1;
            $elem.$_0204 = $this;
            $elem.$_150 = var$2;
            var$3 = sci_LazyList__init_($elem);
        }
        return var$3;
    }
    function sci_LazyList_appendedAll($this, $suffix) {
        var var$2;
        if ($this.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state($this) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
            sci_LazyList$_$callClinit();
            var$2 = sci_LazyList$_from(sci_LazyList$_MODULE$, $suffix);
        } else {
            var$2 = new sci_LazyList$appendedAll$lambda$_57_0;
            var$2.$_0205 = $suffix;
            $suffix = new sci_LazyList$appendedAll$lambda$_57_1;
            $suffix.$_0206 = $this;
            $suffix.$_151 = var$2;
            var$2 = sci_LazyList__init_($suffix);
        }
        return var$2;
    }
    function sci_LazyList_tail0($this) {
        return sci_LazyList_tail($this);
    }
    function sci_LazyList_iterableFactory($this) {
        sci_LazyList$_$callClinit();
        return sci_LazyList$_MODULE$;
    }
    function sci_LazyList_$anonfun$lazyAppendedAll$1($$this, $suffix$1) {
        var $scala$collection$immutable$LazyList$$sCons_hd, $lazyAppendedAll_this, $lazyAppendedAll_scala$collection$immutable$LazyList$$newLL_state;
        if (!sci_LazyList_isEmpty($$this)) {
            $scala$collection$immutable$LazyList$$sCons_hd = sci_LazyList_head($$this);
            $lazyAppendedAll_this = sci_LazyList_tail($$this);
            if ($lazyAppendedAll_this === null)
                $rt_throw(null);
            $lazyAppendedAll_scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$anonfun$lazyAppendedAll$1$lambda$_147_0;
            $lazyAppendedAll_scala$collection$immutable$LazyList$$newLL_state.$_0207 = $lazyAppendedAll_this;
            $lazyAppendedAll_scala$collection$immutable$LazyList$$newLL_state.$_152 = $suffix$1;
            return sci_LazyList$State$Cons__init_($scala$collection$immutable$LazyList$$sCons_hd, sci_LazyList__init_($lazyAppendedAll_scala$collection$immutable$LazyList$$newLL_state));
        }
        $$this = $suffix$1.$apply2();
        if ($$this instanceof sci_LazyList)
            return sci_LazyList_scala$collection$immutable$LazyList$$state($$this);
        if (!$$this.$knownSize())
            return sci_LazyList$State$Empty$_MODULE$;
        sci_LazyList$_$callClinit();
        return sci_LazyList$_scala$collection$immutable$LazyList$$stateFromIterator(sci_LazyList$_MODULE$, $$this.$iterator0());
    }
    function sci_LazyList_$anonfun$mapImpl$1($$this, $f$2) {
        var $scala$collection$immutable$LazyList$$sCons_hd, $mapImpl_this, $mapImpl_scala$collection$immutable$LazyList$$newLL_state;
        if (sci_LazyList_isEmpty($$this))
            return sci_LazyList$State$Empty$_MODULE$;
        $scala$collection$immutable$LazyList$$sCons_hd = $f$2.$apply(sci_LazyList_head($$this));
        $mapImpl_this = sci_LazyList_tail($$this);
        if ($mapImpl_this === null)
            $rt_throw(null);
        $mapImpl_scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$anonfun$mapImpl$1$lambda$_161_0;
        $mapImpl_scala$collection$immutable$LazyList$$newLL_state.$_0208 = $mapImpl_this;
        $mapImpl_scala$collection$immutable$LazyList$$newLL_state.$_153 = $f$2;
        return sci_LazyList$State$Cons__init_($scala$collection$immutable$LazyList$$sCons_hd, sci_LazyList__init_($mapImpl_scala$collection$immutable$LazyList$$newLL_state));
    }
    function sci_LazyList_$anonfun$takeImpl$1($$this, $n$2) {
        var $scala$collection$immutable$LazyList$$sCons_hd, $scala$collection$immutable$LazyList$$sCons_tl, var$5;
        if (sci_LazyList_isEmpty($$this))
            return sci_LazyList$State$Empty$_MODULE$;
        $scala$collection$immutable$LazyList$$sCons_hd = sci_LazyList_head($$this);
        $$this = sci_LazyList_tail($$this);
        $n$2 = $n$2 - 1 | 0;
        if ($n$2 <= 0) {
            sci_LazyList$_$callClinit();
            $scala$collection$immutable$LazyList$$sCons_tl = sci_LazyList$_empty(sci_LazyList$_MODULE$);
        } else {
            var$5 = new sci_LazyList$takeImpl$lambda$_90_0;
            var$5.$_0209 = $$this;
            var$5.$_154 = $n$2;
            $scala$collection$immutable$LazyList$$sCons_tl = sci_LazyList__init_(var$5);
        }
        return sci_LazyList$State$Cons__init_($scala$collection$immutable$LazyList$$sCons_hd, $scala$collection$immutable$LazyList$$sCons_tl);
    }
    function sci_LazyList_$anonfun$takeWhileImpl$1($$this, $p$1) {
        var $scala$collection$immutable$LazyList$$sCons_hd, $takeWhileImpl_this, $takeWhileImpl_scala$collection$immutable$LazyList$$newLL_state;
        if (!sci_LazyList_isEmpty($$this) && sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply($p$1, sci_LazyList_head($$this)))) {
            $scala$collection$immutable$LazyList$$sCons_hd = sci_LazyList_head($$this);
            $takeWhileImpl_this = sci_LazyList_tail($$this);
            if ($takeWhileImpl_this === null)
                $rt_throw(null);
            $takeWhileImpl_scala$collection$immutable$LazyList$$newLL_state = new sci_LazyList$$anonfun$takeWhileImpl$1$lambda$_179_0;
            $takeWhileImpl_scala$collection$immutable$LazyList$$newLL_state.$_0210 = $takeWhileImpl_this;
            $takeWhileImpl_scala$collection$immutable$LazyList$$newLL_state.$_155 = $p$1;
            return sci_LazyList$State$Cons__init_($scala$collection$immutable$LazyList$$sCons_hd, sci_LazyList__init_($takeWhileImpl_scala$collection$immutable$LazyList$$newLL_state));
        }
        return sci_LazyList$State$Empty$_MODULE$;
    }
    function sci_LazyList__init_0($this, $lazyState) {
        $this.$lazyState = $lazyState;
        $this.$scala$collection$immutable$LazyList$$stateEvaluated = 0;
        $this.$midEvaluation = 0;
    }
    var sci_LazyList$$_clinit_$lambda$_0_1 = $rt_classWithoutFields();
    function sci_LazyList$$_clinit_$lambda$_0_1_apply(var$0, var$1) {
        sci_LazyList$_$callClinit();
        return sr_Statics_pfMarker;
    }
    function sci_NewVectorIterator() {
        var a = this; jl_Object.call(a);
        a.$v = null;
        a.$totalLength = 0;
        a.$sliceCount = 0;
        a.$a1 = null;
        a.$a2 = null;
        a.$a3 = null;
        a.$a4 = null;
        a.$a5 = null;
        a.$a6 = null;
        a.$a1len = 0;
        a.$scala$collection$immutable$NewVectorIterator$$i1 = 0;
        a.$oldPos = 0;
        a.$scala$collection$immutable$NewVectorIterator$$len1 = 0;
        a.$sliceIdx = 0;
        a.$sliceDim = 0;
        a.$sliceStart = 0;
        a.$sliceEnd = 0;
    }
    function sci_NewVectorIterator__init_(var_0, var_1, var_2) {
        var var_3 = new sci_NewVectorIterator();
        sci_NewVectorIterator__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function sci_NewVectorIterator_iterator($this) {
        return $this;
    }
    function sci_NewVectorIterator_grouped($this, $size) {
        return sc_Iterator_grouped$($this, $size);
    }
    function sci_NewVectorIterator_sliding($this, $size, $step) {
        return sc_Iterator_sliding$($this, $size, $step);
    }
    function sci_NewVectorIterator_indexWhere($this, $p, $from) {
        return sc_Iterator_indexWhere$($this, $p, $from);
    }
    function sci_NewVectorIterator_isEmpty($this) {
        return sc_Iterator_isEmpty$($this);
    }
    function sci_NewVectorIterator_filter($this, $p) {
        return sc_Iterator_filter$($this, $p);
    }
    function sci_NewVectorIterator_filterImpl($this, $p, $isFlipped) {
        return sc_Iterator_filterImpl$($this, $p, $isFlipped);
    }
    function sci_NewVectorIterator_distinctBy($this, $f) {
        return sc_Iterator_distinctBy$($this, $f);
    }
    function sci_NewVectorIterator_map($this, $f) {
        return sc_Iterator_map$($this, $f);
    }
    function sci_NewVectorIterator_flatMap($this, $f) {
        return sc_Iterator_flatMap$($this, $f);
    }
    function sci_NewVectorIterator_concat($this, $xs) {
        return sc_Iterator_concat$($this, $xs);
    }
    function sci_NewVectorIterator_takeWhile($this, $p) {
        return sc_Iterator_takeWhile$($this, $p);
    }
    function sci_NewVectorIterator_dropWhile($this, $p) {
        return sc_Iterator_dropWhile$($this, $p);
    }
    function sci_NewVectorIterator_sameElements($this, $that) {
        return sc_Iterator_sameElements$($this, $that);
    }
    function sci_NewVectorIterator_toString($this) {
        return $rt_s(466);
    }
    function sci_NewVectorIterator_foreach($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    }
    function sci_NewVectorIterator_exists($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    }
    function sci_NewVectorIterator_find($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    }
    function sci_NewVectorIterator_foldLeft($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    }
    function sci_NewVectorIterator_nonEmpty($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    }
    function sci_NewVectorIterator_size($this) {
        return sc_IterableOnceOps_size$($this);
    }
    function sci_NewVectorIterator_copyToArray0($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    }
    function sci_NewVectorIterator_copyToArray1($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    }
    function sci_NewVectorIterator_to($this, $factory) {
        return $factory.$fromSpecific($this);
    }
    function sci_NewVectorIterator_toList($this) {
        return sc_IterableOnceOps_toList$($this);
    }
    function sci_NewVectorIterator_toSeq($this) {
        return sc_IterableOnceOps_toSeq$($this);
    }
    function sci_NewVectorIterator_toArray($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    }
    function sci_NewVectorIterator_knownSize($this) {
        return $this.$scala$collection$immutable$NewVectorIterator$$len1 - $this.$scala$collection$immutable$NewVectorIterator$$i1 | 0;
    }
    function sci_NewVectorIterator_hasNext($this) {
        if ($this.$scala$collection$immutable$NewVectorIterator$$len1 <= $this.$scala$collection$immutable$NewVectorIterator$$i1)
            return 0;
        return 1;
    }
    function sci_NewVectorIterator_next($this) {
        var var$1, var$2, $r;
        if ($this.$scala$collection$immutable$NewVectorIterator$$i1 == $this.$a1len)
            sci_NewVectorIterator_advance($this);
        var$1 = $this.$a1.data;
        var$2 = $this.$scala$collection$immutable$NewVectorIterator$$i1;
        $r = var$1[var$2];
        $this.$scala$collection$immutable$NewVectorIterator$$i1 = var$2 + 1 | 0;
        return $r;
    }
    function sci_NewVectorIterator_advanceSlice($this) {
        var $vectorSliceDim_c, $slice, var$3, $vectorSliceDim_idx, var$5;
        if (!($this.$scala$collection$immutable$NewVectorIterator$$len1 <= $this.$scala$collection$immutable$NewVectorIterator$$i1 ? 0 : 1))
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $vectorSliceDim_c = $this.$sliceIdx + 1 | 0;
        $this.$sliceIdx = $vectorSliceDim_c;
        $slice = $this.$v.$vectorSlice($vectorSliceDim_c);
        while (true) {
            var$3 = $slice.data.length;
            if (var$3)
                break;
            $vectorSliceDim_c = $this.$sliceIdx + 1 | 0;
            $this.$sliceIdx = $vectorSliceDim_c;
            $slice = $this.$v.$vectorSlice($vectorSliceDim_c);
        }
        a: {
            $this.$sliceStart = $this.$sliceEnd;
            $vectorSliceDim_c = $this.$sliceCount;
            $vectorSliceDim_idx = $this.$sliceIdx;
            $vectorSliceDim_c = $vectorSliceDim_c / 2 | 0;
            var$5 = ($vectorSliceDim_c + 1 | 0) - jl_Math_abs($vectorSliceDim_idx - $vectorSliceDim_c | 0) | 0;
            $this.$sliceDim = var$5;
            switch (var$5) {
                case 1:
                    $this.$a1 = $slice;
                    break a;
                case 2:
                    $this.$a2 = $slice;
                    break a;
                case 3:
                    $this.$a3 = $slice;
                    break a;
                case 4:
                    $this.$a4 = $slice;
                    break a;
                case 5:
                    $this.$a5 = $slice;
                    break a;
                case 6:
                    $this.$a6 = $slice;
                    break a;
                default:
            }
            $rt_throw(s_MatchError__init_(jl_Integer_valueOf(var$5)));
        }
        $vectorSliceDim_c = $this.$sliceStart + $rt_imul(var$3, 1 << (5 * (var$5 - 1 | 0) | 0)) | 0;
        $this.$sliceEnd = $vectorSliceDim_c;
        $vectorSliceDim_idx = $this.$totalLength;
        if ($vectorSliceDim_c > $vectorSliceDim_idx)
            $this.$sliceEnd = $vectorSliceDim_idx;
        if (var$5 <= 1)
            return;
        $this.$oldPos = (1 << (5 * var$5 | 0)) - 1 | 0;
    }
    function sci_NewVectorIterator_advance($this) {
        var $pos, $io;
        $pos = ($this.$scala$collection$immutable$NewVectorIterator$$i1 - $this.$scala$collection$immutable$NewVectorIterator$$len1 | 0) + $this.$totalLength | 0;
        if ($pos == $this.$sliceEnd)
            sci_NewVectorIterator_advanceSlice($this);
        if ($this.$sliceDim > 1) {
            $io = $pos - $this.$sliceStart | 0;
            sci_NewVectorIterator_advanceA($this, $io, $this.$oldPos ^ $io);
            $this.$oldPos = $io;
        }
        $pos = $this.$scala$collection$immutable$NewVectorIterator$$len1 - $this.$scala$collection$immutable$NewVectorIterator$$i1 | 0;
        $this.$scala$collection$immutable$NewVectorIterator$$len1 = $pos;
        $this.$a1len = jl_Math_min($this.$a1.data.length, $pos);
        $this.$scala$collection$immutable$NewVectorIterator$$i1 = 0;
    }
    function sci_NewVectorIterator_advanceA($this, $io, $xor) {
        var var$3, var$4;
        if ($xor < 1024) {
            $this.$a1 = $this.$a2.data[$io >>> 5 & 31];
            return;
        }
        if ($xor < 32768) {
            var$3 = $this.$a3.data[$io >>> 10 & 31];
            var$4 = var$3.data;
            $this.$a2 = var$3;
            $this.$a1 = var$4[0];
            return;
        }
        if ($xor < 1048576) {
            var$3 = $this.$a4.data[$io >>> 15 & 31];
            var$4 = var$3.data;
            $this.$a3 = var$3;
            var$3 = var$4[0];
            var$4 = var$3.data;
            $this.$a2 = var$3;
            $this.$a1 = var$4[0];
            return;
        }
        if ($xor < 33554432) {
            var$3 = $this.$a5.data[$io >>> 20 & 31];
            var$4 = var$3.data;
            $this.$a4 = var$3;
            var$3 = var$4[0];
            var$4 = var$3.data;
            $this.$a3 = var$3;
            var$3 = var$4[0];
            var$4 = var$3.data;
            $this.$a2 = var$3;
            $this.$a1 = var$4[0];
            return;
        }
        var$3 = $this.$a6.data[$io >>> 25];
        var$4 = var$3.data;
        $this.$a5 = var$3;
        var$3 = var$4[0];
        var$4 = var$3.data;
        $this.$a4 = var$3;
        var$3 = var$4[0];
        var$4 = var$3.data;
        $this.$a3 = var$3;
        var$3 = var$4[0];
        var$4 = var$3.data;
        $this.$a2 = var$3;
        $this.$a1 = var$4[0];
    }
    function sci_NewVectorIterator_setA($this, $io, $xor) {
        var var$3, var$4;
        if ($xor < 1024) {
            $this.$a1 = $this.$a2.data[$io >>> 5 & 31];
            return;
        }
        if ($xor < 32768) {
            var$3 = $this.$a3.data[$io >>> 10 & 31];
            var$4 = var$3.data;
            $this.$a2 = var$3;
            $this.$a1 = var$4[$io >>> 5 & 31];
            return;
        }
        if ($xor < 1048576) {
            var$3 = $this.$a4.data[$io >>> 15 & 31];
            var$4 = var$3.data;
            $this.$a3 = var$3;
            var$3 = var$4[$io >>> 10 & 31];
            var$4 = var$3.data;
            $this.$a2 = var$3;
            $this.$a1 = var$4[$io >>> 5 & 31];
            return;
        }
        if ($xor < 33554432) {
            var$3 = $this.$a5.data[$io >>> 20 & 31];
            var$4 = var$3.data;
            $this.$a4 = var$3;
            var$3 = var$4[$io >>> 15 & 31];
            var$4 = var$3.data;
            $this.$a3 = var$3;
            var$3 = var$4[$io >>> 10 & 31];
            var$4 = var$3.data;
            $this.$a2 = var$3;
            $this.$a1 = var$4[$io >>> 5 & 31];
            return;
        }
        var$3 = $this.$a6.data[$io >>> 25];
        var$4 = var$3.data;
        $this.$a5 = var$3;
        var$3 = var$4[$io >>> 20 & 31];
        var$4 = var$3.data;
        $this.$a4 = var$3;
        var$3 = var$4[$io >>> 15 & 31];
        var$4 = var$3.data;
        $this.$a3 = var$3;
        var$3 = var$4[$io >>> 10 & 31];
        var$4 = var$3.data;
        $this.$a2 = var$3;
        $this.$a1 = var$4[$io >>> 5 & 31];
    }
    function sci_NewVectorIterator_drop($this, $n) {
        var $newpos, $io, $xor;
        if ($n > 0) {
            $newpos = $this.$scala$collection$immutable$NewVectorIterator$$i1 - $this.$scala$collection$immutable$NewVectorIterator$$len1 | 0;
            $io = $this.$totalLength;
            $newpos = jl_Math_min(($newpos + $io | 0) + $n | 0, $io);
            if ($newpos == $this.$totalLength) {
                $this.$scala$collection$immutable$NewVectorIterator$$i1 = 0;
                $this.$scala$collection$immutable$NewVectorIterator$$len1 = 0;
                $this.$a1len = 0;
            } else {
                while ($newpos >= $this.$sliceEnd) {
                    sci_NewVectorIterator_advanceSlice($this);
                }
                $io = $newpos - $this.$sliceStart | 0;
                if ($this.$sliceDim > 1) {
                    sci_NewVectorIterator_setA($this, $io, $this.$oldPos ^ $io);
                    $this.$oldPos = $io;
                }
                $xor = $this.$a1.data.length;
                $this.$a1len = $xor;
                $n = $io & 31;
                $this.$scala$collection$immutable$NewVectorIterator$$i1 = $n;
                $n = $n + ($this.$totalLength - $newpos | 0) | 0;
                $this.$scala$collection$immutable$NewVectorIterator$$len1 = $n;
                if ($xor > $n)
                    $this.$a1len = $n;
            }
        }
        return $this;
    }
    function sci_NewVectorIterator_take($this, $n) {
        var $trunc;
        $trunc = $this.$scala$collection$immutable$NewVectorIterator$$len1 - $this.$scala$collection$immutable$NewVectorIterator$$i1 | 0;
        if ($n < $trunc) {
            $trunc = $trunc - jl_Math_max(0, $n) | 0;
            $n = $this.$totalLength - $trunc | 0;
            $this.$totalLength = $n;
            $trunc = $this.$scala$collection$immutable$NewVectorIterator$$len1 - $trunc | 0;
            $this.$scala$collection$immutable$NewVectorIterator$$len1 = $trunc;
            if ($trunc < $this.$a1len)
                $this.$a1len = $trunc;
            if ($n < $this.$sliceEnd)
                $this.$sliceEnd = $n;
        }
        return $this;
    }
    function sci_NewVectorIterator_copyToArray($this, $xs, $start, $len) {
        var $xsLen, $total, $copied, $isBoxed, $count;
        $xsLen = jlr_Array_getLength($xs);
        $total = jl_Math_max(jl_Math_min(jl_Math_min($len, $this.$scala$collection$immutable$NewVectorIterator$$len1 - $this.$scala$collection$immutable$NewVectorIterator$$i1 | 0), $xsLen - $start | 0), 0);
        $copied = 0;
        $isBoxed = $rt_isInstance($xs, $rt_arraycls(jl_Object));
        while ($copied < $total) {
            if ($this.$scala$collection$immutable$NewVectorIterator$$i1 == $this.$a1len)
                sci_NewVectorIterator_advance($this);
            $count = jl_Math_min($total - $copied | 0, $this.$a1.data.length - $this.$scala$collection$immutable$NewVectorIterator$$i1 | 0);
            if ($isBoxed)
                jl_System_arraycopy($this.$a1, $this.$scala$collection$immutable$NewVectorIterator$$i1, $xs, $start + $copied | 0, $count);
            else
                s_Array$_copy(s_Array$_MODULE$, $this.$a1, $this.$scala$collection$immutable$NewVectorIterator$$i1, $xs, $start + $copied | 0, $count);
            $this.$scala$collection$immutable$NewVectorIterator$$i1 = $this.$scala$collection$immutable$NewVectorIterator$$i1 + $count | 0;
            $copied = $copied + $count | 0;
        }
        return $total;
    }
    function sci_NewVectorIterator__init_0($this, $v, $totalLength, $sliceCount) {
        var var$4, var$5;
        $this.$v = $v;
        $this.$totalLength = $totalLength;
        $this.$sliceCount = $sliceCount;
        var$4 = $v.$prefix10;
        var$5 = var$4.data;
        $this.$a1 = var$4;
        $sliceCount = var$5.length;
        $this.$a1len = $sliceCount;
        $this.$scala$collection$immutable$NewVectorIterator$$i1 = 0;
        $this.$oldPos = 0;
        $this.$scala$collection$immutable$NewVectorIterator$$len1 = $totalLength;
        $this.$sliceIdx = 0;
        $this.$sliceDim = 1;
        $this.$sliceStart = 0;
        $this.$sliceEnd = $sliceCount;
    }
    var sci_VectorImpl = $rt_classWithoutFields(sci_Vector);
    function sci_VectorImpl_slice($this, $from, $until) {
        var $lo, $hi;
        $lo = jl_Math_max($from, 0);
        $hi = jl_Math_min($until, sci_Vector_length($this));
        if ($hi <= $lo) {
            sci_Vector0$_$callClinit();
            return sci_Vector0$_MODULE$;
        }
        if (($hi - $lo | 0) == sci_Vector_length($this))
            return $this;
        return $this.$slice0($lo, $hi);
    }
    function sci_VectorImpl_slice0($this, $from, $until) {
        return sci_VectorImpl_slice($this, $from, $until);
    }
    function sci_VectorImpl__init_($this, $_prefix1) {
        $this.$prefix10 = $_prefix1;
    }
    function sci_BigVector() {
        var a = this; sci_VectorImpl.call(a);
        a.$suffix1 = null;
        a.$length00 = 0;
    }
    function sci_BigVector_suffix1($this) {
        return $this.$suffix1;
    }
    function sci_BigVector_length0($this) {
        return $this.$length00;
    }
    function sci_BigVector__init_($this, $_prefix1, $suffix1, $length0) {
        $this.$suffix1 = $suffix1;
        $this.$length00 = $length0;
        sci_VectorImpl__init_($this, $_prefix1);
    }
    var sci_Vector0$ = $rt_classWithoutFields(sci_BigVector);
    var sci_Vector0$_MODULE$ = null;
    function sci_Vector0$_$callClinit() {
        sci_Vector0$_$callClinit = $rt_eraseClinit(sci_Vector0$);
        sci_Vector0$__clinit_();
    }
    function sci_Vector0$__clinit_() {
        var var$1, var$2;
        var$1 = new sci_Vector0$;
        sci_Vector0$_$callClinit();
        var$2 = sci_VectorStatics$_empty1;
        sci_BigVector__init_(var$1, var$2, var$2, 0);
        sci_Vector0$_MODULE$ = var$1;
    }
    function sci_Vector0$_updated($this, $index, $elem) {
        $rt_throw(sci_Vector0$_ioob($this, $index));
    }
    function sci_Vector0$_appended($this, $elem) {
        var var$2, $wrap1_a;
        var$2 = new sci_Vector1;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        sci_VectorImpl__init_(var$2, $wrap1_a);
        return var$2;
    }
    function sci_Vector0$_prepended($this, $elem) {
        var var$2, $wrap1_a;
        var$2 = new sci_Vector1;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        sci_VectorImpl__init_(var$2, $wrap1_a);
        return var$2;
    }
    function sci_Vector0$_init($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(492));
        $rt_throw(var$1);
    }
    function sci_Vector0$_slice0($this, $lo, $hi) {
        return $this;
    }
    function sci_Vector0$_vectorSliceCount($this) {
        return 0;
    }
    function sci_Vector0$_vectorSlice($this, $idx) {
        return null;
    }
    function sci_Vector0$_equals($this, $o) {
        if ($this === $o)
            return 1;
        if (!($o instanceof sci_Vector))
            return sc_Seq_equals$($this, $o);
        return 0;
    }
    function sci_Vector0$_appendedAll0($this, $suffix, $k) {
        sci_Vector$_$callClinit();
        return sci_Vector$_from(sci_Vector$_MODULE$, $suffix);
    }
    function sci_Vector0$_ioob($this, $index) {
        var var$2, var$3;
        var$2 = new jl_IndexOutOfBoundsException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 32);
        var$3 = jl_StringBuilder_append0(var$3, $index);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(493));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        return var$2;
    }
    function sci_Vector0$_init0($this) {
        return sci_Vector0$_init($this);
    }
    function sci_Vector0$_tail($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(480));
        $rt_throw(var$1);
    }
    function sci_Vector0$_map($this, $f) {
        return $this;
    }
    function sci_Vector0$_prepended0($this, $elem) {
        return sci_Vector0$_prepended($this, $elem);
    }
    function sci_Vector0$_appended0($this, $elem) {
        return sci_Vector0$_appended($this, $elem);
    }
    function sci_Vector0$_updated0($this, $index, $elem) {
        $rt_throw(sci_Vector0$_ioob($this, $index));
    }
    function sci_Vector0$_apply($this, $v1) {
        $rt_throw(sci_Vector0$_ioob($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_Vector0$_apply0($this, $i) {
        $rt_throw(sci_Vector0$_ioob($this, $i));
    }
    function jm_MathContext() {
        var a = this; jl_Object.call(a);
        a.$precision = 0;
        a.$roundingMode = null;
    }
    var jm_MathContext_DECIMAL128 = null;
    var jm_MathContext_DECIMAL32 = null;
    var jm_MathContext_DECIMAL64 = null;
    var jm_MathContext_UNLIMITED = null;
    var jm_MathContext_chPrecision = null;
    var jm_MathContext_chRoundingMode = null;
    function jm_MathContext_$callClinit() {
        jm_MathContext_$callClinit = $rt_eraseClinit(jm_MathContext);
        jm_MathContext__clinit_();
    }
    function jm_MathContext__init_(var_0, var_1) {
        var var_2 = new jm_MathContext();
        jm_MathContext__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function jm_MathContext__init_0($this, $precision, $roundingMode) {
        var var$3;
        jm_MathContext_$callClinit();
        if ($precision < 0) {
            $roundingMode = new jl_IllegalArgumentException;
            jl_Throwable__init_($roundingMode, $rt_s(494));
            $rt_throw($roundingMode);
        }
        if ($roundingMode !== null) {
            $this.$precision = $precision;
            $this.$roundingMode = $roundingMode;
            return;
        }
        var$3 = new jl_NullPointerException;
        jl_Throwable__init_(var$3, $rt_s(495));
        $rt_throw(var$3);
    }
    function jm_MathContext__clinit_() {
        var var$1;
        var$1 = new jm_MathContext;
        jm_RoundingMode_$callClinit();
        jm_MathContext__init_0(var$1, 34, jm_RoundingMode_HALF_EVEN);
        jm_MathContext_DECIMAL128 = var$1;
        jm_MathContext_DECIMAL32 = jm_MathContext__init_(7, jm_RoundingMode_HALF_EVEN);
        jm_MathContext_DECIMAL64 = jm_MathContext__init_(16, jm_RoundingMode_HALF_EVEN);
        jm_MathContext_UNLIMITED = jm_MathContext__init_(0, jm_RoundingMode_HALF_UP);
        jm_MathContext_chPrecision = $rt_createCharArrayFromData([112, 114, 101, 99, 105, 115, 105, 111, 110, 61]);
        jm_MathContext_chRoundingMode = $rt_createCharArrayFromData([114, 111, 117, 110, 100, 105, 110, 103, 77, 111, 100, 101, 61]);
    }
    function jm_BigInteger() {
        var a = this; jl_Number.call(a);
        a.$digits = null;
        a.$numberLength = 0;
        a.$sign1 = 0;
        a.$firstNonzeroDigit = 0;
    }
    var jm_BigInteger_ZERO = null;
    var jm_BigInteger_ONE = null;
    var jm_BigInteger_TEN = null;
    var jm_BigInteger_MINUS_ONE = null;
    var jm_BigInteger_SMALL_VALUES = null;
    var jm_BigInteger_TWO_POWS = null;
    function jm_BigInteger_$callClinit() {
        jm_BigInteger_$callClinit = $rt_eraseClinit(jm_BigInteger);
        jm_BigInteger__clinit_();
    }
    function jm_BigInteger__init_(var_0, var_1) {
        var var_2 = new jm_BigInteger();
        jm_BigInteger__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function jm_BigInteger__init_1(var_0, var_1) {
        var var_2 = new jm_BigInteger();
        jm_BigInteger__init_2(var_2, var_0, var_1);
        return var_2;
    }
    function jm_BigInteger__init_0($this, $sign, $value) {
        var var$3;
        jm_BigInteger_$callClinit();
        $this.$firstNonzeroDigit = (-2);
        $this.$sign1 = $sign;
        $this.$numberLength = 1;
        var$3 = $rt_createIntArray(1);
        var$3.data[0] = $value;
        $this.$digits = var$3;
    }
    function jm_BigInteger__init_2($this, $sign, $val) {
        var var$3;
        jm_BigInteger_$callClinit();
        $this.$firstNonzeroDigit = (-2);
        $this.$sign1 = $sign;
        if (Long_eq(Long_and($val, Long_create(0, 4294967295)), Long_ZERO)) {
            $this.$numberLength = 1;
            var$3 = $rt_createIntArray(1);
            var$3.data[0] = Long_lo($val);
            $this.$digits = var$3;
        } else {
            $this.$numberLength = 2;
            $this.$digits = $rt_createIntArrayFromData([Long_lo($val), Long_hi($val)]);
        }
    }
    function jm_BigInteger_valueOf($val) {
        jm_BigInteger_$callClinit();
        if (Long_lt($val, Long_ZERO)) {
            if (Long_eq($val, Long_fromInt(-1)))
                return jm_BigInteger_MINUS_ONE;
            return jm_BigInteger__init_1((-1), Long_neg($val));
        }
        if (Long_gt($val, Long_fromInt(10)))
            return jm_BigInteger__init_1(1, $val);
        return jm_BigInteger_SMALL_VALUES.data[Long_lo($val)];
    }
    function jm_BigInteger__clinit_() {
        var $i, var$2;
        jm_BigInteger_ZERO = jm_BigInteger__init_(0, 0);
        jm_BigInteger_ONE = jm_BigInteger__init_(1, 1);
        jm_BigInteger_TEN = jm_BigInteger__init_(1, 10);
        jm_BigInteger_MINUS_ONE = jm_BigInteger__init_((-1), 1);
        jm_BigInteger_SMALL_VALUES = $rt_createArrayFromData(jm_BigInteger, [jm_BigInteger_ZERO, jm_BigInteger_ONE, jm_BigInteger__init_(1, 2), jm_BigInteger__init_(1, 3), jm_BigInteger__init_(1, 4), jm_BigInteger__init_(1, 5), jm_BigInteger__init_(1, 6), jm_BigInteger__init_(1, 7), jm_BigInteger__init_(1, 8), jm_BigInteger__init_(1, 9), jm_BigInteger_TEN]);
        jm_BigInteger_TWO_POWS = $rt_createArray(jm_BigInteger, 32);
        $i = 0;
        while (true) {
            var$2 = jm_BigInteger_TWO_POWS.data;
            if ($i >= var$2.length)
                break;
            var$2[$i] = jm_BigInteger_valueOf(Long_shl(Long_fromInt(1), $i));
            $i = $i + 1 | 0;
        }
    }
    var sm_ScalaNumericAnyConversions = $rt_classWithoutFields(0);
    var sm_ScalaNumericConversions = $rt_classWithoutFields(0);
    var sm_Ordered = $rt_classWithoutFields(0);
    function sm_BigInt() {
        var a = this; sm_ScalaNumber.call(a);
        a.$_bigInteger = null;
        a.$_long = Long_ZERO;
    }
    var sci_Iterable$ = $rt_classWithoutFields(sc_IterableFactory$Delegate);
    var sci_Iterable$_MODULE$ = null;
    function sci_Iterable$_$callClinit() {
        sci_Iterable$_$callClinit = $rt_eraseClinit(sci_Iterable$);
        sci_Iterable$__clinit_();
    }
    function sci_Iterable$__clinit_() {
        var var$1;
        var$1 = new sci_Iterable$;
        sci_Iterable$_$callClinit();
        sci_List$_$callClinit();
        sc_IterableFactory$Delegate__init_0(var$1, sci_List$_MODULE$);
        sci_Iterable$_MODULE$ = var$1;
    }
    function sci_Iterable$_from($this, $it) {
        return $rt_isInstance($it, sci_Iterable) ? $it : sc_IterableFactory$Delegate_from($this, $it);
    }
    var jl_SecurityException = $rt_classWithoutFields(jl_RuntimeException);
    function jm_RoundingMode() {
        jl_Enum.call(this);
        this.$bigDecimalRM = 0;
    }
    var jm_RoundingMode_UP = null;
    var jm_RoundingMode_DOWN = null;
    var jm_RoundingMode_CEILING = null;
    var jm_RoundingMode_FLOOR = null;
    var jm_RoundingMode_HALF_UP = null;
    var jm_RoundingMode_HALF_DOWN = null;
    var jm_RoundingMode_HALF_EVEN = null;
    var jm_RoundingMode_UNNECESSARY = null;
    var jm_RoundingMode_$VALUES = null;
    function jm_RoundingMode_$callClinit() {
        jm_RoundingMode_$callClinit = $rt_eraseClinit(jm_RoundingMode);
        jm_RoundingMode__clinit_();
    }
    function jm_RoundingMode__init_(var_0, var_1, var_2) {
        var var_3 = new jm_RoundingMode();
        jm_RoundingMode__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function jm_RoundingMode_values() {
        jm_RoundingMode_$callClinit();
        return jm_RoundingMode_$VALUES.$clone();
    }
    function jm_RoundingMode__init_0($this, var$1, var$2, $rm) {
        jm_RoundingMode_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
        $this.$bigDecimalRM = $rm;
    }
    function jm_RoundingMode__clinit_() {
        var var$1;
        jm_RoundingMode_UP = jm_RoundingMode__init_($rt_s(496), 0, 0);
        jm_RoundingMode_DOWN = jm_RoundingMode__init_($rt_s(497), 1, 1);
        jm_RoundingMode_CEILING = jm_RoundingMode__init_($rt_s(498), 2, 2);
        jm_RoundingMode_FLOOR = jm_RoundingMode__init_($rt_s(499), 3, 3);
        jm_RoundingMode_HALF_UP = jm_RoundingMode__init_($rt_s(500), 4, 4);
        jm_RoundingMode_HALF_DOWN = jm_RoundingMode__init_($rt_s(501), 5, 5);
        jm_RoundingMode_HALF_EVEN = jm_RoundingMode__init_($rt_s(502), 6, 6);
        var$1 = jm_RoundingMode__init_($rt_s(503), 7, 7);
        jm_RoundingMode_UNNECESSARY = var$1;
        jm_RoundingMode_$VALUES = $rt_createArrayFromData(jm_RoundingMode, [jm_RoundingMode_UP, jm_RoundingMode_DOWN, jm_RoundingMode_CEILING, jm_RoundingMode_FLOOR, jm_RoundingMode_HALF_UP, jm_RoundingMode_HALF_DOWN, jm_RoundingMode_HALF_EVEN, var$1]);
    }
    var jl_NumberFormatException = $rt_classWithoutFields(jl_IllegalArgumentException);
    var sci_VectorStatics$ = $rt_classWithoutFields();
    var sci_VectorStatics$_MODULE$ = null;
    var sci_VectorStatics$_empty1 = null;
    var sci_VectorStatics$_empty2 = null;
    var sci_VectorStatics$_empty3 = null;
    var sci_VectorStatics$_empty4 = null;
    var sci_VectorStatics$_empty5 = null;
    var sci_VectorStatics$_empty6 = null;
    function sci_VectorStatics$__clinit_() {
        sci_VectorStatics$_MODULE$ = new sci_VectorStatics$;
        sci_VectorStatics$_empty1 = $rt_createArray(jl_Object, 0);
        sci_VectorStatics$_empty2 = $rt_createArray($rt_arraycls(jl_Object), 0);
        sci_VectorStatics$_empty3 = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 0);
        sci_VectorStatics$_empty4 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))), 0);
        sci_VectorStatics$_empty5 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object)))), 0);
        sci_VectorStatics$_empty6 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))))), 0);
    }
    function sci_VectorStatics$_copyAppend1($this, $a, $elem) {
        var $alen, $ac, var$5;
        $alen = $a.data.length;
        $ac = $rt_createArray(jl_Object, $alen + 1 | 0);
        var$5 = $ac.data;
        jl_System_arraycopy($a, 0, $ac, 0, $alen);
        var$5[$alen] = $elem;
        return $ac;
    }
    function sci_VectorStatics$_copyAppend($this, $a, $elem) {
        var $ac;
        $ac = ju_Arrays_copyOf($a, $a.data.length + 1 | 0);
        $a = $ac.data;
        $a[$a.length - 1 | 0] = $elem;
        return $ac;
    }
    function sci_VectorStatics$_copyPrepend1($this, $elem, $a) {
        var var$3, $ac, var$5;
        var$3 = $a.data.length;
        $ac = $rt_createArray(jl_Object, var$3 + 1 | 0);
        var$5 = $ac.data;
        jl_System_arraycopy($a, 0, $ac, 1, var$3);
        var$5[0] = $elem;
        return $ac;
    }
    function sci_VectorStatics$_copyPrepend($this, $elem, $a) {
        var var$3, var$4, var$5, $ac;
        var$3 = $a.data;
        var$4 = jl_Class_getComponentType(jl_Object_getClass($a));
        var$5 = var$3.length;
        $ac = jlr_Array_newInstance(var$4, var$5 + 1 | 0);
        var$3 = $ac.data;
        jl_System_arraycopy($a, 0, $ac, 1, var$5);
        var$3[0] = $elem;
        return $ac;
    }
    function sci_VectorStatics$_empty20($this) {
        return sci_VectorStatics$_empty2;
    }
    function sci_VectorStatics$_empty30($this) {
        return sci_VectorStatics$_empty3;
    }
    function sci_VectorStatics$_empty40($this) {
        return sci_VectorStatics$_empty4;
    }
    function sci_VectorStatics$_empty50($this) {
        return sci_VectorStatics$_empty5;
    }
    function sci_VectorStatics$_empty60($this) {
        return sci_VectorStatics$_empty6;
    }
    function sci_VectorStatics$_foreachRec($this, $level, $a, $f) {
        var var$4, $i, $len, $l;
        var$4 = $a.data;
        $i = 0;
        $len = var$4.length;
        if (!$level) {
            while ($i < $len) {
                $f.$apply(var$4[$i]);
                $i = $i + 1 | 0;
            }
            return;
        }
        $l = $level - 1 | 0;
        while ($i < $len) {
            sci_VectorStatics$_foreachRec($this, $l, var$4[$i], $f);
            $i = $i + 1 | 0;
        }
    }
    function sci_VectorStatics$_mapElems($this, $n, $a, $f) {
        var $mapElems1_i, var$5, $i, $mapElems1_v1, $mapElems1_v2, $mapElems1_mapElems1Rest_ac, $mapElems1_mapElems1Rest_i, $v1, $v2, $mapElemsRest_ac, $mapElemsRest_i, var$15, var$16, $mapElemsRest_mapElems_a, $mapElemsRest_mapElems_i, $mapElemsRest_mapElems_v1, $mapElemsRest_mapElems_v2, $mapElemsRest_mapElems_mapElems1_i, $mapElemsRest_mapElems_mapElems1_v1, $mapElemsRest_mapElems_mapElems1_v2, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i;
        if ($n == 1) {
            $mapElems1_i = 0;
            while (true) {
                var$5 = $a.data;
                $i = var$5.length;
                if ($mapElems1_i >= $i)
                    break;
                $mapElems1_v1 = var$5[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $mapElems1_mapElems1Rest_ac = $rt_createArray(jl_Object, $i);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($a, 0, $mapElems1_mapElems1Rest_ac, 0, $mapElems1_i);
                    $a = $mapElems1_mapElems1Rest_ac.data;
                    $a[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $i) {
                        $a[$mapElems1_mapElems1Rest_i] = $f.$apply(var$5[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    return $mapElems1_mapElems1Rest_ac;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
            return $a;
        }
        $i = 0;
        $mapElems1_i = $n - 1 | 0;
        while (true) {
            var$5 = $a.data;
            $mapElems1_mapElems1Rest_i = var$5.length;
            if ($i >= $mapElems1_mapElems1Rest_i)
                break;
            $v1 = var$5[$i];
            $v2 = sci_VectorStatics$_mapElems($this, $mapElems1_i, $v1, $f);
            if ($v1 !== $v2) {
                $mapElemsRest_ac = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($a)), $mapElems1_mapElems1Rest_i);
                if ($i > 0)
                    jl_System_arraycopy($a, 0, $mapElemsRest_ac, 0, $i);
                $a = $mapElemsRest_ac.data;
                $a[$i] = $v2;
                $mapElemsRest_i = $i + 1 | 0;
                var$15 = $rt_compare($mapElems1_i, 1);
                var$16 = $mapElems1_i - 1 | 0;
                while ($mapElemsRest_i < $mapElems1_mapElems1Rest_i) {
                    a: {
                        $mapElemsRest_mapElems_a = var$5[$mapElemsRest_i];
                        if (var$15) {
                            $mapElemsRest_mapElems_i = 0;
                            while (true) {
                                $mapElems1_mapElems1Rest_ac = $mapElemsRest_mapElems_a.data;
                                if ($mapElemsRest_mapElems_i >= $mapElems1_mapElems1Rest_ac.length)
                                    break;
                                $mapElemsRest_mapElems_v1 = $mapElems1_mapElems1Rest_ac[$mapElemsRest_mapElems_i];
                                $mapElemsRest_mapElems_v2 = sci_VectorStatics$_mapElems($this, var$16, $mapElemsRest_mapElems_v1, $f);
                                if ($mapElemsRest_mapElems_v1 !== $mapElemsRest_mapElems_v2) {
                                    $mapElemsRest_mapElems_a = sci_VectorStatics$_mapElemsRest($this, $mapElems1_i, $mapElemsRest_mapElems_a, $f, $mapElemsRest_mapElems_i, $mapElemsRest_mapElems_v2);
                                    break a;
                                }
                                $mapElemsRest_mapElems_i = $mapElemsRest_mapElems_i + 1 | 0;
                            }
                        } else {
                            $mapElemsRest_mapElems_mapElems1_i = 0;
                            b: {
                                while (true) {
                                    $mapElems1_mapElems1Rest_ac = $mapElemsRest_mapElems_a.data;
                                    $mapElemsRest_mapElems_i = $mapElems1_mapElems1Rest_ac.length;
                                    if ($mapElemsRest_mapElems_mapElems1_i >= $mapElemsRest_mapElems_i)
                                        break;
                                    $mapElemsRest_mapElems_mapElems1_v1 = $mapElems1_mapElems1Rest_ac[$mapElemsRest_mapElems_mapElems1_i];
                                    $mapElemsRest_mapElems_mapElems1_v2 = $f.$apply($mapElemsRest_mapElems_mapElems1_v1);
                                    if ($mapElemsRest_mapElems_mapElems1_v1 !== $mapElemsRest_mapElems_mapElems1_v2) {
                                        $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac = $rt_createArray(jl_Object, $mapElemsRest_mapElems_i);
                                        if ($mapElemsRest_mapElems_mapElems1_i > 0)
                                            jl_System_arraycopy($mapElemsRest_mapElems_a, 0, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, 0, $mapElemsRest_mapElems_mapElems1_i);
                                        $mapElemsRest_mapElems_a = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac.data;
                                        $mapElemsRest_mapElems_a[$mapElemsRest_mapElems_mapElems1_i] = $mapElemsRest_mapElems_mapElems1_v2;
                                        $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                                        while ($mapElemsRest_mapElems_mapElems1_mapElems1Rest_i < $mapElemsRest_mapElems_i) {
                                            $mapElemsRest_mapElems_a[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i] = $f.$apply($mapElems1_mapElems1Rest_ac[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i]);
                                            $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i + 1 | 0;
                                        }
                                        $mapElemsRest_mapElems_a = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac;
                                        break b;
                                    }
                                    $mapElemsRest_mapElems_mapElems1_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                                }
                            }
                        }
                    }
                    $a[$mapElemsRest_i] = $mapElemsRest_mapElems_a;
                    $mapElemsRest_i = $mapElemsRest_i + 1 | 0;
                }
                return $mapElemsRest_ac;
            }
            $i = $i + 1 | 0;
        }
        return $a;
    }
    function sci_VectorStatics$_mapElemsRest($this, $n, $a, $f, $at, $v2) {
        var var$6, $mapElems_mapElems1_v1, var$8, $ac, $i, $mapElems_n, var$12, var$13, $mapElems_a, $mapElems_i, $mapElems_mapElems1_mapElems1Rest_ac, $mapElems_v1, $mapElems_v2, $mapElems_mapElems1_i, $mapElems_mapElems1_v2, $mapElems_mapElems1_mapElems1Rest_i;
        var$6 = $a.data;
        $mapElems_mapElems1_v1 = jl_Class_getComponentType(jl_Object_getClass($a));
        var$8 = var$6.length;
        $ac = jlr_Array_newInstance($mapElems_mapElems1_v1, var$8);
        if ($at > 0)
            jl_System_arraycopy($a, 0, $ac, 0, $at);
        $a = $ac.data;
        $a[$at] = $v2;
        $i = $at + 1 | 0;
        $mapElems_n = $n - 1 | 0;
        var$12 = $rt_compare($mapElems_n, 1);
        var$13 = $mapElems_n - 1 | 0;
        while ($i < var$8) {
            a: {
                $mapElems_a = var$6[$i];
                if (var$12) {
                    $mapElems_i = 0;
                    while (true) {
                        $mapElems_mapElems1_mapElems1Rest_ac = $mapElems_a.data;
                        if ($mapElems_i >= $mapElems_mapElems1_mapElems1Rest_ac.length)
                            break;
                        $mapElems_v1 = $mapElems_mapElems1_mapElems1Rest_ac[$mapElems_i];
                        $mapElems_v2 = sci_VectorStatics$_mapElems($this, var$13, $mapElems_v1, $f);
                        if ($mapElems_v1 !== $mapElems_v2) {
                            $mapElems_a = sci_VectorStatics$_mapElemsRest($this, $mapElems_n, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                            break a;
                        }
                        $mapElems_i = $mapElems_i + 1 | 0;
                    }
                } else {
                    $mapElems_mapElems1_i = 0;
                    b: {
                        while (true) {
                            $mapElems_v2 = $mapElems_a.data;
                            $n = $mapElems_v2.length;
                            if ($mapElems_mapElems1_i >= $n)
                                break;
                            $mapElems_mapElems1_v1 = $mapElems_v2[$mapElems_mapElems1_i];
                            $mapElems_mapElems1_v2 = $f.$apply($mapElems_mapElems1_v1);
                            if ($mapElems_mapElems1_v1 !== $mapElems_mapElems1_v2) {
                                $mapElems_mapElems1_mapElems1Rest_ac = $rt_createArray(jl_Object, $n);
                                if ($mapElems_mapElems1_i > 0)
                                    jl_System_arraycopy($mapElems_a, 0, $mapElems_mapElems1_mapElems1Rest_ac, 0, $mapElems_mapElems1_i);
                                $mapElems_a = $mapElems_mapElems1_mapElems1Rest_ac.data;
                                $mapElems_a[$mapElems_mapElems1_i] = $mapElems_mapElems1_v2;
                                $mapElems_mapElems1_mapElems1Rest_i = $mapElems_mapElems1_i + 1 | 0;
                                while ($mapElems_mapElems1_mapElems1Rest_i < $n) {
                                    $mapElems_a[$mapElems_mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_v2[$mapElems_mapElems1_mapElems1Rest_i]);
                                    $mapElems_mapElems1_mapElems1Rest_i = $mapElems_mapElems1_mapElems1Rest_i + 1 | 0;
                                }
                                $mapElems_a = $mapElems_mapElems1_mapElems1Rest_ac;
                                break b;
                            }
                            $mapElems_mapElems1_i = $mapElems_mapElems1_i + 1 | 0;
                        }
                    }
                }
            }
            $a[$i] = $mapElems_a;
            $i = $i + 1 | 0;
        }
        return $ac;
    }
    function sci_VectorStatics$_append1IfSpace($this, $suffix1, $xs) {
        var $s, var$4, $suffix1b, var$6;
        if (!$rt_isInstance($xs, sci_Iterable)) {
            $s = $xs.$knownSize();
            if ($s > 0) {
                var$4 = $suffix1.data.length;
                if ($s <= (32 - var$4 | 0)) {
                    $suffix1b = ju_Arrays_copyOf($suffix1, var$4 + $s | 0);
                    ($xs.$iterator0()).$copyToArray0($suffix1b, var$4);
                    return $suffix1b;
                }
            }
            return null;
        }
        $suffix1b = $suffix1.data;
        $xs = $xs;
        $s = $suffix1b.length;
        if ($xs.$sizeCompare(32 - $s | 0) > 0)
            return null;
        var$6 = $xs.$size();
        switch (var$6) {
            case 0:
                break;
            case 1:
                return sci_VectorStatics$_copyAppend($this, $suffix1, $xs.$head());
            default:
                $suffix1b = ju_Arrays_copyOf($suffix1, $s + var$6 | 0);
                sc_IterableOnceOps_copyToArray$0($xs, $suffix1b, $s);
                return $suffix1b;
        }
        return null;
    }
    function scm_HashMap$HashMapIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$i0 = 0;
        a.$node1 = null;
        a.$len2 = 0;
        a.$$outer21 = null;
    }
    function scm_HashMap$HashMapIterator_hasNext($this) {
        var var$1, $n;
        if ($this.$node1 !== null)
            return 1;
        while (true) {
            var$1 = $this.$i0;
            if (var$1 >= $this.$len2)
                break;
            $n = $this.$$outer21.$scala$collection$mutable$HashMap$$table.data[var$1];
            $this.$i0 = var$1 + 1 | 0;
            if ($n === null)
                continue;
            else {
                $this.$node1 = $n;
                return 1;
            }
        }
        return 0;
    }
    function scm_HashMap$HashMapIterator_next($this) {
        var $r;
        if (!scm_HashMap$HashMapIterator_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $r = $this.$extract0($this.$node1);
        $this.$node1 = $this.$node1.$_next;
        return $r;
    }
    function scm_HashMap$HashMapIterator_scala$collection$mutable$HashMap$HashMapIterator$$$outer($this) {
        return $this.$$outer21;
    }
    function scm_HashMap$HashMapIterator__init_($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer21 = $$outer;
        $this.$i0 = 0;
        $this.$node1 = null;
        $this.$len2 = $$outer.$scala$collection$mutable$HashMap$$table.data.length;
    }
    var scm_HashMap$$anon$2 = $rt_classWithoutFields(scm_HashMap$HashMapIterator);
    function scm_HashMap$$anon$2_extract($this, $nd) {
        return $nd.$_key;
    }
    var suh_MurmurHash3 = $rt_classWithoutFields();
    function suh_MurmurHash3_mix($this, $hash, $data) {
        return (jl_Integer_rotateLeft(suh_MurmurHash3_mixLast($this, $hash, $data), 13) * 5 | 0) + (-430675100) | 0;
    }
    function suh_MurmurHash3_mixLast($this, $hash, $data) {
        return $hash ^ $rt_imul(jl_Integer_rotateLeft($rt_imul($data, (-862048943)), 15), 461845907);
    }
    function suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, $hash) {
        $hash = $rt_imul($hash ^ $hash >>> 16, (-2048144789));
        $hash = $rt_imul($hash ^ $hash >>> 13, (-1028477387));
        return $hash ^ $hash >>> 16;
    }
    function suh_MurmurHash3_tuple2Hash($this, $x, $y, $seed) {
        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, $seed, jl_String_hashCode($rt_s(44))), $x), $y) ^ 2);
    }
    function suh_MurmurHash3_unorderedHash($this, $xs, $seed) {
        var $a, $b, $n, $c, $iterator, $h;
        $a = 0;
        $b = 0;
        $n = 0;
        $c = 1;
        $iterator = $xs.$iterator0();
        while ($iterator.$hasNext()) {
            $h = sr_Statics_anyHash($iterator.$next());
            $a = $a + $h | 0;
            $b = $b ^ $h;
            $c = $rt_imul($c, $h | 1);
            $n = $n + 1 | 0;
        }
        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mixLast($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, $seed, $a), $b), $c) ^ $n);
    }
    function suh_MurmurHash3_arrayHash($this, $a, $seed) {
        var $l, $initial, $finalizeHash_length, $prev, $rangeDiff, $i, $hash;
        $l = jlr_Array_getLength($a);
        switch ($l) {
            case 0:
                break;
            case 1:
                return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, $seed, sr_Statics_anyHash(sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, 0))) ^ 1);
            default:
                $initial = sr_Statics_anyHash(sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, 0));
                $finalizeHash_length = suh_MurmurHash3_mix($this, $seed, $initial);
                $prev = sr_Statics_anyHash(sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, 1));
                $rangeDiff = $prev - $initial | 0;
                $i = 2;
                $initial = $finalizeHash_length;
                while ($i < $l) {
                    $initial = suh_MurmurHash3_mix($this, $initial, $prev);
                    $hash = sr_Statics_anyHash(sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, $i));
                    if ($rangeDiff != ($hash - $prev | 0)) {
                        $seed = suh_MurmurHash3_mix($this, $initial, $hash);
                        $hash = $i + 1 | 0;
                        while ($hash < $l) {
                            $seed = suh_MurmurHash3_mix($this, $seed, sr_Statics_anyHash(sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, $hash)));
                            $hash = $hash + 1 | 0;
                        }
                        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, $seed ^ $l);
                    }
                    $i = $i + 1 | 0;
                    $prev = $hash;
                }
                return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, $finalizeHash_length, $rangeDiff), $prev));
        }
        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, $seed ^ 0);
    }
    var suh_MurmurHash3$ = $rt_classWithoutFields(suh_MurmurHash3);
    var suh_MurmurHash3$_MODULE$ = null;
    var suh_MurmurHash3$_seqSeed0 = 0;
    var suh_MurmurHash3$_mapSeed0 = 0;
    var suh_MurmurHash3$_setSeed0 = 0;
    var suh_MurmurHash3$_emptyMapHash0 = 0;
    function suh_MurmurHash3$_$callClinit() {
        suh_MurmurHash3$_$callClinit = $rt_eraseClinit(suh_MurmurHash3$);
        suh_MurmurHash3$__clinit_();
    }
    function suh_MurmurHash3$__clinit_() {
        var var$1;
        var$1 = new suh_MurmurHash3$;
        suh_MurmurHash3$_$callClinit();
        suh_MurmurHash3$_MODULE$ = var$1;
        suh_MurmurHash3$_seqSeed0 = jl_String_hashCode($rt_s(504));
        suh_MurmurHash3$_mapSeed0 = jl_String_hashCode($rt_s(388));
        suh_MurmurHash3$_setSeed0 = jl_String_hashCode($rt_s(401));
        var$1 = suh_MurmurHash3$_MODULE$;
        suh_MurmurHash3$_emptyMapHash0 = suh_MurmurHash3_unorderedHash(var$1, sci_Nil$_MODULE$, suh_MurmurHash3$_mapSeed(var$1));
    }
    function suh_MurmurHash3$_seqSeed($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_seqSeed0;
    }
    function suh_MurmurHash3$_mapSeed($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_mapSeed0;
    }
    function suh_MurmurHash3$_setSeed($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_setSeed0;
    }
    function suh_MurmurHash3$_productHash($this, $x) {
        var var$2, var$3, var$4, var$5;
        var$2 = $x.$productArity();
        if (!var$2)
            var$3 = jl_String_hashCode($x.$productPrefix());
        else {
            var$4 = suh_MurmurHash3_mix($this, (-889275714), jl_String_hashCode($x.$productPrefix()));
            var$5 = 0;
            while (var$5 < var$2) {
                var$4 = suh_MurmurHash3_mix($this, var$4, sr_Statics_anyHash($x.$productElement(var$5)));
                var$5 = var$5 + 1 | 0;
            }
            var$3 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$4 ^ var$2);
        }
        return var$3;
    }
    function suh_MurmurHash3$_arraySeqHash($this, $a) {
        return suh_MurmurHash3_arrayHash($this, $a, suh_MurmurHash3$_seqSeed($this));
    }
    function suh_MurmurHash3$_tuple2Hash($this, $x, $y) {
        return suh_MurmurHash3_tuple2Hash($this, sr_Statics_anyHash($x), sr_Statics_anyHash($y), (-889275714));
    }
    function suh_MurmurHash3$_emptyMapHash($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_emptyMapHash0;
    }
    function suh_MurmurHash3$_arraySeqHash$mZc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, !$a[0] ? 1237 : 1231) ^ 1);
                    break a;
                default:
                    var$4 = !$a[0] ? 1237 : 1231;
                    var$5 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$6 = !$a[1] ? 1237 : 1231;
                    var$4 = var$6 - var$4 | 0;
                    var$7 = 2;
                    var$8 = var$5;
                    while (var$7 < var$3) {
                        var$8 = suh_MurmurHash3_mix($this, var$8, var$6);
                        var$2 = !$a[var$7] ? 1237 : 1231;
                        if (var$4 != (var$2 - var$6 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$8, var$2);
                            var$6 = var$7 + 1 | 0;
                            while (var$6 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, !$a[var$6] ? 1237 : 1231);
                                var$6 = var$6 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$7 = var$7 + 1 | 0;
                        var$6 = var$2;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$5, var$4), var$6));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mBc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, $a[0]) ^ 1);
                    break a;
                default:
                    var$4 = $a[0];
                    var$5 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$2 = $a[1];
                    var$4 = var$2 - var$4 | 0;
                    var$6 = 2;
                    var$7 = var$5;
                    while (var$6 < var$3) {
                        var$7 = suh_MurmurHash3_mix($this, var$7, var$2);
                        var$8 = $a[var$6];
                        if (var$4 != (var$8 - var$2 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$7, var$8);
                            var$5 = var$6 + 1 | 0;
                            while (var$5 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, $a[var$5]);
                                var$5 = var$5 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$6 = var$6 + 1 | 0;
                        var$2 = var$8;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$5, var$4), var$2));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mCc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, $a[0]) ^ 1);
                    break a;
                default:
                    var$4 = $a[0];
                    var$5 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$2 = $a[1];
                    var$4 = var$2 - var$4 | 0;
                    var$6 = 2;
                    var$7 = var$5;
                    while (var$6 < var$3) {
                        var$7 = suh_MurmurHash3_mix($this, var$7, var$2);
                        var$8 = $a[var$6];
                        if (var$4 != (var$8 - var$2 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$7, var$8);
                            var$5 = var$6 + 1 | 0;
                            while (var$5 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, $a[var$5]);
                                var$5 = var$5 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$6 = var$6 + 1 | 0;
                        var$2 = var$8;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$5, var$4), var$2));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mDc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, sr_Statics_doubleHash($a[0])) ^ 1);
                    break a;
                default:
                    var$4 = sr_Statics_doubleHash($a[0]);
                    var$5 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$2 = sr_Statics_doubleHash($a[1]);
                    var$4 = var$2 - var$4 | 0;
                    var$6 = 2;
                    var$7 = var$5;
                    while (var$6 < var$3) {
                        var$7 = suh_MurmurHash3_mix($this, var$7, var$2);
                        var$8 = sr_Statics_doubleHash($a[var$6]);
                        if (var$4 != (var$8 - var$2 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$7, var$8);
                            var$5 = var$6 + 1 | 0;
                            while (var$5 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, sr_Statics_doubleHash($a[var$5]));
                                var$5 = var$5 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$6 = var$6 + 1 | 0;
                        var$2 = var$8;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$5, var$4), var$2));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mFc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, sr_Statics_floatHash($a[0])) ^ 1);
                    break a;
                default:
                    var$4 = sr_Statics_floatHash($a[0]);
                    var$5 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$2 = sr_Statics_floatHash($a[1]);
                    var$4 = var$2 - var$4 | 0;
                    var$6 = 2;
                    var$7 = var$5;
                    while (var$6 < var$3) {
                        var$7 = suh_MurmurHash3_mix($this, var$7, var$2);
                        var$8 = sr_Statics_floatHash($a[var$6]);
                        if (var$4 != (var$8 - var$2 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$7, var$8);
                            var$5 = var$6 + 1 | 0;
                            while (var$5 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, sr_Statics_floatHash($a[var$5]));
                                var$5 = var$5 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$6 = var$6 + 1 | 0;
                        var$2 = var$8;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$5, var$4), var$2));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mIc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, $a[0]) ^ 1);
                    break a;
                default:
                    var$4 = $a[0];
                    var$2 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$5 = $a[1];
                    var$6 = var$5 - var$4 | 0;
                    var$4 = 2;
                    var$7 = var$2;
                    while (var$4 < var$3) {
                        var$7 = suh_MurmurHash3_mix($this, var$7, var$5);
                        var$8 = $a[var$4];
                        if (var$6 != (var$8 - var$5 | 0)) {
                            var$5 = suh_MurmurHash3_mix($this, var$7, var$8);
                            var$2 = var$4 + 1 | 0;
                            while (var$2 < var$3) {
                                var$5 = suh_MurmurHash3_mix($this, var$5, $a[var$2]);
                                var$2 = var$2 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$5 ^ var$3);
                            break a;
                        }
                        var$4 = var$4 + 1 | 0;
                        var$5 = var$8;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$2, var$6), var$5));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mJc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, sr_Statics_longHash($a[0])) ^ 1);
                    break a;
                default:
                    var$4 = sr_Statics_longHash($a[0]);
                    var$5 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$2 = sr_Statics_longHash($a[1]);
                    var$4 = var$2 - var$4 | 0;
                    var$6 = 2;
                    var$7 = var$5;
                    while (var$6 < var$3) {
                        var$7 = suh_MurmurHash3_mix($this, var$7, var$2);
                        var$8 = sr_Statics_longHash($a[var$6]);
                        if (var$4 != (var$8 - var$2 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$7, var$8);
                            var$5 = var$6 + 1 | 0;
                            while (var$5 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, sr_Statics_longHash($a[var$5]));
                                var$5 = var$5 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$6 = var$6 + 1 | 0;
                        var$2 = var$8;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$5, var$4), var$2));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mSc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, $a[0]) ^ 1);
                    break a;
                default:
                    var$4 = $a[0];
                    var$5 = suh_MurmurHash3_mix($this, var$2, var$4);
                    var$2 = $a[1];
                    var$4 = var$2 - var$4 | 0;
                    var$6 = 2;
                    var$7 = var$5;
                    while (var$6 < var$3) {
                        var$7 = suh_MurmurHash3_mix($this, var$7, var$2);
                        var$8 = $a[var$6];
                        if (var$4 != (var$8 - var$2 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$7, var$8);
                            var$5 = var$6 + 1 | 0;
                            while (var$5 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, $a[var$5]);
                                var$5 = var$5 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$6 = var$6 + 1 | 0;
                        var$2 = var$8;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$5, var$4), var$2));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    function suh_MurmurHash3$_arraySeqHash$mVc$sp($this, $a) {
        var var$2, var$3, var$4, var$5, var$6;
        a: {
            $a = $a.data;
            var$2 = suh_MurmurHash3$_seqSeed($this);
            var$3 = $a.length;
            switch (var$3) {
                case 0:
                    break;
                case 1:
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, var$2, 0) ^ 1);
                    break a;
                default:
                    var$2 = suh_MurmurHash3_mix($this, var$2, 0);
                    var$4 = 0;
                    var$5 = 2;
                    var$6 = var$2;
                    while (var$5 < var$3) {
                        var$6 = suh_MurmurHash3_mix($this, var$6, var$4);
                        if (0 != (0 - var$4 | 0)) {
                            var$2 = suh_MurmurHash3_mix($this, var$6, 0);
                            var$4 = var$5 + 1 | 0;
                            while (var$4 < var$3) {
                                var$2 = suh_MurmurHash3_mix($this, var$2, 0);
                                var$4 = var$4 + 1 | 0;
                            }
                            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ var$3);
                            break a;
                        }
                        var$5 = var$5 + 1 | 0;
                        var$4 = 0;
                    }
                    var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, suh_MurmurHash3_mix($this, suh_MurmurHash3_mix($this, var$2, 0), var$4));
                    break a;
            }
            var$2 = suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche($this, var$2 ^ 0);
        }
        return var$2;
    }
    var jl_UnsupportedOperationException = $rt_classWithoutFields(jl_RuntimeException);
    function jl_UnsupportedOperationException__init_(var_0) {
        var var_1 = new jl_UnsupportedOperationException();
        jl_UnsupportedOperationException__init_0(var_1, var_0);
        return var_1;
    }
    function jl_UnsupportedOperationException__init_0($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    var oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_0 = $rt_classWithoutFields();
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_0_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$1$lambda$_29_0;
        var$2.$_0211 = var$1;
        return var$2;
    }
    var oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_1 = $rt_classWithoutFields();
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_1_apply(var$0, var$1) {
        return var$1.$notification;
    }
    var oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_2 = $rt_classWithoutFields();
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_2_apply(var$0, var$1) {
        return var$1.$replacement2;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_3() {
        jl_Object.call(this);
        this.$_027 = null;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_3_apply(var$0, var$1) {
        return sr_BoxedUnit_UNIT;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1() {
        sr_AbstractPartialFunction.call(this);
        this.$replacements$1 = null;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1_applyOrElse($this, $x1, $default) {
        var var$3, var$4;
        if (!$rt_isInstance($x1, onciu_ASTNode))
            return $default.$apply($x1);
        $x1 = $x1;
        $default = $this.$replacements$1;
        var$3 = onciu_Ref$_apply(onciu_Ref$_MODULE$, $x1);
        var$4 = new oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1$applyOrElse$lambda$_0_0;
        var$4.$_0212 = $x1;
        return $default.$getOrElse0(var$3, var$4);
    }
    var onciu_Rewritable$RewritableAny$ = $rt_classWithoutFields();
    var onciu_Rewritable$RewritableAny$_MODULE$ = null;
    function onciu_Rewritable$RewritableAny$__clinit_() {
        onciu_Rewritable$RewritableAny$_MODULE$ = new onciu_Rewritable$RewritableAny$;
    }
    var onciu_Rewritable$ = $rt_classWithoutFields();
    var onciu_Rewritable$_MODULE$ = null;
    function onciu_Rewritable$__clinit_() {
        onciu_Rewritable$_MODULE$ = new onciu_Rewritable$;
    }
    function onciu_Rewritable$_IteratorEq($this, $iterator) {
        var var$2;
        var$2 = new onciu_Rewritable$IteratorEq;
        var$2.$iterator1 = $iterator;
        return var$2;
    }
    function onciu_Rewritable$_dupAny($this, $that, $children) {
        var $builder, var$4, var$5, $$je;
        a: {
            try {
                b: {
                    if (onciu_Rewritable$IteratorEq_eqElements(onciu_Rewritable$_IteratorEq($this, $children.$iterator0()), onciu_Foldable$TreeAny$_treeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, onciu_Foldable$_TreeAny(onciu_Foldable$_MODULE$, $that)))) {
                        $builder = $that;
                        break b;
                    }
                    if ($rt_isInstance($that, onciu_RewritableUniversal)) {
                        $builder = $that.$dup($children);
                        break b;
                    }
                    if ($rt_isInstance($that, sc_IndexedSeq)) {
                        $builder = $children.$toIndexedSeq0();
                        break b;
                    }
                    if ($that instanceof sci_List) {
                        $builder = $children.$toList();
                        break b;
                    }
                    if ($rt_isInstance($that, sc_Seq)) {
                        $builder = $children;
                        break b;
                    }
                    if ($that instanceof sci_ListSet) {
                        $builder = sc_AbstractIterable_to($children, sc_IterableFactory$_toFactory(sc_IterableFactory$_MODULE$, sci_ListSet$_MODULE$));
                        break b;
                    }
                    if ($rt_isInstance($that, sc_Set)) {
                        $builder = sc_AbstractIterable_toSet($children);
                        break b;
                    }
                    if ($rt_isInstance($that, sc_Map)) {
                        s_Predef$_$callClinit();
                        $builder = sci_Map$_newBuilder(s_Predef$_Map(s_Predef$_MODULE$));
                        sc_AbstractIterator_foreach(($children.$iterator0()).$grouped(2), onciu_Rewritable$$dupAny$lambda$_2_0__init_($builder));
                        $builder = sci_MapBuilderImpl_result($builder);
                        break b;
                    }
                    if ($that instanceof s_Some) {
                        $builder = s_Some__init_($children.$head());
                        break b;
                    }
                    if (jl_Object_equals(s_None$_MODULE$, $that)) {
                        $builder = s_None$_MODULE$;
                        break b;
                    }
                    if ($that instanceof su_Left) {
                        s_package$_$callClinit();
                        $builder = su_Left$_apply(s_package$_Left(s_package$_MODULE$), $children.$head());
                        break b;
                    }
                    if ($that instanceof su_Right) {
                        s_package$_$callClinit();
                        $builder = su_Right$_apply(s_package$_Right(s_package$_MODULE$), $children.$head());
                        break b;
                    }
                    if ($rt_isInstance($that, s_Product)) {
                        $builder = jl_Object_getClass($that);
                        sr_ClassTag$_$callClinit();
                        $builder = onciu_RewritableCompat_copyConstructor($builder, $that, sc_AbstractIterable_toArray($children, sr_ClassTag$_AnyRef(sr_ClassTag$_MODULE$)));
                        break b;
                    }
                    $builder = $that;
                }
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_IllegalArgumentException) {
                    var$4 = $$je;
                    break a;
                } else {
                    throw $$e;
                }
            }
            return $builder;
        }
        var$5 = new jl_IllegalStateException;
        $children = sc_AbstractIterable_mkString0($children, $rt_s(43));
        $builder = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($builder);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($builder, $rt_s(505)), $that), $rt_s(506)), $children);
        jl_Throwable__init_4(var$5, jl_AbstractStringBuilder_toString($builder), var$4);
        $rt_throw(var$5);
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_4() {
        jl_Object.call(this);
        this.$_025 = null;
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_4_apply(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_025;
        var$2 = new jl_IllegalStateException;
        var$1 = jl_Class_getSimpleName(jl_Object_getClass(var$1));
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(507)), var$1), $rt_s(508));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    var oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_5 = $rt_classWithoutFields();
    function oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_5_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$4$lambda$_32_0;
        var$2.$_0213 = var$1;
        return var$2;
    }
    var onciafn_JavaCCParser$ = $rt_classWithoutFields();
    var onciafn_JavaCCParser$_MODULE$ = null;
    function onciafn_JavaCCParser$__clinit_() {
        onciafn_JavaCCParser$_MODULE$ = new onciafn_JavaCCParser$;
    }
    var oncias_SemanticState$ = $rt_classWithoutFields();
    var oncias_SemanticState$_MODULE$ = null;
    var oncias_SemanticState$_clean = null;
    function oncias_SemanticState$_$callClinit() {
        oncias_SemanticState$_$callClinit = $rt_eraseClinit(oncias_SemanticState$);
        oncias_SemanticState$__clinit_();
    }
    function oncias_SemanticState$__clinit_() {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = new oncias_SemanticState$;
        oncias_SemanticState$_$callClinit();
        oncias_SemanticState$_MODULE$ = var$1;
        var$2 = new oncias_SemanticState;
        oncias_Scope$_$callClinit();
        var$3 = oncias_Scope$_empty(oncias_Scope$_MODULE$);
        oncias_SemanticState$ScopeZipper$_$callClinit();
        var$1 = oncias_SemanticState$ScopeZipper$_MODULE$;
        var$4 = onciuh_TreeZipper$Location__init_(var$1, var$3, onciuh_TreeZipper_Top(var$1));
        var$1 = oncia_ASTAnnotationMap$_empty(oncia_ASTAnnotationMap$_MODULE$);
        var$3 = oncia_ASTAnnotationMap$_empty(oncia_ASTAnnotationMap$_MODULE$);
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        var$5 = sci_Set$EmptySet$_MODULE$;
        s_Predef$_Set(s_Predef$_MODULE$);
        oncias_SemanticState__init_0(var$2, var$4, var$1, var$3, var$5, sci_Set$EmptySet$_MODULE$, 1, 0);
        oncias_SemanticState$_clean = var$2;
    }
    function oncias_SemanticState$_recordCurrentScope($this, $node) {
        var var$2, var$3;
        var$2 = oncias_package$_MODULE$;
        var$3 = new oncias_SemanticState$$recordCurrentScope$lambda$_7_0;
        var$3.$_0214 = $node;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$3);
    }
    var oncias_SemanticCheckContext = $rt_classWithoutFields(0);
    function oncifp_SemanticAnalysis$$anon$1() {
        jl_Object.call(this);
        this.$context$1 = null;
    }
    function oncifp_SemanticAnalysis$$anon$1_errorMessageProvider($this) {
        return $this.$context$1.$errorMessageProvider;
    }
    var oncias_SemanticChecker$ = $rt_classWithoutFields();
    var oncias_SemanticChecker$_MODULE$ = null;
    function oncias_SemanticChecker$__clinit_() {
        oncias_SemanticChecker$_MODULE$ = new oncias_SemanticChecker$;
    }
    function oncifp_SemanticAnalysis$process$lambda$_13_0() {
        jl_Object.call(this);
        this.$_035 = null;
    }
    function oncifp_SemanticAnalysis$process$lambda$_13_0_apply(var$0, var$1) {
        return sr_BoxedUnit_UNIT;
    }
    var oncifp_SemanticAnalysis$process$lambda$_13_1 = $rt_classWithoutFields();
    function oncifp_SemanticAnalysis$process$lambda$_13_1_apply(var$0, var$1) {
        return var$1.$location.$elem;
    }
    function oncirr_computeDependenciesForExpressions() {
        var a = this; jl_Object.call(a);
        a.$semanticState = null;
        a.$instance = null;
    }
    function oncirr_computeDependenciesForExpressions_apply($this, $that) {
        return onciu_topDown$TopDownRewriter_apply($this.$instance, $that);
    }
    var oncias_SemanticTable$ = $rt_classWithoutFields();
    var oncias_SemanticTable$_MODULE$ = null;
    function oncias_SemanticTable$__clinit_() {
        oncias_SemanticTable$_MODULE$ = new oncias_SemanticTable$;
    }
    function oncias_SemanticTable$_apply($this, $types, $recordedScopes) {
        return oncias_SemanticTable__init_($types, $recordedScopes, scm_HashMap__init_(), scm_HashMap__init_(), scm_HashMap__init_());
    }
    var oncifp_SemanticAnalysis$process$lambda$_13_2 = $rt_classWithoutFields();
    function oncifp_SemanticAnalysis$process$lambda$_13_2__init_() {
        var var_0 = new oncifp_SemanticAnalysis$process$lambda$_13_2();
        oncifp_SemanticAnalysis$process$lambda$_13_2__init_0(var_0);
        return var_0;
    }
    function oncifp_SemanticAnalysis$process$lambda$_13_2__init_0(var$0) {}
    function oncifp_SemanticAnalysis$process$lambda$_13_2_apply(var$0, var$1) {
        return var$1.$location.$elem;
    }
    function oncifp_PreparatoryRewriting$$process$lambda$_9_0() {
        jl_Object.call(this);
        this.$_033 = null;
    }
    function oncifp_PreparatoryRewriting$$process$lambda$_9_0_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_033;
        oncifp_PreparatoryRewriting$_$callClinit();
        var$2 = var$1.$getRewriter(oncifp_SemanticAnalyzer$$anon$1_cypherExceptionFactory(var$2));
        if (onciu_AssertionRunner_isAssertionsEnabled()) {
            var$3 = new oncir_ValidatingRewriter;
            var$3.$inner4 = var$2;
            var$3.$step3 = var$1;
            var$2 = var$3;
        }
        return var$2;
    }
    var onciu_inSequence$ = $rt_classWithoutFields();
    var onciu_inSequence$_MODULE$ = null;
    function onciu_inSequence$__clinit_() {
        onciu_inSequence$_MODULE$ = new onciu_inSequence$;
    }
    var oncifp_extractSensitiveLiterals$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncifp_extractSensitiveLiterals$$anonfun$1_applyOrElse($this, $x1, $default) {
        if (!$rt_isInstance($x1, oncie_Literal))
            return $default.$apply($x1);
        return $x1.$asSensitiveLiteral();
    }
    var otcic_Console = $rt_classWithoutFields();
    var sc_AbstractSeqView = $rt_classWithoutFields(sc_AbstractView);
    function sc_AbstractSeqView_stringPrefix($this) {
        return $rt_s(509);
    }
    function sc_AbstractSeqView_scala$collection$SeqOps$$super$concat($this, $suffix) {
        return sc_IterableOps_concat$($this, $suffix);
    }
    function sc_AbstractSeqView_scala$collection$SeqOps$$super$sizeCompare($this, $otherSize) {
        return sc_IterableOps_sizeCompare$($this, $otherSize);
    }
    function sc_AbstractSeqView_$colon$plus($this, $elem) {
        return $this.$appended($elem);
    }
    function sc_AbstractSeqView_appendedAll($this, $suffix) {
        return $this.$scala$collection$SeqOps$$super$concat($suffix);
    }
    function sc_AbstractSeqView_concat($this, $suffix) {
        return $this.$appendedAll($suffix);
    }
    function sc_AbstractSeqView_size($this) {
        return $this.$length();
    }
    function sc_AbstractSeqView_distinct($this) {
        return sc_SeqOps_distinct$($this);
    }
    function sc_AbstractSeqView_distinctBy($this, $f) {
        return sc_SeqOps_distinctBy$($this, $f);
    }
    function sc_AbstractSeqView_lengthCompare($this, $len) {
        return $this.$scala$collection$SeqOps$$super$sizeCompare($len);
    }
    function sc_AbstractSeqView_appended($this, $elem) {
        return sc_SeqView_appended$($this, $elem);
    }
    function sc_AbstractSeqView_map($this, $f) {
        return sc_SeqView_map$($this, $f);
    }
    var sc_AbstractIndexedSeqView = $rt_classWithoutFields(sc_AbstractSeqView);
    function sc_AbstractIndexedSeqView_iterator($this) {
        return sc_IndexedSeqView_iterator$($this);
    }
    function scm_ArrayBufferView() {
        var a = this; sc_AbstractIndexedSeqView.call(a);
        a.$underlying6 = null;
        a.$mutationCount0 = null;
    }
    function scm_ArrayBufferView_apply($this, $n) {
        return scm_ArrayBuffer_apply($this.$underlying6, $n);
    }
    function scm_ArrayBufferView_length($this) {
        return $this.$underlying6.$size00;
    }
    function scm_ArrayBufferView_iterator($this) {
        return scm_CheckedIndexedSeqView$CheckedIterator__init_($this, $this.$mutationCount0);
    }
    function scm_ArrayBufferView_reverseIterator($this) {
        var var$1, var$2;
        var$1 = new scm_CheckedIndexedSeqView$CheckedReverseIterator;
        var$2 = $this.$mutationCount0;
        var$1.$mutationCount3 = var$2;
        sc_IndexedSeqView$IndexedSeqViewReverseIterator__init_(var$1, $this);
        var$1.$expectedCount0 = scm_ArrayBuffer$view$lambda$_88_0_apply$mcI$sp(var$2);
        return var$1;
    }
    function scm_ArrayBufferView_reverse($this) {
        var var$1, var$2;
        var$1 = new scm_CheckedIndexedSeqView$Reverse;
        var$2 = $this.$mutationCount0;
        var$1.$underlying12 = $this;
        var$1.$mutationCount4 = var$2;
        sc_IndexedSeqView$Reverse__init_0(var$1, $this);
        return var$1;
    }
    var srj_JFunction0$mcI$sp = $rt_classWithoutFields(0);
    function scm_ArrayBuffer$view$lambda$_88_0() {
        jl_Object.call(this);
        this.$_0137 = null;
    }
    function scm_ArrayBuffer$view$lambda$_88_0_apply$mcI$sp(var$0) {
        return var$0.$_0137.$mutationCount;
    }
    function onciu_Foldable$Folder() {
        var a = this; jl_Object.call(a);
        a.$foldedOver0 = null;
        a.$cancellation1 = null;
    }
    function onciu_Foldable$Folder_treeCollect($this, $f) {
        var var$2, var$3;
        s_package$_$callClinit();
        var$2 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        var$3 = new onciu_Foldable$Folder$$anonfun$treeCollect$1;
        var$3.$f$10 = $f;
        return onciu_Foldable$Folder_fold($this, var$2, var$3);
    }
    function onciu_Foldable$Folder_fold($this, $init, $f) {
        var var$3, var$4, var$5, var$6, var$7;
        var$3 = scm_Stack$_MODULE$;
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(jl_Object, 1);
        var$5.data[0] = $this.$foldedOver0;
        var$3 = var$3.$from0(sr_ScalaRunTime$_genericWrapArray(var$4, var$5));
        $f = $f.$lift1();
        while (!scm_ArrayDeque_isEmpty(var$3)) {
            var$6 = scm_Stack_pop(var$3);
            var$3 = scm_Stack_pushAll(var$3, onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$6));
            var$4 = s_PartialFunction$Lifted_apply($f, var$6);
            var$6 = new onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_0;
            var$6.$_0215 = $init;
            var$7 = new onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_1;
            var$7.$_0216 = $init;
            $init = s_Option_fold(var$4, var$6, var$7);
        }
        return $init;
    }
    function onciu_Foldable$Folder_treeFold($this, $init, $f) {
        var var$3, var$4, var$5, var$6, var$7, var$8;
        var$3 = scm_Stack$_MODULE$;
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(jl_Object, 1);
        var$5.data[0] = $this.$foldedOver0;
        var$3 = var$3.$from0(sr_ScalaRunTime$_genericWrapArray(var$4, var$5));
        var$4 = new onciu_Foldable$Folder$$anonfun$treeFold$1;
        var$4.$$outer22 = $this;
        var$6 = s_PartialFunction_lift$(sr_AbstractPartialFunction_andThen0($f, var$4));
        $f = scm_Stack__init_(16);
        a: {
            b: while (true) {
                if (scm_ArrayDeque_isEmpty(var$3)) {
                    if (scm_ArrayDeque_isEmpty($f))
                        break;
                    var$3 = scm_Stack_pop($f);
                    if (var$3 === null)
                        $rt_throw(s_MatchError__init_(var$3));
                    var$7 = s_Tuple2__init_(var$3.$_10, var$3.$_20);
                    var$3 = var$7.$_10;
                    $init = var$7.$_20.$apply($init);
                    continue;
                }
                var$7 = scm_Stack_pop(var$3);
                var$4 = s_PartialFunction$Lifted_apply(var$6, var$7);
                if (jl_Object_equals(s_None$_MODULE$, var$4)) {
                    var$3 = scm_Stack_pushAll(var$3, !0 ? onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$7) : onciu_Foldable$TreeAny$_treeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$7));
                    continue;
                }
                if (!(var$4 instanceof s_Some))
                    $rt_throw(s_MatchError__init_(var$4));
                c: {
                    var$8 = var$4.$value5.$apply($init);
                    if (var$8 !== null) {
                        $init = var$8.$_10;
                        var$4 = var$8.$_20;
                        if (var$4 instanceof s_Some)
                            break c;
                    }
                    if (var$8 === null)
                        break a;
                    $init = var$8.$_10;
                    var$4 = var$8.$_20;
                    if (!jl_Object_equals(s_None$_MODULE$, var$4))
                        break a;
                    continue b;
                }
                scm_Stack_push($f, s_Tuple2__init_(var$3, var$4.$value5));
                var$4 = !0 ? onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$7) : onciu_Foldable$TreeAny$_treeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$7);
                var$3 = scm_Stack_pushAll(scm_Stack$_MODULE$.$from0(sci_Nil$_MODULE$), var$4);
            }
            return $init;
        }
        $rt_throw(s_MatchError__init_(var$8));
    }
    function onciu_Foldable$Folder_treeExists($this, $f) {
        var var$2, var$3, var$4, var$5, var$6;
        var$2 = scm_Stack$_MODULE$;
        var$3 = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(jl_Object, 1);
        var$4.data[0] = $this.$foldedOver0;
        var$2 = var$2.$from0(sr_ScalaRunTime$_genericWrapArray(var$3, var$4));
        $f = s_PartialFunction_lift$($f);
        a: {
            while (!scm_ArrayDeque_isEmpty(var$2)) {
                var$3 = scm_Stack_pop(var$2);
                var$5 = s_PartialFunction$Lifted_apply($f, var$3);
                if (var$5 instanceof s_Some && 1 == sr_BoxesRunTime_unboxToBoolean(var$5.$value5)) {
                    var$6 = 1;
                    break a;
                }
                var$2 = scm_Stack_pushAll(var$2, onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$3));
            }
            var$6 = 0;
        }
        return var$6;
    }
    function onciu_Foldable$Folder_treeFind($this, $f, $evidence$1) {
        var var$3, var$4, var$5, var$6;
        var$3 = scm_Stack$_MODULE$;
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(jl_Object, 1);
        var$5.data[0] = $this.$foldedOver0;
        var$3 = var$3.$from0(sr_ScalaRunTime$_genericWrapArray(var$4, var$5));
        $f = s_PartialFunction_lift$($f);
        a: {
            while (!scm_ArrayDeque_isEmpty(var$3)) {
                var$4 = scm_Stack_pop(var$3);
                if (var$4 !== null) {
                    var$6 = $evidence$1.$unapply0(var$4);
                    if (!s_Option_isEmpty(var$6) && var$6.$get0() instanceof jl_Object && s_Option_isDefined(s_PartialFunction$Lifted_apply($f, var$4))) {
                        $f = s_Some__init_(var$4);
                        break a;
                    }
                }
                var$3 = scm_Stack_pushAll(var$3, onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$4));
            }
            $f = s_None$_MODULE$;
        }
        return $f;
    }
    function onciu_Foldable$Folder_treeFindByClass($this, $evidence$2) {
        var var$2, var$3, var$4, var$5;
        var$2 = scm_Stack$_MODULE$;
        var$3 = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(jl_Object, 1);
        var$4.data[0] = $this.$foldedOver0;
        var$2 = var$2.$from0(sr_ScalaRunTime$_genericWrapArray(var$3, var$4));
        a: {
            while (!scm_ArrayDeque_isEmpty(var$2)) {
                var$3 = scm_Stack_pop(var$2);
                if (var$3 !== null) {
                    var$5 = $evidence$2.$unapply0(var$3);
                    if (!s_Option_isEmpty(var$5) && var$5.$get0() instanceof jl_Object) {
                        $evidence$2 = s_Some__init_(var$3);
                        break a;
                    }
                }
                var$2 = var$2.$addAll0(onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, var$3));
            }
            $evidence$2 = s_None$_MODULE$;
        }
        return $evidence$2;
    }
    function onciu_Foldable$Folder_findAllByClass($this, $evidence$3) {
        var $remaining, $result, var$4, $that, var$6;
        $remaining = scm_Stack$_MODULE$;
        $result = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(jl_Object, 1);
        var$4.data[0] = $this.$foldedOver0;
        $remaining = $remaining.$from0(sr_ScalaRunTime$_genericWrapArray($result, var$4));
        $result = scm_ListBuffer$_MODULE$.$from0(sci_Nil$_MODULE$);
        while (sc_IterableOnceOps_nonEmpty$($remaining)) {
            $that = scm_Stack_pop($remaining);
            if ($that !== null) {
                var$6 = $evidence$3.$unapply0($that);
                if (!s_Option_isEmpty(var$6) && var$6.$get0() instanceof jl_Object)
                    $result.$addOne($that);
            }
            scm_Stack_pushAll($remaining, onciu_Foldable$TreeAny$_reverseTreeChildren$extension(onciu_Foldable$TreeAny$_MODULE$, $that));
        }
        return sc_IterableOnceOps_toSeq$($result);
    }
    function oncias_SemanticCheckResult() {
        var a = this; jl_Object.call(a);
        a.$state = null;
        a.$errors = null;
    }
    function oncias_SemanticCheckResult__init_(var_0, var_1) {
        var var_2 = new oncias_SemanticCheckResult();
        oncias_SemanticCheckResult__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function oncias_SemanticCheckResult_productPrefix($this) {
        return $rt_s(510);
    }
    function oncias_SemanticCheckResult_productArity($this) {
        return 2;
    }
    function oncias_SemanticCheckResult_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$state;
            case 1:
                return $this.$errors;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticCheckResult_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticCheckResult_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticCheckResult_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticCheckResult_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_SemanticCheckResult) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$state;
                            var$3 = $x$1.$state;
                            if (var$2 !== null) {
                                if (!oncias_SemanticState_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$errors;
                        $x$1 = $x$1.$errors;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncias_SemanticCheckResult__init_0($this, $state, $errors) {
        $this.$state = $state;
        $this.$errors = $errors;
    }
    function oncirr_computeDependenciesForExpressions$$anonfun$1() {
        sr_AbstractPartialFunction.call(this);
        this.$$outer0 = null;
    }
    function oncirr_computeDependenciesForExpressions$$anonfun$1_applyOrElse($this, $x1, $default) {
        var $declarations, $dependencies;
        if (!$rt_isInstance($x1, oncie_ExpressionWithComputedDependencies))
            return $default.$apply($x1);
        $x1 = $x1;
        $default = oncias_SemanticState$ScopeLocation$_declarationsAndDependencies$extension(oncias_SemanticState$ScopeLocation$_MODULE$, ($this.$$outer0.$semanticState.$recordedScopes.$apply(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $x1.$subqueryAstNode()))).$location);
        if ($default === null)
            $rt_throw(s_MatchError__init_($default));
        $declarations = $default.$declarations;
        $dependencies = $default.$dependencies;
        $default = s_Tuple2__init_($declarations, $dependencies);
        $declarations = $default.$_10;
        $dependencies = $default.$_20;
        return ($x1.$withComputedIntroducedVariables($declarations.$map1(new oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_0))).$withComputedScopeDependencies($dependencies.$map1(new oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_1));
    }
    function onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_0() {
        var a = this; jl_Object.call(a);
        a.$_054 = null;
        a.$_115 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_0_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_054;
        if (!(var$1 instanceof onciu_StepSequencer$NegatedCondition)) {
            var$2 = sr_BoxedUnit_UNIT;
            return s_Tuple3__init_(var$1, var$2, var$2);
        }
        var$3 = new jl_IllegalArgumentException;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(201)), var$2), $rt_s(511)), var$1), $rt_s(512));
        jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$4));
        $rt_throw(var$3);
    }
    function onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_1() {
        jl_Object.call(this);
        this.$_055 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_1_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_055;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$1 = var$1.$_121;
        var$3 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        s_package$_$callClinit();
        return s_Predef$ArrowAssoc$_$minus$greater$extension(var$3, var$1, su_Right$_apply(s_package$_Right(s_package$_MODULE$), var$2));
    }
    var sci_HashMap$ = $rt_classWithoutFields();
    var sci_HashMap$_MODULE$ = null;
    var sci_HashMap$_EmptyMap = null;
    function sci_HashMap$_$callClinit() {
        sci_HashMap$_$callClinit = $rt_eraseClinit(sci_HashMap$);
        sci_HashMap$__clinit_();
    }
    function sci_HashMap$__clinit_() {
        var var$1, var$2;
        var$1 = new sci_HashMap$;
        sci_HashMap$_$callClinit();
        sci_HashMap$_MODULE$ = var$1;
        var$2 = new sci_HashMap;
        sci_MapNode$_$callClinit();
        sci_HashMap__init_(var$2, sci_MapNode$_empty(sci_MapNode$_MODULE$));
        sci_HashMap$_EmptyMap = var$2;
    }
    function sci_HashMap$_empty($this) {
        sci_HashMap$_$callClinit();
        return sci_HashMap$_EmptyMap;
    }
    function sci_HashMap$_newBuilder($this) {
        return sci_HashMapBuilder__init_();
    }
    function sci_HashMap$_from($this, $it) {
        return $it instanceof sci_HashMap ? $it : sci_HashMapBuilder_result(sci_HashMapBuilder_addAll(sci_HashMapBuilder__init_(), $it));
    }
    function sc_IterableOps$groupBy$lambda$_72_0() {
        jl_Object.call(this);
        this.$_05 = null;
    }
    function sc_IterableOps$groupBy$lambda$_72_0_apply(var$0) {
        return var$0.$_05.$newSpecificBuilder();
    }
    function onciu_StepSequencer$MutableDirectedGraph$$$anonfun$copyOf$2$lambda$_4_0() {
        var a = this; jl_Object.call(a);
        a.$_0157 = null;
        a.$_126 = null;
    }
    function onciu_StepSequencer$MutableDirectedGraph$$$anonfun$copyOf$2$lambda$_4_0_apply(var$0, var$1) {
        onciu_StepSequencer$MutableDirectedGraph_connect(var$0.$_0157, var$0.$_126, var$1);
        return sr_BoxedUnit_UNIT;
    }
    function onciu_StepSequencer$MutableDirectedGraph$$anonfun$toString$2$lambda$_10_0() {
        jl_Object.call(this);
        this.$_0156 = null;
    }
    function onciu_StepSequencer$MutableDirectedGraph$$anonfun$toString$2$lambda$_10_0_apply(var$0, var$1) {
        var var$2, var$3;
        var$2 = var$0.$_0156;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(424)), var$2), $rt_s(513)), var$1), $rt_s(425));
        return jl_AbstractStringBuilder_toString(var$3);
    }
    function onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_0() {
        jl_Object.call(this);
        this.$_057 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_0_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_057;
        if (!(var$1 instanceof onciu_StepSequencer$NegatedCondition))
            return s_Tuple2__init_(var$1, sr_BoxedUnit_UNIT);
        var$3 = new jl_IllegalArgumentException;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(201)), var$2), $rt_s(514)), var$1), $rt_s(512));
        jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$4));
        $rt_throw(var$3);
    }
    function onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_1() {
        jl_Object.call(this);
        this.$_058 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_1_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_058;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$1 = var$1.$_10;
        var$3 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        return s_Predef$ArrowAssoc$_$minus$greater$extension(var$3, var$1, var$2);
    }
    function onciu_StepSequencer$$anonfun$$nestedInanonfun$sort$2$1() {
        sr_AbstractPartialFunction.call(this);
        this.$introducingSteps$2 = null;
    }
    function onciu_StepSequencer$$anonfun$$nestedInanonfun$sort$2$1_applyOrElse($this, $x, $default) {
        $x = $x;
        return !$this.$introducingSteps$2.$contains0($x) ? $default.$apply($x) : $this.$introducingSteps$2.$apply($x);
    }
    var oncias_Scope$ = $rt_classWithoutFields();
    var oncias_Scope$_MODULE$ = null;
    var oncias_Scope$_empty0 = null;
    function oncias_Scope$_$callClinit() {
        oncias_Scope$_$callClinit = $rt_eraseClinit(oncias_Scope$);
        oncias_Scope$__clinit_();
    }
    function oncias_Scope$__clinit_() {
        var var$1, var$2, var$3;
        var$1 = new oncias_Scope$;
        oncias_Scope$_$callClinit();
        oncias_Scope$_MODULE$ = var$1;
        var$2 = new oncias_Scope;
        sci_HashMap$_$callClinit();
        var$3 = sci_HashMap$_empty(sci_HashMap$_MODULE$);
        s_package$_$callClinit();
        oncias_Scope__init_(var$2, var$3, (s_package$_Vector0(s_package$_MODULE$)).$from0(sci_Nil$_MODULE$));
        oncias_Scope$_empty0 = var$2;
    }
    function oncias_Scope$_empty($this) {
        oncias_Scope$_$callClinit();
        return oncias_Scope$_empty0;
    }
    function onciuh_TreeZipper() {
        var a = this; jl_Object.call(a);
        a.$Top$module = null;
        a.$org$neo4j$cypher$internal$util$helpers$TreeZipper$$evidence$1 = null;
    }
    function onciuh_TreeZipper_Top($this) {
        var var$1, $$je;
        if ($this.$Top$module === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$Top$module !== null)
                        break a;
                    $this.$Top$module = onciuh_TreeZipper$Top$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$Top$module;
    }
    var oncias_SemanticState$ScopeZipper$ = $rt_classWithoutFields(onciuh_TreeZipper);
    var oncias_SemanticState$ScopeZipper$_MODULE$ = null;
    function oncias_SemanticState$ScopeZipper$_$callClinit() {
        oncias_SemanticState$ScopeZipper$_$callClinit = $rt_eraseClinit(oncias_SemanticState$ScopeZipper$);
        oncias_SemanticState$ScopeZipper$__clinit_();
    }
    function oncias_SemanticState$ScopeZipper$__clinit_() {
        var var$1;
        var$1 = new oncias_SemanticState$ScopeZipper$;
        oncias_SemanticState$ScopeZipper$_$callClinit();
        sr_ClassTag$_$callClinit();
        var$1.$org$neo4j$cypher$internal$util$helpers$TreeZipper$$evidence$1 = sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncias_Scope));
        oncias_SemanticState$ScopeZipper$_MODULE$ = var$1;
    }
    var oncia_ASTAnnotationMap$ = $rt_classWithoutFields();
    var oncia_ASTAnnotationMap$_MODULE$ = null;
    function oncia_ASTAnnotationMap$__clinit_() {
        oncia_ASTAnnotationMap$_MODULE$ = new oncia_ASTAnnotationMap$;
    }
    function oncia_ASTAnnotationMap$_empty($this) {
        s_Predef$_$callClinit();
        s_Predef$_Map(s_Predef$_MODULE$);
        return sci_Map$EmptyMap$_MODULE$;
    }
    var sci_StrictOptimizedMapOps = $rt_classWithoutFields(0);
    function sci_HashMap() {
        sci_AbstractMap.call(this);
        this.$rootNode = null;
    }
    function sci_HashMap__init_0(var_0) {
        var var_1 = new sci_HashMap();
        sci_HashMap__init_(var_1, var_0);
        return var_1;
    }
    function sci_HashMap_map($this, $f) {
        var var$2, var$3, var$4;
        var$2 = sci_HashMap$_newBuilder(sci_HashMap_mapFactory($this));
        var$3 = sci_HashMap_iterator($this);
        while (true) {
            if (!var$3.$hasNext())
                return sci_HashMapBuilder_result(var$2);
            var$4 = oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_6_apply($f, var$3.$next());
            if (var$2 === null)
                break;
            sci_HashMapBuilder_addOne(var$2, var$4);
        }
        $rt_throw(null);
    }
    function sci_HashMap_collect($this, $pf) {
        var var$2, var$3, var$4, var$5, var$6;
        var$2 = sci_HashMap$_newBuilder(sci_HashMap_mapFactory($this));
        var$3 = sr_Statics_pfMarker;
        var$4 = sci_HashMap_iterator($this);
        while (true) {
            if (!var$4.$hasNext())
                return sci_HashMapBuilder_result(var$2);
            var$5 = var$4.$next();
            var$6 = new sc_StrictOptimizedMapOps$collect$lambda$_7_0;
            var$6.$_0217 = var$3;
            var$5 = $pf.$applyOrElse(var$5, var$6);
            if (var$3 === var$5)
                continue;
            if (var$2 === null)
                break;
            sci_HashMapBuilder_addOne(var$2, var$5);
        }
        $rt_throw(null);
    }
    function sci_HashMap_map0($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function sci_HashMap_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_HashMap_collect0($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_HashMap_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_HashMap_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_HashMap_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_HashMap_rootNode($this) {
        return $this.$rootNode;
    }
    function sci_HashMap_mapFactory($this) {
        sci_HashMap$_$callClinit();
        return sci_HashMap$_MODULE$;
    }
    function sci_HashMap_knownSize($this) {
        return $this.$rootNode.$size6;
    }
    function sci_HashMap_size($this) {
        return $this.$rootNode.$size6;
    }
    function sci_HashMap_isEmpty($this) {
        if ($this.$rootNode.$size6)
            return 0;
        return 1;
    }
    function sci_HashMap_keySet($this) {
        var var$1;
        if (!sci_HashMap_size($this))
            return sci_Set$EmptySet$_MODULE$;
        var$1 = new sci_HashMap$HashKeySet;
        sci_MapOps$ImmutableKeySet__init_0(var$1, $this);
        return var$1;
    }
    function sci_HashMap_iterator($this) {
        var var$1;
        if (sci_HashMap_isEmpty($this))
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new sci_MapKeyValueTupleIterator;
        sci_ChampBaseIterator__init_(var$1, $this.$rootNode);
        return var$1;
    }
    function sci_HashMap_keysIterator($this) {
        var var$1;
        if (sci_HashMap_isEmpty($this))
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new sci_MapKeyIterator;
        sci_ChampBaseIterator__init_(var$1, $this.$rootNode);
        return var$1;
    }
    function sci_HashMap_valuesIterator($this) {
        var var$1;
        if (sci_HashMap_isEmpty($this))
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        var$1 = new sci_MapValueIterator;
        sci_ChampBaseIterator__init_(var$1, $this.$rootNode);
        return var$1;
    }
    function sci_HashMap_contains($this, $key) {
        var $keyUnimprovedHash, $keyHash;
        $keyUnimprovedHash = sr_Statics_anyHash($key);
        $keyHash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $keyUnimprovedHash);
        return sci_BitmapIndexedMapNode_containsKey($this.$rootNode, $key, $keyUnimprovedHash, $keyHash, 0);
    }
    function sci_HashMap_apply($this, $key) {
        var $keyUnimprovedHash, $keyHash;
        $keyUnimprovedHash = sr_Statics_anyHash($key);
        $keyHash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $keyUnimprovedHash);
        return sci_BitmapIndexedMapNode_apply($this.$rootNode, $key, $keyUnimprovedHash, $keyHash, 0);
    }
    function sci_HashMap_get($this, $key) {
        var $keyUnimprovedHash, $keyHash;
        $keyUnimprovedHash = sr_Statics_anyHash($key);
        $keyHash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $keyUnimprovedHash);
        return sci_BitmapIndexedMapNode_get($this.$rootNode, $key, $keyUnimprovedHash, $keyHash, 0);
    }
    function sci_HashMap_getOrElse($this, $key, $default) {
        var $keyUnimprovedHash, $keyHash, $getOrElse_this, $getOrElse_mask, $getOrElse_bitpos, var$8, $getOrElse_index, var$10;
        $keyUnimprovedHash = sr_Statics_anyHash($key);
        $keyHash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $keyUnimprovedHash);
        $getOrElse_this = $this.$rootNode;
        if ($getOrElse_this === null)
            $rt_throw(null);
        $getOrElse_mask = $keyHash >>> 0 & 31;
        $getOrElse_bitpos = 1 << $getOrElse_mask;
        var$8 = $getOrElse_this.$dataMap1;
        if (!(var$8 & $getOrElse_bitpos)) {
            var$8 = $getOrElse_this.$nodeMap1;
            if (!(var$8 & $getOrElse_bitpos))
                return $default.$apply2();
            return (sci_BitmapIndexedMapNode_getNode($getOrElse_this, sci_Node$_indexFrom(sci_Node$_MODULE$, var$8, $getOrElse_mask, $getOrElse_bitpos))).$getOrElse1($key, $keyUnimprovedHash, $keyHash, 5, $default);
        }
        $getOrElse_index = sci_Node$_indexFrom(sci_Node$_MODULE$, var$8, $getOrElse_mask, $getOrElse_bitpos);
        var$10 = $getOrElse_this.$content.data;
        $keyUnimprovedHash = 2 * $getOrElse_index | 0;
        if (!sr_BoxesRunTime_equals($key, var$10[$keyUnimprovedHash]))
            return $default.$apply2();
        return $getOrElse_this.$content.data[$keyUnimprovedHash + 1 | 0];
    }
    function sci_HashMap_updated($this, $key, $value) {
        var $keyUnimprovedHash, $newHashMapOrThis_newRootNode;
        $keyUnimprovedHash = sr_Statics_anyHash($key);
        $newHashMapOrThis_newRootNode = sci_BitmapIndexedMapNode_updated($this.$rootNode, $key, $value, $keyUnimprovedHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $keyUnimprovedHash), 0, 1);
        if ($newHashMapOrThis_newRootNode === $this.$rootNode)
            return $this;
        return sci_HashMap__init_0($newHashMapOrThis_newRootNode);
    }
    function sci_HashMap_concat($this, $that) {
        var $it, $accum, $newHashMapOrThis_newRootNode, $iter, $current, $next, $originalHash, $improved, $shallowlyMutableNodeMap, $current_0;
        if ($that instanceof sci_HashMap) {
            $that = $that;
            if (sci_HashMap_isEmpty($this))
                return $that;
            $it = sci_BitmapIndexedMapNode_concat($this.$rootNode, $that.$rootNode, 0);
            $accum = $that.$rootNode;
            if ($it === $accum)
                return $that;
            $newHashMapOrThis_newRootNode = sci_BitmapIndexedMapNode_concat($this.$rootNode, $accum, 0);
            if ($newHashMapOrThis_newRootNode === $this.$rootNode)
                return $this;
            return sci_HashMap__init_0($newHashMapOrThis_newRootNode);
        }
        if ($that instanceof scm_HashMap) {
            $that = $that;
            $iter = $that.$nodeIterator();
            $current = $this.$rootNode;
            while ($iter.$hasNext()) {
                $next = $iter.$next();
                $originalHash = $that.$unimproveHash($next.$_hash);
                $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
                $current = sci_BitmapIndexedMapNode_updated($current, $next.$_key, $next.$_value, $originalHash, $improved, 0, 1);
                if ($current !== $this.$rootNode) {
                    $shallowlyMutableNodeMap = 1 << ($improved >>> 0 & 31);
                    while ($iter.$hasNext()) {
                        $next = $iter.$next();
                        $originalHash = $that.$unimproveHash($next.$_hash);
                        $shallowlyMutableNodeMap = sci_BitmapIndexedMapNode_updateWithShallowMutations($current, $next.$_key, $next.$_value, $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0, $shallowlyMutableNodeMap);
                    }
                    return sci_HashMap__init_0($current);
                }
            }
            return $this;
        }
        if (!($that instanceof scm_LinkedHashMap)) {
            if ($rt_isInstance($that, sci_Map)) {
                $that = $that;
                if ($that.$isEmpty())
                    return $this;
                $accum = sci_HashMap$accum$1__init_($this);
                $that.$foreachEntry($accum);
                $newHashMapOrThis_newRootNode = $accum.$current1;
                if ($newHashMapOrThis_newRootNode === $this.$rootNode)
                    return $this;
                return sci_HashMap__init_0($newHashMapOrThis_newRootNode);
            }
            $it = $that.$iterator0();
            if ($it.$isEmpty())
                return $this;
            $accum = sci_HashMap$accum$1__init_($this);
            $it.$foreach($accum);
            $newHashMapOrThis_newRootNode = $accum.$current1;
            if ($newHashMapOrThis_newRootNode === $this.$rootNode)
                return $this;
            return sci_HashMap__init_0($newHashMapOrThis_newRootNode);
        }
        $that = $that;
        $iter = $that.$entryIterator();
        $current_0 = $this.$rootNode;
        while ($iter.$hasNext()) {
            $next = $iter.$next();
            $originalHash = $that.$unimproveHash(scm_LinkedHashMap$LinkedEntry_hash($next));
            $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
            $current_0 = sci_BitmapIndexedMapNode_updated($current_0, scm_LinkedHashMap$LinkedEntry_key($next), scm_LinkedHashMap$LinkedEntry_value($next), $originalHash, $improved, 0, 1);
            if ($current_0 !== $this.$rootNode) {
                $shallowlyMutableNodeMap = 1 << ($improved >>> 0 & 31);
                while ($iter.$hasNext()) {
                    $next = $iter.$next();
                    $originalHash = $that.$unimproveHash(scm_LinkedHashMap$LinkedEntry_hash($next));
                    $shallowlyMutableNodeMap = sci_BitmapIndexedMapNode_updateWithShallowMutations($current_0, scm_LinkedHashMap$LinkedEntry_key($next), scm_LinkedHashMap$LinkedEntry_value($next), $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0, $shallowlyMutableNodeMap);
                }
                return sci_HashMap__init_0($current_0);
            }
        }
        return $this;
    }
    function sci_HashMap_foreach($this, $f) {
        var $foreach_this, $foreach_iN, $foreach_i, $foreach_jN, $foreach_j;
        $foreach_this = $this.$rootNode;
        if ($foreach_this === null)
            $rt_throw(null);
        $foreach_iN = sci_BitmapIndexedMapNode_payloadArity($foreach_this);
        $foreach_i = 0;
        while ($foreach_i < $foreach_iN) {
            $f.$apply(sci_BitmapIndexedMapNode_getPayload($foreach_this, $foreach_i));
            $foreach_i = $foreach_i + 1 | 0;
        }
        $foreach_jN = sci_BitmapIndexedMapNode_nodeArity($foreach_this);
        $foreach_j = 0;
        while ($foreach_j < $foreach_jN) {
            (sci_BitmapIndexedMapNode_getNode($foreach_this, $foreach_j)).$foreach($f);
            $foreach_j = $foreach_j + 1 | 0;
        }
    }
    function sci_HashMap_foreachEntry($this, $f) {
        var $foreachEntry_this, $foreachEntry_iN, $foreachEntry_i, var$5, $foreachEntry_jN, $foreachEntry_j;
        $foreachEntry_this = $this.$rootNode;
        if ($foreachEntry_this === null)
            $rt_throw(null);
        $foreachEntry_iN = sci_BitmapIndexedMapNode_payloadArity($foreachEntry_this);
        $foreachEntry_i = 0;
        while ($foreachEntry_i < $foreachEntry_iN) {
            var$5 = $foreachEntry_this.$content.data;
            $foreachEntry_jN = 2 * $foreachEntry_i | 0;
            $f.$apply0(var$5[$foreachEntry_jN], var$5[$foreachEntry_jN + 1 | 0]);
            $foreachEntry_i = $foreachEntry_i + 1 | 0;
        }
        $foreachEntry_jN = sci_BitmapIndexedMapNode_nodeArity($foreachEntry_this);
        $foreachEntry_j = 0;
        while ($foreachEntry_j < $foreachEntry_jN) {
            (sci_BitmapIndexedMapNode_getNode($foreachEntry_this, $foreachEntry_j)).$foreachEntry($f);
            $foreachEntry_j = $foreachEntry_j + 1 | 0;
        }
    }
    function sci_HashMap_equals($this, $that) {
        var var$2;
        if (!($that instanceof sci_HashMap))
            return sc_Map_equals$($this, $that);
        a: {
            b: {
                $that = $that;
                if ($this !== $that) {
                    var$2 = $this.$rootNode;
                    $that = $that.$rootNode;
                    if (var$2 !== null) {
                        if (!sci_BitmapIndexedMapNode_equals(var$2, $that))
                            break a;
                        else
                            break b;
                    }
                    if ($that !== null)
                        break a;
                }
            }
            return 1;
        }
        return 0;
    }
    function sci_HashMap_hashCode($this) {
        var $hashIterator, var$2, var$3;
        if (sci_HashMap_isEmpty($this)) {
            suh_MurmurHash3$_$callClinit();
            return suh_MurmurHash3$_emptyMapHash(suh_MurmurHash3$_MODULE$);
        }
        $hashIterator = new sci_MapKeyValueTupleHashIterator;
        var$2 = $this.$rootNode;
        $hashIterator.$currentValueCursor0 = (-1);
        $hashIterator.$currentStackLevel0 = (-1);
        var$3 = sci_Node$_MaxDepth + 1 | 0;
        $hashIterator.$nodeIndex0 = $rt_createIntArray(var$3);
        $hashIterator.$nodeStack = $rt_createArray(sci_Node, var$3);
        sci_ChampBaseReverseIterator_pushNode($hashIterator, var$2);
        sci_ChampBaseReverseIterator_searchNextValueNode($hashIterator);
        $hashIterator.$hash4 = 0;
        suh_MurmurHash3$_$callClinit();
        var$2 = suh_MurmurHash3$_MODULE$;
        return suh_MurmurHash3_unorderedHash(var$2, $hashIterator, suh_MurmurHash3$_mapSeed(var$2));
    }
    function sci_HashMap_className($this) {
        return $rt_s(439);
    }
    function sci_HashMap_filterImpl($this, $pred, $isFlipped) {
        var $newRootNode, $filterImpl_i, $filterImpl_maximumIndex, $filterImpl_newDataMap, $filterImpl_newCachedHashCode, $filterImpl_dataIndex, $filterImpl_bitpos, $filterImpl_newSize, $filterImpl_newContent, var$12, $filterImpl_newOriginalHashCodes, var$14, $filterImpl_newMaximumIndex, $filterImpl_j, $filterImpl_newDataIndex, $filterImpl_oldIndex, $filterImpl_newOriginalHashes, $filterImpl_newAllMap, $filterImpl_allMap, $filterImpl_minimumIndex, $filterImpl_oldDataPassThrough, $filterImpl_nodeMigrateToDataTargetMap,
        $filterImpl_nodesToMigrateToData, $filterImpl_nodesToPassThroughMap, $filterImpl_mapOfNewNodes, $filterImpl_newNodes, $filterImpl_newNodeMap, $filterImpl_nodeIndex, $filterImpl_oldSubNode, $filterImpl_newSubNode, $filterImpl_newDataSize, $filterImpl_newContentSize, $filterImpl_maxIndex, $filterImpl_oldDataIndex, $filterImpl_oldNodeIndex, $filterImpl_newNodeIndex, $filterImpl_node;
        $newRootNode = sci_HashMap_rootNode($this);
        if ($newRootNode === null)
            $rt_throw(null);
        if (sci_BitmapIndexedMapNode_size($newRootNode)) {
            if (sci_BitmapIndexedMapNode_size($newRootNode) == 1) {
                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(sci_BitmapIndexedMapNode_getPayload($newRootNode, 0))) == $isFlipped) {
                    sci_MapNode$_$callClinit();
                    $newRootNode = sci_MapNode$_empty(sci_MapNode$_MODULE$);
                }
            } else if (!sci_BitmapIndexedMapNode_nodeMap($newRootNode)) {
                $filterImpl_i = jl_Integer_numberOfTrailingZeros(sci_BitmapIndexedMapNode_dataMap($newRootNode));
                $filterImpl_maximumIndex = 32 - jl_Integer_numberOfLeadingZeros(sci_BitmapIndexedMapNode_dataMap($newRootNode)) | 0;
                $filterImpl_newDataMap = 0;
                $filterImpl_newCachedHashCode = 0;
                $filterImpl_dataIndex = 0;
                while ($filterImpl_i < $filterImpl_maximumIndex) {
                    $filterImpl_bitpos = 1 << $filterImpl_i;
                    if ($filterImpl_bitpos & sci_BitmapIndexedMapNode_dataMap($newRootNode)) {
                        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(sci_BitmapIndexedMapNode_getPayload($newRootNode, $filterImpl_dataIndex))) == $isFlipped ? 0 : 1) {
                            $filterImpl_newDataMap = $filterImpl_newDataMap | $filterImpl_bitpos;
                            $filterImpl_newCachedHashCode = $filterImpl_newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, (sci_BitmapIndexedMapNode_originalHashes($newRootNode)).data[$filterImpl_dataIndex]) | 0;
                        }
                        $filterImpl_dataIndex = $filterImpl_dataIndex + 1 | 0;
                    }
                    $filterImpl_i = $filterImpl_i + 1 | 0;
                }
                if (!$filterImpl_newDataMap) {
                    sci_MapNode$_$callClinit();
                    $newRootNode = sci_MapNode$_empty(sci_MapNode$_MODULE$);
                } else if ($filterImpl_newDataMap != sci_BitmapIndexedMapNode_dataMap($newRootNode)) {
                    $filterImpl_newSize = jl_Integer_bitCount($filterImpl_newDataMap);
                    $filterImpl_newContent = $rt_createArray(jl_Object, $filterImpl_newSize * 2 | 0);
                    var$12 = $filterImpl_newContent.data;
                    $filterImpl_newOriginalHashCodes = $rt_createIntArray($filterImpl_newSize);
                    var$14 = $filterImpl_newOriginalHashCodes.data;
                    $filterImpl_newMaximumIndex = 32 - jl_Integer_numberOfLeadingZeros($filterImpl_newDataMap) | 0;
                    $filterImpl_j = jl_Integer_numberOfTrailingZeros($filterImpl_newDataMap);
                    $filterImpl_newDataIndex = 0;
                    while ($filterImpl_j < $filterImpl_newMaximumIndex) {
                        $filterImpl_bitpos = 1 << $filterImpl_j;
                        if ($filterImpl_bitpos & $filterImpl_newDataMap) {
                            $filterImpl_oldIndex = jl_Integer_bitCount(sci_BitmapIndexedMapNode_dataMap($newRootNode) & ($filterImpl_bitpos - 1 | 0));
                            $isFlipped = $filterImpl_newDataIndex * 2 | 0;
                            $filterImpl_newOriginalHashes = (sci_BitmapIndexedMapNode_content($newRootNode)).data;
                            $filterImpl_newAllMap = $filterImpl_oldIndex * 2 | 0;
                            var$12[$isFlipped] = $filterImpl_newOriginalHashes[$filterImpl_newAllMap];
                            var$12[$isFlipped + 1 | 0] = (sci_BitmapIndexedMapNode_content($newRootNode)).data[$filterImpl_newAllMap + 1 | 0];
                            var$14[$filterImpl_newDataIndex] = (sci_BitmapIndexedMapNode_originalHashes($newRootNode)).data[$filterImpl_oldIndex];
                            $filterImpl_newDataIndex = $filterImpl_newDataIndex + 1 | 0;
                        }
                        $filterImpl_j = $filterImpl_j + 1 | 0;
                    }
                    $newRootNode = sci_BitmapIndexedMapNode__init_($filterImpl_newDataMap, 0, $filterImpl_newContent, $filterImpl_newOriginalHashCodes, $filterImpl_newSize, $filterImpl_newCachedHashCode);
                }
            } else {
                $filterImpl_allMap = sci_BitmapIndexedMapNode_dataMap($newRootNode) | sci_BitmapIndexedMapNode_nodeMap($newRootNode);
                $filterImpl_minimumIndex = jl_Integer_numberOfTrailingZeros($filterImpl_allMap);
                $filterImpl_maximumIndex = 32 - jl_Integer_numberOfLeadingZeros($filterImpl_allMap) | 0;
                $filterImpl_oldDataPassThrough = 0;
                $filterImpl_nodeMigrateToDataTargetMap = 0;
                $filterImpl_nodesToMigrateToData = null;
                $filterImpl_nodesToPassThroughMap = 0;
                $filterImpl_mapOfNewNodes = 0;
                $filterImpl_newNodes = null;
                $filterImpl_newDataMap = 0;
                $filterImpl_newNodeMap = 0;
                $filterImpl_newSize = 0;
                $filterImpl_newCachedHashCode = 0;
                $filterImpl_dataIndex = 0;
                $filterImpl_nodeIndex = 0;
                $filterImpl_i = $filterImpl_minimumIndex;
                while ($filterImpl_i < $filterImpl_maximumIndex) {
                    $filterImpl_bitpos = 1 << $filterImpl_i;
                    if ($filterImpl_bitpos & sci_BitmapIndexedMapNode_dataMap($newRootNode)) {
                        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(sci_BitmapIndexedMapNode_getPayload($newRootNode, $filterImpl_dataIndex))) == $isFlipped ? 0 : 1) {
                            $filterImpl_newDataMap = $filterImpl_newDataMap | $filterImpl_bitpos;
                            $filterImpl_oldDataPassThrough = $filterImpl_oldDataPassThrough | $filterImpl_bitpos;
                            $filterImpl_newSize = $filterImpl_newSize + 1 | 0;
                            $filterImpl_newCachedHashCode = $filterImpl_newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, (sci_BitmapIndexedMapNode_originalHashes($newRootNode)).data[$filterImpl_dataIndex]) | 0;
                        }
                        $filterImpl_dataIndex = $filterImpl_dataIndex + 1 | 0;
                    } else if ($filterImpl_bitpos & sci_BitmapIndexedMapNode_nodeMap($newRootNode)) {
                        $filterImpl_oldSubNode = sci_BitmapIndexedMapNode_getNode($newRootNode, $filterImpl_nodeIndex);
                        $filterImpl_newSubNode = $filterImpl_oldSubNode.$filterImpl4($pred, $isFlipped);
                        $filterImpl_newSize = $filterImpl_newSize + $filterImpl_newSubNode.$size() | 0;
                        $filterImpl_newCachedHashCode = $filterImpl_newCachedHashCode + $filterImpl_newSubNode.$cachedJavaKeySetHashCode() | 0;
                        if ($filterImpl_newSubNode.$size() > 1) {
                            $filterImpl_newNodeMap = $filterImpl_newNodeMap | $filterImpl_bitpos;
                            if ($filterImpl_oldSubNode === $filterImpl_newSubNode)
                                $filterImpl_nodesToPassThroughMap = $filterImpl_nodesToPassThroughMap | $filterImpl_bitpos;
                            else {
                                $filterImpl_mapOfNewNodes = $filterImpl_mapOfNewNodes | $filterImpl_bitpos;
                                if ($filterImpl_newNodes === null)
                                    $filterImpl_newNodes = scm_Queue$_empty(scm_Queue$_MODULE$);
                                scm_AbstractBuffer_$plus$eq($filterImpl_newNodes, $filterImpl_newSubNode);
                            }
                        } else if ($filterImpl_newSubNode.$size() == 1) {
                            $filterImpl_newDataMap = $filterImpl_newDataMap | $filterImpl_bitpos;
                            $filterImpl_nodeMigrateToDataTargetMap = $filterImpl_nodeMigrateToDataTargetMap | $filterImpl_bitpos;
                            if ($filterImpl_nodesToMigrateToData === null)
                                $filterImpl_nodesToMigrateToData = sc_IterableFactory_apply$(scm_Queue$_MODULE$, sci_Nil$_MODULE$);
                            scm_AbstractBuffer_$plus$eq($filterImpl_nodesToMigrateToData, $filterImpl_newSubNode);
                        }
                        $filterImpl_nodeIndex = $filterImpl_nodeIndex + 1 | 0;
                    }
                    $filterImpl_i = $filterImpl_i + 1 | 0;
                }
                if (!$filterImpl_newSize) {
                    sci_MapNode$_$callClinit();
                    $newRootNode = sci_MapNode$_empty(sci_MapNode$_MODULE$);
                } else if ($filterImpl_newSize != sci_BitmapIndexedMapNode_size($newRootNode)) {
                    $filterImpl_newDataSize = jl_Integer_bitCount($filterImpl_newDataMap);
                    $filterImpl_newContentSize = (2 * $filterImpl_newDataSize | 0) + jl_Integer_bitCount($filterImpl_newNodeMap) | 0;
                    $filterImpl_newContent = $rt_createArray(jl_Object, $filterImpl_newContentSize);
                    $filterImpl_newOriginalHashCodes = $filterImpl_newContent.data;
                    $filterImpl_newOriginalHashes = $rt_createIntArray($filterImpl_newDataSize);
                    var$14 = $filterImpl_newOriginalHashes.data;
                    $filterImpl_maxIndex = 32 - jl_Integer_numberOfLeadingZeros($filterImpl_newDataMap | $filterImpl_newNodeMap) | 0;
                    $filterImpl_oldDataIndex = 0;
                    $filterImpl_oldNodeIndex = 0;
                    $filterImpl_newDataIndex = 0;
                    $filterImpl_newNodeIndex = 0;
                    while ($filterImpl_minimumIndex < $filterImpl_maxIndex) {
                        $filterImpl_bitpos = 1 << $filterImpl_minimumIndex;
                        if ($filterImpl_bitpos & $filterImpl_oldDataPassThrough) {
                            $isFlipped = $filterImpl_newDataIndex * 2 | 0;
                            var$12 = (sci_BitmapIndexedMapNode_content($newRootNode)).data;
                            $filterImpl_newAllMap = 2 * $filterImpl_oldDataIndex | 0;
                            $filterImpl_newOriginalHashCodes[$isFlipped] = var$12[$filterImpl_newAllMap];
                            $filterImpl_newOriginalHashCodes[$isFlipped + 1 | 0] = (sci_BitmapIndexedMapNode_content($newRootNode)).data[$filterImpl_newAllMap + 1 | 0];
                            var$14[$filterImpl_newDataIndex] = (sci_BitmapIndexedMapNode_originalHashes($newRootNode)).data[$filterImpl_oldDataIndex];
                            $filterImpl_newDataIndex = $filterImpl_newDataIndex + 1 | 0;
                            $filterImpl_oldDataIndex = $filterImpl_oldDataIndex + 1 | 0;
                        } else if ($filterImpl_bitpos & $filterImpl_nodesToPassThroughMap) {
                            $filterImpl_newOriginalHashCodes[($filterImpl_newContentSize - $filterImpl_newNodeIndex | 0) - 1 | 0] = sci_BitmapIndexedMapNode_getNode($newRootNode, $filterImpl_oldNodeIndex);
                            $filterImpl_newNodeIndex = $filterImpl_newNodeIndex + 1 | 0;
                            $filterImpl_oldNodeIndex = $filterImpl_oldNodeIndex + 1 | 0;
                        } else if ($filterImpl_bitpos & $filterImpl_nodeMigrateToDataTargetMap) {
                            $filterImpl_node = scm_Queue_dequeue($filterImpl_nodesToMigrateToData);
                            $isFlipped = 2 * $filterImpl_newDataIndex | 0;
                            $filterImpl_newOriginalHashCodes[$isFlipped] = $filterImpl_node.$getKey(0);
                            $filterImpl_newOriginalHashCodes[$isFlipped + 1 | 0] = $filterImpl_node.$getValue(0);
                            var$14[$filterImpl_newDataIndex] = $filterImpl_node.$getHash(0);
                            $filterImpl_newDataIndex = $filterImpl_newDataIndex + 1 | 0;
                            $filterImpl_oldNodeIndex = $filterImpl_oldNodeIndex + 1 | 0;
                        } else if ($filterImpl_bitpos & $filterImpl_mapOfNewNodes) {
                            $filterImpl_newOriginalHashCodes[($filterImpl_newContentSize - $filterImpl_newNodeIndex | 0) - 1 | 0] = scm_Queue_dequeue($filterImpl_newNodes);
                            $filterImpl_newNodeIndex = $filterImpl_newNodeIndex + 1 | 0;
                            $filterImpl_oldNodeIndex = $filterImpl_oldNodeIndex + 1 | 0;
                        } else if ($filterImpl_bitpos & sci_BitmapIndexedMapNode_dataMap($newRootNode))
                            $filterImpl_oldDataIndex = $filterImpl_oldDataIndex + 1 | 0;
                        else if ($filterImpl_bitpos & sci_BitmapIndexedMapNode_nodeMap($newRootNode))
                            $filterImpl_oldNodeIndex = $filterImpl_oldNodeIndex + 1 | 0;
                        $filterImpl_minimumIndex = $filterImpl_minimumIndex + 1 | 0;
                    }
                    $newRootNode = sci_BitmapIndexedMapNode__init_($filterImpl_newDataMap, $filterImpl_newNodeMap, $filterImpl_newContent, $filterImpl_newOriginalHashes, $filterImpl_newSize, $filterImpl_newCachedHashCode);
                }
            }
        }
        if ($newRootNode === sci_HashMap_rootNode($this))
            return $this;
        if (sci_BitmapIndexedMapNode_size($newRootNode))
            return sci_HashMap__init_0($newRootNode);
        sci_HashMap$_$callClinit();
        return sci_HashMap$_empty(sci_HashMap$_MODULE$);
    }
    function sci_HashMap_removedAll($this, $keys) {
        var $iter, $newRootNode, $originalHash, $curr, $next, $unimproveHash_improvedHash, $originalHash_0, $improved;
        if (sci_HashMap_isEmpty($this))
            return $this;
        if ($keys instanceof sci_HashSet) {
            $keys = $keys;
            if (sci_HashSet_isEmpty($keys))
                return $this;
            $iter = new sci_MapNodeRemoveAllSetNodeIterator;
            sci_ChampBaseIterator__init_($iter, $keys.$rootNode0);
            $newRootNode = $this.$rootNode;
            while ($newRootNode.$size6 > 0 && sci_ChampBaseIterator_hasNext($iter)) {
                $originalHash = $iter.$currentValueNode.$getHash($iter.$currentValueCursor);
                $newRootNode = sci_BitmapIndexedMapNode_removed($newRootNode, $iter.$currentValueNode.$getPayload($iter.$currentValueCursor), $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0);
                $iter.$currentValueCursor = $iter.$currentValueCursor + 1 | 0;
            }
            if ($newRootNode === $this.$rootNode)
                return $this;
            if ($newRootNode.$size6 > 0)
                return sci_HashMap__init_0($newRootNode);
            sci_HashMap$_$callClinit();
            return sci_HashMap$_empty(sci_HashMap$_MODULE$);
        }
        if ($keys instanceof scm_HashSet) {
            $keys = $keys;
            if (scm_HashSet_isEmpty($keys))
                return $this;
            $iter = new scm_HashSet$$anon$2;
            scm_HashSet$HashSetIterator__init_($iter, $keys);
            $curr = $this.$rootNode;
            while (true) {
                if (!scm_HashSet$HashSetIterator_hasNext($iter)) {
                    if ($curr === $this.$rootNode)
                        return $this;
                    return sci_HashMap__init_0($curr);
                }
                $next = scm_HashSet$HashSetIterator_next($iter);
                $unimproveHash_improvedHash = $next.$_hash0;
                $originalHash_0 = $unimproveHash_improvedHash ^ $unimproveHash_improvedHash >>> 16;
                $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash_0);
                $curr = sci_BitmapIndexedMapNode_removed($curr, $next.$_key0, $originalHash_0, $improved, 0);
                if (!$curr.$size6)
                    break;
            }
            sci_HashMap$_$callClinit();
            return sci_HashMap$_empty(sci_HashMap$_MODULE$);
        }
        if (!($keys instanceof scm_LinkedHashSet)) {
            $iter = $keys.$iterator0();
            $curr = $this.$rootNode;
            while (true) {
                if (!$iter.$hasNext()) {
                    if ($curr === $this.$rootNode)
                        return $this;
                    return sci_HashMap__init_0($curr);
                }
                $next = $iter.$next();
                $originalHash = sr_Statics_anyHash($next);
                $curr = sci_BitmapIndexedMapNode_removed($curr, $next, $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0);
                if (!$curr.$size6)
                    break;
            }
            sci_HashMap$_$callClinit();
            return sci_HashMap$_empty(sci_HashMap$_MODULE$);
        }
        $keys = $keys;
        if ($keys.$isEmpty())
            return $this;
        $iter = $keys.$entryIterator();
        $curr = $this.$rootNode;
        while (true) {
            if (!$iter.$hasNext()) {
                if ($curr === $this.$rootNode)
                    return $this;
                return sci_HashMap__init_0($curr);
            }
            $next = $iter.$next();
            $originalHash_0 = $keys.$unimproveHash(scm_LinkedHashSet$Entry_hash($next));
            $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash_0);
            $curr = sci_BitmapIndexedMapNode_removed($curr, scm_LinkedHashSet$Entry_key($next), $originalHash_0, $improved, 0);
            if (!$curr.$size6)
                break;
        }
        sci_HashMap$_$callClinit();
        return sci_HashMap$_empty(sci_HashMap$_MODULE$);
    }
    function sci_HashMap_removedAll0($this, $keys) {
        return sci_HashMap_removedAll($this, $keys);
    }
    function sci_HashMap_filterImpl0($this, $pred, $isFlipped) {
        return sci_HashMap_filterImpl($this, $pred, $isFlipped);
    }
    function sci_HashMap_head($this) {
        return (sci_HashMap_iterator($this)).$next();
    }
    function sci_HashMap_concat0($this, $suffix) {
        return sci_HashMap_concat($this, $suffix);
    }
    function sci_HashMap_removed($this, $key) {
        var var$2;
        var$2 = sr_Statics_anyHash($key);
        $key = sci_BitmapIndexedMapNode_removed($this.$rootNode, $key, var$2, sc_Hashing$_improve(sc_Hashing$_MODULE$, var$2), 0);
        if ($key !== $this.$rootNode)
            $this = sci_HashMap__init_0($key);
        return $this;
    }
    function sci_HashMap_updated0($this, $key, $value) {
        return sci_HashMap_updated($this, $key, $value);
    }
    function sci_HashMap_keySet0($this) {
        return sci_HashMap_keySet($this);
    }
    function sci_HashMap__init_($this, $rootNode) {
        $this.$rootNode = $rootNode;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$19$lambda$_39_0() {
        var a = this; jl_Object.call(a);
        a.$_060 = null;
        a.$_116 = null;
        a.$_28 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$19$lambda$_39_0_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_060;
        var$3 = var$0.$_116;
        var$4 = var$0.$_28;
        var$1 = var$2.$get1(var$1);
        var$2 = new onciu_StepSequencer$$anonfun$orderSteps$20$lambda$_38_0;
        var$2.$_0218 = var$3;
        var$2.$_156 = var$4;
        s_Option_foreach(var$1, var$2);
        return sr_BoxedUnit_UNIT;
    }
    var onciu_StepSequencer$RepeatedSteps$Forbidden$ = $rt_classWithoutFields();
    var onciu_StepSequencer$RepeatedSteps$Forbidden$_MODULE$ = null;
    function onciu_StepSequencer$RepeatedSteps$Forbidden$__clinit_() {
        onciu_StepSequencer$RepeatedSteps$Forbidden$_MODULE$ = new onciu_StepSequencer$RepeatedSteps$Forbidden$;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_0() {
        var a = this; jl_Object.call(a);
        a.$_069 = null;
        a.$_120 = null;
        a.$_211 = null;
        a.$_34 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_0_apply(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_069;
        var$3 = var$0.$_120;
        var$4 = var$0.$_211;
        var$5 = var$0.$_34;
        if (var$1 instanceof onciu_StepSequencer$NegatedCondition) {
            var$6 = var$1;
            var$1 = var$6.$inner3;
            var$2 = var$2.$get1(var$1);
            var$5 = new onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_0;
            var$5.$_0219 = var$3;
            var$5.$_157 = var$6;
            var$5.$_223 = var$1;
            var$5.$_37 = var$4;
            s_Option_foreach(var$2, var$5);
        } else
            a: {
                var$6 = new onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_1;
                var$6.$_0220 = var$1;
                var$6 = var$2.$getOrElse0(var$1, var$6);
                if (var$6 instanceof su_Left) {
                    var$2 = var$6.$value11;
                    if (jl_Object_equals(onciu_StepSequencer$ByInitialCondition$_MODULE$, var$2)) {
                        var$2 = sc_AbstractMap_apply(var$5, var$1);
                        var$1 = new onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_2;
                        var$1.$_0221 = var$3;
                        var$2 = var$2.$filterNot1(var$1);
                        var$1 = new onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_3;
                        var$1.$_0222 = var$4;
                        var$1.$_158 = var$3;
                        var$2.$foreach(var$1);
                        break a;
                    }
                }
                if (!(var$6 instanceof su_Right))
                    $rt_throw(s_MatchError__init_(var$6));
                onciu_StepSequencer$MutableDirectedGraph_connect(var$4, var$6.$value10, var$3);
            }
        return sr_BoxedUnit_UNIT;
    }
    var onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_1 = $rt_classWithoutFields();
    function onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_1_apply(var$0, var$1) {
        return var$1.$unary_$bang();
    }
    var onciuh_TreeElem = $rt_classWithoutFields(0);
    function oncias_Scope() {
        var a = this; jl_Object.call(a);
        a.$symbolTable = null;
        a.$children1 = null;
    }
    function oncias_Scope__init_0(var_0, var_1) {
        var var_2 = new oncias_Scope();
        oncias_Scope__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncias_Scope_symbol($this, $name) {
        return $this.$symbolTable.$get1($name);
    }
    function oncias_Scope_symbolNames($this) {
        return $this.$symbolTable.$keySet0();
    }
    function oncias_Scope_allSymbolDefinitions($this) {
        var var$1;
        var$1 = oncias_Scope_allScopes($this);
        s_Predef$_$callClinit();
        s_Predef$_Map(s_Predef$_MODULE$);
        return var$1.$foldLeft(sci_Map$EmptyMap$_MODULE$, new oncias_Scope$allSymbolDefinitions$lambda$_15_0);
    }
    function oncias_Scope_allSymbols($this) {
        var var$1;
        var$1 = oncias_Scope_allScopes($this);
        s_Predef$_$callClinit();
        s_Predef$_Map(s_Predef$_MODULE$);
        return var$1.$foldLeft(sci_Map$EmptyMap$_MODULE$, new oncias_Scope$allSymbols$lambda$_16_0);
    }
    function oncias_Scope_symbolDefinitions($this) {
        return sc_AbstractIterable_toSet(sc_AbstractIterable_map(sc_AbstractMap_values($this.$symbolTable), new oncias_Scope$symbolDefinitions$lambda$_17_0));
    }
    function oncias_Scope_allScopes($this) {
        return (sci_$colon$colon__init_($this, sci_Nil$_MODULE$)).$concat0($this.$children1.$flatMap(new oncias_Scope$allScopes$lambda$_20_0));
    }
    function oncias_Scope_toString($this) {
        var $builder;
        $builder = scm_StringBuilder__init_();
        oncias_Scope_dumpSingle($this, $rt_s(3), $builder);
        return scm_StringBuilder_result($builder);
    }
    function oncias_Scope_dumpSingle($this, $indent, $builder) {
        var var$3, var$4, var$5;
        var$3 = onciu_Ref_toIdString(onciu_Ref$_apply(onciu_Ref$_MODULE$, $this));
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(var$4, 35);
        jl_StringBuilder_append(var$4, var$3);
        var$4 = jl_AbstractStringBuilder_toString(var$4);
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $indent), var$4), $rt_s(311)), $rt_s(66));
        scm_StringBuilder_append($builder, jl_AbstractStringBuilder_toString(var$5));
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(384)), $indent);
        var$5 = jl_AbstractStringBuilder_toString(var$3);
        var$4 = (sc_IterableOnceOps_toSeq$($this.$symbolTable.$keySet())).$sorted1(sm_Ordering$String$_MODULE$);
        var$3 = new oncias_Scope$dumpTree$lambda$_24_0;
        var$3.$_0223 = $this;
        var$3.$_159 = $builder;
        var$3.$_224 = var$5;
        var$4.$foreach(var$3);
        var$4 = $this.$children1;
        var$3 = new oncias_Scope$dumpTree$lambda$_24_1;
        var$3.$_0224 = var$5;
        var$3.$_160 = $builder;
        var$4.$foreach(var$3);
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        $indent = jl_StringBuilder_append(var$4, $indent);
        jl_AbstractStringBuilder_append($indent, 125);
        jl_StringBuilder_append($indent, $rt_s(66));
        scm_StringBuilder_append($builder, jl_AbstractStringBuilder_toString(var$4));
    }
    function oncias_Scope_copy($this, $symbolTable, $children) {
        return oncias_Scope__init_0($symbolTable, $children);
    }
    function oncias_Scope_productPrefix($this) {
        return $rt_s(515);
    }
    function oncias_Scope_productArity($this) {
        return 2;
    }
    function oncias_Scope_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$symbolTable;
            case 1:
                return $this.$children1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncias_Scope_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_Scope_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_Scope_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_Scope) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$symbolTable;
                            var$3 = $x$1.$symbolTable;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$children1;
                        $x$1 = $x$1.$children1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncias_Scope_updateChildren($this, $newChildren) {
        return oncias_Scope_copy($this, $this.$symbolTable, $newChildren);
    }
    function oncias_Scope__init_($this, $symbolTable, $children) {
        $this.$symbolTable = $symbolTable;
        $this.$children1 = $children;
    }
    var sci_MapNode$ = $rt_classWithoutFields();
    var sci_MapNode$_MODULE$ = null;
    var sci_MapNode$_EmptyMapNode = null;
    function sci_MapNode$_$callClinit() {
        sci_MapNode$_$callClinit = $rt_eraseClinit(sci_MapNode$);
        sci_MapNode$__clinit_();
    }
    function sci_MapNode$__clinit_() {
        var var$1, var$2;
        var$1 = new sci_MapNode$;
        sci_MapNode$_$callClinit();
        sci_MapNode$_MODULE$ = var$1;
        var$2 = new sci_BitmapIndexedMapNode;
        sr_ClassTag$_$callClinit();
        sr_ClassTag$_Any(sr_ClassTag$_MODULE$);
        sci_BitmapIndexedMapNode__init_0(var$2, 0, 0, $rt_createArray(jl_Object, 0), $rt_createIntArray(0), 0, 0);
        sci_MapNode$_EmptyMapNode = var$2;
    }
    function sci_MapNode$_empty($this) {
        sci_MapNode$_$callClinit();
        return sci_MapNode$_EmptyMapNode;
    }
    var sci_MapNode = $rt_classWithoutFields(sci_Node);
    function sci_BitmapIndexedMapNode() {
        var a = this; sci_MapNode.call(a);
        a.$dataMap1 = 0;
        a.$nodeMap1 = 0;
        a.$content = null;
        a.$originalHashes = null;
        a.$size6 = 0;
        a.$cachedJavaKeySetHashCode1 = 0;
    }
    function sci_BitmapIndexedMapNode__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new sci_BitmapIndexedMapNode();
        sci_BitmapIndexedMapNode__init_0(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    function sci_BitmapIndexedMapNode_dataMap($this) {
        return $this.$dataMap1;
    }
    function sci_BitmapIndexedMapNode_nodeMap($this) {
        return $this.$nodeMap1;
    }
    function sci_BitmapIndexedMapNode_content($this) {
        return $this.$content;
    }
    function sci_BitmapIndexedMapNode_originalHashes($this) {
        return $this.$originalHashes;
    }
    function sci_BitmapIndexedMapNode_size($this) {
        return $this.$size6;
    }
    function sci_BitmapIndexedMapNode_cachedJavaKeySetHashCode($this) {
        return $this.$cachedJavaKeySetHashCode1;
    }
    function sci_BitmapIndexedMapNode_getKey($this, $index) {
        return $this.$content.data[2 * $index | 0];
    }
    function sci_BitmapIndexedMapNode_getValue($this, $index) {
        return $this.$content.data[(2 * $index | 0) + 1 | 0];
    }
    function sci_BitmapIndexedMapNode_getPayload($this, $index) {
        var var$2, var$3;
        var$2 = new s_Tuple2;
        var$3 = $this.$content.data;
        $index = 2 * $index | 0;
        s_Tuple2__init_0(var$2, var$3[$index], var$3[$index + 1 | 0]);
        return var$2;
    }
    function sci_BitmapIndexedMapNode_getHash($this, $index) {
        return $this.$originalHashes.data[$index];
    }
    function sci_BitmapIndexedMapNode_getNode($this, $index) {
        var var$2;
        var$2 = $this.$content.data;
        return var$2[(var$2.length - 1 | 0) - $index | 0];
    }
    function sci_BitmapIndexedMapNode_apply($this, $key, $originalHash, $keyHash, $shift) {
        var $mask, $bitpos, $index, var$8, var$9, var$10;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $index = $this.$dataMap1;
        if (!($index & $bitpos)) {
            $index = $this.$nodeMap1;
            if ($index & $bitpos)
                return (sci_BitmapIndexedMapNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos))).$apply28($key, $originalHash, $keyHash, $shift + 5 | 0);
            var$8 = new ju_NoSuchElementException;
            var$9 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$9, 15);
            jl_AbstractStringBuilder_append1(var$9, $rt_s(389));
            jl_Throwable__init_(var$8, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$9, $key)));
            $rt_throw(var$8);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos);
        var$10 = $this.$content.data;
        $originalHash = 2 * $index | 0;
        if (sr_BoxesRunTime_equals($key, var$10[$originalHash]))
            return $this.$content.data[$originalHash + 1 | 0];
        var$9 = new ju_NoSuchElementException;
        var$8 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$8, 15);
        jl_AbstractStringBuilder_append1(var$8, $rt_s(389));
        jl_Throwable__init_(var$9, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$8, $key)));
        $rt_throw(var$9);
    }
    function sci_BitmapIndexedMapNode_get($this, $key, $originalHash, $keyHash, $shift) {
        var $mask, $bitpos, var$7, $index, var$9;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        var$7 = $this.$dataMap1;
        if (!(var$7 & $bitpos)) {
            var$7 = $this.$nodeMap1;
            if (!(var$7 & $bitpos))
                return s_None$_MODULE$;
            return (sci_BitmapIndexedMapNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, var$7, $mask, $bitpos))).$get4($key, $originalHash, $keyHash, $shift + 5 | 0);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, var$7, $mask, $bitpos);
        var$9 = $this.$content.data;
        $originalHash = 2 * $index | 0;
        if (!sr_BoxesRunTime_equals($key, var$9[$originalHash]))
            return s_None$_MODULE$;
        return s_Some__init_($this.$content.data[$originalHash + 1 | 0]);
    }
    function sci_BitmapIndexedMapNode_getOrElse($this, $key, $originalHash, $keyHash, $shift, $f) {
        var $mask, $bitpos, var$8, $index, var$10;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        var$8 = $this.$dataMap1;
        if (!(var$8 & $bitpos)) {
            var$8 = $this.$nodeMap1;
            if (!(var$8 & $bitpos))
                return $f.$apply2();
            return (sci_BitmapIndexedMapNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, var$8, $mask, $bitpos))).$getOrElse1($key, $originalHash, $keyHash, $shift + 5 | 0, $f);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, var$8, $mask, $bitpos);
        var$10 = $this.$content.data;
        $originalHash = 2 * $index | 0;
        if (!sr_BoxesRunTime_equals($key, var$10[$originalHash]))
            return $f.$apply2();
        return $this.$content.data[$originalHash + 1 | 0];
    }
    function sci_BitmapIndexedMapNode_containsKey($this, $key, $originalHash, $keyHash, $shift) {
        var $mask, $bitpos, $index;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $index = $this.$dataMap1;
        if (!($index & $bitpos)) {
            $index = $this.$nodeMap1;
            if (!($index & $bitpos))
                return 0;
            return (sci_BitmapIndexedMapNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos))).$containsKey0($key, $originalHash, $keyHash, $shift + 5 | 0);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos);
        if ($this.$originalHashes.data[$index] == $originalHash && sr_BoxesRunTime_equals($key, $this.$content.data[2 * $index | 0]))
            return 1;
        return 0;
    }
    function sci_BitmapIndexedMapNode_updated($this, $key, $value, $originalHash, $keyHash, $shift, $replaceValue) {
        var $mask, $bitpos, $key0UnimprovedHash, $subNode, $subNodeNew, var$12, $key0Hash, var$14, var$15, $index, $key0, $value0;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $key0UnimprovedHash = $this.$dataMap1;
        if (!($key0UnimprovedHash & $bitpos)) {
            $key0UnimprovedHash = $this.$nodeMap1;
            if ($key0UnimprovedHash & $bitpos) {
                $subNode = sci_BitmapIndexedMapNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $key0UnimprovedHash, $mask, $bitpos));
                $subNodeNew = $subNode.$updated6($key, $value, $originalHash, $keyHash, $shift + 5 | 0, $replaceValue);
                if ($subNodeNew === $subNode)
                    return $this;
                return sci_BitmapIndexedMapNode_copyAndSetNode($this, $bitpos, $subNode, $subNodeNew);
            }
            $replaceValue = sci_BitmapIndexedMapNode_dataIndex($this, $bitpos);
            $key0UnimprovedHash = 2 * $replaceValue | 0;
            var$12 = $this.$content;
            $key0Hash = var$12.data.length;
            var$14 = $rt_createArray(jl_Object, $key0Hash + 2 | 0);
            var$15 = var$14.data;
            jl_System_arraycopy(var$12, 0, var$14, 0, $key0UnimprovedHash);
            var$15[$key0UnimprovedHash] = $key;
            var$15[$key0UnimprovedHash + 1 | 0] = $value;
            jl_System_arraycopy(var$12, $key0UnimprovedHash, var$14, $key0UnimprovedHash + 2 | 0, $key0Hash - $key0UnimprovedHash | 0);
            var$15 = sci_Node_insertElement($this, $this.$originalHashes, $replaceValue, $originalHash);
            return sci_BitmapIndexedMapNode__init_($this.$dataMap1 | $bitpos, $this.$nodeMap1, var$14, var$15, $this.$size6 + 1 | 0, $this.$cachedJavaKeySetHashCode1 + $keyHash | 0);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $key0UnimprovedHash, $mask, $bitpos);
        var$14 = $this.$content.data;
        $mask = 2 * $index | 0;
        $key0 = var$14[$mask];
        $key0UnimprovedHash = $this.$originalHashes.data[$index];
        if ($key0UnimprovedHash == $originalHash && sr_BoxesRunTime_equals($key0, $key)) {
            if (!$replaceValue)
                return $this;
            $value0 = $this.$content.data[$mask + 1 | 0];
            if ($key0 === $key && $value0 === $value)
                return $this;
            $keyHash = 2 * sci_BitmapIndexedMapNode_dataIndex($this, $bitpos) | 0;
            var$12 = $this.$content;
            $shift = var$12.data.length;
            var$14 = $rt_createArray(jl_Object, $shift);
            var$15 = var$14.data;
            jl_System_arraycopy(var$12, 0, var$14, 0, $shift);
            var$15[$keyHash + 1 | 0] = $value;
            return sci_BitmapIndexedMapNode__init_($this.$dataMap1, $this.$nodeMap1, var$14, $this.$originalHashes, $this.$size6, $this.$cachedJavaKeySetHashCode1);
        }
        $value0 = $this.$content.data[$mask + 1 | 0];
        $key0Hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $key0UnimprovedHash);
        $subNodeNew = sci_BitmapIndexedMapNode_mergeTwoKeyValPairs($this, $key0, $value0, $key0UnimprovedHash, $key0Hash, $key, $value, $originalHash, $keyHash, $shift + 5 | 0);
        $keyHash = sci_BitmapIndexedMapNode_dataIndex($this, $bitpos);
        $shift = 2 * $keyHash | 0;
        $replaceValue = ($this.$content.data.length - 2 | 0) - sci_BitmapIndexedMapNode_nodeIndex($this, $bitpos) | 0;
        var$12 = $this.$content;
        $key0UnimprovedHash = var$12.data.length;
        var$14 = $rt_createArray(jl_Object, ($key0UnimprovedHash - 2 | 0) + 1 | 0);
        var$15 = var$14.data;
        jl_System_arraycopy(var$12, 0, var$14, 0, $shift);
        jl_System_arraycopy(var$12, $shift + 2 | 0, var$14, $shift, $replaceValue - $shift | 0);
        var$15[$replaceValue] = $subNodeNew;
        jl_System_arraycopy(var$12, $replaceValue + 2 | 0, var$14, $replaceValue + 1 | 0, ($key0UnimprovedHash - $replaceValue | 0) - 2 | 0);
        var$15 = sci_Node_removeElement($this, $this.$originalHashes, $keyHash);
        return sci_BitmapIndexedMapNode__init_($this.$dataMap1 ^ $bitpos, $this.$nodeMap1 | $bitpos, var$14, var$15, ($this.$size6 - 1 | 0) + $subNodeNew.$size() | 0, ($this.$cachedJavaKeySetHashCode1 - $key0Hash | 0) + $subNodeNew.$cachedJavaKeySetHashCode() | 0);
    }
    function sci_BitmapIndexedMapNode_updateWithShallowMutations($this, $key, $value, $originalHash, $keyHash, $shift, $shallowlyMutableNodeMap) {
        var $mask, $bitpos, $key0Hash, $index, $src, $key0, $key0UnimprovedHash, $value0, $idx, $dataIx, $dst, var$18, $subNode, $subNodeSize, $subNodeHashCode, $subNodeNew;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $key0Hash = $this.$dataMap1;
        if ($key0Hash & $bitpos) {
            $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $key0Hash, $mask, $bitpos);
            $src = $this.$content.data;
            $key0Hash = 2 * $index | 0;
            $key0 = $src[$key0Hash];
            $key0UnimprovedHash = $this.$originalHashes.data[$index];
            if ($key0UnimprovedHash == $originalHash && sr_BoxesRunTime_equals($key0, $key)) {
                $value0 = $this.$content.data[$key0Hash + 1 | 0];
                if (!($key0 === $key && $value0 === $value)) {
                    $idx = 2 * sci_BitmapIndexedMapNode_dataIndex($this, $bitpos) | 0;
                    $this.$content.data[$idx + 1 | 0] = $value;
                }
                return $shallowlyMutableNodeMap;
            }
            $value0 = $this.$content.data[$key0Hash + 1 | 0];
            $key0Hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $key0UnimprovedHash);
            sci_BitmapIndexedMapNode_migrateFromInlineToNodeInPlace($this, $bitpos, $key0Hash, sci_BitmapIndexedMapNode_mergeTwoKeyValPairs($this, $key0, $value0, $key0UnimprovedHash, $key0Hash, $key, $value, $originalHash, $keyHash, $shift + 5 | 0));
            return $shallowlyMutableNodeMap | $bitpos;
        }
        $key0Hash = $this.$nodeMap1;
        if (!($key0Hash & $bitpos)) {
            $dataIx = sci_BitmapIndexedMapNode_dataIndex($this, $bitpos);
            $idx = 2 * $dataIx | 0;
            $src = $this.$content;
            $shift = $src.data.length;
            $dst = $rt_createArray(jl_Object, $shift + 2 | 0);
            var$18 = $dst.data;
            jl_System_arraycopy($src, 0, $dst, 0, $idx);
            var$18[$idx] = $key;
            var$18[$idx + 1 | 0] = $value;
            jl_System_arraycopy($src, $idx, $dst, $idx + 2 | 0, $shift - $idx | 0);
            $this.$dataMap1 = $this.$dataMap1 | $bitpos;
            $this.$content = $dst;
            $this.$originalHashes = sci_Node_insertElement($this, $this.$originalHashes, $dataIx, $originalHash);
            $this.$size6 = $this.$size6 + 1 | 0;
            $this.$cachedJavaKeySetHashCode1 = $this.$cachedJavaKeySetHashCode1 + $keyHash | 0;
            return $shallowlyMutableNodeMap;
        }
        a: {
            $subNode = sci_BitmapIndexedMapNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $key0Hash, $mask, $bitpos));
            $subNodeSize = $subNode.$size();
            $subNodeHashCode = $subNode.$cachedJavaKeySetHashCode();
            if ($subNode instanceof sci_BitmapIndexedMapNode) {
                $subNodeNew = $subNode;
                if ($bitpos & $shallowlyMutableNodeMap) {
                    sci_BitmapIndexedMapNode_updateWithShallowMutations($subNodeNew, $key, $value, $originalHash, $keyHash, $shift + 5 | 0, 0);
                    break a;
                }
            }
            $subNodeNew = $subNode.$updated6($key, $value, $originalHash, $keyHash, $shift + 5 | 0, 1);
            if ($subNodeNew !== $subNode)
                $shallowlyMutableNodeMap = $shallowlyMutableNodeMap | $bitpos;
        }
        $src = $this.$content.data;
        $src[($src.length - 1 | 0) - sci_BitmapIndexedMapNode_nodeIndex($this, $bitpos) | 0] = $subNodeNew;
        $this.$size6 = ($this.$size6 - $subNodeSize | 0) + $subNodeNew.$size() | 0;
        $this.$cachedJavaKeySetHashCode1 = ($this.$cachedJavaKeySetHashCode1 - $subNodeHashCode | 0) + $subNodeNew.$cachedJavaKeySetHashCode() | 0;
        return $shallowlyMutableNodeMap;
    }
    function sci_BitmapIndexedMapNode_removed($this, $key, $originalHash, $keyHash, $shift) {
        var $mask, $bitpos, $index, $subNode, $subNodeNew, var$10, var$11, $subNodeNewSize, var$13, var$14, $newDataMap, var$16;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $index = $this.$dataMap1;
        if (!($index & $bitpos)) {
            $index = $this.$nodeMap1;
            if (!($index & $bitpos))
                return $this;
            $subNode = sci_BitmapIndexedMapNode_getNode($this, sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos));
            $subNodeNew = $subNode.$removed3($key, $originalHash, $keyHash, $shift + 5 | 0);
            if ($subNodeNew === $subNode)
                return $this;
            $originalHash = $rt_compare($subNodeNew.$size(), 1);
            if ($originalHash) {
                if ($originalHash <= 0)
                    return $this;
                return sci_BitmapIndexedMapNode_copyAndSetNode($this, $bitpos, $subNode, $subNodeNew);
            }
            if ($this.$size6 == $subNode.$size())
                return $subNodeNew;
            $index = ($this.$content.data.length - 1 | 0) - sci_BitmapIndexedMapNode_nodeIndex($this, $bitpos) | 0;
            $keyHash = sci_BitmapIndexedMapNode_dataIndex($this, $bitpos);
            $shift = 2 * $keyHash | 0;
            $key = $subNodeNew.$getKey(0);
            var$10 = $subNodeNew.$getValue(0);
            var$11 = $this.$content;
            $subNodeNewSize = var$11.data.length;
            var$13 = $rt_createArray(jl_Object, ($subNodeNewSize - 1 | 0) + 2 | 0);
            var$14 = var$13.data;
            jl_System_arraycopy(var$11, 0, var$13, 0, $shift);
            var$14[$shift] = $key;
            var$14[$shift + 1 | 0] = var$10;
            jl_System_arraycopy(var$11, $shift, var$13, $shift + 2 | 0, $index - $shift | 0);
            jl_System_arraycopy(var$11, $index + 1 | 0, var$13, $index + 2 | 0, ($subNodeNewSize - $index | 0) - 1 | 0);
            $originalHash = $subNodeNew.$getHash(0);
            var$11 = sci_Node_insertElement($this, $this.$originalHashes, $keyHash, $originalHash);
            return sci_BitmapIndexedMapNode__init_($this.$dataMap1 | $bitpos, $this.$nodeMap1 ^ $bitpos, var$13, var$11, ($this.$size6 - $subNode.$size() | 0) + 1 | 0, ($this.$cachedJavaKeySetHashCode1 - $subNode.$cachedJavaKeySetHashCode() | 0) + $subNodeNew.$cachedJavaKeySetHashCode() | 0);
        }
        $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $index, $mask, $bitpos);
        if (!sr_BoxesRunTime_equals($this.$content.data[2 * $index | 0], $key))
            return $this;
        if (sci_BitmapIndexedMapNode_payloadArity($this) == 2 && !sci_BitmapIndexedMapNode_nodeArity($this)) {
            $newDataMap = !$shift ? $this.$dataMap1 ^ $bitpos : 1 << ($keyHash >>> 0 & 31);
            if ($index) {
                $key = new sci_BitmapIndexedMapNode;
                var$11 = $rt_createArray(jl_Object, 2);
                var$14 = var$11.data;
                var$13 = $this.$content.data;
                var$14[0] = var$13[0];
                var$14[1] = var$13[1];
                var$13 = $rt_createIntArray(1);
                var$16 = var$13.data;
                var$14 = $this.$originalHashes.data;
                var$16[0] = var$14[0];
                sci_BitmapIndexedMapNode__init_0($key, $newDataMap, 0, var$11, var$13, 1, sc_Hashing$_improve(sc_Hashing$_MODULE$, var$14[0]));
                return $key;
            }
            $key = new sci_BitmapIndexedMapNode;
            var$11 = $rt_createArray(jl_Object, 2);
            var$14 = var$11.data;
            var$13 = $this.$content.data;
            var$14[0] = var$13[2];
            var$14[1] = var$13[3];
            var$13 = $rt_createIntArray(1);
            var$16 = var$13.data;
            var$14 = $this.$originalHashes.data;
            var$16[0] = var$14[1];
            sci_BitmapIndexedMapNode__init_0($key, $newDataMap, 0, var$11, var$13, 1, sc_Hashing$_improve(sc_Hashing$_MODULE$, var$14[1]));
            return $key;
        }
        $shift = sci_BitmapIndexedMapNode_dataIndex($this, $bitpos);
        $mask = 2 * $shift | 0;
        var$13 = $this.$content;
        $index = var$13.data.length;
        var$11 = $rt_createArray(jl_Object, $index - 2 | 0);
        jl_System_arraycopy(var$13, 0, var$11, 0, $mask);
        jl_System_arraycopy(var$13, $mask + 2 | 0, var$11, $mask, ($index - $mask | 0) - 2 | 0);
        var$13 = sci_Node_removeElement($this, $this.$originalHashes, $shift);
        return sci_BitmapIndexedMapNode__init_($this.$dataMap1 ^ $bitpos, $this.$nodeMap1, var$11, var$13, $this.$size6 - 1 | 0, $this.$cachedJavaKeySetHashCode1 - $keyHash | 0);
    }
    function sci_BitmapIndexedMapNode_mergeTwoKeyValPairs($this, $key0, $value0, $originalHash0, $keyHash0, $key1, $value1, $originalHash1, $keyHash1, $shift) {
        var $node, $mask0, $mask1, $newCachedHash, $nodeMap, var$15, $dataMap;
        if ($shift >= 32) {
            $node = new sci_HashCollisionMapNode;
            sci_Vector$_$callClinit();
            sci_HashCollisionMapNode__init_($node, $originalHash0, $keyHash0, sci_Vector$_from(sci_Vector$_MODULE$, sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(s_Tuple2, [s_Tuple2__init_($key0, $value0), s_Tuple2__init_($key1, $value1)]))));
            return $node;
        }
        $mask0 = $keyHash0 >>> $shift & 31;
        $mask1 = $keyHash1 >>> $shift & 31;
        $newCachedHash = $keyHash0 + $keyHash1 | 0;
        $nodeMap = $rt_compare($mask0, $mask1);
        if (!$nodeMap) {
            $nodeMap = 1 << $mask0;
            $node = sci_BitmapIndexedMapNode_mergeTwoKeyValPairs($this, $key0, $value0, $originalHash0, $keyHash0, $key1, $value1, $originalHash1, $keyHash1, $shift + 5 | 0);
            $key0 = new sci_BitmapIndexedMapNode;
            var$15 = $rt_createArray(jl_Object, 1);
            var$15.data[0] = $node;
            sci_BitmapIndexedMapNode__init_0($key0, 0, $nodeMap, var$15, s_Array$_emptyIntArray, $node.$size(), $node.$cachedJavaKeySetHashCode());
            return $key0;
        }
        $dataMap = 1 << $mask0 | 1 << $mask1;
        if ($nodeMap >= 0)
            return sci_BitmapIndexedMapNode__init_($dataMap, 0, $rt_createArrayFromData(jl_Object, [$key1, $value1, $key0, $value0]), $rt_createIntArrayFromData([$originalHash1, $originalHash0]), 2, $newCachedHash);
        return sci_BitmapIndexedMapNode__init_($dataMap, 0, $rt_createArrayFromData(jl_Object, [$key0, $value0, $key1, $value1]), $rt_createIntArrayFromData([$originalHash0, $originalHash1]), 2, $newCachedHash);
    }
    function sci_BitmapIndexedMapNode_hasNodes($this) {
        if (!$this.$nodeMap1)
            return 0;
        return 1;
    }
    function sci_BitmapIndexedMapNode_nodeArity($this) {
        return jl_Integer_bitCount($this.$nodeMap1);
    }
    function sci_BitmapIndexedMapNode_hasPayload($this) {
        if (!$this.$dataMap1)
            return 0;
        return 1;
    }
    function sci_BitmapIndexedMapNode_payloadArity($this) {
        return jl_Integer_bitCount($this.$dataMap1);
    }
    function sci_BitmapIndexedMapNode_dataIndex($this, $bitpos) {
        return jl_Integer_bitCount($this.$dataMap1 & ($bitpos - 1 | 0));
    }
    function sci_BitmapIndexedMapNode_nodeIndex($this, $bitpos) {
        return jl_Integer_bitCount($this.$nodeMap1 & ($bitpos - 1 | 0));
    }
    function sci_BitmapIndexedMapNode_copyAndSetNode($this, $bitpos, $oldNode, $newNode) {
        var $idx, $src, var$6, $dst, var$8;
        $idx = ($this.$content.data.length - 1 | 0) - sci_BitmapIndexedMapNode_nodeIndex($this, $bitpos) | 0;
        $src = $this.$content;
        var$6 = $src.data.length;
        $dst = $rt_createArray(jl_Object, var$6);
        var$8 = $dst.data;
        jl_System_arraycopy($src, 0, $dst, 0, var$6);
        var$8[$idx] = $newNode;
        return sci_BitmapIndexedMapNode__init_($this.$dataMap1, $this.$nodeMap1, $dst, $this.$originalHashes, ($this.$size6 - $oldNode.$size() | 0) + $newNode.$size() | 0, ($this.$cachedJavaKeySetHashCode1 - $oldNode.$cachedJavaKeySetHashCode() | 0) + $newNode.$cachedJavaKeySetHashCode() | 0);
    }
    function sci_BitmapIndexedMapNode_migrateFromInlineToNodeInPlace($this, $bitpos, $keyHash, $node) {
        var $dataIx, $idxOld, $idxNew, $src, var$8, $dst, $dstHashes;
        $dataIx = sci_BitmapIndexedMapNode_dataIndex($this, $bitpos);
        $idxOld = 2 * $dataIx | 0;
        $idxNew = ($this.$content.data.length - 2 | 0) - sci_BitmapIndexedMapNode_nodeIndex($this, $bitpos) | 0;
        $src = $this.$content;
        var$8 = $src.data.length;
        $dst = $rt_createArray(jl_Object, (var$8 - 2 | 0) + 1 | 0);
        $dstHashes = $dst.data;
        jl_System_arraycopy($src, 0, $dst, 0, $idxOld);
        jl_System_arraycopy($src, $idxOld + 2 | 0, $dst, $idxOld, $idxNew - $idxOld | 0);
        $dstHashes[$idxNew] = $node;
        jl_System_arraycopy($src, $idxNew + 2 | 0, $dst, $idxNew + 1 | 0, (var$8 - $idxNew | 0) - 2 | 0);
        $dstHashes = sci_Node_removeElement($this, $this.$originalHashes, $dataIx);
        $this.$dataMap1 = $this.$dataMap1 ^ $bitpos;
        $this.$nodeMap1 = $this.$nodeMap1 | $bitpos;
        $this.$content = $dst;
        $this.$originalHashes = $dstHashes;
        $this.$size6 = ($this.$size6 - 1 | 0) + $node.$size() | 0;
        $this.$cachedJavaKeySetHashCode1 = ($this.$cachedJavaKeySetHashCode1 - $keyHash | 0) + $node.$cachedJavaKeySetHashCode() | 0;
        return $this;
    }
    function sci_BitmapIndexedMapNode_foreach($this, $f) {
        var $iN, $i, $jN, $j;
        $iN = sci_BitmapIndexedMapNode_payloadArity($this);
        $i = 0;
        while ($i < $iN) {
            $f.$apply(sci_BitmapIndexedMapNode_getPayload($this, $i));
            $i = $i + 1 | 0;
        }
        $jN = sci_BitmapIndexedMapNode_nodeArity($this);
        $j = 0;
        while ($j < $jN) {
            (sci_BitmapIndexedMapNode_getNode($this, $j)).$foreach($f);
            $j = $j + 1 | 0;
        }
    }
    function sci_BitmapIndexedMapNode_foreachEntry($this, $f) {
        var $iN, $i, var$4, $j, $jN;
        $iN = sci_BitmapIndexedMapNode_payloadArity($this);
        $i = 0;
        while ($i < $iN) {
            var$4 = $this.$content.data;
            $j = 2 * $i | 0;
            $f.$apply0(var$4[$j], var$4[$j + 1 | 0]);
            $i = $i + 1 | 0;
        }
        $jN = sci_BitmapIndexedMapNode_nodeArity($this);
        $j = 0;
        while ($j < $jN) {
            (sci_BitmapIndexedMapNode_getNode($this, $j)).$foreachEntry($f);
            $j = $j + 1 | 0;
        }
    }
    function sci_BitmapIndexedMapNode_foreachWithHash($this, $f) {
        var $i, $iN, var$4, $j, $jN;
        $i = 0;
        $iN = sci_BitmapIndexedMapNode_payloadArity($this);
        while ($i < $iN) {
            var$4 = $this.$content.data;
            $j = 2 * $i | 0;
            scm_HashMap$addAll$lambda$_42_0_apply($f, var$4[$j], var$4[$j + 1 | 0], jl_Integer_valueOf($this.$originalHashes.data[$i]));
            $i = $i + 1 | 0;
        }
        $jN = sci_BitmapIndexedMapNode_nodeArity($this);
        $j = 0;
        while ($j < $jN) {
            (sci_BitmapIndexedMapNode_getNode($this, $j)).$foreachWithHash($f);
            $j = $j + 1 | 0;
        }
    }
    function sci_BitmapIndexedMapNode_equals($this, $that) {
        var $deepContentEquality_a1, var$3, $deepContentEquality_a2, $deepContentEquality_length, $deepContentEquality_isEqual, $deepContentEquality_i;
        if (!($that instanceof sci_BitmapIndexedMapNode))
            return 0;
        a: {
            $that = $that;
            if ($this !== $that) {
                if ($this.$cachedJavaKeySetHashCode1 != $that.$cachedJavaKeySetHashCode1)
                    break a;
                if ($this.$nodeMap1 != $that.$nodeMap1)
                    break a;
                if ($this.$dataMap1 != $that.$dataMap1)
                    break a;
                if ($this.$size6 != $that.$size6)
                    break a;
                if (!ju_Arrays_equals0($this.$originalHashes, $that.$originalHashes))
                    break a;
                $deepContentEquality_a1 = $this.$content;
                var$3 = $deepContentEquality_a1.data;
                $deepContentEquality_a2 = $that.$content;
                $deepContentEquality_length = var$3.length;
                if ($deepContentEquality_a1 === $deepContentEquality_a2)
                    $deepContentEquality_isEqual = 1;
                else {
                    $deepContentEquality_isEqual = 1;
                    $deepContentEquality_i = 0;
                    while ($deepContentEquality_isEqual && $deepContentEquality_i < $deepContentEquality_length) {
                        $deepContentEquality_a1 = $deepContentEquality_a2.data;
                        $deepContentEquality_isEqual = !sr_BoxesRunTime_equals(var$3[$deepContentEquality_i], $deepContentEquality_a1[$deepContentEquality_i]) ? 0 : 1;
                        $deepContentEquality_i = $deepContentEquality_i + 1 | 0;
                    }
                }
                if (!$deepContentEquality_isEqual)
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function sci_BitmapIndexedMapNode_hashCode($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(472));
        $rt_throw(var$1);
    }
    function sci_BitmapIndexedMapNode_concat($this, $that, $shift) {
        var var$3, $originalHash, $anyChangesMadeSoFar, $allMap, $minimumBitPos, $maximumBitPos, $leftNodeRightNode, $leftDataRightNode, $leftNodeRightData, $leftDataOnly, $rightDataOnly, $leftNodeOnly, $rightNodeOnly, $leftDataRightDataMigrateToNode, $leftDataRightDataRightOverwrites, $dataToNodeMigrationTargets, $leftIdx, $rightIdx, $finished, $leftOriginalHash, $leftOriginalHash_0, $newDataMap, $newNodeMap, $newDataSize, $newContentSize, $newContent, var$29, $newOriginalHashes, var$31, $newSize, $newCachedHashCode,
        $leftDataIdx, $rightDataIdx, $leftNodeIdx, $rightNodeIdx, $nextShift, $compressedDataIdx, $compressedNodeIdx, $finished_0, $rightNode, $newNode, $n, $leftKey, $leftValue, $updated, $rightOriginalHash;
        if (!($that instanceof sci_BitmapIndexedMapNode))
            $rt_throw(jl_UnsupportedOperationException__init_($rt_s(516)));
        var$3 = $that;
        if (!sci_BitmapIndexedMapNode_size($this))
            return var$3;
        if (sci_BitmapIndexedMapNode_size(var$3) && var$3 !== $this) {
            if (sci_BitmapIndexedMapNode_size(var$3) == 1) {
                $originalHash = sci_BitmapIndexedMapNode_getHash(var$3, 0);
                return sci_BitmapIndexedMapNode_updated($this, sci_BitmapIndexedMapNode_getKey(var$3, 0), sci_BitmapIndexedMapNode_getValue(var$3, 0), $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), $shift, 1);
            }
            $anyChangesMadeSoFar = 0;
            $allMap = sci_BitmapIndexedMapNode_dataMap($this) | sci_BitmapIndexedMapNode_dataMap(var$3) | sci_BitmapIndexedMapNode_nodeMap($this) | sci_BitmapIndexedMapNode_nodeMap(var$3);
            $minimumBitPos = sci_Node$_bitposFrom(sci_Node$_MODULE$, jl_Integer_numberOfTrailingZeros($allMap));
            $maximumBitPos = sci_Node$_bitposFrom(sci_Node$_MODULE$, (32 - jl_Integer_numberOfLeadingZeros($allMap) | 0) - 1 | 0);
            $leftNodeRightNode = 0;
            $leftDataRightNode = 0;
            $leftNodeRightData = 0;
            $leftDataOnly = 0;
            $rightDataOnly = 0;
            $leftNodeOnly = 0;
            $rightNodeOnly = 0;
            $leftDataRightDataMigrateToNode = 0;
            $leftDataRightDataRightOverwrites = 0;
            $dataToNodeMigrationTargets = 0;
            $leftIdx = 0;
            $rightIdx = 0;
            $finished = 0;
            $leftOriginalHash = $minimumBitPos;
            while (!$finished) {
                if (!($leftOriginalHash & sci_BitmapIndexedMapNode_dataMap($this))) {
                    if (!($leftOriginalHash & sci_BitmapIndexedMapNode_nodeMap($this))) {
                        if ($leftOriginalHash & sci_BitmapIndexedMapNode_dataMap(var$3)) {
                            $rightDataOnly = $rightDataOnly | $leftOriginalHash;
                            $rightIdx = $rightIdx + 1 | 0;
                        } else if ($leftOriginalHash & sci_BitmapIndexedMapNode_nodeMap(var$3))
                            $rightNodeOnly = $rightNodeOnly | $leftOriginalHash;
                    } else if ($leftOriginalHash & sci_BitmapIndexedMapNode_dataMap(var$3)) {
                        $leftNodeRightData = $leftNodeRightData | $leftOriginalHash;
                        $rightIdx = $rightIdx + 1 | 0;
                    } else if (!($leftOriginalHash & sci_BitmapIndexedMapNode_nodeMap(var$3)))
                        $leftNodeOnly = $leftNodeOnly | $leftOriginalHash;
                    else
                        $leftNodeRightNode = $leftNodeRightNode | $leftOriginalHash;
                } else {
                    if (!($leftOriginalHash & sci_BitmapIndexedMapNode_dataMap(var$3))) {
                        if (!($leftOriginalHash & sci_BitmapIndexedMapNode_nodeMap(var$3)))
                            $leftDataOnly = $leftDataOnly | $leftOriginalHash;
                        else
                            $leftDataRightNode = $leftDataRightNode | $leftOriginalHash;
                    } else {
                        $leftOriginalHash_0 = sci_BitmapIndexedMapNode_getHash($this, $leftIdx);
                        if ($leftOriginalHash_0 == sci_BitmapIndexedMapNode_getHash(var$3, $rightIdx) && sr_BoxesRunTime_equals(sci_BitmapIndexedMapNode_getKey($this, $leftIdx), sci_BitmapIndexedMapNode_getKey(var$3, $rightIdx)))
                            $leftDataRightDataRightOverwrites = $leftDataRightDataRightOverwrites | $leftOriginalHash;
                        else {
                            $leftDataRightDataMigrateToNode = $leftDataRightDataMigrateToNode | $leftOriginalHash;
                            $that = sci_Node$_MODULE$;
                            $dataToNodeMigrationTargets = $dataToNodeMigrationTargets | sci_Node$_bitposFrom($that, sci_Node$_maskFrom($that, sc_Hashing$_improve(sc_Hashing$_MODULE$, $leftOriginalHash_0), $shift));
                        }
                        $rightIdx = $rightIdx + 1 | 0;
                    }
                    $leftIdx = $leftIdx + 1 | 0;
                }
                if ($leftOriginalHash == $maximumBitPos) {
                    $finished = 1;
                    continue;
                }
                $leftOriginalHash = $leftOriginalHash << 1;
            }
            $newDataMap = $leftDataOnly | $rightDataOnly | $leftDataRightDataRightOverwrites;
            $newNodeMap = $leftNodeRightNode | $leftDataRightNode | $leftNodeRightData | $leftNodeOnly | $rightNodeOnly | $dataToNodeMigrationTargets;
            if ($newDataMap == ($rightDataOnly | $leftDataRightDataRightOverwrites) && $newNodeMap == $rightNodeOnly)
                return var$3;
            $newDataSize = jl_Integer_bitCount($newDataMap);
            $newContentSize = (2 * $newDataSize | 0) + jl_Integer_bitCount($newNodeMap) | 0;
            $newContent = $rt_createArray(jl_Object, $newContentSize);
            var$29 = $newContent.data;
            $newOriginalHashes = $rt_createIntArray($newDataSize);
            var$31 = $newOriginalHashes.data;
            $newSize = 0;
            $newCachedHashCode = 0;
            $leftDataIdx = 0;
            $rightDataIdx = 0;
            $leftNodeIdx = 0;
            $rightNodeIdx = 0;
            $nextShift = $shift + 5 | 0;
            $compressedDataIdx = 0;
            $compressedNodeIdx = 0;
            $finished_0 = 0;
            while (!$finished_0) {
                a: {
                    if ($minimumBitPos & $leftNodeRightNode) {
                        $rightNode = sci_BitmapIndexedMapNode_getNode(var$3, $rightNodeIdx);
                        $newNode = (sci_BitmapIndexedMapNode_getNode($this, $leftNodeIdx)).$concat8($rightNode, $nextShift);
                        if ($rightNode !== $newNode)
                            $anyChangesMadeSoFar = 1;
                        var$29[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $rightNodeIdx = $rightNodeIdx + 1 | 0;
                        $leftNodeIdx = $leftNodeIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftDataRightNode) {
                        $n = sci_BitmapIndexedMapNode_getNode(var$3, $rightNodeIdx);
                        $leftKey = sci_BitmapIndexedMapNode_getKey($this, $leftDataIdx);
                        $leftValue = sci_BitmapIndexedMapNode_getValue($this, $leftDataIdx);
                        $leftOriginalHash = sci_BitmapIndexedMapNode_getHash($this, $leftDataIdx);
                        $updated = $n.$updated6($leftKey, $leftValue, $leftOriginalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $leftOriginalHash), $nextShift, 0);
                        if ($updated !== $n)
                            $anyChangesMadeSoFar = 1;
                        var$29[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $updated;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $rightNodeIdx = $rightNodeIdx + 1 | 0;
                        $leftDataIdx = $leftDataIdx + 1 | 0;
                        $newSize = $newSize + $updated.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $updated.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftNodeRightData) {
                        $anyChangesMadeSoFar = 1;
                        $rightOriginalHash = sci_BitmapIndexedMapNode_getHash(var$3, $rightDataIdx);
                        $newNode = (sci_BitmapIndexedMapNode_getNode($this, $leftNodeIdx)).$updated6(sci_BitmapIndexedMapNode_getKey(var$3, $rightDataIdx), sci_BitmapIndexedMapNode_getValue(var$3, $rightDataIdx), sci_BitmapIndexedMapNode_getHash(var$3, $rightDataIdx), sc_Hashing$_improve(sc_Hashing$_MODULE$, $rightOriginalHash), $nextShift, 1);
                        var$29[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $leftNodeIdx = $leftNodeIdx + 1 | 0;
                        $rightDataIdx = $rightDataIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftDataOnly) {
                        $anyChangesMadeSoFar = 1;
                        $originalHash = (sci_BitmapIndexedMapNode_originalHashes($this)).data[$leftDataIdx];
                        $shift = 2 * $compressedDataIdx | 0;
                        var$29[$shift] = sci_BitmapIndexedMapNode_getKey($this, $leftDataIdx);
                        var$29[$shift + 1 | 0] = sci_BitmapIndexedMapNode_getValue($this, $leftDataIdx);
                        var$31[$compressedDataIdx] = $originalHash;
                        $compressedDataIdx = $compressedDataIdx + 1 | 0;
                        $leftDataIdx = $leftDataIdx + 1 | 0;
                        $newSize = $newSize + 1 | 0;
                        $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash) | 0;
                        break a;
                    }
                    if ($minimumBitPos & $rightDataOnly) {
                        $originalHash = (sci_BitmapIndexedMapNode_originalHashes(var$3)).data[$rightDataIdx];
                        $shift = 2 * $compressedDataIdx | 0;
                        var$29[$shift] = sci_BitmapIndexedMapNode_getKey(var$3, $rightDataIdx);
                        var$29[$shift + 1 | 0] = sci_BitmapIndexedMapNode_getValue(var$3, $rightDataIdx);
                        var$31[$compressedDataIdx] = $originalHash;
                        $compressedDataIdx = $compressedDataIdx + 1 | 0;
                        $rightDataIdx = $rightDataIdx + 1 | 0;
                        $newSize = $newSize + 1 | 0;
                        $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash) | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftNodeOnly) {
                        $anyChangesMadeSoFar = 1;
                        $newNode = sci_BitmapIndexedMapNode_getNode($this, $leftNodeIdx);
                        var$29[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $leftNodeIdx = $leftNodeIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $rightNodeOnly) {
                        $newNode = sci_BitmapIndexedMapNode_getNode(var$3, $rightNodeIdx);
                        var$29[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $rightNodeIdx = $rightNodeIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if ($minimumBitPos & $leftDataRightDataMigrateToNode) {
                        $anyChangesMadeSoFar = 1;
                        $leftOriginalHash = sci_BitmapIndexedMapNode_getHash($this, $leftDataIdx);
                        $rightOriginalHash = sci_BitmapIndexedMapNode_getHash(var$3, $rightDataIdx);
                        $newNode = sci_BitmapIndexedMapNode_mergeTwoKeyValPairs(var$3, sci_BitmapIndexedMapNode_getKey($this, $leftDataIdx), sci_BitmapIndexedMapNode_getValue($this, $leftDataIdx), $leftOriginalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $leftOriginalHash), sci_BitmapIndexedMapNode_getKey(var$3, $rightDataIdx), sci_BitmapIndexedMapNode_getValue(var$3, $rightDataIdx), $rightOriginalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $rightOriginalHash), $nextShift);
                        var$29[($newContentSize - $compressedNodeIdx | 0) - 1 | 0] = $newNode;
                        $compressedNodeIdx = $compressedNodeIdx + 1 | 0;
                        $leftDataIdx = $leftDataIdx + 1 | 0;
                        $rightDataIdx = $rightDataIdx + 1 | 0;
                        $newSize = $newSize + $newNode.$size() | 0;
                        $newCachedHashCode = $newCachedHashCode + $newNode.$cachedJavaKeySetHashCode() | 0;
                        break a;
                    }
                    if (!($minimumBitPos & $leftDataRightDataRightOverwrites))
                        break a;
                    $originalHash = (sci_BitmapIndexedMapNode_originalHashes(var$3)).data[$rightDataIdx];
                    $leftOriginalHash = 2 * $compressedDataIdx | 0;
                    var$29[$leftOriginalHash] = sci_BitmapIndexedMapNode_getKey(var$3, $rightDataIdx);
                    var$29[$leftOriginalHash + 1 | 0] = sci_BitmapIndexedMapNode_getValue(var$3, $rightDataIdx);
                    var$31[$compressedDataIdx] = $originalHash;
                    $compressedDataIdx = $compressedDataIdx + 1 | 0;
                    $rightDataIdx = $rightDataIdx + 1 | 0;
                    $newSize = $newSize + 1 | 0;
                    $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash) | 0;
                    $leftDataIdx = $leftDataIdx + 1 | 0;
                }
                if ($minimumBitPos == $maximumBitPos) {
                    $finished_0 = 1;
                    continue;
                }
                $minimumBitPos = $minimumBitPos << 1;
            }
            if (!$anyChangesMadeSoFar)
                return var$3;
            return sci_BitmapIndexedMapNode__init_($newDataMap, $newNodeMap, $newContent, $newOriginalHashes, $newSize, $newCachedHashCode);
        }
        return $this;
    }
    function sci_BitmapIndexedMapNode_copy($this) {
        var $contentClone, var$2, $contentLength, $i;
        $contentClone = $this.$content.$clone();
        var$2 = $contentClone.data;
        $contentLength = var$2.length;
        $i = jl_Integer_bitCount($this.$dataMap1) * 2 | 0;
        while ($i < $contentLength) {
            var$2[$i] = var$2[$i].$copy21();
            $i = $i + 1 | 0;
        }
        return sci_BitmapIndexedMapNode__init_($this.$dataMap1, $this.$nodeMap1, $contentClone, $this.$originalHashes.$clone(), $this.$size6, $this.$cachedJavaKeySetHashCode1);
    }
    function sci_BitmapIndexedMapNode_filterImpl($this, $pred, $flipped) {
        var $i, $maximumIndex, $newDataMap, $newCachedHashCode, $dataIndex, $bitpos, $newSize, $newContent, $newContent_0, $newOriginalHashCodes, $newOriginalHashes, $newMaximumIndex, $j, $newDataIndex, $oldIndex, var$18, $allMap, $minimumIndex, $oldDataPassThrough, $nodeMigrateToDataTargetMap, $nodesToMigrateToData, $nodesToPassThroughMap, $mapOfNewNodes, $newNodes, $newNodeMap, $nodeIndex, $oldSubNode, $newSubNode, $newDataSize, $newContentSize, $maxIndex, $oldDataIndex, $oldNodeIndex, $newNodeIndex, $node;
        if (!sci_BitmapIndexedMapNode_size($this))
            return $this;
        if (sci_BitmapIndexedMapNode_size($this) == 1) {
            if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(sci_BitmapIndexedMapNode_getPayload($this, 0))) != $flipped)
                return $this;
            sci_MapNode$_$callClinit();
            return sci_MapNode$_empty(sci_MapNode$_MODULE$);
        }
        if (!sci_BitmapIndexedMapNode_nodeMap($this)) {
            $i = jl_Integer_numberOfTrailingZeros(sci_BitmapIndexedMapNode_dataMap($this));
            $maximumIndex = 32 - jl_Integer_numberOfLeadingZeros(sci_BitmapIndexedMapNode_dataMap($this)) | 0;
            $newDataMap = 0;
            $newCachedHashCode = 0;
            $dataIndex = 0;
            while ($i < $maximumIndex) {
                $bitpos = 1 << $i;
                if ($bitpos & sci_BitmapIndexedMapNode_dataMap($this)) {
                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(sci_BitmapIndexedMapNode_getPayload($this, $dataIndex))) == $flipped ? 0 : 1) {
                        $newDataMap = $newDataMap | $bitpos;
                        $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, (sci_BitmapIndexedMapNode_originalHashes($this)).data[$dataIndex]) | 0;
                    }
                    $dataIndex = $dataIndex + 1 | 0;
                }
                $i = $i + 1 | 0;
            }
            if (!$newDataMap) {
                sci_MapNode$_$callClinit();
                return sci_MapNode$_empty(sci_MapNode$_MODULE$);
            }
            if ($newDataMap == sci_BitmapIndexedMapNode_dataMap($this))
                return $this;
            $newSize = jl_Integer_bitCount($newDataMap);
            $newContent = $rt_createArray(jl_Object, $newSize * 2 | 0);
            $newContent_0 = $newContent.data;
            $newOriginalHashCodes = $rt_createIntArray($newSize);
            $newOriginalHashes = $newOriginalHashCodes.data;
            $newMaximumIndex = 32 - jl_Integer_numberOfLeadingZeros($newDataMap) | 0;
            $j = jl_Integer_numberOfTrailingZeros($newDataMap);
            $newDataIndex = 0;
            while ($j < $newMaximumIndex) {
                $bitpos = 1 << $j;
                if ($bitpos & $newDataMap) {
                    $oldIndex = jl_Integer_bitCount(sci_BitmapIndexedMapNode_dataMap($this) & ($bitpos - 1 | 0));
                    $flipped = $newDataIndex * 2 | 0;
                    var$18 = (sci_BitmapIndexedMapNode_content($this)).data;
                    $allMap = $oldIndex * 2 | 0;
                    $newContent_0[$flipped] = var$18[$allMap];
                    $newContent_0[$flipped + 1 | 0] = (sci_BitmapIndexedMapNode_content($this)).data[$allMap + 1 | 0];
                    $newOriginalHashes[$newDataIndex] = (sci_BitmapIndexedMapNode_originalHashes($this)).data[$oldIndex];
                    $newDataIndex = $newDataIndex + 1 | 0;
                }
                $j = $j + 1 | 0;
            }
            return sci_BitmapIndexedMapNode__init_($newDataMap, 0, $newContent, $newOriginalHashCodes, $newSize, $newCachedHashCode);
        }
        $allMap = sci_BitmapIndexedMapNode_dataMap($this) | sci_BitmapIndexedMapNode_nodeMap($this);
        $minimumIndex = jl_Integer_numberOfTrailingZeros($allMap);
        $maximumIndex = 32 - jl_Integer_numberOfLeadingZeros($allMap) | 0;
        $oldDataPassThrough = 0;
        $nodeMigrateToDataTargetMap = 0;
        $nodesToMigrateToData = null;
        $nodesToPassThroughMap = 0;
        $mapOfNewNodes = 0;
        $newNodes = null;
        $newDataMap = 0;
        $newNodeMap = 0;
        $newSize = 0;
        $newCachedHashCode = 0;
        $dataIndex = 0;
        $nodeIndex = 0;
        $i = $minimumIndex;
        while ($i < $maximumIndex) {
            $bitpos = 1 << $i;
            if ($bitpos & sci_BitmapIndexedMapNode_dataMap($this)) {
                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(sci_BitmapIndexedMapNode_getPayload($this, $dataIndex))) == $flipped ? 0 : 1) {
                    $newDataMap = $newDataMap | $bitpos;
                    $oldDataPassThrough = $oldDataPassThrough | $bitpos;
                    $newSize = $newSize + 1 | 0;
                    $newCachedHashCode = $newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, (sci_BitmapIndexedMapNode_originalHashes($this)).data[$dataIndex]) | 0;
                }
                $dataIndex = $dataIndex + 1 | 0;
            } else if ($bitpos & sci_BitmapIndexedMapNode_nodeMap($this)) {
                $oldSubNode = sci_BitmapIndexedMapNode_getNode($this, $nodeIndex);
                $newSubNode = $oldSubNode.$filterImpl4($pred, $flipped);
                $newSize = $newSize + $newSubNode.$size() | 0;
                $newCachedHashCode = $newCachedHashCode + $newSubNode.$cachedJavaKeySetHashCode() | 0;
                if ($newSubNode.$size() > 1) {
                    $newNodeMap = $newNodeMap | $bitpos;
                    if ($oldSubNode === $newSubNode)
                        $nodesToPassThroughMap = $nodesToPassThroughMap | $bitpos;
                    else {
                        $mapOfNewNodes = $mapOfNewNodes | $bitpos;
                        if ($newNodes === null)
                            $newNodes = scm_Queue$_empty(scm_Queue$_MODULE$);
                        scm_AbstractBuffer_$plus$eq($newNodes, $newSubNode);
                    }
                } else if ($newSubNode.$size() == 1) {
                    $newDataMap = $newDataMap | $bitpos;
                    $nodeMigrateToDataTargetMap = $nodeMigrateToDataTargetMap | $bitpos;
                    if ($nodesToMigrateToData === null)
                        $nodesToMigrateToData = sc_IterableFactory_apply$(scm_Queue$_MODULE$, sci_Nil$_MODULE$);
                    scm_AbstractBuffer_$plus$eq($nodesToMigrateToData, $newSubNode);
                }
                $nodeIndex = $nodeIndex + 1 | 0;
            }
            $i = $i + 1 | 0;
        }
        if (!$newSize) {
            sci_MapNode$_$callClinit();
            return sci_MapNode$_empty(sci_MapNode$_MODULE$);
        }
        if ($newSize == sci_BitmapIndexedMapNode_size($this))
            return $this;
        $newDataSize = jl_Integer_bitCount($newDataMap);
        $newContentSize = (2 * $newDataSize | 0) + jl_Integer_bitCount($newNodeMap) | 0;
        $newContent_0 = $rt_createArray(jl_Object, $newContentSize);
        var$18 = $newContent_0.data;
        $newOriginalHashes = $rt_createIntArray($newDataSize);
        $newOriginalHashCodes = $newOriginalHashes.data;
        $maxIndex = 32 - jl_Integer_numberOfLeadingZeros($newDataMap | $newNodeMap) | 0;
        $oldDataIndex = 0;
        $oldNodeIndex = 0;
        $newDataIndex = 0;
        $newNodeIndex = 0;
        while ($minimumIndex < $maxIndex) {
            $bitpos = 1 << $minimumIndex;
            if ($bitpos & $oldDataPassThrough) {
                $flipped = $newDataIndex * 2 | 0;
                $newContent = (sci_BitmapIndexedMapNode_content($this)).data;
                $allMap = 2 * $oldDataIndex | 0;
                var$18[$flipped] = $newContent[$allMap];
                var$18[$flipped + 1 | 0] = (sci_BitmapIndexedMapNode_content($this)).data[$allMap + 1 | 0];
                $newOriginalHashCodes[$newDataIndex] = (sci_BitmapIndexedMapNode_originalHashes($this)).data[$oldDataIndex];
                $newDataIndex = $newDataIndex + 1 | 0;
                $oldDataIndex = $oldDataIndex + 1 | 0;
            } else if ($bitpos & $nodesToPassThroughMap) {
                var$18[($newContentSize - $newNodeIndex | 0) - 1 | 0] = sci_BitmapIndexedMapNode_getNode($this, $oldNodeIndex);
                $newNodeIndex = $newNodeIndex + 1 | 0;
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            } else if ($bitpos & $nodeMigrateToDataTargetMap) {
                $node = scm_Queue_dequeue($nodesToMigrateToData);
                $allMap = 2 * $newDataIndex | 0;
                var$18[$allMap] = $node.$getKey(0);
                var$18[$allMap + 1 | 0] = $node.$getValue(0);
                $newOriginalHashCodes[$newDataIndex] = $node.$getHash(0);
                $newDataIndex = $newDataIndex + 1 | 0;
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            } else if ($bitpos & $mapOfNewNodes) {
                var$18[($newContentSize - $newNodeIndex | 0) - 1 | 0] = scm_Queue_dequeue($newNodes);
                $newNodeIndex = $newNodeIndex + 1 | 0;
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            } else if ($bitpos & sci_BitmapIndexedMapNode_dataMap($this))
                $oldDataIndex = $oldDataIndex + 1 | 0;
            else if ($bitpos & sci_BitmapIndexedMapNode_nodeMap($this))
                $oldNodeIndex = $oldNodeIndex + 1 | 0;
            $minimumIndex = $minimumIndex + 1 | 0;
        }
        return sci_BitmapIndexedMapNode__init_($newDataMap, $newNodeMap, $newContent_0, $newOriginalHashes, $newSize, $newCachedHashCode);
    }
    function sci_BitmapIndexedMapNode_filterImpl0($this, $pred, $isFlipped) {
        return sci_BitmapIndexedMapNode_filterImpl($this, $pred, $isFlipped);
    }
    function sci_BitmapIndexedMapNode_copy0($this) {
        return sci_BitmapIndexedMapNode_copy($this);
    }
    function sci_BitmapIndexedMapNode_concat0($this, $that, $shift) {
        return sci_BitmapIndexedMapNode_concat($this, $that, $shift);
    }
    function sci_BitmapIndexedMapNode_removed0($this, $key, $originalHash, $hash, $shift) {
        return sci_BitmapIndexedMapNode_removed($this, $key, $originalHash, $hash, $shift);
    }
    function sci_BitmapIndexedMapNode_updated0($this, $key, $value, $originalHash, $hash, $shift, $replaceValue) {
        return sci_BitmapIndexedMapNode_updated($this, $key, $value, $originalHash, $hash, $shift, $replaceValue);
    }
    function sci_BitmapIndexedMapNode_getNode0($this, $index) {
        return sci_BitmapIndexedMapNode_getNode($this, $index);
    }
    function sci_BitmapIndexedMapNode__init_0($this, $dataMap, $nodeMap, $content, $originalHashes, $size, $cachedJavaKeySetHashCode) {
        $this.$dataMap1 = $dataMap;
        $this.$nodeMap1 = $nodeMap;
        $this.$content = $content;
        $this.$originalHashes = $originalHashes;
        $this.$size6 = $size;
        $this.$cachedJavaKeySetHashCode1 = $cachedJavaKeySetHashCode;
    }
    var su_Either = $rt_classWithoutFields();
    function su_Either_left($this) {
        var var$1;
        var$1 = new su_Either$LeftProjection;
        var$1.$e0 = $this;
        return var$1;
    }
    function su_Either_fold($this, $fa, $fb) {
        if ($this instanceof su_Right) {
            $fa = $this.$value10;
            return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, $fa);
        }
        if (!($this instanceof su_Left))
            $rt_throw(s_MatchError__init_($this));
        $fb = $this.$value11;
        $fa = $fa.$_0225;
        return oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, $fa, $fb);
    }
    function su_Either_foreach($this, $f) {
        var $b;
        if (!($this instanceof su_Right))
            return;
        $b = $this.$value10;
        onciu_StepSequencer$MutableDirectedGraph_connect($f.$_0226, $f.$_161, $b);
    }
    function su_Either_toOption($this) {
        if (!($this instanceof su_Right))
            return s_None$_MODULE$;
        return s_Some__init_($this.$value10);
    }
    function su_Left() {
        su_Either.call(this);
        this.$value11 = null;
    }
    function su_Left__init_(var_0) {
        var var_1 = new su_Left();
        su_Left__init_0(var_1, var_0);
        return var_1;
    }
    function su_Left_value($this) {
        return $this.$value11;
    }
    function su_Left_productPrefix($this) {
        return $rt_s(517);
    }
    function su_Left_productArity($this) {
        return 1;
    }
    function su_Left_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value11;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function su_Left_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function su_Left_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    }
    function su_Left_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function su_Left_equals($this, $x$1) {
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof su_Left) ? 0 : 1))
                    break a;
                $x$1 = $x$1;
                if (!sr_BoxesRunTime_equals($this.$value11, $x$1.$value11))
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function su_Left__init_0($this, $value) {
        $this.$value11 = $value;
    }
    function sci_Set$SetNIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$current2 = 0;
        a.$remainder = 0;
    }
    function sci_Set$SetNIterator_knownSize($this) {
        return $this.$remainder;
    }
    function sci_Set$SetNIterator_hasNext($this) {
        if ($this.$remainder <= 0)
            return 0;
        return 1;
    }
    function sci_Set$SetNIterator_next($this) {
        var $r;
        if (!sci_Set$SetNIterator_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $r = $this.$apply1($this.$current2);
        $this.$current2 = $this.$current2 + 1 | 0;
        $this.$remainder = $this.$remainder - 1 | 0;
        return $r;
    }
    function sci_Set$SetNIterator_drop($this, $n) {
        if ($n > 0) {
            $this.$current2 = $this.$current2 + $n | 0;
            $this.$remainder = jl_Math_max(0, $this.$remainder - $n | 0);
        }
        return $this;
    }
    function sci_Set$SetNIterator__init_($this, $n) {
        $this.$current2 = 0;
        $this.$remainder = $n;
    }
    function sci_Set$Set2$$anon$1() {
        sci_Set$SetNIterator.call(this);
        this.$$outer17 = null;
    }
    function sci_Set$Set2$$anon$1_apply($this, $i) {
        var var$2;
        a: {
            var$2 = $this.$$outer17;
            switch ($i) {
                case 0:
                    break;
                case 1:
                    var$2 = var$2.$elem20;
                    break a;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf($i)));
            }
            var$2 = var$2.$elem11;
        }
        return var$2;
    }
    function sc_IndexedSeqView$IndexedSeqViewIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$self1 = null;
        a.$current3 = 0;
        a.$scala$collection$IndexedSeqView$IndexedSeqViewIterator$$remainder = 0;
    }
    function sc_IndexedSeqView$IndexedSeqViewIterator__init_(var_0) {
        var var_1 = new sc_IndexedSeqView$IndexedSeqViewIterator();
        sc_IndexedSeqView$IndexedSeqViewIterator__init_0(var_1, var_0);
        return var_1;
    }
    function sc_IndexedSeqView$IndexedSeqViewIterator_knownSize($this) {
        return $this.$scala$collection$IndexedSeqView$IndexedSeqViewIterator$$remainder;
    }
    function sc_IndexedSeqView$IndexedSeqViewIterator_hasNext($this) {
        if ($this.$scala$collection$IndexedSeqView$IndexedSeqViewIterator$$remainder <= 0)
            return 0;
        return 1;
    }
    function sc_IndexedSeqView$IndexedSeqViewIterator_next($this) {
        var $r;
        if (!($this.$scala$collection$IndexedSeqView$IndexedSeqViewIterator$$remainder <= 0 ? 0 : 1))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $r = $this.$self1.$apply1($this.$current3);
        $this.$current3 = $this.$current3 + 1 | 0;
        $this.$scala$collection$IndexedSeqView$IndexedSeqViewIterator$$remainder = $this.$scala$collection$IndexedSeqView$IndexedSeqViewIterator$$remainder - 1 | 0;
        return $r;
    }
    function sc_IndexedSeqView$IndexedSeqViewIterator__init_0($this, $self) {
        $this.$self1 = $self;
        $this.$current3 = 0;
        $this.$scala$collection$IndexedSeqView$IndexedSeqViewIterator$$remainder = $self.$length();
    }
    function scm_CheckedIndexedSeqView$CheckedIterator() {
        var a = this; sc_IndexedSeqView$IndexedSeqViewIterator.call(a);
        a.$mutationCount5 = null;
        a.$expectedCount1 = 0;
    }
    function scm_CheckedIndexedSeqView$CheckedIterator__init_(var_0, var_1) {
        var var_2 = new scm_CheckedIndexedSeqView$CheckedIterator();
        scm_CheckedIndexedSeqView$CheckedIterator__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function scm_CheckedIndexedSeqView$CheckedIterator_hasNext($this) {
        scm_MutationTracker$_checkMutations(scm_MutationTracker$_MODULE$, $this.$expectedCount1, scm_ArrayBuffer$view$lambda$_88_0_apply$mcI$sp($this.$mutationCount5), $rt_s(518));
        return sc_IndexedSeqView$IndexedSeqViewIterator_hasNext($this);
    }
    function scm_CheckedIndexedSeqView$CheckedIterator__init_0($this, $self, $mutationCount) {
        $this.$mutationCount5 = $mutationCount;
        sc_IndexedSeqView$IndexedSeqViewIterator__init_0($this, $self);
        $this.$expectedCount1 = scm_ArrayBuffer$view$lambda$_88_0_apply$mcI$sp($mutationCount);
    }
    var oncipj_CharStream = $rt_classWithoutFields(0);
    function oncipj_CypherCharStream() {
        var a = this; jl_Object.call(a);
        a.$query = null;
        a.$queryCursor = 0;
        a.$queryCursorColumn = 0;
        a.$queryCursorLine = 0;
        a.$queryCursorIsCR = 0;
        a.$queryCursorIsLF = 0;
        a.$result1 = null;
        a.$resultCursor = 0;
        a.$resultHighMark = 0;
        a.$lines = null;
        a.$columns = null;
        a.$offsets = null;
        a.$beginOffset0 = 0;
        a.$tabSize = 0;
    }
    var oncipj_CypherCharStream_END_OF_INPUT = null;
    function oncipj_CypherCharStream_readChar($this) {
        var var$1, var$2, var$3, var$4, var$5, $$je;
        a: {
            if (($this.$resultCursor + 1 | 0) == $this.$resultHighMark) {
                b: {
                    var$1 = oncipj_CypherCharStream_nextQueryChar($this);
                    if (var$1 != 92)
                        var$2 = var$1;
                    else {
                        var$2 = oncipj_CypherCharStream_nextQueryChar($this);
                        if (var$2 != 117)
                            oncipj_CypherCharStream_appendToResult($this, var$1);
                        else {
                            while (true) {
                                try {
                                    if (var$2 != 117)
                                        break;
                                    var$2 = oncipj_CypherCharStream_nextQueryChar($this);
                                    continue;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof ji_IOException) {
                                        var$3 = $$je;
                                        break a;
                                    } else {
                                        throw $$e;
                                    }
                                }
                            }
                            try {
                                var$2 = (oncipj_CypherCharStream_hexval(var$2) << 12 | oncipj_CypherCharStream_hexval(oncipj_CypherCharStream_nextQueryChar($this)) << 8 | oncipj_CypherCharStream_hexval(oncipj_CypherCharStream_nextQueryChar($this)) << 4 | oncipj_CypherCharStream_hexval(oncipj_CypherCharStream_nextQueryChar($this))) & 65535;
                                break b;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                    var$3 = $$je;
                                    break a;
                                } else {
                                    throw $$e;
                                }
                            }
                        }
                    }
                }
                oncipj_CypherCharStream_appendToResult($this, var$2);
            }
            var$2 = $this.$resultCursor + 1 | 0;
            $this.$resultCursor = var$2;
            return $this.$result1.data[var$2];
        }
        var$4 = new oncipj_InvalidUnicodeLiteral;
        var$3 = var$3.$getMessage();
        var$2 = $this.$queryCursor;
        var$1 = $this.$queryCursorLine;
        var$5 = $this.$queryCursorColumn;
        jl_Throwable__init_(var$4, var$3);
        var$4.$offset = var$2;
        var$4.$line = var$1;
        var$4.$column = var$5;
        $rt_throw(var$4);
    }
    function oncipj_CypherCharStream_appendToResult($this, $c) {
        var var$2, var$3;
        var$2 = $this.$result1.data;
        var$3 = $this.$resultHighMark;
        var$2[var$3] = $c;
        $this.$lines.data[var$3] = $this.$queryCursorLine;
        $this.$columns.data[var$3] = $this.$queryCursorColumn;
        $this.$offsets.data[var$3] = $this.$queryCursor;
        $this.$resultHighMark = var$3 + 1 | 0;
    }
    function oncipj_CypherCharStream_nextQueryChar($this) {
        var $c, var$2, var$3;
        if (($this.$queryCursor + 1 | 0) >= jl_String_length($this.$query))
            $rt_throw(oncipj_CypherCharStream_END_OF_INPUT);
        $c = $this.$queryCursor + 1 | 0;
        $this.$queryCursor = $c;
        $c = jl_String_charAt($this.$query, $c);
        $this.$queryCursorColumn = $this.$queryCursorColumn + 1 | 0;
        if ($this.$queryCursorIsLF) {
            $this.$queryCursorIsLF = 0;
            $this.$queryCursorColumn = 1;
            $this.$queryCursorLine = $this.$queryCursorLine + 1 | 0;
        } else if ($this.$queryCursorIsCR) {
            $this.$queryCursorIsCR = 0;
            if ($c == 10)
                $this.$queryCursorIsLF = 1;
            else {
                $this.$queryCursorColumn = 1;
                $this.$queryCursorLine = $this.$queryCursorLine + 1 | 0;
            }
        }
        a: {
            switch ($c) {
                case 9:
                    var$2 = $this.$queryCursorColumn - 1 | 0;
                    $this.$queryCursorColumn = var$2;
                    var$3 = $this.$tabSize;
                    $this.$queryCursorColumn = var$2 + (var$3 - (var$2 % var$3 | 0) | 0) | 0;
                    break a;
                case 10:
                    break;
                case 11:
                case 12:
                    break a;
                case 13:
                    $this.$queryCursorIsCR = 1;
                    break a;
                default:
                    break a;
            }
            $this.$queryCursorIsLF = 1;
        }
        return $c;
    }
    function oncipj_CypherCharStream_backup($this, $amount) {
        $this.$resultCursor = $this.$resultCursor - $amount | 0;
    }
    function oncipj_CypherCharStream_getEndColumn($this) {
        return $this.$columns.data[$this.$resultCursor];
    }
    function oncipj_CypherCharStream_getEndLine($this) {
        return $this.$lines.data[$this.$resultCursor];
    }
    function oncipj_CypherCharStream_beginToken($this) {
        var $c;
        $c = oncipj_CypherCharStream_readChar($this);
        $this.$beginOffset0 = $this.$resultCursor;
        return $c;
    }
    function oncipj_CypherCharStream_getImage($this) {
        return jl_String__init_1($this.$result1, $this.$beginOffset0, oncipj_CypherCharStream_nextOffset($this) - $this.$beginOffset0 | 0);
    }
    function oncipj_CypherCharStream_nextOffset($this) {
        return $this.$resultCursor + 1 | 0;
    }
    function oncipj_CypherCharStream_getSuffix($this, $len) {
        var $suffix, $endOffset;
        $suffix = $rt_createCharArray($len);
        $endOffset = oncipj_CypherCharStream_nextOffset($this);
        jl_System_arraycopy($this.$result1, $endOffset - $len | 0, $suffix, 0, $len);
        return $suffix;
    }
    function oncipj_CypherCharStream_hexval($c) {
        var var$2, var$3, var$4;
        a: {
            switch ($c) {
                case 48:
                    break;
                case 49:
                    return 1;
                case 50:
                    return 2;
                case 51:
                    return 3;
                case 52:
                    return 4;
                case 53:
                    return 5;
                case 54:
                    return 6;
                case 55:
                    return 7;
                case 56:
                    return 8;
                case 57:
                    return 9;
                case 58:
                case 59:
                case 60:
                case 61:
                case 62:
                case 63:
                case 64:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 86:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                    break a;
                case 65:
                case 97:
                    return 10;
                case 66:
                case 98:
                    return 11;
                case 67:
                case 99:
                    return 12;
                case 68:
                case 100:
                    return 13;
                case 69:
                case 101:
                    return 14;
                case 70:
                case 102:
                    return 15;
                default:
                    break a;
            }
            return 0;
        }
        var$2 = new ji_IOException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$4 = jl_StringBuilder_append(var$3, $rt_s(519));
        jl_AbstractStringBuilder_append(var$4, $c);
        jl_StringBuilder_append(var$4, $rt_s(520));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    function oncipj_CypherCharStream__clinit_() {
        var var$1;
        var$1 = new ji_IOException;
        jl_Throwable__init_(var$1, $rt_s(521));
        oncipj_CypherCharStream_END_OF_INPUT = var$1;
    }
    var onciaf_ASTExceptionFactory = $rt_classWithoutFields(0);
    function onciaf_ASTExceptionFactory_relationshipPatternNotAllowed($type) {
        var var$2;
        var$2 = $rt_createArray(jl_Object, 1);
        var$2.data[0] = $type.$description0;
        return jl_String_format($rt_s(522), var$2);
    }
    function onciaf_ASTExceptionFactory_nodePatternNotAllowed($type) {
        var var$2;
        var$2 = $rt_createArray(jl_Object, 1);
        var$2.data[0] = $type.$description0;
        return jl_String_format($rt_s(523), var$2);
    }
    function onciaf_ASTExceptionFactory_invalidShowFilterType($command, $got) {
        return jl_String_format($rt_s(524), $rt_createArrayFromData(jl_Object, [$got.$description1, $command]));
    }
    function onciaf_ASTExceptionFactory_invalidCreateIndexType($got) {
        var var$2;
        var$2 = $rt_createArray(jl_Object, 1);
        var$2.data[0] = $got.$description2;
        return jl_String_format($rt_s(525), var$2);
    }
    var scc_AsScalaConverters = $rt_classWithoutFields(0);
    function scc_AsScalaConverters_asScala$($$this, $l) {
        if ($l === null)
            $$this = null;
        else if ($l instanceof scc_JavaCollectionWrappers$MutableBufferWrapper)
            $$this = $l.$underlying13();
        else {
            $$this = new scc_JavaCollectionWrappers$JListWrapper;
            $$this.$underlying14 = $l;
        }
        return $$this;
    }
    function onciafn_Neo4jASTExceptionFactory() {
        jl_Object.call(this);
        this.$inner = null;
    }
    function onciafn_Neo4jASTExceptionFactory_syntaxException0($this, $got, $expected, $source, $offset, $line, $column) {
        var $exp, $message;
        $exp = sc_IterableOnceOps_toSeq$(scc_AsScalaConverters_asScala$($this, $expected));
        $source = scm_StringBuilder_append(scm_StringBuilder_append(scm_StringBuilder_append(scm_StringBuilder__init_0(jl_StringBuilder__init_3($rt_s(519))), $got), $rt_s(526)), $rt_s(527));
        if ($exp.$length() == 1) {
            $got = $exp.$head();
            $expected = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($expected);
            jl_AbstractStringBuilder_append($expected, 32);
            jl_StringBuilder_append($expected, $got);
            $got = jl_AbstractStringBuilder_toString($expected);
        } else if ($exp.$length() >= 5) {
            $got = sc_AbstractIterable_mkString0($exp.$map1(new onciafn_Neo4jASTExceptionFactory$syntaxException$lambda$_10_0), $rt_s(66));
            $exp = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($exp);
            jl_StringBuilder_append(jl_StringBuilder_append($exp, $rt_s(66)), $got);
            $got = jl_AbstractStringBuilder_toString($exp);
        } else {
            $got = sc_AbstractIterable_mkString0($exp.$init1(), $rt_s(16));
            $expected = $exp.$last();
            $exp = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($exp);
            jl_AbstractStringBuilder_append($exp, 32);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($exp, $got), $rt_s(442)), $expected);
            $got = jl_AbstractStringBuilder_toString($exp);
        }
        $message = scm_StringBuilder_result(scm_StringBuilder_append($source, $got));
        return onciu_OpenCypherExceptionFactory_syntaxException($this.$inner, $message, onciu_InputPosition__init_($offset, $line, $column));
    }
    function onciafn_Neo4jASTExceptionFactory_syntaxException($this, $source, $offset, $line, $column) {
        return onciu_OpenCypherExceptionFactory_syntaxException($this.$inner, $source.$getMessage(), onciu_InputPosition__init_($offset, $line, $column));
    }
    var onciaf_ASTExpressionFactory = $rt_classWithoutFields(0);
    var onciaf_ASTFactory = $rt_classWithoutFields(0);
    function onciafn_Neo4jASTFactory() {
        var a = this; jl_Object.call(a);
        a.$query0 = null;
        a.$astExceptionFactory = null;
    }
    function onciafn_Neo4jASTFactory_usingJoin($this, $p, $joinVariables) {
        var var$3, var$4, var$5;
        var$3 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $joinVariables)));
        $joinVariables = new oncia_UsingJoinHint;
        var$3 = var$3.$iterator0();
        if (sc_Iterator_isEmpty$(var$3))
            var$4 = s_None$_MODULE$;
        else {
            var$4 = new s_Some;
            var$5 = onciu_Last__init_(var$3.$next());
            while (var$3.$hasNext()) {
                var$5 = onciu_Fby__init_(var$3.$next(), var$5);
            }
            s_Some__init_0(var$4, var$5);
        }
        oncia_UsingJoinHint__init_($joinVariables, s_Option_getOrElse(s_Option_map(var$4, new onciu_NonEmptyList$IteratorConverter$asNonEmptyListOption$lambda$_1_0), new oncia_UsingJoinHint$$apply$lambda$_1_0), $p);
        return $joinVariables;
    }
    function onciafn_Neo4jASTFactory_usingScan($this, $p, $v, $labelOrRelType) {
        return oncia_UsingScanHint__init_($v, oncie_LabelOrRelTypeName__init_($labelOrRelType, $p), $p);
    }
    function onciafn_Neo4jASTFactory_allPathSelector($this, $position) {
        return oncie_PatternPart$AllPaths__init_($position);
    }
    function onciafn_Neo4jASTFactory_defaultCountValue($this, $count, $countPosition, $position) {
        if ($count !== null)
            return oncie_UnsignedDecimalIntegerLiteral__init_($count, $countPosition);
        return oncie_UnsignedDecimalIntegerLiteral__init_($rt_s(91), $position);
    }
    function onciafn_Neo4jASTFactory_parenthesizedPathPattern($this, $p, $internalPattern, $where, $length) {
        var $pathPatternKind, var$6;
        if ($rt_isInstance($internalPattern, oncie_NonPrefixedPatternPart)) {
            $pathPatternKind = $internalPattern;
            if ($length === null)
                return oncie_ParenthesizedPath__init_($pathPatternKind, s_Option$_apply(s_Option$_MODULE$, $where), $p);
            $internalPattern = s_Option$_apply(s_Option$_MODULE$, $where);
            $where = $pathPatternKind.$allVariables();
            var$6 = new oncie_QuantifiedPath$$apply$lambda$_1_0;
            var$6.$_0227 = $p;
            return oncie_QuantifiedPath__init_($pathPatternKind, $length, $internalPattern, $where.$map1(var$6), $p);
        }
        if (!($internalPattern instanceof oncie_PatternPartWithSelector))
            $rt_throw(s_MatchError__init_($internalPattern));
        $p = $internalPattern;
        $pathPatternKind = $length !== null ? $rt_s(528) : $rt_s(529);
        $internalPattern = $p.$selector;
        $p = $internalPattern.$position2();
        $length = $this.$astExceptionFactory;
        $where = new onciafn_Neo4jASTConstructionException;
        $internalPattern = $internalPattern.$prettified();
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(530)), $internalPattern), $rt_s(531)), $pathPatternKind), $rt_s(532));
        jl_Throwable__init_($where, jl_AbstractStringBuilder_toString(var$6));
        $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($length, $where, $p.$offset0, $p.$line0, $p.$column0));
    }
    function onciafn_Neo4jASTFactory_pathSelectorCannotBeUsedInClauseException($this, $clauseName, $selector) {
        var $p, var$4, var$5, var$6, var$7;
        $p = $selector.$position2();
        var$4 = $this.$astExceptionFactory;
        var$5 = new onciafn_Neo4jASTConstructionException;
        var$6 = $selector.$prettified();
        var$7 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$7);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$7, $rt_s(530)), var$6), $rt_s(533)), $clauseName), $rt_s(534));
        jl_Throwable__init_(var$5, jl_AbstractStringBuilder_toString(var$7));
        return onciafn_Neo4jASTExceptionFactory_syntaxException(var$4, var$5, $p.$offset0, $p.$line0, $p.$column0);
    }
    function onciafn_Neo4jASTFactory_transformParameterType($this, $t) {
        var var$2, var$3;
        onciaf_ParameterType_$callClinit();
        if (jl_Enum_equals(onciaf_ParameterType_ANY, $t)) {
            oncius_package$_$callClinit();
            return oncius_package$_CTAny(oncius_package$_MODULE$);
        }
        if (jl_Enum_equals(onciaf_ParameterType_STRING, $t)) {
            oncius_package$_$callClinit();
            return oncius_package$_CTString(oncius_package$_MODULE$);
        }
        if (jl_Enum_equals(onciaf_ParameterType_MAP, $t)) {
            oncius_package$_$callClinit();
            return oncius_package$_CTMap(oncius_package$_MODULE$);
        }
        var$2 = new jl_IllegalArgumentException;
        var$3 = $t.$name5;
        $t = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($t);
        jl_StringBuilder_append(jl_StringBuilder_append($t, $rt_s(535)), var$3);
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString($t));
        $rt_throw(var$2);
    }
    function onciafn_Neo4jASTFactory_convertSubqueryExpressionToUnifiedExpression($this, $finalMatchMode, $patterns, $query, $where) {
        var $patternParts, $patternPos, var$7, var$8, var$9;
        if ($query !== null)
            return $query;
        $query = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $patterns)));
        $patterns = new onciafn_Neo4jASTFactory$convertSubqueryExpressionToUnifiedExpression$lambda$_124_0;
        $patterns.$_0228 = $this;
        $patternParts = sci_List_map($query, $patterns);
        $patternPos = oncie_PatternPartWithSelector_position($patternParts.$head());
        if ($finalMatchMode === null)
            $finalMatchMode = oncie_MatchMode$_default(oncie_MatchMode$_MODULE$, $patternPos);
        var$7 = new oncia_SingleQuery;
        $patterns = new sci_$colon$colon;
        var$8 = new oncia_Match;
        var$9 = oncie_Pattern$ForMatch__init_($patternParts, $patternPos);
        s_package$_$callClinit();
        oncia_Match__init_(var$8, 0, $finalMatchMode, var$9, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), s_Option$_apply(s_Option$_MODULE$, $where), $patternPos);
        sci_$colon$colon__init_0($patterns, var$8, sci_Nil$_MODULE$);
        oncia_SingleQuery__init_0(var$7, $patterns, $patternPos);
        return var$7;
    }
    function onciafn_Neo4jASTFactory_inputPosition($this, $offset, $line, $column) {
        return onciu_InputPosition__init_($offset, $line, $column);
    }
    function onciafn_Neo4jASTFactory_showConstraintClause($this, $p, $initialConstraintType, $brief, $verbose, $where, $hasYield) {
        var $constraintType, var$8, var$9, var$10, var$11, var$12, var$13, var$14;
        a: {
            onciaf_ShowCommandFilterTypes_$callClinit();
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_ALL, $initialConstraintType)) {
                $constraintType = oncia_AllConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_UNIQUE, $initialConstraintType)) {
                $constraintType = oncia_UniqueConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_NODE_UNIQUE, $initialConstraintType)) {
                $constraintType = oncia_NodeUniqueConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_RELATIONSHIP_UNIQUE, $initialConstraintType)) {
                $constraintType = oncia_RelUniqueConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_KEY, $initialConstraintType)) {
                $constraintType = oncia_KeyConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_NODE_KEY, $initialConstraintType)) {
                $constraintType = oncia_NodeKeyConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_RELATIONSHIP_KEY, $initialConstraintType)) {
                $constraintType = oncia_RelKeyConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_EXIST, $initialConstraintType)) {
                $constraintType = oncia_ExistsConstraints__init_(oncia_ValidSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_OLD_EXISTS, $initialConstraintType)) {
                $constraintType = oncia_ExistsConstraints__init_(oncia_RemovedSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_OLD_EXIST, $initialConstraintType)) {
                $constraintType = oncia_ExistsConstraints__init_(oncia_ValidSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_NODE_EXIST, $initialConstraintType)) {
                $constraintType = oncia_NodeExistsConstraints__init_(oncia_ValidSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_NODE_OLD_EXISTS, $initialConstraintType)) {
                $constraintType = oncia_NodeExistsConstraints__init_(oncia_RemovedSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_NODE_OLD_EXIST, $initialConstraintType)) {
                $constraintType = oncia_NodeExistsConstraints__init_(oncia_ValidSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST, $initialConstraintType)) {
                $constraintType = oncia_RelExistsConstraints__init_(oncia_ValidSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXISTS, $initialConstraintType)) {
                $constraintType = oncia_RelExistsConstraints__init_(oncia_RemovedSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXIST, $initialConstraintType)) {
                $constraintType = oncia_RelExistsConstraints__init_(oncia_ValidSyntax$_MODULE$);
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_PROP_TYPE, $initialConstraintType)) {
                $constraintType = oncia_PropTypeConstraints$_MODULE$;
                break a;
            }
            if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_NODE_PROP_TYPE, $initialConstraintType)) {
                $constraintType = oncia_NodePropTypeConstraints$_MODULE$;
                break a;
            }
            if (!jl_Enum_equals(onciaf_ShowCommandFilterTypes_RELATIONSHIP_PROP_TYPE, $initialConstraintType)) {
                $where = new onciafn_Neo4jASTConstructionException;
                jl_Throwable__init_($where, onciaf_ASTExceptionFactory_invalidShowFilterType($rt_s(536), $initialConstraintType));
                $rt_throw($where);
            }
            $constraintType = oncia_RelPropTypeConstraints$_MODULE$;
        }
        var$8 = s_Option$_apply(s_Option$_MODULE$, $where);
        s_package$_$callClinit();
        var$9 = s_package$_List0(s_package$_MODULE$);
        var$10 = sr_ScalaRunTime$_MODULE$;
        var$11 = $rt_createArray(oncia_ShowColumn, 8);
        var$12 = var$11.data;
        $initialConstraintType = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        var$12[0] = oncia_ShowColumn$_apply($initialConstraintType, $rt_s(94), oncius_package$_CTInteger(oncius_package$_MODULE$), $p);
        $initialConstraintType = oncia_ShowColumn$_MODULE$;
        var$12[1] = oncia_ShowColumn$_apply($initialConstraintType, $rt_s(537), oncia_ShowColumn$_apply$default$2($initialConstraintType), $p);
        $initialConstraintType = oncia_ShowColumn$_MODULE$;
        var$12[2] = oncia_ShowColumn$_apply($initialConstraintType, $rt_s(538), oncia_ShowColumn$_apply$default$2($initialConstraintType), $p);
        $initialConstraintType = oncia_ShowColumn$_MODULE$;
        var$12[3] = oncia_ShowColumn$_apply($initialConstraintType, $rt_s(539), oncia_ShowColumn$_apply$default$2($initialConstraintType), $p);
        $initialConstraintType = oncia_ShowColumn$_MODULE$;
        var$13 = oncius_package$_MODULE$;
        var$12[4] = oncia_ShowColumn$_apply($initialConstraintType, $rt_s(540), oncius_package$_CTList(var$13, oncius_package$_CTString(var$13)), $p);
        var$14 = oncia_ShowColumn$_MODULE$;
        $where = oncius_package$_MODULE$;
        var$12[5] = oncia_ShowColumn$_apply(var$14, $rt_s(541), oncius_package$_CTList($where, oncius_package$_CTString($where)), $p);
        $initialConstraintType = oncia_ShowColumn$_MODULE$;
        var$12[6] = oncia_ShowColumn$_apply($initialConstraintType, $rt_s(542), oncia_ShowColumn$_apply$default$2($initialConstraintType), $p);
        $initialConstraintType = oncia_ShowColumn$_MODULE$;
        var$12[7] = oncia_ShowColumn$_apply($initialConstraintType, $rt_s(543), oncia_ShowColumn$_apply$default$2($initialConstraintType), $p);
        $initialConstraintType = var$9.$from0(sr_ScalaRunTime$_wrapRefArray(var$10, var$11));
        $where = new sci_$colon$colon;
        var$13 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(544), oncius_package$_CTMap(oncius_package$_MODULE$), $p);
        var$14 = new sci_$colon$colon;
        var$10 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$14, oncia_ShowColumn$_apply(var$10, $rt_s(545), oncia_ShowColumn$_apply$default$2(var$10), $p), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0($where, var$13, var$14);
        return oncia_ShowConstraintsClause__init_(oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $hasYield, $initialConstraintType, $initialConstraintType.$concat0($where)), $constraintType, $brief, $verbose, var$8, $hasYield, $p);
    }
    function onciafn_Neo4jASTFactory_getYieldAllAndYieldItems($this, $yieldClause) {
        var $yieldAll, $yieldedItems;
        $yieldAll = s_Option_exists(s_Option$_apply(s_Option$_MODULE$, $yieldClause), new onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_0);
        $yieldedItems = s_Option_getOrElse(s_Option_map(s_Option$_apply(s_Option$_MODULE$, $yieldClause), new onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_1), new onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_2);
        return s_Tuple2__init_(jl_Boolean_valueOf($yieldAll), $yieldedItems);
    }
    function onciafn_Neo4jASTFactory_createConstraint($this, $p, $constraintType, $replace, $ifNotExists, $name, $variable, $label, $javaProperties, $javaPropertyType, $options, $containsOn, $constraintVersion) {
        var $constraintVersionScala, $properties, $scalaPropertyType, $scalaPropertyTypes;
        onciaf_ConstraintVersion_$callClinit();
        if (jl_Enum_equals(onciaf_ConstraintVersion_CONSTRAINT_VERSION_0, $constraintVersion))
            $constraintVersionScala = oncia_ConstraintVersion0$_MODULE$;
        else if (jl_Enum_equals(onciaf_ConstraintVersion_CONSTRAINT_VERSION_1, $constraintVersion))
            $constraintVersionScala = oncia_ConstraintVersion1$_MODULE$;
        else {
            if (!jl_Enum_equals(onciaf_ConstraintVersion_CONSTRAINT_VERSION_2, $constraintVersion))
                $rt_throw(s_MatchError__init_($constraintVersion));
            $constraintVersionScala = oncia_ConstraintVersion2$_MODULE$;
        }
        $properties = sc_IterableOnceOps_toSeq$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $javaProperties)));
        onciaf_ConstraintType_$callClinit();
        if (jl_Enum_equals(onciaf_ConstraintType_NODE_UNIQUE, $constraintType))
            return oncia_CreateNodePropertyUniquenessConstraint__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
        if (jl_Enum_equals(onciaf_ConstraintType_REL_UNIQUE, $constraintType))
            return oncia_CreateRelationshipPropertyUniquenessConstraint__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
        if (jl_Enum_equals(onciaf_ConstraintType_NODE_KEY, $constraintType))
            return oncia_CreateNodeKeyConstraint__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
        if (jl_Enum_equals(onciaf_ConstraintType_REL_KEY, $constraintType))
            return oncia_CreateRelationshipKeyConstraint__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
        if (jl_Enum_equals(onciaf_ConstraintType_NODE_EXISTS, $constraintType) ? 1 : !jl_Enum_equals(onciaf_ConstraintType_NODE_IS_NOT_NULL, $constraintType) ? 0 : 1) {
            onciafn_Neo4jASTFactory_validateSingleProperty($this, $properties, $constraintType);
            return oncia_CreateNodePropertyExistenceConstraint__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties.$head(), s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
        }
        if (jl_Enum_equals(onciaf_ConstraintType_REL_EXISTS, $constraintType) ? 1 : !jl_Enum_equals(onciaf_ConstraintType_REL_IS_NOT_NULL, $constraintType) ? 0 : 1) {
            onciafn_Neo4jASTFactory_validateSingleProperty($this, $properties, $constraintType);
            return oncia_CreateRelationshipPropertyExistenceConstraint__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties.$head(), s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
        }
        if (jl_Enum_equals(onciaf_ConstraintType_NODE_IS_TYPED, $constraintType)) {
            onciafn_Neo4jASTFactory_validateSingleProperty($this, $properties, $constraintType);
            $scalaPropertyType = onciafn_Neo4jASTFactory_convertCypherType($this, $javaPropertyType);
            return oncia_CreateNodePropertyTypeConstraint__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties.$head(), $scalaPropertyType, s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
        }
        if (!jl_Enum_equals(onciaf_ConstraintType_REL_IS_TYPED, $constraintType))
            $rt_throw(s_MatchError__init_($constraintType));
        onciafn_Neo4jASTFactory_validateSingleProperty($this, $properties, $constraintType);
        $scalaPropertyTypes = onciafn_Neo4jASTFactory_convertCypherType($this, $javaPropertyType);
        return oncia_CreateRelationshipPropertyTypeConstraint__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties.$head(), $scalaPropertyTypes, s_Option$_apply(s_Option$_MODULE$, $name), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), $containsOn, $constraintVersionScala, s_None$_MODULE$, $p);
    }
    function onciafn_Neo4jASTFactory_dropConstraint($this, $p, $constraintType, $variable, $label, $javaProperties) {
        var $properties;
        $properties = sc_IterableOnceOps_toSeq$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $javaProperties)));
        onciaf_ConstraintType_$callClinit();
        if (jl_Enum_equals(onciaf_ConstraintType_NODE_UNIQUE, $constraintType))
            return oncia_DropPropertyUniquenessConstraint__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_None$_MODULE$, $p);
        if (jl_Enum_equals(onciaf_ConstraintType_NODE_KEY, $constraintType))
            return oncia_DropNodeKeyConstraint__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_None$_MODULE$, $p);
        if (jl_Enum_equals(onciaf_ConstraintType_NODE_EXISTS, $constraintType)) {
            onciafn_Neo4jASTFactory_validateSingleProperty($this, $properties, $constraintType);
            return oncia_DropNodePropertyExistenceConstraint__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties.$head(), s_None$_MODULE$, $p);
        }
        if (!jl_Enum_equals(onciaf_ConstraintType_REL_EXISTS, $constraintType)) {
            $constraintType = new onciafn_Neo4jASTConstructionException;
            jl_Throwable__init_($constraintType, $rt_s(546));
            $rt_throw($constraintType);
        }
        onciafn_Neo4jASTFactory_validateSingleProperty($this, $properties, $constraintType);
        return oncia_DropRelationshipPropertyExistenceConstraint__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties.$head(), s_None$_MODULE$, $p);
    }
    function onciafn_Neo4jASTFactory_validateSingleProperty($this, $seq, $constraintType) {
        var var$3;
        if ($seq.$length() == 1)
            return;
        $seq = new onciafn_Neo4jASTConstructionException;
        var$3 = $rt_createArray(jl_Object, 1);
        var$3.data[0] = $constraintType.$description0;
        jl_Throwable__init_($seq, jl_String_format($rt_s(547), var$3));
        $rt_throw($seq);
    }
    function onciafn_Neo4jASTFactory_convertCypherType($this, $javaType) {
        var $pos, $unionOfTypes, $cypherTypeName;
        a: {
            s_Predef$_$callClinit();
            $pos = onciafn_Neo4jASTFactory_inputPosition($this, s_Predef$_Integer2int(s_Predef$_MODULE$, onciaf_ParserCypherTypeName_getOffset($javaType)), s_Predef$_Integer2int(s_Predef$_MODULE$, onciaf_ParserCypherTypeName_getLine($javaType)), s_Predef$_Integer2int(s_Predef$_MODULE$, onciaf_ParserCypherTypeName_getColumn($javaType)));
            $unionOfTypes = onciaf_ParserCypherTypeName_NOTHING;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_NothingType__init_($pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_NullType__init_($pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_BOOLEAN;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_BooleanType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_BOOLEAN_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_BooleanType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_STRING;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_StringType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_STRING_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_StringType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_INTEGER;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_IntegerType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_INTEGER_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_IntegerType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_FLOAT;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_FloatType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_FLOAT_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_FloatType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_DATE;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_DateType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_DATE_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_DateType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_LOCAL_TIME;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_LocalTimeType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_LOCAL_TIME_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_LocalTimeType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_ZONED_TIME;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_ZonedTimeType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_ZONED_TIME_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_ZonedTimeType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_LOCAL_DATETIME;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_LocalDateTimeType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_LOCAL_DATETIME_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_LocalDateTimeType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_ZONED_DATETIME;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_ZonedDateTimeType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_ZONED_DATETIME_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_ZonedDateTimeType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_DURATION;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_DurationType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_DURATION_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_DurationType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_POINT;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_PointType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_POINT_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_PointType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_NODE;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_NodeType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_NODE_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_NodeType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_RELATIONSHIP;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_RelationshipType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_RELATIONSHIP_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_RelationshipType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_MAP;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_MapType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_MAP_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_MapType__init_(0, $pos);
                break a;
            }
            if ($javaType instanceof onciaf_ParserCypherTypeName$ListParserCypherTypeName) {
                $javaType = $javaType;
                $cypherTypeName = oncius_ListType__init_(onciafn_Neo4jASTFactory_convertCypherType($this, onciaf_ParserCypherTypeName$ListParserCypherTypeName_getInnerType($javaType)), onciaf_ParserCypherTypeName$ListParserCypherTypeName_isNullable($javaType), $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_PATH;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_PathType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_PATH_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_PathType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_PROPERTY_VALUE;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_PropertyValueType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_PROPERTY_VALUE_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_PropertyValueType__init_(0, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_ANY;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_AnyType__init_(1, $pos);
                break a;
            }
            $unionOfTypes = onciaf_ParserCypherTypeName_ANY_NOT_NULL;
            if ($unionOfTypes !== null && jl_Object_equals($unionOfTypes, $javaType)) {
                $cypherTypeName = oncius_AnyType__init_(0, $pos);
                break a;
            }
            if (!($javaType instanceof onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName)) {
                $pos = new onciafn_Neo4jASTConstructionException;
                $unionOfTypes = jl_StringBuilder__init_1();
                jl_StringBuilder_append(jl_StringBuilder_append($unionOfTypes, $rt_s(548)), $javaType);
                onciafn_Neo4jASTConstructionException__init_($pos, jl_StringBuilder_toString($unionOfTypes));
                $rt_throw($pos);
            }
            $javaType = $javaType;
            $cypherTypeName = oncius_ClosedDynamicUnionType__init_(sc_AbstractIterable_toSet(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, jus_Stream_toList(jusi_SimpleStreamImpl_map(ju_Collection_stream(onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName_getUnionTypes($javaType)), onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0__init_($this)))))), $pos);
        }
        return $cypherTypeName.$simplify();
    }
    function onciafn_Neo4jASTFactory_createIndex($this, $p, $replace, $ifNotExists, $isNode, $indexName, $variable, $label, $javaProperties, $options, $indexType) {
        var $properties, $t, var$13;
        $properties = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $javaProperties)));
        $t = s_Tuple2__init_($indexType, jl_Boolean_valueOf($isNode));
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        onciaf_CreateIndexTypes_$callClinit();
        if (jl_Enum_equals(onciaf_CreateIndexTypes_DEFAULT, $javaProperties) && 1 == $isNode)
            return oncia_CreateRangeNodeIndex__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), 1, s_None$_MODULE$, $p);
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_DEFAULT, $javaProperties) && 0 == $isNode)
            return oncia_CreateRangeRelationshipIndex__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), 1, s_None$_MODULE$, $p);
        $indexType = $t.$_10;
        var$13 = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_RANGE, $indexType) && 1 == var$13)
            return oncia_CreateRangeNodeIndex__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), 0, s_None$_MODULE$, $p);
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_RANGE, $javaProperties) && 0 == $isNode)
            return oncia_CreateRangeRelationshipIndex__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), 0, s_None$_MODULE$, $p);
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_BTREE, $javaProperties) && 1 == $isNode)
            return oncia_CreateBtreeNodeIndex__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), s_None$_MODULE$, $p);
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_BTREE, $javaProperties) && 0 == $isNode)
            return oncia_CreateBtreeRelationshipIndex__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), s_None$_MODULE$, $p);
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_TEXT, $javaProperties) && 1 == $isNode)
            return oncia_CreateTextNodeIndex__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), s_None$_MODULE$, $p);
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_TEXT, $javaProperties) && 0 == $isNode)
            return oncia_CreateTextRelationshipIndex__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), s_None$_MODULE$, $p);
        $javaProperties = $t.$_10;
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_POINT, $javaProperties) && 1 == $isNode)
            return oncia_CreatePointNodeIndex__init_($variable, oncie_LabelName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), s_None$_MODULE$, $p);
        $javaProperties = s_Tuple2__1($t);
        $isNode = s_Tuple2__2$mcZ$sp($t);
        if (jl_Enum_equals(onciaf_CreateIndexTypes_POINT, $javaProperties) && 0 == $isNode)
            return oncia_CreatePointRelationshipIndex__init_($variable, oncie_RelTypeName__init_($label.$string0, $label.$pos), $properties, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($this, $options), oncia_CreatePointRelationshipIndex$_apply$default$7(oncia_CreatePointRelationshipIndex$_MODULE$), $p);
        $t = s_Tuple2__1($t);
        $rt_throw(onciafn_Neo4jASTConstructionException__init_0(onciaf_ASTExceptionFactory_invalidCreateIndexType($t)));
    }
    function onciafn_Neo4jASTFactory_userPrivilegeScope($this, $p, $users) {
        if (!s_Option_isDefined(s_Option$_apply(s_Option$_MODULE$, $users)))
            return oncia_ShowUserPrivileges__init_(s_None$_MODULE$, $p);
        return oncia_ShowUsersPrivileges__init_((sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $users)), new onciafn_Neo4jASTFactory$userPrivilegeScope$lambda$_176_0)).$toList(), $p);
    }
    function onciafn_Neo4jASTFactory_privilegeAction($this, $action) {
        onciaf_ActionType_$callClinit();
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_ALL, $action))
            return oncia_AllDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ACCESS, $action))
            return oncia_AccessDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_START, $action))
            return oncia_StartDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_STOP, $action))
            return oncia_StopDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_INDEX_ALL, $action))
            return oncia_AllIndexActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_INDEX_CREATE, $action))
            return oncia_CreateIndexAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_INDEX_DROP, $action))
            return oncia_DropIndexAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_INDEX_SHOW, $action))
            return oncia_ShowIndexAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CONSTRAINT_ALL, $action))
            return oncia_AllConstraintActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CONSTRAINT_CREATE, $action))
            return oncia_CreateConstraintAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CONSTRAINT_DROP, $action))
            return oncia_DropConstraintAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CONSTRAINT_SHOW, $action))
            return oncia_ShowConstraintAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CREATE_TOKEN, $action))
            return oncia_AllTokenActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CREATE_PROPERTYKEY, $action))
            return oncia_CreatePropertyKeyAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CREATE_LABEL, $action))
            return oncia_CreateNodeLabelAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_CREATE_RELTYPE, $action))
            return oncia_CreateRelationshipTypeAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_TRANSACTION_ALL, $action))
            return oncia_AllTransactionActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_TRANSACTION_SHOW, $action))
            return oncia_ShowTransactionAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_TRANSACTION_TERMINATE, $action))
            return oncia_TerminateTransactionAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DBMS_ALL, $action))
            return oncia_AllDbmsAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_ALL, $action))
            return oncia_AllUserActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_SHOW, $action))
            return oncia_ShowUserAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_ALTER, $action))
            return oncia_AlterUserAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_CREATE, $action))
            return oncia_CreateUserAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_DROP, $action))
            return oncia_DropUserAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_RENAME, $action))
            return oncia_RenameUserAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_PASSWORD, $action))
            return oncia_SetPasswordsAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_STATUS, $action))
            return oncia_SetUserStatusAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_HOME, $action))
            return oncia_SetUserHomeDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_USER_IMPERSONATE, $action))
            return oncia_ImpersonateUserAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ROLE_ALL, $action))
            return oncia_AllRoleActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ROLE_SHOW, $action))
            return oncia_ShowRoleAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ROLE_CREATE, $action))
            return oncia_CreateRoleAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ROLE_DROP, $action))
            return oncia_DropRoleAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ROLE_RENAME, $action))
            return oncia_RenameRoleAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ROLE_ASSIGN, $action))
            return oncia_AssignRoleAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ROLE_REMOVE, $action))
            return oncia_RemoveRoleAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_MANAGEMENT, $action))
            return oncia_AllDatabaseManagementActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_CREATE, $action))
            return oncia_CreateDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_DROP, $action))
            return oncia_DropDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_COMPOSITE_MANAGEMENT, $action))
            return oncia_CompositeDatabaseManagementActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_COMPOSITE_CREATE, $action))
            return oncia_CreateCompositeDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_COMPOSITE_DROP, $action))
            return oncia_DropCompositeDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_DATABASE_ALTER, $action))
            return oncia_AlterDatabaseAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_SET_DATABASE_ACCESS, $action))
            return oncia_SetDatabaseAccessAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ALIAS_MANAGEMENT, $action))
            return oncia_AllAliasManagementActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ALIAS_CREATE, $action))
            return oncia_CreateAliasAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ALIAS_DROP, $action))
            return oncia_DropAliasAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ALIAS_ALTER, $action))
            return oncia_AlterAliasAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_ALIAS_SHOW, $action))
            return oncia_ShowAliasAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_PRIVILEGE_ALL, $action))
            return oncia_AllPrivilegeActions$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_PRIVILEGE_ASSIGN, $action))
            return oncia_AssignPrivilegeAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_PRIVILEGE_REMOVE, $action))
            return oncia_RemovePrivilegeAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_PRIVILEGE_SHOW, $action))
            return oncia_ShowPrivilegeAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_EXECUTE_FUNCTION, $action))
            return oncia_ExecuteFunctionAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_EXECUTE_BOOSTED_FUNCTION, $action))
            return oncia_ExecuteBoostedFunctionAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_EXECUTE_PROCEDURE, $action))
            return oncia_ExecuteProcedureAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_EXECUTE_BOOSTED_PROCEDURE, $action))
            return oncia_ExecuteBoostedProcedureAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_EXECUTE_ADMIN_PROCEDURE, $action))
            return oncia_ExecuteAdminProcedureAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_SERVER_SHOW, $action))
            return oncia_ShowServerAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_SERVER_MANAGEMENT, $action))
            return oncia_ServerManagementAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_SETTING_SHOW, $action))
            return oncia_ShowSettingAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_ALL, $action))
            return oncia_AllGraphAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_WRITE, $action))
            return oncia_WriteAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_CREATE, $action))
            return oncia_CreateElementAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_MERGE, $action))
            return oncia_MergeAdminAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_DELETE, $action))
            return oncia_DeleteElementAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_LABEL_SET, $action))
            return oncia_SetLabelAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_LABEL_REMOVE, $action))
            return oncia_RemoveLabelAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_PROPERTY_SET, $action))
            return oncia_SetPropertyAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_MATCH, $action))
            return oncia_MatchAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_READ, $action))
            return oncia_ReadAction$_MODULE$;
        if (jl_Enum_equals(onciaf_ActionType_GRAPH_TRAVERSE, $action))
            return oncia_TraverseAction$_MODULE$;
        $rt_throw(s_MatchError__init_($action));
    }
    function onciafn_Neo4jASTFactory_allQualifier($this) {
        var $list, var$2;
        $list = ju_ArrayList__init_();
        var$2 = new oncia_AllQualifier;
        onciu_InputPosition$_$callClinit();
        var$2.$position11 = onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$);
        ju_ArrayList_add($list, var$2);
        return $list;
    }
    function onciafn_Neo4jASTFactory_allDatabasesQualifier($this) {
        var $list, var$2;
        $list = ju_ArrayList__init_();
        var$2 = new oncia_AllDatabasesQualifier;
        onciu_InputPosition$_$callClinit();
        var$2.$position12 = onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$);
        ju_ArrayList_add($list, var$2);
        return $list;
    }
    function onciafn_Neo4jASTFactory_userQualifier($this, $users) {
        var $list, var$3;
        $list = ju_ArrayList__init_();
        var$3 = new onciafn_Neo4jASTFactory$userQualifier$lambda$_200_0;
        var$3.$_0229 = $list;
        ju_ArrayList_forEach($users, var$3);
        return $list;
    }
    function onciafn_Neo4jASTFactory_allUsersQualifier($this) {
        var $list, var$2;
        $list = ju_ArrayList__init_();
        var$2 = new oncia_UserAllQualifier;
        onciu_InputPosition$_$callClinit();
        var$2.$position13 = onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$);
        ju_ArrayList_add($list, var$2);
        return $list;
    }
    function onciafn_Neo4jASTFactory_ifExistsDo($this, $replace, $ifNotExists) {
        var var$3, var$4, var$5;
        var$3 = s_Tuple2$mcZZ$sp__init_($replace, $ifNotExists);
        var$4 = var$3.$_1$mcZ$sp0;
        var$5 = var$3.$_2$mcZ$sp0;
        $replace = $rt_compare(1, var$4);
        if (!$replace && 1 == var$5)
            return oncia_IfExistsInvalidSyntax$_MODULE$;
        if (!$replace && 0 == var$5)
            return oncia_IfExistsReplace$_MODULE$;
        $replace = $rt_compare(0, var$4);
        if (!$replace && 1 == var$5)
            return oncia_IfExistsDoNothing$_MODULE$;
        if (!$replace && 0 == var$5)
            return oncia_IfExistsThrowError$_MODULE$;
        $rt_throw(s_MatchError__init_(var$3));
    }
    function onciafn_Neo4jASTFactory_yieldOrWhere($this, $yieldExpr, $returnWithoutGraph, $where) {
        var var$4, var$5;
        if ($yieldExpr === null) {
            if ($where === null)
                return s_None$_MODULE$;
            $returnWithoutGraph = new s_Some;
            s_package$_$callClinit();
            s_Some__init_0($returnWithoutGraph, su_Right$_apply(s_package$_Right(s_package$_MODULE$), $where));
            return $returnWithoutGraph;
        }
        $where = new s_Some;
        s_package$_$callClinit();
        var$4 = s_package$_Left(s_package$_MODULE$);
        var$5 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        s_Some__init_0($where, su_Left$_apply(var$4, s_Predef$ArrowAssoc$_$minus$greater$extension(var$5, $yieldExpr, s_Option$_apply(s_Option$_MODULE$, $returnWithoutGraph))));
        return $where;
    }
    function onciafn_Neo4jASTFactory_asBooleanOption($this, $bool) {
        if ($bool === null)
            return s_None$_MODULE$;
        return s_Some__init_(jl_Boolean_valueOf($bool.$value8));
    }
    function onciafn_Neo4jASTFactory_asOptionsAst($this, $options) {
        var var$2, $map, $param;
        var$2 = 0;
        $map = null;
        $options = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $options), new onciafn_Neo4jASTFactory$asOptionsAst$lambda$_234_0);
        if ($options instanceof s_Some) {
            var$2 = 1;
            $map = $options;
            $param = $map.$value5;
            if ($param instanceof su_Left) {
                $map = $param.$value11;
                return oncia_OptionsMap__init_(sc_AbstractIterable_toMap(scc_AsScalaExtensions$MapHasAsScala_asScala(sj_CollectionConverters$_MapHasAsScala(sj_CollectionConverters$_MODULE$, $map)), s_$less$colon$less$_singleton));
            }
        }
        if (var$2) {
            $map = $map.$value5;
            if ($map instanceof su_Right) {
                $param = $map.$value10;
                $options = new oncia_OptionsParam;
                $options.$parameter1 = $param;
                return $options;
            }
        }
        if (jl_Object_equals(s_None$_MODULE$, $options))
            return oncia_NoOptions$_MODULE$;
        $rt_throw(s_MatchError__init_($options));
    }
    function onciafn_Neo4jASTFactory_asExpressionMapAst($this, $driverSettings) {
        var $param, $map;
        $driverSettings = onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, $driverSettings));
        if (!($driverSettings instanceof su_Left)) {
            if (!($driverSettings instanceof su_Right))
                $rt_throw(s_MatchError__init_($driverSettings));
            $param = $driverSettings.$value10;
            s_package$_$callClinit();
            return su_Right$_apply(s_package$_Right(s_package$_MODULE$), $param);
        }
        $map = $driverSettings.$value11;
        s_package$_$callClinit();
        return su_Left$_apply(s_package$_Left(s_package$_MODULE$), sc_AbstractIterable_toMap(scc_AsScalaExtensions$MapHasAsScala_asScala(sj_CollectionConverters$_MapHasAsScala(sj_CollectionConverters$_MODULE$, $map)), s_$less$colon$less$_singleton));
    }
    function onciafn_Neo4jASTFactory_pretty($this, $ts) {
        var var$2, var$3, var$4, var$5;
        $ts = jusi_SimpleStreamImpl_map(ju_Collection_stream($ts), new onciafn_Neo4jASTFactory$pretty$lambda$_236_0);
        var$2 = new jus_Collectors$joining$lambda$_7_0;
        var$2.$_0230 = $rt_s(43);
        var$3 = new jus_Collectors$joining$lambda$_7_1;
        var$3.$_0231 = $rt_s(43);
        var$4 = new jus_Collectors$joining$lambda$_7_2;
        var$5 = new jus_Collectors$joining$lambda$_7_3;
        var$5.$_0232 = $rt_s(3);
        var$5.$_162 = $rt_s(3);
        return jusi_SimpleStreamImpl_collect($ts, jus_Collector_of(var$4, var$2, var$3, var$5, $rt_createArray(jus_Collector$Characteristics, 0)));
    }
    function onciafn_Neo4jASTFactory_relationshipType($this) {
        oncipj_EntityType_$callClinit();
        return oncipj_EntityType_RELATIONSHIP;
    }
    function onciafn_Neo4jASTFactory_nodeType($this) {
        oncipj_EntityType_$callClinit();
        return oncipj_EntityType_NODE;
    }
    function onciafn_Neo4jASTFactory_labelColonDisjunction($this, $x$1, $x$2, $x$3, $x$4) {
        return oncil_LabelExpression$ColonDisjunction__init_($x$2, $x$3, $x$4, $x$1);
    }
    function onciafn_Neo4jASTFactory_labelColonConjunction($this, $x$1, $x$2, $x$3, $x$4) {
        return oncil_LabelExpression$ColonConjunction__init_($x$2, $x$3, $x$4, $x$1);
    }
    function onciafn_Neo4jASTFactory_labelLeaf($this, $x$1, $x$2, $x$3, $x$4) {
        oncipj_EntityType_$callClinit();
        if (jl_Enum_equals(oncipj_EntityType_NODE, $x$3))
            $x$3 = oncil_LabelExpression$Leaf__init_(oncie_LabelName__init_($x$2, $x$1), $x$4);
        else if (jl_Enum_equals(oncipj_EntityType_NODE_OR_RELATIONSHIP, $x$3))
            $x$3 = oncil_LabelExpression$Leaf__init_(oncie_LabelOrRelTypeName__init_($x$2, $x$1), $x$4);
        else {
            if (!jl_Enum_equals(oncipj_EntityType_RELATIONSHIP, $x$3))
                $rt_throw(s_MatchError__init_($x$3));
            $x$3 = oncil_LabelExpression$Leaf__init_(oncie_RelTypeName__init_($x$2, $x$1), $x$4);
        }
        return $x$3;
    }
    function onciafn_Neo4jASTFactory_labelWildcard($this, $x$1, $x$2) {
        return oncil_LabelExpression$Wildcard__init_($x$2, $x$1);
    }
    function onciafn_Neo4jASTFactory_labelNegation($this, $x$1, $x$2, $x$3) {
        return oncil_LabelExpression$Negation__init_($x$2, $x$3, $x$1);
    }
    function onciafn_Neo4jASTFactory_labelDisjunction($this, $x$1, $x$2, $x$3, $x$4) {
        return oncil_LabelExpression$Disjunctions$_flat(oncil_LabelExpression$Disjunctions$_MODULE$, $x$2, $x$3, $x$1, $x$4);
    }
    function onciafn_Neo4jASTFactory_labelConjunction($this, $x$1, $x$2, $x$3, $x$4) {
        return oncil_LabelExpression$Conjunctions$_flat(oncil_LabelExpression$Conjunctions$_MODULE$, $x$2, $x$3, $x$1, $x$4);
    }
    function onciafn_Neo4jASTFactory_databaseName($this, $x$1) {
        return oncia_ParameterName__init_($x$1, $x$1.$position14);
    }
    function onciafn_Neo4jASTFactory_databaseName0($this, $x$1, $x$2) {
        var var$3, var$4, var$5, var$6;
        a: {
            var$3 = 0;
            var$4 = null;
            $x$2 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2)));
            if ($x$2 instanceof sci_$colon$colon) {
                var$3 = 1;
                var$4 = $x$2;
                var$5 = var$4.$head0;
                var$6 = var$4.$next0;
                if (sci_List_equals(sci_Nil$_MODULE$, var$6)) {
                    $x$2 = oncia_NamespacedName__init_(sci_$colon$colon__init_(var$5, sci_Nil$_MODULE$), s_None$_MODULE$, $x$1);
                    break a;
                }
            }
            if (!var$3) {
                $x$1 = new jl_InternalError;
                jl_Throwable__init_($x$1, $rt_s(549));
                $rt_throw($x$1);
            }
            var$6 = var$4.$head0;
            var$5 = var$4.$next0;
            $x$2 = oncia_NamespacedName__init_(var$5, s_Some__init_(var$6), $x$1);
        }
        return $x$2;
    }
    function onciafn_Neo4jASTFactory_wait($this, $x$1, $x$2) {
        var var$3, var$4;
        if (!$x$1) {
            oncia_NoWait$_$callClinit();
            var$3 = oncia_NoWait$_MODULE$;
        } else if (Long_le($x$2, Long_ZERO)) {
            oncia_IndefiniteWait$_$callClinit();
            var$3 = oncia_IndefiniteWait$_MODULE$;
        } else {
            var$3 = new oncia_TimeoutAfter;
            var$3.$timoutSeconds = $x$2;
            oncia_WaitUntilComplete_$init$(var$3);
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$4);
            jl_StringBuilder_append(jl_StringBuilder_append2(jl_StringBuilder_append(var$4, $rt_s(550)), $x$2), $rt_s(551));
            var$3.$name20 = jl_AbstractStringBuilder_toString(var$4);
        }
        return var$3;
    }
    function onciafn_Neo4jASTFactory_alterDatabase($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7, $x$8, $x$9) {
        var var$10, var$11;
        var$10 = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $x$4), new onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_0);
        var$11 = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $x$5), new onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_1);
        $x$4 = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $x$6), new onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_2);
        $x$5 = $x$7 === null ? oncia_NoOptions$_MODULE$ : oncia_OptionsMap__init_(sc_AbstractIterable_toMap(scc_AsScalaExtensions$MapHasAsScala_asScala(sj_CollectionConverters$_MapHasAsScala(sj_CollectionConverters$_MODULE$, $x$7)), s_$less$colon$less$_singleton));
        if (sj_CollectionConverters$_MODULE$ === null)
            $rt_throw(null);
        if ($x$8 === null)
            $x$6 = null;
        else if ($x$8 instanceof scc_JavaCollectionWrappers$MutableSetWrapper)
            $x$6 = $x$8.$underlying15();
        else {
            $x$6 = new scc_JavaCollectionWrappers$JSetWrapper;
            $x$6.$underlying16 = $x$8;
            jl_Object__init_0($x$6);
        }
        $x$6 = sc_AbstractIterable_toSet($x$6);
        return oncia_AlterDatabase__init_($x$2, $x$3, var$10, !s_Option_isDefined(var$11) && !s_Option_isDefined($x$4) ? s_None$_MODULE$ : s_Some__init_(oncia_Topology__init_(var$11, $x$4)), $x$5, $x$6, $x$9, $x$1);
    }
    function onciafn_Neo4jASTFactory_databaseScope($this, $x$1, $x$2, $x$3) {
        onciaf_ScopeType_$callClinit();
        if (jl_Enum_equals(onciaf_ScopeType_ALL, $x$3))
            $x$3 = oncia_AllDatabasesScope__init_($x$1);
        else if (jl_Enum_equals(onciaf_ScopeType_HOME, $x$3))
            $x$3 = oncia_HomeDatabaseScope__init_($x$1);
        else if (jl_Enum_equals(onciaf_ScopeType_DEFAULT, $x$3))
            $x$3 = oncia_DefaultDatabaseScope__init_($x$1);
        else {
            if (!jl_Enum_equals(onciaf_ScopeType_NAMED, $x$3))
                $rt_throw(s_MatchError__init_($x$3));
            $x$3 = oncia_NamedDatabasesScope__init_(sc_IterableOnceOps_toSeq$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2))), $x$1);
        }
        return $x$3;
    }
    function onciafn_Neo4jASTFactory_graphScope($this, $x$1, $x$2, $x$3) {
        onciaf_ScopeType_$callClinit();
        if (jl_Enum_equals(onciaf_ScopeType_ALL, $x$3)) {
            $x$3 = new oncia_AllGraphsScope;
            $x$3.$position15 = $x$1;
        } else if (jl_Enum_equals(onciaf_ScopeType_HOME, $x$3)) {
            $x$3 = new oncia_HomeGraphScope;
            $x$3.$position16 = $x$1;
        } else if (jl_Enum_equals(onciaf_ScopeType_DEFAULT, $x$3)) {
            $x$3 = new oncia_DefaultGraphScope;
            $x$3.$position17 = $x$1;
        } else {
            if (!jl_Enum_equals(onciaf_ScopeType_NAMED, $x$3))
                $rt_throw(s_MatchError__init_($x$3));
            $x$3 = oncia_NamedGraphsScope__init_(sc_IterableOnceOps_toSeq$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2))), $x$1);
        }
        return $x$3;
    }
    function onciafn_Neo4jASTFactory_patternQualifier($this, $x$1, $x$2, $x$3) {
        var var$4, var$5;
        $x$3 = $x$3;
        if (!($x$3 instanceof oncie_Not))
            $x$3 = onciafn_Neo4jASTFactory_switchSides$1($x$3);
        else {
            var$4 = $x$3;
            var$5 = var$4.$rhs5;
            $x$3 = oncie_Not__init_(onciafn_Neo4jASTFactory_switchSides$1(var$5), var$4.$position18);
        }
        return oncia_PatternQualifier__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$1))), s_Option$_apply(s_Option$_MODULE$, $x$2), $x$3);
    }
    function onciafn_Neo4jASTFactory_allElementsQualifier($this, $x$1) {
        var var$2;
        var$2 = new oncia_ElementsAllQualifier;
        var$2.$position19 = $x$1;
        return var$2;
    }
    function onciafn_Neo4jASTFactory_elementQualifier($this, $x$1, $x$2) {
        return oncia_ElementQualifier__init_($x$2, $x$1);
    }
    function onciafn_Neo4jASTFactory_allRelationshipsQualifier($this, $x$1) {
        var var$2;
        var$2 = new oncia_RelationshipAllQualifier;
        var$2.$position20 = $x$1;
        return var$2;
    }
    function onciafn_Neo4jASTFactory_relationshipQualifier($this, $x$1, $x$2) {
        return oncia_RelationshipQualifier__init_($x$2, $x$1);
    }
    function onciafn_Neo4jASTFactory_allLabelsQualifier($this, $x$1) {
        var var$2;
        var$2 = new oncia_LabelAllQualifier;
        var$2.$position21 = $x$1;
        return var$2;
    }
    function onciafn_Neo4jASTFactory_labelQualifier($this, $x$1, $x$2) {
        return oncia_LabelQualifier__init_($x$2, $x$1);
    }
    function onciafn_Neo4jASTFactory_privilegeAction0($this, $x$1) {
        return onciafn_Neo4jASTFactory_privilegeAction($this, $x$1);
    }
    function onciafn_Neo4jASTFactory_graphPrivilege($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6) {
        var var$7, var$8;
        var$7 = new onciafn_Privilege;
        var$8 = new oncia_GraphPrivilege;
        $x$2 = $x$2;
        var$8.$action0 = $x$2;
        var$8.$scope5 = $x$3;
        var$8.$position22 = $x$1;
        oncia_PrivilegeType__init_(var$8, $x$2.$name21);
        onciafn_Privilege__init_(var$7, var$8, $x$4, $x$5, $x$6);
        return var$7;
    }
    function onciafn_Neo4jASTFactory_dbmsPrivilege($this, $x$1, $x$2, $x$3, $x$4) {
        var var$5, var$6;
        var$5 = new onciafn_Privilege;
        var$6 = new oncia_DbmsPrivilege;
        $x$2 = $x$2;
        var$6.$action1 = $x$2;
        var$6.$position23 = $x$1;
        oncia_PrivilegeType__init_(var$6, $x$2.$name3());
        onciafn_Privilege__init_(var$5, var$6, null, $x$3, $x$4);
        return var$5;
    }
    function onciafn_Neo4jASTFactory_databasePrivilege($this, $x$1, $x$2, $x$3, $x$4, $x$5) {
        var var$6, var$7;
        var$6 = new onciafn_Privilege;
        var$7 = new oncia_DatabasePrivilege;
        $x$2 = $x$2;
        var$7.$action2 = $x$2;
        var$7.$scope6 = $x$3;
        var$7.$position24 = $x$1;
        oncia_PrivilegeType__init_(var$7, $x$2.$name3());
        onciafn_Privilege__init_(var$6, var$7, null, $x$4, $x$5);
        return var$6;
    }
    function onciafn_Neo4jASTFactory_revokePrivilege($this, $x$1, $x$2, $x$3, $x$4, $x$5) {
        var var$6, var$7, var$8, var$9, var$10, var$11;
        var$6 = s_Tuple2$mcZZ$sp__init_($x$4, $x$5);
        $x$5 = var$6.$_1$mcZ$sp0;
        $x$4 = var$6.$_2$mcZ$sp0;
        if (1 == $x$5 && 0 == $x$4) {
            var$7 = new oncia_RevokePrivilege;
            var$8 = $x$3.$privilegeType;
            $x$4 = $x$3.$immutable;
            var$6 = s_Option$_apply(s_Option$_MODULE$, $x$3.$resource0);
            var$9 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$3.$qualifier0)));
            $x$2 = (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2)), new onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_0)).$toSeq();
            $x$3 = new oncia_RevokeGrantType;
            $x$3.$position25 = $x$1;
            oncia_RevokeType__init_($x$3, $rt_s(552), $rt_s(553));
            oncia_RevokePrivilege__init_(var$7, var$8, $x$4, var$6, var$9, $x$2, $x$3, $x$1);
        } else if (0 == $x$5 && 1 == $x$4) {
            var$7 = new oncia_RevokePrivilege;
            var$9 = $x$3.$privilegeType;
            $x$4 = $x$3.$immutable;
            var$6 = s_Option$_apply(s_Option$_MODULE$, $x$3.$resource0);
            var$10 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$3.$qualifier0)));
            $x$2 = (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2)), new onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_1)).$toSeq();
            $x$3 = new oncia_RevokeDenyType;
            $x$3.$position26 = $x$1;
            oncia_RevokeType__init_($x$3, $rt_s(554), $rt_s(555));
            oncia_RevokePrivilege__init_(var$7, var$9, $x$4, var$6, var$10, $x$2, $x$3, $x$1);
        } else {
            var$7 = new oncia_RevokePrivilege;
            var$11 = $x$3.$privilegeType;
            $x$4 = $x$3.$immutable;
            var$6 = s_Option$_apply(s_Option$_MODULE$, $x$3.$resource0);
            var$8 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$3.$qualifier0)));
            $x$2 = (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2)), new onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_2)).$toSeq();
            $x$3 = new oncia_RevokeBothType;
            $x$3.$position27 = $x$1;
            oncia_RevokeType__init_($x$3, $rt_s(3), $rt_s(3));
            oncia_RevokePrivilege__init_(var$7, var$11, $x$4, var$6, var$8, $x$2, $x$3, $x$1);
        }
        return var$7;
    }
    function onciafn_Neo4jASTFactory_grantPrivilege($this, $x$1, $x$2, $x$3) {
        return oncia_GrantPrivilege__init_($x$3.$privilegeType, $x$3.$immutable, s_Option$_apply(s_Option$_MODULE$, $x$3.$resource0), sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$3.$qualifier0))), (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2)), new onciafn_Neo4jASTFactory$grantPrivilege$lambda$_177_0)).$toSeq(),
        $x$1);
    }
    function onciafn_Neo4jASTFactory_createConstraint0($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7, $x$8, $x$9, $x$10, $x$11, $x$12) {
        return onciafn_Neo4jASTFactory_createConstraint($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7, $x$8, $x$9, $x$10, $x$11, $x$12);
    }
    function onciafn_Neo4jASTFactory_showSettingsClause($this, $x$1, $x$2, $x$3, $x$4) {
        var var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13, var$14, var$15;
        var$5 = su_Either$LeftProjection_map(su_Either_left(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, $x$2))), new onciafn_Neo4jASTFactory$showSettingsClause$lambda$_145_0);
        var$6 = s_Option$_apply(s_Option$_MODULE$, $x$3);
        var$7 = new sci_$colon$colon;
        $x$2 = oncia_ShowColumn$_MODULE$;
        var$8 = oncia_ShowColumn$_apply($x$2, $rt_s(537), oncia_ShowColumn$_apply$default$2($x$2), $x$1);
        var$9 = new sci_$colon$colon;
        $x$3 = oncia_ShowColumn$_MODULE$;
        var$10 = oncia_ShowColumn$_apply($x$3, $rt_s(556), oncia_ShowColumn$_apply$default$2($x$3), $x$1);
        var$11 = new sci_$colon$colon;
        var$12 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        var$13 = oncia_ShowColumn$_apply(var$12, $rt_s(557), oncius_package$_CTBoolean(oncius_package$_MODULE$), $x$1);
        $x$2 = new sci_$colon$colon;
        $x$3 = oncia_ShowColumn$_MODULE$;
        $x$3 = oncia_ShowColumn$_apply($x$3, $rt_s(558), oncia_ShowColumn$_apply$default$2($x$3), $x$1);
        var$12 = new sci_$colon$colon;
        var$14 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$12, oncia_ShowColumn$_apply(var$14, $rt_s(559), oncia_ShowColumn$_apply$default$2(var$14), $x$1), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0($x$2, $x$3, var$12);
        sci_$colon$colon__init_0(var$11, var$13, $x$2);
        sci_$colon$colon__init_0(var$9, var$10, var$11);
        sci_$colon$colon__init_0(var$7, var$8, var$9);
        $x$3 = new sci_$colon$colon;
        $x$2 = oncia_ShowColumn$_MODULE$;
        $x$2 = oncia_ShowColumn$_apply($x$2, $rt_s(560), oncia_ShowColumn$_apply$default$2($x$2), $x$1);
        var$12 = new sci_$colon$colon;
        var$14 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(561), oncius_package$_CTBoolean(oncius_package$_MODULE$), $x$1);
        var$15 = new sci_$colon$colon;
        var$8 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$15, oncia_ShowColumn$_apply(var$8, $rt_s(562), oncia_ShowColumn$_apply$default$2(var$8), $x$1), sci_$colon$colon__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(563), oncius_package$_CTBoolean(oncius_package$_MODULE$), $x$1), sci_Nil$_MODULE$));
        sci_$colon$colon__init_0(var$12, var$14, var$15);
        sci_$colon$colon__init_0($x$3, $x$2, var$12);
        return oncia_ShowSettingsClause__init_(oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $x$4, var$7, var$7.$concat0($x$3)), var$5, var$6, $x$4, $x$1);
    }
    function onciafn_Neo4jASTFactory_turnYieldToWith($this, $x$1) {
        var var$2, var$3;
        var$2 = $x$1.$returnItems;
        var$3 = !sc_IterableOnceOps_nonEmpty$(var$2.$items) ? s_None$_MODULE$ : s_Some__init_((var$2.$items.$map1(new onciafn_Neo4jASTFactory$turnYieldToWith$lambda$_144_0)).$toList());
        return oncia_With__init_0(0, oncia_ReturnItems__init_(1, sci_Nil$_MODULE$, var$3, var$2.$position28), $x$1.$orderBy, $x$1.$skip, $x$1.$limit, $x$1.$where, oncia_ParsedAsYield$_MODULE$, $x$1.$position4);
    }
    function onciafn_Neo4jASTFactory_terminateTransactionsClause($this, $x$1, $x$2, $x$3, $x$4) {
        var var$5, var$6, var$7, var$8, var$9;
        $x$2 = su_Either$LeftProjection_map(su_Either_left(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, $x$2))), new onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_0);
        $x$4 = onciafn_Neo4jASTFactory_getYieldAllAndYieldItems($this, $x$4);
        if ($x$4 === null)
            $rt_throw(s_MatchError__init_($x$4));
        var$5 = s_Tuple2__1$mcZ$sp($x$4);
        var$6 = $x$4.$_20;
        var$7 = s_Tuple2__init_(jl_Boolean_valueOf(var$5), var$6);
        var$5 = s_Tuple2__1$mcZ$sp(var$7);
        var$8 = var$7.$_20;
        var$9 = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $x$3), new onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_1);
        return oncia_TerminateTransactionsClause__init_(sci_$colon$colon__init_(oncia_TransactionColumn__init_($rt_s(564), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sci_$colon$colon__init_(oncia_TransactionColumn__init_($rt_s(565), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sci_$colon$colon__init_(oncia_TransactionColumn__init_($rt_s(566), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sci_Nil$_MODULE$))), $x$2, var$8,
        var$5, var$9, $x$1);
    }
    function onciafn_Neo4jASTFactory_showTransactionsClause($this, $x$1, $x$2, $x$3, $x$4) {
        var var$5, var$6;
        $x$2 = su_Either$LeftProjection_map(su_Either_left(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, $x$2))), new onciafn_Neo4jASTFactory$showTransactionsClause$lambda$_141_0);
        $x$4 = onciafn_Neo4jASTFactory_getYieldAllAndYieldItems($this, $x$4);
        if ($x$4 === null)
            $rt_throw(s_MatchError__init_($x$4));
        var$5 = s_Tuple2__1$mcZ$sp($x$4);
        $x$4 = $x$4.$_20;
        var$6 = s_Tuple2__init_(jl_Boolean_valueOf(var$5), $x$4);
        var$5 = s_Tuple2__1$mcZ$sp(var$6);
        $x$4 = var$6.$_20;
        return oncia_ShowTransactionsClause$_apply(oncia_ShowTransactionsClause$_MODULE$, $x$2, s_Option$_apply(s_Option$_MODULE$, $x$3), $x$4, var$5, $x$1);
    }
    function onciafn_Neo4jASTFactory_showFunctionClause($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6) {
        var var$7;
        onciaf_ShowCommandFilterTypes_$callClinit();
        if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_ALL, $x$2))
            $x$2 = oncia_AllFunctions$_MODULE$;
        else if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_BUILT_IN, $x$2))
            $x$2 = oncia_BuiltInFunctions$_MODULE$;
        else {
            if (!jl_Enum_equals(onciaf_ShowCommandFilterTypes_USER_DEFINED, $x$2)) {
                $x$4 = new onciafn_Neo4jASTConstructionException;
                jl_Throwable__init_($x$4, onciaf_ASTExceptionFactory_invalidShowFilterType($rt_s(567), $x$2));
                $rt_throw($x$4);
            }
            $x$2 = oncia_UserDefinedFunctions$_MODULE$;
        }
        var$7 = $x$4 !== null ? s_Some__init_(oncia_User__init_($x$4)) : !$x$3 ? s_None$_MODULE$ : s_Some__init_(oncia_CurrentUser$_MODULE$);
        return oncia_ShowFunctionsClause$_apply(oncia_ShowFunctionsClause$_MODULE$, $x$2, var$7, s_Option$_apply(s_Option$_MODULE$, $x$5), $x$6, $x$1);
    }
    function onciafn_Neo4jASTFactory_showProcedureClause($this, $x$1, $x$2, $x$3, $x$4, $x$5) {
        var var$6;
        var$6 = $x$3 !== null ? s_Some__init_(oncia_User__init_($x$3)) : !$x$2 ? s_None$_MODULE$ : s_Some__init_(oncia_CurrentUser$_MODULE$);
        return oncia_ShowProceduresClause$_apply(oncia_ShowProceduresClause$_MODULE$, var$6, s_Option$_apply(s_Option$_MODULE$, $x$4), $x$5, $x$1);
    }
    function onciafn_Neo4jASTFactory_showConstraintClause0($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6) {
        return onciafn_Neo4jASTFactory_showConstraintClause($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6);
    }
    function onciafn_Neo4jASTFactory_showIndexClause($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6) {
        onciaf_ShowCommandFilterTypes_$callClinit();
        if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_ALL, $x$2))
            $x$2 = oncia_AllIndexes$_MODULE$;
        else if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_BTREE, $x$2))
            $x$2 = oncia_BtreeIndexes$_MODULE$;
        else if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_RANGE, $x$2))
            $x$2 = oncia_RangeIndexes$_MODULE$;
        else if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_FULLTEXT, $x$2))
            $x$2 = oncia_FulltextIndexes$_MODULE$;
        else if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_TEXT, $x$2))
            $x$2 = oncia_TextIndexes$_MODULE$;
        else if (jl_Enum_equals(onciaf_ShowCommandFilterTypes_POINT, $x$2))
            $x$2 = oncia_PointIndexes$_MODULE$;
        else {
            if (!jl_Enum_equals(onciaf_ShowCommandFilterTypes_LOOKUP, $x$2)) {
                $x$5 = new onciafn_Neo4jASTConstructionException;
                jl_Throwable__init_($x$5, onciaf_ASTExceptionFactory_invalidShowFilterType($rt_s(568), $x$2));
                $rt_throw($x$5);
            }
            $x$2 = oncia_LookupIndexes$_MODULE$;
        }
        return oncia_ShowIndexesClause$_apply(oncia_ShowIndexesClause$_MODULE$, $x$2, $x$3, $x$4, s_Option$_apply(s_Option$_MODULE$, $x$5), $x$6, $x$1);
    }
    function onciafn_Neo4jASTFactory_useGraph($this, $x$1, $x$2) {
        return $x$1.$withGraph(s_Option$_apply(s_Option$_MODULE$, $x$2));
    }
    function onciafn_Neo4jASTFactory_patternExpression($this, $x$1, $x$2) {
        var var$3, var$4;
        if ($x$2 instanceof oncie_ShortestPathsPatternPart)
            var$3 = oncie_ShortestPathExpression__init_($x$2);
        else {
            var$3 = new oncie_PatternExpression;
            var$4 = oncie_RelationshipsPattern__init_($x$2.$element(), $x$1);
            $x$1 = s_None$_MODULE$;
            oncie_PatternExpression__init_(var$3, var$4, $x$1, $x$1);
        }
        return var$3;
    }
    function onciafn_Neo4jASTFactory_isTyped($this, $x$1, $x$2, $x$3) {
        return oncia_IsTyped__init_($x$2, onciafn_Neo4jASTFactory_convertCypherType($this, $x$3), $x$1);
    }
    function onciafn_Neo4jASTFactory_newInfinityLiteral($this, $x$1) {
        return oncie_Infinity__init_($x$1);
    }
    function onciafn_Neo4jASTFactory_newDecimalInteger($this, $x$1, $x$2, $x$3) {
        var var$4, var$5;
        if (!$x$3)
            var$4 = oncie_SignedDecimalIntegerLiteral__init_($x$2, $x$1);
        else {
            var$4 = new oncie_SignedDecimalIntegerLiteral;
            var$5 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$5);
            jl_AbstractStringBuilder_append(var$5, 45);
            jl_StringBuilder_append(var$5, $x$2);
            oncie_SignedDecimalIntegerLiteral__init_0(var$4, jl_AbstractStringBuilder_toString(var$5), $x$1);
        }
        return var$4;
    }
    function onciafn_Neo4jASTFactory_newVariable($this, $x$1, $x$2) {
        return oncie_Variable__init_($x$2, $x$1);
    }
    function onciafn_Neo4jASTFactory_pathLength($this, $x$1, $x$2, $x$3, $x$4, $x$5) {
        var var$6;
        if ($x$4 === null && $x$5 === null)
            $x$3 = s_None$_MODULE$;
        else {
            var$6 = $x$4 !== null && jl_String_equals($x$4, $rt_s(3)) ? s_None$_MODULE$ : s_Some__init_(oncie_UnsignedDecimalIntegerLiteral__init_($x$4, $x$2));
            $x$4 = $x$5 !== null && jl_String_equals($x$5, $rt_s(3)) ? s_None$_MODULE$ : s_Some__init_(oncie_UnsignedDecimalIntegerLiteral__init_($x$5, $x$3));
            $x$3 = new s_Some;
            $x$5 = new oncie_Range;
            if ($x$2 !== null)
                $x$1 = $x$2;
            oncie_Range__init_0($x$5, var$6, $x$4, $x$1);
            s_Some__init_0($x$3, $x$5);
        }
        return $x$3;
    }
    function onciafn_Neo4jASTFactory_relationshipPattern($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7, $x$8) {
        var var$9, var$10;
        $x$8 = $x$8;
        var$9 = $x$2 && !$x$3 ? oncie_SemanticDirection$INCOMING$_MODULE$ : !$x$2 && $x$3 ? oncie_SemanticDirection$OUTGOING$_MODULE$ : oncie_SemanticDirection$BOTH$_MODULE$;
        if ($x$6 === null)
            $x$6 = s_None$_MODULE$;
        else if (jl_Object_equals(s_None$_MODULE$, $x$6))
            $x$6 = s_Some__init_(s_None$_MODULE$);
        else {
            if (!($x$6 instanceof s_Some))
                $rt_throw(s_MatchError__init_($x$6));
            var$10 = $x$6.$value5;
            $x$6 = s_Some__init_(s_Some__init_(var$10));
        }
        return oncie_RelationshipPattern__init_(s_Option$_apply(s_Option$_MODULE$, $x$4), s_Option$_apply(s_Option$_MODULE$, $x$5), $x$6, s_Option$_apply(s_Option$_MODULE$, $x$7), s_Option$_apply(s_Option$_MODULE$, $x$8), var$9, $x$1);
    }
    function onciafn_Neo4jASTFactory_nodePattern($this, $x$1, $x$2, $x$3, $x$4, $x$5) {
        var var$6;
        var$6 = $x$5;
        return oncie_NodePattern__init_(s_Option$_apply(s_Option$_MODULE$, $x$2), s_Option$_apply(s_Option$_MODULE$, $x$3), s_Option$_apply(s_Option$_MODULE$, $x$4), s_Option$_apply(s_Option$_MODULE$, var$6), $x$1);
    }
    function onciafn_Neo4jASTFactory_shortestGroupsSelector($this, $x$1, $x$2, $x$3) {
        return oncie_PatternPart$ShortestGroups__init_(onciafn_Neo4jASTFactory_defaultCountValue($this, $x$1, $x$2, $x$3), $x$3);
    }
    function onciafn_Neo4jASTFactory_allShortestPathSelector($this, $x$1) {
        return oncie_PatternPart$AllShortestPaths__init_($x$1);
    }
    function onciafn_Neo4jASTFactory_anyShortestPathSelector($this, $x$1, $x$2, $x$3) {
        return oncie_PatternPart$AnyShortestPath__init_(onciafn_Neo4jASTFactory_defaultCountValue($this, $x$1, $x$2, $x$3), $x$3);
    }
    function onciafn_Neo4jASTFactory_allPathSelector0($this, $x$1) {
        return onciafn_Neo4jASTFactory_allPathSelector($this, $x$1);
    }
    function onciafn_Neo4jASTFactory_anyPathSelector($this, $x$1, $x$2, $x$3) {
        return oncie_PatternPart$AnyPath__init_(onciafn_Neo4jASTFactory_defaultCountValue($this, $x$1, $x$2, $x$3), $x$3);
    }
    function onciafn_Neo4jASTFactory_patternElement($this, $x$1) {
        var var$2, var$3, var$4, var$5;
        $x$1 = scc_AsScalaExtensions$IteratorHasAsScala_asScala(scc_AsScalaExtensions$IteratorHasAsScala__init_(sj_CollectionConverters$_MODULE$, ju_AbstractList_iterator($x$1)));
        var$2 = new sc_Iterator$$anon$1;
        if ($x$1 === null)
            $rt_throw(null);
        var$2.$$outer23 = $x$1;
        var$2.$hdDefined1 = 0;
        s_package$_$callClinit();
        $x$1 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        while (true) {
            if (!sc_Iterator$$anon$1_hasNext(var$2)) {
                a: {
                    if ($x$1 !== null) {
                        s_package$_Seq(s_package$_MODULE$);
                        sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $x$1);
                        if (!$x$1.$lengthCompare(1)) {
                            var$3 = $x$1.$apply1(0);
                            break a;
                        }
                    }
                    var$3 = oncie_PathConcatenation__init_($x$1, ($x$1.$head()).$position2());
                }
                return var$3;
            }
            var$3 = sc_Iterator$$anon$1_next(var$2);
            if (!(var$3 instanceof oncie_NodePattern)) {
                if (var$3 instanceof oncie_QuantifiedPath)
                    $x$1 = $x$1.$appended(var$3);
                else {
                    if (!(var$3 instanceof oncie_ParenthesizedPath))
                        break;
                    $x$1 = $x$1.$appended(var$3);
                }
            } else {
                var$3 = var$3;
                while (sc_Iterator$$anon$1_hasNext(var$2)) {
                    if (!var$2.$hdDefined1) {
                        var$2.$hd = sc_Iterator$$anon$1_next(var$2);
                        var$2.$hdDefined1 = 1;
                    }
                    if (!(var$2.$hd instanceof oncie_RelationshipPattern))
                        break;
                    var$4 = sc_Iterator$$anon$1_next(var$2);
                    var$5 = sc_Iterator$$anon$1_next(var$2);
                    var$3 = oncie_RelationshipChain__init_(var$3, var$4, var$5, var$3.$position2());
                }
                $x$1 = $x$1.$appended(var$3);
            }
        }
        if (!(var$3 instanceof oncie_RelationshipPattern))
            $rt_throw(s_MatchError__init_(var$3));
        $x$1 = new jl_IllegalStateException;
        jl_Throwable__init_($x$1, $rt_s(569));
        $rt_throw($x$1);
    }
    function onciafn_Neo4jASTFactory_pathPattern($this, $x$1) {
        return oncie_PathPatternPart__init_($x$1);
    }
    function onciafn_Neo4jASTFactory_matchClause($this, $x$1, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7) {
        var var$8;
        var$8 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$4)));
        $x$4 = new onciafn_Neo4jASTFactory$matchClause$lambda$_11_0;
        $x$4.$_0233 = $this;
        $x$4 = sci_List_map(var$8, $x$4);
        if ($x$3 === null)
            $x$3 = oncie_MatchMode$_default(oncie_MatchMode$_MODULE$, $x$1);
        return oncia_Match__init_0($x$2, $x$3, oncie_Pattern$ForMatch__init_($x$4, $x$5), $x$6 === null ? sci_Nil$_MODULE$ : sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$6))), s_Option$_apply(s_Option$_MODULE$, $x$7), $x$1);
    }
    function onciafn_Neo4jASTFactory_newReturnItem($this, $x$1, $x$2, $x$3, $x$4) {
        return oncia_UnaliasedReturnItem__init_($x$2, jl_String_substring0($this.$query0, $x$3, $x$4 + 1 | 0), $x$1);
    }
    function onciafn_Neo4jASTFactory_newReturnItem0($this, $x$1, $x$2, $x$3) {
        return oncia_AliasedReturnItem__init_($x$2, $x$3, $x$1);
    }
    function onciafn_Neo4jASTFactory_newSingleQuery($this, $x$1) {
        var var$2;
        if (ju_AbstractCollection_isEmpty($x$1)) {
            $x$1 = new onciafn_Neo4jASTConstructionException;
            jl_Throwable__init_($x$1, $rt_s(570));
            $rt_throw($x$1);
        }
        var$2 = (ju_ArrayList_get($x$1, 0)).$position2();
        return oncia_SingleQuery__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$1))), var$2);
    }
    function onciafn_Neo4jASTFactory_newSingleQuery0($this, $x$1, $x$2) {
        if (ju_AbstractCollection_isEmpty($x$2)) {
            $x$1 = new onciafn_Neo4jASTConstructionException;
            jl_Throwable__init_($x$1, $rt_s(570));
            $rt_throw($x$1);
        }
        return oncia_SingleQuery__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $x$2))), $x$1);
    }
    function onciafn_Neo4jASTFactory_switchSides$1($expression) {
        var var$2, var$3;
        if ($expression instanceof oncie_Equals) {
            var$2 = $expression;
            var$3 = var$2.$rhs6;
            if (var$3 instanceof oncie_Property)
                return oncie_Equals_copy(var$2, var$3, var$2.$lhs5, var$2.$position29);
        }
        if ($expression instanceof oncie_NotEquals) {
            var$2 = $expression;
            var$3 = var$2.$rhs7;
            if (var$3 instanceof oncie_Property)
                return oncie_NotEquals_copy(var$2, var$3, var$2.$lhs6, var$2.$position30);
        }
        return $expression;
    }
    var oncipj_CypherConstants = $rt_classWithoutFields(0);
    var oncipj_CypherConstants_tokenImage = null;
    function oncipj_CypherConstants__clinit_() {
        oncipj_CypherConstants_tokenImage = $rt_createArrayFromData(jl_String, [$rt_s(571), $rt_s(572), $rt_s(573), $rt_s(574), $rt_s(575), $rt_s(576), $rt_s(577), $rt_s(578), $rt_s(579), $rt_s(580), $rt_s(581), $rt_s(582), $rt_s(583), $rt_s(584), $rt_s(585), $rt_s(586), $rt_s(587), $rt_s(588), $rt_s(589), $rt_s(590), $rt_s(591), $rt_s(592), $rt_s(593), $rt_s(594), $rt_s(595), $rt_s(596), $rt_s(597), $rt_s(598), $rt_s(599), $rt_s(600), $rt_s(601), $rt_s(602), $rt_s(603), $rt_s(603), $rt_s(604), $rt_s(605), $rt_s(606),
        $rt_s(607), $rt_s(608), $rt_s(609), $rt_s(610), $rt_s(611), $rt_s(612), $rt_s(613), $rt_s(614), $rt_s(615), $rt_s(616), $rt_s(617), $rt_s(618), $rt_s(619), $rt_s(620), $rt_s(621), $rt_s(611), $rt_s(622), $rt_s(612), $rt_s(613), $rt_s(614), $rt_s(615), $rt_s(616), $rt_s(617), $rt_s(618), $rt_s(619), $rt_s(620), $rt_s(623), $rt_s(622), $rt_s(624), $rt_s(625), $rt_s(626), $rt_s(624), $rt_s(627), $rt_s(628), $rt_s(629), $rt_s(630), $rt_s(631), $rt_s(632), $rt_s(633), $rt_s(634), $rt_s(635), $rt_s(636), $rt_s(637),
        $rt_s(638), $rt_s(639), $rt_s(640), $rt_s(641), $rt_s(642), $rt_s(643), $rt_s(644), $rt_s(645), $rt_s(646), $rt_s(647), $rt_s(648), $rt_s(649), $rt_s(650), $rt_s(651), $rt_s(652), $rt_s(653), $rt_s(654), $rt_s(655), $rt_s(656), $rt_s(657), $rt_s(658), $rt_s(659), $rt_s(660), $rt_s(661), $rt_s(662), $rt_s(663), $rt_s(664), $rt_s(665), $rt_s(666), $rt_s(667), $rt_s(668), $rt_s(669), $rt_s(670), $rt_s(671), $rt_s(672), $rt_s(673), $rt_s(674), $rt_s(675), $rt_s(676), $rt_s(677), $rt_s(678), $rt_s(679), $rt_s(680),
        $rt_s(681), $rt_s(682), $rt_s(683), $rt_s(684), $rt_s(685), $rt_s(686), $rt_s(687), $rt_s(688), $rt_s(689), $rt_s(690), $rt_s(691), $rt_s(692), $rt_s(693), $rt_s(694), $rt_s(695), $rt_s(696), $rt_s(697), $rt_s(698), $rt_s(699), $rt_s(700), $rt_s(701), $rt_s(702), $rt_s(703), $rt_s(704), $rt_s(705), $rt_s(706), $rt_s(707), $rt_s(708), $rt_s(709), $rt_s(710), $rt_s(711), $rt_s(712), $rt_s(713), $rt_s(714), $rt_s(715), $rt_s(716), $rt_s(717), $rt_s(718), $rt_s(719), $rt_s(720), $rt_s(721), $rt_s(722), $rt_s(723),
        $rt_s(724), $rt_s(725), $rt_s(726), $rt_s(727), $rt_s(728), $rt_s(729), $rt_s(730), $rt_s(731), $rt_s(732), $rt_s(733), $rt_s(734), $rt_s(735), $rt_s(736), $rt_s(737), $rt_s(738), $rt_s(739), $rt_s(740), $rt_s(741), $rt_s(742), $rt_s(743), $rt_s(744), $rt_s(745), $rt_s(746), $rt_s(747), $rt_s(748), $rt_s(749), $rt_s(750), $rt_s(751), $rt_s(752), $rt_s(753), $rt_s(754), $rt_s(755), $rt_s(756), $rt_s(757), $rt_s(758), $rt_s(759), $rt_s(760), $rt_s(761), $rt_s(762), $rt_s(763), $rt_s(764), $rt_s(765), $rt_s(766),
        $rt_s(767), $rt_s(768), $rt_s(769), $rt_s(770), $rt_s(771), $rt_s(772), $rt_s(773), $rt_s(774), $rt_s(775), $rt_s(776), $rt_s(777), $rt_s(778), $rt_s(779), $rt_s(780), $rt_s(781), $rt_s(782), $rt_s(783), $rt_s(784), $rt_s(785), $rt_s(786), $rt_s(787), $rt_s(788), $rt_s(789), $rt_s(790), $rt_s(791), $rt_s(792), $rt_s(793), $rt_s(794), $rt_s(795), $rt_s(796), $rt_s(797), $rt_s(798), $rt_s(799), $rt_s(800), $rt_s(801), $rt_s(802), $rt_s(803), $rt_s(804), $rt_s(805), $rt_s(806), $rt_s(807), $rt_s(808), $rt_s(809),
        $rt_s(810), $rt_s(811), $rt_s(812), $rt_s(813), $rt_s(814), $rt_s(815), $rt_s(816), $rt_s(817), $rt_s(818), $rt_s(819), $rt_s(820), $rt_s(821), $rt_s(822), $rt_s(823), $rt_s(824), $rt_s(825), $rt_s(826), $rt_s(827), $rt_s(828), $rt_s(829), $rt_s(830), $rt_s(831), $rt_s(832), $rt_s(833), $rt_s(834), $rt_s(835), $rt_s(836), $rt_s(837), $rt_s(838), $rt_s(839), $rt_s(840), $rt_s(841), $rt_s(842), $rt_s(843), $rt_s(844), $rt_s(845), $rt_s(846), $rt_s(847), $rt_s(848), $rt_s(849), $rt_s(850), $rt_s(851), $rt_s(852),
        $rt_s(853), $rt_s(854), $rt_s(855), $rt_s(856), $rt_s(857), $rt_s(858), $rt_s(859), $rt_s(860), $rt_s(861), $rt_s(862), $rt_s(863), $rt_s(864), $rt_s(865), $rt_s(866), $rt_s(867), $rt_s(868), $rt_s(869), $rt_s(870), $rt_s(871), $rt_s(872), $rt_s(873), $rt_s(874), $rt_s(875), $rt_s(876), $rt_s(877), $rt_s(878), $rt_s(879), $rt_s(880), $rt_s(881), $rt_s(882), $rt_s(883), $rt_s(884), $rt_s(885), $rt_s(886), $rt_s(887), $rt_s(888), $rt_s(889), $rt_s(890), $rt_s(891), $rt_s(892), $rt_s(893), $rt_s(894), $rt_s(895),
        $rt_s(896), $rt_s(897), $rt_s(898), $rt_s(899), $rt_s(900), $rt_s(901), $rt_s(902), $rt_s(903), $rt_s(904), $rt_s(905)]);
    }
    function oncipj_Cypher() {
        var a = this; jl_Object.call(a);
        a.$exceptionFactory = null;
        a.$astFactory = null;
        a.$labelExpressionStack = null;
        a.$token_source = null;
        a.$token = null;
        a.$jj_nt = null;
        a.$jj_ntk = 0;
        a.$jj_scanpos = null;
        a.$jj_lastpos = null;
        a.$jj_la = 0;
        a.$jj_lookingAhead = 0;
        a.$jj_semLA = 0;
        a.$jj_gen = 0;
        a.$jj_la1 = null;
        a.$jj_2_rtns = null;
        a.$jj_rescan = 0;
        a.$jj_gc = 0;
        a.$jj_ls = null;
        a.$jj_expentries = null;
        a.$jj_expentry = null;
        a.$jj_kind = 0;
        a.$jj_lasttokens = null;
        a.$jj_endpos = 0;
    }
    var oncipj_Cypher_jj_la1_0 = null;
    var oncipj_Cypher_jj_la1_1 = null;
    var oncipj_Cypher_jj_la1_2 = null;
    var oncipj_Cypher_jj_la1_3 = null;
    var oncipj_Cypher_jj_la1_4 = null;
    var oncipj_Cypher_jj_la1_5 = null;
    var oncipj_Cypher_jj_la1_6 = null;
    var oncipj_Cypher_jj_la1_7 = null;
    var oncipj_Cypher_jj_la1_8 = null;
    var oncipj_Cypher_jj_la1_9 = null;
    var oncipj_Cypher_jj_la1_10 = null;
    function oncipj_Cypher_$callClinit() {
        oncipj_Cypher_$callClinit = $rt_eraseClinit(oncipj_Cypher);
        oncipj_Cypher__clinit_();
    }
    function oncipj_Cypher_pos($this, $t) {
        return $t === null ? null : onciafn_Neo4jASTFactory_inputPosition($this.$astFactory, $t.$beginOffset, $t.$beginLine, $t.$beginColumn);
    }
    function oncipj_Cypher_assertValidType($this, $t, $expected, $actual) {
        var var$4, var$5;
        if ($expected !== null && !jl_String_equals($expected, $actual)) {
            var$4 = $this.$exceptionFactory;
            var$5 = new oncipj_ParseException;
            jl_Throwable__init_(var$5, jl_String_format($rt_s(906), $rt_createArrayFromData(jl_Object, [$t.$image0, $expected])));
            $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException(var$4, var$5, $t.$beginOffset, $t.$beginLine, $t.$beginColumn));
        }
    }
    function oncipj_Cypher_assertNotAlreadySet($this, $object, $token, $errorMessage) {
        var var$4;
        if ($object === null)
            return;
        var$4 = $this.$exceptionFactory;
        $object = new oncipj_ParseException;
        jl_Throwable__init_($object, $errorMessage);
        $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException(var$4, $object, $token.$beginOffset, $token.$beginLine, $token.$beginColumn));
    }
    function oncipj_Cypher_Statement($this) {
        var var$1, var$2, $statement, $statement_0, $statement_1, var$6, $$je;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$1) {
            case 327:
                break;
            default:
                $this.$jj_la1.data[0] = $this.$jj_gen;
                var$2 = $this.$jj_ntk;
                if (var$2 == (-1))
                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                a: {
                    switch (var$2) {
                        case 77:
                        case 96:
                        case 114:
                        case 123:
                        case 126:
                        case 127:
                        case 130:
                        case 138:
                        case 139:
                        case 144:
                        case 163:
                        case 169:
                        case 199:
                        case 206:
                        case 207:
                        case 226:
                        case 257:
                        case 259:
                        case 264:
                        case 269:
                        case 270:
                        case 286:
                        case 291:
                        case 295:
                        case 298:
                        case 303:
                        case 322:
                        case 335:
                            $statement = null;
                            $statement_0 = null;
                            $this.$jj_la = 2;
                            $statement_1 = $this.$token;
                            $this.$jj_scanpos = $statement_1;
                            $this.$jj_lastpos = $statement_1;
                            b: {
                                c: {
                                    d: {
                                        e: {
                                            try {
                                                var$1 = oncipj_Cypher_jj_3_3($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break e;
                                                } else{
                                                    $statement = $$je;
                                                    break d;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 2, 2);
                                            break b;
                                        }
                                        try {
                                            var$1 = 1;
                                            break c;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $statement = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 2, 2);
                                    $rt_throw($statement);
                                }
                                oncipj_Cypher_jj_save($this, 2, 2);
                            }
                            f: {
                                if (var$1)
                                    $statement = oncipj_Cypher_CreateCommand($this, null);
                                else {
                                    var$2 = $this.$jj_ntk;
                                    if (var$2 == (-1))
                                        var$2 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$2) {
                                        case 77:
                                        case 123:
                                        case 127:
                                        case 138:
                                        case 139:
                                        case 144:
                                        case 169:
                                        case 257:
                                        case 259:
                                        case 270:
                                        case 291:
                                        case 295:
                                        case 298:
                                        case 303:
                                            $statement = oncipj_Cypher_Command($this, null);
                                            break f;
                                        case 96:
                                        case 114:
                                        case 126:
                                        case 130:
                                        case 163:
                                        case 199:
                                        case 206:
                                        case 207:
                                        case 226:
                                        case 264:
                                        case 269:
                                        case 286:
                                        case 322:
                                        case 324:
                                        case 335:
                                            $statement_0 = oncipj_Cypher_SingleQuery($this);
                                            g: while (true) {
                                                var$2 = $this.$jj_ntk;
                                                if (var$2 == (-1))
                                                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                                                switch (var$2) {
                                                    case 319:
                                                        break;
                                                    default:
                                                        break g;
                                                }
                                                $statement_0 = oncipj_Cypher_Union($this, $statement_0);
                                            }
                                            $this.$jj_la1.data[2] = $this.$jj_gen;
                                            break f;
                                        default:
                                    }
                                    $this.$jj_la1.data[3] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $statement = new oncipj_ParseException;
                                    jl_Throwable__init_0($statement);
                                    $rt_throw($statement);
                                }
                            }
                            if ($statement_0 !== null)
                                $statement = $statement_0;
                            break a;
                        case 324:
                            $statement_0 = oncipj_Cypher_UseClause($this);
                            $statement = null;
                            $statement_1 = null;
                            $this.$jj_la = 2;
                            var$6 = $this.$token;
                            $this.$jj_scanpos = var$6;
                            $this.$jj_lastpos = var$6;
                            h: {
                                i: {
                                    j: {
                                        k: {
                                            try {
                                                var$1 = oncipj_Cypher_jj_3_4($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break k;
                                                } else{
                                                    $statement = $$je;
                                                    break j;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 3, 2);
                                            break h;
                                        }
                                        try {
                                            var$1 = 1;
                                            break i;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $statement = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 3, 2);
                                    $rt_throw($statement);
                                }
                                oncipj_Cypher_jj_save($this, 3, 2);
                            }
                            l: {
                                if (var$1)
                                    $statement = oncipj_Cypher_CreateCommand($this, $statement_0);
                                else {
                                    var$2 = $this.$jj_ntk;
                                    if (var$2 == (-1))
                                        var$2 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$2) {
                                        case 77:
                                        case 123:
                                        case 127:
                                        case 138:
                                        case 139:
                                        case 144:
                                        case 169:
                                        case 257:
                                        case 259:
                                        case 270:
                                        case 291:
                                        case 295:
                                        case 298:
                                        case 303:
                                            break;
                                        default:
                                            $this.$jj_la1.data[5] = $this.$jj_gen;
                                            $statement_1 = ju_ArrayList__init_();
                                            if ($statement_0 !== null)
                                                ju_ArrayList_add($statement_1, $statement_0);
                                            m: while (true) {
                                                var$2 = $this.$jj_ntk;
                                                if (var$2 == (-1))
                                                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                                                switch (var$2) {
                                                    case 96:
                                                    case 114:
                                                    case 126:
                                                    case 130:
                                                    case 163:
                                                    case 199:
                                                    case 206:
                                                    case 207:
                                                    case 226:
                                                    case 264:
                                                    case 269:
                                                    case 286:
                                                    case 322:
                                                    case 324:
                                                    case 335:
                                                        break;
                                                    default:
                                                        break m;
                                                }
                                                ju_ArrayList_add($statement_1, oncipj_Cypher_Clause($this));
                                            }
                                            $this.$jj_la1.data[10] = $this.$jj_gen;
                                            $statement_1 = onciafn_Neo4jASTFactory_newSingleQuery($this.$astFactory, $statement_1);
                                            n: while (true) {
                                                var$2 = $this.$jj_ntk;
                                                if (var$2 == (-1))
                                                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                                                switch (var$2) {
                                                    case 319:
                                                        break;
                                                    default:
                                                        break n;
                                                }
                                                $statement_1 = oncipj_Cypher_Union($this, $statement_1);
                                            }
                                            $this.$jj_la1.data[4] = $this.$jj_gen;
                                            break l;
                                    }
                                    $statement = oncipj_Cypher_Command($this, $statement_0);
                                }
                            }
                            if ($statement_1 !== null)
                                $statement = $statement_1;
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[1] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $statement = new oncipj_ParseException;
                    jl_Throwable__init_0($statement);
                    $rt_throw($statement);
                }
                return $statement;
        }
        oncipj_Cypher_jj_consume_token($this, 327);
        $statement = oncipj_Cypher_jj_consume_token($this, 236);
        oncipj_Cypher_jj_consume_token($this, 106);
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        o: {
            switch (var$2) {
                case 36:
                    break;
                default:
                    $this.$jj_la1.data[6] = $this.$jj_gen;
                    break o;
            }
            oncipj_Cypher_jj_consume_token($this, 36);
        }
        $statement_1 = $this.$exceptionFactory;
        var$6 = new oncipj_ParseException;
        jl_Throwable__init_(var$6, $rt_s(907));
        $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($statement_1, var$6, $statement.$beginOffset, $statement.$beginLine, $statement.$beginColumn));
    }
    function oncipj_Cypher_RegularQuery($this) {
        var $x, var$2;
        $x = oncipj_Cypher_SingleQuery($this);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 319:
                    break;
                default:
                    break a;
            }
            $x = oncipj_Cypher_Union($this, $x);
        }
        $this.$jj_la1.data[7] = $this.$jj_gen;
        return $x;
    }
    function oncipj_Cypher_Union($this, $lhs) {
        var $all, $t, var$4, $rhs;
        $all = 0;
        $t = oncipj_Cypher_jj_consume_token($this, 319);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 76:
                    break;
                default:
                    $this.$jj_la1.data[8] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 76);
            $all = 1;
        }
        $rhs = oncipj_Cypher_SingleQuery($this);
        $t = oncipj_Cypher_pos($this, $t);
        if ($rhs instanceof oncia_SingleQuery)
            return !$all ? oncia_UnionDistinct__init_($lhs, $rhs, $t) : oncia_UnionAll__init_($lhs, $rhs, $t);
        $lhs = new onciafn_Neo4jASTConstructionException;
        $t = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($t);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($t, $rt_s(908)), $rhs), 96);
        jl_Throwable__init_($lhs, jl_AbstractStringBuilder_toString($t));
        $rt_throw($lhs);
    }
    function oncipj_Cypher_SingleQuery($this) {
        var $clauses, var$2;
        $clauses = ju_ArrayList__init_();
        a: while (true) {
            ju_ArrayList_add($clauses, oncipj_Cypher_Clause($this));
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 96:
                case 114:
                case 126:
                case 130:
                case 163:
                case 199:
                case 206:
                case 207:
                case 226:
                case 264:
                case 269:
                case 286:
                case 322:
                case 324:
                case 335:
                    break;
                default:
                    break a;
            }
        }
        $this.$jj_la1.data[9] = $this.$jj_gen;
        return onciafn_Neo4jASTFactory_newSingleQuery($this.$astFactory, $clauses);
    }
    function oncipj_Cypher_Clause($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 114:
                    var$2 = oncipj_Cypher_jj_consume_token($this, 114);
                    var$3 = oncipj_Cypher_PatternList($this);
                    var$4 = $this.$astFactory;
                    var$5 = oncipj_Cypher_pos($this, var$2);
                    var$6 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$3)));
                    var$2 = new onciafn_Neo4jASTFactory$createClause$lambda$_10_0;
                    var$2.$_0234 = var$4;
                    var$7 = sci_List_map(var$6, var$2);
                    var$2 = new oncia_Create;
                    var$4 = new oncie_Pattern$ForUpdate;
                    var$8 = sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$3)), new onciafn_Neo4jASTFactory$createClause$lambda$_10_1);
                    var$6 = new onciafn_Neo4jASTFactory$createClause$lambda$_10_2;
                    sm_Ordering$Int$_$callClinit();
                    oncie_Pattern$ForUpdate__init_(var$4, var$7, sc_AbstractIterable_minBy(var$8, var$6, sm_Ordering$Int$_MODULE$));
                    oncia_Create__init_(var$2, var$4, var$5);
                    break a;
                case 126:
                case 130:
                    var$2 = null;
                    var$9 = 0;
                    var$3 = ju_ArrayList__init_();
                    var$1 = $this.$jj_ntk;
                    if (var$1 == (-1))
                        var$1 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$1) {
                            case 130:
                                break;
                            default:
                                $this.$jj_la1.data[29] = $this.$jj_gen;
                                break b;
                        }
                        var$2 = oncipj_Cypher_jj_consume_token($this, 130);
                        var$9 = 1;
                    }
                    var$5 = oncipj_Cypher_jj_consume_token($this, 126);
                    ju_ArrayList_add(var$3, oncipj_Cypher_Expression($this));
                    c: while (true) {
                        var$1 = $this.$jj_ntk;
                        if (var$1 == (-1))
                            var$1 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$1) {
                            case 103:
                                break;
                            default:
                                break c;
                        }
                        oncipj_Cypher_jj_consume_token($this, 103);
                        ju_ArrayList_add(var$3, oncipj_Cypher_Expression($this));
                    }
                    $this.$jj_la1.data[30] = $this.$jj_gen;
                    if (var$2 !== null)
                        var$5 = var$2;
                    var$5 = oncipj_Cypher_pos($this, var$5);
                    var$2 = oncia_Delete__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$3))), var$9, var$5);
                    break a;
                case 206:
                case 226:
                    var$2 = null;
                    var$1 = 0;
                    var$3 = null;
                    var$8 = null;
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    d: {
                        switch (var$10) {
                            case 226:
                                break;
                            default:
                                $this.$jj_la1.data[31] = $this.$jj_gen;
                                break d;
                        }
                        var$2 = oncipj_Cypher_jj_consume_token($this, 226);
                        var$1 = 1;
                    }
                    var$11 = oncipj_Cypher_jj_consume_token($this, 206);
                    if (oncipj_Cypher_jj_2_12($this, 2))
                        var$3 = oncipj_Cypher_MatchMode($this);
                    var$12 = oncipj_Cypher_PatternList($this);
                    var$13 = null;
                    e: while (true) {
                        var$10 = $this.$jj_ntk;
                        if (var$10 == (-1))
                            var$10 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$10) {
                            case 327:
                                break;
                            default:
                                $this.$jj_la1.data[36] = $this.$jj_gen;
                                var$9 = $this.$jj_ntk;
                                if (var$9 == (-1))
                                    var$9 = oncipj_Cypher_jj_ntk_f($this);
                                f: {
                                    switch (var$9) {
                                        case 334:
                                            break;
                                        default:
                                            $this.$jj_la1.data[32] = $this.$jj_gen;
                                            break f;
                                    }
                                    var$8 = oncipj_Cypher_WhereClause($this);
                                }
                                var$5 = $this.$astFactory;
                                if (var$2 === null)
                                    var$2 = var$11;
                                var$2 = onciafn_Neo4jASTFactory_matchClause(var$5, oncipj_Cypher_pos($this, var$2), var$1, var$3, var$12, oncipj_Cypher_pos($this, var$11.$next1), var$13, var$8);
                                break a;
                        }
                        var$7 = oncipj_Cypher_jj_consume_token($this, 327);
                        var$9 = $this.$jj_ntk;
                        if (var$9 == (-1))
                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                        g: {
                            switch (var$9) {
                                case 93:
                                    oncipj_Cypher_jj_consume_token($this, 93);
                                    oncipj_Cypher_jj_consume_token($this, 181);
                                    onciaf_HintIndexType_$callClinit();
                                    var$5 = oncipj_Cypher_IndexHintBody($this, onciaf_HintIndexType_BTREE, oncipj_Cypher_pos($this, var$7));
                                    break g;
                                case 181:
                                    break;
                                case 188:
                                    oncipj_Cypher_jj_consume_token($this, 188);
                                    oncipj_Cypher_jj_consume_token($this, 224);
                                    var$5 = oncipj_Cypher_VariableList1($this);
                                    var$5 = onciafn_Neo4jASTFactory_usingJoin($this.$astFactory, oncipj_Cypher_pos($this, var$7), var$5);
                                    break g;
                                case 240:
                                    oncipj_Cypher_jj_consume_token($this, 240);
                                    oncipj_Cypher_jj_consume_token($this, 181);
                                    onciaf_HintIndexType_$callClinit();
                                    var$5 = oncipj_Cypher_IndexHintBody($this, onciaf_HintIndexType_POINT, oncipj_Cypher_pos($this, var$7));
                                    break g;
                                case 253:
                                    oncipj_Cypher_jj_consume_token($this, 253);
                                    oncipj_Cypher_jj_consume_token($this, 181);
                                    onciaf_HintIndexType_$callClinit();
                                    var$5 = oncipj_Cypher_IndexHintBody($this, onciaf_HintIndexType_RANGE, oncipj_Cypher_pos($this, var$7));
                                    break g;
                                case 276:
                                    oncipj_Cypher_jj_consume_token($this, 276);
                                    var$5 = oncipj_Cypher_Variable($this);
                                    var$4 = oncipj_Cypher_LabelOrRelType($this);
                                    var$5 = onciafn_Neo4jASTFactory_usingScan($this.$astFactory, oncipj_Cypher_pos($this, var$7), var$5, var$4.$image0);
                                    break g;
                                case 304:
                                    oncipj_Cypher_jj_consume_token($this, 304);
                                    oncipj_Cypher_jj_consume_token($this, 181);
                                    onciaf_HintIndexType_$callClinit();
                                    var$5 = oncipj_Cypher_IndexHintBody($this, onciaf_HintIndexType_TEXT, oncipj_Cypher_pos($this, var$7));
                                    break g;
                                default:
                                    break e;
                            }
                            oncipj_Cypher_jj_consume_token($this, 181);
                            onciaf_HintIndexType_$callClinit();
                            var$5 = oncipj_Cypher_IndexHintBody($this, onciaf_HintIndexType_ANY, oncipj_Cypher_pos($this, var$7));
                        }
                        if (var$13 === null)
                            var$13 = ju_ArrayList__init_();
                        ju_ArrayList_add(var$13, var$5);
                    }
                    $this.$jj_la1.data[37] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    var$2 = new oncipj_ParseException;
                    jl_Throwable__init_0(var$2);
                    $rt_throw(var$2);
                case 207:
                    break;
                case 264:
                    var$2 = oncipj_Cypher_RemoveClause($this);
                    break a;
                case 269:
                    var$2 = oncipj_Cypher_ReturnClause($this);
                    break a;
                case 286:
                    var$2 = oncipj_Cypher_SetClause($this);
                    break a;
                case 322:
                    var$2 = oncipj_Cypher_UnwindClause($this);
                    break a;
                case 324:
                    var$2 = oncipj_Cypher_UseClause($this);
                    break a;
                case 335:
                    var$2 = oncipj_Cypher_WithClause($this);
                    break a;
                default:
                    $this.$jj_la1.data[11] = $this.$jj_gen;
                    if (oncipj_Cypher_jj_2_5($this, 2)) {
                        var$2 = oncipj_Cypher_CallClause($this);
                        break a;
                    }
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$9) {
                        case 96:
                            break;
                        case 163:
                            var$2 = oncipj_Cypher_ForeachClause($this);
                            break a;
                        case 199:
                            var$2 = oncipj_Cypher_LoadCSVClause($this);
                            break a;
                        default:
                            $this.$jj_la1.data[12] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                    }
                    var$2 = oncipj_Cypher_SubqueryClause($this);
                    break a;
            }
            var$2 = oncipj_Cypher_MergeClause($this);
        }
        return var$2;
    }
    function oncipj_Cypher_UseClause($this) {
        var $t, $e, var$3, var$4, $$je;
        $t = oncipj_Cypher_jj_consume_token($this, 324);
        $this.$jj_la = 2;
        $e = $this.$token;
        $this.$jj_scanpos = $e;
        $this.$jj_lastpos = $e;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_6($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $t = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 5, 2);
                        break a;
                    }
                    try {
                        var$3 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 5, 2);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 5, 2);
        }
        e: {
            if (var$3) {
                oncipj_Cypher_jj_consume_token($this, 170);
                $e = oncipj_Cypher_Expression($this);
            } else {
                var$4 = $this.$jj_ntk;
                if (var$4 == (-1))
                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$4) {
                    case 35:
                    case 36:
                    case 39:
                    case 40:
                    case 52:
                    case 64:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 131:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 194:
                    case 195:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 202:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 208:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 238:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 37:
                    case 38:
                    case 41:
                    case 42:
                    case 43:
                    case 44:
                    case 45:
                    case 46:
                    case 47:
                    case 48:
                    case 49:
                    case 50:
                    case 51:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                    case 57:
                    case 58:
                    case 59:
                    case 60:
                    case 61:
                    case 62:
                    case 63:
                    case 65:
                    case 66:
                    case 67:
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 196:
                    case 203:
                    case 209:
                    case 210:
                    case 211:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break e;
                    default:
                        break e;
                }
                $e = oncipj_Cypher_Expression($this);
            }
            $t = oncipj_Cypher_pos($this, $t);
            return oncia_UseGraph__init_($e, $t);
        }
        $this.$jj_la1.data[13] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $t = new oncipj_ParseException;
        jl_Throwable__init_0($t);
        $rt_throw($t);
    }
    function oncipj_Cypher_ReturnClause($this) {
        return oncipj_Cypher_ReturnBody($this, oncipj_Cypher_jj_consume_token($this, 269));
    }
    function oncipj_Cypher_ReturnBody($this, $t) {
        var $skipPosition, $limitPosition, $distinct, $order, $orderPos, $skip, $limit, var$9, var$10, var$11, var$12, var$13, var$14, $$je;
        $skipPosition = null;
        $limitPosition = null;
        $distinct = 0;
        $order = ju_ArrayList__init_();
        $orderPos = null;
        $skip = null;
        $limit = null;
        $this.$jj_la = 2;
        var$9 = $this.$token;
        $this.$jj_scanpos = var$9;
        $this.$jj_lastpos = var$9;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$10 = oncipj_Cypher_jj_3_7($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $t = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 6, 2);
                        break a;
                    }
                    try {
                        var$10 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 6, 2);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 6, 2);
        }
        if (var$10) {
            oncipj_Cypher_jj_consume_token($this, 133);
            $distinct = 1;
        }
        var$11 = ju_ArrayList__init_();
        var$10 = 0;
        var$12 = $this.$token;
        var$13 = $this.$jj_ntk;
        if (var$13 == (-1))
            var$13 = oncipj_Cypher_jj_ntk_f($this);
        e: {
            switch (var$13) {
                case 35:
                case 36:
                case 39:
                case 40:
                case 52:
                case 64:
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 131:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 194:
                case 195:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 202:
                case 204:
                case 205:
                case 206:
                case 207:
                case 208:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 238:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    ju_ArrayList_add(var$11, oncipj_Cypher_ReturnItem($this));
                    f: while (true) {
                        var$13 = $this.$jj_ntk;
                        if (var$13 == (-1))
                            var$13 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$13) {
                            case 103:
                                break;
                            default:
                                break f;
                        }
                        oncipj_Cypher_jj_consume_token($this, 103);
                        ju_ArrayList_add(var$11, oncipj_Cypher_ReturnItem($this));
                    }
                    $this.$jj_la1.data[20] = $this.$jj_gen;
                    break e;
                case 37:
                case 38:
                case 41:
                case 42:
                case 43:
                case 44:
                case 45:
                case 46:
                case 47:
                case 48:
                case 49:
                case 50:
                case 51:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                case 58:
                case 59:
                case 60:
                case 61:
                case 62:
                case 63:
                case 65:
                case 66:
                case 67:
                case 86:
                case 101:
                case 102:
                case 103:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 196:
                case 203:
                case 209:
                case 210:
                case 211:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                    break;
                case 307:
                    oncipj_Cypher_jj_consume_token($this, 307);
                    var$10 = 1;
                    g: while (true) {
                        var$13 = $this.$jj_ntk;
                        if (var$13 == (-1))
                            var$13 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$13) {
                            case 103:
                                break;
                            default:
                                break g;
                        }
                        oncipj_Cypher_jj_consume_token($this, 103);
                        ju_ArrayList_add(var$11, oncipj_Cypher_ReturnItem($this));
                    }
                    $this.$jj_la1.data[19] = $this.$jj_gen;
                    break e;
                default:
            }
            $this.$jj_la1.data[21] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $t = new oncipj_ParseException;
            jl_Throwable__init_0($t);
            $rt_throw($t);
        }
        var$9 = oncipj_Cypher_pos($this, var$12.$next1);
        var$12 = oncia_ReturnItems__init_(var$10, sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$11))), s_None$_MODULE$, var$9);
        var$13 = $this.$jj_ntk;
        if (var$13 == (-1))
            var$13 = oncipj_Cypher_jj_ntk_f($this);
        h: {
            switch (var$13) {
                case 230:
                    $orderPos = oncipj_Cypher_jj_consume_token($this, 230);
                    oncipj_Cypher_jj_consume_token($this, 95);
                    ju_ArrayList_add($order, oncipj_Cypher_OrderItem($this));
                    i: while (true) {
                        var$13 = $this.$jj_ntk;
                        if (var$13 == (-1))
                            var$13 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$13) {
                            case 103:
                                break;
                            default:
                                break i;
                        }
                        oncipj_Cypher_jj_consume_token($this, 103);
                        ju_ArrayList_add($order, oncipj_Cypher_OrderItem($this));
                    }
                    $this.$jj_la1.data[14] = $this.$jj_gen;
                    break h;
                default:
            }
            $this.$jj_la1.data[15] = $this.$jj_gen;
        }
        var$13 = $this.$jj_ntk;
        if (var$13 == (-1))
            var$13 = oncipj_Cypher_jj_ntk_f($this);
        j: {
            switch (var$13) {
                case 294:
                    $skipPosition = $this.$token.$next1;
                    oncipj_Cypher_jj_consume_token($this, 294);
                    $skip = oncipj_Cypher_Expression($this);
                    break j;
                default:
            }
            $this.$jj_la1.data[16] = $this.$jj_gen;
        }
        var$13 = $this.$jj_ntk;
        if (var$13 == (-1))
            var$13 = oncipj_Cypher_jj_ntk_f($this);
        k: {
            switch (var$13) {
                case 197:
                    $limitPosition = $this.$token.$next1;
                    oncipj_Cypher_jj_consume_token($this, 197);
                    $limit = oncipj_Cypher_Expression($this);
                    break k;
                default:
            }
            $this.$jj_la1.data[17] = $this.$jj_gen;
        }
        $t = oncipj_Cypher_pos($this, $t);
        var$9 = oncipj_Cypher_pos($this, $orderPos);
        $skipPosition = oncipj_Cypher_pos($this, $skipPosition);
        var$14 = oncipj_Cypher_pos($this, $limitPosition);
        $orderPos = $skip;
        $skip = $limit;
        $limit = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $order)));
        var$11 = new oncia_Return;
        $limitPosition = ju_AbstractCollection_isEmpty($order) ? s_None$_MODULE$ : s_Some__init_(oncia_OrderBy__init_($limit, var$9));
        var$9 = s_Option$_apply(s_Option$_MODULE$, $orderPos);
        $order = new onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_0;
        $order.$_0235 = $skipPosition;
        $skipPosition = s_Option_map(var$9, $order);
        var$9 = s_Option$_apply(s_Option$_MODULE$, $skip);
        $order = new onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_1;
        $order.$_0236 = var$14;
        oncia_Return__init_(var$11, $distinct, var$12, $limitPosition, $skipPosition, s_Option_map(var$9, $order), oncia_Return$_apply$default$6(oncia_Return$_MODULE$), 0, $t);
        return var$11;
    }
    function oncipj_Cypher_ReturnItem($this) {
        var $v, $eStart, $e, $eEnd, var$5;
        $v = null;
        $eStart = $this.$token;
        $e = oncipj_Cypher_Expression($this);
        $eEnd = $this.$token;
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 81:
                    break;
                default:
                    $this.$jj_la1.data[18] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 81);
            $v = oncipj_Cypher_Variable($this);
        }
        if ($v !== null)
            return onciafn_Neo4jASTFactory_newReturnItem0($this.$astFactory, oncipj_Cypher_pos($this, $eStart.$next1), $e, $v);
        return onciafn_Neo4jASTFactory_newReturnItem($this.$astFactory, oncipj_Cypher_pos($this, $eStart.$next1), $e, $eStart.$next1.$beginOffset, $eEnd.$endOffset);
    }
    function oncipj_Cypher_OrderItem($this) {
        var $t, $e, var$3, var$4;
        $t = $this.$token;
        $e = oncipj_Cypher_Expression($this);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$3) {
            case 128:
                break;
            default:
                $this.$jj_la1.data[23] = $this.$jj_gen;
                var$4 = $this.$jj_ntk;
                if (var$4 == (-1))
                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                a: {
                    switch (var$4) {
                        case 82:
                            break;
                        default:
                            $this.$jj_la1.data[22] = $this.$jj_gen;
                            break a;
                    }
                    oncipj_Cypher_jj_consume_token($this, 82);
                }
                $t = oncipj_Cypher_pos($this, $t.$next1);
                return oncia_AscSortItem__init_($e, $t);
        }
        oncipj_Cypher_jj_consume_token($this, 128);
        $t = oncipj_Cypher_pos($this, $t.$next1);
        return oncia_DescSortItem__init_($e, $t);
    }
    function oncipj_Cypher_WhereClause($this) {
        var $t, $e;
        $t = oncipj_Cypher_jj_consume_token($this, 334);
        $e = oncipj_Cypher_Expression($this);
        $t = oncipj_Cypher_pos($this, $t);
        return oncia_Where__init_($e, $t);
    }
    function oncipj_Cypher_WithClause($this) {
        var $where, $t, $returnClause, var$4, var$5;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 335);
        $returnClause = oncipj_Cypher_ReturnBody($this, $t);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[24] = $this.$jj_gen;
                    break a;
            }
            $where = oncipj_Cypher_WhereClause($this);
        }
        var$5 = oncipj_Cypher_pos($this, $t);
        return oncia_With__init_0($returnClause.$distinct, $returnClause.$returnItems1, $returnClause.$orderBy0, $returnClause.$skip0, $returnClause.$limit0, s_Option$_apply(s_Option$_MODULE$, $where), oncia_DefaultWith$_MODULE$, var$5);
    }
    function oncipj_Cypher_SetClause($this) {
        var $items, $t, var$3;
        $items = ju_ArrayList__init_();
        $t = oncipj_Cypher_jj_consume_token($this, 286);
        ju_ArrayList_add($items, oncipj_Cypher_SetItem($this));
        a: while (true) {
            var$3 = $this.$jj_ntk;
            if (var$3 == (-1))
                var$3 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$3) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($items, oncipj_Cypher_SetItem($this));
        }
        $this.$jj_la1.data[25] = $this.$jj_gen;
        $t = oncipj_Cypher_pos($this, $t);
        return oncia_SetClause__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $items))), $t);
    }
    function oncipj_Cypher_SetItem($this) {
        var $v, var$2, $p, var$4, $labels, $$je;
        $this.$jj_la = 2;
        $v = $this.$token;
        $this.$jj_scanpos = $v;
        $this.$jj_lastpos = $v;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_8($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $v = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 7, 2);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $v = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 7, 2);
                $rt_throw($v);
            }
            oncipj_Cypher_jj_save($this, 7, 2);
        }
        if (var$2) {
            $p = oncipj_Cypher_PropertyExpression($this);
            oncipj_Cypher_jj_consume_token($this, 151);
            return oncia_SetPropertyItem__init_($p, oncipj_Cypher_Expression($this), $p.$position31);
        }
        $this.$jj_la = 2;
        $v = $this.$token;
        $this.$jj_scanpos = $v;
        $this.$jj_lastpos = $v;
        e: {
            f: {
                g: {
                    h: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_9($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break h;
                            } else{
                                $v = $$je;
                                break g;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 8, 2);
                        break e;
                    }
                    try {
                        var$2 = 1;
                        break f;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $v = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 8, 2);
                $rt_throw($v);
            }
            oncipj_Cypher_jj_save($this, 8, 2);
        }
        if (var$2) {
            $v = oncipj_Cypher_Variable($this);
            oncipj_Cypher_jj_consume_token($this, 151);
            return oncia_SetExactPropertiesFromMapItem__init_($v, oncipj_Cypher_Expression($this), $v.$position0);
        }
        $this.$jj_la = 2;
        $v = $this.$token;
        $this.$jj_scanpos = $v;
        $this.$jj_lastpos = $v;
        i: {
            j: {
                k: {
                    l: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_10($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break l;
                            } else{
                                $v = $$je;
                                break k;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 9, 2);
                        break i;
                    }
                    try {
                        var$2 = 1;
                        break j;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $v = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 9, 2);
                $rt_throw($v);
            }
            oncipj_Cypher_jj_save($this, 9, 2);
        }
        if (var$2) {
            $v = oncipj_Cypher_Variable($this);
            oncipj_Cypher_jj_consume_token($this, 239);
            return oncia_SetIncludingPropertiesFromMapItem__init_($v, oncipj_Cypher_Expression($this), $v.$position0);
        }
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$4) {
            case 68:
            case 69:
            case 70:
            case 71:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
            case 78:
            case 79:
            case 80:
            case 81:
            case 82:
            case 83:
            case 84:
            case 85:
            case 87:
            case 88:
            case 89:
            case 90:
            case 91:
            case 92:
            case 93:
            case 94:
            case 95:
            case 96:
            case 97:
            case 98:
            case 99:
            case 100:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
            case 110:
            case 111:
            case 112:
            case 113:
            case 114:
            case 115:
            case 116:
            case 117:
            case 118:
            case 119:
            case 120:
            case 121:
            case 122:
            case 123:
            case 124:
            case 125:
            case 126:
            case 127:
            case 128:
            case 129:
            case 130:
            case 132:
            case 133:
            case 137:
            case 138:
            case 139:
            case 140:
            case 141:
            case 142:
            case 143:
            case 144:
            case 145:
            case 146:
            case 147:
            case 148:
            case 149:
            case 150:
            case 152:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
            case 160:
            case 161:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
            case 167:
            case 169:
            case 170:
            case 171:
            case 172:
            case 173:
            case 175:
            case 176:
            case 177:
            case 179:
            case 180:
            case 181:
            case 182:
            case 183:
            case 184:
            case 185:
            case 186:
            case 187:
            case 188:
            case 189:
            case 190:
            case 191:
            case 197:
            case 198:
            case 199:
            case 200:
            case 201:
            case 204:
            case 205:
            case 206:
            case 207:
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 218:
            case 219:
            case 220:
            case 221:
            case 222:
            case 223:
            case 224:
            case 225:
            case 226:
            case 227:
            case 228:
            case 229:
            case 230:
            case 231:
            case 232:
            case 233:
            case 234:
            case 235:
            case 236:
            case 237:
            case 240:
            case 241:
            case 243:
            case 244:
            case 245:
            case 246:
            case 247:
            case 248:
            case 249:
            case 250:
            case 251:
            case 253:
            case 256:
            case 257:
            case 258:
            case 259:
            case 261:
            case 262:
            case 263:
            case 264:
            case 265:
            case 266:
            case 267:
            case 268:
            case 269:
            case 270:
            case 271:
            case 272:
            case 273:
            case 274:
            case 276:
            case 277:
            case 278:
            case 279:
            case 280:
            case 281:
            case 282:
            case 284:
            case 285:
            case 286:
            case 287:
            case 288:
            case 289:
            case 290:
            case 291:
            case 292:
            case 293:
            case 294:
            case 295:
            case 296:
            case 297:
            case 298:
            case 299:
            case 300:
            case 301:
            case 302:
            case 303:
            case 304:
            case 305:
            case 306:
            case 308:
            case 309:
            case 310:
            case 311:
            case 312:
            case 313:
            case 314:
            case 315:
            case 316:
            case 317:
            case 318:
            case 319:
            case 320:
            case 321:
            case 322:
            case 323:
            case 324:
            case 325:
            case 326:
            case 327:
            case 328:
            case 329:
            case 330:
            case 331:
            case 332:
            case 333:
            case 334:
            case 335:
            case 336:
            case 337:
            case 338:
            case 339:
            case 340:
            case 341:
                $v = oncipj_Cypher_Variable($this);
                $labels = oncipj_Cypher_NodeLabels($this);
                return oncia_SetLabelItem__init_($v, sci_List_map(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $labels))), new onciafn_Neo4jASTFactory$setLabels$lambda$_22_0), $v.$position0);
            case 86:
            case 101:
            case 102:
            case 103:
            case 131:
            case 134:
            case 135:
            case 136:
            case 151:
            case 168:
            case 174:
            case 178:
            case 192:
            case 193:
            case 194:
            case 195:
            case 196:
            case 202:
            case 203:
            case 208:
            case 209:
            case 210:
            case 211:
            case 238:
            case 239:
            case 242:
            case 252:
            case 254:
            case 255:
            case 260:
            case 275:
            case 283:
            case 307:
                break;
            default:
        }
        $this.$jj_la1.data[26] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $v = new oncipj_ParseException;
        jl_Throwable__init_0($v);
        $rt_throw($v);
    }
    function oncipj_Cypher_RemoveClause($this) {
        var $items, $t, var$3;
        $items = ju_ArrayList__init_();
        $t = oncipj_Cypher_jj_consume_token($this, 264);
        ju_ArrayList_add($items, oncipj_Cypher_RemoveItem($this));
        a: while (true) {
            var$3 = $this.$jj_ntk;
            if (var$3 == (-1))
                var$3 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$3) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($items, oncipj_Cypher_RemoveItem($this));
        }
        $this.$jj_la1.data[27] = $this.$jj_gen;
        $t = oncipj_Cypher_pos($this, $t);
        return oncia_Remove__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $items))), $t);
    }
    function oncipj_Cypher_RemoveItem($this) {
        var $v, var$2, var$3, $labels, $$je;
        $this.$jj_la = 2;
        $v = $this.$token;
        $this.$jj_scanpos = $v;
        $this.$jj_lastpos = $v;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_11($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $v = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 10, 2);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $v = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 10, 2);
                $rt_throw($v);
            }
            oncipj_Cypher_jj_save($this, 10, 2);
        }
        if (var$2)
            return oncia_RemovePropertyItem__init_(oncipj_Cypher_PropertyExpression($this));
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$3) {
            case 68:
            case 69:
            case 70:
            case 71:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
            case 78:
            case 79:
            case 80:
            case 81:
            case 82:
            case 83:
            case 84:
            case 85:
            case 87:
            case 88:
            case 89:
            case 90:
            case 91:
            case 92:
            case 93:
            case 94:
            case 95:
            case 96:
            case 97:
            case 98:
            case 99:
            case 100:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
            case 110:
            case 111:
            case 112:
            case 113:
            case 114:
            case 115:
            case 116:
            case 117:
            case 118:
            case 119:
            case 120:
            case 121:
            case 122:
            case 123:
            case 124:
            case 125:
            case 126:
            case 127:
            case 128:
            case 129:
            case 130:
            case 132:
            case 133:
            case 137:
            case 138:
            case 139:
            case 140:
            case 141:
            case 142:
            case 143:
            case 144:
            case 145:
            case 146:
            case 147:
            case 148:
            case 149:
            case 150:
            case 152:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
            case 160:
            case 161:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
            case 167:
            case 169:
            case 170:
            case 171:
            case 172:
            case 173:
            case 175:
            case 176:
            case 177:
            case 179:
            case 180:
            case 181:
            case 182:
            case 183:
            case 184:
            case 185:
            case 186:
            case 187:
            case 188:
            case 189:
            case 190:
            case 191:
            case 197:
            case 198:
            case 199:
            case 200:
            case 201:
            case 204:
            case 205:
            case 206:
            case 207:
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 218:
            case 219:
            case 220:
            case 221:
            case 222:
            case 223:
            case 224:
            case 225:
            case 226:
            case 227:
            case 228:
            case 229:
            case 230:
            case 231:
            case 232:
            case 233:
            case 234:
            case 235:
            case 236:
            case 237:
            case 240:
            case 241:
            case 243:
            case 244:
            case 245:
            case 246:
            case 247:
            case 248:
            case 249:
            case 250:
            case 251:
            case 253:
            case 256:
            case 257:
            case 258:
            case 259:
            case 261:
            case 262:
            case 263:
            case 264:
            case 265:
            case 266:
            case 267:
            case 268:
            case 269:
            case 270:
            case 271:
            case 272:
            case 273:
            case 274:
            case 276:
            case 277:
            case 278:
            case 279:
            case 280:
            case 281:
            case 282:
            case 284:
            case 285:
            case 286:
            case 287:
            case 288:
            case 289:
            case 290:
            case 291:
            case 292:
            case 293:
            case 294:
            case 295:
            case 296:
            case 297:
            case 298:
            case 299:
            case 300:
            case 301:
            case 302:
            case 303:
            case 304:
            case 305:
            case 306:
            case 308:
            case 309:
            case 310:
            case 311:
            case 312:
            case 313:
            case 314:
            case 315:
            case 316:
            case 317:
            case 318:
            case 319:
            case 320:
            case 321:
            case 322:
            case 323:
            case 324:
            case 325:
            case 326:
            case 327:
            case 328:
            case 329:
            case 330:
            case 331:
            case 332:
            case 333:
            case 334:
            case 335:
            case 336:
            case 337:
            case 338:
            case 339:
            case 340:
            case 341:
                $v = oncipj_Cypher_Variable($this);
                $labels = oncipj_Cypher_NodeLabels($this);
                return oncia_RemoveLabelItem__init_($v, sci_List_map(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $labels))), new onciafn_Neo4jASTFactory$removeLabels$lambda$_25_0), $v.$position0);
            case 86:
            case 101:
            case 102:
            case 103:
            case 131:
            case 134:
            case 135:
            case 136:
            case 151:
            case 168:
            case 174:
            case 178:
            case 192:
            case 193:
            case 194:
            case 195:
            case 196:
            case 202:
            case 203:
            case 208:
            case 209:
            case 210:
            case 211:
            case 238:
            case 239:
            case 242:
            case 252:
            case 254:
            case 255:
            case 260:
            case 275:
            case 283:
            case 307:
                break;
            default:
        }
        $this.$jj_la1.data[28] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $v = new oncipj_ParseException;
        jl_Throwable__init_0($v);
        $rt_throw($v);
    }
    function oncipj_Cypher_MatchMode($this) {
        var var$1, $t, $matchMode, var$4, $$je;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 132:
                    $t = oncipj_Cypher_jj_consume_token($this, 132);
                    $this.$jj_la = 2;
                    $matchMode = $this.$token;
                    $this.$jj_scanpos = $matchMode;
                    $this.$jj_lastpos = $matchMode;
                    b: {
                        c: {
                            d: {
                                e: {
                                    try {
                                        var$1 = oncipj_Cypher_jj_3_14($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break e;
                                        } else{
                                            $t = $$je;
                                            break d;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 13, 2);
                                    break b;
                                }
                                try {
                                    var$1 = 1;
                                    break c;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $t = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 13, 2);
                            $rt_throw($t);
                        }
                        oncipj_Cypher_jj_save($this, 13, 2);
                    }
                    f: {
                        if (var$1) {
                            oncipj_Cypher_jj_consume_token($this, 262);
                            oncipj_Cypher_jj_consume_token($this, 87);
                        } else {
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 262:
                                    oncipj_Cypher_jj_consume_token($this, 262);
                                    break f;
                                case 263:
                                    oncipj_Cypher_jj_consume_token($this, 263);
                                    break f;
                                default:
                            }
                            $this.$jj_la1.data[34] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $t = new oncipj_ParseException;
                            jl_Throwable__init_0($t);
                            $rt_throw($t);
                        }
                    }
                    $matchMode = oncie_MatchMode$DifferentRelationships__init_(0, oncipj_Cypher_pos($this, $t));
                    break a;
                case 243:
                    $t = oncipj_Cypher_jj_consume_token($this, 243);
                    $this.$jj_la = 2;
                    $matchMode = $this.$token;
                    $this.$jj_scanpos = $matchMode;
                    $this.$jj_lastpos = $matchMode;
                    g: {
                        h: {
                            i: {
                                j: {
                                    try {
                                        var$1 = oncipj_Cypher_jj_3_13($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break j;
                                        } else{
                                            $t = $$je;
                                            break i;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 12, 2);
                                    break g;
                                }
                                try {
                                    var$1 = 1;
                                    break h;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $t = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 12, 2);
                            $rt_throw($t);
                        }
                        oncipj_Cypher_jj_save($this, 12, 2);
                    }
                    k: {
                        if (var$1) {
                            oncipj_Cypher_jj_consume_token($this, 145);
                            oncipj_Cypher_jj_consume_token($this, 87);
                        } else {
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 145:
                                    break;
                                case 146:
                                    oncipj_Cypher_jj_consume_token($this, 146);
                                    break k;
                                default:
                                    $this.$jj_la1.data[33] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $t = new oncipj_ParseException;
                                    jl_Throwable__init_0($t);
                                    $rt_throw($t);
                            }
                            oncipj_Cypher_jj_consume_token($this, 145);
                        }
                    }
                    $matchMode = oncie_MatchMode$RepeatableElements__init_(oncipj_Cypher_pos($this, $t));
                    break a;
                default:
            }
            $this.$jj_la1.data[35] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $t = new oncipj_ParseException;
            jl_Throwable__init_0($t);
            $rt_throw($t);
        }
        return $matchMode;
    }
    function oncipj_Cypher_IndexHintBody($this, $indexType, $p) {
        var $seek, $v, var$5, $labelOrRelType, $propNames, var$8, var$9, var$10, var$11, var$12, var$13, var$14, var$15, $$je;
        $seek = 0;
        $this.$jj_la = 2;
        $v = $this.$token;
        $this.$jj_scanpos = $v;
        $this.$jj_lastpos = $v;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$5 = oncipj_Cypher_jj_3_15($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $indexType = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 14, 2);
                        break a;
                    }
                    try {
                        var$5 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $indexType = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 14, 2);
                $rt_throw($indexType);
            }
            oncipj_Cypher_jj_save($this, 14, 2);
        }
        if (var$5) {
            oncipj_Cypher_jj_consume_token($this, 282);
            $seek = 1;
        }
        $v = oncipj_Cypher_Variable($this);
        $labelOrRelType = oncipj_Cypher_LabelOrRelType($this);
        oncipj_Cypher_jj_consume_token($this, 202);
        $propNames = oncipj_Cypher_SymbolicNameList1($this);
        oncipj_Cypher_jj_consume_token($this, 275);
        $labelOrRelType = $labelOrRelType.$image0;
        var$8 = new oncia_UsingIndexHint;
        var$9 = oncie_LabelOrRelTypeName__init_($labelOrRelType, $p);
        $propNames = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $propNames)));
        $labelOrRelType = new onciafn_Neo4jASTFactory$usingIndexHint$lambda$_12_0;
        $labelOrRelType.$_0237 = $p;
        $labelOrRelType = sci_List_map($propNames, $labelOrRelType);
        $propNames = !$seek ? oncia_SeekOrScan$_MODULE$ : oncia_SeekOnly$_MODULE$;
        onciaf_HintIndexType_$callClinit();
        if (jl_Enum_equals(onciaf_HintIndexType_ANY, $indexType))
            $indexType = oncia_UsingAnyIndexType$_MODULE$;
        else {
            if (jl_Enum_equals(onciaf_HintIndexType_BTREE, $indexType)) {
                $p = new onciafn_Neo4jASTConstructionException;
                var$10 = onciaf_HintIndexType_values();
                var$11 = var$10.data;
                $propNames = new jusi_ArrayStreamImpl;
                var$12 = var$11.length;
                $propNames.$array3 = var$10;
                $propNames.$index = 0;
                $propNames.$end2 = var$12;
                $propNames.$size7 = var$12 - 0 | 0;
                $v = new onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_0;
                $labelOrRelType = new jusi_FilteringStreamImpl;
                jusi_WrappingStreamImpl__init_($labelOrRelType, $propNames);
                $labelOrRelType.$filter3 = $v;
                $propNames = jusi_SimpleStreamImpl_map($labelOrRelType, new onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_1);
                $v = new jus_Collectors$toList$lambda$_2_0;
                $labelOrRelType = new jus_Collectors$toCollection$lambda$_1_0;
                var$8 = new jus_Collectors$toCollection$lambda$_1_1;
                var$10 = $rt_createArray(jus_Collector$Characteristics, 0);
                var$9 = new jus_Collector$of$lambda$_5_0;
                jl_Object__init_0(var$9);
                var$13 = jus_Collector_of($v, $labelOrRelType, var$8, var$9, var$10);
                var$14 = new onciaf_ASTExceptionFactory$joiningLastDelimiter$lambda$_9_0;
                var$14.$_0238 = $rt_s(442);
                var$14.$_163 = $rt_s(16);
                var$9 = var$13.$characteristics;
                if (var$9 instanceof ju_EnumSet) {
                    $labelOrRelType = new ju_GenericEnumSet;
                    $v = var$9.$cls;
                    var$10 = var$9.$bits.$clone();
                    ju_EnumSet__init_($labelOrRelType);
                    $labelOrRelType.$cls = $v;
                    $labelOrRelType.$bits = var$10;
                } else {
                    var$8 = new ju_GenericEnumSet$1;
                    var$8.$this$01 = var$9;
                    jl_Object__init_0(var$8);
                    var$8.$indexToRemove = (-1);
                    var$8.$count0 = ju_GenericEnumSet_size(var$8.$this$01);
                    if (!ju_GenericEnumSet$1_hasNext(var$8)) {
                        $indexType = new jl_IllegalArgumentException;
                        jl_Throwable__init_0($indexType);
                        $rt_throw($indexType);
                    }
                    $v = ju_GenericEnumSet$1_next(var$8);
                    $labelOrRelType = ju_EnumSet_noneOf(jl_Enum_getDeclaringClass($v));
                    ju_GenericEnumSet_add($labelOrRelType, $v);
                    while (ju_GenericEnumSet$1_hasNext(var$8)) {
                        ju_GenericEnumSet_add($labelOrRelType, ju_GenericEnumSet$1_next(var$8));
                    }
                }
                jus_Collector$Characteristics_$callClinit();
                $v = jus_Collector$Characteristics_IDENTITY_FINISH;
                if (jl_Class_isInstance($labelOrRelType.$cls, $v)) {
                    var$15 = $v.$ordinal;
                    var$12 = var$15 / 32 | 0;
                    var$5 = 1 << (var$15 % 32 | 0);
                    var$10 = $labelOrRelType.$bits.data;
                    if (var$10[var$12] & var$5)
                        var$10[var$12] = var$10[var$12] & (var$5 ^ (-1));
                }
                $v = jusi_SimpleStreamImpl_collect($propNames, jus_CollectorImpl__init_(var$13.$supplier, var$13.$accumulator0, var$13.$combiner, juf_Function_andThen(var$13.$finisher, var$14), $labelOrRelType));
                jl_Throwable__init_($p, $indexType !== onciaf_HintIndexType_BTREE ? jl_String_format($rt_s(909), $rt_createArrayFromData(jl_Object, [$indexType.$name5, $v])) : jl_String_format($rt_s(910), $rt_createArrayFromData(jl_Object, [$indexType.$name5, $v])));
                $rt_throw($p);
            }
            if (jl_Enum_equals(onciaf_HintIndexType_TEXT, $indexType))
                $indexType = oncia_UsingTextIndexType$_MODULE$;
            else if (jl_Enum_equals(onciaf_HintIndexType_RANGE, $indexType))
                $indexType = oncia_UsingRangeIndexType$_MODULE$;
            else {
                if (!jl_Enum_equals(onciaf_HintIndexType_POINT, $indexType))
                    $rt_throw(s_MatchError__init_($indexType));
                $indexType = oncia_UsingPointIndexType$_MODULE$;
            }
        }
        oncia_UsingIndexHint__init_(var$8, $v, var$9, $labelOrRelType, $propNames, $indexType, $p);
        return var$8;
    }
    function oncipj_Cypher_MergeClause($this) {
        var $clauses, $positions, $actionTypes, $t, $p, var$6, $onToken;
        $clauses = ju_ArrayList__init_();
        $positions = ju_ArrayList__init_();
        $actionTypes = ju_ArrayList__init_();
        $t = oncipj_Cypher_jj_consume_token($this, 207);
        $p = oncipj_Cypher_Pattern($this);
        a: while (true) {
            var$6 = $this.$jj_ntk;
            if (var$6 == (-1))
                var$6 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$6) {
                case 224:
                    break;
                default:
                    $this.$jj_la1.data[38] = $this.$jj_gen;
                    $onToken = $this.$astFactory;
                    $t = oncipj_Cypher_pos($this, $t);
                    if (!$rt_isInstance($p, oncie_NonPrefixedPatternPart)) {
                        if (!($p instanceof oncie_PatternPartWithSelector))
                            $rt_throw(s_MatchError__init_($p));
                        $rt_throw(onciafn_Neo4jASTFactory_pathSelectorCannotBeUsedInClauseException($onToken, $rt_s(911), $p.$selector));
                    }
                    $onToken = $p;
                    $clauses = ju_AbstractList_iterator($clauses);
                    $positions = ju_AbstractList_iterator($positions);
                    $p = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $actionTypes)));
                    $actionTypes = new onciafn_Neo4jASTFactory$mergeClause$lambda$_28_0;
                    $actionTypes.$_0239 = $clauses;
                    $actionTypes.$_164 = $positions;
                    return oncia_Merge__init_($onToken, sci_List_map($p, $actionTypes), s_None$_MODULE$, $t);
            }
            $onToken = oncipj_Cypher_jj_consume_token($this, 224);
            var$6 = $this.$jj_ntk;
            if (var$6 == (-1))
                var$6 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$6) {
                case 114:
                    break;
                case 206:
                    oncipj_Cypher_jj_consume_token($this, 206);
                    ju_ArrayList_add($clauses, oncipj_Cypher_SetClause($this));
                    onciaf_ASTFactory$MergeActionType_$callClinit();
                    ju_ArrayList_add($actionTypes, onciaf_ASTFactory$MergeActionType_OnMatch);
                    ju_ArrayList_add($positions, oncipj_Cypher_pos($this, $onToken));
                    continue a;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 114);
            ju_ArrayList_add($clauses, oncipj_Cypher_SetClause($this));
            onciaf_ASTFactory$MergeActionType_$callClinit();
            ju_ArrayList_add($actionTypes, onciaf_ASTFactory$MergeActionType_OnCreate);
            ju_ArrayList_add($positions, oncipj_Cypher_pos($this, $onToken));
        }
        $this.$jj_la1.data[39] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $clauses = new oncipj_ParseException;
        jl_Throwable__init_0($clauses);
        $rt_throw($clauses);
    }
    function oncipj_Cypher_UnwindClause($this) {
        var $t, $e, $v;
        $t = oncipj_Cypher_jj_consume_token($this, 322);
        $e = oncipj_Cypher_Expression($this);
        oncipj_Cypher_jj_consume_token($this, 81);
        $v = oncipj_Cypher_Variable($this);
        $t = oncipj_Cypher_pos($this, $t);
        return oncia_Unwind__init_($e, $v, $t);
    }
    function oncipj_Cypher_CallClause($this) {
        var $procedureResultPosition, $arguments, $yieldAll, $items, $where, $t, $namespace, $procedureNamePosition, $name, var$10, $x, var$12, var$13, $e, var$15, var$16, $$je;
        $procedureResultPosition = null;
        $arguments = null;
        $yieldAll = 0;
        $items = null;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 96);
        $namespace = oncipj_Cypher_Namespace($this);
        $procedureNamePosition = $this.$token;
        $name = (oncipj_Cypher_SymbolicNameString($this)).$image0;
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$10) {
                case 202:
                    oncipj_Cypher_jj_consume_token($this, 202);
                    $arguments = ju_ArrayList__init_();
                    $this.$jj_la = 2;
                    $x = $this.$token;
                    $this.$jj_scanpos = $x;
                    $this.$jj_lastpos = $x;
                    b: {
                        c: {
                            d: {
                                e: {
                                    try {
                                        var$12 = oncipj_Cypher_jj_3_16($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break e;
                                        } else{
                                            $procedureResultPosition = $$je;
                                            break d;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 15, 2);
                                    break b;
                                }
                                try {
                                    var$12 = 1;
                                    break c;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $procedureResultPosition = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 15, 2);
                            $rt_throw($procedureResultPosition);
                        }
                        oncipj_Cypher_jj_save($this, 15, 2);
                    }
                    if (var$12)
                        ju_ArrayList_add($arguments, oncipj_Cypher_Expression($this));
                    f: while (true) {
                        var$13 = $this.$jj_ntk;
                        if (var$13 == (-1))
                            var$13 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$13) {
                            case 103:
                                break;
                            default:
                                break f;
                        }
                        oncipj_Cypher_jj_consume_token($this, 103);
                        ju_ArrayList_add($arguments, oncipj_Cypher_Expression($this));
                    }
                    $this.$jj_la1.data[40] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, 275);
                    break a;
                default:
            }
            $this.$jj_la1.data[41] = $this.$jj_gen;
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        g: {
            switch (var$10) {
                case 339:
                    $procedureResultPosition = oncipj_Cypher_jj_consume_token($this, 339);
                    var$13 = $this.$jj_ntk;
                    if (var$13 == (-1))
                        var$13 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$13) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            $items = ju_ArrayList__init_();
                            ju_ArrayList_add($items, oncipj_Cypher_ProcedureResultItem($this));
                            h: while (true) {
                                var$10 = $this.$jj_ntk;
                                if (var$10 == (-1))
                                    var$10 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$10) {
                                    case 103:
                                        break;
                                    default:
                                        break h;
                                }
                                oncipj_Cypher_jj_consume_token($this, 103);
                                ju_ArrayList_add($items, oncipj_Cypher_ProcedureResultItem($this));
                            }
                            $this.$jj_la1.data[42] = $this.$jj_gen;
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 334:
                                    break;
                                default:
                                    $this.$jj_la1.data[43] = $this.$jj_gen;
                                    break g;
                            }
                            $where = oncipj_Cypher_WhereClause($this);
                            break g;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                            break;
                        case 307:
                            oncipj_Cypher_jj_consume_token($this, 307);
                            $yieldAll = 1;
                            break g;
                        default:
                    }
                    $this.$jj_la1.data[44] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $procedureResultPosition = new oncipj_ParseException;
                    jl_Throwable__init_0($procedureResultPosition);
                    $rt_throw($procedureResultPosition);
                default:
            }
            $this.$jj_la1.data[45] = $this.$jj_gen;
        }
        $x = oncipj_Cypher_pos($this, $t);
        $t = oncipj_Cypher_pos($this, $t.$next1);
        $procedureNamePosition = oncipj_Cypher_pos($this, $procedureNamePosition.$next1);
        $procedureResultPosition = oncipj_Cypher_pos($this, $procedureResultPosition);
        $e = new oncia_UnresolvedCall;
        var$15 = oncie_Namespace__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $namespace))), $t);
        $t = oncie_ProcedureName__init_($name, $procedureNamePosition);
        $procedureNamePosition = $arguments === null ? s_None$_MODULE$ : s_Some__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $arguments))));
        $arguments = s_Option$_apply(s_Option$_MODULE$, $items);
        var$16 = new onciafn_Neo4jASTFactory$callClause$lambda$_29_0;
        var$16.$_0240 = $where;
        var$16.$_165 = $procedureResultPosition;
        oncia_UnresolvedCall__init_($e, var$15, $t, $procedureNamePosition, s_Option_map($arguments, var$16), $yieldAll, $x);
        return $e;
    }
    function oncipj_Cypher_ProcedureResultItem($this) {
        var $v, $t, var$3, var$4, var$5;
        $v = null;
        $t = oncipj_Cypher_SymbolicNameString($this);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 81:
                    break;
                default:
                    $this.$jj_la1.data[46] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 81);
            $v = oncipj_Cypher_Variable($this);
        }
        var$4 = oncipj_Cypher_pos($this, $t);
        $t = $t.$image0;
        if ($v === null) {
            $v = oncie_Variable__init_($t, var$4);
            $t = oncia_ProcedureResultItem__init_(s_None$_MODULE$, $v, var$4);
        } else {
            var$5 = oncie_ProcedureOutput__init_($t, $v.$position0);
            $t = oncia_ProcedureResultItem__init_(s_Some__init_(var$5), $v, var$4);
        }
        return $t;
    }
    function oncipj_Cypher_LoadCSVClause($this) {
        var $headers, $sep, $t, var$4, $source, $e, $v, var$8, $$je;
        $headers = 0;
        $sep = null;
        $t = oncipj_Cypher_jj_consume_token($this, 199);
        oncipj_Cypher_jj_consume_token($this, 115);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 335:
                    break;
                default:
                    $this.$jj_la1.data[47] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 335);
            oncipj_Cypher_jj_consume_token($this, 175);
            $headers = 1;
        }
        oncipj_Cypher_jj_consume_token($this, 164);
        b: {
            try {
                $source = oncipj_Cypher_Expression($this);
                break b;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_Exception) {
                    $e = $$je;
                } else {
                    throw $$e;
                }
            }
            $sep = new oncipj_ParseException;
            $source = $e.$getMessage();
            $v = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($v);
            $t = jl_StringBuilder_append($v, $rt_s(912));
            jl_AbstractStringBuilder_append($t, 32);
            jl_StringBuilder_append($t, $source);
            jl_Throwable__init_($sep, jl_AbstractStringBuilder_toString($v));
            $rt_throw($sep);
        }
        oncipj_Cypher_jj_consume_token($this, 81);
        $v = oncipj_Cypher_Variable($this);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$4) {
                case 160:
                    break;
                default:
                    $this.$jj_la1.data[48] = $this.$jj_gen;
                    break c;
            }
            oncipj_Cypher_jj_consume_token($this, 160);
            $sep = oncipj_Cypher_StringToken($this);
        }
        $t = oncipj_Cypher_pos($this, $t);
        $sep = $sep !== null ? $sep.$image0 : null;
        $source = $source;
        $e = new oncia_LoadCSV;
        $sep = s_Option$_apply(s_Option$_MODULE$, $sep);
        var$8 = new onciafn_Neo4jASTFactory$loadCsvClause$lambda$_31_0;
        var$8.$_0241 = $t;
        oncia_LoadCSV__init_($e, $headers, $source, $v, s_Option_map($sep, var$8), $t);
        return $e;
    }
    function oncipj_Cypher_ForeachClause($this) {
        var $clauses, $t, $v, $list, var$5;
        $clauses = ju_ArrayList__init_();
        $t = oncipj_Cypher_jj_consume_token($this, 163);
        oncipj_Cypher_jj_consume_token($this, 202);
        $v = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 180);
        $list = oncipj_Cypher_Expression($this);
        oncipj_Cypher_jj_consume_token($this, 86);
        a: while (true) {
            ju_ArrayList_add($clauses, oncipj_Cypher_Clause($this));
            var$5 = $this.$jj_ntk;
            if (var$5 == (-1))
                var$5 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$5) {
                case 96:
                case 114:
                case 126:
                case 130:
                case 163:
                case 199:
                case 206:
                case 207:
                case 226:
                case 264:
                case 269:
                case 286:
                case 322:
                case 324:
                case 335:
                    break;
                default:
                    break a;
            }
        }
        $this.$jj_la1.data[49] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, 275);
        $t = oncipj_Cypher_pos($this, $t);
        return oncia_Foreach__init_($v, $list, sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $clauses))), $t);
    }
    function oncipj_Cypher_SubqueryClause($this) {
        var $inTransactionsParams, $t, $q, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $inTransactionsParams = null;
        $t = oncipj_Cypher_jj_consume_token($this, 96);
        oncipj_Cypher_jj_consume_token($this, 195);
        $q = oncipj_Cypher_RegularQuery($this);
        oncipj_Cypher_jj_consume_token($this, 255);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 180:
                    var$5 = null;
                    var$6 = null;
                    var$7 = null;
                    var$8 = oncipj_Cypher_jj_consume_token($this, 180);
                    oncipj_Cypher_jj_consume_token($this, 313);
                    b: while (true) {
                        var$9 = $this.$jj_ntk;
                        if (var$9 == (-1))
                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$9) {
                            case 223:
                            case 224:
                            case 266:
                                break;
                            default:
                                $this.$jj_la1.data[51] = $this.$jj_gen;
                                var$10 = oncipj_Cypher_pos($this, var$8);
                                $inTransactionsParams = oncia_SubqueryCall$InTransactionsParameters__init_(s_Option$_apply(s_Option$_MODULE$, var$5), s_Option$_apply(s_Option$_MODULE$, var$6), s_Option$_apply(s_Option$_MODULE$, var$7), var$10);
                                break a;
                        }
                        var$4 = $this.$jj_ntk;
                        if (var$4 == (-1))
                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$4) {
                            case 223:
                                oncipj_Cypher_assertNotAlreadySet($this, var$5, var$8, $rt_s(913));
                                $inTransactionsParams = oncipj_Cypher_jj_consume_token($this, 223);
                                var$10 = oncipj_Cypher_Expression($this);
                                var$4 = $this.$jj_ntk;
                                if (var$4 == (-1))
                                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                                c: {
                                    switch (var$4) {
                                        case 273:
                                            break;
                                        case 274:
                                            oncipj_Cypher_jj_consume_token($this, 274);
                                            break c;
                                        default:
                                            $this.$jj_la1.data[53] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $inTransactionsParams = new oncipj_ParseException;
                                            jl_Throwable__init_0($inTransactionsParams);
                                            $rt_throw($inTransactionsParams);
                                    }
                                    oncipj_Cypher_jj_consume_token($this, 273);
                                }
                                $inTransactionsParams = oncipj_Cypher_pos($this, $inTransactionsParams);
                                var$5 = oncia_SubqueryCall$InTransactionsBatchParameters__init_(var$10, $inTransactionsParams);
                                continue b;
                            case 224:
                                oncipj_Cypher_assertNotAlreadySet($this, var$6, var$8, $rt_s(914));
                                onciaf_CallInTxsOnErrorBehaviourType_$callClinit();
                                $inTransactionsParams = onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_FAIL;
                                var$10 = oncipj_Cypher_jj_consume_token($this, 224);
                                oncipj_Cypher_jj_consume_token($this, 157);
                                var$4 = $this.$jj_ntk;
                                if (var$4 == (-1))
                                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                                d: {
                                    switch (var$4) {
                                        case 91:
                                            oncipj_Cypher_jj_consume_token($this, 91);
                                            $inTransactionsParams = onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_BREAK;
                                            break d;
                                        case 112:
                                            oncipj_Cypher_jj_consume_token($this, 112);
                                            $inTransactionsParams = onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_CONTINUE;
                                            break d;
                                        case 158:
                                            break;
                                        default:
                                            $this.$jj_la1.data[54] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $inTransactionsParams = new oncipj_ParseException;
                                            jl_Throwable__init_0($inTransactionsParams);
                                            $rt_throw($inTransactionsParams);
                                    }
                                    oncipj_Cypher_jj_consume_token($this, 158);
                                }
                                var$10 = oncipj_Cypher_pos($this, var$10);
                                if (jl_Enum_equals(onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_CONTINUE, $inTransactionsParams))
                                    var$6 = oncia_SubqueryCall$InTransactionsErrorParameters__init_(oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_MODULE$, var$10);
                                else if (jl_Enum_equals(onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_BREAK, $inTransactionsParams))
                                    var$6 = oncia_SubqueryCall$InTransactionsErrorParameters__init_(oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_MODULE$, var$10);
                                else {
                                    if (!jl_Enum_equals(onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_FAIL, $inTransactionsParams))
                                        break b;
                                    var$6 = oncia_SubqueryCall$InTransactionsErrorParameters__init_(oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_MODULE$, var$10);
                                }
                                continue b;
                            case 266:
                                break;
                            default:
                                $this.$jj_la1.data[52] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $inTransactionsParams = new oncipj_ParseException;
                                jl_Throwable__init_0($inTransactionsParams);
                                $rt_throw($inTransactionsParams);
                        }
                        oncipj_Cypher_assertNotAlreadySet($this, var$7, var$8, $rt_s(915));
                        $inTransactionsParams = oncipj_Cypher_jj_consume_token($this, 266);
                        oncipj_Cypher_jj_consume_token($this, 297);
                        oncipj_Cypher_jj_consume_token($this, 81);
                        var$7 = oncia_SubqueryCall$InTransactionsReportParameters__init_(oncipj_Cypher_Variable($this), oncipj_Cypher_pos($this, $inTransactionsParams));
                    }
                    $rt_throw(s_MatchError__init_($inTransactionsParams));
                default:
            }
            $this.$jj_la1.data[50] = $this.$jj_gen;
        }
        $t = oncipj_Cypher_pos($this, $t);
        return oncia_SubqueryCall__init_($q, s_Option$_apply(s_Option$_MODULE$, $inTransactionsParams), $t);
    }
    function oncipj_Cypher_PatternList($this) {
        var $patterns, var$2;
        $patterns = ju_ArrayList__init_();
        ju_ArrayList_add($patterns, oncipj_Cypher_Pattern($this));
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($patterns, oncipj_Cypher_Pattern($this));
        }
        $this.$jj_la1.data[55] = $this.$jj_gen;
        return $patterns;
    }
    function oncipj_Cypher_Pattern($this) {
        var $v, $s, $p, var$4, var$5, var$6, $$je;
        $v = null;
        $s = null;
        $this.$jj_la = 2;
        $p = $this.$token;
        $this.$jj_scanpos = $p;
        $this.$jj_lastpos = $p;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$4 = oncipj_Cypher_jj_3_17($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $v = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 16, 2);
                        break a;
                    }
                    try {
                        var$4 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $v = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 16, 2);
                $rt_throw($v);
            }
            oncipj_Cypher_jj_save($this, 16, 2);
        }
        e: {
            if (!var$4) {
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 76:
                    case 79:
                    case 290:
                        break;
                    default:
                        $this.$jj_la1.data[57] = $this.$jj_gen;
                        break e;
                }
                $s = oncipj_Cypher_Selector($this);
            } else {
                $v = oncipj_Cypher_Variable($this);
                oncipj_Cypher_jj_consume_token($this, 151);
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 76:
                    case 79:
                    case 290:
                        break;
                    default:
                        $this.$jj_la1.data[56] = $this.$jj_gen;
                        break e;
                }
                $s = oncipj_Cypher_Selector($this);
            }
        }
        $this.$jj_la = 3;
        $p = $this.$token;
        $this.$jj_scanpos = $p;
        $this.$jj_lastpos = $p;
        f: {
            g: {
                h: {
                    i: {
                        try {
                            var$4 = oncipj_Cypher_jj_3_19($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break i;
                            } else{
                                $v = $$je;
                                break h;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 18, 3);
                        break f;
                    }
                    try {
                        var$4 = 1;
                        break g;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $v = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 18, 3);
                $rt_throw($v);
            }
            oncipj_Cypher_jj_save($this, 18, 3);
        }
        j: {
            if (var$4)
                $p = oncipj_Cypher_ShortestPathPattern($this);
            else {
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 202:
                        $p = oncipj_Cypher_PatternElement($this);
                        $p = onciafn_Neo4jASTFactory_pathPattern($this.$astFactory, $p);
                        break j;
                    default:
                }
                $this.$jj_la1.data[61] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $v = new oncipj_ParseException;
                jl_Throwable__init_0($v);
                $rt_throw($v);
            }
        }
        var$6 = $v === null ? $p : oncie_NamedPatternPart__init_($v, $p, $v.$position0);
        if ($s === null)
            $v = var$6;
        else {
            if (!$rt_isInstance(var$6, oncie_NonPrefixedPatternPart)) {
                if (!(var$6 instanceof oncie_PatternPartWithSelector))
                    $rt_throw(s_MatchError__init_(var$6));
                $v = var$6;
                $s = new jl_IllegalArgumentException;
                $p = jl_Class_getSimpleName(jl_Object_getClass($v));
                var$6 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$6);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(916)), $p), $rt_s(917)), $v);
                jl_Throwable__init_($s, jl_AbstractStringBuilder_toString(var$6));
                $rt_throw($s);
            }
            $v = oncie_PatternPartWithSelector__init_($s, var$6);
        }
        return $v;
    }
    function oncipj_Cypher_Quantifier($this) {
        var $l, $u, $range, var$4, var$5, var$6, var$7, var$8, var$9, $$je;
        $l = null;
        $u = null;
        $this.$jj_la = 3;
        $range = $this.$token;
        $this.$jj_scanpos = $range;
        $this.$jj_lastpos = $range;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$4 = oncipj_Cypher_jj_3_18($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $l = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 17, 3);
                        break a;
                    }
                    try {
                        var$4 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $l = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 17, 3);
                $rt_throw($l);
            }
            oncipj_Cypher_jj_save($this, 17, 3);
        }
        if (var$4) {
            $range = oncipj_Cypher_jj_consume_token($this, 195);
            $l = oncipj_Cypher_jj_consume_token($this, 36);
            oncipj_Cypher_jj_consume_token($this, 255);
            $u = oncipj_Cypher_pos($this, $range);
            $range = oncipj_Cypher_pos($this, $l);
            $l = $l.$image0;
            return oncie_FixedQuantifier__init_(oncie_UnsignedDecimalIntegerLiteral__init_($l, $range), $u);
        }
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$5) {
            case 195:
                $range = oncipj_Cypher_jj_consume_token($this, 195);
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                e: {
                    switch (var$5) {
                        case 36:
                            break;
                        default:
                            $this.$jj_la1.data[58] = $this.$jj_gen;
                            break e;
                    }
                    $l = oncipj_Cypher_jj_consume_token($this, 36);
                }
                oncipj_Cypher_jj_consume_token($this, 103);
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                f: {
                    switch (var$5) {
                        case 36:
                            break;
                        default:
                            $this.$jj_la1.data[59] = $this.$jj_gen;
                            break f;
                    }
                    $u = oncipj_Cypher_jj_consume_token($this, 36);
                }
                oncipj_Cypher_jj_consume_token($this, 255);
                $range = oncipj_Cypher_pos($this, $range);
                var$6 = oncipj_Cypher_pos($this, $l);
                var$7 = oncipj_Cypher_pos($this, $u);
                var$8 = $l !== null ? $l.$image0 : null;
                var$9 = $u !== null ? $u.$image0 : null;
                return oncie_IntervalQuantifier__init_(var$8 === null ? s_None$_MODULE$ : s_Some__init_(oncie_UnsignedDecimalIntegerLiteral__init_(var$8, var$6)), var$9 === null ? s_None$_MODULE$ : s_Some__init_(oncie_UnsignedDecimalIntegerLiteral__init_(var$9, var$7)), $range);
            case 238:
                break;
            case 307:
                return oncie_StarQuantifier__init_(oncipj_Cypher_pos($this, oncipj_Cypher_jj_consume_token($this, 307)));
            default:
                $this.$jj_la1.data[60] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $l = new oncipj_ParseException;
                jl_Throwable__init_0($l);
                $rt_throw($l);
        }
        return oncie_PlusQuantifier__init_(oncipj_Cypher_pos($this, oncipj_Cypher_jj_consume_token($this, 238)));
    }
    function oncipj_Cypher_ShortestPathPattern($this) {
        var var$1, $t, $pe;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$1) {
            case 75:
                $t = oncipj_Cypher_jj_consume_token($this, 75);
                oncipj_Cypher_jj_consume_token($this, 202);
                $pe = oncipj_Cypher_PatternElement($this);
                oncipj_Cypher_jj_consume_token($this, 275);
                return oncie_ShortestPathsPatternPart__init_($pe, 0, oncipj_Cypher_pos($this, $t));
            case 289:
                $t = oncipj_Cypher_jj_consume_token($this, 289);
                oncipj_Cypher_jj_consume_token($this, 202);
                $pe = oncipj_Cypher_PatternElement($this);
                oncipj_Cypher_jj_consume_token($this, 275);
                return oncie_ShortestPathsPatternPart__init_($pe, 1, oncipj_Cypher_pos($this, $t));
            default:
        }
        $this.$jj_la1.data[62] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $t = new oncipj_ParseException;
        jl_Throwable__init_0($t);
        $rt_throw($t);
    }
    function oncipj_Cypher_PatternElement($this) {
        var $patternAtoms, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, $$je;
        ju_ArrayList__init_0(new ju_ArrayList);
        $patternAtoms = ju_ArrayList__init_();
        var$2 = $this.$labelExpressionStack;
        oncipj_ExpectBar_$callClinit();
        ju_Stack_push(var$2, oncipj_ExpectBar_DO_NOT_EXPECT_BAR);
        a: {
            b: while (true) {
                $this.$jj_la = 3;
                var$2 = $this.$token;
                $this.$jj_scanpos = var$2;
                $this.$jj_lastpos = var$2;
                c: {
                    d: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_21($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $patternAtoms = $$je;
                                break a;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 20, 3);
                        break c;
                    }
                    try {
                        var$3 = 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $patternAtoms = $$je;
                        break a;

                    }
                    oncipj_Cypher_jj_save($this, 20, 3);
                }
                e: {
                    if (var$3) {
                        ju_ArrayList_add($patternAtoms, oncipj_Cypher_NodePattern($this));
                        while (true) {
                            $this.$jj_la = 2;
                            var$2 = $this.$token;
                            $this.$jj_scanpos = var$2;
                            $this.$jj_lastpos = var$2;
                            f: {
                                g: {
                                    try {
                                        var$3 = oncipj_Cypher_jj_3_20($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break g;
                                        } else{
                                            $patternAtoms = $$je;
                                            break b;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 19, 2);
                                    break f;
                                }
                                try {
                                    var$3 = 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $patternAtoms = $$je;
                                    break b;

                                }
                                oncipj_Cypher_jj_save($this, 19, 2);
                            }
                            if (!var$3)
                                break e;
                            var$4 = null;
                            var$2 = oncipj_Cypher_RelationshipPattern($this);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            h: {
                                switch (var$3) {
                                    case 195:
                                    case 238:
                                    case 307:
                                        break;
                                    default:
                                        $this.$jj_la1.data[63] = $this.$jj_gen;
                                        break h;
                                }
                                var$4 = oncipj_Cypher_Quantifier($this);
                            }
                            if (var$4 !== null) {
                                var$5 = $this.$astFactory;
                                var$6 = var$2.$position32;
                                var$7 = new oncie_PathPatternPart;
                                var$8 = new oncie_RelationshipChain;
                                var$9 = new oncie_NodePattern;
                                var$10 = s_None$_MODULE$;
                                oncie_NodePattern__init_0(var$9, var$10, var$10, var$10, var$10, var$6);
                                var$10 = new oncie_NodePattern;
                                var$11 = s_None$_MODULE$;
                                oncie_NodePattern__init_0(var$10, var$11, var$11, var$11, var$11, var$6);
                                oncie_RelationshipChain__init_0(var$8, var$9, var$2, var$10, var$6);
                                oncie_PathPatternPart__init_0(var$7, var$8);
                                var$2 = onciafn_Neo4jASTFactory_parenthesizedPathPattern(var$5, var$6, var$7, null, var$4);
                            }
                            ju_ArrayList_add($patternAtoms, var$2);
                            ju_ArrayList_add($patternAtoms, oncipj_Cypher_NodePattern($this));
                        }
                    }
                    var$12 = $this.$jj_ntk;
                    if (var$12 == (-1))
                        var$12 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$12) {
                        case 202:
                            break;
                        default:
                            $this.$jj_la1.data[64] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $patternAtoms = new oncipj_ParseException;
                            jl_Throwable__init_0($patternAtoms);
                            $rt_throw($patternAtoms);
                    }
                    var$2 = null;
                    var$7 = null;
                    var$10 = oncipj_Cypher_jj_consume_token($this, 202);
                    var$11 = oncipj_Cypher_Pattern($this);
                    var$12 = $this.$jj_ntk;
                    if (var$12 == (-1))
                        var$12 = oncipj_Cypher_jj_ntk_f($this);
                    i: {
                        switch (var$12) {
                            case 334:
                                break;
                            default:
                                $this.$jj_la1.data[93] = $this.$jj_gen;
                                break i;
                        }
                        oncipj_Cypher_jj_consume_token($this, 334);
                        var$2 = oncipj_Cypher_Expression($this);
                    }
                    oncipj_Cypher_jj_consume_token($this, 275);
                    var$12 = $this.$jj_ntk;
                    if (var$12 == (-1))
                        var$12 = oncipj_Cypher_jj_ntk_f($this);
                    j: {
                        switch (var$12) {
                            case 195:
                            case 238:
                            case 307:
                                break;
                            default:
                                $this.$jj_la1.data[94] = $this.$jj_gen;
                                break j;
                        }
                        var$7 = oncipj_Cypher_Quantifier($this);
                    }
                    ju_ArrayList_add($patternAtoms, onciafn_Neo4jASTFactory_parenthesizedPathPattern($this.$astFactory, oncipj_Cypher_pos($this, var$10), var$11, var$2, var$7));
                }
                var$12 = $this.$jj_ntk;
                if (var$12 == (-1))
                    var$12 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$12) {
                    case 202:
                        break;
                    default:
                        $this.$jj_la1.data[65] = $this.$jj_gen;
                        ju_Stack_pop($this.$labelExpressionStack);
                        return onciafn_Neo4jASTFactory_patternElement($this.$astFactory, $patternAtoms);
                }
            }
            oncipj_Cypher_jj_save($this, 19, 2);
            $rt_throw($patternAtoms);
        }
        oncipj_Cypher_jj_save($this, 20, 3);
        $rt_throw($patternAtoms);
    }
    function oncipj_Cypher_Selector($this) {
        var $k, $s, var$3;
        a: {
            $k = null;
            if (oncipj_Cypher_jj_2_22($this, 2)) {
                $s = oncipj_Cypher_jj_consume_token($this, 79);
                oncipj_Cypher_jj_consume_token($this, 290);
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                b: {
                    switch (var$3) {
                        case 234:
                        case 235:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 234:
                                    oncipj_Cypher_jj_consume_token($this, 234);
                                    break b;
                                case 235:
                                    oncipj_Cypher_jj_consume_token($this, 235);
                                    break b;
                                default:
                            }
                            $this.$jj_la1.data[66] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        default:
                    }
                    $this.$jj_la1.data[67] = $this.$jj_gen;
                }
                $k = onciafn_Neo4jASTFactory_anyShortestPathSelector($this.$astFactory, null, null, oncipj_Cypher_pos($this, $s));
            } else if (oncipj_Cypher_jj_2_23($this, 2)) {
                $s = oncipj_Cypher_jj_consume_token($this, 76);
                oncipj_Cypher_jj_consume_token($this, 290);
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                c: {
                    switch (var$3) {
                        case 234:
                        case 235:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 234:
                                    break;
                                case 235:
                                    oncipj_Cypher_jj_consume_token($this, 235);
                                    break c;
                                default:
                                    $this.$jj_la1.data[68] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                            }
                            oncipj_Cypher_jj_consume_token($this, 234);
                            break c;
                        default:
                    }
                    $this.$jj_la1.data[69] = $this.$jj_gen;
                }
                $k = onciafn_Neo4jASTFactory_allShortestPathSelector($this.$astFactory, oncipj_Cypher_pos($this, $s));
            } else if (oncipj_Cypher_jj_2_24($this, 2)) {
                $s = oncipj_Cypher_jj_consume_token($this, 79);
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                d: {
                    switch (var$3) {
                        case 36:
                            break;
                        default:
                            $this.$jj_la1.data[70] = $this.$jj_gen;
                            break d;
                    }
                    $k = oncipj_Cypher_jj_consume_token($this, 36);
                }
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                e: {
                    switch (var$3) {
                        case 234:
                        case 235:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 234:
                                    oncipj_Cypher_jj_consume_token($this, 234);
                                    break e;
                                case 235:
                                    oncipj_Cypher_jj_consume_token($this, 235);
                                    break e;
                                default:
                            }
                            $this.$jj_la1.data[71] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        default:
                    }
                    $this.$jj_la1.data[72] = $this.$jj_gen;
                }
                $k = onciafn_Neo4jASTFactory_anyPathSelector($this.$astFactory, $k === null ? null : $k.$image0, oncipj_Cypher_pos($this, $k), oncipj_Cypher_pos($this, $s));
            } else if (oncipj_Cypher_jj_2_25($this, 2)) {
                $s = oncipj_Cypher_jj_consume_token($this, 76);
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                f: {
                    switch (var$3) {
                        case 234:
                        case 235:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 234:
                                    break;
                                case 235:
                                    oncipj_Cypher_jj_consume_token($this, 235);
                                    break f;
                                default:
                                    $this.$jj_la1.data[73] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                            }
                            oncipj_Cypher_jj_consume_token($this, 234);
                            break f;
                        default:
                    }
                    $this.$jj_la1.data[74] = $this.$jj_gen;
                }
                $k = onciafn_Neo4jASTFactory_allPathSelector0($this.$astFactory, oncipj_Cypher_pos($this, $s));
            } else {
                if (!oncipj_Cypher_jj_2_26($this, 4)) {
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$3) {
                        case 290:
                            $s = oncipj_Cypher_jj_consume_token($this, 290);
                            $k = oncipj_Cypher_jj_consume_token($this, 36);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            g: {
                                switch (var$3) {
                                    case 234:
                                    case 235:
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$3) {
                                            case 234:
                                                oncipj_Cypher_jj_consume_token($this, 234);
                                                break g;
                                            case 235:
                                                oncipj_Cypher_jj_consume_token($this, 235);
                                                break g;
                                            default:
                                        }
                                        $this.$jj_la1.data[79] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $rt_throw(oncipj_ParseException__init_());
                                    default:
                                }
                                $this.$jj_la1.data[80] = $this.$jj_gen;
                            }
                            $k = onciafn_Neo4jASTFactory_anyShortestPathSelector($this.$astFactory, $k.$image0, oncipj_Cypher_pos($this, $k), oncipj_Cypher_pos($this, $s));
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[81] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                $s = oncipj_Cypher_jj_consume_token($this, 290);
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                h: {
                    switch (var$3) {
                        case 36:
                            break;
                        default:
                            $this.$jj_la1.data[75] = $this.$jj_gen;
                            break h;
                    }
                    $k = oncipj_Cypher_jj_consume_token($this, 36);
                }
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                i: {
                    switch (var$3) {
                        case 234:
                        case 235:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 234:
                                    oncipj_Cypher_jj_consume_token($this, 234);
                                    break i;
                                case 235:
                                    oncipj_Cypher_jj_consume_token($this, 235);
                                    break i;
                                default:
                            }
                            $this.$jj_la1.data[76] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        default:
                    }
                    $this.$jj_la1.data[77] = $this.$jj_gen;
                }
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                j: {
                    switch (var$3) {
                        case 172:
                            oncipj_Cypher_jj_consume_token($this, 172);
                            break j;
                        case 173:
                            oncipj_Cypher_jj_consume_token($this, 173);
                            break j;
                        default:
                    }
                    $this.$jj_la1.data[78] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                $k = onciafn_Neo4jASTFactory_shortestGroupsSelector($this.$astFactory, $k === null ? null : $k.$image0, oncipj_Cypher_pos($this, $k), oncipj_Cypher_pos($this, $s));
            }
        }
        return $k;
    }
    function oncipj_Cypher_PathPatternNonEmpty($this) {
        var $patternAtoms, $n, var$3, $$je;
        $patternAtoms = ju_ArrayList__init_();
        $n = $this.$labelExpressionStack;
        oncipj_ExpectBar_$callClinit();
        ju_Stack_push($n, oncipj_ExpectBar_DO_NOT_EXPECT_BAR);
        ju_ArrayList_add($patternAtoms, oncipj_Cypher_NodePattern($this));
        a: while (true) {
            ju_ArrayList_add($patternAtoms, oncipj_Cypher_RelationshipPattern($this));
            ju_ArrayList_add($patternAtoms, oncipj_Cypher_NodePattern($this));
            $this.$jj_la = 2;
            $n = $this.$token;
            $this.$jj_scanpos = $n;
            $this.$jj_lastpos = $n;
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_27($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            $patternAtoms = $$je;
                            break a;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 26, 2);
                    break b;
                }
                try {
                    var$3 = 1;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    $patternAtoms = $$je;
                    break a;

                }
                oncipj_Cypher_jj_save($this, 26, 2);
            }
            if (!var$3) {
                ju_Stack_pop($this.$labelExpressionStack);
                $n = $this.$astFactory;
                return onciafn_Neo4jASTFactory_pathPattern($n, onciafn_Neo4jASTFactory_patternElement($n, $patternAtoms));
            }
        }
        oncipj_Cypher_jj_save($this, 26, 2);
        $rt_throw($patternAtoms);
    }
    function oncipj_Cypher_NodePattern($this) {
        var $t, $n, var$3, var$4, var$5, var$6, var$7, $$je;
        $t = oncipj_Cypher_jj_consume_token($this, 202);
        $this.$jj_la = 2147483647;
        $n = $this.$token;
        $this.$jj_scanpos = $n;
        $this.$jj_lastpos = $n;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_28($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $t = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 27, 2147483647);
                        break a;
                    }
                    try {
                        var$3 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 27, 2147483647);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 27, 2147483647);
        }
        e: {
            if (var$3) {
                oncipj_Cypher_jj_consume_token($this, 275);
                $n = onciafn_Neo4jASTFactory_nodePattern($this.$astFactory, oncipj_Cypher_pos($this, $t), null, null, null, null);
            } else {
                $this.$jj_la = 2147483647;
                $n = $this.$token;
                $this.$jj_scanpos = $n;
                $this.$jj_lastpos = $n;
                f: {
                    g: {
                        h: {
                            i: {
                                try {
                                    var$3 = oncipj_Cypher_jj_3_29($this) ? 0 : 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                        break i;
                                    } else{
                                        $t = $$je;
                                        break h;
                                    }
                                }
                                oncipj_Cypher_jj_save($this, 28, 2147483647);
                                break f;
                            }
                            try {
                                var$3 = 1;
                                break g;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                $t = $$je;

                            }
                        }
                        oncipj_Cypher_jj_save($this, 28, 2147483647);
                        $rt_throw($t);
                    }
                    oncipj_Cypher_jj_save($this, 28, 2147483647);
                }
                if (var$3) {
                    var$4 = oncipj_Cypher_Variable($this);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    $n = onciafn_Neo4jASTFactory_nodePattern($this.$astFactory, oncipj_Cypher_pos($this, $t), var$4, null, null, null);
                } else {
                    $this.$jj_la = 2147483647;
                    $n = $this.$token;
                    $this.$jj_scanpos = $n;
                    $this.$jj_lastpos = $n;
                    j: {
                        k: {
                            l: {
                                m: {
                                    try {
                                        var$3 = oncipj_Cypher_jj_3_30($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break m;
                                        } else{
                                            $t = $$je;
                                            break l;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 29, 2147483647);
                                    break j;
                                }
                                try {
                                    var$3 = 1;
                                    break k;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $t = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 29, 2147483647);
                            $rt_throw($t);
                        }
                        oncipj_Cypher_jj_save($this, 29, 2147483647);
                    }
                    if (var$3) {
                        $n = null;
                        var$5 = null;
                        var$4 = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_nodeType($this.$astFactory));
                        var$6 = $this.$jj_ntk;
                        if (var$6 == (-1))
                            var$6 = oncipj_Cypher_jj_ntk_f($this);
                        n: {
                            switch (var$6) {
                                case 131:
                                case 195:
                                    break;
                                default:
                                    $this.$jj_la1.data[83] = $this.$jj_gen;
                                    break n;
                            }
                            $n = oncipj_Cypher_Properties($this);
                        }
                        var$6 = $this.$jj_ntk;
                        if (var$6 == (-1))
                            var$6 = oncipj_Cypher_jj_ntk_f($this);
                        o: {
                            switch (var$6) {
                                case 334:
                                    break;
                                default:
                                    $this.$jj_la1.data[84] = $this.$jj_gen;
                                    break o;
                            }
                            oncipj_Cypher_jj_consume_token($this, 334);
                            var$5 = oncipj_Cypher_Expression($this);
                        }
                        oncipj_Cypher_jj_consume_token($this, 275);
                        $n = onciafn_Neo4jASTFactory_nodePattern($this.$astFactory, oncipj_Cypher_pos($this, $t), null, var$4, $n, var$5);
                    } else {
                        $this.$jj_la = 2147483647;
                        $n = $this.$token;
                        $this.$jj_scanpos = $n;
                        $this.$jj_lastpos = $n;
                        p: {
                            q: {
                                r: {
                                    s: {
                                        try {
                                            var$3 = oncipj_Cypher_jj_3_31($this) ? 0 : 1;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                break s;
                                            } else{
                                                $t = $$je;
                                                break r;
                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 30, 2147483647);
                                        break p;
                                    }
                                    try {
                                        var$3 = 1;
                                        break q;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        $t = $$je;

                                    }
                                }
                                oncipj_Cypher_jj_save($this, 30, 2147483647);
                                $rt_throw($t);
                            }
                            oncipj_Cypher_jj_save($this, 30, 2147483647);
                        }
                        if (var$3) {
                            $n = null;
                            var$5 = null;
                            var$4 = oncipj_Cypher_Variable($this);
                            var$7 = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_nodeType($this.$astFactory));
                            var$6 = $this.$jj_ntk;
                            if (var$6 == (-1))
                                var$6 = oncipj_Cypher_jj_ntk_f($this);
                            t: {
                                switch (var$6) {
                                    case 131:
                                    case 195:
                                        break;
                                    default:
                                        $this.$jj_la1.data[85] = $this.$jj_gen;
                                        break t;
                                }
                                $n = oncipj_Cypher_Properties($this);
                            }
                            var$6 = $this.$jj_ntk;
                            if (var$6 == (-1))
                                var$6 = oncipj_Cypher_jj_ntk_f($this);
                            u: {
                                switch (var$6) {
                                    case 334:
                                        break;
                                    default:
                                        $this.$jj_la1.data[86] = $this.$jj_gen;
                                        break u;
                                }
                                oncipj_Cypher_jj_consume_token($this, 334);
                                var$5 = oncipj_Cypher_Expression($this);
                            }
                            oncipj_Cypher_jj_consume_token($this, 275);
                            $n = onciafn_Neo4jASTFactory_nodePattern($this.$astFactory, oncipj_Cypher_pos($this, $t), var$4, var$7, $n, var$5);
                        } else {
                            $this.$jj_la = 2147483647;
                            $n = $this.$token;
                            $this.$jj_scanpos = $n;
                            $this.$jj_lastpos = $n;
                            v: {
                                w: {
                                    x: {
                                        y: {
                                            try {
                                                var$3 = oncipj_Cypher_jj_3_32($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break y;
                                                } else{
                                                    $t = $$je;
                                                    break x;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 31, 2147483647);
                                            break v;
                                        }
                                        try {
                                            var$3 = 1;
                                            break w;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $t = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 31, 2147483647);
                                    $rt_throw($t);
                                }
                                oncipj_Cypher_jj_save($this, 31, 2147483647);
                            }
                            if (!var$3) {
                                var$6 = $this.$jj_ntk;
                                if (var$6 == (-1))
                                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                                z: {
                                    switch (var$6) {
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 71:
                                        case 72:
                                        case 73:
                                        case 74:
                                        case 75:
                                        case 76:
                                        case 77:
                                        case 78:
                                        case 79:
                                        case 80:
                                        case 81:
                                        case 82:
                                        case 83:
                                        case 84:
                                        case 85:
                                        case 87:
                                        case 88:
                                        case 89:
                                        case 90:
                                        case 91:
                                        case 92:
                                        case 93:
                                        case 94:
                                        case 95:
                                        case 96:
                                        case 97:
                                        case 98:
                                        case 99:
                                        case 100:
                                        case 101:
                                        case 104:
                                        case 105:
                                        case 106:
                                        case 107:
                                        case 108:
                                        case 109:
                                        case 110:
                                        case 111:
                                        case 112:
                                        case 113:
                                        case 114:
                                        case 115:
                                        case 116:
                                        case 117:
                                        case 118:
                                        case 119:
                                        case 120:
                                        case 121:
                                        case 122:
                                        case 123:
                                        case 124:
                                        case 125:
                                        case 126:
                                        case 127:
                                        case 128:
                                        case 129:
                                        case 130:
                                        case 132:
                                        case 133:
                                        case 137:
                                        case 138:
                                        case 139:
                                        case 140:
                                        case 141:
                                        case 142:
                                        case 143:
                                        case 144:
                                        case 145:
                                        case 146:
                                        case 147:
                                        case 148:
                                        case 149:
                                        case 150:
                                        case 152:
                                        case 153:
                                        case 154:
                                        case 155:
                                        case 156:
                                        case 157:
                                        case 158:
                                        case 159:
                                        case 160:
                                        case 161:
                                        case 162:
                                        case 163:
                                        case 164:
                                        case 165:
                                        case 166:
                                        case 167:
                                        case 169:
                                        case 170:
                                        case 171:
                                        case 172:
                                        case 173:
                                        case 175:
                                        case 176:
                                        case 177:
                                        case 179:
                                        case 180:
                                        case 181:
                                        case 182:
                                        case 183:
                                        case 184:
                                        case 185:
                                        case 186:
                                        case 187:
                                        case 188:
                                        case 189:
                                        case 190:
                                        case 191:
                                        case 197:
                                        case 198:
                                        case 199:
                                        case 200:
                                        case 201:
                                        case 204:
                                        case 205:
                                        case 206:
                                        case 207:
                                        case 212:
                                        case 213:
                                        case 214:
                                        case 215:
                                        case 216:
                                        case 217:
                                        case 218:
                                        case 219:
                                        case 220:
                                        case 221:
                                        case 222:
                                        case 223:
                                        case 224:
                                        case 225:
                                        case 226:
                                        case 227:
                                        case 228:
                                        case 229:
                                        case 230:
                                        case 231:
                                        case 232:
                                        case 233:
                                        case 234:
                                        case 235:
                                        case 236:
                                        case 237:
                                        case 240:
                                        case 241:
                                        case 243:
                                        case 244:
                                        case 245:
                                        case 246:
                                        case 247:
                                        case 248:
                                        case 249:
                                        case 250:
                                        case 251:
                                        case 253:
                                        case 256:
                                        case 257:
                                        case 258:
                                        case 259:
                                        case 261:
                                        case 262:
                                        case 263:
                                        case 264:
                                        case 265:
                                        case 266:
                                        case 267:
                                        case 268:
                                        case 269:
                                        case 270:
                                        case 271:
                                        case 272:
                                        case 273:
                                        case 274:
                                        case 276:
                                        case 277:
                                        case 278:
                                        case 279:
                                        case 280:
                                        case 281:
                                        case 282:
                                        case 284:
                                        case 285:
                                        case 286:
                                        case 287:
                                        case 288:
                                        case 289:
                                        case 290:
                                        case 291:
                                        case 292:
                                        case 293:
                                        case 294:
                                        case 295:
                                        case 296:
                                        case 297:
                                        case 298:
                                        case 299:
                                        case 300:
                                        case 301:
                                        case 302:
                                        case 303:
                                        case 304:
                                        case 305:
                                        case 306:
                                        case 308:
                                        case 309:
                                        case 310:
                                        case 311:
                                        case 312:
                                        case 313:
                                        case 314:
                                        case 315:
                                        case 316:
                                        case 317:
                                        case 318:
                                        case 319:
                                        case 320:
                                        case 321:
                                        case 322:
                                        case 323:
                                        case 324:
                                        case 325:
                                        case 326:
                                        case 327:
                                        case 328:
                                        case 329:
                                        case 330:
                                        case 331:
                                        case 332:
                                        case 333:
                                        case 334:
                                        case 335:
                                        case 336:
                                        case 337:
                                        case 338:
                                        case 339:
                                        case 340:
                                        case 341:
                                            break;
                                        case 86:
                                        case 102:
                                        case 103:
                                        case 131:
                                        case 134:
                                        case 135:
                                        case 136:
                                        case 151:
                                        case 168:
                                        case 174:
                                        case 178:
                                        case 192:
                                        case 193:
                                        case 194:
                                        case 195:
                                        case 196:
                                        case 202:
                                        case 203:
                                        case 208:
                                        case 209:
                                        case 210:
                                        case 211:
                                        case 238:
                                        case 239:
                                        case 242:
                                        case 252:
                                        case 254:
                                        case 255:
                                        case 260:
                                        case 275:
                                        case 283:
                                        case 307:
                                            break z;
                                        default:
                                            break z;
                                    }
                                    $n = oncipj_Cypher_NodePatternComplex($this, $t);
                                    break e;
                                }
                                $this.$jj_la1.data[82] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $t = new oncipj_ParseException;
                                jl_Throwable__init_0($t);
                                $rt_throw($t);
                            }
                            $n = null;
                            var$5 = oncipj_Cypher_Properties($this);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            ba: {
                                switch (var$3) {
                                    case 334:
                                        break;
                                    default:
                                        $this.$jj_la1.data[87] = $this.$jj_gen;
                                        break ba;
                                }
                                oncipj_Cypher_jj_consume_token($this, 334);
                                $n = oncipj_Cypher_Expression($this);
                            }
                            oncipj_Cypher_jj_consume_token($this, 275);
                            $n = onciafn_Neo4jASTFactory_nodePattern($this.$astFactory, oncipj_Cypher_pos($this, $t), null, null, var$5, $n);
                        }
                    }
                }
            }
        }
        return $n;
    }
    function oncipj_Cypher_NodePatternComplex($this, $t) {
        var $v, $labelExpression, $properties, $predicate, var$6, var$7, var$8, $$je;
        $v = null;
        $labelExpression = null;
        $properties = null;
        $predicate = null;
        $this.$jj_la = 2147483647;
        var$6 = $this.$token;
        $this.$jj_scanpos = var$6;
        $this.$jj_lastpos = var$6;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$7 = oncipj_Cypher_jj_3_33($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $t = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 32, 2147483647);
                        break a;
                    }
                    try {
                        var$7 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 32, 2147483647);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 32, 2147483647);
        }
        e: {
            if (var$7) {
                $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_nodeType($this.$astFactory));
                oncipj_Cypher_jj_consume_token($this, 334);
                $predicate = oncipj_Cypher_Expression($this);
            } else {
                $this.$jj_la = 2;
                var$6 = $this.$token;
                $this.$jj_scanpos = var$6;
                $this.$jj_lastpos = var$6;
                f: {
                    g: {
                        h: {
                            i: {
                                try {
                                    var$7 = oncipj_Cypher_jj_3_34($this) ? 0 : 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                        break i;
                                    } else{
                                        $t = $$je;
                                        break h;
                                    }
                                }
                                oncipj_Cypher_jj_save($this, 33, 2);
                                break f;
                            }
                            try {
                                var$7 = 1;
                                break g;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                $t = $$je;

                            }
                        }
                        oncipj_Cypher_jj_save($this, 33, 2);
                        $rt_throw($t);
                    }
                    oncipj_Cypher_jj_save($this, 33, 2);
                }
                if (var$7) {
                    $v = oncipj_Cypher_Variable($this);
                    $properties = oncipj_Cypher_Properties($this);
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$8) {
                        case 334:
                            break;
                        default:
                            $this.$jj_la1.data[88] = $this.$jj_gen;
                            break e;
                    }
                    oncipj_Cypher_jj_consume_token($this, 334);
                    $predicate = oncipj_Cypher_Expression($this);
                } else {
                    $this.$jj_la = 2147483647;
                    var$6 = $this.$token;
                    $this.$jj_scanpos = var$6;
                    $this.$jj_lastpos = var$6;
                    j: {
                        k: {
                            l: {
                                m: {
                                    try {
                                        var$7 = oncipj_Cypher_jj_3_35($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break m;
                                        } else{
                                            $t = $$je;
                                            break l;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 34, 2147483647);
                                    break j;
                                }
                                try {
                                    var$7 = 1;
                                    break k;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $t = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 34, 2147483647);
                            $rt_throw($t);
                        }
                        oncipj_Cypher_jj_save($this, 34, 2147483647);
                    }
                    if (var$7) {
                        $v = oncipj_Cypher_Variable($this);
                        oncipj_Cypher_jj_consume_token($this, 334);
                        $predicate = oncipj_Cypher_Expression($this);
                    } else {
                        $this.$jj_la = 2147483647;
                        var$6 = $this.$token;
                        $this.$jj_scanpos = var$6;
                        $this.$jj_lastpos = var$6;
                        n: {
                            o: {
                                p: {
                                    q: {
                                        try {
                                            var$7 = oncipj_Cypher_jj_3_36($this) ? 0 : 1;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                break q;
                                            } else{
                                                $t = $$je;
                                                break p;
                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 35, 2147483647);
                                        break n;
                                    }
                                    try {
                                        var$7 = 1;
                                        break o;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        $t = $$je;

                                    }
                                }
                                oncipj_Cypher_jj_save($this, 35, 2147483647);
                                $rt_throw($t);
                            }
                            oncipj_Cypher_jj_save($this, 35, 2147483647);
                        }
                        if (var$7) {
                            oncipj_Cypher_jj_consume_token($this, 334);
                            $predicate = oncipj_Cypher_Expression($this);
                        } else {
                            $this.$jj_la = 3;
                            var$6 = $this.$token;
                            $this.$jj_scanpos = var$6;
                            $this.$jj_lastpos = var$6;
                            r: {
                                s: {
                                    t: {
                                        u: {
                                            try {
                                                var$7 = oncipj_Cypher_jj_3_37($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break u;
                                                } else{
                                                    $t = $$je;
                                                    break t;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 36, 3);
                                            break r;
                                        }
                                        try {
                                            var$7 = 1;
                                            break s;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $t = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 36, 3);
                                    $rt_throw($t);
                                }
                                oncipj_Cypher_jj_save($this, 36, 3);
                            }
                            if (var$7) {
                                $v = oncipj_Cypher_Variable($this);
                                $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_nodeType($this.$astFactory));
                                var$8 = $this.$jj_ntk;
                                if (var$8 == (-1))
                                    var$8 = oncipj_Cypher_jj_ntk_f($this);
                                v: {
                                    switch (var$8) {
                                        case 131:
                                        case 195:
                                            break;
                                        default:
                                            $this.$jj_la1.data[89] = $this.$jj_gen;
                                            break v;
                                    }
                                    $properties = oncipj_Cypher_Properties($this);
                                }
                                var$8 = $this.$jj_ntk;
                                if (var$8 == (-1))
                                    var$8 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$8) {
                                    case 334:
                                        break;
                                    default:
                                        $this.$jj_la1.data[90] = $this.$jj_gen;
                                        break e;
                                }
                                oncipj_Cypher_jj_consume_token($this, 334);
                                $predicate = oncipj_Cypher_Expression($this);
                            } else {
                                $this.$jj_la = 2147483647;
                                var$6 = $this.$token;
                                $this.$jj_scanpos = var$6;
                                $this.$jj_lastpos = var$6;
                                w: {
                                    x: {
                                        y: {
                                            z: {
                                                try {
                                                    var$7 = oncipj_Cypher_jj_3_38($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break z;
                                                    } else{
                                                        $t = $$je;
                                                        break y;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 37, 2147483647);
                                                break w;
                                            }
                                            try {
                                                var$7 = 1;
                                                break x;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $t = $$je;

                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 37, 2147483647);
                                        $rt_throw($t);
                                    }
                                    oncipj_Cypher_jj_save($this, 37, 2147483647);
                                }
                                if (!var$7) {
                                    var$8 = $this.$jj_ntk;
                                    if (var$8 == (-1))
                                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$8) {
                                        case 101:
                                        case 187:
                                            break;
                                        default:
                                            $this.$jj_la1.data[92] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $t = new oncipj_ParseException;
                                            jl_Throwable__init_0($t);
                                            $rt_throw($t);
                                    }
                                    $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_nodeType($this.$astFactory));
                                } else {
                                    $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_nodeType($this.$astFactory));
                                    $properties = oncipj_Cypher_Properties($this);
                                    var$8 = $this.$jj_ntk;
                                    if (var$8 == (-1))
                                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$8) {
                                        case 334:
                                            break;
                                        default:
                                            $this.$jj_la1.data[91] = $this.$jj_gen;
                                            break e;
                                    }
                                    oncipj_Cypher_jj_consume_token($this, 334);
                                    $predicate = oncipj_Cypher_Expression($this);
                                }
                            }
                        }
                    }
                }
            }
        }
        oncipj_Cypher_jj_consume_token($this, 275);
        return onciafn_Neo4jASTFactory_nodePattern($this.$astFactory, oncipj_Cypher_pos($this, $t), $v, $labelExpression, $properties, $predicate);
    }
    function oncipj_Cypher_NodeLabels($this) {
        var $labels, $label, var$3, $$je;
        $labels = ju_ArrayList__init_();
        a: {
            while (true) {
                $label = oncipj_Cypher_LabelOrRelType($this);
                ju_ArrayList_add($labels, onciaf_ASTFactory$StringPos__init_($label.$image0, oncipj_Cypher_pos($this, $label)));
                $this.$jj_la = 2;
                $label = $this.$token;
                $this.$jj_scanpos = $label;
                $this.$jj_lastpos = $label;
                b: {
                    c: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_39($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break c;
                            } else{
                                $labels = $$je;
                                break a;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 38, 2);
                        break b;
                    }
                    try {
                        var$3 = 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $labels = $$je;
                        break a;

                    }
                    oncipj_Cypher_jj_save($this, 38, 2);
                }
                if (!var$3)
                    break;
            }
            return $labels;
        }
        oncipj_Cypher_jj_save($this, 38, 2);
        $rt_throw($labels);
    }
    function oncipj_Cypher_LabelExpressionPredicate($this, $subject) {
        var var$2;
        oncipj_EntityType_$callClinit();
        var$2 = oncipj_Cypher_LabelExpression($this, oncipj_EntityType_NODE_OR_RELATIONSHIP);
        $subject = $subject;
        return oncil_LabelExpressionPredicate__init_($subject, var$2, $subject.$position2());
    }
    function oncipj_Cypher_LabelOrRelType($this) {
        oncipj_Cypher_jj_consume_token($this, 101);
        return oncipj_Cypher_SymbolicNameString($this);
    }
    function oncipj_Cypher_LabelOrRelTypes($this) {
        var $labels, var$2, var$3, var$4;
        $labels = ju_ArrayList__init_();
        oncipj_Cypher_jj_consume_token($this, 101);
        oncipj_Cypher_SymbolicNameString($this);
        var$2 = new onciaf_ASTFactory$StringPos;
        var$3 = $this.$token;
        onciaf_ASTFactory$StringPos__init_0(var$2, var$3.$image0, oncipj_Cypher_pos($this, var$3));
        ju_ArrayList_add($labels, var$2);
        a: while (true) {
            var$4 = $this.$jj_ntk;
            if (var$4 == (-1))
                var$4 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$4) {
                case 86:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 86);
            oncipj_Cypher_SymbolicNameString($this);
            var$2 = new onciaf_ASTFactory$StringPos;
            var$3 = $this.$token;
            onciaf_ASTFactory$StringPos__init_0(var$2, var$3.$image0, oncipj_Cypher_pos($this, var$3));
            ju_ArrayList_add($labels, var$2);
        }
        $this.$jj_la1.data[95] = $this.$jj_gen;
        return $labels;
    }
    function oncipj_Cypher_Properties($this) {
        var $e, var$2, var$3, $$je;
        $this.$jj_la = 3;
        $e = $this.$token;
        $this.$jj_scanpos = $e;
        $this.$jj_lastpos = $e;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_40($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $e = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 39, 3);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $e = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 39, 3);
                $rt_throw($e);
            }
            oncipj_Cypher_jj_save($this, 39, 3);
        }
        if (var$2)
            $e = oncipj_Cypher_MapLiteral($this);
        else {
            var$3 = $this.$jj_ntk;
            if (var$3 == (-1))
                var$3 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$3) {
                case 131:
                    break;
                default:
                    $this.$jj_la1.data[96] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $e = new oncipj_ParseException;
                    jl_Throwable__init_0($e);
                    $rt_throw($e);
            }
            onciaf_ParameterType_$callClinit();
            $e = oncipj_Cypher_Parameter($this, onciaf_ParameterType_ANY);
        }
        return $e;
    }
    function oncipj_Cypher_RelationshipPattern($this) {
        var $firstToken, $left, var$3, var$4, var$5, $r, var$7, $$je;
        $firstToken = $this.$token;
        $left = 0;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 203:
                case 345:
                    break;
                default:
                    $this.$jj_la1.data[97] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_LeftArrow($this);
            $left = 1;
        }
        b: {
            c: {
                oncipj_Cypher_ArrowLine($this);
                if (oncipj_Cypher_jj_2_48($this, 2147483647)) {
                    var$4 = 0;
                    oncipj_Cypher_ArrowLine($this);
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    d: {
                        switch (var$5) {
                            case 174:
                            case 346:
                                break;
                            default:
                                $this.$jj_la1.data[100] = $this.$jj_gen;
                                break d;
                        }
                        oncipj_Cypher_RightArrow($this);
                        var$4 = 1;
                    }
                    $r = onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, var$4, null, null, null, null, null);
                } else {
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$4) {
                        case 194:
                            oncipj_Cypher_jj_consume_token($this, 194);
                            $this.$jj_la = 2147483647;
                            $r = $this.$token;
                            $this.$jj_scanpos = $r;
                            $this.$jj_lastpos = $r;
                            e: {
                                f: {
                                    g: {
                                        h: {
                                            try {
                                                var$5 = oncipj_Cypher_jj_3_41($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break h;
                                                } else{
                                                    $firstToken = $$je;
                                                    break g;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 40, 2147483647);
                                            break e;
                                        }
                                        try {
                                            var$5 = 1;
                                            break f;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $firstToken = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 40, 2147483647);
                                    $rt_throw($firstToken);
                                }
                                oncipj_Cypher_jj_save($this, 40, 2147483647);
                            }
                            if (var$5) {
                                var$5 = 0;
                                oncipj_Cypher_jj_consume_token($this, 254);
                                oncipj_Cypher_ArrowLine($this);
                                var$4 = $this.$jj_ntk;
                                if (var$4 == (-1))
                                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                                i: {
                                    switch (var$4) {
                                        case 174:
                                        case 346:
                                            break;
                                        default:
                                            $this.$jj_la1.data[101] = $this.$jj_gen;
                                            break i;
                                    }
                                    oncipj_Cypher_RightArrow($this);
                                    var$5 = 1;
                                }
                                $r = onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, var$5, null, null, null, null, null);
                                break c;
                            }
                            $this.$jj_la = 2147483647;
                            $r = $this.$token;
                            $this.$jj_scanpos = $r;
                            $this.$jj_lastpos = $r;
                            j: {
                                k: {
                                    l: {
                                        m: {
                                            try {
                                                var$5 = oncipj_Cypher_jj_3_42($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break m;
                                                } else{
                                                    $firstToken = $$je;
                                                    break l;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 41, 2147483647);
                                            break j;
                                        }
                                        try {
                                            var$5 = 1;
                                            break k;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $firstToken = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 41, 2147483647);
                                    $rt_throw($firstToken);
                                }
                                oncipj_Cypher_jj_save($this, 41, 2147483647);
                            }
                            if (var$5) {
                                var$4 = 0;
                                var$7 = oncipj_Cypher_Variable($this);
                                oncipj_Cypher_jj_consume_token($this, 254);
                                oncipj_Cypher_ArrowLine($this);
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                n: {
                                    switch (var$3) {
                                        case 174:
                                        case 346:
                                            break;
                                        default:
                                            $this.$jj_la1.data[102] = $this.$jj_gen;
                                            break n;
                                    }
                                    oncipj_Cypher_RightArrow($this);
                                    var$4 = 1;
                                }
                                $r = onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, var$4, var$7, null, null, null, null);
                                break c;
                            }
                            $this.$jj_la = 2147483647;
                            $r = $this.$token;
                            $this.$jj_scanpos = $r;
                            $this.$jj_lastpos = $r;
                            o: {
                                p: {
                                    q: {
                                        r: {
                                            try {
                                                var$3 = oncipj_Cypher_jj_3_43($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break r;
                                                } else{
                                                    $firstToken = $$je;
                                                    break q;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 42, 2147483647);
                                            break o;
                                        }
                                        try {
                                            var$3 = 1;
                                            break p;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $firstToken = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 42, 2147483647);
                                    $rt_throw($firstToken);
                                }
                                oncipj_Cypher_jj_save($this, 42, 2147483647);
                            }
                            if (var$3) {
                                $r = oncipj_Cypher_RelationshipPatternColon($this, $firstToken, $left);
                                break c;
                            }
                            $this.$jj_la = 2147483647;
                            $r = $this.$token;
                            $this.$jj_scanpos = $r;
                            $this.$jj_lastpos = $r;
                            s: {
                                t: {
                                    u: {
                                        v: {
                                            try {
                                                var$3 = oncipj_Cypher_jj_3_44($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break v;
                                                } else{
                                                    $firstToken = $$je;
                                                    break u;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 43, 2147483647);
                                            break s;
                                        }
                                        try {
                                            var$3 = 1;
                                            break t;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $firstToken = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 43, 2147483647);
                                    $rt_throw($firstToken);
                                }
                                oncipj_Cypher_jj_save($this, 43, 2147483647);
                            }
                            if (var$3) {
                                $r = oncipj_Cypher_RelationshipPatternVariableColon($this, $firstToken, $left);
                                break c;
                            }
                            $this.$jj_la = 2147483647;
                            $r = $this.$token;
                            $this.$jj_scanpos = $r;
                            $this.$jj_lastpos = $r;
                            w: {
                                x: {
                                    y: {
                                        z: {
                                            try {
                                                var$3 = oncipj_Cypher_jj_3_45($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break z;
                                                } else{
                                                    $firstToken = $$je;
                                                    break y;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 44, 2147483647);
                                            break w;
                                        }
                                        try {
                                            var$3 = 1;
                                            break x;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $firstToken = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 44, 2147483647);
                                    $rt_throw($firstToken);
                                }
                                oncipj_Cypher_jj_save($this, 44, 2147483647);
                            }
                            if (var$3) {
                                $r = oncipj_Cypher_RelationshipPatternProperties($this, $firstToken, $left);
                                break c;
                            }
                            $this.$jj_la = 2147483647;
                            $r = $this.$token;
                            $this.$jj_scanpos = $r;
                            $this.$jj_lastpos = $r;
                            ba: {
                                bb: {
                                    bc: {
                                        bd: {
                                            try {
                                                var$3 = oncipj_Cypher_jj_3_46($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break bd;
                                                } else{
                                                    $firstToken = $$je;
                                                    break bc;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 45, 2147483647);
                                            break ba;
                                        }
                                        try {
                                            var$3 = 1;
                                            break bb;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $firstToken = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 45, 2147483647);
                                    $rt_throw($firstToken);
                                }
                                oncipj_Cypher_jj_save($this, 45, 2147483647);
                            }
                            if (var$3) {
                                $r = oncipj_Cypher_RelationshipPatternPathLength($this, $firstToken, $left);
                                break c;
                            }
                            if (oncipj_Cypher_jj_2_47($this, 2147483647)) {
                                $r = oncipj_Cypher_RelationshipPatternOnlyVariablePathLength($this, $firstToken, $left);
                                break c;
                            }
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 101:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    break;
                                case 86:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                case 307:
                                    break b;
                                default:
                                    break b;
                            }
                            $r = oncipj_Cypher_RelationshipPatternComplex($this, $firstToken, $left);
                            break c;
                        default:
                    }
                    $this.$jj_la1.data[99] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $firstToken = new oncipj_ParseException;
                    jl_Throwable__init_0($firstToken);
                    $rt_throw($firstToken);
                }
            }
            return $r;
        }
        $this.$jj_la1.data[98] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $firstToken = new oncipj_ParseException;
        jl_Throwable__init_0($firstToken);
        $rt_throw($firstToken);
    }
    function oncipj_Cypher_RelationshipPatternColon($this, $firstToken, $left) {
        var $right, $pathLength, $properties, $predicate, var$7, var$8;
        $right = 0;
        $pathLength = null;
        $properties = null;
        $predicate = null;
        var$7 = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_relationshipType($this.$astFactory));
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 307:
                    break;
                default:
                    $this.$jj_la1.data[103] = $this.$jj_gen;
                    break a;
            }
            $pathLength = oncipj_Cypher_PathLength($this);
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$8) {
                case 131:
                case 195:
                    break;
                default:
                    $this.$jj_la1.data[104] = $this.$jj_gen;
                    break b;
            }
            $properties = oncipj_Cypher_Properties($this);
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$8) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[105] = $this.$jj_gen;
                    break c;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $predicate = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 254);
        oncipj_Cypher_ArrowLine($this);
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        d: {
            switch (var$8) {
                case 174:
                case 346:
                    break;
                default:
                    $this.$jj_la1.data[106] = $this.$jj_gen;
                    break d;
            }
            oncipj_Cypher_RightArrow($this);
            $right = 1;
        }
        return onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, $right, null, var$7, $pathLength, $properties, $predicate);
    }
    function oncipj_Cypher_RelationshipPatternVariableColon($this, $firstToken, $left) {
        var $right, $pathLength, $properties, $predicate, var$7, var$8, var$9, var$10;
        $right = 0;
        $pathLength = null;
        $properties = null;
        $predicate = null;
        var$7 = oncipj_Cypher_Variable($this);
        var$8 = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_relationshipType($this.$astFactory));
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$9) {
                case 307:
                    break;
                default:
                    $this.$jj_la1.data[107] = $this.$jj_gen;
                    break a;
            }
            $pathLength = oncipj_Cypher_PathLength($this);
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$10) {
                case 131:
                case 195:
                    break;
                default:
                    $this.$jj_la1.data[108] = $this.$jj_gen;
                    break b;
            }
            $properties = oncipj_Cypher_Properties($this);
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$9) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[109] = $this.$jj_gen;
                    break c;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $predicate = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 254);
        oncipj_Cypher_ArrowLine($this);
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        d: {
            switch (var$10) {
                case 174:
                case 346:
                    break;
                default:
                    $this.$jj_la1.data[110] = $this.$jj_gen;
                    break d;
            }
            oncipj_Cypher_RightArrow($this);
            $right = 1;
        }
        return onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, $right, var$7, var$8, $pathLength, $properties, $predicate);
    }
    function oncipj_Cypher_RelationshipPatternProperties($this, $firstToken, $left) {
        var $right, $predicate, var$5, var$6, var$7;
        $right = 0;
        $predicate = null;
        var$5 = oncipj_Cypher_Properties($this);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[111] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $predicate = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 254);
        oncipj_Cypher_ArrowLine($this);
        var$7 = $this.$jj_ntk;
        if (var$7 == (-1))
            var$7 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$7) {
                case 174:
                case 346:
                    break;
                default:
                    $this.$jj_la1.data[112] = $this.$jj_gen;
                    break b;
            }
            oncipj_Cypher_RightArrow($this);
            $right = 1;
        }
        return onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, $right, null, null, null, var$5, $predicate);
    }
    function oncipj_Cypher_RelationshipPatternPathLength($this, $firstToken, $left) {
        var $right, $properties, $predicate, var$6, var$7, var$8;
        $right = 0;
        $properties = null;
        $predicate = null;
        var$6 = oncipj_Cypher_PathLength($this);
        var$7 = $this.$jj_ntk;
        if (var$7 == (-1))
            var$7 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$7) {
                case 131:
                case 195:
                    break;
                default:
                    $this.$jj_la1.data[113] = $this.$jj_gen;
                    break a;
            }
            $properties = oncipj_Cypher_Properties($this);
        }
        var$7 = $this.$jj_ntk;
        if (var$7 == (-1))
            var$7 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$7) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[114] = $this.$jj_gen;
                    break b;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $predicate = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 254);
        oncipj_Cypher_ArrowLine($this);
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$8) {
                case 174:
                case 346:
                    break;
                default:
                    $this.$jj_la1.data[115] = $this.$jj_gen;
                    break c;
            }
            oncipj_Cypher_RightArrow($this);
            $right = 1;
        }
        return onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, $right, null, null, var$6, $properties, $predicate);
    }
    function oncipj_Cypher_RelationshipPatternOnlyVariablePathLength($this, $firstToken, $left) {
        var $right, var$4, var$5, var$6;
        $right = 0;
        var$4 = oncipj_Cypher_Variable($this);
        var$5 = oncipj_Cypher_PathLength($this);
        oncipj_Cypher_jj_consume_token($this, 254);
        oncipj_Cypher_ArrowLine($this);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 174:
                case 346:
                    break;
                default:
                    $this.$jj_la1.data[116] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_RightArrow($this);
            $right = 1;
        }
        return onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, $right, var$4, null, var$5, null, null);
    }
    function oncipj_Cypher_RelationshipPatternComplex($this, $firstToken, $left) {
        var $right, $v, $labelExpression, $pathLength, $properties, $predicate, var$9, var$10, var$11, $$je;
        $right = 0;
        $v = null;
        $labelExpression = null;
        $pathLength = null;
        $properties = null;
        $predicate = null;
        $this.$jj_la = 2147483647;
        var$9 = $this.$token;
        $this.$jj_scanpos = var$9;
        $this.$jj_lastpos = var$9;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$10 = oncipj_Cypher_jj_3_49($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $firstToken = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 48, 2147483647);
                        break a;
                    }
                    try {
                        var$10 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $firstToken = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 48, 2147483647);
                $rt_throw($firstToken);
            }
            oncipj_Cypher_jj_save($this, 48, 2147483647);
        }
        e: {
            if (var$10) {
                $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_relationshipType($this.$astFactory));
                var$11 = $this.$jj_ntk;
                if (var$11 == (-1))
                    var$11 = oncipj_Cypher_jj_ntk_f($this);
                f: {
                    switch (var$11) {
                        case 307:
                            break;
                        default:
                            $this.$jj_la1.data[117] = $this.$jj_gen;
                            break f;
                    }
                    $pathLength = oncipj_Cypher_PathLength($this);
                }
                oncipj_Cypher_jj_consume_token($this, 334);
                $predicate = oncipj_Cypher_Expression($this);
            } else {
                $this.$jj_la = 2147483647;
                var$9 = $this.$token;
                $this.$jj_scanpos = var$9;
                $this.$jj_lastpos = var$9;
                g: {
                    h: {
                        i: {
                            j: {
                                try {
                                    var$10 = oncipj_Cypher_jj_3_50($this) ? 0 : 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                        break j;
                                    } else{
                                        $firstToken = $$je;
                                        break i;
                                    }
                                }
                                oncipj_Cypher_jj_save($this, 49, 2147483647);
                                break g;
                            }
                            try {
                                var$10 = 1;
                                break h;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                $firstToken = $$je;

                            }
                        }
                        oncipj_Cypher_jj_save($this, 49, 2147483647);
                        $rt_throw($firstToken);
                    }
                    oncipj_Cypher_jj_save($this, 49, 2147483647);
                }
                if (var$10) {
                    $v = oncipj_Cypher_Variable($this);
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    k: {
                        switch (var$11) {
                            case 307:
                                break;
                            default:
                                $this.$jj_la1.data[118] = $this.$jj_gen;
                                break k;
                        }
                        $pathLength = oncipj_Cypher_PathLength($this);
                    }
                    $properties = oncipj_Cypher_Properties($this);
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$11) {
                        case 334:
                            break;
                        default:
                            $this.$jj_la1.data[119] = $this.$jj_gen;
                            break e;
                    }
                    oncipj_Cypher_jj_consume_token($this, 334);
                    $predicate = oncipj_Cypher_Expression($this);
                } else if (oncipj_Cypher_jj_2_51($this, 2147483647)) {
                    $v = oncipj_Cypher_Variable($this);
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    l: {
                        switch (var$11) {
                            case 307:
                                break;
                            default:
                                $this.$jj_la1.data[120] = $this.$jj_gen;
                                break l;
                        }
                        $pathLength = oncipj_Cypher_PathLength($this);
                    }
                    oncipj_Cypher_jj_consume_token($this, 334);
                    $predicate = oncipj_Cypher_Expression($this);
                } else if (oncipj_Cypher_jj_2_52($this, 2147483647)) {
                    oncipj_Cypher_jj_consume_token($this, 334);
                    $predicate = oncipj_Cypher_Expression($this);
                } else if (!oncipj_Cypher_jj_2_53($this, 3)) {
                    if (!oncipj_Cypher_jj_2_54($this, 2147483647)) {
                        var$11 = $this.$jj_ntk;
                        if (var$11 == (-1))
                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$11) {
                            case 101:
                            case 187:
                                $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_relationshipType($this.$astFactory));
                                var$11 = $this.$jj_ntk;
                                if (var$11 == (-1))
                                    var$11 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$11) {
                                    case 307:
                                        break;
                                    default:
                                        $this.$jj_la1.data[126] = $this.$jj_gen;
                                        break e;
                                }
                                $pathLength = oncipj_Cypher_PathLength($this);
                                break e;
                            default:
                        }
                        $this.$jj_la1.data[127] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $firstToken = new oncipj_ParseException;
                        jl_Exception__init_0($firstToken);
                        $rt_throw($firstToken);
                    }
                    $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_relationshipType($this.$astFactory));
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    m: {
                        switch (var$11) {
                            case 307:
                                break;
                            default:
                                $this.$jj_la1.data[124] = $this.$jj_gen;
                                break m;
                        }
                        $pathLength = oncipj_Cypher_PathLength($this);
                    }
                    $properties = oncipj_Cypher_Properties($this);
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$11) {
                        case 334:
                            break;
                        default:
                            $this.$jj_la1.data[125] = $this.$jj_gen;
                            break e;
                    }
                    oncipj_Cypher_jj_consume_token($this, 334);
                    $predicate = oncipj_Cypher_Expression($this);
                } else {
                    $v = oncipj_Cypher_Variable($this);
                    $labelExpression = oncipj_Cypher_LabelExpression($this, onciafn_Neo4jASTFactory_relationshipType($this.$astFactory));
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    n: {
                        switch (var$11) {
                            case 307:
                                break;
                            default:
                                $this.$jj_la1.data[121] = $this.$jj_gen;
                                break n;
                        }
                        $pathLength = oncipj_Cypher_PathLength($this);
                    }
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    o: {
                        switch (var$11) {
                            case 131:
                            case 195:
                                break;
                            default:
                                $this.$jj_la1.data[122] = $this.$jj_gen;
                                break o;
                        }
                        $properties = oncipj_Cypher_Properties($this);
                    }
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$11) {
                        case 334:
                            break;
                        default:
                            $this.$jj_la1.data[123] = $this.$jj_gen;
                            break e;
                    }
                    oncipj_Cypher_jj_consume_token($this, 334);
                    $predicate = oncipj_Cypher_Expression($this);
                }
            }
        }
        oncipj_Cypher_jj_consume_token($this, 254);
        oncipj_Cypher_ArrowLine($this);
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        p: {
            switch (var$11) {
                case 174:
                case 346:
                    break;
                default:
                    $this.$jj_la1.data[128] = $this.$jj_gen;
                    break p;
            }
            oncipj_Cypher_RightArrow($this);
            $right = 1;
        }
        return onciafn_Neo4jASTFactory_relationshipPattern($this.$astFactory, oncipj_Cypher_pos($this, $firstToken.$next1), $left, $right, $v, $labelExpression, $pathLength, $properties, $predicate);
    }
    function oncipj_Cypher_LeftArrow($this) {
        var var$1, var$2;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 203:
                    break;
                case 345:
                    oncipj_Cypher_jj_consume_token($this, 345);
                    break a;
                default:
                    $this.$jj_la1.data[129] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    var$2 = new oncipj_ParseException;
                    jl_Throwable__init_0(var$2);
                    $rt_throw(var$2);
            }
            oncipj_Cypher_jj_consume_token($this, 203);
        }
    }
    function oncipj_Cypher_ArrowLine($this) {
        var var$1, var$2;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 208:
                    break;
                case 344:
                    oncipj_Cypher_jj_consume_token($this, 344);
                    break a;
                default:
                    $this.$jj_la1.data[130] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    var$2 = new oncipj_ParseException;
                    jl_Throwable__init_0(var$2);
                    $rt_throw(var$2);
            }
            oncipj_Cypher_jj_consume_token($this, 208);
        }
    }
    function oncipj_Cypher_RightArrow($this) {
        var var$1, var$2;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 174:
                    break;
                case 346:
                    oncipj_Cypher_jj_consume_token($this, 346);
                    break a;
                default:
                    $this.$jj_la1.data[131] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    var$2 = new oncipj_ParseException;
                    jl_Throwable__init_0(var$2);
                    $rt_throw(var$2);
            }
            oncipj_Cypher_jj_consume_token($this, 174);
        }
    }
    function oncipj_Cypher_PathLength($this) {
        var $p, $t, var$3, var$4, var$5, var$6, var$7, $$je;
        $p = null;
        $t = oncipj_Cypher_jj_consume_token($this, 307);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 36:
                case 136:
                    $p = null;
                    var$4 = null;
                    $this.$jj_la = 2;
                    var$5 = $this.$token;
                    $this.$jj_scanpos = var$5;
                    $this.$jj_lastpos = var$5;
                    b: {
                        c: {
                            d: {
                                e: {
                                    try {
                                        var$6 = oncipj_Cypher_jj_3_55($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break e;
                                        } else{
                                            $p = $$je;
                                            break d;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 54, 2);
                                    break b;
                                }
                                try {
                                    var$6 = 1;
                                    break c;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $p = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 54, 2);
                            $rt_throw($p);
                        }
                        oncipj_Cypher_jj_save($this, 54, 2);
                    }
                    f: {
                        if (!var$6) {
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 36:
                                    $p = oncipj_Cypher_jj_consume_token($this, 36);
                                    var$5 = $p !== null ? $p.$image0 : $rt_s(3);
                                    $p = onciafn_Neo4jASTFactory_pathLength($this.$astFactory, oncipj_Cypher_pos($this, $t), $p !== null ? oncipj_Cypher_pos($this, $p) : null, $p !== null ? oncipj_Cypher_pos($this, $p) : null, var$5, var$5);
                                    break f;
                                default:
                            }
                            $this.$jj_la1.data[135] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $p = new oncipj_ParseException;
                            jl_Throwable__init_0($p);
                            $rt_throw($p);
                        }
                        var$3 = $this.$jj_ntk;
                        if (var$3 == (-1))
                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                        g: {
                            switch (var$3) {
                                case 36:
                                    break;
                                default:
                                    $this.$jj_la1.data[133] = $this.$jj_gen;
                                    break g;
                            }
                            $p = oncipj_Cypher_jj_consume_token($this, 36);
                        }
                        var$7 = oncipj_Cypher_jj_consume_token($this, 136);
                        var$3 = $this.$jj_ntk;
                        if (var$3 == (-1))
                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                        h: {
                            switch (var$3) {
                                case 36:
                                    break;
                                default:
                                    $this.$jj_la1.data[134] = $this.$jj_gen;
                                    break h;
                            }
                            var$4 = oncipj_Cypher_jj_consume_token($this, 36);
                        }
                        $p = onciafn_Neo4jASTFactory_pathLength($this.$astFactory, oncipj_Cypher_pos($this, var$7), $p !== null ? oncipj_Cypher_pos($this, $p) : null, var$4 !== null ? oncipj_Cypher_pos($this, var$4) : null, $p !== null ? $p.$image0 : $rt_s(3), var$4 !== null ? var$4.$image0 : $rt_s(3));
                    }
                    break a;
                default:
            }
            $this.$jj_la1.data[132] = $this.$jj_gen;
        }
        if ($p === null)
            $p = onciafn_Neo4jASTFactory_pathLength($this.$astFactory, oncipj_Cypher_pos($this, $t), null, null, null, null);
        return $p;
    }
    function oncipj_Cypher_LabelExpression($this, $type) {
        var var$2, $e, var$4, var$5, var$6, var$7, $$je;
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$2) {
                    case 101:
                        oncipj_Cypher_jj_consume_token($this, 101);
                        if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                            $e = ju_Stack_peek($this.$labelExpressionStack);
                            oncipj_ExpectBar_$callClinit();
                            if ($e === oncipj_ExpectBar_EXPECT_BAR) {
                                $e = oncipj_Cypher_LabelExpression3($this, $type);
                                c: {
                                    d: while (true) {
                                        $this.$jj_la = 2147483647;
                                        var$4 = $this.$token;
                                        $this.$jj_scanpos = var$4;
                                        $this.$jj_lastpos = var$4;
                                        e: {
                                            f: {
                                                try {
                                                    var$2 = oncipj_Cypher_jj_3_58($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break f;
                                                    } else{
                                                        $type = $$je;
                                                        break d;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 57, 2147483647);
                                                break e;
                                            }
                                            try {
                                                var$2 = 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $type = $$je;
                                                break d;

                                            }
                                            oncipj_Cypher_jj_save($this, 57, 2147483647);
                                        }
                                        if (!var$2)
                                            break b;
                                        var$4 = oncipj_Cypher_jj_consume_token($this, 86);
                                        var$5 = $this.$jj_ntk;
                                        if (var$5 == (-1))
                                            var$5 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$5) {
                                            case 68:
                                            case 69:
                                            case 70:
                                            case 71:
                                            case 72:
                                            case 73:
                                            case 74:
                                            case 75:
                                            case 76:
                                            case 77:
                                            case 78:
                                            case 79:
                                            case 80:
                                            case 81:
                                            case 82:
                                            case 83:
                                            case 84:
                                            case 85:
                                            case 87:
                                            case 88:
                                            case 89:
                                            case 90:
                                            case 91:
                                            case 92:
                                            case 93:
                                            case 94:
                                            case 95:
                                            case 96:
                                            case 97:
                                            case 98:
                                            case 99:
                                            case 100:
                                            case 104:
                                            case 105:
                                            case 106:
                                            case 107:
                                            case 108:
                                            case 109:
                                            case 110:
                                            case 111:
                                            case 112:
                                            case 113:
                                            case 114:
                                            case 115:
                                            case 116:
                                            case 117:
                                            case 118:
                                            case 119:
                                            case 120:
                                            case 121:
                                            case 122:
                                            case 123:
                                            case 124:
                                            case 125:
                                            case 126:
                                            case 127:
                                            case 128:
                                            case 129:
                                            case 130:
                                            case 132:
                                            case 133:
                                            case 137:
                                            case 138:
                                            case 139:
                                            case 140:
                                            case 141:
                                            case 142:
                                            case 143:
                                            case 144:
                                            case 145:
                                            case 146:
                                            case 147:
                                            case 148:
                                            case 149:
                                            case 150:
                                            case 152:
                                            case 153:
                                            case 154:
                                            case 155:
                                            case 156:
                                            case 157:
                                            case 158:
                                            case 159:
                                            case 160:
                                            case 161:
                                            case 162:
                                            case 163:
                                            case 164:
                                            case 165:
                                            case 166:
                                            case 167:
                                            case 169:
                                            case 170:
                                            case 171:
                                            case 172:
                                            case 173:
                                            case 175:
                                            case 176:
                                            case 177:
                                            case 179:
                                            case 180:
                                            case 181:
                                            case 182:
                                            case 183:
                                            case 184:
                                            case 185:
                                            case 186:
                                            case 187:
                                            case 188:
                                            case 189:
                                            case 190:
                                            case 191:
                                            case 193:
                                            case 197:
                                            case 198:
                                            case 199:
                                            case 200:
                                            case 201:
                                            case 202:
                                            case 204:
                                            case 205:
                                            case 206:
                                            case 207:
                                            case 209:
                                            case 212:
                                            case 213:
                                            case 214:
                                            case 215:
                                            case 216:
                                            case 217:
                                            case 218:
                                            case 219:
                                            case 220:
                                            case 221:
                                            case 222:
                                            case 223:
                                            case 224:
                                            case 225:
                                            case 226:
                                            case 227:
                                            case 228:
                                            case 229:
                                            case 230:
                                            case 231:
                                            case 232:
                                            case 233:
                                            case 234:
                                            case 235:
                                            case 236:
                                            case 237:
                                            case 240:
                                            case 241:
                                            case 243:
                                            case 244:
                                            case 245:
                                            case 246:
                                            case 247:
                                            case 248:
                                            case 249:
                                            case 250:
                                            case 251:
                                            case 253:
                                            case 256:
                                            case 257:
                                            case 258:
                                            case 259:
                                            case 261:
                                            case 262:
                                            case 263:
                                            case 264:
                                            case 265:
                                            case 266:
                                            case 267:
                                            case 268:
                                            case 269:
                                            case 270:
                                            case 271:
                                            case 272:
                                            case 273:
                                            case 274:
                                            case 276:
                                            case 277:
                                            case 278:
                                            case 279:
                                            case 280:
                                            case 281:
                                            case 282:
                                            case 284:
                                            case 285:
                                            case 286:
                                            case 287:
                                            case 288:
                                            case 289:
                                            case 290:
                                            case 291:
                                            case 292:
                                            case 293:
                                            case 294:
                                            case 295:
                                            case 296:
                                            case 297:
                                            case 298:
                                            case 299:
                                            case 300:
                                            case 301:
                                            case 302:
                                            case 303:
                                            case 304:
                                            case 305:
                                            case 306:
                                            case 308:
                                            case 309:
                                            case 310:
                                            case 311:
                                            case 312:
                                            case 313:
                                            case 314:
                                            case 315:
                                            case 316:
                                            case 317:
                                            case 318:
                                            case 319:
                                            case 320:
                                            case 321:
                                            case 322:
                                            case 323:
                                            case 324:
                                            case 325:
                                            case 326:
                                            case 327:
                                            case 328:
                                            case 329:
                                            case 330:
                                            case 331:
                                            case 332:
                                            case 333:
                                            case 334:
                                            case 335:
                                            case 336:
                                            case 337:
                                            case 338:
                                            case 339:
                                            case 340:
                                            case 341:
                                                break;
                                            case 86:
                                            case 102:
                                            case 103:
                                            case 131:
                                            case 134:
                                            case 135:
                                            case 136:
                                            case 151:
                                            case 168:
                                            case 174:
                                            case 178:
                                            case 192:
                                            case 194:
                                            case 195:
                                            case 196:
                                            case 203:
                                            case 208:
                                            case 210:
                                            case 211:
                                            case 238:
                                            case 239:
                                            case 242:
                                            case 252:
                                            case 254:
                                            case 255:
                                            case 260:
                                            case 275:
                                            case 283:
                                            case 307:
                                                break c;
                                            case 101:
                                                oncipj_Cypher_jj_consume_token($this, 101);
                                                var$6 = oncipj_Cypher_LabelExpression3($this, $type);
                                                $e = onciafn_Neo4jASTFactory_labelColonDisjunction($this.$astFactory, oncipj_Cypher_pos($this, var$4), $e, var$6, 0);
                                                continue d;
                                            default:
                                                break c;
                                        }
                                        var$6 = oncipj_Cypher_LabelExpression3($this, $type);
                                        $e = onciafn_Neo4jASTFactory_labelDisjunction($this.$astFactory, oncipj_Cypher_pos($this, var$4), $e, var$6, 0);
                                    }
                                    oncipj_Cypher_jj_save($this, 57, 2147483647);
                                    $rt_throw($type);
                                }
                                $this.$jj_la1.data[139] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $type = new oncipj_ParseException;
                                jl_Throwable__init_0($type);
                                $rt_throw($type);
                            }
                        }
                        if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                            $e = ju_Stack_peek($this.$labelExpressionStack);
                            oncipj_ExpectBar_$callClinit();
                            if ($e !== oncipj_ExpectBar_DO_NOT_EXPECT_BAR) {
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $type = new oncipj_ParseException;
                                jl_Throwable__init_0($type);
                                $rt_throw($type);
                            }
                        }
                        $e = oncipj_Cypher_LabelExpression4($this, $type);
                        break b;
                    case 187:
                        oncipj_Cypher_jj_consume_token($this, 187);
                        if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                            $e = ju_Stack_peek($this.$labelExpressionStack);
                            oncipj_ExpectBar_$callClinit();
                            if ($e === oncipj_ExpectBar_EXPECT_BAR) {
                                $e = oncipj_Cypher_LabelExpression3Is($this, $type);
                                g: while (true) {
                                    $this.$jj_la = 2147483647;
                                    var$4 = $this.$token;
                                    $this.$jj_scanpos = var$4;
                                    $this.$jj_lastpos = var$4;
                                    h: {
                                        i: {
                                            try {
                                                var$2 = oncipj_Cypher_jj_3_59($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break i;
                                                } else{
                                                    $type = $$je;
                                                    break g;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 58, 2147483647);
                                            break h;
                                        }
                                        try {
                                            var$2 = 1;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $type = $$je;
                                            break g;

                                        }
                                        oncipj_Cypher_jj_save($this, 58, 2147483647);
                                    }
                                    if (!var$2)
                                        break b;
                                    var$4 = oncipj_Cypher_jj_consume_token($this, 86);
                                    var$5 = $this.$jj_ntk;
                                    if (var$5 == (-1))
                                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$5) {
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 71:
                                        case 72:
                                        case 73:
                                        case 74:
                                        case 75:
                                        case 76:
                                        case 77:
                                        case 78:
                                        case 79:
                                        case 80:
                                        case 81:
                                        case 82:
                                        case 83:
                                        case 84:
                                        case 85:
                                        case 87:
                                        case 88:
                                        case 89:
                                        case 90:
                                        case 91:
                                        case 92:
                                        case 93:
                                        case 94:
                                        case 95:
                                        case 96:
                                        case 97:
                                        case 98:
                                        case 99:
                                        case 100:
                                        case 104:
                                        case 105:
                                        case 106:
                                        case 107:
                                        case 108:
                                        case 109:
                                        case 110:
                                        case 111:
                                        case 112:
                                        case 113:
                                        case 114:
                                        case 115:
                                        case 116:
                                        case 117:
                                        case 118:
                                        case 119:
                                        case 120:
                                        case 121:
                                        case 122:
                                        case 123:
                                        case 124:
                                        case 125:
                                        case 126:
                                        case 127:
                                        case 128:
                                        case 129:
                                        case 130:
                                        case 132:
                                        case 133:
                                        case 137:
                                        case 138:
                                        case 139:
                                        case 140:
                                        case 141:
                                        case 142:
                                        case 143:
                                        case 144:
                                        case 145:
                                        case 146:
                                        case 147:
                                        case 148:
                                        case 149:
                                        case 150:
                                        case 152:
                                        case 153:
                                        case 154:
                                        case 155:
                                        case 156:
                                        case 157:
                                        case 158:
                                        case 159:
                                        case 160:
                                        case 161:
                                        case 162:
                                        case 163:
                                        case 164:
                                        case 165:
                                        case 166:
                                        case 167:
                                        case 169:
                                        case 170:
                                        case 171:
                                        case 172:
                                        case 173:
                                        case 175:
                                        case 176:
                                        case 177:
                                        case 179:
                                        case 180:
                                        case 181:
                                        case 182:
                                        case 183:
                                        case 184:
                                        case 185:
                                        case 186:
                                        case 187:
                                        case 188:
                                        case 189:
                                        case 190:
                                        case 191:
                                        case 193:
                                        case 197:
                                        case 198:
                                        case 199:
                                        case 200:
                                        case 201:
                                        case 202:
                                        case 204:
                                        case 205:
                                        case 206:
                                        case 207:
                                        case 209:
                                        case 212:
                                        case 213:
                                        case 214:
                                        case 215:
                                        case 216:
                                        case 217:
                                        case 218:
                                        case 220:
                                        case 221:
                                        case 223:
                                        case 224:
                                        case 225:
                                        case 226:
                                        case 227:
                                        case 228:
                                        case 229:
                                        case 230:
                                        case 231:
                                        case 232:
                                        case 233:
                                        case 234:
                                        case 235:
                                        case 236:
                                        case 237:
                                        case 240:
                                        case 241:
                                        case 243:
                                        case 244:
                                        case 245:
                                        case 246:
                                        case 247:
                                        case 248:
                                        case 249:
                                        case 250:
                                        case 251:
                                        case 253:
                                        case 256:
                                        case 257:
                                        case 258:
                                        case 259:
                                        case 261:
                                        case 262:
                                        case 263:
                                        case 264:
                                        case 265:
                                        case 266:
                                        case 267:
                                        case 268:
                                        case 269:
                                        case 270:
                                        case 271:
                                        case 272:
                                        case 273:
                                        case 274:
                                        case 276:
                                        case 277:
                                        case 278:
                                        case 279:
                                        case 280:
                                        case 281:
                                        case 282:
                                        case 284:
                                        case 285:
                                        case 286:
                                        case 287:
                                        case 288:
                                        case 289:
                                        case 290:
                                        case 291:
                                        case 292:
                                        case 293:
                                        case 294:
                                        case 295:
                                        case 296:
                                        case 297:
                                        case 298:
                                        case 299:
                                        case 300:
                                        case 301:
                                        case 302:
                                        case 303:
                                        case 304:
                                        case 305:
                                        case 306:
                                        case 308:
                                        case 309:
                                        case 310:
                                        case 311:
                                        case 312:
                                        case 313:
                                        case 314:
                                        case 315:
                                        case 316:
                                        case 318:
                                        case 319:
                                        case 320:
                                        case 321:
                                        case 322:
                                        case 323:
                                        case 324:
                                        case 325:
                                        case 326:
                                        case 327:
                                        case 328:
                                        case 329:
                                        case 330:
                                        case 331:
                                        case 332:
                                        case 333:
                                        case 334:
                                        case 335:
                                        case 336:
                                        case 337:
                                        case 338:
                                        case 339:
                                        case 340:
                                        case 341:
                                            break;
                                        case 86:
                                        case 102:
                                        case 103:
                                        case 131:
                                        case 134:
                                        case 135:
                                        case 136:
                                        case 151:
                                        case 168:
                                        case 174:
                                        case 178:
                                        case 192:
                                        case 194:
                                        case 195:
                                        case 196:
                                        case 203:
                                        case 208:
                                        case 210:
                                        case 211:
                                        case 219:
                                        case 222:
                                        case 238:
                                        case 239:
                                        case 242:
                                        case 252:
                                        case 254:
                                        case 255:
                                        case 260:
                                        case 275:
                                        case 283:
                                        case 307:
                                        case 317:
                                            break a;
                                        case 101:
                                            oncipj_Cypher_jj_consume_token($this, 101);
                                            var$6 = oncipj_Cypher_LabelExpression3Is($this, $type);
                                            $e = onciafn_Neo4jASTFactory_labelColonDisjunction($this.$astFactory, oncipj_Cypher_pos($this, var$4), $e, var$6, 1);
                                            continue g;
                                        default:
                                            break a;
                                    }
                                    var$7 = oncipj_Cypher_LabelExpression3Is($this, $type);
                                    $e = onciafn_Neo4jASTFactory_labelDisjunction($this.$astFactory, oncipj_Cypher_pos($this, var$4), $e, var$7, 1);
                                }
                                oncipj_Cypher_jj_save($this, 58, 2147483647);
                                $rt_throw($type);
                            }
                        }
                        if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                            $e = ju_Stack_peek($this.$labelExpressionStack);
                            oncipj_ExpectBar_$callClinit();
                            if ($e !== oncipj_ExpectBar_DO_NOT_EXPECT_BAR) {
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $type = new oncipj_ParseException;
                                jl_Throwable__init_0($type);
                                $rt_throw($type);
                            }
                        }
                        $e = oncipj_Cypher_LabelExpression4Is($this, $type);
                        break b;
                    default:
                }
                $this.$jj_la1.data[136] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $type = new oncipj_ParseException;
                jl_Throwable__init_0($type);
                $rt_throw($type);
            }
            return $e;
        }
        $this.$jj_la1.data[140] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $type = new oncipj_ParseException;
        jl_Throwable__init_0($type);
        $rt_throw($type);
    }
    function oncipj_Cypher_LabelExpression4($this, $type) {
        var $e, $temp, var$4, $t, var$6, $$je;
        $e = oncipj_Cypher_LabelExpression3($this, $type);
        a: {
            b: {
                c: while (true) {
                    $this.$jj_la = 2;
                    $temp = $this.$token;
                    $this.$jj_scanpos = $temp;
                    $this.$jj_lastpos = $temp;
                    d: {
                        e: {
                            try {
                                var$4 = oncipj_Cypher_jj_3_56($this) ? 0 : 1;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                    break e;
                                } else{
                                    $type = $$je;
                                    break b;
                                }
                            }
                            oncipj_Cypher_jj_save($this, 55, 2);
                            break d;
                        }
                        try {
                            var$4 = 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            $type = $$je;
                            break b;

                        }
                        oncipj_Cypher_jj_save($this, 55, 2);
                    }
                    if (!var$4)
                        break;
                    $t = oncipj_Cypher_jj_consume_token($this, 86);
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 193:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 202:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 209:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            break;
                        case 86:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 194:
                        case 195:
                        case 196:
                        case 203:
                        case 208:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break a;
                        case 101:
                            oncipj_Cypher_jj_consume_token($this, 101);
                            $temp = oncipj_Cypher_LabelExpression3($this, $type);
                            $e = onciafn_Neo4jASTFactory_labelColonDisjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 0);
                            continue c;
                        default:
                            break a;
                    }
                    $temp = oncipj_Cypher_LabelExpression3($this, $type);
                    $e = onciafn_Neo4jASTFactory_labelDisjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 0);
                }
                return $e;
            }
            oncipj_Cypher_jj_save($this, 55, 2);
            $rt_throw($type);
        }
        $this.$jj_la1.data[137] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $type = new oncipj_ParseException;
        jl_Throwable__init_0($type);
        $rt_throw($type);
    }
    function oncipj_Cypher_LabelExpression4Is($this, $type) {
        var $e, $temp, var$4, $t, var$6, $$je;
        $e = oncipj_Cypher_LabelExpression3Is($this, $type);
        a: {
            b: {
                c: while (true) {
                    $this.$jj_la = 2;
                    $temp = $this.$token;
                    $this.$jj_scanpos = $temp;
                    $this.$jj_lastpos = $temp;
                    d: {
                        e: {
                            try {
                                var$4 = oncipj_Cypher_jj_3_57($this) ? 0 : 1;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                    break e;
                                } else{
                                    $type = $$je;
                                    break b;
                                }
                            }
                            oncipj_Cypher_jj_save($this, 56, 2);
                            break d;
                        }
                        try {
                            var$4 = 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            $type = $$je;
                            break b;

                        }
                        oncipj_Cypher_jj_save($this, 56, 2);
                    }
                    if (!var$4)
                        break;
                    $t = oncipj_Cypher_jj_consume_token($this, 86);
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 193:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 202:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 209:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 220:
                        case 221:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            break;
                        case 86:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 194:
                        case 195:
                        case 196:
                        case 203:
                        case 208:
                        case 210:
                        case 211:
                        case 219:
                        case 222:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                        case 317:
                            break a;
                        case 101:
                            oncipj_Cypher_jj_consume_token($this, 101);
                            $temp = oncipj_Cypher_LabelExpression3Is($this, $type);
                            $e = onciafn_Neo4jASTFactory_labelColonDisjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 1);
                            continue c;
                        default:
                            break a;
                    }
                    $temp = oncipj_Cypher_LabelExpression3Is($this, $type);
                    $e = onciafn_Neo4jASTFactory_labelDisjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 1);
                }
                return $e;
            }
            oncipj_Cypher_jj_save($this, 56, 2);
            $rt_throw($type);
        }
        $this.$jj_la1.data[138] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $type = new oncipj_ParseException;
        jl_Throwable__init_0($type);
        $rt_throw($type);
    }
    function oncipj_Cypher_LabelExpression3($this, $type) {
        var $e, $t, var$4, var$5, $temp, $$je;
        $e = oncipj_Cypher_LabelExpression2($this, $type);
        a: {
            b: while (true) {
                $this.$jj_la = 2;
                $t = $this.$token;
                $this.$jj_scanpos = $t;
                $this.$jj_lastpos = $t;
                c: {
                    d: {
                        try {
                            var$4 = oncipj_Cypher_jj_3_60($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $type = $$je;
                                break a;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 59, 2);
                        break c;
                    }
                    try {
                        var$4 = 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $type = $$je;
                        break a;

                    }
                    oncipj_Cypher_jj_save($this, 59, 2);
                }
                if (!var$4)
                    break;
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 101:
                        break;
                    case 192:
                        $t = oncipj_Cypher_jj_consume_token($this, 192);
                        $temp = oncipj_Cypher_LabelExpression2($this, $type);
                        $e = onciafn_Neo4jASTFactory_labelConjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 0);
                        continue b;
                    default:
                        $this.$jj_la1.data[141] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $type = new oncipj_ParseException;
                        jl_Throwable__init_0($type);
                        $rt_throw($type);
                }
                $t = oncipj_Cypher_jj_consume_token($this, 101);
                $temp = oncipj_Cypher_LabelExpression2($this, $type);
                $e = onciafn_Neo4jASTFactory_labelColonConjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 0);
            }
            return $e;
        }
        oncipj_Cypher_jj_save($this, 59, 2);
        $rt_throw($type);
    }
    function oncipj_Cypher_LabelExpression3Is($this, $type) {
        var $e, $t, var$4, var$5, $temp, $$je;
        $e = oncipj_Cypher_LabelExpression2Is($this, $type);
        a: {
            b: while (true) {
                $this.$jj_la = 2;
                $t = $this.$token;
                $this.$jj_scanpos = $t;
                $this.$jj_lastpos = $t;
                c: {
                    d: {
                        try {
                            var$4 = oncipj_Cypher_jj_3_61($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $type = $$je;
                                break a;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 60, 2);
                        break c;
                    }
                    try {
                        var$4 = 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $type = $$je;
                        break a;

                    }
                    oncipj_Cypher_jj_save($this, 60, 2);
                }
                if (!var$4)
                    break;
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 101:
                        break;
                    case 192:
                        $t = oncipj_Cypher_jj_consume_token($this, 192);
                        $temp = oncipj_Cypher_LabelExpression2Is($this, $type);
                        $e = onciafn_Neo4jASTFactory_labelConjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 1);
                        continue b;
                    default:
                        $this.$jj_la1.data[142] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $type = new oncipj_ParseException;
                        jl_Throwable__init_0($type);
                        $rt_throw($type);
                }
                $t = oncipj_Cypher_jj_consume_token($this, 101);
                $temp = oncipj_Cypher_LabelExpression2Is($this, $type);
                $e = onciafn_Neo4jASTFactory_labelColonConjunction($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, $temp, 1);
            }
            return $e;
        }
        oncipj_Cypher_jj_save($this, 60, 2);
        $rt_throw($type);
    }
    function oncipj_Cypher_LabelExpression2($this, $type) {
        var $t, var$3, $e, var$5, $$je;
        $this.$jj_la = 3;
        $t = $this.$token;
        $this.$jj_scanpos = $t;
        $this.$jj_lastpos = $t;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_62($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $type = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 61, 3);
                        break a;
                    }
                    try {
                        var$3 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $type = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 61, 3);
                $rt_throw($type);
            }
            oncipj_Cypher_jj_save($this, 61, 3);
        }
        e: {
            if (var$3) {
                $t = oncipj_Cypher_jj_consume_token($this, 193);
                $e = oncipj_Cypher_LabelExpression2($this, $type);
                $e = onciafn_Neo4jASTFactory_labelNegation($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, 0);
            } else {
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 202:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 209:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        $e = $this.$labelExpressionStack;
                        oncipj_ExpectBar_$callClinit();
                        ju_Stack_push($e, oncipj_ExpectBar_DO_NOT_EXPECT_BAR);
                        var$5 = $this.$jj_ntk;
                        if (var$5 == (-1))
                            var$5 = oncipj_Cypher_jj_ntk_f($this);
                        f: {
                            switch (var$5) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    $t = oncipj_Cypher_SymbolicNameString($this);
                                    $e = onciafn_Neo4jASTFactory_labelLeaf($this.$astFactory, oncipj_Cypher_pos($this, $t), $t.$image0, $type, 0);
                                    break f;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 203:
                                case 208:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                case 307:
                                    break;
                                case 202:
                                    oncipj_Cypher_jj_consume_token($this, 202);
                                    $e = oncipj_Cypher_LabelExpression4($this, $type);
                                    oncipj_Cypher_jj_consume_token($this, 275);
                                    break f;
                                case 209:
                                    $type = oncipj_Cypher_jj_consume_token($this, 209);
                                    $e = onciafn_Neo4jASTFactory_labelWildcard($this.$astFactory, oncipj_Cypher_pos($this, $type), 0);
                                    break f;
                                default:
                            }
                            $this.$jj_la1.data[145] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $type = new oncipj_ParseException;
                            jl_Throwable__init_0($type);
                            $rt_throw($type);
                        }
                        ju_Stack_pop($this.$labelExpressionStack);
                        break e;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 203:
                    case 208:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break;
                    default:
                }
                $this.$jj_la1.data[143] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $type = new oncipj_ParseException;
                jl_Throwable__init_0($type);
                $rt_throw($type);
            }
        }
        return $e;
    }
    function oncipj_Cypher_LabelExpression2Is($this, $type) {
        var $t, var$3, $e, var$5, var$6, $$je;
        $this.$jj_la = 3;
        $t = $this.$token;
        $this.$jj_scanpos = $t;
        $this.$jj_lastpos = $t;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_63($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $type = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 62, 3);
                        break a;
                    }
                    try {
                        var$3 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $type = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 62, 3);
                $rt_throw($type);
            }
            oncipj_Cypher_jj_save($this, 62, 3);
        }
        e: {
            if (var$3) {
                $t = oncipj_Cypher_jj_consume_token($this, 193);
                $e = oncipj_Cypher_LabelExpression2Is($this, $type);
                $e = onciafn_Neo4jASTFactory_labelNegation($this.$astFactory, oncipj_Cypher_pos($this, $t), $e, 1);
            } else {
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 202:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 209:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 220:
                    case 221:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        $e = $this.$labelExpressionStack;
                        oncipj_ExpectBar_$callClinit();
                        ju_Stack_push($e, oncipj_ExpectBar_DO_NOT_EXPECT_BAR);
                        var$5 = $this.$jj_ntk;
                        if (var$5 == (-1))
                            var$5 = oncipj_Cypher_jj_ntk_f($this);
                        f: {
                            switch (var$5) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 220:
                                case 221:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    var$3 = $this.$jj_ntk;
                                    if (var$3 == (-1))
                                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                                    g: {
                                        switch (var$3) {
                                            case 68:
                                                var$6 = oncipj_Cypher_EscapedSymbolicNameString($this);
                                                break g;
                                            case 69:
                                            case 70:
                                            case 71:
                                            case 72:
                                            case 73:
                                            case 74:
                                            case 75:
                                            case 76:
                                            case 77:
                                            case 78:
                                            case 79:
                                            case 80:
                                            case 81:
                                            case 82:
                                            case 83:
                                            case 84:
                                            case 85:
                                            case 87:
                                            case 88:
                                            case 89:
                                            case 90:
                                            case 91:
                                            case 92:
                                            case 93:
                                            case 94:
                                            case 95:
                                            case 96:
                                            case 97:
                                            case 98:
                                            case 99:
                                            case 100:
                                            case 104:
                                            case 105:
                                            case 106:
                                            case 107:
                                            case 108:
                                            case 109:
                                            case 110:
                                            case 111:
                                            case 112:
                                            case 113:
                                            case 114:
                                            case 115:
                                            case 116:
                                            case 117:
                                            case 118:
                                            case 119:
                                            case 120:
                                            case 121:
                                            case 122:
                                            case 123:
                                            case 124:
                                            case 125:
                                            case 126:
                                            case 127:
                                            case 128:
                                            case 129:
                                            case 130:
                                            case 132:
                                            case 133:
                                            case 137:
                                            case 138:
                                            case 139:
                                            case 140:
                                            case 141:
                                            case 142:
                                            case 143:
                                            case 144:
                                            case 145:
                                            case 146:
                                            case 147:
                                            case 148:
                                            case 149:
                                            case 150:
                                            case 152:
                                            case 153:
                                            case 154:
                                            case 155:
                                            case 156:
                                            case 157:
                                            case 158:
                                            case 159:
                                            case 160:
                                            case 161:
                                            case 162:
                                            case 163:
                                            case 164:
                                            case 165:
                                            case 166:
                                            case 167:
                                            case 169:
                                            case 170:
                                            case 171:
                                            case 172:
                                            case 173:
                                            case 175:
                                            case 176:
                                            case 177:
                                            case 179:
                                            case 180:
                                            case 181:
                                            case 182:
                                            case 183:
                                            case 184:
                                            case 185:
                                            case 186:
                                            case 187:
                                            case 188:
                                            case 189:
                                            case 190:
                                            case 191:
                                            case 197:
                                            case 198:
                                            case 199:
                                            case 200:
                                            case 201:
                                            case 204:
                                            case 205:
                                            case 206:
                                            case 207:
                                            case 212:
                                            case 213:
                                            case 214:
                                            case 215:
                                            case 216:
                                            case 217:
                                            case 218:
                                            case 220:
                                            case 221:
                                            case 223:
                                            case 224:
                                            case 225:
                                            case 226:
                                            case 227:
                                            case 228:
                                            case 229:
                                            case 230:
                                            case 231:
                                            case 232:
                                            case 233:
                                            case 234:
                                            case 235:
                                            case 236:
                                            case 237:
                                            case 240:
                                            case 241:
                                            case 243:
                                            case 244:
                                            case 245:
                                            case 246:
                                            case 247:
                                            case 248:
                                            case 249:
                                            case 250:
                                            case 251:
                                            case 253:
                                            case 256:
                                            case 257:
                                            case 258:
                                            case 259:
                                            case 261:
                                            case 262:
                                            case 263:
                                            case 264:
                                            case 265:
                                            case 266:
                                            case 267:
                                            case 268:
                                            case 269:
                                            case 270:
                                            case 271:
                                            case 272:
                                            case 273:
                                            case 274:
                                            case 276:
                                            case 277:
                                            case 278:
                                            case 279:
                                            case 280:
                                            case 281:
                                            case 282:
                                            case 284:
                                            case 285:
                                            case 286:
                                            case 287:
                                            case 288:
                                            case 289:
                                            case 290:
                                            case 291:
                                            case 292:
                                            case 293:
                                            case 294:
                                            case 295:
                                            case 296:
                                            case 297:
                                            case 298:
                                            case 299:
                                            case 300:
                                            case 301:
                                            case 302:
                                            case 303:
                                            case 304:
                                            case 305:
                                            case 306:
                                            case 308:
                                            case 309:
                                            case 310:
                                            case 311:
                                            case 312:
                                            case 313:
                                            case 314:
                                            case 315:
                                            case 316:
                                            case 318:
                                            case 319:
                                            case 320:
                                            case 321:
                                            case 322:
                                            case 323:
                                            case 324:
                                            case 325:
                                            case 326:
                                            case 327:
                                            case 328:
                                            case 329:
                                            case 330:
                                            case 331:
                                            case 332:
                                            case 333:
                                            case 334:
                                            case 335:
                                            case 336:
                                            case 337:
                                            case 338:
                                            case 339:
                                            case 340:
                                            case 341:
                                                var$6 = oncipj_Cypher_UnescapedLabelSymbolicNameString($this);
                                                break g;
                                            case 86:
                                            case 101:
                                            case 102:
                                            case 103:
                                            case 131:
                                            case 134:
                                            case 135:
                                            case 136:
                                            case 151:
                                            case 168:
                                            case 174:
                                            case 178:
                                            case 192:
                                            case 193:
                                            case 194:
                                            case 195:
                                            case 196:
                                            case 202:
                                            case 203:
                                            case 208:
                                            case 209:
                                            case 210:
                                            case 211:
                                            case 219:
                                            case 222:
                                            case 238:
                                            case 239:
                                            case 242:
                                            case 252:
                                            case 254:
                                            case 255:
                                            case 260:
                                            case 275:
                                            case 283:
                                            case 307:
                                            case 317:
                                                break;
                                            default:
                                        }
                                        $this.$jj_la1.data[635] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $type = new oncipj_ParseException;
                                        jl_Throwable__init_0($type);
                                        $rt_throw($type);
                                    }
                                    $e = onciafn_Neo4jASTFactory_labelLeaf($this.$astFactory, oncipj_Cypher_pos($this, var$6), var$6.$image0, $type, 1);
                                    break f;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 203:
                                case 208:
                                case 210:
                                case 211:
                                case 219:
                                case 222:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                case 307:
                                case 317:
                                    break;
                                case 202:
                                    oncipj_Cypher_jj_consume_token($this, 202);
                                    $e = oncipj_Cypher_LabelExpression4Is($this, $type);
                                    oncipj_Cypher_jj_consume_token($this, 275);
                                    break f;
                                case 209:
                                    $type = oncipj_Cypher_jj_consume_token($this, 209);
                                    $e = onciafn_Neo4jASTFactory_labelWildcard($this.$astFactory, oncipj_Cypher_pos($this, $type), 1);
                                    break f;
                                default:
                            }
                            $this.$jj_la1.data[146] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $type = new oncipj_ParseException;
                            jl_Throwable__init_0($type);
                            $rt_throw($type);
                        }
                        ju_Stack_pop($this.$labelExpressionStack);
                        break e;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 203:
                    case 208:
                    case 210:
                    case 211:
                    case 219:
                    case 222:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                    case 317:
                        break;
                    default:
                }
                $this.$jj_la1.data[144] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $type = new oncipj_ParseException;
                jl_Throwable__init_0($type);
                $rt_throw($type);
            }
        }
        return $e;
    }
    function oncipj_Cypher_Expression($this) {
        var $e, var$2, var$3, var$4;
        $e = oncipj_Cypher_Expression11($this);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 229:
                    break;
                default:
                    break a;
            }
            var$3 = oncipj_Cypher_jj_consume_token($this, 229);
            var$4 = oncipj_Cypher_Expression11($this);
            var$3 = oncipj_Cypher_pos($this, var$3);
            $e = oncie_Or__init_($e, var$4, var$3);
        }
        $this.$jj_la1.data[147] = $this.$jj_gen;
        return $e;
    }
    function oncipj_Cypher_Expression11($this) {
        var $e, var$2, $t, $temp;
        $e = oncipj_Cypher_Expression10($this);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 338:
                    break;
                default:
                    break a;
            }
            $t = oncipj_Cypher_jj_consume_token($this, 338);
            $temp = oncipj_Cypher_Expression10($this);
            $t = oncipj_Cypher_pos($this, $t);
            $e = oncie_Xor__init_($e, $temp, $t);
        }
        $this.$jj_la1.data[148] = $this.$jj_gen;
        return $e;
    }
    function oncipj_Cypher_Expression10($this) {
        var $e, var$2, $t, $temp;
        $e = oncipj_Cypher_Expression9($this);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 78:
                    break;
                default:
                    break a;
            }
            $t = oncipj_Cypher_jj_consume_token($this, 78);
            $temp = oncipj_Cypher_Expression9($this);
            $t = oncipj_Cypher_pos($this, $t);
            $e = oncie_And__init_($e, $temp, $t);
        }
        $this.$jj_la1.data[149] = $this.$jj_gen;
        return $e;
    }
    function oncipj_Cypher_Expression9($this) {
        var $t, var$2, $e, var$4, $$je;
        $this.$jj_la = 3;
        $t = $this.$token;
        $this.$jj_scanpos = $t;
        $this.$jj_lastpos = $t;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_64($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $t = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 63, 3);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 63, 3);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 63, 3);
        }
        e: {
            if (var$2) {
                $t = oncipj_Cypher_jj_consume_token($this, 219);
                $e = oncipj_Cypher_Expression9($this);
                $t = oncipj_Cypher_pos($this, $t);
                $e = oncie_Not__init_($e, $t);
            } else {
                var$4 = $this.$jj_ntk;
                if (var$4 == (-1))
                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$4) {
                    case 35:
                    case 36:
                    case 39:
                    case 40:
                    case 52:
                    case 64:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 131:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 194:
                    case 195:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 202:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 208:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 238:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 37:
                    case 38:
                    case 41:
                    case 42:
                    case 43:
                    case 44:
                    case 45:
                    case 46:
                    case 47:
                    case 48:
                    case 49:
                    case 50:
                    case 51:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                    case 57:
                    case 58:
                    case 59:
                    case 60:
                    case 61:
                    case 62:
                    case 63:
                    case 65:
                    case 66:
                    case 67:
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 196:
                    case 203:
                    case 209:
                    case 210:
                    case 211:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break e;
                    default:
                        break e;
                }
                $e = oncipj_Cypher_Expression8($this);
            }
            return $e;
        }
        $this.$jj_la1.data[150] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $t = new oncipj_ParseException;
        jl_Throwable__init_0($t);
        $rt_throw($t);
    }
    function oncipj_Cypher_Expression8($this) {
        var $expressions, $e, $lhs, var$4, $t, var$6, $lhs_0, var$8, $$je;
        $expressions = ju_ArrayList__init_();
        $e = oncipj_Cypher_Expression7($this);
        $lhs = $e;
        a: while (true) {
            var$4 = $this.$jj_ntk;
            if (var$4 == (-1))
                var$4 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$4) {
                case 151:
                case 168:
                case 174:
                case 196:
                case 203:
                case 210:
                case 211:
                    break;
                default:
                    $this.$jj_la1.data[151] = $this.$jj_gen;
                    if (ju_AbstractCollection_isEmpty($expressions))
                        return $e;
                    if ($expressions.$size2 == 1)
                        return ju_ArrayList_get($expressions, 0);
                    $e = scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $expressions));
                    $expressions = (ju_ArrayList_get($expressions, 0)).$position2();
                    return oncie_Ands__init_0(sci_ListSet$_from(sci_ListSet$_MODULE$, $e), $expressions);
            }
            $this.$jj_la = 2;
            $t = $this.$token;
            $this.$jj_scanpos = $t;
            $this.$jj_lastpos = $t;
            b: {
                c: {
                    try {
                        var$6 = oncipj_Cypher_jj_3_65($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            $expressions = $$je;
                            break a;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 64, 2);
                    break b;
                }
                try {
                    var$6 = 1;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    $expressions = $$je;
                    break a;

                }
                oncipj_Cypher_jj_save($this, 64, 2);
            }
            if (var$6) {
                $t = oncipj_Cypher_jj_consume_token($this, 151);
                $lhs_0 = oncipj_Cypher_Expression7($this);
                var$8 = oncipj_Cypher_pos($this, $t);
                ju_ArrayList_add($expressions, oncie_Equals__init_($lhs, $lhs_0, var$8));
                $lhs = $lhs_0;
                continue;
            }
            var$4 = $this.$jj_ntk;
            if (var$4 == (-1))
                var$4 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$4) {
                case 168:
                    break;
                case 174:
                    $t = oncipj_Cypher_jj_consume_token($this, 174);
                    $lhs_0 = oncipj_Cypher_Expression7($this);
                    var$8 = oncipj_Cypher_pos($this, $t);
                    ju_ArrayList_add($expressions, oncie_GreaterThan__init_($lhs, $lhs_0, var$8));
                    $lhs = $lhs_0;
                    continue a;
                case 196:
                    $t = oncipj_Cypher_jj_consume_token($this, 196);
                    $lhs_0 = oncipj_Cypher_Expression7($this);
                    var$8 = oncipj_Cypher_pos($this, $t);
                    ju_ArrayList_add($expressions, oncie_LessThanOrEqual__init_($lhs, $lhs_0, var$8));
                    $lhs = $lhs_0;
                    continue a;
                case 203:
                    $t = oncipj_Cypher_jj_consume_token($this, 203);
                    $lhs_0 = oncipj_Cypher_Expression7($this);
                    var$8 = oncipj_Cypher_pos($this, $t);
                    ju_ArrayList_add($expressions, oncie_LessThan__init_($lhs, $lhs_0, var$8));
                    $lhs = $lhs_0;
                    continue a;
                case 210:
                    $t = oncipj_Cypher_jj_consume_token($this, 210);
                    $lhs_0 = oncipj_Cypher_Expression7($this);
                    var$8 = oncipj_Cypher_pos($this, $t);
                    ju_ArrayList_add($expressions, oncie_InvalidNotEquals__init_($lhs, $lhs_0, var$8));
                    $lhs = $lhs_0;
                    continue a;
                case 211:
                    $t = oncipj_Cypher_jj_consume_token($this, 211);
                    $lhs_0 = oncipj_Cypher_Expression7($this);
                    var$8 = oncipj_Cypher_pos($this, $t);
                    ju_ArrayList_add($expressions, oncie_NotEquals__init_($lhs, $lhs_0, var$8));
                    $lhs = $lhs_0;
                    continue a;
                default:
                    $this.$jj_la1.data[152] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $expressions = new oncipj_ParseException;
                    jl_Throwable__init_0($expressions);
                    $rt_throw($expressions);
            }
            $t = oncipj_Cypher_jj_consume_token($this, 168);
            $lhs_0 = oncipj_Cypher_Expression7($this);
            var$8 = oncipj_Cypher_pos($this, $t);
            ju_ArrayList_add($expressions, oncie_GreaterThanOrEqual__init_($lhs, $lhs_0, var$8));
            $lhs = $lhs_0;
        }
        oncipj_Cypher_jj_save($this, 64, 2);
        $rt_throw($expressions);
    }
    function oncipj_Cypher_Expression7($this) {
        var $e, var$2;
        $e = oncipj_Cypher_Expression6($this);
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$2) {
                case 102:
                case 110:
                case 150:
                case 180:
                case 187:
                case 260:
                case 296:
                    break;
                default:
                    $this.$jj_la1.data[153] = $this.$jj_gen;
                    break a;
            }
            $e = oncipj_Cypher_ComparisonExpression6($this, $e);
        }
        return $e;
    }
    function oncipj_Cypher_ComparisonExpression6($this, $lhs) {
        var $t, var$3, $rhs, var$5, $typeName, $$je;
        $this.$jj_la = 2;
        $t = $this.$token;
        $this.$jj_scanpos = $t;
        $this.$jj_lastpos = $t;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_66($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $lhs = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 65, 2);
                        break a;
                    }
                    try {
                        var$3 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $lhs = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 65, 2);
                $rt_throw($lhs);
            }
            oncipj_Cypher_jj_save($this, 65, 2);
        }
        if (var$3) {
            $t = oncipj_Cypher_jj_consume_token($this, 260);
            $rhs = oncipj_Cypher_Expression6($this);
            $t = oncipj_Cypher_pos($this, $t);
            return oncie_RegexMatch__init_($lhs, $rhs, $t);
        }
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$5) {
            case 102:
                break;
            case 110:
                $t = oncipj_Cypher_jj_consume_token($this, 110);
                $rhs = oncipj_Cypher_Expression6($this);
                $t = oncipj_Cypher_pos($this, $t);
                return oncie_Contains__init_($lhs, $rhs, $t);
            case 150:
                $t = oncipj_Cypher_jj_consume_token($this, 150);
                oncipj_Cypher_jj_consume_token($this, 335);
                $rhs = oncipj_Cypher_Expression6($this);
                $t = oncipj_Cypher_pos($this, $t);
                return oncie_EndsWith__init_($lhs, $rhs, $t);
            case 180:
                $t = oncipj_Cypher_jj_consume_token($this, 180);
                $rhs = oncipj_Cypher_Expression6($this);
                $t = oncipj_Cypher_pos($this, $t);
                return oncie_In__init_($lhs, $rhs, $t);
            case 187:
                $t = oncipj_Cypher_jj_consume_token($this, 187);
                var$5 = $this.$jj_ntk;
                if (var$5 == (-1))
                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$5) {
                    case 102:
                    case 317:
                        var$5 = $this.$jj_ntk;
                        if (var$5 == (-1))
                            var$5 = oncipj_Cypher_jj_ntk_f($this);
                        e: {
                            switch (var$5) {
                                case 102:
                                    break;
                                case 317:
                                    oncipj_Cypher_jj_consume_token($this, 317);
                                    break e;
                                default:
                                    $this.$jj_la1.data[156] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $lhs = new oncipj_ParseException;
                                    jl_Throwable__init_0($lhs);
                                    $rt_throw($lhs);
                            }
                            oncipj_Cypher_jj_consume_token($this, 102);
                        }
                        $typeName = oncipj_Cypher_cypherTypeName($this);
                        return onciafn_Neo4jASTFactory_isTyped($this.$astFactory, oncipj_Cypher_pos($this, $t), $lhs, $typeName);
                    case 219:
                        oncipj_Cypher_jj_consume_token($this, 219);
                        var$5 = $this.$jj_ntk;
                        if (var$5 == (-1))
                            var$5 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$5) {
                            case 102:
                            case 317:
                                var$5 = $this.$jj_ntk;
                                if (var$5 == (-1))
                                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                                f: {
                                    switch (var$5) {
                                        case 102:
                                            oncipj_Cypher_jj_consume_token($this, 102);
                                            break f;
                                        case 317:
                                            oncipj_Cypher_jj_consume_token($this, 317);
                                            break f;
                                        default:
                                    }
                                    $this.$jj_la1.data[154] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $lhs = new oncipj_ParseException;
                                    jl_Throwable__init_0($lhs);
                                    $rt_throw($lhs);
                                }
                                $typeName = oncipj_Cypher_cypherTypeName($this);
                                $rhs = $this.$astFactory;
                                $t = oncipj_Cypher_pos($this, $t);
                                return oncia_IsNotTyped__init_($lhs, onciafn_Neo4jASTFactory_convertCypherType($rhs, $typeName), $t);
                            case 222:
                                break;
                            default:
                                $this.$jj_la1.data[155] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $lhs = new oncipj_ParseException;
                                jl_Throwable__init_0($lhs);
                                $rt_throw($lhs);
                        }
                        oncipj_Cypher_jj_consume_token($this, 222);
                        $t = oncipj_Cypher_pos($this, $t);
                        return oncie_IsNotNull__init_($lhs, $t);
                    case 222:
                        break;
                    default:
                        $this.$jj_la1.data[157] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $lhs = new oncipj_ParseException;
                        jl_Throwable__init_0($lhs);
                        $rt_throw($lhs);
                }
                oncipj_Cypher_jj_consume_token($this, 222);
                $t = oncipj_Cypher_pos($this, $t);
                return oncie_IsNull__init_($lhs, $t);
            case 296:
                $t = oncipj_Cypher_jj_consume_token($this, 296);
                oncipj_Cypher_jj_consume_token($this, 335);
                $rhs = oncipj_Cypher_Expression6($this);
                $t = oncipj_Cypher_pos($this, $t);
                return oncie_StartsWith__init_($lhs, $rhs, $t);
            default:
                $this.$jj_la1.data[158] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $lhs = new oncipj_ParseException;
                jl_Throwable__init_0($lhs);
                $rt_throw($lhs);
        }
        $t = oncipj_Cypher_jj_consume_token($this, 102);
        $typeName = oncipj_Cypher_cypherTypeName($this);
        return onciafn_Neo4jASTFactory_isTyped($this.$astFactory, oncipj_Cypher_pos($this, $t), $lhs, $typeName);
    }
    function oncipj_Cypher_Expression6($this) {
        var $lhs, var$2, var$3, $t, $rhs;
        $lhs = oncipj_Cypher_Expression5($this);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 208:
                case 238:
                    break;
                default:
                    break a;
            }
            var$3 = $this.$jj_ntk;
            if (var$3 == (-1))
                var$3 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$3) {
                case 208:
                    break;
                case 238:
                    $t = oncipj_Cypher_jj_consume_token($this, 238);
                    $rhs = oncipj_Cypher_Expression5($this);
                    $t = oncipj_Cypher_pos($this, $t);
                    $lhs = oncie_Add__init_($lhs, $rhs, $t);
                    continue a;
                default:
                    $this.$jj_la1.data[160] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $lhs = new oncipj_ParseException;
                    jl_Throwable__init_0($lhs);
                    $rt_throw($lhs);
            }
            $t = oncipj_Cypher_jj_consume_token($this, 208);
            $rhs = oncipj_Cypher_Expression5($this);
            $t = oncipj_Cypher_pos($this, $t);
            $lhs = oncie_Subtract__init_($lhs, $rhs, $t);
        }
        $this.$jj_la1.data[159] = $this.$jj_gen;
        return $lhs;
    }
    function oncipj_Cypher_Expression5($this) {
        var $lhs, var$2, var$3, $t, $rhs;
        $lhs = oncipj_Cypher_Expression4($this);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 134:
                case 209:
                case 307:
                    break;
                default:
                    break a;
            }
            var$3 = $this.$jj_ntk;
            if (var$3 == (-1))
                var$3 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$3) {
                case 134:
                    break;
                case 209:
                    $t = oncipj_Cypher_jj_consume_token($this, 209);
                    $rhs = oncipj_Cypher_Expression4($this);
                    $t = oncipj_Cypher_pos($this, $t);
                    $lhs = oncie_Modulo__init_($lhs, $rhs, $t);
                    continue a;
                case 307:
                    $t = oncipj_Cypher_jj_consume_token($this, 307);
                    $rhs = oncipj_Cypher_Expression4($this);
                    $t = oncipj_Cypher_pos($this, $t);
                    $lhs = oncie_Multiply__init_($lhs, $rhs, $t);
                    continue a;
                default:
                    $this.$jj_la1.data[162] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $lhs = new oncipj_ParseException;
                    jl_Throwable__init_0($lhs);
                    $rt_throw($lhs);
            }
            $t = oncipj_Cypher_jj_consume_token($this, 134);
            $rhs = oncipj_Cypher_Expression4($this);
            $t = oncipj_Cypher_pos($this, $t);
            $lhs = oncie_Divide__init_($lhs, $rhs, $t);
        }
        $this.$jj_la1.data[161] = $this.$jj_gen;
        return $lhs;
    }
    function oncipj_Cypher_Expression4($this) {
        var $lhs, var$2, $t, $rhs;
        $lhs = oncipj_Cypher_Expression3($this);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 242:
                    break;
                default:
                    break a;
            }
            $t = oncipj_Cypher_jj_consume_token($this, 242);
            $rhs = oncipj_Cypher_Expression3($this);
            $t = oncipj_Cypher_pos($this, $t);
            $lhs = oncie_Pow__init_($lhs, $rhs, $t);
        }
        $this.$jj_la1.data[163] = $this.$jj_gen;
        return $lhs;
    }
    function oncipj_Cypher_Expression3($this) {
        var $t, var$2, $e, var$4, $$je;
        $this.$jj_la = 3;
        $t = $this.$token;
        $this.$jj_scanpos = $t;
        $this.$jj_lastpos = $t;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_67($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $t = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 66, 3);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 66, 3);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 66, 3);
        }
        e: {
            if (var$2)
                $e = oncipj_Cypher_Expression2($this);
            else {
                var$4 = $this.$jj_ntk;
                if (var$4 == (-1))
                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$4) {
                    case 208:
                        $t = oncipj_Cypher_jj_consume_token($this, 208);
                        $e = oncipj_Cypher_Expression2($this);
                        $t = oncipj_Cypher_pos($this, $t);
                        $e = oncie_UnarySubtract__init_($e, $t);
                        break e;
                    case 238:
                        $t = oncipj_Cypher_jj_consume_token($this, 238);
                        $e = oncipj_Cypher_Expression2($this);
                        $t = oncipj_Cypher_pos($this, $t);
                        $e = oncie_UnaryAdd__init_($e, $t);
                        break e;
                    default:
                }
                $this.$jj_la1.data[164] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $t = new oncipj_ParseException;
                jl_Throwable__init_0($t);
                $rt_throw($t);
            }
        }
        return $e;
    }
    function oncipj_Cypher_Expression2($this) {
        var $e, var$2, var$3, var$4, var$5, var$6, var$7, var$8, $$je;
        $e = oncipj_Cypher_Expression1($this);
        a: {
            b: {
                c: {
                    d: {
                        while (true) {
                            $this.$jj_la = 2147483647;
                            var$2 = $this.$token;
                            $this.$jj_scanpos = var$2;
                            $this.$jj_lastpos = var$2;
                            e: {
                                f: {
                                    try {
                                        var$3 = oncipj_Cypher_jj_3_68($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break f;
                                        } else{
                                            $e = $$je;
                                            break a;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 67, 2147483647);
                                    break e;
                                }
                                try {
                                    var$3 = 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $e = $$je;
                                    break a;

                                }
                                oncipj_Cypher_jj_save($this, 67, 2147483647);
                            }
                            if (!var$3)
                                break;
                            var$2 = null;
                            var$4 = null;
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            g: {
                                switch (var$3) {
                                    case 135:
                                        break;
                                    default:
                                        $this.$jj_la1.data[167] = $this.$jj_gen;
                                        $this.$jj_la = 2147483647;
                                        var$5 = $this.$token;
                                        $this.$jj_scanpos = var$5;
                                        $this.$jj_lastpos = var$5;
                                        h: {
                                            i: {
                                                try {
                                                    var$6 = oncipj_Cypher_jj_3_69($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break i;
                                                    } else{
                                                        $e = $$je;
                                                        break b;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 68, 2147483647);
                                                break h;
                                            }
                                            try {
                                                var$6 = 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $e = $$je;
                                                break b;

                                            }
                                            oncipj_Cypher_jj_save($this, 68, 2147483647);
                                        }
                                        if (var$6) {
                                            $e = oncipj_Cypher_LabelExpressionPredicate($this, $e);
                                            break g;
                                        }
                                        $this.$jj_la = 2147483647;
                                        var$5 = $this.$token;
                                        $this.$jj_scanpos = var$5;
                                        $this.$jj_lastpos = var$5;
                                        j: {
                                            k: {
                                                try {
                                                    var$6 = oncipj_Cypher_jj_3_70($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break k;
                                                    } else{
                                                        $e = $$je;
                                                        break c;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 69, 2147483647);
                                                break j;
                                            }
                                            try {
                                                var$6 = 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $e = $$je;
                                                break c;

                                            }
                                            oncipj_Cypher_jj_save($this, 69, 2147483647);
                                        }
                                        if (var$6) {
                                            $e = oncipj_Cypher_LabelExpressionPredicate($this, $e);
                                            break g;
                                        }
                                        $this.$jj_la = 2147483647;
                                        var$5 = $this.$token;
                                        $this.$jj_scanpos = var$5;
                                        $this.$jj_lastpos = var$5;
                                        l: {
                                            m: {
                                                try {
                                                    var$6 = oncipj_Cypher_jj_3_71($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break m;
                                                    } else{
                                                        $e = $$je;
                                                        break d;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 70, 2147483647);
                                                break l;
                                            }
                                            try {
                                                var$6 = 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $e = $$je;
                                                break d;

                                            }
                                            oncipj_Cypher_jj_save($this, 70, 2147483647);
                                        }
                                        if (var$6) {
                                            oncipj_Cypher_jj_consume_token($this, 194);
                                            var$2 = oncipj_Cypher_Expression($this);
                                            oncipj_Cypher_jj_consume_token($this, 254);
                                            var$5 = $e;
                                            var$2 = var$2;
                                            $e = oncie_ContainerIndex__init_(var$5, var$2, var$2.$position2());
                                            break g;
                                        }
                                        var$7 = $this.$jj_ntk;
                                        if (var$7 == (-1))
                                            var$7 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$7) {
                                            case 194:
                                                break;
                                            default:
                                                $this.$jj_la1.data[168] = $this.$jj_gen;
                                                oncipj_Cypher_jj_consume_token($this, (-1));
                                                $e = new oncipj_ParseException;
                                                jl_Throwable__init_0($e);
                                                $rt_throw($e);
                                        }
                                        var$5 = oncipj_Cypher_jj_consume_token($this, 194);
                                        var$7 = $this.$jj_ntk;
                                        if (var$7 == (-1))
                                            var$7 = oncipj_Cypher_jj_ntk_f($this);
                                        n: {
                                            o: {
                                                switch (var$7) {
                                                    case 35:
                                                    case 36:
                                                    case 39:
                                                    case 40:
                                                    case 52:
                                                    case 64:
                                                    case 68:
                                                    case 69:
                                                    case 70:
                                                    case 71:
                                                    case 72:
                                                    case 73:
                                                    case 74:
                                                    case 75:
                                                    case 76:
                                                    case 77:
                                                    case 78:
                                                    case 79:
                                                    case 80:
                                                    case 81:
                                                    case 82:
                                                    case 83:
                                                    case 84:
                                                    case 85:
                                                    case 87:
                                                    case 88:
                                                    case 89:
                                                    case 90:
                                                    case 91:
                                                    case 92:
                                                    case 93:
                                                    case 94:
                                                    case 95:
                                                    case 96:
                                                    case 97:
                                                    case 98:
                                                    case 99:
                                                    case 100:
                                                    case 104:
                                                    case 105:
                                                    case 106:
                                                    case 107:
                                                    case 108:
                                                    case 109:
                                                    case 110:
                                                    case 111:
                                                    case 112:
                                                    case 113:
                                                    case 114:
                                                    case 115:
                                                    case 116:
                                                    case 117:
                                                    case 118:
                                                    case 119:
                                                    case 120:
                                                    case 121:
                                                    case 122:
                                                    case 123:
                                                    case 124:
                                                    case 125:
                                                    case 126:
                                                    case 127:
                                                    case 128:
                                                    case 129:
                                                    case 130:
                                                    case 131:
                                                    case 132:
                                                    case 133:
                                                    case 137:
                                                    case 138:
                                                    case 139:
                                                    case 140:
                                                    case 141:
                                                    case 142:
                                                    case 143:
                                                    case 144:
                                                    case 145:
                                                    case 146:
                                                    case 147:
                                                    case 148:
                                                    case 149:
                                                    case 150:
                                                    case 152:
                                                    case 153:
                                                    case 154:
                                                    case 155:
                                                    case 156:
                                                    case 157:
                                                    case 158:
                                                    case 159:
                                                    case 160:
                                                    case 161:
                                                    case 162:
                                                    case 163:
                                                    case 164:
                                                    case 165:
                                                    case 166:
                                                    case 167:
                                                    case 169:
                                                    case 170:
                                                    case 171:
                                                    case 172:
                                                    case 173:
                                                    case 175:
                                                    case 176:
                                                    case 177:
                                                    case 179:
                                                    case 180:
                                                    case 181:
                                                    case 182:
                                                    case 183:
                                                    case 184:
                                                    case 185:
                                                    case 186:
                                                    case 187:
                                                    case 188:
                                                    case 189:
                                                    case 190:
                                                    case 191:
                                                    case 194:
                                                    case 195:
                                                    case 197:
                                                    case 198:
                                                    case 199:
                                                    case 200:
                                                    case 201:
                                                    case 202:
                                                    case 204:
                                                    case 205:
                                                    case 206:
                                                    case 207:
                                                    case 208:
                                                    case 212:
                                                    case 213:
                                                    case 214:
                                                    case 215:
                                                    case 216:
                                                    case 217:
                                                    case 218:
                                                    case 219:
                                                    case 220:
                                                    case 221:
                                                    case 222:
                                                    case 223:
                                                    case 224:
                                                    case 225:
                                                    case 226:
                                                    case 227:
                                                    case 228:
                                                    case 229:
                                                    case 230:
                                                    case 231:
                                                    case 232:
                                                    case 233:
                                                    case 234:
                                                    case 235:
                                                    case 236:
                                                    case 237:
                                                    case 238:
                                                    case 240:
                                                    case 241:
                                                    case 243:
                                                    case 244:
                                                    case 245:
                                                    case 246:
                                                    case 247:
                                                    case 248:
                                                    case 249:
                                                    case 250:
                                                    case 251:
                                                    case 253:
                                                    case 256:
                                                    case 257:
                                                    case 258:
                                                    case 259:
                                                    case 261:
                                                    case 262:
                                                    case 263:
                                                    case 264:
                                                    case 265:
                                                    case 266:
                                                    case 267:
                                                    case 268:
                                                    case 269:
                                                    case 270:
                                                    case 271:
                                                    case 272:
                                                    case 273:
                                                    case 274:
                                                    case 276:
                                                    case 277:
                                                    case 278:
                                                    case 279:
                                                    case 280:
                                                    case 281:
                                                    case 282:
                                                    case 284:
                                                    case 285:
                                                    case 286:
                                                    case 287:
                                                    case 288:
                                                    case 289:
                                                    case 290:
                                                    case 291:
                                                    case 292:
                                                    case 293:
                                                    case 294:
                                                    case 295:
                                                    case 296:
                                                    case 297:
                                                    case 298:
                                                    case 299:
                                                    case 300:
                                                    case 301:
                                                    case 302:
                                                    case 303:
                                                    case 304:
                                                    case 305:
                                                    case 306:
                                                    case 308:
                                                    case 309:
                                                    case 310:
                                                    case 311:
                                                    case 312:
                                                    case 313:
                                                    case 314:
                                                    case 315:
                                                    case 316:
                                                    case 317:
                                                    case 318:
                                                    case 319:
                                                    case 320:
                                                    case 321:
                                                    case 322:
                                                    case 323:
                                                    case 324:
                                                    case 325:
                                                    case 326:
                                                    case 327:
                                                    case 328:
                                                    case 329:
                                                    case 330:
                                                    case 331:
                                                    case 332:
                                                    case 333:
                                                    case 334:
                                                    case 335:
                                                    case 336:
                                                    case 337:
                                                    case 338:
                                                    case 339:
                                                    case 340:
                                                    case 341:
                                                        break;
                                                    case 37:
                                                    case 38:
                                                    case 41:
                                                    case 42:
                                                    case 43:
                                                    case 44:
                                                    case 45:
                                                    case 46:
                                                    case 47:
                                                    case 48:
                                                    case 49:
                                                    case 50:
                                                    case 51:
                                                    case 53:
                                                    case 54:
                                                    case 55:
                                                    case 56:
                                                    case 57:
                                                    case 58:
                                                    case 59:
                                                    case 60:
                                                    case 61:
                                                    case 62:
                                                    case 63:
                                                    case 65:
                                                    case 66:
                                                    case 67:
                                                    case 86:
                                                    case 101:
                                                    case 102:
                                                    case 103:
                                                    case 134:
                                                    case 135:
                                                    case 136:
                                                    case 151:
                                                    case 168:
                                                    case 174:
                                                    case 178:
                                                    case 192:
                                                    case 193:
                                                    case 196:
                                                    case 203:
                                                    case 209:
                                                    case 210:
                                                    case 211:
                                                    case 239:
                                                    case 242:
                                                    case 252:
                                                    case 254:
                                                    case 255:
                                                    case 260:
                                                    case 275:
                                                    case 283:
                                                    case 307:
                                                        break o;
                                                    default:
                                                        break o;
                                                }
                                                var$2 = oncipj_Cypher_Expression($this);
                                                break n;
                                            }
                                            $this.$jj_la1.data[165] = $this.$jj_gen;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 136);
                                        var$7 = $this.$jj_ntk;
                                        if (var$7 == (-1))
                                            var$7 = oncipj_Cypher_jj_ntk_f($this);
                                        p: {
                                            q: {
                                                switch (var$7) {
                                                    case 35:
                                                    case 36:
                                                    case 39:
                                                    case 40:
                                                    case 52:
                                                    case 64:
                                                    case 68:
                                                    case 69:
                                                    case 70:
                                                    case 71:
                                                    case 72:
                                                    case 73:
                                                    case 74:
                                                    case 75:
                                                    case 76:
                                                    case 77:
                                                    case 78:
                                                    case 79:
                                                    case 80:
                                                    case 81:
                                                    case 82:
                                                    case 83:
                                                    case 84:
                                                    case 85:
                                                    case 87:
                                                    case 88:
                                                    case 89:
                                                    case 90:
                                                    case 91:
                                                    case 92:
                                                    case 93:
                                                    case 94:
                                                    case 95:
                                                    case 96:
                                                    case 97:
                                                    case 98:
                                                    case 99:
                                                    case 100:
                                                    case 104:
                                                    case 105:
                                                    case 106:
                                                    case 107:
                                                    case 108:
                                                    case 109:
                                                    case 110:
                                                    case 111:
                                                    case 112:
                                                    case 113:
                                                    case 114:
                                                    case 115:
                                                    case 116:
                                                    case 117:
                                                    case 118:
                                                    case 119:
                                                    case 120:
                                                    case 121:
                                                    case 122:
                                                    case 123:
                                                    case 124:
                                                    case 125:
                                                    case 126:
                                                    case 127:
                                                    case 128:
                                                    case 129:
                                                    case 130:
                                                    case 131:
                                                    case 132:
                                                    case 133:
                                                    case 137:
                                                    case 138:
                                                    case 139:
                                                    case 140:
                                                    case 141:
                                                    case 142:
                                                    case 143:
                                                    case 144:
                                                    case 145:
                                                    case 146:
                                                    case 147:
                                                    case 148:
                                                    case 149:
                                                    case 150:
                                                    case 152:
                                                    case 153:
                                                    case 154:
                                                    case 155:
                                                    case 156:
                                                    case 157:
                                                    case 158:
                                                    case 159:
                                                    case 160:
                                                    case 161:
                                                    case 162:
                                                    case 163:
                                                    case 164:
                                                    case 165:
                                                    case 166:
                                                    case 167:
                                                    case 169:
                                                    case 170:
                                                    case 171:
                                                    case 172:
                                                    case 173:
                                                    case 175:
                                                    case 176:
                                                    case 177:
                                                    case 179:
                                                    case 180:
                                                    case 181:
                                                    case 182:
                                                    case 183:
                                                    case 184:
                                                    case 185:
                                                    case 186:
                                                    case 187:
                                                    case 188:
                                                    case 189:
                                                    case 190:
                                                    case 191:
                                                    case 194:
                                                    case 195:
                                                    case 197:
                                                    case 198:
                                                    case 199:
                                                    case 200:
                                                    case 201:
                                                    case 202:
                                                    case 204:
                                                    case 205:
                                                    case 206:
                                                    case 207:
                                                    case 208:
                                                    case 212:
                                                    case 213:
                                                    case 214:
                                                    case 215:
                                                    case 216:
                                                    case 217:
                                                    case 218:
                                                    case 219:
                                                    case 220:
                                                    case 221:
                                                    case 222:
                                                    case 223:
                                                    case 224:
                                                    case 225:
                                                    case 226:
                                                    case 227:
                                                    case 228:
                                                    case 229:
                                                    case 230:
                                                    case 231:
                                                    case 232:
                                                    case 233:
                                                    case 234:
                                                    case 235:
                                                    case 236:
                                                    case 237:
                                                    case 238:
                                                    case 240:
                                                    case 241:
                                                    case 243:
                                                    case 244:
                                                    case 245:
                                                    case 246:
                                                    case 247:
                                                    case 248:
                                                    case 249:
                                                    case 250:
                                                    case 251:
                                                    case 253:
                                                    case 256:
                                                    case 257:
                                                    case 258:
                                                    case 259:
                                                    case 261:
                                                    case 262:
                                                    case 263:
                                                    case 264:
                                                    case 265:
                                                    case 266:
                                                    case 267:
                                                    case 268:
                                                    case 269:
                                                    case 270:
                                                    case 271:
                                                    case 272:
                                                    case 273:
                                                    case 274:
                                                    case 276:
                                                    case 277:
                                                    case 278:
                                                    case 279:
                                                    case 280:
                                                    case 281:
                                                    case 282:
                                                    case 284:
                                                    case 285:
                                                    case 286:
                                                    case 287:
                                                    case 288:
                                                    case 289:
                                                    case 290:
                                                    case 291:
                                                    case 292:
                                                    case 293:
                                                    case 294:
                                                    case 295:
                                                    case 296:
                                                    case 297:
                                                    case 298:
                                                    case 299:
                                                    case 300:
                                                    case 301:
                                                    case 302:
                                                    case 303:
                                                    case 304:
                                                    case 305:
                                                    case 306:
                                                    case 308:
                                                    case 309:
                                                    case 310:
                                                    case 311:
                                                    case 312:
                                                    case 313:
                                                    case 314:
                                                    case 315:
                                                    case 316:
                                                    case 317:
                                                    case 318:
                                                    case 319:
                                                    case 320:
                                                    case 321:
                                                    case 322:
                                                    case 323:
                                                    case 324:
                                                    case 325:
                                                    case 326:
                                                    case 327:
                                                    case 328:
                                                    case 329:
                                                    case 330:
                                                    case 331:
                                                    case 332:
                                                    case 333:
                                                    case 334:
                                                    case 335:
                                                    case 336:
                                                    case 337:
                                                    case 338:
                                                    case 339:
                                                    case 340:
                                                    case 341:
                                                        break;
                                                    case 37:
                                                    case 38:
                                                    case 41:
                                                    case 42:
                                                    case 43:
                                                    case 44:
                                                    case 45:
                                                    case 46:
                                                    case 47:
                                                    case 48:
                                                    case 49:
                                                    case 50:
                                                    case 51:
                                                    case 53:
                                                    case 54:
                                                    case 55:
                                                    case 56:
                                                    case 57:
                                                    case 58:
                                                    case 59:
                                                    case 60:
                                                    case 61:
                                                    case 62:
                                                    case 63:
                                                    case 65:
                                                    case 66:
                                                    case 67:
                                                    case 86:
                                                    case 101:
                                                    case 102:
                                                    case 103:
                                                    case 134:
                                                    case 135:
                                                    case 136:
                                                    case 151:
                                                    case 168:
                                                    case 174:
                                                    case 178:
                                                    case 192:
                                                    case 193:
                                                    case 196:
                                                    case 203:
                                                    case 209:
                                                    case 210:
                                                    case 211:
                                                    case 239:
                                                    case 242:
                                                    case 252:
                                                    case 254:
                                                    case 255:
                                                    case 260:
                                                    case 275:
                                                    case 283:
                                                    case 307:
                                                        break q;
                                                    default:
                                                        break q;
                                                }
                                                var$4 = oncipj_Cypher_Expression($this);
                                                break p;
                                            }
                                            $this.$jj_la1.data[166] = $this.$jj_gen;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 254);
                                        var$5 = oncipj_Cypher_pos($this, var$5);
                                        var$8 = $e;
                                        var$2 = var$2;
                                        var$4 = var$4;
                                        $e = oncie_ListSlice__init_(var$8, s_Option$_apply(s_Option$_MODULE$, var$2), s_Option$_apply(s_Option$_MODULE$, var$4), var$5);
                                        break g;
                                }
                                $e = oncipj_Cypher_Property($this, $e);
                            }
                        }
                        return $e;
                    }
                    oncipj_Cypher_jj_save($this, 70, 2147483647);
                    $rt_throw($e);
                }
                oncipj_Cypher_jj_save($this, 69, 2147483647);
                $rt_throw($e);
            }
            oncipj_Cypher_jj_save($this, 68, 2147483647);
            $rt_throw($e);
        }
        oncipj_Cypher_jj_save($this, 67, 2147483647);
        $rt_throw($e);
    }
    function oncipj_Cypher_Property($this, $subject) {
        var $propKeyName;
        oncipj_Cypher_jj_consume_token($this, 135);
        $propKeyName = oncipj_Cypher_PropertyKeyName($this);
        $subject = $subject;
        return oncie_Property__init_($subject, oncie_PropertyKeyName__init_($propKeyName.$string0, $propKeyName.$pos), $subject.$position2());
    }
    function oncipj_Cypher_PropertyExpression($this) {
        var $subject, var$2;
        $subject = oncipj_Cypher_Expression1($this);
        a: while (true) {
            $subject = oncipj_Cypher_Property($this, $subject);
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 135:
                    break;
                default:
                    break a;
            }
        }
        $this.$jj_la1.data[169] = $this.$jj_gen;
        return $subject;
    }
    function oncipj_Cypher_Expression1($this) {
        var var$1, var$2, $t, var$4, $$je;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$1) {
                    case 35:
                    case 36:
                    case 39:
                    case 40:
                    case 208:
                        break;
                    case 52:
                    case 64:
                        var$2 = oncipj_Cypher_pos($this, oncipj_Cypher_StringToken($this));
                        $t = oncie_StringLiteral__init_($this.$token.$image0, var$2);
                        break b;
                    case 131:
                        onciaf_ParameterType_$callClinit();
                        $t = oncipj_Cypher_Parameter($this, onciaf_ParameterType_ANY);
                        break b;
                    case 159:
                        $t = oncie_False__init_(oncipj_Cypher_pos($this, oncipj_Cypher_jj_consume_token($this, 159)));
                        break b;
                    case 183:
                    case 184:
                        var$4 = $this.$jj_ntk;
                        if (var$4 == (-1))
                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                        c: {
                            switch (var$4) {
                                case 183:
                                    break;
                                case 184:
                                    $t = oncipj_Cypher_jj_consume_token($this, 184);
                                    break c;
                                default:
                                    $this.$jj_la1.data[170] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $t = new oncipj_ParseException;
                                    jl_Exception__init_0($t);
                                    $rt_throw($t);
                            }
                            $t = oncipj_Cypher_jj_consume_token($this, 183);
                        }
                        $t = onciafn_Neo4jASTFactory_newInfinityLiteral($this.$astFactory, oncipj_Cypher_pos($this, $t));
                        break b;
                    case 214:
                        $t = oncie_NaN__init_(oncipj_Cypher_pos($this, oncipj_Cypher_jj_consume_token($this, 214)));
                        break b;
                    case 315:
                        $t = oncie_True__init_(oncipj_Cypher_pos($this, oncipj_Cypher_jj_consume_token($this, 315)));
                        break b;
                    default:
                        $this.$jj_la1.data[171] = $this.$jj_gen;
                        $this.$jj_la = 2;
                        $t = $this.$token;
                        $this.$jj_scanpos = $t;
                        $this.$jj_lastpos = $t;
                        d: {
                            e: {
                                f: {
                                    g: {
                                        try {
                                            var$1 = oncipj_Cypher_jj_3_72($this) ? 0 : 1;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                break g;
                                            } else{
                                                $t = $$je;
                                                break f;
                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 71, 2);
                                        break d;
                                    }
                                    try {
                                        var$1 = 1;
                                        break e;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        $t = $$je;

                                    }
                                }
                                oncipj_Cypher_jj_save($this, 71, 2);
                                $rt_throw($t);
                            }
                            oncipj_Cypher_jj_save($this, 71, 2);
                        }
                        if (var$1) {
                            $t = oncie_Null__init_(oncipj_Cypher_pos($this, oncipj_Cypher_jj_consume_token($this, 222)));
                            break b;
                        }
                        $this.$jj_la = 3;
                        $t = $this.$token;
                        $this.$jj_scanpos = $t;
                        $this.$jj_lastpos = $t;
                        h: {
                            i: {
                                j: {
                                    k: {
                                        try {
                                            var$1 = oncipj_Cypher_jj_3_73($this) ? 0 : 1;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                break k;
                                            } else{
                                                $t = $$je;
                                                break j;
                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 72, 3);
                                        break h;
                                    }
                                    try {
                                        var$1 = 1;
                                        break i;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        $t = $$je;

                                    }
                                }
                                oncipj_Cypher_jj_save($this, 72, 3);
                                $rt_throw($t);
                            }
                            oncipj_Cypher_jj_save($this, 72, 3);
                        }
                        if (var$1) {
                            $t = oncipj_Cypher_CaseExpression($this);
                            break b;
                        }
                        $this.$jj_la = 3;
                        $t = $this.$token;
                        $this.$jj_scanpos = $t;
                        $this.$jj_lastpos = $t;
                        l: {
                            m: {
                                n: {
                                    o: {
                                        try {
                                            var$1 = oncipj_Cypher_jj_3_74($this) ? 0 : 1;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                break o;
                                            } else{
                                                $t = $$je;
                                                break n;
                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 73, 3);
                                        break l;
                                    }
                                    try {
                                        var$1 = 1;
                                        break m;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        $t = $$je;

                                    }
                                }
                                oncipj_Cypher_jj_save($this, 73, 3);
                                $rt_throw($t);
                            }
                            oncipj_Cypher_jj_save($this, 73, 3);
                        }
                        if (var$1) {
                            $t = oncipj_Cypher_jj_consume_token($this, 113);
                            oncipj_Cypher_jj_consume_token($this, 202);
                            oncipj_Cypher_jj_consume_token($this, 307);
                            oncipj_Cypher_jj_consume_token($this, 275);
                            $t = oncie_CountStar__init_(oncipj_Cypher_pos($this, $t));
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_75($this, 3)) {
                            $t = oncipj_Cypher_MapLiteral($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_76($this, 3)) {
                            $t = oncipj_Cypher_ExistsExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_77($this, 3)) {
                            $t = oncipj_Cypher_CountExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_78($this, 3)) {
                            $t = oncipj_Cypher_CollectExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_79($this, 2)) {
                            $t = oncipj_Cypher_MapProjection($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_80($this, 2147483647)) {
                            $t = oncipj_Cypher_ListComprehension($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_81($this, 2147483647)) {
                            $t = oncipj_Cypher_PatternComprehension($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_82($this, 3)) {
                            $t = oncipj_Cypher_ListLiteral($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_83($this, 3)) {
                            $t = oncipj_Cypher_ReduceExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_84($this, 3)) {
                            $t = oncipj_Cypher_AllExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_85($this, 3)) {
                            $t = oncipj_Cypher_AnyExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_86($this, 3)) {
                            $t = oncipj_Cypher_NoneExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_87($this, 3)) {
                            $t = oncipj_Cypher_SingleExpression($this);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_88($this, 2147483647)) {
                            $t = $this.$token;
                            var$2 = oncipj_Cypher_PathPatternNonEmpty($this);
                            $t = onciafn_Neo4jASTFactory_patternExpression($this.$astFactory, oncipj_Cypher_pos($this, $t.$next1), var$2);
                            break b;
                        }
                        if (oncipj_Cypher_jj_2_89($this, 2)) {
                            $t = oncipj_Cypher_ShortestPathExpression($this);
                            break b;
                        }
                        var$4 = $this.$jj_ntk;
                        if (var$4 == (-1))
                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$4) {
                            case 202:
                                break;
                            default:
                                $this.$jj_la1.data[172] = $this.$jj_gen;
                                if (oncipj_Cypher_jj_2_90($this, 2147483647)) {
                                    $t = oncipj_Cypher_FunctionInvocation($this);
                                    break b;
                                }
                                var$4 = $this.$jj_ntk;
                                if (var$4 == (-1))
                                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$4) {
                                    case 68:
                                    case 69:
                                    case 70:
                                    case 71:
                                    case 72:
                                    case 73:
                                    case 74:
                                    case 75:
                                    case 76:
                                    case 77:
                                    case 78:
                                    case 79:
                                    case 80:
                                    case 81:
                                    case 82:
                                    case 83:
                                    case 84:
                                    case 85:
                                    case 87:
                                    case 88:
                                    case 89:
                                    case 90:
                                    case 91:
                                    case 92:
                                    case 93:
                                    case 94:
                                    case 95:
                                    case 96:
                                    case 97:
                                    case 98:
                                    case 99:
                                    case 100:
                                    case 104:
                                    case 105:
                                    case 106:
                                    case 107:
                                    case 108:
                                    case 109:
                                    case 110:
                                    case 111:
                                    case 112:
                                    case 113:
                                    case 114:
                                    case 115:
                                    case 116:
                                    case 117:
                                    case 118:
                                    case 119:
                                    case 120:
                                    case 121:
                                    case 122:
                                    case 123:
                                    case 124:
                                    case 125:
                                    case 126:
                                    case 127:
                                    case 128:
                                    case 129:
                                    case 130:
                                    case 132:
                                    case 133:
                                    case 137:
                                    case 138:
                                    case 139:
                                    case 140:
                                    case 141:
                                    case 142:
                                    case 143:
                                    case 144:
                                    case 145:
                                    case 146:
                                    case 147:
                                    case 148:
                                    case 149:
                                    case 150:
                                    case 152:
                                    case 153:
                                    case 154:
                                    case 155:
                                    case 156:
                                    case 157:
                                    case 158:
                                    case 159:
                                    case 160:
                                    case 161:
                                    case 162:
                                    case 163:
                                    case 164:
                                    case 165:
                                    case 166:
                                    case 167:
                                    case 169:
                                    case 170:
                                    case 171:
                                    case 172:
                                    case 173:
                                    case 175:
                                    case 176:
                                    case 177:
                                    case 179:
                                    case 180:
                                    case 181:
                                    case 182:
                                    case 183:
                                    case 184:
                                    case 185:
                                    case 186:
                                    case 187:
                                    case 188:
                                    case 189:
                                    case 190:
                                    case 191:
                                    case 197:
                                    case 198:
                                    case 199:
                                    case 200:
                                    case 201:
                                    case 204:
                                    case 205:
                                    case 206:
                                    case 207:
                                    case 212:
                                    case 213:
                                    case 214:
                                    case 215:
                                    case 216:
                                    case 217:
                                    case 218:
                                    case 219:
                                    case 220:
                                    case 221:
                                    case 222:
                                    case 223:
                                    case 224:
                                    case 225:
                                    case 226:
                                    case 227:
                                    case 228:
                                    case 229:
                                    case 230:
                                    case 231:
                                    case 232:
                                    case 233:
                                    case 234:
                                    case 235:
                                    case 236:
                                    case 237:
                                    case 240:
                                    case 241:
                                    case 243:
                                    case 244:
                                    case 245:
                                    case 246:
                                    case 247:
                                    case 248:
                                    case 249:
                                    case 250:
                                    case 251:
                                    case 253:
                                    case 256:
                                    case 257:
                                    case 258:
                                    case 259:
                                    case 261:
                                    case 262:
                                    case 263:
                                    case 264:
                                    case 265:
                                    case 266:
                                    case 267:
                                    case 268:
                                    case 269:
                                    case 270:
                                    case 271:
                                    case 272:
                                    case 273:
                                    case 274:
                                    case 276:
                                    case 277:
                                    case 278:
                                    case 279:
                                    case 280:
                                    case 281:
                                    case 282:
                                    case 284:
                                    case 285:
                                    case 286:
                                    case 287:
                                    case 288:
                                    case 289:
                                    case 290:
                                    case 291:
                                    case 292:
                                    case 293:
                                    case 294:
                                    case 295:
                                    case 296:
                                    case 297:
                                    case 298:
                                    case 299:
                                    case 300:
                                    case 301:
                                    case 302:
                                    case 303:
                                    case 304:
                                    case 305:
                                    case 306:
                                    case 308:
                                    case 309:
                                    case 310:
                                    case 311:
                                    case 312:
                                    case 313:
                                    case 314:
                                    case 315:
                                    case 316:
                                    case 317:
                                    case 318:
                                    case 319:
                                    case 320:
                                    case 321:
                                    case 322:
                                    case 323:
                                    case 324:
                                    case 325:
                                    case 326:
                                    case 327:
                                    case 328:
                                    case 329:
                                    case 330:
                                    case 331:
                                    case 332:
                                    case 333:
                                    case 334:
                                    case 335:
                                    case 336:
                                    case 337:
                                    case 338:
                                    case 339:
                                    case 340:
                                    case 341:
                                        break;
                                    case 86:
                                    case 101:
                                    case 102:
                                    case 103:
                                    case 131:
                                    case 134:
                                    case 135:
                                    case 136:
                                    case 151:
                                    case 168:
                                    case 174:
                                    case 178:
                                    case 192:
                                    case 193:
                                    case 194:
                                    case 195:
                                    case 196:
                                    case 202:
                                    case 203:
                                    case 208:
                                    case 209:
                                    case 210:
                                    case 211:
                                    case 238:
                                    case 239:
                                    case 242:
                                    case 252:
                                    case 254:
                                    case 255:
                                    case 260:
                                    case 275:
                                    case 283:
                                    case 307:
                                        break a;
                                    default:
                                        break a;
                                }
                                $t = oncipj_Cypher_Variable($this);
                                break b;
                        }
                        oncipj_Cypher_jj_consume_token($this, 202);
                        $t = $this.$labelExpressionStack;
                        oncipj_ExpectBar_$callClinit();
                        ju_Stack_push($t, oncipj_ExpectBar_DO_NOT_EXPECT_BAR);
                        $t = oncipj_Cypher_Expression($this);
                        ju_Stack_pop($this.$labelExpressionStack);
                        oncipj_Cypher_jj_consume_token($this, 275);
                        break b;
                }
                $t = oncipj_Cypher_NumberLiteral($this);
            }
            return $t;
        }
        $this.$jj_la1.data[173] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $t = new oncipj_ParseException;
        jl_Throwable__init_0($t);
        $rt_throw($t);
    }
    function oncipj_Cypher_CaseExpression($this) {
        var $caseExpr, $when, $then, $elseCase, $t, $e, var$7, var$8, var$9, var$10, var$11, $$je;
        $caseExpr = null;
        $when = ju_ArrayList__init_();
        $then = ju_ArrayList__init_();
        $elseCase = null;
        $t = oncipj_Cypher_jj_consume_token($this, 97);
        $this.$jj_la = 2147483647;
        $e = $this.$token;
        $this.$jj_scanpos = $e;
        $this.$jj_lastpos = $e;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$7 = oncipj_Cypher_jj_3_91($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $caseExpr = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 90, 2147483647);
                        break a;
                    }
                    try {
                        var$7 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $caseExpr = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 90, 2147483647);
                $rt_throw($caseExpr);
            }
            oncipj_Cypher_jj_save($this, 90, 2147483647);
        }
        e: {
            if (var$7) {
                $caseExpr = oncipj_Cypher_Expression($this);
                oncipj_Cypher_jj_consume_token($this, 333);
            } else {
                var$8 = $this.$jj_ntk;
                if (var$8 == (-1))
                    var$8 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$8) {
                    case 333:
                        oncipj_Cypher_jj_consume_token($this, 333);
                        break e;
                    default:
                }
                $this.$jj_la1.data[174] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $caseExpr = new oncipj_ParseException;
                jl_Throwable__init_0($caseExpr);
                $rt_throw($caseExpr);
            }
        }
        ju_ArrayList_add($when, oncipj_Cypher_Expression($this));
        oncipj_Cypher_jj_consume_token($this, 305);
        ju_ArrayList_add($then, oncipj_Cypher_Expression($this));
        f: while (true) {
            var$8 = $this.$jj_ntk;
            if (var$8 == (-1))
                var$8 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$8) {
                case 333:
                    break;
                default:
                    break f;
            }
            oncipj_Cypher_jj_consume_token($this, 333);
            ju_ArrayList_add($when, oncipj_Cypher_Expression($this));
            oncipj_Cypher_jj_consume_token($this, 305);
            ju_ArrayList_add($then, oncipj_Cypher_Expression($this));
        }
        $this.$jj_la1.data[175] = $this.$jj_gen;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        g: {
            switch (var$8) {
                case 147:
                    break;
                default:
                    $this.$jj_la1.data[176] = $this.$jj_gen;
                    break g;
            }
            oncipj_Cypher_jj_consume_token($this, 147);
            $elseCase = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 149);
        $e = $this.$astFactory;
        $t = oncipj_Cypher_pos($this, $t);
        $caseExpr = $caseExpr;
        $elseCase = $elseCase;
        var$9 = $when.$size2;
        if (var$9 != $then.$size2) {
            $caseExpr = new onciafn_Neo4jASTConstructionException;
            $when = onciafn_Neo4jASTFactory_pretty($e, $when);
            $then = onciafn_Neo4jASTFactory_pretty($e, $then);
            $e = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($e);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($e, $rt_s(918)), $when), $rt_s(919)), $then), 96);
            jl_Throwable__init_($caseExpr, jl_AbstractStringBuilder_toString($e));
            $rt_throw($caseExpr);
        }
        var$10 = $rt_createArray(s_Tuple2, var$9);
        var$11 = var$10.data;
        var$8 = 0;
        while (var$8 < $when.$size2) {
            $e = s_Predef$ArrowAssoc$_MODULE$;
            s_Predef$_$callClinit();
            var$11[var$8] = s_Predef$ArrowAssoc$_$minus$greater$extension($e, ju_ArrayList_get($when, var$8), ju_ArrayList_get($then, var$8));
            var$8 = var$8 + 1 | 0;
        }
        $then = new oncie_CaseExpression;
        $caseExpr = s_Option$_apply(s_Option$_MODULE$, $caseExpr);
        $when = sc_ArrayOps$_MODULE$;
        s_Predef$_$callClinit();
        oncie_CaseExpression__init_($then, $caseExpr, sc_ArrayOps$_toIndexedSeq$extension($when, var$10), s_Option$_apply(s_Option$_MODULE$, $elseCase), $t);
        return $then;
    }
    function oncipj_Cypher_ListComprehension($this) {
        var $where, $projection, $e, $t, $v, var$6;
        $where = null;
        $projection = null;
        $e = $this.$labelExpressionStack;
        oncipj_ExpectBar_$callClinit();
        ju_Stack_push($e, oncipj_ExpectBar_EXPECT_BAR);
        $t = oncipj_Cypher_jj_consume_token($this, 194);
        $v = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 180);
        $e = oncipj_Cypher_Expression($this);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[177] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $where = oncipj_Cypher_Expression($this);
        }
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$6) {
                case 86:
                    break;
                default:
                    $this.$jj_la1.data[178] = $this.$jj_gen;
                    break b;
            }
            oncipj_Cypher_jj_consume_token($this, 86);
            $projection = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 254);
        ju_Stack_pop($this.$labelExpressionStack);
        $t = oncipj_Cypher_pos($this, $t);
        $e = $e;
        $where = $where;
        $projection = $projection;
        $where = s_Option$_apply(s_Option$_MODULE$, $where);
        $projection = s_Option$_apply(s_Option$_MODULE$, $projection);
        return oncie_ListComprehension__init_(oncie_ExtractScope__init_($v, $where, $projection, $t), $e, $t);
    }
    function oncipj_Cypher_PatternComprehension($this) {
        var $v, $where, $t, var$4, $relationshipPatternPosition, $p, var$7, var$8, var$9;
        $v = null;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 194);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$4) {
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 202:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break b;
                    default:
                        break b;
                }
                $v = oncipj_Cypher_Variable($this);
                oncipj_Cypher_jj_consume_token($this, 151);
                break a;
            }
            $this.$jj_la1.data[179] = $this.$jj_gen;
        }
        $relationshipPatternPosition = $this.$token;
        $p = oncipj_Cypher_PathPatternNonEmpty($this);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$4) {
                case 334:
                    oncipj_Cypher_jj_consume_token($this, 334);
                    $where = $this.$labelExpressionStack;
                    oncipj_ExpectBar_$callClinit();
                    ju_Stack_push($where, oncipj_ExpectBar_EXPECT_BAR);
                    $where = oncipj_Cypher_Expression($this);
                    ju_Stack_pop($this.$labelExpressionStack);
                    break c;
                default:
            }
            $this.$jj_la1.data[180] = $this.$jj_gen;
        }
        oncipj_Cypher_jj_consume_token($this, 86);
        var$7 = oncipj_Cypher_Expression($this);
        oncipj_Cypher_jj_consume_token($this, 254);
        $t = oncipj_Cypher_pos($this, $t);
        $relationshipPatternPosition = oncipj_Cypher_pos($this, $relationshipPatternPosition.$next1);
        $where = $where;
        var$7 = var$7;
        var$8 = new oncie_PatternComprehension;
        $v = s_Option$_apply(s_Option$_MODULE$, $v);
        var$9 = oncie_RelationshipsPattern__init_($p.$element2, $relationshipPatternPosition);
        $relationshipPatternPosition = s_Option$_apply(s_Option$_MODULE$, $where);
        $where = s_None$_MODULE$;
        oncie_PatternComprehension__init_(var$8, $v, var$9, $relationshipPatternPosition, var$7, $t, $where, $where);
        return var$8;
    }
    function oncipj_Cypher_ReduceExpression($this) {
        var $t, $acc, $accExpr, $v, $vExpr, $innerExpr;
        $t = oncipj_Cypher_jj_consume_token($this, 258);
        oncipj_Cypher_jj_consume_token($this, 202);
        $acc = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 151);
        $accExpr = oncipj_Cypher_Expression($this);
        oncipj_Cypher_jj_consume_token($this, 103);
        $v = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 180);
        $vExpr = oncipj_Cypher_Expression($this);
        oncipj_Cypher_jj_consume_token($this, 86);
        $innerExpr = oncipj_Cypher_Expression($this);
        oncipj_Cypher_jj_consume_token($this, 275);
        $t = oncipj_Cypher_pos($this, $t);
        $accExpr = $accExpr;
        $vExpr = $vExpr;
        $innerExpr = $innerExpr;
        return oncie_ReduceExpression__init_(oncie_ReduceScope__init_($acc, $v, $innerExpr, $t), $accExpr, $vExpr, $t);
    }
    function oncipj_Cypher_AllExpression($this) {
        var $where, $t, $v, $e, var$5;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 76);
        oncipj_Cypher_jj_consume_token($this, 202);
        $v = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 180);
        $e = oncipj_Cypher_Expression($this);
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[183] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $where = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 275);
        $t = oncipj_Cypher_pos($this, $t);
        $e = $e;
        $where = $where;
        $where = s_Option$_apply(s_Option$_MODULE$, $where);
        return oncie_AllIterablePredicate__init_(oncie_FilterScope__init_($v, $where, $t), $e, $t);
    }
    function oncipj_Cypher_AnyExpression($this) {
        var $where, $t, $v, $e, var$5;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 79);
        oncipj_Cypher_jj_consume_token($this, 202);
        $v = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 180);
        $e = oncipj_Cypher_Expression($this);
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[184] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $where = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 275);
        $t = oncipj_Cypher_pos($this, $t);
        $e = $e;
        $where = $where;
        $where = s_Option$_apply(s_Option$_MODULE$, $where);
        return oncie_AnyIterablePredicate__init_(oncie_FilterScope__init_($v, $where, $t), $e, $t);
    }
    function oncipj_Cypher_NoneExpression($this) {
        var $where, $t, $v, $e, var$5;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 218);
        oncipj_Cypher_jj_consume_token($this, 202);
        $v = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 180);
        $e = oncipj_Cypher_Expression($this);
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[185] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $where = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 275);
        $t = oncipj_Cypher_pos($this, $t);
        $e = $e;
        $where = $where;
        $where = s_Option$_apply(s_Option$_MODULE$, $where);
        return oncie_NoneIterablePredicate__init_(oncie_FilterScope__init_($v, $where, $t), $e, $t);
    }
    function oncipj_Cypher_SingleExpression($this) {
        var $where, $t, $v, $e, var$5;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 293);
        oncipj_Cypher_jj_consume_token($this, 202);
        $v = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 180);
        $e = oncipj_Cypher_Expression($this);
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[186] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 334);
            $where = oncipj_Cypher_Expression($this);
        }
        oncipj_Cypher_jj_consume_token($this, 275);
        $t = oncipj_Cypher_pos($this, $t);
        $e = $e;
        $where = $where;
        $where = s_Option$_apply(s_Option$_MODULE$, $where);
        return oncie_SingleIterablePredicate__init_(oncie_FilterScope__init_($v, $where, $t), $e, $t);
    }
    function oncipj_Cypher_ShortestPathExpression($this) {
        var $t, $p;
        $t = $this.$token;
        $p = oncipj_Cypher_ShortestPathPattern($this);
        return onciafn_Neo4jASTFactory_patternExpression($this.$astFactory, oncipj_Cypher_pos($this, $t.$next1), $p);
    }
    function oncipj_Cypher_MapProjection($this) {
        var $items, $v, $t, var$4, $x;
        $items = ju_ArrayList__init_();
        $v = oncipj_Cypher_Variable($this);
        $t = oncipj_Cypher_jj_consume_token($this, 195);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$4) {
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 135:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 202:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break b;
                    default:
                        break b;
                }
                ju_ArrayList_add($items, oncipj_Cypher_MapProjectionItem($this));
                break a;
            }
            $this.$jj_la1.data[187] = $this.$jj_gen;
        }
        c: while (true) {
            var$4 = $this.$jj_ntk;
            if (var$4 == (-1))
                var$4 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$4) {
                case 103:
                    break;
                default:
                    break c;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($items, oncipj_Cypher_MapProjectionItem($this));
        }
        $this.$jj_la1.data[188] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, 255);
        $x = oncipj_Cypher_pos($this, $t);
        return oncie_MapProjection__init_($v, sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $items))), $x);
    }
    function oncipj_Cypher_MapProjectionItem($this) {
        var $t, var$2, $p, var$4, $v, $$je;
        $this.$jj_la = 2;
        $t = $this.$token;
        $this.$jj_scanpos = $t;
        $this.$jj_lastpos = $t;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_92($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $t = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 91, 2);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 91, 2);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 91, 2);
        }
        if (var$2) {
            $p = oncipj_Cypher_PropertyKeyName($this);
            oncipj_Cypher_jj_consume_token($this, 101);
            $t = oncipj_Cypher_Expression($this);
            return oncie_LiteralEntry__init_(oncie_PropertyKeyName__init_($p.$string0, $p.$pos), $t, $t.$position2());
        }
        $this.$jj_la = 2;
        $t = $this.$token;
        $this.$jj_scanpos = $t;
        $this.$jj_lastpos = $t;
        e: {
            f: {
                g: {
                    h: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_93($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break h;
                            } else{
                                $t = $$je;
                                break g;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 92, 2);
                        break e;
                    }
                    try {
                        var$2 = 1;
                        break f;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $t = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 92, 2);
                $rt_throw($t);
            }
            oncipj_Cypher_jj_save($this, 92, 2);
        }
        if (var$2) {
            oncipj_Cypher_jj_consume_token($this, 135);
            $p = oncipj_Cypher_PropertyKeyName($this);
            return oncie_PropertySelector__init_(oncie_PropertyKeyName__init_($p.$string0, $p.$pos), $p.$pos);
        }
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        i: {
            switch (var$4) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    break;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break i;
                case 135:
                    oncipj_Cypher_jj_consume_token($this, 135);
                    return oncie_AllPropertiesSelector__init_0(oncipj_Cypher_pos($this, oncipj_Cypher_jj_consume_token($this, 307)));
                default:
                    break i;
            }
            $v = oncipj_Cypher_Variable($this);
            return oncie_VariableSelector__init_($v, $v.$position0);
        }
        $this.$jj_la1.data[189] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $t = new oncipj_ParseException;
        jl_Throwable__init_0($t);
        $rt_throw($t);
    }
    function oncipj_Cypher_ExistsExpression($this) {
        var $patterns, $matchMode, $q, $where, $t, var$6, var$7, var$8;
        $patterns = null;
        $matchMode = null;
        $q = null;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 156);
        oncipj_Cypher_jj_consume_token($this, 195);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 127:
                case 128:
                case 129:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 200:
                case 201:
                case 202:
                case 204:
                case 205:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 265:
                case 266:
                case 267:
                case 268:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 323:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$6) {
                            case 132:
                            case 243:
                                break;
                            default:
                                $this.$jj_la1.data[190] = $this.$jj_gen;
                                break b;
                        }
                        $matchMode = oncipj_Cypher_MatchMode($this);
                    }
                    $patterns = oncipj_Cypher_PatternList($this);
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 334:
                            break;
                        default:
                            $this.$jj_la1.data[191] = $this.$jj_gen;
                            break a;
                    }
                    $where = oncipj_Cypher_WhereClause($this);
                    break a;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                case 96:
                case 114:
                case 126:
                case 130:
                case 163:
                case 199:
                case 206:
                case 207:
                case 226:
                case 264:
                case 269:
                case 286:
                case 322:
                case 324:
                case 335:
                    $q = oncipj_Cypher_RegularQuery($this);
                    break a;
                default:
            }
            $this.$jj_la1.data[192] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $patterns = new oncipj_ParseException;
            jl_Throwable__init_0($patterns);
            $rt_throw($patterns);
        }
        oncipj_Cypher_jj_consume_token($this, 255);
        var$7 = $this.$astFactory;
        $t = oncipj_Cypher_pos($this, $t);
        var$8 = new oncia_ExistsExpression;
        $patterns = onciafn_Neo4jASTFactory_convertSubqueryExpressionToUnifiedExpression(var$7, $matchMode, $patterns, $q, $where);
        $matchMode = s_None$_MODULE$;
        oncia_ExistsExpression__init_(var$8, $patterns, $t, $matchMode, $matchMode);
        return var$8;
    }
    function oncipj_Cypher_CountExpression($this) {
        var $patterns, $matchMode, $q, $where, $t, var$6, var$7, var$8;
        $patterns = null;
        $matchMode = null;
        $q = null;
        $where = null;
        $t = oncipj_Cypher_jj_consume_token($this, 113);
        oncipj_Cypher_jj_consume_token($this, 195);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 127:
                case 128:
                case 129:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 200:
                case 201:
                case 202:
                case 204:
                case 205:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 265:
                case 266:
                case 267:
                case 268:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 323:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$6) {
                            case 132:
                            case 243:
                                break;
                            default:
                                $this.$jj_la1.data[193] = $this.$jj_gen;
                                break b;
                        }
                        $matchMode = oncipj_Cypher_MatchMode($this);
                    }
                    $patterns = oncipj_Cypher_PatternList($this);
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 334:
                            break;
                        default:
                            $this.$jj_la1.data[194] = $this.$jj_gen;
                            break a;
                    }
                    $where = oncipj_Cypher_WhereClause($this);
                    break a;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                case 96:
                case 114:
                case 126:
                case 130:
                case 163:
                case 199:
                case 206:
                case 207:
                case 226:
                case 264:
                case 269:
                case 286:
                case 322:
                case 324:
                case 335:
                    $q = oncipj_Cypher_RegularQuery($this);
                    break a;
                default:
            }
            $this.$jj_la1.data[195] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $patterns = new oncipj_ParseException;
            jl_Throwable__init_0($patterns);
            $rt_throw($patterns);
        }
        oncipj_Cypher_jj_consume_token($this, 255);
        var$7 = $this.$astFactory;
        $t = oncipj_Cypher_pos($this, $t);
        var$8 = new oncia_CountExpression;
        $patterns = onciafn_Neo4jASTFactory_convertSubqueryExpressionToUnifiedExpression(var$7, $matchMode, $patterns, $q, $where);
        $matchMode = s_None$_MODULE$;
        oncia_CountExpression__init_(var$8, $patterns, $t, $matchMode, $matchMode);
        return var$8;
    }
    function oncipj_Cypher_CollectExpression($this) {
        var $t, $q, var$3, var$4;
        $t = oncipj_Cypher_jj_consume_token($this, 100);
        oncipj_Cypher_jj_consume_token($this, 195);
        $q = oncipj_Cypher_RegularQuery($this);
        oncipj_Cypher_jj_consume_token($this, 255);
        $t = oncipj_Cypher_pos($this, $t);
        var$3 = new oncia_CollectExpression;
        var$4 = s_None$_MODULE$;
        oncia_CollectExpression__init_(var$3, $q, $t, var$4, var$4);
        return var$3;
    }
    function oncipj_Cypher_NumberLiteral($this) {
        var $sign, $negated, var$3, var$4, $t, var$6, var$7;
        $sign = null;
        $negated = 0;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 208:
                    break;
                default:
                    $this.$jj_la1.data[196] = $this.$jj_gen;
                    break a;
            }
            $sign = oncipj_Cypher_jj_consume_token($this, 208);
            $negated = 1;
        }
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$4) {
            case 35:
                $t = oncipj_Cypher_jj_consume_token($this, 35);
                if ($sign !== null)
                    $t = $sign;
                $t = oncipj_Cypher_pos($this, $t);
                if ($sign === null)
                    $sign = $this.$token.$image0;
                else {
                    $sign = $sign.$image0;
                    var$6 = $this.$token.$image0;
                    var$7 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$7);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$7, $sign), var$6);
                    $sign = jl_AbstractStringBuilder_toString(var$7);
                }
                return oncie_DecimalDoubleLiteral__init_($sign, $t);
            case 36:
                $t = oncipj_Cypher_jj_consume_token($this, 36);
                var$6 = $this.$astFactory;
                if ($sign !== null)
                    $t = $sign;
                return onciafn_Neo4jASTFactory_newDecimalInteger(var$6, oncipj_Cypher_pos($this, $t), $this.$token.$image0, $negated);
            case 37:
            case 38:
                break;
            case 39:
                $t = oncipj_Cypher_jj_consume_token($this, 39);
                if ($sign !== null)
                    $t = $sign;
                $sign = oncipj_Cypher_pos($this, $t);
                $t = $this.$token.$image0;
                if (!$negated)
                    var$6 = oncie_SignedHexIntegerLiteral__init_($t, $sign);
                else {
                    var$6 = new oncie_SignedHexIntegerLiteral;
                    var$7 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$7);
                    jl_AbstractStringBuilder_append(var$7, 45);
                    jl_StringBuilder_append(var$7, $t);
                    oncie_SignedHexIntegerLiteral__init_0(var$6, jl_AbstractStringBuilder_toString(var$7), $sign);
                }
                return var$6;
            case 40:
                $t = oncipj_Cypher_jj_consume_token($this, 40);
                if ($sign !== null)
                    $t = $sign;
                $sign = oncipj_Cypher_pos($this, $t);
                $t = $this.$token.$image0;
                if (!$negated)
                    var$6 = oncie_SignedOctalIntegerLiteral__init_($t, $sign);
                else {
                    var$6 = new oncie_SignedOctalIntegerLiteral;
                    var$7 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$7);
                    jl_AbstractStringBuilder_append(var$7, 45);
                    jl_StringBuilder_append(var$7, $t);
                    oncie_SignedOctalIntegerLiteral__init_0(var$6, jl_AbstractStringBuilder_toString(var$7), $sign);
                }
                return var$6;
            default:
        }
        $this.$jj_la1.data[197] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $sign = new oncipj_ParseException;
        jl_Throwable__init_0($sign);
        $rt_throw($sign);
    }
    function oncipj_Cypher_SignedIntegerLiteral($this) {
        var $sign, $negated, var$3, $number, var$5;
        $sign = null;
        $negated = 0;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 208:
                    break;
                default:
                    $this.$jj_la1.data[198] = $this.$jj_gen;
                    break a;
            }
            $sign = oncipj_Cypher_jj_consume_token($this, 208);
            $negated = 1;
        }
        $number = oncipj_Cypher_jj_consume_token($this, 36);
        var$5 = $this.$astFactory;
        if ($sign !== null)
            $number = $sign;
        return onciafn_Neo4jASTFactory_newDecimalInteger(var$5, oncipj_Cypher_pos($this, $number), $this.$token.$image0, $negated);
    }
    function oncipj_Cypher_ListLiteral($this) {
        var $list, $t, var$3;
        $list = ju_ArrayList__init_();
        $t = oncipj_Cypher_jj_consume_token($this, 194);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$3) {
                    case 35:
                    case 36:
                    case 39:
                    case 40:
                    case 52:
                    case 64:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 131:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 194:
                    case 195:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 202:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 208:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 238:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 37:
                    case 38:
                    case 41:
                    case 42:
                    case 43:
                    case 44:
                    case 45:
                    case 46:
                    case 47:
                    case 48:
                    case 49:
                    case 50:
                    case 51:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                    case 57:
                    case 58:
                    case 59:
                    case 60:
                    case 61:
                    case 62:
                    case 63:
                    case 65:
                    case 66:
                    case 67:
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 196:
                    case 203:
                    case 209:
                    case 210:
                    case 211:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break b;
                    default:
                        break b;
                }
                ju_ArrayList_add($list, oncipj_Cypher_Expression($this));
                break a;
            }
            $this.$jj_la1.data[199] = $this.$jj_gen;
        }
        c: while (true) {
            var$3 = $this.$jj_ntk;
            if (var$3 == (-1))
                var$3 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$3) {
                case 103:
                    break;
                default:
                    break c;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($list, oncipj_Cypher_Expression($this));
        }
        $this.$jj_la1.data[200] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, 254);
        $t = oncipj_Cypher_pos($this, $t);
        return oncie_ListLiteral__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $list))), $t);
    }
    function oncipj_Cypher_MapLiteral($this) {
        var $keys, $values, $t, var$4, $key, $value, var$7, var$8, var$9;
        $keys = ju_ArrayList__init_();
        $values = ju_ArrayList__init_();
        $t = oncipj_Cypher_jj_consume_token($this, 195);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $key = oncipj_Cypher_PropertyKeyName($this);
                    oncipj_Cypher_jj_consume_token($this, 101);
                    $value = oncipj_Cypher_Expression($this);
                    ju_ArrayList_add($keys, $key);
                    ju_ArrayList_add($values, $value);
                    break a;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                default:
            }
            $this.$jj_la1.data[201] = $this.$jj_gen;
        }
        b: while (true) {
            var$4 = $this.$jj_ntk;
            if (var$4 == (-1))
                var$4 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$4) {
                case 103:
                    break;
                default:
                    break b;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            $key = oncipj_Cypher_PropertyKeyName($this);
            oncipj_Cypher_jj_consume_token($this, 101);
            $value = oncipj_Cypher_Expression($this);
            ju_ArrayList_add($keys, $key);
            ju_ArrayList_add($values, $value);
        }
        $this.$jj_la1.data[202] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, 255);
        $key = $this.$astFactory;
        $t = oncipj_Cypher_pos($this, $t);
        var$7 = $keys.$size2;
        if (var$7 != $values.$size2) {
            $t = new onciafn_Neo4jASTConstructionException;
            $keys = onciafn_Neo4jASTFactory_pretty($key, $keys);
            $values = onciafn_Neo4jASTFactory_pretty($key, $values);
            $key = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($key);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($key, $rt_s(920)), $keys), $rt_s(921)), $values), 96);
            jl_Throwable__init_($t, jl_AbstractStringBuilder_toString($key));
            $rt_throw($t);
        }
        var$4 = 0;
        var$8 = $rt_createArray(s_Tuple2, var$7);
        var$9 = var$8.data;
        while (var$4 < $keys.$size2) {
            $key = ju_ArrayList_get($keys, var$4);
            $value = s_Predef$ArrowAssoc$_MODULE$;
            s_Predef$_$callClinit();
            var$9[var$4] = s_Predef$ArrowAssoc$_$minus$greater$extension($value, oncie_PropertyKeyName__init_($key.$string0, $key.$pos), ju_ArrayList_get($values, var$4));
            var$4 = var$4 + 1 | 0;
        }
        $values = new oncie_MapExpression;
        $keys = sc_ArrayOps$_MODULE$;
        s_Predef$_$callClinit();
        oncie_MapExpression__init_($values, sc_ArrayOps$_toIndexedSeq$extension($keys, var$8), $t);
        return $values;
    }
    function oncipj_Cypher_PropertyKeyName($this) {
        var $t;
        $t = oncipj_Cypher_SymbolicNameString($this);
        return onciaf_ASTFactory$StringPos__init_($t.$image0, oncipj_Cypher_pos($this, $t));
    }
    function oncipj_Cypher_Parameter($this, $type) {
        var $t, var$3, $v, var$5;
        $t = oncipj_Cypher_jj_consume_token($this, 131);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$3) {
            case 36:
                oncipj_Cypher_jj_consume_token($this, 36);
                $v = $this.$astFactory;
                $t = oncipj_Cypher_pos($this, $t);
                return oncie_ExplicitParameter__init_($this.$token.$image0, onciafn_Neo4jASTFactory_transformParameterType($v, $type), onciu_UnknownSize$_MODULE$, $t);
            case 37:
            case 38:
            case 39:
            case 40:
            case 41:
            case 42:
            case 43:
            case 44:
            case 45:
            case 46:
            case 47:
            case 48:
            case 49:
            case 50:
            case 51:
            case 52:
            case 53:
            case 54:
            case 55:
            case 56:
            case 57:
            case 58:
            case 59:
            case 60:
            case 61:
            case 62:
            case 63:
            case 64:
            case 65:
            case 66:
            case 67:
            case 86:
            case 101:
            case 102:
            case 103:
            case 131:
            case 134:
            case 135:
            case 136:
            case 151:
            case 168:
            case 174:
            case 178:
            case 192:
            case 193:
            case 194:
            case 195:
            case 196:
            case 202:
            case 203:
            case 208:
            case 209:
            case 210:
            case 211:
            case 238:
            case 239:
            case 242:
            case 252:
            case 254:
            case 255:
            case 260:
            case 275:
            case 283:
            case 307:
                break;
            case 68:
            case 69:
            case 70:
            case 71:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
            case 78:
            case 79:
            case 80:
            case 81:
            case 82:
            case 83:
            case 84:
            case 85:
            case 87:
            case 88:
            case 89:
            case 90:
            case 91:
            case 92:
            case 93:
            case 94:
            case 95:
            case 96:
            case 97:
            case 98:
            case 99:
            case 100:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
            case 110:
            case 111:
            case 112:
            case 113:
            case 114:
            case 115:
            case 116:
            case 117:
            case 118:
            case 119:
            case 120:
            case 121:
            case 122:
            case 123:
            case 124:
            case 125:
            case 126:
            case 127:
            case 128:
            case 129:
            case 130:
            case 132:
            case 133:
            case 137:
            case 138:
            case 139:
            case 140:
            case 141:
            case 142:
            case 143:
            case 144:
            case 145:
            case 146:
            case 147:
            case 148:
            case 149:
            case 150:
            case 152:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
            case 160:
            case 161:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
            case 167:
            case 169:
            case 170:
            case 171:
            case 172:
            case 173:
            case 175:
            case 176:
            case 177:
            case 179:
            case 180:
            case 181:
            case 182:
            case 183:
            case 184:
            case 185:
            case 186:
            case 187:
            case 188:
            case 189:
            case 190:
            case 191:
            case 197:
            case 198:
            case 199:
            case 200:
            case 201:
            case 204:
            case 205:
            case 206:
            case 207:
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 218:
            case 219:
            case 220:
            case 221:
            case 222:
            case 223:
            case 224:
            case 225:
            case 226:
            case 227:
            case 228:
            case 229:
            case 230:
            case 231:
            case 232:
            case 233:
            case 234:
            case 235:
            case 236:
            case 237:
            case 240:
            case 241:
            case 243:
            case 244:
            case 245:
            case 246:
            case 247:
            case 248:
            case 249:
            case 250:
            case 251:
            case 253:
            case 256:
            case 257:
            case 258:
            case 259:
            case 261:
            case 262:
            case 263:
            case 264:
            case 265:
            case 266:
            case 267:
            case 268:
            case 269:
            case 270:
            case 271:
            case 272:
            case 273:
            case 274:
            case 276:
            case 277:
            case 278:
            case 279:
            case 280:
            case 281:
            case 282:
            case 284:
            case 285:
            case 286:
            case 287:
            case 288:
            case 289:
            case 290:
            case 291:
            case 292:
            case 293:
            case 294:
            case 295:
            case 296:
            case 297:
            case 298:
            case 299:
            case 300:
            case 301:
            case 302:
            case 303:
            case 304:
            case 305:
            case 306:
            case 308:
            case 309:
            case 310:
            case 311:
            case 312:
            case 313:
            case 314:
            case 315:
            case 316:
            case 317:
            case 318:
            case 319:
            case 320:
            case 321:
            case 322:
            case 323:
            case 324:
            case 325:
            case 326:
            case 327:
            case 328:
            case 329:
            case 330:
            case 331:
            case 332:
            case 333:
            case 334:
            case 335:
            case 336:
            case 337:
            case 338:
            case 339:
            case 340:
            case 341:
                $v = oncipj_Cypher_Variable($this);
                var$5 = $this.$astFactory;
                $t = oncipj_Cypher_pos($this, $t);
                return oncie_ExplicitParameter__init_($v.$name4, onciafn_Neo4jASTFactory_transformParameterType(var$5, $type), onciu_UnknownSize$_MODULE$, $t);
            default:
        }
        $this.$jj_la1.data[203] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $type = new oncipj_ParseException;
        jl_Throwable__init_0($type);
        $rt_throw($type);
    }
    function oncipj_Cypher_FunctionInvocation($this) {
        var $before, $distinct, $arguments, $namespace, $nameToken, $e, var$7, var$8, var$9, var$10, var$11, $$je;
        $before = $this.$token;
        $distinct = 0;
        $arguments = ju_ArrayList__init_();
        $namespace = oncipj_Cypher_Namespace($this);
        $nameToken = oncipj_Cypher_SymbolicNameString($this);
        oncipj_Cypher_jj_consume_token($this, 202);
        $this.$jj_la = 2;
        $e = $this.$token;
        $this.$jj_scanpos = $e;
        $this.$jj_lastpos = $e;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$7 = oncipj_Cypher_jj_3_94($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $before = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 93, 2);
                        break a;
                    }
                    try {
                        var$7 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $before = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 93, 2);
                $rt_throw($before);
            }
            oncipj_Cypher_jj_save($this, 93, 2);
        }
        if (var$7) {
            oncipj_Cypher_jj_consume_token($this, 133);
            $distinct = 1;
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        e: {
            f: {
                switch (var$8) {
                    case 35:
                    case 36:
                    case 39:
                    case 40:
                    case 52:
                    case 64:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 131:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 194:
                    case 195:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 202:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 208:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 238:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 37:
                    case 38:
                    case 41:
                    case 42:
                    case 43:
                    case 44:
                    case 45:
                    case 46:
                    case 47:
                    case 48:
                    case 49:
                    case 50:
                    case 51:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                    case 57:
                    case 58:
                    case 59:
                    case 60:
                    case 61:
                    case 62:
                    case 63:
                    case 65:
                    case 66:
                    case 67:
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 196:
                    case 203:
                    case 209:
                    case 210:
                    case 211:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break f;
                    default:
                        break f;
                }
                ju_ArrayList_add($arguments, oncipj_Cypher_Expression($this));
                break e;
            }
            $this.$jj_la1.data[204] = $this.$jj_gen;
        }
        g: while (true) {
            var$9 = $this.$jj_ntk;
            if (var$9 == (-1))
                var$9 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$9) {
                case 103:
                    break;
                default:
                    break g;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($arguments, oncipj_Cypher_Expression($this));
        }
        $this.$jj_la1.data[205] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, 275);
        $e = oncipj_Cypher_pos($this, $before.$next1);
        var$10 = oncipj_Cypher_pos($this, $nameToken);
        var$11 = $nameToken.$image0;
        return oncie_FunctionInvocation__init_(oncie_Namespace__init_(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $namespace))), $e), oncie_FunctionName__init_(var$11, var$10), $distinct, sc_AbstractIterable_toIndexedSeq(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $arguments))), $e);
    }
    function oncipj_Cypher_Namespace($this) {
        var $parts, $t, var$3, $$je;
        $parts = ju_ArrayList__init_();
        a: {
            while (true) {
                $this.$jj_la = 2;
                $t = $this.$token;
                $this.$jj_scanpos = $t;
                $this.$jj_lastpos = $t;
                b: {
                    c: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_95($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break c;
                            } else{
                                $parts = $$je;
                                break a;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 94, 2);
                        break b;
                    }
                    try {
                        var$3 = 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $parts = $$je;
                        break a;

                    }
                    oncipj_Cypher_jj_save($this, 94, 2);
                }
                if (!var$3)
                    break;
                ju_ArrayList_add($parts, (oncipj_Cypher_SymbolicNameString($this)).$image0);
                oncipj_Cypher_jj_consume_token($this, 135);
            }
            return $parts;
        }
        oncipj_Cypher_jj_save($this, 94, 2);
        $rt_throw($parts);
    }
    function oncipj_Cypher_VariableList1($this) {
        var $list, $t, var$3;
        $list = ju_ArrayList__init_();
        $t = oncipj_Cypher_SymbolicNameString($this);
        ju_ArrayList_add($list, onciafn_Neo4jASTFactory_newVariable($this.$astFactory, oncipj_Cypher_pos($this, $t), $t.$image0));
        a: while (true) {
            var$3 = $this.$jj_ntk;
            if (var$3 == (-1))
                var$3 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$3) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            $t = oncipj_Cypher_SymbolicNameString($this);
            ju_ArrayList_add($list, onciafn_Neo4jASTFactory_newVariable($this.$astFactory, oncipj_Cypher_pos($this, $t), $t.$image0));
        }
        $this.$jj_la1.data[206] = $this.$jj_gen;
        return $list;
    }
    function oncipj_Cypher_Variable($this) {
        var $t;
        $t = oncipj_Cypher_SymbolicNameString($this);
        return onciafn_Neo4jASTFactory_newVariable($this.$astFactory, oncipj_Cypher_pos($this, $t), $t.$image0);
    }
    function oncipj_Cypher_SymbolicNameList1($this) {
        var $list, var$2;
        $list = ju_ArrayList__init_();
        ju_ArrayList_add($list, (oncipj_Cypher_SymbolicNameString($this)).$image0);
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($list, (oncipj_Cypher_SymbolicNameString($this)).$image0);
        }
        $this.$jj_la1.data[207] = $this.$jj_gen;
        return $list;
    }
    function oncipj_Cypher_CreateCommand($this, $useClause) {
        var $replace, $start, var$4, var$5, $statement, var$7, var$8, var$9, var$10, $$je;
        $replace = 0;
        $start = oncipj_Cypher_jj_consume_token($this, 114);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 229:
                    break;
                default:
                    $this.$jj_la1.data[208] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 229);
            oncipj_Cypher_jj_consume_token($this, 265);
            $replace = 1;
        }
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$4) {
                case 73:
                    break;
                case 93:
                case 165:
                case 181:
                case 201:
                case 240:
                case 253:
                case 304:
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$5) {
                            case 93:
                                oncipj_Cypher_jj_consume_token($this, 93);
                                oncipj_Cypher_jj_consume_token($this, 181);
                                onciaf_CreateIndexTypes_$callClinit();
                                $statement = oncipj_Cypher_createIndex($this, $start, $replace, onciaf_CreateIndexTypes_BTREE);
                                break c;
                            case 165:
                                break;
                            case 181:
                                oncipj_Cypher_jj_consume_token($this, 181);
                                $this.$jj_la = 2147483647;
                                var$7 = $this.$token;
                                $this.$jj_scanpos = var$7;
                                $this.$jj_lastpos = var$7;
                                d: {
                                    e: {
                                        f: {
                                            g: {
                                                try {
                                                    var$5 = oncipj_Cypher_jj_3_124($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break g;
                                                    } else{
                                                        $useClause = $$je;
                                                        break f;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 123, 2147483647);
                                                break d;
                                            }
                                            try {
                                                var$5 = 1;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $useClause = $$je;

                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 123, 2147483647);
                                        $rt_throw($useClause);
                                    }
                                    oncipj_Cypher_jj_save($this, 123, 2147483647);
                                }
                                if (!var$5) {
                                    var$4 = $this.$jj_ntk;
                                    if (var$4 == (-1))
                                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                                    h: {
                                        switch (var$4) {
                                            case 68:
                                            case 69:
                                            case 70:
                                            case 71:
                                            case 72:
                                            case 73:
                                            case 74:
                                            case 75:
                                            case 76:
                                            case 77:
                                            case 78:
                                            case 79:
                                            case 80:
                                            case 81:
                                            case 82:
                                            case 83:
                                            case 84:
                                            case 85:
                                            case 87:
                                            case 88:
                                            case 89:
                                            case 90:
                                            case 91:
                                            case 92:
                                            case 93:
                                            case 94:
                                            case 95:
                                            case 96:
                                            case 97:
                                            case 98:
                                            case 99:
                                            case 100:
                                            case 104:
                                            case 105:
                                            case 106:
                                            case 107:
                                            case 108:
                                            case 109:
                                            case 110:
                                            case 111:
                                            case 112:
                                            case 113:
                                            case 114:
                                            case 115:
                                            case 116:
                                            case 117:
                                            case 118:
                                            case 119:
                                            case 120:
                                            case 121:
                                            case 122:
                                            case 123:
                                            case 124:
                                            case 125:
                                            case 126:
                                            case 127:
                                            case 128:
                                            case 129:
                                            case 130:
                                            case 132:
                                            case 133:
                                            case 137:
                                            case 138:
                                            case 139:
                                            case 140:
                                            case 141:
                                            case 142:
                                            case 143:
                                            case 144:
                                            case 145:
                                            case 146:
                                            case 147:
                                            case 148:
                                            case 149:
                                            case 150:
                                            case 152:
                                            case 153:
                                            case 154:
                                            case 155:
                                            case 156:
                                            case 157:
                                            case 158:
                                            case 159:
                                            case 160:
                                            case 161:
                                            case 162:
                                            case 163:
                                            case 164:
                                            case 165:
                                            case 166:
                                            case 167:
                                            case 169:
                                            case 170:
                                            case 171:
                                            case 172:
                                            case 173:
                                            case 175:
                                            case 176:
                                            case 177:
                                            case 179:
                                            case 180:
                                            case 181:
                                            case 182:
                                            case 183:
                                            case 184:
                                            case 185:
                                            case 186:
                                            case 187:
                                            case 188:
                                            case 189:
                                            case 190:
                                            case 191:
                                            case 197:
                                            case 198:
                                            case 199:
                                            case 200:
                                            case 201:
                                            case 204:
                                            case 205:
                                            case 206:
                                            case 207:
                                            case 212:
                                            case 213:
                                            case 214:
                                            case 215:
                                            case 216:
                                            case 217:
                                            case 218:
                                            case 219:
                                            case 220:
                                            case 221:
                                            case 222:
                                            case 223:
                                            case 224:
                                            case 225:
                                            case 226:
                                            case 227:
                                            case 228:
                                            case 229:
                                            case 230:
                                            case 231:
                                            case 232:
                                            case 233:
                                            case 234:
                                            case 235:
                                            case 236:
                                            case 237:
                                            case 240:
                                            case 241:
                                            case 243:
                                            case 244:
                                            case 245:
                                            case 246:
                                            case 247:
                                            case 248:
                                            case 249:
                                            case 250:
                                            case 251:
                                            case 253:
                                            case 256:
                                            case 257:
                                            case 258:
                                            case 259:
                                            case 261:
                                            case 262:
                                            case 263:
                                            case 264:
                                            case 265:
                                            case 266:
                                            case 267:
                                            case 268:
                                            case 269:
                                            case 270:
                                            case 271:
                                            case 272:
                                            case 273:
                                            case 274:
                                            case 276:
                                            case 277:
                                            case 278:
                                            case 279:
                                            case 280:
                                            case 281:
                                            case 282:
                                            case 284:
                                            case 285:
                                            case 286:
                                            case 287:
                                            case 288:
                                            case 289:
                                            case 290:
                                            case 291:
                                            case 292:
                                            case 293:
                                            case 294:
                                            case 295:
                                            case 296:
                                            case 297:
                                            case 298:
                                            case 299:
                                            case 300:
                                            case 301:
                                            case 302:
                                            case 303:
                                            case 304:
                                            case 305:
                                            case 306:
                                            case 308:
                                            case 309:
                                            case 310:
                                            case 311:
                                            case 312:
                                            case 313:
                                            case 314:
                                            case 315:
                                            case 316:
                                            case 317:
                                            case 318:
                                            case 319:
                                            case 320:
                                            case 321:
                                            case 322:
                                            case 323:
                                            case 324:
                                            case 325:
                                            case 326:
                                            case 327:
                                            case 328:
                                            case 329:
                                            case 330:
                                            case 331:
                                            case 332:
                                            case 333:
                                            case 334:
                                            case 335:
                                            case 336:
                                            case 337:
                                            case 338:
                                            case 339:
                                            case 340:
                                            case 341:
                                                break;
                                            case 86:
                                            case 101:
                                            case 102:
                                            case 103:
                                            case 131:
                                            case 134:
                                            case 135:
                                            case 136:
                                            case 151:
                                            case 168:
                                            case 174:
                                            case 178:
                                            case 192:
                                            case 193:
                                            case 194:
                                            case 195:
                                            case 196:
                                            case 202:
                                            case 203:
                                            case 208:
                                            case 209:
                                            case 210:
                                            case 211:
                                            case 238:
                                            case 239:
                                            case 242:
                                            case 252:
                                            case 254:
                                            case 255:
                                            case 260:
                                            case 275:
                                            case 283:
                                            case 307:
                                                break h;
                                            default:
                                                break h;
                                        }
                                        onciaf_CreateIndexTypes_$callClinit();
                                        $statement = oncipj_Cypher_createIndex($this, $start, $replace, onciaf_CreateIndexTypes_DEFAULT);
                                        break c;
                                    }
                                    $this.$jj_la1.data[345] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $useClause = new oncipj_ParseException;
                                    jl_Throwable__init_0($useClause);
                                    $rt_throw($useClause);
                                }
                                oncipj_Cypher_jj_consume_token($this, 224);
                                var$7 = oncipj_Cypher_LabelOrRelType($this);
                                oncipj_Cypher_jj_consume_token($this, 202);
                                var$8 = oncipj_Cypher_SymbolicNamePositions($this);
                                oncipj_Cypher_jj_consume_token($this, 275);
                                if ($replace) {
                                    $useClause = $this.$exceptionFactory;
                                    var$7 = new oncipj_ParseException;
                                    jl_Throwable__init_(var$7, $rt_s(922));
                                    $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($useClause, var$7, $start.$beginOffset, $start.$beginLine, $start.$beginColumn));
                                }
                                $start = oncipj_Cypher_pos($this, $start);
                                var$9 = onciaf_ASTFactory$StringPos__init_(var$7.$image0, oncipj_Cypher_pos($this, var$7));
                                $statement = oncia_CreateIndexOldSyntax__init_(oncie_LabelName__init_(var$9.$string0, var$9.$pos), sci_List_map(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$8))), new onciafn_Neo4jASTFactory$createIndexWithOldSyntax$lambda$_152_0), s_None$_MODULE$, $start);
                                break c;
                            case 201:
                                oncipj_Cypher_jj_consume_token($this, 201);
                                oncipj_Cypher_jj_consume_token($this, 181);
                                $statement = oncipj_Cypher_createLookupIndex($this, $start, $replace);
                                break c;
                            case 240:
                                oncipj_Cypher_jj_consume_token($this, 240);
                                oncipj_Cypher_jj_consume_token($this, 181);
                                onciaf_CreateIndexTypes_$callClinit();
                                $statement = oncipj_Cypher_createIndex($this, $start, $replace, onciaf_CreateIndexTypes_POINT);
                                break c;
                            case 253:
                                oncipj_Cypher_jj_consume_token($this, 253);
                                oncipj_Cypher_jj_consume_token($this, 181);
                                onciaf_CreateIndexTypes_$callClinit();
                                $statement = oncipj_Cypher_createIndex($this, $start, $replace, onciaf_CreateIndexTypes_RANGE);
                                break c;
                            case 304:
                                oncipj_Cypher_jj_consume_token($this, 304);
                                oncipj_Cypher_jj_consume_token($this, 181);
                                onciaf_CreateIndexTypes_$callClinit();
                                $statement = oncipj_Cypher_createIndex($this, $start, $replace, onciaf_CreateIndexTypes_TEXT);
                                break c;
                            default:
                                $this.$jj_la1.data[346] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $useClause = new oncipj_ParseException;
                                jl_Throwable__init_0($useClause);
                                $rt_throw($useClause);
                        }
                        oncipj_Cypher_jj_consume_token($this, 165);
                        oncipj_Cypher_jj_consume_token($this, 181);
                        $statement = oncipj_Cypher_createFulltextIndex($this, $start, $replace);
                    }
                    break b;
                case 107:
                    var$9 = null;
                    var$10 = onciafn_Neo4jASTFactory_wait($this.$astFactory, 0, Long_fromInt(-1));
                    var$4 = 0;
                    oncipj_Cypher_jj_consume_token($this, 107);
                    oncipj_Cypher_jj_consume_token($this, 118);
                    $statement = oncipj_Cypher_SymbolicAliasName($this);
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    i: {
                        switch (var$5) {
                            case 177:
                                oncipj_Cypher_jj_consume_token($this, 177);
                                oncipj_Cypher_jj_consume_token($this, 219);
                                oncipj_Cypher_jj_consume_token($this, 156);
                                var$4 = 1;
                                break i;
                            default:
                        }
                        $this.$jj_la1.data[562] = $this.$jj_gen;
                    }
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    j: {
                        switch (var$5) {
                            case 227:
                                break;
                            default:
                                $this.$jj_la1.data[563] = $this.$jj_gen;
                                break j;
                        }
                        var$9 = oncipj_Cypher_Options($this);
                    }
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    k: {
                        switch (var$5) {
                            case 221:
                            case 332:
                                break;
                            default:
                                $this.$jj_la1.data[564] = $this.$jj_gen;
                                break k;
                        }
                        var$10 = oncipj_Cypher_WaitClause($this);
                    }
                    var$7 = $this.$astFactory;
                    var$8 = oncipj_Cypher_pos($this, $start);
                    $statement = oncia_CreateCompositeDatabase__init_(oncipj_AliasName_getLocalAliasName($statement, $this.$astFactory), onciafn_Neo4jASTFactory_ifExistsDo(var$7, $replace, var$4), onciafn_Neo4jASTFactory_asOptionsAst(var$7, var$9), var$10, var$8);
                    break b;
                case 108:
                    $statement = oncipj_Cypher_CreateConstraint($this, $start, $replace);
                    break b;
                case 118:
                    $statement = oncipj_Cypher_CreateDatabase($this, $start, $replace);
                    break b;
                case 271:
                    $statement = oncipj_Cypher_CreateRole($this, $start, $replace);
                    break b;
                case 325:
                    $statement = oncipj_Cypher_CreateUser($this, $start, $replace);
                    break b;
                default:
                    $this.$jj_la1.data[209] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $useClause = new oncipj_ParseException;
                    jl_Throwable__init_0($useClause);
                    $rt_throw($useClause);
            }
            $statement = oncipj_Cypher_CreateAlias($this, $start, $replace);
        }
        return onciafn_Neo4jASTFactory_useGraph($this.$astFactory, $statement, $useClause);
    }
    function oncipj_Cypher_Command($this, $useClause) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$2) {
                case 77:
                case 123:
                case 127:
                case 138:
                case 139:
                case 144:
                case 169:
                case 257:
                case 259:
                case 270:
                case 295:
                case 298:
                    var$2 = $this.$jj_ntk;
                    if (var$2 == (-1))
                        var$2 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$2) {
                            case 77:
                                var$3 = oncipj_Cypher_jj_consume_token($this, 77);
                                var$4 = $this.$jj_ntk;
                                if (var$4 == (-1))
                                    var$4 = oncipj_Cypher_jj_ntk_f($this);
                                c: {
                                    switch (var$4) {
                                        case 73:
                                            break;
                                        case 116:
                                            oncipj_Cypher_jj_consume_token($this, 116);
                                            oncipj_Cypher_jj_consume_token($this, 325);
                                            oncipj_Cypher_jj_consume_token($this, 286);
                                            oncipj_Cypher_jj_consume_token($this, 232);
                                            oncipj_Cypher_jj_consume_token($this, 164);
                                            var$5 = oncipj_Cypher_passwordExpression($this);
                                            oncipj_Cypher_jj_consume_token($this, 310);
                                            var$3 = oncia_SetOwnPassword__init_(oncipj_Cypher_passwordExpression($this), var$5, oncipj_Cypher_pos($this, var$3));
                                            break c;
                                        case 118:
                                            var$3 = oncipj_Cypher_AlterDatabase($this, var$3);
                                            break c;
                                        case 284:
                                            oncipj_Cypher_jj_consume_token($this, 284);
                                            var$5 = oncipj_Cypher_StringOrParameter($this);
                                            oncipj_Cypher_jj_consume_token($this, 286);
                                            var$6 = oncipj_Cypher_Options($this);
                                            var$7 = $this.$astFactory;
                                            var$8 = oncipj_Cypher_pos($this, var$3);
                                            var$3 = oncia_AlterServer__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$5)), onciafn_Neo4jASTFactory_asOptionsAst(var$7, var$6), var$8);
                                            break c;
                                        case 325:
                                            var$3 = oncipj_Cypher_AlterUser($this, var$3);
                                            break c;
                                        default:
                                            $this.$jj_la1.data[213] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $useClause = new oncipj_ParseException;
                                            jl_Throwable__init_0($useClause);
                                            $rt_throw($useClause);
                                    }
                                    var$3 = oncipj_Cypher_AlterAlias($this, var$3);
                                }
                                break b;
                            case 123:
                            case 139:
                            case 257:
                                var$4 = 0;
                                var$9 = $this.$jj_ntk;
                                if (var$9 == (-1))
                                    var$9 = oncipj_Cypher_jj_ntk_f($this);
                                d: {
                                    switch (var$9) {
                                        case 139:
                                            break;
                                        default:
                                            $this.$jj_la1.data[389] = $this.$jj_gen;
                                            break d;
                                    }
                                    oncipj_Cypher_jj_consume_token($this, 139);
                                    var$4 = 1;
                                }
                                var$2 = $this.$jj_ntk;
                                if (var$2 == (-1))
                                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                                e: {
                                    switch (var$2) {
                                        case 123:
                                            var$6 = ju_ArrayList__init_();
                                            var$3 = oncipj_Cypher_jj_consume_token($this, 123);
                                            var$2 = $this.$jj_ntk;
                                            if (var$2 == (-1))
                                                var$2 = oncipj_Cypher_jj_ntk_f($this);
                                            f: {
                                                switch (var$2) {
                                                    case 118:
                                                        oncipj_Cypher_jj_consume_token($this, 118);
                                                        break f;
                                                    case 119:
                                                        oncipj_Cypher_jj_consume_token($this, 119);
                                                        break f;
                                                    default:
                                                }
                                                $this.$jj_la1.data[391] = $this.$jj_gen;
                                                oncipj_Cypher_jj_consume_token($this, (-1));
                                                $useClause = new oncipj_ParseException;
                                                jl_Throwable__init_0($useClause);
                                                $rt_throw($useClause);
                                            }
                                            oncipj_Cypher_jj_consume_token($this, 164);
                                            var$2 = $this.$jj_ntk;
                                            if (var$2 == (-1))
                                                var$2 = oncipj_Cypher_jj_ntk_f($this);
                                            g: {
                                                switch (var$2) {
                                                    case 284:
                                                        oncipj_Cypher_jj_consume_token($this, 284);
                                                        break g;
                                                    case 285:
                                                        oncipj_Cypher_jj_consume_token($this, 285);
                                                        break g;
                                                    default:
                                                }
                                                $this.$jj_la1.data[392] = $this.$jj_gen;
                                                oncipj_Cypher_jj_consume_token($this, (-1));
                                                $useClause = new oncipj_ParseException;
                                                jl_Throwable__init_0($useClause);
                                                $rt_throw($useClause);
                                            }
                                            ju_ArrayList_add(var$6, oncipj_Cypher_StringOrParameter($this));
                                            h: while (true) {
                                                var$2 = $this.$jj_ntk;
                                                if (var$2 == (-1))
                                                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                                                switch (var$2) {
                                                    case 103:
                                                        break;
                                                    default:
                                                        break h;
                                                }
                                                oncipj_Cypher_jj_consume_token($this, 103);
                                                ju_ArrayList_add(var$6, oncipj_Cypher_StringOrParameter($this));
                                            }
                                            $this.$jj_la1.data[393] = $this.$jj_gen;
                                            var$7 = oncipj_Cypher_pos($this, var$3);
                                            var$3 = oncia_DeallocateServers__init_(var$4, (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$6)), new onciafn_Neo4jASTFactory$deallocateServers$lambda$_212_0)).$toList(), var$7);
                                            break e;
                                        case 257:
                                            var$3 = oncipj_Cypher_jj_consume_token($this, 257);
                                            var$2 = $this.$jj_ntk;
                                            if (var$2 == (-1))
                                                var$2 = oncipj_Cypher_jj_ntk_f($this);
                                            i: {
                                                switch (var$2) {
                                                    case 118:
                                                        oncipj_Cypher_jj_consume_token($this, 118);
                                                        break i;
                                                    case 119:
                                                        oncipj_Cypher_jj_consume_token($this, 119);
                                                        break i;
                                                    default:
                                                }
                                                $this.$jj_la1.data[394] = $this.$jj_gen;
                                                oncipj_Cypher_jj_consume_token($this, (-1));
                                                $useClause = new oncipj_ParseException;
                                                jl_Throwable__init_0($useClause);
                                                $rt_throw($useClause);
                                            }
                                            var$3 = oncia_ReallocateDatabases__init_(var$4, oncipj_Cypher_pos($this, var$3));
                                            break e;
                                        default:
                                    }
                                    $this.$jj_la1.data[390] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $useClause = new oncipj_ParseException;
                                    jl_Throwable__init_0($useClause);
                                    $rt_throw($useClause);
                                }
                                break b;
                            case 127:
                                break;
                            case 138:
                                var$3 = oncipj_Cypher_DropCommand($this);
                                break b;
                            case 144:
                                var$3 = oncipj_Cypher_EnableServerCommand($this);
                                break b;
                            case 169:
                                var$3 = oncipj_Cypher_GrantCommand($this);
                                break b;
                            case 259:
                                var$3 = oncipj_Cypher_RenameCommand($this);
                                break b;
                            case 270:
                                var$3 = oncipj_Cypher_RevokeCommand($this);
                                break b;
                            case 295:
                                var$3 = oncipj_Cypher_StartDatabase($this);
                                break b;
                            case 298:
                                var$3 = oncipj_Cypher_StopDatabase($this);
                                break b;
                            default:
                                $this.$jj_la1.data[211] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $useClause = new oncipj_ParseException;
                                jl_Throwable__init_0($useClause);
                                $rt_throw($useClause);
                        }
                        var$3 = oncipj_Cypher_DenyPrivilege($this);
                    }
                    $useClause = onciafn_Neo4jASTFactory_useGraph($this.$astFactory, var$3, $useClause);
                    break a;
                case 291:
                    break;
                case 303:
                    var$3 = oncipj_Cypher_jj_consume_token($this, 303);
                    var$5 = oncipj_Cypher_TerminateTransactions($this, var$3);
                    if ($useClause !== null)
                        ju_AbstractSequentialList_add(var$5, 0, $useClause);
                    $useClause = onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, var$3), var$5);
                    break a;
                default:
                    $this.$jj_la1.data[210] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $useClause = new oncipj_ParseException;
                    jl_Throwable__init_0($useClause);
                    $rt_throw($useClause);
            }
            $useClause = oncipj_Cypher_ShowCommand($this, $useClause);
        }
        return $useClause;
    }
    function oncipj_Cypher_DropCommand($this) {
        var $start, var$2, var$3, var$4, $s, var$6, var$7, var$8, $$je;
        $start = oncipj_Cypher_jj_consume_token($this, 138);
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$2) {
                case 73:
                    var$2 = 0;
                    oncipj_Cypher_jj_consume_token($this, 73);
                    var$3 = oncipj_Cypher_SymbolicAliasName($this);
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$4) {
                            case 177:
                                break;
                            default:
                                $this.$jj_la1.data[608] = $this.$jj_gen;
                                break b;
                        }
                        oncipj_Cypher_jj_consume_token($this, 177);
                        oncipj_Cypher_jj_consume_token($this, 156);
                        var$2 = 1;
                    }
                    oncipj_Cypher_jj_consume_token($this, 162);
                    oncipj_Cypher_jj_consume_token($this, 118);
                    $start = oncipj_Cypher_pos($this, $start);
                    $s = oncia_DropDatabaseAlias__init_(oncipj_AliasName_getLocalAliasName(var$3, $this.$astFactory), var$2, $start);
                    break a;
                case 107:
                case 118:
                    break;
                case 108:
                    $s = oncipj_Cypher_DropConstraint($this, $start);
                    break a;
                case 181:
                    var$2 = 0;
                    oncipj_Cypher_jj_consume_token($this, 181);
                    $this.$jj_la = 2;
                    var$3 = $this.$token;
                    $this.$jj_scanpos = var$3;
                    $this.$jj_lastpos = var$3;
                    c: {
                        d: {
                            e: {
                                f: {
                                    try {
                                        var$6 = oncipj_Cypher_jj_3_132($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break f;
                                        } else{
                                            $start = $$je;
                                            break e;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 131, 2);
                                    break c;
                                }
                                try {
                                    var$6 = 1;
                                    break d;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $start = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 131, 2);
                            $rt_throw($start);
                        }
                        oncipj_Cypher_jj_save($this, 131, 2);
                    }
                    g: {
                        if (var$6) {
                            oncipj_Cypher_jj_consume_token($this, 224);
                            var$3 = oncipj_Cypher_LabelOrRelType($this);
                            oncipj_Cypher_jj_consume_token($this, 202);
                            $s = oncipj_Cypher_SymbolicNamePositions($this);
                            oncipj_Cypher_jj_consume_token($this, 275);
                            $start = oncipj_Cypher_pos($this, $start);
                            var$7 = onciaf_ASTFactory$StringPos__init_(var$3.$image0, oncipj_Cypher_pos($this, var$3));
                            var$8 = (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $s)), new onciafn_Neo4jASTFactory$dropIndex$lambda$_156_0)).$toList();
                            $s = oncia_DropIndex__init_(oncie_LabelName__init_(var$7.$string0, var$7.$pos), var$8, s_None$_MODULE$, $start);
                        } else {
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    var$3 = oncipj_Cypher_SymbolicNameString($this);
                                    var$4 = $this.$jj_ntk;
                                    if (var$4 == (-1))
                                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                                    h: {
                                        switch (var$4) {
                                            case 177:
                                                break;
                                            default:
                                                $this.$jj_la1.data[366] = $this.$jj_gen;
                                                break h;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 177);
                                        oncipj_Cypher_jj_consume_token($this, 156);
                                        var$2 = 1;
                                    }
                                    $start = oncipj_Cypher_pos($this, $start);
                                    $s = oncia_DropIndexOnName__init_(var$3.$image0, var$2, s_None$_MODULE$, $start);
                                    break g;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                case 307:
                                    break;
                                default:
                            }
                            $this.$jj_la1.data[367] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                        }
                    }
                    break a;
                case 271:
                    var$4 = 0;
                    oncipj_Cypher_jj_consume_token($this, 271);
                    var$3 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    var$2 = $this.$jj_ntk;
                    if (var$2 == (-1))
                        var$2 = oncipj_Cypher_jj_ntk_f($this);
                    i: {
                        switch (var$2) {
                            case 177:
                                break;
                            default:
                                $this.$jj_la1.data[397] = $this.$jj_gen;
                                break i;
                        }
                        oncipj_Cypher_jj_consume_token($this, 177);
                        oncipj_Cypher_jj_consume_token($this, 156);
                        var$4 = 1;
                    }
                    $start = oncipj_Cypher_pos($this, $start);
                    $s = oncia_DropRole__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$3)), var$4, $start);
                    break a;
                case 284:
                    oncipj_Cypher_jj_consume_token($this, 284);
                    var$3 = oncipj_Cypher_StringOrParameter($this);
                    $start = oncipj_Cypher_pos($this, $start);
                    $s = oncia_DropServer__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$3)), $start);
                    break a;
                case 325:
                    var$4 = 0;
                    oncipj_Cypher_jj_consume_token($this, 325);
                    var$3 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    var$2 = $this.$jj_ntk;
                    if (var$2 == (-1))
                        var$2 = oncipj_Cypher_jj_ntk_f($this);
                    j: {
                        switch (var$2) {
                            case 177:
                                break;
                            default:
                                $this.$jj_la1.data[410] = $this.$jj_gen;
                                break j;
                        }
                        oncipj_Cypher_jj_consume_token($this, 177);
                        oncipj_Cypher_jj_consume_token($this, 156);
                        var$4 = 1;
                    }
                    $start = oncipj_Cypher_pos($this, $start);
                    $s = oncia_DropUser__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$3)), var$4, $start);
                    break a;
                default:
                    $this.$jj_la1.data[212] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            $s = oncipj_Cypher_DropDatabase($this, $start);
        }
        return $s;
    }
    function oncipj_Cypher_ShowCommand($this, $useClause) {
        var $statement, $clauses, var$4, var$5;
        $statement = null;
        $clauses = null;
        var$4 = oncipj_Cypher_jj_consume_token($this, 291);
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 73:
                case 74:
                    break;
                case 76:
                    oncipj_Cypher_jj_consume_token($this, 76);
                    $statement = oncipj_Cypher_ShowAllCommand($this, var$4, $useClause);
                    break a;
                case 93:
                    oncipj_Cypher_jj_consume_token($this, 93);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowIndexesAllowBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_BTREE);
                    break a;
                case 94:
                    oncipj_Cypher_jj_consume_token($this, 94);
                    oncipj_Cypher_jj_consume_token($this, 180);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowFunctions($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_BUILT_IN);
                    break a;
                case 108:
                case 109:
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_ALL);
                    break a;
                case 116:
                    $statement = oncipj_Cypher_ShowCurrentUser($this, var$4, $useClause);
                    break a;
                case 118:
                case 119:
                case 124:
                case 176:
                    $statement = oncipj_Cypher_ShowDatabase($this, var$4, $useClause);
                    break a;
                case 154:
                    oncipj_Cypher_jj_consume_token($this, 154);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_OLD_EXIST);
                    break a;
                case 155:
                    oncipj_Cypher_jj_consume_token($this, 155);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowConstraintsAllowYield($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_EXIST);
                    break a;
                case 156:
                    oncipj_Cypher_jj_consume_token($this, 156);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowConstraintsAllowBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_OLD_EXISTS);
                    break a;
                case 165:
                    oncipj_Cypher_jj_consume_token($this, 165);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowIndexesNoBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_FULLTEXT);
                    break a;
                case 166:
                case 167:
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowFunctions($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_ALL);
                    break a;
                case 181:
                case 182:
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowIndexesAllowBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_ALL);
                    break a;
                case 189:
                    oncipj_Cypher_jj_consume_token($this, 189);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowConstraintsAllowYield($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_KEY);
                    break a;
                case 201:
                    oncipj_Cypher_jj_consume_token($this, 201);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowIndexesNoBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_LOOKUP);
                    break a;
                case 216:
                    oncipj_Cypher_jj_consume_token($this, 216);
                    $statement = oncipj_Cypher_ShowNodeCommand($this, var$4, $useClause);
                    break a;
                case 240:
                    oncipj_Cypher_jj_consume_token($this, 240);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowIndexesNoBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_POINT);
                    break a;
                case 241:
                    oncipj_Cypher_jj_consume_token($this, 241);
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$5) {
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                break b;
                            case 272:
                                oncipj_Cypher_jj_consume_token($this, 272);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[214] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    $statement = oncipj_Cypher_ShowRoles($this, var$4, $useClause, 0);
                    break a;
                case 246:
                case 247:
                    $statement = oncipj_Cypher_ShowPrivileges($this, var$4, $useClause);
                    break a;
                case 248:
                case 249:
                    $statement = oncipj_Cypher_ShowProcedures($this, var$4, $useClause);
                    break a;
                case 251:
                    oncipj_Cypher_jj_consume_token($this, 251);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowPropertyCommand($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_EXIST);
                    break a;
                case 253:
                    oncipj_Cypher_jj_consume_token($this, 253);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowIndexesNoBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_RANGE);
                    break a;
                case 261:
                    oncipj_Cypher_jj_consume_token($this, 261);
                    $statement = oncipj_Cypher_ShowRelCommand($this, var$4, $useClause);
                    break a;
                case 262:
                    oncipj_Cypher_jj_consume_token($this, 262);
                    $statement = oncipj_Cypher_ShowRelationshipCommand($this, var$4, $useClause);
                    break a;
                case 271:
                case 272:
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$5) {
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                break c;
                            case 272:
                                oncipj_Cypher_jj_consume_token($this, 272);
                                break c;
                            default:
                        }
                        $this.$jj_la1.data[215] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    if (oncipj_Cypher_jj_2_96($this, 2147483647)) {
                        $statement = oncipj_Cypher_ShowRolePrivileges($this, var$4, $useClause);
                        break a;
                    }
                    if (oncipj_Cypher_jj_2_97($this, 2147483647)) {
                        $statement = oncipj_Cypher_ShowRoles($this, var$4, $useClause, 1);
                        break a;
                    }
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$5) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            $statement = oncipj_Cypher_ShowRolePrivileges($this, var$4, $useClause);
                            break a;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[216] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                case 284:
                case 285:
                    $statement = oncipj_Cypher_ShowServers($this, var$4, $useClause);
                    break a;
                case 287:
                case 288:
                    $statement = oncipj_Cypher_ShowSettings($this, var$4, $useClause);
                    break a;
                case 300:
                    $statement = oncipj_Cypher_ShowSupportedPrivileges($this, var$4, $useClause);
                    break a;
                case 304:
                    oncipj_Cypher_jj_consume_token($this, 304);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowIndexesNoBrief($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_TEXT);
                    break a;
                case 312:
                case 313:
                    $clauses = oncipj_Cypher_ShowTransactions($this, var$4);
                    break a;
                case 320:
                    oncipj_Cypher_jj_consume_token($this, 320);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_UNIQUE);
                    break a;
                case 321:
                    oncipj_Cypher_jj_consume_token($this, 321);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $statement = oncipj_Cypher_ShowConstraintsAllowYield($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_UNIQUE);
                    break a;
                default:
                    $this.$jj_la1.data[219] = $this.$jj_gen;
                    if (oncipj_Cypher_jj_2_100($this, 2147483647)) {
                        oncipj_Cypher_jj_consume_token($this, 325);
                        oncipj_Cypher_jj_consume_token($this, 125);
                        onciaf_ShowCommandFilterTypes_$callClinit();
                        $statement = oncipj_Cypher_ShowFunctions($this, var$4, $useClause, onciaf_ShowCommandFilterTypes_USER_DEFINED);
                        break a;
                    }
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$5) {
                        case 325:
                        case 326:
                            var$5 = $this.$jj_ntk;
                            if (var$5 == (-1))
                                var$5 = oncipj_Cypher_jj_ntk_f($this);
                            d: {
                                switch (var$5) {
                                    case 325:
                                        oncipj_Cypher_jj_consume_token($this, 325);
                                        break d;
                                    case 326:
                                        oncipj_Cypher_jj_consume_token($this, 326);
                                        break d;
                                    default:
                                }
                                $this.$jj_la1.data[217] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $useClause = new oncipj_ParseException;
                                jl_Throwable__init_0($useClause);
                                $rt_throw($useClause);
                            }
                            if (oncipj_Cypher_jj_2_98($this, 2147483647)) {
                                $statement = oncipj_Cypher_ShowUserPrivileges($this, var$4, $useClause);
                                break a;
                            }
                            if (oncipj_Cypher_jj_2_99($this, 2147483647)) {
                                $statement = oncipj_Cypher_ShowUsers($this, var$4, $useClause);
                                break a;
                            }
                            var$5 = $this.$jj_ntk;
                            if (var$5 == (-1))
                                var$5 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$5) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 131:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    $statement = oncipj_Cypher_ShowUserPrivileges($this, var$4, $useClause);
                                    break a;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                case 307:
                                    break;
                                default:
                            }
                            $this.$jj_la1.data[218] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $useClause = new oncipj_ParseException;
                            jl_Throwable__init_0($useClause);
                            $rt_throw($useClause);
                        default:
                    }
                    $this.$jj_la1.data[220] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $useClause = new oncipj_ParseException;
                    jl_Throwable__init_0($useClause);
                    $rt_throw($useClause);
            }
            $statement = oncipj_Cypher_ShowAliases($this, var$4, $useClause);
        }
        if ($clauses !== null) {
            if ($useClause !== null)
                ju_AbstractSequentialList_add($clauses, 0, $useClause);
            $statement = onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, var$4), $clauses);
        }
        return $statement;
    }
    function oncipj_Cypher_ShowAllCommand($this, $start, $useClause) {
        var var$3, var$4;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 108:
                case 109:
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_ALL);
                    break a;
                case 166:
                case 167:
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowFunctions($this, $start, $useClause, onciaf_ShowCommandFilterTypes_ALL);
                    break a;
                case 181:
                case 182:
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowIndexesAllowBrief($this, $start, $useClause, onciaf_ShowCommandFilterTypes_ALL);
                    break a;
                case 246:
                case 247:
                    break;
                case 271:
                case 272:
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$4) {
                            case 271:
                                break;
                            case 272:
                                oncipj_Cypher_jj_consume_token($this, 272);
                                break b;
                            default:
                                $this.$jj_la1.data[221] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                        }
                        oncipj_Cypher_jj_consume_token($this, 271);
                    }
                    $start = oncipj_Cypher_ShowRoles($this, $start, $useClause, 1);
                    break a;
                default:
                    $this.$jj_la1.data[222] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            $start = oncipj_Cypher_ShowPrivileges($this, $start, $useClause);
        }
        return $start;
    }
    function oncipj_Cypher_ShowNodeCommand($this, $start, $useClause) {
        var var$3, var$4;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 154:
                    break;
                case 155:
                    oncipj_Cypher_jj_consume_token($this, 155);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_NODE_EXIST);
                    break a;
                case 156:
                    oncipj_Cypher_jj_consume_token($this, 156);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowBrief($this, $start, $useClause, onciaf_ShowCommandFilterTypes_NODE_OLD_EXISTS);
                    break a;
                case 189:
                    oncipj_Cypher_jj_consume_token($this, 189);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_NODE_KEY);
                    break a;
                case 251:
                    oncipj_Cypher_jj_consume_token($this, 251);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowPropertyCommand($this, $start, $useClause, onciaf_ShowCommandFilterTypes_NODE_EXIST);
                    break a;
                case 320:
                case 321:
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$4) {
                            case 320:
                                break;
                            case 321:
                                oncipj_Cypher_jj_consume_token($this, 321);
                                break b;
                            default:
                                $this.$jj_la1.data[223] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                        }
                        oncipj_Cypher_jj_consume_token($this, 320);
                    }
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_NODE_UNIQUE);
                    break a;
                default:
                    $this.$jj_la1.data[224] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            oncipj_Cypher_jj_consume_token($this, 154);
            onciaf_ShowCommandFilterTypes_$callClinit();
            $start = oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_NODE_OLD_EXIST);
        }
        return $start;
    }
    function oncipj_Cypher_ShowRelationshipCommand($this, $start, $useClause) {
        var var$3, var$4;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 154:
                    break;
                case 155:
                    oncipj_Cypher_jj_consume_token($this, 155);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST);
                    break a;
                case 156:
                    oncipj_Cypher_jj_consume_token($this, 156);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowBrief($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXISTS);
                    break a;
                case 189:
                    oncipj_Cypher_jj_consume_token($this, 189);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_KEY);
                    break a;
                case 251:
                    oncipj_Cypher_jj_consume_token($this, 251);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowPropertyCommand($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST);
                    break a;
                case 320:
                case 321:
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$4) {
                            case 320:
                                break;
                            case 321:
                                oncipj_Cypher_jj_consume_token($this, 321);
                                break b;
                            default:
                                $this.$jj_la1.data[225] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                        }
                        oncipj_Cypher_jj_consume_token($this, 320);
                    }
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_UNIQUE);
                    break a;
                default:
                    $this.$jj_la1.data[226] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            oncipj_Cypher_jj_consume_token($this, 154);
            onciaf_ShowCommandFilterTypes_$callClinit();
            $start = oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXIST);
        }
        return $start;
    }
    function oncipj_Cypher_ShowRelCommand($this, $start, $useClause) {
        var var$3, var$4;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 154:
                    break;
                case 155:
                    oncipj_Cypher_jj_consume_token($this, 155);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST);
                    break a;
                case 189:
                    oncipj_Cypher_jj_consume_token($this, 189);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_KEY);
                    break a;
                case 251:
                    oncipj_Cypher_jj_consume_token($this, 251);
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowPropertyCommand($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST);
                    break a;
                case 320:
                case 321:
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$4) {
                            case 320:
                                break;
                            case 321:
                                oncipj_Cypher_jj_consume_token($this, 321);
                                break b;
                            default:
                                $this.$jj_la1.data[227] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                        }
                        oncipj_Cypher_jj_consume_token($this, 320);
                    }
                    onciaf_ShowCommandFilterTypes_$callClinit();
                    $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_UNIQUE);
                    break a;
                default:
                    $this.$jj_la1.data[228] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            oncipj_Cypher_jj_consume_token($this, 154);
            onciaf_ShowCommandFilterTypes_$callClinit();
            $start = oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST);
        }
        return $start;
    }
    function oncipj_Cypher_ShowPropertyCommand($this, $start, $useClause, $constraintType) {
        var $constraintType_0, var$5;
        if (jl_String_startsWith0($constraintType.$description1, $rt_s(923))) {
            onciaf_ShowCommandFilterTypes_$callClinit();
            $constraintType_0 = onciaf_ShowCommandFilterTypes_NODE_PROP_TYPE;
        } else if (!jl_String_startsWith0($constraintType.$description1, $rt_s(924))) {
            onciaf_ShowCommandFilterTypes_$callClinit();
            $constraintType_0 = onciaf_ShowCommandFilterTypes_PROP_TYPE;
        } else {
            onciaf_ShowCommandFilterTypes_$callClinit();
            $constraintType_0 = onciaf_ShowCommandFilterTypes_RELATIONSHIP_PROP_TYPE;
        }
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 154:
                case 155:
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$5) {
                            case 154:
                                break;
                            case 155:
                                oncipj_Cypher_jj_consume_token($this, 155);
                                break b;
                            default:
                                $this.$jj_la1.data[229] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                        }
                        oncipj_Cypher_jj_consume_token($this, 154);
                    }
                    $constraintType_0 = $constraintType;
                    break a;
                case 316:
                    break;
                default:
                    $this.$jj_la1.data[230] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            oncipj_Cypher_jj_consume_token($this, 316);
        }
        return oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, $constraintType_0);
    }
    function oncipj_Cypher_YieldItem($this) {
        var $v, $eStart, $e, $eEnd, var$5;
        $v = null;
        $eStart = $this.$token;
        $e = oncipj_Cypher_Variable($this);
        $eEnd = $this.$token;
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 81:
                    break;
                default:
                    $this.$jj_la1.data[231] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 81);
            $v = oncipj_Cypher_Variable($this);
        }
        if ($v !== null)
            return onciafn_Neo4jASTFactory_newReturnItem0($this.$astFactory, oncipj_Cypher_pos($this, $eStart.$next1), $e, $v);
        return onciafn_Neo4jASTFactory_newReturnItem($this.$astFactory, oncipj_Cypher_pos($this, $eStart.$next1), $e, $eStart.$next1.$beginOffset, $eEnd.$endOffset);
    }
    function oncipj_Cypher_YieldClause($this) {
        var $skipPosition, $limitPosition, $orderToken, $returnAll, $returnItems, $orders, $skip, $limit, $where, $start, var$11, $item, $o, var$14, var$15;
        $skipPosition = null;
        $limitPosition = null;
        $orderToken = null;
        $returnAll = 0;
        $returnItems = ju_ArrayList__init_();
        $orders = ju_ArrayList__init_();
        $skip = null;
        $limit = null;
        $where = null;
        $start = oncipj_Cypher_jj_consume_token($this, 339);
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$11) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    ju_ArrayList_add($returnItems, oncipj_Cypher_YieldItem($this));
                    b: while (true) {
                        var$11 = $this.$jj_ntk;
                        if (var$11 == (-1))
                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$11) {
                            case 103:
                                break;
                            default:
                                break b;
                        }
                        oncipj_Cypher_jj_consume_token($this, 103);
                        ju_ArrayList_add($returnItems, oncipj_Cypher_YieldItem($this));
                    }
                    $this.$jj_la1.data[232] = $this.$jj_gen;
                    break a;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                    break;
                case 307:
                    oncipj_Cypher_jj_consume_token($this, 307);
                    $returnAll = 1;
                    break a;
                default:
            }
            $this.$jj_la1.data[233] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $skipPosition = new oncipj_ParseException;
            jl_Throwable__init_0($skipPosition);
            $rt_throw($skipPosition);
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$11) {
                case 230:
                    $orderToken = oncipj_Cypher_jj_consume_token($this, 230);
                    oncipj_Cypher_jj_consume_token($this, 95);
                    ju_ArrayList_add($orders, oncipj_Cypher_OrderItem($this));
                    d: while (true) {
                        var$11 = $this.$jj_ntk;
                        if (var$11 == (-1))
                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$11) {
                            case 103:
                                break;
                            default:
                                break d;
                        }
                        oncipj_Cypher_jj_consume_token($this, 103);
                        ju_ArrayList_add($orders, oncipj_Cypher_OrderItem($this));
                    }
                    $this.$jj_la1.data[234] = $this.$jj_gen;
                    break c;
                default:
            }
            $this.$jj_la1.data[235] = $this.$jj_gen;
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        e: {
            switch (var$11) {
                case 294:
                    break;
                default:
                    $this.$jj_la1.data[236] = $this.$jj_gen;
                    break e;
            }
            $skipPosition = oncipj_Cypher_jj_consume_token($this, 294);
            $skip = oncipj_Cypher_SignedIntegerLiteral($this);
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        f: {
            switch (var$11) {
                case 197:
                    break;
                default:
                    $this.$jj_la1.data[237] = $this.$jj_gen;
                    break f;
            }
            $limitPosition = oncipj_Cypher_jj_consume_token($this, 197);
            $limit = oncipj_Cypher_SignedIntegerLiteral($this);
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        g: {
            switch (var$11) {
                case 334:
                    break;
                default:
                    $this.$jj_la1.data[238] = $this.$jj_gen;
                    break g;
            }
            $where = oncipj_Cypher_WhereClause($this);
        }
        $item = oncipj_Cypher_pos($this, $start);
        $o = oncipj_Cypher_pos($this, $start.$next1);
        $orderToken = oncipj_Cypher_pos($this, $orderToken);
        $start = oncipj_Cypher_pos($this, $skipPosition);
        var$14 = oncipj_Cypher_pos($this, $limitPosition);
        var$15 = oncia_ReturnItems__init_($returnAll, sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $returnItems))), s_None$_MODULE$, $o);
        $o = new oncia_Yield;
        $skipPosition = s_Option_filter(s_Option$_apply(s_Option$_MODULE$, sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $orders)))), new onciafn_Neo4jASTFactory$yieldClause$lambda$_136_0);
        $limitPosition = new onciafn_Neo4jASTFactory$yieldClause$lambda$_136_1;
        $limitPosition.$_0242 = $orderToken;
        $skipPosition = s_Option_map($skipPosition, $limitPosition);
        $limitPosition = s_Option$_apply(s_Option$_MODULE$, $skip);
        $orderToken = new onciafn_Neo4jASTFactory$yieldClause$lambda$_136_2;
        $orderToken.$_0243 = $start;
        $limitPosition = s_Option_map($limitPosition, $orderToken);
        $orderToken = s_Option$_apply(s_Option$_MODULE$, $limit);
        $orders = new onciafn_Neo4jASTFactory$yieldClause$lambda$_136_3;
        $orders.$_0244 = var$14;
        oncia_Yield__init_($o, var$15, $skipPosition, $limitPosition, s_Option_map($orderToken, $orders), s_Option$_apply(s_Option$_MODULE$, $where), $item);
        return $o;
    }
    function oncipj_Cypher_ShowIndexesAllowBrief($this, $start, $useClause, $indexType) {
        var $clauses, $brief, $verbose, $where, $yieldClause, $returnClause, var$10;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $brief = 0;
        $verbose = 0;
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$10) {
                case 181:
                    oncipj_Cypher_jj_consume_token($this, 181);
                    break a;
                case 182:
                    oncipj_Cypher_jj_consume_token($this, 182);
                    break a;
                default:
            }
            $this.$jj_la1.data[239] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$10) {
                case 92:
                case 330:
                case 334:
                case 339:
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 92:
                        case 330:
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            c: {
                                switch (var$10) {
                                    case 92:
                                        oncipj_Cypher_jj_consume_token($this, 92);
                                        $brief = 1;
                                        break c;
                                    case 330:
                                        oncipj_Cypher_jj_consume_token($this, 330);
                                        $verbose = 1;
                                        break c;
                                    default:
                                }
                                $this.$jj_la1.data[240] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                            }
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 231:
                                    break;
                                default:
                                    $this.$jj_la1.data[241] = $this.$jj_gen;
                                    break b;
                            }
                            oncipj_Cypher_jj_consume_token($this, 231);
                            break b;
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break b;
                        case 339:
                            $yieldClause = oncipj_Cypher_YieldClause($this);
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[242] = $this.$jj_gen;
                                    break b;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break b;
                        default:
                    }
                    $this.$jj_la1.data[243] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[244] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showIndexClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $indexType, $brief, $verbose, $where, 0));
        else {
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showIndexClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $indexType, $brief, $verbose, $where, 1));
            ju_ArrayList_add($clauses, $yieldClause);
            if ($returnClause !== null)
                ju_ArrayList_add($clauses, $returnClause);
        }
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_ShowIndexesNoBrief($this, $start, $useClause, $indexType) {
        var $clauses, $where, $yieldClause, $returnClause, var$8;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 181:
                    oncipj_Cypher_jj_consume_token($this, 181);
                    break a;
                case 182:
                    oncipj_Cypher_jj_consume_token($this, 182);
                    break a;
                default:
            }
            $this.$jj_la1.data[245] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$8) {
                case 334:
                case 339:
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$8) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break b;
                        case 339:
                            $yieldClause = oncipj_Cypher_YieldClause($this);
                            var$8 = $this.$jj_ntk;
                            if (var$8 == (-1))
                                var$8 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$8) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[246] = $this.$jj_gen;
                                    break b;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break b;
                        default:
                    }
                    $this.$jj_la1.data[247] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[248] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showIndexClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $indexType, 0, 0, $where, 0));
        else {
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showIndexClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $indexType, 0, 0, $where, 1));
            ju_ArrayList_add($clauses, $yieldClause);
            if ($returnClause !== null)
                ju_ArrayList_add($clauses, $returnClause);
        }
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_ShowConstraintsAllowBriefAndYield($this, $start, $useClause, $constraintType) {
        var $clauses, $brief, $verbose, $where, $yieldClause, $returnClause, var$10;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $brief = 0;
        $verbose = 0;
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$10) {
                case 108:
                    oncipj_Cypher_jj_consume_token($this, 108);
                    break a;
                case 109:
                    oncipj_Cypher_jj_consume_token($this, 109);
                    break a;
                default:
            }
            $this.$jj_la1.data[249] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$10) {
                case 92:
                case 330:
                case 334:
                case 339:
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 92:
                        case 330:
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            c: {
                                switch (var$10) {
                                    case 92:
                                        oncipj_Cypher_jj_consume_token($this, 92);
                                        $brief = 1;
                                        break c;
                                    case 330:
                                        oncipj_Cypher_jj_consume_token($this, 330);
                                        $verbose = 1;
                                        break c;
                                    default:
                                }
                                $this.$jj_la1.data[250] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                            }
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 231:
                                    break;
                                default:
                                    $this.$jj_la1.data[251] = $this.$jj_gen;
                                    break b;
                            }
                            oncipj_Cypher_jj_consume_token($this, 231);
                            break b;
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break b;
                        case 339:
                            $yieldClause = oncipj_Cypher_YieldClause($this);
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[252] = $this.$jj_gen;
                                    break b;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break b;
                        default:
                    }
                    $this.$jj_la1.data[253] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[254] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showConstraintClause0($this.$astFactory, oncipj_Cypher_pos($this, $start), $constraintType, $brief, $verbose, $where, 0));
        else {
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showConstraintClause0($this.$astFactory, oncipj_Cypher_pos($this, $start), $constraintType, $brief, $verbose, $where, 1));
            ju_ArrayList_add($clauses, $yieldClause);
            if ($returnClause !== null)
                ju_ArrayList_add($clauses, $returnClause);
        }
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_ShowConstraintsAllowBrief($this, $start, $useClause, $constraintType) {
        var $clauses, $brief, $verbose, var$7;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $brief = 0;
        $verbose = 0;
        var$7 = $this.$jj_ntk;
        if (var$7 == (-1))
            var$7 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$7) {
                case 108:
                    oncipj_Cypher_jj_consume_token($this, 108);
                    break a;
                case 109:
                    oncipj_Cypher_jj_consume_token($this, 109);
                    break a;
                default:
            }
            $this.$jj_la1.data[255] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$7 = $this.$jj_ntk;
        if (var$7 == (-1))
            var$7 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$7) {
                case 92:
                case 330:
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$7) {
                            case 92:
                                oncipj_Cypher_jj_consume_token($this, 92);
                                $brief = 1;
                                break c;
                            case 330:
                                oncipj_Cypher_jj_consume_token($this, 330);
                                $verbose = 1;
                                break c;
                            default:
                        }
                        $this.$jj_la1.data[256] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$7) {
                        case 231:
                            break;
                        default:
                            $this.$jj_la1.data[257] = $this.$jj_gen;
                            break b;
                    }
                    oncipj_Cypher_jj_consume_token($this, 231);
                    break b;
                default:
            }
            $this.$jj_la1.data[258] = $this.$jj_gen;
        }
        ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showConstraintClause0($this.$astFactory, oncipj_Cypher_pos($this, $start), $constraintType, $brief, $verbose, null, 0));
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_ShowConstraintsAllowYield($this, $start, $useClause, $constraintType) {
        var $clauses, $where, $yieldClause, $returnClause, var$8;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 108:
                    oncipj_Cypher_jj_consume_token($this, 108);
                    break a;
                case 109:
                    oncipj_Cypher_jj_consume_token($this, 109);
                    break a;
                default:
            }
            $this.$jj_la1.data[259] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$8) {
                case 334:
                case 339:
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$8) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break b;
                        case 339:
                            $yieldClause = oncipj_Cypher_YieldClause($this);
                            var$8 = $this.$jj_ntk;
                            if (var$8 == (-1))
                                var$8 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$8) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[260] = $this.$jj_gen;
                                    break b;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break b;
                        default:
                    }
                    $this.$jj_la1.data[261] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[262] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showConstraintClause0($this.$astFactory, oncipj_Cypher_pos($this, $start), $constraintType, 0, 0, $where, 0));
        else {
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showConstraintClause0($this.$astFactory, oncipj_Cypher_pos($this, $start), $constraintType, 0, 0, $where, 1));
            ju_ArrayList_add($clauses, $yieldClause);
            if ($returnClause !== null)
                ju_ArrayList_add($clauses, $returnClause);
        }
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_ShowProcedures($this, $start, $useClause) {
        var $clauses, $currentUser, $user, $where, $yieldClause, $returnClause, var$9, var$10, $$je;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $currentUser = 0;
        $user = null;
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$9) {
                case 248:
                    oncipj_Cypher_jj_consume_token($this, 248);
                    break a;
                case 249:
                    oncipj_Cypher_jj_consume_token($this, 249);
                    break a;
                default:
            }
            $this.$jj_la1.data[263] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$9) {
                case 152:
                    oncipj_Cypher_jj_consume_token($this, 152);
                    $currentUser = 1;
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 95:
                            oncipj_Cypher_jj_consume_token($this, 95);
                            $this.$jj_la = 2147483647;
                            $useClause = $this.$token;
                            $this.$jj_scanpos = $useClause;
                            $this.$jj_lastpos = $useClause;
                            c: {
                                d: {
                                    e: {
                                        f: {
                                            try {
                                                $currentUser = oncipj_Cypher_jj_3_101($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break f;
                                                } else{
                                                    $start = $$je;
                                                    break e;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 100, 2147483647);
                                            break c;
                                        }
                                        try {
                                            $currentUser = 1;
                                            break d;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $start = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 100, 2147483647);
                                    $rt_throw($start);
                                }
                                oncipj_Cypher_jj_save($this, 100, 2147483647);
                            }
                            if ($currentUser) {
                                oncipj_Cypher_jj_consume_token($this, 116);
                                oncipj_Cypher_jj_consume_token($this, 325);
                                $currentUser = 1;
                                break b;
                            }
                            var$9 = $this.$jj_ntk;
                            if (var$9 == (-1))
                                var$9 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$9) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    $user = (oncipj_Cypher_SymbolicNameString($this)).$image0;
                                    $currentUser = 0;
                                    break b;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                case 307:
                                    break;
                                default:
                            }
                            $this.$jj_la1.data[264] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                        default:
                    }
                    $this.$jj_la1.data[265] = $this.$jj_gen;
                    break b;
                default:
            }
            $this.$jj_la1.data[266] = $this.$jj_gen;
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        g: {
            switch (var$9) {
                case 334:
                case 339:
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$9) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break g;
                        case 339:
                            $yieldClause = oncipj_Cypher_YieldClause($this);
                            var$9 = $this.$jj_ntk;
                            if (var$9 == (-1))
                                var$9 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$9) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[267] = $this.$jj_gen;
                                    break g;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break g;
                        default:
                    }
                    $this.$jj_la1.data[268] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[269] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showProcedureClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $currentUser, $user, $where, 0));
        else {
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showProcedureClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $currentUser, $user, $where, 1));
            ju_ArrayList_add($clauses, $yieldClause);
            if ($returnClause !== null)
                ju_ArrayList_add($clauses, $returnClause);
        }
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_ShowFunctions($this, $start, $useClause, $functionType) {
        var $clauses, $currentUser, $user, $where, $yieldClause, $returnClause, var$10, var$11, $$je;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $currentUser = 0;
        $user = null;
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$10) {
                case 166:
                    oncipj_Cypher_jj_consume_token($this, 166);
                    break a;
                case 167:
                    oncipj_Cypher_jj_consume_token($this, 167);
                    break a;
                default:
            }
            $this.$jj_la1.data[270] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$10) {
                case 152:
                    oncipj_Cypher_jj_consume_token($this, 152);
                    $currentUser = 1;
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 95:
                            oncipj_Cypher_jj_consume_token($this, 95);
                            $this.$jj_la = 2147483647;
                            $useClause = $this.$token;
                            $this.$jj_scanpos = $useClause;
                            $this.$jj_lastpos = $useClause;
                            c: {
                                d: {
                                    e: {
                                        f: {
                                            try {
                                                var$11 = oncipj_Cypher_jj_3_102($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break f;
                                                } else{
                                                    $start = $$je;
                                                    break e;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 101, 2147483647);
                                            break c;
                                        }
                                        try {
                                            var$11 = 1;
                                            break d;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $start = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 101, 2147483647);
                                    $rt_throw($start);
                                }
                                oncipj_Cypher_jj_save($this, 101, 2147483647);
                            }
                            if (var$11) {
                                oncipj_Cypher_jj_consume_token($this, 116);
                                oncipj_Cypher_jj_consume_token($this, 325);
                                $currentUser = 1;
                                break b;
                            }
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    $user = (oncipj_Cypher_SymbolicNameString($this)).$image0;
                                    $currentUser = 0;
                                    break b;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                case 307:
                                    break;
                                default:
                            }
                            $this.$jj_la1.data[271] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                        default:
                    }
                    $this.$jj_la1.data[272] = $this.$jj_gen;
                    break b;
                default:
            }
            $this.$jj_la1.data[273] = $this.$jj_gen;
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        g: {
            switch (var$10) {
                case 334:
                case 339:
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break g;
                        case 339:
                            $yieldClause = oncipj_Cypher_YieldClause($this);
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[274] = $this.$jj_gen;
                                    break g;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break g;
                        default:
                    }
                    $this.$jj_la1.data[275] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[276] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showFunctionClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $functionType, $currentUser, $user, $where, 0));
        else {
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showFunctionClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $functionType, $currentUser, $user, $where, 1));
            ju_ArrayList_add($clauses, $yieldClause);
            if ($returnClause !== null)
                ju_ArrayList_add($clauses, $returnClause);
        }
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_ShowTransactions($this, $start) {
        var $clauses, $idEither, $where, $yieldClause, $returnClause, $tailClauses, var$8, var$9, var$10, $$je;
        $clauses = new ju_LinkedList;
        $idEither = onciaf_SimpleEither_left(ju_ArrayList__init_());
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        $tailClauses = null;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 312:
                    oncipj_Cypher_jj_consume_token($this, 312);
                    break a;
                case 313:
                    oncipj_Cypher_jj_consume_token($this, 313);
                    break a;
                default:
            }
            $this.$jj_la1.data[277] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$8) {
                case 35:
                case 36:
                case 39:
                case 40:
                case 52:
                case 64:
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 131:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 194:
                case 195:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 202:
                case 204:
                case 205:
                case 206:
                case 207:
                case 208:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 238:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $this.$jj_la = 2147483647;
                    var$9 = $this.$token;
                    $this.$jj_scanpos = var$9;
                    $this.$jj_lastpos = var$9;
                    c: {
                        d: {
                            e: {
                                f: {
                                    try {
                                        var$10 = oncipj_Cypher_jj_3_106($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break f;
                                        } else{
                                            $start = $$je;
                                            break e;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 105, 2147483647);
                                    break c;
                                }
                                try {
                                    var$10 = 1;
                                    break d;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $start = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 105, 2147483647);
                            $rt_throw($start);
                        }
                        oncipj_Cypher_jj_save($this, 105, 2147483647);
                    }
                    if (var$10) {
                        $tailClauses = oncipj_Cypher_showOrTerminateTransactions($this);
                        break b;
                    }
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$8) {
                        case 35:
                        case 36:
                        case 39:
                        case 40:
                        case 52:
                        case 64:
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 194:
                        case 195:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 202:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 208:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 238:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            $this.$jj_la = 2147483647;
                            var$9 = $this.$token;
                            $this.$jj_scanpos = var$9;
                            $this.$jj_lastpos = var$9;
                            g: {
                                h: {
                                    i: {
                                        j: {
                                            try {
                                                var$10 = oncipj_Cypher_jj_3_103($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break j;
                                                } else{
                                                    $start = $$je;
                                                    break i;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 102, 2147483647);
                                            break g;
                                        }
                                        try {
                                            var$10 = 1;
                                            break h;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $start = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 102, 2147483647);
                                    $rt_throw($start);
                                }
                                oncipj_Cypher_jj_save($this, 102, 2147483647);
                            }
                            k: {
                                if (var$10) {
                                    $idEither = oncipj_Cypher_stringsOrExpression($this);
                                    var$8 = $this.$jj_ntk;
                                    if (var$8 == (-1))
                                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$8) {
                                        case 334:
                                            $where = oncipj_Cypher_WhereClause($this);
                                            break k;
                                        case 339:
                                            $yieldClause = oncipj_Cypher_YieldClause($this);
                                            var$8 = $this.$jj_ntk;
                                            if (var$8 == (-1))
                                                var$8 = oncipj_Cypher_jj_ntk_f($this);
                                            switch (var$8) {
                                                case 269:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[278] = $this.$jj_gen;
                                                    break k;
                                            }
                                            $returnClause = oncipj_Cypher_ReturnClause($this);
                                            break k;
                                        default:
                                    }
                                    $this.$jj_la1.data[279] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                                }
                                $this.$jj_la = 2147483647;
                                var$9 = $this.$token;
                                $this.$jj_scanpos = var$9;
                                $this.$jj_lastpos = var$9;
                                l: {
                                    m: {
                                        n: {
                                            o: {
                                                try {
                                                    var$10 = oncipj_Cypher_jj_3_104($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break o;
                                                    } else{
                                                        $start = $$je;
                                                        break n;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 103, 2147483647);
                                                break l;
                                            }
                                            try {
                                                var$10 = 1;
                                                break m;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $start = $$je;

                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 103, 2147483647);
                                        $rt_throw($start);
                                    }
                                    oncipj_Cypher_jj_save($this, 103, 2147483647);
                                }
                                if (var$10) {
                                    $yieldClause = oncipj_Cypher_YieldClause($this);
                                    var$8 = $this.$jj_ntk;
                                    if (var$8 == (-1))
                                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$8) {
                                        case 269:
                                            break;
                                        default:
                                            $this.$jj_la1.data[280] = $this.$jj_gen;
                                            break k;
                                    }
                                    $returnClause = oncipj_Cypher_ReturnClause($this);
                                } else {
                                    $this.$jj_la = 2147483647;
                                    var$9 = $this.$token;
                                    $this.$jj_scanpos = var$9;
                                    $this.$jj_lastpos = var$9;
                                    p: {
                                        q: {
                                            r: {
                                                s: {
                                                    try {
                                                        var$10 = oncipj_Cypher_jj_3_105($this) ? 0 : 1;
                                                    } catch ($$e) {
                                                        $$je = $rt_wrapException($$e);
                                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                            break s;
                                                        } else{
                                                            $start = $$je;
                                                            break r;
                                                        }
                                                    }
                                                    oncipj_Cypher_jj_save($this, 104, 2147483647);
                                                    break p;
                                                }
                                                try {
                                                    var$10 = 1;
                                                    break q;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    $start = $$je;

                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 104, 2147483647);
                                            $rt_throw($start);
                                        }
                                        oncipj_Cypher_jj_save($this, 104, 2147483647);
                                    }
                                    if (var$10)
                                        $where = oncipj_Cypher_WhereClause($this);
                                    else {
                                        var$8 = $this.$jj_ntk;
                                        if (var$8 == (-1))
                                            var$8 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$8) {
                                            case 35:
                                            case 36:
                                            case 39:
                                            case 40:
                                            case 52:
                                            case 64:
                                            case 68:
                                            case 69:
                                            case 70:
                                            case 71:
                                            case 72:
                                            case 73:
                                            case 74:
                                            case 75:
                                            case 76:
                                            case 77:
                                            case 78:
                                            case 79:
                                            case 80:
                                            case 81:
                                            case 82:
                                            case 83:
                                            case 84:
                                            case 85:
                                            case 87:
                                            case 88:
                                            case 89:
                                            case 90:
                                            case 91:
                                            case 92:
                                            case 93:
                                            case 94:
                                            case 95:
                                            case 96:
                                            case 97:
                                            case 98:
                                            case 99:
                                            case 100:
                                            case 104:
                                            case 105:
                                            case 106:
                                            case 107:
                                            case 108:
                                            case 109:
                                            case 110:
                                            case 111:
                                            case 112:
                                            case 113:
                                            case 114:
                                            case 115:
                                            case 116:
                                            case 117:
                                            case 118:
                                            case 119:
                                            case 120:
                                            case 121:
                                            case 122:
                                            case 123:
                                            case 124:
                                            case 125:
                                            case 126:
                                            case 127:
                                            case 128:
                                            case 129:
                                            case 130:
                                            case 131:
                                            case 132:
                                            case 133:
                                            case 137:
                                            case 138:
                                            case 139:
                                            case 140:
                                            case 141:
                                            case 142:
                                            case 143:
                                            case 144:
                                            case 145:
                                            case 146:
                                            case 147:
                                            case 148:
                                            case 149:
                                            case 150:
                                            case 152:
                                            case 153:
                                            case 154:
                                            case 155:
                                            case 156:
                                            case 157:
                                            case 158:
                                            case 159:
                                            case 160:
                                            case 161:
                                            case 162:
                                            case 163:
                                            case 164:
                                            case 165:
                                            case 166:
                                            case 167:
                                            case 169:
                                            case 170:
                                            case 171:
                                            case 172:
                                            case 173:
                                            case 175:
                                            case 176:
                                            case 177:
                                            case 179:
                                            case 180:
                                            case 181:
                                            case 182:
                                            case 183:
                                            case 184:
                                            case 185:
                                            case 186:
                                            case 187:
                                            case 188:
                                            case 189:
                                            case 190:
                                            case 191:
                                            case 194:
                                            case 195:
                                            case 197:
                                            case 198:
                                            case 199:
                                            case 200:
                                            case 201:
                                            case 202:
                                            case 204:
                                            case 205:
                                            case 206:
                                            case 207:
                                            case 208:
                                            case 212:
                                            case 213:
                                            case 214:
                                            case 215:
                                            case 216:
                                            case 217:
                                            case 218:
                                            case 219:
                                            case 220:
                                            case 221:
                                            case 222:
                                            case 223:
                                            case 224:
                                            case 225:
                                            case 226:
                                            case 227:
                                            case 228:
                                            case 229:
                                            case 230:
                                            case 231:
                                            case 232:
                                            case 233:
                                            case 234:
                                            case 235:
                                            case 236:
                                            case 237:
                                            case 238:
                                            case 240:
                                            case 241:
                                            case 243:
                                            case 244:
                                            case 245:
                                            case 246:
                                            case 247:
                                            case 248:
                                            case 249:
                                            case 250:
                                            case 251:
                                            case 253:
                                            case 256:
                                            case 257:
                                            case 258:
                                            case 259:
                                            case 261:
                                            case 262:
                                            case 263:
                                            case 264:
                                            case 265:
                                            case 266:
                                            case 267:
                                            case 268:
                                            case 269:
                                            case 270:
                                            case 271:
                                            case 272:
                                            case 273:
                                            case 274:
                                            case 276:
                                            case 277:
                                            case 278:
                                            case 279:
                                            case 280:
                                            case 281:
                                            case 282:
                                            case 284:
                                            case 285:
                                            case 286:
                                            case 287:
                                            case 288:
                                            case 289:
                                            case 290:
                                            case 291:
                                            case 292:
                                            case 293:
                                            case 294:
                                            case 295:
                                            case 296:
                                            case 297:
                                            case 298:
                                            case 299:
                                            case 300:
                                            case 301:
                                            case 302:
                                            case 303:
                                            case 304:
                                            case 305:
                                            case 306:
                                            case 308:
                                            case 309:
                                            case 310:
                                            case 311:
                                            case 312:
                                            case 313:
                                            case 314:
                                            case 315:
                                            case 316:
                                            case 317:
                                            case 318:
                                            case 319:
                                            case 320:
                                            case 321:
                                            case 322:
                                            case 323:
                                            case 324:
                                            case 325:
                                            case 326:
                                            case 327:
                                            case 328:
                                            case 329:
                                            case 330:
                                            case 331:
                                            case 332:
                                            case 333:
                                            case 334:
                                            case 335:
                                            case 336:
                                            case 337:
                                            case 338:
                                            case 339:
                                            case 340:
                                            case 341:
                                                $idEither = oncipj_Cypher_stringsOrExpression($this);
                                                break k;
                                            case 37:
                                            case 38:
                                            case 41:
                                            case 42:
                                            case 43:
                                            case 44:
                                            case 45:
                                            case 46:
                                            case 47:
                                            case 48:
                                            case 49:
                                            case 50:
                                            case 51:
                                            case 53:
                                            case 54:
                                            case 55:
                                            case 56:
                                            case 57:
                                            case 58:
                                            case 59:
                                            case 60:
                                            case 61:
                                            case 62:
                                            case 63:
                                            case 65:
                                            case 66:
                                            case 67:
                                            case 86:
                                            case 101:
                                            case 102:
                                            case 103:
                                            case 134:
                                            case 135:
                                            case 136:
                                            case 151:
                                            case 168:
                                            case 174:
                                            case 178:
                                            case 192:
                                            case 193:
                                            case 196:
                                            case 203:
                                            case 209:
                                            case 210:
                                            case 211:
                                            case 239:
                                            case 242:
                                            case 252:
                                            case 254:
                                            case 255:
                                            case 260:
                                            case 275:
                                            case 283:
                                            case 307:
                                                break;
                                            default:
                                        }
                                        $this.$jj_la1.data[281] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $start = new oncipj_ParseException;
                                        jl_Throwable__init_0($start);
                                        $rt_throw($start);
                                    }
                                }
                            }
                            var$8 = $this.$jj_ntk;
                            if (var$8 == (-1))
                                var$8 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$8) {
                                case 291:
                                case 303:
                                    break;
                                default:
                                    $this.$jj_la1.data[282] = $this.$jj_gen;
                                    break b;
                            }
                            $tailClauses = oncipj_Cypher_showOrTerminateTransactions($this);
                            break b;
                        case 37:
                        case 38:
                        case 41:
                        case 42:
                        case 43:
                        case 44:
                        case 45:
                        case 46:
                        case 47:
                        case 48:
                        case 49:
                        case 50:
                        case 51:
                        case 53:
                        case 54:
                        case 55:
                        case 56:
                        case 57:
                        case 58:
                        case 59:
                        case 60:
                        case 61:
                        case 62:
                        case 63:
                        case 65:
                        case 66:
                        case 67:
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 196:
                        case 203:
                        case 209:
                        case 210:
                        case 211:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[283] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                case 37:
                case 38:
                case 41:
                case 42:
                case 43:
                case 44:
                case 45:
                case 46:
                case 47:
                case 48:
                case 49:
                case 50:
                case 51:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                case 58:
                case 59:
                case 60:
                case 61:
                case 62:
                case 63:
                case 65:
                case 66:
                case 67:
                case 86:
                case 101:
                case 102:
                case 103:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 196:
                case 203:
                case 209:
                case 210:
                case 211:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                default:
            }
            $this.$jj_la1.data[284] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_AbstractList_add($clauses, onciafn_Neo4jASTFactory_showTransactionsClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $idEither, $where, null));
        else {
            ju_AbstractList_add($clauses, onciafn_Neo4jASTFactory_showTransactionsClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $idEither, $where, $yieldClause));
            ju_AbstractList_add($clauses, onciafn_Neo4jASTFactory_turnYieldToWith($this.$astFactory, $yieldClause));
            if ($returnClause !== null)
                ju_AbstractList_add($clauses, $returnClause);
        }
        if ($tailClauses !== null)
            ju_AbstractCollection_addAll($clauses, $tailClauses);
        return $clauses;
    }
    function oncipj_Cypher_TerminateTransactions($this, $start) {
        var $clauses, $idEither, $where, $yieldClause, $returnClause, $tailClauses, var$8, var$9, var$10, $$je;
        $clauses = new ju_LinkedList;
        $idEither = onciaf_SimpleEither_left(ju_ArrayList__init_());
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        $tailClauses = null;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 312:
                    oncipj_Cypher_jj_consume_token($this, 312);
                    break a;
                case 313:
                    oncipj_Cypher_jj_consume_token($this, 313);
                    break a;
                default:
            }
            $this.$jj_la1.data[285] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$8) {
                case 35:
                case 36:
                case 39:
                case 40:
                case 52:
                case 64:
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 131:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 194:
                case 195:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 202:
                case 204:
                case 205:
                case 206:
                case 207:
                case 208:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 238:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $this.$jj_la = 2147483647;
                    var$9 = $this.$token;
                    $this.$jj_scanpos = var$9;
                    $this.$jj_lastpos = var$9;
                    c: {
                        d: {
                            e: {
                                f: {
                                    try {
                                        var$10 = oncipj_Cypher_jj_3_110($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break f;
                                        } else{
                                            $start = $$je;
                                            break e;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 109, 2147483647);
                                    break c;
                                }
                                try {
                                    var$10 = 1;
                                    break d;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $start = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 109, 2147483647);
                            $rt_throw($start);
                        }
                        oncipj_Cypher_jj_save($this, 109, 2147483647);
                    }
                    if (var$10) {
                        $tailClauses = oncipj_Cypher_showOrTerminateTransactions($this);
                        break b;
                    }
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$8) {
                        case 35:
                        case 36:
                        case 39:
                        case 40:
                        case 52:
                        case 64:
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 194:
                        case 195:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 202:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 208:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 238:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            $this.$jj_la = 2147483647;
                            var$9 = $this.$token;
                            $this.$jj_scanpos = var$9;
                            $this.$jj_lastpos = var$9;
                            g: {
                                h: {
                                    i: {
                                        j: {
                                            try {
                                                var$10 = oncipj_Cypher_jj_3_107($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break j;
                                                } else{
                                                    $start = $$je;
                                                    break i;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 106, 2147483647);
                                            break g;
                                        }
                                        try {
                                            var$10 = 1;
                                            break h;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $start = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 106, 2147483647);
                                    $rt_throw($start);
                                }
                                oncipj_Cypher_jj_save($this, 106, 2147483647);
                            }
                            k: {
                                if (var$10) {
                                    $idEither = oncipj_Cypher_stringsOrExpression($this);
                                    var$8 = $this.$jj_ntk;
                                    if (var$8 == (-1))
                                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$8) {
                                        case 334:
                                            $where = oncipj_Cypher_WhereClause($this);
                                            break k;
                                        case 339:
                                            $yieldClause = oncipj_Cypher_YieldClause($this);
                                            var$8 = $this.$jj_ntk;
                                            if (var$8 == (-1))
                                                var$8 = oncipj_Cypher_jj_ntk_f($this);
                                            switch (var$8) {
                                                case 269:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[286] = $this.$jj_gen;
                                                    break k;
                                            }
                                            $returnClause = oncipj_Cypher_ReturnClause($this);
                                            break k;
                                        default:
                                    }
                                    $this.$jj_la1.data[287] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                                }
                                $this.$jj_la = 2147483647;
                                var$9 = $this.$token;
                                $this.$jj_scanpos = var$9;
                                $this.$jj_lastpos = var$9;
                                l: {
                                    m: {
                                        n: {
                                            o: {
                                                try {
                                                    var$10 = oncipj_Cypher_jj_3_108($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break o;
                                                    } else{
                                                        $start = $$je;
                                                        break n;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 107, 2147483647);
                                                break l;
                                            }
                                            try {
                                                var$10 = 1;
                                                break m;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $start = $$je;

                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 107, 2147483647);
                                        $rt_throw($start);
                                    }
                                    oncipj_Cypher_jj_save($this, 107, 2147483647);
                                }
                                if (var$10) {
                                    $yieldClause = oncipj_Cypher_YieldClause($this);
                                    var$8 = $this.$jj_ntk;
                                    if (var$8 == (-1))
                                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$8) {
                                        case 269:
                                            break;
                                        default:
                                            $this.$jj_la1.data[288] = $this.$jj_gen;
                                            break k;
                                    }
                                    $returnClause = oncipj_Cypher_ReturnClause($this);
                                } else {
                                    $this.$jj_la = 2147483647;
                                    var$9 = $this.$token;
                                    $this.$jj_scanpos = var$9;
                                    $this.$jj_lastpos = var$9;
                                    p: {
                                        q: {
                                            r: {
                                                s: {
                                                    try {
                                                        var$10 = oncipj_Cypher_jj_3_109($this) ? 0 : 1;
                                                    } catch ($$e) {
                                                        $$je = $rt_wrapException($$e);
                                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                            break s;
                                                        } else{
                                                            $start = $$je;
                                                            break r;
                                                        }
                                                    }
                                                    oncipj_Cypher_jj_save($this, 108, 2147483647);
                                                    break p;
                                                }
                                                try {
                                                    var$10 = 1;
                                                    break q;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    $start = $$je;

                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 108, 2147483647);
                                            $rt_throw($start);
                                        }
                                        oncipj_Cypher_jj_save($this, 108, 2147483647);
                                    }
                                    if (var$10)
                                        $where = oncipj_Cypher_WhereClause($this);
                                    else {
                                        var$8 = $this.$jj_ntk;
                                        if (var$8 == (-1))
                                            var$8 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$8) {
                                            case 35:
                                            case 36:
                                            case 39:
                                            case 40:
                                            case 52:
                                            case 64:
                                            case 68:
                                            case 69:
                                            case 70:
                                            case 71:
                                            case 72:
                                            case 73:
                                            case 74:
                                            case 75:
                                            case 76:
                                            case 77:
                                            case 78:
                                            case 79:
                                            case 80:
                                            case 81:
                                            case 82:
                                            case 83:
                                            case 84:
                                            case 85:
                                            case 87:
                                            case 88:
                                            case 89:
                                            case 90:
                                            case 91:
                                            case 92:
                                            case 93:
                                            case 94:
                                            case 95:
                                            case 96:
                                            case 97:
                                            case 98:
                                            case 99:
                                            case 100:
                                            case 104:
                                            case 105:
                                            case 106:
                                            case 107:
                                            case 108:
                                            case 109:
                                            case 110:
                                            case 111:
                                            case 112:
                                            case 113:
                                            case 114:
                                            case 115:
                                            case 116:
                                            case 117:
                                            case 118:
                                            case 119:
                                            case 120:
                                            case 121:
                                            case 122:
                                            case 123:
                                            case 124:
                                            case 125:
                                            case 126:
                                            case 127:
                                            case 128:
                                            case 129:
                                            case 130:
                                            case 131:
                                            case 132:
                                            case 133:
                                            case 137:
                                            case 138:
                                            case 139:
                                            case 140:
                                            case 141:
                                            case 142:
                                            case 143:
                                            case 144:
                                            case 145:
                                            case 146:
                                            case 147:
                                            case 148:
                                            case 149:
                                            case 150:
                                            case 152:
                                            case 153:
                                            case 154:
                                            case 155:
                                            case 156:
                                            case 157:
                                            case 158:
                                            case 159:
                                            case 160:
                                            case 161:
                                            case 162:
                                            case 163:
                                            case 164:
                                            case 165:
                                            case 166:
                                            case 167:
                                            case 169:
                                            case 170:
                                            case 171:
                                            case 172:
                                            case 173:
                                            case 175:
                                            case 176:
                                            case 177:
                                            case 179:
                                            case 180:
                                            case 181:
                                            case 182:
                                            case 183:
                                            case 184:
                                            case 185:
                                            case 186:
                                            case 187:
                                            case 188:
                                            case 189:
                                            case 190:
                                            case 191:
                                            case 194:
                                            case 195:
                                            case 197:
                                            case 198:
                                            case 199:
                                            case 200:
                                            case 201:
                                            case 202:
                                            case 204:
                                            case 205:
                                            case 206:
                                            case 207:
                                            case 208:
                                            case 212:
                                            case 213:
                                            case 214:
                                            case 215:
                                            case 216:
                                            case 217:
                                            case 218:
                                            case 219:
                                            case 220:
                                            case 221:
                                            case 222:
                                            case 223:
                                            case 224:
                                            case 225:
                                            case 226:
                                            case 227:
                                            case 228:
                                            case 229:
                                            case 230:
                                            case 231:
                                            case 232:
                                            case 233:
                                            case 234:
                                            case 235:
                                            case 236:
                                            case 237:
                                            case 238:
                                            case 240:
                                            case 241:
                                            case 243:
                                            case 244:
                                            case 245:
                                            case 246:
                                            case 247:
                                            case 248:
                                            case 249:
                                            case 250:
                                            case 251:
                                            case 253:
                                            case 256:
                                            case 257:
                                            case 258:
                                            case 259:
                                            case 261:
                                            case 262:
                                            case 263:
                                            case 264:
                                            case 265:
                                            case 266:
                                            case 267:
                                            case 268:
                                            case 269:
                                            case 270:
                                            case 271:
                                            case 272:
                                            case 273:
                                            case 274:
                                            case 276:
                                            case 277:
                                            case 278:
                                            case 279:
                                            case 280:
                                            case 281:
                                            case 282:
                                            case 284:
                                            case 285:
                                            case 286:
                                            case 287:
                                            case 288:
                                            case 289:
                                            case 290:
                                            case 291:
                                            case 292:
                                            case 293:
                                            case 294:
                                            case 295:
                                            case 296:
                                            case 297:
                                            case 298:
                                            case 299:
                                            case 300:
                                            case 301:
                                            case 302:
                                            case 303:
                                            case 304:
                                            case 305:
                                            case 306:
                                            case 308:
                                            case 309:
                                            case 310:
                                            case 311:
                                            case 312:
                                            case 313:
                                            case 314:
                                            case 315:
                                            case 316:
                                            case 317:
                                            case 318:
                                            case 319:
                                            case 320:
                                            case 321:
                                            case 322:
                                            case 323:
                                            case 324:
                                            case 325:
                                            case 326:
                                            case 327:
                                            case 328:
                                            case 329:
                                            case 330:
                                            case 331:
                                            case 332:
                                            case 333:
                                            case 334:
                                            case 335:
                                            case 336:
                                            case 337:
                                            case 338:
                                            case 339:
                                            case 340:
                                            case 341:
                                                $idEither = oncipj_Cypher_stringsOrExpression($this);
                                                break k;
                                            case 37:
                                            case 38:
                                            case 41:
                                            case 42:
                                            case 43:
                                            case 44:
                                            case 45:
                                            case 46:
                                            case 47:
                                            case 48:
                                            case 49:
                                            case 50:
                                            case 51:
                                            case 53:
                                            case 54:
                                            case 55:
                                            case 56:
                                            case 57:
                                            case 58:
                                            case 59:
                                            case 60:
                                            case 61:
                                            case 62:
                                            case 63:
                                            case 65:
                                            case 66:
                                            case 67:
                                            case 86:
                                            case 101:
                                            case 102:
                                            case 103:
                                            case 134:
                                            case 135:
                                            case 136:
                                            case 151:
                                            case 168:
                                            case 174:
                                            case 178:
                                            case 192:
                                            case 193:
                                            case 196:
                                            case 203:
                                            case 209:
                                            case 210:
                                            case 211:
                                            case 239:
                                            case 242:
                                            case 252:
                                            case 254:
                                            case 255:
                                            case 260:
                                            case 275:
                                            case 283:
                                            case 307:
                                                break;
                                            default:
                                        }
                                        $this.$jj_la1.data[289] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $start = new oncipj_ParseException;
                                        jl_Throwable__init_0($start);
                                        $rt_throw($start);
                                    }
                                }
                            }
                            var$8 = $this.$jj_ntk;
                            if (var$8 == (-1))
                                var$8 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$8) {
                                case 291:
                                case 303:
                                    break;
                                default:
                                    $this.$jj_la1.data[290] = $this.$jj_gen;
                                    break b;
                            }
                            $tailClauses = oncipj_Cypher_showOrTerminateTransactions($this);
                            break b;
                        case 37:
                        case 38:
                        case 41:
                        case 42:
                        case 43:
                        case 44:
                        case 45:
                        case 46:
                        case 47:
                        case 48:
                        case 49:
                        case 50:
                        case 51:
                        case 53:
                        case 54:
                        case 55:
                        case 56:
                        case 57:
                        case 58:
                        case 59:
                        case 60:
                        case 61:
                        case 62:
                        case 63:
                        case 65:
                        case 66:
                        case 67:
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 196:
                        case 203:
                        case 209:
                        case 210:
                        case 211:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[291] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                case 37:
                case 38:
                case 41:
                case 42:
                case 43:
                case 44:
                case 45:
                case 46:
                case 47:
                case 48:
                case 49:
                case 50:
                case 51:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                case 58:
                case 59:
                case 60:
                case 61:
                case 62:
                case 63:
                case 65:
                case 66:
                case 67:
                case 86:
                case 101:
                case 102:
                case 103:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 196:
                case 203:
                case 209:
                case 210:
                case 211:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                default:
            }
            $this.$jj_la1.data[292] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_AbstractList_add($clauses, onciafn_Neo4jASTFactory_terminateTransactionsClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $idEither, $where, null));
        else {
            ju_AbstractList_add($clauses, onciafn_Neo4jASTFactory_terminateTransactionsClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $idEither, $where, $yieldClause));
            ju_AbstractList_add($clauses, onciafn_Neo4jASTFactory_turnYieldToWith($this.$astFactory, $yieldClause));
            if ($returnClause !== null)
                ju_AbstractList_add($clauses, $returnClause);
        }
        if ($tailClauses !== null)
            ju_AbstractCollection_addAll($clauses, $tailClauses);
        return $clauses;
    }
    function oncipj_Cypher_showOrTerminateTransactions($this) {
        var var$1, var$2;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 291:
                    break;
                case 303:
                    var$2 = oncipj_Cypher_TerminateTransactions($this, oncipj_Cypher_jj_consume_token($this, 303));
                    break a;
                default:
                    $this.$jj_la1.data[293] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    var$2 = new oncipj_ParseException;
                    jl_Throwable__init_0(var$2);
                    $rt_throw(var$2);
            }
            var$2 = oncipj_Cypher_ShowTransactions($this, oncipj_Cypher_jj_consume_token($this, 291));
        }
        return var$2;
    }
    function oncipj_Cypher_stringsOrExpression($this) {
        var $ids, var$2, var$3, $$je;
        onciaf_SimpleEither_left(ju_ArrayList__init_());
        $this.$jj_la = 2147483647;
        $ids = $this.$token;
        $this.$jj_scanpos = $ids;
        $this.$jj_lastpos = $ids;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_111($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $ids = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 110, 2147483647);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $ids = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 110, 2147483647);
                $rt_throw($ids);
            }
            oncipj_Cypher_jj_save($this, 110, 2147483647);
        }
        e: {
            if (!var$2) {
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                f: {
                    switch (var$3) {
                        case 35:
                        case 36:
                        case 39:
                        case 40:
                        case 52:
                        case 64:
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 194:
                        case 195:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 202:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 208:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 238:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            break;
                        case 37:
                        case 38:
                        case 41:
                        case 42:
                        case 43:
                        case 44:
                        case 45:
                        case 46:
                        case 47:
                        case 48:
                        case 49:
                        case 50:
                        case 51:
                        case 53:
                        case 54:
                        case 55:
                        case 56:
                        case 57:
                        case 58:
                        case 59:
                        case 60:
                        case 61:
                        case 62:
                        case 63:
                        case 65:
                        case 66:
                        case 67:
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 196:
                        case 203:
                        case 209:
                        case 210:
                        case 211:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break f;
                        default:
                            break f;
                    }
                    $ids = onciaf_SimpleEither_right(oncipj_Cypher_Expression($this));
                    break e;
                }
                $this.$jj_la1.data[294] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $ids = new oncipj_ParseException;
                jl_Throwable__init_0($ids);
                $rt_throw($ids);
            }
            $ids = ju_ArrayList__init_();
            ju_ArrayList_add($ids, oncipj_Cypher_StringImage($this));
            g: while (true) {
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$3) {
                    case 103:
                        break;
                    default:
                        break g;
                }
                oncipj_Cypher_jj_consume_token($this, 103);
                ju_ArrayList_add($ids, oncipj_Cypher_StringImage($this));
            }
            $this.$jj_la1.data[626] = $this.$jj_gen;
            $ids = onciaf_SimpleEither_left($ids);
        }
        return $ids;
    }
    function oncipj_Cypher_ShowSettings($this, $start, $useClause) {
        var $clauses, $nameEither, $where, $yieldClause, $returnClause, var$8, var$9, $$je;
        $clauses = ju_ArrayList__init_();
        if ($useClause !== null)
            ju_ArrayList_add($clauses, $useClause);
        $nameEither = onciaf_SimpleEither_left(ju_ArrayList__init_());
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 287:
                    oncipj_Cypher_jj_consume_token($this, 287);
                    break a;
                case 288:
                    oncipj_Cypher_jj_consume_token($this, 288);
                    break a;
                default:
            }
            $this.$jj_la1.data[295] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$8) {
                case 35:
                case 36:
                case 39:
                case 40:
                case 52:
                case 64:
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 131:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 194:
                case 195:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 202:
                case 204:
                case 205:
                case 206:
                case 207:
                case 208:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 238:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $this.$jj_la = 2147483647;
                    $useClause = $this.$token;
                    $this.$jj_scanpos = $useClause;
                    $this.$jj_lastpos = $useClause;
                    c: {
                        d: {
                            e: {
                                f: {
                                    try {
                                        var$9 = oncipj_Cypher_jj_3_112($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break f;
                                        } else{
                                            $start = $$je;
                                            break e;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 111, 2147483647);
                                    break c;
                                }
                                try {
                                    var$9 = 1;
                                    break d;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $start = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 111, 2147483647);
                            $rt_throw($start);
                        }
                        oncipj_Cypher_jj_save($this, 111, 2147483647);
                    }
                    if (var$9) {
                        $nameEither = oncipj_Cypher_stringsOrExpression($this);
                        var$8 = $this.$jj_ntk;
                        if (var$8 == (-1))
                            var$8 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$8) {
                            case 334:
                                $where = oncipj_Cypher_WhereClause($this);
                                break b;
                            case 339:
                                $yieldClause = oncipj_Cypher_YieldClause($this);
                                var$8 = $this.$jj_ntk;
                                if (var$8 == (-1))
                                    var$8 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$8) {
                                    case 269:
                                        break;
                                    default:
                                        $this.$jj_la1.data[296] = $this.$jj_gen;
                                        break b;
                                }
                                $returnClause = oncipj_Cypher_ReturnClause($this);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[297] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    $this.$jj_la = 2147483647;
                    $useClause = $this.$token;
                    $this.$jj_scanpos = $useClause;
                    $this.$jj_lastpos = $useClause;
                    g: {
                        h: {
                            i: {
                                j: {
                                    try {
                                        var$9 = oncipj_Cypher_jj_3_113($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break j;
                                        } else{
                                            $start = $$je;
                                            break i;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 112, 2147483647);
                                    break g;
                                }
                                try {
                                    var$9 = 1;
                                    break h;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $start = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 112, 2147483647);
                            $rt_throw($start);
                        }
                        oncipj_Cypher_jj_save($this, 112, 2147483647);
                    }
                    if (var$9) {
                        $yieldClause = oncipj_Cypher_YieldClause($this);
                        var$8 = $this.$jj_ntk;
                        if (var$8 == (-1))
                            var$8 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$8) {
                            case 269:
                                break;
                            default:
                                $this.$jj_la1.data[298] = $this.$jj_gen;
                                break b;
                        }
                        $returnClause = oncipj_Cypher_ReturnClause($this);
                        break b;
                    }
                    $this.$jj_la = 2147483647;
                    $useClause = $this.$token;
                    $this.$jj_scanpos = $useClause;
                    $this.$jj_lastpos = $useClause;
                    k: {
                        l: {
                            m: {
                                n: {
                                    try {
                                        var$9 = oncipj_Cypher_jj_3_114($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break n;
                                        } else{
                                            $start = $$je;
                                            break m;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 113, 2147483647);
                                    break k;
                                }
                                try {
                                    var$9 = 1;
                                    break l;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $start = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 113, 2147483647);
                            $rt_throw($start);
                        }
                        oncipj_Cypher_jj_save($this, 113, 2147483647);
                    }
                    if (var$9) {
                        $where = oncipj_Cypher_WhereClause($this);
                        break b;
                    }
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$8) {
                        case 35:
                        case 36:
                        case 39:
                        case 40:
                        case 52:
                        case 64:
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 194:
                        case 195:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 202:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 208:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 238:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            $nameEither = oncipj_Cypher_stringsOrExpression($this);
                            break b;
                        case 37:
                        case 38:
                        case 41:
                        case 42:
                        case 43:
                        case 44:
                        case 45:
                        case 46:
                        case 47:
                        case 48:
                        case 49:
                        case 50:
                        case 51:
                        case 53:
                        case 54:
                        case 55:
                        case 56:
                        case 57:
                        case 58:
                        case 59:
                        case 60:
                        case 61:
                        case 62:
                        case 63:
                        case 65:
                        case 66:
                        case 67:
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 196:
                        case 203:
                        case 209:
                        case 210:
                        case 211:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[299] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                case 37:
                case 38:
                case 41:
                case 42:
                case 43:
                case 44:
                case 45:
                case 46:
                case 47:
                case 48:
                case 49:
                case 50:
                case 51:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                case 58:
                case 59:
                case 60:
                case 61:
                case 62:
                case 63:
                case 65:
                case 66:
                case 67:
                case 86:
                case 101:
                case 102:
                case 103:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 196:
                case 203:
                case 209:
                case 210:
                case 211:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                default:
            }
            $this.$jj_la1.data[300] = $this.$jj_gen;
        }
        if ($yieldClause === null)
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showSettingsClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $nameEither, $where, 0));
        else {
            ju_ArrayList_add($clauses, onciafn_Neo4jASTFactory_showSettingsClause($this.$astFactory, oncipj_Cypher_pos($this, $start), $nameEither, $where, 1));
            ju_ArrayList_add($clauses, $yieldClause);
            if ($returnClause !== null)
                ju_ArrayList_add($clauses, $returnClause);
        }
        return onciafn_Neo4jASTFactory_newSingleQuery0($this.$astFactory, oncipj_Cypher_pos($this, $start), $clauses);
    }
    function oncipj_Cypher_CreateConstraint($this, $start, $replace) {
        var $name, $ifNotExists, $propertyType, $options, $isNode, $containsOn, var$9, var$10, $properties, $label, var$13, var$14, var$15, $errorStart;
        a: {
            $name = null;
            $ifNotExists = 0;
            ju_ArrayList__init_0(new ju_ArrayList);
            $propertyType = null;
            $options = null;
            $isNode = 0;
            $containsOn = 1;
            oncipj_Cypher_jj_consume_token($this, 108);
            if (oncipj_Cypher_jj_2_116($this, 2147483647)) {
                oncipj_Cypher_jj_consume_token($this, 224);
                oncipj_Cypher_jj_consume_token($this, 202);
            } else if (oncipj_Cypher_jj_2_117($this, 2147483647)) {
                oncipj_Cypher_jj_consume_token($this, 162);
                oncipj_Cypher_jj_consume_token($this, 202);
                $containsOn = 0;
            } else if (oncipj_Cypher_jj_2_118($this, 2147483647)) {
                oncipj_Cypher_jj_consume_token($this, 177);
                oncipj_Cypher_jj_consume_token($this, 219);
                oncipj_Cypher_jj_consume_token($this, 156);
                $ifNotExists = 1;
                var$9 = $this.$jj_ntk;
                if (var$9 == (-1))
                    var$9 = oncipj_Cypher_jj_ntk_f($this);
                b: {
                    switch (var$9) {
                        case 162:
                            oncipj_Cypher_jj_consume_token($this, 162);
                            $containsOn = 0;
                            break b;
                        case 224:
                            oncipj_Cypher_jj_consume_token($this, 224);
                            break b;
                        default:
                    }
                    $this.$jj_la1.data[301] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                oncipj_Cypher_jj_consume_token($this, 202);
            } else {
                var$10 = $this.$jj_ntk;
                if (var$10 == (-1))
                    var$10 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$10) {
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        if (oncipj_Cypher_jj_2_115($this, 2)) {
                            oncipj_Cypher_SymbolicNameString($this);
                            $name = $this.$token.$image0;
                        }
                        var$9 = $this.$jj_ntk;
                        if (var$9 == (-1))
                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                        c: {
                            switch (var$9) {
                                case 177:
                                    oncipj_Cypher_jj_consume_token($this, 177);
                                    oncipj_Cypher_jj_consume_token($this, 219);
                                    oncipj_Cypher_jj_consume_token($this, 156);
                                    $ifNotExists = 1;
                                    break c;
                                default:
                            }
                            $this.$jj_la1.data[302] = $this.$jj_gen;
                        }
                        var$9 = $this.$jj_ntk;
                        if (var$9 == (-1))
                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                        d: {
                            switch (var$9) {
                                case 162:
                                    oncipj_Cypher_jj_consume_token($this, 162);
                                    $containsOn = 0;
                                    break d;
                                case 224:
                                    oncipj_Cypher_jj_consume_token($this, 224);
                                    break d;
                                default:
                            }
                            $this.$jj_la1.data[303] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        }
                        oncipj_Cypher_jj_consume_token($this, 202);
                        break a;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 202:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break;
                    default:
                }
                $this.$jj_la1.data[304] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $rt_throw(oncipj_ParseException__init_());
            }
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        e: {
            switch (var$9) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $properties = oncipj_Cypher_Variable($this);
                    $label = oncipj_Cypher_LabelOrRelType($this);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    $isNode = 1;
                    break e;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 283:
                case 307:
                    break;
                case 275:
                    oncipj_Cypher_jj_consume_token($this, 275);
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    f: {
                        switch (var$9) {
                            case 203:
                            case 345:
                                break;
                            default:
                                $this.$jj_la1.data[305] = $this.$jj_gen;
                                break f;
                        }
                        oncipj_Cypher_LeftArrow($this);
                    }
                    oncipj_Cypher_ArrowLine($this);
                    oncipj_Cypher_jj_consume_token($this, 194);
                    $properties = oncipj_Cypher_Variable($this);
                    $label = oncipj_Cypher_LabelOrRelType($this);
                    oncipj_Cypher_jj_consume_token($this, 254);
                    oncipj_Cypher_ArrowLine($this);
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    g: {
                        switch (var$9) {
                            case 174:
                            case 346:
                                break;
                            default:
                                $this.$jj_la1.data[306] = $this.$jj_gen;
                                break g;
                        }
                        oncipj_Cypher_RightArrow($this);
                    }
                    oncipj_Cypher_jj_consume_token($this, 202);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    break e;
                default:
            }
            $this.$jj_la1.data[307] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $rt_throw(oncipj_ParseException__init_());
        }
        h: {
            if (oncipj_Cypher_jj_2_119($this, 2147483647)) {
                oncipj_Cypher_jj_consume_token($this, 83);
                onciaf_ConstraintVersion_$callClinit();
                var$13 = onciaf_ConstraintVersion_CONSTRAINT_VERSION_0;
                oncipj_Cypher_jj_consume_token($this, 156);
                if (!$isNode) {
                    onciaf_ConstraintType_$callClinit();
                    var$14 = onciaf_ConstraintType_REL_EXISTS;
                } else {
                    onciaf_ConstraintType_$callClinit();
                    var$14 = onciaf_ConstraintType_NODE_EXISTS;
                }
                var$15 = oncipj_Cypher_PropertyList($this);
            } else {
                var$9 = $this.$jj_ntk;
                if (var$9 == (-1))
                    var$9 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$9) {
                    case 83:
                    case 267:
                        var$9 = $this.$jj_ntk;
                        if (var$9 == (-1))
                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                        i: {
                            switch (var$9) {
                                case 83:
                                    oncipj_Cypher_jj_consume_token($this, 83);
                                    onciaf_ConstraintVersion_$callClinit();
                                    var$13 = onciaf_ConstraintVersion_CONSTRAINT_VERSION_0;
                                    break i;
                                case 267:
                                    oncipj_Cypher_jj_consume_token($this, 267);
                                    onciaf_ConstraintVersion_$callClinit();
                                    var$13 = onciaf_ConstraintVersion_CONSTRAINT_VERSION_2;
                                    break i;
                                default:
                            }
                            $this.$jj_la1.data[308] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        }
                        var$15 = oncipj_Cypher_PropertyList($this);
                        var$9 = $this.$jj_ntk;
                        if (var$9 == (-1))
                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$9) {
                            case 102:
                                oncipj_Cypher_jj_consume_token($this, 102);
                                $propertyType = oncipj_Cypher_cypherTypeName($this);
                                if (!$isNode) {
                                    onciaf_ConstraintType_$callClinit();
                                    var$14 = onciaf_ConstraintType_REL_IS_TYPED;
                                } else {
                                    onciaf_ConstraintType_$callClinit();
                                    var$14 = onciaf_ConstraintType_NODE_IS_TYPED;
                                }
                                break h;
                            case 187:
                                $errorStart = oncipj_Cypher_jj_consume_token($this, 187);
                                var$9 = $this.$jj_ntk;
                                if (var$9 == (-1))
                                    var$9 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$9) {
                                    case 102:
                                    case 317:
                                        var$9 = $this.$jj_ntk;
                                        if (var$9 == (-1))
                                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                                        j: {
                                            switch (var$9) {
                                                case 102:
                                                    oncipj_Cypher_jj_consume_token($this, 102);
                                                    break j;
                                                case 317:
                                                    oncipj_Cypher_jj_consume_token($this, 317);
                                                    break j;
                                                default:
                                            }
                                            $this.$jj_la1.data[312] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $rt_throw(oncipj_ParseException__init_());
                                        }
                                        $propertyType = oncipj_Cypher_cypherTypeName($this);
                                        if (!$isNode) {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_REL_IS_TYPED;
                                        } else {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_NODE_IS_TYPED;
                                        }
                                        break h;
                                    case 189:
                                        oncipj_Cypher_jj_consume_token($this, 189);
                                        if (!$isNode) {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_REL_KEY;
                                        } else {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_NODE_KEY;
                                        }
                                        break h;
                                    case 216:
                                        oncipj_Cypher_jj_consume_token($this, 216);
                                        var$9 = $this.$jj_ntk;
                                        if (var$9 == (-1))
                                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$9) {
                                            case 189:
                                                oncipj_Cypher_jj_consume_token($this, 189);
                                                onciaf_ConstraintType_$callClinit();
                                                var$14 = onciaf_ConstraintType_NODE_KEY;
                                                if (!$isNode)
                                                    $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($this.$exceptionFactory, oncipj_ParseException__init_0(onciaf_ASTExceptionFactory_relationshipPatternNotAllowed(var$14)), $errorStart.$beginOffset, $errorStart.$beginLine, $errorStart.$beginColumn));
                                                break h;
                                            case 320:
                                                oncipj_Cypher_jj_consume_token($this, 320);
                                                onciaf_ConstraintType_$callClinit();
                                                var$14 = onciaf_ConstraintType_NODE_UNIQUE;
                                                if (!$isNode)
                                                    $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($this.$exceptionFactory, oncipj_ParseException__init_0(onciaf_ASTExceptionFactory_relationshipPatternNotAllowed(var$14)), $errorStart.$beginOffset, $errorStart.$beginLine, $errorStart.$beginColumn));
                                                break h;
                                            default:
                                        }
                                        $this.$jj_la1.data[309] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $rt_throw(oncipj_ParseException__init_());
                                    case 219:
                                        oncipj_Cypher_jj_consume_token($this, 219);
                                        oncipj_Cypher_jj_consume_token($this, 222);
                                        if (!$isNode) {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_REL_IS_NOT_NULL;
                                        } else {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_NODE_IS_NOT_NULL;
                                        }
                                        onciaf_ConstraintVersion_$callClinit();
                                        if (var$13 !== onciaf_ConstraintVersion_CONSTRAINT_VERSION_0)
                                            break h;
                                        var$13 = onciaf_ConstraintVersion_CONSTRAINT_VERSION_1;
                                        break h;
                                    case 261:
                                    case 262:
                                        var$9 = $this.$jj_ntk;
                                        if (var$9 == (-1))
                                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                                        k: {
                                            switch (var$9) {
                                                case 261:
                                                    oncipj_Cypher_jj_consume_token($this, 261);
                                                    break k;
                                                case 262:
                                                    oncipj_Cypher_jj_consume_token($this, 262);
                                                    break k;
                                                default:
                                            }
                                            $this.$jj_la1.data[310] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $rt_throw(oncipj_ParseException__init_());
                                        }
                                        var$9 = $this.$jj_ntk;
                                        if (var$9 == (-1))
                                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$9) {
                                            case 189:
                                                oncipj_Cypher_jj_consume_token($this, 189);
                                                onciaf_ConstraintType_$callClinit();
                                                var$14 = onciaf_ConstraintType_REL_KEY;
                                                if ($isNode)
                                                    $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($this.$exceptionFactory, oncipj_ParseException__init_0(onciaf_ASTExceptionFactory_nodePatternNotAllowed(var$14)), $errorStart.$beginOffset, $errorStart.$beginLine, $errorStart.$beginColumn));
                                                break h;
                                            case 320:
                                                oncipj_Cypher_jj_consume_token($this, 320);
                                                onciaf_ConstraintType_$callClinit();
                                                var$14 = onciaf_ConstraintType_REL_UNIQUE;
                                                if ($isNode)
                                                    $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($this.$exceptionFactory, oncipj_ParseException__init_0(onciaf_ASTExceptionFactory_nodePatternNotAllowed(var$14)), $errorStart.$beginOffset, $errorStart.$beginLine, $errorStart.$beginColumn));
                                                break h;
                                            default:
                                        }
                                        $this.$jj_la1.data[311] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $rt_throw(oncipj_ParseException__init_());
                                    case 320:
                                        oncipj_Cypher_jj_consume_token($this, 320);
                                        if (!$isNode) {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_REL_UNIQUE;
                                        } else {
                                            onciaf_ConstraintType_$callClinit();
                                            var$14 = onciaf_ConstraintType_NODE_UNIQUE;
                                        }
                                        break h;
                                    default:
                                }
                                $this.$jj_la1.data[313] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            default:
                        }
                        $this.$jj_la1.data[314] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    default:
                }
                $this.$jj_la1.data[315] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $rt_throw(oncipj_ParseException__init_());
            }
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        l: {
            switch (var$9) {
                case 227:
                    break;
                default:
                    $this.$jj_la1.data[316] = $this.$jj_gen;
                    break l;
            }
            oncipj_Cypher_jj_consume_token($this, 227);
            $options = oncipj_Cypher_MapOrParameter($this);
        }
        return onciafn_Neo4jASTFactory_createConstraint0($this.$astFactory, oncipj_Cypher_pos($this, $start), var$14, $replace, $ifNotExists, $name, $properties, onciaf_ASTFactory$StringPos__init_($label.$image0, oncipj_Cypher_pos($this, $label)), var$15, $propertyType, $options, $containsOn, var$13);
    }
    function oncipj_Cypher_cypherTypeName($this) {
        var $list, var$2;
        ju_ArrayList__init_0(new ju_ArrayList);
        $list = $this.$token;
        var$2 = oncipj_Cypher_cypherTypeNameList($this);
        if (var$2.$size2 == 1)
            return ju_ArrayList_get(var$2, 0);
        $list = $list.$next1;
        return onciaf_ParserCypherTypeName_withPos(onciaf_ParserCypherTypeName_closedDynamicUnionOf(var$2), jl_Integer_valueOf($list.$beginOffset), jl_Integer_valueOf($list.$beginLine), jl_Integer_valueOf($list.$beginColumn));
    }
    function oncipj_Cypher_cypherTypeNameList($this) {
        var $list, $typeName, var$3, $$je;
        $list = ju_ArrayList__init_();
        ju_ArrayList_add($list, oncipj_Cypher_cypherTypeNamePart($this));
        a: {
            while (true) {
                $this.$jj_la = 2;
                $typeName = $this.$token;
                $this.$jj_scanpos = $typeName;
                $this.$jj_lastpos = $typeName;
                b: {
                    c: {
                        try {
                            var$3 = oncipj_Cypher_jj_3_120($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break c;
                            } else{
                                $list = $$je;
                                break a;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 119, 2);
                        break b;
                    }
                    try {
                        var$3 = 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $list = $$je;
                        break a;

                    }
                    oncipj_Cypher_jj_save($this, 119, 2);
                }
                if (!var$3)
                    break;
                oncipj_Cypher_jj_consume_token($this, 86);
                ju_ArrayList_add($list, oncipj_Cypher_cypherTypeNamePart($this));
            }
            return $list;
        }
        oncipj_Cypher_jj_save($this, 119, 2);
        $rt_throw($list);
    }
    function oncipj_Cypher_cypherTypeNamePart($this) {
        var var$1, var$2, var$3, $e, $$je;
        var$1 = $this.$token;
        a: {
            try {
                var$2 = $this.$jj_ntk;
                if (var$2 == (-1))
                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                b: {
                    switch (var$2) {
                        case 79:
                            oncipj_Cypher_jj_consume_token($this, 79);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 143:
                                case 262:
                                    var$3 = $this.$jj_ntk;
                                    if (var$3 == (-1))
                                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                                    c: {
                                        switch (var$3) {
                                            case 143:
                                                oncipj_Cypher_jj_consume_token($this, 143);
                                                break c;
                                            case 262:
                                                oncipj_Cypher_jj_consume_token($this, 262);
                                                break c;
                                            default:
                                        }
                                        $this.$jj_la1.data[329] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $rt_throw(oncipj_ParseException__init_());
                                    }
                                    $e = onciaf_ParserCypherTypeName_RELATIONSHIP;
                                    break b;
                                case 205:
                                    break;
                                case 216:
                                case 331:
                                    var$3 = $this.$jj_ntk;
                                    if (var$3 == (-1))
                                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                                    d: {
                                        switch (var$3) {
                                            case 216:
                                                oncipj_Cypher_jj_consume_token($this, 216);
                                                break d;
                                            case 331:
                                                oncipj_Cypher_jj_consume_token($this, 331);
                                                break d;
                                            default:
                                        }
                                        $this.$jj_la1.data[328] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $rt_throw(oncipj_ParseException__init_());
                                    }
                                    $e = onciaf_ParserCypherTypeName_NODE;
                                    break b;
                                case 251:
                                    oncipj_Cypher_jj_consume_token($this, 251);
                                    oncipj_Cypher_jj_consume_token($this, 328);
                                    $e = onciaf_ParserCypherTypeName_PROPERTY_VALUE;
                                    break b;
                                default:
                                    $this.$jj_la1.data[332] = $this.$jj_gen;
                                    if (!oncipj_Cypher_jj_2_121($this, 2)) {
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        e: {
                                            switch (var$3) {
                                                case 328:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[331] = $this.$jj_gen;
                                                    break e;
                                            }
                                            oncipj_Cypher_jj_consume_token($this, 328);
                                        }
                                        $e = onciaf_ParserCypherTypeName_ANY;
                                        break b;
                                    }
                                    var$3 = $this.$jj_ntk;
                                    if (var$3 == (-1))
                                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                                    f: {
                                        switch (var$3) {
                                            case 328:
                                                break;
                                            default:
                                                $this.$jj_la1.data[330] = $this.$jj_gen;
                                                break f;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 328);
                                    }
                                    oncipj_Cypher_jj_consume_token($this, 203);
                                    $e = oncipj_Cypher_cypherTypeNameList($this);
                                    oncipj_Cypher_jj_consume_token($this, 174);
                                    $e = onciaf_ParserCypherTypeName_closedDynamicUnionOf($e);
                                    break b;
                            }
                            oncipj_Cypher_jj_consume_token($this, 205);
                            $e = onciaf_ParserCypherTypeName_MAP;
                            break b;
                        case 80:
                        case 198:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            g: {
                                switch (var$3) {
                                    case 80:
                                        oncipj_Cypher_jj_consume_token($this, 80);
                                        break g;
                                    case 198:
                                        oncipj_Cypher_jj_consume_token($this, 198);
                                        break g;
                                    default:
                                }
                                $this.$jj_la1.data[327] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            oncipj_Cypher_jj_consume_token($this, 203);
                            $e = oncipj_Cypher_cypherTypeName($this);
                            oncipj_Cypher_jj_consume_token($this, 174);
                            $e = onciaf_ParserCypherTypeName_listOf($e);
                            break b;
                        case 88:
                        case 89:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            h: {
                                switch (var$3) {
                                    case 88:
                                        oncipj_Cypher_jj_consume_token($this, 88);
                                        break h;
                                    case 89:
                                        oncipj_Cypher_jj_consume_token($this, 89);
                                        break h;
                                    default:
                                }
                                $this.$jj_la1.data[317] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            $e = onciaf_ParserCypherTypeName_BOOLEAN;
                            break b;
                        case 120:
                            oncipj_Cypher_jj_consume_token($this, 120);
                            $e = onciaf_ParserCypherTypeName_DATE;
                            break b;
                        case 141:
                            oncipj_Cypher_jj_consume_token($this, 141);
                            $e = onciaf_ParserCypherTypeName_DURATION;
                            break b;
                        case 143:
                        case 262:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            i: {
                                switch (var$3) {
                                    case 143:
                                        oncipj_Cypher_jj_consume_token($this, 143);
                                        break i;
                                    case 262:
                                        oncipj_Cypher_jj_consume_token($this, 262);
                                        break i;
                                    default:
                                }
                                $this.$jj_la1.data[326] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            $e = onciaf_ParserCypherTypeName_RELATIONSHIP;
                            break b;
                        case 161:
                            oncipj_Cypher_jj_consume_token($this, 161);
                            $e = onciaf_ParserCypherTypeName_FLOAT;
                            break b;
                        case 185:
                        case 186:
                        case 292:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            j: {
                                switch (var$3) {
                                    case 185:
                                        oncipj_Cypher_jj_consume_token($this, 185);
                                        break j;
                                    case 186:
                                    case 292:
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        k: {
                                            switch (var$3) {
                                                case 292:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[319] = $this.$jj_gen;
                                                    break k;
                                            }
                                            oncipj_Cypher_jj_consume_token($this, 292);
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 186);
                                        break j;
                                    default:
                                }
                                $this.$jj_la1.data[320] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            $e = onciaf_ParserCypherTypeName_INTEGER;
                            break b;
                        case 200:
                            oncipj_Cypher_jj_consume_token($this, 200);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 121:
                                    oncipj_Cypher_jj_consume_token($this, 121);
                                    $e = onciaf_ParserCypherTypeName_LOCAL_DATETIME;
                                    break b;
                                case 306:
                                    oncipj_Cypher_jj_consume_token($this, 306);
                                    $e = onciaf_ParserCypherTypeName_LOCAL_TIME;
                                    break b;
                                default:
                            }
                            $this.$jj_la1.data[321] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        case 205:
                            oncipj_Cypher_jj_consume_token($this, 205);
                            $e = onciaf_ParserCypherTypeName_MAP;
                            break b;
                        case 216:
                        case 331:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            l: {
                                switch (var$3) {
                                    case 216:
                                        oncipj_Cypher_jj_consume_token($this, 216);
                                        break l;
                                    case 331:
                                        oncipj_Cypher_jj_consume_token($this, 331);
                                        break l;
                                    default:
                                }
                                $this.$jj_la1.data[325] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            $e = onciaf_ParserCypherTypeName_NODE;
                            break b;
                        case 220:
                            oncipj_Cypher_jj_consume_token($this, 220);
                            $e = onciaf_ParserCypherTypeName_NOTHING;
                            break b;
                        case 222:
                            oncipj_Cypher_jj_consume_token($this, 222);
                            $e = onciaf_ParserCypherTypeName_NULL;
                            break b;
                        case 234:
                            oncipj_Cypher_jj_consume_token($this, 234);
                            $e = onciaf_ParserCypherTypeName_PATH;
                            break b;
                        case 240:
                            oncipj_Cypher_jj_consume_token($this, 240);
                            $e = onciaf_ParserCypherTypeName_POINT;
                            break b;
                        case 251:
                            oncipj_Cypher_jj_consume_token($this, 251);
                            oncipj_Cypher_jj_consume_token($this, 328);
                            $e = onciaf_ParserCypherTypeName_PROPERTY_VALUE;
                            break b;
                        case 299:
                        case 329:
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            m: {
                                switch (var$3) {
                                    case 299:
                                        oncipj_Cypher_jj_consume_token($this, 299);
                                        break m;
                                    case 329:
                                        oncipj_Cypher_jj_consume_token($this, 329);
                                        break m;
                                    default:
                                }
                                $this.$jj_la1.data[318] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            $e = onciaf_ParserCypherTypeName_STRING;
                            break b;
                        case 306:
                            oncipj_Cypher_jj_consume_token($this, 306);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 335:
                                    oncipj_Cypher_jj_consume_token($this, 335);
                                    oncipj_Cypher_jj_consume_token($this, 309);
                                    $e = onciaf_ParserCypherTypeName_ZONED_TIME;
                                    break b;
                                case 336:
                                    oncipj_Cypher_jj_consume_token($this, 336);
                                    oncipj_Cypher_jj_consume_token($this, 309);
                                    $e = onciaf_ParserCypherTypeName_LOCAL_TIME;
                                    break b;
                                default:
                            }
                            $this.$jj_la1.data[323] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        case 308:
                            oncipj_Cypher_jj_consume_token($this, 308);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 335:
                                    oncipj_Cypher_jj_consume_token($this, 335);
                                    oncipj_Cypher_jj_consume_token($this, 309);
                                    $e = onciaf_ParserCypherTypeName_ZONED_DATETIME;
                                    break b;
                                case 336:
                                    oncipj_Cypher_jj_consume_token($this, 336);
                                    oncipj_Cypher_jj_consume_token($this, 309);
                                    $e = onciaf_ParserCypherTypeName_LOCAL_DATETIME;
                                    break b;
                                default:
                            }
                            $this.$jj_la1.data[324] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        case 340:
                            oncipj_Cypher_jj_consume_token($this, 340);
                            var$3 = $this.$jj_ntk;
                            if (var$3 == (-1))
                                var$3 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$3) {
                                case 121:
                                    oncipj_Cypher_jj_consume_token($this, 121);
                                    $e = onciaf_ParserCypherTypeName_ZONED_DATETIME;
                                    break b;
                                case 306:
                                    oncipj_Cypher_jj_consume_token($this, 306);
                                    $e = onciaf_ParserCypherTypeName_ZONED_TIME;
                                    break b;
                                default:
                            }
                            $this.$jj_la1.data[322] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        default:
                    }
                    $this.$jj_la1.data[333] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                n: {
                    switch (var$3) {
                        case 219:
                            break;
                        default:
                            $this.$jj_la1.data[334] = $this.$jj_gen;
                            break n;
                    }
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 222);
                    $e = onciaf_ParserCypherTypeName_getNotNullTypeName($e);
                }
                o: while (true) {
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$3) {
                        case 80:
                        case 198:
                            break;
                        default:
                            $this.$jj_la1.data[335] = $this.$jj_gen;
                            break a;
                    }
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    p: {
                        switch (var$3) {
                            case 80:
                                break;
                            case 198:
                                oncipj_Cypher_jj_consume_token($this, 198);
                                break p;
                            default:
                                break o;
                        }
                        oncipj_Cypher_jj_consume_token($this, 80);
                    }
                    $e = onciaf_ParserCypherTypeName_listOf($e);
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$3) {
                        case 219:
                            break;
                        default:
                            $this.$jj_la1.data[337] = $this.$jj_gen;
                            continue o;
                    }
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 222);
                    $e = onciaf_ParserCypherTypeName_getNotNullTypeName($e);
                }
                $this.$jj_la1.data[336] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $rt_throw(oncipj_ParseException__init_());
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_IllegalArgumentException) {
                    $e = $$je;
                } else {
                    throw $$e;
                }
            }
            var$1 = var$1.$next1;
            $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($this.$exceptionFactory, $e, var$1.$beginOffset, var$1.$beginLine, var$1.$beginColumn));
        }
        var$1 = var$1.$next1;
        return onciaf_ParserCypherTypeName_withPos($e, jl_Integer_valueOf(var$1.$beginOffset), jl_Integer_valueOf(var$1.$beginLine), jl_Integer_valueOf(var$1.$beginColumn));
    }
    function oncipj_Cypher_DropConstraint($this, $start) {
        var $ifExists, $isNode, $properties, var$5, var$6, var$7, var$8, var$9, $errorStart, $$je;
        $ifExists = 0;
        ju_ArrayList__init_0(new ju_ArrayList);
        $isNode = 0;
        oncipj_Cypher_jj_consume_token($this, 108);
        $this.$jj_la = 2147483647;
        $properties = $this.$token;
        $this.$jj_scanpos = $properties;
        $this.$jj_lastpos = $properties;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$5 = oncipj_Cypher_jj_3_123($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $start = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 122, 2147483647);
                        break a;
                    }
                    try {
                        var$5 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $start = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 122, 2147483647);
                $rt_throw($start);
            }
            oncipj_Cypher_jj_save($this, 122, 2147483647);
        }
        if (!var$5) {
            $isNode = $this.$jj_ntk;
            if ($isNode == (-1))
                $isNode = oncipj_Cypher_jj_ntk_f($this);
            switch ($isNode) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $properties = oncipj_Cypher_SymbolicNameString($this);
                    $isNode = $this.$jj_ntk;
                    if ($isNode == (-1))
                        $isNode = oncipj_Cypher_jj_ntk_f($this);
                    e: {
                        switch ($isNode) {
                            case 177:
                                break;
                            default:
                                $this.$jj_la1.data[343] = $this.$jj_gen;
                                break e;
                        }
                        oncipj_Cypher_jj_consume_token($this, 177);
                        oncipj_Cypher_jj_consume_token($this, 156);
                        $ifExists = 1;
                    }
                    $start = oncipj_Cypher_pos($this, $start);
                    return oncia_DropConstraintOnName__init_($properties.$image0, $ifExists, s_None$_MODULE$, $start);
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                default:
            }
            $this.$jj_la1.data[344] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        oncipj_Cypher_jj_consume_token($this, 224);
        oncipj_Cypher_jj_consume_token($this, 202);
        $ifExists = $this.$jj_ntk;
        if ($ifExists == (-1))
            $ifExists = oncipj_Cypher_jj_ntk_f($this);
        f: {
            switch ($ifExists) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $properties = oncipj_Cypher_Variable($this);
                    var$6 = oncipj_Cypher_LabelOrRelType($this);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    $isNode = 1;
                    break f;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 283:
                case 307:
                    break;
                case 275:
                    oncipj_Cypher_jj_consume_token($this, 275);
                    $ifExists = $this.$jj_ntk;
                    if ($ifExists == (-1))
                        $ifExists = oncipj_Cypher_jj_ntk_f($this);
                    g: {
                        switch ($ifExists) {
                            case 203:
                            case 345:
                                break;
                            default:
                                $this.$jj_la1.data[338] = $this.$jj_gen;
                                break g;
                        }
                        oncipj_Cypher_LeftArrow($this);
                    }
                    oncipj_Cypher_ArrowLine($this);
                    oncipj_Cypher_jj_consume_token($this, 194);
                    $properties = oncipj_Cypher_Variable($this);
                    var$6 = oncipj_Cypher_LabelOrRelType($this);
                    oncipj_Cypher_jj_consume_token($this, 254);
                    oncipj_Cypher_ArrowLine($this);
                    $ifExists = $this.$jj_ntk;
                    if ($ifExists == (-1))
                        $ifExists = oncipj_Cypher_jj_ntk_f($this);
                    h: {
                        switch ($ifExists) {
                            case 174:
                            case 346:
                                break;
                            default:
                                $this.$jj_la1.data[339] = $this.$jj_gen;
                                break h;
                        }
                        oncipj_Cypher_RightArrow($this);
                    }
                    oncipj_Cypher_jj_consume_token($this, 202);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    break f;
                default:
            }
            $this.$jj_la1.data[340] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        oncipj_Cypher_jj_consume_token($this, 83);
        $this.$jj_la = 2147483647;
        var$7 = $this.$token;
        $this.$jj_scanpos = var$7;
        $this.$jj_lastpos = var$7;
        i: {
            j: {
                k: {
                    l: {
                        try {
                            var$8 = oncipj_Cypher_jj_3_122($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break l;
                            } else{
                                $start = $$je;
                                break k;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 121, 2147483647);
                        break i;
                    }
                    try {
                        var$8 = 1;
                        break j;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $start = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 121, 2147483647);
                $rt_throw($start);
            }
            oncipj_Cypher_jj_save($this, 121, 2147483647);
        }
        m: {
            if (var$8) {
                oncipj_Cypher_jj_consume_token($this, 156);
                if (!$isNode) {
                    onciaf_ConstraintType_$callClinit();
                    var$9 = onciaf_ConstraintType_REL_EXISTS;
                } else {
                    onciaf_ConstraintType_$callClinit();
                    var$9 = onciaf_ConstraintType_NODE_EXISTS;
                }
                var$7 = oncipj_Cypher_PropertyList($this);
            } else {
                $ifExists = $this.$jj_ntk;
                if ($ifExists == (-1))
                    $ifExists = oncipj_Cypher_jj_ntk_f($this);
                switch ($ifExists) {
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 202:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        var$7 = oncipj_Cypher_PropertyList($this);
                        $errorStart = oncipj_Cypher_jj_consume_token($this, 187);
                        $ifExists = $this.$jj_ntk;
                        if ($ifExists == (-1))
                            $ifExists = oncipj_Cypher_jj_ntk_f($this);
                        switch ($ifExists) {
                            case 216:
                                oncipj_Cypher_jj_consume_token($this, 216);
                                oncipj_Cypher_jj_consume_token($this, 189);
                                onciaf_ConstraintType_$callClinit();
                                var$9 = onciaf_ConstraintType_NODE_KEY;
                                if (!$isNode) {
                                    $start = $this.$exceptionFactory;
                                    $properties = new oncipj_ParseException;
                                    jl_Throwable__init_($properties, onciaf_ASTExceptionFactory_relationshipPatternNotAllowed(var$9));
                                    $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($start, $properties, $errorStart.$beginOffset, $errorStart.$beginLine, $errorStart.$beginColumn));
                                }
                                break m;
                            case 219:
                                oncipj_Cypher_jj_consume_token($this, 219);
                                oncipj_Cypher_jj_consume_token($this, 222);
                                if (!$isNode) {
                                    onciaf_ConstraintType_$callClinit();
                                    var$9 = onciaf_ConstraintType_REL_IS_NOT_NULL;
                                } else {
                                    onciaf_ConstraintType_$callClinit();
                                    var$9 = onciaf_ConstraintType_NODE_IS_NOT_NULL;
                                }
                                break m;
                            case 320:
                                oncipj_Cypher_jj_consume_token($this, 320);
                                onciaf_ConstraintType_$callClinit();
                                var$9 = onciaf_ConstraintType_NODE_UNIQUE;
                                if (!$isNode) {
                                    $start = $this.$exceptionFactory;
                                    $properties = new oncipj_ParseException;
                                    jl_Throwable__init_($properties, onciaf_ASTExceptionFactory_relationshipPatternNotAllowed(var$9));
                                    $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($start, $properties, $errorStart.$beginOffset, $errorStart.$beginLine, $errorStart.$beginColumn));
                                }
                                break m;
                            default:
                        }
                        $this.$jj_la1.data[341] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break;
                    default:
                }
                $this.$jj_la1.data[342] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $start = new oncipj_ParseException;
                jl_Throwable__init_0($start);
                $rt_throw($start);
            }
        }
        return onciafn_Neo4jASTFactory_dropConstraint($this.$astFactory, oncipj_Cypher_pos($this, $start), var$9, $properties, onciaf_ASTFactory$StringPos__init_(var$6.$image0, oncipj_Cypher_pos($this, var$6)), var$7);
    }
    function oncipj_Cypher_createIndex($this, $start, $replace, $indexType) {
        var $ifNotExists, $isNode, $indexName, $options, $properties, var$9, var$10, var$11, var$12, $$je;
        $ifNotExists = 0;
        $isNode = 0;
        $indexName = null;
        ju_ArrayList__init_0(new ju_ArrayList);
        $options = null;
        $this.$jj_la = 2147483647;
        $properties = $this.$token;
        $this.$jj_scanpos = $properties;
        $this.$jj_lastpos = $properties;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$9 = oncipj_Cypher_jj_3_125($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $start = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 124, 2147483647);
                        break a;
                    }
                    try {
                        var$9 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $start = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 124, 2147483647);
                $rt_throw($start);
            }
            oncipj_Cypher_jj_save($this, 124, 2147483647);
        }
        e: {
            if (var$9) {
                oncipj_Cypher_jj_consume_token($this, 162);
                oncipj_Cypher_jj_consume_token($this, 202);
            } else {
                $this.$jj_la = 2147483647;
                $properties = $this.$token;
                $this.$jj_scanpos = $properties;
                $this.$jj_lastpos = $properties;
                f: {
                    g: {
                        h: {
                            i: {
                                try {
                                    var$9 = oncipj_Cypher_jj_3_126($this) ? 0 : 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                        break i;
                                    } else{
                                        $start = $$je;
                                        break h;
                                    }
                                }
                                oncipj_Cypher_jj_save($this, 125, 2147483647);
                                break f;
                            }
                            try {
                                var$9 = 1;
                                break g;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                $start = $$je;

                            }
                        }
                        oncipj_Cypher_jj_save($this, 125, 2147483647);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_save($this, 125, 2147483647);
                }
                if (var$9) {
                    oncipj_Cypher_jj_consume_token($this, 177);
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 156);
                    $ifNotExists = 1;
                    oncipj_Cypher_jj_consume_token($this, 162);
                    oncipj_Cypher_jj_consume_token($this, 202);
                } else {
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            oncipj_Cypher_SymbolicNameString($this);
                            $indexName = $this.$token.$image0;
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            j: {
                                switch (var$10) {
                                    case 177:
                                        oncipj_Cypher_jj_consume_token($this, 177);
                                        oncipj_Cypher_jj_consume_token($this, 219);
                                        oncipj_Cypher_jj_consume_token($this, 156);
                                        $ifNotExists = 1;
                                        break j;
                                    default:
                                }
                                $this.$jj_la1.data[347] = $this.$jj_gen;
                            }
                            oncipj_Cypher_jj_consume_token($this, 162);
                            oncipj_Cypher_jj_consume_token($this, 202);
                            break e;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[348] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                }
            }
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        k: {
            switch (var$10) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $properties = oncipj_Cypher_Variable($this);
                    var$11 = oncipj_Cypher_LabelOrRelType($this);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    $isNode = 1;
                    break k;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 283:
                case 307:
                    break;
                case 275:
                    oncipj_Cypher_jj_consume_token($this, 275);
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    l: {
                        switch (var$10) {
                            case 203:
                            case 345:
                                break;
                            default:
                                $this.$jj_la1.data[349] = $this.$jj_gen;
                                break l;
                        }
                        oncipj_Cypher_LeftArrow($this);
                    }
                    oncipj_Cypher_ArrowLine($this);
                    oncipj_Cypher_jj_consume_token($this, 194);
                    $properties = oncipj_Cypher_Variable($this);
                    var$11 = oncipj_Cypher_LabelOrRelType($this);
                    oncipj_Cypher_jj_consume_token($this, 254);
                    oncipj_Cypher_ArrowLine($this);
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    m: {
                        switch (var$10) {
                            case 174:
                            case 346:
                                break;
                            default:
                                $this.$jj_la1.data[350] = $this.$jj_gen;
                                break m;
                        }
                        oncipj_Cypher_RightArrow($this);
                    }
                    oncipj_Cypher_jj_consume_token($this, 202);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    break k;
                default:
            }
            $this.$jj_la1.data[351] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        oncipj_Cypher_jj_consume_token($this, 224);
        var$12 = oncipj_Cypher_PropertyList($this);
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        n: {
            switch (var$10) {
                case 227:
                    break;
                default:
                    $this.$jj_la1.data[352] = $this.$jj_gen;
                    break n;
            }
            oncipj_Cypher_jj_consume_token($this, 227);
            $options = oncipj_Cypher_MapOrParameter($this);
        }
        return onciafn_Neo4jASTFactory_createIndex($this.$astFactory, oncipj_Cypher_pos($this, $start), $replace, $ifNotExists, $isNode, $indexName, $properties, onciaf_ASTFactory$StringPos__init_(var$11.$image0, oncipj_Cypher_pos($this, var$11)), var$12, $options, $indexType);
    }
    function oncipj_Cypher_createFulltextIndex($this, $start, $replace) {
        var $ifNotExists, $isNode, $indexName, $properties, $options, $labels, var$9, var$10, var$11, var$12, var$13, var$14, $$je;
        $ifNotExists = 0;
        $isNode = 0;
        $indexName = null;
        ju_ArrayList__init_0(new ju_ArrayList);
        $properties = ju_ArrayList__init_();
        $options = null;
        $this.$jj_la = 2147483647;
        $labels = $this.$token;
        $this.$jj_scanpos = $labels;
        $this.$jj_lastpos = $labels;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$9 = oncipj_Cypher_jj_3_127($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $start = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 126, 2147483647);
                        break a;
                    }
                    try {
                        var$9 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $start = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 126, 2147483647);
                $rt_throw($start);
            }
            oncipj_Cypher_jj_save($this, 126, 2147483647);
        }
        e: {
            if (var$9) {
                oncipj_Cypher_jj_consume_token($this, 162);
                oncipj_Cypher_jj_consume_token($this, 202);
            } else {
                $this.$jj_la = 2147483647;
                $labels = $this.$token;
                $this.$jj_scanpos = $labels;
                $this.$jj_lastpos = $labels;
                f: {
                    g: {
                        h: {
                            i: {
                                try {
                                    var$9 = oncipj_Cypher_jj_3_128($this) ? 0 : 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                        break i;
                                    } else{
                                        $start = $$je;
                                        break h;
                                    }
                                }
                                oncipj_Cypher_jj_save($this, 127, 2147483647);
                                break f;
                            }
                            try {
                                var$9 = 1;
                                break g;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                $start = $$je;

                            }
                        }
                        oncipj_Cypher_jj_save($this, 127, 2147483647);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_save($this, 127, 2147483647);
                }
                if (var$9) {
                    oncipj_Cypher_jj_consume_token($this, 177);
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 156);
                    $ifNotExists = 1;
                    oncipj_Cypher_jj_consume_token($this, 162);
                    oncipj_Cypher_jj_consume_token($this, 202);
                } else {
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            oncipj_Cypher_SymbolicNameString($this);
                            $indexName = $this.$token.$image0;
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            j: {
                                switch (var$10) {
                                    case 177:
                                        oncipj_Cypher_jj_consume_token($this, 177);
                                        oncipj_Cypher_jj_consume_token($this, 219);
                                        oncipj_Cypher_jj_consume_token($this, 156);
                                        $ifNotExists = 1;
                                        break j;
                                    default:
                                }
                                $this.$jj_la1.data[353] = $this.$jj_gen;
                            }
                            oncipj_Cypher_jj_consume_token($this, 162);
                            oncipj_Cypher_jj_consume_token($this, 202);
                            break e;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[354] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                }
            }
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        k: {
            switch (var$10) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    var$11 = oncipj_Cypher_Variable($this);
                    var$12 = oncipj_Cypher_LabelOrRelTypes($this);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    $isNode = 1;
                    break k;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 283:
                case 307:
                    break;
                case 275:
                    oncipj_Cypher_jj_consume_token($this, 275);
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    l: {
                        switch (var$10) {
                            case 203:
                            case 345:
                                break;
                            default:
                                $this.$jj_la1.data[355] = $this.$jj_gen;
                                break l;
                        }
                        oncipj_Cypher_LeftArrow($this);
                    }
                    oncipj_Cypher_ArrowLine($this);
                    oncipj_Cypher_jj_consume_token($this, 194);
                    var$11 = oncipj_Cypher_Variable($this);
                    var$12 = oncipj_Cypher_LabelOrRelTypes($this);
                    oncipj_Cypher_jj_consume_token($this, 254);
                    oncipj_Cypher_ArrowLine($this);
                    var$13 = $this.$jj_ntk;
                    if (var$13 == (-1))
                        var$13 = oncipj_Cypher_jj_ntk_f($this);
                    m: {
                        switch (var$13) {
                            case 174:
                            case 346:
                                break;
                            default:
                                $this.$jj_la1.data[356] = $this.$jj_gen;
                                break m;
                        }
                        oncipj_Cypher_RightArrow($this);
                    }
                    oncipj_Cypher_jj_consume_token($this, 202);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    break k;
                default:
            }
            $this.$jj_la1.data[357] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        oncipj_Cypher_jj_consume_token($this, 224);
        oncipj_Cypher_jj_consume_token($this, 142);
        oncipj_Cypher_jj_consume_token($this, 194);
        ju_ArrayList_add($properties, oncipj_Cypher_Property($this, oncipj_Cypher_Variable($this)));
        n: while (true) {
            var$10 = $this.$jj_ntk;
            if (var$10 == (-1))
                var$10 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$10) {
                case 103:
                    break;
                default:
                    break n;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($properties, oncipj_Cypher_Property($this, oncipj_Cypher_Variable($this)));
        }
        $this.$jj_la1.data[358] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, 254);
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        o: {
            switch (var$10) {
                case 227:
                    break;
                default:
                    $this.$jj_la1.data[359] = $this.$jj_gen;
                    break o;
            }
            oncipj_Cypher_jj_consume_token($this, 227);
            $options = oncipj_Cypher_MapOrParameter($this);
        }
        $labels = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        var$14 = sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $properties)));
        return !$isNode ? oncia_CreateFulltextRelationshipIndex__init_(var$11, sci_List_map(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$12))), new onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_0), var$14, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($labels, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($labels, $options), s_None$_MODULE$, $start)
        : oncia_CreateFulltextNodeIndex__init_(var$11, sci_List_map(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$12))), new onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_1), var$14, s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo($labels, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($labels, $options), s_None$_MODULE$, $start);
    }
    function oncipj_Cypher_createLookupIndex($this, $start, $replace) {
        var $ifNotExists, $isNode, $indexName, $options, var$7, var$8, var$9, var$10, var$11, var$12, var$13, var$14, var$15, var$16, $$je;
        $ifNotExists = 0;
        $isNode = 0;
        $indexName = null;
        $options = null;
        $this.$jj_la = 2147483647;
        var$7 = $this.$token;
        $this.$jj_scanpos = var$7;
        $this.$jj_lastpos = var$7;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$8 = oncipj_Cypher_jj_3_129($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $start = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 128, 2147483647);
                        break a;
                    }
                    try {
                        var$8 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $start = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 128, 2147483647);
                $rt_throw($start);
            }
            oncipj_Cypher_jj_save($this, 128, 2147483647);
        }
        e: {
            if (var$8) {
                oncipj_Cypher_jj_consume_token($this, 162);
                oncipj_Cypher_jj_consume_token($this, 202);
            } else {
                $this.$jj_la = 2147483647;
                var$7 = $this.$token;
                $this.$jj_scanpos = var$7;
                $this.$jj_lastpos = var$7;
                f: {
                    g: {
                        h: {
                            i: {
                                try {
                                    var$8 = oncipj_Cypher_jj_3_130($this) ? 0 : 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                        break i;
                                    } else{
                                        $start = $$je;
                                        break h;
                                    }
                                }
                                oncipj_Cypher_jj_save($this, 129, 2147483647);
                                break f;
                            }
                            try {
                                var$8 = 1;
                                break g;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                $start = $$je;

                            }
                        }
                        oncipj_Cypher_jj_save($this, 129, 2147483647);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_save($this, 129, 2147483647);
                }
                if (var$8) {
                    oncipj_Cypher_jj_consume_token($this, 177);
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 156);
                    $ifNotExists = 1;
                    oncipj_Cypher_jj_consume_token($this, 162);
                    oncipj_Cypher_jj_consume_token($this, 202);
                } else {
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$9) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            oncipj_Cypher_SymbolicNameString($this);
                            $indexName = $this.$token.$image0;
                            var$9 = $this.$jj_ntk;
                            if (var$9 == (-1))
                                var$9 = oncipj_Cypher_jj_ntk_f($this);
                            j: {
                                switch (var$9) {
                                    case 177:
                                        oncipj_Cypher_jj_consume_token($this, 177);
                                        oncipj_Cypher_jj_consume_token($this, 219);
                                        oncipj_Cypher_jj_consume_token($this, 156);
                                        $ifNotExists = 1;
                                        break j;
                                    default:
                                }
                                $this.$jj_la1.data[360] = $this.$jj_gen;
                            }
                            oncipj_Cypher_jj_consume_token($this, 162);
                            oncipj_Cypher_jj_consume_token($this, 202);
                            break e;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[361] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                }
            }
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        k: {
            switch (var$9) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    var$10 = oncipj_Cypher_Variable($this);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    oncipj_Cypher_jj_consume_token($this, 224);
                    oncipj_Cypher_jj_consume_token($this, 142);
                    $isNode = 1;
                    break k;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 283:
                case 307:
                    break;
                case 275:
                    oncipj_Cypher_jj_consume_token($this, 275);
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    l: {
                        switch (var$9) {
                            case 203:
                            case 345:
                                break;
                            default:
                                $this.$jj_la1.data[362] = $this.$jj_gen;
                                break l;
                        }
                        oncipj_Cypher_LeftArrow($this);
                    }
                    oncipj_Cypher_ArrowLine($this);
                    oncipj_Cypher_jj_consume_token($this, 194);
                    var$10 = oncipj_Cypher_Variable($this);
                    oncipj_Cypher_jj_consume_token($this, 254);
                    oncipj_Cypher_ArrowLine($this);
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    m: {
                        switch (var$9) {
                            case 174:
                            case 346:
                                break;
                            default:
                                $this.$jj_la1.data[363] = $this.$jj_gen;
                                break m;
                        }
                        oncipj_Cypher_RightArrow($this);
                    }
                    oncipj_Cypher_jj_consume_token($this, 202);
                    oncipj_Cypher_jj_consume_token($this, 275);
                    oncipj_Cypher_jj_consume_token($this, 224);
                    $this.$jj_la = 2147483647;
                    var$7 = $this.$token;
                    $this.$jj_scanpos = var$7;
                    $this.$jj_lastpos = var$7;
                    n: {
                        o: {
                            p: {
                                q: {
                                    try {
                                        var$8 = oncipj_Cypher_jj_3_131($this) ? 0 : 1;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                            break q;
                                        } else{
                                            $start = $$je;
                                            break p;
                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 130, 2147483647);
                                    break n;
                                }
                                try {
                                    var$8 = 1;
                                    break o;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    $start = $$je;

                                }
                            }
                            oncipj_Cypher_jj_save($this, 130, 2147483647);
                            $rt_throw($start);
                        }
                        oncipj_Cypher_jj_save($this, 130, 2147483647);
                    }
                    if (!var$8)
                        break k;
                    oncipj_Cypher_jj_consume_token($this, 142);
                    break k;
                default:
            }
            $this.$jj_la1.data[364] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        oncipj_Cypher_SymbolicNameString($this);
        var$11 = new onciaf_ASTFactory$StringPos;
        var$7 = $this.$token;
        onciaf_ASTFactory$StringPos__init_0(var$11, var$7.$image0, oncipj_Cypher_pos($this, var$7));
        oncipj_Cypher_jj_consume_token($this, 202);
        var$12 = oncipj_Cypher_Variable($this);
        oncipj_Cypher_jj_consume_token($this, 275);
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        r: {
            switch (var$9) {
                case 227:
                    break;
                default:
                    $this.$jj_la1.data[365] = $this.$jj_gen;
                    break r;
            }
            oncipj_Cypher_jj_consume_token($this, 227);
            $options = oncipj_Cypher_MapOrParameter($this);
        }
        var$13 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        var$7 = oncie_FunctionName__init_(var$11.$string0, var$11.$pos);
        s_package$_$callClinit();
        var$14 = s_package$_IndexedSeq0(s_package$_MODULE$);
        var$15 = sr_ScalaRunTime$_MODULE$;
        var$16 = $rt_createArray(oncie_Variable, 1);
        var$16.data[0] = var$12;
        var$14 = sc_SeqFactory$Delegate_apply(var$14, sr_ScalaRunTime$_wrapRefArray(var$15, var$16));
        var$15 = var$11.$pos;
        return oncia_CreateLookupIndex__init_(var$10, $isNode, oncie_FunctionInvocation__init_(oncie_Namespace__init_(oncie_Namespace$_apply$default$1(oncie_Namespace$_MODULE$), var$15), var$7, 0, var$14, var$15), s_Option$_apply(s_Option$_MODULE$, $indexName), onciafn_Neo4jASTFactory_ifExistsDo(var$13, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst(var$13, $options), s_None$_MODULE$, $start);
    }
    function oncipj_Cypher_PropertyList($this) {
        var $properties, var$2;
        $properties = ju_ArrayList__init_();
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$2) {
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break b;
                    case 202:
                        oncipj_Cypher_jj_consume_token($this, 202);
                        ju_ArrayList_add($properties, oncipj_Cypher_Property($this, oncipj_Cypher_Variable($this)));
                        c: while (true) {
                            var$2 = $this.$jj_ntk;
                            if (var$2 == (-1))
                                var$2 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$2) {
                                case 103:
                                    break;
                                default:
                                    break c;
                            }
                            oncipj_Cypher_jj_consume_token($this, 103);
                            ju_ArrayList_add($properties, oncipj_Cypher_Property($this, oncipj_Cypher_Variable($this)));
                        }
                        $this.$jj_la1.data[368] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, 275);
                        break a;
                    default:
                        break b;
                }
                ju_ArrayList_add($properties, oncipj_Cypher_Property($this, oncipj_Cypher_Variable($this)));
                break a;
            }
            $this.$jj_la1.data[369] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $properties = new oncipj_ParseException;
            jl_Throwable__init_0($properties);
            $rt_throw($properties);
        }
        return $properties;
    }
    function oncipj_Cypher_RenameCommand($this) {
        var $start, var$2, var$3, var$4, var$5, $command;
        $start = oncipj_Cypher_jj_consume_token($this, 259);
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$2) {
                case 271:
                    var$3 = 0;
                    oncipj_Cypher_jj_consume_token($this, 271);
                    var$4 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    var$2 = $this.$jj_ntk;
                    if (var$2 == (-1))
                        var$2 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$2) {
                            case 177:
                                break;
                            default:
                                $this.$jj_la1.data[398] = $this.$jj_gen;
                                break b;
                        }
                        oncipj_Cypher_jj_consume_token($this, 177);
                        oncipj_Cypher_jj_consume_token($this, 156);
                        var$3 = 1;
                    }
                    oncipj_Cypher_jj_consume_token($this, 310);
                    var$5 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    $start = oncipj_Cypher_pos($this, $start);
                    $command = oncia_RenameRole__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$4)), onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$5)), var$3, $start);
                    break a;
                case 284:
                    oncipj_Cypher_jj_consume_token($this, 284);
                    var$4 = oncipj_Cypher_StringOrParameter($this);
                    oncipj_Cypher_jj_consume_token($this, 310);
                    var$5 = oncipj_Cypher_StringOrParameter($this);
                    $start = oncipj_Cypher_pos($this, $start);
                    $command = oncia_RenameServer__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$4)), onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$5)), $start);
                    break a;
                case 325:
                    var$3 = 0;
                    oncipj_Cypher_jj_consume_token($this, 325);
                    var$4 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    var$2 = $this.$jj_ntk;
                    if (var$2 == (-1))
                        var$2 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$2) {
                            case 177:
                                break;
                            default:
                                $this.$jj_la1.data[411] = $this.$jj_gen;
                                break c;
                        }
                        oncipj_Cypher_jj_consume_token($this, 177);
                        oncipj_Cypher_jj_consume_token($this, 156);
                        var$3 = 1;
                    }
                    oncipj_Cypher_jj_consume_token($this, 310);
                    var$5 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    $start = oncipj_Cypher_pos($this, $start);
                    $command = oncia_RenameUser__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$4)), onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$5)), var$3, $start);
                    break a;
                default:
            }
            $this.$jj_la1.data[370] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        return $command;
    }
    function oncipj_Cypher_GrantCommand($this) {
        var $start, var$2, $c, var$4, $$je;
        $start = oncipj_Cypher_jj_consume_token($this, 169);
        var$2 = $this.$jj_ntk;
        if (var$2 == (-1))
            var$2 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$2) {
                    case 69:
                    case 73:
                    case 76:
                    case 77:
                    case 84:
                    case 107:
                    case 108:
                    case 109:
                    case 114:
                    case 118:
                    case 126:
                    case 138:
                    case 153:
                    case 178:
                    case 181:
                    case 182:
                    case 199:
                    case 206:
                    case 207:
                    case 212:
                    case 246:
                    case 256:
                    case 259:
                    case 264:
                    case 271:
                    case 272:
                    case 284:
                    case 286:
                    case 291:
                    case 295:
                    case 298:
                    case 303:
                    case 312:
                    case 314:
                    case 325:
                    case 337:
                        var$2 = $this.$jj_ntk;
                        if (var$2 == (-1))
                            var$2 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$2) {
                            case 69:
                            case 73:
                            case 76:
                            case 77:
                            case 84:
                            case 107:
                            case 108:
                            case 109:
                            case 114:
                            case 118:
                            case 126:
                            case 138:
                            case 153:
                            case 178:
                            case 181:
                            case 182:
                            case 199:
                            case 206:
                            case 207:
                            case 212:
                            case 246:
                            case 256:
                            case 259:
                            case 264:
                            case 284:
                            case 286:
                            case 291:
                            case 295:
                            case 298:
                            case 303:
                            case 312:
                            case 314:
                            case 325:
                            case 337:
                                break;
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                $this.$jj_la = 2147483647;
                                $c = $this.$token;
                                $this.$jj_scanpos = $c;
                                $this.$jj_lastpos = $c;
                                c: {
                                    d: {
                                        e: {
                                            f: {
                                                try {
                                                    var$4 = oncipj_Cypher_jj_3_133($this) ? 0 : 1;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                        break f;
                                                    } else{
                                                        $start = $$je;
                                                        break e;
                                                    }
                                                }
                                                oncipj_Cypher_jj_save($this, 132, 2147483647);
                                                break c;
                                            }
                                            try {
                                                var$4 = 1;
                                                break d;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                $start = $$je;

                                            }
                                        }
                                        oncipj_Cypher_jj_save($this, 132, 2147483647);
                                        $rt_throw($start);
                                    }
                                    oncipj_Cypher_jj_save($this, 132, 2147483647);
                                }
                                if (var$4) {
                                    $c = oncipj_Cypher_grantRoleManagement($this, $start, 0);
                                    break b;
                                }
                                var$2 = $this.$jj_ntk;
                                if (var$2 == (-1))
                                    var$2 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$2) {
                                    case 68:
                                    case 69:
                                    case 70:
                                    case 71:
                                    case 72:
                                    case 73:
                                    case 74:
                                    case 75:
                                    case 76:
                                    case 77:
                                    case 78:
                                    case 79:
                                    case 80:
                                    case 81:
                                    case 82:
                                    case 83:
                                    case 84:
                                    case 85:
                                    case 87:
                                    case 88:
                                    case 89:
                                    case 90:
                                    case 91:
                                    case 92:
                                    case 93:
                                    case 94:
                                    case 95:
                                    case 96:
                                    case 97:
                                    case 98:
                                    case 99:
                                    case 100:
                                    case 104:
                                    case 105:
                                    case 106:
                                    case 107:
                                    case 108:
                                    case 109:
                                    case 110:
                                    case 111:
                                    case 112:
                                    case 113:
                                    case 114:
                                    case 115:
                                    case 116:
                                    case 117:
                                    case 118:
                                    case 119:
                                    case 120:
                                    case 121:
                                    case 122:
                                    case 123:
                                    case 124:
                                    case 125:
                                    case 126:
                                    case 127:
                                    case 128:
                                    case 129:
                                    case 130:
                                    case 131:
                                    case 132:
                                    case 133:
                                    case 137:
                                    case 138:
                                    case 139:
                                    case 140:
                                    case 141:
                                    case 142:
                                    case 143:
                                    case 144:
                                    case 145:
                                    case 146:
                                    case 147:
                                    case 148:
                                    case 149:
                                    case 150:
                                    case 152:
                                    case 153:
                                    case 154:
                                    case 155:
                                    case 156:
                                    case 157:
                                    case 158:
                                    case 159:
                                    case 160:
                                    case 161:
                                    case 162:
                                    case 163:
                                    case 164:
                                    case 165:
                                    case 166:
                                    case 167:
                                    case 169:
                                    case 170:
                                    case 171:
                                    case 172:
                                    case 173:
                                    case 175:
                                    case 176:
                                    case 177:
                                    case 179:
                                    case 180:
                                    case 181:
                                    case 182:
                                    case 183:
                                    case 184:
                                    case 185:
                                    case 186:
                                    case 187:
                                    case 188:
                                    case 189:
                                    case 190:
                                    case 191:
                                    case 197:
                                    case 198:
                                    case 199:
                                    case 200:
                                    case 201:
                                    case 204:
                                    case 205:
                                    case 206:
                                    case 207:
                                    case 212:
                                    case 213:
                                    case 214:
                                    case 215:
                                    case 216:
                                    case 217:
                                    case 218:
                                    case 219:
                                    case 220:
                                    case 221:
                                    case 222:
                                    case 223:
                                    case 224:
                                    case 225:
                                    case 226:
                                    case 227:
                                    case 228:
                                    case 229:
                                    case 230:
                                    case 231:
                                    case 232:
                                    case 233:
                                    case 234:
                                    case 235:
                                    case 236:
                                    case 237:
                                    case 240:
                                    case 241:
                                    case 243:
                                    case 244:
                                    case 245:
                                    case 246:
                                    case 247:
                                    case 248:
                                    case 249:
                                    case 250:
                                    case 251:
                                    case 253:
                                    case 256:
                                    case 257:
                                    case 258:
                                    case 259:
                                    case 261:
                                    case 262:
                                    case 263:
                                    case 264:
                                    case 265:
                                    case 266:
                                    case 267:
                                    case 268:
                                    case 269:
                                    case 270:
                                    case 271:
                                    case 272:
                                    case 273:
                                    case 274:
                                    case 276:
                                    case 277:
                                    case 278:
                                    case 279:
                                    case 280:
                                    case 281:
                                    case 282:
                                    case 284:
                                    case 285:
                                    case 286:
                                    case 287:
                                    case 288:
                                    case 289:
                                    case 290:
                                    case 291:
                                    case 292:
                                    case 293:
                                    case 294:
                                    case 295:
                                    case 296:
                                    case 297:
                                    case 298:
                                    case 299:
                                    case 300:
                                    case 301:
                                    case 302:
                                    case 303:
                                    case 304:
                                    case 305:
                                    case 306:
                                    case 308:
                                    case 309:
                                    case 310:
                                    case 311:
                                    case 312:
                                    case 313:
                                    case 314:
                                    case 315:
                                    case 316:
                                    case 317:
                                    case 318:
                                    case 319:
                                    case 320:
                                    case 321:
                                    case 322:
                                    case 323:
                                    case 324:
                                    case 325:
                                    case 326:
                                    case 327:
                                    case 328:
                                    case 329:
                                    case 330:
                                    case 331:
                                    case 332:
                                    case 333:
                                    case 334:
                                    case 335:
                                    case 336:
                                    case 337:
                                    case 338:
                                    case 339:
                                    case 340:
                                    case 341:
                                        break;
                                    case 86:
                                    case 101:
                                    case 102:
                                    case 103:
                                    case 134:
                                    case 135:
                                    case 136:
                                    case 151:
                                    case 168:
                                    case 174:
                                    case 178:
                                    case 192:
                                    case 193:
                                    case 194:
                                    case 195:
                                    case 196:
                                    case 202:
                                    case 203:
                                    case 208:
                                    case 209:
                                    case 210:
                                    case 211:
                                    case 238:
                                    case 239:
                                    case 242:
                                    case 252:
                                    case 254:
                                    case 255:
                                    case 260:
                                    case 275:
                                    case 283:
                                    case 307:
                                        break a;
                                    default:
                                        break a;
                                }
                                $c = oncipj_Cypher_GrantRole($this, $start);
                                break b;
                            case 272:
                                oncipj_Cypher_jj_consume_token($this, 272);
                                $c = oncipj_Cypher_GrantRole($this, $start);
                                break b;
                            default:
                                $this.$jj_la1.data[373] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                        }
                        $c = oncipj_Cypher_grantPrivilege($this, $start, 0);
                        break b;
                    case 179:
                        oncipj_Cypher_jj_consume_token($this, 179);
                        var$2 = $this.$jj_ntk;
                        if (var$2 == (-1))
                            var$2 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$2) {
                            case 69:
                            case 73:
                            case 76:
                            case 77:
                            case 84:
                            case 107:
                            case 108:
                            case 109:
                            case 114:
                            case 118:
                            case 126:
                            case 138:
                            case 153:
                            case 178:
                            case 181:
                            case 182:
                            case 199:
                            case 206:
                            case 207:
                            case 212:
                            case 246:
                            case 256:
                            case 259:
                            case 264:
                            case 284:
                            case 286:
                            case 291:
                            case 295:
                            case 298:
                            case 303:
                            case 312:
                            case 314:
                            case 325:
                            case 337:
                                break;
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                $c = oncipj_Cypher_grantRoleManagement($this, $start, 1);
                                break b;
                            default:
                                $this.$jj_la1.data[371] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                        }
                        $c = oncipj_Cypher_grantPrivilege($this, $start, 1);
                        break b;
                    default:
                }
                $this.$jj_la1.data[374] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $start = new oncipj_ParseException;
                jl_Throwable__init_0($start);
                $rt_throw($start);
            }
            return $c;
        }
        $this.$jj_la1.data[372] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $start = new oncipj_ParseException;
        jl_Throwable__init_0($start);
        $rt_throw($start);
    }
    function oncipj_Cypher_RevokeCommand($this) {
        var $immutable, $start, var$3, var$4, $c, var$6, $$je;
        $immutable = 0;
        $start = oncipj_Cypher_jj_consume_token($this, 270);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 69:
                case 73:
                case 76:
                case 77:
                case 84:
                case 107:
                case 108:
                case 109:
                case 114:
                case 118:
                case 126:
                case 138:
                case 153:
                case 178:
                case 181:
                case 182:
                case 199:
                case 206:
                case 207:
                case 212:
                case 246:
                case 256:
                case 259:
                case 264:
                case 271:
                case 272:
                case 284:
                case 286:
                case 291:
                case 295:
                case 298:
                case 303:
                case 312:
                case 314:
                case 325:
                case 337:
                    $immutable = $this.$jj_ntk;
                    if ($immutable == (-1))
                        $immutable = oncipj_Cypher_jj_ntk_f($this);
                    switch ($immutable) {
                        case 69:
                        case 73:
                        case 76:
                        case 77:
                        case 84:
                        case 107:
                        case 108:
                        case 109:
                        case 114:
                        case 118:
                        case 126:
                        case 138:
                        case 153:
                        case 178:
                        case 181:
                        case 182:
                        case 199:
                        case 206:
                        case 207:
                        case 212:
                        case 246:
                        case 256:
                        case 259:
                        case 264:
                        case 284:
                        case 286:
                        case 291:
                        case 295:
                        case 298:
                        case 303:
                        case 312:
                        case 314:
                        case 325:
                        case 337:
                            break;
                        default:
                            $this.$jj_la1.data[381] = $this.$jj_gen;
                            $this.$jj_la = 2147483647;
                            var$4 = $this.$token;
                            $this.$jj_scanpos = var$4;
                            $this.$jj_lastpos = var$4;
                            b: {
                                c: {
                                    d: {
                                        e: {
                                            try {
                                                var$3 = oncipj_Cypher_jj_3_134($this) ? 0 : 1;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                                    break e;
                                                } else{
                                                    $start = $$je;
                                                    break d;
                                                }
                                            }
                                            oncipj_Cypher_jj_save($this, 133, 2147483647);
                                            break b;
                                        }
                                        try {
                                            var$3 = 1;
                                            break c;
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            $start = $$je;

                                        }
                                    }
                                    oncipj_Cypher_jj_save($this, 133, 2147483647);
                                    $rt_throw($start);
                                }
                                oncipj_Cypher_jj_save($this, 133, 2147483647);
                            }
                            if (var$3) {
                                oncipj_Cypher_jj_consume_token($this, 271);
                                $c = oncipj_Cypher_revokeRoleManagement($this, $start, 1, 1, 0);
                                break a;
                            }
                            $immutable = $this.$jj_ntk;
                            if ($immutable == (-1))
                                $immutable = oncipj_Cypher_jj_ntk_f($this);
                            switch ($immutable) {
                                case 271:
                                case 272:
                                    $immutable = $this.$jj_ntk;
                                    if ($immutable == (-1))
                                        $immutable = oncipj_Cypher_jj_ntk_f($this);
                                    f: {
                                        switch ($immutable) {
                                            case 271:
                                                oncipj_Cypher_jj_consume_token($this, 271);
                                                break f;
                                            case 272:
                                                oncipj_Cypher_jj_consume_token($this, 272);
                                                break f;
                                            default:
                                        }
                                        $this.$jj_la1.data[380] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $start = new oncipj_ParseException;
                                        jl_Throwable__init_0($start);
                                        $rt_throw($start);
                                    }
                                    var$4 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                                    oncipj_Cypher_jj_consume_token($this, 164);
                                    var$6 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                                    $start = oncipj_Cypher_pos($this, $start);
                                    $c = oncia_RevokeRolesFromUsers__init_((sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$4)), new onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_0)).$toSeq(), (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$6)), new onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_1)).$toSeq(),
                                    $start);
                                    break a;
                                default:
                            }
                            $this.$jj_la1.data[382] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                    }
                    $c = oncipj_Cypher_RevokePrivilege($this, $start, 1, 1, 0);
                    break a;
                case 127:
                    oncipj_Cypher_jj_consume_token($this, 127);
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    g: {
                        switch (var$3) {
                            case 179:
                                break;
                            default:
                                $this.$jj_la1.data[375] = $this.$jj_gen;
                                break g;
                        }
                        oncipj_Cypher_jj_consume_token($this, 179);
                        $immutable = 1;
                    }
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$3) {
                        case 69:
                        case 73:
                        case 76:
                        case 77:
                        case 84:
                        case 107:
                        case 108:
                        case 109:
                        case 114:
                        case 118:
                        case 126:
                        case 138:
                        case 153:
                        case 178:
                        case 181:
                        case 182:
                        case 199:
                        case 206:
                        case 207:
                        case 212:
                        case 246:
                        case 256:
                        case 259:
                        case 264:
                        case 284:
                        case 286:
                        case 291:
                        case 295:
                        case 298:
                        case 303:
                        case 312:
                        case 314:
                        case 325:
                        case 337:
                            break;
                        case 271:
                            oncipj_Cypher_jj_consume_token($this, 271);
                            $c = oncipj_Cypher_revokeRoleManagement($this, $start, 0, 1, $immutable);
                            break a;
                        default:
                            $this.$jj_la1.data[376] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                    }
                    $c = oncipj_Cypher_RevokePrivilege($this, $start, 0, 1, $immutable);
                    break a;
                case 169:
                    oncipj_Cypher_jj_consume_token($this, 169);
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    h: {
                        switch (var$3) {
                            case 179:
                                break;
                            default:
                                $this.$jj_la1.data[377] = $this.$jj_gen;
                                break h;
                        }
                        oncipj_Cypher_jj_consume_token($this, 179);
                        $immutable = 1;
                    }
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$3) {
                        case 69:
                        case 73:
                        case 76:
                        case 77:
                        case 84:
                        case 107:
                        case 108:
                        case 109:
                        case 114:
                        case 118:
                        case 126:
                        case 138:
                        case 153:
                        case 178:
                        case 181:
                        case 182:
                        case 199:
                        case 206:
                        case 207:
                        case 212:
                        case 246:
                        case 256:
                        case 259:
                        case 264:
                        case 284:
                        case 286:
                        case 291:
                        case 295:
                        case 298:
                        case 303:
                        case 312:
                        case 314:
                        case 325:
                        case 337:
                            break;
                        case 271:
                            oncipj_Cypher_jj_consume_token($this, 271);
                            $c = oncipj_Cypher_revokeRoleManagement($this, $start, 1, 0, $immutable);
                            break a;
                        default:
                            $this.$jj_la1.data[378] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                    }
                    $c = oncipj_Cypher_RevokePrivilege($this, $start, 1, 0, $immutable);
                    break a;
                case 179:
                    oncipj_Cypher_jj_consume_token($this, 179);
                    $immutable = $this.$jj_ntk;
                    if ($immutable == (-1))
                        $immutable = oncipj_Cypher_jj_ntk_f($this);
                    switch ($immutable) {
                        case 69:
                        case 73:
                        case 76:
                        case 77:
                        case 84:
                        case 107:
                        case 108:
                        case 109:
                        case 114:
                        case 118:
                        case 126:
                        case 138:
                        case 153:
                        case 178:
                        case 181:
                        case 182:
                        case 199:
                        case 206:
                        case 207:
                        case 212:
                        case 246:
                        case 256:
                        case 259:
                        case 264:
                        case 284:
                        case 286:
                        case 291:
                        case 295:
                        case 298:
                        case 303:
                        case 312:
                        case 314:
                        case 325:
                        case 337:
                            break;
                        case 271:
                            oncipj_Cypher_jj_consume_token($this, 271);
                            $c = oncipj_Cypher_revokeRoleManagement($this, $start, 1, 1, 1);
                            break a;
                        default:
                            $this.$jj_la1.data[379] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                    }
                    $c = oncipj_Cypher_RevokePrivilege($this, $start, 1, 1, 1);
                    break a;
                default:
            }
            $this.$jj_la1.data[383] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        return $c;
    }
    function oncipj_Cypher_EnableServerCommand($this) {
        var $options, $start, var$3, var$4, var$5;
        $options = null;
        $start = oncipj_Cypher_jj_consume_token($this, 144);
        oncipj_Cypher_jj_consume_token($this, 284);
        var$3 = oncipj_Cypher_StringOrParameter($this);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 227:
                    break;
                default:
                    $this.$jj_la1.data[384] = $this.$jj_gen;
                    break a;
            }
            $options = oncipj_Cypher_Options($this);
        }
        var$5 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        return oncia_EnableServer__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$3)), onciafn_Neo4jASTFactory_asOptionsAst(var$5, $options), $start);
    }
    function oncipj_Cypher_ShowServers($this, $start, $useClause) {
        var $yield, $returnClause, $where, var$6, var$7, var$8;
        $yield = null;
        $returnClause = null;
        $where = null;
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 284:
                    oncipj_Cypher_jj_consume_token($this, 284);
                    break a;
                case 285:
                    oncipj_Cypher_jj_consume_token($this, 285);
                    break a;
                default:
            }
            $this.$jj_la1.data[385] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$7 = $this.$jj_ntk;
        if (var$7 == (-1))
            var$7 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$7) {
                case 334:
                case 339:
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$7) {
                        case 334:
                            break;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$7 = $this.$jj_ntk;
                            if (var$7 == (-1))
                                var$7 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$7) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[386] = $this.$jj_gen;
                                    break b;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break b;
                        default:
                            $this.$jj_la1.data[387] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                    }
                    $where = oncipj_Cypher_WhereClause($this);
                    break b;
                default:
            }
            $this.$jj_la1.data[388] = $this.$jj_gen;
        }
        var$8 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        return onciafn_Neo4jASTFactory_useGraph(var$8, oncia_ShowServers$_apply(oncia_ShowServers$_MODULE$, onciafn_Neo4jASTFactory_yieldOrWhere(var$8, $yield, $returnClause, $where), $start), $useClause);
    }
    function oncipj_Cypher_CreateRole($this, $start, $replace) {
        var $sourceRoleName, $ifNotExists, var$5, var$6, var$7;
        $sourceRoleName = null;
        $ifNotExists = 0;
        oncipj_Cypher_jj_consume_token($this, 271);
        var$5 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 177:
                    oncipj_Cypher_jj_consume_token($this, 177);
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 156);
                    $ifNotExists = 1;
                    break a;
                default:
            }
            $this.$jj_la1.data[395] = $this.$jj_gen;
        }
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$6) {
                case 81:
                    oncipj_Cypher_jj_consume_token($this, 81);
                    oncipj_Cypher_jj_consume_token($this, 111);
                    oncipj_Cypher_jj_consume_token($this, 223);
                    $sourceRoleName = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    break b;
                default:
            }
            $this.$jj_la1.data[396] = $this.$jj_gen;
        }
        var$7 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        return oncia_CreateRole__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$5)), s_Option_map(s_Option$_apply(s_Option$_MODULE$, $sourceRoleName), new onciafn_Neo4jASTFactory$createRole$lambda$_157_0), onciafn_Neo4jASTFactory_ifExistsDo(var$7, $replace, $ifNotExists), $start);
    }
    function oncipj_Cypher_ShowRoles($this, $start, $useClause, $showAll) {
        var $withUsers, $yield, $returnClause, $where, var$8, var$9, var$10, var$11, var$12;
        $withUsers = 0;
        $yield = null;
        $returnClause = null;
        $where = null;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 335:
                    oncipj_Cypher_jj_consume_token($this, 335);
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$9) {
                            case 325:
                                oncipj_Cypher_jj_consume_token($this, 325);
                                break b;
                            case 326:
                                oncipj_Cypher_jj_consume_token($this, 326);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[399] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    $withUsers = 1;
                    break a;
                default:
            }
            $this.$jj_la1.data[400] = $this.$jj_gen;
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$9) {
                case 334:
                case 339:
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$9) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break c;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$9 = $this.$jj_ntk;
                            if (var$9 == (-1))
                                var$9 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$9) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[401] = $this.$jj_gen;
                                    break c;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break c;
                        default:
                    }
                    $this.$jj_la1.data[402] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[403] = $this.$jj_gen;
        }
        var$10 = $this.$astFactory;
        var$11 = oncipj_Cypher_pos($this, $start);
        $returnClause = onciafn_Neo4jASTFactory_yieldOrWhere(var$10, $yield, $returnClause, $where);
        if (!$withUsers) {
            $where = new sci_$colon$colon;
            $start = new oncia_ShowColumn;
            $yield = oncie_Variable__init_($rt_s(925), var$11);
            oncius_package$_$callClinit();
            oncia_ShowColumn__init_($start, $yield, oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(925));
            sci_$colon$colon__init_0($where, $start, sci_Nil$_MODULE$);
        } else {
            $where = new sci_$colon$colon;
            var$12 = new oncia_ShowColumn;
            $start = oncie_Variable__init_($rt_s(925), var$11);
            oncius_package$_$callClinit();
            oncia_ShowColumn__init_(var$12, $start, oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(925));
            sci_$colon$colon__init_0($where, var$12, sci_$colon$colon__init_(oncia_ShowColumn__init_0(oncie_Variable__init_($rt_s(926), var$11), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(926)), sci_Nil$_MODULE$));
        }
        return onciafn_Neo4jASTFactory_useGraph(var$10, oncia_ShowRoles__init_($withUsers, $showAll, $returnClause, $where, var$11), $useClause);
    }
    function oncipj_Cypher_GrantRole($this, $start) {
        var $roles, $users;
        $roles = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        oncipj_Cypher_jj_consume_token($this, 310);
        $users = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        $start = oncipj_Cypher_pos($this, $start);
        return oncia_GrantRolesToUsers__init_((sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $roles)), new onciafn_Neo4jASTFactory$grantRoles$lambda$_161_0)).$toSeq(), (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, $users)), new onciafn_Neo4jASTFactory$grantRoles$lambda$_161_1)).$toSeq(), $start);
    }
    function oncipj_Cypher_CreateUser($this, $start, $replace) {
        var $ifNotExists, $encrypted, $changeRequired, $suspended, $homeDatabase, var$8, var$9, var$10, var$11, var$12, var$13, var$14;
        $ifNotExists = 0;
        $encrypted = 0;
        $changeRequired = ju_Optional_empty();
        $suspended = ju_Optional_empty();
        $homeDatabase = ju_Optional_empty();
        oncipj_Cypher_jj_consume_token($this, 325);
        var$8 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$9) {
                case 177:
                    oncipj_Cypher_jj_consume_token($this, 177);
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 156);
                    $ifNotExists = 1;
                    break a;
                default:
            }
            $this.$jj_la1.data[404] = $this.$jj_gen;
        }
        oncipj_Cypher_jj_consume_token($this, 286);
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$9) {
                case 148:
                case 237:
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$9) {
                        case 148:
                            oncipj_Cypher_jj_consume_token($this, 148);
                            $encrypted = 1;
                            break b;
                        case 237:
                            oncipj_Cypher_jj_consume_token($this, 237);
                            $encrypted = 0;
                            break b;
                        default:
                    }
                    $this.$jj_la1.data[405] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[406] = $this.$jj_gen;
        }
        oncipj_Cypher_jj_consume_token($this, 232);
        var$10 = oncipj_Cypher_passwordExpression($this);
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$9) {
                case 98:
                    break;
                default:
                    $this.$jj_la1.data[407] = $this.$jj_gen;
                    break c;
            }
            $changeRequired = oncipj_Cypher_PasswordChangeRequired($this, $start, $changeRequired);
        }
        d: while (true) {
            var$9 = $this.$jj_ntk;
            if (var$9 == (-1))
                var$9 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$9) {
                case 286:
                    break;
                default:
                    $this.$jj_la1.data[408] = $this.$jj_gen;
                    var$11 = $this.$astFactory;
                    var$12 = oncipj_Cypher_pos($this, $start);
                    var$9 = (ju_Optional_orElse($changeRequired, jl_Boolean_valueOf(1))).$value8;
                    var$13 = ju_Optional_orElse($suspended, null);
                    var$14 = ju_Optional_orElse($homeDatabase, null);
                    $start = var$14 === null ? s_None$_MODULE$ : s_Some__init_(oncia_SetHomeDatabaseAction__init_(var$14));
                    var$14 = oncia_UserOptions__init_(s_Some__init_(jl_Boolean_valueOf(var$9)), onciafn_Neo4jASTFactory_asBooleanOption(var$11, var$13), $start);
                    return oncia_CreateUser__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$8)), $encrypted, var$10, var$14, onciafn_Neo4jASTFactory_ifExistsDo(var$11, $replace, $ifNotExists), var$12);
            }
            var$14 = oncipj_Cypher_jj_consume_token($this, 286);
            var$9 = $this.$jj_ntk;
            if (var$9 == (-1))
                var$9 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$9) {
                case 176:
                    break;
                case 232:
                    oncipj_Cypher_jj_consume_token($this, 232);
                    $changeRequired = oncipj_Cypher_PasswordChangeRequired($this, var$14, $changeRequired);
                    continue d;
                case 297:
                    $suspended = oncipj_Cypher_UserStatus($this, var$14, $suspended);
                    continue d;
                default:
                    break d;
            }
            $homeDatabase = oncipj_Cypher_HomeDatabase($this, var$14, $homeDatabase);
        }
        $this.$jj_la1.data[409] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $start = new oncipj_ParseException;
        jl_Throwable__init_0($start);
        $rt_throw($start);
    }
    function oncipj_Cypher_AlterUser($this, $start) {
        var $password, $ifExists, $encrypted, $changeRequired, $suspended, $homeDatabase, $removeHome, var$9, var$10, var$11, $passwordSetError, var$13;
        $password = null;
        $ifExists = 0;
        $encrypted = 0;
        $changeRequired = ju_Optional_empty();
        $suspended = ju_Optional_empty();
        $homeDatabase = ju_Optional_empty();
        $removeHome = 0;
        oncipj_Cypher_jj_consume_token($this, 325);
        var$9 = oncipj_Cypher_SymbolicNameOrStringParameter($this);
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$10) {
                case 177:
                    break;
                default:
                    $this.$jj_la1.data[412] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 177);
            oncipj_Cypher_jj_consume_token($this, 156);
            $ifExists = 1;
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$10) {
                case 264:
                    oncipj_Cypher_jj_consume_token($this, 264);
                    oncipj_Cypher_jj_consume_token($this, 176);
                    oncipj_Cypher_jj_consume_token($this, 118);
                    $removeHome = 1;
                    break b;
                case 286:
                    c: while (true) {
                        var$11 = oncipj_Cypher_jj_consume_token($this, 286);
                        var$10 = $this.$jj_ntk;
                        if (var$10 == (-1))
                            var$10 = oncipj_Cypher_jj_ntk_f($this);
                        d: {
                            switch (var$10) {
                                case 148:
                                    oncipj_Cypher_jj_consume_token($this, 148);
                                    oncipj_Cypher_assertNotAlreadySet($this, $password, var$11, $rt_s(927));
                                    $encrypted = 1;
                                    oncipj_Cypher_jj_consume_token($this, 232);
                                    $password = oncipj_Cypher_SetPassword($this, var$11, $password);
                                    var$10 = $this.$jj_ntk;
                                    if (var$10 == (-1))
                                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$10) {
                                        case 98:
                                            break;
                                        default:
                                            $this.$jj_la1.data[414] = $this.$jj_gen;
                                            break d;
                                    }
                                    $changeRequired = oncipj_Cypher_PasswordChangeRequired($this, var$11, $changeRequired);
                                    break d;
                                case 176:
                                    break;
                                case 232:
                                    oncipj_Cypher_jj_consume_token($this, 232);
                                    var$10 = $this.$jj_ntk;
                                    if (var$10 == (-1))
                                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$10) {
                                        case 52:
                                        case 64:
                                        case 131:
                                            $password = oncipj_Cypher_SetPassword($this, var$11, $password);
                                            var$10 = $this.$jj_ntk;
                                            if (var$10 == (-1))
                                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                                            switch (var$10) {
                                                case 98:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[415] = $this.$jj_gen;
                                                    break d;
                                            }
                                            $changeRequired = oncipj_Cypher_PasswordChangeRequired($this, var$11, $changeRequired);
                                            break d;
                                        case 98:
                                            break;
                                        default:
                                            $this.$jj_la1.data[416] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $start = new oncipj_ParseException;
                                            jl_Throwable__init_0($start);
                                            $rt_throw($start);
                                    }
                                    $changeRequired = oncipj_Cypher_PasswordChangeRequired($this, var$11, $changeRequired);
                                    break d;
                                case 237:
                                    oncipj_Cypher_jj_consume_token($this, 237);
                                    oncipj_Cypher_assertNotAlreadySet($this, $password, var$11, $rt_s(927));
                                    oncipj_Cypher_jj_consume_token($this, 232);
                                    $password = oncipj_Cypher_SetPassword($this, var$11, $password);
                                    var$10 = $this.$jj_ntk;
                                    if (var$10 == (-1))
                                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$10) {
                                        case 98:
                                            break;
                                        default:
                                            $this.$jj_la1.data[413] = $this.$jj_gen;
                                            break d;
                                    }
                                    $changeRequired = oncipj_Cypher_PasswordChangeRequired($this, var$11, $changeRequired);
                                    break d;
                                case 297:
                                    $suspended = oncipj_Cypher_UserStatus($this, var$11, $suspended);
                                    break d;
                                default:
                                    break c;
                            }
                            $homeDatabase = oncipj_Cypher_HomeDatabase($this, var$11, $homeDatabase);
                        }
                        var$10 = $this.$jj_ntk;
                        if (var$10 == (-1))
                            var$10 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$10) {
                            case 286:
                                break;
                            default:
                                $this.$jj_la1.data[418] = $this.$jj_gen;
                                break b;
                        }
                    }
                    $this.$jj_la1.data[417] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[419] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        $passwordSetError = $this.$astFactory;
        var$11 = oncipj_Cypher_pos($this, $start);
        $start = ju_Optional_orElse($changeRequired, null);
        $changeRequired = ju_Optional_orElse($suspended, null);
        $suspended = ju_Optional_orElse($homeDatabase, null);
        $password = s_Option$_apply(s_Option$_MODULE$, $password);
        $homeDatabase = !s_Option_isDefined($password) ? s_None$_MODULE$ : s_Some__init_(jl_Boolean_valueOf($encrypted));
        var$13 = $removeHome ? s_Some__init_(oncia_RemoveHomeDatabaseAction$_MODULE$) : $suspended === null ? s_None$_MODULE$ : s_Some__init_(oncia_SetHomeDatabaseAction__init_($suspended));
        $suspended = oncia_UserOptions__init_(onciafn_Neo4jASTFactory_asBooleanOption($passwordSetError, $start), onciafn_Neo4jASTFactory_asBooleanOption($passwordSetError, $changeRequired), var$13);
        return oncia_AlterUser__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$9)), $homeDatabase, $password, $suspended, $ifExists, var$11);
    }
    function oncipj_Cypher_SetPassword($this, $start, $password) {
        var var$3;
        var$3 = oncipj_Cypher_passwordExpression($this);
        if ($password === null)
            return var$3;
        var$3 = $this.$exceptionFactory;
        $password = new oncipj_ParseException;
        jl_Throwable__init_($password, $rt_s(927));
        $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException(var$3, $password, $start.$beginOffset, $start.$beginLine, $start.$beginColumn));
    }
    function oncipj_Cypher_passwordExpression($this) {
        var $name, $parameter, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13, var$14, var$15, var$16, $$je;
        $name = null;
        $parameter = null;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 52:
                case 64:
                    $name = oncipj_Cypher_StringToken($this);
                    break a;
                case 131:
                    onciaf_ParameterType_$callClinit();
                    $parameter = oncipj_Cypher_Parameter($this, onciaf_ParameterType_STRING);
                    break a;
                default:
            }
            $this.$jj_la1.data[420] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $name = new oncipj_ParseException;
            jl_Throwable__init_0($name);
            $rt_throw($name);
        }
        if ($name === null) {
            $name = new onciafn_Neo4jASTFactory$$anon$3;
            var$4 = $parameter.$name10;
            oncius_package$_$callClinit();
            oncie_ExplicitParameter__init_0($name, var$4, oncius_package$_CTString(oncius_package$_MODULE$), onciu_UnknownSize$_MODULE$, $parameter.$position14);
            return $name;
        }
        $parameter = oncipj_Cypher_pos($this, $name);
        $name = $name.$image0;
        var$5 = new oncie_SensitiveStringLiteral;
        jnc_StandardCharsets_$callClinit();
        var$6 = jnc_StandardCharsets_UTF_8;
        $name = jn_CharBuffer_wrap($name.$characters);
        b: {
            try {
                $name = jnc_CharsetEncoder_encode0(jnc_CharsetEncoder_onUnmappableCharacter(jnc_CharsetEncoder_onMalformedInput(jnci_UTF8Charset_newEncoder(var$6), jnc_CodingErrorAction_REPLACE), jnc_CodingErrorAction_REPLACE), $name);
                break b;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jnc_CharacterCodingException) {
                    $parameter = $$je;
                } else {
                    throw $$e;
                }
            }
            var$5 = new jl_AssertionError;
            jl_Throwable__init_4(var$5, $rt_s(928), $parameter);
            $rt_throw(var$5);
        }
        if (!$name.$position9 && $name.$limit2 == $name.$capacity)
            var$7 = $name.$array1;
        else {
            var$7 = $rt_createByteArray(jn_Buffer_remaining($name));
            var$8 = var$7.data;
            var$9 = 0;
            var$3 = var$8.length;
            if (var$9 >= var$3) {
                var$6 = new jl_IndexOutOfBoundsException;
                $name = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($name);
                jl_AbstractStringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($name, $rt_s(421)), var$9), $rt_s(415)), var$3), 41);
                jl_Throwable__init_(var$6, jl_AbstractStringBuilder_toString($name));
                $rt_throw(var$6);
            }
            var$10 = var$9 + var$3 | 0;
            if (var$10 > var$3) {
                $name = new jl_IndexOutOfBoundsException;
                $parameter = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($parameter);
                jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($parameter, $rt_s(929)), var$10), $rt_s(418)), var$3);
                jl_Throwable__init_($name, jl_AbstractStringBuilder_toString($parameter));
                $rt_throw($name);
            }
            if (jn_Buffer_remaining($name) < var$3) {
                $name = new jn_BufferUnderflowException;
                jl_Throwable__init_0($name);
                $rt_throw($name);
            }
            if (var$3 < 0) {
                $name = new jl_IndexOutOfBoundsException;
                $parameter = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($parameter);
                jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($parameter, $rt_s(419)), var$3), $rt_s(420));
                jl_Throwable__init_($name, jl_AbstractStringBuilder_toString($parameter));
                $rt_throw($name);
            }
            var$11 = $name.$position9;
            var$12 = var$11 + $name.$start2 | 0;
            var$13 = 0;
            while (var$13 < var$3) {
                var$14 = var$9 + 1 | 0;
                var$15 = $name.$array1.data;
                var$16 = var$12 + 1 | 0;
                var$8[var$9] = var$15[var$12];
                var$13 = var$13 + 1 | 0;
                var$9 = var$14;
                var$12 = var$16;
            }
            $name.$position9 = var$11 + var$3 | 0;
        }
        oncie_SensitiveStringLiteral__init_(var$5, var$7, $parameter);
        return var$5;
    }
    function oncipj_Cypher_PasswordChangeRequired($this, $start, $changeRequired) {
        var $required, var$4;
        $required = 1;
        oncipj_Cypher_jj_consume_token($this, 98);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 219:
                    break;
                default:
                    $this.$jj_la1.data[421] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 219);
            $required = 0;
        }
        oncipj_Cypher_jj_consume_token($this, 268);
        oncipj_Cypher_assertNotAlreadySet($this, ju_Optional_orElse($changeRequired, null), $start, $rt_s(930));
        return ju_Optional_of(jl_Boolean_valueOf($required));
    }
    function oncipj_Cypher_UserStatus($this, $start, $suspended) {
        var var$3;
        oncipj_Cypher_jj_consume_token($this, 297);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 70:
                    break;
                case 301:
                    oncipj_Cypher_jj_consume_token($this, 301);
                    var$3 = 1;
                    break a;
                default:
                    $this.$jj_la1.data[422] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            oncipj_Cypher_jj_consume_token($this, 70);
            var$3 = 0;
        }
        oncipj_Cypher_assertNotAlreadySet($this, ju_Optional_orElse($suspended, null), $start, $rt_s(931));
        return ju_Optional_of(jl_Boolean_valueOf(var$3));
    }
    function oncipj_Cypher_HomeDatabase($this, $start, $homeDatabase) {
        var var$3;
        oncipj_Cypher_jj_consume_token($this, 176);
        oncipj_Cypher_jj_consume_token($this, 118);
        var$3 = oncipj_Cypher_SymbolicAliasName($this);
        oncipj_Cypher_assertNotAlreadySet($this, ju_Optional_orElse($homeDatabase, null), $start, $rt_s(932));
        return ju_Optional_of(oncipj_AliasName_getLocalAliasName(var$3, $this.$astFactory));
    }
    function oncipj_Cypher_ShowUsers($this, $start, $useClause) {
        var $yield, $returnClause, $where, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13, var$14, var$15, var$16, var$17, var$18;
        $yield = null;
        $returnClause = null;
        $where = null;
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 334:
                case 339:
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break a;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$7 = $this.$jj_ntk;
                            if (var$7 == (-1))
                                var$7 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$7) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[423] = $this.$jj_gen;
                                    break a;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[424] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[425] = $this.$jj_gen;
        }
        var$8 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        $yield = onciafn_Neo4jASTFactory_yieldOrWhere(var$8, $yield, $returnClause, $where);
        $returnClause = new oncia_ShowUsers;
        var$9 = new sci_$colon$colon;
        $where = oncia_ShowColumn$_MODULE$;
        var$10 = oncia_ShowColumn$_apply($where, $rt_s(933), oncia_ShowColumn$_apply$default$2($where), $start);
        var$11 = new sci_$colon$colon;
        var$12 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        var$13 = oncius_package$_MODULE$;
        var$13 = oncia_ShowColumn$_apply(var$12, $rt_s(934), oncius_package$_CTList(var$13, oncius_package$_CTString(var$13)), $start);
        var$12 = new sci_$colon$colon;
        var$14 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(935), oncius_package$_CTBoolean(oncius_package$_MODULE$), $start);
        var$15 = new sci_$colon$colon;
        var$16 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(936), oncius_package$_CTBoolean(oncius_package$_MODULE$), $start);
        var$17 = new sci_$colon$colon;
        var$18 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$17, oncia_ShowColumn$_apply(var$18, $rt_s(937), oncia_ShowColumn$_apply$default$2(var$18), $start), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$15, var$16, var$17);
        sci_$colon$colon__init_0(var$12, var$14, var$15);
        sci_$colon$colon__init_0(var$11, var$13, var$12);
        sci_$colon$colon__init_0(var$9, var$10, var$11);
        oncia_ShowUsers__init_($returnClause, $yield, var$9, $start);
        return onciafn_Neo4jASTFactory_useGraph(var$8, $returnClause, $useClause);
    }
    function oncipj_Cypher_ShowCurrentUser($this, $start, $useClause) {
        var $yield, $returnClause, $where, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13, var$14, var$15, var$16, var$17;
        $yield = null;
        $returnClause = null;
        $where = null;
        oncipj_Cypher_jj_consume_token($this, 116);
        oncipj_Cypher_jj_consume_token($this, 325);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 334:
                case 339:
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break a;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$6 = $this.$jj_ntk;
                            if (var$6 == (-1))
                                var$6 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$6) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[426] = $this.$jj_gen;
                                    break a;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[427] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[428] = $this.$jj_gen;
        }
        var$7 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        $yield = onciafn_Neo4jASTFactory_yieldOrWhere(var$7, $yield, $returnClause, $where);
        $returnClause = new oncia_ShowCurrentUser;
        $where = new sci_$colon$colon;
        var$8 = oncia_ShowColumn$_MODULE$;
        var$8 = oncia_ShowColumn$_apply(var$8, $rt_s(933), oncia_ShowColumn$_apply$default$2(var$8), $start);
        var$9 = new sci_$colon$colon;
        var$10 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        var$11 = oncius_package$_MODULE$;
        var$12 = oncia_ShowColumn$_apply(var$10, $rt_s(934), oncius_package$_CTList(var$11, oncius_package$_CTString(var$11)), $start);
        var$13 = new sci_$colon$colon;
        var$11 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(935), oncius_package$_CTBoolean(oncius_package$_MODULE$), $start);
        var$14 = new sci_$colon$colon;
        var$15 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(936), oncius_package$_CTBoolean(oncius_package$_MODULE$), $start);
        var$16 = new sci_$colon$colon;
        var$17 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$16, oncia_ShowColumn$_apply(var$17, $rt_s(937), oncia_ShowColumn$_apply$default$2(var$17), $start), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$14, var$15, var$16);
        sci_$colon$colon__init_0(var$13, var$11, var$14);
        sci_$colon$colon__init_0(var$9, var$12, var$13);
        sci_$colon$colon__init_0($where, var$8, var$9);
        oncia_ShowCurrentUser__init_($returnClause, $yield, $where, $start);
        return onciafn_Neo4jASTFactory_useGraph(var$7, $returnClause, $useClause);
    }
    function oncipj_Cypher_ShowSupportedPrivileges($this, $start, $useClause) {
        var $yield, $returnClause, $where, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13, var$14, var$15, var$16;
        $yield = null;
        $returnClause = null;
        $where = null;
        oncipj_Cypher_jj_consume_token($this, 300);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 246:
                    oncipj_Cypher_jj_consume_token($this, 246);
                    break a;
                case 247:
                    oncipj_Cypher_jj_consume_token($this, 247);
                    break a;
                default:
            }
            $this.$jj_la1.data[429] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$6) {
                case 334:
                case 339:
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break b;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$6 = $this.$jj_ntk;
                            if (var$6 == (-1))
                                var$6 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$6) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[430] = $this.$jj_gen;
                                    break b;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break b;
                        default:
                    }
                    $this.$jj_la1.data[431] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[432] = $this.$jj_gen;
        }
        var$7 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        $yield = onciafn_Neo4jASTFactory_yieldOrWhere(var$7, $yield, $returnClause, $where);
        $returnClause = new sci_$colon$colon;
        $where = oncia_ShowColumn$_MODULE$;
        var$8 = oncia_ShowColumn$_apply($where, oncia_ShowSupportedPrivilegeCommand$_ACTION, oncia_ShowColumn$_apply$default$2($where), $start);
        var$9 = new sci_$colon$colon;
        var$10 = oncia_ShowColumn$_MODULE$;
        var$11 = oncia_ShowColumn$_apply(var$10, oncia_ShowSupportedPrivilegeCommand$_QUALIFIER, oncia_ShowColumn$_apply$default$2(var$10), $start);
        var$12 = new sci_$colon$colon;
        $where = oncia_ShowColumn$_MODULE$;
        var$10 = oncia_ShowColumn$_apply($where, oncia_ShowSupportedPrivilegeCommand$_TARGET, oncia_ShowColumn$_apply$default$2($where), $start);
        var$13 = new sci_$colon$colon;
        var$14 = oncia_ShowColumn$_MODULE$;
        var$15 = oncia_ShowSupportedPrivilegeCommand$_SCOPE;
        oncius_package$_$callClinit();
        $where = oncius_package$_MODULE$;
        $where = oncia_ShowColumn$_apply(var$14, var$15, oncius_package$_CTList($where, oncius_package$_CTString($where)), $start);
        var$14 = new sci_$colon$colon;
        var$16 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$14, oncia_ShowColumn$_apply(var$16, oncia_ShowSupportedPrivilegeCommand$_DESCRIPTION, oncia_ShowColumn$_apply$default$2(var$16), $start), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$13, $where, var$14);
        sci_$colon$colon__init_0(var$12, var$10, var$13);
        sci_$colon$colon__init_0(var$9, var$11, var$12);
        sci_$colon$colon__init_0($returnClause, var$8, var$9);
        return onciafn_Neo4jASTFactory_useGraph(var$7, oncia_ShowSupportedPrivilegeCommand__init_($yield, $returnClause, $start), $useClause);
    }
    function oncipj_Cypher_ShowPrivileges($this, $start, $useClause) {
        var $asCommand, $asRevoke, $yield, $returnClause, $where, var$8, var$9, var$10;
        $asCommand = 0;
        $asRevoke = 0;
        $yield = null;
        $returnClause = null;
        $where = null;
        var$8 = $this.$jj_ntk;
        if (var$8 == (-1))
            var$8 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$8) {
                case 246:
                    oncipj_Cypher_jj_consume_token($this, 246);
                    break a;
                case 247:
                    oncipj_Cypher_jj_consume_token($this, 247);
                    break a;
                default:
            }
            $this.$jj_la1.data[433] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$9) {
                case 81:
                    oncipj_Cypher_jj_consume_token($this, 81);
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$9) {
                            case 270:
                                break;
                            default:
                                $this.$jj_la1.data[434] = $this.$jj_gen;
                                break c;
                        }
                        oncipj_Cypher_jj_consume_token($this, 270);
                        $asRevoke = 1;
                    }
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    d: {
                        switch (var$9) {
                            case 104:
                                oncipj_Cypher_jj_consume_token($this, 104);
                                break d;
                            case 105:
                                oncipj_Cypher_jj_consume_token($this, 105);
                                break d;
                            default:
                        }
                        $this.$jj_la1.data[435] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    $asCommand = 1;
                    break b;
                default:
            }
            $this.$jj_la1.data[436] = $this.$jj_gen;
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        e: {
            switch (var$9) {
                case 334:
                case 339:
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$9) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break e;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$9 = $this.$jj_ntk;
                            if (var$9 == (-1))
                                var$9 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$9) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[437] = $this.$jj_gen;
                                    break e;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break e;
                        default:
                    }
                    $this.$jj_la1.data[438] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[439] = $this.$jj_gen;
        }
        var$10 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        return onciafn_Neo4jASTFactory_useGraph(var$10, !$asCommand ? oncia_ShowPrivileges$_apply(oncia_ShowPrivileges$_MODULE$, oncia_ShowAllPrivileges__init_($start), onciafn_Neo4jASTFactory_yieldOrWhere(var$10, $yield, $returnClause, $where), $start) : oncia_ShowPrivilegeCommands$_apply(oncia_ShowPrivilegeCommands$_MODULE$, oncia_ShowAllPrivileges__init_($start), $asRevoke, onciafn_Neo4jASTFactory_yieldOrWhere(var$10, $yield, $returnClause, $where), $start), $useClause);
    }
    function oncipj_Cypher_ShowRolePrivileges($this, $start, $useClause) {
        var $asCommand, $asRevoke, $yield, $returnClause, $where, var$8, var$9, var$10, var$11, var$12;
        $asCommand = 0;
        $asRevoke = 0;
        $yield = null;
        $returnClause = null;
        $where = null;
        var$8 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$9) {
                case 246:
                    oncipj_Cypher_jj_consume_token($this, 246);
                    break a;
                case 247:
                    oncipj_Cypher_jj_consume_token($this, 247);
                    break a;
                default:
            }
            $this.$jj_la1.data[440] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$10) {
                case 81:
                    oncipj_Cypher_jj_consume_token($this, 81);
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$10) {
                            case 270:
                                break;
                            default:
                                $this.$jj_la1.data[441] = $this.$jj_gen;
                                break c;
                        }
                        oncipj_Cypher_jj_consume_token($this, 270);
                        $asRevoke = 1;
                    }
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    d: {
                        switch (var$10) {
                            case 104:
                                oncipj_Cypher_jj_consume_token($this, 104);
                                break d;
                            case 105:
                                oncipj_Cypher_jj_consume_token($this, 105);
                                break d;
                            default:
                        }
                        $this.$jj_la1.data[442] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    $asCommand = 1;
                    break b;
                default:
            }
            $this.$jj_la1.data[443] = $this.$jj_gen;
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        e: {
            switch (var$10) {
                case 334:
                case 339:
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break e;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[444] = $this.$jj_gen;
                                    break e;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break e;
                        default:
                    }
                    $this.$jj_la1.data[445] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[446] = $this.$jj_gen;
        }
        var$11 = $this.$astFactory;
        var$12 = oncipj_Cypher_pos($this, $start);
        return onciafn_Neo4jASTFactory_useGraph(var$11, !$asCommand ? oncia_ShowPrivileges$_apply(oncia_ShowPrivileges$_MODULE$, oncia_ShowRolesPrivileges__init_((sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$8)), new onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_0)).$toList(), var$12), onciafn_Neo4jASTFactory_yieldOrWhere(var$11, $yield, $returnClause, $where), var$12) : oncia_ShowPrivilegeCommands$_apply(oncia_ShowPrivilegeCommands$_MODULE$,
        oncia_ShowRolesPrivileges__init_((sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$8)), new onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_1)).$toList(), var$12), $asRevoke, onciafn_Neo4jASTFactory_yieldOrWhere(var$11, $yield, $returnClause, $where), var$12), $useClause);
    }
    function oncipj_Cypher_ShowUserPrivileges($this, $start, $useClause) {
        var $users, $asCommand, $asRevoke, $yield, $returnClause, $where, var$9, var$10, var$11, var$12, var$13, $$je;
        $users = null;
        $asCommand = 0;
        $asRevoke = 0;
        $yield = null;
        $returnClause = null;
        $where = null;
        $this.$jj_la = 2147483647;
        var$9 = $this.$token;
        $this.$jj_scanpos = var$9;
        $this.$jj_lastpos = var$9;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$10 = oncipj_Cypher_jj_3_135($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                $start = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 134, 2147483647);
                        break a;
                    }
                    try {
                        var$10 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $start = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 134, 2147483647);
                $rt_throw($start);
            }
            oncipj_Cypher_jj_save($this, 134, 2147483647);
        }
        e: {
            if (var$10) {
                $users = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                var$11 = $this.$jj_ntk;
                if (var$11 == (-1))
                    var$11 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$11) {
                    case 246:
                        oncipj_Cypher_jj_consume_token($this, 246);
                        break e;
                    case 247:
                        oncipj_Cypher_jj_consume_token($this, 247);
                        break e;
                    default:
                }
                $this.$jj_la1.data[447] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $start = new oncipj_ParseException;
                jl_Throwable__init_0($start);
                $rt_throw($start);
            }
            var$11 = $this.$jj_ntk;
            if (var$11 == (-1))
                var$11 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$11) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 131:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    $users = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$11) {
                        case 246:
                            oncipj_Cypher_jj_consume_token($this, 246);
                            break e;
                        case 247:
                            oncipj_Cypher_jj_consume_token($this, 247);
                            break e;
                        default:
                    }
                    $this.$jj_la1.data[449] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                case 86:
                case 101:
                case 102:
                case 103:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break;
                case 246:
                case 247:
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$11) {
                        case 246:
                            oncipj_Cypher_jj_consume_token($this, 246);
                            break e;
                        case 247:
                            oncipj_Cypher_jj_consume_token($this, 247);
                            break e;
                        default:
                    }
                    $this.$jj_la1.data[448] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[450] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        f: {
            switch (var$11) {
                case 81:
                    oncipj_Cypher_jj_consume_token($this, 81);
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    g: {
                        switch (var$11) {
                            case 270:
                                break;
                            default:
                                $this.$jj_la1.data[451] = $this.$jj_gen;
                                break g;
                        }
                        oncipj_Cypher_jj_consume_token($this, 270);
                        $asRevoke = 1;
                    }
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    h: {
                        switch (var$11) {
                            case 104:
                                oncipj_Cypher_jj_consume_token($this, 104);
                                break h;
                            case 105:
                                oncipj_Cypher_jj_consume_token($this, 105);
                                break h;
                            default:
                        }
                        $this.$jj_la1.data[452] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    $asCommand = 1;
                    break f;
                default:
            }
            $this.$jj_la1.data[453] = $this.$jj_gen;
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        i: {
            switch (var$11) {
                case 334:
                case 339:
                    var$11 = $this.$jj_ntk;
                    if (var$11 == (-1))
                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$11) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break i;
                        case 339:
                            $yield = oncipj_Cypher_YieldClause($this);
                            var$11 = $this.$jj_ntk;
                            if (var$11 == (-1))
                                var$11 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$11) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[454] = $this.$jj_gen;
                                    break i;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break i;
                        default:
                    }
                    $this.$jj_la1.data[455] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[456] = $this.$jj_gen;
        }
        var$12 = $this.$astFactory;
        var$13 = oncipj_Cypher_pos($this, $start);
        return onciafn_Neo4jASTFactory_useGraph(var$12, !$asCommand ? oncia_ShowPrivileges$_apply(oncia_ShowPrivileges$_MODULE$, onciafn_Neo4jASTFactory_userPrivilegeScope(var$12, var$13, $users), onciafn_Neo4jASTFactory_yieldOrWhere(var$12, $yield, $returnClause, $where), var$13) : oncia_ShowPrivilegeCommands$_apply(oncia_ShowPrivilegeCommands$_MODULE$, onciafn_Neo4jASTFactory_userPrivilegeScope(var$12, var$13, $users), $asRevoke, onciafn_Neo4jASTFactory_yieldOrWhere(var$12, $yield, $returnClause, $where), var$13),
        $useClause);
    }
    function oncipj_Cypher_grantRoleManagement($this, $start, $immutable) {
        var var$3, var$4;
        var$3 = oncipj_Cypher_roleManagementPrivilege($this, $start, $immutable);
        oncipj_Cypher_jj_consume_token($this, 310);
        var$4 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        return onciafn_Neo4jASTFactory_grantPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$4, var$3);
    }
    function oncipj_Cypher_revokeRoleManagement($this, $start, $revokeGrant, $revokeDeny, $immutable) {
        var var$5, var$6;
        var$5 = oncipj_Cypher_roleManagementPrivilege($this, $start, $immutable);
        oncipj_Cypher_jj_consume_token($this, 164);
        var$6 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        return onciafn_Neo4jASTFactory_revokePrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$6, var$5, $revokeGrant, $revokeDeny);
    }
    function oncipj_Cypher_roleManagementPrivilege($this, $start, $immutable) {
        var var$3, var$4, var$5;
        oncipj_Cypher_jj_consume_token($this, 204);
        oncipj_Cypher_jj_consume_token($this, 224);
        oncipj_Cypher_jj_consume_token($this, 122);
        var$3 = $this.$astFactory;
        var$4 = oncipj_Cypher_pos($this, $start);
        var$5 = $this.$astFactory;
        onciaf_ActionType_$callClinit();
        return onciafn_Neo4jASTFactory_dbmsPrivilege(var$3, var$4, onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_ROLE_ALL), onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
    }
    function oncipj_Cypher_grantPrivilege($this, $start, $immutable) {
        var var$3, var$4;
        var$3 = oncipj_Cypher_privilege($this, $start, $immutable);
        oncipj_Cypher_jj_consume_token($this, 310);
        var$4 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        return onciafn_Neo4jASTFactory_grantPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$4, var$3);
    }
    function oncipj_Cypher_DenyPrivilege($this) {
        var $immutable, $start, var$3, var$4, var$5;
        $immutable = 0;
        $start = oncipj_Cypher_jj_consume_token($this, 127);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 179:
                    break;
                default:
                    $this.$jj_la1.data[457] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 179);
            $immutable = 1;
        }
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$3) {
                case 69:
                case 73:
                case 76:
                case 77:
                case 84:
                case 107:
                case 108:
                case 109:
                case 114:
                case 118:
                case 126:
                case 138:
                case 153:
                case 178:
                case 181:
                case 182:
                case 199:
                case 206:
                case 207:
                case 212:
                case 246:
                case 256:
                case 259:
                case 264:
                case 284:
                case 286:
                case 291:
                case 295:
                case 298:
                case 303:
                case 312:
                case 314:
                case 325:
                case 337:
                    var$4 = oncipj_Cypher_privilege($this, $start, $immutable);
                    break b;
                case 271:
                    oncipj_Cypher_jj_consume_token($this, 271);
                    var$4 = oncipj_Cypher_roleManagementPrivilege($this, $start, $immutable);
                    break b;
                default:
            }
            $this.$jj_la1.data[458] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        oncipj_Cypher_jj_consume_token($this, 310);
        var$5 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        $start = oncipj_Cypher_pos($this, $start);
        return oncia_DenyPrivilege__init_(var$4.$privilegeType, var$4.$immutable, s_Option$_apply(s_Option$_MODULE$, var$4.$resource0), sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$4.$qualifier0))), (sc_StrictOptimizedIterableOps_map$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$5)), new onciafn_Neo4jASTFactory$denyPrivilege$lambda$_178_0)).$toSeq(),
        $start);
    }
    function oncipj_Cypher_RevokePrivilege($this, $start, $revokeGrant, $revokeDeny, $immutable) {
        var var$5, var$6;
        var$5 = oncipj_Cypher_privilege($this, $start, $immutable);
        oncipj_Cypher_jj_consume_token($this, 164);
        var$6 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
        return onciafn_Neo4jASTFactory_revokePrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$6, var$5, $revokeGrant, $revokeDeny);
    }
    function oncipj_Cypher_privilege($this, $start, $immutable) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 69:
                case 108:
                case 109:
                case 181:
                case 182:
                case 212:
                case 295:
                case 298:
                case 303:
                case 312:
                    break;
                case 73:
                case 77:
                case 84:
                case 107:
                case 118:
                case 153:
                case 178:
                case 246:
                case 259:
                case 284:
                case 325:
                    $start = oncipj_Cypher_dbmsPrivilege($this, $start, $immutable);
                    break a;
                case 76:
                    $start = oncipj_Cypher_allPrivilege($this, $start, $immutable);
                    break a;
                case 114:
                    $start = oncipj_Cypher_createPrivilege($this, $start, $immutable);
                    break a;
                case 126:
                case 207:
                    var$4 = null;
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$3) {
                            case 126:
                                oncipj_Cypher_jj_consume_token($this, 126);
                                var$5 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_GRAPH_DELETE);
                                break b;
                            case 207:
                                oncipj_Cypher_jj_consume_token($this, 207);
                                var$4 = oncipj_Cypher_propertyResource($this);
                                var$7 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$7, onciaf_ActionType_GRAPH_MERGE);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[537] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    var$5 = oncipj_Cypher_GraphScope($this);
                    var$7 = oncipj_Cypher_graphQualifier($this);
                    $start = onciafn_Neo4jASTFactory_graphPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$6, var$5, var$4, var$7, $immutable);
                    break a;
                case 138:
                    $start = oncipj_Cypher_dropPrivilege($this, $start, $immutable);
                    break a;
                case 199:
                    var$5 = null;
                    var$7 = null;
                    oncipj_Cypher_jj_consume_token($this, 199);
                    oncipj_Cypher_jj_consume_token($this, 224);
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$8) {
                            case 76:
                                oncipj_Cypher_jj_consume_token($this, 76);
                                oncipj_Cypher_jj_consume_token($this, 117);
                                break c;
                            case 99:
                                oncipj_Cypher_jj_consume_token($this, 99);
                                var$5 = oncipj_Cypher_StringOrParameter($this);
                                break c;
                            case 323:
                                oncipj_Cypher_jj_consume_token($this, 323);
                                var$7 = oncipj_Cypher_StringOrParameter($this);
                                break c;
                            default:
                        }
                        $this.$jj_la1.data[487] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    var$9 = oncipj_Cypher_pos($this, $start);
                    if (var$7 !== null)
                        $start = onciafn_Privilege__init_0(oncia_LoadPrivilege__init_(oncia_LoadAction$_MODULE$, var$9), oncia_FileResource__init_(var$9), ju_List_of(oncia_LoadUrlQualifier__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$7)), var$9)), $immutable);
                    else if (var$5 !== null)
                        $start = onciafn_Privilege__init_0(oncia_LoadPrivilege__init_(oncia_LoadAction$_MODULE$, var$9), oncia_FileResource__init_(var$9), ju_List_of(oncia_LoadCidrQualifier__init_(onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$5)), var$9)), $immutable);
                    else {
                        $start = new onciafn_Privilege;
                        var$5 = oncia_LoadPrivilege__init_(oncia_LoadAction$_MODULE$, var$9);
                        var$7 = oncia_FileResource__init_(var$9);
                        var$4 = new oncia_LoadAllQualifier;
                        var$4.$position33 = var$9;
                        onciafn_Privilege__init_($start, var$5, var$7, ju_List_of(var$4), $immutable);
                    }
                    break a;
                case 206:
                case 256:
                case 314:
                    var$5 = null;
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    d: {
                        switch (var$3) {
                            case 206:
                                oncipj_Cypher_jj_consume_token($this, 206);
                                var$5 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$7 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_GRAPH_MATCH);
                                var$5 = oncipj_Cypher_propertyResource($this);
                                break d;
                            case 256:
                                oncipj_Cypher_jj_consume_token($this, 256);
                                var$5 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$7 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_GRAPH_READ);
                                var$5 = oncipj_Cypher_propertyResource($this);
                                break d;
                            case 314:
                                oncipj_Cypher_jj_consume_token($this, 314);
                                var$7 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$7 = onciafn_Neo4jASTFactory_privilegeAction0(var$7, onciaf_ActionType_GRAPH_TRAVERSE);
                                break d;
                            default:
                        }
                        $this.$jj_la1.data[535] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    var$9 = oncipj_Cypher_GraphScope($this);
                    var$4 = oncipj_Cypher_graphQualifier($this);
                    var$8 = $this.$jj_ntk;
                    if (var$8 == (-1))
                        var$8 = oncipj_Cypher_jj_ntk_f($this);
                    e: {
                        switch (var$8) {
                            case 202:
                                oncipj_Cypher_jj_consume_token($this, 202);
                                oncipj_Cypher_jj_consume_token($this, 307);
                                oncipj_Cypher_jj_consume_token($this, 275);
                                break e;
                            default:
                        }
                        $this.$jj_la1.data[536] = $this.$jj_gen;
                    }
                    $start = onciafn_Neo4jASTFactory_graphPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$7, var$9, var$5, var$4, $immutable);
                    break a;
                case 264:
                    $start = oncipj_Cypher_removePrivilege($this, $start, $immutable);
                    break a;
                case 286:
                    $start = oncipj_Cypher_setPrivilege($this, $start, $immutable);
                    break a;
                case 291:
                    $start = oncipj_Cypher_showPrivilege($this, $start, $immutable);
                    break a;
                case 337:
                    oncipj_Cypher_jj_consume_token($this, 337);
                    oncipj_Cypher_jj_consume_token($this, 224);
                    var$7 = oncipj_Cypher_GraphScope($this);
                    var$9 = $this.$astFactory;
                    var$4 = oncipj_Cypher_pos($this, $start);
                    var$6 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    $start = onciafn_Neo4jASTFactory_graphPrivilege(var$9, var$4, onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_GRAPH_WRITE), var$7, null, ju_List_of(onciafn_Neo4jASTFactory_allElementsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $start))), $immutable);
                    break a;
                default:
                    $this.$jj_la1.data[459] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
            }
            $start = oncipj_Cypher_databasePrivilege($this, $start, $immutable);
        }
        return $start;
    }
    function oncipj_Cypher_allPrivilege($this, $start, $immutable) {
        var $names, $type, $scopeType, var$6, var$7, var$8, var$9;
        $names = null;
        $type = null;
        onciaf_ScopeType_$callClinit();
        $scopeType = onciaf_ScopeType_NAMED;
        oncipj_Cypher_jj_consume_token($this, 76);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 118:
                case 122:
                case 170:
                case 247:
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$7) {
                            case 118:
                            case 122:
                            case 170:
                                var$6 = $this.$jj_ntk;
                                if (var$6 == (-1))
                                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$6) {
                                    case 118:
                                        oncipj_Cypher_jj_consume_token($this, 118);
                                        $type = $rt_s(938);
                                        break b;
                                    case 122:
                                        oncipj_Cypher_jj_consume_token($this, 122);
                                        $type = $rt_s(939);
                                        break b;
                                    case 170:
                                        oncipj_Cypher_jj_consume_token($this, 170);
                                        $type = $rt_s(940);
                                        break b;
                                    default:
                                }
                                $this.$jj_la1.data[460] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            default:
                        }
                        $this.$jj_la1.data[461] = $this.$jj_gen;
                    }
                    oncipj_Cypher_jj_consume_token($this, 247);
                    break a;
                default:
            }
            $this.$jj_la1.data[462] = $this.$jj_gen;
        }
        oncipj_Cypher_jj_consume_token($this, 224);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$6) {
            case 118:
            case 119:
                var$6 = $this.$jj_ntk;
                if (var$6 == (-1))
                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                c: {
                    switch (var$6) {
                        case 118:
                            var$8 = oncipj_Cypher_jj_consume_token($this, 118);
                            break c;
                        case 119:
                            var$8 = oncipj_Cypher_jj_consume_token($this, 119);
                            break c;
                        default:
                    }
                    $this.$jj_la1.data[467] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                var$6 = $this.$jj_ntk;
                if (var$6 == (-1))
                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                d: {
                    switch (var$6) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            $names = oncipj_Cypher_SymbolicAliasNameList($this);
                            break d;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                            break;
                        case 307:
                            oncipj_Cypher_jj_consume_token($this, 307);
                            $scopeType = onciaf_ScopeType_ALL;
                            break d;
                        default:
                    }
                    $this.$jj_la1.data[468] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                oncipj_Cypher_assertValidType($this, var$8, $type, $rt_s(938));
                var$9 = $this.$astFactory;
                $start = oncipj_Cypher_pos($this, $start);
                $type = $this.$astFactory;
                onciaf_ActionType_$callClinit();
                return onciafn_Neo4jASTFactory_databasePrivilege(var$9, $start, onciafn_Neo4jASTFactory_privilegeAction0($type, onciaf_ActionType_DATABASE_ALL), onciafn_Neo4jASTFactory_databaseScope($this.$astFactory, oncipj_Cypher_pos($this, var$8), $names, $scopeType), onciafn_Neo4jASTFactory_allDatabasesQualifier($this.$astFactory), $immutable);
            case 122:
                oncipj_Cypher_assertValidType($this, oncipj_Cypher_jj_consume_token($this, 122), $type, $rt_s(939));
                var$9 = $this.$astFactory;
                $start = oncipj_Cypher_pos($this, $start);
                $names = $this.$astFactory;
                onciaf_ActionType_$callClinit();
                return onciafn_Neo4jASTFactory_dbmsPrivilege(var$9, $start, onciafn_Neo4jASTFactory_privilegeAction0($names, onciaf_ActionType_DBMS_ALL), onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
            case 124:
                var$9 = oncipj_Cypher_jj_consume_token($this, 124);
                var$6 = $this.$jj_ntk;
                if (var$6 == (-1))
                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$6) {
                    case 118:
                        oncipj_Cypher_jj_consume_token($this, 118);
                        oncipj_Cypher_assertValidType($this, var$9, $type, $rt_s(938));
                        $names = $this.$astFactory;
                        $start = oncipj_Cypher_pos($this, $start);
                        var$8 = $this.$astFactory;
                        onciaf_ActionType_$callClinit();
                        return onciafn_Neo4jASTFactory_databasePrivilege($names, $start, onciafn_Neo4jASTFactory_privilegeAction0(var$8, onciaf_ActionType_DATABASE_ALL), onciafn_Neo4jASTFactory_databaseScope($this.$astFactory, oncipj_Cypher_pos($this, var$9), null, onciaf_ScopeType_DEFAULT), onciafn_Neo4jASTFactory_allDatabasesQualifier($this.$astFactory), $immutable);
                    case 170:
                        oncipj_Cypher_jj_consume_token($this, 170);
                        oncipj_Cypher_assertValidType($this, var$9, $type, $rt_s(940));
                        $names = $this.$astFactory;
                        $start = oncipj_Cypher_pos($this, $start);
                        var$8 = $this.$astFactory;
                        onciaf_ActionType_$callClinit();
                        return onciafn_Neo4jASTFactory_graphPrivilege($names, $start, onciafn_Neo4jASTFactory_privilegeAction0(var$8, onciaf_ActionType_GRAPH_ALL), onciafn_Neo4jASTFactory_graphScope($this.$astFactory, oncipj_Cypher_pos($this, var$9), null, onciaf_ScopeType_DEFAULT), null, onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
                    default:
                }
                $this.$jj_la1.data[463] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $rt_throw(oncipj_ParseException__init_());
            case 170:
            case 171:
                var$6 = $this.$jj_ntk;
                if (var$6 == (-1))
                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                e: {
                    switch (var$6) {
                        case 170:
                            var$9 = oncipj_Cypher_jj_consume_token($this, 170);
                            break e;
                        case 171:
                            var$9 = oncipj_Cypher_jj_consume_token($this, 171);
                            break e;
                        default:
                    }
                    $this.$jj_la1.data[465] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                var$6 = $this.$jj_ntk;
                if (var$6 == (-1))
                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                f: {
                    switch (var$6) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            $names = oncipj_Cypher_SymbolicAliasNameList($this);
                            break f;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                            break;
                        case 307:
                            oncipj_Cypher_jj_consume_token($this, 307);
                            $scopeType = onciaf_ScopeType_ALL;
                            break f;
                        default:
                    }
                    $this.$jj_la1.data[466] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                }
                oncipj_Cypher_assertValidType($this, var$9, $type, $rt_s(940));
                var$8 = $this.$astFactory;
                $start = oncipj_Cypher_pos($this, $start);
                $type = $this.$astFactory;
                onciaf_ActionType_$callClinit();
                return onciafn_Neo4jASTFactory_graphPrivilege(var$8, $start, onciafn_Neo4jASTFactory_privilegeAction0($type, onciaf_ActionType_GRAPH_ALL), onciafn_Neo4jASTFactory_graphScope($this.$astFactory, oncipj_Cypher_pos($this, var$9), $names, $scopeType), null, onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
            case 176:
                var$9 = oncipj_Cypher_jj_consume_token($this, 176);
                var$6 = $this.$jj_ntk;
                if (var$6 == (-1))
                    var$6 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$6) {
                    case 118:
                        oncipj_Cypher_jj_consume_token($this, 118);
                        oncipj_Cypher_assertValidType($this, var$9, $type, $rt_s(938));
                        $names = $this.$astFactory;
                        $start = oncipj_Cypher_pos($this, $start);
                        var$8 = $this.$astFactory;
                        onciaf_ActionType_$callClinit();
                        return onciafn_Neo4jASTFactory_databasePrivilege($names, $start, onciafn_Neo4jASTFactory_privilegeAction0(var$8, onciaf_ActionType_DATABASE_ALL), onciafn_Neo4jASTFactory_databaseScope($this.$astFactory, oncipj_Cypher_pos($this, var$9), null, onciaf_ScopeType_HOME), onciafn_Neo4jASTFactory_allDatabasesQualifier($this.$astFactory), $immutable);
                    case 170:
                        oncipj_Cypher_jj_consume_token($this, 170);
                        oncipj_Cypher_assertValidType($this, var$9, $type, $rt_s(940));
                        $names = $this.$astFactory;
                        $start = oncipj_Cypher_pos($this, $start);
                        var$8 = $this.$astFactory;
                        onciaf_ActionType_$callClinit();
                        return onciafn_Neo4jASTFactory_graphPrivilege($names, $start, onciafn_Neo4jASTFactory_privilegeAction0(var$8, onciaf_ActionType_GRAPH_ALL), onciafn_Neo4jASTFactory_graphScope($this.$astFactory, oncipj_Cypher_pos($this, var$9), null, onciaf_ScopeType_HOME), null, onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
                    default:
                }
                $this.$jj_la1.data[464] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $rt_throw(oncipj_ParseException__init_());
            default:
        }
        $this.$jj_la1.data[469] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $rt_throw(oncipj_ParseException__init_());
    }
    function oncipj_Cypher_createPrivilege($this, $start, $immutable) {
        var var$3, $qualifier, var$5, var$6, var$7;
        ju_ArrayList__init_0(new ju_ArrayList);
        oncipj_Cypher_jj_consume_token($this, 114);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 73:
                case 107:
                case 118:
                case 271:
                case 325:
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$3) {
                            case 73:
                                oncipj_Cypher_jj_consume_token($this, 73);
                                $qualifier = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $qualifier = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_ALIAS_CREATE);
                                break b;
                            case 107:
                                oncipj_Cypher_jj_consume_token($this, 107);
                                oncipj_Cypher_jj_consume_token($this, 118);
                                $qualifier = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $qualifier = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_DATABASE_COMPOSITE_CREATE);
                                break b;
                            case 118:
                                oncipj_Cypher_jj_consume_token($this, 118);
                                $qualifier = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $qualifier = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_DATABASE_CREATE);
                                break b;
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                $qualifier = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $qualifier = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_ROLE_CREATE);
                                break b;
                            case 325:
                                oncipj_Cypher_jj_consume_token($this, 325);
                                $qualifier = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $qualifier = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_USER_CREATE);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[480] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    oncipj_Cypher_jj_consume_token($this, 122);
                    $start = onciafn_Neo4jASTFactory_dbmsPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), $qualifier, onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
                    break a;
                case 108:
                case 109:
                case 181:
                case 182:
                case 215:
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$3) {
                            case 108:
                            case 109:
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                d: {
                                    switch (var$3) {
                                        case 108:
                                            oncipj_Cypher_jj_consume_token($this, 108);
                                            break d;
                                        case 109:
                                            oncipj_Cypher_jj_consume_token($this, 109);
                                            break d;
                                        default:
                                    }
                                    $this.$jj_la1.data[471] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                $qualifier = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$5 = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_CONSTRAINT_CREATE);
                                break c;
                            case 181:
                            case 182:
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                e: {
                                    switch (var$3) {
                                        case 181:
                                            oncipj_Cypher_jj_consume_token($this, 181);
                                            break e;
                                        case 182:
                                            oncipj_Cypher_jj_consume_token($this, 182);
                                            break e;
                                        default:
                                    }
                                    $this.$jj_la1.data[470] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                $qualifier = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$5 = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_INDEX_CREATE);
                                break c;
                            case 215:
                                oncipj_Cypher_jj_consume_token($this, 215);
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$3) {
                                    case 190:
                                    case 191:
                                    case 216:
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        f: {
                                            switch (var$3) {
                                                case 216:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[472] = $this.$jj_gen;
                                                    break f;
                                            }
                                            oncipj_Cypher_jj_consume_token($this, 216);
                                        }
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        g: {
                                            switch (var$3) {
                                                case 190:
                                                    oncipj_Cypher_jj_consume_token($this, 190);
                                                    break g;
                                                case 191:
                                                    oncipj_Cypher_jj_consume_token($this, 191);
                                                    break g;
                                                default:
                                            }
                                            $this.$jj_la1.data[473] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $rt_throw(oncipj_ParseException__init_());
                                        }
                                        $qualifier = $this.$astFactory;
                                        onciaf_ActionType_$callClinit();
                                        var$5 = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_CREATE_LABEL);
                                        break c;
                                    case 212:
                                    case 213:
                                    case 251:
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        h: {
                                            switch (var$3) {
                                                case 251:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[476] = $this.$jj_gen;
                                                    break h;
                                            }
                                            oncipj_Cypher_jj_consume_token($this, 251);
                                        }
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        i: {
                                            switch (var$3) {
                                                case 212:
                                                    oncipj_Cypher_jj_consume_token($this, 212);
                                                    break i;
                                                case 213:
                                                    oncipj_Cypher_jj_consume_token($this, 213);
                                                    break i;
                                                default:
                                            }
                                            $this.$jj_la1.data[477] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $rt_throw(oncipj_ParseException__init_());
                                        }
                                        $qualifier = $this.$astFactory;
                                        onciaf_ActionType_$callClinit();
                                        var$5 = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_CREATE_PROPERTYKEY);
                                        break c;
                                    case 262:
                                    case 316:
                                    case 318:
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        j: {
                                            switch (var$3) {
                                                case 262:
                                                    break;
                                                default:
                                                    $this.$jj_la1.data[474] = $this.$jj_gen;
                                                    break j;
                                            }
                                            oncipj_Cypher_jj_consume_token($this, 262);
                                        }
                                        var$3 = $this.$jj_ntk;
                                        if (var$3 == (-1))
                                            var$3 = oncipj_Cypher_jj_ntk_f($this);
                                        k: {
                                            switch (var$3) {
                                                case 316:
                                                    oncipj_Cypher_jj_consume_token($this, 316);
                                                    break k;
                                                case 318:
                                                    oncipj_Cypher_jj_consume_token($this, 318);
                                                    break k;
                                                default:
                                            }
                                            $this.$jj_la1.data[475] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $rt_throw(oncipj_ParseException__init_());
                                        }
                                        $qualifier = $this.$astFactory;
                                        onciaf_ActionType_$callClinit();
                                        var$5 = onciafn_Neo4jASTFactory_privilegeAction0($qualifier, onciaf_ActionType_CREATE_RELTYPE);
                                        break c;
                                    default:
                                }
                                $this.$jj_la1.data[478] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            default:
                        }
                        $this.$jj_la1.data[479] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    $qualifier = oncipj_Cypher_DatabaseScope($this);
                    $start = onciafn_Neo4jASTFactory_databasePrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$5, $qualifier, onciafn_Neo4jASTFactory_allDatabasesQualifier($this.$astFactory), $immutable);
                    break a;
                case 224:
                    oncipj_Cypher_jj_consume_token($this, 224);
                    $qualifier = oncipj_Cypher_GraphScope($this);
                    var$6 = oncipj_Cypher_graphQualifier($this);
                    var$7 = $this.$astFactory;
                    $start = oncipj_Cypher_pos($this, $start);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    $start = onciafn_Neo4jASTFactory_graphPrivilege(var$7, $start, onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_GRAPH_CREATE), $qualifier, null, var$6, $immutable);
                    break a;
                default:
            }
            $this.$jj_la1.data[481] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $rt_throw(oncipj_ParseException__init_());
        }
        return $start;
    }
    function oncipj_Cypher_dropPrivilege($this, $start, $immutable) {
        var var$3, var$4, var$5;
        oncipj_Cypher_jj_consume_token($this, 138);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 73:
                case 107:
                case 118:
                case 271:
                case 325:
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$3) {
                            case 73:
                                oncipj_Cypher_jj_consume_token($this, 73);
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_ALIAS_DROP);
                                break b;
                            case 107:
                                oncipj_Cypher_jj_consume_token($this, 107);
                                oncipj_Cypher_jj_consume_token($this, 118);
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_DATABASE_COMPOSITE_DROP);
                                break b;
                            case 118:
                                oncipj_Cypher_jj_consume_token($this, 118);
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_DATABASE_DROP);
                                break b;
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_ROLE_DROP);
                                break b;
                            case 325:
                                oncipj_Cypher_jj_consume_token($this, 325);
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_USER_DROP);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[485] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    oncipj_Cypher_jj_consume_token($this, 122);
                    $start = onciafn_Neo4jASTFactory_dbmsPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$4, onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
                    break a;
                case 108:
                case 109:
                case 181:
                case 182:
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$3) {
                            case 108:
                            case 109:
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                d: {
                                    switch (var$3) {
                                        case 108:
                                            oncipj_Cypher_jj_consume_token($this, 108);
                                            break d;
                                        case 109:
                                            oncipj_Cypher_jj_consume_token($this, 109);
                                            break d;
                                        default:
                                    }
                                    $this.$jj_la1.data[483] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                                }
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_CONSTRAINT_DROP);
                                break c;
                            case 181:
                            case 182:
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                e: {
                                    switch (var$3) {
                                        case 181:
                                            oncipj_Cypher_jj_consume_token($this, 181);
                                            break e;
                                        case 182:
                                            oncipj_Cypher_jj_consume_token($this, 182);
                                            break e;
                                        default:
                                    }
                                    $this.$jj_la1.data[482] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                                }
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_INDEX_DROP);
                                break c;
                            default:
                        }
                        $this.$jj_la1.data[484] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    var$5 = oncipj_Cypher_DatabaseScope($this);
                    $start = onciafn_Neo4jASTFactory_databasePrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$4, var$5, onciafn_Neo4jASTFactory_allDatabasesQualifier($this.$astFactory), $immutable);
                    break a;
                default:
            }
            $this.$jj_la1.data[486] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        return $start;
    }
    function oncipj_Cypher_showPrivilege($this, $start, $immutable) {
        var $databaseQualifier, $dbmsQualifier, var$5, var$6, var$7, var$8;
        $databaseQualifier = onciafn_Neo4jASTFactory_allDatabasesQualifier($this.$astFactory);
        $dbmsQualifier = onciafn_Neo4jASTFactory_allQualifier($this.$astFactory);
        oncipj_Cypher_jj_consume_token($this, 291);
        var$5 = $this.$jj_ntk;
        if (var$5 == (-1))
            var$5 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$5) {
                case 73:
                case 246:
                case 271:
                case 284:
                case 285:
                case 287:
                case 288:
                case 325:
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$5) {
                            case 73:
                                oncipj_Cypher_jj_consume_token($this, 73);
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_ALIAS_SHOW);
                                break b;
                            case 246:
                                oncipj_Cypher_jj_consume_token($this, 246);
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_PRIVILEGE_SHOW);
                                break b;
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_ROLE_SHOW);
                                break b;
                            case 284:
                            case 285:
                                var$5 = $this.$jj_ntk;
                                if (var$5 == (-1))
                                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                                c: {
                                    switch (var$5) {
                                        case 284:
                                            oncipj_Cypher_jj_consume_token($this, 284);
                                            break c;
                                        case 285:
                                            oncipj_Cypher_jj_consume_token($this, 285);
                                            break c;
                                        default:
                                    }
                                    $this.$jj_la1.data[494] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_SERVER_SHOW);
                                break b;
                            case 287:
                            case 288:
                                var$5 = $this.$jj_ntk;
                                if (var$5 == (-1))
                                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                                d: {
                                    switch (var$5) {
                                        case 287:
                                            oncipj_Cypher_jj_consume_token($this, 287);
                                            break d;
                                        case 288:
                                            oncipj_Cypher_jj_consume_token($this, 288);
                                            break d;
                                        default:
                                    }
                                    $this.$jj_la1.data[495] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                                }
                                var$6 = oncipj_Cypher_pos($this, $start);
                                var$7 = oncipj_Cypher_globs($this);
                                $dbmsQualifier = ju_ArrayList__init_();
                                $databaseQualifier = new onciafn_Neo4jASTFactory$settingQualifier$lambda$_204_0;
                                $databaseQualifier.$_0245 = $dbmsQualifier;
                                $databaseQualifier.$_166 = var$6;
                                ju_ArrayList_forEach(var$7, $databaseQualifier);
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_SETTING_SHOW);
                                break b;
                            case 325:
                                oncipj_Cypher_jj_consume_token($this, 325);
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_USER_SHOW);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[496] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    oncipj_Cypher_jj_consume_token($this, 122);
                    $start = onciafn_Neo4jASTFactory_dbmsPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$6, $dbmsQualifier, $immutable);
                    break a;
                case 108:
                case 109:
                case 181:
                case 182:
                case 312:
                case 313:
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    e: {
                        switch (var$5) {
                            case 108:
                            case 109:
                                var$5 = $this.$jj_ntk;
                                if (var$5 == (-1))
                                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                                f: {
                                    switch (var$5) {
                                        case 108:
                                            oncipj_Cypher_jj_consume_token($this, 108);
                                            break f;
                                        case 109:
                                            oncipj_Cypher_jj_consume_token($this, 109);
                                            break f;
                                        default:
                                    }
                                    $this.$jj_la1.data[489] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $dbmsQualifier = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_CONSTRAINT_SHOW);
                                break e;
                            case 181:
                            case 182:
                                var$5 = $this.$jj_ntk;
                                if (var$5 == (-1))
                                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                                g: {
                                    switch (var$5) {
                                        case 181:
                                            oncipj_Cypher_jj_consume_token($this, 181);
                                            break g;
                                        case 182:
                                            oncipj_Cypher_jj_consume_token($this, 182);
                                            break g;
                                        default:
                                    }
                                    $this.$jj_la1.data[488] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $dbmsQualifier = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_INDEX_SHOW);
                                break e;
                            case 312:
                            case 313:
                                var$5 = $this.$jj_ntk;
                                if (var$5 == (-1))
                                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                                h: {
                                    switch (var$5) {
                                        case 312:
                                            oncipj_Cypher_jj_consume_token($this, 312);
                                            break h;
                                        case 313:
                                            oncipj_Cypher_jj_consume_token($this, 313);
                                            break h;
                                        default:
                                    }
                                    $this.$jj_la1.data[490] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                var$6 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                $dbmsQualifier = onciafn_Neo4jASTFactory_privilegeAction0(var$6, onciaf_ActionType_TRANSACTION_SHOW);
                                $databaseQualifier = onciafn_Neo4jASTFactory_allUsersQualifier($this.$astFactory);
                                var$5 = $this.$jj_ntk;
                                if (var$5 == (-1))
                                    var$5 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$5) {
                                    case 202:
                                        oncipj_Cypher_jj_consume_token($this, 202);
                                        var$8 = $this.$jj_ntk;
                                        if (var$8 == (-1))
                                            var$8 = oncipj_Cypher_jj_ntk_f($this);
                                        i: {
                                            switch (var$8) {
                                                case 68:
                                                case 69:
                                                case 70:
                                                case 71:
                                                case 72:
                                                case 73:
                                                case 74:
                                                case 75:
                                                case 76:
                                                case 77:
                                                case 78:
                                                case 79:
                                                case 80:
                                                case 81:
                                                case 82:
                                                case 83:
                                                case 84:
                                                case 85:
                                                case 87:
                                                case 88:
                                                case 89:
                                                case 90:
                                                case 91:
                                                case 92:
                                                case 93:
                                                case 94:
                                                case 95:
                                                case 96:
                                                case 97:
                                                case 98:
                                                case 99:
                                                case 100:
                                                case 104:
                                                case 105:
                                                case 106:
                                                case 107:
                                                case 108:
                                                case 109:
                                                case 110:
                                                case 111:
                                                case 112:
                                                case 113:
                                                case 114:
                                                case 115:
                                                case 116:
                                                case 117:
                                                case 118:
                                                case 119:
                                                case 120:
                                                case 121:
                                                case 122:
                                                case 123:
                                                case 124:
                                                case 125:
                                                case 126:
                                                case 127:
                                                case 128:
                                                case 129:
                                                case 130:
                                                case 131:
                                                case 132:
                                                case 133:
                                                case 137:
                                                case 138:
                                                case 139:
                                                case 140:
                                                case 141:
                                                case 142:
                                                case 143:
                                                case 144:
                                                case 145:
                                                case 146:
                                                case 147:
                                                case 148:
                                                case 149:
                                                case 150:
                                                case 152:
                                                case 153:
                                                case 154:
                                                case 155:
                                                case 156:
                                                case 157:
                                                case 158:
                                                case 159:
                                                case 160:
                                                case 161:
                                                case 162:
                                                case 163:
                                                case 164:
                                                case 165:
                                                case 166:
                                                case 167:
                                                case 169:
                                                case 170:
                                                case 171:
                                                case 172:
                                                case 173:
                                                case 175:
                                                case 176:
                                                case 177:
                                                case 179:
                                                case 180:
                                                case 181:
                                                case 182:
                                                case 183:
                                                case 184:
                                                case 185:
                                                case 186:
                                                case 187:
                                                case 188:
                                                case 189:
                                                case 190:
                                                case 191:
                                                case 197:
                                                case 198:
                                                case 199:
                                                case 200:
                                                case 201:
                                                case 204:
                                                case 205:
                                                case 206:
                                                case 207:
                                                case 212:
                                                case 213:
                                                case 214:
                                                case 215:
                                                case 216:
                                                case 217:
                                                case 218:
                                                case 219:
                                                case 220:
                                                case 221:
                                                case 222:
                                                case 223:
                                                case 224:
                                                case 225:
                                                case 226:
                                                case 227:
                                                case 228:
                                                case 229:
                                                case 230:
                                                case 231:
                                                case 232:
                                                case 233:
                                                case 234:
                                                case 235:
                                                case 236:
                                                case 237:
                                                case 240:
                                                case 241:
                                                case 243:
                                                case 244:
                                                case 245:
                                                case 246:
                                                case 247:
                                                case 248:
                                                case 249:
                                                case 250:
                                                case 251:
                                                case 253:
                                                case 256:
                                                case 257:
                                                case 258:
                                                case 259:
                                                case 261:
                                                case 262:
                                                case 263:
                                                case 264:
                                                case 265:
                                                case 266:
                                                case 267:
                                                case 268:
                                                case 269:
                                                case 270:
                                                case 271:
                                                case 272:
                                                case 273:
                                                case 274:
                                                case 276:
                                                case 277:
                                                case 278:
                                                case 279:
                                                case 280:
                                                case 281:
                                                case 282:
                                                case 284:
                                                case 285:
                                                case 286:
                                                case 287:
                                                case 288:
                                                case 289:
                                                case 290:
                                                case 291:
                                                case 292:
                                                case 293:
                                                case 294:
                                                case 295:
                                                case 296:
                                                case 297:
                                                case 298:
                                                case 299:
                                                case 300:
                                                case 301:
                                                case 302:
                                                case 303:
                                                case 304:
                                                case 305:
                                                case 306:
                                                case 308:
                                                case 309:
                                                case 310:
                                                case 311:
                                                case 312:
                                                case 313:
                                                case 314:
                                                case 315:
                                                case 316:
                                                case 317:
                                                case 318:
                                                case 319:
                                                case 320:
                                                case 321:
                                                case 322:
                                                case 323:
                                                case 324:
                                                case 325:
                                                case 326:
                                                case 327:
                                                case 328:
                                                case 329:
                                                case 330:
                                                case 331:
                                                case 332:
                                                case 333:
                                                case 334:
                                                case 335:
                                                case 336:
                                                case 337:
                                                case 338:
                                                case 339:
                                                case 340:
                                                case 341:
                                                    var$6 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                                                    $databaseQualifier = onciafn_Neo4jASTFactory_userQualifier($this.$astFactory, var$6);
                                                    break i;
                                                case 86:
                                                case 101:
                                                case 102:
                                                case 103:
                                                case 134:
                                                case 135:
                                                case 136:
                                                case 151:
                                                case 168:
                                                case 174:
                                                case 178:
                                                case 192:
                                                case 193:
                                                case 194:
                                                case 195:
                                                case 196:
                                                case 202:
                                                case 203:
                                                case 208:
                                                case 209:
                                                case 210:
                                                case 211:
                                                case 238:
                                                case 239:
                                                case 242:
                                                case 252:
                                                case 254:
                                                case 255:
                                                case 260:
                                                case 275:
                                                case 283:
                                                    break;
                                                case 307:
                                                    oncipj_Cypher_jj_consume_token($this, 307);
                                                    break i;
                                                default:
                                            }
                                            $this.$jj_la1.data[491] = $this.$jj_gen;
                                            oncipj_Cypher_jj_consume_token($this, (-1));
                                            $rt_throw(oncipj_ParseException__init_());
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 275);
                                        break e;
                                    default:
                                }
                                $this.$jj_la1.data[492] = $this.$jj_gen;
                                break e;
                            default:
                        }
                        $this.$jj_la1.data[493] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    var$6 = oncipj_Cypher_DatabaseScope($this);
                    $start = onciafn_Neo4jASTFactory_databasePrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), $dbmsQualifier, var$6, $databaseQualifier, $immutable);
                    break a;
                default:
            }
            $this.$jj_la1.data[497] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        return $start;
    }
    function oncipj_Cypher_setPrivilege($this, $start, $immutable) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        oncipj_Cypher_jj_consume_token($this, 286);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 118:
                case 232:
                case 233:
                case 325:
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$3) {
                            case 118:
                                oncipj_Cypher_jj_consume_token($this, 118);
                                oncipj_Cypher_jj_consume_token($this, 69);
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_SET_DATABASE_ACCESS);
                                break b;
                            case 232:
                            case 233:
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                c: {
                                    switch (var$3) {
                                        case 232:
                                            oncipj_Cypher_jj_consume_token($this, 232);
                                            break c;
                                        case 233:
                                            oncipj_Cypher_jj_consume_token($this, 233);
                                            break c;
                                        default:
                                    }
                                    $this.$jj_la1.data[498] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                                }
                                var$4 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_USER_PASSWORD);
                                break b;
                            case 325:
                                oncipj_Cypher_jj_consume_token($this, 325);
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$3) {
                                    case 176:
                                        oncipj_Cypher_jj_consume_token($this, 176);
                                        oncipj_Cypher_jj_consume_token($this, 118);
                                        var$4 = $this.$astFactory;
                                        onciaf_ActionType_$callClinit();
                                        var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_USER_HOME);
                                        break b;
                                    case 297:
                                        oncipj_Cypher_jj_consume_token($this, 297);
                                        var$4 = $this.$astFactory;
                                        onciaf_ActionType_$callClinit();
                                        var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$4, onciaf_ActionType_USER_STATUS);
                                        break b;
                                    default:
                                }
                                $this.$jj_la1.data[499] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $start = new oncipj_ParseException;
                                jl_Throwable__init_0($start);
                                $rt_throw($start);
                            default:
                        }
                        $this.$jj_la1.data[500] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    oncipj_Cypher_jj_consume_token($this, 122);
                    $start = onciafn_Neo4jASTFactory_dbmsPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$4, onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
                    break a;
                case 190:
                case 251:
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$3) {
                        case 190:
                            oncipj_Cypher_jj_consume_token($this, 190);
                            var$4 = oncipj_Cypher_labelResource($this);
                            oncipj_Cypher_jj_consume_token($this, 224);
                            var$5 = oncipj_Cypher_GraphScope($this);
                            var$6 = $this.$astFactory;
                            var$7 = oncipj_Cypher_pos($this, $start);
                            var$8 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            $start = onciafn_Neo4jASTFactory_graphPrivilege(var$6, var$7, onciafn_Neo4jASTFactory_privilegeAction0(var$8, onciaf_ActionType_GRAPH_LABEL_SET), var$5, var$4, ju_List_of(onciafn_Neo4jASTFactory_allLabelsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $start))), $immutable);
                            break a;
                        case 251:
                            oncipj_Cypher_jj_consume_token($this, 251);
                            var$4 = oncipj_Cypher_propertyResource($this);
                            oncipj_Cypher_jj_consume_token($this, 224);
                            var$5 = oncipj_Cypher_GraphScope($this);
                            var$6 = oncipj_Cypher_graphQualifier($this);
                            var$7 = $this.$astFactory;
                            var$8 = oncipj_Cypher_pos($this, $start);
                            var$9 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            $start = onciafn_Neo4jASTFactory_graphPrivilege(var$7, var$8, onciafn_Neo4jASTFactory_privilegeAction0(var$9, onciaf_ActionType_GRAPH_PROPERTY_SET), var$5, var$4, var$6, $immutable);
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[501] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[502] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        return $start;
    }
    function oncipj_Cypher_removePrivilege($this, $start, $immutable) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        oncipj_Cypher_jj_consume_token($this, 264);
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 190:
                    oncipj_Cypher_jj_consume_token($this, 190);
                    var$4 = oncipj_Cypher_labelResource($this);
                    oncipj_Cypher_jj_consume_token($this, 224);
                    var$5 = oncipj_Cypher_GraphScope($this);
                    var$6 = $this.$astFactory;
                    var$7 = oncipj_Cypher_pos($this, $start);
                    var$8 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    $start = onciafn_Neo4jASTFactory_graphPrivilege(var$6, var$7, onciafn_Neo4jASTFactory_privilegeAction0(var$8, onciaf_ActionType_GRAPH_LABEL_REMOVE), var$5, var$4, ju_List_of(onciafn_Neo4jASTFactory_allLabelsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $start))), $immutable);
                    break a;
                case 246:
                case 271:
                    var$3 = $this.$jj_ntk;
                    if (var$3 == (-1))
                        var$3 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$3) {
                            case 246:
                                oncipj_Cypher_jj_consume_token($this, 246);
                                var$9 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$9, onciaf_ActionType_PRIVILEGE_REMOVE);
                                break b;
                            case 271:
                                oncipj_Cypher_jj_consume_token($this, 271);
                                var$9 = $this.$astFactory;
                                onciaf_ActionType_$callClinit();
                                var$4 = onciafn_Neo4jASTFactory_privilegeAction0(var$9, onciaf_ActionType_ROLE_REMOVE);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[503] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 224);
                    oncipj_Cypher_jj_consume_token($this, 122);
                    $start = onciafn_Neo4jASTFactory_dbmsPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$4, onciafn_Neo4jASTFactory_allQualifier($this.$astFactory), $immutable);
                    break a;
                default:
            }
            $this.$jj_la1.data[504] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        return $start;
    }
    function oncipj_Cypher_databasePrivilege($this, $start, $immutable) {
        var $qualifier, var$4, var$5, var$6, var$7;
        $qualifier = onciafn_Neo4jASTFactory_allDatabasesQualifier($this.$astFactory);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 69:
                    oncipj_Cypher_jj_consume_token($this, 69);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_ACCESS);
                    break a;
                case 108:
                case 109:
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$7) {
                            case 108:
                                oncipj_Cypher_jj_consume_token($this, 108);
                                break b;
                            case 109:
                                oncipj_Cypher_jj_consume_token($this, 109);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[507] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$7) {
                            case 204:
                                break;
                            default:
                                $this.$jj_la1.data[508] = $this.$jj_gen;
                                break c;
                        }
                        oncipj_Cypher_jj_consume_token($this, 204);
                    }
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_CONSTRAINT_ALL);
                    break a;
                case 181:
                case 182:
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    d: {
                        switch (var$7) {
                            case 181:
                                oncipj_Cypher_jj_consume_token($this, 181);
                                break d;
                            case 182:
                                oncipj_Cypher_jj_consume_token($this, 182);
                                break d;
                            default:
                        }
                        $this.$jj_la1.data[505] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    e: {
                        switch (var$7) {
                            case 204:
                                break;
                            default:
                                $this.$jj_la1.data[506] = $this.$jj_gen;
                                break e;
                        }
                        oncipj_Cypher_jj_consume_token($this, 204);
                    }
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_INDEX_ALL);
                    break a;
                case 212:
                    oncipj_Cypher_jj_consume_token($this, 212);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    f: {
                        switch (var$7) {
                            case 204:
                                break;
                            default:
                                $this.$jj_la1.data[515] = $this.$jj_gen;
                                break f;
                        }
                        oncipj_Cypher_jj_consume_token($this, 204);
                    }
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_CREATE_TOKEN);
                    break a;
                case 295:
                    oncipj_Cypher_jj_consume_token($this, 295);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_DATABASE_START);
                    break a;
                case 298:
                    oncipj_Cypher_jj_consume_token($this, 298);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_DATABASE_STOP);
                    break a;
                case 303:
                    oncipj_Cypher_jj_consume_token($this, 303);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    g: {
                        switch (var$7) {
                            case 312:
                                oncipj_Cypher_jj_consume_token($this, 312);
                                break g;
                            case 313:
                                oncipj_Cypher_jj_consume_token($this, 313);
                                break g;
                            default:
                        }
                        $this.$jj_la1.data[512] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $rt_throw(oncipj_ParseException__init_());
                    }
                    $qualifier = onciafn_Neo4jASTFactory_allUsersQualifier($this.$astFactory);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    h: {
                        switch (var$7) {
                            case 202:
                                oncipj_Cypher_jj_consume_token($this, 202);
                                var$7 = $this.$jj_ntk;
                                if (var$7 == (-1))
                                    var$7 = oncipj_Cypher_jj_ntk_f($this);
                                i: {
                                    switch (var$7) {
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 71:
                                        case 72:
                                        case 73:
                                        case 74:
                                        case 75:
                                        case 76:
                                        case 77:
                                        case 78:
                                        case 79:
                                        case 80:
                                        case 81:
                                        case 82:
                                        case 83:
                                        case 84:
                                        case 85:
                                        case 87:
                                        case 88:
                                        case 89:
                                        case 90:
                                        case 91:
                                        case 92:
                                        case 93:
                                        case 94:
                                        case 95:
                                        case 96:
                                        case 97:
                                        case 98:
                                        case 99:
                                        case 100:
                                        case 104:
                                        case 105:
                                        case 106:
                                        case 107:
                                        case 108:
                                        case 109:
                                        case 110:
                                        case 111:
                                        case 112:
                                        case 113:
                                        case 114:
                                        case 115:
                                        case 116:
                                        case 117:
                                        case 118:
                                        case 119:
                                        case 120:
                                        case 121:
                                        case 122:
                                        case 123:
                                        case 124:
                                        case 125:
                                        case 126:
                                        case 127:
                                        case 128:
                                        case 129:
                                        case 130:
                                        case 131:
                                        case 132:
                                        case 133:
                                        case 137:
                                        case 138:
                                        case 139:
                                        case 140:
                                        case 141:
                                        case 142:
                                        case 143:
                                        case 144:
                                        case 145:
                                        case 146:
                                        case 147:
                                        case 148:
                                        case 149:
                                        case 150:
                                        case 152:
                                        case 153:
                                        case 154:
                                        case 155:
                                        case 156:
                                        case 157:
                                        case 158:
                                        case 159:
                                        case 160:
                                        case 161:
                                        case 162:
                                        case 163:
                                        case 164:
                                        case 165:
                                        case 166:
                                        case 167:
                                        case 169:
                                        case 170:
                                        case 171:
                                        case 172:
                                        case 173:
                                        case 175:
                                        case 176:
                                        case 177:
                                        case 179:
                                        case 180:
                                        case 181:
                                        case 182:
                                        case 183:
                                        case 184:
                                        case 185:
                                        case 186:
                                        case 187:
                                        case 188:
                                        case 189:
                                        case 190:
                                        case 191:
                                        case 197:
                                        case 198:
                                        case 199:
                                        case 200:
                                        case 201:
                                        case 204:
                                        case 205:
                                        case 206:
                                        case 207:
                                        case 212:
                                        case 213:
                                        case 214:
                                        case 215:
                                        case 216:
                                        case 217:
                                        case 218:
                                        case 219:
                                        case 220:
                                        case 221:
                                        case 222:
                                        case 223:
                                        case 224:
                                        case 225:
                                        case 226:
                                        case 227:
                                        case 228:
                                        case 229:
                                        case 230:
                                        case 231:
                                        case 232:
                                        case 233:
                                        case 234:
                                        case 235:
                                        case 236:
                                        case 237:
                                        case 240:
                                        case 241:
                                        case 243:
                                        case 244:
                                        case 245:
                                        case 246:
                                        case 247:
                                        case 248:
                                        case 249:
                                        case 250:
                                        case 251:
                                        case 253:
                                        case 256:
                                        case 257:
                                        case 258:
                                        case 259:
                                        case 261:
                                        case 262:
                                        case 263:
                                        case 264:
                                        case 265:
                                        case 266:
                                        case 267:
                                        case 268:
                                        case 269:
                                        case 270:
                                        case 271:
                                        case 272:
                                        case 273:
                                        case 274:
                                        case 276:
                                        case 277:
                                        case 278:
                                        case 279:
                                        case 280:
                                        case 281:
                                        case 282:
                                        case 284:
                                        case 285:
                                        case 286:
                                        case 287:
                                        case 288:
                                        case 289:
                                        case 290:
                                        case 291:
                                        case 292:
                                        case 293:
                                        case 294:
                                        case 295:
                                        case 296:
                                        case 297:
                                        case 298:
                                        case 299:
                                        case 300:
                                        case 301:
                                        case 302:
                                        case 303:
                                        case 304:
                                        case 305:
                                        case 306:
                                        case 308:
                                        case 309:
                                        case 310:
                                        case 311:
                                        case 312:
                                        case 313:
                                        case 314:
                                        case 315:
                                        case 316:
                                        case 317:
                                        case 318:
                                        case 319:
                                        case 320:
                                        case 321:
                                        case 322:
                                        case 323:
                                        case 324:
                                        case 325:
                                        case 326:
                                        case 327:
                                        case 328:
                                        case 329:
                                        case 330:
                                        case 331:
                                        case 332:
                                        case 333:
                                        case 334:
                                        case 335:
                                        case 336:
                                        case 337:
                                        case 338:
                                        case 339:
                                        case 340:
                                        case 341:
                                            var$5 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                                            $qualifier = onciafn_Neo4jASTFactory_userQualifier($this.$astFactory, var$5);
                                            break i;
                                        case 86:
                                        case 101:
                                        case 102:
                                        case 103:
                                        case 134:
                                        case 135:
                                        case 136:
                                        case 151:
                                        case 168:
                                        case 174:
                                        case 178:
                                        case 192:
                                        case 193:
                                        case 194:
                                        case 195:
                                        case 196:
                                        case 202:
                                        case 203:
                                        case 208:
                                        case 209:
                                        case 210:
                                        case 211:
                                        case 238:
                                        case 239:
                                        case 242:
                                        case 252:
                                        case 254:
                                        case 255:
                                        case 260:
                                        case 275:
                                        case 283:
                                            break;
                                        case 307:
                                            oncipj_Cypher_jj_consume_token($this, 307);
                                            break i;
                                        default:
                                    }
                                    $this.$jj_la1.data[513] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                oncipj_Cypher_jj_consume_token($this, 275);
                                break h;
                            default:
                        }
                        $this.$jj_la1.data[514] = $this.$jj_gen;
                    }
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_TRANSACTION_TERMINATE);
                    break a;
                case 312:
                    oncipj_Cypher_jj_consume_token($this, 312);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    j: {
                        switch (var$7) {
                            case 204:
                                break;
                            default:
                                $this.$jj_la1.data[509] = $this.$jj_gen;
                                break j;
                        }
                        oncipj_Cypher_jj_consume_token($this, 204);
                    }
                    $qualifier = onciafn_Neo4jASTFactory_allUsersQualifier($this.$astFactory);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    k: {
                        switch (var$7) {
                            case 202:
                                oncipj_Cypher_jj_consume_token($this, 202);
                                var$7 = $this.$jj_ntk;
                                if (var$7 == (-1))
                                    var$7 = oncipj_Cypher_jj_ntk_f($this);
                                l: {
                                    switch (var$7) {
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 71:
                                        case 72:
                                        case 73:
                                        case 74:
                                        case 75:
                                        case 76:
                                        case 77:
                                        case 78:
                                        case 79:
                                        case 80:
                                        case 81:
                                        case 82:
                                        case 83:
                                        case 84:
                                        case 85:
                                        case 87:
                                        case 88:
                                        case 89:
                                        case 90:
                                        case 91:
                                        case 92:
                                        case 93:
                                        case 94:
                                        case 95:
                                        case 96:
                                        case 97:
                                        case 98:
                                        case 99:
                                        case 100:
                                        case 104:
                                        case 105:
                                        case 106:
                                        case 107:
                                        case 108:
                                        case 109:
                                        case 110:
                                        case 111:
                                        case 112:
                                        case 113:
                                        case 114:
                                        case 115:
                                        case 116:
                                        case 117:
                                        case 118:
                                        case 119:
                                        case 120:
                                        case 121:
                                        case 122:
                                        case 123:
                                        case 124:
                                        case 125:
                                        case 126:
                                        case 127:
                                        case 128:
                                        case 129:
                                        case 130:
                                        case 131:
                                        case 132:
                                        case 133:
                                        case 137:
                                        case 138:
                                        case 139:
                                        case 140:
                                        case 141:
                                        case 142:
                                        case 143:
                                        case 144:
                                        case 145:
                                        case 146:
                                        case 147:
                                        case 148:
                                        case 149:
                                        case 150:
                                        case 152:
                                        case 153:
                                        case 154:
                                        case 155:
                                        case 156:
                                        case 157:
                                        case 158:
                                        case 159:
                                        case 160:
                                        case 161:
                                        case 162:
                                        case 163:
                                        case 164:
                                        case 165:
                                        case 166:
                                        case 167:
                                        case 169:
                                        case 170:
                                        case 171:
                                        case 172:
                                        case 173:
                                        case 175:
                                        case 176:
                                        case 177:
                                        case 179:
                                        case 180:
                                        case 181:
                                        case 182:
                                        case 183:
                                        case 184:
                                        case 185:
                                        case 186:
                                        case 187:
                                        case 188:
                                        case 189:
                                        case 190:
                                        case 191:
                                        case 197:
                                        case 198:
                                        case 199:
                                        case 200:
                                        case 201:
                                        case 204:
                                        case 205:
                                        case 206:
                                        case 207:
                                        case 212:
                                        case 213:
                                        case 214:
                                        case 215:
                                        case 216:
                                        case 217:
                                        case 218:
                                        case 219:
                                        case 220:
                                        case 221:
                                        case 222:
                                        case 223:
                                        case 224:
                                        case 225:
                                        case 226:
                                        case 227:
                                        case 228:
                                        case 229:
                                        case 230:
                                        case 231:
                                        case 232:
                                        case 233:
                                        case 234:
                                        case 235:
                                        case 236:
                                        case 237:
                                        case 240:
                                        case 241:
                                        case 243:
                                        case 244:
                                        case 245:
                                        case 246:
                                        case 247:
                                        case 248:
                                        case 249:
                                        case 250:
                                        case 251:
                                        case 253:
                                        case 256:
                                        case 257:
                                        case 258:
                                        case 259:
                                        case 261:
                                        case 262:
                                        case 263:
                                        case 264:
                                        case 265:
                                        case 266:
                                        case 267:
                                        case 268:
                                        case 269:
                                        case 270:
                                        case 271:
                                        case 272:
                                        case 273:
                                        case 274:
                                        case 276:
                                        case 277:
                                        case 278:
                                        case 279:
                                        case 280:
                                        case 281:
                                        case 282:
                                        case 284:
                                        case 285:
                                        case 286:
                                        case 287:
                                        case 288:
                                        case 289:
                                        case 290:
                                        case 291:
                                        case 292:
                                        case 293:
                                        case 294:
                                        case 295:
                                        case 296:
                                        case 297:
                                        case 298:
                                        case 299:
                                        case 300:
                                        case 301:
                                        case 302:
                                        case 303:
                                        case 304:
                                        case 305:
                                        case 306:
                                        case 308:
                                        case 309:
                                        case 310:
                                        case 311:
                                        case 312:
                                        case 313:
                                        case 314:
                                        case 315:
                                        case 316:
                                        case 317:
                                        case 318:
                                        case 319:
                                        case 320:
                                        case 321:
                                        case 322:
                                        case 323:
                                        case 324:
                                        case 325:
                                        case 326:
                                        case 327:
                                        case 328:
                                        case 329:
                                        case 330:
                                        case 331:
                                        case 332:
                                        case 333:
                                        case 334:
                                        case 335:
                                        case 336:
                                        case 337:
                                        case 338:
                                        case 339:
                                        case 340:
                                        case 341:
                                            var$5 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                                            $qualifier = onciafn_Neo4jASTFactory_userQualifier($this.$astFactory, var$5);
                                            break l;
                                        case 86:
                                        case 101:
                                        case 102:
                                        case 103:
                                        case 134:
                                        case 135:
                                        case 136:
                                        case 151:
                                        case 168:
                                        case 174:
                                        case 178:
                                        case 192:
                                        case 193:
                                        case 194:
                                        case 195:
                                        case 196:
                                        case 202:
                                        case 203:
                                        case 208:
                                        case 209:
                                        case 210:
                                        case 211:
                                        case 238:
                                        case 239:
                                        case 242:
                                        case 252:
                                        case 254:
                                        case 255:
                                        case 260:
                                        case 275:
                                        case 283:
                                            break;
                                        case 307:
                                            oncipj_Cypher_jj_consume_token($this, 307);
                                            break l;
                                        default:
                                    }
                                    $this.$jj_la1.data[510] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                oncipj_Cypher_jj_consume_token($this, 275);
                                break k;
                            default:
                        }
                        $this.$jj_la1.data[511] = $this.$jj_gen;
                    }
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_TRANSACTION_ALL);
                    break a;
                default:
            }
            $this.$jj_la1.data[516] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        oncipj_Cypher_jj_consume_token($this, 224);
        var$5 = oncipj_Cypher_DatabaseScope($this);
        return onciafn_Neo4jASTFactory_databasePrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$6, var$5, $qualifier, $immutable);
    }
    function oncipj_Cypher_dbmsPrivilege($this, $start, $immutable) {
        var $qualifier, var$4, var$5, var$6, var$7;
        $qualifier = onciafn_Neo4jASTFactory_allQualifier($this.$astFactory);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 73:
                    oncipj_Cypher_jj_consume_token($this, 73);
                    oncipj_Cypher_jj_consume_token($this, 204);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_ALIAS_MANAGEMENT);
                    break a;
                case 77:
                    oncipj_Cypher_jj_consume_token($this, 77);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$7) {
                        case 73:
                            oncipj_Cypher_jj_consume_token($this, 73);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_ALIAS_ALTER);
                            break a;
                        case 118:
                            oncipj_Cypher_jj_consume_token($this, 118);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_DATABASE_ALTER);
                            break a;
                        case 325:
                            oncipj_Cypher_jj_consume_token($this, 325);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_USER_ALTER);
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[517] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                case 84:
                    oncipj_Cypher_jj_consume_token($this, 84);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$7) {
                        case 246:
                            oncipj_Cypher_jj_consume_token($this, 246);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_PRIVILEGE_ASSIGN);
                            break a;
                        case 271:
                            oncipj_Cypher_jj_consume_token($this, 271);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_ROLE_ASSIGN);
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[518] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                case 107:
                    oncipj_Cypher_jj_consume_token($this, 107);
                    oncipj_Cypher_jj_consume_token($this, 118);
                    oncipj_Cypher_jj_consume_token($this, 204);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_DATABASE_COMPOSITE_MANAGEMENT);
                    break a;
                case 118:
                    oncipj_Cypher_jj_consume_token($this, 118);
                    oncipj_Cypher_jj_consume_token($this, 204);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_DATABASE_MANAGEMENT);
                    break a;
                case 153:
                    oncipj_Cypher_jj_consume_token($this, 153);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$7) {
                        case 71:
                        case 72:
                            var$7 = $this.$jj_ntk;
                            if (var$7 == (-1))
                                var$7 = oncipj_Cypher_jj_ntk_f($this);
                            b: {
                                switch (var$7) {
                                    case 71:
                                        oncipj_Cypher_jj_consume_token($this, 71);
                                        break b;
                                    case 72:
                                        oncipj_Cypher_jj_consume_token($this, 72);
                                        break b;
                                    default:
                                }
                                $this.$jj_la1.data[519] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            oncipj_Cypher_jj_consume_token($this, 249);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_EXECUTE_ADMIN_PROCEDURE);
                            break a;
                        case 90:
                            oncipj_Cypher_jj_consume_token($this, 90);
                            var$7 = $this.$jj_ntk;
                            if (var$7 == (-1))
                                var$7 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$7) {
                                case 166:
                                case 167:
                                case 325:
                                    var$7 = $this.$jj_ntk;
                                    if (var$7 == (-1))
                                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                                    c: {
                                        switch (var$7) {
                                            case 325:
                                                oncipj_Cypher_jj_consume_token($this, 325);
                                                var$7 = $this.$jj_ntk;
                                                if (var$7 == (-1))
                                                    var$7 = oncipj_Cypher_jj_ntk_f($this);
                                                switch (var$7) {
                                                    case 125:
                                                        break;
                                                    default:
                                                        $this.$jj_la1.data[521] = $this.$jj_gen;
                                                        break c;
                                                }
                                                oncipj_Cypher_jj_consume_token($this, 125);
                                                break c;
                                            default:
                                        }
                                        $this.$jj_la1.data[522] = $this.$jj_gen;
                                    }
                                    var$7 = $this.$jj_ntk;
                                    if (var$7 == (-1))
                                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                                    d: {
                                        switch (var$7) {
                                            case 166:
                                                oncipj_Cypher_jj_consume_token($this, 166);
                                                break d;
                                            case 167:
                                                oncipj_Cypher_jj_consume_token($this, 167);
                                                break d;
                                            default:
                                        }
                                        $this.$jj_la1.data[523] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $rt_throw(oncipj_ParseException__init_());
                                    }
                                    $qualifier = oncipj_Cypher_executeFunctionQualifier($this, $start);
                                    var$5 = $this.$astFactory;
                                    onciaf_ActionType_$callClinit();
                                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_EXECUTE_BOOSTED_FUNCTION);
                                    break a;
                                case 248:
                                case 249:
                                    var$7 = $this.$jj_ntk;
                                    if (var$7 == (-1))
                                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                                    e: {
                                        switch (var$7) {
                                            case 248:
                                                oncipj_Cypher_jj_consume_token($this, 248);
                                                break e;
                                            case 249:
                                                oncipj_Cypher_jj_consume_token($this, 249);
                                                break e;
                                            default:
                                        }
                                        $this.$jj_la1.data[520] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $rt_throw(oncipj_ParseException__init_());
                                    }
                                    $qualifier = oncipj_Cypher_executeProcedureQualifier($this, $start);
                                    var$5 = $this.$astFactory;
                                    onciaf_ActionType_$callClinit();
                                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_EXECUTE_BOOSTED_PROCEDURE);
                                    break a;
                                default:
                            }
                            $this.$jj_la1.data[524] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        case 166:
                        case 167:
                        case 325:
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            f: {
                                switch (var$4) {
                                    case 325:
                                        oncipj_Cypher_jj_consume_token($this, 325);
                                        var$4 = $this.$jj_ntk;
                                        if (var$4 == (-1))
                                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$4) {
                                            case 125:
                                                break;
                                            default:
                                                $this.$jj_la1.data[526] = $this.$jj_gen;
                                                break f;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 125);
                                        break f;
                                    default:
                                }
                                $this.$jj_la1.data[527] = $this.$jj_gen;
                            }
                            var$7 = $this.$jj_ntk;
                            if (var$7 == (-1))
                                var$7 = oncipj_Cypher_jj_ntk_f($this);
                            g: {
                                switch (var$7) {
                                    case 166:
                                        oncipj_Cypher_jj_consume_token($this, 166);
                                        break g;
                                    case 167:
                                        oncipj_Cypher_jj_consume_token($this, 167);
                                        break g;
                                    default:
                                }
                                $this.$jj_la1.data[528] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            $qualifier = oncipj_Cypher_executeFunctionQualifier($this, $start);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_EXECUTE_FUNCTION);
                            break a;
                        case 248:
                        case 249:
                            var$7 = $this.$jj_ntk;
                            if (var$7 == (-1))
                                var$7 = oncipj_Cypher_jj_ntk_f($this);
                            h: {
                                switch (var$7) {
                                    case 248:
                                        oncipj_Cypher_jj_consume_token($this, 248);
                                        break h;
                                    case 249:
                                        oncipj_Cypher_jj_consume_token($this, 249);
                                        break h;
                                    default:
                                }
                                $this.$jj_la1.data[525] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            $qualifier = oncipj_Cypher_executeProcedureQualifier($this, $start);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_EXECUTE_PROCEDURE);
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[529] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                case 178:
                    oncipj_Cypher_jj_consume_token($this, 178);
                    $qualifier = onciafn_Neo4jASTFactory_allUsersQualifier($this.$astFactory);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    i: {
                        switch (var$7) {
                            case 202:
                                oncipj_Cypher_jj_consume_token($this, 202);
                                var$7 = $this.$jj_ntk;
                                if (var$7 == (-1))
                                    var$7 = oncipj_Cypher_jj_ntk_f($this);
                                j: {
                                    switch (var$7) {
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 71:
                                        case 72:
                                        case 73:
                                        case 74:
                                        case 75:
                                        case 76:
                                        case 77:
                                        case 78:
                                        case 79:
                                        case 80:
                                        case 81:
                                        case 82:
                                        case 83:
                                        case 84:
                                        case 85:
                                        case 87:
                                        case 88:
                                        case 89:
                                        case 90:
                                        case 91:
                                        case 92:
                                        case 93:
                                        case 94:
                                        case 95:
                                        case 96:
                                        case 97:
                                        case 98:
                                        case 99:
                                        case 100:
                                        case 104:
                                        case 105:
                                        case 106:
                                        case 107:
                                        case 108:
                                        case 109:
                                        case 110:
                                        case 111:
                                        case 112:
                                        case 113:
                                        case 114:
                                        case 115:
                                        case 116:
                                        case 117:
                                        case 118:
                                        case 119:
                                        case 120:
                                        case 121:
                                        case 122:
                                        case 123:
                                        case 124:
                                        case 125:
                                        case 126:
                                        case 127:
                                        case 128:
                                        case 129:
                                        case 130:
                                        case 131:
                                        case 132:
                                        case 133:
                                        case 137:
                                        case 138:
                                        case 139:
                                        case 140:
                                        case 141:
                                        case 142:
                                        case 143:
                                        case 144:
                                        case 145:
                                        case 146:
                                        case 147:
                                        case 148:
                                        case 149:
                                        case 150:
                                        case 152:
                                        case 153:
                                        case 154:
                                        case 155:
                                        case 156:
                                        case 157:
                                        case 158:
                                        case 159:
                                        case 160:
                                        case 161:
                                        case 162:
                                        case 163:
                                        case 164:
                                        case 165:
                                        case 166:
                                        case 167:
                                        case 169:
                                        case 170:
                                        case 171:
                                        case 172:
                                        case 173:
                                        case 175:
                                        case 176:
                                        case 177:
                                        case 179:
                                        case 180:
                                        case 181:
                                        case 182:
                                        case 183:
                                        case 184:
                                        case 185:
                                        case 186:
                                        case 187:
                                        case 188:
                                        case 189:
                                        case 190:
                                        case 191:
                                        case 197:
                                        case 198:
                                        case 199:
                                        case 200:
                                        case 201:
                                        case 204:
                                        case 205:
                                        case 206:
                                        case 207:
                                        case 212:
                                        case 213:
                                        case 214:
                                        case 215:
                                        case 216:
                                        case 217:
                                        case 218:
                                        case 219:
                                        case 220:
                                        case 221:
                                        case 222:
                                        case 223:
                                        case 224:
                                        case 225:
                                        case 226:
                                        case 227:
                                        case 228:
                                        case 229:
                                        case 230:
                                        case 231:
                                        case 232:
                                        case 233:
                                        case 234:
                                        case 235:
                                        case 236:
                                        case 237:
                                        case 240:
                                        case 241:
                                        case 243:
                                        case 244:
                                        case 245:
                                        case 246:
                                        case 247:
                                        case 248:
                                        case 249:
                                        case 250:
                                        case 251:
                                        case 253:
                                        case 256:
                                        case 257:
                                        case 258:
                                        case 259:
                                        case 261:
                                        case 262:
                                        case 263:
                                        case 264:
                                        case 265:
                                        case 266:
                                        case 267:
                                        case 268:
                                        case 269:
                                        case 270:
                                        case 271:
                                        case 272:
                                        case 273:
                                        case 274:
                                        case 276:
                                        case 277:
                                        case 278:
                                        case 279:
                                        case 280:
                                        case 281:
                                        case 282:
                                        case 284:
                                        case 285:
                                        case 286:
                                        case 287:
                                        case 288:
                                        case 289:
                                        case 290:
                                        case 291:
                                        case 292:
                                        case 293:
                                        case 294:
                                        case 295:
                                        case 296:
                                        case 297:
                                        case 298:
                                        case 299:
                                        case 300:
                                        case 301:
                                        case 302:
                                        case 303:
                                        case 304:
                                        case 305:
                                        case 306:
                                        case 308:
                                        case 309:
                                        case 310:
                                        case 311:
                                        case 312:
                                        case 313:
                                        case 314:
                                        case 315:
                                        case 316:
                                        case 317:
                                        case 318:
                                        case 319:
                                        case 320:
                                        case 321:
                                        case 322:
                                        case 323:
                                        case 324:
                                        case 325:
                                        case 326:
                                        case 327:
                                        case 328:
                                        case 329:
                                        case 330:
                                        case 331:
                                        case 332:
                                        case 333:
                                        case 334:
                                        case 335:
                                        case 336:
                                        case 337:
                                        case 338:
                                        case 339:
                                        case 340:
                                        case 341:
                                            var$5 = oncipj_Cypher_SymbolicNameOrStringParameterList($this);
                                            $qualifier = onciafn_Neo4jASTFactory_userQualifier($this.$astFactory, var$5);
                                            break j;
                                        case 86:
                                        case 101:
                                        case 102:
                                        case 103:
                                        case 134:
                                        case 135:
                                        case 136:
                                        case 151:
                                        case 168:
                                        case 174:
                                        case 178:
                                        case 192:
                                        case 193:
                                        case 194:
                                        case 195:
                                        case 196:
                                        case 202:
                                        case 203:
                                        case 208:
                                        case 209:
                                        case 210:
                                        case 211:
                                        case 238:
                                        case 239:
                                        case 242:
                                        case 252:
                                        case 254:
                                        case 255:
                                        case 260:
                                        case 275:
                                        case 283:
                                            break;
                                        case 307:
                                            oncipj_Cypher_jj_consume_token($this, 307);
                                            break j;
                                        default:
                                    }
                                    $this.$jj_la1.data[531] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                                oncipj_Cypher_jj_consume_token($this, 275);
                                break i;
                            default:
                        }
                        $this.$jj_la1.data[532] = $this.$jj_gen;
                    }
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_USER_IMPERSONATE);
                    break a;
                case 246:
                    oncipj_Cypher_jj_consume_token($this, 246);
                    oncipj_Cypher_jj_consume_token($this, 204);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_PRIVILEGE_ALL);
                    break a;
                case 259:
                    oncipj_Cypher_jj_consume_token($this, 259);
                    var$7 = $this.$jj_ntk;
                    if (var$7 == (-1))
                        var$7 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$7) {
                        case 271:
                            oncipj_Cypher_jj_consume_token($this, 271);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_ROLE_RENAME);
                            break a;
                        case 325:
                            oncipj_Cypher_jj_consume_token($this, 325);
                            var$5 = $this.$astFactory;
                            onciaf_ActionType_$callClinit();
                            var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_USER_RENAME);
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[530] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                case 284:
                    oncipj_Cypher_jj_consume_token($this, 284);
                    oncipj_Cypher_jj_consume_token($this, 204);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_SERVER_MANAGEMENT);
                    break a;
                case 325:
                    oncipj_Cypher_jj_consume_token($this, 325);
                    oncipj_Cypher_jj_consume_token($this, 204);
                    var$5 = $this.$astFactory;
                    onciaf_ActionType_$callClinit();
                    var$6 = onciafn_Neo4jASTFactory_privilegeAction0(var$5, onciaf_ActionType_USER_ALL);
                    break a;
                default:
            }
            $this.$jj_la1.data[533] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $rt_throw(oncipj_ParseException__init_());
        }
        oncipj_Cypher_jj_consume_token($this, 224);
        oncipj_Cypher_jj_consume_token($this, 122);
        return onciafn_Neo4jASTFactory_dbmsPrivilege($this.$astFactory, oncipj_Cypher_pos($this, $start), var$6, $qualifier, $immutable);
    }
    function oncipj_Cypher_executeFunctionQualifier($this, $start) {
        var var$2, var$3, var$4;
        $start = oncipj_Cypher_pos($this, $start);
        var$2 = oncipj_Cypher_globs($this);
        var$3 = ju_ArrayList__init_();
        var$4 = new onciafn_Neo4jASTFactory$functionQualifier$lambda$_202_0;
        var$4.$_0246 = var$3;
        var$4.$_167 = $start;
        ju_ArrayList_forEach(var$2, var$4);
        return var$3;
    }
    function oncipj_Cypher_executeProcedureQualifier($this, $start) {
        var var$2, var$3, var$4;
        $start = oncipj_Cypher_pos($this, $start);
        var$2 = oncipj_Cypher_globs($this);
        var$3 = ju_ArrayList__init_();
        var$4 = new onciafn_Neo4jASTFactory$procedureQualifier$lambda$_203_0;
        var$4.$_0247 = var$3;
        var$4.$_168 = $start;
        ju_ArrayList_forEach(var$2, var$4);
        return var$3;
    }
    function oncipj_Cypher_globs($this) {
        var $executableList, var$2;
        $executableList = ju_ArrayList__init_();
        ju_ArrayList_add($executableList, oncipj_Cypher_Glob($this));
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($executableList, oncipj_Cypher_Glob($this));
        }
        $this.$jj_la1.data[534] = $this.$jj_gen;
        return $executableList;
    }
    function oncipj_Cypher_labelResource($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$1) {
            case 68:
            case 69:
            case 70:
            case 71:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
            case 78:
            case 79:
            case 80:
            case 81:
            case 82:
            case 83:
            case 84:
            case 85:
            case 87:
            case 88:
            case 89:
            case 90:
            case 91:
            case 92:
            case 93:
            case 94:
            case 95:
            case 96:
            case 97:
            case 98:
            case 99:
            case 100:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
            case 110:
            case 111:
            case 112:
            case 113:
            case 114:
            case 115:
            case 116:
            case 117:
            case 118:
            case 119:
            case 120:
            case 121:
            case 122:
            case 123:
            case 124:
            case 125:
            case 126:
            case 127:
            case 128:
            case 129:
            case 130:
            case 132:
            case 133:
            case 137:
            case 138:
            case 139:
            case 140:
            case 141:
            case 142:
            case 143:
            case 144:
            case 145:
            case 146:
            case 147:
            case 148:
            case 149:
            case 150:
            case 152:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
            case 160:
            case 161:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
            case 167:
            case 169:
            case 170:
            case 171:
            case 172:
            case 173:
            case 175:
            case 176:
            case 177:
            case 179:
            case 180:
            case 181:
            case 182:
            case 183:
            case 184:
            case 185:
            case 186:
            case 187:
            case 188:
            case 189:
            case 190:
            case 191:
            case 197:
            case 198:
            case 199:
            case 200:
            case 201:
            case 204:
            case 205:
            case 206:
            case 207:
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 218:
            case 219:
            case 220:
            case 221:
            case 222:
            case 223:
            case 224:
            case 225:
            case 226:
            case 227:
            case 228:
            case 229:
            case 230:
            case 231:
            case 232:
            case 233:
            case 234:
            case 235:
            case 236:
            case 237:
            case 240:
            case 241:
            case 243:
            case 244:
            case 245:
            case 246:
            case 247:
            case 248:
            case 249:
            case 250:
            case 251:
            case 253:
            case 256:
            case 257:
            case 258:
            case 259:
            case 261:
            case 262:
            case 263:
            case 264:
            case 265:
            case 266:
            case 267:
            case 268:
            case 269:
            case 270:
            case 271:
            case 272:
            case 273:
            case 274:
            case 276:
            case 277:
            case 278:
            case 279:
            case 280:
            case 281:
            case 282:
            case 284:
            case 285:
            case 286:
            case 287:
            case 288:
            case 289:
            case 290:
            case 291:
            case 292:
            case 293:
            case 294:
            case 295:
            case 296:
            case 297:
            case 298:
            case 299:
            case 300:
            case 301:
            case 302:
            case 303:
            case 304:
            case 305:
            case 306:
            case 308:
            case 309:
            case 310:
            case 311:
            case 312:
            case 313:
            case 314:
            case 315:
            case 316:
            case 317:
            case 318:
            case 319:
            case 320:
            case 321:
            case 322:
            case 323:
            case 324:
            case 325:
            case 326:
            case 327:
            case 328:
            case 329:
            case 330:
            case 331:
            case 332:
            case 333:
            case 334:
            case 335:
            case 336:
            case 337:
            case 338:
            case 339:
            case 340:
            case 341:
                var$2 = oncipj_Cypher_SymbolicNameList1($this);
                var$3 = oncipj_Cypher_pos($this, $this.$token);
                var$4 = new oncia_LabelsResource;
                var$4.$labels0 = sc_IterableOnceOps_toSeq$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$2)));
                var$4.$position34 = var$3;
                return var$4;
            case 86:
            case 101:
            case 102:
            case 103:
            case 131:
            case 134:
            case 135:
            case 136:
            case 151:
            case 168:
            case 174:
            case 178:
            case 192:
            case 193:
            case 194:
            case 195:
            case 196:
            case 202:
            case 203:
            case 208:
            case 209:
            case 210:
            case 211:
            case 238:
            case 239:
            case 242:
            case 252:
            case 254:
            case 255:
            case 260:
            case 275:
            case 283:
                break;
            case 307:
                oncipj_Cypher_jj_consume_token($this, 307);
                var$2 = oncipj_Cypher_pos($this, $this.$token);
                var$3 = new oncia_AllLabelResource;
                var$3.$position35 = var$2;
                return var$3;
            default:
        }
        $this.$jj_la1.data[538] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        var$2 = new oncipj_ParseException;
        jl_Throwable__init_0(var$2);
        $rt_throw(var$2);
    }
    function oncipj_Cypher_propertyResource($this) {
        var var$1, var$2, var$3, var$4;
        oncipj_Cypher_jj_consume_token($this, 195);
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    var$2 = oncipj_Cypher_SymbolicNameList1($this);
                    var$3 = oncipj_Cypher_pos($this, $this.$token);
                    var$4 = new oncia_PropertiesResource;
                    var$4.$properties2 = sc_IterableOnceOps_toSeq$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$2)));
                    var$4.$position36 = var$3;
                    break a;
                case 86:
                case 101:
                case 102:
                case 103:
                case 131:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                    break;
                case 307:
                    oncipj_Cypher_jj_consume_token($this, 307);
                    var$2 = oncipj_Cypher_pos($this, $this.$token);
                    var$4 = new oncia_AllPropertyResource;
                    var$4.$position37 = var$2;
                    break a;
                default:
            }
            $this.$jj_la1.data[539] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            var$2 = new oncipj_ParseException;
            jl_Throwable__init_0(var$2);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_consume_token($this, 255);
        return var$4;
    }
    function oncipj_Cypher_graphQualifier($this) {
        var $qualifier, $v, $labels, var$4, var$5, var$6, $labelQualifiers, $label;
        $qualifier = ju_ArrayList__init_();
        $v = null;
        $labels = null;
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 145:
                case 146:
                case 162:
                case 216:
                case 217:
                case 262:
                case 263:
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$4) {
                        case 145:
                        case 146:
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            b: {
                                switch (var$4) {
                                    case 145:
                                        oncipj_Cypher_jj_consume_token($this, 145);
                                        break b;
                                    case 146:
                                        oncipj_Cypher_jj_consume_token($this, 146);
                                        break b;
                                    default:
                                }
                                $this.$jj_la1.data[546] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    $v = oncipj_Cypher_SymbolicNameString($this);
                                    ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_elementQualifier($this.$astFactory, oncipj_Cypher_pos($this, $v), $v.$image0));
                                    c: while (true) {
                                        var$4 = $this.$jj_ntk;
                                        if (var$4 == (-1))
                                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$4) {
                                            case 103:
                                                break;
                                            default:
                                                break c;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 103);
                                        $v = oncipj_Cypher_SymbolicNameString($this);
                                        ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_elementQualifier($this.$astFactory, oncipj_Cypher_pos($this, $v), $v.$image0));
                                    }
                                    $this.$jj_la1.data[547] = $this.$jj_gen;
                                    break a;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                    break;
                                case 307:
                                    oncipj_Cypher_jj_consume_token($this, 307);
                                    ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_allElementsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $this.$token)));
                                    break a;
                                default:
                            }
                            $this.$jj_la1.data[548] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        case 162:
                            oncipj_Cypher_jj_consume_token($this, 162);
                            oncipj_Cypher_jj_consume_token($this, 202);
                            var$5 = $this.$jj_ntk;
                            if (var$5 == (-1))
                                var$5 = oncipj_Cypher_jj_ntk_f($this);
                            d: {
                                e: {
                                    switch (var$5) {
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 71:
                                        case 72:
                                        case 73:
                                        case 74:
                                        case 75:
                                        case 76:
                                        case 77:
                                        case 78:
                                        case 79:
                                        case 80:
                                        case 81:
                                        case 82:
                                        case 83:
                                        case 84:
                                        case 85:
                                        case 87:
                                        case 88:
                                        case 89:
                                        case 90:
                                        case 91:
                                        case 92:
                                        case 93:
                                        case 94:
                                        case 95:
                                        case 96:
                                        case 97:
                                        case 98:
                                        case 99:
                                        case 100:
                                        case 104:
                                        case 105:
                                        case 106:
                                        case 107:
                                        case 108:
                                        case 109:
                                        case 110:
                                        case 111:
                                        case 112:
                                        case 113:
                                        case 114:
                                        case 115:
                                        case 116:
                                        case 117:
                                        case 118:
                                        case 119:
                                        case 120:
                                        case 121:
                                        case 122:
                                        case 123:
                                        case 124:
                                        case 125:
                                        case 126:
                                        case 127:
                                        case 128:
                                        case 129:
                                        case 130:
                                        case 132:
                                        case 133:
                                        case 137:
                                        case 138:
                                        case 139:
                                        case 140:
                                        case 141:
                                        case 142:
                                        case 143:
                                        case 144:
                                        case 145:
                                        case 146:
                                        case 147:
                                        case 148:
                                        case 149:
                                        case 150:
                                        case 152:
                                        case 153:
                                        case 154:
                                        case 155:
                                        case 156:
                                        case 157:
                                        case 158:
                                        case 159:
                                        case 160:
                                        case 161:
                                        case 162:
                                        case 163:
                                        case 164:
                                        case 165:
                                        case 166:
                                        case 167:
                                        case 169:
                                        case 170:
                                        case 171:
                                        case 172:
                                        case 173:
                                        case 175:
                                        case 176:
                                        case 177:
                                        case 179:
                                        case 180:
                                        case 181:
                                        case 182:
                                        case 183:
                                        case 184:
                                        case 185:
                                        case 186:
                                        case 187:
                                        case 188:
                                        case 189:
                                        case 190:
                                        case 191:
                                        case 197:
                                        case 198:
                                        case 199:
                                        case 200:
                                        case 201:
                                        case 204:
                                        case 205:
                                        case 206:
                                        case 207:
                                        case 212:
                                        case 213:
                                        case 214:
                                        case 215:
                                        case 216:
                                        case 217:
                                        case 218:
                                        case 219:
                                        case 220:
                                        case 221:
                                        case 222:
                                        case 223:
                                        case 224:
                                        case 225:
                                        case 226:
                                        case 227:
                                        case 228:
                                        case 229:
                                        case 230:
                                        case 231:
                                        case 232:
                                        case 233:
                                        case 234:
                                        case 235:
                                        case 236:
                                        case 237:
                                        case 240:
                                        case 241:
                                        case 243:
                                        case 244:
                                        case 245:
                                        case 246:
                                        case 247:
                                        case 248:
                                        case 249:
                                        case 250:
                                        case 251:
                                        case 253:
                                        case 256:
                                        case 257:
                                        case 258:
                                        case 259:
                                        case 261:
                                        case 262:
                                        case 263:
                                        case 264:
                                        case 265:
                                        case 266:
                                        case 267:
                                        case 268:
                                        case 269:
                                        case 270:
                                        case 271:
                                        case 272:
                                        case 273:
                                        case 274:
                                        case 276:
                                        case 277:
                                        case 278:
                                        case 279:
                                        case 280:
                                        case 281:
                                        case 282:
                                        case 284:
                                        case 285:
                                        case 286:
                                        case 287:
                                        case 288:
                                        case 289:
                                        case 290:
                                        case 291:
                                        case 292:
                                        case 293:
                                        case 294:
                                        case 295:
                                        case 296:
                                        case 297:
                                        case 298:
                                        case 299:
                                        case 300:
                                        case 301:
                                        case 302:
                                        case 303:
                                        case 304:
                                        case 305:
                                        case 306:
                                        case 308:
                                        case 309:
                                        case 310:
                                        case 311:
                                        case 312:
                                        case 313:
                                        case 314:
                                        case 315:
                                        case 316:
                                        case 317:
                                        case 318:
                                        case 319:
                                        case 320:
                                        case 321:
                                        case 322:
                                        case 323:
                                        case 324:
                                        case 325:
                                        case 326:
                                        case 327:
                                        case 328:
                                        case 329:
                                        case 330:
                                        case 331:
                                        case 332:
                                        case 333:
                                        case 334:
                                        case 335:
                                        case 336:
                                        case 337:
                                        case 338:
                                        case 339:
                                        case 340:
                                        case 341:
                                            break;
                                        case 86:
                                        case 101:
                                        case 102:
                                        case 103:
                                        case 131:
                                        case 134:
                                        case 135:
                                        case 136:
                                        case 151:
                                        case 168:
                                        case 174:
                                        case 178:
                                        case 192:
                                        case 193:
                                        case 194:
                                        case 195:
                                        case 196:
                                        case 202:
                                        case 203:
                                        case 208:
                                        case 209:
                                        case 210:
                                        case 211:
                                        case 238:
                                        case 239:
                                        case 242:
                                        case 252:
                                        case 254:
                                        case 255:
                                        case 260:
                                        case 275:
                                        case 283:
                                        case 307:
                                            break e;
                                        default:
                                            break e;
                                    }
                                    $v = oncipj_Cypher_Variable($this);
                                    break d;
                                }
                                $this.$jj_la1.data[549] = $this.$jj_gen;
                            }
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            f: {
                                switch (var$4) {
                                    case 101:
                                        break;
                                    default:
                                        $this.$jj_la1.data[550] = $this.$jj_gen;
                                        break f;
                                }
                                $labels = oncipj_Cypher_LabelOrRelTypes($this);
                            }
                            g: {
                                if (oncipj_Cypher_jj_2_136($this, 2147483647)) {
                                    oncipj_Cypher_jj_consume_token($this, 275);
                                    oncipj_Cypher_jj_consume_token($this, 334);
                                    var$6 = oncipj_Cypher_Expression($this);
                                } else if (oncipj_Cypher_jj_2_137($this, 2147483647)) {
                                    oncipj_Cypher_jj_consume_token($this, 334);
                                    var$6 = oncipj_Cypher_Expression($this);
                                    oncipj_Cypher_jj_consume_token($this, 275);
                                } else {
                                    var$4 = $this.$jj_ntk;
                                    if (var$4 == (-1))
                                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$4) {
                                        case 195:
                                            var$6 = oncipj_Cypher_MapLiteral($this);
                                            oncipj_Cypher_jj_consume_token($this, 275);
                                            break g;
                                        default:
                                    }
                                    $this.$jj_la1.data[551] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                                }
                            }
                            h: {
                                $labelQualifiers = ju_ArrayList__init_();
                                if ($labels === null)
                                    ju_ArrayList_add($labelQualifiers, onciafn_Neo4jASTFactory_allLabelsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $this.$token)));
                                else {
                                    $labels = ju_AbstractList_iterator($labels);
                                    while (true) {
                                        if (!ju_AbstractList$1_hasNext($labels))
                                            break h;
                                        $label = ju_AbstractList$1_next($labels);
                                        ju_ArrayList_add($labelQualifiers, onciafn_Neo4jASTFactory_labelQualifier($this.$astFactory, $label.$pos, $label.$string0));
                                    }
                                }
                            }
                            ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_patternQualifier($this.$astFactory, $labelQualifiers, $v, var$6));
                            break a;
                        case 216:
                        case 217:
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            i: {
                                switch (var$4) {
                                    case 216:
                                        oncipj_Cypher_jj_consume_token($this, 216);
                                        break i;
                                    case 217:
                                        oncipj_Cypher_jj_consume_token($this, 217);
                                        break i;
                                    default:
                                }
                                $this.$jj_la1.data[543] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    $v = oncipj_Cypher_SymbolicNameString($this);
                                    ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_labelQualifier($this.$astFactory, oncipj_Cypher_pos($this, $v), $v.$image0));
                                    j: while (true) {
                                        var$4 = $this.$jj_ntk;
                                        if (var$4 == (-1))
                                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$4) {
                                            case 103:
                                                break;
                                            default:
                                                break j;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 103);
                                        $v = oncipj_Cypher_SymbolicNameString($this);
                                        ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_labelQualifier($this.$astFactory, oncipj_Cypher_pos($this, $v), $v.$image0));
                                    }
                                    $this.$jj_la1.data[544] = $this.$jj_gen;
                                    break a;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                    break;
                                case 307:
                                    oncipj_Cypher_jj_consume_token($this, 307);
                                    ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_allLabelsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $this.$token)));
                                    break a;
                                default:
                            }
                            $this.$jj_la1.data[545] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        case 262:
                        case 263:
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            k: {
                                switch (var$4) {
                                    case 262:
                                        oncipj_Cypher_jj_consume_token($this, 262);
                                        break k;
                                    case 263:
                                        oncipj_Cypher_jj_consume_token($this, 263);
                                        break k;
                                    default:
                                }
                                $this.$jj_la1.data[540] = $this.$jj_gen;
                                oncipj_Cypher_jj_consume_token($this, (-1));
                                $rt_throw(oncipj_ParseException__init_());
                            }
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 68:
                                case 69:
                                case 70:
                                case 71:
                                case 72:
                                case 73:
                                case 74:
                                case 75:
                                case 76:
                                case 77:
                                case 78:
                                case 79:
                                case 80:
                                case 81:
                                case 82:
                                case 83:
                                case 84:
                                case 85:
                                case 87:
                                case 88:
                                case 89:
                                case 90:
                                case 91:
                                case 92:
                                case 93:
                                case 94:
                                case 95:
                                case 96:
                                case 97:
                                case 98:
                                case 99:
                                case 100:
                                case 104:
                                case 105:
                                case 106:
                                case 107:
                                case 108:
                                case 109:
                                case 110:
                                case 111:
                                case 112:
                                case 113:
                                case 114:
                                case 115:
                                case 116:
                                case 117:
                                case 118:
                                case 119:
                                case 120:
                                case 121:
                                case 122:
                                case 123:
                                case 124:
                                case 125:
                                case 126:
                                case 127:
                                case 128:
                                case 129:
                                case 130:
                                case 132:
                                case 133:
                                case 137:
                                case 138:
                                case 139:
                                case 140:
                                case 141:
                                case 142:
                                case 143:
                                case 144:
                                case 145:
                                case 146:
                                case 147:
                                case 148:
                                case 149:
                                case 150:
                                case 152:
                                case 153:
                                case 154:
                                case 155:
                                case 156:
                                case 157:
                                case 158:
                                case 159:
                                case 160:
                                case 161:
                                case 162:
                                case 163:
                                case 164:
                                case 165:
                                case 166:
                                case 167:
                                case 169:
                                case 170:
                                case 171:
                                case 172:
                                case 173:
                                case 175:
                                case 176:
                                case 177:
                                case 179:
                                case 180:
                                case 181:
                                case 182:
                                case 183:
                                case 184:
                                case 185:
                                case 186:
                                case 187:
                                case 188:
                                case 189:
                                case 190:
                                case 191:
                                case 197:
                                case 198:
                                case 199:
                                case 200:
                                case 201:
                                case 204:
                                case 205:
                                case 206:
                                case 207:
                                case 212:
                                case 213:
                                case 214:
                                case 215:
                                case 216:
                                case 217:
                                case 218:
                                case 219:
                                case 220:
                                case 221:
                                case 222:
                                case 223:
                                case 224:
                                case 225:
                                case 226:
                                case 227:
                                case 228:
                                case 229:
                                case 230:
                                case 231:
                                case 232:
                                case 233:
                                case 234:
                                case 235:
                                case 236:
                                case 237:
                                case 240:
                                case 241:
                                case 243:
                                case 244:
                                case 245:
                                case 246:
                                case 247:
                                case 248:
                                case 249:
                                case 250:
                                case 251:
                                case 253:
                                case 256:
                                case 257:
                                case 258:
                                case 259:
                                case 261:
                                case 262:
                                case 263:
                                case 264:
                                case 265:
                                case 266:
                                case 267:
                                case 268:
                                case 269:
                                case 270:
                                case 271:
                                case 272:
                                case 273:
                                case 274:
                                case 276:
                                case 277:
                                case 278:
                                case 279:
                                case 280:
                                case 281:
                                case 282:
                                case 284:
                                case 285:
                                case 286:
                                case 287:
                                case 288:
                                case 289:
                                case 290:
                                case 291:
                                case 292:
                                case 293:
                                case 294:
                                case 295:
                                case 296:
                                case 297:
                                case 298:
                                case 299:
                                case 300:
                                case 301:
                                case 302:
                                case 303:
                                case 304:
                                case 305:
                                case 306:
                                case 308:
                                case 309:
                                case 310:
                                case 311:
                                case 312:
                                case 313:
                                case 314:
                                case 315:
                                case 316:
                                case 317:
                                case 318:
                                case 319:
                                case 320:
                                case 321:
                                case 322:
                                case 323:
                                case 324:
                                case 325:
                                case 326:
                                case 327:
                                case 328:
                                case 329:
                                case 330:
                                case 331:
                                case 332:
                                case 333:
                                case 334:
                                case 335:
                                case 336:
                                case 337:
                                case 338:
                                case 339:
                                case 340:
                                case 341:
                                    $v = oncipj_Cypher_SymbolicNameString($this);
                                    ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_relationshipQualifier($this.$astFactory, oncipj_Cypher_pos($this, $v), $v.$image0));
                                    l: while (true) {
                                        var$4 = $this.$jj_ntk;
                                        if (var$4 == (-1))
                                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$4) {
                                            case 103:
                                                break;
                                            default:
                                                break l;
                                        }
                                        oncipj_Cypher_jj_consume_token($this, 103);
                                        $v = oncipj_Cypher_SymbolicNameString($this);
                                        ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_relationshipQualifier($this.$astFactory, oncipj_Cypher_pos($this, $v), $v.$image0));
                                    }
                                    $this.$jj_la1.data[541] = $this.$jj_gen;
                                    break a;
                                case 86:
                                case 101:
                                case 102:
                                case 103:
                                case 131:
                                case 134:
                                case 135:
                                case 136:
                                case 151:
                                case 168:
                                case 174:
                                case 178:
                                case 192:
                                case 193:
                                case 194:
                                case 195:
                                case 196:
                                case 202:
                                case 203:
                                case 208:
                                case 209:
                                case 210:
                                case 211:
                                case 238:
                                case 239:
                                case 242:
                                case 252:
                                case 254:
                                case 255:
                                case 260:
                                case 275:
                                case 283:
                                    break;
                                case 307:
                                    oncipj_Cypher_jj_consume_token($this, 307);
                                    ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_allRelationshipsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $this.$token)));
                                    break a;
                                default:
                            }
                            $this.$jj_la1.data[542] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $rt_throw(oncipj_ParseException__init_());
                        default:
                    }
                    $this.$jj_la1.data[552] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                default:
            }
            $this.$jj_la1.data[553] = $this.$jj_gen;
        }
        if (ju_AbstractCollection_isEmpty($qualifier))
            ju_ArrayList_add($qualifier, onciafn_Neo4jASTFactory_allElementsQualifier($this.$astFactory, oncipj_Cypher_pos($this, $this.$token)));
        return $qualifier;
    }
    function oncipj_Cypher_CreateDatabase($this, $start, $replace) {
        var $ifNotExists, $wait, $options, $primaries, $secondaries, var$8, var$9, var$10, var$11, var$12, $topologyMultiplePrimaryError, $topologyMultipleSecondaryError;
        $ifNotExists = 0;
        $wait = onciafn_Neo4jASTFactory_wait($this.$astFactory, 0, Long_fromInt(-1));
        $options = null;
        $primaries = null;
        $secondaries = null;
        oncipj_Cypher_jj_consume_token($this, 118);
        var$8 = oncipj_Cypher_SymbolicAliasName($this);
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$9) {
                case 177:
                    oncipj_Cypher_jj_consume_token($this, 177);
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 156);
                    $ifNotExists = 1;
                    break a;
                default:
            }
            $this.$jj_la1.data[554] = $this.$jj_gen;
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$9) {
                case 311:
                    oncipj_Cypher_jj_consume_token($this, 311);
                    c: while (true) {
                        var$10 = oncipj_Cypher_jj_consume_token($this, 36);
                        var$9 = $this.$jj_ntk;
                        if (var$9 == (-1))
                            var$9 = oncipj_Cypher_jj_ntk_f($this);
                        d: {
                            switch (var$9) {
                                case 244:
                                case 245:
                                    var$9 = $this.$jj_ntk;
                                    if (var$9 == (-1))
                                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                                    e: {
                                        switch (var$9) {
                                            case 244:
                                                break;
                                            case 245:
                                                var$11 = oncipj_Cypher_jj_consume_token($this, 245);
                                                break e;
                                            default:
                                                break c;
                                        }
                                        var$11 = oncipj_Cypher_jj_consume_token($this, 244);
                                    }
                                    oncipj_Cypher_assertNotAlreadySet($this, $primaries, var$11, $rt_s(941));
                                    $primaries = var$10;
                                    var$10 = $secondaries;
                                    break d;
                                case 279:
                                case 280:
                                    break;
                                default:
                                    $this.$jj_la1.data[557] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                            }
                            var$12 = $this.$jj_ntk;
                            if (var$12 == (-1))
                                var$12 = oncipj_Cypher_jj_ntk_f($this);
                            f: {
                                switch (var$12) {
                                    case 279:
                                        break;
                                    case 280:
                                        var$11 = oncipj_Cypher_jj_consume_token($this, 280);
                                        break f;
                                    default:
                                        $this.$jj_la1.data[556] = $this.$jj_gen;
                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                        $start = new oncipj_ParseException;
                                        jl_Throwable__init_0($start);
                                        $rt_throw($start);
                                }
                                var$11 = oncipj_Cypher_jj_consume_token($this, 279);
                            }
                            oncipj_Cypher_assertNotAlreadySet($this, $secondaries, var$11, $rt_s(942));
                        }
                        var$12 = $this.$jj_ntk;
                        if (var$12 == (-1))
                            var$12 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$12) {
                            case 36:
                                break;
                            default:
                                $this.$jj_la1.data[558] = $this.$jj_gen;
                                $secondaries = var$10;
                                break b;
                        }
                        $secondaries = var$10;
                    }
                    $this.$jj_la1.data[555] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[559] = $this.$jj_gen;
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        g: {
            switch (var$9) {
                case 227:
                    break;
                default:
                    $this.$jj_la1.data[560] = $this.$jj_gen;
                    break g;
            }
            $options = oncipj_Cypher_Options($this);
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        h: {
            switch (var$9) {
                case 221:
                case 332:
                    break;
                default:
                    $this.$jj_la1.data[561] = $this.$jj_gen;
                    break h;
            }
            $wait = oncipj_Cypher_WaitClause($this);
        }
        $topologyMultiplePrimaryError = $this.$astFactory;
        $topologyMultipleSecondaryError = oncipj_Cypher_pos($this, $start);
        var$8 = oncipj_AliasName_getLocalAliasName(var$8, $this.$astFactory);
        var$11 = $primaries === null ? null : jl_Integer_valueOf(jl_Integer_parseInt0($primaries.$image0));
        $start = $secondaries === null ? null : jl_Integer_valueOf(jl_Integer_parseInt0($secondaries.$image0));
        $primaries = s_Option_map(s_Option$_apply(s_Option$_MODULE$, var$11), new onciafn_Neo4jASTFactory$createDatabase$lambda$_214_0);
        $start = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $start), new onciafn_Neo4jASTFactory$createDatabase$lambda$_214_1);
        return oncia_CreateDatabase__init_(var$8, onciafn_Neo4jASTFactory_ifExistsDo($topologyMultiplePrimaryError, $replace, $ifNotExists), onciafn_Neo4jASTFactory_asOptionsAst($topologyMultiplePrimaryError, $options), $wait, !s_Option_isDefined($primaries) && !s_Option_isDefined($start) ? s_None$_MODULE$ : s_Some__init_(oncia_Topology__init_($primaries, $start)), $topologyMultipleSecondaryError);
    }
    function oncipj_Cypher_Options($this) {
        oncipj_Cypher_jj_consume_token($this, 227);
        return oncipj_Cypher_MapOrParameter($this);
    }
    function oncipj_Cypher_DropDatabase($this, $start) {
        var $ifExists, $wait, $dumpData, $composite, var$6, var$7;
        $ifExists = 0;
        $wait = onciafn_Neo4jASTFactory_wait($this.$astFactory, 0, Long_fromInt(-1));
        $dumpData = 0;
        $composite = 0;
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$6) {
                case 107:
                    break;
                default:
                    $this.$jj_la1.data[565] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 107);
            $composite = 1;
        }
        oncipj_Cypher_jj_consume_token($this, 118);
        var$7 = oncipj_Cypher_SymbolicAliasName($this);
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$6) {
                case 177:
                    break;
                default:
                    $this.$jj_la1.data[566] = $this.$jj_gen;
                    break b;
            }
            oncipj_Cypher_jj_consume_token($this, 177);
            oncipj_Cypher_jj_consume_token($this, 156);
            $ifExists = 1;
        }
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$6) {
                case 129:
                case 140:
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    d: {
                        switch (var$6) {
                            case 129:
                                oncipj_Cypher_jj_consume_token($this, 129);
                                break d;
                            case 140:
                                oncipj_Cypher_jj_consume_token($this, 140);
                                $dumpData = 1;
                                break d;
                            default:
                        }
                        $this.$jj_la1.data[567] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    oncipj_Cypher_jj_consume_token($this, 117);
                    break c;
                default:
            }
            $this.$jj_la1.data[568] = $this.$jj_gen;
        }
        var$6 = $this.$jj_ntk;
        if (var$6 == (-1))
            var$6 = oncipj_Cypher_jj_ntk_f($this);
        e: {
            switch (var$6) {
                case 221:
                case 332:
                    break;
                default:
                    $this.$jj_la1.data[569] = $this.$jj_gen;
                    break e;
            }
            $wait = oncipj_Cypher_WaitClause($this);
        }
        $start = oncipj_Cypher_pos($this, $start);
        return oncia_DropDatabase__init_(oncipj_AliasName_getLocalAliasName(var$7, $this.$astFactory), $ifExists, $composite, !$dumpData ? oncia_DestroyData$_MODULE$ : oncia_DumpData$_MODULE$, $wait, $start);
    }
    function oncipj_Cypher_AlterDatabase($this, $start) {
        var $ifExists, $accessType, $primaries, $secondaries, $count, $options, $optionsToRemove, $wait, var$10, var$11, var$12, var$13, $entryOrNull, var$15, $topologyMultiplePrimaryError, var$17, var$18;
        $ifExists = 0;
        $accessType = null;
        $primaries = null;
        $secondaries = null;
        $count = null;
        $options = null;
        $optionsToRemove = ju_LinkedHashSet__init_();
        $wait = onciafn_Neo4jASTFactory_wait($this.$astFactory, 0, Long_fromInt(-1));
        oncipj_Cypher_jj_consume_token($this, 118);
        var$10 = oncipj_Cypher_SymbolicAliasName($this);
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$11) {
                case 177:
                    break;
                default:
                    $this.$jj_la1.data[570] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 177);
            oncipj_Cypher_jj_consume_token($this, 156);
            $ifExists = 1;
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$11) {
                case 264:
                    c: while (true) {
                        var$12 = oncipj_Cypher_jj_consume_token($this, 264);
                        oncipj_Cypher_jj_consume_token($this, 228);
                        var$13 = oncipj_Cypher_SymbolicNameString($this);
                        $entryOrNull = !ju_HashSet_contains($optionsToRemove, var$13.$image0) ? null : var$13.$image0;
                        var$15 = var$13.$image0;
                        $topologyMultiplePrimaryError = jl_StringBuilder__init_1();
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($topologyMultiplePrimaryError, $rt_s(943)), var$15), $rt_s(944));
                        oncipj_Cypher_assertNotAlreadySet($this, $entryOrNull, var$12, jl_StringBuilder_toString($topologyMultiplePrimaryError));
                        ju_HashSet_add($optionsToRemove, var$13.$image0);
                        var$11 = $this.$jj_ntk;
                        if (var$11 == (-1))
                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$11) {
                            case 264:
                                break;
                            default:
                                break c;
                        }
                    }
                    $this.$jj_la1.data[578] = $this.$jj_gen;
                    break b;
                case 286:
                    d: while (true) {
                        var$17 = oncipj_Cypher_jj_consume_token($this, 286);
                        var$11 = $this.$jj_ntk;
                        if (var$11 == (-1))
                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                        e: {
                            switch (var$11) {
                                case 69:
                                    oncipj_Cypher_jj_consume_token($this, 69);
                                    oncipj_Cypher_assertNotAlreadySet($this, $accessType, var$17, $rt_s(945));
                                    oncipj_Cypher_jj_consume_token($this, 256);
                                    var$11 = $this.$jj_ntk;
                                    if (var$11 == (-1))
                                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$11) {
                                        case 225:
                                            break;
                                        case 337:
                                            oncipj_Cypher_jj_consume_token($this, 337);
                                            onciaf_AccessType_$callClinit();
                                            $accessType = onciaf_AccessType_READ_WRITE;
                                            break e;
                                        default:
                                            break d;
                                    }
                                    oncipj_Cypher_jj_consume_token($this, 225);
                                    onciaf_AccessType_$callClinit();
                                    $accessType = onciaf_AccessType_READ_ONLY;
                                    break e;
                                case 228:
                                    break;
                                case 311:
                                    oncipj_Cypher_jj_consume_token($this, 311);
                                    oncipj_Cypher_assertNotAlreadySet($this, $count, var$17, $rt_s(946));
                                    f: while (true) {
                                        $count = oncipj_Cypher_jj_consume_token($this, 36);
                                        var$11 = $this.$jj_ntk;
                                        if (var$11 == (-1))
                                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                                        g: {
                                            switch (var$11) {
                                                case 244:
                                                case 245:
                                                    break;
                                                case 279:
                                                case 280:
                                                    var$11 = $this.$jj_ntk;
                                                    if (var$11 == (-1))
                                                        var$11 = oncipj_Cypher_jj_ntk_f($this);
                                                    h: {
                                                        switch (var$11) {
                                                            case 279:
                                                                break;
                                                            case 280:
                                                                var$13 = oncipj_Cypher_jj_consume_token($this, 280);
                                                                break h;
                                                            default:
                                                                $this.$jj_la1.data[573] = $this.$jj_gen;
                                                                oncipj_Cypher_jj_consume_token($this, (-1));
                                                                $rt_throw(oncipj_ParseException__init_());
                                                        }
                                                        var$13 = oncipj_Cypher_jj_consume_token($this, 279);
                                                    }
                                                    oncipj_Cypher_assertNotAlreadySet($this, $secondaries, var$13, $rt_s(942));
                                                    $secondaries = $count;
                                                    break g;
                                                default:
                                                    $this.$jj_la1.data[574] = $this.$jj_gen;
                                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                                    $rt_throw(oncipj_ParseException__init_());
                                            }
                                            var$11 = $this.$jj_ntk;
                                            if (var$11 == (-1))
                                                var$11 = oncipj_Cypher_jj_ntk_f($this);
                                            i: {
                                                switch (var$11) {
                                                    case 244:
                                                        break;
                                                    case 245:
                                                        var$13 = oncipj_Cypher_jj_consume_token($this, 245);
                                                        break i;
                                                    default:
                                                        $this.$jj_la1.data[572] = $this.$jj_gen;
                                                        oncipj_Cypher_jj_consume_token($this, (-1));
                                                        $rt_throw(oncipj_ParseException__init_());
                                                }
                                                var$13 = oncipj_Cypher_jj_consume_token($this, 244);
                                            }
                                            oncipj_Cypher_assertNotAlreadySet($this, $primaries, var$13, $rt_s(941));
                                            $primaries = $count;
                                        }
                                        var$11 = $this.$jj_ntk;
                                        if (var$11 == (-1))
                                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                                        switch (var$11) {
                                            case 36:
                                                break;
                                            default:
                                                break f;
                                        }
                                    }
                                    $this.$jj_la1.data[575] = $this.$jj_gen;
                                    break e;
                                default:
                                    $this.$jj_la1.data[576] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $rt_throw(oncipj_ParseException__init_());
                            }
                            oncipj_Cypher_jj_consume_token($this, 228);
                            var$13 = oncipj_Cypher_SymbolicNameString($this);
                            $entryOrNull = oncipj_Cypher_Expression($this);
                            if ($options === null)
                                $options = ju_LinkedHashMap__init_();
                            var$15 = ju_Map_getOrDefault($options, var$13.$image0, null);
                            var$12 = var$13.$image0;
                            var$18 = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$18, $rt_s(947)), var$12), $rt_s(944));
                            oncipj_Cypher_assertNotAlreadySet($this, var$15, var$17, jl_StringBuilder_toString(var$18));
                            ju_LinkedHashMap_put($options, var$13.$image0, $entryOrNull);
                        }
                        var$11 = $this.$jj_ntk;
                        if (var$11 == (-1))
                            var$11 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$11) {
                            case 286:
                                break;
                            default:
                                $this.$jj_la1.data[577] = $this.$jj_gen;
                                break b;
                        }
                    }
                    $this.$jj_la1.data[571] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $rt_throw(oncipj_ParseException__init_());
                default:
            }
            $this.$jj_la1.data[579] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $rt_throw(oncipj_ParseException__init_());
        }
        var$11 = $this.$jj_ntk;
        if (var$11 == (-1))
            var$11 = oncipj_Cypher_jj_ntk_f($this);
        j: {
            switch (var$11) {
                case 221:
                case 332:
                    break;
                default:
                    $this.$jj_la1.data[580] = $this.$jj_gen;
                    break j;
            }
            $wait = oncipj_Cypher_WaitClause($this);
        }
        return onciafn_Neo4jASTFactory_alterDatabase($this.$astFactory, oncipj_Cypher_pos($this, $start), oncipj_AliasName_getLocalAliasName(var$10, $this.$astFactory), $ifExists, $accessType, $primaries === null ? null : jl_Integer_valueOf(jl_Integer_parseInt0($primaries.$image0)), $secondaries === null ? null : jl_Integer_valueOf(jl_Integer_parseInt0($secondaries.$image0)), $options, $optionsToRemove, $wait);
    }
    function oncipj_Cypher_StartDatabase($this) {
        var $wait, $start, $databaseName, var$4;
        $wait = onciafn_Neo4jASTFactory_wait($this.$astFactory, 0, Long_fromInt(-1));
        $start = oncipj_Cypher_jj_consume_token($this, 295);
        oncipj_Cypher_jj_consume_token($this, 118);
        $databaseName = oncipj_Cypher_SymbolicAliasName($this);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 221:
                case 332:
                    break;
                default:
                    $this.$jj_la1.data[581] = $this.$jj_gen;
                    break a;
            }
            $wait = oncipj_Cypher_WaitClause($this);
        }
        $start = oncipj_Cypher_pos($this, $start);
        return oncia_StartDatabase__init_(oncipj_AliasName_getLocalAliasName($databaseName, $this.$astFactory), $wait, $start);
    }
    function oncipj_Cypher_StopDatabase($this) {
        var $wait, $start, $databaseName, var$4;
        $wait = onciafn_Neo4jASTFactory_wait($this.$astFactory, 0, Long_fromInt(-1));
        $start = oncipj_Cypher_jj_consume_token($this, 298);
        oncipj_Cypher_jj_consume_token($this, 118);
        $databaseName = oncipj_Cypher_SymbolicAliasName($this);
        var$4 = $this.$jj_ntk;
        if (var$4 == (-1))
            var$4 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$4) {
                case 221:
                case 332:
                    break;
                default:
                    $this.$jj_la1.data[582] = $this.$jj_gen;
                    break a;
            }
            $wait = oncipj_Cypher_WaitClause($this);
        }
        $start = oncipj_Cypher_pos($this, $start);
        return oncia_StopDatabase__init_(oncipj_AliasName_getLocalAliasName($databaseName, $this.$astFactory), $wait, $start);
    }
    function oncipj_Cypher_WaitClause($this) {
        var $number, $wait, var$3, var$4;
        $number = null;
        $wait = 0;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$3) {
                case 221:
                    oncipj_Cypher_jj_consume_token($this, 221);
                    break a;
                case 332:
                    oncipj_Cypher_jj_consume_token($this, 332);
                    $wait = 1;
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$4) {
                        case 36:
                            $number = oncipj_Cypher_jj_consume_token($this, 36);
                            var$4 = $this.$jj_ntk;
                            if (var$4 == (-1))
                                var$4 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$4) {
                                case 277:
                                case 278:
                                case 281:
                                    var$4 = $this.$jj_ntk;
                                    if (var$4 == (-1))
                                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$4) {
                                        case 277:
                                            oncipj_Cypher_jj_consume_token($this, 277);
                                            break a;
                                        case 278:
                                            oncipj_Cypher_jj_consume_token($this, 278);
                                            break a;
                                        case 279:
                                        case 280:
                                            break;
                                        case 281:
                                            oncipj_Cypher_jj_consume_token($this, 281);
                                            break a;
                                        default:
                                    }
                                    $this.$jj_la1.data[583] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $number = new oncipj_ParseException;
                                    jl_Throwable__init_0($number);
                                    $rt_throw($number);
                                case 279:
                                case 280:
                                    break;
                                default:
                            }
                            $this.$jj_la1.data[584] = $this.$jj_gen;
                            break a;
                        default:
                    }
                    $this.$jj_la1.data[585] = $this.$jj_gen;
                    break a;
                default:
            }
            $this.$jj_la1.data[586] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $number = new oncipj_ParseException;
            jl_Throwable__init_0($number);
            $rt_throw($number);
        }
        if ($number === null)
            return onciafn_Neo4jASTFactory_wait($this.$astFactory, $wait, Long_fromInt(-1));
        return onciafn_Neo4jASTFactory_wait($this.$astFactory, $wait, jl_Long_parseLong($number.$image0));
    }
    function oncipj_Cypher_ShowDatabase($this, $start, $useClause) {
        var $name, $isDefault, $isHome, $yield, $returnClause, $where, var$9, var$10, var$11, var$12, $scope, var$14, var$15;
        $name = null;
        $isDefault = 0;
        $isHome = 0;
        $yield = null;
        $returnClause = null;
        $where = null;
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$9) {
                case 118:
                case 119:
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    b: {
                        switch (var$10) {
                            case 118:
                                var$11 = oncipj_Cypher_jj_consume_token($this, 118);
                                break b;
                            case 119:
                                var$11 = oncipj_Cypher_jj_consume_token($this, 119);
                                break b;
                            default:
                        }
                        $this.$jj_la1.data[587] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 131:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            if (!oncipj_Cypher_jj_2_138($this, 2147483647)) {
                                if (!oncipj_Cypher_jj_2_139($this, 2147483647)) {
                                    if (oncipj_Cypher_jj_2_140($this, 2147483647)) {
                                        $where = oncipj_Cypher_WhereClause($this);
                                        break a;
                                    }
                                    var$10 = $this.$jj_ntk;
                                    if (var$10 == (-1))
                                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$10) {
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 71:
                                        case 72:
                                        case 73:
                                        case 74:
                                        case 75:
                                        case 76:
                                        case 77:
                                        case 78:
                                        case 79:
                                        case 80:
                                        case 81:
                                        case 82:
                                        case 83:
                                        case 84:
                                        case 85:
                                        case 87:
                                        case 88:
                                        case 89:
                                        case 90:
                                        case 91:
                                        case 92:
                                        case 93:
                                        case 94:
                                        case 95:
                                        case 96:
                                        case 97:
                                        case 98:
                                        case 99:
                                        case 100:
                                        case 104:
                                        case 105:
                                        case 106:
                                        case 107:
                                        case 108:
                                        case 109:
                                        case 110:
                                        case 111:
                                        case 112:
                                        case 113:
                                        case 114:
                                        case 115:
                                        case 116:
                                        case 117:
                                        case 118:
                                        case 119:
                                        case 120:
                                        case 121:
                                        case 122:
                                        case 123:
                                        case 124:
                                        case 125:
                                        case 126:
                                        case 127:
                                        case 128:
                                        case 129:
                                        case 130:
                                        case 131:
                                        case 132:
                                        case 133:
                                        case 137:
                                        case 138:
                                        case 139:
                                        case 140:
                                        case 141:
                                        case 142:
                                        case 143:
                                        case 144:
                                        case 145:
                                        case 146:
                                        case 147:
                                        case 148:
                                        case 149:
                                        case 150:
                                        case 152:
                                        case 153:
                                        case 154:
                                        case 155:
                                        case 156:
                                        case 157:
                                        case 158:
                                        case 159:
                                        case 160:
                                        case 161:
                                        case 162:
                                        case 163:
                                        case 164:
                                        case 165:
                                        case 166:
                                        case 167:
                                        case 169:
                                        case 170:
                                        case 171:
                                        case 172:
                                        case 173:
                                        case 175:
                                        case 176:
                                        case 177:
                                        case 179:
                                        case 180:
                                        case 181:
                                        case 182:
                                        case 183:
                                        case 184:
                                        case 185:
                                        case 186:
                                        case 187:
                                        case 188:
                                        case 189:
                                        case 190:
                                        case 191:
                                        case 197:
                                        case 198:
                                        case 199:
                                        case 200:
                                        case 201:
                                        case 204:
                                        case 205:
                                        case 206:
                                        case 207:
                                        case 212:
                                        case 213:
                                        case 214:
                                        case 215:
                                        case 216:
                                        case 217:
                                        case 218:
                                        case 219:
                                        case 220:
                                        case 221:
                                        case 222:
                                        case 223:
                                        case 224:
                                        case 225:
                                        case 226:
                                        case 227:
                                        case 228:
                                        case 229:
                                        case 230:
                                        case 231:
                                        case 232:
                                        case 233:
                                        case 234:
                                        case 235:
                                        case 236:
                                        case 237:
                                        case 240:
                                        case 241:
                                        case 243:
                                        case 244:
                                        case 245:
                                        case 246:
                                        case 247:
                                        case 248:
                                        case 249:
                                        case 250:
                                        case 251:
                                        case 253:
                                        case 256:
                                        case 257:
                                        case 258:
                                        case 259:
                                        case 261:
                                        case 262:
                                        case 263:
                                        case 264:
                                        case 265:
                                        case 266:
                                        case 267:
                                        case 268:
                                        case 269:
                                        case 270:
                                        case 271:
                                        case 272:
                                        case 273:
                                        case 274:
                                        case 276:
                                        case 277:
                                        case 278:
                                        case 279:
                                        case 280:
                                        case 281:
                                        case 282:
                                        case 284:
                                        case 285:
                                        case 286:
                                        case 287:
                                        case 288:
                                        case 289:
                                        case 290:
                                        case 291:
                                        case 292:
                                        case 293:
                                        case 294:
                                        case 295:
                                        case 296:
                                        case 297:
                                        case 298:
                                        case 299:
                                        case 300:
                                        case 301:
                                        case 302:
                                        case 303:
                                        case 304:
                                        case 305:
                                        case 306:
                                        case 308:
                                        case 309:
                                        case 310:
                                        case 311:
                                        case 312:
                                        case 313:
                                        case 314:
                                        case 315:
                                        case 316:
                                        case 317:
                                        case 318:
                                        case 319:
                                        case 320:
                                        case 321:
                                        case 322:
                                        case 323:
                                        case 324:
                                        case 325:
                                        case 326:
                                        case 327:
                                        case 328:
                                        case 329:
                                        case 330:
                                        case 331:
                                        case 332:
                                        case 333:
                                        case 334:
                                        case 335:
                                        case 336:
                                        case 337:
                                        case 338:
                                        case 339:
                                        case 340:
                                        case 341:
                                            $name = oncipj_Cypher_SymbolicAliasName($this);
                                            break a;
                                        case 86:
                                        case 101:
                                        case 102:
                                        case 103:
                                        case 134:
                                        case 135:
                                        case 136:
                                        case 151:
                                        case 168:
                                        case 174:
                                        case 178:
                                        case 192:
                                        case 193:
                                        case 194:
                                        case 195:
                                        case 196:
                                        case 202:
                                        case 203:
                                        case 208:
                                        case 209:
                                        case 210:
                                        case 211:
                                        case 238:
                                        case 239:
                                        case 242:
                                        case 252:
                                        case 254:
                                        case 255:
                                        case 260:
                                        case 275:
                                        case 283:
                                        case 307:
                                            break;
                                        default:
                                    }
                                    $this.$jj_la1.data[591] = $this.$jj_gen;
                                    oncipj_Cypher_jj_consume_token($this, (-1));
                                    $start = new oncipj_ParseException;
                                    jl_Throwable__init_0($start);
                                    $rt_throw($start);
                                }
                                $yield = oncipj_Cypher_YieldClause($this);
                                var$10 = $this.$jj_ntk;
                                if (var$10 == (-1))
                                    var$10 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$10) {
                                    case 269:
                                        break;
                                    default:
                                        $this.$jj_la1.data[590] = $this.$jj_gen;
                                        break a;
                                }
                                $returnClause = oncipj_Cypher_ReturnClause($this);
                                break a;
                            }
                            $name = oncipj_Cypher_SymbolicAliasName($this);
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 334:
                                    $where = oncipj_Cypher_WhereClause($this);
                                    break a;
                                case 339:
                                    $yield = oncipj_Cypher_YieldClause($this);
                                    var$10 = $this.$jj_ntk;
                                    if (var$10 == (-1))
                                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$10) {
                                        case 269:
                                            break;
                                        default:
                                            $this.$jj_la1.data[588] = $this.$jj_gen;
                                            break a;
                                    }
                                    $returnClause = oncipj_Cypher_ReturnClause($this);
                                    break a;
                                default:
                            }
                            $this.$jj_la1.data[589] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[592] = $this.$jj_gen;
                    break a;
                case 124:
                case 176:
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    c: {
                        switch (var$10) {
                            case 124:
                                var$11 = oncipj_Cypher_jj_consume_token($this, 124);
                                oncipj_Cypher_jj_consume_token($this, 118);
                                $isDefault = 1;
                                break c;
                            case 176:
                                var$11 = oncipj_Cypher_jj_consume_token($this, 176);
                                oncipj_Cypher_jj_consume_token($this, 118);
                                $isHome = 1;
                                break c;
                            default:
                        }
                        $this.$jj_la1.data[593] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $start = new oncipj_ParseException;
                        jl_Throwable__init_0($start);
                        $rt_throw($start);
                    }
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 334:
                        case 339:
                            var$10 = $this.$jj_ntk;
                            if (var$10 == (-1))
                                var$10 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$10) {
                                case 334:
                                    $where = oncipj_Cypher_WhereClause($this);
                                    break a;
                                case 339:
                                    $yield = oncipj_Cypher_YieldClause($this);
                                    var$10 = $this.$jj_ntk;
                                    if (var$10 == (-1))
                                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                                    switch (var$10) {
                                        case 269:
                                            break;
                                        default:
                                            $this.$jj_la1.data[594] = $this.$jj_gen;
                                            break a;
                                    }
                                    $returnClause = oncipj_Cypher_ReturnClause($this);
                                    break a;
                                default:
                            }
                            $this.$jj_la1.data[595] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $start = new oncipj_ParseException;
                            jl_Throwable__init_0($start);
                            $rt_throw($start);
                        default:
                    }
                    $this.$jj_la1.data[596] = $this.$jj_gen;
                    break a;
                default:
            }
            $this.$jj_la1.data[597] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$11 = oncipj_Cypher_pos($this, var$11);
        var$12 = $name === null ? null : oncipj_AliasName_getLocalAliasName($name, $this.$astFactory);
        $scope = var$12 !== null ? oncia_SingleNamedDatabaseScope__init_(var$12, var$11) : $isDefault ? oncia_DefaultDatabaseScope__init_(var$11) : !$isHome ? oncia_AllDatabasesScope__init_(var$11) : oncia_HomeDatabaseScope__init_(var$11);
        var$14 = $this.$astFactory;
        var$15 = oncipj_Cypher_pos($this, $start);
        if ($yield === null)
            $start = oncia_ShowDatabase$_apply(oncia_ShowDatabase$_MODULE$, $scope, s_Option_map(s_Option$_apply(s_Option$_MODULE$, $where), new onciafn_Neo4jASTFactory$showDatabase$lambda$_218_0), var$15);
        else {
            var$11 = oncia_ShowDatabase$_MODULE$;
            var$12 = new s_Some;
            s_package$_$callClinit();
            s_Some__init_0(var$12, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_($yield, s_Option$_apply(s_Option$_MODULE$, $returnClause))));
            $start = oncia_ShowDatabase$_apply(var$11, $scope, var$12, var$15);
        }
        return onciafn_Neo4jASTFactory_useGraph(var$14, $start, $useClause);
    }
    function oncipj_Cypher_DatabaseScope($this) {
        var $names, $type, var$3, var$4, var$5;
        $names = null;
        onciaf_ScopeType_$callClinit();
        $type = onciaf_ScopeType_NAMED;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$3) {
                    case 118:
                    case 119:
                        var$4 = $this.$jj_ntk;
                        if (var$4 == (-1))
                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                        c: {
                            switch (var$4) {
                                case 118:
                                    var$5 = oncipj_Cypher_jj_consume_token($this, 118);
                                    break c;
                                case 119:
                                    var$5 = oncipj_Cypher_jj_consume_token($this, 119);
                                    break c;
                                default:
                            }
                            $this.$jj_la1.data[598] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $names = new oncipj_ParseException;
                            jl_Throwable__init_0($names);
                            $rt_throw($names);
                        }
                        var$4 = $this.$jj_ntk;
                        if (var$4 == (-1))
                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$4) {
                            case 68:
                            case 69:
                            case 70:
                            case 71:
                            case 72:
                            case 73:
                            case 74:
                            case 75:
                            case 76:
                            case 77:
                            case 78:
                            case 79:
                            case 80:
                            case 81:
                            case 82:
                            case 83:
                            case 84:
                            case 85:
                            case 87:
                            case 88:
                            case 89:
                            case 90:
                            case 91:
                            case 92:
                            case 93:
                            case 94:
                            case 95:
                            case 96:
                            case 97:
                            case 98:
                            case 99:
                            case 100:
                            case 104:
                            case 105:
                            case 106:
                            case 107:
                            case 108:
                            case 109:
                            case 110:
                            case 111:
                            case 112:
                            case 113:
                            case 114:
                            case 115:
                            case 116:
                            case 117:
                            case 118:
                            case 119:
                            case 120:
                            case 121:
                            case 122:
                            case 123:
                            case 124:
                            case 125:
                            case 126:
                            case 127:
                            case 128:
                            case 129:
                            case 130:
                            case 131:
                            case 132:
                            case 133:
                            case 137:
                            case 138:
                            case 139:
                            case 140:
                            case 141:
                            case 142:
                            case 143:
                            case 144:
                            case 145:
                            case 146:
                            case 147:
                            case 148:
                            case 149:
                            case 150:
                            case 152:
                            case 153:
                            case 154:
                            case 155:
                            case 156:
                            case 157:
                            case 158:
                            case 159:
                            case 160:
                            case 161:
                            case 162:
                            case 163:
                            case 164:
                            case 165:
                            case 166:
                            case 167:
                            case 169:
                            case 170:
                            case 171:
                            case 172:
                            case 173:
                            case 175:
                            case 176:
                            case 177:
                            case 179:
                            case 180:
                            case 181:
                            case 182:
                            case 183:
                            case 184:
                            case 185:
                            case 186:
                            case 187:
                            case 188:
                            case 189:
                            case 190:
                            case 191:
                            case 197:
                            case 198:
                            case 199:
                            case 200:
                            case 201:
                            case 204:
                            case 205:
                            case 206:
                            case 207:
                            case 212:
                            case 213:
                            case 214:
                            case 215:
                            case 216:
                            case 217:
                            case 218:
                            case 219:
                            case 220:
                            case 221:
                            case 222:
                            case 223:
                            case 224:
                            case 225:
                            case 226:
                            case 227:
                            case 228:
                            case 229:
                            case 230:
                            case 231:
                            case 232:
                            case 233:
                            case 234:
                            case 235:
                            case 236:
                            case 237:
                            case 240:
                            case 241:
                            case 243:
                            case 244:
                            case 245:
                            case 246:
                            case 247:
                            case 248:
                            case 249:
                            case 250:
                            case 251:
                            case 253:
                            case 256:
                            case 257:
                            case 258:
                            case 259:
                            case 261:
                            case 262:
                            case 263:
                            case 264:
                            case 265:
                            case 266:
                            case 267:
                            case 268:
                            case 269:
                            case 270:
                            case 271:
                            case 272:
                            case 273:
                            case 274:
                            case 276:
                            case 277:
                            case 278:
                            case 279:
                            case 280:
                            case 281:
                            case 282:
                            case 284:
                            case 285:
                            case 286:
                            case 287:
                            case 288:
                            case 289:
                            case 290:
                            case 291:
                            case 292:
                            case 293:
                            case 294:
                            case 295:
                            case 296:
                            case 297:
                            case 298:
                            case 299:
                            case 300:
                            case 301:
                            case 302:
                            case 303:
                            case 304:
                            case 305:
                            case 306:
                            case 308:
                            case 309:
                            case 310:
                            case 311:
                            case 312:
                            case 313:
                            case 314:
                            case 315:
                            case 316:
                            case 317:
                            case 318:
                            case 319:
                            case 320:
                            case 321:
                            case 322:
                            case 323:
                            case 324:
                            case 325:
                            case 326:
                            case 327:
                            case 328:
                            case 329:
                            case 330:
                            case 331:
                            case 332:
                            case 333:
                            case 334:
                            case 335:
                            case 336:
                            case 337:
                            case 338:
                            case 339:
                            case 340:
                            case 341:
                                break;
                            case 86:
                            case 101:
                            case 102:
                            case 103:
                            case 134:
                            case 135:
                            case 136:
                            case 151:
                            case 168:
                            case 174:
                            case 178:
                            case 192:
                            case 193:
                            case 194:
                            case 195:
                            case 196:
                            case 202:
                            case 203:
                            case 208:
                            case 209:
                            case 210:
                            case 211:
                            case 238:
                            case 239:
                            case 242:
                            case 252:
                            case 254:
                            case 255:
                            case 260:
                            case 275:
                            case 283:
                                break a;
                            case 307:
                                oncipj_Cypher_jj_consume_token($this, 307);
                                $type = onciaf_ScopeType_ALL;
                                break b;
                            default:
                                break a;
                        }
                        $names = oncipj_Cypher_SymbolicAliasNameList($this);
                        break b;
                    case 124:
                        break;
                    case 176:
                        var$5 = oncipj_Cypher_jj_consume_token($this, 176);
                        oncipj_Cypher_jj_consume_token($this, 118);
                        $type = onciaf_ScopeType_HOME;
                        break b;
                    default:
                        $this.$jj_la1.data[600] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $names = new oncipj_ParseException;
                        jl_Throwable__init_0($names);
                        $rt_throw($names);
                }
                var$5 = oncipj_Cypher_jj_consume_token($this, 124);
                oncipj_Cypher_jj_consume_token($this, 118);
                $type = onciaf_ScopeType_DEFAULT;
            }
            return onciafn_Neo4jASTFactory_databaseScope($this.$astFactory, oncipj_Cypher_pos($this, var$5), $names, $type);
        }
        $this.$jj_la1.data[599] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $names = new oncipj_ParseException;
        jl_Throwable__init_0($names);
        $rt_throw($names);
    }
    function oncipj_Cypher_GraphScope($this) {
        var $names, $type, var$3, var$4, var$5;
        $names = null;
        onciaf_ScopeType_$callClinit();
        $type = onciaf_ScopeType_NAMED;
        var$3 = $this.$jj_ntk;
        if (var$3 == (-1))
            var$3 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$3) {
                    case 124:
                        break;
                    case 170:
                    case 171:
                        var$4 = $this.$jj_ntk;
                        if (var$4 == (-1))
                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                        c: {
                            switch (var$4) {
                                case 170:
                                    var$5 = oncipj_Cypher_jj_consume_token($this, 170);
                                    break c;
                                case 171:
                                    var$5 = oncipj_Cypher_jj_consume_token($this, 171);
                                    break c;
                                default:
                            }
                            $this.$jj_la1.data[601] = $this.$jj_gen;
                            oncipj_Cypher_jj_consume_token($this, (-1));
                            $names = new oncipj_ParseException;
                            jl_Throwable__init_0($names);
                            $rt_throw($names);
                        }
                        var$4 = $this.$jj_ntk;
                        if (var$4 == (-1))
                            var$4 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$4) {
                            case 68:
                            case 69:
                            case 70:
                            case 71:
                            case 72:
                            case 73:
                            case 74:
                            case 75:
                            case 76:
                            case 77:
                            case 78:
                            case 79:
                            case 80:
                            case 81:
                            case 82:
                            case 83:
                            case 84:
                            case 85:
                            case 87:
                            case 88:
                            case 89:
                            case 90:
                            case 91:
                            case 92:
                            case 93:
                            case 94:
                            case 95:
                            case 96:
                            case 97:
                            case 98:
                            case 99:
                            case 100:
                            case 104:
                            case 105:
                            case 106:
                            case 107:
                            case 108:
                            case 109:
                            case 110:
                            case 111:
                            case 112:
                            case 113:
                            case 114:
                            case 115:
                            case 116:
                            case 117:
                            case 118:
                            case 119:
                            case 120:
                            case 121:
                            case 122:
                            case 123:
                            case 124:
                            case 125:
                            case 126:
                            case 127:
                            case 128:
                            case 129:
                            case 130:
                            case 131:
                            case 132:
                            case 133:
                            case 137:
                            case 138:
                            case 139:
                            case 140:
                            case 141:
                            case 142:
                            case 143:
                            case 144:
                            case 145:
                            case 146:
                            case 147:
                            case 148:
                            case 149:
                            case 150:
                            case 152:
                            case 153:
                            case 154:
                            case 155:
                            case 156:
                            case 157:
                            case 158:
                            case 159:
                            case 160:
                            case 161:
                            case 162:
                            case 163:
                            case 164:
                            case 165:
                            case 166:
                            case 167:
                            case 169:
                            case 170:
                            case 171:
                            case 172:
                            case 173:
                            case 175:
                            case 176:
                            case 177:
                            case 179:
                            case 180:
                            case 181:
                            case 182:
                            case 183:
                            case 184:
                            case 185:
                            case 186:
                            case 187:
                            case 188:
                            case 189:
                            case 190:
                            case 191:
                            case 197:
                            case 198:
                            case 199:
                            case 200:
                            case 201:
                            case 204:
                            case 205:
                            case 206:
                            case 207:
                            case 212:
                            case 213:
                            case 214:
                            case 215:
                            case 216:
                            case 217:
                            case 218:
                            case 219:
                            case 220:
                            case 221:
                            case 222:
                            case 223:
                            case 224:
                            case 225:
                            case 226:
                            case 227:
                            case 228:
                            case 229:
                            case 230:
                            case 231:
                            case 232:
                            case 233:
                            case 234:
                            case 235:
                            case 236:
                            case 237:
                            case 240:
                            case 241:
                            case 243:
                            case 244:
                            case 245:
                            case 246:
                            case 247:
                            case 248:
                            case 249:
                            case 250:
                            case 251:
                            case 253:
                            case 256:
                            case 257:
                            case 258:
                            case 259:
                            case 261:
                            case 262:
                            case 263:
                            case 264:
                            case 265:
                            case 266:
                            case 267:
                            case 268:
                            case 269:
                            case 270:
                            case 271:
                            case 272:
                            case 273:
                            case 274:
                            case 276:
                            case 277:
                            case 278:
                            case 279:
                            case 280:
                            case 281:
                            case 282:
                            case 284:
                            case 285:
                            case 286:
                            case 287:
                            case 288:
                            case 289:
                            case 290:
                            case 291:
                            case 292:
                            case 293:
                            case 294:
                            case 295:
                            case 296:
                            case 297:
                            case 298:
                            case 299:
                            case 300:
                            case 301:
                            case 302:
                            case 303:
                            case 304:
                            case 305:
                            case 306:
                            case 308:
                            case 309:
                            case 310:
                            case 311:
                            case 312:
                            case 313:
                            case 314:
                            case 315:
                            case 316:
                            case 317:
                            case 318:
                            case 319:
                            case 320:
                            case 321:
                            case 322:
                            case 323:
                            case 324:
                            case 325:
                            case 326:
                            case 327:
                            case 328:
                            case 329:
                            case 330:
                            case 331:
                            case 332:
                            case 333:
                            case 334:
                            case 335:
                            case 336:
                            case 337:
                            case 338:
                            case 339:
                            case 340:
                            case 341:
                                break;
                            case 86:
                            case 101:
                            case 102:
                            case 103:
                            case 134:
                            case 135:
                            case 136:
                            case 151:
                            case 168:
                            case 174:
                            case 178:
                            case 192:
                            case 193:
                            case 194:
                            case 195:
                            case 196:
                            case 202:
                            case 203:
                            case 208:
                            case 209:
                            case 210:
                            case 211:
                            case 238:
                            case 239:
                            case 242:
                            case 252:
                            case 254:
                            case 255:
                            case 260:
                            case 275:
                            case 283:
                                break a;
                            case 307:
                                oncipj_Cypher_jj_consume_token($this, 307);
                                $type = onciaf_ScopeType_ALL;
                                break b;
                            default:
                                break a;
                        }
                        $names = oncipj_Cypher_SymbolicAliasNameList($this);
                        break b;
                    case 176:
                        var$5 = oncipj_Cypher_jj_consume_token($this, 176);
                        oncipj_Cypher_jj_consume_token($this, 170);
                        $type = onciaf_ScopeType_HOME;
                        break b;
                    default:
                        $this.$jj_la1.data[603] = $this.$jj_gen;
                        oncipj_Cypher_jj_consume_token($this, (-1));
                        $names = new oncipj_ParseException;
                        jl_Throwable__init_0($names);
                        $rt_throw($names);
                }
                var$5 = oncipj_Cypher_jj_consume_token($this, 124);
                oncipj_Cypher_jj_consume_token($this, 170);
                $type = onciaf_ScopeType_DEFAULT;
            }
            return onciafn_Neo4jASTFactory_graphScope($this.$astFactory, oncipj_Cypher_pos($this, var$5), $names, $type);
        }
        $this.$jj_la1.data[602] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $names = new oncipj_ParseException;
        jl_Throwable__init_0($names);
        $rt_throw($names);
    }
    function oncipj_Cypher_CreateAlias($this, $start, $replace) {
        var $ifNotExists, $url, $username, $password, $driverSettings, $properties, var$9, var$10, var$11, var$12, var$13, var$14, var$15;
        $ifNotExists = 0;
        $url = null;
        $username = null;
        $password = null;
        $driverSettings = null;
        $properties = null;
        oncipj_Cypher_jj_consume_token($this, 73);
        var$9 = oncipj_Cypher_SymbolicAliasName($this);
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$10) {
                case 177:
                    oncipj_Cypher_jj_consume_token($this, 177);
                    oncipj_Cypher_jj_consume_token($this, 219);
                    oncipj_Cypher_jj_consume_token($this, 156);
                    $ifNotExists = 1;
                    break a;
                default:
            }
            $this.$jj_la1.data[604] = $this.$jj_gen;
        }
        oncipj_Cypher_jj_consume_token($this, 162);
        oncipj_Cypher_jj_consume_token($this, 118);
        var$11 = oncipj_Cypher_SymbolicAliasName($this);
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        b: {
            switch (var$10) {
                case 85:
                    oncipj_Cypher_jj_consume_token($this, 85);
                    $url = oncipj_Cypher_StringOrParameter($this);
                    oncipj_Cypher_jj_consume_token($this, 325);
                    $username = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                    oncipj_Cypher_jj_consume_token($this, 232);
                    $password = oncipj_Cypher_passwordExpression($this);
                    var$10 = $this.$jj_ntk;
                    if (var$10 == (-1))
                        var$10 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$10) {
                        case 137:
                            break;
                        default:
                            $this.$jj_la1.data[605] = $this.$jj_gen;
                            break b;
                    }
                    oncipj_Cypher_jj_consume_token($this, 137);
                    $driverSettings = oncipj_Cypher_MapOrParameter($this);
                    break b;
                default:
            }
            $this.$jj_la1.data[606] = $this.$jj_gen;
        }
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        c: {
            switch (var$10) {
                case 250:
                    break;
                default:
                    $this.$jj_la1.data[607] = $this.$jj_gen;
                    break c;
            }
            oncipj_Cypher_jj_consume_token($this, 250);
            $properties = oncipj_Cypher_MapOrParameter($this);
        }
        if ($url === null) {
            $password = $this.$astFactory;
            $start = oncipj_Cypher_pos($this, $start);
            $driverSettings = oncipj_AliasName_getLocalAliasName(var$9, $this.$astFactory);
            var$9 = oncipj_AliasName_getLocalAliasName(var$11, $this.$astFactory);
            var$11 = new oncia_CreateLocalDatabaseAlias;
            var$12 = onciafn_Neo4jASTFactory_ifExistsDo($password, $replace, $ifNotExists);
            $properties = s_Option$_apply(s_Option$_MODULE$, $properties);
            $url = new onciafn_Neo4jASTFactory$createLocalDatabaseAlias$lambda$_225_0;
            $url.$_0248 = $password;
            oncia_CreateLocalDatabaseAlias__init_(var$11, $driverSettings, var$9, var$12, s_Option_map($properties, $url), $start);
            return var$11;
        }
        var$13 = $this.$astFactory;
        var$14 = oncipj_Cypher_pos($this, $start);
        var$15 = oncipj_AliasName_getRemoteAliasName(var$9, $this.$astFactory);
        $start = oncipj_AliasName_getLocalAliasName(var$11, $this.$astFactory);
        var$9 = new oncia_CreateRemoteDatabaseAlias;
        var$12 = onciafn_Neo4jASTFactory_ifExistsDo(var$13, $replace, $ifNotExists);
        $url = onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, $url));
        $username = onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, $username));
        $driverSettings = s_Option$_apply(s_Option$_MODULE$, $driverSettings);
        var$11 = new onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_0;
        var$11.$_0249 = var$13;
        $driverSettings = s_Option_map($driverSettings, var$11);
        $properties = s_Option$_apply(s_Option$_MODULE$, $properties);
        var$11 = new onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_1;
        var$11.$_0250 = var$13;
        oncia_CreateRemoteDatabaseAlias__init_(var$9, var$15, $start, var$12, $url, $username, $password, $driverSettings, s_Option_map($properties, var$11), var$14);
        return var$9;
    }
    function oncipj_Cypher_AlterAlias($this, $start) {
        var $targetName, $ifExists, $url, $username, $password, $driverSettings, $properties, var$9, var$10, var$11, var$12, var$13, var$14, $alreadySet;
        $targetName = null;
        $ifExists = 0;
        $url = null;
        $username = null;
        $password = null;
        $driverSettings = null;
        $properties = null;
        oncipj_Cypher_jj_consume_token($this, 73);
        var$9 = oncipj_Cypher_SymbolicAliasName($this);
        var$10 = $this.$jj_ntk;
        if (var$10 == (-1))
            var$10 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$10) {
                case 177:
                    break;
                default:
                    $this.$jj_la1.data[609] = $this.$jj_gen;
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 177);
            oncipj_Cypher_jj_consume_token($this, 156);
            $ifExists = 1;
        }
        oncipj_Cypher_jj_consume_token($this, 286);
        oncipj_Cypher_jj_consume_token($this, 118);
        b: while (true) {
            var$10 = $this.$jj_ntk;
            if (var$10 == (-1))
                var$10 = oncipj_Cypher_jj_ntk_f($this);
            c: {
                switch (var$10) {
                    case 137:
                        break;
                    case 232:
                        var$11 = oncipj_Cypher_jj_consume_token($this, 232);
                        var$12 = $rt_createArray(jl_Object, 1);
                        var$12.data[0] = var$11.$image0;
                        oncipj_Cypher_assertNotAlreadySet($this, $password, var$11, jl_String_format($rt_s(948), var$12));
                        $password = oncipj_Cypher_passwordExpression($this);
                        break c;
                    case 250:
                        var$13 = oncipj_Cypher_jj_consume_token($this, 250);
                        var$12 = $rt_createArray(jl_Object, 1);
                        var$12.data[0] = var$13.$image0;
                        oncipj_Cypher_assertNotAlreadySet($this, $properties, var$13, jl_String_format($rt_s(948), var$12));
                        $properties = oncipj_Cypher_MapOrParameter($this);
                        break c;
                    case 302:
                        var$11 = oncipj_Cypher_jj_consume_token($this, 302);
                        var$12 = $rt_createArray(jl_Object, 1);
                        var$12.data[0] = var$11.$image0;
                        oncipj_Cypher_assertNotAlreadySet($this, $targetName, var$11, jl_String_format($rt_s(948), var$12));
                        $targetName = oncipj_Cypher_SymbolicAliasName($this);
                        var$14 = $this.$jj_ntk;
                        if (var$14 == (-1))
                            var$14 = oncipj_Cypher_jj_ntk_f($this);
                        switch (var$14) {
                            case 85:
                                break;
                            default:
                                $this.$jj_la1.data[610] = $this.$jj_gen;
                                break c;
                        }
                        oncipj_Cypher_jj_consume_token($this, 85);
                        $url = oncipj_Cypher_StringOrParameter($this);
                        break c;
                    case 325:
                        var$11 = oncipj_Cypher_jj_consume_token($this, 325);
                        var$12 = $rt_createArray(jl_Object, 1);
                        var$12.data[0] = var$11.$image0;
                        oncipj_Cypher_assertNotAlreadySet($this, $username, var$11, jl_String_format($rt_s(948), var$12));
                        $username = oncipj_Cypher_SymbolicNameOrStringParameter($this);
                        break c;
                    default:
                        break b;
                }
                var$11 = oncipj_Cypher_jj_consume_token($this, 137);
                var$12 = $rt_createArray(jl_Object, 1);
                var$12.data[0] = var$11.$image0;
                oncipj_Cypher_assertNotAlreadySet($this, $driverSettings, var$11, jl_String_format($rt_s(948), var$12));
                $driverSettings = oncipj_Cypher_MapOrParameter($this);
            }
            var$10 = $this.$jj_ntk;
            if (var$10 == (-1))
                var$10 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$10) {
                case 137:
                case 232:
                case 250:
                case 302:
                case 325:
                    break;
                default:
                    $this.$jj_la1.data[612] = $this.$jj_gen;
                    if ($url === null && $username === null && $password === null && $driverSettings === null) {
                        var$11 = $this.$astFactory;
                        $start = oncipj_Cypher_pos($this, $start);
                        var$13 = oncipj_AliasName_getLocalAliasName(var$9, $this.$astFactory);
                        $targetName = $targetName === null ? null : oncipj_AliasName_getLocalAliasName($targetName, $this.$astFactory);
                        $alreadySet = new oncia_AlterLocalDatabaseAlias;
                        var$9 = s_Option$_apply(s_Option$_MODULE$, $targetName);
                        $targetName = s_Option$_apply(s_Option$_MODULE$, $properties);
                        $properties = new onciafn_Neo4jASTFactory$alterLocalDatabaseAlias$lambda$_227_0;
                        $properties.$_0251 = var$11;
                        oncia_AlterLocalDatabaseAlias__init_($alreadySet, var$13, var$9, $ifExists, s_Option_map($targetName, $properties), $start);
                        return $alreadySet;
                    }
                    var$11 = $this.$astFactory;
                    $start = oncipj_Cypher_pos($this, $start);
                    var$13 = oncipj_AliasName_getRemoteAliasName(var$9, $this.$astFactory);
                    $targetName = $targetName === null ? null : oncipj_AliasName_getRemoteAliasName($targetName, $this.$astFactory);
                    $alreadySet = new oncia_AlterRemoteDatabaseAlias;
                    var$9 = s_Option$_apply(s_Option$_MODULE$, $targetName);
                    $url = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $url), new onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_0);
                    $username = s_Option_map(s_Option$_apply(s_Option$_MODULE$, $username), new onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_1);
                    $password = s_Option$_apply(s_Option$_MODULE$, $password);
                    $driverSettings = s_Option$_apply(s_Option$_MODULE$, $driverSettings);
                    $targetName = new onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_2;
                    $targetName.$_0252 = var$11;
                    $driverSettings = s_Option_map($driverSettings, $targetName);
                    $properties = s_Option$_apply(s_Option$_MODULE$, $properties);
                    $targetName = new onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_3;
                    $targetName.$_0253 = var$11;
                    oncia_AlterRemoteDatabaseAlias__init_($alreadySet, var$13, var$9, $ifExists, $url, $username, $password, $driverSettings, s_Option_map($properties, $targetName), $start);
                    return $alreadySet;
            }
        }
        $this.$jj_la1.data[611] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $start = new oncipj_ParseException;
        jl_Throwable__init_0($start);
        $rt_throw($start);
    }
    function oncipj_Cypher_ShowAliases($this, $start, $useClause) {
        var $aliasName, $where, $yieldClause, $returnClause, var$7, var$8, var$9, $maybeAliasName, $$je;
        $aliasName = null;
        $where = null;
        $yieldClause = null;
        $returnClause = null;
        var$7 = $this.$jj_ntk;
        if (var$7 == (-1))
            var$7 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$7) {
                case 73:
                    oncipj_Cypher_jj_consume_token($this, 73);
                    break a;
                case 74:
                    oncipj_Cypher_jj_consume_token($this, 74);
                    break a;
                default:
            }
            $this.$jj_la1.data[613] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        $this.$jj_la = 2147483647;
        var$8 = $this.$token;
        $this.$jj_scanpos = var$8;
        $this.$jj_lastpos = var$8;
        b: {
            c: {
                d: {
                    e: {
                        try {
                            var$7 = oncipj_Cypher_jj_3_141($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break e;
                            } else{
                                $start = $$je;
                                break d;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 140, 2147483647);
                        break b;
                    }
                    try {
                        var$7 = 1;
                        break c;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        $start = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 140, 2147483647);
                $rt_throw($start);
            }
            oncipj_Cypher_jj_save($this, 140, 2147483647);
        }
        if (var$7)
            $aliasName = oncipj_Cypher_SymbolicAliasName($this);
        oncipj_Cypher_jj_consume_token($this, 162);
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        f: {
            switch (var$9) {
                case 118:
                    oncipj_Cypher_jj_consume_token($this, 118);
                    break f;
                case 119:
                    oncipj_Cypher_jj_consume_token($this, 119);
                    break f;
                default:
            }
            $this.$jj_la1.data[614] = $this.$jj_gen;
            oncipj_Cypher_jj_consume_token($this, (-1));
            $start = new oncipj_ParseException;
            jl_Throwable__init_0($start);
            $rt_throw($start);
        }
        var$9 = $this.$jj_ntk;
        if (var$9 == (-1))
            var$9 = oncipj_Cypher_jj_ntk_f($this);
        g: {
            switch (var$9) {
                case 334:
                case 339:
                    var$9 = $this.$jj_ntk;
                    if (var$9 == (-1))
                        var$9 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$9) {
                        case 334:
                            $where = oncipj_Cypher_WhereClause($this);
                            break g;
                        case 339:
                            $yieldClause = oncipj_Cypher_YieldClause($this);
                            var$9 = $this.$jj_ntk;
                            if (var$9 == (-1))
                                var$9 = oncipj_Cypher_jj_ntk_f($this);
                            switch (var$9) {
                                case 269:
                                    break;
                                default:
                                    $this.$jj_la1.data[615] = $this.$jj_gen;
                                    break g;
                            }
                            $returnClause = oncipj_Cypher_ReturnClause($this);
                            break g;
                        default:
                    }
                    $this.$jj_la1.data[616] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    $start = new oncipj_ParseException;
                    jl_Throwable__init_0($start);
                    $rt_throw($start);
                default:
            }
            $this.$jj_la1.data[617] = $this.$jj_gen;
        }
        $maybeAliasName = $aliasName === null ? null : oncipj_AliasName_getLocalAliasName($aliasName, $this.$astFactory);
        var$8 = $this.$astFactory;
        $start = oncipj_Cypher_pos($this, $start);
        return onciafn_Neo4jASTFactory_useGraph(var$8, oncia_ShowAliases$_apply(oncia_ShowAliases$_MODULE$, s_Option$_apply(s_Option$_MODULE$, $maybeAliasName), onciafn_Neo4jASTFactory_yieldOrWhere(var$8, $yieldClause, $returnClause, $where), $start), $useClause);
    }
    function oncipj_Cypher_SymbolicAliasNameList($this) {
        var $databases, var$2;
        $databases = ju_ArrayList__init_();
        ju_ArrayList_add($databases, oncipj_AliasName_getLocalAliasName(oncipj_Cypher_SymbolicAliasName($this), $this.$astFactory));
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($databases, oncipj_AliasName_getLocalAliasName(oncipj_Cypher_SymbolicAliasName($this), $this.$astFactory));
        }
        $this.$jj_la1.data[618] = $this.$jj_gen;
        return $databases;
    }
    function oncipj_Cypher_SymbolicAliasName($this) {
        var var$1, $token, $parameter, var$4, var$5, var$6;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$1) {
            case 68:
            case 69:
            case 70:
            case 71:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
            case 78:
            case 79:
            case 80:
            case 81:
            case 82:
            case 83:
            case 84:
            case 85:
            case 87:
            case 88:
            case 89:
            case 90:
            case 91:
            case 92:
            case 93:
            case 94:
            case 95:
            case 96:
            case 97:
            case 98:
            case 99:
            case 100:
            case 104:
            case 105:
            case 106:
            case 107:
            case 108:
            case 109:
            case 110:
            case 111:
            case 112:
            case 113:
            case 114:
            case 115:
            case 116:
            case 117:
            case 118:
            case 119:
            case 120:
            case 121:
            case 122:
            case 123:
            case 124:
            case 125:
            case 126:
            case 127:
            case 128:
            case 129:
            case 130:
            case 132:
            case 133:
            case 137:
            case 138:
            case 139:
            case 140:
            case 141:
            case 142:
            case 143:
            case 144:
            case 145:
            case 146:
            case 147:
            case 148:
            case 149:
            case 150:
            case 152:
            case 153:
            case 154:
            case 155:
            case 156:
            case 157:
            case 158:
            case 159:
            case 160:
            case 161:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
            case 167:
            case 169:
            case 170:
            case 171:
            case 172:
            case 173:
            case 175:
            case 176:
            case 177:
            case 179:
            case 180:
            case 181:
            case 182:
            case 183:
            case 184:
            case 185:
            case 186:
            case 187:
            case 188:
            case 189:
            case 190:
            case 191:
            case 197:
            case 198:
            case 199:
            case 200:
            case 201:
            case 204:
            case 205:
            case 206:
            case 207:
            case 212:
            case 213:
            case 214:
            case 215:
            case 216:
            case 217:
            case 218:
            case 219:
            case 220:
            case 221:
            case 222:
            case 223:
            case 224:
            case 225:
            case 226:
            case 227:
            case 228:
            case 229:
            case 230:
            case 231:
            case 232:
            case 233:
            case 234:
            case 235:
            case 236:
            case 237:
            case 240:
            case 241:
            case 243:
            case 244:
            case 245:
            case 246:
            case 247:
            case 248:
            case 249:
            case 250:
            case 251:
            case 253:
            case 256:
            case 257:
            case 258:
            case 259:
            case 261:
            case 262:
            case 263:
            case 264:
            case 265:
            case 266:
            case 267:
            case 268:
            case 269:
            case 270:
            case 271:
            case 272:
            case 273:
            case 274:
            case 276:
            case 277:
            case 278:
            case 279:
            case 280:
            case 281:
            case 282:
            case 284:
            case 285:
            case 286:
            case 287:
            case 288:
            case 289:
            case 290:
            case 291:
            case 292:
            case 293:
            case 294:
            case 295:
            case 296:
            case 297:
            case 298:
            case 299:
            case 300:
            case 301:
            case 302:
            case 303:
            case 304:
            case 305:
            case 306:
            case 308:
            case 309:
            case 310:
            case 311:
            case 312:
            case 313:
            case 314:
            case 315:
            case 316:
            case 317:
            case 318:
            case 319:
            case 320:
            case 321:
            case 322:
            case 323:
            case 324:
            case 325:
            case 326:
            case 327:
            case 328:
            case 329:
            case 330:
            case 331:
            case 332:
            case 333:
            case 334:
            case 335:
            case 336:
            case 337:
            case 338:
            case 339:
            case 340:
            case 341:
                $token = oncipj_Cypher_SymbolicNameString($this);
                $parameter = new oncipj_AliasName;
                var$4 = $this.$exceptionFactory;
                var$5 = ju_ArrayList__init_();
                $parameter.$names0 = var$5;
                $parameter.$exceptionFactory0 = var$4;
                $parameter.$start4 = $token;
                ju_ArrayList_add(var$5, $token.$image0);
                a: while (true) {
                    var$6 = $this.$jj_ntk;
                    if (var$6 == (-1))
                        var$6 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$6) {
                        case 135:
                            break;
                        default:
                            break a;
                    }
                    oncipj_Cypher_jj_consume_token($this, 135);
                    $token = oncipj_Cypher_SymbolicNameString($this);
                    ju_ArrayList_add($parameter.$names0, $token.$image0);
                }
                $this.$jj_la1.data[619] = $this.$jj_gen;
                return $parameter;
            case 86:
            case 101:
            case 102:
            case 103:
            case 134:
            case 135:
            case 136:
            case 151:
            case 168:
            case 174:
            case 178:
            case 192:
            case 193:
            case 194:
            case 195:
            case 196:
            case 202:
            case 203:
            case 208:
            case 209:
            case 210:
            case 211:
            case 238:
            case 239:
            case 242:
            case 252:
            case 254:
            case 255:
            case 260:
            case 275:
            case 283:
            case 307:
                break;
            case 131:
                onciaf_ParameterType_$callClinit();
                $parameter = oncipj_Cypher_Parameter($this, onciaf_ParameterType_STRING);
                $token = new oncipj_AliasName;
                var$4 = $this.$exceptionFactory;
                $token.$names0 = ju_ArrayList__init_();
                $token.$exceptionFactory0 = var$4;
                $token.$parameter2 = $parameter;
                return $token;
            default:
        }
        $this.$jj_la1.data[620] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $token = new oncipj_ParseException;
        jl_Throwable__init_0($token);
        $rt_throw($token);
    }
    function oncipj_Cypher_SymbolicNameOrStringParameterList($this) {
        var $list, var$2;
        $list = ju_ArrayList__init_();
        ju_ArrayList_add($list, oncipj_Cypher_SymbolicNameOrStringParameter($this));
        a: while (true) {
            var$2 = $this.$jj_ntk;
            if (var$2 == (-1))
                var$2 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$2) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            ju_ArrayList_add($list, oncipj_Cypher_SymbolicNameOrStringParameter($this));
        }
        $this.$jj_la1.data[621] = $this.$jj_gen;
        return $list;
    }
    function oncipj_Cypher_SymbolicNameOrStringParameter($this) {
        var var$1, $name;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 87:
                case 88:
                case 89:
                case 90:
                case 91:
                case 92:
                case 93:
                case 94:
                case 95:
                case 96:
                case 97:
                case 98:
                case 99:
                case 100:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                case 123:
                case 124:
                case 125:
                case 126:
                case 127:
                case 128:
                case 129:
                case 130:
                case 132:
                case 133:
                case 137:
                case 138:
                case 139:
                case 140:
                case 141:
                case 142:
                case 143:
                case 144:
                case 145:
                case 146:
                case 147:
                case 148:
                case 149:
                case 150:
                case 152:
                case 153:
                case 154:
                case 155:
                case 156:
                case 157:
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 175:
                case 176:
                case 177:
                case 179:
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                case 186:
                case 187:
                case 188:
                case 189:
                case 190:
                case 191:
                case 197:
                case 198:
                case 199:
                case 200:
                case 201:
                case 204:
                case 205:
                case 206:
                case 207:
                case 212:
                case 213:
                case 214:
                case 215:
                case 216:
                case 217:
                case 218:
                case 219:
                case 220:
                case 221:
                case 222:
                case 223:
                case 224:
                case 225:
                case 226:
                case 227:
                case 228:
                case 229:
                case 230:
                case 231:
                case 232:
                case 233:
                case 234:
                case 235:
                case 236:
                case 237:
                case 240:
                case 241:
                case 243:
                case 244:
                case 245:
                case 246:
                case 247:
                case 248:
                case 249:
                case 250:
                case 251:
                case 253:
                case 256:
                case 257:
                case 258:
                case 259:
                case 261:
                case 262:
                case 263:
                case 264:
                case 265:
                case 266:
                case 267:
                case 268:
                case 269:
                case 270:
                case 271:
                case 272:
                case 273:
                case 274:
                case 276:
                case 277:
                case 278:
                case 279:
                case 280:
                case 281:
                case 282:
                case 284:
                case 285:
                case 286:
                case 287:
                case 288:
                case 289:
                case 290:
                case 291:
                case 292:
                case 293:
                case 294:
                case 295:
                case 296:
                case 297:
                case 298:
                case 299:
                case 300:
                case 301:
                case 302:
                case 303:
                case 304:
                case 305:
                case 306:
                case 308:
                case 309:
                case 310:
                case 311:
                case 312:
                case 313:
                case 314:
                case 315:
                case 316:
                case 317:
                case 318:
                case 319:
                case 320:
                case 321:
                case 322:
                case 323:
                case 324:
                case 325:
                case 326:
                case 327:
                case 328:
                case 329:
                case 330:
                case 331:
                case 332:
                case 333:
                case 334:
                case 335:
                case 336:
                case 337:
                case 338:
                case 339:
                case 340:
                case 341:
                    break;
                case 86:
                case 101:
                case 102:
                case 103:
                case 134:
                case 135:
                case 136:
                case 151:
                case 168:
                case 174:
                case 178:
                case 192:
                case 193:
                case 194:
                case 195:
                case 196:
                case 202:
                case 203:
                case 208:
                case 209:
                case 210:
                case 211:
                case 238:
                case 239:
                case 242:
                case 252:
                case 254:
                case 255:
                case 260:
                case 275:
                case 283:
                case 307:
                    break a;
                case 131:
                    onciaf_ParameterType_$callClinit();
                    return onciaf_SimpleEither_right(oncipj_Cypher_Parameter($this, onciaf_ParameterType_STRING));
                default:
                    break a;
            }
            return onciaf_SimpleEither_left((oncipj_Cypher_SymbolicNameString($this)).$image0);
        }
        $this.$jj_la1.data[622] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $name = new oncipj_ParseException;
        jl_Throwable__init_0($name);
        $rt_throw($name);
    }
    function oncipj_Cypher_Glob($this) {
        var var$1, var$2, var$3, var$4, var$5, $$je;
        $this.$jj_la = 2147483647;
        var$1 = $this.$token;
        $this.$jj_scanpos = var$1;
        $this.$jj_lastpos = var$1;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_142($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                var$1 = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 141, 2147483647);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        var$1 = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 141, 2147483647);
                $rt_throw(var$1);
            }
            oncipj_Cypher_jj_save($this, 141, 2147483647);
        }
        e: {
            if (var$2)
                var$1 = (oncipj_Cypher_EscapedSymbolicNameString($this)).$image0;
            else {
                $this.$jj_la = 2147483647;
                var$1 = $this.$token;
                $this.$jj_scanpos = var$1;
                $this.$jj_lastpos = var$1;
                f: {
                    g: {
                        h: {
                            i: {
                                try {
                                    var$2 = oncipj_Cypher_jj_3_143($this) ? 0 : 1;
                                } catch ($$e) {
                                    $$je = $rt_wrapException($$e);
                                    if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                        break i;
                                    } else{
                                        var$1 = $$je;
                                        break h;
                                    }
                                }
                                oncipj_Cypher_jj_save($this, 142, 2147483647);
                                break f;
                            }
                            try {
                                var$2 = 1;
                                break g;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                var$1 = $$je;

                            }
                        }
                        oncipj_Cypher_jj_save($this, 142, 2147483647);
                        $rt_throw(var$1);
                    }
                    oncipj_Cypher_jj_save($this, 142, 2147483647);
                }
                if (var$2) {
                    var$1 = (oncipj_Cypher_EscapedSymbolicNameString($this)).$image0;
                    var$3 = oncipj_Cypher_GlobRecursive($this);
                    var$4 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$4);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$4, var$1), var$3);
                    var$1 = jl_AbstractStringBuilder_toString(var$4);
                } else {
                    var$5 = $this.$jj_ntk;
                    if (var$5 == (-1))
                        var$5 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$5) {
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 135:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 252:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 307:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            break;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                            break e;
                        default:
                            break e;
                    }
                    var$1 = oncipj_Cypher_GlobRecursive($this);
                }
            }
            return var$1;
        }
        $this.$jj_la1.data[623] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        var$1 = new oncipj_ParseException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    function oncipj_Cypher_GlobRecursive($this) {
        var var$1, var$2, var$3, var$4, var$5, $$je;
        $this.$jj_la = 2147483647;
        var$1 = $this.$token;
        $this.$jj_scanpos = var$1;
        $this.$jj_lastpos = var$1;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_144($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                var$1 = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 143, 2147483647);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        var$1 = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 143, 2147483647);
                $rt_throw(var$1);
            }
            oncipj_Cypher_jj_save($this, 143, 2147483647);
        }
        e: {
            if (var$2)
                var$1 = oncipj_Cypher_GlobPart($this);
            else {
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                switch (var$3) {
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 135:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 252:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 307:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 202:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                        break e;
                    default:
                        break e;
                }
                var$1 = oncipj_Cypher_GlobPart($this);
                var$4 = oncipj_Cypher_GlobRecursive($this);
                var$5 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$5);
                jl_StringBuilder_append(jl_StringBuilder_append(var$5, var$1), var$4);
                var$1 = jl_AbstractStringBuilder_toString(var$5);
            }
            return var$1;
        }
        $this.$jj_la1.data[624] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        var$1 = new oncipj_ParseException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    function oncipj_Cypher_GlobPart($this) {
        var var$1, var$2, var$3, var$4, $$je;
        $this.$jj_la = 2147483647;
        var$1 = $this.$token;
        $this.$jj_scanpos = var$1;
        $this.$jj_lastpos = var$1;
        a: {
            b: {
                c: {
                    d: {
                        try {
                            var$2 = oncipj_Cypher_jj_3_145($this) ? 0 : 1;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                                break d;
                            } else{
                                var$1 = $$je;
                                break c;
                            }
                        }
                        oncipj_Cypher_jj_save($this, 144, 2147483647);
                        break a;
                    }
                    try {
                        var$2 = 1;
                        break b;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        var$1 = $$je;

                    }
                }
                oncipj_Cypher_jj_save($this, 144, 2147483647);
                $rt_throw(var$1);
            }
            oncipj_Cypher_jj_save($this, 144, 2147483647);
        }
        e: {
            f: {
                if (var$2) {
                    oncipj_Cypher_jj_consume_token($this, 135);
                    var$1 = (oncipj_Cypher_EscapedSymbolicNameString($this)).$image0;
                    var$3 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$3);
                    jl_AbstractStringBuilder_append(var$3, 46);
                    jl_StringBuilder_append(var$3, var$1);
                    var$1 = jl_AbstractStringBuilder_toString(var$3);
                } else {
                    var$4 = $this.$jj_ntk;
                    if (var$4 == (-1))
                        var$4 = oncipj_Cypher_jj_ntk_f($this);
                    switch (var$4) {
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            break;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                            break e;
                        case 135:
                            oncipj_Cypher_jj_consume_token($this, 135);
                            var$1 = $rt_s(142);
                            break f;
                        case 252:
                            oncipj_Cypher_jj_consume_token($this, 252);
                            var$1 = $rt_s(949);
                            break f;
                        case 307:
                            oncipj_Cypher_jj_consume_token($this, 307);
                            var$1 = $rt_s(305);
                            break f;
                        default:
                            break e;
                    }
                    var$1 = (oncipj_Cypher_UnescapedSymbolicNameString($this)).$image0;
                }
            }
            return var$1;
        }
        $this.$jj_la1.data[625] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        var$1 = new oncipj_ParseException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    function oncipj_Cypher_StringImage($this) {
        oncipj_Cypher_StringToken($this);
        return $this.$token.$image0;
    }
    function oncipj_Cypher_StringToken($this) {
        var var$1, var$2;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            switch (var$1) {
                case 52:
                    break;
                case 64:
                    var$2 = oncipj_Cypher_jj_consume_token($this, 64);
                    break a;
                default:
                    $this.$jj_la1.data[627] = $this.$jj_gen;
                    oncipj_Cypher_jj_consume_token($this, (-1));
                    var$2 = new oncipj_ParseException;
                    jl_Throwable__init_0(var$2);
                    $rt_throw(var$2);
            }
            var$2 = oncipj_Cypher_jj_consume_token($this, 52);
        }
        return var$2;
    }
    function oncipj_Cypher_StringOrParameter($this) {
        var var$1, var$2;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$1) {
            case 52:
            case 64:
                break;
            case 131:
                onciaf_ParameterType_$callClinit();
                return onciaf_SimpleEither_right(oncipj_Cypher_Parameter($this, onciaf_ParameterType_STRING));
            default:
                $this.$jj_la1.data[628] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                var$2 = new oncipj_ParseException;
                jl_Throwable__init_0(var$2);
                $rt_throw(var$2);
        }
        return onciaf_SimpleEither_left((oncipj_Cypher_StringToken($this)).$image0);
    }
    function oncipj_Cypher_MapOrParameter($this) {
        var var$1, $parameter, var$3, var$4, var$5;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        switch (var$1) {
            case 131:
                break;
            case 195:
                $parameter = ju_LinkedHashMap__init_();
                oncipj_Cypher_jj_consume_token($this, 195);
                var$3 = $this.$jj_ntk;
                if (var$3 == (-1))
                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                a: {
                    switch (var$3) {
                        case 68:
                        case 69:
                        case 70:
                        case 71:
                        case 72:
                        case 73:
                        case 74:
                        case 75:
                        case 76:
                        case 77:
                        case 78:
                        case 79:
                        case 80:
                        case 81:
                        case 82:
                        case 83:
                        case 84:
                        case 85:
                        case 87:
                        case 88:
                        case 89:
                        case 90:
                        case 91:
                        case 92:
                        case 93:
                        case 94:
                        case 95:
                        case 96:
                        case 97:
                        case 98:
                        case 99:
                        case 100:
                        case 104:
                        case 105:
                        case 106:
                        case 107:
                        case 108:
                        case 109:
                        case 110:
                        case 111:
                        case 112:
                        case 113:
                        case 114:
                        case 115:
                        case 116:
                        case 117:
                        case 118:
                        case 119:
                        case 120:
                        case 121:
                        case 122:
                        case 123:
                        case 124:
                        case 125:
                        case 126:
                        case 127:
                        case 128:
                        case 129:
                        case 130:
                        case 132:
                        case 133:
                        case 137:
                        case 138:
                        case 139:
                        case 140:
                        case 141:
                        case 142:
                        case 143:
                        case 144:
                        case 145:
                        case 146:
                        case 147:
                        case 148:
                        case 149:
                        case 150:
                        case 152:
                        case 153:
                        case 154:
                        case 155:
                        case 156:
                        case 157:
                        case 158:
                        case 159:
                        case 160:
                        case 161:
                        case 162:
                        case 163:
                        case 164:
                        case 165:
                        case 166:
                        case 167:
                        case 169:
                        case 170:
                        case 171:
                        case 172:
                        case 173:
                        case 175:
                        case 176:
                        case 177:
                        case 179:
                        case 180:
                        case 181:
                        case 182:
                        case 183:
                        case 184:
                        case 185:
                        case 186:
                        case 187:
                        case 188:
                        case 189:
                        case 190:
                        case 191:
                        case 197:
                        case 198:
                        case 199:
                        case 200:
                        case 201:
                        case 204:
                        case 205:
                        case 206:
                        case 207:
                        case 212:
                        case 213:
                        case 214:
                        case 215:
                        case 216:
                        case 217:
                        case 218:
                        case 219:
                        case 220:
                        case 221:
                        case 222:
                        case 223:
                        case 224:
                        case 225:
                        case 226:
                        case 227:
                        case 228:
                        case 229:
                        case 230:
                        case 231:
                        case 232:
                        case 233:
                        case 234:
                        case 235:
                        case 236:
                        case 237:
                        case 240:
                        case 241:
                        case 243:
                        case 244:
                        case 245:
                        case 246:
                        case 247:
                        case 248:
                        case 249:
                        case 250:
                        case 251:
                        case 253:
                        case 256:
                        case 257:
                        case 258:
                        case 259:
                        case 261:
                        case 262:
                        case 263:
                        case 264:
                        case 265:
                        case 266:
                        case 267:
                        case 268:
                        case 269:
                        case 270:
                        case 271:
                        case 272:
                        case 273:
                        case 274:
                        case 276:
                        case 277:
                        case 278:
                        case 279:
                        case 280:
                        case 281:
                        case 282:
                        case 284:
                        case 285:
                        case 286:
                        case 287:
                        case 288:
                        case 289:
                        case 290:
                        case 291:
                        case 292:
                        case 293:
                        case 294:
                        case 295:
                        case 296:
                        case 297:
                        case 298:
                        case 299:
                        case 300:
                        case 301:
                        case 302:
                        case 303:
                        case 304:
                        case 305:
                        case 306:
                        case 308:
                        case 309:
                        case 310:
                        case 311:
                        case 312:
                        case 313:
                        case 314:
                        case 315:
                        case 316:
                        case 317:
                        case 318:
                        case 319:
                        case 320:
                        case 321:
                        case 322:
                        case 323:
                        case 324:
                        case 325:
                        case 326:
                        case 327:
                        case 328:
                        case 329:
                        case 330:
                        case 331:
                        case 332:
                        case 333:
                        case 334:
                        case 335:
                        case 336:
                        case 337:
                        case 338:
                        case 339:
                        case 340:
                        case 341:
                            var$4 = oncipj_Cypher_SymbolicNameString($this);
                            oncipj_Cypher_jj_consume_token($this, 101);
                            var$5 = oncipj_Cypher_Expression($this);
                            ju_LinkedHashMap_put($parameter, var$4.$image0, var$5);
                            b: while (true) {
                                var$3 = $this.$jj_ntk;
                                if (var$3 == (-1))
                                    var$3 = oncipj_Cypher_jj_ntk_f($this);
                                switch (var$3) {
                                    case 103:
                                        break;
                                    default:
                                        break b;
                                }
                                oncipj_Cypher_jj_consume_token($this, 103);
                                var$4 = oncipj_Cypher_SymbolicNameString($this);
                                oncipj_Cypher_jj_consume_token($this, 101);
                                var$5 = oncipj_Cypher_Expression($this);
                                ju_LinkedHashMap_put($parameter, var$4.$image0, var$5);
                            }
                            $this.$jj_la1.data[630] = $this.$jj_gen;
                            break a;
                        case 86:
                        case 101:
                        case 102:
                        case 103:
                        case 131:
                        case 134:
                        case 135:
                        case 136:
                        case 151:
                        case 168:
                        case 174:
                        case 178:
                        case 192:
                        case 193:
                        case 194:
                        case 195:
                        case 196:
                        case 202:
                        case 203:
                        case 208:
                        case 209:
                        case 210:
                        case 211:
                        case 238:
                        case 239:
                        case 242:
                        case 252:
                        case 254:
                        case 255:
                        case 260:
                        case 275:
                        case 283:
                        case 307:
                            break;
                        default:
                    }
                    $this.$jj_la1.data[631] = $this.$jj_gen;
                }
                oncipj_Cypher_jj_consume_token($this, 255);
                return onciaf_SimpleEither_left($parameter);
            default:
                $this.$jj_la1.data[629] = $this.$jj_gen;
                oncipj_Cypher_jj_consume_token($this, (-1));
                $parameter = new oncipj_ParseException;
                jl_Throwable__init_0($parameter);
                $rt_throw($parameter);
        }
        onciaf_ParameterType_$callClinit();
        return onciaf_SimpleEither_right(oncipj_Cypher_Parameter($this, onciaf_ParameterType_MAP));
    }
    function oncipj_Cypher_SymbolicNamePositions($this) {
        var $names, var$2, var$3, var$4;
        $names = ju_ArrayList__init_();
        oncipj_Cypher_SymbolicNameString($this);
        var$2 = new onciaf_ASTFactory$StringPos;
        var$3 = $this.$token;
        onciaf_ASTFactory$StringPos__init_0(var$2, var$3.$image0, oncipj_Cypher_pos($this, var$3));
        ju_ArrayList_add($names, var$2);
        a: while (true) {
            var$4 = $this.$jj_ntk;
            if (var$4 == (-1))
                var$4 = oncipj_Cypher_jj_ntk_f($this);
            switch (var$4) {
                case 103:
                    break;
                default:
                    break a;
            }
            oncipj_Cypher_jj_consume_token($this, 103);
            oncipj_Cypher_SymbolicNameString($this);
            var$2 = new onciaf_ASTFactory$StringPos;
            var$3 = $this.$token;
            onciaf_ASTFactory$StringPos__init_0(var$2, var$3.$image0, oncipj_Cypher_pos($this, var$3));
            ju_ArrayList_add($names, var$2);
        }
        $this.$jj_la1.data[632] = $this.$jj_gen;
        return $names;
    }
    function oncipj_Cypher_SymbolicNameString($this) {
        var var$1, $t;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$1) {
                    case 68:
                        break;
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 219:
                    case 220:
                    case 221:
                    case 222:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 317:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        $t = oncipj_Cypher_UnescapedSymbolicNameString($this);
                        break b;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 202:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break a;
                    default:
                        break a;
                }
                $t = oncipj_Cypher_EscapedSymbolicNameString($this);
            }
            return $t;
        }
        $this.$jj_la1.data[633] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $t = new oncipj_ParseException;
        jl_Throwable__init_0($t);
        $rt_throw($t);
    }
    function oncipj_Cypher_EscapedSymbolicNameString($this) {
        return oncipj_Cypher_jj_consume_token($this, 68);
    }
    function oncipj_Cypher_UnescapedSymbolicNameString($this) {
        var var$1, $t;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$1) {
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 79:
                    case 80:
                    case 81:
                    case 82:
                    case 83:
                    case 84:
                    case 85:
                    case 87:
                    case 88:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 98:
                    case 99:
                    case 100:
                    case 104:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 111:
                    case 112:
                    case 113:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 125:
                    case 126:
                    case 127:
                    case 128:
                    case 129:
                    case 130:
                    case 132:
                    case 133:
                    case 137:
                    case 138:
                    case 139:
                    case 140:
                    case 141:
                    case 142:
                    case 143:
                    case 144:
                    case 145:
                    case 146:
                    case 147:
                    case 148:
                    case 149:
                    case 150:
                    case 152:
                    case 153:
                    case 154:
                    case 155:
                    case 156:
                    case 157:
                    case 158:
                    case 159:
                    case 160:
                    case 161:
                    case 162:
                    case 163:
                    case 164:
                    case 165:
                    case 166:
                    case 167:
                    case 169:
                    case 170:
                    case 171:
                    case 172:
                    case 173:
                    case 175:
                    case 176:
                    case 177:
                    case 179:
                    case 180:
                    case 181:
                    case 182:
                    case 183:
                    case 184:
                    case 185:
                    case 186:
                    case 187:
                    case 188:
                    case 189:
                    case 190:
                    case 191:
                    case 197:
                    case 198:
                    case 199:
                    case 200:
                    case 201:
                    case 204:
                    case 205:
                    case 206:
                    case 207:
                    case 212:
                    case 213:
                    case 214:
                    case 215:
                    case 216:
                    case 217:
                    case 218:
                    case 220:
                    case 221:
                    case 223:
                    case 224:
                    case 225:
                    case 226:
                    case 227:
                    case 228:
                    case 229:
                    case 230:
                    case 231:
                    case 232:
                    case 233:
                    case 234:
                    case 235:
                    case 236:
                    case 237:
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 245:
                    case 246:
                    case 247:
                    case 248:
                    case 249:
                    case 250:
                    case 251:
                    case 253:
                    case 256:
                    case 257:
                    case 258:
                    case 259:
                    case 261:
                    case 262:
                    case 263:
                    case 264:
                    case 265:
                    case 266:
                    case 267:
                    case 268:
                    case 269:
                    case 270:
                    case 271:
                    case 272:
                    case 273:
                    case 274:
                    case 276:
                    case 277:
                    case 278:
                    case 279:
                    case 280:
                    case 281:
                    case 282:
                    case 284:
                    case 285:
                    case 286:
                    case 287:
                    case 288:
                    case 289:
                    case 290:
                    case 291:
                    case 292:
                    case 293:
                    case 294:
                    case 295:
                    case 296:
                    case 297:
                    case 298:
                    case 299:
                    case 300:
                    case 301:
                    case 302:
                    case 303:
                    case 304:
                    case 305:
                    case 306:
                    case 308:
                    case 309:
                    case 310:
                    case 311:
                    case 312:
                    case 313:
                    case 314:
                    case 315:
                    case 316:
                    case 318:
                    case 319:
                    case 320:
                    case 321:
                    case 322:
                    case 323:
                    case 324:
                    case 325:
                    case 326:
                    case 327:
                    case 328:
                    case 329:
                    case 330:
                    case 331:
                    case 332:
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                    case 337:
                    case 338:
                    case 339:
                    case 340:
                    case 341:
                        break;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 202:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                        break a;
                    case 219:
                        $t = oncipj_Cypher_jj_consume_token($this, 219);
                        break b;
                    case 222:
                        $t = oncipj_Cypher_jj_consume_token($this, 222);
                        break b;
                    case 317:
                        $t = oncipj_Cypher_jj_consume_token($this, 317);
                        break b;
                    default:
                        break a;
                }
                $t = oncipj_Cypher_UnescapedLabelSymbolicNameString($this);
            }
            return $t;
        }
        $this.$jj_la1.data[634] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $t = new oncipj_ParseException;
        jl_Throwable__init_0($t);
        $rt_throw($t);
    }
    function oncipj_Cypher_UnescapedLabelSymbolicNameString($this) {
        var var$1, $t;
        var$1 = $this.$jj_ntk;
        if (var$1 == (-1))
            var$1 = oncipj_Cypher_jj_ntk_f($this);
        a: {
            b: {
                switch (var$1) {
                    case 69:
                        break;
                    case 70:
                        $t = oncipj_Cypher_jj_consume_token($this, 70);
                        break b;
                    case 71:
                        $t = oncipj_Cypher_jj_consume_token($this, 71);
                        break b;
                    case 72:
                        $t = oncipj_Cypher_jj_consume_token($this, 72);
                        break b;
                    case 73:
                        $t = oncipj_Cypher_jj_consume_token($this, 73);
                        break b;
                    case 74:
                        $t = oncipj_Cypher_jj_consume_token($this, 74);
                        break b;
                    case 75:
                        $t = oncipj_Cypher_jj_consume_token($this, 75);
                        break b;
                    case 76:
                        $t = oncipj_Cypher_jj_consume_token($this, 76);
                        break b;
                    case 77:
                        $t = oncipj_Cypher_jj_consume_token($this, 77);
                        break b;
                    case 78:
                        $t = oncipj_Cypher_jj_consume_token($this, 78);
                        break b;
                    case 79:
                        $t = oncipj_Cypher_jj_consume_token($this, 79);
                        break b;
                    case 80:
                        $t = oncipj_Cypher_jj_consume_token($this, 80);
                        break b;
                    case 81:
                        $t = oncipj_Cypher_jj_consume_token($this, 81);
                        break b;
                    case 82:
                        $t = oncipj_Cypher_jj_consume_token($this, 82);
                        break b;
                    case 83:
                        $t = oncipj_Cypher_jj_consume_token($this, 83);
                        break b;
                    case 84:
                        $t = oncipj_Cypher_jj_consume_token($this, 84);
                        break b;
                    case 85:
                        $t = oncipj_Cypher_jj_consume_token($this, 85);
                        break b;
                    case 86:
                    case 101:
                    case 102:
                    case 103:
                    case 131:
                    case 134:
                    case 135:
                    case 136:
                    case 151:
                    case 168:
                    case 174:
                    case 178:
                    case 192:
                    case 193:
                    case 194:
                    case 195:
                    case 196:
                    case 202:
                    case 203:
                    case 208:
                    case 209:
                    case 210:
                    case 211:
                    case 219:
                    case 222:
                    case 238:
                    case 239:
                    case 242:
                    case 252:
                    case 254:
                    case 255:
                    case 260:
                    case 275:
                    case 283:
                    case 307:
                    case 317:
                        break a;
                    case 87:
                        $t = oncipj_Cypher_jj_consume_token($this, 87);
                        break b;
                    case 88:
                        $t = oncipj_Cypher_jj_consume_token($this, 88);
                        break b;
                    case 89:
                        $t = oncipj_Cypher_jj_consume_token($this, 89);
                        break b;
                    case 90:
                        $t = oncipj_Cypher_jj_consume_token($this, 90);
                        break b;
                    case 91:
                        $t = oncipj_Cypher_jj_consume_token($this, 91);
                        break b;
                    case 92:
                        $t = oncipj_Cypher_jj_consume_token($this, 92);
                        break b;
                    case 93:
                        $t = oncipj_Cypher_jj_consume_token($this, 93);
                        break b;
                    case 94:
                        $t = oncipj_Cypher_jj_consume_token($this, 94);
                        break b;
                    case 95:
                        $t = oncipj_Cypher_jj_consume_token($this, 95);
                        break b;
                    case 96:
                        $t = oncipj_Cypher_jj_consume_token($this, 96);
                        break b;
                    case 97:
                        $t = oncipj_Cypher_jj_consume_token($this, 97);
                        break b;
                    case 98:
                        $t = oncipj_Cypher_jj_consume_token($this, 98);
                        break b;
                    case 99:
                        $t = oncipj_Cypher_jj_consume_token($this, 99);
                        break b;
                    case 100:
                        $t = oncipj_Cypher_jj_consume_token($this, 100);
                        break b;
                    case 104:
                        $t = oncipj_Cypher_jj_consume_token($this, 104);
                        break b;
                    case 105:
                        $t = oncipj_Cypher_jj_consume_token($this, 105);
                        break b;
                    case 106:
                        $t = oncipj_Cypher_jj_consume_token($this, 106);
                        break b;
                    case 107:
                        $t = oncipj_Cypher_jj_consume_token($this, 107);
                        break b;
                    case 108:
                        $t = oncipj_Cypher_jj_consume_token($this, 108);
                        break b;
                    case 109:
                        $t = oncipj_Cypher_jj_consume_token($this, 109);
                        break b;
                    case 110:
                        $t = oncipj_Cypher_jj_consume_token($this, 110);
                        break b;
                    case 111:
                        $t = oncipj_Cypher_jj_consume_token($this, 111);
                        break b;
                    case 112:
                        $t = oncipj_Cypher_jj_consume_token($this, 112);
                        break b;
                    case 113:
                        $t = oncipj_Cypher_jj_consume_token($this, 113);
                        break b;
                    case 114:
                        $t = oncipj_Cypher_jj_consume_token($this, 114);
                        break b;
                    case 115:
                        $t = oncipj_Cypher_jj_consume_token($this, 115);
                        break b;
                    case 116:
                        $t = oncipj_Cypher_jj_consume_token($this, 116);
                        break b;
                    case 117:
                        $t = oncipj_Cypher_jj_consume_token($this, 117);
                        break b;
                    case 118:
                        $t = oncipj_Cypher_jj_consume_token($this, 118);
                        break b;
                    case 119:
                        $t = oncipj_Cypher_jj_consume_token($this, 119);
                        break b;
                    case 120:
                        $t = oncipj_Cypher_jj_consume_token($this, 120);
                        break b;
                    case 121:
                        $t = oncipj_Cypher_jj_consume_token($this, 121);
                        break b;
                    case 122:
                        $t = oncipj_Cypher_jj_consume_token($this, 122);
                        break b;
                    case 123:
                        $t = oncipj_Cypher_jj_consume_token($this, 123);
                        break b;
                    case 124:
                        $t = oncipj_Cypher_jj_consume_token($this, 124);
                        break b;
                    case 125:
                        $t = oncipj_Cypher_jj_consume_token($this, 125);
                        break b;
                    case 126:
                        $t = oncipj_Cypher_jj_consume_token($this, 126);
                        break b;
                    case 127:
                        $t = oncipj_Cypher_jj_consume_token($this, 127);
                        break b;
                    case 128:
                        $t = oncipj_Cypher_jj_consume_token($this, 128);
                        break b;
                    case 129:
                        $t = oncipj_Cypher_jj_consume_token($this, 129);
                        break b;
                    case 130:
                        $t = oncipj_Cypher_jj_consume_token($this, 130);
                        break b;
                    case 132:
                        $t = oncipj_Cypher_jj_consume_token($this, 132);
                        break b;
                    case 133:
                        $t = oncipj_Cypher_jj_consume_token($this, 133);
                        break b;
                    case 137:
                        $t = oncipj_Cypher_jj_consume_token($this, 137);
                        break b;
                    case 138:
                        $t = oncipj_Cypher_jj_consume_token($this, 138);
                        break b;
                    case 139:
                        $t = oncipj_Cypher_jj_consume_token($this, 139);
                        break b;
                    case 140:
                        $t = oncipj_Cypher_jj_consume_token($this, 140);
                        break b;
                    case 141:
                        $t = oncipj_Cypher_jj_consume_token($this, 141);
                        break b;
                    case 142:
                        $t = oncipj_Cypher_jj_consume_token($this, 142);
                        break b;
                    case 143:
                        $t = oncipj_Cypher_jj_consume_token($this, 143);
                        break b;
                    case 144:
                        $t = oncipj_Cypher_jj_consume_token($this, 144);
                        break b;
                    case 145:
                        $t = oncipj_Cypher_jj_consume_token($this, 145);
                        break b;
                    case 146:
                        $t = oncipj_Cypher_jj_consume_token($this, 146);
                        break b;
                    case 147:
                        $t = oncipj_Cypher_jj_consume_token($this, 147);
                        break b;
                    case 148:
                        $t = oncipj_Cypher_jj_consume_token($this, 148);
                        break b;
                    case 149:
                        $t = oncipj_Cypher_jj_consume_token($this, 149);
                        break b;
                    case 150:
                        $t = oncipj_Cypher_jj_consume_token($this, 150);
                        break b;
                    case 152:
                        $t = oncipj_Cypher_jj_consume_token($this, 152);
                        break b;
                    case 153:
                        $t = oncipj_Cypher_jj_consume_token($this, 153);
                        break b;
                    case 154:
                        $t = oncipj_Cypher_jj_consume_token($this, 154);
                        break b;
                    case 155:
                        $t = oncipj_Cypher_jj_consume_token($this, 155);
                        break b;
                    case 156:
                        $t = oncipj_Cypher_jj_consume_token($this, 156);
                        break b;
                    case 157:
                        $t = oncipj_Cypher_jj_consume_token($this, 157);
                        break b;
                    case 158:
                        $t = oncipj_Cypher_jj_consume_token($this, 158);
                        break b;
                    case 159:
                        $t = oncipj_Cypher_jj_consume_token($this, 159);
                        break b;
                    case 160:
                        $t = oncipj_Cypher_jj_consume_token($this, 160);
                        break b;
                    case 161:
                        $t = oncipj_Cypher_jj_consume_token($this, 161);
                        break b;
                    case 162:
                        $t = oncipj_Cypher_jj_consume_token($this, 162);
                        break b;
                    case 163:
                        $t = oncipj_Cypher_jj_consume_token($this, 163);
                        break b;
                    case 164:
                        $t = oncipj_Cypher_jj_consume_token($this, 164);
                        break b;
                    case 165:
                        $t = oncipj_Cypher_jj_consume_token($this, 165);
                        break b;
                    case 166:
                        $t = oncipj_Cypher_jj_consume_token($this, 166);
                        break b;
                    case 167:
                        $t = oncipj_Cypher_jj_consume_token($this, 167);
                        break b;
                    case 169:
                        $t = oncipj_Cypher_jj_consume_token($this, 169);
                        break b;
                    case 170:
                        $t = oncipj_Cypher_jj_consume_token($this, 170);
                        break b;
                    case 171:
                        $t = oncipj_Cypher_jj_consume_token($this, 171);
                        break b;
                    case 172:
                        $t = oncipj_Cypher_jj_consume_token($this, 172);
                        break b;
                    case 173:
                        $t = oncipj_Cypher_jj_consume_token($this, 173);
                        break b;
                    case 175:
                        $t = oncipj_Cypher_jj_consume_token($this, 175);
                        break b;
                    case 176:
                        $t = oncipj_Cypher_jj_consume_token($this, 176);
                        break b;
                    case 177:
                        $t = oncipj_Cypher_jj_consume_token($this, 177);
                        break b;
                    case 179:
                        $t = oncipj_Cypher_jj_consume_token($this, 179);
                        break b;
                    case 180:
                        $t = oncipj_Cypher_jj_consume_token($this, 180);
                        break b;
                    case 181:
                        $t = oncipj_Cypher_jj_consume_token($this, 181);
                        break b;
                    case 182:
                        $t = oncipj_Cypher_jj_consume_token($this, 182);
                        break b;
                    case 183:
                        $t = oncipj_Cypher_jj_consume_token($this, 183);
                        break b;
                    case 184:
                        $t = oncipj_Cypher_jj_consume_token($this, 184);
                        break b;
                    case 185:
                        $t = oncipj_Cypher_jj_consume_token($this, 185);
                        break b;
                    case 186:
                        $t = oncipj_Cypher_jj_consume_token($this, 186);
                        break b;
                    case 187:
                        $t = oncipj_Cypher_jj_consume_token($this, 187);
                        break b;
                    case 188:
                        $t = oncipj_Cypher_jj_consume_token($this, 188);
                        break b;
                    case 189:
                        $t = oncipj_Cypher_jj_consume_token($this, 189);
                        break b;
                    case 190:
                        $t = oncipj_Cypher_jj_consume_token($this, 190);
                        break b;
                    case 191:
                        $t = oncipj_Cypher_jj_consume_token($this, 191);
                        break b;
                    case 197:
                        $t = oncipj_Cypher_jj_consume_token($this, 197);
                        break b;
                    case 198:
                        $t = oncipj_Cypher_jj_consume_token($this, 198);
                        break b;
                    case 199:
                        $t = oncipj_Cypher_jj_consume_token($this, 199);
                        break b;
                    case 200:
                        $t = oncipj_Cypher_jj_consume_token($this, 200);
                        break b;
                    case 201:
                        $t = oncipj_Cypher_jj_consume_token($this, 201);
                        break b;
                    case 204:
                        $t = oncipj_Cypher_jj_consume_token($this, 204);
                        break b;
                    case 205:
                        $t = oncipj_Cypher_jj_consume_token($this, 205);
                        break b;
                    case 206:
                        $t = oncipj_Cypher_jj_consume_token($this, 206);
                        break b;
                    case 207:
                        $t = oncipj_Cypher_jj_consume_token($this, 207);
                        break b;
                    case 212:
                        $t = oncipj_Cypher_jj_consume_token($this, 212);
                        break b;
                    case 213:
                        $t = oncipj_Cypher_jj_consume_token($this, 213);
                        break b;
                    case 214:
                        $t = oncipj_Cypher_jj_consume_token($this, 214);
                        break b;
                    case 215:
                        $t = oncipj_Cypher_jj_consume_token($this, 215);
                        break b;
                    case 216:
                        $t = oncipj_Cypher_jj_consume_token($this, 216);
                        break b;
                    case 217:
                        $t = oncipj_Cypher_jj_consume_token($this, 217);
                        break b;
                    case 218:
                        $t = oncipj_Cypher_jj_consume_token($this, 218);
                        break b;
                    case 220:
                        $t = oncipj_Cypher_jj_consume_token($this, 220);
                        break b;
                    case 221:
                        $t = oncipj_Cypher_jj_consume_token($this, 221);
                        break b;
                    case 223:
                        $t = oncipj_Cypher_jj_consume_token($this, 223);
                        break b;
                    case 224:
                        $t = oncipj_Cypher_jj_consume_token($this, 224);
                        break b;
                    case 225:
                        $t = oncipj_Cypher_jj_consume_token($this, 225);
                        break b;
                    case 226:
                        $t = oncipj_Cypher_jj_consume_token($this, 226);
                        break b;
                    case 227:
                        $t = oncipj_Cypher_jj_consume_token($this, 227);
                        break b;
                    case 228:
                        $t = oncipj_Cypher_jj_consume_token($this, 228);
                        break b;
                    case 229:
                        $t = oncipj_Cypher_jj_consume_token($this, 229);
                        break b;
                    case 230:
                        $t = oncipj_Cypher_jj_consume_token($this, 230);
                        break b;
                    case 231:
                        $t = oncipj_Cypher_jj_consume_token($this, 231);
                        break b;
                    case 232:
                        $t = oncipj_Cypher_jj_consume_token($this, 232);
                        break b;
                    case 233:
                        $t = oncipj_Cypher_jj_consume_token($this, 233);
                        break b;
                    case 234:
                        $t = oncipj_Cypher_jj_consume_token($this, 234);
                        break b;
                    case 235:
                        $t = oncipj_Cypher_jj_consume_token($this, 235);
                        break b;
                    case 236:
                        $t = oncipj_Cypher_jj_consume_token($this, 236);
                        break b;
                    case 237:
                        $t = oncipj_Cypher_jj_consume_token($this, 237);
                        break b;
                    case 240:
                        $t = oncipj_Cypher_jj_consume_token($this, 240);
                        break b;
                    case 241:
                        $t = oncipj_Cypher_jj_consume_token($this, 241);
                        break b;
                    case 243:
                        $t = oncipj_Cypher_jj_consume_token($this, 243);
                        break b;
                    case 244:
                        $t = oncipj_Cypher_jj_consume_token($this, 244);
                        break b;
                    case 245:
                        $t = oncipj_Cypher_jj_consume_token($this, 245);
                        break b;
                    case 246:
                        $t = oncipj_Cypher_jj_consume_token($this, 246);
                        break b;
                    case 247:
                        $t = oncipj_Cypher_jj_consume_token($this, 247);
                        break b;
                    case 248:
                        $t = oncipj_Cypher_jj_consume_token($this, 248);
                        break b;
                    case 249:
                        $t = oncipj_Cypher_jj_consume_token($this, 249);
                        break b;
                    case 250:
                        $t = oncipj_Cypher_jj_consume_token($this, 250);
                        break b;
                    case 251:
                        $t = oncipj_Cypher_jj_consume_token($this, 251);
                        break b;
                    case 253:
                        $t = oncipj_Cypher_jj_consume_token($this, 253);
                        break b;
                    case 256:
                        $t = oncipj_Cypher_jj_consume_token($this, 256);
                        break b;
                    case 257:
                        $t = oncipj_Cypher_jj_consume_token($this, 257);
                        break b;
                    case 258:
                        $t = oncipj_Cypher_jj_consume_token($this, 258);
                        break b;
                    case 259:
                        $t = oncipj_Cypher_jj_consume_token($this, 259);
                        break b;
                    case 261:
                        $t = oncipj_Cypher_jj_consume_token($this, 261);
                        break b;
                    case 262:
                        $t = oncipj_Cypher_jj_consume_token($this, 262);
                        break b;
                    case 263:
                        $t = oncipj_Cypher_jj_consume_token($this, 263);
                        break b;
                    case 264:
                        $t = oncipj_Cypher_jj_consume_token($this, 264);
                        break b;
                    case 265:
                        $t = oncipj_Cypher_jj_consume_token($this, 265);
                        break b;
                    case 266:
                        $t = oncipj_Cypher_jj_consume_token($this, 266);
                        break b;
                    case 267:
                        $t = oncipj_Cypher_jj_consume_token($this, 267);
                        break b;
                    case 268:
                        $t = oncipj_Cypher_jj_consume_token($this, 268);
                        break b;
                    case 269:
                        $t = oncipj_Cypher_jj_consume_token($this, 269);
                        break b;
                    case 270:
                        $t = oncipj_Cypher_jj_consume_token($this, 270);
                        break b;
                    case 271:
                        $t = oncipj_Cypher_jj_consume_token($this, 271);
                        break b;
                    case 272:
                        $t = oncipj_Cypher_jj_consume_token($this, 272);
                        break b;
                    case 273:
                        $t = oncipj_Cypher_jj_consume_token($this, 273);
                        break b;
                    case 274:
                        $t = oncipj_Cypher_jj_consume_token($this, 274);
                        break b;
                    case 276:
                        $t = oncipj_Cypher_jj_consume_token($this, 276);
                        break b;
                    case 277:
                        $t = oncipj_Cypher_jj_consume_token($this, 277);
                        break b;
                    case 278:
                        $t = oncipj_Cypher_jj_consume_token($this, 278);
                        break b;
                    case 279:
                        $t = oncipj_Cypher_jj_consume_token($this, 279);
                        break b;
                    case 280:
                        $t = oncipj_Cypher_jj_consume_token($this, 280);
                        break b;
                    case 281:
                        $t = oncipj_Cypher_jj_consume_token($this, 281);
                        break b;
                    case 282:
                        $t = oncipj_Cypher_jj_consume_token($this, 282);
                        break b;
                    case 284:
                        $t = oncipj_Cypher_jj_consume_token($this, 284);
                        break b;
                    case 285:
                        $t = oncipj_Cypher_jj_consume_token($this, 285);
                        break b;
                    case 286:
                        $t = oncipj_Cypher_jj_consume_token($this, 286);
                        break b;
                    case 287:
                        $t = oncipj_Cypher_jj_consume_token($this, 287);
                        break b;
                    case 288:
                        $t = oncipj_Cypher_jj_consume_token($this, 288);
                        break b;
                    case 289:
                        $t = oncipj_Cypher_jj_consume_token($this, 289);
                        break b;
                    case 290:
                        $t = oncipj_Cypher_jj_consume_token($this, 290);
                        break b;
                    case 291:
                        $t = oncipj_Cypher_jj_consume_token($this, 291);
                        break b;
                    case 292:
                        $t = oncipj_Cypher_jj_consume_token($this, 292);
                        break b;
                    case 293:
                        $t = oncipj_Cypher_jj_consume_token($this, 293);
                        break b;
                    case 294:
                        $t = oncipj_Cypher_jj_consume_token($this, 294);
                        break b;
                    case 295:
                        $t = oncipj_Cypher_jj_consume_token($this, 295);
                        break b;
                    case 296:
                        $t = oncipj_Cypher_jj_consume_token($this, 296);
                        break b;
                    case 297:
                        $t = oncipj_Cypher_jj_consume_token($this, 297);
                        break b;
                    case 298:
                        $t = oncipj_Cypher_jj_consume_token($this, 298);
                        break b;
                    case 299:
                        $t = oncipj_Cypher_jj_consume_token($this, 299);
                        break b;
                    case 300:
                        $t = oncipj_Cypher_jj_consume_token($this, 300);
                        break b;
                    case 301:
                        $t = oncipj_Cypher_jj_consume_token($this, 301);
                        break b;
                    case 302:
                        $t = oncipj_Cypher_jj_consume_token($this, 302);
                        break b;
                    case 303:
                        $t = oncipj_Cypher_jj_consume_token($this, 303);
                        break b;
                    case 304:
                        $t = oncipj_Cypher_jj_consume_token($this, 304);
                        break b;
                    case 305:
                        $t = oncipj_Cypher_jj_consume_token($this, 305);
                        break b;
                    case 306:
                        $t = oncipj_Cypher_jj_consume_token($this, 306);
                        break b;
                    case 308:
                        $t = oncipj_Cypher_jj_consume_token($this, 308);
                        break b;
                    case 309:
                        $t = oncipj_Cypher_jj_consume_token($this, 309);
                        break b;
                    case 310:
                        $t = oncipj_Cypher_jj_consume_token($this, 310);
                        break b;
                    case 311:
                        $t = oncipj_Cypher_jj_consume_token($this, 311);
                        break b;
                    case 312:
                        $t = oncipj_Cypher_jj_consume_token($this, 312);
                        break b;
                    case 313:
                        $t = oncipj_Cypher_jj_consume_token($this, 313);
                        break b;
                    case 314:
                        $t = oncipj_Cypher_jj_consume_token($this, 314);
                        break b;
                    case 315:
                        $t = oncipj_Cypher_jj_consume_token($this, 315);
                        break b;
                    case 316:
                        $t = oncipj_Cypher_jj_consume_token($this, 316);
                        break b;
                    case 318:
                        $t = oncipj_Cypher_jj_consume_token($this, 318);
                        break b;
                    case 319:
                        $t = oncipj_Cypher_jj_consume_token($this, 319);
                        break b;
                    case 320:
                        $t = oncipj_Cypher_jj_consume_token($this, 320);
                        break b;
                    case 321:
                        $t = oncipj_Cypher_jj_consume_token($this, 321);
                        break b;
                    case 322:
                        $t = oncipj_Cypher_jj_consume_token($this, 322);
                        break b;
                    case 323:
                        $t = oncipj_Cypher_jj_consume_token($this, 323);
                        break b;
                    case 324:
                        $t = oncipj_Cypher_jj_consume_token($this, 324);
                        break b;
                    case 325:
                        $t = oncipj_Cypher_jj_consume_token($this, 325);
                        break b;
                    case 326:
                        $t = oncipj_Cypher_jj_consume_token($this, 326);
                        break b;
                    case 327:
                        $t = oncipj_Cypher_jj_consume_token($this, 327);
                        break b;
                    case 328:
                        $t = oncipj_Cypher_jj_consume_token($this, 328);
                        break b;
                    case 329:
                        $t = oncipj_Cypher_jj_consume_token($this, 329);
                        break b;
                    case 330:
                        $t = oncipj_Cypher_jj_consume_token($this, 330);
                        break b;
                    case 331:
                        $t = oncipj_Cypher_jj_consume_token($this, 331);
                        break b;
                    case 332:
                        $t = oncipj_Cypher_jj_consume_token($this, 332);
                        break b;
                    case 333:
                        $t = oncipj_Cypher_jj_consume_token($this, 333);
                        break b;
                    case 334:
                        $t = oncipj_Cypher_jj_consume_token($this, 334);
                        break b;
                    case 335:
                        $t = oncipj_Cypher_jj_consume_token($this, 335);
                        break b;
                    case 336:
                        $t = oncipj_Cypher_jj_consume_token($this, 336);
                        break b;
                    case 337:
                        $t = oncipj_Cypher_jj_consume_token($this, 337);
                        break b;
                    case 338:
                        $t = oncipj_Cypher_jj_consume_token($this, 338);
                        break b;
                    case 339:
                        $t = oncipj_Cypher_jj_consume_token($this, 339);
                        break b;
                    case 340:
                        $t = oncipj_Cypher_jj_consume_token($this, 340);
                        break b;
                    case 341:
                        $t = oncipj_Cypher_jj_consume_token($this, 341);
                        break b;
                    default:
                        break a;
                }
                $t = oncipj_Cypher_jj_consume_token($this, 69);
            }
            return $t;
        }
        $this.$jj_la1.data[636] = $this.$jj_gen;
        oncipj_Cypher_jj_consume_token($this, (-1));
        $rt_throw(oncipj_ParseException__init_());
    }
    function oncipj_Cypher_jj_2_1($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_1($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 0, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 0, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 0, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_2($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_2($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 1, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 1, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 1, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_5($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_5($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 4, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 4, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 4, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_12($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_12($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 11, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 11, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 11, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_22($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_22($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 21, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 21, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 21, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_23($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_23($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 22, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 22, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 22, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_24($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_24($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 23, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 23, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 23, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_25($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_25($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 24, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 24, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 24, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_26($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_26($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 25, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 25, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 25, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_47($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_47($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 46, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 46, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 46, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_48($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_48($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 47, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 47, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 47, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_51($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_51($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 50, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 50, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 50, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_52($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_52($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 51, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 51, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 51, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_53($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_53($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 52, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 52, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 52, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_54($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_54($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 53, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 53, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 53, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_75($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_75($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 74, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 74, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 74, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_76($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_76($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 75, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 75, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 75, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_77($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_77($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 76, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 76, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 76, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_78($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_78($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 77, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 77, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 77, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_79($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_79($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 78, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 78, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 78, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_80($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_80($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 79, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 79, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 79, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_81($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_81($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 80, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 80, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 80, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_82($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_82($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 81, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 81, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 81, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_83($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_83($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 82, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 82, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 82, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_84($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_84($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 83, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 83, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 83, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_85($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_85($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 84, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 84, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 84, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_86($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_86($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 85, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 85, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 85, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_87($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_87($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 86, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 86, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 86, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_88($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_88($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 87, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 87, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 87, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_89($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_89($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 88, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 88, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 88, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_90($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_90($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 89, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 89, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 89, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_96($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_96($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 95, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 95, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 95, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_97($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_97($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 96, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 96, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 96, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_98($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_98($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 97, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 97, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 97, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_99($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_99($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 98, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 98, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 98, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_100($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_100($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 99, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 99, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 99, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_115($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_115($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 114, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 114, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 114, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_116($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_116($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 115, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 115, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 115, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_117($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_117($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 116, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 116, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 116, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_118($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_118($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 117, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 117, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 117, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_119($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_119($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 118, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 118, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 118, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_121($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_121($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 120, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 120, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 120, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_136($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_136($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 135, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 135, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 135, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_137($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_137($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 136, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 136, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 136, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_138($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_138($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 137, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 137, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 137, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_139($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_139($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 138, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 138, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 138, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_2_140($this, $xla) {
        var var$2, var$3, $$je;
        $this.$jj_la = $xla;
        var$2 = $this.$token;
        $this.$jj_scanpos = var$2;
        $this.$jj_lastpos = var$2;
        a: {
            b: {
                c: {
                    try {
                        var$3 = oncipj_Cypher_jj_3_140($this) ? 0 : 1;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                            break c;
                        } else{
                            var$2 = $$je;
                            break b;
                        }
                    }
                    oncipj_Cypher_jj_save($this, 139, $xla);
                    return var$3;
                }
                try {
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$2 = $$je;

                }
            }
            oncipj_Cypher_jj_save($this, 139, $xla);
            $rt_throw(var$2);
        }
        oncipj_Cypher_jj_save($this, 139, $xla);
        return 1;
    }
    function oncipj_Cypher_jj_3_16($this) {
        if (!oncipj_Cypher_jj_3R_75($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_306($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 81) ? 1 : !oncipj_Cypher_jj_3R_77($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_133($this) {
        var $xsp, var$2, var$3;
        if (oncipj_Cypher_jj_scan_token($this, 339))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_scan_token($this, 307) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_3R_306($this))
                var$2 = 1;
            else {
                while (true) {
                    $xsp = $this.$jj_scanpos;
                    if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_306($this) ? 0 : 1))
                        continue;
                    else
                        break;
                }
                $this.$jj_scanpos = $xsp;
                var$2 = 0;
            }
            if (var$2)
                return 1;
        }
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 230))
            var$2 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 95))
            var$2 = 1;
        else if (oncipj_Cypher_jj_3R_308($this))
            var$2 = 1;
        else {
            while (true) {
                var$3 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_308($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$3;
            var$2 = 0;
        }
        if (var$2)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 294) ? 1 : !oncipj_Cypher_jj_3R_310($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 197) ? 1 : !oncipj_Cypher_jj_3R_310($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_653($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_128($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 81) ? 1 : !oncipj_Cypher_jj_3R_77($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_136($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_137($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 334))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_630($this) {
        if (!oncipj_Cypher_jj_3R_415($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_293($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_361($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_361($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_361($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_17($this)) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_509($this) ? 0 : 1)
                $this.$jj_scanpos = $xsp;
        }
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_3_19($this)) {
                $this.$jj_scanpos = $xsp;
                if (!oncipj_Cypher_jj_3R_270($this) ? 0 : 1) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (!var$2)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_17($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 151))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_509($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_18($this) {
        if (oncipj_Cypher_jj_scan_token($this, 195))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 36))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 255))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_553($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 295))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_658($this) {
        var $xsp, var$2, var$3;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_18($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 195))
                var$2 = 1;
            else {
                var$3 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_scan_token($this, 36))
                    $this.$jj_scanpos = var$3;
                if (oncipj_Cypher_jj_scan_token($this, 103))
                    var$2 = 1;
                else {
                    var$3 = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 36))
                        $this.$jj_scanpos = var$3;
                    var$2 = !oncipj_Cypher_jj_scan_token($this, 255) ? 0 : 1;
                }
            }
            if (var$2) {
                $this.$jj_scanpos = $xsp;
                if (!oncipj_Cypher_jj_scan_token($this, 238) ? 0 : 1) {
                    $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_scan_token($this, 307) ? 0 : 1)
                        return 1;
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_554($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 298))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_19($this) {
        if (!oncipj_Cypher_jj_3R_79($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_79($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 289) ? 1 : oncipj_Cypher_jj_scan_token($this, 202) ? 1 : oncipj_Cypher_jj_3R_270($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 75) ? 1 : oncipj_Cypher_jj_scan_token($this, 202) ? 1 : oncipj_Cypher_jj_3R_270($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_101($this) {
        if (oncipj_Cypher_jj_scan_token($this, 116))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 325))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_270($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_3R_395($this))
            var$1 = 1;
        else {
            while (true) {
                var$2 = $this.$jj_scanpos;
                if (!oncipj_Cypher_jj_3R_395($this))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_138($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_143($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_133($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_139($this) {
        if (!oncipj_Cypher_jj_3R_133($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_140($this) {
        if (!oncipj_Cypher_jj_3R_134($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_21($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_81($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_20($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_395($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_21($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 202))
                var$2 = 1;
            else if (oncipj_Cypher_jj_3R_361($this))
                var$2 = 1;
            else {
                $xsp = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                    $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 275))
                    var$2 = 1;
                else {
                    $xsp = $this.$jj_scanpos;
                    if (!oncipj_Cypher_jj_3R_658($this) ? 0 : 1)
                        $this.$jj_scanpos = $xsp;
                    var$2 = 0;
                }
            }
            if (!var$2 ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_102($this) {
        if (oncipj_Cypher_jj_scan_token($this, 116))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 325))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_20($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_3R_85($this))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_658($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (var$1)
            return 1;
        if (!oncipj_Cypher_jj_3R_81($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_509($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_22($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_3_23($this)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_3_24($this)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_3_25($this)) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_3_26($this)) {
                            $this.$jj_scanpos = $xsp;
                            if (oncipj_Cypher_jj_scan_token($this, 290))
                                var$2 = 1;
                            else if (oncipj_Cypher_jj_scan_token($this, 36))
                                var$2 = 1;
                            else {
                                a: {
                                    $xsp = $this.$jj_scanpos;
                                    if (oncipj_Cypher_jj_scan_token($this, 234)) {
                                        $this.$jj_scanpos = $xsp;
                                        if (oncipj_Cypher_jj_scan_token($this, 235)) {
                                            var$2 = 1;
                                            break a;
                                        }
                                    }
                                    var$2 = 0;
                                }
                                if (var$2)
                                    $this.$jj_scanpos = $xsp;
                                var$2 = 0;
                            }
                            if (var$2)
                                return 1;
                        }
                    }
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_22($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 79))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 290))
            return 1;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 234)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 235)) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (var$2)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_23($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 76))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 290))
            return 1;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 234)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 235)) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (var$2)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_24($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 79))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 36))
            $this.$jj_scanpos = $xsp;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 234)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 235)) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (var$2)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_25($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 76))
            return 1;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 234)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 235)) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (var$2)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_26($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 290))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 36))
            $this.$jj_scanpos = $xsp;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 234)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 235)) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (var$2)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 172)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 173))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_106($this) {
        if (!oncipj_Cypher_jj_3R_135($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_200($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_81($this))
            return 1;
        if (oncipj_Cypher_jj_3_27($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_27($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_27($this) {
        if (oncipj_Cypher_jj_3R_85($this))
            return 1;
        if (!oncipj_Cypher_jj_3R_81($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_103($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_130($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_133($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_104($this) {
        if (!oncipj_Cypher_jj_3R_133($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_105($this) {
        if (!oncipj_Cypher_jj_3R_134($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_81($this) {
        var $xsp, var$2, var$3;
        if (oncipj_Cypher_jj_scan_token($this, 202))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!(!oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_3R_77($this) ? (!oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1) : 1) ? 0 : 1) {
                $this.$jj_scanpos = $xsp;
                if (!oncipj_Cypher_jj_3R_86($this)) {
                    var$2 = $this.$jj_scanpos;
                    if (!oncipj_Cypher_jj_3R_87($this) ? 0 : 1)
                        $this.$jj_scanpos = var$2;
                    var$2 = $this.$jj_scanpos;
                    if (!oncipj_Cypher_jj_scan_token($this, 334) ? (!oncipj_Cypher_jj_3R_75($this) ? 0 : 1) : 1)
                        $this.$jj_scanpos = var$2;
                    var$3 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
                } else
                    var$3 = 1;
                if (!var$3 ? 0 : 1) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_3R_77($this))
                        var$3 = 1;
                    else if (oncipj_Cypher_jj_3R_86($this))
                        var$3 = 1;
                    else {
                        var$2 = $this.$jj_scanpos;
                        if (!oncipj_Cypher_jj_3R_87($this) ? 0 : 1)
                            $this.$jj_scanpos = var$2;
                        var$2 = $this.$jj_scanpos;
                        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                            $this.$jj_scanpos = var$2;
                        var$3 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
                    }
                    if (!var$3 ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_3R_87($this))
                            var$3 = 1;
                        else {
                            var$2 = $this.$jj_scanpos;
                            if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                                $this.$jj_scanpos = var$2;
                            var$3 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
                        }
                        if (!var$3 ? 0 : 1) {
                            $this.$jj_scanpos = $xsp;
                            var$3 = oncipj_Cypher_jj_3R_86($this) ? 1 : oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1;
                            a: {
                                if (var$3) {
                                    $this.$jj_scanpos = $xsp;
                                    if (oncipj_Cypher_jj_3_34($this)) {
                                        $this.$jj_scanpos = $xsp;
                                        if (oncipj_Cypher_jj_3R_77($this) ? 1 : oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1) {
                                            $this.$jj_scanpos = $xsp;
                                            if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1) {
                                                $this.$jj_scanpos = $xsp;
                                                if (oncipj_Cypher_jj_3_37($this)) {
                                                    $this.$jj_scanpos = $xsp;
                                                    if (oncipj_Cypher_jj_3R_86($this))
                                                        var$3 = 1;
                                                    else if (oncipj_Cypher_jj_3R_87($this))
                                                        var$3 = 1;
                                                    else {
                                                        var$2 = $this.$jj_scanpos;
                                                        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                                                            $this.$jj_scanpos = var$2;
                                                        var$3 = 0;
                                                    }
                                                    if (var$3) {
                                                        $this.$jj_scanpos = $xsp;
                                                        if (!oncipj_Cypher_jj_3R_86($this) ? 0 : 1) {
                                                            var$3 = 1;
                                                            break a;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                var$3 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
                            }
                            if (!var$3 ? 0 : 1)
                                return 1;
                        }
                    }
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_28($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_29($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_30($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 101))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_31($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 101))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_32($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 195)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 131))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_110($this) {
        if (!oncipj_Cypher_jj_3R_135($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_107($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_130($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_133($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_108($this) {
        if (!oncipj_Cypher_jj_3R_133($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_109($this) {
        if (!oncipj_Cypher_jj_3R_134($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_135($this) {
        var $xsp, var$2, var$3, var$4, var$5;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 303))
            var$2 = 1;
        else {
            a: {
                var$3 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_scan_token($this, 312)) {
                    $this.$jj_scanpos = var$3;
                    if (oncipj_Cypher_jj_scan_token($this, 313)) {
                        var$2 = 1;
                        break a;
                    }
                }
                var$3 = $this.$jj_scanpos;
                var$2 = !oncipj_Cypher_jj_3R_135($this) ? 0 : 1;
                b: {
                    if (var$2) {
                        c: {
                            $this.$jj_scanpos = var$3;
                            if (!oncipj_Cypher_jj_3R_130($this)) {
                                var$4 = $this.$jj_scanpos;
                                if (!oncipj_Cypher_jj_3R_133($this)) {
                                    var$5 = $this.$jj_scanpos;
                                    if (!oncipj_Cypher_jj_3R_510($this) ? 0 : 1)
                                        $this.$jj_scanpos = var$5;
                                    var$2 = 0;
                                } else
                                    var$2 = 1;
                                if (var$2) {
                                    $this.$jj_scanpos = var$4;
                                    if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
                                        var$2 = 1;
                                        break c;
                                    }
                                }
                                var$2 = 0;
                            } else
                                var$2 = 1;
                        }
                        d: {
                            if (var$2) {
                                $this.$jj_scanpos = var$3;
                                if (oncipj_Cypher_jj_3R_133($this))
                                    var$2 = 1;
                                else {
                                    var$4 = $this.$jj_scanpos;
                                    if (!oncipj_Cypher_jj_3R_510($this) ? 0 : 1)
                                        $this.$jj_scanpos = var$4;
                                    var$2 = 0;
                                }
                                if (var$2) {
                                    $this.$jj_scanpos = var$3;
                                    if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
                                        $this.$jj_scanpos = var$3;
                                        if (!oncipj_Cypher_jj_3R_130($this) ? 0 : 1) {
                                            var$2 = 1;
                                            break d;
                                        }
                                    }
                                }
                            }
                            var$4 = $this.$jj_scanpos;
                            if (!oncipj_Cypher_jj_3R_135($this) ? 0 : 1)
                                $this.$jj_scanpos = var$4;
                            var$2 = 0;
                        }
                        if (var$2) {
                            var$2 = 1;
                            break b;
                        }
                    }
                    var$2 = 0;
                }
                if (var$2)
                    $this.$jj_scanpos = var$3;
                var$2 = 0;
            }
            var$2 = !var$2 ? 0 : 1;
        }
        if (var$2) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 291))
                var$2 = 1;
            else {
                e: {
                    $xsp = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 312)) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_scan_token($this, 313)) {
                            var$2 = 1;
                            break e;
                        }
                    }
                    $xsp = $this.$jj_scanpos;
                    var$2 = !oncipj_Cypher_jj_3R_135($this) ? 0 : 1;
                    f: {
                        if (var$2) {
                            g: {
                                $this.$jj_scanpos = $xsp;
                                if (oncipj_Cypher_jj_3R_130($this))
                                    var$2 = 1;
                                else {
                                    var$3 = $this.$jj_scanpos;
                                    if (oncipj_Cypher_jj_3R_133($this))
                                        var$2 = 1;
                                    else {
                                        var$4 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_510($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$4;
                                        var$2 = 0;
                                    }
                                    if (var$2) {
                                        $this.$jj_scanpos = var$3;
                                        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
                                            var$2 = 1;
                                            break g;
                                        }
                                    }
                                    var$2 = 0;
                                }
                            }
                            h: {
                                if (var$2) {
                                    $this.$jj_scanpos = $xsp;
                                    if (oncipj_Cypher_jj_3R_133($this))
                                        var$2 = 1;
                                    else {
                                        var$3 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_510($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        var$2 = 0;
                                    }
                                    if (var$2) {
                                        $this.$jj_scanpos = $xsp;
                                        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
                                            $this.$jj_scanpos = $xsp;
                                            if (!oncipj_Cypher_jj_3R_130($this) ? 0 : 1) {
                                                var$2 = 1;
                                                break h;
                                            }
                                        }
                                    }
                                }
                                var$3 = $this.$jj_scanpos;
                                if (!oncipj_Cypher_jj_3R_135($this) ? 0 : 1)
                                    $this.$jj_scanpos = var$3;
                                var$2 = 0;
                            }
                            if (var$2) {
                                var$2 = 1;
                                break f;
                            }
                        }
                        var$2 = 0;
                    }
                    if (var$2)
                        $this.$jj_scanpos = $xsp;
                    var$2 = 0;
                }
                var$2 = !var$2 ? 0 : 1;
            }
            if (var$2)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_130($this) {
        var $xsp, var$2, var$3;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3R_138($this))
            var$2 = 1;
        else {
            while (true) {
                var$3 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_138($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$3;
            var$2 = 0;
        }
        if (!var$2 ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_141($this) {
        if (oncipj_Cypher_jj_3R_143($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 162))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_111($this) {
        if (oncipj_Cypher_jj_3R_138($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 103))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_143($this) {
        var $xsp, var$2, var$3;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3R_128($this))
            var$2 = 1;
        else {
            while (true) {
                var$3 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 135) ? 1 : !oncipj_Cypher_jj_3R_128($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$3;
            var$2 = 0;
        }
        if (var$2) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_283($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_112($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_130($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_133($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_34($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_3R_87($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_238($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_315($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_315($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_37($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_3R_86($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_87($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_33($this) {
        if (oncipj_Cypher_jj_3R_86($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 334))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_113($this) {
        if (!oncipj_Cypher_jj_3R_133($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_114($this) {
        if (!oncipj_Cypher_jj_3R_134($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_35($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 334))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_36($this) {
        if (oncipj_Cypher_jj_scan_token($this, 334))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_315($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_128($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_283($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_38($this) {
        if (oncipj_Cypher_jj_3R_86($this))
            return 1;
        if (!oncipj_Cypher_jj_3R_87($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_645($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3_39($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_39($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_39($this) {
        if (!oncipj_Cypher_jj_3R_88($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_142($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_3R_146($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 103)) {
            a: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 224))
                    var$2 = 1;
                else if (oncipj_Cypher_jj_scan_token($this, 122))
                    var$2 = 1;
                else {
                    $xsp = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 310)) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_scan_token($this, 164)) {
                            var$2 = 1;
                            break a;
                        }
                    }
                    var$2 = oncipj_Cypher_jj_3R_238($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 0) ? 0 : 1;
                }
            }
            if (var$2)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_115($this) {
        if (!oncipj_Cypher_jj_3R_128($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_116($this) {
        if (oncipj_Cypher_jj_scan_token($this, 224))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 202))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_143($this) {
        if (oncipj_Cypher_jj_3R_146($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 135))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_411($this) {
        if (!oncipj_Cypher_jj_3R_86($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_117($this) {
        if (oncipj_Cypher_jj_scan_token($this, 162))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 202))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_118($this) {
        if (oncipj_Cypher_jj_scan_token($this, 177))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 219))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_88($this) {
        if (oncipj_Cypher_jj_scan_token($this, 101))
            return 1;
        if (!oncipj_Cypher_jj_3R_128($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_119($this) {
        if (oncipj_Cypher_jj_scan_token($this, 83))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 156))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_144($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        var$2 = oncipj_Cypher_jj_scan_token($this, 135) ? 1 : !oncipj_Cypher_jj_3R_146($this) ? 0 : 1;
        a: {
            if (var$2) {
                $this.$jj_scanpos = $xsp;
                if (!oncipj_Cypher_jj_scan_token($this, 252) ? 0 : 1) {
                    $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_scan_token($this, 307) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (!oncipj_Cypher_jj_scan_token($this, 135) ? 0 : 1) {
                            $this.$jj_scanpos = $xsp;
                            if (!oncipj_Cypher_jj_3R_304($this) ? 0 : 1) {
                                var$2 = 1;
                                break a;
                            }
                        }
                    }
                }
            }
            var$2 = 0;
        }
        if (var$2)
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 103)) {
            b: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 224))
                    var$2 = 1;
                else if (oncipj_Cypher_jj_scan_token($this, 122))
                    var$2 = 1;
                else {
                    $xsp = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 310)) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_scan_token($this, 164)) {
                            var$2 = 1;
                            break b;
                        }
                    }
                    var$2 = oncipj_Cypher_jj_3R_238($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 0) ? 0 : 1;
                }
            }
            if (var$2)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_87($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_40($this)) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_283($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_145($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 135))
            return 1;
        if (oncipj_Cypher_jj_3R_146($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 135)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 103)) {
                a: {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 224))
                        var$2 = 1;
                    else if (oncipj_Cypher_jj_scan_token($this, 122))
                        var$2 = 1;
                    else {
                        $xsp = $this.$jj_scanpos;
                        if (oncipj_Cypher_jj_scan_token($this, 310)) {
                            $this.$jj_scanpos = $xsp;
                            if (oncipj_Cypher_jj_scan_token($this, 164)) {
                                var$2 = 1;
                                break a;
                            }
                        }
                        var$2 = oncipj_Cypher_jj_3R_238($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 0) ? 0 : 1;
                    }
                }
                if (var$2)
                    return 1;
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_40($this) {
        if (!oncipj_Cypher_jj_3R_89($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_138($this) {
        if (!oncipj_Cypher_jj_3R_215($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_85($this) {
        var $xsp, var$2, var$3;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 203)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 345)) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (!var$2 ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (!oncipj_Cypher_jj_3R_91($this)) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_91($this)) {
                var$3 = $this.$jj_scanpos;
                if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
                    $this.$jj_scanpos = var$3;
                var$2 = 0;
            } else
                var$2 = 1;
            if (!var$2 ? 0 : 1) {
                b: {
                    $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_scan_token($this, 194)) {
                        $xsp = $this.$jj_scanpos;
                        if (oncipj_Cypher_jj_scan_token($this, 254))
                            var$2 = 1;
                        else if (oncipj_Cypher_jj_3R_91($this))
                            var$2 = 1;
                        else {
                            var$3 = $this.$jj_scanpos;
                            if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
                                $this.$jj_scanpos = var$3;
                            var$2 = 0;
                        }
                        if (!var$2 ? 0 : 1) {
                            $this.$jj_scanpos = $xsp;
                            if (!oncipj_Cypher_jj_3R_77($this)) {
                                if (!oncipj_Cypher_jj_scan_token($this, 254)) {
                                    if (!oncipj_Cypher_jj_3R_91($this)) {
                                        var$3 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        var$2 = 0;
                                    } else
                                        var$2 = 1;
                                } else
                                    var$2 = 1;
                            } else
                                var$2 = 1;
                            if (!var$2 ? 0 : 1) {
                                $this.$jj_scanpos = $xsp;
                                if (oncipj_Cypher_jj_3R_86($this))
                                    var$2 = 1;
                                else {
                                    var$3 = $this.$jj_scanpos;
                                    if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
                                        $this.$jj_scanpos = var$3;
                                    var$3 = $this.$jj_scanpos;
                                    if (!oncipj_Cypher_jj_3R_87($this) ? 0 : 1)
                                        $this.$jj_scanpos = var$3;
                                    var$3 = $this.$jj_scanpos;
                                    if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                                        $this.$jj_scanpos = var$3;
                                    if (oncipj_Cypher_jj_scan_token($this, 254))
                                        var$2 = 1;
                                    else if (oncipj_Cypher_jj_3R_91($this))
                                        var$2 = 1;
                                    else {
                                        var$3 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        var$2 = 0;
                                    }
                                }
                                if (!var$2 ? 0 : 1) {
                                    $this.$jj_scanpos = $xsp;
                                    if (oncipj_Cypher_jj_3R_77($this))
                                        var$2 = 1;
                                    else if (oncipj_Cypher_jj_3R_86($this))
                                        var$2 = 1;
                                    else {
                                        var$3 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        var$3 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_87($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        var$3 = $this.$jj_scanpos;
                                        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        if (oncipj_Cypher_jj_scan_token($this, 254))
                                            var$2 = 1;
                                        else if (oncipj_Cypher_jj_3R_91($this))
                                            var$2 = 1;
                                        else {
                                            var$3 = $this.$jj_scanpos;
                                            if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
                                                $this.$jj_scanpos = var$3;
                                            var$2 = 0;
                                        }
                                    }
                                    if (!var$2 ? 0 : 1) {
                                        $this.$jj_scanpos = $xsp;
                                        if (!oncipj_Cypher_jj_3R_373($this) ? 0 : 1) {
                                            $this.$jj_scanpos = $xsp;
                                            if (!oncipj_Cypher_jj_3R_374($this) ? 0 : 1) {
                                                $this.$jj_scanpos = $xsp;
                                                if (!oncipj_Cypher_jj_3R_375($this) ? 0 : 1) {
                                                    $this.$jj_scanpos = $xsp;
                                                    if (oncipj_Cypher_jj_3R_303($this)) {
                                                        var$2 = 1;
                                                        break b;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        var$2 = 0;
                    } else
                        var$2 = 1;
                }
                if (var$2)
                    return 1;
            }
            return 0;
        }
        return 1;
    }
    function oncipj_Cypher_jj_3R_215($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 52)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 64))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_48($this) {
        if (!oncipj_Cypher_jj_3R_91($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_41($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_303($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3R_86($this))
            var$2 = 1;
        else {
            var$3 = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
                $this.$jj_scanpos = var$3;
            var$2 = oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1;
        }
        a: {
            if (var$2) {
                $this.$jj_scanpos = var$1;
                if (oncipj_Cypher_jj_3R_77($this))
                    var$2 = 1;
                else {
                    var$3 = $this.$jj_scanpos;
                    if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
                        $this.$jj_scanpos = var$3;
                    if (oncipj_Cypher_jj_3R_87($this))
                        var$2 = 1;
                    else {
                        var$3 = $this.$jj_scanpos;
                        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                            $this.$jj_scanpos = var$3;
                        var$2 = 0;
                    }
                }
                if (var$2) {
                    $this.$jj_scanpos = var$1;
                    if (oncipj_Cypher_jj_3R_77($this))
                        var$2 = 1;
                    else {
                        var$3 = $this.$jj_scanpos;
                        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
                            $this.$jj_scanpos = var$3;
                        var$2 = oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1;
                    }
                    if (var$2) {
                        $this.$jj_scanpos = var$1;
                        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1) {
                            $this.$jj_scanpos = var$1;
                            if (oncipj_Cypher_jj_3_53($this)) {
                                $this.$jj_scanpos = var$1;
                                if (oncipj_Cypher_jj_3R_86($this))
                                    var$2 = 1;
                                else {
                                    var$3 = $this.$jj_scanpos;
                                    if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
                                        $this.$jj_scanpos = var$3;
                                    if (oncipj_Cypher_jj_3R_87($this))
                                        var$2 = 1;
                                    else {
                                        var$3 = $this.$jj_scanpos;
                                        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        var$2 = 0;
                                    }
                                }
                                if (var$2) {
                                    $this.$jj_scanpos = var$1;
                                    if (oncipj_Cypher_jj_3R_86($this))
                                        var$2 = 1;
                                    else {
                                        var$1 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$1;
                                        var$2 = 0;
                                    }
                                    if (var$2) {
                                        var$2 = 1;
                                        break a;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (oncipj_Cypher_jj_scan_token($this, 254))
                var$2 = 1;
            else if (oncipj_Cypher_jj_3R_91($this))
                var$2 = 1;
            else {
                var$1 = $this.$jj_scanpos;
                if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
                    $this.$jj_scanpos = var$1;
                var$2 = 0;
            }
        }
        if (!var$2)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_42($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_43($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 101))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_44($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 101))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_45($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 195)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 131))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_46($this) {
        if (!oncipj_Cypher_jj_3R_90($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_47($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_3R_90($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_575($this) {
        if (!oncipj_Cypher_jj_3R_142($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_128($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_146($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_304($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_142($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_141($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_120($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_120($this) {
        if (oncipj_Cypher_jj_scan_token($this, 86))
            return 1;
        if (!oncipj_Cypher_jj_3R_141($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_146($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 68))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_141($this) {
        var $xsp, var$2, var$3;
        $xsp = $this.$jj_scanpos;
        var$2 = !oncipj_Cypher_jj_scan_token($this, 220) ? 0 : 1;
        a: {
            if (!var$2)
                break a;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 222) ? 0 : 1))
                break a;
            b: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 89)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 88)) {
                        var$2 = 1;
                        break b;
                    }
                }
                var$2 = 0;
            }
            if (!var$2)
                break a;
            c: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 299)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 329)) {
                        var$2 = 1;
                        break c;
                    }
                }
                var$2 = 0;
            }
            if (!var$2)
                break a;
            d: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 185)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 292))
                        $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_scan_token($this, 186) ? 0 : 1) {
                        var$2 = 1;
                        break d;
                    }
                }
                var$2 = 0;
            }
            if (!var$2)
                break a;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 161) ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 120) ? 0 : 1))
                break a;
            e: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 200))
                    var$2 = 1;
                else {
                    var$3 = $this.$jj_scanpos;
                    if (!oncipj_Cypher_jj_scan_token($this, 306) ? 0 : 1) {
                        $this.$jj_scanpos = var$3;
                        if (!oncipj_Cypher_jj_scan_token($this, 121) ? 0 : 1) {
                            var$2 = 1;
                            break e;
                        }
                    }
                    var$2 = 0;
                }
            }
            if (!var$2)
                break a;
            f: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 340))
                    var$2 = 1;
                else {
                    var$3 = $this.$jj_scanpos;
                    if (!oncipj_Cypher_jj_scan_token($this, 306) ? 0 : 1) {
                        $this.$jj_scanpos = var$3;
                        if (!oncipj_Cypher_jj_scan_token($this, 121) ? 0 : 1) {
                            var$2 = 1;
                            break f;
                        }
                    }
                    var$2 = 0;
                }
            }
            if (!var$2)
                break a;
            g: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 306))
                    var$2 = 1;
                else {
                    var$3 = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 336) ? 1 : !oncipj_Cypher_jj_scan_token($this, 309) ? 0 : 1) {
                        $this.$jj_scanpos = var$3;
                        if (oncipj_Cypher_jj_scan_token($this, 335) ? 1 : !oncipj_Cypher_jj_scan_token($this, 309) ? 0 : 1) {
                            var$2 = 1;
                            break g;
                        }
                    }
                    var$2 = 0;
                }
            }
            if (!var$2)
                break a;
            h: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 308))
                    var$2 = 1;
                else {
                    var$3 = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 336) ? 1 : !oncipj_Cypher_jj_scan_token($this, 309) ? 0 : 1) {
                        $this.$jj_scanpos = var$3;
                        if (oncipj_Cypher_jj_3R_591($this)) {
                            var$2 = 1;
                            break h;
                        }
                    }
                    var$2 = 0;
                }
            }
            if (!var$2)
                break a;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 141) ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_228($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_229($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_230($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_231($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_232($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_233($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_234($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_235($this))
                break a;
            return 1;
        }
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 219) ? 1 : !oncipj_Cypher_jj_scan_token($this, 222) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_583($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_304($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_360($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 219)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 222)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 317))
                        return 1;
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_373($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_87($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 254))
            return 1;
        if (oncipj_Cypher_jj_3R_91($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_192($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_146($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_360($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_228($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 240))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_229($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 216)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 331))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_591($this) {
        if (oncipj_Cypher_jj_scan_token($this, 335))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 309))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_230($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 262)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 143))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_231($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 205))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_232($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 198)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 80))
                return 1;
        }
        if (oncipj_Cypher_jj_scan_token($this, 203))
            return 1;
        if (oncipj_Cypher_jj_3R_575($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 174))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_233($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 234))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_234($this) {
        if (oncipj_Cypher_jj_scan_token($this, 251))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 328))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_235($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 79))
            return 1;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 216)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 331)) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (var$2) {
            b: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 262)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 143)) {
                        var$2 = 1;
                        break b;
                    }
                }
                var$2 = 0;
            }
            if (var$2) {
                $this.$jj_scanpos = $xsp;
                if (!oncipj_Cypher_jj_scan_token($this, 205) ? 0 : 1) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 251) ? 1 : !oncipj_Cypher_jj_scan_token($this, 328) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_3_121($this)) {
                            $this.$jj_scanpos = $xsp;
                            if (oncipj_Cypher_jj_scan_token($this, 328))
                                $this.$jj_scanpos = $xsp;
                        }
                    }
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_374($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_90($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_87($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 254))
            return 1;
        if (oncipj_Cypher_jj_3R_91($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_360($this) {
        var $xsp;
        a: {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_scan_token($this, 341))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 69))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 70))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 71))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 72))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 73))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 74))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 75))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 76))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 77))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 78))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 79))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 80))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 81))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 82))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 83))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 84))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 85))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 87))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 88))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 89))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 90))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 91))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 92))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 93))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 94))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 95))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 96))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 97))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 98))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 99))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 100))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 104))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 105))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 106))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 107))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 108))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 109))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 110))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 112))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 111))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 113))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 114))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 115))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 116))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 117))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 118))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 119))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 120))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 121))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 122))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 123))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 124))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 125))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 126))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 127))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 128))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 129))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 130))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 132))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 133))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 137))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 138))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 139))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 140))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 141))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 142))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 143))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 145))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 146))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 147))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 144))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 148))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 149))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 150))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 157))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 152))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 153))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 154))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 155))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 156))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 158))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 159))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 160))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 161))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 163))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 162))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 164))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 165))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 166))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 167))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 169))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 170))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 171))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 172))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 173))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 175))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 176))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 177))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 179))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 180))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 181))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 182))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 183))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 184))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 185))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 186))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 187))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 188))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 189))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 190))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 191))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 197))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 198))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 199))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 200))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 201))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 206))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 204))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 205))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 207))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 212))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 213))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 214))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 215))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 216))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 217))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 218))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 220))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 221))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 223))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 224))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 225))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 226))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 227))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 228))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 229))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 230))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 231))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 232))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 233))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 234))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 235))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 236))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 237))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 240))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 241))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 244))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 245))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 246))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 247))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 248))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 249))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 250))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 251))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 253))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 256))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 257))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 258))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 261))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 262))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 263))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 264))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 259))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 243))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 265))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 266))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 267))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 268))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 269))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 270))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 271))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 272))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 273))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 274))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 276))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 277))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 278))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 279))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 280))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 281))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 282))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 284))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 285))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 286))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 287))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 288))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 290))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 289))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 291))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 292))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 293))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 294))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 295))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 296))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 297))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 298))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 299))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 300))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 301))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 302))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 303))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 304))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 305))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 306))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 308))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 309))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 310))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 311))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 312))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 313))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 314))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 315))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 316))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 318))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 319))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 320))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 321))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 322))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 323))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 324))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 325))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 326))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 327))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 328))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 329))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 330))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 331))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 332))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 333))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 334))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 335))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 336))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 337))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 338))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 339))
                break a;
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 340))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_583($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 198)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 80))
                return 1;
        }
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 219) ? 1 : !oncipj_Cypher_jj_scan_token($this, 222) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_121($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 328))
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 203))
            return 1;
        if (oncipj_Cypher_jj_3R_142($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 174))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_375($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_3R_90($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 254))
            return 1;
        if (oncipj_Cypher_jj_3R_91($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_420($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_123($this) {
        if (oncipj_Cypher_jj_scan_token($this, 224))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 202))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_122($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 156))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_49($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_86($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 334))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_53($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_3R_86($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_87($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_50($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (!oncipj_Cypher_jj_3R_87($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_51($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 334))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_52($this) {
        if (oncipj_Cypher_jj_scan_token($this, 334))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_54($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_86($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_90($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (!oncipj_Cypher_jj_3R_87($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_91($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 344)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 208))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_420($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 174)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 346))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_90($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 307))
            return 1;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_3_55($this)) {
                $this.$jj_scanpos = $xsp;
                if (!oncipj_Cypher_jj_scan_token($this, 36) ? 0 : 1) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (!var$2 ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_55($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 36))
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 136))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 36))
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_124($this) {
        if (oncipj_Cypher_jj_scan_token($this, 224))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 101))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_86($this) {
        var $xsp, var$2, var$3, var$4, var$5;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 101))
                var$2 = 1;
            else {
                b: {
                    var$3 = $this.$jj_scanpos;
                    $this.$jj_lookingAhead = 1;
                    if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                        var$4 = ju_Stack_peek($this.$labelExpressionStack);
                        oncipj_ExpectBar_$callClinit();
                        if (var$4 === oncipj_ExpectBar_EXPECT_BAR) {
                            var$2 = 1;
                            break b;
                        }
                    }
                    var$2 = 0;
                }
                c: {
                    d: {
                        $this.$jj_semLA = var$2;
                        $this.$jj_lookingAhead = 0;
                        if (var$2) {
                            if (oncipj_Cypher_jj_3R_100($this))
                                var$2 = 1;
                            else {
                                while (true) {
                                    e: {
                                        var$5 = $this.$jj_scanpos;
                                        if (oncipj_Cypher_jj_scan_token($this, 86))
                                            var$2 = 1;
                                        else {
                                            var$4 = $this.$jj_scanpos;
                                            if (oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_100($this) ? 0 : 1) {
                                                $this.$jj_scanpos = var$4;
                                                if (!oncipj_Cypher_jj_3R_100($this) ? 0 : 1) {
                                                    var$2 = 1;
                                                    break e;
                                                }
                                            }
                                            var$2 = 0;
                                        }
                                    }
                                    if (!var$2)
                                        continue;
                                    else
                                        break;
                                }
                                $this.$jj_scanpos = var$5;
                                var$2 = 0;
                            }
                            if (!(!var$2 ? 0 : 1))
                                break d;
                        }
                        f: {
                            $this.$jj_scanpos = var$3;
                            $this.$jj_lookingAhead = 1;
                            if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                                var$5 = ju_Stack_peek($this.$labelExpressionStack);
                                oncipj_ExpectBar_$callClinit();
                                if (var$5 !== oncipj_ExpectBar_DO_NOT_EXPECT_BAR) {
                                    var$2 = 0;
                                    break f;
                                }
                            }
                            var$2 = 1;
                        }
                        $this.$jj_semLA = var$2;
                        $this.$jj_lookingAhead = 0;
                        if (!var$2)
                            break c;
                        if (!oncipj_Cypher_jj_3R_341($this) ? 0 : 1)
                            break c;
                    }
                    var$2 = 0;
                    break a;
                }
                var$2 = 1;
            }
        }
        if (var$2) {
            g: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 187))
                    var$2 = 1;
                else {
                    h: {
                        var$5 = $this.$jj_scanpos;
                        $this.$jj_lookingAhead = 1;
                        if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                            var$3 = ju_Stack_peek($this.$labelExpressionStack);
                            oncipj_ExpectBar_$callClinit();
                            if (var$3 === oncipj_ExpectBar_EXPECT_BAR) {
                                var$2 = 1;
                                break h;
                            }
                        }
                        var$2 = 0;
                    }
                    i: {
                        j: {
                            $this.$jj_semLA = var$2;
                            $this.$jj_lookingAhead = 0;
                            if (var$2) {
                                if (oncipj_Cypher_jj_3R_101($this))
                                    var$2 = 1;
                                else {
                                    while (true) {
                                        k: {
                                            $xsp = $this.$jj_scanpos;
                                            if (oncipj_Cypher_jj_scan_token($this, 86))
                                                var$2 = 1;
                                            else {
                                                var$3 = $this.$jj_scanpos;
                                                if (oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_101($this) ? 0 : 1) {
                                                    $this.$jj_scanpos = var$3;
                                                    if (!oncipj_Cypher_jj_3R_101($this) ? 0 : 1) {
                                                        var$2 = 1;
                                                        break k;
                                                    }
                                                }
                                                var$2 = 0;
                                            }
                                        }
                                        if (!var$2)
                                            continue;
                                        else
                                            break;
                                    }
                                    $this.$jj_scanpos = $xsp;
                                    var$2 = 0;
                                }
                                if (!(!var$2 ? 0 : 1))
                                    break j;
                            }
                            l: {
                                $this.$jj_scanpos = var$5;
                                $this.$jj_lookingAhead = 1;
                                if (!ju_Vector_isEmpty($this.$labelExpressionStack)) {
                                    $xsp = ju_Stack_peek($this.$labelExpressionStack);
                                    oncipj_ExpectBar_$callClinit();
                                    if ($xsp !== oncipj_ExpectBar_DO_NOT_EXPECT_BAR) {
                                        var$2 = 0;
                                        break l;
                                    }
                                }
                                var$2 = 1;
                            }
                            $this.$jj_semLA = var$2;
                            $this.$jj_lookingAhead = 0;
                            if (!var$2)
                                break i;
                            if (!oncipj_Cypher_jj_3R_343($this) ? 0 : 1)
                                break i;
                        }
                        var$2 = 0;
                        break g;
                    }
                    var$2 = 1;
                }
            }
            if (var$2)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_125($this) {
        if (oncipj_Cypher_jj_scan_token($this, 162))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 202))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_126($this) {
        if (oncipj_Cypher_jj_scan_token($this, 177))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 219))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_341($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_100($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_56($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_56($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 86))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_100($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_100($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_343($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_101($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_57($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_57($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 86))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_101($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_101($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_127($this) {
        if (oncipj_Cypher_jj_scan_token($this, 162))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 202))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_128($this) {
        if (oncipj_Cypher_jj_scan_token($this, 177))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 219))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_58($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 86))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 101))
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_3R_100($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 86))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_129($this) {
        if (oncipj_Cypher_jj_scan_token($this, 162))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 202))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_130($this) {
        if (oncipj_Cypher_jj_scan_token($this, 177))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 219))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_59($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 86))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 101))
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_3R_101($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 86))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_132($this) {
        if (oncipj_Cypher_jj_scan_token($this, 224))
            return 1;
        if (!oncipj_Cypher_jj_3R_88($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_100($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_106($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_60($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_60($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 192) ? 1 : !oncipj_Cypher_jj_3R_106($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_106($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_101($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_107($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_61($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_549($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 259))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_61($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 192) ? 1 : !oncipj_Cypher_jj_3R_107($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_107($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_131($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 142))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_106($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_62($this)) {
            $this.$jj_scanpos = $xsp;
            var$2 = oncipj_Cypher_jj_scan_token($this, 202) ? 1 : oncipj_Cypher_jj_3R_341($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
            a: {
                if (var$2) {
                    $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_scan_token($this, 209) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (!oncipj_Cypher_jj_3R_128($this) ? 0 : 1) {
                            var$2 = 1;
                            break a;
                        }
                    }
                }
                var$2 = 0;
            }
            if (!var$2 ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_552($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 169))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_62($this) {
        if (oncipj_Cypher_jj_scan_token($this, 193))
            return 1;
        if (!oncipj_Cypher_jj_3R_106($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_107($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_63($this)) {
            $this.$jj_scanpos = $xsp;
            var$2 = oncipj_Cypher_jj_scan_token($this, 202) ? 1 : oncipj_Cypher_jj_3R_343($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
            a: {
                if (var$2) {
                    $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_scan_token($this, 209) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (!oncipj_Cypher_jj_3R_192($this) ? 0 : 1) {
                            var$2 = 1;
                            break a;
                        }
                    }
                }
                var$2 = 0;
            }
            if (!var$2 ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_63($this) {
        if (oncipj_Cypher_jj_scan_token($this, 193))
            return 1;
        if (!oncipj_Cypher_jj_3R_107($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_551($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 270))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_133($this) {
        if (oncipj_Cypher_jj_scan_token($this, 204))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 224))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_134($this) {
        if (oncipj_Cypher_jj_scan_token($this, 271))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 204))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 224))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_555($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 144))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_75($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_3R_254($this))
            var$1 = 1;
        else {
            while (true) {
                var$2 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 229) ? 1 : !oncipj_Cypher_jj_3R_254($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_254($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_326($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 338) ? 1 : !oncipj_Cypher_jj_3R_326($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_326($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_108($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 78) ? 1 : !oncipj_Cypher_jj_3R_108($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_556($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_scan_token($this, 139) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (!(!oncipj_Cypher_jj_scan_token($this, 123) ? 0 : 1) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 257) ? 0 : 1) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_108($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_64($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_3R_109($this))
                var$2 = 1;
            else {
                while (true) {
                    a: {
                        $xsp = $this.$jj_scanpos;
                        if (oncipj_Cypher_jj_3_65($this)) {
                            $this.$jj_scanpos = $xsp;
                            if (oncipj_Cypher_jj_scan_token($this, 210) ? 1 : !oncipj_Cypher_jj_3R_109($this) ? 0 : 1) {
                                $this.$jj_scanpos = $xsp;
                                if (oncipj_Cypher_jj_scan_token($this, 211) ? 1 : !oncipj_Cypher_jj_3R_109($this) ? 0 : 1) {
                                    $this.$jj_scanpos = $xsp;
                                    if (oncipj_Cypher_jj_scan_token($this, 196) ? 1 : !oncipj_Cypher_jj_3R_109($this) ? 0 : 1) {
                                        $this.$jj_scanpos = $xsp;
                                        if (oncipj_Cypher_jj_scan_token($this, 168) ? 1 : !oncipj_Cypher_jj_3R_109($this) ? 0 : 1) {
                                            $this.$jj_scanpos = $xsp;
                                            if (oncipj_Cypher_jj_scan_token($this, 203) ? 1 : !oncipj_Cypher_jj_3R_109($this) ? 0 : 1) {
                                                $this.$jj_scanpos = $xsp;
                                                if (oncipj_Cypher_jj_scan_token($this, 174) ? 1 : !oncipj_Cypher_jj_3R_109($this) ? 0 : 1) {
                                                    var$2 = 1;
                                                    break a;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        var$2 = 0;
                    }
                    if (!var$2)
                        continue;
                    else
                        break;
                }
                $this.$jj_scanpos = $xsp;
                var$2 = 0;
            }
            if (!var$2 ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_64($this) {
        if (oncipj_Cypher_jj_scan_token($this, 219))
            return 1;
        if (!oncipj_Cypher_jj_3R_108($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_65($this) {
        if (oncipj_Cypher_jj_scan_token($this, 151))
            return 1;
        if (!oncipj_Cypher_jj_3R_109($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_109($this) {
        var $xsp, var$2, var$3, var$4;
        if (oncipj_Cypher_jj_3R_110($this))
            return 1;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_3_66($this)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 296) ? 1 : oncipj_Cypher_jj_scan_token($this, 335) ? 1 : !oncipj_Cypher_jj_3R_110($this) ? 0 : 1) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 150) ? 1 : oncipj_Cypher_jj_scan_token($this, 335) ? 1 : !oncipj_Cypher_jj_3R_110($this) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_scan_token($this, 110) ? 1 : !oncipj_Cypher_jj_3R_110($this) ? 0 : 1) {
                            $this.$jj_scanpos = $xsp;
                            if (oncipj_Cypher_jj_scan_token($this, 180) ? 1 : !oncipj_Cypher_jj_3R_110($this) ? 0 : 1) {
                                b: {
                                    $this.$jj_scanpos = $xsp;
                                    if (oncipj_Cypher_jj_scan_token($this, 187))
                                        var$2 = 1;
                                    else {
                                        var$3 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_scan_token($this, 222) ? 0 : 1) {
                                            c: {
                                                $this.$jj_scanpos = var$3;
                                                if (oncipj_Cypher_jj_scan_token($this, 219))
                                                    var$2 = 1;
                                                else {
                                                    var$4 = $this.$jj_scanpos;
                                                    if (!oncipj_Cypher_jj_scan_token($this, 222) ? 0 : 1) {
                                                        d: {
                                                            $this.$jj_scanpos = var$4;
                                                            if (oncipj_Cypher_jj_scan_token($this, 317)) {
                                                                $this.$jj_scanpos = var$4;
                                                                if (oncipj_Cypher_jj_scan_token($this, 102)) {
                                                                    var$2 = 1;
                                                                    break d;
                                                                }
                                                            }
                                                            var$2 = !oncipj_Cypher_jj_3R_575($this) ? 0 : 1;
                                                        }
                                                        if (var$2) {
                                                            var$2 = 1;
                                                            break c;
                                                        }
                                                    }
                                                    var$2 = 0;
                                                }
                                            }
                                            if (var$2) {
                                                e: {
                                                    $this.$jj_scanpos = var$3;
                                                    if (oncipj_Cypher_jj_scan_token($this, 317)) {
                                                        $this.$jj_scanpos = var$3;
                                                        if (oncipj_Cypher_jj_scan_token($this, 102)) {
                                                            var$2 = 1;
                                                            break e;
                                                        }
                                                    }
                                                    var$2 = !oncipj_Cypher_jj_3R_575($this) ? 0 : 1;
                                                }
                                                if (var$2) {
                                                    var$2 = 1;
                                                    break b;
                                                }
                                            }
                                        }
                                        var$2 = 0;
                                    }
                                }
                                if (var$2) {
                                    $this.$jj_scanpos = $xsp;
                                    if (oncipj_Cypher_jj_scan_token($this, 102) ? 1 : !oncipj_Cypher_jj_3R_575($this) ? 0 : 1) {
                                        var$2 = 1;
                                        break a;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            var$2 = 0;
        }
        if (!var$2 ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_66($this) {
        if (oncipj_Cypher_jj_scan_token($this, 260))
            return 1;
        if (!oncipj_Cypher_jj_3R_110($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_110($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_3R_189($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            var$2 = oncipj_Cypher_jj_scan_token($this, 238) ? 1 : !oncipj_Cypher_jj_3R_189($this) ? 0 : 1;
            a: {
                if (var$2) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 208) ? 1 : !oncipj_Cypher_jj_3R_189($this) ? 0 : 1) {
                        var$2 = 1;
                        break a;
                    }
                }
                var$2 = 0;
            }
            if (!var$2)
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_189($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_3R_288($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            var$2 = oncipj_Cypher_jj_scan_token($this, 307) ? 1 : !oncipj_Cypher_jj_3R_288($this) ? 0 : 1;
            a: {
                if (var$2) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 134) ? 1 : !oncipj_Cypher_jj_3R_288($this) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_scan_token($this, 209) ? 1 : !oncipj_Cypher_jj_3R_288($this) ? 0 : 1) {
                            var$2 = 1;
                            break a;
                        }
                    }
                }
                var$2 = 0;
            }
            if (!var$2)
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_288($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_354($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 242) ? 1 : !oncipj_Cypher_jj_3R_354($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_354($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_67($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 238) ? 1 : !oncipj_Cypher_jj_3R_111($this) ? 0 : 1) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 208) ? 1 : !oncipj_Cypher_jj_3R_111($this) ? 0 : 1)
                    return 1;
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_67($this) {
        if (!oncipj_Cypher_jj_3R_111($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_111($this) {
        var $xsp, var$2, var$3;
        if (oncipj_Cypher_jj_3R_165($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            var$2 = !oncipj_Cypher_jj_3R_268($this) ? 0 : 1;
            a: {
                if (var$2) {
                    $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_3R_411($this) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        if (!oncipj_Cypher_jj_3R_411($this) ? 0 : 1) {
                            $this.$jj_scanpos = $xsp;
                            if (oncipj_Cypher_jj_scan_token($this, 194) ? 1 : oncipj_Cypher_jj_3R_75($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 254) ? 0 : 1) {
                                $this.$jj_scanpos = $xsp;
                                if (oncipj_Cypher_jj_scan_token($this, 194))
                                    var$2 = 1;
                                else {
                                    var$3 = $this.$jj_scanpos;
                                    if (!oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                                        $this.$jj_scanpos = var$3;
                                    if (oncipj_Cypher_jj_scan_token($this, 136))
                                        var$2 = 1;
                                    else {
                                        var$3 = $this.$jj_scanpos;
                                        if (!oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                                            $this.$jj_scanpos = var$3;
                                        var$2 = !oncipj_Cypher_jj_scan_token($this, 254) ? 0 : 1;
                                    }
                                }
                                if (var$2) {
                                    var$2 = 1;
                                    break a;
                                }
                            }
                        }
                    }
                }
                var$2 = 0;
            }
            if (!(!var$2 ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_68($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 135)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 194)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 101)) {
                    a: {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_scan_token($this, 187))
                            var$2 = 1;
                        else {
                            $xsp = $this.$jj_scanpos;
                            if (oncipj_Cypher_jj_scan_token($this, 193)) {
                                $this.$jj_scanpos = $xsp;
                                if (oncipj_Cypher_jj_scan_token($this, 209)) {
                                    $this.$jj_scanpos = $xsp;
                                    if (oncipj_Cypher_jj_scan_token($this, 202)) {
                                        $this.$jj_scanpos = $xsp;
                                        if (!oncipj_Cypher_jj_3R_192($this) ? 0 : 1) {
                                            var$2 = 1;
                                            break a;
                                        }
                                    }
                                }
                            }
                            var$2 = 0;
                        }
                    }
                    if (var$2)
                        return 1;
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_69($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 101))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_268($this) {
        if (oncipj_Cypher_jj_scan_token($this, 135))
            return 1;
        if (!oncipj_Cypher_jj_3R_129($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_70($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 187))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 193)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 209)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 202)) {
                    $this.$jj_scanpos = $xsp;
                    if (!oncipj_Cypher_jj_3R_192($this) ? 0 : 1)
                        return 1;
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_71($this) {
        if (oncipj_Cypher_jj_scan_token($this, 194))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_76($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_165($this))
            return 1;
        if (oncipj_Cypher_jj_3R_166($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_166($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_165($this) {
        var $xsp, var$2, var$3;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_scan_token($this, 208) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        var$2 = $this.$jj_scanpos;
        var$3 = !oncipj_Cypher_jj_scan_token($this, 35) ? 0 : 1;
        a: {
            if (var$3) {
                $this.$jj_scanpos = var$2;
                if (!oncipj_Cypher_jj_scan_token($this, 36) ? 0 : 1) {
                    $this.$jj_scanpos = var$2;
                    if (!oncipj_Cypher_jj_scan_token($this, 39) ? 0 : 1) {
                        $this.$jj_scanpos = var$2;
                        if (!oncipj_Cypher_jj_scan_token($this, 40) ? 0 : 1) {
                            var$3 = 1;
                            break a;
                        }
                    }
                }
            }
            var$3 = 0;
        }
        var$3 = !var$3 ? 0 : 1;
        b: {
            if (!var$3)
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!(!oncipj_Cypher_jj_3R_215($this) ? 0 : 1) ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_3R_283($this) ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 315) ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 159) ? 0 : 1))
                break b;
            c: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 184)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 183)) {
                        var$3 = 1;
                        break c;
                    }
                }
                var$3 = 0;
            }
            if (!var$3)
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 214) ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_72($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_73($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_74($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_75($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_76($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_77($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_78($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_79($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 194))
                var$3 = 1;
            else if (oncipj_Cypher_jj_3R_77($this))
                var$3 = 1;
            else if (oncipj_Cypher_jj_scan_token($this, 180))
                var$3 = 1;
            else if (oncipj_Cypher_jj_3R_75($this))
                var$3 = 1;
            else {
                var$2 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                    $this.$jj_scanpos = var$2;
                var$2 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_scan_token($this, 86) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                    $this.$jj_scanpos = var$2;
                var$3 = !oncipj_Cypher_jj_scan_token($this, 254) ? 0 : 1;
            }
            if (!(!var$3 ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_3R_330($this) ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_82($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_83($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_84($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_85($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_86($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_87($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!(!oncipj_Cypher_jj_3R_200($this) ? 0 : 1) ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_89($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_265($this))
                break b;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_3R_332($this) ? 0 : 1))
                break b;
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_3R_267($this))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_166($this) {
        if (!oncipj_Cypher_jj_3R_268($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_72($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 222))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_73($this) {
        var var$1, var$2;
        a: {
            if (oncipj_Cypher_jj_scan_token($this, 97))
                var$1 = 1;
            else {
                var$2 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_3R_75($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 333) ? 0 : 1) {
                    $this.$jj_scanpos = var$2;
                    if (oncipj_Cypher_jj_scan_token($this, 333)) {
                        var$1 = 1;
                        break a;
                    }
                }
                if (oncipj_Cypher_jj_3R_75($this))
                    var$1 = 1;
                else if (oncipj_Cypher_jj_scan_token($this, 305))
                    var$1 = 1;
                else if (oncipj_Cypher_jj_3R_75($this))
                    var$1 = 1;
                else {
                    while (true) {
                        var$2 = $this.$jj_scanpos;
                        if (!(oncipj_Cypher_jj_scan_token($this, 333) ? 1 : oncipj_Cypher_jj_3R_75($this) ? 1 : oncipj_Cypher_jj_scan_token($this, 305) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1))
                            continue;
                        else
                            break;
                    }
                    $this.$jj_scanpos = var$2;
                    if (oncipj_Cypher_jj_scan_token($this, 147) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                        $this.$jj_scanpos = var$2;
                    if (!oncipj_Cypher_jj_scan_token($this, 149))
                        var$1 = 0;
                    else
                        var$1 = 1;
                }
            }
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_74($this) {
        if (oncipj_Cypher_jj_scan_token($this, 113))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 202))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 307))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_75($this) {
        if (!oncipj_Cypher_jj_3R_89($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_76($this) {
        var var$1, var$2;
        a: {
            if (oncipj_Cypher_jj_scan_token($this, 156))
                var$1 = 1;
            else if (oncipj_Cypher_jj_scan_token($this, 195))
                var$1 = 1;
            else {
                var$2 = $this.$jj_scanpos;
                if (!oncipj_Cypher_jj_3R_198($this) ? 0 : 1) {
                    $this.$jj_scanpos = var$2;
                    if (!oncipj_Cypher_jj_3R_78($this) ? 0 : 1)
                        $this.$jj_scanpos = var$2;
                    if (oncipj_Cypher_jj_3R_293($this))
                        var$1 = 1;
                    else {
                        var$2 = $this.$jj_scanpos;
                        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1)
                            $this.$jj_scanpos = var$2;
                        var$1 = 0;
                    }
                    if (var$1) {
                        var$1 = 1;
                        break a;
                    }
                }
                if (!oncipj_Cypher_jj_scan_token($this, 255))
                    var$1 = 0;
                else
                    var$1 = 1;
            }
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_77($this) {
        var var$1, var$2;
        a: {
            if (oncipj_Cypher_jj_scan_token($this, 113))
                var$1 = 1;
            else if (oncipj_Cypher_jj_scan_token($this, 195))
                var$1 = 1;
            else {
                var$2 = $this.$jj_scanpos;
                if (!oncipj_Cypher_jj_3R_198($this) ? 0 : 1) {
                    $this.$jj_scanpos = var$2;
                    if (!oncipj_Cypher_jj_3R_78($this) ? 0 : 1)
                        $this.$jj_scanpos = var$2;
                    if (oncipj_Cypher_jj_3R_293($this))
                        var$1 = 1;
                    else {
                        var$2 = $this.$jj_scanpos;
                        if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1)
                            $this.$jj_scanpos = var$2;
                        var$1 = 0;
                    }
                    if (var$1) {
                        var$1 = 1;
                        break a;
                    }
                }
                if (!oncipj_Cypher_jj_scan_token($this, 255))
                    var$1 = 0;
                else
                    var$1 = 1;
            }
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_78($this) {
        if (!(oncipj_Cypher_jj_scan_token($this, 100) ? 1 : oncipj_Cypher_jj_scan_token($this, 195) ? 1 : oncipj_Cypher_jj_3R_198($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 255) ? 0 : 1))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_79($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_3R_77($this))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 195))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_458($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            while (true) {
                var$2 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_458($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$2;
            var$1 = !oncipj_Cypher_jj_scan_token($this, 255) ? 0 : 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_82($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 194))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            while (true) {
                var$2 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$2;
            var$1 = !oncipj_Cypher_jj_scan_token($this, 254) ? 0 : 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_83($this) {
        var var$1;
        a: {
            if (oncipj_Cypher_jj_scan_token($this, 258)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 202)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_77($this)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 151)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_75($this)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 103)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_77($this)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 180)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_75($this)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 86)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_75($this)) {
                var$1 = 1;
                break a;
            }
            if (!oncipj_Cypher_jj_scan_token($this, 275)) {
                var$1 = 0;
                break a;
            }
            var$1 = 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_84($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 76))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 202))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_77($this))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 180))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_75($this))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            var$1 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_85($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 79))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 202))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_77($this))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 180))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_75($this))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            var$1 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_86($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 218))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 202))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_77($this))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 180))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_75($this))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            var$1 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_87($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 293))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 202))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_77($this))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 180))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_75($this))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            var$1 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_89($this) {
        if (!(!oncipj_Cypher_jj_3R_79($this) ? 0 : 1))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_265($this) {
        if (oncipj_Cypher_jj_scan_token($this, 202))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_80($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 194))
            return 1;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 180))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 334)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 86)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 254))
                    return 1;
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_81($this) {
        var var$1, var$2;
        a: {
            if (oncipj_Cypher_jj_scan_token($this, 194))
                var$1 = 1;
            else {
                var$2 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_3R_77($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 151) ? 0 : 1)
                    $this.$jj_scanpos = var$2;
                if (oncipj_Cypher_jj_3R_200($this))
                    var$1 = 1;
                else {
                    var$2 = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 334)) {
                        $this.$jj_scanpos = var$2;
                        if (oncipj_Cypher_jj_scan_token($this, 86)) {
                            var$1 = 1;
                            break a;
                        }
                    }
                    var$1 = 0;
                }
            }
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_267($this) {
        if (!oncipj_Cypher_jj_3R_77($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_88($this) {
        if (oncipj_Cypher_jj_3R_81($this))
            return 1;
        if (!oncipj_Cypher_jj_3R_85($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_90($this) {
        var $xsp;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_3R_128($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 135) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_3R_128($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 202))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_91($this) {
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 333))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_330($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 194))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3R_77($this) ? 1 : !oncipj_Cypher_jj_scan_token($this, 151) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_3R_200($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 334) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 86))
            return 1;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 254))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_1($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 283))
            return 1;
        var$1 = $this.$jj_scanpos;
        if (!(!oncipj_Cypher_jj_scan_token($this, 327) ? 0 : 1) ? 0 : 1)
            $this.$jj_scanpos = var$1;
        var$1 = $this.$jj_scanpos;
        var$2 = !oncipj_Cypher_jj_3R_245($this) ? 0 : 1;
        a: {
            if (var$2) {
                b: {
                    $this.$jj_scanpos = var$1;
                    if (oncipj_Cypher_jj_3_3($this)) {
                        $this.$jj_scanpos = var$1;
                        var$2 = !oncipj_Cypher_jj_3R_547($this) ? 0 : 1;
                        c: {
                            d: {
                                if (!var$2)
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_548($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_549($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_550($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_551($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_552($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_553($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_554($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_3R_555($this) ? 0 : 1))
                                    break d;
                                $this.$jj_scanpos = var$1;
                                if (!oncipj_Cypher_jj_3R_556($this) ? 0 : 1) {
                                    var$2 = 1;
                                    break c;
                                }
                            }
                            var$2 = 0;
                        }
                        var$2 = !var$2 ? 0 : 1;
                        e: {
                            if (var$2) {
                                $this.$jj_scanpos = var$1;
                                if (!(!oncipj_Cypher_jj_scan_token($this, 291) ? 0 : 1) ? 0 : 1) {
                                    $this.$jj_scanpos = var$1;
                                    if (!(!oncipj_Cypher_jj_scan_token($this, 303) ? 0 : 1) ? 0 : 1) {
                                        var$2 = 1;
                                        break e;
                                    }
                                }
                            }
                            var$2 = 0;
                        }
                        if (!var$2 ? 0 : 1) {
                            $this.$jj_scanpos = var$1;
                            if (!oncipj_Cypher_jj_3R_295($this) ? 0 : 1) {
                                var$2 = 1;
                                break b;
                            }
                        }
                    }
                    var$2 = 0;
                }
                if (!var$2 ? 0 : 1) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (!var$2)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_3($this) {
        if (!oncipj_Cypher_jj_3R_73($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_92($this) {
        if (oncipj_Cypher_jj_3R_129($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 101))
            return 1;
        if (!oncipj_Cypher_jj_3R_75($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_458($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_92($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_3_93($this)) {
                $this.$jj_scanpos = $xsp;
                if (!oncipj_Cypher_jj_3R_77($this) ? 0 : 1) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 135) ? 1 : !oncipj_Cypher_jj_scan_token($this, 307) ? 0 : 1)
                        return 1;
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_93($this) {
        if (oncipj_Cypher_jj_scan_token($this, 135))
            return 1;
        if (!oncipj_Cypher_jj_3R_129($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_135($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 246)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 247))
                return 1;
        }
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 246)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 247)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 103))
                    return 1;
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_4($this) {
        if (!oncipj_Cypher_jj_3R_73($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_2($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 283))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_198($this) {
        var $xsp, var$2, var$3;
        if (oncipj_Cypher_jj_3R_295($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 319))
                var$2 = 1;
            else {
                var$3 = $this.$jj_scanpos;
                if (!oncipj_Cypher_jj_scan_token($this, 76) ? 0 : 1)
                    $this.$jj_scanpos = var$3;
                var$2 = !oncipj_Cypher_jj_3R_295($this) ? 0 : 1;
            }
            if (!(!var$2 ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_550($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 127))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_295($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_362($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_362($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_362($this) {
        if (!oncipj_Cypher_jj_3R_415($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_310($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_scan_token($this, 208) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        if (!oncipj_Cypher_jj_scan_token($this, 36))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_415($this) {
        var $xsp, var$2, var$3, var$4;
        $xsp = $this.$jj_scanpos;
        var$2 = !oncipj_Cypher_jj_3R_245($this) ? 0 : 1;
        a: {
            if (!var$2)
                break a;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_3R_510($this) ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!(!(oncipj_Cypher_jj_scan_token($this, 114) ? 1 : !oncipj_Cypher_jj_3R_293($this) ? 0 : 1) ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 130) ? 0 : 1)
                $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 126))
                var$2 = 1;
            else if (oncipj_Cypher_jj_3R_75($this))
                var$2 = 1;
            else {
                while (true) {
                    var$3 = $this.$jj_scanpos;
                    if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1))
                        continue;
                    else
                        break;
                }
                $this.$jj_scanpos = var$3;
                var$2 = 0;
            }
            if (!(!var$2 ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_3R_513($this) ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 264))
                var$2 = 1;
            else if (oncipj_Cypher_jj_3R_619($this))
                var$2 = 1;
            else {
                while (true) {
                    var$3 = $this.$jj_scanpos;
                    if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_619($this) ? 0 : 1))
                        continue;
                    else
                        break;
                }
                $this.$jj_scanpos = var$3;
                var$2 = 0;
            }
            if (!(!var$2 ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 226) ? 0 : 1)
                $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 206))
                var$2 = 1;
            else {
                var$3 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_3_12($this))
                    $this.$jj_scanpos = var$3;
                if (oncipj_Cypher_jj_3R_293($this))
                    var$2 = 1;
                else {
                    while (true) {
                        b: {
                            var$3 = $this.$jj_scanpos;
                            if (oncipj_Cypher_jj_scan_token($this, 327))
                                var$2 = 1;
                            else {
                                var$4 = $this.$jj_scanpos;
                                if (oncipj_Cypher_jj_scan_token($this, 181) ? 1 : !oncipj_Cypher_jj_3R_659($this) ? 0 : 1) {
                                    $this.$jj_scanpos = var$4;
                                    if (oncipj_Cypher_jj_scan_token($this, 93) ? 1 : oncipj_Cypher_jj_scan_token($this, 181) ? 1 : !oncipj_Cypher_jj_3R_659($this) ? 0 : 1) {
                                        $this.$jj_scanpos = var$4;
                                        if (oncipj_Cypher_jj_scan_token($this, 304) ? 1 : oncipj_Cypher_jj_scan_token($this, 181) ? 1 : !oncipj_Cypher_jj_3R_659($this) ? 0 : 1) {
                                            $this.$jj_scanpos = var$4;
                                            if (oncipj_Cypher_jj_scan_token($this, 253) ? 1 : oncipj_Cypher_jj_scan_token($this, 181) ? 1 : !oncipj_Cypher_jj_3R_659($this) ? 0 : 1) {
                                                $this.$jj_scanpos = var$4;
                                                if (oncipj_Cypher_jj_3R_650($this)) {
                                                    $this.$jj_scanpos = var$4;
                                                    if (oncipj_Cypher_jj_3R_651($this)) {
                                                        $this.$jj_scanpos = var$4;
                                                        if (oncipj_Cypher_jj_3R_652($this)) {
                                                            var$2 = 1;
                                                            break b;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                var$2 = 0;
                            }
                        }
                        if (!var$2)
                            continue;
                        else
                            break;
                    }
                    $this.$jj_scanpos = var$3;
                    if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1)
                        $this.$jj_scanpos = var$3;
                    var$2 = 0;
                }
            }
            if (!(!var$2 ? 0 : 1))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_468($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_469($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_470($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3_5($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_471($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_472($this))
                break a;
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_473($this))
                break a;
            return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_468($this) {
        var var$1, var$2, var$3;
        if (oncipj_Cypher_jj_scan_token($this, 207))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_361($this))
            var$1 = 1;
        else {
            while (true) {
                a: {
                    var$2 = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_scan_token($this, 224))
                        var$1 = 1;
                    else {
                        var$3 = $this.$jj_scanpos;
                        if (oncipj_Cypher_jj_scan_token($this, 206) ? 1 : !oncipj_Cypher_jj_3R_513($this) ? 0 : 1) {
                            $this.$jj_scanpos = var$3;
                            if (oncipj_Cypher_jj_scan_token($this, 114) ? 1 : !oncipj_Cypher_jj_3R_513($this) ? 0 : 1) {
                                var$1 = 1;
                                break a;
                            }
                        }
                        var$1 = 0;
                    }
                }
                if (!var$1)
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_469($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 335))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_557($this))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_470($this) {
        if (!(oncipj_Cypher_jj_scan_token($this, 322) ? 1 : oncipj_Cypher_jj_3R_75($this) ? 1 : oncipj_Cypher_jj_scan_token($this, 81) ? 1 : !oncipj_Cypher_jj_3R_77($this) ? 0 : 1))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_5($this) {
        var var$1, var$2, var$3;
        if (oncipj_Cypher_jj_scan_token($this, 96))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_162($this))
            var$1 = 1;
        else if (!oncipj_Cypher_jj_3R_128($this) ? 0 : 1)
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 202))
                var$1 = 1;
            else {
                var$3 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_3_16($this))
                    $this.$jj_scanpos = var$3;
                while (true) {
                    var$3 = $this.$jj_scanpos;
                    if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1))
                        continue;
                    else
                        break;
                }
                $this.$jj_scanpos = var$3;
                var$1 = !oncipj_Cypher_jj_scan_token($this, 275) ? 0 : 1;
            }
            if (var$1)
                $this.$jj_scanpos = var$2;
            a: {
                var$2 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_scan_token($this, 339))
                    var$1 = 1;
                else {
                    var$3 = $this.$jj_scanpos;
                    if (!oncipj_Cypher_jj_scan_token($this, 307) ? 0 : 1) {
                        $this.$jj_scanpos = var$3;
                        if (oncipj_Cypher_jj_3R_653($this))
                            var$1 = 1;
                        else {
                            while (true) {
                                var$3 = $this.$jj_scanpos;
                                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_653($this) ? 0 : 1))
                                    continue;
                                else
                                    break;
                            }
                            $this.$jj_scanpos = var$3;
                            if (!oncipj_Cypher_jj_3R_134($this) ? 0 : 1)
                                $this.$jj_scanpos = var$3;
                            var$1 = 0;
                        }
                        if (var$1) {
                            var$1 = 1;
                            break a;
                        }
                    }
                    var$1 = 0;
                }
            }
            if (var$1)
                $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_471($this) {
        var var$1, var$2, var$3, var$4;
        if (oncipj_Cypher_jj_scan_token($this, 96))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 195))
            var$1 = 1;
        else if (oncipj_Cypher_jj_3R_198($this))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 255))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 180))
                var$1 = 1;
            else if (oncipj_Cypher_jj_scan_token($this, 313))
                var$1 = 1;
            else {
                while (true) {
                    a: {
                        var$3 = $this.$jj_scanpos;
                        if (oncipj_Cypher_jj_scan_token($this, 223))
                            var$1 = 1;
                        else if (oncipj_Cypher_jj_3R_75($this))
                            var$1 = 1;
                        else {
                            var$4 = $this.$jj_scanpos;
                            if (oncipj_Cypher_jj_scan_token($this, 273)) {
                                $this.$jj_scanpos = var$4;
                                if (oncipj_Cypher_jj_scan_token($this, 274)) {
                                    var$1 = 1;
                                    break a;
                                }
                            }
                            var$1 = 0;
                        }
                    }
                    var$1 = !var$1 ? 0 : 1;
                    b: {
                        if (var$1) {
                            c: {
                                $this.$jj_scanpos = var$3;
                                if (oncipj_Cypher_jj_scan_token($this, 224))
                                    var$1 = 1;
                                else if (oncipj_Cypher_jj_scan_token($this, 157))
                                    var$1 = 1;
                                else {
                                    var$4 = $this.$jj_scanpos;
                                    if (!oncipj_Cypher_jj_scan_token($this, 112) ? 0 : 1) {
                                        $this.$jj_scanpos = var$4;
                                        if (!oncipj_Cypher_jj_scan_token($this, 91) ? 0 : 1) {
                                            $this.$jj_scanpos = var$4;
                                            if (oncipj_Cypher_jj_scan_token($this, 158)) {
                                                var$1 = 1;
                                                break c;
                                            }
                                        }
                                    }
                                    var$1 = 0;
                                }
                            }
                            if (!var$1 ? 0 : 1) {
                                $this.$jj_scanpos = var$3;
                                if (!(oncipj_Cypher_jj_scan_token($this, 266) ? 1 : oncipj_Cypher_jj_scan_token($this, 297) ? 1 : oncipj_Cypher_jj_scan_token($this, 81) ? 1 : !oncipj_Cypher_jj_3R_77($this) ? 0 : 1) ? 0 : 1) {
                                    var$1 = 1;
                                    break b;
                                }
                            }
                        }
                        var$1 = 0;
                    }
                    if (!var$1)
                        continue;
                    else
                        break;
                }
                $this.$jj_scanpos = var$3;
                var$1 = 0;
            }
            if (!var$1 ? 0 : 1)
                $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_472($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 199))
            var$1 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 115))
            var$1 = 1;
        else {
            var$2 = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 335) ? 1 : !oncipj_Cypher_jj_scan_token($this, 175) ? 0 : 1)
                $this.$jj_scanpos = var$2;
            if (oncipj_Cypher_jj_scan_token($this, 164))
                var$1 = 1;
            else if (oncipj_Cypher_jj_3R_75($this))
                var$1 = 1;
            else if (oncipj_Cypher_jj_scan_token($this, 81))
                var$1 = 1;
            else if (oncipj_Cypher_jj_3R_77($this))
                var$1 = 1;
            else {
                var$2 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_scan_token($this, 160) ? 1 : !oncipj_Cypher_jj_3R_215($this) ? 0 : 1)
                    $this.$jj_scanpos = var$2;
                var$1 = 0;
            }
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_473($this) {
        var var$1, var$2;
        a: {
            if (oncipj_Cypher_jj_scan_token($this, 163)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 202)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_77($this)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 180)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_75($this)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_scan_token($this, 86)) {
                var$1 = 1;
                break a;
            }
            if (oncipj_Cypher_jj_3R_630($this)) {
                var$1 = 1;
                break a;
            }
            while (true) {
                var$2 = $this.$jj_scanpos;
                if (!oncipj_Cypher_jj_3R_630($this))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$2;
            if (!oncipj_Cypher_jj_scan_token($this, 275)) {
                var$1 = 0;
                break a;
            }
            var$1 = 1;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_89($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 195))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3R_129($this) ? 1 : oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : oncipj_Cypher_jj_3R_129($this) ? 1 : oncipj_Cypher_jj_scan_token($this, 101) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        if (!oncipj_Cypher_jj_scan_token($this, 255))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_245($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 324))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_6($this)) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_6($this) {
        if (oncipj_Cypher_jj_scan_token($this, 170))
            return 1;
        if (!oncipj_Cypher_jj_3R_75($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_129($this) {
        if (!oncipj_Cypher_jj_3R_128($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_283($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 131))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_77($this) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!oncipj_Cypher_jj_scan_token($this, 36) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_510($this) {
        if (oncipj_Cypher_jj_scan_token($this, 269))
            return 1;
        if (!oncipj_Cypher_jj_3R_557($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_332($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_162($this))
            return 1;
        if (oncipj_Cypher_jj_3R_128($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 202))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_94($this))
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_3R_75($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_557($this) {
        var $xsp, var$2, var$3;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_7($this))
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 307))
            var$2 = 1;
        else {
            while (true) {
                var$3 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_577($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$3;
            var$2 = 0;
        }
        a: {
            if (var$2) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_3R_577($this))
                    var$2 = 1;
                else {
                    while (true) {
                        $xsp = $this.$jj_scanpos;
                        if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_577($this) ? 0 : 1))
                            continue;
                        else
                            break;
                    }
                    $this.$jj_scanpos = $xsp;
                    var$2 = 0;
                }
                if (var$2) {
                    var$2 = 1;
                    break a;
                }
            }
            var$2 = 0;
        }
        if (var$2)
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 230))
            var$2 = 1;
        else if (oncipj_Cypher_jj_scan_token($this, 95))
            var$2 = 1;
        else if (oncipj_Cypher_jj_3R_308($this))
            var$2 = 1;
        else {
            while (true) {
                var$3 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_308($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$3;
            var$2 = 0;
        }
        if (var$2)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (!(oncipj_Cypher_jj_scan_token($this, 294) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (!(oncipj_Cypher_jj_scan_token($this, 197) ? 1 : !oncipj_Cypher_jj_3R_75($this) ? 0 : 1) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_7($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 133))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_94($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 133))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_162($this) {
        var $xsp;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!oncipj_Cypher_jj_3_95($this))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3_95($this) {
        if (oncipj_Cypher_jj_3R_128($this))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 135))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_577($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 81) ? 1 : !oncipj_Cypher_jj_3R_77($this) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_77($this) {
        if (!oncipj_Cypher_jj_3R_128($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_308($this) {
        var $xsp;
        if (oncipj_Cypher_jj_3R_75($this))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_scan_token($this, 128) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 82))
                $this.$jj_scanpos = $xsp;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_73($this) {
        var $xsp, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 114))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (!oncipj_Cypher_jj_scan_token($this, 229) ? 0 : 1)
            $this.$jj_scanpos = $xsp;
        $xsp = $this.$jj_scanpos;
        if (!(!oncipj_Cypher_jj_scan_token($this, 271) ? 0 : 1) ? 0 : 1) {
            $this.$jj_scanpos = $xsp;
            if (!(!oncipj_Cypher_jj_scan_token($this, 325) ? 0 : 1) ? 0 : 1) {
                $this.$jj_scanpos = $xsp;
                if (!(!oncipj_Cypher_jj_scan_token($this, 118) ? 0 : 1) ? 0 : 1) {
                    $this.$jj_scanpos = $xsp;
                    if (!(!oncipj_Cypher_jj_scan_token($this, 108) ? 0 : 1) ? 0 : 1) {
                        $this.$jj_scanpos = $xsp;
                        var$2 = !oncipj_Cypher_jj_scan_token($this, 93) ? 0 : 1;
                        a: {
                            if (var$2) {
                                $this.$jj_scanpos = $xsp;
                                if (!oncipj_Cypher_jj_scan_token($this, 253) ? 0 : 1) {
                                    $this.$jj_scanpos = $xsp;
                                    if (!oncipj_Cypher_jj_scan_token($this, 165) ? 0 : 1) {
                                        $this.$jj_scanpos = $xsp;
                                        if (!oncipj_Cypher_jj_scan_token($this, 304) ? 0 : 1) {
                                            $this.$jj_scanpos = $xsp;
                                            if (!oncipj_Cypher_jj_scan_token($this, 240) ? 0 : 1) {
                                                $this.$jj_scanpos = $xsp;
                                                if (!oncipj_Cypher_jj_scan_token($this, 201) ? 0 : 1) {
                                                    $this.$jj_scanpos = $xsp;
                                                    if (!oncipj_Cypher_jj_scan_token($this, 181) ? 0 : 1) {
                                                        var$2 = 1;
                                                        break a;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            var$2 = 0;
                        }
                        if (!var$2 ? 0 : 1) {
                            $this.$jj_scanpos = $xsp;
                            if (!(!oncipj_Cypher_jj_scan_token($this, 73) ? 0 : 1) ? 0 : 1) {
                                $this.$jj_scanpos = $xsp;
                                if (!(!oncipj_Cypher_jj_scan_token($this, 107) ? 0 : 1) ? 0 : 1)
                                    return 1;
                            }
                        }
                    }
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_134($this) {
        if (oncipj_Cypher_jj_scan_token($this, 334))
            return 1;
        if (!oncipj_Cypher_jj_3R_75($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_547($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 138))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_513($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 286))
            return 1;
        if (oncipj_Cypher_jj_3R_617($this))
            return 1;
        while (true) {
            $xsp = $this.$jj_scanpos;
            if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_617($this) ? 0 : 1))
                continue;
            else
                break;
        }
        $this.$jj_scanpos = $xsp;
        return 0;
    }
    function oncipj_Cypher_jj_3R_548($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 77))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_8($this) {
        if (oncipj_Cypher_jj_3R_76($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 151))
            return 1;
        if (!oncipj_Cypher_jj_3R_75($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_617($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_8($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_3_9($this)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_3_10($this)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_3R_77($this) ? 1 : !oncipj_Cypher_jj_3R_645($this) ? 0 : 1)
                        return 1;
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_9($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 151))
            return 1;
        if (!oncipj_Cypher_jj_3R_75($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_10($this) {
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 239))
            return 1;
        if (!oncipj_Cypher_jj_3R_75($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_11($this) {
        if (!oncipj_Cypher_jj_3R_76($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_619($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_11($this)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_3R_77($this) ? 1 : !oncipj_Cypher_jj_3R_645($this) ? 0 : 1)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_100($this) {
        var $xsp;
        if (oncipj_Cypher_jj_scan_token($this, 325))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 125))
            return 1;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 166)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 167))
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_96($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 339)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 334)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 335))
                    return 1;
            }
        }
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 246)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 247)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 103))
                    return 1;
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3R_78($this) {
        var $xsp, var$2, var$3;
        a: {
            $xsp = $this.$jj_scanpos;
            if (oncipj_Cypher_jj_scan_token($this, 243))
                var$2 = 1;
            else {
                var$3 = $this.$jj_scanpos;
                if (oncipj_Cypher_jj_3_13($this)) {
                    $this.$jj_scanpos = var$3;
                    if (oncipj_Cypher_jj_scan_token($this, 145)) {
                        $this.$jj_scanpos = var$3;
                        if (oncipj_Cypher_jj_scan_token($this, 146)) {
                            var$2 = 1;
                            break a;
                        }
                    }
                }
                var$2 = 0;
            }
        }
        if (var$2) {
            b: {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 132))
                    var$2 = 1;
                else {
                    $xsp = $this.$jj_scanpos;
                    if (oncipj_Cypher_jj_3_14($this)) {
                        $this.$jj_scanpos = $xsp;
                        if (oncipj_Cypher_jj_scan_token($this, 262)) {
                            $this.$jj_scanpos = $xsp;
                            if (oncipj_Cypher_jj_scan_token($this, 263)) {
                                var$2 = 1;
                                break b;
                            }
                        }
                    }
                    var$2 = 0;
                }
            }
            if (var$2)
                return 1;
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_97($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 339)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 334)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 335)) {
                    $this.$jj_scanpos = $xsp;
                    if (oncipj_Cypher_jj_scan_token($this, 0))
                        return 1;
                }
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_98($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 339)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 334))
                return 1;
        }
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 246)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 247)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 103))
                    return 1;
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_99($this) {
        var $xsp;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_scan_token($this, 339)) {
            $this.$jj_scanpos = $xsp;
            if (oncipj_Cypher_jj_scan_token($this, 334)) {
                $this.$jj_scanpos = $xsp;
                if (oncipj_Cypher_jj_scan_token($this, 0))
                    return 1;
            }
        }
        return 0;
    }
    function oncipj_Cypher_jj_3_13($this) {
        if (oncipj_Cypher_jj_scan_token($this, 145))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 87))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_14($this) {
        if (oncipj_Cypher_jj_scan_token($this, 262))
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 87))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_650($this) {
        if (oncipj_Cypher_jj_scan_token($this, 240))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 181))
            return 1;
        if (!oncipj_Cypher_jj_3R_659($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_651($this) {
        var var$1, var$2;
        if (oncipj_Cypher_jj_scan_token($this, 188))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 224))
            return 1;
        if (oncipj_Cypher_jj_3R_128($this))
            var$1 = 1;
        else {
            while (true) {
                var$2 = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_128($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = var$2;
            var$1 = 0;
        }
        if (!var$1)
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_652($this) {
        if (oncipj_Cypher_jj_scan_token($this, 276))
            return 1;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (!oncipj_Cypher_jj_3R_88($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_12($this) {
        if (!oncipj_Cypher_jj_3R_78($this))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3R_659($this) {
        var $xsp, var$2;
        $xsp = $this.$jj_scanpos;
        if (oncipj_Cypher_jj_3_15($this))
            $this.$jj_scanpos = $xsp;
        if (oncipj_Cypher_jj_3R_77($this))
            return 1;
        if (oncipj_Cypher_jj_3R_88($this))
            return 1;
        if (oncipj_Cypher_jj_scan_token($this, 202))
            return 1;
        if (oncipj_Cypher_jj_3R_128($this))
            var$2 = 1;
        else {
            while (true) {
                $xsp = $this.$jj_scanpos;
                if (!(oncipj_Cypher_jj_scan_token($this, 103) ? 1 : !oncipj_Cypher_jj_3R_128($this) ? 0 : 1))
                    continue;
                else
                    break;
            }
            $this.$jj_scanpos = $xsp;
            var$2 = 0;
        }
        if (var$2)
            return 1;
        if (!oncipj_Cypher_jj_scan_token($this, 275))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_3_15($this) {
        if (!oncipj_Cypher_jj_scan_token($this, 282))
            return 0;
        return 1;
    }
    function oncipj_Cypher_jj_la1_init_0() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_0 = $rt_createIntArrayFromData([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
    }
    function oncipj_Cypher_jj_la1_init_1() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_1 = $rt_createIntArrayFromData([0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 1048984, 0, 0, 0, 0, 0, 0, 0, 1048984, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 16, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1048984, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048984, 1048984, 0, 0, 0, 0, 1048984, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 408, 0, 1048984, 0, 0, 0, 16, 1048984, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048984, 0, 1048984, 1048984, 0, 0, 0, 0, 1048984, 0, 1048984,
        1048984, 0, 1048984, 0, 0, 0, 0, 1048984, 1048984, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048576, 0, 0, 0, 1048576, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1048576, 1048576, 0, 0, 0, 0, 0, 0, 0, 0]);
    }
    function oncipj_Cypher_jj_la1_init_2() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_2 = $rt_createIntArrayFromData([0, 8192, 0, 8192, 0, 8192, 0, 0, 4096, 0, 0, 0, 0, (-4194319), 0, 0, 0, 0, 131072, 0, 0, (-4194319), 262144, 0, 0, 0, (-4194320), 0, (-4194320), 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, (-4194320), 0, 131072, 0, 0, 0, 0, 0, 0, 0, 134217728, 0, 36864, 36864, 0, 0, 0, 0, 2048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4194320), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4194304, 0, 0, (-4194320), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4194320), (-4194320), (-4194320), (-4194320), 0, 0, (-4194320), (-4194320), (-4194320), (-4194320), 0, 0, 16384, (-4194319), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4194319), (-4194319), 0, 0, 0, 0, 1, 0, (-4194320), 0, 0, 0, 0, 4194304, (-4194320), 0, (-4194320), 4194304, 0, 0, 0, 0, (-4194320), 0, (-4194320), 0, 0, (-4194320), 0, 0, (-4194320), 0, 0, 0, (-4194319), 0, (-4194320), 0, (-4194320), (-4194319), 0, 0, 0, 0, 536871424,
        8192, 8192, 512, 512, 0, 0, (-4194320), 0, (-4194320), 1610618368, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131072, 0, (-4194320), 0, 0, 0, 0, 0, 0, 268435456, 0, 0, 268435456, 268435456, 0, 0, 0, 0, 0, 268435456, 0, 0, 268435456, 268435456, 0, 268435456, 0, 268435456, 0, 0, 0, 0, 0, (-4194320), (-2147483648), 0, 0, 0, 0, 0, (-4194320), (-2147483648), 0, 0, 0, 0, 0, 0, 0, 0, (-4194319), 0, (-4194319), (-4194319), 0, 0, 0, 0, (-4194319), 0, (-4194319), (-4194319), 0, (-4194319), 0, 0, 0, 0, (-4194319), (-4194319),
        0, 0, 0, (-4194320), 0, 0, (-4194320), 524288, 0, 0, 0, 0, 0, 0, 524288, 0, 50331648, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65536, 0, 0, 0, 0, 0, 50429952, 0, 65536, 65536, 0, 0, 0, (-4194320), 0, (-4194320), 0, (-4194320), (-4194320), 536870912, 0, (-4194320), 0, 0, (-4194320), 0, 0, (-4194320), 0, 0, (-4194320), 0, 0, 0, (-4194320), 0, 0, (-4194320), 0, 0, (-4194320), 0, (-4194320), 0, 1061408, (-4194320), 1061408, 1061408, 0, 1061408, 0, 1061408, 1061408, 0, 1061408, 0, 1061408, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 131072, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 131072, 0, 0, 0, 0, 0, 0, 131072, 0, 0, 0, 0, 0, 0, (-4194320), 0, 0, 131072, 0, 0, 0, 0, 1061408, 1061408, 0, 0, 0, 0, 0, 0, (-4194320), 0, (-4194320), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 512, 512, 0, 0, 0, 512, 512, 4096, 0, 0, 0, (-4194320), 0, 0, 0, 0, 512, 512, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4194320), 0, 0, (-4194320), 0, 0, 32, 512, 0, 384, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        67109248, 0, (-4194320), 0, 1057280, 0, 0, 0, 0, (-4194320), (-4194320), 0, 0, (-4194320), 0, 0, (-4194320), 0, 0, (-4194320), (-4194320), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4194320), (-4194320), 0, 0, 0, 0, 0, 0, (-4194320), 0, 0, (-4194320), 0, 0, 0, 2097152, 0, 0, 0, 2097152, 0, 0, 1536, 0, 0, 0, 0, 0, 0, (-4194320), 0, (-4194320), (-4194336), (-4194336), (-4194336), 0, 1, 1, 0, 0, (-4194320), 0, (-4194320), (-4194336),
        (-4194320), (-4194336)]);
    }
    function oncipj_Cypher_jj_la1_init_3() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_3 = $rt_createIntArrayFromData([0, (-939261951), 0, (-939261951), 0, (-2013265920), 0, 0, 0, 1074003969, 1074003969, 1074003968, 1, (-225), 128, 0, 0, 0, 0, 128, 128, (-225), 0, 0, 0, 128, (-225), 128, (-225), 0, 128, 0, 0, 0, 0, 0, 0, 0, 0, 262144, 128, 0, 128, 0, (-225), 0, 0, 0, 0, 1074003969, 0, 0, 0, 0, 65536, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-193), 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, (-193), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 0, 32, (-193), (-193), (-193), (-193), 32, 32, (-225), (-225), (-225), (-225), 0, 0, 0, (-225), 0, 0, 16448, 64, 64, 64, 64, 16448, 0, 0, 0, 0, 0, 0, (-225), (-225), 0, 0, 0, 0, 0, 0, (-225), 0, 0, 0, 0, 0, (-225), 0, (-225), 0, 0, 0, 0, 0, (-225), 128, (-225), 0, 0, (-225), 0, 0, (-225), 0, 0, 0, (-225), 128, (-225), 128, (-225), (-225), 128, 128, 128, 0, 4200448, (-2013265920), (-2013265920), 4200448, 5242880, 0, 0, (-225),
        0, (-225), 282079232, 0, 0, 12288, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, (-225), 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12288, 0, 0, 0, 0, 0, 12288, 0, 0, 0, 12288, 0, 0, 0, 0, (-225), 0, 0, 0, 0, 0, 0, (-225), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-225), 0, (-225), (-225), 0, 0, 0, 0, (-225), 0, (-225), (-225), 0, (-225), 0, 0, 0, 0, (-225), (-225), 0, 0, 0, (-225), 0, 0, (-225), 0, 0, 0, 0, 64, 64, 64, 0, 0, 0, 0, 0, 0, 33554432, 33554432, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16777216, 0, 0, 0, 0, 0, 0, (-225), 0, (-225),
        0, (-225), (-225), 0, 0, (-225), 0, 0, (-225), 0, 0, (-225), 0, 0, (-225), 128, 0, 0, (-225), 0, 0, (-225), 0, 0, (-225), 128, (-225), 0, 1078212608, (-225), 1078212608, 1078212608, 0, 1078212608, 0, 1078212608, 1078212608, 0, 1078212608, 0, (-1069271040), 0, 0, 0, 0, 0, 0, 134217728, 12582912, 0, 128, 12582912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 4, 4, 4, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 768, 0, 0, 0, 0, 0, 0, 768, 0, 0, 0, 0, 0, 0, 0, (-225), 0, 768, 0, 0, 0, 0,
        0, 1078212608, 1078212608, 71303168, 71303168, 71303168, 4194304, 4194304, 0, (-225), 12582912, (-225), 348127232, 0, 12288, 0, 0, 0, 0, 0, 0, 0, 12288, 4196352, 4208640, 0, 12288, 12288, 4196352, 4208640, 8, 0, 12288, 0, (-225), 0, 12288, 0, 0, 0, 12288, 0, 0, 4194304, 0, 4194304, 0, 0, 0, 0, 12288, 0, 0, (-225), 0, 0, (-225), 0, 0, 12288, 4194304, 0, 0, 0, 536870912, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, (-225), 0, 4196352, 128, 0, 0, 1073741824, (-225), (-225), 0, 128, (-225), 0, 128, (-225), 0, 128, (-225),
        (-225), 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12582912, 0, 0, 0, (-225), (-225), 268435456, 0, 0, 0, 281018368, 12582912, (-225), 281018368, 0, (-225), 268435456, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12582912, 0, 0, 0, 128, 0, (-225), 128, (-225), (-225), (-225), (-225), 128, 0, 0, 0, 128, (-225), 128, (-225), (-225), (-225), (-225)]);
    }
    function oncipj_Cypher_jj_la1_init_4() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_4 = $rt_createIntArrayFromData([0, 68612, 0, 68612, 0, 68608, 0, 0, 0, 4, 4, 4, 0, (-8389057), 0, 0, 0, 0, 0, 0, 0, (-8389057), 0, 1, 0, 0, (-8389065), 0, (-8389065), 4, 0, 0, 0, 393216, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, (-8389065), 0, 0, 0, 0, 4, 0, 0, 0, 0, 1073741824, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-8389065), 8, 0, 8, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 8, 0, (-8389065), 0, 0, 0, 0, 0, 8, 0, 0, 0, 8, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 0,
        8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 256, 0, 0, 0, 0, (-8389065), (-8389065), (-8389065), (-8389065), 0, 0, (-8389065), (-8389065), (-8389065), (-8389065), 0, 0, 0, (-8389057), 8388608, 0, 4194304, 0, 0, 0, 0, 4194304, 0, 0, 64, 64, 0, 0, (-8389057), (-8389057), 128, 0, 128, 0, (-2147483640), 0, (-8389065), 0, 0, 524288, 0, 0, (-8389065), 0, (-8389065), 0, 0, 0, 0, 0, (-8388937), 0, (-8388937), 16, 0, (-8389065), 16, 0, (-8389065), 0, 0, 0, (-8389057), 0, (-8389065), 0, (-8389065), (-8389057), 0, 0, 0, 0, 0, 68608,
        68608, 0, 0, 0, 0, (-8389057), 0, (-8389057), 469762048, 0, 0, 0, 0, 469762048, 0, 469762048, 0, 201326592, 201326592, 201326592, 0, 0, (-8389065), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-8389065), 0, 16777216, 0, 0, 0, 0, (-8389065), 0, 16777216, 0, 0, 0, 0, 0, 0, 0, (-8389057), 0, (-8389057), (-8389057), 0, 0, 0, 0, (-8389057), 0, (-8389057), (-8389057), 0, (-8389057), 0, 0, 0, 0, (-8389057), (-8389057), 0, 0, 0, (-8389065), 0, 0, (-8389065), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32768, 0, 0, 32768, 0, 0, 32768, 40960, 0, 0, 0, 0, 0, 0, (-8389065), 0, (-8389065), 0, (-8389065), (-8389065), 0, 0, (-8389065), 0, 0, (-8389065), 0, 0, (-8389065), 0, 0, (-8389065), 0, 0, 0, (-8389065), 0, 0, (-8389065), 0, 0, (-8389065), 0, (-8389065), 0, 33555456, (-8389057), 33555456, 33555456, 0, 33555456, 0, 33555456, 33555456, 0, 33555456, 0, 33555456, 0, 0, 0, 0, 0, 2048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1048576, 1048576, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 8, 1048576, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-8389057), 0, 0, 0, 0, 0, 0, 0, 33555456, 33555456, 0, 0, 0, 0, 0, 0, (-8389057), 0, (-8389057), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-8389057), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-8389057), 0, 0, (-8389057), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-8389057), 0, 33554432, 0, 0, 0, 0, (-8389065), (-8389065), 0, 0, (-8389065), 0,
        0, (-8389065), 393216, 0, (-8389065), (-8389065), 0, 0, 393216, 393216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4098, 4098, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-8389057), (-8389057), 0, 0, 0, 0, 0, 0, (-8389057), 0, 0, (-8389057), 0, 0, 512, 0, 0, 0, 0, 0, 512, 512, 0, 0, 0, 0, 0, 0, 128, (-8389057), 0, (-8389057), (-8388937), (-8388937), (-8388937), 0, 0, 8, 8, 0, (-8389065), 0, (-8389065), (-8389065), (-8389065), (-8389065)]);
    }
    function oncipj_Cypher_jj_la1_init_5() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_5 = $rt_createIntArrayFromData([0, 520, 0, 520, 0, 512, 0, 0, 0, 8, 8, 0, 8, (-278785), 0, 0, 0, 0, 0, 0, 0, (-278785), 0, 0, 0, 0, (-278785), 0, (-278785), 0, 0, 0, 0, 0, 0, 0, 0, 270532608, 0, 0, 0, 0, 0, 0, (-278785), 0, 0, 0, 1, 8, 1048576, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12288, 0, 0, 0, (-278785), 0, 0, 0, 0, 0, 0, 0, 0, 0, 134217728, 0, 0, 0, 0, 0, (-278785), 0, 16384, 16384, 16384, 0, 0, 0, 16384, 0, 0, 0, 16384, 0, 16384, 0, 0,
        16384, 16384, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134217728, 16384, 0, 0, 16384, 0, 0, 0, 0, 134217728, (-278785), (-278785), (-278785), (-278785), 0, 0, (-278785), (-278785), (-278785), (-278785), 0, 0, 0, (-278785), 16640, 16640, 135266304, 0, 0, 0, 0, 135266304, 0, 0, 0, 0, 0, 0, (-278785), (-278785), 0, 0, 0, 25165824, 25165824, 0, (-278785), 0, 0, 0, 0, 0, (-278785), 0, (-278785), 0, 0, 0, 0, 0, (-278785), 0, (-278785), 0, 0, (-278785), 0, 0, (-278785), 0, 0, 0, (-278785), 0, (-278785), 0, (-278785), (-278785),
        0, 0, 0, 0, 2097184, 512, 512, 2097152, 0, 0, 0, (-278785), 0, (-278785), 543228128, 0, 0, 6291648, 0, 536870912, 0, 536870912, 0, 536870912, 0, 0, 0, 0, (-278785), 0, 0, 0, 0, 0, 6291456, 0, 0, 0, 0, 0, 6291456, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-278785), 0, 0, 0, 0, 0, 192, (-278785), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-278785), 0, (-278785), (-278785), 0, 0, 0, 0, (-278785), 0, (-278785), (-278785), 0, (-278785), 0, 0, 0, 0, (-278785), (-278785), 4, 131072, 4, (-278785), 0, 16384, (-278785),
        0, 536870912, 0, 536870912, 0, 536870912, 134217728, 0, 0, 0, 0, 0, 100663296, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100663298, 0, 0, 0, 0, 0, 16384, (-278785), 0, (-278785), 131072, (-278785), (-278785), 2097184, 131072, (-278785), 0, 16384, (-278785), 0, 131072, (-278785), 0, 16384, (-278785), 0, 0, 131072, (-278785), 0, 16384, (-278785), 0, 131072, (-278785), 0, (-278785), 0, 6553600, (-278785), 6553600, 7077888, 524288, 6553600, 524288, 6553600, 6553600, 0, 6553600, 0, 7078400, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 131072, 0, 131072, 131072, 0, 0, 0, 0, 0, 131072, 0, 0, 0, 0, 65536, 131072, 131072, 131072, 0, 0, 0, 0, 65536, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-278785), 0, 0, 0, 0, 0, 0, 524288, 6553600, 6553600, 1024, 1024, 1024, 1024, 1024, 3072, (-278785), 0, (-278785), 68608, 6291456, 0, 0, (-1073741824), 0, 0, 0, 0, (-1073741824), 6291456, 0, 6291456, 6291456, 0, 6291456, 0, 6291456, 0, 6291456, 0, 0, (-278785), 0, 6291456, 0, 0, 0, 6291456,
        0, 65536, 0, 1073741824, 1073741824, 0, 1073741824, 6291456, 0, 0, 0, 0, (-278785), 0, 0, (-278785), 0, 0, 6291456, 0, 0, 0, 0, 0, 0, 192, 192, 0, 0, 0, 192, 192, 0, (-278785), 0, 262144, 0, 0, 0, 0, (-278785), (-278785), 0, 0, (-278785), 0, 0, (-278785), 0, 0, (-278785), (-278785), 0, 0, 4, 4, 131072, 0, 0, 0, 0, 0, 0, 0, 131072, 0, 0, 0, 131072, 0, 0, 0, 131072, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-278785), (-278785), 65536, 0, 0, 0, 65536, 0, (-278785), 65536, 3072, (-278785),
        68608, 131072, 0, 0, 0, 131072, 131072, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-278785), 0, (-278785), (-278785), (-278785), (-278785), 0, 0, 0, 0, 0, (-278785), 0, (-278785), (-278785), (-278785), (-278785)]);
    }
    function oncipj_Cypher_jj_la1_init_6() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_6 = $rt_createIntArrayFromData([0, 49280, 0, 49280, 0, 0, 0, 0, 0, 49280, 49280, 49152, 128, (-919572), 0, 0, 0, 32, 0, 0, 0, (-919572), 0, 0, 0, 0, (-986144), 0, (-986144), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16384, 0, 1024, 0, 0, (-986144), 0, 0, 0, 0, 49280, 0, (-2147483648), (-2147483648), 0, 0, 0, 0, 0, 0, 0, 8, 1024, 0, 8, 1024, 1024, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-986144), 8, 0, 8, 0, 0, 0, 8, 0, 0, 0, 0, 8, 0, 0, 2048, (-986144), 4, 0, 0, 0, 0, 8, 0, 0, 0, 8, 0,
        0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 2048, 65536, 0, 0, 0, 0, 0, 0, (-854046), (-1208813598), (-854046), (-1208813598), 1, 1, (-854048), (-1208813600), (-854048), (-1208813600), 0, 0, 0, (-919572), 788496, 788496, 0, 0, 1073741824, 0, 1207959552, 0, 65536, 65536, 131072, 131072, 0, 65536, (-919572), (-919572), 0, 4, 0, 0, 4259840, 1024, (-986144), 0, 0, 0, 0, 0, (-986144), 0, (-986144), 0, 0, 0, 0, 0, (-986144), 0, (-986144), 0, 0, (-985120), 0, 0, (-985120), 65536, 0, 65536, (-919572),
        0, (-986144), 0, (-986144), (-919572), 0, 0, 0, 0, 512, 0, 0, 0, 0, 0, 0, (-986144), 0, (-986144), 16777728, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-986144), 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-986144), 0, 0, 0, 0, 0, 0, (-986144), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-919572), 0, (-919572), (-919572), 0, 0, 0, 0, (-919572), 0, (-919572), (-919572), 0, (-919572), 0, 0, 0, 0, (-919572), (-919572), 0, 0, 0, (-986144), 2048, 0, (-986144), 0, 0, 0, 0, 0, 150994944,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16777216, 0, 64, 16777216, 0, 0, 0, 16785408, 1358963008, 134217728, 64, 64, 134217728, 2048, 0, (-986144), 150994944, (-985120), 0, (-986144), (-986144), 512, 0, (-986144), 2048, 0, (-986144), 0, 0, (-986144), 2048, 0, (-986144), 0, 0, 0, (-986144), 2048, 0, (-986144), 0, 0, (-986144), 0, (-985120), 0, 1097856, (-986144), 1097856, 1097856, 0, 1097856, 0, 1097856, 1097856, 0, 1097856, 0, 1097856, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134217728, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-986144), 0, 0, 0, 0, 0, 0, 0, 1097856, 1097856, 0, 0, 0, 0, 0, 0, (-986144), 0, (-986144), 0, 0, 0, 16777216, 0, 0, 0, 0, 3145728, 19922944, 8388608, 0, 8388608, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-986144), 1024, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4096, 0, 4096, 4096, (-986144), 1024, 0, (-986144), 1024, 4096, 1048576, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-986144), 1024, 0,
        0, 16384, 1024, 32768, (-986144), (-986144), 0, 0, (-986144), 50331648, 0, (-986144), 0, 0, (-986144), (-986144), 0, 8, 50331648, 50331648, 0, 0, 0, 0, 0, 0, 0, 536870912, 0, 0, 536870912, 0, 0, 0, 0, 536870912, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 536870912, 536870912, 536870912, 0, 0, 0, 536870912, 0, 0, 0, 0, (-986144), (-986144), 0, 0, 0, 0, 0, 0, (-986144), 0, 0, (-986144), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-986144), 0, (-986144), (-986144), (-986144), (-986144), 0, 0, 0, 8, 0, (-986144),
        0, (-986144), (-986144), (-1208945696), (-1208945696)]);
    }
    function oncipj_Cypher_jj_la1_init_7() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_7 = $rt_createIntArrayFromData([0, 4, 0, 4, 0, 0, 0, 0, 0, 4, 4, 4, 0, 805011455, 0, 64, 0, 0, 0, 0, 0, 805011455, 0, 0, 0, 0, 804995071, 0, 804995071, 0, 0, 4, 0, 0, 0, 524288, 0, 536936448, 1, 0, 0, 0, 0, 0, 804995071, 0, 0, 0, 0, 4, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 16384, 0, 0, 16384, 0, 0, 3072, 3072, 3072, 3072, 0, 3072, 3072, 3072, 3072, 0, 3072, 3072, 0, 3072, 3072, 0, 804995071, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16384, 0, 0, 0, 804995071, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 804995071, 804995071, 804995071, 804995071, 0, 0, 804995071, 804995071, 804995071, 804995071, 32, 0, 0, 805011455, 0, 0, 0, 0, 0, 0, 0, 0, 16384, 16384, 0, 0, 262144, 16384, 805011455, 805011455, 0, 0, 0, 0, 0, 0, 804995071, 0, 0, 0, 0, 0, 804995071, 0, 804995071, 0, 0, 0, 0, 0, 804995071, 0, 804995071, 524288, 0, 804995071, 524288, 0, 804995071, 0, 0, 0, 805011455, 0, 804995071, 0, 804995071, 805011455, 0, 0, 0, 32, 536936448, 0, 0,
        0, 0, 0, 0, 804995071, 0, 804995071, 734199808, 0, 0, 12582912, 0, 134217728, 0, 134217728, 0, 134217728, 0, 0, 0, 0, 804995071, 0, 64, 0, 0, 0, 0, 0, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 0, 0, 0, 0, 0, 128, 0, 0, 0, 0, 0, 50331648, 804995071, 0, 0, 0, 0, 0, 0, 804995071, 0, 0, 0, 0, 0, 0, 0, 0, 0, 805011455, 0, 805011455, 805011455, 0, 0, 0, 0, 805011455, 0, 805011455, 805011455, 0, 805011455, 0, 0, 0, 0, 805011455, 805011455, 1, 0, 1, 804995071, 0, 0, 804995071, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 134217728, 134284288, 0, 0, 0, 0, 0, 0, 804995071, 0, 804995071, 0, 804995071, 804995071, 536936448, 0, 804995071, 0, 0, 804995071, 8, 0, 804995071, 0, 0, 804995071, 0, 8, 0, 804995071, 0, 0, 804995071, 8, 0, 804995071, 0, 804995071, 0, 4194304, 804995071, 4194304, 4194304, 0, 4194304, 0, 4194304, 4194304, 0, 4194304, 0, 4194304, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 8192, 0, 0, 256, 0, 0, 0, 0, 0, 0, 0, 8448, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12582912,
        0, 0, 0, 12582912, 0, 0, 0, 0, 0, 0, 12582912, 0, 0, 0, 0, 0, 0, 12582912, 12582912, 12582912, 804995071, 0, 0, 0, 0, 0, 0, 0, 4194304, 4194304, 0, 0, 8388608, 0, 0, 0, 804995071, 0, 804995071, 0, 0, 0, 0, 0, 0, 0, 134217728, 0, 134217728, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 804995071, 0, 0, 0, 0, 4194304, 4194304, 768, 0, 768, 134217728, 134218496, 4194304, 4194304, 0, 0, 0, 0, 0, 804995071, 0, 0, 804995071, 0, 0, 0, 0, 4194304, 0, 50331648, 0, 0, 0, 50331648, 50331648, 0, 0, 0, 50331648, 0, 804995071,
        0, 4194304, 0, 0, 0, 0, 804995071, 804995071, 0, 0, 804995071, 0, 0, 804995071, 0, 0, 804995071, 804995071, 0, 0, 0, 0, 0, 3145728, 0, 3145728, 0, 0, 8, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 2, 3145728, 0, 3145728, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 804995071, 804995071, 0, 0, 0, 0, 0, 0, 804995071, 0, 0, 804995071, 0, 0, 0, 0, 67108864, 0, 0, 0, 67109120, 67109120, 0, 0, 0, 0, 0, 0, 0, 804995071, 0, 804995071, 1073430527, 1073430527, 1073430527, 0, 0, 0, 0, 0, 804995071, 0, 804995071, 804995071, 804995071,
        804995071]);
    }
    function oncipj_Cypher_jj_la1_init_8() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_8 = $rt_createIntArrayFromData([0, 1073766666, 0, 1073766666, 0, 16394, 0, 0, 0, 1073750272, 1073750272, 1073750272, 0, (-134742033), 0, 0, 0, 0, 0, 0, 0, (-134742033), 0, 0, 0, 0, (-134742033), 0, (-134742033), 0, 0, 0, 0, 0, 192, 0, 0, 1048576, 0, 0, 0, 0, 0, 0, (-134742033), 0, 0, 0, 0, 1073750272, 0, 1024, 1024, 393216, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-134742033), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-134742033), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-134742033), (-134742033), (-134742033), (-134742033), 0, 0, (-134742033), (-134742033), (-134742033), (-134742033), 0, 0, 0, (-134742033), 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-134742033), (-134742033), 0, 0, 0, 0, 0, 0, (-134742033), 0, 0, 0, 0, 0, (-134742033), 0, (-134742033), 0, 0, 0, 0, 0, (-134742033), 0, (-134742033), 0, 0, (-134742033), 0, 0, (-134742033), 0, 0, 0, (-134742033), 0,
        (-134742033), 0, (-134742033), (-134742033), 0, 0, 0, 0, 32768, 16394, 16394, 268468224, 268435456, 98304, 98304, (-134742033), 0, (-134742033), (-1342078880), 0, 98304, 98304, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-134742033), 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, (-134742033), 0, 0, 8192, 0, 0, 0, (-134742033), 0, 0, 8192, 0, 0, 0, 8192, 0, 8192, (-134742033), 0, (-134742033), (-134742033), 0, 8192, 0, 8192, (-134742033), 0, (-134742033), (-134742033),
        0, (-134742033), (-2147483648), 8192, 0, 8192, (-134742033), (-134742033), 0, 0, 0, (-134742033), 0, 0, (-134217745), 2048, 0, 96, 0, 0, 96, 0, 2048, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 0, 0, 64, 0, 0, 64, 64, 0, 0, 0, 0, 0, 0, (-134217745), 0, (-134742033), 0, (-134742033), (-134742033), 0, 0, (-134742033), 0, 0, (-134217745), 0, 0, (-134742033), 0, 0, (-134217745), 0, 0, 0, (-134742033), 0, 0, (-134217745), 0, 0, (-134742033), 0, (-134742033), 268468224, 1342210313, (-134742033), 1342275849, 1342275849,
        0, 1342210313, 0, 1342210313, 1342210313, 98304, 1342177545, 98304, 1342275849, 0, 805306368, 8192, 0, 0, 0, 2, 0, 805306368, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 0, 1073741824, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1073741824, 1073742080, 0, 0, 0, 8192, 0, 0, 8192, 0, 0, 0, 8192, 0, 0, 0, 16384, 0, 0, 8192, 0, 0, 0, 16384, 0, 0, 8192, 0, 0, 0, 0, 0, (-134742033), 16384, 0, 0, 8192, 0, 0, 0, 1342210313, 1342177545, 0, 0, 0, 0, 0, 0, (-134742033), 0, (-134742033), 0, 0, 0, 0, 0, 64, 0, 0, 0, 64, 0, 32768, 32768,
        0, 0, 0, 32768, 32768, 0, 0, 0, 0, (-134742033), 0, 0, 805306368, (-2147483648), (-1342144512), (-1342144512), 0, 0, 0, 0, 0, 32768, 32768, 0, 0, 0, 0, 0, (-134742033), 0, 0, (-134742033), 0, 0, 0, 0, 32768, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32768, (-134742033), 0, 268435464, 0, 1, 0, 0, (-134742033), (-134742033), 192, 0, (-134742033), 0, 0, (-134742033), 0, 0, (-134742033), (-134742033), 0, 0, 192, 192, 0, 0, 25165824, 25165824, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25165824, 25165824, 0, 0, 1073741824,
        256, 1073742080, 0, 0, 0, 39845888, 39845888, 0, 0, 0, 8192, 0, 8192, (-134742033), (-134742033), 0, 8192, 0, 0, 0, 0, (-134742033), 0, 0, (-134742033), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 0, 0, 0, (-134742033), 0, (-134742033), (-134742033), (-134742033), (-134742033), 0, 0, 0, 0, 0, (-134742033), 0, (-134742033), (-134742033), (-134742033), (-134742033)]);
    }
    function oncipj_Cypher_jj_la1_init_9() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_9 = $rt_createIntArrayFromData([0, 33928, (-2147483648), 33928, (-2147483648), 33928, 0, (-2147483648), 0, 0, 0, 0, 0, (-524289), 0, 0, 64, 0, 0, 0, 0, (-1), 0, 0, 0, 0, (-524289), 0, (-524289), 0, 0, 0, 0, 0, 0, 0, 0, 65536, 0, 0, 0, 0, 0, 0, (-1), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 524288, 0, 2, 524288, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, (-524289), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 524288, 0, 0, 0, (-524289), 0, 0, 0, 0, 524288, 0, 0, 0, 524288, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 524288, 524288, 0, 524288, 524288, 0, 0, 524288, 0, 524288, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-524289), (-537395201), (-524289), (-537395201), 0, 0, (-524289), (-537395201), (-524289), (-537395201), 0, 0, 0, (-524289), 0, 0, 256, 536870912, 536870912, 536870912, 536870912, 256, 0, 0, 524288, 524288, 0, 0, (-524289), (-524289), 0, 0, 0, 0, 134217728, 0, (-524289), 0, 0, 0, 0, 0, (-524289), 0, (-524289), 0, 0, 0, 0, 0, (-524289), 0, (-524289), 0, 0, (-524289), 0, 0, (-524289), 0, 0, 0, (-524289),
        0, (-524289), 0, (-524289), (-524289), 0, 0, 0, 0, 65536, 33928, 1152, 0, 0, 0, 0, (-524289), 0, (-524289), 50401281, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 268435456, 0, 0, (-1), 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-524289), 0, 0, 0, 0, 0, 0, (-524289), 0, 0, 0, 0, 0, 50331648, 0, 0, 0, (-524289), 32776, (-524289), (-524289), 50331648, 0, 0, 0, (-524289), 32776, (-524289), (-524289), 32776, (-524289), 1, 0, 0, 0, (-524289), (-524289), 0, 0, 0, (-524289), 0,
        0, (-524289), 0, 0, 0, 0, 536870912, 536870912, 0, 0, 0, 0, 2048, 16, 16, 262144, 262144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1312784, 0, 0, 0, 0, 0, 0, (-524289), 0, (-524289), 0, (-524289), (-524289), 65536, 0, (-524289), 0, 0, (-524289), 0, 0, (-524289), 0, 0, (-524289), 0, 0, 0, (-524289), 0, 0, (-524289), 0, 0, (-524289), 0, (-524289), 0, 83920008, (-524289), 83920008, 83920008, 0, 83920008, 0, 83920008, 83920008, 0, 83920008, 0, 83920008, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 512, 0, 0, 0, 0, 0, 0, 0, 512, 0, 0, 0, 0, 8192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-524289), 0, 0, 0, 0, 0, 0, 0, 83920008, 83920008, 0, 0, 0, 0, 0, 0, (-1), 0, (-1), 0, 0, 0, 0, 0, 0, 1342177280, 0, 0, 1342177280, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50331648, (-1), 0, 50331648, 0, 1, 1, 50331649, 0, 512, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-1), 0, 50331648, (-1), 0, 0, 16811136, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-1), 0, 0, 0, 67108864, 0, 0, (-1),
        (-1), 0, 0, (-1), 0, 0, (-1), 0, 0, (-1), (-524289), 0, 0, 0, 0, 0, 0, 0, 0, 0, 8388608, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8388608, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-524289), (-524289), 0, 0, 0, 0, 0, 0, (-1), 0, 0, (-1), 0, 0, 0, 0, 0, 0, 0, 0, 16384, 16384, 0, 0, 0, 0, 0, 0, 0, (-524289), 0, (-524289), (-1), (-1), (-1), 0, 0, 0, 0, 0, (-524289), 0, (-524289), (-524289), (-537395201), (-537395201)]);
    }
    function oncipj_Cypher_jj_la1_init_10() {
        oncipj_Cypher_$callClinit();
        oncipj_Cypher_jj_la1_10 = $rt_createIntArrayFromData([128, 32788, 0, 32788, 0, 0, 0, 0, 0, 32788, 32788, 32788, 0, 4194303, 0, 0, 0, 0, 0, 0, 0, 4194303, 0, 0, 16384, 0, 4194303, 0, 4194303, 0, 0, 0, 16384, 0, 0, 0, 128, 0, 0, 0, 0, 0, 0, 16384, 4194303, 524288, 0, 32768, 0, 32788, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4194303, 0, 16384, 0, 16384, 16384, 16384, 0, 16384, 16384, 0, 16384, 0, 0, 0, 33554432, 4194303, 0, 67108864, 67108864, 67108864,
        0, 0, 16384, 67108864, 0, 0, 16384, 67108864, 16384, 67108864, 0, 16384, 67108864, 67108864, 0, 0, 16384, 0, 0, 0, 16384, 0, 16384, 0, 0, 67108864, 33554432, 16777216, 67108864, 0, 0, 0, 0, 0, 4194303, 4194303, 4194303, 4194303, 0, 0, 4194303, 4194303, 4194303, 4194303, 0, 262144, 0, 4194303, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4194303, 4194303, 0, 0, 0, 0, 0, 0, 4194303, 8192, 8192, 0, 16384, 0, 4194303, 16384, 4194303, 16384, 16384, 16384, 16384, 16384, 4194303, 0, 4194303, 0, 16384, 4194303, 0,
        16384, 4194303, 0, 0, 0, 4194303, 0, 4194303, 0, 4194303, 4194303, 0, 0, 0, 0, 32, 0, 0, 32, 32, 0, 0, 4194303, 96, 4194303, 3, 96, 0, 0, 3, 3, 3, 3, 3, 3, 0, 0, 0, 0, 4194303, 0, 0, 0, 0, 16384, 0, 1024, 0, 0, 541696, 541696, 0, 0, 540672, 540672, 0, 1024, 0, 0, 541696, 541696, 0, 1024, 0, 1024, 0, 0, 540672, 540672, 0, 4194303, 0, 0, 0, 540672, 540672, 0, 4194303, 0, 0, 0, 540672, 540672, 0, 0, 540672, 0, 4194303, 0, 4194303, 4194303, 0, 0, 540672, 0, 4194303, 0, 4194303, 4194303, 0, 4194303, 0, 0, 540672,
        0, 4194303, 4194303, 0, 0, 0, 4194303, 33554432, 67108864, 4194303, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 512, 0, 0, 0, 0, 98304, 98304, 2048, 0, 0, 2048, 0, 256, 256, 2048, 1051136, 0, 0, 0, 0, 33554432, 67108864, 4194303, 1, 4194303, 0, 4194303, 4194303, 0, 0, 4194303, 33554432, 67108864, 4194303, 0, 0, 4194303, 33554432, 67108864, 4194303, 0, 0, 0, 4194303, 33554432, 67108864, 4194303, 0, 0, 4194303, 0, 4194303, 32, 131104, 4194303, 131104, 131104, 0, 131104, 0, 131104, 131104, 0, 131104, 0, 131104, 0, 0, 0,
        540672, 540672, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 32768, 0, 540672, 540672, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 540672, 540672, 0, 540672, 540672, 0, 0, 540672, 540672, 0, 0, 0, 0, 0, 540672, 540672, 0, 0, 0, 0, 0, 540672, 540672, 0, 0, 0, 4194303, 0, 0, 0, 0, 540672, 540672, 0, 131104, 131104, 0, 0, 0, 0, 0, 0, 4194303, 0, 4194303, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 32, 0, 0, 0, 32, 32, 8, 0, 0, 0, 4194303, 0, 0, 0, 0, 32, 32, 0, 0, 32, 0, 32, 0, 0, 0, 0, 0, 0, 0, 4194303, 0, 0,
        4194303, 0, 0, 0, 32, 0, 0, 0, 0, 32, 0, 32, 0, 0, 32, 0, 32, 32, 4194303, 0, 32, 0, 0, 0, 0, 4194303, 4194303, 0, 0, 4194303, 0, 0, 4194303, 0, 0, 4194303, 4194303, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4096, 0, 0, 4096, 0, 0, 0, 0, 4096, 0, 131072, 0, 0, 0, 0, 0, 0, 0, 0, 4096, 4096, 4096, 0, 0, 0, 4096, 0, 0, 540672, 0, 4194303, 4194303, 0, 0, 540672, 540672, 0, 0, 4194303, 0, 0, 4194303, 0, 0, 0, 0, 0, 0, 0, 0, 32, 32, 0, 0, 0, 540672, 540672, 0, 0, 4194303, 0, 4194303, 4194303, 4194303, 4194303, 0, 0, 0,
        0, 0, 4194303, 0, 4194303, 4194303, 4194303, 4194303]);
    }
    function oncipj_Cypher_jj_consume_token($this, $kind) {
        var $oldToken, var$3, var$4, $i, var$6, $c;
        $oldToken = $this.$token;
        var$3 = $oldToken.$next1;
        if (var$3 !== null)
            $this.$token = var$3;
        else {
            $oldToken.$next1 = oncipj_CypherTokenManager_getNextToken($this.$token_source);
            $this.$token = $this.$token.$next1;
        }
        $this.$jj_ntk = (-1);
        var$3 = $this.$token;
        if (var$3.$kind0 != $kind) {
            $this.$token = $oldToken;
            $this.$jj_kind = $kind;
            $rt_throw(oncipj_Cypher_generateParseException($this));
        }
        a: {
            $kind = $this.$jj_gen + 1 | 0;
            $this.$jj_gen = $kind;
            var$4 = $this.$jj_gc + 1 | 0;
            $this.$jj_gc = var$4;
            if (var$4 > 100) {
                $this.$jj_gc = 0;
                $i = 0;
                while (true) {
                    var$6 = $this.$jj_2_rtns.data;
                    if ($i >= var$6.length)
                        break a;
                    $c = var$6[$i];
                    while ($c !== null) {
                        if ($c.$gen < $kind)
                            $c.$first2 = null;
                        $c = $c.$next6;
                    }
                    $i = $i + 1 | 0;
                }
            }
        }
        return var$3;
    }
    function oncipj_Cypher_jj_scan_token($this, $kind) {
        var $tok, var$3, $i;
        $tok = $this.$jj_scanpos;
        if ($tok !== $this.$jj_lastpos)
            $this.$jj_scanpos = $tok.$next1;
        else {
            $this.$jj_la = $this.$jj_la - 1 | 0;
            var$3 = $tok.$next1;
            if (var$3 !== null) {
                $this.$jj_scanpos = var$3;
                $this.$jj_lastpos = var$3;
            } else {
                var$3 = oncipj_CypherTokenManager_getNextToken($this.$token_source);
                $tok.$next1 = var$3;
                $this.$jj_scanpos = var$3;
                $this.$jj_lastpos = var$3;
            }
        }
        if ($this.$jj_rescan) {
            $i = 0;
            $tok = $this.$token;
            while ($tok !== null && $tok !== $this.$jj_scanpos) {
                $i = $i + 1 | 0;
                $tok = $tok.$next1;
            }
            if ($tok !== null)
                oncipj_Cypher_jj_add_error_token($this, $kind, $i);
        }
        $tok = $this.$jj_scanpos;
        if ($tok.$kind0 != $kind)
            return 1;
        if (!$this.$jj_la && $tok === $this.$jj_lastpos)
            $rt_throw($this.$jj_ls);
        return 0;
    }
    function oncipj_Cypher_jj_ntk_f($this) {
        var var$1, var$2, $ret;
        var$1 = $this.$token;
        var$2 = var$1.$next1;
        $this.$jj_nt = var$2;
        if (var$2 !== null) {
            $ret = var$2.$kind0;
            $this.$jj_ntk = $ret;
        } else {
            var$1.$next1 = oncipj_CypherTokenManager_getNextToken($this.$token_source);
            $ret = $this.$token.$next1.$kind0;
            $this.$jj_ntk = $ret;
        }
        return $ret;
    }
    function oncipj_Cypher_jj_add_error_token($this, $kind, $pos) {
        var $i, $isMatched, $oldentry, var$6, $i_0, var$8, var$9;
        if ($pos >= 100)
            return;
        $i = $this.$jj_endpos;
        $isMatched = $i + 1 | 0;
        if ($pos == $isMatched) {
            $oldentry = $this.$jj_lasttokens.data;
            $this.$jj_endpos = $isMatched;
            $oldentry[$i] = $kind;
        } else if ($i) {
            $oldentry = $rt_createIntArray($i);
            var$6 = $oldentry.data;
            $this.$jj_expentry = $oldentry;
            $i_0 = 0;
            while ($i_0 < $i) {
                var$6[$i_0] = $this.$jj_lasttokens.data[$i_0];
                $i_0 = $i_0 + 1 | 0;
            }
            var$8 = ju_AbstractList_iterator($this.$jj_expentries);
            a: {
                while (true) {
                    if (!ju_AbstractList$1_hasNext(var$8))
                        break a;
                    $oldentry = (ju_AbstractList$1_next(var$8)).data;
                    $isMatched = $oldentry.length;
                    var$6 = $this.$jj_expentry;
                    var$9 = var$6.data;
                    $i_0 = var$9.length;
                    if ($isMatched == $i_0) {
                        $isMatched = 1;
                        $i = 0;
                        b: {
                            while ($i < $i_0) {
                                if ($oldentry[$i] != var$9[$i]) {
                                    $isMatched = 0;
                                    break b;
                                }
                                $i = $i + 1 | 0;
                            }
                        }
                        if ($isMatched)
                            break;
                    }
                }
                ju_ArrayList_add($this.$jj_expentries, var$6);
            }
            if ($pos) {
                $this.$jj_endpos = $pos;
                $this.$jj_lasttokens.data[$pos - 1 | 0] = $kind;
            }
        }
    }
    function oncipj_Cypher_generateParseException($this) {
        var var$1, $la1tokens, $i, var$4, $i_0, $j, var$7, $exptokseq, var$9;
        var$1 = $this.$jj_expentries;
        ju_Arrays_fill(var$1.$array, 0, var$1.$size2, null);
        var$1.$size2 = 0;
        $la1tokens = $rt_createBooleanArray(348);
        $i = $this.$jj_kind;
        if ($i >= 0) {
            $la1tokens.data[$i] = 1;
            $this.$jj_kind = (-1);
        }
        var$4 = $la1tokens.data;
        $i_0 = 0;
        while ($i_0 < 637) {
            a: {
                if ($this.$jj_la1.data[$i_0] == $this.$jj_gen) {
                    $j = 0;
                    while (true) {
                        if ($j >= 32)
                            break a;
                        oncipj_Cypher_$callClinit();
                        $i = oncipj_Cypher_jj_la1_0.data[$i_0];
                        var$7 = 1 << $j;
                        if ($i & var$7)
                            var$4[$j] = 1;
                        if (oncipj_Cypher_jj_la1_1.data[$i_0] & var$7)
                            var$4[32 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_2.data[$i_0] & var$7)
                            var$4[64 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_3.data[$i_0] & var$7)
                            var$4[96 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_4.data[$i_0] & var$7)
                            var$4[128 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_5.data[$i_0] & var$7)
                            var$4[160 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_6.data[$i_0] & var$7)
                            var$4[192 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_7.data[$i_0] & var$7)
                            var$4[224 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_8.data[$i_0] & var$7)
                            var$4[256 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_9.data[$i_0] & var$7)
                            var$4[288 + $j | 0] = 1;
                        if (oncipj_Cypher_jj_la1_10.data[$i_0] & var$7)
                            var$4[320 + $j | 0] = 1;
                        $j = $j + 1 | 0;
                    }
                }
            }
            $i_0 = $i_0 + 1 | 0;
        }
        $i = 0;
        while ($i < 348) {
            if (var$4[$i]) {
                $la1tokens = $rt_createIntArray(1);
                $exptokseq = $la1tokens.data;
                $this.$jj_expentry = $la1tokens;
                $exptokseq[0] = $i;
                ju_ArrayList_add($this.$jj_expentries, $la1tokens);
            }
            $i = $i + 1 | 0;
        }
        $this.$jj_endpos = 0;
        oncipj_Cypher_jj_rescan_token($this);
        oncipj_Cypher_jj_add_error_token($this, 0, 0);
        $exptokseq = $rt_createArray($rt_arraycls($rt_intcls()), $this.$jj_expentries.$size2);
        var$4 = $exptokseq.data;
        $i = 0;
        while (true) {
            var$1 = $this.$jj_expentries;
            if ($i >= var$1.$size2)
                break;
            var$4[$i] = ju_ArrayList_get(var$1, $i);
            $i = $i + 1 | 0;
        }
        var$1 = new oncipj_ParseException;
        var$9 = $this.$token;
        $la1tokens = oncipj_CypherConstants_tokenImage;
        jl_Throwable__init_(var$1, oncipj_ParseException__initialise(var$9, $exptokseq, $la1tokens));
        var$1.$currentToken = var$9;
        var$1.$expectedTokenSequences = $exptokseq;
        var$1.$tokenImage = $la1tokens;
        return var$1;
    }
    function oncipj_Cypher_jj_rescan_token($this) {
        var $i, $p, var$3, $$je;
        $this.$jj_rescan = 1;
        $i = 0;
        while ($i < 145) {
            a: {
                b: {
                    try {
                        $p = $this.$jj_2_rtns.data[$i];
                        while (true) {
                            c: {
                                if ($p.$gen > $this.$jj_gen) {
                                    $this.$jj_la = $p.$arg;
                                    var$3 = $p.$first2;
                                    $this.$jj_scanpos = var$3;
                                    $this.$jj_lastpos = var$3;
                                    switch ($i) {
                                        case 0:
                                            break;
                                        case 1:
                                            oncipj_Cypher_jj_3_2($this);
                                            break c;
                                        case 2:
                                            oncipj_Cypher_jj_3_3($this);
                                            break c;
                                        case 3:
                                            oncipj_Cypher_jj_3_4($this);
                                            break c;
                                        case 4:
                                            oncipj_Cypher_jj_3_5($this);
                                            break c;
                                        case 5:
                                            oncipj_Cypher_jj_3_6($this);
                                            break c;
                                        case 6:
                                            oncipj_Cypher_jj_3_7($this);
                                            break c;
                                        case 7:
                                            oncipj_Cypher_jj_3_8($this);
                                            break c;
                                        case 8:
                                            oncipj_Cypher_jj_3_9($this);
                                            break c;
                                        case 9:
                                            oncipj_Cypher_jj_3_10($this);
                                            break c;
                                        case 10:
                                            oncipj_Cypher_jj_3_11($this);
                                            break c;
                                        case 11:
                                            oncipj_Cypher_jj_3_12($this);
                                            break c;
                                        case 12:
                                            oncipj_Cypher_jj_3_13($this);
                                            break c;
                                        case 13:
                                            oncipj_Cypher_jj_3_14($this);
                                            break c;
                                        case 14:
                                            oncipj_Cypher_jj_3_15($this);
                                            break c;
                                        case 15:
                                            oncipj_Cypher_jj_3_16($this);
                                            break c;
                                        case 16:
                                            oncipj_Cypher_jj_3_17($this);
                                            break c;
                                        case 17:
                                            oncipj_Cypher_jj_3_18($this);
                                            break c;
                                        case 18:
                                            oncipj_Cypher_jj_3_19($this);
                                            break c;
                                        case 19:
                                            oncipj_Cypher_jj_3_20($this);
                                            break c;
                                        case 20:
                                            oncipj_Cypher_jj_3_21($this);
                                            break c;
                                        case 21:
                                            oncipj_Cypher_jj_3_22($this);
                                            break c;
                                        case 22:
                                            oncipj_Cypher_jj_3_23($this);
                                            break c;
                                        case 23:
                                            oncipj_Cypher_jj_3_24($this);
                                            break c;
                                        case 24:
                                            oncipj_Cypher_jj_3_25($this);
                                            break c;
                                        case 25:
                                            oncipj_Cypher_jj_3_26($this);
                                            break c;
                                        case 26:
                                            oncipj_Cypher_jj_3_27($this);
                                            break c;
                                        case 27:
                                            oncipj_Cypher_jj_3_28($this);
                                            break c;
                                        case 28:
                                            oncipj_Cypher_jj_3_29($this);
                                            break c;
                                        case 29:
                                            oncipj_Cypher_jj_3_30($this);
                                            break c;
                                        case 30:
                                            oncipj_Cypher_jj_3_31($this);
                                            break c;
                                        case 31:
                                            oncipj_Cypher_jj_3_32($this);
                                            break c;
                                        case 32:
                                            oncipj_Cypher_jj_3_33($this);
                                            break c;
                                        case 33:
                                            oncipj_Cypher_jj_3_34($this);
                                            break c;
                                        case 34:
                                            oncipj_Cypher_jj_3_35($this);
                                            break c;
                                        case 35:
                                            oncipj_Cypher_jj_3_36($this);
                                            break c;
                                        case 36:
                                            oncipj_Cypher_jj_3_37($this);
                                            break c;
                                        case 37:
                                            oncipj_Cypher_jj_3_38($this);
                                            break c;
                                        case 38:
                                            oncipj_Cypher_jj_3_39($this);
                                            break c;
                                        case 39:
                                            oncipj_Cypher_jj_3_40($this);
                                            break c;
                                        case 40:
                                            oncipj_Cypher_jj_3_41($this);
                                            break c;
                                        case 41:
                                            oncipj_Cypher_jj_3_42($this);
                                            break c;
                                        case 42:
                                            oncipj_Cypher_jj_3_43($this);
                                            break c;
                                        case 43:
                                            oncipj_Cypher_jj_3_44($this);
                                            break c;
                                        case 44:
                                            oncipj_Cypher_jj_3_45($this);
                                            break c;
                                        case 45:
                                            oncipj_Cypher_jj_3_46($this);
                                            break c;
                                        case 46:
                                            oncipj_Cypher_jj_3_47($this);
                                            break c;
                                        case 47:
                                            oncipj_Cypher_jj_3_48($this);
                                            break c;
                                        case 48:
                                            oncipj_Cypher_jj_3_49($this);
                                            break c;
                                        case 49:
                                            oncipj_Cypher_jj_3_50($this);
                                            break c;
                                        case 50:
                                            oncipj_Cypher_jj_3_51($this);
                                            break c;
                                        case 51:
                                            oncipj_Cypher_jj_3_52($this);
                                            break c;
                                        case 52:
                                            oncipj_Cypher_jj_3_53($this);
                                            break c;
                                        case 53:
                                            oncipj_Cypher_jj_3_54($this);
                                            break c;
                                        case 54:
                                            oncipj_Cypher_jj_3_55($this);
                                            break c;
                                        case 55:
                                            oncipj_Cypher_jj_3_56($this);
                                            break c;
                                        case 56:
                                            oncipj_Cypher_jj_3_57($this);
                                            break c;
                                        case 57:
                                            oncipj_Cypher_jj_3_58($this);
                                            break c;
                                        case 58:
                                            oncipj_Cypher_jj_3_59($this);
                                            break c;
                                        case 59:
                                            oncipj_Cypher_jj_3_60($this);
                                            break c;
                                        case 60:
                                            oncipj_Cypher_jj_3_61($this);
                                            break c;
                                        case 61:
                                            oncipj_Cypher_jj_3_62($this);
                                            break c;
                                        case 62:
                                            oncipj_Cypher_jj_3_63($this);
                                            break c;
                                        case 63:
                                            oncipj_Cypher_jj_3_64($this);
                                            break c;
                                        case 64:
                                            oncipj_Cypher_jj_3_65($this);
                                            break c;
                                        case 65:
                                            oncipj_Cypher_jj_3_66($this);
                                            break c;
                                        case 66:
                                            oncipj_Cypher_jj_3_67($this);
                                            break c;
                                        case 67:
                                            oncipj_Cypher_jj_3_68($this);
                                            break c;
                                        case 68:
                                            oncipj_Cypher_jj_3_69($this);
                                            break c;
                                        case 69:
                                            oncipj_Cypher_jj_3_70($this);
                                            break c;
                                        case 70:
                                            oncipj_Cypher_jj_3_71($this);
                                            break c;
                                        case 71:
                                            oncipj_Cypher_jj_3_72($this);
                                            break c;
                                        case 72:
                                            oncipj_Cypher_jj_3_73($this);
                                            break c;
                                        case 73:
                                            oncipj_Cypher_jj_3_74($this);
                                            break c;
                                        case 74:
                                            oncipj_Cypher_jj_3_75($this);
                                            break c;
                                        case 75:
                                            oncipj_Cypher_jj_3_76($this);
                                            break c;
                                        case 76:
                                            oncipj_Cypher_jj_3_77($this);
                                            break c;
                                        case 77:
                                            oncipj_Cypher_jj_3_78($this);
                                            break c;
                                        case 78:
                                            oncipj_Cypher_jj_3_79($this);
                                            break c;
                                        case 79:
                                            oncipj_Cypher_jj_3_80($this);
                                            break c;
                                        case 80:
                                            oncipj_Cypher_jj_3_81($this);
                                            break c;
                                        case 81:
                                            oncipj_Cypher_jj_3_82($this);
                                            break c;
                                        case 82:
                                            oncipj_Cypher_jj_3_83($this);
                                            break c;
                                        case 83:
                                            oncipj_Cypher_jj_3_84($this);
                                            break c;
                                        case 84:
                                            oncipj_Cypher_jj_3_85($this);
                                            break c;
                                        case 85:
                                            oncipj_Cypher_jj_3_86($this);
                                            break c;
                                        case 86:
                                            oncipj_Cypher_jj_3_87($this);
                                            break c;
                                        case 87:
                                            oncipj_Cypher_jj_3_88($this);
                                            break c;
                                        case 88:
                                            oncipj_Cypher_jj_3_89($this);
                                            break c;
                                        case 89:
                                            oncipj_Cypher_jj_3_90($this);
                                            break c;
                                        case 90:
                                            oncipj_Cypher_jj_3_91($this);
                                            break c;
                                        case 91:
                                            oncipj_Cypher_jj_3_92($this);
                                            break c;
                                        case 92:
                                            oncipj_Cypher_jj_3_93($this);
                                            break c;
                                        case 93:
                                            oncipj_Cypher_jj_3_94($this);
                                            break c;
                                        case 94:
                                            oncipj_Cypher_jj_3_95($this);
                                            break c;
                                        case 95:
                                            oncipj_Cypher_jj_3_96($this);
                                            break c;
                                        case 96:
                                            oncipj_Cypher_jj_3_97($this);
                                            break c;
                                        case 97:
                                            oncipj_Cypher_jj_3_98($this);
                                            break c;
                                        case 98:
                                            oncipj_Cypher_jj_3_99($this);
                                            break c;
                                        case 99:
                                            oncipj_Cypher_jj_3_100($this);
                                            break c;
                                        case 100:
                                            oncipj_Cypher_jj_3_101($this);
                                            break c;
                                        case 101:
                                            oncipj_Cypher_jj_3_102($this);
                                            break c;
                                        case 102:
                                            oncipj_Cypher_jj_3_103($this);
                                            break c;
                                        case 103:
                                            oncipj_Cypher_jj_3_104($this);
                                            break c;
                                        case 104:
                                            oncipj_Cypher_jj_3_105($this);
                                            break c;
                                        case 105:
                                            oncipj_Cypher_jj_3_106($this);
                                            break c;
                                        case 106:
                                            oncipj_Cypher_jj_3_107($this);
                                            break c;
                                        case 107:
                                            oncipj_Cypher_jj_3_108($this);
                                            break c;
                                        case 108:
                                            oncipj_Cypher_jj_3_109($this);
                                            break c;
                                        case 109:
                                            oncipj_Cypher_jj_3_110($this);
                                            break c;
                                        case 110:
                                            oncipj_Cypher_jj_3_111($this);
                                            break c;
                                        case 111:
                                            oncipj_Cypher_jj_3_112($this);
                                            break c;
                                        case 112:
                                            oncipj_Cypher_jj_3_113($this);
                                            break c;
                                        case 113:
                                            oncipj_Cypher_jj_3_114($this);
                                            break c;
                                        case 114:
                                            oncipj_Cypher_jj_3_115($this);
                                            break c;
                                        case 115:
                                            oncipj_Cypher_jj_3_116($this);
                                            break c;
                                        case 116:
                                            oncipj_Cypher_jj_3_117($this);
                                            break c;
                                        case 117:
                                            oncipj_Cypher_jj_3_118($this);
                                            break c;
                                        case 118:
                                            oncipj_Cypher_jj_3_119($this);
                                            break c;
                                        case 119:
                                            oncipj_Cypher_jj_3_120($this);
                                            break c;
                                        case 120:
                                            oncipj_Cypher_jj_3_121($this);
                                            break c;
                                        case 121:
                                            oncipj_Cypher_jj_3_122($this);
                                            break c;
                                        case 122:
                                            oncipj_Cypher_jj_3_123($this);
                                            break c;
                                        case 123:
                                            oncipj_Cypher_jj_3_124($this);
                                            break c;
                                        case 124:
                                            oncipj_Cypher_jj_3_125($this);
                                            break c;
                                        case 125:
                                            oncipj_Cypher_jj_3_126($this);
                                            break c;
                                        case 126:
                                            oncipj_Cypher_jj_3_127($this);
                                            break c;
                                        case 127:
                                            oncipj_Cypher_jj_3_128($this);
                                            break c;
                                        case 128:
                                            oncipj_Cypher_jj_3_129($this);
                                            break c;
                                        case 129:
                                            oncipj_Cypher_jj_3_130($this);
                                            break c;
                                        case 130:
                                            oncipj_Cypher_jj_3_131($this);
                                            break c;
                                        case 131:
                                            oncipj_Cypher_jj_3_132($this);
                                            break c;
                                        case 132:
                                            oncipj_Cypher_jj_3_133($this);
                                            break c;
                                        case 133:
                                            oncipj_Cypher_jj_3_134($this);
                                            break c;
                                        case 134:
                                            oncipj_Cypher_jj_3_135($this);
                                            break c;
                                        case 135:
                                            oncipj_Cypher_jj_3_136($this);
                                            break c;
                                        case 136:
                                            oncipj_Cypher_jj_3_137($this);
                                            break c;
                                        case 137:
                                            oncipj_Cypher_jj_3_138($this);
                                            break c;
                                        case 138:
                                            oncipj_Cypher_jj_3_139($this);
                                            break c;
                                        case 139:
                                            oncipj_Cypher_jj_3_140($this);
                                            break c;
                                        case 140:
                                            oncipj_Cypher_jj_3_141($this);
                                            break c;
                                        case 141:
                                            oncipj_Cypher_jj_3_142($this);
                                            break c;
                                        case 142:
                                            oncipj_Cypher_jj_3_143($this);
                                            break c;
                                        case 143:
                                            oncipj_Cypher_jj_3_144($this);
                                            break c;
                                        case 144:
                                            oncipj_Cypher_jj_3_145($this);
                                            break c;
                                        default:
                                            break c;
                                    }
                                    oncipj_Cypher_jj_3_1($this);
                                }
                            }
                            $p = $p.$next6;
                            if ($p === null)
                                break b;
                        }
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof oncipj_Cypher$LookaheadSuccess) {
                        } else {
                            throw $$e;
                        }
                    }
                    break a;
                }
            }
            $i = $i + 1 | 0;
        }
        $this.$jj_rescan = 0;
    }
    function oncipj_Cypher_jj_save($this, $index, $xla) {
        var $p, var$4, $p_0;
        $p = $this.$jj_2_rtns.data[$index];
        a: {
            while (true) {
                $index = $p.$gen;
                var$4 = $this.$jj_gen;
                if ($index <= var$4)
                    break;
                $p_0 = $p.$next6;
                if ($p_0 === null) {
                    $p_0 = new oncipj_Cypher$JJCalls;
                    $p.$next6 = $p_0;
                    break a;
                }
                $p = $p_0;
            }
            $p_0 = $p;
        }
        $p_0.$gen = (var$4 + $xla | 0) - $this.$jj_la | 0;
        $p_0.$first2 = $this.$token;
        $p_0.$arg = $xla;
    }
    function oncipj_Cypher__clinit_() {
        oncipj_Cypher_jj_la1_init_0();
        oncipj_Cypher_jj_la1_init_1();
        oncipj_Cypher_jj_la1_init_2();
        oncipj_Cypher_jj_la1_init_3();
        oncipj_Cypher_jj_la1_init_4();
        oncipj_Cypher_jj_la1_init_5();
        oncipj_Cypher_jj_la1_init_6();
        oncipj_Cypher_jj_la1_init_7();
        oncipj_Cypher_jj_la1_init_8();
        oncipj_Cypher_jj_la1_init_9();
        oncipj_Cypher_jj_la1_init_10();
    }
    var onciu_InputPosition$ = $rt_classWithoutFields();
    var onciu_InputPosition$_MODULE$ = null;
    var onciu_InputPosition$_byOffset = null;
    var onciu_InputPosition$_NONE0 = null;
    function onciu_InputPosition$_$callClinit() {
        onciu_InputPosition$_$callClinit = $rt_eraseClinit(onciu_InputPosition$);
        onciu_InputPosition$__clinit_();
    }
    function onciu_InputPosition$__clinit_() {
        var var$1, var$2, var$3;
        var$1 = new onciu_InputPosition$;
        onciu_InputPosition$_$callClinit();
        onciu_InputPosition$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$2 = new onciu_InputPosition$$_clinit_$lambda$_0_0;
        sm_Ordering$Int$_$callClinit();
        var$1 = sm_Ordering$Int$_MODULE$;
        var$3 = new sm_Ordering$$anon$5;
        var$3.$ord$2 = var$1;
        var$3.$f$30 = var$2;
        onciu_InputPosition$_byOffset = var$3;
        onciu_InputPosition$_NONE0 = onciu_InputPosition__init_(0, 0, 0);
    }
    function onciu_InputPosition$_byOffset0($this) {
        onciu_InputPosition$_$callClinit();
        return onciu_InputPosition$_byOffset;
    }
    function onciu_InputPosition$_NONE($this) {
        onciu_InputPosition$_$callClinit();
        return onciu_InputPosition$_NONE0;
    }
    var oncias_SemanticFeature$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$_MODULE$ = null;
    var oncias_SemanticFeature$_allSemanticFeatures = null;
    function oncias_SemanticFeature$_$callClinit() {
        oncias_SemanticFeature$_$callClinit = $rt_eraseClinit(oncias_SemanticFeature$);
        oncias_SemanticFeature$__clinit_();
    }
    function oncias_SemanticFeature$__clinit_() {
        var var$1;
        var$1 = new oncias_SemanticFeature$;
        oncias_SemanticFeature$_$callClinit();
        oncias_SemanticFeature$_MODULE$ = var$1;
        s_Predef$_$callClinit();
        oncias_SemanticFeature$_allSemanticFeatures = (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncias_SemanticFeature, [oncias_SemanticFeature$MultipleDatabases$_MODULE$, oncias_SemanticFeature$MultipleGraphs$_MODULE$, oncias_SemanticFeature$UseAsMultipleGraphsSelector$_MODULE$, oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$, oncias_SemanticFeature$ShowSetting$_MODULE$, oncias_SemanticFeature$GpmShortestPath$_MODULE$, oncias_SemanticFeature$MatchModes$_MODULE$,
        oncias_SemanticFeature$PropertyValueAccessRules$_MODULE$])));
    }
    var oncias_ScopeTreeVerifier$ = $rt_classWithoutFields();
    var oncias_ScopeTreeVerifier$_MODULE$ = null;
    function oncias_ScopeTreeVerifier$__clinit_() {
        oncias_ScopeTreeVerifier$_MODULE$ = new oncias_ScopeTreeVerifier$;
    }
    function onciu_inSequence$InSequenceRewriter() {
        jl_Object.call(this);
        this.$rewriters = null;
    }
    function onciu_inSequence$InSequenceRewriter_apply($this, $result) {
        var $it;
        $it = $this.$rewriters.$iterator0();
        while ($it.$hasNext()) {
            $result = ($it.$next()).$apply($result);
        }
        return $result;
    }
    var oncirr_ReturnItemsAreAliased$ = $rt_classWithoutFields();
    var oncirr_ReturnItemsAreAliased$_MODULE$ = null;
    function oncirr_ReturnItemsAreAliased$__clinit_() {
        oncirr_ReturnItemsAreAliased$_MODULE$ = new oncirr_ReturnItemsAreAliased$;
    }
    function oncirr_ReturnItemsAreAliased$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_ReturnItemsAreAliased$_productArity($this) {
        return 0;
    }
    function oncirr_ReturnItemsAreAliased$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_ReturnItemsAreAliased$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_ReturnItemsAreAliased$_hashCode($this) {
        return (-1126646165);
    }
    function oncirr_ReturnItemsAreAliased$_toString($this) {
        return $rt_s(950);
    }
    var oncirr_ExpressionsInOrderByAndWhereUseAliases$ = $rt_classWithoutFields();
    var oncirr_ExpressionsInOrderByAndWhereUseAliases$_MODULE$ = null;
    function oncirr_ExpressionsInOrderByAndWhereUseAliases$__clinit_() {
        oncirr_ExpressionsInOrderByAndWhereUseAliases$_MODULE$ = new oncirr_ExpressionsInOrderByAndWhereUseAliases$;
    }
    function oncirr_ExpressionsInOrderByAndWhereUseAliases$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_ExpressionsInOrderByAndWhereUseAliases$_productArity($this) {
        return 0;
    }
    function oncirr_ExpressionsInOrderByAndWhereUseAliases$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_ExpressionsInOrderByAndWhereUseAliases$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_ExpressionsInOrderByAndWhereUseAliases$_hashCode($this) {
        return (-1748277588);
    }
    function oncirr_ExpressionsInOrderByAndWhereUseAliases$_toString($this) {
        return $rt_s(951);
    }
    var oncirr_WithBetweenOptionalMatchAndMatchInserted$ = $rt_classWithoutFields();
    var oncirr_WithBetweenOptionalMatchAndMatchInserted$_MODULE$ = null;
    function oncirr_WithBetweenOptionalMatchAndMatchInserted$__clinit_() {
        oncirr_WithBetweenOptionalMatchAndMatchInserted$_MODULE$ = new oncirr_WithBetweenOptionalMatchAndMatchInserted$;
    }
    function oncirr_WithBetweenOptionalMatchAndMatchInserted$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_WithBetweenOptionalMatchAndMatchInserted$_productArity($this) {
        return 0;
    }
    function oncirr_WithBetweenOptionalMatchAndMatchInserted$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_WithBetweenOptionalMatchAndMatchInserted$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_WithBetweenOptionalMatchAndMatchInserted$_hashCode($this) {
        return 254160041;
    }
    function oncirr_WithBetweenOptionalMatchAndMatchInserted$_toString($this) {
        return $rt_s(952);
    }
    var oncirr_WithBetweenCallAndWhereInserted$ = $rt_classWithoutFields();
    var oncirr_WithBetweenCallAndWhereInserted$_MODULE$ = null;
    function oncirr_WithBetweenCallAndWhereInserted$__clinit_() {
        oncirr_WithBetweenCallAndWhereInserted$_MODULE$ = new oncirr_WithBetweenCallAndWhereInserted$;
    }
    function oncirr_WithBetweenCallAndWhereInserted$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_WithBetweenCallAndWhereInserted$_productArity($this) {
        return 0;
    }
    function oncirr_WithBetweenCallAndWhereInserted$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_WithBetweenCallAndWhereInserted$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_WithBetweenCallAndWhereInserted$_hashCode($this) {
        return 892628072;
    }
    function oncirr_WithBetweenCallAndWhereInserted$_toString($this) {
        return $rt_s(953);
    }
    var oncirr_WithBetweenShowAndWhereInserted$ = $rt_classWithoutFields();
    var oncirr_WithBetweenShowAndWhereInserted$_MODULE$ = null;
    function oncirr_WithBetweenShowAndWhereInserted$__clinit_() {
        oncirr_WithBetweenShowAndWhereInserted$_MODULE$ = new oncirr_WithBetweenShowAndWhereInserted$;
    }
    function oncirr_WithBetweenShowAndWhereInserted$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_WithBetweenShowAndWhereInserted$_productArity($this) {
        return 0;
    }
    function oncirr_WithBetweenShowAndWhereInserted$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_WithBetweenShowAndWhereInserted$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_WithBetweenShowAndWhereInserted$_hashCode($this) {
        return 335326983;
    }
    function oncirr_WithBetweenShowAndWhereInserted$_toString($this) {
        return $rt_s(954);
    }
    var oncirr_ShowRewrittenToShowYieldWhereReturn$ = $rt_classWithoutFields();
    var oncirr_ShowRewrittenToShowYieldWhereReturn$_MODULE$ = null;
    function oncirr_ShowRewrittenToShowYieldWhereReturn$__clinit_() {
        oncirr_ShowRewrittenToShowYieldWhereReturn$_MODULE$ = new oncirr_ShowRewrittenToShowYieldWhereReturn$;
    }
    function oncirr_ShowRewrittenToShowYieldWhereReturn$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_ShowRewrittenToShowYieldWhereReturn$_productArity($this) {
        return 0;
    }
    function oncirr_ShowRewrittenToShowYieldWhereReturn$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_ShowRewrittenToShowYieldWhereReturn$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_ShowRewrittenToShowYieldWhereReturn$_hashCode($this) {
        return 149999913;
    }
    function oncirr_ShowRewrittenToShowYieldWhereReturn$_toString($this) {
        return $rt_s(955);
    }
    var oncirr_MultipleInPredicatesAreMerged$ = $rt_classWithoutFields();
    var oncirr_MultipleInPredicatesAreMerged$_MODULE$ = null;
    function oncirr_MultipleInPredicatesAreMerged$__clinit_() {
        oncirr_MultipleInPredicatesAreMerged$_MODULE$ = new oncirr_MultipleInPredicatesAreMerged$;
    }
    function oncirr_MultipleInPredicatesAreMerged$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_MultipleInPredicatesAreMerged$_productArity($this) {
        return 0;
    }
    function oncirr_MultipleInPredicatesAreMerged$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_MultipleInPredicatesAreMerged$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_MultipleInPredicatesAreMerged$_hashCode($this) {
        return 294418095;
    }
    function oncirr_MultipleInPredicatesAreMerged$_toString($this) {
        return $rt_s(956);
    }
    var oncirr_TimestampRewritten$ = $rt_classWithoutFields();
    var oncirr_TimestampRewritten$_MODULE$ = null;
    function oncirr_TimestampRewritten$__clinit_() {
        oncirr_TimestampRewritten$_MODULE$ = new oncirr_TimestampRewritten$;
    }
    function oncirr_TimestampRewritten$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_TimestampRewritten$_productArity($this) {
        return 0;
    }
    function oncirr_TimestampRewritten$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_TimestampRewritten$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_TimestampRewritten$_hashCode($this) {
        return (-1487483090);
    }
    function oncirr_TimestampRewritten$_toString($this) {
        return $rt_s(957);
    }
    var oncirr_NoShortestPathWithFixedLength$ = $rt_classWithoutFields();
    var oncirr_NoShortestPathWithFixedLength$_MODULE$ = null;
    function oncirr_NoShortestPathWithFixedLength$__clinit_() {
        oncirr_NoShortestPathWithFixedLength$_MODULE$ = new oncirr_NoShortestPathWithFixedLength$;
    }
    function oncirr_NoShortestPathWithFixedLength$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirr_NoShortestPathWithFixedLength$_productArity($this) {
        return 0;
    }
    function oncirr_NoShortestPathWithFixedLength$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_NoShortestPathWithFixedLength$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_NoShortestPathWithFixedLength$_hashCode($this) {
        return 389986660;
    }
    function oncirr_NoShortestPathWithFixedLength$_toString($this) {
        return $rt_s(958);
    }
    function sci_VectorBuilder() {
        var a = this; jl_Object.call(a);
        a.$a60 = null;
        a.$a50 = null;
        a.$a40 = null;
        a.$a30 = null;
        a.$a20 = null;
        a.$a10 = null;
        a.$scala$collection$immutable$VectorBuilder$$len1 = 0;
        a.$scala$collection$immutable$VectorBuilder$$lenRest = 0;
        a.$scala$collection$immutable$VectorBuilder$$offset = 0;
        a.$prefixIsRightAligned = 0;
        a.$depth = 0;
    }
    function sci_VectorBuilder__init_() {
        var var_0 = new sci_VectorBuilder();
        sci_VectorBuilder__init_0(var_0);
        return var_0;
    }
    function sci_VectorBuilder_sizeHint($this, $size) {}
    function sci_VectorBuilder_sizeHint0($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    }
    function sci_VectorBuilder_initFrom($this, $prefix1) {
        var var$2, $setLen_i, $copyOrUse_start;
        var$2 = $prefix1.data;
        $this.$depth = 1;
        $setLen_i = var$2.length;
        $copyOrUse_start = $setLen_i & 31;
        $this.$scala$collection$immutable$VectorBuilder$$len1 = $copyOrUse_start;
        $this.$scala$collection$immutable$VectorBuilder$$lenRest = $setLen_i - $copyOrUse_start | 0;
        if (32 != $setLen_i)
            $prefix1 = ju_Arrays_copyOfRange($prefix1, 0, 32);
        $this.$a10 = $prefix1;
        if (!$this.$scala$collection$immutable$VectorBuilder$$len1) {
            $copyOrUse_start = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
            if ($copyOrUse_start > 0) {
                $this.$scala$collection$immutable$VectorBuilder$$len1 = 32;
                $this.$scala$collection$immutable$VectorBuilder$$lenRest = $copyOrUse_start - 32 | 0;
                return;
            }
        }
    }
    function sci_VectorBuilder_initFrom0($this, $v) {
        var $copyOrUse_end, $v1, $setLen_i, $copyOrUse_a, $v2, $d2, $s2, $d3, $copyOrUse_start, $v3, $s3, $d5, $d4, $v4, $s2_0, $copyOrUse_a_0, $s4, $v5, $d6, $v6, $s5, var$23;
        a: {
            $copyOrUse_end = $v.$vectorSliceCount();
            switch ($copyOrUse_end) {
                case 0:
                    break a;
                case 1:
                    $v1 = $v;
                    $this.$depth = 1;
                    $setLen_i = (sci_Vector_prefix1($v1)).data.length;
                    $copyOrUse_end = $setLen_i & 31;
                    $this.$scala$collection$immutable$VectorBuilder$$len1 = $copyOrUse_end;
                    $this.$scala$collection$immutable$VectorBuilder$$lenRest = $setLen_i - $copyOrUse_end | 0;
                    $copyOrUse_a = sci_Vector_prefix1($v1);
                    if (32 != $copyOrUse_a.data.length)
                        $copyOrUse_a = ju_Arrays_copyOfRange($copyOrUse_a, 0, 32);
                    $this.$a10 = $copyOrUse_a;
                    break a;
                case 3:
                    $v2 = $v;
                    $d2 = sci_Vector2_data2($v2);
                    $copyOrUse_a = sci_BigVector_suffix1($v2);
                    if (32 != $copyOrUse_a.data.length)
                        $copyOrUse_a = ju_Arrays_copyOfRange($copyOrUse_a, 0, 32);
                    $s2 = $d2.data;
                    $this.$a10 = $copyOrUse_a;
                    $this.$depth = 2;
                    $this.$scala$collection$immutable$VectorBuilder$$offset = 32 - sci_Vector2_len1($v2) | 0;
                    $setLen_i = sci_BigVector_length0($v2) + $this.$scala$collection$immutable$VectorBuilder$$offset | 0;
                    $copyOrUse_end = $setLen_i & 31;
                    $this.$scala$collection$immutable$VectorBuilder$$len1 = $copyOrUse_end;
                    $this.$scala$collection$immutable$VectorBuilder$$lenRest = $setLen_i - $copyOrUse_end | 0;
                    $copyOrUse_a = $rt_createArray($rt_arraycls(jl_Object), 32);
                    $d3 = $copyOrUse_a.data;
                    $this.$a20 = $copyOrUse_a;
                    $d3[0] = sci_Vector_prefix1($v2);
                    $copyOrUse_a = $this.$a20;
                    $copyOrUse_start = $s2.length;
                    jl_System_arraycopy($d2, 0, $copyOrUse_a, 1, $copyOrUse_start);
                    $this.$a20.data[$copyOrUse_start + 1 | 0] = $this.$a10;
                    break a;
                case 5:
                    $v3 = $v;
                    $d3 = sci_Vector3_data3($v3);
                    $s2 = sci_Vector3_suffix2($v3);
                    $copyOrUse_a = sci_BigVector_suffix1($v3);
                    if (32 != $copyOrUse_a.data.length)
                        $copyOrUse_a = ju_Arrays_copyOfRange($copyOrUse_a, 0, 32);
                    $s3 = $d3.data;
                    $d5 = $s2.data;
                    $this.$a10 = $copyOrUse_a;
                    $this.$depth = 3;
                    $this.$scala$collection$immutable$VectorBuilder$$offset = 1024 - sci_Vector3_len12($v3) | 0;
                    $setLen_i = sci_BigVector_length0($v3) + $this.$scala$collection$immutable$VectorBuilder$$offset | 0;
                    $copyOrUse_end = $setLen_i & 31;
                    $this.$scala$collection$immutable$VectorBuilder$$len1 = $copyOrUse_end;
                    $this.$scala$collection$immutable$VectorBuilder$$lenRest = $setLen_i - $copyOrUse_end | 0;
                    $copyOrUse_a = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 32);
                    $d4 = $copyOrUse_a.data;
                    $this.$a30 = $copyOrUse_a;
                    $d4[0] = sci_VectorStatics$_copyPrepend(sci_VectorStatics$_MODULE$, sci_Vector_prefix1($v3), sci_Vector3_prefix2($v3));
                    $copyOrUse_a = $this.$a30;
                    $copyOrUse_start = $s3.length;
                    jl_System_arraycopy($d3, 0, $copyOrUse_a, 1, $copyOrUse_start);
                    $copyOrUse_a = ju_Arrays_copyOf($s2, 32);
                    $d3 = $copyOrUse_a.data;
                    $this.$a20 = $copyOrUse_a;
                    $this.$a30.data[$copyOrUse_start + 1 | 0] = $copyOrUse_a;
                    $d3[$d5.length] = $this.$a10;
                    break a;
                case 7:
                    $v4 = $v;
                    $d4 = sci_Vector4_data4($v4);
                    $s3 = sci_Vector4_suffix3($v4);
                    $s2_0 = sci_Vector4_suffix2($v4);
                    $copyOrUse_a_0 = sci_BigVector_suffix1($v4);
                    if (32 != $copyOrUse_a_0.data.length)
                        $copyOrUse_a_0 = ju_Arrays_copyOfRange($copyOrUse_a_0, 0, 32);
                    $s2 = $d4.data;
                    $d5 = $s3.data;
                    $s4 = $s2_0.data;
                    $this.$a10 = $copyOrUse_a_0;
                    $this.$depth = 4;
                    $this.$scala$collection$immutable$VectorBuilder$$offset = 32768 - sci_Vector4_len123($v4) | 0;
                    $setLen_i = sci_BigVector_length0($v4) + $this.$scala$collection$immutable$VectorBuilder$$offset | 0;
                    $copyOrUse_end = $setLen_i & 31;
                    $this.$scala$collection$immutable$VectorBuilder$$len1 = $copyOrUse_end;
                    $this.$scala$collection$immutable$VectorBuilder$$lenRest = $setLen_i - $copyOrUse_end | 0;
                    $copyOrUse_a = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))), 32);
                    $d3 = $copyOrUse_a.data;
                    $this.$a40 = $copyOrUse_a;
                    $v = sci_VectorStatics$_MODULE$;
                    $d3[0] = sci_VectorStatics$_copyPrepend($v, sci_VectorStatics$_copyPrepend($v, sci_Vector_prefix1($v4), sci_Vector4_prefix2($v4)), sci_Vector4_prefix3($v4));
                    $copyOrUse_a = $this.$a40;
                    $copyOrUse_start = $s2.length;
                    jl_System_arraycopy($d4, 0, $copyOrUse_a, 1, $copyOrUse_start);
                    $this.$a30 = ju_Arrays_copyOf($s3, 32);
                    $copyOrUse_a = ju_Arrays_copyOf($s2_0, 32);
                    $d3 = $copyOrUse_a.data;
                    $this.$a20 = $copyOrUse_a;
                    $d2 = $this.$a40.data;
                    $copyOrUse_end = $copyOrUse_start + 1 | 0;
                    $s2 = $this.$a30;
                    $d4 = $s2.data;
                    $d2[$copyOrUse_end] = $s2;
                    $d4[$d5.length] = $copyOrUse_a;
                    $d3[$s4.length] = $this.$a10;
                    break a;
                case 9:
                    $v5 = $v;
                    $d5 = sci_Vector5_data5($v5);
                    $s4 = sci_Vector5_suffix4($v5);
                    $s3 = sci_Vector5_suffix3($v5);
                    $s2 = sci_Vector5_suffix2($v5);
                    $copyOrUse_a = sci_BigVector_suffix1($v5);
                    if (32 != $copyOrUse_a.data.length)
                        $copyOrUse_a = ju_Arrays_copyOfRange($copyOrUse_a, 0, 32);
                    $d4 = $d5.data;
                    $s2_0 = $s4.data;
                    $copyOrUse_a_0 = $s3.data;
                    $d6 = $s2.data;
                    $this.$a10 = $copyOrUse_a;
                    $this.$depth = 5;
                    $this.$scala$collection$immutable$VectorBuilder$$offset = 1048576 - sci_Vector5_len1234($v5) | 0;
                    $setLen_i = sci_BigVector_length0($v5) + $this.$scala$collection$immutable$VectorBuilder$$offset | 0;
                    $copyOrUse_end = $setLen_i & 31;
                    $this.$scala$collection$immutable$VectorBuilder$$len1 = $copyOrUse_end;
                    $this.$scala$collection$immutable$VectorBuilder$$lenRest = $setLen_i - $copyOrUse_end | 0;
                    $copyOrUse_a = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object)))), 32);
                    $d3 = $copyOrUse_a.data;
                    $this.$a50 = $copyOrUse_a;
                    $v = sci_VectorStatics$_MODULE$;
                    $d3[0] = sci_VectorStatics$_copyPrepend($v, sci_VectorStatics$_copyPrepend($v, sci_VectorStatics$_copyPrepend($v, sci_Vector_prefix1($v5), sci_Vector5_prefix2($v5)), sci_Vector5_prefix3($v5)), sci_Vector5_prefix4($v5));
                    $copyOrUse_a = $this.$a50;
                    $copyOrUse_start = $d4.length;
                    jl_System_arraycopy($d5, 0, $copyOrUse_a, 1, $copyOrUse_start);
                    $this.$a40 = ju_Arrays_copyOf($s4, 32);
                    $this.$a30 = ju_Arrays_copyOf($s3, 32);
                    $copyOrUse_a = ju_Arrays_copyOf($s2, 32);
                    $d4 = $copyOrUse_a.data;
                    $this.$a20 = $copyOrUse_a;
                    $d3 = $this.$a50.data;
                    $copyOrUse_end = $copyOrUse_start + 1 | 0;
                    $d2 = $this.$a40;
                    $s2 = $d2.data;
                    $d3[$copyOrUse_end] = $d2;
                    $copyOrUse_end = $s2_0.length;
                    $d2 = $this.$a30;
                    $d3 = $d2.data;
                    $s2[$copyOrUse_end] = $d2;
                    $d3[$copyOrUse_a_0.length] = $copyOrUse_a;
                    $d4[$d6.length] = $this.$a10;
                    break a;
                case 11:
                    $v6 = $v;
                    $d6 = sci_Vector6_data6($v6);
                    $s5 = sci_Vector6_suffix5($v6);
                    $s4 = sci_Vector6_suffix4($v6);
                    $s3 = sci_Vector6_suffix3($v6);
                    $s2 = sci_Vector6_suffix2($v6);
                    $copyOrUse_a = sci_BigVector_suffix1($v6);
                    if (32 != $copyOrUse_a.data.length)
                        $copyOrUse_a = ju_Arrays_copyOfRange($copyOrUse_a, 0, 32);
                    $d4 = $d6.data;
                    $d5 = $s5.data;
                    $s2_0 = $s4.data;
                    $copyOrUse_a_0 = $s3.data;
                    var$23 = $s2.data;
                    $this.$a10 = $copyOrUse_a;
                    $this.$depth = 6;
                    $this.$scala$collection$immutable$VectorBuilder$$offset = 33554432 - sci_Vector6_len12345($v6) | 0;
                    $setLen_i = sci_BigVector_length0($v6) + $this.$scala$collection$immutable$VectorBuilder$$offset | 0;
                    $copyOrUse_end = $setLen_i & 31;
                    $this.$scala$collection$immutable$VectorBuilder$$len1 = $copyOrUse_end;
                    $this.$scala$collection$immutable$VectorBuilder$$lenRest = $setLen_i - $copyOrUse_end | 0;
                    $copyOrUse_a = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))))), 64);
                    $d3 = $copyOrUse_a.data;
                    $this.$a60 = $copyOrUse_a;
                    $v = sci_VectorStatics$_MODULE$;
                    $d3[0] = sci_VectorStatics$_copyPrepend($v, sci_VectorStatics$_copyPrepend($v, sci_VectorStatics$_copyPrepend($v, sci_VectorStatics$_copyPrepend($v, sci_Vector_prefix1($v6), sci_Vector6_prefix2($v6)), sci_Vector6_prefix3($v6)), sci_Vector6_prefix4($v6)), sci_Vector6_prefix5($v6));
                    $copyOrUse_a = $this.$a60;
                    $copyOrUse_start = $d4.length;
                    jl_System_arraycopy($d6, 0, $copyOrUse_a, 1, $copyOrUse_start);
                    $this.$a50 = ju_Arrays_copyOf($s5, 32);
                    $this.$a40 = ju_Arrays_copyOf($s4, 32);
                    $this.$a30 = ju_Arrays_copyOf($s3, 32);
                    $copyOrUse_a = ju_Arrays_copyOf($s2, 32);
                    $d4 = $copyOrUse_a.data;
                    $this.$a20 = $copyOrUse_a;
                    $d3 = $this.$a60.data;
                    $copyOrUse_end = $copyOrUse_start + 1 | 0;
                    $d2 = $this.$a50;
                    $s2 = $d2.data;
                    $d3[$copyOrUse_end] = $d2;
                    $copyOrUse_end = $d5.length;
                    $d2 = $this.$a40;
                    $d3 = $d2.data;
                    $s2[$copyOrUse_end] = $d2;
                    $copyOrUse_end = $s2_0.length;
                    $d2 = $this.$a30;
                    $s2 = $d2.data;
                    $d3[$copyOrUse_end] = $d2;
                    $s2[$copyOrUse_a_0.length] = $copyOrUse_a;
                    $d4[var$23.length] = $this.$a10;
                    break a;
                default:
            }
            $rt_throw(s_MatchError__init_(jl_Integer_valueOf($copyOrUse_end)));
        }
        if (!$this.$scala$collection$immutable$VectorBuilder$$len1) {
            $copyOrUse_end = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
            if ($copyOrUse_end > 0) {
                $this.$scala$collection$immutable$VectorBuilder$$len1 = 32;
                $this.$scala$collection$immutable$VectorBuilder$$lenRest = $copyOrUse_end - 32 | 0;
            }
        }
        return $this;
    }
    function sci_VectorBuilder_leftAlignPrefix($this) {
        var $a, $aParent, $i, $shrinkOffsetIfToLarge$1_newOffset, $shrinkOffsetIfToLarge$1_width, var$6, $i_0;
        $a = null;
        $aParent = null;
        if ($this.$depth >= 6) {
            $aParent = $this.$a60;
            $i = $this.$scala$collection$immutable$VectorBuilder$$offset >>> 25;
            if ($i > 0)
                jl_System_arraycopy($aParent, $i, $aParent, 0, 64 - $i | 0);
            $i = $this.$scala$collection$immutable$VectorBuilder$$offset;
            $shrinkOffsetIfToLarge$1_newOffset = $i % 33554432 | 0;
            $shrinkOffsetIfToLarge$1_width = $this.$scala$collection$immutable$VectorBuilder$$lenRest - ($i - $shrinkOffsetIfToLarge$1_newOffset | 0) | 0;
            $this.$scala$collection$immutable$VectorBuilder$$lenRest = $shrinkOffsetIfToLarge$1_width;
            $this.$scala$collection$immutable$VectorBuilder$$offset = $shrinkOffsetIfToLarge$1_newOffset;
            if (!($shrinkOffsetIfToLarge$1_width >>> 25))
                $this.$depth = 5;
            $a = $aParent.data[0];
        }
        $shrinkOffsetIfToLarge$1_width = $rt_compare($this.$depth, 5);
        if ($shrinkOffsetIfToLarge$1_width < 0)
            var$6 = $aParent;
        else {
            var$6 = $a === null ? $this.$a50 : $a;
            $i = $this.$scala$collection$immutable$VectorBuilder$$offset >>> 20 & 31;
            if ($shrinkOffsetIfToLarge$1_width) {
                if ($i > 0)
                    var$6 = ju_Arrays_copyOfRange(var$6, $i, 32);
                $aParent.data[0] = var$6;
            } else {
                if ($i > 0)
                    jl_System_arraycopy(var$6, $i, var$6, 0, 32 - $i | 0);
                $this.$a50 = var$6;
                $i = $this.$scala$collection$immutable$VectorBuilder$$offset;
                $shrinkOffsetIfToLarge$1_newOffset = $i % 1048576 | 0;
                $shrinkOffsetIfToLarge$1_width = $this.$scala$collection$immutable$VectorBuilder$$lenRest - ($i - $shrinkOffsetIfToLarge$1_newOffset | 0) | 0;
                $this.$scala$collection$immutable$VectorBuilder$$lenRest = $shrinkOffsetIfToLarge$1_width;
                $this.$scala$collection$immutable$VectorBuilder$$offset = $shrinkOffsetIfToLarge$1_newOffset;
                if (!($shrinkOffsetIfToLarge$1_width >>> 20))
                    $this.$depth = 4;
            }
            $a = var$6.data[0];
        }
        $shrinkOffsetIfToLarge$1_width = $rt_compare($this.$depth, 4);
        if ($shrinkOffsetIfToLarge$1_width < 0)
            $aParent = var$6;
        else {
            $aParent = $a === null ? $this.$a40 : $a;
            $i = $this.$scala$collection$immutable$VectorBuilder$$offset >>> 15 & 31;
            if ($shrinkOffsetIfToLarge$1_width) {
                if ($i > 0)
                    $aParent = ju_Arrays_copyOfRange($aParent, $i, 32);
                var$6.data[0] = $aParent;
            } else {
                if ($i > 0)
                    jl_System_arraycopy($aParent, $i, $aParent, 0, 32 - $i | 0);
                $this.$a40 = $aParent;
                $i = $this.$scala$collection$immutable$VectorBuilder$$offset;
                $shrinkOffsetIfToLarge$1_newOffset = $i % 32768 | 0;
                $shrinkOffsetIfToLarge$1_width = $this.$scala$collection$immutable$VectorBuilder$$lenRest - ($i - $shrinkOffsetIfToLarge$1_newOffset | 0) | 0;
                $this.$scala$collection$immutable$VectorBuilder$$lenRest = $shrinkOffsetIfToLarge$1_width;
                $this.$scala$collection$immutable$VectorBuilder$$offset = $shrinkOffsetIfToLarge$1_newOffset;
                if (!($shrinkOffsetIfToLarge$1_width >>> 15))
                    $this.$depth = 3;
            }
            $a = $aParent.data[0];
        }
        $shrinkOffsetIfToLarge$1_width = $rt_compare($this.$depth, 3);
        if ($shrinkOffsetIfToLarge$1_width < 0)
            var$6 = $aParent;
        else {
            var$6 = $a === null ? $this.$a30 : $a;
            $i = $this.$scala$collection$immutable$VectorBuilder$$offset >>> 10 & 31;
            if ($shrinkOffsetIfToLarge$1_width) {
                if ($i > 0)
                    var$6 = ju_Arrays_copyOfRange(var$6, $i, 32);
                $aParent.data[0] = var$6;
            } else {
                if ($i > 0)
                    jl_System_arraycopy(var$6, $i, var$6, 0, 32 - $i | 0);
                $this.$a30 = var$6;
                $i = $this.$scala$collection$immutable$VectorBuilder$$offset;
                $shrinkOffsetIfToLarge$1_newOffset = $i % 1024 | 0;
                $shrinkOffsetIfToLarge$1_width = $this.$scala$collection$immutable$VectorBuilder$$lenRest - ($i - $shrinkOffsetIfToLarge$1_newOffset | 0) | 0;
                $this.$scala$collection$immutable$VectorBuilder$$lenRest = $shrinkOffsetIfToLarge$1_width;
                $this.$scala$collection$immutable$VectorBuilder$$offset = $shrinkOffsetIfToLarge$1_newOffset;
                if (!($shrinkOffsetIfToLarge$1_width >>> 10))
                    $this.$depth = 2;
            }
            $a = var$6.data[0];
        }
        $shrinkOffsetIfToLarge$1_width = $rt_compare($this.$depth, 2);
        if ($shrinkOffsetIfToLarge$1_width < 0)
            $aParent = var$6;
        else {
            $aParent = $a === null ? $this.$a20 : $a;
            $i = $this.$scala$collection$immutable$VectorBuilder$$offset >>> 5 & 31;
            if ($shrinkOffsetIfToLarge$1_width) {
                if ($i > 0)
                    $aParent = ju_Arrays_copyOfRange($aParent, $i, 32);
                var$6.data[0] = $aParent;
            } else {
                if ($i > 0)
                    jl_System_arraycopy($aParent, $i, $aParent, 0, 32 - $i | 0);
                $this.$a20 = $aParent;
                $i = $this.$scala$collection$immutable$VectorBuilder$$offset;
                $shrinkOffsetIfToLarge$1_newOffset = $i % 32 | 0;
                $shrinkOffsetIfToLarge$1_width = $this.$scala$collection$immutable$VectorBuilder$$lenRest - ($i - $shrinkOffsetIfToLarge$1_newOffset | 0) | 0;
                $this.$scala$collection$immutable$VectorBuilder$$lenRest = $shrinkOffsetIfToLarge$1_width;
                $this.$scala$collection$immutable$VectorBuilder$$offset = $shrinkOffsetIfToLarge$1_newOffset;
                if (!($shrinkOffsetIfToLarge$1_width >>> 5))
                    $this.$depth = 1;
            }
            $a = $aParent.data[0];
        }
        $shrinkOffsetIfToLarge$1_width = $rt_compare($this.$depth, 1);
        if ($shrinkOffsetIfToLarge$1_width >= 0) {
            if ($a === null)
                $a = $this.$a10;
            $i_0 = $this.$scala$collection$immutable$VectorBuilder$$offset & 31;
            if ($shrinkOffsetIfToLarge$1_width) {
                if ($i_0 > 0)
                    $a = ju_Arrays_copyOfRange($a, $i_0, 32);
                $aParent.data[0] = $a;
            } else {
                if ($i_0 > 0)
                    jl_System_arraycopy($a, $i_0, $a, 0, 32 - $i_0 | 0);
                $this.$a10 = $a;
                $this.$scala$collection$immutable$VectorBuilder$$len1 = $this.$scala$collection$immutable$VectorBuilder$$len1 - $this.$scala$collection$immutable$VectorBuilder$$offset | 0;
                $this.$scala$collection$immutable$VectorBuilder$$offset = 0;
            }
        }
        $this.$prefixIsRightAligned = 0;
    }
    function sci_VectorBuilder_addOne($this, $elem) {
        var var$2, var$3;
        if ($this.$scala$collection$immutable$VectorBuilder$$len1 == 32)
            sci_VectorBuilder_advance($this);
        var$2 = $this.$a10.data;
        var$3 = $this.$scala$collection$immutable$VectorBuilder$$len1;
        var$2[var$3] = $elem;
        $this.$scala$collection$immutable$VectorBuilder$$len1 = var$3 + 1 | 0;
        return $this;
    }
    function sci_VectorBuilder_addArr1($this, $data) {
        var $dl, $copy1, $copy2;
        $dl = $data.data.length;
        if ($dl <= 0)
            return;
        if ($this.$scala$collection$immutable$VectorBuilder$$len1 == 32)
            sci_VectorBuilder_advance($this);
        $copy1 = jl_Math_min(32 - $this.$scala$collection$immutable$VectorBuilder$$len1 | 0, $dl);
        $copy2 = $dl - $copy1 | 0;
        jl_System_arraycopy($data, 0, $this.$a10, $this.$scala$collection$immutable$VectorBuilder$$len1, $copy1);
        $this.$scala$collection$immutable$VectorBuilder$$len1 = $this.$scala$collection$immutable$VectorBuilder$$len1 + $copy1 | 0;
        if ($copy2 <= 0)
            return;
        sci_VectorBuilder_advance($this);
        jl_System_arraycopy($data, $copy1, $this.$a10, 0, $copy2);
        $this.$scala$collection$immutable$VectorBuilder$$len1 = $this.$scala$collection$immutable$VectorBuilder$$len1 + $copy2 | 0;
    }
    function sci_VectorBuilder_addArrN($this, $slice, $dim) {
        var var$3, $copy2, $copy1, $destPos, $foreach$extension_i, var$8;
        var$3 = $slice.data;
        $copy2 = var$3.length;
        if ($copy2 ? 0 : 1)
            return;
        if ($this.$scala$collection$immutable$VectorBuilder$$len1 == 32)
            sci_VectorBuilder_advance($this);
        switch ($dim) {
            case 2:
                $copy1 = jl_Math_min((1024 - $this.$scala$collection$immutable$VectorBuilder$$lenRest | 0) >>> 5 & 31, $copy2);
                $copy2 = $copy2 - $copy1 | 0;
                $destPos = $this.$scala$collection$immutable$VectorBuilder$$lenRest >>> 5 & 31;
                jl_System_arraycopy($slice, 0, $this.$a20, $destPos, $copy1);
                sci_VectorBuilder_advanceN($this, 32 * $copy1 | 0);
                if ($copy2 <= 0)
                    return;
                jl_System_arraycopy($slice, $copy1, $this.$a20, 0, $copy2);
                sci_VectorBuilder_advanceN($this, 32 * $copy2 | 0);
                return;
            case 3:
                $dim = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
                if ($dim % 1024 | 0) {
                    $foreach$extension_i = 0;
                    while ($foreach$extension_i < $copy2) {
                        sci_VectorBuilder_addArrN($this, var$3[$foreach$extension_i], 2);
                        $foreach$extension_i = $foreach$extension_i + 1 | 0;
                    }
                    return;
                }
                $copy1 = jl_Math_min((32768 - $dim | 0) >>> 10 & 31, $copy2);
                $copy2 = $copy2 - $copy1 | 0;
                $destPos = $this.$scala$collection$immutable$VectorBuilder$$lenRest >>> 10 & 31;
                jl_System_arraycopy($slice, 0, $this.$a30, $destPos, $copy1);
                sci_VectorBuilder_advanceN($this, 1024 * $copy1 | 0);
                if ($copy2 <= 0)
                    return;
                jl_System_arraycopy($slice, $copy1, $this.$a30, 0, $copy2);
                sci_VectorBuilder_advanceN($this, 1024 * $copy2 | 0);
                return;
            case 4:
                $dim = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
                if ($dim % 32768 | 0) {
                    $foreach$extension_i = 0;
                    while ($foreach$extension_i < $copy2) {
                        sci_VectorBuilder_addArrN($this, var$3[$foreach$extension_i], 3);
                        $foreach$extension_i = $foreach$extension_i + 1 | 0;
                    }
                    return;
                }
                $copy1 = jl_Math_min((1048576 - $dim | 0) >>> 15 & 31, $copy2);
                $copy2 = $copy2 - $copy1 | 0;
                $destPos = $this.$scala$collection$immutable$VectorBuilder$$lenRest >>> 15 & 31;
                jl_System_arraycopy($slice, 0, $this.$a40, $destPos, $copy1);
                sci_VectorBuilder_advanceN($this, 32768 * $copy1 | 0);
                if ($copy2 <= 0)
                    return;
                jl_System_arraycopy($slice, $copy1, $this.$a40, 0, $copy2);
                sci_VectorBuilder_advanceN($this, 32768 * $copy2 | 0);
                return;
            case 5:
                $dim = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
                if ($dim % 1048576 | 0) {
                    $foreach$extension_i = 0;
                    while ($foreach$extension_i < $copy2) {
                        sci_VectorBuilder_addArrN($this, var$3[$foreach$extension_i], 4);
                        $foreach$extension_i = $foreach$extension_i + 1 | 0;
                    }
                    return;
                }
                $copy1 = jl_Math_min((33554432 - $dim | 0) >>> 20 & 31, $copy2);
                $copy2 = $copy2 - $copy1 | 0;
                $destPos = $this.$scala$collection$immutable$VectorBuilder$$lenRest >>> 20 & 31;
                jl_System_arraycopy($slice, 0, $this.$a50, $destPos, $copy1);
                sci_VectorBuilder_advanceN($this, $rt_imul(1048576, $copy1));
                if ($copy2 <= 0)
                    return;
                jl_System_arraycopy($slice, $copy1, $this.$a50, 0, $copy2);
                sci_VectorBuilder_advanceN($this, $rt_imul(1048576, $copy2));
                return;
            case 6:
                $dim = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
                if ($dim % 33554432 | 0) {
                    $foreach$extension_i = 0;
                    while ($foreach$extension_i < $copy2) {
                        sci_VectorBuilder_addArrN($this, var$3[$foreach$extension_i], 5);
                        $foreach$extension_i = $foreach$extension_i + 1 | 0;
                    }
                    return;
                }
                $destPos = $dim >>> 25;
                if (($destPos + $copy2 | 0) <= 64) {
                    jl_System_arraycopy($slice, 0, $this.$a60, $destPos, $copy2);
                    sci_VectorBuilder_advanceN($this, $rt_imul(33554432, $copy2));
                    return;
                }
                var$8 = new jl_IllegalArgumentException;
                jl_Throwable__init_(var$8, $rt_s(959));
                $rt_throw(var$8);
            default:
        }
        $rt_throw(s_MatchError__init_(jl_Integer_valueOf($dim)));
    }
    function sci_VectorBuilder_addAll($this, $xs) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        if (!($xs instanceof sci_Vector))
            return scm_Growable_addAll$($this, $xs);
        $xs = $xs;
        if (!$this.$scala$collection$immutable$VectorBuilder$$len1 && !$this.$scala$collection$immutable$VectorBuilder$$lenRest && !$this.$prefixIsRightAligned)
            return sci_VectorBuilder_initFrom0($this, $xs);
        var$2 = $xs.$vectorSliceCount();
        var$3 = 0;
        while (var$3 < var$2) {
            a: {
                var$4 = $xs.$vectorSlice(var$3);
                var$5 = var$2 / 2 | 0;
                var$6 = (var$5 + 1 | 0) - jl_Math_abs(var$3 - var$5 | 0) | 0;
                switch (var$6) {
                    case 1:
                        break;
                    default:
                        var$7 = $this.$scala$collection$immutable$VectorBuilder$$len1;
                        if (var$7 != 32 && var$7) {
                            b: {
                                var$4 = var$4.data;
                                var$8 = sci_VectorStatics$_MODULE$;
                                var$7 = var$6 - 2 | 0;
                                var$9 = new sci_VectorBuilder$addVector$lambda$_22_0;
                                var$9.$_0254 = $this;
                                var$10 = 0;
                                var$5 = var$4.length;
                                if (!var$7)
                                    while (true) {
                                        if (var$10 >= var$5)
                                            break b;
                                        sci_VectorBuilder_addArr1($this, var$4[var$10]);
                                        var$10 = var$10 + 1 | 0;
                                    }
                                var$6 = var$7 - 1 | 0;
                                while (true) {
                                    if (var$10 >= var$5)
                                        break b;
                                    sci_VectorStatics$_foreachRec(var$8, var$6, var$4[var$10], var$9);
                                    var$10 = var$10 + 1 | 0;
                                }
                            }
                            break a;
                        }
                        sci_VectorBuilder_addArrN($this, var$4, var$6);
                        break a;
                }
                sci_VectorBuilder_addArr1($this, var$4);
            }
            var$3 = var$3 + 1 | 0;
        }
        return $this;
    }
    function sci_VectorBuilder_advance($this) {
        var $xor, $idx;
        $xor = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
        $idx = $xor + 32 | 0;
        $xor = $idx ^ $xor;
        $this.$scala$collection$immutable$VectorBuilder$$lenRest = $idx;
        $this.$scala$collection$immutable$VectorBuilder$$len1 = 0;
        sci_VectorBuilder_advance1($this, $idx, $xor);
    }
    function sci_VectorBuilder_advanceN($this, $n) {
        var $xor, $idx;
        if ($n <= 0)
            return;
        $xor = $this.$scala$collection$immutable$VectorBuilder$$lenRest;
        $idx = $xor + $n | 0;
        $xor = $idx ^ $xor;
        $this.$scala$collection$immutable$VectorBuilder$$lenRest = $idx;
        $this.$scala$collection$immutable$VectorBuilder$$len1 = 0;
        sci_VectorBuilder_advance1($this, $idx, $xor);
    }
    function sci_VectorBuilder_advance1($this, $idx, $xor) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13;
        if ($xor <= 0) {
            var$3 = new jl_IllegalArgumentException;
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$4, 50);
            jl_AbstractStringBuilder_append1(var$4, $rt_s(960));
            jl_IllegalArgumentException__init_2(var$3, jl_StringBuilder_toString(jl_StringBuilder_append0(jl_StringBuilder_append1(jl_StringBuilder_append(jl_StringBuilder_append1(jl_StringBuilder_append(jl_StringBuilder_append1(jl_StringBuilder_append(jl_StringBuilder_append1(jl_StringBuilder_append(jl_StringBuilder_append1(jl_StringBuilder_append(jl_StringBuilder_append1(jl_StringBuilder_append(jl_StringBuilder_append1(jl_StringBuilder_append0(jl_StringBuilder_append1(jl_StringBuilder_append0(var$4, $idx), $rt_s(16)),
            $xor), $rt_s(961)), $this.$a10), $rt_s(962)), $this.$a20), $rt_s(963)), $this.$a30), $rt_s(964)), $this.$a40), $rt_s(965)), $this.$a50), $rt_s(966)), $this.$a60), $rt_s(967)), $this.$depth)));
            $rt_throw(var$3);
        }
        if ($xor < 1024) {
            if ($this.$depth <= 1) {
                var$5 = $rt_createArray($rt_arraycls(jl_Object), 32);
                var$6 = var$5.data;
                $this.$a20 = var$5;
                var$6[0] = $this.$a10;
                $this.$depth = 2;
            }
            var$5 = $rt_createArray(jl_Object, 32);
            $this.$a10 = var$5;
            $this.$a20.data[$idx >>> 5 & 31] = var$5;
            return;
        }
        if ($xor < 32768) {
            if ($this.$depth <= 2) {
                var$5 = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 32);
                var$6 = var$5.data;
                $this.$a30 = var$5;
                var$6[0] = $this.$a20;
                $this.$depth = 3;
            }
            var$5 = $rt_createArray(jl_Object, 32);
            $this.$a10 = var$5;
            var$6 = $rt_createArray($rt_arraycls(jl_Object), 32);
            var$7 = var$6.data;
            $this.$a20 = var$6;
            var$7[$idx >>> 5 & 31] = var$5;
            $this.$a30.data[$idx >>> 10 & 31] = var$6;
            return;
        }
        if ($xor < 1048576) {
            if ($this.$depth <= 3) {
                var$5 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))), 32);
                var$6 = var$5.data;
                $this.$a40 = var$5;
                var$6[0] = $this.$a30;
                $this.$depth = 4;
            }
            var$5 = $rt_createArray(jl_Object, 32);
            $this.$a10 = var$5;
            var$6 = $rt_createArray($rt_arraycls(jl_Object), 32);
            var$8 = var$6.data;
            $this.$a20 = var$6;
            var$7 = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 32);
            var$9 = var$7.data;
            $this.$a30 = var$7;
            var$8[$idx >>> 5 & 31] = var$5;
            var$9[$idx >>> 10 & 31] = var$6;
            $this.$a40.data[$idx >>> 15 & 31] = var$7;
            return;
        }
        if ($xor < 33554432) {
            if ($this.$depth <= 4) {
                var$5 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object)))), 32);
                var$6 = var$5.data;
                $this.$a50 = var$5;
                var$6[0] = $this.$a40;
                $this.$depth = 5;
            }
            var$5 = $rt_createArray(jl_Object, 32);
            $this.$a10 = var$5;
            var$6 = $rt_createArray($rt_arraycls(jl_Object), 32);
            var$9 = var$6.data;
            $this.$a20 = var$6;
            var$7 = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 32);
            var$10 = var$7.data;
            $this.$a30 = var$7;
            var$8 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))), 32);
            var$11 = var$8.data;
            $this.$a40 = var$8;
            var$9[$idx >>> 5 & 31] = var$5;
            var$10[$idx >>> 10 & 31] = var$6;
            var$11[$idx >>> 15 & 31] = var$7;
            $this.$a50.data[$idx >>> 20 & 31] = var$8;
            return;
        }
        if ($this.$depth <= 5) {
            var$5 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))))), 64);
            var$6 = var$5.data;
            $this.$a60 = var$5;
            var$6[0] = $this.$a50;
            $this.$depth = 6;
        }
        var$5 = $rt_createArray(jl_Object, 32);
        $this.$a10 = var$5;
        var$6 = $rt_createArray($rt_arraycls(jl_Object), 32);
        var$10 = var$6.data;
        $this.$a20 = var$6;
        var$7 = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 32);
        var$11 = var$7.data;
        $this.$a30 = var$7;
        var$8 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))), 32);
        var$12 = var$8.data;
        $this.$a40 = var$8;
        var$9 = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object)))), 32);
        var$13 = var$9.data;
        $this.$a50 = var$9;
        var$10[$idx >>> 5 & 31] = var$5;
        var$11[$idx >>> 10 & 31] = var$6;
        var$12[$idx >>> 15 & 31] = var$7;
        var$13[$idx >>> 20 & 31] = var$8;
        $this.$a60.data[$idx >>> 25] = var$9;
    }
    function sci_VectorBuilder_result($this) {
        var $len, $realLen, var$3, $copyIfDifferentSize_a, $i1, $i2, $data, $suffix1, $prefix1, $copyTail_a, $copyIfDifferentSize_len, $i3, $prefix2, $suffix2, $prefix5, $len1, $i4, $prefix3, $suffix3, $prefix4, $len12, $i5, $suffix4, $suffix5, $len123, $i6, var$27, var$28, var$29, $len1234;
        if ($this.$prefixIsRightAligned)
            sci_VectorBuilder_leftAlignPrefix($this);
        $len = $this.$scala$collection$immutable$VectorBuilder$$len1 + $this.$scala$collection$immutable$VectorBuilder$$lenRest | 0;
        $realLen = $len - $this.$scala$collection$immutable$VectorBuilder$$offset | 0;
        if (!$realLen) {
            sci_Vector$_$callClinit();
            return sci_Vector$_empty(sci_Vector$_MODULE$);
        }
        if ($len < 0)
            $rt_throw(jl_IndexOutOfBoundsException__init_(jl_StringBuilder_toString(jl_StringBuilder_append0(jl_StringBuilder_append1(jl_StringBuilder__init_(33), $rt_s(968)), $len))));
        if ($len <= 32) {
            var$3 = new sci_Vector1;
            $copyIfDifferentSize_a = $this.$a10;
            if ($copyIfDifferentSize_a.data.length != $realLen)
                $copyIfDifferentSize_a = ju_Arrays_copyOf($copyIfDifferentSize_a, $realLen);
            sci_Vector1__init_0(var$3, $copyIfDifferentSize_a);
            return var$3;
        }
        if ($len <= 1024) {
            $len = $len - 1 | 0;
            $i1 = $len & 31;
            $i2 = $len >>> 5;
            $data = ju_Arrays_copyOfRange($this.$a20, 1, $i2);
            $suffix1 = $this.$a20.data;
            $prefix1 = $suffix1[0];
            $suffix1 = $suffix1[$i2];
            $copyTail_a = $suffix1.data;
            $copyIfDifferentSize_len = $i1 + 1 | 0;
            if ($copyTail_a.length != $copyIfDifferentSize_len)
                $suffix1 = ju_Arrays_copyOf($suffix1, $copyIfDifferentSize_len);
            return sci_Vector2__init_($prefix1, 32 - $this.$scala$collection$immutable$VectorBuilder$$offset | 0, $data, $suffix1, $realLen);
        }
        if ($len <= 32768) {
            $len = $len - 1 | 0;
            $i1 = $len & 31;
            $i2 = $len >>> 5 & 31;
            $i3 = $len >>> 10;
            $data = ju_Arrays_copyOfRange($this.$a30, 1, $i3);
            $copyTail_a = $this.$a30.data[0];
            $prefix2 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
            $suffix1 = $this.$a30.data;
            $prefix1 = $suffix1[0].data[0];
            $suffix2 = ju_Arrays_copyOf($suffix1[$i3], $i2);
            $suffix1 = $this.$a30.data[$i3].data[$i2];
            $copyTail_a = $suffix1.data;
            $copyIfDifferentSize_len = $i1 + 1 | 0;
            if ($copyTail_a.length != $copyIfDifferentSize_len)
                $suffix1 = ju_Arrays_copyOf($suffix1, $copyIfDifferentSize_len);
            $copyTail_a = $prefix1.data;
            $prefix5 = $prefix2.data;
            $len1 = $copyTail_a.length;
            return sci_Vector3__init_($prefix1, $len1, $prefix2, $len1 + ($prefix5.length * 32 | 0) | 0, $data, $suffix2, $suffix1, $realLen);
        }
        if ($len <= 1048576) {
            $len = $len - 1 | 0;
            $i1 = $len & 31;
            $i2 = $len >>> 5 & 31;
            $i3 = $len >>> 10 & 31;
            $i4 = $len >>> 15;
            $data = ju_Arrays_copyOfRange($this.$a40, 1, $i4);
            $copyTail_a = $this.$a40.data[0];
            $prefix3 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
            $copyTail_a = $this.$a40.data[0].data[0];
            $prefix2 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
            $suffix1 = $this.$a40.data;
            $prefix1 = $suffix1[0].data[0].data[0];
            $suffix3 = ju_Arrays_copyOf($suffix1[$i4], $i3);
            $suffix2 = ju_Arrays_copyOf($this.$a40.data[$i4].data[$i3], $i2);
            $suffix1 = $this.$a40.data[$i4].data[$i3].data[$i2];
            $copyTail_a = $suffix1.data;
            $copyIfDifferentSize_len = $i1 + 1 | 0;
            if ($copyTail_a.length != $copyIfDifferentSize_len)
                $suffix1 = ju_Arrays_copyOf($suffix1, $copyIfDifferentSize_len);
            $copyTail_a = $prefix1.data;
            $prefix5 = $prefix2.data;
            $prefix4 = $prefix3.data;
            $len1 = $copyTail_a.length;
            $len12 = $len1 + ($prefix5.length * 32 | 0) | 0;
            return sci_Vector4__init_($prefix1, $len1, $prefix2, $len12, $prefix3, $len12 + ($prefix4.length * 1024 | 0) | 0, $data, $suffix3, $suffix2, $suffix1, $realLen);
        }
        if ($len <= 33554432) {
            $len = $len - 1 | 0;
            $i1 = $len & 31;
            $i2 = $len >>> 5 & 31;
            $i3 = $len >>> 10 & 31;
            $i4 = $len >>> 15 & 31;
            $i5 = $len >>> 20;
            $data = ju_Arrays_copyOfRange($this.$a50, 1, $i5);
            $copyTail_a = $this.$a50.data[0];
            $prefix4 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
            $copyTail_a = $this.$a50.data[0].data[0];
            $prefix3 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
            $copyTail_a = $this.$a50.data[0].data[0].data[0];
            $prefix2 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
            $suffix1 = $this.$a50.data;
            $prefix1 = $suffix1[0].data[0].data[0].data[0];
            $suffix4 = ju_Arrays_copyOf($suffix1[$i5], $i4);
            $suffix3 = ju_Arrays_copyOf($this.$a50.data[$i5].data[$i4], $i3);
            $suffix2 = ju_Arrays_copyOf($this.$a50.data[$i5].data[$i4].data[$i3], $i2);
            $suffix1 = $this.$a50.data[$i5].data[$i4].data[$i3].data[$i2];
            $copyTail_a = $suffix1.data;
            $copyIfDifferentSize_len = $i1 + 1 | 0;
            if ($copyTail_a.length != $copyIfDifferentSize_len)
                $suffix1 = ju_Arrays_copyOf($suffix1, $copyIfDifferentSize_len);
            $copyTail_a = $prefix1.data;
            $prefix5 = $prefix2.data;
            $suffix5 = $prefix3.data;
            $copyIfDifferentSize_a = $prefix4.data;
            $len1 = $copyTail_a.length;
            $len12 = $len1 + ($prefix5.length * 32 | 0) | 0;
            $len123 = $len12 + ($suffix5.length * 1024 | 0) | 0;
            return sci_Vector5__init_($prefix1, $len1, $prefix2, $len12, $prefix3, $len123, $prefix4, $len123 + ($copyIfDifferentSize_a.length * 32768 | 0) | 0, $data, $suffix4, $suffix3, $suffix2, $suffix1, $realLen);
        }
        $len = $len - 1 | 0;
        $i1 = $len & 31;
        $i2 = $len >>> 5 & 31;
        $i3 = $len >>> 10 & 31;
        $i4 = $len >>> 15 & 31;
        $i5 = $len >>> 20 & 31;
        $i6 = $len >>> 25;
        $data = ju_Arrays_copyOfRange($this.$a60, 1, $i6);
        $copyTail_a = $this.$a60.data[0];
        $prefix5 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
        $copyTail_a = $this.$a60.data[0].data[0];
        $prefix4 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
        $copyTail_a = $this.$a60.data[0].data[0].data[0];
        $prefix3 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
        $copyTail_a = $this.$a60.data[0].data[0].data[0].data[0];
        $prefix2 = ju_Arrays_copyOfRange($copyTail_a, 1, $copyTail_a.data.length);
        $suffix1 = $this.$a60.data;
        $prefix1 = $suffix1[0].data[0].data[0].data[0].data[0];
        $suffix5 = ju_Arrays_copyOf($suffix1[$i6], $i5);
        $suffix4 = ju_Arrays_copyOf($this.$a60.data[$i6].data[$i5], $i4);
        $suffix3 = ju_Arrays_copyOf($this.$a60.data[$i6].data[$i5].data[$i4], $i3);
        $suffix2 = ju_Arrays_copyOf($this.$a60.data[$i6].data[$i5].data[$i4].data[$i3], $i2);
        $suffix1 = $this.$a60.data[$i6].data[$i5].data[$i4].data[$i3].data[$i2];
        $copyTail_a = $suffix1.data;
        $copyIfDifferentSize_len = $i1 + 1 | 0;
        if ($copyTail_a.length != $copyIfDifferentSize_len)
            $suffix1 = ju_Arrays_copyOf($suffix1, $copyIfDifferentSize_len);
        $copyTail_a = $prefix1.data;
        $copyIfDifferentSize_a = $prefix2.data;
        var$27 = $prefix3.data;
        var$28 = $prefix4.data;
        var$29 = $prefix5.data;
        $len1 = $copyTail_a.length;
        $len12 = $len1 + ($copyIfDifferentSize_a.length * 32 | 0) | 0;
        $len123 = $len12 + (var$27.length * 1024 | 0) | 0;
        $len1234 = $len123 + (var$28.length * 32768 | 0) | 0;
        return sci_Vector6__init_($prefix1, $len1, $prefix2, $len12, $prefix3, $len123, $prefix4, $len1234, $prefix5, $len1234 + $rt_imul(var$29.length, 1048576) | 0, $data, $suffix5, $suffix4, $suffix3, $suffix2, $suffix1, $realLen);
    }
    function sci_VectorBuilder_toString($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 47);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(969));
        var$1 = jl_StringBuilder_append0(var$1, $this.$scala$collection$immutable$VectorBuilder$$len1);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(970));
        var$1 = jl_StringBuilder_append0(var$1, $this.$scala$collection$immutable$VectorBuilder$$lenRest);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(971));
        var$1 = jl_StringBuilder_append0(var$1, $this.$scala$collection$immutable$VectorBuilder$$offset);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(967));
        var$1 = jl_StringBuilder_append0(var$1, $this.$depth);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(25));
        return jl_AbstractStringBuilder_toString(var$1);
    }
    function sci_VectorBuilder_result0($this) {
        return sci_VectorBuilder_result($this);
    }
    function sci_VectorBuilder_addAll0($this, $xs) {
        return sci_VectorBuilder_addAll($this, $xs);
    }
    function sci_VectorBuilder_addOne0($this, $elem) {
        return sci_VectorBuilder_addOne($this, $elem);
    }
    function sci_VectorBuilder__init_0($this) {
        $this.$a10 = $rt_createArray(jl_Object, 32);
        $this.$scala$collection$immutable$VectorBuilder$$len1 = 0;
        $this.$scala$collection$immutable$VectorBuilder$$lenRest = 0;
        $this.$scala$collection$immutable$VectorBuilder$$offset = 0;
        $this.$prefixIsRightAligned = 0;
        $this.$depth = 1;
    }
    var sci_Vector1 = $rt_classWithoutFields(sci_VectorImpl);
    function sci_Vector1__init_(var_0) {
        var var_1 = new sci_Vector1();
        sci_Vector1__init_0(var_1, var_0);
        return var_1;
    }
    function sci_Vector1_apply($this, $index) {
        var var$2;
        if ($index >= 0) {
            var$2 = $this.$prefix10.data;
            if ($index < var$2.length)
                return var$2[$index];
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector1_updated($this, $index, $elem) {
        var var$3, var$4, $copyUpdate_a1c;
        if ($index >= 0) {
            var$3 = $this.$prefix10;
            if ($index < var$3.data.length) {
                var$4 = new sci_Vector1;
                $copyUpdate_a1c = var$3.$clone();
                $copyUpdate_a1c.data[$index] = $elem;
                sci_VectorImpl__init_(var$4, $copyUpdate_a1c);
                return var$4;
            }
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector1_appended($this, $elem) {
        var var$2, var$3, var$4, $wrap1_a;
        var$2 = $this.$prefix10;
        if (var$2.data.length < 32) {
            var$3 = new sci_Vector1;
            sci_VectorImpl__init_(var$3, sci_VectorStatics$_copyAppend1(sci_VectorStatics$_MODULE$, var$2, $elem));
            return var$3;
        }
        var$3 = new sci_Vector2;
        var$4 = sci_VectorStatics$_empty2;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        sci_Vector2__init_0(var$3, var$2, 32, var$4, $wrap1_a, 33);
        return var$3;
    }
    function sci_Vector1_prepended($this, $elem) {
        var var$2, $len1, var$4, $wrap1_a;
        var$2 = $this.$prefix10;
        $len1 = var$2.data.length;
        if ($len1 < 32) {
            var$4 = new sci_Vector1;
            sci_VectorImpl__init_(var$4, sci_VectorStatics$_copyPrepend1(sci_VectorStatics$_MODULE$, $elem, var$2));
            return var$4;
        }
        var$4 = new sci_Vector2;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        sci_Vector2__init_0(var$4, $wrap1_a, 1, sci_VectorStatics$_empty2, var$2, $len1 + 1 | 0);
        return var$4;
    }
    function sci_Vector1_slice0($this, $lo, $hi) {
        var var$3;
        var$3 = new sci_Vector1;
        sci_VectorImpl__init_(var$3, ju_Arrays_copyOfRange($this.$prefix10, $lo, $hi));
        return var$3;
    }
    function sci_Vector1_init($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$prefix10;
        var$2 = var$1.data.length;
        if (var$2 == 1) {
            sci_Vector0$_$callClinit();
            return sci_Vector0$_MODULE$;
        }
        var$3 = new sci_Vector1;
        sci_VectorImpl__init_(var$3, ju_Arrays_copyOfRange(var$1, 0, var$2 - 1 | 0));
        return var$3;
    }
    function sci_Vector1_vectorSliceCount($this) {
        return 1;
    }
    function sci_Vector1_vectorSlice($this, $idx) {
        return $this.$prefix10;
    }
    function sci_Vector1_appendedAll0($this, $suffix, $k) {
        var $data1b;
        $data1b = sci_VectorStatics$_append1IfSpace(sci_VectorStatics$_MODULE$, $this.$prefix10, $suffix);
        if ($data1b === null)
            return sci_Vector_appendedAll0($this, $suffix, $k);
        $suffix = new sci_Vector1;
        sci_VectorImpl__init_($suffix, $data1b);
        return $suffix;
    }
    function sci_Vector1_init0($this) {
        return sci_Vector1_init($this);
    }
    function sci_Vector1_tail($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$prefix10;
        var$2 = var$1.data.length;
        if (var$2 == 1) {
            sci_Vector0$_$callClinit();
            var$3 = sci_Vector0$_MODULE$;
        } else {
            var$3 = new sci_Vector1;
            sci_VectorImpl__init_(var$3, ju_Arrays_copyOfRange(var$1, 1, var$2));
        }
        return var$3;
    }
    function sci_Vector1_map($this, $f) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        var$2 = new sci_Vector1;
        var$3 = $this.$prefix10;
        var$4 = 0;
        a: {
            while (true) {
                var$5 = var$3.data;
                var$6 = var$5.length;
                if (var$4 >= var$6)
                    break;
                var$7 = var$5[var$4];
                var$8 = $f.$apply(var$7);
                if (var$7 !== var$8) {
                    var$9 = $rt_createArray(jl_Object, var$6);
                    if (var$4 > 0)
                        jl_System_arraycopy(var$3, 0, var$9, 0, var$4);
                    var$3 = var$9.data;
                    var$3[var$4] = var$8;
                    var$10 = var$4 + 1 | 0;
                    while (var$10 < var$6) {
                        var$3[var$10] = $f.$apply(var$5[var$10]);
                        var$10 = var$10 + 1 | 0;
                    }
                    var$3 = var$9;
                    break a;
                }
                var$4 = var$4 + 1 | 0;
            }
        }
        sci_VectorImpl__init_(var$2, var$3);
        return var$2;
    }
    function sci_Vector1_prepended0($this, $elem) {
        return sci_Vector1_prepended($this, $elem);
    }
    function sci_Vector1_appended0($this, $elem) {
        return sci_Vector1_appended($this, $elem);
    }
    function sci_Vector1_updated0($this, $index, $elem) {
        return sci_Vector1_updated($this, $index, $elem);
    }
    function sci_Vector1_apply0($this, $v1) {
        return sci_Vector1_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_Vector1__init_0($this, $_data1) {
        sci_VectorImpl__init_($this, $_data1);
    }
    function oncifp_SemanticTypeCheck$$visit$lambda$_9_0() {
        var a = this; jl_Object.call(a);
        a.$_036 = null;
        a.$_111 = null;
    }
    function oncifp_SemanticTypeCheck$$visit$lambda$_9_0_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_036;
        var$3 = var$0.$_111;
        oncifp_SemanticTypeCheck$_$callClinit();
        return var$1.$apply0(var$2, var$3);
    }
    var s_Function$ = $rt_classWithoutFields();
    var s_Function$_MODULE$ = null;
    function s_Function$__clinit_() {
        s_Function$_MODULE$ = new s_Function$;
    }
    function oncir_Deprecations$semanticallyDeprecatedFeatures$$find$lambda$_4_0() {
        jl_Object.call(this);
        this.$_026 = null;
    }
    var onciu_InternalNotificationLogger = $rt_classWithoutFields(0);
    var onciu_devNullLogger$ = $rt_classWithoutFields();
    var onciu_devNullLogger$_MODULE$ = null;
    function onciu_devNullLogger$__clinit_() {
        onciu_devNullLogger$_MODULE$ = new onciu_devNullLogger$;
    }
    var onciu_CypherExceptionFactory = $rt_classWithoutFields(0);
    function onciu_OpenCypherExceptionFactory() {
        jl_Object.call(this);
        this.$preParserOffset = null;
    }
    function onciu_OpenCypherExceptionFactory_productPrefix($this) {
        return $rt_s(972);
    }
    function onciu_OpenCypherExceptionFactory_productArity($this) {
        return 1;
    }
    function onciu_OpenCypherExceptionFactory_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$preParserOffset;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function onciu_OpenCypherExceptionFactory_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_OpenCypherExceptionFactory_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_OpenCypherExceptionFactory_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_OpenCypherExceptionFactory_equals($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_OpenCypherExceptionFactory) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$preParserOffset;
                        $x$1 = $x$1.$preParserOffset;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_OpenCypherExceptionFactory))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    }
    function onciu_OpenCypherExceptionFactory_syntaxException($this, $message, $pos) {
        var var$3, var$4, var$5;
        var$3 = $this.$preParserOffset;
        if (!(var$3 instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, var$3))
                $rt_throw(s_MatchError__init_(var$3));
            var$4 = $pos;
        } else {
            var$3 = var$3.$value5;
            var$5 = $pos.$line0 != var$3.$line1() ? $pos.$column0 : ($pos.$column0 + var$3.$column1() | 0) - 1 | 0;
            var$4 = onciu_InputPosition__init_($pos.$offset0 + var$3.$offset1() | 0, ($pos.$line0 + var$3.$line1() | 0) - 1 | 0, var$5);
        }
        $pos = new onciu_OpenCypherExceptionFactory$SyntaxException;
        $pos.$message0 = $message;
        $pos.$pos1 = var$4;
        var$4 = null;
        $pos.$message1 = $message;
        jl_Throwable__init_4($pos, $message, var$4);
        return $pos;
    }
    var oncifp_SemanticAnalyzer$$anon$1$errorHandler$lambda$_4_0 = $rt_classWithoutFields();
    function oncifp_SemanticAnalyzer$$anon$1$errorHandler$lambda$_4_0_apply(var$0, var$1) {
        var var$2;
        if (!sc_IterableOnceOps_nonEmpty$(var$1))
            return sr_BoxedUnit_UNIT;
        var$2 = new oncifp_SemanticAnalyzer$SomeErrors;
        var$2.$errs = var$1;
        jl_Throwable__init_0(var$2);
        $rt_throw(var$2);
    }
    function scm_HashSet$subtractAll$lambda$_53_0() {
        jl_Object.call(this);
        this.$_0168 = null;
    }
    function scm_HashSet$subtractAll$lambda$_53_0_apply(var$0, var$1, var$2) {
        return jl_Boolean_valueOf(scm_HashSet_$anonfun$subtractAll$1(var$0.$_0168, var$1, sr_BoxesRunTime_unboxToInt(var$2)));
    }
    var oncifp_AmbiguousAggregationAnalysis$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncifp_AmbiguousAggregationAnalysis$$anonfun$1_applyOrElse($this, $x1, $default) {
        if ($rt_isInstance($x1, oncia_ProjectionClause)) {
            $x1 = $x1;
            if (!($x1.$returnItems0()).$includeExisting) {
                $default = new oncifp_AmbiguousAggregationAnalysis$$anonfun$1$applyOrElse$lambda$_0_0;
                $default.$_0255 = $x1;
                return $default;
            }
        }
        return s_PartialFunction$_fallback_fn;
    }
    var sci_LazyList$State = $rt_classWithoutFields(0);
    var sci_LazyList$State$Empty$ = $rt_classWithoutFields();
    var sci_LazyList$State$Empty$_MODULE$ = null;
    function sci_LazyList$State$Empty$__clinit_() {
        sci_LazyList$State$Empty$_MODULE$ = new sci_LazyList$State$Empty$;
    }
    function sci_LazyList$State$Empty$_tail($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(973));
        $rt_throw(var$1);
    }
    function sci_LazyList$State$Empty$_head($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(974));
        $rt_throw(var$1);
    }
    var scm_HashMap$$anon$1 = $rt_classWithoutFields(scm_HashMap$HashMapIterator);
    function scm_HashMap$$anon$1_extract($this, $nd) {
        return s_Tuple2__init_($nd.$_key, $nd.$_value);
    }
    function sci_MapBuilderImpl() {
        var a = this; jl_Object.call(a);
        a.$elems1 = null;
        a.$switchedToHashMapBuilder = 0;
        a.$hashMapBuilder = null;
    }
    function sci_MapBuilderImpl__init_() {
        var var_0 = new sci_MapBuilderImpl();
        sci_MapBuilderImpl__init_0(var_0);
        return var_0;
    }
    function sci_MapBuilderImpl_sizeHint($this, $size) {}
    function sci_MapBuilderImpl_addAll($this, $xs) {
        if (!$this.$switchedToHashMapBuilder)
            return scm_Growable_addAll$($this, $xs);
        sci_HashMapBuilder_addAll($this.$hashMapBuilder, $xs);
        return $this;
    }
    function sci_MapBuilderImpl_addAll0($this, $xs) {
        return sci_MapBuilderImpl_addAll($this, $xs);
    }
    function sci_MapBuilderImpl_addOne($this, $elem) {
        var var$2, var$3;
        $elem = $elem;
        var$2 = $elem.$_10;
        var$3 = $elem.$_20;
        if ($this.$switchedToHashMapBuilder)
            sci_HashMapBuilder_addOne0($this.$hashMapBuilder, var$2, var$3);
        else if ($this.$elems1.$size() < 4)
            $this.$elems1 = $this.$elems1.$updated1(var$2, var$3);
        else if ($this.$elems1.$contains0(var$2))
            $this.$elems1 = $this.$elems1.$updated1(var$2, var$3);
        else {
            $this.$switchedToHashMapBuilder = 1;
            if ($this.$hashMapBuilder === null)
                $this.$hashMapBuilder = sci_HashMapBuilder__init_();
            $elem = $this.$elems1;
            sci_HashMapBuilder_addOne0(sci_HashMapBuilder_addOne0(sci_HashMapBuilder_addOne0(sci_HashMapBuilder_addOne0($this.$hashMapBuilder, $elem.$scala$collection$immutable$Map$Map4$$key1, $elem.$scala$collection$immutable$Map$Map4$$value1), $elem.$scala$collection$immutable$Map$Map4$$key2, $elem.$scala$collection$immutable$Map$Map4$$value2), $elem.$scala$collection$immutable$Map$Map4$$key3, $elem.$scala$collection$immutable$Map$Map4$$value3), $elem.$scala$collection$immutable$Map$Map4$$key4, $elem.$scala$collection$immutable$Map$Map4$$value4);
            sci_HashMapBuilder_addOne0($this.$hashMapBuilder, var$2, var$3);
        }
        return $this;
    }
    function sci_MapBuilderImpl_result($this) {
        return !$this.$switchedToHashMapBuilder ? $this.$elems1 : sci_HashMapBuilder_result($this.$hashMapBuilder);
    }
    function sci_MapBuilderImpl__init_0($this) {
        $this.$elems1 = sci_Map$EmptyMap$_MODULE$;
        $this.$switchedToHashMapBuilder = 0;
    }
    var oncirc_containsNoReturnAll$ = $rt_classWithoutFields();
    var oncirc_containsNoReturnAll$_MODULE$ = null;
    var oncirc_containsNoReturnAll$_matcher = null;
    function oncirc_containsNoReturnAll$__clinit_() {
        var var$1;
        oncirc_containsNoReturnAll$_MODULE$ = new oncirc_containsNoReturnAll$;
        var$1 = new oncirc_containsNoMatchingNodes;
        var$1.$matcher0 = new oncirc_containsNoReturnAll$$anonfun$1;
        oncirc_containsNoReturnAll$_matcher = var$1;
    }
    function oncirc_containsNoReturnAll$_toString($this) {
        return $this.$name3();
    }
    function oncirc_containsNoReturnAll$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirc_containsNoReturnAll$_name($this) {
        return $rt_s(975);
    }
    function oncirc_containsNoReturnAll$_productArity($this) {
        return 0;
    }
    function oncirc_containsNoReturnAll$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirc_containsNoReturnAll$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirc_containsNoReturnAll$_hashCode($this) {
        return (-835982863);
    }
    function oncirc_containsNoReturnAll$_apply($this, $v1) {
        var var$2, var$3, var$4;
        var$2 = oncirc_containsNoReturnAll$_matcher;
        var$3 = onciu_Foldable_folder$(onciu_Foldable$_FoldableAny(onciu_Foldable$_MODULE$, $v1));
        s_package$_$callClinit();
        var$4 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        $v1 = new oncirc_containsNoMatchingNodes$$anonfun$apply$1;
        if (var$2 === null)
            $rt_throw(null);
        $v1.$$outer24 = var$2;
        return (onciu_Foldable$Folder_fold(var$3, var$4, $v1)).$map1(new oncirc_containsNoMatchingNodes$apply$lambda$_30_0);
    }
    var oncirc_package$LiteralsExtracted$ = $rt_classWithoutFields();
    var oncirc_package$LiteralsExtracted$_MODULE$ = null;
    function oncirc_package$LiteralsExtracted$__clinit_() {
        oncirc_package$LiteralsExtracted$_MODULE$ = new oncirc_package$LiteralsExtracted$;
    }
    function oncirc_package$LiteralsExtracted$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirc_package$LiteralsExtracted$_productArity($this) {
        return 0;
    }
    function oncirc_package$LiteralsExtracted$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirc_package$LiteralsExtracted$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirc_package$LiteralsExtracted$_hashCode($this) {
        return 1638944636;
    }
    function oncirc_package$LiteralsExtracted$_toString($this) {
        return $rt_s(976);
    }
    var oncirc_package$FunctionInvocationsResolved$ = $rt_classWithoutFields();
    var oncirc_package$FunctionInvocationsResolved$_MODULE$ = null;
    function oncirc_package$FunctionInvocationsResolved$__clinit_() {
        oncirc_package$FunctionInvocationsResolved$_MODULE$ = new oncirc_package$FunctionInvocationsResolved$;
    }
    function oncirc_package$FunctionInvocationsResolved$_unary_$bang($this) {
        return onciu_StepSequencer$Condition_unary_$bang$($this);
    }
    function oncirc_package$FunctionInvocationsResolved$_productArity($this) {
        return 0;
    }
    function oncirc_package$FunctionInvocationsResolved$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncirc_package$FunctionInvocationsResolved$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirc_package$FunctionInvocationsResolved$_hashCode($this) {
        return 1223713763;
    }
    function oncirc_package$FunctionInvocationsResolved$_toString($this) {
        return $rt_s(977);
    }
    function sci_HashCollisionSetNode$equals$lambda$_20_0() {
        jl_Object.call(this);
        this.$_0174 = null;
    }
    function sci_HashCollisionSetNode$equals$lambda$_20_0_apply(var$0, var$1) {
        return jl_Boolean_valueOf(sc_AbstractSeq_contains(var$0.$_0174, var$1));
    }
    var oncias_SemanticCheck = $rt_classWithoutFields(0);
    function oncias_SemanticCheck_run$($$this, $state, $context) {
        var var$4, var$5, var$6;
        var$4 = oncias_SemanticCheckInterpreter$_MODULE$;
        var$5 = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, $state);
        var$6 = sci_$colon$colon__init_(oncias_SemanticCheckInterpreter$ExecutableCheck$_apply(oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$, $$this), sci_Nil$_MODULE$);
        s_package$_$callClinit();
        return oncias_SemanticCheckInterpreter$_run(var$4, var$5, var$6, $context, sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$)));
    }
    function oncias_SemanticCheck_apply$($$this, $state) {
        return $$this.$run($state, oncias_SemanticCheckContext$default$_MODULE$);
    }
    function oncias_SemanticCheck_chain$($$this, $next) {
        var var$3;
        var$3 = new oncias_SemanticCheck$chain$lambda$_17_0;
        var$3.$_0256 = $next;
        return $$this.$flatMap3(var$3);
    }
    function oncias_SemanticCheck_ifOkChain$($$this, $next) {
        var var$3;
        var$3 = new oncias_SemanticCheck$ifOkChain$lambda$_19_0;
        var$3.$_0257 = $next;
        return $$this.$flatMap3(var$3);
    }
    function oncias_SemanticCheck_map$($$this, $f) {
        var var$3;
        var$3 = new oncias_SemanticCheck$Map;
        var$3.$check0 = $$this;
        var$3.$f5 = $f;
        return var$3;
    }
    function oncias_SemanticCheck_flatMap$($$this, $f) {
        var var$3;
        var$3 = new oncias_SemanticCheck$FlatMap;
        var$3.$check1 = $$this;
        var$3.$f6 = $f;
        return var$3;
    }
    function ju_Vector() {
        var a = this; ju_AbstractList.call(a);
        a.$elementCount = 0;
        a.$elementData = null;
        a.$capacityIncrement = 0;
    }
    var ju_Vector_$assertionsDisabled = 0;
    function ju_Vector_addElement($this, $object) {
        var var$2, var$3, var$4, var$5, var$6;
        jl_Object_monitorEnterSync($this);
        try {
            var$2 = $this.$elementCount;
            var$3 = $this.$elementData;
            var$4 = var$3.data.length;
            if (var$2 == var$4) {
                var$5 = $this.$capacityIncrement;
                if (var$5 <= 0)
                    var$5 = !var$4 ? 1 : var$4;
                var$6 = $rt_createArray(jl_Object, var$4 + var$5 | 0);
                jl_System_arraycopy(var$3, 0, var$6, 0, var$2);
                $this.$elementData = var$6;
            }
            var$6 = $this.$elementData.data;
            var$4 = $this.$elementCount;
            $this.$elementCount = var$4 + 1 | 0;
            var$6[var$4] = $object;
            $this.$modCount = $this.$modCount + 1 | 0;
        } finally {
            jl_Object_monitorExitSync($this);
        }
    }
    function ju_Vector_isEmpty($this) {
        jl_Object_monitorEnterSync($this);
        try {
            return $this.$elementCount ? 0 : 1;
        } finally {
            jl_Object_monitorExitSync($this);
        }
    }
    function ju_Vector__clinit_() {
        ju_Vector_$assertionsDisabled = 0;
    }
    var ju_Stack = $rt_classWithoutFields(ju_Vector);
    function ju_Stack_peek($this) {
        var var$1, $$je;
        jl_Object_monitorEnterSync($this);
        try {
            a: {
                try {
                    var$1 = $this.$elementData.data[$this.$elementCount - 1 | 0];
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    if ($$je instanceof jl_IndexOutOfBoundsException) {
                        break a;
                    } else {
                        throw $$e;
                    }
                }
                return var$1;
            }
            var$1 = new ju_EmptyStackException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        } finally {
            jl_Object_monitorExitSync($this);
        }
    }
    function ju_Stack_pop($this) {
        var var$1, $obj, var$3, var$4;
        jl_Object_monitorEnterSync($this);
        try {
            var$1 = $this.$elementCount;
            if (!var$1) {
                $obj = new ju_EmptyStackException;
                jl_Throwable__init_0($obj);
                $rt_throw($obj);
            }
            var$3 = var$1 - 1 | 0;
            $this.$elementCount = var$3;
            var$4 = $this.$elementData.data;
            $obj = var$4[var$3];
            var$4[var$3] = null;
            $this.$modCount = $this.$modCount + 1 | 0;
            return $obj;
        } finally {
            jl_Object_monitorExitSync($this);
        }
    }
    function ju_Stack_push($this, $object) {
        ju_Vector_addElement($this, $object);
        return $object;
    }
    function oncipj_Cypher$JJCalls() {
        var a = this; jl_Object.call(a);
        a.$gen = 0;
        a.$first2 = null;
        a.$arg = 0;
        a.$next6 = null;
    }
    var oncipj_Cypher$LookaheadSuccess = $rt_classWithoutFields(jl_IllegalStateException);
    function oncipj_CypherTokenManager() {
        var a = this; jl_Object.call(a);
        a.$curLexState = 0;
        a.$defaultLexState = 0;
        a.$jjnewStateCnt = 0;
        a.$jjround = 0;
        a.$jjmatchedPos = 0;
        a.$jjmatchedKind = 0;
        a.$input_stream = null;
        a.$jjrounds = null;
        a.$jjstateSet = null;
        a.$jjimage = null;
        a.$image = null;
        a.$jjimageLen = 0;
        a.$lengthOfMatch = 0;
        a.$curChar = 0;
    }
    var oncipj_CypherTokenManager_jjbitVec0 = null;
    var oncipj_CypherTokenManager_jjbitVec2 = null;
    var oncipj_CypherTokenManager_jjbitVec3 = null;
    var oncipj_CypherTokenManager_jjbitVec4 = null;
    var oncipj_CypherTokenManager_jjbitVec5 = null;
    var oncipj_CypherTokenManager_jjbitVec6 = null;
    var oncipj_CypherTokenManager_jjbitVec7 = null;
    var oncipj_CypherTokenManager_jjbitVec8 = null;
    var oncipj_CypherTokenManager_jjbitVec9 = null;
    var oncipj_CypherTokenManager_jjbitVec10 = null;
    var oncipj_CypherTokenManager_jjbitVec11 = null;
    var oncipj_CypherTokenManager_jjbitVec12 = null;
    var oncipj_CypherTokenManager_jjbitVec13 = null;
    var oncipj_CypherTokenManager_jjbitVec14 = null;
    var oncipj_CypherTokenManager_jjbitVec15 = null;
    var oncipj_CypherTokenManager_jjbitVec16 = null;
    var oncipj_CypherTokenManager_jjbitVec17 = null;
    var oncipj_CypherTokenManager_jjbitVec18 = null;
    var oncipj_CypherTokenManager_jjbitVec19 = null;
    var oncipj_CypherTokenManager_jjbitVec20 = null;
    var oncipj_CypherTokenManager_jjbitVec21 = null;
    var oncipj_CypherTokenManager_jjbitVec22 = null;
    var oncipj_CypherTokenManager_jjbitVec23 = null;
    var oncipj_CypherTokenManager_jjbitVec24 = null;
    var oncipj_CypherTokenManager_jjbitVec25 = null;
    var oncipj_CypherTokenManager_jjbitVec26 = null;
    var oncipj_CypherTokenManager_jjbitVec27 = null;
    var oncipj_CypherTokenManager_jjbitVec28 = null;
    var oncipj_CypherTokenManager_jjbitVec29 = null;
    var oncipj_CypherTokenManager_jjbitVec30 = null;
    var oncipj_CypherTokenManager_jjbitVec31 = null;
    var oncipj_CypherTokenManager_jjbitVec32 = null;
    var oncipj_CypherTokenManager_jjbitVec33 = null;
    var oncipj_CypherTokenManager_jjbitVec34 = null;
    var oncipj_CypherTokenManager_jjbitVec35 = null;
    var oncipj_CypherTokenManager_jjbitVec36 = null;
    var oncipj_CypherTokenManager_jjbitVec37 = null;
    var oncipj_CypherTokenManager_jjbitVec38 = null;
    var oncipj_CypherTokenManager_jjbitVec39 = null;
    var oncipj_CypherTokenManager_jjbitVec40 = null;
    var oncipj_CypherTokenManager_jjbitVec41 = null;
    var oncipj_CypherTokenManager_jjbitVec42 = null;
    var oncipj_CypherTokenManager_jjbitVec43 = null;
    var oncipj_CypherTokenManager_jjbitVec44 = null;
    var oncipj_CypherTokenManager_jjbitVec45 = null;
    var oncipj_CypherTokenManager_jjbitVec46 = null;
    var oncipj_CypherTokenManager_jjbitVec47 = null;
    var oncipj_CypherTokenManager_jjbitVec48 = null;
    var oncipj_CypherTokenManager_jjbitVec49 = null;
    var oncipj_CypherTokenManager_jjbitVec50 = null;
    var oncipj_CypherTokenManager_jjbitVec51 = null;
    var oncipj_CypherTokenManager_jjbitVec52 = null;
    var oncipj_CypherTokenManager_jjbitVec53 = null;
    var oncipj_CypherTokenManager_jjbitVec54 = null;
    var oncipj_CypherTokenManager_jjbitVec55 = null;
    var oncipj_CypherTokenManager_jjbitVec56 = null;
    var oncipj_CypherTokenManager_jjbitVec57 = null;
    var oncipj_CypherTokenManager_jjbitVec58 = null;
    var oncipj_CypherTokenManager_jjbitVec59 = null;
    var oncipj_CypherTokenManager_jjbitVec60 = null;
    var oncipj_CypherTokenManager_jjbitVec61 = null;
    var oncipj_CypherTokenManager_jjbitVec62 = null;
    var oncipj_CypherTokenManager_jjbitVec63 = null;
    var oncipj_CypherTokenManager_jjbitVec64 = null;
    var oncipj_CypherTokenManager_jjbitVec65 = null;
    var oncipj_CypherTokenManager_jjbitVec66 = null;
    var oncipj_CypherTokenManager_jjbitVec67 = null;
    var oncipj_CypherTokenManager_jjbitVec68 = null;
    var oncipj_CypherTokenManager_jjbitVec69 = null;
    var oncipj_CypherTokenManager_jjbitVec70 = null;
    var oncipj_CypherTokenManager_jjbitVec71 = null;
    var oncipj_CypherTokenManager_jjbitVec72 = null;
    var oncipj_CypherTokenManager_jjbitVec73 = null;
    var oncipj_CypherTokenManager_jjbitVec74 = null;
    var oncipj_CypherTokenManager_jjbitVec75 = null;
    var oncipj_CypherTokenManager_jjbitVec76 = null;
    var oncipj_CypherTokenManager_jjbitVec77 = null;
    var oncipj_CypherTokenManager_jjbitVec78 = null;
    var oncipj_CypherTokenManager_jjbitVec79 = null;
    var oncipj_CypherTokenManager_jjbitVec80 = null;
    var oncipj_CypherTokenManager_jjbitVec81 = null;
    var oncipj_CypherTokenManager_jjbitVec82 = null;
    var oncipj_CypherTokenManager_jjbitVec83 = null;
    var oncipj_CypherTokenManager_jjbitVec84 = null;
    var oncipj_CypherTokenManager_jjbitVec85 = null;
    var oncipj_CypherTokenManager_jjbitVec86 = null;
    var oncipj_CypherTokenManager_jjbitVec87 = null;
    var oncipj_CypherTokenManager_jjbitVec88 = null;
    var oncipj_CypherTokenManager_jjbitVec89 = null;
    var oncipj_CypherTokenManager_jjbitVec90 = null;
    var oncipj_CypherTokenManager_jjbitVec91 = null;
    var oncipj_CypherTokenManager_jjbitVec92 = null;
    var oncipj_CypherTokenManager_jjbitVec93 = null;
    var oncipj_CypherTokenManager_jjbitVec94 = null;
    var oncipj_CypherTokenManager_jjbitVec95 = null;
    var oncipj_CypherTokenManager_jjbitVec96 = null;
    var oncipj_CypherTokenManager_jjbitVec97 = null;
    var oncipj_CypherTokenManager_jjbitVec98 = null;
    var oncipj_CypherTokenManager_jjbitVec99 = null;
    var oncipj_CypherTokenManager_jjbitVec100 = null;
    var oncipj_CypherTokenManager_jjstrLiteralImages = null;
    var oncipj_CypherTokenManager_jjnextStates = null;
    var oncipj_CypherTokenManager_lexStateNames = null;
    var oncipj_CypherTokenManager_jjnewLexState = null;
    var oncipj_CypherTokenManager_jjtoToken = null;
    var oncipj_CypherTokenManager_jjtoSkip = null;
    var oncipj_CypherTokenManager_jjtoSpecial = null;
    var oncipj_CypherTokenManager_jjtoMore = null;
    function oncipj_CypherTokenManager_CommonTokenAction($this, $t) {
        var $ccStream, var$3;
        $ccStream = $this.$input_stream;
        var$3 = $ccStream.$offsets.data;
        $t.$beginOffset = var$3[$ccStream.$beginOffset0];
        $t.$endOffset = var$3[$ccStream.$resultCursor];
    }
    function oncipj_CypherTokenManager_jjStopAtPos($this, $pos, $kind) {
        $this.$jjmatchedKind = $kind;
        $this.$jjmatchedPos = $pos;
        return $pos + 1 | 0;
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_0($this) {
        switch ($this.$curChar) {
            case 9:
                $this.$jjmatchedKind = 1;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 10:
                $this.$jjmatchedKind = 2;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 11:
                $this.$jjmatchedKind = 3;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 12:
                $this.$jjmatchedKind = 4;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 13:
                $this.$jjmatchedKind = 5;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 28:
                $this.$jjmatchedKind = 6;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 29:
                $this.$jjmatchedKind = 7;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 30:
                $this.$jjmatchedKind = 8;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 31:
                $this.$jjmatchedKind = 9;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 32:
                $this.$jjmatchedKind = 10;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 33:
                $this.$jjmatchedKind = 193;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(262144), Long_ZERO, Long_ZERO);
            case 34:
                $this.$jjmatchedKind = 53;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 36:
                $this.$jjmatchedKind = 131;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 37:
                $this.$jjmatchedKind = 209;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 38:
                $this.$jjmatchedKind = 192;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 39:
                $this.$jjmatchedKind = 41;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 40:
                $this.$jjmatchedKind = 202;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 41:
                $this.$jjmatchedKind = 275;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 42:
                $this.$jjmatchedKind = 307;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 43:
                $this.$jjmatchedKind = 238;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 32768), Long_ZERO, Long_ZERO);
            case 44:
                $this.$jjmatchedKind = 103;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 45:
                $this.$jjmatchedKind = 208;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 46:
                $this.$jjmatchedKind = 135;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_fromInt(256), Long_ZERO, Long_ZERO, Long_ZERO);
            case 47:
                $this.$jjmatchedKind = 134;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_create(2147483648, 0), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 58:
                $this.$jjmatchedKind = 101;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_create(0, 64), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 59:
                $this.$jjmatchedKind = 283;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 60:
                $this.$jjmatchedKind = 203;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(524304), Long_ZERO, Long_ZERO);
            case 61:
                $this.$jjmatchedKind = 151;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(16), Long_ZERO);
            case 62:
                $this.$jjmatchedKind = 174;
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 256), Long_ZERO, Long_ZERO, Long_ZERO);
            case 63:
                $this.$jjmatchedKind = 252;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 65:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_fromInt(3932128), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 66:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_create(4286578688, 0), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 67:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_create(0, 2096927), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 68:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_create(0, 4292870144), Long_fromInt(15926), Long_ZERO, Long_ZERO, Long_ZERO);
            case 69:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_fromInt(1065336832), Long_ZERO, Long_ZERO, Long_ZERO);
            case 70:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(3221225472, 255), Long_ZERO, Long_ZERO, Long_ZERO);
            case 71:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 15872), Long_ZERO, Long_ZERO, Long_ZERO);
            case 72:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 98304), Long_ZERO, Long_ZERO, Long_ZERO);
            case 73:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 268304384), Long_ZERO, Long_ZERO, Long_ZERO);
            case 74:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 268435456), Long_ZERO, Long_ZERO, Long_ZERO);
            case 75:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 536870912), Long_ZERO, Long_ZERO, Long_ZERO);
            case 76:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 3221225472), Long_fromInt(992), Long_ZERO, Long_ZERO);
            case 77:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(61440), Long_ZERO, Long_ZERO);
            case 78:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(2146435072), Long_ZERO, Long_ZERO);
            case 79:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(2147483648, 255), Long_ZERO, Long_ZERO);
            case 80:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 267599616), Long_ZERO, Long_ZERO);
            case 82:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 537395200), Long_fromInt(524271), Long_ZERO);
            case 83:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(4159700992, 16383), Long_ZERO);
            case 84:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 2146942976), Long_ZERO);
            case 85:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 2147483648), Long_fromInt(255));
            case 86:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(3840));
            case 87:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(258048));
            case 88:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(262144));
            case 89:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(524288));
            case 90:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(1048576));
            case 91:
                $this.$jjmatchedKind = 194;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 93:
                $this.$jjmatchedKind = 254;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 94:
                $this.$jjmatchedKind = 242;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 96:
                $this.$jjmatchedKind = 65;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 97:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_fromInt(3932128), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 98:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_create(4286578688, 0), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 99:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_create(0, 2096927), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO);
            case 100:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_create(0, 4292870144), Long_fromInt(15926), Long_ZERO, Long_ZERO, Long_ZERO);
            case 101:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_fromInt(1065336832), Long_ZERO, Long_ZERO, Long_ZERO);
            case 102:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(3221225472, 255), Long_ZERO, Long_ZERO, Long_ZERO);
            case 103:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 15872), Long_ZERO, Long_ZERO, Long_ZERO);
            case 104:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 98304), Long_ZERO, Long_ZERO, Long_ZERO);
            case 105:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 268304384), Long_ZERO, Long_ZERO, Long_ZERO);
            case 106:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 268435456), Long_ZERO, Long_ZERO, Long_ZERO);
            case 107:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 536870912), Long_ZERO, Long_ZERO, Long_ZERO);
            case 108:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_create(0, 3221225472), Long_fromInt(992), Long_ZERO, Long_ZERO);
            case 109:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(61440), Long_ZERO, Long_ZERO);
            case 110:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(2146435072), Long_ZERO, Long_ZERO);
            case 111:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(2147483648, 255), Long_ZERO, Long_ZERO);
            case 112:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 267599616), Long_ZERO, Long_ZERO);
            case 114:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 537395200), Long_fromInt(524271), Long_ZERO);
            case 115:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(4159700992, 16383), Long_ZERO);
            case 116:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 2146942976), Long_ZERO);
            case 117:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 2147483648), Long_fromInt(255));
            case 118:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(3840));
            case 119:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(258048));
            case 120:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(262144));
            case 121:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(524288));
            case 122:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_fromInt(1048576));
            case 123:
                $this.$jjmatchedKind = 195;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 124:
                $this.$jjmatchedKind = 86;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 125:
                $this.$jjmatchedKind = 255;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 160:
                $this.$jjmatchedKind = 11;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 5760:
                $this.$jjmatchedKind = 12;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8192:
                $this.$jjmatchedKind = 13;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8193:
                $this.$jjmatchedKind = 14;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8194:
                $this.$jjmatchedKind = 15;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8195:
                $this.$jjmatchedKind = 16;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8196:
                $this.$jjmatchedKind = 17;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8197:
                $this.$jjmatchedKind = 18;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8198:
                $this.$jjmatchedKind = 19;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8199:
                $this.$jjmatchedKind = 20;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8200:
                $this.$jjmatchedKind = 21;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8201:
                $this.$jjmatchedKind = 22;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8202:
                $this.$jjmatchedKind = 23;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8232:
                $this.$jjmatchedKind = 24;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8233:
                $this.$jjmatchedKind = 25;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8239:
                $this.$jjmatchedKind = 26;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 8287:
                $this.$jjmatchedKind = 27;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            case 12288:
                $this.$jjmatchedKind = 28;
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
            default:
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa1_0($this, $active0, $active1, $active2, $active3, $active4, $active5) {
        var var$7, $$je;
        a: {
            try {
                var$7 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$7;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 0);
        }
        b: {
            c: {
                d: {
                    e: {
                        f: {
                            g: {
                                h: {
                                    i: {
                                        switch (var$7) {
                                            case 42:
                                                if (Long_eq(Long_and($active0, Long_create(2147483648, 0)), Long_ZERO))
                                                    break b;
                                                $this.$jjmatchedKind = 31;
                                                $this.$jjmatchedPos = 1;
                                                break b;
                                            case 43:
                                            case 44:
                                            case 45:
                                            case 47:
                                            case 48:
                                            case 49:
                                            case 50:
                                            case 51:
                                            case 52:
                                            case 53:
                                            case 54:
                                            case 55:
                                            case 56:
                                            case 57:
                                            case 59:
                                            case 60:
                                            case 63:
                                            case 64:
                                            case 71:
                                            case 74:
                                            case 81:
                                            case 86:
                                            case 87:
                                            case 90:
                                            case 91:
                                            case 92:
                                            case 93:
                                            case 94:
                                            case 95:
                                            case 96:
                                            case 103:
                                            case 106:
                                            case 113:
                                            case 118:
                                            case 119:
                                            case 122:
                                            case 123:
                                            case 124:
                                            case 125:
                                                break b;
                                            case 46:
                                                break i;
                                            case 58:
                                                break h;
                                            case 61:
                                                if (Long_ne(Long_and($active2, Long_create(0, 256)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 168;
                                                    $this.$jjmatchedPos = 1;
                                                    break b;
                                                }
                                                if (Long_ne(Long_and($active3, Long_fromInt(16)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 196;
                                                    $this.$jjmatchedPos = 1;
                                                    break b;
                                                }
                                                if (Long_ne(Long_and($active3, Long_fromInt(262144)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 210;
                                                    $this.$jjmatchedPos = 1;
                                                    break b;
                                                }
                                                if (Long_eq(Long_and($active3, Long_create(0, 32768)), Long_ZERO))
                                                    break b;
                                                $this.$jjmatchedKind = 239;
                                                $this.$jjmatchedPos = 1;
                                                break b;
                                            case 62:
                                                break g;
                                            case 65:
                                                break;
                                            case 66:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 67108864), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 67:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(96), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_fromInt(1048576), $active5, Long_ZERO);
                                            case 68:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(384), $active2, Long_fromInt(32768), $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 69:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 4160749568), $active2, Long_create(6, 536903680), $active3, Long_create(8421376, 528384), $active4, Long_create(4158685167, 98305), $active5, Long_fromInt(3072));
                                            case 70:
                                                if (Long_ne(Long_and($active2, Long_create(0, 131072)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 177;
                                                    $this.$jjmatchedPos = 1;
                                                    break b;
                                                }
                                                if (Long_eq(Long_and($active3, Long_create(2147483648, 0)), Long_ZERO))
                                                    break b;
                                                $this.$jjmatchedKind = 223;
                                                $this.$jjmatchedPos = 1;
                                                break b;
                                            case 72:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 4), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 131086), $active5, Long_fromInt(24576));
                                            case 73:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(8388608, 8), $active2, Long_create(48, 1), $active3, Long_fromInt(96), $active4, Long_create(0, 3407920), $active5, Long_fromInt(622592));
                                            case 75:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 64), $active5, Long_ZERO);
                                            case 76:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(15872), $active2, Long_create(917504, 2), $active3, Long_create(0, 8192), $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 77:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_create(0, 786432), $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 78:
                                                break c;
                                            case 79:
                                                break e;
                                            case 80:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_ZERO, $active3, Long_create(0, 28), $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 82:
                                                if (Long_ne(Long_and($active3, Long_create(0, 32)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 229;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(402718720, 262144), $active2, Long_create(536874496, 15888), $active3, Long_create(0, 267386944), $active4, Long_create(0, 251658240), $active5, Long_fromInt(131080));
                                            case 83:
                                                if (Long_ne(Long_and($active1, Long_fromInt(131072)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 81;
                                                    $this.$jjmatchedPos = 1;
                                                } else if (Long_ne(Long_and($active2, Long_create(0, 134217728)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 187;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(1572864, 524288), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_fromInt(240));
                                            case 84:
                                                if (Long_ne(Long_and($active1, Long_fromInt(2097152)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 85;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(536870912), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 3968), $active5, Long_ZERO);
                                            case 85:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(1073741824, 1048576), $active2, Long_create(12288, 224), $active3, Long_create(1073741824, 128), $active4, Long_create(0, 12288), $active5, Long_ZERO);
                                            case 88:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_fromInt(520093696), $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 89:
                                                if (Long_ne(Long_and($active1, Long_create(2147483648, 0)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 95;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 1879048192), $active5, Long_ZERO);
                                            case 97:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 65011715), $active2, Long_create(3221241856, 3221225472), $active3, Long_create(7368704, 536874752), $active4, Long_create(0, 16384), $active5, Long_fromInt(4864));
                                            case 98:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 67108864), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 99:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(96), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_fromInt(1048576), $active5, Long_ZERO);
                                            case 100:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(384), $active2, Long_fromInt(32768), $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 101:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 4160749568), $active2, Long_create(6, 536903680), $active3, Long_create(8421376, 528384), $active4, Long_create(4158685167, 98305), $active5, Long_fromInt(3072));
                                            case 102:
                                                break d;
                                            case 104:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 4), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 131086), $active5, Long_fromInt(24576));
                                            case 105:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(8388608, 8), $active2, Long_create(48, 1), $active3, Long_fromInt(96), $active4, Long_create(0, 3407920), $active5, Long_fromInt(622592));
                                            case 107:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 64), $active5, Long_ZERO);
                                            case 108:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(15872), $active2, Long_create(917504, 2), $active3, Long_create(0, 8192), $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 109:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_create(0, 786432), $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 110:
                                                if (Long_ne(Long_and($active2, Long_create(0, 1048576)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 180;
                                                    $this.$jjmatchedPos = 1;
                                                } else if (Long_ne(Long_and($active3, Long_create(0, 1)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 224;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(49152), $active2, Long_create(7405568, 132120576), $active3, Long_create(0, 2), $active4, Long_create(0, 2147483648), $active5, Long_fromInt(7));
                                            case 111:
                                                if (Long_ne(Long_and($active4, Long_create(0, 4194304)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 310;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(117440512, 261904), $active2, Long_create(0, 268501004), $active3, Long_create(1056965504, 196608), $active4, Long_create(491520, 8388608), $active5, Long_fromInt(1310720));
                                            case 112:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_ZERO, $active3, Long_create(0, 28), $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 114:
                                                if (Long_ne(Long_and($active3, Long_create(0, 32)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 229;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(402718720, 262144), $active2, Long_create(536874496, 15888), $active3, Long_create(0, 267386944), $active4, Long_create(0, 251658240), $active5, Long_fromInt(131080));
                                            case 115:
                                                if (Long_ne(Long_and($active1, Long_fromInt(131072)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 81;
                                                    $this.$jjmatchedPos = 1;
                                                } else if (Long_ne(Long_and($active2, Long_create(0, 134217728)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 187;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(1572864, 524288), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_fromInt(240));
                                            case 116:
                                                if (Long_ne(Long_and($active1, Long_fromInt(2097152)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 85;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(536870912), $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 3968), $active5, Long_ZERO);
                                            case 117:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(1073741824, 1048576), $active2, Long_create(12288, 224), $active3, Long_create(1073741824, 128), $active4, Long_create(0, 12288), $active5, Long_ZERO);
                                            case 120:
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_fromInt(520093696), $active3, Long_ZERO, $active4, Long_ZERO, $active5, Long_ZERO);
                                            case 121:
                                                if (Long_ne(Long_and($active1, Long_create(2147483648, 0)), Long_ZERO)) {
                                                    $this.$jjmatchedKind = 95;
                                                    $this.$jjmatchedPos = 1;
                                                }
                                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_ZERO, $active2, Long_ZERO, $active3, Long_ZERO, $active4, Long_create(0, 1879048192), $active5, Long_ZERO);
                                            case 126:
                                                break f;
                                            default:
                                                break b;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(0, 65011715), $active2, Long_create(3221241856, 3221225472), $active3, Long_create(7368704, 536874752), $active4, Long_create(0, 16384), $active5, Long_fromInt(4864));
                                    }
                                    if (Long_eq(Long_and($active2, Long_fromInt(256)), Long_ZERO))
                                        break b;
                                    $this.$jjmatchedKind = 136;
                                    $this.$jjmatchedPos = 1;
                                    break b;
                                }
                                if (Long_eq(Long_and($active1, Long_create(0, 64)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 102;
                                $this.$jjmatchedPos = 1;
                                break b;
                            }
                            if (Long_eq(Long_and($active3, Long_fromInt(524288)), Long_ZERO))
                                break b;
                            $this.$jjmatchedKind = 211;
                            $this.$jjmatchedPos = 1;
                            break b;
                        }
                        if (Long_eq(Long_and($active4, Long_fromInt(16)), Long_ZERO))
                            break b;
                        $this.$jjmatchedKind = 260;
                        $this.$jjmatchedPos = 1;
                        break b;
                    }
                    if (Long_ne(Long_and($active4, Long_create(0, 4194304)), Long_ZERO)) {
                        $this.$jjmatchedKind = 310;
                        $this.$jjmatchedPos = 1;
                    }
                    return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_create(117440512, 261904), $active2, Long_create(0, 268501004), $active3, Long_create(1056965504, 196608), $active4, Long_create(491520, 8388608), $active5, Long_fromInt(1310720));
                }
                if (Long_ne(Long_and($active2, Long_create(0, 131072)), Long_ZERO)) {
                    $this.$jjmatchedKind = 177;
                    $this.$jjmatchedPos = 1;
                    break b;
                }
                if (Long_eq(Long_and($active3, Long_create(2147483648, 0)), Long_ZERO))
                    break b;
                $this.$jjmatchedKind = 223;
                $this.$jjmatchedPos = 1;
                break b;
            }
            if (Long_ne(Long_and($active2, Long_create(0, 1048576)), Long_ZERO)) {
                $this.$jjmatchedKind = 180;
                $this.$jjmatchedPos = 1;
            } else if (Long_ne(Long_and($active3, Long_create(0, 1)), Long_ZERO)) {
                $this.$jjmatchedKind = 224;
                $this.$jjmatchedPos = 1;
            }
            return oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $active0, Long_ZERO, $active1, Long_fromInt(49152), $active2, Long_create(7405568, 132120576), $active3, Long_create(0, 2), $active4, Long_create(0, 2147483648), $active5, Long_fromInt(7));
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 1);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa2_0($this, $old0, $active0, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$13, var$14, $$je;
        $old0 = Long_and($active0, $old0);
        var$13 = Long_and($active1, $old1);
        $old0 = Long_or($old0, var$13);
        $active2 = Long_and($active2, $old2);
        $old0 = Long_or($old0, $active2);
        $old3 = Long_and($active3, $old3);
        $old0 = Long_or($old0, $old3);
        $active3 = Long_and($active4, $old4);
        $old0 = Long_or($old0, $active3);
        $old4 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old0, $old4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 1);
        a: {
            try {
                var$14 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$14;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 1);
        }
        switch (var$14) {
            case 65:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 134217732), $active2, Long_create(65536, 36352), $old3, Long_create(128, 8192), $active3, Long_create(1048579, 117441408), $old4, Long_ZERO);
            case 66:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_create(0, 3221225472), $old3, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO);
            case 67:
                if (Long_ne(Long_and($active3, Long_fromInt(2097152)), Long_ZERO)) {
                    $this.$jjmatchedKind = 277;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_fromInt(32), $active2, Long_fromInt(1064960), $old3, Long_fromInt(256), $active3, Long_fromInt(62914560), $old4, Long_ZERO);
            case 68:
                if (Long_ne(Long_and(var$13, Long_fromInt(16384)), Long_ZERO)) {
                    $this.$jjmatchedKind = 78;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active2, Long_fromInt(2097152)), Long_ZERO)) {
                    $this.$jjmatchedKind = 149;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 8), $active2, Long_create(4194304, 6291456), $old3, Long_create(50331648, 64), $active3, Long_fromInt(4), $old4, Long_ZERO);
            case 69:
                if (Long_ne(Long_and($old4, Long_fromInt(16)), Long_ZERO)) {
                    $this.$jjmatchedKind = 324;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(134217728, 262144), $active2, Long_create(50724864, 1), $old3, Long_ZERO, $active3, Long_create(67108864, 131072), $old4, Long_fromInt(548960));
            case 70:
                if (Long_ne(Long_and($active2, Long_create(0, 8388608)), Long_ZERO)) {
                    $this.$jjmatchedKind = 183;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 805306368), $active2, Long_create(16, 16777216), $old3, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO);
            case 71:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_fromInt(32768), $old3, Long_ZERO, $active3, Long_create(0, 16), $old4, Long_ZERO);
            case 72:
            case 74:
            case 75:
            case 90:
            case 91:
            case 92:
            case 93:
            case 94:
            case 95:
            case 96:
            case 104:
            case 106:
            case 107:
                break;
            case 73:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_fromInt(1342178816), $active2, Long_create(1543504384, 268435456), $old3, Long_create(0, 15794176), $active3, Long_create(0, 2147483712), $old4, Long_fromInt(135299));
            case 76:
                if (Long_ne(Long_and(var$13, Long_fromInt(4096)), Long_ZERO)) {
                    $this.$jjmatchedKind = 76;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active3, Long_fromInt(32)), Long_ZERO)) {
                    $this.$jjmatchedKind = 261;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($old4, Long_fromInt(8)), Long_ZERO)) {
                    $this.$jjmatchedKind = 323;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(2048, 1073741841), $active2, Long_create(2147483648, 32), $old3, Long_create(1073741824, 2), $active3, Long_fromInt(98496), $old4, Long_fromInt(256));
            case 77:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(384, 67112704), $active2, Long_create(4096, 589824), $old3, Long_fromInt(3145760), $active3, Long_create(256, 3407872), $old4, Long_ZERO);
            case 78:
                if (Long_ne(Long_and($old3, Long_fromInt(4194304)), Long_ZERO)) {
                    $this.$jjmatchedKind = 214;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(8388608, 2147577856), $active2, Long_create(0, 192), $old3, Long_create(67112960, 536870912), $active3, Long_create(8, 32), $old4, Long_fromInt(1048576));
            case 79:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_fromInt(117440512), $active2, Long_create(1024, 12306), $old3, Long_create(512, 251658240), $active3, Long_create(0, 1038), $old4, Long_ZERO);
            case 80:
                if (Long_ne(Long_and($old3, Long_fromInt(8192)), Long_ZERO)) {
                    $this.$jjmatchedKind = 205;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 32768), $active2, Long_create(0, 262144), $old3, Long_create(0, 655360), $active3, Long_create(1536, 1887440896), $old4, Long_ZERO);
            case 81:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_fromInt(6144), $old4, Long_ZERO);
            case 82:
                if (Long_ne(Long_and($active2, Long_create(0, 4)), Long_ZERO)) {
                    $this.$jjmatchedKind = 162;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($old4, Long_fromInt(262144)), Long_ZERO)) {
                    $this.$jjmatchedKind = 338;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(536936448, 1048576), $active2, Long_create(536879104, 8), $old3, Long_create(32768, 4096), $active3, Long_create(805306368, 51200), $old4, Long_fromInt(3584));
            case 83:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(1572864, 2), $active2, Long_fromInt(524322), $old3, Long_create(64, 768), $active3, Long_create(0, 8192), $old4, Long_ZERO);
            case 84:
                if (Long_ne(Long_and($active2, Long_create(0, 33554432)), Long_ZERO)) {
                    $this.$jjmatchedKind = 185;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($old3, Long_fromInt(134217728)), Long_ZERO)) {
                    $this.$jjmatchedKind = 219;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active3, Long_fromInt(1073741824)), Long_ZERO)) {
                    $this.$jjmatchedKind = 286;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(8256, 65011712), $active2, Long_create(4, 67108864), $old3, Long_create(268451840, 3228), $active3, Long_create(2147491840, 1), $old4, Long_fromInt(98304));
            case 85:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 131072), $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_create(0, 134217728), $old4, Long_ZERO);
            case 86:
                if (Long_ne(Long_and(var$13, Long_create(0, 524288)), Long_ZERO)) {
                    $this.$jjmatchedKind = 115;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_fromInt(16384), $old4, Long_ZERO);
            case 87:
                if (Long_ne(Long_and($old3, Long_fromInt(8388608)), Long_ZERO)) {
                    $this.$jjmatchedKind = 215;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active3, Long_fromInt(131072)), Long_ZERO)) {
                    $this.$jjmatchedKind = 273;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_fromInt(536870912), $active3, Long_fromInt(262144), $old4, Long_fromInt(4));
            case 88:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_create(0, 65536), $old4, Long_ZERO);
            case 89:
                if (Long_ne(Long_and(var$13, Long_fromInt(32768)), Long_ZERO)) {
                    $this.$jjmatchedKind = 79;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active2, Long_create(0, 536870912)), Long_ZERO)) {
                    $this.$jjmatchedKind = 189;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_fromInt(2048), $old3, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO);
            case 97:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 134217732), $active2, Long_create(65536, 36352), $old3, Long_create(128, 8192), $active3, Long_create(1048579, 117441408), $old4, Long_ZERO);
            case 98:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_create(0, 3221225472), $old3, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO);
            case 99:
                if (Long_ne(Long_and($active3, Long_fromInt(2097152)), Long_ZERO)) {
                    $this.$jjmatchedKind = 277;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_fromInt(32), $active2, Long_fromInt(1064960), $old3, Long_fromInt(256), $active3, Long_fromInt(62914560), $old4, Long_ZERO);
            case 100:
                if (Long_ne(Long_and(var$13, Long_fromInt(16384)), Long_ZERO)) {
                    $this.$jjmatchedKind = 78;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active2, Long_fromInt(2097152)), Long_ZERO)) {
                    $this.$jjmatchedKind = 149;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 8), $active2, Long_create(4194304, 6291456), $old3, Long_create(50331648, 64), $active3, Long_fromInt(4), $old4, Long_ZERO);
            case 101:
                if (Long_ne(Long_and($old4, Long_fromInt(16)), Long_ZERO)) {
                    $this.$jjmatchedKind = 324;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(134217728, 262144), $active2, Long_create(50724864, 1), $old3, Long_ZERO, $active3, Long_create(67108864, 131072), $old4, Long_fromInt(548960));
            case 102:
                if (Long_ne(Long_and($active2, Long_create(0, 8388608)), Long_ZERO)) {
                    $this.$jjmatchedKind = 183;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 805306368), $active2, Long_create(16, 16777216), $old3, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO);
            case 103:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_fromInt(32768), $old3, Long_ZERO, $active3, Long_create(0, 16), $old4, Long_ZERO);
            case 105:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_fromInt(1342178816), $active2, Long_create(1543504384, 268435456), $old3, Long_create(0, 15794176), $active3, Long_create(0, 2147483712), $old4, Long_fromInt(135299));
            case 108:
                if (Long_ne(Long_and(var$13, Long_fromInt(4096)), Long_ZERO)) {
                    $this.$jjmatchedKind = 76;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active3, Long_fromInt(32)), Long_ZERO)) {
                    $this.$jjmatchedKind = 261;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($old4, Long_fromInt(8)), Long_ZERO)) {
                    $this.$jjmatchedKind = 323;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(2048, 1073741841), $active2, Long_create(2147483648, 32), $old3, Long_create(1073741824, 2), $active3, Long_fromInt(98496), $old4, Long_fromInt(256));
            case 109:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(384, 67112704), $active2, Long_create(4096, 589824), $old3, Long_fromInt(3145760), $active3, Long_create(256, 3407872), $old4, Long_ZERO);
            case 110:
                if (Long_ne(Long_and($old3, Long_fromInt(4194304)), Long_ZERO)) {
                    $this.$jjmatchedKind = 214;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(8388608, 2147577856), $active2, Long_create(0, 192), $old3, Long_create(67112960, 536870912), $active3, Long_create(8, 32), $old4, Long_fromInt(1048576));
            case 111:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_fromInt(117440512), $active2, Long_create(1024, 12306), $old3, Long_create(512, 251658240), $active3, Long_create(0, 1038), $old4, Long_ZERO);
            case 112:
                if (Long_ne(Long_and($old3, Long_fromInt(8192)), Long_ZERO)) {
                    $this.$jjmatchedKind = 205;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 32768), $active2, Long_create(0, 262144), $old3, Long_create(0, 655360), $active3, Long_create(1536, 1887440896), $old4, Long_ZERO);
            case 113:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_fromInt(6144), $old4, Long_ZERO);
            case 114:
                if (Long_ne(Long_and($active2, Long_create(0, 4)), Long_ZERO)) {
                    $this.$jjmatchedKind = 162;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($old4, Long_fromInt(262144)), Long_ZERO)) {
                    $this.$jjmatchedKind = 338;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(536936448, 1048576), $active2, Long_create(536879104, 8), $old3, Long_create(32768, 4096), $active3, Long_create(805306368, 51200), $old4, Long_fromInt(3584));
            case 115:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(1572864, 2), $active2, Long_fromInt(524322), $old3, Long_create(64, 768), $active3, Long_create(0, 8192), $old4, Long_ZERO);
            case 116:
                if (Long_ne(Long_and($active2, Long_create(0, 33554432)), Long_ZERO)) {
                    $this.$jjmatchedKind = 185;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($old3, Long_fromInt(134217728)), Long_ZERO)) {
                    $this.$jjmatchedKind = 219;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active3, Long_fromInt(1073741824)), Long_ZERO)) {
                    $this.$jjmatchedKind = 286;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(8256, 65011712), $active2, Long_create(4, 67108864), $old3, Long_create(268451840, 3228), $active3, Long_create(2147491840, 1), $old4, Long_fromInt(98304));
            case 117:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_create(0, 131072), $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_create(0, 134217728), $old4, Long_ZERO);
            case 118:
                if (Long_ne(Long_and(var$13, Long_create(0, 524288)), Long_ZERO)) {
                    $this.$jjmatchedKind = 115;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_fromInt(16384), $old4, Long_ZERO);
            case 119:
                if (Long_ne(Long_and($old3, Long_fromInt(8388608)), Long_ZERO)) {
                    $this.$jjmatchedKind = 215;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active3, Long_fromInt(131072)), Long_ZERO)) {
                    $this.$jjmatchedKind = 273;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_fromInt(536870912), $active3, Long_fromInt(262144), $old4, Long_fromInt(4));
            case 120:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_ZERO, $old3, Long_ZERO, $active3, Long_create(0, 65536), $old4, Long_ZERO);
            case 121:
                if (Long_ne(Long_and(var$13, Long_fromInt(32768)), Long_ZERO)) {
                    $this.$jjmatchedKind = 79;
                    $this.$jjmatchedPos = 2;
                } else if (Long_ne(Long_and($active2, Long_create(0, 536870912)), Long_ZERO)) {
                    $this.$jjmatchedKind = 189;
                    $this.$jjmatchedPos = 2;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, var$13, Long_ZERO, $active2, Long_fromInt(2048), $old3, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO);
            default:
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 2);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa3_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, var$13, var$14, $$je;
        var$11 = Long_and($active1, $old1);
        var$12 = Long_and($active2, $old2);
        $old1 = Long_or(var$11, var$12);
        var$13 = Long_and($active3, $old3);
        $old1 = Long_or($old1, var$13);
        $old4 = Long_and($active4, $old4);
        $old1 = Long_or($old1, $old4);
        $active3 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old1, $active3), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 2);
        a: {
            try {
                var$14 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$14;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 2);
        }
        b: {
            c: {
                d: {
                    e: {
                        switch (var$14) {
                            case 65:
                                break d;
                            case 66:
                                break;
                            case 67:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_create(50331648, 192), var$13, Long_create(16384, 50331648), $old4, Long_ZERO, $active3, Long_fromInt(512));
                            case 68:
                                if (Long_ne(Long_and(var$13, Long_fromInt(128)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 199;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(1)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 256;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_fromInt(8388608), var$12, Long_create(0, 32768), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 69:
                                f: {
                                    if (Long_ne(Long_and(var$11, Long_create(0, 2)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 97;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and(var$11, Long_create(0, 16777216)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 120;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and(var$12, Long_fromInt(32768)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 143;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and(var$12, Long_fromInt(524288)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 147;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and(var$12, Long_create(0, 65536)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 176;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and(var$13, Long_fromInt(1048576)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 212;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and(var$13, Long_fromInt(16777216)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 216;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and(var$13, Long_fromInt(67108864)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 218;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and($old4, Long_fromInt(32768)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 271;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and($old4, Long_create(0, 262144)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 306;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_ne(Long_and($old4, Long_create(0, 134217728)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 315;
                                        $this.$jjmatchedPos = 3;
                                        break f;
                                    }
                                    if (Long_eq(Long_and($old4, Long_create(0, 268435456)), Long_ZERO))
                                        break f;
                                    $this.$jjmatchedKind = 316;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(805838880, 1107296256), var$12, Long_create(0, 3294887944), var$13, Long_create(35651584, 524352), $old4, Long_create(65536, 1613758464), $active3, Long_fromInt(1048576));
                            case 70:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(16), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 71:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(32768, 536870912), $old4, Long_create(0, 16416), $active3, Long_ZERO);
                            case 72:
                                if (Long_ne(Long_and(var$12, Long_fromInt(16384)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 142;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$13, Long_create(0, 1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 234;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(32768)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 335;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(268435456, 2048), $old4, Long_ZERO, $active3, Long_fromInt(65536));
                            case 73:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(1049024, 536870912), var$12, Long_create(0, 16777216), var$13, Long_create(32, 12316), $old4, Long_create(0, 2048), $active3, Long_fromInt(4));
                            case 74:
                            case 88:
                            case 90:
                            case 91:
                            case 92:
                            case 93:
                            case 94:
                            case 95:
                            case 96:
                            case 106:
                            case 120:
                                break b;
                            case 75:
                                if (Long_ne(Long_and($old4, Long_fromInt(67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 282;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_fromInt(512), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 76:
                                if (Long_ne(Long_and(var$11, Long_fromInt(16777216)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 88;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 1)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 96;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(1073741824)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 158;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$13, Long_fromInt(1073741824)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 222;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(1107296256, 134217744), var$12, Long_create(0, 33), var$13, Long_ZERO, $old4, Long_fromInt(514), $active3, Long_fromInt(524288));
                            case 77:
                                if (Long_ne(Long_and(var$12, Long_create(0, 16)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 164;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 1792), var$12, Long_fromInt(393216), var$13, Long_create(0, 3145728), $old4, Long_create(0, 32768), $active3, Long_ZERO);
                            case 78:
                                if (Long_ne(Long_and(var$12, Long_create(0, 268435456)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 188;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(1048576)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 276;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 131072)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 305;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(8192)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 333;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 131076), var$12, Long_create(0, 512), var$13, Long_create(0, 65536), $old4, Long_create(0, 50331664), $active3, Long_fromInt(128));
                            case 79:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(536870912), var$13, Long_ZERO, $old4, Long_create(62932224, 2155872256), $active3, Long_ZERO);
                            case 80:
                                if (Long_ne(Long_and(var$12, Long_fromInt(1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 138;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 140;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 294;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 298;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 2048), var$12, Long_create(0, 3072), var$13, Long_create(0, 201326720), $old4, Long_create(0, 12288), $active3, Long_ZERO);
                            case 81:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_fromInt(3));
                            case 82:
                                if (Long_ne(Long_and(var$11, Long_create(0, 8)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 99;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(32)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 325;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 1048576), var$12, Long_fromInt(1050624), var$13, Long_ZERO, $old4, Long_create(0, 390), $active3, Long_fromInt(16448));
                            case 83:
                                if (Long_ne(Long_and(var$11, Long_create(0, 67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 122;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 150;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(262144)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 274;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(67110912, 12288), var$12, Long_create(2617245696, 0), var$13, Long_create(0, 768), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 84:
                                if (Long_ne(Long_and(var$13, Long_fromInt(64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 198;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 65536)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 304;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 332;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 81920), var$12, Long_fromInt(34), var$13, Long_ZERO, $old4, Long_create(2147483648, 513), $active3, Long_fromInt(133120));
                            case 85:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_create(0, 536576), var$13, Long_create(0, 131072), $old4, Long_fromInt(14340), $active3, Long_fromInt(256));
                            case 86:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(512), var$13, Long_create(0, 12582912), $old4, Long_create(805306368, 67108864), $active3, Long_ZERO);
                            case 87:
                                if (Long_eq(Long_and($old4, Long_create(0, 8)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 291;
                                $this.$jjmatchedPos = 3;
                                break b;
                            case 89:
                                if (Long_ne(Long_and(var$11, Long_create(0, 32768)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 111;
                                    $this.$jjmatchedPos = 3;
                                    break b;
                                }
                                if (Long_ne(Long_and(var$11, Long_create(0, 2147483648)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 127;
                                    $this.$jjmatchedPos = 3;
                                    break b;
                                }
                                if (Long_eq(Long_and(var$13, Long_create(0, 2)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 225;
                                $this.$jjmatchedPos = 3;
                                break b;
                            case 97:
                                if (Long_ne(Long_and(var$11, Long_create(0, 2097152)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 117;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(134284800, 281280512), var$12, Long_create(8196, 2), var$13, Long_fromInt(536875264), $old4, Long_fromInt(200), $active3, Long_ZERO);
                            case 98:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(65536), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_fromInt(1024));
                            case 99:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_create(50331648, 192), var$13, Long_create(16384, 50331648), $old4, Long_ZERO, $active3, Long_fromInt(512));
                            case 100:
                                if (Long_ne(Long_and(var$13, Long_fromInt(128)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 199;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(1)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 256;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_fromInt(8388608), var$12, Long_create(0, 32768), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 101:
                                g: {
                                    if (Long_ne(Long_and(var$11, Long_create(0, 2)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 97;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and(var$11, Long_create(0, 16777216)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 120;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and(var$12, Long_fromInt(32768)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 143;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and(var$12, Long_fromInt(524288)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 147;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and(var$12, Long_create(0, 65536)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 176;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and(var$13, Long_fromInt(1048576)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 212;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and(var$13, Long_fromInt(16777216)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 216;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and(var$13, Long_fromInt(67108864)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 218;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and($old4, Long_fromInt(32768)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 271;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and($old4, Long_create(0, 262144)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 306;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_ne(Long_and($old4, Long_create(0, 134217728)), Long_ZERO)) {
                                        $this.$jjmatchedKind = 315;
                                        $this.$jjmatchedPos = 3;
                                        break g;
                                    }
                                    if (Long_eq(Long_and($old4, Long_create(0, 268435456)), Long_ZERO))
                                        break g;
                                    $this.$jjmatchedKind = 316;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(805838880, 1107296256), var$12, Long_create(0, 3294887944), var$13, Long_create(35651584, 524352), $old4, Long_create(65536, 1613758464), $active3, Long_fromInt(1048576));
                            case 102:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(16), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 103:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(32768, 536870912), $old4, Long_create(0, 16416), $active3, Long_ZERO);
                            case 104:
                                if (Long_ne(Long_and(var$12, Long_fromInt(16384)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 142;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$13, Long_create(0, 1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 234;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(32768)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 335;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(268435456, 2048), $old4, Long_ZERO, $active3, Long_fromInt(65536));
                            case 105:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(1049024, 536870912), var$12, Long_create(0, 16777216), var$13, Long_create(32, 12316), $old4, Long_create(0, 2048), $active3, Long_fromInt(4));
                            case 107:
                                if (Long_ne(Long_and($old4, Long_fromInt(67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 282;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_fromInt(512), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 108:
                                if (Long_ne(Long_and(var$11, Long_fromInt(16777216)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 88;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 1)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 96;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(1073741824)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 158;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$13, Long_fromInt(1073741824)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 222;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(1107296256, 134217744), var$12, Long_create(0, 33), var$13, Long_ZERO, $old4, Long_fromInt(514), $active3, Long_fromInt(524288));
                            case 109:
                                if (Long_ne(Long_and(var$12, Long_create(0, 16)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 164;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 1792), var$12, Long_fromInt(393216), var$13, Long_create(0, 3145728), $old4, Long_create(0, 32768), $active3, Long_ZERO);
                            case 110:
                                if (Long_ne(Long_and(var$12, Long_create(0, 268435456)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 188;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(1048576)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 276;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 131072)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 305;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(8192)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 333;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 131076), var$12, Long_create(0, 512), var$13, Long_create(0, 65536), $old4, Long_create(0, 50331664), $active3, Long_fromInt(128));
                            case 111:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(536870912), var$13, Long_ZERO, $old4, Long_create(62932224, 2155872256), $active3, Long_ZERO);
                            case 112:
                                if (Long_ne(Long_and(var$12, Long_fromInt(1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 138;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 140;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 294;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 298;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 2048), var$12, Long_create(0, 3072), var$13, Long_create(0, 201326720), $old4, Long_create(0, 12288), $active3, Long_ZERO);
                            case 113:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_fromInt(3));
                            case 114:
                                if (Long_ne(Long_and(var$11, Long_create(0, 8)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 99;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(32)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 325;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 1048576), var$12, Long_fromInt(1050624), var$13, Long_ZERO, $old4, Long_create(0, 390), $active3, Long_fromInt(16448));
                            case 115:
                                if (Long_ne(Long_and(var$11, Long_create(0, 67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 122;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 150;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(262144)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 274;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(67110912, 12288), var$12, Long_create(2617245696, 0), var$13, Long_create(0, 768), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 116:
                                if (Long_ne(Long_and(var$13, Long_fromInt(64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 198;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 65536)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 304;
                                    $this.$jjmatchedPos = 3;
                                } else if (Long_ne(Long_and($active3, Long_fromInt(4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 332;
                                    $this.$jjmatchedPos = 3;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(0, 81920), var$12, Long_fromInt(34), var$13, Long_ZERO, $old4, Long_create(2147483648, 513), $active3, Long_fromInt(133120));
                            case 117:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_create(0, 536576), var$13, Long_create(0, 131072), $old4, Long_fromInt(14340), $active3, Long_fromInt(256));
                            case 118:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(512), var$13, Long_create(0, 12582912), $old4, Long_create(805306368, 67108864), $active3, Long_ZERO);
                            case 119:
                                break e;
                            case 121:
                                break c;
                            default:
                                break b;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_ZERO, var$12, Long_fromInt(65536), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_fromInt(1024));
                    }
                    if (Long_eq(Long_and($old4, Long_create(0, 8)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 291;
                    $this.$jjmatchedPos = 3;
                    break b;
                }
                if (Long_ne(Long_and(var$11, Long_create(0, 2097152)), Long_ZERO)) {
                    $this.$jjmatchedKind = 117;
                    $this.$jjmatchedPos = 3;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, var$11, Long_create(134284800, 281280512), var$12, Long_create(8196, 2), var$13, Long_fromInt(536875264), $old4, Long_fromInt(200), $active3, Long_ZERO);
            }
            if (Long_ne(Long_and(var$11, Long_create(0, 32768)), Long_ZERO)) {
                $this.$jjmatchedKind = 111;
                $this.$jjmatchedPos = 3;
            } else if (Long_ne(Long_and(var$11, Long_create(0, 2147483648)), Long_ZERO)) {
                $this.$jjmatchedKind = 127;
                $this.$jjmatchedPos = 3;
            } else if (Long_ne(Long_and(var$13, Long_create(0, 2)), Long_ZERO)) {
                $this.$jjmatchedKind = 225;
                $this.$jjmatchedPos = 3;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 3);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa4_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, var$13, $$je;
        var$11 = Long_and($active1, $old1);
        var$12 = Long_and($active2, $old2);
        $old1 = Long_or(var$11, var$12);
        $active3 = Long_and($active3, $old3);
        $old1 = Long_or($old1, $active3);
        $old4 = Long_and($active4, $old4);
        $old1 = Long_or($old1, $old4);
        $active4 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old1, $active4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 3);
        a: {
            try {
                var$13 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$13;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 3);
        }
        b: {
            c: {
                switch (var$13) {
                    case 65:
                        break;
                    case 66:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 12582912), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 67:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_fromInt(4), $active3, Long_ZERO, $old4, Long_fromInt(4), $active4, Long_ZERO);
                    case 68:
                        if (Long_ne(Long_and($old4, Long_create(0, 536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 317;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(524288)), Long_ZERO)) {
                            $this.$jjmatchedKind = 339;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(1048576)), Long_ZERO)) {
                            $this.$jjmatchedKind = 340;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 69:
                        if (Long_ne(Long_and(var$11, Long_fromInt(536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 93;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and(var$12, Long_create(2147483648, 0)), Long_ZERO)) {
                            $this.$jjmatchedKind = 159;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(32768)), Long_ZERO)) {
                            $this.$jjmatchedKind = 207;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_create(0, 536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 253;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(256)), Long_ZERO)) {
                            $this.$jjmatchedKind = 328;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(16384)), Long_ZERO)) {
                            $this.$jjmatchedKind = 334;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(131072)), Long_ZERO)) {
                            $this.$jjmatchedKind = 337;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(33554432, 1048592), var$12, Long_create(393744, 32768), $active3, Long_create(0, 251658240), $old4, Long_create(805306368, 67133456), $active4, Long_fromInt(2048));
                    case 70:
                        if (Long_eq(Long_and(var$11, Long_fromInt(268435456)), Long_ZERO))
                            break b;
                        $this.$jjmatchedKind = 92;
                        $this.$jjmatchedPos = 4;
                        break b;
                    case 71:
                        if (Long_ne(Long_and($active4, Long_fromInt(128)), Long_ZERO)) {
                            $this.$jjmatchedKind = 327;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(1048576, 4), var$12, Long_create(0, 67108864), $active3, Long_fromInt(4096), $old4, Long_ZERO, $active4, Long_ZERO);
                    case 72:
                        if (Long_ne(Long_and(var$12, Long_create(0, 1024)), Long_ZERO)) {
                            $this.$jjmatchedKind = 170;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(16384)), Long_ZERO)) {
                            $this.$jjmatchedKind = 206;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(2048), var$12, Long_create(0, 2048), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_fromInt(512));
                    case 73:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(8388608, 66560), var$12, Long_fromInt(32), $active3, Long_create(805306368, 12582912), $old4, Long_create(2147489792, 32769), $active4, Long_ZERO);
                    case 74:
                    case 81:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 106:
                    case 113:
                        break b;
                    case 75:
                        if (Long_ne(Long_and(var$11, Long_fromInt(134217728)), Long_ZERO)) {
                            $this.$jjmatchedKind = 91;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(16384), $active4, Long_ZERO);
                    case 76:
                        if (Long_ne(Long_and(var$12, Long_create(0, 1073741824)), Long_ZERO)) {
                            $this.$jjmatchedKind = 190;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(256)), Long_ZERO)) {
                            $this.$jjmatchedKind = 200;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 134217728), var$12, Long_create(65536, 2147483648), $active3, Long_create(0, 131072), $old4, Long_create(2, 8388640), $active4, Long_ZERO);
                    case 77:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(8), $active4, Long_ZERO);
                    case 78:
                        if (Long_ne(Long_and(var$11, Long_fromInt(128)), Long_ZERO)) {
                            $this.$jjmatchedKind = 71;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($old4, Long_create(0, 2147483648)), Long_ZERO)) {
                            $this.$jjmatchedKind = 319;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(256, 536870912), var$12, Long_create(0, 16777216), $active3, Long_create(0, 8192), $old4, Long_create(62914560, 2048), $active4, Long_fromInt(4));
                    case 79:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 2048), var$12, Long_ZERO, $active3, Long_create(0, 4124), $old4, Long_create(0, 4096), $active4, Long_fromInt(66560));
                    case 80:
                        if (Long_ne(Long_and(var$12, Long_create(0, 4096)), Long_ZERO)) {
                            $this.$jjmatchedKind = 172;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_create(0, 8192), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 82:
                        if (Long_ne(Long_and(var$11, Long_fromInt(8192)), Long_ZERO)) {
                            $this.$jjmatchedKind = 77;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and(var$12, Long_fromInt(536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 157;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_create(0, 64)), Long_ZERO)) {
                            $this.$jjmatchedKind = 230;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(524288), var$12, Long_create(2, 262144), $active3, Long_ZERO, $old4, Long_fromInt(9216), $active4, Long_ZERO);
                    case 83:
                        if (Long_ne(Long_and(var$11, Long_fromInt(512)), Long_ZERO)) {
                            $this.$jjmatchedKind = 73;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(2097152)), Long_ZERO)) {
                            $this.$jjmatchedKind = 213;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(33554432)), Long_ZERO)) {
                            $this.$jjmatchedKind = 217;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_create(0, 2048)), Long_ZERO)) {
                            $this.$jjmatchedKind = 235;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($old4, Long_fromInt(65536)), Long_ZERO)) {
                            $this.$jjmatchedKind = 272;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($old4, Long_create(0, 1073741824)), Long_ZERO)) {
                            $this.$jjmatchedKind = 318;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(64)), Long_ZERO)) {
                            $this.$jjmatchedKind = 326;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(1056), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 51380224), $active4, Long_ZERO);
                    case 84:
                        d: {
                            if (Long_ne(Long_and(var$11, Long_fromInt(1073741824)), Long_ZERO)) {
                                $this.$jjmatchedKind = 94;
                                $this.$jjmatchedPos = 4;
                                break d;
                            }
                            if (Long_ne(Long_and(var$11, Long_create(0, 131072)), Long_ZERO)) {
                                $this.$jjmatchedKind = 113;
                                $this.$jjmatchedPos = 4;
                                break d;
                            }
                            if (Long_ne(Long_and(var$12, Long_fromInt(67108864)), Long_ZERO)) {
                                $this.$jjmatchedKind = 154;
                                $this.$jjmatchedPos = 4;
                                break d;
                            }
                            if (Long_ne(Long_and(var$12, Long_create(0, 2)), Long_ZERO)) {
                                $this.$jjmatchedKind = 161;
                                $this.$jjmatchedPos = 4;
                                break d;
                            }
                            if (Long_ne(Long_and(var$12, Long_create(0, 512)), Long_ZERO)) {
                                $this.$jjmatchedKind = 169;
                                $this.$jjmatchedPos = 4;
                                break d;
                            }
                            if (Long_ne(Long_and($active3, Long_fromInt(32)), Long_ZERO)) {
                                $this.$jjmatchedKind = 197;
                                $this.$jjmatchedPos = 4;
                                break d;
                            }
                            if (Long_ne(Long_and($active3, Long_create(0, 65536)), Long_ZERO)) {
                                $this.$jjmatchedKind = 240;
                                $this.$jjmatchedPos = 4;
                                break d;
                            }
                            if (Long_eq(Long_and($old4, Long_create(0, 128)), Long_ZERO))
                                break d;
                            $this.$jjmatchedKind = 295;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(67108864, 1107570688), var$12, Long_create(402661376, 524512), $active3, Long_ZERO, $old4, Long_create(192, 262), $active4, Long_ZERO);
                    case 85:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 268435456), var$12, Long_fromInt(50333696), $active3, Long_create(512, 128), $old4, Long_create(0, 512), $active4, Long_fromInt(3));
                    case 86:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(64), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(256), $active4, Long_ZERO);
                    case 87:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_create(0, 768), $old4, Long_ZERO, $active4, Long_ZERO);
                    case 88:
                        if (Long_ne(Long_and(var$12, Long_create(0, 2097152)), Long_ZERO)) {
                            $this.$jjmatchedKind = 181;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_create(0, 4194304), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 89:
                        if (Long_ne(Long_and(var$11, Long_fromInt(65536)), Long_ZERO)) {
                            $this.$jjmatchedKind = 80;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_fromInt(1048576), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 90:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 2097152), $active4, Long_ZERO);
                    case 97:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 17152), var$12, Long_create(0, 8), $active3, Long_create(0, 3670016), $old4, Long_fromInt(512), $active4, Long_ZERO);
                    case 98:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 12582912), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 99:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_fromInt(4), $active3, Long_ZERO, $old4, Long_fromInt(4), $active4, Long_ZERO);
                    case 100:
                        if (Long_ne(Long_and($old4, Long_create(0, 536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 317;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(524288)), Long_ZERO)) {
                            $this.$jjmatchedKind = 339;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(1048576)), Long_ZERO)) {
                            $this.$jjmatchedKind = 340;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 101:
                        if (Long_ne(Long_and(var$11, Long_fromInt(536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 93;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and(var$12, Long_create(2147483648, 0)), Long_ZERO)) {
                            $this.$jjmatchedKind = 159;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(32768)), Long_ZERO)) {
                            $this.$jjmatchedKind = 207;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_create(0, 536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 253;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(256)), Long_ZERO)) {
                            $this.$jjmatchedKind = 328;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(16384)), Long_ZERO)) {
                            $this.$jjmatchedKind = 334;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(131072)), Long_ZERO)) {
                            $this.$jjmatchedKind = 337;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(33554432, 1048592), var$12, Long_create(393744, 32768), $active3, Long_create(0, 251658240), $old4, Long_create(805306368, 67133456), $active4, Long_fromInt(2048));
                    case 102:
                        break c;
                    case 103:
                        if (Long_ne(Long_and($active4, Long_fromInt(128)), Long_ZERO)) {
                            $this.$jjmatchedKind = 327;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(1048576, 4), var$12, Long_create(0, 67108864), $active3, Long_fromInt(4096), $old4, Long_ZERO, $active4, Long_ZERO);
                    case 104:
                        if (Long_ne(Long_and(var$12, Long_create(0, 1024)), Long_ZERO)) {
                            $this.$jjmatchedKind = 170;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(16384)), Long_ZERO)) {
                            $this.$jjmatchedKind = 206;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(2048), var$12, Long_create(0, 2048), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_fromInt(512));
                    case 105:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(8388608, 66560), var$12, Long_fromInt(32), $active3, Long_create(805306368, 12582912), $old4, Long_create(2147489792, 32769), $active4, Long_ZERO);
                    case 107:
                        if (Long_ne(Long_and(var$11, Long_fromInt(134217728)), Long_ZERO)) {
                            $this.$jjmatchedKind = 91;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(16384), $active4, Long_ZERO);
                    case 108:
                        if (Long_ne(Long_and(var$12, Long_create(0, 1073741824)), Long_ZERO)) {
                            $this.$jjmatchedKind = 190;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(256)), Long_ZERO)) {
                            $this.$jjmatchedKind = 200;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 134217728), var$12, Long_create(65536, 2147483648), $active3, Long_create(0, 131072), $old4, Long_create(2, 8388640), $active4, Long_ZERO);
                    case 109:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(8), $active4, Long_ZERO);
                    case 110:
                        if (Long_ne(Long_and(var$11, Long_fromInt(128)), Long_ZERO)) {
                            $this.$jjmatchedKind = 71;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($old4, Long_create(0, 2147483648)), Long_ZERO)) {
                            $this.$jjmatchedKind = 319;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(256, 536870912), var$12, Long_create(0, 16777216), $active3, Long_create(0, 8192), $old4, Long_create(62914560, 2048), $active4, Long_fromInt(4));
                    case 111:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 2048), var$12, Long_ZERO, $active3, Long_create(0, 4124), $old4, Long_create(0, 4096), $active4, Long_fromInt(66560));
                    case 112:
                        if (Long_ne(Long_and(var$12, Long_create(0, 4096)), Long_ZERO)) {
                            $this.$jjmatchedKind = 172;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_create(0, 8192), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 114:
                        if (Long_ne(Long_and(var$11, Long_fromInt(8192)), Long_ZERO)) {
                            $this.$jjmatchedKind = 77;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and(var$12, Long_fromInt(536870912)), Long_ZERO)) {
                            $this.$jjmatchedKind = 157;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_create(0, 64)), Long_ZERO)) {
                            $this.$jjmatchedKind = 230;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(524288), var$12, Long_create(2, 262144), $active3, Long_ZERO, $old4, Long_fromInt(9216), $active4, Long_ZERO);
                    case 115:
                        if (Long_ne(Long_and(var$11, Long_fromInt(512)), Long_ZERO)) {
                            $this.$jjmatchedKind = 73;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(2097152)), Long_ZERO)) {
                            $this.$jjmatchedKind = 213;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_fromInt(33554432)), Long_ZERO)) {
                            $this.$jjmatchedKind = 217;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active3, Long_create(0, 2048)), Long_ZERO)) {
                            $this.$jjmatchedKind = 235;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($old4, Long_fromInt(65536)), Long_ZERO)) {
                            $this.$jjmatchedKind = 272;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($old4, Long_create(0, 1073741824)), Long_ZERO)) {
                            $this.$jjmatchedKind = 318;
                            $this.$jjmatchedPos = 4;
                        } else if (Long_ne(Long_and($active4, Long_fromInt(64)), Long_ZERO)) {
                            $this.$jjmatchedKind = 326;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(1056), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 51380224), $active4, Long_ZERO);
                    case 116:
                        e: {
                            if (Long_ne(Long_and(var$11, Long_fromInt(1073741824)), Long_ZERO)) {
                                $this.$jjmatchedKind = 94;
                                $this.$jjmatchedPos = 4;
                                break e;
                            }
                            if (Long_ne(Long_and(var$11, Long_create(0, 131072)), Long_ZERO)) {
                                $this.$jjmatchedKind = 113;
                                $this.$jjmatchedPos = 4;
                                break e;
                            }
                            if (Long_ne(Long_and(var$12, Long_fromInt(67108864)), Long_ZERO)) {
                                $this.$jjmatchedKind = 154;
                                $this.$jjmatchedPos = 4;
                                break e;
                            }
                            if (Long_ne(Long_and(var$12, Long_create(0, 2)), Long_ZERO)) {
                                $this.$jjmatchedKind = 161;
                                $this.$jjmatchedPos = 4;
                                break e;
                            }
                            if (Long_ne(Long_and(var$12, Long_create(0, 512)), Long_ZERO)) {
                                $this.$jjmatchedKind = 169;
                                $this.$jjmatchedPos = 4;
                                break e;
                            }
                            if (Long_ne(Long_and($active3, Long_fromInt(32)), Long_ZERO)) {
                                $this.$jjmatchedKind = 197;
                                $this.$jjmatchedPos = 4;
                                break e;
                            }
                            if (Long_ne(Long_and($active3, Long_create(0, 65536)), Long_ZERO)) {
                                $this.$jjmatchedKind = 240;
                                $this.$jjmatchedPos = 4;
                                break e;
                            }
                            if (Long_eq(Long_and($old4, Long_create(0, 128)), Long_ZERO))
                                break e;
                            $this.$jjmatchedKind = 295;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(67108864, 1107570688), var$12, Long_create(402661376, 524512), $active3, Long_ZERO, $old4, Long_create(192, 262), $active4, Long_ZERO);
                    case 117:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 268435456), var$12, Long_fromInt(50333696), $active3, Long_create(512, 128), $old4, Long_create(0, 512), $active4, Long_fromInt(3));
                    case 118:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_fromInt(64), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(256), $active4, Long_ZERO);
                    case 119:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_create(0, 768), $old4, Long_ZERO, $active4, Long_ZERO);
                    case 120:
                        if (Long_ne(Long_and(var$12, Long_create(0, 2097152)), Long_ZERO)) {
                            $this.$jjmatchedKind = 181;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_create(0, 4194304), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 121:
                        if (Long_ne(Long_and(var$11, Long_fromInt(65536)), Long_ZERO)) {
                            $this.$jjmatchedKind = 80;
                            $this.$jjmatchedPos = 4;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_fromInt(1048576), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    case 122:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 2097152), $active4, Long_ZERO);
                    default:
                        break b;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, var$11, Long_create(0, 17152), var$12, Long_create(0, 8), $active3, Long_create(0, 3670016), $old4, Long_fromInt(512), $active4, Long_ZERO);
            }
            if (Long_ne(Long_and(var$11, Long_fromInt(268435456)), Long_ZERO)) {
                $this.$jjmatchedKind = 92;
                $this.$jjmatchedPos = 4;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 4);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa5_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, var$13, $$je;
        var$11 = Long_and($active1, $old1);
        var$12 = Long_and($active2, $old2);
        $old1 = Long_or(var$11, var$12);
        $active3 = Long_and($active3, $old3);
        $old1 = Long_or($old1, $active3);
        $old4 = Long_and($active4, $old4);
        $old1 = Long_or($old1, $old4);
        $active4 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old1, $active4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 4);
        a: {
            try {
                var$13 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$13;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 4);
        }
        b: {
            c: {
                d: {
                    e: {
                        f: {
                            g: {
                                switch (var$13) {
                                    case 65:
                                        break;
                                    case 66:
                                    case 70:
                                    case 74:
                                    case 75:
                                    case 77:
                                    case 81:
                                    case 86:
                                    case 87:
                                    case 89:
                                    case 90:
                                    case 91:
                                    case 92:
                                    case 93:
                                    case 94:
                                    case 95:
                                    case 96:
                                    case 98:
                                    case 102:
                                    case 106:
                                    case 107:
                                    case 109:
                                    case 113:
                                    case 118:
                                    case 119:
                                        break b;
                                    case 67:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 16), var$12, Long_create(0, 8), $active3, Long_ZERO, $old4, Long_fromInt(512), $active4, Long_ZERO);
                                    case 68:
                                        if (Long_ne(Long_and($old4, Long_fromInt(4194304)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 278;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 16)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 292;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active4, Long_fromInt(4)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 322;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_create(0, 50335744), $old4, Long_fromInt(58720256), $active4, Long_ZERO);
                                    case 69:
                                        h: {
                                            if (Long_ne(Long_and(var$11, Long_fromInt(64)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 70;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and(var$11, Long_create(0, 4)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 98;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and(var$11, Long_create(0, 262144)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 114;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and(var$11, Long_create(0, 1073741824)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 126;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and(var$12, Long_fromInt(65536)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 144;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(4)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 258;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(8)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 259;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(256)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 264;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(16384)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 270;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_ne(Long_and($old4, Long_create(0, 32)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 293;
                                                $this.$jjmatchedPos = 5;
                                                break h;
                                            }
                                            if (Long_eq(Long_and($active4, Long_fromInt(1)), Long_ZERO))
                                                break h;
                                            $this.$jjmatchedKind = 320;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(67109888, 536870912), var$12, Long_create(134217728, 71303200), $active3, Long_fromInt(4096), $old4, Long_create(0, 6), $active4, Long_fromInt(2));
                                    case 71:
                                        if (Long_eq(Long_and($old4, Long_create(0, 2048)), Long_ZERO))
                                            break b;
                                        $this.$jjmatchedKind = 299;
                                        $this.$jjmatchedPos = 5;
                                        break b;
                                    case 72:
                                        break g;
                                    case 73:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(256, 33570816), var$12, Long_create(8192, 16777408), $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_ZERO);
                                    case 76:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 268435456), var$12, Long_ZERO, $active3, Long_create(0, 12582912), $old4, Long_ZERO, $active4, Long_ZERO);
                                    case 78:
                                        if (Long_ne(Long_and(var$11, Long_fromInt(1048576)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 84;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_fromInt(2048)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 139;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active3, Long_create(0, 16)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 228;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_fromInt(8192)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 269;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(8388608, 1114880), var$12, Long_fromInt(393248), $active3, Long_create(268435456, 12), $old4, Long_create(2147483648, 40961), $active4, Long_ZERO);
                                    case 79:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(2048, 134217728), var$12, Long_fromInt(2), $active3, Long_create(0, 768), $old4, Long_create(2, 10485760), $active4, Long_ZERO);
                                    case 80:
                                        if (Long_ne(Long_and($active3, Long_fromInt(512)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 201;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_fromInt(1048576), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                                    case 82:
                                        if (Long_ne(Long_and(var$12, Long_fromInt(512)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 137;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_fromInt(268435456)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 284;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 12288), var$12, Long_create(16, 32768), $active3, Long_create(0, 204472320), $old4, Long_create(536877056, 67112960), $active4, Long_ZERO);
                                    case 83:
                                        if (Long_ne(Long_and(var$11, Long_fromInt(32)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 69;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_fromInt(268435456)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 156;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_create(0, 2048)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 171;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_create(0, 8192)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 173;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_create(0, 2147483648)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 191;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 256)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 296;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 512)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 297;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 2048), var$12, Long_create(0, 262144), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_fromInt(1024));
                                    case 84:
                                        if (Long_ne(Long_and(var$11, Long_fromInt(524288)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 83;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$11, Long_create(0, 1024)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 106;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active3, Long_fromInt(536870912)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 221;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active3, Long_create(0, 128)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 231;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_fromInt(1024)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 266;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 16384)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 302;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_create(50331648, 1), $active3, Long_create(0, 532480), $old4, Long_create(0, 1048576), $active4, Long_ZERO);
                                    case 85:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_fromInt(65536));
                                    case 88:
                                        break f;
                                    case 97:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(33554432, 12582912), var$12, Long_create(0, 524288), $active3, Long_create(0, 131072), $old4, Long_create(0, 50331648), $active4, Long_fromInt(512));
                                    case 99:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 16), var$12, Long_create(0, 8), $active3, Long_ZERO, $old4, Long_fromInt(512), $active4, Long_ZERO);
                                    case 100:
                                        if (Long_ne(Long_and($old4, Long_fromInt(4194304)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 278;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 16)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 292;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active4, Long_fromInt(4)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 322;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_create(0, 50335744), $old4, Long_fromInt(58720256), $active4, Long_ZERO);
                                    case 101:
                                        i: {
                                            if (Long_ne(Long_and(var$11, Long_fromInt(64)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 70;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and(var$11, Long_create(0, 4)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 98;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and(var$11, Long_create(0, 262144)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 114;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and(var$11, Long_create(0, 1073741824)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 126;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and(var$12, Long_fromInt(65536)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 144;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(4)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 258;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(8)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 259;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(256)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 264;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and($old4, Long_fromInt(16384)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 270;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_ne(Long_and($old4, Long_create(0, 32)), Long_ZERO)) {
                                                $this.$jjmatchedKind = 293;
                                                $this.$jjmatchedPos = 5;
                                                break i;
                                            }
                                            if (Long_eq(Long_and($active4, Long_fromInt(1)), Long_ZERO))
                                                break i;
                                            $this.$jjmatchedKind = 320;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(67109888, 536870912), var$12, Long_create(134217728, 71303200), $active3, Long_fromInt(4096), $old4, Long_create(0, 6), $active4, Long_fromInt(2));
                                    case 103:
                                        break e;
                                    case 104:
                                        break d;
                                    case 105:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(256, 33570816), var$12, Long_create(8192, 16777408), $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_ZERO);
                                    case 108:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 268435456), var$12, Long_ZERO, $active3, Long_create(0, 12582912), $old4, Long_ZERO, $active4, Long_ZERO);
                                    case 110:
                                        if (Long_ne(Long_and(var$11, Long_fromInt(1048576)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 84;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_fromInt(2048)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 139;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active3, Long_create(0, 16)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 228;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_fromInt(8192)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 269;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(8388608, 1114880), var$12, Long_fromInt(393248), $active3, Long_create(268435456, 12), $old4, Long_create(2147483648, 40961), $active4, Long_ZERO);
                                    case 111:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(2048, 134217728), var$12, Long_fromInt(2), $active3, Long_create(0, 768), $old4, Long_create(2, 10485760), $active4, Long_ZERO);
                                    case 112:
                                        if (Long_ne(Long_and($active3, Long_fromInt(512)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 201;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_fromInt(1048576), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                                    case 114:
                                        if (Long_ne(Long_and(var$12, Long_fromInt(512)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 137;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_fromInt(268435456)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 284;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 12288), var$12, Long_create(16, 32768), $active3, Long_create(0, 204472320), $old4, Long_create(536877056, 67112960), $active4, Long_ZERO);
                                    case 115:
                                        if (Long_ne(Long_and(var$11, Long_fromInt(32)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 69;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_fromInt(268435456)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 156;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_create(0, 2048)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 171;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_create(0, 8192)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 173;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$12, Long_create(0, 2147483648)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 191;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 256)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 296;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 512)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 297;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(0, 2048), var$12, Long_create(0, 262144), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_fromInt(1024));
                                    case 116:
                                        if (Long_ne(Long_and(var$11, Long_fromInt(524288)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 83;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and(var$11, Long_create(0, 1024)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 106;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active3, Long_fromInt(536870912)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 221;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($active3, Long_create(0, 128)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 231;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_fromInt(1024)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 266;
                                            $this.$jjmatchedPos = 5;
                                        } else if (Long_ne(Long_and($old4, Long_create(0, 16384)), Long_ZERO)) {
                                            $this.$jjmatchedKind = 302;
                                            $this.$jjmatchedPos = 5;
                                        }
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_create(50331648, 1), $active3, Long_create(0, 532480), $old4, Long_create(0, 1048576), $active4, Long_ZERO);
                                    case 117:
                                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_fromInt(65536));
                                    case 120:
                                        break c;
                                    default:
                                        break b;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, var$11, Long_create(33554432, 12582912), var$12, Long_create(0, 524288), $active3, Long_create(0, 131072), $old4, Long_create(0, 50331648), $active4, Long_fromInt(512));
                            }
                            if (Long_eq(Long_and(var$12, Long_fromInt(4)), Long_ZERO))
                                break b;
                            $this.$jjmatchedKind = 130;
                            $this.$jjmatchedPos = 5;
                            break b;
                        }
                        if (Long_eq(Long_and($active4, Long_fromInt(2048)), Long_ZERO))
                            break b;
                        $this.$jjmatchedKind = 331;
                        $this.$jjmatchedPos = 5;
                        break b;
                    }
                    if (Long_eq(Long_and($old4, Long_create(0, 2048)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 299;
                    $this.$jjmatchedPos = 5;
                    break b;
                }
                if (Long_eq(Long_and(var$12, Long_fromInt(4)), Long_ZERO))
                    break b;
                $this.$jjmatchedKind = 130;
                $this.$jjmatchedPos = 5;
                break b;
            }
            if (Long_ne(Long_and($active4, Long_fromInt(2048)), Long_ZERO)) {
                $this.$jjmatchedKind = 331;
                $this.$jjmatchedPos = 5;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 5);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa6_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, var$13, $$je;
        var$11 = Long_and($active1, $old1);
        var$12 = Long_and($active2, $old2);
        $old1 = Long_or(var$11, var$12);
        $active3 = Long_and($active3, $old3);
        $old1 = Long_or($old1, $active3);
        $old4 = Long_and($active4, $old4);
        $old1 = Long_or($old1, $old4);
        $active4 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old1, $active4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 5);
        a: {
            try {
                var$13 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$13;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 5);
        }
        b: {
            c: {
                d: {
                    e: {
                        switch (var$13) {
                            case 65:
                                break;
                            case 66:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(0, 524288), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 67:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 134217728), var$12, Long_fromInt(32), $active3, Long_ZERO, $old4, Long_create(2, 50331648), $active4, Long_ZERO);
                            case 68:
                                if (Long_ne(Long_and(var$11, Long_fromInt(67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 90;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 256)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 104;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 536870912)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 125;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 512), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 8192), $active4, Long_ZERO);
                            case 69:
                                if (Long_ne(Long_and(var$12, Long_fromInt(33554432)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 153;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(512)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 265;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(2048)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 267;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active4, Long_fromInt(1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 330;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(16, 1), $active3, Long_create(0, 12591104), $old4, Long_fromInt(4096), $active4, Long_ZERO);
                            case 70:
                            case 74:
                            case 75:
                            case 76:
                            case 80:
                            case 81:
                            case 86:
                            case 87:
                            case 90:
                            case 91:
                            case 92:
                            case 93:
                            case 94:
                            case 95:
                            case 96:
                            case 102:
                            case 106:
                            case 107:
                            case 108:
                            case 112:
                            case 113:
                            case 118:
                            case 119:
                                break b;
                            case 71:
                                if (Long_ne(Long_and($active3, Long_fromInt(268435456)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 220;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_create(2147483648, 0)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 287;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_fromInt(8388608), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 8388609), $active4, Long_ZERO);
                            case 72:
                                if (Long_eq(Long_and(var$12, Long_create(0, 8)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 163;
                                $this.$jjmatchedPos = 6;
                                break b;
                            case 73:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 2048), var$12, Long_ZERO, $active3, Long_create(0, 2101248), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 77:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 33554432), var$12, Long_ZERO, $active3, Long_fromInt(4096), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 78:
                                break d;
                            case 79:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(8192, 262336), $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_ZERO);
                            case 82:
                                if (Long_ne(Long_and(var$12, Long_create(0, 67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 186;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active4, Long_fromInt(512)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 329;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_fromInt(2048), var$12, Long_ZERO, $active3, Long_create(0, 768), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 83:
                                if (Long_ne(Long_and(var$11, Long_fromInt(1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 74;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 32768)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 175;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 182;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 8)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 227;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(33554432)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 281;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(536870912)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 285;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(256, 12582912), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 67108870), $active4, Long_ZERO);
                            case 84:
                                if (Long_ne(Long_and(var$11, Long_create(0, 16)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 100;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 1048576)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 116;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 268435456)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 124;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(131072)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 145;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active4, Long_fromInt(65536)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 336;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(1310720, 16777216), $active3, Long_create(0, 201457664), $old4, Long_create(0, 4096), $active4, Long_ZERO);
                            case 85:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 65536), var$12, Long_ZERO, $active3, Long_create(0, 50331648), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 88:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(0, 32), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 89:
                                if (Long_ne(Long_and(var$12, Long_fromInt(2)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 129;
                                    $this.$jjmatchedPos = 6;
                                    break b;
                                }
                                if (Long_eq(Long_and($active3, Long_create(0, 1048576)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 244;
                                $this.$jjmatchedPos = 6;
                                break b;
                            case 97:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 12288), var$12, Long_fromInt(16777216), $active3, Long_create(0, 524292), $old4, Long_create(25165824, 1081344), $active4, Long_ZERO);
                            case 98:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(0, 524288), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 99:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 134217728), var$12, Long_fromInt(32), $active3, Long_ZERO, $old4, Long_create(2, 50331648), $active4, Long_ZERO);
                            case 100:
                                if (Long_ne(Long_and(var$11, Long_fromInt(67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 90;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 256)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 104;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 536870912)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 125;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 512), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 8192), $active4, Long_ZERO);
                            case 101:
                                if (Long_ne(Long_and(var$12, Long_fromInt(33554432)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 153;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(512)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 265;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(2048)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 267;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active4, Long_fromInt(1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 330;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(16, 1), $active3, Long_create(0, 12591104), $old4, Long_fromInt(4096), $active4, Long_ZERO);
                            case 103:
                                if (Long_ne(Long_and($active3, Long_fromInt(268435456)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 220;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_create(2147483648, 0)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 287;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_fromInt(8388608), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 8388609), $active4, Long_ZERO);
                            case 104:
                                break e;
                            case 105:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 2048), var$12, Long_ZERO, $active3, Long_create(0, 2101248), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 109:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 33554432), var$12, Long_ZERO, $active3, Long_fromInt(4096), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 110:
                                if (Long_ne(Long_and(var$11, Long_fromInt(33554432)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 89;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 16384), var$12, Long_fromInt(134217728), $active3, Long_ZERO, $old4, Long_create(0, 2097152), $active4, Long_fromInt(2));
                            case 111:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(8192, 262336), $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_ZERO);
                            case 114:
                                if (Long_ne(Long_and(var$12, Long_create(0, 67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 186;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active4, Long_fromInt(512)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 329;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_fromInt(2048), var$12, Long_ZERO, $active3, Long_create(0, 768), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 115:
                                if (Long_ne(Long_and(var$11, Long_fromInt(1024)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 74;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 32768)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 175;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 182;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 8)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 227;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(33554432)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 281;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(536870912)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 285;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(256, 12582912), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 67108870), $active4, Long_ZERO);
                            case 116:
                                if (Long_ne(Long_and(var$11, Long_create(0, 16)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 100;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 1048576)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 116;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 268435456)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 124;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(131072)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 145;
                                    $this.$jjmatchedPos = 6;
                                } else if (Long_ne(Long_and($active4, Long_fromInt(65536)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 336;
                                    $this.$jjmatchedPos = 6;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(1310720, 16777216), $active3, Long_create(0, 201457664), $old4, Long_create(0, 4096), $active4, Long_ZERO);
                            case 117:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 65536), var$12, Long_ZERO, $active3, Long_create(0, 50331648), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 120:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_ZERO, var$12, Long_create(0, 32), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 121:
                                break c;
                            default:
                                break b;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 12288), var$12, Long_fromInt(16777216), $active3, Long_create(0, 524292), $old4, Long_create(25165824, 1081344), $active4, Long_ZERO);
                    }
                    if (Long_eq(Long_and(var$12, Long_create(0, 8)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 163;
                    $this.$jjmatchedPos = 6;
                    break b;
                }
                if (Long_ne(Long_and(var$11, Long_fromInt(33554432)), Long_ZERO)) {
                    $this.$jjmatchedKind = 89;
                    $this.$jjmatchedPos = 6;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, var$11, Long_create(0, 16384), var$12, Long_fromInt(134217728), $active3, Long_ZERO, $old4, Long_create(0, 2097152), $active4, Long_fromInt(2));
            }
            if (Long_ne(Long_and(var$12, Long_fromInt(2)), Long_ZERO)) {
                $this.$jjmatchedKind = 129;
                $this.$jjmatchedPos = 6;
            } else if (Long_ne(Long_and($active3, Long_create(0, 1048576)), Long_ZERO)) {
                $this.$jjmatchedKind = 244;
                $this.$jjmatchedPos = 6;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 6);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa7_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, var$13, var$14, $$je;
        var$11 = Long_and($active1, $old1);
        var$12 = Long_and($active2, $old2);
        $old1 = Long_or(var$11, var$12);
        var$13 = Long_and($active3, $old3);
        $old1 = Long_or($old1, var$13);
        $old4 = Long_and($active4, $old4);
        $old1 = Long_or($old1, $old4);
        $active3 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old1, $active3), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 6);
        a: {
            try {
                var$14 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$14;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 6);
        }
        b: {
            c: {
                d: {
                    e: {
                        switch (var$14) {
                            case 65:
                                break;
                            case 66:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_fromInt(16777216), var$13, Long_create(0, 524288), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 67:
                                if (Long_ne(Long_and(var$13, Long_create(0, 4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 236;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_fromInt(134217728), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 68:
                                if (Long_ne(Long_and(var$13, Long_create(0, 256)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 232;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 268;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(0, 512), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 69:
                                if (Long_ne(Long_and(var$11, Long_create(0, 65536)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 112;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 118;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 33554432)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 121;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 2097152)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 309;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 314;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(0, 8388608), var$12, Long_fromInt(1048576), var$13, Long_create(4096, 2228224), $old4, Long_create(0, 12288), $active3, Long_fromInt(2));
                            case 70:
                            case 72:
                            case 74:
                            case 75:
                            case 79:
                            case 80:
                            case 81:
                            case 85:
                            case 86:
                            case 87:
                            case 90:
                            case 91:
                            case 92:
                            case 93:
                            case 94:
                            case 95:
                            case 96:
                            case 102:
                            case 104:
                            case 106:
                            case 107:
                            case 111:
                            case 112:
                            case 113:
                            case 117:
                            case 118:
                            case 119:
                                break b;
                            case 71:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(0, 12582912), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 73:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(0, 12288), var$12, Long_ZERO, var$13, Long_create(0, 67108864), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 76:
                                if (Long_ne(Long_and(var$13, Long_create(0, 4)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 226;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_create(0, 524288), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 77:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_create(0, 1048576), $active3, Long_ZERO);
                            case 78:
                                if (Long_ne(Long_and(var$12, Long_fromInt(8192)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 141;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 166;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_create(16, 262272), var$13, Long_ZERO, $old4, Long_fromInt(192), $active3, Long_ZERO);
                            case 82:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), var$13, Long_create(0, 50331648), $old4, Long_fromInt(25165824), $active3, Long_ZERO);
                            case 83:
                                if (Long_ne(Long_and(var$11, Long_fromInt(8388608)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 87;
                                    $this.$jjmatchedPos = 7;
                                    break b;
                                }
                                if (Long_ne(Long_and(var$11, Long_create(0, 512)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 105;
                                    $this.$jjmatchedPos = 7;
                                    break b;
                                }
                                if (Long_ne(Long_and(var$11, Long_create(0, 16384)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 110;
                                    $this.$jjmatchedPos = 7;
                                    break b;
                                }
                                if (Long_ne(Long_and(var$12, Long_fromInt(262144)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 146;
                                    $this.$jjmatchedPos = 7;
                                    break b;
                                }
                                if (Long_eq(Long_and($old4, Long_create(0, 1)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 288;
                                $this.$jjmatchedPos = 7;
                                break b;
                            case 84:
                                break d;
                            case 88:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(0, 8192), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 89:
                                if (Long_ne(Long_and(var$12, Long_create(0, 16777216)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 184;
                                    $this.$jjmatchedPos = 7;
                                    break b;
                                }
                                if (Long_ne(Long_and(var$13, Long_create(0, 134217728)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 251;
                                    $this.$jjmatchedPos = 7;
                                    break b;
                                }
                                if (Long_eq(Long_and($old4, Long_create(0, 8388608)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 311;
                                $this.$jjmatchedPos = 7;
                                break b;
                            case 97:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(0, 134217728), var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_fromInt(2), $active3, Long_ZERO);
                            case 98:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_fromInt(16777216), var$13, Long_create(0, 524288), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 99:
                                if (Long_ne(Long_and(var$13, Long_create(0, 4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 236;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_fromInt(134217728), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 100:
                                if (Long_ne(Long_and(var$13, Long_create(0, 256)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 232;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and($old4, Long_fromInt(4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 268;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(0, 512), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 101:
                                if (Long_ne(Long_and(var$11, Long_create(0, 65536)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 112;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 118;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and(var$11, Long_create(0, 33554432)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 121;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 2097152)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 309;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 67108864)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 314;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(0, 8388608), var$12, Long_fromInt(1048576), var$13, Long_create(4096, 2228224), $old4, Long_create(0, 12288), $active3, Long_fromInt(2));
                            case 103:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(0, 12582912), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 105:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(0, 12288), var$12, Long_ZERO, var$13, Long_create(0, 67108864), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 108:
                                if (Long_ne(Long_and(var$13, Long_create(0, 4)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 226;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_create(0, 524288), var$13, Long_ZERO, $old4, Long_ZERO, $active3, Long_ZERO);
                            case 109:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_create(0, 1048576), $active3, Long_ZERO);
                            case 110:
                                if (Long_ne(Long_and(var$12, Long_fromInt(8192)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 141;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 166;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_create(16, 262272), var$13, Long_ZERO, $old4, Long_fromInt(192), $active3, Long_ZERO);
                            case 114:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), var$13, Long_create(0, 50331648), $old4, Long_fromInt(25165824), $active3, Long_ZERO);
                            case 115:
                                break c;
                            case 116:
                                if (Long_ne(Long_and(var$12, Long_fromInt(32)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 133;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 32)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 165;
                                    $this.$jjmatchedPos = 7;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 4)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 290;
                                    $this.$jjmatchedPos = 7;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(2304, 2048), var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_create(0, 50364418), $active3, Long_ZERO);
                            case 120:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_ZERO, var$12, Long_ZERO, var$13, Long_create(0, 8192), $old4, Long_ZERO, $active3, Long_ZERO);
                            case 121:
                                break e;
                            default:
                                break b;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(0, 134217728), var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_fromInt(2), $active3, Long_ZERO);
                    }
                    if (Long_ne(Long_and(var$12, Long_create(0, 16777216)), Long_ZERO)) {
                        $this.$jjmatchedKind = 184;
                        $this.$jjmatchedPos = 7;
                        break b;
                    }
                    if (Long_ne(Long_and(var$13, Long_create(0, 134217728)), Long_ZERO)) {
                        $this.$jjmatchedKind = 251;
                        $this.$jjmatchedPos = 7;
                        break b;
                    }
                    if (Long_eq(Long_and($old4, Long_create(0, 8388608)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 311;
                    $this.$jjmatchedPos = 7;
                    break b;
                }
                if (Long_ne(Long_and(var$12, Long_fromInt(32)), Long_ZERO)) {
                    $this.$jjmatchedKind = 133;
                    $this.$jjmatchedPos = 7;
                } else if (Long_ne(Long_and(var$12, Long_create(0, 32)), Long_ZERO)) {
                    $this.$jjmatchedKind = 165;
                    $this.$jjmatchedPos = 7;
                } else if (Long_ne(Long_and($old4, Long_create(0, 4)), Long_ZERO)) {
                    $this.$jjmatchedKind = 290;
                    $this.$jjmatchedPos = 7;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, var$11, Long_create(2304, 2048), var$12, Long_ZERO, var$13, Long_ZERO, $old4, Long_create(0, 50364418), $active3, Long_ZERO);
            }
            if (Long_ne(Long_and(var$11, Long_fromInt(8388608)), Long_ZERO)) {
                $this.$jjmatchedKind = 87;
                $this.$jjmatchedPos = 7;
            } else if (Long_ne(Long_and(var$11, Long_create(0, 512)), Long_ZERO)) {
                $this.$jjmatchedKind = 105;
                $this.$jjmatchedPos = 7;
            } else if (Long_ne(Long_and(var$11, Long_create(0, 16384)), Long_ZERO)) {
                $this.$jjmatchedKind = 110;
                $this.$jjmatchedPos = 7;
            } else if (Long_ne(Long_and(var$12, Long_fromInt(262144)), Long_ZERO)) {
                $this.$jjmatchedKind = 146;
                $this.$jjmatchedPos = 7;
            } else if (Long_ne(Long_and($old4, Long_create(0, 1)), Long_ZERO)) {
                $this.$jjmatchedKind = 288;
                $this.$jjmatchedPos = 7;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 7);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa8_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, var$13, $$je;
        var$11 = Long_and($active1, $old1);
        var$12 = Long_and($active2, $old2);
        $old1 = Long_or(var$11, var$12);
        $active3 = Long_and($active3, $old3);
        $old1 = Long_or($old1, $active3);
        $old4 = Long_and($active4, $old4);
        $old1 = Long_or($old1, $old4);
        $active4 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old1, $active4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 7);
        a: {
            try {
                var$13 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$13;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 7);
        }
        b: {
            c: {
                d: {
                    e: {
                        switch (var$13) {
                            case 65:
                                break;
                            case 66:
                            case 67:
                            case 70:
                            case 71:
                            case 72:
                            case 74:
                            case 75:
                            case 79:
                            case 81:
                            case 85:
                            case 86:
                            case 87:
                            case 88:
                            case 90:
                            case 91:
                            case 92:
                            case 93:
                            case 94:
                            case 95:
                            case 96:
                            case 98:
                            case 99:
                            case 102:
                            case 103:
                            case 104:
                            case 106:
                            case 107:
                            case 111:
                            case 113:
                            case 117:
                            case 118:
                            case 119:
                            case 120:
                                break b;
                            case 68:
                                if (Long_ne(Long_and(var$12, Long_fromInt(1048576)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 148;
                                    $this.$jjmatchedPos = 8;
                                    break b;
                                }
                                if (Long_ne(Long_and($active3, Long_create(0, 131072)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 241;
                                    $this.$jjmatchedPos = 8;
                                    break b;
                                }
                                if (Long_ne(Long_and($old4, Long_create(0, 4096)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 300;
                                    $this.$jjmatchedPos = 8;
                                    break b;
                                }
                                if (Long_eq(Long_and($old4, Long_create(0, 8192)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 301;
                                $this.$jjmatchedPos = 8;
                                break b;
                            case 69:
                                if (Long_ne(Long_and(var$11, Long_create(0, 2048)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 107;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(134217728)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 155;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 524288)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 179;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 246;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 16777216)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 248;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 32768)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 303;
                                    $this.$jjmatchedPos = 8;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_fromInt(2048), var$12, Long_ZERO, $active3, Long_create(0, 109051904), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 73:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(16777216, 50331648), $active4, Long_ZERO);
                            case 76:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_fromInt(16777216), $active3, Long_create(0, 524288), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 77:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 78:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_create(0, 12288), var$12, Long_ZERO, $active3, Long_fromInt(4096), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 80:
                                break d;
                            case 82:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_fromInt(256), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 83:
                                if (Long_ne(Long_and(var$11, Long_create(0, 8388608)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 119;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 128)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 167;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 512)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 233;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 2097152)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 245;
                                    $this.$jjmatchedPos = 8;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_fromInt(2));
                            case 84:
                                if (Long_ne(Long_and(var$12, Long_fromInt(16)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 132;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 8192)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 237;
                                    $this.$jjmatchedPos = 8;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_create(0, 134217728), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(2), $active4, Long_ZERO);
                            case 89:
                                if (Long_eq(Long_and($old4, Long_fromInt(8388608)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 279;
                                $this.$jjmatchedPos = 8;
                                break b;
                            case 97:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_create(0, 262144), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 100:
                                break c;
                            case 101:
                                if (Long_ne(Long_and(var$11, Long_create(0, 2048)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 107;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and(var$12, Long_fromInt(134217728)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 155;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 524288)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 179;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 4194304)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 246;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 16777216)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 248;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($old4, Long_create(0, 32768)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 303;
                                    $this.$jjmatchedPos = 8;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_fromInt(2048), var$12, Long_ZERO, $active3, Long_create(0, 109051904), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 105:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(16777216, 50331648), $active4, Long_ZERO);
                            case 108:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_fromInt(16777216), $active3, Long_create(0, 524288), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 109:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 110:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_create(0, 12288), var$12, Long_ZERO, $active3, Long_fromInt(4096), $old4, Long_ZERO, $active4, Long_ZERO);
                            case 112:
                                if (Long_ne(Long_and($old4, Long_create(0, 1048576)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 308;
                                    $this.$jjmatchedPos = 8;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 2), $active4, Long_ZERO);
                            case 114:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_fromInt(256), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                            case 115:
                                if (Long_ne(Long_and(var$11, Long_create(0, 8388608)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 119;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and(var$12, Long_create(0, 128)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 167;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 512)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 233;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 2097152)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 245;
                                    $this.$jjmatchedPos = 8;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_fromInt(2));
                            case 116:
                                if (Long_ne(Long_and(var$12, Long_fromInt(16)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 132;
                                    $this.$jjmatchedPos = 8;
                                } else if (Long_ne(Long_and($active3, Long_create(0, 8192)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 237;
                                    $this.$jjmatchedPos = 8;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_create(0, 134217728), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(2), $active4, Long_ZERO);
                            case 121:
                                break e;
                            default:
                                break b;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_create(0, 262144), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
                    }
                    if (Long_eq(Long_and($old4, Long_fromInt(8388608)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 279;
                    $this.$jjmatchedPos = 8;
                    break b;
                }
                if (Long_ne(Long_and($old4, Long_create(0, 1048576)), Long_ZERO)) {
                    $this.$jjmatchedKind = 308;
                    $this.$jjmatchedPos = 8;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 2), $active4, Long_ZERO);
            }
            if (Long_ne(Long_and(var$12, Long_fromInt(1048576)), Long_ZERO)) {
                $this.$jjmatchedKind = 148;
                $this.$jjmatchedPos = 8;
            } else if (Long_ne(Long_and($active3, Long_create(0, 131072)), Long_ZERO)) {
                $this.$jjmatchedKind = 241;
                $this.$jjmatchedPos = 8;
            } else if (Long_ne(Long_and($old4, Long_create(0, 4096)), Long_ZERO)) {
                $this.$jjmatchedKind = 300;
                $this.$jjmatchedPos = 8;
            } else if (Long_ne(Long_and($old4, Long_create(0, 8192)), Long_ZERO)) {
                $this.$jjmatchedKind = 301;
                $this.$jjmatchedPos = 8;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 8);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, var$13, $$je;
        var$11 = Long_and($active1, $old1);
        var$12 = Long_and($active2, $old2);
        $old1 = Long_or(var$11, var$12);
        $active3 = Long_and($active3, $old3);
        $old1 = Long_or($old1, $active3);
        $old4 = Long_and($active4, $old4);
        $old1 = Long_or($old1, $old4);
        $active4 = Long_and($active5, $old5);
        if (Long_eq(Long_or($old1, $active4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 8);
        a: {
            try {
                var$13 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$13;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 8);
        }
        switch (var$13) {
            case 65:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_fromInt(256), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 2), $active4, Long_ZERO);
            case 66:
            case 67:
            case 68:
            case 70:
            case 71:
            case 74:
            case 75:
            case 76:
            case 77:
            case 78:
            case 80:
            case 81:
            case 82:
            case 85:
            case 86:
            case 87:
            case 88:
            case 89:
            case 90:
            case 91:
            case 92:
            case 93:
            case 94:
            case 95:
            case 96:
            case 98:
            case 99:
            case 100:
            case 102:
            case 103:
            case 106:
            case 107:
            case 108:
            case 109:
            case 110:
            case 112:
            case 113:
            case 114:
                break;
            case 69:
                if (Long_ne(Long_and(var$11, Long_create(0, 134217728)), Long_ZERO)) {
                    $this.$jjmatchedKind = 123;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and(var$12, Long_fromInt(16777216)), Long_ZERO)) {
                    $this.$jjmatchedKind = 152;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_create(0, 524288)), Long_ZERO)) {
                    $this.$jjmatchedKind = 243;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($old4, Long_fromInt(2)), Long_ZERO)) {
                    $this.$jjmatchedKind = 257;
                    $this.$jjmatchedPos = 9;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(16777216), $active4, Long_ZERO);
            case 72:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_ZERO);
            case 73:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
            case 79:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 50331648), $active4, Long_ZERO);
            case 83:
                if (Long_ne(Long_and($active3, Long_create(0, 8388608)), Long_ZERO)) {
                    $this.$jjmatchedKind = 247;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_create(0, 33554432)), Long_ZERO)) {
                    $this.$jjmatchedKind = 249;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_create(0, 67108864)), Long_ZERO)) {
                    $this.$jjmatchedKind = 250;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active4, Long_fromInt(2)), Long_ZERO)) {
                    $this.$jjmatchedKind = 321;
                    $this.$jjmatchedPos = 9;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_fromInt(2048), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
            case 84:
                if (Long_ne(Long_and(var$11, Long_create(0, 4096)), Long_ZERO)) {
                    $this.$jjmatchedKind = 108;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_fromInt(4096)), Long_ZERO)) {
                    $this.$jjmatchedKind = 204;
                    $this.$jjmatchedPos = 9;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_create(0, 8192), var$12, Long_create(0, 262144), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
            case 97:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_fromInt(256), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 2), $active4, Long_ZERO);
            case 101:
                if (Long_ne(Long_and(var$11, Long_create(0, 134217728)), Long_ZERO)) {
                    $this.$jjmatchedKind = 123;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and(var$12, Long_fromInt(16777216)), Long_ZERO)) {
                    $this.$jjmatchedKind = 152;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_create(0, 524288)), Long_ZERO)) {
                    $this.$jjmatchedKind = 243;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($old4, Long_fromInt(2)), Long_ZERO)) {
                    $this.$jjmatchedKind = 257;
                    $this.$jjmatchedPos = 9;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(16777216), $active4, Long_ZERO);
            case 104:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_fromInt(192), $active4, Long_ZERO);
            case 105:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_create(0, 1), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
            case 111:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_ZERO, var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_create(0, 50331648), $active4, Long_ZERO);
            case 115:
                if (Long_ne(Long_and($active3, Long_create(0, 8388608)), Long_ZERO)) {
                    $this.$jjmatchedKind = 247;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_create(0, 33554432)), Long_ZERO)) {
                    $this.$jjmatchedKind = 249;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_create(0, 67108864)), Long_ZERO)) {
                    $this.$jjmatchedKind = 250;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active4, Long_fromInt(2)), Long_ZERO)) {
                    $this.$jjmatchedKind = 321;
                    $this.$jjmatchedPos = 9;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_fromInt(2048), var$12, Long_ZERO, $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
            case 116:
                if (Long_ne(Long_and(var$11, Long_create(0, 4096)), Long_ZERO)) {
                    $this.$jjmatchedKind = 108;
                    $this.$jjmatchedPos = 9;
                } else if (Long_ne(Long_and($active3, Long_fromInt(4096)), Long_ZERO)) {
                    $this.$jjmatchedKind = 204;
                    $this.$jjmatchedPos = 9;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, var$11, Long_create(0, 8192), var$12, Long_create(0, 262144), $active3, Long_ZERO, $old4, Long_ZERO, $active4, Long_ZERO);
            default:
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 9);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa10_0($this, $old1, $active1, $old2, $active2, $old3, $active3, $old4, $active4, $old5, $active5) {
        var var$11, var$12, $$je;
        var$11 = Long_and($active1, $old1);
        $active2 = Long_and($active2, $old2);
        $old1 = Long_or(Long_or(var$11, $active2), Long_and($active3, $old3));
        $old3 = Long_and($active4, $old4);
        if (Long_eq(Long_or(Long_or($old1, $old3), Long_and($active5, $old5)), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 9);
        a: {
            try {
                var$12 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$12;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 9);
        }
        b: {
            c: {
                d: {
                    e: {
                        switch (var$12) {
                            case 69:
                                if (Long_eq(Long_and($active2, Long_create(0, 262144)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 178;
                                $this.$jjmatchedPos = 10;
                                break b;
                            case 73:
                                break;
                            case 78:
                                break d;
                            case 83:
                                if (Long_ne(Long_and(var$11, Long_create(0, 8192)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 109;
                                    $this.$jjmatchedPos = 10;
                                    break b;
                                }
                                if (Long_eq(Long_and($old3, Long_fromInt(16777216)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 280;
                                $this.$jjmatchedPos = 10;
                                break b;
                            case 84:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa11_0($this, var$11, Long_fromInt(2304), $active2, Long_ZERO, $old3, Long_create(0, 2));
                            case 101:
                                break e;
                            case 105:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa11_0($this, var$11, Long_ZERO, $active2, Long_ZERO, $old3, Long_fromInt(192));
                            case 110:
                                if (Long_ne(Long_and($old3, Long_create(0, 16777216)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 312;
                                    $this.$jjmatchedPos = 10;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa11_0($this, var$11, Long_ZERO, $active2, Long_create(0, 1), $old3, Long_create(0, 33554432));
                            case 115:
                                break c;
                            case 116:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa11_0($this, var$11, Long_fromInt(2304), $active2, Long_ZERO, $old3, Long_create(0, 2));
                            default:
                                break b;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa11_0($this, var$11, Long_ZERO, $active2, Long_ZERO, $old3, Long_fromInt(192));
                    }
                    if (Long_eq(Long_and($active2, Long_create(0, 262144)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 178;
                    $this.$jjmatchedPos = 10;
                    break b;
                }
                if (Long_ne(Long_and($old3, Long_create(0, 16777216)), Long_ZERO)) {
                    $this.$jjmatchedKind = 312;
                    $this.$jjmatchedPos = 10;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa11_0($this, var$11, Long_ZERO, $active2, Long_create(0, 1), $old3, Long_create(0, 33554432));
            }
            if (Long_ne(Long_and(var$11, Long_create(0, 8192)), Long_ZERO)) {
                $this.$jjmatchedKind = 109;
                $this.$jjmatchedPos = 10;
            } else if (Long_ne(Long_and($old3, Long_fromInt(16777216)), Long_ZERO)) {
                $this.$jjmatchedKind = 280;
                $this.$jjmatchedPos = 10;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 10);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa11_0($this, $old1, $active1, $old2, $active2, $old4, $active4) {
        var var$7, var$8, $$je;
        var$7 = Long_and($active1, $old1);
        $active2 = Long_and($active2, $old2);
        $old1 = Long_or(var$7, $active2);
        $old4 = Long_and($active4, $old4);
        if (Long_eq(Long_or($old1, $old4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 10);
        a: {
            try {
                var$8 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$8;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 10);
        }
        b: {
            c: {
                d: {
                    e: {
                        switch (var$8) {
                            case 65:
                                break;
                            case 72:
                                if (Long_eq(Long_and($old4, Long_create(0, 2)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 289;
                                $this.$jjmatchedPos = 11;
                                break b;
                            case 79:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa12_0($this, var$7, Long_fromInt(256), $active2, Long_ZERO, $old4, Long_ZERO);
                            case 80:
                                if (Long_ne(Long_and($old4, Long_fromInt(64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 262;
                                    $this.$jjmatchedPos = 11;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa12_0($this, var$7, Long_fromInt(2048), $active2, Long_ZERO, $old4, Long_fromInt(128));
                            case 83:
                                break e;
                            case 97:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa12_0($this, var$7, Long_ZERO, $active2, Long_create(0, 1), $old4, Long_ZERO);
                            case 104:
                                break d;
                            case 111:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa12_0($this, var$7, Long_fromInt(256), $active2, Long_ZERO, $old4, Long_ZERO);
                            case 112:
                                if (Long_ne(Long_and($old4, Long_fromInt(64)), Long_ZERO)) {
                                    $this.$jjmatchedKind = 262;
                                    $this.$jjmatchedPos = 11;
                                }
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa12_0($this, var$7, Long_fromInt(2048), $active2, Long_ZERO, $old4, Long_fromInt(128));
                            case 115:
                                break c;
                            default:
                                break b;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa12_0($this, var$7, Long_ZERO, $active2, Long_create(0, 1), $old4, Long_ZERO);
                    }
                    if (Long_eq(Long_and($old4, Long_create(0, 33554432)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 313;
                    $this.$jjmatchedPos = 11;
                    break b;
                }
                if (Long_eq(Long_and($old4, Long_create(0, 2)), Long_ZERO))
                    break b;
                $this.$jjmatchedKind = 289;
                $this.$jjmatchedPos = 11;
                break b;
            }
            if (Long_ne(Long_and($old4, Long_create(0, 33554432)), Long_ZERO)) {
                $this.$jjmatchedKind = 313;
                $this.$jjmatchedPos = 11;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 11);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa12_0($this, $old1, $active1, $old2, $active2, $old4, $active4) {
        var var$7, var$8, $$je;
        var$7 = Long_and($active1, $old1);
        $active2 = Long_and($active2, $old2);
        $old1 = Long_or(var$7, $active2);
        $old4 = Long_and($active4, $old4);
        if (Long_eq(Long_or($old1, $old4), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 11);
        a: {
            try {
                var$8 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$8;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 11);
        }
        b: {
            c: {
                d: {
                    e: {
                        switch (var$8) {
                            case 65:
                                break;
                            case 82:
                                if (Long_eq(Long_and(var$7, Long_fromInt(256)), Long_ZERO))
                                    break b;
                                $this.$jjmatchedKind = 72;
                                $this.$jjmatchedPos = 12;
                                break b;
                            case 83:
                                break e;
                            case 84:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa13_0($this, var$7, Long_ZERO, $active2, Long_create(0, 1), $old4, Long_ZERO);
                            case 97:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa13_0($this, var$7, Long_fromInt(2048), $active2, Long_ZERO, $old4, Long_ZERO);
                            case 114:
                                break d;
                            case 115:
                                break c;
                            case 116:
                                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa13_0($this, var$7, Long_ZERO, $active2, Long_create(0, 1), $old4, Long_ZERO);
                            default:
                                break b;
                        }
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa13_0($this, var$7, Long_fromInt(2048), $active2, Long_ZERO, $old4, Long_ZERO);
                    }
                    if (Long_eq(Long_and($old4, Long_fromInt(128)), Long_ZERO))
                        break b;
                    $this.$jjmatchedKind = 263;
                    $this.$jjmatchedPos = 12;
                    break b;
                }
                if (Long_eq(Long_and(var$7, Long_fromInt(256)), Long_ZERO))
                    break b;
                $this.$jjmatchedKind = 72;
                $this.$jjmatchedPos = 12;
                break b;
            }
            if (Long_ne(Long_and($old4, Long_fromInt(128)), Long_ZERO)) {
                $this.$jjmatchedKind = 263;
                $this.$jjmatchedPos = 12;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 12);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa13_0($this, $old1, $active1, $old2, $active2, $old4, $active4) {
        var var$7, var$8, $$je;
        var$7 = Long_and($active1, $old1);
        $old2 = Long_and($active2, $old2);
        if (Long_eq(Long_or(Long_or(var$7, $old2), Long_and($active4, $old4)), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 12);
        a: {
            try {
                var$8 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$8;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 12);
        }
        switch (var$8) {
            case 79:
                break;
            case 84:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa14_0($this, var$7, Long_fromInt(2048), $old2, Long_ZERO);
            case 111:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa14_0($this, var$7, Long_ZERO, $old2, Long_create(0, 1));
            case 116:
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa14_0($this, var$7, Long_fromInt(2048), $old2, Long_ZERO);
            default:
                return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 13);
        }
        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa14_0($this, var$7, Long_ZERO, $old2, Long_create(0, 1));
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa14_0($this, $old1, $active1, $old2, $active2) {
        var var$5, var$6, $$je;
        var$5 = Long_and($active1, $old1);
        $old2 = Long_and($active2, $old2);
        if (Long_eq(Long_or(var$5, $old2), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 13);
        a: {
            try {
                var$6 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$6;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 13);
        }
        b: {
            c: {
                switch (var$6) {
                    case 72:
                        break;
                    case 82:
                        if (Long_eq(Long_and($old2, Long_create(0, 1)), Long_ZERO))
                            break b;
                        $this.$jjmatchedKind = 160;
                        $this.$jjmatchedPos = 14;
                        break b;
                    case 104:
                        return oncipj_CypherTokenManager_jjMoveStringLiteralDfa15_0($this, var$5, Long_fromInt(2048), $old2, Long_ZERO);
                    case 114:
                        break c;
                    default:
                        break b;
                }
                return oncipj_CypherTokenManager_jjMoveStringLiteralDfa15_0($this, var$5, Long_fromInt(2048), $old2, Long_ZERO);
            }
            if (Long_ne(Long_and($old2, Long_create(0, 1)), Long_ZERO)) {
                $this.$jjmatchedKind = 160;
                $this.$jjmatchedPos = 14;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 14);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa15_0($this, $old1, $active1, $old2, $active2) {
        var var$5, $$je;
        $old1 = Long_and($active1, $old1);
        if (Long_eq(Long_or($old1, Long_and($active2, $old2)), Long_ZERO))
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 14);
        a: {
            try {
                var$5 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$5;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 14);
        }
        b: {
            c: {
                switch (var$5) {
                    case 83:
                        break;
                    case 115:
                        break c;
                    default:
                        break b;
                }
                if (Long_eq(Long_and($old1, Long_fromInt(2048)), Long_ZERO))
                    break b;
                $this.$jjmatchedKind = 75;
                $this.$jjmatchedPos = 15;
                break b;
            }
            if (Long_ne(Long_and($old1, Long_fromInt(2048)), Long_ZERO)) {
                $this.$jjmatchedKind = 75;
                $this.$jjmatchedPos = 15;
            }
        }
        return oncipj_CypherTokenManager_jjMoveNfa_0($this, 0, 15);
    }
    function oncipj_CypherTokenManager_jjMoveNfa_0($this, $startState, $curPos) {
        var $strKind, $strPos, var$5, var$6, $startsAt, $i, $kind, $toRet, $l, var$12, var$13, var$14, $i2, $i1, $hiByte, var$18, var$19, $l_0, var$21, var$22, var$23, var$24, $l1, $l2, $$je;
        $strKind = $this.$jjmatchedKind;
        $strPos = $this.$jjmatchedPos;
        var$5 = $this.$input_stream;
        $curPos = $curPos + 1 | 0;
        oncipj_CypherCharStream_backup(var$5, $curPos);
        a: {
            try {
                $this.$curChar = oncipj_CypherCharStream_readChar($this.$input_stream);
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            $rt_throw(jl_Error__init_($rt_s(978)));
        }
        var$6 = 0;
        $startsAt = 0;
        $this.$jjnewStateCnt = 74;
        $i = 1;
        $this.$jjstateSet.data[0] = $startState;
        $kind = 2147483647;
        b: {
            while (true) {
                $startState = $this.$jjround + 1 | 0;
                $this.$jjround = $startState;
                if ($startState == 2147483647)
                    oncipj_CypherTokenManager_ReInitRounds($this);
                $toRet = $this.$curChar;
                if ($toRet < 64) {
                    $l = Long_shl(Long_fromInt(1), $toRet);
                    var$12 = Long_compare(Long_and(Long_create(268419583, 67043344), $l), Long_ZERO);
                    var$13 = Long_compare(Long_and(Long_create(4294967295, 4294934527), $l), Long_ZERO);
                    var$14 = Long_compare(Long_and(Long_fromInt(9216), $l), Long_ZERO);
                    $i2 = Long_compare(Long_and(Long_fromInt(-9217), $l), Long_ZERO);
                    $i1 = Long_compare(Long_and(Long_create(0, 67043328), $l), Long_ZERO);
                    $hiByte = Long_compare(Long_and(Long_create(0, 10240), $l), Long_ZERO);
                    var$18 = Long_compare(Long_and(Long_create(0, 66977792), $l), Long_ZERO);
                    while (true) {
                        c: {
                            var$19 = $this.$jjstateSet.data;
                            $i = $i + (-1) | 0;
                            switch (var$19[$i]) {
                                case 0:
                                    if ($i1)
                                        oncipj_CypherTokenManager_jjCheckNAddStates($this, 0, 5);
                                    else {
                                        $startState = $this.$curChar;
                                        if ($startState == 47)
                                            oncipj_CypherTokenManager_jjAddStates($this, 6, 7);
                                        else if ($startState == 45) {
                                            if ($kind > 344)
                                                $kind = 344;
                                        } else if ($startState == 46)
                                            oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 1, 2);
                                    }
                                    if (var$18) {
                                        if ($kind > 36)
                                            $kind = 36;
                                        oncipj_CypherTokenManager_jjCheckNAddStates($this, 8, 10);
                                        break c;
                                    }
                                    if ($this.$curChar != 48)
                                        break c;
                                    if ($kind > 36)
                                        $kind = 36;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 11, 13);
                                    break c;
                                case 2:
                                    if (!$i1)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 14, 17);
                                    break c;
                                case 4:
                                    if (!$hiByte)
                                        break c;
                                    oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 5, 6);
                                    break c;
                                case 6:
                                    if (!$i1)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 18, 21);
                                    break c;
                                case 7:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 7, 8);
                                    break c;
                                case 9:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 9;
                                    break c;
                                case 10:
                                    if (!var$18)
                                        break c;
                                    if ($kind > 36)
                                        $kind = 36;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 8, 10);
                                    break c;
                                case 12:
                                    if (!$i1)
                                        break c;
                                    if ($kind > 36)
                                        $kind = 36;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 8, 10);
                                    break c;
                                case 13:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 36)
                                        $kind = 36;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 13);
                                    break c;
                                case 34:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 341)
                                        $kind = 341;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 34;
                                    break c;
                                case 35:
                                    if ($this.$curChar != 45)
                                        break c;
                                    if ($kind <= 344)
                                        break c;
                                    $kind = 344;
                                    break c;
                                case 38:
                                    if (!$i1)
                                        break c;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 0, 5);
                                    break c;
                                case 39:
                                    if (!$i1)
                                        break c;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 22, 24);
                                    break c;
                                case 40:
                                    if ($this.$curChar != 46)
                                        break c;
                                    oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 41, 42);
                                    break c;
                                case 42:
                                    if (!$i1)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 25, 28);
                                    break c;
                                case 44:
                                    if (!$hiByte)
                                        break c;
                                    oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 45, 46);
                                    break c;
                                case 46:
                                    if (!$i1)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 29, 32);
                                    break c;
                                case 47:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 47, 48);
                                    break c;
                                case 49:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 49;
                                    break c;
                                case 52:
                                    if (!$i1)
                                        break c;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 33, 35);
                                    break c;
                                case 54:
                                    if (!$hiByte)
                                        break c;
                                    oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 55, 56);
                                    break c;
                                case 56:
                                    if (!$i1)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 36, 39);
                                    break c;
                                case 57:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, 57, 58);
                                    break c;
                                case 59:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 35)
                                        $kind = 35;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 59;
                                    break c;
                                case 60:
                                    if ($this.$curChar != 47)
                                        break c;
                                    oncipj_CypherTokenManager_jjAddStates($this, 6, 7);
                                    break c;
                                case 61:
                                    if ($this.$curChar != 47)
                                        break c;
                                    if ($kind > 29)
                                        $kind = 29;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 40, 42);
                                    break c;
                                case 62:
                                    if (!$i2)
                                        break c;
                                    if ($kind > 29)
                                        $kind = 29;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 40, 42);
                                    break c;
                                case 63:
                                    if (!var$14)
                                        break c;
                                    if ($kind <= 29)
                                        break c;
                                    $kind = 29;
                                    break c;
                                case 64:
                                    if ($this.$curChar != 10)
                                        break c;
                                    if ($kind <= 29)
                                        break c;
                                    $kind = 29;
                                    break c;
                                case 65:
                                    if ($this.$curChar != 13)
                                        break c;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 64;
                                    break c;
                                case 66:
                                    if ($this.$curChar != 42)
                                        break c;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 67;
                                    break c;
                                case 67:
                                    if (!var$13)
                                        break c;
                                    if ($kind <= 30)
                                        break c;
                                    $kind = 30;
                                    break c;
                                case 68:
                                    if ($this.$curChar != 42)
                                        break c;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 66;
                                    break c;
                                case 69:
                                    if ($this.$curChar != 48)
                                        break c;
                                    if ($kind > 36)
                                        $kind = 36;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 11, 13);
                                    break c;
                                case 71:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 39)
                                        $kind = 39;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 71;
                                    break c;
                                case 73:
                                    if (!var$12)
                                        break c;
                                    if ($kind > 40)
                                        $kind = 40;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 73);
                                    break c;
                                case 1:
                                case 3:
                                case 5:
                                case 8:
                                case 11:
                                case 14:
                                case 15:
                                case 16:
                                case 17:
                                case 18:
                                case 19:
                                case 20:
                                case 21:
                                case 22:
                                case 23:
                                case 24:
                                case 25:
                                case 26:
                                case 27:
                                case 28:
                                case 29:
                                case 30:
                                case 31:
                                case 32:
                                case 33:
                                case 36:
                                case 37:
                                case 41:
                                case 43:
                                case 45:
                                case 48:
                                case 50:
                                case 51:
                                case 53:
                                case 55:
                                case 58:
                                case 70:
                                case 72:
                                    break;
                                default:
                            }
                        }
                        if ($i == $startsAt)
                            break;
                    }
                } else if ($toRet < 128) {
                    $l_0 = Long_shl(Long_fromInt(1), $toRet & 63);
                    $i1 = Long_compare(Long_and(Long_create(2281701374, 2281701374), $l_0), Long_ZERO);
                    $hiByte = Long_compare(Long_and(Long_create(16777216, 16777216), $l_0), Long_ZERO);
                    var$13 = Long_compare(Long_and(Long_create(2281701374, 134217726), $l_0), Long_ZERO);
                    var$14 = Long_compare(Long_and(Long_create(32, 32), $l_0), Long_ZERO);
                    $i2 = Long_compare(Long_and(Long_create(16, 16), $l_0), Long_ZERO);
                    var$21 = Long_compare(Long_and(Long_create(524288, 524288), $l_0), Long_ZERO);
                    var$22 = Long_compare(Long_and(Long_create(16384, 16384), $l_0), Long_ZERO);
                    var$23 = Long_compare(Long_and(Long_create(512, 512), $l_0), Long_ZERO);
                    var$24 = Long_compare(Long_and(Long_create(128, 128), $l_0), Long_ZERO);
                    var$18 = Long_compare(Long_and(Long_create(8, 8), $l_0), Long_ZERO);
                    var$12 = Long_compare(Long_and(Long_create(2, 2), $l_0), Long_ZERO);
                    while (true) {
                        d: {
                            var$19 = $this.$jjstateSet.data;
                            $i = $i + (-1) | 0;
                            switch (var$19[$i]) {
                                case 0:
                                    if (var$13) {
                                        if ($kind > 341)
                                            $kind = 341;
                                        oncipj_CypherTokenManager_jjCheckNAdd($this, 34);
                                    }
                                    if ($i2) {
                                        var$19 = $this.$jjstateSet.data;
                                        $startState = $this.$jjnewStateCnt;
                                        $this.$jjnewStateCnt = $startState + 1 | 0;
                                        var$19[$startState] = 31;
                                        break d;
                                    }
                                    if (!var$12)
                                        break d;
                                    var$19 = $this.$jjstateSet.data;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 21;
                                    break d;
                                case 1:
                                    if ($this.$curChar != 95)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 2;
                                    break d;
                                case 3:
                                    if (!var$14)
                                        break d;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 43, 45);
                                    break d;
                                case 5:
                                    if ($this.$curChar != 95)
                                        break d;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 6);
                                    break d;
                                case 7:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjAddStates($this, 46, 47);
                                    break d;
                                case 8:
                                    if (!var$13)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 9);
                                    break d;
                                case 9:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 9);
                                    break d;
                                case 11:
                                    if ($this.$curChar != 95)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 12;
                                    break d;
                                case 13:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 36)
                                        $kind = 36;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 13;
                                    break d;
                                case 14:
                                    if (!var$18)
                                        break d;
                                    if ($kind > 82)
                                        $kind = 82;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 20;
                                    break d;
                                case 15:
                                    if (!var$24)
                                        break d;
                                    if ($kind <= 82)
                                        break d;
                                    $kind = 82;
                                    break d;
                                case 16:
                                    if (!var$22)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 15;
                                    break d;
                                case 17:
                                    if (!var$23)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 16;
                                    break d;
                                case 18:
                                    if (!$i2)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 17;
                                    break d;
                                case 19:
                                    if (!var$22)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 18;
                                    break d;
                                case 20:
                                    if (!var$14)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 19;
                                    break d;
                                case 21:
                                    if (!var$21)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 14;
                                    break d;
                                case 22:
                                    if (!var$12)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 21;
                                    break d;
                                case 23:
                                    if (!var$18)
                                        break d;
                                    if ($kind > 128)
                                        $kind = 128;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 29;
                                    break d;
                                case 24:
                                    if (!var$24)
                                        break d;
                                    if ($kind <= 128)
                                        break d;
                                    $kind = 128;
                                    break d;
                                case 25:
                                    if (!var$22)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 24;
                                    break d;
                                case 26:
                                    if (!var$23)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 25;
                                    break d;
                                case 27:
                                    if (!$i2)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 26;
                                    break d;
                                case 28:
                                    if (!var$22)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 27;
                                    break d;
                                case 29:
                                    if (!var$14)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 28;
                                    break d;
                                case 30:
                                    if (!var$21)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 23;
                                    break d;
                                case 31:
                                    if (!var$14)
                                        break d;
                                    $toRet = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $toRet + 1 | 0;
                                    var$19[$toRet] = 30;
                                    break d;
                                case 32:
                                    if (!$i2)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 31;
                                    break d;
                                case 33:
                                    if (!var$13)
                                        break d;
                                    if ($kind > 341)
                                        $kind = 341;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 34);
                                    break d;
                                case 34:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 341)
                                        $kind = 341;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 34);
                                    break d;
                                case 41:
                                    if ($this.$curChar != 95)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 42;
                                    break d;
                                case 43:
                                    if (!var$14)
                                        break d;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 48, 50);
                                    break d;
                                case 45:
                                    if ($this.$curChar != 95)
                                        break d;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 46);
                                    break d;
                                case 47:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjAddStates($this, 51, 52);
                                    break d;
                                case 48:
                                    if (!var$13)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 49);
                                    break d;
                                case 49:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 49);
                                    break d;
                                case 50:
                                    if ($this.$curChar != 95)
                                        break d;
                                    oncipj_CypherTokenManager_jjAddStates($this, 53, 54);
                                    break d;
                                case 51:
                                    if ($this.$curChar != 95)
                                        break d;
                                    $startState = $this.$jjnewStateCnt;
                                    $this.$jjnewStateCnt = $startState + 1 | 0;
                                    var$19[$startState] = 52;
                                    break d;
                                case 53:
                                    if (!var$14)
                                        break d;
                                    oncipj_CypherTokenManager_jjCheckNAddStates($this, 55, 57);
                                    break d;
                                case 55:
                                    if ($this.$curChar != 95)
                                        break d;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 56);
                                    break d;
                                case 57:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjAddStates($this, 58, 59);
                                    break d;
                                case 58:
                                    if (!var$13)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 59);
                                    break d;
                                case 59:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 35)
                                        $kind = 35;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 59);
                                    break d;
                                case 62:
                                    if ($kind > 29)
                                        $kind = 29;
                                    oncipj_CypherTokenManager_jjAddStates($this, 40, 42);
                                    break d;
                                case 67:
                                    if ($kind <= 30)
                                        break d;
                                    $kind = 30;
                                    break d;
                                case 70:
                                    if (!$hiByte)
                                        break d;
                                    if ($kind > 39)
                                        $kind = 39;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 71);
                                    break d;
                                case 71:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 39)
                                        $kind = 39;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 71);
                                    break d;
                                case 72:
                                    if ($this.$curChar != 111)
                                        break d;
                                    if ($kind > 40)
                                        $kind = 40;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 73);
                                    break d;
                                case 73:
                                    if (!$i1)
                                        break d;
                                    if ($kind > 40)
                                        $kind = 40;
                                    oncipj_CypherTokenManager_jjCheckNAdd($this, 73);
                                    break d;
                                case 2:
                                case 4:
                                case 6:
                                case 10:
                                case 12:
                                case 35:
                                case 36:
                                case 37:
                                case 38:
                                case 39:
                                case 40:
                                case 42:
                                case 44:
                                case 46:
                                case 52:
                                case 54:
                                case 56:
                                case 60:
                                case 61:
                                case 63:
                                case 64:
                                case 65:
                                case 66:
                                case 68:
                                case 69:
                                    break;
                                default:
                            }
                        }
                        if ($i == $startsAt)
                            break;
                    }
                } else {
                    $hiByte = $toRet >> 8;
                    $i1 = $hiByte >> 6;
                    $l1 = Long_shl(Long_fromInt(1), $hiByte & 63);
                    $i2 = ($toRet & 255) >> 6;
                    $l2 = Long_shl(Long_fromInt(1), $toRet & 63);
                    var$14 = Long_compare($l1, Long_ZERO);
                    var$13 = Long_compare($l2, Long_ZERO);
                    while (true) {
                        e: {
                            f: {
                                g: {
                                    var$19 = $this.$jjstateSet.data;
                                    $i = $i + (-1) | 0;
                                    switch (var$19[$i]) {
                                        case 0:
                                            break f;
                                        case 1:
                                        case 2:
                                        case 3:
                                        case 4:
                                        case 5:
                                        case 6:
                                        case 10:
                                        case 11:
                                        case 12:
                                        case 14:
                                        case 15:
                                        case 16:
                                        case 17:
                                        case 18:
                                        case 19:
                                        case 20:
                                        case 21:
                                        case 22:
                                        case 23:
                                        case 24:
                                        case 25:
                                        case 26:
                                        case 27:
                                        case 28:
                                        case 29:
                                        case 30:
                                        case 31:
                                        case 32:
                                        case 38:
                                        case 39:
                                        case 40:
                                        case 41:
                                        case 42:
                                        case 43:
                                        case 44:
                                        case 45:
                                        case 46:
                                        case 50:
                                        case 51:
                                        case 52:
                                        case 53:
                                        case 54:
                                        case 55:
                                        case 56:
                                        case 60:
                                        case 61:
                                        case 63:
                                        case 64:
                                        case 65:
                                        case 66:
                                        case 68:
                                        case 69:
                                        case 70:
                                        case 72:
                                            break g;
                                        case 7:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjAddStates($this, 46, 47);
                                            break e;
                                        case 8:
                                            if (!oncipj_CypherTokenManager_jjCanMove_1($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 9);
                                            break e;
                                        case 9:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 9);
                                            break e;
                                        case 13:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 36)
                                                $kind = 36;
                                            var$19 = $this.$jjstateSet.data;
                                            $toRet = $this.$jjnewStateCnt;
                                            $this.$jjnewStateCnt = $toRet + 1 | 0;
                                            var$19[$toRet] = 13;
                                            break e;
                                        case 33:
                                            if (!oncipj_CypherTokenManager_jjCanMove_1($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 341)
                                                $kind = 341;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 34);
                                            break e;
                                        case 34:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 341)
                                                $kind = 341;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 34);
                                            break e;
                                        case 35:
                                            break;
                                        case 36:
                                            if (!oncipj_CypherTokenManager_jjCanMove_3($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind <= 345)
                                                break e;
                                            $kind = 345;
                                            break e;
                                        case 37:
                                            if (!oncipj_CypherTokenManager_jjCanMove_4($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind <= 346)
                                                break e;
                                            $kind = 346;
                                            break e;
                                        case 47:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjAddStates($this, 51, 52);
                                            break e;
                                        case 48:
                                            if (!oncipj_CypherTokenManager_jjCanMove_1($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 49);
                                            break e;
                                        case 49:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 49);
                                            break e;
                                        case 57:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjAddStates($this, 58, 59);
                                            break e;
                                        case 58:
                                            if (!oncipj_CypherTokenManager_jjCanMove_1($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 59);
                                            break e;
                                        case 59:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 35)
                                                $kind = 35;
                                            oncipj_CypherTokenManager_jjCheckNAdd($this, 59);
                                            break e;
                                        case 62:
                                            if (!oncipj_CypherTokenManager_jjCanMove_5($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 29)
                                                $kind = 29;
                                            oncipj_CypherTokenManager_jjAddStates($this, 40, 42);
                                            break e;
                                        case 67:
                                            if (!oncipj_CypherTokenManager_jjCanMove_5($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind <= 30)
                                                break e;
                                            $kind = 30;
                                            break e;
                                        case 71:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 39)
                                                $kind = 39;
                                            var$19 = $this.$jjstateSet.data;
                                            $startState = $this.$jjnewStateCnt;
                                            $this.$jjnewStateCnt = $startState + 1 | 0;
                                            var$19[$startState] = 71;
                                            break e;
                                        case 73:
                                            if (!oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2))
                                                break e;
                                            if ($kind > 40)
                                                $kind = 40;
                                            var$19 = $this.$jjstateSet.data;
                                            $startState = $this.$jjnewStateCnt;
                                            $this.$jjnewStateCnt = $startState + 1 | 0;
                                            var$19[$startState] = 73;
                                            break e;
                                        default:
                                            break g;
                                    }
                                    if (!oncipj_CypherTokenManager_jjCanMove_2($hiByte, $i1, $i2, $l1, $l2))
                                        break e;
                                    if ($kind <= 344)
                                        break e;
                                    $kind = 344;
                                    break e;
                                }
                                if (!$i1)
                                    break e;
                                if (!var$14)
                                    break e;
                                if (!$i2)
                                    break e;
                                break e;
                            }
                            if (oncipj_CypherTokenManager_jjCanMove_1($hiByte, $i1, $i2, $l1, $l2)) {
                                if ($kind > 341)
                                    $kind = 341;
                                oncipj_CypherTokenManager_jjCheckNAdd($this, 34);
                            }
                            if (oncipj_CypherTokenManager_jjCanMove_2($hiByte, $i1, $i2, $l1, $l2) && $kind > 344)
                                $kind = 344;
                            if (oncipj_CypherTokenManager_jjCanMove_3($hiByte, $i1, $i2, $l1, $l2) && $kind > 345)
                                $kind = 345;
                            if (oncipj_CypherTokenManager_jjCanMove_4($hiByte, $i1, $i2, $l1, $l2) && $kind > 346)
                                $kind = 346;
                        }
                        if ($i == $startsAt)
                            break;
                    }
                }
                if ($kind != 2147483647) {
                    $this.$jjmatchedKind = $kind;
                    $this.$jjmatchedPos = var$6;
                    $kind = 2147483647;
                }
                var$6 = var$6 + 1 | 0;
                $i = $this.$jjnewStateCnt;
                $this.$jjnewStateCnt = $startsAt;
                $startsAt = 74 - $startsAt | 0;
                if ($i == $startsAt)
                    break;
                try {
                    $this.$curChar = oncipj_CypherCharStream_readChar($this.$input_stream);
                    continue;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    if ($$je instanceof ji_IOException) {
                        break b;
                    } else {
                        throw $$e;
                    }
                }
            }
        }
        if ($this.$jjmatchedPos > $strPos)
            return var$6;
        h: {
            $toRet = jl_Math_max(var$6, $curPos);
            if (var$6 < $toRet) {
                $startState = $toRet - jl_Math_min(var$6, $curPos) | 0;
                while (true) {
                    $curPos = $startState + (-1) | 0;
                    if ($startState <= 0)
                        break h;
                    try {
                        $this.$curChar = oncipj_CypherCharStream_readChar($this.$input_stream);
                        $startState = $curPos;
                        continue;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof ji_IOException) {
                            break;
                        } else {
                            throw $$e;
                        }
                    }
                }
                $rt_throw(jl_Error__init_($rt_s(979)));
            }
        }
        $startState = $rt_compare($this.$jjmatchedPos, $strPos);
        if ($startState < 0) {
            $this.$jjmatchedKind = $strKind;
            $this.$jjmatchedPos = $strPos;
        } else if (!$startState && $this.$jjmatchedKind > $strKind)
            $this.$jjmatchedKind = $strKind;
        return $toRet;
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_1($this) {
        var var$1, $$je;
        switch ($this.$curChar) {
            case 42:
                a: {
                    b: {
                        try {
                            var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                            $this.$curChar = var$1;
                            break b;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof ji_IOException) {
                            } else {
                                throw $$e;
                            }
                        }
                        var$1 = 1;
                        break a;
                    }
                    switch (var$1) {
                        case 47:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 32);
                            break a;
                        default:
                    }
                    var$1 = 2;
                }
                return var$1;
            default:
        }
        return 1;
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_2($this) {
        var var$1, $$je;
        switch ($this.$curChar) {
            case 42:
                a: {
                    b: {
                        try {
                            var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                            $this.$curChar = var$1;
                            break b;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof ji_IOException) {
                            } else {
                                throw $$e;
                            }
                        }
                        var$1 = 1;
                        break a;
                    }
                    switch (var$1) {
                        case 47:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 33);
                            break a;
                        default:
                    }
                    var$1 = 2;
                }
                return var$1;
            default:
        }
        return 1;
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_3($this) {
        return 1;
    }
    function oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, $pos, $active0) {
        switch ($pos) {
            case 0:
                if (Long_eq(Long_and($active0, Long_create(0, 523264)), Long_ZERO))
                    return (-1);
                $this.$jjmatchedKind = 51;
                return (-1);
            case 1:
                if (Long_eq(Long_and($active0, Long_create(0, 523264)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 2:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 3:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 4:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 5:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 6:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 7:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 8:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 9:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 10:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 11:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 12:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 13:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 14:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 15:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 16:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 17:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 18:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 19:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 20:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 21:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 22:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 23:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 24:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 25:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 26:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 27:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 28:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 29:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 30:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 31:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 32:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 33:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 34:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 35:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 36:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 37:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 38:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 39:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 40:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 41:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 42:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 43:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 44:
                if (Long_eq(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 51;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            default:
        }
        return (-1);
    }
    function oncipj_CypherTokenManager_jjStartNfa_4($this, $pos, $active0) {
        return oncipj_CypherTokenManager_jjMoveNfa_4($this, oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, $pos, $active0), $pos + 1 | 0);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_4($this) {
        var var$1, $$je;
        switch ($this.$curChar) {
            case 39:
                break;
            case 92:
                a: {
                    b: {
                        try {
                            var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                            $this.$curChar = var$1;
                            break b;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof ji_IOException) {
                            } else {
                                throw $$e;
                            }
                        }
                        oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 0, Long_create(0, 523264));
                        var$1 = 1;
                        break a;
                    }
                    switch (var$1) {
                        case 34:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 44);
                            break a;
                        case 39:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 43);
                            break a;
                        case 92:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 42);
                            break a;
                        case 98:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 45);
                            break a;
                        case 102:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 46);
                            break a;
                        case 110:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 47);
                            break a;
                        case 114:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 48);
                            break a;
                        case 116:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 49);
                            break a;
                        case 117:
                            c: {
                                d: {
                                    try {
                                        var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                        $this.$curChar = var$1;
                                        break d;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof ji_IOException) {
                                        } else {
                                            throw $$e;
                                        }
                                    }
                                    oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 1, Long_create(0, 262144));
                                    var$1 = 2;
                                    break c;
                                }
                                switch (var$1) {
                                    case 91:
                                        e: {
                                            f: {
                                                try {
                                                    var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                    $this.$curChar = var$1;
                                                    break f;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof ji_IOException) {
                                                    } else {
                                                        throw $$e;
                                                    }
                                                }
                                                oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 2, Long_create(0, 262144));
                                                var$1 = 3;
                                                break e;
                                            }
                                            switch (var$1) {
                                                case 48:
                                                    g: {
                                                        h: {
                                                            try {
                                                                var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$1;
                                                                break h;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 3, Long_create(0, 262144));
                                                            var$1 = 4;
                                                            break g;
                                                        }
                                                        switch (var$1) {
                                                            case 45:
                                                                i: {
                                                                    j: {
                                                                        try {
                                                                            var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                            $this.$curChar = var$1;
                                                                            break j;
                                                                        } catch ($$e) {
                                                                            $$je = $rt_wrapException($$e);
                                                                            if ($$je instanceof ji_IOException) {
                                                                            } else {
                                                                                throw $$e;
                                                                            }
                                                                        }
                                                                        oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 4, Long_create(0, 262144));
                                                                        var$1 = 5;
                                                                        break i;
                                                                    }
                                                                    switch (var$1) {
                                                                        case 57:
                                                                            k: {
                                                                                l: {
                                                                                    try {
                                                                                        var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                        $this.$curChar = var$1;
                                                                                        break l;
                                                                                    } catch ($$e) {
                                                                                        $$je = $rt_wrapException($$e);
                                                                                        if ($$je instanceof ji_IOException) {
                                                                                        } else {
                                                                                            throw $$e;
                                                                                        }
                                                                                    }
                                                                                    oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 5, Long_create(0, 262144));
                                                                                    var$1 = 6;
                                                                                    break k;
                                                                                }
                                                                                switch (var$1) {
                                                                                    case 97:
                                                                                        m: {
                                                                                            n: {
                                                                                                try {
                                                                                                    var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                    $this.$curChar = var$1;
                                                                                                    break n;
                                                                                                } catch ($$e) {
                                                                                                    $$je = $rt_wrapException($$e);
                                                                                                    if ($$je instanceof ji_IOException) {
                                                                                                    } else {
                                                                                                        throw $$e;
                                                                                                    }
                                                                                                }
                                                                                                oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 6, Long_create(0, 262144));
                                                                                                var$1 = 7;
                                                                                                break m;
                                                                                            }
                                                                                            switch (var$1) {
                                                                                                case 45:
                                                                                                    o: {
                                                                                                        p: {
                                                                                                            try {
                                                                                                                var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$1;
                                                                                                                break p;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 7, Long_create(0, 262144));
                                                                                                            var$1 = 8;
                                                                                                            break o;
                                                                                                        }
                                                                                                        switch (var$1) {
                                                                                                            case 102:
                                                                                                                break;
                                                                                                            default:
                                                                                                                var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 7, Long_create(0, 262144));
                                                                                                                break o;
                                                                                                        }
                                                                                                        var$1 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_4($this, Long_create(0, 262144), Long_create(0, 262144));
                                                                                                    }
                                                                                                    break m;
                                                                                                default:
                                                                                            }
                                                                                            var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 6, Long_create(0, 262144));
                                                                                        }
                                                                                        break k;
                                                                                    default:
                                                                                }
                                                                                var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 5, Long_create(0, 262144));
                                                                            }
                                                                            break i;
                                                                        default:
                                                                    }
                                                                    var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 4, Long_create(0, 262144));
                                                                }
                                                                break g;
                                                            default:
                                                        }
                                                        var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 3, Long_create(0, 262144));
                                                    }
                                                    break e;
                                                default:
                                            }
                                            var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 2, Long_create(0, 262144));
                                        }
                                        break c;
                                    default:
                                }
                                var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 1, Long_create(0, 262144));
                            }
                            break a;
                        default:
                    }
                    var$1 = oncipj_CypherTokenManager_jjStartNfa_4($this, 0, Long_create(0, 523264));
                }
                return var$1;
            default:
                return oncipj_CypherTokenManager_jjMoveNfa_4($this, 0, 0);
        }
        return oncipj_CypherTokenManager_jjStopAtPos($this, 0, 52);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_4($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_4($this, 7, $old0);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 8, $active0);
            return 9;
        }
        switch (var$3) {
            case 65:
                b: {
                    var$4 = Long_and(Long_create(0, 262144), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 8, $active0);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 9, var$4);
                            var$3 = 10;
                            break b;
                        }
                        switch (var$3) {
                            case 45:
                                d: {
                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 9, var$4);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 10, $active0);
                                            var$3 = 11;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 70:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 10, $active0);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 11, var$4);
                                                            var$3 = 12;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 93:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 11, var$4);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 12, $active0);
                                                                            var$3 = 13;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 91:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 12, $active0);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 13, var$4);
                                                                                            var$3 = 14;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 48:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 13, var$4);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 14, $active0);
                                                                                                            var$3 = 15;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 45:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 14, $active0);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 15, var$4);
                                                                                                                            var$3 = 16;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 57:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 15, var$4);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 16, $active0);
                                                                                                                                            var$3 = 17;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 97:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 16, $active0);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa18_4($this, $active0, Long_create(0, 262144));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 15, var$4);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 14, $active0);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 13, var$4);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 12, $active0);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 11, var$4);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 10, $active0);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 9, var$4);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_4($this, 8, $active0);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa18_4($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_4($this, 16, $old0);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 17, $active0);
            return 18;
        }
        switch (var$3) {
            case 45:
                b: {
                    var$4 = Long_and(Long_create(0, 262144), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 17, $active0);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 18, var$4);
                            var$3 = 19;
                            break b;
                        }
                        switch (var$3) {
                            case 102:
                                d: {
                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 18, var$4);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 19, $active0);
                                            var$3 = 20;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 65:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 19, $active0);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 20, var$4);
                                                            var$3 = 21;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 45:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 20, var$4);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 21, $active0);
                                                                            var$3 = 22;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 70:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 21, $active0);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 22, var$4);
                                                                                            var$3 = 23;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 93:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 22, var$4);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 23, $active0);
                                                                                                            var$3 = 24;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 91:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 23, $active0);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 24, var$4);
                                                                                                                            var$3 = 25;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 48:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 24, var$4);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 25, $active0);
                                                                                                                                            var$3 = 26;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 45:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 25, $active0);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa27_4($this, $active0, Long_create(0, 262144));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 24, var$4);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 23, $active0);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 22, var$4);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 21, $active0);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 20, var$4);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 19, $active0);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 18, var$4);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_4($this, 17, $active0);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa27_4($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_4($this, 25, $old0);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 26, $active0);
            return 27;
        }
        switch (var$3) {
            case 57:
                b: {
                    var$4 = Long_and(Long_create(0, 262144), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 26, $active0);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 27, var$4);
                            var$3 = 28;
                            break b;
                        }
                        switch (var$3) {
                            case 97:
                                d: {
                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 27, var$4);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 28, $active0);
                                            var$3 = 29;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 45:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 28, $active0);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 29, var$4);
                                                            var$3 = 30;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 102:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 29, var$4);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 30, $active0);
                                                                            var$3 = 31;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 65:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 30, $active0);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 31, var$4);
                                                                                            var$3 = 32;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 45:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 31, var$4);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 32, $active0);
                                                                                                            var$3 = 33;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 70:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 32, $active0);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 33, var$4);
                                                                                                                            var$3 = 34;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 93:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 33, var$4);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 34, $active0);
                                                                                                                                            var$3 = 35;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 91:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 34, $active0);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa36_4($this, $active0, Long_create(0, 262144));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 33, var$4);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 32, $active0);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 31, var$4);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 30, $active0);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 29, var$4);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 28, $active0);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 27, var$4);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_4($this, 26, $active0);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa36_4($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_4($this, 34, $old0);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 35, $active0);
            return 36;
        }
        switch (var$3) {
            case 48:
                b: {
                    var$4 = Long_and(Long_create(0, 262144), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 35, $active0);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 36, var$4);
                            var$3 = 37;
                            break b;
                        }
                        switch (var$3) {
                            case 45:
                                d: {
                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 36, var$4);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 37, $active0);
                                            var$3 = 38;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 57:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 37, $active0);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 38, var$4);
                                                            var$3 = 39;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 97:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 38, var$4);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 39, $active0);
                                                                            var$3 = 40;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 45:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 39, $active0);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 40, var$4);
                                                                                            var$3 = 41;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 102:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 40, var$4);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 41, $active0);
                                                                                                            var$3 = 42;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 65:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 262144), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 41, $active0);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 42, var$4);
                                                                                                                            var$3 = 43;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 45:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 262144), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 42, var$4);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 43, $active0);
                                                                                                                                            var$3 = 44;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 70:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 43, $active0);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa45_4($this, $active0, Long_create(0, 262144));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 42, var$4);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 41, $active0);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 40, var$4);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 39, $active0);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 38, var$4);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 37, $active0);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_4($this, 36, var$4);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_4($this, 35, $active0);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa45_4($this, $old0, $active0) {
        var var$3, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_4($this, 43, $old0);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_4($this, 44, $active0);
            return 45;
        }
        b: {
            switch (var$3) {
                case 93:
                    break;
                default:
                    break b;
            }
            if (Long_ne(Long_and($active0, Long_create(0, 262144)), Long_ZERO))
                return oncipj_CypherTokenManager_jjStopAtPos($this, 45, 50);
        }
        return oncipj_CypherTokenManager_jjStartNfa_4($this, 44, $active0);
    }
    function oncipj_CypherTokenManager_jjMoveNfa_4($this, $startState, $curPos) {
        var $startsAt, $i, $kind, var$6, $i1, var$8, $hiByte, $l1, $i2, $l2, var$13, $$je;
        $startsAt = 0;
        $this.$jjnewStateCnt = 1;
        $i = 1;
        $this.$jjstateSet.data[0] = $startState;
        $kind = 2147483647;
        while (true) {
            $startState = $this.$jjround + 1 | 0;
            $this.$jjround = $startState;
            if ($startState == 2147483647)
                oncipj_CypherTokenManager_ReInitRounds($this);
            var$6 = $this.$curChar;
            if (var$6 < 64) {
                $i1 = Long_compare(Long_and(Long_create(4294967295, 4294967167), Long_shl(Long_fromInt(1), var$6)), Long_ZERO);
                while (true) {
                    a: {
                        var$8 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$8[$i]) {
                            case 0:
                                if (!$i1)
                                    break a;
                                $kind = 51;
                                break a;
                            default:
                        }
                    }
                    if ($i == $startsAt)
                        break;
                }
            } else if (var$6 < 128)
                while (true) {
                    b: {
                        var$8 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$8[$i]) {
                            case 0:
                                $kind = 51;
                                break b;
                            default:
                        }
                    }
                    if ($i == $startsAt)
                        break;
                }
            else {
                $hiByte = var$6 >> 8;
                $i1 = $hiByte >> 6;
                $l1 = Long_shl(Long_fromInt(1), $hiByte & 63);
                $i2 = (var$6 & 255) >> 6;
                $l2 = Long_shl(Long_fromInt(1), var$6 & 63);
                var$6 = Long_compare($l1, Long_ZERO);
                var$13 = Long_compare($l2, Long_ZERO);
                while (true) {
                    c: {
                        var$8 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$8[$i]) {
                            case 0:
                                break;
                            default:
                                if (!$i1)
                                    break c;
                                if (!var$6)
                                    break c;
                                if (!$i2)
                                    break c;
                                break c;
                        }
                        if (oncipj_CypherTokenManager_jjCanMove_5($hiByte, $i1, $i2, $l1, $l2) && $kind > 51)
                            $kind = 51;
                    }
                    if ($i == $startsAt)
                        break;
                }
            }
            if ($kind != 2147483647) {
                $this.$jjmatchedKind = $kind;
                $this.$jjmatchedPos = $curPos;
                $kind = 2147483647;
            }
            $curPos = $curPos + 1 | 0;
            $i = $this.$jjnewStateCnt;
            $this.$jjnewStateCnt = $startsAt;
            $startsAt = 1 - $startsAt | 0;
            if ($i == $startsAt)
                break;
            try {
                $this.$curChar = oncipj_CypherCharStream_readChar($this.$input_stream);
                continue;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                    return $curPos;
                } else {
                    throw $$e;
                }
            }
        }
        return $curPos;
    }
    function oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, $pos, $active0, $active1) {
        switch ($pos) {
            case 0:
                if (Long_eq(Long_and($active0, Long_create(0, 2143289344)), Long_ZERO))
                    return (-1);
                $this.$jjmatchedKind = 63;
                return (-1);
            case 1:
                if (Long_eq(Long_and($active0, Long_create(0, 2143289344)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 2:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 3:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 4:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 5:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 6:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 7:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 8:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 9:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 10:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 11:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 12:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 13:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 14:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 15:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 16:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 17:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 18:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 19:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 20:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 21:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 22:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 23:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 24:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 25:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 26:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 27:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 28:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 29:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 30:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 31:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 32:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 33:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 34:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 35:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 36:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 37:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 38:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 39:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 40:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 41:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 42:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 43:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            case 44:
                if (Long_eq(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                    return (-1);
                if (!$this.$jjmatchedPos) {
                    $this.$jjmatchedKind = 63;
                    $this.$jjmatchedPos = 0;
                }
                return (-1);
            default:
        }
        return (-1);
    }
    function oncipj_CypherTokenManager_jjStartNfa_5($this, $pos, $active0, $active1) {
        return oncipj_CypherTokenManager_jjMoveNfa_5($this, oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, $pos, $active0, $active1), $pos + 1 | 0);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_5($this) {
        var var$1, $$je;
        switch ($this.$curChar) {
            case 34:
                break;
            case 92:
                a: {
                    b: {
                        try {
                            var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                            $this.$curChar = var$1;
                            break b;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof ji_IOException) {
                            } else {
                                throw $$e;
                            }
                        }
                        oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 0, Long_create(0, 2143289344), Long_ZERO);
                        var$1 = 1;
                        break a;
                    }
                    switch (var$1) {
                        case 34:
                            break;
                        case 39:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 55);
                            break a;
                        case 92:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 54);
                            break a;
                        case 98:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 57);
                            break a;
                        case 102:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 58);
                            break a;
                        case 110:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 59);
                            break a;
                        case 114:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 60);
                            break a;
                        case 116:
                            var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 61);
                            break a;
                        case 117:
                            c: {
                                d: {
                                    try {
                                        var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                        $this.$curChar = var$1;
                                        break d;
                                    } catch ($$e) {
                                        $$je = $rt_wrapException($$e);
                                        if ($$je instanceof ji_IOException) {
                                        } else {
                                            throw $$e;
                                        }
                                    }
                                    oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 1, Long_create(0, 1073741824), Long_ZERO);
                                    var$1 = 2;
                                    break c;
                                }
                                switch (var$1) {
                                    case 91:
                                        e: {
                                            f: {
                                                try {
                                                    var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                    $this.$curChar = var$1;
                                                    break f;
                                                } catch ($$e) {
                                                    $$je = $rt_wrapException($$e);
                                                    if ($$je instanceof ji_IOException) {
                                                    } else {
                                                        throw $$e;
                                                    }
                                                }
                                                oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 2, Long_create(0, 1073741824), Long_ZERO);
                                                var$1 = 3;
                                                break e;
                                            }
                                            switch (var$1) {
                                                case 48:
                                                    g: {
                                                        h: {
                                                            try {
                                                                var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$1;
                                                                break h;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 3, Long_create(0, 1073741824), Long_ZERO);
                                                            var$1 = 4;
                                                            break g;
                                                        }
                                                        switch (var$1) {
                                                            case 45:
                                                                i: {
                                                                    j: {
                                                                        try {
                                                                            var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                            $this.$curChar = var$1;
                                                                            break j;
                                                                        } catch ($$e) {
                                                                            $$je = $rt_wrapException($$e);
                                                                            if ($$je instanceof ji_IOException) {
                                                                            } else {
                                                                                throw $$e;
                                                                            }
                                                                        }
                                                                        oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 4, Long_create(0, 1073741824), Long_ZERO);
                                                                        var$1 = 5;
                                                                        break i;
                                                                    }
                                                                    switch (var$1) {
                                                                        case 57:
                                                                            k: {
                                                                                l: {
                                                                                    try {
                                                                                        var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                        $this.$curChar = var$1;
                                                                                        break l;
                                                                                    } catch ($$e) {
                                                                                        $$je = $rt_wrapException($$e);
                                                                                        if ($$je instanceof ji_IOException) {
                                                                                        } else {
                                                                                            throw $$e;
                                                                                        }
                                                                                    }
                                                                                    oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 5, Long_create(0, 1073741824), Long_ZERO);
                                                                                    var$1 = 6;
                                                                                    break k;
                                                                                }
                                                                                switch (var$1) {
                                                                                    case 97:
                                                                                        m: {
                                                                                            n: {
                                                                                                try {
                                                                                                    var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                    $this.$curChar = var$1;
                                                                                                    break n;
                                                                                                } catch ($$e) {
                                                                                                    $$je = $rt_wrapException($$e);
                                                                                                    if ($$je instanceof ji_IOException) {
                                                                                                    } else {
                                                                                                        throw $$e;
                                                                                                    }
                                                                                                }
                                                                                                oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 6, Long_create(0, 1073741824), Long_ZERO);
                                                                                                var$1 = 7;
                                                                                                break m;
                                                                                            }
                                                                                            switch (var$1) {
                                                                                                case 45:
                                                                                                    o: {
                                                                                                        p: {
                                                                                                            try {
                                                                                                                var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$1;
                                                                                                                break p;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 7, Long_create(0, 1073741824), Long_ZERO);
                                                                                                            var$1 = 8;
                                                                                                            break o;
                                                                                                        }
                                                                                                        switch (var$1) {
                                                                                                            case 102:
                                                                                                                break;
                                                                                                            default:
                                                                                                                var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 7, Long_create(0, 1073741824), Long_ZERO);
                                                                                                                break o;
                                                                                                        }
                                                                                                        var$1 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_5($this, Long_create(0, 1073741824), Long_create(0, 1073741824));
                                                                                                    }
                                                                                                    break m;
                                                                                                default:
                                                                                            }
                                                                                            var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 6, Long_create(0, 1073741824), Long_ZERO);
                                                                                        }
                                                                                        break k;
                                                                                    default:
                                                                                }
                                                                                var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 5, Long_create(0, 1073741824), Long_ZERO);
                                                                            }
                                                                            break i;
                                                                        default:
                                                                    }
                                                                    var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 4, Long_create(0, 1073741824), Long_ZERO);
                                                                }
                                                                break g;
                                                            default:
                                                        }
                                                        var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 3, Long_create(0, 1073741824), Long_ZERO);
                                                    }
                                                    break e;
                                                default:
                                            }
                                            var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 2, Long_create(0, 1073741824), Long_ZERO);
                                        }
                                        break c;
                                    default:
                                }
                                var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 1, Long_create(0, 1073741824), Long_ZERO);
                            }
                            break a;
                        default:
                            var$1 = oncipj_CypherTokenManager_jjStartNfa_5($this, 0, Long_create(0, 2143289344), Long_ZERO);
                            break a;
                    }
                    var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 56);
                }
                return var$1;
            default:
                return oncipj_CypherTokenManager_jjMoveNfa_5($this, 0, 0);
        }
        return oncipj_CypherTokenManager_jjStopAtPos($this, 0, 64);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa9_5($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_5($this, 7, $old0, Long_ZERO);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 8, $active0, Long_ZERO);
            return 9;
        }
        switch (var$3) {
            case 65:
                b: {
                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 8, $active0, Long_ZERO);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 9, var$4, Long_ZERO);
                            var$3 = 10;
                            break b;
                        }
                        switch (var$3) {
                            case 45:
                                d: {
                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 9, var$4, Long_ZERO);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 10, $active0, Long_ZERO);
                                            var$3 = 11;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 70:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 10, $active0, Long_ZERO);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 11, var$4, Long_ZERO);
                                                            var$3 = 12;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 93:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 11, var$4, Long_ZERO);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 12, $active0, Long_ZERO);
                                                                            var$3 = 13;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 91:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 12, $active0, Long_ZERO);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 13, var$4, Long_ZERO);
                                                                                            var$3 = 14;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 48:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 13, var$4, Long_ZERO);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 14, $active0, Long_ZERO);
                                                                                                            var$3 = 15;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 45:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 14, $active0, Long_ZERO);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 15, var$4, Long_ZERO);
                                                                                                                            var$3 = 16;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 57:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 15, var$4, Long_ZERO);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 16, $active0, Long_ZERO);
                                                                                                                                            var$3 = 17;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 97:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 16, $active0, Long_ZERO);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa18_5($this, $active0, Long_create(0, 1073741824));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 15, var$4, Long_ZERO);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 14, $active0, Long_ZERO);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 13, var$4, Long_ZERO);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 12, $active0, Long_ZERO);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 11, var$4, Long_ZERO);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 10, $active0, Long_ZERO);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 9, var$4, Long_ZERO);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_5($this, 8, $active0, Long_ZERO);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa18_5($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_5($this, 16, $old0, Long_ZERO);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 17, $active0, Long_ZERO);
            return 18;
        }
        switch (var$3) {
            case 45:
                b: {
                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 17, $active0, Long_ZERO);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 18, var$4, Long_ZERO);
                            var$3 = 19;
                            break b;
                        }
                        switch (var$3) {
                            case 102:
                                d: {
                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 18, var$4, Long_ZERO);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 19, $active0, Long_ZERO);
                                            var$3 = 20;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 65:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 19, $active0, Long_ZERO);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 20, var$4, Long_ZERO);
                                                            var$3 = 21;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 45:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 20, var$4, Long_ZERO);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 21, $active0, Long_ZERO);
                                                                            var$3 = 22;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 70:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 21, $active0, Long_ZERO);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 22, var$4, Long_ZERO);
                                                                                            var$3 = 23;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 93:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 22, var$4, Long_ZERO);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 23, $active0, Long_ZERO);
                                                                                                            var$3 = 24;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 91:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 23, $active0, Long_ZERO);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 24, var$4, Long_ZERO);
                                                                                                                            var$3 = 25;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 48:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 24, var$4, Long_ZERO);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 25, $active0, Long_ZERO);
                                                                                                                                            var$3 = 26;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 45:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 25, $active0, Long_ZERO);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa27_5($this, $active0, Long_create(0, 1073741824));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 24, var$4, Long_ZERO);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 23, $active0, Long_ZERO);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 22, var$4, Long_ZERO);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 21, $active0, Long_ZERO);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 20, var$4, Long_ZERO);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 19, $active0, Long_ZERO);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 18, var$4, Long_ZERO);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_5($this, 17, $active0, Long_ZERO);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa27_5($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_5($this, 25, $old0, Long_ZERO);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 26, $active0, Long_ZERO);
            return 27;
        }
        switch (var$3) {
            case 57:
                b: {
                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 26, $active0, Long_ZERO);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 27, var$4, Long_ZERO);
                            var$3 = 28;
                            break b;
                        }
                        switch (var$3) {
                            case 97:
                                d: {
                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 27, var$4, Long_ZERO);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 28, $active0, Long_ZERO);
                                            var$3 = 29;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 45:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 28, $active0, Long_ZERO);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 29, var$4, Long_ZERO);
                                                            var$3 = 30;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 102:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 29, var$4, Long_ZERO);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 30, $active0, Long_ZERO);
                                                                            var$3 = 31;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 65:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 30, $active0, Long_ZERO);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 31, var$4, Long_ZERO);
                                                                                            var$3 = 32;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 45:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 31, var$4, Long_ZERO);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 32, $active0, Long_ZERO);
                                                                                                            var$3 = 33;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 70:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 32, $active0, Long_ZERO);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 33, var$4, Long_ZERO);
                                                                                                                            var$3 = 34;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 93:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 33, var$4, Long_ZERO);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 34, $active0, Long_ZERO);
                                                                                                                                            var$3 = 35;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 91:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 34, $active0, Long_ZERO);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa36_5($this, $active0, Long_create(0, 1073741824));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 33, var$4, Long_ZERO);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 32, $active0, Long_ZERO);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 31, var$4, Long_ZERO);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 30, $active0, Long_ZERO);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 29, var$4, Long_ZERO);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 28, $active0, Long_ZERO);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 27, var$4, Long_ZERO);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_5($this, 26, $active0, Long_ZERO);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa36_5($this, $old0, $active0) {
        var var$3, var$4, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_5($this, 34, $old0, Long_ZERO);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 35, $active0, Long_ZERO);
            return 36;
        }
        switch (var$3) {
            case 48:
                b: {
                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                    if (Long_eq(var$4, Long_ZERO))
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 35, $active0, Long_ZERO);
                    else {
                        c: {
                            try {
                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                $this.$curChar = var$3;
                                break c;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof ji_IOException) {
                                } else {
                                    throw $$e;
                                }
                            }
                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 36, var$4, Long_ZERO);
                            var$3 = 37;
                            break b;
                        }
                        switch (var$3) {
                            case 45:
                                d: {
                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                    if (Long_eq($active0, Long_ZERO))
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 36, var$4, Long_ZERO);
                                    else {
                                        e: {
                                            try {
                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                $this.$curChar = var$3;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof ji_IOException) {
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 37, $active0, Long_ZERO);
                                            var$3 = 38;
                                            break d;
                                        }
                                        switch (var$3) {
                                            case 57:
                                                f: {
                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                    if (Long_eq(var$4, Long_ZERO))
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 37, $active0, Long_ZERO);
                                                    else {
                                                        g: {
                                                            try {
                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                $this.$curChar = var$3;
                                                                break g;
                                                            } catch ($$e) {
                                                                $$je = $rt_wrapException($$e);
                                                                if ($$je instanceof ji_IOException) {
                                                                } else {
                                                                    throw $$e;
                                                                }
                                                            }
                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 38, var$4, Long_ZERO);
                                                            var$3 = 39;
                                                            break f;
                                                        }
                                                        switch (var$3) {
                                                            case 97:
                                                                h: {
                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                    if (Long_eq($active0, Long_ZERO))
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 38, var$4, Long_ZERO);
                                                                    else {
                                                                        i: {
                                                                            try {
                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                $this.$curChar = var$3;
                                                                                break i;
                                                                            } catch ($$e) {
                                                                                $$je = $rt_wrapException($$e);
                                                                                if ($$je instanceof ji_IOException) {
                                                                                } else {
                                                                                    throw $$e;
                                                                                }
                                                                            }
                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 39, $active0, Long_ZERO);
                                                                            var$3 = 40;
                                                                            break h;
                                                                        }
                                                                        switch (var$3) {
                                                                            case 45:
                                                                                j: {
                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 39, $active0, Long_ZERO);
                                                                                    else {
                                                                                        k: {
                                                                                            try {
                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                $this.$curChar = var$3;
                                                                                                break k;
                                                                                            } catch ($$e) {
                                                                                                $$je = $rt_wrapException($$e);
                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                } else {
                                                                                                    throw $$e;
                                                                                                }
                                                                                            }
                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 40, var$4, Long_ZERO);
                                                                                            var$3 = 41;
                                                                                            break j;
                                                                                        }
                                                                                        switch (var$3) {
                                                                                            case 102:
                                                                                                l: {
                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 40, var$4, Long_ZERO);
                                                                                                    else {
                                                                                                        m: {
                                                                                                            try {
                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                $this.$curChar = var$3;
                                                                                                                break m;
                                                                                                            } catch ($$e) {
                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                } else {
                                                                                                                    throw $$e;
                                                                                                                }
                                                                                                            }
                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 41, $active0, Long_ZERO);
                                                                                                            var$3 = 42;
                                                                                                            break l;
                                                                                                        }
                                                                                                        switch (var$3) {
                                                                                                            case 65:
                                                                                                                n: {
                                                                                                                    var$4 = Long_and(Long_create(0, 1073741824), $active0);
                                                                                                                    if (Long_eq(var$4, Long_ZERO))
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 41, $active0, Long_ZERO);
                                                                                                                    else {
                                                                                                                        o: {
                                                                                                                            try {
                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                $this.$curChar = var$3;
                                                                                                                                break o;
                                                                                                                            } catch ($$e) {
                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                } else {
                                                                                                                                    throw $$e;
                                                                                                                                }
                                                                                                                            }
                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 42, var$4, Long_ZERO);
                                                                                                                            var$3 = 43;
                                                                                                                            break n;
                                                                                                                        }
                                                                                                                        switch (var$3) {
                                                                                                                            case 45:
                                                                                                                                p: {
                                                                                                                                    $active0 = Long_and(Long_create(0, 1073741824), var$4);
                                                                                                                                    if (Long_eq($active0, Long_ZERO))
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 42, var$4, Long_ZERO);
                                                                                                                                    else {
                                                                                                                                        q: {
                                                                                                                                            try {
                                                                                                                                                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                                                                                                                                                $this.$curChar = var$3;
                                                                                                                                                break q;
                                                                                                                                            } catch ($$e) {
                                                                                                                                                $$je = $rt_wrapException($$e);
                                                                                                                                                if ($$je instanceof ji_IOException) {
                                                                                                                                                } else {
                                                                                                                                                    throw $$e;
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 43, $active0, Long_ZERO);
                                                                                                                                            var$3 = 44;
                                                                                                                                            break p;
                                                                                                                                        }
                                                                                                                                        switch (var$3) {
                                                                                                                                            case 70:
                                                                                                                                                break;
                                                                                                                                            default:
                                                                                                                                                var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 43, $active0, Long_ZERO);
                                                                                                                                                break p;
                                                                                                                                        }
                                                                                                                                        var$3 = oncipj_CypherTokenManager_jjMoveStringLiteralDfa45_5($this, $active0, Long_create(0, 1073741824));
                                                                                                                                    }
                                                                                                                                }
                                                                                                                                break n;
                                                                                                                            default:
                                                                                                                        }
                                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 42, var$4, Long_ZERO);
                                                                                                                    }
                                                                                                                }
                                                                                                                break l;
                                                                                                            default:
                                                                                                        }
                                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 41, $active0, Long_ZERO);
                                                                                                    }
                                                                                                }
                                                                                                break j;
                                                                                            default:
                                                                                        }
                                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 40, var$4, Long_ZERO);
                                                                                    }
                                                                                }
                                                                                break h;
                                                                            default:
                                                                        }
                                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 39, $active0, Long_ZERO);
                                                                    }
                                                                }
                                                                break f;
                                                            default:
                                                        }
                                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 38, var$4, Long_ZERO);
                                                    }
                                                }
                                                break d;
                                            default:
                                        }
                                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 37, $active0, Long_ZERO);
                                    }
                                }
                                break b;
                            default:
                        }
                        var$3 = oncipj_CypherTokenManager_jjStartNfa_5($this, 36, var$4, Long_ZERO);
                    }
                }
                return var$3;
            default:
        }
        return oncipj_CypherTokenManager_jjStartNfa_5($this, 35, $active0, Long_ZERO);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa45_5($this, $old0, $active0) {
        var var$3, $$je;
        $active0 = Long_and($active0, $old0);
        if (Long_eq($active0, Long_ZERO))
            return oncipj_CypherTokenManager_jjStartNfa_5($this, 43, $old0, Long_ZERO);
        a: {
            try {
                var$3 = oncipj_CypherCharStream_readChar($this.$input_stream);
                $this.$curChar = var$3;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            oncipj_CypherTokenManager_jjStopStringLiteralDfa_5($this, 44, $active0, Long_ZERO);
            return 45;
        }
        b: {
            switch (var$3) {
                case 93:
                    break;
                default:
                    break b;
            }
            if (Long_ne(Long_and($active0, Long_create(0, 1073741824)), Long_ZERO))
                return oncipj_CypherTokenManager_jjStopAtPos($this, 45, 62);
        }
        return oncipj_CypherTokenManager_jjStartNfa_5($this, 44, $active0, Long_ZERO);
    }
    function oncipj_CypherTokenManager_jjMoveNfa_5($this, $startState, $curPos) {
        var $startsAt, $i, $kind, var$6, $i1, var$8, $hiByte, $l1, $i2, $l2, var$13, $$je;
        $startsAt = 0;
        $this.$jjnewStateCnt = 1;
        $i = 1;
        $this.$jjstateSet.data[0] = $startState;
        $kind = 2147483647;
        while (true) {
            $startState = $this.$jjround + 1 | 0;
            $this.$jjround = $startState;
            if ($startState == 2147483647)
                oncipj_CypherTokenManager_ReInitRounds($this);
            var$6 = $this.$curChar;
            if (var$6 < 64) {
                $i1 = Long_compare(Long_and(Long_create(4294967295, 4294967291), Long_shl(Long_fromInt(1), var$6)), Long_ZERO);
                while (true) {
                    a: {
                        var$8 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$8[$i]) {
                            case 0:
                                if (!$i1)
                                    break a;
                                $kind = 63;
                                break a;
                            default:
                        }
                    }
                    if ($i == $startsAt)
                        break;
                }
            } else if (var$6 < 128)
                while (true) {
                    b: {
                        var$8 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$8[$i]) {
                            case 0:
                                $kind = 63;
                                break b;
                            default:
                        }
                    }
                    if ($i == $startsAt)
                        break;
                }
            else {
                $hiByte = var$6 >> 8;
                $i1 = $hiByte >> 6;
                $l1 = Long_shl(Long_fromInt(1), $hiByte & 63);
                $i2 = (var$6 & 255) >> 6;
                $l2 = Long_shl(Long_fromInt(1), var$6 & 63);
                var$6 = Long_compare($l1, Long_ZERO);
                var$13 = Long_compare($l2, Long_ZERO);
                while (true) {
                    c: {
                        var$8 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$8[$i]) {
                            case 0:
                                break;
                            default:
                                if (!$i1)
                                    break c;
                                if (!var$6)
                                    break c;
                                if (!$i2)
                                    break c;
                                break c;
                        }
                        if (oncipj_CypherTokenManager_jjCanMove_5($hiByte, $i1, $i2, $l1, $l2) && $kind > 63)
                            $kind = 63;
                    }
                    if ($i == $startsAt)
                        break;
                }
            }
            if ($kind != 2147483647) {
                $this.$jjmatchedKind = $kind;
                $this.$jjmatchedPos = $curPos;
                $kind = 2147483647;
            }
            $curPos = $curPos + 1 | 0;
            $i = $this.$jjnewStateCnt;
            $this.$jjnewStateCnt = $startsAt;
            $startsAt = 1 - $startsAt | 0;
            if ($i == $startsAt)
                break;
            try {
                $this.$curChar = oncipj_CypherCharStream_readChar($this.$input_stream);
                continue;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                    return $curPos;
                } else {
                    throw $$e;
                }
            }
        }
        return $curPos;
    }
    function oncipj_CypherTokenManager_jjStopStringLiteralDfa_6($this, $pos, $active0, $active1) {
        return (-1);
    }
    function oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_6($this) {
        var var$1, $$je;
        switch ($this.$curChar) {
            case 96:
                $this.$jjmatchedKind = 68;
                a: {
                    b: {
                        try {
                            var$1 = oncipj_CypherCharStream_readChar($this.$input_stream);
                            $this.$curChar = var$1;
                            break b;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof ji_IOException) {
                            } else {
                                throw $$e;
                            }
                        }
                        oncipj_CypherTokenManager_jjStopStringLiteralDfa_6($this, 0, Long_ZERO, Long_fromInt(8));
                        var$1 = 1;
                        break a;
                    }
                    switch (var$1) {
                        case 96:
                            break;
                        default:
                            var$1 = oncipj_CypherTokenManager_jjMoveNfa_6($this, oncipj_CypherTokenManager_jjStopStringLiteralDfa_6($this, 0, Long_ZERO, Long_fromInt(8)), 1);
                            break a;
                    }
                    var$1 = oncipj_CypherTokenManager_jjStopAtPos($this, 1, 67);
                }
                return var$1;
            default:
        }
        return oncipj_CypherTokenManager_jjMoveNfa_6($this, 0, 0);
    }
    function oncipj_CypherTokenManager_jjMoveNfa_6($this, $startState, $curPos) {
        var $startsAt, $i, $kind, var$6, var$7, $i1, $hiByte, $l1, $i2, $l2, var$13, $$je;
        $startsAt = 0;
        $this.$jjnewStateCnt = 1;
        $i = 1;
        $this.$jjstateSet.data[0] = $startState;
        $kind = 2147483647;
        while (true) {
            $startState = $this.$jjround + 1 | 0;
            $this.$jjround = $startState;
            if ($startState == 2147483647)
                oncipj_CypherTokenManager_ReInitRounds($this);
            var$6 = $this.$curChar;
            if (var$6 < 64)
                while (true) {
                    a: {
                        var$7 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$7[$i]) {
                            case 0:
                                $kind = 66;
                                break a;
                            default:
                        }
                    }
                    if ($i == $startsAt)
                        break;
                }
            else if (var$6 < 128) {
                $i1 = Long_compare(Long_and(Long_create(4294967295, 4294967294), Long_shl(Long_fromInt(1), var$6 & 63)), Long_ZERO);
                while (true) {
                    b: {
                        var$7 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$7[$i]) {
                            case 0:
                                if (!$i1)
                                    break b;
                                $kind = 66;
                                break b;
                            default:
                        }
                    }
                    if ($i == $startsAt)
                        break;
                }
            } else {
                $hiByte = var$6 >> 8;
                $i1 = $hiByte >> 6;
                $l1 = Long_shl(Long_fromInt(1), $hiByte & 63);
                $i2 = (var$6 & 255) >> 6;
                $l2 = Long_shl(Long_fromInt(1), var$6 & 63);
                var$6 = Long_compare($l1, Long_ZERO);
                var$13 = Long_compare($l2, Long_ZERO);
                while (true) {
                    c: {
                        var$7 = $this.$jjstateSet.data;
                        $i = $i + (-1) | 0;
                        switch (var$7[$i]) {
                            case 0:
                                break;
                            default:
                                if (!$i1)
                                    break c;
                                if (!var$6)
                                    break c;
                                if (!$i2)
                                    break c;
                                break c;
                        }
                        if (oncipj_CypherTokenManager_jjCanMove_5($hiByte, $i1, $i2, $l1, $l2) && $kind > 66)
                            $kind = 66;
                    }
                    if ($i == $startsAt)
                        break;
                }
            }
            if ($kind != 2147483647) {
                $this.$jjmatchedKind = $kind;
                $this.$jjmatchedPos = $curPos;
                $kind = 2147483647;
            }
            $curPos = $curPos + 1 | 0;
            $i = $this.$jjnewStateCnt;
            $this.$jjnewStateCnt = $startsAt;
            $startsAt = 1 - $startsAt | 0;
            if ($i == $startsAt)
                break;
            try {
                $this.$curChar = oncipj_CypherCharStream_readChar($this.$input_stream);
                continue;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                    return $curPos;
                } else {
                    throw $$e;
                }
            }
        }
        return $curPos;
    }
    function oncipj_CypherTokenManager_jjFillToken($this) {
        var $curTokenImage, var$2, var$3, $endLine, $beginLine, $beginColumn, $endColumn, var$8, var$9;
        $curTokenImage = oncipj_CypherTokenManager_jjstrLiteralImages.data[$this.$jjmatchedKind];
        if ($curTokenImage === null)
            $curTokenImage = oncipj_CypherCharStream_getImage($this.$input_stream);
        var$2 = $this.$input_stream;
        var$3 = var$2.$lines.data;
        $endLine = var$2.$beginOffset0;
        $beginLine = var$3[$endLine];
        $beginColumn = var$2.$columns.data[$endLine];
        $endLine = oncipj_CypherCharStream_getEndLine(var$2);
        $endColumn = oncipj_CypherCharStream_getEndColumn($this.$input_stream);
        var$8 = $this.$jjmatchedKind;
        var$9 = null;
        var$2 = new oncipj_Token;
        var$2.$kind0 = var$8;
        var$2.$image0 = var$9;
        var$2.$kind0 = var$8;
        var$2.$image0 = $curTokenImage;
        var$2.$beginLine = $beginLine;
        var$2.$endLine = $endLine;
        var$2.$beginColumn = $beginColumn;
        var$2.$endColumn = $endColumn;
        return var$2;
    }
    function oncipj_CypherTokenManager_jjCanMove_0($hiByte, $i1, $i2, $l1, $l2) {
        switch ($hiByte) {
            case 0:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec2.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 2:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec3.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 3:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec4.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 4:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec5.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 5:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec6.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 6:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec7.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 7:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec8.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 8:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec9.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 9:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec10.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 10:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec11.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 11:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec12.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 12:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec13.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 13:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec14.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 14:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec15.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 15:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec16.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 16:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec17.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 18:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec18.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 19:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec19.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 20:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec20.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 22:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec21.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 23:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec22.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 24:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec23.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 25:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec24.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 26:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec25.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 27:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec26.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 28:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec27.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 29:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec28.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 31:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec29.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 32:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec30.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 33:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec31.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 44:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec32.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 45:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec33.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 46:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec34.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 48:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec35.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 49:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec36.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 77:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec37.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 159:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec38.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 164:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec39.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 166:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec40.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 167:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec41.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 168:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec42.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 169:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec43.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 170:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec44.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 171:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec45.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 215:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec46.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 250:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec47.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 251:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec48.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 253:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec49.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 254:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec50.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 255:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec51.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            default:
        }
        if (Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec0.data[$i1], $l1), Long_ZERO))
            return 0;
        return 1;
    }
    function oncipj_CypherTokenManager_jjCanMove_1($hiByte, $i1, $i2, $l1, $l2) {
        switch ($hiByte) {
            case 0:
                break;
            case 2:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec3.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 3:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec54.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 4:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec55.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 5:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec56.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 6:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec57.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 7:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec58.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 8:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec59.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 9:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec60.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 10:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec61.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 11:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec62.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 12:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec63.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 13:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec64.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 14:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec65.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 15:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec66.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 16:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec67.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 18:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec18.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 19:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec68.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 20:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec20.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 22:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec21.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 23:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec69.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 24:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec70.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 25:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec71.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 26:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec72.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 27:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec73.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 28:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec74.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 31:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec29.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 32:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec75.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 33:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec31.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 44:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec76.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 45:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec77.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 46:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec34.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 48:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec78.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 49:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec36.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 159:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec38.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 164:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec39.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 166:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec79.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 167:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec41.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 168:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec80.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 169:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec81.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 170:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec82.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 171:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec83.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 215:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec46.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 250:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec47.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 251:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec84.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 253:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec85.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 254:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec86.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 255:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec87.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            default:
                if (Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec52.data[$i1], $l1), Long_ZERO)) {
                    if (Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec0.data[$i1], $l1), Long_ZERO))
                        return 0;
                    return 1;
                }
                if (Long_ne(Long_and(oncipj_CypherTokenManager_jjbitVec37.data[$i2], $l2), Long_ZERO))
                    return 1;
                return 0;
        }
        return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec53.data[$i2], $l2), Long_ZERO) ? 0 : 1;
    }
    function oncipj_CypherTokenManager_jjCanMove_2($hiByte, $i1, $i2, $l1, $l2) {
        switch ($hiByte) {
            case 0:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec88.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 32:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec89.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 254:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec90.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 255:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec91.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            default:
        }
        return 0;
    }
    function oncipj_CypherTokenManager_jjCanMove_3($hiByte, $i1, $i2, $l1, $l2) {
        switch ($hiByte) {
            case 39:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec92.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 48:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec93.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 254:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec94.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 255:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec95.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            default:
        }
        return 0;
    }
    function oncipj_CypherTokenManager_jjCanMove_4($hiByte, $i1, $i2, $l1, $l2) {
        switch ($hiByte) {
            case 39:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec96.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 48:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec97.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 254:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec98.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            case 255:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec99.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            default:
        }
        return 0;
    }
    function oncipj_CypherTokenManager_jjCanMove_5($hiByte, $i1, $i2, $l1, $l2) {
        switch ($hiByte) {
            case 0:
                return Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec100.data[$i2], $l2), Long_ZERO) ? 0 : 1;
            default:
        }
        if (Long_eq(Long_and(oncipj_CypherTokenManager_jjbitVec20.data[$i1], $l1), Long_ZERO))
            return 0;
        return 1;
    }
    function oncipj_CypherTokenManager_getNextToken($this) {
        var $specialToken, $curPos, $error_after, $error_line, var$5, $error_column, var$7, var$8, $matchedToken, $EOFSeen, var$11, $$je;
        $specialToken = null;
        $curPos = 0;
        a: {
            while (true) {
                try {
                    $this.$curChar = oncipj_CypherCharStream_beginToken($this.$input_stream);
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    if ($$je instanceof jl_Exception) {
                        break;
                    } else {
                        throw $$e;
                    }
                }
                $error_after = $this.$jjimage;
                $this.$image = $error_after;
                jl_StringBuilder_setLength($error_after, 0);
                $this.$jjimageLen = 0;
                while (true) {
                    b: {
                        switch ($this.$curLexState) {
                            case 0:
                                $this.$jjmatchedKind = 2147483647;
                                $this.$jjmatchedPos = 0;
                                $curPos = oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_0($this);
                                if ($this.$jjmatchedPos)
                                    break b;
                                if ($this.$jjmatchedKind <= 347)
                                    break b;
                                $this.$jjmatchedKind = 347;
                                break b;
                            case 1:
                                $this.$jjmatchedKind = 2147483647;
                                $this.$jjmatchedPos = 0;
                                $curPos = oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_1($this);
                                if ($this.$jjmatchedPos)
                                    break b;
                                if ($this.$jjmatchedKind <= 34)
                                    break b;
                                $this.$jjmatchedKind = 34;
                                break b;
                            case 2:
                                $this.$jjmatchedKind = 2147483647;
                                $this.$jjmatchedPos = 0;
                                $curPos = oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_2($this);
                                if ($this.$jjmatchedPos)
                                    break b;
                                if ($this.$jjmatchedKind <= 34)
                                    break b;
                                $this.$jjmatchedKind = 34;
                                break b;
                            case 3:
                                $this.$jjmatchedKind = 2147483647;
                                $this.$jjmatchedPos = 0;
                                $curPos = oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_3($this);
                                if ($this.$jjmatchedPos)
                                    break b;
                                if ($this.$jjmatchedKind <= 34)
                                    break b;
                                $this.$jjmatchedKind = 34;
                                break b;
                            case 4:
                                $this.$jjmatchedKind = 2147483647;
                                $this.$jjmatchedPos = 0;
                                $curPos = oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_4($this);
                                if ($this.$jjmatchedPos)
                                    break b;
                                if ($this.$jjmatchedKind <= 347)
                                    break b;
                                $this.$jjmatchedKind = 347;
                                break b;
                            case 5:
                                $this.$jjmatchedKind = 2147483647;
                                $this.$jjmatchedPos = 0;
                                $curPos = oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_5($this);
                                if ($this.$jjmatchedPos)
                                    break b;
                                if ($this.$jjmatchedKind <= 347)
                                    break b;
                                $this.$jjmatchedKind = 347;
                                break b;
                            case 6:
                                $this.$jjmatchedKind = 2147483647;
                                $this.$jjmatchedPos = 0;
                                $curPos = oncipj_CypherTokenManager_jjMoveStringLiteralDfa0_6($this);
                                if ($this.$jjmatchedPos)
                                    break b;
                                if ($this.$jjmatchedKind <= 347)
                                    break b;
                                $this.$jjmatchedKind = 347;
                                break b;
                            default:
                        }
                    }
                    if ($this.$jjmatchedKind == 2147483647)
                        break a;
                    $error_line = $this.$jjmatchedPos;
                    if (($error_line + 1 | 0) < $curPos)
                        oncipj_CypherCharStream_backup($this.$input_stream, ($curPos - $error_line | 0) - 1 | 0);
                    var$5 = oncipj_CypherTokenManager_jjtoToken.data;
                    $error_line = $this.$jjmatchedKind;
                    $error_column = $error_line >> 6;
                    var$7 = var$5[$error_column];
                    var$8 = Long_shl(Long_fromInt(1), $error_line & 63);
                    if (Long_ne(Long_and(var$7, var$8), Long_ZERO)) {
                        $matchedToken = oncipj_CypherTokenManager_jjFillToken($this);
                        $matchedToken.$specialToken = $specialToken;
                        oncipj_CypherTokenManager_TokenLexicalActions($this, $matchedToken);
                        var$5 = oncipj_CypherTokenManager_jjnewLexState.data;
                        $curPos = $this.$jjmatchedKind;
                        if (var$5[$curPos] != (-1))
                            $this.$curLexState = var$5[$curPos];
                        oncipj_CypherTokenManager_CommonTokenAction($this, $matchedToken);
                        return $matchedToken;
                    }
                    if (Long_ne(Long_and(oncipj_CypherTokenManager_jjtoSkip.data[$error_column], var$8), Long_ZERO))
                        break;
                    oncipj_CypherTokenManager_MoreLexicalActions($this);
                    var$5 = oncipj_CypherTokenManager_jjnewLexState.data;
                    $curPos = $this.$jjmatchedKind;
                    if (var$5[$curPos] != (-1))
                        $this.$curLexState = var$5[$curPos];
                    $curPos = 0;
                    $this.$jjmatchedKind = 2147483647;
                    try {
                        $this.$curChar = oncipj_CypherCharStream_readChar($this.$input_stream);
                        continue;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof ji_IOException) {
                            break a;
                        } else {
                            throw $$e;
                        }
                    }
                }
                if (Long_eq(Long_and(oncipj_CypherTokenManager_jjtoSpecial.data[$error_column], var$8), Long_ZERO))
                    oncipj_CypherTokenManager_SkipLexicalActions($this, null);
                else {
                    $matchedToken = oncipj_CypherTokenManager_jjFillToken($this);
                    if ($specialToken === null)
                        $specialToken = $matchedToken;
                    else {
                        $matchedToken.$specialToken = $specialToken;
                        $specialToken.$next1 = $matchedToken;
                        $specialToken = $matchedToken;
                    }
                    oncipj_CypherTokenManager_SkipLexicalActions($this, $matchedToken);
                }
                var$5 = oncipj_CypherTokenManager_jjnewLexState.data;
                $error_line = $this.$jjmatchedKind;
                if (var$5[$error_line] == (-1))
                    continue;
                $this.$curLexState = var$5[$error_line];
            }
            $this.$jjmatchedKind = 0;
            $this.$jjmatchedPos = (-1);
            $matchedToken = oncipj_CypherTokenManager_jjFillToken($this);
            $matchedToken.$specialToken = $specialToken;
            oncipj_CypherTokenManager_CommonTokenAction($this, $matchedToken);
            return $matchedToken;
        }
        $error_line = oncipj_CypherCharStream_getEndLine($this.$input_stream);
        $error_column = oncipj_CypherCharStream_getEndColumn($this.$input_stream);
        $error_after = null;
        $EOFSeen = 0;
        c: {
            try {
                oncipj_CypherCharStream_readChar($this.$input_stream);
                oncipj_CypherCharStream_backup($this.$input_stream, 1);
                break c;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ji_IOException) {
                } else {
                    throw $$e;
                }
            }
            $EOFSeen = 1;
            $error_after = $curPos <= 1 ? $rt_s(3) : oncipj_CypherCharStream_getImage($this.$input_stream);
            var$11 = $this.$curChar;
            if (var$11 != 10 && var$11 != 13)
                $error_column = $error_column + 1 | 0;
            else {
                $error_line = $error_line + 1 | 0;
                $error_column = 0;
            }
        }
        if (!$EOFSeen) {
            oncipj_CypherCharStream_backup($this.$input_stream, 1);
            $error_after = $curPos <= 1 ? $rt_s(3) : oncipj_CypherCharStream_getImage($this.$input_stream);
        }
        $rt_throw(oncipj_TokenMgrException__init_($EOFSeen, $this.$curLexState, $error_line, $error_column, $error_after, $this.$curChar, 0));
    }
    function oncipj_CypherTokenManager_SkipLexicalActions($this, $matchedToken) {}
    function oncipj_CypherTokenManager_MoreLexicalActions($this) {
        var var$1, var$2, var$3;
        a: {
            var$1 = $this.$jjimageLen;
            var$2 = $this.$jjmatchedPos + 1 | 0;
            $this.$lengthOfMatch = var$2;
            var$2 = var$1 + var$2 | 0;
            $this.$jjimageLen = var$2;
            switch ($this.$jjmatchedKind) {
                case 30:
                    break;
                case 31:
                case 32:
                case 33:
                case 34:
                case 35:
                case 36:
                case 37:
                case 38:
                case 39:
                case 40:
                case 41:
                case 50:
                case 51:
                case 52:
                case 53:
                case 62:
                case 63:
                case 64:
                case 65:
                case 66:
                    break a;
                case 42:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(980));
                    break a;
                case 43:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(981));
                    break a;
                case 44:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(185));
                    break a;
                case 45:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(982));
                    break a;
                case 46:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(983));
                    break a;
                case 47:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(66));
                    break a;
                case 48:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(984));
                    break a;
                case 49:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(985));
                    break a;
                case 54:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(980));
                    break a;
                case 55:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(981));
                    break a;
                case 56:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(185));
                    break a;
                case 57:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(982));
                    break a;
                case 58:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(983));
                    break a;
                case 59:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(66));
                    break a;
                case 60:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(984));
                    break a;
                case 61:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(985));
                    break a;
                case 67:
                    jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
                    $this.$jjimageLen = 0;
                    var$3 = $this.$image;
                    jl_StringBuilder_delete(var$3, jl_StringBuilder_length(var$3) - 2 | 0, jl_StringBuilder_length($this.$image));
                    jl_StringBuilder_append1($this.$image, $rt_s(89));
                    break a;
                default:
                    break a;
            }
            jl_StringBuilder_append5($this.$image, oncipj_CypherCharStream_getSuffix($this.$input_stream, var$2));
            $this.$jjimageLen = 0;
            oncipj_CypherCharStream_backup($this.$input_stream, 1);
        }
    }
    function oncipj_CypherTokenManager_TokenLexicalActions($this, $matchedToken) {
        var var$2, var$3, var$4, var$5;
        a: {
            switch ($this.$jjmatchedKind) {
                case 52:
                    break;
                case 64:
                    var$2 = $this.$image;
                    var$3 = $this.$input_stream;
                    var$4 = $this.$jjimageLen;
                    var$5 = $this.$jjmatchedPos + 1 | 0;
                    $this.$lengthOfMatch = var$5;
                    jl_AbstractStringBuilder_append5(var$2, oncipj_CypherCharStream_getSuffix(var$3, var$4 + var$5 | 0));
                    var$2 = $this.$image;
                    $matchedToken.$image0 = jl_StringBuilder_substring(var$2, 1, var$2.$length0 - 1 | 0);
                    break a;
                case 68:
                    var$2 = $this.$image;
                    var$3 = $this.$input_stream;
                    var$5 = $this.$jjimageLen;
                    var$4 = $this.$jjmatchedPos + 1 | 0;
                    $this.$lengthOfMatch = var$4;
                    jl_AbstractStringBuilder_append5(var$2, oncipj_CypherCharStream_getSuffix(var$3, var$5 + var$4 | 0));
                    var$2 = $this.$image;
                    $matchedToken.$image0 = jl_StringBuilder_substring(var$2, 1, var$2.$length0 - 1 | 0);
                    break a;
                default:
                    break a;
            }
            var$2 = $this.$image;
            var$3 = $this.$input_stream;
            var$5 = $this.$jjimageLen;
            var$4 = $this.$jjmatchedPos + 1 | 0;
            $this.$lengthOfMatch = var$4;
            jl_AbstractStringBuilder_append5(var$2, oncipj_CypherCharStream_getSuffix(var$3, var$5 + var$4 | 0));
            var$2 = $this.$image;
            $matchedToken.$image0 = jl_StringBuilder_substring(var$2, 1, var$2.$length0 - 1 | 0);
        }
    }
    function oncipj_CypherTokenManager_jjCheckNAdd($this, $state) {
        var var$2, var$3, var$4, var$5, var$6;
        var$2 = $this.$jjrounds.data;
        var$3 = var$2[$state];
        var$4 = $this.$jjround;
        if (var$3 != var$4) {
            var$5 = $this.$jjstateSet.data;
            var$6 = $this.$jjnewStateCnt;
            $this.$jjnewStateCnt = var$6 + 1 | 0;
            var$5[var$6] = $state;
            var$2[$state] = var$4;
        }
    }
    function oncipj_CypherTokenManager_jjAddStates($this, $start, $end) {
        var var$3, var$4, $start_0;
        while (true) {
            var$3 = $this.$jjstateSet.data;
            var$4 = $this.$jjnewStateCnt;
            $this.$jjnewStateCnt = var$4 + 1 | 0;
            var$3[var$4] = oncipj_CypherTokenManager_jjnextStates.data[$start];
            $start_0 = $start + 1 | 0;
            if ($start == $end)
                break;
            $start = $start_0;
        }
    }
    function oncipj_CypherTokenManager_jjCheckNAddTwoStates($this, $state1, $state2) {
        oncipj_CypherTokenManager_jjCheckNAdd($this, $state1);
        oncipj_CypherTokenManager_jjCheckNAdd($this, $state2);
    }
    function oncipj_CypherTokenManager_jjCheckNAddStates($this, $start, $end) {
        var $start_0;
        while (true) {
            oncipj_CypherTokenManager_jjCheckNAdd($this, oncipj_CypherTokenManager_jjnextStates.data[$start]);
            $start_0 = $start + 1 | 0;
            if ($start == $end)
                break;
            $start = $start_0;
        }
    }
    function oncipj_CypherTokenManager_ReInitRounds($this) {
        var $i, $i_0;
        $this.$jjround = (-2147483647);
        $i = 74;
        while (true) {
            $i_0 = $i + (-1) | 0;
            if ($i <= 0)
                break;
            $this.$jjrounds.data[$i_0] = (-2147483648);
            $i = $i_0;
        }
    }
    function oncipj_CypherTokenManager__clinit_() {
        oncipj_CypherTokenManager_jjbitVec0 = $rt_createLongArrayFromData([Long_create(1075970050, 4293918720), Long_fromInt(-8193), Long_create(2147483647, 4294963247), Long_create(8388607, 301989888)]);
        oncipj_CypherTokenManager_jjbitVec2 = $rt_createLongArrayFromData([Long_ZERO, Long_ZERO, Long_create(4294967295, 69215292), Long_create(4286578687, 4286578687)]);
        oncipj_CypherTokenManager_jjbitVec3 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-1), Long_create(262083, 20511)]);
        oncipj_CypherTokenManager_jjbitVec4 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_create(4294967295, 3168796671), Long_create(4294956864, 4294967291), Long_create(4294967295, 4290772991)]);
        oncipj_CypherTokenManager_jjbitVec5 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-773), Long_fromInt(-1)]);
        oncipj_CypherTokenManager_jjbitVec6 = $rt_createLongArrayFromData([Long_create(4294967295, 4294901759), Long_create(41943039, 4294967295), Long_create(4294869503, 3221225471), Long_create(4294901942, 493567)]);
        oncipj_CypherTokenManager_jjbitVec7 = $rt_createLongArrayFromData([Long_create(402589759, 4294967295), Long_create(4294967295, 4294951935), Long_fromInt(-1), Long_create(3220176895, 2684354047)]);
        oncipj_CypherTokenManager_jjbitVec8 = $rt_createLongArrayFromData([Long_fromInt(-32768), Long_fromInt(-6145), Long_create(4294967295, 262143), Long_create(4294967295, 3829399551)]);
        oncipj_CypherTokenManager_jjbitVec9 = $rt_createLongArrayFromData([Long_create(4294967295, 16383), Long_create(268435455, 2047), Long_create(0, 4292870143), Long_fromInt(-524033)]);
        oncipj_CypherTokenManager_jjbitVec10 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_create(4294967295, 4294901711), Long_create(4294549487, 4089839103), Long_create(2961209759, 1477443535)]);
        oncipj_CypherTokenManager_jjbitVec11 = $rt_createLongArrayFromData([Long_create(4294543342, 3547201023), Long_create(1577204103, 4194240), Long_create(4294688750, 4092460543), Long_create(80831, 4261609423)]);
        oncipj_CypherTokenManager_jjbitVec12 = $rt_createLongArrayFromData([Long_create(4294549486, 4092460543), Long_create(2967484831, 196559), Long_create(3594373100, 3288319768), Long_create(8469959, 33619904)]);
        oncipj_CypherTokenManager_jjbitVec13 = $rt_createLongArrayFromData([Long_create(4294828031, 3825204735), Long_create(123747807, 65487), Long_create(4294828015, 4092591615), Long_create(1080049119, 458703)]);
        oncipj_CypherTokenManager_jjbitVec14 = $rt_createLongArrayFromData([Long_fromInt(-139265), Long_create(2163244511, 4227923919), Long_create(4236247022, 805044223), Long_create(4284449919, 851904)]);
        oncipj_CypherTokenManager_jjbitVec15 = $rt_createLongArrayFromData([Long_create(4294967294, 2281701375), Long_fromInt(67076095), Long_create(4294965206, 1073741743), Long_create(4093591391, 0)]);
        oncipj_CypherTokenManager_jjbitVec16 = $rt_createLongArrayFromData([Long_create(50331649, 3265266687), Long_create(4294967039, 4294844415), Long_create(4278190047, 536870911), Long_fromInt(64)]);
        oncipj_CypherTokenManager_jjbitVec17 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-64513), Long_create(1073741823, 4294967295), Long_create(4294910143, 4160749567)]);
        oncipj_CypherTokenManager_jjbitVec18 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_create(1031749119, 4294967295), Long_create(4294917631, 2134769663), Long_fromInt(-8388803)]);
        oncipj_CypherTokenManager_jjbitVec19 = $rt_createLongArrayFromData([Long_fromInt(-12713985), Long_create(3892314111, 0), Long_create(65535, 4294967295), Long_create(4294967295, 1061158911)]);
        oncipj_CypherTokenManager_jjbitVec20 = $rt_createLongArrayFromData([Long_fromInt(-2), Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-1)]);
        oncipj_CypherTokenManager_jjbitVec21 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_create(4294967295, 4294942719), Long_create(134217726, 4294967295), Long_create(4294967295, 33540095)]);
        oncipj_CypherTokenManager_jjbitVec22 = $rt_createLongArrayFromData([Long_create(2088959, 2097151), Long_create(1048575, 909311), Long_fromInt(-1), Long_create(948961279, 1023)]);
        oncipj_CypherTokenManager_jjbitVec23 = $rt_createLongArrayFromData([Long_create(67074048, 4294967295), Long_create(4294967295, 33554431), Long_create(4294967295, 4294903807), Long_create(4294967295, 4194303)]);
        oncipj_CypherTokenManager_jjbitVec24 = $rt_createLongArrayFromData([Long_create(2147483647, 268374015), Long_create(4294967232, 2047999), Long_create(4294967295, 4294905855), Long_fromInt(67044351)]);
        oncipj_CypherTokenManager_jjbitVec25 = $rt_createLongArrayFromData([Long_create(268435455, 4294967295), Long_create(2147483647, 2684354559), Long_create(67044351, 3221160064), Long_fromInt(1)]);
        oncipj_CypherTokenManager_jjbitVec26 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_create(67047423, 1046528), Long_fromInt(-1), Long_create(4294967295, 1048575)]);
        oncipj_CypherTokenManager_jjbitVec27 = $rt_createLongArrayFromData([Long_create(4294967295, 16777215), Long_create(4294960127, 1073741823), Long_create(4294902271, 3892314111), Long_create(4294377472, 134217727)]);
        oncipj_CypherTokenManager_jjbitVec28 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-1), Long_create(4294967295, 4227858431)]);
        oncipj_CypherTokenManager_jjbitVec29 = $rt_createLongArrayFromData([Long_create(1061158911, 4294967295), Long_create(2868854591, 1073741823), Long_create(4294967295, 1608515583), Long_create(265232348, 534519807)]);
        oncipj_CypherTokenManager_jjbitVec30 = $rt_createLongArrayFromData([Long_create(63488, 2147515392), Long_create(1048577, 2147680223), Long_create(536805376, 4294967295), Long_create(536805376, 131042)]);
        oncipj_CypherTokenManager_jjbitVec31 = $rt_createLongArrayFromData([Long_create(1043332228, 4093623632), Long_create(17376, 4294967295), Long_fromInt(511), Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec32 = $rt_createLongArrayFromData([Long_create(4294967295, 4294934527), Long_create(2147483647, 4294967295), Long_fromInt(-1), Long_create(4294967295, 1046559)]);
        oncipj_CypherTokenManager_jjbitVec33 = $rt_createLongArrayFromData([Long_create(4294967295, 4294910143), Long_create(4294967295, 2147516671), Long_create(8388607, 2139062143), Long_create(2139062143, 4294967295)]);
        oncipj_CypherTokenManager_jjbitVec34 = $rt_createLongArrayFromData([Long_create(0, 32768), Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec35 = $rt_createLongArrayFromData([Long_create(224, 524222462), Long_fromInt(-2), Long_create(3867148287, 4294967294), Long_create(4294967295, 4160749567)]);
        oncipj_CypherTokenManager_jjbitVec36 = $rt_createLongArrayFromData([Long_create(4294967264, 4294901759), Long_fromInt(-1), Long_create(32767, 4294967295), Long_create(0, 4294901760)]);
        oncipj_CypherTokenManager_jjbitVec37 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-1), Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec38 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-1), Long_create(4294967295, 536870911)]);
        oncipj_CypherTokenManager_jjbitVec39 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(8191), Long_create(4294901760, 1073741823)]);
        oncipj_CypherTokenManager_jjbitVec40 = $rt_createLongArrayFromData([Long_create(4294909951, 4095), Long_create(4294967295, 3220242431), Long_fromInt(-1), Long_create(4294967295, 262143)]);
        oncipj_CypherTokenManager_jjbitVec41 = $rt_createLongArrayFromData([Long_create(4286578688, 4294967292), Long_fromInt(-1), Long_fromInt(-1537), Long_create(2044, 4292870144)]);
        oncipj_CypherTokenManager_jjbitVec42 = $rt_createLongArrayFromData([Long_create(4294967295, 16781567), Long_create(4294967295, 1048575), Long_fromInt(-1), Long_create(67043391, 3909091327)]);
        oncipj_CypherTokenManager_jjbitVec43 = $rt_createLongArrayFromData([Long_create(4294967295, 4294918143), Long_create(1048575, 536870911), Long_fromInt(-1), Long_create(67076097, 2147483647)]);
        oncipj_CypherTokenManager_jjbitVec44 = $rt_createLongArrayFromData([Long_create(4294967295, 8388607), Long_create(67059711, 4236247039), Long_fromInt(-1), Long_create(939524103, 8191999)]);
        oncipj_CypherTokenManager_jjbitVec45 = $rt_createLongArrayFromData([Long_create(8289918, 4294934399), Long_create(4160749567, 4294902783), Long_fromInt(-1), Long_create(4294967295, 67057663)]);
        oncipj_CypherTokenManager_jjbitVec46 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_create(4294967295, 4294901775), Long_create(4294965375, 268435455)]);
        oncipj_CypherTokenManager_jjbitVec47 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_create(4294967295, 4294918143), Long_fromInt(-1), Long_fromInt(67108863)]);
        oncipj_CypherTokenManager_jjbitVec48 = $rt_createLongArrayFromData([Long_create(3774349439, 1602223615), Long_fromInt(-37), Long_create(4294967295, 262143), Long_fromInt(-524288)]);
        oncipj_CypherTokenManager_jjbitVec49 = $rt_createLongArrayFromData([Long_create(4294967295, 1073741823), Long_fromInt(-65536), Long_fromInt(-196609), Long_create(255, 536805376)]);
        oncipj_CypherTokenManager_jjbitVec50 = $rt_createLongArrayFromData([Long_create(65535, 1638399), Long_create(57344, 4292805120), Long_fromInt(-1), Long_create(4294967295, 2684354559)]);
        oncipj_CypherTokenManager_jjbitVec51 = $rt_createLongArrayFromData([Long_create(67043344, 2281701374), Long_create(134217726, 4294967232), Long_create(4294967295, 2147483647), Long_create(486341884, 234881123)]);
        oncipj_CypherTokenManager_jjbitVec52 = $rt_createLongArrayFromData([Long_fromInt(536870912), Long_fromInt(8192), Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec53 = $rt_createLongArrayFromData([Long_ZERO, Long_ZERO, Long_create(0, 69207040), Long_create(4286578687, 4286578687)]);
        oncipj_CypherTokenManager_jjbitVec54 = $rt_createLongArrayFromData([Long_ZERO, Long_create(0, 3168731136), Long_create(4294956864, 4294967291), Long_create(4294967295, 4290772991)]);
        oncipj_CypherTokenManager_jjbitVec55 = $rt_createLongArrayFromData([Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-1021), Long_fromInt(-1)]);
        oncipj_CypherTokenManager_jjbitVec56 = $rt_createLongArrayFromData([Long_create(4294967295, 4294901759), Long_create(41943039, 4294967295), Long_fromInt(511), Long_create(4294901760, 493567)]);
        oncipj_CypherTokenManager_jjbitVec57 = $rt_createLongArrayFromData([Long_create(0, 4294967295), Long_create(2047, 4294885376), Long_fromInt(-1), Long_create(3145727, 2617294944)]);
        oncipj_CypherTokenManager_jjbitVec58 = $rt_createLongArrayFromData([Long_create(4294770688, 65535), Long_fromInt(-8192), Long_create(4294967295, 131135), Long_create(4294966272, 70256639)]);
        oncipj_CypherTokenManager_jjbitVec59 = $rt_createLongArrayFromData([Long_create(71303167, 272), Long_create(33554431, 2047), Long_create(0, 4292870143), Long_fromInt(255)]);
        oncipj_CypherTokenManager_jjbitVec60 = $rt_createLongArrayFromData([Long_create(4294967280, 603979775), Long_create(4278255616, 4294836227), Long_create(4294549473, 600178175), Long_create(2952806400, 268632067)]);
        oncipj_CypherTokenManager_jjbitVec61 = $rt_createLongArrayFromData([Long_create(4294543328, 57540095), Long_create(1577058304, 1835008), Long_create(4294688736, 602799615), Long_create(65536, 33554435)]);
        oncipj_CypherTokenManager_jjbitVec62 = $rt_createLongArrayFromData([Long_create(4294549472, 602799615), Long_create(2952790016, 131075), Long_create(3594373096, 67094296), Long_fromInt(65536)]);
        oncipj_CypherTokenManager_jjbitVec63 = $rt_createLongArrayFromData([Long_create(4294828000, 603979263), Long_create(117440512, 3), Long_create(4294828001, 602930687), Long_create(1073741824, 393219)]);
        oncipj_CypherTokenManager_jjbitVec64 = $rt_createLongArrayFromData([Long_create(4294828016, 671088639), Long_create(2154840064, 4227858435), Long_create(4236247008, 805044223), Long_fromInt(127)]);
        oncipj_CypherTokenManager_jjbitVec65 = $rt_createLongArrayFromData([Long_create(4294967294, 917503), Long_fromInt(127), Long_create(4294965206, 537788335), Long_create(4026531935, 0)]);
        oncipj_CypherTokenManager_jjbitVec66 = $rt_createLongArrayFromData([Long_fromInt(1), Long_create(4294967039, 8191), Long_fromInt(7936), Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec67 = $rt_createLongArrayFromData([Long_create(4294967295, 2147485695), Long_create(1010761728, 4292984930), Long_create(16387, 4294967295), Long_create(4294910143, 4160749567)]);
        oncipj_CypherTokenManager_jjbitVec68 = $rt_createLongArrayFromData([Long_fromInt(-12713985), Long_fromInt(134217727), Long_create(65535, 4294967295), Long_create(4294967295, 1061158911)]);
        oncipj_CypherTokenManager_jjbitVec69 = $rt_createLongArrayFromData([Long_create(253951, 262143), Long_create(262143, 122879), Long_create(4294967295, 1048575), Long_fromInt(276824064)]);
        oncipj_CypherTokenManager_jjbitVec70 = $rt_createLongArrayFromData([Long_create(0, 4294967295), Long_create(4294967295, 33554431), Long_create(4294967199, 4294903295), Long_create(4294967295, 4194303)]);
        oncipj_CypherTokenManager_jjbitVec71 = $rt_createLongArrayFromData([Long_fromInt(2147483647), Long_create(4294901760, 2047999), Long_create(4294967295, 4294905855), Long_fromInt(1023)]);
        oncipj_CypherTokenManager_jjbitVec72 = $rt_createLongArrayFromData([Long_create(8388607, 4294967295), Long_fromInt(2097151), Long_create(0, 128), Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec73 = $rt_createLongArrayFromData([Long_create(4294967264, 1048575), Long_fromInt(4064), Long_create(4294967288, 4227907585), Long_create(4294967295, 63)]);
        oncipj_CypherTokenManager_jjbitVec74 = $rt_createLongArrayFromData([Long_create(4294967295, 15), Long_create(4227915776, 1073741823), Long_create(4294902271, 3892314111), Long_create(0, 74440192)]);
        oncipj_CypherTokenManager_jjbitVec75 = $rt_createLongArrayFromData([Long_create(0, 2147483648), Long_create(1048577, 2147614720), Long_fromInt(536805376), Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec76 = $rt_createLongArrayFromData([Long_create(4294967295, 4294934527), Long_create(2147483647, 4294967295), Long_fromInt(-1), Long_create(4294967295, 817183)]);
        oncipj_CypherTokenManager_jjbitVec77 = $rt_createLongArrayFromData([Long_create(4294967295, 4294910143), Long_create(4294967295, 33023), Long_create(8388607, 2139062143), Long_fromInt(2139062143)]);
        oncipj_CypherTokenManager_jjbitVec78 = $rt_createLongArrayFromData([Long_create(224, 524157950), Long_fromInt(-2), Long_create(3766484991, 4294967294), Long_create(4294967295, 4160749567)]);
        oncipj_CypherTokenManager_jjbitVec79 = $rt_createLongArrayFromData([Long_create(4294909951, 3072), Long_create(4294967295, 2147516415), Long_create(1073741823, 4294967295), Long_create(4294967295, 65535)]);
        oncipj_CypherTokenManager_jjbitVec80 = $rt_createLongArrayFromData([Long_create(4294965179, 7), Long_create(4294967295, 1048575), Long_create(4294967292, 1048575), Long_create(0, 1761345536)]);
        oncipj_CypherTokenManager_jjbitVec81 = $rt_createLongArrayFromData([Long_create(4294966272, 4294901823), Long_create(127, 536870911), Long_create(4294967280, 524287), Long_create(32768, 2080440287)]);
        oncipj_CypherTokenManager_jjbitVec82 = $rt_createLongArrayFromData([Long_create(4294967295, 511), Long_create(4087, 3296722943), Long_create(4294967295, 1046675455), Long_create(939524101, 1837055)]);
        oncipj_CypherTokenManager_jjbitVec83 = $rt_createLongArrayFromData([Long_create(8289918, 4294934399), Long_create(4160749567, 4294902783), Long_fromInt(-1), Long_create(4294967295, 7)]);
        oncipj_CypherTokenManager_jjbitVec84 = $rt_createLongArrayFromData([Long_create(2700607615, 1602223615), Long_fromInt(-37), Long_create(4294967295, 262143), Long_fromInt(-524288)]);
        oncipj_CypherTokenManager_jjbitVec85 = $rt_createLongArrayFromData([Long_create(4294967295, 1073741823), Long_fromInt(-65536), Long_fromInt(-196609), Long_create(255, 268369920)]);
        oncipj_CypherTokenManager_jjbitVec86 = $rt_createLongArrayFromData([Long_create(0, 1572864), Long_create(57344, 4292804608), Long_fromInt(-1), Long_create(4294967295, 536870911)]);
        oncipj_CypherTokenManager_jjbitVec87 = $rt_createLongArrayFromData([Long_create(0, 2281701374), Long_create(134217726, 4294967232), Long_create(4294967295, 2147483647), Long_fromInt(486341884)]);
        oncipj_CypherTokenManager_jjbitVec88 = $rt_createLongArrayFromData([Long_ZERO, Long_ZERO, Long_create(0, 8192), Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec89 = $rt_createLongArrayFromData([Long_fromInt(4128768), Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec90 = $rt_createLongArrayFromData([Long_ZERO, Long_create(16777216, 8), Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec91 = $rt_createLongArrayFromData([Long_fromInt(8192), Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec92 = $rt_createLongArrayFromData([Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 256)]);
        oncipj_CypherTokenManager_jjbitVec93 = $rt_createLongArrayFromData([Long_fromInt(256), Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec94 = $rt_createLongArrayFromData([Long_ZERO, Long_create(0, 16), Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec95 = $rt_createLongArrayFromData([Long_fromInt(268435456), Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec96 = $rt_createLongArrayFromData([Long_ZERO, Long_ZERO, Long_ZERO, Long_create(0, 512)]);
        oncipj_CypherTokenManager_jjbitVec97 = $rt_createLongArrayFromData([Long_fromInt(512), Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec98 = $rt_createLongArrayFromData([Long_ZERO, Long_create(0, 32), Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec99 = $rt_createLongArrayFromData([Long_fromInt(1073741824), Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjbitVec100 = $rt_createLongArrayFromData([Long_ZERO, Long_ZERO, Long_fromInt(-1), Long_fromInt(-1)]);
        oncipj_CypherTokenManager_jjstrLiteralImages = $rt_createArrayFromData(jl_String, [$rt_s(3), null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null,
        null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(189), null, null, null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(136), $rt_s(986), $rt_s(43), null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(987), null, null, $rt_s(134), $rt_s(142), $rt_s(151), null, null, null, null, null, null, null, null, null, null, null,
        null, null, null, $rt_s(988), null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(989), null, null, null, null, null, $rt_s(398), null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(191), $rt_s(990), $rt_s(143), $rt_s(146), $rt_s(991), null, null, null, null, null, $rt_s(24), $rt_s(397), null, null, null, null, $rt_s(992), $rt_s(192), $rt_s(993), $rt_s(994), null, null, null, null, null, null, null,
        null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(395), $rt_s(995), null, null, $rt_s(996), null, null, null, null, null, null, null, null, null, $rt_s(949), null, $rt_s(144), $rt_s(147), null, null, null, null, $rt_s(997), null, null, null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(25), null, null, null, null, null, null, null, $rt_s(998), null, null, null, null, null, null, null, null, null, null, null,
        null, null, null, null, null, null, null, null, null, null, null, null, $rt_s(305), null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null]);
        oncipj_CypherTokenManager_jjnextStates = $rt_createIntArrayFromData([39, 40, 51, 52, 53, 50, 61, 68, 11, 12, 13, 70, 72, 73, 1, 2, 3, 8, 5, 6, 7, 8, 39, 40, 50, 41, 42, 43, 48, 45, 46, 47, 48, 51, 52, 53, 55, 56, 57, 58, 62, 63, 65, 4, 5, 6, 7, 8, 44, 45, 46, 47, 48, 39, 40, 54, 55, 56, 57, 58]);
        oncipj_CypherTokenManager_lexStateNames = $rt_createArrayFromData(jl_String, [$rt_s(306), $rt_s(999), $rt_s(1000), $rt_s(1001), $rt_s(1002), $rt_s(1003), $rt_s(1004)]);
        oncipj_CypherTokenManager_jjnewLexState = $rt_createIntArrayFromData([(-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), 1, 2, 0, 0, (-1), (-1), (-1), (-1), (-1), (-1), (-1), 4, (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), 0, 5, (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), 0, 6, (-1), (-1), 0, (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1),
        (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1),
        (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1),
        (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1),
        (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1)]);
        oncipj_CypherTokenManager_jjtoToken = $rt_createLongArrayFromData([Long_create(1, 1048984), Long_fromInt(-15), Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(-1), Long_fromInt(255852543)]);
        oncipj_CypherTokenManager_jjtoSkip = $rt_createLongArrayFromData([Long_create(1073741822, 3), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjtoSpecial = $rt_createLongArrayFromData([Long_create(536870912, 3), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO]);
        oncipj_CypherTokenManager_jjtoMore = $rt_createLongArrayFromData([Long_create(3221225472, 4293918212), Long_fromInt(14), Long_ZERO, Long_ZERO, Long_ZERO, Long_ZERO]);
    }
    function oncipj_WithOffset() {
        var a = this; jl_Object.call(a);
        a.$beginOffset = 0;
        a.$endOffset = 0;
    }
    function oncipj_Token() {
        var a = this; oncipj_WithOffset.call(a);
        a.$kind0 = 0;
        a.$beginLine = 0;
        a.$beginColumn = 0;
        a.$endLine = 0;
        a.$endColumn = 0;
        a.$image0 = null;
        a.$next1 = null;
        a.$specialToken = null;
    }
    var onciu_InputPosition$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    function onciu_InputPosition$$_clinit_$lambda$_0_0_apply(var$0, var$1) {
        var$1 = var$1;
        onciu_InputPosition$_$callClinit();
        return jl_Integer_valueOf(var$1.$offset0);
    }
    var sm_Ordering$IntOrdering = $rt_classWithoutFields(0);
    var sm_Ordering$CachedReverse = $rt_classWithoutFields(0);
    var sm_Ordering$Int$ = $rt_classWithoutFields();
    var sm_Ordering$Int$_MODULE$ = null;
    var sm_Ordering$Int$_scala$math$Ordering$CachedReverse$$_reverse = null;
    function sm_Ordering$Int$_$callClinit() {
        sm_Ordering$Int$_$callClinit = $rt_eraseClinit(sm_Ordering$Int$);
        sm_Ordering$Int$__clinit_();
    }
    function sm_Ordering$Int$__clinit_() {
        var var$1, var$2;
        var$1 = new sm_Ordering$Int$;
        sm_Ordering$Int$_$callClinit();
        sm_Ordering$Int$_MODULE$ = var$1;
        var$2 = new sm_Ordering$Reverse;
        var$2.$outer = var$1;
        sm_Ordering$Int$_scala$math$Ordering$CachedReverse$$_reverse = var$2;
    }
    function sm_Ordering$Int$_lteq($this, $x, $y) {
        return sm_Ordering$Int$_compare($this, $x, $y) > 0 ? 0 : 1;
    }
    function sm_Ordering$Int$_gteq($this, $x, $y) {
        return sm_Ordering$Int$_compare($this, $x, $y) < 0 ? 0 : 1;
    }
    function sm_Ordering$Int$_lt($this, $x, $y) {
        return sm_Ordering$Int$_compare($this, $x, $y) >= 0 ? 0 : 1;
    }
    function sm_Ordering$Int$_max($this, $x, $y) {
        return sm_Ordering_max$($this, $x, $y);
    }
    function sm_Ordering$Int$_min($this, $x, $y) {
        return sm_Ordering_min$($this, $x, $y);
    }
    function sm_Ordering$Int$_compare($this, $x, $y) {
        return $rt_compare(sr_BoxesRunTime_unboxToInt($x), sr_BoxesRunTime_unboxToInt($y));
    }
    function onciu_InputPosition() {
        var a = this; jl_Object.call(a);
        a.$offset0 = 0;
        a.$line0 = 0;
        a.$column0 = 0;
    }
    function onciu_InputPosition__init_(var_0, var_1, var_2) {
        var var_3 = new onciu_InputPosition();
        onciu_InputPosition__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function onciu_InputPosition_toString($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$line0;
        var$2 = $this.$column0;
        var$3 = $this.$offset0;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$4, $rt_s(1005)), var$1), $rt_s(1006)), var$2), $rt_s(1007)), var$3), 41);
        return jl_AbstractStringBuilder_toString(var$4);
    }
    function onciu_InputPosition_productArity($this) {
        return 3;
    }
    function onciu_InputPosition_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Integer_valueOf($this.$offset0);
            case 1:
                return jl_Integer_valueOf($this.$line0);
            case 2:
                return jl_Integer_valueOf($this.$column0);
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function onciu_InputPosition_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_InputPosition_hashCode($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1008))), $this.$offset0), $this.$line0), $this.$column0), 3);
    }
    function onciu_InputPosition_equals($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_InputPosition) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$offset0 != $x$1.$offset0)
                        break b;
                    if ($this.$line0 != $x$1.$line0)
                        break b;
                    if ($this.$column0 != $x$1.$column0)
                        break b;
                    if (!($this instanceof onciu_InputPosition))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    }
    function onciu_InputPosition__init_0($this, $offset, $line, $column) {
        $this.$offset0 = $offset;
        $this.$line0 = $line;
        $this.$column0 = $column;
    }
    var oncias_SemanticFeature$UseAsMultipleGraphsSelector$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$UseAsMultipleGraphsSelector$_MODULE$ = null;
    function oncias_SemanticFeature$UseAsMultipleGraphsSelector$__clinit_() {
        oncias_SemanticFeature$UseAsMultipleGraphsSelector$_MODULE$ = new oncias_SemanticFeature$UseAsMultipleGraphsSelector$;
    }
    function oncias_SemanticFeature$UseAsMultipleGraphsSelector$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$UseAsMultipleGraphsSelector$_name($this) {
        return $rt_s(1009);
    }
    function oncias_SemanticFeature$UseAsMultipleGraphsSelector$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$UseAsMultipleGraphsSelector$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$UseAsMultipleGraphsSelector$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$UseAsMultipleGraphsSelector$_hashCode($this) {
        return 164738413;
    }
    var oncias_SemanticFeature$ShowSetting$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$ShowSetting$_MODULE$ = null;
    function oncias_SemanticFeature$ShowSetting$__clinit_() {
        oncias_SemanticFeature$ShowSetting$_MODULE$ = new oncias_SemanticFeature$ShowSetting$;
    }
    function oncias_SemanticFeature$ShowSetting$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$ShowSetting$_name($this) {
        return $rt_s(1010);
    }
    function oncias_SemanticFeature$ShowSetting$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$ShowSetting$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$ShowSetting$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$ShowSetting$_hashCode($this) {
        return (-252998541);
    }
    var oncias_SemanticFeature$GpmShortestPath$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$GpmShortestPath$_MODULE$ = null;
    function oncias_SemanticFeature$GpmShortestPath$__clinit_() {
        oncias_SemanticFeature$GpmShortestPath$_MODULE$ = new oncias_SemanticFeature$GpmShortestPath$;
    }
    function oncias_SemanticFeature$GpmShortestPath$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$GpmShortestPath$_name($this) {
        return $rt_s(1011);
    }
    function oncias_SemanticFeature$GpmShortestPath$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$GpmShortestPath$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$GpmShortestPath$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$GpmShortestPath$_hashCode($this) {
        return (-199053965);
    }
    var oncias_SemanticFeature$MatchModes$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$MatchModes$_MODULE$ = null;
    function oncias_SemanticFeature$MatchModes$__clinit_() {
        oncias_SemanticFeature$MatchModes$_MODULE$ = new oncias_SemanticFeature$MatchModes$;
    }
    function oncias_SemanticFeature$MatchModes$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$MatchModes$_name($this) {
        return $rt_s(1012);
    }
    function oncias_SemanticFeature$MatchModes$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$MatchModes$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$MatchModes$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$MatchModes$_hashCode($this) {
        return (-453025653);
    }
    var oncias_SemanticFeature$PropertyValueAccessRules$ = $rt_classWithoutFields();
    var oncias_SemanticFeature$PropertyValueAccessRules$_MODULE$ = null;
    function oncias_SemanticFeature$PropertyValueAccessRules$__clinit_() {
        oncias_SemanticFeature$PropertyValueAccessRules$_MODULE$ = new oncias_SemanticFeature$PropertyValueAccessRules$;
    }
    function oncias_SemanticFeature$PropertyValueAccessRules$_toString($this) {
        return $this.$name3();
    }
    function oncias_SemanticFeature$PropertyValueAccessRules$_name($this) {
        return $rt_s(1013);
    }
    function oncias_SemanticFeature$PropertyValueAccessRules$_productArity($this) {
        return 0;
    }
    function oncias_SemanticFeature$PropertyValueAccessRules$_productElement($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    }
    function oncias_SemanticFeature$PropertyValueAccessRules$_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncias_SemanticFeature$PropertyValueAccessRules$_hashCode($this) {
        return 426693591;
    }
    function oncifp_BaseState$statement$lambda$_13_0() {
        jl_Object.call(this);
        this.$_019 = null;
    }
    function oncifp_BaseState$statement$lambda$_13_0_apply(var$0) {
        return oncifp_InitialState_fail(var$0.$_019, $rt_s(1014));
    }
    function scm_Shrinkable$subtractAll$lambda$_6_0() {
        jl_Object.call(this);
        this.$_081 = null;
    }
    function scm_Shrinkable$subtractAll$lambda$_6_0_apply(var$0, var$1) {
        return var$0.$_081.$subtractOne(var$1);
    }
    function oncirc_containsNoMatchingNodes() {
        jl_Object.call(this);
        this.$matcher0 = null;
    }
    var oncirc_containsNoReturnAll$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirc_containsNoReturnAll$$anonfun$1_applyOrElse($this, $x, $default) {
        $x = $x;
        return $x instanceof oncia_ReturnItems && $x.$includeExisting ? $rt_s(1015) : s_PartialFunction$$anon$1_apply($default, $x);
    }
    var jnc_CoderMalfunctionError = $rt_classWithoutFields(jl_Error);
    var scm_MutationTracker$ = $rt_classWithoutFields();
    var scm_MutationTracker$_MODULE$ = null;
    function scm_MutationTracker$__clinit_() {
        scm_MutationTracker$_MODULE$ = new scm_MutationTracker$;
    }
    function scm_MutationTracker$_checkMutations($this, $expectedCount, $actualCount, $message) {
        var var$4;
        if ($actualCount == $expectedCount)
            return;
        var$4 = new ju_ConcurrentModificationException;
        jl_Throwable__init_(var$4, $message);
        $rt_throw(var$4);
    }
    var oncias_SemanticState$withFeatures$lambda$_40_0 = $rt_classWithoutFields();
    function oncias_SemanticState$withFeatures$lambda$_40_0_apply(var$0, var$1, var$2) {
        var var$3;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = var$1.$features1.$incl(var$2);
        return oncias_SemanticState_copy(var$1, var$1.$currentScope, var$1.$typeTable, var$1.$recordedScopes, var$1.$notifications, var$3, var$1.$declareVariablesToSuppressDuplicateErrors, var$1.$semanticCheckHasRunOnce);
    }
    function sci_Vector2() {
        var a = this; sci_BigVector.call(a);
        a.$len10 = 0;
        a.$data20 = null;
    }
    function sci_Vector2__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new sci_Vector2();
        sci_Vector2__init_0(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    function sci_Vector2_len1($this) {
        return $this.$len10;
    }
    function sci_Vector2_data2($this) {
        return $this.$data20;
    }
    function sci_Vector2_apply($this, $index) {
        var $io, $i2, $i1, var$5;
        if ($index >= 0 && $index < $this.$length00) {
            $io = $index - $this.$len10 | 0;
            if ($io < 0)
                return $this.$prefix10.data[$index];
            $i2 = $io >>> 5;
            $i1 = $io & 31;
            var$5 = $this.$data20.data;
            if ($i2 >= var$5.length)
                return $this.$suffix1.data[$i1];
            return var$5[$i2].data[$i1];
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector2_updated($this, $index, $elem) {
        var var$3, var$4, $copyUpdate_a1c, $io, $i2, $i1, $copyUpdate_a1c_0, $copyUpdate_a2c, $copyUpdate_copyUpdate_a1c;
        if ($index >= 0) {
            var$3 = $this.$length00;
            if ($index < var$3) {
                var$4 = $this.$len10;
                if ($index < var$4) {
                    $copyUpdate_a1c = $this.$prefix10.$clone();
                    $copyUpdate_a1c.data[$index] = $elem;
                    return sci_Vector2__init_($copyUpdate_a1c, var$4, $this.$data20, $this.$suffix1, var$3);
                }
                $io = $index - var$4 | 0;
                $i2 = $io >>> 5;
                $i1 = $io & 31;
                $copyUpdate_a1c = $this.$data20;
                if ($i2 >= $copyUpdate_a1c.data.length) {
                    $copyUpdate_a1c_0 = $this.$suffix1.$clone();
                    $copyUpdate_a1c_0.data[$i1] = $elem;
                    return sci_Vector2__init_($this.$prefix10, var$4, $copyUpdate_a1c, $copyUpdate_a1c_0, var$3);
                }
                $copyUpdate_a2c = $copyUpdate_a1c.$clone();
                $copyUpdate_a1c = $copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$i2].$clone();
                $copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copyUpdate_a1c[$i2] = $copyUpdate_copyUpdate_a1c;
                return sci_Vector2__init_($this.$prefix10, var$4, $copyUpdate_a2c, $this.$suffix1, var$3);
            }
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector2_appended($this, $elem) {
        var $wrap1_a, $x$1, $x$2, $x$9, $x$6, $wrap1_a_0, $x$8, var$9, $x$10, $wrap2_a;
        $wrap1_a = $this.$suffix1;
        if ($wrap1_a.data.length < 32) {
            $x$1 = sci_VectorStatics$_copyAppend1(sci_VectorStatics$_MODULE$, $wrap1_a, $elem);
            $x$2 = $this.$length00 + 1 | 0;
            return sci_Vector2__init_($this.$prefix10, $this.$len10, $this.$data20, $x$1, $x$2);
        }
        $x$9 = $this.$data20;
        if ($x$9.data.length < 30) {
            $x$6 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, $x$9, $wrap1_a);
            $wrap1_a_0 = $rt_createArray(jl_Object, 1);
            $wrap1_a_0.data[0] = $elem;
            $x$8 = $this.$length00 + 1 | 0;
            return sci_Vector2__init_($this.$prefix10, $this.$len10, $x$6, $wrap1_a_0, $x$8);
        }
        var$9 = new sci_Vector3;
        $wrap1_a_0 = $this.$prefix10;
        $x$10 = $this.$len10;
        $x$2 = 960 + $x$10 | 0;
        $x$6 = sci_VectorStatics$_empty3;
        $wrap2_a = $rt_createArray($rt_arraycls(jl_Object), 1);
        $wrap2_a.data[0] = $wrap1_a;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        sci_Vector3__init_0(var$9, $wrap1_a_0, $x$10, $x$9, $x$2, $x$6, $wrap2_a, $wrap1_a, $this.$length00 + 1 | 0);
        return var$9;
    }
    function sci_Vector2_prepended($this, $elem) {
        var $x$2, $x$1, $x$3, $x$8, $wrap1_a, $x$9, var$8, $wrap2_x, $wrap2_a;
        $x$2 = $this.$len10;
        if ($x$2 < 32) {
            $x$1 = sci_VectorStatics$_copyPrepend1(sci_VectorStatics$_MODULE$, $elem, $this.$prefix10);
            $x$2 = $this.$len10 + 1 | 0;
            $x$3 = $this.$length00 + 1 | 0;
            return sci_Vector2__init_($x$1, $x$2, $this.$data20, $this.$suffix1, $x$3);
        }
        $x$8 = $this.$data20;
        if ($x$8.data.length < 30) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$8 = sci_VectorStatics$_copyPrepend(sci_VectorStatics$_MODULE$, $this.$prefix10, $x$8);
            $x$9 = $this.$length00 + 1 | 0;
            return sci_Vector2__init_($wrap1_a, 1, $x$8, $this.$suffix1, $x$9);
        }
        var$8 = new sci_Vector3;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $wrap2_x = $this.$prefix10;
        $wrap2_a = $rt_createArray($rt_arraycls(jl_Object), 1);
        $wrap2_a.data[0] = $wrap2_x;
        sci_Vector3__init_0(var$8, $wrap1_a, 1, $wrap2_a, $x$2 + 1 | 0, sci_VectorStatics$_empty3, $x$8, $this.$suffix1, $this.$length00 + 1 | 0);
        return var$8;
    }
    function sci_Vector2_map($this, $f) {
        var $x$1, $mapElems1_i, $x$2, $mapElemsRest_mapElems_mapElems1_i, $mapElems1_v1, $mapElems1_v2, $x$1_0, $mapElems1_mapElems1Rest_i, $mapElems_this, $mapElems_a, $mapElems_i, $mapElems_v1, $mapElems_v2, $mapElemsRest_ac, $mapElemsRest_i, $mapElemsRest_mapElems_a, $mapElemsRest_mapElems_mapElems1_v1, $mapElemsRest_mapElems_mapElems1_v2, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i, $x$3, $x$3_0;
        $x$1 = $this.$prefix10;
        $mapElems1_i = 0;
        a: {
            while (true) {
                $x$2 = $x$1.data;
                $mapElemsRest_mapElems_mapElems1_i = $x$2.length;
                if ($mapElems1_i >= $mapElemsRest_mapElems_mapElems1_i)
                    break;
                $mapElems1_v1 = $x$2[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$1_0 = $rt_createArray(jl_Object, $mapElemsRest_mapElems_mapElems1_i);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$1, 0, $x$1_0, 0, $mapElems1_i);
                    $x$1 = $x$1_0.data;
                    $x$1[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElemsRest_mapElems_mapElems1_i) {
                        $x$1[$mapElems1_mapElems1Rest_i] = $f.$apply($x$2[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$1 = $x$1_0;
                    break a;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = $this.$data20;
        $mapElems_i = 0;
        b: {
            while (true) {
                $x$2 = $mapElems_a.data;
                $mapElems1_i = $x$2.length;
                if ($mapElems_i >= $mapElems1_i)
                    break;
                $mapElems_v1 = $x$2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElemsRest_ac = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($mapElems_a)), $mapElems1_i);
                    if ($mapElems_i > 0)
                        jl_System_arraycopy($mapElems_a, 0, $mapElemsRest_ac, 0, $mapElems_i);
                    $x$1_0 = $mapElemsRest_ac.data;
                    $x$1_0[$mapElems_i] = $mapElems_v2;
                    $mapElemsRest_i = $mapElems_i + 1 | 0;
                    while ($mapElemsRest_i < $mapElems1_i) {
                        $mapElemsRest_mapElems_a = $x$2[$mapElemsRest_i];
                        $mapElemsRest_mapElems_mapElems1_i = 0;
                        c: {
                            while (true) {
                                $mapElems_a = $mapElemsRest_mapElems_a.data;
                                $mapElems_i = $mapElems_a.length;
                                if ($mapElemsRest_mapElems_mapElems1_i >= $mapElems_i)
                                    break;
                                $mapElemsRest_mapElems_mapElems1_v1 = $mapElems_a[$mapElemsRest_mapElems_mapElems1_i];
                                $mapElemsRest_mapElems_mapElems1_v2 = $f.$apply($mapElemsRest_mapElems_mapElems1_v1);
                                if ($mapElemsRest_mapElems_mapElems1_v1 !== $mapElemsRest_mapElems_mapElems1_v2) {
                                    $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac = $rt_createArray(jl_Object, $mapElems_i);
                                    if ($mapElemsRest_mapElems_mapElems1_i > 0)
                                        jl_System_arraycopy($mapElemsRest_mapElems_a, 0, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, 0, $mapElemsRest_mapElems_mapElems1_i);
                                    $mapElemsRest_mapElems_a = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac.data;
                                    $mapElemsRest_mapElems_a[$mapElemsRest_mapElems_mapElems1_i] = $mapElemsRest_mapElems_mapElems1_v2;
                                    $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                                    while ($mapElemsRest_mapElems_mapElems1_mapElems1Rest_i < $mapElems_i) {
                                        $mapElemsRest_mapElems_a[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_a[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i]);
                                        $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i + 1 | 0;
                                    }
                                    $mapElemsRest_mapElems_a = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac;
                                    break c;
                                }
                                $mapElemsRest_mapElems_mapElems1_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                            }
                        }
                        $x$1_0[$mapElemsRest_i] = $mapElemsRest_mapElems_a;
                        $mapElemsRest_i = $mapElemsRest_i + 1 | 0;
                    }
                    $mapElems_a = $mapElemsRest_ac;
                    break b;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$2 = $mapElems_a;
        $x$3 = $this.$suffix1;
        $mapElems1_i = 0;
        d: {
            while (true) {
                $x$1_0 = $x$3.data;
                $mapElems_i = $x$1_0.length;
                if ($mapElems1_i >= $mapElems_i)
                    break;
                $mapElems1_v1 = $x$1_0[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$3_0 = $rt_createArray(jl_Object, $mapElems_i);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$3, 0, $x$3_0, 0, $mapElems1_i);
                    $mapElemsRest_ac = $x$3_0.data;
                    $mapElemsRest_ac[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElems_i) {
                        $mapElemsRest_ac[$mapElems1_mapElems1Rest_i] = $f.$apply($x$1_0[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$3 = $x$3_0;
                    break d;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        return sci_Vector2__init_($x$1, $this.$len10, $x$2, $x$3, $this.$length00);
    }
    function sci_Vector2_slice0($this, $lo, $hi) {
        var $b;
        $b = sci_VectorSliceBuilder__init_($lo, $hi);
        sci_VectorSliceBuilder_consider($b, 1, $this.$prefix10);
        sci_VectorSliceBuilder_consider($b, 2, $this.$data20);
        sci_VectorSliceBuilder_consider($b, 1, $this.$suffix1);
        return sci_VectorSliceBuilder_result($b);
    }
    function sci_Vector2_init($this) {
        var $x$3, $x$4, $x$1, $x$2;
        $x$3 = $this.$suffix1;
        $x$4 = $x$3.data.length;
        if ($x$4 <= 1)
            return sci_Vector2_slice0($this, 0, $this.$length00 - 1 | 0);
        $x$1 = ju_Arrays_copyOfRange($x$3, 0, $x$4 - 1 | 0);
        $x$2 = $this.$length00 - 1 | 0;
        return sci_Vector2__init_($this.$prefix10, $this.$len10, $this.$data20, $x$1, $x$2);
    }
    function sci_Vector2_vectorSliceCount($this) {
        return 3;
    }
    function sci_Vector2_vectorSlice($this, $idx) {
        switch ($idx) {
            case 0:
                break;
            case 1:
                return $this.$data20;
            case 2:
                return $this.$suffix1;
            default:
                $rt_throw(s_MatchError__init_(jl_Integer_valueOf($idx)));
        }
        return $this.$prefix10;
    }
    function sci_Vector2_appendedAll0($this, $suffix, $k) {
        var $suffix1b, $x$3, $x$2;
        $suffix1b = sci_VectorStatics$_append1IfSpace(sci_VectorStatics$_MODULE$, $this.$suffix1, $suffix);
        if ($suffix1b === null)
            return sci_Vector_appendedAll0($this, $suffix, $k);
        $x$3 = $suffix1b.data;
        $x$2 = ($this.$length00 - $this.$suffix1.data.length | 0) + $x$3.length | 0;
        return sci_Vector2__init_($this.$prefix10, $this.$len10, $this.$data20, $suffix1b, $x$2);
    }
    function sci_Vector2_init0($this) {
        return sci_Vector2_init($this);
    }
    function sci_Vector2_tail($this) {
        var var$1, var$2, var$3, var$4, var$5;
        if ($this.$len10 <= 1)
            var$1 = sci_Vector2_slice0($this, 1, $this.$length00);
        else {
            var$2 = $this.$prefix10;
            var$3 = ju_Arrays_copyOfRange(var$2, 1, var$2.data.length);
            var$4 = $this.$len10 - 1 | 0;
            var$5 = $this.$length00 - 1 | 0;
            var$1 = sci_Vector2__init_(var$3, var$4, $this.$data20, $this.$suffix1, var$5);
        }
        return var$1;
    }
    function sci_Vector2_map0($this, $f) {
        return sci_Vector2_map($this, $f);
    }
    function sci_Vector2_prepended0($this, $elem) {
        return sci_Vector2_prepended($this, $elem);
    }
    function sci_Vector2_appended0($this, $elem) {
        return sci_Vector2_appended($this, $elem);
    }
    function sci_Vector2_updated0($this, $index, $elem) {
        return sci_Vector2_updated($this, $index, $elem);
    }
    function sci_Vector2_apply0($this, $v1) {
        return sci_Vector2_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_Vector2__init_0($this, $_prefix1, $len1, $data2, $_suffix1, $_length0) {
        $this.$len10 = $len1;
        $this.$data20 = $data2;
        sci_BigVector__init_($this, $_prefix1, $_suffix1, $_length0);
    }
    function oncias_ScopeTreeVerifier$$verify$lambda$_1_0() {
        jl_Object.call(this);
        this.$_034 = null;
    }
    function oncias_ScopeTreeVerifier$$verify$lambda$_1_0_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_034;
        var$3 = var$1.$symbolTable;
        var$4 = new oncias_ScopeTreeVerifier$$anonfun$$nestedInanonfun$verify$1$1;
        var$4.$scope$1 = var$1;
        var$4.$root$1 = var$2;
        return var$3.$collect0(var$4);
    }
    function s_PartialFunction$Lifted() {
        sr_AbstractFunction1.call(this);
        this.$pf = null;
    }
    function s_PartialFunction$Lifted_apply($this, $v1) {
        var var$2;
        var$2 = $this.$pf.$applyOrElse($v1, s_PartialFunction$_fallback_fn);
        return s_PartialFunction$_scala$PartialFunction$$fallbackOccurred(s_PartialFunction$_MODULE$, var$2) ? s_None$_MODULE$ : s_Some__init_(var$2);
    }
    function s_PartialFunction$Unlifted() {
        sr_AbstractPartialFunction.call(this);
        this.$f2 = null;
    }
    function s_PartialFunction$Unlifted_applyOrElse($this, $x, $default) {
        $x = oncir_Deprecations$semanticallyDeprecatedFeatures$_$anonfun$find$1($this.$f2.$_026, $x);
        if ($x === null)
            $rt_throw(null);
        if (!s_Option_isEmpty($x))
            return $x.$get0();
        return s_PartialFunction$_fallback_fn;
    }
    function oncipj_ParseException() {
        var a = this; jl_Exception.call(a);
        a.$currentToken = null;
        a.$expectedTokenSequences = null;
        a.$tokenImage = null;
    }
    var oncipj_ParseException_EOL = null;
    function oncipj_ParseException__init_() {
        var var_0 = new oncipj_ParseException();
        oncipj_ParseException__init_1(var_0);
        return var_0;
    }
    function oncipj_ParseException__init_0(var_0) {
        var var_1 = new oncipj_ParseException();
        oncipj_ParseException__init_2(var_1, var_0);
        return var_1;
    }
    function oncipj_ParseException__init_1($this) {
        jl_Throwable__init_0($this);
    }
    function oncipj_ParseException__init_2($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    function oncipj_ParseException__initialise($currentToken, $expectedTokenSequences, $tokenImage) {
        var $expected, $maxSize, $i, var$7, $j, $sb, $tok, $i_0, $tokenText, var$13, var$14, var$15, var$16, var$17, var$18;
        $expected = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($expected);
        $maxSize = 0;
        $i = 0;
        while (true) {
            var$7 = $expectedTokenSequences.data;
            $j = var$7.length;
            if ($i >= $j)
                break;
            if ($maxSize < var$7[$i].data.length)
                $maxSize = var$7[$i].data.length;
            $j = 0;
            while ($j < var$7[$i].data.length) {
                jl_AbstractStringBuilder_append1($expected, $tokenImage.data[var$7[$i].data[$j]]);
                jl_AbstractStringBuilder_append($expected, 32);
                $j = $j + 1 | 0;
            }
            if (var$7[$i].data[var$7[$i].data.length - 1 | 0])
                jl_AbstractStringBuilder_append1($expected, $rt_s(1016));
            jl_AbstractStringBuilder_append1($expected, oncipj_ParseException_EOL);
            jl_AbstractStringBuilder_append1($expected, $rt_s(1017));
            $i = $i + 1 | 0;
        }
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        jl_AbstractStringBuilder_append1($sb, $rt_s(1018));
        $tok = $currentToken.$next1;
        $i_0 = 0;
        a: {
            while (true) {
                if ($i_0 >= $maxSize)
                    break a;
                $tokenText = $tok.$image0;
                var$13 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$13);
                var$14 = 0;
                while (var$14 < jl_String_length($tokenText)) {
                    b: {
                        $i = jl_String_charAt($tokenText, var$14);
                        switch ($i) {
                            case 8:
                                break;
                            case 9:
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(1019));
                                break b;
                            case 10:
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(1020));
                                break b;
                            case 12:
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(1021));
                                break b;
                            case 13:
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(1022));
                                break b;
                            case 34:
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(1023));
                                break b;
                            case 39:
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(1024));
                                break b;
                            case 92:
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(183));
                                break b;
                            default:
                                if ($i >= 32 && $i <= 126) {
                                    jl_AbstractStringBuilder_append(var$13, $i);
                                    break b;
                                }
                                var$15 = jl_Integer_toString($i, 16);
                                var$16 = new jl_StringBuilder;
                                jl_AbstractStringBuilder__init_(var$16);
                                jl_StringBuilder_append(jl_StringBuilder_append(var$16, $rt_s(1025)), var$15);
                                var$16 = jl_AbstractStringBuilder_toString(var$16);
                                jl_AbstractStringBuilder_append1(var$13, $rt_s(1026));
                                jl_AbstractStringBuilder_append1(var$13, jl_String_substring0(var$16, jl_String_length(var$16) - 4 | 0, jl_String_length(var$16)));
                                break b;
                        }
                        jl_AbstractStringBuilder_append1(var$13, $rt_s(1027));
                    }
                    var$14 = var$14 + 1 | 0;
                }
                var$15 = jl_AbstractStringBuilder_toString(var$13);
                if ($i_0)
                    jl_AbstractStringBuilder_append($sb, 32);
                var$17 = $tok.$kind0;
                if (!var$17)
                    break;
                var$16 = $tokenImage.data[var$17];
                var$18 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$18);
                jl_AbstractStringBuilder_append(var$18, 32);
                jl_StringBuilder_append(var$18, var$16);
                jl_AbstractStringBuilder_append1($sb, jl_AbstractStringBuilder_toString(var$18));
                jl_AbstractStringBuilder_append1($sb, $rt_s(1028));
                jl_AbstractStringBuilder_append1($sb, var$15);
                jl_AbstractStringBuilder_append1($sb, $rt_s(185));
                $tok = $tok.$next1;
                $i_0 = $i_0 + 1 | 0;
            }
            jl_AbstractStringBuilder_append1($sb, $tokenImage.data[0]);
        }
        jl_AbstractStringBuilder_append1($sb, $rt_s(1029));
        var$15 = jl_StringBuilder_append0($sb, $currentToken.$next1.$beginLine);
        jl_AbstractStringBuilder_append1(var$15, $rt_s(1006));
        jl_StringBuilder_append0(var$15, $currentToken.$next1.$beginColumn);
        jl_AbstractStringBuilder_append1($sb, $rt_s(142));
        jl_AbstractStringBuilder_append1($sb, oncipj_ParseException_EOL);
        if ($j) {
            jl_AbstractStringBuilder_append1($sb, oncipj_ParseException_EOL);
            jl_AbstractStringBuilder_append1($sb, $rt_s(1030));
            jl_AbstractStringBuilder_append1($sb, $j != 1 ? $rt_s(1031) : $rt_s(136));
            jl_AbstractStringBuilder_append1($sb, oncipj_ParseException_EOL);
            jl_AbstractStringBuilder_append1($sb, oncipj_ParseException_EOL);
            jl_AbstractStringBuilder_append0($sb, $expected);
        }
        return jl_AbstractStringBuilder_toString($sb);
    }
    function oncipj_ParseException__clinit_() {
        oncipj_ParseException_EOL = jl_System_getProperty0($rt_s(137), $rt_s(66));
    }
    function oncipj_InvalidUnicodeLiteral() {
        var a = this; jl_RuntimeException.call(a);
        a.$offset = 0;
        a.$line = 0;
        a.$column = 0;
    }
    var oncipj_ParseExceptions = $rt_classWithoutFields(jl_RuntimeException);
    var s_Product3 = $rt_classWithoutFields(0);
    function s_Tuple3() {
        var a = this; jl_Object.call(a);
        a.$_121 = null;
        a.$_212 = null;
        a.$_35 = null;
    }
    function s_Tuple3__init_(var_0, var_1, var_2) {
        var var_3 = new s_Tuple3();
        s_Tuple3__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function s_Tuple3_productArity($this) {
        return 3;
    }
    function s_Tuple3_productElement($this, $n) {
        var var$2, var$3;
        a: {
            switch ($n) {
                case 0:
                    break;
                case 1:
                    var$2 = $this.$_212;
                    break a;
                case 2:
                    var$2 = $this.$_35;
                    break a;
                default:
                    var$3 = new jl_IndexOutOfBoundsException;
                    var$2 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_2(var$2, 32);
                    var$2 = jl_StringBuilder_append0(var$2, $n);
                    jl_AbstractStringBuilder_append1(var$2, $rt_s(1032));
                    jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$2));
                    $rt_throw(var$3);
            }
            var$2 = $this.$_121;
        }
        return var$2;
    }
    function s_Tuple3__1($this) {
        return $this.$_121;
    }
    function s_Tuple3_toString($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 4);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(24));
        var$1 = jl_StringBuilder_append(var$1, $this.$_121);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_212);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_35);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(25));
        return jl_AbstractStringBuilder_toString(var$1);
    }
    function s_Tuple3_productPrefix($this) {
        return $rt_s(1033);
    }
    function s_Tuple3_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function s_Tuple3_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    }
    function s_Tuple3_equals($this, $x$1) {
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof s_Tuple3) ? 0 : 1))
                    break a;
                $x$1 = $x$1;
                if (!sr_BoxesRunTime_equals($this.$_121, $x$1.$_121))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_212, $x$1.$_212))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_35, $x$1.$_35))
                    break a;
            }
            return 1;
        }
        return 0;
    }
    function s_Tuple3__init_0($this, $_1, $_2, $_3) {
        $this.$_121 = $_1;
        $this.$_212 = $_2;
        $this.$_35 = $_3;
    }
    var scm_Queue$ = $rt_classWithoutFields();
    var scm_Queue$_MODULE$ = null;
    function scm_Queue$__clinit_() {
        scm_Queue$_MODULE$ = new scm_Queue$;
    }
    function scm_Queue$_empty($this) {
        var var$1;
        var$1 = new scm_Queue;
        scm_ArrayDeque__init_(var$1, scm_ArrayDeque$_alloc(scm_ArrayDeque$_MODULE$, 16), 0, 0);
        return var$1;
    }
    function scm_Queue$_newBuilder($this) {
        return scm_GrowableBuilder__init_0(scm_Queue$_empty($this));
    }
    function scm_Queue$_from($this, $source) {
        var var$2;
        var$2 = scm_Queue$_empty($this);
        if (var$2 === null)
            $rt_throw(null);
        return scm_ArrayDeque_addAll(var$2, $source);
    }
    function sci_ArraySeq$ofInt() {
        sci_ArraySeq.call(this);
        this.$unsafeArray2 = null;
    }
    function sci_ArraySeq$ofInt__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofInt();
        sci_ArraySeq$ofInt__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofInt_length($this) {
        return $this.$unsafeArray2.data.length;
    }
    function sci_ArraySeq$ofInt_apply($this, $i) {
        return $this.$unsafeArray2.data[$i];
    }
    function sci_ArraySeq$ofInt_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mIc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray2);
    }
    function sci_ArraySeq$ofInt_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofInt))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals0($this.$unsafeArray2, $that.$unsafeArray2);
    }
    function sci_ArraySeq$ofInt_sorted($this, $ord) {
        var var$2, $a;
        var$2 = $this.$unsafeArray2;
        if (var$2.data.length <= 1)
            return $this;
        sm_Ordering$Int$_$callClinit();
        if ($ord !== sm_Ordering$Int$_MODULE$)
            return sci_ArraySeq_sorted($this, $ord);
        $a = var$2.$clone();
        ju_Arrays_sort0($a);
        return sci_ArraySeq$ofInt__init_($a);
    }
    function sci_ArraySeq$ofInt_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcI$sp__init_($this.$unsafeArray2);
    }
    function sci_ArraySeq$ofInt_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Integer))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToInt($elem);
        $elem = new sci_ArraySeq$ofInt;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray2;
        var$6 = jl_Integer_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofInt__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Int0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofInt_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Integer))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToInt($elem);
        var$3 = new sci_ArraySeq$ofInt;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray2;
        var$5 = jl_Integer_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofInt__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Int0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofInt_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Integer))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToInt($elem);
        var$3 = new sci_ArraySeq$ofInt;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray2;
        var$5 = jl_Integer_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofInt__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Int0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofInt_prepended0($this, $elem) {
        return sci_ArraySeq$ofInt_prepended($this, $elem);
    }
    function sci_ArraySeq$ofInt_appended0($this, $elem) {
        return sci_ArraySeq$ofInt_appended($this, $elem);
    }
    function sci_ArraySeq$ofInt_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofInt_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofInt_sorted0($this, $ord) {
        return sci_ArraySeq$ofInt_sorted($this, $ord);
    }
    function sci_ArraySeq$ofInt_apply0($this, $v1) {
        return jl_Integer_valueOf(sci_ArraySeq$ofInt_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofInt_apply1($this, $i) {
        return jl_Integer_valueOf(sci_ArraySeq$ofInt_apply($this, $i));
    }
    function sci_ArraySeq$ofInt_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Int0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofInt_unsafeArray($this) {
        return $this.$unsafeArray2;
    }
    function sci_ArraySeq$ofInt__init_0($this, $unsafeArray) {
        $this.$unsafeArray2 = $unsafeArray;
    }
    function sci_ArraySeq$ofDouble() {
        sci_ArraySeq.call(this);
        this.$unsafeArray3 = null;
    }
    function sci_ArraySeq$ofDouble__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofDouble();
        sci_ArraySeq$ofDouble__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofDouble_length($this) {
        return $this.$unsafeArray3.data.length;
    }
    function sci_ArraySeq$ofDouble_apply($this, $i) {
        return $this.$unsafeArray3.data[$i];
    }
    function sci_ArraySeq$ofDouble_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mDc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray3);
    }
    function sci_ArraySeq$ofDouble_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofDouble))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals5($this.$unsafeArray3, $that.$unsafeArray3);
    }
    function sci_ArraySeq$ofDouble_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcD$sp__init_($this.$unsafeArray3);
    }
    function sci_ArraySeq$ofDouble_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Double))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToDouble($elem);
        $elem = new sci_ArraySeq$ofDouble;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray3;
        var$6 = jl_Double_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofDouble__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Double0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofDouble_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Double))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToDouble($elem);
        var$3 = new sci_ArraySeq$ofDouble;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray3;
        var$5 = jl_Double_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofDouble__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Double0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofDouble_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Double))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToDouble($elem);
        var$3 = new sci_ArraySeq$ofDouble;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray3;
        var$5 = jl_Double_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofDouble__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Double0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofDouble_prepended0($this, $elem) {
        return sci_ArraySeq$ofDouble_prepended($this, $elem);
    }
    function sci_ArraySeq$ofDouble_appended0($this, $elem) {
        return sci_ArraySeq$ofDouble_appended($this, $elem);
    }
    function sci_ArraySeq$ofDouble_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofDouble_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofDouble_apply0($this, $v1) {
        return jl_Double_valueOf(sci_ArraySeq$ofDouble_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofDouble_apply1($this, $i) {
        return jl_Double_valueOf(sci_ArraySeq$ofDouble_apply($this, $i));
    }
    function sci_ArraySeq$ofDouble_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Double0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofDouble_unsafeArray($this) {
        return $this.$unsafeArray3;
    }
    function sci_ArraySeq$ofDouble__init_0($this, $unsafeArray) {
        $this.$unsafeArray3 = $unsafeArray;
    }
    function sci_ArraySeq$ofLong() {
        sci_ArraySeq.call(this);
        this.$unsafeArray4 = null;
    }
    function sci_ArraySeq$ofLong__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofLong();
        sci_ArraySeq$ofLong__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofLong_length($this) {
        return $this.$unsafeArray4.data.length;
    }
    function sci_ArraySeq$ofLong_apply($this, $i) {
        return $this.$unsafeArray4.data[$i];
    }
    function sci_ArraySeq$ofLong_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mJc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray4);
    }
    function sci_ArraySeq$ofLong_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofLong))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals($this.$unsafeArray4, $that.$unsafeArray4);
    }
    function sci_ArraySeq$ofLong_sorted($this, $ord) {
        var var$2, $a;
        var$2 = $this.$unsafeArray4;
        if (var$2.data.length <= 1)
            return $this;
        if ($ord !== sm_Ordering$Long$_MODULE$)
            return sci_ArraySeq_sorted($this, $ord);
        $a = var$2.$clone();
        ju_Arrays_sort1($a);
        return sci_ArraySeq$ofLong__init_($a);
    }
    function sci_ArraySeq$ofLong_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcJ$sp__init_($this.$unsafeArray4);
    }
    function sci_ArraySeq$ofLong_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Long))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToLong($elem);
        $elem = new sci_ArraySeq$ofLong;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray4;
        var$6 = jl_Long_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofLong__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Long0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofLong_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Long))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToLong($elem);
        var$3 = new sci_ArraySeq$ofLong;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray4;
        var$5 = jl_Long_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofLong__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Long0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofLong_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Long))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToLong($elem);
        var$3 = new sci_ArraySeq$ofLong;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray4;
        var$5 = jl_Long_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofLong__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Long0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofLong_prepended0($this, $elem) {
        return sci_ArraySeq$ofLong_prepended($this, $elem);
    }
    function sci_ArraySeq$ofLong_appended0($this, $elem) {
        return sci_ArraySeq$ofLong_appended($this, $elem);
    }
    function sci_ArraySeq$ofLong_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofLong_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofLong_sorted0($this, $ord) {
        return sci_ArraySeq$ofLong_sorted($this, $ord);
    }
    function sci_ArraySeq$ofLong_apply0($this, $v1) {
        return jl_Long_valueOf(sci_ArraySeq$ofLong_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofLong_apply1($this, $i) {
        return jl_Long_valueOf(sci_ArraySeq$ofLong_apply($this, $i));
    }
    function sci_ArraySeq$ofLong_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Long0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofLong_unsafeArray($this) {
        return $this.$unsafeArray4;
    }
    function sci_ArraySeq$ofLong__init_0($this, $unsafeArray) {
        $this.$unsafeArray4 = $unsafeArray;
    }
    function sci_ArraySeq$ofFloat() {
        sci_ArraySeq.call(this);
        this.$unsafeArray5 = null;
    }
    function sci_ArraySeq$ofFloat__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofFloat();
        sci_ArraySeq$ofFloat__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofFloat_length($this) {
        return $this.$unsafeArray5.data.length;
    }
    function sci_ArraySeq$ofFloat_apply($this, $i) {
        return $this.$unsafeArray5.data[$i];
    }
    function sci_ArraySeq$ofFloat_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mFc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray5);
    }
    function sci_ArraySeq$ofFloat_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofFloat))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals4($this.$unsafeArray5, $that.$unsafeArray5);
    }
    function sci_ArraySeq$ofFloat_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcF$sp__init_($this.$unsafeArray5);
    }
    function sci_ArraySeq$ofFloat_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Float))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToFloat($elem);
        $elem = new sci_ArraySeq$ofFloat;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray5;
        var$6 = jl_Float_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofFloat__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Float0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofFloat_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Float))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToFloat($elem);
        var$3 = new sci_ArraySeq$ofFloat;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray5;
        var$5 = jl_Float_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofFloat__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Float0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofFloat_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Float))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToFloat($elem);
        var$3 = new sci_ArraySeq$ofFloat;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray5;
        var$5 = jl_Float_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofFloat__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Float0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofFloat_prepended0($this, $elem) {
        return sci_ArraySeq$ofFloat_prepended($this, $elem);
    }
    function sci_ArraySeq$ofFloat_appended0($this, $elem) {
        return sci_ArraySeq$ofFloat_appended($this, $elem);
    }
    function sci_ArraySeq$ofFloat_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofFloat_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofFloat_apply0($this, $v1) {
        return jl_Float_valueOf(sci_ArraySeq$ofFloat_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofFloat_apply1($this, $i) {
        return jl_Float_valueOf(sci_ArraySeq$ofFloat_apply($this, $i));
    }
    function sci_ArraySeq$ofFloat_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Float0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofFloat_unsafeArray($this) {
        return $this.$unsafeArray5;
    }
    function sci_ArraySeq$ofFloat__init_0($this, $unsafeArray) {
        $this.$unsafeArray5 = $unsafeArray;
    }
    function sci_ArraySeq$ofChar() {
        sci_ArraySeq.call(this);
        this.$unsafeArray6 = null;
    }
    function sci_ArraySeq$ofChar__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofChar();
        sci_ArraySeq$ofChar__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofChar_length($this) {
        return $this.$unsafeArray6.data.length;
    }
    function sci_ArraySeq$ofChar_apply($this, $i) {
        return $this.$unsafeArray6.data[$i];
    }
    function sci_ArraySeq$ofChar_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mCc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray6);
    }
    function sci_ArraySeq$ofChar_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofChar))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals2($this.$unsafeArray6, $that.$unsafeArray6);
    }
    function sci_ArraySeq$ofChar_sorted($this, $ord) {
        var var$2, $a;
        var$2 = $this.$unsafeArray6;
        if (var$2.data.length <= 1)
            return $this;
        if ($ord !== sm_Ordering$Char$_MODULE$)
            return sci_ArraySeq_sorted($this, $ord);
        $a = var$2.$clone();
        ju_Arrays_sort5($a);
        return sci_ArraySeq$ofChar__init_($a);
    }
    function sci_ArraySeq$ofChar_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcC$sp__init_($this.$unsafeArray6);
    }
    function sci_ArraySeq$ofChar_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Character))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToChar($elem);
        $elem = new sci_ArraySeq$ofChar;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray6;
        var$6 = jl_Character_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofChar__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Char0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofChar_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Character))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToChar($elem);
        var$3 = new sci_ArraySeq$ofChar;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray6;
        var$5 = jl_Character_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofChar__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Char0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofChar_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Character))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToChar($elem);
        var$3 = new sci_ArraySeq$ofChar;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray6;
        var$5 = jl_Character_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofChar__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Char0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofChar_addString($this, $sb, $start, $sep, $end) {
        return scm_ArraySeq$ofChar_addString(scm_ArraySeq$ofChar__init_($this.$unsafeArray6), $sb, $start, $sep, $end);
    }
    function sci_ArraySeq$ofChar_prepended0($this, $elem) {
        return sci_ArraySeq$ofChar_prepended($this, $elem);
    }
    function sci_ArraySeq$ofChar_appended0($this, $elem) {
        return sci_ArraySeq$ofChar_appended($this, $elem);
    }
    function sci_ArraySeq$ofChar_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofChar_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofChar_sorted0($this, $ord) {
        return sci_ArraySeq$ofChar_sorted($this, $ord);
    }
    function sci_ArraySeq$ofChar_apply0($this, $v1) {
        return jl_Character_valueOf(sci_ArraySeq$ofChar_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofChar_apply1($this, $i) {
        return jl_Character_valueOf(sci_ArraySeq$ofChar_apply($this, $i));
    }
    function sci_ArraySeq$ofChar_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Char0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofChar_unsafeArray($this) {
        return $this.$unsafeArray6;
    }
    function sci_ArraySeq$ofChar__init_0($this, $unsafeArray) {
        $this.$unsafeArray6 = $unsafeArray;
    }
    function sci_ArraySeq$ofByte() {
        sci_ArraySeq.call(this);
        this.$unsafeArray7 = null;
    }
    function sci_ArraySeq$ofByte__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofByte();
        sci_ArraySeq$ofByte__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofByte_length($this) {
        return $this.$unsafeArray7.data.length;
    }
    function sci_ArraySeq$ofByte_apply($this, $i) {
        return $this.$unsafeArray7.data[$i];
    }
    function sci_ArraySeq$ofByte_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mBc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray7);
    }
    function sci_ArraySeq$ofByte_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofByte))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals3($this.$unsafeArray7, $that.$unsafeArray7);
    }
    function sci_ArraySeq$ofByte_sorted($this, $ord) {
        var var$2, $a;
        var$2 = $this.$unsafeArray7;
        if (var$2.data.length <= 1)
            return $this;
        if ($ord !== sm_Ordering$Byte$_MODULE$)
            return sci_ArraySeq_sorted($this, $ord);
        $a = var$2.$clone();
        ju_Arrays_sort7($a);
        return sci_ArraySeq$ofByte__init_($a);
    }
    function sci_ArraySeq$ofByte_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcB$sp__init_($this.$unsafeArray7);
    }
    function sci_ArraySeq$ofByte_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Byte))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToByte($elem);
        $elem = new sci_ArraySeq$ofByte;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray7;
        var$6 = jl_Byte_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofByte__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Byte0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofByte_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Byte))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToByte($elem);
        var$3 = new sci_ArraySeq$ofByte;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray7;
        var$5 = jl_Byte_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofByte__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Byte0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofByte_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Byte))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToByte($elem);
        var$3 = new sci_ArraySeq$ofByte;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray7;
        var$5 = jl_Byte_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofByte__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Byte0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofByte_prepended0($this, $elem) {
        return sci_ArraySeq$ofByte_prepended($this, $elem);
    }
    function sci_ArraySeq$ofByte_appended0($this, $elem) {
        return sci_ArraySeq$ofByte_appended($this, $elem);
    }
    function sci_ArraySeq$ofByte_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofByte_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofByte_sorted0($this, $ord) {
        return sci_ArraySeq$ofByte_sorted($this, $ord);
    }
    function sci_ArraySeq$ofByte_apply0($this, $v1) {
        return jl_Byte_valueOf(sci_ArraySeq$ofByte_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofByte_apply1($this, $i) {
        return jl_Byte_valueOf(sci_ArraySeq$ofByte_apply($this, $i));
    }
    function sci_ArraySeq$ofByte_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Byte0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofByte_unsafeArray($this) {
        return $this.$unsafeArray7;
    }
    function sci_ArraySeq$ofByte__init_0($this, $unsafeArray) {
        $this.$unsafeArray7 = $unsafeArray;
    }
    function sci_ArraySeq$ofShort() {
        sci_ArraySeq.call(this);
        this.$unsafeArray8 = null;
    }
    function sci_ArraySeq$ofShort__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofShort();
        sci_ArraySeq$ofShort__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofShort_length($this) {
        return $this.$unsafeArray8.data.length;
    }
    function sci_ArraySeq$ofShort_apply($this, $i) {
        return $this.$unsafeArray8.data[$i];
    }
    function sci_ArraySeq$ofShort_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mSc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray8);
    }
    function sci_ArraySeq$ofShort_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofShort))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals1($this.$unsafeArray8, $that.$unsafeArray8);
    }
    function sci_ArraySeq$ofShort_sorted($this, $ord) {
        var var$2, $a;
        var$2 = $this.$unsafeArray8;
        if (var$2.data.length <= 1)
            return $this;
        if ($ord !== sm_Ordering$Short$_MODULE$)
            return sci_ArraySeq_sorted($this, $ord);
        $a = var$2.$clone();
        ju_Arrays_sort3($a);
        return sci_ArraySeq$ofShort__init_($a);
    }
    function sci_ArraySeq$ofShort_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcS$sp__init_($this.$unsafeArray8);
    }
    function sci_ArraySeq$ofShort_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Short))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToShort($elem);
        $elem = new sci_ArraySeq$ofShort;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray8;
        var$6 = jl_Short_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofShort__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Short0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofShort_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Short))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToShort($elem);
        var$3 = new sci_ArraySeq$ofShort;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray8;
        var$5 = jl_Short_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofShort__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Short0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofShort_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Short))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToShort($elem);
        var$3 = new sci_ArraySeq$ofShort;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray8;
        var$5 = jl_Short_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofShort__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Short0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofShort_prepended0($this, $elem) {
        return sci_ArraySeq$ofShort_prepended($this, $elem);
    }
    function sci_ArraySeq$ofShort_appended0($this, $elem) {
        return sci_ArraySeq$ofShort_appended($this, $elem);
    }
    function sci_ArraySeq$ofShort_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofShort_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofShort_sorted0($this, $ord) {
        return sci_ArraySeq$ofShort_sorted($this, $ord);
    }
    function sci_ArraySeq$ofShort_apply0($this, $v1) {
        return jl_Short_valueOf(sci_ArraySeq$ofShort_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofShort_apply1($this, $i) {
        return jl_Short_valueOf(sci_ArraySeq$ofShort_apply($this, $i));
    }
    function sci_ArraySeq$ofShort_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Short0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofShort_unsafeArray($this) {
        return $this.$unsafeArray8;
    }
    function sci_ArraySeq$ofShort__init_0($this, $unsafeArray) {
        $this.$unsafeArray8 = $unsafeArray;
    }
    function sci_ArraySeq$ofBoolean() {
        sci_ArraySeq.call(this);
        this.$unsafeArray9 = null;
    }
    function sci_ArraySeq$ofBoolean__init_(var_0) {
        var var_1 = new sci_ArraySeq$ofBoolean();
        sci_ArraySeq$ofBoolean__init_0(var_1, var_0);
        return var_1;
    }
    function sci_ArraySeq$ofBoolean_length($this) {
        return $this.$unsafeArray9.data.length;
    }
    function sci_ArraySeq$ofBoolean_apply($this, $i) {
        return $this.$unsafeArray9.data[$i];
    }
    function sci_ArraySeq$ofBoolean_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mZc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray9);
    }
    function sci_ArraySeq$ofBoolean_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofBoolean))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        return ju_Arrays_equals6($this.$unsafeArray9, $that.$unsafeArray9);
    }
    function sci_ArraySeq$ofBoolean_sorted($this, $ord) {
        var var$2, $stableSort_evidence$3, $a;
        var$2 = $this.$unsafeArray9;
        if (var$2.data.length <= 1)
            return $this;
        $stableSort_evidence$3 = sm_Ordering$Boolean$_MODULE$;
        if ($ord !== $stableSort_evidence$3)
            return sci_ArraySeq_sorted($this, $ord);
        $a = var$2.$clone();
        var$2 = $a.data;
        su_Sorting$_stableSort(su_Sorting$_MODULE$, $a, 0, var$2.length, $stableSort_evidence$3);
        return sci_ArraySeq$ofBoolean__init_($a);
    }
    function sci_ArraySeq$ofBoolean_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcZ$sp__init_($this.$unsafeArray9);
    }
    function sci_ArraySeq$ofBoolean_updated($this, $index, $elem) {
        var var$3, var$4, var$5, var$6;
        if (!($elem instanceof jl_Boolean))
            return sci_ArraySeq_updated($this, $index, $elem);
        var$3 = sr_BoxesRunTime_unboxToBoolean($elem);
        $elem = new sci_ArraySeq$ofBoolean;
        var$4 = sc_ArrayOps$_MODULE$;
        var$5 = $this.$unsafeArray9;
        var$6 = jl_Boolean_valueOf(var$3);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofBoolean__init_0($elem, sc_ArrayOps$_updated$extension(var$4, var$5, $index, var$6, sr_ClassTag$_Boolean0(sr_ClassTag$_MODULE$)));
        return $elem;
    }
    function sci_ArraySeq$ofBoolean_appended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Boolean))
            return sci_ArraySeq_appended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToBoolean($elem);
        var$3 = new sci_ArraySeq$ofBoolean;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray9;
        var$5 = jl_Boolean_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofBoolean__init_0(var$3, sc_ArrayOps$_appended$extension($elem, var$4, var$5, sr_ClassTag$_Boolean0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofBoolean_prepended($this, $elem) {
        var var$2, var$3, var$4, var$5;
        if (!($elem instanceof jl_Boolean))
            return sci_ArraySeq_prepended($this, $elem);
        var$2 = sr_BoxesRunTime_unboxToBoolean($elem);
        var$3 = new sci_ArraySeq$ofBoolean;
        $elem = sc_ArrayOps$_MODULE$;
        var$4 = $this.$unsafeArray9;
        var$5 = jl_Boolean_valueOf(var$2);
        sr_ClassTag$_$callClinit();
        sci_ArraySeq$ofBoolean__init_0(var$3, sc_ArrayOps$_prepended$extension($elem, var$4, var$5, sr_ClassTag$_Boolean0(sr_ClassTag$_MODULE$)));
        return var$3;
    }
    function sci_ArraySeq$ofBoolean_prepended0($this, $elem) {
        return sci_ArraySeq$ofBoolean_prepended($this, $elem);
    }
    function sci_ArraySeq$ofBoolean_appended0($this, $elem) {
        return sci_ArraySeq$ofBoolean_appended($this, $elem);
    }
    function sci_ArraySeq$ofBoolean_updated0($this, $index, $elem) {
        return sci_ArraySeq$ofBoolean_updated($this, $index, $elem);
    }
    function sci_ArraySeq$ofBoolean_sorted0($this, $ord) {
        return sci_ArraySeq$ofBoolean_sorted($this, $ord);
    }
    function sci_ArraySeq$ofBoolean_apply0($this, $v1) {
        return jl_Boolean_valueOf(sci_ArraySeq$ofBoolean_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    }
    function sci_ArraySeq$ofBoolean_apply1($this, $i) {
        return jl_Boolean_valueOf(sci_ArraySeq$ofBoolean_apply($this, $i));
    }
    function sci_ArraySeq$ofBoolean_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Boolean0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofBoolean_unsafeArray($this) {
        return $this.$unsafeArray9;
    }
    function sci_ArraySeq$ofBoolean__init_0($this, $unsafeArray) {
        $this.$unsafeArray9 = $unsafeArray;
    }
    function sci_ArraySeq$ofUnit() {
        sci_ArraySeq.call(this);
        this.$unsafeArray1 = null;
    }
    function sci_ArraySeq$ofUnit_length($this) {
        return $this.$unsafeArray1.data.length;
    }
    function sci_ArraySeq$ofUnit_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mVc$sp(suh_MurmurHash3$_MODULE$, $this.$unsafeArray1);
    }
    function sci_ArraySeq$ofUnit_equals($this, $that) {
        if (!($that instanceof sci_ArraySeq$ofUnit))
            return sc_Seq_equals$($this, $that);
        $that = $that;
        if ($this.$unsafeArray1.data.length != $that.$unsafeArray1.data.length)
            return 0;
        return 1;
    }
    function sci_ArraySeq$ofUnit_iterator($this) {
        return sc_ArrayOps$ArrayIterator$mcV$sp__init_($this.$unsafeArray1);
    }
    function sci_ArraySeq$ofUnit_apply($this, $v1) {
        sr_BoxesRunTime_unboxToInt($v1);
        return sr_BoxedUnit_UNIT;
    }
    function sci_ArraySeq$ofUnit_apply0($this, $i) {
        return sr_BoxedUnit_UNIT;
    }
    function sci_ArraySeq$ofUnit_elemTag($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Unit0(sr_ClassTag$_MODULE$);
    }
    function sci_ArraySeq$ofUnit_unsafeArray($this) {
        return $this.$unsafeArray1;
    }
    var scm_SortedSetOps = $rt_classWithoutFields(0);
    var scm_SortedSet = $rt_classWithoutFields(0);
    var sc_StrictOptimizedSortedSetOps = $rt_classWithoutFields(0);
    function scm_TreeSet() {
        var a = this; scm_AbstractSet.call(a);
        a.$scala$collection$mutable$TreeSet$$tree = null;
        a.$ordering = null;
    }
    function scm_TreeSet__init_0(var_0, var_1) {
        var var_2 = new scm_TreeSet();
        scm_TreeSet__init_(var_2, var_0, var_1);
        return var_2;
    }
    function scm_TreeSet_concat($this, $that) {
        var var$2;
        var$2 = scm_TreeSet_newSpecificBuilder($this);
        if (var$2 === null)
            $rt_throw(null);
        scm_Growable_addAll$(var$2, $this);
        scm_Growable_addAll$(var$2, $that);
        return scm_TreeSet$$anon$1_result(var$2);
    }
    function scm_TreeSet_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function scm_TreeSet_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function scm_TreeSet_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function scm_TreeSet_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function scm_TreeSet_stringPrefix($this) {
        return $rt_s(1034);
    }
    function scm_TreeSet_equals($this, $that) {
        var var$2, var$3, var$4, var$5;
        a: {
            if ($this === $that)
                var$2 = 1;
            else {
                b: {
                    c: {
                        if ($rt_isInstance($that, sc_SortedSet)) {
                            var$3 = $that;
                            var$4 = var$3.$ordering;
                            var$5 = $this.$ordering;
                            if (var$4 !== null) {
                                if (!jl_Object_equals(var$4, var$5))
                                    break c;
                                else
                                    break b;
                            }
                            if (var$5 === null)
                                break b;
                        }
                    }
                    var$2 = sc_Set_equals$($this, $that);
                    break a;
                }
                if (scm_TreeSet_size($this) == scm_TreeSet_size(var$3)) {
                    $that = scm_TreeSet_iterator($this);
                    var$3 = scm_TreeSet_iterator(var$3);
                    var$2 = 1;
                    while (var$2 && scm_RedBlackTree$TreeIterator_hasNext($that)) {
                        var$2 = onciu_StepSequencer$$anonfun$heuristicStepOrdering$3_compare($this.$ordering, scm_RedBlackTree$TreeIterator_next($that), scm_RedBlackTree$TreeIterator_next(var$3)) ? 0 : 1;
                    }
                    if (var$2) {
                        var$2 = 1;
                        break a;
                    }
                }
                var$2 = 0;
            }
        }
        return var$2;
    }
    function scm_TreeSet_fromSpecific($this, $coll) {
        return scm_TreeSet$_from(scm_TreeSet$_MODULE$, $coll, $this.$ordering);
    }
    function scm_TreeSet_newSpecificBuilder($this) {
        var var$1, var$2;
        var$1 = $this.$ordering;
        var$2 = new scm_TreeSet$$anon$1;
        var$2.$ordering$1 = var$1;
        var$2.$tree = scm_RedBlackTree$Tree$_empty(scm_RedBlackTree$Tree$_MODULE$);
        return var$2;
    }
    function scm_TreeSet_iterator($this) {
        var $keysIterator_tree, $keysIterator_end, $keysIterator_evidence$4, var$4, var$5, var$6, var$7, var$8;
        $keysIterator_tree = $this.$scala$collection$mutable$TreeSet$$tree;
        $keysIterator_end = s_None$_MODULE$;
        $keysIterator_evidence$4 = $this.$ordering;
        var$4 = new scm_RedBlackTree$KeysIterator;
        var$4.$end3 = $keysIterator_end;
        var$4.$ord = $keysIterator_evidence$4;
        if (jl_Object_equals($keysIterator_end, $keysIterator_end))
            var$5 = scm_RedBlackTree$_scala$collection$mutable$RedBlackTree$$minNode(scm_RedBlackTree$_MODULE$, $keysIterator_tree.$root0);
        else {
            if (!($keysIterator_end instanceof s_Some))
                $rt_throw(s_MatchError__init_($keysIterator_end));
            var$6 = $keysIterator_end.$value5;
            $keysIterator_end = scm_RedBlackTree$_MODULE$;
            $keysIterator_tree = $keysIterator_tree.$root0;
            if ($keysIterator_tree === null)
                var$5 = null;
            else {
                var$5 = null;
                var$7 = 1;
                while ($keysIterator_tree !== null && var$7) {
                    var$7 = onciu_StepSequencer$$anonfun$heuristicStepOrdering$3_compare($keysIterator_evidence$4, var$6, $keysIterator_tree.$key2);
                    var$8 = var$7 >= 0 ? $keysIterator_tree.$right0 : $keysIterator_tree.$left1;
                    var$5 = $keysIterator_tree;
                    $keysIterator_tree = var$8;
                }
                if (var$7 > 0)
                    var$5 = scm_RedBlackTree$_scala$collection$mutable$RedBlackTree$$successor($keysIterator_end, var$5);
            }
        }
        var$4.$nextNode = var$5;
        scm_RedBlackTree$TreeIterator_setNullIfAfterEnd(var$4);
        return var$4;
    }
    function scm_TreeSet_contains($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = scm_RedBlackTree$_MODULE$;
        var$3 = $this.$scala$collection$mutable$TreeSet$$tree;
        var$4 = $this.$ordering;
        return scm_RedBlackTree$_getNode(var$2, var$3.$root0, $elem, var$4) === null ? 0 : 1;
    }
    function scm_TreeSet_className($this) {
        return $rt_s(1035);
    }
    function scm_TreeSet_size($this) {
        return $this.$scala$collection$mutable$TreeSet$$tree.$size3;
    }
    function scm_TreeSet_knownSize($this) {
        return scm_TreeSet_size($this);
    }
    function scm_TreeSet_isEmpty($this) {
        return $this.$scala$collection$mutable$TreeSet$$tree.$root0 !== null ? 0 : 1;
    }
    function scm_TreeSet_head($this) {
        var var$1;
        var$1 = scm_RedBlackTree$_scala$collection$mutable$RedBlackTree$$minNode(scm_RedBlackTree$_MODULE$, $this.$scala$collection$mutable$TreeSet$$tree.$root0);
        return (var$1 === null ? s_None$_MODULE$ : s_Some__init_(var$1.$key2)).$get0();
    }
    function scm_TreeSet_foreach($this, $f) {
        var var$2, var$3, var$4;
        var$2 = scm_RedBlackTree$_MODULE$;
        var$3 = $this.$scala$collection$mutable$TreeSet$$tree.$root0;
        if (var$3 !== null)
            while (true) {
                var$4 = var$3.$left1;
                if (var$4 !== null)
                    scm_RedBlackTree$_g$1(var$2, var$4, $f);
                $f.$apply(var$3.$key2);
                var$3 = var$3.$right0;
                if (var$3 === null)
                    break;
            }
    }
    function scm_TreeSet_fromSpecific0($this, $coll) {
        return scm_TreeSet_fromSpecific($this, $coll);
    }
    function scm_TreeSet_fromSpecific1($this, $coll) {
        return scm_TreeSet_fromSpecific($this, $coll);
    }
    function scm_TreeSet_subtractOne($this, $elem) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$2 = scm_RedBlackTree$_MODULE$;
        var$3 = $this.$scala$collection$mutable$TreeSet$$tree;
        var$4 = $this.$ordering;
        $elem = scm_RedBlackTree$_getNode(var$2, var$3.$root0, $elem, var$4);
        if ($elem !== null) {
            var$5 = $elem.$red;
            var$6 = $elem.$left1;
            if (var$6 === null) {
                var$6 = $elem.$right0;
                scm_RedBlackTree$_transplant(var$2, var$3, $elem, var$6);
                var$4 = $elem.$parent0;
            } else {
                var$7 = $elem.$right0;
                if (var$7 === null) {
                    scm_RedBlackTree$_transplant(var$2, var$3, $elem, var$6);
                    var$4 = $elem.$parent0;
                } else {
                    var$7 = scm_RedBlackTree$_minNodeNonNull(var$2, var$7);
                    var$5 = var$7.$red;
                    var$6 = var$7.$right0;
                    var$4 = var$7.$parent0;
                    if (var$4 === $elem)
                        var$4 = var$7;
                    else {
                        scm_RedBlackTree$_transplant(var$2, var$3, var$7, var$6);
                        var$8 = $elem.$right0;
                        var$7.$right0 = var$8;
                        var$8.$parent0 = var$7;
                    }
                    scm_RedBlackTree$_transplant(var$2, var$3, $elem, var$7);
                    var$8 = $elem.$left1;
                    var$7.$left1 = var$8;
                    var$8.$parent0 = var$7;
                    var$7.$red = $elem.$red;
                }
            }
            if (!var$5) {
                while (var$6 !== var$3.$root0 && scm_RedBlackTree$_isBlack(var$2, var$6)) {
                    $elem = var$4.$left1;
                    if (var$6 !== $elem) {
                        if ($elem.$red) {
                            $elem.$red = 0;
                            var$4.$red = 1;
                            scm_RedBlackTree$_rotateRight(var$2, var$3, var$4);
                            $elem = var$4.$left1;
                        }
                        if (scm_RedBlackTree$_isBlack(var$2, $elem.$right0) && scm_RedBlackTree$_isBlack(var$2, $elem.$left1))
                            $elem.$red = 1;
                        else {
                            if (scm_RedBlackTree$_isBlack(var$2, $elem.$left1)) {
                                $elem.$right0.$red = 0;
                                $elem.$red = 1;
                                scm_RedBlackTree$_rotateLeft(var$2, var$3, $elem);
                                $elem = var$4.$left1;
                            }
                            $elem.$red = var$4.$red;
                            var$4.$red = 0;
                            $elem.$left1.$red = 0;
                            scm_RedBlackTree$_rotateRight(var$2, var$3, var$4);
                            var$4 = var$3.$root0;
                        }
                    } else {
                        $elem = var$4.$right0;
                        if ($elem.$red) {
                            $elem.$red = 0;
                            var$4.$red = 1;
                            scm_RedBlackTree$_rotateLeft(var$2, var$3, var$4);
                            $elem = var$4.$right0;
                        }
                        if (scm_RedBlackTree$_isBlack(var$2, $elem.$left1) && scm_RedBlackTree$_isBlack(var$2, $elem.$right0))
                            $elem.$red = 1;
                        else {
                            if (scm_RedBlackTree$_isBlack(var$2, $elem.$right0)) {
                                $elem.$left1.$red = 0;
                                $elem.$red = 1;
                                scm_RedBlackTree$_rotateRight(var$2, var$3, $elem);
                                $elem = var$4.$right0;
                            }
                            $elem.$red = var$4.$red;
                            var$4.$red = 0;
                            $elem.$right0.$red = 0;
                            scm_RedBlackTree$_rotateLeft(var$2, var$3, var$4);
                            var$4 = var$3.$root0;
                        }
                    }
                    $elem = var$4.$parent0;
                    var$6 = var$4;
                    var$4 = $elem;
                }
                if (var$6 !== null)
                    var$6.$red = 0;
            }
            var$3.$size3 = var$3.$size3 - 1 | 0;
        }
        return $this;
    }
    function scm_TreeSet_addOne($this, $elem) {
        scm_RedBlackTree$_insert(scm_RedBlackTree$_MODULE$, $this.$scala$collection$mutable$TreeSet$$tree, $elem, null, $this.$ordering);
        return $this;
    }
    function scm_TreeSet__init_($this, $tree, $ordering) {
        $this.$scala$collection$mutable$TreeSet$$tree = $tree;
        $this.$ordering = $ordering;
        if ($ordering !== null)
            return;
        $ordering = new jl_NullPointerException;
        jl_Throwable__init_($ordering, $rt_s(1036));
        $rt_throw($ordering);
    }
    var scm_RedBlackTree$ = $rt_classWithoutFields();
    var scm_RedBlackTree$_MODULE$ = null;
    function scm_RedBlackTree$__clinit_() {
        scm_RedBlackTree$_MODULE$ = new scm_RedBlackTree$;
    }
    function scm_RedBlackTree$_isRed($this, $node) {
        if ($node !== null && $node.$red)
            return 1;
        return 0;
    }
    function scm_RedBlackTree$_isBlack($this, $node) {
        if ($node !== null && $node.$red)
            return 0;
        return 1;
    }
    function scm_RedBlackTree$_getNode($this, $node, $key, $ord) {
        var $cmp;
        while (true) {
            if ($node === null)
                return null;
            $cmp = $rt_compare(onciu_StepSequencer$$anonfun$heuristicStepOrdering$3_compare($ord, $key, $node.$key2), 0);
            if ($cmp < 0) {
                $node = $node.$left1;
                continue;
            }
            if ($cmp <= 0)
                break;
            $node = $node.$right0;
        }
        return $node;
    }
    function scm_RedBlackTree$_scala$collection$mutable$RedBlackTree$$minNode($this, $node) {
        if ($node !== null)
            return scm_RedBlackTree$_minNodeNonNull($this, $node);
        return null;
    }
    function scm_RedBlackTree$_minNodeNonNull($this, $node) {
        var $node_0;
        while (true) {
            $node_0 = $node.$left1;
            if ($node_0 === null)
                break;
            $node = $node_0;
        }
        return $node;
    }
    function scm_RedBlackTree$_insert($this, $tree, $key, $value, $ord) {
        var $y, $x, $cmp, $z, var$9;
        $y = null;
        $x = $tree.$root0;
        $cmp = 1;
        while ($x !== null && $cmp) {
            $cmp = onciu_StepSequencer$$anonfun$heuristicStepOrdering$3_compare($ord, $key, $x.$key2);
            $z = $cmp >= 0 ? $x.$right0 : $x.$left1;
            $y = $x;
            $x = $z;
        }
        var$9 = $rt_compare($cmp, 0);
        if (!var$9) {
            $y.$value18 = $value;
            return;
        }
        $z = scm_RedBlackTree$Node__init_($key, $value, 1, null, null, $y);
        if ($y === null)
            $tree.$root0 = $z;
        else if (var$9 >= 0)
            $y.$right0 = $z;
        else
            $y.$left1 = $z;
        while (scm_RedBlackTree$_isRed($this, $z.$parent0)) {
            $ord = $z.$parent0;
            $value = $ord.$parent0;
            $key = $value.$left1;
            if ($ord !== $key) {
                if (scm_RedBlackTree$_isRed($this, $key)) {
                    $value = $z.$parent0;
                    $value.$red = 0;
                    $key.$red = 0;
                    $z = $value.$parent0;
                    $z.$red = 1;
                    continue;
                }
                $value = $z.$parent0;
                if ($z === $value.$left1) {
                    scm_RedBlackTree$_rotateRight($this, $tree, $value);
                    $z = $value;
                }
                $key = $z.$parent0;
                $key.$red = 0;
                $key = $key.$parent0;
                $key.$red = 1;
                scm_RedBlackTree$_rotateLeft($this, $tree, $key);
                continue;
            }
            $key = $value.$right0;
            if (scm_RedBlackTree$_isRed($this, $key)) {
                $value = $z.$parent0;
                $value.$red = 0;
                $key.$red = 0;
                $z = $value.$parent0;
                $z.$red = 1;
                continue;
            }
            $value = $z.$parent0;
            if ($z === $value.$right0) {
                scm_RedBlackTree$_rotateLeft($this, $tree, $value);
                $z = $value;
            }
            $key = $z.$parent0;
            $key.$red = 0;
            $key = $key.$parent0;
            $key.$red = 1;
            scm_RedBlackTree$_rotateRight($this, $tree, $key);
        }
        $tree.$root0.$red = 0;
        $tree.$size3 = $tree.$size3 + 1 | 0;
    }
    function scm_RedBlackTree$_scala$collection$mutable$RedBlackTree$$successor($this, $node) {
        var $y, $y_0;
        $y = $node.$right0;
        if ($y !== null)
            return scm_RedBlackTree$_minNodeNonNull($this, $y);
        $y = $node.$parent0;
        while ($y !== null && $node === $y.$right0) {
            $y_0 = $y.$parent0;
            $node = $y;
            $y = $y_0;
        }
        return $y;
    }
    function scm_RedBlackTree$_rotateLeft($this, $tree, $x) {
        var $y, var$4;
        if ($x === null)
            return;
        $y = $x.$right0;
        var$4 = $y.$left1;
        $x.$right0 = var$4;
        if (var$4 !== null)
            var$4.$parent0 = $x;
        $y.$parent0 = $x.$parent0;
        var$4 = $x.$parent0;
        if (var$4 === null)
            $tree.$root0 = $y;
        else if ($x !== var$4.$left1)
            var$4.$right0 = $y;
        else
            var$4.$left1 = $y;
        $y.$left1 = $x;
        $x.$parent0 = $y;
    }
    function scm_RedBlackTree$_rotateRight($this, $tree, $x) {
        var $y, var$4;
        if ($x === null)
            return;
        $y = $x.$left1;
        var$4 = $y.$right0;
        $x.$left1 = var$4;
        if (var$4 !== null)
            var$4.$parent0 = $x;
        $y.$parent0 = $x.$parent0;
        var$4 = $x.$parent0;
        if (var$4 === null)
            $tree.$root0 = $y;
        else if ($x !== var$4.$right0)
            var$4.$left1 = $y;
        else
            var$4.$right0 = $y;
        $y.$right0 = $x;
        $x.$parent0 = $y;
    }
    function scm_RedBlackTree$_transplant($this, $tree, $to, $from) {
        var var$4;
        var$4 = $to.$parent0;
        if (var$4 === null)
            $tree.$root0 = $from;
        else if ($to !== var$4.$left1)
            var$4.$right0 = $from;
        else
            var$4.$left1 = $from;
        if ($from === null)
            return;
        $from.$parent0 = var$4;
    }
    function scm_RedBlackTree$_fromOrderedKeys($this, $xs, $size) {
        var $maxUsedDepth;
        $maxUsedDepth = 32 - jl_Integer_numberOfLeadingZeros($size) | 0;
        return scm_RedBlackTree$Tree__init_(scm_RedBlackTree$_f$3(1, $size, $xs, $maxUsedDepth), $size);
    }
    function scm_RedBlackTree$_copyTree($this, $n) {
        var $c;
        if ($n === null)
            return null;
        $c = scm_RedBlackTree$Node__init_($n.$key2, $n.$value18, $n.$red, scm_RedBlackTree$_copyTree($this, $n.$left1), scm_RedBlackTree$_copyTree($this, $n.$right0), null);
        $n = $c.$left1;
        if ($n !== null)
            $n.$parent0 = $c;
        $n = $c.$right0;
        if ($n !== null)
            $n.$parent0 = $c;
        return $c;
    }
    function scm_RedBlackTree$_g$1($this, $node, $f$1) {
        var $l;
        while (true) {
            $l = $node.$left1;
            if ($l !== null)
                scm_RedBlackTree$_g$1($this, $l, $f$1);
            $f$1.$apply($node.$key2);
            $node = $node.$right0;
            if ($node === null)
                break;
        }
    }
    function scm_RedBlackTree$_f$3($level, $size, $xs$1, $maxUsedDepth$1) {
        var $leftSize, $left, $x, $right, $n;
        switch ($size) {
            case 0:
                break;
            case 1:
                return scm_RedBlackTree$Node__init_($xs$1.$next(), null, $level == $maxUsedDepth$1 && $level != 1 ? 1 : 0, null, null, null);
            default:
                $size = $size - 1 | 0;
                $leftSize = $size / 2 | 0;
                $level = $level + 1 | 0;
                $left = scm_RedBlackTree$_f$3($level, $leftSize, $xs$1, $maxUsedDepth$1);
                $x = $xs$1.$next();
                $right = scm_RedBlackTree$_f$3($level, $size - $leftSize | 0, $xs$1, $maxUsedDepth$1);
                $n = scm_RedBlackTree$Node__init_($x, null, 0, $left, $right, null);
                if ($left !== null)
                    $left.$parent0 = $n;
                $right.$parent0 = $n;
                return $n;
        }
        return null;
    }
    var scm_RedBlackTree$Tree$ = $rt_classWithoutFields();
    var scm_RedBlackTree$Tree$_MODULE$ = null;
    function scm_RedBlackTree$Tree$__clinit_() {
        scm_RedBlackTree$Tree$_MODULE$ = new scm_RedBlackTree$Tree$;
    }
    function scm_RedBlackTree$Tree$_empty($this) {
        return scm_RedBlackTree$Tree__init_(null, 0);
    }
    function sci_VectorBuilder$addVector$lambda$_22_0() {
        jl_Object.call(this);
        this.$_0254 = null;
    }
    function sci_VectorBuilder$addVector$lambda$_22_0_apply(var$0, var$1) {
        var var$2;
        var$2 = var$1;
        sci_VectorBuilder_addArr1(var$0.$_0254, var$2);
        return sr_BoxedUnit_UNIT;
    }
    function scm_RedBlackTree$Tree() {
        var a = this; jl_Object.call(a);
        a.$root0 = null;
        a.$size3 = 0;
    }
    function scm_RedBlackTree$Tree__init_(var_0, var_1) {
        var var_2 = new scm_RedBlackTree$Tree();
        scm_RedBlackTree$Tree__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function scm_RedBlackTree$Tree__init_0($this, $root, $size) {
        $this.$root0 = $root;
        $this.$size3 = $size;
    }
    function sci_HashMapBuilder() {
        var a = this; jl_Object.call(a);
        a.$aliased1 = null;
        a.$scala$collection$immutable$HashMapBuilder$$rootNode = null;
    }
    function sci_HashMapBuilder__init_() {
        var var_0 = new sci_HashMapBuilder();
        sci_HashMapBuilder__init_0(var_0);
        return var_0;
    }
    function sci_HashMapBuilder_update($this, $mapNode, $key, $value, $originalHash, $keyHash, $shift) {
        var $value0, $index, $mask, $bitpos, $key0UnimprovedHash, var$12, $beforeHash, $key0, $key0Hash, $subNode, $beforeSize, var$18, var$19, var$20;
        if (!($mapNode instanceof sci_BitmapIndexedMapNode)) {
            if (!($mapNode instanceof sci_HashCollisionMapNode))
                $rt_throw(s_MatchError__init_($mapNode));
            $value0 = $mapNode;
            $index = sci_HashCollisionMapNode_indexOf($value0, $key);
            if ($index >= 0) {
                $value0.$content4 = $value0.$content4.$updated2($index, s_Tuple2__init_($key, $value));
                return;
            }
            $value0.$content4 = $value0.$content4.$appended1(s_Tuple2__init_($key, $value));
            return;
        }
        $mapNode = $mapNode;
        $mask = $keyHash >>> $shift & 31;
        $bitpos = 1 << $mask;
        $key0UnimprovedHash = $mapNode.$dataMap1;
        if ($key0UnimprovedHash & $bitpos) {
            $index = sci_Node$_indexFrom(sci_Node$_MODULE$, $key0UnimprovedHash, $mask, $bitpos);
            var$12 = $mapNode.$content.data;
            $beforeHash = 2 * $index | 0;
            $key0 = var$12[$beforeHash];
            $key0UnimprovedHash = $mapNode.$originalHashes.data[$index];
            if ($key0UnimprovedHash == $originalHash && sr_BoxesRunTime_equals($key0, $key)) {
                $mapNode.$content.data[$beforeHash + 1 | 0] = $value;
                return;
            }
            $value0 = $mapNode.$content.data[$beforeHash + 1 | 0];
            $key0Hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $key0UnimprovedHash);
            sci_BitmapIndexedMapNode_migrateFromInlineToNodeInPlace($mapNode, $bitpos, $key0Hash, sci_BitmapIndexedMapNode_mergeTwoKeyValPairs($mapNode, $key0, $value0, $key0UnimprovedHash, $key0Hash, $key, $value, $originalHash, $keyHash, $shift + 5 | 0));
            return;
        }
        $key0UnimprovedHash = $mapNode.$nodeMap1;
        if ($key0UnimprovedHash & $bitpos) {
            $subNode = sci_BitmapIndexedMapNode_getNode($mapNode, sci_Node$_indexFrom(sci_Node$_MODULE$, $key0UnimprovedHash, $mask, $bitpos));
            $beforeSize = $subNode.$size();
            $beforeHash = $subNode.$cachedJavaKeySetHashCode();
            sci_HashMapBuilder_update($this, $subNode, $key, $value, $originalHash, $keyHash, $shift + 5 | 0);
            $mapNode.$size6 = $mapNode.$size6 + ($subNode.$size() - $beforeSize | 0) | 0;
            $mapNode.$cachedJavaKeySetHashCode1 = $mapNode.$cachedJavaKeySetHashCode1 + ($subNode.$cachedJavaKeySetHashCode() - $beforeHash | 0) | 0;
            return;
        }
        $key0Hash = sci_BitmapIndexedMapNode_dataIndex($mapNode, $bitpos);
        $key0UnimprovedHash = 2 * $key0Hash | 0;
        var$12 = $mapNode.$content;
        $beforeHash = var$12.data.length;
        var$18 = $rt_createArray(jl_Object, $beforeHash + 2 | 0);
        var$19 = var$18.data;
        jl_System_arraycopy(var$12, 0, var$18, 0, $key0UnimprovedHash);
        var$19[$key0UnimprovedHash] = $key;
        var$19[$key0UnimprovedHash + 1 | 0] = $value;
        jl_System_arraycopy(var$12, $key0UnimprovedHash, var$18, $key0UnimprovedHash + 2 | 0, $beforeHash - $key0UnimprovedHash | 0);
        var$20 = $mapNode.$originalHashes;
        if ($key0Hash < 0) {
            $mapNode = new jl_ArrayIndexOutOfBoundsException;
            jl_Throwable__init_0($mapNode);
            $rt_throw($mapNode);
        }
        $shift = var$20.data.length;
        if ($key0Hash > $shift) {
            $mapNode = new jl_ArrayIndexOutOfBoundsException;
            jl_Throwable__init_0($mapNode);
            $rt_throw($mapNode);
        }
        var$12 = $rt_createIntArray($shift + 1 | 0);
        var$19 = var$12.data;
        jl_System_arraycopy(var$20, 0, var$12, 0, $key0Hash);
        var$19[$key0Hash] = $originalHash;
        jl_System_arraycopy(var$20, $key0Hash, var$12, $key0Hash + 1 | 0, $shift - $key0Hash | 0);
        $mapNode.$dataMap1 = $mapNode.$dataMap1 | $bitpos;
        $mapNode.$content = var$18;
        $mapNode.$originalHashes = var$12;
        $mapNode.$size6 = $mapNode.$size6 + 1 | 0;
        $mapNode.$cachedJavaKeySetHashCode1 = $mapNode.$cachedJavaKeySetHashCode1 + $keyHash | 0;
    }
    function sci_HashMapBuilder_ensureUnaliased($this) {
        if ($this.$aliased1 === null ? 0 : 1)
            $this.$scala$collection$immutable$HashMapBuilder$$rootNode = sci_BitmapIndexedMapNode_copy($this.$scala$collection$immutable$HashMapBuilder$$rootNode);
        $this.$aliased1 = null;
    }
    function sci_HashMapBuilder_result($this) {
        var var$1, var$2;
        var$1 = $this.$scala$collection$immutable$HashMapBuilder$$rootNode;
        if (!var$1.$size6) {
            sci_HashMap$_$callClinit();
            return sci_HashMap$_empty(sci_HashMap$_MODULE$);
        }
        var$2 = $this.$aliased1;
        if (var$2 !== null)
            return var$2;
        var$2 = sci_HashMap__init_0(var$1);
        $this.$aliased1 = var$2;
        return var$2;
    }
    function sci_HashMapBuilder_addOne1($this, $elem) {
        var $h, $im;
        sci_HashMapBuilder_ensureUnaliased($this);
        $h = sr_Statics_anyHash($elem.$_10);
        $im = sc_Hashing$_improve(sc_Hashing$_MODULE$, $h);
        sci_HashMapBuilder_update($this, $this.$scala$collection$immutable$HashMapBuilder$$rootNode, $elem.$_10, $elem.$_20, $h, $im, 0);
        return $this;
    }
    function sci_HashMapBuilder_addOne0($this, $key, $value) {
        var $originalHash;
        sci_HashMapBuilder_ensureUnaliased($this);
        $originalHash = sr_Statics_anyHash($key);
        sci_HashMapBuilder_update($this, $this.$scala$collection$immutable$HashMapBuilder$$rootNode, $key, $value, $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0);
        return $this;
    }
    function sci_HashMapBuilder_addAll($this, $xs) {
        var $it, $originalHash, $iter, $next, $hash, $originalHash_0;
        a: {
            sci_HashMapBuilder_ensureUnaliased($this);
            if ($xs instanceof sci_HashMap) {
                $xs = $xs;
                $it = new sci_HashMapBuilder$$anon$1;
                sci_ChampBaseIterator__init_($it, $xs.$rootNode);
                while (sci_ChampBaseIterator_hasNext($it)) {
                    $originalHash = $it.$currentValueNode.$getHash($it.$currentValueCursor);
                    sci_HashMapBuilder_update($this, $this.$scala$collection$immutable$HashMapBuilder$$rootNode, $it.$currentValueNode.$getKey($it.$currentValueCursor), $it.$currentValueNode.$getValue($it.$currentValueCursor), $originalHash, sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash), 0);
                    $it.$currentValueCursor = $it.$currentValueCursor + 1 | 0;
                }
            } else {
                if ($xs instanceof scm_HashMap) {
                    $xs = $xs;
                    $iter = scm_HashMap_nodeIterator($xs);
                    while (true) {
                        if (!$iter.$hasNext())
                            break a;
                        $next = $iter.$next();
                        $originalHash = scm_HashMap_unimproveHash($xs, $next.$_hash);
                        $hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
                        sci_HashMapBuilder_update($this, $this.$scala$collection$immutable$HashMapBuilder$$rootNode, $next.$_key, $next.$_value, $originalHash, $hash, 0);
                    }
                }
                if (!($xs instanceof scm_LinkedHashMap)) {
                    if ($rt_isInstance($xs, sci_Map)) {
                        $xs = $xs;
                        $it = new sci_HashMapBuilder$addAll$lambda$_25_0;
                        $it.$_0258 = $this;
                        $xs.$foreachEntry($it);
                        break a;
                    }
                    $it = $xs.$iterator0();
                    while (true) {
                        if (!$it.$hasNext())
                            break a;
                        sci_HashMapBuilder_addOne1($this, $it.$next());
                    }
                }
                $xs = $xs;
                $iter = $xs.$entryIterator();
                while (true) {
                    if (!$iter.$hasNext())
                        break a;
                    $next = $iter.$next();
                    $originalHash_0 = $xs.$unimproveHash(scm_LinkedHashMap$LinkedEntry_hash($next));
                    $hash = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash_0);
                    sci_HashMapBuilder_update($this, $this.$scala$collection$immutable$HashMapBuilder$$rootNode, scm_LinkedHashMap$LinkedEntry_key($next), scm_LinkedHashMap$LinkedEntry_value($next), $originalHash_0, $hash, 0);
                }
            }
        }
        return $this;
    }
    function sci_HashMapBuilder_addOne($this, $elem) {
        return sci_HashMapBuilder_addOne1($this, $elem);
    }
    function sci_HashMapBuilder_result0($this) {
        return sci_HashMapBuilder_result($this);
    }
    function sci_HashMapBuilder__init_0($this) {
        $this.$scala$collection$immutable$HashMapBuilder$$rootNode = sci_BitmapIndexedMapNode__init_(0, 0, s_Array$_emptyObjectArray, s_Array$_emptyIntArray, 0, 0);
    }
    function sc_SeqOps$contains$lambda$_84_0() {
        jl_Object.call(this);
        this.$_013 = null;
    }
    function sc_SeqOps$contains$lambda$_84_0_apply(var$0, var$1) {
        return jl_Boolean_valueOf(!sr_BoxesRunTime_equals(var$1, var$0.$_013) ? 0 : 1);
    }
    function sc_StrictOptimizedIterableOps$collect$lambda$_19_0() {
        jl_Object.call(this);
        this.$_016 = null;
    }
    function sc_StrictOptimizedIterableOps$collect$lambda$_19_0_apply(var$0, var$1) {
        return var$0.$_016;
    }
    function s_PartialFunction$AndThen() {
        var a = this; jl_Object.call(a);
        a.$pf1 = null;
        a.$k = null;
    }
    function s_PartialFunction$AndThen_lift($this) {
        return s_PartialFunction_lift$($this);
    }
    function s_PartialFunction$AndThen_applyOrElse($this, $x, $default) {
        var $z;
        $z = $this.$pf1.$applyOrElse($x, s_PartialFunction$_fallback_fn);
        if (s_PartialFunction$_scala$PartialFunction$$fallbackOccurred(s_PartialFunction$_MODULE$, $z))
            return s_PartialFunction$_fallback_fn;
        return $this.$k.$apply($z);
    }
    var oncir_RewriterStep$ = $rt_classWithoutFields();
    var oncir_RewriterStep$_MODULE$ = null;
    function oncir_RewriterStep$__clinit_() {
        oncir_RewriterStep$_MODULE$ = new oncir_RewriterStep$;
    }
    function sc_View$Collect() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying17 = null;
        a.$pf3 = null;
    }
    function sc_View$Collect__init_(var_0, var_1) {
        var var_2 = new sc_View$Collect();
        sc_View$Collect__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function sc_View$Collect_iterator($this) {
        return ($this.$underlying17.$iterator0()).$collect3($this.$pf3);
    }
    function sc_View$Collect__init_0($this, $underlying, $pf) {
        $this.$underlying17 = $underlying;
        $this.$pf3 = $pf;
    }
    var sc_AbstractMapView = $rt_classWithoutFields(sc_AbstractView);
    function sc_AbstractMapView_mapValues($this, $f) {
        var var$2;
        var$2 = new sc_MapView$MapValues;
        var$2.$underlying18 = $this;
        var$2.$f7 = $f;
        return var$2;
    }
    function sc_MapView$Id() {
        sc_AbstractMapView.call(this);
        this.$underlying5 = null;
    }
    function sc_MapView$Id_iterator($this) {
        return $this.$underlying5.$iterator0();
    }
    function sc_MapView$Id_knownSize($this) {
        return $this.$underlying5.$knownSize();
    }
    function onciu_StepSequencer$NegatedCondition() {
        jl_Object.call(this);
        this.$inner3 = null;
    }
    function onciu_StepSequencer$NegatedCondition_toString($this) {
        var var$1, var$2;
        var$1 = $this.$inner3;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 33);
        jl_StringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function onciu_StepSequencer$NegatedCondition_unary_$bang($this) {
        return $this.$inner3;
    }
    function onciu_StepSequencer$NegatedCondition_productPrefix($this) {
        return $rt_s(1037);
    }
    function onciu_StepSequencer$NegatedCondition_productArity($this) {
        return 1;
    }
    function onciu_StepSequencer$NegatedCondition_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$inner3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function onciu_StepSequencer$NegatedCondition_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_StepSequencer$NegatedCondition_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciu_StepSequencer$NegatedCondition_equals($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_StepSequencer$NegatedCondition) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$inner3;
                        $x$1 = $x$1.$inner3;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_StepSequencer$NegatedCondition))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    }
    var ju_Collections = $rt_classWithoutFields();
    var ju_Collections_EMPTY_SET = null;
    var ju_Collections_EMPTY_MAP = null;
    var ju_Collections_EMPTY_LIST = null;
    var ju_Collections_EMPTY_ITERATOR = null;
    var ju_Collections_EMPTY_LIST_ITERATOR = null;
    var ju_Collections_naturalOrder = null;
    var ju_Collections_reverseOrder = null;
    function ju_Collections__clinit_() {
        ju_Collections_EMPTY_SET = new ju_Collections$1;
        ju_Collections_EMPTY_MAP = new ju_Collections$2;
        ju_Collections_EMPTY_LIST = new ju_Collections$3;
        ju_Collections_EMPTY_ITERATOR = new ju_Collections$4;
        ju_Collections_EMPTY_LIST_ITERATOR = new ju_Collections$5;
        ju_Collections_naturalOrder = new ju_Collections$_clinit_$lambda$_58_0;
        ju_Collections_reverseOrder = new ju_Collections$_clinit_$lambda$_58_1;
    }
    var scm_ArrayDequeOps = $rt_classWithoutFields(0);
    function scm_ArrayDeque() {
        var a = this; scm_AbstractBuffer.call(a);
        a.$array4 = null;
        a.$scala$collection$mutable$ArrayDeque$$start = 0;
        a.$scala$collection$mutable$ArrayDeque$$end = 0;
    }
    function scm_ArrayDeque__init_0(var_0, var_1, var_2) {
        var var_3 = new scm_ArrayDeque();
        scm_ArrayDeque__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function scm_ArrayDeque_copySliceToArray($this, $srcStart, $dest, $destStart, $maxItems) {
        var var$5, var$6;
        var$5 = jlr_Array_getLength($dest) + 1 | 0;
        if ($destStart >= 0 && $destStart < var$5) {
            $maxItems = jl_Math_min($maxItems, jl_Math_min(scm_ArrayDeque_length($this) - $srcStart | 0, jlr_Array_getLength($dest) - $destStart | 0));
            if ($maxItems > 0) {
                var$5 = scm_ArrayDeque_length($this);
                if ($srcStart >= 0 && $srcStart < var$5) {
                    var$5 = scm_ArrayDeque_start_$plus($this, $srcStart);
                    $srcStart = jl_Math_min($maxItems, $this.$array4.data.length - var$5 | 0);
                    s_Array$_copy(s_Array$_MODULE$, $this.$array4, var$5, $dest, $destStart, $srcStart);
                    $maxItems = $maxItems - $srcStart | 0;
                    if ($maxItems > 0)
                        s_Array$_copy(s_Array$_MODULE$, $this.$array4, 0, $dest, $destStart + $srcStart | 0, $maxItems);
                } else {
                    $dest = new jl_IndexOutOfBoundsException;
                    var$6 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_2(var$6, 31);
                    var$6 = jl_StringBuilder_append0(var$6, $srcStart);
                    jl_AbstractStringBuilder_append1(var$6, $rt_s(390));
                    var$6 = jl_StringBuilder_append0(var$6, var$5 - 1 | 0);
                    jl_AbstractStringBuilder_append1(var$6, $rt_s(25));
                    jl_Throwable__init_($dest, jl_AbstractStringBuilder_toString(var$6));
                    $rt_throw($dest);
                }
            }
            return $dest;
        }
        var$6 = new jl_IndexOutOfBoundsException;
        $dest = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($dest, 31);
        $dest = jl_StringBuilder_append0($dest, $destStart);
        jl_AbstractStringBuilder_append1($dest, $rt_s(390));
        $dest = jl_StringBuilder_append0($dest, var$5 - 1 | 0);
        jl_AbstractStringBuilder_append1($dest, $rt_s(25));
        jl_Throwable__init_(var$6, jl_AbstractStringBuilder_toString($dest));
        $rt_throw(var$6);
    }
    function scm_ArrayDeque_distinctBy($this, $f) {
        return sc_StrictOptimizedSeqOps_distinctBy$($this, $f);
    }
    function scm_ArrayDeque_prepended($this, $elem) {
        return sc_StrictOptimizedSeqOps_prepended$($this, $elem);
    }
    function scm_ArrayDeque_appended($this, $elem) {
        return sc_StrictOptimizedSeqOps_appended$($this, $elem);
    }
    function scm_ArrayDeque_appendedAll($this, $suffix) {
        return sc_StrictOptimizedSeqOps_appendedAll$($this, $suffix);
    }
    function scm_ArrayDeque_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function scm_ArrayDeque_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function scm_ArrayDeque_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function scm_ArrayDeque_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function scm_ArrayDeque_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function scm_ArrayDeque_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function scm_ArrayDeque_iterator($this) {
        return sc_IndexedSeqOps_iterator$($this);
    }
    function scm_ArrayDeque_reverseIterator($this) {
        return sc_IndexedSeqOps_reverseIterator$($this);
    }
    function scm_ArrayDeque_view($this) {
        return sc_IndexedSeqOps_view$($this);
    }
    function scm_ArrayDeque_reversed($this) {
        return sc_IndexedSeqOps_reversed$($this);
    }
    function scm_ArrayDeque_head($this) {
        return sc_IndexedSeqOps_head$($this);
    }
    function scm_ArrayDeque_headOption($this) {
        return sc_IndexedSeqOps_headOption$($this);
    }
    function scm_ArrayDeque_lengthCompare($this, $len) {
        return sc_IndexedSeqOps_lengthCompare$($this, $len);
    }
    function scm_ArrayDeque_array($this) {
        return $this.$array4;
    }
    function scm_ArrayDeque_array_$eq($this, $x$1) {
        $this.$array4 = $x$1;
    }
    function scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$start($this) {
        return $this.$scala$collection$mutable$ArrayDeque$$start;
    }
    function scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$start_$eq($this, $x$1) {
        $this.$scala$collection$mutable$ArrayDeque$$start = $x$1;
    }
    function scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$end($this) {
        return $this.$scala$collection$mutable$ArrayDeque$$end;
    }
    function scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$end_$eq($this, $x$1) {
        $this.$scala$collection$mutable$ArrayDeque$$end = $x$1;
    }
    function scm_ArrayDeque_reset($this, $array, $start, $end) {
        var var$4, var$5, var$6, var$7, var$8;
        var$4 = $array.data.length;
        var$5 = var$4 - 1 | 0;
        if (!(var$4 & var$5 ? 0 : 1)) {
            var$6 = new jl_AssertionError;
            var$7 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$7, 18);
            jl_AbstractStringBuilder_append1(var$7, $rt_s(1038));
            jl_AssertionError__init_0(var$6, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$7, $rt_s(1039))));
            $rt_throw(var$6);
        }
        if ($start >= 0 && $start < var$4) {
            if ($end >= 0 && $end < var$4) {
                $this.$array4 = $array;
                $this.$scala$collection$mutable$ArrayDeque$$start = $start;
                $this.$scala$collection$mutable$ArrayDeque$$end = $end;
                return;
            }
            var$6 = new jl_IndexOutOfBoundsException;
            var$7 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$7, 31);
            var$7 = jl_StringBuilder_append0(var$7, $end);
            jl_AbstractStringBuilder_append1(var$7, $rt_s(390));
            var$7 = jl_StringBuilder_append0(var$7, var$5);
            jl_AbstractStringBuilder_append1(var$7, $rt_s(25));
            jl_Throwable__init_(var$6, jl_AbstractStringBuilder_toString(var$7));
            $rt_throw(var$6);
        }
        var$7 = new jl_IndexOutOfBoundsException;
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$6, 31);
        var$8 = jl_StringBuilder_append0(var$6, $start);
        jl_AbstractStringBuilder_append1(var$8, $rt_s(390));
        var$6 = jl_StringBuilder_append0(var$8, var$5);
        jl_AbstractStringBuilder_append1(var$6, $rt_s(25));
        jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$6));
        $rt_throw(var$7);
    }
    function scm_ArrayDeque_knownSize($this) {
        return $this.$length();
    }
    function scm_ArrayDeque_apply($this, $idx) {
        var $requireBounds_until, var$3, var$4;
        $requireBounds_until = scm_ArrayDeque_length($this);
        if ($idx >= 0 && $idx < $requireBounds_until)
            return $this.$array4.data[scm_ArrayDeque_start_$plus($this, $idx)];
        var$3 = new jl_IndexOutOfBoundsException;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$4, 31);
        var$4 = jl_StringBuilder_append0(var$4, $idx);
        jl_AbstractStringBuilder_append1(var$4, $rt_s(390));
        var$4 = jl_StringBuilder_append0(var$4, $requireBounds_until - 1 | 0);
        jl_AbstractStringBuilder_append1(var$4, $rt_s(25));
        jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$4));
        $rt_throw(var$3);
    }
    function scm_ArrayDeque_addOne($this, $elem) {
        scm_ArrayDeque_ensureSize($this, scm_ArrayDeque_length($this) + 1 | 0);
        return scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$appendAssumingCapacity($this, $elem);
    }
    function scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$appendAssumingCapacity($this, $elem) {
        var var$2, var$3;
        var$2 = $this.$array4.data;
        var$3 = $this.$scala$collection$mutable$ArrayDeque$$end;
        var$2[var$3] = $elem;
        $this.$scala$collection$mutable$ArrayDeque$$end = (var$3 + 1 | 0) & (var$2.length - 1 | 0);
        return $this;
    }
    function scm_ArrayDeque_prependAll($this, $elems) {
        var $it, $n, var$4, $_set_idx, $array2, $i;
        $it = $elems.$iterator0();
        if ($it.$nonEmpty0()) {
            $n = scm_ArrayDeque_length($this);
            var$4 = $elems.$knownSize();
            if (var$4 < 0) {
                scm_IndexedSeq$_$callClinit();
                scm_ArrayDeque_prependAll($this, $it.$to0(sc_IterableFactory$ToFactory__init_(scm_IndexedSeq$_MODULE$)));
            } else {
                $_set_idx = var$4 + $n | 0;
                if ($_set_idx < $this.$array4.data.length ? 0 : 1) {
                    $array2 = scm_ArrayDeque$_alloc(scm_ArrayDeque$_MODULE$, $_set_idx);
                    $it.$copyToArray1($array2);
                    scm_ArrayDeque_copySliceToArray($this, 0, $array2, var$4, $n);
                    scm_ArrayDeque_reset($this, $array2, 0, $_set_idx);
                } else {
                    $i = 0;
                    while ($i < var$4) {
                        $_set_idx = $i - var$4 | 0;
                        $this.$array4.data[scm_ArrayDeque_start_$plus($this, $_set_idx)] = $it.$next();
                        $i = $i + 1 | 0;
                    }
                    $this.$scala$collection$mutable$ArrayDeque$$start = ($this.$scala$collection$mutable$ArrayDeque$$start - var$4 | 0) & ($this.$array4.data.length - 1 | 0);
                }
            }
        }
        return $this;
    }
    function scm_ArrayDeque_addAll($this, $elems) {
        var var$2, var$3;
        var$2 = $elems.$knownSize();
        if (var$2 <= 0) {
            $elems = $elems.$iterator0();
            var$3 = new scm_ArrayDeque$addAll$lambda$_98_0;
            var$3.$_0259 = $this;
            $elems.$foreach(var$3);
        } else {
            scm_ArrayDeque_ensureSize($this, var$2 + scm_ArrayDeque_length($this) | 0);
            $elems = $elems.$iterator0();
            var$3 = new scm_ArrayDeque$addAll$lambda$_98_1;
            var$3.$_0260 = $this;
            $elems.$foreach(var$3);
        }
        return $this;
    }
    function scm_ArrayDeque_removeHead($this, $resizeInternalRepr) {
        var var$2, var$3, var$4, $removeHeadAssumingNonEmpty_elem;
        if (scm_ArrayDeque_isEmpty($this)) {
            var$2 = new ju_NoSuchElementException;
            jl_Throwable__init_(var$2, $rt_s(1040));
            $rt_throw(var$2);
        }
        var$3 = $this.$array4.data;
        var$4 = $this.$scala$collection$mutable$ArrayDeque$$start;
        $removeHeadAssumingNonEmpty_elem = var$3[var$4];
        var$3[var$4] = null;
        $this.$scala$collection$mutable$ArrayDeque$$start = scm_ArrayDeque_start_$plus($this, 1);
        if ($resizeInternalRepr)
            scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$resize($this, scm_ArrayDeque_length($this));
        return $removeHeadAssumingNonEmpty_elem;
    }
    function scm_ArrayDeque_ensureSize($this, $hint) {
        if ($hint > scm_ArrayDeque_length($this) && ($hint < $this.$array4.data.length ? 0 : 1)) {
            scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$resize($this, $hint);
            return;
        }
    }
    function scm_ArrayDeque_length($this) {
        var $scala$collection$mutable$ArrayDeque$$end_$minus_idx;
        $scala$collection$mutable$ArrayDeque$$end_$minus_idx = $this.$scala$collection$mutable$ArrayDeque$$start;
        return ($this.$scala$collection$mutable$ArrayDeque$$end - $scala$collection$mutable$ArrayDeque$$end_$minus_idx | 0) & ($this.$array4.data.length - 1 | 0);
    }
    function scm_ArrayDeque_isEmpty($this) {
        if ($this.$scala$collection$mutable$ArrayDeque$$start != $this.$scala$collection$mutable$ArrayDeque$$end)
            return 0;
        return 1;
    }
    function scm_ArrayDeque_copyToArray($this, $dest, $destStart, $len) {
        var $elemsToCopyToArray_srcLen, $elemsToCopyToArray_destLen, $copied;
        $elemsToCopyToArray_srcLen = scm_ArrayDeque_length($this);
        $elemsToCopyToArray_destLen = jlr_Array_getLength($dest);
        $copied = jl_Math_max(jl_Math_min(jl_Math_min($len, $elemsToCopyToArray_srcLen), $elemsToCopyToArray_destLen - $destStart | 0), 0);
        if ($copied > 0)
            scm_ArrayDeque_copySliceToArray($this, 0, $dest, $destStart, $len);
        return $copied;
    }
    function scm_ArrayDeque_toArray($this, $evidence$1) {
        return scm_ArrayDeque_copySliceToArray($this, 0, $evidence$1.$newArray(scm_ArrayDeque_length($this)), 0, scm_ArrayDeque_length($this));
    }
    function scm_ArrayDeque_start_$plus($this, $idx) {
        return ($this.$scala$collection$mutable$ArrayDeque$$start + $idx | 0) & ($this.$array4.data.length - 1 | 0);
    }
    function scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$resize($this, $len) {
        var $n, var$3;
        $n = $this.$array4.data.length;
        var$3 = $len < $n ? 0 : 1;
        if (!var$3 && !($n > 16 && ($n - $len | 0) > $len ? 1 : 0))
            return;
        $n = scm_ArrayDeque_length($this);
        scm_ArrayDeque_reset($this, scm_ArrayDeque_copySliceToArray($this, 0, scm_ArrayDeque$_alloc(scm_ArrayDeque$_MODULE$, $len), 0, $n), 0, $n);
    }
    function scm_ArrayDeque_addAll0($this, $xs) {
        return scm_ArrayDeque_addAll($this, $xs);
    }
    function scm_ArrayDeque_addOne0($this, $elem) {
        return scm_ArrayDeque_addOne($this, $elem);
    }
    function scm_ArrayDeque_apply0($this, $v1) {
        return scm_ArrayDeque_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function scm_ArrayDeque__init_($this, $array, $start, $end) {
        $this.$array4 = $array;
        $this.$scala$collection$mutable$ArrayDeque$$start = $start;
        $this.$scala$collection$mutable$ArrayDeque$$end = $end;
        scm_ArrayDeque_reset($this, $array, $start, $end);
    }
    var scm_Queue = $rt_classWithoutFields(scm_ArrayDeque);
    function scm_Queue_stringPrefix($this) {
        return $rt_s(1041);
    }
    function scm_Queue_dequeue($this) {
        return scm_ArrayDeque_removeHead($this, 0);
    }
    function scm_Queue_iterableFactory($this) {
        return scm_Queue$_MODULE$;
    }
    function sc_View$FlatMap() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying19 = null;
        a.$f8 = null;
    }
    function sc_View$FlatMap__init_(var_0, var_1) {
        var var_2 = new sc_View$FlatMap();
        sc_View$FlatMap__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function sc_View$FlatMap_iterator($this) {
        return ($this.$underlying19.$iterator0()).$flatMap2($this.$f8);
    }
    function sc_View$FlatMap_knownSize($this) {
        if ($this.$underlying19.$knownSize())
            return (-1);
        return 0;
    }
    function sc_View$FlatMap_isEmpty($this) {
        return sc_Iterator_isEmpty$(sc_View$FlatMap_iterator($this));
    }
    function sc_View$FlatMap__init_0($this, $underlying, $f) {
        $this.$underlying19 = $underlying;
        $this.$f8 = $f;
    }
    function sm_Ordering$Reverse() {
        jl_Object.call(this);
        this.$outer = null;
    }
    var jl_ClassCastException = $rt_classWithoutFields(jl_RuntimeException);
    function onciu_StepSequencer$$anonfun$orderSteps$20$lambda$_38_0() {
        var a = this; jl_Object.call(a);
        a.$_0218 = null;
        a.$_156 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$20$lambda$_38_0_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0218;
        var$3 = var$0.$_156;
        var$4 = new onciu_StepSequencer$$anonfun$orderSteps$21$lambda$_37_0;
        var$4.$_0226 = var$2;
        var$4.$_161 = var$3;
        su_Either_foreach(var$1, var$4);
        return sr_BoxedUnit_UNIT;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_1() {
        jl_Object.call(this);
        this.$_0220 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_1_apply(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0220;
        var$2 = new jl_IllegalArgumentException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1042)), var$1), $rt_s(512));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$2);
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_0() {
        var a = this; jl_Object.call(a);
        a.$_0219 = null;
        a.$_157 = null;
        a.$_223 = null;
        a.$_37 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_0_apply(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0219;
        var$3 = var$0.$_157;
        var$4 = var$0.$_223;
        var$5 = var$0.$_37;
        if (var$1 instanceof su_Left) {
            var$6 = var$1.$value11;
            if (jl_Object_equals(onciu_StepSequencer$ByInitialCondition$_MODULE$, var$6)) {
                var$1 = new jl_IllegalArgumentException;
                var$5 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$5);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, var$2), $rt_s(1043)), var$3), $rt_s(1044)), var$4), $rt_s(1045));
                jl_Throwable__init_(var$1, jl_AbstractStringBuilder_toString(var$5));
                $rt_throw(var$1);
            }
        }
        if (!(var$1 instanceof su_Right))
            $rt_throw(s_MatchError__init_(var$1));
        onciu_StepSequencer$MutableDirectedGraph_connect(var$5, var$2, var$1.$value10);
        return sr_BoxedUnit_UNIT;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_2() {
        jl_Object.call(this);
        this.$_0221 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_2_apply(var$0, var$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0221;
                    if (var$1 !== null) {
                        if (!jl_Object_equals(var$1, var$2))
                            break b;
                        else
                            break c;
                    }
                    if (var$2 !== null)
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return jl_Boolean_valueOf(var$3);
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_3() {
        var a = this; jl_Object.call(a);
        a.$_0222 = null;
        a.$_158 = null;
    }
    function onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_3_apply(var$0, var$1) {
        var$1 = var$1;
        onciu_StepSequencer$MutableDirectedGraph_connect(var$0.$_0222, var$0.$_158, var$1);
        return sr_BoxedUnit_UNIT;
    }
    function su_Right() {
        su_Either.call(this);
        this.$value10 = null;
    }
    function su_Right_value($this) {
        return $this.$value10;
    }
    function su_Right_productPrefix($this) {
        return $rt_s(1046);
    }
    function su_Right_productArity($this) {
        return 1;
    }
    function su_Right_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value10;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function su_Right_productIterator($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    }
    function su_Right_hashCode($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    }
    function su_Right_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function su_Right_equals($this, $x$1) {
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof su_Right) ? 0 : 1))
                    break a;
                $x$1 = $x$1;
                if (!sr_BoxesRunTime_equals($this.$value10, $x$1.$value10))
                    break a;
            }
            return 1;
        }
        return 0;
    }
    var ju_Set = $rt_classWithoutFields(0);
    var ju_AbstractSet = $rt_classWithoutFields(ju_AbstractCollection);
    function ju_AbstractSet_equals($this, $obj) {
        var $other, $iter;
        if ($this === $obj)
            return 1;
        if (!$rt_isInstance($obj, ju_Set))
            return 0;
        $other = $obj;
        if (ju_HashSet_size($this) != ju_HashSet_size($other))
            return 0;
        $iter = ju_HashSet_iterator($other);
        while (ju_LinkedHashMap$AbstractMapIterator_hasNext($iter)) {
            if (ju_HashSet_contains($this, ju_LinkedHashMap$KeyIterator_next($iter)))
                continue;
            else
                return 0;
        }
        return 1;
    }
    function ju_AbstractSet_hashCode($this) {
        var $result, $iter, $e;
        $result = 0;
        $iter = ju_HashSet_iterator($this);
        while (ju_LinkedHashMap$AbstractMapIterator_hasNext($iter)) {
            $e = ju_LinkedHashMap$KeyIterator_next($iter);
            if ($e !== null)
                $result = $result + $e.$hashCode0() | 0;
        }
        return $result;
    }
    var ju_TemplateCollections$AbstractImmutableSet = $rt_classWithoutFields(ju_AbstractSet);
    var ju_Collections$1 = $rt_classWithoutFields(ju_TemplateCollections$AbstractImmutableSet);
    function ju_AbstractMap() {
        var a = this; jl_Object.call(a);
        a.$cachedKeySet = null;
        a.$cachedValues = null;
    }
    function ju_AbstractMap_equals($this, $obj) {
        var $other, $iter, $entry;
        if ($this === $obj)
            return 1;
        if (!$rt_isInstance($obj, ju_Map))
            return 0;
        $other = $obj;
        if ($this.$elementCount1 != $other.$elementCount1)
            return 0;
        $iter = ju_LinkedHashMap$LinkedHashMapEntrySet_iterator(ju_LinkedHashMap_entrySet($this));
        while (ju_LinkedHashMap$AbstractMapIterator_hasNext($iter)) {
            $entry = ju_LinkedHashMap$EntryIterator_next($iter);
            if (!ju_HashMap_containsKey($other, $entry.$key0))
                return 0;
            if (!ju_Objects_equals($entry.$value12, ju_LinkedHashMap_get($other, $entry.$key0)))
                return 0;
        }
        return 1;
    }
    function ju_AbstractMap_hashCode($this) {
        var $result, $iter, $entry, var$4, var$5;
        $result = 0;
        $iter = ju_LinkedHashMap$LinkedHashMapEntrySet_iterator(ju_LinkedHashMap_entrySet($this));
        while (ju_LinkedHashMap$AbstractMapIterator_hasNext($iter)) {
            $entry = ju_LinkedHashMap$EntryIterator_next($iter);
            var$4 = $entry.$key0;
            var$5 = var$4 !== null ? var$4.$hashCode0() : 0;
            $entry = $entry.$value12;
            $result = $result ^ var$5 ^ ($entry !== null ? $entry.$hashCode0() : 0);
        }
        return $result;
    }
    function ju_AbstractMap_toString($this) {
        var $sb, $iter, $e, var$4;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        jl_AbstractStringBuilder_append($sb, 123);
        $iter = ju_LinkedHashMap$LinkedHashMapEntrySet_iterator(ju_LinkedHashMap_entrySet($this));
        if (ju_LinkedHashMap$AbstractMapIterator_hasNext($iter)) {
            $e = ju_LinkedHashMap$EntryIterator_next($iter);
            var$4 = $e.$key0;
            if (var$4 === $this)
                var$4 = $rt_s(1047);
            jl_StringBuilder_append($sb, var$4);
            jl_AbstractStringBuilder_append($sb, 61);
            $e = $e.$value12;
            if ($e === $this)
                $e = $rt_s(1047);
            jl_StringBuilder_append($sb, $e);
        }
        while (ju_LinkedHashMap$AbstractMapIterator_hasNext($iter)) {
            jl_AbstractStringBuilder_append1($sb, $rt_s(16));
            $e = ju_LinkedHashMap$EntryIterator_next($iter);
            var$4 = $e.$key0;
            if (var$4 === $this)
                var$4 = $rt_s(1047);
            jl_StringBuilder_append($sb, var$4);
            jl_AbstractStringBuilder_append($sb, 61);
            $e = $e.$value12;
            if ($e === $this)
                $e = $rt_s(1047);
            jl_StringBuilder_append($sb, $e);
        }
        jl_AbstractStringBuilder_append($sb, 125);
        return jl_AbstractStringBuilder_toString($sb);
    }
    var ju_TemplateCollections$AbstractImmutableMap = $rt_classWithoutFields(ju_AbstractMap);
    var ju_Collections$2 = $rt_classWithoutFields(ju_TemplateCollections$AbstractImmutableMap);
    var ju_TemplateCollections$AbstractImmutableList = $rt_classWithoutFields(ju_AbstractList);
    var ju_Collections$3 = $rt_classWithoutFields(ju_TemplateCollections$AbstractImmutableList);
    function ju_Collections$3_get($this, $index) {
        var var$2;
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$2);
        $rt_throw(var$2);
    }
    function ju_Collections$3_size($this) {
        return 0;
    }
    function ju_Collections$3_iterator($this) {
        return ju_Collections_EMPTY_ITERATOR;
    }
    function ju_Collections$3_isEmpty($this) {
        return 1;
    }
    var ju_Collections$4 = $rt_classWithoutFields();
    function ju_Collections$4_hasNext($this) {
        return 0;
    }
    function ju_Collections$4_next($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    var ju_ListIterator = $rt_classWithoutFields(0);
    var ju_Collections$5 = $rt_classWithoutFields();
    var ju_Collections$_clinit_$lambda$_58_0 = $rt_classWithoutFields();
    var ju_Collections$_clinit_$lambda$_58_1 = $rt_classWithoutFields();
    var oncipj_ExpectBar = $rt_classWithoutFields(jl_Enum);
    var oncipj_ExpectBar_EXPECT_BAR = null;
    var oncipj_ExpectBar_DO_NOT_EXPECT_BAR = null;
    var oncipj_ExpectBar_$VALUES = null;
    function oncipj_ExpectBar_$callClinit() {
        oncipj_ExpectBar_$callClinit = $rt_eraseClinit(oncipj_ExpectBar);
        oncipj_ExpectBar__clinit_();
    }
    function oncipj_ExpectBar__init_(var_0, var_1) {
        var var_2 = new oncipj_ExpectBar();
        oncipj_ExpectBar__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function oncipj_ExpectBar_values() {
        oncipj_ExpectBar_$callClinit();
        return oncipj_ExpectBar_$VALUES.$clone();
    }
    function oncipj_ExpectBar__init_0($this, var$1, var$2) {
        oncipj_ExpectBar_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    }
    function oncipj_ExpectBar__clinit_() {
        var var$1;
        oncipj_ExpectBar_EXPECT_BAR = oncipj_ExpectBar__init_($rt_s(1048), 0);
        var$1 = oncipj_ExpectBar__init_($rt_s(1049), 1);
        oncipj_ExpectBar_DO_NOT_EXPECT_BAR = var$1;
        oncipj_ExpectBar_$VALUES = $rt_createArrayFromData(oncipj_ExpectBar, [oncipj_ExpectBar_EXPECT_BAR, var$1]);
    }
    function sci_Set$Set3$$anon$2() {
        sci_Set$SetNIterator.call(this);
        this.$$outer18 = null;
    }
    function sci_Set$Set3$$anon$2_apply($this, $i) {
        var var$2;
        a: {
            var$2 = $this.$$outer18;
            switch ($i) {
                case 0:
                    break;
                case 1:
                    var$2 = var$2.$elem21;
                    break a;
                case 2:
                    var$2 = var$2.$elem30;
                    break a;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf($i)));
            }
            var$2 = var$2.$elem12;
        }
        return var$2;
    }
    function sm_Ordering$$anon$5() {
        var a = this; jl_Object.call(a);
        a.$ord$2 = null;
        a.$f$30 = null;
    }
    function sm_Ordering$$anon$5_max($this, $x, $y) {
        return sm_Ordering_max$($this, $x, $y);
    }
    function sm_Ordering$$anon$5_min($this, $x, $y) {
        return sm_Ordering_min$($this, $x, $y);
    }
    function sm_Ordering$$anon$5_lt($this, $x, $y) {
        return sm_Ordering$Int$_lt($this.$ord$2, onciu_InputPosition$$_clinit_$lambda$_0_0_apply($this.$f$30, $x), onciu_InputPosition$$_clinit_$lambda$_0_0_apply($this.$f$30, $y));
    }
    function sm_Ordering$$anon$5_gteq($this, $x, $y) {
        return sm_Ordering$Int$_gteq($this.$ord$2, onciu_InputPosition$$_clinit_$lambda$_0_0_apply($this.$f$30, $x), onciu_InputPosition$$_clinit_$lambda$_0_0_apply($this.$f$30, $y));
    }
    function sm_Ordering$$anon$5_lteq($this, $x, $y) {
        return sm_Ordering$Int$_lteq($this.$ord$2, onciu_InputPosition$$_clinit_$lambda$_0_0_apply($this.$f$30, $x), onciu_InputPosition$$_clinit_$lambda$_0_0_apply($this.$f$30, $y));
    }
    var ju_ConcurrentModificationException = $rt_classWithoutFields(jl_RuntimeException);
    function scm_RedBlackTree$Node() {
        var a = this; jl_Object.call(a);
        a.$key2 = null;
        a.$value18 = null;
        a.$red = 0;
        a.$left1 = null;
        a.$right0 = null;
        a.$parent0 = null;
    }
    function scm_RedBlackTree$Node__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new scm_RedBlackTree$Node();
        scm_RedBlackTree$Node__init_0(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    function scm_RedBlackTree$Node__init_0($this, $key, $value, $red, $left, $right, $parent) {
        $this.$key2 = $key;
        $this.$value18 = $value;
        $this.$red = $red;
        $this.$left1 = $left;
        $this.$right0 = $right;
        $this.$parent0 = $parent;
    }
    function oncir_ValidatingRewriter() {
        var a = this; jl_Object.call(a);
        a.$inner4 = null;
        a.$step3 = null;
    }
    function oncir_ValidatingRewriter_toString($this) {
        return $rt_s(17);
    }
    function oncir_ValidatingRewriter_apply($this, $that) {
        var $result, var$3, var$4;
        $result = $this.$inner4.$apply($that);
        var$3 = $this.$step3.$postConditions0();
        $that = new oncir_ValidatingRewriter$$anonfun$1;
        $that.$input$1 = $result;
        $that = var$3.$collect0($that);
        if (!$that.$exists(new oncir_ValidatingRewriter$validate$lambda$_34_0))
            return $result;
        $result = new jl_IllegalStateException;
        var$3 = scm_StringBuilder__init_();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(1050)), $rt_s(17)), $rt_s(1051));
        scm_StringBuilder_$plus$plus$eq(var$3, jl_AbstractStringBuilder_toString(var$4));
        $that = sc_AbstractIterable_withFilter($that, new oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_0);
        var$4 = new oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_1;
        var$4.$_0261 = var$3;
        sc_IterableOnceOps_foreach$(sc_IterableOps$WithFilter_filtered($that), var$4);
        jl_Throwable__init_($result, scm_StringBuilder_result(var$3));
        $rt_throw($result);
    }
    function oncir_ValidatingRewriter_productPrefix($this) {
        return $rt_s(1052);
    }
    function oncir_ValidatingRewriter_productArity($this) {
        return 2;
    }
    function oncir_ValidatingRewriter_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$inner4;
            case 1:
                return $this.$step3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncir_ValidatingRewriter_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncir_ValidatingRewriter_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncir_ValidatingRewriter_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncir_ValidatingRewriter) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$inner4;
                        var$3 = $x$1.$inner4;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$step3;
                        $x$1 = $x$1.$step3;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncir_ValidatingRewriter))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function sci_Vector3() {
        var a = this; sci_BigVector.call(a);
        a.$len13 = 0;
        a.$prefix20 = null;
        a.$len12 = 0;
        a.$data30 = null;
        a.$suffix20 = null;
    }
    function sci_Vector3__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new sci_Vector3();
        sci_Vector3__init_0(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    function sci_Vector3_len1($this) {
        return $this.$len13;
    }
    function sci_Vector3_prefix2($this) {
        return $this.$prefix20;
    }
    function sci_Vector3_len12($this) {
        return $this.$len12;
    }
    function sci_Vector3_data3($this) {
        return $this.$data30;
    }
    function sci_Vector3_suffix2($this) {
        return $this.$suffix20;
    }
    function sci_Vector3_apply($this, $index) {
        var $io, $i3, $i2, $i1, var$6;
        if ($index >= 0 && $index < $this.$length00) {
            $io = $index - $this.$len12 | 0;
            if ($io < 0) {
                $i3 = $this.$len13;
                if ($index < $i3)
                    return $this.$prefix10.data[$index];
                $io = $index - $i3 | 0;
                return $this.$prefix20.data[$io >>> 5].data[$io & 31];
            }
            $i3 = $io >>> 10;
            $i2 = $io >>> 5 & 31;
            $i1 = $io & 31;
            var$6 = $this.$data30.data;
            if ($i3 < var$6.length)
                return var$6[$i3].data[$i2].data[$i1];
            var$6 = $this.$suffix20.data;
            if ($i2 >= var$6.length)
                return $this.$suffix1.data[$i1];
            return var$6[$i2].data[$i1];
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector3_updated($this, $index, $elem) {
        var var$3, var$4, $x$3, $copyUpdate_a1c, $io, $copyUpdate_a2, $copyUpdate_idx2, $copyUpdate_idx1, $copyUpdate_a2c, $copyUpdate_copyUpdate_a1c, $i3, $i2, $i1, $copyUpdate_a3c, $copyUpdate_copyUpdate_a2c, $copyUpdate_copyUpdate_copyUpdate_a1c, $x$31, $copyUpdate_a2c_0;
        if ($index >= 0) {
            var$3 = $this.$length00;
            if ($index < var$3) {
                var$4 = $this.$len12;
                if ($index < var$4) {
                    $x$3 = $this.$len13;
                    if ($index < $x$3) {
                        $copyUpdate_a1c = $this.$prefix10.$clone();
                        $copyUpdate_a1c.data[$index] = $elem;
                        return sci_Vector3__init_($copyUpdate_a1c, $x$3, $this.$prefix20, var$4, $this.$data30, $this.$suffix20, $this.$suffix1, var$3);
                    }
                    $io = $index - $x$3 | 0;
                    $copyUpdate_a2 = $this.$prefix20;
                    $copyUpdate_idx2 = $io >>> 5;
                    $copyUpdate_idx1 = $io & 31;
                    $copyUpdate_a2c = $copyUpdate_a2.$clone();
                    $copyUpdate_a1c = $copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$copyUpdate_idx2].$clone();
                    $copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                    $copyUpdate_a1c[$copyUpdate_idx2] = $copyUpdate_copyUpdate_a1c;
                    return sci_Vector3__init_($this.$prefix10, $x$3, $copyUpdate_a2c, var$4, $this.$data30, $this.$suffix20, $this.$suffix1, var$3);
                }
                $io = $index - var$4 | 0;
                $i3 = $io >>> 10;
                $i2 = $io >>> 5 & 31;
                $i1 = $io & 31;
                $copyUpdate_a2c = $this.$data30;
                if ($i3 < $copyUpdate_a2c.data.length) {
                    $copyUpdate_a3c = $copyUpdate_a2c.$clone();
                    $copyUpdate_a1c = $copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_a2c = $copyUpdate_a1c[$i3].$clone();
                    $copyUpdate_a2c = $copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a1c = $copyUpdate_a2c[$i2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                    $copyUpdate_a2c[$i2] = $copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copyUpdate_a1c[$i3] = $copyUpdate_copyUpdate_a2c;
                    return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, var$4, $copyUpdate_a3c, $this.$suffix20, $this.$suffix1, var$3);
                }
                $x$31 = $this.$suffix20;
                if ($i2 >= $x$31.data.length) {
                    $copyUpdate_a1c = $this.$suffix1.$clone();
                    $copyUpdate_a1c.data[$i1] = $elem;
                    return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, var$4, $copyUpdate_a2c, $x$31, $copyUpdate_a1c, var$3);
                }
                $copyUpdate_a2c_0 = $x$31.$clone();
                $copyUpdate_a1c = $copyUpdate_a2c_0.data;
                $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$i2].$clone();
                $copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copyUpdate_a1c[$i2] = $copyUpdate_copyUpdate_a1c;
                return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, var$4, $copyUpdate_a2c, $copyUpdate_a2c_0, $this.$suffix1, var$3);
            }
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector3_appended($this, $elem) {
        var $wrap1_a, $x$1, $x$2, $wrap3_a, $x$9, $wrap1_a_0, $x$11, $x$21, var$10, $x$17, $x$18, $x$20, $x$23, $x$22, $x$24, $wrap3_x;
        $wrap1_a = $this.$suffix1;
        if ($wrap1_a.data.length < 32) {
            $x$1 = sci_VectorStatics$_copyAppend1(sci_VectorStatics$_MODULE$, $wrap1_a, $elem);
            $x$2 = $this.$length00 + 1 | 0;
            return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, $this.$len12, $this.$data30, $this.$suffix20, $x$1, $x$2);
        }
        $wrap3_a = $this.$suffix20;
        if ($wrap3_a.data.length < 31) {
            $x$9 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, $wrap3_a, $wrap1_a);
            $wrap1_a_0 = $rt_createArray(jl_Object, 1);
            $wrap1_a_0.data[0] = $elem;
            $x$11 = $this.$length00 + 1 | 0;
            return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, $this.$len12, $this.$data30, $x$9, $wrap1_a_0, $x$11);
        }
        $x$21 = $this.$data30;
        if ($x$21.data.length < 30) {
            var$10 = sci_VectorStatics$_MODULE$;
            $x$17 = sci_VectorStatics$_copyAppend(var$10, $x$21, sci_VectorStatics$_copyAppend(var$10, $wrap3_a, $wrap1_a));
            $x$18 = sci_VectorStatics$_empty2;
            $wrap1_a_0 = $rt_createArray(jl_Object, 1);
            $wrap1_a_0.data[0] = $elem;
            $x$20 = $this.$length00 + 1 | 0;
            return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, $this.$len12, $x$17, $x$18, $wrap1_a_0, $x$20);
        }
        var$10 = new sci_Vector4;
        $x$23 = $this.$prefix10;
        $x$22 = $this.$len13;
        $wrap1_a_0 = $this.$prefix20;
        $x$24 = $this.$len12;
        $x$11 = 30720 + $x$24 | 0;
        $x$17 = sci_VectorStatics$_empty4;
        $wrap3_x = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, $wrap3_a, $wrap1_a);
        $wrap3_a = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 1);
        $wrap3_a.data[0] = $wrap3_x;
        $wrap3_x = sci_VectorStatics$_empty2;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        sci_Vector4__init_0(var$10, $x$23, $x$22, $wrap1_a_0, $x$24, $x$21, $x$11, $x$17, $wrap3_a, $wrap3_x, $wrap1_a, $this.$length00 + 1 | 0);
        return var$10;
    }
    function sci_Vector3_prepended($this, $elem) {
        var $x$1, $x$2, $x$3, $x$4, $wrap1_a, $x$11, $x$12, $x$13, $x$19, $x$21, $x$22, var$13, $wrap3_x, $wrap3_a;
        if ($this.$len13 < 32) {
            $x$1 = sci_VectorStatics$_copyPrepend1(sci_VectorStatics$_MODULE$, $elem, $this.$prefix10);
            $x$2 = $this.$len13 + 1 | 0;
            $x$3 = $this.$len12 + 1 | 0;
            $x$4 = $this.$length00 + 1 | 0;
            return sci_Vector3__init_($x$1, $x$2, $this.$prefix20, $x$3, $this.$data30, $this.$suffix20, $this.$suffix1, $x$4);
        }
        if ($this.$len12 < 1024) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$11 = sci_VectorStatics$_copyPrepend(sci_VectorStatics$_MODULE$, $this.$prefix10, $this.$prefix20);
            $x$12 = $this.$len12 + 1 | 0;
            $x$13 = $this.$length00 + 1 | 0;
            return sci_Vector3__init_($wrap1_a, 1, $x$11, $x$12, $this.$data30, $this.$suffix20, $this.$suffix1, $x$13);
        }
        if ($this.$data30.data.length < 30) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$19 = sci_VectorStatics$_empty2;
            $elem = sci_VectorStatics$_MODULE$;
            $x$21 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, $this.$prefix10, $this.$prefix20), $this.$data30);
            $x$22 = $this.$length00 + 1 | 0;
            return sci_Vector3__init_($wrap1_a, 1, $x$19, 1, $x$21, $this.$suffix20, $this.$suffix1, $x$22);
        }
        var$13 = new sci_Vector4;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $x$19 = sci_VectorStatics$_empty2;
        $wrap3_x = sci_VectorStatics$_copyPrepend(sci_VectorStatics$_MODULE$, $this.$prefix10, $this.$prefix20);
        $wrap3_a = $rt_createArray($rt_arraycls($rt_arraycls(jl_Object)), 1);
        $wrap3_a.data[0] = $wrap3_x;
        sci_Vector4__init_0(var$13, $wrap1_a, 1, $x$19, 1, $wrap3_a, $this.$len12 + 1 | 0, sci_VectorStatics$_empty4, $this.$data30, $this.$suffix20, $this.$suffix1, $this.$length00 + 1 | 0);
        return var$13;
    }
    function sci_Vector3_map($this, $f) {
        var $x$1, $mapElems1_i, $mapElems_a, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i, $mapElems1_v1, $mapElems1_v2, $x$1_0, $mapElems1_mapElems1Rest_i, $mapElems_this, $mapElems_i, $mapElems_v1, $mapElems_v2, $mapElemsRest_ac, $mapElemsRest_i, $mapElemsRest_mapElems_a, $mapElemsRest_mapElems_mapElems1_i, $x$2, $mapElemsRest_mapElems_mapElems1_v1, $mapElemsRest_mapElems_mapElems1_v2, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, $mapElemsRest_mapElems_i, $mapElemsRest_mapElems_v1, $mapElemsRest_mapElems_v2,
        $x$3, $x$4, $x$5, $x$5_0;
        $x$1 = sci_Vector_prefix1($this);
        $mapElems1_i = 0;
        a: {
            while (true) {
                $mapElems_a = $x$1.data;
                $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElems_a.length;
                if ($mapElems1_i >= $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i)
                    break;
                $mapElems1_v1 = $mapElems_a[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$1_0 = $rt_createArray(jl_Object, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$1, 0, $x$1_0, 0, $mapElems1_i);
                    $x$1 = $x$1_0.data;
                    $x$1[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i) {
                        $x$1[$mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_a[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$1 = $x$1_0;
                    break a;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector3_prefix2($this);
        $mapElems_i = 0;
        b: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                $mapElems1_i = $x$1_0.length;
                if ($mapElems_i >= $mapElems1_i)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElemsRest_ac = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($mapElems_a)), $mapElems1_i);
                    if ($mapElems_i > 0)
                        jl_System_arraycopy($mapElems_a, 0, $mapElemsRest_ac, 0, $mapElems_i);
                    $mapElems_a = $mapElemsRest_ac.data;
                    $mapElems_a[$mapElems_i] = $mapElems_v2;
                    $mapElemsRest_i = $mapElems_i + 1 | 0;
                    while ($mapElemsRest_i < $mapElems1_i) {
                        $mapElemsRest_mapElems_a = $x$1_0[$mapElemsRest_i];
                        $mapElemsRest_mapElems_mapElems1_i = 0;
                        c: {
                            while (true) {
                                $x$2 = $mapElemsRest_mapElems_a.data;
                                $mapElems1_mapElems1Rest_i = $x$2.length;
                                if ($mapElemsRest_mapElems_mapElems1_i >= $mapElems1_mapElems1Rest_i)
                                    break;
                                $mapElemsRest_mapElems_mapElems1_v1 = $x$2[$mapElemsRest_mapElems_mapElems1_i];
                                $mapElemsRest_mapElems_mapElems1_v2 = $f.$apply($mapElemsRest_mapElems_mapElems1_v1);
                                if ($mapElemsRest_mapElems_mapElems1_v1 !== $mapElemsRest_mapElems_mapElems1_v2) {
                                    $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac = $rt_createArray(jl_Object, $mapElems1_mapElems1Rest_i);
                                    if ($mapElemsRest_mapElems_mapElems1_i > 0)
                                        jl_System_arraycopy($mapElemsRest_mapElems_a, 0, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, 0, $mapElemsRest_mapElems_mapElems1_i);
                                    $mapElems_v2 = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac.data;
                                    $mapElems_v2[$mapElemsRest_mapElems_mapElems1_i] = $mapElemsRest_mapElems_mapElems1_v2;
                                    $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                                    while ($mapElemsRest_mapElems_mapElems1_mapElems1Rest_i < $mapElems1_mapElems1Rest_i) {
                                        $mapElems_v2[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i] = $f.$apply($x$2[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i]);
                                        $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i + 1 | 0;
                                    }
                                    $mapElemsRest_mapElems_a = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac;
                                    break c;
                                }
                                $mapElemsRest_mapElems_mapElems1_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                            }
                        }
                        $mapElems_a[$mapElemsRest_i] = $mapElemsRest_mapElems_a;
                        $mapElemsRest_i = $mapElemsRest_i + 1 | 0;
                    }
                    $mapElems_a = $mapElemsRest_ac;
                    break b;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$2 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector3_data3($this);
        $mapElems_i = 0;
        d: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                $mapElems1_i = $x$1_0.length;
                if ($mapElems_i >= $mapElems1_i)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 2, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElemsRest_ac = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($mapElems_a)), $mapElems1_i);
                    if ($mapElems_i > 0)
                        jl_System_arraycopy($mapElems_a, 0, $mapElemsRest_ac, 0, $mapElems_i);
                    $mapElems_a = $mapElemsRest_ac.data;
                    $mapElems_a[$mapElems_i] = $mapElems_v2;
                    $mapElemsRest_i = $mapElems_i + 1 | 0;
                    while ($mapElemsRest_i < $mapElems1_i) {
                        $mapElemsRest_mapElems_a = $x$1_0[$mapElemsRest_i];
                        $mapElemsRest_mapElems_i = 0;
                        e: {
                            while (true) {
                                $mapElems_v2 = $mapElemsRest_mapElems_a.data;
                                if ($mapElemsRest_mapElems_i >= $mapElems_v2.length)
                                    break;
                                $mapElemsRest_mapElems_v1 = $mapElems_v2[$mapElemsRest_mapElems_i];
                                $mapElemsRest_mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElemsRest_mapElems_v1, $f);
                                if ($mapElemsRest_mapElems_v1 !== $mapElemsRest_mapElems_v2) {
                                    $mapElemsRest_mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 2, $mapElemsRest_mapElems_a, $f, $mapElemsRest_mapElems_i, $mapElemsRest_mapElems_v2);
                                    break e;
                                }
                                $mapElemsRest_mapElems_i = $mapElemsRest_mapElems_i + 1 | 0;
                            }
                        }
                        $mapElems_a[$mapElemsRest_i] = $mapElemsRest_mapElems_a;
                        $mapElemsRest_i = $mapElemsRest_i + 1 | 0;
                    }
                    $mapElems_a = $mapElemsRest_ac;
                    break d;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$3 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector3_suffix2($this);
        $mapElems_i = 0;
        f: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                if ($mapElems_i >= $x$1_0.length)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 2, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break f;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$4 = $mapElems_a;
        $x$5 = sci_BigVector_suffix1($this);
        $mapElems1_i = 0;
        g: {
            while (true) {
                $mapElems_a = $x$5.data;
                $mapElems_i = $mapElems_a.length;
                if ($mapElems1_i >= $mapElems_i)
                    break;
                $mapElems1_v1 = $mapElems_a[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$5_0 = $rt_createArray(jl_Object, $mapElems_i);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$5, 0, $x$5_0, 0, $mapElems1_i);
                    $x$1_0 = $x$5_0.data;
                    $x$1_0[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElems_i) {
                        $x$1_0[$mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_a[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$5 = $x$5_0;
                    break g;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        return sci_Vector3__init_($x$1, sci_Vector3_len1($this), $x$2, sci_Vector3_len12($this), $x$3, $x$4, $x$5, sci_BigVector_length0($this));
    }
    function sci_Vector3_slice0($this, $lo, $hi) {
        var $b;
        $b = sci_VectorSliceBuilder__init_($lo, $hi);
        sci_VectorSliceBuilder_consider($b, 1, $this.$prefix10);
        sci_VectorSliceBuilder_consider($b, 2, $this.$prefix20);
        sci_VectorSliceBuilder_consider($b, 3, $this.$data30);
        sci_VectorSliceBuilder_consider($b, 2, $this.$suffix20);
        sci_VectorSliceBuilder_consider($b, 1, $this.$suffix1);
        return sci_VectorSliceBuilder_result($b);
    }
    function sci_Vector3_init($this) {
        var $x$7, $x$6, $x$1, $x$2;
        $x$7 = $this.$suffix1;
        $x$6 = $x$7.data.length;
        if ($x$6 <= 1)
            return sci_Vector3_slice0($this, 0, $this.$length00 - 1 | 0);
        $x$1 = ju_Arrays_copyOfRange($x$7, 0, $x$6 - 1 | 0);
        $x$2 = $this.$length00 - 1 | 0;
        return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, $this.$len12, $this.$data30, $this.$suffix20, $x$1, $x$2);
    }
    function sci_Vector3_vectorSliceCount($this) {
        return 5;
    }
    function sci_Vector3_vectorSlice($this, $idx) {
        switch ($idx) {
            case 0:
                break;
            case 1:
                return $this.$prefix20;
            case 2:
                return $this.$data30;
            case 3:
                return $this.$suffix20;
            case 4:
                return $this.$suffix1;
            default:
                $rt_throw(s_MatchError__init_(jl_Integer_valueOf($idx)));
        }
        return $this.$prefix10;
    }
    function sci_Vector3_appendedAll0($this, $suffix, $k) {
        var $suffix1b, $x$8, $x$2;
        $suffix1b = sci_VectorStatics$_append1IfSpace(sci_VectorStatics$_MODULE$, $this.$suffix1, $suffix);
        if ($suffix1b === null)
            return sci_Vector_appendedAll0($this, $suffix, $k);
        $x$8 = $suffix1b.data;
        $x$2 = ($this.$length00 - $this.$suffix1.data.length | 0) + $x$8.length | 0;
        return sci_Vector3__init_($this.$prefix10, $this.$len13, $this.$prefix20, $this.$len12, $this.$data30, $this.$suffix20, $suffix1b, $x$2);
    }
    function sci_Vector3_init0($this) {
        return sci_Vector3_init($this);
    }
    function sci_Vector3_tail($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        if ($this.$len13 <= 1)
            var$1 = sci_Vector3_slice0($this, 1, $this.$length00);
        else {
            var$2 = $this.$prefix10;
            var$3 = ju_Arrays_copyOfRange(var$2, 1, var$2.data.length);
            var$4 = $this.$len13 - 1 | 0;
            var$5 = $this.$len12 - 1 | 0;
            var$6 = $this.$length00 - 1 | 0;
            var$1 = sci_Vector3__init_(var$3, var$4, $this.$prefix20, var$5, $this.$data30, $this.$suffix20, $this.$suffix1, var$6);
        }
        return var$1;
    }
    function sci_Vector3_map0($this, $f) {
        return sci_Vector3_map($this, $f);
    }
    function sci_Vector3_prepended0($this, $elem) {
        return sci_Vector3_prepended($this, $elem);
    }
    function sci_Vector3_appended0($this, $elem) {
        return sci_Vector3_appended($this, $elem);
    }
    function sci_Vector3_updated0($this, $index, $elem) {
        return sci_Vector3_updated($this, $index, $elem);
    }
    function sci_Vector3_apply0($this, $v1) {
        return sci_Vector3_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_Vector3__init_0($this, $_prefix1, $len1, $prefix2, $len12, $data3, $suffix2, $_suffix1, $_length0) {
        $this.$len13 = $len1;
        $this.$prefix20 = $prefix2;
        $this.$len12 = $len12;
        $this.$data30 = $data3;
        $this.$suffix20 = $suffix2;
        sci_BigVector__init_($this, $_prefix1, $_suffix1, $_length0);
    }
    function sc_ArrayOps$ArrayIterator$mcD$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcD$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcD$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcD$sp();
        sc_ArrayOps$ArrayIterator$mcD$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcD$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcD$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcD$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Double_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcD$sp__init_0($this, $xs$mcD$sp) {
        $this.$xs$mcD$sp = $xs$mcD$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcD$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcF$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcF$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcF$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcF$sp();
        sc_ArrayOps$ArrayIterator$mcF$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcF$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcF$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcF$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Float_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcF$sp__init_0($this, $xs$mcF$sp) {
        $this.$xs$mcF$sp = $xs$mcF$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcF$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcS$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcS$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcS$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcS$sp();
        sc_ArrayOps$ArrayIterator$mcS$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcS$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcS$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcS$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Short_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcS$sp__init_0($this, $xs$mcS$sp) {
        $this.$xs$mcS$sp = $xs$mcS$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcS$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcZ$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcZ$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcZ$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcZ$sp();
        sc_ArrayOps$ArrayIterator$mcZ$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcZ$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcZ$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcZ$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Boolean_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcZ$sp__init_0($this, $xs$mcZ$sp) {
        $this.$xs$mcZ$sp = $xs$mcZ$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcZ$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcV$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcV$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcV$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcV$sp();
        sc_ArrayOps$ArrayIterator$mcV$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcV$sp_next($this) {
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcV$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = $this.$scala$collection$ArrayOps$ArrayIterator$$pos + 1 | 0;
        return sr_BoxedUnit_UNIT;
    }
    function sc_ArrayOps$ArrayIterator$mcV$sp__init_0($this, $xs$mcV$sp) {
        $this.$xs$mcV$sp = $xs$mcV$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcV$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcJ$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcJ$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcJ$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcJ$sp();
        sc_ArrayOps$ArrayIterator$mcJ$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcJ$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcJ$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcJ$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Long_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcJ$sp__init_0($this, $xs$mcJ$sp) {
        $this.$xs$mcJ$sp = $xs$mcJ$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcJ$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcI$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcI$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcI$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcI$sp();
        sc_ArrayOps$ArrayIterator$mcI$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcI$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcI$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcI$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Integer_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcI$sp__init_0($this, $xs$mcI$sp) {
        $this.$xs$mcI$sp = $xs$mcI$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcI$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcB$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcB$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcB$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcB$sp();
        sc_ArrayOps$ArrayIterator$mcB$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcB$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcB$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcB$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Byte_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcB$sp__init_0($this, $xs$mcB$sp) {
        $this.$xs$mcB$sp = $xs$mcB$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcB$sp);
    }
    function sc_ArrayOps$ArrayIterator$mcC$sp() {
        sc_ArrayOps$ArrayIterator.call(this);
        this.$xs$mcC$sp = null;
    }
    function sc_ArrayOps$ArrayIterator$mcC$sp__init_(var_0) {
        var var_1 = new sc_ArrayOps$ArrayIterator$mcC$sp();
        sc_ArrayOps$ArrayIterator$mcC$sp__init_0(var_1, var_0);
        return var_1;
    }
    function sc_ArrayOps$ArrayIterator$mcC$sp_next($this) {
        var var$1, var$2, var$3;
        if ($this.$scala$collection$ArrayOps$ArrayIterator$$pos >= $this.$xs$mcC$sp.data.length)
            sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        var$1 = $this.$xs$mcC$sp.data;
        var$2 = $this.$scala$collection$ArrayOps$ArrayIterator$$pos;
        var$3 = var$1[var$2];
        $this.$scala$collection$ArrayOps$ArrayIterator$$pos = var$2 + 1 | 0;
        return jl_Character_valueOf(var$3);
    }
    function sc_ArrayOps$ArrayIterator$mcC$sp__init_0($this, $xs$mcC$sp) {
        $this.$xs$mcC$sp = $xs$mcC$sp;
        sc_ArrayOps$ArrayIterator__init_0($this, $xs$mcC$sp);
    }
    function scm_RedBlackTree$TreeIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$end3 = null;
        a.$ord = null;
        a.$nextNode = null;
    }
    function scm_RedBlackTree$TreeIterator_hasNext($this) {
        if ($this.$nextNode === null)
            return 0;
        return 1;
    }
    function scm_RedBlackTree$TreeIterator_next($this) {
        var var$1, var$2;
        var$1 = $this.$nextNode;
        if (var$1 === null) {
            var$2 = new ju_NoSuchElementException;
            jl_Throwable__init_(var$2, $rt_s(469));
            $rt_throw(var$2);
        }
        $this.$nextNode = scm_RedBlackTree$_scala$collection$mutable$RedBlackTree$$successor(scm_RedBlackTree$_MODULE$, var$1);
        scm_RedBlackTree$TreeIterator_setNullIfAfterEnd($this);
        return var$1.$key2;
    }
    function scm_RedBlackTree$TreeIterator_setNullIfAfterEnd($this) {
        var var$1;
        if (s_Option_isDefined($this.$end3)) {
            var$1 = $this.$nextNode;
            if (var$1 !== null && onciu_StepSequencer$$anonfun$heuristicStepOrdering$3_compare($this.$ord, var$1.$key2, s_None$_get($this.$end3)) >= 0) {
                $this.$nextNode = null;
                return;
            }
        }
    }
    var scm_RedBlackTree$KeysIterator = $rt_classWithoutFields(scm_RedBlackTree$TreeIterator);
    function jnci_BufferedEncoder$Controller() {
        var a = this; jl_Object.call(a);
        a.$in = null;
        a.$out2 = null;
        a.$inPosition = 0;
        a.$outPosition = 0;
    }
    function jnci_BufferedEncoder$Controller_hasMoreOutput($this, $sz) {
        return jn_Buffer_remaining($this.$out2) < $sz ? 0 : 1;
    }
    function onciu_CypherException() {
        jl_RuntimeException.call(this);
        this.$message1 = null;
    }
    function onciu_OpenCypherExceptionFactory$SyntaxException() {
        var a = this; onciu_CypherException.call(a);
        a.$message0 = null;
        a.$pos1 = null;
    }
    function onciu_OpenCypherExceptionFactory$SyntaxException_getMessage($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$message0;
        var$2 = $this.$pos1;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$1), $rt_s(104)), var$2), 41);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    var scm_Stack$ = $rt_classWithoutFields();
    var scm_Stack$_MODULE$ = null;
    function scm_Stack$__clinit_() {
        scm_Stack$_MODULE$ = new scm_Stack$;
    }
    function scm_Stack$_empty($this) {
        return scm_Stack__init_(16);
    }
    function scm_Stack$_newBuilder($this) {
        return scm_GrowableBuilder__init_0(scm_Stack$_empty($this));
    }
    function scm_Stack$_from($this, $source) {
        var var$2;
        var$2 = scm_Stack$_empty($this);
        if (var$2 === null)
            $rt_throw(null);
        return scm_ArrayDeque_addAll(var$2, $source);
    }
    var scm_Stack = $rt_classWithoutFields(scm_ArrayDeque);
    function scm_Stack__init_(var_0) {
        var var_1 = new scm_Stack();
        scm_Stack__init_0(var_1, var_0);
        return var_1;
    }
    function scm_Stack_stringPrefix($this) {
        return $rt_s(1053);
    }
    function scm_Stack_push($this, $elem) {
        var var$2, var$3, var$4;
        scm_ArrayDeque_ensureSize($this, scm_ArrayDeque_length($this) + 1 | 0);
        var$2 = $this.$scala$collection$mutable$ArrayDeque$$start - 1 | 0;
        var$3 = $this.$array4.data;
        var$4 = var$2 & (var$3.length - 1 | 0);
        $this.$scala$collection$mutable$ArrayDeque$$start = var$4;
        var$3[var$4] = $elem;
        return $this;
    }
    function scm_Stack_pushAll($this, $elems) {
        if ($rt_isInstance($elems, sc_Seq))
            $elems = ($elems.$view1()).$reverse();
        else {
            scm_IndexedSeq$_$callClinit();
            $elems = ((sc_SeqFactory$Delegate_from(scm_IndexedSeq$_MODULE$, $elems)).$view0()).$reverse0();
        }
        return scm_ArrayDeque_prependAll($this, $elems);
    }
    function scm_Stack_pop($this) {
        return scm_ArrayDeque_removeHead($this, 0);
    }
    function scm_Stack_iterableFactory($this) {
        return scm_Stack$_MODULE$;
    }
    function scm_Stack__init_0($this, $initialSize) {
        scm_ArrayDeque__init_($this, scm_ArrayDeque$_alloc(scm_ArrayDeque$_MODULE$, $initialSize), 0, 0);
    }
    var onciafn_Neo4jASTExceptionFactory$syntaxException$lambda$_10_0 = $rt_classWithoutFields();
    function onciafn_Neo4jASTExceptionFactory$syntaxException$lambda$_10_0_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(384)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_0() {
        var a = this; jl_Object.call(a);
        a.$_0262 = null;
        a.$_169 = 0;
        a.$_225 = null;
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_0__init_(var_0, var_1, var_2) {
        var var_3 = new sci_HashCollisionSetNode$filterImpl$lambda$_18_0();
        sci_HashCollisionSetNode$filterImpl$lambda$_18_0__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_0__init_0(var$0, var$1, var$2, var$3) {
        var$0.$_0262 = var$1;
        var$0.$_169 = var$2;
        var$0.$_225 = var$3;
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_0_apply(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$1(var$0.$_0262, var$0.$_169, var$0.$_225, var$1);
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_1() {
        var a = this; jl_Object.call(a);
        a.$_0263 = null;
        a.$_170 = 0;
        a.$_226 = null;
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_1__init_(var_0, var_1, var_2) {
        var var_3 = new sci_HashCollisionSetNode$filterImpl$lambda$_18_1();
        sci_HashCollisionSetNode$filterImpl$lambda$_18_1__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_1__init_0(var$0, var$1, var$2, var$3) {
        var$0.$_0263 = var$1;
        var$0.$_170 = var$2;
        var$0.$_226 = var$3;
    }
    function sci_HashCollisionSetNode$filterImpl$lambda$_18_1_apply(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$2(var$0.$_0263, var$0.$_170, var$0.$_226, var$1);
    }
    function sci_Vector4() {
        var a = this; sci_BigVector.call(a);
        a.$len14 = 0;
        a.$prefix21 = null;
        a.$len121 = 0;
        a.$prefix30 = null;
        a.$len123 = 0;
        a.$data40 = null;
        a.$suffix30 = null;
        a.$suffix21 = null;
    }
    function sci_Vector4__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10) {
        var var_11 = new sci_Vector4();
        sci_Vector4__init_0(var_11, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10);
        return var_11;
    }
    function sci_Vector4_len1($this) {
        return $this.$len14;
    }
    function sci_Vector4_prefix2($this) {
        return $this.$prefix21;
    }
    function sci_Vector4_len12($this) {
        return $this.$len121;
    }
    function sci_Vector4_prefix3($this) {
        return $this.$prefix30;
    }
    function sci_Vector4_len123($this) {
        return $this.$len123;
    }
    function sci_Vector4_data4($this) {
        return $this.$data40;
    }
    function sci_Vector4_suffix3($this) {
        return $this.$suffix30;
    }
    function sci_Vector4_suffix2($this) {
        return $this.$suffix21;
    }
    function sci_Vector4_copy$default$1($this) {
        return $this.$prefix10;
    }
    function sci_Vector4_copy$default$2($this) {
        return $this.$len14;
    }
    function sci_Vector4_copy$default$3($this) {
        return $this.$prefix21;
    }
    function sci_Vector4_copy$default$4($this) {
        return $this.$len121;
    }
    function sci_Vector4_copy$default$5($this) {
        return $this.$prefix30;
    }
    function sci_Vector4_copy$default$6($this) {
        return $this.$len123;
    }
    function sci_Vector4_copy$default$7($this) {
        return $this.$data40;
    }
    function sci_Vector4_copy$default$8($this) {
        return $this.$suffix30;
    }
    function sci_Vector4_copy$default$9($this) {
        return $this.$suffix21;
    }
    function sci_Vector4_copy$default$10($this) {
        return $this.$suffix1;
    }
    function sci_Vector4_copy$default$11($this) {
        return $this.$length00;
    }
    function sci_Vector4_apply($this, $index) {
        var $io, $i4, $i3, $i2, $i1, var$7;
        if ($index >= 0 && $index < $this.$length00) {
            $io = $index - $this.$len123 | 0;
            if ($io < 0) {
                $i4 = $this.$len121;
                if ($index >= $i4) {
                    $io = $index - $i4 | 0;
                    return $this.$prefix30.data[$io >>> 10].data[$io >>> 5 & 31].data[$io & 31];
                }
                $i4 = $this.$len14;
                if ($index < $i4)
                    return $this.$prefix10.data[$index];
                $io = $index - $i4 | 0;
                return $this.$prefix21.data[$io >>> 5].data[$io & 31];
            }
            $i4 = $io >>> 15;
            $i3 = $io >>> 10 & 31;
            $i2 = $io >>> 5 & 31;
            $i1 = $io & 31;
            var$7 = $this.$data40.data;
            if ($i4 < var$7.length)
                return var$7[$i4].data[$i3].data[$i2].data[$i1];
            var$7 = $this.$suffix30.data;
            if ($i3 < var$7.length)
                return var$7[$i3].data[$i2].data[$i1];
            var$7 = $this.$suffix21.data;
            if ($i2 >= var$7.length)
                return $this.$suffix1.data[$i1];
            return var$7[$i2].data[$i1];
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector4_updated($this, $index, $elem) {
        var $copy_len123, $copy_len12, $io, $copyUpdate_a3, $copyUpdate_idx3, $copyUpdate_idx2, $copyUpdate_idx1, $copyUpdate_a3c, $copyUpdate_a1c, $copyUpdate_copyUpdate_a2c, $copy_prefix2, $copyUpdate_copyUpdate_copyUpdate_a1c, $copyUpdate_a2, $copyUpdate_a2c, $copyUpdate_copyUpdate_a1c, $i4, $i3, $i2, $i1, $copyUpdate_a4c, $copyUpdate_copyUpdate_a3c, $copyUpdate_copyUpdate_copyUpdate_a2c, $copy_prefix3, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c, $copy_suffix2, $copy_data4, $copy_suffix3, $copyUpdate_a1c_0;
        if ($index >= 0) {
            $copy_len123 = $this.$length00;
            if ($index < $copy_len123) {
                $copy_len12 = $this.$len123;
                if ($index < $copy_len12) {
                    if ($index >= $this.$len121) {
                        $io = $index - sci_Vector4_len12($this) | 0;
                        $copyUpdate_a3 = sci_Vector4_prefix3($this);
                        $copyUpdate_idx3 = $io >>> 10;
                        $copyUpdate_idx2 = $io >>> 5 & 31;
                        $copyUpdate_idx1 = $io & 31;
                        $copyUpdate_a3c = $copyUpdate_a3.$clone();
                        $copyUpdate_a1c = $copyUpdate_a3c.data;
                        $copyUpdate_copyUpdate_a2c = $copyUpdate_a1c[$copyUpdate_idx3].$clone();
                        $copy_prefix2 = $copyUpdate_copyUpdate_a2c.data;
                        $copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix2[$copyUpdate_idx2].$clone();
                        $copyUpdate_copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                        $copy_prefix2[$copyUpdate_idx2] = $copyUpdate_copyUpdate_copyUpdate_a1c;
                        $copyUpdate_a1c[$copyUpdate_idx3] = $copyUpdate_copyUpdate_a2c;
                        return sci_Vector4__init_(sci_Vector4_copy$default$1($this), sci_Vector4_copy$default$2($this), sci_Vector4_copy$default$3($this), sci_Vector4_copy$default$4($this), $copyUpdate_a3c, sci_Vector4_copy$default$6($this), sci_Vector4_copy$default$7($this), sci_Vector4_copy$default$8($this), sci_Vector4_copy$default$9($this), sci_Vector4_copy$default$10($this), sci_Vector4_copy$default$11($this));
                    }
                    if ($index < sci_Vector4_len1($this)) {
                        $copyUpdate_a1c = (sci_Vector_prefix1($this)).$clone();
                        $copyUpdate_a1c.data[$index] = $elem;
                        return sci_Vector4__init_($copyUpdate_a1c, sci_Vector4_copy$default$2($this), sci_Vector4_copy$default$3($this), sci_Vector4_copy$default$4($this), sci_Vector4_copy$default$5($this), sci_Vector4_copy$default$6($this), sci_Vector4_copy$default$7($this), sci_Vector4_copy$default$8($this), sci_Vector4_copy$default$9($this), sci_Vector4_copy$default$10($this), sci_Vector4_copy$default$11($this));
                    }
                    $io = $index - sci_Vector4_len1($this) | 0;
                    $copyUpdate_a2 = sci_Vector4_prefix2($this);
                    $copyUpdate_idx2 = $io >>> 5;
                    $copyUpdate_idx1 = $io & 31;
                    $copyUpdate_a2c = $copyUpdate_a2.$clone();
                    $copyUpdate_a1c = $copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$copyUpdate_idx2].$clone();
                    $copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                    $copyUpdate_a1c[$copyUpdate_idx2] = $copyUpdate_copyUpdate_a1c;
                    return sci_Vector4__init_(sci_Vector4_copy$default$1($this), sci_Vector4_copy$default$2($this), $copyUpdate_a2c, sci_Vector4_copy$default$4($this), sci_Vector4_copy$default$5($this), sci_Vector4_copy$default$6($this), sci_Vector4_copy$default$7($this), sci_Vector4_copy$default$8($this), sci_Vector4_copy$default$9($this), sci_Vector4_copy$default$10($this), sci_Vector4_copy$default$11($this));
                }
                $io = $index - $copy_len12 | 0;
                $i4 = $io >>> 15;
                $i3 = $io >>> 10 & 31;
                $i2 = $io >>> 5 & 31;
                $i1 = $io & 31;
                $copy_prefix2 = $this.$data40;
                if ($i4 < $copy_prefix2.data.length) {
                    $copyUpdate_a4c = $copy_prefix2.$clone();
                    $copyUpdate_a1c = $copyUpdate_a4c.data;
                    $copyUpdate_copyUpdate_a3c = $copyUpdate_a1c[$i4].$clone();
                    $copy_prefix2 = $copyUpdate_copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix2[$i3].$clone();
                    $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix3[$i2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                    $copy_prefix3[$i2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copy_prefix2[$i3] = $copyUpdate_copyUpdate_copyUpdate_a2c;
                    $copyUpdate_a1c[$i4] = $copyUpdate_copyUpdate_a3c;
                    return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $copy_len12, $copyUpdate_a4c, $this.$suffix30, $this.$suffix21, $this.$suffix1, $copy_len123);
                }
                $copy_suffix2 = $this.$suffix30;
                if ($i3 < $copy_suffix2.data.length) {
                    $copyUpdate_a3c = $copy_suffix2.$clone();
                    $copy_data4 = $copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_a2c = $copy_data4[$i3].$clone();
                    $copyUpdate_a1c = $copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$i2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                    $copyUpdate_a1c[$i2] = $copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copy_data4[$i3] = $copyUpdate_copyUpdate_a2c;
                    return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $copy_len12, $copy_prefix2, $copyUpdate_a3c, $this.$suffix21, $this.$suffix1, $copy_len123);
                }
                $copy_suffix3 = $this.$suffix21;
                if ($i2 < $copy_suffix3.data.length) {
                    $copyUpdate_a2c = $copy_suffix3.$clone();
                    $copyUpdate_a1c = $copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$i2].$clone();
                    $copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                    $copyUpdate_a1c[$i2] = $copyUpdate_copyUpdate_a1c;
                    return sci_Vector4__init_($this.$prefix10, sci_Vector4_len1($this), sci_Vector4_copy$default$3($this), sci_Vector4_copy$default$4($this), sci_Vector4_copy$default$5($this), sci_Vector4_copy$default$6($this), sci_Vector4_copy$default$7($this), sci_Vector4_copy$default$8($this), $copyUpdate_a2c, sci_Vector4_copy$default$10($this), sci_Vector4_copy$default$11($this));
                }
                $copyUpdate_a1c_0 = $this.$suffix1.$clone();
                $copyUpdate_a1c_0.data[$i1] = $elem;
                return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $copy_len12, $copy_prefix2, $copy_suffix2, $copy_suffix3, $copyUpdate_a1c_0, $copy_len123);
            }
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector4_appended($this, $elem) {
        var $x$34, $x$1, $x$2, $wrap4_a, $x$12, $wrap1_a, $x$14, $wrap4_x, var$10, $x$23, $x$24, $x$26, $x$35, $x$32, $x$36, $x$39, $x$40, $x$38, $x$41, var$21, $x$43;
        $x$34 = $this.$suffix1;
        if ($x$34.data.length < 32) {
            $x$1 = sci_VectorStatics$_copyAppend1(sci_VectorStatics$_MODULE$, $x$34, $elem);
            $x$2 = $this.$length00 + 1 | 0;
            return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $this.$len123, $this.$data40, $this.$suffix30, $this.$suffix21, $x$1, $x$2);
        }
        $wrap4_a = $this.$suffix21;
        if ($wrap4_a.data.length < 31) {
            $x$12 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, $wrap4_a, $x$34);
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$14 = $this.$length00 + 1 | 0;
            return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $this.$len123, $this.$data40, $this.$suffix30, $x$12, $wrap1_a, $x$14);
        }
        $wrap4_x = $this.$suffix30;
        if ($wrap4_x.data.length < 31) {
            var$10 = sci_VectorStatics$_MODULE$;
            $x$23 = sci_VectorStatics$_copyAppend(var$10, $wrap4_x, sci_VectorStatics$_copyAppend(var$10, $wrap4_a, $x$34));
            $x$24 = sci_VectorStatics$_empty2;
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$26 = $this.$length00 + 1 | 0;
            return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $this.$len123, $this.$data40, $x$23, $x$24, $wrap1_a, $x$26);
        }
        $x$23 = $this.$data40;
        if ($x$23.data.length >= 30) {
            var$10 = new sci_Vector5;
            $x$35 = $this.$prefix10;
            $x$32 = $this.$len14;
            $x$36 = $this.$prefix21;
            $x$26 = $this.$len121;
            $x$39 = $this.$prefix30;
            $x$40 = $this.$len123;
            $x$38 = 983040 + $x$40 | 0;
            $x$41 = sci_VectorStatics$_empty5;
            var$21 = sci_VectorStatics$_MODULE$;
            $wrap4_x = sci_VectorStatics$_copyAppend(var$21, $wrap4_x, sci_VectorStatics$_copyAppend(var$21, $wrap4_a, $x$34));
            $wrap4_a = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))), 1);
            $wrap4_a.data[0] = $wrap4_x;
            $x$43 = sci_VectorStatics$_empty3;
            $x$34 = sci_VectorStatics$_empty2;
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            sci_Vector5__init_0(var$10, $x$35, $x$32, $x$36, $x$26, $x$39, $x$40, $x$23, $x$38, $x$41, $wrap4_a, $x$43, $x$34, $wrap1_a, $this.$length00 + 1 | 0);
            return var$10;
        }
        var$10 = sci_VectorStatics$_MODULE$;
        $x$34 = sci_VectorStatics$_copyAppend(var$10, $x$23, sci_VectorStatics$_copyAppend(var$10, $wrap4_x, sci_VectorStatics$_copyAppend(var$10, $wrap4_a, $x$34)));
        $x$35 = sci_VectorStatics$_empty3;
        $x$36 = sci_VectorStatics$_empty2;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $x$38 = $this.$length00 + 1 | 0;
        return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $this.$len123, $x$34, $x$35, $x$36, $wrap1_a, $x$38);
    }
    function sci_Vector4_prepended($this, $elem) {
        var $x$1, $x$2, $x$3, $x$4, $x$5, $wrap1_a, $x$14, $x$15, $x$16, $x$17, $x$25, $x$27, $x$28, $x$29, $x$36, $x$38, $x$40, $x$41, var$20, $x$43, $x$44, $wrap4_x, $wrap4_a;
        if ($this.$len14 < 32) {
            $x$1 = sci_VectorStatics$_copyPrepend1(sci_VectorStatics$_MODULE$, $elem, $this.$prefix10);
            $x$2 = $this.$len14 + 1 | 0;
            $x$3 = $this.$len121 + 1 | 0;
            $x$4 = $this.$len123 + 1 | 0;
            $x$5 = $this.$length00 + 1 | 0;
            return sci_Vector4__init_($x$1, $x$2, $this.$prefix21, $x$3, $this.$prefix30, $x$4, $this.$data40, $this.$suffix30, $this.$suffix21, $this.$suffix1, $x$5);
        }
        if ($this.$len121 < 1024) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$14 = sci_VectorStatics$_copyPrepend(sci_VectorStatics$_MODULE$, $this.$prefix10, $this.$prefix21);
            $x$15 = $this.$len121 + 1 | 0;
            $x$16 = $this.$len123 + 1 | 0;
            $x$17 = $this.$length00 + 1 | 0;
            return sci_Vector4__init_($wrap1_a, 1, $x$14, $x$15, $this.$prefix30, $x$16, $this.$data40, $this.$suffix30, $this.$suffix21, $this.$suffix1, $x$17);
        }
        if ($this.$len123 < 32768) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$25 = sci_VectorStatics$_empty2;
            $elem = sci_VectorStatics$_MODULE$;
            $x$27 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, $this.$prefix10, $this.$prefix21), $this.$prefix30);
            $x$28 = $this.$len123 + 1 | 0;
            $x$29 = $this.$length00 + 1 | 0;
            return sci_Vector4__init_($wrap1_a, 1, $x$25, 1, $x$27, $x$28, $this.$data40, $this.$suffix30, $this.$suffix21, $this.$suffix1, $x$29);
        }
        if ($this.$data40.data.length < 30) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$36 = sci_VectorStatics$_empty2;
            $x$38 = sci_VectorStatics$_empty3;
            $elem = sci_VectorStatics$_MODULE$;
            $x$40 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, $this.$prefix10, $this.$prefix21), $this.$prefix30), $this.$data40);
            $x$41 = $this.$length00 + 1 | 0;
            return sci_Vector4__init_($wrap1_a, 1, $x$36, 1, $x$38, 1, $x$40, $this.$suffix30, $this.$suffix21, $this.$suffix1, $x$41);
        }
        var$20 = new sci_Vector5;
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $x$43 = sci_VectorStatics$_empty2;
        $x$44 = sci_VectorStatics$_empty3;
        $elem = sci_VectorStatics$_MODULE$;
        $wrap4_x = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, $this.$prefix10, $this.$prefix21), $this.$prefix30);
        $wrap4_a = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object))), 1);
        $wrap4_a.data[0] = $wrap4_x;
        sci_Vector5__init_0(var$20, $wrap1_a, 1, $x$43, 1, $x$44, 1, $wrap4_a, $this.$len123 + 1 | 0, sci_VectorStatics$_empty5, $this.$data40, $this.$suffix30, $this.$suffix21, $this.$suffix1, $this.$length00 + 1 | 0);
        return var$20;
    }
    function sci_Vector4_map($this, $f) {
        var $x$1, $mapElems1_i, $mapElems_a, $mapElems_i, $mapElems1_v1, $mapElems1_v2, $x$1_0, $mapElems1_mapElems1Rest_i, $mapElems_this, $mapElems_v1, $mapElems_v2, $mapElemsRest_ac, $mapElemsRest_i, $mapElemsRest_mapElems_a, $mapElemsRest_mapElems_mapElems1_i, $mapElemsRest_mapElems_mapElems1_v1, $mapElemsRest_mapElems_mapElems1_v2, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7, $mapElems1_i_0, $x$7_0;
        $x$1 = sci_Vector_prefix1($this);
        $mapElems1_i = 0;
        a: {
            while (true) {
                $mapElems_a = $x$1.data;
                $mapElems_i = $mapElems_a.length;
                if ($mapElems1_i >= $mapElems_i)
                    break;
                $mapElems1_v1 = $mapElems_a[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$1_0 = $rt_createArray(jl_Object, $mapElems_i);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$1, 0, $x$1_0, 0, $mapElems1_i);
                    $x$1 = $x$1_0.data;
                    $x$1[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElems_i) {
                        $x$1[$mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_a[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$1 = $x$1_0;
                    break a;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector4_prefix2($this);
        $mapElems_i = 0;
        b: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                $mapElems1_i = $x$1_0.length;
                if ($mapElems_i >= $mapElems1_i)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElemsRest_ac = jlr_Array_newInstance(jl_Class_getComponentType(jl_Object_getClass($mapElems_a)), $mapElems1_i);
                    if ($mapElems_i > 0)
                        jl_System_arraycopy($mapElems_a, 0, $mapElemsRest_ac, 0, $mapElems_i);
                    $mapElems_a = $mapElemsRest_ac.data;
                    $mapElems_a[$mapElems_i] = $mapElems_v2;
                    $mapElemsRest_i = $mapElems_i + 1 | 0;
                    while ($mapElemsRest_i < $mapElems1_i) {
                        $mapElemsRest_mapElems_a = $x$1_0[$mapElemsRest_i];
                        $mapElemsRest_mapElems_mapElems1_i = 0;
                        c: {
                            while (true) {
                                $mapElems_v2 = $mapElemsRest_mapElems_a.data;
                                $mapElems1_mapElems1Rest_i = $mapElems_v2.length;
                                if ($mapElemsRest_mapElems_mapElems1_i >= $mapElems1_mapElems1Rest_i)
                                    break;
                                $mapElemsRest_mapElems_mapElems1_v1 = $mapElems_v2[$mapElemsRest_mapElems_mapElems1_i];
                                $mapElemsRest_mapElems_mapElems1_v2 = $f.$apply($mapElemsRest_mapElems_mapElems1_v1);
                                if ($mapElemsRest_mapElems_mapElems1_v1 !== $mapElemsRest_mapElems_mapElems1_v2) {
                                    $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac = $rt_createArray(jl_Object, $mapElems1_mapElems1Rest_i);
                                    if ($mapElemsRest_mapElems_mapElems1_i > 0)
                                        jl_System_arraycopy($mapElemsRest_mapElems_a, 0, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac, 0, $mapElemsRest_mapElems_mapElems1_i);
                                    $mapElemsRest_mapElems_a = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac.data;
                                    $mapElemsRest_mapElems_a[$mapElemsRest_mapElems_mapElems1_i] = $mapElemsRest_mapElems_mapElems1_v2;
                                    $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                                    while ($mapElemsRest_mapElems_mapElems1_mapElems1Rest_i < $mapElems1_mapElems1Rest_i) {
                                        $mapElemsRest_mapElems_a[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_v2[$mapElemsRest_mapElems_mapElems1_mapElems1Rest_i]);
                                        $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i + 1 | 0;
                                    }
                                    $mapElemsRest_mapElems_a = $mapElemsRest_mapElems_mapElems1_mapElems1Rest_ac;
                                    break c;
                                }
                                $mapElemsRest_mapElems_mapElems1_i = $mapElemsRest_mapElems_mapElems1_i + 1 | 0;
                            }
                        }
                        $mapElems_a[$mapElemsRest_i] = $mapElemsRest_mapElems_a;
                        $mapElemsRest_i = $mapElemsRest_i + 1 | 0;
                    }
                    $mapElems_a = $mapElemsRest_ac;
                    break b;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$2 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector4_prefix3($this);
        $mapElems_i = 0;
        d: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                if ($mapElems_i >= $x$1_0.length)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 2, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 3, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break d;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$3 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector4_data4($this);
        $mapElems_i = 0;
        e: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                if ($mapElems_i >= $x$1_0.length)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 3, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 4, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break e;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$4 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector4_suffix3($this);
        $mapElems_i = 0;
        f: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                if ($mapElems_i >= $x$1_0.length)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 2, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 3, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break f;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$5 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector4_suffix2($this);
        $mapElems_i = 0;
        g: {
            while (true) {
                $x$1_0 = $mapElems_a.data;
                if ($mapElems_i >= $x$1_0.length)
                    break;
                $mapElems_v1 = $x$1_0[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 2, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break g;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$6 = $mapElems_a;
        $x$7 = sci_BigVector_suffix1($this);
        $mapElems1_i_0 = 0;
        h: {
            while (true) {
                $x$1_0 = $x$7.data;
                $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i = $x$1_0.length;
                if ($mapElems1_i_0 >= $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i)
                    break;
                $mapElems1_v1 = $x$1_0[$mapElems1_i_0];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$7_0 = $rt_createArray(jl_Object, $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i);
                    if ($mapElems1_i_0 > 0)
                        jl_System_arraycopy($x$7, 0, $x$7_0, 0, $mapElems1_i_0);
                    $mapElems_a = $x$7_0.data;
                    $mapElems_a[$mapElems1_i_0] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i_0 + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElemsRest_mapElems_mapElems1_mapElems1Rest_i) {
                        $mapElems_a[$mapElems1_mapElems1Rest_i] = $f.$apply($x$1_0[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$7 = $x$7_0;
                    break h;
                }
                $mapElems1_i_0 = $mapElems1_i_0 + 1 | 0;
            }
        }
        return sci_Vector4__init_($x$1, sci_Vector4_copy$default$2($this), $x$2, sci_Vector4_copy$default$4($this), $x$3, sci_Vector4_copy$default$6($this), $x$4, $x$5, $x$6, $x$7, sci_Vector4_copy$default$11($this));
    }
    function sci_Vector4_slice0($this, $lo, $hi) {
        var $b;
        $b = sci_VectorSliceBuilder__init_($lo, $hi);
        sci_VectorSliceBuilder_consider($b, 1, $this.$prefix10);
        sci_VectorSliceBuilder_consider($b, 2, $this.$prefix21);
        sci_VectorSliceBuilder_consider($b, 3, $this.$prefix30);
        sci_VectorSliceBuilder_consider($b, 4, $this.$data40);
        sci_VectorSliceBuilder_consider($b, 3, $this.$suffix30);
        sci_VectorSliceBuilder_consider($b, 2, $this.$suffix21);
        sci_VectorSliceBuilder_consider($b, 1, $this.$suffix1);
        return sci_VectorSliceBuilder_result($b);
    }
    function sci_Vector4_init($this) {
        var $x$10, $x$6, $x$1, $x$2;
        $x$10 = $this.$suffix1;
        $x$6 = $x$10.data.length;
        if ($x$6 <= 1)
            return sci_Vector4_slice0($this, 0, $this.$length00 - 1 | 0);
        $x$1 = ju_Arrays_copyOfRange($x$10, 0, $x$6 - 1 | 0);
        $x$2 = $this.$length00 - 1 | 0;
        return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $this.$len123, $this.$data40, $this.$suffix30, $this.$suffix21, $x$1, $x$2);
    }
    function sci_Vector4_vectorSliceCount($this) {
        return 7;
    }
    function sci_Vector4_vectorSlice($this, $idx) {
        switch ($idx) {
            case 0:
                break;
            case 1:
                return $this.$prefix21;
            case 2:
                return $this.$prefix30;
            case 3:
                return $this.$data40;
            case 4:
                return $this.$suffix30;
            case 5:
                return $this.$suffix21;
            case 6:
                return $this.$suffix1;
            default:
                $rt_throw(s_MatchError__init_(jl_Integer_valueOf($idx)));
        }
        return $this.$prefix10;
    }
    function sci_Vector4_appendedAll0($this, $suffix, $k) {
        var $suffix1b, $x$5, $x$2;
        $suffix1b = sci_VectorStatics$_append1IfSpace(sci_VectorStatics$_MODULE$, $this.$suffix1, $suffix);
        if ($suffix1b === null)
            return sci_Vector_appendedAll0($this, $suffix, $k);
        $x$5 = $suffix1b.data;
        $x$2 = ($this.$length00 - $this.$suffix1.data.length | 0) + $x$5.length | 0;
        return sci_Vector4__init_($this.$prefix10, $this.$len14, $this.$prefix21, $this.$len121, $this.$prefix30, $this.$len123, $this.$data40, $this.$suffix30, $this.$suffix21, $suffix1b, $x$2);
    }
    function sci_Vector4_init0($this) {
        return sci_Vector4_init($this);
    }
    function sci_Vector4_tail($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7;
        if ($this.$len14 <= 1)
            var$1 = sci_Vector4_slice0($this, 1, $this.$length00);
        else {
            var$2 = $this.$prefix10;
            var$3 = ju_Arrays_copyOfRange(var$2, 1, var$2.data.length);
            var$4 = $this.$len14 - 1 | 0;
            var$5 = $this.$len121 - 1 | 0;
            var$6 = $this.$len123 - 1 | 0;
            var$7 = $this.$length00 - 1 | 0;
            var$1 = sci_Vector4__init_(var$3, var$4, $this.$prefix21, var$5, $this.$prefix30, var$6, $this.$data40, $this.$suffix30, $this.$suffix21, $this.$suffix1, var$7);
        }
        return var$1;
    }
    function sci_Vector4_map0($this, $f) {
        return sci_Vector4_map($this, $f);
    }
    function sci_Vector4_prepended0($this, $elem) {
        return sci_Vector4_prepended($this, $elem);
    }
    function sci_Vector4_appended0($this, $elem) {
        return sci_Vector4_appended($this, $elem);
    }
    function sci_Vector4_updated0($this, $index, $elem) {
        return sci_Vector4_updated($this, $index, $elem);
    }
    function sci_Vector4_apply0($this, $v1) {
        return sci_Vector4_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_Vector4__init_0($this, $_prefix1, $len1, $prefix2, $len12, $prefix3, $len123, $data4, $suffix3, $suffix2, $_suffix1, $_length0) {
        $this.$len14 = $len1;
        $this.$prefix21 = $prefix2;
        $this.$len121 = $len12;
        $this.$prefix30 = $prefix3;
        $this.$len123 = $len123;
        $this.$data40 = $data4;
        $this.$suffix30 = $suffix3;
        $this.$suffix21 = $suffix2;
        sci_BigVector__init_($this, $_prefix1, $_suffix1, $_length0);
    }
    function sci_Vector5() {
        var a = this; sci_BigVector.call(a);
        a.$len15 = 0;
        a.$prefix22 = null;
        a.$len122 = 0;
        a.$prefix31 = null;
        a.$len1231 = 0;
        a.$prefix40 = null;
        a.$len1234 = 0;
        a.$data50 = null;
        a.$suffix40 = null;
        a.$suffix31 = null;
        a.$suffix22 = null;
    }
    function sci_Vector5__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10, var_11, var_12, var_13) {
        var var_14 = new sci_Vector5();
        sci_Vector5__init_0(var_14, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10, var_11, var_12, var_13);
        return var_14;
    }
    function sci_Vector5_len1($this) {
        return $this.$len15;
    }
    function sci_Vector5_prefix2($this) {
        return $this.$prefix22;
    }
    function sci_Vector5_len12($this) {
        return $this.$len122;
    }
    function sci_Vector5_prefix3($this) {
        return $this.$prefix31;
    }
    function sci_Vector5_len123($this) {
        return $this.$len1231;
    }
    function sci_Vector5_prefix4($this) {
        return $this.$prefix40;
    }
    function sci_Vector5_len1234($this) {
        return $this.$len1234;
    }
    function sci_Vector5_data5($this) {
        return $this.$data50;
    }
    function sci_Vector5_suffix4($this) {
        return $this.$suffix40;
    }
    function sci_Vector5_suffix3($this) {
        return $this.$suffix31;
    }
    function sci_Vector5_suffix2($this) {
        return $this.$suffix22;
    }
    function sci_Vector5_copy$default$1($this) {
        return $this.$prefix10;
    }
    function sci_Vector5_copy$default$2($this) {
        return $this.$len15;
    }
    function sci_Vector5_copy$default$3($this) {
        return $this.$prefix22;
    }
    function sci_Vector5_copy$default$4($this) {
        return $this.$len122;
    }
    function sci_Vector5_copy$default$5($this) {
        return $this.$prefix31;
    }
    function sci_Vector5_copy$default$6($this) {
        return $this.$len1231;
    }
    function sci_Vector5_copy$default$7($this) {
        return $this.$prefix40;
    }
    function sci_Vector5_copy$default$8($this) {
        return $this.$len1234;
    }
    function sci_Vector5_copy$default$9($this) {
        return $this.$data50;
    }
    function sci_Vector5_copy$default$10($this) {
        return $this.$suffix40;
    }
    function sci_Vector5_copy$default$11($this) {
        return $this.$suffix31;
    }
    function sci_Vector5_copy$default$12($this) {
        return $this.$suffix22;
    }
    function sci_Vector5_copy$default$13($this) {
        return $this.$suffix1;
    }
    function sci_Vector5_copy$default$14($this) {
        return $this.$length00;
    }
    function sci_Vector5_apply($this, $index) {
        var $io, $i5, $i4, $i3, $i2, $i1, var$8;
        if ($index >= 0 && $index < $this.$length00) {
            $io = $index - $this.$len1234 | 0;
            if ($io < 0) {
                $i5 = $this.$len1231;
                if ($index >= $i5) {
                    $io = $index - $i5 | 0;
                    return $this.$prefix40.data[$io >>> 15].data[$io >>> 10 & 31].data[$io >>> 5 & 31].data[$io & 31];
                }
                $i5 = $this.$len122;
                if ($index >= $i5) {
                    $io = $index - $i5 | 0;
                    return $this.$prefix31.data[$io >>> 10].data[$io >>> 5 & 31].data[$io & 31];
                }
                $i5 = $this.$len15;
                if ($index < $i5)
                    return $this.$prefix10.data[$index];
                $io = $index - $i5 | 0;
                return $this.$prefix22.data[$io >>> 5].data[$io & 31];
            }
            $i5 = $io >>> 20;
            $i4 = $io >>> 15 & 31;
            $i3 = $io >>> 10 & 31;
            $i2 = $io >>> 5 & 31;
            $i1 = $io & 31;
            var$8 = $this.$data50.data;
            if ($i5 < var$8.length)
                return var$8[$i5].data[$i4].data[$i3].data[$i2].data[$i1];
            var$8 = $this.$suffix40.data;
            if ($i4 < var$8.length)
                return var$8[$i4].data[$i3].data[$i2].data[$i1];
            var$8 = $this.$suffix31.data;
            if ($i3 < var$8.length)
                return var$8[$i3].data[$i2].data[$i1];
            var$8 = $this.$suffix22.data;
            if ($i2 >= var$8.length)
                return $this.$suffix1.data[$i1];
            return var$8[$i2].data[$i1];
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector5_updated($this, $index, $elem) {
        var $io, $copyUpdate_a4, $copyUpdate_idx4, $copyUpdate_idx3, $copyUpdate_idx2, $copyUpdate_idx1, $copyUpdate_a4c, $copyUpdate_a1c, $copyUpdate_copyUpdate_a3c, $copy_prefix2, $copyUpdate_copyUpdate_copyUpdate_a2c, $copy_prefix3, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c, $copyUpdate_a3, $copyUpdate_a3c, $copyUpdate_copyUpdate_a2c, $copyUpdate_copyUpdate_copyUpdate_a1c, $copyUpdate_a2, $copyUpdate_a2c, $copyUpdate_copyUpdate_a1c, $i5, $i4, $i3, $i2, $i1, $copyUpdate_a5c, $copyUpdate_copyUpdate_a4c,
        $copyUpdate_copyUpdate_copyUpdate_a3c, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c, $copy_prefix4, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
        if ($index >= 0 && $index < sci_BigVector_length0($this)) {
            if ($index < sci_Vector5_len1234($this)) {
                if ($index >= sci_Vector5_len123($this)) {
                    $io = $index - sci_Vector5_len123($this) | 0;
                    $copyUpdate_a4 = sci_Vector5_prefix4($this);
                    $copyUpdate_idx4 = $io >>> 15;
                    $copyUpdate_idx3 = $io >>> 10 & 31;
                    $copyUpdate_idx2 = $io >>> 5 & 31;
                    $copyUpdate_idx1 = $io & 31;
                    $copyUpdate_a4c = $copyUpdate_a4.$clone();
                    $copyUpdate_a1c = $copyUpdate_a4c.data;
                    $copyUpdate_copyUpdate_a3c = $copyUpdate_a1c[$copyUpdate_idx4].$clone();
                    $copy_prefix2 = $copyUpdate_copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix2[$copyUpdate_idx3].$clone();
                    $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix3[$copyUpdate_idx2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                    $copy_prefix3[$copyUpdate_idx2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copy_prefix2[$copyUpdate_idx3] = $copyUpdate_copyUpdate_copyUpdate_a2c;
                    $copyUpdate_a1c[$copyUpdate_idx4] = $copyUpdate_copyUpdate_a3c;
                    return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), $copyUpdate_a4c, sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), sci_Vector5_copy$default$10($this), sci_Vector5_copy$default$11($this), sci_Vector5_copy$default$12($this), sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
                }
                if ($index >= sci_Vector5_len12($this)) {
                    $io = $index - sci_Vector5_len12($this) | 0;
                    $copyUpdate_a3 = sci_Vector5_prefix3($this);
                    $copyUpdate_idx3 = $io >>> 10;
                    $copyUpdate_idx2 = $io >>> 5 & 31;
                    $copyUpdate_idx1 = $io & 31;
                    $copyUpdate_a3c = $copyUpdate_a3.$clone();
                    $copyUpdate_a1c = $copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_a2c = $copyUpdate_a1c[$copyUpdate_idx3].$clone();
                    $copy_prefix2 = $copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix2[$copyUpdate_idx2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                    $copy_prefix2[$copyUpdate_idx2] = $copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copyUpdate_a1c[$copyUpdate_idx3] = $copyUpdate_copyUpdate_a2c;
                    return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), $copyUpdate_a3c, sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), sci_Vector5_copy$default$10($this), sci_Vector5_copy$default$11($this), sci_Vector5_copy$default$12($this), sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
                }
                if ($index < sci_Vector5_len1($this)) {
                    $copyUpdate_a1c = (sci_Vector_prefix1($this)).$clone();
                    $copyUpdate_a1c.data[$index] = $elem;
                    return sci_Vector5__init_($copyUpdate_a1c, sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), sci_Vector5_copy$default$10($this), sci_Vector5_copy$default$11($this), sci_Vector5_copy$default$12($this), sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
                }
                $io = $index - sci_Vector5_len1($this) | 0;
                $copyUpdate_a2 = sci_Vector5_prefix2($this);
                $copyUpdate_idx2 = $io >>> 5;
                $copyUpdate_idx1 = $io & 31;
                $copyUpdate_a2c = $copyUpdate_a2.$clone();
                $copyUpdate_a1c = $copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$copyUpdate_idx2].$clone();
                $copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                $copyUpdate_a1c[$copyUpdate_idx2] = $copyUpdate_copyUpdate_a1c;
                return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), $copyUpdate_a2c, sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), sci_Vector5_copy$default$10($this), sci_Vector5_copy$default$11($this), sci_Vector5_copy$default$12($this), sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
            }
            $io = $index - sci_Vector5_len1234($this) | 0;
            $i5 = $io >>> 20;
            $i4 = $io >>> 15 & 31;
            $i3 = $io >>> 10 & 31;
            $i2 = $io >>> 5 & 31;
            $i1 = $io & 31;
            if ($i5 < (sci_Vector5_data5($this)).data.length) {
                $copyUpdate_a5c = (sci_Vector5_data5($this)).$clone();
                $copyUpdate_a1c = $copyUpdate_a5c.data;
                $copyUpdate_copyUpdate_a4c = $copyUpdate_a1c[$i5].$clone();
                $copy_prefix2 = $copyUpdate_copyUpdate_a4c.data;
                $copyUpdate_copyUpdate_copyUpdate_a3c = $copy_prefix2[$i4].$clone();
                $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a3c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix3[$i3].$clone();
                $copy_prefix4 = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix4[$i2].$clone();
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copy_prefix4[$i2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                $copy_prefix3[$i3] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c;
                $copy_prefix2[$i4] = $copyUpdate_copyUpdate_copyUpdate_a3c;
                $copyUpdate_a1c[$i5] = $copyUpdate_copyUpdate_a4c;
                return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), $copyUpdate_a5c, sci_Vector5_copy$default$10($this), sci_Vector5_copy$default$11($this), sci_Vector5_copy$default$12($this), sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
            }
            if ($i4 < (sci_Vector5_suffix4($this)).data.length) {
                $copyUpdate_a4c = (sci_Vector5_suffix4($this)).$clone();
                $copyUpdate_a1c = $copyUpdate_a4c.data;
                $copyUpdate_copyUpdate_a3c = $copyUpdate_a1c[$i4].$clone();
                $copy_prefix2 = $copyUpdate_copyUpdate_a3c.data;
                $copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix2[$i3].$clone();
                $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix3[$i2].$clone();
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copy_prefix3[$i2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                $copy_prefix2[$i3] = $copyUpdate_copyUpdate_copyUpdate_a2c;
                $copyUpdate_a1c[$i4] = $copyUpdate_copyUpdate_a3c;
                return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), $copyUpdate_a4c, sci_Vector5_copy$default$11($this), sci_Vector5_copy$default$12($this), sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
            }
            if ($i3 < (sci_Vector5_suffix3($this)).data.length) {
                $copyUpdate_a3c = (sci_Vector5_suffix3($this)).$clone();
                $copyUpdate_a1c = $copyUpdate_a3c.data;
                $copyUpdate_copyUpdate_a2c = $copyUpdate_a1c[$i3].$clone();
                $copy_prefix2 = $copyUpdate_copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix2[$i2].$clone();
                $copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copy_prefix2[$i2] = $copyUpdate_copyUpdate_copyUpdate_a1c;
                $copyUpdate_a1c[$i3] = $copyUpdate_copyUpdate_a2c;
                return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), sci_Vector5_copy$default$10($this), $copyUpdate_a3c, sci_Vector5_copy$default$12($this), sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
            }
            if ($i2 >= (sci_Vector5_suffix2($this)).data.length) {
                $copyUpdate_a1c = (sci_BigVector_suffix1($this)).$clone();
                $copyUpdate_a1c.data[$i1] = $elem;
                return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), sci_Vector5_copy$default$10($this), sci_Vector5_copy$default$11($this), sci_Vector5_copy$default$12($this), $copyUpdate_a1c, sci_Vector5_copy$default$14($this));
            }
            $copyUpdate_a2c = (sci_Vector5_suffix2($this)).$clone();
            $copyUpdate_a1c = $copyUpdate_a2c.data;
            $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$i2].$clone();
            $copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
            $copyUpdate_a1c[$i2] = $copyUpdate_copyUpdate_a1c;
            return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), sci_Vector5_copy$default$9($this), sci_Vector5_copy$default$10($this), sci_Vector5_copy$default$11($this), $copyUpdate_a2c, sci_Vector5_copy$default$13($this), sci_Vector5_copy$default$14($this));
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector5_appended($this, $elem) {
        var $x$59, $x$1, $x$2, $wrap1_a, $x$15, $x$17, $x$58, var$9, $x$29, $x$30, $x$32, $wrap5_x, $x$43, $x$44, $x$45, $x$47, var$18, $x$60, $x$66, $x$63, $x$68, $x$65, $x$70, $x$67, $x$69, $x$51, $wrap5_a, $x$57, $x$62;
        $x$59 = $this.$suffix1;
        if ($x$59.data.length < 32) {
            $x$1 = sci_VectorStatics$_copyAppend1(sci_VectorStatics$_MODULE$, $x$59, $elem);
            $x$2 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($this.$prefix10, $this.$len15, $this.$prefix22, $this.$len122, $this.$prefix31, $this.$len1231, $this.$prefix40, $this.$len1234, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $x$1, $x$2);
        }
        $wrap1_a = $this.$suffix22;
        if ($wrap1_a.data.length < 31) {
            $x$15 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, $wrap1_a, $x$59);
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$17 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($this.$prefix10, $this.$len15, $this.$prefix22, $this.$len122, $this.$prefix31, $this.$len1231, $this.$prefix40, $this.$len1234, $this.$data50, $this.$suffix40, $this.$suffix31, $x$15, $wrap1_a, $x$17);
        }
        $x$58 = $this.$suffix31;
        if ($x$58.data.length < 31) {
            var$9 = sci_VectorStatics$_MODULE$;
            $x$29 = sci_VectorStatics$_copyAppend(var$9, $x$58, sci_VectorStatics$_copyAppend(var$9, $wrap1_a, $x$59));
            $x$30 = sci_VectorStatics$_empty2;
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$32 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($this.$prefix10, $this.$len15, $this.$prefix22, $this.$len122, $this.$prefix31, $this.$len1231, $this.$prefix40, $this.$len1234, $this.$data50, $this.$suffix40, $x$29, $x$30, $wrap1_a, $x$32);
        }
        $wrap5_x = $this.$suffix40;
        if ($wrap5_x.data.length < 31) {
            var$9 = sci_VectorStatics$_MODULE$;
            $x$43 = sci_VectorStatics$_copyAppend(var$9, $wrap5_x, sci_VectorStatics$_copyAppend(var$9, $x$58, sci_VectorStatics$_copyAppend(var$9, $wrap1_a, $x$59)));
            $x$44 = sci_VectorStatics$_empty3;
            $x$45 = sci_VectorStatics$_empty2;
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$47 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($this.$prefix10, $this.$len15, $this.$prefix22, $this.$len122, $this.$prefix31, $this.$len1231, $this.$prefix40, $this.$len1234, $this.$data50, $x$43, $x$44, $x$45, $wrap1_a, $x$47);
        }
        if ($this.$data50.data.length >= 30) {
            var$18 = new sci_Vector6;
            $x$60 = $this.$prefix10;
            $x$66 = $this.$len15;
            $x$63 = sci_Vector5_prefix2($this);
            $x$68 = sci_Vector5_len12($this);
            $x$65 = sci_Vector5_prefix3($this);
            $x$70 = sci_Vector5_len123($this);
            $x$67 = sci_Vector5_prefix4($this);
            $x$47 = sci_Vector5_len1234($this);
            $x$69 = sci_Vector5_data5($this);
            $x$51 = 31457280 + sci_Vector5_len1234($this) | 0;
            $x$43 = sci_VectorStatics$_empty60(sci_VectorStatics$_MODULE$);
            $wrap5_x = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector5_suffix4($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector5_suffix3($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector5_suffix2($this), sci_BigVector_suffix1($this))));
            $wrap5_a = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object)))), 1);
            $wrap5_a.data[0] = $wrap5_x;
            $x$57 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
            $wrap5_x = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
            $x$58 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            sci_Vector6__init_0(var$18, $x$60, $x$66, $x$63, $x$68, $x$65, $x$70, $x$67, $x$47, $x$69, $x$51, $x$43, $wrap5_a, $x$57, $wrap5_x, $x$58, $wrap1_a, sci_BigVector_length0($this) + 1 | 0);
            return var$18;
        }
        $x$57 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector5_data5($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector5_suffix4($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector5_suffix3($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector5_suffix2($this), sci_BigVector_suffix1($this)))));
        $x$58 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
        $x$59 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
        $x$60 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $x$62 = sci_BigVector_length0($this) + 1 | 0;
        return sci_Vector5__init_(sci_Vector5_copy$default$1($this), sci_Vector5_copy$default$2($this), sci_Vector5_copy$default$3($this), sci_Vector5_copy$default$4($this), sci_Vector5_copy$default$5($this), sci_Vector5_copy$default$6($this), sci_Vector5_copy$default$7($this), sci_Vector5_copy$default$8($this), $x$57, $x$58, $x$59, $x$60, $wrap1_a, $x$62);
    }
    function sci_Vector5_prepended($this, $elem) {
        var $x$1, $x$2, $x$3, $x$4, $x$5, $x$6, $wrap1_a, $x$17, $x$18, $x$19, $x$20, $x$21, $x$31, $x$33, $x$34, $x$35, $x$36, $x$45, $x$47, $x$49, $x$50, $x$51, var$24, $x$69, $x$59, $x$70, $wrap5_x, $wrap5_a, $x$61, $x$63, $x$65, $x$66;
        if ($this.$len15 < 32) {
            $x$1 = sci_VectorStatics$_copyPrepend1(sci_VectorStatics$_MODULE$, $elem, $this.$prefix10);
            $x$2 = $this.$len15 + 1 | 0;
            $x$3 = $this.$len122 + 1 | 0;
            $x$4 = $this.$len1231 + 1 | 0;
            $x$5 = $this.$len1234 + 1 | 0;
            $x$6 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($x$1, $x$2, $this.$prefix22, $x$3, $this.$prefix31, $x$4, $this.$prefix40, $x$5, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $this.$suffix1, $x$6);
        }
        if ($this.$len122 < 1024) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$17 = sci_VectorStatics$_copyPrepend(sci_VectorStatics$_MODULE$, $this.$prefix10, $this.$prefix22);
            $x$18 = $this.$len122 + 1 | 0;
            $x$19 = $this.$len1231 + 1 | 0;
            $x$20 = $this.$len1234 + 1 | 0;
            $x$21 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($wrap1_a, 1, $x$17, $x$18, $this.$prefix31, $x$19, $this.$prefix40, $x$20, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $this.$suffix1, $x$21);
        }
        if ($this.$len1231 < 32768) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$31 = sci_VectorStatics$_empty2;
            $elem = sci_VectorStatics$_MODULE$;
            $x$33 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, $this.$prefix10, $this.$prefix22), $this.$prefix31);
            $x$34 = $this.$len1231 + 1 | 0;
            $x$35 = $this.$len1234 + 1 | 0;
            $x$36 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($wrap1_a, 1, $x$31, 1, $x$33, $x$34, $this.$prefix40, $x$35, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $this.$suffix1, $x$36);
        }
        if ($this.$len1234 < 1048576) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$45 = sci_VectorStatics$_empty2;
            $x$47 = sci_VectorStatics$_empty3;
            $elem = sci_VectorStatics$_MODULE$;
            $x$49 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, $this.$prefix10, $this.$prefix22), $this.$prefix31), $this.$prefix40);
            $x$50 = $this.$len1234 + 1 | 0;
            $x$51 = $this.$length00 + 1 | 0;
            return sci_Vector5__init_($wrap1_a, 1, $x$45, 1, $x$47, 1, $x$49, $x$50, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $this.$suffix1, $x$51);
        }
        if ($this.$data50.data.length >= 30) {
            var$24 = new sci_Vector6;
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$69 = sci_VectorStatics$_empty2;
            $x$59 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
            $x$70 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
            $elem = sci_VectorStatics$_MODULE$;
            $wrap5_x = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_Vector_prefix1($this), sci_Vector5_prefix2($this)), sci_Vector5_prefix3($this)), sci_Vector5_prefix4($this));
            $wrap5_a = $rt_createArray($rt_arraycls($rt_arraycls($rt_arraycls($rt_arraycls(jl_Object)))), 1);
            $wrap5_a.data[0] = $wrap5_x;
            sci_Vector6__init_0(var$24, $wrap1_a, 1, $x$69, 1, $x$59, 1, $x$70, 1, $wrap5_a, sci_Vector5_len1234($this) + 1 | 0, sci_VectorStatics$_empty60(sci_VectorStatics$_MODULE$), sci_Vector5_data5($this), sci_Vector5_suffix4($this), sci_Vector5_suffix3($this), sci_Vector5_suffix2($this), sci_BigVector_suffix1($this), sci_BigVector_length0($this) + 1 | 0);
            return var$24;
        }
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $x$59 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
        $x$61 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
        $x$63 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
        $elem = sci_VectorStatics$_MODULE$;
        $x$65 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_Vector_prefix1($this), sci_Vector5_prefix2($this)), sci_Vector5_prefix3($this)), sci_Vector5_prefix4($this)), sci_Vector5_data5($this));
        $x$66 = sci_BigVector_length0($this) + 1 | 0;
        return sci_Vector5__init_($wrap1_a, 1, $x$59, 1, $x$61, 1, $x$63, 1, $x$65, sci_Vector5_suffix4($this), sci_Vector5_suffix3($this), sci_Vector5_suffix2($this), sci_BigVector_suffix1($this), $x$66);
    }
    function sci_Vector5_map($this, $f) {
        var $x$1, $mapElems1_i, $mapElems_a, $mapElems_n, $mapElems1_v1, $mapElems1_v2, $x$1_0, $mapElems1_mapElems1Rest_i, $mapElems_this, $mapElems_i, $mapElems_v2, $mapElems_v1, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7, $x$8, $x$9, $mapElems1_i_0, $x$9_0;
        $x$1 = sci_Vector_prefix1($this);
        $mapElems1_i = 0;
        a: {
            while (true) {
                $mapElems_a = $x$1.data;
                $mapElems_n = $mapElems_a.length;
                if ($mapElems1_i >= $mapElems_n)
                    break;
                $mapElems1_v1 = $mapElems_a[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$1_0 = $rt_createArray(jl_Object, $mapElems_n);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$1, 0, $x$1_0, 0, $mapElems1_i);
                    $x$1 = $x$1_0.data;
                    $x$1[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElems_n) {
                        $x$1[$mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_a[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$1 = $x$1_0;
                    break a;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector5_prefix2($this);
        $mapElems_i = 0;
        b: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 2, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break b;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$2 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector5_prefix3($this);
        $mapElems_i = 0;
        c: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 2, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 3, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break c;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$3 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector5_prefix4($this);
        $mapElems_i = 0;
        d: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 3, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 4, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break d;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$4 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector5_data5($this);
        $mapElems_i = 0;
        e: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 4, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 5, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break e;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$5 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector5_suffix4($this);
        $mapElems_i = 0;
        f: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 3, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 4, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break f;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$6 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector5_suffix3($this);
        $mapElems_i = 0;
        g: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 2, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 3, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break g;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$7 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector5_suffix2($this);
        $mapElems_i = 0;
        h: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 2, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break h;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$8 = $mapElems_a;
        $x$9 = sci_BigVector_suffix1($this);
        $mapElems1_i_0 = 0;
        i: {
            while (true) {
                $mapElems_a = $x$9.data;
                $mapElems1_i = $mapElems_a.length;
                if ($mapElems1_i_0 >= $mapElems1_i)
                    break;
                $mapElems1_v1 = $mapElems_a[$mapElems1_i_0];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$9_0 = $rt_createArray(jl_Object, $mapElems1_i);
                    if ($mapElems1_i_0 > 0)
                        jl_System_arraycopy($x$9, 0, $x$9_0, 0, $mapElems1_i_0);
                    $mapElems_v2 = $x$9_0.data;
                    $mapElems_v2[$mapElems1_i_0] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i_0 + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElems1_i) {
                        $mapElems_v2[$mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_a[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$9 = $x$9_0;
                    break i;
                }
                $mapElems1_i_0 = $mapElems1_i_0 + 1 | 0;
            }
        }
        return sci_Vector5__init_($x$1, sci_Vector5_copy$default$2($this), $x$2, sci_Vector5_copy$default$4($this), $x$3, sci_Vector5_copy$default$6($this), $x$4, sci_Vector5_copy$default$8($this), $x$5, $x$6, $x$7, $x$8, $x$9, sci_Vector5_copy$default$14($this));
    }
    function sci_Vector5_slice0($this, $lo, $hi) {
        var $b;
        $b = sci_VectorSliceBuilder__init_($lo, $hi);
        sci_VectorSliceBuilder_consider($b, 1, $this.$prefix10);
        sci_VectorSliceBuilder_consider($b, 2, $this.$prefix22);
        sci_VectorSliceBuilder_consider($b, 3, $this.$prefix31);
        sci_VectorSliceBuilder_consider($b, 4, $this.$prefix40);
        sci_VectorSliceBuilder_consider($b, 5, $this.$data50);
        sci_VectorSliceBuilder_consider($b, 4, $this.$suffix40);
        sci_VectorSliceBuilder_consider($b, 3, $this.$suffix31);
        sci_VectorSliceBuilder_consider($b, 2, $this.$suffix22);
        sci_VectorSliceBuilder_consider($b, 1, $this.$suffix1);
        return sci_VectorSliceBuilder_result($b);
    }
    function sci_Vector5_init($this) {
        var $x$13, $x$10, $x$1, $x$2;
        $x$13 = $this.$suffix1;
        $x$10 = $x$13.data.length;
        if ($x$10 <= 1)
            return sci_Vector5_slice0($this, 0, $this.$length00 - 1 | 0);
        $x$1 = ju_Arrays_copyOfRange($x$13, 0, $x$10 - 1 | 0);
        $x$2 = $this.$length00 - 1 | 0;
        return sci_Vector5__init_($this.$prefix10, $this.$len15, $this.$prefix22, $this.$len122, $this.$prefix31, $this.$len1231, $this.$prefix40, $this.$len1234, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $x$1, $x$2);
    }
    function sci_Vector5_vectorSliceCount($this) {
        return 9;
    }
    function sci_Vector5_vectorSlice($this, $idx) {
        switch ($idx) {
            case 0:
                break;
            case 1:
                return $this.$prefix22;
            case 2:
                return $this.$prefix31;
            case 3:
                return $this.$prefix40;
            case 4:
                return $this.$data50;
            case 5:
                return $this.$suffix40;
            case 6:
                return $this.$suffix31;
            case 7:
                return $this.$suffix22;
            case 8:
                return $this.$suffix1;
            default:
                $rt_throw(s_MatchError__init_(jl_Integer_valueOf($idx)));
        }
        return $this.$prefix10;
    }
    function sci_Vector5_appendedAll0($this, $suffix, $k) {
        var $suffix1b, $x$7, $x$2;
        $suffix1b = sci_VectorStatics$_append1IfSpace(sci_VectorStatics$_MODULE$, $this.$suffix1, $suffix);
        if ($suffix1b === null)
            return sci_Vector_appendedAll0($this, $suffix, $k);
        $x$7 = $suffix1b.data;
        $x$2 = ($this.$length00 - $this.$suffix1.data.length | 0) + $x$7.length | 0;
        return sci_Vector5__init_($this.$prefix10, $this.$len15, $this.$prefix22, $this.$len122, $this.$prefix31, $this.$len1231, $this.$prefix40, $this.$len1234, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $suffix1b, $x$2);
    }
    function sci_Vector5_init0($this) {
        return sci_Vector5_init($this);
    }
    function sci_Vector5_tail($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        if ($this.$len15 <= 1)
            var$1 = sci_Vector5_slice0($this, 1, $this.$length00);
        else {
            var$2 = $this.$prefix10;
            var$3 = ju_Arrays_copyOfRange(var$2, 1, var$2.data.length);
            var$4 = $this.$len15 - 1 | 0;
            var$5 = $this.$len122 - 1 | 0;
            var$6 = $this.$len1231 - 1 | 0;
            var$7 = $this.$len1234 - 1 | 0;
            var$8 = $this.$length00 - 1 | 0;
            var$1 = sci_Vector5__init_(var$3, var$4, $this.$prefix22, var$5, $this.$prefix31, var$6, $this.$prefix40, var$7, $this.$data50, $this.$suffix40, $this.$suffix31, $this.$suffix22, $this.$suffix1, var$8);
        }
        return var$1;
    }
    function sci_Vector5_map0($this, $f) {
        return sci_Vector5_map($this, $f);
    }
    function sci_Vector5_prepended0($this, $elem) {
        return sci_Vector5_prepended($this, $elem);
    }
    function sci_Vector5_appended0($this, $elem) {
        return sci_Vector5_appended($this, $elem);
    }
    function sci_Vector5_updated0($this, $index, $elem) {
        return sci_Vector5_updated($this, $index, $elem);
    }
    function sci_Vector5_apply0($this, $v1) {
        return sci_Vector5_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_Vector5__init_0($this, $_prefix1, $len1, $prefix2, $len12, $prefix3, $len123, $prefix4, $len1234, $data5, $suffix4, $suffix3, $suffix2, $_suffix1, $_length0) {
        $this.$len15 = $len1;
        $this.$prefix22 = $prefix2;
        $this.$len122 = $len12;
        $this.$prefix31 = $prefix3;
        $this.$len1231 = $len123;
        $this.$prefix40 = $prefix4;
        $this.$len1234 = $len1234;
        $this.$data50 = $data5;
        $this.$suffix40 = $suffix4;
        $this.$suffix31 = $suffix3;
        $this.$suffix22 = $suffix2;
        sci_BigVector__init_($this, $_prefix1, $_suffix1, $_length0);
    }
    function sci_Vector6() {
        var a = this; sci_BigVector.call(a);
        a.$len16 = 0;
        a.$prefix23 = null;
        a.$len124 = 0;
        a.$prefix32 = null;
        a.$len1232 = 0;
        a.$prefix41 = null;
        a.$len12341 = 0;
        a.$prefix50 = null;
        a.$len12345 = 0;
        a.$data60 = null;
        a.$suffix50 = null;
        a.$suffix41 = null;
        a.$suffix32 = null;
        a.$suffix23 = null;
    }
    function sci_Vector6__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10, var_11, var_12, var_13, var_14, var_15, var_16) {
        var var_17 = new sci_Vector6();
        sci_Vector6__init_0(var_17, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10, var_11, var_12, var_13, var_14, var_15, var_16);
        return var_17;
    }
    function sci_Vector6_len1($this) {
        return $this.$len16;
    }
    function sci_Vector6_prefix2($this) {
        return $this.$prefix23;
    }
    function sci_Vector6_len12($this) {
        return $this.$len124;
    }
    function sci_Vector6_prefix3($this) {
        return $this.$prefix32;
    }
    function sci_Vector6_len123($this) {
        return $this.$len1232;
    }
    function sci_Vector6_prefix4($this) {
        return $this.$prefix41;
    }
    function sci_Vector6_len1234($this) {
        return $this.$len12341;
    }
    function sci_Vector6_prefix5($this) {
        return $this.$prefix50;
    }
    function sci_Vector6_len12345($this) {
        return $this.$len12345;
    }
    function sci_Vector6_data6($this) {
        return $this.$data60;
    }
    function sci_Vector6_suffix5($this) {
        return $this.$suffix50;
    }
    function sci_Vector6_suffix4($this) {
        return $this.$suffix41;
    }
    function sci_Vector6_suffix3($this) {
        return $this.$suffix32;
    }
    function sci_Vector6_suffix2($this) {
        return $this.$suffix23;
    }
    function sci_Vector6_copy$default$1($this) {
        return $this.$prefix10;
    }
    function sci_Vector6_copy$default$2($this) {
        return $this.$len16;
    }
    function sci_Vector6_copy$default$3($this) {
        return $this.$prefix23;
    }
    function sci_Vector6_copy$default$4($this) {
        return $this.$len124;
    }
    function sci_Vector6_copy$default$5($this) {
        return $this.$prefix32;
    }
    function sci_Vector6_copy$default$6($this) {
        return $this.$len1232;
    }
    function sci_Vector6_copy$default$7($this) {
        return $this.$prefix41;
    }
    function sci_Vector6_copy$default$8($this) {
        return $this.$len12341;
    }
    function sci_Vector6_copy$default$9($this) {
        return $this.$prefix50;
    }
    function sci_Vector6_copy$default$10($this) {
        return $this.$len12345;
    }
    function sci_Vector6_copy$default$11($this) {
        return $this.$data60;
    }
    function sci_Vector6_copy$default$12($this) {
        return $this.$suffix50;
    }
    function sci_Vector6_copy$default$13($this) {
        return $this.$suffix41;
    }
    function sci_Vector6_copy$default$14($this) {
        return $this.$suffix32;
    }
    function sci_Vector6_copy$default$15($this) {
        return $this.$suffix23;
    }
    function sci_Vector6_copy$default$16($this) {
        return $this.$suffix1;
    }
    function sci_Vector6_copy$default$17($this) {
        return $this.$length00;
    }
    function sci_Vector6_apply($this, $index) {
        var $io, $i6, $i5, $i4, $i3, $i2, $i1, var$9;
        if ($index >= 0 && $index < $this.$length00) {
            $io = $index - $this.$len12345 | 0;
            if ($io >= 0) {
                $i6 = $io >>> 25;
                $i5 = $io >>> 20 & 31;
                $i4 = $io >>> 15 & 31;
                $i3 = $io >>> 10 & 31;
                $i2 = $io >>> 5 & 31;
                $i1 = $io & 31;
                var$9 = $this.$data60.data;
                if ($i6 < var$9.length)
                    return var$9[$i6].data[$i5].data[$i4].data[$i3].data[$i2].data[$i1];
                var$9 = $this.$suffix50.data;
                if ($i5 < var$9.length)
                    return var$9[$i5].data[$i4].data[$i3].data[$i2].data[$i1];
                var$9 = $this.$suffix41.data;
                if ($i4 < var$9.length)
                    return var$9[$i4].data[$i3].data[$i2].data[$i1];
                var$9 = $this.$suffix32.data;
                if ($i3 < var$9.length)
                    return var$9[$i3].data[$i2].data[$i1];
                var$9 = $this.$suffix23.data;
                if ($i2 >= var$9.length)
                    return $this.$suffix1.data[$i1];
                return var$9[$i2].data[$i1];
            }
            $i6 = $this.$len12341;
            if ($index >= $i6) {
                $io = $index - $i6 | 0;
                return $this.$prefix50.data[$io >>> 20].data[$io >>> 15 & 31].data[$io >>> 10 & 31].data[$io >>> 5 & 31].data[$io & 31];
            }
            $i6 = $this.$len1232;
            if ($index >= $i6) {
                $io = $index - $i6 | 0;
                return $this.$prefix41.data[$io >>> 15].data[$io >>> 10 & 31].data[$io >>> 5 & 31].data[$io & 31];
            }
            $i6 = $this.$len124;
            if ($index >= $i6) {
                $io = $index - $i6 | 0;
                return $this.$prefix32.data[$io >>> 10].data[$io >>> 5 & 31].data[$io & 31];
            }
            $i6 = $this.$len16;
            if ($index < $i6)
                return $this.$prefix10.data[$index];
            $io = $index - $i6 | 0;
            return $this.$prefix23.data[$io >>> 5].data[$io & 31];
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector6_updated($this, $index, $elem) {
        var $io, $copyUpdate_a5, $copyUpdate_idx5, $copyUpdate_idx4, $copyUpdate_idx3, $copyUpdate_idx2, $copyUpdate_idx1, $copyUpdate_a5c, $copyUpdate_a1c, $copyUpdate_copyUpdate_a4c, $copy_prefix2, $copyUpdate_copyUpdate_copyUpdate_a3c, $copy_prefix3, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c, $copy_prefix4, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c, $copyUpdate_a4, $copyUpdate_a4c, $copyUpdate_copyUpdate_a3c, $copyUpdate_copyUpdate_copyUpdate_a2c, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c,
        $copyUpdate_a3, $copyUpdate_a3c, $copyUpdate_copyUpdate_a2c, $copyUpdate_copyUpdate_copyUpdate_a1c, $copyUpdate_a2, $copyUpdate_a2c, $copyUpdate_copyUpdate_a1c, $i6, $i5, $i4, $i3, $i2, $i1, $copyUpdate_a6c, $copyUpdate_copyUpdate_a5c, $copyUpdate_copyUpdate_copyUpdate_a4c, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a3c, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c, $copy_prefix5, $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
        if ($index >= 0 && $index < sci_BigVector_length0($this)) {
            if ($index < sci_Vector6_len12345($this)) {
                if ($index >= sci_Vector6_len1234($this)) {
                    $io = $index - sci_Vector6_len1234($this) | 0;
                    $copyUpdate_a5 = sci_Vector6_prefix5($this);
                    $copyUpdate_idx5 = $io >>> 20;
                    $copyUpdate_idx4 = $io >>> 15 & 31;
                    $copyUpdate_idx3 = $io >>> 10 & 31;
                    $copyUpdate_idx2 = $io >>> 5 & 31;
                    $copyUpdate_idx1 = $io & 31;
                    $copyUpdate_a5c = $copyUpdate_a5.$clone();
                    $copyUpdate_a1c = $copyUpdate_a5c.data;
                    $copyUpdate_copyUpdate_a4c = $copyUpdate_a1c[$copyUpdate_idx5].$clone();
                    $copy_prefix2 = $copyUpdate_copyUpdate_a4c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a3c = $copy_prefix2[$copyUpdate_idx4].$clone();
                    $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix3[$copyUpdate_idx3].$clone();
                    $copy_prefix4 = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix4[$copyUpdate_idx2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                    $copy_prefix4[$copyUpdate_idx2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copy_prefix3[$copyUpdate_idx3] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c;
                    $copy_prefix2[$copyUpdate_idx4] = $copyUpdate_copyUpdate_copyUpdate_a3c;
                    $copyUpdate_a1c[$copyUpdate_idx5] = $copyUpdate_copyUpdate_a4c;
                    return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), $copyUpdate_a5c, sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                    sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
                }
                if ($index >= sci_Vector6_len123($this)) {
                    $io = $index - sci_Vector6_len123($this) | 0;
                    $copyUpdate_a4 = sci_Vector6_prefix4($this);
                    $copyUpdate_idx4 = $io >>> 15;
                    $copyUpdate_idx3 = $io >>> 10 & 31;
                    $copyUpdate_idx2 = $io >>> 5 & 31;
                    $copyUpdate_idx1 = $io & 31;
                    $copyUpdate_a4c = $copyUpdate_a4.$clone();
                    $copyUpdate_a1c = $copyUpdate_a4c.data;
                    $copyUpdate_copyUpdate_a3c = $copyUpdate_a1c[$copyUpdate_idx4].$clone();
                    $copy_prefix2 = $copyUpdate_copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix2[$copyUpdate_idx3].$clone();
                    $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix3[$copyUpdate_idx2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                    $copy_prefix3[$copyUpdate_idx2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copy_prefix2[$copyUpdate_idx3] = $copyUpdate_copyUpdate_copyUpdate_a2c;
                    $copyUpdate_a1c[$copyUpdate_idx4] = $copyUpdate_copyUpdate_a3c;
                    return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), $copyUpdate_a4c, sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                    sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
                }
                if ($index >= sci_Vector6_len12($this)) {
                    $io = $index - sci_Vector6_len12($this) | 0;
                    $copyUpdate_a3 = sci_Vector6_prefix3($this);
                    $copyUpdate_idx3 = $io >>> 10;
                    $copyUpdate_idx2 = $io >>> 5 & 31;
                    $copyUpdate_idx1 = $io & 31;
                    $copyUpdate_a3c = $copyUpdate_a3.$clone();
                    $copyUpdate_a1c = $copyUpdate_a3c.data;
                    $copyUpdate_copyUpdate_a2c = $copyUpdate_a1c[$copyUpdate_idx3].$clone();
                    $copy_prefix2 = $copyUpdate_copyUpdate_a2c.data;
                    $copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix2[$copyUpdate_idx2].$clone();
                    $copyUpdate_copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                    $copy_prefix2[$copyUpdate_idx2] = $copyUpdate_copyUpdate_copyUpdate_a1c;
                    $copyUpdate_a1c[$copyUpdate_idx3] = $copyUpdate_copyUpdate_a2c;
                    return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), $copyUpdate_a3c, sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                    sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
                }
                if ($index < sci_Vector6_len1($this)) {
                    $copyUpdate_a1c = (sci_Vector_prefix1($this)).$clone();
                    $copyUpdate_a1c.data[$index] = $elem;
                    return sci_Vector6__init_($copyUpdate_a1c, sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                    sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
                }
                $io = $index - sci_Vector6_len1($this) | 0;
                $copyUpdate_a2 = sci_Vector6_prefix2($this);
                $copyUpdate_idx2 = $io >>> 5;
                $copyUpdate_idx1 = $io & 31;
                $copyUpdate_a2c = $copyUpdate_a2.$clone();
                $copyUpdate_a1c = $copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$copyUpdate_idx2].$clone();
                $copyUpdate_copyUpdate_a1c.data[$copyUpdate_idx1] = $elem;
                $copyUpdate_a1c[$copyUpdate_idx2] = $copyUpdate_copyUpdate_a1c;
                return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), $copyUpdate_a2c, sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
            }
            $io = $index - sci_Vector6_len12345($this) | 0;
            $i6 = $io >>> 25;
            $i5 = $io >>> 20 & 31;
            $i4 = $io >>> 15 & 31;
            $i3 = $io >>> 10 & 31;
            $i2 = $io >>> 5 & 31;
            $i1 = $io & 31;
            if ($i6 < (sci_Vector6_data6($this)).data.length) {
                $copyUpdate_a6c = (sci_Vector6_data6($this)).$clone();
                $copyUpdate_a1c = $copyUpdate_a6c.data;
                $copyUpdate_copyUpdate_a5c = $copyUpdate_a1c[$i6].$clone();
                $copy_prefix2 = $copyUpdate_copyUpdate_a5c.data;
                $copyUpdate_copyUpdate_copyUpdate_a4c = $copy_prefix2[$i5].$clone();
                $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a4c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a3c = $copy_prefix3[$i4].$clone();
                $copy_prefix4 = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a3c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix4[$i3].$clone();
                $copy_prefix5 = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix5[$i2].$clone();
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copy_prefix5[$i2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                $copy_prefix4[$i3] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c;
                $copy_prefix3[$i4] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a3c;
                $copy_prefix2[$i5] = $copyUpdate_copyUpdate_copyUpdate_a4c;
                $copyUpdate_a1c[$i6] = $copyUpdate_copyUpdate_a5c;
                return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), $copyUpdate_a6c, sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
            }
            if ($i5 < (sci_Vector6_suffix5($this)).data.length) {
                $copyUpdate_a5c = (sci_Vector6_suffix5($this)).$clone();
                $copyUpdate_a1c = $copyUpdate_a5c.data;
                $copyUpdate_copyUpdate_a4c = $copyUpdate_a1c[$i5].$clone();
                $copy_prefix2 = $copyUpdate_copyUpdate_a4c.data;
                $copyUpdate_copyUpdate_copyUpdate_a3c = $copy_prefix2[$i4].$clone();
                $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a3c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix3[$i3].$clone();
                $copy_prefix4 = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix4[$i2].$clone();
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copy_prefix4[$i2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                $copy_prefix3[$i3] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a2c;
                $copy_prefix2[$i4] = $copyUpdate_copyUpdate_copyUpdate_a3c;
                $copyUpdate_a1c[$i5] = $copyUpdate_copyUpdate_a4c;
                return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), $copyUpdate_a5c, sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
            }
            if ($i4 < (sci_Vector6_suffix4($this)).data.length) {
                $copyUpdate_a4c = (sci_Vector6_suffix4($this)).$clone();
                $copyUpdate_a1c = $copyUpdate_a4c.data;
                $copyUpdate_copyUpdate_a3c = $copyUpdate_a1c[$i4].$clone();
                $copy_prefix2 = $copyUpdate_copyUpdate_a3c.data;
                $copyUpdate_copyUpdate_copyUpdate_a2c = $copy_prefix2[$i3].$clone();
                $copy_prefix3 = $copyUpdate_copyUpdate_copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix3[$i2].$clone();
                $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copy_prefix3[$i2] = $copyUpdate_copyUpdate_copyUpdate_copyUpdate_a1c;
                $copy_prefix2[$i3] = $copyUpdate_copyUpdate_copyUpdate_a2c;
                $copyUpdate_a1c[$i4] = $copyUpdate_copyUpdate_a3c;
                return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), $copyUpdate_a4c, sci_Vector6_copy$default$14($this),
                sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
            }
            if ($i3 < (sci_Vector6_suffix3($this)).data.length) {
                $copyUpdate_a3c = (sci_Vector6_suffix3($this)).$clone();
                $copyUpdate_a1c = $copyUpdate_a3c.data;
                $copyUpdate_copyUpdate_a2c = $copyUpdate_a1c[$i3].$clone();
                $copy_prefix2 = $copyUpdate_copyUpdate_a2c.data;
                $copyUpdate_copyUpdate_copyUpdate_a1c = $copy_prefix2[$i2].$clone();
                $copyUpdate_copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
                $copy_prefix2[$i2] = $copyUpdate_copyUpdate_copyUpdate_a1c;
                $copyUpdate_a1c[$i3] = $copyUpdate_copyUpdate_a2c;
                return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), $copyUpdate_a3c,
                sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
            }
            if ($i2 >= (sci_Vector6_suffix2($this)).data.length) {
                $copyUpdate_a1c = (sci_BigVector_suffix1($this)).$clone();
                $copyUpdate_a1c.data[$i1] = $elem;
                return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
                sci_Vector6_copy$default$15($this), $copyUpdate_a1c, sci_Vector6_copy$default$17($this));
            }
            $copyUpdate_a2c = (sci_Vector6_suffix2($this)).$clone();
            $copyUpdate_a1c = $copyUpdate_a2c.data;
            $copyUpdate_copyUpdate_a1c = $copyUpdate_a1c[$i2].$clone();
            $copyUpdate_copyUpdate_a1c.data[$i1] = $elem;
            $copyUpdate_a1c[$i2] = $copyUpdate_copyUpdate_a1c;
            return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this),
            $copyUpdate_a2c, sci_Vector6_copy$default$16($this), sci_Vector6_copy$default$17($this));
        }
        $rt_throw(sci_Vector_ioob($this, $index));
    }
    function sci_Vector6_appended($this, $elem) {
        var $x$88, $x$1, $x$2, $x$87, $x$18, $wrap1_a, $x$20, $x$35, $x$36, $x$38, $x$52, $x$53, $x$54, $x$56, $x$69, $x$70, $x$71, $x$72, $x$74, $x$86, $x$89, $x$90, $x$92;
        $x$88 = $this.$suffix1;
        if ($x$88.data.length < 32) {
            $x$1 = sci_VectorStatics$_copyAppend1(sci_VectorStatics$_MODULE$, $x$88, $elem);
            $x$2 = $this.$length00 + 1 | 0;
            return sci_Vector6__init_($this.$prefix10, $this.$len16, $this.$prefix23, $this.$len124, $this.$prefix32, $this.$len1232, $this.$prefix41, $this.$len12341, $this.$prefix50, $this.$len12345, $this.$data60, $this.$suffix50, $this.$suffix41, $this.$suffix32, $this.$suffix23, $x$1, $x$2);
        }
        $x$87 = $this.$suffix23;
        if ($x$87.data.length < 31) {
            $x$18 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, $x$87, $x$88);
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$20 = $this.$length00 + 1 | 0;
            return sci_Vector6__init_($this.$prefix10, $this.$len16, $this.$prefix23, $this.$len124, $this.$prefix32, $this.$len1232, $this.$prefix41, $this.$len12341, $this.$prefix50, $this.$len12345, $this.$data60, sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this), $x$18, $wrap1_a, $x$20);
        }
        if ($this.$suffix32.data.length < 31) {
            $x$35 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix3($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix2($this), sci_BigVector_suffix1($this)));
            $x$36 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$38 = sci_BigVector_length0($this) + 1 | 0;
            return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), $x$35, $x$36, $wrap1_a,
            $x$38);
        }
        if ((sci_Vector6_suffix4($this)).data.length < 31) {
            $x$52 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix4($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix3($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix2($this), sci_BigVector_suffix1($this))));
            $x$53 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
            $x$54 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$56 = sci_BigVector_length0($this) + 1 | 0;
            return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), $x$52, $x$53, $x$54, $wrap1_a, $x$56);
        }
        if ((sci_Vector6_suffix5($this)).data.length < 31) {
            $x$69 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix5($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix4($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix3($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix2($this), sci_BigVector_suffix1($this)))));
            $x$70 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
            $x$71 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
            $x$72 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$74 = sci_BigVector_length0($this) + 1 | 0;
            return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), sci_Vector6_copy$default$11($this), $x$69, $x$70, $x$71, $x$72, $wrap1_a, $x$74);
        }
        if ((sci_Vector6_data6($this)).data.length >= 62)
            $rt_throw(jl_IllegalArgumentException__init_());
        $x$86 = sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_data6($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix5($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix4($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix3($this), sci_VectorStatics$_copyAppend(sci_VectorStatics$_MODULE$, sci_Vector6_suffix2($this), sci_BigVector_suffix1($this))))));
        $x$87 = sci_VectorStatics$_empty50(sci_VectorStatics$_MODULE$);
        $x$88 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
        $x$89 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
        $x$90 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $x$92 = sci_BigVector_length0($this) + 1 | 0;
        return sci_Vector6__init_(sci_Vector6_copy$default$1($this), sci_Vector6_copy$default$2($this), sci_Vector6_copy$default$3($this), sci_Vector6_copy$default$4($this), sci_Vector6_copy$default$5($this), sci_Vector6_copy$default$6($this), sci_Vector6_copy$default$7($this), sci_Vector6_copy$default$8($this), sci_Vector6_copy$default$9($this), sci_Vector6_copy$default$10($this), $x$86, $x$87, $x$88, $x$89, $x$90, $wrap1_a, $x$92);
    }
    function sci_Vector6_prepended($this, $elem) {
        var $x$1, $x$2, $x$3, $x$4, $x$5, $x$6, $x$7, $wrap1_a, $x$20, $x$21, $x$22, $x$23, $x$24, $x$25, $x$37, $x$39, $x$40, $x$41, $x$42, $x$43, $x$54, $x$56, $x$58, $x$59, $x$60, $x$61, $x$71, $x$73, $x$75, $x$77, $x$78, $x$79, $x$88, $x$90, $x$92, $x$94, $x$96, $x$97;
        if ($this.$len16 < 32) {
            $x$1 = sci_VectorStatics$_copyPrepend1(sci_VectorStatics$_MODULE$, $elem, $this.$prefix10);
            $x$2 = $this.$len16 + 1 | 0;
            $x$3 = $this.$len124 + 1 | 0;
            $x$4 = $this.$len1232 + 1 | 0;
            $x$5 = $this.$len12341 + 1 | 0;
            $x$6 = $this.$len12345 + 1 | 0;
            $x$7 = $this.$length00 + 1 | 0;
            return sci_Vector6__init_($x$1, $x$2, $this.$prefix23, $x$3, $this.$prefix32, $x$4, $this.$prefix41, $x$5, $this.$prefix50, $x$6, $this.$data60, $this.$suffix50, $this.$suffix41, $this.$suffix32, $this.$suffix23, $this.$suffix1, $x$7);
        }
        if ($this.$len124 < 1024) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$20 = sci_VectorStatics$_copyPrepend(sci_VectorStatics$_MODULE$, $this.$prefix10, $this.$prefix23);
            $x$21 = $this.$len124 + 1 | 0;
            $x$22 = $this.$len1232 + 1 | 0;
            $x$23 = $this.$len12341 + 1 | 0;
            $x$24 = $this.$len12345 + 1 | 0;
            $x$25 = $this.$length00 + 1 | 0;
            return sci_Vector6__init_($wrap1_a, 1, $x$20, $x$21, $this.$prefix32, $x$22, sci_Vector6_copy$default$7($this), $x$23, sci_Vector6_copy$default$9($this), $x$24, sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this), sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), $x$25);
        }
        if ($this.$len1232 < 32768) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$37 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
            $elem = sci_VectorStatics$_MODULE$;
            $x$39 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_Vector_prefix1($this), sci_Vector6_prefix2($this)), sci_Vector6_prefix3($this));
            $x$40 = sci_Vector6_len123($this) + 1 | 0;
            $x$41 = sci_Vector6_len1234($this) + 1 | 0;
            $x$42 = sci_Vector6_len12345($this) + 1 | 0;
            $x$43 = sci_BigVector_length0($this) + 1 | 0;
            return sci_Vector6__init_($wrap1_a, 1, $x$37, 1, $x$39, $x$40, sci_Vector6_copy$default$7($this), $x$41, sci_Vector6_copy$default$9($this), $x$42, sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this), sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), $x$43);
        }
        if (sci_Vector6_len1234($this) < 1048576) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$54 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
            $x$56 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
            $elem = sci_VectorStatics$_MODULE$;
            $x$58 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_Vector_prefix1($this), sci_Vector6_prefix2($this)), sci_Vector6_prefix3($this)), sci_Vector6_prefix4($this));
            $x$59 = sci_Vector6_len1234($this) + 1 | 0;
            $x$60 = sci_Vector6_len12345($this) + 1 | 0;
            $x$61 = sci_BigVector_length0($this) + 1 | 0;
            return sci_Vector6__init_($wrap1_a, 1, $x$54, 1, $x$56, 1, $x$58, $x$59, sci_Vector6_copy$default$9($this), $x$60, sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this), sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), $x$61);
        }
        if (sci_Vector6_len12345($this) < 33554432) {
            $wrap1_a = $rt_createArray(jl_Object, 1);
            $wrap1_a.data[0] = $elem;
            $x$71 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
            $x$73 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
            $x$75 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
            $elem = sci_VectorStatics$_MODULE$;
            $x$77 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_Vector_prefix1($this), sci_Vector6_prefix2($this)), sci_Vector6_prefix3($this)), sci_Vector6_prefix4($this)), sci_Vector6_prefix5($this));
            $x$78 = sci_Vector6_len12345($this) + 1 | 0;
            $x$79 = sci_BigVector_length0($this) + 1 | 0;
            return sci_Vector6__init_($wrap1_a, 1, $x$71, 1, $x$73, 1, $x$75, 1, $x$77, $x$78, sci_Vector6_copy$default$11($this), sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this), sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), $x$79);
        }
        if ((sci_Vector6_data6($this)).data.length >= 62)
            $rt_throw(jl_IllegalArgumentException__init_());
        $wrap1_a = $rt_createArray(jl_Object, 1);
        $wrap1_a.data[0] = $elem;
        $x$88 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
        $x$90 = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
        $x$92 = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
        $x$94 = sci_VectorStatics$_empty50(sci_VectorStatics$_MODULE$);
        $elem = sci_VectorStatics$_MODULE$;
        $x$96 = sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_VectorStatics$_copyPrepend($elem, sci_Vector_prefix1($this), sci_Vector6_prefix2($this)), sci_Vector6_prefix3($this)), sci_Vector6_prefix4($this)), sci_Vector6_prefix5($this)), sci_Vector6_data6($this));
        $x$97 = sci_BigVector_length0($this) + 1 | 0;
        return sci_Vector6__init_($wrap1_a, 1, $x$88, 1, $x$90, 1, $x$92, 1, $x$94, 1, $x$96, sci_Vector6_copy$default$12($this), sci_Vector6_copy$default$13($this), sci_Vector6_copy$default$14($this), sci_Vector6_copy$default$15($this), sci_Vector6_copy$default$16($this), $x$97);
    }
    function sci_Vector6_map($this, $f) {
        var $x$1, $mapElems1_i, $mapElems_a, $mapElems_i, $mapElems1_v1, $mapElems1_v2, $x$1_0, $mapElems1_mapElems1Rest_i, $mapElems_this, $mapElems_v2, $mapElems_v1, $x$2, $x$3, $mapElems_i_0, $x$4, $x$5, $x$6, $x$7, $x$8, $x$9, $x$10, $x$11, $x$12, $x$11_0;
        $x$1 = sci_Vector_prefix1($this);
        $mapElems1_i = 0;
        a: {
            while (true) {
                $mapElems_a = $x$1.data;
                $mapElems_i = $mapElems_a.length;
                if ($mapElems1_i >= $mapElems_i)
                    break;
                $mapElems1_v1 = $mapElems_a[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$1_0 = $rt_createArray(jl_Object, $mapElems_i);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$1, 0, $x$1_0, 0, $mapElems1_i);
                    $x$1 = $x$1_0.data;
                    $x$1[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $mapElems_i) {
                        $x$1[$mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_a[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$1 = $x$1_0;
                    break a;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_prefix2($this);
        $mapElems_i = 0;
        b: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 1, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 2, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break b;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$2 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_prefix3($this);
        $mapElems_i = 0;
        c: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 2, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 3, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break c;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$3 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_prefix4($this);
        $mapElems_i_0 = 0;
        d: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i_0 >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i_0];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 3, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 4, $mapElems_a, $f, $mapElems_i_0, $mapElems_v2);
                    break d;
                }
                $mapElems_i_0 = $mapElems_i_0 + 1 | 0;
            }
        }
        $x$4 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_prefix5($this);
        $mapElems_i = 0;
        e: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 4, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 5, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break e;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$5 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_data6($this);
        $mapElems_i = 0;
        f: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 5, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 6, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break f;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$6 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_suffix5($this);
        $mapElems_i = 0;
        g: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 4, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 5, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break g;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$7 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_suffix4($this);
        $mapElems_i = 0;
        h: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 3, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 4, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break h;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$8 = $mapElems_a;
        $mapElems_this = sci_VectorStatics$_MODULE$;
        $mapElems_a = sci_Vector6_suffix3($this);
        $mapElems_i = 0;
        i: {
            while (true) {
                $mapElems_v2 = $mapElems_a.data;
                if ($mapElems_i >= $mapElems_v2.length)
                    break;
                $mapElems_v1 = $mapElems_v2[$mapElems_i];
                $mapElems_v2 = sci_VectorStatics$_mapElems($mapElems_this, 2, $mapElems_v1, $f);
                if ($mapElems_v1 !== $mapElems_v2) {
                    $mapElems_a = sci_VectorStatics$_mapElemsRest($mapElems_this, 3, $mapElems_a, $f, $mapElems_i, $mapElems_v2);
                    break i;
                }
                $mapElems_i = $mapElems_i + 1 | 0;
            }
        }
        $x$9 = $mapElems_a;
        $x$10 = sci_VectorStatics$_mapElems(sci_VectorStatics$_MODULE$, 2, sci_Vector6_suffix2($this), $f);
        $x$11 = sci_BigVector_suffix1($this);
        $mapElems1_i = 0;
        j: {
            while (true) {
                $mapElems_v2 = $x$11.data;
                $x$12 = $mapElems_v2.length;
                if ($mapElems1_i >= $x$12)
                    break;
                $mapElems1_v1 = $mapElems_v2[$mapElems1_i];
                $mapElems1_v2 = $f.$apply($mapElems1_v1);
                if ($mapElems1_v1 !== $mapElems1_v2) {
                    $x$11_0 = $rt_createArray(jl_Object, $x$12);
                    if ($mapElems1_i > 0)
                        jl_System_arraycopy($x$11, 0, $x$11_0, 0, $mapElems1_i);
                    $mapElems_a = $x$11_0.data;
                    $mapElems_a[$mapElems1_i] = $mapElems1_v2;
                    $mapElems1_mapElems1Rest_i = $mapElems1_i + 1 | 0;
                    while ($mapElems1_mapElems1Rest_i < $x$12) {
                        $mapElems_a[$mapElems1_mapElems1Rest_i] = $f.$apply($mapElems_v2[$mapElems1_mapElems1Rest_i]);
                        $mapElems1_mapElems1Rest_i = $mapElems1_mapElems1Rest_i + 1 | 0;
                    }
                    $x$11 = $x$11_0;
                    break j;
                }
                $mapElems1_i = $mapElems1_i + 1 | 0;
            }
        }
        return sci_Vector6__init_($x$1, sci_Vector6_copy$default$2($this), $x$2, sci_Vector6_copy$default$4($this), $x$3, sci_Vector6_copy$default$6($this), $x$4, sci_Vector6_copy$default$8($this), $x$5, sci_Vector6_copy$default$10($this), $x$6, $x$7, $x$8, $x$9, $x$10, $x$11, sci_Vector6_copy$default$17($this));
    }
    function sci_Vector6_slice0($this, $lo, $hi) {
        var $b;
        $b = sci_VectorSliceBuilder__init_($lo, $hi);
        sci_VectorSliceBuilder_consider($b, 1, $this.$prefix10);
        sci_VectorSliceBuilder_consider($b, 2, $this.$prefix23);
        sci_VectorSliceBuilder_consider($b, 3, $this.$prefix32);
        sci_VectorSliceBuilder_consider($b, 4, $this.$prefix41);
        sci_VectorSliceBuilder_consider($b, 5, $this.$prefix50);
        sci_VectorSliceBuilder_consider($b, 6, $this.$data60);
        sci_VectorSliceBuilder_consider($b, 5, $this.$suffix50);
        sci_VectorSliceBuilder_consider($b, 4, $this.$suffix41);
        sci_VectorSliceBuilder_consider($b, 3, $this.$suffix32);
        sci_VectorSliceBuilder_consider($b, 2, $this.$suffix23);
        sci_VectorSliceBuilder_consider($b, 1, $this.$suffix1);
        return sci_VectorSliceBuilder_result($b);
    }
    function sci_Vector6_init($this) {
        var $x$3, $x$4, $x$1, $x$2;
        $x$3 = $this.$suffix1;
        $x$4 = $x$3.data.length;
        if ($x$4 <= 1)
            return sci_Vector6_slice0($this, 0, $this.$length00 - 1 | 0);
        $x$1 = ju_Arrays_copyOfRange($x$3, 0, $x$4 - 1 | 0);
        $x$2 = $this.$length00 - 1 | 0;
        return sci_Vector6__init_($this.$prefix10, $this.$len16, $this.$prefix23, $this.$len124, $this.$prefix32, $this.$len1232, $this.$prefix41, $this.$len12341, $this.$prefix50, $this.$len12345, $this.$data60, $this.$suffix50, $this.$suffix41, $this.$suffix32, $this.$suffix23, $x$1, $x$2);
    }
    function sci_Vector6_vectorSliceCount($this) {
        return 11;
    }
    function sci_Vector6_vectorSlice($this, $idx) {
        switch ($idx) {
            case 0:
                break;
            case 1:
                return $this.$prefix23;
            case 2:
                return $this.$prefix32;
            case 3:
                return $this.$prefix41;
            case 4:
                return $this.$prefix50;
            case 5:
                return $this.$data60;
            case 6:
                return $this.$suffix50;
            case 7:
                return $this.$suffix41;
            case 8:
                return $this.$suffix32;
            case 9:
                return $this.$suffix23;
            case 10:
                return $this.$suffix1;
            default:
                $rt_throw(s_MatchError__init_(jl_Integer_valueOf($idx)));
        }
        return $this.$prefix10;
    }
    function sci_Vector6_appendedAll0($this, $suffix, $k) {
        var $suffix1b, $x$11, $x$2;
        $suffix1b = sci_VectorStatics$_append1IfSpace(sci_VectorStatics$_MODULE$, $this.$suffix1, $suffix);
        if ($suffix1b === null)
            return sci_Vector_appendedAll0($this, $suffix, $k);
        $x$11 = $suffix1b.data;
        $x$2 = ($this.$length00 - $this.$suffix1.data.length | 0) + $x$11.length | 0;
        return sci_Vector6__init_($this.$prefix10, $this.$len16, $this.$prefix23, $this.$len124, $this.$prefix32, $this.$len1232, $this.$prefix41, $this.$len12341, $this.$prefix50, $this.$len12345, $this.$data60, $this.$suffix50, $this.$suffix41, $this.$suffix32, $this.$suffix23, $suffix1b, $x$2);
    }
    function sci_Vector6_init0($this) {
        return sci_Vector6_init($this);
    }
    function sci_Vector6_tail($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        if ($this.$len16 <= 1)
            var$1 = sci_Vector6_slice0($this, 1, $this.$length00);
        else {
            var$2 = $this.$prefix10;
            var$3 = ju_Arrays_copyOfRange(var$2, 1, var$2.data.length);
            var$4 = $this.$len16 - 1 | 0;
            var$5 = $this.$len124 - 1 | 0;
            var$6 = $this.$len1232 - 1 | 0;
            var$7 = $this.$len12341 - 1 | 0;
            var$8 = $this.$len12345 - 1 | 0;
            var$9 = $this.$length00 - 1 | 0;
            var$1 = sci_Vector6__init_(var$3, var$4, $this.$prefix23, var$5, $this.$prefix32, var$6, $this.$prefix41, var$7, $this.$prefix50, var$8, $this.$data60, $this.$suffix50, $this.$suffix41, $this.$suffix32, $this.$suffix23, $this.$suffix1, var$9);
        }
        return var$1;
    }
    function sci_Vector6_map0($this, $f) {
        return sci_Vector6_map($this, $f);
    }
    function sci_Vector6_prepended0($this, $elem) {
        return sci_Vector6_prepended($this, $elem);
    }
    function sci_Vector6_appended0($this, $elem) {
        return sci_Vector6_appended($this, $elem);
    }
    function sci_Vector6_updated0($this, $index, $elem) {
        return sci_Vector6_updated($this, $index, $elem);
    }
    function sci_Vector6_apply0($this, $v1) {
        return sci_Vector6_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    }
    function sci_Vector6__init_0($this, $_prefix1, $len1, $prefix2, $len12, $prefix3, $len123, $prefix4, $len1234, $prefix5, $len12345, $data6, $suffix5, $suffix4, $suffix3, $suffix2, $_suffix1, $_length0) {
        $this.$len16 = $len1;
        $this.$prefix23 = $prefix2;
        $this.$len124 = $len12;
        $this.$prefix32 = $prefix3;
        $this.$len1232 = $len123;
        $this.$prefix41 = $prefix4;
        $this.$len12341 = $len1234;
        $this.$prefix50 = $prefix5;
        $this.$len12345 = $len12345;
        $this.$data60 = $data6;
        $this.$suffix50 = $suffix5;
        $this.$suffix41 = $suffix4;
        $this.$suffix32 = $suffix3;
        $this.$suffix23 = $suffix2;
        sci_BigVector__init_($this, $_prefix1, $_suffix1, $_length0);
    }
    var onciu_Foldable$ = $rt_classWithoutFields();
    var onciu_Foldable$_MODULE$ = null;
    function onciu_Foldable$__clinit_() {
        onciu_Foldable$_MODULE$ = new onciu_Foldable$;
    }
    function onciu_Foldable$_TreeAny($this, $that) {
        return $that;
    }
    function onciu_Foldable$_FoldableAny($this, $foldedOver) {
        var var$2;
        var$2 = new onciu_Foldable$FoldableAny;
        var$2.$foldedOver1 = $foldedOver;
        return var$2;
    }
    var scm_ListBuffer$ = $rt_classWithoutFields();
    var scm_ListBuffer$_MODULE$ = null;
    function scm_ListBuffer$__clinit_() {
        scm_ListBuffer$_MODULE$ = new scm_ListBuffer$;
    }
    function scm_ListBuffer$_newBuilder($this) {
        return scm_GrowableBuilder__init_0(scm_ListBuffer__init_());
    }
    function scm_ListBuffer$_from($this, $source) {
        return scm_ListBuffer_scala$collection$mutable$ListBuffer$$freshFrom(scm_ListBuffer__init_(), $source);
    }
    var oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1_applyOrElse($this, $x1, $default) {
        var $labelExpression;
        if ($x1 instanceof oncie_NodePattern) {
            $default = $x1.$labelExpression1;
            if ($default instanceof s_Some) {
                $labelExpression = $default.$value5;
                $x1 = new oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_0;
                $default = new oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_1;
                $default.$_0264 = $labelExpression;
                $default.$_171 = $x1;
                return $default;
            }
        }
        if ($x1 instanceof oncie_RelationshipPattern) {
            $default = $x1.$labelExpression2;
            if ($default instanceof s_Some) {
                $labelExpression = $default.$value5;
                $x1 = new oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_2;
                $default = new oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_3;
                $default.$_0265 = $labelExpression;
                $default.$_172 = $x1;
                return $default;
            }
        }
        if (!($x1 instanceof oncil_LabelExpressionPredicate))
            return s_PartialFunction$_fallback_fn;
        $labelExpression = $x1.$labelExpression3;
        $x1 = new oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_4;
        $default = new oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_5;
        $default.$_0266 = $labelExpression;
        $default.$_173 = $x1;
        return $default;
    }
    function oncipj_TokenMgrException() {
        jl_RuntimeException.call(this);
        this.$errorCode = 0;
    }
    function oncipj_TokenMgrException__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncipj_TokenMgrException();
        oncipj_TokenMgrException__init_0(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    }
    function oncipj_TokenMgrException_addEscapes($str) {
        var $retval, $i, $ch, var$5, var$6;
        $retval = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($retval);
        $i = 0;
        while ($i < jl_String_length($str)) {
            a: {
                $ch = jl_String_charAt($str, $i);
                switch ($ch) {
                    case 8:
                        break;
                    case 9:
                        jl_AbstractStringBuilder_append1($retval, $rt_s(1019));
                        break a;
                    case 10:
                        jl_AbstractStringBuilder_append1($retval, $rt_s(1020));
                        break a;
                    case 12:
                        jl_AbstractStringBuilder_append1($retval, $rt_s(1021));
                        break a;
                    case 13:
                        jl_AbstractStringBuilder_append1($retval, $rt_s(1022));
                        break a;
                    case 34:
                        jl_AbstractStringBuilder_append1($retval, $rt_s(1023));
                        break a;
                    case 39:
                        jl_AbstractStringBuilder_append1($retval, $rt_s(1024));
                        break a;
                    case 92:
                        jl_AbstractStringBuilder_append1($retval, $rt_s(183));
                        break a;
                    default:
                        if ($ch >= 32 && $ch <= 126) {
                            jl_AbstractStringBuilder_append($retval, $ch);
                            break a;
                        }
                        var$5 = jl_Integer_toString($ch, 16);
                        var$6 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_(var$6);
                        jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(1025)), var$5);
                        var$6 = jl_AbstractStringBuilder_toString(var$6);
                        jl_AbstractStringBuilder_append1($retval, $rt_s(1026));
                        jl_AbstractStringBuilder_append1($retval, jl_String_substring0(var$6, jl_String_length(var$6) - 4 | 0, jl_String_length(var$6)));
                        break a;
                }
                jl_AbstractStringBuilder_append1($retval, $rt_s(1027));
            }
            $i = $i + 1 | 0;
        }
        return jl_AbstractStringBuilder_toString($retval);
    }
    function oncipj_TokenMgrException_getMessage($this) {
        return $this.$message;
    }
    function oncipj_TokenMgrException__init_0($this, $EOFSeen, $lexState, $errorLine, $errorColumn, $errorAfter, $curChar, $reason) {
        var var$8, var$9, var$10;
        $lexState = $curChar & 65535;
        if ($EOFSeen)
            var$8 = $rt_s(1054);
        else {
            var$9 = oncipj_TokenMgrException_addEscapes(jl_String_valueOf0($lexState));
            var$10 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$10);
            jl_AbstractStringBuilder_append(var$10, 34);
            jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append(var$10, var$9), $rt_s(1055)), $curChar), $rt_s(1056));
            var$8 = jl_AbstractStringBuilder_toString(var$10);
        }
        var$10 = oncipj_TokenMgrException_addEscapes($errorAfter);
        $errorAfter = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($errorAfter);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($errorAfter, $rt_s(1057)), $errorLine), $rt_s(1006)), $errorColumn), $rt_s(1058)), var$8), $rt_s(1059)), var$10), 34);
        jl_Throwable__init_($this, jl_AbstractStringBuilder_toString($errorAfter));
        $this.$errorCode = $reason;
    }
    function onciuh_TreeZipper$Location() {
        var a = this; jl_Object.call(a);
        a.$elem = null;
        a.$context0 = null;
        a.$$outer25 = null;
    }
    function onciuh_TreeZipper$Location__init_(var_0, var_1, var_2) {
        var var_3 = new onciuh_TreeZipper$Location();
        onciuh_TreeZipper$Location__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function onciuh_TreeZipper$Location_root($this) {
        var $this_0, var$2, $left, $right, $parentElem, $parentContext;
        a: {
            while (true) {
                $this_0 = $this.$context0;
                if (jl_Object_equals(onciuh_TreeZipper_Top($this.$$outer25), $this_0))
                    break;
                var$2 = $this.$context0;
                if (!(var$2 instanceof onciuh_TreeZipper$TreeContext))
                    break a;
                var$2 = var$2;
                $left = var$2.$left2;
                $this_0 = var$2.$parent1;
                $right = var$2.$right1;
                if ($this_0 === null)
                    break a;
                $parentElem = $this_0.$elem;
                $parentContext = $this_0.$context0;
                $this = onciuh_TreeZipper$Location__init_($this.$$outer25, oncias_Scope_updateChildren($parentElem, ((sci_List_reverse($left)).$concat0(sci_$colon$colon__init_($this.$elem, sci_Nil$_MODULE$))).$concat0($right)), $parentContext);
            }
            return $this;
        }
        $rt_throw(s_MatchError__init_($this));
    }
    function onciuh_TreeZipper$Location_up($this) {
        var var$1, var$2, $left, $right, $parentElem, $parentContext;
        var$1 = $this.$context0;
        if (jl_Object_equals(onciuh_TreeZipper_Top($this.$$outer25), var$1))
            return s_None$_MODULE$;
        var$2 = $this.$context0;
        if (var$2 instanceof onciuh_TreeZipper$TreeContext) {
            var$2 = var$2;
            $left = var$2.$left2;
            var$1 = var$2.$parent1;
            $right = var$2.$right1;
            if (var$1 !== null) {
                $parentElem = var$1.$elem;
                $parentContext = var$1.$context0;
                return s_Some__init_(onciuh_TreeZipper$Location__init_($this.$$outer25, oncias_Scope_updateChildren($parentElem, ((sci_List_reverse($left)).$concat0(sci_$colon$colon__init_($this.$elem, sci_Nil$_MODULE$))).$concat0($right)), $parentContext));
            }
        }
        $rt_throw(s_MatchError__init_($this));
    }
    function onciuh_TreeZipper$Location_replace($this, $newElem) {
        return onciuh_TreeZipper$Location__init_($this.$$outer25, $newElem, $this.$context0);
    }
    function onciuh_TreeZipper$Location_insertRight($this, $newElem) {
        var var$2, var$3, $left, $parent, $right, var$7, var$8;
        var$2 = $this.$context0;
        if (jl_Object_equals(onciuh_TreeZipper_Top($this.$$outer25), var$2))
            return s_None$_MODULE$;
        var$3 = $this.$context0;
        if (!(var$3 instanceof onciuh_TreeZipper$TreeContext))
            $rt_throw(s_MatchError__init_($this));
        var$3 = var$3;
        $left = var$3.$left2;
        $parent = var$3.$parent1;
        $right = var$3.$right1;
        var$7 = new s_Some;
        var$3 = new onciuh_TreeZipper$Location;
        var$8 = $this.$$outer25;
        onciuh_TreeZipper$Location__init_0(var$3, var$8, $newElem, onciuh_TreeZipper$TreeContext__init_(var$8, $left.$prepended($this.$elem), $parent, $right));
        s_Some__init_0(var$7, var$3);
        return var$7;
    }
    function onciuh_TreeZipper$Location_productPrefix($this) {
        return $rt_s(1060);
    }
    function onciuh_TreeZipper$Location_productArity($this) {
        return 2;
    }
    function onciuh_TreeZipper$Location_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$elem;
            case 1:
                return $this.$context0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function onciuh_TreeZipper$Location_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciuh_TreeZipper$Location_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciuh_TreeZipper$Location_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function onciuh_TreeZipper$Location_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!($x$1 instanceof onciuh_TreeZipper$Location && $x$1.$$outer25 === $this.$$outer25 ? 1 : 0))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$elem;
                        var$3 = $x$1.$elem;
                        if (var$2 !== null) {
                            if (!oncias_Scope_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$context0;
                        $x$1 = $x$1.$context0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciuh_TreeZipper$Location))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function onciuh_TreeZipper$Location__init_0($this, $$outer, $elem, $context) {
        $this.$elem = $elem;
        $this.$context0 = $context;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer25 = $$outer;
    }
    function oncirr_normalizeWithAndReturnClauses() {
        var a = this; jl_Object.call(a);
        a.$cypherExceptionFactory0 = null;
        a.$rewriteProjectionsRecursively = null;
    }
    function oncirr_normalizeWithAndReturnClauses_toString($this) {
        return $rt_s(17);
    }
    function oncirr_normalizeWithAndReturnClauses_apply($this, $that) {
        var var$2, $returns, $yields, $x$1, $x$5, $x$10, $x$14, $x$18;
        if ($rt_isInstance($that, oncia_Query))
            return oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$rewriteTopLevelQuery($this, $that);
        if ($that instanceof oncia_ShowPrivileges) {
            var$2 = $that;
            $returns = oncia_ShowPrivileges_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $x$1 = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($x$1, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0__init_($this)))));
                        return oncia_ShowPrivileges_withGraph(oncia_ShowPrivileges_copy(var$2, oncia_ShowPrivileges_copy$default$1(var$2), $x$1, oncia_ShowPrivileges_copy$default$3(var$2), oncia_ShowPrivileges_position(var$2)), oncia_ShowPrivileges_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowPrivilegeCommands) {
            var$2 = $that;
            $returns = oncia_ShowPrivilegeCommands_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $x$5 = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($x$5, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1__init_($this)))));
                        return oncia_ShowPrivilegeCommands_withGraph(oncia_ShowPrivilegeCommands_copy(var$2, oncia_ShowPrivilegeCommands_copy$default$1(var$2), oncia_ShowPrivilegeCommands_copy$default$2(var$2), $x$5, oncia_ShowPrivilegeCommands_copy$default$4(var$2), oncia_ShowPrivilegeCommands_position(var$2)), oncia_ShowPrivilegeCommands_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowSupportedPrivilegeCommand) {
            var$2 = $that;
            $returns = oncia_ShowSupportedPrivilegeCommand_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $that = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($that, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2__init_($this)))));
                        return oncia_ShowSupportedPrivilegeCommand_withGraph(oncia_ShowSupportedPrivilegeCommand_copy(var$2, $that, oncia_ShowSupportedPrivilegeCommand_copy$default$2(var$2), oncia_ShowSupportedPrivilegeCommand_position(var$2)), oncia_ShowSupportedPrivilegeCommand_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowDatabase) {
            var$2 = $that;
            $returns = oncia_ShowDatabase_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $x$10 = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($x$10, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3__init_($this)))));
                        return oncia_ShowDatabase_withGraph(oncia_ShowDatabase_copy(var$2, oncia_ShowDatabase_copy$default$1(var$2), $x$10, oncia_ShowDatabase_copy$default$3(var$2), oncia_ShowDatabase_position(var$2)), oncia_ShowDatabase_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowAliases) {
            var$2 = $that;
            $returns = oncia_ShowAliases_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $x$14 = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($x$14, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4__init_($this)))));
                        return oncia_ShowAliases_withGraph(oncia_ShowAliases_copy(var$2, oncia_ShowAliases_copy$default$1(var$2), $x$14, oncia_ShowAliases_copy$default$3(var$2), oncia_ShowAliases_position(var$2)), oncia_ShowAliases_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowCurrentUser) {
            var$2 = $that;
            $returns = oncia_ShowCurrentUser_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $that = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($that, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5__init_($this)))));
                        return oncia_ShowCurrentUser_withGraph(oncia_ShowCurrentUser_copy(var$2, $that, oncia_ShowCurrentUser_copy$default$2(var$2), oncia_ShowCurrentUser_position(var$2)), oncia_ShowCurrentUser_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowUsers) {
            var$2 = $that;
            $returns = oncia_ShowUsers_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $that = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($that, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6__init_($this)))));
                        return oncia_ShowUsers_withGraph(oncia_ShowUsers_copy(var$2, $that, oncia_ShowUsers_copy$default$2(var$2), oncia_ShowUsers_position(var$2)), oncia_ShowUsers_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowRoles) {
            var$2 = $that;
            $returns = oncia_ShowRoles_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $x$18 = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($x$18, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7__init_($this)))));
                        return oncia_ShowRoles_withGraph(oncia_ShowRoles_copy(var$2, oncia_ShowRoles_copy$default$1(var$2), oncia_ShowRoles_copy$default$2(var$2), $x$18, oncia_ShowRoles_copy$default$4(var$2), oncia_ShowRoles_position(var$2)), oncia_ShowRoles_useGraph(var$2));
                    }
                }
            }
        }
        if ($that instanceof oncia_ShowServers) {
            var$2 = $that;
            $returns = oncia_ShowServers_yieldOrWhere(var$2);
            if ($returns instanceof s_Some) {
                $returns = s_Some_value($returns);
                if ($returns instanceof su_Left) {
                    $returns = su_Left_value($returns);
                    if ($returns !== null) {
                        $yields = s_Tuple2__1($returns);
                        $returns = s_Tuple2__2($returns);
                        $that = new s_Some;
                        s_package$_$callClinit();
                        s_Some__init_0($that, su_Left$_apply(s_package$_Left(s_package$_MODULE$), s_Tuple2__init_(oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $yields), s_Option_map($returns, oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8__init_($this)))));
                        return oncia_ShowServers_withGraph(oncia_ShowServers_copy(var$2, $that, oncia_ShowServers_copy$default$2(var$2), oncia_ShowServers_position(var$2)), oncia_ShowServers_useGraph(var$2));
                    }
                }
            }
        }
        return $that;
    }
    function oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$rewriteTopLevelQuery($this, $query) {
        var $lhs, $rhs;
        if ($query instanceof oncia_SingleQuery)
            return oncirr_normalizeWithAndReturnClauses_rewriteTopLevelSingleQuery($this, $query);
        if ($query instanceof oncia_UnionAll) {
            $query = $query;
            $lhs = $query.$lhs7;
            $rhs = $query.$rhs8;
            return oncia_UnionAll_copy($query, oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$rewriteTopLevelQuery($this, $lhs), oncirr_normalizeWithAndReturnClauses_rewriteTopLevelSingleQuery($this, $rhs), $query.$position38);
        }
        if (!($query instanceof oncia_UnionDistinct)) {
            if (!$rt_isInstance($query, oncia_ProjectingUnion))
                $rt_throw(s_MatchError__init_($query));
            $query = new jl_IllegalStateException;
            jl_Throwable__init_($query, $rt_s(1061));
            $rt_throw($query);
        }
        $query = $query;
        $lhs = $query.$lhs8;
        $rhs = $query.$rhs9;
        return oncia_UnionDistinct_copy($query, oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$rewriteTopLevelQuery($this, $lhs), oncirr_normalizeWithAndReturnClauses_rewriteTopLevelSingleQuery($this, $rhs), $query.$position39);
    }
    function oncirr_normalizeWithAndReturnClauses_rewriteTopLevelSingleQuery($this, $singleQuery) {
        var var$2, $newClauses;
        var$2 = $singleQuery.$clauses;
        $newClauses = new oncirr_normalizeWithAndReturnClauses$rewriteTopLevelSingleQuery$lambda$_36_0;
        $newClauses.$_0267 = $this;
        $singleQuery = oncia_SingleQuery_copy($singleQuery, var$2.$map1($newClauses), $singleQuery.$position5);
        return $this.$rewriteProjectionsRecursively.$apply($singleQuery);
    }
    function oncirr_normalizeWithAndReturnClauses_addAliasesToReturn($this, $r) {
        var $x$1;
        $x$1 = oncirr_normalizeWithAndReturnClauses_aliasUnaliasedReturnItems($this, $r.$returnItems1);
        return oncia_Return_copy($r, $r.$distinct, $x$1, $r.$orderBy0, $r.$skip0, $r.$limit0, $r.$excludedNames, $r.$addedInRewrite, $r.$position40);
    }
    function oncirr_normalizeWithAndReturnClauses_addAliasesToYield($this, $y) {
        return oncia_Yield_copy($y, oncirr_normalizeWithAndReturnClauses_aliasUnaliasedReturnItems($this, $y.$returnItems), $y.$orderBy, $y.$skip, $y.$limit, $y.$where, $y.$position4);
    }
    function oncirr_normalizeWithAndReturnClauses_aliasUnaliasedReturnItems($this, $ri) {
        var $aliasedReturnItems;
        $aliasedReturnItems = $ri.$items.$map1(new oncirr_normalizeWithAndReturnClauses$aliasUnaliasedReturnItems$lambda$_39_0);
        return oncia_ReturnItems_copy($ri, $ri.$includeExisting, $aliasedReturnItems, $ri.$defaultOrderOnColumns, $ri.$position28);
    }
    function oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems($this, $ri) {
        var $newItems;
        $newItems = $ri.$items.$map1(new oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems$lambda$_40_0);
        return oncia_ReturnItems_copy($ri, $ri.$includeExisting, $newItems, $ri.$defaultOrderOnColumns, $ri.$position28);
    }
    function oncirr_normalizeWithAndReturnClauses_aliasExpression($this, $existingAliases, $expression) {
        var $alias, var$4, $newExpression;
        $alias = $existingAliases.$get1($expression);
        if ($alias instanceof s_Some) {
            $alias = $alias.$value5;
            if (!($existingAliases.$valuesIterator()).$contains0($expression))
                return oncie_Variable_withPosition(oncie_Variable_copyId($alias), $expression.$position2());
        }
        var$4 = onciu_topDown$_MODULE$;
        onciu_Rewriter$_$callClinit();
        $alias = onciu_Rewriter$_MODULE$;
        $newExpression = new oncirr_normalizeWithAndReturnClauses$$anonfun$3;
        $newExpression.$$outer26 = $this;
        $newExpression.$existingAliases$3 = $existingAliases;
        return (onciu_topDown$_apply(var$4, onciu_Rewriter$_lift($alias, $newExpression), new oncirr_normalizeWithAndReturnClauses$aliasExpression$lambda$_45_0, 1, onciu_CancellationChecker$NeverCancelled$_MODULE$)).$apply($expression);
    }
    function oncirr_normalizeWithAndReturnClauses_productPrefix($this) {
        return $rt_s(95);
    }
    function oncirr_normalizeWithAndReturnClauses_productArity($this) {
        return 1;
    }
    function oncirr_normalizeWithAndReturnClauses_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$cypherExceptionFactory0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncirr_normalizeWithAndReturnClauses_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_normalizeWithAndReturnClauses_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncirr_normalizeWithAndReturnClauses_equals($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncirr_normalizeWithAndReturnClauses) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$cypherExceptionFactory0;
                        $x$1 = $x$1.$cypherExceptionFactory0;
                        if (var$2 !== null) {
                            if (!onciu_OpenCypherExceptionFactory_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncirr_normalizeWithAndReturnClauses))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    }
    var oncirr_rewriteShortestPathWithFixedLengthRel$ = $rt_classWithoutFields();
    var oncirr_rewriteShortestPathWithFixedLengthRel$_MODULE$ = null;
    var oncirr_rewriteShortestPathWithFixedLengthRel$_instance = null;
    function oncirr_rewriteShortestPathWithFixedLengthRel$_$callClinit() {
        oncirr_rewriteShortestPathWithFixedLengthRel$_$callClinit = $rt_eraseClinit(oncirr_rewriteShortestPathWithFixedLengthRel$);
        oncirr_rewriteShortestPathWithFixedLengthRel$__clinit_();
    }
    function oncirr_rewriteShortestPathWithFixedLengthRel$__clinit_() {
        var var$1, var$2;
        var$1 = new oncirr_rewriteShortestPathWithFixedLengthRel$;
        oncirr_rewriteShortestPathWithFixedLengthRel$_$callClinit();
        oncirr_rewriteShortestPathWithFixedLengthRel$_MODULE$ = var$1;
        var$2 = onciu_topDown$_MODULE$;
        onciu_Rewriter$_$callClinit();
        oncirr_rewriteShortestPathWithFixedLengthRel$_instance = onciu_topDown$_apply(var$2, onciu_Rewriter$_lift(onciu_Rewriter$_MODULE$, new oncirr_rewriteShortestPathWithFixedLengthRel$$anonfun$1), onciu_topDown$_apply$default$2(onciu_topDown$_MODULE$), 1, onciu_CancellationChecker$NeverCancelled$_MODULE$);
    }
    function oncirr_rewriteShortestPathWithFixedLengthRel$_toString($this) {
        return $rt_s(17);
    }
    function oncirr_rewriteShortestPathWithFixedLengthRel$_apply($this, $v) {
        oncirr_rewriteShortestPathWithFixedLengthRel$_$callClinit();
        return onciu_topDown$TopDownRewriter_apply(oncirr_rewriteShortestPathWithFixedLengthRel$_instance, $v);
    }
    function ju_AbstractList$1() {
        var a = this; jl_Object.call(a);
        a.$index0 = 0;
        a.$modCount0 = 0;
        a.$size1 = 0;
        a.$removeIndex = 0;
        a.$this$0 = null;
    }
    function ju_AbstractList$1_hasNext($this) {
        return $this.$index0 >= $this.$size1 ? 0 : 1;
    }
    function ju_AbstractList$1_next($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$modCount0;
        var$2 = $this.$this$0;
        if (var$1 < var$2.$modCount) {
            var$2 = new ju_ConcurrentModificationException;
            jl_Throwable__init_0(var$2);
            $rt_throw(var$2);
        }
        var$3 = $this.$index0;
        $this.$removeIndex = var$3;
        $this.$index0 = var$3 + 1 | 0;
        return var$2.$get(var$3);
    }
    var ju_EmptyStackException = $rt_classWithoutFields(jl_RuntimeException);
    var scm_ArrayDeque$ = $rt_classWithoutFields();
    var scm_ArrayDeque$_MODULE$ = null;
    function scm_ArrayDeque$__clinit_() {
        scm_ArrayDeque$_MODULE$ = new scm_ArrayDeque$;
    }
    function scm_ArrayDeque$_alloc($this, $len) {
        var var$2, var$3, $size, var$5;
        if (!($len < 0 ? 0 : 1)) {
            var$2 = new jl_IllegalArgumentException;
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$3, 20);
            jl_AbstractStringBuilder_append1(var$3, $rt_s(486));
            jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$3, $rt_s(1062))));
            $rt_throw(var$2);
        }
        $size = (-2147483648) >>> jl_Integer_numberOfLeadingZeros($len) << 1;
        if ($size < 0 ? 0 : 1)
            return $rt_createArray(jl_Object, jl_Math_max($size, 16));
        var$3 = new jl_IllegalArgumentException;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$2, 20);
        jl_AbstractStringBuilder_append1(var$2, $rt_s(486));
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$5, 58);
        jl_AbstractStringBuilder_append1(var$5, $rt_s(1063));
        jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$5, $len)))));
        $rt_throw(var$3);
    }
    var onciu_Foldable$TreeAny$ = $rt_classWithoutFields();
    var onciu_Foldable$TreeAny$_MODULE$ = null;
    function onciu_Foldable$TreeAny$__clinit_() {
        onciu_Foldable$TreeAny$_MODULE$ = new onciu_Foldable$TreeAny$;
    }
    function onciu_Foldable$TreeAny$_treeChildren$extension($this, $$this) {
        if ($rt_isInstance($$this, sc_Seq))
            return $$this.$iterator0();
        if ($rt_isInstance($$this, sci_Set))
            return $$this.$iterator0();
        if ($rt_isInstance($$this, sci_Map))
            return ($$this.$iterator0()).$flatMap2(new onciu_Foldable$TreeAny$$treeChildren$extension$lambda$_1_0);
        if ($rt_isInstance($$this, s_Product))
            return $$this.$productIterator();
        s_package$_$callClinit();
        s_package$_Iterator0(s_package$_MODULE$);
        return sc_Iterator$_scala$collection$Iterator$$_empty;
    }
    function onciu_Foldable$TreeAny$_reverseTreeChildren$extension($this, $$this) {
        var var$2;
        if ($rt_isInstance($$this, sc_Seq))
            return $$this.$reverseIterator();
        if ($$this instanceof sci_ListSet) {
            $$this = $$this;
            s_package$_$callClinit();
            var$2 = sci_List$_newBuilder(s_package$_List0(s_package$_MODULE$));
            while (sc_IterableOnceOps_nonEmpty$($$this)) {
                scm_ListBuffer_addOne(var$2, $$this.$last());
                $$this = $$this.$init1();
            }
            return (scm_ListBuffer_toList(var$2)).$iterator0();
        }
        if ($rt_isInstance($$this, sci_Set))
            return sc_IndexedSeqOps_reverseIterator$(sc_AbstractIterable_toVector($$this));
        if ($rt_isInstance($$this, sci_Map))
            return sc_Iterator_flatMap$(sc_IndexedSeqOps_reverseIterator$(sc_AbstractIterable_toVector($$this)), new onciu_Foldable$TreeAny$$reverseTreeChildren$extension$lambda$_2_0);
        if (!$rt_isInstance($$this, s_Product)) {
            s_package$_$callClinit();
            s_package$_Iterator0(s_package$_MODULE$);
            return sc_Iterator$_scala$collection$Iterator$$_empty;
        }
        $$this = $$this;
        var$2 = new onciu_Foldable$TreeAny$$anon$1;
        var$2.$p$10 = $$this;
        var$2.$c0 = $$this.$productArity() - 1 | 0;
        return var$2;
    }
    function onciu_Foldable$FoldableAny() {
        jl_Object.call(this);
        this.$foldedOver1 = null;
    }
    function onciu_Foldable$FoldableAny_foldedOver($this) {
        return $this.$foldedOver1;
    }
    function oncirr_normalizeWithAndReturnClauses$$anonfun$1() {
        sr_AbstractPartialFunction.call(this);
        this.$$outer1 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$$anonfun$1_applyOrElse($this, $x1, $default) {
        var $x$10, var$4, $existingAliases, $updatedWhere, $updatedOrderBy, $x$1, $x$7;
        $x$10 = 0;
        var$4 = null;
        if ($rt_isInstance($x1, oncia_ProjectionClause)) {
            $x$10 = 1;
            var$4 = $x1;
            $existingAliases = oncia_ProjectionClause$_unapply(oncia_ProjectionClause$_MODULE$, var$4);
            if (!s_Option_isEmpty($existingAliases)) {
                $existingAliases = $existingAliases.$value5;
                $updatedWhere = $existingAliases.$_227;
                $updatedOrderBy = $existingAliases.$_38;
                $existingAliases = $existingAliases.$_6;
                if ($updatedWhere !== null && jl_Object_equals(s_None$_MODULE$, $updatedOrderBy) && jl_Object_equals(s_None$_MODULE$, $existingAliases)) {
                    $x$1 = oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems($this.$$outer1, $updatedWhere);
                    return var$4.$copyProjection(var$4.$copyProjection$default$1(), $x$1, var$4.$copyProjection$default$3(), var$4.$copyProjection$default$4(), var$4.$copyProjection$default$5(), var$4.$copyProjection$default$6());
                }
            }
        }
        if ($rt_isInstance($x1, oncia_FullSubqueryExpression)) {
            $x1 = $x1;
            return $x1.$withQuery(oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$rewriteTopLevelQuery($this.$$outer1, $x1.$query1()));
        }
        if ($x$10) {
            $existingAliases = oncia_ProjectionClause$_unapply(oncia_ProjectionClause$_MODULE$, var$4);
            if (!s_Option_isEmpty($existingAliases)) {
                $existingAliases = $existingAliases.$value5;
                $x$7 = $existingAliases.$_227;
                $updatedOrderBy = $existingAliases.$_38;
                $updatedWhere = $existingAliases.$_6;
                if ($x$7 !== null) {
                    $x1 = new oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_0;
                    $x1.$_0268 = $this;
                    var$4.$verifyOrderByAggregationUse($x1);
                    $existingAliases = ($x$7.$items.$collect0(new oncirr_normalizeWithAndReturnClauses$$anonfun$1$$anonfun$2)).$toMap(s_$less$colon$less$_singleton);
                    $x1 = new oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_1;
                    $x1.$_0269 = $this;
                    $x1.$_174 = $existingAliases;
                    $updatedOrderBy = s_Option_map($updatedOrderBy, $x1);
                    $x1 = new oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_2;
                    $x1.$_0270 = $this;
                    $x1.$_175 = $existingAliases;
                    $updatedWhere = s_Option_map($updatedWhere, $x1);
                    $x$7 = oncirr_normalizeWithAndReturnClauses_org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems($this.$$outer1, $x$7);
                    return var$4.$copyProjection(var$4.$copyProjection$default$1(), $x$7, $updatedOrderBy, var$4.$copyProjection$default$4(), var$4.$copyProjection$default$5(), $updatedWhere);
                }
            }
        }
        return $default.$apply($x1);
    }
    function s_PartialFunction$Combined() {
        var a = this; jl_Object.call(a);
        a.$pf2 = null;
        a.$k0 = null;
    }
    function s_PartialFunction$Combined_lift($this) {
        return s_PartialFunction_lift$($this);
    }
    function s_PartialFunction$Combined_applyOrElse($this, $x, $default) {
        var $pfv;
        $pfv = $this.$pf2.$applyOrElse($x, s_PartialFunction$_fallback_fn);
        if (s_PartialFunction$_scala$PartialFunction$$fallbackOccurred(s_PartialFunction$_MODULE$, $pfv))
            return s_PartialFunction$_fallback_fn;
        $x = $pfv;
        $default = new onciu_Foldable$Folder$org$neo4j$cypher$internal$util$Foldable$Folder$$innerTreeFold$lambda$_4_0;
        $default.$_0271 = $x;
        return $default;
    }
    function sc_MapView$MapValues() {
        var a = this; sc_AbstractMapView.call(a);
        a.$underlying18 = null;
        a.$f7 = null;
    }
    function sc_MapView$MapValues_iterator($this) {
        var var$1, var$2;
        var$1 = sc_MapView$Id_iterator($this.$underlying18);
        var$2 = new sc_MapView$MapValues$iterator$lambda$_0_0;
        var$2.$_0272 = $this;
        return var$1.$map7(var$2);
    }
    function sc_MapView$MapValues_knownSize($this) {
        return sc_MapView$Id_knownSize($this.$underlying18);
    }
    function sc_SeqOps$indexOf$lambda$_58_0() {
        jl_Object.call(this);
        this.$_012 = null;
    }
    function sc_SeqOps$indexOf$lambda$_58_0_apply(var$0, var$1) {
        return jl_Boolean_valueOf(!sr_BoxesRunTime_equals(var$0.$_012, var$1) ? 0 : 1);
    }
    var oncirr_rewriteShortestPathWithFixedLengthRel$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    function oncirr_rewriteShortestPathWithFixedLengthRel$$anonfun$1_applyOrElse($this, $x1, $default) {
        var var$3, $r, $relPat, $range, $one, $x$8;
        if ($x1 instanceof oncie_ShortestPathsPatternPart) {
            var$3 = $x1;
            $r = var$3.$element3;
            if ($r instanceof oncie_RelationshipChain) {
                $r = $r;
                $relPat = $r.$relationship1;
                if ($r.$element4 instanceof oncie_NodePattern && $relPat !== null) {
                    $range = $relPat.$length2;
                    if (jl_Object_equals(s_None$_MODULE$, $range)) {
                        $one = new s_Some;
                        $range = new oncie_UnsignedDecimalIntegerLiteral;
                        onciu_InputPosition$_$callClinit();
                        oncie_UnsignedDecimalIntegerLiteral__init_0($range, $rt_s(91), onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
                        s_Some__init_0($one, $range);
                        $range = s_Some__init_(s_Some__init_(oncie_Range__init_($one, $one, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$))));
                        $x$8 = oncie_RelationshipPattern_copy($relPat, $relPat.$variable12, $relPat.$labelExpression2, $range, $relPat.$properties5, $relPat.$predicate1, $relPat.$direction0, $relPat.$position32);
                        return oncie_ShortestPathsPatternPart_copy(var$3, oncie_RelationshipChain_copy($r, $r.$element4, $x$8, $r.$rightNode, $r.$position41), var$3.$single0, var$3.$position42);
                    }
                }
            }
        }
        return $default.$apply($x1);
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_0() {
        jl_Object.call(this);
        this.$_0158 = null;
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_0_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0158;
        return jl_Boolean_valueOf((var$1.$postConditions0()).$subsetOf(var$2));
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_1() {
        jl_Object.call(this);
        this.$_0159 = null;
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_1_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0159;
        return jl_Boolean_valueOf((var$1.$preConditions()).$subsetOf(var$2));
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_2() {
        var a = this; jl_Object.call(a);
        a.$_0160 = null;
        a.$_127 = null;
        a.$_214 = null;
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_2_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0160;
        var$3 = var$0.$_127;
        var$4 = var$0.$_214;
        onciu_StepSequencer$MutableDirectedGraph_connect(var$2, var$3, var$1);
        return var$4.$addOne(var$1);
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_3() {
        jl_Object.call(this);
        this.$_0161 = null;
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_3_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0161;
        return jl_Boolean_valueOf(sc_IterableOnceOps_nonEmpty$((var$1.$postConditions0()).$intersect(var$2)));
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_4() {
        var a = this; jl_Object.call(a);
        a.$_0162 = null;
        a.$_128 = null;
        a.$_215 = null;
    }
    function onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_4_apply(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0162;
        var$3 = var$0.$_128;
        var$4 = var$0.$_215;
        onciu_StepSequencer$MutableDirectedGraph_connect(var$2, var$1, var$3);
        return var$4.$addOne(var$3);
    }
    function oncirc_containsNoMatchingNodes$$anonfun$apply$1() {
        sr_AbstractPartialFunction.call(this);
        this.$$outer24 = null;
    }
    function oncirc_containsNoMatchingNodes$$anonfun$apply$1_applyOrElse($this, $x1, $default) {
        if ($rt_isInstance($x1, onciu_ASTNode)) {
            $x1 = $x1;
            if ($x1 instanceof oncia_ReturnItems && $x1.$includeExisting ? 1 : 0) {
                $default = new oncirc_containsNoMatchingNodes$$anonfun$apply$1$applyOrElse$lambda$_0_0;
                $default.$_0273 = $this;
                $default.$_176 = $x1;
                return $default;
            }
        }
        return s_PartialFunction$_fallback_fn;
    }
    var oncirc_containsNoMatchingNodes$apply$lambda$_30_0 = $rt_classWithoutFields();
    function oncirc_containsNoMatchingNodes$apply$lambda$_30_0_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1064)), var$2), $rt_s(1065)), var$1);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    var onciu_Foldable$TreeAny$$treeChildren$extension$lambda$_1_0 = $rt_classWithoutFields();
    function onciu_Foldable$TreeAny$$treeChildren$extension$lambda$_1_0_apply(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$3 = var$1.$_20;
        s_package$_$callClinit();
        s_package$_Iterator0(s_package$_MODULE$);
        return (sr_ScalaRunTime$_genericWrapArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_Object, [var$2, var$3]))).$iterator0();
    }
    function sc_MapView$MapValues$iterator$lambda$_0_0() {
        jl_Object.call(this);
        this.$_0272 = null;
    }
    function sc_MapView$MapValues$iterator$lambda$_0_0_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0272;
        return s_Tuple2__init_(var$1.$_10, var$2.$f7.$apply(var$1.$_20));
    }
    function scm_MutationTracker$CheckedIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$underlying9 = null;
        a.$mutationCount2 = null;
        a.$expectedCount = 0;
    }
    function scm_MutationTracker$CheckedIterator_hasNext($this) {
        scm_MutationTracker$_checkMutations(scm_MutationTracker$_MODULE$, $this.$expectedCount, scm_ListBuffer$iterator$lambda$_59_0_apply$mcI$sp($this.$mutationCount2), $rt_s(518));
        return $this.$underlying9.$hasNext();
    }
    function scm_MutationTracker$CheckedIterator_next($this) {
        return $this.$underlying9.$next();
    }
    function scm_ListBuffer$iterator$lambda$_59_0() {
        jl_Object.call(this);
        this.$_0170 = null;
    }
    function scm_ListBuffer$iterator$lambda$_59_0_apply$mcI$sp(var$0) {
        return var$0.$_0170.$mutationCount1;
    }
    var jn_ReadOnlyBufferException = $rt_classWithoutFields(jl_UnsupportedOperationException);
    var jn_BufferOverflowException = $rt_classWithoutFields(jl_RuntimeException);
    var jn_BufferUnderflowException = $rt_classWithoutFields(jl_RuntimeException);
    var oncias_SemanticAnalysisTooling = $rt_classWithoutFields(0);
    function oncias_SemanticAnalysisTooling_semanticCheckFold$($$this, $iterable, $f) {
        var var$4;
        var$4 = oncias_SemanticCheck$_success;
        $$this = new oncias_SemanticAnalysisTooling$semanticCheckFold$lambda$_1_0;
        $$this.$_0274 = $f;
        return $iterable.$foldLeft(var$4, $$this);
    }
    function oncias_SemanticAnalysisTooling_specifyType$($$this, $typeGen, $expression) {
        var var$4;
        var$4 = new oncias_SemanticAnalysisTooling$specifyType$lambda$_7_0;
        var$4.$_0275 = $$this;
        var$4.$_177 = $typeGen;
        var$4.$_228 = $expression;
        return var$4;
    }
    function oncias_SemanticAnalysisTooling_specifyType$0($$this, $possibleTypes, $expression) {
        $$this = new oncias_SemanticAnalysisTooling$specifyType$lambda$_9_0;
        $$this.$_0276 = $expression;
        $$this.$_178 = $possibleTypes;
        return $$this;
    }
    function oncias_SemanticAnalysisTooling_expectType$($$this, $possibleTypes, $opt) {
        var var$4, var$5;
        var$4 = oncias_OptionSemanticChecking$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$expectType$lambda$_13_0;
        var$5.$_0277 = $$this;
        var$5.$_179 = $possibleTypes;
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$4, $opt, var$5);
    }
    function oncias_SemanticAnalysisTooling_expectType$0($$this, $possibleTypes, $expressions) {
        var var$4, var$5;
        var$4 = oncias_package$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$expectType$lambda$_17_0;
        var$5.$_0278 = $$this;
        var$5.$_180 = $expressions;
        var$5.$_229 = $possibleTypes;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5);
    }
    function oncias_SemanticAnalysisTooling_expectType$1($$this, $possibleTypes, $expression) {
        var var$4, var$5;
        var$4 = oncias_package$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$expectType$lambda$_21_0;
        var$5.$_0279 = $$this;
        var$5.$_181 = $possibleTypes;
        var$5.$_230 = $expression;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5);
    }
    function oncias_SemanticAnalysisTooling_expectType$2($$this, $s, $possibleTypes, $expression, $messageGen) {
        var var$6, var$7, var$8, var$9;
        a: {
            b: {
                c: {
                    var$6 = $possibleTypes.$apply2();
                    $$this = oncias_SemanticState_expressionType($s, $expression);
                    var$7 = oncias_ExpressionTypeInfo$_apply(oncias_ExpressionTypeInfo$_MODULE$, $$this.$specified, s_Some__init_(var$6));
                    var$8 = new s_Tuple2;
                    $$this = $s.$typeTable.$updated1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $expression), var$7);
                    s_Tuple2__init_0(var$8, oncias_SemanticState_copy($s, $s.$currentScope, $$this, $s.$recordedScopes, $s.$notifications, $s.$features1, $s.$declareVariablesToSuppressDuplicateErrors, $s.$semanticCheckHasRunOnce), oncias_ExpressionTypeInfo_actual(var$7));
                    $s = var$8.$_10;
                    $$this = var$8.$_20;
                    oncius_TypeSpec$_$callClinit();
                    var$9 = oncius_TypeSpec$_none(oncius_TypeSpec$_MODULE$);
                    if (var$9 !== null) {
                        if (!oncius_TypeSpec_equals(var$9, $$this))
                            break c;
                        else
                            break b;
                    }
                    if ($$this === null)
                        break b;
                }
                $$this = var$8.$_10;
                $$this = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, $$this);
                break a;
            }
            $$this = oncius_TypeSpec_mkString((oncias_SemanticState_expressionType($s, $expression)).$specified, $rt_s(16), $rt_s(442));
            $possibleTypes = oncius_TypeSpec_mkString($possibleTypes.$apply2(), $rt_s(16), $rt_s(442));
            if ($rt_isInstance($expression, oncie_Parameter)) {
                var$8 = $expression;
                if (!jl_String_matches(var$8.$name10, $rt_s(1066))) {
                    var$9 = oncias_SemanticCheckResult$_MODULE$;
                    var$6 = new oncias_SemanticError;
                    var$8 = var$8.$name10;
                    $$this = $messageGen.$apply0($possibleTypes, $$this);
                    $possibleTypes = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($possibleTypes);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($possibleTypes, $rt_s(1067)), var$8), $rt_s(1068)), $$this);
                    oncias_SemanticError__init_(var$6, jl_AbstractStringBuilder_toString($possibleTypes), $expression.$position2());
                    $$this = oncias_SemanticCheckResult$_error(var$9, $s, var$6);
                    break a;
                }
            }
            var$8 = oncias_SemanticCheckResult$_MODULE$;
            var$9 = new oncias_SemanticError;
            $$this = $messageGen.$apply0($possibleTypes, $$this);
            $possibleTypes = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($possibleTypes);
            jl_StringBuilder_append(jl_StringBuilder_append($possibleTypes, $rt_s(443)), $$this);
            oncias_SemanticError__init_(var$9, jl_AbstractStringBuilder_toString($possibleTypes), $expression.$position2());
            $$this = oncias_SemanticCheckResult$_error(var$8, $s, var$9);
        }
        return $$this;
    }
    function oncias_SemanticAnalysisTooling_expectType$default$4$($$this) {
        return oncie_Expression$_DefaultTypeMismatchMessageGenerator;
    }
    function oncias_SemanticAnalysisTooling_checkTypes$($$this, $expression, $signatures) {
        var var$4, var$5;
        var$4 = oncias_package$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$checkTypes$lambda$_29_0;
        var$5.$_0280 = $$this;
        var$5.$_182 = $signatures;
        var$5.$_231 = $expression;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5);
    }
    function oncias_SemanticAnalysisTooling_whenState$($$this, $condition, $thenBranch, $elseBranch) {
        var var$5;
        $$this = oncias_SemanticCheck$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$whenState$lambda$_31_0;
        var$5.$_0281 = $condition;
        var$5.$_183 = $thenBranch;
        var$5.$_232 = $elseBranch;
        return oncias_SemanticCheck$_fromState($$this, var$5);
    }
    function oncias_SemanticAnalysisTooling_whenState$default$3$($$this, $condition) {
        return oncias_SemanticCheck$_success;
    }
    function oncias_SemanticAnalysisTooling_unionOfTypes$($$this, $iterable) {
        var var$3;
        var$3 = new oncias_SemanticAnalysisTooling$unionOfTypes$lambda$_37_0;
        var$3.$_0282 = $$this;
        var$3.$_184 = $iterable;
        return var$3;
    }
    function oncias_SemanticAnalysisTooling_withScopedState$($$this, $check) {
        oncias_SemanticAnalysisTooling$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScope, $check.$apply2()), oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$popStateScope(oncias_SemanticAnalysisTooling$_MODULE$));
    }
    function oncias_SemanticAnalysisTooling_withScopedStateWithVariablesFromRecordedScope$($$this, $astNode, $exclude, $check) {
        var var$5;
        oncias_SemanticAnalysisTooling$_$callClinit();
        $$this = oncias_package$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$$org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScopeWithVariablesFromRecordedScope$lambda$_2_0;
        var$5.$_0283 = $astNode;
        var$5.$_185 = $exclude;
        $exclude = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($$this, var$5);
        $$this = $check.$_0284;
        $astNode = $check.$_186;
        $check = $check.$_233;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($exclude, oncias_SemanticCheck_chain$((oncias_SemanticPatternCheck$_check(oncias_SemanticPatternCheck$_MODULE$, $$this, $astNode)).$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $check.$optionalWhereExpression, new oncias_SemanticPatternCheck$$$anonfun$check$16$lambda$_97_0)), oncias_SemanticAnalysisTooling_recordCurrentScope$(oncias_SemanticPatternCheck$_MODULE$, $check))), oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$popStateScope(oncias_SemanticAnalysisTooling$_MODULE$));
    }
    function oncias_SemanticAnalysisTooling_ensureDefined$($$this, $v) {
        $$this = new oncias_SemanticAnalysisTooling$ensureDefined$lambda$_53_0;
        $$this.$_0285 = $v;
        return $$this;
    }
    function oncias_SemanticAnalysisTooling_declareVariable$($$this, $v, $possibleTypes) {
        $$this = new oncias_SemanticAnalysisTooling$declareVariable$lambda$_55_0;
        $$this.$_0286 = $v;
        $$this.$_187 = $possibleTypes;
        return $$this;
    }
    function oncias_SemanticAnalysisTooling_declareVariable$0($$this, $v, $typeGen, $maybePreviousDeclaration, $overriding) {
        $$this = new oncias_SemanticAnalysisTooling$declareVariable$lambda$_57_0;
        $$this.$_0287 = $v;
        $$this.$_188 = $typeGen;
        $$this.$_234 = $maybePreviousDeclaration;
        $$this.$_39 = $overriding;
        return $$this;
    }
    function oncias_SemanticAnalysisTooling_recordCurrentScope$($$this, $astNode) {
        var var$3;
        $$this = oncias_package$_MODULE$;
        var$3 = new oncias_SemanticAnalysisTooling$recordCurrentScope$lambda$_67_0;
        var$3.$_0288 = $astNode;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($$this, var$3);
    }
    function oncias_SemanticAnalysisTooling_requireFeatureSupport$($$this, $msg, $feature, $position) {
        var var$5;
        $$this = oncias_package$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$requireFeatureSupport$lambda$_69_0;
        var$5.$_0289 = $feature;
        var$5.$_189 = $msg;
        var$5.$_235 = $position;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($$this, var$5);
    }
    function oncias_SemanticAnalysisTooling_error$($$this, $msg, $position) {
        var var$4, var$5;
        $$this = oncias_SemanticCheck$_MODULE$;
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(oncias_SemanticErrorDef, 1);
        var$5.data[0] = oncias_SemanticError__init_0($msg, $position);
        return oncias_SemanticCheck$_error($$this, sr_ScalaRunTime$_wrapRefArray(var$4, var$5));
    }
    function oncias_SemanticAnalysisTooling_types$($$this, $expression) {
        $$this = new oncias_SemanticAnalysisTooling$types$lambda$_77_0;
        $$this.$_0290 = $expression;
        return $$this;
    }
    var oncia_Query = $rt_classWithoutFields(0);
    function oncia_Query_returnColumns$($$this) {
        return ($$this.$returnVariables()).$explicitVariables.$toList();
    }
    function oncia_Query_checkUse$($$this) {
        var var$2, var$3, var$4;
        var$2 = new oncia_Query$checkUse$lambda$_11_0;
        var$3 = new oncia_Query$checkUse$lambda$_11_1;
        var$3.$_0291 = $$this;
        var$4 = new oncia_Query$checkUse$lambda$_11_2;
        var$4.$_0292 = $$this;
        var$4.$_190 = var$2;
        return $$this.$whenState(var$2, var$3, var$4);
    }
    var oncia_StatementWithGraph = $rt_classWithoutFields(0);
    var oncia_AdministrationCommand = $rt_classWithoutFields(0);
    function oncia_AdministrationCommand_semanticCheck$($$this) {
        var var$2, var$3, var$4, var$5;
        var$2 = $$this.$name3();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1069)), var$2), $rt_s(1070));
        var$2 = $$this.$requireFeatureSupport(jl_AbstractStringBuilder_toString(var$3), oncias_SemanticFeature$MultipleDatabases$_MODULE$, $$this.$position2());
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = s_Option_isDefined($$this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar());
        var$5 = new oncia_AdministrationCommand$semanticCheck$lambda$_11_0;
        var$5.$_0293 = $$this;
        return oncias_SemanticCheck_chain$(var$2, oncias_SemanticCheck$_when(var$3, var$4, var$5));
    }
    function oncia_AdministrationCommand_$init$($$this) {
        $$this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq(s_None$_MODULE$);
    }
    var oncia_ReadAdministrationCommand = $rt_classWithoutFields(0);
    function oncia_ReadAdministrationCommand_defaultColumnNames$($$this) {
        return sci_List_map($$this.$defaultColumnSet(), new oncia_ReadAdministrationCommand$defaultColumnNames$lambda$_7_0);
    }
    function oncia_ReadAdministrationCommand_yields$($$this) {
        return s_Option_flatMap($$this.$yieldOrWhere(), new oncia_ReadAdministrationCommand$yields$lambda$_11_0);
    }
    function oncia_ReadAdministrationCommand_returns$($$this) {
        return s_Option_flatMap($$this.$yieldOrWhere(), new oncia_ReadAdministrationCommand$returns$lambda$_13_0);
    }
    function oncia_ReadAdministrationCommand_semanticCheck$($$this) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new oncia_ReadAdministrationCommand$semanticCheck$lambda$_18_0;
        var$3.$_0294 = $$this;
        return oncias_SemanticCheck$_nestedCheck(var$2, var$3);
    }
    function oncia_ReadAdministrationCommand_$init$($$this) {
        $$this.$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq(1);
    }
    function oncia_ShowPrivileges() {
        var a = this; jl_Object.call(a);
        a.$scope7 = null;
        a.$yieldOrWhere1 = null;
        a.$defaultColumnSet0 = null;
        a.$position43 = null;
        a.$isReadOnly = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar0 = null;
    }
    function oncia_ShowPrivileges__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_ShowPrivileges();
        oncia_ShowPrivileges__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowPrivileges_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowPrivileges_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowPrivileges_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowPrivileges_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowPrivileges_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowPrivileges_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowPrivileges_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowPrivileges_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowPrivileges_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowPrivileges_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowPrivileges_foldedOver($this) {
        return $this;
    }
    function oncia_ShowPrivileges_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly = $x$1;
    }
    function oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar0;
    }
    function oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar0 = $x$1;
    }
    function oncia_ShowPrivileges_scope($this) {
        return $this.$scope7;
    }
    function oncia_ShowPrivileges_yieldOrWhere($this) {
        return $this.$yieldOrWhere1;
    }
    function oncia_ShowPrivileges_defaultColumnSet($this) {
        return $this.$defaultColumnSet0;
    }
    function oncia_ShowPrivileges_position($this) {
        return $this.$position43;
    }
    function oncia_ShowPrivileges_name($this) {
        return $rt_s(1071);
    }
    function oncia_ShowPrivileges_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowPrivileges_copy($this, $scope, $yieldOrWhere, $defaultColumnSet, $position) {
        return oncia_ShowPrivileges__init_($scope, $yieldOrWhere, $defaultColumnSet, $position);
    }
    function oncia_ShowPrivileges_copy$default$1($this) {
        return $this.$scope7;
    }
    function oncia_ShowPrivileges_copy$default$3($this) {
        return $this.$defaultColumnSet0;
    }
    function oncia_ShowPrivileges_productPrefix($this) {
        return $rt_s(1072);
    }
    function oncia_ShowPrivileges_productArity($this) {
        return 3;
    }
    function oncia_ShowPrivileges_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope7;
            case 1:
                return $this.$yieldOrWhere1;
            case 2:
                return $this.$defaultColumnSet0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowPrivileges_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowPrivileges_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowPrivileges_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowPrivileges_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowPrivileges) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$scope7;
                            var$3 = $x$1.$scope7;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$yieldOrWhere1;
                            var$3 = $x$1.$yieldOrWhere1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumnSet0;
                        $x$1 = $x$1.$defaultColumnSet0;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowPrivileges_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowPrivileges_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowPrivileges__init_0($this, $scope, $yieldOrWhere, $defaultColumnSet, $position) {
        $this.$scope7 = $scope;
        $this.$yieldOrWhere1 = $yieldOrWhere;
        $this.$defaultColumnSet0 = $defaultColumnSet;
        $this.$position43 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
    }
    var oncia_Clause = $rt_classWithoutFields(0);
    function oncia_Clause_returnVariables$($$this) {
        return oncia_ReturnItems$ReturnVariables$_empty(oncia_ReturnItems$ReturnVariables$_MODULE$);
    }
    function oncia_Clause_semanticCheck$($$this) {
        var var$2, var$3, var$4, var$5;
        var$2 = $$this.$clauseSpecificSemanticCheck();
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = $$this.$shouldRunGpmChecks();
        var$5 = new oncia_Clause$semanticCheck$lambda$_7_0;
        var$5.$_0295 = $$this;
        return var$2.$chain(oncias_SemanticCheck$_when(var$3, var$4, var$5));
    }
    function oncia_Clause_org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition($this, $labelExpression, $isNode, $partition) {
        var $children;
        if ($labelExpression instanceof oncil_LabelExpression$Leaf) {
            $labelExpression = $labelExpression;
            $children = $partition.$leaf.$incl($labelExpression);
            return oncia_Clause$LabelExpressionsPartition_copy($partition, $partition.$legacy, $partition.$gpm, $children);
        }
        if ($labelExpression instanceof oncil_LabelExpression$Disjunctions) {
            $children = $labelExpression.$children;
            if (!$isNode && $children.$forall(new oncia_Clause$org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition$lambda$_13_0))
                return $partition;
        }
        if ($isNode && $labelExpression.$containsGpmSpecificLabelExpression()) {
            $children = $partition.$gpm.$incl($labelExpression);
            return oncia_Clause$LabelExpressionsPartition_copy($partition, $partition.$legacy, $children, $partition.$leaf);
        }
        if (!$isNode && $labelExpression.$containsGpmSpecificRelTypeExpression()) {
            $children = $partition.$gpm.$incl($labelExpression);
            return oncia_Clause$LabelExpressionsPartition_copy($partition, $partition.$legacy, $children, $partition.$leaf);
        }
        return oncia_Clause$LabelExpressionsPartition_copy($partition, $partition.$legacy.$incl($labelExpression), $partition.$gpm, $partition.$leaf);
    }
    function oncia_Clause_$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2($$this, $partition$1) {
        var $maybeExplanation, $explanation, $singleExpression, $containsIs, $pos, $isOrColon, $replacement;
        a: {
            $maybeExplanation = $partition$1.$legacy;
            $explanation = new oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_0;
            $explanation.$_0296 = $$this;
            $explanation = $maybeExplanation.$map1($explanation);
            if ($explanation !== null) {
                $maybeExplanation = oncia_Clause$SetExtractor$_unapplySeq($$this.$SetExtractor(), $explanation);
                if (!s_Option_isEmpty($maybeExplanation)) {
                    $maybeExplanation = $maybeExplanation.$value5;
                    if ($maybeExplanation !== null && !$maybeExplanation.$lengthCompare(0)) {
                        $maybeExplanation = s_None$_MODULE$;
                        break a;
                    }
                }
            }
            if ($explanation !== null) {
                $$this = oncia_Clause$SetExtractor$_unapplySeq($$this.$SetExtractor(), $explanation);
                if (!s_Option_isEmpty($$this)) {
                    $maybeExplanation = $$this.$value5;
                    if ($maybeExplanation !== null && !$maybeExplanation.$lengthCompare(1)) {
                        $$this = $$this.$value5.$apply1(0);
                        if ($$this !== null) {
                            $singleExpression = $$this.$_121;
                            $containsIs = sr_BoxesRunTime_unboxToBoolean($$this.$_212);
                            $pos = $$this.$_35;
                            $isOrColon = !$containsIs ? $rt_s(136) : $rt_s(1073);
                            $maybeExplanation = new s_Some;
                            $explanation = new s_Tuple2;
                            $replacement = new jl_StringBuilder;
                            jl_AbstractStringBuilder__init_($replacement);
                            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($replacement, $rt_s(1074)), $isOrColon), $singleExpression), 46);
                            s_Tuple2__init_0($explanation, jl_AbstractStringBuilder_toString($replacement), $pos);
                            s_Some__init_0($maybeExplanation, $explanation);
                            break a;
                        }
                    }
                }
            }
            if ($explanation === null)
                $rt_throw(s_MatchError__init_($explanation));
            $replacement = $explanation.$map1(new oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_1);
            $maybeExplanation = new s_Some;
            $$this = new s_Tuple2;
            $pos = sc_AbstractIterable_mkString0($replacement, $rt_s(16));
            $singleExpression = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($singleExpression);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($singleExpression, $rt_s(1075)), $pos), 46);
            s_Tuple2__init_0($$this, jl_AbstractStringBuilder_toString($singleExpression), ($explanation.$head()).$_35);
            s_Some__init_0($maybeExplanation, $$this);
        }
        if ($maybeExplanation instanceof s_Some) {
            $$this = $maybeExplanation.$value5;
            if ($$this !== null) {
                $explanation = $$this.$_10;
                $pos = $$this.$_20;
                $$this = oncias_package$_MODULE$;
                $maybeExplanation = new oncias_SemanticError;
                if (!sc_IterableOnceOps_nonEmpty$($partition$1.$gpm)) {
                    $partition$1 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($partition$1);
                    jl_StringBuilder_append(jl_StringBuilder_append($partition$1, $rt_s(1076)), $explanation);
                    $partition$1 = jl_AbstractStringBuilder_toString($partition$1);
                } else {
                    $partition$1 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($partition$1);
                    jl_StringBuilder_append(jl_StringBuilder_append($partition$1, $rt_s(1077)), $explanation);
                    $partition$1 = jl_AbstractStringBuilder_toString($partition$1);
                }
                oncias_SemanticError__init_($maybeExplanation, $partition$1, $pos);
                return oncias_package$_liftSemanticErrorDef($$this, $maybeExplanation);
            }
        }
        if (!jl_Object_equals(s_None$_MODULE$, $maybeExplanation))
            $rt_throw(s_MatchError__init_($maybeExplanation));
        return oncias_SemanticCheck$_success;
    }
    function oncia_Clause_$init$($$this) {
        $$this.$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq(onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_ExpressionStringifier$_failingExtender, 0, 0, 0, 0));
    }
    var oncia_HorizonClause = $rt_classWithoutFields(0);
    var oncia_ProjectionClause = $rt_classWithoutFields(0);
    function oncia_ProjectionClause_copyProjection$($$this, $distinct, $returnItems, $orderBy, $skip, $limit, $where) {
        var var$8;
        if ($$this instanceof oncia_With) {
            var$8 = $$this;
            $$this = oncia_With_copy(var$8, $distinct, $returnItems, $orderBy, $skip, $limit, $where, var$8.$withType, $$this.$position2());
        } else if (!($$this instanceof oncia_Return)) {
            if (!($$this instanceof oncia_Yield))
                $rt_throw(s_MatchError__init_($$this));
            $$this = oncia_Yield_copy($$this, $returnItems, $orderBy, $skip, $limit, $where, $$this.$position2());
        } else {
            var$8 = $$this;
            $$this = oncia_Return_copy(var$8, $distinct, $returnItems, $orderBy, $skip, $limit, var$8.$excludedNames, var$8.$addedInRewrite, $$this.$position2());
        }
        return $$this;
    }
    function oncia_ProjectionClause_clauseSpecificSemanticCheck$($$this) {
        return oncia_ReturnItems_semanticCheck($$this.$returnItems0());
    }
    function oncia_ProjectionClause_semanticCheckContinuation$($$this, $previousScope, $outerScope) {
        var var$4, var$5;
        var$4 = oncias_SemanticCheck$_MODULE$;
        var$5 = new oncia_ProjectionClause$semanticCheckContinuation$lambda$_31_0;
        var$5.$_0297 = $$this;
        var$5.$_191 = $previousScope;
        var$5.$_236 = $outerScope;
        return oncias_SemanticCheck$_fromState(var$4, var$5);
    }
    function oncia_ProjectionClause_warnOnAccessToRestrictedVariableInOrderByOrWhere$($$this, $previousScopeVars, $error) {
        $$this = new oncia_ProjectionClause$$anonfun$warnOnAccessToRestrictedVariableInOrderByOrWhere$1;
        $$this.$error$1 = $error;
        $$this = sc_AbstractIterable_collectFirst($previousScopeVars, $$this);
        $previousScopeVars = new oncia_ProjectionClause$warnOnAccessToRestrictedVariableInOrderByOrWhere$lambda$_35_0;
        $previousScopeVars.$_0298 = $error;
        return s_Option_getOrElse($$this, $previousScopeVars);
    }
    function oncia_ProjectionClause_verifyOrderByAggregationUse$($$this, $fail) {
        var var$3, var$4, var$5, var$6;
        var$3 = oncia_ReturnItems_containsAggregate($$this.$returnItems0());
        var$4 = s_Option_exists($$this.$orderBy2(), new oncia_ProjectionClause$verifyOrderByAggregationUse$lambda$_37_0);
        if (!var$3 && var$4) {
            var$5 = $$this.$name3();
            var$6 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$6);
            jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(1078)), var$5);
            var$5 = jl_AbstractStringBuilder_toString(var$6);
            $$this = $$this.$position2();
            $rt_throw(onciu_OpenCypherExceptionFactory_syntaxException($fail.$_0268.$$outer1.$cypherExceptionFactory0, var$5, $$this));
        }
    }
    function oncia_ProjectionClause_runChecks$1($this, $scopeToImportVariablesFrom) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncia_ReturnItems_declareVariables($this.$returnItems0(), $scopeToImportVariablesFrom), oncias_SemanticCheckableOption$_semanticCheck$extension(oncias_SemanticCheckableOption$_MODULE$, $this.$orderBy2())), oncias_SemanticCheckableOption$_semanticCheck$extension(oncias_SemanticCheckableOption$_MODULE$, $this.$limit3())), oncias_SemanticCheckableOption$_semanticCheck$extension(oncias_SemanticCheckableOption$_MODULE$,
        $this.$skip2())), oncias_SemanticCheckableOption$_semanticCheck$extension(oncias_SemanticCheckableOption$_MODULE$, $this.$where0()));
    }
    var oncia_ClauseAllowedOnSystem = $rt_classWithoutFields(0);
    function oncia_Yield() {
        var a = this; jl_Object.call(a);
        a.$returnItems = null;
        a.$orderBy = null;
        a.$skip = null;
        a.$limit = null;
        a.$where = null;
        a.$position4 = null;
        a.$LabelExpressionsPartition$module = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier = null;
        a.$SetExtractor$module = null;
    }
    function oncia_Yield__init_0(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_Yield();
        oncia_Yield__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    function oncia_Yield_isReturn($this) {
        return 0;
    }
    function oncia_Yield_copyProjection($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where) {
        return oncia_ProjectionClause_copyProjection$($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where);
    }
    function oncia_Yield_copyProjection$default$1($this) {
        return $this.$distinct1();
    }
    function oncia_Yield_copyProjection$default$3($this) {
        return $this.$orderBy2();
    }
    function oncia_Yield_copyProjection$default$4($this) {
        return $this.$skip2();
    }
    function oncia_Yield_copyProjection$default$5($this) {
        return $this.$limit3();
    }
    function oncia_Yield_copyProjection$default$6($this) {
        return $this.$where0();
    }
    function oncia_Yield_clauseSpecificSemanticCheck($this) {
        return oncia_ProjectionClause_clauseSpecificSemanticCheck$($this);
    }
    function oncia_Yield_semanticCheckContinuation($this, $previousScope, $outerScope) {
        return oncia_ProjectionClause_semanticCheckContinuation$($this, $previousScope, $outerScope);
    }
    function oncia_Yield_semanticCheckContinuation$default$2($this) {
        return s_None$_MODULE$;
    }
    function oncia_Yield_verifyOrderByAggregationUse($this, $fail) {
        oncia_ProjectionClause_verifyOrderByAggregationUse$($this, $fail);
    }
    function oncia_Yield_returnVariables($this) {
        return oncia_Clause_returnVariables$($this);
    }
    function oncia_Yield_semanticCheck($this) {
        return oncia_Clause_semanticCheck$($this);
    }
    function oncia_Yield_shouldRunGpmChecks($this) {
        return 1;
    }
    function oncia_Yield_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_Yield_asCanonicalStringVal($this) {
        return $this.$toString();
    }
    function oncia_Yield_foldedOver($this) {
        return $this;
    }
    function oncia_Yield_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_Yield_LabelExpressionsPartition($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module;
    }
    function oncia_Yield_org$neo4j$cypher$internal$ast$Clause$$stringifier($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier;
    }
    function oncia_Yield_SetExtractor($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module !== null)
                        break a;
                    $this.$SetExtractor$module = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module;
    }
    function oncia_Yield_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier = $x$1;
    }
    function oncia_Yield_returnItems($this) {
        return $this.$returnItems;
    }
    function oncia_Yield_orderBy($this) {
        return $this.$orderBy;
    }
    function oncia_Yield_skip($this) {
        return $this.$skip;
    }
    function oncia_Yield_limit($this) {
        return $this.$limit;
    }
    function oncia_Yield_where($this) {
        return $this.$where;
    }
    function oncia_Yield_position($this) {
        return $this.$position4;
    }
    function oncia_Yield_distinct($this) {
        return 0;
    }
    function oncia_Yield_name($this) {
        return $rt_s(1079);
    }
    function oncia_Yield_warnOnAccessToRestrictedVariableInOrderByOrWhere($this, $previousScopeVars, $error) {
        return $error;
    }
    function oncia_Yield_copy($this, $returnItems, $orderBy, $skip, $limit, $where, $position) {
        return oncia_Yield__init_0($returnItems, $orderBy, $skip, $limit, $where, $position);
    }
    function oncia_Yield_productPrefix($this) {
        return $rt_s(1080);
    }
    function oncia_Yield_productArity($this) {
        return 5;
    }
    function oncia_Yield_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$returnItems;
            case 1:
                return $this.$orderBy;
            case 2:
                return $this.$skip;
            case 3:
                return $this.$limit;
            case 4:
                return $this.$where;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_Yield_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_Yield_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_Yield_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_Yield_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Yield) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$returnItems;
                        var$3 = $x$1.$returnItems;
                        if (var$2 !== null) {
                            if (!oncia_ReturnItems_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$orderBy;
                        var$3 = $x$1.$orderBy;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$skip;
                        var$3 = $x$1.$skip;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$limit;
                        var$3 = $x$1.$limit;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$3 = $this.$where;
                        $x$1 = $x$1.$where;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break g;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Yield))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_Yield_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_Yield__init_($this, $returnItems, $orderBy, $skip, $limit, $where, $position) {
        $this.$returnItems = $returnItems;
        $this.$orderBy = $orderBy;
        $this.$skip = $skip;
        $this.$limit = $limit;
        $this.$where = $where;
        $this.$position4 = $position;
        oncia_Clause_$init$($this);
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0() {
        jl_Object.call(this);
        this.$_0299 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0__init_0(var$0, var$1) {
        var$0.$_0299 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0299, var$1);
    }
    function oncia_ShowPrivilegeCommands() {
        var a = this; jl_Object.call(a);
        a.$scope8 = null;
        a.$asRevoke0 = 0;
        a.$yieldOrWhere2 = null;
        a.$defaultColumnSet1 = null;
        a.$position44 = null;
        a.$isReadOnly0 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar1 = null;
    }
    function oncia_ShowPrivilegeCommands__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_ShowPrivilegeCommands();
        oncia_ShowPrivilegeCommands__init_0(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    function oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowPrivilegeCommands_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowPrivilegeCommands_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowPrivilegeCommands_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowPrivilegeCommands_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowPrivilegeCommands_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowPrivilegeCommands_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowPrivilegeCommands_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowPrivilegeCommands_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowPrivilegeCommands_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowPrivilegeCommands_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowPrivilegeCommands_foldedOver($this) {
        return $this;
    }
    function oncia_ShowPrivilegeCommands_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly0 = $x$1;
    }
    function oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar1;
    }
    function oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar1 = $x$1;
    }
    function oncia_ShowPrivilegeCommands_scope($this) {
        return $this.$scope8;
    }
    function oncia_ShowPrivilegeCommands_asRevoke($this) {
        return $this.$asRevoke0;
    }
    function oncia_ShowPrivilegeCommands_yieldOrWhere($this) {
        return $this.$yieldOrWhere2;
    }
    function oncia_ShowPrivilegeCommands_defaultColumnSet($this) {
        return $this.$defaultColumnSet1;
    }
    function oncia_ShowPrivilegeCommands_position($this) {
        return $this.$position44;
    }
    function oncia_ShowPrivilegeCommands_name($this) {
        return $rt_s(1081);
    }
    function oncia_ShowPrivilegeCommands_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowPrivilegeCommands_copy($this, $scope, $asRevoke, $yieldOrWhere, $defaultColumnSet, $position) {
        return oncia_ShowPrivilegeCommands__init_($scope, $asRevoke, $yieldOrWhere, $defaultColumnSet, $position);
    }
    function oncia_ShowPrivilegeCommands_copy$default$1($this) {
        return $this.$scope8;
    }
    function oncia_ShowPrivilegeCommands_copy$default$2($this) {
        return $this.$asRevoke0;
    }
    function oncia_ShowPrivilegeCommands_copy$default$4($this) {
        return $this.$defaultColumnSet1;
    }
    function oncia_ShowPrivilegeCommands_productPrefix($this) {
        return $rt_s(1082);
    }
    function oncia_ShowPrivilegeCommands_productArity($this) {
        return 4;
    }
    function oncia_ShowPrivilegeCommands_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope8;
            case 1:
                return jl_Boolean_valueOf($this.$asRevoke0);
            case 2:
                return $this.$yieldOrWhere2;
            case 3:
                return $this.$defaultColumnSet1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowPrivilegeCommands_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowPrivilegeCommands_hashCode($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1082))), sr_Statics_anyHash($this.$scope8)), !$this.$asRevoke0 ? 1237 : 1231), sr_Statics_anyHash($this.$yieldOrWhere2)), sr_Statics_anyHash($this.$defaultColumnSet1)), 4);
    }
    function oncia_ShowPrivilegeCommands_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowPrivilegeCommands_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowPrivilegeCommands) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$asRevoke0 != $x$1.$asRevoke0)
                            break b;
                        d: {
                            var$2 = $this.$scope8;
                            var$3 = $x$1.$scope8;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$yieldOrWhere2;
                            var$3 = $x$1.$yieldOrWhere2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumnSet1;
                        $x$1 = $x$1.$defaultColumnSet1;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowPrivilegeCommands_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowPrivilegeCommands_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowPrivilegeCommands__init_0($this, $scope, $asRevoke, $yieldOrWhere, $defaultColumnSet, $position) {
        $this.$scope8 = $scope;
        $this.$asRevoke0 = $asRevoke;
        $this.$yieldOrWhere2 = $yieldOrWhere;
        $this.$defaultColumnSet1 = $defaultColumnSet;
        $this.$position44 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1() {
        jl_Object.call(this);
        this.$_0300 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1__init_0(var$0, var$1) {
        var$0.$_0300 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0300, var$1);
    }
    function oncia_ShowSupportedPrivilegeCommand() {
        var a = this; jl_Object.call(a);
        a.$yieldOrWhere3 = null;
        a.$defaultColumnSet2 = null;
        a.$position45 = null;
        a.$isReadOnly1 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar2 = null;
    }
    function oncia_ShowSupportedPrivilegeCommand__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_ShowSupportedPrivilegeCommand();
        oncia_ShowSupportedPrivilegeCommand__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowSupportedPrivilegeCommand_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowSupportedPrivilegeCommand_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowSupportedPrivilegeCommand_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowSupportedPrivilegeCommand_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowSupportedPrivilegeCommand_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowSupportedPrivilegeCommand_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowSupportedPrivilegeCommand_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowSupportedPrivilegeCommand_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowSupportedPrivilegeCommand_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowSupportedPrivilegeCommand_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowSupportedPrivilegeCommand_foldedOver($this) {
        return $this;
    }
    function oncia_ShowSupportedPrivilegeCommand_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly1 = $x$1;
    }
    function oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar2;
    }
    function oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar2 = $x$1;
    }
    function oncia_ShowSupportedPrivilegeCommand_yieldOrWhere($this) {
        return $this.$yieldOrWhere3;
    }
    function oncia_ShowSupportedPrivilegeCommand_defaultColumnSet($this) {
        return $this.$defaultColumnSet2;
    }
    function oncia_ShowSupportedPrivilegeCommand_position($this) {
        return $this.$position45;
    }
    function oncia_ShowSupportedPrivilegeCommand_name($this) {
        return $rt_s(264);
    }
    function oncia_ShowSupportedPrivilegeCommand_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowSupportedPrivilegeCommand_copy($this, $yieldOrWhere, $defaultColumnSet, $position) {
        return oncia_ShowSupportedPrivilegeCommand__init_($yieldOrWhere, $defaultColumnSet, $position);
    }
    function oncia_ShowSupportedPrivilegeCommand_copy$default$2($this) {
        return $this.$defaultColumnSet2;
    }
    function oncia_ShowSupportedPrivilegeCommand_productPrefix($this) {
        return $rt_s(1083);
    }
    function oncia_ShowSupportedPrivilegeCommand_productArity($this) {
        return 2;
    }
    function oncia_ShowSupportedPrivilegeCommand_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$yieldOrWhere3;
            case 1:
                return $this.$defaultColumnSet2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowSupportedPrivilegeCommand_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowSupportedPrivilegeCommand_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowSupportedPrivilegeCommand_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowSupportedPrivilegeCommand_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowSupportedPrivilegeCommand) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$yieldOrWhere3;
                            var$3 = $x$1.$yieldOrWhere3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumnSet2;
                        $x$1 = $x$1.$defaultColumnSet2;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowSupportedPrivilegeCommand_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowSupportedPrivilegeCommand_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowSupportedPrivilegeCommand__init_0($this, $yieldOrWhere, $defaultColumnSet, $position) {
        $this.$yieldOrWhere3 = $yieldOrWhere;
        $this.$defaultColumnSet2 = $defaultColumnSet;
        $this.$position45 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2() {
        jl_Object.call(this);
        this.$_0301 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2__init_0(var$0, var$1) {
        var$0.$_0301 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0301, var$1);
    }
    function oncia_ShowDatabase() {
        var a = this; jl_Object.call(a);
        a.$scope9 = null;
        a.$yieldOrWhere4 = null;
        a.$defaultColumns = null;
        a.$position46 = null;
        a.$defaultColumnSet3 = null;
        a.$isReadOnly2 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar3 = null;
    }
    function oncia_ShowDatabase__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_ShowDatabase();
        oncia_ShowDatabase__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function oncia_ShowDatabase_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowDatabase_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowDatabase_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowDatabase_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowDatabase_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowDatabase_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowDatabase_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowDatabase_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowDatabase_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowDatabase_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowDatabase_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowDatabase_foldedOver($this) {
        return $this;
    }
    function oncia_ShowDatabase_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowDatabase_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly2 = $x$1;
    }
    function oncia_ShowDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar3;
    }
    function oncia_ShowDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar3 = $x$1;
    }
    function oncia_ShowDatabase_scope($this) {
        return $this.$scope9;
    }
    function oncia_ShowDatabase_yieldOrWhere($this) {
        return $this.$yieldOrWhere4;
    }
    function oncia_ShowDatabase_position($this) {
        return $this.$position46;
    }
    function oncia_ShowDatabase_defaultColumnSet($this) {
        return $this.$defaultColumnSet3;
    }
    function oncia_ShowDatabase_name($this) {
        var var$1;
        var$1 = $this.$scope9;
        if (var$1 instanceof oncia_SingleNamedDatabaseScope)
            return $rt_s(1084);
        if (var$1 instanceof oncia_AllDatabasesScope ? 1 : !(var$1 instanceof oncia_NamedDatabasesScope) ? 0 : 1)
            return $rt_s(1085);
        if (var$1 instanceof oncia_DefaultDatabaseScope)
            return $rt_s(1086);
        if (var$1 instanceof oncia_HomeDatabaseScope)
            return $rt_s(1087);
        $rt_throw(s_MatchError__init_(var$1));
    }
    function oncia_ShowDatabase_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowDatabase_copy($this, $scope, $yieldOrWhere, $defaultColumns, $position) {
        return oncia_ShowDatabase__init_($scope, $yieldOrWhere, $defaultColumns, $position);
    }
    function oncia_ShowDatabase_copy$default$1($this) {
        return $this.$scope9;
    }
    function oncia_ShowDatabase_copy$default$3($this) {
        return $this.$defaultColumns;
    }
    function oncia_ShowDatabase_productPrefix($this) {
        return $rt_s(1088);
    }
    function oncia_ShowDatabase_productArity($this) {
        return 3;
    }
    function oncia_ShowDatabase_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope9;
            case 1:
                return $this.$yieldOrWhere4;
            case 2:
                return $this.$defaultColumns;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowDatabase_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowDatabase_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowDatabase_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowDatabase_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowDatabase) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$scope9;
                            var$3 = $x$1.$scope9;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$yieldOrWhere4;
                            var$3 = $x$1.$yieldOrWhere4;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumns;
                        $x$1 = $x$1.$defaultColumns;
                        if (var$3 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowDatabase_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowDatabase_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowDatabase__init_0($this, $scope, $yieldOrWhere, $defaultColumns, $position) {
        $this.$scope9 = $scope;
        $this.$yieldOrWhere4 = $yieldOrWhere;
        $this.$defaultColumns = $defaultColumns;
        $this.$position46 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
        $this.$defaultColumnSet3 = $defaultColumns.$columns0;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3() {
        jl_Object.call(this);
        this.$_0302 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3__init_0(var$0, var$1) {
        var$0.$_0302 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0302, var$1);
    }
    function oncia_ShowAliases() {
        var a = this; jl_Object.call(a);
        a.$aliasName1 = null;
        a.$yieldOrWhere5 = null;
        a.$defaultColumns0 = null;
        a.$position47 = null;
        a.$defaultColumnSet4 = null;
        a.$isReadOnly3 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar4 = null;
    }
    function oncia_ShowAliases__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_ShowAliases();
        oncia_ShowAliases__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function oncia_ShowAliases_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowAliases_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowAliases_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowAliases_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowAliases_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowAliases_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowAliases_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowAliases_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowAliases_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowAliases_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowAliases_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowAliases_foldedOver($this) {
        return $this;
    }
    function oncia_ShowAliases_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowAliases_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly3 = $x$1;
    }
    function oncia_ShowAliases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar4;
    }
    function oncia_ShowAliases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar4 = $x$1;
    }
    function oncia_ShowAliases_aliasName($this) {
        return $this.$aliasName1;
    }
    function oncia_ShowAliases_yieldOrWhere($this) {
        return $this.$yieldOrWhere5;
    }
    function oncia_ShowAliases_position($this) {
        return $this.$position47;
    }
    function oncia_ShowAliases_defaultColumnSet($this) {
        return $this.$defaultColumnSet4;
    }
    function oncia_ShowAliases_name($this) {
        var var$1;
        var$1 = $this.$aliasName1;
        if (jl_Object_equals(s_None$_MODULE$, var$1))
            return $rt_s(1089);
        if (var$1 instanceof s_Some)
            return $rt_s(1090);
        $rt_throw(s_MatchError__init_(var$1));
    }
    function oncia_ShowAliases_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowAliases_copy($this, $aliasName, $yieldOrWhere, $defaultColumns, $position) {
        return oncia_ShowAliases__init_($aliasName, $yieldOrWhere, $defaultColumns, $position);
    }
    function oncia_ShowAliases_copy$default$1($this) {
        return $this.$aliasName1;
    }
    function oncia_ShowAliases_copy$default$3($this) {
        return $this.$defaultColumns0;
    }
    function oncia_ShowAliases_productPrefix($this) {
        return $rt_s(1091);
    }
    function oncia_ShowAliases_productArity($this) {
        return 3;
    }
    function oncia_ShowAliases_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$aliasName1;
            case 1:
                return $this.$yieldOrWhere5;
            case 2:
                return $this.$defaultColumns0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowAliases_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowAliases_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowAliases_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowAliases_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowAliases) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$aliasName1;
                            var$3 = $x$1.$aliasName1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$yieldOrWhere5;
                            var$3 = $x$1.$yieldOrWhere5;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumns0;
                        $x$1 = $x$1.$defaultColumns0;
                        if (var$3 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowAliases_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowAliases_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowAliases__init_0($this, $aliasName, $yieldOrWhere, $defaultColumns, $position) {
        $this.$aliasName1 = $aliasName;
        $this.$yieldOrWhere5 = $yieldOrWhere;
        $this.$defaultColumns0 = $defaultColumns;
        $this.$position47 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
        $this.$defaultColumnSet4 = $defaultColumns.$columns0;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4() {
        jl_Object.call(this);
        this.$_0303 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4__init_0(var$0, var$1) {
        var$0.$_0303 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0303, var$1);
    }
    function oncia_ShowCurrentUser() {
        var a = this; jl_Object.call(a);
        a.$yieldOrWhere6 = null;
        a.$defaultColumnSet5 = null;
        a.$position48 = null;
        a.$isReadOnly4 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar5 = null;
    }
    function oncia_ShowCurrentUser__init_0(var_0, var_1, var_2) {
        var var_3 = new oncia_ShowCurrentUser();
        oncia_ShowCurrentUser__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowCurrentUser_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowCurrentUser_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowCurrentUser_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowCurrentUser_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowCurrentUser_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowCurrentUser_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowCurrentUser_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowCurrentUser_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowCurrentUser_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowCurrentUser_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowCurrentUser_foldedOver($this) {
        return $this;
    }
    function oncia_ShowCurrentUser_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly4 = $x$1;
    }
    function oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar5;
    }
    function oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar5 = $x$1;
    }
    function oncia_ShowCurrentUser_yieldOrWhere($this) {
        return $this.$yieldOrWhere6;
    }
    function oncia_ShowCurrentUser_defaultColumnSet($this) {
        return $this.$defaultColumnSet5;
    }
    function oncia_ShowCurrentUser_position($this) {
        return $this.$position48;
    }
    function oncia_ShowCurrentUser_name($this) {
        return $rt_s(1092);
    }
    function oncia_ShowCurrentUser_semanticCheck($this) {
        return oncia_ReadAdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowCurrentUser_copy($this, $yieldOrWhere, $defaultColumnSet, $position) {
        return oncia_ShowCurrentUser__init_0($yieldOrWhere, $defaultColumnSet, $position);
    }
    function oncia_ShowCurrentUser_copy$default$2($this) {
        return $this.$defaultColumnSet5;
    }
    function oncia_ShowCurrentUser_productPrefix($this) {
        return $rt_s(1093);
    }
    function oncia_ShowCurrentUser_productArity($this) {
        return 2;
    }
    function oncia_ShowCurrentUser_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$yieldOrWhere6;
            case 1:
                return $this.$defaultColumnSet5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowCurrentUser_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowCurrentUser_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowCurrentUser_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowCurrentUser_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowCurrentUser) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$yieldOrWhere6;
                            var$3 = $x$1.$yieldOrWhere6;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumnSet5;
                        $x$1 = $x$1.$defaultColumnSet5;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowCurrentUser_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowCurrentUser_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowCurrentUser__init_($this, $yieldOrWhere, $defaultColumnSet, $position) {
        $this.$yieldOrWhere6 = $yieldOrWhere;
        $this.$defaultColumnSet5 = $defaultColumnSet;
        $this.$position48 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5() {
        jl_Object.call(this);
        this.$_0304 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5__init_0(var$0, var$1) {
        var$0.$_0304 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0304, var$1);
    }
    function oncia_ShowUsers() {
        var a = this; jl_Object.call(a);
        a.$yieldOrWhere7 = null;
        a.$defaultColumnSet6 = null;
        a.$position49 = null;
        a.$isReadOnly5 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar6 = null;
    }
    function oncia_ShowUsers__init_0(var_0, var_1, var_2) {
        var var_3 = new oncia_ShowUsers();
        oncia_ShowUsers__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_ShowUsers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowUsers_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowUsers_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowUsers_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowUsers_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowUsers_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowUsers_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowUsers_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowUsers_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowUsers_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowUsers_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowUsers_foldedOver($this) {
        return $this;
    }
    function oncia_ShowUsers_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowUsers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly5 = $x$1;
    }
    function oncia_ShowUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar6;
    }
    function oncia_ShowUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar6 = $x$1;
    }
    function oncia_ShowUsers_yieldOrWhere($this) {
        return $this.$yieldOrWhere7;
    }
    function oncia_ShowUsers_defaultColumnSet($this) {
        return $this.$defaultColumnSet6;
    }
    function oncia_ShowUsers_position($this) {
        return $this.$position49;
    }
    function oncia_ShowUsers_name($this) {
        return $rt_s(1094);
    }
    function oncia_ShowUsers_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowUsers_copy($this, $yieldOrWhere, $defaultColumnSet, $position) {
        return oncia_ShowUsers__init_0($yieldOrWhere, $defaultColumnSet, $position);
    }
    function oncia_ShowUsers_copy$default$2($this) {
        return $this.$defaultColumnSet6;
    }
    function oncia_ShowUsers_productPrefix($this) {
        return $rt_s(1095);
    }
    function oncia_ShowUsers_productArity($this) {
        return 2;
    }
    function oncia_ShowUsers_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$yieldOrWhere7;
            case 1:
                return $this.$defaultColumnSet6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowUsers_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowUsers_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowUsers_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowUsers_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowUsers) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$yieldOrWhere7;
                            var$3 = $x$1.$yieldOrWhere7;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumnSet6;
                        $x$1 = $x$1.$defaultColumnSet6;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowUsers_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowUsers_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowUsers__init_($this, $yieldOrWhere, $defaultColumnSet, $position) {
        $this.$yieldOrWhere7 = $yieldOrWhere;
        $this.$defaultColumnSet6 = $defaultColumnSet;
        $this.$position49 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6() {
        jl_Object.call(this);
        this.$_0305 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6__init_0(var$0, var$1) {
        var$0.$_0305 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0305, var$1);
    }
    function oncia_ShowRoles() {
        var a = this; jl_Object.call(a);
        a.$withUsers0 = 0;
        a.$showAll = 0;
        a.$yieldOrWhere8 = null;
        a.$defaultColumnSet7 = null;
        a.$position50 = null;
        a.$isReadOnly6 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar7 = null;
    }
    function oncia_ShowRoles__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_ShowRoles();
        oncia_ShowRoles__init_0(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    function oncia_ShowRoles_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowRoles_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowRoles_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowRoles_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowRoles_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowRoles_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowRoles_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowRoles_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowRoles_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowRoles_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowRoles_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowRoles_foldedOver($this) {
        return $this;
    }
    function oncia_ShowRoles_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowRoles_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly6 = $x$1;
    }
    function oncia_ShowRoles_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar7;
    }
    function oncia_ShowRoles_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar7 = $x$1;
    }
    function oncia_ShowRoles_withUsers($this) {
        return $this.$withUsers0;
    }
    function oncia_ShowRoles_yieldOrWhere($this) {
        return $this.$yieldOrWhere8;
    }
    function oncia_ShowRoles_defaultColumnSet($this) {
        return $this.$defaultColumnSet7;
    }
    function oncia_ShowRoles_position($this) {
        return $this.$position50;
    }
    function oncia_ShowRoles_name($this) {
        if (!$this.$showAll)
            return $rt_s(1096);
        return $rt_s(1097);
    }
    function oncia_ShowRoles_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowRoles_copy($this, $withUsers, $showAll, $yieldOrWhere, $defaultColumnSet, $position) {
        return oncia_ShowRoles__init_($withUsers, $showAll, $yieldOrWhere, $defaultColumnSet, $position);
    }
    function oncia_ShowRoles_copy$default$1($this) {
        return $this.$withUsers0;
    }
    function oncia_ShowRoles_copy$default$2($this) {
        return $this.$showAll;
    }
    function oncia_ShowRoles_copy$default$4($this) {
        return $this.$defaultColumnSet7;
    }
    function oncia_ShowRoles_productPrefix($this) {
        return $rt_s(1098);
    }
    function oncia_ShowRoles_productArity($this) {
        return 4;
    }
    function oncia_ShowRoles_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$withUsers0);
            case 1:
                return jl_Boolean_valueOf($this.$showAll);
            case 2:
                return $this.$yieldOrWhere8;
            case 3:
                return $this.$defaultColumnSet7;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowRoles_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowRoles_hashCode($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1098))), !$this.$withUsers0 ? 1237 : 1231), !$this.$showAll ? 1237 : 1231), sr_Statics_anyHash($this.$yieldOrWhere8)), sr_Statics_anyHash($this.$defaultColumnSet7)), 4);
    }
    function oncia_ShowRoles_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowRoles_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowRoles) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$withUsers0 != $x$1.$withUsers0)
                            break b;
                        if ($this.$showAll != $x$1.$showAll)
                            break b;
                        d: {
                            var$2 = $this.$yieldOrWhere8;
                            var$3 = $x$1.$yieldOrWhere8;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumnSet7;
                        $x$1 = $x$1.$defaultColumnSet7;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowRoles_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowRoles_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowRoles__init_0($this, $withUsers, $showAll, $yieldOrWhere, $defaultColumnSet, $position) {
        $this.$withUsers0 = $withUsers;
        $this.$showAll = $showAll;
        $this.$yieldOrWhere8 = $yieldOrWhere;
        $this.$defaultColumnSet7 = $defaultColumnSet;
        $this.$position50 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7() {
        jl_Object.call(this);
        this.$_0306 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7__init_0(var$0, var$1) {
        var$0.$_0306 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0306, var$1);
    }
    function oncia_ShowServers() {
        var a = this; jl_Object.call(a);
        a.$yieldOrWhere9 = null;
        a.$defaultColumns1 = null;
        a.$position51 = null;
        a.$defaultColumnSet8 = null;
        a.$isReadOnly7 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar8 = null;
    }
    function oncia_ShowServers__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_ShowServers();
        oncia_ShowServers__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_ShowServers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck($this) {
        return oncia_AdministrationCommand_semanticCheck$($this);
    }
    function oncia_ShowServers_defaultColumnNames($this) {
        return oncia_ReadAdministrationCommand_defaultColumnNames$($this);
    }
    function oncia_ShowServers_yields($this) {
        return oncia_ReadAdministrationCommand_yields$($this);
    }
    function oncia_ShowServers_returns($this) {
        return oncia_ReadAdministrationCommand_returns$($this);
    }
    function oncia_ShowServers_useGraph($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar();
    }
    function oncia_ShowServers_withGraph($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowServers_semanticCheckFold($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    }
    function oncia_ShowServers_declareVariable($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    }
    function oncia_ShowServers_recordCurrentScope($this, $astNode) {
        return oncias_SemanticAnalysisTooling_recordCurrentScope$($this, $astNode);
    }
    function oncia_ShowServers_requireFeatureSupport($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    }
    function oncia_ShowServers_error($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    }
    function oncia_ShowServers_foldedOver($this) {
        return $this;
    }
    function oncia_ShowServers_folder($this) {
        return onciu_Foldable_folder$($this);
    }
    function oncia_ShowServers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq($this, $x$1) {
        $this.$isReadOnly7 = $x$1;
    }
    function oncia_ShowServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar8;
    }
    function oncia_ShowServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar8 = $x$1;
    }
    function oncia_ShowServers_yieldOrWhere($this) {
        return $this.$yieldOrWhere9;
    }
    function oncia_ShowServers_position($this) {
        return $this.$position51;
    }
    function oncia_ShowServers_defaultColumnSet($this) {
        return $this.$defaultColumnSet8;
    }
    function oncia_ShowServers_name($this) {
        return $rt_s(1099);
    }
    function oncia_ShowServers_semanticCheck($this) {
        var var$1;
        var$1 = oncia_ReadAdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    }
    function oncia_ShowServers_copy($this, $yieldOrWhere, $defaultColumns, $position) {
        return oncia_ShowServers__init_($yieldOrWhere, $defaultColumns, $position);
    }
    function oncia_ShowServers_copy$default$2($this) {
        return $this.$defaultColumns1;
    }
    function oncia_ShowServers_productPrefix($this) {
        return $rt_s(1100);
    }
    function oncia_ShowServers_productArity($this) {
        return 2;
    }
    function oncia_ShowServers_productElement($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$yieldOrWhere9;
            case 1:
                return $this.$defaultColumns1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    }
    function oncia_ShowServers_productIterator($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowServers_hashCode($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowServers_toString($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    }
    function oncia_ShowServers_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowServers) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$yieldOrWhere9;
                            var$3 = $x$1.$yieldOrWhere9;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultColumns1;
                        $x$1 = $x$1.$defaultColumns1;
                        if (var$3 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    function oncia_ShowServers_dup($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    }
    function oncia_ShowServers_withGraph0($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    }
    function oncia_ShowServers__init_0($this, $yieldOrWhere, $defaultColumns, $position) {
        $this.$yieldOrWhere9 = $yieldOrWhere;
        $this.$defaultColumns1 = $defaultColumns;
        $this.$position51 = $position;
        oncia_AdministrationCommand_$init$($this);
        oncia_ReadAdministrationCommand_$init$($this);
        $this.$defaultColumnSet8 = $defaultColumns.$columns0;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8() {
        jl_Object.call(this);
        this.$_0307 = null;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8__init_(var_0) {
        var var_1 = new oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8();
        oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8__init_0(var_1, var_0);
        return var_1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8__init_0(var$0, var$1) {
        var$0.$_0307 = var$1;
    }
    function oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8_apply(var$0, var$1) {
        var$1 = var$1;
        return oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$0.$_0307, var$1);
    }
    function sr_ScalaRunTime$$anon$1() {
        var a = this; sc_AbstractIterator.call(a);
        a.$c1 = 0;
        a.$cmax = 0;
        a.$x$2 = null;
    }
    function sr_ScalaRunTime$$anon$1__init_(var_0) {
        var var_1 = new sr_ScalaRunTime$$anon$1();
        sr_ScalaRunTime$$anon$1__init_0(var_1, var_0);
        return var_1;
    }
    function sr_ScalaRunTime$$anon$1_hasNext($this) {
        if ($this.$c1 >= $this.$cmax)
            return 0;
        return 1;
    }
    function sr_ScalaRunTime$$anon$1_next($this) {
        var $result;
        $result = $this.$x$2.$productElement($this.$c1);
        $this.$c1 = $this.$c1 + 1 | 0;
        return $result;
    }
    function sr_ScalaRunTime$$anon$1__init_0($this, $x$2) {
        $this.$x$2 = $x$2;
        $this.$c1 = 0;
        $this.$cmax = $x$2.$productArity();
    }
    var sci_ListSet = $rt_classWithoutFields(sci_AbstractSet);
    function sci_ListSet_concat($this, $that) {
        var var$2, var$3;
        var$2 = $this;
        $that = $that.$iterator0();
        while ($that.$hasNext()) {
            var$3 = $that.$next();
            if (var$2 === null)
                $rt_throw(null);
            var$2 = var$2.$incl(var$3);
        }
        return var$2;
    }
    function sci_ListSet_partition($this, $p) {
        return sc_StrictOptimizedIterableOps_partition$($this, $p);
    }
    function sci_ListSet_map($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    }
    function sci_ListSet_flatMap($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    }
    function sci_ListSet_collect($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    }
    function sci_ListSet_flatten($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    }
    function sci_ListSet_filter($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    }
    function sci_ListSet_filterNot($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    }
    function sci_ListSet_filterImpl($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    }
    function sci_ListSet_dropRight($this, $n) {
        return sc_StrictOptimizedIterableOps_dropRight$($this, $n);
    }
    function sci_ListSet_className($this) {
        return $rt_s(1101);
    }
    function sci_ListSet_size($this) {
        return 0;
    }
    function sci_ListSet_isEmpty($this) {
        return 1;
    }
    function sci_ListSet_contains($this, $elem) {
        return 0;
    }
    function sci_ListSet_incl($this, $elem) {
        return sci_ListSet$Node__init_($this, $elem);
    }
    function sci_ListSet_excl($this, $elem) {
        return $this;
    }
    function sci_ListSet_iterator($this) {
        var $res;
        $res = sci_Nil$_MODULE$;
        while (!$this.$isEmpty()) {
            $res = sci_List_$colon$colon($res, $this.$elem7());
            $this = $this.$next7();
        }
        return $res.$iterator0();
    }
    function sci_ListSet_elem($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(1102));
        $rt_throw(var$1);
    }
    function sci_ListSet_next($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(1103));
        $rt_throw(var$1);
    }
    function sci_ListSet_iterableFactory($this) {
        return sci_ListSet$_MODULE$;
    }
    function sci_ListSet_concat0($this, $that) {
        return sci_ListSet_concat($this, $that);
    }
    function sci_ListSet_excl0($this, $elem) {
        return $this.$excl1($elem);
    }
    function sci_ListSet_incl0($this, $elem) {
        return $this.$incl1($elem);
    }
    var sci_ListSet$ = $rt_classWithoutFields();
    var sci_ListSet$_MODULE$ = null;
    function sci_ListSet$__clinit_() {
        sci_ListSet$_MODULE$ = new sci_ListSet$;
    }
    function sci_ListSet$_from($this, $it) {
        if ($it instanceof sci_ListSet)
            return $it;
        if (!$it.$knownSize())
            return sci_ListSet$EmptyListSet$_MODULE$;
        return (scm_Growable_addAll$(sci_ListSet$$anon$1__init_(), $it)).$result0();
    }
    function sci_ListSet$_newBuilder($this) {
        return sci_ListSet$$anon$1__init_();
    }
    function sci_ListSet$_from0($this, $source) {
        return sci_ListSet$_from($this, $source);
    }
    function onciu_Rewritable$$dupAny$lambda$_2_0() {
        jl_Object.call(this);
        this.$_0308 = null;
    }
    function onciu_Rewritable$$dupAny$lambda$_2_0__init_(var_0) {
        var var_1 = new onciu_Rewritable$$dupAny$lambda$_2_0();
        onciu_Rewritable$$dupAny$lambda$_2_0__init_0(var_1, var_0);
        return var_1;
    }
    function onciu_Rewritable$$dupAny$lambda$_2_0__init_0(var$0, var$1) {
        var$0.$_0308 = var$1;
    }
    function onciu_Rewritable$$dupAny$lambda$_2_0_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0308;
        if (var$1 !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, var$1);
            if (!var$1.$lengthCompare(2))
                return sci_MapBuilderImpl_addOne(var$2, s_Tuple2__init_(var$1.$apply1(0), var$1.$apply1(1)));
        }
        var$1 = new jl_IllegalStateException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    var onciu_RewritableCompat = $rt_classWithoutFields();
    function onciu_RewritableCompat_copyConstructor(var$1, var$2, var$3) {
        var var$4;
        a: {
            b: {
                c: {
                    d: {
                        e: {
                            f: {
                                g: {
                                    h: {
                                        i: {
                                            j: {
                                                k: {
                                                    l: {
                                                        m: {
                                                            n: {
                                                                o: {
                                                                    p: {
                                                                        q: {
                                                                            r: {
                                                                                s: {
                                                                                    t: {
                                                                                        u: {
                                                                                            v: {
                                                                                                w: {
                                                                                                    x: {
                                                                                                        y: {
                                                                                                            z: {
                                                                                                                ba: {
                                                                                                                    bb: {
                                                                                                                        bc: {
                                                                                                                            bd: {
                                                                                                                                be: {
                                                                                                                                    bf: {
                                                                                                                                        bg: {
                                                                                                                                            bh: {
                                                                                                                                                bi: {
                                                                                                                                                    bj: {
                                                                                                                                                        bk: {
                                                                                                                                                            bl: {
                                                                                                                                                                bm: {
                                                                                                                                                                    bn: {
                                                                                                                                                                        bo: {
                                                                                                                                                                            bp: {
                                                                                                                                                                                bq: {
                                                                                                                                                                                    br: {
                                                                                                                                                                                        bs: {
                                                                                                                                                                                            bt: {
                                                                                                                                                                                                bu: {
                                                                                                                                                                                                    bv: {
                                                                                                                                                                                                        bw: {
                                                                                                                                                                                                            bx: {
                                                                                                                                                                                                                by: {
                                                                                                                                                                                                                    bz: {
                                                                                                                                                                                                                        bA: {
                                                                                                                                                                                                                            bB: {
                                                                                                                                                                                                                                bC: {
                                                                                                                                                                                                                                    bD: {
                                                                                                                                                                                                                                        bE: {
                                                                                                                                                                                                                                            bF: {
                                                                                                                                                                                                                                                bG: {
                                                                                                                                                                                                                                                    bH: {
                                                                                                                                                                                                                                                        bI: {
                                                                                                                                                                                                                                                            bJ: {
                                                                                                                                                                                                                                                                bK: {
                                                                                                                                                                                                                                                                    bL: {
                                                                                                                                                                                                                                                                        bM: {
                                                                                                                                                                                                                                                                            bN: {
                                                                                                                                                                                                                                                                                bO: {
                                                                                                                                                                                                                                                                                    bP: {
                                                                                                                                                                                                                                                                                        bQ: {
                                                                                                                                                                                                                                                                                            bR: {
                                                                                                                                                                                                                                                                                                bS: {
                                                                                                                                                                                                                                                                                                    bT: {
                                                                                                                                                                                                                                                                                                        bU: {
                                                                                                                                                                                                                                                                                                            bV: {
                                                                                                                                                                                                                                                                                                                bW: {
                                                                                                                                                                                                                                                                                                                    bX: {
                                                                                                                                                                                                                                                                                                                        bY: {
                                                                                                                                                                                                                                                                                                                            bZ: {
                                                                                                                                                                                                                                                                                                                                b0: {
                                                                                                                                                                                                                                                                                                                                    b1: {
                                                                                                                                                                                                                                                                                                                                        b2: {
                                                                                                                                                                                                                                                                                                                                            b3: {
                                                                                                                                                                                                                                                                                                                                                b4: {
                                                                                                                                                                                                                                                                                                                                                    b5: {
                                                                                                                                                                                                                                                                                                                                                        b6: {
                                                                                                                                                                                                                                                                                                                                                            b7: {
                                                                                                                                                                                                                                                                                                                                                                b8: {
                                                                                                                                                                                                                                                                                                                                                                    b9: {
                                                                                                                                                                                                                                                                                                                                                                        b$: {
                                                                                                                                                                                                                                                                                                                                                                            b_: {
                                                                                                                                                                                                                                                                                                                                                                                ca: {
                                                                                                                                                                                                                                                                                                                                                                                    cb: {
                                                                                                                                                                                                                                                                                                                                                                                        cc: {
                                                                                                                                                                                                                                                                                                                                                                                            cd: {
                                                                                                                                                                                                                                                                                                                                                                                                ce: {
                                                                                                                                                                                                                                                                                                                                                                                                    cf: {
                                                                                                                                                                                                                                                                                                                                                                                                        cg: {
                                                                                                                                                                                                                                                                                                                                                                                                            ch: {
                                                                                                                                                                                                                                                                                                                                                                                                                ci: {
                                                                                                                                                                                                                                                                                                                                                                                                                    cj: {
                                                                                                                                                                                                                                                                                                                                                                                                                        ck: {
                                                                                                                                                                                                                                                                                                                                                                                                                            cl: {
                                                                                                                                                                                                                                                                                                                                                                                                                                cm: {
                                                                                                                                                                                                                                                                                                                                                                                                                                    cn: {
                                                                                                                                                                                                                                                                                                                                                                                                                                        co: {
                                                                                                                                                                                                                                                                                                                                                                                                                                            cp: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                cq: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    cr: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        cs: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            ct: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                cu: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cv: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cw: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cx: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cy: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cz: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cA: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cB: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cC: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cD: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cE: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cF: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cG: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cH: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cI: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cJ: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cK: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c0:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c1:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c2:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c3:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c4:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c5:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c6:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c7:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c8:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c9:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c$:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c_:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                da:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    db:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dc:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dd:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                de:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    df:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dg:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dh:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                di:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dj:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dk:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dl:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dm:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dn:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dp:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dq:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dr:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ds:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dt:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            du:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dv:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dw:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dx:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dy:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dz:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dA:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dB:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dC:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dD:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dE:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dF:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dG:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dH:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dI:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dJ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dK:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d0:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d1:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d2:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d3:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d4:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d5:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d6:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d7:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d8:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d9:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d$:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d_:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ea:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eb:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ec:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ed:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ee:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ef:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eg:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eh:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ei:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ej:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ek:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        el:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            em:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                en:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eo:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ep:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eq:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                er:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    es:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        et:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eu:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ev:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ew:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ex:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ey:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ez:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eA:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eB:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eC:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eD:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eE:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eF:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eG:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eH:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eI:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eJ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eK:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            e0:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                e1:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    e2:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$4
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        =
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        jl_Class_getName(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        switch
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (jl_String_hashCode(var$4))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 455596914:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -696583615:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break e2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 814608189:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break e1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1944844053:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break e0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -149837559:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -173726688:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 463217861:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1638198402:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1344819286:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1539521346:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1885430284:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1990238911:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1624236093:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1139703987:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 218162326:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2109905426:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1699139200:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 161043599:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 257300197:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1161986269:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1849450182:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2004672172:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1854989025:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1995730627:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -59220920:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -56818274:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1905747848:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 876306657:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 563302816:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1509369838:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -551872710:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ez;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -309054547:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ey;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 597069130:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ex;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1106883801:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ew;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -83434525:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ev;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 791743121:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -173726498:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break et;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1090567930:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break es;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -324525645:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break er;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 35532533:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 552142263:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ep;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1728481248:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eo;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 808140963:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break en;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 180309318:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break em;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1113043596:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break el;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 552536514:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ek;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1098373913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ej;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 171553019:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ei;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -690264973:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1956588185:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -185398452:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ef;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -354016038:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ee;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -547163946:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ed;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1697153532:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ec;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1836487610:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break eb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -124559559:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ea;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1298739788:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1505287241:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -527102827:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1375343095:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1687177394:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2107404354:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1252416461:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1971775404:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1143216060:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1836370035:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -57639779:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 386603235:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 140909333:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1111213695:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1539103505:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1875460719:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -974095529:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2008336743:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 767481184:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -446332315:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1846818353:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 25975226:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1869678611:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1672152040:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 933593450:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 2123943227:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -925030859:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1525448294:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 490543052:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 553477153:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 2021177853:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1032130721:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1399872522:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -101943729:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 68785030:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 630773776:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -382919541:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1036156617:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 44260601:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1053180719:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dy;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 941027000:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2097338776:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1838452428:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1430315311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break du;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1743234077:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dt;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1002775686:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ds;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1994092090:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dr;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1400223240:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1889018242:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 773610978:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 549588447:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1540596742:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 715403871:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dk;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 488962701:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 773878287:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break di;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -862437735:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1590622701:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 654843427:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break df;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -72889640:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break de;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 51139985:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1509467160:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break dc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -931686672:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break db;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1569671430:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break da;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1086375751:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -692014538:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1494021353:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1377215654:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1085962297:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1397478846:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1158862256:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 787353940:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1930616743:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1629866976:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1344230015:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 967704049:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2070218311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1651308197:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -601065917:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -946641608:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1363729583:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1131485948:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -937120067:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 257458495:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 608145466:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -361629069:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -14881129:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1148049014:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1887073695:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1903613124:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1743141064:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 345156959:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1384882995:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -721388032:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -391096479:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1942599922:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2013484445:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -335388913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1209682917:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 838435105:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 68878043:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -8013773:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 390701443:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1605005311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cy;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1087067473:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1131043253:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1167383453:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -769608440:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1845562242:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ct;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1400329004:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cs;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 825085381:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cr;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 224696041:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -766295774:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1814577755:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break co;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -212889784:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 2117196269:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1752564371:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 86719663:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ck;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 884425735:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1622751247:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ci;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 2111686605:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ch;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 185377688:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -921688526:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cf;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1553787535:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ce;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1087184836:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1092119273:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1388906993:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break cb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1734229172:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ca;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2128450866:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1555225207:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 2016921081:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1683547861:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -523752746:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1223363698:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 421974435:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1090555552:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2060497514:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -288223014:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1628021123:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 722610464:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -48137118:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -779711344:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 433120830:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -429840592:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1189054542:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1878523352:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -395643130:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1090555080:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1154925950:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 984874708:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 49269903:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 839143939:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1674145006:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1991860843:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1757559093:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -914850913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 2129483779:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 513352456:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1054021648:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1713437764:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -514003336:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 867259615:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 577543513:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 473626369:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -225666173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2109192114:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1319121459:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 893432812:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break by;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1137178901:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1605470032:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1090545472:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -424824043:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1040811906:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bt;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1367871194:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bs;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -165889114:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break br;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 935334798:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -213184938:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 737899923:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bo;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1231296631:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1818883748:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1090553155:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 41837598:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bk;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 979786518:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -419512299:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bi;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 953953403:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 44353614:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1588700173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bf;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 616494848:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break be;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1567771547:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1671927173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -677401976:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break bb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1522974895:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break ba;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 906154098:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break z;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1721669609:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break y;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 699450984:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break x;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -246593737:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break w;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 24898165:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break v;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -621882202:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break u;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -299067664:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break t;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 841414265:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break s;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1096497267:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break r;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -841884003:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break q;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -513789148:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break p;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1693229482:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break o;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 2136683676:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break n;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1684645191:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break m;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -17764532:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break l;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 736006033:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break k;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 552712649:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break j;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -160977132:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break i;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -493082050:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break h;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1996487587:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break g;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 250317358:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break f;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 342871275:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break e;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case 1876558156:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break d;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -2068787732:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break c;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            case -1090567620:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break b;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            default:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1104)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_136_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1105)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_594_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1106)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_544_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1107)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_890_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1108)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_168_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1109)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_745_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1110)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_170_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1111)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_359_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1112)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_169_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1113)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_384_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1114)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_850_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1115)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_895_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1116)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_226_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1117)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_464_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1118)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_230_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1119)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_423_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1120)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_721_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1121)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_750_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1122)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_747_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1123)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_412_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1124)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_469_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1125)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_228_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1126)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_435_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1127)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_593_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1128)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_150_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1129)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_366_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1130)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_894_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1131)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_163_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1132)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_222_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1133)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_240_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1134)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_434_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1135)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_893_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1136)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_612_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1137)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_237_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1138)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_251_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1139)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_379_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1140)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_132_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1141)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_729_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1142)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_201_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1143)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_355_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1144)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_591_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1145)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_548_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1146)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_856_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1147)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_129_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1148)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_466_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1149)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_516_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1150)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_124_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1151)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_141_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1152)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_545_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1153)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_716_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1154)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_931_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1155)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_738_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1156)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_884_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1157)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_557_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1158)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_138_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1159)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_603_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1160)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_142_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1161)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_416_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1162)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_748_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1163)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_438_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1164)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_731_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1165)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_702_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1166)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_259_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1167)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_549_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1168)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_472_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1169)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_396_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1170)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_873_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1171)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_525_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1172)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_561_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1173)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_257_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1174)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_613_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1175)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_719_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1176)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_386_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1177)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_380_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1178)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_221_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1179)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_231_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1180)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_709_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1181)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_290_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1182)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_536_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1183)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_948_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1184)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_543_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1185)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_166_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1186)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_914_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1187)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_389_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1188)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_189_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1189)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_235_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1190)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_186_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1191)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_590_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1192)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_470_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1193)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_173_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1194)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_239_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1195)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_846_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1196)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_241_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1197)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_197_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1198)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_539_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1199)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_223_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1200)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_254_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1201)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_538_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1202)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_372_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1203)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_477_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1204)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_555_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1205)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_256_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1206)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_496_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1207)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_622_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1208)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_550_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1209)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_759_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1210)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_243_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1211)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_154_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1212)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_541_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1213)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_558_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1214)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_624_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1215)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_614_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1216)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_218_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1217)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_382_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1218)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_751_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1219)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_369_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1220)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_851_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1221)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_181_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1222)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_242_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1223)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_375_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1224)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_752_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1225)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_609_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1226)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_928_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1227)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_930_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1228)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_621_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1229)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_974_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1230)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_377_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1231)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_756_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1232)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_497_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1233)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_200_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1234)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_373_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1235)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_727_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1236)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_535_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1237)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_534_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1238)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_378_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1239)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_610_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1240)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_126_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1241)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_562_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1242)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_164_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1243)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_975_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1244)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_171_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1245)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_560_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1246)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_418_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1247)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_439_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1248)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_461_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1249)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_564_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1250)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_165_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1251)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_553_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1252)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_374_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1253)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_422_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1254)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_584_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1255)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_371_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1256)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_174_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1257)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_611_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1258)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_861_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1259)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_238_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1260)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_554_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1261)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_147_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1262)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_757_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1263)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_183_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1264)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_623_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1265)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_625_copyConstructor(var$1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1266)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_626_copyConstructor(var$1, var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1267)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_551_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1268)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_556_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1269)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_413_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1270)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_357_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1271)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_529_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1272)))
                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_617_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1273)))
                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_533_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1274)))
                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_619_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1275)))
                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_701_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1276)))
                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_885_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1277)))
                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_388_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1278)))
                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_854_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1279)))
                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_493_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1280)))
                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_563_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1281)))
                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_754_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1282)))
                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_364_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1283)))
                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_184_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1284)))
                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_498_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1285)))
                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_949_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1286)))
                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_742_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1287)))
                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_589_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1288)))
                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_130_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1289)))
                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_249_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1290)))
                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_755_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1291)))
                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_188_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1292)))
                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_859_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1293)))
                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_929_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1294)))
                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_514_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1295)))
                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_627_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1296)))
                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_542_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1297)))
                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_224_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1298)))
                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_232_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1299)))
                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_137_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1300)))
                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_133_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1301)))
                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_714_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1302)))
                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_157_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1303)))
                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_215_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1304)))
                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_599_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1305)))
                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_552_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1306)))
                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_419_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1307)))
                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_162_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1308)))
                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_229_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1309)))
                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_234_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1310)))
                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_363_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1311)))
                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_615_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1312)))
                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_476_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1313)))
                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_161_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1314)))
                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_182_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1315)))
                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_219_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1316)))
                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_167_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1317)))
                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_255_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1318)))
                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_216_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1319)))
                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_185_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1320)))
                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_853_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1321)))
                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_977_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1322)))
                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_417_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1323)))
                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_620_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1324)))
                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_362_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1325)))
                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_467_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                                }
                                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1326)))
                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_128_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                            }
                                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1327)))
                                                                                                                                                                                                                break a;
                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_365_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                        }
                                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1328)))
                                                                                                                                                                                                            break a;
                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_546_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                    }
                                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1329)))
                                                                                                                                                                                                        break a;
                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_190_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                                }
                                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1330)))
                                                                                                                                                                                                    break a;
                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_744_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                            }
                                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1331)))
                                                                                                                                                                                                break a;
                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_420_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                        }
                                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1332)))
                                                                                                                                                                                            break a;
                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_134_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                    }
                                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1333)))
                                                                                                                                                                                        break a;
                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_713_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                                }
                                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1334)))
                                                                                                                                                                                    break a;
                                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_547_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                            }
                                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1335)))
                                                                                                                                                                                break a;
                                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_199_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                        }
                                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1336)))
                                                                                                                                                                            break a;
                                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_616_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                    }
                                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1337)))
                                                                                                                                                                        break a;
                                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_353_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                                }
                                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1338)))
                                                                                                                                                                    break a;
                                                                                                                                                                return onciu_RewritableCompat$PROXY$3_227_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                            }
                                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1339)))
                                                                                                                                                                break a;
                                                                                                                                                            return onciu_RewritableCompat$PROXY$3_866_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                        }
                                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1340)))
                                                                                                                                                            break a;
                                                                                                                                                        return onciu_RewritableCompat$PROXY$3_214_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                    }
                                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1341)))
                                                                                                                                                        break a;
                                                                                                                                                    return onciu_RewritableCompat$PROXY$3_855_copyConstructor(var$1, var$2, var$3);
                                                                                                                                                }
                                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1342)))
                                                                                                                                                    break a;
                                                                                                                                                return onciu_RewritableCompat$PROXY$3_187_copyConstructor(var$1, var$2, var$3);
                                                                                                                                            }
                                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1343)))
                                                                                                                                                break a;
                                                                                                                                            return onciu_RewritableCompat$PROXY$3_236_copyConstructor(var$1, var$2, var$3);
                                                                                                                                        }
                                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1344)))
                                                                                                                                            break a;
                                                                                                                                        return onciu_RewritableCompat$PROXY$3_559_copyConstructor(var$1, var$2, var$3);
                                                                                                                                    }
                                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1345)))
                                                                                                                                        break a;
                                                                                                                                    return onciu_RewritableCompat$PROXY$3_858_copyConstructor(var$1, var$2, var$3);
                                                                                                                                }
                                                                                                                                if (!jl_String_equals(var$4, $rt_s(1346)))
                                                                                                                                    break a;
                                                                                                                                return onciu_RewritableCompat$PROXY$3_383_copyConstructor(var$1, var$2, var$3);
                                                                                                                            }
                                                                                                                            if (!jl_String_equals(var$4, $rt_s(1347)))
                                                                                                                                break a;
                                                                                                                            return onciu_RewritableCompat$PROXY$3_963_copyConstructor(var$1, var$2, var$3);
                                                                                                                        }
                                                                                                                        if (!jl_String_equals(var$4, $rt_s(1348)))
                                                                                                                            break a;
                                                                                                                        return onciu_RewritableCompat$PROXY$3_537_copyConstructor(var$1, var$2, var$3);
                                                                                                                    }
                                                                                                                    if (!jl_String_equals(var$4, $rt_s(1349)))
                                                                                                                        break a;
                                                                                                                    return onciu_RewritableCompat$PROXY$3_391_copyConstructor(var$1, var$2, var$3);
                                                                                                                }
                                                                                                                if (!jl_String_equals(var$4, $rt_s(1350)))
                                                                                                                    break a;
                                                                                                                return onciu_RewritableCompat$PROXY$3_217_copyConstructor(var$1, var$2, var$3);
                                                                                                            }
                                                                                                            if (!jl_String_equals(var$4, $rt_s(1351)))
                                                                                                                break a;
                                                                                                            return onciu_RewritableCompat$PROXY$3_468_copyConstructor(var$1, var$2, var$3);
                                                                                                        }
                                                                                                        if (!jl_String_equals(var$4, $rt_s(1352)))
                                                                                                            break a;
                                                                                                        return onciu_RewritableCompat$PROXY$3_202_copyConstructor(var$1, var$2, var$3);
                                                                                                    }
                                                                                                    if (!jl_String_equals(var$4, $rt_s(1353)))
                                                                                                        break a;
                                                                                                    return onciu_RewritableCompat$PROXY$3_540_copyConstructor(var$1, var$2, var$3);
                                                                                                }
                                                                                                if (!jl_String_equals(var$4, $rt_s(1354)))
                                                                                                    break a;
                                                                                                return onciu_RewritableCompat$PROXY$3_463_copyConstructor(var$1, var$2, var$3);
                                                                                            }
                                                                                            if (!jl_String_equals(var$4, $rt_s(1355)))
                                                                                                break a;
                                                                                            return onciu_RewritableCompat$PROXY$3_437_copyConstructor(var$1, var$2, var$3);
                                                                                        }
                                                                                        if (!jl_String_equals(var$4, $rt_s(1356)))
                                                                                            break a;
                                                                                        return onciu_RewritableCompat$PROXY$3_526_copyConstructor(var$1, var$2, var$3);
                                                                                    }
                                                                                    if (!jl_String_equals(var$4, $rt_s(1357)))
                                                                                        break a;
                                                                                    return onciu_RewritableCompat$PROXY$3_618_copyConstructor(var$1, var$2, var$3);
                                                                                }
                                                                                if (!jl_String_equals(var$4, $rt_s(1358)))
                                                                                    break a;
                                                                                return onciu_RewritableCompat$PROXY$3_361_copyConstructor(var$1, var$2, var$3);
                                                                            }
                                                                            if (!jl_String_equals(var$4, $rt_s(1359)))
                                                                                break a;
                                                                            return onciu_RewritableCompat$PROXY$3_225_copyConstructor(var$1, var$2, var$3);
                                                                        }
                                                                        if (!jl_String_equals(var$4, $rt_s(1360)))
                                                                            break a;
                                                                        return onciu_RewritableCompat$PROXY$3_608_copyConstructor(var$1, var$2, var$3);
                                                                    }
                                                                    if (!jl_String_equals(var$4, $rt_s(1361)))
                                                                        break a;
                                                                    return onciu_RewritableCompat$PROXY$3_139_copyConstructor(var$1, var$2, var$3);
                                                                }
                                                                if (!jl_String_equals(var$4, $rt_s(1362)))
                                                                    break a;
                                                                return onciu_RewritableCompat$PROXY$3_394_copyConstructor(var$1, var$2, var$3);
                                                            }
                                                            if (!jl_String_equals(var$4, $rt_s(1363)))
                                                                break a;
                                                            return onciu_RewritableCompat$PROXY$3_950_copyConstructor(var$1, var$2, var$3);
                                                        }
                                                        if (!jl_String_equals(var$4, $rt_s(1364)))
                                                            break a;
                                                        return onciu_RewritableCompat$PROXY$3_211_copyConstructor(var$1, var$2, var$3);
                                                    }
                                                    if (!jl_String_equals(var$4, $rt_s(1365)))
                                                        break a;
                                                    return onciu_RewritableCompat$PROXY$3_485_copyConstructor(var$1, var$2, var$3);
                                                }
                                                if (!jl_String_equals(var$4, $rt_s(1366)))
                                                    break a;
                                                return onciu_RewritableCompat$PROXY$3_946_copyConstructor(var$1, var$2, var$3);
                                            }
                                            if (!jl_String_equals(var$4, $rt_s(1367)))
                                                break a;
                                            return onciu_RewritableCompat$PROXY$3_515_copyConstructor(var$1, var$2, var$3);
                                        }
                                        if (!jl_String_equals(var$4, $rt_s(1368)))
                                            break a;
                                        return onciu_RewritableCompat$PROXY$3_758_copyConstructor(var$1, var$2, var$3);
                                    }
                                    if (!jl_String_equals(var$4, $rt_s(1369)))
                                        break a;
                                    return onciu_RewritableCompat$PROXY$3_193_copyConstructor(var$1, var$2, var$3);
                                }
                                if (!jl_String_equals(var$4, $rt_s(1370)))
                                    break a;
                                return onciu_RewritableCompat$PROXY$3_886_copyConstructor(var$1, var$2, var$3);
                            }
                            if (!jl_String_equals(var$4, $rt_s(1371)))
                                break a;
                            return onciu_RewritableCompat$PROXY$3_358_copyConstructor(var$1, var$2, var$3);
                        }
                        if (!jl_String_equals(var$4, $rt_s(1372)))
                            break a;
                        return onciu_RewritableCompat$PROXY$3_367_copyConstructor(var$1, var$2, var$3);
                    }
                    if (!jl_String_equals(var$4, $rt_s(1373)))
                        break a;
                    return onciu_RewritableCompat$PROXY$3_390_copyConstructor(var$1, var$2, var$3);
                }
                if (!jl_String_equals(var$4, $rt_s(1374)))
                    break a;
                return onciu_RewritableCompat$PROXY$3_735_copyConstructor(var$1, var$2, var$3);
            }
            if (jl_String_equals(var$4, $rt_s(1375)))
                return onciu_RewritableCompat$PROXY$3_233_copyConstructor(var$1, var$2, var$3);
        }
        return null;
    }
    function onciu_RewritableCompat_paramsLength(var$1) {
        var var$2;
        a: {
            b: {
                c: {
                    d: {
                        e: {
                            f: {
                                g: {
                                    h: {
                                        i: {
                                            j: {
                                                k: {
                                                    l: {
                                                        m: {
                                                            n: {
                                                                o: {
                                                                    p: {
                                                                        q: {
                                                                            r: {
                                                                                s: {
                                                                                    t: {
                                                                                        u: {
                                                                                            v: {
                                                                                                w: {
                                                                                                    x: {
                                                                                                        y: {
                                                                                                            z: {
                                                                                                                ba: {
                                                                                                                    bb: {
                                                                                                                        bc: {
                                                                                                                            bd: {
                                                                                                                                be: {
                                                                                                                                    bf: {
                                                                                                                                        bg: {
                                                                                                                                            bh: {
                                                                                                                                                bi: {
                                                                                                                                                    bj: {
                                                                                                                                                        bk: {
                                                                                                                                                            bl: {
                                                                                                                                                                bm: {
                                                                                                                                                                    bn: {
                                                                                                                                                                        bo: {
                                                                                                                                                                            bp: {
                                                                                                                                                                                bq: {
                                                                                                                                                                                    br: {
                                                                                                                                                                                        bs: {
                                                                                                                                                                                            bt: {
                                                                                                                                                                                                bu: {
                                                                                                                                                                                                    bv: {
                                                                                                                                                                                                        bw: {
                                                                                                                                                                                                            bx: {
                                                                                                                                                                                                                by: {
                                                                                                                                                                                                                    bz: {
                                                                                                                                                                                                                        bA: {
                                                                                                                                                                                                                            bB: {
                                                                                                                                                                                                                                bC: {
                                                                                                                                                                                                                                    bD: {
                                                                                                                                                                                                                                        bE: {
                                                                                                                                                                                                                                            bF: {
                                                                                                                                                                                                                                                bG: {
                                                                                                                                                                                                                                                    bH: {
                                                                                                                                                                                                                                                        bI: {
                                                                                                                                                                                                                                                            bJ: {
                                                                                                                                                                                                                                                                bK: {
                                                                                                                                                                                                                                                                    bL: {
                                                                                                                                                                                                                                                                        bM: {
                                                                                                                                                                                                                                                                            bN: {
                                                                                                                                                                                                                                                                                bO: {
                                                                                                                                                                                                                                                                                    bP: {
                                                                                                                                                                                                                                                                                        bQ: {
                                                                                                                                                                                                                                                                                            bR: {
                                                                                                                                                                                                                                                                                                bS: {
                                                                                                                                                                                                                                                                                                    bT: {
                                                                                                                                                                                                                                                                                                        bU: {
                                                                                                                                                                                                                                                                                                            bV: {
                                                                                                                                                                                                                                                                                                                bW: {
                                                                                                                                                                                                                                                                                                                    bX: {
                                                                                                                                                                                                                                                                                                                        bY: {
                                                                                                                                                                                                                                                                                                                            bZ: {
                                                                                                                                                                                                                                                                                                                                b0: {
                                                                                                                                                                                                                                                                                                                                    b1: {
                                                                                                                                                                                                                                                                                                                                        b2: {
                                                                                                                                                                                                                                                                                                                                            b3: {
                                                                                                                                                                                                                                                                                                                                                b4: {
                                                                                                                                                                                                                                                                                                                                                    b5: {
                                                                                                                                                                                                                                                                                                                                                        b6: {
                                                                                                                                                                                                                                                                                                                                                            b7: {
                                                                                                                                                                                                                                                                                                                                                                b8: {
                                                                                                                                                                                                                                                                                                                                                                    b9: {
                                                                                                                                                                                                                                                                                                                                                                        b$: {
                                                                                                                                                                                                                                                                                                                                                                            b_: {
                                                                                                                                                                                                                                                                                                                                                                                ca: {
                                                                                                                                                                                                                                                                                                                                                                                    cb: {
                                                                                                                                                                                                                                                                                                                                                                                        cc: {
                                                                                                                                                                                                                                                                                                                                                                                            cd: {
                                                                                                                                                                                                                                                                                                                                                                                                ce: {
                                                                                                                                                                                                                                                                                                                                                                                                    cf: {
                                                                                                                                                                                                                                                                                                                                                                                                        cg: {
                                                                                                                                                                                                                                                                                                                                                                                                            ch: {
                                                                                                                                                                                                                                                                                                                                                                                                                ci: {
                                                                                                                                                                                                                                                                                                                                                                                                                    cj: {
                                                                                                                                                                                                                                                                                                                                                                                                                        ck: {
                                                                                                                                                                                                                                                                                                                                                                                                                            cl: {
                                                                                                                                                                                                                                                                                                                                                                                                                                cm: {
                                                                                                                                                                                                                                                                                                                                                                                                                                    cn: {
                                                                                                                                                                                                                                                                                                                                                                                                                                        co: {
                                                                                                                                                                                                                                                                                                                                                                                                                                            cp: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                cq: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    cr: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        cs: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            ct: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                cu: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cv: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cw: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cx: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cy: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cz: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cA: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cB: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cC: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cD: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cE: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cF: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cG: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cH: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cI: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cJ: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cK: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c0:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c1:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c2:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c3:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c4:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c5:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c6:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c7:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c8:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c9:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c$:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c_:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                da:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    db:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dc:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dd:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                de:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    df:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dg:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dh:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                di:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dj:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dk:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dl:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dm:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dn:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dp:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dq:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dr:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ds:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dt:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            du:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dv:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dw:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dx:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dy:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dz:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dA:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dB:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dC:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dD:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dE:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dF:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dG:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dH:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dI:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dJ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dK:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d0:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d1:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d2:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d3:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d4:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d5:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d6:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d7:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d8:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d9:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d$:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d_:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ea:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eb:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ec:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ed:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ee:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ef:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eg:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eh:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ei:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ej:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ek:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        el:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            em:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                en:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eo:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ep:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eq:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                er:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    es:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        et:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eu:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ev:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ew:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ex:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ey:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ez:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eA:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eB:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eC:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eD:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eE:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eF:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eG:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eH:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eI:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eJ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eK:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            =
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            jl_Class_getName(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            switch
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (jl_String_hashCode(var$2))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 455596914:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -696583615:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 814608189:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1944844053:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -149837559:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -173726688:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 463217861:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1638198402:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1344819286:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1539521346:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1885430284:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1990238911:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1624236093:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1139703987:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 218162326:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1699139200:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 161043599:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 257300197:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1161986269:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1849450182:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2004672172:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1854989025:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1995730627:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -59220920:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -56818274:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1905747848:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 876306657:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 563302816:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ez;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1509369838:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ey;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -551872710:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ex;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -309054547:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ew;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 597069130:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ev;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -83434525:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1106883801:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break et;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 791743121:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break es;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -173726498:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break er;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090567930:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -324525645:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ep;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 35532533:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eo;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 552142263:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break en;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1728481248:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break em;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 808140963:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break el;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 180309318:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ek;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 552536514:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ej;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1113043596:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ei;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1098373913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 171553019:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -690264973:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ef;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1956588185:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ee;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -185398452:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ed;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -354016038:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ec;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -547163946:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1697153532:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ea;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1836487610:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -124559559:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1298739788:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1505287241:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -527102827:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1375343095:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1687177394:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2107404354:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1252416461:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1971775404:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1143216060:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1836370035:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -57639779:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 386603235:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 140909333:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1111213695:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1539103505:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1875460719:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -974095529:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2008336743:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 767481184:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -446332315:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1846818353:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 25975226:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1869678611:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1672152040:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 933593450:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2123943227:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -925030859:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1525448294:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 490543052:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 553477153:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2021177853:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1032130721:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1399872522:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -101943729:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 68785030:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 630773776:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -382919541:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1036156617:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dy;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 44260601:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1053180719:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 941027000:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2097338776:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break du;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1430315311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dt;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1838452428:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ds;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1743234077:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dr;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1002775686:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1994092090:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1400223240:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1889018242:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 773610978:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 549588447:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dk;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1540596742:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 715403871:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break di;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 488962701:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 773878287:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -862437735:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break df;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1590622701:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break de;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 654843427:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -72889640:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 51139985:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break db;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1509467160:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break da;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -931686672:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1569671430:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1086375751:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -692014538:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1494021353:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1377215654:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1085962297:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1397478846:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1158862256:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 787353940:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1930616743:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1629866976:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1344230015:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 967704049:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2070218311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1651308197:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -601065917:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -946641608:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1363729583:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1131485948:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -937120067:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 257458495:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 608145466:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -361629069:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -14881129:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1887073695:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1903613124:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1743141064:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 345156959:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1384882995:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -721388032:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -391096479:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1942599922:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2013484445:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -335388913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1209682917:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 838435105:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 68878043:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -8013773:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 390701443:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cy;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1605005311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1087067473:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1131043253:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1167383453:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -769608440:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ct;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1400329004:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cs;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1845562242:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cr;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 825085381:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 224696041:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -766295774:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break co;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1814577755:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2117196269:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -212889784:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1752564371:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ck;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 86719663:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 884425735:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ci;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1622751247:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ch;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2111686605:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 185377688:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cf;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -921688526:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ce;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1553787535:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1087184836:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1092119273:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1388906993:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ca;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1734229172:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2128450866:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2016921081:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1555225207:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1683547861:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -523752746:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1223363698:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 421974435:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090555552:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2060497514:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -288223014:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1628021123:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 722610464:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -48137118:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -779711344:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 433120830:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -429840592:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1189054542:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1878523352:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -395643130:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090555080:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1154925950:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 984874708:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 49269903:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 839143939:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1674145006:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1991860843:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1757559093:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -914850913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2129483779:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 513352456:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1054021648:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1713437764:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -514003336:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 867259615:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 577543513:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 473626369:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -225666173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2109192114:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1319121459:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break by;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 893432812:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1137178901:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1605470032:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090545472:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -424824043:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bt;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1040811906:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bs;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1367871194:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break br;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -165889114:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 935334798:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -213184938:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bo;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 737899923:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1231296631:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1818883748:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090553155:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bk;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 41837598:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 979786518:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bi;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -419512299:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 953953403:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 44353614:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bf;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1588700173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break be;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 616494848:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1567771547:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1671927173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -677401976:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ba;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1522974895:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break z;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 906154098:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break y;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1721669609:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break x;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 699450984:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break w;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -246593737:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break v;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -621882202:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break u;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 24898165:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break t;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -299067664:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break s;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 841414265:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break r;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1096497267:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break q;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -841884003:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break p;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -513789148:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break o;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1693229482:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break n;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2136683676:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break m;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1684645191:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break l;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -17764532:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break k;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 736006033:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break j;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 552712649:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break i;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -160977132:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break h;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1996487587:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break g;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 250317358:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break f;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 342871275:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break e;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1876558156:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2068787732:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090567620:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                default:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1104)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_42_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1105)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_144_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1106)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_172_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1107)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_254_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1108)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_17_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1109)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_210_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1110)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_19_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1111)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_108_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1112)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_18_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1113)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_126_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1114)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_236_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1115)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_251_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1116)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_66_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1117)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_169_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1118)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_70_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1120)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_218_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1121)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_222_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1122)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_205_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1123)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_60_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1124)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_93_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1125)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_68_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1126)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_138_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1127)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_142_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1128)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_45_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1129)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_113_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1130)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_249_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1131)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_12_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1132)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_63_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1133)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_78_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1134)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_137_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1135)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_248_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1136)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_232_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1138)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_48_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1137)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_75_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1139)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_122_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1140)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_40_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1141)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_212_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1142)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_34_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1143)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_103_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1144)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_146_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1145)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_178_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1146)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_247_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1147)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_87_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1149)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_101_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1148)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_164_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1150)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_0_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1151)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_7_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1152)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_184_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1153)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_214_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1154)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_256_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1155)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_217_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1156)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_255_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1157)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_183_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1158)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_5_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1159)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_147_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1160)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_43_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1161)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_134_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1162)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_207_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1163)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_140_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1164)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_216_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1165)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_243_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1166)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_85_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1167)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_198_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1168)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_90_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1169)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_132_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1170)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_250_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1171)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_98_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1172)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_197_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1173)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_84_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1174)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_231_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1175)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_211_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1176)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_104_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1177)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_123_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1178)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_62_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1179)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_59_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1180)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_203_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1181)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_86_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1182)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return onciu_RewritableCompat$PROXY$5_199_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1183)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return onciu_RewritableCompat$PROXY$5_262_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1184)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return onciu_RewritableCompat$PROXY$5_180_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1185)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return onciu_RewritableCompat$PROXY$5_15_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1186)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_258_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1187)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_128_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1188)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_31_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1189)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_73_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1190)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_28_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1191)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_143_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1192)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_92_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1193)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_21_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1194)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_77_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1195)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_245_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1196)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_79_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1197)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_44_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1198)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_194_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1199)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_64_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1200)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_82_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1201)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_192_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1203)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_94_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1202)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_116_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1204)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_195_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1205)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_50_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1206)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_96_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1207)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_155_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1208)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_187_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1209)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_225_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1210)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_81_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1211)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_9_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1212)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_188_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1213)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_191_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1214)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_157_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1215)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_233_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1216)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_58_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1217)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_124_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1218)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_221_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1219)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_105_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1220)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_237_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1221)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_23_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1222)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_80_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1223)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_119_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1224)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_220_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1225)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_235_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1226)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_260_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1227)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_257_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1228)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_154_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1229)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_267_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1230)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_120_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1231)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_227_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1232)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_91_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1233)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_33_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1234)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_117_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1235)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_208_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1236)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_196_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1237)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_175_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1238)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_121_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1239)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_229_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1240)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_1_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1241)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_179_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1242)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_13_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1243)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_268_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1244)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_20_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1245)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_171_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1247)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_141_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1248)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_95_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1249)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_202_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1250)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_14_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1251)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_182_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1252)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_118_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1253)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_38_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1254)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_162_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1255)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_115_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1256)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_22_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1257)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_230_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1258)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_242_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1259)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_76_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1260)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_177_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1261)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_8_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1262)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_223_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1263)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_25_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1264)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_156_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1265)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_158_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1266)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_159_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1268)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_186_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1267)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_201_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1269)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_133_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1270)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_106_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1271)))
                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_170_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1272)))
                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_150_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1274)))
                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_152_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1273)))
                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_185_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1275)))
                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_204_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1276)))
                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_252_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1277)))
                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_127_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1278)))
                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_238_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1279)))
                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_168_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1280)))
                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_200_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1281)))
                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_226_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1282)))
                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_112_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1283)))
                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_26_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1284)))
                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_89_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1285)))
                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_264_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1286)))
                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_215_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1287)))
                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_145_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1289)))
                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_47_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1288)))
                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_52_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1290)))
                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_228_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1291)))
                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_30_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1292)))
                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_241_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1293)))
                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_261_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1294)))
                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_100_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1295)))
                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_160_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1296)))
                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_173_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1297)))
                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_51_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1298)))
                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_71_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1299)))
                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_4_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1300)))
                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_41_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1301)))
                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_209_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1302)))
                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_46_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1303)))
                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_55_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1304)))
                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_161_paramsLength(var$1);
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1305)))
                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_189_paramsLength(var$1);
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1306)))
                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_37_paramsLength(var$1);
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1307)))
                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_11_paramsLength(var$1);
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1308)))
                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_69_paramsLength(var$1);
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1309)))
                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_72_paramsLength(var$1);
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1310)))
                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_111_paramsLength(var$1);
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1311)))
                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_148_paramsLength(var$1);
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1312)))
                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_88_paramsLength(var$1);
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1313)))
                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_10_paramsLength(var$1);
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1314)))
                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_24_paramsLength(var$1);
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1315)))
                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_61_paramsLength(var$1);
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1316)))
                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_16_paramsLength(var$1);
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1317)))
                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_83_paramsLength(var$1);
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1318)))
                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_56_paramsLength(var$1);
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1319)))
                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_27_paramsLength(var$1);
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1320)))
                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_239_paramsLength(var$1);
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1321)))
                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_266_paramsLength(var$1);
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1322)))
                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_135_paramsLength(var$1);
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1323)))
                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_153_paramsLength(var$1);
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1324)))
                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_110_paramsLength(var$1);
                                                                                                                                                                                                                }
                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1325)))
                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_166_paramsLength(var$1);
                                                                                                                                                                                                            }
                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1326)))
                                                                                                                                                                                                                break a;
                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_2_paramsLength(var$1);
                                                                                                                                                                                                        }
                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1327)))
                                                                                                                                                                                                            break a;
                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_36_paramsLength(var$1);
                                                                                                                                                                                                    }
                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1328)))
                                                                                                                                                                                                        break a;
                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_181_paramsLength(var$1);
                                                                                                                                                                                                }
                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1329)))
                                                                                                                                                                                                    break a;
                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_49_paramsLength(var$1);
                                                                                                                                                                                            }
                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1330)))
                                                                                                                                                                                                break a;
                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_206_paramsLength(var$1);
                                                                                                                                                                                        }
                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1331)))
                                                                                                                                                                                            break a;
                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_136_paramsLength(var$1);
                                                                                                                                                                                    }
                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1332)))
                                                                                                                                                                                        break a;
                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_3_paramsLength(var$1);
                                                                                                                                                                                }
                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1333)))
                                                                                                                                                                                    break a;
                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_219_paramsLength(var$1);
                                                                                                                                                                            }
                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1334)))
                                                                                                                                                                                break a;
                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_174_paramsLength(var$1);
                                                                                                                                                                        }
                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1335)))
                                                                                                                                                                            break a;
                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_32_paramsLength(var$1);
                                                                                                                                                                    }
                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1336)))
                                                                                                                                                                        break a;
                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_149_paramsLength(var$1);
                                                                                                                                                                }
                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1337)))
                                                                                                                                                                    break a;
                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_102_paramsLength(var$1);
                                                                                                                                                            }
                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1338)))
                                                                                                                                                                break a;
                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_67_paramsLength(var$1);
                                                                                                                                                        }
                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1339)))
                                                                                                                                                            break a;
                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_244_paramsLength(var$1);
                                                                                                                                                    }
                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1340)))
                                                                                                                                                        break a;
                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_54_paramsLength(var$1);
                                                                                                                                                }
                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1341)))
                                                                                                                                                    break a;
                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_246_paramsLength(var$1);
                                                                                                                                            }
                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1342)))
                                                                                                                                                break a;
                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_29_paramsLength(var$1);
                                                                                                                                        }
                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1343)))
                                                                                                                                            break a;
                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_74_paramsLength(var$1);
                                                                                                                                    }
                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1344)))
                                                                                                                                        break a;
                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_193_paramsLength(var$1);
                                                                                                                                }
                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1345)))
                                                                                                                                    break a;
                                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_240_paramsLength(var$1);
                                                                                                                            }
                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1346)))
                                                                                                                                break a;
                                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_125_paramsLength(var$1);
                                                                                                                        }
                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1347)))
                                                                                                                            break a;
                                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_265_paramsLength(var$1);
                                                                                                                    }
                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1348)))
                                                                                                                        break a;
                                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_190_paramsLength(var$1);
                                                                                                                }
                                                                                                                if (!jl_String_equals(var$2, $rt_s(1349)))
                                                                                                                    break a;
                                                                                                                return $java.onciu_RewritableCompat$PROXY$5_130_paramsLength(var$1);
                                                                                                            }
                                                                                                            if (!jl_String_equals(var$2, $rt_s(1350)))
                                                                                                                break a;
                                                                                                            return $java.onciu_RewritableCompat$PROXY$5_57_paramsLength(var$1);
                                                                                                        }
                                                                                                        if (!jl_String_equals(var$2, $rt_s(1351)))
                                                                                                            break a;
                                                                                                        return $java.onciu_RewritableCompat$PROXY$5_163_paramsLength(var$1);
                                                                                                    }
                                                                                                    if (!jl_String_equals(var$2, $rt_s(1352)))
                                                                                                        break a;
                                                                                                    return $java.onciu_RewritableCompat$PROXY$5_35_paramsLength(var$1);
                                                                                                }
                                                                                                if (!jl_String_equals(var$2, $rt_s(1353)))
                                                                                                    break a;
                                                                                                return $java.onciu_RewritableCompat$PROXY$5_176_paramsLength(var$1);
                                                                                            }
                                                                                            if (!jl_String_equals(var$2, $rt_s(1354)))
                                                                                                break a;
                                                                                            return $java.onciu_RewritableCompat$PROXY$5_167_paramsLength(var$1);
                                                                                        }
                                                                                        if (!jl_String_equals(var$2, $rt_s(1356)))
                                                                                            break a;
                                                                                        return $java.onciu_RewritableCompat$PROXY$5_99_paramsLength(var$1);
                                                                                    }
                                                                                    if (!jl_String_equals(var$2, $rt_s(1355)))
                                                                                        break a;
                                                                                    return $java.onciu_RewritableCompat$PROXY$5_139_paramsLength(var$1);
                                                                                }
                                                                                if (!jl_String_equals(var$2, $rt_s(1357)))
                                                                                    break a;
                                                                                return $java.onciu_RewritableCompat$PROXY$5_151_paramsLength(var$1);
                                                                            }
                                                                            if (!jl_String_equals(var$2, $rt_s(1358)))
                                                                                break a;
                                                                            return $java.onciu_RewritableCompat$PROXY$5_109_paramsLength(var$1);
                                                                        }
                                                                        if (!jl_String_equals(var$2, $rt_s(1359)))
                                                                            break a;
                                                                        return $java.onciu_RewritableCompat$PROXY$5_65_paramsLength(var$1);
                                                                    }
                                                                    if (!jl_String_equals(var$2, $rt_s(1360)))
                                                                        break a;
                                                                    return $java.onciu_RewritableCompat$PROXY$5_234_paramsLength(var$1);
                                                                }
                                                                if (!jl_String_equals(var$2, $rt_s(1361)))
                                                                    break a;
                                                                return $java.onciu_RewritableCompat$PROXY$5_6_paramsLength(var$1);
                                                            }
                                                            if (!jl_String_equals(var$2, $rt_s(1362)))
                                                                break a;
                                                            return $java.onciu_RewritableCompat$PROXY$5_131_paramsLength(var$1);
                                                        }
                                                        if (!jl_String_equals(var$2, $rt_s(1363)))
                                                            break a;
                                                        return $java.onciu_RewritableCompat$PROXY$5_263_paramsLength(var$1);
                                                    }
                                                    if (!jl_String_equals(var$2, $rt_s(1364)))
                                                        break a;
                                                    return $java.onciu_RewritableCompat$PROXY$5_53_paramsLength(var$1);
                                                }
                                                if (!jl_String_equals(var$2, $rt_s(1365)))
                                                    break a;
                                                return $java.onciu_RewritableCompat$PROXY$5_165_paramsLength(var$1);
                                            }
                                            if (!jl_String_equals(var$2, $rt_s(1366)))
                                                break a;
                                            return $java.onciu_RewritableCompat$PROXY$5_259_paramsLength(var$1);
                                        }
                                        if (!jl_String_equals(var$2, $rt_s(1367)))
                                            break a;
                                        return $java.onciu_RewritableCompat$PROXY$5_97_paramsLength(var$1);
                                    }
                                    if (!jl_String_equals(var$2, $rt_s(1368)))
                                        break a;
                                    return $java.onciu_RewritableCompat$PROXY$5_224_paramsLength(var$1);
                                }
                                if (!jl_String_equals(var$2, $rt_s(1370)))
                                    break a;
                                return $java.onciu_RewritableCompat$PROXY$5_253_paramsLength(var$1);
                            }
                            if (!jl_String_equals(var$2, $rt_s(1371)))
                                break a;
                            return $java.onciu_RewritableCompat$PROXY$5_107_paramsLength(var$1);
                        }
                        if (!jl_String_equals(var$2, $rt_s(1372)))
                            break a;
                        return $java.onciu_RewritableCompat$PROXY$5_114_paramsLength(var$1);
                    }
                    if (!jl_String_equals(var$2, $rt_s(1373)))
                        break a;
                    return $java.onciu_RewritableCompat$PROXY$5_129_paramsLength(var$1);
                }
                if (!jl_String_equals(var$2, $rt_s(1374)))
                    break a;
                return $java.onciu_RewritableCompat$PROXY$5_213_paramsLength(var$1);
            }
            if (jl_String_equals(var$2, $rt_s(1375)))
                return $java.onciu_RewritableCompat$PROXY$5_39_paramsLength(var$1);
        }
        return null;
    }
    function onciu_RewritableCompat_lastParamIsPosition(var$1) {
        var var$2;
        a: {
            b: {
                c: {
                    d: {
                        e: {
                            f: {
                                g: {
                                    h: {
                                        i: {
                                            j: {
                                                k: {
                                                    l: {
                                                        m: {
                                                            n: {
                                                                o: {
                                                                    p: {
                                                                        q: {
                                                                            r: {
                                                                                s: {
                                                                                    t: {
                                                                                        u: {
                                                                                            v: {
                                                                                                w: {
                                                                                                    x: {
                                                                                                        y: {
                                                                                                            z: {
                                                                                                                ba: {
                                                                                                                    bb: {
                                                                                                                        bc: {
                                                                                                                            bd: {
                                                                                                                                be: {
                                                                                                                                    bf: {
                                                                                                                                        bg: {
                                                                                                                                            bh: {
                                                                                                                                                bi: {
                                                                                                                                                    bj: {
                                                                                                                                                        bk: {
                                                                                                                                                            bl: {
                                                                                                                                                                bm: {
                                                                                                                                                                    bn: {
                                                                                                                                                                        bo: {
                                                                                                                                                                            bp: {
                                                                                                                                                                                bq: {
                                                                                                                                                                                    br: {
                                                                                                                                                                                        bs: {
                                                                                                                                                                                            bt: {
                                                                                                                                                                                                bu: {
                                                                                                                                                                                                    bv: {
                                                                                                                                                                                                        bw: {
                                                                                                                                                                                                            bx: {
                                                                                                                                                                                                                by: {
                                                                                                                                                                                                                    bz: {
                                                                                                                                                                                                                        bA: {
                                                                                                                                                                                                                            bB: {
                                                                                                                                                                                                                                bC: {
                                                                                                                                                                                                                                    bD: {
                                                                                                                                                                                                                                        bE: {
                                                                                                                                                                                                                                            bF: {
                                                                                                                                                                                                                                                bG: {
                                                                                                                                                                                                                                                    bH: {
                                                                                                                                                                                                                                                        bI: {
                                                                                                                                                                                                                                                            bJ: {
                                                                                                                                                                                                                                                                bK: {
                                                                                                                                                                                                                                                                    bL: {
                                                                                                                                                                                                                                                                        bM: {
                                                                                                                                                                                                                                                                            bN: {
                                                                                                                                                                                                                                                                                bO: {
                                                                                                                                                                                                                                                                                    bP: {
                                                                                                                                                                                                                                                                                        bQ: {
                                                                                                                                                                                                                                                                                            bR: {
                                                                                                                                                                                                                                                                                                bS: {
                                                                                                                                                                                                                                                                                                    bT: {
                                                                                                                                                                                                                                                                                                        bU: {
                                                                                                                                                                                                                                                                                                            bV: {
                                                                                                                                                                                                                                                                                                                bW: {
                                                                                                                                                                                                                                                                                                                    bX: {
                                                                                                                                                                                                                                                                                                                        bY: {
                                                                                                                                                                                                                                                                                                                            bZ: {
                                                                                                                                                                                                                                                                                                                                b0: {
                                                                                                                                                                                                                                                                                                                                    b1: {
                                                                                                                                                                                                                                                                                                                                        b2: {
                                                                                                                                                                                                                                                                                                                                            b3: {
                                                                                                                                                                                                                                                                                                                                                b4: {
                                                                                                                                                                                                                                                                                                                                                    b5: {
                                                                                                                                                                                                                                                                                                                                                        b6: {
                                                                                                                                                                                                                                                                                                                                                            b7: {
                                                                                                                                                                                                                                                                                                                                                                b8: {
                                                                                                                                                                                                                                                                                                                                                                    b9: {
                                                                                                                                                                                                                                                                                                                                                                        b$: {
                                                                                                                                                                                                                                                                                                                                                                            b_: {
                                                                                                                                                                                                                                                                                                                                                                                ca: {
                                                                                                                                                                                                                                                                                                                                                                                    cb: {
                                                                                                                                                                                                                                                                                                                                                                                        cc: {
                                                                                                                                                                                                                                                                                                                                                                                            cd: {
                                                                                                                                                                                                                                                                                                                                                                                                ce: {
                                                                                                                                                                                                                                                                                                                                                                                                    cf: {
                                                                                                                                                                                                                                                                                                                                                                                                        cg: {
                                                                                                                                                                                                                                                                                                                                                                                                            ch: {
                                                                                                                                                                                                                                                                                                                                                                                                                ci: {
                                                                                                                                                                                                                                                                                                                                                                                                                    cj: {
                                                                                                                                                                                                                                                                                                                                                                                                                        ck: {
                                                                                                                                                                                                                                                                                                                                                                                                                            cl: {
                                                                                                                                                                                                                                                                                                                                                                                                                                cm: {
                                                                                                                                                                                                                                                                                                                                                                                                                                    cn: {
                                                                                                                                                                                                                                                                                                                                                                                                                                        co: {
                                                                                                                                                                                                                                                                                                                                                                                                                                            cp: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                cq: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                    cr: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                        cs: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                            ct: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                cu: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cv: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cw: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cx: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cy: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cz: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cA: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cB: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cC: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cD: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cE: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cF: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cG: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cH: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cI: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cJ: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cK: {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                cW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    cX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        cY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            cZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c0:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c1:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c2:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c3:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c4:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c5:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c6:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c7:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                c8:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    c9:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        c$:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            c_:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                da:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    db:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dc:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dd:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                de:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    df:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dg:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dh:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                di:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dj:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dk:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dl:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dm:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dn:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dp:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dq:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dr:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ds:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dt:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            du:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dv:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dw:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dx:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dy:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dz:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dA:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dB:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dC:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dD:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dE:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dF:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dG:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dH:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dI:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dJ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dK:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            dW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                dX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    dY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        dZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d0:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d1:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d2:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d3:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d4:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d5:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d6:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d7:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            d8:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                d9:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    d$:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        d_:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ea:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eb:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ec:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ed:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ee:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ef:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eg:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eh:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ei:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ej:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ek:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        el:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            em:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                en:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eo:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ep:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eq:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                er:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    es:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        et:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eu:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ev:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ew:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ex:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ey:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ez:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eA:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eB:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eC:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eD:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eE:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eF:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eG:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eH:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eI:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eJ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eK:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eL:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eM:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eN:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eO:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eP:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eQ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eR:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eS:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eT:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eU:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eV:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            eW:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                eX:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    eY:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        eZ:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            var$2
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            =
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            jl_Class_getName(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            switch
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (jl_String_hashCode(var$2))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            {
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 455596914:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -696583615:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 814608189:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1944844053:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -149837559:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -173726688:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 463217861:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1638198402:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1344819286:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1539521346:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1885430284:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1990238911:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1624236093:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1139703987:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 218162326:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1699139200:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 161043599:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 257300197:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1161986269:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1849450182:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2004672172:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1854989025:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1995730627:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -59220920:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -56818274:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1905747848:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 876306657:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 563302816:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ez;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1509369838:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ey;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -551872710:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ex;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -309054547:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ew;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 597069130:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ev;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -83434525:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1106883801:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break et;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 791743121:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break es;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -173726498:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break er;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090567930:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -324525645:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ep;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 35532533:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eo;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 552142263:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break en;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1728481248:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break em;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 808140963:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break el;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 180309318:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ek;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 552536514:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ej;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1113043596:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ei;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1098373913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 171553019:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -690264973:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ef;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1956588185:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ee;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -185398452:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ed;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -354016038:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ec;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -547163946:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break eb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1697153532:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ea;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1836487610:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -124559559:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1298739788:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1505287241:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -527102827:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1375343095:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1687177394:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2107404354:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1252416461:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1971775404:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1143216060:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1836370035:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -57639779:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 386603235:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 140909333:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1111213695:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1539103505:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1875460719:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -974095529:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2008336743:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 767481184:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -446332315:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1846818353:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 25975226:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1869678611:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1672152040:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 933593450:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2123943227:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -925030859:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1525448294:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 490543052:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 553477153:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2021177853:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1032130721:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1399872522:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -101943729:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 68785030:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 630773776:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -382919541:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1036156617:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dy;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 44260601:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1053180719:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 941027000:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2097338776:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break du;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1430315311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dt;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1838452428:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ds;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1743234077:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dr;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1002775686:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1994092090:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1400223240:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1889018242:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 773610978:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 549588447:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dk;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1540596742:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 715403871:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break di;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 488962701:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 773878287:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -862437735:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break df;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1590622701:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break de;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 654843427:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -72889640:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break dc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 51139985:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break db;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1509467160:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break da;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -931686672:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1569671430:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1086375751:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -692014538:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1494021353:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1377215654:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1085962297:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1397478846:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1158862256:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 787353940:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1930616743:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1629866976:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1344230015:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 967704049:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2070218311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1651308197:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -601065917:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -946641608:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1363729583:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1131485948:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -937120067:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 257458495:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 608145466:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -361629069:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -14881129:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1887073695:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1903613124:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1743141064:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 345156959:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1384882995:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -721388032:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -391096479:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1942599922:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2013484445:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -335388913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1209682917:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 838435105:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 68878043:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -8013773:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 390701443:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cy;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1605005311:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1087067473:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1131043253:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1167383453:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -769608440:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ct;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1400329004:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cs;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1845562242:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cr;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 825085381:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 224696041:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -766295774:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break co;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1814577755:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2117196269:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -212889784:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1752564371:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ck;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 86719663:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 884425735:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ci;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1622751247:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ch;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2111686605:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 185377688:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cf;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -921688526:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ce;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1553787535:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1087184836:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1092119273:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break cb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1388906993:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ca;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1734229172:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b_;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2128450866:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b$;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2016921081:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b9;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1555225207:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b8;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1683547861:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b7;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -523752746:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b6;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1223363698:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b5;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 421974435:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b4;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090555552:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b3;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2060497514:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b2;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -288223014:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b1;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1628021123:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b0;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 722610464:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bZ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -48137118:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bY;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -779711344:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bX;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 433120830:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bW;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -429840592:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bV;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1189054542:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bU;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1878523352:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bT;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -395643130:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bS;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090555080:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bR;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1154925950:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bQ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 984874708:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bP;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 49269903:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bO;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 839143939:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bN;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1674145006:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bM;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1991860843:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bL;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1757559093:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bK;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -914850913:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bJ;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2129483779:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bI;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 513352456:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bH;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1054021648:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bG;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1713437764:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bF;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -514003336:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bE;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 867259615:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bD;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 577543513:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bC;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 473626369:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bB;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -225666173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bA;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2109192114:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bz;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1319121459:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break by;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 893432812:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bx;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1137178901:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bw;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1605470032:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bv;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090545472:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bu;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -424824043:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bt;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1040811906:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bs;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1367871194:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break br;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -165889114:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bq;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 935334798:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bp;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -213184938:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bo;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 737899923:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bn;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1231296631:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bm;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1818883748:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bl;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090553155:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bk;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 41837598:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bj;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 979786518:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bi;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -419512299:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bh;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 953953403:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bg;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 44353614:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bf;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1588700173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break be;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 616494848:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bd;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1567771547:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bc;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1671927173:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break bb;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -677401976:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break ba;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1522974895:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break z;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 906154098:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break y;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1721669609:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break x;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 699450984:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break w;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -246593737:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break v;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -621882202:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break u;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 24898165:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break t;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -299067664:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break s;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 841414265:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break r;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1096497267:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break q;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -841884003:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break p;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -513789148:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break o;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1693229482:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break n;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 2136683676:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break m;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1684645191:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break l;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -17764532:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break k;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 736006033:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break j;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 552712649:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break i;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -160977132:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break h;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1996487587:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break g;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 250317358:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break f;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 342871275:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break e;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case 1876558156:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break d;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -2068787732:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break c;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                case -1090567620:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break b;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                default:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1104)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_42_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1105)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_144_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1106)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_172_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1107)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_254_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1108)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_17_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1109)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_210_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1110)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_19_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1111)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_108_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1112)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_18_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1113)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_126_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1114)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_236_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1115)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_251_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1116)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_66_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1117)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_169_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1118)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_70_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1120)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_218_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1121)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_222_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1122)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_205_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1123)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_60_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1124)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_93_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1125)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_68_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1126)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_138_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1127)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_142_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1128)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_45_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1129)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_113_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1130)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_249_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1131)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_12_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1132)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_63_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1133)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_78_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1134)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_137_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1135)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_248_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1136)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_232_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1138)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_48_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1137)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_75_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1139)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_122_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1140)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_40_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1141)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_212_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1142)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_34_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1143)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_103_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1144)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_146_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1145)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_178_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1146)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_247_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1147)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_87_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1149)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_101_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1148)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_164_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1150)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_0_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1151)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_7_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1152)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_184_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1153)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_214_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1154)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_256_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1155)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_217_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1156)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_255_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1157)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_183_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1158)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_5_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1159)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_147_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1160)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_43_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1161)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_134_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1162)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_207_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1163)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_140_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1164)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_216_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1165)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_243_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1166)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_85_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1167)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_198_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1168)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_90_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1169)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_132_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1170)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_250_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1171)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_98_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1172)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_197_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1173)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_84_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1174)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_231_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1175)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_211_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1176)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_104_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1177)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_123_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1178)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_62_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1179)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_59_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1180)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_203_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1181)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_86_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1182)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_199_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1183)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_262_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1184)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_180_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1185)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_15_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1186)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_258_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1187)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_128_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1188)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_31_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1189)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_73_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1190)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_28_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1191)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_143_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1192)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_92_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1193)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_21_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1194)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_77_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1195)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_245_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1196)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_79_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1197)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_44_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1198)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_194_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1199)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_64_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1200)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_82_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1201)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_192_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1203)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_94_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1202)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_116_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1204)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_195_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1205)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_50_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1206)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_96_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1207)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_155_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1208)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_187_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1209)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_225_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1210)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_81_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1211)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_9_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1212)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_188_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1213)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_191_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1214)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_157_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1215)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_233_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1216)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_58_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1217)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_124_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1218)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_221_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1219)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_105_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1220)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_237_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1221)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_23_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1222)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_80_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1223)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_119_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1224)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_220_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1225)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_235_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1226)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_260_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1227)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_257_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1228)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_154_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1229)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_267_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1230)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_120_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1231)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_227_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1232)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_91_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1233)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_33_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1234)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_117_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1235)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_208_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1236)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_196_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1237)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_175_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1238)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_121_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1239)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_229_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1240)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_1_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1241)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_179_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1242)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_13_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1243)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_268_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1244)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_20_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1245)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_171_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1247)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_141_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1248)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_95_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1249)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_202_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1250)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_14_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1251)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_182_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    $rt_s(1252)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_118_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                $rt_s(1253)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_38_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            $rt_s(1254)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_162_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        $rt_s(1255)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_115_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1256)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_22_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1257)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_230_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1258)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_242_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1259)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_76_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1260)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_177_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1261)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_8_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1262)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_223_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1263)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_25_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1264)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_156_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1265)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_158_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1266)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_159_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1268)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_186_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1267)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_201_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1269)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_133_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1270)))
                                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_106_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1271)))
                                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_170_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1272)))
                                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_150_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1274)))
                                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_152_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1273)))
                                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_185_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1275)))
                                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_204_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1276)))
                                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_252_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1277)))
                                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_127_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1278)))
                                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_238_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1279)))
                                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_168_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1280)))
                                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_200_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1281)))
                                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_226_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1282)))
                                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_112_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1283)))
                                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_26_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1284)))
                                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_89_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1285)))
                                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_264_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1286)))
                                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_215_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1287)))
                                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_145_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1289)))
                                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_47_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1288)))
                                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_52_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1290)))
                                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_228_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1291)))
                                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_30_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1292)))
                                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_241_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1293)))
                                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_261_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1294)))
                                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_100_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1295)))
                                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_160_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1296)))
                                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_173_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1297)))
                                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_51_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1298)))
                                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_71_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1299)))
                                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_4_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1300)))
                                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_41_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1301)))
                                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_209_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1302)))
                                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_46_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1303)))
                                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_55_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1304)))
                                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_161_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1305)))
                                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_189_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1306)))
                                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_37_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1307)))
                                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_11_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1308)))
                                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_69_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1309)))
                                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_72_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1310)))
                                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_111_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1311)))
                                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_148_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1312)))
                                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_88_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1313)))
                                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_10_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1314)))
                                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_24_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1315)))
                                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_61_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1316)))
                                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_16_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1317)))
                                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_83_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                            }
                                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1318)))
                                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_56_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                        }
                                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1319)))
                                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_27_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                    }
                                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1320)))
                                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_239_lastParamIsPosition(var$1);
                                                                                                                                                                                                                                }
                                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1321)))
                                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_266_lastParamIsPosition(var$1);
                                                                                                                                                                                                                            }
                                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1322)))
                                                                                                                                                                                                                                break a;
                                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_135_lastParamIsPosition(var$1);
                                                                                                                                                                                                                        }
                                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1323)))
                                                                                                                                                                                                                            break a;
                                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_153_lastParamIsPosition(var$1);
                                                                                                                                                                                                                    }
                                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1324)))
                                                                                                                                                                                                                        break a;
                                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_110_lastParamIsPosition(var$1);
                                                                                                                                                                                                                }
                                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1325)))
                                                                                                                                                                                                                    break a;
                                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_166_lastParamIsPosition(var$1);
                                                                                                                                                                                                            }
                                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1326)))
                                                                                                                                                                                                                break a;
                                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_2_lastParamIsPosition(var$1);
                                                                                                                                                                                                        }
                                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1327)))
                                                                                                                                                                                                            break a;
                                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_36_lastParamIsPosition(var$1);
                                                                                                                                                                                                    }
                                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1328)))
                                                                                                                                                                                                        break a;
                                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_181_lastParamIsPosition(var$1);
                                                                                                                                                                                                }
                                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1329)))
                                                                                                                                                                                                    break a;
                                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_49_lastParamIsPosition(var$1);
                                                                                                                                                                                            }
                                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1330)))
                                                                                                                                                                                                break a;
                                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_206_lastParamIsPosition(var$1);
                                                                                                                                                                                        }
                                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1331)))
                                                                                                                                                                                            break a;
                                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_136_lastParamIsPosition(var$1);
                                                                                                                                                                                    }
                                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1332)))
                                                                                                                                                                                        break a;
                                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_3_lastParamIsPosition(var$1);
                                                                                                                                                                                }
                                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1333)))
                                                                                                                                                                                    break a;
                                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_219_lastParamIsPosition(var$1);
                                                                                                                                                                            }
                                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1334)))
                                                                                                                                                                                break a;
                                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_174_lastParamIsPosition(var$1);
                                                                                                                                                                        }
                                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1335)))
                                                                                                                                                                            break a;
                                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_32_lastParamIsPosition(var$1);
                                                                                                                                                                    }
                                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1336)))
                                                                                                                                                                        break a;
                                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_149_lastParamIsPosition(var$1);
                                                                                                                                                                }
                                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1337)))
                                                                                                                                                                    break a;
                                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_102_lastParamIsPosition(var$1);
                                                                                                                                                            }
                                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1338)))
                                                                                                                                                                break a;
                                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_67_lastParamIsPosition(var$1);
                                                                                                                                                        }
                                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1339)))
                                                                                                                                                            break a;
                                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_244_lastParamIsPosition(var$1);
                                                                                                                                                    }
                                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1340)))
                                                                                                                                                        break a;
                                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_54_lastParamIsPosition(var$1);
                                                                                                                                                }
                                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1341)))
                                                                                                                                                    break a;
                                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_246_lastParamIsPosition(var$1);
                                                                                                                                            }
                                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1342)))
                                                                                                                                                break a;
                                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_29_lastParamIsPosition(var$1);
                                                                                                                                        }
                                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1343)))
                                                                                                                                            break a;
                                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_74_lastParamIsPosition(var$1);
                                                                                                                                    }
                                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1344)))
                                                                                                                                        break a;
                                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_193_lastParamIsPosition(var$1);
                                                                                                                                }
                                                                                                                                if (!jl_String_equals(var$2, $rt_s(1345)))
                                                                                                                                    break a;
                                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_240_lastParamIsPosition(var$1);
                                                                                                                            }
                                                                                                                            if (!jl_String_equals(var$2, $rt_s(1346)))
                                                                                                                                break a;
                                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_125_lastParamIsPosition(var$1);
                                                                                                                        }
                                                                                                                        if (!jl_String_equals(var$2, $rt_s(1347)))
                                                                                                                            break a;
                                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_265_lastParamIsPosition(var$1);
                                                                                                                    }
                                                                                                                    if (!jl_String_equals(var$2, $rt_s(1348)))
                                                                                                                        break a;
                                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_190_lastParamIsPosition(var$1);
                                                                                                                }
                                                                                                                if (!jl_String_equals(var$2, $rt_s(1349)))
                                                                                                                    break a;
                                                                                                                return $java.onciu_RewritableCompat$PROXY$7_130_lastParamIsPosition(var$1);
                                                                                                            }
                                                                                                            if (!jl_String_equals(var$2, $rt_s(1350)))
                                                                                                                break a;
                                                                                                            return $java.onciu_RewritableCompat$PROXY$7_57_lastParamIsPosition(var$1);
                                                                                                        }
                                                                                                        if (!jl_String_equals(var$2, $rt_s(1351)))
                                                                                                            break a;
                                                                                                        return $java.onciu_RewritableCompat$PROXY$7_163_lastParamIsPosition(var$1);
                                                                                                    }
                                                                                                    if (!jl_String_equals(var$2, $rt_s(1352)))
                                                                                                        break a;
                                                                                                    return $java.onciu_RewritableCompat$PROXY$7_35_lastParamIsPosition(var$1);
                                                                                                }
                                                                                                if (!jl_String_equals(var$2, $rt_s(1353)))
                                                                                                    break a;
                                                                                                return $java.onciu_RewritableCompat$PROXY$7_176_lastParamIsPosition(var$1);
                                                                                            }
                                                                                            if (!jl_String_equals(var$2, $rt_s(1354)))
                                                                                                break a;
                                                                                            return $java.onciu_RewritableCompat$PROXY$7_167_lastParamIsPosition(var$1);
                                                                                        }
                                                                                        if (!jl_String_equals(var$2, $rt_s(1356)))
                                                                                            break a;
                                                                                        return $java.onciu_RewritableCompat$PROXY$7_99_lastParamIsPosition(var$1);
                                                                                    }
                                                                                    if (!jl_String_equals(var$2, $rt_s(1355)))
                                                                                        break a;
                                                                                    return $java.onciu_RewritableCompat$PROXY$7_139_lastParamIsPosition(var$1);
                                                                                }
                                                                                if (!jl_String_equals(var$2, $rt_s(1357)))
                                                                                    break a;
                                                                                return $java.onciu_RewritableCompat$PROXY$7_151_lastParamIsPosition(var$1);
                                                                            }
                                                                            if (!jl_String_equals(var$2, $rt_s(1358)))
                                                                                break a;
                                                                            return $java.onciu_RewritableCompat$PROXY$7_109_lastParamIsPosition(var$1);
                                                                        }
                                                                        if (!jl_String_equals(var$2, $rt_s(1359)))
                                                                            break a;
                                                                        return $java.onciu_RewritableCompat$PROXY$7_65_lastParamIsPosition(var$1);
                                                                    }
                                                                    if (!jl_String_equals(var$2, $rt_s(1360)))
                                                                        break a;
                                                                    return $java.onciu_RewritableCompat$PROXY$7_234_lastParamIsPosition(var$1);
                                                                }
                                                                if (!jl_String_equals(var$2, $rt_s(1361)))
                                                                    break a;
                                                                return $java.onciu_RewritableCompat$PROXY$7_6_lastParamIsPosition(var$1);
                                                            }
                                                            if (!jl_String_equals(var$2, $rt_s(1362)))
                                                                break a;
                                                            return $java.onciu_RewritableCompat$PROXY$7_131_lastParamIsPosition(var$1);
                                                        }
                                                        if (!jl_String_equals(var$2, $rt_s(1363)))
                                                            break a;
                                                        return $java.onciu_RewritableCompat$PROXY$7_263_lastParamIsPosition(var$1);
                                                    }
                                                    if (!jl_String_equals(var$2, $rt_s(1364)))
                                                        break a;
                                                    return $java.onciu_RewritableCompat$PROXY$7_53_lastParamIsPosition(var$1);
                                                }
                                                if (!jl_String_equals(var$2, $rt_s(1365)))
                                                    break a;
                                                return $java.onciu_RewritableCompat$PROXY$7_165_lastParamIsPosition(var$1);
                                            }
                                            if (!jl_String_equals(var$2, $rt_s(1366)))
                                                break a;
                                            return $java.onciu_RewritableCompat$PROXY$7_259_lastParamIsPosition(var$1);
                                        }
                                        if (!jl_String_equals(var$2, $rt_s(1367)))
                                            break a;
                                        return $java.onciu_RewritableCompat$PROXY$7_97_lastParamIsPosition(var$1);
                                    }
                                    if (!jl_String_equals(var$2, $rt_s(1368)))
                                        break a;
                                    return $java.onciu_RewritableCompat$PROXY$7_224_lastParamIsPosition(var$1);
                                }
                                if (!jl_String_equals(var$2, $rt_s(1370)))
                                    break a;
                                return $java.onciu_RewritableCompat$PROXY$7_253_lastParamIsPosition(var$1);
                            }
                            if (!jl_String_equals(var$2, $rt_s(1371)))
                                break a;
                            return $java.onciu_RewritableCompat$PROXY$7_107_lastParamIsPosition(var$1);
                        }
                        if (!jl_String_equals(var$2, $rt_s(1372)))
                            break a;
                        return $java.onciu_RewritableCompat$PROXY$7_114_lastParamIsPosition(var$1);
                    }
                    if (!jl_String_equals(var$2, $rt_s(1373)))
                        break a;
                    return $java.onciu_RewritableCompat$PROXY$7_129_lastParamIsPosition(var$1);
                }
                if (!jl_String_equals(var$2, $rt_s(1374)))
                    break a;
                return $java.onciu_RewritableCompat$PROXY$7_213_lastParamIsPosition(var$1);
            }
            if (jl_String_equals(var$2, $rt_s(1375)))
                return $java.onciu_RewritableCompat$PROXY$7_39_lastParamIsPosition(var$1);
        }
        return null;
    }
    function sci_SetHashIterator() {
        sci_ChampBaseIterator.call(this);
        this.$hash2 = 0;
    }
    $java.sci_SetHashIterator_iterator = function($this) {
        return $this;
    };
    $java.sci_SetHashIterator_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.sci_SetHashIterator_toString = function($this) {
        return $rt_s(466);
    };
    $java.sci_SetHashIterator_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.sci_SetHashIterator_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.sci_SetHashIterator_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.sci_SetHashIterator_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.sci_SetHashIterator_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.sci_SetHashIterator_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.sci_SetHashIterator_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.sci_SetHashIterator_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.sci_SetHashIterator_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.sci_SetHashIterator_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.sci_SetHashIterator_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.sci_SetHashIterator_knownSize = function($this) {
        return (-1);
    };
    $java.sci_SetHashIterator_hashCode = function($this) {
        return $this.$hash2;
    };
    $java.sci_SetHashIterator_next = function($this) {
        var var$1;
        if (!sci_ChampBaseIterator_hasNext($this)) {
            var$1 = new ju_NoSuchElementException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        $this.$hash2 = $this.$currentValueNode.$getHash($this.$currentValueCursor);
        $this.$currentValueCursor = $this.$currentValueCursor + 1 | 0;
        return $this;
    };
    function oncir_ValidatingRewriter$$anonfun$1() {
        sr_AbstractPartialFunction.call(this);
        this.$input$1 = null;
    }
    $java.oncir_ValidatingRewriter$$anonfun$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        if (!$rt_isInstance($x, oncir_ValidatingCondition))
            $x = $default.$apply($x);
        else {
            $x = $x;
            $default = s_Predef$ArrowAssoc$_MODULE$;
            s_Predef$_$callClinit();
            $x = s_Predef$ArrowAssoc$_$minus$greater$extension($default, $x.$name3(), $x.$apply($this.$input$1));
        }
        return $x;
    };
    var oncir_ValidatingRewriter$validate$lambda$_34_0 = $rt_classWithoutFields();
    $java.oncir_ValidatingRewriter$validate$lambda$_34_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$_20.$nonEmpty0());
    };
    var otcit_DoubleAnalyzer = $rt_classWithoutFields();
    $java.otcit_DoubleAnalyzer_mantissa10Table = null;
    $java.otcit_DoubleAnalyzer_exp10Table = null;
    function otcit_DoubleAnalyzer_analyze($d, $result) {
        var $bits, $mantissa, $exponent, $errorShift, $decExponent, $mantissaShift, $decMantissa, $error, $upError, $downError, $lowerPos, $upperPos;
        $bits = $rt_doubleToLongBits($d);
        $result.$sign0 = Long_eq(Long_and($bits, Long_create(0, 2147483648)), Long_ZERO) ? 0 : 1;
        $mantissa = Long_and($bits, Long_create(4294967295, 1048575));
        $exponent = Long_lo(Long_shr($bits, 52)) & 2047;
        if (Long_eq($mantissa, Long_ZERO) && !$exponent) {
            $result.$mantissa0 = Long_ZERO;
            $result.$exponent0 = 0;
            return;
        }
        $errorShift = 0;
        if ($exponent)
            $mantissa = Long_or($mantissa, Long_create(0, 1048576));
        else {
            $mantissa = Long_shl($mantissa, 1);
            while (Long_eq(Long_and($mantissa, Long_create(0, 1048576)), Long_ZERO)) {
                $mantissa = Long_shl($mantissa, 1);
                $exponent = $exponent + (-1) | 0;
                $errorShift = $errorShift + 1 | 0;
            }
        }
        $decExponent = ju_Arrays_binarySearch($java.otcit_DoubleAnalyzer_exp10Table, $exponent);
        if ($decExponent < 0)
            $decExponent = ( -$decExponent | 0) - 2 | 0;
        $mantissaShift = 12 + ($exponent - $java.otcit_DoubleAnalyzer_exp10Table.data[$decExponent] | 0) | 0;
        $decMantissa = $java.otcit_DoubleAnalyzer_mulAndShiftRight($mantissa, $java.otcit_DoubleAnalyzer_mantissa10Table.data[$decExponent], $mantissaShift);
        if (Long_ge($decMantissa, Long_create(2808348672, 232830643))) {
            $decExponent = $decExponent + 1 | 0;
            $mantissaShift = 12 + ($exponent - $java.otcit_DoubleAnalyzer_exp10Table.data[$decExponent] | 0) | 0;
            $decMantissa = $java.otcit_DoubleAnalyzer_mulAndShiftRight($mantissa, $java.otcit_DoubleAnalyzer_mantissa10Table.data[$decExponent], $mantissaShift);
        }
        $error = Long_shru($java.otcit_DoubleAnalyzer_mantissa10Table.data[$decExponent], (63 - $mantissaShift | 0) - $errorShift | 0);
        $upError = Long_shr(Long_add($error, Long_fromInt(1)), 1);
        $downError = Long_shr($error, 1);
        if (Long_eq($mantissa, Long_create(0, 1048576)))
            $downError = Long_shr($downError, 2);
        $lowerPos = Long_fromInt(10);
        while (Long_le($lowerPos, $downError)) {
            $lowerPos = Long_mul($lowerPos, Long_fromInt(10));
        }
        if (Long_ge(Long_rem($decMantissa, $lowerPos), Long_div($downError, Long_fromInt(2))))
            $lowerPos = Long_div($lowerPos, Long_fromInt(10));
        $upperPos = Long_fromInt(1);
        while (Long_le($upperPos, $upError)) {
            $upperPos = Long_mul($upperPos, Long_fromInt(10));
        }
        if (Long_gt(Long_sub($upperPos, Long_rem($decMantissa, $upperPos)), Long_div($upError, Long_fromInt(2))))
            $upperPos = Long_div($upperPos, Long_fromInt(10));
        $exponent = Long_compare($lowerPos, $upperPos);
        $mantissa = $exponent > 0 ? Long_mul(Long_div($decMantissa, $lowerPos), $lowerPos) : $exponent < 0 ? Long_add(Long_mul(Long_div($decMantissa, $upperPos), $upperPos), $upperPos) : Long_mul(Long_div(Long_add($decMantissa, Long_div($upperPos, Long_fromInt(2))), $upperPos), $upperPos);
        if (Long_ge($mantissa, Long_create(2808348672, 232830643))) {
            $decExponent = $decExponent + 1 | 0;
            $mantissa = Long_div($mantissa, Long_fromInt(10));
        } else if (Long_lt($mantissa, Long_create(1569325056, 23283064))) {
            $decExponent = $decExponent + (-1) | 0;
            $mantissa = Long_mul($mantissa, Long_fromInt(10));
        }
        $result.$mantissa0 = $mantissa;
        $result.$exponent0 = $decExponent - 330 | 0;
    }
    $java.otcit_DoubleAnalyzer_mulAndShiftRight = function($a, $b, $shift) {
        var $a1, $a2, $a3, $a4, $b1, $b2, $b3, $b4, $cm, $c0, $c;
        $a1 = Long_and($a, Long_fromInt(65535));
        $a2 = Long_and(Long_shru($a, 16), Long_fromInt(65535));
        $a3 = Long_and(Long_shru($a, 32), Long_fromInt(65535));
        $a4 = Long_and(Long_shru($a, 48), Long_fromInt(65535));
        $b1 = Long_and($b, Long_fromInt(65535));
        $b2 = Long_and(Long_shru($b, 16), Long_fromInt(65535));
        $b3 = Long_and(Long_shru($b, 32), Long_fromInt(65535));
        $b4 = Long_and(Long_shru($b, 48), Long_fromInt(65535));
        $cm = Long_add(Long_add(Long_mul($b3, $a1), Long_mul($b2, $a2)), Long_mul($b1, $a3));
        $c0 = Long_add(Long_add(Long_add(Long_mul($b4, $a1), Long_mul($b3, $a2)), Long_mul($b2, $a3)), Long_mul($b1, $a4));
        $c = Long_add(Long_add(Long_shl(Long_mul($b4, $a4), 32 + $shift | 0), Long_shl(Long_add(Long_mul($b4, $a3), Long_mul($b3, $a4)), 16 + $shift | 0)), Long_shl(Long_add(Long_add(Long_mul($b4, $a2), Long_mul($b3, $a3)), Long_mul($b2, $a4)), $shift));
        return Long_add($shift > 16 ? Long_add($c, Long_shl($c0, $shift - 16 | 0)) : Long_add($c, Long_shru($c0, 16 - $shift | 0)), Long_shru($cm, 32 - $shift | 0));
    };
    function otcit_DoubleAnalyzer__clinit_() {
        var $decimalMantissaOne, $exponent, $i, $shiftedOffPart, var$5, var$6, $maxMantissa, $i_0, $shift, var$10;
        $java.otcit_DoubleAnalyzer_mantissa10Table = $rt_createLongArray(660);
        $java.otcit_DoubleAnalyzer_exp10Table = $rt_createIntArray(660);
        $decimalMantissaOne = Long_create(991952896, 1862645149);
        $exponent = 1023;
        $i = 0;
        $shiftedOffPart = $decimalMantissaOne;
        while ($i < 330) {
            var$5 = $java.otcit_DoubleAnalyzer_mantissa10Table.data;
            var$6 = $i + 330 | 0;
            var$5[var$6] = jl_Long_divideUnsigned($shiftedOffPart, Long_fromInt(80));
            $java.otcit_DoubleAnalyzer_exp10Table.data[var$6] = $exponent;
            $shiftedOffPart = jl_Long_divideUnsigned($shiftedOffPart, Long_fromInt(10));
            $maxMantissa = jl_Long_remainderUnsigned($shiftedOffPart, Long_fromInt(10));
            while (Long_le($shiftedOffPart, $decimalMantissaOne) && Long_eq(Long_and($shiftedOffPart, Long_create(0, 2147483648)), Long_ZERO)) {
                $shiftedOffPart = Long_shl($shiftedOffPart, 1);
                $exponent = $exponent + 1 | 0;
                $maxMantissa = Long_shl($maxMantissa, 1);
            }
            $shiftedOffPart = Long_add($shiftedOffPart, Long_div($maxMantissa, Long_fromInt(10)));
            $i = $i + 1 | 0;
        }
        $i = 1023;
        $i_0 = 0;
        while ($i_0 < 330) {
            $shift = 0;
            $shiftedOffPart = $decimalMantissaOne;
            while (Long_gt($shiftedOffPart, Long_create(3435973836, 214748364))) {
                $shiftedOffPart = Long_shr($shiftedOffPart, 1);
                $shift = $shift + 1 | 0;
                $i = $i + (-1) | 0;
            }
            var$10 = Long_mul($shiftedOffPart, Long_fromInt(10));
            $decimalMantissaOne = $shift <= 0 ? var$10 : Long_add(var$10, Long_shr(Long_mul(Long_and($decimalMantissaOne, Long_fromInt((1 << $shift) - 1 | 0)), Long_fromInt(10)), $shift));
            var$5 = $java.otcit_DoubleAnalyzer_mantissa10Table.data;
            var$6 = (330 - $i_0 | 0) - 1 | 0;
            var$5[var$6] = jl_Long_divideUnsigned($decimalMantissaOne, Long_fromInt(80));
            $java.otcit_DoubleAnalyzer_exp10Table.data[var$6] = $i;
            $i_0 = $i_0 + 1 | 0;
        }
    }
    $java.onciuh_TreeZipper$Context = $rt_classWithoutFields(0);
    var onciuh_TreeZipper$Top$ = $rt_classWithoutFields();
    function onciuh_TreeZipper$Top$__init_(var_0) {
        var var_1 = new onciuh_TreeZipper$Top$();
        $java.onciuh_TreeZipper$Top$__init_(var_1, var_0);
        return var_1;
    }
    $java.onciuh_TreeZipper$Top$_productArity = function($this) {
        return 0;
    };
    $java.onciuh_TreeZipper$Top$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.onciuh_TreeZipper$Top$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciuh_TreeZipper$Top$_hashCode = function($this) {
        return 84277;
    };
    $java.onciuh_TreeZipper$Top$_toString = function($this) {
        return $rt_s(1376);
    };
    $java.onciuh_TreeZipper$Top$__init_ = function($this, $$outer) {};
    function onciu_Rewritable$IteratorEq() {
        jl_Object.call(this);
        this.$iterator1 = null;
    }
    function onciu_Rewritable$IteratorEq_eqElements($this, $that) {
        a: {
            while (true) {
                if (!$this.$iterator1.$hasNext())
                    break a;
                if (!$that.$hasNext())
                    break a;
                if ($this.$iterator1.$next() !== $that.$next())
                    break;
            }
            return 0;
        }
        return !$this.$iterator1.$hasNext() && !$that.$hasNext() ? 1 : 0;
    }
    function sci_Map$WithDefault() {
        var a = this; sci_AbstractMap.call(a);
        a.$underlying20 = null;
        a.$defaultValue = null;
    }
    $java.sci_Map$WithDefault__init_ = function(var_0, var_1) {
        var var_2 = new sci_Map$WithDefault();
        sci_Map$WithDefault__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.sci_Map$WithDefault_get = function($this, $key) {
        return $this.$underlying20.$get1($key);
    };
    $java.sci_Map$WithDefault_default = function($this, $key) {
        return $this.$defaultValue.$_0136;
    };
    $java.sci_Map$WithDefault_iterableFactory = function($this) {
        return $this.$underlying20.$iterableFactory();
    };
    $java.sci_Map$WithDefault_iterator = function($this) {
        return $this.$underlying20.$iterator0();
    };
    $java.sci_Map$WithDefault_isEmpty = function($this) {
        return $this.$underlying20.$isEmpty();
    };
    $java.sci_Map$WithDefault_mapFactory = function($this) {
        return $this.$underlying20.$mapFactory();
    };
    $java.sci_Map$WithDefault_fromSpecific = function($this, $coll) {
        return $java.sci_Map$WithDefault__init_(($java.sci_Map$WithDefault_mapFactory($this)).$from0($coll), $this.$defaultValue);
    };
    $java.sci_Map$WithDefault_newSpecificBuilder = function($this) {
        var $mapResult_this, $mapResult_f;
        $mapResult_this = sci_MapBuilderImpl__init_();
        $mapResult_f = new $java.sci_Map$WithDefault$newSpecificBuilder$lambda$_13_0;
        $mapResult_f.$_0309 = $this;
        return scm_Builder$$anon$1__init_($mapResult_this, $mapResult_f);
    };
    $java.sci_Map$WithDefault_fromSpecific0 = function($this, $coll) {
        return $java.sci_Map$WithDefault_fromSpecific($this, $coll);
    };
    $java.sci_Map$WithDefault_fromSpecific1 = function($this, $coll) {
        return $java.sci_Map$WithDefault_fromSpecific($this, $coll);
    };
    $java.sci_Map$WithDefault_updated = function($this, $key, $value) {
        return $java.sci_Map$WithDefault__init_($this.$underlying20.$updated1($key, $value), $this.$defaultValue);
    };
    $java.sci_Map$WithDefault_removed = function($this, $key) {
        return $java.sci_Map$WithDefault__init_($this.$underlying20.$removed($key), $this.$defaultValue);
    };
    $java.sci_Map$WithDefault_concat = function($this, $suffix) {
        return $java.sci_Map$WithDefault__init_($this.$underlying20.$concat2($suffix), $this.$defaultValue);
    };
    function sci_Map$WithDefault__init_($this, $underlying, $defaultValue) {
        $this.$underlying20 = $underlying;
        $this.$defaultValue = $defaultValue;
    }
    function sci_Map$withDefaultValue$lambda$_9_0() {
        jl_Object.call(this);
        this.$_0136 = null;
    }
    function sc_Iterator$$anon$7() {
        var a = this; sc_AbstractIterator.call(a);
        a.$hd0 = null;
        a.$status = 0;
        a.$$outer8 = null;
        a.$pf$1 = null;
    }
    $java.sc_Iterator$$anon$7_toString = function($this) {
        return $rt_s(17);
    };
    $java.sc_Iterator$$anon$7_apply = function($this, $value) {
        return sr_Statics_pfMarker;
    };
    $java.sc_Iterator$$anon$7_hasNext = function($this) {
        var $marker, var$2, $x, $v;
        $marker = sr_Statics_pfMarker;
        while (true) {
            var$2 = $this.$status;
            if (var$2)
                break;
            if (!$this.$$outer8.$hasNext()) {
                $this.$status = (-1);
                continue;
            }
            $x = $this.$$outer8.$next();
            $v = $this.$pf$1.$applyOrElse($x, $this);
            if ($marker === $v)
                continue;
            $this.$hd0 = $v;
            $this.$status = 1;
        }
        if (var$2 != 1)
            return 0;
        return 1;
    };
    $java.sc_Iterator$$anon$7_next = function($this) {
        if (!$java.sc_Iterator$$anon$7_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $this.$status = 0;
        return $this.$hd0;
    };
    var oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_0 = $rt_classWithoutFields();
    $java.oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 === null ? 0 : 1);
    };
    function oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_1() {
        jl_Object.call(this);
        this.$_0261 = null;
    }
    $java.oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0261;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$3 = var$1.$_10;
        var$1 = var$1.$_20;
        var$4 = new $java.oncir_ValidatingRewriter$$anonfun$buildErrorMessage$2$lambda$_50_0;
        var$4.$_0310 = var$2;
        var$4.$_192 = var$3;
        var$1.$foreach(var$4);
        return sr_BoxedUnit_UNIT;
    };
    var oncirr_normalizeWithAndReturnClauses$aliasUnaliasedReturnItems$lambda$_39_0 = $rt_classWithoutFields();
    $java.oncirr_normalizeWithAndReturnClauses$aliasUnaliasedReturnItems$lambda$_39_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        if (var$1 instanceof oncia_UnaliasedReturnItem) {
            var$2 = var$1;
            var$3 = var$2.$alias0;
            var$1 = new $java.oncirr_normalizeWithAndReturnClauses$$anonfun$aliasUnaliasedReturnItems$1$lambda$_68_0;
            var$1.$_0311 = var$2;
            var$3 = s_Option_getOrElse(var$3, var$1);
            var$1 = oncia_AliasedReturnItem__init_(var$2.$expression9, var$3, var$2.$position10);
        }
        return var$1;
    };
    $java.scc_JavaCollectionWrappers$IterableWrapperTrait = $rt_classWithoutFields(0);
    var scc_JavaCollectionWrappers$MutableBufferWrapper = $rt_classWithoutFields(ju_AbstractList);
    function scc_JavaCollectionWrappers$JListWrapper() {
        scm_AbstractBuffer.call(this);
        this.$underlying14 = null;
    }
    $java.scc_JavaCollectionWrappers$JListWrapper_knownSize = function($this) {
        if (!$this.$underlying14.$isEmpty())
            return (-1);
        return 0;
    };
    $java.scc_JavaCollectionWrappers$JListWrapper_iterator = function($this) {
        return scc_AsScalaExtensions$IteratorHasAsScala_asScala(scc_AsScalaExtensions$IteratorHasAsScala__init_(sj_CollectionConverters$_MODULE$, $this.$underlying14.$iterator()));
    };
    $java.scc_JavaCollectionWrappers$JListWrapper_iterableFactory = function($this) {
        return scm_ArrayBuffer$_MODULE$;
    };
    function oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1() {
        sr_AbstractPartialFunction.call(this);
        this.$baseState$1 = null;
    }
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1_applyOrElse = function($this, $x1, $default) {
        var var$3, $p, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        if ($x1 instanceof oncie_Expression) {
            $default = $x1;
            $java.oncief_Exists$_$callClinit();
            onciu_InputPosition$_$callClinit();
            var$3 = onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$);
            $p = jur_Pattern_compile($rt_s(1377));
            var$5 = ju_ArrayList__init_();
            $p = jur_Pattern_matcher($p, $rt_s(1378));
            var$6 = 0;
            var$7 = 0;
            if (!jl_String_length($rt_s(1378))) {
                var$8 = $rt_createArray(jl_String, 1);
                var$8.data[0] = $rt_s(3);
            } else {
                while (jur_Matcher_find($p)) {
                    var$6 = var$6 + 1 | 0;
                    ju_ArrayList_add(var$5, jl_String_substring0($rt_s(1378), var$7, jur_Matcher_start($p)));
                    var$7 = jur_Matcher_end($p);
                }
                ju_ArrayList_add(var$5, jl_String_substring0($rt_s(1378), var$7, jl_String_length($rt_s(1378))));
                var$9 = var$6 + 1 | 0;
                a: {
                    while (true) {
                        var$9 = var$9 + (-1) | 0;
                        if (var$9 < 0)
                            break;
                        if (jl_String_length(ju_ArrayList_get(var$5, var$9)))
                            break a;
                        ju_ArrayList_remove(var$5, var$9);
                    }
                }
                if (var$9 < 0)
                    var$9 = 0;
                var$8 = ju_AbstractCollection_toArray(var$5, $rt_createArray(jl_String, var$9));
            }
            if (var$8.data.length == 1)
                var$10 = s_Tuple2__init_(oncie_Namespace__init_(oncie_Namespace$_apply$default$1(oncie_Namespace$_MODULE$), var$3), oncie_FunctionName__init_($rt_s(1378), var$3));
            else {
                var$10 = new s_Tuple2;
                var$5 = new oncie_Namespace;
                s_Predef$_$callClinit();
                var$11 = sc_ArrayOps$_dropRight$extension(sc_ArrayOps$_MODULE$, var$8, 1);
                if (var$11 === null)
                    $p = null;
                else if (var$11.data.length)
                    $p = $java.scm_ArraySeq$ofRef__init_(var$11);
                else {
                    sr_ClassTag$_$callClinit();
                    sr_ClassTag$_AnyRef(sr_ClassTag$_MODULE$);
                    $p = $java.scm_ArraySeq$_EmptyArraySeq;
                }
                $java.oncie_Namespace__init_(var$5, sc_IterableOnceOps_toList$($p), var$3);
                var$12 = new oncie_FunctionName;
                if (!(!jlr_Array_getLength(var$8) ? 0 : 1)) {
                    $default = new ju_NoSuchElementException;
                    jl_Throwable__init_($default, $rt_s(1379));
                    $rt_throw($default);
                }
                $java.oncie_FunctionName__init_(var$12, sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, var$8, jlr_Array_getLength(var$8) - 1 | 0), var$3);
                s_Tuple2__init_0(var$10, var$5, var$12);
            }
            b: {
                var$10 = s_Tuple2__init_(var$10.$_10, var$10.$_20);
                $p = var$10.$_10;
                var$5 = var$10.$_20;
                if ($default instanceof oncie_FunctionInvocation)
                    c: {
                        d: {
                            $default = $default;
                            var$12 = $default.$namespace1;
                            var$10 = $default.$functionName0;
                            $default = $default.$args;
                            if (var$5 !== null) {
                                if (!$java.oncie_FunctionName_equals(var$5, var$10))
                                    break c;
                                else
                                    break d;
                            }
                            if (var$10 !== null)
                                break c;
                        }
                        e: {
                            if (var$12 !== null) {
                                if (!$java.oncie_Namespace_equals(var$12, $p))
                                    break c;
                                else
                                    break e;
                            }
                            if ($p !== null)
                                break c;
                        }
                        $p = s_Some__init_($default.$head());
                        break b;
                    }
                $p = s_None$_MODULE$;
            }
            if (!s_Option_isEmpty($p))
                return new $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_0;
        }
        if ($x1 instanceof oncie_FunctionInvocation) {
            $default = $x1;
            $p = $default.$functionName0;
            var$5 = $default.$args;
            if ($p !== null && jl_String_equals($rt_s(1380), $p.$name6) && var$5 instanceof sci_Vector) {
                $default = var$5;
                s_package$_$callClinit();
                s_package$_Vector0(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $default);
                if (!$default.$lengthCompare(1)) {
                    $p = $default.$apply1(0);
                    if ($p instanceof oncie_PatternExpression) {
                        $default = $p;
                        if (!oncifp_ExpectedBooleanTypeCheck_isExpectedTypeBoolean$(oncifp_PatternExpressionInNonExistenceCheck$_MODULE$, oncifp_InitialState_semanticTable($this.$baseState$1), $default)) {
                            $x1 = new $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_1;
                            $x1.$_0312 = $default;
                            return $x1;
                        }
                    }
                }
            }
        }
        if ($x1 instanceof oncie_PatternExpression) {
            $x1 = $x1;
            if (!oncifp_ExpectedBooleanTypeCheck_isExpectedTypeBoolean$(oncifp_PatternExpressionInNonExistenceCheck$_MODULE$, oncifp_InitialState_semanticTable($this.$baseState$1), $x1)) {
                $default = new $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_2;
                $default.$_0313 = $x1;
                return $default;
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    function oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$semanticTable$1 = null;
        a.$baseContext$1 = null;
    }
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1_applyOrElse = function($this, $x1, $default) {
        var $p;
        if (!($x1 instanceof oncia_Create))
            return s_PartialFunction$_fallback_fn;
        $p = $x1.$pattern;
        $x1 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0;
        $x1.$_0314 = $this;
        $x1.$_193 = $p;
        return $x1;
    };
    function oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1() {
        sr_AbstractPartialFunction.call(this);
        this.$baseState$2 = null;
    }
    $java.oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1_applyOrElse = function($this, $x1, $default) {
        var var$3, var$4;
        if ($x1 instanceof oncie_Expression) {
            $x1 = $x1;
            $default = oncifp_InitialState_semanticTable($this.$baseState$2);
            var$3 = $default.$types.$get1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $x1));
            var$4 = new $java.oncifp_ListCoercedToBooleanCheck$$org$neo4j$cypher$internal$frontend$phases$ListCoercedToBooleanCheck$$isListCoercedToBoolean$lambda$_2_0;
            var$4.$_0315 = $default;
            var$4.$_194 = $x1;
            if (s_Option_exists(var$3, var$4) && !($x1 instanceof oncie_PatternExpression)) {
                $default = new $java.oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1$applyOrElse$lambda$_0_0;
                $default.$_0316 = $x1;
                return $default;
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    function oncia_ReturnItems() {
        var a = this; jl_Object.call(a);
        a.$includeExisting = 0;
        a.$items = null;
        a.$defaultOrderOnColumns = null;
        a.$position28 = null;
    }
    function oncia_ReturnItems__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_ReturnItems();
        $java.oncia_ReturnItems__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function oncia_ReturnItems_includeExisting($this) {
        return $this.$includeExisting;
    }
    $java.oncia_ReturnItems_position = function($this) {
        return $this.$position28;
    };
    function oncia_ReturnItems_withDefaultOrderOnColumns($this, $defaultOrderOnColumns) {
        var $x$1;
        $x$1 = s_Some__init_($defaultOrderOnColumns);
        return oncia_ReturnItems_copy($this, $this.$includeExisting, $this.$items, $x$1, $this.$position28);
    }
    function oncia_ReturnItems_semanticCheck($this) {
        return ($java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension($java.oncias_SemanticCheckableIterableOnce$_MODULE$, $this.$items)).$chain($java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, sc_AbstractIterable_groupBy($this.$items, new $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_0), new $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_1));
    }
    function oncia_ReturnItems_declareVariables($this, $previousScope) {
        var var$2, var$3, var$4, var$5, var$6;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = $this.$includeExisting;
        var$4 = new $java.oncia_ReturnItems$declareVariables$lambda$_60_0;
        var$4.$_0317 = $previousScope;
        var$2 = oncias_SemanticCheck$_when(var$2, var$3, var$4);
        var$4 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$5 = $this.$items;
        var$6 = new $java.oncia_ReturnItems$declareVariables$lambda$_60_1;
        var$6.$_0318 = $this;
        var$6.$_195 = $previousScope;
        return var$2.$chain($java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$4, var$5, var$6));
    }
    $java.oncia_ReturnItems_returnVariables = function($this) {
        return $java.oncia_ReturnItems$ReturnVariables__init_($this.$includeExisting, $this.$items.$flatMap(new $java.oncia_ReturnItems$returnVariables$lambda$_62_0));
    };
    function oncia_ReturnItems_containsAggregate($this) {
        return $this.$items.$exists(new $java.oncia_ReturnItems$containsAggregate$lambda$_63_0);
    }
    function oncia_ReturnItems_copy($this, $includeExisting, $items, $defaultOrderOnColumns, $position) {
        return oncia_ReturnItems__init_($includeExisting, $items, $defaultOrderOnColumns, $position);
    }
    $java.oncia_ReturnItems_productPrefix = function($this) {
        return $rt_s(1381);
    };
    $java.oncia_ReturnItems_productArity = function($this) {
        return 3;
    };
    $java.oncia_ReturnItems_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$includeExisting);
            case 1:
                return $this.$items;
            case 2:
                return $this.$defaultOrderOnColumns;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ReturnItems_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ReturnItems_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1381))), !$this.$includeExisting ? 1237 : 1231), sr_Statics_anyHash($this.$items)), sr_Statics_anyHash($this.$defaultOrderOnColumns)), 3);
    };
    $java.oncia_ReturnItems_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    function oncia_ReturnItems_equals($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ReturnItems) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$includeExisting != $x$1.$includeExisting)
                            break b;
                        d: {
                            var$2 = $this.$items;
                            var$3 = $x$1.$items;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$defaultOrderOnColumns;
                        $x$1 = $x$1.$defaultOrderOnColumns;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    }
    $java.oncia_ReturnItems_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ReturnItems__init_ = function($this, $includeExisting, $items, $defaultOrderOnColumns, $position) {
        $this.$includeExisting = $includeExisting;
        $this.$items = $items;
        $this.$defaultOrderOnColumns = $defaultOrderOnColumns;
        $this.$position28 = $position;
    };
    var sci_MapKeyValueTupleIterator = $rt_classWithoutFields(sci_ChampBaseIterator);
    $java.sci_MapKeyValueTupleIterator_iterator = function($this) {
        return $this;
    };
    $java.sci_MapKeyValueTupleIterator_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.sci_MapKeyValueTupleIterator_filter = function($this, $p) {
        return sc_Iterator_filter$($this, $p);
    };
    $java.sci_MapKeyValueTupleIterator_filterImpl = function($this, $p, $isFlipped) {
        return sc_Iterator_filterImpl$($this, $p, $isFlipped);
    };
    $java.sci_MapKeyValueTupleIterator_collect = function($this, $pf) {
        return sc_Iterator_collect$($this, $pf);
    };
    $java.sci_MapKeyValueTupleIterator_map = function($this, $f) {
        return sc_Iterator_map$($this, $f);
    };
    $java.sci_MapKeyValueTupleIterator_flatMap = function($this, $f) {
        return sc_Iterator_flatMap$($this, $f);
    };
    $java.sci_MapKeyValueTupleIterator_concat = function($this, $xs) {
        return sc_Iterator_concat$($this, $xs);
    };
    $java.sci_MapKeyValueTupleIterator_toString = function($this) {
        return $rt_s(466);
    };
    $java.sci_MapKeyValueTupleIterator_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.sci_MapKeyValueTupleIterator_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.sci_MapKeyValueTupleIterator_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.sci_MapKeyValueTupleIterator_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.sci_MapKeyValueTupleIterator_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.sci_MapKeyValueTupleIterator_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.sci_MapKeyValueTupleIterator_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.sci_MapKeyValueTupleIterator_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.sci_MapKeyValueTupleIterator_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.sci_MapKeyValueTupleIterator_to = function($this, $factory) {
        return $factory.$fromSpecific($this);
    };
    $java.sci_MapKeyValueTupleIterator_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.sci_MapKeyValueTupleIterator_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.sci_MapKeyValueTupleIterator_knownSize = function($this) {
        return (-1);
    };
    $java.sci_MapKeyValueTupleIterator_next = function($this) {
        var var$1;
        if (!sci_ChampBaseIterator_hasNext($this)) {
            var$1 = new ju_NoSuchElementException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        var$1 = $this.$currentValueNode.$getPayload0($this.$currentValueCursor);
        $this.$currentValueCursor = $this.$currentValueCursor + 1 | 0;
        return var$1;
    };
    function sci_Set$Set4$$anon$3() {
        sci_Set$SetNIterator.call(this);
        this.$$outer19 = null;
    }
    $java.sci_Set$Set4$$anon$3_apply = function($this, $i) {
        var var$2;
        a: {
            var$2 = $this.$$outer19;
            switch ($i) {
                case 0:
                    break;
                case 1:
                    var$2 = var$2.$elem2;
                    break a;
                case 2:
                    var$2 = var$2.$elem3;
                    break a;
                case 3:
                    var$2 = var$2.$elem4;
                    break a;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf($i)));
            }
            var$2 = var$2.$elem1;
        }
        return var$2;
    };
    $java.scc_AsJavaExtensions = $rt_classWithoutFields(0);
    $java.scc_AsScalaExtensions = $rt_classWithoutFields(0);
    var sj_CollectionConverters$ = $rt_classWithoutFields();
    var sj_CollectionConverters$_MODULE$ = null;
    function sj_CollectionConverters$__clinit_() {
        sj_CollectionConverters$_MODULE$ = new sj_CollectionConverters$;
    }
    function sj_CollectionConverters$_ListHasAsScala($this, $l) {
        var var$2;
        var$2 = new scc_AsScalaExtensions$ListHasAsScala;
        var$2.$l = $l;
        var$2.$$outer27 = $this;
        return var$2;
    }
    function sj_CollectionConverters$_MapHasAsScala($this, $m) {
        var var$2;
        var$2 = new scc_AsScalaExtensions$MapHasAsScala;
        var$2.$m = $m;
        var$2.$$outer28 = $this;
        return var$2;
    }
    function scc_AsScalaExtensions$IteratorHasAsScala() {
        var a = this; jl_Object.call(a);
        a.$i1 = null;
        a.$$outer29 = null;
    }
    function scc_AsScalaExtensions$IteratorHasAsScala__init_(var_0, var_1) {
        var var_2 = new scc_AsScalaExtensions$IteratorHasAsScala();
        $java.scc_AsScalaExtensions$IteratorHasAsScala__init_(var_2, var_0, var_1);
        return var_2;
    }
    function scc_AsScalaExtensions$IteratorHasAsScala_asScala($this) {
        var var$1, var$2;
        var$1 = $this.$i1;
        if (var$1 === null)
            var$2 = null;
        else if (var$1 instanceof $java.scc_JavaCollectionWrappers$IteratorWrapper)
            var$2 = var$1.$underlying21();
        else {
            var$2 = new $java.scc_JavaCollectionWrappers$JIteratorWrapper;
            var$2.$underlying22 = var$1;
        }
        return var$2;
    }
    $java.scc_AsScalaExtensions$IteratorHasAsScala__init_ = function($this, $$outer, $i) {
        $this.$i1 = $i;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer29 = $$outer;
    };
    function sci_HashCollisionMapNode() {
        var a = this; sci_MapNode.call(a);
        a.$originalHash1 = 0;
        a.$hash5 = 0;
        a.$content4 = null;
    }
    $java.sci_HashCollisionMapNode__init_ = function(var_0, var_1, var_2) {
        var var_3 = new sci_HashCollisionMapNode();
        sci_HashCollisionMapNode__init_(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.sci_HashCollisionMapNode_originalHash = function($this) {
        return $this.$originalHash1;
    };
    $java.sci_HashCollisionMapNode_hash = function($this) {
        return $this.$hash5;
    };
    $java.sci_HashCollisionMapNode_content = function($this) {
        return $this.$content4;
    };
    function sci_HashCollisionMapNode_indexOf($this, $key) {
        var $iter, $i;
        $iter = sci_Vector_iterator($this.$content4);
        $i = 0;
        while (true) {
            if (!sci_NewVectorIterator_hasNext($iter))
                return (-1);
            if (sr_BoxesRunTime_equals((sci_NewVectorIterator_next($iter)).$_10, $key))
                break;
            $i = $i + 1 | 0;
        }
        return $i;
    }
    $java.sci_HashCollisionMapNode_size = function($this) {
        return sci_Vector_length($this.$content4);
    };
    $java.sci_HashCollisionMapNode_apply = function($this, $key, $originalHash, $hash, $shift) {
        var $getOrElse_this;
        $getOrElse_this = $java.sci_HashCollisionMapNode_get($this, $key, $originalHash, $hash, $shift);
        if ($getOrElse_this === null)
            $rt_throw(null);
        if (!s_Option_isEmpty($getOrElse_this))
            return $getOrElse_this.$get0();
        $key = new ju_NoSuchElementException;
        jl_Throwable__init_0($key);
        $rt_throw($key);
    };
    $java.sci_HashCollisionMapNode_get = function($this, $key, $originalHash, $hash, $shift) {
        var $index;
        if ($this.$hash5 != $hash)
            return s_None$_MODULE$;
        $index = sci_HashCollisionMapNode_indexOf($this, $key);
        if ($index < 0)
            return s_None$_MODULE$;
        return s_Some__init_(($this.$content4.$apply1($index)).$_20);
    };
    $java.sci_HashCollisionMapNode_getOrElse = function($this, $key, $originalHash, $hash, $shift, $f) {
        if ($this.$hash5 != $hash)
            return $f.$apply2();
        $originalHash = sci_HashCollisionMapNode_indexOf($this, $key);
        switch ($originalHash) {
            case -1:
                break;
            default:
                return ($this.$content4.$apply1($originalHash)).$_20;
        }
        return $f.$apply2();
    };
    $java.sci_HashCollisionMapNode_containsKey = function($this, $key, $originalHash, $hash, $shift) {
        if ($this.$hash5 == $hash && sci_HashCollisionMapNode_indexOf($this, $key) >= 0)
            return 1;
        return 0;
    };
    $java.sci_HashCollisionMapNode_updated = function($this, $key, $value, $originalHash, $hash, $shift, $replaceValue) {
        var $index;
        $index = sci_HashCollisionMapNode_indexOf($this, $key);
        if ($index < 0)
            return $java.sci_HashCollisionMapNode__init_($originalHash, $hash, $this.$content4.$appended1(s_Tuple2__init_($key, $value)));
        if (!$replaceValue)
            return $this;
        if (($this.$content4.$apply1($index)).$_20 === $value)
            return $this;
        return $java.sci_HashCollisionMapNode__init_($originalHash, $hash, $this.$content4.$updated2($index, s_Tuple2__init_($key, $value)));
    };
    $java.sci_HashCollisionMapNode_removed = function($this, $key, $originalHash, $hash, $shift) {
        var $v, $updatedContent, $k, $maskFrom_shift, var$9, var$10;
        if (!$java.sci_HashCollisionMapNode_containsKey($this, $key, $originalHash, $hash, $shift))
            return $this;
        $v = $this.$content4;
        $updatedContent = new $java.sci_HashCollisionMapNode$removed$lambda$_13_0;
        $updatedContent.$_0319 = $key;
        $updatedContent = sc_StrictOptimizedIterableOps_filterNot$($v, $updatedContent);
        if ($updatedContent === null)
            $rt_throw(null);
        switch (sci_Vector_length($updatedContent)) {
            case 1:
                $key = $updatedContent.$apply1(0);
                if ($key === null)
                    $rt_throw(s_MatchError__init_(null));
                $k = $key.$_10;
                $v = $key.$_20;
                $key = new sci_BitmapIndexedMapNode;
                $maskFrom_shift = 1 << ($hash >>> 0 & 31);
                var$9 = $rt_createArrayFromData(jl_Object, [$k, $v]);
                var$10 = $rt_createIntArray(1);
                var$10.data[0] = $originalHash;
                sci_BitmapIndexedMapNode__init_0($key, $maskFrom_shift, 0, var$9, var$10, 1, $hash);
                return $key;
            default:
        }
        return $java.sci_HashCollisionMapNode__init_($originalHash, $hash, $updatedContent);
    };
    $java.sci_HashCollisionMapNode_hasNodes = function($this) {
        return 0;
    };
    $java.sci_HashCollisionMapNode_nodeArity = function($this) {
        return 0;
    };
    $java.sci_HashCollisionMapNode_hasPayload = function($this) {
        return 1;
    };
    $java.sci_HashCollisionMapNode_payloadArity = function($this) {
        return sci_Vector_length($this.$content4);
    };
    $java.sci_HashCollisionMapNode_getKey = function($this, $index) {
        return ($java.sci_HashCollisionMapNode_getPayload($this, $index)).$_10;
    };
    $java.sci_HashCollisionMapNode_getValue = function($this, $index) {
        return ($java.sci_HashCollisionMapNode_getPayload($this, $index)).$_20;
    };
    $java.sci_HashCollisionMapNode_getPayload = function($this, $index) {
        return $this.$content4.$apply1($index);
    };
    $java.sci_HashCollisionMapNode_getHash = function($this, $index) {
        return $this.$originalHash1;
    };
    $java.sci_HashCollisionMapNode_foreach = function($this, $f) {
        var $foreach_this, $foreach_c, $foreach_i, $foreach_foreachRec_this, $foreach_vectorSliceDim_c, $foreach_foreachRec_level, $foreach_foreachRec_a, $foreach_foreachRec_i, $foreach_foreachRec_len, $foreach_foreachRec_l, $foreachRec_l, $foreachRec_a, $foreachRec_i, $foreachRec_len;
        $foreach_this = $this.$content4;
        if ($foreach_this === null)
            $rt_throw(null);
        $foreach_c = $foreach_this.$vectorSliceCount();
        $foreach_i = 0;
        while ($foreach_i < $foreach_c) {
            a: {
                $foreach_foreachRec_this = sci_VectorStatics$_MODULE$;
                $foreach_vectorSliceDim_c = $foreach_c / 2 | 0;
                $foreach_foreachRec_level = (($foreach_vectorSliceDim_c + 1 | 0) - jl_Math_abs($foreach_i - $foreach_vectorSliceDim_c | 0) | 0) - 1 | 0;
                $foreach_foreachRec_a = ($foreach_this.$vectorSlice($foreach_i)).data;
                $foreach_foreachRec_i = 0;
                $foreach_foreachRec_len = $foreach_foreachRec_a.length;
                if (!$foreach_foreachRec_level)
                    while (true) {
                        if ($foreach_foreachRec_i >= $foreach_foreachRec_len)
                            break a;
                        $f.$apply($foreach_foreachRec_a[$foreach_foreachRec_i]);
                        $foreach_foreachRec_i = $foreach_foreachRec_i + 1 | 0;
                    }
                $foreach_foreachRec_l = $foreach_foreachRec_level - 1 | 0;
                $foreach_vectorSliceDim_c = $rt_compare($foreach_foreachRec_l, 0);
                $foreachRec_l = $foreach_foreachRec_l - 1 | 0;
                while (true) {
                    if ($foreach_foreachRec_i >= $foreach_foreachRec_len)
                        break a;
                    b: {
                        $foreachRec_a = $foreach_foreachRec_a[$foreach_foreachRec_i].data;
                        $foreachRec_i = 0;
                        $foreachRec_len = $foreachRec_a.length;
                        if (!$foreach_vectorSliceDim_c)
                            while (true) {
                                if ($foreachRec_i >= $foreachRec_len)
                                    break b;
                                $f.$apply($foreachRec_a[$foreachRec_i]);
                                $foreachRec_i = $foreachRec_i + 1 | 0;
                            }
                        while (true) {
                            if ($foreachRec_i >= $foreachRec_len)
                                break b;
                            sci_VectorStatics$_foreachRec($foreach_foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $f);
                            $foreachRec_i = $foreachRec_i + 1 | 0;
                        }
                    }
                    $foreach_foreachRec_i = $foreach_foreachRec_i + 1 | 0;
                }
            }
            $foreach_i = $foreach_i + 1 | 0;
        }
    };
    $java.sci_HashCollisionMapNode_foreachEntry = function($this, $f) {
        var $foreach_this, $foreach_f, $foreach_c, $foreach_i, $foreach_foreachRec_this, $foreach_vectorSliceDim_c, $foreach_foreachRec_level, $foreach_foreachRec_a, $foreach_foreachRec_i, $foreach_foreachRec_len, $foreach_foreachRec_l, $foreachRec_l, $foreachRec_a, $foreachRec_i, $foreachRec_len, $$anonfun$foreachEntry$1_v;
        $foreach_this = $this.$content4;
        $foreach_f = new $java.sci_HashCollisionMapNode$foreachEntry$lambda$_24_0;
        $foreach_f.$_0320 = $f;
        if ($foreach_this === null)
            $rt_throw(null);
        $foreach_c = $foreach_this.$vectorSliceCount();
        $foreach_i = 0;
        while ($foreach_i < $foreach_c) {
            a: {
                $foreach_foreachRec_this = sci_VectorStatics$_MODULE$;
                $foreach_vectorSliceDim_c = $foreach_c / 2 | 0;
                $foreach_foreachRec_level = (($foreach_vectorSliceDim_c + 1 | 0) - jl_Math_abs($foreach_i - $foreach_vectorSliceDim_c | 0) | 0) - 1 | 0;
                $foreach_foreachRec_a = ($foreach_this.$vectorSlice($foreach_i)).data;
                $foreach_foreachRec_i = 0;
                $foreach_foreachRec_len = $foreach_foreachRec_a.length;
                if (!$foreach_foreachRec_level)
                    while (true) {
                        if ($foreach_foreachRec_i >= $foreach_foreachRec_len)
                            break a;
                        $foreach_foreachRec_this = $foreach_foreachRec_a[$foreach_foreachRec_i];
                        if ($foreach_foreachRec_this === null)
                            $rt_throw(s_MatchError__init_(null));
                        $f.$apply0($foreach_foreachRec_this.$_10, $foreach_foreachRec_this.$_20);
                        $foreach_foreachRec_i = $foreach_foreachRec_i + 1 | 0;
                    }
                $foreach_foreachRec_l = $foreach_foreachRec_level - 1 | 0;
                $foreach_vectorSliceDim_c = $rt_compare($foreach_foreachRec_l, 0);
                $foreachRec_l = $foreach_foreachRec_l - 1 | 0;
                while (true) {
                    if ($foreach_foreachRec_i >= $foreach_foreachRec_len)
                        break a;
                    b: {
                        $foreachRec_a = $foreach_foreachRec_a[$foreach_foreachRec_i].data;
                        $foreachRec_i = 0;
                        $foreachRec_len = $foreachRec_a.length;
                        if ($foreach_vectorSliceDim_c)
                            while (true) {
                                if ($foreachRec_i >= $foreachRec_len)
                                    break b;
                                sci_VectorStatics$_foreachRec($foreach_foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $foreach_f);
                                $foreachRec_i = $foreachRec_i + 1 | 0;
                            }
                        while (true) {
                            if ($foreachRec_i >= $foreachRec_len)
                                break b;
                            $$anonfun$foreachEntry$1_v = $foreachRec_a[$foreachRec_i];
                            if ($$anonfun$foreachEntry$1_v === null)
                                $rt_throw(s_MatchError__init_(null));
                            $f.$apply0($$anonfun$foreachEntry$1_v.$_10, $$anonfun$foreachEntry$1_v.$_20);
                            $foreachRec_i = $foreachRec_i + 1 | 0;
                        }
                    }
                    $foreach_foreachRec_i = $foreach_foreachRec_i + 1 | 0;
                }
            }
            $foreach_i = $foreach_i + 1 | 0;
        }
    };
    $java.sci_HashCollisionMapNode_foreachWithHash = function($this, $f) {
        var $iter, $next;
        $iter = sci_Vector_iterator($this.$content4);
        while (sci_NewVectorIterator_hasNext($iter)) {
            $next = sci_NewVectorIterator_next($iter);
            scm_HashMap$addAll$lambda$_42_0_apply($f, $next.$_10, $next.$_20, jl_Integer_valueOf($this.$originalHash1));
        }
    };
    $java.sci_HashCollisionMapNode_equals = function($this, $that) {
        var $iter, var$3, $key, $value, $index;
        if (!($that instanceof sci_HashCollisionMapNode))
            return 0;
        a: {
            b: {
                $that = $that;
                if ($this !== $that) {
                    if (!($this.$hash5 == $that.$hash5 && sci_Vector_length($this.$content4) == sci_Vector_length($that.$content4)))
                        return 0;
                    $iter = sci_Vector_iterator($this.$content4);
                    while (true) {
                        if (!sci_NewVectorIterator_hasNext($iter))
                            break b;
                        var$3 = sci_NewVectorIterator_next($iter);
                        if (var$3 === null)
                            $rt_throw(s_MatchError__init_(null));
                        $key = var$3.$_10;
                        $value = var$3.$_20;
                        $index = sci_HashCollisionMapNode_indexOf($that, $key);
                        if ($index < 0)
                            break a;
                        if (sr_BoxesRunTime_equals($value, ($that.$content4.$apply1($index)).$_20))
                            continue;
                        else
                            break a;
                    }
                }
            }
            return 1;
        }
        return 0;
    };
    $java.sci_HashCollisionMapNode_filterImpl = function($this, $pred, $flipped) {
        var $newContent, $filterImpl_i, $filterImpl_len, $filterImpl_bitmap, $filterImpl_k, $filterImpl_j, $filterImpl_newLen, $filterImpl_newData, $foreachRec_a, $filterImpl_b, $filterImpl_k_0, $filterImpl_foreachRest_this, $filterImpl_foreachRest_f, $filterImpl_foreachRest_c, $filterImpl_foreachRest_i, $filterImpl_foreachRest_foreachRec_this, $filterImpl_foreachRest_vectorSliceDim_c, $filterImpl_foreachRest_foreachRec_level, $filterImpl_foreachRest_foreachRec_a, $filterImpl_foreachRest_foreachRec_i, $filterImpl_foreachRest_foreachRec_len,
        $filterImpl_foreachRest_foreachRec_l, $foreachRec_l, $foreachRec_i, $foreachRec_len, $k, $filterImpl_foreachRest_f_0, $newContentLength, $v;
        $newContent = $java.sci_HashCollisionMapNode_content($this);
        if ($newContent === null)
            $rt_throw(null);
        $filterImpl_i = 0;
        $filterImpl_len = (sci_Vector_prefix1($newContent)).data.length;
        a: {
            while ($filterImpl_i != $filterImpl_len) {
                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply((sci_Vector_prefix1($newContent)).data[$filterImpl_i])) == $flipped) {
                    $filterImpl_bitmap = 0;
                    $filterImpl_k = $filterImpl_i + 1 | 0;
                    $filterImpl_j = $filterImpl_k;
                    while ($filterImpl_j < $filterImpl_len) {
                        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply((sci_Vector_prefix1($newContent)).data[$filterImpl_j])) != $flipped)
                            $filterImpl_bitmap = $filterImpl_bitmap | 1 << $filterImpl_j;
                        $filterImpl_j = $filterImpl_j + 1 | 0;
                    }
                    $filterImpl_newLen = $filterImpl_i + jl_Integer_bitCount($filterImpl_bitmap) | 0;
                    if (!($newContent instanceof sci_BigVector)) {
                        if (!$filterImpl_newLen) {
                            sci_Vector0$_$callClinit();
                            $newContent = sci_Vector0$_MODULE$;
                            break a;
                        }
                        $filterImpl_newData = $rt_createArray(jl_Object, $filterImpl_newLen);
                        $foreachRec_a = $filterImpl_newData.data;
                        jl_System_arraycopy(sci_Vector_prefix1($newContent), 0, $filterImpl_newData, 0, $filterImpl_i);
                        while ($filterImpl_i != $filterImpl_newLen) {
                            if (1 << $filterImpl_k & $filterImpl_bitmap) {
                                $foreachRec_a[$filterImpl_i] = (sci_Vector_prefix1($newContent)).data[$filterImpl_k];
                                $filterImpl_i = $filterImpl_i + 1 | 0;
                            }
                            $filterImpl_k = $filterImpl_k + 1 | 0;
                        }
                        $newContent = sci_Vector1__init_($filterImpl_newData);
                        break a;
                    }
                    $filterImpl_b = sci_VectorBuilder__init_();
                    $filterImpl_k_0 = 0;
                    while ($filterImpl_k_0 < $filterImpl_i) {
                        sci_VectorBuilder_addOne($filterImpl_b, (sci_Vector_prefix1($newContent)).data[$filterImpl_k_0]);
                        $filterImpl_k_0 = $filterImpl_k_0 + 1 | 0;
                    }
                    while ($filterImpl_i != $filterImpl_newLen) {
                        if (1 << $filterImpl_k & $filterImpl_bitmap) {
                            sci_VectorBuilder_addOne($filterImpl_b, (sci_Vector_prefix1($newContent)).data[$filterImpl_k]);
                            $filterImpl_i = $filterImpl_i + 1 | 0;
                        }
                        $filterImpl_k = $filterImpl_k + 1 | 0;
                    }
                    $filterImpl_foreachRest_this = $newContent;
                    $filterImpl_foreachRest_f = $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0__init_($pred, $flipped, $filterImpl_b);
                    $filterImpl_foreachRest_c = $filterImpl_foreachRest_this.$vectorSliceCount();
                    $filterImpl_foreachRest_i = 1;
                    while ($filterImpl_foreachRest_i < $filterImpl_foreachRest_c) {
                        b: {
                            $filterImpl_foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                            $filterImpl_foreachRest_vectorSliceDim_c = $filterImpl_foreachRest_c / 2 | 0;
                            $filterImpl_foreachRest_foreachRec_level = (($filterImpl_foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($filterImpl_foreachRest_i - $filterImpl_foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                            $filterImpl_foreachRest_foreachRec_a = ($filterImpl_foreachRest_this.$vectorSlice($filterImpl_foreachRest_i)).data;
                            $filterImpl_foreachRest_foreachRec_i = 0;
                            $filterImpl_foreachRest_foreachRec_len = $filterImpl_foreachRest_foreachRec_a.length;
                            if (!$filterImpl_foreachRest_foreachRec_level)
                                while (true) {
                                    if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                        break b;
                                    $filterImpl_foreachRest_foreachRec_this = $filterImpl_foreachRest_foreachRec_a[$filterImpl_foreachRest_foreachRec_i];
                                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_foreachRest_foreachRec_this)) != $flipped)
                                        sci_VectorBuilder_addOne($filterImpl_b, $filterImpl_foreachRest_foreachRec_this);
                                    $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                                }
                            $filterImpl_foreachRest_foreachRec_l = $filterImpl_foreachRest_foreachRec_level - 1 | 0;
                            $filterImpl_foreachRest_vectorSliceDim_c = $rt_compare($filterImpl_foreachRest_foreachRec_l, 0);
                            $foreachRec_l = $filterImpl_foreachRest_foreachRec_l - 1 | 0;
                            while (true) {
                                if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                    break b;
                                c: {
                                    $foreachRec_a = $filterImpl_foreachRest_foreachRec_a[$filterImpl_foreachRest_foreachRec_i].data;
                                    $foreachRec_i = 0;
                                    $foreachRec_len = $foreachRec_a.length;
                                    if ($filterImpl_foreachRest_vectorSliceDim_c)
                                        while (true) {
                                            if ($foreachRec_i >= $foreachRec_len)
                                                break c;
                                            sci_VectorStatics$_foreachRec($filterImpl_foreachRest_foreachRec_this, $foreachRec_l, $foreachRec_a[$foreachRec_i], $filterImpl_foreachRest_f);
                                            $foreachRec_i = $foreachRec_i + 1 | 0;
                                        }
                                    while (true) {
                                        if ($foreachRec_i >= $foreachRec_len)
                                            break c;
                                        $k = $foreachRec_a[$foreachRec_i];
                                        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($k)) != $flipped)
                                            sci_VectorBuilder_addOne($filterImpl_b, $k);
                                        $foreachRec_i = $foreachRec_i + 1 | 0;
                                    }
                                }
                                $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                            }
                        }
                        $filterImpl_foreachRest_i = $filterImpl_foreachRest_i + 1 | 0;
                    }
                    $newContent = sci_VectorBuilder_result($filterImpl_b);
                    break a;
                }
                $filterImpl_i = $filterImpl_i + 1 | 0;
            }
            if ($newContent instanceof sci_BigVector) {
                $filterImpl_b = sci_VectorBuilder__init_();
                sci_VectorBuilder_initFrom($filterImpl_b, sci_Vector_prefix1($newContent));
                $filterImpl_foreachRest_this = $newContent;
                $filterImpl_foreachRest_f_0 = $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1__init_($pred, $flipped, $filterImpl_b);
                $filterImpl_foreachRest_c = $filterImpl_foreachRest_this.$vectorSliceCount();
                $filterImpl_foreachRest_i = 1;
                while ($filterImpl_foreachRest_i < $filterImpl_foreachRest_c) {
                    d: {
                        $filterImpl_foreachRest_foreachRec_this = sci_VectorStatics$_MODULE$;
                        $filterImpl_foreachRest_vectorSliceDim_c = $filterImpl_foreachRest_c / 2 | 0;
                        $filterImpl_foreachRest_foreachRec_level = (($filterImpl_foreachRest_vectorSliceDim_c + 1 | 0) - jl_Math_abs($filterImpl_foreachRest_i - $filterImpl_foreachRest_vectorSliceDim_c | 0) | 0) - 1 | 0;
                        $filterImpl_newData = ($filterImpl_foreachRest_this.$vectorSlice($filterImpl_foreachRest_i)).data;
                        $filterImpl_foreachRest_foreachRec_i = 0;
                        $filterImpl_foreachRest_foreachRec_len = $filterImpl_newData.length;
                        if (!$filterImpl_foreachRest_foreachRec_level)
                            while (true) {
                                if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                    break d;
                                $filterImpl_foreachRest_foreachRec_this = $filterImpl_newData[$filterImpl_foreachRest_foreachRec_i];
                                if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_foreachRest_foreachRec_this)) != $flipped)
                                    sci_VectorBuilder_addOne($filterImpl_b, $filterImpl_foreachRest_foreachRec_this);
                                $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                            }
                        $filterImpl_foreachRest_foreachRec_l = $filterImpl_foreachRest_foreachRec_level - 1 | 0;
                        $filterImpl_k_0 = $rt_compare($filterImpl_foreachRest_foreachRec_l, 0);
                        $foreachRec_l = $filterImpl_foreachRest_foreachRec_l - 1 | 0;
                        while (true) {
                            if ($filterImpl_foreachRest_foreachRec_i >= $filterImpl_foreachRest_foreachRec_len)
                                break d;
                            e: {
                                $filterImpl_foreachRest_foreachRec_a = $filterImpl_newData[$filterImpl_foreachRest_foreachRec_i].data;
                                $foreachRec_i = 0;
                                $foreachRec_len = $filterImpl_foreachRest_foreachRec_a.length;
                                if ($filterImpl_k_0)
                                    while (true) {
                                        if ($foreachRec_i >= $foreachRec_len)
                                            break e;
                                        sci_VectorStatics$_foreachRec($filterImpl_foreachRest_foreachRec_this, $foreachRec_l, $filterImpl_foreachRest_foreachRec_a[$foreachRec_i], $filterImpl_foreachRest_f_0);
                                        $foreachRec_i = $foreachRec_i + 1 | 0;
                                    }
                                while (true) {
                                    if ($foreachRec_i >= $foreachRec_len)
                                        break e;
                                    $filterImpl_foreachRest_f = $filterImpl_foreachRest_foreachRec_a[$foreachRec_i];
                                    if (sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_foreachRest_f)) != $flipped)
                                        sci_VectorBuilder_addOne($filterImpl_b, $filterImpl_foreachRest_f);
                                    $foreachRec_i = $foreachRec_i + 1 | 0;
                                }
                            }
                            $filterImpl_foreachRest_foreachRec_i = $filterImpl_foreachRest_foreachRec_i + 1 | 0;
                        }
                    }
                    $filterImpl_foreachRest_i = $filterImpl_foreachRest_i + 1 | 0;
                }
                $newContent = sci_VectorBuilder_result($filterImpl_b);
            }
        }
        $newContentLength = sci_Vector_length($newContent);
        if (!$newContentLength) {
            sci_MapNode$_$callClinit();
            return sci_MapNode$_empty(sci_MapNode$_MODULE$);
        }
        if ($newContentLength != 1) {
            if ($newContentLength == sci_Vector_length($java.sci_HashCollisionMapNode_content($this)))
                return $this;
            return $java.sci_HashCollisionMapNode__init_($java.sci_HashCollisionMapNode_originalHash($this), $java.sci_HashCollisionMapNode_hash($this), $newContent);
        }
        $pred = sci_Vector_head($newContent);
        if ($pred === null)
            $rt_throw(s_MatchError__init_(null));
        $k = s_Tuple2__1($pred);
        $v = s_Tuple2__2($pred);
        $pred = new sci_BitmapIndexedMapNode;
        $filterImpl_k_0 = 1 << ($java.sci_HashCollisionMapNode_hash($this) >>> 0 & 31);
        $filterImpl_foreachRest_foreachRec_a = $rt_createArrayFromData(jl_Object, [$k, $v]);
        $foreachRec_a = $rt_createIntArray(1);
        $foreachRec_a.data[0] = $java.sci_HashCollisionMapNode_originalHash($this);
        sci_BitmapIndexedMapNode__init_0($pred, $filterImpl_k_0, 0, $filterImpl_foreachRest_foreachRec_a, $foreachRec_a, 1, $java.sci_HashCollisionMapNode_hash($this));
        return $pred;
    };
    $java.sci_HashCollisionMapNode_hashCode = function($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(472));
        $rt_throw(var$1);
    };
    $java.sci_HashCollisionMapNode_cachedJavaKeySetHashCode = function($this) {
        return $rt_imul($java.sci_HashCollisionMapNode_size($this), $this.$hash5);
    };
    $java.sci_HashCollisionMapNode_copy = function($this) {
        return $java.sci_HashCollisionMapNode__init_($this.$originalHash1, $this.$hash5, $this.$content4);
    };
    $java.sci_HashCollisionMapNode_concat = function($this, $that, $shift) {
        var var$3, var$4, var$5;
        if (!($that instanceof sci_HashCollisionMapNode)) {
            if (!($that instanceof sci_BitmapIndexedMapNode))
                $rt_throw(s_MatchError__init_($that));
            $that = new jl_UnsupportedOperationException;
            jl_Throwable__init_($that, $rt_s(516));
            $rt_throw($that);
        }
        $that = $that;
        if ($that !== $this) {
            var$3 = null;
            var$4 = sci_Vector_iterator($this.$content4);
            while (sci_NewVectorIterator_hasNext(var$4)) {
                var$5 = sci_NewVectorIterator_next(var$4);
                if (sci_HashCollisionMapNode_indexOf($that, var$5.$_10) >= 0)
                    continue;
                if (var$3 === null) {
                    var$3 = sci_VectorBuilder__init_();
                    sci_VectorBuilder_addAll(var$3, $that.$content4);
                }
                sci_VectorBuilder_addOne(var$3, var$5);
            }
            $this = var$3 === null ? $that : $java.sci_HashCollisionMapNode__init_($this.$originalHash1, $this.$hash5, sci_VectorBuilder_result(var$3));
        }
        return $this;
    };
    $java.sci_HashCollisionMapNode_getNode = function($this, $index) {
        var var$2;
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_(var$2, $rt_s(475));
        $rt_throw(var$2);
    };
    function sci_HashCollisionMapNode__init_($this, $originalHash, $hash, $content) {
        $this.$originalHash1 = $originalHash;
        $this.$hash5 = $hash;
        $this.$content4 = $content;
        s_Predef$_$callClinit();
        s_Predef$_require(s_Predef$_MODULE$, sci_Vector_length($content) < 2 ? 0 : 1);
    }
    var oncias_SemanticErrorDef = $rt_classWithoutFields(0);
    $java.sci_Map$Map4 = function() {
        var a = this; sci_AbstractMap.call(a);
        a.$scala$collection$immutable$Map$Map4$$key1 = null;
        a.$scala$collection$immutable$Map$Map4$$value1 = null;
        a.$scala$collection$immutable$Map$Map4$$key2 = null;
        a.$scala$collection$immutable$Map$Map4$$value2 = null;
        a.$scala$collection$immutable$Map$Map4$$key3 = null;
        a.$scala$collection$immutable$Map$Map4$$value3 = null;
        a.$scala$collection$immutable$Map$Map4$$key4 = null;
        a.$scala$collection$immutable$Map$Map4$$value4 = null;
    };
    $java.sci_Map$Map4__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new $java.sci_Map$Map4();
        $java.sci_Map$Map4__init_0(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    };
    $java.sci_Map$Map4_map = function($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    };
    $java.sci_Map$Map4_flatMap = function($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    };
    $java.sci_Map$Map4_collect = function($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    };
    $java.sci_Map$Map4_flatten = function($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    };
    $java.sci_Map$Map4_filter = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    };
    $java.sci_Map$Map4_filterNot = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    };
    $java.sci_Map$Map4_size = function($this) {
        return 4;
    };
    $java.sci_Map$Map4_knownSize = function($this) {
        return 4;
    };
    $java.sci_Map$Map4_isEmpty = function($this) {
        return 0;
    };
    $java.sci_Map$Map4_apply = function($this, $key) {
        var var$2, var$3;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key1))
            return $this.$scala$collection$immutable$Map$Map4$$value1;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key2))
            return $this.$scala$collection$immutable$Map$Map4$$value2;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key3))
            return $this.$scala$collection$immutable$Map$Map4$$value3;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key4))
            return $this.$scala$collection$immutable$Map$Map4$$value4;
        var$2 = new ju_NoSuchElementException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 15);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(389));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$3, $key)));
        $rt_throw(var$2);
    };
    $java.sci_Map$Map4_contains = function($this, $key) {
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key1) && !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key2) && !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key3) && !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key4))
            return 0;
        return 1;
    };
    $java.sci_Map$Map4_get = function($this, $key) {
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key1))
            return s_Some__init_($this.$scala$collection$immutable$Map$Map4$$value1);
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key2))
            return s_Some__init_($this.$scala$collection$immutable$Map$Map4$$value2);
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key3))
            return s_Some__init_($this.$scala$collection$immutable$Map$Map4$$value3);
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key4))
            return s_None$_MODULE$;
        return s_Some__init_($this.$scala$collection$immutable$Map$Map4$$value4);
    };
    $java.sci_Map$Map4_getOrElse = function($this, $key, $default) {
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key1))
            return $this.$scala$collection$immutable$Map$Map4$$value1;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key2))
            return $this.$scala$collection$immutable$Map$Map4$$value2;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key3))
            return $this.$scala$collection$immutable$Map$Map4$$value3;
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key4))
            return $default.$apply2();
        return $this.$scala$collection$immutable$Map$Map4$$value4;
    };
    $java.sci_Map$Map4_iterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map4$$anon$7;
        $java.sci_Map$Map4$Map4Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map4_keysIterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map4$$anon$8;
        $java.sci_Map$Map4$Map4Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map4_valuesIterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map4$$anon$9;
        $java.sci_Map$Map4$Map4Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map4_foreach = function($this, $f) {
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1));
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2));
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3));
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4));
    };
    $java.sci_Map$Map4_exists = function($this, $p) {
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1))) && !sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2))) && !sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3))) && !sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key4,
        $this.$scala$collection$immutable$Map$Map4$$value4))))
            return 0;
        return 1;
    };
    $java.sci_Map$Map4_forall = function($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1))) && sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2))) && sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key3,
        $this.$scala$collection$immutable$Map$Map4$$value3))) && sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4))))
            return 1;
        return 0;
    };
    $java.sci_Map$Map4_filterImpl = function($this, $pred, $isFlipped) {
        var $k1, $k2, $k3, $v1, $v2, $v3, $n;
        $k1 = null;
        $k2 = null;
        $k3 = null;
        $v1 = null;
        $v2 = null;
        $v3 = null;
        $n = 0;
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1))) != $isFlipped) {
            $k1 = $this.$scala$collection$immutable$Map$Map4$$key1;
            $v1 = $this.$scala$collection$immutable$Map$Map4$$value1;
            $n = 1;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2))) != $isFlipped) {
            if ($n) {
                $k2 = $this.$scala$collection$immutable$Map$Map4$$key2;
                $v2 = $this.$scala$collection$immutable$Map$Map4$$value2;
            } else {
                $k1 = $this.$scala$collection$immutable$Map$Map4$$key2;
                $v1 = $this.$scala$collection$immutable$Map$Map4$$value2;
            }
            $n = $n + 1 | 0;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3))) != $isFlipped) {
            if (!$n) {
                $k1 = $this.$scala$collection$immutable$Map$Map4$$key3;
                $v1 = $this.$scala$collection$immutable$Map$Map4$$value3;
            } else if ($n != 1) {
                $k3 = $this.$scala$collection$immutable$Map$Map4$$key3;
                $v3 = $this.$scala$collection$immutable$Map$Map4$$value3;
            } else {
                $k2 = $this.$scala$collection$immutable$Map$Map4$$key3;
                $v2 = $this.$scala$collection$immutable$Map$Map4$$value3;
            }
            $n = $n + 1 | 0;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4))) != $isFlipped) {
            if (!$n) {
                $k1 = $this.$scala$collection$immutable$Map$Map4$$key4;
                $v1 = $this.$scala$collection$immutable$Map$Map4$$value4;
            } else if ($n == 1) {
                $k2 = $this.$scala$collection$immutable$Map$Map4$$key4;
                $v2 = $this.$scala$collection$immutable$Map$Map4$$value4;
            } else if ($n == 2) {
                $k3 = $this.$scala$collection$immutable$Map$Map4$$key4;
                $v3 = $this.$scala$collection$immutable$Map$Map4$$value4;
            }
            $n = $n + 1 | 0;
        }
        switch ($n) {
            case 0:
                return sci_Map$EmptyMap$_MODULE$;
            case 1:
                return sci_Map$Map1__init_($k1, $v1);
            case 2:
                return $java.sci_Map$Map2__init_($k1, $v1, $k2, $v2);
            case 3:
                return $java.sci_Map$Map3__init_($k1, $v1, $k2, $v2, $k3, $v3);
            case 4:
                break;
            default:
                $rt_throw(s_MatchError__init_(jl_Integer_valueOf($n)));
        }
        return $this;
    };
    $java.sci_Map$Map4_hashCode = function($this) {
        var $h, $a, var$3, $c, $b;
        suh_MurmurHash3$_$callClinit();
        $h = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1);
        $a = 0 + $h | 0;
        var$3 = 0 ^ $h;
        $c = 1 * ($h | 1) | 0;
        $b = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2);
        $a = $a + $b | 0;
        $h = var$3 ^ $b;
        $b = $rt_imul($c, $b | 1);
        $c = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3);
        $a = $a + $c | 0;
        $h = $h ^ $c;
        $b = $rt_imul($b, $c | 1);
        $c = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4);
        $a = $a + $c | 0;
        $h = $h ^ $c;
        $b = $rt_imul($b, $c | 1);
        $c = suh_MurmurHash3$_mapSeed(suh_MurmurHash3$_MODULE$);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $c, $a);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $a, $h);
        $a = suh_MurmurHash3_mixLast(suh_MurmurHash3$_MODULE$, $a, $b);
        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(suh_MurmurHash3$_MODULE$, $a ^ 4);
    };
    $java.sci_Map$Map4_filterImpl0 = function($this, $pred, $isFlipped) {
        return $java.sci_Map$Map4_filterImpl($this, $pred, $isFlipped);
    };
    $java.sci_Map$Map4_removed = function($this, $key) {
        return sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key1) ? $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2, $this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3, $this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4) : sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key2) ? $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map4$$key1,
        $this.$scala$collection$immutable$Map$Map4$$value1, $this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3, $this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4) : sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key3) ? $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1, $this.$scala$collection$immutable$Map$Map4$$key2,
        $this.$scala$collection$immutable$Map$Map4$$value2, $this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4) : !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key4) ? $this : $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1, $this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2, $this.$scala$collection$immutable$Map$Map4$$key3,
        $this.$scala$collection$immutable$Map$Map4$$value3);
    };
    $java.sci_Map$Map4_updated = function($this, $key, $value) {
        var var$3;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key1))
            var$3 = $java.sci_Map$Map4__init_($this.$scala$collection$immutable$Map$Map4$$key1, $value, $this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2, $this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3, $this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4);
        else if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key2))
            var$3 = $java.sci_Map$Map4__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1, $this.$scala$collection$immutable$Map$Map4$$key2, $value, $this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3, $this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4);
        else if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key3))
            var$3 = $java.sci_Map$Map4__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1, $this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2, $this.$scala$collection$immutable$Map$Map4$$key3, $value, $this.$scala$collection$immutable$Map$Map4$$key4, $this.$scala$collection$immutable$Map$Map4$$value4);
        else if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map4$$key4))
            var$3 = $java.sci_Map$Map4__init_($this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1, $this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2, $this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3, $this.$scala$collection$immutable$Map$Map4$$key4, $value);
        else {
            sci_HashMap$_$callClinit();
            var$3 = sci_HashMap_updated(sci_HashMap_updated(sci_HashMap_updated(sci_HashMap_updated(sci_HashMap_updated(sci_HashMap$_empty(sci_HashMap$_MODULE$), $this.$scala$collection$immutable$Map$Map4$$key1, $this.$scala$collection$immutable$Map$Map4$$value1), $this.$scala$collection$immutable$Map$Map4$$key2, $this.$scala$collection$immutable$Map$Map4$$value2), $this.$scala$collection$immutable$Map$Map4$$key3, $this.$scala$collection$immutable$Map$Map4$$value3), $this.$scala$collection$immutable$Map$Map4$$key4,
            $this.$scala$collection$immutable$Map$Map4$$value4), $key, $value);
        }
        return var$3;
    };
    $java.sci_Map$Map4__init_0 = function($this, $key1, $value1, $key2, $value2, $key3, $value3, $key4, $value4) {
        $this.$scala$collection$immutable$Map$Map4$$key1 = $key1;
        $this.$scala$collection$immutable$Map$Map4$$value1 = $value1;
        $this.$scala$collection$immutable$Map$Map4$$key2 = $key2;
        $this.$scala$collection$immutable$Map$Map4$$value2 = $value2;
        $this.$scala$collection$immutable$Map$Map4$$key3 = $key3;
        $this.$scala$collection$immutable$Map$Map4$$value3 = $value3;
        $this.$scala$collection$immutable$Map$Map4$$key4 = $key4;
        $this.$scala$collection$immutable$Map$Map4$$value4 = $value4;
    };
    function oncia_SingleQuery() {
        var a = this; jl_Object.call(a);
        a.$clauses = null;
        a.$position5 = null;
    }
    function oncia_SingleQuery__init_(var_0, var_1) {
        var var_2 = new oncia_SingleQuery();
        oncia_SingleQuery__init_0(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_SingleQuery_returnColumns = function($this) {
        return oncia_Query_returnColumns$($this);
    };
    $java.oncia_SingleQuery_whenState = function($this, $condition, $thenBranch, $elseBranch) {
        return oncias_SemanticAnalysisTooling_whenState$($this, $condition, $thenBranch, $elseBranch);
    };
    $java.oncia_SingleQuery_whenState$default$3 = function($this, $condition) {
        return oncias_SemanticAnalysisTooling_whenState$default$3$($this, $condition);
    };
    $java.oncia_SingleQuery_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_SingleQuery_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_SingleQuery_position = function($this) {
        return $this.$position5;
    };
    $java.oncia_SingleQuery_containsUpdates = function($this) {
        return $this.$clauses.$exists(new $java.oncia_SingleQuery$containsUpdates$lambda$_51_0);
    };
    $java.oncia_SingleQuery_returnVariables = function($this) {
        return ($this.$clauses.$last()).$returnVariables();
    };
    $java.oncia_SingleQuery_isReturning = function($this) {
        if (!($this.$clauses.$last() instanceof oncia_Return))
            return 0;
        return 1;
    };
    $java.oncia_SingleQuery_importWith = function($this) {
        var var$1, var$2;
        var$1 = ($java.oncia_SingleQuery_clausesExceptLeadingFrom($this)).$headOption();
        var$2 = new $java.oncia_SingleQuery$$anonfun$importWith$2;
        var$2.$$outer30 = $this;
        return s_Option_collect(var$1, var$2);
    };
    $java.oncia_SingleQuery_leadingGraphSelection = function($this) {
        return s_Option_collect($this.$clauses.$headOption(), new $java.oncia_SingleQuery$$anonfun$leadingGraphSelection$1);
    };
    $java.oncia_SingleQuery_clausesExceptLeadingFrom = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$clauses;
        var$2 = $java.oncia_SingleQuery_leadingGraphSelection($this);
        var$3 = new $java.oncia_SingleQuery$clausesExceptLeadingFrom$lambda$_60_0;
        var$3.$_0321 = var$2;
        return var$1.$filterNot1(var$3);
    };
    $java.oncia_SingleQuery_semanticCheckAbstract = function($this, $clauses, $clauseCheck, $canOmitReturnClause) {
        var var$4, var$5, var$6, var$7;
        var$4 = $java.oncia_SingleQuery_checkStandaloneCall($this, $clauses);
        var$5 = new $java.oncia_SingleQuery$semanticCheckAbstract$lambda$_62_0;
        var$5.$_0322 = $clauseCheck;
        var$5.$_196 = $clauses;
        $clauseCheck = var$4.$chain(oncias_SemanticAnalysisTooling_withScopedState$($this, var$5));
        var$4 = oncias_package$_MODULE$;
        var$5 = new $java.oncia_SingleQuery$checkOrder$lambda$_71_0;
        var$5.$_0323 = $this;
        var$5.$_197 = $clauses;
        var$5.$_237 = $canOmitReturnClause;
        var$6 = oncias_SemanticCheck_chain$($clauseCheck, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5));
        $clauseCheck = new $java.sr_LazyRef;
        var$5 = $java.oncia_SingleQuery_Acc$3($this, $clauseCheck);
        s_package$_$callClinit();
        var$4 = $java.oncia_SingleQuery$Acc$2$_apply(var$5, 0, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
        var$5 = new $java.oncia_SingleQuery$checkNoCallInTransactionsAfterWriteClause$lambda$_72_0;
        var$5.$_0324 = $this;
        var$5.$_198 = $clauseCheck;
        $clauseCheck = $clauses.$foldLeft(var$4, var$5);
        if ($clauseCheck === null)
            $rt_throw(s_MatchError__init_($clauseCheck));
        var$4 = $clauseCheck.$errors0;
        var$4 = oncias_SemanticCheck_chain$(var$6, $java.oncias_package$_liftSemanticErrorDefs(oncias_package$_MODULE$, var$4));
        $clauseCheck = $clauses.$filter1(new $java.oncia_SingleQuery$checkInputDataStream$lambda$_75_0);
        var$7 = $clauseCheck.$length();
        $canOmitReturnClause = $rt_compare(var$7, 1);
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$4, $canOmitReturnClause > 0 ? oncias_SemanticAnalysisTooling_error$($this, $rt_s(1382), ($clauseCheck.$apply1(1)).$position2()) : $canOmitReturnClause ? oncias_SemanticCheck$_success : $clauses.$head() instanceof $java.oncia_InputDataStream ? oncias_SemanticCheck$_success : oncias_SemanticAnalysisTooling_error$($this, $rt_s(1383), ($clauseCheck.$head()).$position2())), oncia_Query_checkUse$($this)), oncias_SemanticAnalysisTooling_recordCurrentScope$($this,
        $this));
    };
    $java.oncia_SingleQuery_semanticCheck = function($this) {
        var var$1, var$2;
        var$1 = $this.$clauses;
        var$2 = new $java.oncia_SingleQuery$semanticCheck$lambda$_63_0;
        var$2.$_0325 = $this;
        return $java.oncia_SingleQuery_semanticCheckAbstract($this, var$1, var$2, 0);
    };
    $java.oncia_SingleQuery_semanticCheckInSubqueryExpressionContext = function($this, $canOmitReturn) {
        var var$2, var$3;
        var$2 = $this.$clauses;
        var$3 = new $java.oncia_SingleQuery$semanticCheckInSubqueryExpressionContext$lambda$_65_0;
        var$3.$_0326 = $this;
        return $java.oncia_SingleQuery_semanticCheckAbstract($this, var$2, var$3, $canOmitReturn);
    };
    $java.oncia_SingleQuery_checkImportingWith = function($this) {
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $java.oncia_SingleQuery_importWith($this), new $java.oncia_SingleQuery$checkImportingWith$lambda$_66_0);
    };
    $java.oncia_SingleQuery_semanticCheckInSubqueryContext = function($this, $outer) {
        var var$2, var$3, var$4, var$5;
        var$2 = oncias_OptionSemanticChecking$_MODULE$;
        var$3 = s_Option_isDefined($java.oncia_SingleQuery_importWith($this)) ? s_None$_MODULE$ : s_Option_collect(($java.oncia_SingleQuery_clausesExceptLeadingFrom($this)).$headOption(), new $java.oncia_SingleQuery$$anonfun$leadingNonImportWith$1);
        var$4 = new $java.oncia_SingleQuery$checkIllegalImportWith$lambda$_69_0;
        var$4.$_0327 = $this;
        var$4 = oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$2, var$3, var$4);
        var$2 = $java.oncia_SingleQuery_leadingGraphSelection($this);
        if (!(var$2 instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, var$2))
                $rt_throw(s_MatchError__init_(var$2));
            var$2 = oncias_SemanticCheck$_success;
        } else {
            var$5 = oncia_Clause_semanticCheck$(var$2.$value5);
            var$3 = oncias_SemanticCheck$_success;
            var$2 = new $java.oncias_SemanticAnalysisTooling$withState$lambda$_5_0;
            var$2.$_0328 = $outer;
            var$2.$_199 = var$5;
            var$2 = oncias_SemanticCheck_flatMap$(var$3, var$2);
        }
        var$2 = var$4.$chain(var$2);
        var$4 = $this.$clauses;
        var$3 = new oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0;
        var$3.$_0329 = $this;
        var$5 = var$4.$span(var$3);
        if (var$5 === null)
            $rt_throw(s_MatchError__init_(var$5));
        var$4 = var$5.$_10;
        var$3 = var$5.$_20;
        var$5 = s_Tuple2__init_(var$4, var$3);
        var$3 = var$5.$_10.$concat0(var$5.$_20.$drop(1));
        var$4 = $java.oncia_SingleQuery_leadingGraphSelection($this);
        var$5 = new $java.oncia_SingleQuery$clausesExceptLeadingFromAndImportWith$lambda$_61_0;
        var$5.$_0330 = var$4;
        var$4 = var$3.$filterNot1(var$5);
        var$3 = new $java.oncia_SingleQuery$semanticCheckInSubqueryContext$lambda$_67_0;
        var$3.$_0331 = $this;
        var$3.$_1100 = $outer;
        var$4 = oncias_SemanticCheck_chain$(var$2, $java.oncia_SingleQuery_semanticCheckAbstract($this, var$4, var$3, 0));
        var$2 = oncias_package$_MODULE$;
        var$3 = new $java.oncia_SingleQuery$checkShadowedVariables$lambda$_76_0;
        var$3.$_0332 = $this;
        var$3.$_1101 = $outer;
        return oncias_SemanticCheck_chain$(var$4, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$3));
    };
    $java.oncia_SingleQuery_checkStandaloneCall = function($this, $clauses) {
        var $where;
        if ($clauses !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $clauses);
            if (!$clauses.$lengthCompare(2)) {
                $where = $clauses.$apply1(1);
                if ($clauses.$apply1(0) instanceof oncia_UnresolvedCall && $where instanceof oncia_With)
                    return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1384), $where.$position52);
            }
        }
        if ($clauses !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $clauses);
            if (!$clauses.$lengthCompare(2) && $rt_isInstance($clauses.$apply1(0), $java.oncia_GraphSelection) && $clauses.$apply1(1) instanceof oncia_UnresolvedCall)
                return oncias_SemanticCheck$_success;
        }
        if ($clauses.$length() > 1 && $clauses.$exists(new $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_0)) {
            $clauses = $clauses.$find0(new $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_1);
            $where = new $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_2;
            $where.$_0333 = $this;
            return s_Option_getOrElse(s_Option_map($clauses, $where), new $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_3);
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncia_SingleQuery_checkClauses = function($this, $clauses, $outerScope) {
        var $lastIndex, var$4, var$5;
        $lastIndex = $clauses.$length() - 1 | 0;
        var$4 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        $clauses = $clauses.$zipWithIndex();
        var$5 = new $java.oncia_SingleQuery$checkClauses$lambda$_73_0;
        var$5.$_0334 = $this;
        var$5.$_1102 = $outerScope;
        var$5.$_238 = $lastIndex;
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$4, $clauses, var$5);
    };
    $java.oncia_SingleQuery_finalScope = function($this, $scope) {
        return $scope.$children1.$last();
    };
    function oncia_SingleQuery_copy($this, $clauses, $position) {
        return oncia_SingleQuery__init_($clauses, $position);
    }
    $java.oncia_SingleQuery_productPrefix = function($this) {
        return $rt_s(1385);
    };
    $java.oncia_SingleQuery_productArity = function($this) {
        return 1;
    };
    $java.oncia_SingleQuery_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$clauses;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SingleQuery_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleQuery_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleQuery_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleQuery_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_SingleQuery) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$clauses;
                        $x$1 = $x$1.$clauses;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_SingleQuery))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SingleQuery_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SingleQuery_err$1 = function($this, $msg, $wth$1) {
        var var$3;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1386)), $msg), 46);
        return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$3), $wth$1.$position52);
    };
    $java.oncia_SingleQuery_$anonfun$checkOrder$2 = function($x0$1, $x1$1) {
        var $pair, $semanticErrors, $match1, $match2, $optError, $clause, $update;
        a: {
            $pair = s_Tuple2__init_($x0$1, $x1$1);
            $semanticErrors = s_Tuple2__1($pair);
            $pair = s_Tuple2__2($pair);
            if ($pair !== null) {
                s_package$_$callClinit();
                $x0$1 = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $pair);
                if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1)) {
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1));
                    $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                    if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 2)) {
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        $match1 = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 0);
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        $match2 = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 1);
                        if ($match1 instanceof oncia_Match) {
                            $x0$1 = $match1;
                            if ($match2 instanceof oncia_Match) {
                                $x1$1 = $match2;
                                if ($java.oncia_Match_optional($x0$1) && !$java.oncia_Match_optional($x1$1)) {
                                    $optError = new s_Some;
                                    $pair = new oncias_SemanticError;
                                    $match1 = $java.oncia_Match_name($x1$1);
                                    $x0$1 = $java.oncia_Match_name($x0$1);
                                    $match2 = jl_StringBuilder__init_1();
                                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($match2, $match1), $rt_s(1387)), $x0$1), $rt_s(1388));
                                    oncias_SemanticError__init_($pair, jl_StringBuilder_toString($match2), $java.oncia_Match_position($x1$1));
                                    s_Some__init_0($optError, $pair);
                                    break a;
                                }
                            }
                        }
                    }
                }
            }
            if ($pair !== null) {
                s_package$_$callClinit();
                $x0$1 = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $pair);
                if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1)) {
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1));
                    $match1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                    if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($match1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($match1, $x0$1), 2)) {
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        $clause = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 0);
                        if ($clause instanceof oncia_Return) {
                            $x0$1 = $clause;
                            $optError = new s_Some;
                            $x1$1 = new oncias_SemanticError;
                            $pair = $java.oncia_Return_name($x0$1);
                            $match1 = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append($match1, $pair), $rt_s(1389));
                            oncias_SemanticError__init_($x1$1, jl_StringBuilder_toString($match1), $java.oncia_Return_position($x0$1));
                            s_Some__init_0($optError, $x1$1);
                            break a;
                        }
                    }
                }
            }
            if ($pair !== null) {
                s_package$_$callClinit();
                $x0$1 = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $pair);
                if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1)) {
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1));
                    $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                    if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 2)) {
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        if ($rt_isInstance($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 0), $java.oncia_UpdateClause)) {
                            $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            if ($rt_isInstance($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 1), $java.oncia_UpdateClause)) {
                                $optError = s_None$_MODULE$;
                                break a;
                            }
                        }
                    }
                }
            }
            if ($pair !== null) {
                s_package$_$callClinit();
                $x0$1 = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $pair);
                if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1)) {
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1));
                    $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                    if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 2)) {
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        if ($rt_isInstance($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 0), $java.oncia_UpdateClause)) {
                            $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            if ($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 1) instanceof oncia_With) {
                                $optError = s_None$_MODULE$;
                                break a;
                            }
                        }
                    }
                }
            }
            if ($pair !== null) {
                s_package$_$callClinit();
                $x0$1 = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $pair);
                if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1)) {
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1));
                    $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                    if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 2)) {
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        if ($rt_isInstance($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 0), $java.oncia_UpdateClause)) {
                            $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            if ($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 1) instanceof oncia_Return) {
                                $optError = s_None$_MODULE$;
                                break a;
                            }
                        }
                    }
                }
            }
            if ($pair !== null) {
                s_package$_$callClinit();
                $x0$1 = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $pair);
                if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1)) {
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $x0$1));
                    $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                    if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 2)) {
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        $update = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 0);
                        $x1$1 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        $clause = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($x1$1, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($x1$1, $x0$1), 1);
                        if ($rt_isInstance($update, $java.oncia_UpdateClause)) {
                            $x0$1 = $update;
                            $optError = new s_Some;
                            $x1$1 = new oncias_SemanticError;
                            $x0$1 = $x0$1.$name3();
                            $pair = $clause.$name3();
                            $match1 = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($match1, $rt_s(1390)), $x0$1), $rt_s(64)), $pair);
                            oncias_SemanticError__init_($x1$1, jl_StringBuilder_toString($match1), $clause.$position2());
                            s_Some__init_0($optError, $x1$1);
                            break a;
                        }
                    }
                }
            }
            $optError = s_None$_MODULE$;
        }
        return s_Option_fold($optError, $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0__init_($semanticErrors), $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1__init_($semanticErrors));
    };
    $java.oncia_SingleQuery_$anonfun$checkOrder$6 = function($x0$2, $x1$2) {
        var $pair, $semanticErrors, $command, $clause, $optError;
        a: {
            $pair = s_Tuple2__init_($x0$2, $x1$2);
            $semanticErrors = $pair.$_10;
            $pair = $pair.$_20;
            if ($pair !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $pair);
                if (!$pair.$lengthCompare(2)) {
                    $command = $pair.$apply1(0);
                    $clause = $pair.$apply1(1);
                    if ($rt_isInstance($command, oncia_TransactionsCommandClause)) {
                        $x0$2 = $command;
                        if ($clause instanceof oncia_With) {
                            $x1$2 = $clause;
                            if ($x0$2.$yieldAll2()) {
                                $optError = new s_Some;
                                $pair = new oncias_SemanticError;
                                $x0$2 = $x0$2.$name3();
                                $command = new jl_StringBuilder;
                                jl_AbstractStringBuilder__init_($command);
                                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($command, $rt_s(1391)), $x0$2), $rt_s(1392));
                                oncias_SemanticError__init_($pair, jl_AbstractStringBuilder_toString($command), $x1$2.$position52);
                                s_Some__init_0($optError, $pair);
                                break a;
                            }
                        }
                    }
                }
            }
            if ($pair !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $pair);
                if (!$pair.$lengthCompare(2)) {
                    $clause = $pair.$apply1(1);
                    if ($rt_isInstance($pair.$apply1(0), oncia_CommandClause) && $clause instanceof oncia_With)
                        b: {
                            c: {
                                $x1$2 = $clause.$withType;
                                $x0$2 = oncia_AddedInRewrite$_MODULE$;
                                if ($x1$2 !== null) {
                                    if (jl_Object_equals($x1$2, $x0$2))
                                        break b;
                                    else
                                        break c;
                                }
                                if ($x0$2 === null)
                                    break b;
                            }
                            $optError = s_None$_MODULE$;
                            break a;
                        }
                }
            }
            if ($pair !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $pair);
                if (!$pair.$lengthCompare(2)) {
                    $command = $pair.$apply1(0);
                    if ($rt_isInstance($command, oncia_CommandClause)) {
                        $x0$2 = $command;
                        $optError = new s_Some;
                        $x1$2 = new oncias_SemanticError;
                        $pair = $x0$2.$name3();
                        $command = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($command);
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($command, $rt_s(1391)), $pair), $rt_s(1393));
                        oncias_SemanticError__init_($x1$2, jl_AbstractStringBuilder_toString($command), $x0$2.$position2());
                        s_Some__init_0($optError, $x1$2);
                        break a;
                    }
                }
            }
            $optError = s_None$_MODULE$;
        }
        $x0$2 = new $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_0;
        $x0$2.$_0335 = $semanticErrors;
        $x1$2 = new $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_1;
        $x1$2.$_0336 = $semanticErrors;
        return s_Option_fold($optError, $x0$2, $x1$2);
    };
    $java.oncia_SingleQuery_$anonfun$checkOrder$1 = function($$this, $clauses$2, $canOmitReturnClause$1, $s) {
        var $validLastClauses, $sequenceErrors, $commandErrors, $missingYield, $concludeError, $missingReturn, var$11;
        $validLastClauses = sc_AbstractIterable_sliding($clauses$2, 2);
        s_package$_$callClinit();
        $sequenceErrors = sc_IterableOnceOps_foldLeft$($validLastClauses, sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$)), new $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_0);
        if (sc_AbstractIterable_count($clauses$2, new $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_1) <= 1)
            $commandErrors = sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$));
        else {
            $missingYield = sc_IterableOnceOps_foldLeft$(sc_AbstractIterable_sliding($clauses$2, 2), sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$)), new $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_2);
            $validLastClauses = $clauses$2.$last();
            $commandErrors = $missingYield.$concat0($validLastClauses instanceof oncia_Return && !$validLastClauses.$addedInRewrite ? s_None$_MODULE$ : s_Some__init_(oncias_SemanticError__init_0($rt_s(1394), $validLastClauses.$position2())));
        }
        a: {
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $clauses$2);
            if (!$clauses$2.$lengthCompare(1) && $clauses$2.$apply1(0) instanceof $java.oncia_CallClause)
                $concludeError = s_None$_MODULE$;
            else {
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $clauses$2);
                if (!$clauses$2.$lengthCompare(2) && $rt_isInstance($clauses$2.$apply1(0), $java.oncia_GraphSelection) && $clauses$2.$apply1(1) instanceof $java.oncia_CallClause)
                    $concludeError = s_None$_MODULE$;
                else {
                    s_package$_Seq(s_package$_MODULE$);
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $clauses$2);
                    if (!$clauses$2.$lengthCompare(0)) {
                        $concludeError = new s_Some;
                        $clauses$2 = new oncias_SemanticError;
                        $missingReturn = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($missingReturn);
                        jl_StringBuilder_append(jl_StringBuilder_append($missingReturn, $rt_s(1395)), $rt_s(1396));
                        oncias_SemanticError__init_($clauses$2, jl_AbstractStringBuilder_toString($missingReturn), $$this.$position5);
                        s_Some__init_0($concludeError, $clauses$2);
                    } else {
                        var$11 = 0;
                        $$this = null;
                        $clauses$2 = $clauses$2.$last();
                        if ($rt_isInstance($clauses$2, $java.oncia_UpdateClause) ? 1 : $clauses$2 instanceof oncia_Return ? 1 : !$rt_isInstance($clauses$2, oncia_CommandClause) ? 0 : 1)
                            $concludeError = s_None$_MODULE$;
                        else {
                            if ($clauses$2 instanceof oncia_SubqueryCall) {
                                $missingReturn = $clauses$2;
                                if (!$missingReturn.$innerQuery.$isReturning() && s_Option_isEmpty(s_Option_flatMap($missingReturn.$inTransactionsParameters, new $java.oncia_SubqueryCall$reportParams$lambda$_61_0))) {
                                    $concludeError = s_None$_MODULE$;
                                    break a;
                                }
                            }
                            if ($clauses$2 instanceof $java.oncia_CallClause) {
                                var$11 = 1;
                                $$this = $clauses$2;
                                if (($java.oncia_UnresolvedCall_returnVariables($$this)).$explicitVariables.$isEmpty() && !$$this.$yieldAll) {
                                    $concludeError = s_None$_MODULE$;
                                    break a;
                                }
                            }
                            if (var$11) {
                                $concludeError = new s_Some;
                                $clauses$2 = new oncias_SemanticError;
                                $validLastClauses = new jl_StringBuilder;
                                jl_AbstractStringBuilder__init_($validLastClauses);
                                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($validLastClauses, $rt_s(1397)), $rt_s(1398)), $rt_s(1399));
                                oncias_SemanticError__init_($clauses$2, jl_AbstractStringBuilder_toString($validLastClauses), $$this.$position53);
                                s_Some__init_0($concludeError, $clauses$2);
                            } else if ($canOmitReturnClause$1)
                                $concludeError = s_None$_MODULE$;
                            else {
                                $concludeError = new s_Some;
                                $$this = new oncias_SemanticError;
                                $missingReturn = $clauses$2.$name3();
                                $missingYield = new jl_StringBuilder;
                                jl_AbstractStringBuilder__init_($missingYield);
                                jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($missingYield, $rt_s(1397)), $missingReturn), $rt_s(1400)), $rt_s(1396)), 41);
                                oncias_SemanticError__init_($$this, jl_AbstractStringBuilder_toString($missingYield), $clauses$2.$position2());
                                s_Some__init_0($concludeError, $$this);
                            }
                        }
                    }
                }
            }
        }
        return oncias_SemanticCheckResult__init_($s, ($sequenceErrors.$concat0($concludeError)).$concat0($commandErrors));
    };
    $java.oncia_SingleQuery_Acc$3 = function($this, $Acc$module$1) {
        var var$2, $$je;
        if ($Acc$module$1.$_initialized)
            return $Acc$module$1.$_value0;
        jl_Object_monitorEnterSync($Acc$module$1);
        a: {
            try {
                var$2 = $java.sr_LazyRef_initialized($Acc$module$1) ? $java.sr_LazyRef_value($Acc$module$1) : $java.sr_LazyRef_initialize($Acc$module$1, $java.oncia_SingleQuery$Acc$2$__init_($this));
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;
                break a;

            }
            jl_Object_monitorExitSync($Acc$module$1);
            return var$2;
        }
        jl_Object_monitorExitSync($Acc$module$1);
        $rt_throw(var$2);
    };
    function oncia_SingleQuery__init_0($this, $clauses, $position) {
        $this.$clauses = $clauses;
        $this.$position5 = $position;
        s_Predef$_$callClinit();
        s_Predef$_assert(s_Predef$_MODULE$, sc_IterableOnceOps_nonEmpty$($clauses));
    }
    var oncia_Union = $rt_classWithoutFields(0);
    $java.oncia_Union_returnVariables$ = function($$this) {
        return $java.oncia_ReturnItems$ReturnVariables__init_(!(($$this.$lhs()).$returnVariables()).$includeExisting1 && !($java.oncia_SingleQuery_returnVariables($$this.$rhs())).$includeExisting1 ? 0 : 1, sci_List_map($$this.$unionMappings(), new $java.oncia_Union$returnVariables$lambda$_4_0));
    };
    $java.oncia_Union_containsUpdates$ = function($$this) {
        return !($$this.$lhs()).$containsUpdates() && !$java.oncia_SingleQuery_containsUpdates($$this.$rhs()) ? 0 : 1;
    };
    $java.oncia_Union_semanticCheckAbstract = function($this, $queryCheck, $singleQueryCheck) {
        var var$3, var$4, var$5;
        var$3 = s_Tuple2__init_($this.$lhs(), $this);
        var$4 = var$3.$_10;
        var$4 = var$4 instanceof oncia_SingleQuery ? $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$) : var$4 instanceof oncia_UnionAll && var$3.$_20 instanceof oncia_UnionAll ? $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$) : var$4 instanceof oncia_UnionDistinct && var$3.$_20 instanceof oncia_UnionDistinct ? $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$) : var$4 instanceof oncia_ProjectingUnionAll
        && var$3.$_20 instanceof oncia_ProjectingUnionAll ? $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$) : var$4 instanceof oncia_ProjectingUnionDistinct && var$3.$_20 instanceof oncia_ProjectingUnionDistinct ? $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$) : $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_Some__init_(oncias_SemanticError__init_0($rt_s(1401), $this.$position2())));
        var$3 = new $java.oncia_Union$semanticCheckAbstract$lambda$_7_0;
        var$3.$_0337 = $this;
        var$3.$_1103 = $queryCheck;
        var$4 = oncias_SemanticCheck_chain$(var$4, $this.$withScopedState(var$3));
        $queryCheck = new $java.oncia_Union$semanticCheckAbstract$lambda$_7_1;
        $queryCheck.$_0338 = $this;
        $queryCheck.$_1104 = $singleQueryCheck;
        var$4 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$4, $this.$withScopedState($queryCheck)), $this.$checkColumnNamesAgree());
        $queryCheck = oncias_package$_MODULE$;
        $singleQueryCheck = new $java.oncia_Union$defineUnionVariables$lambda$_20_0;
        $singleQueryCheck.$_0339 = $this;
        var$4 = oncias_SemanticCheck_chain$(var$4, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($queryCheck, $singleQueryCheck));
        $queryCheck = oncias_package$_MODULE$;
        $singleQueryCheck = new $java.oncia_Union$checkInputDataStream$lambda$_24_0;
        $singleQueryCheck.$_0340 = $this;
        var$5 = oncias_SemanticCheck_chain$(var$4, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($queryCheck, $singleQueryCheck));
        var$4 = sci_List_flatMap(sci_$colon$colon__init_($this.$lhs(), sci_$colon$colon__init_($this.$rhs(), sci_Nil$_MODULE$)), new $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_0);
        $queryCheck = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        $singleQueryCheck = new $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_1;
        $singleQueryCheck.$_0341 = $this;
        $singleQueryCheck = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$5, $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($queryCheck, var$4, $singleQueryCheck)), $this.$checkUse());
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$($singleQueryCheck, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_Union_semanticCheck$ = function($$this) {
        return $java.oncia_Union_semanticCheckAbstract($$this, new $java.oncia_Union$semanticCheck$lambda$_9_0, new $java.oncia_Union$semanticCheck$lambda$_9_1);
    };
    $java.oncia_Union_semanticCheckInSubqueryExpressionContext$ = function($$this, $canOmitReturn) {
        var var$3, var$4;
        var$3 = new $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_0;
        var$3.$_0342 = $canOmitReturn;
        var$4 = new $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_1;
        var$4.$_0343 = $canOmitReturn;
        return $java.oncia_Union_semanticCheckAbstract($$this, var$3, var$4);
    };
    $java.oncia_Union_checkImportingWith$ = function($$this) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncia_Union$checkImportingWith$lambda$_13_0;
        var$3.$_0344 = $$this;
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck$_nestedCheck(var$2, var$3), $java.oncia_SingleQuery_checkImportingWith($$this.$rhs()));
    };
    $java.oncia_Union_isReturning$ = function($$this) {
        return $java.oncia_SingleQuery_isReturning($$this.$rhs());
    };
    $java.oncia_Union_semanticCheckInSubqueryContext$ = function($$this, $outer) {
        var var$3, var$4;
        var$3 = new $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_0;
        var$3.$_0345 = $outer;
        var$4 = new $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_1;
        var$4.$_0346 = $outer;
        return $java.oncia_Union_semanticCheckAbstract($$this, var$3, var$4);
    };
    $java.oncia_Union_Mapping$3 = function($this, $Mapping$module$1) {
        var var$2, $$je;
        if ($Mapping$module$1.$_initialized)
            return $Mapping$module$1.$_value0;
        jl_Object_monitorEnterSync($Mapping$module$1);
        a: {
            try {
                var$2 = $java.sr_LazyRef_initialized($Mapping$module$1) ? $java.sr_LazyRef_value($Mapping$module$1) : $java.sr_LazyRef_initialize($Mapping$module$1, $java.oncia_Union$Mapping$2$__init_($this));
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;
                break a;

            }
            jl_Object_monitorExitSync($Mapping$module$1);
            return var$2;
        }
        jl_Object_monitorExitSync($Mapping$module$1);
        $rt_throw(var$2);
    };
    $java.oncia_Union_checkSingleQuery$1 = function($query, $state) {
        var $idsClause;
        $idsClause = $query.$clauses.$find0(new $java.oncia_Union$checkSingleQuery$1$lambda$_50_0);
        if (s_Option_isEmpty($idsClause))
            return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, $state);
        return oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, $state, oncias_SemanticError__init_0($rt_s(1402), ($idsClause.$get0()).$position2()));
    };
    $java.oncia_UnmappedUnion = $rt_classWithoutFields(0);
    $java.oncia_UnmappedUnion_dup$ = function($$this, $children) {
        var var$3, var$4, var$5, var$6;
        $children = $$this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$super$dup($children);
        var$3 = ($$this.$lhs()).$returnColumns();
        var$4 = oncia_Query_returnColumns$($$this.$rhs());
        var$5 = ($children.$lhs()).$returnColumns();
        var$6 = oncia_Query_returnColumns$($children.$rhs());
        if ($java.oncia_UnmappedUnion_containTheSameInstances$1(var$3, var$5) && $java.oncia_UnmappedUnion_containTheSameInstances$1(var$4, var$6))
            $children.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq($$this.$unionMappings());
        return $children;
    };
    $java.oncia_UnmappedUnion_checkColumnNamesAgree$ = function($$this) {
        var var$2, var$3;
        var$2 = oncias_package$_MODULE$;
        var$3 = new $java.oncia_UnmappedUnion$checkColumnNamesAgree$lambda$_8_0;
        var$3.$_0347 = $$this;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$3);
    };
    $java.oncia_UnmappedUnion_containTheSameInstances$1 = function($a, $b) {
        var var$3;
        var$3 = new $java.oncia_UnmappedUnion$containTheSameInstances$1$lambda$_14_0;
        var$3.$_0348 = $b;
        return sci_List_forall($a, var$3) && $a.$length() == $b.$length() ? 1 : 0;
    };
    $java.oncia_UnmappedUnion_$init$ = function($$this) {
        var var$2, var$3;
        var$2 = ($$this.$lhs()).$returnColumns();
        var$3 = new $java.oncia_UnmappedUnion$$init$$lambda$_16_0;
        var$3.$_0349 = $$this;
        $$this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq(sci_List_flatMap(var$2, var$3));
    };
    function oncia_UnionAll() {
        var a = this; jl_Object.call(a);
        a.$lhs7 = null;
        a.$rhs8 = null;
        a.$position38 = null;
        a.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings = null;
    }
    function oncia_UnionAll__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_UnionAll();
        $java.oncia_UnionAll__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_UnionAll_org$neo4j$cypher$internal$ast$UnmappedUnion$$super$dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_UnionAll_unionMappings = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings0();
    };
    $java.oncia_UnionAll_checkColumnNamesAgree = function($this) {
        return $java.oncia_UnmappedUnion_checkColumnNamesAgree$($this);
    };
    $java.oncia_UnionAll_returnVariables = function($this) {
        return $java.oncia_Union_returnVariables$($this);
    };
    $java.oncia_UnionAll_containsUpdates = function($this) {
        return $java.oncia_Union_containsUpdates$($this);
    };
    $java.oncia_UnionAll_semanticCheck = function($this) {
        return $java.oncia_Union_semanticCheck$($this);
    };
    $java.oncia_UnionAll_semanticCheckInSubqueryExpressionContext = function($this, $canOmitReturn) {
        return $java.oncia_Union_semanticCheckInSubqueryExpressionContext$($this, $canOmitReturn);
    };
    $java.oncia_UnionAll_checkImportingWith = function($this) {
        return $java.oncia_Union_checkImportingWith$($this);
    };
    $java.oncia_UnionAll_isReturning = function($this) {
        return $java.oncia_Union_isReturning$($this);
    };
    $java.oncia_UnionAll_semanticCheckInSubqueryContext = function($this, $outer) {
        return $java.oncia_Union_semanticCheckInSubqueryContext$($this, $outer);
    };
    $java.oncia_UnionAll_finalScope = function($this, $scope) {
        return $scope;
    };
    $java.oncia_UnionAll_returnColumns = function($this) {
        return oncia_Query_returnColumns$($this);
    };
    $java.oncia_UnionAll_checkUse = function($this) {
        return oncia_Query_checkUse$($this);
    };
    $java.oncia_UnionAll_whenState = function($this, $condition, $thenBranch, $elseBranch) {
        return oncias_SemanticAnalysisTooling_whenState$($this, $condition, $thenBranch, $elseBranch);
    };
    $java.oncia_UnionAll_whenState$default$3 = function($this, $condition) {
        return oncias_SemanticAnalysisTooling_whenState$default$3$($this, $condition);
    };
    $java.oncia_UnionAll_withScopedState = function($this, $check) {
        return oncias_SemanticAnalysisTooling_withScopedState$($this, $check);
    };
    $java.oncia_UnionAll_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_UnionAll_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_UnionAll_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_UnionAll_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings;
    };
    $java.oncia_UnionAll_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings = $x$1;
    };
    function oncia_UnionAll_lhs($this) {
        return $this.$lhs7;
    }
    function oncia_UnionAll_rhs($this) {
        return $this.$rhs8;
    }
    $java.oncia_UnionAll_position = function($this) {
        return $this.$position38;
    };
    function oncia_UnionAll_copy($this, $lhs, $rhs, $position) {
        return oncia_UnionAll__init_($lhs, $rhs, $position);
    }
    $java.oncia_UnionAll_productPrefix = function($this) {
        return $rt_s(1403);
    };
    $java.oncia_UnionAll_productArity = function($this) {
        return 2;
    };
    $java.oncia_UnionAll_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs7;
            case 1:
                return $this.$rhs8;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UnionAll_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnionAll_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnionAll_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnionAll_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_UnionAll) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$lhs7;
                            var$3 = $x$1.$lhs7;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$rhs8;
                        $x$1 = $x$1.$rhs8;
                        if (var$3 !== null) {
                            if (!$java.oncia_SingleQuery_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_UnionAll_dup = function($this, $children) {
        return $java.oncia_UnmappedUnion_dup$($this, $children);
    };
    $java.oncia_UnionAll__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs7 = $lhs;
        $this.$rhs8 = $rhs;
        $this.$position38 = $position;
        $java.oncia_UnmappedUnion_$init$($this);
    };
    function oncia_UnionDistinct() {
        var a = this; jl_Object.call(a);
        a.$lhs8 = null;
        a.$rhs9 = null;
        a.$position39 = null;
        a.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings1 = null;
    }
    function oncia_UnionDistinct__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_UnionDistinct();
        $java.oncia_UnionDistinct__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_UnionDistinct_org$neo4j$cypher$internal$ast$UnmappedUnion$$super$dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_UnionDistinct_unionMappings = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings0();
    };
    $java.oncia_UnionDistinct_checkColumnNamesAgree = function($this) {
        return $java.oncia_UnmappedUnion_checkColumnNamesAgree$($this);
    };
    $java.oncia_UnionDistinct_returnVariables = function($this) {
        return $java.oncia_Union_returnVariables$($this);
    };
    $java.oncia_UnionDistinct_containsUpdates = function($this) {
        return $java.oncia_Union_containsUpdates$($this);
    };
    $java.oncia_UnionDistinct_semanticCheck = function($this) {
        return $java.oncia_Union_semanticCheck$($this);
    };
    $java.oncia_UnionDistinct_semanticCheckInSubqueryExpressionContext = function($this, $canOmitReturn) {
        return $java.oncia_Union_semanticCheckInSubqueryExpressionContext$($this, $canOmitReturn);
    };
    $java.oncia_UnionDistinct_checkImportingWith = function($this) {
        return $java.oncia_Union_checkImportingWith$($this);
    };
    $java.oncia_UnionDistinct_isReturning = function($this) {
        return $java.oncia_Union_isReturning$($this);
    };
    $java.oncia_UnionDistinct_semanticCheckInSubqueryContext = function($this, $outer) {
        return $java.oncia_Union_semanticCheckInSubqueryContext$($this, $outer);
    };
    $java.oncia_UnionDistinct_finalScope = function($this, $scope) {
        return $scope;
    };
    $java.oncia_UnionDistinct_returnColumns = function($this) {
        return oncia_Query_returnColumns$($this);
    };
    $java.oncia_UnionDistinct_checkUse = function($this) {
        return oncia_Query_checkUse$($this);
    };
    $java.oncia_UnionDistinct_whenState = function($this, $condition, $thenBranch, $elseBranch) {
        return oncias_SemanticAnalysisTooling_whenState$($this, $condition, $thenBranch, $elseBranch);
    };
    $java.oncia_UnionDistinct_whenState$default$3 = function($this, $condition) {
        return oncias_SemanticAnalysisTooling_whenState$default$3$($this, $condition);
    };
    $java.oncia_UnionDistinct_withScopedState = function($this, $check) {
        return oncias_SemanticAnalysisTooling_withScopedState$($this, $check);
    };
    $java.oncia_UnionDistinct_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_UnionDistinct_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_UnionDistinct_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_UnionDistinct_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings1;
    };
    $java.oncia_UnionDistinct_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings1 = $x$1;
    };
    function oncia_UnionDistinct_lhs($this) {
        return $this.$lhs8;
    }
    function oncia_UnionDistinct_rhs($this) {
        return $this.$rhs9;
    }
    $java.oncia_UnionDistinct_position = function($this) {
        return $this.$position39;
    };
    function oncia_UnionDistinct_copy($this, $lhs, $rhs, $position) {
        return oncia_UnionDistinct__init_($lhs, $rhs, $position);
    }
    $java.oncia_UnionDistinct_productPrefix = function($this) {
        return $rt_s(1404);
    };
    $java.oncia_UnionDistinct_productArity = function($this) {
        return 2;
    };
    $java.oncia_UnionDistinct_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs8;
            case 1:
                return $this.$rhs9;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UnionDistinct_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnionDistinct_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnionDistinct_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnionDistinct_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_UnionDistinct) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$lhs8;
                            var$3 = $x$1.$lhs8;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$rhs9;
                        $x$1 = $x$1.$rhs9;
                        if (var$3 !== null) {
                            if (!$java.oncia_SingleQuery_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_UnionDistinct_dup = function($this, $children) {
        return $java.oncia_UnmappedUnion_dup$($this, $children);
    };
    $java.oncia_UnionDistinct__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs8 = $lhs;
        $this.$rhs9 = $rhs;
        $this.$position39 = $position;
        $java.oncia_UnmappedUnion_$init$($this);
    };
    var oncia_ProjectingUnion = $rt_classWithoutFields(0);
    var oncie_Expression = $rt_classWithoutFields();
    $java.oncie_Expression_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_Expression_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncie_Expression_foldedOver = function($this) {
        return $this;
    };
    $java.oncie_Expression_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncie_Expression_arguments = function($this) {
        var var$1, var$2, var$3;
        var$1 = onciu_Foldable_folder$($this);
        s_package$_$callClinit();
        s_package$_List0(s_package$_MODULE$);
        var$2 = sci_Nil$_MODULE$;
        var$3 = new $java.oncie_Expression$$anonfun$arguments$1;
        var$3.$$outer31 = $this;
        return onciu_Foldable$Folder_treeFold(var$1, var$2, var$3);
    };
    $java.oncie_Expression_dependencies = function($this) {
        var var$1, var$2;
        var$1 = onciu_Foldable_folder$($this);
        var$2 = new $java.oncie_Expression$TreeAcc;
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        $java.oncie_Expression$TreeAcc__init_(var$2, sci_Set$EmptySet$_MODULE$, $java.oncie_Expression$TreeAcc$_apply$default$2($java.oncie_Expression$TreeAcc$_MODULE$));
        return (onciu_Foldable$Folder_treeFold(var$1, var$2, new $java.oncie_Expression$$anonfun$dependencies$1)).$data0;
    };
    $java.oncie_Expression_containsAggregate = function($this) {
        return onciu_Foldable$Folder_treeExists(onciu_Foldable_folder$($this), new $java.oncie_Expression$$anonfun$containsAggregate$1);
    };
    $java.oncie_Expression_findAggregate = function($this) {
        var var$1, var$2;
        var$1 = onciu_Foldable_folder$($this);
        var$2 = new $java.oncie_Expression$$anonfun$findAggregate$1;
        sr_ClassTag$_$callClinit();
        return onciu_Foldable$Folder_treeFind(var$1, var$2, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_Expression)));
    };
    $java.oncie_Expression_dup0 = function($this, $children) {
        return $this.$dup0($children);
    };
    $java.oncie_Expression__init_ = function($this) {};
    var s_Option$ = $rt_classWithoutFields();
    var s_Option$_MODULE$ = null;
    function s_Option$__clinit_() {
        s_Option$_MODULE$ = new s_Option$;
    }
    function s_Option$_option2Iterable($this, $xo) {
        var var$2, $single_a;
        if (s_Option_isEmpty($xo)) {
            s_package$_$callClinit();
            return sc_IterableFactory$Delegate_empty(s_package$_Iterable0(s_package$_MODULE$));
        }
        s_package$_$callClinit();
        var$2 = s_package$_Iterable0(s_package$_MODULE$);
        $single_a = $xo.$get0();
        if (var$2 === null)
            $rt_throw(null);
        $xo = new $java.sc_Iterable$$anon$1;
        $xo.$a$10 = $single_a;
        return $xo;
    }
    function s_Option$_apply($this, $x) {
        if ($x === null)
            return s_None$_MODULE$;
        return s_Some__init_($x);
    }
    $java.s_Option$_when = function($this, $cond, $a) {
        if (!$cond)
            return s_None$_MODULE$;
        return s_Some__init_($a.$apply2());
    };
    var oncirc_containsNoNodesOfType$apply$lambda$_31_0 = $rt_classWithoutFields();
    $java.oncirc_containsNoNodesOfType$apply$lambda$_31_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = jl_Class_getSimpleName(jl_Object_getClass(var$1));
        var$1 = var$1.$position2();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1064)), var$2), $rt_s(1065)), var$1);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    var oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1$$anonfun$2 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1$$anonfun$2_applyOrElse = function($this, $x1, $default) {
        var $match1, $match2, $withStar;
        if ($x1 !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $x1);
            if (!$x1.$lengthCompare(2)) {
                $match1 = $x1.$apply1(0);
                $match2 = $x1.$apply1(1);
                if ($match1 instanceof oncia_Match) {
                    $default = $match1;
                    if ($match2 instanceof oncia_Match) {
                        $match1 = $match2;
                        if ($default.$optional && !$match1.$optional) {
                            $withStar = new oncia_With;
                            $match1 = oncia_ReturnItems__init_(1, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), s_None$_MODULE$, $default.$position54);
                            $x1 = s_None$_MODULE$;
                            oncia_With__init_($withStar, 0, $match1, $x1, $x1, $x1, $x1, oncia_DefaultWith$_MODULE$, $default.$position54);
                            return sci_$colon$colon__init_($default, sci_$colon$colon__init_($withStar, sci_Nil$_MODULE$));
                        }
                    }
                }
            }
        }
        if ($x1 !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $x1);
            if (!$x1.$lengthCompare(2))
                return sci_$colon$colon__init_($x1.$apply1(0), sci_Nil$_MODULE$);
        }
        return sr_Statics_pfMarker;
    };
    $java.oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1$$anonfun$2_applyOrElse0 = function($this, $x, $default) {
        return $java.oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1$$anonfun$2_applyOrElse($this, $x, $default);
    };
    var oncirr_expandCallWhere$$anonfun$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncirr_expandCallWhere$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        a: {
            var$1 = var$1;
            if (var$1 instanceof oncia_UnresolvedCall) {
                var$2 = var$1;
                var$3 = var$2.$declaredResult;
                if (var$3 instanceof s_Some) {
                    var$3 = var$3.$value5;
                    if (var$3 !== null) {
                        var$4 = var$3.$where9;
                        if (var$4 instanceof s_Some) {
                            var$4 = var$4;
                            var$5 = var$4.$value5;
                            var$6 = s_None$_MODULE$;
                            var$7 = s_Some__init_($java.oncia_ProcedureResult_copy(var$3, var$3.$items4, var$6, var$3.$position55));
                            var$1 = $java.oncia_UnresolvedCall_copy(var$2, var$2.$procedureNamespace, var$2.$procedureName, var$2.$declaredArguments, var$7, var$2.$yieldAll, var$2.$position53);
                            var$6 = new oncia_ReturnItems;
                            s_package$_$callClinit();
                            $java.oncia_ReturnItems__init_(var$6, 1, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), s_None$_MODULE$, var$5.$position3);
                            var$3 = new oncia_With;
                            var$2 = s_None$_MODULE$;
                            oncia_With__init_(var$3, 0, var$6, var$2, var$2, var$2, var$4, oncia_DefaultWith$_MODULE$, var$5.$position3);
                            var$2 = sci_$colon$colon__init_(var$1, sci_$colon$colon__init_(var$3, sci_Nil$_MODULE$));
                            break a;
                        }
                    }
                }
            }
            var$2 = s_Some__init_(var$1);
        }
        return var$2;
    };
    function oncia_Where() {
        var a = this; jl_Object.call(a);
        a.$expression4 = null;
        a.$position3 = null;
    }
    function oncia_Where__init_(var_0, var_1) {
        var var_2 = new oncia_Where();
        $java.oncia_Where__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_Where_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Where_position = function($this) {
        return $this.$position3;
    };
    $java.oncia_Where_semanticCheck = function($this) {
        return $java.oncia_Where$_checkExpression($java.oncia_Where$_MODULE$, $this.$expression4);
    };
    $java.oncia_Where_productPrefix = function($this) {
        return $rt_s(1405);
    };
    $java.oncia_Where_productArity = function($this) {
        return 1;
    };
    $java.oncia_Where_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Where_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Where_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Where_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Where_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Where) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression4;
                        $x$1 = $x$1.$expression4;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Where))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_Where_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Where__init_ = function($this, $expression, $position) {
        $this.$expression4 = $expression;
        $this.$position3 = $position;
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    var oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8 = $rt_classWithoutFields();
    function oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8__init_() {
        var var_0 = new oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8();
        $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8__init_(var_0);
        return var_0;
    }
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8__init_ = function(var$0) {};
    $java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems1.$includeExisting);
    };
    $java.oncie_BooleanExpression = $rt_classWithoutFields(0);
    $java.oncie_OperatorExpression = $rt_classWithoutFields(0);
    $java.oncie_OperatorExpression_canonicalOperatorSymbol$ = function($$this) {
        $$this = $$this.$productPrefix();
        $java.ju_Locale_$callClinit();
        return jl_String_toUpperCase($$this);
    };
    var oncie_BinaryOperatorExpression = $rt_classWithoutFields(0);
    $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$ = function($$this) {
        var var$2, var$3, var$4;
        var$2 = ($$this.$lhs0()).$asCanonicalStringVal();
        var$3 = $$this.$canonicalOperatorSymbol();
        $$this = ($$this.$rhs0()).$asCanonicalStringVal();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        var$2 = jl_StringBuilder_append(var$4, var$2);
        jl_AbstractStringBuilder_append(var$2, 32);
        var$2 = jl_StringBuilder_append(var$2, var$3);
        jl_AbstractStringBuilder_append(var$2, 32);
        jl_StringBuilder_append(var$2, $$this);
        return jl_AbstractStringBuilder_toString(var$4);
    };
    function oncie_And() {
        var a = this; oncie_Expression.call(a);
        a.$lhs1 = null;
        a.$rhs1 = null;
        a.$position56 = null;
        a.$signatures = null;
    }
    function oncie_And__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_And();
        $java.oncie_And__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_And_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_And_canonicalOperatorSymbol = function($this) {
        return $java.oncie_OperatorExpression_canonicalOperatorSymbol$($this);
    };
    $java.oncie_And_lhs = function($this) {
        return $this.$lhs1;
    };
    $java.oncie_And_rhs = function($this) {
        return $this.$rhs1;
    };
    $java.oncie_And_position = function($this) {
        return $this.$position56;
    };
    $java.oncie_And_signatures = function($this) {
        return $this.$signatures;
    };
    $java.oncie_And_copy = function($this, $lhs, $rhs, $position) {
        return oncie_And__init_($lhs, $rhs, $position);
    };
    $java.oncie_And_productPrefix = function($this) {
        return $rt_s(1406);
    };
    $java.oncie_And_productArity = function($this) {
        return 2;
    };
    $java.oncie_And_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs1;
            case 1:
                return $this.$rhs1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_And_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_And_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_And_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_And_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_And) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs1;
                        var$3 = $x$1.$lhs1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs1;
                        $x$1 = $x$1.$rhs1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_And))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_And__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs1 = $lhs;
        $this.$rhs1 = $rhs;
        $this.$position56 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_BooleanType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    var oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1, var$2) {
        return var$1.$intersect1(var$2);
    };
    function oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_1() {
        jl_Object.call(this);
        this.$_045 = null;
    }
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = var$0.$_045;
        return $java.oncie_And_copy(var$3, var$1, var$2, var$3.$position56);
    };
    var oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_2 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1, var$2) {
        return var$1.$appendedAll(var$2);
    };
    function oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_3() {
        jl_Object.call(this);
        this.$_046 = null;
    }
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_3_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = var$0.$_046;
        return $java.oncie_And_copy(var$3, var$1, var$2, var$3.$position56);
    };
    function oncie_Or() {
        var a = this; oncie_Expression.call(a);
        a.$lhs2 = null;
        a.$rhs2 = null;
        a.$position57 = null;
        a.$signatures0 = null;
    }
    function oncie_Or__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Or();
        $java.oncie_Or__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Or_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Or_canonicalOperatorSymbol = function($this) {
        return $java.oncie_OperatorExpression_canonicalOperatorSymbol$($this);
    };
    $java.oncie_Or_lhs = function($this) {
        return $this.$lhs2;
    };
    $java.oncie_Or_rhs = function($this) {
        return $this.$rhs2;
    };
    $java.oncie_Or_position = function($this) {
        return $this.$position57;
    };
    $java.oncie_Or_signatures = function($this) {
        return $this.$signatures0;
    };
    $java.oncie_Or_copy = function($this, $lhs, $rhs, $position) {
        return oncie_Or__init_($lhs, $rhs, $position);
    };
    $java.oncie_Or_productPrefix = function($this) {
        return $rt_s(1407);
    };
    $java.oncie_Or_productArity = function($this) {
        return 2;
    };
    $java.oncie_Or_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs2;
            case 1:
                return $this.$rhs2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Or_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Or_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Or_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Or_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Or) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs2;
                        var$3 = $x$1.$lhs2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs2;
                        $x$1 = $x$1.$rhs2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Or))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Or__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs2 = $lhs;
        $this.$rhs2 = $rhs;
        $this.$position57 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_BooleanType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures0 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    var oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_4 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_4_apply = function(var$0, var$1, var$2) {
        return var$1.$appendedAll(var$2);
    };
    function oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_5() {
        jl_Object.call(this);
        this.$_047 = null;
    }
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_5_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = var$0.$_047;
        return $java.oncie_Or_copy(var$3, var$1, var$2, var$3.$position57);
    };
    var oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_6 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_6_apply = function(var$0, var$1, var$2) {
        return var$1.$intersect1(var$2);
    };
    function oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_7() {
        jl_Object.call(this);
        this.$_048 = null;
    }
    $java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_7_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = var$0.$_048;
        return $java.oncie_Or_copy(var$3, var$1, var$2, var$3.$position57);
    };
    function oncie_FunctionInvocation() {
        var a = this; oncie_Expression.call(a);
        a.$namespace1 = null;
        a.$functionName0 = null;
        a.$distinct0 = 0;
        a.$args = null;
        a.$position7 = null;
        a.$name22 = null;
        a.$function0 = null;
    }
    function oncie_FunctionInvocation__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncie_FunctionInvocation();
        $java.oncie_FunctionInvocation__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    function oncie_FunctionInvocation_namespace($this) {
        return $this.$namespace1;
    }
    function oncie_FunctionInvocation_functionName($this) {
        return $this.$functionName0;
    }
    function oncie_FunctionInvocation_distinct($this) {
        return $this.$distinct0;
    }
    function oncie_FunctionInvocation_args($this) {
        return $this.$args;
    }
    function oncie_FunctionInvocation_position($this) {
        return $this.$position7;
    }
    $java.oncie_FunctionInvocation_asCanonicalStringVal = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$name22;
        var$2 = sc_AbstractIterable_mkString0($this.$args.$map1(new $java.oncie_FunctionInvocation$asCanonicalStringVal$lambda$_15_0), $rt_s(43));
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$1 = jl_StringBuilder_append(var$3, var$1);
        jl_AbstractStringBuilder_append(var$1, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$1, var$2), 41);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    function oncie_FunctionInvocation_copy($this, $namespace, $functionName, $distinct, $args, $position) {
        return oncie_FunctionInvocation__init_($namespace, $functionName, $distinct, $args, $position);
    }
    $java.oncie_FunctionInvocation_productPrefix = function($this) {
        return $rt_s(1408);
    };
    $java.oncie_FunctionInvocation_productArity = function($this) {
        return 4;
    };
    $java.oncie_FunctionInvocation_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$namespace1;
            case 1:
                return $this.$functionName0;
            case 2:
                return jl_Boolean_valueOf($this.$distinct0);
            case 3:
                return $this.$args;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_FunctionInvocation_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FunctionInvocation_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1408))), sr_Statics_anyHash($this.$namespace1)), sr_Statics_anyHash($this.$functionName0)), !$this.$distinct0 ? 1237 : 1231), sr_Statics_anyHash($this.$args)), 4);
    };
    $java.oncie_FunctionInvocation_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FunctionInvocation_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_FunctionInvocation) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$distinct0 != $x$1.$distinct0)
                        break b;
                    c: {
                        var$2 = $this.$namespace1;
                        var$3 = $x$1.$namespace1;
                        if (var$2 !== null) {
                            if (!$java.oncie_Namespace_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$functionName0;
                        var$3 = $x$1.$functionName0;
                        if (var$2 !== null) {
                            if (!$java.oncie_FunctionName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$args;
                        $x$1 = $x$1.$args;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_FunctionInvocation))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_FunctionInvocation__init_ = function($this, $namespace, $functionName, $distinct, $args, $position) {
        var $$je;
        $this.$namespace1 = $namespace;
        $this.$functionName0 = $functionName;
        $this.$distinct0 = $distinct;
        $this.$args = $args;
        $this.$position7 = $position;
        $java.oncie_Expression__init_($this);
        $this.$name22 = sc_AbstractIterable_mkString0($namespace.$parts0.$appended($functionName.$name6), $rt_s(142));
        $java.oncief_Function$_$callClinit();
        $namespace = $java.oncief_Function$_MODULE$;
        if (($java.oncief_Function$_bitmap$0 & 1) << 24 >> 24)
            $namespace = $java.oncief_Function$_lookup;
        else {
            jl_Object_monitorEnterSync($namespace);
            a: {
                try {
                    if (($java.oncief_Function$_bitmap$0 & 1) << 24 >> 24)
                        break a;
                    $java.oncief_Function$_lookup = sc_AbstractIterable_toMap(($java.oncief_Function$_knownFunctions($namespace)).$map1($java.oncief_Function$$lookup$lzycompute$lambda$_2_0__init_()), s_$less$colon$less$_refl(s_$less$colon$less$_MODULE$));
                    $java.oncief_Function$_bitmap$0 = ($java.oncief_Function$_bitmap$0 | 1) << 24 >> 24;
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    $functionName = $$je;

                }
                jl_Object_monitorExitSync($namespace);
                $rt_throw($functionName);
            }
            jl_Object_monitorExitSync($namespace);
            $java.oncief_Function$_knownFunctions0 = null;
            $namespace = $java.oncief_Function$_lookup;
        }
        $functionName = $this.$name22;
        $java.ju_Locale_$callClinit();
        $this.$function0 = $namespace.$getOrElse0(jl_String_toLowerCase($functionName), new $java.oncie_FunctionInvocation$_init_$lambda$_34_0);
    };
    var oncie_SymbolicName = $rt_classWithoutFields(0);
    function oncie_FunctionName() {
        var a = this; jl_Object.call(a);
        a.$name6 = null;
        a.$position6 = null;
    }
    function oncie_FunctionName__init_(var_0, var_1) {
        var var_2 = new oncie_FunctionName();
        $java.oncie_FunctionName__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_FunctionName_name($this) {
        return $this.$name6;
    }
    $java.oncie_FunctionName_position = function($this) {
        return $this.$position6;
    };
    $java.oncie_FunctionName_equals = function($this, $x) {
        var $other, var$3;
        if (!($x instanceof oncie_FunctionName))
            return 0;
        a: {
            b: {
                c: {
                    $other = $x.$name6;
                    $java.ju_Locale_$callClinit();
                    $x = jl_String_toLowerCase($other);
                    $other = jl_String_toLowerCase($this.$name6);
                    if ($x !== null) {
                        if (!jl_String_equals($x, $other))
                            break b;
                        else
                            break c;
                    }
                    if ($other !== null)
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_FunctionName_hashCode = function($this) {
        var var$1;
        var$1 = $this.$name6;
        $java.ju_Locale_$callClinit();
        return jl_String_hashCode(jl_String_toLowerCase(var$1));
    };
    $java.oncie_FunctionName_productPrefix = function($this) {
        return $rt_s(1409);
    };
    $java.oncie_FunctionName_productArity = function($this) {
        return 1;
    };
    $java.oncie_FunctionName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_FunctionName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FunctionName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FunctionName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_FunctionName__init_ = function($this, $name, $position) {
        $this.$name6 = $name;
        $this.$position6 = $position;
    };
    $java.oncie_LogicalProperty = $rt_classWithoutFields(oncie_Expression);
    function oncie_Property() {
        var a = this; $java.oncie_LogicalProperty.call(a);
        a.$map11 = null;
        a.$propertyKey0 = null;
        a.$position31 = null;
    }
    function oncie_Property__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Property();
        $java.oncie_Property__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncie_Property_map($this) {
        return $this.$map11;
    }
    function oncie_Property_propertyKey($this) {
        return $this.$propertyKey0;
    }
    $java.oncie_Property_position = function($this) {
        return $this.$position31;
    };
    $java.oncie_Property_asCanonicalStringVal = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$map11.$asCanonicalStringVal();
        var$2 = $this.$propertyKey0.$name11;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$1 = jl_StringBuilder_append(var$3, var$1);
        jl_AbstractStringBuilder_append(var$1, 46);
        jl_StringBuilder_append(var$1, var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.oncie_Property_productPrefix = function($this) {
        return $rt_s(1410);
    };
    $java.oncie_Property_productArity = function($this) {
        return 2;
    };
    $java.oncie_Property_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$map11;
            case 1:
                return $this.$propertyKey0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Property_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Property_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Property_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Property_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Property) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$map11;
                        var$3 = $x$1.$map11;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$propertyKey0;
                        $x$1 = $x$1.$propertyKey0;
                        if (var$3 !== null) {
                            if (!$java.oncie_PropertyKeyName_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Property))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Property__init_ = function($this, $map, $propertyKey, $position) {
        $this.$map11 = $map;
        $this.$propertyKey0 = $propertyKey;
        $this.$position31 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_PropertyKeyName() {
        var a = this; jl_Object.call(a);
        a.$name11 = null;
        a.$position58 = null;
    }
    function oncie_PropertyKeyName__init_(var_0, var_1) {
        var var_2 = new oncie_PropertyKeyName();
        $java.oncie_PropertyKeyName__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_PropertyKeyName_name = function($this) {
        return $this.$name11;
    };
    $java.oncie_PropertyKeyName_position = function($this) {
        return $this.$position58;
    };
    $java.oncie_PropertyKeyName_productPrefix = function($this) {
        return $rt_s(1411);
    };
    $java.oncie_PropertyKeyName_productArity = function($this) {
        return 1;
    };
    $java.oncie_PropertyKeyName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name11;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PropertyKeyName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PropertyKeyName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PropertyKeyName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PropertyKeyName_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PropertyKeyName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name11;
                        $x$1 = $x$1.$name11;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PropertyKeyName))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PropertyKeyName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PropertyKeyName__init_ = function($this, $name, $position) {
        $this.$name11 = $name;
        $this.$position58 = $position;
    };
    var onciu_Ref$ = $rt_classWithoutFields();
    var onciu_Ref$_MODULE$ = null;
    function onciu_Ref$__clinit_() {
        onciu_Ref$_MODULE$ = new onciu_Ref$;
    }
    function onciu_Ref$_apply($this, $v) {
        var var$2;
        var$2 = new onciu_Ref;
        var$2.$value19 = $v;
        if ($v !== null)
            return var$2;
        var$2 = new jl_IllegalArgumentException;
        jl_Throwable__init_(var$2, $rt_s(1412));
        $rt_throw(var$2);
    }
    function oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1$applyOrElse$lambda$_0_0() {
        jl_Object.call(this);
        this.$_0212 = null;
    }
    $java.oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0) {
        return var$0.$_0212;
    };
    var oncie_Literal = $rt_classWithoutFields(0);
    var oncie_ExpressionWithComputedDependencies = $rt_classWithoutFields(0);
    $java.oncie_ExpressionWithComputedDependencies_introducedVariables$ = function($$this) {
        return s_Option_getOrElse($$this.$computedIntroducedVariables(), new $java.oncie_ExpressionWithComputedDependencies$introducedVariables$lambda$_6_0);
    };
    $java.oncie_ExpressionWithComputedDependencies_scopeDependencies$ = function($$this) {
        return s_Option_getOrElse($$this.$computedScopeDependencies(), new $java.oncie_ExpressionWithComputedDependencies$scopeDependencies$lambda$_8_0);
    };
    var oncias_SemanticState$ScopeLocation$ = $rt_classWithoutFields();
    var oncias_SemanticState$ScopeLocation$_MODULE$ = null;
    function oncias_SemanticState$ScopeLocation$__clinit_() {
        oncias_SemanticState$ScopeLocation$_MODULE$ = new oncias_SemanticState$ScopeLocation$;
    }
    function oncias_SemanticState$ScopeLocation$_parent$extension($this, $$this) {
        return s_Option_map(onciuh_TreeZipper$Location_up($$this), new $java.oncias_SemanticState$ScopeLocation$$parent$extension$lambda$_4_0);
    }
    function oncias_SemanticState$ScopeLocation$_newChildScope$extension($this, $$this) {
        var var$2, var$3, var$4, var$5, var$6;
        oncias_SemanticState$_$callClinit();
        oncias_Scope$_$callClinit();
        var$2 = oncias_Scope$_empty(oncias_Scope$_MODULE$);
        var$3 = new onciuh_TreeZipper$Location;
        var$4 = $$this.$$outer25;
        var$5 = new onciuh_TreeZipper$TreeContext;
        var$6 = sci_List_reverse($$this.$elem.$children1.$toList());
        s_package$_$callClinit();
        s_package$_List0(s_package$_MODULE$);
        $java.onciuh_TreeZipper$TreeContext__init_(var$5, var$4, var$6, $$this, sci_Nil$_MODULE$);
        onciuh_TreeZipper$Location__init_0(var$3, var$4, var$2, var$5);
        return var$3;
    }
    function oncias_SemanticState$ScopeLocation$_localSymbol$extension($this, $$this, $name) {
        return oncias_Scope_symbol($$this.$elem, $name);
    }
    function oncias_SemanticState$ScopeLocation$_symbol$extension($this, $$this, $name) {
        var var$3, var$4;
        var$3 = oncias_SemanticState$ScopeLocation$_localSymbol$extension($this, $$this, $name);
        var$4 = new $java.oncias_SemanticState$ScopeLocation$$symbol$extension$lambda$_10_0;
        var$4.$_021 = $$this;
        var$4.$_17 = $name;
        return s_Option_orElse(var$3, var$4);
    }
    $java.oncias_SemanticState$ScopeLocation$_symbolNames$extension = function($this, $$this) {
        return oncias_Scope_symbolNames($$this.$elem);
    };
    $java.oncias_SemanticState$ScopeLocation$_availableSymbolDefinitions$extension = function($this, $$this) {
        return (oncias_Scope_symbolDefinitions($$this.$elem)).$concat1((sc_AbstractIterable_toSet(s_Option$_option2Iterable(s_Option$_MODULE$, onciuh_TreeZipper$Location_up($$this)))).$flatMap(new $java.oncias_SemanticState$ScopeLocation$$availableSymbolDefinitions$extension$lambda$_12_0));
    };
    function oncias_SemanticState$ScopeLocation$_declarationsAndDependencies$extension($this, $$this) {
        var $allDefinitions, $parentDefinitions, $dependencies, $declarations;
        $allDefinitions = sc_AbstractMap_values(oncias_Scope_allSymbolDefinitions($$this.$elem));
        s_Predef$_$callClinit();
        $allDefinitions = sc_AbstractIterable_toSet($allDefinitions.$flatMap(s_Predef$_$conforms(s_Predef$_MODULE$)));
        $parentDefinitions = $java.oncias_SemanticState$ScopeLocation$_availableSymbolDefinitions$extension($this, ((oncias_SemanticState$ScopeLocation$_parent$extension($this, $$this)).$get0()).$location);
        $$this = new $java.oncias_SemanticState$ScopeLocation$$declarationsAndDependencies$extension$lambda$_17_0;
        $$this.$_0350 = $parentDefinitions;
        $$this = $allDefinitions.$partition($$this);
        if ($$this === null)
            $rt_throw(s_MatchError__init_($$this));
        $dependencies = $$this.$_10;
        $declarations = $$this.$_20;
        $$this = s_Tuple2__init_($dependencies, $declarations);
        $dependencies = $$this.$_10;
        $declarations = $$this.$_20;
        $$this = new $java.oncias_Scope$DeclarationsAndDependencies;
        $$this.$declarations = $declarations;
        $$this.$dependencies = $dependencies;
        return $$this;
    }
    var oncia_ASTAnnotationMap$PositionedNode$ = $rt_classWithoutFields();
    var oncia_ASTAnnotationMap$PositionedNode$_MODULE$ = null;
    function oncia_ASTAnnotationMap$PositionedNode$__clinit_() {
        oncia_ASTAnnotationMap$PositionedNode$_MODULE$ = new oncia_ASTAnnotationMap$PositionedNode$;
    }
    function oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter($this, $i) {
        var var$2;
        var$2 = new $java.oncia_ASTAnnotationMap$PositionedNode;
        var$2.$node2 = $i;
        return var$2;
    }
    function oncias_SemanticState$ScopeLocation() {
        jl_Object.call(this);
        this.$location = null;
    }
    function oncias_SemanticState$ScopeLocation__init_(var_0) {
        var var_1 = new oncias_SemanticState$ScopeLocation();
        $java.oncias_SemanticState$ScopeLocation__init_(var_1, var_0);
        return var_1;
    }
    $java.oncias_SemanticState$ScopeLocation_hashCode = function($this) {
        return onciuh_TreeZipper$Location_hashCode($this.$location);
    };
    $java.oncias_SemanticState$ScopeLocation_equals = function($this, $x$1) {
        var var$2, var$3;
        var$2 = $this.$location;
        var$3 = !($x$1 instanceof oncias_SemanticState$ScopeLocation) ? 0 : 1;
        a: {
            b: {
                if (var$3) {
                    $x$1 = $x$1 === null ? null : $x$1.$location;
                    c: {
                        if (var$2 !== null) {
                            if (!onciuh_TreeZipper$Location_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    var$3 = 1;
                    break a;
                }
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncias_SemanticState$ScopeLocation__init_ = function($this, $location) {
        $this.$location = $location;
    };
    var oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return $java.oncias_SymbolUse_asVariable(var$1);
    };
    var oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_1 = $rt_classWithoutFields();
    $java.oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        return $java.oncias_SymbolUse_asVariable(var$1);
    };
    var oncia_ProjectionClause$ = $rt_classWithoutFields();
    var oncia_ProjectionClause$_MODULE$ = null;
    function oncia_ProjectionClause$__clinit_() {
        oncia_ProjectionClause$_MODULE$ = new oncia_ProjectionClause$;
    }
    function oncia_ProjectionClause$_unapply($this, $arg) {
        var $distinct, $ri, $orderBy, $skip, $limit, $where, $limit_0, $skip_0, $where_0;
        if ($arg instanceof oncia_With) {
            $arg = $arg;
            $distinct = $arg.$distinct2;
            $ri = $arg.$returnItems2;
            $orderBy = $arg.$orderBy1;
            $skip = $arg.$skip1;
            $limit = $arg.$limit1;
            $where = $arg.$where2;
            return s_Some__init_($java.s_Tuple6__init_(jl_Boolean_valueOf($distinct), $ri, $orderBy, $skip, $limit, $where));
        }
        if ($arg instanceof oncia_Return) {
            $arg = $arg;
            $distinct = $arg.$distinct;
            $ri = $arg.$returnItems1;
            $orderBy = $arg.$orderBy0;
            $skip = $arg.$skip0;
            $limit_0 = $arg.$limit0;
            return s_Some__init_($java.s_Tuple6__init_(jl_Boolean_valueOf($distinct), $ri, $orderBy, $skip, $limit_0, s_None$_MODULE$));
        }
        if (!($arg instanceof oncia_Yield))
            $rt_throw(s_MatchError__init_($arg));
        $arg = $arg;
        $ri = $arg.$returnItems;
        $orderBy = $arg.$orderBy;
        $skip_0 = $arg.$skip;
        $limit = $arg.$limit;
        $where_0 = $arg.$where;
        return s_Some__init_($java.s_Tuple6__init_(jl_Boolean_valueOf(0), $ri, $orderBy, $skip_0, $limit, $where_0));
    }
    $java.oncia_ProjectionClause$_checkAliasedReturnItems = function($this, $returnItems, $clauseName) {
        var var$3;
        var$3 = new $java.oncia_ProjectionClause$$checkAliasedReturnItems$lambda$_2_0;
        var$3.$_0351 = $returnItems;
        var$3.$_1105 = $clauseName;
        return var$3;
    };
    $java.s_Product6 = $rt_classWithoutFields(0);
    $java.s_Tuple6 = function() {
        var a = this; jl_Object.call(a);
        a.$_1106 = null;
        a.$_227 = null;
        a.$_38 = null;
        a.$_4 = null;
        a.$_5 = null;
        a.$_6 = null;
    };
    $java.s_Tuple6__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new $java.s_Tuple6();
        $java.s_Tuple6__init_0(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    };
    $java.s_Tuple6_productArity = function($this) {
        return 6;
    };
    $java.s_Tuple6_productElement = function($this, $n) {
        var var$2, var$3;
        a: {
            switch ($n) {
                case 0:
                    break;
                case 1:
                    var$2 = $this.$_227;
                    break a;
                case 2:
                    var$2 = $this.$_38;
                    break a;
                case 3:
                    var$2 = $this.$_4;
                    break a;
                case 4:
                    var$2 = $this.$_5;
                    break a;
                case 5:
                    var$2 = $this.$_6;
                    break a;
                default:
                    var$3 = new jl_IndexOutOfBoundsException;
                    var$2 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_2(var$2, 32);
                    var$2 = jl_StringBuilder_append0(var$2, $n);
                    jl_AbstractStringBuilder_append1(var$2, $rt_s(1413));
                    jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$2));
                    $rt_throw(var$3);
            }
            var$2 = $this.$_1106;
        }
        return var$2;
    };
    $java.s_Tuple6_toString = function($this) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 7);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(24));
        var$1 = jl_StringBuilder_append(var$1, $this.$_1106);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_227);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_38);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_4);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_5);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(43));
        var$1 = jl_StringBuilder_append(var$1, $this.$_6);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(25));
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.s_Tuple6_productPrefix = function($this) {
        return $rt_s(1414);
    };
    $java.s_Tuple6_productIterator = function($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    };
    $java.s_Tuple6_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    };
    $java.s_Tuple6_equals = function($this, $x$1) {
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof $java.s_Tuple6) ? 0 : 1))
                    break a;
                $x$1 = $x$1;
                if (!sr_BoxesRunTime_equals($this.$_1106, $x$1.$_1106))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_227, $x$1.$_227))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_38, $x$1.$_38))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_4, $x$1.$_4))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_5, $x$1.$_5))
                    break a;
                if (!sr_BoxesRunTime_equals($this.$_6, $x$1.$_6))
                    break a;
            }
            return 1;
        }
        return 0;
    };
    $java.s_Tuple6__init_0 = function($this, $_1, $_2, $_3, $_4, $_5, $_6) {
        $this.$_1106 = $_1;
        $this.$_227 = $_2;
        $this.$_38 = $_3;
        $this.$_4 = $_4;
        $this.$_5 = $_5;
        $this.$_6 = $_6;
    };
    $java.oncie_ScopeExpression = $rt_classWithoutFields(0);
    $java.oncie_SubqueryExpression = $rt_classWithoutFields(0);
    var oncia_FullSubqueryExpression = $rt_classWithoutFields(0);
    function oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_0() {
        jl_Object.call(this);
        this.$_0268 = null;
    }
    var oncirr_normalizeWithAndReturnClauses$$anonfun$1$$anonfun$2 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_normalizeWithAndReturnClauses$$anonfun$1$$anonfun$2_applyOrElse = function($this, $x, $default) {
        var var$3;
        $x = $x;
        if (!($x instanceof oncia_AliasedReturnItem))
            $x = $default.$apply($x);
        else {
            $x = $x;
            var$3 = $x.$expression10;
            $default = $x.$variable13;
            $x = s_Predef$ArrowAssoc$_MODULE$;
            s_Predef$_$callClinit();
            $x = s_Predef$ArrowAssoc$_$minus$greater$extension($x, var$3, $default);
        }
        return $x;
    };
    function oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_1() {
        var a = this; jl_Object.call(a);
        a.$_0269 = null;
        a.$_174 = null;
    }
    $java.oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0269;
        var$3 = var$0.$_174;
        var$2 = var$2.$$outer1;
        var$4 = var$1.$sortItems;
        var$5 = new $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasOrderBy$lambda$_42_0;
        var$5.$_0352 = var$2;
        var$5.$_1107 = var$3;
        return oncia_OrderBy__init_(var$4.$map1(var$5), var$1.$position59);
    };
    function oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_2() {
        var a = this; jl_Object.call(a);
        a.$_0270 = null;
        a.$_175 = null;
    }
    $java.oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0270;
        var$3 = var$0.$_175;
        var$2 = var$2.$$outer1;
        return oncia_Where__init_(oncirr_normalizeWithAndReturnClauses_aliasExpression(var$2, var$3, var$1.$expression4), var$1.$position3);
    };
    $java.oncie_PatternPart = $rt_classWithoutFields();
    $java.oncie_PatternPart_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternPart_foldedOver = function($this) {
        return $this;
    };
    $java.oncie_PatternPart_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncie_PatternPart_dup0 = function($this, $children) {
        return $this.$dup0($children);
    };
    $java.oncie_PatternPart__init_ = function($this) {};
    var oncie_NonPrefixedPatternPart = $rt_classWithoutFields(0);
    var oncie_AnonymousPatternPart = $rt_classWithoutFields(0);
    $java.oncie_AnonymousPatternPart_allVariables$ = function($$this) {
        return ($$this.$element()).$allVariables();
    };
    function oncie_ShortestPathsPatternPart() {
        var a = this; $java.oncie_PatternPart.call(a);
        a.$element3 = null;
        a.$single0 = 0;
        a.$position42 = null;
        a.$name13 = null;
    }
    function oncie_ShortestPathsPatternPart__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_ShortestPathsPatternPart();
        $java.oncie_ShortestPathsPatternPart__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_ShortestPathsPatternPart_allVariables = function($this) {
        return $java.oncie_AnonymousPatternPart_allVariables$($this);
    };
    function oncie_ShortestPathsPatternPart_element($this) {
        return $this.$element3;
    }
    function oncie_ShortestPathsPatternPart_single($this) {
        return $this.$single0;
    }
    $java.oncie_ShortestPathsPatternPart_position = function($this) {
        return $this.$position42;
    };
    $java.oncie_ShortestPathsPatternPart_isBounded = function($this) {
        return 1;
    };
    function oncie_ShortestPathsPatternPart_copy($this, $element, $single, $position) {
        return oncie_ShortestPathsPatternPart__init_($element, $single, $position);
    }
    $java.oncie_ShortestPathsPatternPart_productPrefix = function($this) {
        return $rt_s(1415);
    };
    $java.oncie_ShortestPathsPatternPart_productArity = function($this) {
        return 2;
    };
    $java.oncie_ShortestPathsPatternPart_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$element3;
            case 1:
                return jl_Boolean_valueOf($this.$single0);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ShortestPathsPatternPart_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ShortestPathsPatternPart_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1415))), sr_Statics_anyHash($this.$element3)), !$this.$single0 ? 1237 : 1231), 2);
    };
    $java.oncie_ShortestPathsPatternPart_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ShortestPathsPatternPart_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ShortestPathsPatternPart) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$single0 != $x$1.$single0)
                        break b;
                    c: {
                        var$2 = $this.$element3;
                        $x$1 = $x$1.$element3;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ShortestPathsPatternPart))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_ShortestPathsPatternPart__init_ = function($this, $element, $single, $position) {
        $this.$element3 = $element;
        $this.$single0 = $single;
        $this.$position42 = $position;
        $java.oncie_PatternPart__init_($this);
        $this.$name13 = !$single ? $rt_s(1416) : $rt_s(1417);
    };
    $java.oncie_PatternElement = $rt_classWithoutFields();
    $java.oncie_PatternElement_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternElement_foldedOver = function($this) {
        return $this;
    };
    $java.oncie_PatternElement_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncie_PatternElement_dup0 = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternElement__init_ = function($this) {};
    $java.oncie_PathFactor = $rt_classWithoutFields(0);
    $java.oncie_SimplePattern = $rt_classWithoutFields($java.oncie_PatternElement);
    function oncie_RelationshipChain() {
        var a = this; $java.oncie_SimplePattern.call(a);
        a.$element4 = null;
        a.$relationship1 = null;
        a.$rightNode = null;
        a.$position41 = null;
    }
    function oncie_RelationshipChain__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncie_RelationshipChain();
        oncie_RelationshipChain__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function oncie_RelationshipChain_element($this) {
        return $this.$element4;
    }
    function oncie_RelationshipChain_relationship($this) {
        return $this.$relationship1;
    }
    $java.oncie_RelationshipChain_position = function($this) {
        return $this.$position41;
    };
    $java.oncie_RelationshipChain_allVariables = function($this) {
        return (($this.$element4.$allVariables()).$concat1($this.$relationship1.$variable12)).$concat1($this.$rightNode.$variable11);
    };
    $java.oncie_RelationshipChain_isBounded = function($this) {
        var var$1, var$2, var$3;
        a: {
            var$1 = $this.$relationship1.$length2;
            if (var$1 instanceof s_Some) {
                var$2 = var$1.$value5;
                if (var$2 instanceof s_Some) {
                    var$2 = var$2.$value5;
                    if (var$2 !== null && var$2.$upper instanceof s_Some) {
                        var$3 = 1;
                        break a;
                    }
                }
            }
            if (!jl_Object_equals(s_None$_MODULE$, var$1))
                var$3 = 0;
            else
                var$3 = 1;
        }
        return var$3 && $this.$element4.$isBounded() ? 1 : 0;
    };
    function oncie_RelationshipChain_copy($this, $element, $relationship, $rightNode, $position) {
        return oncie_RelationshipChain__init_($element, $relationship, $rightNode, $position);
    }
    $java.oncie_RelationshipChain_productPrefix = function($this) {
        return $rt_s(1418);
    };
    $java.oncie_RelationshipChain_productArity = function($this) {
        return 3;
    };
    $java.oncie_RelationshipChain_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$element4;
            case 1:
                return $this.$relationship1;
            case 2:
                return $this.$rightNode;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_RelationshipChain_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipChain_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipChain_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipChain_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_RelationshipChain) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$element4;
                        var$3 = $x$1.$element4;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relationship1;
                        var$3 = $x$1.$relationship1;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelationshipPattern_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$rightNode;
                        $x$1 = $x$1.$rightNode;
                        if (var$3 !== null) {
                            if (!$java.oncie_NodePattern_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_RelationshipChain))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncie_RelationshipChain__init_0($this, $element, $relationship, $rightNode, $position) {
        $this.$element4 = $element;
        $this.$relationship1 = $relationship;
        $this.$rightNode = $rightNode;
        $this.$position41 = $position;
        $java.oncie_PatternElement__init_($this);
    }
    $java.oncie_PatternAtom = $rt_classWithoutFields(0);
    function oncie_NodePattern() {
        var a = this; $java.oncie_SimplePattern.call(a);
        a.$variable11 = null;
        a.$labelExpression1 = null;
        a.$properties4 = null;
        a.$predicate0 = null;
        a.$position60 = null;
    }
    function oncie_NodePattern__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncie_NodePattern();
        oncie_NodePattern__init_0(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncie_NodePattern_labelExpression = function($this) {
        return $this.$labelExpression1;
    };
    $java.oncie_NodePattern_properties = function($this) {
        return $this.$properties4;
    };
    $java.oncie_NodePattern_position = function($this) {
        return $this.$position60;
    };
    $java.oncie_NodePattern_allVariables = function($this) {
        return sc_AbstractIterable_toSet(s_Option$_option2Iterable(s_Option$_MODULE$, $this.$variable11));
    };
    $java.oncie_NodePattern_isBounded = function($this) {
        return 1;
    };
    $java.oncie_NodePattern_productPrefix = function($this) {
        return $rt_s(1419);
    };
    $java.oncie_NodePattern_productArity = function($this) {
        return 4;
    };
    $java.oncie_NodePattern_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable11;
            case 1:
                return $this.$labelExpression1;
            case 2:
                return $this.$properties4;
            case 3:
                return $this.$predicate0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_NodePattern_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NodePattern_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NodePattern_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NodePattern_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_NodePattern) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable11;
                        var$3 = $x$1.$variable11;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$labelExpression1;
                        var$3 = $x$1.$labelExpression1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties4;
                        var$3 = $x$1.$properties4;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$predicate0;
                        $x$1 = $x$1.$predicate0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_NodePattern))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncie_NodePattern__init_0($this, $variable, $labelExpression, $properties, $predicate, $position) {
        $this.$variable11 = $variable;
        $this.$labelExpression1 = $labelExpression;
        $this.$properties4 = $properties;
        $this.$predicate0 = $predicate;
        $this.$position60 = $position;
        $java.oncie_PatternElement__init_($this);
    }
    $java.oncie_NumberLiteral = $rt_classWithoutFields(0);
    $java.oncie_IntegerLiteral = $rt_classWithoutFields(0);
    $java.oncie_DecimalIntegerLiteral = function() {
        var a = this; oncie_Expression.call(a);
        a.$integerMatcher = null;
        a.$value20 = null;
        a.$stringVal0 = null;
        a.$bitmap$01 = 0;
    };
    $java.oncie_DecimalIntegerLiteral_asCanonicalStringVal = function($this) {
        return $this.$stringVal1();
    };
    $java.oncie_DecimalIntegerLiteral_integerMatcher = function($this) {
        var var$1, var$2, $$je;
        if (($this.$bitmap$01 & 1) << 24 >> 24)
            return $this.$integerMatcher;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$01 & 1) << 24 >> 24)
                    break a;
                var$1 = sc_StringOps$_MODULE$;
                s_Predef$_$callClinit();
                $this.$integerMatcher = sc_StringOps$_r$extension(var$1, s_Predef$_augmentString(s_Predef$_MODULE$, $rt_s(1420)));
                $this.$bitmap$01 = ($this.$bitmap$01 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$2);
        }
        jl_Object_monitorExitSync($this);
        return $this.$integerMatcher;
    };
    $java.oncie_DecimalIntegerLiteral_value = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$01 & 2) << 24 >> 24)
            return $this.$value20;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$01 & 2) << 24 >> 24)
                    break a;
                var$1 = $this.$stringVal0;
                if (var$1 !== null && !s_Option_isEmpty($java.sum_Regex_unapplySeq($java.oncie_DecimalIntegerLiteral_integerMatcher($this), var$1))) {
                    s_Predef$_$callClinit();
                    var$1 = s_Predef$_MODULE$;
                    var$1 = s_Predef$_long2Long(var$1, jl_Long_parseLong(sc_AbstractIterable_mkString1(sci_List_filter(sc_AbstractIterable_toList(s_LowPriorityImplicits_wrapString(var$1, $this.$stringVal0)), $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0__init_()))));
                } else {
                    s_Predef$_$callClinit();
                    var$1 = s_Predef$_long2Long(s_Predef$_MODULE$, jl_Long_parseLong($this.$stringVal0));
                }
                $this.$value20 = var$1;
                $this.$bitmap$01 = ($this.$bitmap$01 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$value20;
    };
    $java.oncie_DecimalIntegerLiteral__init_ = function($this, $stringVal) {
        $this.$stringVal0 = $stringVal;
        $java.oncie_Expression__init_($this);
    };
    $java.oncie_UnsignedIntegerLiteral = $rt_classWithoutFields(0);
    function oncie_UnsignedDecimalIntegerLiteral() {
        var a = this; $java.oncie_DecimalIntegerLiteral.call(a);
        a.$stringVal = null;
        a.$position61 = null;
    }
    function oncie_UnsignedDecimalIntegerLiteral__init_(var_0, var_1) {
        var var_2 = new oncie_UnsignedDecimalIntegerLiteral();
        oncie_UnsignedDecimalIntegerLiteral__init_0(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_UnsignedDecimalIntegerLiteral_stringVal = function($this) {
        return $this.$stringVal;
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_position = function($this) {
        return $this.$position61;
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_UnsignedDecimalIntegerLiteral$$anon$2;
        oncie_UnsignedDecimalIntegerLiteral__init_0(var$1, $this.$stringVal, $this.$position61);
        return var$1;
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_copy = function($this, $stringVal, $position) {
        return oncie_UnsignedDecimalIntegerLiteral__init_($stringVal, $position);
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_productPrefix = function($this) {
        return $rt_s(1421);
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$stringVal;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_UnsignedDecimalIntegerLiteral;
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnsignedDecimalIntegerLiteral_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_UnsignedDecimalIntegerLiteral) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$stringVal;
                        $x$1 = $x$1.$stringVal;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_UnsignedDecimalIntegerLiteral))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncie_UnsignedDecimalIntegerLiteral__init_0($this, $stringVal, $position) {
        $this.$stringVal = $stringVal;
        $this.$position61 = $position;
        $java.oncie_DecimalIntegerLiteral__init_($this, $stringVal);
    }
    function oncie_Range() {
        var a = this; jl_Object.call(a);
        a.$lower = null;
        a.$upper = null;
        a.$position62 = null;
    }
    function oncie_Range__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Range();
        oncie_Range__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Range_position = function($this) {
        return $this.$position62;
    };
    $java.oncie_Range_productPrefix = function($this) {
        return $rt_s(1422);
    };
    $java.oncie_Range_productArity = function($this) {
        return 2;
    };
    $java.oncie_Range_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lower;
            case 1:
                return $this.$upper;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Range_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Range_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Range_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Range_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Range) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lower;
                        var$3 = $x$1.$lower;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$upper;
                        $x$1 = $x$1.$upper;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Range))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Range_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncie_Range__init_0($this, $lower, $upper, $position) {
        $this.$lower = $lower;
        $this.$upper = $upper;
        $this.$position62 = $position;
    }
    var onciu_Foldable$TreeAny$$reverseTreeChildren$extension$lambda$_2_0 = $rt_classWithoutFields();
    $java.onciu_Foldable$TreeAny$$reverseTreeChildren$extension$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$3 = var$1.$_20;
        s_package$_$callClinit();
        s_package$_Iterator0(s_package$_MODULE$);
        return (sr_ScalaRunTime$_genericWrapArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_Object, [var$3, var$2]))).$iterator0();
    };
    function sr_ObjectRef() {
        jl_Object.call(this);
        this.$elem5 = null;
    }
    function sr_ObjectRef__init_(var_0) {
        var var_1 = new sr_ObjectRef();
        $java.sr_ObjectRef__init_(var_1, var_0);
        return var_1;
    }
    $java.sr_ObjectRef__init_ = function($this, $elem) {
        $this.$elem5 = $elem;
    };
    $java.sr_ObjectRef_create = function($e) {
        return sr_ObjectRef__init_($e);
    };
    function sci_Vector$appendedAll0$lambda$_77_0() {
        jl_Object.call(this);
        this.$_0177 = null;
    }
    $java.sci_Vector$appendedAll0$lambda$_77_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0177;
        var$2.$elem5 = var$2.$elem5.$appended1(var$1);
        return sr_BoxedUnit_UNIT;
    };
    function sci_Vector$appendedAll0$lambda$_77_1() {
        jl_Object.call(this);
        this.$_0178 = null;
    }
    $java.sci_Vector$appendedAll0$lambda$_77_1_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0178;
        var$2.$elem5 = var$2.$elem5.$appended1(var$1);
        return sr_BoxedUnit_UNIT;
    };
    function oncirr_normalizeWithAndReturnClauses$rewriteTopLevelSingleQuery$lambda$_36_0() {
        jl_Object.call(this);
        this.$_0267 = null;
    }
    $java.oncirr_normalizeWithAndReturnClauses$rewriteTopLevelSingleQuery$lambda$_36_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0267;
        if (var$1 instanceof oncia_Return)
            var$1 = oncirr_normalizeWithAndReturnClauses_addAliasesToReturn(var$2, var$1);
        return var$1;
    };
    function oncie_Namespace() {
        var a = this; jl_Object.call(a);
        a.$parts0 = null;
        a.$position63 = null;
    }
    function oncie_Namespace__init_(var_0, var_1) {
        var var_2 = new oncie_Namespace();
        $java.oncie_Namespace__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_Namespace_parts($this) {
        return $this.$parts0;
    }
    $java.oncie_Namespace_position = function($this) {
        return $this.$position63;
    };
    $java.oncie_Namespace_productPrefix = function($this) {
        return $rt_s(1423);
    };
    $java.oncie_Namespace_productArity = function($this) {
        return 1;
    };
    $java.oncie_Namespace_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$parts0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Namespace_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Namespace_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Namespace_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Namespace_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Namespace) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$parts0;
                        $x$1 = $x$1.$parts0;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Namespace))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_Namespace_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_Namespace__init_ = function($this, $parts, $position) {
        $this.$parts0 = $parts;
        $this.$position63 = $position;
    };
    $java.oncias_Scope$DeclarationsAndDependencies = function() {
        var a = this; jl_Object.call(a);
        a.$declarations = null;
        a.$dependencies = null;
    };
    $java.oncias_Scope$DeclarationsAndDependencies_productPrefix = function($this) {
        return $rt_s(1424);
    };
    $java.oncias_Scope$DeclarationsAndDependencies_productArity = function($this) {
        return 2;
    };
    $java.oncias_Scope$DeclarationsAndDependencies_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$declarations;
            case 1:
                return $this.$dependencies;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_Scope$DeclarationsAndDependencies_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_Scope$DeclarationsAndDependencies_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    function oncie_RelationshipPattern() {
        var a = this; jl_Object.call(a);
        a.$variable12 = null;
        a.$labelExpression2 = null;
        a.$length2 = null;
        a.$properties5 = null;
        a.$predicate1 = null;
        a.$direction0 = null;
        a.$position32 = null;
    }
    function oncie_RelationshipPattern__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncie_RelationshipPattern();
        $java.oncie_RelationshipPattern__init_(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    }
    function oncie_RelationshipPattern_asCanonicalStringVal($this) {
        return $this.$toString();
    }
    function oncie_RelationshipPattern_variable($this) {
        return $this.$variable12;
    }
    function oncie_RelationshipPattern_labelExpression($this) {
        return $this.$labelExpression2;
    }
    function oncie_RelationshipPattern_length($this) {
        return $this.$length2;
    }
    function oncie_RelationshipPattern_properties($this) {
        return $this.$properties5;
    }
    function oncie_RelationshipPattern_predicate($this) {
        return $this.$predicate1;
    }
    function oncie_RelationshipPattern_direction($this) {
        return $this.$direction0;
    }
    function oncie_RelationshipPattern_position($this) {
        return $this.$position32;
    }
    function oncie_RelationshipPattern_copy($this, $variable, $labelExpression, $length, $properties, $predicate, $direction, $position) {
        return oncie_RelationshipPattern__init_($variable, $labelExpression, $length, $properties, $predicate, $direction, $position);
    }
    function oncie_RelationshipPattern_copy$default$1($this) {
        return $this.$variable12;
    }
    function oncie_RelationshipPattern_copy$default$3($this) {
        return $this.$length2;
    }
    function oncie_RelationshipPattern_copy$default$4($this) {
        return $this.$properties5;
    }
    function oncie_RelationshipPattern_copy$default$5($this) {
        return $this.$predicate1;
    }
    function oncie_RelationshipPattern_copy$default$6($this) {
        return $this.$direction0;
    }
    $java.oncie_RelationshipPattern_productPrefix = function($this) {
        return $rt_s(1425);
    };
    $java.oncie_RelationshipPattern_productArity = function($this) {
        return 6;
    };
    $java.oncie_RelationshipPattern_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable12;
            case 1:
                return $this.$labelExpression2;
            case 2:
                return $this.$length2;
            case 3:
                return $this.$properties5;
            case 4:
                return $this.$predicate1;
            case 5:
                return $this.$direction0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_RelationshipPattern_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipPattern_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipPattern_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipPattern_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_RelationshipPattern) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable12;
                        var$3 = $x$1.$variable12;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$labelExpression2;
                        var$3 = $x$1.$labelExpression2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$length2;
                        var$3 = $x$1.$length2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$properties5;
                        var$3 = $x$1.$properties5;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$predicate1;
                        var$3 = $x$1.$predicate1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$3 = $this.$direction0;
                        $x$1 = $x$1.$direction0;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break h;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_RelationshipPattern))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_RelationshipPattern_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_RelationshipPattern__init_ = function($this, $variable, $labelExpression, $length, $properties, $predicate, $direction, $position) {
        $this.$variable12 = $variable;
        $this.$labelExpression2 = $labelExpression;
        $this.$length2 = $length;
        $this.$properties5 = $properties;
        $this.$predicate1 = $predicate;
        $this.$direction0 = $direction;
        $this.$position32 = $position;
    };
    var sci_SetOps$removedAll$lambda$_9_0 = $rt_classWithoutFields();
    $java.sci_SetOps$removedAll$lambda$_9_0_apply = function(var$0, var$1, var$2) {
        return var$1.$excl(var$2);
    };
    function oncifp_BaseState$semanticTable$lambda$_19_0() {
        jl_Object.call(this);
        this.$_020 = null;
    }
    $java.oncifp_BaseState$semanticTable$lambda$_19_0_apply = function(var$0) {
        return oncifp_InitialState_fail(var$0.$_020, $rt_s(1426));
    };
    function onciu_StepSequencer$$anonfun$orderSteps$21$lambda$_37_0() {
        var a = this; jl_Object.call(a);
        a.$_0226 = null;
        a.$_161 = null;
    }
    var sci_HashMapBuilder$$anon$1 = $rt_classWithoutFields(sci_ChampBaseIterator);
    $java.sc_SeqMap = $rt_classWithoutFields(0);
    $java.scm_SeqMap = $rt_classWithoutFields(0);
    var scm_LinkedHashMap = $rt_classWithoutFields(scm_AbstractMap);
    var scm_LinkedHashMap$LinkedEntry = $rt_classWithoutFields();
    function sci_HashMapBuilder$addAll$lambda$_25_0() {
        jl_Object.call(this);
        this.$_0258 = null;
    }
    $java.sci_HashMapBuilder$addAll$lambda$_25_0_apply = function(var$0, var$1, var$2) {
        return sci_HashMapBuilder_addOne0(var$0.$_0258, var$1, var$2);
    };
    $java.sc_Iterable$$anon$1 = function() {
        sc_AbstractIterable.call(this);
        this.$a$10 = null;
    };
    $java.sc_Iterable$$anon$1_iterator = function($this) {
        return sc_Iterator$$anon$20__init_($this.$a$10);
    };
    $java.sc_Iterable$$anon$1_knownSize = function($this) {
        return 1;
    };
    function onciu_Ref() {
        jl_Object.call(this);
        this.$value19 = null;
    }
    $java.onciu_Ref_id = function($this) {
        return jl_Object_identity($this.$value19);
    };
    function onciu_Ref_toIdString($this) {
        return jl_Integer_toHexString($java.onciu_Ref_id($this));
    }
    $java.onciu_Ref_toString = function($this) {
        var var$1, var$2, var$3;
        var$1 = onciu_Ref_toIdString($this);
        var$2 = $this.$value19;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$1 = jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1427)), var$1);
        jl_AbstractStringBuilder_append(var$1, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$1, var$2), 41);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.onciu_Ref_hashCode = function($this) {
        return $java.onciu_Ref_id($this);
    };
    $java.onciu_Ref_equals = function($this, $that) {
        if (!($that instanceof onciu_Ref))
            return 0;
        $that = $that;
        return $this.$value19 !== $that.$value19 ? 0 : 1;
    };
    $java.oncias_SemanticState$ScopeLocation$$declarationsAndDependencies$extension$lambda$_17_0 = function() {
        jl_Object.call(this);
        this.$_0350 = null;
    };
    $java.oncias_SemanticState$ScopeLocation$$declarationsAndDependencies$extension$lambda$_17_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$0.$_0350.$contains0(var$1));
    };
    $java.oncia_ASTAnnotationMap$PositionedNode = function() {
        jl_Object.call(this);
        this.$node2 = null;
    };
    $java.oncia_ASTAnnotationMap$PositionedNode_toString = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$node2;
        var$2 = (var$1.$position2()).$offset0;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$4 = jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1428)), var$1);
        jl_AbstractStringBuilder_append(var$4, 64);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append0(var$4, var$2), 41);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.oncia_ASTAnnotationMap$PositionedNode_equals = function($this, $that) {
        var var$2, var$3, var$4;
        if (!($that instanceof $java.oncia_ASTAnnotationMap$PositionedNode))
            return 0;
        a: {
            b: {
                $that = $that;
                if ($this instanceof $java.oncia_ASTAnnotationMap$PositionedNode) {
                    c: {
                        var$2 = $this.$node2;
                        var$3 = $that.$node2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$node2.$position2();
                        $that = $that.$node2.$position2();
                        if (var$3 !== null) {
                            if (!onciu_InputPosition_equals(var$3, $that))
                                break b;
                            else
                                break d;
                        }
                        if ($that !== null)
                            break b;
                    }
                    var$4 = 1;
                    break a;
                }
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ASTAnnotationMap$PositionedNode_hashCode = function($this) {
        var var$1, var$2;
        var$1 = new s_Tuple2;
        var$2 = $this.$node2;
        s_Tuple2__init_0(var$1, var$2, var$2.$position2());
        return s_Tuple2_hashCode(var$1);
    };
    $java.oncia_ASTAnnotationMap$PositionedNode_productArity = function($this) {
        return 1;
    };
    $java.oncia_ASTAnnotationMap$PositionedNode_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$node2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ASTAnnotationMap$PositionedNode_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    function oncia_With() {
        var a = this; jl_Object.call(a);
        a.$distinct2 = 0;
        a.$returnItems2 = null;
        a.$orderBy1 = null;
        a.$skip1 = null;
        a.$limit1 = null;
        a.$where2 = null;
        a.$withType = null;
        a.$position52 = null;
        a.$LabelExpressionsPartition$module0 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier0 = null;
        a.$SetExtractor$module0 = null;
    }
    function oncia_With__init_0(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_With();
        oncia_With__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_With_isReturn = function($this) {
        return 0;
    };
    $java.oncia_With_copyProjection = function($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where) {
        return oncia_ProjectionClause_copyProjection$($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where);
    };
    $java.oncia_With_copyProjection$default$1 = function($this) {
        return $this.$distinct1();
    };
    $java.oncia_With_copyProjection$default$3 = function($this) {
        return $this.$orderBy2();
    };
    $java.oncia_With_copyProjection$default$4 = function($this) {
        return $this.$skip2();
    };
    $java.oncia_With_copyProjection$default$5 = function($this) {
        return $this.$limit3();
    };
    $java.oncia_With_copyProjection$default$6 = function($this) {
        return $this.$where0();
    };
    $java.oncia_With_semanticCheckContinuation = function($this, $previousScope, $outerScope) {
        return oncia_ProjectionClause_semanticCheckContinuation$($this, $previousScope, $outerScope);
    };
    $java.oncia_With_semanticCheckContinuation$default$2 = function($this) {
        return s_None$_MODULE$;
    };
    $java.oncia_With_warnOnAccessToRestrictedVariableInOrderByOrWhere = function($this, $previousScopeVars, $error) {
        return oncia_ProjectionClause_warnOnAccessToRestrictedVariableInOrderByOrWhere$($this, $previousScopeVars, $error);
    };
    $java.oncia_With_verifyOrderByAggregationUse = function($this, $fail) {
        oncia_ProjectionClause_verifyOrderByAggregationUse$($this, $fail);
    };
    $java.oncia_With_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_With_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_With_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_With_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_With_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_With_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_With_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_With_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module0 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module0 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module0 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module0;
    };
    $java.oncia_With_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier0;
    };
    $java.oncia_With_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module0 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module0 !== null)
                        break a;
                    $this.$SetExtractor$module0 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module0;
    };
    $java.oncia_With_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier0 = $x$1;
    };
    $java.oncia_With_distinct = function($this) {
        return $this.$distinct2;
    };
    $java.oncia_With_returnItems = function($this) {
        return $this.$returnItems2;
    };
    $java.oncia_With_orderBy = function($this) {
        return $this.$orderBy1;
    };
    $java.oncia_With_skip = function($this) {
        return $this.$skip1;
    };
    $java.oncia_With_limit = function($this) {
        return $this.$limit1;
    };
    $java.oncia_With_where = function($this) {
        return $this.$where2;
    };
    $java.oncia_With_position = function($this) {
        return $this.$position52;
    };
    $java.oncia_With_name = function($this) {
        return $rt_s(364);
    };
    $java.oncia_With_clauseSpecificSemanticCheck = function($this) {
        var var$1;
        var$1 = oncias_SemanticCheck_chain$(oncia_ProjectionClause_clauseSpecificSemanticCheck$($this), $java.oncias_package$_liftSemanticErrorDefsFunc(oncias_package$_MODULE$, $java.oncia_ProjectionClause$_checkAliasedReturnItems(oncia_ProjectionClause$_MODULE$, $this.$returnItems2, $rt_s(364))));
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNamesInReturnItems(oncias_SemanticPatternCheck$_MODULE$, $this.$returnItems2));
    };
    function oncia_With_copy($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where, $withType, $position) {
        return oncia_With__init_0($distinct, $returnItems, $orderBy, $skip, $limit, $where, $withType, $position);
    }
    $java.oncia_With_productPrefix = function($this) {
        return $rt_s(1429);
    };
    $java.oncia_With_productArity = function($this) {
        return 7;
    };
    $java.oncia_With_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$distinct2);
            case 1:
                return $this.$returnItems2;
            case 2:
                return $this.$orderBy1;
            case 3:
                return $this.$skip1;
            case 4:
                return $this.$limit1;
            case 5:
                return $this.$where2;
            case 6:
                return $this.$withType;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_With_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_With_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1429))), !$this.$distinct2 ? 1237 : 1231), sr_Statics_anyHash($this.$returnItems2)), sr_Statics_anyHash($this.$orderBy1)), sr_Statics_anyHash($this.$skip1)), sr_Statics_anyHash($this.$limit1)), sr_Statics_anyHash($this.$where2)), sr_Statics_anyHash($this.$withType)), 7);
    };
    $java.oncia_With_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_With_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_With) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$distinct2 != $x$1.$distinct2)
                        break b;
                    c: {
                        var$2 = $this.$returnItems2;
                        var$3 = $x$1.$returnItems2;
                        if (var$2 !== null) {
                            if (!oncia_ReturnItems_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$orderBy1;
                        var$3 = $x$1.$orderBy1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$skip1;
                        var$3 = $x$1.$skip1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$limit1;
                        var$3 = $x$1.$limit1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$where2;
                        var$3 = $x$1.$where2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$3 = $this.$withType;
                        $x$1 = $x$1.$withType;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break h;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_With))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_With_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncia_With__init_($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where, $withType, $position) {
        $this.$distinct2 = $distinct;
        $this.$returnItems2 = $returnItems;
        $this.$orderBy1 = $orderBy;
        $this.$skip1 = $skip;
        $this.$limit1 = $limit;
        $this.$where2 = $where;
        $this.$withType = $withType;
        $this.$position52 = $position;
        oncia_Clause_$init$($this);
    }
    function oncia_Return() {
        var a = this; jl_Object.call(a);
        a.$distinct = 0;
        a.$returnItems1 = null;
        a.$orderBy0 = null;
        a.$skip0 = null;
        a.$limit0 = null;
        a.$excludedNames = null;
        a.$addedInRewrite = 0;
        a.$position40 = null;
        a.$LabelExpressionsPartition$module1 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier1 = null;
        a.$SetExtractor$module1 = null;
    }
    $java.oncia_Return__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_Return();
        oncia_Return__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    };
    $java.oncia_Return_copyProjection = function($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where) {
        return oncia_ProjectionClause_copyProjection$($this, $distinct, $returnItems, $orderBy, $skip, $limit, $where);
    };
    $java.oncia_Return_copyProjection$default$1 = function($this) {
        return $this.$distinct1();
    };
    $java.oncia_Return_copyProjection$default$3 = function($this) {
        return $this.$orderBy2();
    };
    $java.oncia_Return_copyProjection$default$4 = function($this) {
        return $this.$skip2();
    };
    $java.oncia_Return_copyProjection$default$5 = function($this) {
        return $this.$limit3();
    };
    $java.oncia_Return_copyProjection$default$6 = function($this) {
        return $this.$where0();
    };
    $java.oncia_Return_semanticCheckContinuation = function($this, $previousScope, $outerScope) {
        return oncia_ProjectionClause_semanticCheckContinuation$($this, $previousScope, $outerScope);
    };
    $java.oncia_Return_semanticCheckContinuation$default$2 = function($this) {
        return s_None$_MODULE$;
    };
    $java.oncia_Return_warnOnAccessToRestrictedVariableInOrderByOrWhere = function($this, $previousScopeVars, $error) {
        return oncia_ProjectionClause_warnOnAccessToRestrictedVariableInOrderByOrWhere$($this, $previousScopeVars, $error);
    };
    $java.oncia_Return_verifyOrderByAggregationUse = function($this, $fail) {
        oncia_ProjectionClause_verifyOrderByAggregationUse$($this, $fail);
    };
    $java.oncia_Return_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Return_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_Return_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Return_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Return_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Return_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Return_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module1 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module1 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module1 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module1;
    };
    $java.oncia_Return_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier1;
    };
    $java.oncia_Return_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module1 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module1 !== null)
                        break a;
                    $this.$SetExtractor$module1 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module1;
    };
    $java.oncia_Return_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier1 = $x$1;
    };
    $java.oncia_Return_distinct = function($this) {
        return $this.$distinct;
    };
    function oncia_Return_returnItems($this) {
        return $this.$returnItems1;
    }
    $java.oncia_Return_orderBy = function($this) {
        return $this.$orderBy0;
    };
    $java.oncia_Return_skip = function($this) {
        return $this.$skip0;
    };
    $java.oncia_Return_limit = function($this) {
        return $this.$limit0;
    };
    $java.oncia_Return_position = function($this) {
        return $this.$position40;
    };
    $java.oncia_Return_name = function($this) {
        return $rt_s(339);
    };
    $java.oncia_Return_isReturn = function($this) {
        return 1;
    };
    $java.oncia_Return_where = function($this) {
        return s_None$_MODULE$;
    };
    $java.oncia_Return_returnVariables = function($this) {
        return $java.oncia_ReturnItems_returnVariables($this.$returnItems1);
    };
    $java.oncia_Return_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2, var$3;
        var$1 = oncia_ProjectionClause_clauseSpecificSemanticCheck$($this);
        var$2 = oncias_package$_MODULE$;
        var$3 = new $java.oncia_Return$checkVariableScope$lambda$_85_0;
        var$3.$_0353 = $this;
        var$1 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$1, $java.oncias_package$_liftSemanticErrorDefsFunc(var$2, var$3)), $java.oncias_package$_liftSemanticErrorDefsFunc(oncias_package$_MODULE$, $java.oncia_ProjectionClause$_checkAliasedReturnItems(oncia_ProjectionClause$_MODULE$, $this.$returnItems1, $rt_s(1430))));
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNamesInReturnItems(oncias_SemanticPatternCheck$_MODULE$, $this.$returnItems1));
    };
    function oncia_Return_withReturnItems($this, $returnItems) {
        return oncia_Return_copy($this, $this.$distinct, $returnItems, $this.$orderBy0, $this.$skip0, $this.$limit0, $this.$excludedNames, $this.$addedInRewrite, $this.$position40);
    }
    function oncia_Return_copy($this, $distinct, $returnItems, $orderBy, $skip, $limit, $excludedNames, $addedInRewrite, $position) {
        return $java.oncia_Return__init_($distinct, $returnItems, $orderBy, $skip, $limit, $excludedNames, $addedInRewrite, $position);
    }
    $java.oncia_Return_productPrefix = function($this) {
        return $rt_s(1431);
    };
    $java.oncia_Return_productArity = function($this) {
        return 7;
    };
    $java.oncia_Return_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$distinct);
            case 1:
                return $this.$returnItems1;
            case 2:
                return $this.$orderBy0;
            case 3:
                return $this.$skip0;
            case 4:
                return $this.$limit0;
            case 5:
                return $this.$excludedNames;
            case 6:
                return jl_Boolean_valueOf($this.$addedInRewrite);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Return_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Return_hashCode = function($this) {
        var var$1, var$2;
        var$1 = sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1431)));
        var$2 = !$this.$distinct ? 1237 : 1231;
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(var$1, var$2), sr_Statics_anyHash($this.$returnItems1)), sr_Statics_anyHash($this.$orderBy0)), sr_Statics_anyHash($this.$skip0)), sr_Statics_anyHash($this.$limit0)), sr_Statics_anyHash($this.$excludedNames)), !$this.$addedInRewrite ? 1237 : 1231), 7);
    };
    $java.oncia_Return_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Return_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Return) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$distinct != $x$1.$distinct)
                        break b;
                    if ($this.$addedInRewrite != $x$1.$addedInRewrite)
                        break b;
                    c: {
                        var$2 = $this.$returnItems1;
                        var$3 = $x$1.$returnItems1;
                        if (var$2 !== null) {
                            if (!oncia_ReturnItems_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$orderBy0;
                        var$3 = $x$1.$orderBy0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$skip0;
                        var$3 = $x$1.$skip0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$limit0;
                        var$3 = $x$1.$limit0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$3 = $this.$excludedNames;
                        $x$1 = $x$1.$excludedNames;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break g;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Return))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Return_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncia_Return__init_($this, $distinct, $returnItems, $orderBy, $skip, $limit, $excludedNames, $addedInRewrite, $position) {
        $this.$distinct = $distinct;
        $this.$returnItems1 = $returnItems;
        $this.$orderBy0 = $orderBy;
        $this.$skip0 = $skip;
        $this.$limit0 = $limit;
        $this.$excludedNames = $excludedNames;
        $this.$addedInRewrite = $addedInRewrite;
        $this.$position40 = $position;
        oncia_Clause_$init$($this);
    }
    $java.oncia_SingleQuery$semanticCheck$lambda$_63_0 = function() {
        jl_Object.call(this);
        this.$_0325 = null;
    };
    $java.oncia_SingleQuery$semanticCheck$lambda$_63_0_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_checkClauses(var$0.$_0325, var$1, s_None$_MODULE$);
    };
    $java.scc_AsJavaConverters = $rt_classWithoutFields(0);
    var sjj_CollectionConverters$ = $rt_classWithoutFields();
    $java.sjj_CollectionConverters$_MODULE$ = null;
    function sjj_CollectionConverters$__clinit_() {
        $java.sjj_CollectionConverters$_MODULE$ = new sjj_CollectionConverters$;
    }
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0354 = null;
        a.$_1108 = 0;
        a.$_239 = null;
    };
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0();
        $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0__init_0 = function(var$0, var$1, var$2, var$3) {
        var$0.$_0354 = var$1;
        var$0.$_1108 = var$2;
        var$0.$_239 = var$3;
    };
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0_apply = function(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$1(var$0.$_0354, var$0.$_1108, var$0.$_239, var$1);
    };
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0355 = null;
        a.$_1109 = 0;
        a.$_240 = null;
    };
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1();
        $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1__init_0 = function(var$0, var$1, var$2, var$3) {
        var$0.$_0355 = var$1;
        var$0.$_1109 = var$2;
        var$0.$_240 = var$3;
    };
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1_apply = function(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$2(var$0.$_0355, var$0.$_1109, var$0.$_240, var$1);
    };
    function onciaf_CreateIndexTypes() {
        jl_Enum.call(this);
        this.$description2 = null;
    }
    var onciaf_CreateIndexTypes_BTREE = null;
    var onciaf_CreateIndexTypes_RANGE = null;
    $java.onciaf_CreateIndexTypes_FULLTEXT = null;
    $java.onciaf_CreateIndexTypes_LOOKUP = null;
    var onciaf_CreateIndexTypes_TEXT = null;
    var onciaf_CreateIndexTypes_POINT = null;
    var onciaf_CreateIndexTypes_DEFAULT = null;
    $java.onciaf_CreateIndexTypes_INVALID = null;
    $java.onciaf_CreateIndexTypes_$VALUES = null;
    function onciaf_CreateIndexTypes_$callClinit() {
        onciaf_CreateIndexTypes_$callClinit = $rt_eraseClinit(onciaf_CreateIndexTypes);
        $java.onciaf_CreateIndexTypes__clinit_();
    }
    $java.onciaf_CreateIndexTypes__init_ = function(var_0, var_1, var_2) {
        var var_3 = new onciaf_CreateIndexTypes();
        $java.onciaf_CreateIndexTypes__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    function onciaf_CreateIndexTypes_values() {
        onciaf_CreateIndexTypes_$callClinit();
        return $java.onciaf_CreateIndexTypes_$VALUES.$clone();
    }
    $java.onciaf_CreateIndexTypes__init_0 = function($this, var$1, var$2, $description) {
        onciaf_CreateIndexTypes_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
        $this.$description2 = $description;
    };
    $java.onciaf_CreateIndexTypes__clinit_ = function() {
        var var$1;
        onciaf_CreateIndexTypes_BTREE = $java.onciaf_CreateIndexTypes__init_($rt_s(1432), 0, $rt_s(1432));
        onciaf_CreateIndexTypes_RANGE = $java.onciaf_CreateIndexTypes__init_($rt_s(1433), 1, $rt_s(1433));
        $java.onciaf_CreateIndexTypes_FULLTEXT = $java.onciaf_CreateIndexTypes__init_($rt_s(1434), 2, $rt_s(1434));
        $java.onciaf_CreateIndexTypes_LOOKUP = $java.onciaf_CreateIndexTypes__init_($rt_s(1435), 3, $rt_s(1435));
        onciaf_CreateIndexTypes_TEXT = $java.onciaf_CreateIndexTypes__init_($rt_s(1436), 4, $rt_s(1436));
        onciaf_CreateIndexTypes_POINT = $java.onciaf_CreateIndexTypes__init_($rt_s(1437), 5, $rt_s(1437));
        onciaf_CreateIndexTypes_DEFAULT = $java.onciaf_CreateIndexTypes__init_($rt_s(306), 6, $rt_s(306));
        var$1 = $java.onciaf_CreateIndexTypes__init_($rt_s(1438), 7, $rt_s(1438));
        $java.onciaf_CreateIndexTypes_INVALID = var$1;
        $java.onciaf_CreateIndexTypes_$VALUES = $rt_createArrayFromData(onciaf_CreateIndexTypes, [onciaf_CreateIndexTypes_BTREE, onciaf_CreateIndexTypes_RANGE, $java.onciaf_CreateIndexTypes_FULLTEXT, $java.onciaf_CreateIndexTypes_LOOKUP, onciaf_CreateIndexTypes_TEXT, onciaf_CreateIndexTypes_POINT, onciaf_CreateIndexTypes_DEFAULT, var$1]);
    };
    var onciaf_ConstraintVersion = $rt_classWithoutFields(jl_Enum);
    var onciaf_ConstraintVersion_CONSTRAINT_VERSION_0 = null;
    var onciaf_ConstraintVersion_CONSTRAINT_VERSION_1 = null;
    var onciaf_ConstraintVersion_CONSTRAINT_VERSION_2 = null;
    $java.onciaf_ConstraintVersion_$VALUES = null;
    function onciaf_ConstraintVersion_$callClinit() {
        onciaf_ConstraintVersion_$callClinit = $rt_eraseClinit(onciaf_ConstraintVersion);
        $java.onciaf_ConstraintVersion__clinit_();
    }
    $java.onciaf_ConstraintVersion__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_ConstraintVersion();
        $java.onciaf_ConstraintVersion__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_ConstraintVersion_values() {
        onciaf_ConstraintVersion_$callClinit();
        return $java.onciaf_ConstraintVersion_$VALUES.$clone();
    }
    $java.onciaf_ConstraintVersion__init_0 = function($this, var$1, var$2) {
        onciaf_ConstraintVersion_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_ConstraintVersion__clinit_ = function() {
        var var$1;
        onciaf_ConstraintVersion_CONSTRAINT_VERSION_0 = $java.onciaf_ConstraintVersion__init_($rt_s(1439), 0);
        onciaf_ConstraintVersion_CONSTRAINT_VERSION_1 = $java.onciaf_ConstraintVersion__init_($rt_s(1440), 1);
        var$1 = $java.onciaf_ConstraintVersion__init_($rt_s(1441), 2);
        onciaf_ConstraintVersion_CONSTRAINT_VERSION_2 = var$1;
        $java.onciaf_ConstraintVersion_$VALUES = $rt_createArrayFromData(onciaf_ConstraintVersion, [onciaf_ConstraintVersion_CONSTRAINT_VERSION_0, onciaf_ConstraintVersion_CONSTRAINT_VERSION_1, var$1]);
    };
    function onciaf_ConstraintType() {
        jl_Enum.call(this);
        this.$description0 = null;
    }
    var onciaf_ConstraintType_NODE_UNIQUE = null;
    var onciaf_ConstraintType_REL_UNIQUE = null;
    var onciaf_ConstraintType_NODE_KEY = null;
    var onciaf_ConstraintType_REL_KEY = null;
    var onciaf_ConstraintType_NODE_EXISTS = null;
    var onciaf_ConstraintType_NODE_IS_NOT_NULL = null;
    var onciaf_ConstraintType_REL_EXISTS = null;
    var onciaf_ConstraintType_REL_IS_NOT_NULL = null;
    var onciaf_ConstraintType_NODE_IS_TYPED = null;
    var onciaf_ConstraintType_REL_IS_TYPED = null;
    $java.onciaf_ConstraintType_$VALUES = null;
    function onciaf_ConstraintType_$callClinit() {
        onciaf_ConstraintType_$callClinit = $rt_eraseClinit(onciaf_ConstraintType);
        $java.onciaf_ConstraintType__clinit_();
    }
    $java.onciaf_ConstraintType__init_ = function(var_0, var_1, var_2) {
        var var_3 = new onciaf_ConstraintType();
        $java.onciaf_ConstraintType__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    function onciaf_ConstraintType_values() {
        onciaf_ConstraintType_$callClinit();
        return $java.onciaf_ConstraintType_$VALUES.$clone();
    }
    $java.onciaf_ConstraintType__init_0 = function($this, var$1, var$2, $description) {
        onciaf_ConstraintType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
        $this.$description0 = $description;
    };
    $java.onciaf_ConstraintType__clinit_ = function() {
        var var$1;
        onciaf_ConstraintType_NODE_UNIQUE = $java.onciaf_ConstraintType__init_($rt_s(1442), 0, $rt_s(1443));
        onciaf_ConstraintType_REL_UNIQUE = $java.onciaf_ConstraintType__init_($rt_s(1444), 1, $rt_s(1445));
        onciaf_ConstraintType_NODE_KEY = $java.onciaf_ConstraintType__init_($rt_s(1446), 2, $rt_s(1447));
        onciaf_ConstraintType_REL_KEY = $java.onciaf_ConstraintType__init_($rt_s(1448), 3, $rt_s(1449));
        onciaf_ConstraintType_NODE_EXISTS = $java.onciaf_ConstraintType__init_($rt_s(1450), 4, $rt_s(1451));
        onciaf_ConstraintType_NODE_IS_NOT_NULL = $java.onciaf_ConstraintType__init_($rt_s(1452), 5, $rt_s(1453));
        onciaf_ConstraintType_REL_EXISTS = $java.onciaf_ConstraintType__init_($rt_s(1454), 6, $rt_s(1451));
        onciaf_ConstraintType_REL_IS_NOT_NULL = $java.onciaf_ConstraintType__init_($rt_s(1455), 7, $rt_s(1453));
        onciaf_ConstraintType_NODE_IS_TYPED = $java.onciaf_ConstraintType__init_($rt_s(1456), 8, $rt_s(1457));
        var$1 = $java.onciaf_ConstraintType__init_($rt_s(1458), 9, $rt_s(1457));
        onciaf_ConstraintType_REL_IS_TYPED = var$1;
        $java.onciaf_ConstraintType_$VALUES = $rt_createArrayFromData(onciaf_ConstraintType, [onciaf_ConstraintType_NODE_UNIQUE, onciaf_ConstraintType_REL_UNIQUE, onciaf_ConstraintType_NODE_KEY, onciaf_ConstraintType_REL_KEY, onciaf_ConstraintType_NODE_EXISTS, onciaf_ConstraintType_NODE_IS_NOT_NULL, onciaf_ConstraintType_REL_EXISTS, onciaf_ConstraintType_REL_IS_NOT_NULL, onciaf_ConstraintType_NODE_IS_TYPED, var$1]);
    };
    function onciaf_ASTFactory$StringPos() {
        var a = this; jl_Object.call(a);
        a.$string0 = null;
        a.$pos = null;
    }
    function onciaf_ASTFactory$StringPos__init_(var_0, var_1) {
        var var_2 = new onciaf_ASTFactory$StringPos();
        onciaf_ASTFactory$StringPos__init_0(var_2, var_0, var_1);
        return var_2;
    }
    function onciaf_ASTFactory$StringPos__init_0($this, $string, $pos) {
        $this.$string0 = $string;
        $this.$pos = $pos;
    }
    function ju_Optional() {
        jl_Object.call(this);
        this.$value21 = null;
    }
    $java.ju_Optional_emptyInstance = null;
    $java.ju_Optional__init_ = function(var_0) {
        var var_1 = new ju_Optional();
        $java.ju_Optional__init_0(var_1, var_0);
        return var_1;
    };
    $java.ju_Optional__init_0 = function($this, $value) {
        $this.$value21 = $value;
    };
    function ju_Optional_empty() {
        if ($java.ju_Optional_emptyInstance === null)
            $java.ju_Optional_emptyInstance = $java.ju_Optional__init_(null);
        return $java.ju_Optional_emptyInstance;
    }
    function ju_Optional_of($value) {
        return $java.ju_Optional__init_($java.ju_Objects_requireNonNull($value));
    }
    function ju_Optional_orElse($this, $other) {
        var var$2;
        var$2 = $this.$value21;
        if (var$2 !== null)
            $other = var$2;
        return $other;
    }
    $java.oncia_GraphSelection = $rt_classWithoutFields(0);
    function oncia_UseGraph() {
        var a = this; jl_Object.call(a);
        a.$expression3 = null;
        a.$position64 = null;
        a.$LabelExpressionsPartition$module2 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier2 = null;
        a.$SetExtractor$module2 = null;
    }
    function oncia_UseGraph__init_(var_0, var_1) {
        var var_2 = new oncia_UseGraph();
        $java.oncia_UseGraph__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_UseGraph_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_UseGraph_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_UseGraph_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_UseGraph_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_UseGraph_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_UseGraph_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_UseGraph_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_UseGraph_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module2 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module2 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module2 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module2;
    };
    $java.oncia_UseGraph_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier2;
    };
    $java.oncia_UseGraph_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module2 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module2 !== null)
                        break a;
                    $this.$SetExtractor$module2 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module2;
    };
    $java.oncia_UseGraph_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier2 = $x$1;
    };
    $java.oncia_UseGraph_position = function($this) {
        return $this.$position64;
    };
    $java.oncia_UseGraph_name = function($this) {
        return $rt_s(1459);
    };
    $java.oncia_UseGraph_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2, var$3;
        var$1 = new $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_0;
        var$2 = new $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_1;
        var$2.$_0356 = $this;
        var$3 = new $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_2;
        var$3.$_0357 = $this;
        return oncias_SemanticAnalysisTooling_whenState$($this, var$1, var$2, var$3);
    };
    $java.oncia_UseGraph_checkExpressions = function($this, $expressions) {
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, $expressions, new $java.oncia_UseGraph$checkExpressions$lambda$_61_0);
    };
    $java.oncia_UseGraph_checkGraphReference = function($this) {
        return $java.oncia_GraphReference$_checkNotEmpty($java.oncia_GraphReference$_MODULE$, $java.oncia_UseGraph_graphReference($this), $this.$expression3.$position2());
    };
    $java.oncia_UseGraph_graphReference = function($this) {
        return $java.oncia_GraphReference$_from($java.oncia_GraphReference$_MODULE$, $this.$expression3);
    };
    $java.oncia_UseGraph_productPrefix = function($this) {
        return $rt_s(1460);
    };
    $java.oncia_UseGraph_productArity = function($this) {
        return 1;
    };
    $java.oncia_UseGraph_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UseGraph_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UseGraph_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UseGraph_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UseGraph_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_UseGraph) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$expression3;
                        $x$1 = $x$1.$expression3;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_UseGraph_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_UseGraph__init_ = function($this, $expression, $position) {
        $this.$expression3 = $expression;
        $this.$position64 = $position;
        oncia_Clause_$init$($this);
    };
    function onciaf_ShowCommandFilterTypes() {
        jl_Enum.call(this);
        this.$description1 = null;
    }
    var onciaf_ShowCommandFilterTypes_BTREE = null;
    var onciaf_ShowCommandFilterTypes_RANGE = null;
    var onciaf_ShowCommandFilterTypes_FULLTEXT = null;
    var onciaf_ShowCommandFilterTypes_TEXT = null;
    var onciaf_ShowCommandFilterTypes_POINT = null;
    var onciaf_ShowCommandFilterTypes_LOOKUP = null;
    var onciaf_ShowCommandFilterTypes_UNIQUE = null;
    var onciaf_ShowCommandFilterTypes_NODE_UNIQUE = null;
    var onciaf_ShowCommandFilterTypes_RELATIONSHIP_UNIQUE = null;
    var onciaf_ShowCommandFilterTypes_KEY = null;
    var onciaf_ShowCommandFilterTypes_NODE_KEY = null;
    var onciaf_ShowCommandFilterTypes_RELATIONSHIP_KEY = null;
    var onciaf_ShowCommandFilterTypes_OLD_EXISTS = null;
    var onciaf_ShowCommandFilterTypes_OLD_EXIST = null;
    var onciaf_ShowCommandFilterTypes_EXIST = null;
    var onciaf_ShowCommandFilterTypes_NODE_OLD_EXISTS = null;
    var onciaf_ShowCommandFilterTypes_NODE_OLD_EXIST = null;
    var onciaf_ShowCommandFilterTypes_NODE_EXIST = null;
    var onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXISTS = null;
    var onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXIST = null;
    var onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST = null;
    var onciaf_ShowCommandFilterTypes_PROP_TYPE = null;
    var onciaf_ShowCommandFilterTypes_NODE_PROP_TYPE = null;
    var onciaf_ShowCommandFilterTypes_RELATIONSHIP_PROP_TYPE = null;
    var onciaf_ShowCommandFilterTypes_BUILT_IN = null;
    var onciaf_ShowCommandFilterTypes_USER_DEFINED = null;
    var onciaf_ShowCommandFilterTypes_ALL = null;
    $java.onciaf_ShowCommandFilterTypes_INVALID = null;
    $java.onciaf_ShowCommandFilterTypes_$VALUES = null;
    function onciaf_ShowCommandFilterTypes_$callClinit() {
        onciaf_ShowCommandFilterTypes_$callClinit = $rt_eraseClinit(onciaf_ShowCommandFilterTypes);
        $java.onciaf_ShowCommandFilterTypes__clinit_();
    }
    $java.onciaf_ShowCommandFilterTypes__init_ = function(var_0, var_1, var_2) {
        var var_3 = new onciaf_ShowCommandFilterTypes();
        $java.onciaf_ShowCommandFilterTypes__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    function onciaf_ShowCommandFilterTypes_values() {
        onciaf_ShowCommandFilterTypes_$callClinit();
        return $java.onciaf_ShowCommandFilterTypes_$VALUES.$clone();
    }
    $java.onciaf_ShowCommandFilterTypes__init_0 = function($this, var$1, var$2, $description) {
        onciaf_ShowCommandFilterTypes_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
        $this.$description1 = $description;
    };
    $java.onciaf_ShowCommandFilterTypes__clinit_ = function() {
        var var$1;
        onciaf_ShowCommandFilterTypes_BTREE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1432), 0, $rt_s(1432));
        onciaf_ShowCommandFilterTypes_RANGE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1433), 1, $rt_s(1433));
        onciaf_ShowCommandFilterTypes_FULLTEXT = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1434), 2, $rt_s(1434));
        onciaf_ShowCommandFilterTypes_TEXT = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1436), 3, $rt_s(1436));
        onciaf_ShowCommandFilterTypes_POINT = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1437), 4, $rt_s(1437));
        onciaf_ShowCommandFilterTypes_LOOKUP = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1435), 5, $rt_s(1435));
        onciaf_ShowCommandFilterTypes_UNIQUE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1461), 6, $rt_s(1462));
        onciaf_ShowCommandFilterTypes_NODE_UNIQUE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1442), 7, $rt_s(1463));
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_UNIQUE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1464), 8, $rt_s(1465));
        onciaf_ShowCommandFilterTypes_KEY = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1466), 9, $rt_s(1466));
        onciaf_ShowCommandFilterTypes_NODE_KEY = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1446), 10, $rt_s(1467));
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_KEY = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1468), 11, $rt_s(1469));
        onciaf_ShowCommandFilterTypes_OLD_EXISTS = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1470), 12, $rt_s(1451));
        onciaf_ShowCommandFilterTypes_OLD_EXIST = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1471), 13, $rt_s(1472));
        onciaf_ShowCommandFilterTypes_EXIST = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1472), 14, $rt_s(1473));
        onciaf_ShowCommandFilterTypes_NODE_OLD_EXISTS = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1474), 15, $rt_s(1475));
        onciaf_ShowCommandFilterTypes_NODE_OLD_EXIST = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1476), 16, $rt_s(1477));
        onciaf_ShowCommandFilterTypes_NODE_EXIST = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1478), 17, $rt_s(1479));
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXISTS = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1480), 18, $rt_s(1481));
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXIST = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1482), 19, $rt_s(1483));
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1484), 20, $rt_s(1485));
        onciaf_ShowCommandFilterTypes_PROP_TYPE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1486), 21, $rt_s(1487));
        onciaf_ShowCommandFilterTypes_NODE_PROP_TYPE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1488), 22, $rt_s(1489));
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_PROP_TYPE = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1490), 23, $rt_s(1491));
        onciaf_ShowCommandFilterTypes_BUILT_IN = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1492), 24, $rt_s(1493));
        onciaf_ShowCommandFilterTypes_USER_DEFINED = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1494), 25, $rt_s(1495));
        onciaf_ShowCommandFilterTypes_ALL = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(302), 26, $rt_s(302));
        var$1 = $java.onciaf_ShowCommandFilterTypes__init_($rt_s(1438), 27, $rt_s(1438));
        $java.onciaf_ShowCommandFilterTypes_INVALID = var$1;
        $java.onciaf_ShowCommandFilterTypes_$VALUES = $rt_createArrayFromData(onciaf_ShowCommandFilterTypes, [onciaf_ShowCommandFilterTypes_BTREE, onciaf_ShowCommandFilterTypes_RANGE, onciaf_ShowCommandFilterTypes_FULLTEXT, onciaf_ShowCommandFilterTypes_TEXT, onciaf_ShowCommandFilterTypes_POINT, onciaf_ShowCommandFilterTypes_LOOKUP, onciaf_ShowCommandFilterTypes_UNIQUE, onciaf_ShowCommandFilterTypes_NODE_UNIQUE, onciaf_ShowCommandFilterTypes_RELATIONSHIP_UNIQUE, onciaf_ShowCommandFilterTypes_KEY, onciaf_ShowCommandFilterTypes_NODE_KEY,
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_KEY, onciaf_ShowCommandFilterTypes_OLD_EXISTS, onciaf_ShowCommandFilterTypes_OLD_EXIST, onciaf_ShowCommandFilterTypes_EXIST, onciaf_ShowCommandFilterTypes_NODE_OLD_EXISTS, onciaf_ShowCommandFilterTypes_NODE_OLD_EXIST, onciaf_ShowCommandFilterTypes_NODE_EXIST, onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXISTS, onciaf_ShowCommandFilterTypes_RELATIONSHIP_OLD_EXIST, onciaf_ShowCommandFilterTypes_RELATIONSHIP_EXIST, onciaf_ShowCommandFilterTypes_PROP_TYPE, onciaf_ShowCommandFilterTypes_NODE_PROP_TYPE,
        onciaf_ShowCommandFilterTypes_RELATIONSHIP_PROP_TYPE, onciaf_ShowCommandFilterTypes_BUILT_IN, onciaf_ShowCommandFilterTypes_USER_DEFINED, onciaf_ShowCommandFilterTypes_ALL, var$1]);
    };
    $java.scm_ImmutableBuilder = function() {
        var a = this; jl_Object.call(a);
        a.$empty17 = null;
        a.$elems2 = null;
    };
    $java.scm_ImmutableBuilder_sizeHint = function($this, $size) {};
    $java.scm_ImmutableBuilder_sizeHint0 = function($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    };
    $java.scm_ImmutableBuilder_addAll = function($this, $xs) {
        return scm_Growable_addAll$($this, $xs);
    };
    $java.scm_ImmutableBuilder_result = function($this) {
        return $this.$elems2;
    };
    var sci_ListSet$$anon$1 = $rt_classWithoutFields($java.scm_ImmutableBuilder);
    function sci_ListSet$$anon$1__init_() {
        var var_0 = new sci_ListSet$$anon$1();
        $java.sci_ListSet$$anon$1__init_(var_0);
        return var_0;
    }
    $java.sci_ListSet$$anon$1_addOne = function($this, $elem) {
        var var$2;
        var$2 = $this.$elems2;
        if (var$2 === null)
            $rt_throw(null);
        $this.$elems2 = var$2.$incl($elem);
        return $this;
    };
    $java.sci_ListSet$$anon$1__init_ = function($this) {
        var var$1;
        var$1 = sci_ListSet$EmptyListSet$_MODULE$;
        $this.$empty17 = var$1;
        $this.$elems2 = var$1;
    };
    var sci_ListSet$EmptyListSet$ = $rt_classWithoutFields(sci_ListSet);
    var sci_ListSet$EmptyListSet$_MODULE$ = null;
    function sci_ListSet$EmptyListSet$__clinit_() {
        sci_ListSet$EmptyListSet$_MODULE$ = new sci_ListSet$EmptyListSet$;
    }
    $java.sci_ListSet$EmptyListSet$_knownSize = function($this) {
        return 0;
    };
    var oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_0 = $rt_classWithoutFields();
    $java.oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_expandShowWhere$_$callClinit();
        return var$1.$name3();
    };
    function oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_1() {
        jl_Object.call(this);
        this.$_038 = null;
    }
    $java.oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_1_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_038;
        oncirr_expandShowWhere$_$callClinit();
        return var$1;
    };
    function oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_2() {
        jl_Object.call(this);
        this.$_039 = null;
    }
    $java.oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_039;
        oncirr_expandShowWhere$_$callClinit();
        var$3 = var$1.$returnItems1;
        if (var$3.$includeExisting) {
            var$4 = var$3.$defaultOrderOnColumns;
            var$3 = new $java.oncirr_expandShowWhere$$$anonfun$addDefaultColumns$3$lambda$_21_0;
            var$3.$_0358 = var$2;
            var$2 = s_Option_getOrElse(var$4, var$3);
            var$1 = oncia_Return_withReturnItems(var$1, oncia_ReturnItems_withDefaultOrderOnColumns(var$1.$returnItems1, var$2));
        }
        return var$1;
    };
    var oncia_CommandClause = $rt_classWithoutFields(0);
    $java.oncia_CommandClause_clauseSpecificSemanticCheck$ = function($$this) {
        var var$2, var$3;
        var$2 = ($$this.$unfilteredColumns()).$columns0;
        var$3 = new $java.oncia_CommandClause$clauseSpecificSemanticCheck$lambda$_3_0;
        var$3.$_0359 = $$this;
        return $$this.$semanticCheckFold(var$2, var$3);
    };
    $java.oncia_CommandClauseAllowedOnSystem = $rt_classWithoutFields(0);
    var oncia_TransactionsCommandClause = $rt_classWithoutFields(0);
    $java.oncia_TransactionsCommandClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$ = function($$this) {
        return sc_AbstractIterable_toMap(sci_List_map($$this.$transactionColumns(), new $java.oncia_TransactionsCommandClause$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$lambda$_6_0), s_$less$colon$less$_singleton);
    };
    $java.oncia_TransactionsCommandClause_checkYieldItems = function($this) {
        var var$1, var$2, var$3;
        if (!sc_IterableOnceOps_nonEmpty$($this.$yieldItems1()))
            return $this.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$super$clauseSpecificSemanticCheck();
        var$1 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$2 = $this.$yieldItems1();
        var$3 = new $java.oncia_TransactionsCommandClause$checkYieldItems$lambda$_7_0;
        var$3.$_0360 = $this;
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$1, var$2, var$3);
    };
    $java.oncia_TransactionsCommandClause_clauseSpecificSemanticCheck$ = function($$this) {
        var var$2;
        var$2 = $$this.$ids1();
        if (!(var$2 instanceof su_Right))
            $$this = $java.oncia_TransactionsCommandClause_checkYieldItems($$this);
        else {
            var$2 = var$2.$value10;
            oncias_SemanticExpressionCheck$_$callClinit();
            $$this = oncias_SemanticCheck_chain$($java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, var$2), $java.oncia_TransactionsCommandClause_checkYieldItems($$this));
        }
        return $$this;
    };
    var oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNeitherOrsNorInnerScopes$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNeitherOrsNorInnerScopes$lambda$_7_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_mergeInPredicates$_$callClinit();
        return jl_Boolean_valueOf(onciu_Foldable$Folder_treeExists(onciu_Foldable_folder$(var$1), new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNeitherOrsNorInnerScopes$1$1) ? 0 : 1);
    };
    var oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns$lambda$_11_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_mergeInPredicates$_$callClinit();
        return jl_Boolean_valueOf(onciu_Foldable$Folder_treeExists(onciu_Foldable_folder$(var$1), new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containIns$1$1));
    };
    var oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots$lambda$_10_0 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots$lambda$_10_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_mergeInPredicates$_$callClinit();
        return jl_Boolean_valueOf(onciu_Foldable$Folder_treeExists(onciu_Foldable_folder$(var$1), new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoNots$1$1) ? 0 : 1);
    };
    var oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots$lambda$_9_0 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots$lambda$_9_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_mergeInPredicates$_$callClinit();
        return jl_Boolean_valueOf(onciu_Foldable$Folder_treeExists(onciu_Foldable_folder$(var$1), new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNots$1$1));
    };
    var oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoAnds$lambda$_8_0 = $rt_classWithoutFields();
    $java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoAnds$lambda$_8_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_mergeInPredicates$_$callClinit();
        return jl_Boolean_valueOf(onciu_Foldable$Folder_treeExists(onciu_Foldable_folder$(var$1), new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoAnds$1$1) ? 0 : 1);
    };
    function oncias_SymbolUse() {
        jl_Object.call(this);
        this.$use = null;
    }
    $java.oncias_SymbolUse_toString = function($this) {
        var var$1, var$2;
        var$1 = $java.oncias_SymbolUse_uniqueName($this);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(1496)), var$1), 41);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncias_SymbolUse_asVariable = function($this) {
        return $this.$use.$value19;
    };
    $java.oncias_SymbolUse_uniqueName = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = ($java.oncias_SymbolUse_asVariable($this)).$name4;
        var$2 = ($java.oncias_SymbolUse_asVariable($this)).$position0.$offset0;
        var$3 = onciu_Ref_toIdString($this.$use);
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        var$1 = jl_StringBuilder_append(var$4, var$1);
        jl_AbstractStringBuilder_append(var$1, 64);
        var$1 = jl_StringBuilder_append0(var$1, var$2);
        jl_AbstractStringBuilder_append(var$1, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$1, var$3), 41);
        return jl_AbstractStringBuilder_toString(var$4);
    };
    $java.oncias_SymbolUse_positionsAndUniqueIdString = function($this) {
        return s_Tuple2__init_(jl_Integer_valueOf(($java.oncias_SymbolUse_asVariable($this)).$position0.$offset0), onciu_Ref_toIdString($this.$use));
    };
    $java.oncias_SymbolUse_name = function($this) {
        return ($java.oncias_SymbolUse_asVariable($this)).$name4;
    };
    $java.oncias_SymbolUse_productPrefix = function($this) {
        return $rt_s(1497);
    };
    $java.oncias_SymbolUse_productArity = function($this) {
        return 1;
    };
    $java.oncias_SymbolUse_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$use;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SymbolUse_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SymbolUse_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SymbolUse_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_SymbolUse) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$use;
                        $x$1 = $x$1.$use;
                        if (var$2 !== null) {
                            if (!$java.onciu_Ref_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    var oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems$lambda$_40_0 = $rt_classWithoutFields();
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems$lambda$_40_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        if (var$1 instanceof oncia_UnaliasedReturnItem) {
            var$2 = var$1;
            if (s_Option_isDefined(var$2.$alias0))
                var$1 = oncia_AliasedReturnItem__init_(var$2.$expression9, var$2.$alias0.$get0(), var$2.$position10);
        }
        return var$1;
    };
    function onciu_Foldable$TreeAny$$anon$1() {
        var a = this; jl_Object.call(a);
        a.$c0 = 0;
        a.$p$10 = null;
    }
    $java.onciu_Foldable$TreeAny$$anon$1_iterator = function($this) {
        return $this;
    };
    $java.onciu_Foldable$TreeAny$$anon$1_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_toString = function($this) {
        return $rt_s(466);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_toList = function($this) {
        return sc_IterableOnceOps_toList$($this);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_knownSize = function($this) {
        return (-1);
    };
    $java.onciu_Foldable$TreeAny$$anon$1_hasNext = function($this) {
        return $this.$c0 < 0 ? 0 : 1;
    };
    $java.onciu_Foldable$TreeAny$$anon$1_next = function($this) {
        var $result;
        $result = $this.$p$10.$productElement($this.$c0);
        $this.$c0 = $this.$c0 - 1 | 0;
        return $result;
    };
    function sci_HashSet$removedAll$lambda$_62_0() {
        jl_Object.call(this);
        this.$_0172 = null;
    }
    $java.sci_HashSet$removedAll$lambda$_62_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0172;
        return jl_Boolean_valueOf(!(var$1 instanceof jl_Integer) ? 1 : $java.sci_Range_contains(var$2, sr_BoxesRunTime_unboxToInt(var$1)) ? 0 : 1);
    };
    var oncie_SensitiveLiteral = $rt_classWithoutFields(0);
    $java.oncie_UnsignedDecimalIntegerLiteral$$anon$2 = $rt_classWithoutFields(oncie_UnsignedDecimalIntegerLiteral);
    function scm_HashSet$$anon$3() {
        var a = this; scm_HashSet$HashSetIterator.call(a);
        a.$hash1 = 0;
        a.$$outer16 = null;
    }
    $java.scm_HashSet$$anon$3_hashCode = function($this) {
        return $this.$hash1;
    };
    $java.scm_HashSet$$anon$3_extract = function($this, $nd) {
        var var$2, $unimproveHash_improvedHash;
        var$2 = $this.$$outer16;
        $unimproveHash_improvedHash = $nd.$_hash0;
        if (var$2 === null)
            $rt_throw(null);
        $this.$hash1 = $unimproveHash_improvedHash ^ $unimproveHash_improvedHash >>> 16;
        return $this;
    };
    $java.oncia_SingleQuery$semanticCheckAbstract$lambda$_62_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0322 = null;
        a.$_196 = null;
    };
    $java.oncia_SingleQuery$semanticCheckAbstract$lambda$_62_0_apply = function(var$0) {
        return var$0.$_0322.$apply(var$0.$_196);
    };
    function oncipj_AliasName() {
        var a = this; jl_Object.call(a);
        a.$exceptionFactory0 = null;
        a.$start4 = null;
        a.$names0 = null;
        a.$parameter2 = null;
    }
    function oncipj_AliasName_getRemoteAliasName($this, $astFactory) {
        var var$2, var$3, var$4;
        var$2 = $this.$parameter2;
        if (var$2 !== null)
            return onciafn_Neo4jASTFactory_databaseName($astFactory, var$2);
        var$2 = $this.$names0;
        if (var$2.$size2 <= 2) {
            var$2 = $this.$start4;
            return onciafn_Neo4jASTFactory_databaseName0($astFactory, onciafn_Neo4jASTFactory_inputPosition($astFactory, var$2.$beginOffset, var$2.$beginLine, var$2.$beginColumn), $this.$names0);
        }
        $astFactory = $this.$exceptionFactory0;
        var$3 = new oncipj_ParseException;
        var$2 = jl_String_join($rt_s(142), var$2);
        var$4 = $rt_createArray(jl_Object, 1);
        var$4.data[0] = var$2;
        jl_Throwable__init_(var$3, jl_String_format($rt_s(1498), var$4));
        var$2 = $this.$start4;
        $rt_throw(onciafn_Neo4jASTExceptionFactory_syntaxException($astFactory, var$3, var$2.$beginOffset, var$2.$beginLine, var$2.$beginColumn));
    }
    function oncipj_AliasName_getLocalAliasName($this, $astFactory) {
        var var$2;
        var$2 = $this.$parameter2;
        if (var$2 !== null)
            return onciafn_Neo4jASTFactory_databaseName($astFactory, var$2);
        var$2 = $this.$start4;
        return onciafn_Neo4jASTFactory_databaseName0($astFactory, onciafn_Neo4jASTFactory_inputPosition($astFactory, var$2.$beginOffset, var$2.$beginLine, var$2.$beginColumn), $this.$names0);
    }
    var oncirr_rewriteShowQuery$$rewriteToWithAndReturn$lambda$_12_0 = $rt_classWithoutFields();
    $java.oncirr_rewriteShowQuery$$rewriteToWithAndReturn$lambda$_12_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_rewriteShowQuery$_$callClinit();
        return var$1.$name23;
    };
    $java.oncia_WithType = $rt_classWithoutFields(0);
    var oncia_AddedInRewrite$ = $rt_classWithoutFields();
    var oncia_AddedInRewrite$_MODULE$ = null;
    function oncia_AddedInRewrite$__clinit_() {
        oncia_AddedInRewrite$_MODULE$ = new oncia_AddedInRewrite$;
    }
    $java.oncia_AddedInRewrite$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AddedInRewrite$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AddedInRewrite$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AddedInRewrite$_hashCode = function($this) {
        return 1072546727;
    };
    $java.oncia_AddedInRewrite$_toString = function($this) {
        return $rt_s(1499);
    };
    var oncirr_rewriteShowQuery$$rewriteWithYieldAndReturn$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncirr_rewriteShowQuery$$rewriteWithYieldAndReturn$lambda$_11_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_rewriteShowQuery$_$callClinit();
        return var$1.$name23;
    };
    var oncirr_rewriteShowQuery$$anonfun$lastPosition$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_rewriteShowQuery$$anonfun$lastPosition$1_applyOrElse = function($this, $x1, $default) {
        if (!$rt_isInstance($x1, onciu_ASTNode))
            return s_PartialFunction$_fallback_fn;
        $x1 = $x1;
        $default = new $java.oncirr_rewriteShowQuery$$anonfun$lastPosition$1$applyOrElse$lambda$_0_0;
        $default.$_0361 = $x1;
        return $default;
    };
    var oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_0 = $rt_classWithoutFields();
    $java.oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_rewriteShowQuery$_$callClinit();
        return var$1.$name3();
    };
    function oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_1() {
        jl_Object.call(this);
        this.$_040 = null;
    }
    $java.oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_1_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_040;
        oncirr_rewriteShowQuery$_$callClinit();
        return sci_List_map((var$1.$unfilteredColumns()).$columns0, new $java.oncirr_rewriteShowQuery$$$anonfun$getDefaultOrderFromYieldOrCommand$1$lambda$_25_0);
    };
    var oncia_Return$ = $rt_classWithoutFields();
    var oncia_Return$_MODULE$ = null;
    function oncia_Return$__clinit_() {
        oncia_Return$_MODULE$ = new oncia_Return$;
    }
    function oncia_Return$_apply$default$6($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    }
    function oncirr_rewriteShowQuery$$updateDefaultOrderOnReturn$lambda$_9_0() {
        var a = this; jl_Object.call(a);
        a.$_041 = null;
        a.$_113 = null;
    }
    $java.oncirr_rewriteShowQuery$$updateDefaultOrderOnReturn$lambda$_9_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_041;
        var$2 = var$0.$_113;
        oncirr_rewriteShowQuery$_$callClinit();
        return oncirr_rewriteShowQuery$_getDefaultOrderFromYieldOrCommand(oncirr_rewriteShowQuery$_MODULE$, var$1, var$2);
    };
    function oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_0() {
        jl_Object.call(this);
        this.$_042 = null;
    }
    $java.oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_042;
        oncirr_mergeInPredicates$_$callClinit();
        var$3 = onciu_Foldable_folder$(var$1);
        s_Predef$_$callClinit();
        s_Predef$_Map(s_Predef$_MODULE$);
        var$4 = sci_Map$EmptyMap$_MODULE$;
        var$1 = new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1;
        var$1.$merge$1 = var$2;
        return onciu_Foldable$Folder_treeFold(var$3, var$4, var$1);
    };
    function oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_1() {
        jl_Object.call(this);
        this.$_043 = null;
    }
    $java.oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_1_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = var$0.$_043;
        oncirr_mergeInPredicates$_$callClinit();
        var$4 = (var$1.$keySet0()).$intersect(var$2.$keySet0());
        var$5 = new $java.oncirr_mergeInPredicates$$$anonfun$collectInPredicates$2$lambda$_31_0;
        var$5.$_0362 = var$3;
        var$5.$_1110 = var$1;
        var$5.$_241 = var$2;
        return (var$1.$concat2(var$4.$map1(var$5))).$concat2(var$2.$removedAll(var$4));
    };
    function oncirr_mergeInPredicates$$anonfun$inRewriter$1() {
        sr_AbstractPartialFunction.call(this);
        this.$inPredicates$1 = null;
    }
    $java.oncirr_mergeInPredicates$$anonfun$inRewriter$1_applyOrElse = function($this, $x1, $default) {
        var var$3, $a, $list, $expressions, $x$1;
        if ($x1 instanceof oncie_In) {
            var$3 = $x1;
            $a = var$3.$lhs9;
            $list = var$3.$rhs10;
            if ($list instanceof oncie_ListLiteral) {
                $x1 = $list;
                $expressions = $this.$inPredicates$1.$apply($a);
                if (!sc_IterableOnceOps_nonEmpty$($expressions))
                    return oncie_False__init_(var$3.$position65);
                $x$1 = $java.oncie_ListLiteral_copy($x1, $expressions, $x1.$position66);
                return $java.oncie_In_copy(var$3, var$3.$lhs9, $x$1, var$3.$position65);
            }
        }
        return $default.$apply($x1);
    };
    $java.sc_WithFilter = $rt_classWithoutFields();
    function sc_IterableOps$WithFilter() {
        var a = this; $java.sc_WithFilter.call(a);
        a.$self = null;
        a.$p = null;
    }
    function sc_IterableOps$WithFilter_filtered($this) {
        return sc_View$Filter__init_($this.$self, $this.$p, 0);
    }
    function sc_IterableOps$WithFilter_flatMap($this, $f) {
        return ($this.$self.$iterableFactory()).$from0(sc_View$FlatMap__init_(sc_IterableOps$WithFilter_filtered($this), $f));
    }
    var sc_SeqFactory$UnapplySeqWrapper$ = $rt_classWithoutFields();
    var sc_SeqFactory$UnapplySeqWrapper$_MODULE$ = null;
    function sc_SeqFactory$UnapplySeqWrapper$__clinit_() {
        sc_SeqFactory$UnapplySeqWrapper$_MODULE$ = new sc_SeqFactory$UnapplySeqWrapper$;
    }
    function sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension($this, $$this) {
        return 0;
    }
    $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension = function($this, $$this) {
        return $$this;
    };
    function sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($this, $$this, $len) {
        return $$this.$lengthCompare($len);
    }
    $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension = function($this, $$this, $i) {
        return $$this.$apply1($i);
    };
    function sc_SeqFactory$UnapplySeqWrapper() {
        jl_Object.call(this);
        this.$scala$collection$SeqFactory$UnapplySeqWrapper$$c = null;
    }
    $java.sc_SeqFactory$UnapplySeqWrapper__init_ = function(var_0) {
        var var_1 = new sc_SeqFactory$UnapplySeqWrapper();
        sc_SeqFactory$UnapplySeqWrapper__init_(var_1, var_0);
        return var_1;
    };
    function sc_SeqFactory$UnapplySeqWrapper__init_($this, $c) {
        $this.$scala$collection$SeqFactory$UnapplySeqWrapper$$c = $c;
    }
    $java.oncia_CallClause = function() {
        var a = this; jl_Object.call(a);
        a.$LabelExpressionsPartition$module3 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier3 = null;
        a.$SetExtractor$module3 = null;
    };
    $java.oncia_CallClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_CallClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_CallClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CallClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_CallClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CallClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CallClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module3 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module3 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module3 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module3;
    };
    $java.oncia_CallClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier3;
    };
    $java.oncia_CallClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module3 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module3 !== null)
                        break a;
                    $this.$SetExtractor$module3 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module3;
    };
    $java.oncia_CallClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier3 = $x$1;
    };
    $java.oncia_CallClause_name = function($this) {
        return $rt_s(1398);
    };
    $java.oncia_CallClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncia_UnresolvedCall() {
        var a = this; $java.oncia_CallClause.call(a);
        a.$procedureNamespace = null;
        a.$procedureName = null;
        a.$declaredArguments = null;
        a.$declaredResult = null;
        a.$yieldAll = 0;
        a.$position53 = null;
    }
    $java.oncia_UnresolvedCall__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_UnresolvedCall();
        oncia_UnresolvedCall__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    };
    $java.oncia_UnresolvedCall_position = function($this) {
        return $this.$position53;
    };
    $java.oncia_UnresolvedCall_returnVariables = function($this) {
        return $java.oncia_ReturnItems$ReturnVariables__init_(0, s_Option_getOrElse(s_Option_map($this.$declaredResult, new $java.oncia_UnresolvedCall$returnVariables$lambda$_14_0), new $java.oncia_UnresolvedCall$returnVariables$lambda$_14_1));
    };
    $java.oncia_UnresolvedCall_clauseSpecificSemanticCheck = function($this) {
        var $argumentCheck, $resultsCheck, var$3, $invalidExpressionsCheck;
        $argumentCheck = s_Option_getOrElse(s_Option_map($this.$declaredArguments, new $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_0), new $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_1);
        $resultsCheck = s_Option_getOrElse(s_Option_map($this.$declaredResult, new $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_2), new $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_3);
        var$3 = $this.$declaredArguments;
        $invalidExpressionsCheck = new $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_4;
        $invalidExpressionsCheck.$_0363 = $this;
        $invalidExpressionsCheck = s_Option_getOrElse(s_Option_map(var$3, $invalidExpressionsCheck), new $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_5);
        return oncias_SemanticCheck_chain$($argumentCheck.$chain($resultsCheck), $invalidExpressionsCheck);
    };
    $java.oncia_UnresolvedCall_copy = function($this, $procedureNamespace, $procedureName, $declaredArguments, $declaredResult, $yieldAll, $position) {
        return $java.oncia_UnresolvedCall__init_($procedureNamespace, $procedureName, $declaredArguments, $declaredResult, $yieldAll, $position);
    };
    $java.oncia_UnresolvedCall_productPrefix = function($this) {
        return $rt_s(1500);
    };
    $java.oncia_UnresolvedCall_productArity = function($this) {
        return 5;
    };
    $java.oncia_UnresolvedCall_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$procedureNamespace;
            case 1:
                return $this.$procedureName;
            case 2:
                return $this.$declaredArguments;
            case 3:
                return $this.$declaredResult;
            case 4:
                return jl_Boolean_valueOf($this.$yieldAll);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UnresolvedCall_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnresolvedCall_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1500))), sr_Statics_anyHash($this.$procedureNamespace)), sr_Statics_anyHash($this.$procedureName)), sr_Statics_anyHash($this.$declaredArguments)), sr_Statics_anyHash($this.$declaredResult)), !$this.$yieldAll ? 1237 : 1231), 5);
    };
    $java.oncia_UnresolvedCall_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UnresolvedCall_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_UnresolvedCall) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$yieldAll != $x$1.$yieldAll)
                        break b;
                    c: {
                        var$2 = $this.$procedureNamespace;
                        var$3 = $x$1.$procedureNamespace;
                        if (var$2 !== null) {
                            if (!$java.oncie_Namespace_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$procedureName;
                        var$3 = $x$1.$procedureName;
                        if (var$2 !== null) {
                            if (!$java.oncie_ProcedureName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$declaredArguments;
                        var$3 = $x$1.$declaredArguments;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$declaredResult;
                        $x$1 = $x$1.$declaredResult;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_UnresolvedCall))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncia_UnresolvedCall__init_($this, $procedureNamespace, $procedureName, $declaredArguments, $declaredResult, $yieldAll, $position) {
        $this.$procedureNamespace = $procedureNamespace;
        $this.$procedureName = $procedureName;
        $this.$declaredArguments = $declaredArguments;
        $this.$declaredResult = $declaredResult;
        $this.$yieldAll = $yieldAll;
        $this.$position53 = $position;
        oncia_Clause_$init$($this);
    }
    var oncias_SemanticCheck$ = $rt_classWithoutFields();
    var oncias_SemanticCheck$_MODULE$ = null;
    var oncias_SemanticCheck$_success = null;
    $java.oncias_SemanticCheck$_DEBUG_ENABLED = 0;
    function oncias_SemanticCheck$__clinit_() {
        var var$1;
        var$1 = new oncias_SemanticCheck$;
        oncias_SemanticCheck$_MODULE$ = var$1;
        oncias_SemanticCheck$_success = $java.oncias_SemanticCheck$_fromFunction(var$1, new $java.oncias_SemanticCheck$$_clinit_$lambda$_0_0);
        $java.oncias_SemanticCheck$_DEBUG_ENABLED = 0;
    }
    $java.oncias_SemanticCheck$_success = function($this) {
        return oncias_SemanticCheck$_success;
    };
    function oncias_SemanticCheck$_error($this, $errors) {
        var var$2;
        var$2 = new $java.oncias_SemanticCheck$$error$lambda$_2_0;
        var$2.$_0364 = $errors;
        return $java.oncias_SemanticCheck$_fromFunction($this, var$2);
    }
    $java.oncias_SemanticCheck$_fromFunction = function($this, $f) {
        var var$2;
        var$2 = new $java.oncias_SemanticCheck$Leaf;
        var$2.$f9 = $f;
        return var$2;
    };
    $java.oncias_SemanticCheck$_setState = function($this, $s) {
        var var$2;
        var$2 = new $java.oncias_SemanticCheck$$setState$lambda$_7_0;
        var$2.$_0365 = $s;
        return $java.oncias_SemanticCheck$_fromFunction($this, var$2);
    };
    function oncias_SemanticCheck$_fromState($this, $f) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_success;
        var$3 = new $java.oncias_SemanticCheck$$fromState$lambda$_8_0;
        var$3.$_0366 = $f;
        return oncias_SemanticCheck_flatMap$(var$2, var$3);
    }
    $java.oncias_SemanticCheck$_fromFunctionWithContext = function($this, $f) {
        var var$2;
        var$2 = new $java.oncias_SemanticCheck$$fromFunctionWithContext$lambda$_10_0;
        var$2.$_0367 = $f;
        $f = new $java.oncias_SemanticCheck$CheckFromContext;
        $f.$f11 = var$2;
        return $f;
    };
    function oncias_SemanticCheck$_nestedCheck($this, $check) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_success;
        var$3 = new $java.oncias_SemanticCheck$$nestedCheck$lambda$_11_0;
        var$3.$_0368 = $check;
        return oncias_SemanticCheck_flatMap$(var$2, var$3);
    }
    function oncias_SemanticCheck$_when($this, $condition, $check) {
        if ($condition)
            return $check.$apply2();
        return oncias_SemanticCheck$_success;
    }
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncia_UnresolvedCall);
    };
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_1 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(!(var$1 instanceof oncia_UnresolvedCall) ? 0 : var$1.$yieldAll);
    };
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_2 = function() {
        jl_Object.call(this);
        this.$_0333 = null;
    };
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticAnalysisTooling_error$(var$0.$_0333, $rt_s(1501), var$1.$position2());
    };
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_3 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_3_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    var oncias_package$ = $rt_classWithoutFields();
    var oncias_package$_MODULE$ = null;
    function oncias_package$__clinit_() {
        oncias_package$_MODULE$ = new oncias_package$;
    }
    function oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($this, $f) {
        return $java.oncias_SemanticCheck$_fromFunction(oncias_SemanticCheck$_MODULE$, $f);
    }
    $java.oncias_package$_liftSemanticEitherFunc = function($this, $func) {
        var var$2;
        var$2 = new $java.oncias_package$$liftSemanticEitherFunc$lambda$_2_0;
        var$2.$_0369 = $func;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($this, var$2);
    };
    $java.oncias_package$_liftSemanticErrorDefsFunc = function($this, $func) {
        var var$2;
        var$2 = new $java.oncias_package$$liftSemanticErrorDefsFunc$lambda$_3_0;
        var$2.$_0370 = $func;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($this, var$2);
    };
    $java.oncias_package$_liftSemanticErrorDefs = function($this, $errors) {
        var var$2;
        var$2 = new $java.oncias_package$$liftSemanticErrorDefs$lambda$_5_0;
        var$2.$_0371 = $errors;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($this, var$2);
    };
    function oncias_package$_liftSemanticErrorDef($this, $error) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncias_package$$liftSemanticErrorDef$lambda$_6_0;
        var$3.$_0372 = $error;
        return $java.oncias_SemanticCheck$_fromFunction(var$2, var$3);
    }
    $java.oncias_package$_liftSemanticErrorDefOption = function($this, $error) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncias_package$$liftSemanticErrorDefOption$lambda$_7_0;
        var$3.$_0373 = $error;
        return $java.oncias_SemanticCheck$_fromFunction(var$2, var$3);
    };
    $java.oncias_package$_optionSemanticChecking = function($this, $option) {
        return $option;
    };
    $java.oncia_SingleQuery$checkOrder$lambda$_71_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0323 = null;
        a.$_197 = null;
        a.$_237 = 0;
    };
    $java.oncia_SingleQuery$checkOrder$lambda$_71_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncia_SingleQuery_$anonfun$checkOrder$1(var$0.$_0323, var$0.$_197, var$0.$_237, var$1);
    };
    $java.sr_LazyRef = function() {
        var a = this; jl_Object.call(a);
        a.$_initialized = 0;
        a.$_value0 = null;
    };
    $java.sr_LazyRef_initialized = function($this) {
        return $this.$_initialized;
    };
    $java.sr_LazyRef_value = function($this) {
        return $this.$_value0;
    };
    $java.sr_LazyRef_initialize = function($this, $value) {
        $this.$_value0 = $value;
        $this.$_initialized = 1;
        return $value;
    };
    $java.oncia_SingleQuery$checkNoCallInTransactionsAfterWriteClause$lambda$_72_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0324 = null;
        a.$_198 = null;
    };
    $java.oncia_SingleQuery$checkNoCallInTransactionsAfterWriteClause$lambda$_72_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6, var$7;
        a: {
            var$1 = var$1;
            var$2 = var$2;
            var$3 = var$0.$_0324;
            var$4 = var$0.$_198;
            var$5 = s_Tuple2__init_(var$1, var$2);
            var$1 = var$5.$_10;
            var$2 = var$5.$_20;
            if (var$1 !== null) {
                var$6 = var$1.$precedingWrite;
                var$7 = var$1.$errors0;
                if (var$2 instanceof oncia_SubqueryCall) {
                    var$1 = var$2;
                    if ($java.oncia_SubqueryCall$_isTransactionalSubquery($java.oncia_SubqueryCall$_MODULE$, var$1)) {
                        if (!var$6) {
                            var$1 = $java.oncia_SingleQuery$Acc$2$_apply($java.oncia_SingleQuery_Acc$3(var$3, var$4), var$6, var$7);
                            break a;
                        }
                        var$1 = $java.oncia_SingleQuery$Acc$2$_apply($java.oncia_SingleQuery_Acc$3(var$3, var$4), var$6, var$7.$appended(oncias_SemanticError__init_0($rt_s(1502), var$1.$position67)));
                        break a;
                    }
                }
            }
            var$1 = var$5.$_10;
            var$2 = var$5.$_20;
            var$1 = $java.oncia_SingleQuery$Acc$2$_apply($java.oncia_SingleQuery_Acc$3(var$3, var$4), !var$1.$precedingWrite && !onciu_Foldable$Folder_treeExists(var$2.$folder(), new $java.oncia_SingleQuery$$anonfun$$nestedInanonfun$checkNoCallInTransactionsAfterWriteClause$1$1) ? 0 : 1, var$1.$errors0);
        }
        return var$1;
    };
    $java.oncia_SingleQuery$Acc$1 = function() {
        var a = this; jl_Object.call(a);
        a.$precedingWrite = 0;
        a.$errors0 = null;
        a.$$outer32 = null;
    };
    $java.oncia_SingleQuery$Acc$1_productPrefix = function($this) {
        return $rt_s(1503);
    };
    $java.oncia_SingleQuery$Acc$1_productArity = function($this) {
        return 2;
    };
    $java.oncia_SingleQuery$Acc$1_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$precedingWrite);
            case 1:
                return $this.$errors0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SingleQuery$Acc$1_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleQuery$Acc$1_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1503))), !$this.$precedingWrite ? 1237 : 1231), sr_Statics_anyHash($this.$errors0)), 2);
    };
    $java.oncia_SingleQuery$Acc$1_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleQuery$Acc$1_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_SingleQuery$Acc$1) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$precedingWrite != $x$1.$precedingWrite)
                        break b;
                    c: {
                        var$2 = $this.$errors0;
                        $x$1 = $x$1.$errors0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_SingleQuery$Acc$1))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SingleQuery$checkInputDataStream$lambda$_75_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$checkInputDataStream$lambda$_75_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof $java.oncia_InputDataStream);
    };
    $java.oncia_InputDataStream = $rt_classWithoutFields();
    function sc_Map$equals$lambda$_7_0() {
        jl_Object.call(this);
        this.$_0374 = null;
    }
    function sc_Map$equals$lambda$_7_0__init_(var_0) {
        var var_1 = new sc_Map$equals$lambda$_7_0();
        $java.sc_Map$equals$lambda$_7_0__init_(var_1, var_0);
        return var_1;
    }
    $java.sc_Map$equals$lambda$_7_0__init_ = function(var$0, var$1) {
        var$0.$_0374 = var$1;
    };
    $java.sc_Map$equals$lambda$_7_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0374;
        var$3 = var$1.$_10;
        $java.sc_Map$_$callClinit();
        return jl_Boolean_valueOf(!sr_BoxesRunTime_equals(var$2.$getOrElse0(var$3, $java.sc_Map$_scala$collection$Map$$DefaultSentinelFn), var$1.$_20) ? 0 : 1);
    };
    $java.scc_JavaCollectionWrappers$IteratorWrapper = $rt_classWithoutFields();
    $java.scc_JavaCollectionWrappers$JIteratorWrapper = function() {
        sc_AbstractIterator.call(this);
        this.$underlying22 = null;
    };
    $java.scc_JavaCollectionWrappers$JIteratorWrapper_hasNext = function($this) {
        return $this.$underlying22.$hasNext();
    };
    $java.scc_JavaCollectionWrappers$JIteratorWrapper_next = function($this) {
        return $this.$underlying22.$next();
    };
    function ju_Formatter() {
        var a = this; jl_Object.call(a);
        a.$locale = null;
        a.$out = null;
        a.$ioException = null;
    }
    function ju_Formatter_requireOpen($this) {
        var var$1;
        if ($this.$out !== null)
            return;
        var$1 = new $java.ju_FormatterClosedException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    }
    function oncia_DefaultOrAllShowColumns() {
        var a = this; jl_Object.call(a);
        a.$useAllColumns = 0;
        a.$columns0 = null;
    }
    $java.oncia_DefaultOrAllShowColumns__init_ = function(var_0, var_1) {
        var var_2 = new oncia_DefaultOrAllShowColumns();
        $java.oncia_DefaultOrAllShowColumns__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_DefaultOrAllShowColumns_productPrefix = function($this) {
        return $rt_s(1504);
    };
    $java.oncia_DefaultOrAllShowColumns_productArity = function($this) {
        return 2;
    };
    $java.oncia_DefaultOrAllShowColumns_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$useAllColumns);
            case 1:
                return $this.$columns0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DefaultOrAllShowColumns_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultOrAllShowColumns_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1504))), !$this.$useAllColumns ? 1237 : 1231), sr_Statics_anyHash($this.$columns0)), 2);
    };
    $java.oncia_DefaultOrAllShowColumns_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    function oncia_DefaultOrAllShowColumns_equals($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DefaultOrAllShowColumns) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$useAllColumns != $x$1.$useAllColumns)
                        break b;
                    c: {
                        var$2 = $this.$columns0;
                        $x$1 = $x$1.$columns0;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DefaultOrAllShowColumns))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    }
    $java.oncia_DefaultOrAllShowColumns__init_0 = function($this, $useAllColumns, $columns) {
        $this.$useAllColumns = $useAllColumns;
        $this.$columns0 = $columns;
    };
    $java.sr_AbstractFunction2 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$Acc$2$ = function() {
        $java.sr_AbstractFunction2.call(this);
        this.$$outer33 = null;
    };
    $java.oncia_SingleQuery$Acc$2$__init_ = function(var_0) {
        var var_1 = new $java.oncia_SingleQuery$Acc$2$();
        $java.oncia_SingleQuery$Acc$2$__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_SingleQuery$Acc$2$_apply = function($this, $precedingWrite, $errors) {
        var var$3, var$4;
        var$3 = new $java.oncia_SingleQuery$Acc$1;
        var$4 = $this.$$outer33;
        var$3.$precedingWrite = $precedingWrite;
        var$3.$errors0 = $errors;
        if (var$4 === null)
            $rt_throw(null);
        var$3.$$outer32 = var$4;
        return var$3;
    };
    $java.oncia_SingleQuery$Acc$2$__init_0 = function($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer33 = $$outer;
    };
    function ju_Locale() {
        var a = this; jl_Object.call(a);
        a.$countryCode = null;
        a.$languageCode = null;
        a.$variantCode = null;
    }
    $java.ju_Locale_defaultLocale = null;
    $java.ju_Locale_CANADA = null;
    $java.ju_Locale_CANADA_FRENCH = null;
    $java.ju_Locale_CHINA = null;
    $java.ju_Locale_CHINESE = null;
    $java.ju_Locale_ENGLISH = null;
    $java.ju_Locale_FRANCE = null;
    $java.ju_Locale_FRENCH = null;
    $java.ju_Locale_GERMAN = null;
    $java.ju_Locale_GERMANY = null;
    $java.ju_Locale_ITALIAN = null;
    $java.ju_Locale_ITALY = null;
    $java.ju_Locale_JAPAN = null;
    $java.ju_Locale_JAPANESE = null;
    $java.ju_Locale_KOREA = null;
    $java.ju_Locale_KOREAN = null;
    $java.ju_Locale_PRC = null;
    $java.ju_Locale_SIMPLIFIED_CHINESE = null;
    $java.ju_Locale_TAIWAN = null;
    $java.ju_Locale_TRADITIONAL_CHINESE = null;
    $java.ju_Locale_UK = null;
    $java.ju_Locale_US = null;
    $java.ju_Locale_ROOT = null;
    $java.ju_Locale_$callClinit = function() {
        $java.ju_Locale_$callClinit = $rt_eraseClinit(ju_Locale);
        $java.ju_Locale__clinit_();
    };
    $java.ju_Locale__init_ = function(var_0, var_1) {
        var var_2 = new ju_Locale();
        $java.ju_Locale__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.ju_Locale__init_1 = function(var_0, var_1, var_2) {
        var var_3 = new ju_Locale();
        $java.ju_Locale__init_2(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.ju_Locale__init_0 = function($this, $language, $country) {
        $java.ju_Locale_$callClinit();
        $java.ju_Locale__init_2($this, $language, $country, $rt_s(3));
    };
    $java.ju_Locale__init_2 = function($this, $language, $country, $variant) {
        $java.ju_Locale_$callClinit();
        if ($language !== null && $country !== null && $variant !== null) {
            if (!jl_String_length($language) && !jl_String_length($country)) {
                $this.$languageCode = $rt_s(3);
                $this.$countryCode = $rt_s(3);
                $this.$variantCode = $variant;
                return;
            }
            $this.$languageCode = $language;
            $this.$countryCode = $country;
            $this.$variantCode = $variant;
            return;
        }
        $language = new jl_NullPointerException;
        jl_Throwable__init_0($language);
        $rt_throw($language);
    };
    function ju_Locale_getDefault() {
        $java.ju_Locale_$callClinit();
        return $java.ju_Locale_defaultLocale;
    }
    $java.ju_Locale__clinit_ = function() {
        var $localeName, $countryIndex;
        $java.ju_Locale_CANADA = $java.ju_Locale__init_($rt_s(1505), $rt_s(1506));
        $java.ju_Locale_CANADA_FRENCH = $java.ju_Locale__init_($rt_s(1507), $rt_s(1506));
        $java.ju_Locale_CHINA = $java.ju_Locale__init_($rt_s(1508), $rt_s(1509));
        $java.ju_Locale_CHINESE = $java.ju_Locale__init_($rt_s(1508), $rt_s(3));
        $java.ju_Locale_ENGLISH = $java.ju_Locale__init_($rt_s(1505), $rt_s(3));
        $java.ju_Locale_FRANCE = $java.ju_Locale__init_($rt_s(1507), $rt_s(1510));
        $java.ju_Locale_FRENCH = $java.ju_Locale__init_($rt_s(1507), $rt_s(3));
        $java.ju_Locale_GERMAN = $java.ju_Locale__init_($rt_s(1511), $rt_s(3));
        $java.ju_Locale_GERMANY = $java.ju_Locale__init_($rt_s(1511), $rt_s(1512));
        $java.ju_Locale_ITALIAN = $java.ju_Locale__init_($rt_s(1513), $rt_s(3));
        $java.ju_Locale_ITALY = $java.ju_Locale__init_($rt_s(1513), $rt_s(1514));
        $java.ju_Locale_JAPAN = $java.ju_Locale__init_($rt_s(1515), $rt_s(1516));
        $java.ju_Locale_JAPANESE = $java.ju_Locale__init_($rt_s(1515), $rt_s(3));
        $java.ju_Locale_KOREA = $java.ju_Locale__init_($rt_s(1517), $rt_s(1518));
        $java.ju_Locale_KOREAN = $java.ju_Locale__init_($rt_s(1517), $rt_s(3));
        $java.ju_Locale_PRC = $java.ju_Locale__init_($rt_s(1508), $rt_s(1509));
        $java.ju_Locale_SIMPLIFIED_CHINESE = $java.ju_Locale__init_($rt_s(1508), $rt_s(1509));
        $java.ju_Locale_TAIWAN = $java.ju_Locale__init_($rt_s(1508), $rt_s(1519));
        $java.ju_Locale_TRADITIONAL_CHINESE = $java.ju_Locale__init_($rt_s(1508), $rt_s(1519));
        $java.ju_Locale_UK = $java.ju_Locale__init_($rt_s(1505), $rt_s(1520));
        $java.ju_Locale_US = $java.ju_Locale__init_($rt_s(1505), $rt_s(1521));
        $java.ju_Locale_ROOT = $java.ju_Locale__init_($rt_s(3), $rt_s(3));
        if ($java.otciu_CLDRHelper_$$metadata$$10 === null)
            $java.otciu_CLDRHelper_$$metadata$$10 = $java.otciu_CLDRHelper_getDefaultLocale$$create();
        $localeName = ($java.otciu_CLDRHelper_$$metadata$$10.value !== null ? $rt_str($java.otciu_CLDRHelper_$$metadata$$10.value) : null);
        $countryIndex = jl_String_indexOf0($localeName, 95);
        $java.ju_Locale_defaultLocale = $java.ju_Locale__init_1(jl_String_substring0($localeName, 0, $countryIndex), jl_String_substring($localeName, $countryIndex + 1 | 0), $rt_s(3));
    };
    $java.oncias_SemanticCheck$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncias_SemanticCheck$$_clinit_$lambda$_0_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
    };
    $java.otciu_CLDRHelper = $rt_classWithoutFields();
    $java.otciu_CLDRHelper_$$metadata$$0 = null;
    $java.otciu_CLDRHelper_$$metadata$$10 = null;
    $java.otciu_CLDRHelper_$$metadata$$17 = null;
    $java.otciu_CLDRHelper_$$metadata$$20 = null;
    $java.otciu_CLDRHelper_getCode = function($language, $country) {
        var var$3;
        if (!jl_String_isEmpty($country)) {
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            $language = jl_StringBuilder_append(var$3, $language);
            jl_AbstractStringBuilder_append($language, 45);
            jl_StringBuilder_append($language, $country);
            $language = jl_AbstractStringBuilder_toString(var$3);
        }
        return $language;
    };
    $java.otciu_CLDRHelper_getLikelySubtagsMap$$create = function() {
        return {"ksh": {"value" : "ksh-Latn-DE"}, "ksj": {"value" : "ksj-Latn-ZZ"}, "tdu": {"value" : "tdu-Latn-MY"}, "cch": {"value" : "cch-Latn-NG"}, "und-Khar": {"value" : "pra-Khar-PK"}, "gkn": {"value" : "gkn-Latn-ZZ"}, "ksr": {"value" : "ksr-Latn-ZZ"}, "und-Mani": {"value" : "xmn-Mani-CN"}, "gkp": {"value" : "gkp-Latn-ZZ"}, "xmf": {"value" : "xmf-Geor-GE"}, "ccp": {"value" : "ccp-Cakm-BD"}, "ted": {"value" : "ted-Latn-ZZ"}, "und-Mand": {"value" : "myz-Mand-IR"}, "ktb": {"value" : "ktb-Ethi-ZZ"}, "xmn": {"value"
        : "xmn-Mani-CN"}, "sd-Sind": {"value" : "sd-Sind-IN"}, "xmr": {"value" : "xmr-Merc-SD"}, "tem": {"value" : "tem-Latn-SL"}, "und-Mroo": {"value" : "mro-Mroo-BD"}, "teo": {"value" : "teo-Latn-UG"}, "tet": {"value" : "tet-Latn-TL"}, "ktm": {"value" : "ktm-Latn-ZZ"}, "glk": {"value" : "glk-Arab-IR"}, "kto": {"value" : "kto-Latn-ZZ"}, "ktr": {"value" : "ktr-Latn-MY"}, "und-Soyo": {"value" : "cmg-Soyo-MN"}, "xna": {"value" : "xna-Narb-SA"}, "tfi": {"value" : "tfi-Latn-ZZ"}, "kub": {"value" : "kub-Latn-ZZ"}, "kue":
        {"value" : "kue-Latn-ZZ"}, "kud": {"value" : "kud-Latn-ZZ"}, "xnr": {"value" : "xnr-Deva-IN"}, "ceb": {"value" : "ceb-Latn-PH"}, "kuj": {"value" : "kuj-Latn-ZZ"}, "kum": {"value" : "kum-Cyrl-RU"}, "kun": {"value" : "kun-Latn-ZZ"}, "gmm": {"value" : "gmm-Latn-ZZ"}, "kup": {"value" : "kup-Latn-ZZ"}, "kus": {"value" : "kus-Latn-ZZ"}, "gmv": {"value" : "gmv-Ethi-ZZ"}, "tgc": {"value" : "tgc-Latn-ZZ"}, "xog": {"value" : "xog-Latn-UG"}, "und-Arab-YT": {"value" : "swb-Arab-YT"}, "und-Latn-ET": {"value" : "en-Latn-ET"}
        , "xon": {"value" : "xon-Latn-ZZ"}, "ha-CM": {"value" : "ha-Arab-CM"}, "gnd": {"value" : "gnd-Latn-ZZ"}, "kvg": {"value" : "kvg-Latn-ZZ"}, "tgo": {"value" : "tgo-Latn-ZZ"}, "cfa": {"value" : "cfa-Latn-ZZ"}, "gng": {"value" : "gng-Latn-ZZ"}, "tgu": {"value" : "tgu-Latn-ZZ"}, "und-Latn-GE": {"value" : "ku-Latn-GE"}, "kvr": {"value" : "kvr-Latn-ID"}, "kvx": {"value" : "kvx-Arab-PK"}, "und-Gujr": {"value" : "gu-Gujr-IN"}, "thl": {"value" : "thl-Deva-NP"}, "xpr": {"value" : "xpr-Prti-IR"}, "thq": {"value" : "thq-Deva-NP"}
        , "god": {"value" : "god-Latn-ZZ"}, "gof": {"value" : "gof-Ethi-ZZ"}, "kwj": {"value" : "kwj-Latn-ZZ"}, "ky-Arab": {"value" : "ky-Arab-CN"}, "thr": {"value" : "thr-Deva-NP"}, "goi": {"value" : "goi-Latn-ZZ"}, "cgg": {"value" : "cgg-Latn-UG"}, "kwo": {"value" : "kwo-Latn-ZZ"}, "gom": {"value" : "gom-Deva-IN"}, "kwq": {"value" : "kwq-Latn-ZZ"}, "gon": {"value" : "gon-Telu-IN"}, "gos": {"value" : "gos-Latn-NL"}, "gor": {"value" : "gor-Latn-ID"}, "und-Latn-CY": {"value" : "tr-Latn-CY"}, "got": {"value" : "got-Goth-UA"}
        , "tif": {"value" : "tif-Latn-ZZ"}, "tig": {"value" : "tig-Ethi-ER"}, "kxa": {"value" : "kxa-Latn-ZZ"}, "kxc": {"value" : "kxc-Ethi-ZZ"}, "pag": {"value" : "pag-Latn-PH"}, "tik": {"value" : "tik-Latn-ZZ"}, "kxe": {"value" : "kxe-Latn-ZZ"}, "tim": {"value" : "tim-Latn-ZZ"}, "pal": {"value" : "pal-Phli-IR"}, "tio": {"value" : "tio-Latn-ZZ"}, "pam": {"value" : "pam-Latn-PH"}, "und-Marc": {"value" : "bo-Marc-CN"}, "pap": {"value" : "pap-Latn-AW"}, "und-Latn-CN": {"value" : "za-Latn-CN"}, "tiv": {"value" : "tiv-Latn-NG"}
        , "kxm": {"value" : "kxm-Thai-TH"}, "kxp": {"value" : "kxp-Arab-PK"}, "pau": {"value" : "pau-Latn-PW"}, "chk": {"value" : "chk-Latn-FM"}, "chm": {"value" : "chm-Cyrl-RU"}, "xrb": {"value" : "xrb-Latn-ZZ"}, "chp": {"value" : "chp-Latn-CA"}, "cho": {"value" : "cho-Latn-US"}, "kxw": {"value" : "kxw-Latn-ZZ"}, "und-Latn-DZ": {"value" : "fr-Latn-DZ"}, "chr": {"value" : "chr-Cher-US"}, "kxz": {"value" : "kxz-Latn-ZZ"}, "und-Batk": {"value" : "bbc-Batk-ID"}, "und-Bass": {"value" : "bsq-Bass-LR"}, "kye": {"value"
        : "kye-Latn-ZZ"}, "pbi": {"value" : "pbi-Latn-ZZ"}, "und-Deva-MU": {"value" : "bho-Deva-MU"}, "cic": {"value" : "cic-Latn-US"}, "und-Sgnw": {"value" : "ase-Sgnw-US"}, "xsa": {"value" : "xsa-Sarb-YE"}, "kyx": {"value" : "kyx-Latn-ZZ"}, "xsi": {"value" : "xsi-Latn-ZZ"}, "pcd": {"value" : "pcd-Latn-FR"}, "und-Latn-AM": {"value" : "ku-Latn-AM"}, "xsm": {"value" : "xsm-Latn-ZZ"}, "tkl": {"value" : "tkl-Latn-TK"}, "und-Thai-CN": {"value" : "lcp-Thai-CN"}, "grb": {"value" : "grb-Latn-ZZ"}, "xsr": {"value" : "xsr-Deva-NP"}
        , "und-Latn-AF": {"value" : "tk-Latn-AF"}, "grc": {"value" : "grc-Cprt-CY"}, "kzj": {"value" : "kzj-Latn-MY"}, "tkr": {"value" : "tkr-Latn-AZ"}, "cja": {"value" : "cja-Arab-KH"}, "pcm": {"value" : "pcm-Latn-NG"}, "tkt": {"value" : "tkt-Deva-NP"}, "und-Olck": {"value" : "sat-Olck-IN"}, "kzr": {"value" : "kzr-Latn-ZZ"}, "kzt": {"value" : "kzt-Latn-MY"}, "cjm": {"value" : "cjm-Cham-VN"}, "grt": {"value" : "grt-Beng-IN"}, "und-Arab-TJ": {"value" : "fa-Arab-TJ"}, "und-Arab-TG": {"value" : "apd-Arab-TG"}, "und-Arab-TH":
        {"value" : "mfa-Arab-TH"}, "und-Deva-PK": {"value" : "btv-Deva-PK"}, "grw": {"value" : "grw-Latn-ZZ"}, "cjv": {"value" : "cjv-Latn-ZZ"}, "pdc": {"value" : "pdc-Latn-US"}, "tlf": {"value" : "tlf-Latn-ZZ"}, "und-Arab-TR": {"value" : "az-Arab-TR"}, "ckb": {"value" : "ckb-Arab-IQ"}, "tly": {"value" : "tly-Latn-AZ"}, "pdt": {"value" : "pdt-Latn-CA"}, "tlx": {"value" : "tlx-Latn-ZZ"}, "ckl": {"value" : "ckl-Latn-ZZ"}, "cko": {"value" : "cko-Latn-ZZ"}, "gsw": {"value" : "gsw-Latn-CH"}, "ped": {"value" : "ped-Latn-ZZ"}
        , "tmh": {"value" : "tmh-Latn-NE"}, "cky": {"value" : "cky-Latn-ZZ"}, "kk-Arab": {"value" : "kk-Arab-CN"}, "und-Runr": {"value" : "non-Runr-SE"}, "cla": {"value" : "cla-Latn-ZZ"}, "peo": {"value" : "peo-Xpeo-IR"}, "tmy": {"value" : "tmy-Latn-ZZ"}, "pex": {"value" : "pex-Latn-ZZ"}, "ky-TR": {"value" : "ky-Latn-TR"}, "tnh": {"value" : "tnh-Latn-ZZ"}, "guc": {"value" : "guc-Latn-CO"}, "gub": {"value" : "gub-Latn-BR"}, "gud": {"value" : "gud-Latn-ZZ"}, "pfl": {"value" : "pfl-Latn-DE"}, "cme": {"value" : "cme-Latn-ZZ"}
        , "cmg": {"value" : "cmg-Soyo-MN"}, "gur": {"value" : "gur-Latn-GH"}, "xwe": {"value" : "xwe-Latn-ZZ"}, "guw": {"value" : "guw-Latn-ZZ"}, "tof": {"value" : "tof-Latn-ZZ"}, "gux": {"value" : "gux-Latn-ZZ"}, "guz": {"value" : "guz-Latn-KE"}, "tog": {"value" : "tog-Latn-MW"}, "gvf": {"value" : "gvf-Latn-ZZ"}, "toq": {"value" : "toq-Latn-ZZ"}, "gvr": {"value" : "gvr-Deva-NP"}, "und-Guru": {"value" : "pa-Guru-IN"}, "gvs": {"value" : "gvs-Latn-ZZ"}, "tpi": {"value" : "tpi-Latn-PG"}, "tpm": {"value" : "tpm-Latn-ZZ"}
        , "und-Tfng": {"value" : "zgh-Tfng-MA"}, "gwc": {"value" : "gwc-Arab-ZZ"}, "und-Arab-PK": {"value" : "ur-Arab-PK"}, "phl": {"value" : "phl-Arab-ZZ"}, "und-Aghb": {"value" : "lez-Aghb-RU"}, "phn": {"value" : "phn-Phnx-LB"}, "gwi": {"value" : "gwi-Latn-CA"}, "tpz": {"value" : "tpz-Latn-ZZ"}, "cop": {"value" : "cop-Copt-EG"}, "gwt": {"value" : "gwt-Arab-ZZ"}, "lab": {"value" : "lab-Lina-GR"}, "lad": {"value" : "lad-Hebr-IL"}, "lah": {"value" : "lah-Arab-PK"}, "pil": {"value" : "pil-Latn-ZZ"}, "lag": {"value"
        : "lag-Latn-TZ"}, "tqo": {"value" : "tqo-Latn-ZZ"}, "laj": {"value" : "laj-Latn-UG"}, "pip": {"value" : "pip-Latn-ZZ"}, "und-Khmr": {"value" : "km-Khmr-KH"}, "las": {"value" : "las-Latn-ZZ"}, "sd-Deva": {"value" : "sd-Deva-IN"}, "und-Khoj": {"value" : "sd-Khoj-IN"}, "cps": {"value" : "cps-Latn-PH"}, "kk-AF": {"value" : "kk-Arab-AF"}, "und-Arab-MU": {"value" : "ur-Arab-MU"}, "lbe": {"value" : "lbe-Cyrl-RU"}, "und-Arab-NG": {"value" : "ha-Arab-NG"}, "gyi": {"value" : "gyi-Latn-ZZ"}, "tru": {"value" : "tru-Latn-TR"}
        , "trw": {"value" : "trw-Arab-ZZ"}, "trv": {"value" : "trv-Latn-TW"}, "lbu": {"value" : "lbu-Latn-ZZ"}, "lbw": {"value" : "lbw-Latn-ID"}, "tsd": {"value" : "tsd-Grek-GR"}, "tsf": {"value" : "tsf-Deva-NP"}, "pka": {"value" : "pka-Brah-IN"}, "tsg": {"value" : "tsg-Latn-PH"}, "tsj": {"value" : "tsj-Tibt-BT"}, "und-Deva-FJ": {"value" : "hif-Deva-FJ"}, "pko": {"value" : "pko-Latn-KE"}, "lcm": {"value" : "lcm-Latn-ZZ"}, "crh": {"value" : "crh-Cyrl-UA"}, "lcp": {"value" : "lcp-Thai-CN"}, "tsw": {"value" : "tsw-Latn-ZZ"}
        , "crj": {"value" : "crj-Cans-CA"}, "crl": {"value" : "crl-Cans-CA"}, "und-Arab-MN": {"value" : "kk-Arab-MN"}, "crk": {"value" : "crk-Cans-CA"}, "crm": {"value" : "crm-Cans-CA"}, "und-Arab-MM": {"value" : "rhg-Arab-MM"}, "pla": {"value" : "pla-Latn-ZZ"}, "tte": {"value" : "tte-Latn-ZZ"}, "crs": {"value" : "crs-Latn-SC"}, "ttd": {"value" : "ttd-Latn-ZZ"}, "ldb": {"value" : "ldb-Latn-ZZ"}, "ttj": {"value" : "ttj-Latn-UG"}, "kk-CN": {"value" : "kk-Arab-CN"}, "und-Yiii": {"value" : "ii-Yiii-CN"}, "tts": {"value"
        : "tts-Thai-TH"}, "csb": {"value" : "csb-Latn-PL"}, "ttr": {"value" : "ttr-Latn-ZZ"}, "ttt": {"value" : "ttt-Latn-AZ"}, "csw": {"value" : "csw-Cans-CA"}, "tuh": {"value" : "tuh-Latn-ZZ"}, "led": {"value" : "led-Latn-ZZ"}, "tul": {"value" : "tul-Latn-ZZ"}, "lee": {"value" : "lee-Latn-ZZ"}, "tum": {"value" : "tum-Latn-MW"}, "und-Arab-KH": {"value" : "cja-Arab-KH"}, "tuq": {"value" : "tuq-Latn-ZZ"}, "ctd": {"value" : "ctd-Pauc-MM"}, "lem": {"value" : "lem-Latn-ZZ"}, "lep": {"value" : "lep-Lepc-IN"}, "pms":
        {"value" : "pms-Latn-IT"}, "leq": {"value" : "leq-Latn-ZZ"}, "und-Pauc": {"value" : "ctd-Pauc-MM"}, "und-Sogo": {"value" : "sog-Sogo-UZ"}, "leu": {"value" : "leu-Latn-ZZ"}, "lez": {"value" : "lez-Cyrl-RU"}, "tvd": {"value" : "tvd-Latn-ZZ"}, "mn-CN": {"value" : "mn-Mong-CN"}, "sr-TR": {"value" : "sr-Latn-TR"}, "png": {"value" : "png-Latn-ZZ"}, "tvl": {"value" : "tvl-Latn-TV"}, "und-Brah": {"value" : "pka-Brah-IN"}, "und-Brai": {"value" : "fr-Brai-FR"}, "pnn": {"value" : "pnn-Latn-ZZ"}, "tvu": {"value" : "tvu-Latn-ZZ"}
        , "pnt": {"value" : "pnt-Grek-GR"}, "uz-CN": {"value" : "uz-Cyrl-CN"}, "ha-SD": {"value" : "ha-Arab-SD"}, "twh": {"value" : "twh-Latn-ZZ"}, "und-Takr": {"value" : "doi-Takr-IN"}, "lgg": {"value" : "lgg-Latn-ZZ"}, "pon": {"value" : "pon-Latn-FM"}, "twq": {"value" : "twq-Latn-NE"}, "und-Arab-ID": {"value" : "ms-Arab-ID"}, "und-Arab-IN": {"value" : "ur-Arab-IN"}, "ppa": {"value" : "ppa-Deva-IN"}, "txg": {"value" : "txg-Tang-CN"}, "yam": {"value" : "yam-Latn-ZZ"}, "und-Talu": {"value" : "khb-Talu-CN"}, "yao":
        {"value" : "yao-Latn-MZ"}, "yap": {"value" : "yap-Latn-FM"}, "yas": {"value" : "yas-Latn-ZZ"}, "yat": {"value" : "yat-Latn-ZZ"}, "ppo": {"value" : "ppo-Latn-ZZ"}, "yav": {"value" : "yav-Latn-CM"}, "yay": {"value" : "yay-Latn-ZZ"}, "yaz": {"value" : "yaz-Latn-ZZ"}, "und-Tale": {"value" : "tdd-Tale-CN"}, "ybb": {"value" : "ybb-Latn-CM"}, "yba": {"value" : "yba-Latn-ZZ"}, "tya": {"value" : "tya-Latn-ZZ"}, "lia": {"value" : "lia-Latn-ZZ"}, "lid": {"value" : "lid-Latn-ZZ"}, "und-Latn-TW": {"value" : "trv-Latn-TW"}
        , "lif": {"value" : "lif-Deva-NP"}, "lih": {"value" : "lih-Latn-ZZ"}, "lig": {"value" : "lig-Latn-ZZ"}, "lij": {"value" : "lij-Latn-IT"}, "hag": {"value" : "hag-Latn-ZZ"}, "und-Latn-TN": {"value" : "fr-Latn-TN"}, "tyv": {"value" : "tyv-Cyrl-RU"}, "yby": {"value" : "yby-Latn-ZZ"}, "und-Arab-GB": {"value" : "ks-Arab-GB"}, "hak": {"value" : "hak-Hans-CN"}, "und-Taml": {"value" : "ta-Taml-IN"}, "ham": {"value" : "ham-Latn-ZZ"}, "lis": {"value" : "lis-Lisu-CN"}, "und-Latn-SY": {"value" : "fr-Latn-SY"}, "ky-Latn":
        {"value" : "ky-Latn-TR"}, "pra": {"value" : "pra-Khar-PK"}, "haw": {"value" : "haw-Latn-US"}, "haz": {"value" : "haz-Arab-AF"}, "ku-LB": {"value" : "ku-Arab-LB"}, "prd": {"value" : "prd-Arab-IR"}, "prg": {"value" : "prg-Latn-001"}, "tzm": {"value" : "tzm-Latn-MA"}, "hbb": {"value" : "hbb-Latn-ZZ"}, "und-Latn-UA": {"value" : "pl-Latn-UA"}, "ljp": {"value" : "ljp-Latn-ID"}, "und-Tang": {"value" : "txg-Tang-CN"}, "yue-Hans": {"value" : "yue-Hans-CN"}, "und-Latn-RU": {"value" : "krl-Latn-RU"}, "lki": {"value"
        : "lki-Arab-IR"}, "pss": {"value" : "pss-Latn-ZZ"}, "lkt": {"value" : "lkt-Latn-US"}, "sr-RO": {"value" : "sr-Latn-RO"}, "und-Arab-CN": {"value" : "ug-Arab-CN"}, "lle": {"value" : "lle-Latn-ZZ"}, "und-Cyrl": {"value" : "ru-Cyrl-RU"}, "uz-AF": {"value" : "uz-Arab-AF"}, "yer": {"value" : "yer-Latn-ZZ"}, "und-Beng": {"value" : "bn-Beng-BD"}, "ptp": {"value" : "ptp-Latn-ZZ"}, "lln": {"value" : "lln-Latn-ZZ"}, "sr-RU": {"value" : "sr-Latn-RU"}, "hdy": {"value" : "hdy-Ethi-ZZ"}, "unr-NP": {"value" : "unr-Deva-NP"}
        , "und-Mend": {"value" : "men-Mend-SL"}, "lmn": {"value" : "lmn-Telu-IN"}, "lmp": {"value" : "lmp-Latn-ZZ"}, "lmo": {"value" : "lmo-Latn-IT"}, "puu": {"value" : "puu-Latn-GA"}, "und-Arab-CC": {"value" : "ms-Arab-CC"}, "pal-Phlp": {"value" : "pal-Phlp-CN"}, "ygr": {"value" : "ygr-Latn-ZZ"}, "ygw": {"value" : "ygw-Latn-ZZ"}, "lns": {"value" : "lns-Latn-ZZ"}, "ky-CN": {"value" : "ky-Arab-CN"}, "lnu": {"value" : "lnu-Latn-ZZ"}, "pwa": {"value" : "pwa-Latn-ZZ"}, "und-Chrs": {"value" : "xco-Chrs-UZ"}, "und-Mahj":
        {"value" : "hi-Mahj-IN"}, "rif-NL": {"value" : "rif-Latn-NL"}, "loj": {"value" : "loj-Latn-ZZ"}, "lol": {"value" : "lol-Latn-CD"}, "lok": {"value" : "lok-Latn-ZZ"}, "lor": {"value" : "lor-Latn-ZZ"}, "und-Sora": {"value" : "srb-Sora-IN"}, "los": {"value" : "los-Latn-ZZ"}, "loz": {"value" : "loz-Latn-ZM"}, "und-202": {"value" : "en-Latn-NG"}, "und-Latn-MR": {"value" : "fr-Latn-MR"}, "ku-Yezi": {"value" : "ku-Yezi-GE"}, "hhy": {"value" : "hhy-Latn-ZZ"}, "hia": {"value" : "hia-Latn-ZZ"}, "hif": {"value" : "hif-Latn-FJ"}
        , "dad": {"value" : "dad-Latn-ZZ"}, "hih": {"value" : "hih-Latn-ZZ"}, "hig": {"value" : "hig-Latn-ZZ"}, "daf": {"value" : "daf-Latn-ZZ"}, "ubu": {"value" : "ubu-Latn-ZZ"}, "dah": {"value" : "dah-Latn-ZZ"}, "hil": {"value" : "hil-Latn-PH"}, "dag": {"value" : "dag-Latn-ZZ"}, "und-Mero": {"value" : "xmr-Mero-SD"}, "dak": {"value" : "dak-Latn-US"}, "und-Merc": {"value" : "xmr-Merc-SD"}, "dar": {"value" : "dar-Cyrl-RU"}, "dav": {"value" : "dav-Latn-KE"}, "lrc": {"value" : "lrc-Arab-IR"}, "yko": {"value" : "yko-Latn-ZZ"}
        , "und-Latn-MK": {"value" : "sq-Latn-MK"}, "und-Latn-MM": {"value" : "kac-Latn-MM"}, "dbd": {"value" : "dbd-Latn-ZZ"}, "und-Latn-MO": {"value" : "pt-Latn-MO"}, "und-Latn-MA": {"value" : "fr-Latn-MA"}, "und-Bali": {"value" : "ban-Bali-ID"}, "und-Tavt": {"value" : "blt-Tavt-VN"}, "dbq": {"value" : "dbq-Latn-ZZ"}, "yle": {"value" : "yle-Latn-ZZ"}, "ylg": {"value" : "ylg-Latn-ZZ"}, "und-Maka": {"value" : "mak-Maka-ID"}, "yll": {"value" : "yll-Latn-ZZ"}, "udm": {"value" : "udm-Cyrl-RU"}, "dcc": {"value" : "dcc-Arab-IN"}
        , "yml": {"value" : "yml-Latn-ZZ"}, "hla": {"value" : "hla-Latn-ZZ"}, "und-Latn-IR": {"value" : "tk-Latn-IR"}, "ltg": {"value" : "ltg-Latn-LV"}, "und-Latn-KM": {"value" : "fr-Latn-KM"}, "ddn": {"value" : "ddn-Latn-ZZ"}, "hlu": {"value" : "hlu-Hluw-TR"}, "lua": {"value" : "lua-Latn-CD"}, "und-Bamu": {"value" : "bax-Bamu-CM"}, "hmd": {"value" : "hmd-Plrd-CN"}, "ded": {"value" : "ded-Latn-ZZ"}, "luo": {"value" : "luo-Latn-KE"}, "und-142": {"value" : "zh-Hans-CN"}, "und-143": {"value" : "uz-Latn-UZ"}, "den":
        {"value" : "den-Latn-CA"}, "und-Gran": {"value" : "sa-Gran-IN"}, "hmt": {"value" : "hmt-Latn-ZZ"}, "uga": {"value" : "uga-Ugar-SY"}, "luz": {"value" : "luz-Arab-IR"}, "luy": {"value" : "luy-Latn-KE"}, "und-145": {"value" : "ar-Arab-SA"}, "und-Cakm": {"value" : "ccp-Cakm-BD"}, "und-Dupl": {"value" : "fr-Dupl-FR"}, "yon": {"value" : "yon-Latn-ZZ"}, "ug-MN": {"value" : "ug-Cyrl-MN"}, "hne": {"value" : "hne-Deva-IN"}, "hnd": {"value" : "hnd-Arab-PK"}, "hnj": {"value" : "hnj-Hmng-LA"}, "hno": {"value" : "hno-Arab-PK"}
        , "hnn": {"value" : "hnn-Latn-PH"}, "ug-KZ": {"value" : "ug-Cyrl-KZ"}, "und-154": {"value" : "en-Latn-GB"}, "und-155": {"value" : "de-Latn-DE"}, "und-150": {"value" : "ru-Cyrl-RU"}, "und-151": {"value" : "ru-Cyrl-RU"}, "und-Sylo": {"value" : "syl-Sylo-BD"}, "hoc": {"value" : "hoc-Deva-IN"}, "dga": {"value" : "dga-Latn-ZZ"}, "lwl": {"value" : "lwl-Thai-TH"}, "und-Ital": {"value" : "ett-Ital-IT"}, "hoj": {"value" : "hoj-Deva-IN"}, "dgh": {"value" : "dgh-Latn-ZZ"}, "dgi": {"value" : "dgi-Latn-ZZ"}, "dgl": {"value"
        : "dgl-Arab-ZZ"}, "hot": {"value" : "hot-Latn-ZZ"}, "dgr": {"value" : "dgr-Latn-CA"}, "dgz": {"value" : "dgz-Latn-ZZ"}, "yrb": {"value" : "yrb-Latn-ZZ"}, "yre": {"value" : "yre-Latn-ZZ"}, "und-Lyci": {"value" : "xlc-Lyci-TR"}, "und-Cans": {"value" : "cr-Cans-CA"}, "und-Hluw": {"value" : "hlu-Hluw-TR"}, "und-Nand": {"value" : "sa-Nand-IN"}, "yrl": {"value" : "yrl-Latn-BR"}, "dia": {"value" : "dia-Latn-ZZ"}, "und-Grek": {"value" : "el-Grek-GR"}, "und-Mong": {"value" : "mn-Mong-CN"}, "und-Lydi": {"value" :
        "xld-Lydi-TR"}, "yss": {"value" : "yss-Latn-ZZ"}, "und-Newa": {"value" : "new-Newa-NP"}, "lzh": {"value" : "lzh-Hans-CN"}, "dje": {"value" : "dje-Latn-NE"}, "lzz": {"value" : "lzz-Latn-TR"}, "uli": {"value" : "uli-Latn-FM"}, "hsb": {"value" : "hsb-Latn-DE"}, "und-Xsux": {"value" : "akk-Xsux-IQ"}, "hsn": {"value" : "hsn-Hans-CN"}, "und-Cari": {"value" : "xcr-Cari-TR"}, "und-Syrc": {"value" : "syr-Syrc-IQ"}, "yua": {"value" : "yua-Latn-MX"}, "yue": {"value" : "yue-Hant-HK"}, "umb": {"value" : "umb-Latn-AO"}
        , "yuj": {"value" : "yuj-Latn-ZZ"}, "yut": {"value" : "yut-Latn-ZZ"}, "yuw": {"value" : "yuw-Latn-ZZ"}, "und-Bopo": {"value" : "zh-Bopo-TW"}, "und-Yezi": {"value" : "ku-Yezi-GE"}, "und": {"value" : "en-Latn-US"}, "und-Egyp": {"value" : "egy-Egyp-EG"}, "und-Tglg": {"value" : "fil-Tglg-PH"}, "unr": {"value" : "unr-Beng-IN"}, "hui": {"value" : "hui-Latn-ZZ"}, "und-Elba": {"value" : "sq-Elba-AL"}, "unx": {"value" : "unx-Beng-IN"}, "und-Narb": {"value" : "xna-Narb-SA"}, "pa-PK": {"value" : "pa-Arab-PK"}, "und-Hebr-CA":
        {"value" : "yi-Hebr-CA"}, "uok": {"value" : "uok-Latn-ZZ"}, "und-Geor": {"value" : "ka-Geor-GE"}, "und-Shrd": {"value" : "sa-Shrd-IN"}, "dnj": {"value" : "dnj-Latn-CI"}, "und-Diak": {"value" : "dv-Diak-MV"}, "dob": {"value" : "dob-Latn-ZZ"}, "und-Mymr-TH": {"value" : "mnw-Mymr-TH"}, "doi": {"value" : "doi-Arab-IN"}, "dop": {"value" : "dop-Latn-ZZ"}, "und-Sund": {"value" : "su-Sund-ID"}, "dow": {"value" : "dow-Latn-ZZ"}, "sr-ME": {"value" : "sr-Latn-ME"}, "und-Hung": {"value" : "hu-Hung-HU"}, "mad": {"value"
        : "mad-Latn-ID"}, "mag": {"value" : "mag-Deva-IN"}, "maf": {"value" : "maf-Latn-CM"}, "mai": {"value" : "mai-Deva-IN"}, "mak": {"value" : "mak-Latn-ID"}, "man": {"value" : "man-Latn-GM"}, "mas": {"value" : "mas-Latn-KE"}, "maw": {"value" : "maw-Latn-ZZ"}, "maz": {"value" : "maz-Latn-MX"}, "uri": {"value" : "uri-Latn-ZZ"}, "mbh": {"value" : "mbh-Latn-ZZ"}, "urt": {"value" : "urt-Latn-ZZ"}, "mbo": {"value" : "mbo-Latn-ZZ"}, "urw": {"value" : "urw-Latn-ZZ"}, "mbq": {"value" : "mbq-Latn-ZZ"}, "mbu": {"value"
        : "mbu-Latn-ZZ"}, "und-Hebr-GB": {"value" : "yi-Hebr-GB"}, "usa": {"value" : "usa-Latn-ZZ"}, "mbw": {"value" : "mbw-Latn-ZZ"}, "mci": {"value" : "mci-Latn-ZZ"}, "dri": {"value" : "dri-Latn-ZZ"}, "mcq": {"value" : "mcq-Latn-ZZ"}, "drh": {"value" : "drh-Mong-CN"}, "mcp": {"value" : "mcp-Latn-ZZ"}, "mcr": {"value" : "mcr-Latn-ZZ"}, "mcu": {"value" : "mcu-Latn-ZZ"}, "drs": {"value" : "drs-Ethi-ZZ"}, "mda": {"value" : "mda-Latn-ZZ"}, "mdf": {"value" : "mdf-Cyrl-RU"}, "mde": {"value" : "mde-Arab-ZZ"}, "mdh": {"value"
        : "mdh-Latn-PH"}, "dsb": {"value" : "dsb-Latn-DE"}, "mdj": {"value" : "mdj-Latn-ZZ"}, "utr": {"value" : "utr-Latn-ZZ"}, "mdr": {"value" : "mdr-Latn-ID"}, "mdx": {"value" : "mdx-Ethi-ZZ"}, "mee": {"value" : "mee-Latn-ZZ"}, "med": {"value" : "med-Latn-ZZ"}, "mek": {"value" : "mek-Latn-ZZ"}, "men": {"value" : "men-Latn-SL"}, "az-RU": {"value" : "az-Cyrl-RU"}, "mis-Medf": {"value" : "mis-Medf-NG"}, "mer": {"value" : "mer-Latn-KE"}, "dtm": {"value" : "dtm-Latn-ML"}, "meu": {"value" : "meu-Latn-ZZ"}, "met": {"value"
        : "met-Latn-ZZ"}, "dtp": {"value" : "dtp-Latn-MY"}, "dts": {"value" : "dts-Latn-ZZ"}, "uvh": {"value" : "uvh-Latn-ZZ"}, "dty": {"value" : "dty-Deva-NP"}, "mfa": {"value" : "mfa-Arab-TH"}, "uvl": {"value" : "uvl-Latn-ZZ"}, "mfe": {"value" : "mfe-Latn-MU"}, "dua": {"value" : "dua-Latn-CM"}, "dud": {"value" : "dud-Latn-ZZ"}, "duc": {"value" : "duc-Latn-ZZ"}, "mfn": {"value" : "mfn-Latn-ZZ"}, "dug": {"value" : "dug-Latn-ZZ"}, "mfo": {"value" : "mfo-Latn-ZZ"}, "mfq": {"value" : "mfq-Latn-ZZ"}, "und-Phag": {"value"
        : "lzh-Phag-CN"}, "dva": {"value" : "dva-Latn-ZZ"}, "mgh": {"value" : "mgh-Latn-MZ"}, "mgl": {"value" : "mgl-Latn-ZZ"}, "mgo": {"value" : "mgo-Latn-CM"}, "mgp": {"value" : "mgp-Deva-NP"}, "mgy": {"value" : "mgy-Latn-TZ"}, "zag": {"value" : "zag-Latn-SD"}, "mhi": {"value" : "mhi-Latn-ZZ"}, "mhl": {"value" : "mhl-Latn-ZZ"}, "dww": {"value" : "dww-Latn-ZZ"}, "mif": {"value" : "mif-Latn-ZZ"}, "und-Mymr-IN": {"value" : "kht-Mymr-IN"}, "min": {"value" : "min-Latn-ID"}, "mis": {"value" : "mis-Hatr-IQ"}, "ian":
        {"value" : "ian-Latn-ZZ"}, "miw": {"value" : "miw-Latn-ZZ"}, "iar": {"value" : "iar-Latn-ZZ"}, "uz-Arab": {"value" : "uz-Arab-AF"}, "ibb": {"value" : "ibb-Latn-NG"}, "iba": {"value" : "iba-Latn-MY"}, "dyo": {"value" : "dyo-Latn-SN"}, "dyu": {"value" : "dyu-Latn-BF"}, "iby": {"value" : "iby-Latn-ZZ"}, "zdj": {"value" : "zdj-Arab-KM"}, "ica": {"value" : "ica-Latn-ZZ"}, "mki": {"value" : "mki-Arab-ZZ"}, "und-Wcho": {"value" : "nnp-Wcho-IN"}, "ich": {"value" : "ich-Latn-ZZ"}, "mkl": {"value" : "mkl-Latn-ZZ"}
        , "dzg": {"value" : "dzg-Latn-ZZ"}, "mkp": {"value" : "mkp-Latn-ZZ"}, "zea": {"value" : "zea-Latn-NL"}, "mkw": {"value" : "mkw-Latn-ZZ"}, "mle": {"value" : "mle-Latn-ZZ"}, "idd": {"value" : "idd-Latn-ZZ"}, "idi": {"value" : "idi-Latn-ZZ"}, "lif-Limb": {"value" : "lif-Limb-IN"}, "mlp": {"value" : "mlp-Latn-ZZ"}, "mls": {"value" : "mls-Latn-SD"}, "idu": {"value" : "idu-Latn-ZZ"}, "quc": {"value" : "quc-Latn-GT"}, "qug": {"value" : "qug-Latn-EC"}, "und-Jamo": {"value" : "ko-Jamo-KR"}, "mmo": {"value" : "mmo-Latn-ZZ"}
        , "mmu": {"value" : "mmu-Latn-ZZ"}, "mmx": {"value" : "mmx-Latn-ZZ"}, "zgh": {"value" : "zgh-Tfng-MA"}, "mna": {"value" : "mna-Latn-ZZ"}, "mnf": {"value" : "mnf-Latn-ZZ"}, "ife": {"value" : "ife-Latn-TG"}, "mni": {"value" : "mni-Beng-IN"}, "mnw": {"value" : "mnw-Mymr-MM"}, "moa": {"value" : "moa-Latn-ZZ"}, "moe": {"value" : "moe-Latn-CA"}, "igb": {"value" : "igb-Latn-ZZ"}, "ige": {"value" : "ige-Latn-ZZ"}, "moh": {"value" : "moh-Latn-CA"}, "und-Hebr-SE": {"value" : "yi-Hebr-SE"}, "zhx": {"value" : "zhx-Nshu-CN"}
        , "mos": {"value" : "mos-Latn-BF"}, "und-Shaw": {"value" : "en-Shaw-GB"}, "zia": {"value" : "zia-Latn-ZZ"}, "mox": {"value" : "mox-Latn-ZZ"}, "vag": {"value" : "vag-Latn-ZZ"}, "vai": {"value" : "vai-Vaii-LR"}, "van": {"value" : "van-Latn-ZZ"}, "mpp": {"value" : "mpp-Latn-ZZ"}, "mpt": {"value" : "mpt-Latn-ZZ"}, "mps": {"value" : "mps-Latn-ZZ"}, "mpx": {"value" : "mpx-Latn-ZZ"}, "und-Hebr-US": {"value" : "yi-Hebr-US"}, "hi-Latn": {"value" : "hi-Latn-IN"}, "mql": {"value" : "mql-Latn-ZZ"}, "und-Hebr-UA": {"value"
        : "yi-Hebr-UA"}, "mrd": {"value" : "mrd-Deva-NP"}, "zkt": {"value" : "zkt-Kits-CN"}, "mrj": {"value" : "mrj-Cyrl-RU"}, "ijj": {"value" : "ijj-Latn-ZZ"}, "mro": {"value" : "mro-Mroo-BD"}, "und-Modi": {"value" : "mr-Modi-IN"}, "ebu": {"value" : "ebu-Latn-KE"}, "zlm": {"value" : "zlm-Latn-TG"}, "arc-Palm": {"value" : "arc-Palm-SY"}, "ikk": {"value" : "ikk-Latn-ZZ"}, "ikt": {"value" : "ikt-Latn-CA"}, "ikw": {"value" : "ikw-Latn-ZZ"}, "vec": {"value" : "vec-Latn-IT"}, "ikx": {"value" : "ikx-Latn-ZZ"}, "zmi":
        {"value" : "zmi-Latn-MY"}, "mtc": {"value" : "mtc-Latn-ZZ"}, "mtf": {"value" : "mtf-Latn-ZZ"}, "vep": {"value" : "vep-Latn-RU"}, "zh-Bopo": {"value" : "zh-Bopo-TW"}, "mti": {"value" : "mti-Latn-ZZ"}, "und-Ethi": {"value" : "am-Ethi-ET"}, "mtr": {"value" : "mtr-Deva-IN"}, "und-Thai-LA": {"value" : "kdt-Thai-LA"}, "ilo": {"value" : "ilo-Latn-PH"}, "zne": {"value" : "zne-Latn-ZZ"}, "mua": {"value" : "mua-Latn-CM"}, "und-Thai-KH": {"value" : "kdt-Thai-KH"}, "imo": {"value" : "imo-Latn-ZZ"}, "mus": {"value" :
        "mus-Latn-US"}, "mur": {"value" : "mur-Latn-ZZ"}, "mva": {"value" : "mva-Latn-ZZ"}, "inh": {"value" : "inh-Cyrl-RU"}, "mvn": {"value" : "mvn-Latn-ZZ"}, "efi": {"value" : "efi-Latn-NG"}, "mvy": {"value" : "mvy-Arab-PK"}, "und-Java": {"value" : "jv-Java-ID"}, "mwk": {"value" : "mwk-Latn-ML"}, "mwr": {"value" : "mwr-Deva-IN"}, "und-021": {"value" : "en-Latn-US"}, "egl": {"value" : "egl-Latn-IT"}, "mww": {"value" : "mww-Hmnp-US"}, "mwv": {"value" : "mwv-Latn-ID"}, "iou": {"value" : "iou-Latn-ZZ"}, "und-029":
        {"value" : "es-Latn-CU"}, "vic": {"value" : "vic-Latn-SX"}, "egy": {"value" : "egy-Egyp-EG"}, "und-Ugar": {"value" : "uga-Ugar-SY"}, "mxc": {"value" : "mxc-Latn-ZW"}, "raj": {"value" : "raj-Deva-IN"}, "rai": {"value" : "rai-Latn-ZZ"}, "rao": {"value" : "rao-Latn-ZZ"}, "viv": {"value" : "viv-Latn-ZZ"}, "mxm": {"value" : "mxm-Latn-ZZ"}, "und-034": {"value" : "hi-Deva-IN"}, "und-030": {"value" : "zh-Hans-CN"}, "und-039": {"value" : "it-Latn-IT"}, "und-035": {"value" : "id-Latn-ID"}, "ug-Cyrl": {"value" : "ug-Cyrl-KZ"}
        , "myk": {"value" : "myk-Latn-ZZ"}, "mym": {"value" : "mym-Ethi-ZZ"}, "aai": {"value" : "aai-Latn-ZZ"}, "aak": {"value" : "aak-Latn-ZZ"}, "myw": {"value" : "myw-Latn-ZZ"}, "myv": {"value" : "myv-Cyrl-RU"}, "myx": {"value" : "myx-Latn-UG"}, "myz": {"value" : "myz-Mand-IR"}, "und-Sinh": {"value" : "si-Sinh-LK"}, "und-Sind": {"value" : "sd-Sind-IN"}, "aau": {"value" : "aau-Latn-ZZ"}, "rcf": {"value" : "rcf-Latn-RE"}, "und-Orkh": {"value" : "otk-Orkh-MN"}, "mzk": {"value" : "mzk-Latn-ZZ"}, "mzn": {"value" :
        "mzn-Arab-IR"}, "iri": {"value" : "iri-Latn-ZZ"}, "mzm": {"value" : "mzm-Latn-ZZ"}, "mzp": {"value" : "mzp-Latn-ZZ"}, "und-053": {"value" : "en-Latn-AU"}, "abi": {"value" : "abi-Latn-ZZ"}, "und-054": {"value" : "en-Latn-PG"}, "mzw": {"value" : "mzw-Latn-ZZ"}, "mzz": {"value" : "mzz-Latn-ZZ"}, "abr": {"value" : "abr-Latn-GH"}, "abq": {"value" : "abq-Cyrl-ZZ"}, "abt": {"value" : "abt-Latn-ZZ"}, "und-057": {"value" : "en-Latn-GU"}, "aby": {"value" : "aby-Latn-ZZ"}, "eka": {"value" : "eka-Latn-ZZ"}, "vls": {"value"
        : "vls-Latn-BE"}, "ace": {"value" : "ace-Latn-ID"}, "acd": {"value" : "acd-Latn-ZZ"}, "ach": {"value" : "ach-Latn-UG"}, "vmf": {"value" : "vmf-Latn-DE"}, "eky": {"value" : "eky-Kali-MM"}, "rej": {"value" : "rej-Latn-ID"}, "rel": {"value" : "rel-Latn-ZZ"}, "ada": {"value" : "ada-Latn-GH"}, "res": {"value" : "res-Latn-ZZ"}, "vmw": {"value" : "vmw-Latn-MZ"}, "ade": {"value" : "ade-Latn-ZZ"}, "adj": {"value" : "adj-Latn-ZZ"}, "und-Hira": {"value" : "ja-Hira-JP"}, "adp": {"value" : "adp-Tibt-BT"}, "adz": {"value"
        : "adz-Latn-ZZ"}, "ady": {"value" : "ady-Cyrl-RU"}, "ema": {"value" : "ema-Latn-ZZ"}, "und-Deva": {"value" : "hi-Deva-IN"}, "aeb": {"value" : "aeb-Arab-TN"}, "emi": {"value" : "emi-Latn-ZZ"}, "und-009": {"value" : "en-Latn-AU"}, "aey": {"value" : "aey-Latn-ZZ"}, "und-002": {"value" : "en-Latn-NG"}, "und-003": {"value" : "en-Latn-US"}, "und-005": {"value" : "pt-Latn-BR"}, "rgn": {"value" : "rgn-Latn-IT"}, "vot": {"value" : "vot-Latn-RU"}, "enn": {"value" : "enn-Latn-ZZ"}, "enq": {"value" : "enq-Latn-ZZ"}
        , "und-011": {"value" : "en-Latn-NG"}, "rhg": {"value" : "rhg-Arab-MM"}, "und-017": {"value" : "sw-Latn-CD"}, "und-018": {"value" : "en-Latn-ZA"}, "und-019": {"value" : "en-Latn-US"}, "und-013": {"value" : "es-Latn-MX"}, "und-014": {"value" : "sw-Latn-TZ"}, "und-015": {"value" : "ar-Arab-EG"}, "agc": {"value" : "agc-Latn-ZZ"}, "und-Zanb": {"value" : "cmg-Zanb-MN"}, "iwm": {"value" : "iwm-Latn-ZZ"}, "agd": {"value" : "agd-Latn-ZZ"}, "agg": {"value" : "agg-Latn-ZZ"}, "iws": {"value" : "iws-Latn-ZZ"}, "agm":
        {"value" : "agm-Latn-ZZ"}, "ago": {"value" : "ago-Latn-ZZ"}, "agq": {"value" : "agq-Latn-CM"}, "ria": {"value" : "ria-Latn-IN"}, "rif": {"value" : "rif-Tfng-MA"}, "nac": {"value" : "nac-Latn-ZZ"}, "naf": {"value" : "naf-Latn-ZZ"}, "nak": {"value" : "nak-Latn-ZZ"}, "nan": {"value" : "nan-Hans-CN"}, "aha": {"value" : "aha-Latn-ZZ"}, "nap": {"value" : "nap-Latn-IT"}, "naq": {"value" : "naq-Latn-NA"}, "zza": {"value" : "zza-Latn-TR"}, "nas": {"value" : "nas-Latn-ZZ"}, "ahl": {"value" : "ahl-Latn-ZZ"}, "en-Shaw":
        {"value" : "en-Shaw-GB"}, "und-Copt": {"value" : "cop-Copt-EG"}, "aho": {"value" : "aho-Ahom-IN"}, "vro": {"value" : "vro-Latn-EE"}, "rjs": {"value" : "rjs-Deva-NP"}, "nca": {"value" : "nca-Latn-ZZ"}, "ncf": {"value" : "ncf-Latn-ZZ"}, "nce": {"value" : "nce-Latn-ZZ"}, "nch": {"value" : "nch-Latn-MX"}, "izh": {"value" : "izh-Latn-RU"}, "izi": {"value" : "izi-Latn-ZZ"}, "rkt": {"value" : "rkt-Beng-BD"}, "nco": {"value" : "nco-Latn-ZZ"}, "eri": {"value" : "eri-Latn-ZZ"}, "ajg": {"value" : "ajg-Latn-ZZ"}, "ncu":
        {"value" : "ncu-Latn-ZZ"}, "ndc": {"value" : "ndc-Latn-MZ"}, "esg": {"value" : "esg-Gonm-IN"}, "nds": {"value" : "nds-Latn-DE"}, "akk": {"value" : "akk-Xsux-IQ"}, "esu": {"value" : "esu-Latn-US"}, "neb": {"value" : "neb-Latn-ZZ"}, "rmf": {"value" : "rmf-Latn-FI"}, "und-061": {"value" : "sm-Latn-WS"}, "und-Limb": {"value" : "lif-Limb-IN"}, "vun": {"value" : "vun-Latn-TZ"}, "ff-Adlm": {"value" : "ff-Adlm-GN"}, "vut": {"value" : "vut-Latn-ZZ"}, "rmo": {"value" : "rmo-Latn-CH"}, "ala": {"value" : "ala-Latn-ZZ"}
        , "rmt": {"value" : "rmt-Arab-IR"}, "rmu": {"value" : "rmu-Latn-SE"}, "ali": {"value" : "ali-Latn-ZZ"}, "nex": {"value" : "nex-Latn-ZZ"}, "new": {"value" : "new-Deva-NP"}, "aln": {"value" : "aln-Latn-XK"}, "etr": {"value" : "etr-Latn-ZZ"}, "und-Rohg": {"value" : "rhg-Rohg-MM"}, "ett": {"value" : "ett-Ital-IT"}, "rna": {"value" : "rna-Latn-ZZ"}, "etu": {"value" : "etu-Latn-ZZ"}, "alt": {"value" : "alt-Cyrl-RU"}, "etx": {"value" : "etx-Latn-ZZ"}, "rng": {"value" : "rng-Latn-MZ"}, "und-Linb": {"value" : "grc-Linb-GR"}
        , "und-Lina": {"value" : "lab-Lina-GR"}, "und-Jpan": {"value" : "ja-Jpan-JP"}, "man-GN": {"value" : "man-Nkoo-GN"}, "nfr": {"value" : "nfr-Latn-ZZ"}, "amm": {"value" : "amm-Latn-ZZ"}, "und-Arab": {"value" : "ar-Arab-EG"}, "amo": {"value" : "amo-Latn-NG"}, "amn": {"value" : "amn-Latn-ZZ"}, "rob": {"value" : "rob-Latn-ID"}, "amp": {"value" : "amp-Latn-ZZ"}, "ngb": {"value" : "ngb-Latn-ZZ"}, "rof": {"value" : "rof-Latn-TZ"}, "nga": {"value" : "nga-Latn-ZZ"}, "ngl": {"value" : "ngl-Latn-MZ"}, "roo": {"value"
        : "roo-Latn-ZZ"}, "anc": {"value" : "anc-Latn-ZZ"}, "ank": {"value" : "ank-Latn-ZZ"}, "ann": {"value" : "ann-Latn-ZZ"}, "und-Bhks": {"value" : "sa-Bhks-IN"}, "nhb": {"value" : "nhb-Latn-ZZ"}, "nhe": {"value" : "nhe-Latn-MX"}, "any": {"value" : "any-Latn-ZZ"}, "und-Orya": {"value" : "or-Orya-IN"}, "ewo": {"value" : "ewo-Latn-CM"}, "nhw": {"value" : "nhw-Latn-MX"}, "aoj": {"value" : "aoj-Latn-ZZ"}, "aom": {"value" : "aom-Latn-ZZ"}, "zh-Hanb": {"value" : "zh-Hanb-TW"}, "und-Kits": {"value" : "zkt-Kits-CN"}
        , "jab": {"value" : "jab-Latn-ZZ"}, "nif": {"value" : "nif-Latn-ZZ"}, "aoz": {"value" : "aoz-Latn-ID"}, "nij": {"value" : "nij-Latn-ID"}, "nii": {"value" : "nii-Latn-ZZ"}, "zh-PH": {"value" : "zh-Hant-PH"}, "nin": {"value" : "nin-Latn-ZZ"}, "zh-Hant": {"value" : "zh-Hant-TW"}, "zh-PF": {"value" : "zh-Hant-PF"}, "und-Ahom": {"value" : "aho-Ahom-IN"}, "apd": {"value" : "apd-Arab-TG"}, "apc": {"value" : "apc-Arab-ZZ"}, "ape": {"value" : "ape-Latn-ZZ"}, "jam": {"value" : "jam-Latn-JM"}, "zh-PA": {"value" : "zh-Hant-PA"}
        , "niu": {"value" : "niu-Latn-NU"}, "niz": {"value" : "niz-Latn-ZZ"}, "niy": {"value" : "niy-Latn-ZZ"}, "ext": {"value" : "ext-Latn-ES"}, "apr": {"value" : "apr-Latn-ZZ"}, "aps": {"value" : "aps-Latn-ZZ"}, "apz": {"value" : "apz-Latn-ZZ"}, "rro": {"value" : "rro-Latn-ZZ"}, "njo": {"value" : "njo-Latn-IN"}, "jbo": {"value" : "jbo-Latn-001"}, "jbu": {"value" : "jbu-Latn-ZZ"}, "zh-MO": {"value" : "zh-Hant-MO"}, "nkg": {"value" : "nkg-Latn-ZZ"}, "zh-MY": {"value" : "zh-Hant-MY"}, "arc": {"value" : "arc-Armi-IR"}
        , "nko": {"value" : "nko-Latn-ZZ"}, "arh": {"value" : "arh-Latn-ZZ"}, "pa-Arab": {"value" : "pa-Arab-PK"}, "und-Mtei": {"value" : "mni-Mtei-IN"}, "arn": {"value" : "arn-Latn-CL"}, "aro": {"value" : "aro-Latn-BO"}, "und-Cyrl-RO": {"value" : "bg-Cyrl-RO"}, "arq": {"value" : "arq-Arab-DZ"}, "ars": {"value" : "ars-Arab-SA"}, "arz": {"value" : "arz-Arab-EG"}, "ary": {"value" : "ary-Arab-MA"}, "rtm": {"value" : "rtm-Latn-FJ"}, "asa": {"value" : "asa-Latn-TZ"}, "und-Grek-TR": {"value" : "bgx-Grek-TR"}, "ase": {"value"
        : "ase-Sgnw-US"}, "asg": {"value" : "asg-Latn-ZZ"}, "aso": {"value" : "aso-Latn-ZZ"}, "ast": {"value" : "ast-Latn-ES"}, "rue": {"value" : "rue-Cyrl-UA"}, "rug": {"value" : "rug-Latn-SB"}, "nmg": {"value" : "nmg-Latn-CM"}, "ata": {"value" : "ata-Latn-ZZ"}, "jen": {"value" : "jen-Latn-ZZ"}, "atg": {"value" : "atg-Latn-ZZ"}, "atj": {"value" : "atj-Latn-CA"}, "nmz": {"value" : "nmz-Latn-ZZ"}, "unr-Deva": {"value" : "unr-Deva-NP"}, "nnf": {"value" : "nnf-Latn-ZZ"}, "nnh": {"value" : "nnh-Latn-CM"}, "nnk": {"value"
        : "nnk-Latn-ZZ"}, "nnm": {"value" : "nnm-Latn-ZZ"}, "nnp": {"value" : "nnp-Wcho-IN"}, "az-IR": {"value" : "az-Arab-IR"}, "und-Adlm": {"value" : "ff-Adlm-GN"}, "az-IQ": {"value" : "az-Arab-IQ"}, "und-Nbat": {"value" : "arc-Nbat-JO"}, "sd-Khoj": {"value" : "sd-Khoj-IN"}, "nod": {"value" : "nod-Lana-TH"}, "auy": {"value" : "auy-Latn-ZZ"}, "noe": {"value" : "noe-Deva-IN"}, "rwk": {"value" : "rwk-Latn-TZ"}, "und-Cyrl-MD": {"value" : "uk-Cyrl-MD"}, "rwo": {"value" : "rwo-Latn-ZZ"}, "non": {"value" : "non-Runr-SE"}
        , "nop": {"value" : "nop-Latn-ZZ"}, "jgk": {"value" : "jgk-Latn-ZZ"}, "jgo": {"value" : "jgo-Latn-CM"}, "und-Vaii": {"value" : "vai-Vaii-LR"}, "nou": {"value" : "nou-Latn-ZZ"}, "avl": {"value" : "avl-Arab-ZZ"}, "avn": {"value" : "avn-Latn-ZZ"}, "wae": {"value" : "wae-Latn-CH"}, "avt": {"value" : "avt-Latn-ZZ"}, "avu": {"value" : "avu-Latn-ZZ"}, "waj": {"value" : "waj-Latn-ZZ"}, "wal": {"value" : "wal-Ethi-ET"}, "wan": {"value" : "wan-Latn-ZZ"}, "zh-HK": {"value" : "zh-Hant-HK"}, "war": {"value" : "war-Latn-PH"}
        , "awa": {"value" : "awa-Deva-IN"}, "und-Plrd": {"value" : "hmd-Plrd-CN"}, "awb": {"value" : "awb-Latn-ZZ"}, "awo": {"value" : "awo-Latn-ZZ"}, "und-Knda": {"value" : "kn-Knda-IN"}, "zh-ID": {"value" : "zh-Hant-ID"}, "jib": {"value" : "jib-Latn-ZZ"}, "awx": {"value" : "awx-Latn-ZZ"}, "wbp": {"value" : "wbp-Latn-AU"}, "und-Sidd": {"value" : "sa-Sidd-IN"}, "fab": {"value" : "fab-Latn-ZZ"}, "wbr": {"value" : "wbr-Deva-IN"}, "faa": {"value" : "faa-Latn-ZZ"}, "wbq": {"value" : "wbq-Telu-IN"}, "und-Kali": {"value"
        : "eky-Kali-MM"}, "fag": {"value" : "fag-Latn-ZZ"}, "nqo": {"value" : "nqo-Nkoo-GN"}, "fai": {"value" : "fai-Latn-ZZ"}, "ryu": {"value" : "ryu-Kana-JP"}, "fan": {"value" : "fan-Latn-GQ"}, "wci": {"value" : "wci-Latn-ZZ"}, "nrb": {"value" : "nrb-Latn-ZZ"}, "und-Phlp": {"value" : "pal-Phlp-CN"}, "ayb": {"value" : "ayb-Latn-ZZ"}, "und-Phli": {"value" : "pal-Phli-IR"}, "cu-Glag": {"value" : "cu-Glag-BG"}, "und-Cyrl-XK": {"value" : "sr-Cyrl-XK"}, "az-Arab": {"value" : "az-Arab-IR"}, "ks-Deva": {"value" : "ks-Deva-IN"}
        , "und-Thai": {"value" : "th-Thai-TH"}, "nsk": {"value" : "nsk-Cans-CA"}, "nsn": {"value" : "nsn-Latn-ZZ"}, "nso": {"value" : "nso-Latn-ZA"}, "und-Thaa": {"value" : "dv-Thaa-MV"}, "und-Nshu": {"value" : "zhx-Nshu-CN"}, "nss": {"value" : "nss-Latn-ZZ"}, "zh-VN": {"value" : "zh-Hant-VN"}, "und-Hmnp": {"value" : "mww-Hmnp-US"}, "und-Kana": {"value" : "ja-Kana-JP"}, "und-Hmng": {"value" : "hnj-Hmng-LA"}, "wer": {"value" : "wer-Latn-ZZ"}, "zh-TW": {"value" : "zh-Hant-TW"}, "ntm": {"value" : "ntm-Latn-ZZ"}, "ntr":
        {"value" : "ntr-Latn-ZZ"}, "zh-US": {"value" : "zh-Hant-US"}, "und-Xpeo": {"value" : "peo-Xpeo-IR"}, "jmc": {"value" : "jmc-Latn-TZ"}, "nui": {"value" : "nui-Latn-ZZ"}, "jml": {"value" : "jml-Deva-NP"}, "nup": {"value" : "nup-Latn-ZZ"}, "und-Cyrl-SK": {"value" : "uk-Cyrl-SK"}, "nus": {"value" : "nus-Latn-SS"}, "nuv": {"value" : "nuv-Latn-ZZ"}, "nux": {"value" : "nux-Latn-ZZ"}, "zh-TH": {"value" : "zh-Hant-TH"}, "wgi": {"value" : "wgi-Latn-ZZ"}, "und-Phnx": {"value" : "phn-Phnx-LB"}, "und-Cyrl-TR": {"value"
        : "kbd-Cyrl-TR"}, "ffi": {"value" : "ffi-Latn-ZZ"}, "und-Elym": {"value" : "arc-Elym-IR"}, "ffm": {"value" : "ffm-Latn-ML"}, "und-Rjng": {"value" : "rej-Rjng-ID"}, "whg": {"value" : "whg-Latn-ZZ"}, "nwb": {"value" : "nwb-Latn-ZZ"}, "zh-SR": {"value" : "zh-Hant-SR"}, "wib": {"value" : "wib-Latn-ZZ"}, "und-Hebr": {"value" : "he-Hebr-IL"}, "saf": {"value" : "saf-Latn-GH"}, "sah": {"value" : "sah-Cyrl-RU"}, "saq": {"value" : "saq-Latn-KE"}, "wiu": {"value" : "wiu-Latn-ZZ"}, "sas": {"value" : "sas-Latn-ID"},
        "wiv": {"value" : "wiv-Latn-ZZ"}, "nxq": {"value" : "nxq-Latn-CN"}, "sat": {"value" : "sat-Olck-IN"}, "nxr": {"value" : "nxr-Latn-ZZ"}, "sav": {"value" : "sav-Latn-SN"}, "saz": {"value" : "saz-Saur-IN"}, "wja": {"value" : "wja-Latn-ZZ"}, "sba": {"value" : "sba-Latn-ZZ"}, "sbe": {"value" : "sbe-Latn-ZZ"}, "wji": {"value" : "wji-Latn-ZZ"}, "mn-Mong": {"value" : "mn-Mong-CN"}, "und-419": {"value" : "es-Latn-419"}, "fia": {"value" : "fia-Arab-SD"}, "sbp": {"value" : "sbp-Latn-TZ"}, "und-NO": {"value" : "nb-Latn-NO"}
        , "nyn": {"value" : "nyn-Latn-UG"}, "nym": {"value" : "nym-Latn-TZ"}, "und-NL": {"value" : "nl-Latn-NL"}, "und-NP": {"value" : "ne-Deva-NP"}, "fil": {"value" : "fil-Latn-PH"}, "bal": {"value" : "bal-Arab-PK"}, "ban": {"value" : "ban-Latn-ID"}, "bap": {"value" : "bap-Deva-NP"}, "fit": {"value" : "fit-Latn-SE"}, "bar": {"value" : "bar-Latn-AT"}, "bas": {"value" : "bas-Latn-CM"}, "bav": {"value" : "bav-Latn-ZZ"}, "bax": {"value" : "bax-Bamu-CM"}, "jra": {"value" : "jra-Latn-ZZ"}, "sck": {"value" : "sck-Deva-IN"}
        , "nzi": {"value" : "nzi-Latn-GH"}, "scl": {"value" : "scl-Arab-ZZ"}, "sco": {"value" : "sco-Latn-GB"}, "scn": {"value" : "scn-Latn-IT"}, "aa": {"value" : "aa-Latn-ET"}, "bba": {"value" : "bba-Latn-ZZ"}, "und-MN": {"value" : "mn-Cyrl-MN"}, "ab": {"value" : "ab-Cyrl-GE"}, "und-MM": {"value" : "my-Mymr-MM"}, "und-Osma": {"value" : "so-Osma-SO"}, "bbc": {"value" : "bbc-Latn-ID"}, "scs": {"value" : "scs-Latn-CA"}, "und-ML": {"value" : "bm-Latn-ML"}, "bbb": {"value" : "bbb-Latn-ZZ"}, "und-MK": {"value" : "mk-Cyrl-MK"}
        , "ae": {"value" : "ae-Avst-IR"}, "und-MR": {"value" : "ar-Arab-MR"}, "af": {"value" : "af-Latn-ZA"}, "bbd": {"value" : "bbd-Latn-ZZ"}, "und-MQ": {"value" : "fr-Latn-MQ"}, "und-Wara": {"value" : "hoc-Wara-IN"}, "und-MO": {"value" : "zh-Hant-MO"}, "und-MV": {"value" : "dv-Thaa-MV"}, "und-MU": {"value" : "mfe-Latn-MU"}, "ak": {"value" : "ak-Latn-GH"}, "und-MT": {"value" : "mt-Latn-MT"}, "bbj": {"value" : "bbj-Latn-CM"}, "am": {"value" : "am-Ethi-ET"}, "und-MZ": {"value" : "pt-Latn-MZ"}, "an": {"value" : "an-Latn-ES"}
        , "und-MY": {"value" : "ms-Latn-MY"}, "und-MX": {"value" : "es-Latn-MX"}, "ar": {"value" : "ar-Arab-EG"}, "bbp": {"value" : "bbp-Latn-ZZ"}, "as": {"value" : "as-Beng-IN"}, "bbr": {"value" : "bbr-Latn-ZZ"}, "sdc": {"value" : "sdc-Latn-IT"}, "und-NC": {"value" : "fr-Latn-NC"}, "av": {"value" : "av-Cyrl-RU"}, "sdh": {"value" : "sdh-Arab-IR"}, "und-NA": {"value" : "af-Latn-NA"}, "ay": {"value" : "ay-Latn-BO"}, "az": {"value" : "az-Latn-AZ"}, "und-NE": {"value" : "ha-Latn-NE"}, "und-NI": {"value" : "es-Latn-NI"}
        , "ba": {"value" : "ba-Cyrl-RU"}, "wls": {"value" : "wls-Latn-WF"}, "und-Kore": {"value" : "ko-Kore-KR"}, "und-LK": {"value" : "si-Sinh-LK"}, "be": {"value" : "be-Cyrl-BY"}, "bcf": {"value" : "bcf-Latn-ZZ"}, "bg": {"value" : "bg-Cyrl-BG"}, "bch": {"value" : "bch-Latn-ZZ"}, "bi": {"value" : "bi-Latn-VU"}, "und-LU": {"value" : "fr-Latn-LU"}, "bci": {"value" : "bci-Latn-CI"}, "und-LT": {"value" : "lt-Latn-LT"}, "und-LS": {"value" : "st-Latn-LS"}, "bm": {"value" : "bm-Latn-ML"}, "bcn": {"value" : "bcn-Latn-ZZ"}
        , "bn": {"value" : "bn-Beng-BD"}, "und-LY": {"value" : "ar-Arab-LY"}, "bcm": {"value" : "bcm-Latn-ZZ"}, "bo": {"value" : "bo-Tibt-CN"}, "bco": {"value" : "bco-Latn-ZZ"}, "und-LV": {"value" : "lv-Latn-LV"}, "br": {"value" : "br-Latn-FR"}, "bcq": {"value" : "bcq-Ethi-ZZ"}, "bs": {"value" : "bs-Latn-BA"}, "bcu": {"value" : "bcu-Latn-ZZ"}, "sef": {"value" : "sef-Latn-CI"}, "und-MA": {"value" : "ar-Arab-MA"}, "sei": {"value" : "sei-Latn-MX"}, "seh": {"value" : "seh-Latn-MZ"}, "und-MF": {"value" : "fr-Latn-MF"}
        , "wmo": {"value" : "wmo-Latn-ZZ"}, "und-ME": {"value" : "sr-Latn-ME"}, "und-MD": {"value" : "ro-Latn-MD"}, "und-MC": {"value" : "fr-Latn-MC"}, "ca": {"value" : "ca-Latn-ES"}, "und-MG": {"value" : "mg-Latn-MG"}, "ses": {"value" : "ses-Latn-ML"}, "ce": {"value" : "ce-Cyrl-RU"}, "und-Cyrl-BA": {"value" : "sr-Cyrl-BA"}, "bdd": {"value" : "bdd-Latn-ZZ"}, "und-KP": {"value" : "ko-Kore-KP"}, "ch": {"value" : "ch-Latn-GU"}, "und-KM": {"value" : "ar-Arab-KM"}, "und-KR": {"value" : "ko-Kore-KR"}, "co": {"value" :
        "co-Latn-FR"}, "flr": {"value" : "flr-Latn-ZZ"}, "und-KW": {"value" : "ar-Arab-KW"}, "wnc": {"value" : "wnc-Latn-ZZ"}, "und-Dogr": {"value" : "doi-Dogr-IN"}, "cr": {"value" : "cr-Cans-CA"}, "cs": {"value" : "cs-Latn-CZ"}, "cu": {"value" : "cu-Cyrl-RU"}, "und-KZ": {"value" : "ru-Cyrl-KZ"}, "cv": {"value" : "cv-Cyrl-RU"}, "wni": {"value" : "wni-Arab-KM"}, "und-LA": {"value" : "lo-Laoo-LA"}, "cy": {"value" : "cy-Latn-GB"}, "und-LB": {"value" : "ar-Arab-LB"}, "und-LI": {"value" : "de-Latn-LI"}, "da": {"value"
        : "da-Latn-DK"}, "und-Cyrl-AL": {"value" : "mk-Cyrl-AL"}, "wnu": {"value" : "wnu-Latn-ZZ"}, "de": {"value" : "de-Latn-DE"}, "bef": {"value" : "bef-Latn-ZZ"}, "beh": {"value" : "beh-Latn-ZZ"}, "und-JO": {"value" : "ar-Arab-JO"}, "bej": {"value" : "bej-Arab-SD"}, "fmp": {"value" : "fmp-Latn-ZZ"}, "jut": {"value" : "jut-Latn-DK"}, "bem": {"value" : "bem-Latn-ZM"}, "und-JP": {"value" : "ja-Jpan-JP"}, "wob": {"value" : "wob-Latn-ZZ"}, "sga": {"value" : "sga-Ogam-IE"}, "bet": {"value" : "bet-Latn-ZZ"}, "dv": {"value"
        : "dv-Thaa-MV"}, "bex": {"value" : "bex-Latn-ZZ"}, "bew": {"value" : "bew-Latn-ID"}, "bez": {"value" : "bez-Latn-TZ"}, "dz": {"value" : "dz-Tibt-BT"}, "ms-ID": {"value" : "ms-Latn-ID"}, "wos": {"value" : "wos-Latn-ZZ"}, "und-KH": {"value" : "km-Khmr-KH"}, "und-KG": {"value" : "ky-Cyrl-KG"}, "sgs": {"value" : "sgs-Latn-LT"}, "und-KE": {"value" : "sw-Latn-KE"}, "ee": {"value" : "ee-Latn-GH"}, "bfd": {"value" : "bfd-Latn-CM"}, "sgw": {"value" : "sgw-Ethi-ZZ"}, "und-IN": {"value" : "hi-Deva-IN"}, "und-IL": {"value"
        : "he-Hebr-IL"}, "el": {"value" : "el-Grek-GR"}, "sgz": {"value" : "sgz-Latn-ZZ"}, "und-IR": {"value" : "fa-Arab-IR"}, "en": {"value" : "en-Latn-US"}, "und-IQ": {"value" : "ar-Arab-IQ"}, "und-Perm": {"value" : "kv-Perm-RU"}, "eo": {"value" : "eo-Latn-001"}, "bfq": {"value" : "bfq-Taml-IN"}, "es": {"value" : "es-Latn-ES"}, "und-IT": {"value" : "it-Latn-IT"}, "et": {"value" : "et-Latn-EE"}, "und-IS": {"value" : "is-Latn-IS"}, "eu": {"value" : "eu-Latn-ES"}, "bft": {"value" : "bft-Arab-PK"}, "bfy": {"value"
        : "bfy-Deva-IN"}, "shi": {"value" : "shi-Tfng-MA"}, "shk": {"value" : "shk-Latn-ZZ"}, "shn": {"value" : "shn-Mymr-MM"}, "fod": {"value" : "fod-Latn-ZZ"}, "fa": {"value" : "fa-Arab-IR"}, "bgc": {"value" : "bgc-Deva-IN"}, "ff": {"value" : "ff-Latn-SN"}, "shu": {"value" : "shu-Arab-ZZ"}, "fi": {"value" : "fi-Latn-FI"}, "fj": {"value" : "fj-Latn-FJ"}, "fon": {"value" : "fon-Latn-BJ"}, "und-HM": {"value" : "und-Latn-HM"}, "und-HK": {"value" : "zh-Hant-HK"}, "bgn": {"value" : "bgn-Arab-PK"}, "for": {"value" :
        "for-Latn-ZZ"}, "fo": {"value" : "fo-Latn-FO"}, "und-HN": {"value" : "es-Latn-HN"}, "fr": {"value" : "fr-Latn-FR"}, "und-HU": {"value" : "hu-Latn-HU"}, "und-HT": {"value" : "ht-Latn-HT"}, "ku-Arab": {"value" : "ku-Arab-IQ"}, "sid": {"value" : "sid-Latn-ET"}, "und-HR": {"value" : "hr-Latn-HR"}, "sig": {"value" : "sig-Latn-ZZ"}, "bgx": {"value" : "bgx-Grek-TR"}, "fy": {"value" : "fy-Latn-NL"}, "sim": {"value" : "sim-Latn-ZZ"}, "sil": {"value" : "sil-Latn-ZZ"}, "fpe": {"value" : "fpe-Latn-ZZ"}, "ga": {"value"
        : "ga-Latn-IE"}, "bhb": {"value" : "bhb-Deva-IN"}, "gd": {"value" : "gd-Latn-GB"}, "und-ID": {"value" : "id-Latn-ID"}, "und-IC": {"value" : "es-Latn-IC"}, "bhg": {"value" : "bhg-Latn-ZZ"}, "und-GH": {"value" : "ak-Latn-GH"}, "bhi": {"value" : "bhi-Deva-IN"}, "und-GF": {"value" : "fr-Latn-GF"}, "und-GE": {"value" : "ka-Geor-GE"}, "und-GL": {"value" : "kl-Latn-GL"}, "gl": {"value" : "gl-Latn-ES"}, "bhl": {"value" : "bhl-Latn-ZZ"}, "gn": {"value" : "gn-Latn-PY"}, "bho": {"value" : "bho-Deva-IN"}, "und-GP":
        {"value" : "fr-Latn-GP"}, "und-GN": {"value" : "fr-Latn-GN"}, "und-GT": {"value" : "es-Latn-GT"}, "und-GS": {"value" : "und-Latn-GS"}, "gu": {"value" : "gu-Gujr-IN"}, "und-GR": {"value" : "el-Grek-GR"}, "gv": {"value" : "gv-Latn-IM"}, "und-GQ": {"value" : "es-Latn-GQ"}, "und-Palm": {"value" : "arc-Palm-SY"}, "und-GW": {"value" : "pt-Latn-GW"}, "bhy": {"value" : "bhy-Latn-ZZ"}, "ha": {"value" : "ha-Latn-NG"}, "wrs": {"value" : "wrs-Latn-ZZ"}, "bib": {"value" : "bib-Latn-ZZ"}, "sjr": {"value" : "sjr-Latn-ZZ"}
        , "he": {"value" : "he-Hebr-IL"}, "big": {"value" : "big-Latn-ZZ"}, "hi": {"value" : "hi-Deva-IN"}, "und-Cyrl-GE": {"value" : "ab-Cyrl-GE"}, "bik": {"value" : "bik-Latn-PH"}, "bin": {"value" : "bin-Latn-NG"}, "und-Cham": {"value" : "cjm-Cham-VN"}, "und-FI": {"value" : "fi-Latn-FI"}, "bim": {"value" : "bim-Latn-ZZ"}, "ho": {"value" : "ho-Latn-PG"}, "tg-PK": {"value" : "tg-Arab-PK"}, "und-FO": {"value" : "fo-Latn-FO"}, "bio": {"value" : "bio-Latn-ZZ"}, "fqs": {"value" : "fqs-Latn-ZZ"}, "hr": {"value" : "hr-Latn-HR"}
        , "skc": {"value" : "skc-Latn-ZZ"}, "wsg": {"value" : "wsg-Gong-IN"}, "biq": {"value" : "biq-Latn-ZZ"}, "ht": {"value" : "ht-Latn-HT"}, "hu": {"value" : "hu-Latn-HU"}, "und-FR": {"value" : "fr-Latn-FR"}, "wsk": {"value" : "wsk-Latn-ZZ"}, "hy": {"value" : "hy-Armn-AM"}, "hz": {"value" : "hz-Latn-NA"}, "frc": {"value" : "frc-Latn-US"}, "ia": {"value" : "ia-Latn-001"}, "sks": {"value" : "sks-Latn-ZZ"}, "id": {"value" : "id-Latn-ID"}, "skr": {"value" : "skr-Arab-PK"}, "ig": {"value" : "ig-Latn-NG"}, "und-GA":
        {"value" : "fr-Latn-GA"}, "bji": {"value" : "bji-Ethi-ZZ"}, "ii": {"value" : "ii-Yiii-CN"}, "bjh": {"value" : "bjh-Latn-ZZ"}, "und-EE": {"value" : "et-Latn-EE"}, "ik": {"value" : "ik-Latn-US"}, "bjj": {"value" : "bjj-Deva-IN"}, "und-EC": {"value" : "es-Latn-EC"}, "und-Cprt": {"value" : "grc-Cprt-CY"}, "frp": {"value" : "frp-Latn-FR"}, "in": {"value" : "in-Latn-ID"}, "bjo": {"value" : "bjo-Latn-ZZ"}, "frs": {"value" : "frs-Latn-DE"}, "io": {"value" : "io-Latn-001"}, "und-EH": {"value" : "ar-Arab-EH"}, "bjn":
        {"value" : "bjn-Latn-ID"}, "frr": {"value" : "frr-Latn-DE"}, "und-EG": {"value" : "ar-Arab-EG"}, "is": {"value" : "is-Latn-IS"}, "sld": {"value" : "sld-Latn-ZZ"}, "bjr": {"value" : "bjr-Latn-ZZ"}, "it": {"value" : "it-Latn-IT"}, "iu": {"value" : "iu-Cans-CA"}, "und-ER": {"value" : "ti-Ethi-ER"}, "bjt": {"value" : "bjt-Latn-SN"}, "iw": {"value" : "iw-Hebr-IL"}, "und-Tirh": {"value" : "mai-Tirh-IN"}, "sli": {"value" : "sli-Latn-PL"}, "und-EU": {"value" : "en-Latn-GB"}, "wtm": {"value" : "wtm-Deva-IN"}, "sll":
        {"value" : "sll-Latn-ZZ"}, "und-ET": {"value" : "am-Ethi-ET"}, "bjz": {"value" : "bjz-Latn-ZZ"}, "und-ES": {"value" : "es-Latn-ES"}, "und-EZ": {"value" : "de-Latn-EZ"}, "ja": {"value" : "ja-Jpan-JP"}, "zh-GF": {"value" : "zh-Hant-GF"}, "bkc": {"value" : "bkc-Latn-ZZ"}, "zh-GB": {"value" : "zh-Hant-GB"}, "und-Cyrl-GR": {"value" : "mk-Cyrl-GR"}, "ji": {"value" : "ji-Hebr-UA"}, "und-DE": {"value" : "de-Latn-DE"}, "sly": {"value" : "sly-Latn-ID"}, "bkm": {"value" : "bkm-Latn-CM"}, "sma": {"value" : "sma-Latn-SE"}
        , "bkq": {"value" : "bkq-Latn-ZZ"}, "und-DK": {"value" : "da-Latn-DK"}, "und-DJ": {"value" : "aa-Latn-DJ"}, "bkv": {"value" : "bkv-Latn-ZZ"}, "jv": {"value" : "jv-Latn-ID"}, "bku": {"value" : "bku-Latn-PH"}, "jw": {"value" : "jw-Latn-ID"}, "und-DO": {"value" : "es-Latn-DO"}, "smj": {"value" : "smj-Latn-SE"}, "smn": {"value" : "smn-Latn-FI"}, "ka": {"value" : "ka-Geor-GE"}, "smq": {"value" : "smq-Latn-ZZ"}, "wuu": {"value" : "wuu-Hans-CN"}, "smp": {"value" : "smp-Samr-IL"}, "sms": {"value" : "sms-Latn-FI"}
        , "wuv": {"value" : "wuv-Latn-ZZ"}, "und-DZ": {"value" : "ar-Arab-DZ"}, "kg": {"value" : "kg-Latn-CD"}, "und-EA": {"value" : "es-Latn-EA"}, "ki": {"value" : "ki-Latn-KE"}, "kj": {"value" : "kj-Latn-NA"}, "kk": {"value" : "kk-Cyrl-KZ"}, "man-Nkoo": {"value" : "man-Nkoo-GN"}, "und-CD": {"value" : "sw-Latn-CD"}, "kl": {"value" : "kl-Latn-GL"}, "und-Telu": {"value" : "te-Telu-IN"}, "km": {"value" : "km-Khmr-KH"}, "kn": {"value" : "kn-Knda-IN"}, "ko": {"value" : "ko-Kore-KR"}, "und-CH": {"value" : "de-Latn-CH"}
        , "und-CG": {"value" : "fr-Latn-CG"}, "und-CF": {"value" : "fr-Latn-CF"}, "kr": {"value" : "kr-Latn-ZZ"}, "ks": {"value" : "ks-Arab-IN"}, "und-CL": {"value" : "es-Latn-CL"}, "snc": {"value" : "snc-Latn-ZZ"}, "ku": {"value" : "ku-Latn-TR"}, "blt": {"value" : "blt-Tavt-VN"}, "kv": {"value" : "kv-Cyrl-RU"}, "und-CI": {"value" : "fr-Latn-CI"}, "kw": {"value" : "kw-Latn-GB"}, "und-CP": {"value" : "und-Latn-CP"}, "und-CO": {"value" : "es-Latn-CO"}, "ky": {"value" : "ky-Cyrl-KG"}, "und-CN": {"value" : "zh-Hans-CN"}
        , "und-CM": {"value" : "fr-Latn-CM"}, "snk": {"value" : "snk-Latn-ML"}, "fub": {"value" : "fub-Arab-CM"}, "und-CR": {"value" : "es-Latn-CR"}, "fud": {"value" : "fud-Latn-WF"}, "snp": {"value" : "snp-Latn-ZZ"}, "la": {"value" : "la-Latn-VA"}, "und-CW": {"value" : "pap-Latn-CW"}, "fuf": {"value" : "fuf-Latn-GN"}, "lb": {"value" : "lb-Latn-LU"}, "und-CV": {"value" : "pt-Latn-CV"}, "fue": {"value" : "fue-Latn-ZZ"}, "und-CU": {"value" : "es-Latn-CU"}, "fuh": {"value" : "fuh-Latn-ZZ"}, "und-CZ": {"value" : "cs-Latn-CZ"}
        , "lg": {"value" : "lg-Latn-UG"}, "und-CY": {"value" : "el-Grek-CY"}, "bmh": {"value" : "bmh-Latn-ZZ"}, "snx": {"value" : "snx-Latn-ZZ"}, "li": {"value" : "li-Latn-NL"}, "sny": {"value" : "sny-Latn-ZZ"}, "wwa": {"value" : "wwa-Latn-ZZ"}, "bmk": {"value" : "bmk-Latn-ZZ"}, "und-Cher": {"value" : "chr-Cher-US"}, "fur": {"value" : "fur-Latn-IT"}, "ln": {"value" : "ln-Latn-CD"}, "und-BA": {"value" : "bs-Latn-BA"}, "fuq": {"value" : "fuq-Latn-NE"}, "lo": {"value" : "lo-Laoo-LA"}, "und-BG": {"value" : "bg-Cyrl-BG"}
        , "und-BF": {"value" : "fr-Latn-BF"}, "fuv": {"value" : "fuv-Latn-NG"}, "und-BE": {"value" : "nl-Latn-BE"}, "bmq": {"value" : "bmq-Latn-ML"}, "und-BD": {"value" : "bn-Beng-BD"}, "lt": {"value" : "lt-Latn-LT"}, "lu": {"value" : "lu-Latn-CD"}, "und-BJ": {"value" : "fr-Latn-BJ"}, "lv": {"value" : "lv-Latn-LV"}, "ogc": {"value" : "ogc-Latn-ZZ"}, "sog": {"value" : "sog-Sogd-UZ"}, "und-BI": {"value" : "rn-Latn-BI"}, "bmu": {"value" : "bmu-Latn-ZZ"}, "fuy": {"value" : "fuy-Latn-ZZ"}, "und-BH": {"value" : "ar-Arab-BH"}
        , "und-BO": {"value" : "es-Latn-BO"}, "und-BN": {"value" : "ms-Latn-BN"}, "sok": {"value" : "sok-Latn-ZZ"}, "und-BL": {"value" : "fr-Latn-BL"}, "und-BR": {"value" : "pt-Latn-BR"}, "und-BQ": {"value" : "pap-Latn-BQ"}, "soq": {"value" : "soq-Latn-ZZ"}, "und-BV": {"value" : "und-Latn-BV"}, "und-BT": {"value" : "dz-Tibt-BT"}, "sou": {"value" : "sou-Thai-TH"}, "bng": {"value" : "bng-Latn-ZZ"}, "mg": {"value" : "mg-Latn-MG"}, "und-BY": {"value" : "be-Cyrl-BY"}, "und-Glag": {"value" : "cu-Glag-BG"}, "mh": {"value"
        : "mh-Latn-MH"}, "mi": {"value" : "mi-Latn-NZ"}, "soy": {"value" : "soy-Latn-ZZ"}, "mk": {"value" : "mk-Cyrl-MK"}, "ml": {"value" : "ml-Mlym-IN"}, "bnm": {"value" : "bnm-Latn-ZZ"}, "mn": {"value" : "mn-Cyrl-MN"}, "mo": {"value" : "mo-Latn-RO"}, "und-Prti": {"value" : "xpr-Prti-IR"}, "fvr": {"value" : "fvr-Latn-SD"}, "und-AF": {"value" : "fa-Arab-AF"}, "bnp": {"value" : "bnp-Latn-ZZ"}, "mr": {"value" : "mr-Deva-IN"}, "und-AE": {"value" : "ar-Arab-AE"}, "ms": {"value" : "ms-Latn-MY"}, "spd": {"value" : "spd-Latn-ZZ"}
        , "und-AD": {"value" : "ca-Latn-AD"}, "mt": {"value" : "mt-Latn-MT"}, "my": {"value" : "my-Mymr-MM"}, "zh-BN": {"value" : "zh-Hant-BN"}, "und-AM": {"value" : "hy-Armn-AM"}, "spl": {"value" : "spl-Latn-ZZ"}, "und-AL": {"value" : "sq-Latn-AL"}, "und-AR": {"value" : "es-Latn-AR"}, "und-AQ": {"value" : "und-Latn-AQ"}, "na": {"value" : "na-Latn-NR"}, "und-AO": {"value" : "pt-Latn-AO"}, "nb": {"value" : "nb-Latn-NO"}, "nd": {"value" : "nd-Latn-ZW"}, "und-AT": {"value" : "de-Latn-AT"}, "ne": {"value" : "ne-Deva-NP"}
        , "sps": {"value" : "sps-Latn-ZZ"}, "und-AS": {"value" : "sm-Latn-AS"}, "und-AZ": {"value" : "az-Latn-AZ"}, "ng": {"value" : "ng-Latn-NA"}, "und-AX": {"value" : "sv-Latn-AX"}, "und-AW": {"value" : "nl-Latn-AW"}, "boj": {"value" : "boj-Latn-ZZ"}, "nl": {"value" : "nl-Latn-NL"}, "bon": {"value" : "bon-Latn-ZZ"}, "nn": {"value" : "nn-Latn-NO"}, "bom": {"value" : "bom-Latn-ZZ"}, "no": {"value" : "no-Latn-NO"}, "nr": {"value" : "nr-Latn-ZA"}, "arc-Nbat": {"value" : "arc-Nbat-JO"}, "und-Medf": {"value" : "mis-Medf-NG"}
        , "nv": {"value" : "nv-Latn-US"}, "kaa": {"value" : "kaa-Cyrl-UZ"}, "ny": {"value" : "ny-Latn-MW"}, "kac": {"value" : "kac-Latn-MM"}, "kab": {"value" : "kab-Latn-DZ"}, "kad": {"value" : "kad-Latn-ZZ"}, "kai": {"value" : "kai-Latn-ZZ"}, "oc": {"value" : "oc-Latn-FR"}, "zh-AU": {"value" : "zh-Hant-AU"}, "kaj": {"value" : "kaj-Latn-NG"}, "kam": {"value" : "kam-Latn-KE"}, "und-Tagb": {"value" : "tbw-Tagb-PH"}, "kao": {"value" : "kao-Latn-ML"}, "und-Ogam": {"value" : "sga-Ogam-IE"}, "om": {"value" : "om-Latn-ET"}
        , "srb": {"value" : "srb-Sora-IN"}, "or": {"value" : "or-Orya-IN"}, "tg-Arab": {"value" : "tg-Arab-PK"}, "os": {"value" : "os-Cyrl-GE"}, "und-Sogd": {"value" : "sog-Sogd-UZ"}, "bpy": {"value" : "bpy-Beng-IN"}, "kbd": {"value" : "kbd-Cyrl-RU"}, "srn": {"value" : "srn-Latn-SR"}, "pa": {"value" : "pa-Guru-IN"}, "srr": {"value" : "srr-Latn-SN"}, "bqc": {"value" : "bqc-Latn-ZZ"}, "und-Kthi": {"value" : "bho-Kthi-IN"}, "kbm": {"value" : "kbm-Latn-ZZ"}, "kbp": {"value" : "kbp-Latn-ZZ"}, "srx": {"value" : "srx-Deva-IN"}
        , "bqi": {"value" : "bqi-Arab-IR"}, "kbq": {"value" : "kbq-Latn-ZZ"}, "pl": {"value" : "pl-Latn-PL"}, "bqp": {"value" : "bqp-Latn-ZZ"}, "kbx": {"value" : "kbx-Latn-ZZ"}, "kby": {"value" : "kby-Arab-NE"}, "ps": {"value" : "ps-Arab-AF"}, "pt": {"value" : "pt-Latn-BR"}, "ssd": {"value" : "ssd-Latn-ZZ"}, "und-Nkoo": {"value" : "man-Nkoo-GN"}, "bqv": {"value" : "bqv-Latn-CI"}, "ssg": {"value" : "ssg-Latn-ZZ"}, "und-Mymr": {"value" : "my-Mymr-MM"}, "kcg": {"value" : "kcg-Latn-NG"}, "bra": {"value" : "bra-Deva-IN"}
        , "kck": {"value" : "kck-Latn-ZW"}, "kcl": {"value" : "kcl-Latn-ZZ"}, "okr": {"value" : "okr-Latn-ZZ"}, "ssy": {"value" : "ssy-Latn-ER"}, "brh": {"value" : "brh-Arab-PK"}, "okv": {"value" : "okv-Latn-ZZ"}, "kct": {"value" : "kct-Latn-ZZ"}, "und-Hani": {"value" : "zh-Hani-CN"}, "und-Bugi": {"value" : "bug-Bugi-ID"}, "und-Hang": {"value" : "ko-Hang-KR"}, "qu": {"value" : "qu-Latn-PE"}, "brx": {"value" : "brx-Deva-IN"}, "und-Samr": {"value" : "smp-Samr-IL"}, "brz": {"value" : "brz-Latn-ZZ"}, "stk": {"value"
        : "stk-Latn-ZZ"}, "und-Hano": {"value" : "hnn-Hano-PH"}, "kde": {"value" : "kde-Latn-TZ"}, "kdh": {"value" : "kdh-Arab-TG"}, "stq": {"value" : "stq-Latn-DE"}, "kdl": {"value" : "kdl-Latn-ZZ"}, "bsj": {"value" : "bsj-Latn-ZZ"}, "und-Hanb": {"value" : "zh-Hanb-TW"}, "kdt": {"value" : "kdt-Thai-TH"}, "rm": {"value" : "rm-Latn-CH"}, "rn": {"value" : "rn-Latn-BI"}, "ro": {"value" : "ro-Latn-RO"}, "sua": {"value" : "sua-Latn-ZZ"}, "und-Deva-BT": {"value" : "ne-Deva-BT"}, "bsq": {"value" : "bsq-Bass-LR"}, "bst":
        {"value" : "bst-Ethi-ZZ"}, "sue": {"value" : "sue-Latn-ZZ"}, "bss": {"value" : "bss-Latn-CM"}, "ru": {"value" : "ru-Cyrl-RU"}, "und-Buhd": {"value" : "bku-Buhd-PH"}, "rw": {"value" : "rw-Latn-RW"}, "kea": {"value" : "kea-Latn-CV"}, "suk": {"value" : "suk-Latn-TZ"}, "grc-Linb": {"value" : "grc-Linb-GR"}, "sa": {"value" : "sa-Deva-IN"}, "sc": {"value" : "sc-Latn-IT"}, "sus": {"value" : "sus-Latn-GN"}, "sd": {"value" : "sd-Arab-PK"}, "sur": {"value" : "sur-Latn-ZZ"}, "se": {"value" : "se-Latn-NO"}, "sg": {"value"
        : "sg-Latn-CF"}, "ken": {"value" : "ken-Latn-CM"}, "si": {"value" : "si-Sinh-LK"}, "und-Hant": {"value" : "zh-Hant-TW"}, "und-Hans": {"value" : "zh-Hans-CN"}, "sk": {"value" : "sk-Latn-SK"}, "sl": {"value" : "sl-Latn-SI"}, "sm": {"value" : "sm-Latn-WS"}, "sn": {"value" : "sn-Latn-ZW"}, "bto": {"value" : "bto-Latn-PH"}, "so": {"value" : "so-Latn-SO"}, "sq": {"value" : "sq-Latn-AL"}, "sr": {"value" : "sr-Cyrl-RS"}, "ss": {"value" : "ss-Latn-ZA"}, "kez": {"value" : "kez-Latn-ZZ"}, "st": {"value" : "st-Latn-ZA"}
        , "su": {"value" : "su-Latn-ID"}, "btt": {"value" : "btt-Latn-ZZ"}, "sv": {"value" : "sv-Latn-SE"}, "sw": {"value" : "sw-Latn-TZ"}, "btv": {"value" : "btv-Deva-PK"}, "ong": {"value" : "ong-Latn-ZZ"}, "ta": {"value" : "ta-Taml-IN"}, "onn": {"value" : "onn-Latn-ZZ"}, "bua": {"value" : "bua-Cyrl-RU"}, "bud": {"value" : "bud-Latn-ZZ"}, "buc": {"value" : "buc-Latn-YT"}, "te": {"value" : "te-Telu-IN"}, "tg": {"value" : "tg-Cyrl-TJ"}, "th": {"value" : "th-Thai-TH"}, "und-Gong": {"value" : "wsg-Gong-IN"}, "bug":
        {"value" : "bug-Latn-ID"}, "kfo": {"value" : "kfo-Latn-CI"}, "ons": {"value" : "ons-Latn-ZZ"}, "ti": {"value" : "ti-Ethi-ET"}, "kfr": {"value" : "kfr-Deva-IN"}, "tk": {"value" : "tk-Latn-TM"}, "tl": {"value" : "tl-Latn-PH"}, "und-Lisu": {"value" : "lis-Lisu-CN"}, "buk": {"value" : "buk-Latn-ZZ"}, "tn": {"value" : "tn-Latn-ZA"}, "bum": {"value" : "bum-Latn-CM"}, "to": {"value" : "to-Latn-TO"}, "buo": {"value" : "buo-Latn-ZZ"}, "swc": {"value" : "swc-Latn-CD"}, "tr": {"value" : "tr-Latn-TR"}, "und-Gonm": {"value"
        : "esg-Gonm-IN"}, "kfy": {"value" : "kfy-Deva-IN"}, "swb": {"value" : "swb-Arab-YT"}, "ts": {"value" : "ts-Latn-ZA"}, "tt": {"value" : "tt-Cyrl-RU"}, "bus": {"value" : "bus-Latn-ZZ"}, "swg": {"value" : "swg-Latn-DE"}, "buu": {"value" : "buu-Latn-ZZ"}, "ty": {"value" : "ty-Latn-PF"}, "kge": {"value" : "kge-Latn-ID"}, "kgf": {"value" : "kgf-Latn-ZZ"}, "swp": {"value" : "swp-Latn-ZZ"}, "bvb": {"value" : "bvb-Latn-GQ"}, "ug": {"value" : "ug-Arab-CN"}, "swv": {"value" : "swv-Deva-IN"}, "kgp": {"value" : "kgp-Latn-BR"}
        , "uk": {"value" : "uk-Cyrl-UA"}, "ur": {"value" : "ur-Arab-PK"}, "kk-IR": {"value" : "kk-Arab-IR"}, "khb": {"value" : "khb-Talu-CN"}, "kha": {"value" : "kha-Latn-IN"}, "uz": {"value" : "uz-Latn-UZ"}, "sxn": {"value" : "sxn-Latn-ID"}, "xav": {"value" : "xav-Latn-BR"}, "opm": {"value" : "opm-Latn-ZZ"}, "bwd": {"value" : "bwd-Latn-ZZ"}, "und-Mlym": {"value" : "ml-Mlym-IN"}, "ve": {"value" : "ve-Latn-ZA"}, "khn": {"value" : "khn-Deva-IN"}, "sxw": {"value" : "sxw-Latn-ZZ"}, "vi": {"value" : "vi-Latn-VN"}, "khq":
        {"value" : "khq-Latn-ML"}, "kht": {"value" : "kht-Mymr-IN"}, "khs": {"value" : "khs-Latn-ZZ"}, "vo": {"value" : "vo-Latn-001"}, "khw": {"value" : "khw-Arab-PK"}, "bwr": {"value" : "bwr-Latn-ZZ"}, "khz": {"value" : "khz-Latn-ZZ"}, "und-ZW": {"value" : "sn-Latn-ZW"}, "xbi": {"value" : "xbi-Latn-ZZ"}, "gaa": {"value" : "gaa-Latn-GH"}, "syl": {"value" : "syl-Beng-BD"}, "wa": {"value" : "wa-Latn-BE"}, "gag": {"value" : "gag-Latn-MD"}, "gaf": {"value" : "gaf-Latn-ZZ"}, "kij": {"value" : "kij-Latn-ZZ"}, "syr":
        {"value" : "syr-Syrc-IQ"}, "und-YE": {"value" : "ar-Arab-YE"}, "gah": {"value" : "gah-Latn-ZZ"}, "gaj": {"value" : "gaj-Latn-ZZ"}, "gam": {"value" : "gam-Latn-ZZ"}, "bxh": {"value" : "bxh-Latn-ZZ"}, "gan": {"value" : "gan-Hans-CN"}, "kiu": {"value" : "kiu-Latn-TR"}, "kiw": {"value" : "kiw-Latn-ZZ"}, "wo": {"value" : "wo-Latn-SN"}, "gaw": {"value" : "gaw-Latn-ZZ"}, "und-Sarb": {"value" : "xsa-Sarb-YE"}, "gay": {"value" : "gay-Latn-ID"}, "und-YT": {"value" : "fr-Latn-YT"}, "kjd": {"value" : "kjd-Latn-ZZ"}
        , "szl": {"value" : "szl-Latn-PL"}, "xco": {"value" : "xco-Chrs-UZ"}, "xcr": {"value" : "xcr-Cari-TR"}, "gba": {"value" : "gba-Latn-ZZ"}, "und-Mult": {"value" : "skr-Mult-PK"}, "kjg": {"value" : "kjg-Laoo-LA"}, "gbf": {"value" : "gbf-Latn-ZZ"}, "oro": {"value" : "oro-Latn-ZZ"}, "und-Hatr": {"value" : "mis-Hatr-IQ"}, "bye": {"value" : "bye-Latn-ZZ"}, "xh": {"value" : "xh-Latn-ZA"}, "gbm": {"value" : "gbm-Deva-IN"}, "oru": {"value" : "oru-Arab-ZZ"}, "kjs": {"value" : "kjs-Latn-ZZ"}, "byn": {"value" : "byn-Ethi-ER"}
        , "und-XK": {"value" : "sq-Latn-XK"}, "yue-CN": {"value" : "yue-Hans-CN"}, "und-Lepc": {"value" : "lep-Lepc-IN"}, "byr": {"value" : "byr-Latn-ZZ"}, "kjy": {"value" : "kjy-Latn-ZZ"}, "osa": {"value" : "osa-Osge-US"}, "bys": {"value" : "bys-Latn-ZZ"}, "byv": {"value" : "byv-Latn-CM"}, "gbz": {"value" : "gbz-Arab-IR"}, "gby": {"value" : "gby-Latn-ZZ"}, "byx": {"value" : "byx-Latn-ZZ"}, "kkc": {"value" : "kkc-Latn-ZZ"}, "und-VU": {"value" : "bi-Latn-VU"}, "bza": {"value" : "bza-Latn-ZZ"}, "und-Goth": {"value"
        : "got-Goth-UA"}, "kkj": {"value" : "kkj-Latn-CM"}, "bze": {"value" : "bze-Latn-ML"}, "und-Avst": {"value" : "ae-Avst-IR"}, "bzf": {"value" : "bzf-Latn-ZZ"}, "yi": {"value" : "yi-Hebr-001"}, "bzh": {"value" : "bzh-Latn-ZZ"}, "und-WF": {"value" : "fr-Latn-WF"}, "yo": {"value" : "yo-Latn-NG"}, "gcr": {"value" : "gcr-Latn-GF"}, "ota": {"value" : "ota-Arab-ZZ"}, "und-WS": {"value" : "sm-Latn-WS"}, "bzw": {"value" : "bzw-Latn-ZZ"}, "und-UZ": {"value" : "uz-Latn-UZ"}, "und-UY": {"value" : "es-Latn-UY"}, "otk":
        {"value" : "otk-Orkh-MN"}, "xes": {"value" : "xes-Latn-ZZ"}, "za": {"value" : "za-Latn-CN"}, "gde": {"value" : "gde-Latn-ZZ"}, "kln": {"value" : "kln-Latn-KE"}, "und-VA": {"value" : "it-Latn-VA"}, "zh": {"value" : "zh-Hans-CN"}, "gdn": {"value" : "gdn-Latn-ZZ"}, "klq": {"value" : "klq-Latn-ZZ"}, "und-Saur": {"value" : "saz-Saur-IN"}, "klt": {"value" : "klt-Latn-ZZ"}, "und-VE": {"value" : "es-Latn-VE"}, "gdr": {"value" : "gdr-Latn-ZZ"}, "klx": {"value" : "klx-Latn-ZZ"}, "und-VN": {"value" : "vi-Latn-VN"}
        , "kk-MN": {"value" : "kk-Arab-MN"}, "zu": {"value" : "zu-Latn-ZA"}, "und-Armn": {"value" : "hy-Armn-AM"}, "kmb": {"value" : "kmb-Latn-AO"}, "und-TR": {"value" : "tr-Latn-TR"}, "geb": {"value" : "geb-Latn-ZZ"}, "und-TW": {"value" : "zh-Hant-TW"}, "kmh": {"value" : "kmh-Latn-ZZ"}, "und-TV": {"value" : "tvl-Latn-TV"}, "und-TZ": {"value" : "sw-Latn-TZ"}, "kmo": {"value" : "kmo-Latn-ZZ"}, "gej": {"value" : "gej-Latn-ZZ"}, "und-UA": {"value" : "uk-Cyrl-UA"}, "gel": {"value" : "gel-Latn-ZZ"}, "kms": {"value" :
        "kms-Latn-ZZ"}, "kmu": {"value" : "kmu-Latn-ZZ"}, "kmw": {"value" : "kmw-Latn-ZZ"}, "und-Tibt": {"value" : "bo-Tibt-CN"}, "und-UG": {"value" : "sw-Latn-UG"}, "und-Armi": {"value" : "arc-Armi-IR"}, "gez": {"value" : "gez-Ethi-ET"}, "und-ST": {"value" : "pt-Latn-ST"}, "knf": {"value" : "knf-Latn-GW"}, "und-SR": {"value" : "nl-Latn-SR"}, "und-SV": {"value" : "es-Latn-SV"}, "und-SY": {"value" : "ar-Arab-SY"}, "knp": {"value" : "knp-Latn-ZZ"}, "gfk": {"value" : "gfk-Latn-ZZ"}, "und-TD": {"value" : "fr-Latn-TD"}
        , "und-TH": {"value" : "th-Thai-TH"}, "und-TG": {"value" : "fr-Latn-TG"}, "und-TF": {"value" : "fr-Latn-TF"}, "und-TM": {"value" : "tk-Latn-TM"}, "und-TL": {"value" : "pt-Latn-TL"}, "und-TK": {"value" : "tkl-Latn-TK"}, "und-TJ": {"value" : "tg-Cyrl-TJ"}, "und-TO": {"value" : "to-Latn-TO"}, "und-TN": {"value" : "ar-Arab-TN"}, "und-RS": {"value" : "sr-Cyrl-RS"}, "koi": {"value" : "koi-Cyrl-RU"}, "und-RW": {"value" : "rw-Latn-RW"}, "kok": {"value" : "kok-Deva-IN"}, "und-RU": {"value" : "ru-Cyrl-RU"}, "kol":
        {"value" : "kol-Latn-ZZ"}, "kos": {"value" : "kos-Latn-FM"}, "ggn": {"value" : "ggn-Deva-NP"}, "und-SD": {"value" : "ar-Arab-SD"}, "und-SC": {"value" : "fr-Latn-SC"}, "und-SA": {"value" : "ar-Arab-SA"}, "koz": {"value" : "koz-Latn-ZZ"}, "und-SE": {"value" : "sv-Latn-SE"}, "und-SK": {"value" : "sk-Latn-SK"}, "und-SJ": {"value" : "nb-Latn-SJ"}, "und-SI": {"value" : "sl-Latn-SI"}, "taj": {"value" : "taj-Deva-NP"}, "und-SO": {"value" : "so-Latn-SO"}, "tal": {"value" : "tal-Latn-ZZ"}, "und-SN": {"value" : "fr-Latn-SN"}
        , "und-Osge": {"value" : "osa-Osge-US"}, "und-SM": {"value" : "it-Latn-SM"}, "kpf": {"value" : "kpf-Latn-ZZ"}, "tan": {"value" : "tan-Latn-ZZ"}, "kpe": {"value" : "kpe-Latn-LR"}, "und-QO": {"value" : "en-Latn-DG"}, "taq": {"value" : "taq-Latn-ZZ"}, "kpo": {"value" : "kpo-Latn-ZZ"}, "kpr": {"value" : "kpr-Latn-ZZ"}, "kpx": {"value" : "kpx-Latn-ZZ"}, "ghs": {"value" : "ghs-Latn-ZZ"}, "und-Lana": {"value" : "nod-Lana-TH"}, "tbc": {"value" : "tbc-Latn-ZZ"}, "und-RE": {"value" : "fr-Latn-RE"}, "tbd": {"value"
        : "tbd-Latn-ZZ"}, "tbg": {"value" : "tbg-Latn-ZZ"}, "tbf": {"value" : "tbf-Latn-ZZ"}, "und-RO": {"value" : "ro-Latn-RO"}, "kqb": {"value" : "kqb-Latn-ZZ"}, "tbo": {"value" : "tbo-Latn-ZZ"}, "kqf": {"value" : "kqf-Latn-ZZ"}, "und-PT": {"value" : "pt-Latn-PT"}, "und-PS": {"value" : "ar-Arab-PS"}, "cad": {"value" : "cad-Latn-US"}, "und-PR": {"value" : "es-Latn-PR"}, "tbw": {"value" : "tbw-Latn-PH"}, "und-PY": {"value" : "gn-Latn-PY"}, "gim": {"value" : "gim-Latn-ZZ"}, "und-PW": {"value" : "pau-Latn-PW"}, "gil":
        {"value" : "gil-Latn-KI"}, "kqs": {"value" : "kqs-Latn-ZZ"}, "tbz": {"value" : "tbz-Latn-ZZ"}, "und-Laoo": {"value" : "lo-Laoo-LA"}, "can": {"value" : "can-Latn-ZZ"}, "und-QA": {"value" : "ar-Arab-QA"}, "kqy": {"value" : "kqy-Ethi-ZZ"}, "ms-CC": {"value" : "ms-Arab-CC"}, "tci": {"value" : "tci-Latn-ZZ"}, "krc": {"value" : "krc-Cyrl-RU"}, "krj": {"value" : "krj-Latn-PH"}, "kri": {"value" : "kri-Latn-SL"}, "ozm": {"value" : "ozm-Latn-ZZ"}, "und-OM": {"value" : "ar-Arab-OM"}, "krl": {"value" : "krl-Latn-RU"}
        , "gjk": {"value" : "gjk-Arab-PK"}, "cbj": {"value" : "cbj-Latn-ZZ"}, "gjn": {"value" : "gjn-Latn-ZZ"}, "tcy": {"value" : "tcy-Knda-IN"}, "xla": {"value" : "xla-Latn-ZZ"}, "krs": {"value" : "krs-Latn-ZZ"}, "xlc": {"value" : "xlc-Lyci-TR"}, "kru": {"value" : "kru-Deva-IN"}, "und-PA": {"value" : "es-Latn-PA"}, "xld": {"value" : "xld-Lydi-TR"}, "gju": {"value" : "gju-Arab-PK"}, "und-PE": {"value" : "es-Latn-PE"}, "tdd": {"value" : "tdd-Tale-CN"}, "tdg": {"value" : "tdg-Deva-NP"}, "tdh": {"value" : "tdh-Deva-NP"}
        , "und-PH": {"value" : "fil-Latn-PH"}, "und-PG": {"value" : "tpi-Latn-PG"}, "ksb": {"value" : "ksb-Latn-TZ"}, "und-PF": {"value" : "fr-Latn-PF"}, "und-PM": {"value" : "fr-Latn-PM"}, "ksd": {"value" : "ksd-Latn-ZZ"}, "und-PL": {"value" : "pl-Latn-PL"}, "und-PK": {"value" : "ur-Arab-PK"}, "ksf": {"value" : "ksf-Latn-CM"}};
    };
    $java.otciu_CLDRHelper_getDefaultLocale$$create = function() {
        return {"value" : "en_GB"};
    };
    $java.otciu_CLDRHelper_getNumberFormatMap$$create = function() {
        return {"root": {"value" : "#,##0.###"}, "en": {"value" : "#,##0.###"}};
    };
    $java.otciu_CLDRHelper_getDecimalDataMap$$create = function() {
        return {"root": {"exponentSeparator" : "E", "minusSign" : 45, "perMille" : 8240, "decimalSeparator" : 46, "listSeparator" : 59, "infinity" : "∞", "naN" : "NaN", "groupingSeparator" : 44, "percent" : 37}, "en": {"exponentSeparator" : "E", "minusSign" : 45, "perMille" : 8240, "decimalSeparator" : 46, "listSeparator" : 59, "infinity" : "∞", "naN" : "NaN", "groupingSeparator" : 44, "percent" : 37}};
    };
    function onciu_Foldable$Folder$$anonfun$treeFold$1() {
        sr_AbstractPartialFunction.call(this);
        this.$$outer22 = null;
    }
    $java.oncias_package$$liftSemanticErrorDefs$lambda$_5_0 = function() {
        jl_Object.call(this);
        this.$_0371 = null;
    };
    $java.oncias_package$$liftSemanticErrorDefs$lambda$_5_0_apply = function(var$0, var$1) {
        return oncias_SemanticCheckResult__init_(var$1, var$0.$_0371);
    };
    function sci_ChampBaseReverseIterator() {
        var a = this; jl_Object.call(a);
        a.$currentValueCursor0 = 0;
        a.$currentValueNode0 = null;
        a.$currentStackLevel0 = 0;
        a.$nodeIndex0 = null;
        a.$nodeStack = null;
    }
    function sci_ChampBaseReverseIterator_pushNode($this, $node) {
        var var$2;
        var$2 = $this.$currentStackLevel0 + 1 | 0;
        $this.$currentStackLevel0 = var$2;
        $this.$nodeStack.data[var$2] = $node;
        $this.$nodeIndex0.data[var$2] = $node.$nodeArity() - 1 | 0;
    }
    function sci_ChampBaseReverseIterator_searchNextValueNode($this) {
        var var$1, var$2, $nodeCursor, $currNode;
        while (true) {
            var$1 = $this.$currentStackLevel0;
            if (var$1 < 0)
                break;
            var$2 = $this.$nodeIndex0.data;
            $nodeCursor = var$2[var$1];
            var$2[var$1] = $nodeCursor - 1 | 0;
            if ($nodeCursor >= 0) {
                sci_ChampBaseReverseIterator_pushNode($this, $this.$nodeStack.data[var$1].$getNode1($nodeCursor));
                continue;
            }
            $currNode = $this.$nodeStack.data[var$1];
            $this.$currentStackLevel0 = var$1 - 1 | 0;
            if (!$currNode.$hasPayload())
                continue;
            else {
                $this.$currentValueNode0 = $currNode;
                $this.$currentValueCursor0 = $currNode.$payloadArity() - 1 | 0;
                return 1;
            }
        }
        return 0;
    }
    $java.sci_ChampBaseReverseIterator_hasNext = function($this) {
        if ($this.$currentValueCursor0 < 0 && !sci_ChampBaseReverseIterator_searchNextValueNode($this))
            return 0;
        return 1;
    };
    function sci_MapKeyValueTupleHashIterator() {
        var a = this; sci_ChampBaseReverseIterator.call(a);
        a.$hash4 = 0;
        a.$value22 = null;
    }
    $java.sci_MapKeyValueTupleHashIterator_iterator = function($this) {
        return $this;
    };
    $java.sci_MapKeyValueTupleHashIterator_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.sci_MapKeyValueTupleHashIterator_toString = function($this) {
        return $rt_s(466);
    };
    $java.sci_MapKeyValueTupleHashIterator_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.sci_MapKeyValueTupleHashIterator_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.sci_MapKeyValueTupleHashIterator_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.sci_MapKeyValueTupleHashIterator_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.sci_MapKeyValueTupleHashIterator_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.sci_MapKeyValueTupleHashIterator_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.sci_MapKeyValueTupleHashIterator_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.sci_MapKeyValueTupleHashIterator_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.sci_MapKeyValueTupleHashIterator_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.sci_MapKeyValueTupleHashIterator_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.sci_MapKeyValueTupleHashIterator_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.sci_MapKeyValueTupleHashIterator_knownSize = function($this) {
        return (-1);
    };
    $java.sci_MapKeyValueTupleHashIterator_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$hash4, sr_Statics_anyHash($this.$value22), (-889275714));
    };
    $java.sci_MapKeyValueTupleHashIterator_next = function($this) {
        var var$1;
        if (!$java.sci_ChampBaseReverseIterator_hasNext($this)) {
            var$1 = new ju_NoSuchElementException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        $this.$hash4 = $this.$currentValueNode0.$getHash($this.$currentValueCursor0);
        $this.$value22 = $this.$currentValueNode0.$getValue($this.$currentValueCursor0);
        $this.$currentValueCursor0 = $this.$currentValueCursor0 - 1 | 0;
        return $this;
    };
    function onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_0() {
        jl_Object.call(this);
        this.$_0215 = null;
    }
    $java.onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_0_apply = function(var$0) {
        return var$0.$_0215;
    };
    function onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_1() {
        jl_Object.call(this);
        this.$_0216 = null;
    }
    $java.onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_1_apply = function(var$0, var$1) {
        return var$1.$apply(var$0.$_0216);
    };
    function scm_GrowableBuilder() {
        jl_Object.call(this);
        this.$elems3 = null;
    }
    function scm_GrowableBuilder__init_0(var_0) {
        var var_1 = new scm_GrowableBuilder();
        scm_GrowableBuilder__init_(var_1, var_0);
        return var_1;
    }
    $java.scm_GrowableBuilder_sizeHint = function($this, $size) {};
    $java.scm_GrowableBuilder_sizeHint0 = function($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    };
    $java.scm_GrowableBuilder_elems = function($this) {
        return $this.$elems3;
    };
    $java.scm_GrowableBuilder_result = function($this) {
        return $this.$elems3;
    };
    $java.scm_GrowableBuilder_addOne = function($this, $elem) {
        var var$2;
        var$2 = $this.$elems3;
        if (var$2 !== null) {
            var$2.$addOne($elem);
            return $this;
        }
        $rt_throw(null);
    };
    $java.scm_GrowableBuilder_addAll = function($this, $xs) {
        $this.$elems3.$addAll0($xs);
        return $this;
    };
    $java.scm_GrowableBuilder_addAll0 = function($this, $xs) {
        return $java.scm_GrowableBuilder_addAll($this, $xs);
    };
    $java.scm_GrowableBuilder_addOne0 = function($this, $elem) {
        return $java.scm_GrowableBuilder_addOne($this, $elem);
    };
    $java.scm_GrowableBuilder_result0 = function($this) {
        return $this.$elems3;
    };
    function scm_GrowableBuilder__init_($this, $elems) {
        $this.$elems3 = $elems;
    }
    var scm_HashSet$$anon$4 = $rt_classWithoutFields(scm_GrowableBuilder);
    $java.scm_HashSet$$anon$4_sizeHint = function($this, $size) {
        scm_HashSet_sizeHint($this.$elems3, $size);
    };
    $java.oncias_SemanticState$ScopeLocation$$parent$extension$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncias_SemanticState$ScopeLocation$$parent$extension$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new oncias_SemanticState$ScopeLocation;
        oncias_SemanticState$_$callClinit();
        $java.oncias_SemanticState$ScopeLocation__init_(var$2, var$1);
        return var$2;
    };
    $java.oncias_SemanticState$ScopeLocation$$availableSymbolDefinitions$extension$lambda$_12_0 = $rt_classWithoutFields();
    $java.oncias_SemanticState$ScopeLocation$$availableSymbolDefinitions$extension$lambda$_12_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = oncias_SemanticState$ScopeLocation$_MODULE$;
        oncias_SemanticState$_$callClinit();
        return $java.oncias_SemanticState$ScopeLocation$_availableSymbolDefinitions$extension(var$2, var$1);
    };
    function sci_VectorSliceBuilder() {
        var a = this; jl_Object.call(a);
        a.$lo = 0;
        a.$hi = 0;
        a.$scala$collection$immutable$VectorSliceBuilder$$slices = null;
        a.$len3 = 0;
        a.$pos2 = 0;
        a.$maxDim = 0;
    }
    function sci_VectorSliceBuilder__init_(var_0, var_1) {
        var var_2 = new sci_VectorSliceBuilder();
        $java.sci_VectorSliceBuilder__init_(var_2, var_0, var_1);
        return var_2;
    }
    function sci_VectorSliceBuilder_consider($this, $n, $a) {
        var $count, $lo0, $hi0;
        $count = $rt_imul($a.data.length, 1 << (5 * ($n - 1 | 0) | 0));
        $lo0 = jl_Math_max($this.$lo - $this.$pos2 | 0, 0);
        $hi0 = jl_Math_min($this.$hi - $this.$pos2 | 0, $count);
        if ($hi0 > $lo0) {
            $java.sci_VectorSliceBuilder_addSlice($this, $n, $a, $lo0, $hi0);
            $this.$len3 = $this.$len3 + ($hi0 - $lo0 | 0) | 0;
        }
        $this.$pos2 = $this.$pos2 + $count | 0;
    }
    $java.sci_VectorSliceBuilder_addSlice = function($this, $n, $a, $lo, $hi) {
        var $n_0, $bitsN, $widthN, $loN, $hiN, var$10;
        while (true) {
            if ($n == 1) {
                if (!(!$lo && $hi == $a.data.length))
                    $a = ju_Arrays_copyOfRange($a, $lo, $hi);
                $java.sci_VectorSliceBuilder_add($this, 1, $a);
                return;
            }
            $n_0 = $n - 1 | 0;
            $bitsN = 5 * $n_0 | 0;
            $widthN = 1 << $bitsN;
            $loN = $lo >>> $bitsN;
            $hiN = $hi >>> $bitsN;
            $bitsN = $widthN - 1 | 0;
            $lo = $lo & $bitsN;
            $hi = $hi & $bitsN;
            if (!$lo) {
                if (!$hi)
                    break;
                if ($hiN > $loN)
                    $java.sci_VectorSliceBuilder_add($this, $n, !$loN && $hiN == $a.data.length ? $a : ju_Arrays_copyOfRange($a, $loN, $hiN));
                $a = $a.data[$hiN];
                $lo = 0;
                $n = $n_0;
                continue;
            }
            if ($hiN == $loN) {
                $a = $a.data[$loN];
                $n = $n_0;
                continue;
            }
            var$10 = $a.data;
            $java.sci_VectorSliceBuilder_addSlice($this, $n_0, var$10[$loN], $lo, $widthN);
            if (!$hi) {
                $lo = $loN + 1 | 0;
                if ($hiN <= $lo)
                    return;
                if (!(!$lo && $hiN == var$10.length))
                    $a = ju_Arrays_copyOfRange($a, $lo, $hiN);
                $java.sci_VectorSliceBuilder_add($this, $n, $a);
                return;
            }
            $lo = $loN + 1 | 0;
            if ($hiN > $lo) {
                if (!(!$lo && $hiN == var$10.length))
                    $a = ju_Arrays_copyOfRange($a, $lo, $hiN);
                $java.sci_VectorSliceBuilder_add($this, $n, $a);
            }
            $a = var$10[$hiN];
            $lo = 0;
            $n = $n_0;
        }
        if (!(!$loN && $hiN == $a.data.length))
            $a = ju_Arrays_copyOfRange($a, $loN, $hiN);
        $java.sci_VectorSliceBuilder_add($this, $n, $a);
    };
    $java.sci_VectorSliceBuilder_add = function($this, $n, $a) {
        var $idx;
        if ($n <= $this.$maxDim)
            $idx = 11 - $n | 0;
        else {
            $this.$maxDim = $n;
            $idx = $n - 1 | 0;
        }
        $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[$idx] = $a;
    };
    function sci_VectorSliceBuilder_result($this) {
        var $len12, $suffix1, $a, $a_0, $prefix1, $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n, $prefix2, $pre, $suf, $suffixOr_s, $len123, $len1234, $len1, $concatArrays_dest, $dataOr_a, $dataOr_s, $prefixOr_a, $prefixOr_p, $data3, $suffixOr_a, $prefix3, $data4, $suffix3, $suffix2, $prefix4, $data5, $suffix4, $prefix5, $data6, $suffix5, $suffixOr_a_0, $len12_0;
        $len12 = $this.$len3;
        if ($len12 <= 32) {
            if (!$len12) {
                sci_Vector0$_$callClinit();
                return sci_Vector0$_MODULE$;
            }
            $suffix1 = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
            $a = $suffix1[0];
            $a_0 = $suffix1[10];
            if ($a !== null) {
                if ($a_0 !== null) {
                    $suffix1 = $a.data;
                    $prefix1 = $a_0.data;
                    $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n = $suffix1.length;
                    $len12 = $prefix1.length;
                    $a = ju_Arrays_copyOf($a, $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n + $len12 | 0);
                    jl_System_arraycopy($a_0, 0, $a, $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n, $len12);
                }
            } else if ($a_0 !== null)
                $a = $a_0;
            else {
                $prefix2 = $suffix1[1];
                $a = $prefix2 !== null ? $prefix2.data[0] : $suffix1[9].data[0];
            }
            return sci_Vector1__init_($a);
        }
        $java.sci_VectorSliceBuilder_balancePrefix($this, 1);
        $java.sci_VectorSliceBuilder_balanceSuffix($this, 1);
        $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n = $this.$maxDim;
        if ($scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n < 6) {
            $suffix1 = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
            $len12 = $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n - 1 | 0;
            $pre = $suffix1[$len12];
            $suf = $suffix1[11 - $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n | 0];
            if ($pre !== null && $suf !== null) {
                $prefix1 = $pre.data;
                $suffixOr_s = $suf.data;
                $len123 = $prefix1.length;
                $len1234 = $suffixOr_s.length;
                $len1 = $len123 + $len1234 | 0;
                if ($len1 > 30)
                    $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n = $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n + 1 | 0;
                else {
                    $concatArrays_dest = ju_Arrays_copyOf($pre, $len1);
                    jl_System_arraycopy($suf, 0, $concatArrays_dest, $len123, $len1234);
                    $suffix1[$len12] = $concatArrays_dest;
                    $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[11 - $this.$maxDim | 0] = null;
                }
            } else {
                if ($pre !== null)
                    $suf = $pre;
                if ($suf.data.length > 30)
                    $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n = $scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n + 1 | 0;
            }
        }
        $suffix1 = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
        $prefix1 = $suffix1[0];
        $suffixOr_s = $prefix1.data;
        $suffix1 = $suffix1[10];
        $len1 = $suffixOr_s.length;
        switch ($scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n) {
            case 2:
                $dataOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
                $dataOr_s = $suffixOr_s[1];
                if ($dataOr_s === null) {
                    $dataOr_s = $suffixOr_s[9];
                    if ($dataOr_s === null)
                        $dataOr_s = $dataOr_a;
                }
                return sci_Vector2__init_($prefix1, $len1, $dataOr_s, $suffix1, $this.$len3);
            case 3:
                $prefixOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[1];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix2 = $prefixOr_a;
                $dataOr_a = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
                $dataOr_s = $suffixOr_s[2];
                if ($dataOr_s === null) {
                    $dataOr_s = $suffixOr_s[8];
                    if ($dataOr_s === null)
                        $dataOr_s = $dataOr_a;
                }
                $data3 = $dataOr_s;
                $suffixOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[9];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                return sci_Vector3__init_($prefix1, $len1, $prefix2, $len1 + ($prefix2.data.length * 32 | 0) | 0, $data3, $suffixOr_a, $suffix1, $this.$len3);
            case 4:
                $prefixOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[1];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix2 = $prefixOr_a;
                $prefixOr_a = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[2];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix3 = $prefixOr_a;
                $dataOr_a = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
                $dataOr_s = $suffixOr_s[3];
                if ($dataOr_s === null) {
                    $dataOr_s = $suffixOr_s[7];
                    if ($dataOr_s === null)
                        $dataOr_s = $dataOr_a;
                }
                $data4 = $dataOr_s;
                $suffixOr_a = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[8];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffix3 = $suffixOr_a;
                $suffixOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[9];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffixOr_s = $prefix2.data;
                $prefixOr_a = $prefix3.data;
                $suffix2 = $suffixOr_a;
                $len12 = $len1 + ($suffixOr_s.length * 32 | 0) | 0;
                return sci_Vector4__init_($prefix1, $len1, $prefix2, $len12, $prefix3, $len12 + ($prefixOr_a.length * 1024 | 0) | 0, $data4, $suffix3, $suffix2, $suffix1, $this.$len3);
            case 5:
                $prefixOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[1];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix2 = $prefixOr_a;
                $prefixOr_a = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[2];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix3 = $prefixOr_a;
                $prefixOr_a = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[3];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix4 = $prefixOr_a;
                $dataOr_a = sci_VectorStatics$_empty50(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
                $dataOr_s = $suffixOr_s[4];
                if ($dataOr_s === null) {
                    $dataOr_s = $suffixOr_s[6];
                    if ($dataOr_s === null)
                        $dataOr_s = $dataOr_a;
                }
                $data5 = $dataOr_s;
                $suffixOr_a = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[7];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffix4 = $suffixOr_a;
                $suffixOr_a = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[8];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffix3 = $suffixOr_a;
                $suffixOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[9];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffixOr_s = $prefix2.data;
                $prefixOr_a = $prefix3.data;
                $prefixOr_p = $prefix4.data;
                $suffix2 = $suffixOr_a;
                $len12 = $len1 + ($suffixOr_s.length * 32 | 0) | 0;
                $len123 = $len12 + ($prefixOr_a.length * 1024 | 0) | 0;
                return sci_Vector5__init_($prefix1, $len1, $prefix2, $len12, $prefix3, $len123, $prefix4, $len123 + ($prefixOr_p.length * 32768 | 0) | 0, $data5, $suffix4, $suffix3, $suffix2, $suffix1, $this.$len3);
            case 6:
                $prefixOr_a = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[1];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix2 = $prefixOr_a;
                $prefixOr_a = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[2];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix3 = $prefixOr_a;
                $prefixOr_a = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[3];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix4 = $prefixOr_a;
                $prefixOr_a = sci_VectorStatics$_empty50(sci_VectorStatics$_MODULE$);
                $prefixOr_p = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[4];
                if ($prefixOr_p !== null)
                    $prefixOr_a = $prefixOr_p;
                $prefix5 = $prefixOr_a;
                $dataOr_a = sci_VectorStatics$_empty60(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
                $dataOr_s = $suffixOr_s[5];
                if ($dataOr_s === null) {
                    $dataOr_s = $suffixOr_s[5];
                    if ($dataOr_s === null)
                        $dataOr_s = $dataOr_a;
                }
                $data6 = $dataOr_s;
                $suffixOr_a = sci_VectorStatics$_empty50(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[6];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffix5 = $suffixOr_a;
                $suffixOr_a = sci_VectorStatics$_empty40(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[7];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffix4 = $suffixOr_a;
                $suffixOr_a = sci_VectorStatics$_empty30(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[8];
                if ($suffixOr_s !== null)
                    $suffixOr_a = $suffixOr_s;
                $suffix3 = $suffixOr_a;
                $suffixOr_a_0 = sci_VectorStatics$_empty20(sci_VectorStatics$_MODULE$);
                $suffixOr_s = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data[9];
                if ($suffixOr_s !== null)
                    $suffixOr_a_0 = $suffixOr_s;
                $prefixOr_a = $prefix2.data;
                $prefixOr_p = $prefix3.data;
                $suffixOr_s = $prefix4.data;
                $suffixOr_a = $prefix5.data;
                $suffix2 = $suffixOr_a_0;
                $len12_0 = $len1 + ($prefixOr_a.length * 32 | 0) | 0;
                $len123 = $len12_0 + ($prefixOr_p.length * 1024 | 0) | 0;
                $len1234 = $len123 + ($suffixOr_s.length * 32768 | 0) | 0;
                return sci_Vector6__init_($prefix1, $len1, $prefix2, $len12_0, $prefix3, $len123, $prefix4, $len1234, $prefix5, $len1234 + $rt_imul($suffixOr_a.length, 1048576) | 0, $data6, $suffix5, $suffix4, $suffix3, $suffix2, $suffix1, $this.$len3);
            default:
        }
        $rt_throw(s_MatchError__init_(jl_Integer_valueOf($scala$collection$immutable$VectorSliceBuilder$$suffixIdx_n)));
    }
    $java.sci_VectorSliceBuilder_balancePrefix = function($this, $n) {
        var var$2, var$3, var$4, var$5, var$6, $preN1, var$8, var$9;
        var$2 = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
        var$3 = $n - 1 | 0;
        if (var$2[var$3] !== null)
            return;
        if ($n == $this.$maxDim) {
            $n = 11 - $n | 0;
            var$2[var$3] = var$2[$n];
            var$2[$n] = null;
            return;
        }
        var$4 = $n + 1 | 0;
        $java.sci_VectorSliceBuilder_balancePrefix($this, var$4);
        var$5 = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
        var$6 = var$4 - 1 | 0;
        $preN1 = var$5[var$6];
        var$8 = $preN1.data;
        var$5[var$3] = var$8[0];
        var$9 = var$8.length;
        if (var$9 != 1) {
            var$5[var$6] = ju_Arrays_copyOfRange($preN1, 1, var$9);
            return;
        }
        var$5[var$6] = null;
        if ($this.$maxDim == var$4 && var$5[11 - var$4 | 0] === null) {
            $this.$maxDim = $n;
            return;
        }
    };
    $java.sci_VectorSliceBuilder_balanceSuffix = function($this, $n) {
        var var$2, var$3, var$4, var$5, var$6, $sufN1, var$8, var$9;
        var$2 = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
        var$3 = 11 - $n | 0;
        if (var$2[var$3] !== null)
            return;
        if ($n == $this.$maxDim) {
            $n = $n - 1 | 0;
            var$2[var$3] = var$2[$n];
            var$2[$n] = null;
            return;
        }
        var$4 = $n + 1 | 0;
        $java.sci_VectorSliceBuilder_balanceSuffix($this, var$4);
        var$5 = $this.$scala$collection$immutable$VectorSliceBuilder$$slices.data;
        var$6 = 11 - var$4 | 0;
        $sufN1 = var$5[var$6];
        var$2 = $sufN1.data;
        var$8 = var$2.length;
        var$9 = var$8 - 1 | 0;
        var$5[var$3] = var$2[var$9];
        if (var$8 != 1) {
            var$5[var$6] = ju_Arrays_copyOfRange($sufN1, 0, var$9);
            return;
        }
        var$5[var$6] = null;
        if ($this.$maxDim == var$4 && var$5[var$4 - 1 | 0] === null) {
            $this.$maxDim = $n;
            return;
        }
    };
    $java.sci_VectorSliceBuilder__init_ = function($this, $lo, $hi) {
        $this.$lo = $lo;
        $this.$hi = $hi;
        $this.$scala$collection$immutable$VectorSliceBuilder$$slices = $rt_createArray($rt_arraycls(jl_Object), 11);
        $this.$len3 = 0;
        $this.$pos2 = 0;
        $this.$maxDim = 0;
    };
    function sci_Map$Map1() {
        var a = this; sci_AbstractMap.call(a);
        a.$key10 = null;
        a.$value110 = null;
    }
    function sci_Map$Map1__init_(var_0, var_1) {
        var var_2 = new sci_Map$Map1();
        $java.sci_Map$Map1__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.sci_Map$Map1_map = function($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    };
    $java.sci_Map$Map1_flatMap = function($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    };
    $java.sci_Map$Map1_collect = function($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    };
    $java.sci_Map$Map1_flatten = function($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    };
    $java.sci_Map$Map1_filter = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    };
    $java.sci_Map$Map1_filterNot = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    };
    $java.sci_Map$Map1_size = function($this) {
        return 1;
    };
    $java.sci_Map$Map1_knownSize = function($this) {
        return 1;
    };
    $java.sci_Map$Map1_isEmpty = function($this) {
        return 0;
    };
    $java.sci_Map$Map1_apply = function($this, $key) {
        var var$2, var$3;
        if (sr_BoxesRunTime_equals($key, $this.$key10))
            return $this.$value110;
        var$2 = new ju_NoSuchElementException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 15);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(389));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$3, $key)));
        $rt_throw(var$2);
    };
    $java.sci_Map$Map1_contains = function($this, $key) {
        if (!sr_BoxesRunTime_equals($key, $this.$key10))
            return 0;
        return 1;
    };
    $java.sci_Map$Map1_get = function($this, $key) {
        if (!sr_BoxesRunTime_equals($key, $this.$key10))
            return s_None$_MODULE$;
        return s_Some__init_($this.$value110);
    };
    $java.sci_Map$Map1_getOrElse = function($this, $key, $default) {
        if (!sr_BoxesRunTime_equals($key, $this.$key10))
            return $default.$apply2();
        return $this.$value110;
    };
    $java.sci_Map$Map1_iterator = function($this) {
        return sc_Iterator$$anon$20__init_(s_Tuple2__init_($this.$key10, $this.$value110));
    };
    $java.sci_Map$Map1_keysIterator = function($this) {
        return sc_Iterator$$anon$20__init_($this.$key10);
    };
    $java.sci_Map$Map1_valuesIterator = function($this) {
        return sc_Iterator$$anon$20__init_($this.$value110);
    };
    $java.sci_Map$Map1_foreach = function($this, $f) {
        $f.$apply(s_Tuple2__init_($this.$key10, $this.$value110));
    };
    $java.sci_Map$Map1_exists = function($this, $p) {
        return sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$key10, $this.$value110)));
    };
    $java.sci_Map$Map1_forall = function($this, $p) {
        return sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$key10, $this.$value110)));
    };
    $java.sci_Map$Map1_hashCode = function($this) {
        var $h, $a, $b, $c;
        suh_MurmurHash3$_$callClinit();
        $h = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$key10, $this.$value110);
        $a = 0 + $h | 0;
        $b = 0 ^ $h;
        $c = 1 * ($h | 1) | 0;
        $h = suh_MurmurHash3$_mapSeed(suh_MurmurHash3$_MODULE$);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $h, $a);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $a, $b);
        $a = suh_MurmurHash3_mixLast(suh_MurmurHash3$_MODULE$, $a, $c);
        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(suh_MurmurHash3$_MODULE$, $a ^ 1);
    };
    $java.sci_Map$Map1_filterImpl = function($this, $pred, $isFlipped) {
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$key10, $this.$value110))) == $isFlipped)
            $this = sci_Map$EmptyMap$_MODULE$;
        return $this;
    };
    $java.sci_Map$Map1_removed = function($this, $key) {
        if (sr_BoxesRunTime_equals($key, $this.$key10))
            $this = sci_Map$EmptyMap$_MODULE$;
        return $this;
    };
    $java.sci_Map$Map1_updated = function($this, $key, $value) {
        return sr_BoxesRunTime_equals($key, $this.$key10) ? sci_Map$Map1__init_($this.$key10, $value) : $java.sci_Map$Map2__init_($this.$key10, $this.$value110, $key, $value);
    };
    $java.sci_Map$Map1__init_ = function($this, $key1, $value1) {
        $this.$key10 = $key1;
        $this.$value110 = $value1;
    };
    var onciaf_ParameterType = $rt_classWithoutFields(jl_Enum);
    var onciaf_ParameterType_ANY = null;
    var onciaf_ParameterType_STRING = null;
    var onciaf_ParameterType_MAP = null;
    $java.onciaf_ParameterType_$VALUES = null;
    function onciaf_ParameterType_$callClinit() {
        onciaf_ParameterType_$callClinit = $rt_eraseClinit(onciaf_ParameterType);
        $java.onciaf_ParameterType__clinit_();
    }
    $java.onciaf_ParameterType__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_ParameterType();
        $java.onciaf_ParameterType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_ParameterType_values() {
        onciaf_ParameterType_$callClinit();
        return $java.onciaf_ParameterType_$VALUES.$clone();
    }
    $java.onciaf_ParameterType__init_0 = function($this, var$1, var$2) {
        onciaf_ParameterType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_ParameterType__clinit_ = function() {
        var var$1;
        onciaf_ParameterType_ANY = $java.onciaf_ParameterType__init_($rt_s(1522), 0);
        onciaf_ParameterType_STRING = $java.onciaf_ParameterType__init_($rt_s(1523), 1);
        var$1 = $java.onciaf_ParameterType__init_($rt_s(1524), 2);
        onciaf_ParameterType_MAP = var$1;
        $java.onciaf_ParameterType_$VALUES = $rt_createArrayFromData(onciaf_ParameterType, [onciaf_ParameterType_ANY, onciaf_ParameterType_STRING, var$1]);
    };
    var onciaf_SimpleEither = $rt_classWithoutFields(0);
    function onciaf_SimpleEither_left($value) {
        return $java.onciaf_EitherImpl__init_($value, null);
    }
    function onciaf_SimpleEither_right($value) {
        return $java.onciaf_EitherImpl__init_(null, $value);
    }
    $java.oncia_DatabaseName = $rt_classWithoutFields(0);
    var oncia_WaitUntilComplete = $rt_classWithoutFields(0);
    function oncia_WaitUntilComplete_$init$($$this) {
        $$this.$org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq(Long_fromInt(300));
    }
    var oncie_LogicalVariable = $rt_classWithoutFields(oncie_Expression);
    $java.oncie_LogicalVariable_asCanonicalStringVal = function($this) {
        return $this.$name4;
    };
    function oncie_Variable() {
        var a = this; oncie_LogicalVariable.call(a);
        a.$name4 = null;
        a.$position0 = null;
    }
    function oncie_Variable__init_(var_0, var_1) {
        var var_2 = new oncie_Variable();
        $java.oncie_Variable__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_Variable_name($this) {
        return $this.$name4;
    }
    $java.oncie_Variable_position = function($this) {
        return $this.$position0;
    };
    function oncie_Variable_copyId($this) {
        return $java.oncie_Variable_copy($this, $this.$name4, $this.$position0);
    }
    function oncie_Variable_withPosition($this, $position) {
        return $java.oncie_Variable_copy($this, $this.$name4, $position);
    }
    $java.oncie_Variable_copy = function($this, $name, $position) {
        return oncie_Variable__init_($name, $position);
    };
    $java.oncie_Variable_productPrefix = function($this) {
        return $rt_s(1525);
    };
    $java.oncie_Variable_productArity = function($this) {
        return 1;
    };
    $java.oncie_Variable_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Variable_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Variable_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Variable_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Variable_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Variable) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name4;
                        $x$1 = $x$1.$name4;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Variable))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_Variable__init_ = function($this, $name, $position) {
        $this.$name4 = $name;
        $this.$position0 = $position;
        $java.oncie_Expression__init_($this);
    };
    function onciaf_ParserCypherTypeName() {
        var a = this; jl_Object.call(a);
        a.$typeName0 = null;
        a.$offset2 = null;
        a.$line2 = null;
        a.$column2 = null;
    }
    var onciaf_ParserCypherTypeName_NOTHING = null;
    var onciaf_ParserCypherTypeName_NULL = null;
    var onciaf_ParserCypherTypeName_BOOLEAN = null;
    var onciaf_ParserCypherTypeName_BOOLEAN_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_STRING = null;
    var onciaf_ParserCypherTypeName_STRING_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_INTEGER = null;
    var onciaf_ParserCypherTypeName_INTEGER_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_FLOAT = null;
    var onciaf_ParserCypherTypeName_FLOAT_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_DATE = null;
    var onciaf_ParserCypherTypeName_DATE_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_LOCAL_TIME = null;
    var onciaf_ParserCypherTypeName_LOCAL_TIME_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_ZONED_TIME = null;
    var onciaf_ParserCypherTypeName_ZONED_TIME_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_LOCAL_DATETIME = null;
    var onciaf_ParserCypherTypeName_LOCAL_DATETIME_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_ZONED_DATETIME = null;
    var onciaf_ParserCypherTypeName_ZONED_DATETIME_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_DURATION = null;
    var onciaf_ParserCypherTypeName_DURATION_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_POINT = null;
    var onciaf_ParserCypherTypeName_POINT_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_NODE = null;
    var onciaf_ParserCypherTypeName_NODE_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_RELATIONSHIP = null;
    var onciaf_ParserCypherTypeName_RELATIONSHIP_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_MAP = null;
    var onciaf_ParserCypherTypeName_MAP_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_PATH = null;
    var onciaf_ParserCypherTypeName_PATH_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_ANY = null;
    var onciaf_ParserCypherTypeName_ANY_NOT_NULL = null;
    var onciaf_ParserCypherTypeName_PROPERTY_VALUE = null;
    var onciaf_ParserCypherTypeName_PROPERTY_VALUE_NOT_NULL = null;
    $java.onciaf_ParserCypherTypeName__init_ = function(var_0) {
        var var_1 = new onciaf_ParserCypherTypeName();
        $java.onciaf_ParserCypherTypeName__init_0(var_1, var_0);
        return var_1;
    };
    function onciaf_ParserCypherTypeName_withPos($this, $offset, $line, $column) {
        $this.$offset2 = $offset;
        $this.$line2 = $line;
        $this.$column2 = $column;
        return $this;
    }
    $java.onciaf_ParserCypherTypeName__init_0 = function($this, $typeName) {
        $this.$typeName0 = $typeName;
    };
    function onciaf_ParserCypherTypeName_listOf($inner) {
        return $java.onciaf_ParserCypherTypeName$ListParserCypherTypeName__init_($inner, 1);
    }
    function onciaf_ParserCypherTypeName_closedDynamicUnionOf($unionTypes) {
        var var$2;
        var$2 = new onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName;
        $java.onciaf_ParserCypherTypeName__init_0(var$2, jl_String_join($rt_s(155), jus_Stream_toList(jusi_SimpleStreamImpl_map(ju_Collection_stream($unionTypes), new $java.onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName$_init_$lambda$_0_0))));
        var$2.$unionTypes = $unionTypes;
        return var$2;
    }
    $java.onciaf_ParserCypherTypeName_description = function($this) {
        return $this.$typeName0;
    };
    function onciaf_ParserCypherTypeName_getNotNullTypeName($parserCypherTypeName) {
        var var$2, var$3;
        if (!jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_NOTHING) && !jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_NULL)) {
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_BOOLEAN))
                return onciaf_ParserCypherTypeName_BOOLEAN_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_STRING))
                return onciaf_ParserCypherTypeName_STRING_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_INTEGER))
                return onciaf_ParserCypherTypeName_INTEGER_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_FLOAT))
                return onciaf_ParserCypherTypeName_FLOAT_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_DATE))
                return onciaf_ParserCypherTypeName_DATE_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_LOCAL_TIME))
                return onciaf_ParserCypherTypeName_LOCAL_TIME_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_ZONED_TIME))
                return onciaf_ParserCypherTypeName_ZONED_TIME_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_LOCAL_DATETIME))
                return onciaf_ParserCypherTypeName_LOCAL_DATETIME_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_ZONED_DATETIME))
                return onciaf_ParserCypherTypeName_ZONED_DATETIME_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_DURATION))
                return onciaf_ParserCypherTypeName_DURATION_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_POINT))
                return onciaf_ParserCypherTypeName_POINT_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_NODE))
                return onciaf_ParserCypherTypeName_NODE_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_RELATIONSHIP))
                return onciaf_ParserCypherTypeName_RELATIONSHIP_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_MAP))
                return onciaf_ParserCypherTypeName_MAP_NOT_NULL;
            if ($parserCypherTypeName instanceof onciaf_ParserCypherTypeName$ListParserCypherTypeName)
                return $java.onciaf_ParserCypherTypeName$ListParserCypherTypeName__init_($parserCypherTypeName.$innerType, 0);
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_PATH))
                return onciaf_ParserCypherTypeName_PATH_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_ANY))
                return onciaf_ParserCypherTypeName_ANY_NOT_NULL;
            if (jl_Object_equals($parserCypherTypeName, onciaf_ParserCypherTypeName_PROPERTY_VALUE))
                return onciaf_ParserCypherTypeName_PROPERTY_VALUE_NOT_NULL;
            if ($parserCypherTypeName instanceof onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName) {
                $parserCypherTypeName = new jl_IllegalArgumentException;
                jl_Throwable__init_($parserCypherTypeName, $rt_s(1526));
                $rt_throw($parserCypherTypeName);
            }
            var$2 = new jl_IllegalArgumentException;
            var$3 = $rt_createArray(jl_Object, 1);
            var$3.data[0] = $parserCypherTypeName.$typeName0;
            jl_Throwable__init_(var$2, jl_String_format($rt_s(1527), var$3));
            $rt_throw(var$2);
        }
        return onciaf_ParserCypherTypeName_NOTHING;
    }
    function onciaf_ParserCypherTypeName_getOffset($this) {
        return $this.$offset2;
    }
    function onciaf_ParserCypherTypeName_getLine($this) {
        return $this.$line2;
    }
    function onciaf_ParserCypherTypeName_getColumn($this) {
        return $this.$column2;
    }
    function onciaf_ParserCypherTypeName__clinit_() {
        onciaf_ParserCypherTypeName_NOTHING = $java.onciaf_ParserCypherTypeName__init_($rt_s(1528));
        onciaf_ParserCypherTypeName_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1529));
        onciaf_ParserCypherTypeName_BOOLEAN = $java.onciaf_ParserCypherTypeName__init_($rt_s(1530));
        onciaf_ParserCypherTypeName_BOOLEAN_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1531));
        onciaf_ParserCypherTypeName_STRING = $java.onciaf_ParserCypherTypeName__init_($rt_s(1523));
        onciaf_ParserCypherTypeName_STRING_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1532));
        onciaf_ParserCypherTypeName_INTEGER = $java.onciaf_ParserCypherTypeName__init_($rt_s(1533));
        onciaf_ParserCypherTypeName_INTEGER_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1534));
        onciaf_ParserCypherTypeName_FLOAT = $java.onciaf_ParserCypherTypeName__init_($rt_s(1535));
        onciaf_ParserCypherTypeName_FLOAT_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1536));
        onciaf_ParserCypherTypeName_DATE = $java.onciaf_ParserCypherTypeName__init_($rt_s(1537));
        onciaf_ParserCypherTypeName_DATE_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1538));
        onciaf_ParserCypherTypeName_LOCAL_TIME = $java.onciaf_ParserCypherTypeName__init_($rt_s(1539));
        onciaf_ParserCypherTypeName_LOCAL_TIME_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1540));
        onciaf_ParserCypherTypeName_ZONED_TIME = $java.onciaf_ParserCypherTypeName__init_($rt_s(1541));
        onciaf_ParserCypherTypeName_ZONED_TIME_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1542));
        onciaf_ParserCypherTypeName_LOCAL_DATETIME = $java.onciaf_ParserCypherTypeName__init_($rt_s(1543));
        onciaf_ParserCypherTypeName_LOCAL_DATETIME_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1544));
        onciaf_ParserCypherTypeName_ZONED_DATETIME = $java.onciaf_ParserCypherTypeName__init_($rt_s(1545));
        onciaf_ParserCypherTypeName_ZONED_DATETIME_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1546));
        onciaf_ParserCypherTypeName_DURATION = $java.onciaf_ParserCypherTypeName__init_($rt_s(1547));
        onciaf_ParserCypherTypeName_DURATION_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1548));
        onciaf_ParserCypherTypeName_POINT = $java.onciaf_ParserCypherTypeName__init_($rt_s(1437));
        onciaf_ParserCypherTypeName_POINT_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1549));
        onciaf_ParserCypherTypeName_NODE = $java.onciaf_ParserCypherTypeName__init_($rt_s(923));
        onciaf_ParserCypherTypeName_NODE_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1550));
        onciaf_ParserCypherTypeName_RELATIONSHIP = $java.onciaf_ParserCypherTypeName__init_($rt_s(1551));
        onciaf_ParserCypherTypeName_RELATIONSHIP_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1552));
        onciaf_ParserCypherTypeName_MAP = $java.onciaf_ParserCypherTypeName__init_($rt_s(1524));
        onciaf_ParserCypherTypeName_MAP_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1553));
        onciaf_ParserCypherTypeName_PATH = $java.onciaf_ParserCypherTypeName__init_($rt_s(1554));
        onciaf_ParserCypherTypeName_PATH_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1555));
        onciaf_ParserCypherTypeName_ANY = $java.onciaf_ParserCypherTypeName__init_($rt_s(1522));
        onciaf_ParserCypherTypeName_ANY_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1556));
        onciaf_ParserCypherTypeName_PROPERTY_VALUE = $java.onciaf_ParserCypherTypeName__init_($rt_s(1557));
        onciaf_ParserCypherTypeName_PROPERTY_VALUE_NOT_NULL = $java.onciaf_ParserCypherTypeName__init_($rt_s(1558));
    }
    var ju_AbstractSequentialList = $rt_classWithoutFields(ju_AbstractList);
    $java.ju_AbstractSequentialList_get = function($this, $index) {
        var $iter;
        if ($index >= 0)
            return $java.ju_LinkedList$SequentialListIterator_next($java.ju_LinkedList_listIterator($this, $index));
        $iter = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0($iter);
        $rt_throw($iter);
    };
    function ju_AbstractSequentialList_add($this, $index, $element) {
        var $iter, var$4, var$5;
        if ($index < 0) {
            $element = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_0($element);
            $rt_throw($element);
        }
        $iter = $java.ju_LinkedList_listIterator($this, $index);
        $java.ju_LinkedList$SequentialListIterator_checkConcurrentModification($iter);
        var$4 = new $java.ju_LinkedList$Entry;
        var$4.$item = $element;
        $element = $iter.$prevEntry;
        var$4.$previous = $element;
        var$5 = $iter.$nextEntry;
        var$4.$next8 = var$5;
        if ($element !== null)
            $element.$next8 = var$4;
        else
            $iter.$this$02.$firstEntry = var$4;
        if (var$5 !== null)
            var$5.$previous = var$4;
        else
            $iter.$this$02.$lastEntry = var$4;
        $iter.$prevEntry = var$4;
        $element = $iter.$this$02;
        $element.$size0 = $element.$size0 + 1 | 0;
        $index = $element.$modCount + 1 | 0;
        $element.$modCount = $index;
        $iter.$version = $index;
        $iter.$currentEntry = null;
    }
    $java.ju_AbstractSequentialList_iterator = function($this) {
        return $java.ju_LinkedList$SequentialListIterator__init_($this, $this.$firstEntry, null, 0);
    };
    $java.ju_Queue = $rt_classWithoutFields(0);
    $java.ju_Deque = $rt_classWithoutFields(0);
    function ju_LinkedList() {
        var a = this; ju_AbstractSequentialList.call(a);
        a.$firstEntry = null;
        a.$lastEntry = null;
        a.$size0 = 0;
    }
    $java.ju_LinkedList_size = function($this) {
        return $this.$size0;
    };
    $java.ju_LinkedList_listIterator = function($this, $index) {
        var $prev, var$3, $next, $i;
        if ($index < 0) {
            $prev = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_0($prev);
            $rt_throw($prev);
        }
        var$3 = $this.$size0;
        if ($index <= (var$3 / 2 | 0)) {
            $next = $this.$firstEntry;
            $i = 0;
            while ($i < $index) {
                $next = $next.$next8;
                $i = $i + 1 | 0;
            }
            return $java.ju_LinkedList$SequentialListIterator__init_($this, $next, $next === null ? null : $next.$previous, $index);
        }
        if ($index > var$3) {
            $prev = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_0($prev);
            $rt_throw($prev);
        }
        $prev = $this.$lastEntry;
        $i = $index;
        while ($i < var$3) {
            $prev = $prev.$previous;
            $i = $i + 1 | 0;
        }
        return $java.ju_LinkedList$SequentialListIterator__init_($this, $prev === null ? null : $prev.$next8, $prev, $index);
    };
    var onciafn_Neo4jASTConstructionException = $rt_classWithoutFields(jl_RuntimeException);
    function onciafn_Neo4jASTConstructionException__init_0(var_0) {
        var var_1 = new onciafn_Neo4jASTConstructionException();
        onciafn_Neo4jASTConstructionException__init_(var_1, var_0);
        return var_1;
    }
    function onciafn_Neo4jASTConstructionException__init_($this, $msg) {
        jl_Throwable__init_($this, $msg);
    }
    var onciaf_ASTFactory$MergeActionType = $rt_classWithoutFields(jl_Enum);
    var onciaf_ASTFactory$MergeActionType_OnCreate = null;
    var onciaf_ASTFactory$MergeActionType_OnMatch = null;
    $java.onciaf_ASTFactory$MergeActionType_$VALUES = null;
    function onciaf_ASTFactory$MergeActionType_$callClinit() {
        onciaf_ASTFactory$MergeActionType_$callClinit = $rt_eraseClinit(onciaf_ASTFactory$MergeActionType);
        $java.onciaf_ASTFactory$MergeActionType__clinit_();
    }
    $java.onciaf_ASTFactory$MergeActionType__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_ASTFactory$MergeActionType();
        $java.onciaf_ASTFactory$MergeActionType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_ASTFactory$MergeActionType_values() {
        onciaf_ASTFactory$MergeActionType_$callClinit();
        return $java.onciaf_ASTFactory$MergeActionType_$VALUES.$clone();
    }
    $java.onciaf_ASTFactory$MergeActionType__init_0 = function($this, var$1, var$2) {
        onciaf_ASTFactory$MergeActionType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_ASTFactory$MergeActionType__clinit_ = function() {
        var var$1;
        onciaf_ASTFactory$MergeActionType_OnCreate = $java.onciaf_ASTFactory$MergeActionType__init_($rt_s(1559), 0);
        var$1 = $java.onciaf_ASTFactory$MergeActionType__init_($rt_s(1560), 1);
        onciaf_ASTFactory$MergeActionType_OnMatch = var$1;
        $java.onciaf_ASTFactory$MergeActionType_$VALUES = $rt_createArrayFromData(onciaf_ASTFactory$MergeActionType, [onciaf_ASTFactory$MergeActionType_OnCreate, var$1]);
    };
    function sci_HashSet$diff$lambda$_60_0() {
        jl_Object.call(this);
        this.$_0171 = null;
    }
    $java.sci_HashSet$diff$lambda$_60_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$0.$_0171.$contains0(var$1));
    };
    function oncie_In() {
        var a = this; oncie_Expression.call(a);
        a.$lhs9 = null;
        a.$rhs10 = null;
        a.$position65 = null;
    }
    function oncie_In__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_In();
        $java.oncie_In__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_In_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_In_canonicalOperatorSymbol = function($this) {
        return $java.oncie_OperatorExpression_canonicalOperatorSymbol$($this);
    };
    $java.oncie_In_lhs = function($this) {
        return $this.$lhs9;
    };
    $java.oncie_In_rhs = function($this) {
        return $this.$rhs10;
    };
    $java.oncie_In_position = function($this) {
        return $this.$position65;
    };
    $java.oncie_In_copy = function($this, $lhs, $rhs, $position) {
        return oncie_In__init_($lhs, $rhs, $position);
    };
    $java.oncie_In_productPrefix = function($this) {
        return $rt_s(1561);
    };
    $java.oncie_In_productArity = function($this) {
        return 2;
    };
    $java.oncie_In_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs9;
            case 1:
                return $this.$rhs10;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_In_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_In_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_In_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_In_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_In) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs9;
                        var$3 = $x$1.$lhs9;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs10;
                        $x$1 = $x$1.$rhs10;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_In))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_In__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs9 = $lhs;
        $this.$rhs10 = $rhs;
        $this.$position65 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_ListLiteral() {
        var a = this; oncie_Expression.call(a);
        a.$expressions1 = null;
        a.$position66 = null;
    }
    function oncie_ListLiteral__init_(var_0, var_1) {
        var var_2 = new oncie_ListLiteral();
        $java.oncie_ListLiteral__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_ListLiteral_expressions($this) {
        return $this.$expressions1;
    }
    $java.oncie_ListLiteral_position = function($this) {
        return $this.$position66;
    };
    $java.oncie_ListLiteral_asCanonicalStringVal = function($this) {
        return sc_IterableOnceOps_mkString$($this.$expressions1.$map1(new $java.oncie_ListLiteral$asCanonicalStringVal$lambda$_5_0), $rt_s(143), $rt_s(16), $rt_s(144));
    };
    $java.oncie_ListLiteral_copy = function($this, $expressions, $position) {
        return oncie_ListLiteral__init_($expressions, $position);
    };
    $java.oncie_ListLiteral_productPrefix = function($this) {
        return $rt_s(1562);
    };
    $java.oncie_ListLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_ListLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expressions1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ListLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListLiteral_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListLiteral_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ListLiteral) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expressions1;
                        $x$1 = $x$1.$expressions1;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ListLiteral))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_ListLiteral__init_ = function($this, $expressions, $position) {
        $this.$expressions1 = $expressions;
        $this.$position66 = $position;
        $java.oncie_Expression__init_($this);
    };
    $java.oncie_BooleanLiteral = $rt_classWithoutFields(0);
    function oncie_False() {
        var a = this; oncie_Expression.call(a);
        a.$position68 = null;
        a.$value23 = null;
    }
    function oncie_False__init_(var_0) {
        var var_1 = new oncie_False();
        $java.oncie_False__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_False_position = function($this) {
        return $this.$position68;
    };
    $java.oncie_False_asCanonicalStringVal = function($this) {
        return $rt_s(387);
    };
    $java.oncie_False_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_False$$anon$11;
        $java.oncie_False__init_(var$1, $this.$position68);
        return var$1;
    };
    $java.oncie_False_copy = function($this, $position) {
        return oncie_False__init_($position);
    };
    $java.oncie_False_productPrefix = function($this) {
        return $rt_s(1563);
    };
    $java.oncie_False_productArity = function($this) {
        return 0;
    };
    $java.oncie_False_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_False_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_False_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_False;
    };
    $java.oncie_False_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_False_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_False_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_False) ? 0 : 1;
        return var$2 && $this instanceof oncie_False ? 1 : 0;
    };
    $java.oncie_False__init_ = function($this, $position) {
        $this.$position68 = $position;
        $java.oncie_Expression__init_($this);
        s_Predef$_$callClinit();
        $this.$value23 = jl_Boolean_valueOf(0);
    };
    function suh_MurmurHash3$accum$1() {
        var a = this; jl_Object.call(a);
        a.$a = 0;
        a.$b = 0;
        a.$n1 = 0;
        a.$c = 0;
    }
    $java.suh_MurmurHash3$accum$1_apply = function($this, $v1, $v2) {
        var var$3;
        suh_MurmurHash3$_$callClinit();
        var$3 = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $v1, $v2);
        $this.$a = $this.$a + var$3 | 0;
        $this.$b = $this.$b ^ var$3;
        $this.$c = $rt_imul($this.$c, var$3 | 1);
        $this.$n1 = $this.$n1 + 1 | 0;
        return sr_BoxedUnit_UNIT;
    };
    $java.oncias_SemanticCheck$Leaf = function() {
        jl_Object.call(this);
        this.$f9 = null;
    };
    $java.oncias_SemanticCheck$Leaf_run = function($this, $state, $context) {
        return oncias_SemanticCheck_run$($this, $state, $context);
    };
    $java.oncias_SemanticCheck$Leaf_apply = function($this, $state) {
        return oncias_SemanticCheck_apply$($this, $state);
    };
    $java.oncias_SemanticCheck$Leaf_chain = function($this, $next) {
        return oncias_SemanticCheck_chain$($this, $next);
    };
    $java.oncias_SemanticCheck$Leaf_ifOkChain = function($this, $next) {
        return oncias_SemanticCheck_ifOkChain$($this, $next);
    };
    $java.oncias_SemanticCheck$Leaf_map = function($this, $f) {
        return oncias_SemanticCheck_map$($this, $f);
    };
    $java.oncias_SemanticCheck$Leaf_flatMap = function($this, $f) {
        return oncias_SemanticCheck_flatMap$($this, $f);
    };
    $java.oncias_SemanticCheck$Leaf_productPrefix = function($this) {
        return $rt_s(1564);
    };
    $java.oncias_SemanticCheck$Leaf_productArity = function($this) {
        return 1;
    };
    $java.oncias_SemanticCheck$Leaf_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$f9;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheck$Leaf_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$Leaf_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$Leaf_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$Leaf_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncias_SemanticCheck$Leaf) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$f9;
                        $x$1 = $x$1.$f9;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.onciaf_EitherImpl = function() {
        var a = this; jl_Object.call(a);
        a.$left3 = null;
        a.$right2 = null;
    };
    $java.onciaf_EitherImpl__init_ = function(var_0, var_1) {
        var var_2 = new $java.onciaf_EitherImpl();
        $java.onciaf_EitherImpl__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.onciaf_EitherImpl__init_0 = function($this, $left, $right) {
        if ($left === null && $right === null) {
            $right = new jl_IllegalStateException;
            jl_Throwable__init_($right, $rt_s(1565));
            $rt_throw($right);
        }
        $this.$left3 = $left;
        $this.$right2 = $right;
    };
    function onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName() {
        onciaf_ParserCypherTypeName.call(this);
        this.$unionTypes = null;
    }
    function onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName_getUnionTypes($this) {
        return $this.$unionTypes;
    }
    var ju_Objects = $rt_classWithoutFields();
    function ju_Objects_equals($a, $b) {
        if ($a === $b)
            return 1;
        return $a !== null ? $a.$equals($b) : $b !== null ? 0 : 1;
    }
    $java.ju_Objects_requireNonNull = function($obj) {
        if ($obj !== null)
            return $obj;
        $obj = new jl_NullPointerException;
        jl_Throwable__init_($obj, $rt_s(3));
        $rt_throw($obj);
    };
    function scc_AsScalaExtensions$ListHasAsScala() {
        var a = this; jl_Object.call(a);
        a.$l = null;
        a.$$outer27 = null;
    }
    function scc_AsScalaExtensions$ListHasAsScala_asScala($this) {
        return scc_AsScalaConverters_asScala$($java.sjj_CollectionConverters$_MODULE$, $this.$l);
    }
    var oncia_ProjectionClause$verifyOrderByAggregationUse$lambda$_37_0 = $rt_classWithoutFields();
    $java.oncia_ProjectionClause$verifyOrderByAggregationUse$lambda$_37_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf((var$1.$sortItems.$map1(new $java.oncia_ProjectionClause$$anonfun$verifyOrderByAggregationUse$1$lambda$_58_0)).$exists($java.oncie_containsAggregate$_MODULE$));
    };
    $java.oncia_ProcedureResult = function() {
        var a = this; jl_Object.call(a);
        a.$items4 = null;
        a.$where9 = null;
        a.$position55 = null;
    };
    $java.oncia_ProcedureResult__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.oncia_ProcedureResult();
        $java.oncia_ProcedureResult__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncia_ProcedureResult_position = function($this) {
        return $this.$position55;
    };
    $java.oncia_ProcedureResult_copy = function($this, $items, $where, $position) {
        return $java.oncia_ProcedureResult__init_($items, $where, $position);
    };
    $java.oncia_ProcedureResult_productPrefix = function($this) {
        return $rt_s(1566);
    };
    $java.oncia_ProcedureResult_productArity = function($this) {
        return 2;
    };
    $java.oncia_ProcedureResult_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$items4;
            case 1:
                return $this.$where9;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ProcedureResult_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureResult_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureResult_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureResult_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_ProcedureResult) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$items4;
                        var$3 = $x$1.$items4;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$where9;
                        $x$1 = $x$1.$where9;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_ProcedureResult))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ProcedureResult_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ProcedureResult__init_0 = function($this, $items, $where, $position) {
        $this.$items4 = $items;
        $this.$where9 = $where;
        $this.$position55 = $position;
    };
    var oncia_ReturnItems$ = $rt_classWithoutFields();
    $java.oncia_ReturnItems$_MODULE$ = null;
    function oncia_ReturnItems$__clinit_() {
        $java.oncia_ReturnItems$_MODULE$ = new oncia_ReturnItems$;
    }
    var oncia_With$ = $rt_classWithoutFields();
    $java.oncia_With$_MODULE$ = null;
    function oncia_With$__clinit_() {
        $java.oncia_With$_MODULE$ = new oncia_With$;
    }
    function sc_StrictOptimizedMapOps$collect$lambda$_7_0() {
        jl_Object.call(this);
        this.$_0217 = null;
    }
    $java.sc_StrictOptimizedMapOps$collect$lambda$_7_0_apply = function(var$0, var$1) {
        return var$0.$_0217;
    };
    var sc_MapOps$addString$lambda$_49_0 = $rt_classWithoutFields();
    $java.sc_MapOps$addString$lambda$_49_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(null));
        var$2 = var$1.$_10;
        var$3 = var$1.$_20;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 4);
        var$1 = jl_StringBuilder_append(var$1, var$2);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(1567));
        return jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$1, var$3));
    };
    function sc_SeqView$Id() {
        sc_AbstractSeqView.call(this);
        this.$underlying23 = null;
    }
    function sc_SeqView$Id__init_(var_0) {
        var var_1 = new sc_SeqView$Id();
        sc_SeqView$Id__init_0(var_1, var_0);
        return var_1;
    }
    $java.sc_SeqView$Id_apply = function($this, $idx) {
        return $this.$underlying23.$apply1($idx);
    };
    $java.sc_SeqView$Id_length = function($this) {
        return $this.$underlying23.$length();
    };
    $java.sc_SeqView$Id_iterator = function($this) {
        return $this.$underlying23.$iterator0();
    };
    $java.sc_SeqView$Id_knownSize = function($this) {
        return $this.$underlying23.$knownSize();
    };
    $java.sc_SeqView$Id_isEmpty = function($this) {
        return $this.$underlying23.$isEmpty();
    };
    function sc_SeqView$Id__init_0($this, $underlying) {
        $this.$underlying23 = $underlying;
    }
    var sc_IndexedSeqView$Id = $rt_classWithoutFields(sc_SeqView$Id);
    $java.sc_IndexedSeqView$Id_iterator = function($this) {
        return sc_IndexedSeqView_iterator$($this);
    };
    $java.sc_IndexedSeqView$Id_reverseIterator = function($this) {
        return $java.sc_IndexedSeqView$IndexedSeqViewReverseIterator__init_($this);
    };
    $java.sc_IndexedSeqView$Id_reverse = function($this) {
        return sc_IndexedSeqView$Reverse__init_($this);
    };
    $java.sc_IndexedSeqView$Id_knownSize = function($this) {
        return $this.$length();
    };
    function oncia_SubqueryCall() {
        var a = this; jl_Object.call(a);
        a.$innerQuery = null;
        a.$inTransactionsParameters = null;
        a.$position67 = null;
        a.$LabelExpressionsPartition$module4 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier4 = null;
        a.$SetExtractor$module4 = null;
    }
    function oncia_SubqueryCall__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_SubqueryCall();
        $java.oncia_SubqueryCall__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_SubqueryCall_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_SubqueryCall_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_SubqueryCall_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_SubqueryCall_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_SubqueryCall_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_SubqueryCall_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_SubqueryCall_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_SubqueryCall_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module4 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module4 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module4 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module4;
    };
    $java.oncia_SubqueryCall_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier4;
    };
    $java.oncia_SubqueryCall_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module4 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module4 !== null)
                        break a;
                    $this.$SetExtractor$module4 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module4;
    };
    $java.oncia_SubqueryCall_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier4 = $x$1;
    };
    $java.oncia_SubqueryCall_position = function($this) {
        return $this.$position67;
    };
    $java.oncia_SubqueryCall_name = function($this) {
        return $rt_s(1398);
    };
    $java.oncia_SubqueryCall_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$innerQuery.$checkImportingWith();
        var$2 = new $java.oncia_SubqueryCall$checkSubquery$lambda$_62_0;
        var$2.$_0375 = $this;
        var$3 = var$1.$flatMap3(var$2);
        var$1 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = $this.$inTransactionsParameters;
        var$2 = new $java.oncia_SubqueryCall$clauseSpecificSemanticCheck$lambda$_60_0;
        var$2.$_0376 = $this;
        var$3 = oncias_SemanticCheck_chain$(var$3, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$1, var$4, var$2));
        var$1 = !s_Option_isEmpty($this.$inTransactionsParameters) ? s_None$_MODULE$ : $java.oncia_SubqueryCall$_findTransactionalSubquery($java.oncia_SubqueryCall$_MODULE$, $this.$innerQuery);
        var$2 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = new $java.oncia_SubqueryCall$checkNoCallInTransactionsInsideRegularCall$lambda$_68_0;
        var$4.$_0377 = $this;
        return oncias_SemanticCheck_chain$(var$3, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$2, var$1, var$4));
    };
    $java.oncia_SubqueryCall_semanticCheckContinuation = function($this, $previousScope, $outerScope) {
        var var$3;
        $outerScope = oncias_package$_MODULE$;
        var$3 = new $java.oncia_SubqueryCall$semanticCheckContinuation$lambda$_64_0;
        var$3.$_0378 = $previousScope;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck($outerScope, var$3);
    };
    $java.oncia_SubqueryCall_productPrefix = function($this) {
        return $rt_s(1568);
    };
    $java.oncia_SubqueryCall_productArity = function($this) {
        return 2;
    };
    $java.oncia_SubqueryCall_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$innerQuery;
            case 1:
                return $this.$inTransactionsParameters;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_SubqueryCall) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$innerQuery;
                        var$3 = $x$1.$innerQuery;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$inTransactionsParameters;
                        $x$1 = $x$1.$inTransactionsParameters;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_SubqueryCall))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_SubqueryCall_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SubqueryCall__init_ = function($this, $innerQuery, $inTransactionsParameters, $position) {
        $this.$innerQuery = $innerQuery;
        $this.$inTransactionsParameters = $inTransactionsParameters;
        $this.$position67 = $position;
        oncia_Clause_$init$($this);
    };
    var oncia_SubqueryCall$ = $rt_classWithoutFields();
    $java.oncia_SubqueryCall$_MODULE$ = null;
    function oncia_SubqueryCall$__clinit_() {
        $java.oncia_SubqueryCall$_MODULE$ = new oncia_SubqueryCall$;
    }
    $java.oncia_SubqueryCall$_isTransactionalSubquery = function($this, $clause) {
        return s_Option_isDefined($clause.$inTransactionsParameters);
    };
    $java.oncia_SubqueryCall$_findTransactionalSubquery = function($this, $node) {
        var var$2;
        var$2 = $node.$folder();
        $node = new $java.oncia_SubqueryCall$$anonfun$findTransactionalSubquery$1;
        sr_ClassTag$_$callClinit();
        return onciu_Foldable$Folder_treeFind(var$2, $node, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncia_SubqueryCall)));
    };
    function oncias_SemanticError() {
        var a = this; jl_Object.call(a);
        a.$msg = null;
        a.$position69 = null;
    }
    function oncias_SemanticError__init_0(var_0, var_1) {
        var var_2 = new oncias_SemanticError();
        oncias_SemanticError__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncias_SemanticError_msg = function($this) {
        return $this.$msg;
    };
    $java.oncias_SemanticError_productPrefix = function($this) {
        return $rt_s(1569);
    };
    $java.oncias_SemanticError_productArity = function($this) {
        return 2;
    };
    $java.oncias_SemanticError_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$msg;
            case 1:
                return $this.$position69;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticError_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticError_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticError_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticError_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_SemanticError) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$msg;
                            var$3 = $x$1.$msg;
                            if (var$2 !== null) {
                                if (!jl_String_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$position69;
                        $x$1 = $x$1.$position69;
                        if (var$3 !== null) {
                            if (!onciu_InputPosition_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncias_SemanticError_withMsg = function($this, $message) {
        return oncias_SemanticError__init_0($message, $this.$position69);
    };
    function oncias_SemanticError__init_($this, $msg, $position) {
        $this.$msg = $msg;
        $this.$position69 = $position;
    }
    $java.oncia_SingleQuery$$anonfun$$nestedInanonfun$checkNoCallInTransactionsAfterWriteClause$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_SingleQuery$$anonfun$$nestedInanonfun$checkNoCallInTransactionsAfterWriteClause$1$1_applyOrElse = function($this, $x1, $default) {
        if (!$rt_isInstance($x1, $java.oncia_UpdateClause))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(1);
    };
    var juf_Function = $rt_classWithoutFields(0);
    function juf_Function_andThen($this, $after) {
        var var$2;
        var$2 = new $java.juf_Function$andThen$lambda$_2_0;
        var$2.$_0379 = $this;
        var$2.$_1111 = $after;
        return var$2;
    }
    $java.onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName$_init_$lambda$_0_0 = $rt_classWithoutFields();
    $java.onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName$_init_$lambda$_0_0_apply = function(var$0, var$1) {
        return var$1.$typeName0;
    };
    $java.oncia_UnmappedUnion$$init$$lambda$_16_0 = function() {
        jl_Object.call(this);
        this.$_0349 = null;
    };
    $java.oncia_UnmappedUnion$$init$$lambda$_16_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0349;
        var$3 = oncia_Query_returnColumns$(var$2.$rhs());
        var$4 = new $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_0;
        var$4.$_0380 = var$1;
        var$4 = sci_List_find(var$3, var$4);
        var$3 = new $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_1;
        var$3.$_0381 = var$2;
        var$3.$_1112 = var$1;
        return s_Option_map(var$4, var$3);
    };
    var oncias_SemanticAnalysisTooling$ = $rt_classWithoutFields();
    var oncias_SemanticAnalysisTooling$_MODULE$ = null;
    var oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScope = null;
    $java.oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$popStateScope = null;
    function oncias_SemanticAnalysisTooling$_$callClinit() {
        oncias_SemanticAnalysisTooling$_$callClinit = $rt_eraseClinit(oncias_SemanticAnalysisTooling$);
        $java.oncias_SemanticAnalysisTooling$__clinit_();
    }
    $java.oncias_SemanticAnalysisTooling$__clinit_ = function() {
        var var$1;
        var$1 = new oncias_SemanticAnalysisTooling$;
        oncias_SemanticAnalysisTooling$_$callClinit();
        oncias_SemanticAnalysisTooling$_MODULE$ = var$1;
        oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScope = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(oncias_package$_MODULE$, new $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_0);
        $java.oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$popStateScope = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(oncias_package$_MODULE$, new $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_1);
    };
    function oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$popStateScope($this) {
        oncias_SemanticAnalysisTooling$_$callClinit();
        return $java.oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$popStateScope;
    }
    var oncia_Query$checkUse$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncia_Query$checkUse$lambda$_11_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$features1.$contains0(oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$));
    };
    function oncia_Query$checkUse$lambda$_11_1() {
        jl_Object.call(this);
        this.$_0291 = null;
    }
    $java.oncia_Query$checkUse$lambda$_11_1_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0291.$folder();
        sr_ClassTag$_$callClinit();
        var$2 = onciu_Foldable$Folder_findAllByClass(var$1, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncia_UseGraph)));
        if ((sc_AbstractIterable_toSet(var$2.$map1(new $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_0))).$size() <= 1)
            var$2 = oncias_SemanticCheck$_success;
        else {
            var$3 = oncias_SemanticCheck$_MODULE$;
            var$1 = new $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_1;
            var$1.$_0382 = var$2;
            var$2 = $java.oncias_SemanticCheck$_fromFunctionWithContext(var$3, var$1);
        }
        return var$2;
    };
    function oncia_Query$checkUse$lambda$_11_2() {
        var a = this; jl_Object.call(a);
        a.$_0292 = null;
        a.$_190 = null;
    }
    $java.oncia_Query$checkUse$lambda$_11_2_apply = function(var$0) {
        return var$0.$_0292.$whenState$default$3(var$0.$_190);
    };
    function oncias_SemanticAnalysisTooling$recordCurrentScope$lambda$_67_0() {
        jl_Object.call(this);
        this.$_0288 = null;
    }
    $java.oncias_SemanticAnalysisTooling$recordCurrentScope$lambda$_67_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0288;
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, oncias_SemanticState_recordCurrentScope(var$1, var$2));
    };
    $java.sc_SeqView$Reverse = function() {
        sc_AbstractSeqView.call(this);
        this.$underlying24 = null;
    };
    $java.sc_SeqView$Reverse_apply = function($this, $i) {
        return $this.$underlying24.$apply1(($java.sc_SeqView$Reverse_length($this) - 1 | 0) - $i | 0);
    };
    $java.sc_SeqView$Reverse_length = function($this) {
        var var$1;
        var$1 = $this.$underlying24;
        if (var$1 !== null)
            return var$1.$length();
        $rt_throw(null);
    };
    function sc_IndexedSeqView$Reverse() {
        $java.sc_SeqView$Reverse.call(this);
        this.$underlying25 = null;
    }
    function sc_IndexedSeqView$Reverse__init_(var_0) {
        var var_1 = new sc_IndexedSeqView$Reverse();
        sc_IndexedSeqView$Reverse__init_0(var_1, var_0);
        return var_1;
    }
    $java.sc_IndexedSeqView$Reverse_iterator = function($this) {
        return sc_IndexedSeqView_iterator$($this);
    };
    $java.sc_IndexedSeqView$Reverse_knownSize = function($this) {
        return $this.$length();
    };
    function sc_IndexedSeqView$Reverse__init_0($this, $underlying) {
        $this.$underlying25 = $underlying;
        $this.$underlying24 = $underlying;
    }
    var onciu_StepSequencer$$anonfun$orderSteps$16$lambda$_34_0 = $rt_classWithoutFields();
    $java.onciu_StepSequencer$$anonfun$orderSteps$16$lambda$_34_0_apply = function(var$0, var$1) {
        return var$1.$_20;
    };
    var onciu_StepSequencer$$anonfun$orderSteps$8$lambda$_26_0 = $rt_classWithoutFields();
    $java.onciu_StepSequencer$$anonfun$orderSteps$8$lambda$_26_0_apply = function(var$0, var$1) {
        return (su_Either_toOption(var$1.$_20)).$get0();
    };
    $java.sc_Map$ = $rt_classWithoutFields(sc_MapFactory$Delegate);
    $java.sc_Map$_MODULE$ = null;
    $java.sc_Map$_DefaultSentinel = null;
    $java.sc_Map$_scala$collection$Map$$DefaultSentinelFn = null;
    $java.sc_Map$_$callClinit = function() {
        $java.sc_Map$_$callClinit = $rt_eraseClinit($java.sc_Map$);
        $java.sc_Map$__clinit_();
    };
    $java.sc_Map$__clinit_ = function() {
        var var$1;
        var$1 = new $java.sc_Map$;
        $java.sc_Map$_$callClinit();
        sc_MapFactory$Delegate__init_0(var$1, sci_Map$_MODULE$);
        $java.sc_Map$_MODULE$ = var$1;
        $java.sc_Map$_DefaultSentinel = new jl_Object;
        $java.sc_Map$_scala$collection$Map$$DefaultSentinelFn = new $java.sc_Map$$_clinit_$lambda$_0_0;
    };
    $java.jus_BaseStream = $rt_classWithoutFields(0);
    var jus_Stream = $rt_classWithoutFields(0);
    function jus_Stream_toList($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.ju_TemplateCollections$ImmutableArrayList;
        var$2 = $java.jusi_WrappingStreamImpl_estimateSize($this);
        if (var$2 >= 0) {
            var$3 = $rt_createArray(jl_Object, var$2);
            var$4 = new $java.jusi_SimpleStreamImpl$ArrayFillingConsumer;
            var$4.$array5 = var$3;
            while ($java.jusi_WrappingStreamImpl_next($this, var$4)) {
            }
            var$5 = var$3.data;
            var$2 = var$4.$index1;
            if (var$2 < var$5.length)
                var$3 = ju_Arrays_copyOf(var$3, var$2);
        } else {
            var$4 = ju_ArrayList__init_();
            while (true) {
                $java.ju_Objects_requireNonNull(var$4);
                var$6 = new $java.jusi_SimpleStreamImpl$toArray$lambda$_20_0;
                var$6.$_0383 = var$4;
                if (!$java.jusi_WrappingStreamImpl_next($this, var$6))
                    break;
            }
            var$3 = $rt_createArray(jl_Object, var$4.$size2);
            var$5 = var$3.data;
            var$7 = 0;
            var$8 = var$5.length;
            while (var$7 < var$8) {
                var$5[var$7] = ju_ArrayList_get(var$4, var$7);
                var$7 = var$7 + 1 | 0;
            }
        }
        var$1.$list1 = var$3;
        return var$1;
    }
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNeitherOrsNorInnerScopes$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNeitherOrsNorInnerScopes$1$1_applyOrElse = function($this, $x1, $default) {
        if ($x1 instanceof oncie_Or)
            return jl_Boolean_valueOf(1);
        if (!$rt_isInstance($x1, $java.oncie_ScopeExpression))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(1);
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containIns$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containIns$1$1_applyOrElse = function($this, $x1, $default) {
        if (!($x1 instanceof oncie_In))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(1);
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoNots$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoNots$1$1_applyOrElse = function($this, $x1, $default) {
        if (!($x1 instanceof oncie_Not))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(1);
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNots$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNots$1$1_applyOrElse = function($this, $x1, $default) {
        if (!($x1 instanceof oncie_Not))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(1);
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoAnds$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoAnds$1$1_applyOrElse = function($this, $x1, $default) {
        if (!($x1 instanceof oncie_And))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(1);
    };
    $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticAnalysisTooling$_$callClinit();
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, oncias_SemanticState_newChildScope(var$1));
    };
    $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_1 = $rt_classWithoutFields();
    $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticAnalysisTooling$_$callClinit();
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, oncias_SemanticState_popScope(var$1));
    };
    $java.sc_Map$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.sc_Map$$_clinit_$lambda$_0_0_apply = function(var$0) {
        $java.sc_Map$_$callClinit();
        return $java.sc_Map$_DefaultSentinel;
    };
    $java.oncia_ReturnItems$containsAggregate$lambda$_63_0 = $rt_classWithoutFields();
    $java.oncia_ReturnItems$containsAggregate$lambda$_63_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf($java.oncie_Expression_containsAggregate(var$1.$expression1()));
    };
    function oncir_Deprecation() {
        var a = this; jl_Object.call(a);
        a.$replacement2 = null;
        a.$notification = null;
    }
    function oncir_Deprecation__init_0(var_0, var_1) {
        var var_2 = new oncir_Deprecation();
        oncir_Deprecation__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncir_Deprecation_productPrefix = function($this) {
        return $rt_s(1570);
    };
    $java.oncir_Deprecation_productArity = function($this) {
        return 2;
    };
    $java.oncir_Deprecation_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$replacement2;
            case 1:
                return $this.$notification;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncir_Deprecation_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncir_Deprecation_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncir_Deprecation_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncir_Deprecation_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncir_Deprecation) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$replacement2;
                        var$3 = $x$1.$replacement2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$notification;
                        $x$1 = $x$1.$notification;
                        if (var$3 !== null) {
                            if (!s_Some_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncir_Deprecation))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncir_Deprecation__init_($this, $replacement, $notification) {
        $this.$replacement2 = $replacement;
        $this.$notification = $notification;
    }
    $java.onciu_InternalNotification = $rt_classWithoutFields(0);
    function scm_ArrayDeque$addAll$lambda$_98_0() {
        jl_Object.call(this);
        this.$_0259 = null;
    }
    $java.scm_ArrayDeque$addAll$lambda$_98_0_apply = function(var$0, var$1) {
        return var$0.$_0259.$addOne(var$1);
    };
    function scm_ArrayDeque$addAll$lambda$_98_1() {
        jl_Object.call(this);
        this.$_0260 = null;
    }
    $java.scm_ArrayDeque$addAll$lambda$_98_1_apply = function(var$0, var$1) {
        return scm_ArrayDeque_scala$collection$mutable$ArrayDeque$$appendAssumingCapacity(var$0.$_0260, var$1);
    };
    $java.oncie_False$$anon$11 = $rt_classWithoutFields(oncie_False);
    var oncia_DefaultWith$ = $rt_classWithoutFields();
    var oncia_DefaultWith$_MODULE$ = null;
    function oncia_DefaultWith$__clinit_() {
        oncia_DefaultWith$_MODULE$ = new oncia_DefaultWith$;
    }
    $java.oncia_DefaultWith$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DefaultWith$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DefaultWith$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultWith$_hashCode = function($this) {
        return 1231002247;
    };
    $java.oncia_DefaultWith$_toString = function($this) {
        return $rt_s(1571);
    };
    function sc_View$Filter() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying26 = null;
        a.$p2 = null;
        a.$isFlipped = 0;
    }
    function sc_View$Filter__init_(var_0, var_1, var_2) {
        var var_3 = new sc_View$Filter();
        $java.sc_View$Filter__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.sc_View$Filter_iterator = function($this) {
        return ($this.$underlying26.$iterator0()).$filterImpl0($this.$p2, $this.$isFlipped);
    };
    $java.sc_View$Filter_knownSize = function($this) {
        if ($this.$underlying26.$knownSize())
            return (-1);
        return 0;
    };
    $java.sc_View$Filter_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($java.sc_View$Filter_iterator($this));
    };
    $java.sc_View$Filter__init_ = function($this, $underlying, $p, $isFlipped) {
        $this.$underlying26 = $underlying;
        $this.$p2 = $p;
        $this.$isFlipped = $isFlipped;
    };
    var oncie_Parameter = $rt_classWithoutFields(0);
    function ju_HashMap() {
        var a = this; ju_AbstractMap.call(a);
        a.$elementCount1 = 0;
        a.$elementData1 = null;
        a.$modCount2 = 0;
        a.$loadFactor2 = 0.0;
        a.$threshold2 = 0;
    }
    $java.ju_HashMap__init_ = function() {
        var var_0 = new ju_HashMap();
        $java.ju_HashMap__init_0(var_0);
        return var_0;
    };
    $java.ju_HashMap_newElementArray = function($this, $s) {
        return $rt_createArray($java.ju_HashMap$HashEntry, $s);
    };
    $java.ju_HashMap__init_0 = function($this) {
        var var$1;
        var$1 = $java.ju_HashMap_calculateCapacity(16);
        $this.$elementCount1 = 0;
        $this.$elementData1 = $this.$newElementArray(var$1);
        $this.$loadFactor2 = 0.75;
        $java.ju_HashMap_computeThreshold($this);
    };
    $java.ju_HashMap_calculateCapacity = function($x) {
        var var$2;
        if ($x >= 1073741824)
            return 1073741824;
        if (!$x)
            return 16;
        var$2 = $x - 1 | 0;
        $x = var$2 | var$2 >> 1;
        $x = $x | $x >> 2;
        $x = $x | $x >> 4;
        $x = $x | $x >> 8;
        return ($x | $x >> 16) + 1 | 0;
    };
    $java.ju_HashMap_computeThreshold = function($this) {
        $this.$threshold2 = $this.$elementData1.data.length * $this.$loadFactor2 | 0;
    };
    function ju_HashMap_containsKey($this, $key) {
        return $java.ju_HashMap_getEntry($this, $key) === null ? 0 : 1;
    }
    $java.ju_HashMap_getEntry = function($this, $key) {
        var $m, $hash;
        if ($key === null)
            $m = $java.ju_HashMap_findNullKeyEntry($this);
        else {
            $hash = $key.$hashCode0();
            $m = $java.ju_HashMap_findNonNullKeyEntry($this, $key, $hash & ($this.$elementData1.data.length - 1 | 0), $hash);
        }
        return $m;
    };
    $java.ju_HashMap_findNonNullKeyEntry = function($this, $key, $index, $keyHash) {
        var $m;
        $m = $this.$elementData1.data[$index];
        while ($m !== null && !($m.$origKeyHash == $keyHash && $java.ju_HashMap_areEqualKeys($key, $m.$key0))) {
            $m = $m.$next10;
        }
        return $m;
    };
    $java.ju_HashMap_findNullKeyEntry = function($this) {
        var $m;
        $m = $this.$elementData1.data[0];
        while ($m !== null && $m.$key0 !== null) {
            $m = $m.$next10;
        }
        return $m;
    };
    $java.ju_HashMap_isEmpty = function($this) {
        return $this.$elementCount1 ? 0 : 1;
    };
    function ju_HashMap_put($this, $key, $value) {
        var var$3, var$4, var$5;
        if ($key === null) {
            var$3 = $java.ju_HashMap_findNullKeyEntry($this);
            if (var$3 === null) {
                $this.$modCount2 = $this.$modCount2 + 1 | 0;
                var$3 = $java.ju_HashMap_createHashedEntry($this, null, 0, 0);
                var$4 = $this.$elementCount1 + 1 | 0;
                $this.$elementCount1 = var$4;
                if (var$4 > $this.$threshold2)
                    $java.ju_HashMap_rehash($this);
            }
        } else {
            var$4 = $key.$hashCode0();
            var$5 = var$4 & ($this.$elementData1.data.length - 1 | 0);
            var$3 = $java.ju_HashMap_findNonNullKeyEntry($this, $key, var$5, var$4);
            if (var$3 === null) {
                $this.$modCount2 = $this.$modCount2 + 1 | 0;
                var$3 = $java.ju_HashMap_createHashedEntry($this, $key, var$5, var$4);
                var$4 = $this.$elementCount1 + 1 | 0;
                $this.$elementCount1 = var$4;
                if (var$4 > $this.$threshold2)
                    $java.ju_HashMap_rehash($this);
            }
        }
        $key = var$3.$value12;
        var$3.$value12 = $value;
        return $key;
    }
    $java.ju_HashMap_createHashedEntry = function($this, $key, $index, $hash) {
        var $entry, var$5;
        $entry = $java.ju_HashMap$HashEntry__init_($key, $hash);
        var$5 = $this.$elementData1.data;
        $entry.$next10 = var$5[$index];
        var$5[$index] = $entry;
        return $entry;
    };
    $java.ju_HashMap_rehash0 = function($this, $capacity) {
        var $length, $newData, $i, var$5, $entry, $index, $next;
        $length = $java.ju_HashMap_calculateCapacity(!$capacity ? 1 : $capacity << 1);
        $newData = $this.$newElementArray($length);
        $i = 0;
        $length = $length - 1 | 0;
        while (true) {
            var$5 = $this.$elementData1.data;
            if ($i >= var$5.length)
                break;
            $entry = var$5[$i];
            var$5[$i] = null;
            while ($entry !== null) {
                var$5 = $newData.data;
                $index = $entry.$origKeyHash & $length;
                $next = $entry.$next10;
                $entry.$next10 = var$5[$index];
                var$5[$index] = $entry;
                $entry = $next;
            }
            $i = $i + 1 | 0;
        }
        $this.$elementData1 = $newData;
        $java.ju_HashMap_computeThreshold($this);
    };
    $java.ju_HashMap_rehash = function($this) {
        $java.ju_HashMap_rehash0($this, $this.$elementData1.data.length);
    };
    $java.ju_HashMap_areEqualKeys = function($key1, $key2) {
        return $key1 !== $key2 && !$key1.$equals($key2) ? 0 : 1;
    };
    function ju_LinkedHashMap() {
        var a = this; ju_HashMap.call(a);
        a.$accessOrder = 0;
        a.$head2 = null;
        a.$tail5 = null;
    }
    function ju_LinkedHashMap__init_() {
        var var_0 = new ju_LinkedHashMap();
        $java.ju_LinkedHashMap__init_(var_0);
        return var_0;
    }
    $java.ju_LinkedHashMap__init_ = function($this) {
        $java.ju_HashMap__init_0($this);
        $this.$accessOrder = 0;
        $this.$head2 = null;
    };
    $java.ju_LinkedHashMap_newElementArray = function($this, $s) {
        return $rt_createArray($java.ju_LinkedHashMap$LinkedHashMapEntry, $s);
    };
    function ju_LinkedHashMap_get($this, $key) {
        var $m, $hash, $p, $n;
        if ($key === null)
            $m = $java.ju_HashMap_findNullKeyEntry($this);
        else {
            $hash = $key.$hashCode0();
            $m = $java.ju_HashMap_findNonNullKeyEntry($this, $key, ($hash & 2147483647) % $this.$elementData1.data.length | 0, $hash);
        }
        if ($m === null)
            return null;
        if ($this.$accessOrder) {
            $key = $this.$tail5;
            if ($key !== $m) {
                $p = $m.$chainBackward;
                $n = $m.$chainForward;
                $n.$chainBackward = $p;
                if ($p === null)
                    $this.$head2 = $n;
                else
                    $p.$chainForward = $n;
                $m.$chainForward = null;
                $m.$chainBackward = $key;
                $key.$chainForward = $m;
                $this.$tail5 = $m;
            }
        }
        return $m.$value12;
    }
    $java.ju_LinkedHashMap_createHashedEntry = function($this, $key, $index, $hash) {
        var $m, var$5;
        $m = new $java.ju_LinkedHashMap$LinkedHashMapEntry;
        $java.ju_HashMap$HashEntry__init_0($m, $key, $hash);
        $m.$chainForward = null;
        $m.$chainBackward = null;
        var$5 = $this.$elementData1.data;
        $m.$next10 = var$5[$index];
        var$5[$index] = $m;
        $java.ju_LinkedHashMap_linkEntry($this, $m);
        return $m;
    };
    function ju_LinkedHashMap_put($this, $key, $value) {
        var var$3, var$4, var$5, var$6, var$7, $result;
        if (!$this.$elementCount1) {
            $this.$head2 = null;
            $this.$tail5 = null;
        }
        if ($key === null) {
            var$3 = $java.ju_HashMap_findNullKeyEntry($this);
            if (var$3 !== null)
                $java.ju_LinkedHashMap_linkEntry($this, var$3);
            else {
                $this.$modCount2 = $this.$modCount2 + 1 | 0;
                var$4 = $this.$elementCount1 + 1 | 0;
                $this.$elementCount1 = var$4;
                if (var$4 > $this.$threshold2)
                    $java.ju_HashMap_rehash($this);
                var$3 = $java.ju_LinkedHashMap_createHashedEntry($this, null, 0, 0);
            }
        } else {
            var$5 = jl_String_hashCode($key);
            var$6 = var$5 & 2147483647;
            var$4 = var$6 % $this.$elementData1.data.length | 0;
            var$3 = $java.ju_HashMap_findNonNullKeyEntry($this, $key, var$4, var$5);
            if (var$3 !== null)
                $java.ju_LinkedHashMap_linkEntry($this, var$3);
            else {
                $this.$modCount2 = $this.$modCount2 + 1 | 0;
                var$7 = $this.$elementCount1 + 1 | 0;
                $this.$elementCount1 = var$7;
                if (var$7 > $this.$threshold2) {
                    $java.ju_HashMap_rehash($this);
                    var$4 = var$6 % $this.$elementData1.data.length | 0;
                }
                var$3 = $java.ju_LinkedHashMap_createHashedEntry($this, $key, var$4, var$5);
            }
        }
        $result = var$3.$value12;
        var$3.$value12 = $value;
        return $result;
    }
    $java.ju_LinkedHashMap_linkEntry = function($this, $m) {
        var var$2, $p, $n;
        var$2 = $this.$tail5;
        if (var$2 === $m)
            return;
        if ($this.$head2 === null) {
            $this.$head2 = $m;
            $this.$tail5 = $m;
            return;
        }
        $p = $m.$chainBackward;
        $n = $m.$chainForward;
        if ($p !== null) {
            if ($n === null)
                return;
            if ($this.$accessOrder) {
                $p.$chainForward = $n;
                $n.$chainBackward = $p;
                $m.$chainForward = null;
                $m.$chainBackward = var$2;
                var$2.$chainForward = $m;
                $this.$tail5 = $m;
            }
            return;
        }
        if ($n === null) {
            $m.$chainBackward = var$2;
            $m.$chainForward = null;
            var$2.$chainForward = $m;
            $this.$tail5 = $m;
        } else if ($this.$accessOrder) {
            $this.$head2 = $n;
            $n.$chainBackward = null;
            $m.$chainBackward = var$2;
            $m.$chainForward = null;
            var$2.$chainForward = $m;
            $this.$tail5 = $m;
        }
    };
    function ju_LinkedHashMap_entrySet($this) {
        var var$1;
        var$1 = new ju_LinkedHashMap$LinkedHashMapEntrySet;
        var$1.$associatedMap = $this;
        return var$1;
    }
    $java.oncia_WriteAdministrationCommand = $rt_classWithoutFields(0);
    $java.oncia_WriteAdministrationCommand_topologyCheck$ = function($$this, $topology, $command) {
        var var$4;
        var$4 = new $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_0;
        var$4.$_0384 = $$this;
        var$4.$_1113 = $command;
        return s_Option_getOrElse(s_Option_map($topology, var$4), new $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_1);
    };
    $java.oncia_WriteAdministrationCommand_$init$ = function($$this) {
        $$this.$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq(0);
    };
    function oncia_CreateRemoteDatabaseAlias() {
        var a = this; jl_Object.call(a);
        a.$aliasName2 = null;
        a.$targetName1 = null;
        a.$ifExistsDo1 = null;
        a.$url1 = null;
        a.$username1 = null;
        a.$password1 = null;
        a.$driverSettings0 = null;
        a.$properties6 = null;
        a.$position70 = null;
        a.$isReadOnly8 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar9 = null;
    }
    $java.oncia_CreateRemoteDatabaseAlias__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8) {
        var var_9 = new oncia_CreateRemoteDatabaseAlias();
        oncia_CreateRemoteDatabaseAlias__init_(var_9, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8);
        return var_9;
    };
    $java.oncia_CreateRemoteDatabaseAlias_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_CreateRemoteDatabaseAlias_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateRemoteDatabaseAlias_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateRemoteDatabaseAlias_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly8 = $x$1;
    };
    $java.oncia_CreateRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar9;
    };
    $java.oncia_CreateRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar9 = $x$1;
    };
    function oncia_CreateRemoteDatabaseAlias_aliasName($this) {
        return $this.$aliasName2;
    }
    function oncia_CreateRemoteDatabaseAlias_targetName($this) {
        return $this.$targetName1;
    }
    function oncia_CreateRemoteDatabaseAlias_ifExistsDo($this) {
        return $this.$ifExistsDo1;
    }
    function oncia_CreateRemoteDatabaseAlias_url($this) {
        return $this.$url1;
    }
    function oncia_CreateRemoteDatabaseAlias_username($this) {
        return $this.$username1;
    }
    function oncia_CreateRemoteDatabaseAlias_password($this) {
        return $this.$password1;
    }
    function oncia_CreateRemoteDatabaseAlias_driverSettings($this) {
        return $this.$driverSettings0;
    }
    function oncia_CreateRemoteDatabaseAlias_properties($this) {
        return $this.$properties6;
    }
    $java.oncia_CreateRemoteDatabaseAlias_position = function($this) {
        return $this.$position70;
    };
    function oncia_CreateRemoteDatabaseAlias_name($this) {
        var var$1;
        var$1 = $this.$ifExistsDo1;
        if (!(jl_Object_equals(oncia_IfExistsReplace$_MODULE$, var$1) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1) ? 0 : 1))
            return $rt_s(1572);
        return $rt_s(1573);
    }
    $java.oncia_CreateRemoteDatabaseAlias_semanticCheck = function($this) {
        var $expr, $expr_0, var$3;
        $expr = $this.$ifExistsDo1;
        if (jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $expr)) {
            $expr_0 = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $this.$aliasName2, s_DummyImplicit$_dummyImplicit0);
            $expr = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($expr);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($expr, $rt_s(1574)), $expr_0), $rt_s(1575));
            return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString($expr), $this.$position70);
        }
        var$3 = 0;
        $expr_0 = null;
        $expr = $java.oncia_AliasDriverSettingsCheck$_findInvalidDriverSettings($java.oncia_AliasDriverSettingsCheck$_MODULE$, $this.$driverSettings0);
        if ($expr instanceof s_Some) {
            var$3 = 1;
            $expr_0 = $expr;
            $expr = $expr_0.$value5;
            if ($expr instanceof oncia_ExistsExpression) {
                $expr_0 = $expr;
                return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_existsErrorMessage, $expr_0.$position71);
            }
        }
        if (var$3) {
            $expr = $expr_0.$value5;
            if ($expr instanceof oncia_CountExpression) {
                $expr_0 = $expr;
                return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_countErrorMessage, $expr_0.$position72);
            }
        }
        if (var$3) {
            $expr = $expr_0.$value5;
            if ($expr instanceof oncia_CollectExpression) {
                $expr_0 = $expr;
                return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_collectErrorMessage, $expr_0.$position73);
            }
        }
        if (!var$3) {
            $expr_0 = oncia_AdministrationCommand_semanticCheck$($this);
            oncias_SemanticState$_$callClinit();
            return oncias_SemanticCheck_chain$($expr_0, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
        }
        $expr_0 = $expr_0.$value5;
        return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_genericErrorMessage, $expr_0.$position2());
    };
    $java.oncia_CreateRemoteDatabaseAlias_productPrefix = function($this) {
        return $rt_s(1576);
    };
    $java.oncia_CreateRemoteDatabaseAlias_productArity = function($this) {
        return 8;
    };
    $java.oncia_CreateRemoteDatabaseAlias_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$aliasName2;
            case 1:
                return $this.$targetName1;
            case 2:
                return $this.$ifExistsDo1;
            case 3:
                return $this.$url1;
            case 4:
                return $this.$username1;
            case 5:
                return $this.$password1;
            case 6:
                return $this.$driverSettings0;
            case 7:
                return $this.$properties6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRemoteDatabaseAlias_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRemoteDatabaseAlias_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRemoteDatabaseAlias_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRemoteDatabaseAlias_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_CreateRemoteDatabaseAlias) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$aliasName2;
                            var$3 = $x$1.$aliasName2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$targetName1;
                            var$3 = $x$1.$targetName1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$ifExistsDo1;
                            var$3 = $x$1.$ifExistsDo1;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        g: {
                            var$2 = $this.$url1;
                            var$3 = $x$1.$url1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break g;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        h: {
                            var$2 = $this.$username1;
                            var$3 = $x$1.$username1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break h;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        i: {
                            var$2 = $this.$password1;
                            var$3 = $x$1.$password1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break i;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        j: {
                            var$2 = $this.$driverSettings0;
                            var$3 = $x$1.$driverSettings0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break j;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$properties6;
                        $x$1 = $x$1.$properties6;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRemoteDatabaseAlias_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateRemoteDatabaseAlias_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    function oncia_CreateRemoteDatabaseAlias__init_($this, $aliasName, $targetName, $ifExistsDo, $url, $username, $password, $driverSettings, $properties, $position) {
        $this.$aliasName2 = $aliasName;
        $this.$targetName1 = $targetName;
        $this.$ifExistsDo1 = $ifExistsDo;
        $this.$url1 = $url;
        $this.$username1 = $username;
        $this.$password1 = $password;
        $this.$driverSettings0 = $driverSettings;
        $this.$properties6 = $properties;
        $this.$position70 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    }
    $java.onciafn_DecorateTuple = $rt_classWithoutFields(0);
    var onciafn_TupleConverter$ = $rt_classWithoutFields();
    var onciafn_TupleConverter$_MODULE$ = null;
    function onciafn_TupleConverter$__clinit_() {
        onciafn_TupleConverter$_MODULE$ = new onciafn_TupleConverter$;
    }
    function onciafn_TupleConverter$_asScalaEither($this, $i) {
        var var$2, var$3;
        var$2 = new onciafn_DecorateTuple$AsScala;
        var$3 = new $java.onciafn_DecorateTuple$asScalaEither$lambda$_1_0;
        var$3.$_0385 = $i;
        var$2.$op = var$3;
        var$2.$$outer34 = $this;
        return var$2;
    }
    function onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_0() {
        jl_Object.call(this);
        this.$_0249 = null;
    }
    $java.onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_Neo4jASTFactory_asExpressionMapAst(var$0.$_0249, var$1);
    };
    function onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_1() {
        jl_Object.call(this);
        this.$_0250 = null;
    }
    $java.onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_Neo4jASTFactory_asExpressionMapAst(var$0.$_0250, var$1);
    };
    function oncia_CreateLocalDatabaseAlias() {
        var a = this; jl_Object.call(a);
        a.$aliasName3 = null;
        a.$targetName2 = null;
        a.$ifExistsDo2 = null;
        a.$properties7 = null;
        a.$position74 = null;
        a.$isReadOnly9 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar10 = null;
    }
    $java.oncia_CreateLocalDatabaseAlias__init_ = function(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_CreateLocalDatabaseAlias();
        oncia_CreateLocalDatabaseAlias__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    };
    $java.oncia_CreateLocalDatabaseAlias_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_CreateLocalDatabaseAlias_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateLocalDatabaseAlias_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateLocalDatabaseAlias_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateLocalDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly9 = $x$1;
    };
    $java.oncia_CreateLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar10;
    };
    $java.oncia_CreateLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar10 = $x$1;
    };
    function oncia_CreateLocalDatabaseAlias_aliasName($this) {
        return $this.$aliasName3;
    }
    function oncia_CreateLocalDatabaseAlias_targetName($this) {
        return $this.$targetName2;
    }
    function oncia_CreateLocalDatabaseAlias_ifExistsDo($this) {
        return $this.$ifExistsDo2;
    }
    function oncia_CreateLocalDatabaseAlias_properties($this) {
        return $this.$properties7;
    }
    $java.oncia_CreateLocalDatabaseAlias_position = function($this) {
        return $this.$position74;
    };
    function oncia_CreateLocalDatabaseAlias_name($this) {
        var var$1;
        var$1 = $this.$ifExistsDo2;
        if (!(jl_Object_equals(oncia_IfExistsReplace$_MODULE$, var$1) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1) ? 0 : 1))
            return $rt_s(1572);
        return $rt_s(1573);
    }
    $java.oncia_CreateLocalDatabaseAlias_semanticCheck = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$ifExistsDo2;
        if (jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1)) {
            var$2 = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $this.$aliasName3, s_DummyImplicit$_dummyImplicit0);
            var$1 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$1);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(1574)), var$2), $rt_s(1575));
            return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$1), $this.$position74);
        }
        a: {
            var$2 = oncia_AdministrationCommand_semanticCheck$($this);
            var$1 = $this.$aliasName3;
            if (var$1 instanceof oncia_NamespacedName) {
                var$1 = var$1;
                var$3 = var$1.$nameComponents;
                if (var$1.$namespace2 instanceof s_Some) {
                    if (sci_List_length(var$3) <= 1) {
                        var$1 = oncias_SemanticCheck$_success;
                        break a;
                    }
                    var$4 = oncia_NamespacedName_toString(var$1);
                    var$3 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$3);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1577)), var$4), $rt_s(1578));
                    var$1 = oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$3), var$1.$position75);
                    break a;
                }
            }
            var$1 = oncias_SemanticCheck$_success;
        }
        var$1 = oncias_SemanticCheck_chain$(var$2, var$1);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_CreateLocalDatabaseAlias_productPrefix = function($this) {
        return $rt_s(1579);
    };
    $java.oncia_CreateLocalDatabaseAlias_productArity = function($this) {
        return 4;
    };
    $java.oncia_CreateLocalDatabaseAlias_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$aliasName3;
            case 1:
                return $this.$targetName2;
            case 2:
                return $this.$ifExistsDo2;
            case 3:
                return $this.$properties7;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateLocalDatabaseAlias_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateLocalDatabaseAlias_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateLocalDatabaseAlias_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateLocalDatabaseAlias_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_CreateLocalDatabaseAlias) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$aliasName3;
                            var$3 = $x$1.$aliasName3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$targetName2;
                            var$3 = $x$1.$targetName2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$ifExistsDo2;
                            var$3 = $x$1.$ifExistsDo2;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$properties7;
                        $x$1 = $x$1.$properties7;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateLocalDatabaseAlias_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateLocalDatabaseAlias_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    function oncia_CreateLocalDatabaseAlias__init_($this, $aliasName, $targetName, $ifExistsDo, $properties, $position) {
        $this.$aliasName3 = $aliasName;
        $this.$targetName2 = $targetName;
        $this.$ifExistsDo2 = $ifExistsDo;
        $this.$properties7 = $properties;
        $this.$position74 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    }
    function onciafn_Neo4jASTFactory$createLocalDatabaseAlias$lambda$_225_0() {
        jl_Object.call(this);
        this.$_0248 = null;
    }
    $java.onciafn_Neo4jASTFactory$createLocalDatabaseAlias$lambda$_225_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_Neo4jASTFactory_asExpressionMapAst(var$0.$_0248, var$1);
    };
    var oncia_NoWait$ = $rt_classWithoutFields();
    var oncia_NoWait$_MODULE$ = null;
    $java.oncia_NoWait$_name = null;
    $java.oncia_NoWait$_DEFAULT_TIMEOUT = Long_ZERO;
    function oncia_NoWait$_$callClinit() {
        oncia_NoWait$_$callClinit = $rt_eraseClinit(oncia_NoWait$);
        $java.oncia_NoWait$__clinit_();
    }
    $java.oncia_NoWait$__clinit_ = function() {
        var var$1;
        var$1 = new oncia_NoWait$;
        oncia_NoWait$_$callClinit();
        oncia_NoWait$_MODULE$ = var$1;
        oncia_WaitUntilComplete_$init$(var$1);
        $java.oncia_NoWait$_name = $rt_s(3);
    };
    $java.oncia_NoWait$_org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq = function($this, $x$1) {
        oncia_NoWait$_$callClinit();
        $java.oncia_NoWait$_DEFAULT_TIMEOUT = $x$1;
    };
    $java.oncia_NoWait$_productArity = function($this) {
        return 0;
    };
    $java.oncia_NoWait$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NoWait$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NoWait$_hashCode = function($this) {
        return (-1956694282);
    };
    $java.oncia_NoWait$_toString = function($this) {
        return $rt_s(1580);
    };
    var oncia_IndefiniteWait$ = $rt_classWithoutFields();
    var oncia_IndefiniteWait$_MODULE$ = null;
    $java.oncia_IndefiniteWait$_name = null;
    $java.oncia_IndefiniteWait$_DEFAULT_TIMEOUT = Long_ZERO;
    function oncia_IndefiniteWait$_$callClinit() {
        oncia_IndefiniteWait$_$callClinit = $rt_eraseClinit(oncia_IndefiniteWait$);
        $java.oncia_IndefiniteWait$__clinit_();
    }
    $java.oncia_IndefiniteWait$__clinit_ = function() {
        var var$1;
        var$1 = new oncia_IndefiniteWait$;
        oncia_IndefiniteWait$_$callClinit();
        oncia_IndefiniteWait$_MODULE$ = var$1;
        oncia_WaitUntilComplete_$init$(var$1);
        $java.oncia_IndefiniteWait$_name = $rt_s(1581);
    };
    $java.oncia_IndefiniteWait$_org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq = function($this, $x$1) {
        oncia_IndefiniteWait$_$callClinit();
        $java.oncia_IndefiniteWait$_DEFAULT_TIMEOUT = $x$1;
    };
    $java.oncia_IndefiniteWait$_productArity = function($this) {
        return 0;
    };
    $java.oncia_IndefiniteWait$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_IndefiniteWait$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IndefiniteWait$_hashCode = function($this) {
        return (-363263030);
    };
    $java.oncia_IndefiniteWait$_toString = function($this) {
        return $rt_s(1582);
    };
    function oncia_TimeoutAfter() {
        var a = this; jl_Object.call(a);
        a.$timoutSeconds = Long_ZERO;
        a.$name20 = null;
        a.$DEFAULT_TIMEOUT = Long_ZERO;
    }
    $java.oncia_TimeoutAfter_org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq = function($this, $x$1) {
        $this.$DEFAULT_TIMEOUT = $x$1;
    };
    $java.oncia_TimeoutAfter_productPrefix = function($this) {
        return $rt_s(1583);
    };
    $java.oncia_TimeoutAfter_productArity = function($this) {
        return 1;
    };
    $java.oncia_TimeoutAfter_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Long_valueOf($this.$timoutSeconds);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_TimeoutAfter_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TimeoutAfter_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1583))), sr_Statics_longHash($this.$timoutSeconds)), 1);
    };
    $java.oncia_TimeoutAfter_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TimeoutAfter_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_TimeoutAfter) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if (Long_ne($this.$timoutSeconds, $x$1.$timoutSeconds))
                        break b;
                    if (!($this instanceof oncia_TimeoutAfter))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncia_WaitableAdministrationCommand = $rt_classWithoutFields(0);
    function oncia_CreateCompositeDatabase() {
        var a = this; jl_Object.call(a);
        a.$databaseName2 = null;
        a.$ifExistsDo3 = null;
        a.$options0 = null;
        a.$waitUntilComplete0 = null;
        a.$position76 = null;
        a.$isReadOnly10 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar11 = null;
    }
    function oncia_CreateCompositeDatabase__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_CreateCompositeDatabase();
        $java.oncia_CreateCompositeDatabase__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncia_CreateCompositeDatabase_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_CreateCompositeDatabase_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateCompositeDatabase_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateCompositeDatabase_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateCompositeDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly10 = $x$1;
    };
    $java.oncia_CreateCompositeDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar11;
    };
    $java.oncia_CreateCompositeDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar11 = $x$1;
    };
    function oncia_CreateCompositeDatabase_databaseName($this) {
        return $this.$databaseName2;
    }
    function oncia_CreateCompositeDatabase_ifExistsDo($this) {
        return $this.$ifExistsDo3;
    }
    function oncia_CreateCompositeDatabase_options($this) {
        return $this.$options0;
    }
    function oncia_CreateCompositeDatabase_waitUntilComplete($this) {
        return $this.$waitUntilComplete0;
    }
    $java.oncia_CreateCompositeDatabase_position = function($this) {
        return $this.$position76;
    };
    function oncia_CreateCompositeDatabase_name($this) {
        var var$1;
        var$1 = $this.$ifExistsDo3;
        if (!(jl_Object_equals(oncia_IfExistsReplace$_MODULE$, var$1) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1) ? 0 : 1))
            return $rt_s(1584);
        return $rt_s(1585);
    }
    $java.oncia_CreateCompositeDatabase_semanticCheck = function($this) {
        var var$1, $name, var$3;
        var$1 = $this.$ifExistsDo3;
        if (jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1)) {
            $name = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $this.$databaseName2, s_DummyImplicit$_dummyImplicit0);
            var$1 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$1);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(1586)), $name), $rt_s(1575));
            return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$1), $this.$position76);
        }
        $name = $this.$databaseName2;
        if ($name instanceof oncia_NamespacedName) {
            $name = $name;
            if ($name.$namespace2 instanceof s_Some) {
                var$1 = oncia_NamespacedName_toString($name);
                var$3 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$3);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(1586)), var$1), $rt_s(1587));
                return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$3), $name.$position75);
            }
        }
        return oncia_AdministrationCommand_semanticCheck$($this);
    };
    $java.oncia_CreateCompositeDatabase_productPrefix = function($this) {
        return $rt_s(1588);
    };
    $java.oncia_CreateCompositeDatabase_productArity = function($this) {
        return 4;
    };
    $java.oncia_CreateCompositeDatabase_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$databaseName2;
            case 1:
                return $this.$ifExistsDo3;
            case 2:
                return $this.$options0;
            case 3:
                return $this.$waitUntilComplete0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateCompositeDatabase_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateCompositeDatabase_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateCompositeDatabase_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateCompositeDatabase_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_CreateCompositeDatabase) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$databaseName2;
                            var$3 = $x$1.$databaseName2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$ifExistsDo3;
                            var$3 = $x$1.$ifExistsDo3;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$options0;
                            var$3 = $x$1.$options0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$waitUntilComplete0;
                        $x$1 = $x$1.$waitUntilComplete0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateCompositeDatabase_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateCompositeDatabase_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_CreateCompositeDatabase__init_ = function($this, $databaseName, $ifExistsDo, $options, $waitUntilComplete, $position) {
        $this.$databaseName2 = $databaseName;
        $this.$ifExistsDo3 = $ifExistsDo;
        $this.$options0 = $options;
        $this.$waitUntilComplete0 = $waitUntilComplete;
        $this.$position76 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    $java.oncia_Options = $rt_classWithoutFields(0);
    $java.oncia_ConstraintVersion = $rt_classWithoutFields(0);
    var oncia_ConstraintVersion0$ = $rt_classWithoutFields();
    var oncia_ConstraintVersion0$_MODULE$ = null;
    function oncia_ConstraintVersion0$__clinit_() {
        oncia_ConstraintVersion0$_MODULE$ = new oncia_ConstraintVersion0$;
    }
    $java.oncia_ConstraintVersion0$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ConstraintVersion0$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ConstraintVersion0$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ConstraintVersion0$_hashCode = function($this) {
        return (-182286475);
    };
    $java.oncia_ConstraintVersion0$_toString = function($this) {
        return $rt_s(1589);
    };
    var oncia_SchemaCommand = $rt_classWithoutFields(0);
    $java.oncia_SchemaCommand_checkOptionsMap$ = function($$this, $schemaString, $options) {
        var var$4, var$5;
        a: {
            if ($options instanceof oncia_OptionsMap) {
                $options = sc_AbstractMap_view($options.$map0);
                var$4 = new $java.oncia_SchemaCommand$checkOptionsMap$lambda$_12_0;
                var$5 = new $java.sc_MapView$FilterKeys;
                var$5.$underlying27 = $options;
                var$5.$p3 = var$4;
                jl_Object__init_0(var$5);
                if (sc_IterableOnceOps_nonEmpty$(var$5)) {
                    $options = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($options);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($options, $rt_s(1590)), $schemaString), $rt_s(1591));
                    $$this = $$this.$error2(jl_AbstractStringBuilder_toString($options), $$this.$position2());
                    break a;
                }
            }
            $$this = oncias_SemanticCheck$_success;
        }
        return $$this;
    };
    $java.oncia_SchemaCommand_$init$ = function($$this) {
        $$this.$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq($rt_s(1592));
        $$this.$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq($rt_s(1593));
        $$this.$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq($rt_s(1594));
        $$this.$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq($rt_s(1595));
        $$this.$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq($rt_s(1596));
    };
    $java.oncia_CompositePropertyConstraintCommand = $rt_classWithoutFields(0);
    $java.oncia_CompositePropertyConstraintCommand_semanticCheck$ = function($$this) {
        var var$2, var$3, var$4;
        var$2 = oncias_package$_MODULE$;
        var$3 = $$this.$variable4();
        oncius_package$_$callClinit();
        var$2 = $java.oncias_package$_liftSemanticEitherFunc(var$2, $$this.$declareVariable(var$3, ($$this.$entityType0()).$invariant()));
        oncias_SemanticExpressionCheck$_$callClinit();
        var$4 = oncias_SemanticCheck_chain$(var$2, $java.oncias_SemanticExpressionCheck$_simple0(oncias_SemanticExpressionCheck$_MODULE$, $$this.$properties1()));
        var$2 = $$this.$properties1();
        var$3 = new $java.oncia_CompositePropertyConstraintCommand$semanticCheck$lambda$_4_0;
        var$3.$_0386 = $$this;
        return oncias_SemanticCheck_chain$(var$4, $$this.$semanticCheckFold(var$2, var$3));
    };
    $java.oncia_NodeCompositePropertyConstraintCommand = $rt_classWithoutFields(0);
    $java.oncia_NodeCompositePropertyConstraintCommand_$init$ = function($$this) {
        oncius_package$_$callClinit();
        $$this.$org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq(oncius_package$_CTNode(oncius_package$_MODULE$));
    };
    $java.oncia_CreateConstraint = $rt_classWithoutFields(0);
    $java.oncia_CreateConstraint_checkSemantics$ = function($$this, $constraintTypeString, $ifExistsDo, $options, $containsOn, $constraintVersion) {
        var var$7;
        var$7 = jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsReplace$_MODULE$, $ifExistsDo) ? 0 : 1;
        a: {
            if (var$7) {
                $ifExistsDo = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($ifExistsDo);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ifExistsDo, $rt_s(1590)), $constraintTypeString), $rt_s(1597));
                $$this = $$this.$error2(jl_AbstractStringBuilder_toString($ifExistsDo), $$this.$position2());
            } else {
                var$7 = 0;
                if (jl_Object_equals(oncia_ConstraintVersion2$_MODULE$, $constraintVersion) && $containsOn)
                    $$this = $$this.$error2($$this.$errorMessageOnRequire(), $$this.$position2());
                else {
                    if (jl_Object_equals(oncia_ConstraintVersion0$_MODULE$, $constraintVersion)) {
                        var$7 = 1;
                        if (!$containsOn) {
                            $$this = $$this.$error2($$this.$errorMessageForAssert(), $$this.$position2());
                            break a;
                        }
                    }
                    if (var$7 && $containsOn)
                        $$this = $$this.$error2($$this.$errorMessageOnAssert(), $$this.$position2());
                    else {
                        $ifExistsDo = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($ifExistsDo);
                        jl_StringBuilder_append(jl_StringBuilder_append($ifExistsDo, $constraintTypeString), $rt_s(1598));
                        $$this = $$this.$checkOptionsMap(jl_AbstractStringBuilder_toString($ifExistsDo), $options);
                    }
                }
            }
        }
        return $$this;
    };
    $java.oncia_CreateConstraint_checkSemanticsExistenceConstraints$ = function($$this, $entityTypeString, $ifExistsDo, $options, $containsOn, $constraintVersion) {
        var var$7, var$8;
        var$7 = jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ifExistsDo) ? 1 : !jl_Object_equals(oncia_IfExistsReplace$_MODULE$, $ifExistsDo) ? 0 : 1;
        a: {
            if (var$7) {
                $ifExistsDo = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($ifExistsDo);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($ifExistsDo, $rt_s(1590)), $entityTypeString), $rt_s(1599));
                $$this = $$this.$error2(jl_AbstractStringBuilder_toString($ifExistsDo), $$this.$position2());
            } else {
                var$7 = 0;
                var$8 = 0;
                if (jl_Object_equals(oncia_ConstraintVersion2$_MODULE$, $constraintVersion) && $containsOn)
                    $$this = $$this.$error2($$this.$errorMessageOnRequire(), $$this.$position2());
                else {
                    if (jl_Object_equals(oncia_ConstraintVersion1$_MODULE$, $constraintVersion)) {
                        var$7 = 1;
                        if (!$containsOn) {
                            $$this = $$this.$error2($$this.$errorMessageForAssert(), $$this.$position2());
                            break a;
                        }
                    }
                    if (jl_Object_equals(oncia_ConstraintVersion0$_MODULE$, $constraintVersion)) {
                        var$8 = 1;
                        if (!$containsOn) {
                            $$this = $$this.$error2($$this.$errorMessageForAssertExists(), $$this.$position2());
                            break a;
                        }
                    }
                    if (var$7 && $containsOn)
                        $$this = $$this.$error2($$this.$errorMessageOnAssert(), $$this.$position2());
                    else if (var$8 && $containsOn)
                        $$this = $$this.$error2($$this.$errorMessageOnAssertExists(), $$this.$position2());
                    else {
                        $constraintVersion = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($constraintVersion);
                        jl_StringBuilder_append(jl_StringBuilder_append($constraintVersion, $entityTypeString), $rt_s(1600));
                        $$this = $$this.$checkOptionsMap(jl_AbstractStringBuilder_toString($constraintVersion), $options);
                    }
                }
            }
        }
        return $$this;
    };
    $java.oncia_CreateConstraint_checkPropertyTypes$ = function($$this, $entityTypeString, $originalPropertyType, $normalizedPropertyType) {
        var var$5, var$6, var$7, var$8, var$9;
        var$5 = $java.oncia_CypherTypeName_semanticCheck($java.oncia_CypherTypeName__init_($originalPropertyType));
        var$6 = new $java.oncia_CreateConstraint$checkPropertyTypes$lambda$_9_0;
        var$6.$_0387 = $entityTypeString;
        var$6.$_1114 = $originalPropertyType;
        var$7 = var$5.$map12(var$6);
        var$8 = $java.oncia_CreateConstraint_anyPropertyValueType$1($$this, $originalPropertyType);
        if (!($normalizedPropertyType instanceof oncius_ClosedDynamicUnionType)) {
            var$6 = $$this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes();
            onciu_InputPosition$_$callClinit();
            var$9 = sci_List_contains(var$6, $normalizedPropertyType.$withPosition0(onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)));
        } else {
            var$6 = $normalizedPropertyType.$sortedInnerTypes;
            var$5 = new $java.oncia_CreateConstraint$allowedTypesCheck$1$lambda$_20_0;
            var$5.$_0388 = $$this;
            var$9 = sci_List_forall(var$6, var$5);
        }
        if (!var$8 && var$9)
            $$this = oncias_SemanticCheck$_success;
        else {
            var$6 = !var$8 ? s_Tuple2__init_($normalizedPropertyType.$description(), $java.oncia_CreateConstraint_additionalErrorInfo$1($normalizedPropertyType)) : s_Tuple2__init_($originalPropertyType.$description(), $java.oncia_CreateConstraint_additionalErrorInfo$1($originalPropertyType));
            var$6 = s_Tuple2__init_(var$6.$_10, var$6.$_20);
            $normalizedPropertyType = var$6.$_10;
            var$5 = var$6.$_20;
            var$6 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$6);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(1590)), $entityTypeString), $rt_s(1601)), $normalizedPropertyType), $rt_s(1602)), var$5);
            $$this = $$this.$error2(jl_AbstractStringBuilder_toString(var$6), $originalPropertyType.$position2());
        }
        return oncias_SemanticCheck_chain$(var$7, $$this);
    };
    $java.oncia_CreateConstraint_anyPropertyValueType$1 = function($this, $pt) {
        var var$2;
        while (!($pt instanceof oncius_PropertyValueType)) {
            if (!($pt instanceof oncius_ListType)) {
                if (!($pt instanceof oncius_ClosedDynamicUnionType))
                    return 0;
                var$2 = $pt.$sortedInnerTypes;
                $pt = new $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_0;
                $pt.$_0389 = $this;
                return sci_List_exists(sci_List_map(var$2, $pt), new $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_1);
            }
            $pt = $pt.$innerType0;
        }
        return 1;
    };
    $java.oncia_CreateConstraint_additionalErrorInfo$1 = function($pt) {
        var var$2, $inner;
        var$2 = 0;
        $inner = null;
        if ($pt instanceof oncius_ListType) {
            var$2 = 1;
            $inner = $pt;
            if ($inner.$innerType0 instanceof oncius_ListType)
                return $rt_s(1603);
        }
        if (var$2 && $inner.$innerType0 instanceof oncius_ClosedDynamicUnionType)
            return $rt_s(1604);
        if (var$2 && $inner.$innerType0.$isNullable())
            return $rt_s(1605);
        if ($pt instanceof oncius_ClosedDynamicUnionType) {
            $pt = $pt;
            if (sci_List_exists($pt.$sortedInnerTypes, new $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_0))
                return s_Option_getOrElse(sci_List_find(sci_List_map(sci_List_filter($pt.$sortedInnerTypes, new $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_1), new $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_2), new $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_3), new $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_4);
        }
        return $rt_s(3);
    };
    $java.oncia_CreateConstraint_$init$ = function($$this) {
        var var$2, var$3, var$4, var$5, var$6;
        s_package$_$callClinit();
        var$2 = s_package$_List0(s_package$_MODULE$);
        var$3 = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(oncius_CypherType, 22);
        var$5 = var$4.data;
        var$6 = new oncius_BooleanType;
        onciu_InputPosition$_$callClinit();
        $java.oncius_BooleanType__init_(var$6, 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[0] = var$6;
        var$5[1] = oncius_StringType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[2] = oncius_IntegerType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[3] = oncius_FloatType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[4] = oncius_DateType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[5] = oncius_LocalTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[6] = oncius_ZonedTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[7] = oncius_LocalDateTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[8] = oncius_ZonedDateTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[9] = oncius_DurationType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[10] = oncius_PointType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[11] = oncius_ListType__init_(oncius_BooleanType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[12] = oncius_ListType__init_(oncius_StringType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[13] = oncius_ListType__init_(oncius_IntegerType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[14] = oncius_ListType__init_(oncius_FloatType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[15] = oncius_ListType__init_(oncius_DateType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[16] = oncius_ListType__init_(oncius_LocalTimeType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[17] = oncius_ListType__init_(oncius_ZonedTimeType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[18] = oncius_ListType__init_(oncius_LocalDateTimeType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[19] = oncius_ListType__init_(oncius_ZonedDateTimeType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[20] = oncius_ListType__init_(oncius_DurationType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[21] = oncius_ListType__init_(oncius_PointType__init_(0, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $$this.$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq(var$2.$from0(sr_ScalaRunTime$_wrapRefArray(var$3, var$4)));
    };
    function oncia_CreateNodePropertyUniquenessConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable14 = null;
        a.$label2 = null;
        a.$properties8 = null;
        a.$name24 = null;
        a.$ifExistsDo4 = null;
        a.$options1 = null;
        a.$containsOn0 = 0;
        a.$constraintVersion0 = null;
        a.$useGraph1 = null;
        a.$position77 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes0 = null;
        a.$entityType1 = null;
        a.$errorMessageOnRequire0 = null;
        a.$errorMessageForAssert0 = null;
        a.$errorMessageForAssertExists0 = null;
        a.$errorMessageOnAssert0 = null;
        a.$errorMessageOnAssertExists0 = null;
    }
    function oncia_CreateNodePropertyUniquenessConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9) {
        var var_10 = new oncia_CreateNodePropertyUniquenessConstraint();
        $java.oncia_CreateNodePropertyUniquenessConstraint__init_(var_10, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9);
        return var_10;
    }
    $java.oncia_CreateNodePropertyUniquenessConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes0 = $x$1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType1 = $x$1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire0;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert0;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert0;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire0 = $x$1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert0 = $x$1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists0 = $x$1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert0 = $x$1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists0 = $x$1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_variable = function($this) {
        return $this.$variable14;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_properties = function($this) {
        return $this.$properties8;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_position = function($this) {
        return $this.$position77;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemantics$($this, $rt_s(1606), $this.$ifExistsDo4, $this.$options1, $this.$containsOn0, $this.$constraintVersion0), $java.oncia_CompositePropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_copy = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateNodePropertyUniquenessConstraint__init_($variable, $label, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_productPrefix = function($this) {
        return $rt_s(1607);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_productArity = function($this) {
        return 9;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable14;
            case 1:
                return $this.$label2;
            case 2:
                return $this.$properties8;
            case 3:
                return $this.$name24;
            case 4:
                return $this.$ifExistsDo4;
            case 5:
                return $this.$options1;
            case 6:
                return jl_Boolean_valueOf($this.$containsOn0);
            case 7:
                return $this.$constraintVersion0;
            case 8:
                return $this.$useGraph1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1607))), sr_Statics_anyHash($this.$variable14)), sr_Statics_anyHash($this.$label2)), sr_Statics_anyHash($this.$properties8)), sr_Statics_anyHash($this.$name24)), sr_Statics_anyHash($this.$ifExistsDo4)), sr_Statics_anyHash($this.$options1)), !$this.$containsOn0 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion0)),
        sr_Statics_anyHash($this.$useGraph1)), 9);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateNodePropertyUniquenessConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn0 != $x$1.$containsOn0)
                        break b;
                    c: {
                        var$2 = $this.$variable14;
                        var$3 = $x$1.$variable14;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label2;
                        var$3 = $x$1.$label2;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties8;
                        var$3 = $x$1.$properties8;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name24;
                        var$3 = $x$1.$name24;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo4;
                        var$3 = $x$1.$ifExistsDo4;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options1;
                        var$3 = $x$1.$options1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$constraintVersion0;
                        var$3 = $x$1.$constraintVersion0;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$3 = $this.$useGraph1;
                        $x$1 = $x$1.$useGraph1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break j;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateNodePropertyUniquenessConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_entityType = function($this) {
        return $this.$entityType1;
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateNodePropertyUniquenessConstraint_copy($this, $this.$variable14, $this.$label2, $this.$properties8, $this.$name24, $this.$ifExistsDo4, $this.$options1, $this.$containsOn0, $this.$constraintVersion0, $useGraph, $this.$position77);
    };
    $java.oncia_CreateNodePropertyUniquenessConstraint__init_ = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable14 = $variable;
        $this.$label2 = $label;
        $this.$properties8 = $properties;
        $this.$name24 = $name;
        $this.$ifExistsDo4 = $ifExistsDo;
        $this.$options1 = $options;
        $this.$containsOn0 = $containsOn;
        $this.$constraintVersion0 = $constraintVersion;
        $this.$useGraph1 = $useGraph;
        $this.$position77 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_NodeCompositePropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
    };
    $java.oncil_LabelExpressionLeafName = $rt_classWithoutFields(0);
    $java.oncie_ElementTypeName = $rt_classWithoutFields(0);
    function oncie_LabelName() {
        var a = this; jl_Object.call(a);
        a.$name25 = null;
        a.$position78 = null;
    }
    function oncie_LabelName__init_(var_0, var_1) {
        var var_2 = new oncie_LabelName();
        $java.oncie_LabelName__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_LabelName_name = function($this) {
        return $this.$name25;
    };
    $java.oncie_LabelName_position = function($this) {
        return $this.$position78;
    };
    $java.oncie_LabelName_productPrefix = function($this) {
        return $rt_s(1608);
    };
    $java.oncie_LabelName_productArity = function($this) {
        return 1;
    };
    $java.oncie_LabelName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name25;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_LabelName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LabelName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LabelName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LabelName_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_LabelName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name25;
                        $x$1 = $x$1.$name25;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_LabelName))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_LabelName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_LabelName__init_ = function($this, $name, $position) {
        $this.$name25 = $name;
        $this.$position78 = $position;
    };
    var oncia_CreateNodePropertyUniquenessConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateNodePropertyUniquenessConstraint$_MODULE$ = null;
    function oncia_CreateNodePropertyUniquenessConstraint$__clinit_() {
        $java.oncia_CreateNodePropertyUniquenessConstraint$_MODULE$ = new oncia_CreateNodePropertyUniquenessConstraint$;
    }
    $java.oncia_RelationshipCompositePropertyConstraintCommand = $rt_classWithoutFields(0);
    $java.oncia_RelationshipCompositePropertyConstraintCommand_$init$ = function($$this) {
        oncius_package$_$callClinit();
        $$this.$org$neo4j$cypher$internal$ast$RelationshipCompositePropertyConstraintCommand$_setter_$entityType_$eq(oncius_package$_CTRelationship(oncius_package$_MODULE$));
    };
    function oncia_CreateRelationshipPropertyUniquenessConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable15 = null;
        a.$relType1 = null;
        a.$properties9 = null;
        a.$name26 = null;
        a.$ifExistsDo5 = null;
        a.$options2 = null;
        a.$containsOn1 = 0;
        a.$constraintVersion1 = null;
        a.$useGraph2 = null;
        a.$position79 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes1 = null;
        a.$entityType2 = null;
        a.$errorMessageOnRequire1 = null;
        a.$errorMessageForAssert1 = null;
        a.$errorMessageForAssertExists1 = null;
        a.$errorMessageOnAssert1 = null;
        a.$errorMessageOnAssertExists1 = null;
    }
    function oncia_CreateRelationshipPropertyUniquenessConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9) {
        var var_10 = new oncia_CreateRelationshipPropertyUniquenessConstraint();
        $java.oncia_CreateRelationshipPropertyUniquenessConstraint__init_(var_10, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9);
        return var_10;
    }
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes1 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$RelationshipCompositePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType2 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire1 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert1 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists1 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert1 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists1 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_variable = function($this) {
        return $this.$variable15;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_properties = function($this) {
        return $this.$properties9;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_position = function($this) {
        return $this.$position79;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemantics$($this, $rt_s(1609), $this.$ifExistsDo5, $this.$options2, $this.$containsOn1, $this.$constraintVersion1), $java.oncia_CompositePropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_copy = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateRelationshipPropertyUniquenessConstraint__init_($variable, $relType, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_productPrefix = function($this) {
        return $rt_s(1610);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_productArity = function($this) {
        return 9;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable15;
            case 1:
                return $this.$relType1;
            case 2:
                return $this.$properties9;
            case 3:
                return $this.$name26;
            case 4:
                return $this.$ifExistsDo5;
            case 5:
                return $this.$options2;
            case 6:
                return jl_Boolean_valueOf($this.$containsOn1);
            case 7:
                return $this.$constraintVersion1;
            case 8:
                return $this.$useGraph2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1610))), sr_Statics_anyHash($this.$variable15)), sr_Statics_anyHash($this.$relType1)), sr_Statics_anyHash($this.$properties9)), sr_Statics_anyHash($this.$name26)), sr_Statics_anyHash($this.$ifExistsDo5)), sr_Statics_anyHash($this.$options2)), !$this.$containsOn1 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion1)),
        sr_Statics_anyHash($this.$useGraph2)), 9);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateRelationshipPropertyUniquenessConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn1 != $x$1.$containsOn1)
                        break b;
                    c: {
                        var$2 = $this.$variable15;
                        var$3 = $x$1.$variable15;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType1;
                        var$3 = $x$1.$relType1;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties9;
                        var$3 = $x$1.$properties9;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name26;
                        var$3 = $x$1.$name26;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo5;
                        var$3 = $x$1.$ifExistsDo5;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options2;
                        var$3 = $x$1.$options2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$constraintVersion1;
                        var$3 = $x$1.$constraintVersion1;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$3 = $this.$useGraph2;
                        $x$1 = $x$1.$useGraph2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break j;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateRelationshipPropertyUniquenessConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_entityType = function($this) {
        return $this.$entityType2;
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateRelationshipPropertyUniquenessConstraint_copy($this, $this.$variable15, $this.$relType1, $this.$properties9, $this.$name26, $this.$ifExistsDo5, $this.$options2, $this.$containsOn1, $this.$constraintVersion1, $useGraph, $this.$position79);
    };
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint__init_ = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable15 = $variable;
        $this.$relType1 = $relType;
        $this.$properties9 = $properties;
        $this.$name26 = $name;
        $this.$ifExistsDo5 = $ifExistsDo;
        $this.$options2 = $options;
        $this.$containsOn1 = $containsOn;
        $this.$constraintVersion1 = $constraintVersion;
        $this.$useGraph2 = $useGraph;
        $this.$position79 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_RelationshipCompositePropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
    };
    function oncie_RelTypeName() {
        var a = this; jl_Object.call(a);
        a.$name27 = null;
        a.$position80 = null;
    }
    function oncie_RelTypeName__init_(var_0, var_1) {
        var var_2 = new oncie_RelTypeName();
        $java.oncie_RelTypeName__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_RelTypeName_name = function($this) {
        return $this.$name27;
    };
    $java.oncie_RelTypeName_position = function($this) {
        return $this.$position80;
    };
    $java.oncie_RelTypeName_productPrefix = function($this) {
        return $rt_s(1611);
    };
    $java.oncie_RelTypeName_productArity = function($this) {
        return 1;
    };
    $java.oncie_RelTypeName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name27;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_RelTypeName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelTypeName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelTypeName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelTypeName_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_RelTypeName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name27;
                        $x$1 = $x$1.$name27;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_RelTypeName))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_RelTypeName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_RelTypeName__init_ = function($this, $name, $position) {
        $this.$name27 = $name;
        $this.$position80 = $position;
    };
    var oncia_CreateRelationshipPropertyUniquenessConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateRelationshipPropertyUniquenessConstraint$_MODULE$ = null;
    function oncia_CreateRelationshipPropertyUniquenessConstraint$__clinit_() {
        $java.oncia_CreateRelationshipPropertyUniquenessConstraint$_MODULE$ = new oncia_CreateRelationshipPropertyUniquenessConstraint$;
    }
    function oncia_CreateNodeKeyConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable16 = null;
        a.$label3 = null;
        a.$properties10 = null;
        a.$name28 = null;
        a.$ifExistsDo6 = null;
        a.$options3 = null;
        a.$containsOn2 = 0;
        a.$constraintVersion2 = null;
        a.$useGraph3 = null;
        a.$position81 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes2 = null;
        a.$entityType3 = null;
        a.$errorMessageOnRequire2 = null;
        a.$errorMessageForAssert2 = null;
        a.$errorMessageForAssertExists2 = null;
        a.$errorMessageOnAssert2 = null;
        a.$errorMessageOnAssertExists2 = null;
    }
    function oncia_CreateNodeKeyConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9) {
        var var_10 = new oncia_CreateNodeKeyConstraint();
        $java.oncia_CreateNodeKeyConstraint__init_(var_10, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9);
        return var_10;
    }
    $java.oncia_CreateNodeKeyConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateNodeKeyConstraint_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_CreateNodeKeyConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateNodeKeyConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateNodeKeyConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateNodeKeyConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes2 = $x$1;
    };
    $java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType3 = $x$1;
    };
    $java.oncia_CreateNodeKeyConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire2;
    };
    $java.oncia_CreateNodeKeyConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert2;
    };
    $java.oncia_CreateNodeKeyConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert2;
    };
    $java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire2 = $x$1;
    };
    $java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert2 = $x$1;
    };
    $java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists2 = $x$1;
    };
    $java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert2 = $x$1;
    };
    $java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists2 = $x$1;
    };
    $java.oncia_CreateNodeKeyConstraint_variable = function($this) {
        return $this.$variable16;
    };
    $java.oncia_CreateNodeKeyConstraint_properties = function($this) {
        return $this.$properties10;
    };
    $java.oncia_CreateNodeKeyConstraint_position = function($this) {
        return $this.$position81;
    };
    $java.oncia_CreateNodeKeyConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemantics$($this, $rt_s(1612), $this.$ifExistsDo6, $this.$options3, $this.$containsOn2, $this.$constraintVersion2), $java.oncia_CompositePropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateNodeKeyConstraint_copy = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateNodeKeyConstraint__init_($variable, $label, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateNodeKeyConstraint_productPrefix = function($this) {
        return $rt_s(1613);
    };
    $java.oncia_CreateNodeKeyConstraint_productArity = function($this) {
        return 9;
    };
    $java.oncia_CreateNodeKeyConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable16;
            case 1:
                return $this.$label3;
            case 2:
                return $this.$properties10;
            case 3:
                return $this.$name28;
            case 4:
                return $this.$ifExistsDo6;
            case 5:
                return $this.$options3;
            case 6:
                return jl_Boolean_valueOf($this.$containsOn2);
            case 7:
                return $this.$constraintVersion2;
            case 8:
                return $this.$useGraph3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateNodeKeyConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodeKeyConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1613))), sr_Statics_anyHash($this.$variable16)), sr_Statics_anyHash($this.$label3)), sr_Statics_anyHash($this.$properties10)), sr_Statics_anyHash($this.$name28)), sr_Statics_anyHash($this.$ifExistsDo6)), sr_Statics_anyHash($this.$options3)), !$this.$containsOn2 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion2)),
        sr_Statics_anyHash($this.$useGraph3)), 9);
    };
    $java.oncia_CreateNodeKeyConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodeKeyConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateNodeKeyConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn2 != $x$1.$containsOn2)
                        break b;
                    c: {
                        var$2 = $this.$variable16;
                        var$3 = $x$1.$variable16;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label3;
                        var$3 = $x$1.$label3;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties10;
                        var$3 = $x$1.$properties10;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name28;
                        var$3 = $x$1.$name28;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo6;
                        var$3 = $x$1.$ifExistsDo6;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options3;
                        var$3 = $x$1.$options3;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$constraintVersion2;
                        var$3 = $x$1.$constraintVersion2;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$3 = $this.$useGraph3;
                        $x$1 = $x$1.$useGraph3;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break j;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateNodeKeyConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateNodeKeyConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateNodeKeyConstraint_entityType = function($this) {
        return $this.$entityType3;
    };
    $java.oncia_CreateNodeKeyConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateNodeKeyConstraint_copy($this, $this.$variable16, $this.$label3, $this.$properties10, $this.$name28, $this.$ifExistsDo6, $this.$options3, $this.$containsOn2, $this.$constraintVersion2, $useGraph, $this.$position81);
    };
    $java.oncia_CreateNodeKeyConstraint__init_ = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable16 = $variable;
        $this.$label3 = $label;
        $this.$properties10 = $properties;
        $this.$name28 = $name;
        $this.$ifExistsDo6 = $ifExistsDo;
        $this.$options3 = $options;
        $this.$containsOn2 = $containsOn;
        $this.$constraintVersion2 = $constraintVersion;
        $this.$useGraph3 = $useGraph;
        $this.$position81 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_NodeCompositePropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
    };
    var oncia_CreateNodeKeyConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateNodeKeyConstraint$_MODULE$ = null;
    function oncia_CreateNodeKeyConstraint$__clinit_() {
        $java.oncia_CreateNodeKeyConstraint$_MODULE$ = new oncia_CreateNodeKeyConstraint$;
    }
    function oncia_CreateRelationshipKeyConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable17 = null;
        a.$relType2 = null;
        a.$properties11 = null;
        a.$name29 = null;
        a.$ifExistsDo7 = null;
        a.$options4 = null;
        a.$containsOn3 = 0;
        a.$constraintVersion3 = null;
        a.$useGraph4 = null;
        a.$position82 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes3 = null;
        a.$entityType4 = null;
        a.$errorMessageOnRequire3 = null;
        a.$errorMessageForAssert3 = null;
        a.$errorMessageForAssertExists3 = null;
        a.$errorMessageOnAssert3 = null;
        a.$errorMessageOnAssertExists3 = null;
    }
    function oncia_CreateRelationshipKeyConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9) {
        var var_10 = new oncia_CreateRelationshipKeyConstraint();
        $java.oncia_CreateRelationshipKeyConstraint__init_(var_10, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9);
        return var_10;
    }
    $java.oncia_CreateRelationshipKeyConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateRelationshipKeyConstraint_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_CreateRelationshipKeyConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateRelationshipKeyConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateRelationshipKeyConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateRelationshipKeyConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes3 = $x$1;
    };
    $java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$RelationshipCompositePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType4 = $x$1;
    };
    $java.oncia_CreateRelationshipKeyConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire3;
    };
    $java.oncia_CreateRelationshipKeyConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert3;
    };
    $java.oncia_CreateRelationshipKeyConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert3;
    };
    $java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire3 = $x$1;
    };
    $java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert3 = $x$1;
    };
    $java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists3 = $x$1;
    };
    $java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert3 = $x$1;
    };
    $java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists3 = $x$1;
    };
    $java.oncia_CreateRelationshipKeyConstraint_variable = function($this) {
        return $this.$variable17;
    };
    $java.oncia_CreateRelationshipKeyConstraint_properties = function($this) {
        return $this.$properties11;
    };
    $java.oncia_CreateRelationshipKeyConstraint_position = function($this) {
        return $this.$position82;
    };
    $java.oncia_CreateRelationshipKeyConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemantics$($this, $rt_s(1614), $this.$ifExistsDo7, $this.$options4, $this.$containsOn3, $this.$constraintVersion3), $java.oncia_CompositePropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateRelationshipKeyConstraint_copy = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateRelationshipKeyConstraint__init_($variable, $relType, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateRelationshipKeyConstraint_productPrefix = function($this) {
        return $rt_s(1615);
    };
    $java.oncia_CreateRelationshipKeyConstraint_productArity = function($this) {
        return 9;
    };
    $java.oncia_CreateRelationshipKeyConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable17;
            case 1:
                return $this.$relType2;
            case 2:
                return $this.$properties11;
            case 3:
                return $this.$name29;
            case 4:
                return $this.$ifExistsDo7;
            case 5:
                return $this.$options4;
            case 6:
                return jl_Boolean_valueOf($this.$containsOn3);
            case 7:
                return $this.$constraintVersion3;
            case 8:
                return $this.$useGraph4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRelationshipKeyConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipKeyConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1615))), sr_Statics_anyHash($this.$variable17)), sr_Statics_anyHash($this.$relType2)), sr_Statics_anyHash($this.$properties11)), sr_Statics_anyHash($this.$name29)), sr_Statics_anyHash($this.$ifExistsDo7)), sr_Statics_anyHash($this.$options4)), !$this.$containsOn3 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion3)),
        sr_Statics_anyHash($this.$useGraph4)), 9);
    };
    $java.oncia_CreateRelationshipKeyConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipKeyConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateRelationshipKeyConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn3 != $x$1.$containsOn3)
                        break b;
                    c: {
                        var$2 = $this.$variable17;
                        var$3 = $x$1.$variable17;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType2;
                        var$3 = $x$1.$relType2;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties11;
                        var$3 = $x$1.$properties11;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name29;
                        var$3 = $x$1.$name29;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo7;
                        var$3 = $x$1.$ifExistsDo7;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options4;
                        var$3 = $x$1.$options4;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$constraintVersion3;
                        var$3 = $x$1.$constraintVersion3;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$3 = $this.$useGraph4;
                        $x$1 = $x$1.$useGraph4;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break j;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateRelationshipKeyConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRelationshipKeyConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateRelationshipKeyConstraint_entityType = function($this) {
        return $this.$entityType4;
    };
    $java.oncia_CreateRelationshipKeyConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateRelationshipKeyConstraint_copy($this, $this.$variable17, $this.$relType2, $this.$properties11, $this.$name29, $this.$ifExistsDo7, $this.$options4, $this.$containsOn3, $this.$constraintVersion3, $useGraph, $this.$position82);
    };
    $java.oncia_CreateRelationshipKeyConstraint__init_ = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable17 = $variable;
        $this.$relType2 = $relType;
        $this.$properties11 = $properties;
        $this.$name29 = $name;
        $this.$ifExistsDo7 = $ifExistsDo;
        $this.$options4 = $options;
        $this.$containsOn3 = $containsOn;
        $this.$constraintVersion3 = $constraintVersion;
        $this.$useGraph4 = $useGraph;
        $this.$position82 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_RelationshipCompositePropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
    };
    var oncia_CreateRelationshipKeyConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateRelationshipKeyConstraint$_MODULE$ = null;
    function oncia_CreateRelationshipKeyConstraint$__clinit_() {
        $java.oncia_CreateRelationshipKeyConstraint$_MODULE$ = new oncia_CreateRelationshipKeyConstraint$;
    }
    $java.oncia_PropertyConstraintCommand = $rt_classWithoutFields(0);
    $java.oncia_PropertyConstraintCommand_semanticCheck$ = function($$this) {
        var var$2, var$3, var$4, var$5;
        var$2 = oncias_package$_MODULE$;
        var$3 = $$this.$variable4();
        oncius_package$_$callClinit();
        var$2 = $java.oncias_package$_liftSemanticEitherFunc(var$2, $$this.$declareVariable(var$3, ($$this.$entityType0()).$invariant()));
        oncias_SemanticExpressionCheck$_$callClinit();
        var$4 = oncias_SemanticCheck_chain$(var$2, $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $$this.$property()));
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$5 = ($$this.$property()).$map11 instanceof oncie_Variable ? 0 : 1;
        var$3 = new $java.oncia_PropertyConstraintCommand$semanticCheck$lambda$_4_0;
        var$3.$_0390 = $$this;
        return oncias_SemanticCheck_chain$(var$4, oncias_SemanticCheck$_when(var$2, var$5, var$3));
    };
    $java.oncia_NodePropertyConstraintCommand = $rt_classWithoutFields(0);
    $java.oncia_NodePropertyConstraintCommand_$init$ = function($$this) {
        oncius_package$_$callClinit();
        $$this.$org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq(oncius_package$_CTNode(oncius_package$_MODULE$));
    };
    function oncia_CreateNodePropertyExistenceConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable18 = null;
        a.$label4 = null;
        a.$property1 = null;
        a.$name30 = null;
        a.$ifExistsDo8 = null;
        a.$options5 = null;
        a.$containsOn4 = 0;
        a.$constraintVersion4 = null;
        a.$useGraph5 = null;
        a.$position83 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes4 = null;
        a.$entityType5 = null;
        a.$errorMessageOnRequire4 = null;
        a.$errorMessageForAssert4 = null;
        a.$errorMessageForAssertExists4 = null;
        a.$errorMessageOnAssert4 = null;
        a.$errorMessageOnAssertExists4 = null;
    }
    function oncia_CreateNodePropertyExistenceConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9) {
        var var_10 = new oncia_CreateNodePropertyExistenceConstraint();
        $java.oncia_CreateNodePropertyExistenceConstraint__init_(var_10, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9);
        return var_10;
    }
    $java.oncia_CreateNodePropertyExistenceConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes4 = $x$1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType5 = $x$1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire4;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert4;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_errorMessageForAssertExists = function($this) {
        return $this.$errorMessageForAssertExists4;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert4;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_errorMessageOnAssertExists = function($this) {
        return $this.$errorMessageOnAssertExists4;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire4 = $x$1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert4 = $x$1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists4 = $x$1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert4 = $x$1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists4 = $x$1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_variable = function($this) {
        return $this.$variable18;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_property = function($this) {
        return $this.$property1;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_position = function($this) {
        return $this.$position83;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemanticsExistenceConstraints$($this, $rt_s(1616), $this.$ifExistsDo8, $this.$options5, $this.$containsOn4, $this.$constraintVersion4), $java.oncia_PropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_copy = function($this, $variable, $label, $property, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateNodePropertyExistenceConstraint__init_($variable, $label, $property, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_productPrefix = function($this) {
        return $rt_s(1617);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_productArity = function($this) {
        return 9;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable18;
            case 1:
                return $this.$label4;
            case 2:
                return $this.$property1;
            case 3:
                return $this.$name30;
            case 4:
                return $this.$ifExistsDo8;
            case 5:
                return $this.$options5;
            case 6:
                return jl_Boolean_valueOf($this.$containsOn4);
            case 7:
                return $this.$constraintVersion4;
            case 8:
                return $this.$useGraph5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1617))), sr_Statics_anyHash($this.$variable18)), sr_Statics_anyHash($this.$label4)), sr_Statics_anyHash($this.$property1)), sr_Statics_anyHash($this.$name30)), sr_Statics_anyHash($this.$ifExistsDo8)), sr_Statics_anyHash($this.$options5)), !$this.$containsOn4 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion4)),
        sr_Statics_anyHash($this.$useGraph5)), 9);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateNodePropertyExistenceConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn4 != $x$1.$containsOn4)
                        break b;
                    c: {
                        var$2 = $this.$variable18;
                        var$3 = $x$1.$variable18;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label4;
                        var$3 = $x$1.$label4;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$property1;
                        var$3 = $x$1.$property1;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name30;
                        var$3 = $x$1.$name30;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo8;
                        var$3 = $x$1.$ifExistsDo8;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options5;
                        var$3 = $x$1.$options5;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$constraintVersion4;
                        var$3 = $x$1.$constraintVersion4;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$3 = $this.$useGraph5;
                        $x$1 = $x$1.$useGraph5;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break j;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateNodePropertyExistenceConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_entityType = function($this) {
        return $this.$entityType5;
    };
    $java.oncia_CreateNodePropertyExistenceConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateNodePropertyExistenceConstraint_copy($this, $this.$variable18, $this.$label4, $this.$property1, $this.$name30, $this.$ifExistsDo8, $this.$options5, $this.$containsOn4, $this.$constraintVersion4, $useGraph, $this.$position83);
    };
    $java.oncia_CreateNodePropertyExistenceConstraint__init_ = function($this, $variable, $label, $property, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable18 = $variable;
        $this.$label4 = $label;
        $this.$property1 = $property;
        $this.$name30 = $name;
        $this.$ifExistsDo8 = $ifExistsDo;
        $this.$options5 = $options;
        $this.$containsOn4 = $containsOn;
        $this.$constraintVersion4 = $constraintVersion;
        $this.$useGraph5 = $useGraph;
        $this.$position83 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_NodePropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
    };
    var oncia_CreateNodePropertyExistenceConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateNodePropertyExistenceConstraint$_MODULE$ = null;
    function oncia_CreateNodePropertyExistenceConstraint$__clinit_() {
        $java.oncia_CreateNodePropertyExistenceConstraint$_MODULE$ = new oncia_CreateNodePropertyExistenceConstraint$;
    }
    $java.oncia_RelationshipPropertyConstraintCommand = $rt_classWithoutFields(0);
    $java.oncia_RelationshipPropertyConstraintCommand_$init$ = function($$this) {
        oncius_package$_$callClinit();
        $$this.$org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq(oncius_package$_CTRelationship(oncius_package$_MODULE$));
    };
    function oncia_CreateRelationshipPropertyExistenceConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable19 = null;
        a.$relType3 = null;
        a.$property2 = null;
        a.$name31 = null;
        a.$ifExistsDo9 = null;
        a.$options6 = null;
        a.$containsOn5 = 0;
        a.$constraintVersion5 = null;
        a.$useGraph6 = null;
        a.$position84 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes5 = null;
        a.$entityType6 = null;
        a.$errorMessageOnRequire5 = null;
        a.$errorMessageForAssert5 = null;
        a.$errorMessageForAssertExists5 = null;
        a.$errorMessageOnAssert5 = null;
        a.$errorMessageOnAssertExists5 = null;
    }
    function oncia_CreateRelationshipPropertyExistenceConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9) {
        var var_10 = new oncia_CreateRelationshipPropertyExistenceConstraint();
        $java.oncia_CreateRelationshipPropertyExistenceConstraint__init_(var_10, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9);
        return var_10;
    }
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes5 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType6 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire5;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert5;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageForAssertExists = function($this) {
        return $this.$errorMessageForAssertExists5;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert5;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageOnAssertExists = function($this) {
        return $this.$errorMessageOnAssertExists5;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire5 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert5 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists5 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert5 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists5 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_variable = function($this) {
        return $this.$variable19;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_property = function($this) {
        return $this.$property2;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_position = function($this) {
        return $this.$position84;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemanticsExistenceConstraints$($this, $rt_s(1618), $this.$ifExistsDo9, $this.$options6, $this.$containsOn5, $this.$constraintVersion5), $java.oncia_PropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_copy = function($this, $variable, $relType, $property, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateRelationshipPropertyExistenceConstraint__init_($variable, $relType, $property, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_productPrefix = function($this) {
        return $rt_s(1619);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_productArity = function($this) {
        return 9;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable19;
            case 1:
                return $this.$relType3;
            case 2:
                return $this.$property2;
            case 3:
                return $this.$name31;
            case 4:
                return $this.$ifExistsDo9;
            case 5:
                return $this.$options6;
            case 6:
                return jl_Boolean_valueOf($this.$containsOn5);
            case 7:
                return $this.$constraintVersion5;
            case 8:
                return $this.$useGraph6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1619))), sr_Statics_anyHash($this.$variable19)), sr_Statics_anyHash($this.$relType3)), sr_Statics_anyHash($this.$property2)), sr_Statics_anyHash($this.$name31)), sr_Statics_anyHash($this.$ifExistsDo9)), sr_Statics_anyHash($this.$options6)), !$this.$containsOn5 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion5)),
        sr_Statics_anyHash($this.$useGraph6)), 9);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateRelationshipPropertyExistenceConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn5 != $x$1.$containsOn5)
                        break b;
                    c: {
                        var$2 = $this.$variable19;
                        var$3 = $x$1.$variable19;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType3;
                        var$3 = $x$1.$relType3;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$property2;
                        var$3 = $x$1.$property2;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name31;
                        var$3 = $x$1.$name31;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo9;
                        var$3 = $x$1.$ifExistsDo9;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options6;
                        var$3 = $x$1.$options6;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$constraintVersion5;
                        var$3 = $x$1.$constraintVersion5;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$3 = $this.$useGraph6;
                        $x$1 = $x$1.$useGraph6;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break j;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateRelationshipPropertyExistenceConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_entityType = function($this) {
        return $this.$entityType6;
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateRelationshipPropertyExistenceConstraint_copy($this, $this.$variable19, $this.$relType3, $this.$property2, $this.$name31, $this.$ifExistsDo9, $this.$options6, $this.$containsOn5, $this.$constraintVersion5, $useGraph, $this.$position84);
    };
    $java.oncia_CreateRelationshipPropertyExistenceConstraint__init_ = function($this, $variable, $relType, $property, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable19 = $variable;
        $this.$relType3 = $relType;
        $this.$property2 = $property;
        $this.$name31 = $name;
        $this.$ifExistsDo9 = $ifExistsDo;
        $this.$options6 = $options;
        $this.$containsOn5 = $containsOn;
        $this.$constraintVersion5 = $constraintVersion;
        $this.$useGraph6 = $useGraph;
        $this.$position84 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_RelationshipPropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
    };
    var oncia_CreateRelationshipPropertyExistenceConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateRelationshipPropertyExistenceConstraint$_MODULE$ = null;
    function oncia_CreateRelationshipPropertyExistenceConstraint$__clinit_() {
        $java.oncia_CreateRelationshipPropertyExistenceConstraint$_MODULE$ = new oncia_CreateRelationshipPropertyExistenceConstraint$;
    }
    function oncia_CreateNodePropertyTypeConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable20 = null;
        a.$label5 = null;
        a.$property3 = null;
        a.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType = null;
        a.$name32 = null;
        a.$ifExistsDo10 = null;
        a.$options7 = null;
        a.$containsOn6 = 0;
        a.$constraintVersion6 = null;
        a.$useGraph7 = null;
        a.$position85 = null;
        a.$normalizedPropertyType0 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes6 = null;
        a.$entityType7 = null;
        a.$errorMessageOnRequire6 = null;
        a.$errorMessageForAssert6 = null;
        a.$errorMessageForAssertExists6 = null;
        a.$errorMessageOnAssert6 = null;
        a.$errorMessageOnAssertExists6 = null;
    }
    function oncia_CreateNodePropertyTypeConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10) {
        var var_11 = new oncia_CreateNodePropertyTypeConstraint();
        $java.oncia_CreateNodePropertyTypeConstraint__init_(var_11, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10);
        return var_11;
    }
    $java.oncia_CreateNodePropertyTypeConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes6;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes6 = $x$1;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType7 = $x$1;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire6;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert6;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert6;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire6 = $x$1;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert6 = $x$1;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists6 = $x$1;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert6 = $x$1;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists6 = $x$1;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_variable = function($this) {
        return $this.$variable20;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_property = function($this) {
        return $this.$property3;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_position = function($this) {
        return $this.$position85;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemantics$($this, $rt_s(1620), $this.$ifExistsDo10, $this.$options7, $this.$containsOn6, $this.$constraintVersion6), $java.oncia_CreateConstraint_checkPropertyTypes$($this, $rt_s(1616), $this.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType, $this.$normalizedPropertyType0)), $java.oncia_PropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateNodePropertyTypeConstraint_copy = function($this, $variable, $label, $property, $propertyType, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateNodePropertyTypeConstraint__init_($variable, $label, $property, $propertyType, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_productPrefix = function($this) {
        return $rt_s(1621);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_productArity = function($this) {
        return 10;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable20;
            case 1:
                return $this.$label5;
            case 2:
                return $this.$property3;
            case 3:
                return $this.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType;
            case 4:
                return $this.$name32;
            case 5:
                return $this.$ifExistsDo10;
            case 6:
                return $this.$options7;
            case 7:
                return jl_Boolean_valueOf($this.$containsOn6);
            case 8:
                return $this.$constraintVersion6;
            case 9:
                return $this.$useGraph7;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1621))), sr_Statics_anyHash($this.$variable20)), sr_Statics_anyHash($this.$label5)), sr_Statics_anyHash($this.$property3)), sr_Statics_anyHash($this.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType)), sr_Statics_anyHash($this.$name32)), sr_Statics_anyHash($this.$ifExistsDo10)),
        sr_Statics_anyHash($this.$options7)), !$this.$containsOn6 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion6)), sr_Statics_anyHash($this.$useGraph7)), 10);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateNodePropertyTypeConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn6 != $x$1.$containsOn6)
                        break b;
                    c: {
                        var$2 = $this.$variable20;
                        var$3 = $x$1.$variable20;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label5;
                        var$3 = $x$1.$label5;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$property3;
                        var$3 = $x$1.$property3;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType;
                        var$3 = $x$1.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$name32;
                        var$3 = $x$1.$name32;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$ifExistsDo10;
                        var$3 = $x$1.$ifExistsDo10;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$options7;
                        var$3 = $x$1.$options7;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$2 = $this.$constraintVersion6;
                        var$3 = $x$1.$constraintVersion6;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break j;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    k: {
                        var$3 = $this.$useGraph7;
                        $x$1 = $x$1.$useGraph7;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break k;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateNodePropertyTypeConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateNodePropertyTypeConstraint_entityType = function($this) {
        return $this.$entityType7;
    };
    $java.oncia_CreateNodePropertyTypeConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateNodePropertyTypeConstraint_copy($this, $this.$variable20, $this.$label5, $this.$property3, $this.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType, $this.$name32, $this.$ifExistsDo10, $this.$options7, $this.$containsOn6, $this.$constraintVersion6, $useGraph, $this.$position85);
    };
    $java.oncia_CreateNodePropertyTypeConstraint__init_ = function($this, $variable, $label, $property, $propertyType, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable20 = $variable;
        $this.$label5 = $label;
        $this.$property3 = $property;
        $this.$org$neo4j$cypher$internal$ast$CreateNodePropertyTypeConstraint$$propertyType = $propertyType;
        $this.$name32 = $name;
        $this.$ifExistsDo10 = $ifExistsDo;
        $this.$options7 = $options;
        $this.$containsOn6 = $containsOn;
        $this.$constraintVersion6 = $constraintVersion;
        $this.$useGraph7 = $useGraph;
        $this.$position85 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_NodePropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
        $this.$normalizedPropertyType0 = $java.oncius_CypherType$_normalizeTypes($java.oncius_CypherType$_MODULE$, $propertyType);
    };
    var oncia_CreateNodePropertyTypeConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateNodePropertyTypeConstraint$_MODULE$ = null;
    function oncia_CreateNodePropertyTypeConstraint$__clinit_() {
        $java.oncia_CreateNodePropertyTypeConstraint$_MODULE$ = new oncia_CreateNodePropertyTypeConstraint$;
    }
    function oncia_CreateRelationshipPropertyTypeConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable21 = null;
        a.$relType4 = null;
        a.$property4 = null;
        a.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType = null;
        a.$name33 = null;
        a.$ifExistsDo11 = null;
        a.$options8 = null;
        a.$containsOn7 = 0;
        a.$constraintVersion7 = null;
        a.$useGraph8 = null;
        a.$position86 = null;
        a.$normalizedPropertyType1 = null;
        a.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes7 = null;
        a.$entityType8 = null;
        a.$errorMessageOnRequire7 = null;
        a.$errorMessageForAssert7 = null;
        a.$errorMessageForAssertExists7 = null;
        a.$errorMessageOnAssert7 = null;
        a.$errorMessageOnAssertExists7 = null;
    }
    function oncia_CreateRelationshipPropertyTypeConstraint__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10) {
        var var_11 = new oncia_CreateRelationshipPropertyTypeConstraint();
        $java.oncia_CreateRelationshipPropertyTypeConstraint__init_(var_11, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8, var_9, var_10);
        return var_11;
    }
    $java.oncia_CreateRelationshipPropertyTypeConstraint_checkOptionsMap = function($this, $schemaString, $options) {
        return $java.oncia_SchemaCommand_checkOptionsMap$($this, $schemaString, $options);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes7;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes7 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType8 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_errorMessageOnRequire = function($this) {
        return $this.$errorMessageOnRequire7;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_errorMessageForAssert = function($this) {
        return $this.$errorMessageForAssert7;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_errorMessageOnAssert = function($this) {
        return $this.$errorMessageOnAssert7;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire7 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert7 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists7 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert7 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists7 = $x$1;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_variable = function($this) {
        return $this.$variable21;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_property = function($this) {
        return $this.$property4;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_position = function($this) {
        return $this.$position86;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncia_CreateConstraint_checkSemantics$($this, $rt_s(1622), $this.$ifExistsDo11, $this.$options8, $this.$containsOn7, $this.$constraintVersion7), $java.oncia_CreateConstraint_checkPropertyTypes$($this, $rt_s(1618), $this.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType, $this.$normalizedPropertyType1)), $java.oncia_PropertyConstraintCommand_semanticCheck$($this));
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_copy = function($this, $variable, $relType, $property, $propertyType, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        return oncia_CreateRelationshipPropertyTypeConstraint__init_($variable, $relType, $property, $propertyType, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_productPrefix = function($this) {
        return $rt_s(1623);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_productArity = function($this) {
        return 10;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable21;
            case 1:
                return $this.$relType4;
            case 2:
                return $this.$property4;
            case 3:
                return $this.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType;
            case 4:
                return $this.$name33;
            case 5:
                return $this.$ifExistsDo11;
            case 6:
                return $this.$options8;
            case 7:
                return jl_Boolean_valueOf($this.$containsOn7);
            case 8:
                return $this.$constraintVersion7;
            case 9:
                return $this.$useGraph8;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1623))), sr_Statics_anyHash($this.$variable21)), sr_Statics_anyHash($this.$relType4)), sr_Statics_anyHash($this.$property4)), sr_Statics_anyHash($this.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType)), sr_Statics_anyHash($this.$name33)),
        sr_Statics_anyHash($this.$ifExistsDo11)), sr_Statics_anyHash($this.$options8)), !$this.$containsOn7 ? 1237 : 1231), sr_Statics_anyHash($this.$constraintVersion7)), sr_Statics_anyHash($this.$useGraph8)), 10);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateRelationshipPropertyTypeConstraint) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsOn7 != $x$1.$containsOn7)
                        break b;
                    c: {
                        var$2 = $this.$variable21;
                        var$3 = $x$1.$variable21;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType4;
                        var$3 = $x$1.$relType4;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$property4;
                        var$3 = $x$1.$property4;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType;
                        var$3 = $x$1.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$name33;
                        var$3 = $x$1.$name33;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$ifExistsDo11;
                        var$3 = $x$1.$ifExistsDo11;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$options8;
                        var$3 = $x$1.$options8;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$2 = $this.$constraintVersion7;
                        var$3 = $x$1.$constraintVersion7;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break j;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    k: {
                        var$3 = $this.$useGraph8;
                        $x$1 = $x$1.$useGraph8;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break k;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateRelationshipPropertyTypeConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_entityType = function($this) {
        return $this.$entityType8;
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateRelationshipPropertyTypeConstraint_copy($this, $this.$variable21, $this.$relType4, $this.$property4, $this.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType, $this.$name33, $this.$ifExistsDo11, $this.$options8, $this.$containsOn7, $this.$constraintVersion7, $useGraph, $this.$position86);
    };
    $java.oncia_CreateRelationshipPropertyTypeConstraint__init_ = function($this, $variable, $relType, $property, $propertyType, $name, $ifExistsDo, $options, $containsOn, $constraintVersion, $useGraph, $position) {
        $this.$variable21 = $variable;
        $this.$relType4 = $relType;
        $this.$property4 = $property;
        $this.$org$neo4j$cypher$internal$ast$CreateRelationshipPropertyTypeConstraint$$propertyType = $propertyType;
        $this.$name33 = $name;
        $this.$ifExistsDo11 = $ifExistsDo;
        $this.$options8 = $options;
        $this.$containsOn7 = $containsOn;
        $this.$constraintVersion7 = $constraintVersion;
        $this.$useGraph8 = $useGraph;
        $this.$position86 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_RelationshipPropertyConstraintCommand_$init$($this);
        $java.oncia_CreateConstraint_$init$($this);
        $this.$normalizedPropertyType1 = $java.oncius_CypherType$_normalizeTypes($java.oncius_CypherType$_MODULE$, $propertyType);
    };
    var oncia_CreateRelationshipPropertyTypeConstraint$ = $rt_classWithoutFields();
    $java.oncia_CreateRelationshipPropertyTypeConstraint$_MODULE$ = null;
    function oncia_CreateRelationshipPropertyTypeConstraint$__clinit_() {
        $java.oncia_CreateRelationshipPropertyTypeConstraint$_MODULE$ = new oncia_CreateRelationshipPropertyTypeConstraint$;
    }
    var oncia_ConstraintVersion1$ = $rt_classWithoutFields();
    var oncia_ConstraintVersion1$_MODULE$ = null;
    function oncia_ConstraintVersion1$__clinit_() {
        oncia_ConstraintVersion1$_MODULE$ = new oncia_ConstraintVersion1$;
    }
    $java.oncia_ConstraintVersion1$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ConstraintVersion1$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ConstraintVersion1$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ConstraintVersion1$_hashCode = function($this) {
        return (-182286474);
    };
    $java.oncia_ConstraintVersion1$_toString = function($this) {
        return $rt_s(1624);
    };
    var oncia_ConstraintVersion2$ = $rt_classWithoutFields();
    var oncia_ConstraintVersion2$_MODULE$ = null;
    function oncia_ConstraintVersion2$__clinit_() {
        oncia_ConstraintVersion2$_MODULE$ = new oncia_ConstraintVersion2$;
    }
    $java.oncia_ConstraintVersion2$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ConstraintVersion2$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ConstraintVersion2$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ConstraintVersion2$_hashCode = function($this) {
        return (-182286473);
    };
    $java.oncia_ConstraintVersion2$_toString = function($this) {
        return $rt_s(1625);
    };
    var onciafn_Neo4jASTFactory$createDatabase$lambda$_214_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createDatabase$lambda$_214_0_apply = function(var$0, var$1) {
        return jl_Integer_valueOf(var$1.$value);
    };
    var onciafn_Neo4jASTFactory$createDatabase$lambda$_214_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createDatabase$lambda$_214_1_apply = function(var$0, var$1) {
        return jl_Integer_valueOf(var$1.$value);
    };
    function oncia_CreateDatabase() {
        var a = this; jl_Object.call(a);
        a.$dbName0 = null;
        a.$ifExistsDo12 = null;
        a.$options9 = null;
        a.$waitUntilComplete1 = null;
        a.$topology0 = null;
        a.$position87 = null;
        a.$isReadOnly11 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar12 = null;
    }
    function oncia_CreateDatabase__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_CreateDatabase();
        $java.oncia_CreateDatabase__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    $java.oncia_CreateDatabase_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_CreateDatabase_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateDatabase_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateDatabase_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly11 = $x$1;
    };
    $java.oncia_CreateDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar12;
    };
    $java.oncia_CreateDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar12 = $x$1;
    };
    function oncia_CreateDatabase_dbName($this) {
        return $this.$dbName0;
    }
    function oncia_CreateDatabase_ifExistsDo($this) {
        return $this.$ifExistsDo12;
    }
    function oncia_CreateDatabase_options($this) {
        return $this.$options9;
    }
    function oncia_CreateDatabase_waitUntilComplete($this) {
        return $this.$waitUntilComplete1;
    }
    function oncia_CreateDatabase_topology($this) {
        return $this.$topology0;
    }
    function oncia_CreateDatabase_position($this) {
        return $this.$position87;
    }
    function oncia_CreateDatabase_name($this) {
        var var$1;
        var$1 = $this.$ifExistsDo12;
        if (!(jl_Object_equals(oncia_IfExistsReplace$_MODULE$, var$1) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1) ? 0 : 1))
            return $rt_s(1626);
        return $rt_s(1627);
    }
    $java.oncia_CreateDatabase_semanticCheck = function($this) {
        var var$1, $name;
        var$1 = $this.$ifExistsDo12;
        if (!jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1)) {
            $name = oncia_AdministrationCommand_semanticCheck$($this);
            oncias_SemanticState$_$callClinit();
            $name = oncias_SemanticCheck_chain$($name, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
        } else {
            $name = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $this.$dbName0, s_DummyImplicit$_dummyImplicit0);
            var$1 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$1);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(1628)), $name), $rt_s(1575));
            $name = oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$1), $this.$position87);
        }
        return $name.$chain($java.oncia_WriteAdministrationCommand_topologyCheck$($this, $this.$topology0, oncia_CreateDatabase_name($this)));
    };
    $java.oncia_CreateDatabase_productPrefix = function($this) {
        return $rt_s(1629);
    };
    $java.oncia_CreateDatabase_productArity = function($this) {
        return 5;
    };
    $java.oncia_CreateDatabase_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$dbName0;
            case 1:
                return $this.$ifExistsDo12;
            case 2:
                return $this.$options9;
            case 3:
                return $this.$waitUntilComplete1;
            case 4:
                return $this.$topology0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateDatabase_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateDatabase_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateDatabase_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateDatabase_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_CreateDatabase) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$dbName0;
                            var$3 = $x$1.$dbName0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$ifExistsDo12;
                            var$3 = $x$1.$ifExistsDo12;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$options9;
                            var$3 = $x$1.$options9;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        g: {
                            var$2 = $this.$waitUntilComplete1;
                            var$3 = $x$1.$waitUntilComplete1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break g;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$topology0;
                        $x$1 = $x$1.$topology0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateDatabase_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateDatabase_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_CreateDatabase__init_ = function($this, $dbName, $ifExistsDo, $options, $waitUntilComplete, $topology, $position) {
        $this.$dbName0 = $dbName;
        $this.$ifExistsDo12 = $ifExistsDo;
        $this.$options9 = $options;
        $this.$waitUntilComplete1 = $waitUntilComplete;
        $this.$topology0 = $topology;
        $this.$position87 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_Topology() {
        var a = this; jl_Object.call(a);
        a.$primaries = null;
        a.$secondaries = null;
    }
    function oncia_Topology__init_(var_0, var_1) {
        var var_2 = new oncia_Topology();
        $java.oncia_Topology__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_Topology_productPrefix = function($this) {
        return $rt_s(1630);
    };
    $java.oncia_Topology_productArity = function($this) {
        return 2;
    };
    $java.oncia_Topology_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$primaries;
            case 1:
                return $this.$secondaries;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Topology_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Topology_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Topology_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Topology_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Topology) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$primaries;
                        var$3 = $x$1.$primaries;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$secondaries;
                        $x$1 = $x$1.$secondaries;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Topology))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Topology__init_ = function($this, $primaries, $secondaries) {
        $this.$primaries = $primaries;
        $this.$secondaries = $secondaries;
    };
    function oncia_CreateRole() {
        var a = this; jl_Object.call(a);
        a.$roleName0 = null;
        a.$from13 = null;
        a.$ifExistsDo13 = null;
        a.$position88 = null;
        a.$isReadOnly12 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar13 = null;
    }
    function oncia_CreateRole__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_CreateRole();
        $java.oncia_CreateRole__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_CreateRole_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_CreateRole_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateRole_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateRole_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateRole_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly12 = $x$1;
    };
    $java.oncia_CreateRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar13;
    };
    $java.oncia_CreateRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar13 = $x$1;
    };
    function oncia_CreateRole_roleName($this) {
        return $this.$roleName0;
    }
    function oncia_CreateRole_from($this) {
        return $this.$from13;
    }
    function oncia_CreateRole_ifExistsDo($this) {
        return $this.$ifExistsDo13;
    }
    $java.oncia_CreateRole_position = function($this) {
        return $this.$position88;
    };
    function oncia_CreateRole_name($this) {
        var var$1;
        var$1 = $this.$ifExistsDo13;
        if (!(jl_Object_equals(oncia_IfExistsReplace$_MODULE$, var$1) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1) ? 0 : 1))
            return $rt_s(1631);
        return $rt_s(1632);
    }
    $java.oncia_CreateRole_semanticCheck = function($this) {
        var var$1, $name;
        var$1 = $this.$ifExistsDo13;
        if (!jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1)) {
            $name = oncia_AdministrationCommand_semanticCheck$($this);
            oncias_SemanticState$_$callClinit();
            return oncias_SemanticCheck_chain$($name, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
        }
        $name = onciap_Prettifier$_escapeName(onciap_Prettifier$_MODULE$, $this.$roleName0);
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(1633)), $name), $rt_s(1575));
        return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$1), $this.$position88);
    };
    $java.oncia_CreateRole_productPrefix = function($this) {
        return $rt_s(1634);
    };
    $java.oncia_CreateRole_productArity = function($this) {
        return 3;
    };
    $java.oncia_CreateRole_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$roleName0;
            case 1:
                return $this.$from13;
            case 2:
                return $this.$ifExistsDo13;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRole_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRole_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRole_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRole_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_CreateRole) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$roleName0;
                            var$3 = $x$1.$roleName0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$from13;
                            var$3 = $x$1.$from13;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$ifExistsDo13;
                        $x$1 = $x$1.$ifExistsDo13;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRole_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateRole_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_CreateRole__init_ = function($this, $roleName, $from, $ifExistsDo, $position) {
        $this.$roleName0 = $roleName;
        $this.$from13 = $from;
        $this.$ifExistsDo13 = $ifExistsDo;
        $this.$position88 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    var onciafn_Neo4jASTFactory$createRole$lambda$_157_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createRole$lambda$_157_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    $java.oncia_HomeDatabaseAction = $rt_classWithoutFields(0);
    function oncia_SetHomeDatabaseAction() {
        jl_Object.call(this);
        this.$name34 = null;
    }
    function oncia_SetHomeDatabaseAction__init_(var_0) {
        var var_1 = new oncia_SetHomeDatabaseAction();
        $java.oncia_SetHomeDatabaseAction__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_SetHomeDatabaseAction_productPrefix = function($this) {
        return $rt_s(1635);
    };
    $java.oncia_SetHomeDatabaseAction_productArity = function($this) {
        return 1;
    };
    $java.oncia_SetHomeDatabaseAction_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name34;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetHomeDatabaseAction_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetHomeDatabaseAction_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetHomeDatabaseAction_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetHomeDatabaseAction_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SetHomeDatabaseAction) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$name34;
                        $x$1 = $x$1.$name34;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SetHomeDatabaseAction__init_ = function($this, $name) {
        $this.$name34 = $name;
    };
    function oncia_UserOptions() {
        var a = this; jl_Object.call(a);
        a.$requirePasswordChange0 = null;
        a.$suspended0 = null;
        a.$homeDatabase0 = null;
    }
    function oncia_UserOptions__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_UserOptions();
        $java.oncia_UserOptions__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_UserOptions_requirePasswordChange($this) {
        return $this.$requirePasswordChange0;
    }
    function oncia_UserOptions_suspended($this) {
        return $this.$suspended0;
    }
    function oncia_UserOptions_homeDatabase($this) {
        return $this.$homeDatabase0;
    }
    $java.oncia_UserOptions_productPrefix = function($this) {
        return $rt_s(1636);
    };
    $java.oncia_UserOptions_productArity = function($this) {
        return 3;
    };
    $java.oncia_UserOptions_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$requirePasswordChange0;
            case 1:
                return $this.$suspended0;
            case 2:
                return $this.$homeDatabase0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UserOptions_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserOptions_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserOptions_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserOptions_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_UserOptions) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$requirePasswordChange0;
                            var$3 = $x$1.$requirePasswordChange0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$suspended0;
                            var$3 = $x$1.$suspended0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$homeDatabase0;
                        $x$1 = $x$1.$homeDatabase0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_UserOptions__init_ = function($this, $requirePasswordChange, $suspended, $homeDatabase) {
        $this.$requirePasswordChange0 = $requirePasswordChange;
        $this.$suspended0 = $suspended;
        $this.$homeDatabase0 = $homeDatabase;
    };
    $java.oncia_EitherAsString = $rt_classWithoutFields(0);
    function oncia_CreateUser() {
        var a = this; jl_Object.call(a);
        a.$userName0 = null;
        a.$isEncryptedPassword1 = 0;
        a.$initialPassword1 = null;
        a.$userOptions0 = null;
        a.$ifExistsDo14 = null;
        a.$position89 = null;
        a.$userAsString = null;
        a.$isReadOnly13 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar14 = null;
    }
    function oncia_CreateUser__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_CreateUser();
        $java.oncia_CreateUser__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    $java.oncia_CreateUser_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_CreateUser_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateUser_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateUser_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly13 = $x$1;
    };
    $java.oncia_CreateUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar14;
    };
    $java.oncia_CreateUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar14 = $x$1;
    };
    function oncia_CreateUser_userName($this) {
        return $this.$userName0;
    }
    function oncia_CreateUser_isEncryptedPassword($this) {
        return $this.$isEncryptedPassword1;
    }
    function oncia_CreateUser_initialPassword($this) {
        return $this.$initialPassword1;
    }
    function oncia_CreateUser_userOptions($this) {
        return $this.$userOptions0;
    }
    function oncia_CreateUser_ifExistsDo($this) {
        return $this.$ifExistsDo14;
    }
    $java.oncia_CreateUser_position = function($this) {
        return $this.$position89;
    };
    function oncia_CreateUser_name($this) {
        var var$1;
        var$1 = $this.$ifExistsDo14;
        if (!(jl_Object_equals(oncia_IfExistsReplace$_MODULE$, var$1) ? 1 : !jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1) ? 0 : 1))
            return $rt_s(1637);
        return $rt_s(1638);
    }
    $java.oncia_CreateUser_semanticCheck = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$ifExistsDo14;
        if (!jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, var$1)) {
            var$2 = oncia_AdministrationCommand_semanticCheck$($this);
            oncias_SemanticState$_$callClinit();
            return oncias_SemanticCheck_chain$(var$2, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
        }
        var$3 = $this.$userAsString;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(1639)), var$3), $rt_s(1575));
        return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$2), $this.$position89);
    };
    $java.oncia_CreateUser_productPrefix = function($this) {
        return $rt_s(1640);
    };
    $java.oncia_CreateUser_productArity = function($this) {
        return 5;
    };
    $java.oncia_CreateUser_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$userName0;
            case 1:
                return jl_Boolean_valueOf($this.$isEncryptedPassword1);
            case 2:
                return $this.$initialPassword1;
            case 3:
                return $this.$userOptions0;
            case 4:
                return $this.$ifExistsDo14;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateUser_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateUser_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1640))), sr_Statics_anyHash($this.$userName0)), !$this.$isEncryptedPassword1 ? 1237 : 1231), sr_Statics_anyHash($this.$initialPassword1)), sr_Statics_anyHash($this.$userOptions0)), sr_Statics_anyHash($this.$ifExistsDo14)), 5);
    };
    $java.oncia_CreateUser_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateUser_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_CreateUser) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$isEncryptedPassword1 != $x$1.$isEncryptedPassword1)
                            break b;
                        d: {
                            var$2 = $this.$userName0;
                            var$3 = $x$1.$userName0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$initialPassword1;
                            var$3 = $x$1.$initialPassword1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$userOptions0;
                            var$3 = $x$1.$userOptions0;
                            if (var$2 !== null) {
                                if (!$java.oncia_UserOptions_equals(var$2, var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$ifExistsDo14;
                        $x$1 = $x$1.$ifExistsDo14;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateUser_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateUser_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_CreateUser__init_ = function($this, $userName, $isEncryptedPassword, $initialPassword, $userOptions, $ifExistsDo, $position) {
        $this.$userName0 = $userName;
        $this.$isEncryptedPassword1 = $isEncryptedPassword;
        $this.$initialPassword1 = $initialPassword;
        $this.$userOptions0 = $userOptions;
        $this.$ifExistsDo14 = $ifExistsDo;
        $this.$position89 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
        if ($userName instanceof su_Left)
            $userName = $userName.$value11;
        else {
            if (!($userName instanceof su_Right))
                $rt_throw(s_MatchError__init_($userName));
            $initialPassword = $userName.$value10.$name10;
            $userName = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($userName);
            jl_AbstractStringBuilder_append($userName, 36);
            jl_StringBuilder_append($userName, $initialPassword);
            $userName = jl_AbstractStringBuilder_toString($userName);
        }
        $this.$userAsString = $userName;
    };
    function ju_HashSet() {
        ju_AbstractSet.call(this);
        this.$backingMap = null;
    }
    function ju_HashSet_add($this, $object) {
        return ju_LinkedHashMap_put($this.$backingMap, $object, $this) !== null ? 0 : 1;
    }
    function ju_HashSet_contains($this, $object) {
        return ju_HashMap_containsKey($this.$backingMap, $object);
    }
    function ju_HashSet_iterator($this) {
        var var$1, var$2;
        var$1 = $this.$backingMap;
        if (var$1.$cachedKeySet === null) {
            var$2 = new $java.ju_LinkedHashMap$1;
            var$2.$this$03 = var$1;
            var$1.$cachedKeySet = var$2;
        }
        var$2 = var$1.$cachedKeySet;
        var$1 = new ju_LinkedHashMap$KeyIterator;
        $java.ju_LinkedHashMap$AbstractMapIterator__init_(var$1, var$2.$this$03);
        return var$1;
    }
    function ju_HashSet_size($this) {
        return $this.$backingMap.$elementCount1;
    }
    var ju_LinkedHashSet = $rt_classWithoutFields(ju_HashSet);
    function ju_LinkedHashSet__init_() {
        var var_0 = new ju_LinkedHashSet();
        $java.ju_LinkedHashSet__init_(var_0);
        return var_0;
    }
    $java.ju_LinkedHashSet__init_ = function($this) {
        $this.$backingMap = ju_LinkedHashMap__init_();
    };
    var onciaf_AccessType = $rt_classWithoutFields(jl_Enum);
    var onciaf_AccessType_READ_ONLY = null;
    var onciaf_AccessType_READ_WRITE = null;
    $java.onciaf_AccessType_$VALUES = null;
    function onciaf_AccessType_$callClinit() {
        onciaf_AccessType_$callClinit = $rt_eraseClinit(onciaf_AccessType);
        $java.onciaf_AccessType__clinit_();
    }
    $java.onciaf_AccessType__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_AccessType();
        $java.onciaf_AccessType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_AccessType_values() {
        onciaf_AccessType_$callClinit();
        return $java.onciaf_AccessType_$VALUES.$clone();
    }
    $java.onciaf_AccessType__init_0 = function($this, var$1, var$2) {
        onciaf_AccessType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_AccessType__clinit_ = function() {
        var var$1;
        onciaf_AccessType_READ_ONLY = $java.onciaf_AccessType__init_($rt_s(1641), 0);
        var$1 = $java.onciaf_AccessType__init_($rt_s(1642), 1);
        onciaf_AccessType_READ_WRITE = var$1;
        $java.onciaf_AccessType_$VALUES = $rt_createArrayFromData(onciaf_AccessType, [onciaf_AccessType_READ_ONLY, var$1]);
    };
    var onciaf_ActionType = $rt_classWithoutFields(jl_Enum);
    var onciaf_ActionType_DATABASE_ALL = null;
    var onciaf_ActionType_DATABASE_START = null;
    var onciaf_ActionType_DATABASE_STOP = null;
    var onciaf_ActionType_ACCESS = null;
    var onciaf_ActionType_CREATE_TOKEN = null;
    var onciaf_ActionType_CREATE_PROPERTYKEY = null;
    var onciaf_ActionType_CREATE_LABEL = null;
    var onciaf_ActionType_CREATE_RELTYPE = null;
    var onciaf_ActionType_INDEX_ALL = null;
    var onciaf_ActionType_INDEX_CREATE = null;
    var onciaf_ActionType_INDEX_DROP = null;
    var onciaf_ActionType_INDEX_SHOW = null;
    var onciaf_ActionType_CONSTRAINT_ALL = null;
    var onciaf_ActionType_CONSTRAINT_CREATE = null;
    var onciaf_ActionType_CONSTRAINT_DROP = null;
    var onciaf_ActionType_CONSTRAINT_SHOW = null;
    var onciaf_ActionType_TRANSACTION_ALL = null;
    var onciaf_ActionType_TRANSACTION_SHOW = null;
    var onciaf_ActionType_TRANSACTION_TERMINATE = null;
    var onciaf_ActionType_DBMS_ALL = null;
    var onciaf_ActionType_USER_ALL = null;
    var onciaf_ActionType_USER_SHOW = null;
    var onciaf_ActionType_USER_CREATE = null;
    var onciaf_ActionType_USER_RENAME = null;
    var onciaf_ActionType_USER_ALTER = null;
    var onciaf_ActionType_USER_STATUS = null;
    var onciaf_ActionType_USER_PASSWORD = null;
    var onciaf_ActionType_USER_HOME = null;
    var onciaf_ActionType_USER_DROP = null;
    var onciaf_ActionType_USER_IMPERSONATE = null;
    var onciaf_ActionType_ROLE_ALL = null;
    var onciaf_ActionType_ROLE_SHOW = null;
    var onciaf_ActionType_ROLE_CREATE = null;
    var onciaf_ActionType_ROLE_RENAME = null;
    var onciaf_ActionType_ROLE_DROP = null;
    var onciaf_ActionType_ROLE_ASSIGN = null;
    var onciaf_ActionType_ROLE_REMOVE = null;
    var onciaf_ActionType_DATABASE_MANAGEMENT = null;
    var onciaf_ActionType_DATABASE_CREATE = null;
    var onciaf_ActionType_DATABASE_DROP = null;
    var onciaf_ActionType_DATABASE_COMPOSITE_MANAGEMENT = null;
    var onciaf_ActionType_DATABASE_COMPOSITE_CREATE = null;
    var onciaf_ActionType_DATABASE_COMPOSITE_DROP = null;
    var onciaf_ActionType_DATABASE_ALTER = null;
    var onciaf_ActionType_SET_DATABASE_ACCESS = null;
    var onciaf_ActionType_ALIAS_MANAGEMENT = null;
    var onciaf_ActionType_ALIAS_CREATE = null;
    var onciaf_ActionType_ALIAS_DROP = null;
    var onciaf_ActionType_ALIAS_ALTER = null;
    var onciaf_ActionType_ALIAS_SHOW = null;
    var onciaf_ActionType_PRIVILEGE_ALL = null;
    var onciaf_ActionType_PRIVILEGE_SHOW = null;
    var onciaf_ActionType_PRIVILEGE_ASSIGN = null;
    var onciaf_ActionType_PRIVILEGE_REMOVE = null;
    var onciaf_ActionType_EXECUTE_FUNCTION = null;
    var onciaf_ActionType_EXECUTE_BOOSTED_FUNCTION = null;
    var onciaf_ActionType_EXECUTE_PROCEDURE = null;
    var onciaf_ActionType_EXECUTE_BOOSTED_PROCEDURE = null;
    var onciaf_ActionType_EXECUTE_ADMIN_PROCEDURE = null;
    var onciaf_ActionType_SERVER_SHOW = null;
    var onciaf_ActionType_SERVER_MANAGEMENT = null;
    var onciaf_ActionType_SETTING_SHOW = null;
    var onciaf_ActionType_GRAPH_ALL = null;
    var onciaf_ActionType_GRAPH_WRITE = null;
    var onciaf_ActionType_GRAPH_CREATE = null;
    var onciaf_ActionType_GRAPH_MERGE = null;
    var onciaf_ActionType_GRAPH_DELETE = null;
    var onciaf_ActionType_GRAPH_LABEL_SET = null;
    var onciaf_ActionType_GRAPH_LABEL_REMOVE = null;
    var onciaf_ActionType_GRAPH_PROPERTY_SET = null;
    var onciaf_ActionType_GRAPH_MATCH = null;
    var onciaf_ActionType_GRAPH_READ = null;
    var onciaf_ActionType_GRAPH_TRAVERSE = null;
    $java.onciaf_ActionType_$VALUES = null;
    function onciaf_ActionType_$callClinit() {
        onciaf_ActionType_$callClinit = $rt_eraseClinit(onciaf_ActionType);
        $java.onciaf_ActionType__clinit_();
    }
    $java.onciaf_ActionType__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_ActionType();
        $java.onciaf_ActionType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_ActionType_values() {
        onciaf_ActionType_$callClinit();
        return $java.onciaf_ActionType_$VALUES.$clone();
    }
    $java.onciaf_ActionType__init_0 = function($this, var$1, var$2) {
        onciaf_ActionType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_ActionType_$values = function() {
        onciaf_ActionType_$callClinit();
        return $rt_createArrayFromData(onciaf_ActionType, [onciaf_ActionType_DATABASE_ALL, onciaf_ActionType_DATABASE_START, onciaf_ActionType_DATABASE_STOP, onciaf_ActionType_ACCESS, onciaf_ActionType_CREATE_TOKEN, onciaf_ActionType_CREATE_PROPERTYKEY, onciaf_ActionType_CREATE_LABEL, onciaf_ActionType_CREATE_RELTYPE, onciaf_ActionType_INDEX_ALL, onciaf_ActionType_INDEX_CREATE, onciaf_ActionType_INDEX_DROP, onciaf_ActionType_INDEX_SHOW, onciaf_ActionType_CONSTRAINT_ALL, onciaf_ActionType_CONSTRAINT_CREATE, onciaf_ActionType_CONSTRAINT_DROP,
        onciaf_ActionType_CONSTRAINT_SHOW, onciaf_ActionType_TRANSACTION_ALL, onciaf_ActionType_TRANSACTION_SHOW, onciaf_ActionType_TRANSACTION_TERMINATE, onciaf_ActionType_DBMS_ALL, onciaf_ActionType_USER_ALL, onciaf_ActionType_USER_SHOW, onciaf_ActionType_USER_CREATE, onciaf_ActionType_USER_RENAME, onciaf_ActionType_USER_ALTER, onciaf_ActionType_USER_STATUS, onciaf_ActionType_USER_PASSWORD, onciaf_ActionType_USER_HOME, onciaf_ActionType_USER_DROP, onciaf_ActionType_USER_IMPERSONATE, onciaf_ActionType_ROLE_ALL,
        onciaf_ActionType_ROLE_SHOW, onciaf_ActionType_ROLE_CREATE, onciaf_ActionType_ROLE_RENAME, onciaf_ActionType_ROLE_DROP, onciaf_ActionType_ROLE_ASSIGN, onciaf_ActionType_ROLE_REMOVE, onciaf_ActionType_DATABASE_MANAGEMENT, onciaf_ActionType_DATABASE_CREATE, onciaf_ActionType_DATABASE_DROP, onciaf_ActionType_DATABASE_COMPOSITE_MANAGEMENT, onciaf_ActionType_DATABASE_COMPOSITE_CREATE, onciaf_ActionType_DATABASE_COMPOSITE_DROP, onciaf_ActionType_DATABASE_ALTER, onciaf_ActionType_SET_DATABASE_ACCESS, onciaf_ActionType_ALIAS_MANAGEMENT,
        onciaf_ActionType_ALIAS_CREATE, onciaf_ActionType_ALIAS_DROP, onciaf_ActionType_ALIAS_ALTER, onciaf_ActionType_ALIAS_SHOW, onciaf_ActionType_PRIVILEGE_ALL, onciaf_ActionType_PRIVILEGE_SHOW, onciaf_ActionType_PRIVILEGE_ASSIGN, onciaf_ActionType_PRIVILEGE_REMOVE, onciaf_ActionType_EXECUTE_FUNCTION, onciaf_ActionType_EXECUTE_BOOSTED_FUNCTION, onciaf_ActionType_EXECUTE_PROCEDURE, onciaf_ActionType_EXECUTE_BOOSTED_PROCEDURE, onciaf_ActionType_EXECUTE_ADMIN_PROCEDURE, onciaf_ActionType_SERVER_SHOW, onciaf_ActionType_SERVER_MANAGEMENT,
        onciaf_ActionType_SETTING_SHOW, onciaf_ActionType_GRAPH_ALL, onciaf_ActionType_GRAPH_WRITE, onciaf_ActionType_GRAPH_CREATE, onciaf_ActionType_GRAPH_MERGE, onciaf_ActionType_GRAPH_DELETE, onciaf_ActionType_GRAPH_LABEL_SET, onciaf_ActionType_GRAPH_LABEL_REMOVE, onciaf_ActionType_GRAPH_PROPERTY_SET, onciaf_ActionType_GRAPH_MATCH, onciaf_ActionType_GRAPH_READ, onciaf_ActionType_GRAPH_TRAVERSE]);
    };
    $java.onciaf_ActionType__clinit_ = function() {
        onciaf_ActionType_DATABASE_ALL = $java.onciaf_ActionType__init_($rt_s(1643), 0);
        onciaf_ActionType_DATABASE_START = $java.onciaf_ActionType__init_($rt_s(1644), 1);
        onciaf_ActionType_DATABASE_STOP = $java.onciaf_ActionType__init_($rt_s(1645), 2);
        onciaf_ActionType_ACCESS = $java.onciaf_ActionType__init_($rt_s(1646), 3);
        onciaf_ActionType_CREATE_TOKEN = $java.onciaf_ActionType__init_($rt_s(1647), 4);
        onciaf_ActionType_CREATE_PROPERTYKEY = $java.onciaf_ActionType__init_($rt_s(1648), 5);
        onciaf_ActionType_CREATE_LABEL = $java.onciaf_ActionType__init_($rt_s(1649), 6);
        onciaf_ActionType_CREATE_RELTYPE = $java.onciaf_ActionType__init_($rt_s(1650), 7);
        onciaf_ActionType_INDEX_ALL = $java.onciaf_ActionType__init_($rt_s(1651), 8);
        onciaf_ActionType_INDEX_CREATE = $java.onciaf_ActionType__init_($rt_s(1652), 9);
        onciaf_ActionType_INDEX_DROP = $java.onciaf_ActionType__init_($rt_s(1653), 10);
        onciaf_ActionType_INDEX_SHOW = $java.onciaf_ActionType__init_($rt_s(1654), 11);
        onciaf_ActionType_CONSTRAINT_ALL = $java.onciaf_ActionType__init_($rt_s(1655), 12);
        onciaf_ActionType_CONSTRAINT_CREATE = $java.onciaf_ActionType__init_($rt_s(1656), 13);
        onciaf_ActionType_CONSTRAINT_DROP = $java.onciaf_ActionType__init_($rt_s(1657), 14);
        onciaf_ActionType_CONSTRAINT_SHOW = $java.onciaf_ActionType__init_($rt_s(1658), 15);
        onciaf_ActionType_TRANSACTION_ALL = $java.onciaf_ActionType__init_($rt_s(1659), 16);
        onciaf_ActionType_TRANSACTION_SHOW = $java.onciaf_ActionType__init_($rt_s(1660), 17);
        onciaf_ActionType_TRANSACTION_TERMINATE = $java.onciaf_ActionType__init_($rt_s(1661), 18);
        onciaf_ActionType_DBMS_ALL = $java.onciaf_ActionType__init_($rt_s(1662), 19);
        onciaf_ActionType_USER_ALL = $java.onciaf_ActionType__init_($rt_s(1663), 20);
        onciaf_ActionType_USER_SHOW = $java.onciaf_ActionType__init_($rt_s(1664), 21);
        onciaf_ActionType_USER_CREATE = $java.onciaf_ActionType__init_($rt_s(1665), 22);
        onciaf_ActionType_USER_RENAME = $java.onciaf_ActionType__init_($rt_s(1666), 23);
        onciaf_ActionType_USER_ALTER = $java.onciaf_ActionType__init_($rt_s(1667), 24);
        onciaf_ActionType_USER_STATUS = $java.onciaf_ActionType__init_($rt_s(1668), 25);
        onciaf_ActionType_USER_PASSWORD = $java.onciaf_ActionType__init_($rt_s(1669), 26);
        onciaf_ActionType_USER_HOME = $java.onciaf_ActionType__init_($rt_s(1670), 27);
        onciaf_ActionType_USER_DROP = $java.onciaf_ActionType__init_($rt_s(1671), 28);
        onciaf_ActionType_USER_IMPERSONATE = $java.onciaf_ActionType__init_($rt_s(1672), 29);
        onciaf_ActionType_ROLE_ALL = $java.onciaf_ActionType__init_($rt_s(1673), 30);
        onciaf_ActionType_ROLE_SHOW = $java.onciaf_ActionType__init_($rt_s(1674), 31);
        onciaf_ActionType_ROLE_CREATE = $java.onciaf_ActionType__init_($rt_s(1675), 32);
        onciaf_ActionType_ROLE_RENAME = $java.onciaf_ActionType__init_($rt_s(1676), 33);
        onciaf_ActionType_ROLE_DROP = $java.onciaf_ActionType__init_($rt_s(1677), 34);
        onciaf_ActionType_ROLE_ASSIGN = $java.onciaf_ActionType__init_($rt_s(1678), 35);
        onciaf_ActionType_ROLE_REMOVE = $java.onciaf_ActionType__init_($rt_s(1679), 36);
        onciaf_ActionType_DATABASE_MANAGEMENT = $java.onciaf_ActionType__init_($rt_s(1680), 37);
        onciaf_ActionType_DATABASE_CREATE = $java.onciaf_ActionType__init_($rt_s(1681), 38);
        onciaf_ActionType_DATABASE_DROP = $java.onciaf_ActionType__init_($rt_s(1682), 39);
        onciaf_ActionType_DATABASE_COMPOSITE_MANAGEMENT = $java.onciaf_ActionType__init_($rt_s(1683), 40);
        onciaf_ActionType_DATABASE_COMPOSITE_CREATE = $java.onciaf_ActionType__init_($rt_s(1684), 41);
        onciaf_ActionType_DATABASE_COMPOSITE_DROP = $java.onciaf_ActionType__init_($rt_s(1685), 42);
        onciaf_ActionType_DATABASE_ALTER = $java.onciaf_ActionType__init_($rt_s(1686), 43);
        onciaf_ActionType_SET_DATABASE_ACCESS = $java.onciaf_ActionType__init_($rt_s(1687), 44);
        onciaf_ActionType_ALIAS_MANAGEMENT = $java.onciaf_ActionType__init_($rt_s(1688), 45);
        onciaf_ActionType_ALIAS_CREATE = $java.onciaf_ActionType__init_($rt_s(1689), 46);
        onciaf_ActionType_ALIAS_DROP = $java.onciaf_ActionType__init_($rt_s(1690), 47);
        onciaf_ActionType_ALIAS_ALTER = $java.onciaf_ActionType__init_($rt_s(1691), 48);
        onciaf_ActionType_ALIAS_SHOW = $java.onciaf_ActionType__init_($rt_s(1692), 49);
        onciaf_ActionType_PRIVILEGE_ALL = $java.onciaf_ActionType__init_($rt_s(1693), 50);
        onciaf_ActionType_PRIVILEGE_SHOW = $java.onciaf_ActionType__init_($rt_s(1694), 51);
        onciaf_ActionType_PRIVILEGE_ASSIGN = $java.onciaf_ActionType__init_($rt_s(1695), 52);
        onciaf_ActionType_PRIVILEGE_REMOVE = $java.onciaf_ActionType__init_($rt_s(1696), 53);
        onciaf_ActionType_EXECUTE_FUNCTION = $java.onciaf_ActionType__init_($rt_s(1697), 54);
        onciaf_ActionType_EXECUTE_BOOSTED_FUNCTION = $java.onciaf_ActionType__init_($rt_s(1698), 55);
        onciaf_ActionType_EXECUTE_PROCEDURE = $java.onciaf_ActionType__init_($rt_s(1699), 56);
        onciaf_ActionType_EXECUTE_BOOSTED_PROCEDURE = $java.onciaf_ActionType__init_($rt_s(1700), 57);
        onciaf_ActionType_EXECUTE_ADMIN_PROCEDURE = $java.onciaf_ActionType__init_($rt_s(1701), 58);
        onciaf_ActionType_SERVER_SHOW = $java.onciaf_ActionType__init_($rt_s(1702), 59);
        onciaf_ActionType_SERVER_MANAGEMENT = $java.onciaf_ActionType__init_($rt_s(1703), 60);
        onciaf_ActionType_SETTING_SHOW = $java.onciaf_ActionType__init_($rt_s(1704), 61);
        onciaf_ActionType_GRAPH_ALL = $java.onciaf_ActionType__init_($rt_s(1705), 62);
        onciaf_ActionType_GRAPH_WRITE = $java.onciaf_ActionType__init_($rt_s(1706), 63);
        onciaf_ActionType_GRAPH_CREATE = $java.onciaf_ActionType__init_($rt_s(1707), 64);
        onciaf_ActionType_GRAPH_MERGE = $java.onciaf_ActionType__init_($rt_s(1708), 65);
        onciaf_ActionType_GRAPH_DELETE = $java.onciaf_ActionType__init_($rt_s(1709), 66);
        onciaf_ActionType_GRAPH_LABEL_SET = $java.onciaf_ActionType__init_($rt_s(1710), 67);
        onciaf_ActionType_GRAPH_LABEL_REMOVE = $java.onciaf_ActionType__init_($rt_s(1711), 68);
        onciaf_ActionType_GRAPH_PROPERTY_SET = $java.onciaf_ActionType__init_($rt_s(1712), 69);
        onciaf_ActionType_GRAPH_MATCH = $java.onciaf_ActionType__init_($rt_s(1713), 70);
        onciaf_ActionType_GRAPH_READ = $java.onciaf_ActionType__init_($rt_s(1714), 71);
        onciaf_ActionType_GRAPH_TRAVERSE = $java.onciaf_ActionType__init_($rt_s(1715), 72);
        $java.onciaf_ActionType_$VALUES = $java.onciaf_ActionType_$values();
    };
    function onciafn_Privilege() {
        var a = this; jl_Object.call(a);
        a.$privilegeType = null;
        a.$resource0 = null;
        a.$qualifier0 = null;
        a.$immutable = 0;
    }
    function onciafn_Privilege__init_0(var_0, var_1, var_2, var_3) {
        var var_4 = new onciafn_Privilege();
        onciafn_Privilege__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function onciafn_Privilege__init_($this, $privilegeType, $resource, $qualifier, $immutable) {
        $this.$privilegeType = $privilegeType;
        $this.$resource0 = $resource;
        $this.$qualifier0 = $qualifier;
        $this.$immutable = $immutable;
    }
    $java.oncia_DatabaseScope = $rt_classWithoutFields(0);
    var onciaf_HintIndexType = $rt_classWithoutFields(jl_Enum);
    var onciaf_HintIndexType_ANY = null;
    var onciaf_HintIndexType_BTREE = null;
    var onciaf_HintIndexType_TEXT = null;
    var onciaf_HintIndexType_RANGE = null;
    var onciaf_HintIndexType_POINT = null;
    $java.onciaf_HintIndexType_$VALUES = null;
    function onciaf_HintIndexType_$callClinit() {
        onciaf_HintIndexType_$callClinit = $rt_eraseClinit(onciaf_HintIndexType);
        $java.onciaf_HintIndexType__clinit_();
    }
    $java.onciaf_HintIndexType__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_HintIndexType();
        $java.onciaf_HintIndexType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_HintIndexType_values() {
        onciaf_HintIndexType_$callClinit();
        return $java.onciaf_HintIndexType_$VALUES.$clone();
    }
    $java.onciaf_HintIndexType__init_0 = function($this, var$1, var$2) {
        onciaf_HintIndexType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_HintIndexType__clinit_ = function() {
        var var$1;
        onciaf_HintIndexType_ANY = $java.onciaf_HintIndexType__init_($rt_s(1522), 0);
        onciaf_HintIndexType_BTREE = $java.onciaf_HintIndexType__init_($rt_s(1432), 1);
        onciaf_HintIndexType_TEXT = $java.onciaf_HintIndexType__init_($rt_s(1436), 2);
        onciaf_HintIndexType_RANGE = $java.onciaf_HintIndexType__init_($rt_s(1433), 3);
        var$1 = $java.onciaf_HintIndexType__init_($rt_s(1437), 4);
        onciaf_HintIndexType_POINT = var$1;
        $java.onciaf_HintIndexType_$VALUES = $rt_createArrayFromData(onciaf_HintIndexType, [onciaf_HintIndexType_ANY, onciaf_HintIndexType_BTREE, onciaf_HintIndexType_TEXT, onciaf_HintIndexType_RANGE, var$1]);
    };
    $java.oncie_MatchMode$MatchMode = $rt_classWithoutFields(0);
    function oncia_SubqueryCall$InTransactionsParameters() {
        var a = this; jl_Object.call(a);
        a.$batchParams = null;
        a.$errorParams = null;
        a.$reportParams = null;
        a.$position90 = null;
    }
    function oncia_SubqueryCall$InTransactionsParameters__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_SubqueryCall$InTransactionsParameters();
        $java.oncia_SubqueryCall$InTransactionsParameters__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_SubqueryCall$InTransactionsParameters_position = function($this) {
        return $this.$position90;
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_semanticCheck = function($this) {
        var $checkBatchParams, $checkReportParams, $reportParams, $checkErrorReportCombination, var$5;
        a: {
            $checkBatchParams = oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $this.$batchParams, new $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_0);
            $checkReportParams = oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $this.$reportParams, new $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_1);
            $reportParams = s_Tuple2__init_($this.$errorParams, $this.$reportParams);
            $checkErrorReportCombination = $reportParams.$_10;
            var$5 = $reportParams.$_20;
            if (jl_Object_equals(s_None$_MODULE$, $checkErrorReportCombination) && var$5 instanceof s_Some) {
                $reportParams = var$5.$value5;
                oncias_SemanticPatternCheck$_$callClinit();
                $checkErrorReportCombination = oncias_SemanticAnalysisTooling_error$(oncias_SemanticPatternCheck$_MODULE$, $rt_s(1716), $reportParams.$position91);
            } else {
                $checkErrorReportCombination = $reportParams.$_10;
                $reportParams = $reportParams.$_20;
                if ($checkErrorReportCombination instanceof s_Some) {
                    $checkErrorReportCombination = $checkErrorReportCombination.$value5;
                    if ($checkErrorReportCombination !== null) {
                        var$5 = $checkErrorReportCombination.$behaviour;
                        if (jl_Object_equals(oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_MODULE$, var$5) && $reportParams instanceof s_Some) {
                            $reportParams = $reportParams.$value5;
                            oncias_SemanticPatternCheck$_$callClinit();
                            $checkErrorReportCombination = oncias_SemanticAnalysisTooling_error$(oncias_SemanticPatternCheck$_MODULE$, $rt_s(1716), $reportParams.$position91);
                            break a;
                        }
                    }
                }
                $checkErrorReportCombination = oncias_SemanticCheck$_success;
            }
        }
        return oncias_SemanticCheck_chain$($checkBatchParams.$chain($checkReportParams), $checkErrorReportCombination);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_productPrefix = function($this) {
        return $rt_s(1717);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_productArity = function($this) {
        return 3;
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$batchParams;
            case 1:
                return $this.$errorParams;
            case 2:
                return $this.$reportParams;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SubqueryCall$InTransactionsParameters) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$batchParams;
                            var$3 = $x$1.$batchParams;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$errorParams;
                            var$3 = $x$1.$errorParams;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$reportParams;
                        $x$1 = $x$1.$reportParams;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_SubqueryCall$InTransactionsParameters_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters__init_ = function($this, $batchParams, $errorParams, $reportParams, $position) {
        $this.$batchParams = $batchParams;
        $this.$errorParams = $errorParams;
        $this.$reportParams = $reportParams;
        $this.$position90 = $position;
    };
    function sci_HashCollisionSetNode$removed$lambda$_6_0() {
        jl_Object.call(this);
        this.$_0173 = null;
    }
    $java.sci_HashCollisionSetNode$removed$lambda$_6_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(!sr_BoxesRunTime_equals(var$1, var$0.$_0173) ? 0 : 1);
    };
    function ju_Formatter$FormatWriter() {
        var a = this; jl_Object.call(a);
        a.$formatter = null;
        a.$out3 = null;
        a.$locale0 = null;
        a.$format0 = null;
        a.$args1 = null;
        a.$index2 = 0;
        a.$formatSpecifierStart = 0;
        a.$defaultArgumentIndex = 0;
        a.$argumentIndex = 0;
        a.$previousArgumentIndex = 0;
        a.$width = 0;
        a.$precision0 = 0;
        a.$flags0 = 0;
    }
    function ju_Formatter$FormatWriter__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new ju_Formatter$FormatWriter();
        $java.ju_Formatter$FormatWriter__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.ju_Formatter$FormatWriter__init_ = function($this, $formatter, $out, $locale, $format, $args) {
        $this.$formatter = $formatter;
        $this.$out3 = $out;
        $this.$locale0 = $locale;
        $this.$format0 = $format;
        $this.$args1 = $args;
    };
    function ju_Formatter$FormatWriter_write($this) {
        var $next, $specifier, var$3;
        a: while (true) {
            $next = jl_String_indexOf($this.$format0, 37, $this.$index2);
            if ($next < 0) {
                jl_AbstractStringBuilder_append0($this.$out3, jl_String_substring($this.$format0, $this.$index2));
                return;
            }
            jl_AbstractStringBuilder_append0($this.$out3, jl_String_substring0($this.$format0, $this.$index2, $next));
            $next = $next + 1 | 0;
            $this.$index2 = $next;
            $this.$formatSpecifierStart = $next;
            $specifier = $java.ju_Formatter$FormatWriter_parseFormatSpecifier($this);
            if ($this.$flags0 & 256)
                $this.$argumentIndex = jl_Math_max(0, $this.$previousArgumentIndex);
            if ($this.$argumentIndex == (-1)) {
                var$3 = $this.$defaultArgumentIndex;
                $this.$defaultArgumentIndex = var$3 + 1 | 0;
                $this.$argumentIndex = var$3;
            }
            b: {
                $this.$previousArgumentIndex = $this.$argumentIndex;
                switch ($specifier) {
                    case 66:
                        break;
                    case 67:
                        $java.ju_Formatter$FormatWriter_formatChar($this, $specifier, 1);
                        break b;
                    case 68:
                        $java.ju_Formatter$FormatWriter_formatDecimalInt($this, $specifier, 1);
                        break b;
                    case 69:
                    case 70:
                    case 71:
                    case 73:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                    case 78:
                    case 80:
                    case 81:
                    case 82:
                    case 84:
                    case 85:
                    case 86:
                    case 87:
                    case 89:
                    case 90:
                    case 91:
                    case 92:
                    case 93:
                    case 94:
                    case 95:
                    case 96:
                    case 97:
                    case 101:
                    case 102:
                    case 103:
                    case 105:
                    case 106:
                    case 107:
                    case 108:
                    case 109:
                    case 110:
                    case 112:
                    case 113:
                    case 114:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                        break a;
                    case 72:
                        $java.ju_Formatter$FormatWriter_formatHex($this, $specifier, 1);
                        break b;
                    case 79:
                        $java.ju_Formatter$FormatWriter_formatRadixInt($this, $specifier, 3, 1);
                        break b;
                    case 83:
                        $java.ju_Formatter$FormatWriter_formatString($this, $specifier, 1);
                        break b;
                    case 88:
                        $java.ju_Formatter$FormatWriter_formatRadixInt($this, $specifier, 4, 1);
                        break b;
                    case 98:
                        $java.ju_Formatter$FormatWriter_formatBoolean($this, $specifier, 0);
                        break b;
                    case 99:
                        $java.ju_Formatter$FormatWriter_formatChar($this, $specifier, 0);
                        break b;
                    case 100:
                        $java.ju_Formatter$FormatWriter_formatDecimalInt($this, $specifier, 0);
                        break b;
                    case 104:
                        $java.ju_Formatter$FormatWriter_formatHex($this, $specifier, 0);
                        break b;
                    case 111:
                        $java.ju_Formatter$FormatWriter_formatRadixInt($this, $specifier, 3, 0);
                        break b;
                    case 115:
                        $java.ju_Formatter$FormatWriter_formatString($this, $specifier, 0);
                        break b;
                    case 120:
                        $java.ju_Formatter$FormatWriter_formatRadixInt($this, $specifier, 4, 0);
                        break b;
                    default:
                        break a;
                }
                $java.ju_Formatter$FormatWriter_formatBoolean($this, $specifier, 1);
            }
        }
        $rt_throw($java.ju_UnknownFormatConversionException__init_(jl_String_valueOf0($specifier)));
    }
    $java.ju_Formatter$FormatWriter_formatBoolean = function($this, $specifier, $upperCase) {
        var $arg;
        $java.ju_Formatter$FormatWriter_verifyFlagsForGeneralFormat($this, $specifier);
        $arg = $this.$args1.data[$this.$argumentIndex];
        $java.ju_Formatter$FormatWriter_formatGivenString($this, $upperCase, jl_Boolean_toString($arg instanceof jl_Boolean ? $arg.$value8 : $arg === null ? 0 : 1));
    };
    $java.ju_Formatter$FormatWriter_formatHex = function($this, $specifier, $upperCase) {
        var $arg;
        $java.ju_Formatter$FormatWriter_verifyFlagsForGeneralFormat($this, $specifier);
        $arg = $this.$args1.data[$this.$argumentIndex];
        $java.ju_Formatter$FormatWriter_formatGivenString($this, $upperCase, $arg === null ? $rt_s(7) : jl_Integer_toHexString($arg.$hashCode0()));
    };
    $java.ju_Formatter$FormatWriter_formatString = function($this, $specifier, $upperCase) {
        var $arg, $flagsToPass;
        $java.ju_Formatter$FormatWriter_verifyFlagsForGeneralFormat($this, $specifier);
        $arg = $this.$args1.data[$this.$argumentIndex];
        if (!$rt_isInstance($arg, $java.ju_Formattable))
            $java.ju_Formatter$FormatWriter_formatGivenString($this, $upperCase, jl_String_valueOf($arg));
        else {
            $flagsToPass = $this.$flags0 & 7;
            if ($upperCase)
                $flagsToPass = $flagsToPass | 2;
            $arg.$formatTo($this.$formatter, $flagsToPass, $this.$width, $this.$precision0);
        }
    };
    $java.ju_Formatter$FormatWriter_formatChar = function($this, $specifier, $upperCase) {
        var $arg, $c, var$5;
        $java.ju_Formatter$FormatWriter_verifyFlags($this, $specifier, 259);
        $arg = $this.$args1.data[$this.$argumentIndex];
        $c = $this.$precision0;
        if ($c >= 0)
            $rt_throw($java.ju_IllegalFormatPrecisionException__init_($c));
        if ($arg instanceof jl_Character)
            $c = $arg.$value1;
        else if ($arg instanceof jl_Byte)
            $c = $arg.$value13 & 65535;
        else if ($arg instanceof jl_Short)
            $c = $arg.$value14 & 65535;
        else {
            if (!($arg instanceof jl_Integer)) {
                if ($arg === null) {
                    $java.ju_Formatter$FormatWriter_formatGivenString($this, $upperCase, $rt_s(7));
                    return;
                }
                $rt_throw($java.ju_IllegalFormatConversionException__init_($specifier, jl_Object_getClass($arg)));
            }
            $c = $arg.$value;
            if (!($c >= 0 && $c <= 1114111 ? 1 : 0)) {
                $arg = new $java.ju_IllegalFormatCodePointException;
                var$5 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$5);
                jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$5, $rt_s(1718)), $c), $rt_s(1719));
                jl_Throwable__init_($arg, jl_AbstractStringBuilder_toString(var$5));
                $arg.$codePoint = $c;
                $rt_throw($arg);
            }
        }
        $java.ju_Formatter$FormatWriter_formatGivenString($this, $upperCase, jl_String__init_(jl_Character_toChars($c)));
    };
    $java.ju_Formatter$FormatWriter_formatDecimalInt = function($this, $specifier, $upperCase) {
        var $arg, $value, $str, $negative, $value_0, $additionalSymbols, $sb, $valueSb, $separator, var$12, var$13, var$14, var$15, var$16, var$17, $size, $i, $prev, $i_0;
        $java.ju_Formatter$FormatWriter_verifyFlags($this, $specifier, 507);
        $java.ju_Formatter$FormatWriter_verifyIntFlags($this);
        $arg = $this.$args1.data[$this.$argumentIndex];
        if ($arg instanceof jl_Long) {
            $value = $arg.$value2;
            $specifier = Long_compare($value, Long_ZERO);
            if ($specifier <= 0)
                $value = Long_neg($value);
            $str = jl_Long_toString($value);
            $negative = $specifier >= 0 ? 0 : 1;
        } else {
            if (!($arg instanceof jl_Integer) && !($arg instanceof jl_Byte) && !($arg instanceof jl_Short))
                $rt_throw($java.ju_IllegalFormatConversionException__init_($specifier, $arg === null ? null : jl_Object_getClass($arg)));
            $value_0 = $arg.$intValue();
            $str = jl_Integer_toString0(jl_Math_abs($value_0));
            $negative = $value_0 >= 0 ? 0 : 1;
        }
        $additionalSymbols = 0;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        if ($negative) {
            if (!($this.$flags0 & 128)) {
                jl_AbstractStringBuilder_append($sb, 45);
                $additionalSymbols = 1;
            } else {
                jl_AbstractStringBuilder_append($sb, 40);
                $additionalSymbols = 2;
            }
        } else {
            $specifier = $this.$flags0;
            if ($specifier & 8) {
                jl_StringBuilder_append4($sb, 43);
                $additionalSymbols = 1;
            } else if ($specifier & 16) {
                jl_StringBuilder_append4($sb, 32);
                $additionalSymbols = 1;
            }
        }
        $valueSb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($valueSb);
        if (!($this.$flags0 & 64))
            jl_AbstractStringBuilder_append1($valueSb, $str);
        else {
            $separator = ($java.jt_DecimalFormatSymbols__init_($this.$locale0)).$groupingSeparator;
            $arg = $this.$locale0;
            var$12 = $arg.$languageCode;
            var$13 = $arg.$countryCode;
            if ($java.otciu_CLDRHelper_$$metadata$$17 === null)
                $java.otciu_CLDRHelper_$$metadata$$17 = $java.otciu_CLDRHelper_getNumberFormatMap$$create();
            var$14 = $java.otciu_CLDRHelper_$$metadata$$17;
            var$15 = $java.otciu_CLDRHelper_getCode(var$12, var$13);
            var$15 = var$14.hasOwnProperty($rt_ustr(var$15)) ? var$14[$rt_ustr(var$15)] : var$14.hasOwnProperty($rt_ustr(var$12)) ? var$14[$rt_ustr(var$12)] : var$14.root;
            var$12 = (var$15.value !== null ? $rt_str(var$15.value) : null);
            var$16 = new jt_DecimalFormat;
            var$15 = $java.jt_DecimalFormatSymbols__init_($arg);
            var$16.$groupingUsed = 1;
            var$16.$maximumIntegerDigits = 40;
            var$16.$minimumIntegerDigits = 1;
            var$16.$maximumFractionDigits = 3;
            jm_RoundingMode_$callClinit();
            var$16.$roundingMode0 = jm_RoundingMode_HALF_EVEN;
            $arg = ju_Locale_getDefault();
            if ($arg === null) {
                $arg = new jl_NullPointerException;
                jl_Throwable__init_0($arg);
                $rt_throw($arg);
            }
            var$14 = $arg.$languageCode;
            $arg = $arg.$countryCode;
            if (jl_String_isEmpty($arg)) {
                if ($java.otciu_CLDRHelper_$$metadata$$0 === null)
                    $java.otciu_CLDRHelper_$$metadata$$0 = $java.otciu_CLDRHelper_getLikelySubtagsMap$$create();
                $arg = $java.otciu_CLDRHelper_$$metadata$$0;
                if ($arg.hasOwnProperty($rt_ustr(var$14)))
                    var$14 = ($arg[$rt_ustr(var$14)].value !== null ? $rt_str($arg[$rt_ustr(var$14)].value) : null);
                $specifier = jl_String_lastIndexOf(var$14, 95);
                $arg = $specifier <= 0 ? $rt_s(3) : jl_String_substring(var$14, $specifier + 1 | 0);
            }
            if ($java.otcic_CurrencyHelper_$$metadata$$1 === null)
                $java.otcic_CurrencyHelper_$$metadata$$1 = $java.otcic_CurrencyHelper_getCountryToCurrencyMap$$create();
            var$14 = $java.otcic_CurrencyHelper_$$metadata$$1;
            if (!var$14.hasOwnProperty($rt_ustr($arg)))
                $arg = null;
            else {
                var$14 = (var$14[$rt_ustr($arg)].value !== null ? $rt_str(var$14[$rt_ustr($arg)].value) : null);
                if (var$14 === null) {
                    $arg = new jl_NullPointerException;
                    jl_Exception__init_0($arg);
                    $rt_throw($arg);
                }
                $java.ju_Currency_initCurrencies();
                $arg = $java.ju_HashMap_getEntry($java.ju_Currency_currencies, var$14);
                $arg = $arg === null ? null : $arg.$value12;
                if ($arg === null) {
                    $arg = new jl_IllegalArgumentException;
                    $str = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append($str, $rt_s(1720)), var$14);
                    jl_IllegalArgumentException__init_2($arg, jl_StringBuilder_toString($str));
                    $rt_throw($arg);
                }
            }
            var$16.$currency = $arg;
            var$16.$positivePrefix = $rt_createArray($java.jt_DecimalFormat$FormatField, 0);
            var$17 = $rt_createArray($java.jt_DecimalFormat$FormatField, 1);
            var$17.data[0] = $java.jt_DecimalFormat$TextField__init_($rt_s(992));
            var$16.$negativePrefix = var$17;
            var$16.$positiveSuffix = $rt_createArray($java.jt_DecimalFormat$FormatField, 0);
            var$16.$negativeSuffix = $rt_createArray($java.jt_DecimalFormat$FormatField, 0);
            var$16.$multiplier = 1;
            var$16.$symbols = $java.jt_DecimalFormatSymbols_clone(var$15);
            $java.jt_DecimalFormat_applyPattern(var$16, var$12);
            $size = $java.jt_DecimalFormat_getGroupingSize(var$16);
            $i = jl_String_length($str) % $size | 0;
            if (!$i)
                $i = $size;
            $prev = 0;
            while ($i < jl_String_length($str)) {
                jl_StringBuilder_append1($valueSb, jl_String_substring0($str, $prev, $i));
                jl_StringBuilder_append4($valueSb, $separator);
                $i_0 = $i + $size | 0;
                $prev = $i;
                $i = $i_0;
            }
            jl_StringBuilder_append1($valueSb, jl_String_substring($str, $prev));
        }
        a: {
            if ($this.$flags0 & 32) {
                $i = jl_StringBuilder_length($valueSb) + $additionalSymbols | 0;
                while (true) {
                    if ($i >= $this.$width)
                        break a;
                    jl_StringBuilder_append4($sb, jl_Character_forDigit(0, 10));
                    $i = $i + 1 | 0;
                }
            }
        }
        jl_StringBuilder_append6($sb, $valueSb);
        if ($negative && $this.$flags0 & 128)
            jl_StringBuilder_append4($sb, 41);
        $java.ju_Formatter$FormatWriter_formatGivenString($this, $upperCase, jl_StringBuilder_toString($sb));
    };
    $java.ju_Formatter$FormatWriter_formatRadixInt = function($this, $specifier, $radixLog2, $upperCase) {
        var $arg, $str, var$6, $i, var$8, var$9, var$10, var$11, var$12, var$13, var$14, $sb, $prefix;
        $java.ju_Formatter$FormatWriter_verifyFlags($this, $specifier, 423);
        $java.ju_Formatter$FormatWriter_verifyIntFlags($this);
        $arg = $this.$args1.data[$this.$argumentIndex];
        if (!($arg instanceof jl_Long)) {
            if ($arg instanceof jl_Integer)
                $str = otci_IntegerUtil_toUnsignedLogRadixString($arg.$value, $radixLog2);
            else if ($arg instanceof jl_Short)
                $str = otci_IntegerUtil_toUnsignedLogRadixString($arg.$value14 & 65535, $radixLog2);
            else {
                if (!($arg instanceof jl_Byte))
                    $rt_throw($java.ju_IllegalFormatConversionException__init_($specifier, $arg === null ? null : jl_Object_getClass($arg)));
                $str = otci_IntegerUtil_toUnsignedLogRadixString($arg.$value13 & 255, $radixLog2);
            }
        } else {
            var$6 = $arg.$value2;
            $specifier = Long_compare(var$6, Long_ZERO);
            if (!$specifier)
                $str = $rt_s(14);
            else {
                $i = 1 << $radixLog2;
                var$8 = $i - 1 | 0;
                if (!$specifier)
                    $specifier = 64;
                else {
                    var$9 = 0;
                    var$10 = Long_shru(var$6, 32);
                    if (Long_ne(var$10, Long_ZERO))
                        var$9 = 32;
                    else
                        var$10 = var$6;
                    var$11 = Long_shru(var$10, 16);
                    if (Long_eq(var$11, Long_ZERO))
                        var$11 = var$10;
                    else
                        var$9 = var$9 | 16;
                    var$10 = Long_shru(var$11, 8);
                    if (Long_eq(var$10, Long_ZERO))
                        var$10 = var$11;
                    else
                        var$9 = var$9 | 8;
                    var$11 = Long_shru(var$10, 4);
                    if (Long_eq(var$11, Long_ZERO))
                        var$11 = var$10;
                    else
                        var$9 = var$9 | 4;
                    var$10 = Long_shru(var$11, 2);
                    if (Long_eq(var$10, Long_ZERO))
                        var$10 = var$11;
                    else
                        var$9 = var$9 | 2;
                    if (Long_ne(Long_shru(var$10, 1), Long_ZERO))
                        var$9 = var$9 | 1;
                    $specifier = (64 - var$9 | 0) - 1 | 0;
                }
                $specifier = (((64 - $specifier | 0) + $radixLog2 | 0) - 1 | 0) / $radixLog2 | 0;
                var$12 = $rt_createCharArray($specifier);
                var$13 = var$12.data;
                $specifier = $rt_imul($specifier - 1 | 0, $radixLog2);
                var$9 = 0;
                while ($specifier >= 0) {
                    var$14 = var$9 + 1 | 0;
                    var$13[var$9] = jl_Character_forDigit(Long_lo(Long_shru(var$6, $specifier)) & var$8, $i);
                    $specifier = $specifier - $radixLog2 | 0;
                    var$9 = var$14;
                }
                $str = jl_String__init_(var$12);
            }
        }
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        if ($this.$flags0 & 4) {
            $prefix = $radixLog2 != 4 ? $rt_s(14) : $rt_s(1721);
            $arg = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($arg);
            jl_StringBuilder_append(jl_StringBuilder_append($arg, $prefix), $str);
            $str = jl_AbstractStringBuilder_toString($arg);
        }
        a: {
            if ($this.$flags0 & 32) {
                $i = jl_String_length($str);
                while (true) {
                    if ($i >= $this.$width)
                        break a;
                    jl_AbstractStringBuilder_append($sb, jl_Character_forDigit(0, 10));
                    $i = $i + 1 | 0;
                }
            }
        }
        jl_AbstractStringBuilder_append1($sb, $str);
        $java.ju_Formatter$FormatWriter_formatGivenString($this, $upperCase, jl_AbstractStringBuilder_toString($sb));
    };
    $java.ju_Formatter$FormatWriter_verifyIntFlags = function($this) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = $this.$flags0;
        if (var$1 & 8 && var$1 & 16)
            $rt_throw($java.ju_IllegalFormatFlagsException__init_($rt_s(1722)));
        if (var$1 & 32 && var$1 & 1)
            $rt_throw($java.ju_IllegalFormatFlagsException__init_($rt_s(1723)));
        var$2 = $this.$precision0;
        if (var$2 >= 0)
            $rt_throw($java.ju_IllegalFormatPrecisionException__init_(var$2));
        if (var$1 & 1 && $this.$width < 0) {
            var$3 = new $java.ju_MissingFormatWidthException;
            var$4 = jl_String_substring0($this.$format0, $this.$formatSpecifierStart, $this.$index2);
            var$5 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$5);
            jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(1724)), var$4);
            jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString(var$5));
            var$3.$formatSpecifier = var$4;
            $rt_throw(var$3);
        }
    };
    $java.ju_Formatter$FormatWriter_formatGivenString = function($this, $upperCase, $str) {
        var var$3;
        var$3 = $this.$precision0;
        if (var$3 > 0)
            $str = jl_String_substring0($str, 0, var$3);
        if ($upperCase)
            $str = jl_String_toUpperCase($str);
        if (!($this.$flags0 & 1)) {
            $java.ju_Formatter$FormatWriter_mayBeAppendSpaces($this, $str);
            jl_AbstractStringBuilder_append0($this.$out3, $str);
        } else {
            jl_AbstractStringBuilder_append0($this.$out3, $str);
            $java.ju_Formatter$FormatWriter_mayBeAppendSpaces($this, $str);
        }
    };
    $java.ju_Formatter$FormatWriter_verifyFlagsForGeneralFormat = function($this, $conversion) {
        $java.ju_Formatter$FormatWriter_verifyFlags($this, $conversion, 263);
    };
    $java.ju_Formatter$FormatWriter_verifyFlags = function($this, $conversion, $mask) {
        var var$3, var$4, var$5, var$6;
        var$3 = $this.$flags0;
        if ((var$3 | $mask) == $mask)
            return;
        var$4 = new $java.ju_FormatFlagsConversionMismatchException;
        var$5 = jl_String_valueOf0(jl_String_charAt($rt_s(1725), jl_Integer_numberOfTrailingZeros(var$3 & ($mask ^ (-1)))));
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(1726)), var$5), $rt_s(1727)), $conversion);
        jl_Throwable__init_(var$4, jl_AbstractStringBuilder_toString(var$6));
        var$4.$flags1 = var$5;
        var$4.$conversion = $conversion;
        $rt_throw(var$4);
    };
    $java.ju_Formatter$FormatWriter_mayBeAppendSpaces = function($this, $str) {
        var $diff, $sb, $i;
        if ($this.$width > jl_String_length($str)) {
            $diff = $this.$width - jl_String_length($str) | 0;
            $sb = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2($sb, $diff);
            $i = 0;
            while ($i < $diff) {
                jl_AbstractStringBuilder_append($sb, 32);
                $i = $i + 1 | 0;
            }
            jl_AbstractStringBuilder_append0($this.$out3, $sb);
        }
    };
    $java.ju_Formatter$FormatWriter_parseFormatSpecifier = function($this) {
        var $c, $n, var$3, var$4, var$5, var$6;
        $this.$flags0 = 0;
        $this.$argumentIndex = (-1);
        $this.$width = (-1);
        $this.$precision0 = (-1);
        $c = jl_String_charAt($this.$format0, $this.$index2);
        if ($c != 48 && $java.ju_Formatter$FormatWriter_isDigit($c)) {
            $n = $java.ju_Formatter$FormatWriter_readInt($this);
            if ($this.$index2 < jl_String_length($this.$format0) && jl_String_charAt($this.$format0, $this.$index2) == 36) {
                $this.$index2 = $this.$index2 + 1 | 0;
                $this.$argumentIndex = $n - 1 | 0;
            } else
                $this.$width = $n;
        }
        a: {
            b: {
                while (true) {
                    if ($this.$index2 >= jl_String_length($this.$format0))
                        break a;
                    c: {
                        $c = jl_String_charAt($this.$format0, $this.$index2);
                        switch ($c) {
                            case 32:
                                break;
                            case 33:
                            case 34:
                            case 36:
                            case 37:
                            case 38:
                            case 39:
                            case 41:
                            case 42:
                            case 46:
                            case 47:
                            case 49:
                            case 50:
                            case 51:
                            case 52:
                            case 53:
                            case 54:
                            case 55:
                            case 56:
                            case 57:
                            case 58:
                            case 59:
                                break b;
                            case 35:
                                $n = 4;
                                break c;
                            case 40:
                                $n = 128;
                                break c;
                            case 43:
                                $n = 8;
                                break c;
                            case 44:
                                $n = 64;
                                break c;
                            case 45:
                                $n = 1;
                                break c;
                            case 48:
                                $n = 32;
                                break c;
                            case 60:
                                $n = 256;
                                break c;
                            default:
                                break b;
                        }
                        $n = 16;
                    }
                    var$3 = $this.$flags0;
                    if (var$3 & $n)
                        break;
                    $this.$flags0 = var$3 | $n;
                    $this.$index2 = $this.$index2 + 1 | 0;
                }
                var$4 = new $java.ju_DuplicateFormatFlagsException;
                var$5 = jl_String_valueOf0($c);
                var$6 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$6);
                jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(1728)), var$5);
                jl_Throwable__init_(var$4, jl_AbstractStringBuilder_toString(var$6));
                var$4.$flags2 = var$5;
                $rt_throw(var$4);
            }
        }
        if ($this.$width < 0 && $this.$index2 < jl_String_length($this.$format0) && $java.ju_Formatter$FormatWriter_isDigit(jl_String_charAt($this.$format0, $this.$index2)))
            $this.$width = $java.ju_Formatter$FormatWriter_readInt($this);
        if ($this.$index2 < jl_String_length($this.$format0) && jl_String_charAt($this.$format0, $this.$index2) == 46) {
            $c = $this.$index2 + 1 | 0;
            $this.$index2 = $c;
            if ($c < jl_String_length($this.$format0) && $java.ju_Formatter$FormatWriter_isDigit(jl_String_charAt($this.$format0, $this.$index2)))
                $this.$precision0 = $java.ju_Formatter$FormatWriter_readInt($this);
            else
                $rt_throw($java.ju_UnknownFormatConversionException__init_(jl_String_valueOf0(jl_String_charAt($this.$format0, $this.$index2 - 1 | 0))));
        }
        if ($this.$index2 < jl_String_length($this.$format0)) {
            var$4 = $this.$format0;
            $n = $this.$index2;
            $this.$index2 = $n + 1 | 0;
            return jl_String_charAt(var$4, $n);
        }
        var$4 = new $java.ju_UnknownFormatConversionException;
        var$5 = $this.$format0;
        $java.ju_UnknownFormatConversionException__init_0(var$4, jl_String_valueOf0(jl_String_charAt(var$5, jl_String_length(var$5) - 1 | 0)));
        $rt_throw(var$4);
    };
    $java.ju_Formatter$FormatWriter_readInt = function($this) {
        var $result, var$2, var$3, var$4;
        $result = 0;
        while ($this.$index2 < jl_String_length($this.$format0) && $java.ju_Formatter$FormatWriter_isDigit(jl_String_charAt($this.$format0, $this.$index2))) {
            var$2 = $result * 10 | 0;
            var$3 = $this.$format0;
            var$4 = $this.$index2;
            $this.$index2 = var$4 + 1 | 0;
            $result = var$2 + (jl_String_charAt(var$3, var$4) - 48 | 0) | 0;
        }
        return $result;
    };
    $java.ju_Formatter$FormatWriter_isDigit = function($c) {
        return $c >= 48 && $c <= 57 ? 1 : 0;
    };
    $java.oncias_SemanticCheck$$error$lambda$_2_0 = function() {
        jl_Object.call(this);
        this.$_0364 = null;
    };
    $java.oncias_SemanticCheck$$error$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0364;
        return $java.oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, var$1, var$2);
    };
    function s_Tuple2$mcZZ$sp() {
        var a = this; s_Tuple2.call(a);
        a.$_1$mcZ$sp0 = 0;
        a.$_2$mcZ$sp0 = 0;
    }
    function s_Tuple2$mcZZ$sp__init_(var_0, var_1) {
        var var_2 = new s_Tuple2$mcZZ$sp();
        $java.s_Tuple2$mcZZ$sp__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.s_Tuple2$mcZZ$sp__2 = function($this) {
        return jl_Boolean_valueOf($this.$_2$mcZ$sp0);
    };
    $java.s_Tuple2$mcZZ$sp__1 = function($this) {
        return jl_Boolean_valueOf($this.$_1$mcZ$sp0);
    };
    $java.s_Tuple2$mcZZ$sp__init_ = function($this, $_1$mcZ$sp, $_2$mcZ$sp) {
        $this.$_1$mcZ$sp0 = $_1$mcZ$sp;
        $this.$_2$mcZ$sp0 = $_2$mcZ$sp;
        s_Tuple2__init_0($this, null, null);
    };
    $java.oncia_IfExistsDo = $rt_classWithoutFields(0);
    var oncia_IfExistsInvalidSyntax$ = $rt_classWithoutFields();
    var oncia_IfExistsInvalidSyntax$_MODULE$ = null;
    function oncia_IfExistsInvalidSyntax$__clinit_() {
        oncia_IfExistsInvalidSyntax$_MODULE$ = new oncia_IfExistsInvalidSyntax$;
    }
    $java.oncia_IfExistsInvalidSyntax$_productArity = function($this) {
        return 0;
    };
    $java.oncia_IfExistsInvalidSyntax$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_IfExistsInvalidSyntax$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IfExistsInvalidSyntax$_hashCode = function($this) {
        return (-146745023);
    };
    $java.oncia_IfExistsInvalidSyntax$_toString = function($this) {
        return $rt_s(1729);
    };
    var oncia_IfExistsReplace$ = $rt_classWithoutFields();
    var oncia_IfExistsReplace$_MODULE$ = null;
    function oncia_IfExistsReplace$__clinit_() {
        oncia_IfExistsReplace$_MODULE$ = new oncia_IfExistsReplace$;
    }
    $java.oncia_IfExistsReplace$_productArity = function($this) {
        return 0;
    };
    $java.oncia_IfExistsReplace$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_IfExistsReplace$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IfExistsReplace$_hashCode = function($this) {
        return (-823146373);
    };
    $java.oncia_IfExistsReplace$_toString = function($this) {
        return $rt_s(1730);
    };
    var oncia_IfExistsDoNothing$ = $rt_classWithoutFields();
    var oncia_IfExistsDoNothing$_MODULE$ = null;
    function oncia_IfExistsDoNothing$__clinit_() {
        oncia_IfExistsDoNothing$_MODULE$ = new oncia_IfExistsDoNothing$;
    }
    $java.oncia_IfExistsDoNothing$_productArity = function($this) {
        return 0;
    };
    $java.oncia_IfExistsDoNothing$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_IfExistsDoNothing$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IfExistsDoNothing$_hashCode = function($this) {
        return (-993652535);
    };
    $java.oncia_IfExistsDoNothing$_toString = function($this) {
        return $rt_s(1731);
    };
    var oncia_IfExistsThrowError$ = $rt_classWithoutFields();
    var oncia_IfExistsThrowError$_MODULE$ = null;
    function oncia_IfExistsThrowError$__clinit_() {
        oncia_IfExistsThrowError$_MODULE$ = new oncia_IfExistsThrowError$;
    }
    $java.oncia_IfExistsThrowError$_productArity = function($this) {
        return 0;
    };
    $java.oncia_IfExistsThrowError$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_IfExistsThrowError$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IfExistsThrowError$_hashCode = function($this) {
        return (-1449927781);
    };
    $java.oncia_IfExistsThrowError$_toString = function($this) {
        return $rt_s(1732);
    };
    function onciafn_DecorateTuple$AsScala() {
        var a = this; jl_Object.call(a);
        a.$op = null;
        a.$$outer34 = null;
    }
    function onciafn_DecorateTuple$AsScala_asScala($this) {
        var var$1;
        var$1 = $this.$op.$_0385;
        if (var$1.$right2 !== null) {
            s_package$_$callClinit();
            var$1 = su_Right$_apply(s_package$_Right(s_package$_MODULE$), var$1.$right2);
        } else {
            s_package$_$callClinit();
            var$1 = su_Left$_apply(s_package$_Left(s_package$_MODULE$), var$1.$left3);
        }
        return var$1;
    }
    var onciafn_Neo4jASTFactory$asOptionsAst$lambda$_234_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$asOptionsAst$lambda$_234_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_OptionsMap() {
        jl_Object.call(this);
        this.$map0 = null;
    }
    function oncia_OptionsMap__init_(var_0) {
        var var_1 = new oncia_OptionsMap();
        $java.oncia_OptionsMap__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_OptionsMap_productPrefix = function($this) {
        return $rt_s(1733);
    };
    $java.oncia_OptionsMap_productArity = function($this) {
        return 1;
    };
    $java.oncia_OptionsMap_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$map0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_OptionsMap_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OptionsMap_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OptionsMap_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OptionsMap_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_OptionsMap) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$map0;
                        $x$1 = $x$1.$map0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_OptionsMap))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_OptionsMap__init_ = function($this, $map) {
        $this.$map0 = $map;
    };
    function oncia_OptionsParam() {
        jl_Object.call(this);
        this.$parameter1 = null;
    }
    $java.oncia_OptionsParam_productPrefix = function($this) {
        return $rt_s(1734);
    };
    $java.oncia_OptionsParam_productArity = function($this) {
        return 1;
    };
    $java.oncia_OptionsParam_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$parameter1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_OptionsParam_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OptionsParam_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OptionsParam_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OptionsParam_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_OptionsParam) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$parameter1;
                        $x$1 = $x$1.$parameter1;
                        if (var$2 !== null) {
                            if (!$java.oncie_ExplicitParameter_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_OptionsParam))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    var oncia_NoOptions$ = $rt_classWithoutFields();
    var oncia_NoOptions$_MODULE$ = null;
    function oncia_NoOptions$__clinit_() {
        oncia_NoOptions$_MODULE$ = new oncia_NoOptions$;
    }
    $java.oncia_NoOptions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_NoOptions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NoOptions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NoOptions$_hashCode = function($this) {
        return 1346069885;
    };
    $java.oncia_NoOptions$_toString = function($this) {
        return $rt_s(1735);
    };
    var oncius_CypherType = $rt_classWithoutFields(0);
    $java.oncius_CypherType_description$ = function($$this) {
        var var$2;
        if ($$this.$isNullable())
            $$this = $$this.$toCypherTypeString();
        else {
            $$this = $$this.$toCypherTypeString();
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(var$2, $$this), $rt_s(1736));
            $$this = jl_AbstractStringBuilder_toString(var$2);
        }
        return $$this;
    };
    $java.oncius_CypherType_isSubtypeOf$ = function($$this, $otherCypherType) {
        var var$3, var$4;
        if ($$this instanceof oncius_ClosedDynamicUnionType) {
            $$this = $$this;
            if (!($otherCypherType instanceof oncius_ClosedDynamicUnionType))
                var$3 = 0;
            else {
                $otherCypherType = $otherCypherType;
                var$4 = $$this.$innerTypes;
                $$this = new $java.oncius_CypherType$isSubtypeOf$lambda$_19_0;
                $$this.$_0391 = $otherCypherType;
                var$3 = var$4.$forall($$this);
            }
        } else
            var$3 = $otherCypherType instanceof oncius_ClosedDynamicUnionType ? $otherCypherType.$innerTypes.$contains0($$this) : $otherCypherType instanceof oncius_AnyType ? $$this.$isNullableSubtypeOf($$this, $otherCypherType) : jl_String_equals($$this.$toCypherTypeString(), $otherCypherType.$toCypherTypeString()) && $$this.$isNullableSubtypeOf($$this, $otherCypherType) ? 1 : 0;
        return var$3;
    };
    $java.oncius_CypherType_isNullableSubtypeOf$ = function($$this, $cypherType, $otherCypherType) {
        var var$4;
        a: {
            b: {
                if ($cypherType.$isNullable()) {
                    if (!$cypherType.$isNullable())
                        break b;
                    if (!$otherCypherType.$isNullable())
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncius_CypherType_coercibleTo$ = function($$this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    };
    $java.oncius_CypherType_isAssignableFrom$ = function($$this, $other) {
        var var$3, var$4;
        a: {
            b: {
                c: {
                    if ($other !== null) {
                        if (!$other.$equals($$this))
                            break b;
                        else
                            break c;
                    }
                    if ($$this !== null)
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$4 = $other.$parentType();
            if (var$4 !== null && var$4.$equals($other))
                var$3 = 0;
            else
                var$3 = $$this.$isAssignableFrom0($other.$parentType());
        }
        return var$3;
    };
    $java.oncius_CypherType_leastUpperBound$ = function($$this, $other) {
        if (!$$this.$isAssignableFrom0($other))
            $$this = $other.$isAssignableFrom0($$this) ? $other : ($$this.$parentType()).$leastUpperBound($other.$parentType());
        return $$this;
    };
    $java.oncius_CypherType_greatestLowerBound$ = function($$this, $other) {
        var var$3;
        if ($$this.$isAssignableFrom0($other))
            $$this = s_Some__init_($other);
        else {
            var$3 = s_Some__init_($$this);
            $$this = new $java.oncius_CypherType$greatestLowerBound$lambda$_35_0;
            $$this.$_0392 = $other;
            $$this = s_Option_filter(var$3, $$this);
        }
        return $$this;
    };
    $java.oncius_CypherType_covariant$ = function($$this) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec_constrain($java.oncius_TypeSpec$_all(oncius_TypeSpec$_MODULE$), $$this);
    };
    $java.oncius_CypherType_invariant$ = function($$this) {
        var var$2, var$3, var$4;
        oncius_TypeSpec$_$callClinit();
        var$2 = oncius_TypeSpec$_MODULE$;
        var$3 = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(oncius_CypherType, 1);
        var$4.data[0] = $$this;
        return $java.oncius_TypeSpec$_exact(var$2, sr_ScalaRunTime$_wrapRefArray(var$3, var$4));
    };
    $java.oncius_CypherType_$init$ = function($$this) {
        $$this.$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq(0);
    };
    function oncius_NothingType() {
        var a = this; jl_Object.call(a);
        a.$covariant = null;
        a.$invariant0 = null;
        a.$position92 = null;
        a.$parentType0 = null;
        a.$toString7 = null;
        a.$toCypherTypeString0 = null;
        a.$isAbstract = 0;
        a.$bitmap$02 = 0;
    }
    function oncius_NothingType__init_(var_0) {
        var var_1 = new oncius_NothingType();
        $java.oncius_NothingType__init_(var_1, var_0);
        return var_1;
    }
    $java.oncius_NothingType_simplify = function($this) {
        return $this;
    };
    $java.oncius_NothingType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_NothingType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_NothingType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract = $x$1;
    };
    $java.oncius_NothingType_position = function($this) {
        return $this.$position92;
    };
    $java.oncius_NothingType_parentType = function($this) {
        return $this.$parentType0;
    };
    $java.oncius_NothingType_toString = function($this) {
        return $this.$toString7;
    };
    $java.oncius_NothingType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString0;
    };
    $java.oncius_NothingType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_NOTHING.$i2;
    };
    $java.oncius_NothingType_isNullable = function($this) {
        return 0;
    };
    $java.oncius_NothingType_description = function($this) {
        return $this.$toCypherTypeString0;
    };
    $java.oncius_NothingType_updateIsNullable = function($this, $isNullable) {
        return $this;
    };
    $java.oncius_NothingType_isSubtypeOf = function($this, $otherCypherType) {
        return 1;
    };
    $java.oncius_NothingType_withPosition = function($this, $newPosition) {
        return $java.oncius_NothingType_copy($this, $newPosition);
    };
    $java.oncius_NothingType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$02 & 1) << 24 >> 24)
            return $this.$covariant;
        jl_Object_monitorEnterSync($this);
        a: {
            b: {
                try {
                    if (!(($this.$bitmap$02 & 1) << 24 >> 24))
                        break b;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;
                    break a;

                }
                jl_Object_monitorExitSync($this);
                return $this.$covariant;
            }
            try {
                $rt_throw(jl_UnsupportedOperationException__init_($rt_s(1737)));
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
        }
        jl_Object_monitorExitSync($this);
        $rt_throw(var$1);
    };
    $java.oncius_NothingType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$02 & 2) << 24 >> 24)
            return $this.$invariant0;
        jl_Object_monitorEnterSync($this);
        a: {
            b: {
                try {
                    if (!(($this.$bitmap$02 & 2) << 24 >> 24))
                        break b;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;
                    break a;

                }
                jl_Object_monitorExitSync($this);
                return $this.$invariant0;
            }
            try {
                $rt_throw(jl_UnsupportedOperationException__init_($rt_s(1737)));
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
        }
        jl_Object_monitorExitSync($this);
        $rt_throw(var$1);
    };
    $java.oncius_NothingType_leastUpperBound = function($this, $other) {
        $other = new jl_UnsupportedOperationException;
        jl_Throwable__init_($other, $rt_s(1737));
        $rt_throw($other);
    };
    $java.oncius_NothingType_greatestLowerBound = function($this, $other) {
        $other = new jl_UnsupportedOperationException;
        jl_Throwable__init_($other, $rt_s(1737));
        $rt_throw($other);
    };
    $java.oncius_NothingType_copy = function($this, $position) {
        return oncius_NothingType__init_($position);
    };
    $java.oncius_NothingType_productPrefix = function($this) {
        return $rt_s(1738);
    };
    $java.oncius_NothingType_productArity = function($this) {
        return 0;
    };
    $java.oncius_NothingType_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_NothingType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_NothingType_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_NothingType_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncius_NothingType) ? 0 : 1;
        return var$2 && $this instanceof oncius_NothingType ? 1 : 0;
    };
    $java.oncius_NothingType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_NothingType__init_ = function($this, $position) {
        $this.$position92 = $position;
        $java.oncius_CypherType_$init$($this);
        $this.$parentType0 = $this;
        $this.$toString7 = $rt_s(127);
        $this.$toCypherTypeString0 = $rt_s(1528);
    };
    function oncius_NullType() {
        var a = this; jl_Object.call(a);
        a.$covariant0 = null;
        a.$invariant1 = null;
        a.$position93 = null;
        a.$parentType1 = null;
        a.$toString8 = null;
        a.$toCypherTypeString1 = null;
        a.$isAbstract0 = 0;
        a.$bitmap$03 = 0;
    }
    function oncius_NullType__init_(var_0) {
        var var_1 = new oncius_NullType();
        $java.oncius_NullType__init_(var_1, var_0);
        return var_1;
    }
    $java.oncius_NullType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_NullType_simplify = function($this) {
        return $this;
    };
    $java.oncius_NullType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_NullType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_NullType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract0 = $x$1;
    };
    $java.oncius_NullType_position = function($this) {
        return $this.$position93;
    };
    $java.oncius_NullType_parentType = function($this) {
        return $this.$parentType1;
    };
    $java.oncius_NullType_toString = function($this) {
        return $this.$toString8;
    };
    $java.oncius_NullType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString1;
    };
    $java.oncius_NullType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_NULL.$i2;
    };
    $java.oncius_NullType_isNullable = function($this) {
        return 1;
    };
    $java.oncius_NullType_updateIsNullable = function($this, $isNullable) {
        if ($isNullable)
            return $this;
        return oncius_NothingType__init_($this.$position93);
    };
    $java.oncius_NullType_isSubtypeOf = function($this, $otherCypherType) {
        return $otherCypherType.$isNullable();
    };
    $java.oncius_NullType_withPosition = function($this, $newPosition) {
        return $java.oncius_NullType_copy($this, $newPosition);
    };
    $java.oncius_NullType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$03 & 1) << 24 >> 24)
            return $this.$covariant0;
        jl_Object_monitorEnterSync($this);
        a: {
            b: {
                try {
                    if (!(($this.$bitmap$03 & 1) << 24 >> 24))
                        break b;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;
                    break a;

                }
                jl_Object_monitorExitSync($this);
                return $this.$covariant0;
            }
            try {
                $rt_throw(jl_UnsupportedOperationException__init_($rt_s(1739)));
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
        }
        jl_Object_monitorExitSync($this);
        $rt_throw(var$1);
    };
    $java.oncius_NullType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$03 & 2) << 24 >> 24)
            return $this.$invariant1;
        jl_Object_monitorEnterSync($this);
        a: {
            b: {
                try {
                    if (!(($this.$bitmap$03 & 2) << 24 >> 24))
                        break b;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;
                    break a;

                }
                jl_Object_monitorExitSync($this);
                return $this.$invariant1;
            }
            try {
                $rt_throw(jl_UnsupportedOperationException__init_($rt_s(1739)));
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
        }
        jl_Object_monitorExitSync($this);
        $rt_throw(var$1);
    };
    $java.oncius_NullType_leastUpperBound = function($this, $other) {
        $other = new jl_UnsupportedOperationException;
        jl_Throwable__init_($other, $rt_s(1739));
        $rt_throw($other);
    };
    $java.oncius_NullType_greatestLowerBound = function($this, $other) {
        $other = new jl_UnsupportedOperationException;
        jl_Throwable__init_($other, $rt_s(1739));
        $rt_throw($other);
    };
    $java.oncius_NullType_copy = function($this, $position) {
        return oncius_NullType__init_($position);
    };
    $java.oncius_NullType_productPrefix = function($this) {
        return $rt_s(1740);
    };
    $java.oncius_NullType_productArity = function($this) {
        return 0;
    };
    $java.oncius_NullType_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_NullType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_NullType_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_NullType_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncius_NullType) ? 0 : 1;
        return var$2 && $this instanceof oncius_NullType ? 1 : 0;
    };
    $java.oncius_NullType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_NullType__init_ = function($this, $position) {
        $this.$position93 = $position;
        $java.oncius_CypherType_$init$($this);
        $this.$parentType1 = $this;
        $this.$toString8 = $rt_s(126);
        $this.$toCypherTypeString1 = $rt_s(1529);
    };
    function oncius_BooleanType() {
        var a = this; jl_Object.call(a);
        a.$isNullable0 = 0;
        a.$position94 = null;
        a.$parentType2 = null;
        a.$toString9 = null;
        a.$toCypherTypeString2 = null;
        a.$isAbstract1 = 0;
        a.$covariant1 = null;
        a.$invariant2 = null;
        a.$bitmap$04 = 0;
    }
    function oncius_BooleanType__init_(var_0, var_1) {
        var var_2 = new oncius_BooleanType();
        $java.oncius_BooleanType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_BooleanType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_BooleanType_simplify = function($this) {
        return $this;
    };
    $java.oncius_BooleanType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_BooleanType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_BooleanType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_BooleanType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_BooleanType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_BooleanType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_BooleanType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$04 & 1) << 24 >> 24)
            return $this.$covariant1;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$04 & 1) << 24 >> 24)
                    break a;
                $this.$covariant1 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$04 = ($this.$bitmap$04 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant1;
    };
    $java.oncius_BooleanType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$04 & 2) << 24 >> 24)
            return $this.$invariant2;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$04 & 2) << 24 >> 24)
                    break a;
                $this.$invariant2 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$04 = ($this.$bitmap$04 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant2;
    };
    $java.oncius_BooleanType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract1 = $x$1;
    };
    $java.oncius_BooleanType_isNullable = function($this) {
        return $this.$isNullable0;
    };
    $java.oncius_BooleanType_position = function($this) {
        return $this.$position94;
    };
    $java.oncius_BooleanType_parentType = function($this) {
        return $this.$parentType2;
    };
    $java.oncius_BooleanType_toString = function($this) {
        return $this.$toString9;
    };
    $java.oncius_BooleanType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString2;
    };
    $java.oncius_BooleanType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_BOOLEAN.$i2;
    };
    $java.oncius_BooleanType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_BooleanType_copy($this, $isNullable, $this.$position94);
    };
    $java.oncius_BooleanType_withPosition = function($this, $newPosition) {
        return $java.oncius_BooleanType_copy($this, $this.$isNullable0, $newPosition);
    };
    $java.oncius_BooleanType_copy = function($this, $isNullable, $position) {
        return oncius_BooleanType__init_($isNullable, $position);
    };
    $java.oncius_BooleanType_productArity = function($this) {
        return 1;
    };
    $java.oncius_BooleanType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable0);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_BooleanType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_BooleanType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1741))), !$this.$isNullable0 ? 1237 : 1231), 1);
    };
    $java.oncius_BooleanType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_BooleanType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable0 != $x$1.$isNullable0)
                        break b;
                    if (!($this instanceof oncius_BooleanType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_BooleanType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_BooleanType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable0 = $isNullable;
        $this.$position94 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType2 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString9 = $rt_s(121);
        $this.$toCypherTypeString2 = $rt_s(1530);
    };
    function oncius_StringType() {
        var a = this; jl_Object.call(a);
        a.$isNullable1 = 0;
        a.$position95 = null;
        a.$parentType3 = null;
        a.$toString10 = null;
        a.$toCypherTypeString3 = null;
        a.$isAbstract2 = 0;
        a.$covariant2 = null;
        a.$invariant3 = null;
        a.$bitmap$05 = 0;
    }
    function oncius_StringType__init_(var_0, var_1) {
        var var_2 = new oncius_StringType();
        $java.oncius_StringType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_StringType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_StringType_simplify = function($this) {
        return $this;
    };
    $java.oncius_StringType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_StringType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_StringType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_StringType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_StringType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_StringType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_StringType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$05 & 1) << 24 >> 24)
            return $this.$covariant2;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$05 & 1) << 24 >> 24)
                    break a;
                $this.$covariant2 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$05 = ($this.$bitmap$05 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant2;
    };
    $java.oncius_StringType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$05 & 2) << 24 >> 24)
            return $this.$invariant3;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$05 & 2) << 24 >> 24)
                    break a;
                $this.$invariant3 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$05 = ($this.$bitmap$05 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant3;
    };
    $java.oncius_StringType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract2 = $x$1;
    };
    $java.oncius_StringType_isNullable = function($this) {
        return $this.$isNullable1;
    };
    $java.oncius_StringType_position = function($this) {
        return $this.$position95;
    };
    $java.oncius_StringType_parentType = function($this) {
        return $this.$parentType3;
    };
    $java.oncius_StringType_toString = function($this) {
        return $this.$toString10;
    };
    $java.oncius_StringType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString3;
    };
    $java.oncius_StringType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_STRING.$i2;
    };
    $java.oncius_StringType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_StringType_copy($this, $isNullable, $this.$position95);
    };
    $java.oncius_StringType_withPosition = function($this, $newPosition) {
        return $java.oncius_StringType_copy($this, $this.$isNullable1, $newPosition);
    };
    $java.oncius_StringType_copy = function($this, $isNullable, $position) {
        return oncius_StringType__init_($isNullable, $position);
    };
    $java.oncius_StringType_productArity = function($this) {
        return 1;
    };
    $java.oncius_StringType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable1);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_StringType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_StringType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1742))), !$this.$isNullable1 ? 1237 : 1231), 1);
    };
    $java.oncius_StringType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_StringType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable1 != $x$1.$isNullable1)
                        break b;
                    if (!($this instanceof oncius_StringType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_StringType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_StringType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable1 = $isNullable;
        $this.$position95 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType3 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString10 = $rt_s(1743);
        $this.$toCypherTypeString3 = $rt_s(1523);
    };
    function oncius_IntegerType() {
        var a = this; jl_Object.call(a);
        a.$coercibleTo = null;
        a.$isNullable2 = 0;
        a.$position96 = null;
        a.$parentType4 = null;
        a.$toString11 = null;
        a.$toCypherTypeString4 = null;
        a.$isAbstract3 = 0;
        a.$covariant3 = null;
        a.$invariant4 = null;
        a.$bitmap$06 = 0;
    }
    function oncius_IntegerType__init_(var_0, var_1) {
        var var_2 = new oncius_IntegerType();
        $java.oncius_IntegerType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_IntegerType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_IntegerType_simplify = function($this) {
        return $this;
    };
    $java.oncius_IntegerType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_IntegerType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_IntegerType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_IntegerType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_IntegerType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_IntegerType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$06 & 2) << 24 >> 24)
            return $this.$covariant3;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$06 & 2) << 24 >> 24)
                    break a;
                $this.$covariant3 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$06 = ($this.$bitmap$06 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant3;
    };
    $java.oncius_IntegerType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$06 & 4) << 24 >> 24)
            return $this.$invariant4;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$06 & 4) << 24 >> 24)
                    break a;
                $this.$invariant4 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$06 = ($this.$bitmap$06 | 4) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant4;
    };
    $java.oncius_IntegerType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract3 = $x$1;
    };
    $java.oncius_IntegerType_isNullable = function($this) {
        return $this.$isNullable2;
    };
    $java.oncius_IntegerType_position = function($this) {
        return $this.$position96;
    };
    $java.oncius_IntegerType_parentType = function($this) {
        return $this.$parentType4;
    };
    $java.oncius_IntegerType_coercibleTo = function($this) {
        var var$1, var$2, var$3, var$4, $$je;
        if (($this.$bitmap$06 & 1) << 24 >> 24)
            return $this.$coercibleTo;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$06 & 1) << 24 >> 24)
                    break a;
                s_Predef$_$callClinit();
                var$1 = s_Predef$_Set(s_Predef$_MODULE$);
                var$2 = sr_ScalaRunTime$_MODULE$;
                var$3 = $rt_createArray(oncius_FloatType, 1);
                var$4 = var$3.data;
                oncius_package$_$callClinit();
                var$4[0] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
                $this.$coercibleTo = sc_AbstractIterable_$plus$plus(sci_Set$_apply(var$1, sr_ScalaRunTime$_wrapRefArray(var$2, var$3)), $java.oncius_NumberType_coercibleTo($java.oncius_IntegerType_parentType($this)));
                $this.$bitmap$06 = ($this.$bitmap$06 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$2);
        }
        jl_Object_monitorExitSync($this);
        return $this.$coercibleTo;
    };
    $java.oncius_IntegerType_toString = function($this) {
        return $this.$toString11;
    };
    $java.oncius_IntegerType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString4;
    };
    $java.oncius_IntegerType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_INTEGER.$i2;
    };
    $java.oncius_IntegerType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_IntegerType_copy($this, $isNullable, $this.$position96);
    };
    $java.oncius_IntegerType_withPosition = function($this, $newPosition) {
        return $java.oncius_IntegerType_copy($this, $this.$isNullable2, $newPosition);
    };
    $java.oncius_IntegerType_copy = function($this, $isNullable, $position) {
        return oncius_IntegerType__init_($isNullable, $position);
    };
    $java.oncius_IntegerType_productArity = function($this) {
        return 1;
    };
    $java.oncius_IntegerType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable2);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_IntegerType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_IntegerType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1744))), !$this.$isNullable2 ? 1237 : 1231), 1);
    };
    $java.oncius_IntegerType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_IntegerType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable2 != $x$1.$isNullable2)
                        break b;
                    if (!($this instanceof oncius_IntegerType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_IntegerType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_IntegerType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable2 = $isNullable;
        $this.$position96 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType4 = $java.oncius_package$_CTNumber(oncius_package$_MODULE$);
        $this.$toString11 = $rt_s(1745);
        $this.$toCypherTypeString4 = $rt_s(1533);
    };
    function oncius_FloatType() {
        var a = this; jl_Object.call(a);
        a.$isNullable3 = 0;
        a.$position97 = null;
        a.$parentType5 = null;
        a.$toString12 = null;
        a.$toCypherTypeString5 = null;
        a.$isAbstract4 = 0;
        a.$covariant4 = null;
        a.$invariant5 = null;
        a.$bitmap$07 = 0;
    }
    function oncius_FloatType__init_(var_0, var_1) {
        var var_2 = new oncius_FloatType();
        $java.oncius_FloatType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_FloatType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_FloatType_simplify = function($this) {
        return $this;
    };
    $java.oncius_FloatType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_FloatType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_FloatType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_FloatType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_FloatType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_FloatType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_FloatType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$07 & 1) << 24 >> 24)
            return $this.$covariant4;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$07 & 1) << 24 >> 24)
                    break a;
                $this.$covariant4 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$07 = ($this.$bitmap$07 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant4;
    };
    $java.oncius_FloatType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$07 & 2) << 24 >> 24)
            return $this.$invariant5;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$07 & 2) << 24 >> 24)
                    break a;
                $this.$invariant5 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$07 = ($this.$bitmap$07 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant5;
    };
    $java.oncius_FloatType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract4 = $x$1;
    };
    $java.oncius_FloatType_isNullable = function($this) {
        return $this.$isNullable3;
    };
    $java.oncius_FloatType_position = function($this) {
        return $this.$position97;
    };
    $java.oncius_FloatType_parentType = function($this) {
        return $this.$parentType5;
    };
    $java.oncius_FloatType_toString = function($this) {
        return $this.$toString12;
    };
    $java.oncius_FloatType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString5;
    };
    $java.oncius_FloatType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_FLOAT.$i2;
    };
    $java.oncius_FloatType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_FloatType_copy($this, $isNullable, $this.$position97);
    };
    $java.oncius_FloatType_withPosition = function($this, $newPosition) {
        return $java.oncius_FloatType_copy($this, $this.$isNullable3, $newPosition);
    };
    $java.oncius_FloatType_copy = function($this, $isNullable, $position) {
        return oncius_FloatType__init_($isNullable, $position);
    };
    $java.oncius_FloatType_productArity = function($this) {
        return 1;
    };
    $java.oncius_FloatType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable3);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_FloatType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_FloatType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1746))), !$this.$isNullable3 ? 1237 : 1231), 1);
    };
    $java.oncius_FloatType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_FloatType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable3 != $x$1.$isNullable3)
                        break b;
                    if (!($this instanceof oncius_FloatType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_FloatType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_FloatType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable3 = $isNullable;
        $this.$position97 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType5 = $java.oncius_package$_CTNumber(oncius_package$_MODULE$);
        $this.$toString12 = $rt_s(119);
        $this.$toCypherTypeString5 = $rt_s(1535);
    };
    function oncius_DateType() {
        var a = this; jl_Object.call(a);
        a.$isNullable4 = 0;
        a.$position98 = null;
        a.$parentType6 = null;
        a.$toString13 = null;
        a.$toCypherTypeString6 = null;
        a.$isAbstract5 = 0;
        a.$covariant5 = null;
        a.$invariant6 = null;
        a.$bitmap$08 = 0;
    }
    function oncius_DateType__init_(var_0, var_1) {
        var var_2 = new oncius_DateType();
        $java.oncius_DateType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_DateType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_DateType_simplify = function($this) {
        return $this;
    };
    $java.oncius_DateType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_DateType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_DateType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_DateType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_DateType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_DateType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_DateType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$08 & 1) << 24 >> 24)
            return $this.$covariant5;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$08 & 1) << 24 >> 24)
                    break a;
                $this.$covariant5 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$08 = ($this.$bitmap$08 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant5;
    };
    $java.oncius_DateType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$08 & 2) << 24 >> 24)
            return $this.$invariant6;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$08 & 2) << 24 >> 24)
                    break a;
                $this.$invariant6 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$08 = ($this.$bitmap$08 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant6;
    };
    $java.oncius_DateType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract5 = $x$1;
    };
    $java.oncius_DateType_isNullable = function($this) {
        return $this.$isNullable4;
    };
    $java.oncius_DateType_position = function($this) {
        return $this.$position98;
    };
    $java.oncius_DateType_parentType = function($this) {
        return $this.$parentType6;
    };
    $java.oncius_DateType_toString = function($this) {
        return $this.$toString13;
    };
    $java.oncius_DateType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString6;
    };
    $java.oncius_DateType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_DATE.$i2;
    };
    $java.oncius_DateType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_DateType_copy($this, $isNullable, $this.$position98);
    };
    $java.oncius_DateType_withPosition = function($this, $newPosition) {
        return $java.oncius_DateType_copy($this, $this.$isNullable4, $newPosition);
    };
    $java.oncius_DateType_copy = function($this, $isNullable, $position) {
        return oncius_DateType__init_($isNullable, $position);
    };
    $java.oncius_DateType_productArity = function($this) {
        return 1;
    };
    $java.oncius_DateType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable4);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_DateType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_DateType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1747))), !$this.$isNullable4 ? 1237 : 1231), 1);
    };
    $java.oncius_DateType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_DateType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable4 != $x$1.$isNullable4)
                        break b;
                    if (!($this instanceof oncius_DateType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_DateType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_DateType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable4 = $isNullable;
        $this.$position98 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType6 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString13 = $rt_s(1748);
        $this.$toCypherTypeString6 = $rt_s(1537);
    };
    function oncius_LocalTimeType() {
        var a = this; jl_Object.call(a);
        a.$isNullable5 = 0;
        a.$position99 = null;
        a.$parentType7 = null;
        a.$toString14 = null;
        a.$toCypherTypeString7 = null;
        a.$isAbstract6 = 0;
        a.$covariant6 = null;
        a.$invariant7 = null;
        a.$bitmap$09 = 0;
    }
    function oncius_LocalTimeType__init_(var_0, var_1) {
        var var_2 = new oncius_LocalTimeType();
        $java.oncius_LocalTimeType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_LocalTimeType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_LocalTimeType_simplify = function($this) {
        return $this;
    };
    $java.oncius_LocalTimeType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_LocalTimeType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_LocalTimeType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_LocalTimeType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_LocalTimeType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_LocalTimeType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_LocalTimeType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$09 & 1) << 24 >> 24)
            return $this.$covariant6;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$09 & 1) << 24 >> 24)
                    break a;
                $this.$covariant6 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$09 = ($this.$bitmap$09 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant6;
    };
    $java.oncius_LocalTimeType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$09 & 2) << 24 >> 24)
            return $this.$invariant7;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$09 & 2) << 24 >> 24)
                    break a;
                $this.$invariant7 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$09 = ($this.$bitmap$09 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant7;
    };
    $java.oncius_LocalTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract6 = $x$1;
    };
    $java.oncius_LocalTimeType_isNullable = function($this) {
        return $this.$isNullable5;
    };
    $java.oncius_LocalTimeType_position = function($this) {
        return $this.$position99;
    };
    $java.oncius_LocalTimeType_parentType = function($this) {
        return $this.$parentType7;
    };
    $java.oncius_LocalTimeType_toString = function($this) {
        return $this.$toString14;
    };
    $java.oncius_LocalTimeType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString7;
    };
    $java.oncius_LocalTimeType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_LOCAL_TIME.$i2;
    };
    $java.oncius_LocalTimeType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_LocalTimeType_copy($this, $isNullable, $this.$position99);
    };
    $java.oncius_LocalTimeType_withPosition = function($this, $newPosition) {
        return $java.oncius_LocalTimeType_copy($this, $this.$isNullable5, $newPosition);
    };
    $java.oncius_LocalTimeType_copy = function($this, $isNullable, $position) {
        return oncius_LocalTimeType__init_($isNullable, $position);
    };
    $java.oncius_LocalTimeType_productArity = function($this) {
        return 1;
    };
    $java.oncius_LocalTimeType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable5);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_LocalTimeType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_LocalTimeType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1749))), !$this.$isNullable5 ? 1237 : 1231), 1);
    };
    $java.oncius_LocalTimeType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_LocalTimeType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable5 != $x$1.$isNullable5)
                        break b;
                    if (!($this instanceof oncius_LocalTimeType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_LocalTimeType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_LocalTimeType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable5 = $isNullable;
        $this.$position99 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType7 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString14 = $rt_s(1750);
        $this.$toCypherTypeString7 = $rt_s(1539);
    };
    function oncius_ZonedTimeType() {
        var a = this; jl_Object.call(a);
        a.$isNullable6 = 0;
        a.$position100 = null;
        a.$parentType8 = null;
        a.$toString15 = null;
        a.$toCypherTypeString8 = null;
        a.$isAbstract7 = 0;
        a.$covariant7 = null;
        a.$invariant8 = null;
        a.$bitmap$010 = 0;
    }
    function oncius_ZonedTimeType__init_(var_0, var_1) {
        var var_2 = new oncius_ZonedTimeType();
        $java.oncius_ZonedTimeType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_ZonedTimeType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_ZonedTimeType_simplify = function($this) {
        return $this;
    };
    $java.oncius_ZonedTimeType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_ZonedTimeType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_ZonedTimeType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_ZonedTimeType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_ZonedTimeType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_ZonedTimeType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_ZonedTimeType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$010 & 1) << 24 >> 24)
            return $this.$covariant7;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$010 & 1) << 24 >> 24)
                    break a;
                $this.$covariant7 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$010 = ($this.$bitmap$010 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant7;
    };
    $java.oncius_ZonedTimeType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$010 & 2) << 24 >> 24)
            return $this.$invariant8;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$010 & 2) << 24 >> 24)
                    break a;
                $this.$invariant8 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$010 = ($this.$bitmap$010 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant8;
    };
    $java.oncius_ZonedTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract7 = $x$1;
    };
    $java.oncius_ZonedTimeType_isNullable = function($this) {
        return $this.$isNullable6;
    };
    $java.oncius_ZonedTimeType_position = function($this) {
        return $this.$position100;
    };
    $java.oncius_ZonedTimeType_parentType = function($this) {
        return $this.$parentType8;
    };
    $java.oncius_ZonedTimeType_toString = function($this) {
        return $this.$toString15;
    };
    $java.oncius_ZonedTimeType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString8;
    };
    $java.oncius_ZonedTimeType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_ZONED_TIME.$i2;
    };
    $java.oncius_ZonedTimeType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_ZonedTimeType_copy($this, $isNullable, $this.$position100);
    };
    $java.oncius_ZonedTimeType_withPosition = function($this, $newPosition) {
        return $java.oncius_ZonedTimeType_copy($this, $this.$isNullable6, $newPosition);
    };
    $java.oncius_ZonedTimeType_copy = function($this, $isNullable, $position) {
        return oncius_ZonedTimeType__init_($isNullable, $position);
    };
    $java.oncius_ZonedTimeType_productArity = function($this) {
        return 1;
    };
    $java.oncius_ZonedTimeType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable6);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_ZonedTimeType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_ZonedTimeType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1751))), !$this.$isNullable6 ? 1237 : 1231), 1);
    };
    $java.oncius_ZonedTimeType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_ZonedTimeType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable6 != $x$1.$isNullable6)
                        break b;
                    if (!($this instanceof oncius_ZonedTimeType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_ZonedTimeType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_ZonedTimeType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable6 = $isNullable;
        $this.$position100 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType8 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString15 = $rt_s(1752);
        $this.$toCypherTypeString8 = $rt_s(1541);
    };
    function oncius_LocalDateTimeType() {
        var a = this; jl_Object.call(a);
        a.$isNullable7 = 0;
        a.$position101 = null;
        a.$parentType9 = null;
        a.$toString16 = null;
        a.$toCypherTypeString9 = null;
        a.$isAbstract8 = 0;
        a.$covariant8 = null;
        a.$invariant9 = null;
        a.$bitmap$011 = 0;
    }
    function oncius_LocalDateTimeType__init_(var_0, var_1) {
        var var_2 = new oncius_LocalDateTimeType();
        $java.oncius_LocalDateTimeType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_LocalDateTimeType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_LocalDateTimeType_simplify = function($this) {
        return $this;
    };
    $java.oncius_LocalDateTimeType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_LocalDateTimeType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_LocalDateTimeType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_LocalDateTimeType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_LocalDateTimeType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_LocalDateTimeType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_LocalDateTimeType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$011 & 1) << 24 >> 24)
            return $this.$covariant8;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$011 & 1) << 24 >> 24)
                    break a;
                $this.$covariant8 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$011 = ($this.$bitmap$011 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant8;
    };
    $java.oncius_LocalDateTimeType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$011 & 2) << 24 >> 24)
            return $this.$invariant9;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$011 & 2) << 24 >> 24)
                    break a;
                $this.$invariant9 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$011 = ($this.$bitmap$011 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant9;
    };
    $java.oncius_LocalDateTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract8 = $x$1;
    };
    $java.oncius_LocalDateTimeType_isNullable = function($this) {
        return $this.$isNullable7;
    };
    $java.oncius_LocalDateTimeType_position = function($this) {
        return $this.$position101;
    };
    $java.oncius_LocalDateTimeType_parentType = function($this) {
        return $this.$parentType9;
    };
    $java.oncius_LocalDateTimeType_toString = function($this) {
        return $this.$toString16;
    };
    $java.oncius_LocalDateTimeType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString9;
    };
    $java.oncius_LocalDateTimeType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_LOCAL_DATETIME.$i2;
    };
    $java.oncius_LocalDateTimeType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_LocalDateTimeType_copy($this, $isNullable, $this.$position101);
    };
    $java.oncius_LocalDateTimeType_withPosition = function($this, $newPosition) {
        return $java.oncius_LocalDateTimeType_copy($this, $this.$isNullable7, $newPosition);
    };
    $java.oncius_LocalDateTimeType_copy = function($this, $isNullable, $position) {
        return oncius_LocalDateTimeType__init_($isNullable, $position);
    };
    $java.oncius_LocalDateTimeType_productArity = function($this) {
        return 1;
    };
    $java.oncius_LocalDateTimeType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable7);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_LocalDateTimeType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_LocalDateTimeType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1753))), !$this.$isNullable7 ? 1237 : 1231), 1);
    };
    $java.oncius_LocalDateTimeType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_LocalDateTimeType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable7 != $x$1.$isNullable7)
                        break b;
                    if (!($this instanceof oncius_LocalDateTimeType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_LocalDateTimeType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_LocalDateTimeType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable7 = $isNullable;
        $this.$position101 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType9 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString16 = $rt_s(1754);
        $this.$toCypherTypeString9 = $rt_s(1543);
    };
    function oncius_ZonedDateTimeType() {
        var a = this; jl_Object.call(a);
        a.$isNullable8 = 0;
        a.$position102 = null;
        a.$parentType10 = null;
        a.$toString17 = null;
        a.$toCypherTypeString10 = null;
        a.$isAbstract9 = 0;
        a.$covariant9 = null;
        a.$invariant10 = null;
        a.$bitmap$012 = 0;
    }
    function oncius_ZonedDateTimeType__init_(var_0, var_1) {
        var var_2 = new oncius_ZonedDateTimeType();
        $java.oncius_ZonedDateTimeType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_ZonedDateTimeType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_ZonedDateTimeType_simplify = function($this) {
        return $this;
    };
    $java.oncius_ZonedDateTimeType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_ZonedDateTimeType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_ZonedDateTimeType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_ZonedDateTimeType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_ZonedDateTimeType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_ZonedDateTimeType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_ZonedDateTimeType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$012 & 1) << 24 >> 24)
            return $this.$covariant9;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$012 & 1) << 24 >> 24)
                    break a;
                $this.$covariant9 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$012 = ($this.$bitmap$012 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant9;
    };
    $java.oncius_ZonedDateTimeType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$012 & 2) << 24 >> 24)
            return $this.$invariant10;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$012 & 2) << 24 >> 24)
                    break a;
                $this.$invariant10 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$012 = ($this.$bitmap$012 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant10;
    };
    $java.oncius_ZonedDateTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract9 = $x$1;
    };
    $java.oncius_ZonedDateTimeType_isNullable = function($this) {
        return $this.$isNullable8;
    };
    $java.oncius_ZonedDateTimeType_position = function($this) {
        return $this.$position102;
    };
    $java.oncius_ZonedDateTimeType_parentType = function($this) {
        return $this.$parentType10;
    };
    $java.oncius_ZonedDateTimeType_toString = function($this) {
        return $this.$toString17;
    };
    $java.oncius_ZonedDateTimeType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString10;
    };
    $java.oncius_ZonedDateTimeType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_ZONED_DATETIME.$i2;
    };
    $java.oncius_ZonedDateTimeType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_ZonedDateTimeType_copy($this, $isNullable, $this.$position102);
    };
    $java.oncius_ZonedDateTimeType_withPosition = function($this, $newPosition) {
        return $java.oncius_ZonedDateTimeType_copy($this, $this.$isNullable8, $newPosition);
    };
    $java.oncius_ZonedDateTimeType_copy = function($this, $isNullable, $position) {
        return oncius_ZonedDateTimeType__init_($isNullable, $position);
    };
    $java.oncius_ZonedDateTimeType_productArity = function($this) {
        return 1;
    };
    $java.oncius_ZonedDateTimeType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable8);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_ZonedDateTimeType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_ZonedDateTimeType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1755))), !$this.$isNullable8 ? 1237 : 1231), 1);
    };
    $java.oncius_ZonedDateTimeType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_ZonedDateTimeType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable8 != $x$1.$isNullable8)
                        break b;
                    if (!($this instanceof oncius_ZonedDateTimeType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_ZonedDateTimeType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_ZonedDateTimeType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable8 = $isNullable;
        $this.$position102 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType10 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString17 = $rt_s(1756);
        $this.$toCypherTypeString10 = $rt_s(1545);
    };
    function oncius_DurationType() {
        var a = this; jl_Object.call(a);
        a.$isNullable9 = 0;
        a.$position103 = null;
        a.$parentType11 = null;
        a.$toString18 = null;
        a.$toCypherTypeString11 = null;
        a.$isAbstract10 = 0;
        a.$covariant10 = null;
        a.$invariant11 = null;
        a.$bitmap$013 = 0;
    }
    function oncius_DurationType__init_(var_0, var_1) {
        var var_2 = new oncius_DurationType();
        $java.oncius_DurationType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_DurationType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_DurationType_simplify = function($this) {
        return $this;
    };
    $java.oncius_DurationType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_DurationType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_DurationType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_DurationType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_DurationType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_DurationType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_DurationType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$013 & 1) << 24 >> 24)
            return $this.$covariant10;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$013 & 1) << 24 >> 24)
                    break a;
                $this.$covariant10 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$013 = ($this.$bitmap$013 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant10;
    };
    $java.oncius_DurationType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$013 & 2) << 24 >> 24)
            return $this.$invariant11;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$013 & 2) << 24 >> 24)
                    break a;
                $this.$invariant11 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$013 = ($this.$bitmap$013 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant11;
    };
    $java.oncius_DurationType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract10 = $x$1;
    };
    $java.oncius_DurationType_isNullable = function($this) {
        return $this.$isNullable9;
    };
    $java.oncius_DurationType_position = function($this) {
        return $this.$position103;
    };
    $java.oncius_DurationType_parentType = function($this) {
        return $this.$parentType11;
    };
    $java.oncius_DurationType_toString = function($this) {
        return $this.$toString18;
    };
    $java.oncius_DurationType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString11;
    };
    $java.oncius_DurationType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_DURATION.$i2;
    };
    $java.oncius_DurationType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_DurationType_copy($this, $isNullable, $this.$position103);
    };
    $java.oncius_DurationType_withPosition = function($this, $newPosition) {
        return $java.oncius_DurationType_copy($this, $this.$isNullable9, $newPosition);
    };
    $java.oncius_DurationType_copy = function($this, $isNullable, $position) {
        return oncius_DurationType__init_($isNullable, $position);
    };
    $java.oncius_DurationType_productArity = function($this) {
        return 1;
    };
    $java.oncius_DurationType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable9);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_DurationType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_DurationType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1757))), !$this.$isNullable9 ? 1237 : 1231), 1);
    };
    $java.oncius_DurationType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_DurationType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable9 != $x$1.$isNullable9)
                        break b;
                    if (!($this instanceof oncius_DurationType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_DurationType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_DurationType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable9 = $isNullable;
        $this.$position103 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType11 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString18 = $rt_s(1758);
        $this.$toCypherTypeString11 = $rt_s(1547);
    };
    function oncius_PointType() {
        var a = this; jl_Object.call(a);
        a.$isNullable10 = 0;
        a.$position104 = null;
        a.$parentType12 = null;
        a.$toString19 = null;
        a.$toCypherTypeString12 = null;
        a.$isAbstract11 = 0;
        a.$covariant11 = null;
        a.$invariant12 = null;
        a.$bitmap$014 = 0;
    }
    function oncius_PointType__init_(var_0, var_1) {
        var var_2 = new oncius_PointType();
        $java.oncius_PointType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_PointType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_PointType_simplify = function($this) {
        return $this;
    };
    $java.oncius_PointType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_PointType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_PointType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_PointType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_PointType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_PointType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_PointType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$014 & 1) << 24 >> 24)
            return $this.$covariant11;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$014 & 1) << 24 >> 24)
                    break a;
                $this.$covariant11 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$014 = ($this.$bitmap$014 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant11;
    };
    $java.oncius_PointType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$014 & 2) << 24 >> 24)
            return $this.$invariant12;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$014 & 2) << 24 >> 24)
                    break a;
                $this.$invariant12 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$014 = ($this.$bitmap$014 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant12;
    };
    $java.oncius_PointType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract11 = $x$1;
    };
    $java.oncius_PointType_isNullable = function($this) {
        return $this.$isNullable10;
    };
    $java.oncius_PointType_position = function($this) {
        return $this.$position104;
    };
    $java.oncius_PointType_parentType = function($this) {
        return $this.$parentType12;
    };
    $java.oncius_PointType_toString = function($this) {
        return $this.$toString19;
    };
    $java.oncius_PointType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString12;
    };
    $java.oncius_PointType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return ($java.oncius_CypherTypeOrder$_POINT($java.oncius_CypherTypeOrder$_MODULE$)).$i2;
    };
    $java.oncius_PointType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_PointType_copy($this, $isNullable, $this.$position104);
    };
    $java.oncius_PointType_withPosition = function($this, $newPosition) {
        return $java.oncius_PointType_copy($this, $this.$isNullable10, $newPosition);
    };
    $java.oncius_PointType_copy = function($this, $isNullable, $position) {
        return oncius_PointType__init_($isNullable, $position);
    };
    $java.oncius_PointType_productArity = function($this) {
        return 1;
    };
    $java.oncius_PointType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable10);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_PointType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_PointType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1759))), !$this.$isNullable10 ? 1237 : 1231), 1);
    };
    $java.oncius_PointType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_PointType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable10 != $x$1.$isNullable10)
                        break b;
                    if (!($this instanceof oncius_PointType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_PointType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_PointType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable10 = $isNullable;
        $this.$position104 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType12 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString19 = $rt_s(1760);
        $this.$toCypherTypeString12 = $rt_s(1437);
    };
    function oncius_NodeType() {
        var a = this; jl_Object.call(a);
        a.$isNullable11 = 0;
        a.$position105 = null;
        a.$parentType13 = null;
        a.$toString20 = null;
        a.$toCypherTypeString13 = null;
        a.$isAbstract12 = 0;
        a.$covariant12 = null;
        a.$invariant13 = null;
        a.$bitmap$015 = 0;
    }
    function oncius_NodeType__init_(var_0, var_1) {
        var var_2 = new oncius_NodeType();
        $java.oncius_NodeType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_NodeType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_NodeType_simplify = function($this) {
        return $this;
    };
    $java.oncius_NodeType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_NodeType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_NodeType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_NodeType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_NodeType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_NodeType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_NodeType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$015 & 1) << 24 >> 24)
            return $this.$covariant12;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$015 & 1) << 24 >> 24)
                    break a;
                $this.$covariant12 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$015 = ($this.$bitmap$015 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant12;
    };
    function oncius_NodeType_invariant($this) {
        var var$1, $$je;
        if (($this.$bitmap$015 & 2) << 24 >> 24)
            return $this.$invariant13;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$015 & 2) << 24 >> 24)
                    break a;
                $this.$invariant13 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$015 = ($this.$bitmap$015 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant13;
    }
    $java.oncius_NodeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract12 = $x$1;
    };
    $java.oncius_NodeType_isNullable = function($this) {
        return $this.$isNullable11;
    };
    $java.oncius_NodeType_position = function($this) {
        return $this.$position105;
    };
    $java.oncius_NodeType_parentType = function($this) {
        return $this.$parentType13;
    };
    $java.oncius_NodeType_toString = function($this) {
        return $this.$toString20;
    };
    $java.oncius_NodeType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString13;
    };
    $java.oncius_NodeType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_NODE.$i2;
    };
    $java.oncius_NodeType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_NodeType_copy($this, $isNullable, $this.$position105);
    };
    $java.oncius_NodeType_withPosition = function($this, $newPosition) {
        return $java.oncius_NodeType_copy($this, $this.$isNullable11, $newPosition);
    };
    $java.oncius_NodeType_copy = function($this, $isNullable, $position) {
        return oncius_NodeType__init_($isNullable, $position);
    };
    $java.oncius_NodeType_productArity = function($this) {
        return 1;
    };
    $java.oncius_NodeType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable11);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_NodeType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_NodeType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1761))), !$this.$isNullable11 ? 1237 : 1231), 1);
    };
    $java.oncius_NodeType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_NodeType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable11 != $x$1.$isNullable11)
                        break b;
                    if (!($this instanceof oncius_NodeType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_NodeType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_NodeType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable11 = $isNullable;
        $this.$position105 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType13 = oncius_package$_CTMap(oncius_package$_MODULE$);
        $this.$toString20 = $rt_s(1762);
        $this.$toCypherTypeString13 = $rt_s(923);
    };
    function oncius_RelationshipType() {
        var a = this; jl_Object.call(a);
        a.$isNullable12 = 0;
        a.$position106 = null;
        a.$parentType14 = null;
        a.$toString21 = null;
        a.$toCypherTypeString14 = null;
        a.$isAbstract13 = 0;
        a.$covariant13 = null;
        a.$invariant14 = null;
        a.$bitmap$016 = 0;
    }
    function oncius_RelationshipType__init_(var_0, var_1) {
        var var_2 = new oncius_RelationshipType();
        $java.oncius_RelationshipType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_RelationshipType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_RelationshipType_simplify = function($this) {
        return $this;
    };
    $java.oncius_RelationshipType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_RelationshipType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_RelationshipType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_RelationshipType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_RelationshipType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_RelationshipType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_RelationshipType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$016 & 1) << 24 >> 24)
            return $this.$covariant13;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$016 & 1) << 24 >> 24)
                    break a;
                $this.$covariant13 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$016 = ($this.$bitmap$016 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant13;
    };
    $java.oncius_RelationshipType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$016 & 2) << 24 >> 24)
            return $this.$invariant14;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$016 & 2) << 24 >> 24)
                    break a;
                $this.$invariant14 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$016 = ($this.$bitmap$016 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant14;
    };
    $java.oncius_RelationshipType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract13 = $x$1;
    };
    $java.oncius_RelationshipType_isNullable = function($this) {
        return $this.$isNullable12;
    };
    $java.oncius_RelationshipType_position = function($this) {
        return $this.$position106;
    };
    $java.oncius_RelationshipType_parentType = function($this) {
        return $this.$parentType14;
    };
    $java.oncius_RelationshipType_toString = function($this) {
        return $this.$toString21;
    };
    $java.oncius_RelationshipType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString14;
    };
    $java.oncius_RelationshipType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_RELATIONSHIP.$i2;
    };
    $java.oncius_RelationshipType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_RelationshipType_copy($this, $isNullable, $this.$position106);
    };
    $java.oncius_RelationshipType_withPosition = function($this, $newPosition) {
        return $java.oncius_RelationshipType_copy($this, $this.$isNullable12, $newPosition);
    };
    $java.oncius_RelationshipType_copy = function($this, $isNullable, $position) {
        return oncius_RelationshipType__init_($isNullable, $position);
    };
    $java.oncius_RelationshipType_productArity = function($this) {
        return 1;
    };
    $java.oncius_RelationshipType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable12);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_RelationshipType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_RelationshipType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1763))), !$this.$isNullable12 ? 1237 : 1231), 1);
    };
    $java.oncius_RelationshipType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_RelationshipType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable12 != $x$1.$isNullable12)
                        break b;
                    if (!($this instanceof oncius_RelationshipType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_RelationshipType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_RelationshipType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable12 = $isNullable;
        $this.$position106 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType14 = oncius_package$_CTMap(oncius_package$_MODULE$);
        $this.$toString21 = $rt_s(1764);
        $this.$toCypherTypeString14 = $rt_s(1551);
    };
    function oncius_MapType() {
        var a = this; jl_Object.call(a);
        a.$isNullable13 = 0;
        a.$position107 = null;
        a.$parentType15 = null;
        a.$toString22 = null;
        a.$toCypherTypeString15 = null;
        a.$isAbstract14 = 0;
        a.$covariant14 = null;
        a.$invariant15 = null;
        a.$bitmap$017 = 0;
    }
    function oncius_MapType__init_(var_0, var_1) {
        var var_2 = new oncius_MapType();
        $java.oncius_MapType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_MapType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_MapType_simplify = function($this) {
        return $this;
    };
    $java.oncius_MapType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_MapType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_MapType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_MapType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_MapType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_MapType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_MapType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$017 & 1) << 24 >> 24)
            return $this.$covariant14;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$017 & 1) << 24 >> 24)
                    break a;
                $this.$covariant14 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$017 = ($this.$bitmap$017 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant14;
    };
    $java.oncius_MapType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$017 & 2) << 24 >> 24)
            return $this.$invariant15;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$017 & 2) << 24 >> 24)
                    break a;
                $this.$invariant15 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$017 = ($this.$bitmap$017 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant15;
    };
    $java.oncius_MapType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract14 = $x$1;
    };
    $java.oncius_MapType_isNullable = function($this) {
        return $this.$isNullable13;
    };
    $java.oncius_MapType_position = function($this) {
        return $this.$position107;
    };
    $java.oncius_MapType_parentType = function($this) {
        return $this.$parentType15;
    };
    $java.oncius_MapType_toString = function($this) {
        return $this.$toString22;
    };
    $java.oncius_MapType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString15;
    };
    $java.oncius_MapType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_MAP.$i2;
    };
    $java.oncius_MapType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_MapType_copy($this, $isNullable, $this.$position107);
    };
    $java.oncius_MapType_withPosition = function($this, $newPosition) {
        return $java.oncius_MapType_copy($this, $this.$isNullable13, $newPosition);
    };
    $java.oncius_MapType_copy = function($this, $isNullable, $position) {
        return oncius_MapType__init_($isNullable, $position);
    };
    $java.oncius_MapType_productArity = function($this) {
        return 1;
    };
    $java.oncius_MapType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable13);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_MapType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_MapType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1765))), !$this.$isNullable13 ? 1237 : 1231), 1);
    };
    $java.oncius_MapType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_MapType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable13 != $x$1.$isNullable13)
                        break b;
                    if (!($this instanceof oncius_MapType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_MapType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_MapType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable13 = $isNullable;
        $this.$position107 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType15 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString22 = $rt_s(388);
        $this.$toCypherTypeString15 = $rt_s(1524);
    };
    function onciaf_ParserCypherTypeName$ListParserCypherTypeName() {
        var a = this; onciaf_ParserCypherTypeName.call(a);
        a.$innerType = null;
        a.$isNullable14 = 0;
    }
    $java.onciaf_ParserCypherTypeName$ListParserCypherTypeName__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_ParserCypherTypeName$ListParserCypherTypeName();
        $java.onciaf_ParserCypherTypeName$ListParserCypherTypeName__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.onciaf_ParserCypherTypeName$ListParserCypherTypeName__init_0 = function($this, $innerType, $isNullable) {
        $java.onciaf_ParserCypherTypeName__init_0($this, jl_String_format($rt_s(1766), $rt_createArrayFromData(jl_Object, [$innerType.$typeName0, !$isNullable ? $rt_s(1736) : $rt_s(3)])));
        $this.$innerType = $innerType;
        $this.$isNullable14 = $isNullable;
    };
    function onciaf_ParserCypherTypeName$ListParserCypherTypeName_getInnerType($this) {
        return $this.$innerType;
    }
    function onciaf_ParserCypherTypeName$ListParserCypherTypeName_isNullable($this) {
        return $this.$isNullable14;
    }
    function oncius_ListType() {
        var a = this; jl_Object.call(a);
        a.$coercibleTo1 = null;
        a.$innerType0 = null;
        a.$isNullable15 = 0;
        a.$position108 = null;
        a.$parentType16 = null;
        a.$legacyIteratedType = null;
        a.$toString23 = null;
        a.$toCypherTypeString16 = null;
        a.$isAbstract15 = 0;
        a.$covariant15 = null;
        a.$invariant16 = null;
        a.$bitmap$018 = 0;
    }
    function oncius_ListType__init_(var_0, var_1, var_2) {
        var var_3 = new oncius_ListType();
        $java.oncius_ListType__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncius_ListType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_ListType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$018 & 2) << 24 >> 24)
            return $this.$covariant15;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$018 & 2) << 24 >> 24)
                    break a;
                $this.$covariant15 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$018 = ($this.$bitmap$018 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant15;
    };
    $java.oncius_ListType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$018 & 4) << 24 >> 24)
            return $this.$invariant16;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$018 & 4) << 24 >> 24)
                    break a;
                $this.$invariant16 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$018 = ($this.$bitmap$018 | 4) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant16;
    };
    $java.oncius_ListType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract15 = $x$1;
    };
    $java.oncius_ListType_isNullable = function($this) {
        return $this.$isNullable15;
    };
    $java.oncius_ListType_position = function($this) {
        return $this.$position108;
    };
    $java.oncius_ListType_parentType = function($this) {
        return $this.$parentType16;
    };
    $java.oncius_ListType_coercibleTo = function($this) {
        var var$1, var$2, var$3, var$4, $$je;
        if (($this.$bitmap$018 & 1) << 24 >> 24)
            return $this.$coercibleTo1;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$018 & 1) << 24 >> 24)
                    break a;
                s_Predef$_$callClinit();
                var$1 = s_Predef$_Set(s_Predef$_MODULE$);
                var$2 = sr_ScalaRunTime$_MODULE$;
                var$3 = $rt_createArray(oncius_BooleanType, 1);
                var$4 = var$3.data;
                oncius_package$_$callClinit();
                var$4[0] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
                $this.$coercibleTo1 = sc_AbstractIterable_$plus$plus(sci_Set$_apply(var$1, sr_ScalaRunTime$_wrapRefArray(var$2, var$3)), $java.oncius_AnyType_coercibleTo($java.oncius_ListType_parentType($this)));
                $this.$bitmap$018 = ($this.$bitmap$018 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$2);
        }
        jl_Object_monitorExitSync($this);
        return $this.$coercibleTo1;
    };
    $java.oncius_ListType_toString = function($this) {
        return $this.$toString23;
    };
    $java.oncius_ListType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString16;
    };
    $java.oncius_ListType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_LIST.$i2;
    };
    $java.oncius_ListType_simplify = function($this) {
        var var$1;
        var$1 = $this.$innerType0;
        if (var$1 instanceof oncius_ClosedDynamicUnionType)
            return $java.oncius_ListType_copy($this, $java.oncius_ClosedDynamicUnionType_simplify(var$1), $this.$isNullable15, $this.$position108);
        if (!(var$1 instanceof oncius_ListType))
            return $this;
        return $java.oncius_ListType_copy($this, $java.oncius_ListType_simplify(var$1), $this.$isNullable15, $this.$position108);
    };
    $java.oncius_ListType_isSubtypeOf = function($this, $otherCypherType) {
        var $innerTypes, var$3, var$4;
        if (!($otherCypherType instanceof oncius_ListType)) {
            if ($otherCypherType instanceof oncius_AnyType)
                return $java.oncius_CypherType_isNullableSubtypeOf$($this, $this, $otherCypherType);
            if (!($otherCypherType instanceof oncius_ClosedDynamicUnionType))
                return 0;
            $innerTypes = $otherCypherType.$innerTypes;
            $otherCypherType = new $java.oncius_ListType$isSubtypeOf$lambda$_33_1;
            $otherCypherType.$_0393 = $this;
            return $innerTypes.$exists($otherCypherType);
        }
        $innerTypes = $otherCypherType;
        var$3 = $this.$innerType0;
        if (var$3 instanceof oncius_ClosedDynamicUnionType) {
            $otherCypherType = var$3;
            $innerTypes = $innerTypes.$innerType0;
            if (!($innerTypes instanceof oncius_ClosedDynamicUnionType))
                return 0;
            $innerTypes = $innerTypes;
            var$4 = $otherCypherType.$innerTypes;
            $otherCypherType = new $java.oncius_ListType$isSubtypeOf$lambda$_33_0;
            $otherCypherType.$_0394 = $innerTypes;
            return var$4.$forall($otherCypherType);
        }
        if (var$3 instanceof oncius_ListType) {
            $otherCypherType = var$3;
            if ($innerTypes === null)
                return 0;
            return $java.oncius_ListType_isSubtypeOf($otherCypherType, $innerTypes);
        }
        if (var$3 instanceof oncius_NothingType)
            return 1;
        if (var$3 instanceof oncius_NullType && $innerTypes.$innerType0.$isNullable())
            return 1;
        if (var$3 === null)
            $rt_throw(s_MatchError__init_(var$3));
        return $this.$innerType0.$isSubtypeOf($innerTypes.$innerType0) && $java.oncius_CypherType_isNullableSubtypeOf$($this, $this, $otherCypherType) ? 1 : 0;
    };
    $java.oncius_ListType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_ListType_copy($this, $this.$innerType0, $isNullable, $this.$position108);
    };
    $java.oncius_ListType_withPosition = function($this, $newPosition) {
        return $java.oncius_ListType_copy($this, $this.$innerType0, $this.$isNullable15, $newPosition);
    };
    $java.oncius_ListType_isAssignableFrom = function($this, $other) {
        if (!($other instanceof oncius_ListType))
            return $java.oncius_CypherType_isAssignableFrom$($this, $other);
        $other = $other;
        return $this.$innerType0.$isAssignableFrom0($other.$innerType0);
    };
    $java.oncius_ListType_leastUpperBound = function($this, $other) {
        if (!($other instanceof oncius_ListType))
            return $java.oncius_CypherType_leastUpperBound$($this, $other);
        $other = $other;
        return $java.oncius_ListType_copy($this, $this.$innerType0.$leastUpperBound($other.$innerType0), $this.$isNullable15, $this.$position108);
    };
    $java.oncius_ListType_greatestLowerBound = function($this, $other) {
        var var$2;
        if (!($other instanceof oncius_ListType))
            return $java.oncius_CypherType_greatestLowerBound$($this, $other);
        $other = $other;
        $other = $this.$innerType0.$greatestLowerBound($other.$innerType0);
        var$2 = new $java.oncius_ListType$greatestLowerBound$lambda$_38_0;
        var$2.$_0395 = $this;
        return s_Option_map($other, var$2);
    };
    $java.oncius_ListType_copy = function($this, $innerType, $isNullable, $position) {
        return oncius_ListType__init_($innerType, $isNullable, $position);
    };
    $java.oncius_ListType_productArity = function($this) {
        return 2;
    };
    $java.oncius_ListType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$innerType0;
            case 1:
                return jl_Boolean_valueOf($this.$isNullable15);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_ListType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_ListType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1767))), sr_Statics_anyHash($this.$innerType0)), !$this.$isNullable15 ? 1237 : 1231), 2);
    };
    $java.oncius_ListType_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_ListType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable15 != $x$1.$isNullable15)
                        break b;
                    c: {
                        var$2 = $this.$innerType0;
                        $x$1 = $x$1.$innerType0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncius_ListType))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncius_ListType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_ListType__init_ = function($this, $innerType, $isNullable, $position) {
        $this.$innerType0 = $innerType;
        $this.$isNullable15 = $isNullable;
        $this.$position108 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType16 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$legacyIteratedType = $innerType;
        $position = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($position);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($position, $rt_s(1768)), $innerType), 62);
        $this.$toString23 = jl_AbstractStringBuilder_toString($position);
        $innerType = $innerType.$description();
        $position = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($position);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($position, $rt_s(1769)), $innerType), 62);
        $this.$toCypherTypeString16 = jl_AbstractStringBuilder_toString($position);
    };
    function oncius_PathType() {
        var a = this; jl_Object.call(a);
        a.$isNullable16 = 0;
        a.$position109 = null;
        a.$parentType17 = null;
        a.$toString24 = null;
        a.$toCypherTypeString17 = null;
        a.$isAbstract16 = 0;
        a.$covariant16 = null;
        a.$invariant17 = null;
        a.$bitmap$019 = 0;
    }
    function oncius_PathType__init_(var_0, var_1) {
        var var_2 = new oncius_PathType();
        $java.oncius_PathType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_PathType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_PathType_simplify = function($this) {
        return $this;
    };
    $java.oncius_PathType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_PathType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_PathType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_PathType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_PathType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_PathType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_PathType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$019 & 1) << 24 >> 24)
            return $this.$covariant16;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$019 & 1) << 24 >> 24)
                    break a;
                $this.$covariant16 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$019 = ($this.$bitmap$019 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant16;
    };
    $java.oncius_PathType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$019 & 2) << 24 >> 24)
            return $this.$invariant17;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$019 & 2) << 24 >> 24)
                    break a;
                $this.$invariant17 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$019 = ($this.$bitmap$019 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant17;
    };
    $java.oncius_PathType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract16 = $x$1;
    };
    $java.oncius_PathType_isNullable = function($this) {
        return $this.$isNullable16;
    };
    $java.oncius_PathType_position = function($this) {
        return $this.$position109;
    };
    $java.oncius_PathType_parentType = function($this) {
        return $this.$parentType17;
    };
    $java.oncius_PathType_toString = function($this) {
        return $this.$toString24;
    };
    $java.oncius_PathType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString17;
    };
    $java.oncius_PathType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_PATH.$i2;
    };
    $java.oncius_PathType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_PathType_copy($this, $isNullable, $this.$position109);
    };
    $java.oncius_PathType_withPosition = function($this, $newPosition) {
        return $java.oncius_PathType_copy($this, $this.$isNullable16, $newPosition);
    };
    $java.oncius_PathType_copy = function($this, $isNullable, $position) {
        return oncius_PathType__init_($isNullable, $position);
    };
    $java.oncius_PathType_productArity = function($this) {
        return 1;
    };
    $java.oncius_PathType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable16);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_PathType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_PathType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1770))), !$this.$isNullable16 ? 1237 : 1231), 1);
    };
    $java.oncius_PathType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_PathType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable16 != $x$1.$isNullable16)
                        break b;
                    if (!($this instanceof oncius_PathType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_PathType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_PathType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable16 = $isNullable;
        $this.$position109 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType17 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString24 = $rt_s(1771);
        $this.$toCypherTypeString17 = $rt_s(1554);
    };
    function oncius_PropertyValueType() {
        var a = this; jl_Object.call(a);
        a.$isNullable17 = 0;
        a.$position110 = null;
        a.$parentType18 = null;
        a.$toString25 = null;
        a.$toCypherTypeString18 = null;
        a.$isAbstract17 = 0;
        a.$covariant17 = null;
        a.$invariant18 = null;
        a.$bitmap$020 = 0;
    }
    function oncius_PropertyValueType__init_(var_0, var_1) {
        var var_2 = new oncius_PropertyValueType();
        $java.oncius_PropertyValueType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_PropertyValueType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_PropertyValueType_simplify = function($this) {
        return $this;
    };
    $java.oncius_PropertyValueType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_PropertyValueType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_PropertyValueType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_PropertyValueType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_PropertyValueType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_PropertyValueType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_PropertyValueType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$020 & 1) << 24 >> 24)
            return $this.$covariant17;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$020 & 1) << 24 >> 24)
                    break a;
                $this.$covariant17 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$020 = ($this.$bitmap$020 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant17;
    };
    $java.oncius_PropertyValueType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$020 & 2) << 24 >> 24)
            return $this.$invariant18;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$020 & 2) << 24 >> 24)
                    break a;
                $this.$invariant18 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$020 = ($this.$bitmap$020 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant18;
    };
    $java.oncius_PropertyValueType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract17 = $x$1;
    };
    $java.oncius_PropertyValueType_isNullable = function($this) {
        return $this.$isNullable17;
    };
    $java.oncius_PropertyValueType_position = function($this) {
        return $this.$position110;
    };
    $java.oncius_PropertyValueType_parentType = function($this) {
        return $this.$parentType18;
    };
    $java.oncius_PropertyValueType_toString = function($this) {
        return $this.$toString25;
    };
    $java.oncius_PropertyValueType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString18;
    };
    $java.oncius_PropertyValueType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return ($java.oncius_CypherTypeOrder$_CLOSED_DYNAMIC_UNION($java.oncius_CypherTypeOrder$_MODULE$)).$i2;
    };
    $java.oncius_PropertyValueType_expandToTypes = function($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        s_package$_$callClinit();
        var$1 = s_package$_List0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(oncius_CypherType, 21);
        var$4 = var$3.data;
        var$4[0] = oncius_BooleanType__init_($this.$isNullable17, $this.$position110);
        var$4[1] = oncius_StringType__init_($this.$isNullable17, $this.$position110);
        var$4[2] = oncius_IntegerType__init_($this.$isNullable17, $this.$position110);
        var$4[3] = oncius_FloatType__init_($this.$isNullable17, $this.$position110);
        var$4[4] = oncius_DateType__init_($this.$isNullable17, $this.$position110);
        var$4[5] = oncius_LocalTimeType__init_($this.$isNullable17, $this.$position110);
        var$4[6] = oncius_ZonedTimeType__init_($this.$isNullable17, $this.$position110);
        var$4[7] = oncius_LocalDateTimeType__init_($this.$isNullable17, $this.$position110);
        var$4[8] = oncius_ZonedDateTimeType__init_($this.$isNullable17, $this.$position110);
        var$4[9] = oncius_DurationType__init_($this.$isNullable17, $this.$position110);
        var$4[10] = oncius_PointType__init_($this.$isNullable17, $this.$position110);
        var$4[11] = oncius_ListType__init_(oncius_BooleanType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[12] = oncius_ListType__init_(oncius_StringType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[13] = oncius_ListType__init_(oncius_DateType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[14] = oncius_ListType__init_(oncius_LocalTimeType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[15] = oncius_ListType__init_(oncius_ZonedTimeType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[16] = oncius_ListType__init_(oncius_LocalDateTimeType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[17] = oncius_ListType__init_(oncius_ZonedDateTimeType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[18] = oncius_ListType__init_(oncius_DurationType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$4[19] = oncius_ListType__init_(oncius_PointType__init_(0, $this.$position110), $this.$isNullable17, $this.$position110);
        var$5 = new oncius_ListType;
        var$6 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$6, (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_IntegerType__init_(0, $this.$position110), oncius_FloatType__init_(0, $this.$position110)]))), $this.$position110);
        $java.oncius_ListType__init_(var$5, var$6, $this.$isNullable17, $this.$position110);
        var$4[20] = var$5;
        return var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncius_PropertyValueType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_PropertyValueType_copy($this, $isNullable, $this.$position110);
    };
    $java.oncius_PropertyValueType_withPosition = function($this, $newPosition) {
        return $java.oncius_PropertyValueType_copy($this, $this.$isNullable17, $newPosition);
    };
    $java.oncius_PropertyValueType_copy = function($this, $isNullable, $position) {
        return oncius_PropertyValueType__init_($isNullable, $position);
    };
    $java.oncius_PropertyValueType_productArity = function($this) {
        return 1;
    };
    $java.oncius_PropertyValueType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable17);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_PropertyValueType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_PropertyValueType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1772))), !$this.$isNullable17 ? 1237 : 1231), 1);
    };
    $java.oncius_PropertyValueType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_PropertyValueType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable17 != $x$1.$isNullable17)
                        break b;
                    if (!($this instanceof oncius_PropertyValueType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_PropertyValueType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_PropertyValueType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable17 = $isNullable;
        $this.$position110 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType18 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString25 = $rt_s(1773);
        $this.$toCypherTypeString18 = $rt_s(1557);
    };
    function oncius_AnyType() {
        var a = this; jl_Object.call(a);
        a.$isNullable18 = 0;
        a.$position111 = null;
        a.$parentType19 = null;
        a.$isAbstract18 = 0;
        a.$toString26 = null;
        a.$toCypherTypeString19 = null;
        a.$covariant18 = null;
        a.$invariant19 = null;
        a.$bitmap$021 = 0;
    }
    function oncius_AnyType__init_(var_0, var_1) {
        var var_2 = new oncius_AnyType();
        $java.oncius_AnyType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_AnyType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_AnyType_simplify = function($this) {
        return $this;
    };
    $java.oncius_AnyType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_AnyType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_AnyType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_AnyType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$021 & 1) << 24 >> 24)
            return $this.$covariant18;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$021 & 1) << 24 >> 24)
                    break a;
                $this.$covariant18 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$021 = ($this.$bitmap$021 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant18;
    };
    $java.oncius_AnyType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$021 & 2) << 24 >> 24)
            return $this.$invariant19;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$021 & 2) << 24 >> 24)
                    break a;
                $this.$invariant19 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$021 = ($this.$bitmap$021 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant19;
    };
    $java.oncius_AnyType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {};
    $java.oncius_AnyType_isNullable = function($this) {
        return $this.$isNullable18;
    };
    $java.oncius_AnyType_position = function($this) {
        return $this.$position111;
    };
    $java.oncius_AnyType_parentType = function($this) {
        return $this.$parentType19;
    };
    $java.oncius_AnyType_isAssignableFrom = function($this, $other) {
        return 1;
    };
    $java.oncius_AnyType_toString = function($this) {
        return $this.$toString26;
    };
    $java.oncius_AnyType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString19;
    };
    $java.oncius_AnyType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_ANY.$i2;
    };
    $java.oncius_AnyType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_AnyType_copy($this, $isNullable, $this.$position111);
    };
    $java.oncius_AnyType_isSubtypeOf = function($this, $otherCypherType) {
        if (!($otherCypherType instanceof oncius_AnyType))
            return 0;
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $this, $otherCypherType);
    };
    $java.oncius_AnyType_withPosition = function($this, $newPosition) {
        return $java.oncius_AnyType_copy($this, $this.$isNullable18, $newPosition);
    };
    $java.oncius_AnyType_copy = function($this, $isNullable, $position) {
        return oncius_AnyType__init_($isNullable, $position);
    };
    $java.oncius_AnyType_productArity = function($this) {
        return 1;
    };
    $java.oncius_AnyType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable18);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_AnyType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_AnyType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1774))), !$this.$isNullable18 ? 1237 : 1231), 1);
    };
    $java.oncius_AnyType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncius_AnyType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable18 != $x$1.$isNullable18)
                        break b;
                    if (!($this instanceof oncius_AnyType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_AnyType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_AnyType__init_ = function($this, $isNullable, $position) {
        $this.$isNullable18 = $isNullable;
        $this.$position111 = $position;
        $java.oncius_CypherType_$init$($this);
        $this.$parentType19 = $this;
        $this.$isAbstract18 = 1;
        $this.$toString26 = $rt_s(123);
        $this.$toCypherTypeString19 = $rt_s(1522);
    };
    function onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0() {
        jl_Object.call(this);
        this.$_0396 = null;
    }
    function onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0__init_(var_0) {
        var var_1 = new onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0();
        $java.onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0__init_(var_1, var_0);
        return var_1;
    }
    $java.onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0__init_ = function(var$0, var$1) {
        var$0.$_0396 = var$1;
    };
    $java.onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_Neo4jASTFactory_convertCypherType(var$0.$_0396, var$1);
    };
    function oncius_ClosedDynamicUnionType() {
        var a = this; jl_Object.call(a);
        a.$covariant19 = null;
        a.$invariant20 = null;
        a.$innerTypes = null;
        a.$position112 = null;
        a.$parentType20 = null;
        a.$sortedInnerTypes = null;
        a.$toString27 = null;
        a.$toCypherTypeString20 = null;
        a.$isAbstract19 = 0;
        a.$bitmap$022 = 0;
    }
    function oncius_ClosedDynamicUnionType__init_(var_0, var_1) {
        var var_2 = new oncius_ClosedDynamicUnionType();
        $java.oncius_ClosedDynamicUnionType__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncius_ClosedDynamicUnionType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_ClosedDynamicUnionType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_ClosedDynamicUnionType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_ClosedDynamicUnionType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract19 = $x$1;
    };
    $java.oncius_ClosedDynamicUnionType_innerTypes = function($this) {
        return $this.$innerTypes;
    };
    $java.oncius_ClosedDynamicUnionType_position = function($this) {
        return $this.$position112;
    };
    $java.oncius_ClosedDynamicUnionType_parentType = function($this) {
        return $this.$parentType20;
    };
    $java.oncius_ClosedDynamicUnionType_toString = function($this) {
        return $this.$toString27;
    };
    $java.oncius_ClosedDynamicUnionType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString20;
    };
    $java.oncius_ClosedDynamicUnionType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return ($java.oncius_CypherTypeOrder$_CLOSED_DYNAMIC_UNION($java.oncius_CypherTypeOrder$_MODULE$)).$i2;
    };
    $java.oncius_ClosedDynamicUnionType_isNullable = function($this) {
        return ($this.$sortedInnerTypes.$head()).$isNullable();
    };
    $java.oncius_ClosedDynamicUnionType_description = function($this) {
        return $this.$toCypherTypeString20;
    };
    $java.oncius_ClosedDynamicUnionType_simplify = function($this) {
        var $flattenedInner;
        $flattenedInner = sc_AbstractIterable_toSet(sci_List_flatMap($this.$sortedInnerTypes, new $java.oncius_ClosedDynamicUnionType$simplify$lambda$_29_0));
        if ($flattenedInner.$size() == 1)
            return $flattenedInner.$head();
        return $java.oncius_ClosedDynamicUnionType_copy($this, $flattenedInner, $this.$position112);
    };
    $java.oncius_ClosedDynamicUnionType_updateIsNullable = function($this, $isNullable) {
        var var$2, var$3;
        var$2 = $this.$innerTypes;
        var$3 = new $java.oncius_ClosedDynamicUnionType$updateIsNullable$lambda$_30_0;
        var$3.$_0397 = $isNullable;
        return $java.oncius_ClosedDynamicUnionType_copy($this, var$2.$map1(var$3), $this.$position112);
    };
    $java.oncius_ClosedDynamicUnionType_withPosition = function($this, $newPosition) {
        return $java.oncius_ClosedDynamicUnionType_copy($this, $this.$innerTypes, $newPosition);
    };
    $java.oncius_ClosedDynamicUnionType_equals = function($this, $other) {
        if (!($other instanceof oncius_ClosedDynamicUnionType))
            return 0;
        $other = $other;
        return sci_List_equals($this.$sortedInnerTypes, $other.$sortedInnerTypes);
    };
    $java.oncius_ClosedDynamicUnionType_isAssignableFrom = function($this, $other) {
        var var$2, var$3;
        var$2 = $this.$innerTypes;
        var$3 = new $java.oncius_ClosedDynamicUnionType$isAssignableFrom$lambda$_33_0;
        var$3.$_0398 = $other;
        return var$2.$exists(var$3);
    };
    $java.oncius_ClosedDynamicUnionType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$022 & 1) << 24 >> 24)
            return $this.$covariant19;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$022 & 1) << 24 >> 24)
                    break a;
                $this.$covariant19 = $java.oncius_TypeSpec_covariant((($java.oncius_ClosedDynamicUnionType_innerTypes($this)).$tail()).$foldLeft((($java.oncius_ClosedDynamicUnionType_innerTypes($this)).$head()).$invariant(), $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0__init_()));
                $this.$bitmap$022 = ($this.$bitmap$022 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant19;
    };
    $java.oncius_ClosedDynamicUnionType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$022 & 2) << 24 >> 24)
            return $this.$invariant20;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$022 & 2) << 24 >> 24)
                    break a;
                oncius_TypeSpec$_$callClinit();
                $this.$invariant20 = $java.oncius_TypeSpec$_exact(oncius_TypeSpec$_MODULE$, $java.oncius_ClosedDynamicUnionType_innerTypes($this));
                $this.$bitmap$022 = ($this.$bitmap$022 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant20;
    };
    $java.oncius_ClosedDynamicUnionType_leastUpperBound = function($this, $other) {
        return sc_IterableOnceOps_foldLeft$($this.$innerTypes, $other, new $java.oncius_ClosedDynamicUnionType$leastUpperBound$lambda$_39_0);
    };
    $java.oncius_ClosedDynamicUnionType_greatestLowerBound = function($this, $other) {
        var $lowerBound, $lowerBounds, var$4;
        if (!($other instanceof oncius_ClosedDynamicUnionType)) {
            $lowerBound = $java.sr_ObjectRef_create(($this.$innerTypes.$head()).$greatestLowerBound($other));
            $lowerBounds = $this.$innerTypes.$tail();
            var$4 = new $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_4;
            var$4.$_0399 = $lowerBound;
            var$4.$_1115 = $other;
            $lowerBounds.$foreach(var$4);
            return $lowerBound.$elem5;
        }
        $other = $other;
        s_Predef$_$callClinit();
        $lowerBounds = (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sci_Nil$_MODULE$);
        var$4 = $this.$innerTypes;
        $lowerBound = new $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_0;
        $lowerBound.$_0400 = $other;
        $lowerBound.$_1116 = $lowerBounds;
        var$4.$foreach($lowerBound);
        if (!$lowerBounds.$exists(new $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_1))
            return s_None$_MODULE$;
        return s_Some__init_(oncius_ClosedDynamicUnionType__init_(($lowerBounds.$filter1(new $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_2)).$map1(new $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_3), $this.$position112));
    };
    $java.oncius_ClosedDynamicUnionType_copy = function($this, $innerTypes, $position) {
        return oncius_ClosedDynamicUnionType__init_($innerTypes, $position);
    };
    $java.oncius_ClosedDynamicUnionType_productPrefix = function($this) {
        return $rt_s(1775);
    };
    $java.oncius_ClosedDynamicUnionType_productArity = function($this) {
        return 1;
    };
    $java.oncius_ClosedDynamicUnionType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$innerTypes;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_ClosedDynamicUnionType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_ClosedDynamicUnionType_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_ClosedDynamicUnionType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_ClosedDynamicUnionType__init_ = function($this, $innerTypes, $position) {
        $this.$innerTypes = $innerTypes;
        $this.$position112 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType20 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $innerTypes = (($innerTypes.$map1(new $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_0)).$toList()).$scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted($java.oncius_CypherType$_order);
        $this.$sortedInnerTypes = $innerTypes;
        $this.$toString27 = sc_AbstractIterable_mkString0(sci_List_map($innerTypes, new $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_1), $rt_s(155));
        $this.$toCypherTypeString20 = sc_AbstractIterable_mkString0(sci_List_map($this.$sortedInnerTypes, new $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_2), $rt_s(155));
    };
    var oncius_CypherType$ = $rt_classWithoutFields();
    $java.oncius_CypherType$_MODULE$ = null;
    $java.oncius_CypherType$_order = null;
    function oncius_CypherType$__clinit_() {
        $java.oncius_CypherType$_MODULE$ = new oncius_CypherType$;
        $java.oncius_CypherType$_order = new $java.oncius_CypherType$$anonfun$1;
    }
    $java.oncius_CypherType$_normalizeTypes = function($this, $typeToNormalize) {
        var $simplifiedType, $innerTypes, var$4, var$5, var$6, var$7;
        $simplifiedType = $typeToNormalize.$simplify();
        if (!($simplifiedType instanceof oncius_ClosedDynamicUnionType)) {
            if ($simplifiedType instanceof oncius_ListType) {
                $typeToNormalize = $simplifiedType;
                return $java.oncius_ListType_copy($typeToNormalize, $java.oncius_CypherType$_normalizeTypes($this, $typeToNormalize.$innerType0), $typeToNormalize.$isNullable15, $typeToNormalize.$position108);
            }
            if ($simplifiedType instanceof oncius_PropertyValueType) {
                $typeToNormalize = $simplifiedType;
                return oncius_ClosedDynamicUnionType__init_(sc_AbstractIterable_toSet($java.oncius_PropertyValueType_expandToTypes($typeToNormalize)), $typeToNormalize.$position110);
            }
            if (!($simplifiedType instanceof $java.oncius_NumberType)) {
                if (!($simplifiedType instanceof $java.oncius_GeometryType))
                    return $simplifiedType;
                $typeToNormalize = $simplifiedType;
                return oncius_PointType__init_($typeToNormalize.$isNullable19, $typeToNormalize.$position113);
            }
            $typeToNormalize = $simplifiedType;
            $simplifiedType = new oncius_ClosedDynamicUnionType;
            s_Predef$_$callClinit();
            $java.oncius_ClosedDynamicUnionType__init_($simplifiedType, (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_IntegerType__init_($typeToNormalize.$isNullable20, $typeToNormalize.$position114), oncius_FloatType__init_($typeToNormalize.$isNullable20, $typeToNormalize.$position114)]))), $typeToNormalize.$position114);
            return $simplifiedType;
        }
        $simplifiedType = sc_IterableOnceOps_toList$($simplifiedType.$innerTypes);
        while (true) {
            $innerTypes = (sci_List_map(sci_List_map(sci_List_flatMap($simplifiedType, new $java.oncius_CypherType$$normalize$lambda$_3_0), new $java.oncius_CypherType$$normalize$lambda$_3_1), new $java.oncius_CypherType$$normalize$lambda$_3_2)).$scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted($java.oncius_CypherType$_order);
            s_package$_$callClinit();
            s_package$_List0(s_package$_MODULE$);
            $innerTypes = sc_LinearSeqOps_foldLeft$($innerTypes, sci_Nil$_MODULE$, new $java.oncius_CypherType$$normalize$lambda$_3_3);
            if (!sci_List_forall($innerTypes, new $java.oncius_CypherType$$normalize$lambda$_3_4) && !sci_List_forall($innerTypes, new $java.oncius_CypherType$$normalize$lambda$_3_5))
                $innerTypes = sci_List_map($innerTypes, new $java.oncius_CypherType$$normalize$lambda$_3_6);
            var$4 = $java.oncius_CypherType$_allTypes($this, ($innerTypes.$head()).$isNullable());
            var$5 = sci_List_map($innerTypes, new $java.oncius_CypherType$$normalize$lambda$_3_7);
            var$6 = new $java.oncius_CypherType$$normalize$lambda$_3_8;
            var$6.$_0401 = var$5;
            if (!var$4.$forall(var$6))
                var$4 = $innerTypes;
            else {
                var$4 = new sci_$colon$colon;
                var$5 = new oncius_AnyType;
                var$7 = ($innerTypes.$head()).$isNullable();
                $innerTypes = sci_List_map($innerTypes, new $java.oncius_CypherType$$normalize$lambda$_3_9);
                onciu_InputPosition$_$callClinit();
                $java.oncius_AnyType__init_(var$5, var$7, sc_AbstractIterable_min($innerTypes, onciu_InputPosition$_byOffset0(onciu_InputPosition$_MODULE$)));
                sci_$colon$colon__init_0(var$4, var$5, sci_Nil$_MODULE$);
            }
            $innerTypes = var$4.$scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted($java.oncius_CypherType$_order);
            if (sci_List_equals($simplifiedType, $innerTypes))
                break;
            $simplifiedType = $innerTypes;
        }
        return $java.oncius_ClosedDynamicUnionType_simplify(oncius_ClosedDynamicUnionType__init_(sc_AbstractIterable_toSet($innerTypes), $typeToNormalize.$position2()));
    };
    $java.oncius_CypherType$_allTypes = function($this, $isNullable) {
        var var$2, var$3, var$4, var$5, var$6;
        s_Predef$_$callClinit();
        var$2 = s_Predef$_Set(s_Predef$_MODULE$);
        var$3 = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(oncius_CypherType, 16);
        var$5 = var$4.data;
        var$6 = new oncius_BooleanType;
        onciu_InputPosition$_$callClinit();
        $java.oncius_BooleanType__init_(var$6, $isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[0] = var$6;
        var$5[1] = oncius_StringType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[2] = oncius_IntegerType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[3] = oncius_FloatType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[4] = oncius_DateType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[5] = oncius_LocalTimeType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[6] = oncius_ZonedTimeType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[7] = oncius_LocalDateTimeType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[8] = oncius_ZonedDateTimeType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[9] = oncius_DurationType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[10] = oncius_PointType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[11] = oncius_NodeType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[12] = oncius_RelationshipType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[13] = oncius_MapType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[14] = oncius_ListType__init_(oncius_AnyType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), $isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$5[15] = oncius_PathType__init_($isNullable, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        return var$2.$from0(sr_ScalaRunTime$_wrapRefArray(var$3, var$4));
    };
    $java.oncius_CypherType$_compareListTypes = function($this, $x, $y) {
        var var$3, $hx, $hy, $innerComparisonInnerTypeNullCheck;
        a: {
            var$3 = s_Tuple2__init_($x.$innerType0, $y.$innerType0);
            $hx = var$3.$_10;
            $hy = var$3.$_20;
            if ($hx instanceof oncius_ListType) {
                var$3 = $hx;
                if ($hy instanceof oncius_ListType) {
                    $innerComparisonInnerTypeNullCheck = $java.oncius_CypherType$_compareListTypes($this, var$3, $hy);
                    break a;
                }
            }
            if ($hx instanceof oncius_ClosedDynamicUnionType) {
                $hx = $hx;
                if ($hy instanceof oncius_ClosedDynamicUnionType) {
                    $hy = $hy;
                    $innerComparisonInnerTypeNullCheck = $java.oncius_CypherType$_compareInnerLists($this, $hx.$sortedInnerTypes, $hy.$sortedInnerTypes);
                    break a;
                }
            }
            $hy = new $java.sr_RichInt;
            s_Predef$_$callClinit();
            $java.sr_RichInt__init_($hy, $x.$innerType0.$sortOrder());
            $innerComparisonInnerTypeNullCheck = $java.sr_OrderedProxy_compare$($hy, jl_Integer_valueOf($y.$innerType0.$sortOrder()));
        }
        if (!$innerComparisonInnerTypeNullCheck) {
            $hx = new $java.sr_RichBoolean;
            s_Predef$_$callClinit();
            $java.sr_RichBoolean__init_($hx, $x.$innerType0.$isNullable());
            $innerComparisonInnerTypeNullCheck = $java.sr_OrderedProxy_compare$($hx, jl_Boolean_valueOf($y.$innerType0.$isNullable()));
        }
        if ($innerComparisonInnerTypeNullCheck)
            return $innerComparisonInnerTypeNullCheck;
        $hy = new $java.sr_RichBoolean;
        s_Predef$_$callClinit();
        $java.sr_RichBoolean__init_($hy, $x.$isNullable15);
        return $java.sr_OrderedProxy_compare$($hy, jl_Boolean_valueOf($y.$isNullable15));
    };
    $java.oncius_CypherType$_compareInnerLists = function($this, $x, $y) {
        var $hx, $hy, $innerComparison, $cux, $cuy, var$8, $lxDynamicUnion, $lyDynamicUnion, $lxListType, $lyListType, $lxInnerType, $lyInnerType;
        while (!(sci_List_isEmpty($x) && sci_List_isEmpty($y))) {
            if ($x.$length() != $y.$length()) {
                $hx = new $java.sr_RichInt;
                s_Predef$_$callClinit();
                $java.sr_RichInt__init_($hx, $x.$length());
                return $java.sr_OrderedProxy_compare$($hx, jl_Integer_valueOf($y.$length()));
            }
            if (!($x.$head()).$equals($y.$head())) {
                $hx = $x.$head();
                $hy = $y.$head();
                $y = new $java.sr_RichInt;
                s_Predef$_$callClinit();
                $java.sr_RichInt__init_($y, $hx.$sortOrder());
                $innerComparison = $java.sr_OrderedProxy_compare$($y, jl_Integer_valueOf($hy.$sortOrder()));
                if ($innerComparison)
                    return $innerComparison;
                a: {
                    $y = s_Tuple2__init_($hx, $hy);
                    $cux = $y.$_10;
                    $cuy = $y.$_20;
                    var$8 = $cux instanceof oncius_ListType;
                    if (var$8) {
                        $lxDynamicUnion = $cux.$innerType0;
                        if ($lxDynamicUnion instanceof oncius_ClosedDynamicUnionType) {
                            $y = $lxDynamicUnion;
                            if ($cuy instanceof oncius_ListType) {
                                $lyDynamicUnion = $cuy.$innerType0;
                                if ($lyDynamicUnion instanceof oncius_ClosedDynamicUnionType) {
                                    $x = $lyDynamicUnion;
                                    $innerComparison = $java.oncius_CypherType$_compareInnerLists($this, $y.$sortedInnerTypes, $x.$sortedInnerTypes);
                                    break a;
                                }
                            }
                        }
                    }
                    if (var$8) {
                        $lxListType = $cux.$innerType0;
                        if ($lxListType instanceof oncius_ListType) {
                            $x = $lxListType;
                            if ($cuy instanceof oncius_ListType) {
                                $lyListType = $cuy.$innerType0;
                                if ($lyListType instanceof oncius_ListType) {
                                    $innerComparison = $java.oncius_CypherType$_compareListTypes($this, $x, $lyListType);
                                    break a;
                                }
                            }
                        }
                    }
                    if (var$8) {
                        $lxInnerType = $cux.$innerType0;
                        if ($lxInnerType !== null && $cuy instanceof oncius_ListType) {
                            $lyInnerType = $cuy.$innerType0;
                            if ($lyInnerType !== null) {
                                $innerComparison = $java.sr_OrderedProxy_compare$($java.sr_RichInt__init_0($lxInnerType.$sortOrder()), jl_Integer_valueOf($lyInnerType.$sortOrder()));
                                if ($innerComparison)
                                    break a;
                                $innerComparison = $java.sr_OrderedProxy_compare$($java.sr_RichBoolean__init_0($lxInnerType.$isNullable()), jl_Boolean_valueOf($lyInnerType.$isNullable()));
                                break a;
                            }
                        }
                    }
                    if ($cux instanceof oncius_ClosedDynamicUnionType) {
                        $x = $cux;
                        if ($cuy instanceof oncius_ClosedDynamicUnionType) {
                            $y = $cuy;
                            $innerComparison = $java.oncius_CypherType$_compareInnerLists($this, $x.$sortedInnerTypes, $y.$sortedInnerTypes);
                        }
                    }
                }
                if ($innerComparison)
                    return $innerComparison;
                return $java.sr_OrderedProxy_compare$($java.sr_RichBoolean__init_0($hx.$isNullable()), jl_Boolean_valueOf($hy.$isNullable()));
            }
            $x = $x.$tail();
            $y = $y.$tail();
        }
        return 0;
    };
    $java.oncie_TypeSignature = $rt_classWithoutFields(0);
    $java.oncie_ExpressionTypeSignature = function() {
        var a = this; jl_Object.call(a);
        a.$argumentTypes = null;
        a.$outputType = null;
    };
    $java.oncie_ExpressionTypeSignature__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncie_ExpressionTypeSignature();
        $java.oncie_ExpressionTypeSignature__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncie_ExpressionTypeSignature_argumentTypes = function($this) {
        return $this.$argumentTypes;
    };
    $java.oncie_ExpressionTypeSignature_outputType = function($this) {
        return $this.$outputType;
    };
    $java.oncie_ExpressionTypeSignature_removeFirstArgumentType = function($this) {
        return $java.oncie_ExpressionTypeSignature__init_($this.$argumentTypes.$tail(), $this.$outputType);
    };
    $java.oncie_ExpressionTypeSignature_productPrefix = function($this) {
        return $rt_s(1776);
    };
    $java.oncie_ExpressionTypeSignature_productArity = function($this) {
        return 2;
    };
    $java.oncie_ExpressionTypeSignature_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$argumentTypes;
            case 1:
                return $this.$outputType;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ExpressionTypeSignature_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ExpressionTypeSignature_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ExpressionTypeSignature_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ExpressionTypeSignature_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncie_ExpressionTypeSignature) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$argumentTypes;
                        var$3 = $x$1.$argumentTypes;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$outputType;
                        $x$1 = $x$1.$outputType;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncie_ExpressionTypeSignature))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ExpressionTypeSignature__init_0 = function($this, $argumentTypes, $outputType) {
        $this.$argumentTypes = $argumentTypes;
        $this.$outputType = $outputType;
    };
    var oncie_TypeSignature$ = $rt_classWithoutFields();
    $java.oncie_TypeSignature$_MODULE$ = null;
    function oncie_TypeSignature$__clinit_() {
        $java.oncie_TypeSignature$_MODULE$ = new oncie_TypeSignature$;
    }
    $java.oncie_TypeSignature$_apply0 = function($this, $function, $argumentType, $outputType, $description, $category) {
        var var$6, var$7, var$8, var$9, var$10;
        var$6 = new $java.oncie_FunctionTypeSignature;
        s_package$_$callClinit();
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(jl_String, 1);
        var$9.data[0] = $rt_s(1777);
        var$8 = var$7.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9));
        var$10 = s_package$_Vector0(s_package$_MODULE$);
        var$7 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_CypherType, 1);
        var$9.data[0] = $argumentType;
        $java.oncie_FunctionTypeSignature__init_(var$6, $function, $outputType, var$8, $description, $category, var$10.$from0(sr_ScalaRunTime$_wrapRefArray(var$7, var$9)), $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        return var$6;
    };
    $java.oncie_TypeSignature$_noArg = function($this, $function, $outputType, $description, $category) {
        var var$5, var$6, var$7, var$8;
        var$5 = new $java.oncie_FunctionTypeSignature;
        s_package$_$callClinit();
        var$6 = s_package$_Vector0(s_package$_MODULE$);
        var$7 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(jl_String, 1);
        var$8.data[0] = $rt_s(1777);
        $java.oncie_FunctionTypeSignature__init_(var$5, $function, $outputType, var$6.$from0(sr_ScalaRunTime$_wrapRefArray(var$7, var$8)), $description, $category, (s_package$_Vector0(s_package$_MODULE$)).$from0(sci_Nil$_MODULE$), $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        return var$5;
    };
    $java.oncie_TypeSignature$_apply = function($this, $argumentTypes, $outputType) {
        return $java.oncie_ExpressionTypeSignature__init_($argumentTypes, $outputType);
    };
    var oncius_package$ = $rt_classWithoutFields();
    var oncius_package$_MODULE$ = null;
    $java.oncius_package$_CTAny = null;
    $java.oncius_package$_CTBoolean = null;
    $java.oncius_package$_CTString = null;
    $java.oncius_package$_CTNumber0 = null;
    $java.oncius_package$_CTFloat0 = null;
    $java.oncius_package$_CTInteger = null;
    $java.oncius_package$_CTMap = null;
    $java.oncius_package$_CTNode = null;
    $java.oncius_package$_CTRelationship = null;
    $java.oncius_package$_CTPoint = null;
    $java.oncius_package$_CTDateTime = null;
    $java.oncius_package$_CTLocalDateTime = null;
    $java.oncius_package$_CTDate = null;
    $java.oncius_package$_CTTime = null;
    $java.oncius_package$_CTLocalTime = null;
    $java.oncius_package$_CTDuration = null;
    $java.oncius_package$_CTGeometry = null;
    $java.oncius_package$_CTPath = null;
    $java.oncius_package$_CTGraphRef = null;
    function oncius_package$_$callClinit() {
        oncius_package$_$callClinit = $rt_eraseClinit(oncius_package$);
        $java.oncius_package$__clinit_();
    }
    $java.oncius_package$__clinit_ = function() {
        var var$1, var$2;
        var$1 = new oncius_package$;
        oncius_package$_$callClinit();
        oncius_package$_MODULE$ = var$1;
        var$2 = new oncius_AnyType;
        onciu_InputPosition$_$callClinit();
        $java.oncius_AnyType__init_(var$2, 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTAny = var$2;
        $java.oncius_package$_CTBoolean = oncius_BooleanType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTString = oncius_StringType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTNumber0 = $java.oncius_NumberType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTFloat0 = oncius_FloatType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTInteger = oncius_IntegerType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTMap = oncius_MapType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTNode = oncius_NodeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTRelationship = oncius_RelationshipType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTPoint = oncius_PointType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTDateTime = oncius_ZonedDateTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTLocalDateTime = oncius_LocalDateTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTDate = oncius_DateType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTTime = oncius_ZonedTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTLocalTime = oncius_LocalTimeType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTDuration = oncius_DurationType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTGeometry = $java.oncius_GeometryType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTPath = oncius_PathType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncius_package$_CTGraphRef = $java.oncius_GraphRefType__init_(1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
    };
    function oncius_package$_CTAny($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTAny;
    }
    function oncius_package$_CTBoolean($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTBoolean;
    }
    function oncius_package$_CTString($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTString;
    }
    $java.oncius_package$_CTNumber = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTNumber0;
    };
    $java.oncius_package$_CTFloat = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTFloat0;
    };
    function oncius_package$_CTInteger($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTInteger;
    }
    function oncius_package$_CTMap($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTMap;
    }
    function oncius_package$_CTNode($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTNode;
    }
    function oncius_package$_CTRelationship($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTRelationship;
    }
    $java.oncius_package$_CTPoint0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTPoint;
    };
    $java.oncius_package$_CTDateTime0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTDateTime;
    };
    $java.oncius_package$_CTLocalDateTime0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTLocalDateTime;
    };
    $java.oncius_package$_CTDate0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTDate;
    };
    $java.oncius_package$_CTTime0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTTime;
    };
    $java.oncius_package$_CTLocalTime0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTLocalTime;
    };
    $java.oncius_package$_CTDuration0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTDuration;
    };
    $java.oncius_package$_CTPath0 = function($this) {
        oncius_package$_$callClinit();
        return $java.oncius_package$_CTPath;
    };
    function oncius_package$_CTList($this, $inner) {
        var var$2;
        var$2 = new oncius_ListType;
        onciu_InputPosition$_$callClinit();
        $java.oncius_ListType__init_(var$2, $inner, 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        return var$2;
    }
    $java.ju_FormatterClosedException = $rt_classWithoutFields(jl_IllegalStateException);
    function oncias_SemanticCheck$chain$lambda$_17_0() {
        jl_Object.call(this);
        this.$_0256 = null;
    }
    $java.oncias_SemanticCheck$chain$lambda$_17_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0256;
        var$3 = new $java.oncias_SemanticCheck$$anonfun$chain$1$lambda$_31_0;
        var$3.$_0402 = var$1;
        return var$2.$map12(var$3);
    };
    function sc_IndexedSeqView$IndexedSeqViewReverseIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$self2 = null;
        a.$scala$collection$IndexedSeqView$IndexedSeqViewReverseIterator$$remainder = 0;
        a.$pos3 = 0;
    }
    $java.sc_IndexedSeqView$IndexedSeqViewReverseIterator__init_ = function(var_0) {
        var var_1 = new sc_IndexedSeqView$IndexedSeqViewReverseIterator();
        sc_IndexedSeqView$IndexedSeqViewReverseIterator__init_(var_1, var_0);
        return var_1;
    };
    $java.sc_IndexedSeqView$IndexedSeqViewReverseIterator_hasNext = function($this) {
        if ($this.$scala$collection$IndexedSeqView$IndexedSeqViewReverseIterator$$remainder <= 0)
            return 0;
        return 1;
    };
    function sc_IndexedSeqView$IndexedSeqViewReverseIterator_next($this) {
        var $r;
        if (!($this.$scala$collection$IndexedSeqView$IndexedSeqViewReverseIterator$$remainder <= 0 ? 0 : 1))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $r = $this.$self2.$apply1($this.$pos3);
        $this.$pos3 = $this.$pos3 - 1 | 0;
        $this.$scala$collection$IndexedSeqView$IndexedSeqViewReverseIterator$$remainder = $this.$scala$collection$IndexedSeqView$IndexedSeqViewReverseIterator$$remainder - 1 | 0;
        return $r;
    }
    function sc_IndexedSeqView$IndexedSeqViewReverseIterator__init_($this, $self) {
        var var$2;
        $this.$self2 = $self;
        var$2 = $self.$length();
        $this.$scala$collection$IndexedSeqView$IndexedSeqViewReverseIterator$$remainder = var$2;
        $this.$pos3 = var$2 - 1 | 0;
    }
    $java.oncia_Union$semanticCheck$lambda$_9_0 = $rt_classWithoutFields();
    $java.oncia_Union$semanticCheck$lambda$_9_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncia_Union$$anonfun$semanticCheck$2$lambda$_31_0;
        var$3.$_0403 = var$1;
        return oncias_SemanticCheck$_nestedCheck(var$2, var$3);
    };
    $java.oncia_Union$semanticCheck$lambda$_9_1 = $rt_classWithoutFields();
    $java.oncia_Union$semanticCheck$lambda$_9_1_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_semanticCheck(var$1);
    };
    function scc_AsScalaExtensions$MapHasAsScala() {
        var a = this; jl_Object.call(a);
        a.$m = null;
        a.$$outer28 = null;
    }
    function scc_AsScalaExtensions$MapHasAsScala_asScala($this) {
        var var$1, var$2;
        var$1 = $this.$m;
        if (var$1 === null)
            var$2 = null;
        else if (var$1 instanceof $java.scc_JavaCollectionWrappers$MutableMapWrapper)
            var$2 = var$1.$underlying28();
        else {
            var$2 = new $java.scc_JavaCollectionWrappers$JMapWrapper;
            var$2.$underlying29 = var$1;
        }
        return var$2;
    }
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_0 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_0_apply = function(var$0, var$1) {
        return var$1.$simplify();
    };
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_1 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_1_apply = function(var$0, var$1) {
        return var$1.$toString();
    };
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_2 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_2_apply = function(var$0, var$1) {
        return var$1.$description();
    };
    function sc_Iterator$SliceIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$underlying7 = null;
        a.$scala$collection$Iterator$SliceIterator$$remaining = 0;
        a.$dropping = 0;
    }
    $java.sc_Iterator$SliceIterator_skip = function($this) {
        while ($this.$dropping > 0) {
            if (!$this.$underlying7.$hasNext()) {
                $this.$dropping = 0;
                continue;
            }
            $this.$underlying7.$next();
            $this.$dropping = $this.$dropping - 1 | 0;
        }
    };
    $java.sc_Iterator$SliceIterator_knownSize = function($this) {
        var $size, $dropSize;
        $size = $this.$underlying7.$knownSize();
        if ($size < 0)
            return (-1);
        $dropSize = jl_Math_max(0, $size - $this.$dropping | 0);
        $size = $this.$scala$collection$Iterator$SliceIterator$$remaining;
        if ($size >= 0 ? 0 : 1)
            return $dropSize;
        return jl_Math_min($size, $dropSize);
    };
    $java.sc_Iterator$SliceIterator_hasNext = function($this) {
        $java.sc_Iterator$SliceIterator_skip($this);
        if ($this.$scala$collection$Iterator$SliceIterator$$remaining && $this.$underlying7.$hasNext())
            return 1;
        return 0;
    };
    $java.sc_Iterator$SliceIterator_next = function($this) {
        var var$1, var$2;
        $java.sc_Iterator$SliceIterator_skip($this);
        var$1 = $this.$scala$collection$Iterator$SliceIterator$$remaining;
        var$2 = $rt_compare(var$1, 0);
        if (var$2 > 0) {
            $this.$scala$collection$Iterator$SliceIterator$$remaining = var$1 - 1 | 0;
            return $this.$underlying7.$next();
        }
        if (!(var$2 >= 0 ? 0 : 1))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        return $this.$underlying7.$next();
    };
    function sc_IterableOps$sliding$lambda$_64_0() {
        jl_Object.call(this);
        this.$_04 = null;
    }
    $java.sc_IterableOps$sliding$lambda$_64_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_04.$fromSpecific(var$1);
    };
    function oncias_SemanticAnalysisTooling$whenState$lambda$_31_0() {
        var a = this; jl_Object.call(a);
        a.$_0281 = null;
        a.$_183 = null;
        a.$_232 = null;
    }
    $java.oncias_SemanticAnalysisTooling$whenState$lambda$_31_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0281;
        var$3 = var$0.$_183;
        var$4 = var$0.$_232;
        return !sr_BoxesRunTime_unboxToBoolean(var$2.$apply(var$1)) ? var$4.$apply2() : var$3.$apply2();
    };
    $java.oncia_Union$semanticCheckAbstract$lambda$_7_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0337 = null;
        a.$_1103 = null;
    };
    $java.oncia_Union$semanticCheckAbstract$lambda$_7_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0337;
        return var$0.$_1103.$apply(var$1.$lhs());
    };
    $java.oncia_Union$semanticCheckAbstract$lambda$_7_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0338 = null;
        a.$_1104 = null;
    };
    $java.oncia_Union$semanticCheckAbstract$lambda$_7_1_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0338;
        return var$0.$_1104.$apply(var$1.$rhs());
    };
    $java.oncius_CypherType$$anonfun$1 = $rt_classWithoutFields();
    $java.oncius_CypherType$$anonfun$1_compare = function($this, $x, $y) {
        var var$3, var$4, var$5, var$6;
        a: {
            $x = $x;
            $y = $y;
            var$3 = s_Tuple2__init_($x, $y);
            var$4 = var$3.$_10;
            var$3 = var$3.$_20;
            if (var$4 instanceof oncius_ListType) {
                var$5 = var$4;
                if (var$3 instanceof oncius_ListType) {
                    $x = var$3;
                    var$6 = $java.oncius_CypherType$_compareListTypes($java.oncius_CypherType$_MODULE$, var$5, $x);
                    break a;
                }
            }
            if (var$4 instanceof oncius_ClosedDynamicUnionType) {
                var$5 = var$4;
                if (var$3 instanceof oncius_ClosedDynamicUnionType) {
                    $x = var$3;
                    var$6 = $java.oncius_CypherType$_compareInnerLists($java.oncius_CypherType$_MODULE$, var$5.$sortedInnerTypes, $x.$sortedInnerTypes);
                    break a;
                }
            }
            if (var$4.$sortOrder() != var$3.$sortOrder()) {
                var$3 = new $java.sr_RichInt;
                s_Predef$_$callClinit();
                $java.sr_RichInt__init_(var$3, $x.$sortOrder());
                var$6 = $java.sr_OrderedProxy_compare$(var$3, jl_Integer_valueOf($y.$sortOrder()));
            } else {
                var$3 = new $java.sr_RichBoolean;
                s_Predef$_$callClinit();
                $java.sr_RichBoolean__init_(var$3, $x.$isNullable());
                var$6 = $java.sr_OrderedProxy_compare$(var$3, jl_Boolean_valueOf($y.$isNullable()));
            }
        }
        return var$6;
    };
    $java.oncius_NumberType = function() {
        var a = this; jl_Object.call(a);
        a.$isNullable20 = 0;
        a.$position114 = null;
        a.$parentType21 = null;
        a.$toString28 = null;
        a.$toCypherTypeString21 = null;
        a.$isAbstract20 = 0;
        a.$covariant21 = null;
        a.$invariant21 = null;
        a.$bitmap$023 = 0;
    };
    $java.oncius_NumberType__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncius_NumberType();
        $java.oncius_NumberType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncius_NumberType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_NumberType_simplify = function($this) {
        return $this;
    };
    $java.oncius_NumberType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_NumberType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_NumberType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_NumberType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_NumberType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_NumberType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_NumberType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$023 & 1) << 24 >> 24)
            return $this.$covariant21;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$023 & 1) << 24 >> 24)
                    break a;
                $this.$covariant21 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$023 = ($this.$bitmap$023 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant21;
    };
    $java.oncius_NumberType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$023 & 2) << 24 >> 24)
            return $this.$invariant21;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$023 & 2) << 24 >> 24)
                    break a;
                $this.$invariant21 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$023 = ($this.$bitmap$023 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant21;
    };
    $java.oncius_NumberType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract20 = $x$1;
    };
    $java.oncius_NumberType_isNullable = function($this) {
        return $this.$isNullable20;
    };
    $java.oncius_NumberType_position = function($this) {
        return $this.$position114;
    };
    $java.oncius_NumberType_toString = function($this) {
        return $this.$toString28;
    };
    $java.oncius_NumberType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString21;
    };
    $java.oncius_NumberType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return ($java.oncius_CypherTypeOrder$_CLOSED_DYNAMIC_UNION($java.oncius_CypherTypeOrder$_MODULE$)).$i2;
    };
    $java.oncius_NumberType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_NumberType_copy($this, $isNullable, $this.$position114);
    };
    $java.oncius_NumberType_withPosition = function($this, $newPosition) {
        return $java.oncius_NumberType_copy($this, $this.$isNullable20, $newPosition);
    };
    $java.oncius_NumberType_copy = function($this, $isNullable, $position) {
        return $java.oncius_NumberType__init_($isNullable, $position);
    };
    $java.oncius_NumberType_productArity = function($this) {
        return 1;
    };
    $java.oncius_NumberType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable20);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_NumberType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_NumberType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1778))), !$this.$isNullable20 ? 1237 : 1231), 1);
    };
    $java.oncius_NumberType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncius_NumberType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable20 != $x$1.$isNullable20)
                        break b;
                    if (!($this instanceof $java.oncius_NumberType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_NumberType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_NumberType_parentType = function($this) {
        return $this.$parentType21;
    };
    $java.oncius_NumberType__init_0 = function($this, $isNullable, $position) {
        $this.$isNullable20 = $isNullable;
        $this.$position114 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType21 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString28 = $rt_s(1779);
        $this.$toCypherTypeString21 = $rt_s(1780);
    };
    $java.oncius_GeometryType = function() {
        var a = this; jl_Object.call(a);
        a.$isNullable19 = 0;
        a.$position113 = null;
        a.$parentType22 = null;
        a.$toString29 = null;
        a.$toCypherTypeString22 = null;
        a.$isAbstract21 = 0;
        a.$covariant22 = null;
        a.$invariant22 = null;
        a.$bitmap$024 = 0;
    };
    $java.oncius_GeometryType__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncius_GeometryType();
        $java.oncius_GeometryType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncius_GeometryType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_GeometryType_simplify = function($this) {
        return $this;
    };
    $java.oncius_GeometryType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_GeometryType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_GeometryType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_GeometryType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_GeometryType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_GeometryType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_GeometryType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$024 & 1) << 24 >> 24)
            return $this.$covariant22;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$024 & 1) << 24 >> 24)
                    break a;
                $this.$covariant22 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$024 = ($this.$bitmap$024 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant22;
    };
    $java.oncius_GeometryType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$024 & 2) << 24 >> 24)
            return $this.$invariant22;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$024 & 2) << 24 >> 24)
                    break a;
                $this.$invariant22 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$024 = ($this.$bitmap$024 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant22;
    };
    $java.oncius_GeometryType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract21 = $x$1;
    };
    $java.oncius_GeometryType_isNullable = function($this) {
        return $this.$isNullable19;
    };
    $java.oncius_GeometryType_position = function($this) {
        return $this.$position113;
    };
    $java.oncius_GeometryType_parentType = function($this) {
        return $this.$parentType22;
    };
    $java.oncius_GeometryType_toString = function($this) {
        return $this.$toString29;
    };
    $java.oncius_GeometryType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString22;
    };
    $java.oncius_GeometryType_sortOrder = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return ($java.oncius_CypherTypeOrder$_POINT($java.oncius_CypherTypeOrder$_MODULE$)).$i2;
    };
    $java.oncius_GeometryType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_GeometryType_copy($this, $isNullable, $this.$position113);
    };
    $java.oncius_GeometryType_withPosition = function($this, $newPosition) {
        return $java.oncius_GeometryType_copy($this, $this.$isNullable19, $newPosition);
    };
    $java.oncius_GeometryType_copy = function($this, $isNullable, $position) {
        return $java.oncius_GeometryType__init_($isNullable, $position);
    };
    $java.oncius_GeometryType_productArity = function($this) {
        return 1;
    };
    $java.oncius_GeometryType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable19);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_GeometryType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_GeometryType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1781))), !$this.$isNullable19 ? 1237 : 1231), 1);
    };
    $java.oncius_GeometryType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncius_GeometryType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable19 != $x$1.$isNullable19)
                        break b;
                    if (!($this instanceof $java.oncius_GeometryType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_GeometryType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_GeometryType__init_0 = function($this, $isNullable, $position) {
        $this.$isNullable19 = $isNullable;
        $this.$position113 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType22 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString29 = $rt_s(1782);
        $this.$toCypherTypeString22 = $rt_s(1783);
    };
    $java.oncius_GraphRefType = function() {
        var a = this; jl_Object.call(a);
        a.$isNullable21 = 0;
        a.$position115 = null;
        a.$parentType23 = null;
        a.$toString30 = null;
        a.$toCypherTypeString23 = null;
        a.$isAbstract22 = 0;
        a.$covariant23 = null;
        a.$invariant23 = null;
        a.$bitmap$025 = 0;
    };
    $java.oncius_GraphRefType__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncius_GraphRefType();
        $java.oncius_GraphRefType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncius_GraphRefType_description = function($this) {
        return $java.oncius_CypherType_description$($this);
    };
    $java.oncius_GraphRefType_simplify = function($this) {
        return $this;
    };
    $java.oncius_GraphRefType_isSubtypeOf = function($this, $otherCypherType) {
        return $java.oncius_CypherType_isSubtypeOf$($this, $otherCypherType);
    };
    $java.oncius_GraphRefType_isNullableSubtypeOf = function($this, $cypherType, $otherCypherType) {
        return $java.oncius_CypherType_isNullableSubtypeOf$($this, $cypherType, $otherCypherType);
    };
    $java.oncius_GraphRefType_coercibleTo = function($this) {
        return $java.oncius_CypherType_coercibleTo$($this);
    };
    $java.oncius_GraphRefType_isAssignableFrom = function($this, $other) {
        return $java.oncius_CypherType_isAssignableFrom$($this, $other);
    };
    $java.oncius_GraphRefType_leastUpperBound = function($this, $other) {
        return $java.oncius_CypherType_leastUpperBound$($this, $other);
    };
    $java.oncius_GraphRefType_greatestLowerBound = function($this, $other) {
        return $java.oncius_CypherType_greatestLowerBound$($this, $other);
    };
    $java.oncius_GraphRefType_covariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$025 & 1) << 24 >> 24)
            return $this.$covariant23;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$025 & 1) << 24 >> 24)
                    break a;
                $this.$covariant23 = $java.oncius_CypherType_covariant$($this);
                $this.$bitmap$025 = ($this.$bitmap$025 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$covariant23;
    };
    $java.oncius_GraphRefType_invariant = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$025 & 2) << 24 >> 24)
            return $this.$invariant23;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$025 & 2) << 24 >> 24)
                    break a;
                $this.$invariant23 = $java.oncius_CypherType_invariant$($this);
                $this.$bitmap$025 = ($this.$bitmap$025 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$invariant23;
    };
    $java.oncius_GraphRefType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq = function($this, $x$1) {
        $this.$isAbstract22 = $x$1;
    };
    $java.oncius_GraphRefType_isNullable = function($this) {
        return $this.$isNullable21;
    };
    $java.oncius_GraphRefType_position = function($this) {
        return $this.$position115;
    };
    $java.oncius_GraphRefType_parentType = function($this) {
        return $this.$parentType23;
    };
    $java.oncius_GraphRefType_toString = function($this) {
        return $this.$toString30;
    };
    $java.oncius_GraphRefType_toCypherTypeString = function($this) {
        return $this.$toCypherTypeString23;
    };
    $java.oncius_GraphRefType_sortOrder = function($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(1784));
        $rt_throw(var$1);
    };
    $java.oncius_GraphRefType_updateIsNullable = function($this, $isNullable) {
        return $java.oncius_GraphRefType_copy($this, $isNullable, $this.$position115);
    };
    $java.oncius_GraphRefType_withPosition = function($this, $newPosition) {
        return $java.oncius_GraphRefType_copy($this, $this.$isNullable21, $newPosition);
    };
    $java.oncius_GraphRefType_copy = function($this, $isNullable, $position) {
        return $java.oncius_GraphRefType__init_($isNullable, $position);
    };
    $java.oncius_GraphRefType_productArity = function($this) {
        return 1;
    };
    $java.oncius_GraphRefType_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$isNullable21);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_GraphRefType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_GraphRefType_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1785))), !$this.$isNullable21 ? 1237 : 1231), 1);
    };
    $java.oncius_GraphRefType_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncius_GraphRefType) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNullable21 != $x$1.$isNullable21)
                        break b;
                    if (!($this instanceof $java.oncius_GraphRefType))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncius_GraphRefType_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncius_GraphRefType__init_0 = function($this, $isNullable, $position) {
        $this.$isNullable21 = $isNullable;
        $this.$position115 = $position;
        $java.oncius_CypherType_$init$($this);
        oncius_package$_$callClinit();
        $this.$parentType23 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $this.$toString30 = $rt_s(1786);
        $this.$toCypherTypeString23 = $rt_s(1787);
    };
    var oncia_ProjectingUnionAll = $rt_classWithoutFields();
    var oncia_ProjectingUnionDistinct = $rt_classWithoutFields();
    $java.oncia_Union$defineUnionVariables$lambda$_20_0 = function() {
        jl_Object.call(this);
        this.$_0339 = null;
    };
    $java.oncia_Union$defineUnionVariables$lambda$_20_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = var$1;
        var$2 = var$0.$_0339;
        var$3 = new $java.sr_LazyRef;
        var$4 = $java.sr_ObjectRef_create(oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1));
        var$5 = (var$2.$lhs()).$finalScope((oncias_SemanticState_scope(var$1, var$2.$lhs())).$get0());
        var$1 = $java.oncia_SingleQuery_finalScope(var$2.$rhs(), (oncias_SemanticState_scope(var$1, var$2.$rhs())).$get0());
        s_Predef$_$callClinit();
        var$6 = sci_Set$_newBuilder(s_Predef$_Set(s_Predef$_MODULE$));
        var$7 = var$2.$unionMappings();
        var$8 = new $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_0;
        var$8.$_0404 = var$2;
        var$8.$_1117 = var$6;
        var$8.$_242 = var$3;
        sci_List_foreach(var$7, var$8);
        if (((var$2.$lhs()).$returnVariables()).$includeExisting1) {
            var$7 = oncias_Scope_symbolNames(var$5);
            var$8 = new $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_1;
            var$8.$_0405 = var$2;
            var$8.$_1118 = var$6;
            var$8.$_243 = var$3;
            var$7.$foreach(var$8);
        }
        if (($java.oncia_SingleQuery_returnVariables(var$2.$rhs())).$includeExisting1) {
            var$7 = oncias_Scope_symbolNames(var$1);
            var$8 = new $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_3;
            var$8.$_0406 = var$2;
            var$8.$_1119 = var$6;
            var$8.$_244 = var$3;
            var$7.$foreach(var$8);
        }
        var$2 = sci_SetBuilderImpl_result(var$6);
        var$3 = new $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_2;
        var$3.$_0407 = var$5;
        var$3.$_1120 = var$1;
        var$3.$_245 = var$4;
        var$2.$flatMap(var$3);
        return var$4.$elem5;
    };
    $java.oncia_Union$checkInputDataStream$lambda$_24_0 = function() {
        jl_Object.call(this);
        this.$_0340 = null;
    };
    $java.oncia_Union$checkInputDataStream$lambda$_24_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0340;
        var$3 = var$2.$lhs();
        var$3 = !(var$3 instanceof oncia_SingleQuery) ? oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1) : $java.oncia_Union_checkSingleQuery$1(var$3, var$1);
        var$2 = $java.oncia_Union_checkSingleQuery$1(var$2.$rhs(), var$1);
        return oncias_SemanticCheckResult__init_(var$1, var$3.$errors.$concat0(var$2.$errors));
    };
    $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_0 = $rt_classWithoutFields();
    $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncia_SubqueryCall$_findTransactionalSubquery($java.oncia_SubqueryCall$_MODULE$, var$1);
    };
    var oncias_IterableOnceSemanticChecking$ = $rt_classWithoutFields();
    $java.oncias_IterableOnceSemanticChecking$_MODULE$ = null;
    function oncias_IterableOnceSemanticChecking$__clinit_() {
        $java.oncias_IterableOnceSemanticChecking$_MODULE$ = new oncias_IterableOnceSemanticChecking$;
    }
    $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension = function($this, $$this, $check) {
        var var$3, var$4;
        $$this = $$this.$iterator0();
        var$3 = oncias_SemanticCheck$_success;
        var$4 = new $java.oncias_IterableOnceSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0;
        var$4.$_0408 = $check;
        return $$this.$foldLeft(var$3, var$4);
    };
    $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_1 = function() {
        jl_Object.call(this);
        this.$_0341 = null;
    };
    $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0341.$error2($rt_s(1788), var$1.$position67);
    };
    var scm_IndexedSeq$ = $rt_classWithoutFields(sc_SeqFactory$Delegate);
    var scm_IndexedSeq$_MODULE$ = null;
    function scm_IndexedSeq$_$callClinit() {
        scm_IndexedSeq$_$callClinit = $rt_eraseClinit(scm_IndexedSeq$);
        $java.scm_IndexedSeq$__clinit_();
    }
    $java.scm_IndexedSeq$__clinit_ = function() {
        var var$1;
        var$1 = new scm_IndexedSeq$;
        scm_IndexedSeq$_$callClinit();
        sc_SeqFactory$Delegate__init_0(var$1, scm_ArrayBuffer$_MODULE$);
        scm_IndexedSeq$_MODULE$ = var$1;
    };
    var jusi_SimpleStreamImpl = $rt_classWithoutFields();
    function jusi_SimpleStreamImpl_map($this, $mapper) {
        var var$2;
        var$2 = new $java.jusi_MappingStreamImpl;
        jusi_WrappingStreamImpl__init_(var$2, $this);
        var$2.$mapper = $mapper;
        return var$2;
    }
    function jusi_SimpleStreamImpl_collect($this, $collector) {
        var $collection, $accumulator, var$4;
        $collection = $collector.$supplier.$get0();
        $accumulator = $collector.$accumulator0;
        while (true) {
            var$4 = new $java.jusi_SimpleStreamImpl$collect$lambda$_25_0;
            var$4.$_0409 = $accumulator;
            var$4.$_1121 = $collection;
            if (!$java.jusi_WrappingStreamImpl_next($this, var$4))
                break;
        }
        return $collector.$finisher.$apply($collection);
    }
    function jusi_StreamOverSpliterator() {
        jusi_SimpleStreamImpl.call(this);
        this.$spliterator = null;
    }
    $java.jusi_StreamOverSpliterator_next = function($this, $action$consumer) {
        var $action$wantsMore, var$3, var$4;
        $action$wantsMore = 0;
        while (true) {
            var$3 = $this.$spliterator;
            if (var$3.$iterator2 === null)
                var$3.$iterator2 = ju_AbstractList_iterator(var$3.$collection);
            if (!ju_AbstractList$1_hasNext(var$3.$iterator2))
                var$4 = 0;
            else {
                $action$wantsMore = $action$consumer.$test(ju_AbstractList$1_next(var$3.$iterator2));
                var$4 = 1;
            }
            if (!var$4)
                return 0;
            if (!$action$wantsMore)
                break;
        }
        return 1;
    };
    $java.jusi_StreamOverSpliterator_estimateSize = function($this) {
        return Long_lo(Long_fromInt($this.$spliterator.$collection.$size2));
    };
    $java.ju_Spliterator = $rt_classWithoutFields(0);
    $java.oncius_ClosedDynamicUnionType$simplify$lambda$_29_0 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$simplify$lambda$_29_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return !(var$1 instanceof oncius_ClosedDynamicUnionType) ? sci_$colon$colon__init_(var$1.$simplify(), sci_Nil$_MODULE$) : sci_List_map(var$1.$sortedInnerTypes, new $java.oncius_ClosedDynamicUnionType$$anonfun$simplify$1$lambda$_55_0);
    };
    $java.oncias_IterableOnceSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0 = function() {
        jl_Object.call(this);
        this.$_0408 = null;
    };
    $java.oncias_IterableOnceSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0_apply = function(var$0, var$1, var$2) {
        return var$1.$chain(var$0.$_0408.$apply(var$2));
    };
    function oncia_OrderBy() {
        var a = this; jl_Object.call(a);
        a.$sortItems = null;
        a.$position59 = null;
    }
    function oncia_OrderBy__init_(var_0, var_1) {
        var var_2 = new oncia_OrderBy();
        $java.oncia_OrderBy__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_OrderBy_position = function($this) {
        return $this.$position59;
    };
    $java.oncia_OrderBy_semanticCheck = function($this) {
        return $java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension($java.oncias_SemanticCheckableIterableOnce$_MODULE$, $this.$sortItems);
    };
    $java.oncia_OrderBy_productPrefix = function($this) {
        return $rt_s(1789);
    };
    $java.oncia_OrderBy_productArity = function($this) {
        return 1;
    };
    $java.oncia_OrderBy_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$sortItems;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_OrderBy_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OrderBy_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OrderBy_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OrderBy_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_OrderBy) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$sortItems;
                        $x$1 = $x$1.$sortItems;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_OrderBy))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_OrderBy_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_OrderBy__init_ = function($this, $sortItems, $position) {
        $this.$sortItems = $sortItems;
        $this.$position59 = $position;
    };
    $java.sci_Map$Map2 = function() {
        var a = this; sci_AbstractMap.call(a);
        a.$scala$collection$immutable$Map$Map2$$key1 = null;
        a.$scala$collection$immutable$Map$Map2$$value1 = null;
        a.$scala$collection$immutable$Map$Map2$$key2 = null;
        a.$scala$collection$immutable$Map$Map2$$value2 = null;
    };
    $java.sci_Map$Map2__init_ = function(var_0, var_1, var_2, var_3) {
        var var_4 = new $java.sci_Map$Map2();
        $java.sci_Map$Map2__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    $java.sci_Map$Map2_map = function($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    };
    $java.sci_Map$Map2_flatMap = function($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    };
    $java.sci_Map$Map2_collect = function($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    };
    $java.sci_Map$Map2_flatten = function($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    };
    $java.sci_Map$Map2_filter = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    };
    $java.sci_Map$Map2_filterNot = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    };
    $java.sci_Map$Map2_size = function($this) {
        return 2;
    };
    $java.sci_Map$Map2_knownSize = function($this) {
        return 2;
    };
    $java.sci_Map$Map2_isEmpty = function($this) {
        return 0;
    };
    $java.sci_Map$Map2_apply = function($this, $key) {
        var var$2, var$3;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key1))
            return $this.$scala$collection$immutable$Map$Map2$$value1;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key2))
            return $this.$scala$collection$immutable$Map$Map2$$value2;
        var$2 = new ju_NoSuchElementException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 15);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(389));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$3, $key)));
        $rt_throw(var$2);
    };
    $java.sci_Map$Map2_contains = function($this, $key) {
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key1) && !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key2))
            return 0;
        return 1;
    };
    $java.sci_Map$Map2_get = function($this, $key) {
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key1))
            return s_Some__init_($this.$scala$collection$immutable$Map$Map2$$value1);
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key2))
            return s_None$_MODULE$;
        return s_Some__init_($this.$scala$collection$immutable$Map$Map2$$value2);
    };
    $java.sci_Map$Map2_getOrElse = function($this, $key, $default) {
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key1))
            return $this.$scala$collection$immutable$Map$Map2$$value1;
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key2))
            return $default.$apply2();
        return $this.$scala$collection$immutable$Map$Map2$$value2;
    };
    $java.sci_Map$Map2_iterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map2$$anon$1;
        $java.sci_Map$Map2$Map2Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map2_keysIterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map2$$anon$2;
        $java.sci_Map$Map2$Map2Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map2_valuesIterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map2$$anon$3;
        $java.sci_Map$Map2$Map2Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map2_foreach = function($this, $f) {
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1));
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2));
    };
    $java.sci_Map$Map2_exists = function($this, $p) {
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1))) && !sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2))))
            return 0;
        return 1;
    };
    $java.sci_Map$Map2_forall = function($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1))) && sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2))))
            return 1;
        return 0;
    };
    $java.sci_Map$Map2_hashCode = function($this) {
        var $h, $a, var$3, $c, $b;
        suh_MurmurHash3$_$callClinit();
        $h = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1);
        $a = 0 + $h | 0;
        var$3 = 0 ^ $h;
        $c = 1 * ($h | 1) | 0;
        $b = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2);
        $a = $a + $b | 0;
        $h = var$3 ^ $b;
        $b = $rt_imul($c, $b | 1);
        $c = suh_MurmurHash3$_mapSeed(suh_MurmurHash3$_MODULE$);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $c, $a);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $a, $h);
        $a = suh_MurmurHash3_mixLast(suh_MurmurHash3$_MODULE$, $a, $b);
        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(suh_MurmurHash3$_MODULE$, $a ^ 2);
    };
    $java.sci_Map$Map2_filterImpl = function($this, $pred, $isFlipped) {
        var var$3, var$4, var$5;
        var$3 = null;
        var$4 = null;
        var$5 = 0;
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1))) != $isFlipped) {
            var$3 = $this.$scala$collection$immutable$Map$Map2$$key1;
            var$4 = $this.$scala$collection$immutable$Map$Map2$$value1;
            var$5 = 1;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2))) != $isFlipped) {
            if (!var$5) {
                var$3 = $this.$scala$collection$immutable$Map$Map2$$key2;
                var$4 = $this.$scala$collection$immutable$Map$Map2$$value2;
            }
            var$5 = var$5 + 1 | 0;
        }
        a: {
            switch (var$5) {
                case 0:
                    $this = sci_Map$EmptyMap$_MODULE$;
                    break a;
                case 1:
                    $this = sci_Map$Map1__init_(var$3, var$4);
                    break a;
                case 2:
                    break;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf(var$5)));
            }
        }
        return $this;
    };
    $java.sci_Map$Map2_removed = function($this, $key) {
        return sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key1) ? sci_Map$Map1__init_($this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2) : !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key2) ? $this : sci_Map$Map1__init_($this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1);
    };
    $java.sci_Map$Map2_updated = function($this, $key, $value) {
        return sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key1) ? $java.sci_Map$Map2__init_($this.$scala$collection$immutable$Map$Map2$$key1, $value, $this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2) : sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map2$$key2) ? $java.sci_Map$Map2__init_($this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1, $this.$scala$collection$immutable$Map$Map2$$key2,
        $value) : $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map2$$key1, $this.$scala$collection$immutable$Map$Map2$$value1, $this.$scala$collection$immutable$Map$Map2$$key2, $this.$scala$collection$immutable$Map$Map2$$value2, $key, $value);
    };
    $java.sci_Map$Map2__init_0 = function($this, $key1, $value1, $key2, $value2) {
        $this.$scala$collection$immutable$Map$Map2$$key1 = $key1;
        $this.$scala$collection$immutable$Map$Map2$$value1 = $value1;
        $this.$scala$collection$immutable$Map$Map2$$key2 = $key2;
        $this.$scala$collection$immutable$Map$Map2$$value2 = $value2;
    };
    $java.ju_LinkedList$SequentialListIterator = function() {
        var a = this; jl_Object.call(a);
        a.$nextEntry = null;
        a.$prevEntry = null;
        a.$currentEntry = null;
        a.$index3 = 0;
        a.$version = 0;
        a.$this$02 = null;
    };
    $java.ju_LinkedList$SequentialListIterator__init_ = function(var_0, var_1, var_2, var_3) {
        var var_4 = new $java.ju_LinkedList$SequentialListIterator();
        $java.ju_LinkedList$SequentialListIterator__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    $java.ju_LinkedList$SequentialListIterator__init_0 = function($this, var$1, $nextEntry, $prevEntry, $index) {
        $this.$this$02 = var$1;
        $this.$version = var$1.$modCount;
        $this.$nextEntry = $nextEntry;
        $this.$prevEntry = $prevEntry;
        $this.$index3 = $index;
    };
    $java.ju_LinkedList$SequentialListIterator_hasNext = function($this) {
        return $this.$nextEntry === null ? 0 : 1;
    };
    $java.ju_LinkedList$SequentialListIterator_next = function($this) {
        var var$1, $result;
        $java.ju_LinkedList$SequentialListIterator_checkConcurrentModification($this);
        var$1 = $this.$nextEntry;
        if (var$1 === null) {
            var$1 = new ju_NoSuchElementException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        $result = var$1.$item;
        $this.$currentEntry = var$1;
        $this.$prevEntry = var$1;
        $this.$nextEntry = var$1.$next8;
        $this.$index3 = $this.$index3 + 1 | 0;
        return $result;
    };
    $java.ju_LinkedList$SequentialListIterator_checkConcurrentModification = function($this) {
        var var$1;
        if ($this.$version >= $this.$this$02.$modCount)
            return;
        var$1 = new ju_ConcurrentModificationException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    };
    $java.ju_LinkedList$Entry = function() {
        var a = this; jl_Object.call(a);
        a.$item = null;
        a.$next8 = null;
        a.$previous = null;
    };
    function oncie_ExplicitParameter() {
        var a = this; oncie_Expression.call(a);
        a.$name10 = null;
        a.$parameterType = null;
        a.$sizeHint1 = null;
        a.$position14 = null;
    }
    function oncie_ExplicitParameter__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncie_ExplicitParameter();
        oncie_ExplicitParameter__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncie_ExplicitParameter_asCanonicalStringVal = function($this) {
        var var$1, var$2;
        var$1 = $this.$name10;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 36);
        jl_StringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncie_ExplicitParameter_name = function($this) {
        return $this.$name10;
    };
    $java.oncie_ExplicitParameter_parameterType = function($this) {
        return $this.$parameterType;
    };
    $java.oncie_ExplicitParameter_sizeHint = function($this) {
        return $this.$sizeHint1;
    };
    $java.oncie_ExplicitParameter_position = function($this) {
        return $this.$position14;
    };
    $java.oncie_ExplicitParameter_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3_arrayHash(suh_MurmurHash3$_MODULE$, $rt_createArrayFromData(jl_Object, [$this.$name10, $this.$parameterType]), 1007110753);
    };
    $java.oncie_ExplicitParameter_canEqual = function($this, $that) {
        return $that instanceof oncie_ExplicitParameter;
    };
    $java.oncie_ExplicitParameter_equals = function($this, $obj) {
        var var$2, var$3, var$4;
        if (!$rt_isInstance($obj, oncie_Parameter))
            var$2 = 0;
        else
            a: {
                b: {
                    $obj = $obj;
                    if ($this instanceof oncie_ExplicitParameter) {
                        c: {
                            var$3 = $this.$name10;
                            var$4 = $obj.$name10;
                            if (var$3 !== null) {
                                if (!jl_String_equals(var$3, var$4))
                                    break b;
                                else
                                    break c;
                            }
                            if (var$4 !== null)
                                break b;
                        }
                        d: {
                            var$3 = $this.$parameterType;
                            var$4 = $obj.$parameterType;
                            if (var$3 !== null) {
                                if (!var$3.$equals(var$4))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$4 !== null)
                                break b;
                        }
                        e: {
                            var$4 = $this.$sizeHint1;
                            $obj = $obj.$sizeHint1;
                            if (var$4 !== null) {
                                if (!jl_Object_equals(var$4, $obj))
                                    break b;
                                else
                                    break e;
                            }
                            if ($obj !== null)
                                break b;
                        }
                        var$2 = 1;
                        break a;
                    }
                }
                var$2 = 0;
            }
        return var$2;
    };
    $java.oncie_ExplicitParameter_copy = function($this, $name, $parameterType, $sizeHint, $position) {
        return oncie_ExplicitParameter__init_($name, $parameterType, $sizeHint, $position);
    };
    $java.oncie_ExplicitParameter_productPrefix = function($this) {
        return $rt_s(1790);
    };
    $java.oncie_ExplicitParameter_productArity = function($this) {
        return 3;
    };
    $java.oncie_ExplicitParameter_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name10;
            case 1:
                return $this.$parameterType;
            case 2:
                return $this.$sizeHint1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ExplicitParameter_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ExplicitParameter_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    function oncie_ExplicitParameter__init_0($this, $name, $parameterType, $sizeHint, $position) {
        $this.$name10 = $name;
        $this.$parameterType = $parameterType;
        $this.$sizeHint1 = $sizeHint;
        $this.$position14 = $position;
        $java.oncie_Expression__init_($this);
    }
    $java.oncie_SensitiveParameter = $rt_classWithoutFields(0);
    var onciafn_Neo4jASTFactory$$anon$3 = $rt_classWithoutFields(oncie_ExplicitParameter);
    function oncie_SensitiveStringLiteral() {
        var a = this; oncie_Expression.call(a);
        a.$value24 = null;
        a.$position116 = null;
    }
    $java.oncie_SensitiveStringLiteral__init_ = function(var_0, var_1) {
        var var_2 = new oncie_SensitiveStringLiteral();
        oncie_SensitiveStringLiteral__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncie_SensitiveStringLiteral_position = function($this) {
        return $this.$position116;
    };
    $java.oncie_SensitiveStringLiteral_equals = function($this, $obj) {
        if (!($obj instanceof oncie_SensitiveStringLiteral))
            return 0;
        return ju_Arrays_equals3($obj.$value24, $this.$value24);
    };
    $java.oncie_SensitiveStringLiteral_hashCode = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$value24;
        if (var$1 === null)
            var$2 = 0;
        else {
            var$2 = 1;
            var$3 = 0;
            while (true) {
                var$4 = var$1.data;
                if (var$3 >= var$4.length)
                    break;
                var$2 = (31 * var$2 | 0) + var$4[var$3] | 0;
                var$3 = var$3 + 1 | 0;
            }
        }
        return var$2;
    };
    $java.oncie_SensitiveStringLiteral_productPrefix = function($this) {
        return $rt_s(1791);
    };
    $java.oncie_SensitiveStringLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_SensitiveStringLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value24;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SensitiveStringLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SensitiveStringLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    function oncie_SensitiveStringLiteral__init_($this, $value, $position) {
        $this.$value24 = $value;
        $this.$position116 = $position;
        $java.oncie_Expression__init_($this);
    }
    var jnc_StandardCharsets = $rt_classWithoutFields();
    var jnc_StandardCharsets_UTF_8 = null;
    $java.jnc_StandardCharsets_US_ASCII = null;
    $java.jnc_StandardCharsets_ISO_8859_1 = null;
    $java.jnc_StandardCharsets_UTF_16 = null;
    $java.jnc_StandardCharsets_UTF_16BE = null;
    $java.jnc_StandardCharsets_UTF_16LE = null;
    function jnc_StandardCharsets_$callClinit() {
        jnc_StandardCharsets_$callClinit = $rt_eraseClinit(jnc_StandardCharsets);
        $java.jnc_StandardCharsets__clinit_();
    }
    $java.jnc_StandardCharsets__clinit_ = function() {
        var var$1;
        jnc_StandardCharsets_UTF_8 = jnci_UTF8Charset_INSTANCE;
        var$1 = new $java.jnci_AsciiCharset;
        jnc_Charset__init_(var$1, $rt_s(1792), $rt_createArray(jl_String, 0));
        $java.jnc_StandardCharsets_US_ASCII = var$1;
        var$1 = new $java.jnci_Iso8859Charset;
        jnc_Charset__init_(var$1, $rt_s(1793), $rt_createArray(jl_String, 0));
        $java.jnc_StandardCharsets_ISO_8859_1 = var$1;
        $java.jnc_StandardCharsets_UTF_16 = $java.jnci_UTF16Charset__init_($rt_s(1794), 1, 0);
        $java.jnc_StandardCharsets_UTF_16BE = $java.jnci_UTF16Charset__init_($rt_s(1795), 0, 0);
        $java.jnc_StandardCharsets_UTF_16LE = $java.jnci_UTF16Charset__init_($rt_s(1796), 0, 1);
    };
    $java.ju_HashMap$HashEntry = function() {
        var a = this; ju_MapEntry.call(a);
        a.$origKeyHash = 0;
        a.$next10 = null;
    };
    $java.ju_HashMap$HashEntry__init_ = function(var_0, var_1) {
        var var_2 = new $java.ju_HashMap$HashEntry();
        $java.ju_HashMap$HashEntry__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.ju_HashMap$HashEntry__init_0 = function($this, $theKey, $hash) {
        ju_MapEntry__init_($this, $theKey, null);
        $this.$origKeyHash = $hash;
    };
    $java.ju_LinkedHashMap$LinkedHashMapEntry = function() {
        var a = this; $java.ju_HashMap$HashEntry.call(a);
        a.$chainForward = null;
        a.$chainBackward = null;
    };
    $java.oncia_CreateIndex = function() {
        var a = this; jl_Object.call(a);
        a.$variable22 = null;
        a.$properties12 = null;
        a.$ifExistsDo15 = null;
        a.$isNodeIndex0 = 0;
        a.$position117 = null;
        a.$errorMessageOnRequire8 = null;
        a.$errorMessageForAssert8 = null;
        a.$errorMessageForAssertExists8 = null;
        a.$errorMessageOnAssert8 = null;
        a.$errorMessageOnAssertExists8 = null;
    };
    $java.oncia_CreateIndex_checkSingleProperty = function($this, $schemaString, $properties) {
        var var$3, var$4, var$5;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = $properties.$length() <= 1 ? 0 : 1;
        var$5 = new $java.oncia_SchemaCommand$checkSingleProperty$lambda$_14_0;
        var$5.$_0410 = $this;
        var$5.$_1122 = $schemaString;
        var$5.$_246 = $properties;
        return oncias_SemanticCheck$_when(var$3, var$4, var$5);
    };
    $java.oncia_CreateIndex_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_CreateIndex_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_CreateIndex_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_CreateIndex_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateIndex_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateIndex_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire8 = $x$1;
    };
    $java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert8 = $x$1;
    };
    $java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists8 = $x$1;
    };
    $java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert8 = $x$1;
    };
    $java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists8 = $x$1;
    };
    $java.oncia_CreateIndex_semanticCheck = function($this) {
        var $ctType, var$2, var$3;
        $ctType = $this.$ifExistsDo15;
        if (jl_Object_equals(oncia_IfExistsInvalidSyntax$_MODULE$, $ctType) ? 1 : !jl_Object_equals(oncia_IfExistsReplace$_MODULE$, $ctType) ? 0 : 1)
            return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1797), $this.$position2());
        if (!$this.$isNodeIndex0) {
            oncius_package$_$callClinit();
            $ctType = oncius_package$_CTRelationship(oncius_package$_MODULE$);
        } else {
            oncius_package$_$callClinit();
            $ctType = oncius_package$_CTNode(oncius_package$_MODULE$);
        }
        var$2 = oncias_package$_MODULE$;
        var$3 = $this.$variable22;
        oncius_package$_$callClinit();
        $ctType = $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_declareVariable$($this, var$3, $ctType.$invariant()));
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = oncias_SemanticCheck_chain$($ctType, $java.oncias_SemanticExpressionCheck$_simple0(oncias_SemanticExpressionCheck$_MODULE$, $this.$properties12));
        $ctType = $this.$properties12;
        var$2 = new $java.oncia_CreateIndex$semanticCheck$lambda$_65_0;
        var$2.$_0411 = $this;
        return oncias_SemanticCheck_chain$(var$3, oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $ctType, var$2));
    };
    $java.oncia_CreateIndex_dup0 = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateIndex__init_ = function($this, $variable, $properties, $ifExistsDo, $isNodeIndex, $position) {
        $this.$variable22 = $variable;
        $this.$properties12 = $properties;
        $this.$ifExistsDo15 = $ifExistsDo;
        $this.$isNodeIndex0 = $isNodeIndex;
        $this.$position117 = $position;
        $java.oncia_SchemaCommand_$init$($this);
    };
    function oncia_CreateRangeNodeIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable23 = null;
        a.$label6 = null;
        a.$properties13 = null;
        a.$name35 = null;
        a.$ifExistsDo16 = null;
        a.$options10 = null;
        a.$fromDefault0 = 0;
        a.$useGraph9 = null;
    }
    function oncia_CreateRangeNodeIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8) {
        var var_9 = new oncia_CreateRangeNodeIndex();
        $java.oncia_CreateRangeNodeIndex__init_(var_9, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8);
        return var_9;
    }
    $java.oncia_CreateRangeNodeIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreateRangeNodeIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1798), $this.$options10), $java.oncia_CreateIndex_semanticCheck($this));
    };
    $java.oncia_CreateRangeNodeIndex_copy = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $fromDefault, $useGraph, $position) {
        return oncia_CreateRangeNodeIndex__init_($variable, $label, $properties, $name, $ifExistsDo, $options, $fromDefault, $useGraph, $position);
    };
    $java.oncia_CreateRangeNodeIndex_productPrefix = function($this) {
        return $rt_s(1799);
    };
    $java.oncia_CreateRangeNodeIndex_productArity = function($this) {
        return 8;
    };
    $java.oncia_CreateRangeNodeIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable23;
            case 1:
                return $this.$label6;
            case 2:
                return $this.$properties13;
            case 3:
                return $this.$name35;
            case 4:
                return $this.$ifExistsDo16;
            case 5:
                return $this.$options10;
            case 6:
                return jl_Boolean_valueOf($this.$fromDefault0);
            case 7:
                return $this.$useGraph9;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRangeNodeIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRangeNodeIndex_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1799))), sr_Statics_anyHash($this.$variable23)), sr_Statics_anyHash($this.$label6)), sr_Statics_anyHash($this.$properties13)), sr_Statics_anyHash($this.$name35)), sr_Statics_anyHash($this.$ifExistsDo16)), sr_Statics_anyHash($this.$options10)), !$this.$fromDefault0 ? 1237 : 1231), sr_Statics_anyHash($this.$useGraph9)),
        8);
    };
    $java.oncia_CreateRangeNodeIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRangeNodeIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateRangeNodeIndex) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$fromDefault0 != $x$1.$fromDefault0)
                        break b;
                    c: {
                        var$2 = $this.$variable23;
                        var$3 = $x$1.$variable23;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label6;
                        var$3 = $x$1.$label6;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties13;
                        var$3 = $x$1.$properties13;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name35;
                        var$3 = $x$1.$name35;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo16;
                        var$3 = $x$1.$ifExistsDo16;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options10;
                        var$3 = $x$1.$options10;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph9;
                        $x$1 = $x$1.$useGraph9;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateRangeNodeIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRangeNodeIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateRangeNodeIndex_copy($this, $this.$variable23, $this.$label6, $this.$properties13, $this.$name35, $this.$ifExistsDo16, $this.$options10, $this.$fromDefault0, $useGraph, $this.$position117);
    };
    $java.oncia_CreateRangeNodeIndex__init_ = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $fromDefault, $useGraph, $position) {
        $this.$variable23 = $variable;
        $this.$label6 = $label;
        $this.$properties13 = $properties;
        $this.$name35 = $name;
        $this.$ifExistsDo16 = $ifExistsDo;
        $this.$options10 = $options;
        $this.$fromDefault0 = $fromDefault;
        $this.$useGraph9 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 1, $position);
    };
    var oncia_CreateRangeNodeIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateRangeNodeIndex$_MODULE$ = null;
    function oncia_CreateRangeNodeIndex$__clinit_() {
        $java.oncia_CreateRangeNodeIndex$_MODULE$ = new oncia_CreateRangeNodeIndex$;
    }
    function oncia_CreateRangeRelationshipIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable24 = null;
        a.$relType5 = null;
        a.$properties14 = null;
        a.$name36 = null;
        a.$ifExistsDo17 = null;
        a.$options11 = null;
        a.$fromDefault1 = 0;
        a.$useGraph10 = null;
    }
    function oncia_CreateRangeRelationshipIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8) {
        var var_9 = new oncia_CreateRangeRelationshipIndex();
        $java.oncia_CreateRangeRelationshipIndex__init_(var_9, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8);
        return var_9;
    }
    $java.oncia_CreateRangeRelationshipIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreateRangeRelationshipIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1800), $this.$options11), $java.oncia_CreateIndex_semanticCheck($this));
    };
    $java.oncia_CreateRangeRelationshipIndex_copy = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $fromDefault, $useGraph, $position) {
        return oncia_CreateRangeRelationshipIndex__init_($variable, $relType, $properties, $name, $ifExistsDo, $options, $fromDefault, $useGraph, $position);
    };
    $java.oncia_CreateRangeRelationshipIndex_productPrefix = function($this) {
        return $rt_s(1801);
    };
    $java.oncia_CreateRangeRelationshipIndex_productArity = function($this) {
        return 8;
    };
    $java.oncia_CreateRangeRelationshipIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable24;
            case 1:
                return $this.$relType5;
            case 2:
                return $this.$properties14;
            case 3:
                return $this.$name36;
            case 4:
                return $this.$ifExistsDo17;
            case 5:
                return $this.$options11;
            case 6:
                return jl_Boolean_valueOf($this.$fromDefault1);
            case 7:
                return $this.$useGraph10;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRangeRelationshipIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRangeRelationshipIndex_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1801))), sr_Statics_anyHash($this.$variable24)), sr_Statics_anyHash($this.$relType5)), sr_Statics_anyHash($this.$properties14)), sr_Statics_anyHash($this.$name36)), sr_Statics_anyHash($this.$ifExistsDo17)), sr_Statics_anyHash($this.$options11)), !$this.$fromDefault1 ? 1237 : 1231), sr_Statics_anyHash($this.$useGraph10)),
        8);
    };
    $java.oncia_CreateRangeRelationshipIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRangeRelationshipIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateRangeRelationshipIndex) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$fromDefault1 != $x$1.$fromDefault1)
                        break b;
                    c: {
                        var$2 = $this.$variable24;
                        var$3 = $x$1.$variable24;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType5;
                        var$3 = $x$1.$relType5;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties14;
                        var$3 = $x$1.$properties14;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name36;
                        var$3 = $x$1.$name36;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo17;
                        var$3 = $x$1.$ifExistsDo17;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options11;
                        var$3 = $x$1.$options11;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph10;
                        $x$1 = $x$1.$useGraph10;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateRangeRelationshipIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateRangeRelationshipIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateRangeRelationshipIndex_copy($this, $this.$variable24, $this.$relType5, $this.$properties14, $this.$name36, $this.$ifExistsDo17, $this.$options11, $this.$fromDefault1, $useGraph, $this.$position117);
    };
    $java.oncia_CreateRangeRelationshipIndex__init_ = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $fromDefault, $useGraph, $position) {
        $this.$variable24 = $variable;
        $this.$relType5 = $relType;
        $this.$properties14 = $properties;
        $this.$name36 = $name;
        $this.$ifExistsDo17 = $ifExistsDo;
        $this.$options11 = $options;
        $this.$fromDefault1 = $fromDefault;
        $this.$useGraph10 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 0, $position);
    };
    var oncia_CreateRangeRelationshipIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateRangeRelationshipIndex$_MODULE$ = null;
    function oncia_CreateRangeRelationshipIndex$__clinit_() {
        $java.oncia_CreateRangeRelationshipIndex$_MODULE$ = new oncia_CreateRangeRelationshipIndex$;
    }
    function oncia_CreateBtreeNodeIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable25 = null;
        a.$label7 = null;
        a.$properties15 = null;
        a.$name37 = null;
        a.$ifExistsDo18 = null;
        a.$options12 = null;
        a.$useGraph11 = null;
    }
    function oncia_CreateBtreeNodeIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreateBtreeNodeIndex();
        $java.oncia_CreateBtreeNodeIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_CreateBtreeNodeIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreateBtreeNodeIndex_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1802), $this.$position117);
    };
    $java.oncia_CreateBtreeNodeIndex_copy = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreateBtreeNodeIndex__init_($variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreateBtreeNodeIndex_productPrefix = function($this) {
        return $rt_s(1803);
    };
    $java.oncia_CreateBtreeNodeIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreateBtreeNodeIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable25;
            case 1:
                return $this.$label7;
            case 2:
                return $this.$properties15;
            case 3:
                return $this.$name37;
            case 4:
                return $this.$ifExistsDo18;
            case 5:
                return $this.$options12;
            case 6:
                return $this.$useGraph11;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateBtreeNodeIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateBtreeNodeIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateBtreeNodeIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateBtreeNodeIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateBtreeNodeIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable25;
                        var$3 = $x$1.$variable25;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label7;
                        var$3 = $x$1.$label7;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties15;
                        var$3 = $x$1.$properties15;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name37;
                        var$3 = $x$1.$name37;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo18;
                        var$3 = $x$1.$ifExistsDo18;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options12;
                        var$3 = $x$1.$options12;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph11;
                        $x$1 = $x$1.$useGraph11;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateBtreeNodeIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateBtreeNodeIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateBtreeNodeIndex_copy($this, $this.$variable25, $this.$label7, $this.$properties15, $this.$name37, $this.$ifExistsDo18, $this.$options12, $useGraph, $this.$position117);
    };
    $java.oncia_CreateBtreeNodeIndex__init_ = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable25 = $variable;
        $this.$label7 = $label;
        $this.$properties15 = $properties;
        $this.$name37 = $name;
        $this.$ifExistsDo18 = $ifExistsDo;
        $this.$options12 = $options;
        $this.$useGraph11 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 1, $position);
    };
    var oncia_CreateBtreeNodeIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateBtreeNodeIndex$_MODULE$ = null;
    function oncia_CreateBtreeNodeIndex$__clinit_() {
        $java.oncia_CreateBtreeNodeIndex$_MODULE$ = new oncia_CreateBtreeNodeIndex$;
    }
    function oncia_CreateBtreeRelationshipIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable26 = null;
        a.$relType6 = null;
        a.$properties16 = null;
        a.$name38 = null;
        a.$ifExistsDo19 = null;
        a.$options13 = null;
        a.$useGraph12 = null;
    }
    function oncia_CreateBtreeRelationshipIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreateBtreeRelationshipIndex();
        $java.oncia_CreateBtreeRelationshipIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_CreateBtreeRelationshipIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreateBtreeRelationshipIndex_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1802), $this.$position117);
    };
    $java.oncia_CreateBtreeRelationshipIndex_copy = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreateBtreeRelationshipIndex__init_($variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreateBtreeRelationshipIndex_productPrefix = function($this) {
        return $rt_s(1804);
    };
    $java.oncia_CreateBtreeRelationshipIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreateBtreeRelationshipIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable26;
            case 1:
                return $this.$relType6;
            case 2:
                return $this.$properties16;
            case 3:
                return $this.$name38;
            case 4:
                return $this.$ifExistsDo19;
            case 5:
                return $this.$options13;
            case 6:
                return $this.$useGraph12;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateBtreeRelationshipIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateBtreeRelationshipIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateBtreeRelationshipIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateBtreeRelationshipIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateBtreeRelationshipIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable26;
                        var$3 = $x$1.$variable26;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType6;
                        var$3 = $x$1.$relType6;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties16;
                        var$3 = $x$1.$properties16;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name38;
                        var$3 = $x$1.$name38;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo19;
                        var$3 = $x$1.$ifExistsDo19;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options13;
                        var$3 = $x$1.$options13;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph12;
                        $x$1 = $x$1.$useGraph12;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateBtreeRelationshipIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateBtreeRelationshipIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateBtreeRelationshipIndex_copy($this, $this.$variable26, $this.$relType6, $this.$properties16, $this.$name38, $this.$ifExistsDo19, $this.$options13, $useGraph, $this.$position117);
    };
    $java.oncia_CreateBtreeRelationshipIndex__init_ = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable26 = $variable;
        $this.$relType6 = $relType;
        $this.$properties16 = $properties;
        $this.$name38 = $name;
        $this.$ifExistsDo19 = $ifExistsDo;
        $this.$options13 = $options;
        $this.$useGraph12 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 0, $position);
    };
    var oncia_CreateBtreeRelationshipIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateBtreeRelationshipIndex$_MODULE$ = null;
    function oncia_CreateBtreeRelationshipIndex$__clinit_() {
        $java.oncia_CreateBtreeRelationshipIndex$_MODULE$ = new oncia_CreateBtreeRelationshipIndex$;
    }
    function oncia_CreateTextNodeIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable27 = null;
        a.$label8 = null;
        a.$properties17 = null;
        a.$name39 = null;
        a.$ifExistsDo20 = null;
        a.$options14 = null;
        a.$useGraph13 = null;
    }
    function oncia_CreateTextNodeIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreateTextNodeIndex();
        $java.oncia_CreateTextNodeIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    function oncia_CreateTextNodeIndex_options($this) {
        return $this.$options14;
    }
    function oncia_CreateTextNodeIndex_position($this) {
        return $this.$position117;
    }
    $java.oncia_CreateTextNodeIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1805), $this.$options14), $java.oncia_CreateIndex_semanticCheck($this)), $java.oncia_CreateIndex_checkSingleProperty($this, $rt_s(1806), $this.$properties17));
    };
    $java.oncia_CreateTextNodeIndex_copy = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreateTextNodeIndex__init_($variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreateTextNodeIndex_productPrefix = function($this) {
        return $rt_s(1807);
    };
    $java.oncia_CreateTextNodeIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreateTextNodeIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable27;
            case 1:
                return $this.$label8;
            case 2:
                return $this.$properties17;
            case 3:
                return $this.$name39;
            case 4:
                return $this.$ifExistsDo20;
            case 5:
                return $this.$options14;
            case 6:
                return $this.$useGraph13;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateTextNodeIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateTextNodeIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateTextNodeIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateTextNodeIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateTextNodeIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable27;
                        var$3 = $x$1.$variable27;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label8;
                        var$3 = $x$1.$label8;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties17;
                        var$3 = $x$1.$properties17;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name39;
                        var$3 = $x$1.$name39;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo20;
                        var$3 = $x$1.$ifExistsDo20;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options14;
                        var$3 = $x$1.$options14;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph13;
                        $x$1 = $x$1.$useGraph13;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateTextNodeIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateTextNodeIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateTextNodeIndex_copy($this, $this.$variable27, $this.$label8, $this.$properties17, $this.$name39, $this.$ifExistsDo20, $this.$options14, $useGraph, $this.$position117);
    };
    $java.oncia_CreateTextNodeIndex__init_ = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable27 = $variable;
        $this.$label8 = $label;
        $this.$properties17 = $properties;
        $this.$name39 = $name;
        $this.$ifExistsDo20 = $ifExistsDo;
        $this.$options14 = $options;
        $this.$useGraph13 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 1, $position);
    };
    var oncia_CreateTextNodeIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateTextNodeIndex$_MODULE$ = null;
    function oncia_CreateTextNodeIndex$__clinit_() {
        $java.oncia_CreateTextNodeIndex$_MODULE$ = new oncia_CreateTextNodeIndex$;
    }
    function oncia_CreateTextRelationshipIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable28 = null;
        a.$relType7 = null;
        a.$properties18 = null;
        a.$name40 = null;
        a.$ifExistsDo21 = null;
        a.$options15 = null;
        a.$useGraph14 = null;
    }
    function oncia_CreateTextRelationshipIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreateTextRelationshipIndex();
        $java.oncia_CreateTextRelationshipIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    function oncia_CreateTextRelationshipIndex_options($this) {
        return $this.$options15;
    }
    function oncia_CreateTextRelationshipIndex_position($this) {
        return $this.$position117;
    }
    $java.oncia_CreateTextRelationshipIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1808), $this.$options15), $java.oncia_CreateIndex_semanticCheck($this)), $java.oncia_CreateIndex_checkSingleProperty($this, $rt_s(1806), $this.$properties18));
    };
    $java.oncia_CreateTextRelationshipIndex_copy = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreateTextRelationshipIndex__init_($variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreateTextRelationshipIndex_productPrefix = function($this) {
        return $rt_s(1809);
    };
    $java.oncia_CreateTextRelationshipIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreateTextRelationshipIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable28;
            case 1:
                return $this.$relType7;
            case 2:
                return $this.$properties18;
            case 3:
                return $this.$name40;
            case 4:
                return $this.$ifExistsDo21;
            case 5:
                return $this.$options15;
            case 6:
                return $this.$useGraph14;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateTextRelationshipIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateTextRelationshipIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateTextRelationshipIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateTextRelationshipIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateTextRelationshipIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable28;
                        var$3 = $x$1.$variable28;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType7;
                        var$3 = $x$1.$relType7;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties18;
                        var$3 = $x$1.$properties18;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name40;
                        var$3 = $x$1.$name40;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo21;
                        var$3 = $x$1.$ifExistsDo21;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options15;
                        var$3 = $x$1.$options15;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph14;
                        $x$1 = $x$1.$useGraph14;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateTextRelationshipIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateTextRelationshipIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateTextRelationshipIndex_copy($this, $this.$variable28, $this.$relType7, $this.$properties18, $this.$name40, $this.$ifExistsDo21, $this.$options15, $useGraph, $this.$position117);
    };
    $java.oncia_CreateTextRelationshipIndex__init_ = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable28 = $variable;
        $this.$relType7 = $relType;
        $this.$properties18 = $properties;
        $this.$name40 = $name;
        $this.$ifExistsDo21 = $ifExistsDo;
        $this.$options15 = $options;
        $this.$useGraph14 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 0, $position);
    };
    var oncia_CreateTextRelationshipIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateTextRelationshipIndex$_MODULE$ = null;
    function oncia_CreateTextRelationshipIndex$__clinit_() {
        $java.oncia_CreateTextRelationshipIndex$_MODULE$ = new oncia_CreateTextRelationshipIndex$;
    }
    function oncia_CreatePointNodeIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable29 = null;
        a.$label9 = null;
        a.$properties19 = null;
        a.$name41 = null;
        a.$ifExistsDo22 = null;
        a.$options16 = null;
        a.$useGraph15 = null;
    }
    function oncia_CreatePointNodeIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreatePointNodeIndex();
        $java.oncia_CreatePointNodeIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_CreatePointNodeIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreatePointNodeIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1810), $this.$options16), $java.oncia_CreateIndex_semanticCheck($this)), $java.oncia_CreateIndex_checkSingleProperty($this, $rt_s(1811), $this.$properties19));
    };
    $java.oncia_CreatePointNodeIndex_copy = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreatePointNodeIndex__init_($variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreatePointNodeIndex_productPrefix = function($this) {
        return $rt_s(1812);
    };
    $java.oncia_CreatePointNodeIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreatePointNodeIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable29;
            case 1:
                return $this.$label9;
            case 2:
                return $this.$properties19;
            case 3:
                return $this.$name41;
            case 4:
                return $this.$ifExistsDo22;
            case 5:
                return $this.$options16;
            case 6:
                return $this.$useGraph15;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreatePointNodeIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreatePointNodeIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreatePointNodeIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreatePointNodeIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreatePointNodeIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable29;
                        var$3 = $x$1.$variable29;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label9;
                        var$3 = $x$1.$label9;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties19;
                        var$3 = $x$1.$properties19;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name41;
                        var$3 = $x$1.$name41;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo22;
                        var$3 = $x$1.$ifExistsDo22;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options16;
                        var$3 = $x$1.$options16;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph15;
                        $x$1 = $x$1.$useGraph15;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreatePointNodeIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreatePointNodeIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreatePointNodeIndex_copy($this, $this.$variable29, $this.$label9, $this.$properties19, $this.$name41, $this.$ifExistsDo22, $this.$options16, $useGraph, $this.$position117);
    };
    $java.oncia_CreatePointNodeIndex__init_ = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable29 = $variable;
        $this.$label9 = $label;
        $this.$properties19 = $properties;
        $this.$name41 = $name;
        $this.$ifExistsDo22 = $ifExistsDo;
        $this.$options16 = $options;
        $this.$useGraph15 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 1, $position);
    };
    var oncia_CreatePointNodeIndex$ = $rt_classWithoutFields();
    $java.oncia_CreatePointNodeIndex$_MODULE$ = null;
    function oncia_CreatePointNodeIndex$__clinit_() {
        $java.oncia_CreatePointNodeIndex$_MODULE$ = new oncia_CreatePointNodeIndex$;
    }
    function oncia_CreatePointRelationshipIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable30 = null;
        a.$relType8 = null;
        a.$properties20 = null;
        a.$name42 = null;
        a.$ifExistsDo23 = null;
        a.$options17 = null;
        a.$useGraph16 = null;
    }
    function oncia_CreatePointRelationshipIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreatePointRelationshipIndex();
        $java.oncia_CreatePointRelationshipIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_CreatePointRelationshipIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreatePointRelationshipIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1813), $this.$options17), $java.oncia_CreateIndex_semanticCheck($this)), $java.oncia_CreateIndex_checkSingleProperty($this, $rt_s(1811), $this.$properties20));
    };
    $java.oncia_CreatePointRelationshipIndex_copy = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreatePointRelationshipIndex__init_($variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreatePointRelationshipIndex_productPrefix = function($this) {
        return $rt_s(1814);
    };
    $java.oncia_CreatePointRelationshipIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreatePointRelationshipIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable30;
            case 1:
                return $this.$relType8;
            case 2:
                return $this.$properties20;
            case 3:
                return $this.$name42;
            case 4:
                return $this.$ifExistsDo23;
            case 5:
                return $this.$options17;
            case 6:
                return $this.$useGraph16;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreatePointRelationshipIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreatePointRelationshipIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreatePointRelationshipIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreatePointRelationshipIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreatePointRelationshipIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable30;
                        var$3 = $x$1.$variable30;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType8;
                        var$3 = $x$1.$relType8;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties20;
                        var$3 = $x$1.$properties20;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name42;
                        var$3 = $x$1.$name42;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo23;
                        var$3 = $x$1.$ifExistsDo23;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options17;
                        var$3 = $x$1.$options17;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph16;
                        $x$1 = $x$1.$useGraph16;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreatePointRelationshipIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreatePointRelationshipIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreatePointRelationshipIndex_copy($this, $this.$variable30, $this.$relType8, $this.$properties20, $this.$name42, $this.$ifExistsDo23, $this.$options17, $useGraph, $this.$position117);
    };
    $java.oncia_CreatePointRelationshipIndex__init_ = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable30 = $variable;
        $this.$relType8 = $relType;
        $this.$properties20 = $properties;
        $this.$name42 = $name;
        $this.$ifExistsDo23 = $ifExistsDo;
        $this.$options17 = $options;
        $this.$useGraph16 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 0, $position);
    };
    var oncia_CreatePointRelationshipIndex$ = $rt_classWithoutFields();
    var oncia_CreatePointRelationshipIndex$_MODULE$ = null;
    function oncia_CreatePointRelationshipIndex$__clinit_() {
        oncia_CreatePointRelationshipIndex$_MODULE$ = new oncia_CreatePointRelationshipIndex$;
    }
    function oncia_CreatePointRelationshipIndex$_apply$default$7($this) {
        return s_None$_MODULE$;
    }
    var onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncie_RelTypeName__init_(var$1.$string0, var$1.$pos);
    };
    function oncia_CreateFulltextRelationshipIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable31 = null;
        a.$relType9 = null;
        a.$properties21 = null;
        a.$name43 = null;
        a.$ifExistsDo24 = null;
        a.$options18 = null;
        a.$useGraph17 = null;
    }
    function oncia_CreateFulltextRelationshipIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreateFulltextRelationshipIndex();
        $java.oncia_CreateFulltextRelationshipIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_CreateFulltextRelationshipIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreateFulltextRelationshipIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1815), $this.$options18), $java.oncia_CreateIndex_semanticCheck($this));
    };
    $java.oncia_CreateFulltextRelationshipIndex_copy = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreateFulltextRelationshipIndex__init_($variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreateFulltextRelationshipIndex_productPrefix = function($this) {
        return $rt_s(1816);
    };
    $java.oncia_CreateFulltextRelationshipIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreateFulltextRelationshipIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable31;
            case 1:
                return $this.$relType9;
            case 2:
                return $this.$properties21;
            case 3:
                return $this.$name43;
            case 4:
                return $this.$ifExistsDo24;
            case 5:
                return $this.$options18;
            case 6:
                return $this.$useGraph17;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateFulltextRelationshipIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateFulltextRelationshipIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateFulltextRelationshipIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateFulltextRelationshipIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateFulltextRelationshipIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable31;
                        var$3 = $x$1.$variable31;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType9;
                        var$3 = $x$1.$relType9;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties21;
                        var$3 = $x$1.$properties21;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name43;
                        var$3 = $x$1.$name43;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo24;
                        var$3 = $x$1.$ifExistsDo24;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options18;
                        var$3 = $x$1.$options18;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph17;
                        $x$1 = $x$1.$useGraph17;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateFulltextRelationshipIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateFulltextRelationshipIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateFulltextRelationshipIndex_copy($this, $this.$variable31, $this.$relType9, $this.$properties21, $this.$name43, $this.$ifExistsDo24, $this.$options18, $useGraph, $this.$position117);
    };
    $java.oncia_CreateFulltextRelationshipIndex__init_ = function($this, $variable, $relType, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable31 = $variable;
        $this.$relType9 = $relType;
        $this.$properties21 = $properties;
        $this.$name43 = $name;
        $this.$ifExistsDo24 = $ifExistsDo;
        $this.$options18 = $options;
        $this.$useGraph17 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 0, $position);
    };
    var oncia_CreateFulltextRelationshipIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateFulltextRelationshipIndex$_MODULE$ = null;
    function oncia_CreateFulltextRelationshipIndex$__clinit_() {
        $java.oncia_CreateFulltextRelationshipIndex$_MODULE$ = new oncia_CreateFulltextRelationshipIndex$;
    }
    var onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncie_LabelName__init_(var$1.$string0, var$1.$pos);
    };
    function oncia_CreateFulltextNodeIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable32 = null;
        a.$label10 = null;
        a.$properties22 = null;
        a.$name44 = null;
        a.$ifExistsDo25 = null;
        a.$options19 = null;
        a.$useGraph18 = null;
    }
    function oncia_CreateFulltextNodeIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreateFulltextNodeIndex();
        $java.oncia_CreateFulltextNodeIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_CreateFulltextNodeIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreateFulltextNodeIndex_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1817), $this.$options19), $java.oncia_CreateIndex_semanticCheck($this));
    };
    $java.oncia_CreateFulltextNodeIndex_copy = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreateFulltextNodeIndex__init_($variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreateFulltextNodeIndex_productPrefix = function($this) {
        return $rt_s(1818);
    };
    $java.oncia_CreateFulltextNodeIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreateFulltextNodeIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable32;
            case 1:
                return $this.$label10;
            case 2:
                return $this.$properties22;
            case 3:
                return $this.$name44;
            case 4:
                return $this.$ifExistsDo25;
            case 5:
                return $this.$options19;
            case 6:
                return $this.$useGraph18;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateFulltextNodeIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateFulltextNodeIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateFulltextNodeIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateFulltextNodeIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateFulltextNodeIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable32;
                        var$3 = $x$1.$variable32;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label10;
                        var$3 = $x$1.$label10;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties22;
                        var$3 = $x$1.$properties22;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$name44;
                        var$3 = $x$1.$name44;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$ifExistsDo25;
                        var$3 = $x$1.$ifExistsDo25;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$options19;
                        var$3 = $x$1.$options19;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$3 = $this.$useGraph18;
                        $x$1 = $x$1.$useGraph18;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break i;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateFulltextNodeIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateFulltextNodeIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateFulltextNodeIndex_copy($this, $this.$variable32, $this.$label10, $this.$properties22, $this.$name44, $this.$ifExistsDo25, $this.$options19, $useGraph, $this.$position117);
    };
    $java.oncia_CreateFulltextNodeIndex__init_ = function($this, $variable, $label, $properties, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable32 = $variable;
        $this.$label10 = $label;
        $this.$properties22 = $properties;
        $this.$name44 = $name;
        $this.$ifExistsDo25 = $ifExistsDo;
        $this.$options19 = $options;
        $this.$useGraph18 = $useGraph;
        $java.oncia_CreateIndex__init_($this, $variable, $properties, $ifExistsDo, 1, $position);
    };
    var oncia_CreateFulltextNodeIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateFulltextNodeIndex$_MODULE$ = null;
    function oncia_CreateFulltextNodeIndex$__clinit_() {
        $java.oncia_CreateFulltextNodeIndex$_MODULE$ = new oncia_CreateFulltextNodeIndex$;
    }
    var oncie_FunctionInvocation$ = $rt_classWithoutFields();
    $java.oncie_FunctionInvocation$_MODULE$ = null;
    function oncie_FunctionInvocation$__clinit_() {
        $java.oncie_FunctionInvocation$_MODULE$ = new oncie_FunctionInvocation$;
    }
    function oncia_CreateLookupIndex() {
        var a = this; $java.oncia_CreateIndex.call(a);
        a.$variable33 = null;
        a.$isNodeIndex1 = 0;
        a.$function1 = null;
        a.$name45 = null;
        a.$ifExistsDo26 = null;
        a.$options20 = null;
        a.$useGraph19 = null;
    }
    function oncia_CreateLookupIndex__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_CreateLookupIndex();
        $java.oncia_CreateLookupIndex__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_CreateLookupIndex_position = function($this) {
        return $this.$position117;
    };
    $java.oncia_CreateLookupIndex_semanticCheck = function($this) {
        var var$1, $name, var$3, var$4;
        var$1 = $this.$function1;
        if (var$1 !== null) {
            var$1 = var$1.$functionName0;
            if (var$1 !== null) {
                $name = var$1.$name6;
                if (!$this.$isNodeIndex1) {
                    $java.oncief_Type$_$callClinit();
                    var$3 = jl_String_equalsIgnoreCase($name, $rt_s(538));
                } else {
                    $java.oncief_Labels$_$callClinit();
                    var$3 = jl_String_equalsIgnoreCase($name, $rt_s(1819));
                }
                if (!var$3) {
                    if (!$this.$isNodeIndex1) {
                        $java.oncief_Type$_$callClinit();
                        var$1 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_(var$1);
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(1820)), $name), $rt_s(1821)), $rt_s(538)), $rt_s(1822));
                        return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$1), $this.$position117);
                    }
                    $java.oncief_Labels$_$callClinit();
                    var$1 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$1);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(1823)), $name), $rt_s(1821)), $rt_s(1819)), $rt_s(1822));
                    return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$1), $this.$position117);
                }
            }
        }
        var$4 = oncias_SemanticCheck_chain$($java.oncia_SchemaCommand_checkOptionsMap$($this, $rt_s(1824), $this.$options20), $java.oncia_CreateIndex_semanticCheck($this));
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(var$4, $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$function1));
    };
    $java.oncia_CreateLookupIndex_copy = function($this, $variable, $isNodeIndex, $function, $name, $ifExistsDo, $options, $useGraph, $position) {
        return oncia_CreateLookupIndex__init_($variable, $isNodeIndex, $function, $name, $ifExistsDo, $options, $useGraph, $position);
    };
    $java.oncia_CreateLookupIndex_productPrefix = function($this) {
        return $rt_s(1825);
    };
    $java.oncia_CreateLookupIndex_productArity = function($this) {
        return 7;
    };
    $java.oncia_CreateLookupIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable33;
            case 1:
                return jl_Boolean_valueOf($this.$isNodeIndex1);
            case 2:
                return $this.$function1;
            case 3:
                return $this.$name45;
            case 4:
                return $this.$ifExistsDo26;
            case 5:
                return $this.$options20;
            case 6:
                return $this.$useGraph19;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateLookupIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateLookupIndex_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1825))), sr_Statics_anyHash($this.$variable33)), !$this.$isNodeIndex1 ? 1237 : 1231), sr_Statics_anyHash($this.$function1)), sr_Statics_anyHash($this.$name45)), sr_Statics_anyHash($this.$ifExistsDo26)), sr_Statics_anyHash($this.$options20)), sr_Statics_anyHash($this.$useGraph19)), 7);
    };
    $java.oncia_CreateLookupIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateLookupIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateLookupIndex) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$isNodeIndex1 != $x$1.$isNodeIndex1)
                        break b;
                    c: {
                        var$2 = $this.$variable33;
                        var$3 = $x$1.$variable33;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$function1;
                        var$3 = $x$1.$function1;
                        if (var$2 !== null) {
                            if (!$java.oncie_FunctionInvocation_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$name45;
                        var$3 = $x$1.$name45;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$ifExistsDo26;
                        var$3 = $x$1.$ifExistsDo26;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$options20;
                        var$3 = $x$1.$options20;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$3 = $this.$useGraph19;
                        $x$1 = $x$1.$useGraph19;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break h;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateLookupIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateLookupIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateLookupIndex_copy($this, $this.$variable33, $this.$isNodeIndex1, $this.$function1, $this.$name45, $this.$ifExistsDo26, $this.$options20, $useGraph, $this.$position117);
    };
    $java.oncia_CreateLookupIndex__init_ = function($this, $variable, $isNodeIndex, $function, $name, $ifExistsDo, $options, $useGraph, $position) {
        $this.$variable33 = $variable;
        $this.$isNodeIndex1 = $isNodeIndex;
        $this.$function1 = $function;
        $this.$name45 = $name;
        $this.$ifExistsDo26 = $ifExistsDo;
        $this.$options20 = $options;
        $this.$useGraph19 = $useGraph;
        s_package$_$callClinit();
        s_package$_List0(s_package$_MODULE$);
        $java.oncia_CreateIndex__init_($this, $variable, sci_Nil$_MODULE$, $ifExistsDo, $isNodeIndex, $position);
    };
    var oncia_CreateLookupIndex$ = $rt_classWithoutFields();
    $java.oncia_CreateLookupIndex$_MODULE$ = null;
    function oncia_CreateLookupIndex$__clinit_() {
        $java.oncia_CreateLookupIndex$_MODULE$ = new oncia_CreateLookupIndex$;
    }
    function oncia_CreateIndexOldSyntax() {
        var a = this; jl_Object.call(a);
        a.$label11 = null;
        a.$properties23 = null;
        a.$useGraph20 = null;
        a.$position118 = null;
        a.$errorMessageOnRequire9 = null;
        a.$errorMessageForAssert9 = null;
        a.$errorMessageForAssertExists9 = null;
        a.$errorMessageOnAssert9 = null;
        a.$errorMessageOnAssertExists9 = null;
    }
    function oncia_CreateIndexOldSyntax__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_CreateIndexOldSyntax();
        $java.oncia_CreateIndexOldSyntax__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_CreateIndexOldSyntax_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_CreateIndexOldSyntax_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire9 = $x$1;
    };
    $java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert9 = $x$1;
    };
    $java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists9 = $x$1;
    };
    $java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert9 = $x$1;
    };
    $java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists9 = $x$1;
    };
    $java.oncia_CreateIndexOldSyntax_position = function($this) {
        return $this.$position118;
    };
    $java.oncia_CreateIndexOldSyntax_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1826), $this.$position118);
    };
    $java.oncia_CreateIndexOldSyntax_copy = function($this, $label, $properties, $useGraph, $position) {
        return oncia_CreateIndexOldSyntax__init_($label, $properties, $useGraph, $position);
    };
    $java.oncia_CreateIndexOldSyntax_productPrefix = function($this) {
        return $rt_s(1827);
    };
    $java.oncia_CreateIndexOldSyntax_productArity = function($this) {
        return 3;
    };
    $java.oncia_CreateIndexOldSyntax_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$label11;
            case 1:
                return $this.$properties23;
            case 2:
                return $this.$useGraph20;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateIndexOldSyntax_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateIndexOldSyntax_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateIndexOldSyntax_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateIndexOldSyntax_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CreateIndexOldSyntax) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$label11;
                        var$3 = $x$1.$label11;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$properties23;
                        var$3 = $x$1.$properties23;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$useGraph20;
                        $x$1 = $x$1.$useGraph20;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CreateIndexOldSyntax))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CreateIndexOldSyntax_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CreateIndexOldSyntax_withGraph = function($this, $useGraph) {
        return $java.oncia_CreateIndexOldSyntax_copy($this, $this.$label11, $this.$properties23, $useGraph, $this.$position118);
    };
    $java.oncia_CreateIndexOldSyntax__init_ = function($this, $label, $properties, $useGraph, $position) {
        $this.$label11 = $label;
        $this.$properties23 = $properties;
        $this.$useGraph20 = $useGraph;
        $this.$position118 = $position;
        $java.oncia_SchemaCommand_$init$($this);
    };
    var onciafn_Neo4jASTFactory$createIndexWithOldSyntax$lambda$_152_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createIndexWithOldSyntax$lambda$_152_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncie_PropertyKeyName__init_(var$1.$string0, var$1.$pos);
    };
    var oncia_CreateIndexOldSyntax$ = $rt_classWithoutFields();
    $java.oncia_CreateIndexOldSyntax$_MODULE$ = null;
    function oncia_CreateIndexOldSyntax$__clinit_() {
        $java.oncia_CreateIndexOldSyntax$_MODULE$ = new oncia_CreateIndexOldSyntax$;
    }
    var onciaf_ScopeType = $rt_classWithoutFields(jl_Enum);
    var onciaf_ScopeType_ALL = null;
    var onciaf_ScopeType_DEFAULT = null;
    var onciaf_ScopeType_HOME = null;
    var onciaf_ScopeType_NAMED = null;
    $java.onciaf_ScopeType_$VALUES = null;
    function onciaf_ScopeType_$callClinit() {
        onciaf_ScopeType_$callClinit = $rt_eraseClinit(onciaf_ScopeType);
        $java.onciaf_ScopeType__clinit_();
    }
    $java.onciaf_ScopeType__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_ScopeType();
        $java.onciaf_ScopeType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_ScopeType_values() {
        onciaf_ScopeType_$callClinit();
        return $java.onciaf_ScopeType_$VALUES.$clone();
    }
    $java.onciaf_ScopeType__init_0 = function($this, var$1, var$2) {
        onciaf_ScopeType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_ScopeType__clinit_ = function() {
        var var$1;
        onciaf_ScopeType_ALL = $java.onciaf_ScopeType__init_($rt_s(302), 0);
        onciaf_ScopeType_DEFAULT = $java.onciaf_ScopeType__init_($rt_s(306), 1);
        onciaf_ScopeType_HOME = $java.onciaf_ScopeType__init_($rt_s(307), 2);
        var$1 = $java.onciaf_ScopeType__init_($rt_s(1828), 3);
        onciaf_ScopeType_NAMED = var$1;
        $java.onciaf_ScopeType_$VALUES = $rt_createArrayFromData(onciaf_ScopeType, [onciaf_ScopeType_ALL, onciaf_ScopeType_DEFAULT, onciaf_ScopeType_HOME, var$1]);
    };
    $java.oncia_PrivilegeQualifier = $rt_classWithoutFields(0);
    $java.oncia_GraphPrivilegeQualifier = $rt_classWithoutFields(0);
    function oncia_AllQualifier() {
        jl_Object.call(this);
        this.$position11 = null;
    }
    $java.oncia_AllQualifier_productPrefix = function($this) {
        return $rt_s(1829);
    };
    $java.oncia_AllQualifier_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllQualifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllQualifier_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_AllQualifier))
            return 0;
        return 1;
    };
    $java.oncia_AllQualifier_dup = function($this, $children) {
        return $this;
    };
    $java.oncia_AdministrationAction = $rt_classWithoutFields(0);
    $java.oncia_PrivilegeCommand = function() {
        var a = this; jl_Object.call(a);
        a.$privilege1 = null;
        a.$qualifier1 = null;
        a.$position119 = null;
        a.$featureCheck = null;
        a.$isReadOnly14 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar15 = null;
    };
    $java.oncia_PrivilegeCommand_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_PrivilegeCommand_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_PrivilegeCommand_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_PrivilegeCommand_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_PrivilegeCommand_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_PrivilegeCommand_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_PrivilegeCommand_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_PrivilegeCommand_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly14 = $x$1;
    };
    $java.oncia_PrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar15;
    };
    $java.oncia_PrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar15 = $x$1;
    };
    $java.oncia_PrivilegeCommand_immutableKeywordOrEmptyString = function($this, $immutable) {
        if (!$immutable)
            return $rt_s(3);
        return $rt_s(1830);
    };
    $java.oncia_PrivilegeCommand_nanError = function($this, $l) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1831), $l.$position120);
    };
    $java.oncia_PrivilegeCommand_checkExpression = function($this, $expression) {
        var var$2, $l, var$4, $items, var$6, $pk, $e, var$9, $l_0, var$11, $p;
        a: {
            var$2 = 0;
            $l = null;
            var$4 = 0;
            $items = null;
            var$6 = 0;
            $pk = null;
            if ($expression instanceof oncie_Not) {
                $e = oncie_Not_rhs($expression);
                if ($rt_isInstance($e, $java.oncie_BooleanExpression)) {
                    $e = $e;
                    break a;
                }
            }
            $e = $expression;
        }
        var$9 = $e instanceof oncie_Equals;
        if (var$9) {
            var$2 = 1;
            $l = $e;
            $l_0 = $java.oncie_Equals_rhs($l);
            if ($java.oncie_Equals_lhs($l) instanceof oncie_Property && $l_0 instanceof oncie_NaN)
                return $java.oncia_PrivilegeCommand_nanError($this, $l_0);
        }
        var$11 = $e instanceof oncie_NotEquals;
        if (var$11) {
            var$4 = 1;
            $items = $e;
            $l_0 = $java.oncie_NotEquals_rhs($items);
            if ($java.oncie_NotEquals_lhs($items) instanceof oncie_Property && $l_0 instanceof oncie_NaN)
                return $java.oncia_PrivilegeCommand_nanError($this, $l_0);
        }
        if (var$2) {
            $p = $java.oncie_Equals_lhs($l);
            $l = $java.oncie_Equals_rhs($l);
            if ($p instanceof oncie_Property) {
                $l_0 = $p;
                if ($l instanceof oncie_Null) {
                    $expression = $l;
                    $l = $java.oncie_PropertyKeyName_name(oncie_Property_propertyKey($l_0));
                    $e = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append($e, $l), $rt_s(1832));
                    return $java.oncia_PrivilegeCommand_error($this, jl_StringBuilder_toString($e), $java.oncie_Null_position($expression));
                }
            }
        }
        if (var$4) {
            $p = $java.oncie_NotEquals_lhs($items);
            $l = $java.oncie_NotEquals_rhs($items);
            if ($p instanceof oncie_Property) {
                $l_0 = $p;
                if ($l instanceof oncie_Null) {
                    $expression = $l;
                    $l = $java.oncie_PropertyKeyName_name(oncie_Property_propertyKey($l_0));
                    $e = jl_StringBuilder__init_1();
                    jl_StringBuilder_append(jl_StringBuilder_append($e, $l), $rt_s(1833));
                    return $java.oncia_PrivilegeCommand_error($this, jl_StringBuilder_toString($e), $java.oncie_Null_position($expression));
                }
            }
        }
        var$2 = $e instanceof oncie_MapExpression;
        if (var$2) {
            var$6 = 1;
            $pk = $e;
            if (sc_AbstractSeq_size(oncie_MapExpression_items($pk)) > 1)
                return $java.oncia_PrivilegeCommand_error($this, $rt_s(1834), $java.oncie_MapExpression_position($pk));
        }
        if (var$6) {
            $l = oncie_MapExpression_items($pk);
            if ($l !== null) {
                s_package$_$callClinit();
                $l = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $l);
                if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l)) {
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l));
                    $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                    if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 1)) {
                        $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        $l = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 0);
                        if ($l !== null) {
                            $pk = s_Tuple2__1($l);
                            $l = s_Tuple2__2($l);
                            if ($pk !== null && $l instanceof oncie_Null) {
                                $expression = $l;
                                $l = $java.oncie_PropertyKeyName_name($pk);
                                $e = jl_StringBuilder__init_1();
                                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append4($e, 123), $l), $rt_s(1835));
                                return $java.oncia_PrivilegeCommand_error($this, jl_StringBuilder_toString($e), $java.oncie_Null_position($expression));
                            }
                        }
                    }
                }
            }
        }
        b: {
            if (var$9) {
                $l = $e;
                if ($java.oncie_Equals_lhs($l) instanceof oncie_Property && $rt_isInstance($java.oncie_Equals_rhs($l), oncie_Literal)) {
                    var$2 = 1;
                    break b;
                }
            }
            if (var$11) {
                $l = $e;
                if ($java.oncie_NotEquals_lhs($l) instanceof oncie_Property && $rt_isInstance($java.oncie_NotEquals_rhs($l), oncie_Literal)) {
                    var$2 = 1;
                    break b;
                }
            }
            if (var$9) {
                $l = $e;
                if ($java.oncie_Equals_lhs($l) instanceof oncie_Property && $java.oncie_Equals_rhs($l) instanceof oncie_ExplicitParameter) {
                    var$2 = 1;
                    break b;
                }
            }
            if (var$11) {
                $l = $e;
                if ($java.oncie_NotEquals_lhs($l) instanceof oncie_Property && $java.oncie_NotEquals_rhs($l) instanceof oncie_ExplicitParameter) {
                    var$2 = 1;
                    break b;
                }
            }
            var$4 = $e instanceof oncie_In;
            if (var$4) {
                $l = $e;
                $l_0 = $java.oncie_In_rhs($l);
                if ($java.oncie_In_lhs($l) instanceof oncie_Property && $l_0 instanceof oncie_ListLiteral) {
                    $l = oncie_ListLiteral_expressions($l_0);
                    if ($l !== null) {
                        s_package$_$callClinit();
                        $l = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $l);
                        if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l)) {
                            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l));
                            $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 1)) {
                                $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                if ($rt_isInstance($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 0), oncie_Literal)) {
                                    var$2 = 1;
                                    break b;
                                }
                            }
                        }
                    }
                }
            }
            if (var$4) {
                $l = $e;
                $l_0 = $java.oncie_In_rhs($l);
                if ($java.oncie_In_lhs($l) instanceof oncie_Property && $l_0 instanceof oncie_ListLiteral) {
                    $l = oncie_ListLiteral_expressions($l_0);
                    if ($l !== null) {
                        s_package$_$callClinit();
                        $l = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $l);
                        if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l)) {
                            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l));
                            $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 1)) {
                                $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                if ($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 0) instanceof oncie_ExplicitParameter) {
                                    var$2 = 1;
                                    break b;
                                }
                            }
                        }
                    }
                }
            }
            if (var$4) {
                $l = $e;
                if ($java.oncie_In_lhs($l) instanceof oncie_Property && $java.oncie_In_rhs($l) instanceof oncie_ExplicitParameter) {
                    var$2 = 1;
                    break b;
                }
            }
            var$4 = $e instanceof oncie_Not;
            if (var$4) {
                $l = oncie_Not_rhs($e);
                if ($l instanceof oncie_In) {
                    $l = $l;
                    $l_0 = $java.oncie_In_rhs($l);
                    if ($java.oncie_In_lhs($l) instanceof oncie_Property && $l_0 instanceof oncie_ListLiteral) {
                        $l = oncie_ListLiteral_expressions($l_0);
                        if ($l !== null) {
                            s_package$_$callClinit();
                            $l = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $l);
                            if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l)) {
                                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l));
                                $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 1)) {
                                    $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                    if ($rt_isInstance($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 0), oncie_Literal)) {
                                        var$2 = 1;
                                        break b;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (var$4) {
                $l = oncie_Not_rhs($e);
                if ($l instanceof oncie_In) {
                    $l = $l;
                    $l_0 = $java.oncie_In_rhs($l);
                    if ($java.oncie_In_lhs($l) instanceof oncie_Property && $l_0 instanceof oncie_ListLiteral) {
                        $l = oncie_ListLiteral_expressions($l_0);
                        if ($l !== null) {
                            s_package$_$callClinit();
                            $l = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $l);
                            if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l)) {
                                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l));
                                $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 1)) {
                                    $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                    if ($java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 0) instanceof oncie_ExplicitParameter) {
                                        var$2 = 1;
                                        break b;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (var$4) {
                $l = oncie_Not_rhs($e);
                if ($l instanceof oncie_In) {
                    $l = $l;
                    if ($java.oncie_In_lhs($l) instanceof oncie_Property && $java.oncie_In_rhs($l) instanceof oncie_ExplicitParameter) {
                        var$2 = 1;
                        break b;
                    }
                }
            }
            if ($e instanceof oncie_IsNull && oncie_IsNull_lhs($e) instanceof oncie_Property)
                var$2 = 1;
            else if ($e instanceof oncie_IsNotNull && oncie_IsNotNull_lhs($e) instanceof oncie_Property)
                var$2 = 1;
            else {
                if (var$2) {
                    $l = oncie_MapExpression_items($e);
                    if ($l !== null) {
                        s_package$_$callClinit();
                        $l = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $l);
                        if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l)) {
                            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l));
                            $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 1)) {
                                $l_0 = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                $l = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($l_0, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($l_0, $l), 0);
                                if ($l !== null && s_Tuple2__1($l) !== null && $rt_isInstance(s_Tuple2__2($l), oncie_Literal)) {
                                    var$2 = 1;
                                    break b;
                                }
                            }
                        }
                    }
                }
                if (var$2) {
                    $l = oncie_MapExpression_items($e);
                    if ($l !== null) {
                        s_package$_$callClinit();
                        $l = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $l);
                        if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l)) {
                            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $l));
                            $e = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($e, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($e, $l), 1)) {
                                $e = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                $l = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($e, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($e, $l), 0);
                                if ($l !== null && s_Tuple2__1($l) !== null && s_Tuple2__2($l) instanceof oncie_ExplicitParameter) {
                                    var$2 = 1;
                                    break b;
                                }
                            }
                        }
                    }
                }
                var$2 = 0;
            }
        }
        if (var$2)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        $l = onciap_DefaultExpressionStringifier_apply(onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0__init_(), onciap_ExpressionStringifier$_apply$default$2(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$3(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$4(onciap_ExpressionStringifier$_MODULE$), onciap_ExpressionStringifier$_apply$default$5(onciap_ExpressionStringifier$_MODULE$)),
        $expression);
        $e = jl_StringBuilder__init_1();
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($e, $rt_s(1836)), $l), $rt_s(1837));
        return $java.oncia_PrivilegeCommand_error($this, jl_StringBuilder_toString($e), $expression.$position2());
    };
    $java.oncia_PrivilegeCommand_semanticCheck = function($this) {
        var $showSettingFeatureCheck, var$2, $u, var$4, var$5;
        a: {
            $showSettingFeatureCheck = $this.$privilege1;
            if ($showSettingFeatureCheck instanceof oncia_DbmsPrivilege) {
                var$2 = $showSettingFeatureCheck.$action1;
                if (jl_Object_equals(oncia_ShowSettingAction$_MODULE$, var$2)) {
                    $showSettingFeatureCheck = $this.$name3();
                    var$2 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$2);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(1069)), $showSettingFeatureCheck), $rt_s(1070));
                    $showSettingFeatureCheck = oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, jl_AbstractStringBuilder_toString(var$2), oncias_SemanticFeature$ShowSetting$_MODULE$, $this.$position119);
                    break a;
                }
            }
            $showSettingFeatureCheck = oncias_SemanticCheck$_success;
        }
        b: {
            var$2 = $this.$privilege1;
            if (var$2 instanceof oncia_DbmsPrivilege) {
                $u = var$2.$action1;
                if ($rt_isInstance($u, $java.oncia_UnassignableAction)) {
                    $showSettingFeatureCheck = $u.$name3();
                    var$2 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$2);
                    jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(1838)), $showSettingFeatureCheck), 96);
                    $showSettingFeatureCheck = oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$2), $this.$position119);
                    break b;
                }
            }
            if (var$2 instanceof oncia_GraphPrivilege && var$2.$scope5 instanceof oncia_DefaultGraphScope)
                $showSettingFeatureCheck = oncias_SemanticAnalysisTooling_error$($this, $rt_s(1839), $this.$position119);
            else if (var$2 instanceof oncia_DatabasePrivilege && var$2.$scope6 instanceof oncia_DefaultDatabaseScope)
                $showSettingFeatureCheck = oncias_SemanticAnalysisTooling_error$($this, $rt_s(1840), $this.$position119);
            else if (!(var$2 instanceof oncia_LoadPrivilege)) {
                var$2 = oncias_SemanticCheck_chain$($showSettingFeatureCheck, oncia_AdministrationCommand_semanticCheck$($this));
                oncias_SemanticState$_$callClinit();
                $showSettingFeatureCheck = oncias_SemanticCheck_chain$(var$2, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
            } else {
                var$4 = 0;
                $showSettingFeatureCheck = null;
                var$2 = $this.$qualifier1;
                if (var$2 instanceof sci_$colon$colon) {
                    var$4 = 1;
                    $showSettingFeatureCheck = var$2;
                    if ($showSettingFeatureCheck.$head0 instanceof oncia_LoadCidrQualifier) {
                        $showSettingFeatureCheck = oncias_SemanticAnalysisTooling_error$($this, $rt_s(1841), $this.$position119);
                        break b;
                    }
                }
                if (var$4 && $showSettingFeatureCheck.$head0 instanceof oncia_LoadUrlQualifier)
                    $showSettingFeatureCheck = oncias_SemanticAnalysisTooling_error$($this, $rt_s(1842), $this.$position119);
                else {
                    $showSettingFeatureCheck = oncia_AdministrationCommand_semanticCheck$($this);
                    oncias_SemanticState$_$callClinit();
                    $showSettingFeatureCheck = oncias_SemanticCheck_chain$($showSettingFeatureCheck, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
                }
            }
        }
        var$2 = $this.$qualifier1;
        var$5 = oncias_SemanticCheck$_success;
        $u = new $java.oncia_PrivilegeCommand$privilegeQualifierCheckForPropertyRules$lambda$_61_0;
        $u.$_0412 = $this;
        return $showSettingFeatureCheck.$chain(sc_LinearSeqOps_foldLeft$(var$2, var$5, $u));
    };
    $java.oncia_PrivilegeCommand_dup0 = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_PrivilegeCommand_withGraph0 = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_PrivilegeCommand__init_ = function($this, $privilege, $qualifier, $position) {
        $this.$privilege1 = $privilege;
        $this.$qualifier1 = $qualifier;
        $this.$position119 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
        $privilege = $this.$name3();
        $qualifier = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($qualifier);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($qualifier, $rt_s(1069)), $privilege), $rt_s(1070));
        $this.$featureCheck = oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, jl_AbstractStringBuilder_toString($qualifier), oncias_SemanticFeature$PropertyValueAccessRules$_MODULE$, $position);
    };
    function oncia_DenyPrivilege() {
        var a = this; $java.oncia_PrivilegeCommand.call(a);
        a.$privilege2 = null;
        a.$immutable0 = 0;
        a.$resource1 = null;
        a.$qualifier2 = null;
        a.$roleNames0 = null;
        a.$position121 = null;
    }
    function oncia_DenyPrivilege__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_DenyPrivilege();
        $java.oncia_DenyPrivilege__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    function oncia_DenyPrivilege_privilege($this) {
        return $this.$privilege2;
    }
    function oncia_DenyPrivilege_resource($this) {
        return $this.$resource1;
    }
    function oncia_DenyPrivilege_qualifier($this) {
        return $this.$qualifier2;
    }
    function oncia_DenyPrivilege_roleNames($this) {
        return $this.$roleNames0;
    }
    $java.oncia_DenyPrivilege_position = function($this) {
        return $this.$position121;
    };
    function oncia_DenyPrivilege_name($this) {
        var var$1, var$2, var$3;
        var$1 = $java.oncia_PrivilegeCommand_immutableKeywordOrEmptyString($this, $this.$immutable0);
        var$2 = $this.$privilege2.$name46;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$1 = jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(554)), var$1);
        jl_AbstractStringBuilder_append(var$1, 32);
        jl_StringBuilder_append(var$1, var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    $java.oncia_DenyPrivilege_semanticCheck = function($this) {
        var var$1, var$2;
        var$1 = $this.$privilege2;
        if (var$1 instanceof oncia_GraphPrivilege) {
            var$2 = var$1.$action0;
            if (jl_Object_equals(oncia_MergeAdminAction$_MODULE$, var$2))
                return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1843), $this.$position121);
        }
        return $java.oncia_PrivilegeCommand_semanticCheck($this);
    };
    $java.oncia_DenyPrivilege_productPrefix = function($this) {
        return $rt_s(1844);
    };
    $java.oncia_DenyPrivilege_productArity = function($this) {
        return 5;
    };
    $java.oncia_DenyPrivilege_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$privilege2;
            case 1:
                return jl_Boolean_valueOf($this.$immutable0);
            case 2:
                return $this.$resource1;
            case 3:
                return $this.$qualifier2;
            case 4:
                return $this.$roleNames0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DenyPrivilege_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DenyPrivilege_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1844))), sr_Statics_anyHash($this.$privilege2)), !$this.$immutable0 ? 1237 : 1231), sr_Statics_anyHash($this.$resource1)), sr_Statics_anyHash($this.$qualifier2)), sr_Statics_anyHash($this.$roleNames0)), 5);
    };
    $java.oncia_DenyPrivilege_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DenyPrivilege_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DenyPrivilege) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$immutable0 != $x$1.$immutable0)
                            break b;
                        d: {
                            var$2 = $this.$privilege2;
                            var$3 = $x$1.$privilege2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$resource1;
                            var$3 = $x$1.$resource1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$qualifier2;
                            var$3 = $x$1.$qualifier2;
                            if (var$2 !== null) {
                                if (!sci_List_equals(var$2, var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$roleNames0;
                        $x$1 = $x$1.$roleNames0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DenyPrivilege__init_ = function($this, $privilege, $immutable, $resource, $qualifier, $roleNames, $position) {
        $this.$privilege2 = $privilege;
        $this.$immutable0 = $immutable;
        $this.$resource1 = $resource;
        $this.$qualifier2 = $qualifier;
        $this.$roleNames0 = $roleNames;
        $this.$position121 = $position;
        $java.oncia_PrivilegeCommand__init_($this, $privilege, $qualifier, $position);
    };
    var onciafn_Neo4jASTFactory$denyPrivilege$lambda$_178_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$denyPrivilege$lambda$_178_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_EnableServer() {
        var a = this; jl_Object.call(a);
        a.$serverName0 = null;
        a.$optionsMap0 = null;
        a.$position122 = null;
        a.$isReadOnly15 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar16 = null;
    }
    function oncia_EnableServer__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_EnableServer();
        $java.oncia_EnableServer__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_EnableServer_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_EnableServer_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_EnableServer_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_EnableServer_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_EnableServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly15 = $x$1;
    };
    $java.oncia_EnableServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar16;
    };
    $java.oncia_EnableServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar16 = $x$1;
    };
    function oncia_EnableServer_serverName($this) {
        return $this.$serverName0;
    }
    function oncia_EnableServer_optionsMap($this) {
        return $this.$optionsMap0;
    }
    $java.oncia_EnableServer_position = function($this) {
        return $this.$position122;
    };
    function oncia_EnableServer_name($this) {
        return $rt_s(1845);
    }
    $java.oncia_EnableServer_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_EnableServer_productPrefix = function($this) {
        return $rt_s(1846);
    };
    $java.oncia_EnableServer_productArity = function($this) {
        return 2;
    };
    $java.oncia_EnableServer_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$serverName0;
            case 1:
                return $this.$optionsMap0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_EnableServer_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_EnableServer_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_EnableServer_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_EnableServer_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_EnableServer) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$serverName0;
                            var$3 = $x$1.$serverName0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$optionsMap0;
                        $x$1 = $x$1.$optionsMap0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_EnableServer_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_EnableServer_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_EnableServer__init_ = function($this, $serverName, $optionsMap, $position) {
        $this.$serverName0 = $serverName;
        $this.$optionsMap0 = $optionsMap;
        $this.$position122 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_StartDatabase() {
        var a = this; jl_Object.call(a);
        a.$dbName1 = null;
        a.$waitUntilComplete2 = null;
        a.$position123 = null;
        a.$isReadOnly16 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar17 = null;
    }
    function oncia_StartDatabase__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_StartDatabase();
        $java.oncia_StartDatabase__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_StartDatabase_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_StartDatabase_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_StartDatabase_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_StartDatabase_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_StartDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly16 = $x$1;
    };
    $java.oncia_StartDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar17;
    };
    $java.oncia_StartDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar17 = $x$1;
    };
    function oncia_StartDatabase_dbName($this) {
        return $this.$dbName1;
    }
    function oncia_StartDatabase_waitUntilComplete($this) {
        return $this.$waitUntilComplete2;
    }
    $java.oncia_StartDatabase_position = function($this) {
        return $this.$position123;
    };
    function oncia_StartDatabase_name($this) {
        return $rt_s(1847);
    }
    $java.oncia_StartDatabase_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_StartDatabase_productPrefix = function($this) {
        return $rt_s(1848);
    };
    $java.oncia_StartDatabase_productArity = function($this) {
        return 2;
    };
    $java.oncia_StartDatabase_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$dbName1;
            case 1:
                return $this.$waitUntilComplete2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_StartDatabase_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StartDatabase_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StartDatabase_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StartDatabase_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_StartDatabase) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$dbName1;
                            var$3 = $x$1.$dbName1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$waitUntilComplete2;
                        $x$1 = $x$1.$waitUntilComplete2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_StartDatabase_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_StartDatabase_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_StartDatabase__init_ = function($this, $dbName, $waitUntilComplete, $position) {
        $this.$dbName1 = $dbName;
        $this.$waitUntilComplete2 = $waitUntilComplete;
        $this.$position123 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_StopDatabase() {
        var a = this; jl_Object.call(a);
        a.$dbName2 = null;
        a.$waitUntilComplete3 = null;
        a.$position124 = null;
        a.$isReadOnly17 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar18 = null;
    }
    function oncia_StopDatabase__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_StopDatabase();
        $java.oncia_StopDatabase__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_StopDatabase_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_StopDatabase_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_StopDatabase_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_StopDatabase_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_StopDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly17 = $x$1;
    };
    $java.oncia_StopDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar18;
    };
    $java.oncia_StopDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar18 = $x$1;
    };
    function oncia_StopDatabase_dbName($this) {
        return $this.$dbName2;
    }
    function oncia_StopDatabase_waitUntilComplete($this) {
        return $this.$waitUntilComplete3;
    }
    $java.oncia_StopDatabase_position = function($this) {
        return $this.$position124;
    };
    function oncia_StopDatabase_name($this) {
        return $rt_s(1849);
    }
    $java.oncia_StopDatabase_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_StopDatabase_productPrefix = function($this) {
        return $rt_s(1850);
    };
    $java.oncia_StopDatabase_productArity = function($this) {
        return 2;
    };
    $java.oncia_StopDatabase_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$dbName2;
            case 1:
                return $this.$waitUntilComplete3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_StopDatabase_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StopDatabase_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StopDatabase_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StopDatabase_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_StopDatabase) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$dbName2;
                            var$3 = $x$1.$dbName2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$waitUntilComplete3;
                        $x$1 = $x$1.$waitUntilComplete3;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_StopDatabase_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_StopDatabase_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_StopDatabase__init_ = function($this, $dbName, $waitUntilComplete, $position) {
        $this.$dbName2 = $dbName;
        $this.$waitUntilComplete3 = $waitUntilComplete;
        $this.$position124 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    var oncia_ShowAliases$ = $rt_classWithoutFields();
    var oncia_ShowAliases$_MODULE$ = null;
    function oncia_ShowAliases$__clinit_() {
        oncia_ShowAliases$_MODULE$ = new oncia_ShowAliases$;
    }
    function oncia_ShowAliases$_apply($this, $aliasName, $yieldOrWhere, $position) {
        var var$4, var$5, var$6, var$7, var$8, $showColumns, var$10;
        s_package$_$callClinit();
        var$4 = s_package$_List0(s_package$_MODULE$);
        var$5 = sr_ScalaRunTime$_MODULE$;
        var$6 = $rt_createArray(s_Tuple2, 8);
        var$7 = var$6.data;
        var$8 = new s_Tuple2;
        $showColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0(var$8, oncia_ShowColumn$_apply($showColumns, $rt_s(537), oncia_ShowColumn$_apply$default$2($showColumns), $position), jl_Boolean_valueOf(1));
        var$7[0] = var$8;
        var$10 = new s_Tuple2;
        var$8 = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0(var$10, oncia_ShowColumn$_apply(var$8, $rt_s(1851), oncia_ShowColumn$_apply$default$2(var$8), $position), jl_Boolean_valueOf(1));
        var$7[1] = var$10;
        $showColumns = new s_Tuple2;
        var$10 = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($showColumns, oncia_ShowColumn$_apply(var$10, $rt_s(1852), oncia_ShowColumn$_apply$default$2(var$10), $position), jl_Boolean_valueOf(1));
        var$7[2] = $showColumns;
        $showColumns = new s_Tuple2;
        var$10 = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($showColumns, oncia_ShowColumn$_apply(var$10, $rt_s(1853), oncia_ShowColumn$_apply$default$2(var$10), $position), jl_Boolean_valueOf(1));
        var$7[3] = $showColumns;
        $showColumns = new s_Tuple2;
        var$10 = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($showColumns, oncia_ShowColumn$_apply(var$10, $rt_s(1854), oncia_ShowColumn$_apply$default$2(var$10), $position), jl_Boolean_valueOf(1));
        var$7[4] = $showColumns;
        $showColumns = new s_Tuple2;
        var$10 = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($showColumns, oncia_ShowColumn$_apply(var$10, $rt_s(933), oncia_ShowColumn$_apply$default$2(var$10), $position), jl_Boolean_valueOf(1));
        var$7[5] = $showColumns;
        $showColumns = new s_Tuple2;
        var$10 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        s_Tuple2__init_0($showColumns, oncia_ShowColumn$_apply(var$10, $rt_s(1855), oncius_package$_CTMap(oncius_package$_MODULE$), $position), jl_Boolean_valueOf(0));
        var$7[6] = $showColumns;
        var$7[7] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(541), oncius_package$_CTMap(oncius_package$_MODULE$), $position), jl_Boolean_valueOf(0));
        $showColumns = var$4.$from0(sr_ScalaRunTime$_wrapRefArray(var$5, var$6));
        return oncia_ShowAliases__init_($aliasName, $yieldOrWhere, $java.oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $showColumns, $yieldOrWhere), $position);
    }
    $java.oncia_ShowIndexType = $rt_classWithoutFields(0);
    var oncia_AllIndexes$ = $rt_classWithoutFields();
    var oncia_AllIndexes$_MODULE$ = null;
    $java.oncia_AllIndexes$_prettyPrint = null;
    $java.oncia_AllIndexes$_description = null;
    function oncia_AllIndexes$__clinit_() {
        oncia_AllIndexes$_MODULE$ = new oncia_AllIndexes$;
        $java.oncia_AllIndexes$_prettyPrint = $rt_s(302);
        $java.oncia_AllIndexes$_description = $rt_s(1856);
    }
    $java.oncia_AllIndexes$_prettyPrint0 = function($this) {
        return $java.oncia_AllIndexes$_prettyPrint;
    };
    $java.oncia_AllIndexes$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllIndexes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllIndexes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllIndexes$_hashCode = function($this) {
        return 1032870975;
    };
    $java.oncia_AllIndexes$_toString = function($this) {
        return $rt_s(1857);
    };
    var oncia_ShowIndexesClause$ = $rt_classWithoutFields();
    var oncia_ShowIndexesClause$_MODULE$ = null;
    function oncia_ShowIndexesClause$__clinit_() {
        oncia_ShowIndexesClause$_MODULE$ = new oncia_ShowIndexesClause$;
    }
    function oncia_ShowIndexesClause$_apply($this, $indexType, $brief, $verbose, $where, $hasYield, $position) {
        var var$7, var$8, var$9, var$10, var$11, $briefCols, $verboseCols, var$14, var$15, var$16, var$17, var$18;
        s_package$_$callClinit();
        var$7 = s_package$_List0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncia_ShowColumn, 12);
        var$10 = var$9.data;
        var$11 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        var$10[0] = oncia_ShowColumn$_apply(var$11, $rt_s(94), oncius_package$_CTInteger(oncius_package$_MODULE$), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        var$10[1] = oncia_ShowColumn$_apply(var$11, $rt_s(537), oncia_ShowColumn$_apply$default$2(var$11), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        var$10[2] = oncia_ShowColumn$_apply(var$11, $rt_s(1858), oncia_ShowColumn$_apply$default$2(var$11), $position);
        var$10[3] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(1859), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        var$10[4] = oncia_ShowColumn$_apply(var$11, $rt_s(538), oncia_ShowColumn$_apply$default$2(var$11), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        var$10[5] = oncia_ShowColumn$_apply(var$11, $rt_s(539), oncia_ShowColumn$_apply$default$2(var$11), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        $briefCols = oncius_package$_MODULE$;
        var$10[6] = oncia_ShowColumn$_apply(var$11, $rt_s(540), oncius_package$_CTList($briefCols, oncius_package$_CTString($briefCols)), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        $briefCols = oncius_package$_MODULE$;
        var$10[7] = oncia_ShowColumn$_apply(var$11, $rt_s(541), oncius_package$_CTList($briefCols, oncius_package$_CTString($briefCols)), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        var$10[8] = oncia_ShowColumn$_apply(var$11, $rt_s(1860), oncia_ShowColumn$_apply$default$2(var$11), $position);
        var$11 = oncia_ShowColumn$_MODULE$;
        var$10[9] = oncia_ShowColumn$_apply(var$11, $rt_s(1861), oncia_ShowColumn$_apply$default$2(var$11), $position);
        var$10[10] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(1862), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $position);
        var$10[11] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(1863), oncius_package$_CTInteger(oncius_package$_MODULE$), $position);
        $briefCols = var$7.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9));
        $verboseCols = new sci_$colon$colon;
        var$14 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(1864), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $position);
        var$7 = new sci_$colon$colon;
        var$15 = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(544), oncius_package$_CTMap(oncius_package$_MODULE$), $position);
        var$16 = new sci_$colon$colon;
        var$11 = oncia_ShowColumn$_MODULE$;
        var$17 = oncia_ShowColumn$_apply(var$11, $rt_s(1865), oncia_ShowColumn$_apply$default$2(var$11), $position);
        var$18 = new sci_$colon$colon;
        var$11 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$18, oncia_ShowColumn$_apply(var$11, $rt_s(545), oncia_ShowColumn$_apply$default$2(var$11), $position), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$16, var$17, var$18);
        sci_$colon$colon__init_0(var$7, var$15, var$16);
        sci_$colon$colon__init_0($verboseCols, var$14, var$7);
        return $java.oncia_ShowIndexesClause__init_(oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $hasYield, $briefCols, $briefCols.$concat0($verboseCols)), $indexType, $brief, $verbose, $where, $hasYield, $position);
    }
    var oncia_BtreeIndexes$ = $rt_classWithoutFields();
    var oncia_BtreeIndexes$_MODULE$ = null;
    $java.oncia_BtreeIndexes$_prettyPrint = null;
    $java.oncia_BtreeIndexes$_description = null;
    function oncia_BtreeIndexes$__clinit_() {
        oncia_BtreeIndexes$_MODULE$ = new oncia_BtreeIndexes$;
        $java.oncia_BtreeIndexes$_prettyPrint = $rt_s(1432);
        $java.oncia_BtreeIndexes$_description = $rt_s(1866);
    }
    $java.oncia_BtreeIndexes$_prettyPrint0 = function($this) {
        return $java.oncia_BtreeIndexes$_prettyPrint;
    };
    $java.oncia_BtreeIndexes$_productArity = function($this) {
        return 0;
    };
    $java.oncia_BtreeIndexes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_BtreeIndexes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_BtreeIndexes$_hashCode = function($this) {
        return (-1912249856);
    };
    $java.oncia_BtreeIndexes$_toString = function($this) {
        return $rt_s(1867);
    };
    var oncia_RangeIndexes$ = $rt_classWithoutFields();
    var oncia_RangeIndexes$_MODULE$ = null;
    $java.oncia_RangeIndexes$_prettyPrint = null;
    $java.oncia_RangeIndexes$_description = null;
    function oncia_RangeIndexes$__clinit_() {
        oncia_RangeIndexes$_MODULE$ = new oncia_RangeIndexes$;
        $java.oncia_RangeIndexes$_prettyPrint = $rt_s(1433);
        $java.oncia_RangeIndexes$_description = $rt_s(1868);
    }
    $java.oncia_RangeIndexes$_prettyPrint0 = function($this) {
        return $java.oncia_RangeIndexes$_prettyPrint;
    };
    $java.oncia_RangeIndexes$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RangeIndexes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RangeIndexes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RangeIndexes$_hashCode = function($this) {
        return 1401523491;
    };
    $java.oncia_RangeIndexes$_toString = function($this) {
        return $rt_s(1869);
    };
    var oncia_FulltextIndexes$ = $rt_classWithoutFields();
    var oncia_FulltextIndexes$_MODULE$ = null;
    $java.oncia_FulltextIndexes$_prettyPrint = null;
    $java.oncia_FulltextIndexes$_description = null;
    function oncia_FulltextIndexes$__clinit_() {
        oncia_FulltextIndexes$_MODULE$ = new oncia_FulltextIndexes$;
        $java.oncia_FulltextIndexes$_prettyPrint = $rt_s(1434);
        $java.oncia_FulltextIndexes$_description = $rt_s(1870);
    }
    $java.oncia_FulltextIndexes$_prettyPrint0 = function($this) {
        return $java.oncia_FulltextIndexes$_prettyPrint;
    };
    $java.oncia_FulltextIndexes$_productArity = function($this) {
        return 0;
    };
    $java.oncia_FulltextIndexes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_FulltextIndexes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_FulltextIndexes$_hashCode = function($this) {
        return (-329739004);
    };
    $java.oncia_FulltextIndexes$_toString = function($this) {
        return $rt_s(1871);
    };
    var oncia_TextIndexes$ = $rt_classWithoutFields();
    var oncia_TextIndexes$_MODULE$ = null;
    $java.oncia_TextIndexes$_prettyPrint = null;
    $java.oncia_TextIndexes$_description = null;
    function oncia_TextIndexes$__clinit_() {
        oncia_TextIndexes$_MODULE$ = new oncia_TextIndexes$;
        $java.oncia_TextIndexes$_prettyPrint = $rt_s(1436);
        $java.oncia_TextIndexes$_description = $rt_s(1872);
    }
    $java.oncia_TextIndexes$_prettyPrint0 = function($this) {
        return $java.oncia_TextIndexes$_prettyPrint;
    };
    $java.oncia_TextIndexes$_productArity = function($this) {
        return 0;
    };
    $java.oncia_TextIndexes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_TextIndexes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TextIndexes$_hashCode = function($this) {
        return (-1523742989);
    };
    $java.oncia_TextIndexes$_toString = function($this) {
        return $rt_s(1873);
    };
    var oncia_PointIndexes$ = $rt_classWithoutFields();
    var oncia_PointIndexes$_MODULE$ = null;
    $java.oncia_PointIndexes$_prettyPrint = null;
    $java.oncia_PointIndexes$_description = null;
    function oncia_PointIndexes$__clinit_() {
        oncia_PointIndexes$_MODULE$ = new oncia_PointIndexes$;
        $java.oncia_PointIndexes$_prettyPrint = $rt_s(1437);
        $java.oncia_PointIndexes$_description = $rt_s(1874);
    }
    $java.oncia_PointIndexes$_prettyPrint0 = function($this) {
        return $java.oncia_PointIndexes$_prettyPrint;
    };
    $java.oncia_PointIndexes$_productArity = function($this) {
        return 0;
    };
    $java.oncia_PointIndexes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_PointIndexes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PointIndexes$_hashCode = function($this) {
        return (-951485072);
    };
    $java.oncia_PointIndexes$_toString = function($this) {
        return $rt_s(1875);
    };
    var oncia_LookupIndexes$ = $rt_classWithoutFields();
    var oncia_LookupIndexes$_MODULE$ = null;
    $java.oncia_LookupIndexes$_prettyPrint = null;
    $java.oncia_LookupIndexes$_description = null;
    function oncia_LookupIndexes$__clinit_() {
        oncia_LookupIndexes$_MODULE$ = new oncia_LookupIndexes$;
        $java.oncia_LookupIndexes$_prettyPrint = $rt_s(1435);
        $java.oncia_LookupIndexes$_description = $rt_s(1876);
    }
    $java.oncia_LookupIndexes$_prettyPrint0 = function($this) {
        return $java.oncia_LookupIndexes$_prettyPrint;
    };
    $java.oncia_LookupIndexes$_productArity = function($this) {
        return 0;
    };
    $java.oncia_LookupIndexes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LookupIndexes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LookupIndexes$_hashCode = function($this) {
        return (-610293242);
    };
    $java.oncia_LookupIndexes$_toString = function($this) {
        return $rt_s(1877);
    };
    $java.oncia_ShowFunctionType = $rt_classWithoutFields(0);
    var oncia_AllFunctions$ = $rt_classWithoutFields();
    var oncia_AllFunctions$_MODULE$ = null;
    $java.oncia_AllFunctions$_prettyPrint = null;
    $java.oncia_AllFunctions$_description = null;
    function oncia_AllFunctions$__clinit_() {
        oncia_AllFunctions$_MODULE$ = new oncia_AllFunctions$;
        $java.oncia_AllFunctions$_prettyPrint = $rt_s(302);
        $java.oncia_AllFunctions$_description = $rt_s(1878);
    }
    $java.oncia_AllFunctions$_prettyPrint0 = function($this) {
        return $java.oncia_AllFunctions$_prettyPrint;
    };
    $java.oncia_AllFunctions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllFunctions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllFunctions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllFunctions$_hashCode = function($this) {
        return 1117996826;
    };
    $java.oncia_AllFunctions$_toString = function($this) {
        return $rt_s(1879);
    };
    $java.oncia_ExecutableBy = $rt_classWithoutFields(0);
    function oncia_User() {
        jl_Object.call(this);
        this.$name12 = null;
    }
    function oncia_User__init_(var_0) {
        var var_1 = new oncia_User();
        $java.oncia_User__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_User_productPrefix = function($this) {
        return $rt_s(1880);
    };
    $java.oncia_User_productArity = function($this) {
        return 1;
    };
    $java.oncia_User_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name12;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_User_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_User_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_User_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_User_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_User) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name12;
                        $x$1 = $x$1.$name12;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_User))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_User__init_ = function($this, $name) {
        $this.$name12 = $name;
    };
    var oncia_ShowFunctionsClause$ = $rt_classWithoutFields();
    var oncia_ShowFunctionsClause$_MODULE$ = null;
    function oncia_ShowFunctionsClause$__clinit_() {
        oncia_ShowFunctionsClause$_MODULE$ = new oncia_ShowFunctionsClause$;
    }
    function oncia_ShowFunctionsClause$_apply($this, $functionType, $executable, $where, $hasYield, $position) {
        var $briefCols, $verboseCols, var$8, var$9, var$10, var$11, var$12, var$13, var$14;
        $briefCols = new sci_$colon$colon;
        $verboseCols = oncia_ShowColumn$_MODULE$;
        var$8 = oncia_ShowColumn$_apply($verboseCols, $rt_s(537), oncia_ShowColumn$_apply$default$2($verboseCols), $position);
        var$9 = new sci_$colon$colon;
        var$10 = oncia_ShowColumn$_MODULE$;
        var$10 = oncia_ShowColumn$_apply(var$10, $rt_s(1881), oncia_ShowColumn$_apply$default$2(var$10), $position);
        var$11 = new sci_$colon$colon;
        var$12 = oncia_ShowColumn$_MODULE$;
        sci_$colon$colon__init_0(var$11, oncia_ShowColumn$_apply(var$12, $rt_s(559), oncia_ShowColumn$_apply$default$2(var$12), $position), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$9, var$10, var$11);
        sci_$colon$colon__init_0($briefCols, var$8, var$9);
        s_package$_$callClinit();
        $verboseCols = s_package$_List0(s_package$_MODULE$);
        var$12 = sr_ScalaRunTime$_MODULE$;
        var$13 = $rt_createArray(oncia_ShowColumn, 8);
        var$14 = var$13.data;
        var$10 = oncia_ShowColumn$_MODULE$;
        var$14[0] = oncia_ShowColumn$_apply(var$10, $rt_s(1882), oncia_ShowColumn$_apply$default$2(var$10), $position);
        var$8 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        var$14[1] = oncia_ShowColumn$_apply(var$8, $rt_s(1883), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position);
        var$8 = oncia_ShowColumn$_MODULE$;
        var$10 = oncius_package$_MODULE$;
        var$14[2] = oncia_ShowColumn$_apply(var$8, $rt_s(1884), oncius_package$_CTList(var$10, oncius_package$_CTMap(var$10)), $position);
        var$8 = oncia_ShowColumn$_MODULE$;
        var$14[3] = oncia_ShowColumn$_apply(var$8, $rt_s(1885), oncia_ShowColumn$_apply$default$2(var$8), $position);
        var$14[4] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(1886), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position);
        var$8 = oncia_ShowColumn$_MODULE$;
        var$10 = oncius_package$_MODULE$;
        var$14[5] = oncia_ShowColumn$_apply(var$8, $rt_s(1887), oncius_package$_CTList(var$10, oncius_package$_CTString(var$10)), $position);
        var$8 = oncia_ShowColumn$_MODULE$;
        var$10 = oncius_package$_MODULE$;
        var$14[6] = oncia_ShowColumn$_apply(var$8, $rt_s(1888), oncius_package$_CTList(var$10, oncius_package$_CTString(var$10)), $position);
        var$14[7] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(563), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position);
        $verboseCols = $verboseCols.$from0(sr_ScalaRunTime$_wrapRefArray(var$12, var$13));
        return $java.oncia_ShowFunctionsClause__init_(oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $hasYield, $briefCols, $briefCols.$concat0($verboseCols)), $functionType, $executable, $where, $hasYield, $position);
    }
    var oncia_CurrentUser$ = $rt_classWithoutFields();
    var oncia_CurrentUser$_MODULE$ = null;
    function oncia_CurrentUser$__clinit_() {
        oncia_CurrentUser$_MODULE$ = new oncia_CurrentUser$;
    }
    $java.oncia_CurrentUser$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CurrentUser$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CurrentUser$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CurrentUser$_hashCode = function($this) {
        return (-2025824060);
    };
    $java.oncia_CurrentUser$_toString = function($this) {
        return $rt_s(1889);
    };
    var oncia_BuiltInFunctions$ = $rt_classWithoutFields();
    var oncia_BuiltInFunctions$_MODULE$ = null;
    $java.oncia_BuiltInFunctions$_prettyPrint = null;
    $java.oncia_BuiltInFunctions$_description = null;
    function oncia_BuiltInFunctions$__clinit_() {
        oncia_BuiltInFunctions$_MODULE$ = new oncia_BuiltInFunctions$;
        $java.oncia_BuiltInFunctions$_prettyPrint = $rt_s(1493);
        $java.oncia_BuiltInFunctions$_description = $rt_s(1890);
    }
    $java.oncia_BuiltInFunctions$_prettyPrint0 = function($this) {
        return $java.oncia_BuiltInFunctions$_prettyPrint;
    };
    $java.oncia_BuiltInFunctions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_BuiltInFunctions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_BuiltInFunctions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_BuiltInFunctions$_hashCode = function($this) {
        return (-730407240);
    };
    $java.oncia_BuiltInFunctions$_toString = function($this) {
        return $rt_s(1891);
    };
    var oncia_UserDefinedFunctions$ = $rt_classWithoutFields();
    var oncia_UserDefinedFunctions$_MODULE$ = null;
    $java.oncia_UserDefinedFunctions$_prettyPrint = null;
    $java.oncia_UserDefinedFunctions$_description = null;
    function oncia_UserDefinedFunctions$__clinit_() {
        oncia_UserDefinedFunctions$_MODULE$ = new oncia_UserDefinedFunctions$;
        $java.oncia_UserDefinedFunctions$_prettyPrint = $rt_s(1495);
        $java.oncia_UserDefinedFunctions$_description = $rt_s(1892);
    }
    $java.oncia_UserDefinedFunctions$_prettyPrint0 = function($this) {
        return $java.oncia_UserDefinedFunctions$_prettyPrint;
    };
    $java.oncia_UserDefinedFunctions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_UserDefinedFunctions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UserDefinedFunctions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserDefinedFunctions$_hashCode = function($this) {
        return (-566890083);
    };
    $java.oncia_UserDefinedFunctions$_toString = function($this) {
        return $rt_s(1893);
    };
    $java.oncia_ShowConstraintType = $rt_classWithoutFields(0);
    var oncia_AllConstraints$ = $rt_classWithoutFields();
    var oncia_AllConstraints$_MODULE$ = null;
    $java.oncia_AllConstraints$_output = null;
    $java.oncia_AllConstraints$_prettyPrint = null;
    $java.oncia_AllConstraints$_description = null;
    function oncia_AllConstraints$__clinit_() {
        oncia_AllConstraints$_MODULE$ = new oncia_AllConstraints$;
        $java.oncia_AllConstraints$_output = $rt_s(302);
        $java.oncia_AllConstraints$_prettyPrint = $rt_s(302);
        $java.oncia_AllConstraints$_description = $rt_s(1894);
    }
    $java.oncia_AllConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_AllConstraints$_prettyPrint;
    };
    $java.oncia_AllConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllConstraints$_hashCode = function($this) {
        return 992870901;
    };
    $java.oncia_AllConstraints$_toString = function($this) {
        return $rt_s(1895);
    };
    var oncia_ShowConstraintsClause$ = $rt_classWithoutFields();
    $java.oncia_ShowConstraintsClause$_MODULE$ = null;
    function oncia_ShowConstraintsClause$__clinit_() {
        $java.oncia_ShowConstraintsClause$_MODULE$ = new oncia_ShowConstraintsClause$;
    }
    var oncia_UniqueConstraints$ = $rt_classWithoutFields();
    var oncia_UniqueConstraints$_MODULE$ = null;
    $java.oncia_UniqueConstraints$_output = null;
    $java.oncia_UniqueConstraints$_prettyPrint = null;
    $java.oncia_UniqueConstraints$_description = null;
    function oncia_UniqueConstraints$__clinit_() {
        oncia_UniqueConstraints$_MODULE$ = new oncia_UniqueConstraints$;
        $java.oncia_UniqueConstraints$_output = $rt_s(1896);
        $java.oncia_UniqueConstraints$_prettyPrint = $rt_s(1896);
        $java.oncia_UniqueConstraints$_description = $rt_s(1897);
    }
    $java.oncia_UniqueConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_UniqueConstraints$_prettyPrint;
    };
    $java.oncia_UniqueConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_UniqueConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UniqueConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UniqueConstraints$_hashCode = function($this) {
        return 1368794501;
    };
    $java.oncia_UniqueConstraints$_toString = function($this) {
        return $rt_s(1898);
    };
    var oncia_NodeUniqueConstraints$ = $rt_classWithoutFields();
    var oncia_NodeUniqueConstraints$_MODULE$ = null;
    $java.oncia_NodeUniqueConstraints$_output = null;
    $java.oncia_NodeUniqueConstraints$_prettyPrint = null;
    $java.oncia_NodeUniqueConstraints$_description = null;
    function oncia_NodeUniqueConstraints$__clinit_() {
        oncia_NodeUniqueConstraints$_MODULE$ = new oncia_NodeUniqueConstraints$;
        $java.oncia_NodeUniqueConstraints$_output = $rt_s(1896);
        $java.oncia_NodeUniqueConstraints$_prettyPrint = $rt_s(1899);
        $java.oncia_NodeUniqueConstraints$_description = $rt_s(1900);
    }
    $java.oncia_NodeUniqueConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_NodeUniqueConstraints$_prettyPrint;
    };
    $java.oncia_NodeUniqueConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_NodeUniqueConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NodeUniqueConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NodeUniqueConstraints$_hashCode = function($this) {
        return 2071546787;
    };
    $java.oncia_NodeUniqueConstraints$_toString = function($this) {
        return $rt_s(1901);
    };
    var oncia_RelUniqueConstraints$ = $rt_classWithoutFields();
    var oncia_RelUniqueConstraints$_MODULE$ = null;
    $java.oncia_RelUniqueConstraints$_output = null;
    $java.oncia_RelUniqueConstraints$_prettyPrint = null;
    $java.oncia_RelUniqueConstraints$_description = null;
    function oncia_RelUniqueConstraints$__clinit_() {
        oncia_RelUniqueConstraints$_MODULE$ = new oncia_RelUniqueConstraints$;
        $java.oncia_RelUniqueConstraints$_output = $rt_s(1902);
        $java.oncia_RelUniqueConstraints$_prettyPrint = $rt_s(1903);
        $java.oncia_RelUniqueConstraints$_description = $rt_s(1904);
    }
    $java.oncia_RelUniqueConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_RelUniqueConstraints$_prettyPrint;
    };
    $java.oncia_RelUniqueConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RelUniqueConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RelUniqueConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelUniqueConstraints$_hashCode = function($this) {
        return (-1791965652);
    };
    $java.oncia_RelUniqueConstraints$_toString = function($this) {
        return $rt_s(1905);
    };
    var oncia_KeyConstraints$ = $rt_classWithoutFields();
    var oncia_KeyConstraints$_MODULE$ = null;
    $java.oncia_KeyConstraints$_output = null;
    $java.oncia_KeyConstraints$_prettyPrint = null;
    $java.oncia_KeyConstraints$_description = null;
    function oncia_KeyConstraints$__clinit_() {
        oncia_KeyConstraints$_MODULE$ = new oncia_KeyConstraints$;
        $java.oncia_KeyConstraints$_output = $rt_s(1466);
        $java.oncia_KeyConstraints$_prettyPrint = $rt_s(1466);
        $java.oncia_KeyConstraints$_description = $rt_s(1906);
    }
    $java.oncia_KeyConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_KeyConstraints$_prettyPrint;
    };
    $java.oncia_KeyConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_KeyConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_KeyConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_KeyConstraints$_hashCode = function($this) {
        return (-330818953);
    };
    $java.oncia_KeyConstraints$_toString = function($this) {
        return $rt_s(1907);
    };
    var oncia_NodeKeyConstraints$ = $rt_classWithoutFields();
    var oncia_NodeKeyConstraints$_MODULE$ = null;
    $java.oncia_NodeKeyConstraints$_output = null;
    $java.oncia_NodeKeyConstraints$_prettyPrint = null;
    $java.oncia_NodeKeyConstraints$_description = null;
    function oncia_NodeKeyConstraints$__clinit_() {
        oncia_NodeKeyConstraints$_MODULE$ = new oncia_NodeKeyConstraints$;
        $java.oncia_NodeKeyConstraints$_output = $rt_s(1446);
        $java.oncia_NodeKeyConstraints$_prettyPrint = $rt_s(1467);
        $java.oncia_NodeKeyConstraints$_description = $rt_s(1908);
    }
    $java.oncia_NodeKeyConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_NodeKeyConstraints$_prettyPrint;
    };
    $java.oncia_NodeKeyConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_NodeKeyConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NodeKeyConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NodeKeyConstraints$_hashCode = function($this) {
        return 1525537049;
    };
    $java.oncia_NodeKeyConstraints$_toString = function($this) {
        return $rt_s(1909);
    };
    var oncia_RelKeyConstraints$ = $rt_classWithoutFields();
    var oncia_RelKeyConstraints$_MODULE$ = null;
    $java.oncia_RelKeyConstraints$_output = null;
    $java.oncia_RelKeyConstraints$_prettyPrint = null;
    $java.oncia_RelKeyConstraints$_description = null;
    function oncia_RelKeyConstraints$__clinit_() {
        oncia_RelKeyConstraints$_MODULE$ = new oncia_RelKeyConstraints$;
        $java.oncia_RelKeyConstraints$_output = $rt_s(1468);
        $java.oncia_RelKeyConstraints$_prettyPrint = $rt_s(1910);
        $java.oncia_RelKeyConstraints$_description = $rt_s(1911);
    }
    $java.oncia_RelKeyConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_RelKeyConstraints$_prettyPrint;
    };
    $java.oncia_RelKeyConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RelKeyConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RelKeyConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelKeyConstraints$_hashCode = function($this) {
        return (-1446079696);
    };
    $java.oncia_RelKeyConstraints$_toString = function($this) {
        return $rt_s(1912);
    };
    function oncia_ExistsConstraints() {
        var a = this; jl_Object.call(a);
        a.$syntax = null;
        a.$output = null;
        a.$prettyPrint0 = null;
        a.$description3 = null;
    }
    function oncia_ExistsConstraints__init_(var_0) {
        var var_1 = new oncia_ExistsConstraints();
        $java.oncia_ExistsConstraints__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_ExistsConstraints_prettyPrint = function($this) {
        return $this.$prettyPrint0;
    };
    $java.oncia_ExistsConstraints_productPrefix = function($this) {
        return $rt_s(1913);
    };
    $java.oncia_ExistsConstraints_productArity = function($this) {
        return 1;
    };
    $java.oncia_ExistsConstraints_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$syntax;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ExistsConstraints_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExistsConstraints_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExistsConstraints_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExistsConstraints_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ExistsConstraints) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$syntax;
                        $x$1 = $x$1.$syntax;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ExistsConstraints))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ExistsConstraints__init_ = function($this, $syntax) {
        $this.$syntax = $syntax;
        $this.$output = $rt_s(1914);
        $this.$prettyPrint0 = $rt_s(1915);
        $this.$description3 = $rt_s(1916);
    };
    $java.oncia_ExistenceConstraintSyntax = $rt_classWithoutFields(0);
    var oncia_ValidSyntax$ = $rt_classWithoutFields();
    var oncia_ValidSyntax$_MODULE$ = null;
    function oncia_ValidSyntax$__clinit_() {
        oncia_ValidSyntax$_MODULE$ = new oncia_ValidSyntax$;
    }
    $java.oncia_ValidSyntax$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ValidSyntax$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ValidSyntax$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ValidSyntax$_hashCode = function($this) {
        return (-78617889);
    };
    $java.oncia_ValidSyntax$_toString = function($this) {
        return $rt_s(1917);
    };
    var oncia_RemovedSyntax$ = $rt_classWithoutFields();
    var oncia_RemovedSyntax$_MODULE$ = null;
    function oncia_RemovedSyntax$__clinit_() {
        oncia_RemovedSyntax$_MODULE$ = new oncia_RemovedSyntax$;
    }
    $java.oncia_RemovedSyntax$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RemovedSyntax$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RemovedSyntax$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemovedSyntax$_hashCode = function($this) {
        return 1377212483;
    };
    $java.oncia_RemovedSyntax$_toString = function($this) {
        return $rt_s(1918);
    };
    function oncia_NodeExistsConstraints() {
        var a = this; jl_Object.call(a);
        a.$syntax0 = null;
        a.$output0 = null;
        a.$prettyPrint1 = null;
        a.$description4 = null;
    }
    function oncia_NodeExistsConstraints__init_(var_0) {
        var var_1 = new oncia_NodeExistsConstraints();
        $java.oncia_NodeExistsConstraints__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_NodeExistsConstraints_prettyPrint = function($this) {
        return $this.$prettyPrint1;
    };
    $java.oncia_NodeExistsConstraints_productPrefix = function($this) {
        return $rt_s(1919);
    };
    $java.oncia_NodeExistsConstraints_productArity = function($this) {
        return 1;
    };
    $java.oncia_NodeExistsConstraints_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$syntax0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NodeExistsConstraints_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NodeExistsConstraints_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NodeExistsConstraints_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NodeExistsConstraints_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_NodeExistsConstraints) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$syntax0;
                        $x$1 = $x$1.$syntax0;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_NodeExistsConstraints))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_NodeExistsConstraints__init_ = function($this, $syntax) {
        $this.$syntax0 = $syntax;
        $this.$output0 = $rt_s(1920);
        $this.$prettyPrint1 = $rt_s(1921);
        $this.$description4 = $rt_s(1922);
    };
    function oncia_RelExistsConstraints() {
        var a = this; jl_Object.call(a);
        a.$syntax1 = null;
        a.$output1 = null;
        a.$prettyPrint2 = null;
        a.$description5 = null;
    }
    function oncia_RelExistsConstraints__init_(var_0) {
        var var_1 = new oncia_RelExistsConstraints();
        $java.oncia_RelExistsConstraints__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_RelExistsConstraints_prettyPrint = function($this) {
        return $this.$prettyPrint2;
    };
    $java.oncia_RelExistsConstraints_productPrefix = function($this) {
        return $rt_s(1923);
    };
    $java.oncia_RelExistsConstraints_productArity = function($this) {
        return 1;
    };
    $java.oncia_RelExistsConstraints_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$syntax1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RelExistsConstraints_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelExistsConstraints_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelExistsConstraints_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelExistsConstraints_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_RelExistsConstraints) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$syntax1;
                        $x$1 = $x$1.$syntax1;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_RelExistsConstraints))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_RelExistsConstraints__init_ = function($this, $syntax) {
        $this.$syntax1 = $syntax;
        $this.$output1 = $rt_s(1924);
        $this.$prettyPrint2 = $rt_s(1925);
        $this.$description5 = $rt_s(1926);
    };
    var oncia_PropTypeConstraints$ = $rt_classWithoutFields();
    var oncia_PropTypeConstraints$_MODULE$ = null;
    $java.oncia_PropTypeConstraints$_output = null;
    $java.oncia_PropTypeConstraints$_prettyPrint = null;
    $java.oncia_PropTypeConstraints$_description = null;
    function oncia_PropTypeConstraints$__clinit_() {
        oncia_PropTypeConstraints$_MODULE$ = new oncia_PropTypeConstraints$;
        $java.oncia_PropTypeConstraints$_output = $rt_s(1487);
        $java.oncia_PropTypeConstraints$_prettyPrint = $rt_s(1487);
        $java.oncia_PropTypeConstraints$_description = $rt_s(1927);
    }
    $java.oncia_PropTypeConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_PropTypeConstraints$_prettyPrint;
    };
    $java.oncia_PropTypeConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_PropTypeConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_PropTypeConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PropTypeConstraints$_hashCode = function($this) {
        return 462364825;
    };
    $java.oncia_PropTypeConstraints$_toString = function($this) {
        return $rt_s(1928);
    };
    var oncia_NodePropTypeConstraints$ = $rt_classWithoutFields();
    var oncia_NodePropTypeConstraints$_MODULE$ = null;
    $java.oncia_NodePropTypeConstraints$_output = null;
    $java.oncia_NodePropTypeConstraints$_prettyPrint = null;
    $java.oncia_NodePropTypeConstraints$_description = null;
    function oncia_NodePropTypeConstraints$__clinit_() {
        oncia_NodePropTypeConstraints$_MODULE$ = new oncia_NodePropTypeConstraints$;
        $java.oncia_NodePropTypeConstraints$_output = $rt_s(1929);
        $java.oncia_NodePropTypeConstraints$_prettyPrint = $rt_s(1489);
        $java.oncia_NodePropTypeConstraints$_description = $rt_s(1930);
    }
    $java.oncia_NodePropTypeConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_NodePropTypeConstraints$_prettyPrint;
    };
    $java.oncia_NodePropTypeConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_NodePropTypeConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NodePropTypeConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NodePropTypeConstraints$_hashCode = function($this) {
        return 1497446199;
    };
    $java.oncia_NodePropTypeConstraints$_toString = function($this) {
        return $rt_s(1931);
    };
    var oncia_RelPropTypeConstraints$ = $rt_classWithoutFields();
    var oncia_RelPropTypeConstraints$_MODULE$ = null;
    $java.oncia_RelPropTypeConstraints$_output = null;
    $java.oncia_RelPropTypeConstraints$_prettyPrint = null;
    $java.oncia_RelPropTypeConstraints$_description = null;
    function oncia_RelPropTypeConstraints$__clinit_() {
        oncia_RelPropTypeConstraints$_MODULE$ = new oncia_RelPropTypeConstraints$;
        $java.oncia_RelPropTypeConstraints$_output = $rt_s(1932);
        $java.oncia_RelPropTypeConstraints$_prettyPrint = $rt_s(1933);
        $java.oncia_RelPropTypeConstraints$_description = $rt_s(1934);
    }
    $java.oncia_RelPropTypeConstraints$_prettyPrint0 = function($this) {
        return $java.oncia_RelPropTypeConstraints$_prettyPrint;
    };
    $java.oncia_RelPropTypeConstraints$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RelPropTypeConstraints$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RelPropTypeConstraints$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelPropTypeConstraints$_hashCode = function($this) {
        return (-486263936);
    };
    $java.oncia_RelPropTypeConstraints$_toString = function($this) {
        return $rt_s(1935);
    };
    var oncia_ShowCurrentUser$ = $rt_classWithoutFields();
    $java.oncia_ShowCurrentUser$_MODULE$ = null;
    function oncia_ShowCurrentUser$__clinit_() {
        $java.oncia_ShowCurrentUser$_MODULE$ = new oncia_ShowCurrentUser$;
    }
    function oncia_SingleNamedDatabaseScope() {
        var a = this; jl_Object.call(a);
        a.$database0 = null;
        a.$position125 = null;
        a.$showCommandName = null;
    }
    function oncia_SingleNamedDatabaseScope__init_(var_0, var_1) {
        var var_2 = new oncia_SingleNamedDatabaseScope();
        $java.oncia_SingleNamedDatabaseScope__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncia_SingleNamedDatabaseScope_database($this) {
        return $this.$database0;
    }
    $java.oncia_SingleNamedDatabaseScope_productPrefix = function($this) {
        return $rt_s(1936);
    };
    $java.oncia_SingleNamedDatabaseScope_productArity = function($this) {
        return 1;
    };
    $java.oncia_SingleNamedDatabaseScope_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$database0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SingleNamedDatabaseScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleNamedDatabaseScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleNamedDatabaseScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SingleNamedDatabaseScope_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SingleNamedDatabaseScope) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$database0;
                        $x$1 = $x$1.$database0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SingleNamedDatabaseScope_dup = function($this, $children) {
        return oncia_SingleNamedDatabaseScope__init_($children.$head(), $this.$position125);
    };
    $java.oncia_SingleNamedDatabaseScope__init_ = function($this, $database, $position) {
        $this.$database0 = $database;
        $this.$position125 = $position;
        $this.$showCommandName = $rt_s(1088);
    };
    function oncia_DefaultDatabaseScope() {
        var a = this; jl_Object.call(a);
        a.$position126 = null;
        a.$showCommandName0 = null;
    }
    function oncia_DefaultDatabaseScope__init_(var_0) {
        var var_1 = new oncia_DefaultDatabaseScope();
        $java.oncia_DefaultDatabaseScope__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_DefaultDatabaseScope_productPrefix = function($this) {
        return $rt_s(1937);
    };
    $java.oncia_DefaultDatabaseScope_productArity = function($this) {
        return 0;
    };
    $java.oncia_DefaultDatabaseScope_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DefaultDatabaseScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultDatabaseScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultDatabaseScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultDatabaseScope_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_DefaultDatabaseScope))
            return 0;
        return 1;
    };
    $java.oncia_DefaultDatabaseScope_dup = function($this, $children) {
        return $this;
    };
    $java.oncia_DefaultDatabaseScope__init_ = function($this, $position) {
        $this.$position126 = $position;
        $this.$showCommandName0 = $rt_s(1938);
    };
    function oncia_AllDatabasesScope() {
        var a = this; jl_Object.call(a);
        a.$position127 = null;
        a.$showCommandName1 = null;
    }
    function oncia_AllDatabasesScope__init_(var_0) {
        var var_1 = new oncia_AllDatabasesScope();
        $java.oncia_AllDatabasesScope__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_AllDatabasesScope_productPrefix = function($this) {
        return $rt_s(1939);
    };
    $java.oncia_AllDatabasesScope_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllDatabasesScope_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllDatabasesScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabasesScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabasesScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabasesScope_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_AllDatabasesScope))
            return 0;
        return 1;
    };
    $java.oncia_AllDatabasesScope_dup = function($this, $children) {
        return $this;
    };
    $java.oncia_AllDatabasesScope__init_ = function($this, $position) {
        $this.$position127 = $position;
        $this.$showCommandName1 = $rt_s(1940);
    };
    function oncia_HomeDatabaseScope() {
        var a = this; jl_Object.call(a);
        a.$position128 = null;
        a.$showCommandName2 = null;
    }
    function oncia_HomeDatabaseScope__init_(var_0) {
        var var_1 = new oncia_HomeDatabaseScope();
        $java.oncia_HomeDatabaseScope__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_HomeDatabaseScope_productPrefix = function($this) {
        return $rt_s(1941);
    };
    $java.oncia_HomeDatabaseScope_productArity = function($this) {
        return 0;
    };
    $java.oncia_HomeDatabaseScope_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_HomeDatabaseScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_HomeDatabaseScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_HomeDatabaseScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_HomeDatabaseScope_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_HomeDatabaseScope))
            return 0;
        return 1;
    };
    $java.oncia_HomeDatabaseScope_dup = function($this, $children) {
        return $this;
    };
    $java.oncia_HomeDatabaseScope__init_ = function($this, $position) {
        $this.$position128 = $position;
        $this.$showCommandName2 = $rt_s(1942);
    };
    var oncia_ShowDatabase$ = $rt_classWithoutFields();
    var oncia_ShowDatabase$_MODULE$ = null;
    $java.oncia_ShowDatabase$_NAME_COL = null;
    $java.oncia_ShowDatabase$_ALIASES_COL = null;
    $java.oncia_ShowDatabase$_TYPE_COL = null;
    $java.oncia_ShowDatabase$_ACCESS_COL = null;
    $java.oncia_ShowDatabase$_DATABASE_ID_COL = null;
    $java.oncia_ShowDatabase$_SERVER_ID_COL = null;
    $java.oncia_ShowDatabase$_ADDRESS_COL = null;
    $java.oncia_ShowDatabase$_ROLE_COL = null;
    $java.oncia_ShowDatabase$_WRITER_COL = null;
    $java.oncia_ShowDatabase$_CURRENT_STATUS_COL = null;
    $java.oncia_ShowDatabase$_REQUESTED_STATUS_COL = null;
    $java.oncia_ShowDatabase$_STATUS_MSG_COL = null;
    $java.oncia_ShowDatabase$_DEFAULT_COL = null;
    $java.oncia_ShowDatabase$_HOME_COL = null;
    $java.oncia_ShowDatabase$_CURRENT_PRIMARIES_COUNT_COL = null;
    $java.oncia_ShowDatabase$_CURRENT_SECONDARIES_COUNT_COL = null;
    $java.oncia_ShowDatabase$_REQUESTED_PRIMARIES_COUNT_COL = null;
    $java.oncia_ShowDatabase$_REQUESTED_SECONDARIES_COUNT_COL = null;
    $java.oncia_ShowDatabase$_CREATION_TIME_COL = null;
    $java.oncia_ShowDatabase$_LAST_START_TIME_COL = null;
    $java.oncia_ShowDatabase$_LAST_STOP_TIME_COL = null;
    $java.oncia_ShowDatabase$_STORE_COL = null;
    $java.oncia_ShowDatabase$_LAST_COMMITTED_TX_COL = null;
    $java.oncia_ShowDatabase$_REPLICATION_LAG_COL = null;
    $java.oncia_ShowDatabase$_CONSTITUENTS_COL = null;
    $java.oncia_ShowDatabase$_OPTIONS_COL = null;
    function oncia_ShowDatabase$__clinit_() {
        oncia_ShowDatabase$_MODULE$ = new oncia_ShowDatabase$;
        $java.oncia_ShowDatabase$_NAME_COL = $rt_s(537);
        $java.oncia_ShowDatabase$_ALIASES_COL = $rt_s(1943);
        $java.oncia_ShowDatabase$_TYPE_COL = $rt_s(538);
        $java.oncia_ShowDatabase$_ACCESS_COL = $rt_s(1944);
        $java.oncia_ShowDatabase$_DATABASE_ID_COL = $rt_s(1945);
        $java.oncia_ShowDatabase$_SERVER_ID_COL = $rt_s(1946);
        $java.oncia_ShowDatabase$_ADDRESS_COL = $rt_s(1947);
        $java.oncia_ShowDatabase$_ROLE_COL = $rt_s(925);
        $java.oncia_ShowDatabase$_WRITER_COL = $rt_s(1948);
        $java.oncia_ShowDatabase$_CURRENT_STATUS_COL = $rt_s(1949);
        $java.oncia_ShowDatabase$_REQUESTED_STATUS_COL = $rt_s(1950);
        $java.oncia_ShowDatabase$_STATUS_MSG_COL = $rt_s(1951);
        $java.oncia_ShowDatabase$_DEFAULT_COL = $rt_s(1952);
        $java.oncia_ShowDatabase$_HOME_COL = $rt_s(937);
        $java.oncia_ShowDatabase$_CURRENT_PRIMARIES_COUNT_COL = $rt_s(1953);
        $java.oncia_ShowDatabase$_CURRENT_SECONDARIES_COUNT_COL = $rt_s(1954);
        $java.oncia_ShowDatabase$_REQUESTED_PRIMARIES_COUNT_COL = $rt_s(1955);
        $java.oncia_ShowDatabase$_REQUESTED_SECONDARIES_COUNT_COL = $rt_s(1956);
        $java.oncia_ShowDatabase$_CREATION_TIME_COL = $rt_s(1957);
        $java.oncia_ShowDatabase$_LAST_START_TIME_COL = $rt_s(1958);
        $java.oncia_ShowDatabase$_LAST_STOP_TIME_COL = $rt_s(1959);
        $java.oncia_ShowDatabase$_STORE_COL = $rt_s(1960);
        $java.oncia_ShowDatabase$_LAST_COMMITTED_TX_COL = $rt_s(1961);
        $java.oncia_ShowDatabase$_REPLICATION_LAG_COL = $rt_s(1962);
        $java.oncia_ShowDatabase$_CONSTITUENTS_COL = $rt_s(1963);
        $java.oncia_ShowDatabase$_OPTIONS_COL = $rt_s(544);
    }
    $java.oncia_ShowDatabase$_NAME_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_NAME_COL;
    };
    $java.oncia_ShowDatabase$_ALIASES_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_ALIASES_COL;
    };
    $java.oncia_ShowDatabase$_TYPE_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_TYPE_COL;
    };
    $java.oncia_ShowDatabase$_ACCESS_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_ACCESS_COL;
    };
    $java.oncia_ShowDatabase$_DATABASE_ID_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_DATABASE_ID_COL;
    };
    $java.oncia_ShowDatabase$_SERVER_ID_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_SERVER_ID_COL;
    };
    $java.oncia_ShowDatabase$_ADDRESS_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_ADDRESS_COL;
    };
    $java.oncia_ShowDatabase$_ROLE_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_ROLE_COL;
    };
    $java.oncia_ShowDatabase$_WRITER_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_WRITER_COL;
    };
    $java.oncia_ShowDatabase$_CURRENT_STATUS_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_CURRENT_STATUS_COL;
    };
    $java.oncia_ShowDatabase$_REQUESTED_STATUS_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_REQUESTED_STATUS_COL;
    };
    $java.oncia_ShowDatabase$_STATUS_MSG_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_STATUS_MSG_COL;
    };
    $java.oncia_ShowDatabase$_DEFAULT_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_DEFAULT_COL;
    };
    $java.oncia_ShowDatabase$_HOME_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_HOME_COL;
    };
    $java.oncia_ShowDatabase$_CURRENT_PRIMARIES_COUNT_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_CURRENT_PRIMARIES_COUNT_COL;
    };
    $java.oncia_ShowDatabase$_CURRENT_SECONDARIES_COUNT_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_CURRENT_SECONDARIES_COUNT_COL;
    };
    $java.oncia_ShowDatabase$_REQUESTED_PRIMARIES_COUNT_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_REQUESTED_PRIMARIES_COUNT_COL;
    };
    $java.oncia_ShowDatabase$_REQUESTED_SECONDARIES_COUNT_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_REQUESTED_SECONDARIES_COUNT_COL;
    };
    $java.oncia_ShowDatabase$_CREATION_TIME_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_CREATION_TIME_COL;
    };
    $java.oncia_ShowDatabase$_LAST_START_TIME_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_LAST_START_TIME_COL;
    };
    $java.oncia_ShowDatabase$_LAST_STOP_TIME_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_LAST_STOP_TIME_COL;
    };
    $java.oncia_ShowDatabase$_STORE_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_STORE_COL;
    };
    $java.oncia_ShowDatabase$_LAST_COMMITTED_TX_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_LAST_COMMITTED_TX_COL;
    };
    $java.oncia_ShowDatabase$_REPLICATION_LAG_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_REPLICATION_LAG_COL;
    };
    $java.oncia_ShowDatabase$_CONSTITUENTS_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_CONSTITUENTS_COL;
    };
    $java.oncia_ShowDatabase$_OPTIONS_COL0 = function($this) {
        return $java.oncia_ShowDatabase$_OPTIONS_COL;
    };
    function oncia_ShowDatabase$_apply($this, $scope, $yieldOrWhere, $position) {
        var var$4, var$5, var$6, var$7, $showColumns, var$9, var$10, var$11, var$12, var$13;
        s_package$_$callClinit();
        var$4 = s_package$_List0(s_package$_MODULE$);
        var$5 = sr_ScalaRunTime$_MODULE$;
        var$6 = $rt_createArray(s_Tuple2, 12);
        var$7 = var$6.data;
        var$7[0] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_NAME_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[1] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_TYPE_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        $showColumns = new s_Tuple2;
        var$9 = oncia_ShowColumn$_MODULE$;
        var$10 = $java.oncia_ShowDatabase$_ALIASES_COL0($this);
        oncius_package$_$callClinit();
        var$11 = oncius_package$_MODULE$;
        s_Tuple2__init_0($showColumns, oncia_ShowColumn$_apply(var$9, var$10, oncius_package$_CTList(var$11, oncius_package$_CTString(var$11)), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[2] = $showColumns;
        var$7[3] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_ACCESS_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[4] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_DATABASE_ID_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[5] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_SERVER_ID_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[6] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_ADDRESS_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[7] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_ROLE_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[8] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_WRITER_COL0($this), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[9] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_REQUESTED_STATUS_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[10] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_CURRENT_STATUS_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[11] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_STATUS_MSG_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$9 = sc_AbstractIterable_$plus$plus(sci_List$_apply(var$4, sr_ScalaRunTime$_wrapRefArray(var$5, var$6)), $scope instanceof oncia_DefaultDatabaseScope ? sci_List$_empty(s_package$_List0(s_package$_MODULE$)) : $scope instanceof oncia_HomeDatabaseScope ? sci_List$_empty(s_package$_List0(s_package$_MODULE$)) : sci_$colon$colon__init_(s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_DEFAULT_COL0($this), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position),
        sr_BoxesRunTime_boxToBoolean(1)), sci_$colon$colon__init_(s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_HOME_COL0($this), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(1)), sci_Nil$_MODULE$)));
        var$10 = s_package$_List0(s_package$_MODULE$);
        var$11 = sr_ScalaRunTime$_MODULE$;
        var$6 = $rt_createArray(s_Tuple2, 12);
        var$7 = var$6.data;
        var$7[0] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_CURRENT_PRIMARIES_COUNT_COL0($this), oncius_package$_CTInteger(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[1] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_CURRENT_SECONDARIES_COUNT_COL0($this), oncius_package$_CTInteger(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[2] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_REQUESTED_PRIMARIES_COUNT_COL0($this), oncius_package$_CTInteger(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[3] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_REQUESTED_SECONDARIES_COUNT_COL0($this), oncius_package$_CTInteger(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[4] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_CREATION_TIME_COL0($this), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[5] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_LAST_START_TIME_COL0($this), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[6] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_LAST_STOP_TIME_COL0($this), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[7] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_STORE_COL0($this), oncia_ShowColumn$_apply$default$2(oncia_ShowColumn$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[8] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_LAST_COMMITTED_TX_COL0($this), oncius_package$_CTInteger(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$7[9] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_REPLICATION_LAG_COL0($this), oncius_package$_CTInteger(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        var$12 = new s_Tuple2;
        var$5 = oncia_ShowColumn$_MODULE$;
        var$4 = $java.oncia_ShowDatabase$_CONSTITUENTS_COL0($this);
        var$13 = oncius_package$_MODULE$;
        s_Tuple2__init_0(var$12, oncia_ShowColumn$_apply(var$5, var$4, oncius_package$_CTList(var$13, oncius_package$_CTString(var$13)), $position), sr_BoxesRunTime_boxToBoolean(1));
        var$7[10] = var$12;
        var$7[11] = s_Tuple2__init_(oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $java.oncia_ShowDatabase$_OPTIONS_COL0($this), oncius_package$_CTMap(oncius_package$_MODULE$), $position), sr_BoxesRunTime_boxToBoolean(0));
        $showColumns = sc_AbstractIterable_$plus$plus(var$9, sci_List$_apply(var$10, sr_ScalaRunTime$_wrapRefArray(var$11, var$6)));
        return oncia_ShowDatabase__init_($scope, $yieldOrWhere, $java.oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $showColumns, $yieldOrWhere), $position);
    }
    var onciafn_Neo4jASTFactory$showDatabase$lambda$_218_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$showDatabase$lambda$_218_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        s_package$_$callClinit();
        return su_Right$_apply(s_package$_Right(s_package$_MODULE$), var$1);
    };
    var oncia_ShowPrivileges$ = $rt_classWithoutFields();
    var oncia_ShowPrivileges$_MODULE$ = null;
    function oncia_ShowPrivileges$__clinit_() {
        oncia_ShowPrivileges$_MODULE$ = new oncia_ShowPrivileges$;
    }
    function oncia_ShowPrivileges$_apply($this, $scope, $yieldOrWhere, $position) {
        var var$4, var$5, var$6, var$7, $columns, var$9, var$10, var$11, var$12, var$13, var$14, var$15, var$16, var$17, var$18, var$19;
        var$4 = new sci_$colon$colon;
        var$5 = oncia_ShowColumn$_MODULE$;
        var$6 = oncia_ShowColumn$_apply(var$5, $rt_s(1944), oncia_ShowColumn$_apply$default$2(var$5), $position);
        var$7 = new sci_$colon$colon;
        $columns = oncia_ShowColumn$_MODULE$;
        var$9 = oncia_ShowColumn$_apply($columns, $rt_s(1964), oncia_ShowColumn$_apply$default$2($columns), $position);
        var$10 = new sci_$colon$colon;
        $columns = oncia_ShowColumn$_MODULE$;
        var$11 = oncia_ShowColumn$_apply($columns, $rt_s(1965), oncia_ShowColumn$_apply$default$2($columns), $position);
        var$12 = new sci_$colon$colon;
        var$5 = oncia_ShowColumn$_MODULE$;
        var$13 = oncia_ShowColumn$_apply(var$5, $rt_s(1966), oncia_ShowColumn$_apply$default$2(var$5), $position);
        var$14 = new sci_$colon$colon;
        var$5 = oncia_ShowColumn$_MODULE$;
        var$15 = oncia_ShowColumn$_apply(var$5, $rt_s(1967), oncia_ShowColumn$_apply$default$2(var$5), $position);
        var$16 = new sci_$colon$colon;
        var$5 = oncia_ShowColumn$_MODULE$;
        var$17 = oncia_ShowColumn$_apply(var$5, $rt_s(925), oncia_ShowColumn$_apply$default$2(var$5), $position);
        var$18 = new sci_$colon$colon;
        var$19 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        sci_$colon$colon__init_0(var$18, oncia_ShowColumn$_apply(var$19, $rt_s(1968), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$16, var$17, var$18);
        sci_$colon$colon__init_0(var$14, var$15, var$16);
        sci_$colon$colon__init_0(var$12, var$13, var$14);
        sci_$colon$colon__init_0(var$10, var$11, var$12);
        sci_$colon$colon__init_0(var$7, var$9, var$10);
        sci_$colon$colon__init_0(var$4, var$6, var$7);
        if (!($scope instanceof oncia_ShowUserPrivileges ? 1 : !($scope instanceof oncia_ShowUsersPrivileges) ? 0 : 1)) {
            s_package$_$callClinit();
            s_package$_List0(s_package$_MODULE$);
            $columns = sci_Nil$_MODULE$;
        } else {
            $columns = new sci_$colon$colon;
            var$5 = oncia_ShowColumn$_MODULE$;
            sci_$colon$colon__init_0($columns, oncia_ShowColumn$_apply(var$5, $rt_s(933), oncia_ShowColumn$_apply$default$2(var$5), $position), sci_Nil$_MODULE$);
        }
        return oncia_ShowPrivileges__init_($scope, $yieldOrWhere, var$4.$concat0($columns), $position);
    }
    $java.oncia_ShowPrivilegeScope = $rt_classWithoutFields(0);
    function oncia_ShowAllPrivileges() {
        jl_Object.call(this);
        this.$position129 = null;
    }
    function oncia_ShowAllPrivileges__init_(var_0) {
        var var_1 = new oncia_ShowAllPrivileges();
        $java.oncia_ShowAllPrivileges__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_ShowAllPrivileges_productPrefix = function($this) {
        return $rt_s(1969);
    };
    $java.oncia_ShowAllPrivileges_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowAllPrivileges_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowAllPrivileges_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowAllPrivileges_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowAllPrivileges_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowAllPrivileges_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_ShowAllPrivileges))
            return 0;
        return 1;
    };
    $java.oncia_ShowAllPrivileges_dup = function($this, $children) {
        return $this;
    };
    $java.oncia_ShowAllPrivileges__init_ = function($this, $position) {
        $this.$position129 = $position;
    };
    var oncia_ShowPrivilegeCommands$ = $rt_classWithoutFields();
    var oncia_ShowPrivilegeCommands$_MODULE$ = null;
    function oncia_ShowPrivilegeCommands$__clinit_() {
        oncia_ShowPrivilegeCommands$_MODULE$ = new oncia_ShowPrivilegeCommands$;
    }
    function oncia_ShowPrivilegeCommands$_apply($this, $scope, $asRevoke, $yieldOrWhere, $position) {
        var $allColumns, var$6, var$7, var$8, var$9;
        $allColumns = new sci_$colon$colon;
        var$6 = new s_Tuple2;
        var$7 = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0(var$6, oncia_ShowColumn$_apply(var$7, $rt_s(1970), oncia_ShowColumn$_apply$default$2(var$7), $position), jl_Boolean_valueOf(1));
        var$7 = new sci_$colon$colon;
        var$8 = new s_Tuple2;
        var$9 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        s_Tuple2__init_0(var$8, oncia_ShowColumn$_apply(var$9, $rt_s(1968), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position), jl_Boolean_valueOf(0));
        sci_$colon$colon__init_0(var$7, var$8, sci_Nil$_MODULE$);
        sci_$colon$colon__init_0($allColumns, var$6, var$7);
        return oncia_ShowPrivilegeCommands__init_($scope, $asRevoke, $yieldOrWhere, ($java.oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $allColumns, $yieldOrWhere)).$columns0, $position);
    }
    var oncia_ShowProceduresClause$ = $rt_classWithoutFields();
    var oncia_ShowProceduresClause$_MODULE$ = null;
    function oncia_ShowProceduresClause$__clinit_() {
        oncia_ShowProceduresClause$_MODULE$ = new oncia_ShowProceduresClause$;
    }
    function oncia_ShowProceduresClause$_apply($this, $executable, $where, $hasYield, $position) {
        var $briefCols, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13, $verboseCols, var$15, var$16;
        $briefCols = new sci_$colon$colon;
        var$6 = oncia_ShowColumn$_MODULE$;
        var$7 = oncia_ShowColumn$_apply(var$6, $rt_s(537), oncia_ShowColumn$_apply$default$2(var$6), $position);
        var$8 = new sci_$colon$colon;
        var$6 = oncia_ShowColumn$_MODULE$;
        var$9 = oncia_ShowColumn$_apply(var$6, $rt_s(559), oncia_ShowColumn$_apply$default$2(var$6), $position);
        var$10 = new sci_$colon$colon;
        var$6 = oncia_ShowColumn$_MODULE$;
        var$11 = oncia_ShowColumn$_apply(var$6, $rt_s(1971), oncia_ShowColumn$_apply$default$2(var$6), $position);
        var$12 = new sci_$colon$colon;
        var$13 = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        sci_$colon$colon__init_0(var$12, oncia_ShowColumn$_apply(var$13, $rt_s(1972), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$10, var$11, var$12);
        sci_$colon$colon__init_0(var$8, var$9, var$10);
        sci_$colon$colon__init_0($briefCols, var$7, var$8);
        s_package$_$callClinit();
        $verboseCols = s_package$_List0(s_package$_MODULE$);
        var$7 = sr_ScalaRunTime$_MODULE$;
        var$15 = $rt_createArray(oncia_ShowColumn, 8);
        var$16 = var$15.data;
        var$6 = oncia_ShowColumn$_MODULE$;
        var$16[0] = oncia_ShowColumn$_apply(var$6, $rt_s(1882), oncia_ShowColumn$_apply$default$2(var$6), $position);
        var$6 = oncia_ShowColumn$_MODULE$;
        var$9 = oncius_package$_MODULE$;
        var$16[1] = oncia_ShowColumn$_apply(var$6, $rt_s(1884), oncius_package$_CTList(var$9, oncius_package$_CTMap(var$9)), $position);
        var$6 = oncia_ShowColumn$_MODULE$;
        var$9 = oncius_package$_MODULE$;
        var$16[2] = oncia_ShowColumn$_apply(var$6, $rt_s(1885), oncius_package$_CTList(var$9, oncius_package$_CTMap(var$9)), $position);
        var$16[3] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(1973), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position);
        var$6 = oncia_ShowColumn$_MODULE$;
        var$9 = oncius_package$_MODULE$;
        var$16[4] = oncia_ShowColumn$_apply(var$6, $rt_s(1887), oncius_package$_CTList(var$9, oncius_package$_CTString(var$9)), $position);
        var$8 = oncia_ShowColumn$_MODULE$;
        var$6 = oncius_package$_MODULE$;
        var$16[5] = oncia_ShowColumn$_apply(var$8, $rt_s(1888), oncius_package$_CTList(var$6, oncius_package$_CTString(var$6)), $position);
        var$16[6] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(563), oncius_package$_CTBoolean(oncius_package$_MODULE$), $position);
        var$16[7] = oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, $rt_s(1974), oncius_package$_CTMap(oncius_package$_MODULE$), $position);
        $verboseCols = $verboseCols.$from0(sr_ScalaRunTime$_wrapRefArray(var$7, var$15));
        return $java.oncia_ShowProceduresClause__init_(oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $hasYield, $briefCols, $briefCols.$concat0($verboseCols)), $executable, $where, $hasYield, $position);
    }
    var oncia_ShowServers$ = $rt_classWithoutFields();
    var oncia_ShowServers$_MODULE$ = null;
    function oncia_ShowServers$__clinit_() {
        oncia_ShowServers$_MODULE$ = new oncia_ShowServers$;
    }
    function oncia_ShowServers$_apply($this, $yieldOrWhere, $position) {
        var var$3, $showColumns, var$5, var$6, $allShowColumns, $briefShowColumns, var$9, var$10, $allColumns;
        s_package$_$callClinit();
        var$3 = s_package$_List0(s_package$_MODULE$);
        $showColumns = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(s_Tuple2, 14);
        var$6 = var$5.data;
        $allShowColumns = new s_Tuple2;
        $briefShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($allShowColumns, oncia_ShowColumn$_apply($briefShowColumns, $rt_s(1975), oncia_ShowColumn$_apply$default$2($briefShowColumns), $position), jl_Boolean_valueOf(0));
        var$6[0] = $allShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(537), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(1));
        var$6[1] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1947), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(1));
        var$6[2] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1976), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(0));
        var$6[3] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1977), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(0));
        var$6[4] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1858), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(1));
        var$6[5] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1978), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(1));
        var$6[6] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        oncius_package$_$callClinit();
        var$9 = oncius_package$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1979), oncius_package$_CTList(var$9, oncius_package$_CTString(var$9)), $position), jl_Boolean_valueOf(1));
        var$6[7] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        var$10 = oncius_package$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1980), oncius_package$_CTList(var$10, oncius_package$_CTString(var$10)), $position), jl_Boolean_valueOf(0));
        var$6[8] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        var$9 = oncius_package$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1981), oncius_package$_CTList(var$9, oncius_package$_CTString(var$9)), $position), jl_Boolean_valueOf(0));
        var$6[9] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        var$9 = oncius_package$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1982), oncius_package$_CTList(var$9, oncius_package$_CTString(var$9)), $position), jl_Boolean_valueOf(0));
        var$6[10] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        var$9 = oncius_package$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1983), oncius_package$_CTList(var$9, oncius_package$_CTString(var$9)), $position), jl_Boolean_valueOf(0));
        var$6[11] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1984), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(0));
        var$6[12] = $briefShowColumns;
        $briefShowColumns = new s_Tuple2;
        $allShowColumns = oncia_ShowColumn$_MODULE$;
        s_Tuple2__init_0($briefShowColumns, oncia_ShowColumn$_apply($allShowColumns, $rt_s(1985), oncia_ShowColumn$_apply$default$2($allShowColumns), $position), jl_Boolean_valueOf(0));
        var$6[13] = $briefShowColumns;
        $showColumns = var$3.$from0(sr_ScalaRunTime$_wrapRefArray($showColumns, var$5));
        $briefShowColumns = sci_List_map(sci_List_filter($showColumns, new $java.oncia_ShowServers$$apply$lambda$_1_0), new $java.oncia_ShowServers$$apply$lambda$_1_1);
        $allShowColumns = sci_List_map($showColumns, new $java.oncia_ShowServers$$apply$lambda$_1_2);
        $allColumns = $yieldOrWhere instanceof s_Some && $yieldOrWhere.$value5 instanceof su_Left ? 1 : 0;
        return oncia_ShowServers__init_($yieldOrWhere, oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $allColumns, $briefShowColumns, $allShowColumns), $position);
    }
    var onciafn_Neo4jASTFactory$showSettingsClause$lambda$_145_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$showSettingsClause$lambda$_145_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$1)));
    };
    var oncia_ShowSettingsClause$ = $rt_classWithoutFields();
    $java.oncia_ShowSettingsClause$_MODULE$ = null;
    function oncia_ShowSettingsClause$__clinit_() {
        $java.oncia_ShowSettingsClause$_MODULE$ = new oncia_ShowSettingsClause$;
    }
    var oncia_ShowSupportedPrivilegeCommand$ = $rt_classWithoutFields();
    $java.oncia_ShowSupportedPrivilegeCommand$_MODULE$ = null;
    var oncia_ShowSupportedPrivilegeCommand$_ACTION = null;
    var oncia_ShowSupportedPrivilegeCommand$_QUALIFIER = null;
    var oncia_ShowSupportedPrivilegeCommand$_TARGET = null;
    var oncia_ShowSupportedPrivilegeCommand$_SCOPE = null;
    var oncia_ShowSupportedPrivilegeCommand$_DESCRIPTION = null;
    function oncia_ShowSupportedPrivilegeCommand$__clinit_() {
        $java.oncia_ShowSupportedPrivilegeCommand$_MODULE$ = new oncia_ShowSupportedPrivilegeCommand$;
        oncia_ShowSupportedPrivilegeCommand$_ACTION = $rt_s(1964);
        oncia_ShowSupportedPrivilegeCommand$_QUALIFIER = $rt_s(1986);
        oncia_ShowSupportedPrivilegeCommand$_TARGET = $rt_s(1987);
        oncia_ShowSupportedPrivilegeCommand$_SCOPE = $rt_s(1988);
        oncia_ShowSupportedPrivilegeCommand$_DESCRIPTION = $rt_s(559);
    }
    var onciafn_Neo4jASTFactory$showTransactionsClause$lambda$_141_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$showTransactionsClause$lambda$_141_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$1)));
    };
    var oncia_ShowTransactionsClause$ = $rt_classWithoutFields();
    var oncia_ShowTransactionsClause$_MODULE$ = null;
    function oncia_ShowTransactionsClause$__clinit_() {
        oncia_ShowTransactionsClause$_MODULE$ = new oncia_ShowTransactionsClause$;
    }
    function oncia_ShowTransactionsClause$_apply($this, $ids, $where, $yieldItems, $yieldAll, $position) {
        var var$6, $columns, var$8, var$9, $briefColumns, $allColumns, var$12;
        s_package$_$callClinit();
        var$6 = s_package$_List0(s_package$_MODULE$);
        $columns = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(s_Tuple2, 39);
        var$9 = var$8.data;
        var$9[0] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1852), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[1] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(564), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[2] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1989), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[3] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1990), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[4] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1991), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[5] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1992), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[6] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(565), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        $briefColumns = new s_Tuple2;
        $allColumns = new oncia_TransactionColumn;
        oncius_package$_$callClinit();
        $java.oncia_TransactionColumn__init_($allColumns, $rt_s(1993), oncius_package$_CTMap(oncius_package$_MODULE$));
        s_Tuple2__init_0($briefColumns, $allColumns, sr_BoxesRunTime_boxToBoolean(0));
        var$9[7] = $briefColumns;
        var$9[8] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1994), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[9] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1995), oncius_package$_CTMap(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[10] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1996), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[11] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1997), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        $briefColumns = new s_Tuple2;
        $allColumns = new oncia_TransactionColumn;
        var$12 = oncius_package$_MODULE$;
        $java.oncia_TransactionColumn__init_($allColumns, $rt_s(568), oncius_package$_CTList(var$12, oncius_package$_CTMap(var$12)));
        s_Tuple2__init_0($briefColumns, $allColumns, sr_BoxesRunTime_boxToBoolean(0));
        var$9[12] = $briefColumns;
        var$9[13] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1998), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[14] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(1999), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[15] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2000), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[16] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2001), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[17] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2002), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[18] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2003), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[19] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2004), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[20] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2005), oncius_package$_CTMap(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[21] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2006), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[22] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2007), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[23] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2008), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(1));
        var$9[24] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2009), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[25] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2010), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[26] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2011), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[27] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2012), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[28] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2013), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[29] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2014), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[30] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2015), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[31] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2016), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[32] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2017), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[33] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2018), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[34] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2019), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[35] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2020), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[36] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2021), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[37] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2022), oncius_package$_CTInteger(oncius_package$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        var$9[38] = s_Tuple2__init_(oncia_TransactionColumn__init_($rt_s(2023), oncia_TransactionColumn$_apply$default$2(oncia_TransactionColumn$_MODULE$)), sr_BoxesRunTime_boxToBoolean(0));
        $columns = sci_List$_apply(var$6, sr_ScalaRunTime$_wrapRefArray($columns, var$8));
        return $java.oncia_ShowTransactionsClause__init_(sci_List_map(sci_List_filter($columns, $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0__init_()), $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1__init_()), sci_List_map($columns, $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2__init_()), $ids, $where, $yieldItems, $yieldAll, $position);
    }
    var onciafn_Neo4jASTFactory$turnYieldToWith$lambda$_144_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$turnYieldToWith$lambda$_144_0_apply = function(var$0, var$1) {
        return var$1.$name3();
    };
    var oncia_ParsedAsYield$ = $rt_classWithoutFields();
    var oncia_ParsedAsYield$_MODULE$ = null;
    function oncia_ParsedAsYield$__clinit_() {
        oncia_ParsedAsYield$_MODULE$ = new oncia_ParsedAsYield$;
    }
    $java.oncia_ParsedAsYield$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ParsedAsYield$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ParsedAsYield$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ParsedAsYield$_hashCode = function($this) {
        return (-925484790);
    };
    $java.oncia_ParsedAsYield$_toString = function($this) {
        return $rt_s(2024);
    };
    var oncia_ShowUsers$ = $rt_classWithoutFields();
    $java.oncia_ShowUsers$_MODULE$ = null;
    function oncia_ShowUsers$__clinit_() {
        $java.oncia_ShowUsers$_MODULE$ = new oncia_ShowUsers$;
    }
    function oncia_ShowRolesPrivileges() {
        var a = this; jl_Object.call(a);
        a.$roles = null;
        a.$position130 = null;
    }
    function oncia_ShowRolesPrivileges__init_(var_0, var_1) {
        var var_2 = new oncia_ShowRolesPrivileges();
        $java.oncia_ShowRolesPrivileges__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_ShowRolesPrivileges_productPrefix = function($this) {
        return $rt_s(2025);
    };
    $java.oncia_ShowRolesPrivileges_productArity = function($this) {
        return 1;
    };
    $java.oncia_ShowRolesPrivileges_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$roles;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowRolesPrivileges_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowRolesPrivileges_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowRolesPrivileges_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowRolesPrivileges_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowRolesPrivileges) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$roles;
                        $x$1 = $x$1.$roles;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ShowRolesPrivileges_dup = function($this, $children) {
        return oncia_ShowRolesPrivileges__init_($children.$head(), $this.$position130);
    };
    $java.oncia_ShowRolesPrivileges__init_ = function($this, $roles, $position) {
        $this.$roles = $roles;
        $this.$position130 = $position;
    };
    var onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    var onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    var oncia_ShowRoles$ = $rt_classWithoutFields();
    $java.oncia_ShowRoles$_MODULE$ = null;
    function oncia_ShowRoles$__clinit_() {
        $java.oncia_ShowRoles$_MODULE$ = new oncia_ShowRoles$;
    }
    var onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$1)));
    };
    var oncia_TerminateTransactionsClause$ = $rt_classWithoutFields();
    $java.oncia_TerminateTransactionsClause$_MODULE$ = null;
    function oncia_TerminateTransactionsClause$__clinit_() {
        $java.oncia_TerminateTransactionsClause$_MODULE$ = new oncia_TerminateTransactionsClause$;
    }
    var onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_1_apply = function(var$0, var$1) {
        return var$1.$position3;
    };
    function onciafn_Neo4jASTFactory$createClause$lambda$_10_0() {
        jl_Object.call(this);
        this.$_0234 = null;
    }
    $java.onciafn_Neo4jASTFactory$createClause$lambda$_10_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0234;
        if ($rt_isInstance(var$1, oncie_NonPrefixedPatternPart))
            return var$1;
        if (!(var$1 instanceof oncie_PatternPartWithSelector))
            $rt_throw(s_MatchError__init_(var$1));
        $rt_throw(onciafn_Neo4jASTFactory_pathSelectorCannotBeUsedInClauseException(var$2, $rt_s(2026), var$1.$selector));
    };
    $java.oncia_UpdateClause = $rt_classWithoutFields(0);
    $java.oncia_UpdateClause_returnVariables$ = function($$this) {
        return oncia_ReturnItems$ReturnVariables$_empty(oncia_ReturnItems$ReturnVariables$_MODULE$);
    };
    $java.oncia_SingleRelTypeCheck = $rt_classWithoutFields(0);
    $java.oncia_SingleRelTypeCheck_checkRelTypes$ = function($$this, $patternPart) {
        return !($patternPart instanceof oncie_PathPatternPart) ? oncias_SemanticCheck$_success : $java.oncia_SingleRelTypeCheck_checkRelTypes($$this, $patternPart.$element2);
    };
    $java.oncia_SingleRelTypeCheck_checkRelTypes = function($this, $patternElement) {
        var $element;
        if (!($patternElement instanceof oncie_RelationshipChain))
            return oncias_SemanticCheck$_success;
        $patternElement = $patternElement;
        $element = $patternElement.$element4;
        return oncias_SemanticCheck_chain$($this.$checkRelTypes0($patternElement.$relationship1), $java.oncia_SingleRelTypeCheck_checkRelTypes($this, $element));
    };
    $java.oncia_SingleRelTypeCheck_checkRelTypes$0 = function($$this, $rel) {
        return $java.oncia_SingleRelTypeCheck_checkRelTypes0($$this, $rel);
    };
    $java.oncia_SingleRelTypeCheck_checkRelTypes0 = function($this, $rel) {
        var var$2, $other, $exampleString, $types, $maybePlain, var$7, var$8;
        var$2 = 0;
        $other = null;
        $exampleString = $rel.$labelExpression2;
        if (jl_Object_equals(s_None$_MODULE$, $exampleString)) {
            $other = oncias_package$_MODULE$;
            $types = new oncias_SemanticError;
            $exampleString = $this.$name3();
            $maybePlain = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($maybePlain);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($maybePlain, $rt_s(2027)), $exampleString), $rt_s(2028));
            oncias_SemanticError__init_($types, jl_AbstractStringBuilder_toString($maybePlain), $rel.$position32);
            return oncias_package$_liftSemanticErrorDef($other, $types);
        }
        if ($exampleString instanceof s_Some) {
            var$2 = 1;
            $other = $exampleString;
            $types = $other.$value5;
            if ($types instanceof oncil_LabelExpression$Leaf && $types.$name8 instanceof oncie_RelTypeName)
                return oncias_SemanticCheck$_success;
        }
        if (!var$2)
            $rt_throw(s_MatchError__init_($exampleString));
        $types = sc_SeqOps_distinct$($other.$value5.$flatten0());
        if ($types.$length() != 1)
            $exampleString = s_Tuple2__init_($rt_s(3), $rt_s(3));
        else {
            $exampleString = new s_Tuple2;
            $types = ($types.$head()).$name3();
            $maybePlain = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($maybePlain);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($maybePlain, $rt_s(2029)), $types), $rt_s(2030));
            s_Tuple2__init_0($exampleString, $rt_s(2031), jl_AbstractStringBuilder_toString($maybePlain));
        }
        $maybePlain = $exampleString.$_10;
        $exampleString = $exampleString.$_20;
        $other = s_Tuple2__init_($maybePlain, $exampleString);
        $maybePlain = $other.$_10;
        $exampleString = $other.$_20;
        $other = oncias_package$_MODULE$;
        $types = new oncias_SemanticError;
        var$7 = $this.$name3();
        var$8 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$8);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$8, $rt_s(2032)), $maybePlain), $rt_s(2033)), $exampleString), $rt_s(2034)), var$7);
        oncias_SemanticError__init_($types, jl_AbstractStringBuilder_toString(var$8), $rel.$position32);
        return oncias_package$_liftSemanticErrorDef($other, $types);
    };
    function oncia_Create() {
        var a = this; jl_Object.call(a);
        a.$pattern = null;
        a.$position131 = null;
        a.$LabelExpressionsPartition$module5 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier5 = null;
        a.$SetExtractor$module5 = null;
    }
    $java.oncia_Create__init_ = function(var_0, var_1) {
        var var_2 = new oncia_Create();
        oncia_Create__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_Create_checkRelTypes = function($this, $rel) {
        return $java.oncia_SingleRelTypeCheck_checkRelTypes$0($this, $rel);
    };
    $java.oncia_Create_returnVariables = function($this) {
        return $java.oncia_UpdateClause_returnVariables$($this);
    };
    $java.oncia_Create_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Create_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Create_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Create_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Create_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Create_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module5 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module5 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module5 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module5;
    };
    $java.oncia_Create_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier5;
    };
    $java.oncia_Create_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module5 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module5 !== null)
                        break a;
                    $this.$SetExtractor$module5 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module5;
    };
    $java.oncia_Create_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier5 = $x$1;
    };
    $java.oncia_Create_position = function($this) {
        return $this.$position131;
    };
    $java.oncia_Create_name = function($this) {
        return $rt_s(2026);
    };
    $java.oncia_Create_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2, var$3, var$4;
        oncias_SemanticPatternCheck$_$callClinit();
        var$1 = $java.oncias_SemanticPatternCheck$_check(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Create$_MODULE$, $this.$pattern);
        var$2 = $this.$pattern;
        var$3 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$4 = var$2.$patternParts0;
        var$2 = new $java.oncia_SingleRelTypeCheck$checkRelTypes$lambda$_3_0;
        var$2.$_0413 = $this;
        var$3 = oncias_SemanticCheck_chain$(var$1, $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$3, var$4, var$2));
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this.$pattern));
    };
    $java.oncia_Create_shouldRunGpmChecks = function($this) {
        return 0;
    };
    $java.oncia_Create_productPrefix = function($this) {
        return $rt_s(2035);
    };
    $java.oncia_Create_productArity = function($this) {
        return 1;
    };
    $java.oncia_Create_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$pattern;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Create_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Create_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Create_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Create_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Create) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$pattern;
                        $x$1 = $x$1.$pattern;
                        if (var$2 !== null) {
                            if (!$java.oncie_Pattern$ForUpdate_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Create))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_Create_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncia_Create__init_($this, $pattern, $position) {
        $this.$pattern = $pattern;
        $this.$position131 = $position;
        oncia_Clause_$init$($this);
    }
    $java.oncie_Pattern = $rt_classWithoutFields(0);
    $java.oncie_Pattern_length$ = function($$this) {
        return sr_BoxesRunTime_unboxToInt(onciu_Foldable$Folder_fold(onciu_Foldable_folder$($$this), jl_Integer_valueOf(0), new $java.oncie_Pattern$$anonfun$length$1));
    };
    function oncie_Pattern$ForUpdate() {
        var a = this; jl_Object.call(a);
        a.$patternParts0 = null;
        a.$position132 = null;
    }
    $java.oncie_Pattern$ForUpdate__init_ = function(var_0, var_1) {
        var var_2 = new oncie_Pattern$ForUpdate();
        oncie_Pattern$ForUpdate__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncie_Pattern$ForUpdate_foldedOver = function($this) {
        return $this;
    };
    $java.oncie_Pattern$ForUpdate_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncie_Pattern$ForUpdate_patternParts = function($this) {
        return $this.$patternParts0;
    };
    $java.oncie_Pattern$ForUpdate_position = function($this) {
        return $this.$position132;
    };
    $java.oncie_Pattern$ForUpdate_productPrefix = function($this) {
        return $rt_s(2036);
    };
    $java.oncie_Pattern$ForUpdate_productArity = function($this) {
        return 1;
    };
    $java.oncie_Pattern$ForUpdate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$patternParts0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Pattern$ForUpdate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$ForUpdate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$ForUpdate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$ForUpdate_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncie_Pattern$ForUpdate) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$patternParts0;
                        $x$1 = $x$1.$patternParts0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_Pattern$ForUpdate_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncie_Pattern$ForUpdate__init_($this, $patternParts, $position) {
        $this.$patternParts0 = $patternParts;
        $this.$position132 = $position;
    }
    var onciafn_Neo4jASTFactory$createClause$lambda$_10_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createClause$lambda$_10_1_apply = function(var$0, var$1) {
        return var$1.$position2();
    };
    var onciafn_Neo4jASTFactory$createClause$lambda$_10_2 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$createClause$lambda$_10_2_apply = function(var$0, var$1) {
        return jl_Integer_valueOf(var$1.$offset0);
    };
    function oncia_Delete() {
        var a = this; jl_Object.call(a);
        a.$expressions0 = null;
        a.$forced = 0;
        a.$position133 = null;
        a.$LabelExpressionsPartition$module6 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier6 = null;
        a.$SetExtractor$module6 = null;
    }
    function oncia_Delete__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_Delete();
        $java.oncia_Delete__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_Delete_returnVariables = function($this) {
        return $java.oncia_UpdateClause_returnVariables$($this);
    };
    $java.oncia_Delete_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Delete_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_Delete_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_Delete_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_Delete_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Delete_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Delete_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Delete_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Delete_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module6 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module6 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module6 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module6;
    };
    $java.oncia_Delete_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier6;
    };
    $java.oncia_Delete_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module6 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module6 !== null)
                        break a;
                    $this.$SetExtractor$module6 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module6;
    };
    $java.oncia_Delete_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier6 = $x$1;
    };
    $java.oncia_Delete_position = function($this) {
        return $this.$position133;
    };
    $java.oncia_Delete_name = function($this) {
        return $rt_s(2037);
    };
    $java.oncia_Delete_clauseSpecificSemanticCheck = function($this) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = ($java.oncias_SemanticExpressionCheck$_simple0(oncias_SemanticExpressionCheck$_MODULE$, $this.$expressions0)).$chain($java.oncias_package$_liftSemanticErrorDefs(oncias_package$_MODULE$, ($this.$expressions0.$filter1(new $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_0)).$map1(new $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_1)));
        oncius_package$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticAnalysisTooling_expectType$0($this, $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$))), $java.oncius_PathType_covariant($java.oncius_package$_CTPath0(oncius_package$_MODULE$))), $this.$expressions0));
    };
    $java.oncia_Delete_productPrefix = function($this) {
        return $rt_s(2038);
    };
    $java.oncia_Delete_productArity = function($this) {
        return 2;
    };
    $java.oncia_Delete_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expressions0;
            case 1:
                return jl_Boolean_valueOf($this.$forced);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Delete_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Delete_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2038))), sr_Statics_anyHash($this.$expressions0)), !$this.$forced ? 1237 : 1231), 2);
    };
    $java.oncia_Delete_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Delete_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Delete) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$forced != $x$1.$forced)
                        break b;
                    c: {
                        var$2 = $this.$expressions0;
                        $x$1 = $x$1.$expressions0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Delete))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_Delete_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Delete__init_ = function($this, $expressions, $forced, $position) {
        $this.$expressions0 = $expressions;
        $this.$forced = $forced;
        $this.$position133 = $position;
        oncia_Clause_$init$($this);
    };
    function onciafn_Neo4jASTFactory$matchClause$lambda$_11_0() {
        jl_Object.call(this);
        this.$_0233 = null;
    }
    $java.onciafn_Neo4jASTFactory$matchClause$lambda$_11_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0233;
        if (var$1 instanceof oncie_PatternPartWithSelector)
            var$1 = var$1;
        else {
            if (!$rt_isInstance(var$1, oncie_NonPrefixedPatternPart))
                $rt_throw(s_MatchError__init_(var$1));
            var$3 = var$1;
            var$1 = oncie_PatternPartWithSelector__init_(onciafn_Neo4jASTFactory_allPathSelector(var$2, var$3.$position2()), var$3);
        }
        return var$1;
    };
    var oncie_MatchMode$ = $rt_classWithoutFields();
    var oncie_MatchMode$_MODULE$ = null;
    function oncie_MatchMode$__clinit_() {
        oncie_MatchMode$_MODULE$ = new oncie_MatchMode$;
    }
    function oncie_MatchMode$_default($this, $position) {
        return oncie_MatchMode$DifferentRelationships__init_(1, $position);
    }
    function oncia_Match() {
        var a = this; jl_Object.call(a);
        a.$optional = 0;
        a.$matchMode = null;
        a.$pattern2 = null;
        a.$hints = null;
        a.$where1 = null;
        a.$position54 = null;
        a.$LabelExpressionsPartition$module7 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier7 = null;
        a.$SetExtractor$module7 = null;
    }
    function oncia_Match__init_0(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_Match();
        oncia_Match__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    $java.oncia_Match_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_Match_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Match_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_Match_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Match_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Match_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Match_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Match_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module7 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module7 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module7 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module7;
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier7;
    };
    $java.oncia_Match_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module7 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module7 !== null)
                        break a;
                    $this.$SetExtractor$module7 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module7;
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier7 = $x$1;
    };
    $java.oncia_Match_optional = function($this) {
        return $this.$optional;
    };
    $java.oncia_Match_position = function($this) {
        return $this.$position54;
    };
    $java.oncia_Match_name = function($this) {
        return $rt_s(2039);
    };
    $java.oncia_Match_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = oncias_SemanticCheck$_MODULE$;
        var$2 = new $java.oncia_Match$noImplicitJoinsInQuantifiedPathPatterns$lambda$_62_0;
        var$2.$_0414 = $this;
        var$3 = oncias_SemanticCheck$_fromState(var$1, var$2);
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$3, $java.oncias_SemanticPatternCheck$_check(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Match$_MODULE$, $this.$pattern2)), $java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension($java.oncias_SemanticCheckableIterableOnce$_MODULE$, $this.$hints));
        var$1 = $this.$hints.$collect0(new $java.oncia_Match$$anonfun$4);
        s_Predef$_$callClinit();
        var$1 = (sc_StrictOptimizedIterableOps_collect$(sc_AbstractIterable_groupBy(var$1.$flatten(s_Predef$_$conforms(s_Predef$_MODULE$)), new $java.oncia_Match$uniqueHints$lambda$_66_0), new $java.oncia_Match$$anonfun$5)).$toVector();
        var$2 = oncias_package$_MODULE$;
        var$4 = new $java.oncia_Match$uniqueHints$lambda$_66_1;
        var$4.$_0415 = var$1;
        var$3 = oncias_SemanticCheck_chain$(var$3, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$4));
        var$1 = new $java.oncia_Match$checkMatchMode$lambda$_68_0;
        var$2 = new $java.oncia_Match$checkMatchMode$lambda$_68_1;
        var$2.$_0416 = $this;
        var$4 = new $java.oncia_Match$checkMatchMode$lambda$_68_2;
        var$4.$_0417 = $this;
        var$4.$_1123 = var$1;
        var$2 = oncias_SemanticAnalysisTooling_whenState$($this, var$1, var$2, var$4);
        var$1 = new $java.oncia_Match$checkMatchMode$lambda$_68_3;
        var$1.$_0418 = $this;
        var$4 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$3, oncias_SemanticCheck_ifOkChain$(var$2, var$1)), oncias_SemanticCheckableOption$_semanticCheck$extension(oncias_SemanticCheckableOption$_MODULE$, $this.$where1));
        var$1 = oncias_SemanticCheck$_MODULE$;
        var$2 = new $java.oncia_Match$checkHints$lambda$_71_0;
        var$2.$_0419 = $this;
        var$4 = oncias_SemanticCheck_chain$(var$4, $java.oncias_SemanticCheck$_fromFunctionWithContext(var$1, var$2));
        var$1 = oncias_package$_MODULE$;
        var$2 = new $java.oncia_Match$checkForCartesianProducts$lambda$_67_0;
        var$2.$_0420 = $this;
        return oncias_SemanticCheck_chain$(var$4, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$1, var$2));
    };
    $java.oncia_Match_getPropertyPredicates = function($this, $variable) {
        var var$2, var$3, var$4, var$5;
        var$2 = $this.$where1;
        var$3 = new $java.oncia_Match$getPropertyPredicates$lambda$_73_0;
        var$3.$_0421 = $this;
        var$3.$_1124 = $variable;
        var$2 = s_Option_getOrElse(s_Option_map(var$2, var$3), new $java.oncia_Match$getPropertyPredicates$lambda$_73_1);
        var$4 = onciu_Foldable_folder$($this.$pattern2);
        s_package$_$callClinit();
        var$5 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        var$3 = new $java.oncia_Match$$anonfun$getPropertyPredicates$3;
        var$3.$$outer35 = $this;
        var$3.$variable$2 = $variable;
        return var$2.$concat0(onciu_Foldable$Folder_treeFold(var$4, var$5, var$3));
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap = function($this, $properties) {
        if ($properties instanceof s_Some) {
            $properties = $properties.$value5;
            if ($properties instanceof oncie_MapExpression)
                return $properties.$items5.$map1(new $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap$lambda$_74_0);
        }
        s_package$_$callClinit();
        return sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates = function($this, $variable, $whereExpression) {
        var var$3, var$4;
        var$3 = onciu_Foldable_folder$($whereExpression);
        s_package$_$callClinit();
        var$4 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        $whereExpression = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1;
        $whereExpression.$$outer36 = $this;
        $whereExpression.$variable$3 = $variable;
        return onciu_Foldable$Folder_treeFold(var$3, var$4, $whereExpression);
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$applicable = function($this, $other) {
        var var$2, var$3, var$4;
        if (!($other instanceof oncie_FunctionInvocation))
            return 1;
        a: {
            b: {
                c: {
                    d: {
                        $other = $other;
                        $java.oncief_Function$_$callClinit();
                        var$2 = $other.$function0;
                        $java.oncief_Id$_$callClinit();
                        var$3 = $java.oncief_Id$_MODULE$;
                        if (var$2 !== null) {
                            if (jl_Object_equals(var$2, var$3))
                                break c;
                            else
                                break d;
                        }
                        if (var$3 === null)
                            break c;
                    }
                    var$3 = $other.$function0;
                    $java.oncief_ElementId$_$callClinit();
                    $other = $java.oncief_ElementId$_MODULE$;
                    if (var$3 !== null) {
                        if (!jl_Object_equals(var$3, $other))
                            break b;
                        else
                            break c;
                    }
                    if ($other !== null)
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4 ? 0 : 1;
    };
    $java.oncia_Match_containsLabelOrRelTypePredicate = function($this, $variable, $labelOrRelType) {
        return ($java.oncia_Match_getLabelAndRelTypePredicates($this, $variable)).$contains0($labelOrRelType);
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression = function($this, $labelExpression) {
        return ($labelExpression.$flatten0()).$map1(new $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression$lambda$_78_0);
    };
    $java.oncia_Match_getLabelAndRelTypePredicates = function($this, $variable) {
        var $predicateLabels, $labelExpressionLabels, $inlinedRelTypes, $predicateRelTypes, $allLabels;
        $predicateLabels = onciu_Foldable_folder$($this.$pattern2);
        s_package$_$callClinit();
        $labelExpressionLabels = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        $inlinedRelTypes = new $java.oncia_Match$$anonfun$8;
        $inlinedRelTypes.$$outer37 = $this;
        $inlinedRelTypes.$variable$4 = $variable;
        $inlinedRelTypes = onciu_Foldable$Folder_fold($predicateLabels, $labelExpressionLabels, $inlinedRelTypes);
        $predicateRelTypes = onciu_Foldable_folder$($this.$pattern2);
        $labelExpressionLabels = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        $predicateLabels = new $java.oncia_Match$$anonfun$9;
        $predicateLabels.$$outer38 = $this;
        $predicateLabels.$variable$40 = $variable;
        $labelExpressionLabels = onciu_Foldable$Folder_fold($predicateRelTypes, $labelExpressionLabels, $predicateLabels);
        $predicateLabels = $this.$where1;
        if (!($predicateLabels instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, $predicateLabels))
                $rt_throw(s_MatchError__init_($predicateLabels));
            $predicateRelTypes = s_Tuple2__init_(sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
        } else {
            $predicateRelTypes = onciu_Foldable_folder$($predicateLabels.$value5);
            $allLabels = s_Tuple2__init_(sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
            $predicateLabels = new $java.oncia_Match$$anonfun$10;
            $predicateLabels.$$outer39 = $this;
            $predicateLabels.$variable$41 = $variable;
            $predicateRelTypes = onciu_Foldable$Folder_treeFold($predicateRelTypes, $allLabels, $predicateLabels);
        }
        if ($predicateRelTypes === null)
            $rt_throw(s_MatchError__init_($predicateRelTypes));
        $predicateLabels = $predicateRelTypes.$_10;
        $predicateRelTypes = $predicateRelTypes.$_20;
        $variable = s_Tuple2__init_($predicateLabels, $predicateRelTypes);
        $predicateLabels = $variable.$_10;
        $predicateRelTypes = $variable.$_20;
        return ($labelExpressionLabels.$concat0($predicateLabels)).$concat0($inlinedRelTypes.$concat0($predicateRelTypes));
    };
    $java.oncia_Match_productPrefix = function($this) {
        return $rt_s(2040);
    };
    $java.oncia_Match_productArity = function($this) {
        return 5;
    };
    $java.oncia_Match_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$optional);
            case 1:
                return $this.$matchMode;
            case 2:
                return $this.$pattern2;
            case 3:
                return $this.$hints;
            case 4:
                return $this.$where1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Match_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Match_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2040))), !$this.$optional ? 1237 : 1231), sr_Statics_anyHash($this.$matchMode)), sr_Statics_anyHash($this.$pattern2)), sr_Statics_anyHash($this.$hints)), sr_Statics_anyHash($this.$where1)), 5);
    };
    $java.oncia_Match_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Match_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Match) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$optional != $x$1.$optional)
                        break b;
                    c: {
                        var$2 = $this.$matchMode;
                        var$3 = $x$1.$matchMode;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$pattern2;
                        var$3 = $x$1.$pattern2;
                        if (var$2 !== null) {
                            if (!$java.oncie_Pattern$ForMatch_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$hints;
                        var$3 = $x$1.$hints;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$where1;
                        $x$1 = $x$1.$where1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Match))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Match_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getMissingEntityKindError$1 = function($this, $variable, $labelOrRelTypeName, $hint, $semanticState$1, $context$1) {
        var $isNode, $typeName, $functionName, $operatorDescription, $typePredicates, var$11, $foundTypePredicatesDescription, $typePredicate, var$14;
        $isNode = oncias_SemanticState_isNode($semanticState$1, $variable);
        $typeName = !$isNode ? $rt_s(2041) : $rt_s(2042);
        $functionName = !$isNode ? $rt_s(538) : $rt_s(1819);
        if ($hint instanceof oncia_UsingIndexHint)
            $operatorDescription = $rt_s(2043);
        else if (!($hint instanceof oncia_UsingScanHint)) {
            if (!($hint instanceof oncia_UsingJoinHint))
                $rt_throw(s_MatchError__init_($hint));
            $operatorDescription = $rt_s(2044);
        } else {
            $typePredicates = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($typePredicates);
            jl_StringBuilder_append(jl_StringBuilder_append($typePredicates, $typeName), $rt_s(2045));
            $operatorDescription = jl_AbstractStringBuilder_toString($typePredicates);
        }
        a: {
            $typePredicates = sc_SeqOps_distinct$($java.oncia_Match_getLabelAndRelTypePredicates($this, $variable));
            if ($typePredicates !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $typePredicates);
                if (!$typePredicates.$lengthCompare(0)) {
                    var$11 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$11);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$11, $rt_s(2046)), $typeName), $rt_s(2047));
                    $foundTypePredicatesDescription = jl_AbstractStringBuilder_toString(var$11);
                    break a;
                }
            }
            if ($typePredicates !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $typePredicates);
                if (!$typePredicates.$lengthCompare(1)) {
                    $typePredicate = $typePredicates.$apply1(0);
                    $typePredicates = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($typePredicates);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($typePredicates, $rt_s(2048)), $typeName), $rt_s(2049)), $typePredicate), $rt_s(2050));
                    $foundTypePredicatesDescription = jl_AbstractStringBuilder_toString($typePredicates);
                    break a;
                }
            }
            $foundTypePredicatesDescription = sc_AbstractIterable_mkString0($typePredicates, $rt_s(2051));
            $typePredicates = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($typePredicates);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($typePredicates, $rt_s(2048)), $typeName), $rt_s(2052)), $foundTypePredicatesDescription), $rt_s(2053));
            $foundTypePredicatesDescription = jl_AbstractStringBuilder_toString($typePredicates);
        }
        $typePredicates = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($typePredicates);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($typePredicates, $typeName), $rt_s(2049)), $labelOrRelTypeName), 96);
        $typePredicate = jl_AbstractStringBuilder_toString($typePredicates);
        var$14 = $java.onciuh_StringHelper$RichString$_MODULE$;
        $java.onciuh_StringHelper$_$callClinit();
        $typePredicates = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($typePredicates);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($typePredicates, $rt_s(2054)), $typeName), $rt_s(2055)), $labelOrRelTypeName), $rt_s(2056)), $functionName), $rt_s(2057));
        return $java.oncia_Match_getHintErrorForVariable$1($operatorDescription, $hint, $typePredicate, $foundTypePredicatesDescription, $variable, $java.onciuh_StringHelper$RichString$_stripLinesAndMargins$extension(var$14, jl_AbstractStringBuilder_toString($typePredicates)), $semanticState$1, $context$1);
    };
    $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getMissingPropertyError$1 = function($this, $hint, $semanticState$1, $context$1) {
        var $variable, $propertiesInHint, $plural, $property, $foundPropertiesDescription, $missingPropertiesNames, var$10;
        $variable = $hint.$variable6.$name4;
        $propertiesInHint = $hint.$properties3;
        $plural = $propertiesInHint.$length() <= 1 ? 0 : 1;
        a: {
            $property = $java.oncia_Match_getPropertyPredicates($this, $variable);
            if ($property !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $property);
                if (!$property.$lengthCompare(0)) {
                    $foundPropertiesDescription = $rt_s(2058);
                    break a;
                }
            }
            if ($property !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $property);
                if (!$property.$lengthCompare(1)) {
                    $property = $property.$apply1(0);
                    $missingPropertiesNames = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($missingPropertiesNames);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($missingPropertiesNames, $rt_s(2059)), $property), $rt_s(2050));
                    $foundPropertiesDescription = jl_AbstractStringBuilder_toString($missingPropertiesNames);
                    break a;
                }
            }
            $property = sc_AbstractIterable_mkString0($property, $rt_s(2051));
            $missingPropertiesNames = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($missingPropertiesNames);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($missingPropertiesNames, $rt_s(2059)), $property), $rt_s(2053));
            $foundPropertiesDescription = jl_AbstractStringBuilder_toString($missingPropertiesNames);
        }
        $missingPropertiesNames = sc_AbstractIterable_mkString0($propertiesInHint.$map1(new $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getMissingPropertyError$1$lambda$_128_0), $rt_s(16));
        $property = !$plural ? $rt_s(2060) : $rt_s(541);
        $propertiesInHint = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($propertiesInHint);
        $property = jl_StringBuilder_append(jl_StringBuilder_append($propertiesInHint, $rt_s(2061)), $property);
        jl_AbstractStringBuilder_append($property, 32);
        jl_StringBuilder_append($property, $missingPropertiesNames);
        var$10 = jl_AbstractStringBuilder_toString($propertiesInHint);
        $property = $java.onciuh_StringHelper$RichString$_MODULE$;
        $java.onciuh_StringHelper$_$callClinit();
        return $java.oncia_Match_getHintErrorForVariable$1($rt_s(2043), $hint, var$10, $foundPropertiesDescription, $variable, $java.onciuh_StringHelper$RichString$_stripLinesAndMargins$extension($property, $rt_s(2062)), $semanticState$1, $context$1);
    };
    $java.oncia_Match_getHintErrorForVariable$1 = function($operatorDescription, $hint, $missingThingDescription, $foundThingsDescription, $variable, $additionalInfo, $semanticState$1, $context$1) {
        var $entityName, var$10;
        $entityName = !oncias_SemanticState_isNode($semanticState$1, $variable) ? $rt_s(1618) : $rt_s(1616);
        $semanticState$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($semanticState$1);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($semanticState$1, $rt_s(2061)), $entityName), $rt_s(2049)), $variable), 96);
        var$10 = jl_AbstractStringBuilder_toString($semanticState$1);
        $variable = $context$1.$errorMessageProvider0();
        $java.oncia_Match$_$callClinit();
        $semanticState$1 = $java.oncia_Match$_hintPrettifier;
        return $variable.$createMissingPropertyLabelHintError($operatorDescription, !$rt_isInstance($hint, $java.oncia_UsingHint) ? $hint.$toString() : onciap_Prettifier$IndentingQueryPrettifier_asString21($semanticState$1.$base, $hint), $missingThingDescription, $foundThingsDescription, var$10, $entityName, $additionalInfo);
    };
    function oncia_Match__init_($this, $optional, $matchMode, $pattern, $hints, $where, $position) {
        $this.$optional = $optional;
        $this.$matchMode = $matchMode;
        $this.$pattern2 = $pattern;
        $this.$hints = $hints;
        $this.$where1 = $where;
        $this.$position54 = $position;
        oncia_Clause_$init$($this);
    }
    function oncie_Pattern$ForMatch() {
        var a = this; jl_Object.call(a);
        a.$patternParts1 = null;
        a.$position134 = null;
        a.$length6 = 0;
        a.$bitmap$026 = 0;
    }
    function oncie_Pattern$ForMatch__init_(var_0, var_1) {
        var var_2 = new oncie_Pattern$ForMatch();
        $java.oncie_Pattern$ForMatch__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_Pattern$ForMatch_foldedOver = function($this) {
        return $this;
    };
    $java.oncie_Pattern$ForMatch_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncie_Pattern$ForMatch_patternParts = function($this) {
        return $this.$patternParts1;
    };
    $java.oncie_Pattern$ForMatch_position = function($this) {
        return $this.$position134;
    };
    $java.oncie_Pattern$ForMatch_productPrefix = function($this) {
        return $rt_s(2063);
    };
    $java.oncie_Pattern$ForMatch_productArity = function($this) {
        return 1;
    };
    $java.oncie_Pattern$ForMatch_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$patternParts1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Pattern$ForMatch_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$ForMatch_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$ForMatch_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$ForMatch_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncie_Pattern$ForMatch) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$patternParts1;
                        $x$1 = $x$1.$patternParts1;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_Pattern$ForMatch_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_Pattern$ForMatch__init_ = function($this, $patternParts, $position) {
        $this.$patternParts1 = $patternParts;
        $this.$position134 = $position;
    };
    $java.oncie_PatternPart$Selector = $rt_classWithoutFields(0);
    function oncie_PatternPartWithSelector() {
        var a = this; $java.oncie_PatternPart.call(a);
        a.$selector = null;
        a.$part = null;
    }
    function oncie_PatternPartWithSelector__init_(var_0, var_1) {
        var var_2 = new oncie_PatternPartWithSelector();
        $java.oncie_PatternPartWithSelector__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_PatternPartWithSelector_position($this) {
        return $this.$part.$position2();
    }
    $java.oncie_PatternPartWithSelector_allVariables = function($this) {
        return $this.$part.$allVariables();
    };
    $java.oncie_PatternPartWithSelector_element = function($this) {
        return $this.$part.$element();
    };
    $java.oncie_PatternPartWithSelector_isSelective = function($this) {
        return $this.$selector.$isBounded();
    };
    $java.oncie_PatternPartWithSelector_productPrefix = function($this) {
        return $rt_s(2064);
    };
    $java.oncie_PatternPartWithSelector_productArity = function($this) {
        return 2;
    };
    $java.oncie_PatternPartWithSelector_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$selector;
            case 1:
                return $this.$part;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternPartWithSelector_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPartWithSelector_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPartWithSelector_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPartWithSelector_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PatternPartWithSelector) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$selector;
                        var$3 = $x$1.$selector;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$part;
                        $x$1 = $x$1.$part;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PatternPartWithSelector))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_PatternPartWithSelector__init_ = function($this, $selector, $part) {
        $this.$selector = $selector;
        $this.$part = $part;
        $java.oncie_PatternPart__init_($this);
    };
    function onciafn_Neo4jASTFactory$mergeClause$lambda$_28_0() {
        var a = this; jl_Object.call(a);
        a.$_0239 = null;
        a.$_164 = null;
    }
    $java.onciafn_Neo4jASTFactory$mergeClause$lambda$_28_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0239;
        var$3 = var$0.$_164;
        onciaf_ASTFactory$MergeActionType_$callClinit();
        if (jl_Enum_equals(onciaf_ASTFactory$MergeActionType_OnMatch, var$1))
            var$1 = $java.oncia_OnMatch__init_(ju_AbstractList$1_next(var$2), ju_AbstractList$1_next(var$3));
        else {
            if (!jl_Enum_equals(onciaf_ASTFactory$MergeActionType_OnCreate, var$1))
                $rt_throw(s_MatchError__init_(var$1));
            var$1 = $java.oncia_OnCreate__init_(ju_AbstractList$1_next(var$2), ju_AbstractList$1_next(var$3));
        }
        return var$1;
    };
    function oncia_Merge() {
        var a = this; jl_Object.call(a);
        a.$pattern3 = null;
        a.$actions = null;
        a.$where10 = null;
        a.$position135 = null;
        a.$LabelExpressionsPartition$module8 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier8 = null;
        a.$SetExtractor$module8 = null;
    }
    function oncia_Merge__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_Merge();
        $java.oncia_Merge__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_Merge_checkRelTypes = function($this, $rel) {
        return $java.oncia_SingleRelTypeCheck_checkRelTypes$0($this, $rel);
    };
    $java.oncia_Merge_returnVariables = function($this) {
        return $java.oncia_UpdateClause_returnVariables$($this);
    };
    $java.oncia_Merge_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Merge_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Merge_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Merge_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Merge_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Merge_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module8 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module8 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module8 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module8;
    };
    $java.oncia_Merge_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier8;
    };
    $java.oncia_Merge_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module8 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module8 !== null)
                        break a;
                    $this.$SetExtractor$module8 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module8;
    };
    $java.oncia_Merge_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier8 = $x$1;
    };
    $java.oncia_Merge_position = function($this) {
        return $this.$position135;
    };
    $java.oncia_Merge_name = function($this) {
        return $rt_s(911);
    };
    $java.oncia_Merge_shouldRunGpmChecks = function($this) {
        return 0;
    };
    $java.oncia_Merge_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2, var$3;
        oncias_SemanticPatternCheck$_$callClinit();
        var$1 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_SemanticPatternCheck$_check(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Merge$_MODULE$, $java.oncie_Pattern$ForUpdate__init_(sci_$colon$colon__init_($this.$pattern3, sci_Nil$_MODULE$), $this.$pattern3.$position2())), $java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension($java.oncias_SemanticCheckableIterableOnce$_MODULE$, $this.$actions)), $java.oncia_SingleRelTypeCheck_checkRelTypes$($this,
        $this.$pattern3)), oncias_SemanticCheckableOption$_semanticCheck$extension(oncias_SemanticCheckableOption$_MODULE$, $this.$where10));
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncia_Merge$clauseSpecificSemanticCheck$lambda$_65_0;
        var$3.$_0422 = $this;
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticCheck$_fromState(var$2, var$3));
    };
    $java.oncia_Merge_productPrefix = function($this) {
        return $rt_s(2065);
    };
    $java.oncia_Merge_productArity = function($this) {
        return 3;
    };
    $java.oncia_Merge_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$pattern3;
            case 1:
                return $this.$actions;
            case 2:
                return $this.$where10;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Merge_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Merge_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Merge_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Merge_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Merge) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$pattern3;
                        var$3 = $x$1.$pattern3;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$actions;
                        var$3 = $x$1.$actions;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$where10;
                        $x$1 = $x$1.$where10;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Merge))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Merge_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Merge__init_ = function($this, $pattern, $actions, $where, $position) {
        $this.$pattern3 = $pattern;
        $this.$actions = $actions;
        $this.$where10 = $where;
        $this.$position135 = $position;
        oncia_Clause_$init$($this);
    };
    var oncia_Merge$ = $rt_classWithoutFields();
    $java.oncia_Merge$_MODULE$ = null;
    function oncia_Merge$__clinit_() {
        $java.oncia_Merge$_MODULE$ = new oncia_Merge$;
    }
    function oncia_Remove() {
        var a = this; jl_Object.call(a);
        a.$items2 = null;
        a.$position136 = null;
        a.$LabelExpressionsPartition$module9 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier9 = null;
        a.$SetExtractor$module9 = null;
    }
    function oncia_Remove__init_(var_0, var_1) {
        var var_2 = new oncia_Remove();
        $java.oncia_Remove__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_Remove_returnVariables = function($this) {
        return $java.oncia_UpdateClause_returnVariables$($this);
    };
    $java.oncia_Remove_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Remove_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_Remove_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Remove_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Remove_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Remove_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Remove_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module9 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module9 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module9 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module9;
    };
    $java.oncia_Remove_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier9;
    };
    $java.oncia_Remove_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module9 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module9 !== null)
                        break a;
                    $this.$SetExtractor$module9 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module9;
    };
    $java.oncia_Remove_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier9 = $x$1;
    };
    $java.oncia_Remove_position = function($this) {
        return $this.$position136;
    };
    $java.oncia_Remove_name = function($this) {
        return $rt_s(2066);
    };
    $java.oncia_Remove_clauseSpecificSemanticCheck = function($this) {
        return $java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension($java.oncias_SemanticCheckableIterableOnce$_MODULE$, $this.$items2);
    };
    $java.oncia_Remove_productPrefix = function($this) {
        return $rt_s(2067);
    };
    $java.oncia_Remove_productArity = function($this) {
        return 1;
    };
    $java.oncia_Remove_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$items2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Remove_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Remove_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Remove_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Remove_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Remove) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$items2;
                        $x$1 = $x$1.$items2;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Remove))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_Remove_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Remove__init_ = function($this, $items, $position) {
        $this.$items2 = $items;
        $this.$position136 = $position;
        oncia_Clause_$init$($this);
    };
    function oncia_SetClause() {
        var a = this; jl_Object.call(a);
        a.$items1 = null;
        a.$position137 = null;
        a.$LabelExpressionsPartition$module10 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier10 = null;
        a.$SetExtractor$module10 = null;
    }
    function oncia_SetClause__init_(var_0, var_1) {
        var var_2 = new oncia_SetClause();
        $java.oncia_SetClause__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_SetClause_returnVariables = function($this) {
        return $java.oncia_UpdateClause_returnVariables$($this);
    };
    $java.oncia_SetClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_SetClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_SetClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_SetClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_SetClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_SetClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_SetClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module10 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module10 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module10 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module10;
    };
    $java.oncia_SetClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier10;
    };
    $java.oncia_SetClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module10 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module10 !== null)
                        break a;
                    $this.$SetExtractor$module10 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module10;
    };
    $java.oncia_SetClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier10 = $x$1;
    };
    $java.oncia_SetClause_position = function($this) {
        return $this.$position137;
    };
    $java.oncia_SetClause_name = function($this) {
        return $rt_s(2068);
    };
    $java.oncia_SetClause_clauseSpecificSemanticCheck = function($this) {
        return $java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension($java.oncias_SemanticCheckableIterableOnce$_MODULE$, $this.$items1);
    };
    $java.oncia_SetClause_productPrefix = function($this) {
        return $rt_s(2069);
    };
    $java.oncia_SetClause_productArity = function($this) {
        return 1;
    };
    $java.oncia_SetClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$items1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetClause_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetClause_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_SetClause) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$items1;
                        $x$1 = $x$1.$items1;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_SetClause))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SetClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SetClause__init_ = function($this, $items, $position) {
        $this.$items1 = $items;
        $this.$position137 = $position;
        oncia_Clause_$init$($this);
    };
    function oncia_Unwind() {
        var a = this; jl_Object.call(a);
        a.$expression7 = null;
        a.$variable7 = null;
        a.$position138 = null;
        a.$LabelExpressionsPartition$module11 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier11 = null;
        a.$SetExtractor$module11 = null;
    }
    function oncia_Unwind__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_Unwind();
        $java.oncia_Unwind__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_Unwind_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_Unwind_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Unwind_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_Unwind_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_Unwind_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_Unwind_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Unwind_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Unwind_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Unwind_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Unwind_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module11 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module11 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module11 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module11;
    };
    $java.oncia_Unwind_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier11;
    };
    $java.oncia_Unwind_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module11 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module11 !== null)
                        break a;
                    $this.$SetExtractor$module11 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module11;
    };
    $java.oncia_Unwind_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier11 = $x$1;
    };
    $java.oncia_Unwind_position = function($this) {
        return $this.$position138;
    };
    $java.oncia_Unwind_name = function($this) {
        return $rt_s(2070);
    };
    $java.oncia_Unwind_clauseSpecificSemanticCheck = function($this) {
        var $possibleInnerTypes, var$2, var$3;
        oncias_SemanticExpressionCheck$_$callClinit();
        $possibleInnerTypes = oncias_SemanticCheck_chain$(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, oncie_Expression$SemanticContext$Results$_MODULE$, $this.$expression7), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_0, $this.$expression7));
        var$2 = new $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_1;
        var$2.$_0423 = $this;
        var$3 = oncias_SemanticCheck_ifOkChain$($possibleInnerTypes, var$2);
        $possibleInnerTypes = new $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_2;
        $possibleInnerTypes.$_0424 = $this;
        return oncias_SemanticCheck_chain$(var$3, $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0($this, $this.$variable7, $possibleInnerTypes, s_None$_MODULE$, 0)));
    };
    $java.oncia_Unwind_productPrefix = function($this) {
        return $rt_s(2071);
    };
    $java.oncia_Unwind_productArity = function($this) {
        return 2;
    };
    $java.oncia_Unwind_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression7;
            case 1:
                return $this.$variable7;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Unwind_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Unwind_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Unwind_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Unwind_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Unwind) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression7;
                        var$3 = $x$1.$expression7;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$variable7;
                        $x$1 = $x$1.$variable7;
                        if (var$3 !== null) {
                            if (!$java.oncie_Variable_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Unwind))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Unwind_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Unwind__init_ = function($this, $expression, $variable, $position) {
        $this.$expression7 = $expression;
        $this.$variable7 = $variable;
        $this.$position138 = $position;
        oncia_Clause_$init$($this);
    };
    function oncie_ProcedureName() {
        var a = this; jl_Object.call(a);
        a.$name47 = null;
        a.$position139 = null;
    }
    function oncie_ProcedureName__init_(var_0, var_1) {
        var var_2 = new oncie_ProcedureName();
        $java.oncie_ProcedureName__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_ProcedureName_name = function($this) {
        return $this.$name47;
    };
    $java.oncie_ProcedureName_position = function($this) {
        return $this.$position139;
    };
    $java.oncie_ProcedureName_productPrefix = function($this) {
        return $rt_s(2072);
    };
    $java.oncie_ProcedureName_productArity = function($this) {
        return 1;
    };
    $java.oncie_ProcedureName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name47;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ProcedureName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ProcedureName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ProcedureName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ProcedureName_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ProcedureName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name47;
                        $x$1 = $x$1.$name47;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ProcedureName))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_ProcedureName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_ProcedureName__init_ = function($this, $name, $position) {
        $this.$name47 = $name;
        $this.$position139 = $position;
    };
    function onciafn_Neo4jASTFactory$callClause$lambda$_29_0() {
        var a = this; jl_Object.call(a);
        a.$_0240 = null;
        a.$_165 = null;
    }
    $java.onciafn_Neo4jASTFactory$callClause$lambda$_29_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0240;
        var$3 = var$0.$_165;
        return $java.oncia_ProcedureResult__init_(sc_AbstractIterable_toIndexedSeq(sc_IterableOnceOps_toList$(scc_AsScalaExtensions$ListHasAsScala_asScala(sj_CollectionConverters$_ListHasAsScala(sj_CollectionConverters$_MODULE$, var$1)))), s_Option$_apply(s_Option$_MODULE$, var$2), var$3);
    };
    function oncia_SubqueryCall$InTransactionsBatchParameters() {
        var a = this; jl_Object.call(a);
        a.$batchSize = null;
        a.$position140 = null;
    }
    function oncia_SubqueryCall$InTransactionsBatchParameters__init_(var_0, var_1) {
        var var_2 = new oncia_SubqueryCall$InTransactionsBatchParameters();
        $java.oncia_SubqueryCall$InTransactionsBatchParameters__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_position = function($this) {
        return $this.$position140;
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_semanticCheck = function($this) {
        return $java.oncia_ASTSlicingPhrase$_checkExpressionIsStaticInt($java.oncia_ASTSlicingPhrase$_MODULE$, $this.$batchSize, $rt_s(2073), 0);
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_productPrefix = function($this) {
        return $rt_s(2074);
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_productArity = function($this) {
        return 1;
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$batchSize;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SubqueryCall$InTransactionsBatchParameters) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$batchSize;
                        $x$1 = $x$1.$batchSize;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SubqueryCall$InTransactionsBatchParameters__init_ = function($this, $batchSize, $position) {
        $this.$batchSize = $batchSize;
        $this.$position140 = $position;
    };
    function oncia_SubqueryCall$InTransactionsErrorParameters() {
        var a = this; jl_Object.call(a);
        a.$behaviour = null;
        a.$position141 = null;
    }
    function oncia_SubqueryCall$InTransactionsErrorParameters__init_(var_0, var_1) {
        var var_2 = new oncia_SubqueryCall$InTransactionsErrorParameters();
        $java.oncia_SubqueryCall$InTransactionsErrorParameters__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_position = function($this) {
        return $this.$position141;
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_productPrefix = function($this) {
        return $rt_s(2075);
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_productArity = function($this) {
        return 1;
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$behaviour;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SubqueryCall$InTransactionsErrorParameters) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$behaviour;
                        $x$1 = $x$1.$behaviour;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SubqueryCall$InTransactionsErrorParameters__init_ = function($this, $behaviour, $position) {
        $this.$behaviour = $behaviour;
        $this.$position141 = $position;
    };
    function oncia_SubqueryCall$InTransactionsReportParameters() {
        var a = this; jl_Object.call(a);
        a.$reportAs = null;
        a.$position91 = null;
    }
    function oncia_SubqueryCall$InTransactionsReportParameters__init_(var_0, var_1) {
        var var_2 = new oncia_SubqueryCall$InTransactionsReportParameters();
        $java.oncia_SubqueryCall$InTransactionsReportParameters__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_SubqueryCall$InTransactionsReportParameters_position = function($this) {
        return $this.$position91;
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_semanticCheck = function($this) {
        var var$1, var$2;
        var$1 = oncias_package$_MODULE$;
        var$2 = $this.$reportAs;
        oncius_package$_$callClinit();
        return oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(var$1, oncias_SemanticAnalysisTooling_declareVariable$($this, var$2, (oncius_package$_CTMap(oncius_package$_MODULE$)).$invariant())), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0($this, new $java.oncia_SubqueryCall$InTransactionsReportParameters$semanticCheck$lambda$_47_0, $this.$reportAs)));
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_productPrefix = function($this) {
        return $rt_s(2076);
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_productArity = function($this) {
        return 1;
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$reportAs;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SubqueryCall$InTransactionsReportParameters) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$reportAs;
                        $x$1 = $x$1.$reportAs;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters__init_ = function($this, $reportAs, $position) {
        $this.$reportAs = $reportAs;
        $this.$position91 = $position;
    };
    var onciaf_CallInTxsOnErrorBehaviourType = $rt_classWithoutFields(jl_Enum);
    var onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_BREAK = null;
    var onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_CONTINUE = null;
    var onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_FAIL = null;
    $java.onciaf_CallInTxsOnErrorBehaviourType_$VALUES = null;
    function onciaf_CallInTxsOnErrorBehaviourType_$callClinit() {
        onciaf_CallInTxsOnErrorBehaviourType_$callClinit = $rt_eraseClinit(onciaf_CallInTxsOnErrorBehaviourType);
        $java.onciaf_CallInTxsOnErrorBehaviourType__clinit_();
    }
    $java.onciaf_CallInTxsOnErrorBehaviourType__init_ = function(var_0, var_1) {
        var var_2 = new onciaf_CallInTxsOnErrorBehaviourType();
        $java.onciaf_CallInTxsOnErrorBehaviourType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function onciaf_CallInTxsOnErrorBehaviourType_values() {
        onciaf_CallInTxsOnErrorBehaviourType_$callClinit();
        return $java.onciaf_CallInTxsOnErrorBehaviourType_$VALUES.$clone();
    }
    $java.onciaf_CallInTxsOnErrorBehaviourType__init_0 = function($this, var$1, var$2) {
        onciaf_CallInTxsOnErrorBehaviourType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.onciaf_CallInTxsOnErrorBehaviourType__clinit_ = function() {
        var var$1;
        onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_BREAK = $java.onciaf_CallInTxsOnErrorBehaviourType__init_($rt_s(2077), 0);
        onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_CONTINUE = $java.onciaf_CallInTxsOnErrorBehaviourType__init_($rt_s(2078), 1);
        var$1 = $java.onciaf_CallInTxsOnErrorBehaviourType__init_($rt_s(2079), 2);
        onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_FAIL = var$1;
        $java.onciaf_CallInTxsOnErrorBehaviourType_$VALUES = $rt_createArrayFromData(onciaf_CallInTxsOnErrorBehaviourType, [onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_BREAK, onciaf_CallInTxsOnErrorBehaviourType_ON_ERROR_CONTINUE, var$1]);
    };
    function oncia_Foreach() {
        var a = this; jl_Object.call(a);
        a.$variable9 = null;
        a.$expression8 = null;
        a.$updates = null;
        a.$position142 = null;
        a.$LabelExpressionsPartition$module12 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier12 = null;
        a.$SetExtractor$module12 = null;
    }
    function oncia_Foreach__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_Foreach();
        $java.oncia_Foreach__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_Foreach_returnVariables = function($this) {
        return $java.oncia_UpdateClause_returnVariables$($this);
    };
    $java.oncia_Foreach_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_Foreach_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_Foreach_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_Foreach_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_Foreach_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_Foreach_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_Foreach_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_Foreach_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_Foreach_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module12 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module12 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module12 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module12;
    };
    $java.oncia_Foreach_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier12;
    };
    $java.oncia_Foreach_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module12 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module12 !== null)
                        break a;
                    $this.$SetExtractor$module12 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module12;
    };
    $java.oncia_Foreach_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier12 = $x$1;
    };
    $java.oncia_Foreach_position = function($this) {
        return $this.$position142;
    };
    $java.oncia_Foreach_name = function($this) {
        return $rt_s(2080);
    };
    $java.oncia_Foreach_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$expression8), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_0, $this.$expression8)), $java.oncias_package$_liftSemanticErrorDefs(oncias_package$_MODULE$, ($this.$updates.$filter1(new $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_1)).$map1(new $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_2)));
        var$2 = new $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_3;
        var$2.$_0425 = $this;
        return oncias_SemanticCheck_ifOkChain$(var$1, var$2);
    };
    $java.oncia_Foreach_productPrefix = function($this) {
        return $rt_s(2081);
    };
    $java.oncia_Foreach_productArity = function($this) {
        return 3;
    };
    $java.oncia_Foreach_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable9;
            case 1:
                return $this.$expression8;
            case 2:
                return $this.$updates;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Foreach_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Foreach_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Foreach_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Foreach_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_Foreach) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable9;
                        var$3 = $x$1.$variable9;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$expression8;
                        var$3 = $x$1.$expression8;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$updates;
                        $x$1 = $x$1.$updates;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Foreach))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Foreach_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Foreach__init_ = function($this, $variable, $expression, $updates, $position) {
        $this.$variable9 = $variable;
        $this.$expression8 = $expression;
        $this.$updates = $updates;
        $this.$position142 = $position;
        oncia_Clause_$init$($this);
    };
    function oncia_LoadCSV() {
        var a = this; jl_Object.call(a);
        a.$withHeaders = 0;
        a.$urlString = null;
        a.$variable8 = null;
        a.$fieldTerminator = null;
        a.$position143 = null;
        a.$LabelExpressionsPartition$module13 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier13 = null;
        a.$SetExtractor$module13 = null;
    }
    $java.oncia_LoadCSV__init_ = function(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_LoadCSV();
        oncia_LoadCSV__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    };
    $java.oncia_LoadCSV_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_LoadCSV_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_LoadCSV_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_LoadCSV_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_LoadCSV_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_LoadCSV_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_LoadCSV_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_LoadCSV_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_LoadCSV_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_LoadCSV_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module13 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module13 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module13 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module13;
    };
    $java.oncia_LoadCSV_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier13;
    };
    $java.oncia_LoadCSV_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module13 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module13 !== null)
                        break a;
                    $this.$SetExtractor$module13 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module13;
    };
    $java.oncia_LoadCSV_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier13 = $x$1;
    };
    $java.oncia_LoadCSV_position = function($this) {
        return $this.$position143;
    };
    $java.oncia_LoadCSV_name = function($this) {
        return $rt_s(381);
    };
    $java.oncia_LoadCSV_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2, var$3, var$4;
        a: {
            oncias_SemanticExpressionCheck$_$callClinit();
            var$1 = oncias_SemanticCheck_chain$($java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$urlString), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_LoadCSV$clauseSpecificSemanticCheck$lambda$_60_0, $this.$urlString));
            var$2 = $this.$fieldTerminator;
            if (var$2 instanceof s_Some) {
                var$2 = var$2.$value5;
                if (jl_String_length(var$2.$value25) != 1) {
                    var$2 = oncias_SemanticAnalysisTooling_error$($this, $rt_s(2082), var$2.$position144);
                    break a;
                }
            }
            var$2 = oncias_SemanticCheck$_success;
        }
        var$3 = oncias_SemanticCheck_chain$(var$1, var$2);
        if ($this.$withHeaders) {
            oncius_package$_$callClinit();
            var$2 = oncius_package$_CTMap(oncius_package$_MODULE$);
        } else {
            oncius_package$_$callClinit();
            var$2 = oncius_package$_MODULE$;
            var$2 = oncius_package$_CTList(var$2, oncius_package$_CTString(var$2));
        }
        var$4 = oncias_package$_MODULE$;
        var$1 = $this.$variable8;
        oncius_package$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, $java.oncias_package$_liftSemanticEitherFunc(var$4, oncias_SemanticAnalysisTooling_declareVariable$($this, var$1, var$2.$invariant())));
    };
    $java.oncia_LoadCSV_productPrefix = function($this) {
        return $rt_s(2083);
    };
    $java.oncia_LoadCSV_productArity = function($this) {
        return 4;
    };
    $java.oncia_LoadCSV_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$withHeaders);
            case 1:
                return $this.$urlString;
            case 2:
                return $this.$variable8;
            case 3:
                return $this.$fieldTerminator;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LoadCSV_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadCSV_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2083))), !$this.$withHeaders ? 1237 : 1231), sr_Statics_anyHash($this.$urlString)), sr_Statics_anyHash($this.$variable8)), sr_Statics_anyHash($this.$fieldTerminator)), 4);
    };
    $java.oncia_LoadCSV_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadCSV_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_LoadCSV) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$withHeaders != $x$1.$withHeaders)
                        break b;
                    c: {
                        var$2 = $this.$urlString;
                        var$3 = $x$1.$urlString;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$variable8;
                        var$3 = $x$1.$variable8;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$fieldTerminator;
                        $x$1 = $x$1.$fieldTerminator;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_LoadCSV))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_LoadCSV_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncia_LoadCSV__init_($this, $withHeaders, $urlString, $variable, $fieldTerminator, $position) {
        $this.$withHeaders = $withHeaders;
        $this.$urlString = $urlString;
        $this.$variable8 = $variable;
        $this.$fieldTerminator = $fieldTerminator;
        $this.$position143 = $position;
        oncia_Clause_$init$($this);
    }
    function onciafn_Neo4jASTFactory$loadCsvClause$lambda$_31_0() {
        jl_Object.call(this);
        this.$_0241 = null;
    }
    $java.onciafn_Neo4jASTFactory$loadCsvClause$lambda$_31_0_apply = function(var$0, var$1) {
        return oncie_StringLiteral__init_(var$1, var$0.$_0241);
    };
    function oncie_Xor() {
        var a = this; oncie_Expression.call(a);
        a.$lhs10 = null;
        a.$rhs11 = null;
        a.$position145 = null;
        a.$signatures1 = null;
    }
    function oncie_Xor__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Xor();
        $java.oncie_Xor__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Xor_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Xor_canonicalOperatorSymbol = function($this) {
        return $java.oncie_OperatorExpression_canonicalOperatorSymbol$($this);
    };
    $java.oncie_Xor_lhs = function($this) {
        return $this.$lhs10;
    };
    $java.oncie_Xor_rhs = function($this) {
        return $this.$rhs11;
    };
    $java.oncie_Xor_position = function($this) {
        return $this.$position145;
    };
    $java.oncie_Xor_signatures = function($this) {
        return $this.$signatures1;
    };
    $java.oncie_Xor_productPrefix = function($this) {
        return $rt_s(2084);
    };
    $java.oncie_Xor_productArity = function($this) {
        return 2;
    };
    $java.oncie_Xor_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs10;
            case 1:
                return $this.$rhs11;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Xor_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Xor_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Xor_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Xor_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Xor) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs10;
                        var$3 = $x$1.$lhs10;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs11;
                        $x$1 = $x$1.$rhs11;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Xor))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Xor__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs10 = $lhs;
        $this.$rhs11 = $rhs;
        $this.$position145 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_BooleanType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures1 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function sci_HashCollisionSetNode$diff$lambda$_19_0() {
        var a = this; jl_Object.call(a);
        a.$_0426 = null;
        a.$_1125 = null;
        a.$_247 = 0;
    }
    function sci_HashCollisionSetNode$diff$lambda$_19_0__init_(var_0, var_1, var_2) {
        var var_3 = new sci_HashCollisionSetNode$diff$lambda$_19_0();
        $java.sci_HashCollisionSetNode$diff$lambda$_19_0__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.sci_HashCollisionSetNode$diff$lambda$_19_0__init_ = function(var$0, var$1, var$2, var$3) {
        var$0.$_0426 = var$1;
        var$0.$_1125 = var$2;
        var$0.$_247 = var$3;
    };
    $java.sci_HashCollisionSetNode$diff$lambda$_19_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sci_HashCollisionSetNode_$anonfun$diff$2(var$0.$_0426, var$0.$_1125, var$0.$_247, var$1));
    };
    function sci_HashCollisionSetNode$diff$lambda$_19_1() {
        var a = this; jl_Object.call(a);
        a.$_0427 = null;
        a.$_1126 = 0;
        a.$_248 = null;
    }
    function sci_HashCollisionSetNode$diff$lambda$_19_1__init_(var_0, var_1, var_2) {
        var var_3 = new sci_HashCollisionSetNode$diff$lambda$_19_1();
        $java.sci_HashCollisionSetNode$diff$lambda$_19_1__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.sci_HashCollisionSetNode$diff$lambda$_19_1__init_ = function(var$0, var$1, var$2, var$3) {
        var$0.$_0427 = var$1;
        var$0.$_1126 = var$2;
        var$0.$_248 = var$3;
    };
    $java.sci_HashCollisionSetNode$diff$lambda$_19_1_apply = function(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$1(var$0.$_0427, var$0.$_1126, var$0.$_248, var$1);
    };
    function sci_HashCollisionSetNode$diff$lambda$_19_2() {
        var a = this; jl_Object.call(a);
        a.$_0428 = null;
        a.$_1127 = 0;
        a.$_249 = null;
    }
    function sci_HashCollisionSetNode$diff$lambda$_19_2__init_(var_0, var_1, var_2) {
        var var_3 = new sci_HashCollisionSetNode$diff$lambda$_19_2();
        $java.sci_HashCollisionSetNode$diff$lambda$_19_2__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.sci_HashCollisionSetNode$diff$lambda$_19_2__init_ = function(var$0, var$1, var$2, var$3) {
        var$0.$_0428 = var$1;
        var$0.$_1127 = var$2;
        var$0.$_249 = var$3;
    };
    $java.sci_HashCollisionSetNode$diff$lambda$_19_2_apply = function(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$2(var$0.$_0428, var$0.$_1127, var$0.$_249, var$1);
    };
    $java.sci_HashCollisionMapNode$foreachEntry$lambda$_24_0 = function() {
        jl_Object.call(this);
        this.$_0320 = null;
    };
    $java.sci_HashCollisionMapNode$foreachEntry$lambda$_24_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0320;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(null));
        return var$2.$apply0(var$1.$_10, var$1.$_20);
    };
    function onciuh_TreeZipper$TreeContext() {
        var a = this; jl_Object.call(a);
        a.$left2 = null;
        a.$parent1 = null;
        a.$right1 = null;
        a.$$outer40 = null;
    }
    function onciuh_TreeZipper$TreeContext__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new onciuh_TreeZipper$TreeContext();
        $java.onciuh_TreeZipper$TreeContext__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.onciuh_TreeZipper$TreeContext_productPrefix = function($this) {
        return $rt_s(2085);
    };
    $java.onciuh_TreeZipper$TreeContext_productArity = function($this) {
        return 3;
    };
    $java.onciuh_TreeZipper$TreeContext_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$left2;
            case 1:
                return $this.$parent1;
            case 2:
                return $this.$right1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciuh_TreeZipper$TreeContext_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciuh_TreeZipper$TreeContext_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciuh_TreeZipper$TreeContext_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciuh_TreeZipper$TreeContext_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!($x$1 instanceof onciuh_TreeZipper$TreeContext && $x$1.$$outer40 === $this.$$outer40 ? 1 : 0))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$left2;
                        var$3 = $x$1.$left2;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$parent1;
                        var$3 = $x$1.$parent1;
                        if (var$2 !== null) {
                            if (!onciuh_TreeZipper$Location_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$right1;
                        $x$1 = $x$1.$right1;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciuh_TreeZipper$TreeContext))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.onciuh_TreeZipper$TreeContext__init_ = function($this, $$outer, $left, $parent, $right) {
        $this.$left2 = $left;
        $this.$parent1 = $parent;
        $this.$right1 = $right;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer40 = $$outer;
    };
    $java.oncias_SemanticCheck$$fromState$lambda$_8_0 = function() {
        jl_Object.call(this);
        this.$_0366 = null;
    };
    $java.oncias_SemanticCheck$$fromState$lambda$_8_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0366.$apply(var$1.$state);
    };
    function oncias_SemanticState$$recordCurrentScope$lambda$_7_0() {
        jl_Object.call(this);
        this.$_0214 = null;
    }
    $java.oncias_SemanticState$$recordCurrentScope$lambda$_7_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0214;
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, oncias_SemanticState_recordCurrentScope(var$1, var$2));
    };
    $java.oncias_package$$liftSemanticErrorDefOption$lambda$_7_0 = function() {
        jl_Object.call(this);
        this.$_0373 = null;
    };
    $java.oncias_package$$liftSemanticErrorDefOption$lambda$_7_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0373;
        return oncias_SemanticCheckResult__init_(var$1, sc_AbstractIterable_toVector(s_Option$_option2Iterable(s_Option$_MODULE$, var$2)));
    };
    var oncie_ExplicitParameter$ = $rt_classWithoutFields();
    $java.oncie_ExplicitParameter$_MODULE$ = null;
    function oncie_ExplicitParameter$__clinit_() {
        $java.oncie_ExplicitParameter$_MODULE$ = new oncie_ExplicitParameter$;
    }
    function su_Either$LeftProjection() {
        jl_Object.call(this);
        this.$e0 = null;
    }
    function su_Either$LeftProjection_map($this, $f) {
        var var$2, $a;
        var$2 = $this.$e0;
        if (!(var$2 instanceof su_Left))
            return var$2;
        $a = var$2.$value11;
        return su_Left__init_($f.$apply($a));
    }
    $java.su_Either$LeftProjection_toOption = function($this) {
        var var$1;
        var$1 = $this.$e0;
        if (!(var$1 instanceof su_Left))
            return s_None$_MODULE$;
        return s_Some__init_(var$1.$value11);
    };
    var onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$returnItems.$includeExisting);
    };
    var onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_1_apply = function(var$0, var$1) {
        return (var$1.$returnItems.$items.$map1(new $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$2$lambda$_499_0)).$toList();
    };
    var onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_2 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_2_apply = function(var$0) {
        s_package$_$callClinit();
        s_package$_List0(s_package$_MODULE$);
        return sci_Nil$_MODULE$;
    };
    function oncia_ShowUserPrivileges() {
        var a = this; jl_Object.call(a);
        a.$user = null;
        a.$position146 = null;
    }
    function oncia_ShowUserPrivileges__init_(var_0, var_1) {
        var var_2 = new oncia_ShowUserPrivileges();
        $java.oncia_ShowUserPrivileges__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_ShowUserPrivileges_productPrefix = function($this) {
        return $rt_s(2086);
    };
    $java.oncia_ShowUserPrivileges_productArity = function($this) {
        return 1;
    };
    $java.oncia_ShowUserPrivileges_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$user;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowUserPrivileges_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowUserPrivileges_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowUserPrivileges_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowUserPrivileges_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowUserPrivileges) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$user;
                        $x$1 = $x$1.$user;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ShowUserPrivileges_dup = function($this, $children) {
        return oncia_ShowUserPrivileges__init_($children.$head(), $this.$position146);
    };
    $java.oncia_ShowUserPrivileges__init_ = function($this, $user, $position) {
        $this.$user = $user;
        $this.$position146 = $position;
    };
    function oncia_ShowUsersPrivileges() {
        var a = this; jl_Object.call(a);
        a.$users = null;
        a.$position147 = null;
    }
    function oncia_ShowUsersPrivileges__init_(var_0, var_1) {
        var var_2 = new oncia_ShowUsersPrivileges();
        $java.oncia_ShowUsersPrivileges__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_ShowUsersPrivileges_productPrefix = function($this) {
        return $rt_s(2087);
    };
    $java.oncia_ShowUsersPrivileges_productArity = function($this) {
        return 1;
    };
    $java.oncia_ShowUsersPrivileges_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$users;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowUsersPrivileges_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowUsersPrivileges_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowUsersPrivileges_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowUsersPrivileges_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ShowUsersPrivileges) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$users;
                        $x$1 = $x$1.$users;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ShowUsersPrivileges_dup = function($this, $children) {
        return oncia_ShowUsersPrivileges__init_($children.$head(), $this.$position147);
    };
    $java.oncia_ShowUsersPrivileges__init_ = function($this, $users, $position) {
        $this.$users = $users;
        $this.$position147 = $position;
    };
    var onciafn_Neo4jASTFactory$userPrivilegeScope$lambda$_176_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$userPrivilegeScope$lambda$_176_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    $java.ju_IllegalFormatException = $rt_classWithoutFields(jl_IllegalArgumentException);
    $java.ju_UnknownFormatConversionException = function() {
        $java.ju_IllegalFormatException.call(this);
        this.$conversion0 = null;
    };
    $java.ju_UnknownFormatConversionException__init_ = function(var_0) {
        var var_1 = new $java.ju_UnknownFormatConversionException();
        $java.ju_UnknownFormatConversionException__init_0(var_1, var_0);
        return var_1;
    };
    $java.ju_UnknownFormatConversionException__init_0 = function($this, $conversion) {
        var var$2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2088)), $conversion);
        jl_Throwable__init_($this, jl_AbstractStringBuilder_toString(var$2));
        $this.$conversion0 = $conversion;
    };
    function oncia_AliasedReturnItem() {
        var a = this; jl_Object.call(a);
        a.$expression10 = null;
        a.$variable13 = null;
        a.$position148 = null;
        a.$alias1 = null;
        a.$name48 = null;
    }
    function oncia_AliasedReturnItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_AliasedReturnItem();
        $java.oncia_AliasedReturnItem__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_AliasedReturnItem_isPassThrough = function($this) {
        return oncia_ReturnItem_isPassThrough$($this);
    };
    $java.oncia_AliasedReturnItem_semanticCheck = function($this) {
        return oncia_ReturnItem_semanticCheck$($this);
    };
    $java.oncia_AliasedReturnItem_expression = function($this) {
        return $this.$expression10;
    };
    $java.oncia_AliasedReturnItem_position = function($this) {
        return $this.$position148;
    };
    $java.oncia_AliasedReturnItem_alias = function($this) {
        return $this.$alias1;
    };
    $java.oncia_AliasedReturnItem_name = function($this) {
        return $this.$name48;
    };
    $java.oncia_AliasedReturnItem_copy = function($this, $expression, $variable, $position) {
        return oncia_AliasedReturnItem__init_($expression, $variable, $position);
    };
    $java.oncia_AliasedReturnItem_productPrefix = function($this) {
        return $rt_s(2089);
    };
    $java.oncia_AliasedReturnItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_AliasedReturnItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression10;
            case 1:
                return $this.$variable13;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AliasedReturnItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AliasedReturnItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AliasedReturnItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AliasedReturnItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_AliasedReturnItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression10;
                        var$3 = $x$1.$expression10;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$variable13;
                        $x$1 = $x$1.$variable13;
                        if (var$3 !== null) {
                            if (!$java.oncie_Variable_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_AliasedReturnItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_AliasedReturnItem_dup = function($this, $children) {
        return $java.oncia_AliasedReturnItem_copy($this, $children.$head(), $children.$apply1(1), $this.$position148);
    };
    $java.oncia_AliasedReturnItem__init_ = function($this, $expression, $variable, $position) {
        $this.$expression10 = $expression;
        $this.$variable13 = $variable;
        $this.$position148 = $position;
        $this.$alias1 = s_Some__init_($variable);
        $this.$name48 = $variable.$name4;
    };
    $java.oncia_UnmappedUnion$checkColumnNamesAgree$lambda$_8_0 = function() {
        jl_Object.call(this);
        this.$_0347 = null;
    };
    $java.oncia_UnmappedUnion$checkColumnNamesAgree$lambda$_8_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0347;
        var$3 = var$1.$currentScope.$elem;
        if (!(var$2.$lhs()).$isReturning()) {
            oncias_Scope$_$callClinit();
            var$4 = oncias_Scope$_empty(oncias_Scope$_MODULE$);
        } else
            var$4 = (var$2.$lhs()).$finalScope(var$3.$children1.$head());
        if (!$java.oncia_SingleQuery_isReturning(var$2.$rhs())) {
            oncias_Scope$_$callClinit();
            var$5 = oncias_Scope$_empty(oncias_Scope$_MODULE$);
        } else
            var$5 = $java.oncia_SingleQuery_finalScope(var$2.$rhs(), var$3.$children1.$last());
        a: {
            b: {
                c: {
                    var$4 = oncias_Scope_symbolNames(var$4);
                    var$5 = oncias_Scope_symbolNames(var$5);
                    if (var$4 === null) {
                        if (var$5 === null)
                            break c;
                        break b;
                    }
                    if (!sc_Set_equals$(var$4, var$5))
                        break b;
                }
                s_package$_$callClinit();
                var$3 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
                break a;
            }
            var$3 = sci_$colon$colon__init_(oncias_SemanticError__init_0($rt_s(2090), var$2.$position2()), sci_Nil$_MODULE$);
        }
        return oncias_SemanticCheckResult__init_(var$1, var$3);
    };
    $java.onciafn_DecorateTuple$asScalaEither$lambda$_1_0 = function() {
        jl_Object.call(this);
        this.$_0385 = null;
    };
    $java.oncius_CypherType$$normalize$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        if (var$1 instanceof oncius_PropertyValueType)
            var$2 = $java.oncius_PropertyValueType_expandToTypes(var$1);
        else if (!(var$1 instanceof $java.oncius_NumberType)) {
            if (!(var$1 instanceof $java.oncius_GeometryType))
                var$2 = sci_$colon$colon__init_(var$1, sci_Nil$_MODULE$);
            else {
                var$1 = var$1;
                var$2 = sci_$colon$colon__init_(oncius_PointType__init_(var$1.$isNullable19, var$1.$position113), sci_Nil$_MODULE$);
            }
        } else {
            var$1 = var$1;
            var$2 = sci_$colon$colon__init_(oncius_IntegerType__init_(var$1.$isNullable20, var$1.$position114), sci_$colon$colon__init_(oncius_FloatType__init_(var$1.$isNullable20, var$1.$position114), sci_Nil$_MODULE$));
        }
        return var$2;
    };
    $java.oncius_CypherType$$normalize$lambda$_3_1 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_1_apply = function(var$0, var$1) {
        return var$1.$simplify();
    };
    $java.oncius_CypherType$$normalize$lambda$_3_2 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncius_CypherType$_normalizeTypes($java.oncius_CypherType$_MODULE$, var$1);
    };
    $java.oncius_CypherType$$normalize$lambda$_3_3 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_3_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = s_Tuple2__init_(var$1, var$2);
        var$1 = var$3.$_10;
        var$2 = var$3.$_20;
        var$3 = new $java.oncius_CypherType$$$anonfun$normalize$4$lambda$_12_0;
        var$3.$_0429 = var$2;
        return (sci_List_filterNot(var$1, var$3)).$appended(var$2);
    };
    $java.oncius_CypherType$$normalize$lambda$_3_4 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_4_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isNullable());
    };
    $java.oncius_CypherType$$normalize$lambda$_3_5 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_5_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isNullable() ? 0 : 1);
    };
    $java.oncius_CypherType$$normalize$lambda$_3_6 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_6_apply = function(var$0, var$1) {
        var$1 = var$1;
        if (!var$1.$isNullable())
            var$1 = var$1.$updateIsNullable(1);
        return var$1;
    };
    $java.oncius_CypherType$$normalize$lambda$_3_7 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_7_apply = function(var$0, var$1) {
        var$1 = var$1;
        onciu_InputPosition$_$callClinit();
        return var$1.$withPosition0(onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
    };
    $java.oncius_CypherType$$normalize$lambda$_3_8 = function() {
        jl_Object.call(this);
        this.$_0401 = null;
    };
    $java.oncius_CypherType$$normalize$lambda$_3_8_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sci_List_contains(var$0.$_0401, var$1));
    };
    $java.oncius_CypherType$$normalize$lambda$_3_9 = $rt_classWithoutFields();
    $java.oncius_CypherType$$normalize$lambda$_3_9_apply = function(var$0, var$1) {
        return var$1.$position2();
    };
    $java.jnci_AsciiCharset = $rt_classWithoutFields(jnc_Charset);
    $java.jnci_Iso8859Charset = $rt_classWithoutFields(jnc_Charset);
    $java.jnci_UTF16Charset = function() {
        var a = this; jnc_Charset.call(a);
        a.$bom = 0;
        a.$littleEndian = 0;
    };
    $java.jnci_UTF16Charset__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.jnci_UTF16Charset();
        $java.jnci_UTF16Charset__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.jnci_UTF16Charset__init_0 = function($this, $canonicalName, $bom, $littleEndian) {
        jnc_Charset__init_($this, $canonicalName, $rt_createArray(jl_String, 0));
        $this.$bom = $bom;
        $this.$littleEndian = $littleEndian;
    };
    function ju_TemplateCollections$SingleElementList() {
        ju_TemplateCollections$AbstractImmutableList.call(this);
        this.$value0 = null;
    }
    $java.ju_TemplateCollections$SingleElementList_size = function($this) {
        return 1;
    };
    $java.ju_TemplateCollections$SingleElementList_get = function($this, $index) {
        var var$2;
        if (!$index)
            return $this.$value0;
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$2);
        $rt_throw(var$2);
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$merge$1 = null;
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1_applyOrElse = function($this, $x1, $default) {
        var $a, $exprs;
        if ($x1 instanceof oncie_In) {
            $x1 = $x1;
            $a = $x1.$lhs9;
            $x1 = $x1.$rhs10;
            if ($x1 instanceof oncie_ListLiteral) {
                $exprs = $x1.$expressions1;
                $x1 = new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$applyOrElse$lambda$_0_0;
                $x1.$_0430 = $this;
                $x1.$_1128 = $a;
                $x1.$_250 = $exprs;
                return $x1;
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    $java.ju_DuplicateFormatFlagsException = function() {
        $java.ju_IllegalFormatException.call(this);
        this.$flags2 = null;
    };
    $java.ju_IllegalFormatPrecisionException = function() {
        $java.ju_IllegalFormatException.call(this);
        this.$precision1 = 0;
    };
    $java.ju_IllegalFormatPrecisionException__init_ = function(var_0) {
        var var_1 = new $java.ju_IllegalFormatPrecisionException();
        $java.ju_IllegalFormatPrecisionException__init_0(var_1, var_0);
        return var_1;
    };
    $java.ju_IllegalFormatPrecisionException__init_0 = function($this, $precision) {
        var var$2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$2, $rt_s(2091)), $precision);
        jl_Throwable__init_($this, jl_AbstractStringBuilder_toString(var$2));
        $this.$precision1 = $precision;
    };
    $java.ju_IllegalFormatCodePointException = function() {
        $java.ju_IllegalFormatException.call(this);
        this.$codePoint = 0;
    };
    $java.ju_IllegalFormatConversionException = function() {
        var a = this; $java.ju_IllegalFormatException.call(a);
        a.$conversion1 = 0;
        a.$argumentClass = null;
    };
    $java.ju_IllegalFormatConversionException__init_ = function(var_0, var_1) {
        var var_2 = new $java.ju_IllegalFormatConversionException();
        $java.ju_IllegalFormatConversionException__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.ju_IllegalFormatConversionException__init_0 = function($this, $conversion, $argumentClass) {
        var var$3, var$4;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$4 = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2092)), $argumentClass), $rt_s(2093));
        jl_AbstractStringBuilder_append(var$4, $conversion);
        jl_StringBuilder_append(var$4, $rt_s(2094));
        jl_Throwable__init_($this, jl_AbstractStringBuilder_toString(var$3));
        $this.$conversion1 = $conversion;
        $this.$argumentClass = $argumentClass;
    };
    $java.jt_DecimalFormatSymbols = function() {
        var a = this; jl_Object.call(a);
        a.$locale1 = null;
        a.$zeroDigit = 0;
        a.$groupingSeparator = 0;
        a.$decimalSeparator = 0;
        a.$perMill = 0;
        a.$percent = 0;
        a.$digit = 0;
        a.$patternSeparator = 0;
        a.$nan = null;
        a.$infinity = null;
        a.$minusSign = 0;
        a.$monetaryDecimalSeparator = 0;
        a.$exponentSeparator = null;
    };
    $java.jt_DecimalFormatSymbols__init_ = function(var_0) {
        var var_1 = new $java.jt_DecimalFormatSymbols();
        $java.jt_DecimalFormatSymbols__init_0(var_1, var_0);
        return var_1;
    };
    $java.jt_DecimalFormatSymbols__init_0 = function($this, $locale) {
        var var$2, var$3, var$4;
        $this.$locale1 = $locale;
        var$2 = $locale.$languageCode;
        var$3 = $locale.$countryCode;
        if ($java.otciu_CLDRHelper_$$metadata$$20 === null)
            $java.otciu_CLDRHelper_$$metadata$$20 = $java.otciu_CLDRHelper_getDecimalDataMap$$create();
        var$4 = $java.otciu_CLDRHelper_$$metadata$$20;
        $locale = $java.otciu_CLDRHelper_getCode(var$2, var$3);
        var$4 = var$4.hasOwnProperty($rt_ustr($locale)) ? var$4[$rt_ustr($locale)] : var$4.hasOwnProperty($rt_ustr(var$2)) ? var$4[$rt_ustr(var$2)] : var$4.root;
        $this.$zeroDigit = 48;
        $this.$groupingSeparator = var$4.groupingSeparator & 65535;
        $this.$decimalSeparator = var$4.decimalSeparator & 65535;
        $this.$perMill = var$4.perMille & 65535;
        $this.$percent = var$4.percent & 65535;
        $this.$digit = 35;
        $this.$patternSeparator = 59;
        $this.$nan = (var$4.naN !== null ? $rt_str(var$4.naN) : null);
        $this.$infinity = (var$4.infinity !== null ? $rt_str(var$4.infinity) : null);
        $this.$minusSign = var$4.minusSign & 65535;
        $this.$monetaryDecimalSeparator = var$4.decimalSeparator & 65535;
        $this.$exponentSeparator = (var$4.exponentSeparator !== null ? $rt_str(var$4.exponentSeparator) : null);
    };
    $java.jt_DecimalFormatSymbols_clone = function($this) {
        var var$1, $e, var$3, $$je;
        a: {
            try {
                var$1 = jl_Object_clone($this);
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_CloneNotSupportedException) {
                    $e = $$je;
                    break a;
                } else {
                    throw $$e;
                }
            }
            return var$1;
        }
        var$3 = new jl_AssertionError;
        jl_Throwable__init_4(var$3, $rt_s(2095), $e);
        $rt_throw(var$3);
    };
    $java.jt_Format = $rt_classWithoutFields();
    $java.jt_NumberFormat = function() {
        var a = this; $java.jt_Format.call(a);
        a.$groupingUsed = 0;
        a.$maximumIntegerDigits = 0;
        a.$minimumIntegerDigits = 0;
        a.$maximumFractionDigits = 0;
        a.$minimumFractionDigits = 0;
        a.$roundingMode0 = null;
        a.$currency = null;
    };
    function jt_DecimalFormat() {
        var a = this; $java.jt_NumberFormat.call(a);
        a.$symbols = null;
        a.$positivePrefix = null;
        a.$negativePrefix = null;
        a.$positiveSuffix = null;
        a.$negativeSuffix = null;
        a.$multiplier = 0;
        a.$groupingSize = 0;
        a.$decimalSeparatorAlwaysShown = 0;
        a.$exponentDigits = 0;
        a.$pattern5 = null;
    }
    $java.jt_DecimalFormat_POW10_ARRAY = null;
    $java.jt_DecimalFormat_POW10_INT_ARRAY = null;
    $java.jt_DecimalFormat_applyPattern = function($this, $pattern) {
        var $parser, var$3, var$4, var$5, var$6, var$7;
        $parser = new $java.jt_DecimalFormatParser;
        $parser.$groupSize = 0;
        $parser.$minimumFracLength = 0;
        $parser.$fracLength = 0;
        $parser.$exponentLength = 0;
        $parser.$decimalSeparatorRequired = 0;
        $parser.$multiplier0 = 1;
        $parser.$string1 = $pattern;
        $parser.$index4 = 0;
        $parser.$positivePrefix0 = $java.jt_DecimalFormatParser_parseText($parser, 0, 0);
        if ($parser.$index4 == jl_String_length($pattern)) {
            $parser = new jl_IllegalArgumentException;
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2096)), $pattern);
            jl_Throwable__init_($parser, jl_AbstractStringBuilder_toString(var$3));
            $rt_throw($parser);
        }
        $java.jt_DecimalFormatParser_parseNumber($parser, 1);
        $parser.$negativePrefix0 = null;
        $parser.$negativeSuffix0 = null;
        if ($parser.$index4 < jl_String_length($pattern) && jl_String_charAt($pattern, $parser.$index4) != 59)
            $parser.$positiveSuffix0 = $java.jt_DecimalFormatParser_parseText($parser, 1, 0);
        if ($parser.$index4 < jl_String_length($pattern)) {
            var$4 = $parser.$index4;
            $parser.$index4 = var$4 + 1 | 0;
            if (jl_String_charAt($pattern, var$4) != 59) {
                var$3 = new jl_IllegalArgumentException;
                var$5 = $parser.$index4;
                $parser = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($parser);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append($parser, $rt_s(2097)), var$5), $rt_s(2098)), $pattern);
                jl_Throwable__init_(var$3, jl_AbstractStringBuilder_toString($parser));
                $rt_throw(var$3);
            }
            $parser.$negativePrefix0 = $java.jt_DecimalFormatParser_parseText($parser, 0, 1);
            $java.jt_DecimalFormatParser_parseNumber($parser, 0);
            $parser.$negativeSuffix0 = $java.jt_DecimalFormatParser_parseText($parser, 1, 1);
        }
        var$6 = $parser.$positivePrefix0;
        $this.$positivePrefix = var$6;
        $this.$positiveSuffix = $parser.$positiveSuffix0;
        var$7 = $parser.$negativePrefix0;
        if (var$7 !== null)
            $this.$negativePrefix = var$7;
        else {
            var$4 = var$6.data.length;
            var$7 = $rt_createArray($java.jt_DecimalFormat$FormatField, var$4 + 1 | 0);
            $this.$negativePrefix = var$7;
            jl_System_arraycopy(var$6, 0, var$7, 1, var$4);
            $this.$negativePrefix.data[0] = new $java.jt_DecimalFormat$MinusField;
        }
        var$6 = $parser.$negativeSuffix0;
        if (var$6 === null)
            var$6 = $parser.$positiveSuffix0;
        $this.$negativeSuffix = var$6;
        var$5 = $parser.$groupSize;
        $this.$groupingSize = var$5;
        $this.$groupingUsed = var$5 <= 0 ? 0 : 1;
        var$4 = !$parser.$decimalSeparatorRequired ? $parser.$minimumIntLength : jl_Math_max(1, $parser.$minimumIntLength);
        if (var$4 < 0)
            var$4 = 0;
        $this.$minimumIntegerDigits = var$4;
        if ($this.$maximumIntegerDigits < var$4)
            $this.$maximumIntegerDigits = var$4;
        var$5 = $parser.$intLength;
        if (var$5 < 0)
            var$5 = 0;
        $this.$maximumIntegerDigits = var$5;
        if (var$5 < var$4)
            $this.$minimumIntegerDigits = var$5;
        var$5 = $parser.$minimumFracLength;
        if (var$5 < 0)
            var$5 = 0;
        $this.$minimumFractionDigits = var$5;
        if ($this.$maximumFractionDigits < var$5)
            $this.$maximumFractionDigits = var$5;
        var$4 = $parser.$fracLength;
        if (var$4 < 0)
            var$4 = 0;
        $this.$maximumFractionDigits = var$4;
        if (var$4 < var$5)
            $this.$minimumFractionDigits = var$4;
        $this.$decimalSeparatorAlwaysShown = $parser.$decimalSeparatorRequired;
        $this.$exponentDigits = $parser.$exponentLength;
        $this.$multiplier = $parser.$multiplier0;
        $this.$pattern5 = $pattern;
    };
    $java.jt_DecimalFormat_getGroupingSize = function($this) {
        return $this.$groupingSize;
    };
    function jt_DecimalFormat__clinit_() {
        $java.jt_DecimalFormat_POW10_ARRAY = $rt_createLongArrayFromData([Long_fromInt(1), Long_fromInt(10), Long_fromInt(100), Long_fromInt(1000), Long_fromInt(10000), Long_fromInt(100000), Long_fromInt(1000000), Long_fromInt(10000000), Long_fromInt(100000000), Long_fromInt(1000000000), Long_create(1410065408, 2), Long_create(1215752192, 23), Long_create(3567587328, 232), Long_create(1316134912, 2328), Long_create(276447232, 23283), Long_create(2764472320, 232830), Long_create(1874919424, 2328306), Long_create(1569325056, 23283064),
        Long_create(2808348672, 232830643)]);
        $java.jt_DecimalFormat_POW10_INT_ARRAY = $rt_createIntArrayFromData([1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000]);
    }
    $java.ju_Formattable = $rt_classWithoutFields(0);
    function oncias_SemanticCheck$FlatMap() {
        var a = this; jl_Object.call(a);
        a.$check1 = null;
        a.$f6 = null;
    }
    $java.oncias_SemanticCheck$FlatMap_run = function($this, $state, $context) {
        return oncias_SemanticCheck_run$($this, $state, $context);
    };
    $java.oncias_SemanticCheck$FlatMap_apply = function($this, $state) {
        return oncias_SemanticCheck_apply$($this, $state);
    };
    $java.oncias_SemanticCheck$FlatMap_chain = function($this, $next) {
        return oncias_SemanticCheck_chain$($this, $next);
    };
    $java.oncias_SemanticCheck$FlatMap_ifOkChain = function($this, $next) {
        return oncias_SemanticCheck_ifOkChain$($this, $next);
    };
    $java.oncias_SemanticCheck$FlatMap_map = function($this, $f) {
        return oncias_SemanticCheck_map$($this, $f);
    };
    $java.oncias_SemanticCheck$FlatMap_flatMap = function($this, $f) {
        return oncias_SemanticCheck_flatMap$($this, $f);
    };
    $java.oncias_SemanticCheck$FlatMap_productPrefix = function($this) {
        return $rt_s(2099);
    };
    $java.oncias_SemanticCheck$FlatMap_productArity = function($this) {
        return 2;
    };
    $java.oncias_SemanticCheck$FlatMap_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$check1;
            case 1:
                return $this.$f6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheck$FlatMap_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$FlatMap_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$FlatMap_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$FlatMap_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_SemanticCheck$FlatMap) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$check1;
                            var$3 = $x$1.$check1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$f6;
                        $x$1 = $x$1.$f6;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function sc_Iterator$GroupedIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$self3 = null;
        a.$size8 = 0;
        a.$step4 = 0;
        a.$buffer3 = null;
        a.$prev = null;
        a.$first3 = 0;
        a.$filled = 0;
        a.$partial = 0;
        a.$padding = null;
        a.$$outer41 = null;
    }
    function sc_Iterator$GroupedIterator__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new sc_Iterator$GroupedIterator();
        $java.sc_Iterator$GroupedIterator__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.sc_Iterator$GroupedIterator_newBuilder = function($this) {
        var $make_evidence$1, var$2, $b, $k;
        a: {
            sr_ClassTag$_$callClinit();
            $make_evidence$1 = sr_ClassTag$_Any(sr_ClassTag$_MODULE$);
            var$2 = $make_evidence$1.$runtimeClass0;
            if (jl_Object_equals($rt_cls($rt_bytecls()), var$2)) {
                $b = new scm_ArrayBuilder$ofByte;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_shortcls()), var$2)) {
                $b = new scm_ArrayBuilder$ofShort;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_charcls()), var$2)) {
                $b = new scm_ArrayBuilder$ofChar;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_intcls()), var$2)) {
                $b = new scm_ArrayBuilder$ofInt;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_longcls()), var$2)) {
                $b = new scm_ArrayBuilder$ofLong;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_floatcls()), var$2)) {
                $b = new scm_ArrayBuilder$ofFloat;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_doublecls()), var$2)) {
                $b = new scm_ArrayBuilder$ofDouble;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_booleancls()), var$2)) {
                $b = new scm_ArrayBuilder$ofBoolean;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (!jl_Object_equals($rt_cls($rt_voidcls()), var$2)) {
                $b = scm_ArrayBuilder$ofRef__init_($make_evidence$1);
                break a;
            }
            $b = new scm_ArrayBuilder$ofUnit;
            scm_ArrayBuilder__init_($b);
        }
        $k = $this.$self3.$knownSize();
        if ($k > 0)
            scm_ArrayBuilder_sizeHint($b, jl_Math_min($k, $this.$size8));
        return $b;
    };
    $java.sc_Iterator$GroupedIterator_fill = function($this) {
        var var$1, var$2, var$3, var$4, var$5;
        if (!$this.$filled) {
            a: {
                if ($this.$self3.$hasNext()) {
                    var$1 = $java.sc_Iterator$GroupedIterator_newBuilder($this);
                    var$2 = 0;
                    var$3 = $this.$prev;
                    if (var$3 !== null)
                        scm_ArrayBuilder_addAll(var$1, var$3);
                    if (!$this.$first3) {
                        var$4 = $this.$step4;
                        var$5 = $this.$size8;
                        if (var$4 > var$5) {
                            var$2 = var$4 - var$5 | 0;
                            while (true) {
                                var$4 = $rt_compare(var$2, 0);
                                if (var$4 <= 0)
                                    break;
                                if (!$this.$self3.$hasNext())
                                    break;
                                $this.$self3.$next();
                                var$2 = var$2 + (-1) | 0;
                            }
                            var$2 = var$4 <= 0 ? 0 : 1;
                        }
                    }
                    var$4 = var$1.$size9;
                    if (!var$2) {
                        while (var$4 < $this.$size8 && $this.$self3.$hasNext()) {
                            var$1.$addOne($this.$self3.$next());
                            var$4 = var$4 + 1 | 0;
                        }
                        var$2 = $this.$size8;
                        if (var$4 < var$2 && ($this.$padding === null ? 0 : 1)) {
                            scm_ArrayBuilder_sizeHint(var$1, var$2);
                            while (var$4 < $this.$size8) {
                                var$1.$addOne($this.$padding.$apply2());
                                var$4 = var$4 + 1 | 0;
                            }
                        }
                    }
                    b: {
                        c: {
                            if (var$4 > 0) {
                                if ($this.$partial)
                                    break c;
                                if (var$4 == $this.$size8)
                                    break c;
                            }
                            var$2 = 0;
                            break b;
                        }
                        var$2 = 1;
                    }
                    if (!var$2)
                        $this.$prev = null;
                    else
                        $this.$buffer3 = var$1.$result0();
                    if (var$2) {
                        var$2 = 1;
                        break a;
                    }
                }
                var$2 = 0;
            }
            $this.$filled = var$2;
            if (!var$2)
                return 0;
        }
        return 1;
    };
    $java.sc_Iterator$GroupedIterator_hasNext = function($this) {
        return $java.sc_Iterator$GroupedIterator_fill($this);
    };
    $java.sc_Iterator$GroupedIterator_next = function($this) {
        var var$1, var$2, var$3, var$4, var$5;
        if (!$java.sc_Iterator$GroupedIterator_fill($this))
            var$1 = sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        else {
            $this.$filled = 0;
            var$2 = $this.$step4;
            if (var$2 < $this.$size8) {
                if ($this.$first3)
                    $this.$prev = sc_ArrayOps$_drop$extension(sc_ArrayOps$_MODULE$, $this.$buffer3, var$2);
                else {
                    var$2 = jlr_Array_getLength($this.$buffer3);
                    var$3 = $this.$size8;
                    if (var$2 != var$3)
                        $this.$prev = null;
                    else {
                        var$1 = s_Array$_MODULE$;
                        var$4 = $this.$buffer3;
                        var$5 = $this.$step4;
                        s_Array$_copy(var$1, var$4, var$5, $this.$prev, 0, var$3 - var$5 | 0);
                    }
                }
            }
            var$1 = sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, $this.$buffer3);
            $this.$buffer3 = null;
            $this.$first3 = 0;
        }
        return var$1;
    };
    $java.sc_Iterator$GroupedIterator__init_ = function($this, $$outer, $self, $size, $step) {
        var var$5, var$6;
        $this.$self3 = $self;
        $this.$size8 = $size;
        $this.$step4 = $step;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer41 = $$outer;
        if ($size >= 1 && $step >= 1 ? 1 : 0) {
            $this.$buffer3 = null;
            $this.$prev = null;
            $this.$first3 = 1;
            $this.$filled = 0;
            $this.$partial = 1;
            $this.$padding = null;
            return;
        }
        $self = new jl_IllegalArgumentException;
        $$outer = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($$outer, 20);
        jl_AbstractStringBuilder_append1($$outer, $rt_s(486));
        var$5 = sr_ScalaRunTime$_genericWrapArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_Object, [jl_Integer_valueOf($this.$size8), jl_Integer_valueOf($this.$step4)]));
        var$6 = new $java.sc_StringOps$$format$extension$lambda$_92_0;
        var$6.$_0431 = $rt_s(2100);
        var$6 = sci_ArraySeq_map(var$5, var$6);
        sr_ClassTag$_$callClinit();
        jl_Throwable__init_($self, jl_AbstractStringBuilder_toString(jl_StringBuilder_append($$outer, jl_String_format($rt_s(2100), sc_IterableOnceOps_toArray$(var$6, sr_ClassTag$_AnyRef(sr_ClassTag$_MODULE$))))));
        $rt_throw($self);
    };
    $java.oncia_ReturnItems$ReturnVariables = function() {
        var a = this; jl_Object.call(a);
        a.$includeExisting1 = 0;
        a.$explicitVariables = null;
    };
    $java.oncia_ReturnItems$ReturnVariables__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_ReturnItems$ReturnVariables();
        $java.oncia_ReturnItems$ReturnVariables__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_ReturnItems$ReturnVariables__init_0 = function($this, $includeExisting, $explicitVariables) {
        $this.$includeExisting1 = $includeExisting;
        $this.$explicitVariables = $explicitVariables;
    };
    $java.oncir_ValidatingRewriter$$anonfun$buildErrorMessage$2$lambda$_50_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0310 = null;
        a.$_192 = null;
    };
    $java.oncir_ValidatingRewriter$$anonfun$buildErrorMessage$2$lambda$_50_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0310;
        var$3 = var$0.$_192;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(2101)), var$3), $rt_s(2102)), var$1), 10);
        return scm_StringBuilder_$plus$plus$eq(var$2, jl_AbstractStringBuilder_toString(var$4));
    };
    $java.oncia_ProjectionClause$$anonfun$verifyOrderByAggregationUse$1$lambda$_58_0 = $rt_classWithoutFields();
    $java.oncia_ProjectionClause$$anonfun$verifyOrderByAggregationUse$1$lambda$_58_0_apply = function(var$0, var$1) {
        return var$1.$expression1();
    };
    var oncie_containsAggregate$ = $rt_classWithoutFields();
    $java.oncie_containsAggregate$_MODULE$ = null;
    function oncie_containsAggregate$__clinit_() {
        $java.oncie_containsAggregate$_MODULE$ = new oncie_containsAggregate$;
    }
    $java.oncie_containsAggregate$_apply = function($this, $v1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(onciu_Foldable$Folder_treeFold(onciu_Foldable_folder$($v1), jl_Boolean_valueOf(0), new $java.oncie_containsAggregate$$anonfun$apply$1)));
    };
    $java.ju_FormatFlagsConversionMismatchException = function() {
        var a = this; $java.ju_IllegalFormatException.call(a);
        a.$flags1 = null;
        a.$conversion = 0;
    };
    $java.ju_IllegalFormatFlagsException = function() {
        $java.ju_IllegalFormatException.call(this);
        this.$flags3 = null;
    };
    $java.ju_IllegalFormatFlagsException__init_ = function(var_0) {
        var var_1 = new $java.ju_IllegalFormatFlagsException();
        $java.ju_IllegalFormatFlagsException__init_0(var_1, var_0);
        return var_1;
    };
    $java.ju_IllegalFormatFlagsException__init_0 = function($this, $flags) {
        var var$2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2103)), $flags);
        jl_Throwable__init_($this, jl_AbstractStringBuilder_toString(var$2));
        $this.$flags3 = $flags;
    };
    $java.ju_MissingFormatWidthException = function() {
        $java.ju_IllegalFormatException.call(this);
        this.$formatSpecifier = null;
    };
    $java.oncia_SingleQuery$checkClauses$lambda$_73_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0334 = null;
        a.$_1102 = null;
        a.$_238 = 0;
    };
    $java.oncia_SingleQuery$checkClauses$lambda$_73_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$0.$_0334;
        var$3 = var$0.$_1102;
        var$4 = var$0.$_238;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$5 = var$1.$_10;
        var$6 = s_Tuple2__2$mcI$sp(var$1);
        var$1 = oncias_SemanticCheck$_MODULE$;
        var$7 = new $java.oncia_SingleQuery$$anonfun$checkClauses$1$lambda$_140_0;
        var$7.$_0432 = var$2;
        var$7.$_1129 = var$5;
        var$7.$_251 = var$3;
        var$7.$_310 = var$6;
        var$7.$_40 = var$4;
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck$_fromState(var$1, var$7), oncias_SemanticAnalysisTooling_recordCurrentScope$(var$2, var$5));
    };
    $java.jt_DecimalFormat$FormatField = $rt_classWithoutFields(0);
    $java.jt_DecimalFormat$TextField = function() {
        jl_Object.call(this);
        this.$text = null;
    };
    $java.jt_DecimalFormat$TextField__init_ = function(var_0) {
        var var_1 = new $java.jt_DecimalFormat$TextField();
        $java.jt_DecimalFormat$TextField__init_0(var_1, var_0);
        return var_1;
    };
    $java.jt_DecimalFormat$TextField__init_0 = function($this, $text) {
        $this.$text = $text;
    };
    $java.jt_DecimalFormat$TextField_equals = function($this, $obj) {
        var $other;
        if ($this === $obj)
            return 1;
        if (!($obj instanceof $java.jt_DecimalFormat$TextField))
            return 0;
        $other = $obj;
        return jl_String_equals($this.$text, $other.$text);
    };
    $java.jt_DecimalFormat$TextField_hashCode = function($this) {
        return jl_String_hashCode($this.$text);
    };
    $java.ju_Currency = function() {
        jl_Object.call(this);
        this.$resource2 = null;
    };
    $java.ju_Currency_currencies = null;
    $java.ju_Currency_initCurrencies = function() {
        var $resources, $i, $resource, var$4, var$5, var$6;
        if ($java.ju_Currency_currencies !== null)
            return;
        $java.ju_Currency_currencies = $java.ju_HashMap__init_();
        if ($java.otcic_CurrencyHelper_$$metadata$$0 === null)
            $java.otcic_CurrencyHelper_$$metadata$$0 = $java.otcic_CurrencyHelper_getCurrencies$$create();
        $resources = $java.otcic_CurrencyHelper_$$metadata$$0;
        $i = 0;
        while ($i < $resources.length) {
            $resource = $resources[$i];
            var$4 = $java.ju_Currency_currencies;
            var$5 = ($resource.code !== null ? $rt_str($resource.code) : null);
            var$6 = new $java.ju_Currency;
            var$6.$resource2 = $resource;
            ju_HashMap_put(var$4, var$5, var$6);
            $i = $i + 1 | 0;
        }
    };
    $java.ju_Currency_toString = function($this) {
        return ($this.$resource2.code !== null ? $rt_str($this.$resource2.code) : null);
    };
    $java.otcic_CurrencyHelper = $rt_classWithoutFields();
    $java.otcic_CurrencyHelper_$$metadata$$0 = null;
    $java.otcic_CurrencyHelper_$$metadata$$1 = null;
    $java.otcic_CurrencyHelper_getCurrencies$$create = function() {
        return [{"code" : "AFN", "fractionDigits" : 2, "numericCode" : 971}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "ALL", "fractionDigits" : 2, "numericCode" : 8}, {"code" : "DZD", "fractionDigits" : 2, "numericCode" : 12}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "AOA", "fractionDigits" : 2, "numericCode" : 973}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" : 951}, {"code" : null,
        "fractionDigits" : 0, "numericCode" : 0}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" : 951}, {"code" : "ARS", "fractionDigits" : 2, "numericCode" : 32}, {"code" : "AMD", "fractionDigits" : 2, "numericCode" : 51}, {"code" : "AWG", "fractionDigits" : 2, "numericCode" : 533}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "AZN", "fractionDigits" : 2, "numericCode" : 944}, {"code" : "BSD", "fractionDigits" : 2, "numericCode"
        : 44}, {"code" : "BHD", "fractionDigits" : 3, "numericCode" : 48}, {"code" : "BDT", "fractionDigits" : 2, "numericCode" : 50}, {"code" : "BBD", "fractionDigits" : 2, "numericCode" : 52}, {"code" : "BYR", "fractionDigits" : 0, "numericCode" : 974}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "BZD", "fractionDigits" : 2, "numericCode" : 84}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "BMD", "fractionDigits" : 2, "numericCode" : 60}, {"code" : "BTN", "fractionDigits"
        : 2, "numericCode" : 64}, {"code" : "INR", "fractionDigits" : 2, "numericCode" : 356}, {"code" : "BOB", "fractionDigits" : 2, "numericCode" : 68}, {"code" : "BOV", "fractionDigits" : 2, "numericCode" : 984}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "BAM", "fractionDigits" : 2, "numericCode" : 977}, {"code" : "BWP", "fractionDigits" : 2, "numericCode" : 72}, {"code" : "NOK", "fractionDigits" : 2, "numericCode" : 578}, {"code" : "BRL", "fractionDigits" : 2, "numericCode" : 986}
        , {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "BND", "fractionDigits" : 2, "numericCode" : 96}, {"code" : "BGN", "fractionDigits" : 2, "numericCode" : 975}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "BIF", "fractionDigits" : 0, "numericCode" : 108}, {"code" : "KHR", "fractionDigits" : 2, "numericCode" : 116}, {"code" : "XAF", "fractionDigits" : 0, "numericCode" : 950}, {"code" : "CAD", "fractionDigits" : 2, "numericCode" : 124}, {"code" : "CVE", "fractionDigits"
        : 2, "numericCode" : 132}, {"code" : "KYD", "fractionDigits" : 2, "numericCode" : 136}, {"code" : "XAF", "fractionDigits" : 0, "numericCode" : 950}, {"code" : "XAF", "fractionDigits" : 0, "numericCode" : 950}, {"code" : "CLF", "fractionDigits" : 4, "numericCode" : 990}, {"code" : "CLP", "fractionDigits" : 0, "numericCode" : 152}, {"code" : "CNY", "fractionDigits" : 2, "numericCode" : 156}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}
        , {"code" : "COP", "fractionDigits" : 2, "numericCode" : 170}, {"code" : "COU", "fractionDigits" : 2, "numericCode" : 970}, {"code" : "KMF", "fractionDigits" : 0, "numericCode" : 174}, {"code" : "XAF", "fractionDigits" : 0, "numericCode" : 950}, {"code" : "CDF", "fractionDigits" : 2, "numericCode" : 976}, {"code" : "NZD", "fractionDigits" : 2, "numericCode" : 554}, {"code" : "CRC", "fractionDigits" : 2, "numericCode" : 188}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "HRK", "fractionDigits"
        : 2, "numericCode" : 191}, {"code" : "CUC", "fractionDigits" : 2, "numericCode" : 931}, {"code" : "CUP", "fractionDigits" : 2, "numericCode" : 192}, {"code" : "ANG", "fractionDigits" : 2, "numericCode" : 532}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "CZK", "fractionDigits" : 2, "numericCode" : 203}, {"code" : "DKK", "fractionDigits" : 2, "numericCode" : 208}, {"code" : "DJF", "fractionDigits" : 0, "numericCode" : 262}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" :
        951}, {"code" : "DOP", "fractionDigits" : 2, "numericCode" : 214}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "EGP", "fractionDigits" : 2, "numericCode" : 818}, {"code" : "SVC", "fractionDigits" : 2, "numericCode" : 222}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "XAF", "fractionDigits" : 0, "numericCode" : 950}, {"code" : "ERN", "fractionDigits" : 2, "numericCode" : 232}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "ETB",
        "fractionDigits" : 2, "numericCode" : 230}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "FKP", "fractionDigits" : 2, "numericCode" : 238}, {"code" : "DKK", "fractionDigits" : 2, "numericCode" : 208}, {"code" : "FJD", "fractionDigits" : 2, "numericCode" : 242}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "XPF", "fractionDigits" : 0,
        "numericCode" : 953}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "XAF", "fractionDigits" : 0, "numericCode" : 950}, {"code" : "GMD", "fractionDigits" : 2, "numericCode" : 270}, {"code" : "GEL", "fractionDigits" : 2, "numericCode" : 981}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "GHS", "fractionDigits" : 2, "numericCode" : 936}, {"code" : "GIP", "fractionDigits" : 2, "numericCode" : 292}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}
        , {"code" : "DKK", "fractionDigits" : 2, "numericCode" : 208}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" : 951}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "GTQ", "fractionDigits" : 2, "numericCode" : 320}, {"code" : "GBP", "fractionDigits" : 2, "numericCode" : 826}, {"code" : "GNF", "fractionDigits" : 0, "numericCode" : 324}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "GYD", "fractionDigits"
        : 2, "numericCode" : 328}, {"code" : "HTG", "fractionDigits" : 2, "numericCode" : 332}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "HNL", "fractionDigits" : 2, "numericCode" : 340}, {"code" : "HKD", "fractionDigits" : 2, "numericCode" : 344}, {"code" : "HUF", "fractionDigits" : 2, "numericCode" : 348}, {"code" : "ISK", "fractionDigits" : 0, "numericCode" : 352}
        , {"code" : "INR", "fractionDigits" : 2, "numericCode" : 356}, {"code" : "IDR", "fractionDigits" : 2, "numericCode" : 360}, {"code" : "XDR", "fractionDigits" : -1, "numericCode" : 960}, {"code" : "IRR", "fractionDigits" : 2, "numericCode" : 364}, {"code" : "IQD", "fractionDigits" : 3, "numericCode" : 368}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "GBP", "fractionDigits" : 2, "numericCode" : 826}, {"code" : "ILS", "fractionDigits" : 2, "numericCode" : 376}, {"code" : "EUR", "fractionDigits"
        : 2, "numericCode" : 978}, {"code" : "JMD", "fractionDigits" : 2, "numericCode" : 388}, {"code" : "JPY", "fractionDigits" : 0, "numericCode" : 392}, {"code" : "GBP", "fractionDigits" : 2, "numericCode" : 826}, {"code" : "JOD", "fractionDigits" : 3, "numericCode" : 400}, {"code" : "KZT", "fractionDigits" : 2, "numericCode" : 398}, {"code" : "KES", "fractionDigits" : 2, "numericCode" : 404}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}, {"code" : "KPW", "fractionDigits" : 2, "numericCode" : 408}
        , {"code" : "KRW", "fractionDigits" : 0, "numericCode" : 410}, {"code" : "KWD", "fractionDigits" : 3, "numericCode" : 414}, {"code" : "KGS", "fractionDigits" : 2, "numericCode" : 417}, {"code" : "LAK", "fractionDigits" : 2, "numericCode" : 418}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "LBP", "fractionDigits" : 2, "numericCode" : 422}, {"code" : "LSL", "fractionDigits" : 2, "numericCode" : 426}, {"code" : "ZAR", "fractionDigits" : 2, "numericCode" : 710}, {"code" : "LRD", "fractionDigits"
        : 2, "numericCode" : 430}, {"code" : "LYD", "fractionDigits" : 3, "numericCode" : 434}, {"code" : "CHF", "fractionDigits" : 2, "numericCode" : 756}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "MOP", "fractionDigits" : 2, "numericCode" : 446}, {"code" : "MKD", "fractionDigits" : 2, "numericCode" : 807}, {"code" : "MGA", "fractionDigits" : 2, "numericCode" : 969}, {"code" : "MWK", "fractionDigits" : 2, "numericCode" :
        454}, {"code" : "MYR", "fractionDigits" : 2, "numericCode" : 458}, {"code" : "MVR", "fractionDigits" : 2, "numericCode" : 462}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "MRO", "fractionDigits" : 2, "numericCode" : 478}, {"code" : "MUR", "fractionDigits" : 2, "numericCode" : 480}, {"code" : "EUR",
        "fractionDigits" : 2, "numericCode" : 978}, {"code" : "XUA", "fractionDigits" : -1, "numericCode" : 965}, {"code" : "MXN", "fractionDigits" : 2, "numericCode" : 484}, {"code" : "MXV", "fractionDigits" : 2, "numericCode" : 979}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "MDL", "fractionDigits" : 2, "numericCode" : 498}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "MNT", "fractionDigits" : 2, "numericCode" : 496}, {"code" : "EUR", "fractionDigits" : 2,
        "numericCode" : 978}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" : 951}, {"code" : "MAD", "fractionDigits" : 2, "numericCode" : 504}, {"code" : "MZN", "fractionDigits" : 2, "numericCode" : 943}, {"code" : "MMK", "fractionDigits" : 2, "numericCode" : 104}, {"code" : "NAD", "fractionDigits" : 2, "numericCode" : 516}, {"code" : "ZAR", "fractionDigits" : 2, "numericCode" : 710}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}, {"code" : "NPR", "fractionDigits" : 2, "numericCode" : 524},
        {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "XPF", "fractionDigits" : 0, "numericCode" : 953}, {"code" : "NZD", "fractionDigits" : 2, "numericCode" : 554}, {"code" : "NIO", "fractionDigits" : 2, "numericCode" : 558}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "NGN", "fractionDigits" : 2, "numericCode" : 566}, {"code" : "NZD", "fractionDigits" : 2, "numericCode" : 554}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}, {"code" : "USD", "fractionDigits"
        : 2, "numericCode" : 840}, {"code" : "NOK", "fractionDigits" : 2, "numericCode" : 578}, {"code" : "OMR", "fractionDigits" : 3, "numericCode" : 512}, {"code" : "PKR", "fractionDigits" : 2, "numericCode" : 586}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : null, "fractionDigits" : 0, "numericCode" : 0}, {"code" : "PAB", "fractionDigits" : 2, "numericCode" : 590}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "PGK", "fractionDigits" : 2, "numericCode" : 598}
        , {"code" : "PYG", "fractionDigits" : 0, "numericCode" : 600}, {"code" : "PEN", "fractionDigits" : 2, "numericCode" : 604}, {"code" : "PHP", "fractionDigits" : 2, "numericCode" : 608}, {"code" : "NZD", "fractionDigits" : 2, "numericCode" : 554}, {"code" : "PLN", "fractionDigits" : 2, "numericCode" : 985}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "QAR", "fractionDigits" : 2, "numericCode" : 634}, {"code" : "EUR", "fractionDigits"
        : 2, "numericCode" : 978}, {"code" : "RON", "fractionDigits" : 2, "numericCode" : 946}, {"code" : "RUB", "fractionDigits" : 2, "numericCode" : 643}, {"code" : "RWF", "fractionDigits" : 0, "numericCode" : 646}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "SHP", "fractionDigits" : 2, "numericCode" : 654}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" : 951}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" : 951}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" :
        978}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "XCD", "fractionDigits" : 2, "numericCode" : 951}, {"code" : "WST", "fractionDigits" : 2, "numericCode" : 882}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "STD", "fractionDigits" : 2, "numericCode" : 678}, {"code" : "SAR", "fractionDigits" : 2, "numericCode" : 682}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "RSD", "fractionDigits" : 2, "numericCode" : 941}, {"code" : "SCR",
        "fractionDigits" : 2, "numericCode" : 690}, {"code" : "SLL", "fractionDigits" : 2, "numericCode" : 694}, {"code" : "SGD", "fractionDigits" : 2, "numericCode" : 702}, {"code" : "ANG", "fractionDigits" : 2, "numericCode" : 532}, {"code" : "XSU", "fractionDigits" : -1, "numericCode" : 994}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "SBD", "fractionDigits" : 2, "numericCode" : 90}, {"code" : "SOS", "fractionDigits" : 2,
        "numericCode" : 706}, {"code" : "ZAR", "fractionDigits" : 2, "numericCode" : 710}, {"code" : null, "fractionDigits" : 0, "numericCode" : 0}, {"code" : "SSP", "fractionDigits" : 2, "numericCode" : 728}, {"code" : "EUR", "fractionDigits" : 2, "numericCode" : 978}, {"code" : "LKR", "fractionDigits" : 2, "numericCode" : 144}, {"code" : "SDG", "fractionDigits" : 2, "numericCode" : 938}, {"code" : "SRD", "fractionDigits" : 2, "numericCode" : 968}, {"code" : "NOK", "fractionDigits" : 2, "numericCode" : 578}, {"code"
        : "SZL", "fractionDigits" : 2, "numericCode" : 748}, {"code" : "SEK", "fractionDigits" : 2, "numericCode" : 752}, {"code" : "CHE", "fractionDigits" : 2, "numericCode" : 947}, {"code" : "CHF", "fractionDigits" : 2, "numericCode" : 756}, {"code" : "CHW", "fractionDigits" : 2, "numericCode" : 948}, {"code" : "SYP", "fractionDigits" : 2, "numericCode" : 760}, {"code" : "TWD", "fractionDigits" : 2, "numericCode" : 901}, {"code" : "TJS", "fractionDigits" : 2, "numericCode" : 972}, {"code" : "TZS", "fractionDigits"
        : 2, "numericCode" : 834}, {"code" : "THB", "fractionDigits" : 2, "numericCode" : 764}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "XOF", "fractionDigits" : 0, "numericCode" : 952}, {"code" : "NZD", "fractionDigits" : 2, "numericCode" : 554}, {"code" : "TOP", "fractionDigits" : 2, "numericCode" : 776}, {"code" : "TTD", "fractionDigits" : 2, "numericCode" : 780}, {"code" : "TND", "fractionDigits" : 3, "numericCode" : 788}, {"code" : "TRY", "fractionDigits" : 2, "numericCode" :
        949}, {"code" : "TMT", "fractionDigits" : 2, "numericCode" : 934}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "AUD", "fractionDigits" : 2, "numericCode" : 36}, {"code" : "UGX", "fractionDigits" : 0, "numericCode" : 800}, {"code" : "UAH", "fractionDigits" : 2, "numericCode" : 980}, {"code" : "AED", "fractionDigits" : 2, "numericCode" : 784}, {"code" : "GBP", "fractionDigits" : 2, "numericCode" : 826}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "USN",
        "fractionDigits" : 2, "numericCode" : 997}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "UYI", "fractionDigits" : 0, "numericCode" : 940}, {"code" : "UYU", "fractionDigits" : 2, "numericCode" : 858}, {"code" : "UZS", "fractionDigits" : 2, "numericCode" : 860}, {"code" : "VUV", "fractionDigits" : 0, "numericCode" : 548}, {"code" : "VEF", "fractionDigits" : 2, "numericCode" : 937}, {"code" : "VND", "fractionDigits" : 0, "numericCode" : 704}, {"code" : "USD", "fractionDigits" : 2,
        "numericCode" : 840}, {"code" : "USD", "fractionDigits" : 2, "numericCode" : 840}, {"code" : "XPF", "fractionDigits" : 0, "numericCode" : 953}, {"code" : "MAD", "fractionDigits" : 2, "numericCode" : 504}, {"code" : "YER", "fractionDigits" : 2, "numericCode" : 886}, {"code" : "ZMW", "fractionDigits" : 2, "numericCode" : 967}, {"code" : "ZWL", "fractionDigits" : 2, "numericCode" : 932}, {"code" : "XBA", "fractionDigits" : -1, "numericCode" : 955}, {"code" : "XBB", "fractionDigits" : -1, "numericCode" : 956}
        , {"code" : "XBC", "fractionDigits" : -1, "numericCode" : 957}, {"code" : "XBD", "fractionDigits" : -1, "numericCode" : 958}, {"code" : "XTS", "fractionDigits" : -1, "numericCode" : 963}, {"code" : "XXX", "fractionDigits" : -1, "numericCode" : 999}, {"code" : "XAU", "fractionDigits" : -1, "numericCode" : 959}, {"code" : "XPD", "fractionDigits" : -1, "numericCode" : 964}, {"code" : "XPT", "fractionDigits" : -1, "numericCode" : 962}, {"code" : "XAG", "fractionDigits" : -1, "numericCode" : 961}];
    };
    $java.otcic_CurrencyHelper_getCountryToCurrencyMap$$create = function() {
        return {"": {"value" : "CYP"}, "PR": {"value" : "USD"}, "PT": {"value" : "EUR"}, "PW": {"value" : "USD"}, "PY": {"value" : "PYG"}, "QA": {"value" : "QAR"}, "AC": {"value" : "SHP"}, "AD": {"value" : "EUR"}, "AE": {"value" : "AED"}, "AF": {"value" : "AFN"}, "AG": {"value" : "XCD"}, "AI": {"value" : "XCD"}, "AL": {"value" : "ALL"}, "AM": {"value" : "AMD"}, "AN": {"value" : "ANG"}, "AO": {"value" : "AOA"}, "242": {"value" : "Brazzaville"}, "AQ": {"value" : ""}, "AR": {"value" : "ARS"}, "243": {"value" : "Kinshasa"}
        , "AS": {"value" : "USD"}, "AT": {"value" : "EUR"}, "RE": {"value" : "EUR"}, "AU": {"value" : ""}, "AW": {"value" : "AWG"}, "AX": {"value" : "EUR"}, "AZ": {"value" : "AMD"}, "RO": {"value" : "RON"}, "BA": {"value" : "BAM"}, "BB": {"value" : "BBD"}, "RS": {"value" : "RSD"}, "BD": {"value" : "BDT"}, "BE": {"value" : "EUR"}, "RU": {"value" : "RUB"}, "BF": {"value" : "XOF"}, "BG": {"value" : "BGN"}, "RW": {"value" : "RWF"}, "27": {"value" : ""}, "BH": {"value" : "BHD"}, "BI": {"value" : "BIF"}, "BJ": {"value"
        : "XOF"}, "BM": {"value" : "BMD"}, "BN": {"value" : "BND"}, "BO": {"value" : "BOB"}, "SA": {"value" : "SAR"}, "SB": {"value" : "SBD"}, "BR": {"value" : "BRL"}, "SC": {"value" : "SCR"}, "SD": {"value" : "SDD"}, "BT": {"value" : "BTN"}, "SE": {"value" : "SEK"}, "SG": {"value" : "SGD"}, "BV": {"value" : ""}, "BW": {"value" : "BWP"}, "SH": {"value" : "SHP"}, "SI": {"value" : "EUR"}, "BY": {"value" : "BYR"}, "SJ": {"value" : "NOK"}, "BZ": {"value" : "BZD"}, "SK": {"value" : "SKK"}, "SL": {"value" : "SLL"}, "SM":
        {"value" : "EUR"}, "SN": {"value" : "XOF"}, "SO": {"value" : ""}, "CA": {"value" : "CAD"}, "SR": {"value" : "SRD"}, "CC": {"value" : "AUD"}, "ST": {"value" : "STD"}, "CF": {"value" : "XAF"}, "SV": {"value" : "USD"}, "CH": {"value" : "CHF"}, "CI": {"value" : "XOF"}, "SY": {"value" : "SYP"}, "SZ": {"value" : "SZL"}, "CK": {"value" : "NZD"}, "CL": {"value" : "CLP"}, "CM": {"value" : "XAF"}, "CO": {"value" : "COP"}, "TA": {"value" : "SHP"}, "CR": {"value" : "CRC"}, "TC": {"value" : "USD"}, "TD": {"value" : "XAF"}
        , "CU": {"value" : "CUP"}, "TF": {"value" : ""}, "CV": {"value" : "CVE"}, "TG": {"value" : "XOF"}, "TH": {"value" : "THB"}, "CX": {"value" : "AUD"}, "CY": {"value" : "TRY"}, "TJ": {"value" : "TJS"}, "CZ": {"value" : "CZK"}, "TK": {"value" : "NZD"}, "TL": {"value" : "USD"}, "TM": {"value" : "TMM"}, "TN": {"value" : "TND"}, "TO": {"value" : "TOP"}, "TR": {"value" : "TRY"}, "TT": {"value" : "TTD"}, "DE": {"value" : "EUR"}, "TV": {"value" : "AUD"}, "DJ": {"value" : "DJF"}, "TZ": {"value" : "TZS"}, "DK": {"value"
        : "DKK"}, "DM": {"value" : "XCD"}, "DO": {"value" : "DOP"}, "UA": {"value" : "UAH"}, "UG": {"value" : "UGX"}, "DZ": {"value" : "DZD"}, "UM": {"value" : ""}, "EC": {"value" : "USD"}, "US": {"value" : "USD"}, "EE": {"value" : "EEK"}, "EG": {"value" : "EGP"}, "UY": {"value" : "UYU"}, "UZ": {"value" : "UZS"}, "VA": {"value" : "EUR"}, "ER": {"value" : "ERN"}, "VC": {"value" : "XCD"}, "ES": {"value" : "EUR"}, "ET": {"value" : "ETB"}, "VE": {"value" : "VEB"}, "VG": {"value" : "USD"}, "VI": {"value" : "USD"}, "VN":
        {"value" : "VND"}, "VU": {"value" : "VUV"}, "FI": {"value" : "EUR"}, "FJ": {"value" : "FJD"}, "FK": {"value" : "FKP"}, "FM": {"value" : "USD"}, "FO": {"value" : "DKK"}, "FR": {"value" : "EUR"}, "WF": {"value" : "XPF"}, "850": {"value" : "Pyongyang"}, "GA": {"value" : "XAF"}, "GB": {"value" : "GBP"}, "WS": {"value" : "WST"}, "GD": {"value" : "XCD"}, "GE": {"value" : "RUB and GEL"}, "GF": {"value" : "EUR"}, "GG": {"value" : "GGP"}, "GH": {"value" : "GHC"}, "GI": {"value" : "GIP"}, "GL": {"value" : "DKK"},
        "GN": {"value" : "GNF"}, "GP": {"value" : "EUR"}, "GQ": {"value" : "XAF"}, "GR": {"value" : "EUR"}, "GS": {"value" : ""}, "GT": {"value" : "GTQ"}, "GU": {"value" : "USD"}, "GW": {"value" : "XOF"}, "GY": {"value" : "GYD"}, "-241": {"value" : "Nassau"}, "82": {"value" : "Seoul"}, "86": {"value" : "Beijing"}, "HK": {"value" : "HKD"}, "HM": {"value" : ""}, "HN": {"value" : "HNL"}, "HR": {"value" : "HRK"}, "HT": {"value" : "HTG"}, "YE": {"value" : "YER"}, "HU": {"value" : "HUF"}, "ID": {"value" : "IDR"}, "YT":
        {"value" : "EUR"}, "IE": {"value" : "EUR"}, "IL": {"value" : "ILS"}, "IM": {"value" : "IMP"}, "IN": {"value" : "INR"}, "IO": {"value" : ""}, "IQ": {"value" : "IQD"}, "IR": {"value" : "IRR"}, "IS": {"value" : "ISK"}, "IT": {"value" : "EUR"}, "ZM": {"value" : "ZMK"}, "886": {"value" : "Taipei"}, "JE": {"value" : "JEP"}, "ZW": {"value" : "ZWD"}, "JM": {"value" : "JMD"}, "JO": {"value" : "JOD"}, "JP": {"value" : "JPY"}, "KE": {"value" : "KES"}, "KG": {"value" : "KGS"}, "KH": {"value" : "KHR"}, "KI": {"value"
        : "AUD"}, "KM": {"value" : "KMF"}, "KN": {"value" : "XCD"}, "KW": {"value" : "KWD"}, "KY": {"value" : "KYD"}, "KZ": {"value" : "KZT"}, "LA": {"value" : "LAK"}, "LB": {"value" : "LBP"}, "LC": {"value" : "XCD"}, "LI": {"value" : "CHF"}, "LK": {"value" : "LKR"}, "LR": {"value" : "LRD"}, "LS": {"value" : "LSL"}, "LT": {"value" : "LTL"}, "LU": {"value" : "EUR"}, "LV": {"value" : "LVL"}, "LY": {"value" : "LYD"}, "MA": {"value" : "MAD"}, "MC": {"value" : "EUR"}, "MD": {"value" : ""}, "ME": {"value" : "EUR"}, "MG":
        {"value" : "MGA"}, "MH": {"value" : "USD"}, "MK": {"value" : "MKD"}, "ML": {"value" : "XOF"}, "MM": {"value" : "MMK"}, "MN": {"value" : "MNT"}, "MO": {"value" : "MOP"}, "MP": {"value" : "USD"}, "MQ": {"value" : "EUR"}, "MR": {"value" : "MRO"}, "MS": {"value" : "XCD"}, "MT": {"value" : "MTL"}, "MU": {"value" : "MUR"}, "MV": {"value" : "MVR"}, "MW": {"value" : "MWK"}, "MX": {"value" : "MXN"}, "MY": {"value" : "MYR"}, "MZ": {"value" : "MZM"}, "NA": {"value" : "NAD"}, "NC": {"value" : "XPF"}, "NE": {"value"
        : "XOF"}, "NF": {"value" : "AUD"}, "NG": {"value" : "NGN"}, "NI": {"value" : "NIO"}, "NL": {"value" : "EUR"}, "NO": {"value" : "NOK"}, "NP": {"value" : "NPR"}, "NR": {"value" : "AUD"}, "NU": {"value" : "NZD"}, "NZ": {"value" : "NZD"}, "OM": {"value" : "OMR"}, "220": {"value" : "Banjul"}, "PA": {"value" : "PAB"}, "PE": {"value" : "PEN"}, "PF": {"value" : ""}, "PG": {"value" : "PGK"}, "PH": {"value" : "PHP"}, "PK": {"value" : "PKR"}, "PL": {"value" : "PLN"}, "PM": {"value" : "EUR"}, "PN": {"value" : "NZD"}
        };
    };
    var onciu_RewritableCompat$PROXY$3_124 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_124_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Yield_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_126 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_126_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ReturnItems_copy(var$2, var$3[0].$value8, var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_128 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_128_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SingleQuery_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_129 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_129_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_UnionAll_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_130 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_130_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_UnionDistinct_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_132 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_132_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_Or_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_133 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_133_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Property__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_134 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_134_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_PropertyKeyName__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_136 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_136_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_UnsignedDecimalIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_137 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_137_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Range__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_138 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_138_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_With_copy(var$2, var$3[0].$value8, var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_139 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_139_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Return_copy(var$2, var$3[0].$value8, var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_141 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_141_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_UseGraph__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_142 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_142_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_UnsignedDecimalIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_147 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_147_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_UnresolvedCall_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4].$value8, var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_150 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_150_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_False_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_154 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_154_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SubqueryCall__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_157 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_157_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_False_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_161 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_161_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_BooleanType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_162 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_162_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_StringType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_163 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_163_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_IntegerType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_164 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_164_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_FloatType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_165 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_165_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_DateType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_166 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_166_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_LocalTimeType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_167 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_167_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_ZonedTimeType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_168 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_168_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_LocalDateTimeType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_169 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_169_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_ZonedDateTimeType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_170 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_170_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_DurationType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_171 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_171_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_PointType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_173 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_173_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_ListType_copy(var$2, var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_174 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_174_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_AnyType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_181 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_181_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_Create__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_182 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_182_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Delete__init_(var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_183 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_183_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Match__init_0(var$3[0].$value8, var$3[1], var$3[2], var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_184 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_184_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Merge__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_185 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_185_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Remove__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_186 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_186_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SetClause__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_187 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_187_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Unwind__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_188 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_188_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Foreach__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_189 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_189_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_LoadCSV__init_(var$3[0].$value8, var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_190 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_190_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Xor__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_193 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_193_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_AliasedReturnItem_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_197 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_197_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_Variable_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_199 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_199_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_PathType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_200 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_200_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_MapType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_201 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_201_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_NodeType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_202 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_202_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_RelationshipType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    function jusi_WrappingStreamImpl() {
        jusi_SimpleStreamImpl.call(this);
        this.$sourceStream = null;
    }
    function jusi_WrappingStreamImpl__init_($this, $sourceStream) {
        $this.$sourceStream = $sourceStream;
    }
    $java.jusi_WrappingStreamImpl_next = function($this, $consumer) {
        return $this.$sourceStream.$next9($this.$wrap2($consumer));
    };
    $java.jusi_WrappingStreamImpl_estimateSize = function($this) {
        return $this.$sourceStream.$estimateSize();
    };
    $java.jusi_MappingStreamImpl = function() {
        jusi_WrappingStreamImpl.call(this);
        this.$mapper = null;
    };
    $java.jusi_MappingStreamImpl_wrap = function($this, $consumer) {
        var var$2;
        var$2 = new $java.jusi_MappingStreamImpl$wrap$lambda$_1_0;
        var$2.$_0433 = $this;
        var$2.$_1130 = $consumer;
        return var$2;
    };
    var scm_ArrayBuffer$$anon$1 = $rt_classWithoutFields(scm_GrowableBuilder);
    function scm_ArrayBuffer$$anon$1__init_() {
        var var_0 = new scm_ArrayBuffer$$anon$1();
        $java.scm_ArrayBuffer$$anon$1__init_(var_0);
        return var_0;
    }
    $java.scm_ArrayBuffer$$anon$1_sizeHint = function($this, $size) {
        var var$2;
        var$2 = $this.$elems3;
        var$2.$array0 = scm_ArrayBuffer$_scala$collection$mutable$ArrayBuffer$$ensureSize(scm_ArrayBuffer$_MODULE$, var$2.$array0, var$2.$size00, Long_fromInt($size));
    };
    $java.scm_ArrayBuffer$$anon$1__init_ = function($this) {
        scm_GrowableBuilder__init_($this, scm_ArrayBuffer__init_());
    };
    $java.sci_Map$Map2$Map2Iterator = function() {
        var a = this; sc_AbstractIterator.call(a);
        a.$i3 = 0;
        a.$$outer42 = null;
    };
    $java.sci_Map$Map2$Map2Iterator_hasNext = function($this) {
        if ($this.$i3 >= 2)
            return 0;
        return 1;
    };
    $java.sci_Map$Map2$Map2Iterator_next = function($this) {
        var var$1, $result;
        a: {
            switch ($this.$i3) {
                case 0:
                    var$1 = $this.$$outer42;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map2$$key1, var$1.$scala$collection$immutable$Map$Map2$$value1);
                    break a;
                case 1:
                    var$1 = $this.$$outer42;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map2$$key2, var$1.$scala$collection$immutable$Map$Map2$$value2);
                    break a;
                default:
            }
            $result = sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        }
        $this.$i3 = $this.$i3 + 1 | 0;
        return $result;
    };
    $java.sci_Map$Map2$Map2Iterator_scala$collection$immutable$Map$Map2$Map2Iterator$$$outer = function($this) {
        return $this.$$outer42;
    };
    $java.sci_Map$Map2$Map2Iterator__init_ = function($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer42 = $$outer;
        $this.$i3 = 0;
    };
    $java.sci_Map$Map2$$anon$1 = $rt_classWithoutFields($java.sci_Map$Map2$Map2Iterator);
    $java.sci_Map$Map2$$anon$1_nextResult = function($this, $k, $v) {
        return s_Tuple2__init_($k, $v);
    };
    var oncias_Scope$allSymbolDefinitions$lambda$_15_0 = $rt_classWithoutFields();
    $java.oncias_Scope$allSymbolDefinitions$lambda$_15_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = s_Tuple2__init_(var$1, var$2);
        var$1 = var$3.$_10;
        return sc_IterableOnceOps_foldLeft$(oncias_Scope_symbolDefinitions(var$3.$_20), var$1, new $java.oncias_Scope$$anonfun$allSymbolDefinitions$1$lambda$_38_0);
    };
    var oncias_Scope$symbolDefinitions$lambda$_17_0 = $rt_classWithoutFields();
    $java.oncias_Scope$symbolDefinitions$lambda$_17_0_apply = function(var$0, var$1) {
        return var$1.$definition;
    };
    function scm_CheckedIndexedSeqView$CheckedReverseIterator() {
        var a = this; sc_IndexedSeqView$IndexedSeqViewReverseIterator.call(a);
        a.$mutationCount3 = null;
        a.$expectedCount0 = 0;
    }
    $java.scm_CheckedIndexedSeqView$CheckedReverseIterator_hasNext = function($this) {
        scm_MutationTracker$_checkMutations(scm_MutationTracker$_MODULE$, $this.$expectedCount0, scm_ArrayBuffer$view$lambda$_88_0_apply$mcI$sp($this.$mutationCount3), $rt_s(518));
        return $java.sc_IndexedSeqView$IndexedSeqViewReverseIterator_hasNext($this);
    };
    $java.scm_CheckedIndexedSeqView = $rt_classWithoutFields(0);
    function scm_CheckedIndexedSeqView$Reverse() {
        var a = this; sc_IndexedSeqView$Reverse.call(a);
        a.$underlying12 = null;
        a.$mutationCount4 = null;
    }
    $java.scm_CheckedIndexedSeqView$Reverse_iterator = function($this) {
        return scm_CheckedIndexedSeqView$CheckedIterator__init_($this, $this.$mutationCount4);
    };
    var oncie_Namespace$ = $rt_classWithoutFields();
    var oncie_Namespace$_MODULE$ = null;
    function oncie_Namespace$__clinit_() {
        oncie_Namespace$_MODULE$ = new oncie_Namespace$;
    }
    function oncie_Namespace$_apply$default$1($this) {
        s_package$_$callClinit();
        s_package$_List0(s_package$_MODULE$);
        return sci_Nil$_MODULE$;
    }
    var oncia_ShowColumn$ = $rt_classWithoutFields();
    var oncia_ShowColumn$_MODULE$ = null;
    function oncia_ShowColumn$__clinit_() {
        oncia_ShowColumn$_MODULE$ = new oncia_ShowColumn$;
    }
    function oncia_ShowColumn$_apply($this, $name, $cypherType, $position) {
        return oncia_ShowColumn__init_0(oncie_Variable__init_($name, $position), $cypherType, $name);
    }
    function oncia_ShowColumn$_apply$default$2($this) {
        oncius_package$_$callClinit();
        return oncius_package$_CTString(oncius_package$_MODULE$);
    }
    var oncia_DefaultOrAllShowColumns$ = $rt_classWithoutFields();
    var oncia_DefaultOrAllShowColumns$_MODULE$ = null;
    function oncia_DefaultOrAllShowColumns$__clinit_() {
        oncia_DefaultOrAllShowColumns$_MODULE$ = new oncia_DefaultOrAllShowColumns$;
    }
    $java.oncia_DefaultOrAllShowColumns$_apply = function($this, $columns, $yieldOrWhere) {
        var $briefShowColumns, $allShowColumns;
        $briefShowColumns = sci_List_map(sci_List_filter($columns, new $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_0), new $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_1);
        $allShowColumns = sci_List_map($columns, new $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_2);
        return oncia_DefaultOrAllShowColumns$_apply($this, $yieldOrWhere instanceof s_Some && $yieldOrWhere.$value5 instanceof su_Left ? 1 : 0, $briefShowColumns, $allShowColumns);
    };
    function oncia_DefaultOrAllShowColumns$_apply($this, $useAllColumns, $brief, $all) {
        if (!$useAllColumns)
            return $java.oncia_DefaultOrAllShowColumns__init_($useAllColumns, $brief);
        return $java.oncia_DefaultOrAllShowColumns__init_($useAllColumns, $all);
    }
    function oncia_ShowColumn() {
        var a = this; jl_Object.call(a);
        a.$variable34 = null;
        a.$cypherType = null;
        a.$name23 = null;
    }
    function oncia_ShowColumn__init_0(var_0, var_1, var_2) {
        var var_3 = new oncia_ShowColumn();
        oncia_ShowColumn__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_ShowColumn_productPrefix = function($this) {
        return $rt_s(2104);
    };
    $java.oncia_ShowColumn_productArity = function($this) {
        return 3;
    };
    $java.oncia_ShowColumn_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable34;
            case 1:
                return $this.$cypherType;
            case 2:
                return $this.$name23;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowColumn_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowColumn_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowColumn_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowColumn_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ShowColumn) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable34;
                        var$3 = $x$1.$variable34;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$cypherType;
                        var$3 = $x$1.$cypherType;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$name23;
                        $x$1 = $x$1.$name23;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ShowColumn))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncia_ShowColumn__init_($this, $variable, $cypherType, $name) {
        $this.$variable34 = $variable;
        $this.$cypherType = $cypherType;
        $this.$name23 = $name;
    }
    function oncia_ShowIndexesClause() {
        var a = this; jl_Object.call(a);
        a.$unfilteredColumns0 = null;
        a.$indexType0 = null;
        a.$brief = 0;
        a.$verbose = 0;
        a.$where3 = null;
        a.$hasYield = 0;
        a.$position149 = null;
        a.$LabelExpressionsPartition$module14 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier14 = null;
        a.$SetExtractor$module14 = null;
    }
    $java.oncia_ShowIndexesClause__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncia_ShowIndexesClause();
        $java.oncia_ShowIndexesClause__init_0(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    };
    $java.oncia_ShowIndexesClause_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_ShowIndexesClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_ShowIndexesClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_ShowIndexesClause_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_ShowIndexesClause_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_ShowIndexesClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ShowIndexesClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_ShowIndexesClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_ShowIndexesClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_ShowIndexesClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module14 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module14 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module14 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module14;
    };
    $java.oncia_ShowIndexesClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier14;
    };
    $java.oncia_ShowIndexesClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module14 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module14 !== null)
                        break a;
                    $this.$SetExtractor$module14 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module14;
    };
    $java.oncia_ShowIndexesClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier14 = $x$1;
    };
    $java.oncia_ShowIndexesClause_unfilteredColumns = function($this) {
        return $this.$unfilteredColumns0;
    };
    $java.oncia_ShowIndexesClause_where = function($this) {
        return $this.$where3;
    };
    $java.oncia_ShowIndexesClause_position = function($this) {
        return $this.$position149;
    };
    $java.oncia_ShowIndexesClause_name = function($this) {
        return $rt_s(2105);
    };
    $java.oncia_ShowIndexesClause_moveWhereToYield = function($this) {
        var $x$1;
        $x$1 = s_None$_MODULE$;
        return $java.oncia_ShowIndexesClause_copy($this, $this.$unfilteredColumns0, $this.$indexType0, $this.$brief, $this.$verbose, $x$1, 1, $this.$position149);
    };
    $java.oncia_ShowIndexesClause_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2;
        if (!$this.$brief && !$this.$verbose) {
            a: {
                b: {
                    var$1 = $this.$indexType0;
                    var$2 = oncia_BtreeIndexes$_MODULE$;
                    if (var$1 !== null) {
                        if (!jl_Object_equals(var$1, var$2))
                            break b;
                        else
                            break a;
                    }
                    if (var$2 === null)
                        break a;
                }
                return $java.oncia_CommandClause_clauseSpecificSemanticCheck$($this);
            }
            return oncias_SemanticAnalysisTooling_error$($this, $rt_s(2106), $this.$position149);
        }
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        return oncias_SemanticAnalysisTooling_error$($this, sc_StringOps$_stripMargin$extension(var$2, $rt_s(2107)), $this.$position149);
    };
    $java.oncia_ShowIndexesClause_copy = function($this, $unfilteredColumns, $indexType, $brief, $verbose, $where, $hasYield, $position) {
        return $java.oncia_ShowIndexesClause__init_($unfilteredColumns, $indexType, $brief, $verbose, $where, $hasYield, $position);
    };
    $java.oncia_ShowIndexesClause_productPrefix = function($this) {
        return $rt_s(2108);
    };
    $java.oncia_ShowIndexesClause_productArity = function($this) {
        return 6;
    };
    $java.oncia_ShowIndexesClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$unfilteredColumns0;
            case 1:
                return $this.$indexType0;
            case 2:
                return jl_Boolean_valueOf($this.$brief);
            case 3:
                return jl_Boolean_valueOf($this.$verbose);
            case 4:
                return $this.$where3;
            case 5:
                return jl_Boolean_valueOf($this.$hasYield);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowIndexesClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowIndexesClause_hashCode = function($this) {
        var var$1, var$2;
        var$1 = sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2108))), sr_Statics_anyHash($this.$unfilteredColumns0)), sr_Statics_anyHash($this.$indexType0)), !$this.$brief ? 1237 : 1231);
        var$2 = !$this.$verbose ? 1237 : 1231;
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(var$1, var$2), sr_Statics_anyHash($this.$where3)), !$this.$hasYield ? 1237 : 1231), 6);
    };
    $java.oncia_ShowIndexesClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowIndexesClause_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ShowIndexesClause) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$brief != $x$1.$brief)
                        break b;
                    if ($this.$verbose != $x$1.$verbose)
                        break b;
                    if ($this.$hasYield != $x$1.$hasYield)
                        break b;
                    c: {
                        var$2 = $this.$unfilteredColumns0;
                        var$3 = $x$1.$unfilteredColumns0;
                        if (var$2 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$indexType0;
                        var$3 = $x$1.$indexType0;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$where3;
                        $x$1 = $x$1.$where3;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ShowIndexesClause))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ShowIndexesClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ShowIndexesClause__init_0 = function($this, $unfilteredColumns, $indexType, $brief, $verbose, $where, $hasYield, $position) {
        $this.$unfilteredColumns0 = $unfilteredColumns;
        $this.$indexType0 = $indexType;
        $this.$brief = $brief;
        $this.$verbose = $verbose;
        $this.$where3 = $where;
        $this.$hasYield = $hasYield;
        $this.$position149 = $position;
        oncia_Clause_$init$($this);
    };
    function oncia_ShowFunctionsClause() {
        var a = this; jl_Object.call(a);
        a.$unfilteredColumns1 = null;
        a.$functionType = null;
        a.$executable0 = null;
        a.$where6 = null;
        a.$hasYield0 = 0;
        a.$position150 = null;
        a.$LabelExpressionsPartition$module15 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier15 = null;
        a.$SetExtractor$module15 = null;
    }
    $java.oncia_ShowFunctionsClause__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_ShowFunctionsClause();
        $java.oncia_ShowFunctionsClause__init_0(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    };
    $java.oncia_ShowFunctionsClause_clauseSpecificSemanticCheck = function($this) {
        return $java.oncia_CommandClause_clauseSpecificSemanticCheck$($this);
    };
    $java.oncia_ShowFunctionsClause_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_ShowFunctionsClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_ShowFunctionsClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_ShowFunctionsClause_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_ShowFunctionsClause_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_ShowFunctionsClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ShowFunctionsClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_ShowFunctionsClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_ShowFunctionsClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_ShowFunctionsClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module15 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module15 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module15 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module15;
    };
    $java.oncia_ShowFunctionsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier15;
    };
    $java.oncia_ShowFunctionsClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module15 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module15 !== null)
                        break a;
                    $this.$SetExtractor$module15 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module15;
    };
    $java.oncia_ShowFunctionsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier15 = $x$1;
    };
    $java.oncia_ShowFunctionsClause_unfilteredColumns = function($this) {
        return $this.$unfilteredColumns1;
    };
    $java.oncia_ShowFunctionsClause_where = function($this) {
        return $this.$where6;
    };
    $java.oncia_ShowFunctionsClause_position = function($this) {
        return $this.$position150;
    };
    $java.oncia_ShowFunctionsClause_name = function($this) {
        return $rt_s(2109);
    };
    $java.oncia_ShowFunctionsClause_moveWhereToYield = function($this) {
        var $x$1;
        $x$1 = s_None$_MODULE$;
        return $java.oncia_ShowFunctionsClause_copy($this, $this.$unfilteredColumns1, $this.$functionType, $this.$executable0, $x$1, 1, $this.$position150);
    };
    $java.oncia_ShowFunctionsClause_copy = function($this, $unfilteredColumns, $functionType, $executable, $where, $hasYield, $position) {
        return $java.oncia_ShowFunctionsClause__init_($unfilteredColumns, $functionType, $executable, $where, $hasYield, $position);
    };
    $java.oncia_ShowFunctionsClause_productPrefix = function($this) {
        return $rt_s(2110);
    };
    $java.oncia_ShowFunctionsClause_productArity = function($this) {
        return 5;
    };
    $java.oncia_ShowFunctionsClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$unfilteredColumns1;
            case 1:
                return $this.$functionType;
            case 2:
                return $this.$executable0;
            case 3:
                return $this.$where6;
            case 4:
                return jl_Boolean_valueOf($this.$hasYield0);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowFunctionsClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowFunctionsClause_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2110))), sr_Statics_anyHash($this.$unfilteredColumns1)), sr_Statics_anyHash($this.$functionType)), sr_Statics_anyHash($this.$executable0)), sr_Statics_anyHash($this.$where6)), !$this.$hasYield0 ? 1237 : 1231), 5);
    };
    $java.oncia_ShowFunctionsClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowFunctionsClause_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ShowFunctionsClause) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$hasYield0 != $x$1.$hasYield0)
                        break b;
                    c: {
                        var$2 = $this.$unfilteredColumns1;
                        var$3 = $x$1.$unfilteredColumns1;
                        if (var$2 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$functionType;
                        var$3 = $x$1.$functionType;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$executable0;
                        var$3 = $x$1.$executable0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$where6;
                        $x$1 = $x$1.$where6;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ShowFunctionsClause))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ShowFunctionsClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ShowFunctionsClause__init_0 = function($this, $unfilteredColumns, $functionType, $executable, $where, $hasYield, $position) {
        $this.$unfilteredColumns1 = $unfilteredColumns;
        $this.$functionType = $functionType;
        $this.$executable0 = $executable;
        $this.$where6 = $where;
        $this.$hasYield0 = $hasYield;
        $this.$position150 = $position;
        oncia_Clause_$init$($this);
    };
    function oncia_ShowConstraintsClause() {
        var a = this; jl_Object.call(a);
        a.$unfilteredColumns2 = null;
        a.$constraintType = null;
        a.$brief0 = 0;
        a.$verbose0 = 0;
        a.$where4 = null;
        a.$hasYield1 = 0;
        a.$position151 = null;
        a.$existsErrorMessage = null;
        a.$LabelExpressionsPartition$module16 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier16 = null;
        a.$SetExtractor$module16 = null;
    }
    function oncia_ShowConstraintsClause__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncia_ShowConstraintsClause();
        $java.oncia_ShowConstraintsClause__init_(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    }
    $java.oncia_ShowConstraintsClause_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_ShowConstraintsClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_ShowConstraintsClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_ShowConstraintsClause_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_ShowConstraintsClause_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_ShowConstraintsClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ShowConstraintsClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_ShowConstraintsClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_ShowConstraintsClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_ShowConstraintsClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module16 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module16 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module16 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module16;
    };
    $java.oncia_ShowConstraintsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier16;
    };
    $java.oncia_ShowConstraintsClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module16 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module16 !== null)
                        break a;
                    $this.$SetExtractor$module16 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module16;
    };
    $java.oncia_ShowConstraintsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier16 = $x$1;
    };
    $java.oncia_ShowConstraintsClause_unfilteredColumns = function($this) {
        return $this.$unfilteredColumns2;
    };
    $java.oncia_ShowConstraintsClause_where = function($this) {
        return $this.$where4;
    };
    $java.oncia_ShowConstraintsClause_position = function($this) {
        return $this.$position151;
    };
    $java.oncia_ShowConstraintsClause_name = function($this) {
        return $rt_s(2111);
    };
    $java.oncia_ShowConstraintsClause_moveWhereToYield = function($this) {
        var $x$1;
        $x$1 = s_None$_MODULE$;
        return $java.oncia_ShowConstraintsClause_copy($this, $this.$unfilteredColumns2, $this.$constraintType, $this.$brief0, $this.$verbose0, $x$1, 1, $this.$position151);
    };
    $java.oncia_ShowConstraintsClause_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2;
        var$1 = $this.$constraintType;
        if (var$1 instanceof oncia_ExistsConstraints) {
            var$2 = var$1.$syntax;
            if (jl_Object_equals(oncia_RemovedSyntax$_MODULE$, var$2))
                return oncias_SemanticAnalysisTooling_error$($this, $this.$existsErrorMessage, $this.$position151);
        }
        if (var$1 instanceof oncia_NodeExistsConstraints) {
            var$2 = var$1.$syntax0;
            if (jl_Object_equals(oncia_RemovedSyntax$_MODULE$, var$2))
                return oncias_SemanticAnalysisTooling_error$($this, $this.$existsErrorMessage, $this.$position151);
        }
        if (var$1 instanceof oncia_RelExistsConstraints) {
            var$2 = var$1.$syntax1;
            if (jl_Object_equals(oncia_RemovedSyntax$_MODULE$, var$2))
                return oncias_SemanticAnalysisTooling_error$($this, $this.$existsErrorMessage, $this.$position151);
        }
        if (!$this.$brief0 && !$this.$verbose0)
            return $java.oncia_CommandClause_clauseSpecificSemanticCheck$($this);
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        return oncias_SemanticAnalysisTooling_error$($this, sc_StringOps$_stripMargin$extension(var$2, $rt_s(2112)), $this.$position151);
    };
    $java.oncia_ShowConstraintsClause_copy = function($this, $unfilteredColumns, $constraintType, $brief, $verbose, $where, $hasYield, $position) {
        return oncia_ShowConstraintsClause__init_($unfilteredColumns, $constraintType, $brief, $verbose, $where, $hasYield, $position);
    };
    $java.oncia_ShowConstraintsClause_productPrefix = function($this) {
        return $rt_s(2113);
    };
    $java.oncia_ShowConstraintsClause_productArity = function($this) {
        return 6;
    };
    $java.oncia_ShowConstraintsClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$unfilteredColumns2;
            case 1:
                return $this.$constraintType;
            case 2:
                return jl_Boolean_valueOf($this.$brief0);
            case 3:
                return jl_Boolean_valueOf($this.$verbose0);
            case 4:
                return $this.$where4;
            case 5:
                return jl_Boolean_valueOf($this.$hasYield1);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowConstraintsClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowConstraintsClause_hashCode = function($this) {
        var var$1, var$2;
        var$1 = sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2113))), sr_Statics_anyHash($this.$unfilteredColumns2)), sr_Statics_anyHash($this.$constraintType)), !$this.$brief0 ? 1237 : 1231);
        var$2 = !$this.$verbose0 ? 1237 : 1231;
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(var$1, var$2), sr_Statics_anyHash($this.$where4)), !$this.$hasYield1 ? 1237 : 1231), 6);
    };
    $java.oncia_ShowConstraintsClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowConstraintsClause_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ShowConstraintsClause) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$brief0 != $x$1.$brief0)
                        break b;
                    if ($this.$verbose0 != $x$1.$verbose0)
                        break b;
                    if ($this.$hasYield1 != $x$1.$hasYield1)
                        break b;
                    c: {
                        var$2 = $this.$unfilteredColumns2;
                        var$3 = $x$1.$unfilteredColumns2;
                        if (var$2 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$constraintType;
                        var$3 = $x$1.$constraintType;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$where4;
                        $x$1 = $x$1.$where4;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ShowConstraintsClause))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ShowConstraintsClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ShowConstraintsClause__init_ = function($this, $unfilteredColumns, $constraintType, $brief, $verbose, $where, $hasYield, $position) {
        $this.$unfilteredColumns2 = $unfilteredColumns;
        $this.$constraintType = $constraintType;
        $this.$brief0 = $brief;
        $this.$verbose0 = $verbose;
        $this.$where4 = $where;
        $this.$hasYield1 = $hasYield;
        $this.$position151 = $position;
        oncia_Clause_$init$($this);
        $this.$existsErrorMessage = $rt_s(2114);
    };
    function oncia_ShowProceduresClause() {
        var a = this; jl_Object.call(a);
        a.$unfilteredColumns3 = null;
        a.$executable = null;
        a.$where5 = null;
        a.$hasYield2 = 0;
        a.$position152 = null;
        a.$LabelExpressionsPartition$module17 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier17 = null;
        a.$SetExtractor$module17 = null;
    }
    $java.oncia_ShowProceduresClause__init_ = function(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_ShowProceduresClause();
        $java.oncia_ShowProceduresClause__init_0(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    };
    $java.oncia_ShowProceduresClause_clauseSpecificSemanticCheck = function($this) {
        return $java.oncia_CommandClause_clauseSpecificSemanticCheck$($this);
    };
    $java.oncia_ShowProceduresClause_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_ShowProceduresClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_ShowProceduresClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_ShowProceduresClause_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_ShowProceduresClause_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_ShowProceduresClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ShowProceduresClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_ShowProceduresClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_ShowProceduresClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_ShowProceduresClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module17 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module17 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module17 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module17;
    };
    $java.oncia_ShowProceduresClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier17;
    };
    $java.oncia_ShowProceduresClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module17 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module17 !== null)
                        break a;
                    $this.$SetExtractor$module17 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module17;
    };
    $java.oncia_ShowProceduresClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier17 = $x$1;
    };
    $java.oncia_ShowProceduresClause_unfilteredColumns = function($this) {
        return $this.$unfilteredColumns3;
    };
    $java.oncia_ShowProceduresClause_where = function($this) {
        return $this.$where5;
    };
    $java.oncia_ShowProceduresClause_position = function($this) {
        return $this.$position152;
    };
    $java.oncia_ShowProceduresClause_name = function($this) {
        return $rt_s(372);
    };
    $java.oncia_ShowProceduresClause_moveWhereToYield = function($this) {
        var $x$1;
        $x$1 = s_None$_MODULE$;
        return $java.oncia_ShowProceduresClause_copy($this, $this.$unfilteredColumns3, $this.$executable, $x$1, 1, $this.$position152);
    };
    $java.oncia_ShowProceduresClause_copy = function($this, $unfilteredColumns, $executable, $where, $hasYield, $position) {
        return $java.oncia_ShowProceduresClause__init_($unfilteredColumns, $executable, $where, $hasYield, $position);
    };
    $java.oncia_ShowProceduresClause_productPrefix = function($this) {
        return $rt_s(2115);
    };
    $java.oncia_ShowProceduresClause_productArity = function($this) {
        return 4;
    };
    $java.oncia_ShowProceduresClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$unfilteredColumns3;
            case 1:
                return $this.$executable;
            case 2:
                return $this.$where5;
            case 3:
                return jl_Boolean_valueOf($this.$hasYield2);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowProceduresClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowProceduresClause_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2115))), sr_Statics_anyHash($this.$unfilteredColumns3)), sr_Statics_anyHash($this.$executable)), sr_Statics_anyHash($this.$where5)), !$this.$hasYield2 ? 1237 : 1231), 4);
    };
    $java.oncia_ShowProceduresClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowProceduresClause_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ShowProceduresClause) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$hasYield2 != $x$1.$hasYield2)
                        break b;
                    c: {
                        var$2 = $this.$unfilteredColumns3;
                        var$3 = $x$1.$unfilteredColumns3;
                        if (var$2 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$executable;
                        var$3 = $x$1.$executable;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$where5;
                        $x$1 = $x$1.$where5;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ShowProceduresClause))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ShowProceduresClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ShowProceduresClause__init_0 = function($this, $unfilteredColumns, $executable, $where, $hasYield, $position) {
        $this.$unfilteredColumns3 = $unfilteredColumns;
        $this.$executable = $executable;
        $this.$where5 = $where;
        $this.$hasYield2 = $hasYield;
        $this.$position152 = $position;
        oncia_Clause_$init$($this);
    };
    $java.oncia_ShowServers$$apply$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncia_ShowServers$$apply$lambda$_1_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Tuple2__2$mcZ$sp(var$1));
    };
    $java.oncia_ShowServers$$apply$lambda$_1_1 = $rt_classWithoutFields();
    $java.oncia_ShowServers$$apply$lambda$_1_1_apply = function(var$0, var$1) {
        return var$1.$_10;
    };
    $java.oncia_ShowServers$$apply$lambda$_1_2 = $rt_classWithoutFields();
    $java.oncia_ShowServers$$apply$lambda$_1_2_apply = function(var$0, var$1) {
        return var$1.$_10;
    };
    function oncia_ShowSettingsClause() {
        var a = this; jl_Object.call(a);
        a.$unfilteredColumns4 = null;
        a.$names = null;
        a.$where8 = null;
        a.$hasYield3 = 0;
        a.$position153 = null;
        a.$LabelExpressionsPartition$module18 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier18 = null;
        a.$SetExtractor$module18 = null;
    }
    function oncia_ShowSettingsClause__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_ShowSettingsClause();
        $java.oncia_ShowSettingsClause__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncia_ShowSettingsClause_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_ShowSettingsClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_ShowSettingsClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_ShowSettingsClause_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_ShowSettingsClause_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_ShowSettingsClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ShowSettingsClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_ShowSettingsClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_ShowSettingsClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_ShowSettingsClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module18 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module18 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module18 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module18;
    };
    $java.oncia_ShowSettingsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier18;
    };
    $java.oncia_ShowSettingsClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module18 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module18 !== null)
                        break a;
                    $this.$SetExtractor$module18 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module18;
    };
    $java.oncia_ShowSettingsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier18 = $x$1;
    };
    $java.oncia_ShowSettingsClause_unfilteredColumns = function($this) {
        return $this.$unfilteredColumns4;
    };
    $java.oncia_ShowSettingsClause_where = function($this) {
        return $this.$where8;
    };
    $java.oncia_ShowSettingsClause_position = function($this) {
        return $this.$position153;
    };
    $java.oncia_ShowSettingsClause_name = function($this) {
        return $rt_s(378);
    };
    $java.oncia_ShowSettingsClause_moveWhereToYield = function($this) {
        var $x$1;
        $x$1 = s_None$_MODULE$;
        return $java.oncia_ShowSettingsClause_copy($this, $this.$unfilteredColumns4, $this.$names, $x$1, 1, $this.$position153);
    };
    $java.oncia_ShowSettingsClause_clauseSpecificSemanticCheck = function($this) {
        var var$1, var$2;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(1069)), $rt_s(378)), $rt_s(1070));
        var$2 = oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, jl_AbstractStringBuilder_toString(var$1), oncias_SemanticFeature$ShowSetting$_MODULE$, $this.$position153);
        var$1 = $this.$names;
        if (!(var$1 instanceof su_Right))
            var$1 = oncias_SemanticCheck$_success;
        else {
            var$1 = var$1.$value10;
            oncias_SemanticExpressionCheck$_$callClinit();
            var$1 = $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, var$1);
        }
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$2, var$1), $java.oncia_CommandClause_clauseSpecificSemanticCheck$($this));
    };
    $java.oncia_ShowSettingsClause_copy = function($this, $unfilteredColumns, $names, $where, $hasYield, $position) {
        return oncia_ShowSettingsClause__init_($unfilteredColumns, $names, $where, $hasYield, $position);
    };
    $java.oncia_ShowSettingsClause_productPrefix = function($this) {
        return $rt_s(2116);
    };
    $java.oncia_ShowSettingsClause_productArity = function($this) {
        return 4;
    };
    $java.oncia_ShowSettingsClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$unfilteredColumns4;
            case 1:
                return $this.$names;
            case 2:
                return $this.$where8;
            case 3:
                return jl_Boolean_valueOf($this.$hasYield3);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowSettingsClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowSettingsClause_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2116))), sr_Statics_anyHash($this.$unfilteredColumns4)), sr_Statics_anyHash($this.$names)), sr_Statics_anyHash($this.$where8)), !$this.$hasYield3 ? 1237 : 1231), 4);
    };
    $java.oncia_ShowSettingsClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowSettingsClause_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ShowSettingsClause) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$hasYield3 != $x$1.$hasYield3)
                        break b;
                    c: {
                        var$2 = $this.$unfilteredColumns4;
                        var$3 = $x$1.$unfilteredColumns4;
                        if (var$2 !== null) {
                            if (!oncia_DefaultOrAllShowColumns_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$names;
                        var$3 = $x$1.$names;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$where8;
                        $x$1 = $x$1.$where8;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ShowSettingsClause))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ShowSettingsClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ShowSettingsClause__init_ = function($this, $unfilteredColumns, $names, $where, $hasYield, $position) {
        $this.$unfilteredColumns4 = $unfilteredColumns;
        $this.$names = $names;
        $this.$where8 = $where;
        $this.$hasYield3 = $hasYield;
        $this.$position153 = $position;
        oncia_Clause_$init$($this);
    };
    function oncia_TransactionColumn() {
        var a = this; jl_Object.call(a);
        a.$name49 = null;
        a.$cypherType0 = null;
    }
    function oncia_TransactionColumn__init_(var_0, var_1) {
        var var_2 = new oncia_TransactionColumn();
        $java.oncia_TransactionColumn__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_TransactionColumn_productPrefix = function($this) {
        return $rt_s(2117);
    };
    $java.oncia_TransactionColumn_productArity = function($this) {
        return 2;
    };
    $java.oncia_TransactionColumn_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name49;
            case 1:
                return $this.$cypherType0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_TransactionColumn_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TransactionColumn_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TransactionColumn_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TransactionColumn_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_TransactionColumn) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name49;
                        var$3 = $x$1.$name49;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$cypherType0;
                        $x$1 = $x$1.$cypherType0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_TransactionColumn))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_TransactionColumn__init_ = function($this, $name, $cypherType) {
        $this.$name49 = $name;
        $this.$cypherType0 = $cypherType;
    };
    var oncia_TransactionColumn$ = $rt_classWithoutFields($java.sr_AbstractFunction2);
    var oncia_TransactionColumn$_MODULE$ = null;
    function oncia_TransactionColumn$__clinit_() {
        oncia_TransactionColumn$_MODULE$ = new oncia_TransactionColumn$;
    }
    function oncia_TransactionColumn$_apply$default$2($this) {
        oncius_package$_$callClinit();
        return oncius_package$_CTString(oncius_package$_MODULE$);
    }
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0__init_ = function() {
        var var_0 = new $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0();
        $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0__init_0(var_0);
        return var_0;
    };
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0__init_0 = function(var$0) {};
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Tuple2__2$mcZ$sp(var$1));
    };
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1 = $rt_classWithoutFields();
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1__init_ = function() {
        var var_0 = new $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1();
        $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1__init_0(var_0);
        return var_0;
    };
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1__init_0 = function(var$0) {};
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1_apply = function(var$0, var$1) {
        return var$1.$_10;
    };
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2 = $rt_classWithoutFields();
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2__init_ = function() {
        var var_0 = new $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2();
        $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2__init_0(var_0);
        return var_0;
    };
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2__init_0 = function(var$0) {};
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2_apply = function(var$0, var$1) {
        return var$1.$_10;
    };
    function oncia_ShowTransactionsClause() {
        var a = this; jl_Object.call(a);
        a.$briefTransactionColumns = null;
        a.$allTransactionColumns = null;
        a.$ids = null;
        a.$where7 = null;
        a.$yieldItems = null;
        a.$yieldAll0 = 0;
        a.$position154 = null;
        a.$useAllColumns0 = 0;
        a.$transactionColumns0 = null;
        a.$briefColumns = null;
        a.$allColumns = null;
        a.$unfilteredColumns5 = null;
        a.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap = null;
        a.$LabelExpressionsPartition$module19 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier19 = null;
        a.$SetExtractor$module19 = null;
        a.$bitmap$027 = 0;
    }
    $java.oncia_ShowTransactionsClause__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncia_ShowTransactionsClause();
        $java.oncia_ShowTransactionsClause__init_0(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    };
    $java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$super$clauseSpecificSemanticCheck = function($this) {
        return $java.oncia_CommandClause_clauseSpecificSemanticCheck$($this);
    };
    $java.oncia_ShowTransactionsClause_clauseSpecificSemanticCheck = function($this) {
        return $java.oncia_TransactionsCommandClause_clauseSpecificSemanticCheck$($this);
    };
    $java.oncia_ShowTransactionsClause_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_ShowTransactionsClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_ShowTransactionsClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_ShowTransactionsClause_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_ShowTransactionsClause_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_ShowTransactionsClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ShowTransactionsClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_ShowTransactionsClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_ShowTransactionsClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap = function($this) {
        var var$1, $$je;
        if ($this.$bitmap$027)
            return $this.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$027)
                    break a;
                $this.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap = $java.oncia_TransactionsCommandClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$($this);
                $this.$bitmap$027 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap;
    };
    $java.oncia_ShowTransactionsClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module19 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module19 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module19 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module19;
    };
    $java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier19;
    };
    $java.oncia_ShowTransactionsClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module19 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module19 !== null)
                        break a;
                    $this.$SetExtractor$module19 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module19;
    };
    $java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier19 = $x$1;
    };
    $java.oncia_ShowTransactionsClause_ids = function($this) {
        return $this.$ids;
    };
    $java.oncia_ShowTransactionsClause_where = function($this) {
        return $this.$where7;
    };
    $java.oncia_ShowTransactionsClause_yieldItems = function($this) {
        return $this.$yieldItems;
    };
    $java.oncia_ShowTransactionsClause_yieldAll = function($this) {
        return $this.$yieldAll0;
    };
    $java.oncia_ShowTransactionsClause_position = function($this) {
        return $this.$position154;
    };
    $java.oncia_ShowTransactionsClause_name = function($this) {
        return $rt_s(376);
    };
    $java.oncia_ShowTransactionsClause_transactionColumns = function($this) {
        return $this.$transactionColumns0;
    };
    $java.oncia_ShowTransactionsClause_unfilteredColumns = function($this) {
        return $this.$unfilteredColumns5;
    };
    $java.oncia_ShowTransactionsClause_moveWhereToYield = function($this) {
        var $x$1;
        $x$1 = s_None$_MODULE$;
        return $java.oncia_ShowTransactionsClause_copy($this, $this.$briefTransactionColumns, $this.$allTransactionColumns, $this.$ids, $x$1, $this.$yieldItems, $this.$yieldAll0, $this.$position154);
    };
    $java.oncia_ShowTransactionsClause_copy = function($this, $briefTransactionColumns, $allTransactionColumns, $ids, $where, $yieldItems, $yieldAll, $position) {
        return $java.oncia_ShowTransactionsClause__init_($briefTransactionColumns, $allTransactionColumns, $ids, $where, $yieldItems, $yieldAll, $position);
    };
    $java.oncia_ShowTransactionsClause_productPrefix = function($this) {
        return $rt_s(2118);
    };
    $java.oncia_ShowTransactionsClause_productArity = function($this) {
        return 6;
    };
    $java.oncia_ShowTransactionsClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$briefTransactionColumns;
            case 1:
                return $this.$allTransactionColumns;
            case 2:
                return $this.$ids;
            case 3:
                return $this.$where7;
            case 4:
                return $this.$yieldItems;
            case 5:
                return jl_Boolean_valueOf($this.$yieldAll0);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowTransactionsClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowTransactionsClause_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2118))), sr_Statics_anyHash($this.$briefTransactionColumns)), sr_Statics_anyHash($this.$allTransactionColumns)), sr_Statics_anyHash($this.$ids)), sr_Statics_anyHash($this.$where7)), sr_Statics_anyHash($this.$yieldItems)), !$this.$yieldAll0 ? 1237 : 1231), 6);
    };
    $java.oncia_ShowTransactionsClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowTransactionsClause_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ShowTransactionsClause) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$yieldAll0 != $x$1.$yieldAll0)
                        break b;
                    c: {
                        var$2 = $this.$briefTransactionColumns;
                        var$3 = $x$1.$briefTransactionColumns;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$allTransactionColumns;
                        var$3 = $x$1.$allTransactionColumns;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$ids;
                        var$3 = $x$1.$ids;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$where7;
                        var$3 = $x$1.$where7;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$3 = $this.$yieldItems;
                        $x$1 = $x$1.$yieldItems;
                        if (var$3 !== null) {
                            if (!sci_List_equals(var$3, $x$1))
                                break b;
                            else
                                break g;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ShowTransactionsClause))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ShowTransactionsClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ShowTransactionsClause__init_0 = function($this, $briefTransactionColumns, $allTransactionColumns, $ids, $where, $yieldItems, $yieldAll, $position) {
        $this.$briefTransactionColumns = $briefTransactionColumns;
        $this.$allTransactionColumns = $allTransactionColumns;
        $this.$ids = $ids;
        $this.$where7 = $where;
        $this.$yieldItems = $yieldItems;
        $this.$yieldAll0 = $yieldAll;
        $this.$position154 = $position;
        oncia_Clause_$init$($this);
        $yieldAll = !sc_IterableOnceOps_nonEmpty$($yieldItems) && !$yieldAll ? 0 : 1;
        $this.$useAllColumns0 = $yieldAll;
        $this.$transactionColumns0 = !$yieldAll ? $briefTransactionColumns : $allTransactionColumns;
        $ids = new $java.oncia_ShowTransactionsClause$_init_$lambda$_94_0;
        $ids.$_0434 = $this;
        $this.$briefColumns = sci_List_map($briefTransactionColumns, $ids);
        $briefTransactionColumns = new $java.oncia_ShowTransactionsClause$_init_$lambda$_94_1;
        $briefTransactionColumns.$_0435 = $this;
        $briefTransactionColumns = sci_List_map($allTransactionColumns, $briefTransactionColumns);
        $this.$allColumns = $briefTransactionColumns;
        $this.$unfilteredColumns5 = oncia_DefaultOrAllShowColumns$_apply(oncia_DefaultOrAllShowColumns$_MODULE$, $this.$useAllColumns0, $this.$briefColumns, $briefTransactionColumns);
    };
    function oncia_TerminateTransactionsClause() {
        var a = this; jl_Object.call(a);
        a.$transactionColumns1 = null;
        a.$ids0 = null;
        a.$yieldItems0 = null;
        a.$yieldAll1 = 0;
        a.$wherePos = null;
        a.$position155 = null;
        a.$columns1 = null;
        a.$unfilteredColumns6 = null;
        a.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap0 = null;
        a.$LabelExpressionsPartition$module20 = null;
        a.$org$neo4j$cypher$internal$ast$Clause$$stringifier20 = null;
        a.$SetExtractor$module20 = null;
        a.$bitmap$028 = 0;
    }
    function oncia_TerminateTransactionsClause__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_TerminateTransactionsClause();
        $java.oncia_TerminateTransactionsClause__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    $java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$super$clauseSpecificSemanticCheck = function($this) {
        return $java.oncia_CommandClause_clauseSpecificSemanticCheck$($this);
    };
    $java.oncia_TerminateTransactionsClause_returnVariables = function($this) {
        return oncia_Clause_returnVariables$($this);
    };
    $java.oncia_TerminateTransactionsClause_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this);
    };
    $java.oncia_TerminateTransactionsClause_shouldRunGpmChecks = function($this) {
        return 1;
    };
    $java.oncia_TerminateTransactionsClause_semanticCheckFold = function($this, $iterable, $f) {
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, $f);
    };
    $java.oncia_TerminateTransactionsClause_declareVariable = function($this, $v, $possibleTypes) {
        return oncias_SemanticAnalysisTooling_declareVariable$($this, $v, $possibleTypes);
    };
    $java.oncia_TerminateTransactionsClause_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_TerminateTransactionsClause_asCanonicalStringVal = function($this) {
        return $this.$toString();
    };
    $java.oncia_TerminateTransactionsClause_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_TerminateTransactionsClause_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap = function($this) {
        var var$1, $$je;
        if ($this.$bitmap$028)
            return $this.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap0;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$028)
                    break a;
                $this.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap0 = $java.oncia_TransactionsCommandClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$($this);
                $this.$bitmap$028 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap0;
    };
    $java.oncia_TerminateTransactionsClause_LabelExpressionsPartition = function($this) {
        var var$1, $$je;
        if ($this.$LabelExpressionsPartition$module20 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$LabelExpressionsPartition$module20 !== null)
                        break a;
                    $this.$LabelExpressionsPartition$module20 = oncia_Clause$LabelExpressionsPartition$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$LabelExpressionsPartition$module20;
    };
    $java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier20;
    };
    $java.oncia_TerminateTransactionsClause_SetExtractor = function($this) {
        var var$1, $$je;
        if ($this.$SetExtractor$module20 === null) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($this.$SetExtractor$module20 !== null)
                        break a;
                    $this.$SetExtractor$module20 = oncia_Clause$SetExtractor$__init_($this);
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$SetExtractor$module20;
    };
    $java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$Clause$$stringifier20 = $x$1;
    };
    $java.oncia_TerminateTransactionsClause_transactionColumns = function($this) {
        return $this.$transactionColumns1;
    };
    $java.oncia_TerminateTransactionsClause_ids = function($this) {
        return $this.$ids0;
    };
    $java.oncia_TerminateTransactionsClause_yieldItems = function($this) {
        return $this.$yieldItems0;
    };
    $java.oncia_TerminateTransactionsClause_yieldAll = function($this) {
        return $this.$yieldAll1;
    };
    $java.oncia_TerminateTransactionsClause_position = function($this) {
        return $this.$position155;
    };
    $java.oncia_TerminateTransactionsClause_name = function($this) {
        return $rt_s(377);
    };
    $java.oncia_TerminateTransactionsClause_unfilteredColumns = function($this) {
        return $this.$unfilteredColumns6;
    };
    $java.oncia_TerminateTransactionsClause_clauseSpecificSemanticCheck = function($this) {
        var var$1, $ls, var$3, var$4;
        var$1 = oncias_SemanticCheck$_MODULE$;
        $ls = $this.$ids0;
        if (!($ls instanceof su_Left)) {
            if (!($ls instanceof su_Right))
                $rt_throw(s_MatchError__init_($ls));
            var$3 = 0;
        } else
            var$3 = $ls.$value11.$length() >= 1 ? 0 : 1;
        $ls = new $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_0;
        $ls.$_0436 = $this;
        var$1 = oncias_SemanticCheck$_when(var$1, var$3, $ls);
        $ls = oncias_SemanticCheck$_MODULE$;
        var$3 = s_Option_isDefined($this.$wherePos);
        var$4 = new $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_1;
        var$4.$_0437 = $this;
        return oncias_SemanticCheck_chain$(var$1.$chain(oncias_SemanticCheck$_when($ls, var$3, var$4)), $java.oncia_TransactionsCommandClause_clauseSpecificSemanticCheck$($this));
    };
    $java.oncia_TerminateTransactionsClause_where = function($this) {
        return s_None$_MODULE$;
    };
    $java.oncia_TerminateTransactionsClause_moveWhereToYield = function($this) {
        return $this;
    };
    $java.oncia_TerminateTransactionsClause_productPrefix = function($this) {
        return $rt_s(2119);
    };
    $java.oncia_TerminateTransactionsClause_productArity = function($this) {
        return 5;
    };
    $java.oncia_TerminateTransactionsClause_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$transactionColumns1;
            case 1:
                return $this.$ids0;
            case 2:
                return $this.$yieldItems0;
            case 3:
                return jl_Boolean_valueOf($this.$yieldAll1);
            case 4:
                return $this.$wherePos;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_TerminateTransactionsClause_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TerminateTransactionsClause_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2119))), sr_Statics_anyHash($this.$transactionColumns1)), sr_Statics_anyHash($this.$ids0)), sr_Statics_anyHash($this.$yieldItems0)), !$this.$yieldAll1 ? 1237 : 1231), sr_Statics_anyHash($this.$wherePos)), 5);
    };
    $java.oncia_TerminateTransactionsClause_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TerminateTransactionsClause_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_TerminateTransactionsClause) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$yieldAll1 != $x$1.$yieldAll1)
                        break b;
                    c: {
                        var$2 = $this.$transactionColumns1;
                        var$3 = $x$1.$transactionColumns1;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$ids0;
                        var$3 = $x$1.$ids0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$yieldItems0;
                        var$3 = $x$1.$yieldItems0;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$wherePos;
                        $x$1 = $x$1.$wherePos;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_TerminateTransactionsClause))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_TerminateTransactionsClause_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_TerminateTransactionsClause__init_ = function($this, $transactionColumns, $ids, $yieldItems, $yieldAll, $wherePos, $position) {
        $this.$transactionColumns1 = $transactionColumns;
        $this.$ids0 = $ids;
        $this.$yieldItems0 = $yieldItems;
        $this.$yieldAll1 = $yieldAll;
        $this.$wherePos = $wherePos;
        $this.$position155 = $position;
        oncia_Clause_$init$($this);
        $ids = new $java.oncia_TerminateTransactionsClause$_init_$lambda$_91_0;
        $ids.$_0438 = $this;
        $this.$columns1 = sci_List_map($transactionColumns, $ids);
        $transactionColumns = oncia_DefaultOrAllShowColumns$_MODULE$;
        $yieldAll = !sc_IterableOnceOps_nonEmpty$($yieldItems) && !$yieldAll ? 0 : 1;
        $ids = $this.$columns1;
        $this.$unfilteredColumns6 = oncia_DefaultOrAllShowColumns$_apply($transactionColumns, $yieldAll, $ids, $ids);
    };
    function oncie_MatchMode$DifferentRelationships() {
        var a = this; jl_Object.call(a);
        a.$implicitlyCreated = 0;
        a.$position156 = null;
    }
    function oncie_MatchMode$DifferentRelationships__init_(var_0, var_1) {
        var var_2 = new oncie_MatchMode$DifferentRelationships();
        $java.oncie_MatchMode$DifferentRelationships__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_MatchMode$DifferentRelationships_position = function($this) {
        return $this.$position156;
    };
    $java.oncie_MatchMode$DifferentRelationships_prettified = function($this) {
        if (!$this.$implicitlyCreated)
            return $rt_s(2120);
        return $rt_s(3);
    };
    $java.oncie_MatchMode$DifferentRelationships_productPrefix = function($this) {
        return $rt_s(2121);
    };
    $java.oncie_MatchMode$DifferentRelationships_productArity = function($this) {
        return 1;
    };
    $java.oncie_MatchMode$DifferentRelationships_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$implicitlyCreated);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_MatchMode$DifferentRelationships_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MatchMode$DifferentRelationships_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2121))), !$this.$implicitlyCreated ? 1237 : 1231), 1);
    };
    $java.oncie_MatchMode$DifferentRelationships_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MatchMode$DifferentRelationships_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_MatchMode$DifferentRelationships) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$implicitlyCreated != $x$1.$implicitlyCreated)
                        break b;
                    if (!($this instanceof oncie_MatchMode$DifferentRelationships))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncie_MatchMode$DifferentRelationships_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_MatchMode$DifferentRelationships__init_ = function($this, $implicitlyCreated, $position) {
        $this.$implicitlyCreated = $implicitlyCreated;
        $this.$position156 = $position;
    };
    $java.onciu_BucketSize = $rt_classWithoutFields(0);
    var onciu_UnknownSize$ = $rt_classWithoutFields();
    var onciu_UnknownSize$_MODULE$ = null;
    function onciu_UnknownSize$__clinit_() {
        onciu_UnknownSize$_MODULE$ = new onciu_UnknownSize$;
    }
    $java.onciu_UnknownSize$_productArity = function($this) {
        return 0;
    };
    $java.onciu_UnknownSize$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_UnknownSize$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnknownSize$_hashCode = function($this) {
        return (-1007455413);
    };
    $java.onciu_UnknownSize$_toString = function($this) {
        return $rt_s(2122);
    };
    function jusi_SpliteratorOverCollection() {
        var a = this; jl_Object.call(a);
        a.$collection = null;
        a.$iterator2 = null;
    }
    function oncia_ParameterName() {
        var a = this; jl_Object.call(a);
        a.$parameter0 = null;
        a.$position157 = null;
    }
    function oncia_ParameterName__init_(var_0, var_1) {
        var var_2 = new oncia_ParameterName();
        $java.oncia_ParameterName__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_ParameterName_position = function($this) {
        return $this.$position157;
    };
    $java.oncia_ParameterName_productPrefix = function($this) {
        return $rt_s(2123);
    };
    $java.oncia_ParameterName_productArity = function($this) {
        return 1;
    };
    $java.oncia_ParameterName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$parameter0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ParameterName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ParameterName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ParameterName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ParameterName_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ParameterName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$parameter0;
                        $x$1 = $x$1.$parameter0;
                        if (var$2 !== null) {
                            if (!$java.oncie_ExplicitParameter_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ParameterName))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ParameterName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ParameterName__init_ = function($this, $parameter, $position) {
        $this.$parameter0 = $parameter;
        $this.$position157 = $position;
    };
    var oncia_NamespacedName$ = $rt_classWithoutFields();
    $java.oncia_NamespacedName$_MODULE$ = null;
    function oncia_NamespacedName$__clinit_() {
        $java.oncia_NamespacedName$_MODULE$ = new oncia_NamespacedName$;
    }
    function oncia_AlterLocalDatabaseAlias() {
        var a = this; jl_Object.call(a);
        a.$aliasName4 = null;
        a.$targetName3 = null;
        a.$ifExists0 = 0;
        a.$properties24 = null;
        a.$position158 = null;
        a.$isReadOnly18 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar19 = null;
    }
    $java.oncia_AlterLocalDatabaseAlias__init_ = function(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_AlterLocalDatabaseAlias();
        oncia_AlterLocalDatabaseAlias__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    };
    $java.oncia_AlterLocalDatabaseAlias_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_AlterLocalDatabaseAlias_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_AlterLocalDatabaseAlias_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_AlterLocalDatabaseAlias_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_AlterLocalDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly18 = $x$1;
    };
    $java.oncia_AlterLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar19;
    };
    $java.oncia_AlterLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar19 = $x$1;
    };
    function oncia_AlterLocalDatabaseAlias_aliasName($this) {
        return $this.$aliasName4;
    }
    function oncia_AlterLocalDatabaseAlias_targetName($this) {
        return $this.$targetName3;
    }
    function oncia_AlterLocalDatabaseAlias_ifExists($this) {
        return $this.$ifExists0;
    }
    function oncia_AlterLocalDatabaseAlias_properties($this) {
        return $this.$properties24;
    }
    $java.oncia_AlterLocalDatabaseAlias_position = function($this) {
        return $this.$position158;
    };
    function oncia_AlterLocalDatabaseAlias_name($this) {
        return $rt_s(2124);
    }
    $java.oncia_AlterLocalDatabaseAlias_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_AlterLocalDatabaseAlias_productPrefix = function($this) {
        return $rt_s(2125);
    };
    $java.oncia_AlterLocalDatabaseAlias_productArity = function($this) {
        return 4;
    };
    $java.oncia_AlterLocalDatabaseAlias_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$aliasName4;
            case 1:
                return $this.$targetName3;
            case 2:
                return jl_Boolean_valueOf($this.$ifExists0);
            case 3:
                return $this.$properties24;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterLocalDatabaseAlias_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterLocalDatabaseAlias_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2125))), sr_Statics_anyHash($this.$aliasName4)), sr_Statics_anyHash($this.$targetName3)), !$this.$ifExists0 ? 1237 : 1231), sr_Statics_anyHash($this.$properties24)), 4);
    };
    $java.oncia_AlterLocalDatabaseAlias_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterLocalDatabaseAlias_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_AlterLocalDatabaseAlias) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists0 != $x$1.$ifExists0)
                            break b;
                        d: {
                            var$2 = $this.$aliasName4;
                            var$3 = $x$1.$aliasName4;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$targetName3;
                            var$3 = $x$1.$targetName3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$properties24;
                        $x$1 = $x$1.$properties24;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_AlterLocalDatabaseAlias_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_AlterLocalDatabaseAlias_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    function oncia_AlterLocalDatabaseAlias__init_($this, $aliasName, $targetName, $ifExists, $properties, $position) {
        $this.$aliasName4 = $aliasName;
        $this.$targetName3 = $targetName;
        $this.$ifExists0 = $ifExists;
        $this.$properties24 = $properties;
        $this.$position158 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    }
    function onciafn_Neo4jASTFactory$alterLocalDatabaseAlias$lambda$_227_0() {
        jl_Object.call(this);
        this.$_0251 = null;
    }
    $java.onciafn_Neo4jASTFactory$alterLocalDatabaseAlias$lambda$_227_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_Neo4jASTFactory_asExpressionMapAst(var$0.$_0251, var$1);
    };
    function oncia_AlterRemoteDatabaseAlias() {
        var a = this; jl_Object.call(a);
        a.$aliasName5 = null;
        a.$targetName4 = null;
        a.$ifExists1 = 0;
        a.$url2 = null;
        a.$username2 = null;
        a.$password2 = null;
        a.$driverSettings1 = null;
        a.$properties25 = null;
        a.$position159 = null;
        a.$isReadOnly19 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar20 = null;
    }
    $java.oncia_AlterRemoteDatabaseAlias__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8) {
        var var_9 = new oncia_AlterRemoteDatabaseAlias();
        oncia_AlterRemoteDatabaseAlias__init_(var_9, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8);
        return var_9;
    };
    $java.oncia_AlterRemoteDatabaseAlias_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_AlterRemoteDatabaseAlias_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_AlterRemoteDatabaseAlias_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_AlterRemoteDatabaseAlias_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_AlterRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly19 = $x$1;
    };
    $java.oncia_AlterRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar20;
    };
    $java.oncia_AlterRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar20 = $x$1;
    };
    function oncia_AlterRemoteDatabaseAlias_aliasName($this) {
        return $this.$aliasName5;
    }
    function oncia_AlterRemoteDatabaseAlias_targetName($this) {
        return $this.$targetName4;
    }
    function oncia_AlterRemoteDatabaseAlias_ifExists($this) {
        return $this.$ifExists1;
    }
    function oncia_AlterRemoteDatabaseAlias_url($this) {
        return $this.$url2;
    }
    function oncia_AlterRemoteDatabaseAlias_username($this) {
        return $this.$username2;
    }
    function oncia_AlterRemoteDatabaseAlias_password($this) {
        return $this.$password2;
    }
    function oncia_AlterRemoteDatabaseAlias_driverSettings($this) {
        return $this.$driverSettings1;
    }
    function oncia_AlterRemoteDatabaseAlias_properties($this) {
        return $this.$properties25;
    }
    $java.oncia_AlterRemoteDatabaseAlias_position = function($this) {
        return $this.$position159;
    };
    function oncia_AlterRemoteDatabaseAlias_name($this) {
        return $rt_s(2124);
    }
    $java.oncia_AlterRemoteDatabaseAlias_semanticCheck = function($this) {
        var $expr, $isLocalAlias, $isRemoteAlias, var$4;
        $expr = $java.oncia_AliasDriverSettingsCheck$_findInvalidDriverSettings($java.oncia_AliasDriverSettingsCheck$_MODULE$, $this.$driverSettings1);
        if ($expr instanceof s_Some) {
            $expr = $expr.$value5;
            if ($expr instanceof oncia_ExistsExpression)
                return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_existsErrorMessage, $expr.$position2());
            if ($expr instanceof oncia_CountExpression)
                return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_countErrorMessage, $expr.$position2());
            if (!($expr instanceof oncia_CollectExpression))
                return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_genericErrorMessage, $expr.$position2());
            return oncias_SemanticAnalysisTooling_error$($this, $java.oncia_AliasDriverSettingsCheck$_collectErrorMessage, $expr.$position2());
        }
        $isLocalAlias = s_Option_isDefined($this.$targetName4) && s_Option_isEmpty($this.$url2) ? 1 : 0;
        $isRemoteAlias = !s_Option_isDefined($this.$url2) && !s_Option_isDefined($this.$username2) && !s_Option_isDefined($this.$password2) && !s_Option_isDefined($this.$driverSettings1) ? 0 : 1;
        if ($isLocalAlias && $isRemoteAlias) {
            $expr = onciap_Prettifier$_escapeName0(onciap_Prettifier$_MODULE$, $this.$aliasName5, s_DummyImplicit$_dummyImplicit0);
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$4);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(2126)), $expr), $rt_s(2127));
            return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$4), $this.$position159);
        }
        $expr = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$($expr, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_AlterRemoteDatabaseAlias_productPrefix = function($this) {
        return $rt_s(2128);
    };
    $java.oncia_AlterRemoteDatabaseAlias_productArity = function($this) {
        return 8;
    };
    $java.oncia_AlterRemoteDatabaseAlias_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$aliasName5;
            case 1:
                return $this.$targetName4;
            case 2:
                return jl_Boolean_valueOf($this.$ifExists1);
            case 3:
                return $this.$url2;
            case 4:
                return $this.$username2;
            case 5:
                return $this.$password2;
            case 6:
                return $this.$driverSettings1;
            case 7:
                return $this.$properties25;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterRemoteDatabaseAlias_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterRemoteDatabaseAlias_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2128))), sr_Statics_anyHash($this.$aliasName5)), sr_Statics_anyHash($this.$targetName4)), !$this.$ifExists1 ? 1237 : 1231), sr_Statics_anyHash($this.$url2)), sr_Statics_anyHash($this.$username2)), sr_Statics_anyHash($this.$password2)), sr_Statics_anyHash($this.$driverSettings1)), sr_Statics_anyHash($this.$properties25)),
        8);
    };
    $java.oncia_AlterRemoteDatabaseAlias_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterRemoteDatabaseAlias_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_AlterRemoteDatabaseAlias) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists1 != $x$1.$ifExists1)
                            break b;
                        d: {
                            var$2 = $this.$aliasName5;
                            var$3 = $x$1.$aliasName5;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$targetName4;
                            var$3 = $x$1.$targetName4;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$url2;
                            var$3 = $x$1.$url2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        g: {
                            var$2 = $this.$username2;
                            var$3 = $x$1.$username2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break g;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        h: {
                            var$2 = $this.$password2;
                            var$3 = $x$1.$password2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break h;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        i: {
                            var$2 = $this.$driverSettings1;
                            var$3 = $x$1.$driverSettings1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break i;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$properties25;
                        $x$1 = $x$1.$properties25;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_AlterRemoteDatabaseAlias_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_AlterRemoteDatabaseAlias_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    function oncia_AlterRemoteDatabaseAlias__init_($this, $aliasName, $targetName, $ifExists, $url, $username, $password, $driverSettings, $properties, $position) {
        $this.$aliasName5 = $aliasName;
        $this.$targetName4 = $targetName;
        $this.$ifExists1 = $ifExists;
        $this.$url2 = $url;
        $this.$username2 = $username;
        $this.$password2 = $password;
        $this.$driverSettings1 = $driverSettings;
        $this.$properties25 = $properties;
        $this.$position159 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    }
    var onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    var onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_2() {
        jl_Object.call(this);
        this.$_0252 = null;
    }
    $java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_Neo4jASTFactory_asExpressionMapAst(var$0.$_0252, var$1);
    };
    function onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_3() {
        jl_Object.call(this);
        this.$_0253 = null;
    }
    $java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_Neo4jASTFactory_asExpressionMapAst(var$0.$_0253, var$1);
    };
    function oncia_SetOwnPassword() {
        var a = this; jl_Object.call(a);
        a.$newPassword0 = null;
        a.$currentPassword0 = null;
        a.$position160 = null;
        a.$isReadOnly20 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar21 = null;
    }
    function oncia_SetOwnPassword__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_SetOwnPassword();
        $java.oncia_SetOwnPassword__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_SetOwnPassword_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_SetOwnPassword_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_SetOwnPassword_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_SetOwnPassword_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_SetOwnPassword_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly20 = $x$1;
    };
    $java.oncia_SetOwnPassword_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar21;
    };
    $java.oncia_SetOwnPassword_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar21 = $x$1;
    };
    function oncia_SetOwnPassword_newPassword($this) {
        return $this.$newPassword0;
    }
    function oncia_SetOwnPassword_currentPassword($this) {
        return $this.$currentPassword0;
    }
    $java.oncia_SetOwnPassword_position = function($this) {
        return $this.$position160;
    };
    function oncia_SetOwnPassword_name($this) {
        return $rt_s(2129);
    }
    $java.oncia_SetOwnPassword_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_SetOwnPassword_productPrefix = function($this) {
        return $rt_s(2130);
    };
    $java.oncia_SetOwnPassword_productArity = function($this) {
        return 2;
    };
    $java.oncia_SetOwnPassword_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$newPassword0;
            case 1:
                return $this.$currentPassword0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetOwnPassword_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetOwnPassword_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetOwnPassword_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetOwnPassword_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SetOwnPassword) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$newPassword0;
                            var$3 = $x$1.$newPassword0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$currentPassword0;
                        $x$1 = $x$1.$currentPassword0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_SetOwnPassword_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SetOwnPassword_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_SetOwnPassword__init_ = function($this, $newPassword, $currentPassword, $position) {
        $this.$newPassword0 = $newPassword;
        $this.$currentPassword0 = $currentPassword;
        $this.$position160 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    var onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        onciaf_AccessType_$callClinit();
        if (jl_Enum_equals(onciaf_AccessType_READ_ONLY, var$1))
            var$1 = $java.oncia_ReadOnlyAccess$_MODULE$;
        else {
            if (!jl_Enum_equals(onciaf_AccessType_READ_WRITE, var$1))
                $rt_throw(s_MatchError__init_(var$1));
            var$1 = $java.oncia_ReadWriteAccess$_MODULE$;
        }
        return var$1;
    };
    var onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_1_apply = function(var$0, var$1) {
        return jl_Integer_valueOf(var$1.$value);
    };
    var onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_2 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_2_apply = function(var$0, var$1) {
        return jl_Integer_valueOf(var$1.$value);
    };
    function oncia_AlterDatabase() {
        var a = this; jl_Object.call(a);
        a.$dbName3 = null;
        a.$ifExists2 = 0;
        a.$access0 = null;
        a.$topology1 = null;
        a.$options21 = null;
        a.$optionsToRemove0 = null;
        a.$waitUntilComplete4 = null;
        a.$position161 = null;
        a.$isReadOnly21 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar22 = null;
    }
    function oncia_AlterDatabase__init_(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7) {
        var var_8 = new oncia_AlterDatabase();
        $java.oncia_AlterDatabase__init_(var_8, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7);
        return var_8;
    }
    $java.oncia_AlterDatabase_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_AlterDatabase_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_AlterDatabase_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_AlterDatabase_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_AlterDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly21 = $x$1;
    };
    $java.oncia_AlterDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar22;
    };
    $java.oncia_AlterDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar22 = $x$1;
    };
    function oncia_AlterDatabase_dbName($this) {
        return $this.$dbName3;
    }
    function oncia_AlterDatabase_ifExists($this) {
        return $this.$ifExists2;
    }
    function oncia_AlterDatabase_access($this) {
        return $this.$access0;
    }
    function oncia_AlterDatabase_topology($this) {
        return $this.$topology1;
    }
    function oncia_AlterDatabase_options($this) {
        return $this.$options21;
    }
    function oncia_AlterDatabase_optionsToRemove($this) {
        return $this.$optionsToRemove0;
    }
    function oncia_AlterDatabase_waitUntilComplete($this) {
        return $this.$waitUntilComplete4;
    }
    $java.oncia_AlterDatabase_position = function($this) {
        return $this.$position161;
    };
    function oncia_AlterDatabase_name($this) {
        return $rt_s(2131);
    }
    $java.oncia_AlterDatabase_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this)), $java.oncia_WriteAdministrationCommand_topologyCheck$($this, $this.$topology1, $rt_s(2131)));
    };
    $java.oncia_AlterDatabase_productPrefix = function($this) {
        return $rt_s(2132);
    };
    $java.oncia_AlterDatabase_productArity = function($this) {
        return 7;
    };
    $java.oncia_AlterDatabase_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$dbName3;
            case 1:
                return jl_Boolean_valueOf($this.$ifExists2);
            case 2:
                return $this.$access0;
            case 3:
                return $this.$topology1;
            case 4:
                return $this.$options21;
            case 5:
                return $this.$optionsToRemove0;
            case 6:
                return $this.$waitUntilComplete4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterDatabase_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterDatabase_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2132))), sr_Statics_anyHash($this.$dbName3)), !$this.$ifExists2 ? 1237 : 1231), sr_Statics_anyHash($this.$access0)), sr_Statics_anyHash($this.$topology1)), sr_Statics_anyHash($this.$options21)), sr_Statics_anyHash($this.$optionsToRemove0)), sr_Statics_anyHash($this.$waitUntilComplete4)), 7);
    };
    $java.oncia_AlterDatabase_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterDatabase_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_AlterDatabase) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists2 != $x$1.$ifExists2)
                            break b;
                        d: {
                            var$2 = $this.$dbName3;
                            var$3 = $x$1.$dbName3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$access0;
                            var$3 = $x$1.$access0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$topology1;
                            var$3 = $x$1.$topology1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        g: {
                            var$2 = $this.$options21;
                            var$3 = $x$1.$options21;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break g;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        h: {
                            var$2 = $this.$optionsToRemove0;
                            var$3 = $x$1.$optionsToRemove0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break h;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$waitUntilComplete4;
                        $x$1 = $x$1.$waitUntilComplete4;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_AlterDatabase_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_AlterDatabase_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_AlterDatabase__init_ = function($this, $dbName, $ifExists, $access, $topology, $options, $optionsToRemove, $waitUntilComplete, $position) {
        $this.$dbName3 = $dbName;
        $this.$ifExists2 = $ifExists;
        $this.$access0 = $access;
        $this.$topology1 = $topology;
        $this.$options21 = $options;
        $this.$optionsToRemove0 = $optionsToRemove;
        $this.$waitUntilComplete4 = $waitUntilComplete;
        $this.$position161 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_AlterServer() {
        var a = this; jl_Object.call(a);
        a.$serverName1 = null;
        a.$optionsMap1 = null;
        a.$position162 = null;
        a.$isReadOnly22 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar23 = null;
    }
    function oncia_AlterServer__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_AlterServer();
        $java.oncia_AlterServer__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_AlterServer_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_AlterServer_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_AlterServer_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_AlterServer_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_AlterServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly22 = $x$1;
    };
    $java.oncia_AlterServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar23;
    };
    $java.oncia_AlterServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar23 = $x$1;
    };
    function oncia_AlterServer_serverName($this) {
        return $this.$serverName1;
    }
    function oncia_AlterServer_optionsMap($this) {
        return $this.$optionsMap1;
    }
    $java.oncia_AlterServer_position = function($this) {
        return $this.$position162;
    };
    function oncia_AlterServer_name($this) {
        return $rt_s(2133);
    }
    $java.oncia_AlterServer_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_AlterServer_productPrefix = function($this) {
        return $rt_s(2134);
    };
    $java.oncia_AlterServer_productArity = function($this) {
        return 2;
    };
    $java.oncia_AlterServer_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$serverName1;
            case 1:
                return $this.$optionsMap1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterServer_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterServer_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterServer_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterServer_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_AlterServer) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$serverName1;
                            var$3 = $x$1.$serverName1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$optionsMap1;
                        $x$1 = $x$1.$optionsMap1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_AlterServer_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_AlterServer_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_AlterServer__init_ = function($this, $serverName, $optionsMap, $position) {
        $this.$serverName1 = $serverName;
        $this.$optionsMap1 = $optionsMap;
        $this.$position162 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    var oncia_RemoveHomeDatabaseAction$ = $rt_classWithoutFields();
    var oncia_RemoveHomeDatabaseAction$_MODULE$ = null;
    function oncia_RemoveHomeDatabaseAction$__clinit_() {
        oncia_RemoveHomeDatabaseAction$_MODULE$ = new oncia_RemoveHomeDatabaseAction$;
    }
    $java.oncia_RemoveHomeDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RemoveHomeDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RemoveHomeDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemoveHomeDatabaseAction$_hashCode = function($this) {
        return 1523761684;
    };
    $java.oncia_RemoveHomeDatabaseAction$_toString = function($this) {
        return $rt_s(2135);
    };
    function oncia_AlterUser() {
        var a = this; jl_Object.call(a);
        a.$userName1 = null;
        a.$isEncryptedPassword2 = null;
        a.$initialPassword2 = null;
        a.$userOptions1 = null;
        a.$ifExists3 = 0;
        a.$position163 = null;
        a.$isReadOnly23 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar24 = null;
    }
    function oncia_AlterUser__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_AlterUser();
        $java.oncia_AlterUser__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    $java.oncia_AlterUser_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_AlterUser_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_AlterUser_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_AlterUser_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_AlterUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly23 = $x$1;
    };
    $java.oncia_AlterUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar24;
    };
    $java.oncia_AlterUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar24 = $x$1;
    };
    function oncia_AlterUser_userName($this) {
        return $this.$userName1;
    }
    function oncia_AlterUser_isEncryptedPassword($this) {
        return $this.$isEncryptedPassword2;
    }
    function oncia_AlterUser_initialPassword($this) {
        return $this.$initialPassword2;
    }
    function oncia_AlterUser_userOptions($this) {
        return $this.$userOptions1;
    }
    function oncia_AlterUser_ifExists($this) {
        return $this.$ifExists3;
    }
    $java.oncia_AlterUser_position = function($this) {
        return $this.$position163;
    };
    function oncia_AlterUser_name($this) {
        return $rt_s(2136);
    }
    $java.oncia_AlterUser_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_AlterUser_productPrefix = function($this) {
        return $rt_s(2137);
    };
    $java.oncia_AlterUser_productArity = function($this) {
        return 5;
    };
    $java.oncia_AlterUser_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$userName1;
            case 1:
                return $this.$isEncryptedPassword2;
            case 2:
                return $this.$initialPassword2;
            case 3:
                return $this.$userOptions1;
            case 4:
                return jl_Boolean_valueOf($this.$ifExists3);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterUser_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterUser_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2137))), sr_Statics_anyHash($this.$userName1)), sr_Statics_anyHash($this.$isEncryptedPassword2)), sr_Statics_anyHash($this.$initialPassword2)), sr_Statics_anyHash($this.$userOptions1)), !$this.$ifExists3 ? 1237 : 1231), 5);
    };
    $java.oncia_AlterUser_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterUser_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_AlterUser) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists3 != $x$1.$ifExists3)
                            break b;
                        d: {
                            var$2 = $this.$userName1;
                            var$3 = $x$1.$userName1;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$isEncryptedPassword2;
                            var$3 = $x$1.$isEncryptedPassword2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$initialPassword2;
                            var$3 = $x$1.$initialPassword2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$userOptions1;
                        $x$1 = $x$1.$userOptions1;
                        if (var$3 !== null) {
                            if (!$java.oncia_UserOptions_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_AlterUser_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_AlterUser_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_AlterUser__init_ = function($this, $userName, $isEncryptedPassword, $initialPassword, $userOptions, $ifExists, $position) {
        $this.$userName1 = $userName;
        $this.$isEncryptedPassword2 = $isEncryptedPassword;
        $this.$initialPassword2 = $initialPassword;
        $this.$userOptions1 = $userOptions;
        $this.$ifExists3 = $ifExists;
        $this.$position163 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
        s_Predef$_$callClinit();
        s_Predef$_assert(s_Predef$_MODULE$, !s_Option_isDefined($initialPassword) && !s_Option_isDefined($userOptions.$requirePasswordChange0) && !s_Option_isDefined($userOptions.$suspended0) && !s_Option_isDefined($userOptions.$homeDatabase0) ? 0 : 1);
        if (s_Option_isDefined($userOptions.$homeDatabase0) && $userOptions.$homeDatabase0.$get0() === null)
            s_Predef$_assert(s_Predef$_MODULE$, s_Option_isEmpty($initialPassword) && s_Option_isEmpty($userOptions.$requirePasswordChange0) && s_Option_isEmpty($userOptions.$suspended0) ? 1 : 0);
    };
    function oncia_DeallocateServers() {
        var a = this; jl_Object.call(a);
        a.$dryRun0 = 0;
        a.$serverNames0 = null;
        a.$position164 = null;
        a.$isReadOnly24 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar25 = null;
    }
    function oncia_DeallocateServers__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_DeallocateServers();
        $java.oncia_DeallocateServers__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_DeallocateServers_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_DeallocateServers_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_DeallocateServers_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DeallocateServers_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DeallocateServers_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {};
    $java.oncia_DeallocateServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar25;
    };
    $java.oncia_DeallocateServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar25 = $x$1;
    };
    function oncia_DeallocateServers_dryRun($this) {
        return $this.$dryRun0;
    }
    function oncia_DeallocateServers_serverNames($this) {
        return $this.$serverNames0;
    }
    $java.oncia_DeallocateServers_position = function($this) {
        return $this.$position164;
    };
    function oncia_DeallocateServers_name($this) {
        return $rt_s(2138);
    }
    $java.oncia_DeallocateServers_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_DeallocateServers_productPrefix = function($this) {
        return $rt_s(2139);
    };
    $java.oncia_DeallocateServers_productArity = function($this) {
        return 2;
    };
    $java.oncia_DeallocateServers_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$dryRun0);
            case 1:
                return $this.$serverNames0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DeallocateServers_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DeallocateServers_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2139))), !$this.$dryRun0 ? 1237 : 1231), sr_Statics_anyHash($this.$serverNames0)), 2);
    };
    $java.oncia_DeallocateServers_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DeallocateServers_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DeallocateServers) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$dryRun0 != $x$1.$dryRun0)
                            break b;
                        var$2 = $this.$serverNames0;
                        $x$1 = $x$1.$serverNames0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_DeallocateServers_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DeallocateServers_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_DeallocateServers__init_ = function($this, $dryRun, $serverNames, $position) {
        $this.$dryRun0 = $dryRun;
        $this.$serverNames0 = $serverNames;
        $this.$position164 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
        $this.$isReadOnly24 = $dryRun;
    };
    var onciafn_Neo4jASTFactory$deallocateServers$lambda$_212_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$deallocateServers$lambda$_212_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_ReallocateDatabases() {
        var a = this; jl_Object.call(a);
        a.$dryRun1 = 0;
        a.$position165 = null;
        a.$isReadOnly25 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar26 = null;
    }
    function oncia_ReallocateDatabases__init_(var_0, var_1) {
        var var_2 = new oncia_ReallocateDatabases();
        $java.oncia_ReallocateDatabases__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_ReallocateDatabases_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_ReallocateDatabases_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ReallocateDatabases_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_ReallocateDatabases_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_ReallocateDatabases_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {};
    $java.oncia_ReallocateDatabases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar26;
    };
    $java.oncia_ReallocateDatabases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar26 = $x$1;
    };
    function oncia_ReallocateDatabases_dryRun($this) {
        return $this.$dryRun1;
    }
    $java.oncia_ReallocateDatabases_position = function($this) {
        return $this.$position165;
    };
    function oncia_ReallocateDatabases_name($this) {
        return $rt_s(2140);
    }
    $java.oncia_ReallocateDatabases_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_ReallocateDatabases_productPrefix = function($this) {
        return $rt_s(2141);
    };
    $java.oncia_ReallocateDatabases_productArity = function($this) {
        return 1;
    };
    $java.oncia_ReallocateDatabases_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$dryRun1);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ReallocateDatabases_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ReallocateDatabases_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2141))), !$this.$dryRun1 ? 1237 : 1231), 1);
    };
    $java.oncia_ReallocateDatabases_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ReallocateDatabases_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ReallocateDatabases) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$dryRun1 != $x$1.$dryRun1)
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncia_ReallocateDatabases_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ReallocateDatabases_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_ReallocateDatabases__init_ = function($this, $dryRun, $position) {
        $this.$dryRun1 = $dryRun;
        $this.$position165 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
        $this.$isReadOnly25 = $dryRun;
    };
    $java.oncia_DatabasePrivilegeQualifier = $rt_classWithoutFields(0);
    function oncia_AllDatabasesQualifier() {
        jl_Object.call(this);
        this.$position12 = null;
    }
    $java.oncia_AllDatabasesQualifier_productPrefix = function($this) {
        return $rt_s(2142);
    };
    $java.oncia_AllDatabasesQualifier_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllDatabasesQualifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllDatabasesQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabasesQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabasesQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabasesQualifier_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_AllDatabasesQualifier))
            return 0;
        return 1;
    };
    $java.oncia_AllDatabasesQualifier_dup = function($this, $children) {
        return $this;
    };
    $java.juf_Consumer = $rt_classWithoutFields(0);
    function onciafn_Neo4jASTFactory$userQualifier$lambda$_200_0() {
        jl_Object.call(this);
        this.$_0229 = null;
    }
    $java.onciafn_Neo4jASTFactory$userQualifier$lambda$_200_0_accept = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0229;
        var$3 = new oncia_UserQualifier;
        var$1 = onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
        onciu_InputPosition$_$callClinit();
        $java.oncia_UserQualifier__init_(var$3, var$1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        ju_ArrayList_add(var$2, var$3);
    };
    function oncia_UserAllQualifier() {
        jl_Object.call(this);
        this.$position13 = null;
    }
    $java.oncia_UserAllQualifier_productPrefix = function($this) {
        return $rt_s(2143);
    };
    $java.oncia_UserAllQualifier_productArity = function($this) {
        return 0;
    };
    $java.oncia_UserAllQualifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UserAllQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserAllQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserAllQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserAllQualifier_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_UserAllQualifier))
            return 0;
        return 1;
    };
    $java.oncia_UserAllQualifier_dup = function($this, $children) {
        return $this;
    };
    $java.oncia_GraphScope = $rt_classWithoutFields(0);
    $java.oncia_ActionResource = $rt_classWithoutFields(0);
    $java.oncia_DatabaseAction = function() {
        jl_Object.call(this);
        this.$name50 = null;
    };
    $java.oncia_DatabaseAction_name = function($this) {
        return $this.$name50;
    };
    $java.oncia_DatabaseAction__init_ = function($this, $name) {
        $this.$name50 = $name;
    };
    var oncia_AllDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseAction);
    var oncia_AllDatabaseAction$_MODULE$ = null;
    function oncia_AllDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AllDatabaseAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2144));
        oncia_AllDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_AllDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabaseAction$_hashCode = function($this) {
        return (-2104636558);
    };
    $java.oncia_AllDatabaseAction$_toString = function($this) {
        return $rt_s(2145);
    };
    var oncia_AccessDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseAction);
    var oncia_AccessDatabaseAction$_MODULE$ = null;
    function oncia_AccessDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AccessDatabaseAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(1646));
        oncia_AccessDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_AccessDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AccessDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AccessDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AccessDatabaseAction$_hashCode = function($this) {
        return (-673994187);
    };
    $java.oncia_AccessDatabaseAction$_toString = function($this) {
        return $rt_s(2146);
    };
    var oncia_StartDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseAction);
    var oncia_StartDatabaseAction$_MODULE$ = null;
    function oncia_StartDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_StartDatabaseAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2147));
        oncia_StartDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_StartDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_StartDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_StartDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StartDatabaseAction$_hashCode = function($this) {
        return 1885878387;
    };
    $java.oncia_StartDatabaseAction$_toString = function($this) {
        return $rt_s(2148);
    };
    var oncia_StopDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseAction);
    var oncia_StopDatabaseAction$_MODULE$ = null;
    function oncia_StopDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_StopDatabaseAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2149));
        oncia_StopDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_StopDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_StopDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_StopDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_StopDatabaseAction$_hashCode = function($this) {
        return 1540659283;
    };
    $java.oncia_StopDatabaseAction$_toString = function($this) {
        return $rt_s(2150);
    };
    $java.oncia_IndexManagementAction = $rt_classWithoutFields($java.oncia_DatabaseAction);
    $java.oncia_IndexManagementAction_name = function($this) {
        return $this.$name50;
    };
    var oncia_AllIndexActions$ = $rt_classWithoutFields($java.oncia_IndexManagementAction);
    var oncia_AllIndexActions$_MODULE$ = null;
    function oncia_AllIndexActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllIndexActions$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2151));
        oncia_AllIndexActions$_MODULE$ = var$1;
    }
    $java.oncia_AllIndexActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllIndexActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllIndexActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllIndexActions$_hashCode = function($this) {
        return (-1599036436);
    };
    $java.oncia_AllIndexActions$_toString = function($this) {
        return $rt_s(2152);
    };
    var oncia_CreateIndexAction$ = $rt_classWithoutFields($java.oncia_IndexManagementAction);
    var oncia_CreateIndexAction$_MODULE$ = null;
    function oncia_CreateIndexAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateIndexAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2153));
        oncia_CreateIndexAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateIndexAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateIndexAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateIndexAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateIndexAction$_hashCode = function($this) {
        return 1213284076;
    };
    $java.oncia_CreateIndexAction$_toString = function($this) {
        return $rt_s(2154);
    };
    var oncia_DropIndexAction$ = $rt_classWithoutFields($java.oncia_IndexManagementAction);
    var oncia_DropIndexAction$_MODULE$ = null;
    function oncia_DropIndexAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DropIndexAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2155));
        oncia_DropIndexAction$_MODULE$ = var$1;
    }
    $java.oncia_DropIndexAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DropIndexAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropIndexAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropIndexAction$_hashCode = function($this) {
        return (-815004903);
    };
    $java.oncia_DropIndexAction$_toString = function($this) {
        return $rt_s(2156);
    };
    var oncia_ShowIndexAction$ = $rt_classWithoutFields($java.oncia_IndexManagementAction);
    var oncia_ShowIndexAction$_MODULE$ = null;
    function oncia_ShowIndexAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowIndexAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2157));
        oncia_ShowIndexAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowIndexAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowIndexAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowIndexAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowIndexAction$_hashCode = function($this) {
        return 1987633739;
    };
    $java.oncia_ShowIndexAction$_toString = function($this) {
        return $rt_s(2158);
    };
    $java.oncia_ConstraintManagementAction = $rt_classWithoutFields($java.oncia_DatabaseAction);
    $java.oncia_ConstraintManagementAction_name = function($this) {
        return $this.$name50;
    };
    var oncia_AllConstraintActions$ = $rt_classWithoutFields($java.oncia_ConstraintManagementAction);
    var oncia_AllConstraintActions$_MODULE$ = null;
    function oncia_AllConstraintActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllConstraintActions$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2159));
        oncia_AllConstraintActions$_MODULE$ = var$1;
    }
    $java.oncia_AllConstraintActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllConstraintActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllConstraintActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllConstraintActions$_hashCode = function($this) {
        return (-2117322529);
    };
    $java.oncia_AllConstraintActions$_toString = function($this) {
        return $rt_s(2160);
    };
    var oncia_CreateConstraintAction$ = $rt_classWithoutFields($java.oncia_ConstraintManagementAction);
    var oncia_CreateConstraintAction$_MODULE$ = null;
    function oncia_CreateConstraintAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateConstraintAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2161));
        oncia_CreateConstraintAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateConstraintAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateConstraintAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateConstraintAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateConstraintAction$_hashCode = function($this) {
        return 1912733615;
    };
    $java.oncia_CreateConstraintAction$_toString = function($this) {
        return $rt_s(2162);
    };
    var oncia_DropConstraintAction$ = $rt_classWithoutFields($java.oncia_ConstraintManagementAction);
    var oncia_DropConstraintAction$_MODULE$ = null;
    function oncia_DropConstraintAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DropConstraintAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2163));
        oncia_DropConstraintAction$_MODULE$ = var$1;
    }
    $java.oncia_DropConstraintAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DropConstraintAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropConstraintAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropConstraintAction$_hashCode = function($this) {
        return 231460770;
    };
    $java.oncia_DropConstraintAction$_toString = function($this) {
        return $rt_s(2164);
    };
    var oncia_ShowConstraintAction$ = $rt_classWithoutFields($java.oncia_ConstraintManagementAction);
    var oncia_ShowConstraintAction$_MODULE$ = null;
    function oncia_ShowConstraintAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowConstraintAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2165));
        oncia_ShowConstraintAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowConstraintAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowConstraintAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowConstraintAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowConstraintAction$_hashCode = function($this) {
        return (-867917904);
    };
    $java.oncia_ShowConstraintAction$_toString = function($this) {
        return $rt_s(2166);
    };
    $java.oncia_NameManagementAction = $rt_classWithoutFields($java.oncia_DatabaseAction);
    $java.oncia_NameManagementAction_name = function($this) {
        return $this.$name50;
    };
    var oncia_AllTokenActions$ = $rt_classWithoutFields($java.oncia_NameManagementAction);
    var oncia_AllTokenActions$_MODULE$ = null;
    function oncia_AllTokenActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllTokenActions$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2167));
        oncia_AllTokenActions$_MODULE$ = var$1;
    }
    $java.oncia_AllTokenActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllTokenActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllTokenActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllTokenActions$_hashCode = function($this) {
        return 695060709;
    };
    $java.oncia_AllTokenActions$_toString = function($this) {
        return $rt_s(2168);
    };
    var oncia_CreatePropertyKeyAction$ = $rt_classWithoutFields($java.oncia_NameManagementAction);
    var oncia_CreatePropertyKeyAction$_MODULE$ = null;
    function oncia_CreatePropertyKeyAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreatePropertyKeyAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2169));
        oncia_CreatePropertyKeyAction$_MODULE$ = var$1;
    }
    $java.oncia_CreatePropertyKeyAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreatePropertyKeyAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreatePropertyKeyAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreatePropertyKeyAction$_hashCode = function($this) {
        return (-1818651292);
    };
    $java.oncia_CreatePropertyKeyAction$_toString = function($this) {
        return $rt_s(2170);
    };
    var oncia_CreateNodeLabelAction$ = $rt_classWithoutFields($java.oncia_NameManagementAction);
    var oncia_CreateNodeLabelAction$_MODULE$ = null;
    function oncia_CreateNodeLabelAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateNodeLabelAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2171));
        oncia_CreateNodeLabelAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateNodeLabelAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateNodeLabelAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateNodeLabelAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateNodeLabelAction$_hashCode = function($this) {
        return 1759458860;
    };
    $java.oncia_CreateNodeLabelAction$_toString = function($this) {
        return $rt_s(2172);
    };
    var oncia_CreateRelationshipTypeAction$ = $rt_classWithoutFields($java.oncia_NameManagementAction);
    var oncia_CreateRelationshipTypeAction$_MODULE$ = null;
    function oncia_CreateRelationshipTypeAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateRelationshipTypeAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2173));
        oncia_CreateRelationshipTypeAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateRelationshipTypeAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateRelationshipTypeAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRelationshipTypeAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRelationshipTypeAction$_hashCode = function($this) {
        return (-979939676);
    };
    $java.oncia_CreateRelationshipTypeAction$_toString = function($this) {
        return $rt_s(2174);
    };
    $java.oncia_TransactionManagementAction = $rt_classWithoutFields($java.oncia_DatabaseAction);
    $java.oncia_TransactionManagementAction_name = function($this) {
        return $this.$name50;
    };
    var oncia_AllTransactionActions$ = $rt_classWithoutFields($java.oncia_TransactionManagementAction);
    var oncia_AllTransactionActions$_MODULE$ = null;
    function oncia_AllTransactionActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllTransactionActions$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2175));
        oncia_AllTransactionActions$_MODULE$ = var$1;
    }
    $java.oncia_AllTransactionActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllTransactionActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllTransactionActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllTransactionActions$_hashCode = function($this) {
        return (-1288800352);
    };
    $java.oncia_AllTransactionActions$_toString = function($this) {
        return $rt_s(2176);
    };
    var oncia_ShowTransactionAction$ = $rt_classWithoutFields($java.oncia_TransactionManagementAction);
    var oncia_ShowTransactionAction$_MODULE$ = null;
    function oncia_ShowTransactionAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowTransactionAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2177));
        oncia_ShowTransactionAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowTransactionAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowTransactionAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowTransactionAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowTransactionAction$_hashCode = function($this) {
        return 524455191;
    };
    $java.oncia_ShowTransactionAction$_toString = function($this) {
        return $rt_s(2178);
    };
    var oncia_TerminateTransactionAction$ = $rt_classWithoutFields($java.oncia_TransactionManagementAction);
    var oncia_TerminateTransactionAction$_MODULE$ = null;
    function oncia_TerminateTransactionAction$__clinit_() {
        var var$1;
        var$1 = new oncia_TerminateTransactionAction$;
        $java.oncia_DatabaseAction__init_(var$1, $rt_s(2179));
        oncia_TerminateTransactionAction$_MODULE$ = var$1;
    }
    $java.oncia_TerminateTransactionAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_TerminateTransactionAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_TerminateTransactionAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TerminateTransactionAction$_hashCode = function($this) {
        return 252750451;
    };
    $java.oncia_TerminateTransactionAction$_toString = function($this) {
        return $rt_s(2180);
    };
    $java.oncia_DbmsAction = function() {
        jl_Object.call(this);
        this.$name51 = null;
    };
    $java.oncia_DbmsAction_name = function($this) {
        return $this.$name51;
    };
    $java.oncia_DbmsAction__init_ = function($this, $name) {
        $this.$name51 = $name;
    };
    var oncia_AllDbmsAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_AllDbmsAction$_MODULE$ = null;
    function oncia_AllDbmsAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AllDbmsAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2181));
        oncia_AllDbmsAction$_MODULE$ = var$1;
    }
    $java.oncia_AllDbmsAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllDbmsAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllDbmsAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDbmsAction$_hashCode = function($this) {
        return (-1220050341);
    };
    $java.oncia_AllDbmsAction$_toString = function($this) {
        return $rt_s(2182);
    };
    $java.oncia_UserManagementAction = $rt_classWithoutFields($java.oncia_DbmsAction);
    $java.oncia_UserManagementAction_name = function($this) {
        return $this.$name51;
    };
    var oncia_AllUserActions$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_AllUserActions$_MODULE$ = null;
    function oncia_AllUserActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllUserActions$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2183));
        oncia_AllUserActions$_MODULE$ = var$1;
    }
    $java.oncia_AllUserActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllUserActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllUserActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllUserActions$_hashCode = function($this) {
        return 1135904369;
    };
    $java.oncia_AllUserActions$_toString = function($this) {
        return $rt_s(2184);
    };
    var oncia_ShowUserAction$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_ShowUserAction$_MODULE$ = null;
    function oncia_ShowUserAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowUserAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2185));
        oncia_ShowUserAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowUserAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowUserAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowUserAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowUserAction$_hashCode = function($this) {
        return 1653259486;
    };
    $java.oncia_ShowUserAction$_toString = function($this) {
        return $rt_s(2186);
    };
    var oncia_AlterUserAction$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_AlterUserAction$_MODULE$ = null;
    function oncia_AlterUserAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AlterUserAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2136));
        oncia_AlterUserAction$_MODULE$ = var$1;
    }
    $java.oncia_AlterUserAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AlterUserAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterUserAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterUserAction$_hashCode = function($this) {
        return 983941751;
    };
    $java.oncia_AlterUserAction$_toString = function($this) {
        return $rt_s(2187);
    };
    var oncia_CreateUserAction$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_CreateUserAction$_MODULE$ = null;
    function oncia_CreateUserAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateUserAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1637));
        oncia_CreateUserAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateUserAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateUserAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateUserAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateUserAction$_hashCode = function($this) {
        return 2043922461;
    };
    $java.oncia_CreateUserAction$_toString = function($this) {
        return $rt_s(2188);
    };
    var oncia_DropUserAction$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_DropUserAction$_MODULE$ = null;
    function oncia_DropUserAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DropUserAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2189));
        oncia_DropUserAction$_MODULE$ = var$1;
    }
    $java.oncia_DropUserAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DropUserAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropUserAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropUserAction$_hashCode = function($this) {
        return 1701399120;
    };
    $java.oncia_DropUserAction$_toString = function($this) {
        return $rt_s(2190);
    };
    $java.oncia_RoleManagementAction = $rt_classWithoutFields($java.oncia_DbmsAction);
    $java.oncia_RoleManagementAction_name = function($this) {
        return $this.$name51;
    };
    var oncia_RenameUserAction$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_RenameUserAction$_MODULE$ = null;
    function oncia_RenameUserAction$__clinit_() {
        var var$1;
        var$1 = new oncia_RenameUserAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2191));
        oncia_RenameUserAction$_MODULE$ = var$1;
    }
    $java.oncia_RenameUserAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RenameUserAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RenameUserAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameUserAction$_hashCode = function($this) {
        return (-601099297);
    };
    $java.oncia_RenameUserAction$_toString = function($this) {
        return $rt_s(2192);
    };
    var oncia_SetPasswordsAction$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_SetPasswordsAction$_MODULE$ = null;
    function oncia_SetPasswordsAction$__clinit_() {
        var var$1;
        var$1 = new oncia_SetPasswordsAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2193));
        oncia_SetPasswordsAction$_MODULE$ = var$1;
    }
    $java.oncia_SetPasswordsAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SetPasswordsAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetPasswordsAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetPasswordsAction$_hashCode = function($this) {
        return (-62627604);
    };
    $java.oncia_SetPasswordsAction$_toString = function($this) {
        return $rt_s(2194);
    };
    var oncia_SetUserStatusAction$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_SetUserStatusAction$_MODULE$ = null;
    function oncia_SetUserStatusAction$__clinit_() {
        var var$1;
        var$1 = new oncia_SetUserStatusAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2195));
        oncia_SetUserStatusAction$_MODULE$ = var$1;
    }
    $java.oncia_SetUserStatusAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SetUserStatusAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetUserStatusAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetUserStatusAction$_hashCode = function($this) {
        return (-979916651);
    };
    $java.oncia_SetUserStatusAction$_toString = function($this) {
        return $rt_s(2196);
    };
    var oncia_SetUserHomeDatabaseAction$ = $rt_classWithoutFields($java.oncia_UserManagementAction);
    var oncia_SetUserHomeDatabaseAction$_MODULE$ = null;
    function oncia_SetUserHomeDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_SetUserHomeDatabaseAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2197));
        oncia_SetUserHomeDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_SetUserHomeDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SetUserHomeDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetUserHomeDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetUserHomeDatabaseAction$_hashCode = function($this) {
        return (-381460387);
    };
    $java.oncia_SetUserHomeDatabaseAction$_toString = function($this) {
        return $rt_s(2198);
    };
    var oncia_ImpersonateUserAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ImpersonateUserAction$_MODULE$ = null;
    function oncia_ImpersonateUserAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ImpersonateUserAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2199));
        oncia_ImpersonateUserAction$_MODULE$ = var$1;
    }
    $java.oncia_ImpersonateUserAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ImpersonateUserAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ImpersonateUserAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ImpersonateUserAction$_hashCode = function($this) {
        return 1403738394;
    };
    $java.oncia_ImpersonateUserAction$_toString = function($this) {
        return $rt_s(2200);
    };
    var oncia_AllRoleActions$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_AllRoleActions$_MODULE$ = null;
    function oncia_AllRoleActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllRoleActions$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2201));
        oncia_AllRoleActions$_MODULE$ = var$1;
    }
    $java.oncia_AllRoleActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllRoleActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllRoleActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllRoleActions$_hashCode = function($this) {
        return 2068867942;
    };
    $java.oncia_AllRoleActions$_toString = function($this) {
        return $rt_s(2202);
    };
    var oncia_ShowRoleAction$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_ShowRoleAction$_MODULE$ = null;
    function oncia_ShowRoleAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowRoleAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2203));
        oncia_ShowRoleAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowRoleAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowRoleAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowRoleAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowRoleAction$_hashCode = function($this) {
        return 1544807753;
    };
    $java.oncia_ShowRoleAction$_toString = function($this) {
        return $rt_s(2204);
    };
    var oncia_CreateRoleAction$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_CreateRoleAction$_MODULE$ = null;
    function oncia_CreateRoleAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateRoleAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1631));
        oncia_CreateRoleAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateRoleAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateRoleAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateRoleAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateRoleAction$_hashCode = function($this) {
        return 1935470728;
    };
    $java.oncia_CreateRoleAction$_toString = function($this) {
        return $rt_s(2205);
    };
    var oncia_DropRoleAction$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_DropRoleAction$_MODULE$ = null;
    function oncia_DropRoleAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DropRoleAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2206));
        oncia_DropRoleAction$_MODULE$ = var$1;
    }
    $java.oncia_DropRoleAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DropRoleAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropRoleAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropRoleAction$_hashCode = function($this) {
        return 1592947387;
    };
    $java.oncia_DropRoleAction$_toString = function($this) {
        return $rt_s(2207);
    };
    var oncia_RenameRoleAction$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_RenameRoleAction$_MODULE$ = null;
    function oncia_RenameRoleAction$__clinit_() {
        var var$1;
        var$1 = new oncia_RenameRoleAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2208));
        oncia_RenameRoleAction$_MODULE$ = var$1;
    }
    $java.oncia_RenameRoleAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RenameRoleAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RenameRoleAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameRoleAction$_hashCode = function($this) {
        return (-709551030);
    };
    $java.oncia_RenameRoleAction$_toString = function($this) {
        return $rt_s(2209);
    };
    var oncia_AssignRoleAction$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_AssignRoleAction$_MODULE$ = null;
    function oncia_AssignRoleAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AssignRoleAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2210));
        oncia_AssignRoleAction$_MODULE$ = var$1;
    }
    $java.oncia_AssignRoleAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AssignRoleAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AssignRoleAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AssignRoleAction$_hashCode = function($this) {
        return (-1336755013);
    };
    $java.oncia_AssignRoleAction$_toString = function($this) {
        return $rt_s(2211);
    };
    var oncia_RemoveRoleAction$ = $rt_classWithoutFields($java.oncia_RoleManagementAction);
    var oncia_RemoveRoleAction$_MODULE$ = null;
    function oncia_RemoveRoleAction$__clinit_() {
        var var$1;
        var$1 = new oncia_RemoveRoleAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2212));
        oncia_RemoveRoleAction$_MODULE$ = var$1;
    }
    $java.oncia_RemoveRoleAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RemoveRoleAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RemoveRoleAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemoveRoleAction$_hashCode = function($this) {
        return 1145077264;
    };
    $java.oncia_RemoveRoleAction$_toString = function($this) {
        return $rt_s(2213);
    };
    $java.oncia_DatabaseManagementAction = $rt_classWithoutFields($java.oncia_DbmsAction);
    $java.oncia_DatabaseManagementAction_name = function($this) {
        return $this.$name51;
    };
    var oncia_AllDatabaseManagementActions$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_AllDatabaseManagementActions$_MODULE$ = null;
    function oncia_AllDatabaseManagementActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllDatabaseManagementActions$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2214));
        oncia_AllDatabaseManagementActions$_MODULE$ = var$1;
    }
    $java.oncia_AllDatabaseManagementActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllDatabaseManagementActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllDatabaseManagementActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllDatabaseManagementActions$_hashCode = function($this) {
        return 1807514750;
    };
    $java.oncia_AllDatabaseManagementActions$_toString = function($this) {
        return $rt_s(2215);
    };
    var oncia_CreateDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_CreateDatabaseAction$_MODULE$ = null;
    function oncia_CreateDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateDatabaseAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1626));
        oncia_CreateDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateDatabaseAction$_hashCode = function($this) {
        return (-232690739);
    };
    $java.oncia_CreateDatabaseAction$_toString = function($this) {
        return $rt_s(2216);
    };
    var oncia_DropDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_DropDatabaseAction$_MODULE$ = null;
    function oncia_DropDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DropDatabaseAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2217));
        oncia_DropDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_DropDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DropDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropDatabaseAction$_hashCode = function($this) {
        return 905223296;
    };
    $java.oncia_DropDatabaseAction$_toString = function($this) {
        return $rt_s(2218);
    };
    var oncia_CompositeDatabaseManagementActions$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_CompositeDatabaseManagementActions$_MODULE$ = null;
    function oncia_CompositeDatabaseManagementActions$__clinit_() {
        var var$1;
        var$1 = new oncia_CompositeDatabaseManagementActions$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2219));
        oncia_CompositeDatabaseManagementActions$_MODULE$ = var$1;
    }
    $java.oncia_CompositeDatabaseManagementActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CompositeDatabaseManagementActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CompositeDatabaseManagementActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CompositeDatabaseManagementActions$_hashCode = function($this) {
        return 1442617944;
    };
    $java.oncia_CompositeDatabaseManagementActions$_toString = function($this) {
        return $rt_s(2220);
    };
    var oncia_CreateCompositeDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_CreateCompositeDatabaseAction$_MODULE$ = null;
    function oncia_CreateCompositeDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateCompositeDatabaseAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1584));
        oncia_CreateCompositeDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateCompositeDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateCompositeDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateCompositeDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateCompositeDatabaseAction$_hashCode = function($this) {
        return 1372079420;
    };
    $java.oncia_CreateCompositeDatabaseAction$_toString = function($this) {
        return $rt_s(2221);
    };
    var oncia_DropCompositeDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_DropCompositeDatabaseAction$_MODULE$ = null;
    function oncia_DropCompositeDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DropCompositeDatabaseAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2222));
        oncia_DropCompositeDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_DropCompositeDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DropCompositeDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropCompositeDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropCompositeDatabaseAction$_hashCode = function($this) {
        return 1071984105;
    };
    $java.oncia_DropCompositeDatabaseAction$_toString = function($this) {
        return $rt_s(2223);
    };
    var oncia_AlterDatabaseAction$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_AlterDatabaseAction$_MODULE$ = null;
    function oncia_AlterDatabaseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AlterDatabaseAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2131));
        oncia_AlterDatabaseAction$_MODULE$ = var$1;
    }
    $java.oncia_AlterDatabaseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AlterDatabaseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterDatabaseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterDatabaseAction$_hashCode = function($this) {
        return (-1436899033);
    };
    $java.oncia_AlterDatabaseAction$_toString = function($this) {
        return $rt_s(2224);
    };
    var oncia_SetDatabaseAccessAction$ = $rt_classWithoutFields($java.oncia_DatabaseManagementAction);
    var oncia_SetDatabaseAccessAction$_MODULE$ = null;
    function oncia_SetDatabaseAccessAction$__clinit_() {
        var var$1;
        var$1 = new oncia_SetDatabaseAccessAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2225));
        oncia_SetDatabaseAccessAction$_MODULE$ = var$1;
    }
    $java.oncia_SetDatabaseAccessAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SetDatabaseAccessAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetDatabaseAccessAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetDatabaseAccessAction$_hashCode = function($this) {
        return 1167215927;
    };
    $java.oncia_SetDatabaseAccessAction$_toString = function($this) {
        return $rt_s(2226);
    };
    $java.oncia_AliasManagementAction = $rt_classWithoutFields($java.oncia_DbmsAction);
    $java.oncia_AliasManagementAction_name = function($this) {
        return $this.$name51;
    };
    var oncia_AllAliasManagementActions$ = $rt_classWithoutFields($java.oncia_AliasManagementAction);
    var oncia_AllAliasManagementActions$_MODULE$ = null;
    function oncia_AllAliasManagementActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllAliasManagementActions$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2227));
        oncia_AllAliasManagementActions$_MODULE$ = var$1;
    }
    $java.oncia_AllAliasManagementActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllAliasManagementActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllAliasManagementActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllAliasManagementActions$_hashCode = function($this) {
        return 2064343467;
    };
    $java.oncia_AllAliasManagementActions$_toString = function($this) {
        return $rt_s(2228);
    };
    var oncia_CreateAliasAction$ = $rt_classWithoutFields($java.oncia_AliasManagementAction);
    var oncia_CreateAliasAction$_MODULE$ = null;
    function oncia_CreateAliasAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateAliasAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1572));
        oncia_CreateAliasAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateAliasAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateAliasAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateAliasAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateAliasAction$_hashCode = function($this) {
        return (-169142806);
    };
    $java.oncia_CreateAliasAction$_toString = function($this) {
        return $rt_s(2229);
    };
    var oncia_DropAliasAction$ = $rt_classWithoutFields($java.oncia_AliasManagementAction);
    var oncia_DropAliasAction$_MODULE$ = null;
    function oncia_DropAliasAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DropAliasAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2230));
        oncia_DropAliasAction$_MODULE$ = var$1;
    }
    $java.oncia_DropAliasAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DropAliasAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropAliasAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropAliasAction$_hashCode = function($this) {
        return 2097535511;
    };
    $java.oncia_DropAliasAction$_toString = function($this) {
        return $rt_s(2231);
    };
    var oncia_AlterAliasAction$ = $rt_classWithoutFields($java.oncia_AliasManagementAction);
    var oncia_AlterAliasAction$_MODULE$ = null;
    function oncia_AlterAliasAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AlterAliasAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2124));
        oncia_AlterAliasAction$_MODULE$ = var$1;
    }
    $java.oncia_AlterAliasAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AlterAliasAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AlterAliasAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AlterAliasAction$_hashCode = function($this) {
        return 1331193552;
    };
    $java.oncia_AlterAliasAction$_toString = function($this) {
        return $rt_s(2232);
    };
    var oncia_ShowAliasAction$ = $rt_classWithoutFields($java.oncia_AliasManagementAction);
    var oncia_ShowAliasAction$_MODULE$ = null;
    function oncia_ShowAliasAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowAliasAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1090));
        oncia_ShowAliasAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowAliasAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowAliasAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowAliasAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowAliasAction$_hashCode = function($this) {
        return 605206857;
    };
    $java.oncia_ShowAliasAction$_toString = function($this) {
        return $rt_s(2233);
    };
    $java.oncia_PrivilegeManagementAction = $rt_classWithoutFields($java.oncia_DbmsAction);
    $java.oncia_PrivilegeManagementAction_name = function($this) {
        return $this.$name51;
    };
    var oncia_AllPrivilegeActions$ = $rt_classWithoutFields($java.oncia_PrivilegeManagementAction);
    var oncia_AllPrivilegeActions$_MODULE$ = null;
    function oncia_AllPrivilegeActions$__clinit_() {
        var var$1;
        var$1 = new oncia_AllPrivilegeActions$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2234));
        oncia_AllPrivilegeActions$_MODULE$ = var$1;
    }
    $java.oncia_AllPrivilegeActions$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllPrivilegeActions$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllPrivilegeActions$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllPrivilegeActions$_hashCode = function($this) {
        return 1573475501;
    };
    $java.oncia_AllPrivilegeActions$_toString = function($this) {
        return $rt_s(2235);
    };
    var oncia_AssignPrivilegeAction$ = $rt_classWithoutFields($java.oncia_PrivilegeManagementAction);
    var oncia_AssignPrivilegeAction$_MODULE$ = null;
    function oncia_AssignPrivilegeAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AssignPrivilegeAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2236));
        oncia_AssignPrivilegeAction$_MODULE$ = var$1;
    }
    $java.oncia_AssignPrivilegeAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AssignPrivilegeAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AssignPrivilegeAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AssignPrivilegeAction$_hashCode = function($this) {
        return 1823441720;
    };
    $java.oncia_AssignPrivilegeAction$_toString = function($this) {
        return $rt_s(2237);
    };
    var oncia_RemovePrivilegeAction$ = $rt_classWithoutFields($java.oncia_PrivilegeManagementAction);
    var oncia_RemovePrivilegeAction$_MODULE$ = null;
    function oncia_RemovePrivilegeAction$__clinit_() {
        var var$1;
        var$1 = new oncia_RemovePrivilegeAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2238));
        oncia_RemovePrivilegeAction$_MODULE$ = var$1;
    }
    $java.oncia_RemovePrivilegeAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RemovePrivilegeAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RemovePrivilegeAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemovePrivilegeAction$_hashCode = function($this) {
        return 759058179;
    };
    $java.oncia_RemovePrivilegeAction$_toString = function($this) {
        return $rt_s(2239);
    };
    var oncia_ShowPrivilegeAction$ = $rt_classWithoutFields($java.oncia_PrivilegeManagementAction);
    var oncia_ShowPrivilegeAction$_MODULE$ = null;
    function oncia_ShowPrivilegeAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowPrivilegeAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1071));
        oncia_ShowPrivilegeAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowPrivilegeAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowPrivilegeAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowPrivilegeAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowPrivilegeAction$_hashCode = function($this) {
        return 632783722;
    };
    $java.oncia_ShowPrivilegeAction$_toString = function($this) {
        return $rt_s(2240);
    };
    var oncia_ExecuteFunctionAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ExecuteFunctionAction$_MODULE$ = null;
    function oncia_ExecuteFunctionAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ExecuteFunctionAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2241));
        oncia_ExecuteFunctionAction$_MODULE$ = var$1;
    }
    $java.oncia_ExecuteFunctionAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ExecuteFunctionAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ExecuteFunctionAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExecuteFunctionAction$_hashCode = function($this) {
        return 198180579;
    };
    $java.oncia_ExecuteFunctionAction$_toString = function($this) {
        return $rt_s(2242);
    };
    var oncia_ExecuteBoostedFunctionAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ExecuteBoostedFunctionAction$_MODULE$ = null;
    function oncia_ExecuteBoostedFunctionAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ExecuteBoostedFunctionAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2243));
        oncia_ExecuteBoostedFunctionAction$_MODULE$ = var$1;
    }
    $java.oncia_ExecuteBoostedFunctionAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ExecuteBoostedFunctionAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ExecuteBoostedFunctionAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExecuteBoostedFunctionAction$_hashCode = function($this) {
        return (-1363277829);
    };
    $java.oncia_ExecuteBoostedFunctionAction$_toString = function($this) {
        return $rt_s(2244);
    };
    var oncia_ExecuteProcedureAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ExecuteProcedureAction$_MODULE$ = null;
    function oncia_ExecuteProcedureAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ExecuteProcedureAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2245));
        oncia_ExecuteProcedureAction$_MODULE$ = var$1;
    }
    $java.oncia_ExecuteProcedureAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ExecuteProcedureAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ExecuteProcedureAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExecuteProcedureAction$_hashCode = function($this) {
        return 157693652;
    };
    $java.oncia_ExecuteProcedureAction$_toString = function($this) {
        return $rt_s(2246);
    };
    var oncia_ExecuteBoostedProcedureAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ExecuteBoostedProcedureAction$_MODULE$ = null;
    function oncia_ExecuteBoostedProcedureAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ExecuteBoostedProcedureAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2247));
        oncia_ExecuteBoostedProcedureAction$_MODULE$ = var$1;
    }
    $java.oncia_ExecuteBoostedProcedureAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ExecuteBoostedProcedureAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ExecuteBoostedProcedureAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExecuteBoostedProcedureAction$_hashCode = function($this) {
        return (-1002876740);
    };
    $java.oncia_ExecuteBoostedProcedureAction$_toString = function($this) {
        return $rt_s(2248);
    };
    var oncia_ExecuteAdminProcedureAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ExecuteAdminProcedureAction$_MODULE$ = null;
    function oncia_ExecuteAdminProcedureAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ExecuteAdminProcedureAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2249));
        oncia_ExecuteAdminProcedureAction$_MODULE$ = var$1;
    }
    $java.oncia_ExecuteAdminProcedureAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ExecuteAdminProcedureAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ExecuteAdminProcedureAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExecuteAdminProcedureAction$_hashCode = function($this) {
        return 785569423;
    };
    $java.oncia_ExecuteAdminProcedureAction$_toString = function($this) {
        return $rt_s(2250);
    };
    var oncia_ShowServerAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ShowServerAction$_MODULE$ = null;
    function oncia_ShowServerAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowServerAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(1099));
        oncia_ShowServerAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowServerAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowServerAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowServerAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowServerAction$_hashCode = function($this) {
        return (-846939370);
    };
    $java.oncia_ShowServerAction$_toString = function($this) {
        return $rt_s(2251);
    };
    var oncia_ServerManagementAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ServerManagementAction$_MODULE$ = null;
    function oncia_ServerManagementAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ServerManagementAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2252));
        oncia_ServerManagementAction$_MODULE$ = var$1;
    }
    $java.oncia_ServerManagementAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ServerManagementAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ServerManagementAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ServerManagementAction$_hashCode = function($this) {
        return (-1139237412);
    };
    $java.oncia_ServerManagementAction$_toString = function($this) {
        return $rt_s(2253);
    };
    var oncia_ShowSettingAction$ = $rt_classWithoutFields($java.oncia_DbmsAction);
    var oncia_ShowSettingAction$_MODULE$ = null;
    function oncia_ShowSettingAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ShowSettingAction$;
        $java.oncia_DbmsAction__init_(var$1, $rt_s(2254));
        oncia_ShowSettingAction$_MODULE$ = var$1;
    }
    $java.oncia_ShowSettingAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ShowSettingAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ShowSettingAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ShowSettingAction$_hashCode = function($this) {
        return 1964217481;
    };
    $java.oncia_ShowSettingAction$_toString = function($this) {
        return $rt_s(2255);
    };
    $java.oncia_GraphAction = function() {
        var a = this; jl_Object.call(a);
        a.$name21 = null;
        a.$planName = null;
    };
    $java.oncia_GraphAction_name = function($this) {
        return $this.$name21;
    };
    $java.oncia_GraphAction__init_ = function($this, $name, $planName) {
        $this.$name21 = $name;
        $this.$planName = $planName;
    };
    var oncia_AllGraphAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_AllGraphAction$_MODULE$ = null;
    function oncia_AllGraphAction$__clinit_() {
        var var$1;
        var$1 = new oncia_AllGraphAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(2256), $rt_s(2257));
        oncia_AllGraphAction$_MODULE$ = var$1;
    }
    $java.oncia_AllGraphAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllGraphAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllGraphAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllGraphAction$_hashCode = function($this) {
        return (-566700829);
    };
    $java.oncia_AllGraphAction$_toString = function($this) {
        return $rt_s(2258);
    };
    var oncia_WriteAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_WriteAction$_MODULE$ = null;
    function oncia_WriteAction$__clinit_() {
        var var$1;
        var$1 = new oncia_WriteAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(320), $rt_s(2259));
        oncia_WriteAction$_MODULE$ = var$1;
    }
    $java.oncia_WriteAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_WriteAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_WriteAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_WriteAction$_hashCode = function($this) {
        return (-1745828139);
    };
    $java.oncia_WriteAction$_toString = function($this) {
        return $rt_s(2260);
    };
    var oncia_CreateElementAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_CreateElementAction$_MODULE$ = null;
    function oncia_CreateElementAction$__clinit_() {
        var var$1;
        var$1 = new oncia_CreateElementAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(2026), $rt_s(2261));
        oncia_CreateElementAction$_MODULE$ = var$1;
    }
    $java.oncia_CreateElementAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_CreateElementAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CreateElementAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CreateElementAction$_hashCode = function($this) {
        return 1412377750;
    };
    $java.oncia_CreateElementAction$_toString = function($this) {
        return $rt_s(2262);
    };
    var oncia_MergeAdminAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_MergeAdminAction$_MODULE$ = null;
    function oncia_MergeAdminAction$__clinit_() {
        var var$1;
        var$1 = new oncia_MergeAdminAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(911), $rt_s(2065));
        oncia_MergeAdminAction$_MODULE$ = var$1;
    }
    $java.oncia_MergeAdminAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_MergeAdminAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_MergeAdminAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_MergeAdminAction$_hashCode = function($this) {
        return 130313005;
    };
    $java.oncia_MergeAdminAction$_toString = function($this) {
        return $rt_s(2263);
    };
    var oncia_DeleteElementAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_DeleteElementAction$_MODULE$ = null;
    function oncia_DeleteElementAction$__clinit_() {
        var var$1;
        var$1 = new oncia_DeleteElementAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(2037), $rt_s(2264));
        oncia_DeleteElementAction$_MODULE$ = var$1;
    }
    $java.oncia_DeleteElementAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DeleteElementAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DeleteElementAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DeleteElementAction$_hashCode = function($this) {
        return (-513958841);
    };
    $java.oncia_DeleteElementAction$_toString = function($this) {
        return $rt_s(2265);
    };
    var oncia_SetLabelAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_SetLabelAction$_MODULE$ = null;
    function oncia_SetLabelAction$__clinit_() {
        var var$1;
        var$1 = new oncia_SetLabelAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(321), $rt_s(2266));
        oncia_SetLabelAction$_MODULE$ = var$1;
    }
    $java.oncia_SetLabelAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SetLabelAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetLabelAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetLabelAction$_hashCode = function($this) {
        return 412117160;
    };
    $java.oncia_SetLabelAction$_toString = function($this) {
        return $rt_s(2267);
    };
    var oncia_RemoveLabelAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_RemoveLabelAction$_MODULE$ = null;
    function oncia_RemoveLabelAction$__clinit_() {
        var var$1;
        var$1 = new oncia_RemoveLabelAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(322), $rt_s(2268));
        oncia_RemoveLabelAction$_MODULE$ = var$1;
    }
    $java.oncia_RemoveLabelAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_RemoveLabelAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RemoveLabelAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemoveLabelAction$_hashCode = function($this) {
        return 1199511302;
    };
    $java.oncia_RemoveLabelAction$_toString = function($this) {
        return $rt_s(2269);
    };
    var oncia_SetPropertyAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_SetPropertyAction$_MODULE$ = null;
    function oncia_SetPropertyAction$__clinit_() {
        var var$1;
        var$1 = new oncia_SetPropertyAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(2270), $rt_s(2271));
        oncia_SetPropertyAction$_MODULE$ = var$1;
    }
    $java.oncia_SetPropertyAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SetPropertyAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetPropertyAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetPropertyAction$_hashCode = function($this) {
        return 296372557;
    };
    $java.oncia_SetPropertyAction$_toString = function($this) {
        return $rt_s(2272);
    };
    var oncia_MatchAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_MatchAction$_MODULE$ = null;
    function oncia_MatchAction$__clinit_() {
        var var$1;
        var$1 = new oncia_MatchAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(2039), $rt_s(2040));
        oncia_MatchAction$_MODULE$ = var$1;
    }
    $java.oncia_MatchAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_MatchAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_MatchAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_MatchAction$_hashCode = function($this) {
        return (-1513044933);
    };
    $java.oncia_MatchAction$_toString = function($this) {
        return $rt_s(2273);
    };
    var oncia_ReadAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_ReadAction$_MODULE$ = null;
    function oncia_ReadAction$__clinit_() {
        var var$1;
        var$1 = new oncia_ReadAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(2274), $rt_s(2275));
        oncia_ReadAction$_MODULE$ = var$1;
    }
    $java.oncia_ReadAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ReadAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ReadAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ReadAction$_hashCode = function($this) {
        return 962303884;
    };
    $java.oncia_ReadAction$_toString = function($this) {
        return $rt_s(2276);
    };
    var oncia_TraverseAction$ = $rt_classWithoutFields($java.oncia_GraphAction);
    var oncia_TraverseAction$_MODULE$ = null;
    function oncia_TraverseAction$__clinit_() {
        var var$1;
        var$1 = new oncia_TraverseAction$;
        $java.oncia_GraphAction__init_(var$1, $rt_s(2277), $rt_s(2278));
        oncia_TraverseAction$_MODULE$ = var$1;
    }
    $java.oncia_TraverseAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_TraverseAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_TraverseAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_TraverseAction$_hashCode = function($this) {
        return 1138564712;
    };
    $java.oncia_TraverseAction$_toString = function($this) {
        return $rt_s(2279);
    };
    function oncia_PrivilegeType() {
        jl_Object.call(this);
        this.$name46 = null;
    }
    $java.oncia_PrivilegeType_name = function($this) {
        return $this.$name46;
    };
    function oncia_PrivilegeType__init_($this, $name) {
        $this.$name46 = $name;
    }
    function oncia_DbmsPrivilege() {
        var a = this; oncia_PrivilegeType.call(a);
        a.$action1 = null;
        a.$position23 = null;
    }
    $java.oncia_DbmsPrivilege_productPrefix = function($this) {
        return $rt_s(2280);
    };
    $java.oncia_DbmsPrivilege_productArity = function($this) {
        return 1;
    };
    $java.oncia_DbmsPrivilege_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$action1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DbmsPrivilege_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DbmsPrivilege_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DbmsPrivilege_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DbmsPrivilege_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DbmsPrivilege) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$action1;
                        $x$1 = $x$1.$action1;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncia_DropDatabaseAlias() {
        var a = this; jl_Object.call(a);
        a.$aliasName6 = null;
        a.$ifExists4 = 0;
        a.$position166 = null;
        a.$isReadOnly26 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar27 = null;
    }
    function oncia_DropDatabaseAlias__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_DropDatabaseAlias();
        $java.oncia_DropDatabaseAlias__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_DropDatabaseAlias_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_DropDatabaseAlias_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_DropDatabaseAlias_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropDatabaseAlias_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly26 = $x$1;
    };
    $java.oncia_DropDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar27;
    };
    $java.oncia_DropDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar27 = $x$1;
    };
    function oncia_DropDatabaseAlias_aliasName($this) {
        return $this.$aliasName6;
    }
    function oncia_DropDatabaseAlias_ifExists($this) {
        return $this.$ifExists4;
    }
    $java.oncia_DropDatabaseAlias_position = function($this) {
        return $this.$position166;
    };
    function oncia_DropDatabaseAlias_name($this) {
        return $rt_s(2230);
    }
    $java.oncia_DropDatabaseAlias_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_DropDatabaseAlias_productPrefix = function($this) {
        return $rt_s(2281);
    };
    $java.oncia_DropDatabaseAlias_productArity = function($this) {
        return 2;
    };
    $java.oncia_DropDatabaseAlias_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$aliasName6;
            case 1:
                return jl_Boolean_valueOf($this.$ifExists4);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropDatabaseAlias_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropDatabaseAlias_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2281))), sr_Statics_anyHash($this.$aliasName6)), !$this.$ifExists4 ? 1237 : 1231), 2);
    };
    $java.oncia_DropDatabaseAlias_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropDatabaseAlias_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DropDatabaseAlias) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists4 != $x$1.$ifExists4)
                            break b;
                        var$2 = $this.$aliasName6;
                        $x$1 = $x$1.$aliasName6;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_DropDatabaseAlias_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropDatabaseAlias_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_DropDatabaseAlias__init_ = function($this, $aliasName, $ifExists, $position) {
        $this.$aliasName6 = $aliasName;
        $this.$ifExists4 = $ifExists;
        $this.$position166 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    $java.oncia_DropDatabaseAdditionalAction = function() {
        jl_Object.call(this);
        this.$name52 = null;
    };
    $java.oncia_DropDatabaseAdditionalAction__init_ = function($this, $name) {
        $this.$name52 = $name;
    };
    var oncia_DestroyData$ = $rt_classWithoutFields($java.oncia_DropDatabaseAdditionalAction);
    var oncia_DestroyData$_MODULE$ = null;
    function oncia_DestroyData$__clinit_() {
        var var$1;
        var$1 = new oncia_DestroyData$;
        $java.oncia_DropDatabaseAdditionalAction__init_(var$1, $rt_s(2282));
        oncia_DestroyData$_MODULE$ = var$1;
    }
    $java.oncia_DestroyData$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DestroyData$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DestroyData$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DestroyData$_hashCode = function($this) {
        return (-315023708);
    };
    $java.oncia_DestroyData$_toString = function($this) {
        return $rt_s(2283);
    };
    var oncia_DumpData$ = $rt_classWithoutFields($java.oncia_DropDatabaseAdditionalAction);
    var oncia_DumpData$_MODULE$ = null;
    function oncia_DumpData$__clinit_() {
        var var$1;
        var$1 = new oncia_DumpData$;
        $java.oncia_DropDatabaseAdditionalAction__init_(var$1, $rt_s(2284));
        oncia_DumpData$_MODULE$ = var$1;
    }
    $java.oncia_DumpData$_productArity = function($this) {
        return 0;
    };
    $java.oncia_DumpData$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DumpData$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DumpData$_hashCode = function($this) {
        return (-2058098722);
    };
    $java.oncia_DumpData$_toString = function($this) {
        return $rt_s(2285);
    };
    function oncia_DropDatabase() {
        var a = this; jl_Object.call(a);
        a.$dbName4 = null;
        a.$ifExists5 = 0;
        a.$composite = 0;
        a.$additionalAction0 = null;
        a.$waitUntilComplete5 = null;
        a.$position167 = null;
        a.$isReadOnly27 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar28 = null;
    }
    function oncia_DropDatabase__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_DropDatabase();
        $java.oncia_DropDatabase__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    $java.oncia_DropDatabase_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_DropDatabase_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_DropDatabase_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropDatabase_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly27 = $x$1;
    };
    $java.oncia_DropDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar28;
    };
    $java.oncia_DropDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar28 = $x$1;
    };
    function oncia_DropDatabase_dbName($this) {
        return $this.$dbName4;
    }
    function oncia_DropDatabase_ifExists($this) {
        return $this.$ifExists5;
    }
    function oncia_DropDatabase_additionalAction($this) {
        return $this.$additionalAction0;
    }
    function oncia_DropDatabase_waitUntilComplete($this) {
        return $this.$waitUntilComplete5;
    }
    $java.oncia_DropDatabase_position = function($this) {
        return $this.$position167;
    };
    function oncia_DropDatabase_name($this) {
        if (!$this.$composite)
            return $rt_s(2217);
        return $rt_s(2222);
    }
    $java.oncia_DropDatabase_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_DropDatabase_productPrefix = function($this) {
        return $rt_s(2286);
    };
    $java.oncia_DropDatabase_productArity = function($this) {
        return 5;
    };
    $java.oncia_DropDatabase_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$dbName4;
            case 1:
                return jl_Boolean_valueOf($this.$ifExists5);
            case 2:
                return jl_Boolean_valueOf($this.$composite);
            case 3:
                return $this.$additionalAction0;
            case 4:
                return $this.$waitUntilComplete5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropDatabase_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropDatabase_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2286))), sr_Statics_anyHash($this.$dbName4)), !$this.$ifExists5 ? 1237 : 1231), !$this.$composite ? 1237 : 1231), sr_Statics_anyHash($this.$additionalAction0)), sr_Statics_anyHash($this.$waitUntilComplete5)), 5);
    };
    $java.oncia_DropDatabase_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropDatabase_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DropDatabase) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists5 != $x$1.$ifExists5)
                            break b;
                        if ($this.$composite != $x$1.$composite)
                            break b;
                        d: {
                            var$2 = $this.$dbName4;
                            var$3 = $x$1.$dbName4;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$additionalAction0;
                            var$3 = $x$1.$additionalAction0;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$waitUntilComplete5;
                        $x$1 = $x$1.$waitUntilComplete5;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropDatabase_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropDatabase_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_DropDatabase__init_ = function($this, $dbName, $ifExists, $composite, $additionalAction, $waitUntilComplete, $position) {
        $this.$dbName4 = $dbName;
        $this.$ifExists5 = $ifExists;
        $this.$composite = $composite;
        $this.$additionalAction0 = $additionalAction;
        $this.$waitUntilComplete5 = $waitUntilComplete;
        $this.$position167 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_DropPropertyUniquenessConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable35 = null;
        a.$label12 = null;
        a.$properties26 = null;
        a.$useGraph21 = null;
        a.$position168 = null;
        a.$entityType9 = null;
        a.$errorMessageOnRequire10 = null;
        a.$errorMessageForAssert10 = null;
        a.$errorMessageForAssertExists10 = null;
        a.$errorMessageOnAssert10 = null;
        a.$errorMessageOnAssertExists10 = null;
    }
    function oncia_DropPropertyUniquenessConstraint__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_DropPropertyUniquenessConstraint();
        $java.oncia_DropPropertyUniquenessConstraint__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncia_DropPropertyUniquenessConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropPropertyUniquenessConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType9 = $x$1;
    };
    $java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire10 = $x$1;
    };
    $java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert10 = $x$1;
    };
    $java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists10 = $x$1;
    };
    $java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert10 = $x$1;
    };
    $java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists10 = $x$1;
    };
    $java.oncia_DropPropertyUniquenessConstraint_position = function($this) {
        return $this.$position168;
    };
    $java.oncia_DropPropertyUniquenessConstraint_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(2287), $this.$position168);
    };
    $java.oncia_DropPropertyUniquenessConstraint_copy = function($this, $variable, $label, $properties, $useGraph, $position) {
        return oncia_DropPropertyUniquenessConstraint__init_($variable, $label, $properties, $useGraph, $position);
    };
    $java.oncia_DropPropertyUniquenessConstraint_productPrefix = function($this) {
        return $rt_s(2288);
    };
    $java.oncia_DropPropertyUniquenessConstraint_productArity = function($this) {
        return 4;
    };
    $java.oncia_DropPropertyUniquenessConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable35;
            case 1:
                return $this.$label12;
            case 2:
                return $this.$properties26;
            case 3:
                return $this.$useGraph21;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropPropertyUniquenessConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropPropertyUniquenessConstraint_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropPropertyUniquenessConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropPropertyUniquenessConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DropPropertyUniquenessConstraint) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable35;
                        var$3 = $x$1.$variable35;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label12;
                        var$3 = $x$1.$label12;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties26;
                        var$3 = $x$1.$properties26;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$useGraph21;
                        $x$1 = $x$1.$useGraph21;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DropPropertyUniquenessConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropPropertyUniquenessConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropPropertyUniquenessConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_DropPropertyUniquenessConstraint_copy($this, $this.$variable35, $this.$label12, $this.$properties26, $useGraph, $this.$position168);
    };
    $java.oncia_DropPropertyUniquenessConstraint__init_ = function($this, $variable, $label, $properties, $useGraph, $position) {
        $this.$variable35 = $variable;
        $this.$label12 = $label;
        $this.$properties26 = $properties;
        $this.$useGraph21 = $useGraph;
        $this.$position168 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_NodeCompositePropertyConstraintCommand_$init$($this);
    };
    var oncia_DropPropertyUniquenessConstraint$ = $rt_classWithoutFields();
    $java.oncia_DropPropertyUniquenessConstraint$_MODULE$ = null;
    function oncia_DropPropertyUniquenessConstraint$__clinit_() {
        $java.oncia_DropPropertyUniquenessConstraint$_MODULE$ = new oncia_DropPropertyUniquenessConstraint$;
    }
    function oncia_DropNodeKeyConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable36 = null;
        a.$label13 = null;
        a.$properties27 = null;
        a.$useGraph22 = null;
        a.$position169 = null;
        a.$entityType10 = null;
        a.$errorMessageOnRequire11 = null;
        a.$errorMessageForAssert11 = null;
        a.$errorMessageForAssertExists11 = null;
        a.$errorMessageOnAssert11 = null;
        a.$errorMessageOnAssertExists11 = null;
    }
    function oncia_DropNodeKeyConstraint__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_DropNodeKeyConstraint();
        $java.oncia_DropNodeKeyConstraint__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncia_DropNodeKeyConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropNodeKeyConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType10 = $x$1;
    };
    $java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire11 = $x$1;
    };
    $java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert11 = $x$1;
    };
    $java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists11 = $x$1;
    };
    $java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert11 = $x$1;
    };
    $java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists11 = $x$1;
    };
    $java.oncia_DropNodeKeyConstraint_position = function($this) {
        return $this.$position169;
    };
    $java.oncia_DropNodeKeyConstraint_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(2289), $this.$position169);
    };
    $java.oncia_DropNodeKeyConstraint_copy = function($this, $variable, $label, $properties, $useGraph, $position) {
        return oncia_DropNodeKeyConstraint__init_($variable, $label, $properties, $useGraph, $position);
    };
    $java.oncia_DropNodeKeyConstraint_productPrefix = function($this) {
        return $rt_s(2290);
    };
    $java.oncia_DropNodeKeyConstraint_productArity = function($this) {
        return 4;
    };
    $java.oncia_DropNodeKeyConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable36;
            case 1:
                return $this.$label13;
            case 2:
                return $this.$properties27;
            case 3:
                return $this.$useGraph22;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropNodeKeyConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropNodeKeyConstraint_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropNodeKeyConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropNodeKeyConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DropNodeKeyConstraint) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable36;
                        var$3 = $x$1.$variable36;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label13;
                        var$3 = $x$1.$label13;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties27;
                        var$3 = $x$1.$properties27;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$useGraph22;
                        $x$1 = $x$1.$useGraph22;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DropNodeKeyConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropNodeKeyConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropNodeKeyConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_DropNodeKeyConstraint_copy($this, $this.$variable36, $this.$label13, $this.$properties27, $useGraph, $this.$position169);
    };
    $java.oncia_DropNodeKeyConstraint__init_ = function($this, $variable, $label, $properties, $useGraph, $position) {
        $this.$variable36 = $variable;
        $this.$label13 = $label;
        $this.$properties27 = $properties;
        $this.$useGraph22 = $useGraph;
        $this.$position169 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_NodeCompositePropertyConstraintCommand_$init$($this);
    };
    var oncia_DropNodeKeyConstraint$ = $rt_classWithoutFields();
    $java.oncia_DropNodeKeyConstraint$_MODULE$ = null;
    function oncia_DropNodeKeyConstraint$__clinit_() {
        $java.oncia_DropNodeKeyConstraint$_MODULE$ = new oncia_DropNodeKeyConstraint$;
    }
    function oncia_DropNodePropertyExistenceConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable37 = null;
        a.$label14 = null;
        a.$property5 = null;
        a.$useGraph23 = null;
        a.$position170 = null;
        a.$entityType11 = null;
        a.$errorMessageOnRequire12 = null;
        a.$errorMessageForAssert12 = null;
        a.$errorMessageForAssertExists12 = null;
        a.$errorMessageOnAssert12 = null;
        a.$errorMessageOnAssertExists12 = null;
    }
    function oncia_DropNodePropertyExistenceConstraint__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_DropNodePropertyExistenceConstraint();
        $java.oncia_DropNodePropertyExistenceConstraint__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncia_DropNodePropertyExistenceConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType11 = $x$1;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire12 = $x$1;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert12 = $x$1;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists12 = $x$1;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert12 = $x$1;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists12 = $x$1;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_position = function($this) {
        return $this.$position170;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(2291), $this.$position170);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_copy = function($this, $variable, $label, $property, $useGraph, $position) {
        return oncia_DropNodePropertyExistenceConstraint__init_($variable, $label, $property, $useGraph, $position);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_productPrefix = function($this) {
        return $rt_s(2292);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_productArity = function($this) {
        return 4;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable37;
            case 1:
                return $this.$label14;
            case 2:
                return $this.$property5;
            case 3:
                return $this.$useGraph23;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DropNodePropertyExistenceConstraint) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable37;
                        var$3 = $x$1.$variable37;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$label14;
                        var$3 = $x$1.$label14;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$property5;
                        var$3 = $x$1.$property5;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$useGraph23;
                        $x$1 = $x$1.$useGraph23;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DropNodePropertyExistenceConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropNodePropertyExistenceConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropNodePropertyExistenceConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_DropNodePropertyExistenceConstraint_copy($this, $this.$variable37, $this.$label14, $this.$property5, $useGraph, $this.$position170);
    };
    $java.oncia_DropNodePropertyExistenceConstraint__init_ = function($this, $variable, $label, $property, $useGraph, $position) {
        $this.$variable37 = $variable;
        $this.$label14 = $label;
        $this.$property5 = $property;
        $this.$useGraph23 = $useGraph;
        $this.$position170 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_NodePropertyConstraintCommand_$init$($this);
    };
    var oncia_DropNodePropertyExistenceConstraint$ = $rt_classWithoutFields();
    $java.oncia_DropNodePropertyExistenceConstraint$_MODULE$ = null;
    function oncia_DropNodePropertyExistenceConstraint$__clinit_() {
        $java.oncia_DropNodePropertyExistenceConstraint$_MODULE$ = new oncia_DropNodePropertyExistenceConstraint$;
    }
    function oncia_DropRelationshipPropertyExistenceConstraint() {
        var a = this; jl_Object.call(a);
        a.$variable38 = null;
        a.$relType10 = null;
        a.$property6 = null;
        a.$useGraph24 = null;
        a.$position171 = null;
        a.$entityType12 = null;
        a.$errorMessageOnRequire13 = null;
        a.$errorMessageForAssert13 = null;
        a.$errorMessageForAssertExists13 = null;
        a.$errorMessageOnAssert13 = null;
        a.$errorMessageOnAssertExists13 = null;
    }
    function oncia_DropRelationshipPropertyExistenceConstraint__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncia_DropRelationshipPropertyExistenceConstraint();
        $java.oncia_DropRelationshipPropertyExistenceConstraint__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncia_DropRelationshipPropertyExistenceConstraint_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq = function($this, $x$1) {
        $this.$entityType12 = $x$1;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire13 = $x$1;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert13 = $x$1;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists13 = $x$1;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert13 = $x$1;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists13 = $x$1;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_position = function($this) {
        return $this.$position171;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(2293), $this.$position171);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_copy = function($this, $variable, $relType, $property, $useGraph, $position) {
        return oncia_DropRelationshipPropertyExistenceConstraint__init_($variable, $relType, $property, $useGraph, $position);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_productPrefix = function($this) {
        return $rt_s(2294);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_productArity = function($this) {
        return 4;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable38;
            case 1:
                return $this.$relType10;
            case 2:
                return $this.$property6;
            case 3:
                return $this.$useGraph24;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DropRelationshipPropertyExistenceConstraint) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable38;
                        var$3 = $x$1.$variable38;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relType10;
                        var$3 = $x$1.$relType10;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$property6;
                        var$3 = $x$1.$property6;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$useGraph24;
                        $x$1 = $x$1.$useGraph24;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DropRelationshipPropertyExistenceConstraint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint_withGraph = function($this, $useGraph) {
        return $java.oncia_DropRelationshipPropertyExistenceConstraint_copy($this, $this.$variable38, $this.$relType10, $this.$property6, $useGraph, $this.$position171);
    };
    $java.oncia_DropRelationshipPropertyExistenceConstraint__init_ = function($this, $variable, $relType, $property, $useGraph, $position) {
        $this.$variable38 = $variable;
        $this.$relType10 = $relType;
        $this.$property6 = $property;
        $this.$useGraph24 = $useGraph;
        $this.$position171 = $position;
        $java.oncia_SchemaCommand_$init$($this);
        $java.oncia_RelationshipPropertyConstraintCommand_$init$($this);
    };
    var oncia_DropRelationshipPropertyExistenceConstraint$ = $rt_classWithoutFields();
    $java.oncia_DropRelationshipPropertyExistenceConstraint$_MODULE$ = null;
    function oncia_DropRelationshipPropertyExistenceConstraint$__clinit_() {
        $java.oncia_DropRelationshipPropertyExistenceConstraint$_MODULE$ = new oncia_DropRelationshipPropertyExistenceConstraint$;
    }
    function oncia_DropConstraintOnName() {
        var a = this; jl_Object.call(a);
        a.$name53 = null;
        a.$ifExists6 = 0;
        a.$useGraph25 = null;
        a.$position172 = null;
        a.$errorMessageOnRequire14 = null;
        a.$errorMessageForAssert14 = null;
        a.$errorMessageForAssertExists14 = null;
        a.$errorMessageOnAssert14 = null;
        a.$errorMessageOnAssertExists14 = null;
    }
    function oncia_DropConstraintOnName__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_DropConstraintOnName();
        $java.oncia_DropConstraintOnName__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_DropConstraintOnName_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropConstraintOnName_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire14 = $x$1;
    };
    $java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert14 = $x$1;
    };
    $java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists14 = $x$1;
    };
    $java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert14 = $x$1;
    };
    $java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists14 = $x$1;
    };
    $java.oncia_DropConstraintOnName_position = function($this) {
        return $this.$position172;
    };
    $java.oncia_DropConstraintOnName_semanticCheck = function($this) {
        return $java.oncias_package$_liftSemanticErrorDefs(oncias_package$_MODULE$, sci_Nil$_MODULE$);
    };
    $java.oncia_DropConstraintOnName_copy = function($this, $name, $ifExists, $useGraph, $position) {
        return oncia_DropConstraintOnName__init_($name, $ifExists, $useGraph, $position);
    };
    $java.oncia_DropConstraintOnName_productPrefix = function($this) {
        return $rt_s(2295);
    };
    $java.oncia_DropConstraintOnName_productArity = function($this) {
        return 3;
    };
    $java.oncia_DropConstraintOnName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name53;
            case 1:
                return jl_Boolean_valueOf($this.$ifExists6);
            case 2:
                return $this.$useGraph25;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropConstraintOnName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropConstraintOnName_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2295))), sr_Statics_anyHash($this.$name53)), !$this.$ifExists6 ? 1237 : 1231), sr_Statics_anyHash($this.$useGraph25)), 3);
    };
    $java.oncia_DropConstraintOnName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropConstraintOnName_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DropConstraintOnName) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$ifExists6 != $x$1.$ifExists6)
                        break b;
                    c: {
                        var$2 = $this.$name53;
                        var$3 = $x$1.$name53;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$useGraph25;
                        $x$1 = $x$1.$useGraph25;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DropConstraintOnName))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropConstraintOnName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropConstraintOnName_withGraph = function($this, $useGraph) {
        return $java.oncia_DropConstraintOnName_copy($this, $this.$name53, $this.$ifExists6, $useGraph, $this.$position172);
    };
    $java.oncia_DropConstraintOnName__init_ = function($this, $name, $ifExists, $useGraph, $position) {
        $this.$name53 = $name;
        $this.$ifExists6 = $ifExists;
        $this.$useGraph25 = $useGraph;
        $this.$position172 = $position;
        $java.oncia_SchemaCommand_$init$($this);
    };
    var oncia_DropConstraintOnName$ = $rt_classWithoutFields();
    $java.oncia_DropConstraintOnName$_MODULE$ = null;
    function oncia_DropConstraintOnName$__clinit_() {
        $java.oncia_DropConstraintOnName$_MODULE$ = new oncia_DropConstraintOnName$;
    }
    var onciafn_Neo4jASTFactory$dropIndex$lambda$_156_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$dropIndex$lambda$_156_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncie_PropertyKeyName__init_(var$1.$string0, var$1.$pos);
    };
    function oncia_DropIndex() {
        var a = this; jl_Object.call(a);
        a.$label15 = null;
        a.$properties28 = null;
        a.$useGraph26 = null;
        a.$position173 = null;
        a.$errorMessageOnRequire15 = null;
        a.$errorMessageForAssert15 = null;
        a.$errorMessageForAssertExists15 = null;
        a.$errorMessageOnAssert15 = null;
        a.$errorMessageOnAssertExists15 = null;
    }
    function oncia_DropIndex__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_DropIndex();
        $java.oncia_DropIndex__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_DropIndex_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropIndex_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire15 = $x$1;
    };
    $java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert15 = $x$1;
    };
    $java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists15 = $x$1;
    };
    $java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert15 = $x$1;
    };
    $java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists15 = $x$1;
    };
    $java.oncia_DropIndex_position = function($this) {
        return $this.$position173;
    };
    $java.oncia_DropIndex_semanticCheck = function($this) {
        return oncias_SemanticAnalysisTooling_error$($this, $rt_s(2296), $this.$position173);
    };
    $java.oncia_DropIndex_copy = function($this, $label, $properties, $useGraph, $position) {
        return oncia_DropIndex__init_($label, $properties, $useGraph, $position);
    };
    $java.oncia_DropIndex_productPrefix = function($this) {
        return $rt_s(2297);
    };
    $java.oncia_DropIndex_productArity = function($this) {
        return 3;
    };
    $java.oncia_DropIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$label15;
            case 1:
                return $this.$properties28;
            case 2:
                return $this.$useGraph26;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DropIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$label15;
                        var$3 = $x$1.$label15;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelName_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$properties28;
                        var$3 = $x$1.$properties28;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$useGraph26;
                        $x$1 = $x$1.$useGraph26;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DropIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropIndex_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropIndex_withGraph = function($this, $useGraph) {
        return $java.oncia_DropIndex_copy($this, $this.$label15, $this.$properties28, $useGraph, $this.$position173);
    };
    $java.oncia_DropIndex__init_ = function($this, $label, $properties, $useGraph, $position) {
        $this.$label15 = $label;
        $this.$properties28 = $properties;
        $this.$useGraph26 = $useGraph;
        $this.$position173 = $position;
        $java.oncia_SchemaCommand_$init$($this);
    };
    var oncia_DropIndex$ = $rt_classWithoutFields();
    $java.oncia_DropIndex$_MODULE$ = null;
    function oncia_DropIndex$__clinit_() {
        $java.oncia_DropIndex$_MODULE$ = new oncia_DropIndex$;
    }
    function oncia_DropIndexOnName() {
        var a = this; jl_Object.call(a);
        a.$name54 = null;
        a.$ifExists7 = 0;
        a.$useGraph27 = null;
        a.$position174 = null;
        a.$errorMessageOnRequire16 = null;
        a.$errorMessageForAssert16 = null;
        a.$errorMessageForAssertExists16 = null;
        a.$errorMessageOnAssert16 = null;
        a.$errorMessageOnAssertExists16 = null;
    }
    function oncia_DropIndexOnName__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_DropIndexOnName();
        $java.oncia_DropIndexOnName__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_DropIndexOnName_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropIndexOnName_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq = function($this, $x$1) {
        $this.$errorMessageOnRequire16 = $x$1;
    };
    $java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq = function($this, $x$1) {
        $this.$errorMessageForAssert16 = $x$1;
    };
    $java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageForAssertExists16 = $x$1;
    };
    $java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssert16 = $x$1;
    };
    $java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq = function($this, $x$1) {
        $this.$errorMessageOnAssertExists16 = $x$1;
    };
    $java.oncia_DropIndexOnName_position = function($this) {
        return $this.$position174;
    };
    $java.oncia_DropIndexOnName_semanticCheck = function($this) {
        return $java.oncias_package$_liftSemanticErrorDefs(oncias_package$_MODULE$, sci_Nil$_MODULE$);
    };
    $java.oncia_DropIndexOnName_copy = function($this, $name, $ifExists, $useGraph, $position) {
        return oncia_DropIndexOnName__init_($name, $ifExists, $useGraph, $position);
    };
    $java.oncia_DropIndexOnName_productPrefix = function($this) {
        return $rt_s(2298);
    };
    $java.oncia_DropIndexOnName_productArity = function($this) {
        return 3;
    };
    $java.oncia_DropIndexOnName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name54;
            case 1:
                return jl_Boolean_valueOf($this.$ifExists7);
            case 2:
                return $this.$useGraph27;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropIndexOnName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropIndexOnName_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2298))), sr_Statics_anyHash($this.$name54)), !$this.$ifExists7 ? 1237 : 1231), sr_Statics_anyHash($this.$useGraph27)), 3);
    };
    $java.oncia_DropIndexOnName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropIndexOnName_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DropIndexOnName) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$ifExists7 != $x$1.$ifExists7)
                        break b;
                    c: {
                        var$2 = $this.$name54;
                        var$3 = $x$1.$name54;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$useGraph27;
                        $x$1 = $x$1.$useGraph27;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DropIndexOnName))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_DropIndexOnName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropIndexOnName_withGraph = function($this, $useGraph) {
        return $java.oncia_DropIndexOnName_copy($this, $this.$name54, $this.$ifExists7, $useGraph, $this.$position174);
    };
    $java.oncia_DropIndexOnName__init_ = function($this, $name, $ifExists, $useGraph, $position) {
        $this.$name54 = $name;
        $this.$ifExists7 = $ifExists;
        $this.$useGraph27 = $useGraph;
        $this.$position174 = $position;
        $java.oncia_SchemaCommand_$init$($this);
    };
    var oncia_DropIndexOnName$ = $rt_classWithoutFields();
    $java.oncia_DropIndexOnName$_MODULE$ = null;
    function oncia_DropIndexOnName$__clinit_() {
        $java.oncia_DropIndexOnName$_MODULE$ = new oncia_DropIndexOnName$;
    }
    function oncia_DropRole() {
        var a = this; jl_Object.call(a);
        a.$roleName1 = null;
        a.$ifExists8 = 0;
        a.$position175 = null;
        a.$isReadOnly28 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar29 = null;
    }
    function oncia_DropRole__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_DropRole();
        $java.oncia_DropRole__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_DropRole_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_DropRole_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_DropRole_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropRole_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropRole_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly28 = $x$1;
    };
    $java.oncia_DropRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar29;
    };
    $java.oncia_DropRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar29 = $x$1;
    };
    function oncia_DropRole_roleName($this) {
        return $this.$roleName1;
    }
    function oncia_DropRole_ifExists($this) {
        return $this.$ifExists8;
    }
    $java.oncia_DropRole_position = function($this) {
        return $this.$position175;
    };
    function oncia_DropRole_name($this) {
        return $rt_s(2206);
    }
    $java.oncia_DropRole_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_DropRole_productPrefix = function($this) {
        return $rt_s(2299);
    };
    $java.oncia_DropRole_productArity = function($this) {
        return 2;
    };
    $java.oncia_DropRole_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$roleName1;
            case 1:
                return jl_Boolean_valueOf($this.$ifExists8);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropRole_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropRole_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2299))), sr_Statics_anyHash($this.$roleName1)), !$this.$ifExists8 ? 1237 : 1231), 2);
    };
    $java.oncia_DropRole_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropRole_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DropRole) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists8 != $x$1.$ifExists8)
                            break b;
                        var$2 = $this.$roleName1;
                        $x$1 = $x$1.$roleName1;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_DropRole_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropRole_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_DropRole__init_ = function($this, $roleName, $ifExists, $position) {
        $this.$roleName1 = $roleName;
        $this.$ifExists8 = $ifExists;
        $this.$position175 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_DropServer() {
        var a = this; jl_Object.call(a);
        a.$serverName2 = null;
        a.$position176 = null;
        a.$isReadOnly29 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar30 = null;
    }
    function oncia_DropServer__init_(var_0, var_1) {
        var var_2 = new oncia_DropServer();
        $java.oncia_DropServer__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_DropServer_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_DropServer_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_DropServer_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropServer_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly29 = $x$1;
    };
    $java.oncia_DropServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar30;
    };
    $java.oncia_DropServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar30 = $x$1;
    };
    function oncia_DropServer_serverName($this) {
        return $this.$serverName2;
    }
    $java.oncia_DropServer_position = function($this) {
        return $this.$position176;
    };
    function oncia_DropServer_name($this) {
        return $rt_s(2300);
    }
    $java.oncia_DropServer_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_DropServer_productPrefix = function($this) {
        return $rt_s(2301);
    };
    $java.oncia_DropServer_productArity = function($this) {
        return 1;
    };
    $java.oncia_DropServer_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$serverName2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropServer_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropServer_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropServer_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropServer_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DropServer) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$serverName2;
                        $x$1 = $x$1.$serverName2;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_DropServer_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropServer_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_DropServer__init_ = function($this, $serverName, $position) {
        $this.$serverName2 = $serverName;
        $this.$position176 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_DropUser() {
        var a = this; jl_Object.call(a);
        a.$userName2 = null;
        a.$ifExists9 = 0;
        a.$position177 = null;
        a.$isReadOnly30 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar31 = null;
    }
    function oncia_DropUser__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_DropUser();
        $java.oncia_DropUser__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_DropUser_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_DropUser_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_DropUser_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_DropUser_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_DropUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly30 = $x$1;
    };
    $java.oncia_DropUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar31;
    };
    $java.oncia_DropUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar31 = $x$1;
    };
    function oncia_DropUser_userName($this) {
        return $this.$userName2;
    }
    function oncia_DropUser_ifExists($this) {
        return $this.$ifExists9;
    }
    $java.oncia_DropUser_position = function($this) {
        return $this.$position177;
    };
    function oncia_DropUser_name($this) {
        return $rt_s(2189);
    }
    $java.oncia_DropUser_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_DropUser_productPrefix = function($this) {
        return $rt_s(2302);
    };
    $java.oncia_DropUser_productArity = function($this) {
        return 2;
    };
    $java.oncia_DropUser_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$userName2;
            case 1:
                return jl_Boolean_valueOf($this.$ifExists9);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DropUser_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropUser_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2302))), sr_Statics_anyHash($this.$userName2)), !$this.$ifExists9 ? 1237 : 1231), 2);
    };
    $java.oncia_DropUser_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DropUser_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DropUser) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists9 != $x$1.$ifExists9)
                            break b;
                        var$2 = $this.$userName2;
                        $x$1 = $x$1.$userName2;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_DropUser_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_DropUser_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_DropUser__init_ = function($this, $userName, $ifExists, $position) {
        $this.$userName2 = $userName;
        $this.$ifExists9 = $ifExists;
        $this.$position177 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_GrantPrivilege() {
        var a = this; $java.oncia_PrivilegeCommand.call(a);
        a.$privilege3 = null;
        a.$immutable1 = 0;
        a.$resource3 = null;
        a.$qualifier3 = null;
        a.$roleNames1 = null;
        a.$position178 = null;
    }
    function oncia_GrantPrivilege__init_(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_GrantPrivilege();
        $java.oncia_GrantPrivilege__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    }
    function oncia_GrantPrivilege_privilege($this) {
        return $this.$privilege3;
    }
    function oncia_GrantPrivilege_resource($this) {
        return $this.$resource3;
    }
    function oncia_GrantPrivilege_qualifier($this) {
        return $this.$qualifier3;
    }
    function oncia_GrantPrivilege_roleNames($this) {
        return $this.$roleNames1;
    }
    $java.oncia_GrantPrivilege_position = function($this) {
        return $this.$position178;
    };
    function oncia_GrantPrivilege_name($this) {
        var var$1, var$2, var$3;
        var$1 = $java.oncia_PrivilegeCommand_immutableKeywordOrEmptyString($this, $this.$immutable1);
        var$2 = $this.$privilege3.$name46;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$1 = jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(552)), var$1);
        jl_AbstractStringBuilder_append(var$1, 32);
        jl_StringBuilder_append(var$1, var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    }
    $java.oncia_GrantPrivilege_productPrefix = function($this) {
        return $rt_s(2303);
    };
    $java.oncia_GrantPrivilege_productArity = function($this) {
        return 5;
    };
    $java.oncia_GrantPrivilege_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$privilege3;
            case 1:
                return jl_Boolean_valueOf($this.$immutable1);
            case 2:
                return $this.$resource3;
            case 3:
                return $this.$qualifier3;
            case 4:
                return $this.$roleNames1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_GrantPrivilege_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GrantPrivilege_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2303))), sr_Statics_anyHash($this.$privilege3)), !$this.$immutable1 ? 1237 : 1231), sr_Statics_anyHash($this.$resource3)), sr_Statics_anyHash($this.$qualifier3)), sr_Statics_anyHash($this.$roleNames1)), 5);
    };
    $java.oncia_GrantPrivilege_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GrantPrivilege_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_GrantPrivilege) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$immutable1 != $x$1.$immutable1)
                            break b;
                        d: {
                            var$2 = $this.$privilege3;
                            var$3 = $x$1.$privilege3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$resource3;
                            var$3 = $x$1.$resource3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$qualifier3;
                            var$3 = $x$1.$qualifier3;
                            if (var$2 !== null) {
                                if (!sci_List_equals(var$2, var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$roleNames1;
                        $x$1 = $x$1.$roleNames1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_GrantPrivilege__init_ = function($this, $privilege, $immutable, $resource, $qualifier, $roleNames, $position) {
        $this.$privilege3 = $privilege;
        $this.$immutable1 = $immutable;
        $this.$resource3 = $resource;
        $this.$qualifier3 = $qualifier;
        $this.$roleNames1 = $roleNames;
        $this.$position178 = $position;
        $java.oncia_PrivilegeCommand__init_($this, $privilege, $qualifier, $position);
    };
    var onciafn_Neo4jASTFactory$grantPrivilege$lambda$_177_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$grantPrivilege$lambda$_177_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_GrantRolesToUsers() {
        var a = this; jl_Object.call(a);
        a.$roleNames2 = null;
        a.$userNames0 = null;
        a.$position179 = null;
        a.$isReadOnly31 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar32 = null;
    }
    function oncia_GrantRolesToUsers__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_GrantRolesToUsers();
        $java.oncia_GrantRolesToUsers__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_GrantRolesToUsers_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_GrantRolesToUsers_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_GrantRolesToUsers_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_GrantRolesToUsers_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_GrantRolesToUsers_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly31 = $x$1;
    };
    $java.oncia_GrantRolesToUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar32;
    };
    $java.oncia_GrantRolesToUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar32 = $x$1;
    };
    function oncia_GrantRolesToUsers_roleNames($this) {
        return $this.$roleNames2;
    }
    function oncia_GrantRolesToUsers_userNames($this) {
        return $this.$userNames0;
    }
    $java.oncia_GrantRolesToUsers_position = function($this) {
        return $this.$position179;
    };
    function oncia_GrantRolesToUsers_name($this) {
        return $rt_s(2304);
    }
    $java.oncia_GrantRolesToUsers_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_GrantRolesToUsers_productPrefix = function($this) {
        return $rt_s(2305);
    };
    $java.oncia_GrantRolesToUsers_productArity = function($this) {
        return 2;
    };
    $java.oncia_GrantRolesToUsers_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$roleNames2;
            case 1:
                return $this.$userNames0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_GrantRolesToUsers_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GrantRolesToUsers_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GrantRolesToUsers_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GrantRolesToUsers_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_GrantRolesToUsers) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$roleNames2;
                            var$3 = $x$1.$roleNames2;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$userNames0;
                        $x$1 = $x$1.$userNames0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_GrantRolesToUsers_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_GrantRolesToUsers_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_GrantRolesToUsers__init_ = function($this, $roleNames, $userNames, $position) {
        $this.$roleNames2 = $roleNames;
        $this.$userNames0 = $userNames;
        $this.$position179 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    var onciafn_Neo4jASTFactory$grantRoles$lambda$_161_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$grantRoles$lambda$_161_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    var onciafn_Neo4jASTFactory$grantRoles$lambda$_161_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$grantRoles$lambda$_161_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_RenameRole() {
        var a = this; jl_Object.call(a);
        a.$fromRoleName0 = null;
        a.$toRoleName0 = null;
        a.$ifExists10 = 0;
        a.$position180 = null;
        a.$isReadOnly32 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar33 = null;
    }
    function oncia_RenameRole__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_RenameRole();
        $java.oncia_RenameRole__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_RenameRole_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_RenameRole_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_RenameRole_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_RenameRole_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_RenameRole_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly32 = $x$1;
    };
    $java.oncia_RenameRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar33;
    };
    $java.oncia_RenameRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar33 = $x$1;
    };
    function oncia_RenameRole_fromRoleName($this) {
        return $this.$fromRoleName0;
    }
    function oncia_RenameRole_toRoleName($this) {
        return $this.$toRoleName0;
    }
    function oncia_RenameRole_ifExists($this) {
        return $this.$ifExists10;
    }
    $java.oncia_RenameRole_position = function($this) {
        return $this.$position180;
    };
    function oncia_RenameRole_name($this) {
        return $rt_s(2208);
    }
    $java.oncia_RenameRole_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_RenameRole_productPrefix = function($this) {
        return $rt_s(2306);
    };
    $java.oncia_RenameRole_productArity = function($this) {
        return 3;
    };
    $java.oncia_RenameRole_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$fromRoleName0;
            case 1:
                return $this.$toRoleName0;
            case 2:
                return jl_Boolean_valueOf($this.$ifExists10);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RenameRole_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameRole_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2306))), sr_Statics_anyHash($this.$fromRoleName0)), sr_Statics_anyHash($this.$toRoleName0)), !$this.$ifExists10 ? 1237 : 1231), 3);
    };
    $java.oncia_RenameRole_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameRole_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_RenameRole) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists10 != $x$1.$ifExists10)
                            break b;
                        d: {
                            var$2 = $this.$fromRoleName0;
                            var$3 = $x$1.$fromRoleName0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$toRoleName0;
                        $x$1 = $x$1.$toRoleName0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_RenameRole_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_RenameRole_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_RenameRole__init_ = function($this, $fromRoleName, $toRoleName, $ifExists, $position) {
        $this.$fromRoleName0 = $fromRoleName;
        $this.$toRoleName0 = $toRoleName;
        $this.$ifExists10 = $ifExists;
        $this.$position180 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_RenameServer() {
        var a = this; jl_Object.call(a);
        a.$serverName3 = null;
        a.$newName0 = null;
        a.$position181 = null;
        a.$isReadOnly33 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar34 = null;
    }
    function oncia_RenameServer__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_RenameServer();
        $java.oncia_RenameServer__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_RenameServer_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_RenameServer_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_RenameServer_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_RenameServer_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_RenameServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly33 = $x$1;
    };
    $java.oncia_RenameServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar34;
    };
    $java.oncia_RenameServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar34 = $x$1;
    };
    function oncia_RenameServer_serverName($this) {
        return $this.$serverName3;
    }
    function oncia_RenameServer_newName($this) {
        return $this.$newName0;
    }
    $java.oncia_RenameServer_position = function($this) {
        return $this.$position181;
    };
    function oncia_RenameServer_name($this) {
        return $rt_s(2307);
    }
    $java.oncia_RenameServer_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_RenameServer_productPrefix = function($this) {
        return $rt_s(2308);
    };
    $java.oncia_RenameServer_productArity = function($this) {
        return 2;
    };
    $java.oncia_RenameServer_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$serverName3;
            case 1:
                return $this.$newName0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RenameServer_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameServer_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameServer_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameServer_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_RenameServer) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$serverName3;
                            var$3 = $x$1.$serverName3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$newName0;
                        $x$1 = $x$1.$newName0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_RenameServer_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_RenameServer_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_RenameServer__init_ = function($this, $serverName, $newName, $position) {
        $this.$serverName3 = $serverName;
        $this.$newName0 = $newName;
        $this.$position181 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_RenameUser() {
        var a = this; jl_Object.call(a);
        a.$fromUserName0 = null;
        a.$toUserName0 = null;
        a.$ifExists11 = 0;
        a.$position182 = null;
        a.$isReadOnly34 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar35 = null;
    }
    function oncia_RenameUser__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_RenameUser();
        $java.oncia_RenameUser__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncia_RenameUser_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_RenameUser_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_RenameUser_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_RenameUser_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_RenameUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly34 = $x$1;
    };
    $java.oncia_RenameUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar35;
    };
    $java.oncia_RenameUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar35 = $x$1;
    };
    function oncia_RenameUser_fromUserName($this) {
        return $this.$fromUserName0;
    }
    function oncia_RenameUser_toUserName($this) {
        return $this.$toUserName0;
    }
    function oncia_RenameUser_ifExists($this) {
        return $this.$ifExists11;
    }
    $java.oncia_RenameUser_position = function($this) {
        return $this.$position182;
    };
    function oncia_RenameUser_name($this) {
        return $rt_s(2191);
    }
    $java.oncia_RenameUser_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_RenameUser_productPrefix = function($this) {
        return $rt_s(2309);
    };
    $java.oncia_RenameUser_productArity = function($this) {
        return 3;
    };
    $java.oncia_RenameUser_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$fromUserName0;
            case 1:
                return $this.$toUserName0;
            case 2:
                return jl_Boolean_valueOf($this.$ifExists11);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RenameUser_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameUser_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2309))), sr_Statics_anyHash($this.$fromUserName0)), sr_Statics_anyHash($this.$toUserName0)), !$this.$ifExists11 ? 1237 : 1231), 3);
    };
    $java.oncia_RenameUser_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RenameUser_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_RenameUser) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$ifExists11 != $x$1.$ifExists11)
                            break b;
                        d: {
                            var$2 = $this.$fromUserName0;
                            var$3 = $x$1.$fromUserName0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$toUserName0;
                        $x$1 = $x$1.$toUserName0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_RenameUser_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_RenameUser_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_RenameUser__init_ = function($this, $fromUserName, $toUserName, $ifExists, $position) {
        $this.$fromUserName0 = $fromUserName;
        $this.$toUserName0 = $toUserName;
        $this.$ifExists11 = $ifExists;
        $this.$position182 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    function oncia_RevokePrivilege() {
        var a = this; $java.oncia_PrivilegeCommand.call(a);
        a.$privilege4 = null;
        a.$immutableOnly = 0;
        a.$resource4 = null;
        a.$qualifier4 = null;
        a.$roleNames3 = null;
        a.$revokeType = null;
        a.$position183 = null;
    }
    $java.oncia_RevokePrivilege__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncia_RevokePrivilege();
        oncia_RevokePrivilege__init_(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    };
    function oncia_RevokePrivilege_privilege($this) {
        return $this.$privilege4;
    }
    function oncia_RevokePrivilege_resource($this) {
        return $this.$resource4;
    }
    function oncia_RevokePrivilege_qualifier($this) {
        return $this.$qualifier4;
    }
    function oncia_RevokePrivilege_roleNames($this) {
        return $this.$roleNames3;
    }
    $java.oncia_RevokePrivilege_position = function($this) {
        return $this.$position183;
    };
    function oncia_RevokePrivilege_name($this) {
        var $revokeTypeOrEmptyString, var$2, var$3, var$4;
        $revokeTypeOrEmptyString = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        if (!sc_StringOps$_nonEmpty$extension($revokeTypeOrEmptyString, $this.$revokeType.$name55))
            $revokeTypeOrEmptyString = $rt_s(3);
        else {
            var$2 = $this.$revokeType.$name55;
            $revokeTypeOrEmptyString = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($revokeTypeOrEmptyString);
            jl_AbstractStringBuilder_append($revokeTypeOrEmptyString, 32);
            jl_StringBuilder_append($revokeTypeOrEmptyString, var$2);
            $revokeTypeOrEmptyString = jl_AbstractStringBuilder_toString($revokeTypeOrEmptyString);
        }
        var$2 = $java.oncia_PrivilegeCommand_immutableKeywordOrEmptyString($this, $this.$immutableOnly);
        var$3 = $this.$privilege4.$name46;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        $revokeTypeOrEmptyString = jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(2310)), $revokeTypeOrEmptyString), var$2);
        jl_AbstractStringBuilder_append($revokeTypeOrEmptyString, 32);
        jl_StringBuilder_append($revokeTypeOrEmptyString, var$3);
        return jl_AbstractStringBuilder_toString(var$4);
    }
    $java.oncia_RevokePrivilege_semanticCheck = function($this) {
        var var$1, var$2, var$3;
        var$1 = s_Tuple2__init_($this.$privilege4, $this.$revokeType);
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        if (var$2 instanceof oncia_GraphPrivilege) {
            var$3 = var$2.$action0;
            if (jl_Object_equals(oncia_MergeAdminAction$_MODULE$, var$3) && var$1 instanceof oncia_RevokeDenyType)
                return oncias_SemanticAnalysisTooling_error$($this, $rt_s(1843), $this.$position183);
        }
        return $java.oncia_PrivilegeCommand_semanticCheck($this);
    };
    $java.oncia_RevokePrivilege_productPrefix = function($this) {
        return $rt_s(2311);
    };
    $java.oncia_RevokePrivilege_productArity = function($this) {
        return 6;
    };
    $java.oncia_RevokePrivilege_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$privilege4;
            case 1:
                return jl_Boolean_valueOf($this.$immutableOnly);
            case 2:
                return $this.$resource4;
            case 3:
                return $this.$qualifier4;
            case 4:
                return $this.$roleNames3;
            case 5:
                return $this.$revokeType;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RevokePrivilege_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokePrivilege_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2311))), sr_Statics_anyHash($this.$privilege4)), !$this.$immutableOnly ? 1237 : 1231), sr_Statics_anyHash($this.$resource4)), sr_Statics_anyHash($this.$qualifier4)), sr_Statics_anyHash($this.$roleNames3)), sr_Statics_anyHash($this.$revokeType)), 6);
    };
    $java.oncia_RevokePrivilege_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokePrivilege_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_RevokePrivilege) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$immutableOnly != $x$1.$immutableOnly)
                            break b;
                        d: {
                            var$2 = $this.$privilege4;
                            var$3 = $x$1.$privilege4;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$resource4;
                            var$3 = $x$1.$resource4;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$qualifier4;
                            var$3 = $x$1.$qualifier4;
                            if (var$2 !== null) {
                                if (!sci_List_equals(var$2, var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        g: {
                            var$2 = $this.$roleNames3;
                            var$3 = $x$1.$roleNames3;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break g;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$revokeType;
                        $x$1 = $x$1.$revokeType;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncia_RevokePrivilege__init_($this, $privilege, $immutableOnly, $resource, $qualifier, $roleNames, $revokeType, $position) {
        $this.$privilege4 = $privilege;
        $this.$immutableOnly = $immutableOnly;
        $this.$resource4 = $resource;
        $this.$qualifier4 = $qualifier;
        $this.$roleNames3 = $roleNames;
        $this.$revokeType = $revokeType;
        $this.$position183 = $position;
        $java.oncia_PrivilegeCommand__init_($this, $privilege, $qualifier, $position);
    }
    var onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_RevokeType() {
        var a = this; jl_Object.call(a);
        a.$name55 = null;
        a.$relType11 = null;
    }
    $java.oncia_RevokeType_name = function($this) {
        return $this.$name55;
    };
    function oncia_RevokeType__init_($this, $name, $relType) {
        $this.$name55 = $name;
        $this.$relType11 = $relType;
    }
    function oncia_RevokeGrantType() {
        oncia_RevokeType.call(this);
        this.$position25 = null;
    }
    $java.oncia_RevokeGrantType_productPrefix = function($this) {
        return $rt_s(2312);
    };
    $java.oncia_RevokeGrantType_productArity = function($this) {
        return 0;
    };
    $java.oncia_RevokeGrantType_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RevokeGrantType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeGrantType_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeGrantType_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeGrantType_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_RevokeGrantType))
            return 0;
        return 1;
    };
    var onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_RevokeDenyType() {
        oncia_RevokeType.call(this);
        this.$position26 = null;
    }
    $java.oncia_RevokeDenyType_productPrefix = function($this) {
        return $rt_s(2313);
    };
    $java.oncia_RevokeDenyType_productArity = function($this) {
        return 0;
    };
    $java.oncia_RevokeDenyType_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RevokeDenyType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeDenyType_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeDenyType_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeDenyType_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_RevokeDenyType))
            return 0;
        return 1;
    };
    var onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_2 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    function oncia_RevokeBothType() {
        oncia_RevokeType.call(this);
        this.$position27 = null;
    }
    $java.oncia_RevokeBothType_productPrefix = function($this) {
        return $rt_s(2314);
    };
    $java.oncia_RevokeBothType_productArity = function($this) {
        return 0;
    };
    $java.oncia_RevokeBothType_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RevokeBothType_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeBothType_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeBothType_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeBothType_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_RevokeBothType))
            return 0;
        return 1;
    };
    function oncia_RevokeRolesFromUsers() {
        var a = this; jl_Object.call(a);
        a.$roleNames4 = null;
        a.$userNames1 = null;
        a.$position184 = null;
        a.$isReadOnly35 = 0;
        a.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar36 = null;
    }
    function oncia_RevokeRolesFromUsers__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_RevokeRolesFromUsers();
        $java.oncia_RevokeRolesFromUsers__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_RevokeRolesFromUsers_requireFeatureSupport = function($this, $msg, $feature, $position) {
        return oncias_SemanticAnalysisTooling_requireFeatureSupport$($this, $msg, $feature, $position);
    };
    $java.oncia_RevokeRolesFromUsers_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_RevokeRolesFromUsers_foldedOver = function($this) {
        return $this;
    };
    $java.oncia_RevokeRolesFromUsers_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncia_RevokeRolesFromUsers_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq = function($this, $x$1) {
        $this.$isReadOnly35 = $x$1;
    };
    $java.oncia_RevokeRolesFromUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar = function($this) {
        return $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar36;
    };
    $java.oncia_RevokeRolesFromUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq = function($this, $x$1) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar36 = $x$1;
    };
    function oncia_RevokeRolesFromUsers_roleNames($this) {
        return $this.$roleNames4;
    }
    function oncia_RevokeRolesFromUsers_userNames($this) {
        return $this.$userNames1;
    }
    $java.oncia_RevokeRolesFromUsers_position = function($this) {
        return $this.$position184;
    };
    function oncia_RevokeRolesFromUsers_name($this) {
        return $rt_s(2315);
    }
    $java.oncia_RevokeRolesFromUsers_semanticCheck = function($this) {
        var var$1;
        var$1 = oncia_AdministrationCommand_semanticCheck$($this);
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $this));
    };
    $java.oncia_RevokeRolesFromUsers_productPrefix = function($this) {
        return $rt_s(2316);
    };
    $java.oncia_RevokeRolesFromUsers_productArity = function($this) {
        return 2;
    };
    $java.oncia_RevokeRolesFromUsers_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$roleNames4;
            case 1:
                return $this.$userNames1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RevokeRolesFromUsers_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeRolesFromUsers_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeRolesFromUsers_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RevokeRolesFromUsers_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_RevokeRolesFromUsers) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$roleNames4;
                            var$3 = $x$1.$roleNames4;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$userNames1;
                        $x$1 = $x$1.$userNames1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_RevokeRolesFromUsers_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_RevokeRolesFromUsers_withGraph = function($this, $useGraph) {
        $this.$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq($useGraph);
        return $this;
    };
    $java.oncia_RevokeRolesFromUsers__init_ = function($this, $roleNames, $userNames, $position) {
        $this.$roleNames4 = $roleNames;
        $this.$userNames1 = $userNames;
        $this.$position184 = $position;
        oncia_AdministrationCommand_$init$($this);
        $java.oncia_WriteAdministrationCommand_$init$($this);
    };
    var onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    var onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_1 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciafn_DecorateTuple$AsScala_asScala(onciafn_TupleConverter$_asScalaEither(onciafn_TupleConverter$_MODULE$, var$1));
    };
    var onciafn_Neo4jASTFactory$yieldClause$lambda$_136_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sc_IterableOnceOps_nonEmpty$(var$1));
    };
    function onciafn_Neo4jASTFactory$yieldClause$lambda$_136_1() {
        jl_Object.call(this);
        this.$_0242 = null;
    }
    $java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_1_apply = function(var$0, var$1) {
        return oncia_OrderBy__init_(var$1, var$0.$_0242);
    };
    function onciafn_Neo4jASTFactory$yieldClause$lambda$_136_2() {
        jl_Object.call(this);
        this.$_0243 = null;
    }
    $java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_2_apply = function(var$0, var$1) {
        return $java.oncia_Skip__init_(var$1, var$0.$_0243);
    };
    function onciafn_Neo4jASTFactory$yieldClause$lambda$_136_3() {
        jl_Object.call(this);
        this.$_0244 = null;
    }
    $java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_3_apply = function(var$0, var$1) {
        return $java.oncia_Limit__init_(var$1, var$0.$_0244);
    };
    var oncia_UsingJoinHint$ = $rt_classWithoutFields();
    $java.oncia_UsingJoinHint$_MODULE$ = null;
    function oncia_UsingJoinHint$__clinit_() {
        $java.oncia_UsingJoinHint$_MODULE$ = new oncia_UsingJoinHint$;
    }
    $java.oncia_Hint = $rt_classWithoutFields(0);
    $java.oncia_UsingHint = $rt_classWithoutFields(0);
    $java.oncia_NodeHint = $rt_classWithoutFields(0);
    function oncia_UsingScanHint() {
        var a = this; jl_Object.call(a);
        a.$variable5 = null;
        a.$labelOrRelType = null;
        a.$position185 = null;
    }
    function oncia_UsingScanHint__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_UsingScanHint();
        $java.oncia_UsingScanHint__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_UsingScanHint_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_UsingScanHint_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_UsingScanHint_position = function($this) {
        return $this.$position185;
    };
    $java.oncia_UsingScanHint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_ensureDefined$($this, $this.$variable5)), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_UsingScanHint$semanticCheck$lambda$_51_0, $this.$variable5));
    };
    $java.oncia_UsingScanHint_productPrefix = function($this) {
        return $rt_s(2317);
    };
    $java.oncia_UsingScanHint_productArity = function($this) {
        return 2;
    };
    $java.oncia_UsingScanHint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable5;
            case 1:
                return $this.$labelOrRelType;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UsingScanHint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingScanHint_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingScanHint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingScanHint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_UsingScanHint) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable5;
                        var$3 = $x$1.$variable5;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$labelOrRelType;
                        $x$1 = $x$1.$labelOrRelType;
                        if (var$3 !== null) {
                            if (!$java.oncie_LabelOrRelTypeName_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_UsingScanHint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_UsingScanHint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_UsingScanHint__init_ = function($this, $variable, $labelOrRelType, $position) {
        $this.$variable5 = $variable;
        $this.$labelOrRelType = $labelOrRelType;
        $this.$position185 = $position;
    };
    function oncie_LabelOrRelTypeName() {
        var a = this; jl_Object.call(a);
        a.$name56 = null;
        a.$position186 = null;
    }
    function oncie_LabelOrRelTypeName__init_(var_0, var_1) {
        var var_2 = new oncie_LabelOrRelTypeName();
        $java.oncie_LabelOrRelTypeName__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_LabelOrRelTypeName_name = function($this) {
        return $this.$name56;
    };
    $java.oncie_LabelOrRelTypeName_position = function($this) {
        return $this.$position186;
    };
    $java.oncie_LabelOrRelTypeName_productPrefix = function($this) {
        return $rt_s(2318);
    };
    $java.oncie_LabelOrRelTypeName_productArity = function($this) {
        return 1;
    };
    $java.oncie_LabelOrRelTypeName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name56;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_LabelOrRelTypeName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LabelOrRelTypeName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LabelOrRelTypeName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LabelOrRelTypeName_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_LabelOrRelTypeName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name56;
                        $x$1 = $x$1.$name56;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_LabelOrRelTypeName))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_LabelOrRelTypeName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_LabelOrRelTypeName__init_ = function($this, $name, $position) {
        $this.$name56 = $name;
        $this.$position186 = $position;
    };
    function oncie_MatchMode$RepeatableElements() {
        jl_Object.call(this);
        this.$position187 = null;
    }
    function oncie_MatchMode$RepeatableElements__init_(var_0) {
        var var_1 = new oncie_MatchMode$RepeatableElements();
        $java.oncie_MatchMode$RepeatableElements__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_MatchMode$RepeatableElements_position = function($this) {
        return $this.$position187;
    };
    $java.oncie_MatchMode$RepeatableElements_prettified = function($this) {
        return $rt_s(2319);
    };
    $java.oncie_MatchMode$RepeatableElements_productPrefix = function($this) {
        return $rt_s(2320);
    };
    $java.oncie_MatchMode$RepeatableElements_productArity = function($this) {
        return 0;
    };
    $java.oncie_MatchMode$RepeatableElements_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_MatchMode$RepeatableElements_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MatchMode$RepeatableElements_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MatchMode$RepeatableElements_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MatchMode$RepeatableElements_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_MatchMode$RepeatableElements) ? 0 : 1;
        return var$2 && $this instanceof oncie_MatchMode$RepeatableElements ? 1 : 0;
    };
    $java.oncie_MatchMode$RepeatableElements_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_MatchMode$RepeatableElements__init_ = function($this, $position) {
        $this.$position187 = $position;
    };
    var oncie_MatchMode$DifferentRelationships$ = $rt_classWithoutFields();
    $java.oncie_MatchMode$DifferentRelationships$_MODULE$ = null;
    function oncie_MatchMode$DifferentRelationships$__clinit_() {
        $java.oncie_MatchMode$DifferentRelationships$_MODULE$ = new oncie_MatchMode$DifferentRelationships$;
    }
    function oncie_NamedPatternPart() {
        var a = this; $java.oncie_PatternPart.call(a);
        a.$variable10 = null;
        a.$patternPart = null;
        a.$position188 = null;
    }
    function oncie_NamedPatternPart__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_NamedPatternPart();
        $java.oncie_NamedPatternPart__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_NamedPatternPart_variable = function($this) {
        return $this.$variable10;
    };
    $java.oncie_NamedPatternPart_position = function($this) {
        return $this.$position188;
    };
    $java.oncie_NamedPatternPart_element = function($this) {
        return $this.$patternPart.$element();
    };
    $java.oncie_NamedPatternPart_allVariables = function($this) {
        return ($this.$patternPart.$allVariables()).$incl($this.$variable10);
    };
    $java.oncie_NamedPatternPart_isBounded = function($this) {
        return $this.$patternPart.$isBounded();
    };
    $java.oncie_NamedPatternPart_productPrefix = function($this) {
        return $rt_s(2321);
    };
    $java.oncie_NamedPatternPart_productArity = function($this) {
        return 2;
    };
    $java.oncie_NamedPatternPart_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable10;
            case 1:
                return $this.$patternPart;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_NamedPatternPart_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NamedPatternPart_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NamedPatternPart_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NamedPatternPart_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_NamedPatternPart) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable10;
                        var$3 = $x$1.$variable10;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$patternPart;
                        $x$1 = $x$1.$patternPart;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_NamedPatternPart))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_NamedPatternPart__init_ = function($this, $variable, $patternPart, $position) {
        $this.$variable10 = $variable;
        $this.$patternPart = $patternPart;
        $this.$position188 = $position;
        $java.oncie_PatternPart__init_($this);
    };
    $java.oncia_RemoveItem = $rt_classWithoutFields(0);
    function oncia_RemovePropertyItem() {
        jl_Object.call(this);
        this.$property7 = null;
    }
    function oncia_RemovePropertyItem__init_(var_0) {
        var var_1 = new oncia_RemovePropertyItem();
        $java.oncia_RemovePropertyItem__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_RemovePropertyItem_position = function($this) {
        return $this.$property7.$position31;
    };
    $java.oncia_RemovePropertyItem_semanticCheck = function($this) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$property7);
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(var$1, $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNames(oncias_SemanticPatternCheck$_MODULE$, sci_$colon$colon__init_($this.$property7.$propertyKey0, sci_Nil$_MODULE$)));
    };
    $java.oncia_RemovePropertyItem_productPrefix = function($this) {
        return $rt_s(2322);
    };
    $java.oncia_RemovePropertyItem_productArity = function($this) {
        return 1;
    };
    $java.oncia_RemovePropertyItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$property7;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RemovePropertyItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemovePropertyItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemovePropertyItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemovePropertyItem_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_RemovePropertyItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$property7;
                        $x$1 = $x$1.$property7;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_RemovePropertyItem))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_RemovePropertyItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_RemovePropertyItem__init_ = function($this, $property) {
        $this.$property7 = $property;
    };
    function oncia_RemoveLabelItem() {
        var a = this; jl_Object.call(a);
        a.$variable39 = null;
        a.$labels1 = null;
        a.$position189 = null;
    }
    function oncia_RemoveLabelItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_RemoveLabelItem();
        $java.oncia_RemoveLabelItem__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_RemoveLabelItem_position = function($this) {
        return $this.$position189;
    };
    $java.oncia_RemoveLabelItem_semanticCheck = function($this) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$variable39);
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$1, $java.oncias_SemanticPatternCheck$_checkValidLabels(oncias_SemanticPatternCheck$_MODULE$, $this.$labels1, $this.$position189)), oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncia_RemoveLabelItem$semanticCheck$lambda$_11_0, $this.$variable39));
    };
    $java.oncia_RemoveLabelItem_productPrefix = function($this) {
        return $rt_s(2323);
    };
    $java.oncia_RemoveLabelItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_RemoveLabelItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable39;
            case 1:
                return $this.$labels1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RemoveLabelItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemoveLabelItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemoveLabelItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RemoveLabelItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_RemoveLabelItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable39;
                        var$3 = $x$1.$variable39;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$labels1;
                        $x$1 = $x$1.$labels1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_RemoveLabelItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_RemoveLabelItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_RemoveLabelItem__init_ = function($this, $variable, $labels, $position) {
        $this.$variable39 = $variable;
        $this.$labels1 = $labels;
        $this.$position189 = $position;
    };
    var onciafn_Neo4jASTFactory$removeLabels$lambda$_25_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$removeLabels$lambda$_25_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncie_LabelName__init_(var$1.$string0, var$1.$pos);
    };
    function onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_0() {
        jl_Object.call(this);
        this.$_0235 = null;
    }
    $java.onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_0_apply = function(var$0, var$1) {
        return $java.oncia_Skip__init_(var$1, var$0.$_0235);
    };
    function onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_1() {
        jl_Object.call(this);
        this.$_0236 = null;
    }
    $java.onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_1_apply = function(var$0, var$1) {
        return $java.oncia_Limit__init_(var$1, var$0.$_0236);
    };
    $java.oncia_SetItem = $rt_classWithoutFields(0);
    $java.oncia_SetProperty = $rt_classWithoutFields(0);
    function oncia_SetPropertyItem() {
        var a = this; jl_Object.call(a);
        a.$property8 = null;
        a.$expression11 = null;
        a.$position190 = null;
    }
    function oncia_SetPropertyItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_SetPropertyItem();
        $java.oncia_SetPropertyItem__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_SetPropertyItem_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_SetPropertyItem_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_SetPropertyItem_position = function($this) {
        return $this.$position190;
    };
    $java.oncia_SetPropertyItem_semanticCheck = function($this) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$property8);
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$1, $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNames(oncias_SemanticPatternCheck$_MODULE$, sci_$colon$colon__init_($this.$property8.$propertyKey0, sci_Nil$_MODULE$))), $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$expression11)), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_SetPropertyItem$semanticCheck$lambda$_50_0, $this.$property8.$map11));
    };
    $java.oncia_SetPropertyItem_productPrefix = function($this) {
        return $rt_s(2324);
    };
    $java.oncia_SetPropertyItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_SetPropertyItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$property8;
            case 1:
                return $this.$expression11;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetPropertyItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetPropertyItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetPropertyItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetPropertyItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_SetPropertyItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$property8;
                        var$3 = $x$1.$property8;
                        if (var$2 !== null) {
                            if (!$java.oncie_Property_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression11;
                        $x$1 = $x$1.$expression11;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_SetPropertyItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_SetPropertyItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SetPropertyItem__init_ = function($this, $property, $expression, $position) {
        $this.$property8 = $property;
        $this.$expression11 = $expression;
        $this.$position190 = $position;
    };
    function oncia_SetExactPropertiesFromMapItem() {
        var a = this; jl_Object.call(a);
        a.$variable = null;
        a.$expression = null;
        a.$position = null;
    }
    function oncia_SetExactPropertiesFromMapItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_SetExactPropertiesFromMapItem();
        $java.oncia_SetExactPropertiesFromMapItem__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_SetExactPropertiesFromMapItem_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_SetExactPropertiesFromMapItem_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_SetExactPropertiesFromMapItem_position = function($this) {
        return $this.$position;
    };
    $java.oncia_SetExactPropertiesFromMapItem_semanticCheck = function($this) {
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$variable), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_0, $this.$variable)), $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$expression)), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_1,
        $this.$expression));
    };
    function oncia_SetExactPropertiesFromMapItem_copy($this, $variable, $expression, $position) {
        return oncia_SetExactPropertiesFromMapItem__init_($variable, $expression, $position);
    }
    $java.oncia_SetExactPropertiesFromMapItem_productPrefix = function($this) {
        return $rt_s(2325);
    };
    $java.oncia_SetExactPropertiesFromMapItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_SetExactPropertiesFromMapItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable;
            case 1:
                return $this.$expression;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetExactPropertiesFromMapItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetExactPropertiesFromMapItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetExactPropertiesFromMapItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetExactPropertiesFromMapItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_SetExactPropertiesFromMapItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable;
                        var$3 = $x$1.$variable;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression;
                        $x$1 = $x$1.$expression;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_SetExactPropertiesFromMapItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_SetExactPropertiesFromMapItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SetExactPropertiesFromMapItem__init_ = function($this, $variable, $expression, $position) {
        $this.$variable = $variable;
        $this.$expression = $expression;
        $this.$position = $position;
    };
    function oncia_SetIncludingPropertiesFromMapItem() {
        var a = this; jl_Object.call(a);
        a.$variable0 = null;
        a.$expression0 = null;
        a.$position1 = null;
    }
    function oncia_SetIncludingPropertiesFromMapItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_SetIncludingPropertiesFromMapItem();
        $java.oncia_SetIncludingPropertiesFromMapItem__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_SetIncludingPropertiesFromMapItem_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_position = function($this) {
        return $this.$position1;
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_semanticCheck = function($this) {
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$variable0), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_0, $this.$variable0)), $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$expression0)), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_1,
        $this.$expression0));
    };
    function oncia_SetIncludingPropertiesFromMapItem_copy($this, $variable, $expression, $position) {
        return oncia_SetIncludingPropertiesFromMapItem__init_($variable, $expression, $position);
    }
    $java.oncia_SetIncludingPropertiesFromMapItem_productPrefix = function($this) {
        return $rt_s(2326);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable0;
            case 1:
                return $this.$expression0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_SetIncludingPropertiesFromMapItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable0;
                        var$3 = $x$1.$variable0;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression0;
                        $x$1 = $x$1.$expression0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_SetIncludingPropertiesFromMapItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_SetIncludingPropertiesFromMapItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SetIncludingPropertiesFromMapItem__init_ = function($this, $variable, $expression, $position) {
        $this.$variable0 = $variable;
        $this.$expression0 = $expression;
        $this.$position1 = $position;
    };
    function oncia_SetLabelItem() {
        var a = this; jl_Object.call(a);
        a.$variable40 = null;
        a.$labels2 = null;
        a.$position191 = null;
    }
    function oncia_SetLabelItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_SetLabelItem();
        $java.oncia_SetLabelItem__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_SetLabelItem_position = function($this) {
        return $this.$position191;
    };
    $java.oncia_SetLabelItem_semanticCheck = function($this) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $this.$variable40);
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$1, $java.oncias_SemanticPatternCheck$_checkValidLabels(oncias_SemanticPatternCheck$_MODULE$, $this.$labels2, $this.$position191)), oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncia_SetLabelItem$semanticCheck$lambda$_11_0, $this.$variable40));
    };
    $java.oncia_SetLabelItem_productPrefix = function($this) {
        return $rt_s(2327);
    };
    $java.oncia_SetLabelItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_SetLabelItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable40;
            case 1:
                return $this.$labels2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SetLabelItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetLabelItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetLabelItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SetLabelItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_SetLabelItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable40;
                        var$3 = $x$1.$variable40;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$labels2;
                        $x$1 = $x$1.$labels2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_SetLabelItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_SetLabelItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_SetLabelItem__init_ = function($this, $variable, $labels, $position) {
        $this.$variable40 = $variable;
        $this.$labels2 = $labels;
        $this.$position191 = $position;
    };
    var onciafn_Neo4jASTFactory$setLabels$lambda$_22_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$setLabels$lambda$_22_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncie_LabelName__init_(var$1.$string0, var$1.$pos);
    };
    var oncia_ProcedureResultItem$ = $rt_classWithoutFields();
    $java.oncia_ProcedureResultItem$_MODULE$ = null;
    function oncia_ProcedureResultItem$__clinit_() {
        $java.oncia_ProcedureResultItem$_MODULE$ = new oncia_ProcedureResultItem$;
    }
    function oncie_ProcedureOutput() {
        var a = this; jl_Object.call(a);
        a.$name57 = null;
        a.$position192 = null;
    }
    function oncie_ProcedureOutput__init_(var_0, var_1) {
        var var_2 = new oncie_ProcedureOutput();
        $java.oncie_ProcedureOutput__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_ProcedureOutput_name = function($this) {
        return $this.$name57;
    };
    $java.oncie_ProcedureOutput_position = function($this) {
        return $this.$position192;
    };
    $java.oncie_ProcedureOutput_productPrefix = function($this) {
        return $rt_s(2328);
    };
    $java.oncie_ProcedureOutput_productArity = function($this) {
        return 1;
    };
    $java.oncie_ProcedureOutput_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name57;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ProcedureOutput_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ProcedureOutput_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ProcedureOutput_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ProcedureOutput_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ProcedureOutput) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name57;
                        $x$1 = $x$1.$name57;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ProcedureOutput))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_ProcedureOutput_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_ProcedureOutput__init_ = function($this, $name, $position) {
        $this.$name57 = $name;
        $this.$position192 = $position;
    };
    var oncia_SubqueryCall$InTransactionsParameters$ = $rt_classWithoutFields();
    $java.oncia_SubqueryCall$InTransactionsParameters$_MODULE$ = null;
    function oncia_SubqueryCall$InTransactionsParameters$__clinit_() {
        $java.oncia_SubqueryCall$InTransactionsParameters$_MODULE$ = new oncia_SubqueryCall$InTransactionsParameters$;
    }
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasOrderBy$lambda$_42_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0352 = null;
        a.$_1107 = null;
    };
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasOrderBy$lambda$_42_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0352;
        var$3 = var$0.$_1107;
        if (var$1 instanceof oncia_AscSortItem) {
            var$4 = var$1.$expression12;
            var$5 = oncia_AscSortItem__init_(oncirr_normalizeWithAndReturnClauses_aliasExpression(var$2, var$3, var$4), var$1.$position2());
        } else {
            if (!(var$1 instanceof oncia_DescSortItem))
                $rt_throw(s_MatchError__init_(var$1));
            var$4 = var$1.$expression13;
            var$5 = oncia_DescSortItem__init_(oncirr_normalizeWithAndReturnClauses_aliasExpression(var$2, var$3, var$4), var$1.$position2());
        }
        return var$5;
    };
    $java.oncia_SubqueryCall$$anonfun$findTransactionalSubquery$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_SubqueryCall$$anonfun$findTransactionalSubquery$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return !$java.oncia_SubqueryCall$_isTransactionalSubquery($java.oncia_SubqueryCall$_MODULE$, $x) ? s_PartialFunction$_fallback_fn : jl_Boolean_valueOf(1);
    };
    $java.jt_DecimalFormatParser = function() {
        var a = this; jl_Object.call(a);
        a.$positivePrefix0 = null;
        a.$positiveSuffix0 = null;
        a.$negativePrefix0 = null;
        a.$negativeSuffix0 = null;
        a.$groupSize = 0;
        a.$minimumIntLength = 0;
        a.$intLength = 0;
        a.$minimumFracLength = 0;
        a.$fracLength = 0;
        a.$exponentLength = 0;
        a.$decimalSeparatorRequired = 0;
        a.$string1 = null;
        a.$index4 = 0;
        a.$multiplier0 = 0;
    };
    $java.jt_DecimalFormatParser_parseText = function($this, $suffix, $end) {
        var $fields, $sb, $c, var$6, var$7, $next;
        $fields = ju_ArrayList__init_();
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        a: {
            b: {
                c: while (true) {
                    if ($this.$index4 >= jl_String_length($this.$string1))
                        break a;
                    d: {
                        $c = jl_String_charAt($this.$string1, $this.$index4);
                        switch ($c) {
                            case 35:
                            case 48:
                                if (!$suffix)
                                    break a;
                                $fields = new jl_IllegalArgumentException;
                                $suffix = $this.$index4;
                                var$6 = $this.$string1;
                                var$7 = new jl_StringBuilder;
                                jl_AbstractStringBuilder__init_(var$7);
                                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2329)), $suffix), $rt_s(2098)), var$6);
                                jl_Throwable__init_($fields, jl_AbstractStringBuilder_toString(var$7));
                                $rt_throw($fields);
                            case 37:
                                if ($sb.$length0 > 0) {
                                    ju_ArrayList_add($fields, $java.jt_DecimalFormat$TextField__init_(jl_AbstractStringBuilder_toString($sb)));
                                    $sb.$length0 = 0;
                                }
                                ju_ArrayList_add($fields, new $java.jt_DecimalFormat$PercentField);
                                $this.$index4 = $this.$index4 + 1 | 0;
                                $this.$multiplier0 = 100;
                                break d;
                            case 39:
                                $c = $this.$index4 + 1 | 0;
                                $this.$index4 = $c;
                                $next = jl_String_indexOf($this.$string1, 39, $c);
                                if ($next < 0) {
                                    $fields = new jl_IllegalArgumentException;
                                    $suffix = $this.$index4;
                                    var$6 = $this.$string1;
                                    var$7 = new jl_StringBuilder;
                                    jl_AbstractStringBuilder__init_(var$7);
                                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2330)), $suffix), $rt_s(2331)), var$6);
                                    jl_Throwable__init_($fields, jl_AbstractStringBuilder_toString(var$7));
                                    $rt_throw($fields);
                                }
                                $c = $this.$index4;
                                if ($next == $c)
                                    jl_AbstractStringBuilder_append($sb, 39);
                                else
                                    jl_AbstractStringBuilder_append1($sb, jl_String_substring0($this.$string1, $c, $next));
                                $this.$index4 = $next + 1 | 0;
                                break d;
                            case 45:
                                if ($sb.$length0 > 0) {
                                    ju_ArrayList_add($fields, $java.jt_DecimalFormat$TextField__init_(jl_AbstractStringBuilder_toString($sb)));
                                    $sb.$length0 = 0;
                                }
                                ju_ArrayList_add($fields, new $java.jt_DecimalFormat$MinusField);
                                $this.$index4 = $this.$index4 + 1 | 0;
                                break d;
                            case 46:
                            case 69:
                                break c;
                            case 59:
                                break b;
                            case 164:
                                if ($sb.$length0 > 0) {
                                    ju_ArrayList_add($fields, $java.jt_DecimalFormat$TextField__init_(jl_AbstractStringBuilder_toString($sb)));
                                    $sb.$length0 = 0;
                                }
                                ju_ArrayList_add($fields, new $java.jt_DecimalFormat$CurrencyField);
                                $this.$index4 = $this.$index4 + 1 | 0;
                                break d;
                            case 8240:
                                if ($sb.$length0 > 0) {
                                    ju_ArrayList_add($fields, $java.jt_DecimalFormat$TextField__init_(jl_AbstractStringBuilder_toString($sb)));
                                    $sb.$length0 = 0;
                                }
                                ju_ArrayList_add($fields, new $java.jt_DecimalFormat$PerMillField);
                                $this.$index4 = $this.$index4 + 1 | 0;
                                $this.$multiplier0 = 1000;
                                break d;
                            default:
                        }
                        jl_AbstractStringBuilder_append($sb, $c);
                        $this.$index4 = $this.$index4 + 1 | 0;
                    }
                }
                $fields = new jl_IllegalArgumentException;
                $suffix = $this.$index4;
                var$6 = $this.$string1;
                var$7 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$7);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2329)), $suffix), $rt_s(2098)), var$6);
                jl_Throwable__init_($fields, jl_AbstractStringBuilder_toString(var$7));
                $rt_throw($fields);
            }
            if ($end) {
                $fields = new jl_IllegalArgumentException;
                $suffix = $this.$index4;
                var$6 = $this.$string1;
                var$7 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$7);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2329)), $suffix), $rt_s(2098)), var$6);
                jl_Throwable__init_($fields, jl_AbstractStringBuilder_toString(var$7));
                $rt_throw($fields);
            }
        }
        if ($sb.$length0 > 0)
            ju_ArrayList_add($fields, $java.jt_DecimalFormat$TextField__init_(jl_AbstractStringBuilder_toString($sb)));
        return ju_AbstractCollection_toArray($fields, $rt_createArray($java.jt_DecimalFormat$FormatField, $fields.$size2));
    };
    $java.jt_DecimalFormatParser_parseNumber = function($this, $apply) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        $java.jt_DecimalFormatParser_parseIntegerPart($this, $apply);
        if ($this.$index4 < jl_String_length($this.$string1) && jl_String_charAt($this.$string1, $this.$index4) == 46) {
            $this.$index4 = $this.$index4 + 1 | 0;
            var$2 = 0;
            var$3 = 0;
            var$4 = 0;
            a: {
                b: while (true) {
                    if ($this.$index4 >= jl_String_length($this.$string1))
                        break a;
                    c: {
                        switch (jl_String_charAt($this.$string1, $this.$index4)) {
                            case 35:
                                break;
                            case 44:
                                var$5 = new jl_IllegalArgumentException;
                                $apply = $this.$index4;
                                var$6 = $this.$string1;
                                var$7 = new jl_StringBuilder;
                                jl_AbstractStringBuilder__init_(var$7);
                                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2332)), $apply), $rt_s(2098)), var$6);
                                jl_Throwable__init_(var$5, jl_AbstractStringBuilder_toString(var$7));
                                $rt_throw(var$5);
                            case 46:
                                var$5 = new jl_IllegalArgumentException;
                                $apply = $this.$index4;
                                var$6 = $this.$string1;
                                var$7 = new jl_StringBuilder;
                                jl_AbstractStringBuilder__init_(var$7);
                                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2333)), $apply), $rt_s(2098)), var$6);
                                jl_Throwable__init_(var$5, jl_AbstractStringBuilder_toString(var$7));
                                $rt_throw(var$5);
                            case 48:
                                if (var$2)
                                    break b;
                                var$3 = var$3 + 1 | 0;
                                var$4 = var$4 + 1 | 0;
                                break c;
                            default:
                                break a;
                        }
                        var$3 = var$3 + 1 | 0;
                        var$2 = 1;
                    }
                    $this.$index4 = $this.$index4 + 1 | 0;
                }
                var$5 = new jl_IllegalArgumentException;
                $apply = $this.$index4;
                var$6 = $this.$string1;
                var$7 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$7);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2334)), $apply), $rt_s(2098)), var$6);
                jl_Throwable__init_(var$5, jl_AbstractStringBuilder_toString(var$7));
                $rt_throw(var$5);
            }
            if ($apply) {
                $this.$fracLength = var$3;
                $this.$minimumFracLength = var$4;
                $this.$decimalSeparatorRequired = var$3 ? 0 : 1;
            }
        }
        if ($this.$index4 < jl_String_length($this.$string1) && jl_String_charAt($this.$string1, $this.$index4) == 69) {
            $this.$index4 = $this.$index4 + 1 | 0;
            var$2 = 0;
            d: {
                e: while (true) {
                    if ($this.$index4 >= jl_String_length($this.$string1))
                        break d;
                    switch (jl_String_charAt($this.$string1, $this.$index4)) {
                        case 35:
                        case 44:
                        case 46:
                        case 69:
                            break e;
                        case 48:
                            break;
                        default:
                            break d;
                    }
                    var$2 = var$2 + 1 | 0;
                    $this.$index4 = $this.$index4 + 1 | 0;
                }
                var$5 = new jl_IllegalArgumentException;
                $apply = $this.$index4;
                var$6 = $this.$string1;
                var$7 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$7);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2335)), $apply), $rt_s(2098)), var$6);
                jl_Throwable__init_(var$5, jl_AbstractStringBuilder_toString(var$7));
                $rt_throw(var$5);
            }
            if (!var$2) {
                var$5 = new jl_IllegalArgumentException;
                $apply = $this.$index4;
                var$6 = $this.$string1;
                var$7 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$7);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$7, $rt_s(2336)), $apply), $rt_s(2098)), var$6);
                jl_Throwable__init_(var$5, jl_AbstractStringBuilder_toString(var$7));
                $rt_throw(var$5);
            }
            if ($apply)
                $this.$exponentLength = var$2;
        }
    };
    $java.jt_DecimalFormatParser_parseIntegerPart = function($this, $apply) {
        var $lastGroup, $optionalDigits, $length, $minimumLength, var$6, var$7, var$8, var$9, var$10;
        $lastGroup = $this.$index4;
        $optionalDigits = 1;
        $length = 0;
        $minimumLength = 0;
        var$6 = $lastGroup;
        a: {
            b: while (true) {
                if ($this.$index4 >= jl_String_length($this.$string1))
                    break a;
                c: {
                    d: {
                        switch (jl_String_charAt($this.$string1, $this.$index4)) {
                            case 35:
                                if (!$optionalDigits) {
                                    var$7 = new jl_IllegalArgumentException;
                                    $apply = $this.$index4;
                                    var$8 = $this.$string1;
                                    var$9 = new jl_StringBuilder;
                                    jl_AbstractStringBuilder__init_(var$9);
                                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$9, $rt_s(2337)), $apply), $rt_s(2098)), var$8);
                                    jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$9));
                                    $rt_throw(var$7);
                                }
                                $length = $length + 1 | 0;
                                break c;
                            case 44:
                                break d;
                            case 48:
                                break;
                            default:
                                break a;
                        }
                        $optionalDigits = 0;
                        $length = $length + 1 | 0;
                        $minimumLength = $minimumLength + 1 | 0;
                        break c;
                    }
                    var$10 = $this.$index4;
                    if (var$6 == var$10)
                        break b;
                    if ($apply)
                        $this.$groupSize = var$10 - var$6 | 0;
                    var$6 = var$10 + 1 | 0;
                }
                $this.$index4 = $this.$index4 + 1 | 0;
            }
            var$7 = new jl_IllegalArgumentException;
            var$8 = $this.$string1;
            var$9 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$9);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$9, $rt_s(2338)), var$10), $rt_s(2098)), var$8);
            jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$9));
            $rt_throw(var$7);
        }
        if (!$length) {
            var$7 = new jl_IllegalArgumentException;
            $apply = $this.$index4;
            var$8 = $this.$string1;
            var$9 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$9);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$9, $rt_s(2339)), $apply), $rt_s(2098)), var$8);
            jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$9));
            $rt_throw(var$7);
        }
        $optionalDigits = $this.$index4;
        if (var$6 == $optionalDigits) {
            var$7 = new jl_IllegalArgumentException;
            var$8 = $this.$string1;
            var$9 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$9);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(jl_StringBuilder_append(var$9, $rt_s(2340)), $optionalDigits), $rt_s(2098)), var$8);
            jl_Throwable__init_(var$7, jl_AbstractStringBuilder_toString(var$9));
            $rt_throw(var$7);
        }
        if ($apply && var$6 > $lastGroup)
            $this.$groupSize = $optionalDigits - var$6 | 0;
        if ($apply) {
            $this.$intLength = $length;
            $this.$minimumIntLength = $minimumLength;
        }
    };
    $java.sc_StringOps$$format$extension$lambda$_92_0 = function() {
        jl_Object.call(this);
        this.$_0431 = null;
    };
    $java.sc_StringOps$$format$extension$lambda$_92_0_apply = function(var$0, var$1) {
        if (var$1 instanceof sm_ScalaNumber)
            var$1 = var$1.$underlying30();
        return var$1;
    };
    function scm_HashMap$$anon$5() {
        var a = this; scm_HashMap$HashMapIterator.call(a);
        a.$hash0 = 0;
        a.$$outer13 = null;
    }
    $java.scm_HashMap$$anon$5_hashCode = function($this) {
        return $this.$hash0;
    };
    $java.scm_HashMap$$anon$5_extract = function($this, $nd) {
        suh_MurmurHash3$_$callClinit();
        $this.$hash0 = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, jl_Integer_valueOf(scm_HashMap_unimproveHash($this.$$outer13, $nd.$_hash)), jl_Integer_valueOf(sr_Statics_anyHash($nd.$_value)));
        return $this;
    };
    $java.oncief_Function$ = $rt_classWithoutFields();
    $java.oncief_Function$_MODULE$ = null;
    $java.oncief_Function$_lookup = null;
    $java.oncief_Function$_knownFunctions0 = null;
    $java.oncief_Function$_bitmap$0 = 0;
    $java.oncief_Function$_$callClinit = function() {
        $java.oncief_Function$_$callClinit = $rt_eraseClinit($java.oncief_Function$);
        $java.oncief_Function$__clinit_();
    };
    $java.oncief_Function$__init_ = function() {
        var var_0 = new $java.oncief_Function$();
        $java.oncief_Function$__init_0(var_0);
        return var_0;
    };
    $java.oncief_Function$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5;
        $java.oncief_Function$_MODULE$ = $java.oncief_Function$__init_();
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncief_Function, 87);
        var$4 = var$3.data;
        $java.oncief_Abs$_$callClinit();
        var$4[0] = $java.oncief_Abs$_MODULE$;
        $java.oncief_Acos$_$callClinit();
        var$4[1] = $java.oncief_Acos$_MODULE$;
        $java.oncief_Asin$_$callClinit();
        var$4[2] = $java.oncief_Asin$_MODULE$;
        $java.oncief_Atan$_$callClinit();
        var$4[3] = $java.oncief_Atan$_MODULE$;
        $java.oncief_Atan2$_$callClinit();
        var$4[4] = $java.oncief_Atan2$_MODULE$;
        $java.oncief_Avg$_$callClinit();
        var$4[5] = $java.oncief_Avg$_MODULE$;
        $java.oncief_Ceil$_$callClinit();
        var$5 = $java.oncief_Ceil$_MODULE$;
        var$4[6] = var$5;
        $java.oncief_CharLength$_$callClinit();
        var$4[7] = $java.oncief_CharLength$_MODULE$;
        $java.oncief_CharacterLength$_$callClinit();
        var$4[8] = $java.oncief_CharacterLength$_MODULE$;
        $java.oncief_Coalesce$_$callClinit();
        var$4[9] = $java.oncief_Coalesce$_MODULE$;
        $java.oncief_Collect$_$callClinit();
        var$4[10] = $java.oncief_Collect$_MODULE$;
        var$4[11] = var$5;
        $java.oncief_Cos$_$callClinit();
        var$4[12] = $java.oncief_Cos$_MODULE$;
        $java.oncief_Cot$_$callClinit();
        var$4[13] = $java.oncief_Cot$_MODULE$;
        $java.oncief_Count$_$callClinit();
        var$4[14] = $java.oncief_Count$_MODULE$;
        $java.oncief_Degrees$_$callClinit();
        var$4[15] = $java.oncief_Degrees$_MODULE$;
        $java.oncief_Distance$_$callClinit();
        var$4[16] = $java.oncief_Distance$_MODULE$;
        $java.oncief_E$_$callClinit();
        var$4[17] = $java.oncief_E$_MODULE$;
        $java.oncief_ElementId$_$callClinit();
        var$4[18] = $java.oncief_ElementId$_MODULE$;
        $java.oncief_EndNode$_$callClinit();
        var$4[19] = $java.oncief_EndNode$_MODULE$;
        $java.oncief_Exists$_$callClinit();
        var$4[20] = $java.oncief_Exists$_MODULE$;
        $java.oncief_Exp$_$callClinit();
        var$4[21] = $java.oncief_Exp$_MODULE$;
        $java.oncief_File$_$callClinit();
        var$4[22] = $java.oncief_File$_MODULE$;
        $java.oncief_Floor$_$callClinit();
        var$4[23] = $java.oncief_Floor$_MODULE$;
        $java.oncief_Haversin$_$callClinit();
        var$4[24] = $java.oncief_Haversin$_MODULE$;
        $java.oncief_Head$_$callClinit();
        var$4[25] = $java.oncief_Head$_MODULE$;
        $java.oncief_Id$_$callClinit();
        var$4[26] = $java.oncief_Id$_MODULE$;
        $java.oncief_IsEmpty$_$callClinit();
        var$4[27] = $java.oncief_IsEmpty$_MODULE$;
        $java.oncief_IsNaN$_$callClinit();
        var$4[28] = $java.oncief_IsNaN$_MODULE$;
        $java.oncief_Labels$_$callClinit();
        var$4[29] = $java.oncief_Labels$_MODULE$;
        $java.oncief_Last$_$callClinit();
        var$4[30] = $java.oncief_Last$_MODULE$;
        $java.oncief_Left$_$callClinit();
        var$4[31] = $java.oncief_Left$_MODULE$;
        $java.oncief_Length$_$callClinit();
        var$4[32] = $java.oncief_Length$_MODULE$;
        $java.oncief_Linenumber$_$callClinit();
        var$4[33] = $java.oncief_Linenumber$_MODULE$;
        $java.oncief_Log$_$callClinit();
        var$4[34] = $java.oncief_Log$_MODULE$;
        $java.oncief_Log10$_$callClinit();
        var$4[35] = $java.oncief_Log10$_MODULE$;
        $java.oncief_LTrim$_$callClinit();
        var$4[36] = $java.oncief_LTrim$_MODULE$;
        $java.oncief_Max$_$callClinit();
        var$4[37] = $java.oncief_Max$_MODULE$;
        $java.oncief_Min$_$callClinit();
        var$4[38] = $java.oncief_Min$_MODULE$;
        $java.oncief_Nodes$_$callClinit();
        var$4[39] = $java.oncief_Nodes$_MODULE$;
        $java.oncief_Pi$_$callClinit();
        var$4[40] = $java.oncief_Pi$_MODULE$;
        $java.oncief_PercentileCont$_$callClinit();
        var$4[41] = $java.oncief_PercentileCont$_MODULE$;
        $java.oncief_PercentileDisc$_$callClinit();
        var$4[42] = $java.oncief_PercentileDisc$_MODULE$;
        $java.oncief_Point$_$callClinit();
        var$4[43] = $java.oncief_Point$_MODULE$;
        $java.oncief_Keys$_$callClinit();
        var$4[44] = $java.oncief_Keys$_MODULE$;
        $java.oncief_Radians$_$callClinit();
        var$4[45] = $java.oncief_Radians$_MODULE$;
        $java.oncief_Rand$_$callClinit();
        var$4[46] = $java.oncief_Rand$_MODULE$;
        $java.oncief_RandomUUID$_$callClinit();
        var$4[47] = $java.oncief_RandomUUID$_MODULE$;
        $java.oncief_Range$_$callClinit();
        var$4[48] = $java.oncief_Range$_MODULE$;
        $java.oncief_Reduce$_$callClinit();
        var$4[49] = $java.oncief_Reduce$_MODULE$;
        $java.oncief_Relationships$_$callClinit();
        var$4[50] = $java.oncief_Relationships$_MODULE$;
        $java.oncief_Replace$_$callClinit();
        var$4[51] = $java.oncief_Replace$_MODULE$;
        $java.oncief_Reverse$_$callClinit();
        var$4[52] = $java.oncief_Reverse$_MODULE$;
        $java.oncief_Right$_$callClinit();
        var$4[53] = $java.oncief_Right$_MODULE$;
        $java.oncief_Round$_$callClinit();
        var$4[54] = $java.oncief_Round$_MODULE$;
        $java.oncief_RTrim$_$callClinit();
        var$4[55] = $java.oncief_RTrim$_MODULE$;
        $java.oncief_Sign$_$callClinit();
        var$4[56] = $java.oncief_Sign$_MODULE$;
        $java.oncief_Sin$_$callClinit();
        var$4[57] = $java.oncief_Sin$_MODULE$;
        $java.oncief_Size$_$callClinit();
        var$4[58] = $java.oncief_Size$_MODULE$;
        $java.oncief_Sqrt$_$callClinit();
        var$4[59] = $java.oncief_Sqrt$_MODULE$;
        $java.oncief_Split$_$callClinit();
        var$4[60] = $java.oncief_Split$_MODULE$;
        $java.oncief_StartNode$_$callClinit();
        var$4[61] = $java.oncief_StartNode$_MODULE$;
        $java.oncief_StdDev$_$callClinit();
        var$4[62] = $java.oncief_StdDev$_MODULE$;
        $java.oncief_StdDevP$_$callClinit();
        var$4[63] = $java.oncief_StdDevP$_MODULE$;
        $java.oncief_Substring$_$callClinit();
        var$4[64] = $java.oncief_Substring$_MODULE$;
        $java.oncief_Sum$_$callClinit();
        var$4[65] = $java.oncief_Sum$_MODULE$;
        $java.oncief_Tail$_$callClinit();
        var$4[66] = $java.oncief_Tail$_MODULE$;
        $java.oncief_Tan$_$callClinit();
        var$4[67] = $java.oncief_Tan$_MODULE$;
        $java.oncief_ToBoolean$_$callClinit();
        var$4[68] = $java.oncief_ToBoolean$_MODULE$;
        $java.oncief_ToBooleanList$_$callClinit();
        var$4[69] = $java.oncief_ToBooleanList$_MODULE$;
        $java.oncief_ToBooleanOrNull$_$callClinit();
        var$4[70] = $java.oncief_ToBooleanOrNull$_MODULE$;
        $java.oncief_ToFloat$_$callClinit();
        var$4[71] = $java.oncief_ToFloat$_MODULE$;
        $java.oncief_ToFloatList$_$callClinit();
        var$4[72] = $java.oncief_ToFloatList$_MODULE$;
        $java.oncief_ToFloatOrNull$_$callClinit();
        var$4[73] = $java.oncief_ToFloatOrNull$_MODULE$;
        $java.oncief_ToInteger$_$callClinit();
        var$4[74] = $java.oncief_ToInteger$_MODULE$;
        $java.oncief_ToIntegerList$_$callClinit();
        var$4[75] = $java.oncief_ToIntegerList$_MODULE$;
        $java.oncief_ToIntegerOrNull$_$callClinit();
        var$4[76] = $java.oncief_ToIntegerOrNull$_MODULE$;
        $java.oncief_ToLower$_$callClinit();
        var$4[77] = $java.oncief_ToLower$_MODULE$;
        $java.oncief_ToString$_$callClinit();
        var$4[78] = $java.oncief_ToString$_MODULE$;
        $java.oncief_ToStringList$_$callClinit();
        var$4[79] = $java.oncief_ToStringList$_MODULE$;
        $java.oncief_ToStringOrNull$_$callClinit();
        var$4[80] = $java.oncief_ToStringOrNull$_MODULE$;
        $java.oncief_ToUpper$_$callClinit();
        var$4[81] = $java.oncief_ToUpper$_MODULE$;
        $java.oncief_Properties$_$callClinit();
        var$4[82] = $java.oncief_Properties$_MODULE$;
        $java.oncief_Trim$_$callClinit();
        var$4[83] = $java.oncief_Trim$_MODULE$;
        $java.oncief_Type$_$callClinit();
        var$4[84] = $java.oncief_Type$_MODULE$;
        $java.oncief_ValueType$_$callClinit();
        var$4[85] = $java.oncief_ValueType$_MODULE$;
        $java.oncief_WithinBBox$_$callClinit();
        var$4[86] = $java.oncief_WithinBBox$_MODULE$;
        $java.oncief_Function$_knownFunctions0 = sci_Vector$_apply(var$1, sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Function$_knownFunctions = function($this) {
        $java.oncief_Function$_$callClinit();
        return $java.oncief_Function$_knownFunctions0;
    };
    $java.oncief_Function$__init_0 = function($this) {
        $java.oncief_Function$_$callClinit();
    };
    $java.oncie_FunctionInvocation$_init_$lambda$_34_0 = $rt_classWithoutFields();
    $java.oncie_FunctionInvocation$_init_$lambda$_34_0_apply = function(var$0) {
        return $java.oncief_UnresolvedFunction$_MODULE$;
    };
    $java.oncief_FunctionWithName = $rt_classWithoutFields(0);
    $java.oncie_TypeSignatures = $rt_classWithoutFields(0);
    $java.oncie_TypeSignatures_signatureLengths$ = function($$this) {
        return ($$this.$signatures2()).$map1(new $java.oncie_TypeSignatures$signatureLengths$lambda$_3_0);
    };
    $java.oncief_Function = function() {
        var a = this; jl_Object.call(a);
        a.$signatureLengths = null;
        a.$bitmap$029 = 0;
    };
    $java.oncief_Function_signatures = function($this) {
        s_package$_$callClinit();
        return sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
    };
    $java.oncief_Function_signatureLengths = function($this) {
        var var$1, $$je;
        if ($this.$bitmap$029)
            return $this.$signatureLengths;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$029)
                    break a;
                $this.$signatureLengths = $java.oncie_TypeSignatures_signatureLengths$($this);
                $this.$bitmap$029 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$signatureLengths;
    };
    $java.oncief_Function__init_ = function($this) {};
    $java.oncia_ShowTransactionsClause$_init_$lambda$_94_0 = function() {
        jl_Object.call(this);
        this.$_0434 = null;
    };
    $java.oncia_ShowTransactionsClause$_init_$lambda$_94_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0434;
        return oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, var$1.$name49, var$1.$cypherType0, var$2.$position154);
    };
    $java.oncia_ShowTransactionsClause$_init_$lambda$_94_1 = function() {
        jl_Object.call(this);
        this.$_0435 = null;
    };
    $java.oncia_ShowTransactionsClause$_init_$lambda$_94_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0435;
        return oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, var$1.$name49, var$1.$cypherType0, var$2.$position154);
    };
    $java.oncia_TerminateTransactionsClause$_init_$lambda$_91_0 = function() {
        jl_Object.call(this);
        this.$_0438 = null;
    };
    $java.oncia_TerminateTransactionsClause$_init_$lambda$_91_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0438;
        return oncia_ShowColumn$_apply(oncia_ShowColumn$_MODULE$, var$1.$name49, var$1.$cypherType0, var$2.$position155);
    };
    $java.scc_AsScalaExtensions$SetHasAsScala = function() {
        var a = this; jl_Object.call(a);
        a.$s = null;
        a.$$outer43 = null;
    };
    function oncirr_normalizeWithAndReturnClauses$$anonfun$3() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer26 = null;
        a.$existingAliases$3 = null;
    }
    $java.oncirr_normalizeWithAndReturnClauses$$anonfun$3_applyOrElse = function($this, $x1, $default) {
        var $subAlias, var$4, var$5;
        if (!($x1 instanceof oncie_Expression))
            return $default.$apply($x1);
        $x1 = $x1;
        $default = $this.$existingAliases$3.$get1($x1);
        if ($default instanceof s_Some) {
            a: {
                $subAlias = $default.$value5;
                $default = $this.$existingAliases$3;
                if (!($default.$valuesIterator()).$contains0($x1)) {
                    $default = ($default.$filter1(new $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_0)).$valuesIterator();
                    var$4 = new $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_1;
                    var$4.$_0439 = $x1;
                    if (!$default.$exists(var$4)) {
                        var$5 = 0;
                        break a;
                    }
                }
                var$5 = 1;
            }
            if (!var$5)
                return oncie_Variable_withPosition(oncie_Variable_copyId($subAlias), $x1.$position2());
        }
        return $x1;
    };
    var oncirr_normalizeWithAndReturnClauses$aliasExpression$lambda$_45_0 = $rt_classWithoutFields();
    $java.oncirr_normalizeWithAndReturnClauses$aliasExpression$lambda$_45_0_shouldStop = function(var$0, var$1) {
        return $rt_isInstance(var$1, $java.oncie_ScopeExpression);
    };
    $java.oncirr_rewriteShowQuery$$$anonfun$getDefaultOrderFromYieldOrCommand$1$lambda$_25_0 = $rt_classWithoutFields();
    $java.oncirr_rewriteShowQuery$$$anonfun$getDefaultOrderFromYieldOrCommand$1$lambda$_25_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncirr_rewriteShowQuery$_$callClinit();
        return var$1.$name23;
    };
    $java.oncia_Union$returnVariables$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncia_Union$returnVariables$lambda$_4_0_apply = function(var$0, var$1) {
        return var$1.$unionVariable;
    };
    $java.oncirr_normalizeWithAndReturnClauses$$anonfun$aliasUnaliasedReturnItems$1$lambda$_68_0 = function() {
        jl_Object.call(this);
        this.$_0311 = null;
    };
    $java.oncirr_normalizeWithAndReturnClauses$$anonfun$aliasUnaliasedReturnItems$1$lambda$_68_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0311;
        return oncie_Variable__init_(var$1.$name18, var$1.$expression9.$position2());
    };
    $java.scc_JavaCollectionWrappers$MapWrapper = $rt_classWithoutFields(ju_AbstractMap);
    $java.scc_JavaCollectionWrappers$MutableMapWrapper = $rt_classWithoutFields($java.scc_JavaCollectionWrappers$MapWrapper);
    $java.scc_JavaCollectionWrappers$JMapWrapperLike = $rt_classWithoutFields(0);
    $java.scc_JavaCollectionWrappers$AbstractJMapWrapper = $rt_classWithoutFields(scm_AbstractMap);
    $java.scc_JavaCollectionWrappers$AbstractJMapWrapper_iterator = function($this) {
        var var$1;
        var$1 = new $java.scc_JavaCollectionWrappers$JMapWrapperLike$$anon$5;
        var$1.$ui = ju_LinkedHashMap$LinkedHashMapEntrySet_iterator(ju_LinkedHashMap_entrySet($this.$underlying29));
        return var$1;
    };
    $java.scc_JavaCollectionWrappers$JMapWrapper = function() {
        $java.scc_JavaCollectionWrappers$AbstractJMapWrapper.call(this);
        this.$underlying29 = null;
    };
    $java.scc_JavaCollectionWrappers$JMapWrapper_knownSize = function($this) {
        if (!$java.ju_HashMap_isEmpty($this.$underlying29))
            return (-1);
        return 0;
    };
    function scm_ArrayBuilder() {
        var a = this; jl_Object.call(a);
        a.$capacity0 = 0;
        a.$size9 = 0;
    }
    $java.scm_ArrayBuilder_mapResult = function($this, $f) {
        return scm_Builder_mapResult$($this, $f);
    };
    $java.scm_ArrayBuilder_capacity = function($this) {
        return $this.$capacity0;
    };
    $java.scm_ArrayBuilder_size = function($this) {
        return $this.$size9;
    };
    $java.scm_ArrayBuilder_size_$eq = function($this, $x$1) {
        $this.$size9 = $x$1;
    };
    $java.scm_ArrayBuilder_length = function($this) {
        return $this.$size9;
    };
    $java.scm_ArrayBuilder_ensureSize = function($this, $size) {
        var var$2, $newsize;
        var$2 = $this.$capacity0;
        if (var$2 >= $size && var$2)
            return;
        $newsize = !var$2 ? 16 : var$2 * 2 | 0;
        while ($newsize < $size) {
            $newsize = $newsize * 2 | 0;
        }
        $this.$resize($newsize);
    };
    function scm_ArrayBuilder_sizeHint($this, $size) {
        if ($this.$capacity0 >= $size)
            return;
        $this.$resize($size);
    }
    function scm_ArrayBuilder_addAll($this, $xs) {
        return $this.$addAll13($xs, 0, jlr_Array_getLength($xs));
    }
    $java.scm_ArrayBuilder_addAll = function($this, $xs, $offset, $length) {
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + $length | 0);
        s_Array$_copy(s_Array$_MODULE$, $xs, $offset, $this.$elems4(), $this.$size9, $length);
        $this.$size9 = $this.$size9 + $length | 0;
        return $this;
    };
    $java.scm_ArrayBuilder_addAll0 = function($this, $xs) {
        var $k, $copyElemsToArray_len, $copyElemsToArray_xs, $copyElemsToArray_start, $actual;
        $k = $xs.$knownSize();
        $copyElemsToArray_len = $rt_compare($k, 0);
        if ($copyElemsToArray_len > 0) {
            $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + $k | 0);
            $copyElemsToArray_xs = $this.$elems4();
            $copyElemsToArray_start = $this.$size9;
            $actual = !$rt_isInstance($xs, sc_Iterable) ? ($xs.$iterator0()).$copyToArray($copyElemsToArray_xs, $copyElemsToArray_start, 2147483647) : $xs.$copyToArray($copyElemsToArray_xs, $copyElemsToArray_start, 2147483647);
            if ($actual != $k) {
                $xs = new jl_IllegalStateException;
                $copyElemsToArray_xs = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_2($copyElemsToArray_xs, 11);
                jl_AbstractStringBuilder_append1($copyElemsToArray_xs, $rt_s(458));
                $copyElemsToArray_xs = jl_StringBuilder_append0($copyElemsToArray_xs, $actual);
                jl_AbstractStringBuilder_append1($copyElemsToArray_xs, $rt_s(459));
                jl_Throwable__init_($xs, jl_AbstractStringBuilder_toString(jl_StringBuilder_append0($copyElemsToArray_xs, $k)));
                $rt_throw($xs);
            }
            $this.$size9 = $this.$size9 + $k | 0;
        } else if ($copyElemsToArray_len < 0)
            scm_Growable_addAll$($this, $xs);
        return $this;
    };
    $java.scm_ArrayBuilder_addAll1 = function($this, $xs) {
        return $this.$addAll($xs);
    };
    function scm_ArrayBuilder__init_($this) {
        $this.$capacity0 = 0;
        $this.$size9 = 0;
    }
    function scm_ArrayBuilder$ofByte() {
        scm_ArrayBuilder.call(this);
        this.$elems5 = null;
    }
    $java.scm_ArrayBuilder$ofByte_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createByteArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems5, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofByte_resize = function($this, $size) {
        $this.$elems5 = $java.scm_ArrayBuilder$ofByte_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofByte_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems5;
            $this.$elems5 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofByte_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofByte_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToByte($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems5.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofByte_elems = function($this) {
        return $this.$elems5;
    };
    function scm_ArrayBuilder$ofShort() {
        scm_ArrayBuilder.call(this);
        this.$elems6 = null;
    }
    $java.scm_ArrayBuilder$ofShort_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createShortArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems6, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofShort_resize = function($this, $size) {
        $this.$elems6 = $java.scm_ArrayBuilder$ofShort_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofShort_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems6;
            $this.$elems6 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofShort_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofShort_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToShort($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems6.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofShort_elems = function($this) {
        return $this.$elems6;
    };
    function scm_ArrayBuilder$ofChar() {
        scm_ArrayBuilder.call(this);
        this.$elems7 = null;
    }
    $java.scm_ArrayBuilder$ofChar_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createCharArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems7, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofChar_resize = function($this, $size) {
        $this.$elems7 = $java.scm_ArrayBuilder$ofChar_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofChar_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems7;
            $this.$elems7 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofChar_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofChar_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToChar($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems7.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofChar_elems = function($this) {
        return $this.$elems7;
    };
    function scm_ArrayBuilder$ofInt() {
        scm_ArrayBuilder.call(this);
        this.$elems8 = null;
    }
    $java.scm_ArrayBuilder$ofInt_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createIntArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems8, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofInt_resize = function($this, $size) {
        $this.$elems8 = $java.scm_ArrayBuilder$ofInt_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofInt_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems8;
            $this.$elems8 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofInt_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofInt_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToInt($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems8.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofInt_elems = function($this) {
        return $this.$elems8;
    };
    function scm_ArrayBuilder$ofLong() {
        scm_ArrayBuilder.call(this);
        this.$elems9 = null;
    }
    $java.scm_ArrayBuilder$ofLong_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createLongArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems9, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofLong_resize = function($this, $size) {
        $this.$elems9 = $java.scm_ArrayBuilder$ofLong_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofLong_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems9;
            $this.$elems9 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofLong_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofLong_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToLong($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems9.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofLong_elems = function($this) {
        return $this.$elems9;
    };
    function scm_ArrayBuilder$ofFloat() {
        scm_ArrayBuilder.call(this);
        this.$elems10 = null;
    }
    $java.scm_ArrayBuilder$ofFloat_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createFloatArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems10, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofFloat_resize = function($this, $size) {
        $this.$elems10 = $java.scm_ArrayBuilder$ofFloat_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofFloat_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems10;
            $this.$elems10 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofFloat_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofFloat_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToFloat($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems10.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofFloat_elems = function($this) {
        return $this.$elems10;
    };
    function scm_ArrayBuilder$ofDouble() {
        scm_ArrayBuilder.call(this);
        this.$elems11 = null;
    }
    $java.scm_ArrayBuilder$ofDouble_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createDoubleArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems11, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofDouble_resize = function($this, $size) {
        $this.$elems11 = $java.scm_ArrayBuilder$ofDouble_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofDouble_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems11;
            $this.$elems11 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofDouble_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofDouble_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToDouble($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems11.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofDouble_elems = function($this) {
        return $this.$elems11;
    };
    function scm_ArrayBuilder$ofBoolean() {
        scm_ArrayBuilder.call(this);
        this.$elems12 = null;
    }
    $java.scm_ArrayBuilder$ofBoolean_mkArray = function($this, $size) {
        var $newelems, var$3;
        $newelems = $rt_createBooleanArray($size);
        var$3 = $this.$size9;
        if (var$3 > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$elems12, 0, $newelems, 0, var$3);
        return $newelems;
    };
    $java.scm_ArrayBuilder$ofBoolean_resize = function($this, $size) {
        $this.$elems12 = $java.scm_ArrayBuilder$ofBoolean_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofBoolean_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems12;
            $this.$elems12 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofBoolean_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofBoolean_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = sr_BoxesRunTime_unboxToBoolean($elem);
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$3 = $this.$elems12.data;
        var$4 = $this.$size9;
        var$3[var$4] = var$2;
        $this.$size9 = var$4 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofBoolean_elems = function($this) {
        return $this.$elems12;
    };
    var scm_ArrayBuilder$ofUnit = $rt_classWithoutFields(scm_ArrayBuilder);
    $java.scm_ArrayBuilder$ofUnit_addAll = function($this, $xs) {
        $this.$size9 = $this.$size9 + ($xs.$iterator0()).$size() | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofUnit_resize = function($this, $size) {};
    $java.scm_ArrayBuilder$ofUnit_result = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$size9;
        var$2 = $rt_createArray(sr_BoxedUnit, var$1);
        var$3 = var$2.data;
        var$4 = 0;
        while (var$4 < var$1) {
            var$3[var$4] = sr_BoxedUnit_UNIT;
            var$4 = var$4 + 1 | 0;
        }
        return var$2;
    };
    $java.scm_ArrayBuilder$ofUnit_addAll0 = function($this, $xs, $offset, $length) {
        $this.$size9 = $this.$size9 + $length | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofUnit_addAll1 = function($this, $xs) {
        return $java.scm_ArrayBuilder$ofUnit_addAll($this, $xs);
    };
    $java.scm_ArrayBuilder$ofUnit_addAll2 = function($this, $xs) {
        return $java.scm_ArrayBuilder$ofUnit_addAll($this, $xs);
    };
    $java.scm_ArrayBuilder$ofUnit_addOne = function($this, $elem) {
        $this.$size9 = $this.$size9 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofUnit_elems = function($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    };
    function scm_ArrayBuilder$ofRef() {
        var a = this; scm_ArrayBuilder.call(a);
        a.$ct = null;
        a.$elems13 = null;
    }
    function scm_ArrayBuilder$ofRef__init_(var_0) {
        var var_1 = new scm_ArrayBuilder$ofRef();
        $java.scm_ArrayBuilder$ofRef__init_(var_1, var_0);
        return var_1;
    }
    $java.scm_ArrayBuilder$ofRef_mkArray = function($this, $size) {
        var var$2, var$3;
        var$2 = $this.$capacity0;
        if (var$2 == $size && var$2 > 0)
            return $this.$elems13;
        var$3 = $this.$elems13;
        if (var$3 !== null)
            return ju_Arrays_copyOf(var$3, $size);
        return $this.$ct.$newArray($size);
    };
    $java.scm_ArrayBuilder$ofRef_resize = function($this, $size) {
        $this.$elems13 = $java.scm_ArrayBuilder$ofRef_mkArray($this, $size);
        $this.$capacity0 = $size;
    };
    $java.scm_ArrayBuilder$ofRef_result = function($this) {
        var var$1, var$2;
        var$1 = $this.$capacity0;
        if (var$1 && var$1 == $this.$size9) {
            $this.$capacity0 = 0;
            var$2 = $this.$elems13;
            $this.$elems13 = null;
        } else
            var$2 = $java.scm_ArrayBuilder$ofRef_mkArray($this, $this.$size9);
        return var$2;
    };
    $java.scm_ArrayBuilder$ofRef_addOne = function($this, $elem) {
        var var$2, var$3;
        $java.scm_ArrayBuilder_ensureSize($this, $this.$size9 + 1 | 0);
        var$2 = $this.$elems13.data;
        var$3 = $this.$size9;
        var$2[var$3] = $elem;
        $this.$size9 = var$3 + 1 | 0;
        return $this;
    };
    $java.scm_ArrayBuilder$ofRef_elems = function($this) {
        return $this.$elems13;
    };
    $java.scm_ArrayBuilder$ofRef__init_ = function($this, $ct) {
        $this.$ct = $ct;
        scm_ArrayBuilder__init_($this);
    };
    function oncie_StringLiteral() {
        var a = this; oncie_Expression.call(a);
        a.$value25 = null;
        a.$position144 = null;
    }
    function oncie_StringLiteral__init_(var_0, var_1) {
        var var_2 = new oncie_StringLiteral();
        $java.oncie_StringLiteral__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_StringLiteral_value($this) {
        return $this.$value25;
    }
    $java.oncie_StringLiteral_position = function($this) {
        return $this.$position144;
    };
    $java.oncie_StringLiteral_asCanonicalStringVal = function($this) {
        return $this.$value25;
    };
    $java.oncie_StringLiteral_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_StringLiteral$$anon$6;
        $java.oncie_StringLiteral__init_(var$1, $this.$value25, $this.$position144);
        return var$1;
    };
    $java.oncie_StringLiteral_copy = function($this, $value, $position) {
        return oncie_StringLiteral__init_($value, $position);
    };
    $java.oncie_StringLiteral_productPrefix = function($this) {
        return $rt_s(2341);
    };
    $java.oncie_StringLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_StringLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value25;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_StringLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StringLiteral_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_StringLiteral;
    };
    $java.oncie_StringLiteral_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StringLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StringLiteral_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_StringLiteral) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$value25;
                        $x$1 = $x$1.$value25;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_StringLiteral))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_StringLiteral__init_ = function($this, $value, $position) {
        $this.$value25 = $value;
        $this.$position144 = $position;
        $java.oncie_Expression__init_($this);
    };
    $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$2$lambda$_499_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$2$lambda$_499_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$1.$expression1();
        var$3 = var$1.$alias();
        var$4 = new $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$3$lambda$_498_0;
        var$4.$_0440 = var$2;
        var$3 = s_Option_getOrElse(var$3, var$4);
        return $java.oncia_CommandResultItem__init_(var$2.$name4, var$3, var$1.$position2());
    };
    function oncias_SemanticAnalysisTooling$requireFeatureSupport$lambda$_69_0() {
        var a = this; jl_Object.call(a);
        a.$_0289 = null;
        a.$_189 = null;
        a.$_235 = null;
    }
    $java.oncias_SemanticAnalysisTooling$requireFeatureSupport$lambda$_69_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$0.$_0289;
        var$3 = var$0.$_189;
        var$4 = var$0.$_235;
        if (var$1.$features1.$contains0(var$2))
            var$1 = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
        else {
            var$5 = oncias_SemanticCheckResult$_MODULE$;
            var$6 = new $java.oncias_FeatureError;
            var$7 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$7);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$7, var$3), $rt_s(2342)), var$2), 46);
            $java.oncias_FeatureError__init_(var$6, jl_AbstractStringBuilder_toString(var$7), var$2, var$4);
            var$1 = oncias_SemanticCheckResult$_error(var$5, var$1, var$6);
        }
        return var$1;
    };
    $java.oncirr_mergeInPredicates$$$anonfun$collectInPredicates$2$lambda$_31_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0362 = null;
        a.$_1110 = null;
        a.$_241 = null;
    };
    $java.oncirr_mergeInPredicates$$$anonfun$collectInPredicates$2$lambda$_31_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0362;
        var$3 = var$0.$_1110;
        var$4 = var$0.$_241;
        oncirr_mergeInPredicates$_$callClinit();
        var$5 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        return s_Predef$ArrowAssoc$_$minus$greater$extension(var$5, var$1, sc_SeqOps_distinct$(var$2.$apply0(var$3.$apply(var$1), var$4.$apply(var$1))));
    };
    var scm_Iterable$ = $rt_classWithoutFields(sc_IterableFactory$Delegate);
    var scm_Iterable$_MODULE$ = null;
    function scm_Iterable$_$callClinit() {
        scm_Iterable$_$callClinit = $rt_eraseClinit(scm_Iterable$);
        $java.scm_Iterable$__clinit_();
    }
    $java.scm_Iterable$__clinit_ = function() {
        var var$1;
        var$1 = new scm_Iterable$;
        scm_Iterable$_$callClinit();
        sc_IterableFactory$Delegate__init_0(var$1, scm_ArrayBuffer$_MODULE$);
        scm_Iterable$_MODULE$ = var$1;
    };
    $java.oncia_MergeAction = $rt_classWithoutFields(0);
    $java.oncia_OnMatch = function() {
        var a = this; jl_Object.call(a);
        a.$action3 = null;
        a.$position193 = null;
    };
    $java.oncia_OnMatch__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_OnMatch();
        $java.oncia_OnMatch__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_OnMatch_position = function($this) {
        return $this.$position193;
    };
    $java.oncia_OnMatch_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this.$action3);
    };
    $java.oncia_OnMatch_productPrefix = function($this) {
        return $rt_s(1560);
    };
    $java.oncia_OnMatch_productArity = function($this) {
        return 1;
    };
    $java.oncia_OnMatch_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$action3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_OnMatch_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OnMatch_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OnMatch_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OnMatch_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_OnMatch) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$action3;
                        $x$1 = $x$1.$action3;
                        if (var$2 !== null) {
                            if (!$java.oncia_SetClause_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_OnMatch))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_OnMatch_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_OnMatch__init_0 = function($this, $action, $position) {
        $this.$action3 = $action;
        $this.$position193 = $position;
    };
    $java.oncia_OnCreate = function() {
        var a = this; jl_Object.call(a);
        a.$action4 = null;
        a.$position194 = null;
    };
    $java.oncia_OnCreate__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_OnCreate();
        $java.oncia_OnCreate__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_OnCreate_position = function($this) {
        return $this.$position194;
    };
    $java.oncia_OnCreate_semanticCheck = function($this) {
        return oncia_Clause_semanticCheck$($this.$action4);
    };
    $java.oncia_OnCreate_productPrefix = function($this) {
        return $rt_s(1559);
    };
    $java.oncia_OnCreate_productArity = function($this) {
        return 1;
    };
    $java.oncia_OnCreate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$action4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_OnCreate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OnCreate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OnCreate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_OnCreate_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_OnCreate) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$action4;
                        $x$1 = $x$1.$action4;
                        if (var$2 !== null) {
                            if (!$java.oncia_SetClause_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_OnCreate))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_OnCreate_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_OnCreate__init_0 = function($this, $action, $position) {
        $this.$action4 = $action;
        $this.$position194 = $position;
    };
    $java.sm_Ordering$StringOrdering = $rt_classWithoutFields(0);
    var sm_Ordering$String$ = $rt_classWithoutFields();
    var sm_Ordering$String$_MODULE$ = null;
    function sm_Ordering$String$__clinit_() {
        sm_Ordering$String$_MODULE$ = new sm_Ordering$String$;
    }
    $java.sm_Ordering$String$_compare = function($this, $x, $y) {
        var var$3, var$4, var$5;
        a: {
            $x = $x;
            $y = $y;
            if ($x === $y)
                var$3 = 0;
            else {
                var$4 = jl_Math_min(jl_String_length($x), jl_String_length($y));
                var$5 = 0;
                while (true) {
                    if (var$5 >= var$4) {
                        var$3 = jl_String_length($x) - jl_String_length($y) | 0;
                        break a;
                    }
                    var$3 = jl_String_charAt($x, var$5) - jl_String_charAt($y, var$5) | 0;
                    if (var$3)
                        break;
                    var$5 = var$5 + 1 | 0;
                }
            }
        }
        return var$3;
    };
    function oncias_Scope$dumpTree$lambda$_24_0() {
        var a = this; jl_Object.call(a);
        a.$_0223 = null;
        a.$_159 = null;
        a.$_224 = null;
    }
    $java.oncias_Scope$dumpTree$lambda$_24_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$0.$_0223;
        var$3 = var$0.$_159;
        var$4 = var$0.$_224;
        var$5 = sc_IterableOnceOps_toSeq$(($java.oncias_Symbol_references(var$2.$symbolTable.$apply(var$1))).$map1(new $java.oncias_Symbol$positionsAndUniqueIdString$lambda$_13_0));
        sm_Ordering$Int$_$callClinit();
        var$2 = sm_Ordering$Int$_MODULE$;
        var$6 = sm_Ordering$String$_MODULE$;
        var$7 = new $java.sm_Ordering$Tuple2Ordering;
        var$7.$ord1 = var$2;
        var$7.$ord2 = var$6;
        var$2 = sc_AbstractIterable_mkString0((var$5.$sorted1(var$7)).$map1(new $java.oncias_Scope$$anonfun$dumpTree$1$lambda$_48_0), $rt_s(162));
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, var$4), var$1), $rt_s(10)), var$2), $rt_s(66));
        return scm_StringBuilder_append(var$3, jl_AbstractStringBuilder_toString(var$6));
    };
    function oncias_Scope$dumpTree$lambda$_24_1() {
        var a = this; jl_Object.call(a);
        a.$_0224 = null;
        a.$_160 = null;
    }
    $java.oncias_Scope$dumpTree$lambda$_24_1_apply = function(var$0, var$1) {
        oncias_Scope_dumpSingle(var$1, var$0.$_0224, var$0.$_160);
        return sr_BoxedUnit_UNIT;
    };
    $java.oncief_Abs$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Abs$_MODULE$ = null;
    $java.oncief_Abs$_signatures = null;
    $java.oncief_Abs$_$callClinit = function() {
        $java.oncief_Abs$_$callClinit = $rt_eraseClinit($java.oncief_Abs$);
        $java.oncief_Abs$__clinit_();
    };
    $java.oncief_Abs$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_Abs$;
        $java.oncief_Abs$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Abs$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Abs$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$11[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_ClosedDynamicUnionType__init_((s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), $rt_s(2343), $java.oncief_Category$_NUMERIC);
        $java.oncief_Abs$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Abs$_name = function($this) {
        return $rt_s(2344);
    };
    $java.oncief_Abs$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Abs$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Abs$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Abs$_hashCode = function($this) {
        return 65618;
    };
    $java.oncief_Abs$_toString = function($this) {
        return $rt_s(2345);
    };
    $java.oncief_Abs$_signatures0 = function($this) {
        $java.oncief_Abs$_$callClinit();
        return $java.oncief_Abs$_signatures;
    };
    $java.oncief_Acos$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Acos$_MODULE$ = null;
    $java.oncief_Acos$_signatures = null;
    $java.oncief_Acos$_$callClinit = function() {
        $java.oncief_Acos$_$callClinit = $rt_eraseClinit($java.oncief_Acos$);
        $java.oncief_Acos$__clinit_();
    };
    $java.oncief_Acos$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Acos$;
        $java.oncief_Acos$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Acos$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Acos$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2346), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Acos$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Acos$_name = function($this) {
        return $rt_s(2347);
    };
    $java.oncief_Acos$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Acos$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Acos$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Acos$_hashCode = function($this) {
        return 2035110;
    };
    $java.oncief_Acos$_toString = function($this) {
        return $rt_s(2348);
    };
    $java.oncief_Acos$_signatures0 = function($this) {
        $java.oncief_Acos$_$callClinit();
        return $java.oncief_Acos$_signatures;
    };
    $java.oncief_Asin$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Asin$_MODULE$ = null;
    $java.oncief_Asin$_signatures = null;
    $java.oncief_Asin$_$callClinit = function() {
        $java.oncief_Asin$_$callClinit = $rt_eraseClinit($java.oncief_Asin$);
        $java.oncief_Asin$__clinit_();
    };
    $java.oncief_Asin$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Asin$;
        $java.oncief_Asin$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Asin$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Asin$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2349), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Asin$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Asin$_name = function($this) {
        return $rt_s(2350);
    };
    $java.oncief_Asin$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Asin$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Asin$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Asin$_hashCode = function($this) {
        return 2050295;
    };
    $java.oncief_Asin$_toString = function($this) {
        return $rt_s(2351);
    };
    $java.oncief_Asin$_signatures0 = function($this) {
        $java.oncief_Asin$_$callClinit();
        return $java.oncief_Asin$_signatures;
    };
    $java.oncief_Atan$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Atan$_MODULE$ = null;
    $java.oncief_Atan$_signatures = null;
    $java.oncief_Atan$_$callClinit = function() {
        $java.oncief_Atan$_$callClinit = $rt_eraseClinit($java.oncief_Atan$);
        $java.oncief_Atan$__clinit_();
    };
    $java.oncief_Atan$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Atan$;
        $java.oncief_Atan$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Atan$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Atan$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2352), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Atan$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Atan$_name = function($this) {
        return $rt_s(2353);
    };
    $java.oncief_Atan$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Atan$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Atan$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Atan$_hashCode = function($this) {
        return 2051008;
    };
    $java.oncief_Atan$_toString = function($this) {
        return $rt_s(2354);
    };
    $java.oncief_Atan$_signatures0 = function($this) {
        $java.oncief_Atan$_$callClinit();
        return $java.oncief_Atan$_signatures;
    };
    $java.oncief_Atan2$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Atan2$_MODULE$ = null;
    $java.oncief_Atan2$_signatures = null;
    $java.oncief_Atan2$_$callClinit = function() {
        $java.oncief_Atan2$_$callClinit = $rt_eraseClinit($java.oncief_Atan2$);
        $java.oncief_Atan2$__clinit_();
    };
    $java.oncief_Atan2$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$6, var$9, var$10, $x$3;
        var$1 = new $java.oncief_Atan2$;
        $java.oncief_Atan2$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Atan2$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Atan2$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2355), $rt_s(2356)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$6 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_FloatType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$10[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$6, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $x$2, $rt_s(2357), $java.oncief_Category$_TRIGONOMETRIC, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Atan2$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Atan2$_name = function($this) {
        return $rt_s(2358);
    };
    $java.oncief_Atan2$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Atan2$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Atan2$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Atan2$_hashCode = function($this) {
        return 63581298;
    };
    $java.oncief_Atan2$_toString = function($this) {
        return $rt_s(2359);
    };
    $java.oncief_Atan2$_signatures0 = function($this) {
        $java.oncief_Atan2$_$callClinit();
        return $java.oncief_Atan2$_signatures;
    };
    $java.oncief_AggregatingFunction = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Avg$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_Avg$_MODULE$ = null;
    $java.oncief_Avg$_signatures = null;
    $java.oncief_Avg$_$callClinit = function() {
        $java.oncief_Avg$_$callClinit = $rt_eraseClinit($java.oncief_Avg$);
        $java.oncief_Avg$__clinit_();
    };
    $java.oncief_Avg$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_Avg$;
        $java.oncief_Avg$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Avg$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Avg$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 3);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$11[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$11[2] = $java.oncius_package$_CTDuration0(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_ClosedDynamicUnionType__init_((s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), $rt_s(2360), $java.oncief_Category$_AGGREGATING);
        $java.oncief_Avg$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Avg$_name = function($this) {
        return $rt_s(2361);
    };
    $java.oncief_Avg$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Avg$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Avg$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Avg$_hashCode = function($this) {
        return 66226;
    };
    $java.oncief_Avg$_toString = function($this) {
        return $rt_s(2362);
    };
    $java.oncief_Avg$_signatures0 = function($this) {
        $java.oncief_Avg$_$callClinit();
        return $java.oncief_Avg$_signatures;
    };
    $java.oncief_Ceil$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Ceil$_MODULE$ = null;
    $java.oncief_Ceil$_signatures = null;
    $java.oncief_Ceil$_$callClinit = function() {
        $java.oncief_Ceil$_$callClinit = $rt_eraseClinit($java.oncief_Ceil$);
        $java.oncief_Ceil$__clinit_();
    };
    $java.oncief_Ceil$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Ceil$;
        $java.oncief_Ceil$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Ceil$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Ceil$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2363), $java.oncief_Category$_NUMERIC);
        $java.oncief_Ceil$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Ceil$_name = function($this) {
        return $rt_s(2364);
    };
    $java.oncief_Ceil$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Ceil$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Ceil$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Ceil$_hashCode = function($this) {
        return 2096421;
    };
    $java.oncief_Ceil$_toString = function($this) {
        return $rt_s(2365);
    };
    $java.oncief_Ceil$_signatures0 = function($this) {
        $java.oncief_Ceil$_$callClinit();
        return $java.oncief_Ceil$_signatures;
    };
    $java.oncief_CharLength$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_CharLength$_MODULE$ = null;
    $java.oncief_CharLength$_signatures = null;
    $java.oncief_CharLength$_$callClinit = function() {
        $java.oncief_CharLength$_$callClinit = $rt_eraseClinit($java.oncief_CharLength$);
        $java.oncief_CharLength$__clinit_();
    };
    $java.oncief_CharLength$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_CharLength$;
        $java.oncief_CharLength$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_CharLength$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_CharLength$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2366), $java.oncief_Category$_SCALAR);
        $java.oncief_CharLength$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_CharLength$_name = function($this) {
        return $rt_s(2367);
    };
    $java.oncief_CharLength$_productArity = function($this) {
        return 0;
    };
    $java.oncief_CharLength$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_CharLength$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_CharLength$_hashCode = function($this) {
        return (-1655620100);
    };
    $java.oncief_CharLength$_toString = function($this) {
        return $rt_s(2368);
    };
    $java.oncief_CharLength$_signatures0 = function($this) {
        $java.oncief_CharLength$_$callClinit();
        return $java.oncief_CharLength$_signatures;
    };
    $java.oncief_CharacterLength$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_CharacterLength$_MODULE$ = null;
    $java.oncief_CharacterLength$_signatures = null;
    $java.oncief_CharacterLength$_$callClinit = function() {
        $java.oncief_CharacterLength$_$callClinit = $rt_eraseClinit($java.oncief_CharacterLength$);
        $java.oncief_CharacterLength$__clinit_();
    };
    $java.oncief_CharacterLength$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_CharacterLength$;
        $java.oncief_CharacterLength$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_CharacterLength$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_CharacterLength$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2366), $java.oncief_Category$_SCALAR);
        $java.oncief_CharacterLength$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_CharacterLength$_name = function($this) {
        return $rt_s(2369);
    };
    $java.oncief_CharacterLength$_productArity = function($this) {
        return 0;
    };
    $java.oncief_CharacterLength$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_CharacterLength$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_CharacterLength$_hashCode = function($this) {
        return 925423439;
    };
    $java.oncief_CharacterLength$_toString = function($this) {
        return $rt_s(2370);
    };
    $java.oncief_CharacterLength$_signatures0 = function($this) {
        $java.oncief_CharacterLength$_$callClinit();
        return $java.oncief_CharacterLength$_signatures;
    };
    $java.oncief_Coalesce$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Coalesce$_MODULE$ = null;
    $java.oncief_Coalesce$_signatures = null;
    $java.oncief_Coalesce$_$callClinit = function() {
        $java.oncief_Coalesce$_$callClinit = $rt_eraseClinit($java.oncief_Coalesce$);
        $java.oncief_Coalesce$__clinit_();
    };
    $java.oncief_Coalesce$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Coalesce$;
        $java.oncief_Coalesce$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Coalesce$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Coalesce$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTAny(oncius_package$_MODULE$), $rt_s(2371), $java.oncief_Category$_SCALAR);
        $java.oncief_Coalesce$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Coalesce$_name = function($this) {
        return $rt_s(2372);
    };
    $java.oncief_Coalesce$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Coalesce$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Coalesce$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Coalesce$_hashCode = function($this) {
        return (-882240569);
    };
    $java.oncief_Coalesce$_toString = function($this) {
        return $rt_s(2373);
    };
    $java.oncief_Coalesce$_signatures0 = function($this) {
        $java.oncief_Coalesce$_$callClinit();
        return $java.oncief_Coalesce$_signatures;
    };
    $java.oncief_Collect$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_Collect$_MODULE$ = null;
    $java.oncief_Collect$_signatures = null;
    $java.oncief_Collect$_$callClinit = function() {
        $java.oncief_Collect$_$callClinit = $rt_eraseClinit($java.oncief_Collect$);
        $java.oncief_Collect$__clinit_();
    };
    $java.oncief_Collect$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_Collect$;
        $java.oncief_Collect$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Collect$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Collect$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$8 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTList(var$8, oncius_package$_CTAny(var$8)), $rt_s(2374), $java.oncief_Category$_AGGREGATING);
        $java.oncief_Collect$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Collect$_name = function($this) {
        return $rt_s(2375);
    };
    $java.oncief_Collect$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Collect$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Collect$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Collect$_hashCode = function($this) {
        return (-1680869110);
    };
    $java.oncief_Collect$_toString = function($this) {
        return $rt_s(2376);
    };
    $java.oncief_Collect$_signatures0 = function($this) {
        $java.oncief_Collect$_$callClinit();
        return $java.oncief_Collect$_signatures;
    };
    $java.oncief_Cos$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Cos$_MODULE$ = null;
    $java.oncief_Cos$_signatures = null;
    $java.oncief_Cos$_$callClinit = function() {
        $java.oncief_Cos$_$callClinit = $rt_eraseClinit($java.oncief_Cos$);
        $java.oncief_Cos$__clinit_();
    };
    $java.oncief_Cos$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Cos$;
        $java.oncief_Cos$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Cos$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Cos$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2377), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Cos$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Cos$_name = function($this) {
        return $rt_s(2378);
    };
    $java.oncief_Cos$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Cos$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Cos$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Cos$_hashCode = function($this) {
        return 67943;
    };
    $java.oncief_Cos$_toString = function($this) {
        return $rt_s(2379);
    };
    $java.oncief_Cos$_signatures0 = function($this) {
        $java.oncief_Cos$_$callClinit();
        return $java.oncief_Cos$_signatures;
    };
    $java.oncief_Cot$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Cot$_MODULE$ = null;
    $java.oncief_Cot$_signatures = null;
    $java.oncief_Cot$_$callClinit = function() {
        $java.oncief_Cot$_$callClinit = $rt_eraseClinit($java.oncief_Cot$);
        $java.oncief_Cot$__clinit_();
    };
    $java.oncief_Cot$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Cot$;
        $java.oncief_Cot$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Cot$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Cot$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2380), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Cot$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Cot$_name = function($this) {
        return $rt_s(2381);
    };
    $java.oncief_Cot$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Cot$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Cot$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Cot$_hashCode = function($this) {
        return 67944;
    };
    $java.oncief_Cot$_toString = function($this) {
        return $rt_s(2382);
    };
    $java.oncief_Cot$_signatures0 = function($this) {
        $java.oncief_Cot$_$callClinit();
        return $java.oncief_Cot$_signatures;
    };
    $java.oncief_Count$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_Count$_MODULE$ = null;
    $java.oncief_Count$_signatures = null;
    $java.oncief_Count$_$callClinit = function() {
        $java.oncief_Count$_$callClinit = $rt_eraseClinit($java.oncief_Count$);
        $java.oncief_Count$__clinit_();
    };
    $java.oncief_Count$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Count$;
        $java.oncief_Count$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Count$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Count$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2383), $java.oncief_Category$_AGGREGATING);
        $java.oncief_Count$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Count$_name = function($this) {
        return $rt_s(2384);
    };
    $java.oncief_Count$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Count$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Count$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Count$_hashCode = function($this) {
        return 65298671;
    };
    $java.oncief_Count$_toString = function($this) {
        return $rt_s(2385);
    };
    $java.oncief_Count$_signatures0 = function($this) {
        $java.oncief_Count$_$callClinit();
        return $java.oncief_Count$_signatures;
    };
    $java.oncief_Degrees$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Degrees$_MODULE$ = null;
    $java.oncief_Degrees$_signatures = null;
    $java.oncief_Degrees$_$callClinit = function() {
        $java.oncief_Degrees$_$callClinit = $rt_eraseClinit($java.oncief_Degrees$);
        $java.oncief_Degrees$__clinit_();
    };
    $java.oncief_Degrees$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Degrees$;
        $java.oncief_Degrees$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Degrees$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Degrees$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2386), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Degrees$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Degrees$_name = function($this) {
        return $rt_s(2387);
    };
    $java.oncief_Degrees$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Degrees$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Degrees$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Degrees$_hashCode = function($this) {
        return (-1084095737);
    };
    $java.oncief_Degrees$_toString = function($this) {
        return $rt_s(2388);
    };
    $java.oncief_Degrees$_signatures0 = function($this) {
        $java.oncief_Degrees$_$callClinit();
        return $java.oncief_Degrees$_signatures;
    };
    $java.oncief_Distance$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Distance$_MODULE$ = null;
    $java.oncief_Distance$_name = null;
    $java.oncief_Distance$_signatures = null;
    $java.oncief_Distance$_$callClinit = function() {
        $java.oncief_Distance$_$callClinit = $rt_eraseClinit($java.oncief_Distance$);
        $java.oncief_Distance$__clinit_();
    };
    $java.oncief_Distance$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$7, var$9, var$10, $x$3;
        var$1 = new $java.oncief_Distance$;
        $java.oncief_Distance$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Distance$_MODULE$ = var$1;
        $java.oncief_Distance$_name = $rt_s(2389);
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Distance$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2390), $rt_s(2391)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$7 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_PointType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = $java.oncius_package$_CTPoint0(oncius_package$_MODULE$);
        var$10[1] = $java.oncius_package$_CTPoint0(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$7, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $x$2, $rt_s(2392), $java.oncief_Category$_SPATIAL, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Distance$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Distance$_name0 = function($this) {
        $java.oncief_Distance$_$callClinit();
        return $java.oncief_Distance$_name;
    };
    $java.oncief_Distance$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Distance$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Distance$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Distance$_hashCode = function($this) {
        return 353103893;
    };
    $java.oncief_Distance$_toString = function($this) {
        return $rt_s(2393);
    };
    $java.oncief_Distance$_signatures0 = function($this) {
        $java.oncief_Distance$_$callClinit();
        return $java.oncief_Distance$_signatures;
    };
    $java.oncief_E$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_E$_MODULE$ = null;
    $java.oncief_E$_signatures = null;
    $java.oncief_E$_$callClinit = function() {
        $java.oncief_E$_$callClinit = $rt_eraseClinit($java.oncief_E$);
        $java.oncief_E$__clinit_();
    };
    $java.oncief_E$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_E$;
        $java.oncief_E$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_E$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_E$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_noArg(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2394), $java.oncief_Category$_LOGARITHMIC);
        $java.oncief_E$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_E$_name = function($this) {
        return $rt_s(2395);
    };
    $java.oncief_E$_productArity = function($this) {
        return 0;
    };
    $java.oncief_E$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_E$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_E$_hashCode = function($this) {
        return 69;
    };
    $java.oncief_E$_toString = function($this) {
        return $rt_s(2396);
    };
    $java.oncief_E$_signatures0 = function($this) {
        $java.oncief_E$_$callClinit();
        return $java.oncief_E$_signatures;
    };
    $java.oncief_ElementId$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ElementId$_MODULE$ = null;
    $java.oncief_ElementId$_signatures = null;
    $java.oncief_ElementId$_$callClinit = function() {
        $java.oncief_ElementId$_$callClinit = $rt_eraseClinit($java.oncief_ElementId$);
        $java.oncief_ElementId$__clinit_();
    };
    $java.oncief_ElementId$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_ElementId$;
        $java.oncief_ElementId$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ElementId$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ElementId$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTNode(oncius_package$_MODULE$);
        var$11[1] = oncius_package$_CTRelationship(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2397), $java.oncief_Category$_SCALAR);
        $java.oncief_ElementId$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ElementId$_name = function($this) {
        return $rt_s(2398);
    };
    $java.oncief_ElementId$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ElementId$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ElementId$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ElementId$_hashCode = function($this) {
        return 1745451287;
    };
    $java.oncief_ElementId$_toString = function($this) {
        return $rt_s(2399);
    };
    $java.oncief_ElementId$_signatures0 = function($this) {
        $java.oncief_ElementId$_$callClinit();
        return $java.oncief_ElementId$_signatures;
    };
    $java.oncief_EndNode$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_EndNode$_MODULE$ = null;
    $java.oncief_EndNode$_signatures = null;
    $java.oncief_EndNode$_$callClinit = function() {
        $java.oncief_EndNode$_$callClinit = $rt_eraseClinit($java.oncief_EndNode$);
        $java.oncief_EndNode$__clinit_();
    };
    $java.oncief_EndNode$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_EndNode$;
        $java.oncief_EndNode$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_EndNode$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_EndNode$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTRelationship(oncius_package$_MODULE$), oncius_package$_CTNode(oncius_package$_MODULE$), $rt_s(2400), $java.oncief_Category$_SCALAR);
        $java.oncief_EndNode$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_EndNode$_name = function($this) {
        return $rt_s(2401);
    };
    $java.oncief_EndNode$_productArity = function($this) {
        return 0;
    };
    $java.oncief_EndNode$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_EndNode$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_EndNode$_hashCode = function($this) {
        return 57236829;
    };
    $java.oncief_EndNode$_toString = function($this) {
        return $rt_s(2402);
    };
    $java.oncief_EndNode$_signatures0 = function($this) {
        $java.oncief_EndNode$_$callClinit();
        return $java.oncief_EndNode$_signatures;
    };
    $java.oncief_Exists$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Exists$_MODULE$ = null;
    $java.oncief_Exists$_signatures = null;
    $java.oncief_Exists$_$callClinit = function() {
        $java.oncief_Exists$_$callClinit = $rt_eraseClinit($java.oncief_Exists$);
        $java.oncief_Exists$__clinit_();
    };
    $java.oncief_Exists$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Exists$;
        $java.oncief_Exists$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Exists$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Exists$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTBoolean(oncius_package$_MODULE$), $rt_s(2403), $java.oncief_Category$_PREDICATE);
        $java.oncief_Exists$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Exists$_name = function($this) {
        return $rt_s(1378);
    };
    $java.oncief_Exists$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Exists$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Exists$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Exists$_hashCode = function($this) {
        return 2089476220;
    };
    $java.oncief_Exists$_toString = function($this) {
        return $rt_s(2404);
    };
    $java.oncief_Exists$_signatures0 = function($this) {
        $java.oncief_Exists$_$callClinit();
        return $java.oncief_Exists$_signatures;
    };
    $java.oncief_Exp$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Exp$_MODULE$ = null;
    $java.oncief_Exp$_signatures = null;
    $java.oncief_Exp$_$callClinit = function() {
        $java.oncief_Exp$_$callClinit = $rt_eraseClinit($java.oncief_Exp$);
        $java.oncief_Exp$__clinit_();
    };
    $java.oncief_Exp$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Exp$;
        $java.oncief_Exp$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Exp$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Exp$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2405), $java.oncief_Category$_LOGARITHMIC);
        $java.oncief_Exp$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Exp$_name = function($this) {
        return $rt_s(2406);
    };
    $java.oncief_Exp$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Exp$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Exp$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Exp$_hashCode = function($this) {
        return 70141;
    };
    $java.oncief_Exp$_toString = function($this) {
        return $rt_s(2407);
    };
    $java.oncief_Exp$_signatures0 = function($this) {
        $java.oncief_Exp$_$callClinit();
        return $java.oncief_Exp$_signatures;
    };
    $java.oncief_File$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_File$_MODULE$ = null;
    $java.oncief_File$_signatures = null;
    $java.oncief_File$_$callClinit = function() {
        $java.oncief_File$_$callClinit = $rt_eraseClinit($java.oncief_File$);
        $java.oncief_File$__clinit_();
    };
    $java.oncief_File$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_File$;
        $java.oncief_File$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_File$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_File$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_noArg(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2408), $java.oncief_Category$_SCALAR);
        $java.oncief_File$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_File$_name = function($this) {
        return $rt_s(2409);
    };
    $java.oncief_File$_productArity = function($this) {
        return 0;
    };
    $java.oncief_File$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_File$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_File$_hashCode = function($this) {
        return 2189724;
    };
    $java.oncief_File$_toString = function($this) {
        return $rt_s(2410);
    };
    $java.oncief_File$_signatures0 = function($this) {
        $java.oncief_File$_$callClinit();
        return $java.oncief_File$_signatures;
    };
    $java.oncief_Floor$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Floor$_MODULE$ = null;
    $java.oncief_Floor$_signatures = null;
    $java.oncief_Floor$_$callClinit = function() {
        $java.oncief_Floor$_$callClinit = $rt_eraseClinit($java.oncief_Floor$);
        $java.oncief_Floor$__clinit_();
    };
    $java.oncief_Floor$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Floor$;
        $java.oncief_Floor$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Floor$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Floor$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2411), $java.oncief_Category$_NUMERIC);
        $java.oncief_Floor$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Floor$_name = function($this) {
        return $rt_s(2412);
    };
    $java.oncief_Floor$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Floor$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Floor$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Floor$_hashCode = function($this) {
        return 67974124;
    };
    $java.oncief_Floor$_toString = function($this) {
        return $rt_s(2413);
    };
    $java.oncief_Floor$_signatures0 = function($this) {
        $java.oncief_Floor$_$callClinit();
        return $java.oncief_Floor$_signatures;
    };
    $java.oncief_Haversin$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Haversin$_MODULE$ = null;
    $java.oncief_Haversin$_signatures = null;
    $java.oncief_Haversin$_$callClinit = function() {
        $java.oncief_Haversin$_$callClinit = $rt_eraseClinit($java.oncief_Haversin$);
        $java.oncief_Haversin$__clinit_();
    };
    $java.oncief_Haversin$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Haversin$;
        $java.oncief_Haversin$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Haversin$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Haversin$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2414), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Haversin$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Haversin$_name = function($this) {
        return $rt_s(2415);
    };
    $java.oncief_Haversin$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Haversin$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Haversin$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Haversin$_hashCode = function($this) {
        return 296861870;
    };
    $java.oncief_Haversin$_toString = function($this) {
        return $rt_s(2416);
    };
    $java.oncief_Haversin$_signatures0 = function($this) {
        $java.oncief_Haversin$_$callClinit();
        return $java.oncief_Haversin$_signatures;
    };
    $java.oncief_Head$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Head$_MODULE$ = null;
    $java.oncief_Head$_name = null;
    $java.oncief_Head$_signatures = null;
    $java.oncief_Head$_$callClinit = function() {
        $java.oncief_Head$_$callClinit = $rt_eraseClinit($java.oncief_Head$);
        $java.oncief_Head$__clinit_();
    };
    $java.oncief_Head$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$7, $x$3, var$8, $x$2, $x$4, var$11, var$12;
        var$1 = new $java.oncief_Head$;
        $java.oncief_Head$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Head$_MODULE$ = var$1;
        $java.oncief_Head$_name = $rt_s(2417);
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Head$_MODULE$;
        $x$7 = s_package$_Vector0(s_package$_MODULE$);
        $x$3 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(jl_String, 1);
        var$8.data[0] = $rt_s(2418);
        $x$2 = $x$7.$from0(sr_ScalaRunTime$_wrapRefArray($x$3, var$8));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$7 = sr_ScalaRunTime$_MODULE$;
        var$11 = $rt_createArray(oncius_ListType, 1);
        var$8 = var$11.data;
        oncius_package$_$callClinit();
        var$12 = oncius_package$_MODULE$;
        var$8[0] = oncius_package$_CTList(var$12, oncius_package$_CTAny(var$12));
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$7, var$11));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTAny(oncius_package$_MODULE$), $x$2, $rt_s(2419), $java.oncief_Category$_SCALAR, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Head$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Head$_name0 = function($this) {
        $java.oncief_Head$_$callClinit();
        return $java.oncief_Head$_name;
    };
    $java.oncief_Head$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Head$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Head$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Head$_hashCode = function($this) {
        return 2245120;
    };
    $java.oncief_Head$_toString = function($this) {
        return $rt_s(2420);
    };
    $java.oncief_Head$_signatures0 = function($this) {
        $java.oncief_Head$_$callClinit();
        return $java.oncief_Head$_signatures;
    };
    $java.oncief_Id$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Id$_MODULE$ = null;
    $java.oncief_Id$_signatures = null;
    $java.oncief_Id$_$callClinit = function() {
        $java.oncief_Id$_$callClinit = $rt_eraseClinit($java.oncief_Id$);
        $java.oncief_Id$__clinit_();
    };
    $java.oncief_Id$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_Id$;
        $java.oncief_Id$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Id$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Id$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTNode(oncius_package$_MODULE$);
        var$11[1] = oncius_package$_CTRelationship(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2421), $java.oncief_Category$_SCALAR);
        $java.oncief_Id$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Id$_name = function($this) {
        return $rt_s(94);
    };
    $java.oncief_Id$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Id$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Id$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Id$_hashCode = function($this) {
        return 2363;
    };
    $java.oncief_Id$_toString = function($this) {
        return $rt_s(2422);
    };
    $java.oncief_Id$_signatures0 = function($this) {
        $java.oncief_Id$_$callClinit();
        return $java.oncief_Id$_signatures;
    };
    $java.oncief_IsEmpty$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_IsEmpty$_MODULE$ = null;
    $java.oncief_IsEmpty$_name = null;
    $java.oncief_IsEmpty$_signatures = null;
    $java.oncief_IsEmpty$_$callClinit = function() {
        $java.oncief_IsEmpty$_$callClinit = $rt_eraseClinit($java.oncief_IsEmpty$);
        $java.oncief_IsEmpty$__clinit_();
    };
    $java.oncief_IsEmpty$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_IsEmpty$;
        $java.oncief_IsEmpty$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_IsEmpty$_MODULE$ = var$1;
        $java.oncief_IsEmpty$_name = $rt_s(2423);
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_IsEmpty$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 3);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$12 = oncius_package$_MODULE$;
        var$11[1] = oncius_package$_CTList(var$12, oncius_package$_CTAny(var$12));
        var$11[2] = oncius_package$_CTMap(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTBoolean(oncius_package$_MODULE$), $rt_s(2424), $java.oncief_Category$_PREDICATE);
        $java.oncief_IsEmpty$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_IsEmpty$_name0 = function($this) {
        $java.oncief_IsEmpty$_$callClinit();
        return $java.oncief_IsEmpty$_name;
    };
    $java.oncief_IsEmpty$_productArity = function($this) {
        return 0;
    };
    $java.oncief_IsEmpty$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_IsEmpty$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_IsEmpty$_hashCode = function($this) {
        return (-572274141);
    };
    $java.oncief_IsEmpty$_toString = function($this) {
        return $rt_s(2425);
    };
    $java.oncief_IsEmpty$_signatures0 = function($this) {
        $java.oncief_IsEmpty$_$callClinit();
        return $java.oncief_IsEmpty$_signatures;
    };
    $java.oncief_IsNaN$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_IsNaN$_MODULE$ = null;
    $java.oncief_IsNaN$_signatures = null;
    $java.oncief_IsNaN$_$callClinit = function() {
        $java.oncief_IsNaN$_$callClinit = $rt_eraseClinit($java.oncief_IsNaN$);
        $java.oncief_IsNaN$__clinit_();
    };
    $java.oncief_IsNaN$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_IsNaN$;
        $java.oncief_IsNaN$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_IsNaN$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_IsNaN$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$11[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTBoolean(oncius_package$_MODULE$), $rt_s(2426), $java.oncief_Category$_NUMERIC);
        $java.oncief_IsNaN$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_IsNaN$_name = function($this) {
        return $rt_s(2427);
    };
    $java.oncief_IsNaN$_productArity = function($this) {
        return 0;
    };
    $java.oncief_IsNaN$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_IsNaN$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_IsNaN$_hashCode = function($this) {
        return 70921041;
    };
    $java.oncief_IsNaN$_toString = function($this) {
        return $rt_s(2428);
    };
    $java.oncief_IsNaN$_signatures0 = function($this) {
        $java.oncief_IsNaN$_$callClinit();
        return $java.oncief_IsNaN$_signatures;
    };
    $java.oncief_Labels$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Labels$_MODULE$ = null;
    $java.oncief_Labels$_signatures = null;
    $java.oncief_Labels$_$callClinit = function() {
        $java.oncief_Labels$_$callClinit = $rt_eraseClinit($java.oncief_Labels$);
        $java.oncief_Labels$__clinit_();
    };
    $java.oncief_Labels$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_Labels$;
        $java.oncief_Labels$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Labels$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Labels$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = oncius_package$_CTNode(oncius_package$_MODULE$);
        var$8 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTList(var$8, oncius_package$_CTString(var$8)), $rt_s(2429), $java.oncief_Category$_LIST);
        $java.oncief_Labels$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Labels$_name = function($this) {
        return $rt_s(1819);
    };
    $java.oncief_Labels$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Labels$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Labels$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Labels$_hashCode = function($this) {
        return (-2026550241);
    };
    $java.oncief_Labels$_toString = function($this) {
        return $rt_s(2430);
    };
    $java.oncief_Labels$_signatures0 = function($this) {
        $java.oncief_Labels$_$callClinit();
        return $java.oncief_Labels$_signatures;
    };
    $java.oncief_Last$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Last$_MODULE$ = null;
    $java.oncief_Last$_signatures = null;
    $java.oncief_Last$_$callClinit = function() {
        $java.oncief_Last$_$callClinit = $rt_eraseClinit($java.oncief_Last$);
        $java.oncief_Last$__clinit_();
    };
    $java.oncief_Last$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$7, $x$3, var$8, $x$2, var$10, var$11;
        var$1 = new $java.oncief_Last$;
        $java.oncief_Last$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Last$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Last$_MODULE$;
        $x$7 = s_package$_Vector0(s_package$_MODULE$);
        $x$3 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(jl_String, 1);
        var$8.data[0] = $rt_s(2418);
        $x$2 = $x$7.$from0(sr_ScalaRunTime$_wrapRefArray($x$3, var$8));
        $x$7 = s_package$_Vector0(s_package$_MODULE$);
        var$10 = sr_ScalaRunTime$_MODULE$;
        var$11 = $rt_createArray(oncius_ListType, 1);
        var$8 = var$11.data;
        oncius_package$_$callClinit();
        $x$3 = oncius_package$_MODULE$;
        var$8[0] = oncius_package$_CTList($x$3, oncius_package$_CTAny($x$3));
        $x$3 = $x$7.$from0(sr_ScalaRunTime$_wrapRefArray(var$10, var$11));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTAny(oncius_package$_MODULE$), $x$2, $rt_s(2431), $java.oncief_Category$_SCALAR, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Last$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Last$_name = function($this) {
        return $rt_s(2432);
    };
    $java.oncief_Last$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Last$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Last$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Last$_hashCode = function($this) {
        return 2361014;
    };
    $java.oncief_Last$_toString = function($this) {
        return $rt_s(2433);
    };
    $java.oncief_Last$_signatures0 = function($this) {
        $java.oncief_Last$_$callClinit();
        return $java.oncief_Last$_signatures;
    };
    $java.oncief_Left$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Left$_MODULE$ = null;
    $java.oncief_Left$_signatures = null;
    $java.oncief_Left$_$callClinit = function() {
        $java.oncief_Left$_$callClinit = $rt_eraseClinit($java.oncief_Left$);
        $java.oncief_Left$__clinit_();
    };
    $java.oncief_Left$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$6, var$9, var$10, $x$3;
        var$1 = new $java.oncief_Left$;
        $java.oncief_Left$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Left$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Left$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2434), $rt_s(2435)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$6 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_CypherType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$6, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTString(oncius_package$_MODULE$), $x$2, $rt_s(2436), $java.oncief_Category$_STRING, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Left$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Left$_name = function($this) {
        return $rt_s(2437);
    };
    $java.oncief_Left$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Left$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Left$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Left$_hashCode = function($this) {
        return 2364455;
    };
    $java.oncief_Left$_toString = function($this) {
        return $rt_s(517);
    };
    $java.oncief_Left$_signatures0 = function($this) {
        $java.oncief_Left$_$callClinit();
        return $java.oncief_Left$_signatures;
    };
    $java.oncief_Length$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Length$_MODULE$ = null;
    $java.oncief_Length$_signatures = null;
    $java.oncief_Length$_$callClinit = function() {
        $java.oncief_Length$_$callClinit = $rt_eraseClinit($java.oncief_Length$);
        $java.oncief_Length$__clinit_();
    };
    $java.oncief_Length$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Length$;
        $java.oncief_Length$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Length$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Length$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTPath0(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2438), $java.oncief_Category$_SCALAR);
        $java.oncief_Length$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Length$_name = function($this) {
        return $rt_s(2435);
    };
    $java.oncief_Length$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Length$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Length$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Length$_hashCode = function($this) {
        return (-2022496506);
    };
    $java.oncief_Length$_toString = function($this) {
        return $rt_s(2439);
    };
    $java.oncief_Length$_signatures0 = function($this) {
        $java.oncief_Length$_$callClinit();
        return $java.oncief_Length$_signatures;
    };
    $java.oncief_Linenumber$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Linenumber$_MODULE$ = null;
    $java.oncief_Linenumber$_signatures = null;
    $java.oncief_Linenumber$_$callClinit = function() {
        $java.oncief_Linenumber$_$callClinit = $rt_eraseClinit($java.oncief_Linenumber$);
        $java.oncief_Linenumber$__clinit_();
    };
    $java.oncief_Linenumber$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Linenumber$;
        $java.oncief_Linenumber$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Linenumber$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Linenumber$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_noArg(var$5, var$6, oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2440), $java.oncief_Category$_SCALAR);
        $java.oncief_Linenumber$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Linenumber$_name = function($this) {
        return $rt_s(2441);
    };
    $java.oncief_Linenumber$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Linenumber$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Linenumber$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Linenumber$_hashCode = function($this) {
        return (-1714511779);
    };
    $java.oncief_Linenumber$_toString = function($this) {
        return $rt_s(2442);
    };
    $java.oncief_Linenumber$_signatures0 = function($this) {
        $java.oncief_Linenumber$_$callClinit();
        return $java.oncief_Linenumber$_signatures;
    };
    $java.oncief_Log$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Log$_MODULE$ = null;
    $java.oncief_Log$_signatures = null;
    $java.oncief_Log$_$callClinit = function() {
        $java.oncief_Log$_$callClinit = $rt_eraseClinit($java.oncief_Log$);
        $java.oncief_Log$__clinit_();
    };
    $java.oncief_Log$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Log$;
        $java.oncief_Log$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Log$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Log$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2443), $java.oncief_Category$_LOGARITHMIC);
        $java.oncief_Log$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Log$_name = function($this) {
        return $rt_s(2444);
    };
    $java.oncief_Log$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Log$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Log$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Log$_hashCode = function($this) {
        return 76580;
    };
    $java.oncief_Log$_toString = function($this) {
        return $rt_s(2445);
    };
    $java.oncief_Log$_signatures0 = function($this) {
        $java.oncief_Log$_$callClinit();
        return $java.oncief_Log$_signatures;
    };
    $java.oncief_Log10$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Log10$_MODULE$ = null;
    $java.oncief_Log10$_signatures = null;
    $java.oncief_Log10$_$callClinit = function() {
        $java.oncief_Log10$_$callClinit = $rt_eraseClinit($java.oncief_Log10$);
        $java.oncief_Log10$__clinit_();
    };
    $java.oncief_Log10$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Log10$;
        $java.oncief_Log10$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Log10$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Log10$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2446), $java.oncief_Category$_LOGARITHMIC);
        $java.oncief_Log10$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Log10$_name = function($this) {
        return $rt_s(2447);
    };
    $java.oncief_Log10$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Log10$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Log10$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Log10$_hashCode = function($this) {
        return 73594947;
    };
    $java.oncief_Log10$_toString = function($this) {
        return $rt_s(2448);
    };
    $java.oncief_Log10$_signatures0 = function($this) {
        $java.oncief_Log10$_$callClinit();
        return $java.oncief_Log10$_signatures;
    };
    $java.oncief_LTrim$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_LTrim$_MODULE$ = null;
    $java.oncief_LTrim$_signatures = null;
    $java.oncief_LTrim$_$callClinit = function() {
        $java.oncief_LTrim$_$callClinit = $rt_eraseClinit($java.oncief_LTrim$);
        $java.oncief_LTrim$__clinit_();
    };
    $java.oncief_LTrim$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_LTrim$;
        $java.oncief_LTrim$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_LTrim$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_LTrim$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2449), $java.oncief_Category$_STRING);
        $java.oncief_LTrim$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_LTrim$_name = function($this) {
        return $rt_s(2450);
    };
    $java.oncief_LTrim$_productArity = function($this) {
        return 0;
    };
    $java.oncief_LTrim$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_LTrim$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_LTrim$_hashCode = function($this) {
        return 72802958;
    };
    $java.oncief_LTrim$_toString = function($this) {
        return $rt_s(2451);
    };
    $java.oncief_LTrim$_signatures0 = function($this) {
        $java.oncief_LTrim$_$callClinit();
        return $java.oncief_LTrim$_signatures;
    };
    $java.oncief_Max$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_Max$_MODULE$ = null;
    $java.oncief_Max$_signatures = null;
    $java.oncief_Max$_$callClinit = function() {
        $java.oncief_Max$_$callClinit = $rt_eraseClinit($java.oncief_Max$);
        $java.oncief_Max$__clinit_();
    };
    $java.oncief_Max$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Max$;
        $java.oncief_Max$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Max$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Max$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTAny(oncius_package$_MODULE$), $rt_s(2452), $java.oncief_Category$_AGGREGATING);
        $java.oncief_Max$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Max$_name = function($this) {
        return $rt_s(2453);
    };
    $java.oncief_Max$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Max$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Max$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Max$_hashCode = function($this) {
        return 77124;
    };
    $java.oncief_Max$_toString = function($this) {
        return $rt_s(2454);
    };
    $java.oncief_Max$_signatures0 = function($this) {
        $java.oncief_Max$_$callClinit();
        return $java.oncief_Max$_signatures;
    };
    $java.oncief_Min$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_Min$_MODULE$ = null;
    $java.oncief_Min$_signatures = null;
    $java.oncief_Min$_$callClinit = function() {
        $java.oncief_Min$_$callClinit = $rt_eraseClinit($java.oncief_Min$);
        $java.oncief_Min$__clinit_();
    };
    $java.oncief_Min$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Min$;
        $java.oncief_Min$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Min$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Min$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTAny(oncius_package$_MODULE$), $rt_s(2455), $java.oncief_Category$_AGGREGATING);
        $java.oncief_Min$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Min$_name = function($this) {
        return $rt_s(2456);
    };
    $java.oncief_Min$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Min$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Min$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Min$_hashCode = function($this) {
        return 77362;
    };
    $java.oncief_Min$_toString = function($this) {
        return $rt_s(2457);
    };
    $java.oncief_Min$_signatures0 = function($this) {
        $java.oncief_Min$_$callClinit();
        return $java.oncief_Min$_signatures;
    };
    $java.oncief_Nodes$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Nodes$_MODULE$ = null;
    $java.oncief_Nodes$_signatures = null;
    $java.oncief_Nodes$_$callClinit = function() {
        $java.oncief_Nodes$_$callClinit = $rt_eraseClinit($java.oncief_Nodes$);
        $java.oncief_Nodes$__clinit_();
    };
    $java.oncief_Nodes$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_Nodes$;
        $java.oncief_Nodes$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Nodes$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Nodes$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = $java.oncius_package$_CTPath0(oncius_package$_MODULE$);
        var$8 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTList(var$8, oncius_package$_CTNode(var$8)), $rt_s(2458), $java.oncief_Category$_LIST);
        $java.oncief_Nodes$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Nodes$_name = function($this) {
        return $rt_s(2459);
    };
    $java.oncief_Nodes$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Nodes$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Nodes$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Nodes$_hashCode = function($this) {
        return 75440785;
    };
    $java.oncief_Nodes$_toString = function($this) {
        return $rt_s(2460);
    };
    $java.oncief_Nodes$_signatures0 = function($this) {
        $java.oncief_Nodes$_$callClinit();
        return $java.oncief_Nodes$_signatures;
    };
    $java.oncief_Pi$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Pi$_MODULE$ = null;
    $java.oncief_Pi$_signatures = null;
    $java.oncief_Pi$_$callClinit = function() {
        $java.oncief_Pi$_$callClinit = $rt_eraseClinit($java.oncief_Pi$);
        $java.oncief_Pi$__clinit_();
    };
    $java.oncief_Pi$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Pi$;
        $java.oncief_Pi$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Pi$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Pi$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_noArg(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2461), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Pi$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Pi$_name = function($this) {
        return $rt_s(2462);
    };
    $java.oncief_Pi$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Pi$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Pi$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Pi$_hashCode = function($this) {
        return 2585;
    };
    $java.oncief_Pi$_toString = function($this) {
        return $rt_s(2463);
    };
    $java.oncief_Pi$_signatures0 = function($this) {
        $java.oncief_Pi$_$callClinit();
        return $java.oncief_Pi$_signatures;
    };
    $java.oncief_PercentileCont$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_PercentileCont$_MODULE$ = null;
    $java.oncief_PercentileCont$_signatures = null;
    $java.oncief_PercentileCont$_$callClinit = function() {
        $java.oncief_PercentileCont$_$callClinit = $rt_eraseClinit($java.oncief_PercentileCont$);
        $java.oncief_PercentileCont$__clinit_();
    };
    $java.oncief_PercentileCont$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$6, var$9, var$10, $x$3;
        var$1 = new $java.oncief_PercentileCont$;
        $java.oncief_PercentileCont$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_PercentileCont$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_PercentileCont$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(1777), $rt_s(2464)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$6 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_FloatType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$10[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$6, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $x$2, $rt_s(2465), $java.oncief_Category$_AGGREGATING, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_PercentileCont$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_PercentileCont$_name = function($this) {
        return $rt_s(2466);
    };
    $java.oncief_PercentileCont$_productArity = function($this) {
        return 0;
    };
    $java.oncief_PercentileCont$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_PercentileCont$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_PercentileCont$_hashCode = function($this) {
        return 1231034927;
    };
    $java.oncief_PercentileCont$_toString = function($this) {
        return $rt_s(2467);
    };
    $java.oncief_PercentileCont$_signatures0 = function($this) {
        $java.oncief_PercentileCont$_$callClinit();
        return $java.oncief_PercentileCont$_signatures;
    };
    $java.oncief_PercentileDisc$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_PercentileDisc$_MODULE$ = null;
    $java.oncief_PercentileDisc$_signatures = null;
    $java.oncief_PercentileDisc$_$callClinit = function() {
        $java.oncief_PercentileDisc$_$callClinit = $rt_eraseClinit($java.oncief_PercentileDisc$);
        $java.oncief_PercentileDisc$__clinit_();
    };
    $java.oncief_PercentileDisc$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$7, var$8, var$9, var$10, $x$6, $x$3, var$13, var$14, var$15;
        var$1 = new $java.oncief_PercentileDisc$;
        $java.oncief_PercentileDisc$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_PercentileDisc$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_PercentileDisc$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(1777), $rt_s(2464)])));
        $x$7 = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_CypherType, 2);
        var$10 = var$9.data;
        $x$6 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        $x$3 = s_Predef$_Set(s_Predef$_MODULE$);
        var$13 = sr_ScalaRunTime$_MODULE$;
        var$14 = $rt_createArray(oncius_CypherType, 2);
        var$15 = var$14.data;
        oncius_package$_$callClinit();
        var$15[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$15[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$13 = $x$3.$from0(sr_ScalaRunTime$_wrapRefArray(var$13, var$14));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_($x$6, var$13, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$10[0] = $x$6;
        var$10[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        $x$3 = $x$7.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_ClosedDynamicUnionType__init_((s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), $x$2, $rt_s(2468), $java.oncief_Category$_AGGREGATING, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$),
        0, s_None$_MODULE$);
        $java.oncief_PercentileDisc$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_PercentileDisc$_name = function($this) {
        return $rt_s(2469);
    };
    $java.oncief_PercentileDisc$_productArity = function($this) {
        return 0;
    };
    $java.oncief_PercentileDisc$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_PercentileDisc$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_PercentileDisc$_hashCode = function($this) {
        return 1231059090;
    };
    $java.oncief_PercentileDisc$_toString = function($this) {
        return $rt_s(2470);
    };
    $java.oncief_PercentileDisc$_signatures0 = function($this) {
        $java.oncief_PercentileDisc$_$callClinit();
        return $java.oncief_PercentileDisc$_signatures;
    };
    $java.oncief_Point$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Point$_MODULE$ = null;
    $java.oncief_Point$_signatures = null;
    $java.oncief_Point$_$callClinit = function() {
        $java.oncief_Point$_$callClinit = $rt_eraseClinit($java.oncief_Point$);
        $java.oncief_Point$__clinit_();
    };
    $java.oncief_Point$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Point$;
        $java.oncief_Point$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Point$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Point$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTMap(oncius_package$_MODULE$), $java.oncius_package$_CTPoint0(oncius_package$_MODULE$), $rt_s(2471), $java.oncief_Category$_SPATIAL);
        $java.oncief_Point$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Point$_name = function($this) {
        return $rt_s(2472);
    };
    $java.oncief_Point$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Point$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Point$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Point$_hashCode = function($this) {
        return 77292912;
    };
    $java.oncief_Point$_toString = function($this) {
        return $rt_s(1760);
    };
    $java.oncief_Point$_signatures0 = function($this) {
        $java.oncief_Point$_$callClinit();
        return $java.oncief_Point$_signatures;
    };
    $java.oncief_Keys$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Keys$_MODULE$ = null;
    $java.oncief_Keys$_signatures = null;
    $java.oncief_Keys$_$callClinit = function() {
        $java.oncief_Keys$_$callClinit = $rt_eraseClinit($java.oncief_Keys$);
        $java.oncief_Keys$__clinit_();
    };
    $java.oncief_Keys$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_Keys$;
        $java.oncief_Keys$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Keys$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Keys$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 3);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTNode(oncius_package$_MODULE$);
        var$11[1] = oncius_package$_CTRelationship(oncius_package$_MODULE$);
        var$11[2] = oncius_package$_CTMap(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$12 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTList(var$12, oncius_package$_CTString(var$12)), $rt_s(2473), $java.oncief_Category$_LIST);
        $java.oncief_Keys$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Keys$_name = function($this) {
        return $rt_s(2474);
    };
    $java.oncief_Keys$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Keys$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Keys$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Keys$_hashCode = function($this) {
        return 2335252;
    };
    $java.oncief_Keys$_toString = function($this) {
        return $rt_s(2475);
    };
    $java.oncief_Keys$_signatures0 = function($this) {
        $java.oncief_Keys$_$callClinit();
        return $java.oncief_Keys$_signatures;
    };
    $java.oncief_Radians$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Radians$_MODULE$ = null;
    $java.oncief_Radians$_signatures = null;
    $java.oncief_Radians$_$callClinit = function() {
        $java.oncief_Radians$_$callClinit = $rt_eraseClinit($java.oncief_Radians$);
        $java.oncief_Radians$__clinit_();
    };
    $java.oncief_Radians$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Radians$;
        $java.oncief_Radians$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Radians$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Radians$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2476), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Radians$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Radians$_name = function($this) {
        return $rt_s(2477);
    };
    $java.oncief_Radians$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Radians$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Radians$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Radians$_hashCode = function($this) {
        return (-1661504942);
    };
    $java.oncief_Radians$_toString = function($this) {
        return $rt_s(2478);
    };
    $java.oncief_Radians$_signatures0 = function($this) {
        $java.oncief_Radians$_$callClinit();
        return $java.oncief_Radians$_signatures;
    };
    $java.oncief_Rand$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Rand$_MODULE$ = null;
    $java.oncief_Rand$_name = null;
    $java.oncief_Rand$_signatures = null;
    $java.oncief_Rand$_$callClinit = function() {
        $java.oncief_Rand$_$callClinit = $rt_eraseClinit($java.oncief_Rand$);
        $java.oncief_Rand$__clinit_();
    };
    $java.oncief_Rand$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Rand$;
        $java.oncief_Rand$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Rand$_MODULE$ = var$1;
        $java.oncief_Rand$_name = $rt_s(2479);
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Rand$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_noArg(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2480), $java.oncief_Category$_NUMERIC);
        $java.oncief_Rand$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Rand$_name0 = function($this) {
        $java.oncief_Rand$_$callClinit();
        return $java.oncief_Rand$_name;
    };
    $java.oncief_Rand$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Rand$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Rand$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Rand$_hashCode = function($this) {
        return 2539589;
    };
    $java.oncief_Rand$_toString = function($this) {
        return $rt_s(2481);
    };
    $java.oncief_Rand$_signatures0 = function($this) {
        $java.oncief_Rand$_$callClinit();
        return $java.oncief_Rand$_signatures;
    };
    $java.oncief_RandomUUID$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_RandomUUID$_MODULE$ = null;
    $java.oncief_RandomUUID$_signatures = null;
    $java.oncief_RandomUUID$_$callClinit = function() {
        $java.oncief_RandomUUID$_$callClinit = $rt_eraseClinit($java.oncief_RandomUUID$);
        $java.oncief_RandomUUID$__clinit_();
    };
    $java.oncief_RandomUUID$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_RandomUUID$;
        $java.oncief_RandomUUID$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_RandomUUID$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_RandomUUID$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_noArg(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2482), $java.oncief_Category$_SCALAR);
        $java.oncief_RandomUUID$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_RandomUUID$_name = function($this) {
        return $rt_s(2483);
    };
    $java.oncief_RandomUUID$_signatures0 = function($this) {
        $java.oncief_RandomUUID$_$callClinit();
        return $java.oncief_RandomUUID$_signatures;
    };
    $java.oncief_Range$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Range$_MODULE$ = null;
    $java.oncief_Range$_signatures = null;
    $java.oncief_Range$_$callClinit = function() {
        $java.oncief_Range$_$callClinit = $rt_eraseClinit($java.oncief_Range$);
        $java.oncief_Range$__clinit_();
    };
    $java.oncief_Range$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$7, var$9, var$10, $x$3, $x$10, $x$11, $x$12;
        var$1 = new $java.oncief_Range$;
        $java.oncief_Range$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Range$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 2);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Range$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2484), $rt_s(2485)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$7 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_IntegerType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$7, var$9));
        $x$4 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTList($x$4, oncius_package$_CTInteger($x$4)), $x$2, $rt_s(2486), $java.oncief_Category$_LIST, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $x$10 = $java.oncief_Range$_MODULE$;
        $x$11 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2484), $rt_s(2485), $rt_s(2487)])));
        $x$12 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_IntegerType, [oncius_package$_CTInteger(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)])));
        $x$3 = oncius_package$_MODULE$;
        var$4[1] = $java.oncie_FunctionTypeSignature__init_0($x$10, oncius_package$_CTList($x$3, oncius_package$_CTInteger($x$3)), $x$11, $rt_s(2488), $java.oncief_Category$_LIST, $x$12, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Range$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Range$_name = function($this) {
        return $rt_s(2489);
    };
    $java.oncief_Range$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Range$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Range$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Range$_hashCode = function($this) {
        return 78727453;
    };
    $java.oncief_Range$_toString = function($this) {
        return $rt_s(1422);
    };
    $java.oncief_Range$_signatures0 = function($this) {
        $java.oncief_Range$_$callClinit();
        return $java.oncief_Range$_signatures;
    };
    $java.oncief_Reduce$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Reduce$_MODULE$ = null;
    $java.oncief_Reduce$_signatures = null;
    $java.oncief_Reduce$_$callClinit = function() {
        $java.oncief_Reduce$_$callClinit = $rt_eraseClinit($java.oncief_Reduce$);
        $java.oncief_Reduce$__clinit_();
    };
    $java.oncief_Reduce$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, var$7, $x$8, var$9, var$10, $x$3, $x$4, $x$6, $x$7, var$15;
        var$1 = new $java.oncief_Reduce$;
        $java.oncief_Reduce$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Reduce$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Reduce$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2490), $rt_s(2491)])));
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        $x$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_CypherType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        $x$3 = oncius_package$_MODULE$;
        var$10[1] = oncius_package$_CTList($x$3, oncius_package$_CTAny($x$3));
        $x$3 = var$7.$from0(sr_ScalaRunTime$_wrapRefArray($x$8, var$9));
        $x$4 = oncius_package$_CTAny(oncius_package$_MODULE$);
        $x$6 = $java.oncief_Category$_LIST;
        $x$7 = new s_Some;
        var$15 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$15);
        jl_StringBuilder_append(jl_StringBuilder_append(var$15, $rt_s(2492)), $rt_s(2493));
        s_Some__init_0($x$7, jl_AbstractStringBuilder_toString(var$15));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, $x$4, $x$2, $rt_s(2494), $x$6, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, $x$7);
        $java.oncief_Reduce$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Reduce$_name = function($this) {
        return $rt_s(2492);
    };
    $java.oncief_Reduce$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Reduce$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Reduce$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Reduce$_hashCode = function($this) {
        return (-1851006586);
    };
    $java.oncief_Reduce$_toString = function($this) {
        return $rt_s(2495);
    };
    $java.oncief_Reduce$_signatures0 = function($this) {
        $java.oncief_Reduce$_$callClinit();
        return $java.oncief_Reduce$_signatures;
    };
    $java.oncief_Relationships$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Relationships$_MODULE$ = null;
    $java.oncief_Relationships$_signatures = null;
    $java.oncief_Relationships$_$callClinit = function() {
        $java.oncief_Relationships$_$callClinit = $rt_eraseClinit($java.oncief_Relationships$);
        $java.oncief_Relationships$__clinit_();
    };
    $java.oncief_Relationships$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_Relationships$;
        $java.oncief_Relationships$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Relationships$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Relationships$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = $java.oncius_package$_CTPath0(oncius_package$_MODULE$);
        var$8 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTList(var$8, oncius_package$_CTRelationship(var$8)), $rt_s(2496), $java.oncief_Category$_LIST);
        $java.oncief_Relationships$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Relationships$_name = function($this) {
        return $rt_s(2497);
    };
    $java.oncief_Relationships$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Relationships$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Relationships$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Relationships$_hashCode = function($this) {
        return 1271496987;
    };
    $java.oncief_Relationships$_toString = function($this) {
        return $rt_s(2498);
    };
    $java.oncief_Relationships$_signatures0 = function($this) {
        $java.oncief_Relationships$_$callClinit();
        return $java.oncief_Relationships$_signatures;
    };
    $java.oncief_Replace$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Replace$_MODULE$ = null;
    $java.oncief_Replace$_signatures = null;
    $java.oncief_Replace$_$callClinit = function() {
        $java.oncief_Replace$_$callClinit = $rt_eraseClinit($java.oncief_Replace$);
        $java.oncief_Replace$__clinit_();
    };
    $java.oncief_Replace$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$3, $x$4, var$9, var$10;
        var$1 = new $java.oncief_Replace$;
        $java.oncief_Replace$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Replace$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Replace$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2434), $rt_s(2499), $rt_s(2500)])));
        $x$3 = s_package$_Vector0(s_package$_MODULE$);
        $x$4 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_StringType, 3);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$10[2] = oncius_package$_CTString(oncius_package$_MODULE$);
        $x$3 = $x$3.$from0(sr_ScalaRunTime$_wrapRefArray($x$4, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTString(oncius_package$_MODULE$), $x$2, $rt_s(2501), $java.oncief_Category$_STRING, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Replace$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Replace$_name = function($this) {
        return $rt_s(2500);
    };
    $java.oncief_Replace$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Replace$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Replace$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Replace$_hashCode = function($this) {
        return (-1535817068);
    };
    $java.oncief_Replace$_toString = function($this) {
        return $rt_s(2502);
    };
    $java.oncief_Replace$_signatures0 = function($this) {
        $java.oncief_Replace$_$callClinit();
        return $java.oncief_Replace$_signatures;
    };
    $java.oncief_Reverse$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Reverse$_MODULE$ = null;
    $java.oncief_Reverse$_signatures = null;
    $java.oncief_Reverse$_$callClinit = function() {
        $java.oncief_Reverse$_$callClinit = $rt_eraseClinit($java.oncief_Reverse$);
        $java.oncief_Reverse$__clinit_();
    };
    $java.oncief_Reverse$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13;
        var$1 = new $java.oncief_Reverse$;
        $java.oncief_Reverse$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Reverse$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Reverse$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$12 = oncius_package$_MODULE$;
        var$11[1] = oncius_package$_CTList(var$12, oncius_package$_CTAny(var$12));
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$12 = new oncius_ClosedDynamicUnionType;
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$13 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        var$11[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$9 = oncius_package$_MODULE$;
        var$11[1] = oncius_package$_CTList(var$9, oncius_package$_CTAny(var$9));
        $java.oncius_ClosedDynamicUnionType__init_(var$12, var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$13, var$10)), onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, var$12, $rt_s(2503), $java.oncief_Category$_STRING);
        $java.oncief_Reverse$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Reverse$_name = function($this) {
        return $rt_s(2504);
    };
    $java.oncief_Reverse$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Reverse$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Reverse$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Reverse$_hashCode = function($this) {
        return (-1530467646);
    };
    $java.oncief_Reverse$_toString = function($this) {
        return $rt_s(2505);
    };
    $java.oncief_Reverse$_signatures0 = function($this) {
        $java.oncief_Reverse$_$callClinit();
        return $java.oncief_Reverse$_signatures;
    };
    $java.oncief_Right$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Right$_MODULE$ = null;
    $java.oncief_Right$_signatures = null;
    $java.oncief_Right$_$callClinit = function() {
        $java.oncief_Right$_$callClinit = $rt_eraseClinit($java.oncief_Right$);
        $java.oncief_Right$__clinit_();
    };
    $java.oncief_Right$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$6, var$9, var$10, $x$3;
        var$1 = new $java.oncief_Right$;
        $java.oncief_Right$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Right$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Right$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2434), $rt_s(2435)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$6 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_CypherType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$6, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTString(oncius_package$_MODULE$), $x$2, $rt_s(2506), $java.oncief_Category$_STRING, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Right$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Right$_name = function($this) {
        return $rt_s(2507);
    };
    $java.oncief_Right$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Right$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Right$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Right$_hashCode = function($this) {
        return 78959100;
    };
    $java.oncief_Right$_toString = function($this) {
        return $rt_s(1046);
    };
    $java.oncief_Right$_signatures0 = function($this) {
        $java.oncief_Right$_$callClinit();
        return $java.oncief_Right$_signatures;
    };
    $java.oncief_Round$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Round$_MODULE$ = null;
    $java.oncief_Round$_signatures = null;
    $java.oncief_Round$_$callClinit = function() {
        $java.oncief_Round$_$callClinit = $rt_eraseClinit($java.oncief_Round$);
        $java.oncief_Round$__clinit_();
    };
    $java.oncief_Round$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$3, $x$7, $x$1, $x$2, $x$10, $x$11, $x$12;
        var$1 = new $java.oncief_Round$;
        $java.oncief_Round$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Round$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 3);
        var$4 = var$3.data;
        $x$3 = $java.oncie_TypeSignature$_MODULE$;
        $x$7 = $java.oncief_Round$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0($x$3, $x$7, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2508), $java.oncief_Category$_NUMERIC);
        $x$1 = $java.oncief_Round$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(556), $rt_s(2509)])));
        $x$3 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTNumber(oncius_package$_MODULE$)])));
        var$4[1] = $java.oncie_FunctionTypeSignature__init_0($x$1, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $x$2, $rt_s(2510), $java.oncief_Category$_NUMERIC, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $x$10 = $java.oncief_Round$_MODULE$;
        $x$11 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(556), $rt_s(2509), $rt_s(1971)])));
        $x$12 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTNumber(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$)])));
        var$4[2] = $java.oncie_FunctionTypeSignature__init_0($x$10, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $x$11, $rt_s(2511), $java.oncief_Category$_NUMERIC, $x$12, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Round$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Round$_name = function($this) {
        return $rt_s(2512);
    };
    $java.oncief_Round$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Round$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Round$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Round$_hashCode = function($this) {
        return 79151470;
    };
    $java.oncief_Round$_toString = function($this) {
        return $rt_s(2513);
    };
    $java.oncief_Round$_signatures0 = function($this) {
        $java.oncief_Round$_$callClinit();
        return $java.oncief_Round$_signatures;
    };
    $java.oncief_RTrim$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_RTrim$_MODULE$ = null;
    $java.oncief_RTrim$_signatures = null;
    $java.oncief_RTrim$_$callClinit = function() {
        $java.oncief_RTrim$_$callClinit = $rt_eraseClinit($java.oncief_RTrim$);
        $java.oncief_RTrim$__clinit_();
    };
    $java.oncief_RTrim$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_RTrim$;
        $java.oncief_RTrim$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_RTrim$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_RTrim$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2514), $java.oncief_Category$_STRING);
        $java.oncief_RTrim$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_RTrim$_name = function($this) {
        return $rt_s(2515);
    };
    $java.oncief_RTrim$_productArity = function($this) {
        return 0;
    };
    $java.oncief_RTrim$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_RTrim$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_RTrim$_hashCode = function($this) {
        return 78344084;
    };
    $java.oncief_RTrim$_toString = function($this) {
        return $rt_s(2516);
    };
    $java.oncief_RTrim$_signatures0 = function($this) {
        $java.oncief_RTrim$_$callClinit();
        return $java.oncief_RTrim$_signatures;
    };
    $java.oncief_Sign$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Sign$_MODULE$ = null;
    $java.oncief_Sign$_signatures = null;
    $java.oncief_Sign$_$callClinit = function() {
        $java.oncief_Sign$_$callClinit = $rt_eraseClinit($java.oncief_Sign$);
        $java.oncief_Sign$__clinit_();
    };
    $java.oncief_Sign$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_Sign$;
        $java.oncief_Sign$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Sign$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Sign$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$11[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2517), $java.oncief_Category$_NUMERIC);
        $java.oncief_Sign$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Sign$_name = function($this) {
        return $rt_s(2518);
    };
    $java.oncief_Sign$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Sign$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Sign$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Sign$_hashCode = function($this) {
        return 2576861;
    };
    $java.oncief_Sign$_toString = function($this) {
        return $rt_s(2519);
    };
    $java.oncief_Sign$_signatures0 = function($this) {
        $java.oncief_Sign$_$callClinit();
        return $java.oncief_Sign$_signatures;
    };
    $java.oncief_Sin$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Sin$_MODULE$ = null;
    $java.oncief_Sin$_signatures = null;
    $java.oncief_Sin$_$callClinit = function() {
        $java.oncief_Sin$_$callClinit = $rt_eraseClinit($java.oncief_Sin$);
        $java.oncief_Sin$__clinit_();
    };
    $java.oncief_Sin$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Sin$;
        $java.oncief_Sin$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Sin$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Sin$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2520), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Sin$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Sin$_name = function($this) {
        return $rt_s(2521);
    };
    $java.oncief_Sin$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Sin$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Sin$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Sin$_hashCode = function($this) {
        return 83128;
    };
    $java.oncief_Sin$_toString = function($this) {
        return $rt_s(2522);
    };
    $java.oncief_Sin$_signatures0 = function($this) {
        $java.oncief_Sin$_$callClinit();
        return $java.oncief_Sin$_signatures;
    };
    $java.oncief_Size$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Size$_MODULE$ = null;
    $java.oncief_Size$_signatures = null;
    $java.oncief_Size$_$callClinit = function() {
        $java.oncief_Size$_$callClinit = $rt_eraseClinit($java.oncief_Size$);
        $java.oncief_Size$__clinit_();
    };
    $java.oncief_Size$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_Size$;
        $java.oncief_Size$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Size$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Size$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 2);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$12 = oncius_package$_MODULE$;
        var$11[1] = oncius_package$_CTList(var$12, oncius_package$_CTAny(var$12));
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2523), $java.oncief_Category$_SCALAR);
        $java.oncief_Size$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Size$_name = function($this) {
        return $rt_s(1380);
    };
    $java.oncief_Size$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Size$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Size$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Size$_hashCode = function($this) {
        return 2577441;
    };
    $java.oncief_Size$_toString = function($this) {
        return $rt_s(2524);
    };
    $java.oncief_Size$_signatures0 = function($this) {
        $java.oncief_Size$_$callClinit();
        return $java.oncief_Size$_signatures;
    };
    $java.oncief_Sqrt$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Sqrt$_MODULE$ = null;
    $java.oncief_Sqrt$_signatures = null;
    $java.oncief_Sqrt$_$callClinit = function() {
        $java.oncief_Sqrt$_$callClinit = $rt_eraseClinit($java.oncief_Sqrt$);
        $java.oncief_Sqrt$__clinit_();
    };
    $java.oncief_Sqrt$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Sqrt$;
        $java.oncief_Sqrt$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Sqrt$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Sqrt$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2525), $java.oncief_Category$_LOGARITHMIC);
        $java.oncief_Sqrt$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Sqrt$_name = function($this) {
        return $rt_s(2526);
    };
    $java.oncief_Sqrt$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Sqrt$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Sqrt$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Sqrt$_hashCode = function($this) {
        return 2584896;
    };
    $java.oncief_Sqrt$_toString = function($this) {
        return $rt_s(2527);
    };
    $java.oncief_Sqrt$_signatures0 = function($this) {
        $java.oncief_Sqrt$_$callClinit();
        return $java.oncief_Sqrt$_signatures;
    };
    $java.oncief_Split$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Split$_MODULE$ = null;
    $java.oncief_Split$_signatures = null;
    $java.oncief_Split$_$callClinit = function() {
        $java.oncief_Split$_$callClinit = $rt_eraseClinit($java.oncief_Split$);
        $java.oncief_Split$__clinit_();
    };
    $java.oncief_Split$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$7, var$8, var$9, var$10, $x$6, $x$4, $x$3, var$14, var$15, var$16;
        var$1 = new $java.oncief_Split$;
        $java.oncief_Split$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Split$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Split$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2434), $rt_s(2528)])));
        $x$7 = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_CypherType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        $x$6 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        $x$4 = s_Predef$_Set(s_Predef$_MODULE$);
        $x$3 = sr_ScalaRunTime$_MODULE$;
        var$14 = $rt_createArray(oncius_CypherType, 2);
        var$15 = var$14.data;
        var$15[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$16 = oncius_package$_MODULE$;
        var$15[1] = oncius_package$_CTList(var$16, oncius_package$_CTString(var$16));
        var$16 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$3, var$14));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_($x$6, var$16, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$10[1] = $x$6;
        $x$3 = $x$7.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9));
        $x$7 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTList($x$7, oncius_package$_CTString($x$7)), $x$2, $rt_s(2529), $java.oncief_Category$_STRING, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Split$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Split$_name = function($this) {
        return $rt_s(2530);
    };
    $java.oncief_Split$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Split$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Split$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Split$_hashCode = function($this) {
        return 80095994;
    };
    $java.oncief_Split$_toString = function($this) {
        return $rt_s(2531);
    };
    $java.oncief_Split$_signatures0 = function($this) {
        $java.oncief_Split$_$callClinit();
        return $java.oncief_Split$_signatures;
    };
    $java.oncief_StartNode$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_StartNode$_MODULE$ = null;
    $java.oncief_StartNode$_signatures = null;
    $java.oncief_StartNode$_$callClinit = function() {
        $java.oncief_StartNode$_$callClinit = $rt_eraseClinit($java.oncief_StartNode$);
        $java.oncief_StartNode$__clinit_();
    };
    $java.oncief_StartNode$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_StartNode$;
        $java.oncief_StartNode$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_StartNode$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_StartNode$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTRelationship(oncius_package$_MODULE$), oncius_package$_CTNode(oncius_package$_MODULE$), $rt_s(2532), $java.oncief_Category$_SCALAR);
        $java.oncief_StartNode$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_StartNode$_name = function($this) {
        return $rt_s(2533);
    };
    $java.oncief_StartNode$_productArity = function($this) {
        return 0;
    };
    $java.oncief_StartNode$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_StartNode$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_StartNode$_hashCode = function($this) {
        return (-125500060);
    };
    $java.oncief_StartNode$_toString = function($this) {
        return $rt_s(2534);
    };
    $java.oncief_StartNode$_signatures0 = function($this) {
        $java.oncief_StartNode$_$callClinit();
        return $java.oncief_StartNode$_signatures;
    };
    $java.oncief_StdDev$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_StdDev$_MODULE$ = null;
    $java.oncief_StdDev$_signatures = null;
    $java.oncief_StdDev$_$callClinit = function() {
        $java.oncief_StdDev$_$callClinit = $rt_eraseClinit($java.oncief_StdDev$);
        $java.oncief_StdDev$__clinit_();
    };
    $java.oncief_StdDev$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_StdDev$;
        $java.oncief_StdDev$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_StdDev$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_StdDev$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2535), $java.oncief_Category$_AGGREGATING);
        $java.oncief_StdDev$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_StdDev$_name = function($this) {
        return $rt_s(2536);
    };
    $java.oncief_StdDev$_productArity = function($this) {
        return 0;
    };
    $java.oncief_StdDev$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_StdDev$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_StdDev$_hashCode = function($this) {
        return (-1808571630);
    };
    $java.oncief_StdDev$_toString = function($this) {
        return $rt_s(2537);
    };
    $java.oncief_StdDev$_signatures0 = function($this) {
        $java.oncief_StdDev$_$callClinit();
        return $java.oncief_StdDev$_signatures;
    };
    $java.oncief_StdDevP$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_StdDevP$_MODULE$ = null;
    $java.oncief_StdDevP$_signatures = null;
    $java.oncief_StdDevP$_$callClinit = function() {
        $java.oncief_StdDevP$_$callClinit = $rt_eraseClinit($java.oncief_StdDevP$);
        $java.oncief_StdDevP$__clinit_();
    };
    $java.oncief_StdDevP$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_StdDevP$;
        $java.oncief_StdDevP$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_StdDevP$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_StdDevP$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2538), $java.oncief_Category$_AGGREGATING);
        $java.oncief_StdDevP$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_StdDevP$_name = function($this) {
        return $rt_s(2539);
    };
    $java.oncief_StdDevP$_productArity = function($this) {
        return 0;
    };
    $java.oncief_StdDevP$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_StdDevP$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_StdDevP$_hashCode = function($this) {
        return (-231145602);
    };
    $java.oncief_StdDevP$_toString = function($this) {
        return $rt_s(2540);
    };
    $java.oncief_StdDevP$_signatures0 = function($this) {
        $java.oncief_StdDevP$_$callClinit();
        return $java.oncief_StdDevP$_signatures;
    };
    $java.oncief_Substring$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Substring$_MODULE$ = null;
    $java.oncief_Substring$_signatures = null;
    $java.oncief_Substring$_$callClinit = function() {
        $java.oncief_Substring$_$callClinit = $rt_eraseClinit($java.oncief_Substring$);
        $java.oncief_Substring$__clinit_();
    };
    $java.oncief_Substring$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$7, var$9, var$10, $x$3, $x$10, $x$11, $x$12;
        var$1 = new $java.oncief_Substring$;
        $java.oncief_Substring$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Substring$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 2);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Substring$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2434), $rt_s(2484)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$7 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_CypherType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$7, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTString(oncius_package$_MODULE$), $x$2, $rt_s(2541), $java.oncief_Category$_STRING, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $x$10 = $java.oncief_Substring$_MODULE$;
        $x$11 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2434), $rt_s(2484), $rt_s(2435)])));
        $x$12 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)])));
        var$4[1] = $java.oncie_FunctionTypeSignature__init_0($x$10, oncius_package$_CTString(oncius_package$_MODULE$), $x$11, $rt_s(2542), $java.oncief_Category$_STRING, $x$12, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Substring$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Substring$_name = function($this) {
        return $rt_s(2543);
    };
    $java.oncief_Substring$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Substring$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Substring$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Substring$_hashCode = function($this) {
        return (-1760457167);
    };
    $java.oncief_Substring$_toString = function($this) {
        return $rt_s(2544);
    };
    $java.oncief_Substring$_signatures0 = function($this) {
        $java.oncief_Substring$_$callClinit();
        return $java.oncief_Substring$_signatures;
    };
    $java.oncief_Sum$ = $rt_classWithoutFields($java.oncief_AggregatingFunction);
    $java.oncief_Sum$_MODULE$ = null;
    $java.oncief_Sum$_signatures = null;
    $java.oncief_Sum$_$callClinit = function() {
        $java.oncief_Sum$_$callClinit = $rt_eraseClinit($java.oncief_Sum$);
        $java.oncief_Sum$__clinit_();
    };
    $java.oncief_Sum$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$4, $x$7, var$8, $x$2, $x$3, var$11, var$12, $x$9, var$14, var$15, var$16;
        var$1 = new $java.oncief_Sum$;
        $java.oncief_Sum$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Sum$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_Sum$_MODULE$;
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$7 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(jl_String, 1);
        var$8.data[0] = $rt_s(1777);
        $x$2 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$7, var$8));
        $x$3 = s_package$_Vector0(s_package$_MODULE$);
        $x$4 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_ClosedDynamicUnionType, 1);
        var$11 = var$8.data;
        var$12 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        $x$9 = s_Predef$_Set(s_Predef$_MODULE$);
        $x$7 = sr_ScalaRunTime$_MODULE$;
        var$14 = $rt_createArray(oncius_CypherType, 3);
        var$15 = var$14.data;
        oncius_package$_$callClinit();
        var$15[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$15[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$15[2] = $java.oncius_package$_CTDuration0(oncius_package$_MODULE$);
        var$16 = $x$9.$from0(sr_ScalaRunTime$_wrapRefArray($x$7, var$14));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$12, var$16, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$11[0] = var$12;
        $x$3 = $x$3.$from0(sr_ScalaRunTime$_wrapRefArray($x$4, var$8));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_ClosedDynamicUnionType__init_((s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$)), $x$2, $rt_s(2545), $java.oncief_Category$_AGGREGATING,
        $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_Sum$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Sum$_name = function($this) {
        return $rt_s(2546);
    };
    $java.oncief_Sum$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Sum$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Sum$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Sum$_hashCode = function($this) {
        return 83499;
    };
    $java.oncief_Sum$_toString = function($this) {
        return $rt_s(2547);
    };
    $java.oncief_Sum$_signatures0 = function($this) {
        $java.oncief_Sum$_$callClinit();
        return $java.oncief_Sum$_signatures;
    };
    $java.oncief_Tail$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Tail$_MODULE$ = null;
    $java.oncief_Tail$_signatures = null;
    $java.oncief_Tail$_$callClinit = function() {
        $java.oncief_Tail$_$callClinit = $rt_eraseClinit($java.oncief_Tail$);
        $java.oncief_Tail$__clinit_();
    };
    $java.oncief_Tail$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_Tail$;
        $java.oncief_Tail$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Tail$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Tail$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = oncius_package$_MODULE$;
        var$8 = oncius_package$_CTList(var$7, oncius_package$_CTAny(var$7));
        var$7 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$8, oncius_package$_CTList(var$7, oncius_package$_CTAny(var$7)), $rt_s(2548), $java.oncief_Category$_LIST);
        $java.oncief_Tail$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Tail$_name = function($this) {
        return $rt_s(2549);
    };
    $java.oncief_Tail$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Tail$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Tail$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Tail$_hashCode = function($this) {
        return 2599024;
    };
    $java.oncief_Tail$_toString = function($this) {
        return $rt_s(2550);
    };
    $java.oncief_Tail$_signatures0 = function($this) {
        $java.oncief_Tail$_$callClinit();
        return $java.oncief_Tail$_signatures;
    };
    $java.oncief_Tan$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Tan$_MODULE$ = null;
    $java.oncief_Tan$_signatures = null;
    $java.oncief_Tan$_$callClinit = function() {
        $java.oncief_Tan$_$callClinit = $rt_eraseClinit($java.oncief_Tan$);
        $java.oncief_Tan$__clinit_();
    };
    $java.oncief_Tan$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Tan$;
        $java.oncief_Tan$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Tan$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Tan$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2551), $java.oncief_Category$_TRIGONOMETRIC);
        $java.oncief_Tan$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Tan$_name = function($this) {
        return $rt_s(2552);
    };
    $java.oncief_Tan$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Tan$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Tan$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Tan$_hashCode = function($this) {
        return 83841;
    };
    $java.oncief_Tan$_toString = function($this) {
        return $rt_s(2553);
    };
    $java.oncief_Tan$_signatures0 = function($this) {
        $java.oncief_Tan$_$callClinit();
        return $java.oncief_Tan$_signatures;
    };
    $java.oncief_ToBoolean$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToBoolean$_MODULE$ = null;
    $java.oncief_ToBoolean$_signatures = null;
    $java.oncief_ToBoolean$_$callClinit = function() {
        $java.oncief_ToBoolean$_$callClinit = $rt_eraseClinit($java.oncief_ToBoolean$);
        $java.oncief_ToBoolean$__clinit_();
    };
    $java.oncief_ToBoolean$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_ToBoolean$;
        $java.oncief_ToBoolean$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToBoolean$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToBoolean$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 3);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$11[1] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$11[2] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTBoolean(oncius_package$_MODULE$), $rt_s(2554), $java.oncief_Category$_SCALAR);
        $java.oncief_ToBoolean$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToBoolean$_name = function($this) {
        return $rt_s(2555);
    };
    $java.oncief_ToBoolean$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToBoolean$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToBoolean$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToBoolean$_hashCode = function($this) {
        return 405464333;
    };
    $java.oncief_ToBoolean$_toString = function($this) {
        return $rt_s(2556);
    };
    $java.oncief_ToBoolean$_signatures0 = function($this) {
        $java.oncief_ToBoolean$_$callClinit();
        return $java.oncief_ToBoolean$_signatures;
    };
    $java.oncief_ToBooleanList$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToBooleanList$_MODULE$ = null;
    $java.oncief_ToBooleanList$_signatures = null;
    $java.oncief_ToBooleanList$_$callClinit = function() {
        $java.oncief_ToBooleanList$_$callClinit = $rt_eraseClinit($java.oncief_ToBooleanList$);
        $java.oncief_ToBooleanList$__clinit_();
    };
    $java.oncief_ToBooleanList$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_ToBooleanList$;
        $java.oncief_ToBooleanList$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToBooleanList$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToBooleanList$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = oncius_package$_MODULE$;
        var$8 = oncius_package$_CTList(var$7, oncius_package$_CTAny(var$7));
        var$7 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$8, oncius_package$_CTList(var$7, oncius_package$_CTBoolean(var$7)), $rt_s(2557), $java.oncief_Category$_LIST);
        $java.oncief_ToBooleanList$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToBooleanList$_name = function($this) {
        return $rt_s(2558);
    };
    $java.oncief_ToBooleanList$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToBooleanList$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToBooleanList$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToBooleanList$_hashCode = function($this) {
        return (-1895056565);
    };
    $java.oncief_ToBooleanList$_toString = function($this) {
        return $rt_s(2559);
    };
    $java.oncief_ToBooleanList$_signatures0 = function($this) {
        $java.oncief_ToBooleanList$_$callClinit();
        return $java.oncief_ToBooleanList$_signatures;
    };
    $java.oncief_ToBooleanOrNull$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToBooleanOrNull$_MODULE$ = null;
    $java.oncief_ToBooleanOrNull$_signatures = null;
    $java.oncief_ToBooleanOrNull$_$callClinit = function() {
        $java.oncief_ToBooleanOrNull$_$callClinit = $rt_eraseClinit($java.oncief_ToBooleanOrNull$);
        $java.oncief_ToBooleanOrNull$__clinit_();
    };
    $java.oncief_ToBooleanOrNull$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ToBooleanOrNull$;
        $java.oncief_ToBooleanOrNull$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToBooleanOrNull$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToBooleanOrNull$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTBoolean(oncius_package$_MODULE$), $rt_s(2560), $java.oncief_Category$_SCALAR);
        $java.oncief_ToBooleanOrNull$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToBooleanOrNull$_name = function($this) {
        return $rt_s(2561);
    };
    $java.oncief_ToBooleanOrNull$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToBooleanOrNull$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToBooleanOrNull$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToBooleanOrNull$_hashCode = function($this) {
        return 9875831;
    };
    $java.oncief_ToBooleanOrNull$_toString = function($this) {
        return $rt_s(2562);
    };
    $java.oncief_ToBooleanOrNull$_signatures0 = function($this) {
        $java.oncief_ToBooleanOrNull$_$callClinit();
        return $java.oncief_ToBooleanOrNull$_signatures;
    };
    $java.oncief_ToFloat$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToFloat$_MODULE$ = null;
    $java.oncief_ToFloat$_signatures = null;
    $java.oncief_ToFloat$_$callClinit = function() {
        $java.oncief_ToFloat$_$callClinit = $rt_eraseClinit($java.oncief_ToFloat$);
        $java.oncief_ToFloat$__clinit_();
    };
    $java.oncief_ToFloat$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_ToFloat$;
        $java.oncief_ToFloat$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToFloat$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToFloat$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 3);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$11[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$11[2] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2563), $java.oncief_Category$_SCALAR);
        $java.oncief_ToFloat$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToFloat$_name = function($this) {
        return $rt_s(2564);
    };
    $java.oncief_ToFloat$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToFloat$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToFloat$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToFloat$_hashCode = function($this) {
        return 486707329;
    };
    $java.oncief_ToFloat$_toString = function($this) {
        return $rt_s(2565);
    };
    $java.oncief_ToFloat$_signatures0 = function($this) {
        $java.oncief_ToFloat$_$callClinit();
        return $java.oncief_ToFloat$_signatures;
    };
    $java.oncief_ToFloatList$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToFloatList$_MODULE$ = null;
    $java.oncief_ToFloatList$_signatures = null;
    $java.oncief_ToFloatList$_$callClinit = function() {
        $java.oncief_ToFloatList$_$callClinit = $rt_eraseClinit($java.oncief_ToFloatList$);
        $java.oncief_ToFloatList$__clinit_();
    };
    $java.oncief_ToFloatList$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_ToFloatList$;
        $java.oncief_ToFloatList$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToFloatList$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToFloatList$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = oncius_package$_MODULE$;
        var$8 = oncius_package$_CTList(var$7, oncius_package$_CTAny(var$7));
        var$7 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$8, oncius_package$_CTList(var$7, $java.oncius_package$_CTFloat(var$7)), $rt_s(2566), $java.oncief_Category$_LIST);
        $java.oncief_ToFloatList$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToFloatList$_name = function($this) {
        return $rt_s(2567);
    };
    $java.oncief_ToFloatList$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToFloatList$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToFloatList$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToFloatList$_hashCode = function($this) {
        return (-1065841473);
    };
    $java.oncief_ToFloatList$_toString = function($this) {
        return $rt_s(2568);
    };
    $java.oncief_ToFloatList$_signatures0 = function($this) {
        $java.oncief_ToFloatList$_$callClinit();
        return $java.oncief_ToFloatList$_signatures;
    };
    $java.oncief_ToFloatOrNull$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToFloatOrNull$_MODULE$ = null;
    $java.oncief_ToFloatOrNull$_signatures = null;
    $java.oncief_ToFloatOrNull$_$callClinit = function() {
        $java.oncief_ToFloatOrNull$_$callClinit = $rt_eraseClinit($java.oncief_ToFloatOrNull$);
        $java.oncief_ToFloatOrNull$__clinit_();
    };
    $java.oncief_ToFloatOrNull$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ToFloatOrNull$;
        $java.oncief_ToFloatOrNull$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToFloatOrNull$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToFloatOrNull$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $rt_s(2569), $java.oncief_Category$_SCALAR);
        $java.oncief_ToFloatOrNull$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToFloatOrNull$_name = function($this) {
        return $rt_s(2570);
    };
    $java.oncief_ToFloatOrNull$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToFloatOrNull$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToFloatOrNull$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToFloatOrNull$_hashCode = function($this) {
        return (-1978337813);
    };
    $java.oncief_ToFloatOrNull$_toString = function($this) {
        return $rt_s(2571);
    };
    $java.oncief_ToFloatOrNull$_signatures0 = function($this) {
        $java.oncief_ToFloatOrNull$_$callClinit();
        return $java.oncief_ToFloatOrNull$_signatures;
    };
    $java.oncief_ToInteger$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToInteger$_MODULE$ = null;
    $java.oncief_ToInteger$_signatures = null;
    $java.oncief_ToInteger$_$callClinit = function() {
        $java.oncief_ToInteger$_$callClinit = $rt_eraseClinit($java.oncief_ToInteger$);
        $java.oncief_ToInteger$__clinit_();
    };
    $java.oncief_ToInteger$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_ToInteger$;
        $java.oncief_ToInteger$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToInteger$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToInteger$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 4);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$11[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$11[2] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$11[3] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2572), $java.oncief_Category$_SCALAR);
        $java.oncief_ToInteger$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToInteger$_name = function($this) {
        return $rt_s(2573);
    };
    $java.oncief_ToInteger$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToInteger$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToInteger$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToInteger$_hashCode = function($this) {
        return (-1996162525);
    };
    $java.oncief_ToInteger$_toString = function($this) {
        return $rt_s(2574);
    };
    $java.oncief_ToInteger$_signatures0 = function($this) {
        $java.oncief_ToInteger$_$callClinit();
        return $java.oncief_ToInteger$_signatures;
    };
    $java.oncief_ToIntegerList$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToIntegerList$_MODULE$ = null;
    $java.oncief_ToIntegerList$_signatures = null;
    $java.oncief_ToIntegerList$_$callClinit = function() {
        $java.oncief_ToIntegerList$_$callClinit = $rt_eraseClinit($java.oncief_ToIntegerList$);
        $java.oncief_ToIntegerList$__clinit_();
    };
    $java.oncief_ToIntegerList$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_ToIntegerList$;
        $java.oncief_ToIntegerList$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToIntegerList$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToIntegerList$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = oncius_package$_MODULE$;
        var$8 = oncius_package$_CTList(var$7, oncius_package$_CTAny(var$7));
        var$7 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$8, oncius_package$_CTList(var$7, oncius_package$_CTInteger(var$7)), $rt_s(2575), $java.oncief_Category$_LIST);
        $java.oncief_ToIntegerList$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToIntegerList$_name = function($this) {
        return $rt_s(2576);
    };
    $java.oncief_ToIntegerList$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToIntegerList$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToIntegerList$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToIntegerList$_hashCode = function($this) {
        return 738809185;
    };
    $java.oncief_ToIntegerList$_toString = function($this) {
        return $rt_s(2577);
    };
    $java.oncief_ToIntegerList$_signatures0 = function($this) {
        $java.oncief_ToIntegerList$_$callClinit();
        return $java.oncief_ToIntegerList$_signatures;
    };
    $java.oncief_ToIntegerOrNull$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToIntegerOrNull$_MODULE$ = null;
    $java.oncief_ToIntegerOrNull$_signatures = null;
    $java.oncief_ToIntegerOrNull$_$callClinit = function() {
        $java.oncief_ToIntegerOrNull$_$callClinit = $rt_eraseClinit($java.oncief_ToIntegerOrNull$);
        $java.oncief_ToIntegerOrNull$__clinit_();
    };
    $java.oncief_ToIntegerOrNull$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ToIntegerOrNull$;
        $java.oncief_ToIntegerOrNull$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToIntegerOrNull$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToIntegerOrNull$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), $rt_s(2578), $java.oncief_Category$_SCALAR);
        $java.oncief_ToIntegerOrNull$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToIntegerOrNull$_name = function($this) {
        return $rt_s(2579);
    };
    $java.oncief_ToIntegerOrNull$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToIntegerOrNull$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToIntegerOrNull$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToIntegerOrNull$_hashCode = function($this) {
        return 1419124237;
    };
    $java.oncief_ToIntegerOrNull$_toString = function($this) {
        return $rt_s(2580);
    };
    $java.oncief_ToIntegerOrNull$_signatures0 = function($this) {
        $java.oncief_ToIntegerOrNull$_$callClinit();
        return $java.oncief_ToIntegerOrNull$_signatures;
    };
    $java.oncief_ToLower$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToLower$_MODULE$ = null;
    $java.oncief_ToLower$_signatures = null;
    $java.oncief_ToLower$_$callClinit = function() {
        $java.oncief_ToLower$_$callClinit = $rt_eraseClinit($java.oncief_ToLower$);
        $java.oncief_ToLower$__clinit_();
    };
    $java.oncief_ToLower$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ToLower$;
        $java.oncief_ToLower$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToLower$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToLower$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2581), $java.oncief_Category$_STRING);
        $java.oncief_ToLower$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToLower$_name = function($this) {
        return $rt_s(2582);
    };
    $java.oncief_ToLower$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToLower$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToLower$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToLower$_hashCode = function($this) {
        return 492345638;
    };
    $java.oncief_ToLower$_toString = function($this) {
        return $rt_s(2583);
    };
    $java.oncief_ToLower$_signatures0 = function($this) {
        $java.oncief_ToLower$_$callClinit();
        return $java.oncief_ToLower$_signatures;
    };
    $java.oncief_ToString$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToString$_MODULE$ = null;
    $java.oncief_ToString$_validInputTypes = null;
    $java.oncief_ToString$_signatures = null;
    $java.oncief_ToString$_$callClinit = function() {
        $java.oncief_ToString$_$callClinit = $rt_eraseClinit($java.oncief_ToString$);
        $java.oncief_ToString$__clinit_();
    };
    $java.oncief_ToString$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ToString$;
        $java.oncief_ToString$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToString$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Seq(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(oncius_CypherType, 11);
        var$4 = var$3.data;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$4[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$4[2] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$4[3] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$4[4] = $java.oncius_package$_CTDuration0(oncius_package$_MODULE$);
        var$4[5] = $java.oncius_package$_CTDate0(oncius_package$_MODULE$);
        var$4[6] = $java.oncius_package$_CTTime0(oncius_package$_MODULE$);
        var$4[7] = $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$);
        var$4[8] = $java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$);
        var$4[9] = $java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$);
        var$4[10] = $java.oncius_package$_CTPoint0(oncius_package$_MODULE$);
        $java.oncief_ToString$_validInputTypes = sc_SeqFactory$Delegate_apply(var$1, sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
        var$5 = s_package$_Vector0(s_package$_MODULE$);
        var$6 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$3.data[0] = $java.oncie_TypeSignature$_apply0($java.oncie_TypeSignature$_MODULE$, $java.oncief_ToString$_MODULE$, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2584), $java.oncief_Category$_STRING);
        $java.oncief_ToString$_signatures = var$5.$from0(sr_ScalaRunTime$_wrapRefArray(var$6, var$3));
    };
    $java.oncief_ToString$_name = function($this) {
        return $rt_s(2585);
    };
    $java.oncief_ToString$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToString$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToString$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToString$_hashCode = function($this) {
        return (-1712277876);
    };
    $java.oncief_ToString$_toString = function($this) {
        return $rt_s(2586);
    };
    $java.oncief_ToString$_signatures0 = function($this) {
        $java.oncief_ToString$_$callClinit();
        return $java.oncief_ToString$_signatures;
    };
    $java.oncief_ToStringList$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToStringList$_MODULE$ = null;
    $java.oncief_ToStringList$_signatures = null;
    $java.oncief_ToStringList$_$callClinit = function() {
        $java.oncief_ToStringList$_$callClinit = $rt_eraseClinit($java.oncief_ToStringList$);
        $java.oncief_ToStringList$__clinit_();
    };
    $java.oncief_ToStringList$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = new $java.oncief_ToStringList$;
        $java.oncief_ToStringList$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToStringList$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToStringList$_MODULE$;
        oncius_package$_$callClinit();
        var$7 = oncius_package$_MODULE$;
        var$8 = oncius_package$_CTList(var$7, oncius_package$_CTAny(var$7));
        var$7 = oncius_package$_MODULE$;
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$8, oncius_package$_CTList(var$7, oncius_package$_CTString(var$7)), $rt_s(2587), $java.oncief_Category$_LIST);
        $java.oncief_ToStringList$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToStringList$_name = function($this) {
        return $rt_s(2588);
    };
    $java.oncief_ToStringList$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToStringList$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToStringList$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToStringList$_hashCode = function($this) {
        return 780055882;
    };
    $java.oncief_ToStringList$_toString = function($this) {
        return $rt_s(2589);
    };
    $java.oncief_ToStringList$_signatures0 = function($this) {
        $java.oncief_ToStringList$_$callClinit();
        return $java.oncief_ToStringList$_signatures;
    };
    $java.oncief_ToStringOrNull$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToStringOrNull$_MODULE$ = null;
    $java.oncief_ToStringOrNull$_signatures = null;
    $java.oncief_ToStringOrNull$_$callClinit = function() {
        $java.oncief_ToStringOrNull$_$callClinit = $rt_eraseClinit($java.oncief_ToStringOrNull$);
        $java.oncief_ToStringOrNull$__clinit_();
    };
    $java.oncief_ToStringOrNull$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ToStringOrNull$;
        $java.oncief_ToStringOrNull$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToStringOrNull$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToStringOrNull$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2590), $java.oncief_Category$_STRING);
        $java.oncief_ToStringOrNull$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToStringOrNull$_name = function($this) {
        return $rt_s(2591);
    };
    $java.oncief_ToStringOrNull$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToStringOrNull$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToStringOrNull$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToStringOrNull$_hashCode = function($this) {
        return (-1892472906);
    };
    $java.oncief_ToStringOrNull$_toString = function($this) {
        return $rt_s(2592);
    };
    $java.oncief_ToStringOrNull$_signatures0 = function($this) {
        $java.oncief_ToStringOrNull$_$callClinit();
        return $java.oncief_ToStringOrNull$_signatures;
    };
    $java.oncief_ToUpper$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ToUpper$_MODULE$ = null;
    $java.oncief_ToUpper$_signatures = null;
    $java.oncief_ToUpper$_$callClinit = function() {
        $java.oncief_ToUpper$_$callClinit = $rt_eraseClinit($java.oncief_ToUpper$);
        $java.oncief_ToUpper$__clinit_();
    };
    $java.oncief_ToUpper$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ToUpper$;
        $java.oncief_ToUpper$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ToUpper$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ToUpper$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2593), $java.oncief_Category$_STRING);
        $java.oncief_ToUpper$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ToUpper$_name = function($this) {
        return $rt_s(2594);
    };
    $java.oncief_ToUpper$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ToUpper$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ToUpper$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ToUpper$_hashCode = function($this) {
        return 500680391;
    };
    $java.oncief_ToUpper$_toString = function($this) {
        return $rt_s(2595);
    };
    $java.oncief_ToUpper$_signatures0 = function($this) {
        $java.oncief_ToUpper$_$callClinit();
        return $java.oncief_ToUpper$_signatures;
    };
    $java.oncief_Properties$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Properties$_MODULE$ = null;
    $java.oncief_Properties$_signatures = null;
    $java.oncief_Properties$_$callClinit = function() {
        $java.oncief_Properties$_$callClinit = $rt_eraseClinit($java.oncief_Properties$);
        $java.oncief_Properties$__clinit_();
    };
    $java.oncief_Properties$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$1 = new $java.oncief_Properties$;
        $java.oncief_Properties$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Properties$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Properties$_MODULE$;
        var$7 = new oncius_ClosedDynamicUnionType;
        s_Predef$_$callClinit();
        var$8 = s_Predef$_Set(s_Predef$_MODULE$);
        var$9 = sr_ScalaRunTime$_MODULE$;
        var$10 = $rt_createArray(oncius_CypherType, 3);
        var$11 = var$10.data;
        oncius_package$_$callClinit();
        var$11[0] = oncius_package$_CTNode(oncius_package$_MODULE$);
        var$11[1] = oncius_package$_CTRelationship(oncius_package$_MODULE$);
        var$11[2] = oncius_package$_CTMap(oncius_package$_MODULE$);
        var$12 = var$8.$from0(sr_ScalaRunTime$_wrapRefArray(var$9, var$10));
        onciu_InputPosition$_$callClinit();
        $java.oncius_ClosedDynamicUnionType__init_(var$7, var$12, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, var$7, oncius_package$_CTMap(oncius_package$_MODULE$), $rt_s(2596), $java.oncief_Category$_SCALAR);
        $java.oncief_Properties$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Properties$_name = function($this) {
        return $rt_s(541);
    };
    $java.oncief_Properties$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Properties$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Properties$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Properties$_hashCode = function($this) {
        return 1067411795;
    };
    $java.oncief_Properties$_toString = function($this) {
        return $rt_s(2597);
    };
    $java.oncief_Properties$_signatures0 = function($this) {
        $java.oncief_Properties$_$callClinit();
        return $java.oncief_Properties$_signatures;
    };
    $java.oncief_Trim$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Trim$_MODULE$ = null;
    $java.oncief_Trim$_signatures = null;
    $java.oncief_Trim$_$callClinit = function() {
        $java.oncief_Trim$_$callClinit = $rt_eraseClinit($java.oncief_Trim$);
        $java.oncief_Trim$__clinit_();
    };
    $java.oncief_Trim$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Trim$;
        $java.oncief_Trim$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Trim$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Trim$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTString(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2598), $java.oncief_Category$_STRING);
        $java.oncief_Trim$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Trim$_name = function($this) {
        return $rt_s(2599);
    };
    $java.oncief_Trim$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Trim$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Trim$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Trim$_hashCode = function($this) {
        return 2615362;
    };
    $java.oncief_Trim$_toString = function($this) {
        return $rt_s(2600);
    };
    $java.oncief_Trim$_signatures0 = function($this) {
        $java.oncief_Trim$_$callClinit();
        return $java.oncief_Trim$_signatures;
    };
    $java.oncief_Type$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_Type$_MODULE$ = null;
    $java.oncief_Type$_signatures = null;
    $java.oncief_Type$_$callClinit = function() {
        $java.oncief_Type$_$callClinit = $rt_eraseClinit($java.oncief_Type$);
        $java.oncief_Type$__clinit_();
    };
    $java.oncief_Type$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_Type$;
        $java.oncief_Type$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_Type$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_Type$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTRelationship(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2601), $java.oncief_Category$_SCALAR);
        $java.oncief_Type$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_Type$_name = function($this) {
        return $rt_s(538);
    };
    $java.oncief_Type$_productArity = function($this) {
        return 0;
    };
    $java.oncief_Type$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_Type$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_Type$_hashCode = function($this) {
        return 2622298;
    };
    $java.oncief_Type$_toString = function($this) {
        return $rt_s(2602);
    };
    $java.oncief_Type$_signatures0 = function($this) {
        $java.oncief_Type$_$callClinit();
        return $java.oncief_Type$_signatures;
    };
    $java.oncief_ValueType$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_ValueType$_MODULE$ = null;
    $java.oncief_ValueType$_signatures = null;
    $java.oncief_ValueType$_$callClinit = function() {
        $java.oncief_ValueType$_$callClinit = $rt_eraseClinit($java.oncief_ValueType$);
        $java.oncief_ValueType$__clinit_();
    };
    $java.oncief_ValueType$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = new $java.oncief_ValueType$;
        $java.oncief_ValueType$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_ValueType$_MODULE$ = var$1;
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = $java.oncief_ValueType$_MODULE$;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncie_TypeSignature$_apply0(var$5, var$6, oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTString(oncius_package$_MODULE$), $rt_s(2603), $java.oncief_Category$_SCALAR);
        $java.oncief_ValueType$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_ValueType$_name = function($this) {
        return $rt_s(2604);
    };
    $java.oncief_ValueType$_productArity = function($this) {
        return 0;
    };
    $java.oncief_ValueType$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_ValueType$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_ValueType$_hashCode = function($this) {
        return 1238275115;
    };
    $java.oncief_ValueType$_toString = function($this) {
        return $rt_s(2605);
    };
    $java.oncief_ValueType$_signatures0 = function($this) {
        $java.oncief_ValueType$_$callClinit();
        return $java.oncief_ValueType$_signatures;
    };
    $java.oncief_WithinBBox$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_WithinBBox$_MODULE$ = null;
    $java.oncief_WithinBBox$_name = null;
    $java.oncief_WithinBBox$_signatures = null;
    $java.oncief_WithinBBox$_$callClinit = function() {
        $java.oncief_WithinBBox$_$callClinit = $rt_eraseClinit($java.oncief_WithinBBox$);
        $java.oncief_WithinBBox$__clinit_();
    };
    $java.oncief_WithinBBox$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, $x$1, $x$2, $x$4, $x$7, var$9, var$10, $x$3;
        var$1 = new $java.oncief_WithinBBox$;
        $java.oncief_WithinBBox$_$callClinit();
        $java.oncief_Function__init_(var$1);
        $java.oncief_WithinBBox$_MODULE$ = var$1;
        $java.oncief_WithinBBox$_name = $rt_s(2606);
        s_package$_$callClinit();
        var$1 = s_package$_Vector0(s_package$_MODULE$);
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray($java.oncie_FunctionTypeSignature, 1);
        var$4 = var$3.data;
        $x$1 = $java.oncief_WithinBBox$_MODULE$;
        $x$2 = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(jl_String, [$rt_s(2472), $rt_s(2607), $rt_s(2608)])));
        $x$4 = s_package$_Vector0(s_package$_MODULE$);
        $x$7 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_PointType, 3);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = $java.oncius_package$_CTPoint0(oncius_package$_MODULE$);
        var$10[1] = $java.oncius_package$_CTPoint0(oncius_package$_MODULE$);
        var$10[2] = $java.oncius_package$_CTPoint0(oncius_package$_MODULE$);
        $x$3 = $x$4.$from0(sr_ScalaRunTime$_wrapRefArray($x$7, var$9));
        var$4[0] = $java.oncie_FunctionTypeSignature__init_0($x$1, oncius_package$_CTBoolean(oncius_package$_MODULE$), $x$2, $rt_s(2609), $java.oncief_Category$_SPATIAL, $x$3, $java.oncie_FunctionTypeSignature$_apply$default$7($java.oncie_FunctionTypeSignature$_MODULE$), 0, s_None$_MODULE$);
        $java.oncief_WithinBBox$_signatures = var$1.$from0(sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncief_WithinBBox$_name0 = function($this) {
        $java.oncief_WithinBBox$_$callClinit();
        return $java.oncief_WithinBBox$_name;
    };
    $java.oncief_WithinBBox$_productArity = function($this) {
        return 0;
    };
    $java.oncief_WithinBBox$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_WithinBBox$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_WithinBBox$_hashCode = function($this) {
        return 502356276;
    };
    $java.oncief_WithinBBox$_toString = function($this) {
        return $rt_s(2610);
    };
    $java.oncief_WithinBBox$_signatures0 = function($this) {
        $java.oncief_WithinBBox$_$callClinit();
        return $java.oncief_WithinBBox$_signatures;
    };
    $java.oncie_FunctionTypeSignature = function() {
        var a = this; jl_Object.call(a);
        a.$function2 = null;
        a.$outputType0 = null;
        a.$names1 = null;
        a.$description6 = null;
        a.$category = null;
        a.$argumentTypes0 = null;
        a.$optionalTypes = null;
        a.$deprecated = 0;
        a.$overrideDefaultAsString = null;
    };
    $java.oncie_FunctionTypeSignature__init_0 = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8) {
        var var_9 = new $java.oncie_FunctionTypeSignature();
        $java.oncie_FunctionTypeSignature__init_(var_9, var_0, var_1, var_2, var_3, var_4, var_5, var_6, var_7, var_8);
        return var_9;
    };
    $java.oncie_FunctionTypeSignature_outputType = function($this) {
        return $this.$outputType0;
    };
    $java.oncie_FunctionTypeSignature_argumentTypes = function($this) {
        return $this.$argumentTypes0;
    };
    $java.oncie_FunctionTypeSignature_removeFirstArgumentType = function($this) {
        var $x$1;
        $x$1 = $this.$argumentTypes0.$tail();
        return $java.oncie_FunctionTypeSignature__init_0($this.$function2, $this.$outputType0, $this.$names1, $this.$description6, $this.$category, $x$1, $this.$optionalTypes, $this.$deprecated, $this.$overrideDefaultAsString);
    };
    $java.oncie_FunctionTypeSignature_productPrefix = function($this) {
        return $rt_s(2611);
    };
    $java.oncie_FunctionTypeSignature_productArity = function($this) {
        return 9;
    };
    $java.oncie_FunctionTypeSignature_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$function2;
            case 1:
                return $this.$outputType0;
            case 2:
                return $this.$names1;
            case 3:
                return $this.$description6;
            case 4:
                return $this.$category;
            case 5:
                return $this.$argumentTypes0;
            case 6:
                return $this.$optionalTypes;
            case 7:
                return jl_Boolean_valueOf($this.$deprecated);
            case 8:
                return $this.$overrideDefaultAsString;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_FunctionTypeSignature_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FunctionTypeSignature_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2611))), sr_Statics_anyHash($this.$function2)), sr_Statics_anyHash($this.$outputType0)), sr_Statics_anyHash($this.$names1)), sr_Statics_anyHash($this.$description6)), sr_Statics_anyHash($this.$category)), sr_Statics_anyHash($this.$argumentTypes0)), sr_Statics_anyHash($this.$optionalTypes)),
        !$this.$deprecated ? 1237 : 1231), sr_Statics_anyHash($this.$overrideDefaultAsString)), 9);
    };
    $java.oncie_FunctionTypeSignature_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FunctionTypeSignature_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncie_FunctionTypeSignature) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$deprecated != $x$1.$deprecated)
                        break b;
                    c: {
                        var$2 = $this.$function2;
                        var$3 = $x$1.$function2;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$outputType0;
                        var$3 = $x$1.$outputType0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$names1;
                        var$3 = $x$1.$names1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$description6;
                        var$3 = $x$1.$description6;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$2 = $this.$category;
                        var$3 = $x$1.$category;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break g;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    h: {
                        var$2 = $this.$argumentTypes0;
                        var$3 = $x$1.$argumentTypes0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break h;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    i: {
                        var$2 = $this.$optionalTypes;
                        var$3 = $x$1.$optionalTypes;
                        if (var$2 !== null) {
                            if (!sci_Vector0$_equals(var$2, var$3))
                                break b;
                            else
                                break i;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    j: {
                        var$3 = $this.$overrideDefaultAsString;
                        $x$1 = $x$1.$overrideDefaultAsString;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break j;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncie_FunctionTypeSignature))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_FunctionTypeSignature__init_ = function($this, $function, $outputType, $names, $description, $category, $argumentTypes, $optionalTypes, $deprecated, $overrideDefaultAsString) {
        $this.$function2 = $function;
        $this.$outputType0 = $outputType;
        $this.$names1 = $names;
        $this.$description6 = $description;
        $this.$category = $category;
        $this.$argumentTypes0 = $argumentTypes;
        $this.$optionalTypes = $optionalTypes;
        $this.$deprecated = $deprecated;
        $this.$overrideDefaultAsString = $overrideDefaultAsString;
    };
    function s_Enumeration() {
        var a = this; jl_Object.call(a);
        a.$scala$Enumeration$$vmap = null;
        a.$vset = null;
        a.$scala$Enumeration$$vsetDefined = 0;
        a.$nmap = null;
        a.$nextId = 0;
        a.$nextName = null;
        a.$scala$Enumeration$$topId = 0;
        a.$scala$Enumeration$$bottomId = 0;
    }
    $java.s_Enumeration_Value = function($this) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = $this.$nextId;
        var$2 = $this.$nextName;
        var$2 = var$2 !== null && var$2.$hasNext() ? $this.$nextName.$next() : null;
        var$3 = new $java.s_Enumeration$Val;
        var$3.$i2 = var$1;
        var$3.$name58 = var$2;
        var$3.$$outer44 = $this;
        var$3.$scala$Enumeration$$outerEnum = $this;
        var$4 = $this.$scala$Enumeration$$vmap;
        var$2 = jl_Integer_valueOf(var$1);
        var$5 = sr_Statics_anyHash(var$2);
        var$5 = var$5 ^ var$5 >>> 16;
        var$6 = var$4.$scala$collection$mutable$HashMap$$table.data;
        var$4 = var$6[var$5 & (var$6.length - 1 | 0)];
        if (!(((var$4 !== null ? scm_HashMap$Node_findNode(var$4, var$2, var$5) : null) === null ? 0 : 1) ? 0 : 1)) {
            var$2 = new jl_AssertionError;
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$4, 18);
            jl_AbstractStringBuilder_append1(var$4, $rt_s(1038));
            var$7 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$7, 14);
            jl_AbstractStringBuilder_append1(var$7, $rt_s(2612));
            jl_AssertionError__init_0(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$4, jl_AbstractStringBuilder_toString(jl_StringBuilder_append0(var$7, var$3.$i2)))));
            $rt_throw(var$2);
        }
        scm_HashMap_update($this.$scala$Enumeration$$vmap, jl_Integer_valueOf(var$1), var$3);
        $this.$scala$Enumeration$$vsetDefined = 0;
        var$8 = var$1 + 1 | 0;
        $this.$nextId = var$8;
        if (var$8 > $this.$scala$Enumeration$$topId)
            $this.$scala$Enumeration$$topId = var$8;
        if (var$1 < $this.$scala$Enumeration$$bottomId)
            $this.$scala$Enumeration$$bottomId = var$1;
        return var$3;
    };
    $java.s_Enumeration_populateNameMap = function($this) {
        var $filter$extension_make_evidence$1, $fields, $filter$extension_res, $refArrayOps_xs, $filter$extension_i, $foreach$extension_len, $filter$extension_x, $foreach$extension_i, var$9, $foreach$extension_$this, var$11, var$12;
        $filter$extension_make_evidence$1 = jl_Class_getSuperclass(jl_Object_getClass($this));
        $fields = jl_Class_getDeclaredFields(jl_Object_getClass($this));
        while ($filter$extension_make_evidence$1 !== null) {
            $filter$extension_res = jl_Class_getSuperclass($filter$extension_make_evidence$1);
            if (!((jl_Class_getDeclaredFields($filter$extension_make_evidence$1)).data.length ? 0 : 1)) {
                $refArrayOps_xs = jl_Class_getDeclaredFields($filter$extension_make_evidence$1);
                sr_ClassTag$_$callClinit();
                $filter$extension_make_evidence$1 = sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(jlr_Field));
                $filter$extension_make_evidence$1 = s_Array$_copyAs(s_Array$_MODULE$, $fields, jlr_Array_getLength($fields) + jlr_Array_getLength($refArrayOps_xs) | 0, $filter$extension_make_evidence$1);
                s_Array$_copy(s_Array$_MODULE$, $refArrayOps_xs, 0, $filter$extension_make_evidence$1, jlr_Array_getLength($fields), jlr_Array_getLength($refArrayOps_xs));
                $fields = $filter$extension_make_evidence$1;
            }
            $filter$extension_make_evidence$1 = $filter$extension_res;
        }
        $filter$extension_make_evidence$1 = jl_Object_getClass($this);
        $filter$extension_res = $java.ju_HashMap__init_();
        jl_Class_findMethods($filter$extension_make_evidence$1, $filter$extension_res);
        if ($filter$extension_res.$cachedValues === null) {
            $filter$extension_make_evidence$1 = new $java.ju_HashMap$2;
            $filter$extension_make_evidence$1.$this$04 = $filter$extension_res;
            $filter$extension_res.$cachedValues = $filter$extension_make_evidence$1;
        }
        a: {
            $refArrayOps_xs = ju_AbstractCollection_toArray($filter$extension_res.$cachedValues, $rt_createArray(jlr_Method, $filter$extension_res.$elementCount1));
            sr_ClassTag$_$callClinit();
            $filter$extension_make_evidence$1 = sr_ClassTag$_apply(sr_ClassTag$_MODULE$, jl_Class_getComponentType(jl_Object_getClass($refArrayOps_xs)));
            $filter$extension_res = $filter$extension_make_evidence$1.$runtimeClass();
            if (jl_Object_equals($rt_cls($rt_bytecls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofByte;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_shortcls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofShort;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_charcls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofChar;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_intcls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofInt;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_longcls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofLong;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_floatcls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofFloat;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_doublecls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofDouble;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_booleancls()), $filter$extension_res)) {
                $filter$extension_res = new scm_ArrayBuilder$ofBoolean;
                scm_ArrayBuilder__init_($filter$extension_res);
                break a;
            }
            if (!jl_Object_equals($rt_cls($rt_voidcls()), $filter$extension_res)) {
                $filter$extension_res = scm_ArrayBuilder$ofRef__init_($filter$extension_make_evidence$1);
                break a;
            }
            $filter$extension_res = new scm_ArrayBuilder$ofUnit;
            scm_ArrayBuilder__init_($filter$extension_res);
        }
        $refArrayOps_xs = $refArrayOps_xs.data;
        $filter$extension_i = 0;
        $foreach$extension_len = $refArrayOps_xs.length;
        while ($filter$extension_i < $foreach$extension_len) {
            $filter$extension_x = $refArrayOps_xs[$filter$extension_i];
            $foreach$extension_i = (jlr_Method_getParameterTypes($filter$extension_x)).data.length ? 0 : 1;
            b: {
                if ($foreach$extension_i && jl_Class_isAssignableFrom($rt_cls(s_Enumeration$Value), $filter$extension_x.$returnType)) {
                    var$9 = $filter$extension_x.$declaringClass0;
                    if (!(var$9 !== null && jl_Object_equals(var$9, $rt_cls(s_Enumeration)))) {
                        $foreach$extension_i = 0;
                        c: {
                            while (true) {
                                $foreach$extension_$this = $fields.data;
                                if ($foreach$extension_i >= $foreach$extension_$this.length) {
                                    $foreach$extension_i = (-1);
                                    break c;
                                }
                                d: {
                                    e: {
                                        f: {
                                            $filter$extension_make_evidence$1 = $foreach$extension_$this[$foreach$extension_i];
                                            var$11 = $filter$extension_make_evidence$1.$name0;
                                            var$9 = $filter$extension_x.$name1;
                                            if (var$11 !== null) {
                                                if (!jl_String_equals(var$11, var$9))
                                                    break e;
                                                else
                                                    break f;
                                            }
                                            if (var$9 !== null)
                                                break e;
                                        }
                                        g: {
                                            var$9 = $filter$extension_make_evidence$1.$type;
                                            $filter$extension_make_evidence$1 = $filter$extension_x.$returnType;
                                            if (var$9 !== null) {
                                                if (!jl_Object_equals(var$9, $filter$extension_make_evidence$1))
                                                    break e;
                                                else
                                                    break g;
                                            }
                                            if ($filter$extension_make_evidence$1 !== null)
                                                break e;
                                        }
                                        var$12 = 1;
                                        break d;
                                    }
                                    var$12 = 0;
                                }
                                if (var$12)
                                    break;
                                $foreach$extension_i = $foreach$extension_i + 1 | 0;
                            }
                        }
                        if ($foreach$extension_i < 0 ? 0 : 1) {
                            $foreach$extension_i = 1;
                            break b;
                        }
                    }
                }
                $foreach$extension_i = 0;
            }
            if ($foreach$extension_i)
                $filter$extension_res.$addOne($filter$extension_x);
            $filter$extension_i = $filter$extension_i + 1 | 0;
        }
        $fields = ($filter$extension_res.$result0()).data;
        $foreach$extension_len = $fields.length;
        $foreach$extension_i = 0;
        while ($foreach$extension_i < $foreach$extension_len) {
            $filter$extension_make_evidence$1 = $fields[$foreach$extension_i];
            var$9 = $filter$extension_make_evidence$1.$name1;
            $filter$extension_make_evidence$1 = $java.jlr_Method_invoke($filter$extension_make_evidence$1, $this, $rt_createArray(jl_Object, 0));
            if ($filter$extension_make_evidence$1.$scala$Enumeration$$outerEnum0() === $this) {
                $filter$extension_i = $filter$extension_make_evidence$1.$id1();
                $filter$extension_make_evidence$1 = $this.$nmap;
                $filter$extension_res = s_Tuple2__init_(jl_Integer_valueOf($filter$extension_i), var$9);
                if ($filter$extension_make_evidence$1 === null)
                    $rt_throw(null);
                scm_HashMap_addOne($filter$extension_make_evidence$1, $filter$extension_res);
            }
            $foreach$extension_i = $foreach$extension_i + 1 | 0;
        }
    };
    $java.s_Enumeration_scala$Enumeration$$nameOf = function($this, $i) {
        var var$2, var$3, var$4;
        jl_Object_monitorEnterSync($this);
        try {
            var$2 = $this.$nmap;
            var$3 = jl_Integer_valueOf($i);
            var$4 = new $java.s_Enumeration$scala$Enumeration$$nameOf$lambda$_23_0;
            var$4.$_0441 = $this;
            var$4.$_1131 = $i;
            return scm_HashMap_getOrElse(var$2, var$3, var$4);
        } finally {
            jl_Object_monitorExitSync($this);
        }
    };
    $java.s_Enumeration__init_ = function($this) {
        $this.$scala$Enumeration$$vmap = scm_HashMap__init_();
        $this.$vset = null;
        $this.$scala$Enumeration$$vsetDefined = 0;
        $this.$nmap = scm_HashMap__init_();
        $this.$nextId = 0;
        $this.$scala$Enumeration$$topId = 0;
        $this.$scala$Enumeration$$bottomId = 0;
    };
    var oncief_Category$ = $rt_classWithoutFields(s_Enumeration);
    $java.oncief_Category$_MODULE$ = null;
    $java.oncief_Category$_NUMERIC = null;
    $java.oncief_Category$_TRIGONOMETRIC = null;
    $java.oncief_Category$_PREDICATE = null;
    $java.oncief_Category$_AGGREGATING = null;
    $java.oncief_Category$_SCALAR = null;
    $java.oncief_Category$_TEMPORAL = null;
    $java.oncief_Category$_LOGARITHMIC = null;
    $java.oncief_Category$_LIST = null;
    $java.oncief_Category$_STRING = null;
    $java.oncief_Category$_SPATIAL = null;
    function oncief_Category$__clinit_() {
        var var$1;
        var$1 = new oncief_Category$;
        $java.s_Enumeration__init_(var$1);
        $java.oncief_Category$_MODULE$ = var$1;
        $java.oncief_Category$_NUMERIC = $rt_s(2613);
        $java.oncief_Category$_TRIGONOMETRIC = $rt_s(2614);
        $java.oncief_Category$_PREDICATE = $rt_s(2615);
        $java.oncief_Category$_AGGREGATING = $rt_s(2616);
        $java.oncief_Category$_SCALAR = $rt_s(2617);
        $java.oncief_Category$_TEMPORAL = $rt_s(2618);
        $java.oncief_Category$_LOGARITHMIC = $rt_s(2619);
        $java.oncief_Category$_LIST = $rt_s(34);
        $java.oncief_Category$_STRING = $rt_s(1743);
        $java.oncief_Category$_SPATIAL = $rt_s(2620);
    }
    $java.s_Function9 = $rt_classWithoutFields(0);
    $java.sr_AbstractFunction9 = $rt_classWithoutFields();
    var oncie_FunctionTypeSignature$ = $rt_classWithoutFields($java.sr_AbstractFunction9);
    $java.oncie_FunctionTypeSignature$_MODULE$ = null;
    function oncie_FunctionTypeSignature$__clinit_() {
        $java.oncie_FunctionTypeSignature$_MODULE$ = new oncie_FunctionTypeSignature$;
    }
    $java.oncie_FunctionTypeSignature$_apply$default$7 = function($this) {
        s_package$_$callClinit();
        return sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$));
    };
    var onciu_RewritableCompat$PROXY$3_211 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_211_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ShowFunctionsClause_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4].$value8, var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_214 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_214_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ShowIndexesClause_copy(var$2, var$3[0], var$3[1], var$3[2].$value8, var$3[3].$value8, var$3[4], var$3[5].$value8, var$3[6]);
    }
    var onciu_RewritableCompat$PROXY$3_215 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_215_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_OnMatch__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_216 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_216_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_LabelName__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_217 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_217_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_OnCreate__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_218 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_218_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_PatternPartWithSelector__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_219 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_219_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_RelTypeName__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_221 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_221_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ParameterName__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_222 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_222_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ShowProceduresClause_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3].$value8, var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_223 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_223_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_OrderBy__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_224 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_224_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_StringLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_225 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_225_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_Where__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_226 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_226_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ShowSettingsClause_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3].$value8, var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_227 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_227_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ProcedureResult_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_228 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_228_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ShowConstraintsClause_copy(var$2, var$3[0], var$3[1], var$3[2].$value8, var$3[3].$value8, var$3[4], var$3[5].$value8, var$3[6]);
    }
    var onciu_RewritableCompat$PROXY$3_229 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_229_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_UsingScanHint__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_230 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_230_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SetPropertyItem__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_231 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_231_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_NamedPatternPart__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_232 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_232_copyConstructor(var$1, var$2, var$3) {
        return oncia_RemovePropertyItem__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_233 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_233_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_And_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_234 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_234_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_RemoveLabelItem__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_235 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_235_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SetExactPropertiesFromMapItem_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_236 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_236_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SetIncludingPropertiesFromMapItem_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_237 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_237_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SetLabelItem__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_238 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_238_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_CreateUser__init_(var$3[0], var$3[1].$value8, var$3[2], var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_239 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_239_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_CreateRole__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_240 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_240_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_CreateCompositeDatabase__init_(var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_241 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_241_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_CreateDatabase__init_(var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_242 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_242_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateLocalDatabaseAlias__init_(var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_243 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_243_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateRemoteDatabaseAlias__init_(var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7], var$3[8]);
    }
    var onciu_RewritableCompat$PROXY$3_249 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_249_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_ExplicitParameter_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_251 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_251_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_SensitiveStringLiteral__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_254 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_254_copyConstructor(var$1, var$2, var$3) {
        return $java.oncius_NullType_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_255 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_255_copyConstructor(var$1, var$2, var$3) {
        return $java.oncius_NothingType_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_256 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_256_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_ExplicitParameter_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_257 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_257_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_PropertyValueType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_259 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_259_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_ClosedDynamicUnionType_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_290 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_290_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_NumberType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    $java.ju_TemplateCollections$ImmutableArrayList = function() {
        ju_TemplateCollections$AbstractImmutableList.call(this);
        this.$list1 = null;
    };
    $java.ju_TemplateCollections$ImmutableArrayList_get = function($this, $index) {
        return $this.$list1.data[$index];
    };
    $java.ju_TemplateCollections$ImmutableArrayList_size = function($this) {
        return $this.$list1.data.length;
    };
    $java.s_PartialFunction$Combined$applyOrElse$lambda$_36_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0442 = null;
        a.$_1132 = null;
    };
    $java.oncil_LabelExpression = $rt_classWithoutFields(0);
    $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$ = function($$this) {
        var var$2;
        if (!($$this instanceof oncil_LabelExpression$ColonConjunction))
            var$2 = !($$this instanceof oncil_LabelExpression$Leaf) ? 1 : 0;
        else {
            $$this = $$this;
            var$2 = !$$this.$lhs4.$containsGpmSpecificLabelExpression() && !$$this.$rhs4.$containsGpmSpecificLabelExpression() ? 0 : 1;
        }
        return var$2;
    };
    $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$ = function($$this) {
        var var$2, var$3;
        if ($$this instanceof oncil_LabelExpression$Disjunctions)
            var$2 = $$this.$children.$exists(new $java.oncil_LabelExpression$containsGpmSpecificRelTypeExpression$lambda$_7_0);
        else if (!($$this instanceof oncil_LabelExpression$ColonDisjunction))
            var$2 = !($$this instanceof oncil_LabelExpression$Leaf) ? 1 : 0;
        else {
            $$this = $$this;
            var$3 = $$this.$lhs3;
            $$this = $$this.$rhs3;
            var$2 = !var$3.$containsGpmSpecificRelTypeExpression() && !$$this.$containsGpmSpecificRelTypeExpression() ? 0 : 1;
        }
        return var$2;
    };
    $java.oncil_LabelExpression_replaceColonSyntax$ = function($$this) {
        var var$2;
        var$2 = onciu_bottomUp$_MODULE$;
        return (onciu_bottomUp$_apply(var$2, new $java.oncil_LabelExpression$replaceColonSyntax$lambda$_9_0, onciu_bottomUp$_apply$default$2(var$2), onciu_CancellationChecker$NeverCancelled$_MODULE$)).$apply($$this);
    };
    var oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncie_LabelName);
    };
    function oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_1() {
        var a = this; jl_Object.call(a);
        a.$_0264 = null;
        a.$_171 = null;
    }
    $java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0264;
        var$3 = var$0.$_171;
        return oncifp_ValidSymbolicNamesInLabelExpressions$_org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames(oncifp_ValidSymbolicNamesInLabelExpressions$_MODULE$, $rt_s(2621), var$2, var$3, var$1);
    };
    var oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_2 = $rt_classWithoutFields();
    $java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncie_RelTypeName);
    };
    function oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_3() {
        var a = this; jl_Object.call(a);
        a.$_0265 = null;
        a.$_172 = null;
    }
    $java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_3_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0265;
        var$3 = var$0.$_172;
        return oncifp_ValidSymbolicNamesInLabelExpressions$_org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames(oncifp_ValidSymbolicNamesInLabelExpressions$_MODULE$, $rt_s(2622), var$2, var$3, var$1);
    };
    function oncil_LabelExpressionPredicate() {
        var a = this; oncie_Expression.call(a);
        a.$entity0 = null;
        a.$labelExpression3 = null;
        a.$position195 = null;
    }
    function oncil_LabelExpressionPredicate__init_(var_0, var_1, var_2) {
        var var_3 = new oncil_LabelExpressionPredicate();
        $java.oncil_LabelExpressionPredicate__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncil_LabelExpressionPredicate_entity($this) {
        return $this.$entity0;
    }
    function oncil_LabelExpressionPredicate_labelExpression($this) {
        return $this.$labelExpression3;
    }
    $java.oncil_LabelExpressionPredicate_position = function($this) {
        return $this.$position195;
    };
    $java.oncil_LabelExpressionPredicate_productPrefix = function($this) {
        return $rt_s(2623);
    };
    $java.oncil_LabelExpressionPredicate_productArity = function($this) {
        return 2;
    };
    $java.oncil_LabelExpressionPredicate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$entity0;
            case 1:
                return $this.$labelExpression3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpressionPredicate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpressionPredicate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpressionPredicate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpressionPredicate_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncil_LabelExpressionPredicate) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$entity0;
                        var$3 = $x$1.$entity0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$labelExpression3;
                        $x$1 = $x$1.$labelExpression3;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncil_LabelExpressionPredicate))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncil_LabelExpressionPredicate__init_ = function($this, $entity, $labelExpression, $position) {
        $this.$entity0 = $entity;
        $this.$labelExpression3 = $labelExpression;
        $this.$position195 = $position;
        $java.oncie_Expression__init_($this);
    };
    var oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_4 = $rt_classWithoutFields();
    $java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_4_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncie_LabelOrRelTypeName);
    };
    function oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_5() {
        var a = this; jl_Object.call(a);
        a.$_0266 = null;
        a.$_173 = null;
    }
    $java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_5_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0266;
        var$3 = var$0.$_173;
        return oncifp_ValidSymbolicNamesInLabelExpressions$_org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames(oncifp_ValidSymbolicNamesInLabelExpressions$_MODULE$, $rt_s(2624), var$2, var$3, var$1);
    };
    $java.oncie_LeftUnaryOperatorExpression = $rt_classWithoutFields(0);
    $java.oncie_LeftUnaryOperatorExpression_asCanonicalStringVal$ = function($$this) {
        var var$2, var$3;
        var$2 = $$this.$canonicalOperatorSymbol();
        $$this = ($$this.$rhs0()).$asCanonicalStringVal();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$2 = jl_StringBuilder_append(var$3, var$2);
        jl_AbstractStringBuilder_append(var$2, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$2, $$this), 41);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    function oncie_Not() {
        var a = this; oncie_Expression.call(a);
        a.$rhs5 = null;
        a.$position18 = null;
        a.$signatures3 = null;
    }
    function oncie_Not__init_(var_0, var_1) {
        var var_2 = new oncie_Not();
        $java.oncie_Not__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_Not_asCanonicalStringVal = function($this) {
        return $java.oncie_LeftUnaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Not_canonicalOperatorSymbol = function($this) {
        return $java.oncie_OperatorExpression_canonicalOperatorSymbol$($this);
    };
    function oncie_Not_rhs($this) {
        return $this.$rhs5;
    }
    $java.oncie_Not_position = function($this) {
        return $this.$position18;
    };
    $java.oncie_Not_signatures = function($this) {
        return $this.$signatures3;
    };
    $java.oncie_Not_productPrefix = function($this) {
        return $rt_s(2625);
    };
    $java.oncie_Not_productArity = function($this) {
        return 1;
    };
    $java.oncie_Not_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$rhs5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Not_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Not_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Not_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Not_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Not) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$rhs5;
                        $x$1 = $x$1.$rhs5;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Not))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_Not__init_ = function($this, $rhs, $position) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        $this.$rhs5 = $rhs;
        $this.$position18 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$3 = s_package$_Vector0(s_package$_MODULE$);
        $rhs = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$5 = var$4.data;
        var$6 = $java.oncie_TypeSignature$_MODULE$;
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_BooleanType, 1);
        var$9 = var$8.data;
        oncius_package$_$callClinit();
        var$9[0] = oncius_package$_CTBoolean(oncius_package$_MODULE$);
        var$5[0] = $java.oncie_TypeSignature$_apply(var$6, var$7.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$8)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures3 = var$3.$from0(sr_ScalaRunTime$_wrapRefArray($rhs, var$4));
    };
    function oncirc_containsNoMatchingNodes$$anonfun$apply$1$applyOrElse$lambda$_0_0() {
        var a = this; jl_Object.call(a);
        a.$_0273 = null;
        a.$_176 = null;
    }
    $java.oncirc_containsNoMatchingNodes$$anonfun$apply$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0273;
        var$3 = var$0.$_176;
        return var$1.$appended(s_Tuple2__init_(sr_AbstractPartialFunction_apply(var$2.$$outer24.$matcher0, var$3), var$3.$position2()));
    };
    function oncifp_AmbiguousAggregationAnalysis$$anonfun$1$applyOrElse$lambda$_0_0() {
        jl_Object.call(this);
        this.$_0255 = null;
    }
    $java.oncifp_AmbiguousAggregationAnalysis$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0255;
        var$3 = (s_Option$_option2Iterable(s_Option$_MODULE$, var$2.$orderBy2())).$toSeq();
        var$4 = new $java.oncifp_AmbiguousAggregationAnalysis$$anonfun$1$$anonfun$applyOrElse$1$lambda$_3_0;
        var$4.$_0443 = var$2;
        var$1 = var$1.$concat0(var$3.$flatMap(var$4));
        var$2 = sc_AbstractIterable_toSet((var$2.$returnItems0()).$items.$map1(new $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_0));
        var$3 = var$2.$collect0(new $java.oncia_ReturnItems$$anonfun$1);
        var$4 = var$2.$collect0(new $java.oncia_ReturnItems$$anonfun$2);
        var$2 = var$2.$collect0(new $java.oncia_ReturnItems$$anonfun$3);
        var$5 = new $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_1;
        var$5.$_0444 = var$4;
        var$5.$_1133 = var$2;
        var$3 = var$3.$flatMap(var$5);
        if (!sc_IterableOnceOps_nonEmpty$(var$3))
            var$2 = s_None$_MODULE$;
        else {
            var$2 = sc_AbstractIterable_mkString0((var$3.$map1(new $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_2)).$toSeq(), $rt_s(16));
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$4);
            jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(2626)), var$2);
            var$5 = jl_AbstractStringBuilder_toString(var$4);
            var$2 = s_Some__init_(oncias_SemanticError__init_0(var$5, (var$3.$head()).$position2()));
        }
        return var$1.$concat0(var$2);
    };
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Tuple2__2$mcZ$sp(var$1));
    };
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_1 = $rt_classWithoutFields();
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_1_apply = function(var$0, var$1) {
        return var$1.$_10;
    };
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_2 = $rt_classWithoutFields();
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_2_apply = function(var$0, var$1) {
        return var$1.$_10;
    };
    function oncia_NamespacedName() {
        var a = this; jl_Object.call(a);
        a.$nameComponents = null;
        a.$namespace2 = null;
        a.$position75 = null;
        a.$name59 = null;
    }
    function oncia_NamespacedName__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_NamespacedName();
        $java.oncia_NamespacedName__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_NamespacedName_namespace($this) {
        return $this.$namespace2;
    }
    $java.oncia_NamespacedName_position = function($this) {
        return $this.$position75;
    };
    function oncia_NamespacedName_toString($this) {
        return sc_AbstractIterable_mkString0((s_Option$_option2Iterable(s_Option$_MODULE$, $this.$namespace2)).$concat0(sci_$colon$colon__init_($this.$name59, sci_Nil$_MODULE$)), $rt_s(142));
    }
    $java.oncia_NamespacedName_productPrefix = function($this) {
        return $rt_s(2627);
    };
    $java.oncia_NamespacedName_productArity = function($this) {
        return 2;
    };
    $java.oncia_NamespacedName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$nameComponents;
            case 1:
                return $this.$namespace2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NamespacedName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamespacedName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamespacedName_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_NamespacedName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$nameComponents;
                        var$3 = $x$1.$nameComponents;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$namespace2;
                        $x$1 = $x$1.$namespace2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_NamespacedName))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_NamespacedName_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_NamespacedName__init_ = function($this, $nameComponents, $namespace, $position) {
        $this.$nameComponents = $nameComponents;
        $this.$namespace2 = $namespace;
        $this.$position75 = $position;
        $this.$name59 = sc_AbstractIterable_mkString0($nameComponents, $rt_s(142));
    };
    $java.jl_VirtualMachineError = $rt_classWithoutFields(jl_Error);
    var jl_InternalError = $rt_classWithoutFields($java.jl_VirtualMachineError);
    $java.jl_InternalError__init_ = function(var_0) {
        var var_1 = new jl_InternalError();
        jl_InternalError__init_(var_1, var_0);
        return var_1;
    };
    function jl_InternalError__init_($this, $message) {
        jl_Throwable__init_($this, $message);
    }
    function oncia_UsingJoinHint() {
        var a = this; jl_Object.call(a);
        a.$variables = null;
        a.$position196 = null;
    }
    $java.oncia_UsingJoinHint__init_ = function(var_0, var_1) {
        var var_2 = new oncia_UsingJoinHint();
        oncia_UsingJoinHint__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_UsingJoinHint_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_UsingJoinHint_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_UsingJoinHint_position = function($this) {
        return $this.$position196;
    };
    $java.oncia_UsingJoinHint_semanticCheck = function($this) {
        var var$1, var$2;
        var$1 = $this.$variables;
        var$2 = new $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_0;
        var$2.$_0445 = $this;
        return (var$1.$map5(var$2)).$reduceLeft(new $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_1);
    };
    $java.oncia_UsingJoinHint_productPrefix = function($this) {
        return $rt_s(2628);
    };
    $java.oncia_UsingJoinHint_productArity = function($this) {
        return 1;
    };
    $java.oncia_UsingJoinHint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variables;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UsingJoinHint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingJoinHint_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingJoinHint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingJoinHint_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_UsingJoinHint) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variables;
                        $x$1 = $x$1.$variables;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_UsingJoinHint))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_UsingJoinHint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncia_UsingJoinHint__init_($this, $variables, $position) {
        $this.$variables = $variables;
        $this.$position196 = $position;
    }
    var onciu_NonEmptyList$ = $rt_classWithoutFields();
    $java.onciu_NonEmptyList$_MODULE$ = null;
    function onciu_NonEmptyList$__clinit_() {
        $java.onciu_NonEmptyList$_MODULE$ = new onciu_NonEmptyList$;
    }
    var oncia_UsingJoinHint$$apply$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncia_UsingJoinHint$$apply$lambda$_1_0_apply = function(var$0) {
        var var$1;
        var$1 = new jl_IllegalStateException;
        jl_Throwable__init_(var$1, $rt_s(2629));
        $rt_throw(var$1);
    };
    $java.onciu_NonEmptyList = $rt_classWithoutFields(0);
    $java.onciu_NonEmptyList_map$ = function($$this, $f) {
        var var$3;
        if (!($$this instanceof onciu_Fby)) {
            if (!($$this instanceof onciu_Last))
                $rt_throw(s_MatchError__init_($$this));
            var$3 = $$this.$head3;
            $$this = onciu_Last__init_($f.$apply(var$3));
        } else {
            $$this = $$this;
            var$3 = $$this.$head4;
            $$this = $java.onciu_NonEmptyList_reverse$($$this.$tail6.$mapAndPrependReversedTo($f, onciu_Last__init_($f.$apply(var$3))));
        }
        return $$this;
    };
    $java.onciu_NonEmptyList_mapAndPrependReversedTo$ = function($$this, $f, $acc) {
        var var$4, var$5;
        while ($$this instanceof onciu_Fby) {
            $$this = $$this;
            var$4 = $$this.$head4;
            $$this = $$this.$tail6;
            $acc = onciu_Fby__init_($f.$apply(var$4), $acc);
        }
        if (!($$this instanceof onciu_Last))
            $rt_throw(s_MatchError__init_($$this));
        var$5 = $$this.$head3;
        return onciu_Fby__init_($f.$apply(var$5), $acc);
    };
    $java.onciu_NonEmptyList_foldLeft$ = function($$this, $acc0, $f) {
        var var$4;
        while (true) {
            if ($$this instanceof onciu_Last)
                return $java.onciu_NonEmptyList$toIndexedSeq$lambda$_72_0_apply($f, $acc0, $$this.$head3);
            if (!($$this instanceof onciu_Fby))
                break;
            $$this = $$this;
            var$4 = $$this.$head4;
            $$this = $$this.$tail6;
            $acc0 = $java.onciu_NonEmptyList$toIndexedSeq$lambda$_72_0_apply($f, $acc0, var$4);
        }
        $rt_throw(s_MatchError__init_($$this));
    };
    $java.onciu_NonEmptyList_reduceLeft$ = function($$this, $f) {
        var var$3, var$4;
        if (!($$this instanceof onciu_Fby)) {
            if (!($$this instanceof onciu_Last))
                $rt_throw(s_MatchError__init_($$this));
            $$this = $$this.$head3;
        } else {
            $$this = $$this;
            var$3 = $$this.$head4;
            $$this = $$this.$tail6;
            while ($$this instanceof onciu_Fby) {
                $$this = $$this;
                var$4 = $$this.$head4;
                $$this = $$this.$tail6;
                var$3 = $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_1_apply($f, var$3, var$4);
            }
            if (!($$this instanceof onciu_Last))
                $rt_throw(s_MatchError__init_($$this));
            $$this = $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_1_apply($f, var$3, $$this.$head3);
        }
        return $$this;
    };
    $java.onciu_NonEmptyList_reverse$ = function($$this) {
        var var$2;
        if ($$this instanceof onciu_Fby) {
            $$this = $$this;
            var$2 = $$this.$head4;
            $$this = $$this.$tail6.$mapAndPrependReversedTo(new $java.onciu_NonEmptyList$reverse$lambda$_61_0, onciu_Last__init_(var$2));
        }
        return $$this;
    };
    $java.onciu_NonEmptyList_toIterable$ = function($$this) {
        var var$2;
        var$2 = $$this.$iterator0();
        $$this = sc_IterableFactory$_MODULE$;
        s_package$_$callClinit();
        return var$2.$to0(sc_IterableFactory$_toFactory($$this, s_package$_Iterable0(s_package$_MODULE$)));
    };
    $java.onciu_NonEmptyList_toIndexedSeq$ = function($$this) {
        s_package$_$callClinit();
        return $$this.$foldLeft(sc_SeqFactory$Delegate_empty(s_package$_IndexedSeq0(s_package$_MODULE$)), new $java.onciu_NonEmptyList$toIndexedSeq$lambda$_72_0);
    };
    function oncia_ProcedureResultItem() {
        var a = this; jl_Object.call(a);
        a.$output2 = null;
        a.$variable41 = null;
        a.$position197 = null;
        a.$outputName = null;
    }
    function oncia_ProcedureResultItem__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_ProcedureResultItem();
        $java.oncia_ProcedureResultItem__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_ProcedureResultItem_position = function($this) {
        return $this.$position197;
    };
    $java.oncia_ProcedureResultItem_productPrefix = function($this) {
        return $rt_s(2630);
    };
    $java.oncia_ProcedureResultItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_ProcedureResultItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$output2;
            case 1:
                return $this.$variable41;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ProcedureResultItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureResultItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureResultItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureResultItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ProcedureResultItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$output2;
                        var$3 = $x$1.$output2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$variable41;
                        $x$1 = $x$1.$variable41;
                        if (var$3 !== null) {
                            if (!$java.oncie_Variable_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ProcedureResultItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ProcedureResultItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ProcedureResultItem__init_ = function($this, $output, $variable, $position) {
        $this.$output2 = $output;
        $this.$variable41 = $variable;
        $this.$position197 = $position;
        $output = s_Option_map($output, new $java.oncia_ProcedureResultItem$_init_$lambda$_72_0);
        $variable = new $java.oncia_ProcedureResultItem$_init_$lambda$_72_1;
        $variable.$_0446 = $this;
        $this.$outputName = s_Option_getOrElse($output, $variable);
    };
    $java.oncie_StringLiteral$$anon$6 = $rt_classWithoutFields(oncie_StringLiteral);
    var s_DummyImplicit$ = $rt_classWithoutFields();
    var s_DummyImplicit$_MODULE$ = null;
    var s_DummyImplicit$_dummyImplicit0 = null;
    function s_DummyImplicit$__clinit_() {
        s_DummyImplicit$_MODULE$ = new s_DummyImplicit$;
        s_DummyImplicit$_dummyImplicit0 = new $java.s_DummyImplicit;
    }
    function s_DummyImplicit$_dummyImplicit($this) {
        return s_DummyImplicit$_dummyImplicit0;
    }
    var oncia_AliasDriverSettingsCheck$ = $rt_classWithoutFields();
    $java.oncia_AliasDriverSettingsCheck$_MODULE$ = null;
    $java.oncia_AliasDriverSettingsCheck$_existsErrorMessage = null;
    $java.oncia_AliasDriverSettingsCheck$_countErrorMessage = null;
    $java.oncia_AliasDriverSettingsCheck$_collectErrorMessage = null;
    $java.oncia_AliasDriverSettingsCheck$_genericErrorMessage = null;
    function oncia_AliasDriverSettingsCheck$__clinit_() {
        $java.oncia_AliasDriverSettingsCheck$_MODULE$ = new oncia_AliasDriverSettingsCheck$;
        $java.oncia_AliasDriverSettingsCheck$_existsErrorMessage = $rt_s(2631);
        $java.oncia_AliasDriverSettingsCheck$_countErrorMessage = $rt_s(2632);
        $java.oncia_AliasDriverSettingsCheck$_collectErrorMessage = $rt_s(2633);
        $java.oncia_AliasDriverSettingsCheck$_genericErrorMessage = $rt_s(2634);
    }
    $java.oncia_AliasDriverSettingsCheck$_findInvalidDriverSettings = function($this, $driverSettings) {
        if ($driverSettings instanceof s_Some) {
            $driverSettings = $driverSettings.$value5;
            if ($driverSettings instanceof su_Left)
                return (sc_AbstractIterable_flatMap(sc_AbstractMap_values($driverSettings.$value11), new $java.oncia_AliasDriverSettingsCheck$$findInvalidDriverSettings$lambda$_5_0)).$headOption();
        }
        return s_None$_MODULE$;
    };
    function oncia_ExistsExpression() {
        var a = this; oncie_Expression.call(a);
        a.$query3 = null;
        a.$position71 = null;
        a.$computedIntroducedVariables0 = null;
        a.$computedScopeDependencies0 = null;
    }
    $java.oncia_ExistsExpression__init_ = function(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_ExistsExpression();
        oncia_ExistsExpression__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    $java.oncia_ExistsExpression_introducedVariables = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_introducedVariables$($this);
    };
    $java.oncia_ExistsExpression_scopeDependencies = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_scopeDependencies$($this);
    };
    $java.oncia_ExistsExpression_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    function oncia_ExistsExpression_query($this) {
        return $this.$query3;
    }
    $java.oncia_ExistsExpression_position = function($this) {
        return $this.$position71;
    };
    $java.oncia_ExistsExpression_computedIntroducedVariables = function($this) {
        return $this.$computedIntroducedVariables0;
    };
    $java.oncia_ExistsExpression_computedScopeDependencies = function($this) {
        return $this.$computedScopeDependencies0;
    };
    $java.oncia_ExistsExpression_withQuery = function($this, $query) {
        return $java.oncia_ExistsExpression__init_($query, $this.$position71, $this.$computedIntroducedVariables0, $this.$computedScopeDependencies0);
    };
    $java.oncia_ExistsExpression_withComputedIntroducedVariables = function($this, $computedIntroducedVariables) {
        return $java.oncia_ExistsExpression_copy($this, $this.$query3, $this.$position71, s_Some__init_($computedIntroducedVariables), $this.$computedScopeDependencies0);
    };
    $java.oncia_ExistsExpression_withComputedScopeDependencies = function($this, $computedScopeDependencies) {
        return $java.oncia_ExistsExpression_copy($this, $this.$query3, $this.$position71, $this.$computedIntroducedVariables0, s_Some__init_($computedScopeDependencies));
    };
    $java.oncia_ExistsExpression_subqueryAstNode = function($this) {
        return $this.$query3;
    };
    $java.oncia_ExistsExpression_dup = function($this, $children) {
        return $java.oncia_ExistsExpression__init_($children.$head(), $this.$position71, $this.$computedIntroducedVariables0, $this.$computedScopeDependencies0);
    };
    $java.oncia_ExistsExpression_copy = function($this, $query, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        return $java.oncia_ExistsExpression__init_($query, $position, $computedIntroducedVariables, $computedScopeDependencies);
    };
    $java.oncia_ExistsExpression_productPrefix = function($this) {
        return $rt_s(2635);
    };
    $java.oncia_ExistsExpression_productArity = function($this) {
        return 1;
    };
    $java.oncia_ExistsExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$query3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ExistsExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExistsExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExistsExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ExistsExpression_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_ExistsExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$query3;
                        $x$1 = $x$1.$query3;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_ExistsExpression))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ExistsExpression_dup0 = function($this, $children) {
        return $java.oncia_ExistsExpression_dup($this, $children);
    };
    $java.oncia_ExistsExpression_dup1 = function($this, $children) {
        return $java.oncia_ExistsExpression_dup($this, $children);
    };
    function oncia_ExistsExpression__init_($this, $query, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        $this.$query3 = $query;
        $this.$position71 = $position;
        $this.$computedIntroducedVariables0 = $computedIntroducedVariables;
        $this.$computedScopeDependencies0 = $computedScopeDependencies;
        $java.oncie_Expression__init_($this);
    }
    function oncia_CountExpression() {
        var a = this; oncie_Expression.call(a);
        a.$query4 = null;
        a.$position72 = null;
        a.$computedIntroducedVariables1 = null;
        a.$computedScopeDependencies1 = null;
    }
    $java.oncia_CountExpression__init_ = function(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_CountExpression();
        oncia_CountExpression__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    $java.oncia_CountExpression_introducedVariables = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_introducedVariables$($this);
    };
    $java.oncia_CountExpression_scopeDependencies = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_scopeDependencies$($this);
    };
    $java.oncia_CountExpression_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    function oncia_CountExpression_query($this) {
        return $this.$query4;
    }
    $java.oncia_CountExpression_position = function($this) {
        return $this.$position72;
    };
    $java.oncia_CountExpression_computedIntroducedVariables = function($this) {
        return $this.$computedIntroducedVariables1;
    };
    $java.oncia_CountExpression_computedScopeDependencies = function($this) {
        return $this.$computedScopeDependencies1;
    };
    $java.oncia_CountExpression_withQuery = function($this, $query) {
        return $java.oncia_CountExpression__init_($query, $this.$position72, $this.$computedIntroducedVariables1, $this.$computedScopeDependencies1);
    };
    $java.oncia_CountExpression_withComputedIntroducedVariables = function($this, $computedIntroducedVariables) {
        return $java.oncia_CountExpression_copy($this, $this.$query4, $this.$position72, s_Some__init_($computedIntroducedVariables), $this.$computedScopeDependencies1);
    };
    $java.oncia_CountExpression_withComputedScopeDependencies = function($this, $computedScopeDependencies) {
        return $java.oncia_CountExpression_copy($this, $this.$query4, $this.$position72, $this.$computedIntroducedVariables1, s_Some__init_($computedScopeDependencies));
    };
    $java.oncia_CountExpression_subqueryAstNode = function($this) {
        return $this.$query4;
    };
    $java.oncia_CountExpression_dup = function($this, $children) {
        return $java.oncia_CountExpression__init_($children.$head(), $this.$position72, $this.$computedIntroducedVariables1, $this.$computedScopeDependencies1);
    };
    $java.oncia_CountExpression_copy = function($this, $query, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        return $java.oncia_CountExpression__init_($query, $position, $computedIntroducedVariables, $computedScopeDependencies);
    };
    $java.oncia_CountExpression_productPrefix = function($this) {
        return $rt_s(2636);
    };
    $java.oncia_CountExpression_productArity = function($this) {
        return 1;
    };
    $java.oncia_CountExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$query4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CountExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CountExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CountExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CountExpression_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CountExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$query4;
                        $x$1 = $x$1.$query4;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CountExpression))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_CountExpression_dup0 = function($this, $children) {
        return $java.oncia_CountExpression_dup($this, $children);
    };
    $java.oncia_CountExpression_dup1 = function($this, $children) {
        return $java.oncia_CountExpression_dup($this, $children);
    };
    function oncia_CountExpression__init_($this, $query, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        $this.$query4 = $query;
        $this.$position72 = $position;
        $this.$computedIntroducedVariables1 = $computedIntroducedVariables;
        $this.$computedScopeDependencies1 = $computedScopeDependencies;
        $java.oncie_Expression__init_($this);
    }
    function oncia_CollectExpression() {
        var a = this; oncie_Expression.call(a);
        a.$query5 = null;
        a.$position73 = null;
        a.$computedIntroducedVariables2 = null;
        a.$computedScopeDependencies2 = null;
    }
    $java.oncia_CollectExpression__init_ = function(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_CollectExpression();
        oncia_CollectExpression__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    $java.oncia_CollectExpression_introducedVariables = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_introducedVariables$($this);
    };
    $java.oncia_CollectExpression_scopeDependencies = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_scopeDependencies$($this);
    };
    $java.oncia_CollectExpression_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    function oncia_CollectExpression_query($this) {
        return $this.$query5;
    }
    $java.oncia_CollectExpression_position = function($this) {
        return $this.$position73;
    };
    $java.oncia_CollectExpression_computedIntroducedVariables = function($this) {
        return $this.$computedIntroducedVariables2;
    };
    $java.oncia_CollectExpression_computedScopeDependencies = function($this) {
        return $this.$computedScopeDependencies2;
    };
    $java.oncia_CollectExpression_withQuery = function($this, $query) {
        return $java.oncia_CollectExpression__init_($query, $this.$position73, $this.$computedIntroducedVariables2, $this.$computedScopeDependencies2);
    };
    $java.oncia_CollectExpression_withComputedIntroducedVariables = function($this, $computedIntroducedVariables) {
        return $java.oncia_CollectExpression_copy($this, $this.$query5, $this.$position73, s_Some__init_($computedIntroducedVariables), $this.$computedScopeDependencies2);
    };
    $java.oncia_CollectExpression_withComputedScopeDependencies = function($this, $computedScopeDependencies) {
        return $java.oncia_CollectExpression_copy($this, $this.$query5, $this.$position73, $this.$computedIntroducedVariables2, s_Some__init_($computedScopeDependencies));
    };
    $java.oncia_CollectExpression_subqueryAstNode = function($this) {
        return $this.$query5;
    };
    $java.oncia_CollectExpression_dup = function($this, $children) {
        return $java.oncia_CollectExpression__init_($children.$head(), $this.$position73, $this.$computedIntroducedVariables2, $this.$computedScopeDependencies2);
    };
    $java.oncia_CollectExpression_copy = function($this, $query, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        return $java.oncia_CollectExpression__init_($query, $position, $computedIntroducedVariables, $computedScopeDependencies);
    };
    $java.oncia_CollectExpression_productPrefix = function($this) {
        return $rt_s(2637);
    };
    $java.oncia_CollectExpression_productArity = function($this) {
        return 1;
    };
    $java.oncia_CollectExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$query5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CollectExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CollectExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CollectExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CollectExpression_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_CollectExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$query5;
                        $x$1 = $x$1.$query5;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_CollectExpression))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_CollectExpression_dup0 = function($this, $children) {
        return $java.oncia_CollectExpression_dup($this, $children);
    };
    $java.oncia_CollectExpression_dup1 = function($this, $children) {
        return $java.oncia_CollectExpression_dup($this, $children);
    };
    function oncia_CollectExpression__init_($this, $query, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        $this.$query5 = $query;
        $this.$position73 = $position;
        $this.$computedIntroducedVariables2 = $computedIntroducedVariables;
        $this.$computedScopeDependencies2 = $computedScopeDependencies;
        $java.oncie_Expression__init_($this);
    }
    $java.oncia_UnresolvedCall$returnVariables$lambda$_14_0 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$returnVariables$lambda$_14_0_apply = function(var$0, var$1) {
        return sc_IterableOnceOps_toList$(var$1.$items4.$map1(new $java.oncia_UnresolvedCall$$anonfun$returnVariables$1$lambda$_33_0));
    };
    $java.oncia_UnresolvedCall$returnVariables$lambda$_14_1 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$returnVariables$lambda$_14_1_apply = function(var$0) {
        s_package$_$callClinit();
        s_package$_List0(s_package$_MODULE$);
        return sci_Nil$_MODULE$;
    };
    function sci_Vector$filterImpl$lambda$_70_0() {
        var a = this; jl_Object.call(a);
        a.$_0175 = null;
        a.$_129 = 0;
        a.$_216 = null;
    }
    $java.sci_Vector$filterImpl$lambda$_70_0_apply = function(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$1(var$0.$_0175, var$0.$_129, var$0.$_216, var$1);
    };
    function sci_Vector$filterImpl$lambda$_70_1() {
        var a = this; jl_Object.call(a);
        a.$_0176 = null;
        a.$_130 = 0;
        a.$_217 = null;
    }
    $java.sci_Vector$filterImpl$lambda$_70_1_apply = function(var$0, var$1) {
        return sci_Vector_$anonfun$filterImpl$2(var$0.$_0176, var$0.$_130, var$0.$_217, var$1);
    };
    $java.sci_Map$Map3 = function() {
        var a = this; sci_AbstractMap.call(a);
        a.$scala$collection$immutable$Map$Map3$$key1 = null;
        a.$scala$collection$immutable$Map$Map3$$value1 = null;
        a.$scala$collection$immutable$Map$Map3$$key2 = null;
        a.$scala$collection$immutable$Map$Map3$$value2 = null;
        a.$scala$collection$immutable$Map$Map3$$key3 = null;
        a.$scala$collection$immutable$Map$Map3$$value3 = null;
    };
    $java.sci_Map$Map3__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new $java.sci_Map$Map3();
        $java.sci_Map$Map3__init_0(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    };
    $java.sci_Map$Map3_map = function($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    };
    $java.sci_Map$Map3_flatMap = function($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    };
    $java.sci_Map$Map3_collect = function($this, $pf) {
        return sc_StrictOptimizedIterableOps_collect$($this, $pf);
    };
    $java.sci_Map$Map3_flatten = function($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    };
    $java.sci_Map$Map3_filter = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    };
    $java.sci_Map$Map3_filterNot = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    };
    $java.sci_Map$Map3_size = function($this) {
        return 3;
    };
    $java.sci_Map$Map3_knownSize = function($this) {
        return 3;
    };
    $java.sci_Map$Map3_isEmpty = function($this) {
        return 0;
    };
    $java.sci_Map$Map3_apply = function($this, $key) {
        var var$2, var$3;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key1))
            return $this.$scala$collection$immutable$Map$Map3$$value1;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key2))
            return $this.$scala$collection$immutable$Map$Map3$$value2;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key3))
            return $this.$scala$collection$immutable$Map$Map3$$value3;
        var$2 = new ju_NoSuchElementException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, 15);
        jl_AbstractStringBuilder_append1(var$3, $rt_s(389));
        jl_Throwable__init_(var$2, jl_AbstractStringBuilder_toString(jl_StringBuilder_append(var$3, $key)));
        $rt_throw(var$2);
    };
    $java.sci_Map$Map3_contains = function($this, $key) {
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key1) && !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key2) && !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key3))
            return 0;
        return 1;
    };
    $java.sci_Map$Map3_get = function($this, $key) {
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key1))
            return s_Some__init_($this.$scala$collection$immutable$Map$Map3$$value1);
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key2))
            return s_Some__init_($this.$scala$collection$immutable$Map$Map3$$value2);
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key3))
            return s_None$_MODULE$;
        return s_Some__init_($this.$scala$collection$immutable$Map$Map3$$value3);
    };
    $java.sci_Map$Map3_getOrElse = function($this, $key, $default) {
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key1))
            return $this.$scala$collection$immutable$Map$Map3$$value1;
        if (sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key2))
            return $this.$scala$collection$immutable$Map$Map3$$value2;
        if (!sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key3))
            return $default.$apply2();
        return $this.$scala$collection$immutable$Map$Map3$$value3;
    };
    $java.sci_Map$Map3_iterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map3$$anon$4;
        $java.sci_Map$Map3$Map3Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map3_keysIterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map3$$anon$5;
        $java.sci_Map$Map3$Map3Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map3_valuesIterator = function($this) {
        var var$1;
        var$1 = new $java.sci_Map$Map3$$anon$6;
        $java.sci_Map$Map3$Map3Iterator__init_(var$1, $this);
        return var$1;
    };
    $java.sci_Map$Map3_foreach = function($this, $f) {
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1));
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2));
        $f.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3));
    };
    $java.sci_Map$Map3_exists = function($this, $p) {
        if (!sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1))) && !sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2))) && !sr_BoxesRunTime_unboxToBoolean($p.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3))))
            return 0;
        return 1;
    };
    $java.sci_Map$Map3_forall = function($this, $p) {
        if (sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1))) && sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2))) && sr_BoxesRunTime_unboxToBoolean($java.sc_Map$equals$lambda$_7_0_apply($p, s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key3,
        $this.$scala$collection$immutable$Map$Map3$$value3))))
            return 1;
        return 0;
    };
    $java.sci_Map$Map3_hashCode = function($this) {
        var $h, $a, var$3, $c, $b;
        suh_MurmurHash3$_$callClinit();
        $h = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1);
        $a = 0 + $h | 0;
        var$3 = 0 ^ $h;
        $c = 1 * ($h | 1) | 0;
        $b = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2);
        $a = $a + $b | 0;
        $h = var$3 ^ $b;
        $b = $rt_imul($c, $b | 1);
        $c = suh_MurmurHash3$_tuple2Hash(suh_MurmurHash3$_MODULE$, $this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3);
        $a = $a + $c | 0;
        $h = $h ^ $c;
        $b = $rt_imul($b, $c | 1);
        $c = suh_MurmurHash3$_mapSeed(suh_MurmurHash3$_MODULE$);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $c, $a);
        $a = suh_MurmurHash3_mix(suh_MurmurHash3$_MODULE$, $a, $h);
        $a = suh_MurmurHash3_mixLast(suh_MurmurHash3$_MODULE$, $a, $b);
        return suh_MurmurHash3_scala$util$hashing$MurmurHash3$$avalanche(suh_MurmurHash3$_MODULE$, $a ^ 3);
    };
    $java.sci_Map$Map3_filterImpl = function($this, $pred, $isFlipped) {
        var var$3, var$4, var$5, var$6, var$7;
        var$3 = null;
        var$4 = null;
        var$5 = null;
        var$6 = null;
        var$7 = 0;
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1))) != $isFlipped) {
            var$3 = $this.$scala$collection$immutable$Map$Map3$$key1;
            var$5 = $this.$scala$collection$immutable$Map$Map3$$value1;
            var$7 = 1;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2))) != $isFlipped) {
            if (var$7) {
                var$4 = $this.$scala$collection$immutable$Map$Map3$$key2;
                var$6 = $this.$scala$collection$immutable$Map$Map3$$value2;
            } else {
                var$3 = $this.$scala$collection$immutable$Map$Map3$$key2;
                var$5 = $this.$scala$collection$immutable$Map$Map3$$value2;
            }
            var$7 = var$7 + 1 | 0;
        }
        if (sr_BoxesRunTime_unboxToBoolean($pred.$apply(s_Tuple2__init_($this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3))) != $isFlipped) {
            if (!var$7) {
                var$3 = $this.$scala$collection$immutable$Map$Map3$$key3;
                var$5 = $this.$scala$collection$immutable$Map$Map3$$value3;
            } else if (var$7 == 1) {
                var$4 = $this.$scala$collection$immutable$Map$Map3$$key3;
                var$6 = $this.$scala$collection$immutable$Map$Map3$$value3;
            }
            var$7 = var$7 + 1 | 0;
        }
        a: {
            switch (var$7) {
                case 0:
                    $this = sci_Map$EmptyMap$_MODULE$;
                    break a;
                case 1:
                    $this = sci_Map$Map1__init_(var$3, var$5);
                    break a;
                case 2:
                    $this = $java.sci_Map$Map2__init_(var$3, var$5, var$4, var$6);
                    break a;
                case 3:
                    break;
                default:
                    $rt_throw(s_MatchError__init_(jl_Integer_valueOf(var$7)));
            }
        }
        return $this;
    };
    $java.sci_Map$Map3_removed = function($this, $key) {
        return sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key1) ? $java.sci_Map$Map2__init_($this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2, $this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3) : sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key2) ? $java.sci_Map$Map2__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1,
        $this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3) : !sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key3) ? $this : $java.sci_Map$Map2__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1, $this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2);
    };
    $java.sci_Map$Map3_updated = function($this, $key, $value) {
        return sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key1) ? $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map3$$key1, $value, $this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2, $this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3) : sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key2) ? $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map3$$key1,
        $this.$scala$collection$immutable$Map$Map3$$value1, $this.$scala$collection$immutable$Map$Map3$$key2, $value, $this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3) : sr_BoxesRunTime_equals($key, $this.$scala$collection$immutable$Map$Map3$$key3) ? $java.sci_Map$Map3__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1, $this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2,
        $this.$scala$collection$immutable$Map$Map3$$key3, $value) : $java.sci_Map$Map4__init_($this.$scala$collection$immutable$Map$Map3$$key1, $this.$scala$collection$immutable$Map$Map3$$value1, $this.$scala$collection$immutable$Map$Map3$$key2, $this.$scala$collection$immutable$Map$Map3$$value2, $this.$scala$collection$immutable$Map$Map3$$key3, $this.$scala$collection$immutable$Map$Map3$$value3, $key, $value);
    };
    $java.sci_Map$Map3__init_0 = function($this, $key1, $value1, $key2, $value2, $key3, $value3) {
        $this.$scala$collection$immutable$Map$Map3$$key1 = $key1;
        $this.$scala$collection$immutable$Map$Map3$$value1 = $value1;
        $this.$scala$collection$immutable$Map$Map3$$key2 = $key2;
        $this.$scala$collection$immutable$Map$Map3$$value2 = $value2;
        $this.$scala$collection$immutable$Map$Map3$$key3 = $key3;
        $this.$scala$collection$immutable$Map$Map3$$value3 = $value3;
    };
    var oncias_Scope$allScopes$lambda$_20_0 = $rt_classWithoutFields();
    $java.oncias_Scope$allScopes$lambda$_20_0_apply = function(var$0, var$1) {
        return oncias_Scope_allScopes(var$1);
    };
    var sc_ArrayOps$ = $rt_classWithoutFields();
    var sc_ArrayOps$_MODULE$ = null;
    $java.sc_ArrayOps$_fallback = null;
    function sc_ArrayOps$__clinit_() {
        sc_ArrayOps$_MODULE$ = new sc_ArrayOps$;
        $java.sc_ArrayOps$_fallback = new $java.sc_ArrayOps$$_clinit_$lambda$_0_0;
    }
    function sc_ArrayOps$_slice$extension($this, $$this, $from, $until) {
        var $lo, $hi, var$6, var$7, var$8, var$9;
        $lo = jl_Math_max($from, 0);
        $hi = jl_Math_min($until, jlr_Array_getLength($$this));
        if ($hi <= $lo) {
            sr_ClassTag$_$callClinit();
            return (sr_ClassTag$_apply(sr_ClassTag$_MODULE$, jl_Class_getComponentType(jl_Object_getClass($$this)))).$newArray(0);
        }
        if ($rt_isInstance($$this, $rt_arraycls(jl_Object)))
            return ju_Arrays_copyOfRange($$this, $lo, $hi);
        if ($rt_isInstance($$this, $rt_arraycls($rt_intcls()))) {
            var$6 = $$this;
            var$7 = $rt_createIntArray($hi - $lo | 0);
            var$8 = var$7.data;
            $from = $lo;
            while ($from < $hi) {
                var$8[$from - $lo | 0] = var$6.data[$from];
                $from = $from + 1 | 0;
            }
            return var$7;
        }
        if ($rt_isInstance($$this, $rt_arraycls($rt_doublecls()))) {
            var$6 = $$this;
            var$7 = $rt_createDoubleArray($hi - $lo | 0);
            var$8 = var$7.data;
            $from = $lo;
            while ($from < $hi) {
                var$8[$from - $lo | 0] = var$6.data[$from];
                $from = $from + 1 | 0;
            }
            return var$7;
        }
        if ($rt_isInstance($$this, $rt_arraycls($rt_longcls()))) {
            var$6 = $$this;
            var$7 = $rt_createLongArray($hi - $lo | 0);
            var$8 = var$7.data;
            $from = $lo;
            while ($from < $hi) {
                var$8[$from - $lo | 0] = var$6.data[$from];
                $from = $from + 1 | 0;
            }
            return var$7;
        }
        if ($rt_isInstance($$this, $rt_arraycls($rt_floatcls()))) {
            var$6 = $$this;
            var$8 = $rt_createFloatArray($hi - $lo | 0);
            var$9 = var$8.data;
            $until = $lo;
            while ($until < $hi) {
                var$9[$until - $lo | 0] = var$6.data[$until];
                $until = $until + 1 | 0;
            }
            return var$8;
        }
        if ($rt_isInstance($$this, $rt_arraycls($rt_charcls()))) {
            var$6 = $$this;
            var$7 = $rt_createCharArray($hi - $lo | 0);
            var$8 = var$7.data;
            $from = $lo;
            while ($from < $hi) {
                var$8[$from - $lo | 0] = var$6.data[$from];
                $from = $from + 1 | 0;
            }
            return var$7;
        }
        if ($rt_isInstance($$this, $rt_arraycls($rt_bytecls()))) {
            var$6 = $$this;
            var$7 = $rt_createByteArray($hi - $lo | 0);
            var$8 = var$7.data;
            $from = $lo;
            while ($from < $hi) {
                var$8[$from - $lo | 0] = var$6.data[$from];
                $from = $from + 1 | 0;
            }
            return var$7;
        }
        if ($rt_isInstance($$this, $rt_arraycls($rt_shortcls()))) {
            var$6 = $$this;
            var$7 = $rt_createShortArray($hi - $lo | 0);
            var$8 = var$7.data;
            $from = $lo;
            while ($from < $hi) {
                var$8[$from - $lo | 0] = var$6.data[$from];
                $from = $from + 1 | 0;
            }
            return var$7;
        }
        if (!$rt_isInstance($$this, $rt_arraycls($rt_booleancls())))
            $rt_throw(s_MatchError__init_($$this));
        var$6 = $$this;
        var$7 = $rt_createBooleanArray($hi - $lo | 0);
        var$8 = var$7.data;
        $from = $lo;
        while ($from < $hi) {
            var$9 = var$6.data;
            var$8[$from - $lo | 0] = var$9[$from];
            $from = $from + 1 | 0;
        }
        return var$7;
    }
    function sc_ArrayOps$_drop$extension($this, $$this, $n) {
        return sc_ArrayOps$_slice$extension($this, $$this, $n, jlr_Array_getLength($$this));
    }
    function sc_ArrayOps$_dropRight$extension($this, $$this, $n) {
        return sc_ArrayOps$_slice$extension($this, $$this, 0, jlr_Array_getLength($$this) - jl_Math_max($n, 0) | 0);
    }
    function sc_ArrayOps$_appended$extension($this, $$this, $x, $evidence$10) {
        var $dest;
        $dest = s_Array$_copyAs(s_Array$_MODULE$, $$this, jlr_Array_getLength($$this) + 1 | 0, $evidence$10);
        sr_ScalaRunTime$_array_update(sr_ScalaRunTime$_MODULE$, $dest, jlr_Array_getLength($$this), $x);
        return $dest;
    }
    function sc_ArrayOps$_prepended$extension($this, $$this, $x, $evidence$12) {
        var $dest;
        $dest = $evidence$12.$newArray(jlr_Array_getLength($$this) + 1 | 0);
        sr_ScalaRunTime$_array_update(sr_ScalaRunTime$_MODULE$, $dest, 0, $x);
        s_Array$_copy(s_Array$_MODULE$, $$this, 0, $dest, 1, jlr_Array_getLength($$this));
        return $dest;
    }
    function sc_ArrayOps$_toIndexedSeq$extension($this, $$this) {
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, s_Array$_copyOf(s_Array$_MODULE$, $$this, jlr_Array_getLength($$this)));
    }
    function sc_ArrayOps$_updated$extension($this, $$this, $index, $elem, $evidence$30) {
        var $dest, var$6, var$7;
        if ($index >= 0 && $index < jlr_Array_getLength($$this)) {
            $dest = $evidence$30.$newArray(jlr_Array_getLength($$this));
            var$6 = jlr_Array_getLength($$this);
            var$7 = jlr_Array_getLength($dest);
            var$6 = jl_Math_max(jl_Math_min(jl_Math_min(2147483647, var$6), var$7 - 0 | 0), 0);
            if (var$6 > 0)
                s_Array$_copy(s_Array$_MODULE$, $$this, 0, $dest, 0, var$6);
            sr_ScalaRunTime$_array_update(sr_ScalaRunTime$_MODULE$, $dest, $index, $elem);
            return $dest;
        }
        $evidence$30 = new jl_IndexOutOfBoundsException;
        $elem = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($elem, 31);
        $elem = jl_StringBuilder_append0($elem, $index);
        jl_AbstractStringBuilder_append1($elem, $rt_s(390));
        $$this = jl_StringBuilder_append0($elem, jlr_Array_getLength($$this) - 1 | 0);
        jl_AbstractStringBuilder_append1($$this, $rt_s(25));
        jl_Throwable__init_($evidence$30, jl_AbstractStringBuilder_toString($$this));
        $rt_throw($evidence$30);
    }
    var jnc_CharacterCodingException = $rt_classWithoutFields(ji_IOException);
    function oncia_DatabasePrivilege() {
        var a = this; oncia_PrivilegeType.call(a);
        a.$action2 = null;
        a.$scope6 = null;
        a.$position24 = null;
    }
    function oncia_DatabasePrivilege_scope($this) {
        return $this.$scope6;
    }
    $java.oncia_DatabasePrivilege_productPrefix = function($this) {
        return $rt_s(2638);
    };
    $java.oncia_DatabasePrivilege_productArity = function($this) {
        return 2;
    };
    $java.oncia_DatabasePrivilege_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$action2;
            case 1:
                return $this.$scope6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DatabasePrivilege_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DatabasePrivilege_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DatabasePrivilege_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DatabasePrivilege_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_DatabasePrivilege) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$action2;
                            var$3 = $x$1.$action2;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$scope6;
                        $x$1 = $x$1.$scope6;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncia_NamedDatabasesScope() {
        var a = this; jl_Object.call(a);
        a.$databases = null;
        a.$position198 = null;
        a.$showCommandName3 = null;
    }
    function oncia_NamedDatabasesScope__init_(var_0, var_1) {
        var var_2 = new oncia_NamedDatabasesScope();
        $java.oncia_NamedDatabasesScope__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_NamedDatabasesScope_productPrefix = function($this) {
        return $rt_s(2639);
    };
    $java.oncia_NamedDatabasesScope_productArity = function($this) {
        return 1;
    };
    $java.oncia_NamedDatabasesScope_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$databases;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NamedDatabasesScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamedDatabasesScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamedDatabasesScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamedDatabasesScope_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_NamedDatabasesScope) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$databases;
                        $x$1 = $x$1.$databases;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_NamedDatabasesScope_dup = function($this, $children) {
        return oncia_NamedDatabasesScope__init_($children.$head(), $this.$position198);
    };
    $java.oncia_NamedDatabasesScope__init_ = function($this, $databases, $position) {
        $this.$databases = $databases;
        $this.$position198 = $position;
        $this.$showCommandName3 = $rt_s(1088);
    };
    function oncia_AllGraphsScope() {
        jl_Object.call(this);
        this.$position15 = null;
    }
    $java.oncia_AllGraphsScope_productPrefix = function($this) {
        return $rt_s(2640);
    };
    $java.oncia_AllGraphsScope_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllGraphsScope_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllGraphsScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllGraphsScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllGraphsScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllGraphsScope_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_AllGraphsScope))
            return 0;
        return 1;
    };
    $java.oncia_AllGraphsScope_dup = function($this, $children) {
        return $this;
    };
    function oncia_HomeGraphScope() {
        jl_Object.call(this);
        this.$position16 = null;
    }
    $java.oncia_HomeGraphScope_productPrefix = function($this) {
        return $rt_s(2641);
    };
    $java.oncia_HomeGraphScope_productArity = function($this) {
        return 0;
    };
    $java.oncia_HomeGraphScope_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_HomeGraphScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_HomeGraphScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_HomeGraphScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_HomeGraphScope_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_HomeGraphScope))
            return 0;
        return 1;
    };
    $java.oncia_HomeGraphScope_dup = function($this, $children) {
        return $this;
    };
    function oncia_DefaultGraphScope() {
        jl_Object.call(this);
        this.$position17 = null;
    }
    $java.oncia_DefaultGraphScope_productPrefix = function($this) {
        return $rt_s(2642);
    };
    $java.oncia_DefaultGraphScope_productArity = function($this) {
        return 0;
    };
    $java.oncia_DefaultGraphScope_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DefaultGraphScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultGraphScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultGraphScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DefaultGraphScope_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_DefaultGraphScope))
            return 0;
        return 1;
    };
    $java.oncia_DefaultGraphScope_dup = function($this, $children) {
        return $this;
    };
    function oncia_NamedGraphsScope() {
        var a = this; jl_Object.call(a);
        a.$graphs = null;
        a.$position199 = null;
    }
    function oncia_NamedGraphsScope__init_(var_0, var_1) {
        var var_2 = new oncia_NamedGraphsScope();
        $java.oncia_NamedGraphsScope__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_NamedGraphsScope_productPrefix = function($this) {
        return $rt_s(2643);
    };
    $java.oncia_NamedGraphsScope_productArity = function($this) {
        return 1;
    };
    $java.oncia_NamedGraphsScope_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$graphs;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_NamedGraphsScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamedGraphsScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamedGraphsScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_NamedGraphsScope_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_NamedGraphsScope) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$graphs;
                        $x$1 = $x$1.$graphs;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_NamedGraphsScope_dup = function($this, $children) {
        return oncia_NamedGraphsScope__init_($children.$head(), $this.$position199);
    };
    $java.oncia_NamedGraphsScope__init_ = function($this, $graphs, $position) {
        $this.$graphs = $graphs;
        $this.$position199 = $position;
    };
    function oncia_GraphPrivilege() {
        var a = this; oncia_PrivilegeType.call(a);
        a.$action0 = null;
        a.$scope5 = null;
        a.$position22 = null;
    }
    function oncia_GraphPrivilege_action($this) {
        return $this.$action0;
    }
    function oncia_GraphPrivilege_scope($this) {
        return $this.$scope5;
    }
    $java.oncia_GraphPrivilege_productPrefix = function($this) {
        return $rt_s(2644);
    };
    $java.oncia_GraphPrivilege_productArity = function($this) {
        return 2;
    };
    $java.oncia_GraphPrivilege_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$action0;
            case 1:
                return $this.$scope5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_GraphPrivilege_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphPrivilege_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphPrivilege_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphPrivilege_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_GraphPrivilege) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$action0;
                            var$3 = $x$1.$action0;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$scope5;
                        $x$1 = $x$1.$scope5;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncia_LoadPrivilege() {
        var a = this; oncia_PrivilegeType.call(a);
        a.$action5 = null;
        a.$position200 = null;
    }
    function oncia_LoadPrivilege__init_(var_0, var_1) {
        var var_2 = new oncia_LoadPrivilege();
        $java.oncia_LoadPrivilege__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_LoadPrivilege_productPrefix = function($this) {
        return $rt_s(2645);
    };
    $java.oncia_LoadPrivilege_productArity = function($this) {
        return 1;
    };
    $java.oncia_LoadPrivilege_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$action5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LoadPrivilege_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadPrivilege_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadPrivilege_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadPrivilege_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_LoadPrivilege) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$action5;
                        $x$1 = $x$1.$action5;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_LoadPrivilege__init_ = function($this, $action, $position) {
        $this.$action5 = $action;
        $this.$position200 = $position;
        oncia_PrivilegeType__init_($this, $java.oncia_LoadAction$_name);
    };
    $java.oncia_DataExchangeAction = $rt_classWithoutFields(0);
    var oncia_LoadAction$ = $rt_classWithoutFields();
    var oncia_LoadAction$_MODULE$ = null;
    $java.oncia_LoadAction$_name = null;
    function oncia_LoadAction$__clinit_() {
        oncia_LoadAction$_MODULE$ = new oncia_LoadAction$;
        $java.oncia_LoadAction$_name = $rt_s(2646);
    }
    $java.oncia_LoadAction$_productArity = function($this) {
        return 0;
    };
    $java.oncia_LoadAction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LoadAction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadAction$_hashCode = function($this) {
        return 1246709468;
    };
    $java.oncia_LoadAction$_toString = function($this) {
        return $rt_s(2647);
    };
    function oncia_FileResource() {
        jl_Object.call(this);
        this.$position201 = null;
    }
    function oncia_FileResource__init_(var_0) {
        var var_1 = new oncia_FileResource();
        $java.oncia_FileResource__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_FileResource_productPrefix = function($this) {
        return $rt_s(2648);
    };
    $java.oncia_FileResource_productArity = function($this) {
        return 0;
    };
    $java.oncia_FileResource_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_FileResource_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_FileResource_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_FileResource_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_FileResource_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_FileResource))
            return 0;
        return 1;
    };
    $java.oncia_FileResource__init_ = function($this, $position) {
        $this.$position201 = $position;
    };
    $java.oncia_LoadPrivilegeQualifier = $rt_classWithoutFields(0);
    function oncia_LoadUrlQualifier() {
        var a = this; jl_Object.call(a);
        a.$url3 = null;
        a.$position202 = null;
    }
    function oncia_LoadUrlQualifier__init_(var_0, var_1) {
        var var_2 = new oncia_LoadUrlQualifier();
        $java.oncia_LoadUrlQualifier__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_LoadUrlQualifier_productPrefix = function($this) {
        return $rt_s(2649);
    };
    $java.oncia_LoadUrlQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_LoadUrlQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$url3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LoadUrlQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadUrlQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadUrlQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadUrlQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_LoadUrlQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$url3;
                        $x$1 = $x$1.$url3;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_LoadUrlQualifier_dup = function($this, $children) {
        return oncia_LoadUrlQualifier__init_($children.$head(), $this.$position202);
    };
    $java.oncia_LoadUrlQualifier__init_ = function($this, $url, $position) {
        $this.$url3 = $url;
        $this.$position202 = $position;
    };
    function oncia_LoadAllQualifier() {
        jl_Object.call(this);
        this.$position33 = null;
    }
    $java.oncia_LoadAllQualifier_productPrefix = function($this) {
        return $rt_s(2650);
    };
    $java.oncia_LoadAllQualifier_productArity = function($this) {
        return 0;
    };
    $java.oncia_LoadAllQualifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LoadAllQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadAllQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadAllQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadAllQualifier_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_LoadAllQualifier))
            return 0;
        return 1;
    };
    $java.oncia_LoadAllQualifier_dup = function($this, $children) {
        return $this;
    };
    function oncia_LoadCidrQualifier() {
        var a = this; jl_Object.call(a);
        a.$cidr = null;
        a.$position203 = null;
    }
    function oncia_LoadCidrQualifier__init_(var_0, var_1) {
        var var_2 = new oncia_LoadCidrQualifier();
        $java.oncia_LoadCidrQualifier__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_LoadCidrQualifier_productPrefix = function($this) {
        return $rt_s(2651);
    };
    $java.oncia_LoadCidrQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_LoadCidrQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$cidr;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LoadCidrQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadCidrQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadCidrQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LoadCidrQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_LoadCidrQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$cidr;
                        $x$1 = $x$1.$cidr;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_LoadCidrQualifier_dup = function($this, $children) {
        return oncia_LoadCidrQualifier__init_($children.$head(), $this.$position203);
    };
    $java.oncia_LoadCidrQualifier__init_ = function($this, $cidr, $position) {
        $this.$cidr = $cidr;
        $this.$position203 = $position;
    };
    function oncia_LabelAllQualifier() {
        jl_Object.call(this);
        this.$position21 = null;
    }
    $java.oncia_LabelAllQualifier_productPrefix = function($this) {
        return $rt_s(2652);
    };
    $java.oncia_LabelAllQualifier_productArity = function($this) {
        return 0;
    };
    $java.oncia_LabelAllQualifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LabelAllQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelAllQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelAllQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelAllQualifier_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_LabelAllQualifier))
            return 0;
        return 1;
    };
    $java.oncia_LabelAllQualifier_dup = function($this, $children) {
        return $this;
    };
    function oncia_ElementsAllQualifier() {
        jl_Object.call(this);
        this.$position19 = null;
    }
    $java.oncia_ElementsAllQualifier_productPrefix = function($this) {
        return $rt_s(2653);
    };
    $java.oncia_ElementsAllQualifier_productArity = function($this) {
        return 0;
    };
    $java.oncia_ElementsAllQualifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ElementsAllQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ElementsAllQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ElementsAllQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ElementsAllQualifier_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_ElementsAllQualifier))
            return 0;
        return 1;
    };
    $java.oncia_ElementsAllQualifier_dup = function($this, $children) {
        return $this;
    };
    $java.oncia_SortItem = $rt_classWithoutFields(0);
    $java.oncia_SortItem_semanticCheck$ = function($$this) {
        var var$2, var$3, var$4;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, oncie_Expression$SemanticContext$Results$_MODULE$, $$this.$expression1());
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = onciu_Foldable_folder$($$this.$expression1());
        sr_ClassTag$_$callClinit();
        return oncias_SemanticCheck_chain$(var$2, $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNames(var$3, (onciu_Foldable$Folder_findAllByClass(var$4, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_Property)))).$map1(new $java.oncia_SortItem$semanticCheck$lambda$_2_0)));
    };
    function oncia_DescSortItem() {
        var a = this; jl_Object.call(a);
        a.$expression13 = null;
        a.$position204 = null;
    }
    function oncia_DescSortItem__init_(var_0, var_1) {
        var var_2 = new oncia_DescSortItem();
        $java.oncia_DescSortItem__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_DescSortItem_semanticCheck = function($this) {
        return $java.oncia_SortItem_semanticCheck$($this);
    };
    $java.oncia_DescSortItem_expression = function($this) {
        return $this.$expression13;
    };
    $java.oncia_DescSortItem_position = function($this) {
        return $this.$position204;
    };
    $java.oncia_DescSortItem_productPrefix = function($this) {
        return $rt_s(2654);
    };
    $java.oncia_DescSortItem_productArity = function($this) {
        return 1;
    };
    $java.oncia_DescSortItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression13;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_DescSortItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DescSortItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DescSortItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_DescSortItem_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_DescSortItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression13;
                        $x$1 = $x$1.$expression13;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_DescSortItem))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_DescSortItem_dup = function($this, $children) {
        return oncia_DescSortItem__init_($children.$head(), $this.$position204);
    };
    $java.oncia_DescSortItem__init_ = function($this, $expression, $position) {
        $this.$expression13 = $expression;
        $this.$position204 = $position;
    };
    function oncia_AscSortItem() {
        var a = this; jl_Object.call(a);
        a.$expression12 = null;
        a.$position205 = null;
    }
    function oncia_AscSortItem__init_(var_0, var_1) {
        var var_2 = new oncia_AscSortItem();
        $java.oncia_AscSortItem__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_AscSortItem_semanticCheck = function($this) {
        return $java.oncia_SortItem_semanticCheck$($this);
    };
    $java.oncia_AscSortItem_expression = function($this) {
        return $this.$expression12;
    };
    $java.oncia_AscSortItem_position = function($this) {
        return $this.$position205;
    };
    $java.oncia_AscSortItem_productPrefix = function($this) {
        return $rt_s(2655);
    };
    $java.oncia_AscSortItem_productArity = function($this) {
        return 1;
    };
    $java.oncia_AscSortItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression12;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AscSortItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AscSortItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AscSortItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AscSortItem_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_AscSortItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression12;
                        $x$1 = $x$1.$expression12;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_AscSortItem))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_AscSortItem_dup = function($this, $children) {
        return oncia_AscSortItem__init_($children.$head(), $this.$position205);
    };
    $java.oncia_AscSortItem__init_ = function($this, $expression, $position) {
        $this.$expression12 = $expression;
        $this.$position205 = $position;
    };
    $java.oncie_SignedIntegerLiteral = $rt_classWithoutFields(0);
    function oncie_SignedDecimalIntegerLiteral() {
        var a = this; $java.oncie_DecimalIntegerLiteral.call(a);
        a.$stringVal2 = null;
        a.$position206 = null;
    }
    function oncie_SignedDecimalIntegerLiteral__init_(var_0, var_1) {
        var var_2 = new oncie_SignedDecimalIntegerLiteral();
        oncie_SignedDecimalIntegerLiteral__init_0(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_SignedDecimalIntegerLiteral_stringVal = function($this) {
        return $this.$stringVal2;
    };
    $java.oncie_SignedDecimalIntegerLiteral_position = function($this) {
        return $this.$position206;
    };
    $java.oncie_SignedDecimalIntegerLiteral_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_SignedDecimalIntegerLiteral$$anon$1;
        oncie_SignedDecimalIntegerLiteral__init_0(var$1, $this.$stringVal2, $this.$position206);
        return var$1;
    };
    $java.oncie_SignedDecimalIntegerLiteral_copy = function($this, $stringVal, $position) {
        return oncie_SignedDecimalIntegerLiteral__init_($stringVal, $position);
    };
    $java.oncie_SignedDecimalIntegerLiteral_productPrefix = function($this) {
        return $rt_s(2656);
    };
    $java.oncie_SignedDecimalIntegerLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_SignedDecimalIntegerLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$stringVal2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SignedDecimalIntegerLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedDecimalIntegerLiteral_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_SignedDecimalIntegerLiteral;
    };
    $java.oncie_SignedDecimalIntegerLiteral_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedDecimalIntegerLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedDecimalIntegerLiteral_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_SignedDecimalIntegerLiteral) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$stringVal2;
                        $x$1 = $x$1.$stringVal2;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_SignedDecimalIntegerLiteral))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncie_SignedDecimalIntegerLiteral__init_0($this, $stringVal, $position) {
        $this.$stringVal2 = $stringVal;
        $this.$position206 = $position;
        $java.oncie_DecimalIntegerLiteral__init_($this, $stringVal);
    }
    function oncia_UsingIndexHint() {
        var a = this; jl_Object.call(a);
        a.$variable6 = null;
        a.$labelOrRelType0 = null;
        a.$properties3 = null;
        a.$spec = null;
        a.$indexType = null;
        a.$position207 = null;
    }
    $java.oncia_UsingIndexHint__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5) {
        var var_6 = new oncia_UsingIndexHint();
        oncia_UsingIndexHint__init_(var_6, var_0, var_1, var_2, var_3, var_4, var_5);
        return var_6;
    };
    $java.oncia_UsingIndexHint_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_UsingIndexHint_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_UsingIndexHint_position = function($this) {
        return $this.$position207;
    };
    $java.oncia_UsingIndexHint_semanticCheck = function($this) {
        return oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_ensureDefined$($this, $this.$variable6)), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_UsingIndexHint$semanticCheck$lambda$_58_0, $this.$variable6));
    };
    $java.oncia_UsingIndexHint_productPrefix = function($this) {
        return $rt_s(2657);
    };
    $java.oncia_UsingIndexHint_productArity = function($this) {
        return 5;
    };
    $java.oncia_UsingIndexHint_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable6;
            case 1:
                return $this.$labelOrRelType0;
            case 2:
                return $this.$properties3;
            case 3:
                return $this.$spec;
            case 4:
                return $this.$indexType;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UsingIndexHint_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingIndexHint_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingIndexHint_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingIndexHint_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_UsingIndexHint) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable6;
                        var$3 = $x$1.$variable6;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$labelOrRelType0;
                        var$3 = $x$1.$labelOrRelType0;
                        if (var$2 !== null) {
                            if (!$java.oncie_LabelOrRelTypeName_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$properties3;
                        var$3 = $x$1.$properties3;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$2 = $this.$spec;
                        var$3 = $x$1.$spec;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, var$3))
                                break b;
                            else
                                break f;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    g: {
                        var$3 = $this.$indexType;
                        $x$1 = $x$1.$indexType;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break g;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_UsingIndexHint))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_UsingIndexHint_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    function oncia_UsingIndexHint__init_($this, $variable, $labelOrRelType, $properties, $spec, $indexType, $position) {
        $this.$variable6 = $variable;
        $this.$labelOrRelType0 = $labelOrRelType;
        $this.$properties3 = $properties;
        $this.$spec = $spec;
        $this.$indexType = $indexType;
        $this.$position207 = $position;
    }
    function onciafn_Neo4jASTFactory$usingIndexHint$lambda$_12_0() {
        jl_Object.call(this);
        this.$_0237 = null;
    }
    $java.onciafn_Neo4jASTFactory$usingIndexHint$lambda$_12_0_apply = function(var$0, var$1) {
        return oncie_PropertyKeyName__init_(var$1, var$0.$_0237);
    };
    $java.oncia_UsingIndexHintSpec = $rt_classWithoutFields(0);
    var oncia_SeekOrScan$ = $rt_classWithoutFields();
    var oncia_SeekOrScan$_MODULE$ = null;
    function oncia_SeekOrScan$__clinit_() {
        oncia_SeekOrScan$_MODULE$ = new oncia_SeekOrScan$;
    }
    $java.oncia_SeekOrScan$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SeekOrScan$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SeekOrScan$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SeekOrScan$_hashCode = function($this) {
        return 1478327224;
    };
    $java.oncia_SeekOrScan$_toString = function($this) {
        return $rt_s(2658);
    };
    var oncia_SeekOnly$ = $rt_classWithoutFields();
    var oncia_SeekOnly$_MODULE$ = null;
    function oncia_SeekOnly$__clinit_() {
        oncia_SeekOnly$_MODULE$ = new oncia_SeekOnly$;
    }
    $java.oncia_SeekOnly$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SeekOnly$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SeekOnly$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SeekOnly$_hashCode = function($this) {
        return 1060751972;
    };
    $java.oncia_SeekOnly$_toString = function($this) {
        return $rt_s(2659);
    };
    $java.oncie_PatternPart$SelectiveSelector = $rt_classWithoutFields(0);
    $java.oncie_PatternPart$CountedSelector = $rt_classWithoutFields(0);
    function oncie_PatternPart$AnyShortestPath() {
        var a = this; jl_Object.call(a);
        a.$count2 = null;
        a.$position208 = null;
    }
    function oncie_PatternPart$AnyShortestPath__init_(var_0, var_1) {
        var var_2 = new oncie_PatternPart$AnyShortestPath();
        $java.oncie_PatternPart$AnyShortestPath__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_PatternPart$AnyShortestPath_count = function($this) {
        return $this.$count2;
    };
    $java.oncie_PatternPart$AnyShortestPath_position = function($this) {
        return $this.$position208;
    };
    $java.oncie_PatternPart$AnyShortestPath_prettified = function($this) {
        var var$1, var$2;
        var$1 = $java.oncie_DecimalIntegerLiteral_value($this.$count2);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2660)), var$1), $rt_s(2661));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncie_PatternPart$AnyShortestPath_isBounded = function($this) {
        return 1;
    };
    $java.oncie_PatternPart$AnyShortestPath_productPrefix = function($this) {
        return $rt_s(2662);
    };
    $java.oncie_PatternPart$AnyShortestPath_productArity = function($this) {
        return 1;
    };
    $java.oncie_PatternPart$AnyShortestPath_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$count2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternPart$AnyShortestPath_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AnyShortestPath_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AnyShortestPath_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AnyShortestPath_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PatternPart$AnyShortestPath) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$count2;
                        $x$1 = $x$1.$count2;
                        if (var$2 !== null) {
                            if (!$java.oncie_UnsignedDecimalIntegerLiteral_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PatternPart$AnyShortestPath))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PatternPart$AnyShortestPath_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternPart$AnyShortestPath__init_ = function($this, $count, $position) {
        $this.$count2 = $count;
        $this.$position208 = $position;
    };
    function oncie_PatternPart$AllShortestPaths() {
        jl_Object.call(this);
        this.$position209 = null;
    }
    function oncie_PatternPart$AllShortestPaths__init_(var_0) {
        var var_1 = new oncie_PatternPart$AllShortestPaths();
        $java.oncie_PatternPart$AllShortestPaths__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_PatternPart$AllShortestPaths_position = function($this) {
        return $this.$position209;
    };
    $java.oncie_PatternPart$AllShortestPaths_prettified = function($this) {
        return $rt_s(2663);
    };
    $java.oncie_PatternPart$AllShortestPaths_isBounded = function($this) {
        return 1;
    };
    $java.oncie_PatternPart$AllShortestPaths_productPrefix = function($this) {
        return $rt_s(2664);
    };
    $java.oncie_PatternPart$AllShortestPaths_productArity = function($this) {
        return 0;
    };
    $java.oncie_PatternPart$AllShortestPaths_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternPart$AllShortestPaths_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AllShortestPaths_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AllShortestPaths_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AllShortestPaths_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_PatternPart$AllShortestPaths) ? 0 : 1;
        return var$2 && $this instanceof oncie_PatternPart$AllShortestPaths ? 1 : 0;
    };
    $java.oncie_PatternPart$AllShortestPaths_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternPart$AllShortestPaths__init_ = function($this, $position) {
        $this.$position209 = $position;
    };
    function oncie_PatternPart$AnyPath() {
        var a = this; jl_Object.call(a);
        a.$count3 = null;
        a.$position210 = null;
    }
    function oncie_PatternPart$AnyPath__init_(var_0, var_1) {
        var var_2 = new oncie_PatternPart$AnyPath();
        $java.oncie_PatternPart$AnyPath__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_PatternPart$AnyPath_count = function($this) {
        return $this.$count3;
    };
    $java.oncie_PatternPart$AnyPath_position = function($this) {
        return $this.$position210;
    };
    $java.oncie_PatternPart$AnyPath_prettified = function($this) {
        var var$1, var$2;
        var$1 = $java.oncie_DecimalIntegerLiteral_value($this.$count3);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2665)), var$1), $rt_s(2661));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncie_PatternPart$AnyPath_isBounded = function($this) {
        return 1;
    };
    $java.oncie_PatternPart$AnyPath_productPrefix = function($this) {
        return $rt_s(2666);
    };
    $java.oncie_PatternPart$AnyPath_productArity = function($this) {
        return 1;
    };
    $java.oncie_PatternPart$AnyPath_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$count3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternPart$AnyPath_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AnyPath_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AnyPath_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AnyPath_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PatternPart$AnyPath) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$count3;
                        $x$1 = $x$1.$count3;
                        if (var$2 !== null) {
                            if (!$java.oncie_UnsignedDecimalIntegerLiteral_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PatternPart$AnyPath))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PatternPart$AnyPath_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternPart$AnyPath__init_ = function($this, $count, $position) {
        $this.$count3 = $count;
        $this.$position210 = $position;
    };
    function oncie_PatternPart$AllPaths() {
        jl_Object.call(this);
        this.$position211 = null;
    }
    function oncie_PatternPart$AllPaths__init_(var_0) {
        var var_1 = new oncie_PatternPart$AllPaths();
        $java.oncie_PatternPart$AllPaths__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_PatternPart$AllPaths_position = function($this) {
        return $this.$position211;
    };
    $java.oncie_PatternPart$AllPaths_prettified = function($this) {
        return $rt_s(2667);
    };
    $java.oncie_PatternPart$AllPaths_isBounded = function($this) {
        return 0;
    };
    $java.oncie_PatternPart$AllPaths_productPrefix = function($this) {
        return $rt_s(2668);
    };
    $java.oncie_PatternPart$AllPaths_productArity = function($this) {
        return 0;
    };
    $java.oncie_PatternPart$AllPaths_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternPart$AllPaths_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AllPaths_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AllPaths_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$AllPaths_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_PatternPart$AllPaths) ? 0 : 1;
        return var$2 && $this instanceof oncie_PatternPart$AllPaths ? 1 : 0;
    };
    $java.oncie_PatternPart$AllPaths_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternPart$AllPaths__init_ = function($this, $position) {
        $this.$position211 = $position;
    };
    function oncie_PatternPart$ShortestGroups() {
        var a = this; jl_Object.call(a);
        a.$count4 = null;
        a.$position212 = null;
    }
    function oncie_PatternPart$ShortestGroups__init_(var_0, var_1) {
        var var_2 = new oncie_PatternPart$ShortestGroups();
        $java.oncie_PatternPart$ShortestGroups__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_PatternPart$ShortestGroups_count = function($this) {
        return $this.$count4;
    };
    $java.oncie_PatternPart$ShortestGroups_position = function($this) {
        return $this.$position212;
    };
    $java.oncie_PatternPart$ShortestGroups_prettified = function($this) {
        var var$1, var$2;
        var$1 = $java.oncie_DecimalIntegerLiteral_value($this.$count4);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2660)), var$1), $rt_s(2669));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncie_PatternPart$ShortestGroups_isBounded = function($this) {
        return 1;
    };
    $java.oncie_PatternPart$ShortestGroups_productPrefix = function($this) {
        return $rt_s(2670);
    };
    $java.oncie_PatternPart$ShortestGroups_productArity = function($this) {
        return 1;
    };
    $java.oncie_PatternPart$ShortestGroups_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$count4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternPart$ShortestGroups_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$ShortestGroups_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$ShortestGroups_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternPart$ShortestGroups_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PatternPart$ShortestGroups) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$count4;
                        $x$1 = $x$1.$count4;
                        if (var$2 !== null) {
                            if (!$java.oncie_UnsignedDecimalIntegerLiteral_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PatternPart$ShortestGroups))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PatternPart$ShortestGroups_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PatternPart$ShortestGroups__init_ = function($this, $count, $position) {
        $this.$count4 = $count;
        $this.$position212 = $position;
    };
    function oncie_PathPatternPart() {
        $java.oncie_PatternPart.call(this);
        this.$element2 = null;
    }
    function oncie_PathPatternPart__init_(var_0) {
        var var_1 = new oncie_PathPatternPart();
        oncie_PathPatternPart__init_0(var_1, var_0);
        return var_1;
    }
    $java.oncie_PathPatternPart_allVariables = function($this) {
        return $java.oncie_AnonymousPatternPart_allVariables$($this);
    };
    $java.oncie_PathPatternPart_element = function($this) {
        return $this.$element2;
    };
    $java.oncie_PathPatternPart_position = function($this) {
        return $this.$element2.$position2();
    };
    $java.oncie_PathPatternPart_isBounded = function($this) {
        return $this.$element2.$isBounded();
    };
    $java.oncie_PathPatternPart_dup = function($this, $children) {
        return oncie_PathPatternPart__init_($children.$head());
    };
    $java.oncie_PathPatternPart_productPrefix = function($this) {
        return $rt_s(2671);
    };
    $java.oncie_PathPatternPart_productArity = function($this) {
        return 1;
    };
    $java.oncie_PathPatternPart_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$element2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PathPatternPart_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PathPatternPart_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PathPatternPart_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PathPatternPart_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PathPatternPart) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$element2;
                        $x$1 = $x$1.$element2;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PathPatternPart))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PathPatternPart_dup0 = function($this, $children) {
        return $java.oncie_PathPatternPart_dup($this, $children);
    };
    $java.oncie_PathPatternPart_dup1 = function($this, $children) {
        return $java.oncie_PathPatternPart_dup($this, $children);
    };
    function oncie_PathPatternPart__init_0($this, $element) {
        $this.$element2 = $element;
        $java.oncie_PatternPart__init_($this);
    }
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour = $rt_classWithoutFields(0);
    var oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$ = $rt_classWithoutFields();
    var oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_MODULE$ = null;
    function oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$__clinit_() {
        oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_MODULE$ = new oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$;
    }
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_hashCode = function($this) {
        return (-1599899888);
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_toString = function($this) {
        return $rt_s(2672);
    };
    var oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$ = $rt_classWithoutFields();
    var oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_MODULE$ = null;
    function oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$__clinit_() {
        oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_MODULE$ = new oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$;
    }
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_hashCode = function($this) {
        return 819285814;
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_toString = function($this) {
        return $rt_s(2673);
    };
    var oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$ = $rt_classWithoutFields();
    var oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_MODULE$ = null;
    function oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$__clinit_() {
        oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_MODULE$ = new oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$;
    }
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_productArity = function($this) {
        return 0;
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_hashCode = function($this) {
        return 1966194183;
    };
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_toString = function($this) {
        return $rt_s(2674);
    };
    $java.jt_DecimalFormat$MinusField = $rt_classWithoutFields();
    $java.jt_DecimalFormat$MinusField_equals = function($this, $obj) {
        return $obj instanceof $java.jt_DecimalFormat$MinusField;
    };
    $java.jt_DecimalFormat$MinusField_hashCode = function($this) {
        return 3;
    };
    function sci_ListSet$Node() {
        var a = this; sci_ListSet.call(a);
        a.$elem8 = null;
        a.$$outer45 = null;
    }
    function sci_ListSet$Node__init_(var_0, var_1) {
        var var_2 = new sci_ListSet$Node();
        $java.sci_ListSet$Node__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.sci_ListSet$Node_elem = function($this) {
        return $this.$elem8;
    };
    $java.sci_ListSet$Node_size = function($this) {
        var var$1;
        var$1 = 0;
        while (!$this.$isEmpty()) {
            $this = $this.$next7();
            var$1 = var$1 + 1 | 0;
        }
        return var$1;
    };
    $java.sci_ListSet$Node_knownSize = function($this) {
        return (-1);
    };
    $java.sci_ListSet$Node_isEmpty = function($this) {
        return 0;
    };
    $java.sci_ListSet$Node_contains = function($this, $e) {
        var var$2;
        a: {
            while (!$this.$isEmpty()) {
                if (sr_BoxesRunTime_equals($this.$elem7(), $e)) {
                    var$2 = 1;
                    break a;
                }
                $this = $this.$next7();
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.sci_ListSet$Node_incl = function($this, $e) {
        if ($java.sci_ListSet$Node_contains($this, $e))
            return $this;
        return sci_ListSet$Node__init_($this, $e);
    };
    $java.sci_ListSet$Node_excl = function($this, $e) {
        var var$2, var$3;
        var$2 = sci_Nil$_MODULE$;
        a: {
            while (true) {
                if ($this.$isEmpty()) {
                    $e = var$2.$last();
                    break a;
                }
                if (sr_BoxesRunTime_equals($e, $this.$elem7())) {
                    $e = $this.$next7();
                    var$3 = new $java.sci_ListSet$Node$removeInternal$lambda$_9_0;
                    if (var$2 === null)
                        $rt_throw(null);
                    $e = sc_LinearSeqOps_foldLeft$(var$2, $e, var$3);
                    break a;
                }
                var$3 = $this.$next7();
                if (var$2 === null)
                    break;
                var$2 = sci_$colon$colon__init_($this, var$2);
                $this = var$3;
            }
            $rt_throw(null);
        }
        return $e;
    };
    $java.sci_ListSet$Node_next = function($this) {
        return $this.$$outer45;
    };
    $java.sci_ListSet$Node_last = function($this) {
        return $this.$elem8;
    };
    $java.sci_ListSet$Node_init = function($this) {
        return $this.$$outer45;
    };
    $java.sci_ListSet$Node_excl0 = function($this, $elem) {
        return $java.sci_ListSet$Node_excl($this, $elem);
    };
    $java.sci_ListSet$Node_incl0 = function($this, $elem) {
        return $java.sci_ListSet$Node_incl($this, $elem);
    };
    $java.sci_ListSet$Node__init_ = function($this, $$outer, $elem) {
        $this.$elem8 = $elem;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer45 = $$outer;
    };
    var sci_MapValueIterator = $rt_classWithoutFields(sci_ChampBaseIterator);
    $java.sci_MapValueIterator_iterator = function($this) {
        return $this;
    };
    $java.sci_MapValueIterator_contains = function($this, $elem) {
        return sc_Iterator_contains$($this, $elem);
    };
    $java.sci_MapValueIterator_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.sci_MapValueIterator_filterImpl = function($this, $p, $isFlipped) {
        return sc_Iterator_filterImpl$($this, $p, $isFlipped);
    };
    $java.sci_MapValueIterator_map = function($this, $f) {
        return sc_Iterator_map$($this, $f);
    };
    $java.sci_MapValueIterator_flatMap = function($this, $f) {
        return sc_Iterator_flatMap$($this, $f);
    };
    $java.sci_MapValueIterator_toString = function($this) {
        return $rt_s(466);
    };
    $java.sci_MapValueIterator_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.sci_MapValueIterator_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.sci_MapValueIterator_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.sci_MapValueIterator_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.sci_MapValueIterator_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.sci_MapValueIterator_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.sci_MapValueIterator_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.sci_MapValueIterator_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.sci_MapValueIterator_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.sci_MapValueIterator_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.sci_MapValueIterator_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.sci_MapValueIterator_knownSize = function($this) {
        return (-1);
    };
    $java.sci_MapValueIterator_next = function($this) {
        var $value;
        if (!sci_ChampBaseIterator_hasNext($this)) {
            $value = new ju_NoSuchElementException;
            jl_Throwable__init_0($value);
            $rt_throw($value);
        }
        $value = $this.$currentValueNode.$getValue($this.$currentValueCursor);
        $this.$currentValueCursor = $this.$currentValueCursor + 1 | 0;
        return $value;
    };
    $java.sci_Map$Map2$$anon$3 = $rt_classWithoutFields($java.sci_Map$Map2$Map2Iterator);
    $java.sci_Map$Map2$$anon$3_nextResult = function($this, $k, $v) {
        return $v;
    };
    var scm_HashMap$$anon$4 = $rt_classWithoutFields(scm_HashMap$HashMapIterator);
    $java.scm_HashMap$$anon$4_extract = function($this, $nd) {
        return $nd;
    };
    function sci_MapOps$ImmutableKeySet() {
        sci_AbstractSet.call(this);
        this.$$outer46 = null;
    }
    function sci_MapOps$ImmutableKeySet__init_(var_0) {
        var var_1 = new sci_MapOps$ImmutableKeySet();
        sci_MapOps$ImmutableKeySet__init_0(var_1, var_0);
        return var_1;
    }
    $java.sci_MapOps$ImmutableKeySet_iterator = function($this) {
        return sc_MapOps$GenKeySet_iterator$($this);
    };
    $java.sci_MapOps$ImmutableKeySet_contains = function($this, $key) {
        return $this.$$outer46.$contains0($key);
    };
    $java.sci_MapOps$ImmutableKeySet_size = function($this) {
        return $this.$$outer46.$size();
    };
    $java.sci_MapOps$ImmutableKeySet_knownSize = function($this) {
        return sc_MapOps$GenKeySet_knownSize$($this);
    };
    $java.sci_MapOps$ImmutableKeySet_isEmpty = function($this) {
        return $this.$$outer46.$isEmpty();
    };
    $java.sci_MapOps$ImmutableKeySet_scala$collection$immutable$MapOps$ImmutableKeySet$$$outer = function($this) {
        return $this.$$outer46;
    };
    $java.sci_MapOps$ImmutableKeySet_scala$collection$MapOps$GenKeySet$$$outer = function($this) {
        return $this.$$outer46;
    };
    function sci_MapOps$ImmutableKeySet__init_0($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer46 = $$outer;
    }
    var sci_HashMap$HashKeySet = $rt_classWithoutFields(sci_MapOps$ImmutableKeySet);
    $java.sci_HashMap$HashKeySet_newKeySetOrThis = function($this, $newHashMap) {
        if ($newHashMap === $java.sci_HashMap$HashKeySet_scala$collection$immutable$HashMap$HashKeySet$$$outer($this))
            return $this;
        return sci_HashMap_keySet($newHashMap);
    };
    $java.sci_HashMap$HashKeySet_filter = function($this, $pred) {
        var $filter_this, $filter_pred, $filterImpl_newRootNode, $filterImpl_filterImpl_i, $filterImpl_filterImpl_maximumIndex, $filterImpl_filterImpl_newDataMap, $filterImpl_filterImpl_newCachedHashCode, $filterImpl_filterImpl_dataIndex, $filterImpl_filterImpl_bitpos, $filterImpl_filterImpl_newSize, $filterImpl_filterImpl_newContent, $filterImpl_filterImpl_newOriginalHashes, $filterImpl_filterImpl_newOriginalHashCodes, var$15, $filterImpl_filterImpl_newMaximumIndex, $filterImpl_filterImpl_j, $filterImpl_filterImpl_newDataIndex,
        $filterImpl_filterImpl_oldIndex, $filterImpl_filterImpl_newContent_0, $filterImpl_filterImpl_allMap, $filterImpl_filterImpl_minimumIndex, $filterImpl_filterImpl_oldDataPassThrough, $filterImpl_filterImpl_nodeMigrateToDataTargetMap, $filterImpl_filterImpl_nodesToMigrateToData, $filterImpl_filterImpl_nodesToPassThroughMap, $filterImpl_filterImpl_mapOfNewNodes, $filterImpl_filterImpl_newNodes, $filterImpl_filterImpl_newNodeMap, $filterImpl_filterImpl_nodeIndex, $filterImpl_filterImpl_i_0, $filterImpl_filterImpl_oldSubNode,
        $filterImpl_filterImpl_newSubNode, $filterImpl_filterImpl_newDataSize, $filterImpl_filterImpl_newContentSize, $filterImpl_filterImpl_maxIndex, $filterImpl_filterImpl_oldDataIndex, $filterImpl_filterImpl_oldNodeIndex, $filterImpl_filterImpl_newNodeIndex, $filterImpl_filterImpl_node;
        $filter_this = $java.sci_HashMap$HashKeySet_scala$collection$immutable$HashMap$HashKeySet$$$outer($this);
        $filter_pred = $java.sci_HashMap$HashKeySet$filter$lambda$_4_0__init_($pred);
        if ($filter_this === null)
            $rt_throw(null);
        $filterImpl_newRootNode = sci_HashMap_rootNode($filter_this);
        if ($filterImpl_newRootNode === null)
            $rt_throw(null);
        if (sci_BitmapIndexedMapNode_size($filterImpl_newRootNode)) {
            if (sci_BitmapIndexedMapNode_size($filterImpl_newRootNode) == 1) {
                if (!sr_BoxesRunTime_unboxToBoolean(sc_AbstractSet_apply0($pred, s_Tuple2__1(sci_BitmapIndexedMapNode_getPayload($filterImpl_newRootNode, 0))))) {
                    sci_MapNode$_$callClinit();
                    $filterImpl_newRootNode = sci_MapNode$_empty(sci_MapNode$_MODULE$);
                }
            } else if (!sci_BitmapIndexedMapNode_nodeMap($filterImpl_newRootNode)) {
                $filterImpl_filterImpl_i = jl_Integer_numberOfTrailingZeros(sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode));
                $filterImpl_filterImpl_maximumIndex = 32 - jl_Integer_numberOfLeadingZeros(sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode)) | 0;
                $filterImpl_filterImpl_newDataMap = 0;
                $filterImpl_filterImpl_newCachedHashCode = 0;
                $filterImpl_filterImpl_dataIndex = 0;
                while ($filterImpl_filterImpl_i < $filterImpl_filterImpl_maximumIndex) {
                    $filterImpl_filterImpl_bitpos = 1 << $filterImpl_filterImpl_i;
                    if ($filterImpl_filterImpl_bitpos & sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode)) {
                        if (!sr_BoxesRunTime_unboxToBoolean(sc_AbstractSet_apply0($pred, s_Tuple2__1(sci_BitmapIndexedMapNode_getPayload($filterImpl_newRootNode, $filterImpl_filterImpl_dataIndex)))) ? 0 : 1) {
                            $filterImpl_filterImpl_newDataMap = $filterImpl_filterImpl_newDataMap | $filterImpl_filterImpl_bitpos;
                            $filterImpl_filterImpl_newCachedHashCode = $filterImpl_filterImpl_newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, (sci_BitmapIndexedMapNode_originalHashes($filterImpl_newRootNode)).data[$filterImpl_filterImpl_dataIndex]) | 0;
                        }
                        $filterImpl_filterImpl_dataIndex = $filterImpl_filterImpl_dataIndex + 1 | 0;
                    }
                    $filterImpl_filterImpl_i = $filterImpl_filterImpl_i + 1 | 0;
                }
                if (!$filterImpl_filterImpl_newDataMap) {
                    sci_MapNode$_$callClinit();
                    $filterImpl_newRootNode = sci_MapNode$_empty(sci_MapNode$_MODULE$);
                } else if ($filterImpl_filterImpl_newDataMap != sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode)) {
                    $filterImpl_filterImpl_newSize = jl_Integer_bitCount($filterImpl_filterImpl_newDataMap);
                    $filterImpl_filterImpl_newContent = $rt_createArray(jl_Object, $filterImpl_filterImpl_newSize * 2 | 0);
                    $filterImpl_filterImpl_newOriginalHashes = $filterImpl_filterImpl_newContent.data;
                    $filterImpl_filterImpl_newOriginalHashCodes = $rt_createIntArray($filterImpl_filterImpl_newSize);
                    var$15 = $filterImpl_filterImpl_newOriginalHashCodes.data;
                    $filterImpl_filterImpl_newMaximumIndex = 32 - jl_Integer_numberOfLeadingZeros($filterImpl_filterImpl_newDataMap) | 0;
                    $filterImpl_filterImpl_j = jl_Integer_numberOfTrailingZeros($filterImpl_filterImpl_newDataMap);
                    $filterImpl_filterImpl_newDataIndex = 0;
                    while ($filterImpl_filterImpl_j < $filterImpl_filterImpl_newMaximumIndex) {
                        $filterImpl_filterImpl_bitpos = 1 << $filterImpl_filterImpl_j;
                        if ($filterImpl_filterImpl_bitpos & $filterImpl_filterImpl_newDataMap) {
                            $filterImpl_filterImpl_oldIndex = jl_Integer_bitCount(sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode) & ($filterImpl_filterImpl_bitpos - 1 | 0));
                            $filterImpl_filterImpl_i = $filterImpl_filterImpl_newDataIndex * 2 | 0;
                            $filterImpl_filterImpl_newContent_0 = (sci_BitmapIndexedMapNode_content($filterImpl_newRootNode)).data;
                            $filterImpl_filterImpl_maximumIndex = $filterImpl_filterImpl_oldIndex * 2 | 0;
                            $filterImpl_filterImpl_newOriginalHashes[$filterImpl_filterImpl_i] = $filterImpl_filterImpl_newContent_0[$filterImpl_filterImpl_maximumIndex];
                            $filterImpl_filterImpl_newOriginalHashes[$filterImpl_filterImpl_i + 1 | 0] = (sci_BitmapIndexedMapNode_content($filterImpl_newRootNode)).data[$filterImpl_filterImpl_maximumIndex + 1 | 0];
                            var$15[$filterImpl_filterImpl_newDataIndex] = (sci_BitmapIndexedMapNode_originalHashes($filterImpl_newRootNode)).data[$filterImpl_filterImpl_oldIndex];
                            $filterImpl_filterImpl_newDataIndex = $filterImpl_filterImpl_newDataIndex + 1 | 0;
                        }
                        $filterImpl_filterImpl_j = $filterImpl_filterImpl_j + 1 | 0;
                    }
                    $filterImpl_newRootNode = sci_BitmapIndexedMapNode__init_($filterImpl_filterImpl_newDataMap, 0, $filterImpl_filterImpl_newContent, $filterImpl_filterImpl_newOriginalHashCodes, $filterImpl_filterImpl_newSize, $filterImpl_filterImpl_newCachedHashCode);
                }
            } else {
                $filterImpl_filterImpl_allMap = sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode) | sci_BitmapIndexedMapNode_nodeMap($filterImpl_newRootNode);
                $filterImpl_filterImpl_minimumIndex = jl_Integer_numberOfTrailingZeros($filterImpl_filterImpl_allMap);
                $filterImpl_filterImpl_maximumIndex = 32 - jl_Integer_numberOfLeadingZeros($filterImpl_filterImpl_allMap) | 0;
                $filterImpl_filterImpl_oldDataPassThrough = 0;
                $filterImpl_filterImpl_nodeMigrateToDataTargetMap = 0;
                $filterImpl_filterImpl_nodesToMigrateToData = null;
                $filterImpl_filterImpl_nodesToPassThroughMap = 0;
                $filterImpl_filterImpl_mapOfNewNodes = 0;
                $filterImpl_filterImpl_newNodes = null;
                $filterImpl_filterImpl_newDataMap = 0;
                $filterImpl_filterImpl_newNodeMap = 0;
                $filterImpl_filterImpl_newSize = 0;
                $filterImpl_filterImpl_newCachedHashCode = 0;
                $filterImpl_filterImpl_dataIndex = 0;
                $filterImpl_filterImpl_nodeIndex = 0;
                $filterImpl_filterImpl_i_0 = $filterImpl_filterImpl_minimumIndex;
                while ($filterImpl_filterImpl_i_0 < $filterImpl_filterImpl_maximumIndex) {
                    $filterImpl_filterImpl_bitpos = 1 << $filterImpl_filterImpl_i_0;
                    if ($filterImpl_filterImpl_bitpos & sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode)) {
                        if (!sr_BoxesRunTime_unboxToBoolean(sc_AbstractSet_apply0($pred, s_Tuple2__1(sci_BitmapIndexedMapNode_getPayload($filterImpl_newRootNode, $filterImpl_filterImpl_dataIndex)))) ? 0 : 1) {
                            $filterImpl_filterImpl_newDataMap = $filterImpl_filterImpl_newDataMap | $filterImpl_filterImpl_bitpos;
                            $filterImpl_filterImpl_oldDataPassThrough = $filterImpl_filterImpl_oldDataPassThrough | $filterImpl_filterImpl_bitpos;
                            $filterImpl_filterImpl_newSize = $filterImpl_filterImpl_newSize + 1 | 0;
                            $filterImpl_filterImpl_newCachedHashCode = $filterImpl_filterImpl_newCachedHashCode + sc_Hashing$_improve(sc_Hashing$_MODULE$, (sci_BitmapIndexedMapNode_originalHashes($filterImpl_newRootNode)).data[$filterImpl_filterImpl_dataIndex]) | 0;
                        }
                        $filterImpl_filterImpl_dataIndex = $filterImpl_filterImpl_dataIndex + 1 | 0;
                    } else if ($filterImpl_filterImpl_bitpos & sci_BitmapIndexedMapNode_nodeMap($filterImpl_newRootNode)) {
                        $filterImpl_filterImpl_oldSubNode = sci_BitmapIndexedMapNode_getNode($filterImpl_newRootNode, $filterImpl_filterImpl_nodeIndex);
                        $filterImpl_filterImpl_newSubNode = $filterImpl_filterImpl_oldSubNode.$filterImpl4($filter_pred, 0);
                        $filterImpl_filterImpl_newSize = $filterImpl_filterImpl_newSize + $filterImpl_filterImpl_newSubNode.$size() | 0;
                        $filterImpl_filterImpl_newCachedHashCode = $filterImpl_filterImpl_newCachedHashCode + $filterImpl_filterImpl_newSubNode.$cachedJavaKeySetHashCode() | 0;
                        if ($filterImpl_filterImpl_newSubNode.$size() > 1) {
                            $filterImpl_filterImpl_newNodeMap = $filterImpl_filterImpl_newNodeMap | $filterImpl_filterImpl_bitpos;
                            if ($filterImpl_filterImpl_oldSubNode === $filterImpl_filterImpl_newSubNode)
                                $filterImpl_filterImpl_nodesToPassThroughMap = $filterImpl_filterImpl_nodesToPassThroughMap | $filterImpl_filterImpl_bitpos;
                            else {
                                $filterImpl_filterImpl_mapOfNewNodes = $filterImpl_filterImpl_mapOfNewNodes | $filterImpl_filterImpl_bitpos;
                                if ($filterImpl_filterImpl_newNodes === null)
                                    $filterImpl_filterImpl_newNodes = scm_Queue$_empty(scm_Queue$_MODULE$);
                                scm_AbstractBuffer_$plus$eq($filterImpl_filterImpl_newNodes, $filterImpl_filterImpl_newSubNode);
                            }
                        } else if ($filterImpl_filterImpl_newSubNode.$size() == 1) {
                            $filterImpl_filterImpl_newDataMap = $filterImpl_filterImpl_newDataMap | $filterImpl_filterImpl_bitpos;
                            $filterImpl_filterImpl_nodeMigrateToDataTargetMap = $filterImpl_filterImpl_nodeMigrateToDataTargetMap | $filterImpl_filterImpl_bitpos;
                            if ($filterImpl_filterImpl_nodesToMigrateToData === null)
                                $filterImpl_filterImpl_nodesToMigrateToData = sc_IterableFactory_apply$(scm_Queue$_MODULE$, sci_Nil$_MODULE$);
                            scm_AbstractBuffer_$plus$eq($filterImpl_filterImpl_nodesToMigrateToData, $filterImpl_filterImpl_newSubNode);
                        }
                        $filterImpl_filterImpl_nodeIndex = $filterImpl_filterImpl_nodeIndex + 1 | 0;
                    }
                    $filterImpl_filterImpl_i_0 = $filterImpl_filterImpl_i_0 + 1 | 0;
                }
                if (!$filterImpl_filterImpl_newSize) {
                    sci_MapNode$_$callClinit();
                    $filterImpl_newRootNode = sci_MapNode$_empty(sci_MapNode$_MODULE$);
                } else if ($filterImpl_filterImpl_newSize != sci_BitmapIndexedMapNode_size($filterImpl_newRootNode)) {
                    $filterImpl_filterImpl_newDataSize = jl_Integer_bitCount($filterImpl_filterImpl_newDataMap);
                    $filterImpl_filterImpl_newContentSize = (2 * $filterImpl_filterImpl_newDataSize | 0) + jl_Integer_bitCount($filterImpl_filterImpl_newNodeMap) | 0;
                    $filterImpl_filterImpl_newContent_0 = $rt_createArray(jl_Object, $filterImpl_filterImpl_newContentSize);
                    $filterImpl_filterImpl_newContent = $filterImpl_filterImpl_newContent_0.data;
                    $filterImpl_filterImpl_newOriginalHashes = $rt_createIntArray($filterImpl_filterImpl_newDataSize);
                    $filterImpl_filterImpl_newOriginalHashCodes = $filterImpl_filterImpl_newOriginalHashes.data;
                    $filterImpl_filterImpl_maxIndex = 32 - jl_Integer_numberOfLeadingZeros($filterImpl_filterImpl_newDataMap | $filterImpl_filterImpl_newNodeMap) | 0;
                    $filterImpl_filterImpl_oldDataIndex = 0;
                    $filterImpl_filterImpl_oldNodeIndex = 0;
                    $filterImpl_filterImpl_newDataIndex = 0;
                    $filterImpl_filterImpl_newNodeIndex = 0;
                    while ($filterImpl_filterImpl_minimumIndex < $filterImpl_filterImpl_maxIndex) {
                        $filterImpl_filterImpl_bitpos = 1 << $filterImpl_filterImpl_minimumIndex;
                        if ($filterImpl_filterImpl_bitpos & $filterImpl_filterImpl_oldDataPassThrough) {
                            $filterImpl_filterImpl_maximumIndex = $filterImpl_filterImpl_newDataIndex * 2 | 0;
                            var$15 = (sci_BitmapIndexedMapNode_content($filterImpl_newRootNode)).data;
                            $filterImpl_filterImpl_i = 2 * $filterImpl_filterImpl_oldDataIndex | 0;
                            $filterImpl_filterImpl_newContent[$filterImpl_filterImpl_maximumIndex] = var$15[$filterImpl_filterImpl_i];
                            $filterImpl_filterImpl_newContent[$filterImpl_filterImpl_maximumIndex + 1 | 0] = (sci_BitmapIndexedMapNode_content($filterImpl_newRootNode)).data[$filterImpl_filterImpl_i + 1 | 0];
                            $filterImpl_filterImpl_newOriginalHashCodes[$filterImpl_filterImpl_newDataIndex] = (sci_BitmapIndexedMapNode_originalHashes($filterImpl_newRootNode)).data[$filterImpl_filterImpl_oldDataIndex];
                            $filterImpl_filterImpl_newDataIndex = $filterImpl_filterImpl_newDataIndex + 1 | 0;
                            $filterImpl_filterImpl_oldDataIndex = $filterImpl_filterImpl_oldDataIndex + 1 | 0;
                        } else if ($filterImpl_filterImpl_bitpos & $filterImpl_filterImpl_nodesToPassThroughMap) {
                            $filterImpl_filterImpl_newContent[($filterImpl_filterImpl_newContentSize - $filterImpl_filterImpl_newNodeIndex | 0) - 1 | 0] = sci_BitmapIndexedMapNode_getNode($filterImpl_newRootNode, $filterImpl_filterImpl_oldNodeIndex);
                            $filterImpl_filterImpl_newNodeIndex = $filterImpl_filterImpl_newNodeIndex + 1 | 0;
                            $filterImpl_filterImpl_oldNodeIndex = $filterImpl_filterImpl_oldNodeIndex + 1 | 0;
                        } else if ($filterImpl_filterImpl_bitpos & $filterImpl_filterImpl_nodeMigrateToDataTargetMap) {
                            $filterImpl_filterImpl_node = scm_Queue_dequeue($filterImpl_filterImpl_nodesToMigrateToData);
                            $filterImpl_filterImpl_i = 2 * $filterImpl_filterImpl_newDataIndex | 0;
                            $filterImpl_filterImpl_newContent[$filterImpl_filterImpl_i] = $filterImpl_filterImpl_node.$getKey(0);
                            $filterImpl_filterImpl_newContent[$filterImpl_filterImpl_i + 1 | 0] = $filterImpl_filterImpl_node.$getValue(0);
                            $filterImpl_filterImpl_newOriginalHashCodes[$filterImpl_filterImpl_newDataIndex] = $filterImpl_filterImpl_node.$getHash(0);
                            $filterImpl_filterImpl_newDataIndex = $filterImpl_filterImpl_newDataIndex + 1 | 0;
                            $filterImpl_filterImpl_oldNodeIndex = $filterImpl_filterImpl_oldNodeIndex + 1 | 0;
                        } else if ($filterImpl_filterImpl_bitpos & $filterImpl_filterImpl_mapOfNewNodes) {
                            $filterImpl_filterImpl_newContent[($filterImpl_filterImpl_newContentSize - $filterImpl_filterImpl_newNodeIndex | 0) - 1 | 0] = scm_Queue_dequeue($filterImpl_filterImpl_newNodes);
                            $filterImpl_filterImpl_newNodeIndex = $filterImpl_filterImpl_newNodeIndex + 1 | 0;
                            $filterImpl_filterImpl_oldNodeIndex = $filterImpl_filterImpl_oldNodeIndex + 1 | 0;
                        } else if ($filterImpl_filterImpl_bitpos & sci_BitmapIndexedMapNode_dataMap($filterImpl_newRootNode))
                            $filterImpl_filterImpl_oldDataIndex = $filterImpl_filterImpl_oldDataIndex + 1 | 0;
                        else if ($filterImpl_filterImpl_bitpos & sci_BitmapIndexedMapNode_nodeMap($filterImpl_newRootNode))
                            $filterImpl_filterImpl_oldNodeIndex = $filterImpl_filterImpl_oldNodeIndex + 1 | 0;
                        $filterImpl_filterImpl_minimumIndex = $filterImpl_filterImpl_minimumIndex + 1 | 0;
                    }
                    $filterImpl_newRootNode = sci_BitmapIndexedMapNode__init_($filterImpl_filterImpl_newDataMap, $filterImpl_filterImpl_newNodeMap, $filterImpl_filterImpl_newContent_0, $filterImpl_filterImpl_newOriginalHashes, $filterImpl_filterImpl_newSize, $filterImpl_filterImpl_newCachedHashCode);
                }
            }
        }
        if ($filterImpl_newRootNode !== sci_HashMap_rootNode($filter_this)) {
            if (sci_BitmapIndexedMapNode_size($filterImpl_newRootNode))
                $filter_this = sci_HashMap__init_0($filterImpl_newRootNode);
            else {
                sci_HashMap$_$callClinit();
                $filter_this = sci_HashMap$_empty(sci_HashMap$_MODULE$);
            }
        }
        return $java.sci_HashMap$HashKeySet_newKeySetOrThis($this, $filter_this);
    };
    $java.sci_HashMap$HashKeySet_scala$collection$immutable$HashMap$HashKeySet$$$outer = function($this) {
        return $this.$$outer46;
    };
    $java.sci_HashMap$HashKeySet_filter0 = function($this, $pred) {
        return $java.sci_HashMap$HashKeySet_filter($this, $pred);
    };
    $java.onciu_NonEmptyList$IterableConverter = function() {
        jl_Object.call(this);
        this.$iterable = null;
    };
    $java.oncia_ProcedureResultItem$_init_$lambda$_72_0 = $rt_classWithoutFields();
    $java.oncia_ProcedureResultItem$_init_$lambda$_72_0_apply = function(var$0, var$1) {
        return var$1.$name57;
    };
    $java.oncia_ProcedureResultItem$_init_$lambda$_72_1 = function() {
        jl_Object.call(this);
        this.$_0446 = null;
    };
    $java.oncia_ProcedureResultItem$_init_$lambda$_72_1_apply = function(var$0) {
        return var$0.$_0446.$variable41.$name4;
    };
    $java.oncief_Function$$lookup$lzycompute$lambda$_2_0 = $rt_classWithoutFields();
    $java.oncief_Function$$lookup$lzycompute$lambda$_2_0__init_ = function() {
        var var_0 = new $java.oncief_Function$$lookup$lzycompute$lambda$_2_0();
        $java.oncief_Function$$lookup$lzycompute$lambda$_2_0__init_0(var_0);
        return var_0;
    };
    $java.oncief_Function$$lookup$lzycompute$lambda$_2_0__init_0 = function(var$0) {};
    $java.oncief_Function$$lookup$lzycompute$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        $java.oncief_Function$_$callClinit();
        var$2 = new s_Tuple2;
        var$3 = var$1.$name3();
        $java.ju_Locale_$callClinit();
        s_Tuple2__init_0(var$2, jl_String_toLowerCase(var$3), var$1);
        return var$2;
    };
    function oncie_MapProjection() {
        var a = this; oncie_Expression.call(a);
        a.$name19 = null;
        a.$items6 = null;
        a.$position213 = null;
    }
    function oncie_MapProjection__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_MapProjection();
        $java.oncie_MapProjection__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncie_MapProjection_name($this) {
        return $this.$name19;
    }
    function oncie_MapProjection_items($this) {
        return $this.$items6;
    }
    $java.oncie_MapProjection_position = function($this) {
        return $this.$position213;
    };
    $java.oncie_MapProjection_productPrefix = function($this) {
        return $rt_s(2675);
    };
    $java.oncie_MapProjection_productArity = function($this) {
        return 2;
    };
    $java.oncie_MapProjection_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name19;
            case 1:
                return $this.$items6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_MapProjection_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MapProjection_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MapProjection_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MapProjection_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_MapProjection) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$name19;
                        var$3 = $x$1.$name19;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$items6;
                        $x$1 = $x$1.$items6;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_MapProjection))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_MapProjection__init_ = function($this, $name, $items, $position) {
        $this.$name19 = $name;
        $this.$items6 = $items;
        $this.$position213 = $position;
        $java.oncie_Expression__init_($this);
    };
    var oncia_UnaliasedReturnItem$_init_$lambda$_31_0 = $rt_classWithoutFields();
    $java.oncia_UnaliasedReturnItem$_init_$lambda$_31_0_apply = function(var$0, var$1) {
        return var$1.$name4;
    };
    function oncia_UnaliasedReturnItem$_init_$lambda$_31_1() {
        jl_Object.call(this);
        this.$_0166 = null;
    }
    $java.oncia_UnaliasedReturnItem$_init_$lambda$_31_1_apply = function(var$0) {
        return jl_String_trim(var$0.$_0166.$inputText);
    };
    $java.oncia_UsingIndexHintType = $rt_classWithoutFields(0);
    var oncia_UsingAnyIndexType$ = $rt_classWithoutFields();
    var oncia_UsingAnyIndexType$_MODULE$ = null;
    function oncia_UsingAnyIndexType$__clinit_() {
        oncia_UsingAnyIndexType$_MODULE$ = new oncia_UsingAnyIndexType$;
    }
    $java.oncia_UsingAnyIndexType$_productArity = function($this) {
        return 0;
    };
    $java.oncia_UsingAnyIndexType$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UsingAnyIndexType$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingAnyIndexType$_hashCode = function($this) {
        return (-1470690012);
    };
    $java.oncia_UsingAnyIndexType$_toString = function($this) {
        return $rt_s(2676);
    };
    var oncia_UsingTextIndexType$ = $rt_classWithoutFields();
    var oncia_UsingTextIndexType$_MODULE$ = null;
    function oncia_UsingTextIndexType$__clinit_() {
        oncia_UsingTextIndexType$_MODULE$ = new oncia_UsingTextIndexType$;
    }
    $java.oncia_UsingTextIndexType$_productArity = function($this) {
        return 0;
    };
    $java.oncia_UsingTextIndexType$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UsingTextIndexType$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingTextIndexType$_hashCode = function($this) {
        return (-1846110597);
    };
    $java.oncia_UsingTextIndexType$_toString = function($this) {
        return $rt_s(2677);
    };
    var oncia_UsingRangeIndexType$ = $rt_classWithoutFields();
    var oncia_UsingRangeIndexType$_MODULE$ = null;
    function oncia_UsingRangeIndexType$__clinit_() {
        oncia_UsingRangeIndexType$_MODULE$ = new oncia_UsingRangeIndexType$;
    }
    $java.oncia_UsingRangeIndexType$_productArity = function($this) {
        return 0;
    };
    $java.oncia_UsingRangeIndexType$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UsingRangeIndexType$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingRangeIndexType$_hashCode = function($this) {
        return 1477404659;
    };
    $java.oncia_UsingRangeIndexType$_toString = function($this) {
        return $rt_s(2678);
    };
    var oncia_UsingPointIndexType$ = $rt_classWithoutFields();
    var oncia_UsingPointIndexType$_MODULE$ = null;
    function oncia_UsingPointIndexType$__clinit_() {
        oncia_UsingPointIndexType$_MODULE$ = new oncia_UsingPointIndexType$;
    }
    $java.oncia_UsingPointIndexType$_productArity = function($this) {
        return 0;
    };
    $java.oncia_UsingPointIndexType$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UsingPointIndexType$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UsingPointIndexType$_hashCode = function($this) {
        return (-611026688);
    };
    $java.oncia_UsingPointIndexType$_toString = function($this) {
        return $rt_s(2679);
    };
    var oncias_SemanticCheckInterpreter$ = $rt_classWithoutFields();
    var oncias_SemanticCheckInterpreter$_MODULE$ = null;
    function oncias_SemanticCheckInterpreter$__clinit_() {
        oncias_SemanticCheckInterpreter$_MODULE$ = new oncias_SemanticCheckInterpreter$;
    }
    function oncias_SemanticCheckInterpreter$_run($this, $result, $checkStack, $context, $debugAnnotations) {
        var var$5, $f, $func, $checkStack_0, $check, $checkStack_1, $annotation, $checkStackTail, var$13;
        a: {
            while (true) {
                var$5 = 0;
                $f = null;
                if (sci_List_equals(sci_Nil$_MODULE$, $checkStack))
                    break;
                if ($checkStack instanceof sci_$colon$colon) {
                    var$5 = 1;
                    $f = $checkStack;
                    $func = $f.$head0;
                    $checkStack_0 = $f.$next0;
                    if ($func instanceof $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper) {
                        $check = $func.$check4;
                        if ($check instanceof $java.oncias_SemanticCheck$Leaf) {
                            $result = $check.$f9.$apply($result.$state);
                            $checkStack = $checkStack_0;
                            continue;
                        }
                        if ($check instanceof oncias_SemanticCheck$Map) {
                            $checkStack = $check;
                            $check = $checkStack.$check0;
                            $func = $checkStack.$f5;
                            $checkStack = oncias_SemanticCheckInterpreter$ExecutableCheck$_apply(oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$, $check);
                            $checkStack_1 = new $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map;
                            $checkStack_1.$f12 = $func;
                            $checkStack = sci_List_$colon$colon(sci_List_$colon$colon($checkStack_0, $checkStack_1), $checkStack);
                            continue;
                        }
                        if ($check instanceof oncias_SemanticCheck$FlatMap) {
                            $checkStack = $check;
                            $check = $checkStack.$check1;
                            $func = $checkStack.$f6;
                            $checkStack = oncias_SemanticCheckInterpreter$ExecutableCheck$_apply(oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$, $check);
                            $checkStack_1 = new $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap;
                            $checkStack_1.$f13 = $func;
                            $checkStack = sci_List_$colon$colon(sci_List_$colon$colon($checkStack_0, $checkStack_1), $checkStack);
                            continue;
                        }
                        if ($check instanceof $java.oncias_SemanticCheck$CheckFromContext) {
                            $f = $check.$f11;
                            $checkStack = sci_List_$colon$colon($checkStack_0, oncias_SemanticCheckInterpreter$ExecutableCheck$_apply(oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$, $java.oncias_SemanticCheck$$fromFunctionWithContext$lambda$_10_0_apply($f, $context)));
                            continue;
                        }
                        if (!($check instanceof $java.oncias_SemanticCheck$Annotated))
                            $rt_throw(s_MatchError__init_($check));
                        $checkStack = $check;
                        $check = $java.oncias_SemanticCheck$Annotated_check($checkStack);
                        $annotation = $java.oncias_SemanticCheck$Annotated_annotation($checkStack);
                        $checkStack = $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_MODULE$;
                        $func = oncias_SemanticCheckInterpreter$ExecutableCheck$_apply(oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$, $check);
                        $checkStack_1 = $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_MODULE$;
                        $checkStack = sci_List_$colon$colon(sci_List_$colon$colon(sci_List_$colon$colon(sci_List_$colon$colon($checkStack_0, $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_MODULE$), $checkStack_1), $func), $checkStack);
                        $debugAnnotations = $debugAnnotations.$appended($annotation);
                        continue;
                    }
                }
                if (var$5) {
                    $func = $f.$head0;
                    $checkStack_1 = $f.$next0;
                    if ($func instanceof $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map) {
                        $result = $func.$f12.$apply($result);
                        $checkStack = $checkStack_1;
                        continue;
                    }
                }
                if (var$5) {
                    $func = $f.$head0;
                    $checkStackTail = $f.$next0;
                    if ($func instanceof $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap) {
                        $func = $func.$f13;
                        $checkStack = sci_List_$colon$colon($checkStackTail, oncias_SemanticCheckInterpreter$ExecutableCheck$_apply(oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$, $func.$apply($result)));
                        continue;
                    }
                }
                if (var$5) {
                    $func = $f.$head0;
                    $checkStack_0 = $f.$next0;
                    if (jl_Object_equals($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_MODULE$, $func)) {
                        $debugAnnotations = $debugAnnotations.$init0();
                        $checkStack = $checkStack_0;
                        continue;
                    }
                }
                if (!var$5)
                    break a;
                $func = $f.$head0;
                $checkStack_1 = $f.$next0;
                if (!jl_Object_equals($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_MODULE$, $func))
                    break a;
                s_Predef$_$callClinit();
                s_Predef$_println(s_Predef$_MODULE$, $rt_s(2680));
                sc_IterableOnceOps_foreach$((sc_StrictOptimizedIterableOps_zipWithIndex$($debugAnnotations)).$reverseIterator(), new $java.oncias_SemanticCheckInterpreter$$printAnnotations$lambda$_4_0);
                s_Console$_$callClinit();
                $checkStack = s_Console$_out(s_Console$_MODULE$);
                var$13 = $checkStack.$buffer0;
                var$13.data[0] = 10;
                ji_PrintStream_print($checkStack, var$13, 0, 1);
                $checkStack = $checkStack_1;
            }
            return $result;
        }
        $rt_throw(s_MatchError__init_($checkStack));
    }
    function sc_Iterator$$anon$6() {
        var a = this; sc_AbstractIterator.call(a);
        a.$hd1 = null;
        a.$hdDefined = 0;
        a.$$outer7 = null;
        a.$p$1 = null;
        a.$isFlipped$1 = 0;
    }
    $java.sc_Iterator$$anon$6_hasNext = function($this) {
        a: {
            if (!$this.$hdDefined) {
                if (!$this.$$outer7.$hasNext())
                    return 0;
                $this.$hd1 = $this.$$outer7.$next();
                while (true) {
                    if (sr_BoxesRunTime_unboxToBoolean($this.$p$1.$apply($this.$hd1)) != $this.$isFlipped$1) {
                        $this.$hdDefined = 1;
                        break a;
                    }
                    if (!$this.$$outer7.$hasNext())
                        break;
                    $this.$hd1 = $this.$$outer7.$next();
                }
                return 0;
            }
        }
        return 1;
    };
    $java.sc_Iterator$$anon$6_next = function($this) {
        if (!$java.sc_Iterator$$anon$6_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $this.$hdDefined = 0;
        return $this.$hd1;
    };
    function sc_IterableOnceOps$Maximized() {
        var a = this; $java.sr_AbstractFunction2.call(a);
        a.$descriptor = null;
        a.$f0 = null;
        a.$cmp = null;
        a.$maxElem = null;
        a.$maxF = null;
        a.$nonEmpty = 0;
        a.$$outer = null;
    }
    function sc_IterableOnceOps$minBy$lambda$_89_0() {
        jl_Object.call(this);
        this.$_010 = null;
    }
    var sc_IterableOnceOps$minBy$lambda$_89_1 = $rt_classWithoutFields();
    $java.sc_IterableOnceOps$minBy$lambda$_89_1_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5;
        var$1 = var$1;
        if (!var$1.$nonEmpty) {
            var$1.$nonEmpty = 1;
            var$1.$maxElem = var$2;
            var$1.$maxF = var$1.$f0.$apply(var$2);
        } else {
            var$3 = var$1.$f0.$apply(var$2);
            var$4 = var$1.$cmp;
            var$5 = var$1.$maxF;
            if (sr_BoxesRunTime_unboxToBoolean(jl_Boolean_valueOf(var$4.$_010.$lt(var$3, var$5)))) {
                var$1.$maxF = var$3;
                var$1.$maxElem = var$2;
            }
        }
        return var$1;
    };
    $java.scc_JavaCollectionWrappers$JMapWrapperLike$$anon$5 = function() {
        sc_AbstractIterator.call(this);
        this.$ui = null;
    };
    $java.scc_JavaCollectionWrappers$JMapWrapperLike$$anon$5_hasNext = function($this) {
        return ju_LinkedHashMap$AbstractMapIterator_hasNext($this.$ui);
    };
    $java.scc_JavaCollectionWrappers$JMapWrapperLike$$anon$5_next = function($this) {
        var var$1;
        var$1 = ju_LinkedHashMap$EntryIterator_next($this.$ui);
        return s_Tuple2__init_(var$1.$key0, var$1.$value12);
    };
    function oncia_AdministrationCommand$semanticCheck$lambda$_11_0() {
        jl_Object.call(this);
        this.$_0293 = null;
    }
    $java.oncia_AdministrationCommand$semanticCheck$lambda$_11_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0293;
        return var$1.$error2($rt_s(2681), var$1.$position2());
    };
    $java.s_DummyImplicit = $rt_classWithoutFields();
    var oncia_ReturnItems$ReturnVariables$ = $rt_classWithoutFields();
    var oncia_ReturnItems$ReturnVariables$_MODULE$ = null;
    function oncia_ReturnItems$ReturnVariables$__clinit_() {
        oncia_ReturnItems$ReturnVariables$_MODULE$ = new oncia_ReturnItems$ReturnVariables$;
    }
    function oncia_ReturnItems$ReturnVariables$_empty($this) {
        var var$1;
        var$1 = new $java.oncia_ReturnItems$ReturnVariables;
        s_package$_$callClinit();
        $java.oncia_ReturnItems$ReturnVariables__init_0(var$1, 0, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
        return var$1;
    }
    $java.sc_ArrayOps$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.juf_Predicate = $rt_classWithoutFields(0);
    var onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_0 = $rt_classWithoutFields();
    var onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_1 = $rt_classWithoutFields();
    $java.onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_1_apply = function(var$0, var$1) {
        return var$1.$name5;
    };
    $java.jus_Collectors = $rt_classWithoutFields();
    $java.oncia_Union$$anonfun$semanticCheck$2$lambda$_31_0 = function() {
        jl_Object.call(this);
        this.$_0403 = null;
    };
    $java.oncia_Union$$anonfun$semanticCheck$2$lambda$_31_0_apply = function(var$0) {
        return var$0.$_0403.$semanticCheck();
    };
    $java.oncia_SingleQuery$$anonfun$checkClauses$1$lambda$_140_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0432 = null;
        a.$_1129 = null;
        a.$_251 = null;
        a.$_310 = 0;
        a.$_40 = 0;
    };
    $java.oncia_SingleQuery$$anonfun$checkClauses$1$lambda$_140_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_1129;
        var$2 = var$0.$_251;
        var$3 = var$0.$_310;
        var$4 = var$0.$_40;
        if (!$rt_isInstance(var$1, oncia_HorizonClause)) {
            var$2 = var$1.$semanticCheck();
            var$5 = new $java.oncia_SingleQuery$$anonfun$checkClauses$2$lambda$_139_0;
            var$5.$_0447 = var$1;
            var$5.$_1134 = var$3;
            var$5.$_252 = var$4;
            var$1 = oncias_SemanticCheck_map$(var$2, var$5);
        } else {
            var$1 = var$1;
            var$5 = var$1.$semanticCheck();
            var$6 = new $java.oncia_SingleQuery$checkHorizon$lambda$_74_0;
            var$6.$_0448 = var$1;
            var$6.$_1135 = var$2;
            var$1 = oncias_SemanticCheck_flatMap$(var$5, var$6);
        }
        return var$1;
    };
    $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$3$lambda$_498_0 = function() {
        jl_Object.call(this);
        this.$_0440 = null;
    };
    $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$3$lambda$_498_0_apply = function(var$0) {
        return var$0.$_0440;
    };
    $java.oncia_CommandResultItem = function() {
        var a = this; jl_Object.call(a);
        a.$originalName = null;
        a.$aliasedVariable = null;
        a.$position214 = null;
    };
    $java.oncia_CommandResultItem__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.oncia_CommandResultItem();
        $java.oncia_CommandResultItem__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncia_CommandResultItem_position = function($this) {
        return $this.$position214;
    };
    $java.oncia_CommandResultItem_productPrefix = function($this) {
        return $rt_s(2682);
    };
    $java.oncia_CommandResultItem_productArity = function($this) {
        return 2;
    };
    $java.oncia_CommandResultItem_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$originalName;
            case 1:
                return $this.$aliasedVariable;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CommandResultItem_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CommandResultItem_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CommandResultItem_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CommandResultItem_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_CommandResultItem) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$originalName;
                        var$3 = $x$1.$originalName;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$aliasedVariable;
                        $x$1 = $x$1.$aliasedVariable;
                        if (var$3 !== null) {
                            if (!$java.oncie_Variable_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_CommandResultItem))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_CommandResultItem_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_CommandResultItem__init_0 = function($this, $originalName, $aliasedVariable, $position) {
        $this.$originalName = $originalName;
        $this.$aliasedVariable = $aliasedVariable;
        $this.$position214 = $position;
    };
    $java.oncia_Access = $rt_classWithoutFields(0);
    var oncia_ReadOnlyAccess$ = $rt_classWithoutFields();
    $java.oncia_ReadOnlyAccess$_MODULE$ = null;
    function oncia_ReadOnlyAccess$__clinit_() {
        $java.oncia_ReadOnlyAccess$_MODULE$ = new oncia_ReadOnlyAccess$;
    }
    $java.oncia_ReadOnlyAccess$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ReadOnlyAccess$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ReadOnlyAccess$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ReadOnlyAccess$_hashCode = function($this) {
        return (-422523258);
    };
    $java.oncia_ReadOnlyAccess$_toString = function($this) {
        return $rt_s(2683);
    };
    var oncia_ReadWriteAccess$ = $rt_classWithoutFields();
    $java.oncia_ReadWriteAccess$_MODULE$ = null;
    function oncia_ReadWriteAccess$__clinit_() {
        $java.oncia_ReadWriteAccess$_MODULE$ = new oncia_ReadWriteAccess$;
    }
    $java.oncia_ReadWriteAccess$_productArity = function($this) {
        return 0;
    };
    $java.oncia_ReadWriteAccess$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ReadWriteAccess$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ReadWriteAccess$_hashCode = function($this) {
        return (-574905715);
    };
    $java.oncia_ReadWriteAccess$_toString = function($this) {
        return $rt_s(2684);
    };
    $java.oncia_ASTSlicingPhrase = $rt_classWithoutFields(0);
    $java.oncia_ASTSlicingPhrase_semanticCheck$ = function($$this) {
        return $java.oncia_ASTSlicingPhrase$_checkExpressionIsStaticInt($java.oncia_ASTSlicingPhrase$_MODULE$, $$this.$expression1(), $$this.$name3(), 1);
    };
    $java.oncia_Skip = function() {
        var a = this; jl_Object.call(a);
        a.$expression5 = null;
        a.$position215 = null;
    };
    $java.oncia_Skip__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_Skip();
        $java.oncia_Skip__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_Skip_semanticCheck = function($this) {
        return $java.oncia_ASTSlicingPhrase_semanticCheck$($this);
    };
    $java.oncia_Skip_expression = function($this) {
        return $this.$expression5;
    };
    $java.oncia_Skip_position = function($this) {
        return $this.$position215;
    };
    $java.oncia_Skip_name = function($this) {
        return $rt_s(2685);
    };
    $java.oncia_Skip_productPrefix = function($this) {
        return $rt_s(2686);
    };
    $java.oncia_Skip_productArity = function($this) {
        return 1;
    };
    $java.oncia_Skip_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Skip_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Skip_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Skip_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Skip_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_Skip) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression5;
                        $x$1 = $x$1.$expression5;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_Skip))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_Skip_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Skip__init_0 = function($this, $expression, $position) {
        $this.$expression5 = $expression;
        $this.$position215 = $position;
    };
    $java.oncia_Limit = function() {
        var a = this; jl_Object.call(a);
        a.$expression6 = null;
        a.$position216 = null;
    };
    $java.oncia_Limit__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_Limit();
        $java.oncia_Limit__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_Limit_semanticCheck = function($this) {
        return $java.oncia_ASTSlicingPhrase_semanticCheck$($this);
    };
    $java.oncia_Limit_expression = function($this) {
        return $this.$expression6;
    };
    $java.oncia_Limit_position = function($this) {
        return $this.$position216;
    };
    $java.oncia_Limit_name = function($this) {
        return $rt_s(2687);
    };
    $java.oncia_Limit_productPrefix = function($this) {
        return $rt_s(2688);
    };
    $java.oncia_Limit_productArity = function($this) {
        return 1;
    };
    $java.oncia_Limit_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Limit_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Limit_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Limit_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Limit_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_Limit) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression6;
                        $x$1 = $x$1.$expression6;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_Limit))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_Limit_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_Limit__init_0 = function($this, $expression, $position) {
        $this.$expression6 = $expression;
        $this.$position216 = $position;
    };
    $java.oncia_UnmappedUnion$containTheSameInstances$1$lambda$_14_0 = function() {
        jl_Object.call(this);
        this.$_0348 = null;
    };
    $java.oncia_UnmappedUnion$containTheSameInstances$1$lambda$_14_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$2 = var$0.$_0348;
        var$3 = new $java.oncia_UnmappedUnion$$anonfun$dup$1$lambda$_13_0;
        var$3.$_0449 = var$1;
        return jl_Boolean_valueOf(sci_List_exists(var$2, var$3));
    };
    function jusi_ArrayStreamImpl() {
        var a = this; jusi_SimpleStreamImpl.call(a);
        a.$array3 = null;
        a.$index = 0;
        a.$end2 = 0;
        a.$size7 = 0;
    }
    $java.jusi_ArrayStreamImpl_next = function($this, $consumer) {
        var var$2, var$3;
        a: {
            while (true) {
                var$2 = $this.$index;
                if (var$2 >= $this.$end2)
                    break a;
                var$3 = $this.$array3.data;
                $this.$index = var$2 + 1 | 0;
                if ($consumer.$test(var$3[var$2]))
                    continue;
                else
                    break;
            }
        }
        return $this.$index >= $this.$end2 ? 0 : 1;
    };
    $java.jusi_ArrayStreamImpl_estimateSize = function($this) {
        return $this.$size7;
    };
    $java.juf_Supplier = $rt_classWithoutFields(0);
    var jus_Collectors$toList$lambda$_2_0 = $rt_classWithoutFields();
    $java.jus_Collectors$toList$lambda$_2_0_get = function(var$0) {
        return ju_ArrayList__init_();
    };
    function onciaf_ASTExceptionFactory$joiningLastDelimiter$lambda$_9_0() {
        var a = this; jl_Object.call(a);
        a.$_0238 = null;
        a.$_163 = null;
    }
    var ju_EnumSet = $rt_classWithoutFields(ju_AbstractSet);
    function ju_EnumSet__init_($this) {}
    function ju_EnumSet_noneOf($elementType) {
        var var$2;
        var$2 = new ju_GenericEnumSet;
        var$2.$cls = $elementType;
        var$2.$bits = $rt_createIntArray(((($java.ju_GenericEnumSet_getConstants($elementType)).data.length - 1 | 0) / 32 | 0) + 1 | 0);
        return var$2;
    }
    var jus_Collector$Characteristics = $rt_classWithoutFields(jl_Enum);
    $java.jus_Collector$Characteristics_CONCURRENT = null;
    $java.jus_Collector$Characteristics_UNORDERED = null;
    var jus_Collector$Characteristics_IDENTITY_FINISH = null;
    $java.jus_Collector$Characteristics_$VALUES = null;
    function jus_Collector$Characteristics_$callClinit() {
        jus_Collector$Characteristics_$callClinit = $rt_eraseClinit(jus_Collector$Characteristics);
        $java.jus_Collector$Characteristics__clinit_();
    }
    $java.jus_Collector$Characteristics__init_ = function(var_0, var_1) {
        var var_2 = new jus_Collector$Characteristics();
        $java.jus_Collector$Characteristics__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function jus_Collector$Characteristics_values() {
        jus_Collector$Characteristics_$callClinit();
        return $java.jus_Collector$Characteristics_$VALUES.$clone();
    }
    $java.jus_Collector$Characteristics__init_0 = function($this, var$1, var$2) {
        jus_Collector$Characteristics_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.jus_Collector$Characteristics__clinit_ = function() {
        var var$1;
        $java.jus_Collector$Characteristics_CONCURRENT = $java.jus_Collector$Characteristics__init_($rt_s(2689), 0);
        $java.jus_Collector$Characteristics_UNORDERED = $java.jus_Collector$Characteristics__init_($rt_s(2690), 1);
        var$1 = $java.jus_Collector$Characteristics__init_($rt_s(2691), 2);
        jus_Collector$Characteristics_IDENTITY_FINISH = var$1;
        $java.jus_Collector$Characteristics_$VALUES = $rt_createArrayFromData(jus_Collector$Characteristics, [$java.jus_Collector$Characteristics_CONCURRENT, $java.jus_Collector$Characteristics_UNORDERED, var$1]);
    };
    var jus_Collector = $rt_classWithoutFields(0);
    function jus_Collector_of($supplier, $accumulator, $combiner, $finisher, $characteristics) {
        var $characteristicsSet, var$7, var$8, var$9, var$10, var$11;
        a: {
            $characteristicsSet = ju_EnumSet_noneOf($rt_cls(jus_Collector$Characteristics));
            $java.ju_Objects_requireNonNull($characteristics);
            var$7 = new $java.ju_Arrays$ArrayAsList;
            var$7.$array6 = $characteristics;
            if (var$7 instanceof ju_GenericEnumSet) {
                var$8 = var$7;
                if ($characteristicsSet.$cls === var$8.$cls) {
                    var$9 = 0;
                    while (true) {
                        $characteristics = $characteristicsSet.$bits.data;
                        if (var$9 >= $characteristics.length)
                            break;
                        var$10 = $characteristics[var$9];
                        var$11 = var$8.$bits.data;
                        if ((var$10 | var$11[var$9]) != $characteristics[var$9])
                            $characteristics[var$9] = $characteristics[var$9] | var$11[var$9];
                        var$9 = var$9 + 1 | 0;
                    }
                    break a;
                }
            }
            ju_AbstractCollection_addAll($characteristicsSet, var$7);
        }
        return jus_CollectorImpl__init_($supplier, $accumulator, $combiner, $finisher, $characteristicsSet);
    }
    function jus_CollectorImpl() {
        var a = this; jl_Object.call(a);
        a.$supplier = null;
        a.$accumulator0 = null;
        a.$combiner = null;
        a.$finisher = null;
        a.$characteristics = null;
    }
    function jus_CollectorImpl__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new jus_CollectorImpl();
        $java.jus_CollectorImpl__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.jus_CollectorImpl__init_ = function($this, $supplier, $accumulator, $combiner, $finisher, $characteristics) {
        $this.$supplier = $supplier;
        $this.$accumulator0 = $accumulator;
        $this.$combiner = $combiner;
        $this.$finisher = $finisher;
        $this.$characteristics = $characteristics;
    };
    $java.juf_BiConsumer = $rt_classWithoutFields(0);
    var jus_Collectors$toCollection$lambda$_1_0 = $rt_classWithoutFields();
    $java.jus_Collectors$toCollection$lambda$_1_0_accept = function(var$0, var$1, var$2) {
        ju_ArrayList_add(var$1, var$2);
    };
    $java.juf_BiFunction = $rt_classWithoutFields(0);
    $java.juf_BinaryOperator = $rt_classWithoutFields(0);
    var jus_Collectors$toCollection$lambda$_1_1 = $rt_classWithoutFields();
    var jus_Collector$of$lambda$_5_0 = $rt_classWithoutFields();
    $java.jus_Collector$of$lambda$_5_0_apply = function(var$0, var$1) {
        return var$1;
    };
    function ju_GenericEnumSet() {
        var a = this; ju_EnumSet.call(a);
        a.$cls = null;
        a.$bits = null;
    }
    $java.ju_GenericEnumSet_getConstants = function($cls) {
        var $platformClass;
        $platformClass = $cls.$platformClass;
        $platformClass.$clinit();
        return otp_Platform_getEnumConstants($platformClass);
    };
    function ju_GenericEnumSet_size($this) {
        var $result, var$2, var$3, var$4;
        $result = 0;
        var$2 = $this.$bits.data;
        var$3 = var$2.length;
        var$4 = 0;
        while (var$4 < var$3) {
            $result = $result + jl_Integer_bitCount(var$2[var$4]) | 0;
            var$4 = var$4 + 1 | 0;
        }
        return $result;
    }
    function ju_GenericEnumSet_add($this, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$1.$ordinal;
        var$3 = var$2 / 32 | 0;
        var$4 = 1 << (var$2 % 32 | 0);
        var$5 = $this.$bits.data;
        if (var$5[var$3] & var$4)
            var$4 = 0;
        else {
            var$5[var$3] = var$5[var$3] | var$4;
            var$4 = 1;
        }
        return var$4;
    }
    $java.ju_Arrays$ArrayAsList = function() {
        ju_AbstractList.call(this);
        this.$array6 = null;
    };
    $java.ju_Arrays$ArrayAsList_get = function($this, $index) {
        return $this.$array6.data[$index];
    };
    $java.ju_Arrays$ArrayAsList_size = function($this) {
        return $this.$array6.data.length;
    };
    $java.onciu_RewritableCompat$PROXY$7_0 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_0_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_0 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_0_paramsLength(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_1 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_1_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_1 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_1_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_2 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_2_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_2 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_2_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_3 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_3_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_3 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_3_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_4 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_4_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_4 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_4_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_5 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_5_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_5 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_5_paramsLength(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_6 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_6_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_6 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_6_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_7 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_7_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_7 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_7_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_8 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_8_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_8 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_8_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_9 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_9_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_9 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_9_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_10 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_10_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_10 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_10_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_11 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_11_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_11 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_11_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_12 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_12_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_12 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_12_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_13 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_13_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_13 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_13_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_14 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_14_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_14 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_14_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_15 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_15_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_15 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_15_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_16 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_16_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_16 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_16_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_17 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_17_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_17 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_17_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_18 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_18_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_18 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_18_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_19 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_19_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_19 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_19_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_20 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_20_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_20 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_20_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_21 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_21_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_21 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_21_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_22 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_22_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_22 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_22_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_23 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_23_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_23 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_23_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_24 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_24_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_24 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_24_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_25 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_25_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_25 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_25_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_26 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_26_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_26 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_26_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_27 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_27_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_27 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_27_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_28 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_28_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_28 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_28_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_29 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_29_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_29 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_29_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_30 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_30_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_30 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_30_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_31 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_31_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_31 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_31_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_32 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_32_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_32 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_32_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_33 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_33_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_33 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_33_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_34 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_34_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_34 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_34_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_35 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_35_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_35 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_35_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_353 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_353_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_StartDatabase__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_355 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_355_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ShowTransactionsClause_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5].$value8, var$3[6]);
    }
    var onciu_RewritableCompat$PROXY$3_357 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_357_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_GrantPrivilege__init_(var$3[0], var$3[1].$value8, var$3[2], var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_358 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_358_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SubqueryCall$InTransactionsParameters__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_359 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_359_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateRelationshipPropertyUniquenessConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8], var$3[9]);
    }
    var onciu_RewritableCompat$PROXY$3_361 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_361_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_MatchMode$DifferentRelationships__init_(var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_362 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_362_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SubqueryCall$InTransactionsErrorParameters__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_363 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_363_copyConstructor(var$1, var$2, var$3) {
        return oncie_MatchMode$RepeatableElements__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_364 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_364_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ProcedureResultItem__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_365 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_365_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_SignedDecimalIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_366 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_366_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateNodePropertyTypeConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7].$value8, var$3[8], var$3[9], var$3[10]);
    }
    var onciu_RewritableCompat$PROXY$3_367 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_367_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Pattern$ForMatch__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_369 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_369_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DenyPrivilege__init_(var$3[0], var$3[1].$value8, var$3[2], var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_371 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_371_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_Pattern$ForUpdate__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_372 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_372_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateRelationshipKeyConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8], var$3[9]);
    }
    var onciu_RewritableCompat$PROXY$3_373 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_373_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_TerminateTransactionsClause__init_(var$3[0], var$3[1], var$3[2], var$3[3].$value8, var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_374 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_374_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Namespace__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_375 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_375_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_Limit__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_377 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_377_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateRelationshipPropertyTypeConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7].$value8, var$3[8], var$3[9], var$3[10]);
    }
    var onciu_RewritableCompat$PROXY$3_378 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_378_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateNodePropertyExistenceConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8], var$3[9]);
    }
    var onciu_RewritableCompat$PROXY$3_379 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_379_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_StopDatabase__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_380 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_380_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ProcedureOutput__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_382 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_382_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ProcedureName__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_383 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_383_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SubqueryCall$InTransactionsBatchParameters__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_384 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_384_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateRelationshipPropertyExistenceConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8], var$3[9]);
    }
    var onciu_RewritableCompat$PROXY$3_386 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_386_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_RevokePrivilege__init_(var$3[0], var$3[1].$value8, var$3[2], var$3[3], var$3[4], var$3[5], var$3[6]);
    }
    var onciu_RewritableCompat$PROXY$3_388 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_388_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CommandResultItem__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_389 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_389_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_EnableServer__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_390 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_390_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateNodePropertyUniquenessConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8], var$3[9]);
    }
    var onciu_RewritableCompat$PROXY$3_391 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_391_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_NamespacedName__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_394 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_394_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateNodeKeyConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8], var$3[9]);
    }
    var onciu_RewritableCompat$PROXY$3_396 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_396_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_Skip__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_412 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_412_copyConstructor(var$1, var$2, var$3) {
        return oncie_PathPatternPart__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_413 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_413_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_UnaliasedReturnItem__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_416 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_416_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_UsingIndexHint__init_(var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_417 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_417_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_UsingJoinHint__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_418 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_418_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DescSortItem__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_419 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_419_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Not__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_420 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_420_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SubqueryCall$InTransactionsReportParameters__init_(var$3[0], var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_36 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_36_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_36 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_36_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_37 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_37_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_37 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_37_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_422 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_422_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_StringLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    $java.oncie_MatchMode = $rt_classWithoutFields();
    var onciu_RewritableCompat$PROXY$3_423 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_423_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_AscSortItem__init_(var$3[0], var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_38 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_38_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_38 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_38_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_39 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_39_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_39 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_39_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_40 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_40_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_40 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_40_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_41 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_41_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_41 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_41_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_42 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_42_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_42 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_42_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_43 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_43_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_43 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_43_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_44 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_44_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_44 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_44_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_45 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_45_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_45 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_45_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_46 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_46_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_46 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_46_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_47 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_47_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_47 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_47_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_48 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_48_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_48 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_48_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_49 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_49_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_49 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_49_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_50 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_50_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_50 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_50_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_51 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_51_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_51 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_51_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_434 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_434_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_PatternPart$ShortestGroups__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_435 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_435_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_PatternPart$AnyShortestPath__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_437 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_437_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_PatternPart$AnyPath__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_438 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_438_copyConstructor(var$1, var$2, var$3) {
        return oncie_PatternPart$AllPaths__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_439 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_439_copyConstructor(var$1, var$2, var$3) {
        return oncie_PatternPart$AllShortestPaths__init_(var$3.data[0]);
    }
    $java.sci_Map$Map3$Map3Iterator = function() {
        var a = this; sc_AbstractIterator.call(a);
        a.$i4 = 0;
        a.$$outer47 = null;
    };
    $java.sci_Map$Map3$Map3Iterator_hasNext = function($this) {
        if ($this.$i4 >= 3)
            return 0;
        return 1;
    };
    $java.sci_Map$Map3$Map3Iterator_next = function($this) {
        var var$1, $result;
        a: {
            switch ($this.$i4) {
                case 0:
                    var$1 = $this.$$outer47;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map3$$key1, var$1.$scala$collection$immutable$Map$Map3$$value1);
                    break a;
                case 1:
                    var$1 = $this.$$outer47;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map3$$key2, var$1.$scala$collection$immutable$Map$Map3$$value2);
                    break a;
                case 2:
                    var$1 = $this.$$outer47;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map3$$key3, var$1.$scala$collection$immutable$Map$Map3$$value3);
                    break a;
                default:
            }
            $result = sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        }
        $this.$i4 = $this.$i4 + 1 | 0;
        return $result;
    };
    $java.sci_Map$Map3$Map3Iterator_scala$collection$immutable$Map$Map3$Map3Iterator$$$outer = function($this) {
        return $this.$$outer47;
    };
    $java.sci_Map$Map3$Map3Iterator__init_ = function($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer47 = $$outer;
        $this.$i4 = 0;
    };
    $java.sci_Map$Map3$$anon$4 = $rt_classWithoutFields($java.sci_Map$Map3$Map3Iterator);
    $java.sci_Map$Map3$$anon$4_nextResult = function($this, $k, $v) {
        return s_Tuple2__init_($k, $v);
    };
    $java.sci_Map$Map3$$anon$6 = $rt_classWithoutFields($java.sci_Map$Map3$Map3Iterator);
    $java.sci_Map$Map3$$anon$6_nextResult = function($this, $k, $v) {
        return $v;
    };
    $java.oncie_Expression$$anonfun$containsAggregate$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncie_Expression$$anonfun$containsAggregate$1_applyOrElse = function($this, $x1, $default) {
        if ($x1 !== null && !s_Option_isEmpty($java.oncie_IsAggregate$_unapply($java.oncie_IsAggregate$_MODULE$, $x1)))
            return jl_Boolean_valueOf(1);
        return s_PartialFunction$_fallback_fn;
    };
    $java.oncia_AliasDriverSettingsCheck$$findInvalidDriverSettings$lambda$_5_0 = $rt_classWithoutFields();
    $java.oncia_AliasDriverSettingsCheck$$findInvalidDriverSettings$lambda$_5_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = onciu_Foldable_folder$(var$1);
        var$1 = new $java.oncia_AliasDriverSettingsCheck$$anonfun$$nestedInanonfun$findInvalidDriverSettings$1$1;
        sr_ClassTag$_$callClinit();
        return onciu_Foldable$Folder_treeFind(var$2, var$1, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_Expression)));
    };
    function jusi_FilteringStreamImpl() {
        jusi_WrappingStreamImpl.call(this);
        this.$filter3 = null;
    }
    $java.jusi_FilteringStreamImpl_wrap = function($this, $consumer) {
        var var$2;
        var$2 = new $java.jusi_FilteringStreamImpl$wrap$lambda$_1_0;
        var$2.$_0450 = $this;
        var$2.$_1136 = $consumer;
        return var$2;
    };
    var oncias_SemanticCheckResult$ = $rt_classWithoutFields();
    var oncias_SemanticCheckResult$_MODULE$ = null;
    function oncias_SemanticCheckResult$__clinit_() {
        oncias_SemanticCheckResult$_MODULE$ = new oncias_SemanticCheckResult$;
    }
    function oncias_SemanticCheckResult$_success($this, $s) {
        var var$2;
        var$2 = new oncias_SemanticCheckResult;
        s_package$_$callClinit();
        oncias_SemanticCheckResult__init_0(var$2, $s, sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$)));
        return var$2;
    }
    function oncias_SemanticCheckResult$_error($this, $state, $error) {
        var var$3, var$4, var$5, var$6;
        var$3 = new oncias_SemanticCheckResult;
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        var$5 = sr_ScalaRunTime$_MODULE$;
        var$6 = $rt_createArray(oncias_SemanticErrorDef, 1);
        var$6.data[0] = $error;
        oncias_SemanticCheckResult__init_0(var$3, $state, var$4.$from0(sr_ScalaRunTime$_wrapRefArray(var$5, var$6)));
        return var$3;
    }
    $java.oncias_SemanticCheckResult$_error0 = function($this, $state, $msg, $position) {
        return oncias_SemanticCheckResult$_error($this, $state, oncias_SemanticError__init_0($msg, $position));
    };
    $java.oncias_SemanticCheckResult$_error = function($this, $state, $error) {
        return oncias_SemanticCheckResult__init_($state, ($error.$iterator0()).$toSeq());
    };
    var oncias_SemanticCheckInterpreter$ExecutableCheck$ = $rt_classWithoutFields();
    var oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$ = null;
    function oncias_SemanticCheckInterpreter$ExecutableCheck$__clinit_() {
        oncias_SemanticCheckInterpreter$ExecutableCheck$_MODULE$ = new oncias_SemanticCheckInterpreter$ExecutableCheck$;
    }
    function oncias_SemanticCheckInterpreter$ExecutableCheck$_apply($this, $check) {
        var var$2;
        var$2 = new $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper;
        var$2.$check4 = $check;
        return var$2;
    }
    $java.oncia_UnassignableAction = $rt_classWithoutFields(0);
    $java.oncie_SignedDecimalIntegerLiteral$$anon$1 = $rt_classWithoutFields(oncie_SignedDecimalIntegerLiteral);
    $java.juf_IntFunction = $rt_classWithoutFields(0);
    $java.jusi_SimpleStreamImpl$toArray$lambda$_19_0 = $rt_classWithoutFields();
    var oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    function oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0__init_() {
        var var_0 = new oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0();
        $java.oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0__init_(var_0);
        return var_0;
    }
    $java.oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0__init_ = function(var$0) {};
    $java.oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        $java.onciu_AnonymousVariableNameGenerator$_$callClinit();
        return jl_Boolean_valueOf($java.onciu_AnonymousVariableNameGenerator$_isNamed($java.onciu_AnonymousVariableNameGenerator$_MODULE$, var$1.$name4) ? 0 : 1);
    };
    $java.oncil_BinaryLabelExpression = $rt_classWithoutFields(0);
    $java.oncil_BinaryLabelExpression_flatten$ = function($$this) {
        return (($$this.$lhs11()).$flatten0()).$concat0(($$this.$rhs12()).$flatten0());
    };
    function oncil_LabelExpression$ColonDisjunction() {
        var a = this; jl_Object.call(a);
        a.$lhs3 = null;
        a.$rhs3 = null;
        a.$containsIs = 0;
        a.$position217 = null;
    }
    function oncil_LabelExpression$ColonDisjunction__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncil_LabelExpression$ColonDisjunction();
        $java.oncil_LabelExpression$ColonDisjunction__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncil_LabelExpression$ColonDisjunction_flatten = function($this) {
        return $java.oncil_BinaryLabelExpression_flatten$($this);
    };
    $java.oncil_LabelExpression$ColonDisjunction_containsGpmSpecificLabelExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$($this);
    };
    $java.oncil_LabelExpression$ColonDisjunction_containsGpmSpecificRelTypeExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$($this);
    };
    $java.oncil_LabelExpression$ColonDisjunction_replaceColonSyntax = function($this) {
        return $java.oncil_LabelExpression_replaceColonSyntax$($this);
    };
    $java.oncil_LabelExpression$ColonDisjunction_foldedOver = function($this) {
        return $this;
    };
    $java.oncil_LabelExpression$ColonDisjunction_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncil_LabelExpression$ColonDisjunction_lhs = function($this) {
        return $this.$lhs3;
    };
    $java.oncil_LabelExpression$ColonDisjunction_rhs = function($this) {
        return $this.$rhs3;
    };
    $java.oncil_LabelExpression$ColonDisjunction_containsIs = function($this) {
        return $this.$containsIs;
    };
    function oncil_LabelExpression$ColonDisjunction_position($this) {
        return $this.$position217;
    }
    $java.oncil_LabelExpression$ColonDisjunction_productPrefix = function($this) {
        return $rt_s(2692);
    };
    $java.oncil_LabelExpression$ColonDisjunction_productArity = function($this) {
        return 3;
    };
    $java.oncil_LabelExpression$ColonDisjunction_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs3;
            case 1:
                return $this.$rhs3;
            case 2:
                return jl_Boolean_valueOf($this.$containsIs);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpression$ColonDisjunction_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$ColonDisjunction_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2692))), sr_Statics_anyHash($this.$lhs3)), sr_Statics_anyHash($this.$rhs3)), !$this.$containsIs ? 1237 : 1231), 3);
    };
    $java.oncil_LabelExpression$ColonDisjunction_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$ColonDisjunction_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncil_LabelExpression$ColonDisjunction) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsIs != $x$1.$containsIs)
                        break b;
                    c: {
                        var$2 = $this.$lhs3;
                        var$3 = $x$1.$lhs3;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs3;
                        $x$1 = $x$1.$rhs3;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncil_LabelExpression$ColonDisjunction))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncil_LabelExpression$ColonDisjunction_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncil_LabelExpression$ColonDisjunction__init_ = function($this, $lhs, $rhs, $containsIs, $position) {
        $this.$lhs3 = $lhs;
        $this.$rhs3 = $rhs;
        $this.$containsIs = $containsIs;
        $this.$position217 = $position;
    };
    function onciu_DeprecatedRelTypeSeparatorNotification() {
        var a = this; jl_Object.call(a);
        a.$position218 = null;
        a.$oldExpression = null;
        a.$rewrittenExpression = null;
    }
    $java.onciu_DeprecatedRelTypeSeparatorNotification__init_ = function(var_0, var_1, var_2) {
        var var_3 = new onciu_DeprecatedRelTypeSeparatorNotification();
        onciu_DeprecatedRelTypeSeparatorNotification__init_(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.onciu_DeprecatedRelTypeSeparatorNotification_productPrefix = function($this) {
        return $rt_s(2693);
    };
    $java.onciu_DeprecatedRelTypeSeparatorNotification_productArity = function($this) {
        return 3;
    };
    $java.onciu_DeprecatedRelTypeSeparatorNotification_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position218;
            case 1:
                return $this.$oldExpression;
            case 2:
                return $this.$rewrittenExpression;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_DeprecatedRelTypeSeparatorNotification_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedRelTypeSeparatorNotification_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedRelTypeSeparatorNotification_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedRelTypeSeparatorNotification_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_DeprecatedRelTypeSeparatorNotification) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position218;
                        var$3 = $x$1.$position218;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$oldExpression;
                        var$3 = $x$1.$oldExpression;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$rewrittenExpression;
                        $x$1 = $x$1.$rewrittenExpression;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_DeprecatedRelTypeSeparatorNotification))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function onciu_DeprecatedRelTypeSeparatorNotification__init_($this, $position, $oldExpression, $rewrittenExpression) {
        $this.$position218 = $position;
        $this.$oldExpression = $oldExpression;
        $this.$rewrittenExpression = $rewrittenExpression;
    }
    var oncir_Deprecations$ = $rt_classWithoutFields();
    var oncir_Deprecations$_MODULE$ = null;
    function oncir_Deprecations$__clinit_() {
        oncir_Deprecations$_MODULE$ = new oncir_Deprecations$;
    }
    function oncir_Deprecations$_org$neo4j$cypher$internal$rewriting$Deprecations$$functionInvocationForSetProperties($this, $s, $e) {
        var var$3, var$4, var$5, var$6, var$7, var$8;
        var$3 = new oncie_FunctionInvocation;
        var$4 = oncie_Namespace__init_(sci_Nil$_MODULE$, $e.$position0);
        var$5 = oncie_FunctionName__init_($rt_s(541), $e.$position0);
        s_package$_$callClinit();
        var$6 = s_package$_Vector0(s_package$_MODULE$);
        var$7 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncie_Variable, 1);
        var$8.data[0] = $e;
        $java.oncie_FunctionInvocation__init_(var$3, var$4, var$5, 0, var$6.$from0(sr_ScalaRunTime$_wrapRefArray(var$7, var$8)), $s.$position2());
        return var$3;
    }
    function oncir_Deprecations$_org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder($this, $lhs, $rhs) {
        return sc_IterableOnceOps_nonEmpty$(oncia_Query_returnColumns$($rhs)) && sc_IterableOnceOps_nonEmpty$($lhs.$returnColumns()) && !sci_List_equals(sci_List_map(oncia_Query_returnColumns$($rhs), new $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_0), sci_List_map($lhs.$returnColumns(), new $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_1)) ? 1 : 0;
    }
    function onciu_UnionReturnItemsInDifferentOrder() {
        jl_Object.call(this);
        this.$position219 = null;
    }
    function onciu_UnionReturnItemsInDifferentOrder__init_(var_0) {
        var var_1 = new onciu_UnionReturnItemsInDifferentOrder();
        $java.onciu_UnionReturnItemsInDifferentOrder__init_(var_1, var_0);
        return var_1;
    }
    $java.onciu_UnionReturnItemsInDifferentOrder_productPrefix = function($this) {
        return $rt_s(2694);
    };
    $java.onciu_UnionReturnItemsInDifferentOrder_productArity = function($this) {
        return 1;
    };
    $java.onciu_UnionReturnItemsInDifferentOrder_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position219;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_UnionReturnItemsInDifferentOrder_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnionReturnItemsInDifferentOrder_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnionReturnItemsInDifferentOrder_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnionReturnItemsInDifferentOrder_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_UnionReturnItemsInDifferentOrder) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position219;
                        $x$1 = $x$1.$position219;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_UnionReturnItemsInDifferentOrder))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.onciu_UnionReturnItemsInDifferentOrder__init_ = function($this, $position) {
        $this.$position219 = $position;
    };
    function onciu_FixedLengthRelationshipInShortestPath() {
        var a = this; jl_Object.call(a);
        a.$position220 = null;
        a.$deprecated0 = null;
        a.$replacement3 = null;
    }
    function onciu_FixedLengthRelationshipInShortestPath__init_(var_0, var_1, var_2) {
        var var_3 = new onciu_FixedLengthRelationshipInShortestPath();
        $java.onciu_FixedLengthRelationshipInShortestPath__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.onciu_FixedLengthRelationshipInShortestPath_productPrefix = function($this) {
        return $rt_s(2695);
    };
    $java.onciu_FixedLengthRelationshipInShortestPath_productArity = function($this) {
        return 3;
    };
    $java.onciu_FixedLengthRelationshipInShortestPath_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position220;
            case 1:
                return $this.$deprecated0;
            case 2:
                return $this.$replacement3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_FixedLengthRelationshipInShortestPath_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_FixedLengthRelationshipInShortestPath_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_FixedLengthRelationshipInShortestPath_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_FixedLengthRelationshipInShortestPath_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_FixedLengthRelationshipInShortestPath) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position220;
                        var$3 = $x$1.$position220;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$deprecated0;
                        var$3 = $x$1.$deprecated0;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$replacement3;
                        $x$1 = $x$1.$replacement3;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_FixedLengthRelationshipInShortestPath))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.onciu_FixedLengthRelationshipInShortestPath__init_ = function($this, $position, $deprecated, $replacement) {
        $this.$position220 = $position;
        $this.$deprecated0 = $deprecated;
        $this.$replacement3 = $replacement;
    };
    function onciu_DeprecatedDatabaseNameNotification() {
        var a = this; jl_Object.call(a);
        a.$databaseName3 = null;
        a.$position221 = null;
    }
    function onciu_DeprecatedDatabaseNameNotification__init_(var_0, var_1) {
        var var_2 = new onciu_DeprecatedDatabaseNameNotification();
        $java.onciu_DeprecatedDatabaseNameNotification__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciu_DeprecatedDatabaseNameNotification_productPrefix = function($this) {
        return $rt_s(2696);
    };
    $java.onciu_DeprecatedDatabaseNameNotification_productArity = function($this) {
        return 2;
    };
    $java.onciu_DeprecatedDatabaseNameNotification_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$databaseName3;
            case 1:
                return $this.$position221;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_DeprecatedDatabaseNameNotification_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedDatabaseNameNotification_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedDatabaseNameNotification_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedDatabaseNameNotification_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_DeprecatedDatabaseNameNotification) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$databaseName3;
                        var$3 = $x$1.$databaseName3;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$position221;
                        $x$1 = $x$1.$position221;
                        if (var$3 !== null) {
                            if (!s_Some_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_DeprecatedDatabaseNameNotification))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.onciu_DeprecatedDatabaseNameNotification__init_ = function($this, $databaseName, $position) {
        $this.$databaseName3 = $databaseName;
        $this.$position221 = $position;
    };
    function onciu_DeprecatedTextIndexProvider() {
        jl_Object.call(this);
        this.$position222 = null;
    }
    function onciu_DeprecatedTextIndexProvider__init_(var_0) {
        var var_1 = new onciu_DeprecatedTextIndexProvider();
        $java.onciu_DeprecatedTextIndexProvider__init_(var_1, var_0);
        return var_1;
    }
    $java.onciu_DeprecatedTextIndexProvider_productPrefix = function($this) {
        return $rt_s(2697);
    };
    $java.onciu_DeprecatedTextIndexProvider_productArity = function($this) {
        return 1;
    };
    $java.onciu_DeprecatedTextIndexProvider_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position222;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_DeprecatedTextIndexProvider_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedTextIndexProvider_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedTextIndexProvider_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedTextIndexProvider_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_DeprecatedTextIndexProvider) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position222;
                        $x$1 = $x$1.$position222;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_DeprecatedTextIndexProvider))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.onciu_DeprecatedTextIndexProvider__init_ = function($this, $position) {
        $this.$position222 = $position;
    };
    function onciu_DeprecatedFunctionNotification() {
        var a = this; jl_Object.call(a);
        a.$position223 = null;
        a.$oldName = null;
        a.$newName1 = null;
    }
    function onciu_DeprecatedFunctionNotification__init_(var_0, var_1, var_2) {
        var var_3 = new onciu_DeprecatedFunctionNotification();
        $java.onciu_DeprecatedFunctionNotification__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.onciu_DeprecatedFunctionNotification_productPrefix = function($this) {
        return $rt_s(2698);
    };
    $java.onciu_DeprecatedFunctionNotification_productArity = function($this) {
        return 3;
    };
    $java.onciu_DeprecatedFunctionNotification_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position223;
            case 1:
                return $this.$oldName;
            case 2:
                return $this.$newName1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_DeprecatedFunctionNotification_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedFunctionNotification_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedFunctionNotification_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedFunctionNotification_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_DeprecatedFunctionNotification) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position223;
                        var$3 = $x$1.$position223;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$oldName;
                        var$3 = $x$1.$oldName;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$newName1;
                        $x$1 = $x$1.$newName1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_DeprecatedFunctionNotification))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.onciu_DeprecatedFunctionNotification__init_ = function($this, $position, $oldName, $newName) {
        $this.$position223 = $position;
        $this.$oldName = $oldName;
        $this.$newName1 = $newName;
    };
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    function oncie_PatternExpression() {
        var a = this; oncie_Expression.call(a);
        a.$pattern6 = null;
        a.$computedIntroducedVariables3 = null;
        a.$computedScopeDependencies3 = null;
    }
    $java.oncie_PatternExpression__init_ = function(var_0, var_1, var_2) {
        var var_3 = new oncie_PatternExpression();
        oncie_PatternExpression__init_(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncie_PatternExpression_introducedVariables = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_introducedVariables$($this);
    };
    $java.oncie_PatternExpression_scopeDependencies = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_scopeDependencies$($this);
    };
    $java.oncie_PatternExpression_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    function oncie_PatternExpression_pattern($this) {
        return $this.$pattern6;
    }
    $java.oncie_PatternExpression_computedIntroducedVariables = function($this) {
        return $this.$computedIntroducedVariables3;
    };
    $java.oncie_PatternExpression_computedScopeDependencies = function($this) {
        return $this.$computedScopeDependencies3;
    };
    $java.oncie_PatternExpression_position = function($this) {
        return $this.$pattern6.$position224;
    };
    $java.oncie_PatternExpression_withComputedIntroducedVariables = function($this, $computedIntroducedVariables) {
        return $java.oncie_PatternExpression_copy($this, $this.$pattern6, s_Some__init_($computedIntroducedVariables), $this.$computedScopeDependencies3);
    };
    $java.oncie_PatternExpression_withComputedScopeDependencies = function($this, $computedScopeDependencies) {
        return $java.oncie_PatternExpression_copy($this, $this.$pattern6, $this.$computedIntroducedVariables3, s_Some__init_($computedScopeDependencies));
    };
    $java.oncie_PatternExpression_subqueryAstNode = function($this) {
        return $this.$pattern6;
    };
    $java.oncie_PatternExpression_dup = function($this, $children) {
        return $java.oncie_PatternExpression__init_($children.$head(), $this.$computedIntroducedVariables3, $this.$computedScopeDependencies3);
    };
    $java.oncie_PatternExpression_copy = function($this, $pattern, $computedIntroducedVariables, $computedScopeDependencies) {
        return $java.oncie_PatternExpression__init_($pattern, $computedIntroducedVariables, $computedScopeDependencies);
    };
    $java.oncie_PatternExpression_productPrefix = function($this) {
        return $rt_s(2699);
    };
    $java.oncie_PatternExpression_productArity = function($this) {
        return 1;
    };
    $java.oncie_PatternExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$pattern6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternExpression_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PatternExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$pattern6;
                        $x$1 = $x$1.$pattern6;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelationshipsPattern_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PatternExpression))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PatternExpression_dup0 = function($this, $children) {
        return $java.oncie_PatternExpression_dup($this, $children);
    };
    $java.oncie_PatternExpression_dup1 = function($this, $children) {
        return $java.oncie_PatternExpression_dup($this, $children);
    };
    function oncie_PatternExpression__init_($this, $pattern, $computedIntroducedVariables, $computedScopeDependencies) {
        $this.$pattern6 = $pattern;
        $this.$computedIntroducedVariables3 = $computedIntroducedVariables;
        $this.$computedScopeDependencies3 = $computedScopeDependencies;
        $java.oncie_Expression__init_($this);
    }
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_1 = function() {
        jl_Object.call(this);
        this.$_0312 = null;
    };
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0312;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(oncias_SemanticError__init_0(oncifp_PatternExpressionInNonExistenceCheck$_errorMessageForSizeFunction, $java.oncie_PatternExpression_position(var$2))));
    };
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_2 = function() {
        jl_Object.call(this);
        this.$_0313 = null;
    };
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0313;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(oncias_SemanticError__init_0(oncifp_PatternExpressionInNonExistenceCheck$_errorMessage, $java.oncie_PatternExpression_position(var$2))));
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0314 = null;
        a.$_193 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0314;
        var$3 = var$0.$_193;
        var$4 = oncias_Scope_allSymbolDefinitions(var$2.$semanticTable$1.$recordedScopes1.$apply(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, var$3)));
        var$5 = var$3.$patternParts0;
        var$3 = new $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findSelfReferenceVariablesInPattern$lambda$_2_0;
        var$3.$_0451 = var$4;
        var$4 = sc_AbstractIterable_toSet(var$5.$flatMap(var$3));
        var$3 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$$anonfun$applyOrElse$4$lambda$_3_0;
        var$3.$_0452 = var$2;
        var$2 = (var$4.$map1(var$3)).$toSeq();
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$concat0(var$2));
    };
    $java.oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0316 = null;
    };
    $java.oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0316;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(oncias_SemanticError__init_0(oncifp_ListCoercedToBooleanCheck$_errorMessage, var$2.$position2())));
    };
    $java.oncirr_rewriteShowQuery$$anonfun$lastPosition$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0361 = null;
    };
    $java.oncirr_rewriteShowQuery$$anonfun$lastPosition$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0361;
        var$3 = new $java.onciu_Foldable$TraverseChildren;
        var$4 = sci_$colon$colon__init_(var$1, sci_$colon$colon__init_(var$2.$position2(), sci_Nil$_MODULE$));
        onciu_InputPosition$_$callClinit();
        $java.onciu_Foldable$TraverseChildren__init_(var$3, sc_AbstractIterable_max(var$4, onciu_InputPosition$_byOffset0(onciu_InputPosition$_MODULE$)));
        return var$3;
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0430 = null;
        a.$_1128 = null;
        a.$_250 = null;
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0430;
        var$3 = var$0.$_1128;
        var$4 = var$0.$_250;
        var$5 = var$1.$get1(var$3);
        var$6 = new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_0;
        var$6.$_0453 = var$2;
        var$6.$_1137 = var$4;
        var$2 = s_Option_map(var$5, var$6);
        var$5 = new $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_1;
        var$5.$_0454 = var$4;
        var$4 = (s_Option_getOrElse(var$2, var$5)).$distinct3();
        var$5 = new $java.onciu_Foldable$SkipChildren;
        var$2 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        $java.onciu_Foldable$SkipChildren__init_0(var$5, sci_AbstractMap_$plus(var$1, s_Predef$ArrowAssoc$_$minus$greater$extension(var$2, var$3, var$4)));
        return var$5;
    };
    $java.oncia_ReturnItems$returnVariables$lambda$_62_0 = $rt_classWithoutFields();
    $java.oncia_ReturnItems$returnVariables$lambda$_62_0_apply = function(var$0, var$1) {
        return var$1.$alias();
    };
    function onciafn_Neo4jASTFactory$functionQualifier$lambda$_202_0() {
        var a = this; jl_Object.call(a);
        a.$_0246 = null;
        a.$_167 = null;
    }
    $java.onciafn_Neo4jASTFactory$functionQualifier$lambda$_202_0_accept = function(var$0, var$1) {
        var$1 = var$1;
        ju_ArrayList_add(var$0.$_0246, $java.oncia_FunctionQualifier__init_(var$1, var$0.$_167));
    };
    function onciafn_Neo4jASTFactory$procedureQualifier$lambda$_203_0() {
        var a = this; jl_Object.call(a);
        a.$_0247 = null;
        a.$_168 = null;
    }
    $java.onciafn_Neo4jASTFactory$procedureQualifier$lambda$_203_0_accept = function(var$0, var$1) {
        var$1 = var$1;
        ju_ArrayList_add(var$0.$_0247, $java.oncia_ProcedureQualifier__init_(var$1, var$0.$_168));
    };
    function oncia_RelationshipQualifier() {
        var a = this; jl_Object.call(a);
        a.$reltype = null;
        a.$position225 = null;
    }
    function oncia_RelationshipQualifier__init_(var_0, var_1) {
        var var_2 = new oncia_RelationshipQualifier();
        $java.oncia_RelationshipQualifier__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_RelationshipQualifier_productPrefix = function($this) {
        return $rt_s(2700);
    };
    $java.oncia_RelationshipQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_RelationshipQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$reltype;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RelationshipQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelationshipQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelationshipQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelationshipQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_RelationshipQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$reltype;
                        $x$1 = $x$1.$reltype;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_RelationshipQualifier_dup = function($this, $children) {
        return oncia_RelationshipQualifier__init_($children.$head(), $this.$position225);
    };
    $java.oncia_RelationshipQualifier__init_ = function($this, $reltype, $position) {
        $this.$reltype = $reltype;
        $this.$position225 = $position;
    };
    function oncia_RelationshipAllQualifier() {
        jl_Object.call(this);
        this.$position20 = null;
    }
    $java.oncia_RelationshipAllQualifier_productPrefix = function($this) {
        return $rt_s(2701);
    };
    $java.oncia_RelationshipAllQualifier_productArity = function($this) {
        return 0;
    };
    $java.oncia_RelationshipAllQualifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_RelationshipAllQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelationshipAllQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelationshipAllQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_RelationshipAllQualifier_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_RelationshipAllQualifier))
            return 0;
        return 1;
    };
    $java.oncia_RelationshipAllQualifier_dup = function($this, $children) {
        return $this;
    };
    function oncia_LabelQualifier() {
        var a = this; jl_Object.call(a);
        a.$label16 = null;
        a.$position226 = null;
    }
    function oncia_LabelQualifier__init_(var_0, var_1) {
        var var_2 = new oncia_LabelQualifier();
        $java.oncia_LabelQualifier__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_LabelQualifier_productPrefix = function($this) {
        return $rt_s(2702);
    };
    $java.oncia_LabelQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_LabelQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$label16;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LabelQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_LabelQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$label16;
                        $x$1 = $x$1.$label16;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_LabelQualifier_dup = function($this, $children) {
        return oncia_LabelQualifier__init_($children.$head(), $this.$position226);
    };
    $java.oncia_LabelQualifier__init_ = function($this, $label, $position) {
        $this.$label16 = $label;
        $this.$position226 = $position;
    };
    function oncia_PatternQualifier() {
        var a = this; jl_Object.call(a);
        a.$labelQualifiers0 = null;
        a.$variable42 = null;
        a.$expression14 = null;
    }
    function oncia_PatternQualifier__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_PatternQualifier();
        $java.oncia_PatternQualifier__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncia_PatternQualifier_labelQualifiers($this) {
        return $this.$labelQualifiers0;
    }
    function oncia_PatternQualifier_variable($this) {
        return $this.$variable42;
    }
    function oncia_PatternQualifier_expression($this) {
        return $this.$expression14;
    }
    $java.oncia_PatternQualifier_productPrefix = function($this) {
        return $rt_s(2703);
    };
    $java.oncia_PatternQualifier_productArity = function($this) {
        return 3;
    };
    $java.oncia_PatternQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$labelQualifiers0;
            case 1:
                return $this.$variable42;
            case 2:
                return $this.$expression14;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_PatternQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PatternQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PatternQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PatternQualifier_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_PatternQualifier) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$labelQualifiers0;
                            var$3 = $x$1.$labelQualifiers0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$variable42;
                            var$3 = $x$1.$variable42;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$expression14;
                        $x$1 = $x$1.$expression14;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_PatternQualifier_dup = function($this, $children) {
        return oncia_PatternQualifier__init_($children.$head(), $children.$apply1(1), $children.$apply1(2));
    };
    $java.oncia_PatternQualifier__init_ = function($this, $labelQualifiers, $variable, $expression) {
        $this.$labelQualifiers0 = $labelQualifiers;
        $this.$variable42 = $variable;
        $this.$expression14 = $expression;
    };
    function oncia_ElementQualifier() {
        var a = this; jl_Object.call(a);
        a.$value27 = null;
        a.$position227 = null;
    }
    function oncia_ElementQualifier__init_(var_0, var_1) {
        var var_2 = new oncia_ElementQualifier();
        $java.oncia_ElementQualifier__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncia_ElementQualifier_productPrefix = function($this) {
        return $rt_s(2704);
    };
    $java.oncia_ElementQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_ElementQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value27;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ElementQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ElementQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ElementQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ElementQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ElementQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$value27;
                        $x$1 = $x$1.$value27;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ElementQualifier_dup = function($this, $children) {
        return oncia_ElementQualifier__init_($children.$head(), $this.$position227);
    };
    $java.oncia_ElementQualifier__init_ = function($this, $value, $position) {
        $this.$value27 = $value;
        $this.$position227 = $position;
    };
    function oncia_PropertiesResource() {
        var a = this; jl_Object.call(a);
        a.$properties2 = null;
        a.$position36 = null;
    }
    $java.oncia_PropertiesResource_productPrefix = function($this) {
        return $rt_s(2705);
    };
    $java.oncia_PropertiesResource_productArity = function($this) {
        return 1;
    };
    $java.oncia_PropertiesResource_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$properties2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_PropertiesResource_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PropertiesResource_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PropertiesResource_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_PropertiesResource_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_PropertiesResource) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$properties2;
                        $x$1 = $x$1.$properties2;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncia_AllPropertyResource() {
        jl_Object.call(this);
        this.$position37 = null;
    }
    $java.oncia_AllPropertyResource_productPrefix = function($this) {
        return $rt_s(2706);
    };
    $java.oncia_AllPropertyResource_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllPropertyResource_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllPropertyResource_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllPropertyResource_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllPropertyResource_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllPropertyResource_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_AllPropertyResource))
            return 0;
        return 1;
    };
    function oncia_LabelsResource() {
        var a = this; jl_Object.call(a);
        a.$labels0 = null;
        a.$position34 = null;
    }
    $java.oncia_LabelsResource_productPrefix = function($this) {
        return $rt_s(2707);
    };
    $java.oncia_LabelsResource_productArity = function($this) {
        return 1;
    };
    $java.oncia_LabelsResource_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$labels0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_LabelsResource_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelsResource_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelsResource_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_LabelsResource_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_LabelsResource) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$labels0;
                        $x$1 = $x$1.$labels0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncia_AllLabelResource() {
        jl_Object.call(this);
        this.$position35 = null;
    }
    $java.oncia_AllLabelResource_productPrefix = function($this) {
        return $rt_s(2708);
    };
    $java.oncia_AllLabelResource_productArity = function($this) {
        return 0;
    };
    $java.oncia_AllLabelResource_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_AllLabelResource_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllLabelResource_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllLabelResource_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_AllLabelResource_equals = function($this, $x$1) {
        if (!($x$1 instanceof oncia_AllLabelResource))
            return 0;
        return 1;
    };
    function onciafn_Neo4jASTFactory$settingQualifier$lambda$_204_0() {
        var a = this; jl_Object.call(a);
        a.$_0245 = null;
        a.$_166 = null;
    }
    $java.onciafn_Neo4jASTFactory$settingQualifier$lambda$_204_0_accept = function(var$0, var$1) {
        var$1 = var$1;
        ju_ArrayList_add(var$0.$_0245, $java.oncia_SettingQualifier__init_(var$1, var$0.$_166));
    };
    function oncie_QuantifiedPath() {
        var a = this; $java.oncie_PatternElement.call(a);
        a.$part1 = null;
        a.$quantifier = null;
        a.$optionalWhereExpression = null;
        a.$variableGroupings = null;
        a.$position228 = null;
    }
    function oncie_QuantifiedPath__init_(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new oncie_QuantifiedPath();
        $java.oncie_QuantifiedPath__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    }
    $java.oncie_QuantifiedPath_part = function($this) {
        return $this.$part1;
    };
    $java.oncie_QuantifiedPath_quantifier = function($this) {
        return $this.$quantifier;
    };
    $java.oncie_QuantifiedPath_position = function($this) {
        return $this.$position228;
    };
    $java.oncie_QuantifiedPath_allVariables = function($this) {
        return $this.$variableGroupings.$map1(new $java.oncie_QuantifiedPath$allVariables$lambda$_9_0);
    };
    $java.oncie_QuantifiedPath_isBounded = function($this) {
        var var$1;
        var$1 = $this.$quantifier;
        if (var$1 instanceof oncie_FixedQuantifier)
            return 1;
        if (var$1 instanceof oncie_IntervalQuantifier)
            return s_Option_isDefined(var$1.$upper0);
        if (var$1 instanceof oncie_PlusQuantifier)
            return 0;
        if (var$1 instanceof oncie_StarQuantifier)
            return 0;
        $rt_throw(s_MatchError__init_(var$1));
    };
    $java.oncie_QuantifiedPath_copy = function($this, $part, $quantifier, $optionalWhereExpression, $variableGroupings, $position) {
        return oncie_QuantifiedPath__init_($part, $quantifier, $optionalWhereExpression, $variableGroupings, $position);
    };
    $java.oncie_QuantifiedPath_productPrefix = function($this) {
        return $rt_s(2709);
    };
    $java.oncie_QuantifiedPath_productArity = function($this) {
        return 4;
    };
    $java.oncie_QuantifiedPath_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$part1;
            case 1:
                return $this.$quantifier;
            case 2:
                return $this.$optionalWhereExpression;
            case 3:
                return $this.$variableGroupings;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_QuantifiedPath_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_QuantifiedPath_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_QuantifiedPath_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_QuantifiedPath_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_QuantifiedPath) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$part1;
                        var$3 = $x$1.$part1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$quantifier;
                        var$3 = $x$1.$quantifier;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$optionalWhereExpression;
                        var$3 = $x$1.$optionalWhereExpression;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$variableGroupings;
                        $x$1 = $x$1.$variableGroupings;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_QuantifiedPath))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_QuantifiedPath__init_ = function($this, $part, $quantifier, $optionalWhereExpression, $variableGroupings, $position) {
        $this.$part1 = $part;
        $this.$quantifier = $quantifier;
        $this.$optionalWhereExpression = $optionalWhereExpression;
        $this.$variableGroupings = $variableGroupings;
        $this.$position228 = $position;
        $java.oncie_PatternElement__init_($this);
    };
    function oncie_ParenthesizedPath() {
        var a = this; $java.oncie_PatternElement.call(a);
        a.$part0 = null;
        a.$optionalWhereClause = null;
        a.$position229 = null;
    }
    function oncie_ParenthesizedPath__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_ParenthesizedPath();
        $java.oncie_ParenthesizedPath__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_ParenthesizedPath_part = function($this) {
        return $this.$part0;
    };
    $java.oncie_ParenthesizedPath_optionalWhereClause = function($this) {
        return $this.$optionalWhereClause;
    };
    $java.oncie_ParenthesizedPath_position = function($this) {
        return $this.$position229;
    };
    $java.oncie_ParenthesizedPath_allVariables = function($this) {
        return ($this.$part0.$element()).$allVariables();
    };
    $java.oncie_ParenthesizedPath_isBounded = function($this) {
        return $this.$part0.$isBounded();
    };
    $java.oncie_ParenthesizedPath_productPrefix = function($this) {
        return $rt_s(2710);
    };
    $java.oncie_ParenthesizedPath_productArity = function($this) {
        return 2;
    };
    $java.oncie_ParenthesizedPath_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$part0;
            case 1:
                return $this.$optionalWhereClause;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ParenthesizedPath_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ParenthesizedPath_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ParenthesizedPath_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ParenthesizedPath_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ParenthesizedPath) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$part0;
                        var$3 = $x$1.$part0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$optionalWhereClause;
                        $x$1 = $x$1.$optionalWhereClause;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ParenthesizedPath))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ParenthesizedPath__init_ = function($this, $part, $optionalWhereClause, $position) {
        $this.$part0 = $part;
        $this.$optionalWhereClause = $optionalWhereClause;
        $this.$position229 = $position;
        $java.oncie_PatternElement__init_($this);
    };
    function oncie_PathConcatenation() {
        var a = this; $java.oncie_PatternElement.call(a);
        a.$factors = null;
        a.$position230 = null;
    }
    function oncie_PathConcatenation__init_(var_0, var_1) {
        var var_2 = new oncie_PathConcatenation();
        $java.oncie_PathConcatenation__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_PathConcatenation_factors = function($this) {
        return $this.$factors;
    };
    $java.oncie_PathConcatenation_position = function($this) {
        return $this.$position230;
    };
    $java.oncie_PathConcatenation_allVariables = function($this) {
        return sc_AbstractIterable_toSet($this.$factors.$flatMap(new $java.oncie_PathConcatenation$allVariables$lambda$_4_0));
    };
    $java.oncie_PathConcatenation_isBounded = function($this) {
        return $this.$factors.$forall(new $java.oncie_PathConcatenation$isBounded$lambda$_6_0);
    };
    $java.oncie_PathConcatenation_productPrefix = function($this) {
        return $rt_s(2711);
    };
    $java.oncie_PathConcatenation_productArity = function($this) {
        return 1;
    };
    $java.oncie_PathConcatenation_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$factors;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PathConcatenation_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PathConcatenation_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PathConcatenation_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PathConcatenation_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PathConcatenation) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$factors;
                        $x$1 = $x$1.$factors;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PathConcatenation))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PathConcatenation__init_ = function($this, $factors, $position) {
        $this.$factors = $factors;
        $this.$position230 = $position;
        $java.oncie_PatternElement__init_($this);
    };
    function oncie_NaN() {
        var a = this; oncie_Expression.call(a);
        a.$position120 = null;
        a.$value28 = null;
    }
    function oncie_NaN__init_(var_0) {
        var var_1 = new oncie_NaN();
        $java.oncie_NaN__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_NaN_position = function($this) {
        return $this.$position120;
    };
    $java.oncie_NaN_asCanonicalStringVal = function($this) {
        return $rt_s(2712);
    };
    $java.oncie_NaN_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_NaN$$anon$9;
        $java.oncie_NaN__init_(var$1, $this.$position120);
        return var$1;
    };
    $java.oncie_NaN_copy = function($this, $position) {
        return oncie_NaN__init_($position);
    };
    $java.oncie_NaN_productPrefix = function($this) {
        return $rt_s(2712);
    };
    $java.oncie_NaN_productArity = function($this) {
        return 0;
    };
    $java.oncie_NaN_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_NaN_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NaN_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_NaN;
    };
    $java.oncie_NaN_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NaN_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NaN_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_NaN) ? 0 : 1;
        return var$2 && $this instanceof oncie_NaN ? 1 : 0;
    };
    $java.oncie_NaN__init_ = function($this, $position) {
        $this.$position120 = $position;
        $java.oncie_Expression__init_($this);
        s_Predef$_$callClinit();
        $this.$value28 = jl_Double_valueOf(NaN);
    };
    function oncie_True() {
        var a = this; oncie_Expression.call(a);
        a.$position231 = null;
        a.$value29 = null;
    }
    function oncie_True__init_(var_0) {
        var var_1 = new oncie_True();
        $java.oncie_True__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_True_position = function($this) {
        return $this.$position231;
    };
    $java.oncie_True_asCanonicalStringVal = function($this) {
        return $rt_s(197);
    };
    $java.oncie_True_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_True$$anon$10;
        $java.oncie_True__init_(var$1, $this.$position231);
        return var$1;
    };
    $java.oncie_True_copy = function($this, $position) {
        return oncie_True__init_($position);
    };
    $java.oncie_True_productPrefix = function($this) {
        return $rt_s(2713);
    };
    $java.oncie_True_productArity = function($this) {
        return 0;
    };
    $java.oncie_True_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_True_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_True_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_True;
    };
    $java.oncie_True_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_True_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_True_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_True) ? 0 : 1;
        return var$2 && $this instanceof oncie_True ? 1 : 0;
    };
    $java.oncie_True__init_ = function($this, $position) {
        $this.$position231 = $position;
        $java.oncie_Expression__init_($this);
        s_Predef$_$callClinit();
        $this.$value29 = jl_Boolean_valueOf(1);
    };
    function oncie_Null() {
        var a = this; oncie_Expression.call(a);
        a.$position232 = null;
        a.$value30 = null;
    }
    function oncie_Null__init_(var_0) {
        var var_1 = new oncie_Null();
        $java.oncie_Null__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_Null_position = function($this) {
        return $this.$position232;
    };
    $java.oncie_Null_asCanonicalStringVal = function($this) {
        return $rt_s(1529);
    };
    $java.oncie_Null_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_Null$$anon$7;
        $java.oncie_Null__init_(var$1, $this.$position232);
        return var$1;
    };
    $java.oncie_Null_copy = function($this, $position) {
        return oncie_Null__init_($position);
    };
    $java.oncie_Null_productPrefix = function($this) {
        return $rt_s(126);
    };
    $java.oncie_Null_productArity = function($this) {
        return 0;
    };
    $java.oncie_Null_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Null_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Null_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_Null;
    };
    $java.oncie_Null_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Null_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Null_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_Null) ? 0 : 1;
        return var$2 && $this instanceof oncie_Null ? 1 : 0;
    };
    $java.oncie_Null__init_ = function($this, $position) {
        $this.$position232 = $position;
        $java.oncie_Expression__init_($this);
        $this.$value30 = null;
    };
    function oncie_CountStar() {
        oncie_Expression.call(this);
        this.$position233 = null;
    }
    function oncie_CountStar__init_(var_0) {
        var var_1 = new oncie_CountStar();
        $java.oncie_CountStar__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_CountStar_position = function($this) {
        return $this.$position233;
    };
    $java.oncie_CountStar_asCanonicalStringVal = function($this) {
        return $rt_s(148);
    };
    $java.oncie_CountStar_productPrefix = function($this) {
        return $rt_s(2714);
    };
    $java.oncie_CountStar_productArity = function($this) {
        return 0;
    };
    $java.oncie_CountStar_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_CountStar_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_CountStar_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_CountStar_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_CountStar_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_CountStar) ? 0 : 1;
        return var$2 && $this instanceof oncie_CountStar ? 1 : 0;
    };
    $java.oncie_CountStar__init_ = function($this, $position) {
        $this.$position233 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_Infinity() {
        var a = this; oncie_Expression.call(a);
        a.$position234 = null;
        a.$value31 = null;
    }
    function oncie_Infinity__init_(var_0) {
        var var_1 = new oncie_Infinity();
        $java.oncie_Infinity__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_Infinity_position = function($this) {
        return $this.$position234;
    };
    $java.oncie_Infinity_asCanonicalStringVal = function($this) {
        return $rt_s(2715);
    };
    $java.oncie_Infinity_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_Infinity$$anon$8;
        $java.oncie_Infinity__init_(var$1, $this.$position234);
        return var$1;
    };
    $java.oncie_Infinity_copy = function($this, $position) {
        return oncie_Infinity__init_($position);
    };
    $java.oncie_Infinity_productPrefix = function($this) {
        return $rt_s(2715);
    };
    $java.oncie_Infinity_productArity = function($this) {
        return 0;
    };
    $java.oncie_Infinity_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Infinity_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Infinity_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_Infinity;
    };
    $java.oncie_Infinity_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Infinity_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Infinity_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_Infinity) ? 0 : 1;
        return var$2 && $this instanceof oncie_Infinity ? 1 : 0;
    };
    $java.oncie_Infinity__init_ = function($this, $position) {
        $this.$position234 = $position;
        $java.oncie_Expression__init_($this);
        s_Predef$_$callClinit();
        $this.$value31 = jl_Double_valueOf(Infinity);
    };
    var oncie_Ands$ = $rt_classWithoutFields();
    $java.oncie_Ands$_MODULE$ = null;
    function oncie_Ands$__clinit_() {
        $java.oncie_Ands$_MODULE$ = new oncie_Ands$;
    }
    $java.oncie_ChainableBinaryOperatorExpression = $rt_classWithoutFields(0);
    function oncie_Equals() {
        var a = this; oncie_Expression.call(a);
        a.$lhs5 = null;
        a.$rhs6 = null;
        a.$position29 = null;
        a.$signatures4 = null;
    }
    function oncie_Equals__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Equals();
        $java.oncie_Equals__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Equals_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Equals_lhs = function($this) {
        return $this.$lhs5;
    };
    $java.oncie_Equals_rhs = function($this) {
        return $this.$rhs6;
    };
    $java.oncie_Equals_position = function($this) {
        return $this.$position29;
    };
    $java.oncie_Equals_signatures = function($this) {
        return $this.$signatures4;
    };
    $java.oncie_Equals_canonicalOperatorSymbol = function($this) {
        return $rt_s(988);
    };
    function oncie_Equals_copy($this, $lhs, $rhs, $position) {
        return oncie_Equals__init_($lhs, $rhs, $position);
    }
    $java.oncie_Equals_productPrefix = function($this) {
        return $rt_s(2716);
    };
    $java.oncie_Equals_productArity = function($this) {
        return 2;
    };
    $java.oncie_Equals_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs5;
            case 1:
                return $this.$rhs6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Equals_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Equals_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Equals_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Equals_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Equals) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs5;
                        var$3 = $x$1.$lhs5;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs6;
                        $x$1 = $x$1.$rhs6;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Equals))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Equals__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs5 = $lhs;
        $this.$rhs6 = $rhs;
        $this.$position29 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures4 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    $java.oncie_InequalityExpression = $rt_classWithoutFields(0);
    $java.oncie_InequalityExpression_$init$ = function($$this) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        s_package$_$callClinit();
        var$2 = s_package$_Vector0(s_package$_MODULE$);
        var$3 = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$5 = var$4.data;
        var$6 = $java.oncie_TypeSignature$_MODULE$;
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$5[0] = $java.oncie_TypeSignature$_apply(var$6, var$7.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $$this.$org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq(var$2.$from0(sr_ScalaRunTime$_wrapRefArray(var$3, var$4)));
    };
    function oncie_GreaterThanOrEqual() {
        var a = this; oncie_Expression.call(a);
        a.$lhs12 = null;
        a.$rhs13 = null;
        a.$position235 = null;
        a.$canonicalOperatorSymbol0 = null;
        a.$includeEquality = 0;
        a.$signatures5 = null;
    }
    function oncie_GreaterThanOrEqual__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_GreaterThanOrEqual();
        $java.oncie_GreaterThanOrEqual__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_GreaterThanOrEqual_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_GreaterThanOrEqual_signatures = function($this) {
        return $this.$signatures5;
    };
    $java.oncie_GreaterThanOrEqual_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq = function($this, $x$1) {
        $this.$signatures5 = $x$1;
    };
    $java.oncie_GreaterThanOrEqual_lhs = function($this) {
        return $this.$lhs12;
    };
    $java.oncie_GreaterThanOrEqual_rhs = function($this) {
        return $this.$rhs13;
    };
    $java.oncie_GreaterThanOrEqual_position = function($this) {
        return $this.$position235;
    };
    $java.oncie_GreaterThanOrEqual_canonicalOperatorSymbol = function($this) {
        return $this.$canonicalOperatorSymbol0;
    };
    $java.oncie_GreaterThanOrEqual_productPrefix = function($this) {
        return $rt_s(2717);
    };
    $java.oncie_GreaterThanOrEqual_productArity = function($this) {
        return 2;
    };
    $java.oncie_GreaterThanOrEqual_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs12;
            case 1:
                return $this.$rhs13;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_GreaterThanOrEqual_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_GreaterThanOrEqual_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_GreaterThanOrEqual_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_GreaterThanOrEqual_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncie_GreaterThanOrEqual) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$lhs12;
                            var$3 = $x$1.$lhs12;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$rhs13;
                        $x$1 = $x$1.$rhs13;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_GreaterThanOrEqual__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs12 = $lhs;
        $this.$rhs13 = $rhs;
        $this.$position235 = $position;
        $java.oncie_Expression__init_($this);
        $java.oncie_InequalityExpression_$init$($this);
        $this.$canonicalOperatorSymbol0 = $rt_s(989);
        $this.$includeEquality = 1;
    };
    function oncie_GreaterThan() {
        var a = this; oncie_Expression.call(a);
        a.$lhs13 = null;
        a.$rhs14 = null;
        a.$position236 = null;
        a.$canonicalOperatorSymbol1 = null;
        a.$includeEquality0 = 0;
        a.$signatures6 = null;
    }
    function oncie_GreaterThan__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_GreaterThan();
        $java.oncie_GreaterThan__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_GreaterThan_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_GreaterThan_signatures = function($this) {
        return $this.$signatures6;
    };
    $java.oncie_GreaterThan_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq = function($this, $x$1) {
        $this.$signatures6 = $x$1;
    };
    $java.oncie_GreaterThan_lhs = function($this) {
        return $this.$lhs13;
    };
    $java.oncie_GreaterThan_rhs = function($this) {
        return $this.$rhs14;
    };
    $java.oncie_GreaterThan_position = function($this) {
        return $this.$position236;
    };
    $java.oncie_GreaterThan_canonicalOperatorSymbol = function($this) {
        return $this.$canonicalOperatorSymbol1;
    };
    $java.oncie_GreaterThan_productPrefix = function($this) {
        return $rt_s(2718);
    };
    $java.oncie_GreaterThan_productArity = function($this) {
        return 2;
    };
    $java.oncie_GreaterThan_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs13;
            case 1:
                return $this.$rhs14;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_GreaterThan_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_GreaterThan_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_GreaterThan_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_GreaterThan_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncie_GreaterThan) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$lhs13;
                            var$3 = $x$1.$lhs13;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$rhs14;
                        $x$1 = $x$1.$rhs14;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_GreaterThan__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs13 = $lhs;
        $this.$rhs14 = $rhs;
        $this.$position236 = $position;
        $java.oncie_Expression__init_($this);
        $java.oncie_InequalityExpression_$init$($this);
        $this.$canonicalOperatorSymbol1 = $rt_s(398);
        $this.$includeEquality0 = 0;
    };
    function oncie_LessThanOrEqual() {
        var a = this; oncie_Expression.call(a);
        a.$lhs14 = null;
        a.$rhs15 = null;
        a.$position237 = null;
        a.$canonicalOperatorSymbol2 = null;
        a.$includeEquality1 = 0;
        a.$signatures7 = null;
    }
    function oncie_LessThanOrEqual__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_LessThanOrEqual();
        $java.oncie_LessThanOrEqual__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_LessThanOrEqual_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_LessThanOrEqual_signatures = function($this) {
        return $this.$signatures7;
    };
    $java.oncie_LessThanOrEqual_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq = function($this, $x$1) {
        $this.$signatures7 = $x$1;
    };
    $java.oncie_LessThanOrEqual_lhs = function($this) {
        return $this.$lhs14;
    };
    $java.oncie_LessThanOrEqual_rhs = function($this) {
        return $this.$rhs15;
    };
    $java.oncie_LessThanOrEqual_position = function($this) {
        return $this.$position237;
    };
    $java.oncie_LessThanOrEqual_canonicalOperatorSymbol = function($this) {
        return $this.$canonicalOperatorSymbol2;
    };
    $java.oncie_LessThanOrEqual_productPrefix = function($this) {
        return $rt_s(2719);
    };
    $java.oncie_LessThanOrEqual_productArity = function($this) {
        return 2;
    };
    $java.oncie_LessThanOrEqual_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs14;
            case 1:
                return $this.$rhs15;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_LessThanOrEqual_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LessThanOrEqual_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LessThanOrEqual_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LessThanOrEqual_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncie_LessThanOrEqual) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$lhs14;
                            var$3 = $x$1.$lhs14;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$rhs15;
                        $x$1 = $x$1.$rhs15;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_LessThanOrEqual__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs14 = $lhs;
        $this.$rhs15 = $rhs;
        $this.$position237 = $position;
        $java.oncie_Expression__init_($this);
        $java.oncie_InequalityExpression_$init$($this);
        $this.$canonicalOperatorSymbol2 = $rt_s(991);
        $this.$includeEquality1 = 1;
    };
    function oncie_LessThan() {
        var a = this; oncie_Expression.call(a);
        a.$lhs15 = null;
        a.$rhs16 = null;
        a.$position238 = null;
        a.$canonicalOperatorSymbol3 = null;
        a.$includeEquality2 = 0;
        a.$signatures8 = null;
    }
    function oncie_LessThan__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_LessThan();
        $java.oncie_LessThan__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_LessThan_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_LessThan_signatures = function($this) {
        return $this.$signatures8;
    };
    $java.oncie_LessThan_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq = function($this, $x$1) {
        $this.$signatures8 = $x$1;
    };
    $java.oncie_LessThan_lhs = function($this) {
        return $this.$lhs15;
    };
    $java.oncie_LessThan_rhs = function($this) {
        return $this.$rhs16;
    };
    $java.oncie_LessThan_position = function($this) {
        return $this.$position238;
    };
    $java.oncie_LessThan_canonicalOperatorSymbol = function($this) {
        return $this.$canonicalOperatorSymbol3;
    };
    $java.oncie_LessThan_productPrefix = function($this) {
        return $rt_s(2720);
    };
    $java.oncie_LessThan_productArity = function($this) {
        return 2;
    };
    $java.oncie_LessThan_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs15;
            case 1:
                return $this.$rhs16;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_LessThan_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LessThan_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LessThan_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LessThan_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncie_LessThan) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$lhs15;
                            var$3 = $x$1.$lhs15;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$rhs16;
                        $x$1 = $x$1.$rhs16;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_LessThan__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs15 = $lhs;
        $this.$rhs16 = $rhs;
        $this.$position238 = $position;
        $java.oncie_Expression__init_($this);
        $java.oncie_InequalityExpression_$init$($this);
        $this.$canonicalOperatorSymbol3 = $rt_s(397);
        $this.$includeEquality2 = 0;
    };
    function oncie_InvalidNotEquals() {
        var a = this; oncie_Expression.call(a);
        a.$lhs16 = null;
        a.$rhs17 = null;
        a.$position239 = null;
    }
    function oncie_InvalidNotEquals__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_InvalidNotEquals();
        $java.oncie_InvalidNotEquals__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_InvalidNotEquals_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_InvalidNotEquals_lhs = function($this) {
        return $this.$lhs16;
    };
    $java.oncie_InvalidNotEquals_rhs = function($this) {
        return $this.$rhs17;
    };
    $java.oncie_InvalidNotEquals_position = function($this) {
        return $this.$position239;
    };
    $java.oncie_InvalidNotEquals_canonicalOperatorSymbol = function($this) {
        return $rt_s(993);
    };
    $java.oncie_InvalidNotEquals_productPrefix = function($this) {
        return $rt_s(2721);
    };
    $java.oncie_InvalidNotEquals_productArity = function($this) {
        return 2;
    };
    $java.oncie_InvalidNotEquals_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs16;
            case 1:
                return $this.$rhs17;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_InvalidNotEquals_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_InvalidNotEquals_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_InvalidNotEquals_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_InvalidNotEquals_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_InvalidNotEquals) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs16;
                        var$3 = $x$1.$lhs16;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs17;
                        $x$1 = $x$1.$rhs17;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_InvalidNotEquals))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_InvalidNotEquals__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs16 = $lhs;
        $this.$rhs17 = $rhs;
        $this.$position239 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_NotEquals() {
        var a = this; oncie_Expression.call(a);
        a.$lhs6 = null;
        a.$rhs7 = null;
        a.$position30 = null;
        a.$signatures9 = null;
    }
    function oncie_NotEquals__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_NotEquals();
        $java.oncie_NotEquals__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_NotEquals_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_NotEquals_lhs = function($this) {
        return $this.$lhs6;
    };
    $java.oncie_NotEquals_rhs = function($this) {
        return $this.$rhs7;
    };
    $java.oncie_NotEquals_position = function($this) {
        return $this.$position30;
    };
    $java.oncie_NotEquals_signatures = function($this) {
        return $this.$signatures9;
    };
    $java.oncie_NotEquals_canonicalOperatorSymbol = function($this) {
        return $rt_s(994);
    };
    function oncie_NotEquals_copy($this, $lhs, $rhs, $position) {
        return oncie_NotEquals__init_($lhs, $rhs, $position);
    }
    $java.oncie_NotEquals_productPrefix = function($this) {
        return $rt_s(2722);
    };
    $java.oncie_NotEquals_productArity = function($this) {
        return 2;
    };
    $java.oncie_NotEquals_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs6;
            case 1:
                return $this.$rhs7;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_NotEquals_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NotEquals_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NotEquals_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NotEquals_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_NotEquals) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs6;
                        var$3 = $x$1.$lhs6;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs7;
                        $x$1 = $x$1.$rhs7;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_NotEquals))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_NotEquals__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs6 = $lhs;
        $this.$rhs7 = $rhs;
        $this.$position30 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures9 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    $java.jt_DecimalFormat$PerMillField = $rt_classWithoutFields();
    $java.jt_DecimalFormat$PerMillField_equals = function($this, $obj) {
        return $obj instanceof $java.jt_DecimalFormat$PerMillField;
    };
    $java.jt_DecimalFormat$PerMillField_hashCode = function($this) {
        return 2;
    };
    $java.jt_DecimalFormat$CurrencyField = $rt_classWithoutFields();
    $java.jt_DecimalFormat$CurrencyField_equals = function($this, $obj) {
        return $obj instanceof $java.jt_DecimalFormat$CurrencyField;
    };
    $java.jt_DecimalFormat$CurrencyField_hashCode = function($this) {
        return 0;
    };
    $java.jt_DecimalFormat$PercentField = $rt_classWithoutFields();
    $java.jt_DecimalFormat$PercentField_equals = function($this, $obj) {
        return $obj instanceof $java.jt_DecimalFormat$PercentField;
    };
    $java.jt_DecimalFormat$PercentField_hashCode = function($this) {
        return 1;
    };
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_0 = $rt_classWithoutFields();
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        a: {
            var$1 = var$1;
            if (var$1 !== null) {
                var$2 = var$1.$_10;
                var$1 = var$1.$_20;
                if (var$2 instanceof oncie_Variable) {
                    var$2 = var$2;
                    if (var$1 instanceof oncie_Variable) {
                        b: {
                            c: {
                                d: {
                                    var$2 = var$2.$name4;
                                    var$1 = var$1.$name4;
                                    if (var$2 !== null) {
                                        if (jl_String_equals(var$2, var$1))
                                            break d;
                                        else
                                            break c;
                                    }
                                    if (var$1 !== null)
                                        break c;
                                }
                                var$3 = 0;
                                break b;
                            }
                            var$3 = 1;
                        }
                        break a;
                    }
                }
            }
            var$3 = 1;
        }
        return jl_Boolean_valueOf(var$3);
    };
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_1 = function() {
        jl_Object.call(this);
        this.$_0439 = null;
    };
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = onciu_Foldable_folder$(var$0.$_0439);
        sr_ClassTag$_$callClinit();
        return jl_Boolean_valueOf((onciu_Foldable$Folder_findAllByClass(var$2, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_LogicalVariable)))).$contains0(var$1));
    };
    $java.oncias_SemanticCheck$$nestedCheck$lambda$_11_0 = function() {
        jl_Object.call(this);
        this.$_0368 = null;
    };
    $java.oncias_SemanticCheck$$nestedCheck$lambda$_11_0_apply = function(var$0, var$1) {
        return var$0.$_0368.$apply2();
    };
    $java.scm_ArraySeq = $rt_classWithoutFields(scm_AbstractSeq);
    $java.scm_ArraySeq_distinctBy = function($this, $f) {
        return sc_StrictOptimizedSeqOps_distinctBy$($this, $f);
    };
    $java.scm_ArraySeq_prepended = function($this, $elem) {
        return sc_StrictOptimizedSeqOps_prepended$($this, $elem);
    };
    $java.scm_ArraySeq_appended = function($this, $elem) {
        return sc_StrictOptimizedSeqOps_appended$($this, $elem);
    };
    $java.scm_ArraySeq_appendedAll = function($this, $suffix) {
        return sc_StrictOptimizedSeqOps_appendedAll$($this, $suffix);
    };
    $java.scm_ArraySeq_map = function($this, $f) {
        return sc_StrictOptimizedIterableOps_map$($this, $f);
    };
    $java.scm_ArraySeq_flatMap = function($this, $f) {
        return sc_StrictOptimizedIterableOps_flatMap$($this, $f);
    };
    $java.scm_ArraySeq_flatten = function($this, $toIterableOnce) {
        return sc_StrictOptimizedIterableOps_flatten$($this, $toIterableOnce);
    };
    $java.scm_ArraySeq_filter = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filter$($this, $pred);
    };
    $java.scm_ArraySeq_filterNot = function($this, $pred) {
        return sc_StrictOptimizedIterableOps_filterNot$($this, $pred);
    };
    $java.scm_ArraySeq_filterImpl = function($this, $pred, $isFlipped) {
        return sc_StrictOptimizedIterableOps_filterImpl$($this, $pred, $isFlipped);
    };
    $java.scm_ArraySeq_stringPrefix = function($this) {
        return $rt_s(193);
    };
    $java.scm_ArraySeq_reverseIterator = function($this) {
        return sc_IndexedSeqOps_reverseIterator$($this);
    };
    $java.scm_ArraySeq_view = function($this) {
        return sc_IndexedSeqOps_view$($this);
    };
    $java.scm_ArraySeq_reversed = function($this) {
        return sc_IndexedSeqOps_reversed$($this);
    };
    $java.scm_ArraySeq_head = function($this) {
        return sc_IndexedSeqOps_head$($this);
    };
    $java.scm_ArraySeq_headOption = function($this) {
        return sc_IndexedSeqOps_headOption$($this);
    };
    $java.scm_ArraySeq_lengthCompare = function($this, $len) {
        return sc_IndexedSeqOps_lengthCompare$($this, $len);
    };
    $java.scm_ArraySeq_knownSize = function($this) {
        return $this.$length();
    };
    $java.scm_ArraySeq_iterableFactory = function($this) {
        return $java.scm_ArraySeq$_untagged;
    };
    $java.scm_ArraySeq_fromSpecific = function($this, $coll) {
        var $make_evidence$1, $b, $s;
        a: {
            $make_evidence$1 = $this.$elemTag();
            $b = $make_evidence$1.$runtimeClass();
            if (jl_Object_equals($rt_cls($rt_bytecls()), $b)) {
                $b = new scm_ArrayBuilder$ofByte;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_shortcls()), $b)) {
                $b = new scm_ArrayBuilder$ofShort;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_charcls()), $b)) {
                $b = new scm_ArrayBuilder$ofChar;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_intcls()), $b)) {
                $b = new scm_ArrayBuilder$ofInt;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_longcls()), $b)) {
                $b = new scm_ArrayBuilder$ofLong;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_floatcls()), $b)) {
                $b = new scm_ArrayBuilder$ofFloat;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_doublecls()), $b)) {
                $b = new scm_ArrayBuilder$ofDouble;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_booleancls()), $b)) {
                $b = new scm_ArrayBuilder$ofBoolean;
                scm_ArrayBuilder__init_($b);
                break a;
            }
            if (!jl_Object_equals($rt_cls($rt_voidcls()), $b)) {
                $b = scm_ArrayBuilder$ofRef__init_($make_evidence$1);
                break a;
            }
            $b = new scm_ArrayBuilder$ofUnit;
            scm_ArrayBuilder__init_($b);
        }
        $s = $coll.$knownSize();
        if ($s > 0)
            scm_ArrayBuilder_sizeHint($b, $s);
        $b.$addAll0($coll);
        return $java.scm_ArraySeq$_make($java.scm_ArraySeq$_MODULE$, $b.$result0());
    };
    $java.scm_ArraySeq_newSpecificBuilder = function($this) {
        return $java.scm_ArraySeq$_newBuilder($java.scm_ArraySeq$_MODULE$, $this.$elemTag());
    };
    $java.scm_ArraySeq_className = function($this) {
        return $rt_s(195);
    };
    $java.scm_ArraySeq_copyToArray = function($this, $xs, $start, $len) {
        var $elemsToCopyToArray_srcLen, $elemsToCopyToArray_destLen, $copied;
        $elemsToCopyToArray_srcLen = $this.$length();
        $elemsToCopyToArray_destLen = jlr_Array_getLength($xs);
        $copied = jl_Math_max(jl_Math_min(jl_Math_min($len, $elemsToCopyToArray_srcLen), $elemsToCopyToArray_destLen - $start | 0), 0);
        if ($copied > 0)
            s_Array$_copy(s_Array$_MODULE$, $this.$array7(), 0, $xs, $start, $copied);
        return $copied;
    };
    $java.scm_ArraySeq_equals = function($this, $other) {
        var var$2;
        if ($other instanceof $java.scm_ArraySeq) {
            var$2 = $other;
            if (jlr_Array_getLength($this.$array7()) != jlr_Array_getLength(var$2.$array7()))
                return 0;
        }
        return sc_Seq_equals$($this, $other);
    };
    $java.scm_ArraySeq_fromSpecific0 = function($this, $coll) {
        return $java.scm_ArraySeq_fromSpecific($this, $coll);
    };
    $java.scm_ArraySeq_fromSpecific1 = function($this, $coll) {
        return $java.scm_ArraySeq_fromSpecific($this, $coll);
    };
    $java.scm_ArraySeq_iterableFactory0 = function($this) {
        return $java.scm_ArraySeq_iterableFactory($this);
    };
    function scm_ArraySeq$ofChar() {
        $java.scm_ArraySeq.call(this);
        this.$array8 = null;
    }
    function scm_ArraySeq$ofChar__init_(var_0) {
        var var_1 = new scm_ArraySeq$ofChar();
        $java.scm_ArraySeq$ofChar__init_(var_1, var_0);
        return var_1;
    }
    $java.scm_ArraySeq$ofChar_length = function($this) {
        return $this.$array8.data.length;
    };
    $java.scm_ArraySeq$ofChar_apply = function($this, $index) {
        return $this.$array8.data[$index];
    };
    $java.scm_ArraySeq$ofChar_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mCc$sp(suh_MurmurHash3$_MODULE$, $this.$array8);
    };
    $java.scm_ArraySeq$ofChar_equals = function($this, $that) {
        if (!($that instanceof scm_ArraySeq$ofChar))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals2($this.$array8, $that.$array8);
    };
    $java.scm_ArraySeq$ofChar_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcC$sp__init_($this.$array8);
    };
    function scm_ArraySeq$ofChar_addString($this, $sb, $start, $sep, $end) {
        var $jsb, $len, $i;
        $jsb = $sb.$underlying;
        if (jl_String_length($start))
            jl_AbstractStringBuilder_append1($jsb, $start);
        a: {
            $len = $this.$array8.data.length;
            if ($len) {
                if (jl_String_isEmpty($sep))
                    jl_AbstractStringBuilder_append5($jsb, $this.$array8);
                else {
                    jl_AbstractStringBuilder_ensureCapacity($jsb, (($jsb.$length0 + $len | 0) + jl_String_length($end) | 0) + $rt_imul($len - 1 | 0, jl_String_length($sep)) | 0);
                    jl_AbstractStringBuilder_append($jsb, $this.$array8.data[0]);
                    $i = 1;
                    while (true) {
                        if ($i >= $len)
                            break a;
                        jl_AbstractStringBuilder_append1($jsb, $sep);
                        jl_AbstractStringBuilder_append($jsb, $this.$array8.data[$i]);
                        $i = $i + 1 | 0;
                    }
                }
            }
        }
        if (jl_String_length($end))
            jl_AbstractStringBuilder_append1($jsb, $end);
        return $sb;
    }
    $java.scm_ArraySeq$ofChar_apply0 = function($this, $v1) {
        return jl_Character_valueOf($java.scm_ArraySeq$ofChar_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofChar_apply1 = function($this, $i) {
        return jl_Character_valueOf($java.scm_ArraySeq$ofChar_apply($this, $i));
    };
    $java.scm_ArraySeq$ofChar_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Char0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofChar_array = function($this) {
        return $this.$array8;
    };
    $java.scm_ArraySeq$ofChar__init_ = function($this, $array) {
        $this.$array8 = $array;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck = $rt_classWithoutFields(0);
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper = function() {
        jl_Object.call(this);
        this.$check4 = null;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productPrefix = function($this) {
        return $rt_s(2723);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productArity = function($this) {
        return 1;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$check4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$check4;
                        $x$1 = $x$1.$check4;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncias_SemanticCheck$Map() {
        var a = this; jl_Object.call(a);
        a.$check0 = null;
        a.$f5 = null;
    }
    $java.oncias_SemanticCheck$Map_chain = function($this, $next) {
        return oncias_SemanticCheck_chain$($this, $next);
    };
    $java.oncias_SemanticCheck$Map_map = function($this, $f) {
        return oncias_SemanticCheck_map$($this, $f);
    };
    $java.oncias_SemanticCheck$Map_flatMap = function($this, $f) {
        return oncias_SemanticCheck_flatMap$($this, $f);
    };
    $java.oncias_SemanticCheck$Map_productPrefix = function($this) {
        return $rt_s(388);
    };
    $java.oncias_SemanticCheck$Map_productArity = function($this) {
        return 2;
    };
    $java.oncias_SemanticCheck$Map_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$check0;
            case 1:
                return $this.$f5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheck$Map_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$Map_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$Map_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$Map_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_SemanticCheck$Map) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$check0;
                            var$3 = $x$1.$check0;
                            if (var$2 !== null) {
                                if (!var$2.$equals(var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$f5;
                        $x$1 = $x$1.$f5;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map = function() {
        jl_Object.call(this);
        this.$f12 = null;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productPrefix = function($this) {
        return $rt_s(388);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productArity = function($this) {
        return 1;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$f12;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$f12;
                        $x$1 = $x$1.$f12;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap = function() {
        jl_Object.call(this);
        this.$f13 = null;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productPrefix = function($this) {
        return $rt_s(2099);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productArity = function($this) {
        return 1;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$f13;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$f13;
                        $x$1 = $x$1.$f13;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncias_SemanticCheck$CheckFromContext = function() {
        jl_Object.call(this);
        this.$f11 = null;
    };
    $java.oncias_SemanticCheck$CheckFromContext_chain = function($this, $next) {
        return oncias_SemanticCheck_chain$($this, $next);
    };
    $java.oncias_SemanticCheck$CheckFromContext_map = function($this, $f) {
        return oncias_SemanticCheck_map$($this, $f);
    };
    $java.oncias_SemanticCheck$CheckFromContext_flatMap = function($this, $f) {
        return oncias_SemanticCheck_flatMap$($this, $f);
    };
    $java.oncias_SemanticCheck$CheckFromContext_productPrefix = function($this) {
        return $rt_s(2724);
    };
    $java.oncias_SemanticCheck$CheckFromContext_productArity = function($this) {
        return 1;
    };
    $java.oncias_SemanticCheck$CheckFromContext_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$f11;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheck$CheckFromContext_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$CheckFromContext_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$CheckFromContext_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheck$CheckFromContext_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncias_SemanticCheck$CheckFromContext) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$f11;
                        $x$1 = $x$1.$f11;
                        if (var$2 !== null) {
                            if (!jl_Object_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncias_SemanticCheck$Annotated = $rt_classWithoutFields();
    var oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$ = $rt_classWithoutFields();
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_MODULE$ = null;
    function oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$__clinit_() {
        $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_MODULE$ = new oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$;
    }
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_productArity = function($this) {
        return 0;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_hashCode = function($this) {
        return 489207872;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_toString = function($this) {
        return $rt_s(2725);
    };
    var oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$ = $rt_classWithoutFields();
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_MODULE$ = null;
    function oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$__clinit_() {
        $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_MODULE$ = new oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$;
    }
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_productArity = function($this) {
        return 0;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_hashCode = function($this) {
        return 1210398295;
    };
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_toString = function($this) {
        return $rt_s(2726);
    };
    $java.oncia_PrivilegeCommand$privilegeQualifierCheckForPropertyRules$lambda$_61_0 = function() {
        jl_Object.call(this);
        this.$_0412 = null;
    };
    $java.oncia_PrivilegeCommand$privilegeQualifierCheckForPropertyRules$lambda$_61_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = var$0.$_0412;
        if (!(var$2 instanceof oncia_PatternQualifier))
            var$2 = oncias_SemanticCheck$_success;
        else {
            var$2 = var$2;
            var$4 = var$2.$variable42;
            var$5 = var$2.$expression14;
            var$6 = var$3.$featureCheck;
            var$2 = oncias_OptionSemanticChecking$_MODULE$;
            var$7 = new $java.oncia_PrivilegeCommand$$anonfun$privilegeQualifierCheckForPropertyRules$1$lambda$_67_0;
            var$7.$_0455 = var$3;
            var$6 = oncias_SemanticCheck_chain$(var$6, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$2, var$4, var$7));
            oncias_SemanticExpressionCheck$_$callClinit();
            var$6 = oncias_SemanticCheck_chain$(var$6, oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, oncie_Expression$SemanticContext$Results$_MODULE$, var$5));
            var$2 = var$3.$privilege1;
            if (!(var$2 instanceof oncia_GraphPrivilege))
                var$2 = oncias_SemanticAnalysisTooling_error$(var$3, $rt_s(2727), var$3.$position119);
            else {
                var$7 = var$2.$action0;
                if (jl_Object_equals(oncia_ReadAction$_MODULE$, var$7) ? 1 : jl_Object_equals(oncia_TraverseAction$_MODULE$, var$7) ? 1 : !jl_Object_equals(oncia_MatchAction$_MODULE$, var$7) ? 0 : 1)
                    var$2 = oncias_SemanticCheck$_success;
                else {
                    var$7 = var$7.$name21;
                    var$2 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$2);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$7), $rt_s(2728));
                    var$2 = oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$2), var$3.$position119);
                }
            }
            var$2 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$6, var$2), $java.oncia_PrivilegeCommand_checkExpression(var$3, var$5));
        }
        return var$1.$chain(var$2);
    };
    $java.sci_ListSet$Node$removeInternal$lambda$_9_0 = $rt_classWithoutFields();
    $java.sci_ListSet$Node$removeInternal$lambda$_9_0_apply = function(var$0, var$1, var$2) {
        var$1 = var$1;
        var$2 = var$2;
        return sci_ListSet$Node__init_(var$1, var$2.$elem7());
    };
    function sc_MapOps$$anon$1() {
        sc_AbstractIterable.call(this);
        this.$$outer5 = null;
    }
    $java.sc_MapOps$$anon$1_knownSize = function($this) {
        return $this.$$outer5.$knownSize();
    };
    $java.sc_MapOps$$anon$1_iterator = function($this) {
        return $this.$$outer5.$valuesIterator();
    };
    function sc_Iterator$contains$lambda$_35_0() {
        jl_Object.call(this);
        this.$_0155 = null;
    }
    $java.sc_Iterator$contains$lambda$_35_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(!sr_BoxesRunTime_equals(var$1, var$0.$_0155) ? 0 : 1);
    };
    var oncief_UnresolvedFunction$ = $rt_classWithoutFields($java.oncief_Function);
    $java.oncief_UnresolvedFunction$_MODULE$ = null;
    function oncief_UnresolvedFunction$__clinit_() {
        var var$1;
        var$1 = new oncief_UnresolvedFunction$;
        $java.oncief_Function__init_(var$1);
        $java.oncief_UnresolvedFunction$_MODULE$ = var$1;
    }
    $java.oncief_UnresolvedFunction$_name = function($this) {
        return $rt_s(2729);
    };
    $java.oncief_UnresolvedFunction$_productArity = function($this) {
        return 0;
    };
    $java.oncief_UnresolvedFunction$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncief_UnresolvedFunction$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncief_UnresolvedFunction$_hashCode = function($this) {
        return 933205161;
    };
    $java.oncief_UnresolvedFunction$_toString = function($this) {
        return $rt_s(2730);
    };
    $java.scc_JavaCollectionWrappers$SetWrapper = $rt_classWithoutFields(ju_AbstractSet);
    var scc_JavaCollectionWrappers$MutableSetWrapper = $rt_classWithoutFields($java.scc_JavaCollectionWrappers$SetWrapper);
    function scc_JavaCollectionWrappers$JSetWrapper() {
        scm_AbstractSet.call(this);
        this.$underlying16 = null;
    }
    $java.scc_JavaCollectionWrappers$JSetWrapper_knownSize = function($this) {
        if (!$java.ju_HashMap_isEmpty($this.$underlying16.$backingMap))
            return (-1);
        return 0;
    };
    $java.scc_JavaCollectionWrappers$JSetWrapper_iterator = function($this) {
        return scc_AsScalaExtensions$IteratorHasAsScala_asScala(scc_AsScalaExtensions$IteratorHasAsScala__init_(sj_CollectionConverters$_MODULE$, ju_HashSet_iterator($this.$underlying16)));
    };
    $java.oncias_SemanticCheckInterpreter$$printAnnotations$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncias_SemanticCheckInterpreter$$printAnnotations$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$3 = s_Tuple2__2$mcI$sp(var$1);
        s_Predef$_$callClinit();
        var$1 = s_Predef$_MODULE$;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(var$4, 91);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(var$4, var$3), $rt_s(2731)), var$2);
        s_Predef$_println(var$1, jl_AbstractStringBuilder_toString(var$4));
        return sr_BoxedUnit_UNIT;
    };
    $java.oncifp_AmbiguousAggregationAnalysis$$anonfun$1$$anonfun$applyOrElse$1$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0443 = null;
    };
    $java.oncifp_AmbiguousAggregationAnalysis$$anonfun$1$$anonfun$applyOrElse$1$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = sc_AbstractIterable_toSet(((var$0.$_0443.$returnItems0()).$items.$filter1(new $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_0)).$map1(new $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_1));
        if (!sc_IterableOnceOps_nonEmpty$(var$2))
            var$1 = s_None$_MODULE$;
        else {
            var$3 = var$1.$sortItems;
            var$1 = new $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_2;
            var$1.$_0456 = var$2;
            var$3 = var$3.$flatMap(var$1);
            if (!sc_IterableOnceOps_nonEmpty$(var$3))
                var$1 = s_None$_MODULE$;
            else {
                var$1 = new s_Some;
                var$2 = new oncias_SemanticError;
                var$4 = sc_AbstractIterable_mkString0(var$3.$map1(new $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_3), $rt_s(16));
                var$5 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$5);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(2732)), var$4), $rt_s(2733));
                oncias_SemanticError__init_(var$2, jl_AbstractStringBuilder_toString(var$5), (var$3.$head()).$position2());
                s_Some__init_0(var$1, var$2);
            }
        }
        return var$1;
    };
    var sci_MapOps$removedAll$lambda$_7_0 = $rt_classWithoutFields();
    $java.sci_MapOps$removedAll$lambda$_7_0_apply = function(var$0, var$1, var$2) {
        return var$1.$removed(var$2);
    };
    function sc_MapOps$concat$lambda$_45_0() {
        jl_Object.call(this);
        this.$_056 = null;
    }
    $java.sc_MapOps$concat$lambda$_45_0_apply = function(var$0) {
        return var$0.$_056.$iterator0();
    };
    var oncias_SemanticExpressionCheck$ = $rt_classWithoutFields();
    var oncias_SemanticExpressionCheck$_MODULE$ = null;
    $java.oncias_SemanticExpressionCheck$_crashOnUnknownExpression = null;
    $java.oncias_SemanticExpressionCheck$_semanticCheckFallback = null;
    $java.oncias_SemanticExpressionCheck$_stringifier = null;
    function oncias_SemanticExpressionCheck$_$callClinit() {
        oncias_SemanticExpressionCheck$_$callClinit = $rt_eraseClinit(oncias_SemanticExpressionCheck$);
        $java.oncias_SemanticExpressionCheck$__clinit_();
    }
    $java.oncias_SemanticExpressionCheck$__clinit_ = function() {
        var var$1;
        var$1 = new oncias_SemanticExpressionCheck$;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncias_SemanticExpressionCheck$_MODULE$ = var$1;
        var$1 = new $java.oncias_SemanticExpressionCheck$$_clinit_$lambda$_0_0;
        $java.oncias_SemanticExpressionCheck$_crashOnUnknownExpression = var$1;
        $java.oncias_SemanticExpressionCheck$_semanticCheckFallback = var$1;
        $java.oncias_SemanticExpressionCheck$_stringifier = onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_ExpressionStringifier$_failingExtender, 0, 0, 0, 0);
    };
    $java.oncias_SemanticExpressionCheck$_specifyType = function($this, $typeGen, $expression) {
        return oncias_SemanticAnalysisTooling_specifyType$($this, $typeGen, $expression);
    };
    $java.oncias_SemanticExpressionCheck$_specifyType0 = function($this, $possibleTypes, $expression) {
        return oncias_SemanticAnalysisTooling_specifyType$0($this, $possibleTypes, $expression);
    };
    $java.oncias_SemanticExpressionCheck$_expectType = function($this, $typeGen, $expression) {
        var var$3, var$4;
        var$3 = oncias_package$_MODULE$;
        var$4 = new $java.oncias_SemanticAnalysisTooling$expectType$lambda$_11_0;
        var$4.$_0457 = $this;
        var$4.$_1138 = $typeGen;
        var$4.$_253 = $expression;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$3, var$4);
    };
    $java.oncias_SemanticExpressionCheck$_expectType0 = function($this, $possibleTypes, $opt) {
        return oncias_SemanticAnalysisTooling_expectType$($this, $possibleTypes, $opt);
    };
    $java.oncias_SemanticExpressionCheck$_expectType1 = function($this, $typeGen, $expression, $messageGen) {
        var var$4, var$5;
        var$4 = oncias_package$_MODULE$;
        var$5 = new $java.oncias_SemanticAnalysisTooling$expectType$lambda$_15_0;
        var$5.$_0458 = $this;
        var$5.$_1139 = $typeGen;
        var$5.$_254 = $expression;
        var$5.$_311 = $messageGen;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5);
    };
    $java.oncias_SemanticExpressionCheck$_expectType2 = function($this, $possibleTypes, $expression) {
        return oncias_SemanticAnalysisTooling_expectType$1($this, $possibleTypes, $expression);
    };
    $java.oncias_SemanticExpressionCheck$_expectType3 = function($this, $possibleTypes, $expression, $messageGen) {
        var var$4, var$5;
        var$4 = oncias_package$_MODULE$;
        var$5 = new $java.oncias_SemanticAnalysisTooling$expectType$lambda$_23_0;
        var$5.$_0459 = $this;
        var$5.$_1140 = $possibleTypes;
        var$5.$_255 = $expression;
        var$5.$_312 = $messageGen;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5);
    };
    $java.oncias_SemanticExpressionCheck$_expectType4 = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncias_SemanticExpressionCheck$_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncias_SemanticExpressionCheck$_checkTypes = function($this, $expression, $signatures) {
        return oncias_SemanticAnalysisTooling_checkTypes$($this, $expression, $signatures);
    };
    $java.oncias_SemanticExpressionCheck$_unionOfTypes = function($this, $iterable) {
        return oncias_SemanticAnalysisTooling_unionOfTypes$($this, $iterable);
    };
    $java.oncias_SemanticExpressionCheck$_withScopedState = function($this, $check) {
        return oncias_SemanticAnalysisTooling_withScopedState$($this, $check);
    };
    $java.oncias_SemanticExpressionCheck$_typeSwitch = function($this, $expr, $choice) {
        var var$3, var$4;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = new $java.oncias_SemanticAnalysisTooling$typeSwitch$lambda$_47_0;
        var$4.$_0460 = $choice;
        var$4.$_1141 = $expr;
        return oncias_SemanticCheck$_fromState(var$3, var$4);
    };
    $java.oncias_SemanticExpressionCheck$_validNumber = function($this, $long) {
        var var$2, $$je;
        a: {
            try {
                var$2 = $long.$value26() instanceof jl_Long;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_NumberFormatException) {
                } else {
                    throw $$e;
                }
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncias_SemanticExpressionCheck$_validNumber0 = function($this, $double) {
        var var$2, $$je;
        a: {
            try {
                var$2 = $java.oncie_DecimalDoubleLiteral_value($double) instanceof jl_Double;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_NumberFormatException) {
                } else {
                    throw $$e;
                }
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncias_SemanticExpressionCheck$_ensureDefined = function($this, $v) {
        return oncias_SemanticAnalysisTooling_ensureDefined$($this, $v);
    };
    $java.oncias_SemanticExpressionCheck$_types = function($this, $expression) {
        return oncias_SemanticAnalysisTooling_types$($this, $expression);
    };
    $java.oncias_SemanticExpressionCheck$_semanticCheckFallback0 = function($this) {
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncias_SemanticExpressionCheck$_semanticCheckFallback;
    };
    $java.oncias_SemanticExpressionCheck$_simple = function($this, $expression) {
        return oncias_SemanticExpressionCheck$_check($this, $java.oncie_Expression$SemanticContext$Simple$_MODULE$, $expression);
    };
    function oncias_SemanticExpressionCheck$_check($this, $ctx, $expression) {
        var var$3, var$4;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = new $java.oncias_SemanticExpressionCheck$$check$lambda$_44_0;
        var$4.$_0461 = $expression;
        var$4.$_1142 = $ctx;
        return oncias_SemanticCheck$_nestedCheck(var$3, var$4);
    }
    $java.oncias_SemanticExpressionCheck$_stringifier0 = function($this) {
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncias_SemanticExpressionCheck$_stringifier;
    };
    $java.oncias_SemanticExpressionCheck$_checkLabelExpressionForLegacyRelationshipTypeDisjunction = function($this, $entity, $labelExpression) {
        var var$3, var$4, var$5, var$6;
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = $labelExpression.$folder();
        sr_ClassTag$_$callClinit();
        var$5 = onciu_Foldable$Folder_treeFindByClass(var$4, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncil_LabelExpression$ColonDisjunction)));
        var$6 = new $java.oncias_SemanticExpressionCheck$$checkLabelExpressionForLegacyRelationshipTypeDisjunction$lambda$_46_0;
        var$6.$_0462 = $entity;
        var$6.$_1143 = $labelExpression;
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, var$5, var$6);
    };
    $java.oncias_SemanticExpressionCheck$_checkLabelExpression = function($this, $entityType, $labelExpression) {
        var $colonConjunctions$lzy, $colonDisjunctions$lzy, $legacySymbols$lzy, var$6, var$7, var$8;
        $colonConjunctions$lzy = new $java.sr_LazyRef;
        $colonDisjunctions$lzy = new $java.sr_LazyRef;
        $legacySymbols$lzy = new $java.sr_LazyRef;
        var$6 = oncias_SemanticCheck$_MODULE$;
        var$7 = s_Option_contains($entityType, oncie_NODE_TYPE$_MODULE$) && sc_IterableOnceOps_nonEmpty$($java.oncias_SemanticExpressionCheck$_colonDisjunctions$1($colonDisjunctions$lzy, $labelExpression)) ? 1 : 0;
        var$8 = new $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_0;
        var$8.$_0463 = $colonDisjunctions$lzy;
        var$8.$_1144 = $labelExpression;
        var$8 = oncias_SemanticCheck$_when(var$6, var$7, var$8);
        var$6 = oncias_SemanticCheck$_MODULE$;
        var$7 = s_Option_contains($entityType, oncie_RELATIONSHIP_TYPE$_MODULE$) && sc_IterableOnceOps_nonEmpty$($java.oncias_SemanticExpressionCheck$_colonConjunctions$1($colonConjunctions$lzy, $labelExpression)) ? 1 : 0;
        $entityType = new $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_1;
        $entityType.$_0464 = $colonConjunctions$lzy;
        $entityType.$_1145 = $labelExpression;
        $entityType = var$8.$chain(oncias_SemanticCheck$_when(var$6, var$7, $entityType));
        var$8 = new $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_2;
        var$8.$_0465 = $labelExpression;
        var$8.$_1146 = $colonConjunctions$lzy;
        var$8.$_256 = $legacySymbols$lzy;
        var$8.$_313 = $colonDisjunctions$lzy;
        var$8 = oncias_SemanticCheck_ifOkChain$($entityType, var$8);
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(var$8, $java.oncias_SemanticPatternCheck$_checkValidLabels(oncias_SemanticPatternCheck$_MODULE$, $labelExpression.$flatten0(), $labelExpression.$position2()));
    };
    $java.oncias_SemanticExpressionCheck$_simple0 = function($this, $iterable) {
        return $java.oncias_SemanticExpressionCheck$_check($this, $java.oncie_Expression$SemanticContext$Simple$_MODULE$, $iterable);
    };
    $java.oncias_SemanticExpressionCheck$_check = function($this, $ctx, $iterable) {
        var var$3;
        var$3 = new $java.oncias_SemanticExpressionCheck$$check$lambda$_49_0;
        var$3.$_0466 = $ctx;
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $iterable, var$3);
    };
    $java.oncias_SemanticExpressionCheck$_simple1 = function($this, $option) {
        return $java.oncias_SemanticExpressionCheck$_check0($this, $java.oncie_Expression$SemanticContext$Simple$_MODULE$, $option);
    };
    $java.oncias_SemanticExpressionCheck$_check0 = function($this, $ctx, $option) {
        var var$3, var$4;
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = new $java.oncias_SemanticExpressionCheck$$check$lambda$_51_0;
        var$4.$_0467 = $ctx;
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, $option, var$4);
    };
    $java.oncias_SemanticExpressionCheck$_checkAddBoundary = function($this, $add) {
        var $r, $l, var$4, var$5, var$6;
        $r = s_Tuple2__init_($add.$lhs17, $add.$rhs18);
        $l = $r.$_10;
        $r = $r.$_20;
        if ($rt_isInstance($l, $java.oncie_IntegerLiteral)) {
            $l = $l;
            if ($rt_isInstance($r, $java.oncie_IntegerLiteral)) {
                $r = $r;
                var$4 = $java.onciuh_Try$_MODULE$;
                var$5 = new $java.oncias_SemanticExpressionCheck$$checkAddBoundary$lambda$_52_0;
                var$5.$_0468 = $l;
                var$5.$_1147 = $r;
                if (($java.onciuh_Try$_apply(var$4, var$5)).$isFailure()) {
                    var$4 = oncias_package$_MODULE$;
                    var$5 = new oncias_SemanticError;
                    $l = $l.$stringVal1();
                    $r = $r.$stringVal1();
                    var$6 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$6);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(2734)), $l), $rt_s(2735)), $r), $rt_s(2736));
                    oncias_SemanticError__init_(var$5, jl_AbstractStringBuilder_toString(var$6), $add.$position240);
                    return oncias_package$_liftSemanticErrorDef(var$4, var$5);
                }
            }
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticExpressionCheck$_checkSubtractBoundary = function($this, $subtract) {
        var $r, $l, var$4, var$5, var$6;
        $r = s_Tuple2__init_($subtract.$lhs18, $subtract.$rhs19);
        $l = $r.$_10;
        $r = $r.$_20;
        if ($rt_isInstance($l, $java.oncie_IntegerLiteral)) {
            $l = $l;
            if ($rt_isInstance($r, $java.oncie_IntegerLiteral)) {
                $r = $r;
                var$4 = $java.onciuh_Try$_MODULE$;
                var$5 = new $java.oncias_SemanticExpressionCheck$$checkSubtractBoundary$lambda$_53_0;
                var$5.$_0469 = $l;
                var$5.$_1148 = $r;
                if (($java.onciuh_Try$_apply(var$4, var$5)).$isFailure()) {
                    var$4 = oncias_package$_MODULE$;
                    var$5 = new oncias_SemanticError;
                    $l = $l.$stringVal1();
                    $r = $r.$stringVal1();
                    var$6 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$6);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(2734)), $l), $rt_s(2737)), $r), $rt_s(2736));
                    oncias_SemanticError__init_(var$5, jl_AbstractStringBuilder_toString(var$6), $subtract.$position241);
                    return oncias_package$_liftSemanticErrorDef(var$4, var$5);
                }
            }
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticExpressionCheck$_checkUnarySubtractBoundary = function($this, $subtract) {
        var var$2, var$3, var$4, var$5;
        var$2 = $subtract.$rhs20;
        if ($rt_isInstance(var$2, $java.oncie_IntegerLiteral)) {
            var$2 = var$2;
            var$3 = $java.onciuh_Try$_MODULE$;
            var$4 = new $java.oncias_SemanticExpressionCheck$$checkUnarySubtractBoundary$lambda$_54_0;
            var$4.$_0470 = var$2;
            if (($java.onciuh_Try$_apply(var$3, var$4)).$isFailure()) {
                var$3 = oncias_package$_MODULE$;
                var$4 = new oncias_SemanticError;
                var$2 = var$2.$stringVal1();
                var$5 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$5);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(2738)), var$2), $rt_s(2736));
                oncias_SemanticError__init_(var$4, jl_AbstractStringBuilder_toString(var$5), $subtract.$position242);
                return oncias_package$_liftSemanticErrorDef(var$3, var$4);
            }
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticExpressionCheck$_checkMultiplyBoundary = function($this, $multiply) {
        var $r, $l, var$4, var$5, var$6;
        $r = s_Tuple2__init_($multiply.$lhs19, $multiply.$rhs21);
        $l = $r.$_10;
        $r = $r.$_20;
        if ($rt_isInstance($l, $java.oncie_IntegerLiteral)) {
            $l = $l;
            if ($rt_isInstance($r, $java.oncie_IntegerLiteral)) {
                $r = $r;
                var$4 = $java.onciuh_Try$_MODULE$;
                var$5 = new $java.oncias_SemanticExpressionCheck$$checkMultiplyBoundary$lambda$_55_0;
                var$5.$_0471 = $l;
                var$5.$_1149 = $r;
                if (($java.onciuh_Try$_apply(var$4, var$5)).$isFailure()) {
                    var$4 = oncias_package$_MODULE$;
                    var$5 = new oncias_SemanticError;
                    $l = $l.$stringVal1();
                    $r = $r.$stringVal1();
                    var$6 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$6);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(2734)), $l), $rt_s(2739)), $r), $rt_s(2736));
                    oncias_SemanticError__init_(var$5, jl_AbstractStringBuilder_toString(var$6), $multiply.$position243);
                    return oncias_package$_liftSemanticErrorDef(var$4, var$5);
                }
            }
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticExpressionCheck$_infixAddRhsTypes = function($this, $lhs) {
        var var$2;
        var$2 = new $java.oncias_SemanticExpressionCheck$$infixAddRhsTypes$lambda$_56_0;
        var$2.$_0472 = $lhs;
        return var$2;
    };
    $java.oncias_SemanticExpressionCheck$_infixAddOutputTypes = function($this, $lhs, $rhs) {
        var var$3;
        var$3 = new $java.oncias_SemanticExpressionCheck$$infixAddOutputTypes$lambda$_57_0;
        var$3.$_0473 = $lhs;
        var$3.$_1150 = $rhs;
        return var$3;
    };
    $java.oncias_SemanticExpressionCheck$_checkInnerListComprehension = function($this, $x) {
        var $e, $outerTypes, var$4;
        $e = $java.oncie_ListComprehension_extractExpression($x);
        if (!($e instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, $e))
                $rt_throw(s_MatchError__init_($e));
            $e = new $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_2;
            $e.$_0474 = $x;
            return oncias_SemanticCheck_chain$(oncias_SemanticAnalysisTooling_withScopedState$($this, $e), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$($this, oncias_SemanticAnalysisTooling_types$($this, $x.$expression15), $x)));
        }
        $e = $e.$value5;
        $outerTypes = new $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_0;
        $outerTypes.$_0475 = $x;
        $outerTypes.$_1151 = $e;
        var$4 = oncias_SemanticAnalysisTooling_withScopedState$($this, $outerTypes);
        $outerTypes = new $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_1;
        $outerTypes.$_0476 = $e;
        return oncias_SemanticCheck_chain$(var$4, $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$($this, $outerTypes, $x)));
    };
    $java.oncias_SemanticExpressionCheck$_checkForShadowedVariables = function($this, $subqueryCallsToFilter) {
        var var$2, var$3;
        var$2 = oncias_package$_MODULE$;
        var$3 = new $java.oncias_SemanticExpressionCheck$$checkForShadowedVariables$lambda$_59_0;
        var$3.$_0477 = $subqueryCallsToFilter;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$3);
    };
    $java.oncias_SemanticExpressionCheck$_possibleTypes$1 = function($x69$1) {
        var var$2;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = new $java.oncias_SemanticExpressionCheck$$possibleTypes$1$lambda$_124_0;
        var$2.$_0478 = $x69$1;
        return var$2;
    };
    $java.oncias_SemanticExpressionCheck$_$anonfun$check$1 = function($expression$1, $ctx$1) {
        var $allowedTypes, $possibleTypes, $lhs, $rhs, $relationship, $relationshipList, $outerTypes, $stringVal;
        oncias_SemanticExpressionCheck$_$callClinit();
        if ($expression$1 instanceof oncie_Add) {
            $expression$1 = $expression$1;
            $ctx$1 = $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Add_lhs($expression$1)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0__init_(), $java.oncie_Add_lhs($expression$1))), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1,
            $java.oncie_Add_rhs($expression$1)));
            $allowedTypes = oncias_SemanticExpressionCheck$_MODULE$;
            $ctx$1 = $java.oncias_SemanticCheck$FlatMap_chain($ctx$1, $java.oncias_SemanticExpressionCheck$_expectType($allowedTypes, $java.oncias_SemanticExpressionCheck$_infixAddRhsTypes($allowedTypes, $java.oncie_Add_lhs($expression$1)), $java.oncie_Add_rhs($expression$1)));
            $allowedTypes = oncias_package$_MODULE$;
            $possibleTypes = oncias_SemanticExpressionCheck$_MODULE$;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($ctx$1, $java.oncias_package$_liftSemanticEitherFunc($allowedTypes, $java.oncias_SemanticExpressionCheck$_specifyType($possibleTypes, $java.oncias_SemanticExpressionCheck$_infixAddOutputTypes($possibleTypes, $java.oncie_Add_lhs($expression$1), $java.oncie_Add_rhs($expression$1)), $expression$1))), $java.oncias_SemanticExpressionCheck$_checkAddBoundary(oncias_SemanticExpressionCheck$_MODULE$, $expression$1));
        }
        if ($expression$1 instanceof oncie_Subtract) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Subtract_signatures($expression$1))), $java.oncias_SemanticExpressionCheck$_checkSubtractBoundary(oncias_SemanticExpressionCheck$_MODULE$, $expression$1));
        }
        if ($expression$1 instanceof oncie_UnarySubtract) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_UnarySubtract_signatures($expression$1))), $java.oncias_SemanticExpressionCheck$_checkUnarySubtractBoundary(oncias_SemanticExpressionCheck$_MODULE$, $expression$1));
        }
        if ($expression$1 instanceof oncie_UnaryAdd) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_UnaryAdd_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Multiply) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Multiply_signatures($expression$1))), $java.oncias_SemanticExpressionCheck$_checkMultiplyBoundary(oncias_SemanticExpressionCheck$_MODULE$, $expression$1));
        }
        if ($expression$1 instanceof oncie_Divide) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Divide_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Modulo) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Modulo_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Pow) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Pow_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Not) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Not_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Equals) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Equals_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_NotEquals) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_NotEquals_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_InvalidNotEquals) {
            $expression$1 = $expression$1;
            return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(2740), $java.oncie_InvalidNotEquals_position($expression$1)));
        }
        if ($expression$1 instanceof oncie_RegexMatch) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_RegexMatch_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_And) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_And_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Or) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Or_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Xor) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Xor_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Ands) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_Ands_exprs($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Ands_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Ors) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$exprs())).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $expression$1.$signatures10()));
        }
        if ($expression$1 instanceof oncie_In) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_In_lhs($expression$1)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1__init_(), $java.oncie_In_lhs($expression$1))), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$,
            $ctx$1, $java.oncie_In_rhs($expression$1))), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2__init_(), $java.oncie_In_rhs($expression$1))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_StartsWith) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_StartsWith_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_EndsWith) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_EndsWith_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_Contains) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_Contains_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_IsNull) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_IsNull_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_IsNotNull) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_IsNotNull_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncia_IsTyped) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncia_CypherTypeName_semanticCheck($java.oncia_CypherTypeName__init_(oncia_IsTyped_typeName($expression$1)))), $java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncia_IsTyped_signatures($expression$1))),
            $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$));
        }
        if ($expression$1 instanceof oncia_IsNotTyped) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncia_CypherTypeName_semanticCheck($java.oncia_CypherTypeName__init_(oncia_IsNotTyped_typeName($expression$1)))), $java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncia_IsNotTyped_signatures($expression$1))),
            $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$));
        }
        if ($expression$1 instanceof oncie_LessThan) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_LessThan_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_LessThanOrEqual) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_LessThanOrEqual_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_GreaterThan) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_GreaterThan_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_GreaterThanOrEqual) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $java.oncie_Expression_arguments($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_checkTypes(oncias_SemanticExpressionCheck$_MODULE$, $expression$1, $java.oncie_GreaterThanOrEqual_signatures($expression$1)));
        }
        if ($expression$1 instanceof oncie_DifferentRelationships) {
            $expression$1 = $expression$1;
            $lhs = $expression$1.$rel1();
            $rhs = $expression$1.$rel2();
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$arguments())).$chain($java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4__init_(), $lhs)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5__init_(),
            $rhs)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_NoneOfRelationships) {
            $expression$1 = $expression$1;
            $relationship = $expression$1.$relationship0();
            $relationshipList = $expression$1.$listOfRelationships();
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$arguments())).$chain($java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7__init_(), $relationship)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8__init_(),
            $relationshipList)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_Disjoint) {
            $expression$1 = $expression$1;
            $lhs = $expression$1.$lhs0();
            $rhs = $expression$1.$rhs0();
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$arguments())).$chain($java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10__init_(), $lhs)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11__init_(),
            $rhs)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_Unique) {
            $expression$1 = $expression$1;
            $rhs = $expression$1.$rhs0();
            return $java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$arguments())).$chain($java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13__init_(), $rhs)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14__init_(), $expression$1)));
        }
        if ($expression$1 instanceof $java.oncie_VarLengthBound) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$arguments())).$chain($java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15__init_(), $expression$1.$relName())), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16__init_(), $expression$1)));
        }
        if ($rt_isInstance($expression$1, $java.oncie_PartialPredicate)) {
            $expression$1 = $expression$1;
            return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$coveredPredicate());
        }
        if ($expression$1 instanceof oncie_CaseExpression) {
            $expression$1 = $expression$1;
            $possibleTypes = $java.oncias_SemanticExpressionCheck$_unionOfTypes(oncias_SemanticExpressionCheck$_MODULE$, $java.oncie_CaseExpression_possibleExpressions($expression$1));
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check0(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_CaseExpression_expression($expression$1))).$chain($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, (oncie_CaseExpression_alternatives($expression$1)).$flatMap($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17__init_()))),
            $java.oncias_SemanticExpressionCheck$_check0(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_CaseExpression_default($expression$1))), oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$, s_Option_isEmpty(oncie_CaseExpression_expression($expression$1)), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18__init_($expression$1))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType(oncias_SemanticExpressionCheck$_MODULE$,
            $possibleTypes, $expression$1)));
        }
        if ($expression$1 instanceof oncie_AndedPropertyInequalities)
            return (($expression$1.$inequalities()).$map5($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_19__init_($ctx$1))).$reduceLeft($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_20__init_());
        if ($expression$1 instanceof oncie_CoerceTo) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$expr0()), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21__init_($expression$1), $expression$1.$expr0()));
        }
        if ($expression$1 instanceof oncie_Property) {
            $expression$1 = $expression$1;
            oncius_package$_$callClinit();
            $allowedTypes = $java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_TypeSpec_$bar($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$))), $java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$))),
            $java.oncius_PointType_covariant($java.oncius_package$_CTPoint0(oncius_package$_MODULE$))), $java.oncius_DateType_covariant($java.oncius_package$_CTDate0(oncius_package$_MODULE$))), $java.oncius_ZonedTimeType_covariant($java.oncius_package$_CTTime0(oncius_package$_MODULE$))), $java.oncius_LocalTimeType_covariant($java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$))), $java.oncius_LocalDateTimeType_covariant($java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$))), $java.oncius_ZonedDateTimeType_covariant($java.oncius_package$_CTDateTime0(oncius_package$_MODULE$))),
            $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)));
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_Property_map($expression$1)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22__init_($allowedTypes), oncie_Property_map($expression$1))), $java.oncias_SemanticExpressionCheck$_typeSwitch(oncias_SemanticExpressionCheck$_MODULE$,
            oncie_Property_map($expression$1), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23__init_($expression$1)));
        }
        if ($expression$1 instanceof $java.oncie_CachedProperty) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24__init_(), $expression$1));
        }
        if ($expression$1 instanceof $java.oncie_CachedHasProperty) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25__init_(), $expression$1));
        }
        if ($expression$1 instanceof oncie_Variable) {
            $expression$1 = $expression$1;
            return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26__init_($expression$1));
        }
        if ($expression$1 instanceof oncie_FunctionInvocation) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticFunctionCheck$_check($java.oncias_SemanticFunctionCheck$_MODULE$, $ctx$1, $expression$1);
        }
        if ($expression$1 instanceof $java.oncie_GetDegree) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$node3()), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27__init_(), $expression$1.$node3())), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28__init_(), $expression$1)));
        }
        if ($rt_isInstance($expression$1, oncie_Parameter)) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29__init_($expression$1), $expression$1));
        }
        if ($expression$1 instanceof $java.oncie_ImplicitProcedureArgument) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30__init_($expression$1), $expression$1));
        }
        if ($expression$1 instanceof oncil_LabelExpressionPredicate) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_ifOkChain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncil_LabelExpressionPredicate_entity($expression$1)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31__init_(), oncil_LabelExpressionPredicate_entity($expression$1))),
            $java.oncias_SemanticExpressionCheck$_checkLabelExpressionForLegacyRelationshipTypeDisjunction(oncias_SemanticExpressionCheck$_MODULE$, oncil_LabelExpressionPredicate_entity($expression$1), oncil_LabelExpressionPredicate_labelExpression($expression$1))), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32__init_($expression$1)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33__init_(), $expression$1)));
        }
        if ($rt_isInstance($expression$1, $java.oncie_LabelOrTypeCheckExpression)) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$entityExpression()), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34__init_(), $expression$1.$entityExpression())), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35__init_(), $expression$1)));
        }
        if ($rt_isInstance($expression$1, $java.oncie_LabelCheckExpression)) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$expression1()), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36__init_(), $expression$1.$expression1())), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_HasTypes) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$expression1()), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38__init_(), $expression$1.$expression1())), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_ListComprehension) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticExpressionCheck$FilteringExpressions$_semanticCheck($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, $ctx$1, $expression$1), $java.oncias_SemanticExpressionCheck$_checkInnerListComprehension(oncias_SemanticExpressionCheck$_MODULE$, $expression$1)), $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$FilteringExpressions$_failIfAggregating($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$,
            $java.oncie_ListComprehension_extractExpression($expression$1))));
        }
        if ($expression$1 instanceof oncie_PatternComprehension) {
            $expression$1 = $expression$1;
            oncias_SemanticState$_$callClinit();
            $ctx$1 = $java.oncias_SemanticCheck$Leaf_chain(oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $expression$1), $java.oncias_SemanticExpressionCheck$_withScopedState(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40__init_($expression$1)));
            $outerTypes = $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41__init_($expression$1);
            return $java.oncias_SemanticCheck$FlatMap_chain($ctx$1, $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType(oncias_SemanticExpressionCheck$_MODULE$, $outerTypes, $expression$1)));
        }
        if ($expression$1 instanceof oncie_FilterScope)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        if ($expression$1 instanceof oncie_ExtractScope)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        if ($expression$1 instanceof oncie_ReduceScope)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        if ($expression$1 instanceof oncie_CountStar) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42__init_(), $expression$1));
        }
        if ($expression$1 instanceof oncie_PathExpression) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$Leaf_chain($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43__init_(), $expression$1)), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$step()));
        }
        if ($expression$1 instanceof oncie_NodePathStep) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_NodePathStep_node($expression$1)), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_NodePathStep_next($expression$1)));
        }
        if ($expression$1 instanceof oncie_SingleRelationshipPathStep) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_SingleRelationshipPathStep_rel($expression$1)), oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $java.oncias_package$_optionSemanticChecking(oncias_package$_MODULE$, oncie_SingleRelationshipPathStep_toNode($expression$1)), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44__init_($ctx$1))),
            oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_SingleRelationshipPathStep_next($expression$1)));
        }
        if ($expression$1 instanceof oncie_MultiRelationshipPathStep) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_MultiRelationshipPathStep_rel($expression$1)), oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $java.oncias_package$_optionSemanticChecking(oncias_package$_MODULE$, oncie_MultiRelationshipPathStep_toNode($expression$1)), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45__init_($ctx$1))),
            oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_MultiRelationshipPathStep_next($expression$1)));
        }
        if ($expression$1 instanceof oncie_RepeatPathStep) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, (oncie_RepeatPathStep_variables($expression$1)).$flatMap($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_46__init_()))).$chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_RepeatPathStep_toNode($expression$1))), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1,
            oncie_RepeatPathStep_next($expression$1)));
        }
        if ($expression$1 instanceof oncie_NilPathStep)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        if ($expression$1 instanceof oncie_ShortestPathExpression) {
            $expression$1 = $expression$1;
            oncias_SemanticPatternCheck$_$callClinit();
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticPatternCheck$_declareVariables(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Expression$_MODULE$, oncie_ShortestPathExpression_pattern($expression$1))).$chain(oncias_SemanticPatternCheck$_check(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Expression$_MODULE$, oncie_ShortestPathExpression_pattern($expression$1))), oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$,
            onciu_Foldable$Folder_treeExists($java.oncie_PatternElement_folder(oncie_ShortestPathsPatternPart_element(oncie_ShortestPathExpression_pattern($expression$1))), $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1__init_()), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47__init_($expression$1))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48__init_($expression$1),
            $expression$1)));
        }
        if ($expression$1 instanceof oncie_PatternExpression) {
            $expression$1 = $expression$1;
            oncias_SemanticState$_$callClinit();
            $ctx$1 = $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$Leaf_chain(oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $expression$1), $java.oncias_SemanticExpressionCheck$_withScopedState(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49__init_($expression$1))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50__init_(), $expression$1)));
            oncias_SemanticPatternCheck$_$callClinit();
            return $java.oncias_SemanticCheck$FlatMap_chain($ctx$1, $java.oncias_SemanticPatternCheck$_check0(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Expression$_MODULE$, oncie_RelationshipsPattern_element(oncie_PatternExpression_pattern($expression$1))));
        }
        if ($rt_isInstance($expression$1, $java.oncie_IterablePredicateExpression)) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$FilteringExpressions$_checkPredicateDefined($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, $expression$1)).$chain($java.oncias_SemanticExpressionCheck$FilteringExpressions$_semanticCheck($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, $ctx$1, $expression$1)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_ReduceExpression) {
            $expression$1 = $expression$1;
            $ctx$1 = $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ReduceExpression_init($expression$1)), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ReduceExpression_list($expression$1))), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52__init_(),
            oncie_ReduceExpression_list($expression$1))), $java.oncias_SemanticExpressionCheck$_withScopedState(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53__init_($expression$1)));
            $allowedTypes = oncias_SemanticExpressionCheck$_MODULE$;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($ctx$1, $java.oncias_SemanticExpressionCheck$_expectType1($allowedTypes, $java.oncias_SemanticExpressionCheck$_types($allowedTypes, oncie_ReduceExpression_init($expression$1)), $java.oncie_ReduceExpression_expression($expression$1), $java.oncie_ReduceExpression$_AccumulatorExpressionTypeMismatchMessageGenerator($java.oncie_ReduceExpression$_MODULE$))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$,
            $java.oncias_SemanticExpressionCheck$_specifyType(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54__init_($expression$1), $expression$1))), $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$FilteringExpressions$_failIfAggregating0($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, $java.oncie_ReduceExpression_expression($expression$1))));
        }
        if ($expression$1 instanceof oncie_ListLiteral) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ListLiteral_expressions($expression$1))).$chain($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$_possibleTypes$1($expression$1), $expression$1)));
        }
        if ($expression$1 instanceof oncie_ListSlice) {
            $expression$1 = $expression$1;
            $allowedTypes = $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ListSlice_list($expression$1)), $java.oncias_SemanticExpressionCheck$_expectType2(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55__init_(), oncie_ListSlice_list($expression$1))), oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$,
            s_Option_isEmpty(oncie_ListSlice_from($expression$1)) && s_Option_isEmpty(oncie_ListSlice_to($expression$1)) ? 1 : 0, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56__init_($expression$1))), $java.oncias_SemanticExpressionCheck$_check0(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ListSlice_from($expression$1)));
            $possibleTypes = oncias_SemanticExpressionCheck$_MODULE$;
            oncius_package$_$callClinit();
            $ctx$1 = $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($allowedTypes, $java.oncias_SemanticExpressionCheck$_expectType0($possibleTypes, $java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$)), oncie_ListSlice_from($expression$1))), $java.oncias_SemanticExpressionCheck$_check0(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ListSlice_to($expression$1))), $java.oncias_SemanticExpressionCheck$_expectType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$)), oncie_ListSlice_to($expression$1)));
            $allowedTypes = oncias_package$_MODULE$;
            $possibleTypes = oncias_SemanticExpressionCheck$_MODULE$;
            return $java.oncias_SemanticCheck$FlatMap_chain($ctx$1, $java.oncias_package$_liftSemanticEitherFunc($allowedTypes, $java.oncias_SemanticExpressionCheck$_specifyType($possibleTypes, $java.oncias_SemanticExpressionCheck$_types($possibleTypes, oncie_ListSlice_list($expression$1)), $expression$1)));
        }
        if ($expression$1 instanceof oncie_ContainerIndex) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ContainerIndex_expr($expression$1)), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_ContainerIndex_idx($expression$1))), $java.oncias_SemanticExpressionCheck$_typeSwitch(oncias_SemanticExpressionCheck$_MODULE$, oncie_ContainerIndex_expr($expression$1), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57__init_($expression$1)));
        }
        if ($expression$1 instanceof oncie_MapExpression) {
            $expression$1 = $expression$1;
            return ($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, (oncie_MapExpression_items($expression$1)).$map1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58__init_()))).$chain($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_MapProjection) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_ifOkChain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_MapProjection_items($expression$1))).$chain($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_ensureDefined(oncias_SemanticExpressionCheck$_MODULE$, oncie_MapProjection_name($expression$1)))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$,
            $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60__init_(), $expression$1))), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61__init_($expression$1));
        }
        if ($expression$1 instanceof oncie_LiteralEntry) {
            $expression$1 = $expression$1;
            return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_LiteralEntry_exp($expression$1));
        }
        if ($expression$1 instanceof oncie_VariableSelector) {
            $expression$1 = $expression$1;
            return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, oncie_VariableSelector_id($expression$1));
        }
        if ($expression$1 instanceof oncie_PropertySelector)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        if ($expression$1 instanceof oncie_AllPropertiesSelector)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        if ($expression$1 instanceof oncie_DesugaredMapProjection) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_ifOkChain($java.oncias_SemanticCheck$FlatMap_chain(($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx$1, $expression$1.$items0())).$chain($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_ensureDefined(oncias_SemanticExpressionCheck$_MODULE$, $expression$1.$variable2()))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62__init_(), $expression$1))), $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63__init_($expression$1));
        }
        if ($expression$1 instanceof $java.oncie_DecimalIntegerLiteral) {
            $expression$1 = $expression$1;
            return (oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$_validNumber(oncias_SemanticExpressionCheck$_MODULE$, $expression$1) ? 0 : 1, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64__init_($expression$1))).$chain($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65__init_(),
            $expression$1)));
        }
        if ($expression$1 instanceof $java.oncie_OctalIntegerLiteral) {
            $expression$1 = $expression$1;
            $stringVal = $java.oncie_SignedOctalIntegerLiteral_stringVal($expression$1);
            return $java.oncias_SemanticCheck$FlatMap_chain((oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$_validNumber(oncias_SemanticExpressionCheck$_MODULE$, $expression$1) ? 0 : 1, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66__init_($stringVal, $expression$1))).$ifOkChain($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67__init_($stringVal, $expression$1)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$,
            $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68__init_(), $expression$1)));
        }
        if ($expression$1 instanceof $java.oncie_HexIntegerLiteral) {
            $expression$1 = $expression$1;
            $stringVal = $java.oncie_SignedHexIntegerLiteral_stringVal($expression$1);
            return $java.oncias_SemanticCheck$FlatMap_chain((oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$_validNumber(oncias_SemanticExpressionCheck$_MODULE$, $expression$1) ? 0 : 1, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69__init_($stringVal, $expression$1))).$ifOkChain($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70__init_($stringVal, $expression$1)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$,
            $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_DecimalDoubleLiteral) {
            $expression$1 = $expression$1;
            return $java.oncias_SemanticCheck$FlatMap_chain((oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$_validNumber0(oncias_SemanticExpressionCheck$_MODULE$, $expression$1) ? 0 : 1, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72__init_($expression$1))).$ifOkChain($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73__init_($expression$1)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncie_StringLiteral) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75__init_(), $expression$1));
        }
        if ($expression$1 instanceof oncie_Null) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76__init_(), $expression$1));
        }
        if ($rt_isInstance($expression$1, $java.oncie_BooleanLiteral)) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77__init_(), $expression$1));
        }
        if ($expression$1 instanceof oncie_Infinity) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78__init_(), $expression$1));
        }
        if ($expression$1 instanceof oncie_NaN) {
            $expression$1 = $expression$1;
            return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79__init_(), $expression$1));
        }
        if ($rt_isInstance($expression$1, $java.oncias_SemanticCheckableExpression))
            return $expression$1.$semanticCheck1($ctx$1);
        if ($expression$1 instanceof oncia_ExistsExpression) {
            $expression$1 = $expression$1;
            oncias_SemanticState$_$callClinit();
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$Leaf_chain(oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $expression$1), $java.oncias_SemanticExpressionCheck$_withScopedState(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80__init_($expression$1))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81__init_(), $expression$1)));
        }
        if ($expression$1 instanceof oncia_CountExpression) {
            $expression$1 = $expression$1;
            oncias_SemanticState$_$callClinit();
            return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$Leaf_chain(oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $expression$1), $java.oncias_SemanticExpressionCheck$_withScopedState(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82__init_($expression$1))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
            $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83__init_(), $expression$1)));
        }
        if (!($expression$1 instanceof oncia_CollectExpression)) {
            if ($expression$1 === null)
                $rt_throw(s_MatchError__init_($expression$1));
            return $java.oncias_SemanticExpressionCheck$$_clinit_$lambda$_0_0_apply($java.oncias_SemanticExpressionCheck$_semanticCheckFallback0(oncias_SemanticExpressionCheck$_MODULE$), $ctx$1, $expression$1);
        }
        $expression$1 = $expression$1;
        oncias_SemanticState$_$callClinit();
        return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$Leaf_chain(oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, $expression$1), $java.oncias_SemanticExpressionCheck$_withScopedState(oncias_SemanticExpressionCheck$_MODULE$, $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84__init_($expression$1))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$_specifyType0(oncias_SemanticExpressionCheck$_MODULE$,
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85__init_(), $expression$1)));
    };
    $java.oncias_SemanticExpressionCheck$_colonConjunctions$1 = function($colonConjunctions$lzy$1, $labelExpression$2) {
        var var$3, $$je;
        oncias_SemanticExpressionCheck$_$callClinit();
        if ($colonConjunctions$lzy$1.$_initialized)
            return $colonConjunctions$lzy$1.$_value0;
        jl_Object_monitorEnterSync($colonConjunctions$lzy$1);
        a: {
            try {
                if ($java.sr_LazyRef_initialized($colonConjunctions$lzy$1))
                    $labelExpression$2 = $java.sr_LazyRef_value($colonConjunctions$lzy$1);
                else {
                    var$3 = $labelExpression$2.$folder();
                    sr_ClassTag$_$callClinit();
                    $labelExpression$2 = $java.sr_LazyRef_initialize($colonConjunctions$lzy$1, onciu_Foldable$Folder_findAllByClass(var$3, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncil_LabelExpression$ColonConjunction))));
                }
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                $labelExpression$2 = $$je;
                break a;

            }
            jl_Object_monitorExitSync($colonConjunctions$lzy$1);
            return $labelExpression$2;
        }
        jl_Object_monitorExitSync($colonConjunctions$lzy$1);
        $rt_throw($labelExpression$2);
    };
    $java.oncias_SemanticExpressionCheck$_colonDisjunctions$1 = function($colonDisjunctions$lzy$1, $labelExpression$2) {
        var var$3, $$je;
        oncias_SemanticExpressionCheck$_$callClinit();
        if ($colonDisjunctions$lzy$1.$_initialized)
            return $colonDisjunctions$lzy$1.$_value0;
        jl_Object_monitorEnterSync($colonDisjunctions$lzy$1);
        a: {
            try {
                if ($java.sr_LazyRef_initialized($colonDisjunctions$lzy$1))
                    $labelExpression$2 = $java.sr_LazyRef_value($colonDisjunctions$lzy$1);
                else {
                    var$3 = $labelExpression$2.$folder();
                    sr_ClassTag$_$callClinit();
                    $labelExpression$2 = $java.sr_LazyRef_initialize($colonDisjunctions$lzy$1, onciu_Foldable$Folder_findAllByClass(var$3, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncil_LabelExpression$ColonDisjunction))));
                }
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                $labelExpression$2 = $$je;
                break a;

            }
            jl_Object_monitorExitSync($colonDisjunctions$lzy$1);
            return $labelExpression$2;
        }
        jl_Object_monitorExitSync($colonDisjunctions$lzy$1);
        $rt_throw($labelExpression$2);
    };
    $java.oncias_SemanticExpressionCheck$_$anonfun$infixAddRhsTypes$1 = function($lhs$1, $s) {
        var $lhsTypes, $valueTypes, $temporalTypes, $durationTypes, $listTypes, $lhsListTypes, $rhsListTypes;
        oncias_SemanticExpressionCheck$_$callClinit();
        $lhsTypes = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, $lhs$1), $s);
        oncius_package$_$callClinit();
        if (!$java.oncius_TypeSpec_containsAny($lhsTypes, $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$)), $java.oncius_FloatType_covariant($java.oncius_package$_CTFloat(oncius_package$_MODULE$))), $java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$))))) {
            oncius_TypeSpec$_$callClinit();
            $valueTypes = oncius_TypeSpec$_none(oncius_TypeSpec$_MODULE$);
        } else
            $valueTypes = $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$)), $java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$))), $java.oncius_FloatType_covariant($java.oncius_package$_CTFloat(oncius_package$_MODULE$)));
        if (!$java.oncius_TypeSpec_containsAny($lhsTypes, $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_DateType_covariant($java.oncius_package$_CTDate0(oncius_package$_MODULE$)), $java.oncius_ZonedTimeType_covariant($java.oncius_package$_CTTime0(oncius_package$_MODULE$))), $java.oncius_LocalTimeType_covariant($java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$))), $java.oncius_ZonedDateTimeType_covariant($java.oncius_package$_CTDateTime0(oncius_package$_MODULE$))),
        $java.oncius_LocalDateTimeType_covariant($java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$))), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$))))) {
            oncius_TypeSpec$_$callClinit();
            $temporalTypes = oncius_TypeSpec$_none(oncius_TypeSpec$_MODULE$);
        } else
            $temporalTypes = $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        if (!$java.oncius_TypeSpec_containsAny($lhsTypes, $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)))) {
            oncius_TypeSpec$_$callClinit();
            $durationTypes = oncius_TypeSpec$_none(oncius_TypeSpec$_MODULE$);
        } else
            $durationTypes = $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_DateType_covariant($java.oncius_package$_CTDate0(oncius_package$_MODULE$)), $java.oncius_ZonedTimeType_covariant($java.oncius_package$_CTTime0(oncius_package$_MODULE$))), $java.oncius_LocalTimeType_covariant($java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$))), $java.oncius_ZonedDateTimeType_covariant($java.oncius_package$_CTDateTime0(oncius_package$_MODULE$))),
            $java.oncius_LocalDateTimeType_covariant($java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$))), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)));
        $lhs$1 = oncius_package$_MODULE$;
        $lhs$1 = $java.oncius_TypeSpec_leastUpperBounds($lhsTypes, (oncius_package$_CTList($lhs$1, oncius_package$_CTAny($lhs$1))).$invariant());
        $s = oncius_package$_MODULE$;
        $listTypes = $java.oncius_TypeSpec_covariant($java.oncius_TypeSpec_constrain($lhs$1, oncius_package$_CTList($s, oncius_package$_CTAny($s))));
        $lhsListTypes = $java.oncius_TypeSpec_union($listTypes, $java.oncius_TypeSpec_unwrapLists($listTypes));
        $lhs$1 = oncius_package$_MODULE$;
        $rhsListTypes = $java.oncius_ListType_covariant(oncius_package$_CTList($lhs$1, oncius_package$_CTAny($lhs$1)));
        return $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($valueTypes, $lhsListTypes), $rhsListTypes), $temporalTypes), $durationTypes);
    };
    $java.oncias_SemanticExpressionCheck$_when$1 = function($fst, $snd, $result, $lhsTypes$1, $rhsTypes$1) {
        oncias_SemanticExpressionCheck$_$callClinit();
        a: {
            if (!($java.oncius_TypeSpec_containsAny($lhsTypes$1, $fst) && $java.oncius_TypeSpec_containsAny($rhsTypes$1, $snd))) {
                if (!$java.oncius_TypeSpec_containsAny($lhsTypes$1, $snd))
                    break a;
                if (!$java.oncius_TypeSpec_containsAny($rhsTypes$1, $fst))
                    break a;
            }
            return $result.$invariant();
        }
        oncius_TypeSpec$_$callClinit();
        return oncius_TypeSpec$_none(oncius_TypeSpec$_MODULE$);
    };
    $java.oncias_SemanticExpressionCheck$_$anonfun$infixAddOutputTypes$1 = function($lhs$2, $rhs$1, $s) {
        var $lhsTypes, $rhsTypes, $stringTypes, $numberTypes, $temporalTypes, $lhsListTypes, $rhsListTypes, $lhsListInnerTypes, $rhsListInnerTypes, $lhsScalarTypes, $rhsScalarTypes, $bothListMergedTypes, $lhListMergedTypes, $rhListMergedTypes, $listTypes;
        oncias_SemanticExpressionCheck$_$callClinit();
        $lhsTypes = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, $lhs$2), $s);
        $rhsTypes = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, $rhs$1), $s);
        oncius_package$_$callClinit();
        $stringTypes = $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$)), $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$)), $java.oncius_FloatType_covariant($java.oncius_package$_CTFloat(oncius_package$_MODULE$))), $java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$))), oncius_package$_CTString(oncius_package$_MODULE$),
        $lhsTypes, $rhsTypes);
        $numberTypes = $java.oncius_TypeSpec_union($java.oncias_SemanticExpressionCheck$_when$1($java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$)), $java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$)), oncius_package$_CTInteger(oncius_package$_MODULE$), $lhsTypes, $rhsTypes), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_FloatType_covariant($java.oncius_package$_CTFloat(oncius_package$_MODULE$)), $java.oncius_TypeSpec_union($java.oncius_FloatType_covariant($java.oncius_package$_CTFloat(oncius_package$_MODULE$)),
        $java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), $lhsTypes, $rhsTypes));
        $temporalTypes = $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncias_SemanticExpressionCheck$_when$1($java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)),
        $java.oncius_package$_CTDuration0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_DateType_covariant($java.oncius_package$_CTDate0(oncius_package$_MODULE$)), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), $java.oncius_package$_CTDate0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)),
        $java.oncius_DateType_covariant($java.oncius_package$_CTDate0(oncius_package$_MODULE$)), $java.oncius_package$_CTDate0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_ZonedTimeType_covariant($java.oncius_package$_CTTime0(oncius_package$_MODULE$)), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), $java.oncius_package$_CTTime0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)),
        $java.oncius_ZonedTimeType_covariant($java.oncius_package$_CTTime0(oncius_package$_MODULE$)), $java.oncius_package$_CTTime0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_LocalTimeType_covariant($java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$)), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), $java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)),
        $java.oncius_LocalTimeType_covariant($java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$)), $java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_LocalDateTimeType_covariant($java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$)), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), $java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$), $lhsTypes,
        $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), $java.oncius_LocalDateTimeType_covariant($java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$)), $java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_ZonedDateTimeType_covariant($java.oncius_package$_CTDateTime0(oncius_package$_MODULE$)), $java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)),
        $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes)), $java.oncias_SemanticExpressionCheck$_when$1($java.oncius_DurationType_covariant($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)), $java.oncius_ZonedDateTimeType_covariant($java.oncius_package$_CTDateTime0(oncius_package$_MODULE$)), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $lhsTypes, $rhsTypes));
        $lhs$2 = oncius_package$_MODULE$;
        $lhsListTypes = $java.oncius_TypeSpec_constrain($lhsTypes, oncius_package$_CTList($lhs$2, oncius_package$_CTAny($lhs$2)));
        $lhs$2 = oncius_package$_MODULE$;
        $rhsListTypes = $java.oncius_TypeSpec_constrain($rhsTypes, oncius_package$_CTList($lhs$2, oncius_package$_CTAny($lhs$2)));
        $lhsListInnerTypes = $java.oncius_TypeSpec_unwrapLists($lhsListTypes);
        $rhsListInnerTypes = $java.oncius_TypeSpec_unwrapLists($rhsListTypes);
        $lhs$2 = oncius_package$_MODULE$;
        $lhsScalarTypes = $java.oncius_TypeSpec_without($lhsTypes, oncius_package$_CTList($lhs$2, oncius_package$_CTAny($lhs$2)));
        $lhs$2 = oncius_package$_MODULE$;
        $rhsScalarTypes = $java.oncius_TypeSpec_without($rhsTypes, oncius_package$_CTList($lhs$2, oncius_package$_CTAny($lhs$2)));
        $bothListMergedTypes = $java.oncius_TypeSpec_wrapInList($java.oncius_TypeSpec_coerceOrLeastUpperBound($lhsListInnerTypes, $rhsListInnerTypes));
        $lhListMergedTypes = $java.oncius_TypeSpec_wrapInList($java.oncius_TypeSpec_coerceOrLeastUpperBound($rhsScalarTypes, $lhsListInnerTypes));
        $rhListMergedTypes = $java.oncius_TypeSpec_wrapInList($java.oncius_TypeSpec_coerceOrLeastUpperBound($lhsScalarTypes, $rhsListInnerTypes));
        $listTypes = $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($bothListMergedTypes, $lhListMergedTypes), $rhListMergedTypes);
        return $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($stringTypes, $numberTypes), $listTypes), $temporalTypes);
    };
    $java.oncia_CompositePropertyConstraintCommand$semanticCheck$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0386 = null;
    };
    $java.oncia_CompositePropertyConstraintCommand$semanticCheck$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0386;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = var$1.$map11 instanceof oncie_Variable ? 0 : 1;
        var$5 = new $java.oncia_CompositePropertyConstraintCommand$$anonfun$semanticCheck$4$lambda$_6_0;
        var$5.$_0479 = var$2;
        var$5.$_1152 = var$1;
        return oncias_SemanticCheck$_when(var$3, var$4, var$5);
    };
    $java.oncia_PropertyConstraintCommand$semanticCheck$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0390 = null;
    };
    $java.oncia_PropertyConstraintCommand$semanticCheck$lambda$_4_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0390;
        return var$1.$error2($rt_s(2741), (var$1.$property()).$position31);
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_0_apply = function(var$0, var$1, var$2) {
        return $java.oncia_SingleQuery_$anonfun$checkOrder$2(var$1, var$2);
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_1 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_2 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_2_apply = function(var$0, var$1, var$2) {
        return $java.oncia_SingleQuery_$anonfun$checkOrder$6(var$1, var$2);
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0404 = null;
        a.$_1117 = null;
        a.$_242 = null;
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0404;
        return sci_SetBuilderImpl_addOne(var$0.$_1117, $java.oncia_Union$Mapping$2$_apply($java.oncia_Union_Mapping$3(var$2, var$0.$_242), var$1.$unionVariable, var$1.$variableInLhs.$name4, var$1.$variableInRhs.$name4));
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0405 = null;
        a.$_1118 = null;
        a.$_243 = null;
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0405;
        return sci_SetBuilderImpl_addOne(var$0.$_1118, $java.oncia_Union$Mapping$2$_apply($java.oncia_Union_Mapping$3(var$2, var$0.$_243), oncie_Variable__init_(var$1, var$2.$position2()), var$1, var$1));
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0407 = null;
        a.$_1120 = null;
        a.$_245 = null;
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0407;
        var$3 = var$0.$_1120;
        var$4 = var$0.$_245;
        var$2 = oncias_Scope_symbol(var$2, var$1.$variableInLhsName);
        var$5 = new $java.oncia_Union$$anonfun$defineUnionVariables$5$lambda$_47_0;
        var$5.$_0480 = var$3;
        var$5.$_1153 = var$1;
        var$5.$_257 = var$4;
        return s_Option_flatMap(var$2, var$5);
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_3 = function() {
        var a = this; jl_Object.call(a);
        a.$_0406 = null;
        a.$_1119 = null;
        a.$_244 = null;
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_3_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0406;
        return sci_SetBuilderImpl_addOne(var$0.$_1119, $java.oncia_Union$Mapping$2$_apply($java.oncia_Union_Mapping$3(var$2, var$0.$_244), oncie_Variable__init_(var$1, var$2.$position2()), var$1, var$1));
    };
    $java.oncias_UnsupportedOpenCypher = $rt_classWithoutFields(0);
    $java.oncias_FeatureError = function() {
        var a = this; jl_Object.call(a);
        a.$msg0 = null;
        a.$feature = null;
        a.$position244 = null;
    };
    $java.oncias_FeatureError__init_0 = function(var_0, var_1, var_2) {
        var var_3 = new $java.oncias_FeatureError();
        $java.oncias_FeatureError__init_(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncias_FeatureError_msg = function($this) {
        return $this.$msg0;
    };
    $java.oncias_FeatureError_productPrefix = function($this) {
        return $rt_s(2742);
    };
    $java.oncias_FeatureError_productArity = function($this) {
        return 3;
    };
    $java.oncias_FeatureError_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$msg0;
            case 1:
                return $this.$feature;
            case 2:
                return $this.$position244;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_FeatureError_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_FeatureError_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_FeatureError_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_FeatureError_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncias_FeatureError) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$msg0;
                            var$3 = $x$1.$msg0;
                            if (var$2 !== null) {
                                if (!jl_String_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$feature;
                            var$3 = $x$1.$feature;
                            if (var$2 !== null) {
                                if (!jl_Object_equals(var$2, var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$position244;
                        $x$1 = $x$1.$position244;
                        if (var$3 !== null) {
                            if (!onciu_InputPosition_equals(var$3, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncias_FeatureError_withMsg = function($this, $message) {
        return $java.oncias_FeatureError__init_0($message, $this.$feature, $this.$position244);
    };
    $java.oncias_FeatureError__init_ = function($this, $msg, $feature, $position) {
        $this.$msg0 = $msg;
        $this.$feature = $feature;
        $this.$position244 = $position;
    };
    function oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$1$lambda$_29_0() {
        jl_Object.call(this);
        this.$_0211 = null;
    }
    $java.oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$1$lambda$_29_0_apply = function(var$0, var$1) {
        return var$1.$incl(var$0.$_0211);
    };
    function oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$4$lambda$_32_0() {
        jl_Object.call(this);
        this.$_0213 = null;
    }
    $java.oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$4$lambda$_32_0_apply = function(var$0, var$1) {
        return var$1.$incl(var$0.$_0213);
    };
    $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0384 = null;
        a.$_1113 = null;
    };
    $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0384;
        var$3 = var$0.$_1113;
        if (!s_Option_exists(var$1.$primaries, new $java.oncia_WriteAdministrationCommand$numPrimaryGreaterThanZero$1$lambda$_7_0))
            var$4 = oncias_SemanticCheck$_success;
        else {
            var$5 = jl_String_trim(onciap_Prettifier$_extractTopology(onciap_Prettifier$_MODULE$, var$1));
            var$6 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$6);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(2743)), var$3), $rt_s(2744)), var$5), $rt_s(2745));
            var$4 = var$2.$error2(jl_AbstractStringBuilder_toString(var$6), var$2.$position2());
        }
        if (!s_Option_exists(var$1.$secondaries, new $java.oncia_WriteAdministrationCommand$numSecondaryPositive$1$lambda$_9_0))
            var$1 = oncias_SemanticCheck$_success;
        else {
            var$1 = jl_String_trim(onciap_Prettifier$_extractTopology(onciap_Prettifier$_MODULE$, var$1));
            var$5 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$5);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(2743)), var$3), $rt_s(2744)), var$1), $rt_s(2746));
            var$1 = var$2.$error2(jl_AbstractStringBuilder_toString(var$5), var$2.$position2());
        }
        return oncias_SemanticCheck_chain$(var$4, var$1);
    };
    $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_1 = $rt_classWithoutFields();
    $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_1_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_0 = function() {
        jl_Object.call(this);
        this.$_0380 = null;
    };
    $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0380;
                    var$3 = var$1.$name4;
                    var$1 = var$2.$name4;
                    if (var$3 !== null) {
                        if (!jl_String_equals(var$3, var$1))
                            break b;
                        else
                            break c;
                    }
                    if (var$1 !== null)
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return jl_Boolean_valueOf(var$4);
    };
    $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0381 = null;
        a.$_1112 = null;
    };
    $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0381;
        var$3 = var$0.$_1112;
        var$4 = new $java.oncia_Union$UnionMapping;
        var$4.$unionVariable = oncie_Variable__init_(var$3.$name4, var$2.$position2());
        var$4.$variableInLhs = var$3;
        var$4.$variableInRhs = var$1;
        return var$4;
    };
    $java.oncias_Scope$$anonfun$allSymbolDefinitions$1$lambda$_38_0 = $rt_classWithoutFields();
    $java.oncias_Scope$$anonfun$allSymbolDefinitions$1$lambda$_38_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6;
        var$3 = s_Tuple2__init_(var$1, var$2);
        var$1 = var$3.$_10;
        var$2 = var$3.$_20;
        if (var$1.$contains0($java.oncias_SymbolUse_name(var$2)))
            var$1 = var$1.$updated1($java.oncias_SymbolUse_name(var$2), (var$1.$apply($java.oncias_SymbolUse_name(var$2))).$incl(var$2));
        else {
            var$1 = var$3.$_10;
            var$2 = var$3.$_20;
            var$3 = $java.oncias_SymbolUse_name(var$2);
            s_Predef$_$callClinit();
            var$4 = s_Predef$_Set(s_Predef$_MODULE$);
            var$5 = sr_ScalaRunTime$_MODULE$;
            var$6 = $rt_createArray(oncias_SymbolUse, 1);
            var$6.data[0] = var$2;
            var$1 = var$1.$updated1(var$3, var$4.$from0(sr_ScalaRunTime$_wrapRefArray(var$5, var$6)));
        }
        return var$1;
    };
    function oncia_UserQualifier() {
        var a = this; jl_Object.call(a);
        a.$username3 = null;
        a.$position245 = null;
    }
    $java.oncia_UserQualifier__init_0 = function(var_0, var_1) {
        var var_2 = new oncia_UserQualifier();
        $java.oncia_UserQualifier__init_(var_2, var_0, var_1);
        return var_2;
    };
    function oncia_UserQualifier_username($this) {
        return $this.$username3;
    }
    $java.oncia_UserQualifier_productPrefix = function($this) {
        return $rt_s(2747);
    };
    $java.oncia_UserQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_UserQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$username3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_UserQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_UserQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_UserQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$username3;
                        $x$1 = $x$1.$username3;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_UserQualifier_dup = function($this, $children) {
        return $java.oncia_UserQualifier__init_0($children.$head(), $this.$position245);
    };
    $java.oncia_UserQualifier__init_ = function($this, $username, $position) {
        $this.$username3 = $username;
        $this.$position245 = $position;
    };
    $java.sci_SeqMap = $rt_classWithoutFields(0);
    function sci_TreeSeqMap() {
        var a = this; sci_AbstractMap.call(a);
        a.$scala$collection$immutable$TreeSeqMap$$ordering = null;
        a.$scala$collection$immutable$TreeSeqMap$$mapping = null;
        a.$ordinal0 = 0;
        a.$orderedBy0 = null;
        a.$size10 = 0;
    }
    $java.sci_TreeSeqMap__init_ = function(var_0, var_1, var_2, var_3) {
        var var_4 = new sci_TreeSeqMap();
        $java.sci_TreeSeqMap__init_0(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    $java.sci_TreeSeqMap__init_0 = function($this, $ordering, $mapping, $ordinal, $orderedBy) {
        $this.$scala$collection$immutable$TreeSeqMap$$ordering = $ordering;
        $this.$scala$collection$immutable$TreeSeqMap$$mapping = $mapping;
        $this.$ordinal0 = $ordinal;
        $this.$orderedBy0 = $orderedBy;
        $this.$size10 = sci_HashMap_size($mapping);
    };
    var sci_TreeSeqMap$ = $rt_classWithoutFields();
    var sci_TreeSeqMap$_MODULE$ = null;
    $java.sci_TreeSeqMap$_EmptyByInsertion = null;
    var sci_TreeSeqMap$_EmptyByModification = null;
    $java.sci_TreeSeqMap$_Empty = null;
    $java.sci_TreeSeqMap$_Mapping = null;
    function sci_TreeSeqMap$_$callClinit() {
        sci_TreeSeqMap$_$callClinit = $rt_eraseClinit(sci_TreeSeqMap$);
        $java.sci_TreeSeqMap$__clinit_();
    }
    $java.sci_TreeSeqMap$__clinit_ = function() {
        var var$1, var$2, var$3;
        var$1 = new sci_TreeSeqMap$;
        sci_TreeSeqMap$_$callClinit();
        sci_TreeSeqMap$_MODULE$ = var$1;
        var$2 = new sci_TreeSeqMap;
        var$3 = $java.sci_TreeSeqMap$Ordering$Zero$_MODULE$;
        sci_HashMap$_$callClinit();
        $java.sci_TreeSeqMap__init_0(var$2, var$3, sci_HashMap$_empty(sci_HashMap$_MODULE$), 0, $java.sci_TreeSeqMap$OrderBy$Insertion$_MODULE$);
        $java.sci_TreeSeqMap$_EmptyByInsertion = var$2;
        sci_TreeSeqMap$_EmptyByModification = $java.sci_TreeSeqMap__init_($java.sci_TreeSeqMap$Ordering$Zero$_MODULE$, sci_HashMap$_empty(sci_HashMap$_MODULE$), 0, sci_TreeSeqMap$OrderBy$Modification$_MODULE$);
        $java.sci_TreeSeqMap$_Empty = sci_TreeSeqMap$_EmptyByInsertion(sci_TreeSeqMap$_MODULE$);
        $java.sci_TreeSeqMap$_Mapping = sci_Map$_MODULE$;
    };
    function sci_TreeSeqMap$_EmptyByInsertion($this) {
        sci_TreeSeqMap$_$callClinit();
        return $java.sci_TreeSeqMap$_EmptyByInsertion;
    }
    $java.oncius_CypherType$$$anonfun$normalize$4$lambda$_12_0 = function() {
        jl_Object.call(this);
        this.$_0429 = null;
    };
    $java.oncius_CypherType$$$anonfun$normalize$4$lambda$_12_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isSubtypeOf(var$0.$_0429));
    };
    function sc_IterableOnceOps$min$lambda$_77_0() {
        jl_Object.call(this);
        this.$_08 = null;
    }
    $java.sc_IterableOnceOps$min$lambda$_77_0_apply = function(var$0, var$1, var$2) {
        return var$0.$_08.$min0(var$1, var$2);
    };
    $java.oncius_ClosedDynamicUnionType$$anonfun$simplify$1$lambda$_55_0 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$$anonfun$simplify$1$lambda$_55_0_apply = function(var$0, var$1) {
        return var$1.$simplify();
    };
    $java.oncia_UnresolvedCall$$anonfun$returnVariables$1$lambda$_33_0 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$$anonfun$returnVariables$1$lambda$_33_0_apply = function(var$0, var$1) {
        return var$1.$variable41;
    };
    $java.oncia_Union$checkSingleQuery$1$lambda$_50_0 = $rt_classWithoutFields();
    $java.oncia_Union$checkSingleQuery$1$lambda$_50_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof $java.oncia_InputDataStream);
    };
    $java.oncias_SemanticExpressionCheck$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$_clinit_$lambda$_0_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = new jl_UnsupportedOperationException;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2748)), var$2);
        jl_Throwable__init_(var$1, jl_AbstractStringBuilder_toString(var$3));
        $rt_throw(var$1);
    };
    $java.sci_TreeSeqMap$Ordering = $rt_classWithoutFields();
    var sci_TreeSeqMap$Ordering$Zero$ = $rt_classWithoutFields($java.sci_TreeSeqMap$Ordering);
    $java.sci_TreeSeqMap$Ordering$Zero$_MODULE$ = null;
    function sci_TreeSeqMap$Ordering$Zero$__clinit_() {
        $java.sci_TreeSeqMap$Ordering$Zero$_MODULE$ = new sci_TreeSeqMap$Ordering$Zero$;
    }
    $java.sci_TreeSeqMap$OrderBy = $rt_classWithoutFields(0);
    var sci_TreeSeqMap$OrderBy$Insertion$ = $rt_classWithoutFields();
    $java.sci_TreeSeqMap$OrderBy$Insertion$_MODULE$ = null;
    function sci_TreeSeqMap$OrderBy$Insertion$__clinit_() {
        $java.sci_TreeSeqMap$OrderBy$Insertion$_MODULE$ = new sci_TreeSeqMap$OrderBy$Insertion$;
    }
    var sci_TreeSeqMap$OrderBy$Modification$ = $rt_classWithoutFields();
    var sci_TreeSeqMap$OrderBy$Modification$_MODULE$ = null;
    function sci_TreeSeqMap$OrderBy$Modification$__clinit_() {
        sci_TreeSeqMap$OrderBy$Modification$_MODULE$ = new sci_TreeSeqMap$OrderBy$Modification$;
    }
    $java.onciu_RewritableCompat$PROXY$7_52 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_52_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_52 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_52_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_53 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_53_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_53 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_53_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_54 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_54_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_54 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_54_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(7)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_55 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_55_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_55 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_55_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_56 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_56_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_56 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_56_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_57 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_57_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_57 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_57_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_58 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_58_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_58 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_58_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_59 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_59_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_59 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_59_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_60 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_60_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_60 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_60_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_61 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_61_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_61 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_61_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_62 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_62_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_62 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_62_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_63 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_63_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_63 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_63_paramsLength(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_64 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_64_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_64 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_64_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_65 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_65_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_65 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_65_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_66 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_66_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_66 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_66_paramsLength(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_67 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_67_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_67 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_67_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_68 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_68_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_68 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_68_paramsLength(var$1) {
        return (jl_Integer_valueOf(7)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_69 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_69_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_69 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_69_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_70 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_70_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_70 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_70_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_71 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_71_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_71 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_71_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_72 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_72_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_72 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_72_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_73 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_73_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_73 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_73_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_74 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_74_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_74 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_74_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_75 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_75_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_75 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_75_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_76 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_76_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_76 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_76_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_77 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_77_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_77 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_77_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_78 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_78_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_78 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_78_paramsLength(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_79 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_79_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_79 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_79_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_80 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_80_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_80 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_80_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_81 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_81_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_81 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_81_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(9)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_82 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_82_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_82 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_82_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_83 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_83_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_83 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_83_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_84 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_84_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_84 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_84_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_85 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_85_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_85 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_85_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_86 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_86_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_86 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_86_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_87 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_87_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_87 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_87_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_461 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_461_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_SignedDecimalIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_463 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_463_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowSupportedPrivilegeCommand_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_464 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_464_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowPrivileges_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_466 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_466_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowDatabase_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_467 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_467_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowCurrentUser_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_468 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_468_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DropDatabaseAlias__init_(var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_469 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_469_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Equals_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_470 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_470_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_InvalidNotEquals__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_472 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_472_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_LessThanOrEqual__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_476 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_476_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_LessThan__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_477 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_477_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_GreaterThanOrEqual__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_485 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_485_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowRoles_copy(var$2, var$3[0].$value8, var$3[1].$value8, var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_493 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_493_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowAliases_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_496 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_496_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ShortestPathsPatternPart_copy(var$2, var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_497 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_497_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_GreaterThan__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_498 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_498_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_NotEquals_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_514 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_514_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_NaN_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_515 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_515_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_True_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_516 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_516_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_Null_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_525 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_525_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_Infinity_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_526 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_526_copyConstructor(var$1, var$2, var$3) {
        return oncie_CountStar__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_529 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_529_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_LabelOrRelTypeName__init_(var$3[0], var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_88 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_88_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_88 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_88_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_89 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_89_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_89 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_89_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_90 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_90_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_90 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_90_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_91 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_91_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_91 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_91_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_92 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_92_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_92 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_92_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_93 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_93_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_93 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_93_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_94 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_94_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_94 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_94_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_95 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_95_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_95 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_95_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_96 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_96_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_96 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_96_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_97 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_97_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_97 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_97_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_98 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_98_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_98 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_98_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_99 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_99_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_99 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_99_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_100 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_100_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_100 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_100_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_101 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_101_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_101 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_101_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_533 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_533_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateIndexOldSyntax_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_534 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_534_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateRangeNodeIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8]);
    }
    var onciu_RewritableCompat$PROXY$3_535 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_535_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_RevokeRolesFromUsers__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_536 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_536_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_AlterRemoteDatabaseAlias__init_(var$3[0], var$3[1], var$3[2].$value8, var$3[3], var$3[4], var$3[5], var$3[6], var$3[7], var$3[8]);
    }
    var onciu_RewritableCompat$PROXY$3_537 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_537_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_AlterServer__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_538 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_538_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowPrivilegeCommands_copy(var$2, var$3[0], var$3[1].$value8, var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_539 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_539_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DropRole__init_(var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_540 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_540_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateLookupIndex_copy(var$2, var$3[0], var$3[1].$value8, var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_541 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_541_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowServers_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_542 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_542_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreatePointRelationshipIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_543 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_543_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateBtreeRelationshipIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_544 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_544_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_AlterDatabase__init_(var$3[0], var$3[1].$value8, var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_545 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_545_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_SetOwnPassword__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_546 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_546_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreatePointNodeIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_547 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_547_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateFulltextRelationshipIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_548 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_548_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateBtreeNodeIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_549 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_549_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ReallocateDatabases__init_(var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_550 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_550_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DeallocateServers__init_(var$3[0].$value8, var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_551 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_551_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DropDatabase__init_(var$3[0], var$3[1].$value8, var$3[2].$value8, var$3[3], var$3[4], var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_552 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_552_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DropServer__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_553 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_553_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateRangeRelationshipIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6].$value8, var$3[7], var$3[8]);
    }
    var onciu_RewritableCompat$PROXY$3_554 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_554_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateTextNodeIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_555 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_555_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_RenameUser__init_(var$3[0], var$3[1], var$3[2].$value8, var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_556 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_556_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_AlterLocalDatabaseAlias__init_(var$3[0], var$3[1], var$3[2].$value8, var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_557 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_557_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateFulltextNodeIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_558 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_558_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_AlterUser__init_(var$3[0], var$3[1], var$3[2], var$3[3], var$3[4].$value8, var$3[5]);
    }
    var onciu_RewritableCompat$PROXY$3_559 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_559_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_DropUser__init_(var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_560 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_560_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_ShowUsers_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_561 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_561_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_RenameServer__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_562 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_562_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CreateTextRelationshipIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6], var$3[7]);
    }
    var onciu_RewritableCompat$PROXY$3_563 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_563_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_GrantRolesToUsers__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_564 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_564_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_RenameRole__init_(var$3[0], var$3[1], var$3[2].$value8, var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_584 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_584_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_RelationshipChain_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    $java.jusi_SimpleStreamImpl$collect$lambda$_25_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0409 = null;
        a.$_1121 = null;
    };
    $java.jusi_SimpleStreamImpl$collect$lambda$_25_0_test = function(var$0, var$1) {
        var$0.$_0409.$accept0(var$0.$_1121, var$1);
        return 1;
    };
    function ju_GenericEnumSet$1() {
        var a = this; jl_Object.call(a);
        a.$index5 = 0;
        a.$indexToRemove = 0;
        a.$count0 = 0;
        a.$this$01 = null;
    }
    function ju_GenericEnumSet$1_hasNext($this) {
        return $this.$count0 <= 0 ? 0 : 1;
    }
    function ju_GenericEnumSet$1_next($this) {
        var var$1, var$2, var$3, var$4;
        if (!$this.$count0) {
            var$1 = new ju_NoSuchElementException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        $this.$indexToRemove = $this.$index5;
        while (true) {
            var$2 = $this.$this$01.$bits.data;
            var$3 = $this.$index5;
            var$4 = jl_Integer_numberOfTrailingZeros(var$2[var$3 / 32 | 0] >>> (var$3 % 32 | 0));
            if (var$4 < 32)
                break;
            $this.$index5 = (($this.$index5 / 32 | 0) + 1 | 0) * 32 | 0;
        }
        $this.$index5 = $this.$index5 + var$4 | 0;
        $this.$count0 = $this.$count0 - 1 | 0;
        var$2 = ($java.ju_GenericEnumSet_getConstants($this.$this$01.$cls)).data;
        var$3 = $this.$index5;
        $this.$index5 = var$3 + 1 | 0;
        return var$2[var$3];
    }
    $java.juf_Function$andThen$lambda$_2_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0379 = null;
        a.$_1111 = null;
    };
    $java.juf_Function$andThen$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12, var$13;
        var$2 = var$0.$_0379;
        var$3 = var$0.$_1111;
        var$1 = var$2.$apply(var$1);
        var$2 = var$3.$_0238;
        var$3 = var$3.$_163;
        var$4 = var$1.$size2;
        var$5 = var$4 - 1 | 0;
        var$6 = $rt_createArray(jl_CharSequence, 2);
        if (0 > var$5) {
            var$1 = new jl_IllegalArgumentException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        if (var$5 > var$4) {
            var$1 = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        if (!$rt_isInstance(var$1, ju_RandomAccess))
            var$7 = $java.ju_AbstractList$SubAbstractList__init_(var$1, 0, var$5);
        else {
            var$7 = new $java.ju_AbstractList$SubAbstractListRandomAccess;
            $java.ju_AbstractList$SubAbstractList__init_0(var$7, var$1, 0, var$5);
        }
        var$6 = var$6.data;
        var$6[0] = jl_String_join(var$3, var$7);
        var$6[1] = ju_ArrayList_get(var$1, var$5);
        var$8 = var$6.length;
        if (!var$8)
            var$1 = $rt_s(3);
        else {
            var$9 = 0;
            var$5 = 0;
            while (var$5 < var$8) {
                var$9 = var$9 + jl_String_length(var$6[var$5]) | 0;
                var$5 = var$5 + 1 | 0;
            }
            var$10 = $rt_createCharArray(var$9 + $rt_imul(var$8 - 1 | 0, jl_String_length(var$2)) | 0);
            var$11 = var$10.data;
            var$12 = 0;
            var$1 = var$6[0];
            var$5 = 0;
            while (var$5 < jl_String_length(var$1)) {
                var$13 = var$12 + 1 | 0;
                var$11[var$12] = jl_String_charAt(var$1, var$5);
                var$5 = var$5 + 1 | 0;
                var$12 = var$13;
            }
            var$4 = 1;
            while (var$4 < var$8) {
                var$5 = 0;
                while (var$5 < jl_String_length(var$2)) {
                    var$13 = var$12 + 1 | 0;
                    var$11[var$12] = jl_String_charAt(var$2, var$5);
                    var$5 = var$5 + 1 | 0;
                    var$12 = var$13;
                }
                var$1 = var$6[var$4];
                var$13 = 0;
                while (var$13 < jl_String_length(var$1)) {
                    var$9 = var$12 + 1 | 0;
                    var$11[var$12] = jl_String_charAt(var$1, var$13);
                    var$13 = var$13 + 1 | 0;
                    var$12 = var$9;
                }
                var$4 = var$4 + 1 | 0;
            }
            var$1 = jl_String__init_(var$10);
        }
        return var$1;
    };
    $java.ju_HashMap$HashMapEntrySet = function() {
        ju_AbstractSet.call(this);
        this.$associatedMap = null;
    };
    var ju_LinkedHashMap$LinkedHashMapEntrySet = $rt_classWithoutFields($java.ju_HashMap$HashMapEntrySet);
    function ju_LinkedHashMap$LinkedHashMapEntrySet_iterator($this) {
        var var$1;
        var$1 = new ju_LinkedHashMap$EntryIterator;
        $java.ju_LinkedHashMap$AbstractMapIterator__init_(var$1, $this.$associatedMap);
        return var$1;
    }
    function oncias_Symbol() {
        var a = this; jl_Object.call(a);
        a.$name17 = null;
        a.$types1 = null;
        a.$definition = null;
        a.$uses = null;
        a.$unionSymbol = 0;
    }
    $java.oncias_Symbol_references = function($this) {
        return $this.$uses.$incl($this.$definition);
    };
    $java.oncias_Symbol_toString = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $java.oncias_SymbolUse_uniqueName($this.$definition);
        var$2 = sc_AbstractIterable_mkString0($this.$uses.$map1(new $java.oncias_Symbol$toString$lambda$_14_0), $rt_s(43));
        var$3 = $java.oncius_TypeSpec_toShortString($this.$types1);
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        var$1 = jl_StringBuilder_append(var$4, var$1);
        jl_AbstractStringBuilder_append(var$1, 40);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, var$2), $rt_s(2749)), var$3);
        return jl_AbstractStringBuilder_toString(var$4);
    };
    $java.oncias_Symbol_productArity = function($this) {
        return 5;
    };
    $java.oncias_Symbol_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name17;
            case 1:
                return $this.$types1;
            case 2:
                return $this.$definition;
            case 3:
                return $this.$uses;
            case 4:
                return jl_Boolean_valueOf($this.$unionSymbol);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_Symbol_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_Symbol_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2750))), sr_Statics_anyHash($this.$name17)), sr_Statics_anyHash($this.$types1)), sr_Statics_anyHash($this.$definition)), sr_Statics_anyHash($this.$uses)), !$this.$unionSymbol ? 1237 : 1231), 5);
    };
    $java.oncias_Symbol_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_Symbol) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$unionSymbol != $x$1.$unionSymbol)
                            break b;
                        d: {
                            var$2 = $this.$name17;
                            var$3 = $x$1.$name17;
                            if (var$2 !== null) {
                                if (!jl_String_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        e: {
                            var$2 = $this.$types1;
                            var$3 = $x$1.$types1;
                            if (var$2 !== null) {
                                if (!oncius_TypeSpec_equals(var$2, var$3))
                                    break b;
                                else
                                    break e;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        f: {
                            var$2 = $this.$definition;
                            var$3 = $x$1.$definition;
                            if (var$2 !== null) {
                                if (!$java.oncias_SymbolUse_equals(var$2, var$3))
                                    break b;
                                else
                                    break f;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$uses;
                        $x$1 = $x$1.$uses;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_0 = $rt_classWithoutFields();
    $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_0_apply = function(var$0, var$1) {
        return var$1.$name4;
    };
    $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_1 = $rt_classWithoutFields();
    $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_1_apply = function(var$0, var$1) {
        return var$1.$name4;
    };
    $java.oncie_MultiOperatorExpression = $rt_classWithoutFields(0);
    function oncie_Ands() {
        var a = this; oncie_Expression.call(a);
        a.$exprs0 = null;
        a.$position246 = null;
        a.$signatures11 = null;
    }
    function oncie_Ands__init_0(var_0, var_1) {
        var var_2 = new oncie_Ands();
        oncie_Ands__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_Ands_asCanonicalStringVal = function($this) {
        var var$1, var$2;
        var$1 = sc_AbstractIterable_mkString0(sc_StrictOptimizedIterableOps_map$($this.$exprs0, new $java.oncie_MultiOperatorExpression$asCanonicalStringVal$lambda$_2_0), $rt_s(16));
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2751)), $rt_s(2752)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    function oncie_Ands_exprs($this) {
        return $this.$exprs0;
    }
    $java.oncie_Ands_position = function($this) {
        return $this.$position246;
    };
    $java.oncie_Ands_canonicalOperatorSymbol = function($this) {
        return $rt_s(2751);
    };
    $java.oncie_Ands_signatures = function($this) {
        return $this.$signatures11;
    };
    $java.oncie_Ands_productPrefix = function($this) {
        return $rt_s(2753);
    };
    $java.oncie_Ands_productArity = function($this) {
        return 1;
    };
    $java.oncie_Ands_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$exprs0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Ands_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Ands_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Ands_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Ands_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Ands) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$exprs0;
                        $x$1 = $x$1.$exprs0;
                        if (var$2 === null) {
                            if ($x$1 === null)
                                break c;
                            break b;
                        }
                        if (!sc_Set_equals$(var$2, $x$1))
                            break b;
                    }
                    if (!($this instanceof oncie_Ands))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncie_Ands__init_($this, $exprs, $position) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        $this.$exprs0 = $exprs;
        $this.$position246 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$3 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$5 = $java.oncie_TypeSignature$_MODULE$;
        var$6 = s_package$_Vector0(s_package$_MODULE$);
        var$7 = $exprs.$size();
        $exprs = sci_Vector$_newBuilder(var$6);
        var$8 = 0;
        while (var$8 < var$7) {
            oncius_package$_$callClinit();
            sci_VectorBuilder_addOne($exprs, oncius_package$_CTBoolean(oncius_package$_MODULE$));
            var$8 = var$8 + 1 | 0;
        }
        var$9 = var$4.data;
        var$6 = sci_VectorBuilder_result($exprs);
        oncius_package$_$callClinit();
        var$9[0] = $java.oncie_TypeSignature$_apply(var$5, var$6, oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures11 = var$3.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$4));
    }
    $java.oncie_Expression$SemanticContext = $rt_classWithoutFields(0);
    var oncie_Expression$SemanticContext$Simple$ = $rt_classWithoutFields();
    $java.oncie_Expression$SemanticContext$Simple$_MODULE$ = null;
    function oncie_Expression$SemanticContext$Simple$__clinit_() {
        $java.oncie_Expression$SemanticContext$Simple$_MODULE$ = new oncie_Expression$SemanticContext$Simple$;
    }
    $java.oncia_Union$UnionMapping = function() {
        var a = this; jl_Object.call(a);
        a.$unionVariable = null;
        a.$variableInLhs = null;
        a.$variableInRhs = null;
    };
    $java.oncia_Union$UnionMapping_productPrefix = function($this) {
        return $rt_s(2754);
    };
    $java.oncia_Union$UnionMapping_productArity = function($this) {
        return 3;
    };
    $java.oncia_Union$UnionMapping_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$unionVariable;
            case 1:
                return $this.$variableInLhs;
            case 2:
                return $this.$variableInRhs;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Union$UnionMapping_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Union$UnionMapping_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Union$UnionMapping_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Union$UnionMapping_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_Union$UnionMapping) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$unionVariable;
                        var$3 = $x$1.$unionVariable;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$variableInLhs;
                        var$3 = $x$1.$variableInLhs;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$variableInRhs;
                        $x$1 = $x$1.$variableInRhs;
                        if (var$3 !== null) {
                            if (!$java.oncie_Variable_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_Union$UnionMapping))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    var oncie_IsAggregate$ = $rt_classWithoutFields();
    $java.oncie_IsAggregate$_MODULE$ = null;
    function oncie_IsAggregate$__clinit_() {
        $java.oncie_IsAggregate$_MODULE$ = new oncie_IsAggregate$;
    }
    $java.oncie_IsAggregate$_unapply = function($this, $v) {
        var var$2, var$3;
        var$2 = 0;
        var$3 = null;
        if ($v instanceof oncie_CountStar)
            return s_Some__init_($v);
        if ($v instanceof oncie_FunctionInvocation) {
            var$2 = 1;
            var$3 = $v;
            if (var$3.$distinct0)
                return s_Some__init_(var$3);
        }
        if (var$2) {
            if (!(var$3.$function0 instanceof $java.oncief_AggregatingFunction))
                return s_None$_MODULE$;
            return s_Some__init_(var$3);
        }
        if ($rt_isInstance($v, oncief_UserDefinedFunctionInvocation)) {
            $v = $v;
            if ($v.$isAggregate())
                return s_Some__init_($v);
        }
        return s_None$_MODULE$;
    };
    $java.oncie_Infinity$$anon$8 = $rt_classWithoutFields(oncie_Infinity);
    $java.oncie_NaN$$anon$9 = $rt_classWithoutFields(oncie_NaN);
    $java.oncie_Null$$anon$7 = $rt_classWithoutFields(oncie_Null);
    $java.oncie_True$$anon$10 = $rt_classWithoutFields(oncie_True);
    $java.oncie_containsAggregate$$anonfun$apply$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncie_containsAggregate$$anonfun$apply$1_applyOrElse = function($this, $x1, $default) {
        if ($x1 !== null && !s_Option_isEmpty($java.oncie_IsAggregate$_unapply($java.oncie_IsAggregate$_MODULE$, $x1)))
            return new $java.oncie_containsAggregate$$anonfun$apply$1$applyOrElse$lambda$_0_0;
        return s_PartialFunction$_fallback_fn;
    };
    $java.sci_HashMap$HashKeySet$filter$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0481 = null;
    };
    $java.sci_HashMap$HashKeySet$filter$lambda$_4_0__init_ = function(var_0) {
        var var_1 = new $java.sci_HashMap$HashKeySet$filter$lambda$_4_0();
        $java.sci_HashMap$HashKeySet$filter$lambda$_4_0__init_0(var_1, var_0);
        return var_1;
    };
    $java.sci_HashMap$HashKeySet$filter$lambda$_4_0__init_0 = function(var$0, var$1) {
        var$0.$_0481 = var$1;
    };
    $java.sci_HashMap$HashKeySet$filter$lambda$_4_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(sc_AbstractSet_apply0(var$0.$_0481, var$1.$_10)));
    };
    $java.jusi_SimpleStreamImpl$ArrayFillingConsumer = function() {
        var a = this; jl_Object.call(a);
        a.$array5 = null;
        a.$index1 = 0;
    };
    $java.jusi_SimpleStreamImpl$ArrayFillingConsumer_test = function($this, $t) {
        var var$2, var$3;
        var$2 = $this.$array5.data;
        var$3 = $this.$index1;
        $this.$index1 = var$3 + 1 | 0;
        var$2[var$3] = $t;
        return 1;
    };
    $java.jusi_SimpleStreamImpl$toArray$lambda$_20_0 = function() {
        jl_Object.call(this);
        this.$_0383 = null;
    };
    $java.jusi_SimpleStreamImpl$toArray$lambda$_20_0_test = function(var$0, var$1) {
        return ju_ArrayList_add(var$0.$_0383, var$1);
    };
    var oncir_Deprecations$syntacticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider$lambda$_6_0 = $rt_classWithoutFields();
    $java.oncir_Deprecations$syntacticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider$lambda$_6_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        a: {
            var$1 = var$1;
            oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit();
            if (var$1 !== null) {
                var$2 = var$1.$_10;
                var$1 = var$1.$_20;
                if (var$1 instanceof oncie_StringLiteral) {
                    var$3 = var$1;
                    if (jl_String_equalsIgnoreCase(var$2, $rt_s(1860))) {
                        var$4 = jl_String_equalsIgnoreCase(var$3.$value25, $rt_s(2755));
                        break a;
                    }
                }
            }
            var$4 = 0;
        }
        return jl_Boolean_valueOf(var$4);
    };
    $java.oncifp_ListCoercedToBooleanCheck$$org$neo4j$cypher$internal$frontend$phases$ListCoercedToBooleanCheck$$isListCoercedToBoolean$lambda$_2_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0315 = null;
        a.$_194 = null;
    };
    $java.oncifp_ListCoercedToBooleanCheck$$org$neo4j$cypher$internal$frontend$phases$ListCoercedToBooleanCheck$$isListCoercedToBoolean$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0315;
        var$3 = var$0.$_194;
        oncius_package$_$callClinit();
        var$4 = oncius_package$_MODULE$;
        return jl_Boolean_valueOf($java.oncius_TypeSpec_containsAll($java.oncius_ListType_covariant(oncius_package$_CTList(var$4, oncius_package$_CTAny(var$4))), var$1.$specified) && oncifp_ExpectedBooleanTypeCheck_isExpectedTypeBoolean$(oncifp_ListCoercedToBooleanCheck$_MODULE$, var$2, var$3) ? 1 : 0);
    };
    var jnc_BufferUnderflowException = $rt_classWithoutFields(jl_RuntimeException);
    var jnc_BufferOverflowException = $rt_classWithoutFields(jl_RuntimeException);
    function jnc_MalformedInputException() {
        jnc_CharacterCodingException.call(this);
        this.$length4 = 0;
    }
    $java.jnc_MalformedInputException_getMessage = function($this) {
        var var$1, var$2;
        var$1 = $this.$length4;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$2, $rt_s(2756)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    function jnc_UnmappableCharacterException() {
        jnc_CharacterCodingException.call(this);
        this.$length5 = 0;
    }
    $java.jnc_UnmappableCharacterException_getMessage = function($this) {
        var var$1, var$2;
        var$1 = $this.$length5;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$2, $rt_s(2757)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    function oncie_MapExpression() {
        var a = this; oncie_Expression.call(a);
        a.$items5 = null;
        a.$position247 = null;
    }
    $java.oncie_MapExpression__init_ = function(var_0, var_1) {
        var var_2 = new oncie_MapExpression();
        oncie_MapExpression__init_(var_2, var_0, var_1);
        return var_2;
    };
    function oncie_MapExpression_items($this) {
        return $this.$items5;
    }
    $java.oncie_MapExpression_position = function($this) {
        return $this.$position247;
    };
    $java.oncie_MapExpression_asCanonicalStringVal = function($this) {
        return sc_IterableOnceOps_mkString$($this.$items5.$map1(new $java.oncie_MapExpression$asCanonicalStringVal$lambda$_4_0), $rt_s(146), $rt_s(16), $rt_s(147));
    };
    $java.oncie_MapExpression_productPrefix = function($this) {
        return $rt_s(2758);
    };
    $java.oncie_MapExpression_productArity = function($this) {
        return 1;
    };
    $java.oncie_MapExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$items5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_MapExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MapExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MapExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_MapExpression_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_MapExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$items5;
                        $x$1 = $x$1.$items5;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_MapExpression))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncie_MapExpression__init_($this, $items, $position) {
        $this.$items5 = $items;
        $this.$position247 = $position;
        $java.oncie_Expression__init_($this);
    }
    $java.oncie_GraphPatternQuantifier = $rt_classWithoutFields(0);
    $java.oncie_OctalIntegerLiteral = function() {
        var a = this; oncie_Expression.call(a);
        a.$octalMatcher = null;
        a.$value33 = null;
        a.$stringVal3 = null;
        a.$bitmap$030 = 0;
    };
    $java.oncie_OctalIntegerLiteral_asCanonicalStringVal = function($this) {
        return $this.$stringVal1();
    };
    $java.oncie_OctalIntegerLiteral_octalMatcher = function($this) {
        var var$1, var$2, $$je;
        if (($this.$bitmap$030 & 1) << 24 >> 24)
            return $this.$octalMatcher;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$030 & 1) << 24 >> 24)
                    break a;
                var$1 = sc_StringOps$_MODULE$;
                s_Predef$_$callClinit();
                $this.$octalMatcher = sc_StringOps$_r$extension(var$1, s_Predef$_augmentString(s_Predef$_MODULE$, $rt_s(2759)));
                $this.$bitmap$030 = ($this.$bitmap$030 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$2);
        }
        jl_Object_monitorExitSync($this);
        return $this.$octalMatcher;
    };
    $java.oncie_OctalIntegerLiteral_value = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$030 & 2) << 24 >> 24)
            return $this.$value33;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$030 & 2) << 24 >> 24)
                    break a;
                var$1 = $this.$stringVal3;
                if (var$1 !== null && !s_Option_isEmpty($java.sum_Regex_unapplySeq($java.oncie_OctalIntegerLiteral_octalMatcher($this), var$1))) {
                    s_Predef$_$callClinit();
                    var$1 = jl_Long_decode(sc_AbstractIterable_mkString1(sci_List_filter(sci_List_filter(sc_AbstractIterable_toList(s_LowPriorityImplicits_wrapString(s_Predef$_MODULE$, $this.$stringVal3)), $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0__init_()), $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1__init_())));
                } else {
                    s_Predef$_$callClinit();
                    var$1 = jl_Long_decode(sc_AbstractIterable_mkString1(sci_List_filter(sc_AbstractIterable_toList(s_LowPriorityImplicits_wrapString(s_Predef$_MODULE$, $this.$stringVal3)), $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2__init_())));
                }
                $this.$value33 = var$1;
                $this.$bitmap$030 = ($this.$bitmap$030 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$value33;
    };
    function oncie_SignedOctalIntegerLiteral() {
        var a = this; $java.oncie_OctalIntegerLiteral.call(a);
        a.$stringVal4 = null;
        a.$position248 = null;
    }
    function oncie_SignedOctalIntegerLiteral__init_(var_0, var_1) {
        var var_2 = new oncie_SignedOctalIntegerLiteral();
        oncie_SignedOctalIntegerLiteral__init_0(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_SignedOctalIntegerLiteral_stringVal = function($this) {
        return $this.$stringVal4;
    };
    $java.oncie_SignedOctalIntegerLiteral_position = function($this) {
        return $this.$position248;
    };
    $java.oncie_SignedOctalIntegerLiteral_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_SignedOctalIntegerLiteral$$anon$3;
        oncie_SignedOctalIntegerLiteral__init_0(var$1, $this.$stringVal4, $this.$position248);
        return var$1;
    };
    $java.oncie_SignedOctalIntegerLiteral_copy = function($this, $stringVal, $position) {
        return oncie_SignedOctalIntegerLiteral__init_($stringVal, $position);
    };
    $java.oncie_SignedOctalIntegerLiteral_productPrefix = function($this) {
        return $rt_s(2760);
    };
    $java.oncie_SignedOctalIntegerLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_SignedOctalIntegerLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$stringVal4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SignedOctalIntegerLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedOctalIntegerLiteral_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_SignedOctalIntegerLiteral;
    };
    $java.oncie_SignedOctalIntegerLiteral_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedOctalIntegerLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedOctalIntegerLiteral_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_SignedOctalIntegerLiteral) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$stringVal4;
                        $x$1 = $x$1.$stringVal4;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_SignedOctalIntegerLiteral))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncie_SignedOctalIntegerLiteral__init_0($this, $stringVal, $position) {
        $this.$stringVal4 = $stringVal;
        $this.$position248 = $position;
        $this.$stringVal3 = $stringVal;
        $java.oncie_Expression__init_($this);
    }
    $java.oncie_HexIntegerLiteral = function() {
        var a = this; oncie_Expression.call(a);
        a.$hexMatcher = null;
        a.$value34 = null;
        a.$stringVal5 = null;
        a.$bitmap$031 = 0;
    };
    $java.oncie_HexIntegerLiteral_asCanonicalStringVal = function($this) {
        return $this.$stringVal1();
    };
    $java.oncie_HexIntegerLiteral_hexMatcher = function($this) {
        var var$1, var$2, $$je;
        if (($this.$bitmap$031 & 1) << 24 >> 24)
            return $this.$hexMatcher;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$031 & 1) << 24 >> 24)
                    break a;
                var$1 = sc_StringOps$_MODULE$;
                s_Predef$_$callClinit();
                $this.$hexMatcher = sc_StringOps$_r$extension(var$1, s_Predef$_augmentString(s_Predef$_MODULE$, $rt_s(2761)));
                $this.$bitmap$031 = ($this.$bitmap$031 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$2);
        }
        jl_Object_monitorExitSync($this);
        return $this.$hexMatcher;
    };
    $java.oncie_HexIntegerLiteral_value = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$031 & 2) << 24 >> 24)
            return $this.$value34;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$031 & 2) << 24 >> 24)
                    break a;
                var$1 = $this.$stringVal5;
                if (var$1 !== null && !s_Option_isEmpty($java.sum_Regex_unapplySeq($java.oncie_HexIntegerLiteral_hexMatcher($this), var$1))) {
                    s_Predef$_$callClinit();
                    var$1 = jl_Long_decode(sc_AbstractIterable_mkString1(sci_List_filter(sc_AbstractIterable_toList(s_LowPriorityImplicits_wrapString(s_Predef$_MODULE$, $this.$stringVal5)), $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0__init_())));
                } else
                    var$1 = jl_Long_decode($this.$stringVal5);
                $this.$value34 = var$1;
                $this.$bitmap$031 = ($this.$bitmap$031 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$value34;
    };
    function oncie_SignedHexIntegerLiteral() {
        var a = this; $java.oncie_HexIntegerLiteral.call(a);
        a.$stringVal6 = null;
        a.$position249 = null;
    }
    function oncie_SignedHexIntegerLiteral__init_(var_0, var_1) {
        var var_2 = new oncie_SignedHexIntegerLiteral();
        oncie_SignedHexIntegerLiteral__init_0(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_SignedHexIntegerLiteral_stringVal = function($this) {
        return $this.$stringVal6;
    };
    $java.oncie_SignedHexIntegerLiteral_position = function($this) {
        return $this.$position249;
    };
    $java.oncie_SignedHexIntegerLiteral_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_SignedHexIntegerLiteral$$anon$4;
        oncie_SignedHexIntegerLiteral__init_0(var$1, $this.$stringVal6, $this.$position249);
        return var$1;
    };
    $java.oncie_SignedHexIntegerLiteral_copy = function($this, $stringVal, $position) {
        return oncie_SignedHexIntegerLiteral__init_($stringVal, $position);
    };
    $java.oncie_SignedHexIntegerLiteral_productPrefix = function($this) {
        return $rt_s(2762);
    };
    $java.oncie_SignedHexIntegerLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_SignedHexIntegerLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$stringVal6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SignedHexIntegerLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedHexIntegerLiteral_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_SignedHexIntegerLiteral;
    };
    $java.oncie_SignedHexIntegerLiteral_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedHexIntegerLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SignedHexIntegerLiteral_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_SignedHexIntegerLiteral) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$stringVal6;
                        $x$1 = $x$1.$stringVal6;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_SignedHexIntegerLiteral))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    function oncie_SignedHexIntegerLiteral__init_0($this, $stringVal, $position) {
        $this.$stringVal6 = $stringVal;
        $this.$position249 = $position;
        $this.$stringVal5 = $stringVal;
        $java.oncie_Expression__init_($this);
    }
    $java.oncie_DoubleLiteral = $rt_classWithoutFields(0);
    function oncie_DecimalDoubleLiteral() {
        var a = this; oncie_Expression.call(a);
        a.$doubleMatcher = null;
        a.$value35 = null;
        a.$stringVal7 = null;
        a.$position250 = null;
        a.$bitmap$032 = 0;
    }
    function oncie_DecimalDoubleLiteral__init_(var_0, var_1) {
        var var_2 = new oncie_DecimalDoubleLiteral();
        $java.oncie_DecimalDoubleLiteral__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_DecimalDoubleLiteral_asCanonicalStringVal = function($this) {
        return $this.$stringVal1();
    };
    $java.oncie_DecimalDoubleLiteral_stringVal = function($this) {
        return $this.$stringVal7;
    };
    $java.oncie_DecimalDoubleLiteral_position = function($this) {
        return $this.$position250;
    };
    $java.oncie_DecimalDoubleLiteral_doubleMatcher = function($this) {
        var var$1, var$2, $$je;
        if (($this.$bitmap$032 & 1) << 24 >> 24)
            return $this.$doubleMatcher;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$032 & 1) << 24 >> 24)
                    break a;
                var$1 = sc_StringOps$_MODULE$;
                s_Predef$_$callClinit();
                $this.$doubleMatcher = sc_StringOps$_r$extension(var$1, s_Predef$_augmentString(s_Predef$_MODULE$, $rt_s(2763)));
                $this.$bitmap$032 = ($this.$bitmap$032 | 1) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$2 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$2);
        }
        jl_Object_monitorExitSync($this);
        return $this.$doubleMatcher;
    };
    $java.oncie_DecimalDoubleLiteral_value = function($this) {
        var var$1, $$je;
        if (($this.$bitmap$032 & 2) << 24 >> 24)
            return $this.$value35;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if (($this.$bitmap$032 & 2) << 24 >> 24)
                    break a;
                var$1 = $java.oncie_DecimalDoubleLiteral_stringVal($this);
                if (var$1 !== null && !s_Option_isEmpty($java.sum_Regex_unapplySeq($java.oncie_DecimalDoubleLiteral_doubleMatcher($this), var$1))) {
                    s_Predef$_$callClinit();
                    var$1 = s_Predef$_MODULE$;
                    var$1 = s_Predef$_double2Double(var$1, jl_Double_parseDouble(sc_AbstractIterable_mkString1(sci_List_filter(sc_AbstractIterable_toList(s_LowPriorityImplicits_wrapString(var$1, $java.oncie_DecimalDoubleLiteral_stringVal($this))), $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0__init_()))));
                } else {
                    s_Predef$_$callClinit();
                    var$1 = s_Predef$_double2Double(s_Predef$_MODULE$, jl_Double_parseDouble($java.oncie_DecimalDoubleLiteral_stringVal($this)));
                }
                $this.$value35 = var$1;
                $this.$bitmap$032 = ($this.$bitmap$032 | 2) << 24 >> 24;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$value35;
    };
    $java.oncie_DecimalDoubleLiteral_asSensitiveLiteral = function($this) {
        var var$1;
        var$1 = new $java.oncie_DecimalDoubleLiteral$$anon$5;
        $java.oncie_DecimalDoubleLiteral__init_(var$1, $this.$stringVal7, $this.$position250);
        return var$1;
    };
    $java.oncie_DecimalDoubleLiteral_copy = function($this, $stringVal, $position) {
        return oncie_DecimalDoubleLiteral__init_($stringVal, $position);
    };
    $java.oncie_DecimalDoubleLiteral_productPrefix = function($this) {
        return $rt_s(2764);
    };
    $java.oncie_DecimalDoubleLiteral_productArity = function($this) {
        return 1;
    };
    $java.oncie_DecimalDoubleLiteral_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$stringVal7;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_DecimalDoubleLiteral_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_DecimalDoubleLiteral_canEqual = function($this, $x$1) {
        return $x$1 instanceof oncie_DecimalDoubleLiteral;
    };
    $java.oncie_DecimalDoubleLiteral_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_DecimalDoubleLiteral_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_DecimalDoubleLiteral_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_DecimalDoubleLiteral) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$stringVal7;
                        $x$1 = $x$1.$stringVal7;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_DecimalDoubleLiteral))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_DecimalDoubleLiteral__init_ = function($this, $stringVal, $position) {
        $this.$stringVal7 = $stringVal;
        $this.$position250 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_CaseExpression() {
        var a = this; oncie_Expression.call(a);
        a.$possibleExpressions0 = null;
        a.$expression16 = null;
        a.$alternatives0 = null;
        a.$default2 = null;
        a.$position251 = null;
        a.$bitmap$033 = 0;
    }
    $java.oncie_CaseExpression__init_ = function(var_0, var_1, var_2, var_3) {
        var var_4 = new oncie_CaseExpression();
        oncie_CaseExpression__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    function oncie_CaseExpression_expression($this) {
        return $this.$expression16;
    }
    function oncie_CaseExpression_alternatives($this) {
        return $this.$alternatives0;
    }
    function oncie_CaseExpression_default($this) {
        return $this.$default2;
    }
    $java.oncie_CaseExpression_position = function($this) {
        return $this.$position251;
    };
    $java.oncie_CaseExpression_possibleExpressions = function($this) {
        var var$1, $$je;
        if ($this.$bitmap$033)
            return $this.$possibleExpressions0;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$033)
                    break a;
                $this.$possibleExpressions0 = sc_AbstractIterable_$plus$plus((oncie_CaseExpression_alternatives($this)).$map1($java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0__init_()), oncie_CaseExpression_default($this));
                $this.$bitmap$033 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$possibleExpressions0;
    };
    $java.oncie_CaseExpression_productPrefix = function($this) {
        return $rt_s(2765);
    };
    $java.oncie_CaseExpression_productArity = function($this) {
        return 3;
    };
    $java.oncie_CaseExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expression16;
            case 1:
                return $this.$alternatives0;
            case 2:
                return $this.$default2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_CaseExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_CaseExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_CaseExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_CaseExpression_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_CaseExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expression16;
                        var$3 = $x$1.$expression16;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$alternatives0;
                        var$3 = $x$1.$alternatives0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$default2;
                        $x$1 = $x$1.$default2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_CaseExpression))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function oncie_CaseExpression__init_($this, $expression, $alternatives, $default, $position) {
        $this.$expression16 = $expression;
        $this.$alternatives0 = $alternatives;
        $this.$default2 = $default;
        $this.$position251 = $position;
        $java.oncie_Expression__init_($this);
    }
    var oncie_ListComprehension$ = $rt_classWithoutFields();
    $java.oncie_ListComprehension$_MODULE$ = null;
    function oncie_ListComprehension$__clinit_() {
        $java.oncie_ListComprehension$_MODULE$ = new oncie_ListComprehension$;
    }
    function oncie_PatternComprehension() {
        var a = this; oncie_Expression.call(a);
        a.$namedPath0 = null;
        a.$pattern7 = null;
        a.$predicate2 = null;
        a.$projection0 = null;
        a.$position252 = null;
        a.$computedIntroducedVariables4 = null;
        a.$computedScopeDependencies4 = null;
    }
    $java.oncie_PatternComprehension__init_ = function(var_0, var_1, var_2, var_3, var_4, var_5, var_6) {
        var var_7 = new oncie_PatternComprehension();
        oncie_PatternComprehension__init_(var_7, var_0, var_1, var_2, var_3, var_4, var_5, var_6);
        return var_7;
    };
    $java.oncie_PatternComprehension_introducedVariables = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_introducedVariables$($this);
    };
    $java.oncie_PatternComprehension_scopeDependencies = function($this) {
        return $java.oncie_ExpressionWithComputedDependencies_scopeDependencies$($this);
    };
    $java.oncie_PatternComprehension_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    function oncie_PatternComprehension_namedPath($this) {
        return $this.$namedPath0;
    }
    function oncie_PatternComprehension_pattern($this) {
        return $this.$pattern7;
    }
    function oncie_PatternComprehension_predicate($this) {
        return $this.$predicate2;
    }
    function oncie_PatternComprehension_projection($this) {
        return $this.$projection0;
    }
    $java.oncie_PatternComprehension_position = function($this) {
        return $this.$position252;
    };
    $java.oncie_PatternComprehension_computedIntroducedVariables = function($this) {
        return $this.$computedIntroducedVariables4;
    };
    $java.oncie_PatternComprehension_computedScopeDependencies = function($this) {
        return $this.$computedScopeDependencies4;
    };
    $java.oncie_PatternComprehension_withComputedIntroducedVariables = function($this, $computedIntroducedVariables) {
        return $java.oncie_PatternComprehension_copy($this, $this.$namedPath0, $this.$pattern7, $this.$predicate2, $this.$projection0, $this.$position252, s_Some__init_($computedIntroducedVariables), $this.$computedScopeDependencies4);
    };
    $java.oncie_PatternComprehension_withComputedScopeDependencies = function($this, $computedScopeDependencies) {
        return $java.oncie_PatternComprehension_copy($this, $this.$namedPath0, $this.$pattern7, $this.$predicate2, $this.$projection0, $this.$position252, $this.$computedIntroducedVariables4, s_Some__init_($computedScopeDependencies));
    };
    $java.oncie_PatternComprehension_subqueryAstNode = function($this) {
        return $this.$pattern7;
    };
    $java.oncie_PatternComprehension_dup = function($this, $children) {
        return $java.oncie_PatternComprehension__init_($children.$apply1(0), $children.$apply1(1), $children.$apply1(2), $children.$apply1(3), $this.$position252, $this.$computedIntroducedVariables4, $this.$computedScopeDependencies4);
    };
    $java.oncie_PatternComprehension_copy = function($this, $namedPath, $pattern, $predicate, $projection, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        return $java.oncie_PatternComprehension__init_($namedPath, $pattern, $predicate, $projection, $position, $computedIntroducedVariables, $computedScopeDependencies);
    };
    $java.oncie_PatternComprehension_productPrefix = function($this) {
        return $rt_s(2766);
    };
    $java.oncie_PatternComprehension_productArity = function($this) {
        return 4;
    };
    $java.oncie_PatternComprehension_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$namedPath0;
            case 1:
                return $this.$pattern7;
            case 2:
                return $this.$predicate2;
            case 3:
                return $this.$projection0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PatternComprehension_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternComprehension_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternComprehension_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PatternComprehension_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PatternComprehension) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$namedPath0;
                        var$3 = $x$1.$namedPath0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$pattern7;
                        var$3 = $x$1.$pattern7;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelationshipsPattern_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$2 = $this.$predicate2;
                        var$3 = $x$1.$predicate2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break e;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    f: {
                        var$3 = $this.$projection0;
                        $x$1 = $x$1.$projection0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break f;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PatternComprehension))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_PatternComprehension_dup0 = function($this, $children) {
        return $java.oncie_PatternComprehension_dup($this, $children);
    };
    $java.oncie_PatternComprehension_dup1 = function($this, $children) {
        return $java.oncie_PatternComprehension_dup($this, $children);
    };
    function oncie_PatternComprehension__init_($this, $namedPath, $pattern, $predicate, $projection, $position, $computedIntroducedVariables, $computedScopeDependencies) {
        $this.$namedPath0 = $namedPath;
        $this.$pattern7 = $pattern;
        $this.$predicate2 = $predicate;
        $this.$projection0 = $projection;
        $this.$position252 = $position;
        $this.$computedIntroducedVariables4 = $computedIntroducedVariables;
        $this.$computedScopeDependencies4 = $computedScopeDependencies;
        $java.oncie_Expression__init_($this);
    }
    function oncie_RelationshipsPattern() {
        var a = this; jl_Object.call(a);
        a.$element5 = null;
        a.$position224 = null;
    }
    function oncie_RelationshipsPattern__init_(var_0, var_1) {
        var var_2 = new oncie_RelationshipsPattern();
        $java.oncie_RelationshipsPattern__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_RelationshipsPattern_foldedOver = function($this) {
        return $this;
    };
    $java.oncie_RelationshipsPattern_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    function oncie_RelationshipsPattern_element($this) {
        return $this.$element5;
    }
    $java.oncie_RelationshipsPattern_position = function($this) {
        return $this.$position224;
    };
    $java.oncie_RelationshipsPattern_productPrefix = function($this) {
        return $rt_s(2767);
    };
    $java.oncie_RelationshipsPattern_productArity = function($this) {
        return 1;
    };
    $java.oncie_RelationshipsPattern_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$element5;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_RelationshipsPattern_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipsPattern_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipsPattern_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RelationshipsPattern_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_RelationshipsPattern) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$element5;
                        $x$1 = $x$1.$element5;
                        if (var$2 !== null) {
                            if (!$java.oncie_RelationshipChain_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_RelationshipsPattern))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_RelationshipsPattern_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_RelationshipsPattern__init_ = function($this, $element, $position) {
        $this.$element5 = $element;
        $this.$position224 = $position;
    };
    var oncie_ReduceExpression$ = $rt_classWithoutFields();
    $java.oncie_ReduceExpression$_MODULE$ = null;
    $java.oncie_ReduceExpression$_AccumulatorExpressionTypeMismatchMessageGenerator0 = null;
    function oncie_ReduceExpression$__clinit_() {
        $java.oncie_ReduceExpression$_MODULE$ = new oncie_ReduceExpression$;
        $java.oncie_ReduceExpression$_AccumulatorExpressionTypeMismatchMessageGenerator0 = new $java.oncie_ReduceExpression$$_clinit_$lambda$_0_0;
    }
    $java.oncie_ReduceExpression$_AccumulatorExpressionTypeMismatchMessageGenerator = function($this) {
        return $java.oncie_ReduceExpression$_AccumulatorExpressionTypeMismatchMessageGenerator0;
    };
    $java.oncie_IterableExpressionWithInfo = $rt_classWithoutFields(0);
    var oncie_AllIterablePredicate$ = $rt_classWithoutFields();
    $java.oncie_AllIterablePredicate$_MODULE$ = null;
    $java.oncie_AllIterablePredicate$_name = null;
    $java.oncie_AllIterablePredicate$_description = null;
    function oncie_AllIterablePredicate$__clinit_() {
        $java.oncie_AllIterablePredicate$_MODULE$ = new oncie_AllIterablePredicate$;
        $java.oncie_AllIterablePredicate$_name = $rt_s(156);
        $java.oncie_AllIterablePredicate$_description = $rt_s(2768);
    }
    var oncie_AnyIterablePredicate$ = $rt_classWithoutFields();
    $java.oncie_AnyIterablePredicate$_MODULE$ = null;
    $java.oncie_AnyIterablePredicate$_name = null;
    $java.oncie_AnyIterablePredicate$_description = null;
    function oncie_AnyIterablePredicate$__clinit_() {
        $java.oncie_AnyIterablePredicate$_MODULE$ = new oncie_AnyIterablePredicate$;
        $java.oncie_AnyIterablePredicate$_name = $rt_s(152);
        $java.oncie_AnyIterablePredicate$_description = $rt_s(2769);
    }
    var oncie_NoneIterablePredicate$ = $rt_classWithoutFields();
    $java.oncie_NoneIterablePredicate$_MODULE$ = null;
    $java.oncie_NoneIterablePredicate$_name = null;
    $java.oncie_NoneIterablePredicate$_description = null;
    function oncie_NoneIterablePredicate$__clinit_() {
        $java.oncie_NoneIterablePredicate$_MODULE$ = new oncie_NoneIterablePredicate$;
        $java.oncie_NoneIterablePredicate$_name = $rt_s(157);
        $java.oncie_NoneIterablePredicate$_description = $rt_s(2770);
    }
    var oncie_SingleIterablePredicate$ = $rt_classWithoutFields();
    $java.oncie_SingleIterablePredicate$_MODULE$ = null;
    $java.oncie_SingleIterablePredicate$_name = null;
    $java.oncie_SingleIterablePredicate$_description = null;
    function oncie_SingleIterablePredicate$__clinit_() {
        $java.oncie_SingleIterablePredicate$_MODULE$ = new oncie_SingleIterablePredicate$;
        $java.oncie_SingleIterablePredicate$_name = $rt_s(158);
        $java.oncie_SingleIterablePredicate$_description = $rt_s(2771);
    }
    function oncie_ShortestPathExpression() {
        oncie_Expression.call(this);
        this.$pattern8 = null;
    }
    function oncie_ShortestPathExpression__init_(var_0) {
        var var_1 = new oncie_ShortestPathExpression();
        $java.oncie_ShortestPathExpression__init_(var_1, var_0);
        return var_1;
    }
    function oncie_ShortestPathExpression_pattern($this) {
        return $this.$pattern8;
    }
    $java.oncie_ShortestPathExpression_position = function($this) {
        return $this.$pattern8.$position42;
    };
    $java.oncie_ShortestPathExpression_productPrefix = function($this) {
        return $rt_s(2772);
    };
    $java.oncie_ShortestPathExpression_productArity = function($this) {
        return 1;
    };
    $java.oncie_ShortestPathExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$pattern8;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ShortestPathExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ShortestPathExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ShortestPathExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ShortestPathExpression_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ShortestPathExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$pattern8;
                        $x$1 = $x$1.$pattern8;
                        if (var$2 !== null) {
                            if (!$java.oncie_ShortestPathsPatternPart_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ShortestPathExpression))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_ShortestPathExpression__init_ = function($this, $pattern) {
        $this.$pattern8 = $pattern;
        $java.oncie_Expression__init_($this);
    };
    function sci_HashMap$accum$1() {
        var a = this; $java.sr_AbstractFunction2.call(a);
        a.$changed = 0;
        a.$shallowlyMutableNodeMap = 0;
        a.$current1 = null;
        a.$$outer48 = null;
    }
    function sci_HashMap$accum$1__init_(var_0) {
        var var_1 = new sci_HashMap$accum$1();
        $java.sci_HashMap$accum$1__init_(var_1, var_0);
        return var_1;
    }
    $java.sci_HashMap$accum$1_apply = function($this, $key, $value) {
        var $originalHash, $improved;
        $originalHash = sr_Statics_anyHash($key);
        $improved = sc_Hashing$_improve(sc_Hashing$_MODULE$, $originalHash);
        if ($this.$changed) {
            $this.$shallowlyMutableNodeMap = sci_BitmapIndexedMapNode_updateWithShallowMutations($this.$current1, $key, $value, $originalHash, $improved, 0, $this.$shallowlyMutableNodeMap);
            return;
        }
        $key = sci_BitmapIndexedMapNode_updated($this.$current1, $key, $value, $originalHash, $improved, 0, 1);
        $this.$current1 = $key;
        if ($key === $this.$$outer48.$rootNode)
            return;
        $this.$changed = 1;
        $this.$shallowlyMutableNodeMap = 1 << ($improved >>> 0 & 31);
    };
    $java.sci_HashMap$accum$1_apply0 = function($this, $v1, $v2) {
        $java.sci_HashMap$accum$1_apply($this, $v1, $v2);
        return sr_BoxedUnit_UNIT;
    };
    $java.sci_HashMap$accum$1_apply1 = function($this, $v1) {
        $v1 = $v1;
        $java.sci_HashMap$accum$1_apply($this, $v1.$_10, $v1.$_20);
        return sr_BoxedUnit_UNIT;
    };
    $java.sci_HashMap$accum$1__init_ = function($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer48 = $$outer;
        $this.$changed = 0;
        $this.$shallowlyMutableNodeMap = 0;
        $this.$current1 = $$outer.$rootNode;
    };
    var sci_MapNodeRemoveAllSetNodeIterator = $rt_classWithoutFields(sci_ChampBaseIterator);
    function oncifp_ValidSymbolicNamesInLabelExpressions$$org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames$lambda$_31_0() {
        jl_Object.call(this);
        this.$_0163 = null;
    }
    $java.oncifp_ValidSymbolicNamesInLabelExpressions$$org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames$lambda$_31_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0163;
        var$3 = var$1.$position2();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(2773)), var$1), $rt_s(2774)), var$2), $rt_s(2775)), var$3);
        return jl_AbstractStringBuilder_toString(var$4);
    };
    var scm_HashMap$$anon$6 = $rt_classWithoutFields(scm_GrowableBuilder);
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_0_apply = function(var$0, var$1) {
        return var$1.$expression1();
    };
    $java.oncia_ReturnItems$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_ReturnItems$$anonfun$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        if (!($java.oncie_Expression_containsAggregate($x) && !$rt_isInstance($x, oncia_FullSubqueryExpression)))
            $x = $default.$apply($x);
        return $x;
    };
    $java.oncia_ReturnItems$$anonfun$2 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_ReturnItems$$anonfun$2_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return !($x instanceof oncie_LogicalVariable) ? $default.$apply($x) : $x;
    };
    $java.oncia_ReturnItems$$anonfun$3 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_ReturnItems$$anonfun$3_applyOrElse = function($this, $x, $default) {
        var var$3, var$4;
        a: {
            $x = $x;
            if ($x instanceof $java.oncie_LogicalProperty) {
                var$3 = $x;
                var$4 = $java.oncie_LogicalProperty$_unapply($java.oncie_LogicalProperty$_MODULE$, var$3);
                if (!s_Option_isEmpty(var$4)) {
                    var$4 = var$4.$value5.$_10;
                    if (var$4 instanceof oncie_LogicalVariable) {
                        var$4 = var$4;
                        if (!s_Option_isEmpty(s_Some__init_(var$4.$name4)))
                            break a;
                    }
                }
            }
            var$3 = $default.$apply($x);
        }
        return var$3;
    };
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0444 = null;
        a.$_1133 = null;
    };
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0444;
        var$3 = var$0.$_1133;
        var$4 = onciu_Foldable_folder$(var$1);
        var$1 = new $java.oncie_Expression$TreeAcc;
        s_package$_$callClinit();
        $java.oncie_Expression$TreeAcc__init_(var$1, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), $java.oncie_Expression$TreeAcc$_apply$default$2($java.oncie_Expression$TreeAcc$_MODULE$));
        var$5 = new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1;
        var$5.$variablesUsedForGrouping$1 = var$2;
        var$5.$nonNestedPropertiesUsedForGrouping$1 = var$3;
        return (onciu_Foldable$Folder_treeFold(var$4, var$1, var$5)).$data0;
    };
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_2 = $rt_classWithoutFields();
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_2_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    $java.oncias_package$$liftSemanticEitherFunc$lambda$_2_0 = function() {
        jl_Object.call(this);
        this.$_0369 = null;
    };
    $java.oncias_package$$liftSemanticEitherFunc$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0369.$apply(var$1);
        var$3 = new $java.oncias_package$$$anonfun$liftSemanticEitherFunc$1$lambda$_14_0;
        var$3.$_0225 = var$1;
        return su_Either_fold(var$2, var$3, new $java.oncias_package$$$anonfun$liftSemanticEitherFunc$1$lambda$_14_1);
    };
    $java.oncia_SubqueryCall$reportParams$lambda$_61_0 = $rt_classWithoutFields();
    $java.oncia_SubqueryCall$reportParams$lambda$_61_0_apply = function(var$0, var$1) {
        return var$1.$reportParams;
    };
    $java.oncia_Union$Mapping$1 = function() {
        var a = this; jl_Object.call(a);
        a.$unionVariable0 = null;
        a.$variableInLhsName = null;
        a.$variableInRhsName = null;
        a.$$outer49 = null;
    };
    $java.oncia_Union$Mapping$1_productPrefix = function($this) {
        return $rt_s(2776);
    };
    $java.oncia_Union$Mapping$1_productArity = function($this) {
        return 3;
    };
    $java.oncia_Union$Mapping$1_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$unionVariable0;
            case 1:
                return $this.$variableInLhsName;
            case 2:
                return $this.$variableInRhsName;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Union$Mapping$1_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Union$Mapping$1_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Union$Mapping$1_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Union$Mapping$1_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_Union$Mapping$1) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$unionVariable0;
                        var$3 = $x$1.$unionVariable0;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$variableInLhsName;
                        var$3 = $x$1.$variableInLhsName;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$variableInRhsName;
                        $x$1 = $x$1.$variableInRhsName;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_Union$Mapping$1))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncius_ClosedDynamicUnionType$updateIsNullable$lambda$_30_0 = function() {
        jl_Object.call(this);
        this.$_0397 = 0;
    };
    $java.oncius_ClosedDynamicUnionType$updateIsNullable$lambda$_30_0_apply = function(var$0, var$1) {
        return var$1.$updateIsNullable(var$0.$_0397);
    };
    $java.onciu_NonEmptyList$IteratorConverter = function() {
        jl_Object.call(this);
        this.$iterator3 = null;
    };
    $java.oncie_Ands$_init_$lambda$_23_0 = $rt_classWithoutFields();
    $java.oncia_CreateIndex$semanticCheck$lambda$_65_0 = function() {
        jl_Object.call(this);
        this.$_0411 = null;
    };
    $java.oncia_CreateIndex$semanticCheck$lambda$_65_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0411;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = var$1.$map11 instanceof oncie_Variable ? 0 : 1;
        var$5 = new $java.oncia_CreateIndex$$anonfun$semanticCheck$1$lambda$_68_0;
        var$5.$_0482 = var$2;
        var$5.$_1154 = var$1;
        return oncias_SemanticCheck$_when(var$3, var$4, var$5);
    };
    var onciafn_Neo4jASTFactory$pretty$lambda$_236_0 = $rt_classWithoutFields();
    $java.onciafn_Neo4jASTFactory$pretty$lambda$_236_0_apply = function(var$0, var$1) {
        return var$1.$toString();
    };
    function onciafn_Neo4jASTFactory$convertSubqueryExpressionToUnifiedExpression$lambda$_124_0() {
        jl_Object.call(this);
        this.$_0228 = null;
    }
    $java.onciafn_Neo4jASTFactory$convertSubqueryExpressionToUnifiedExpression$lambda$_124_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0228;
        if (var$1 instanceof oncie_PatternPartWithSelector)
            var$1 = var$1;
        else {
            if (!$rt_isInstance(var$1, oncie_NonPrefixedPatternPart))
                $rt_throw(s_MatchError__init_(var$1));
            var$3 = var$1;
            var$1 = oncie_PatternPartWithSelector__init_(onciafn_Neo4jASTFactory_allPathSelector(var$2, var$3.$position2()), var$3);
        }
        return var$1;
    };
    $java.s_Proxy = $rt_classWithoutFields(0);
    $java.s_Proxy$Typed = $rt_classWithoutFields(0);
    $java.sr_OrderedProxy = $rt_classWithoutFields(0);
    $java.sr_OrderedProxy_compare$ = function($$this, $y) {
        return ($$this.$ord0()).$compare($$this.$self4(), $y);
    };
    $java.sr_RichBoolean = function() {
        jl_Object.call(this);
        this.$self5 = 0;
    };
    $java.sr_RichBoolean__init_0 = function(var_0) {
        var var_1 = new $java.sr_RichBoolean();
        $java.sr_RichBoolean__init_(var_1, var_0);
        return var_1;
    };
    $java.sr_RichBoolean_ord = function($this) {
        return sm_Ordering$Boolean$_MODULE$;
    };
    $java.sr_RichBoolean_self = function($this) {
        return jl_Boolean_valueOf($this.$self5);
    };
    $java.sr_RichBoolean__init_ = function($this, $self) {
        $this.$self5 = $self;
    };
    $java.sr_ScalaNumberProxy = $rt_classWithoutFields(0);
    $java.sr_RangedProxy = $rt_classWithoutFields(0);
    $java.sr_RichInt = function() {
        jl_Object.call(this);
        this.$self6 = 0;
    };
    $java.sr_RichInt__init_0 = function(var_0) {
        var var_1 = new $java.sr_RichInt();
        $java.sr_RichInt__init_(var_1, var_0);
        return var_1;
    };
    $java.sr_RichInt_ord = function($this) {
        sm_Ordering$Int$_$callClinit();
        return sm_Ordering$Int$_MODULE$;
    };
    $java.sr_RichInt_self = function($this) {
        return jl_Integer_valueOf($this.$self6);
    };
    $java.sr_RichInt__init_ = function($this, $self) {
        $this.$self6 = $self;
    };
    function oncias_SemanticAnalysisTooling$declareVariable$lambda$_55_0() {
        var a = this; jl_Object.call(a);
        a.$_0286 = null;
        a.$_187 = null;
    }
    $java.oncias_SemanticAnalysisTooling$declareVariable$lambda$_55_0_apply = function(var$0, var$1) {
        return oncias_SemanticState_declareVariable(var$1, var$0.$_0286, var$0.$_187, s_None$_MODULE$, 0, 0);
    };
    function oncias_SemanticAnalysisTooling$semanticCheckFold$lambda$_1_0() {
        jl_Object.call(this);
        this.$_0274 = null;
    }
    $java.oncias_SemanticAnalysisTooling$semanticCheckFold$lambda$_1_0_apply = function(var$0, var$1, var$2) {
        return var$1.$chain(var$0.$_0274.$apply(var$2));
    };
    function sc_StrictOptimizedIterableOps$partition$lambda$_1_0() {
        var a = this; jl_Object.call(a);
        a.$_015 = null;
        a.$_13 = null;
        a.$_23 = null;
    }
    $java.sc_StrictOptimizedIterableOps$partition$lambda$_1_0_apply = function(var$0, var$1) {
        return sc_StrictOptimizedIterableOps_$anonfun$partition$1(var$0.$_015, var$0.$_13, var$0.$_23, var$1);
    };
    $java.oncia_AliasDriverSettingsCheck$$anonfun$$nestedInanonfun$findInvalidDriverSettings$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_AliasDriverSettingsCheck$$anonfun$$nestedInanonfun$findInvalidDriverSettings$1$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return $x instanceof oncia_ExistsExpression ? jl_Boolean_valueOf(1) : $x instanceof oncia_CollectExpression ? jl_Boolean_valueOf(1) : !($x instanceof oncia_CountExpression) ? s_PartialFunction$_fallback_fn : jl_Boolean_valueOf(1);
    };
    function oncia_ReadAdministrationCommand$semanticCheck$lambda$_18_0() {
        jl_Object.call(this);
        this.$_0294 = null;
    }
    $java.oncia_ReadAdministrationCommand$semanticCheck$lambda$_18_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$0.$_0294;
        var$2 = oncias_SemanticCheck_chain$(var$1.$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck(), oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(oncias_package$_MODULE$, new $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_0));
        var$3 = var$1.$defaultColumnSet();
        var$4 = new $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_1;
        var$4.$_0483 = var$1;
        var$5 = oncias_SemanticCheck_chain$(var$2, var$1.$semanticCheckFold(var$3, var$4));
        var$4 = var$1.$folder();
        var$3 = new $java.oncia_ReadAdministrationCommand$$anonfun$1;
        sr_ClassTag$_$callClinit();
        var$3 = onciu_Foldable$Folder_treeFind(var$4, var$3, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_Expression)));
        var$4 = new $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_0;
        var$4.$_0484 = var$1;
        var$6 = oncias_SemanticCheck_chain$(var$5, s_Option_getOrElse(s_Option_map(var$3, var$4), new $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_1));
        var$2 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$7 = sci_$colon$colon__init_(var$1.$yields(), sci_$colon$colon__init_(var$1.$returns(), sci_Nil$_MODULE$));
        var$3 = new $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_2;
        var$3.$_0485 = var$1;
        return oncias_SemanticCheck_chain$(var$6, $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$2, var$7, var$3));
    };
    var oncia_ReadAdministrationCommand$defaultColumnNames$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncia_ReadAdministrationCommand$defaultColumnNames$lambda$_7_0_apply = function(var$0, var$1) {
        return var$1.$name23;
    };
    $java.oncia_CypherTypeName = function() {
        jl_Object.call(this);
        this.$cypherType1 = null;
    };
    $java.oncia_CypherTypeName__init_ = function(var_0) {
        var var_1 = new $java.oncia_CypherTypeName();
        $java.oncia_CypherTypeName__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_CypherTypeName_semanticCheck = function($this) {
        return $java.oncia_CypherTypeName_cypherTypeSemanticCheck($this, $this.$cypherType1);
    };
    $java.oncia_CypherTypeName_cypherTypeSemanticCheck = function($this, $cypherType) {
        var $innerType;
        a: {
            while ($cypherType instanceof oncius_ListType) {
                $innerType = $cypherType.$innerType0;
                if (!($innerType instanceof oncius_ClosedDynamicUnionType))
                    break a;
                $cypherType = $innerType;
            }
        }
        if (!($cypherType instanceof oncius_ClosedDynamicUnionType))
            return oncias_SemanticCheck$_success;
        $cypherType = $cypherType;
        if (!sci_List_forall($cypherType.$sortedInnerTypes, new $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_0) && !sci_List_forall($cypherType.$sortedInnerTypes, new $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_2))
            return oncias_SemanticAnalysisTooling_error$($this, $rt_s(2777), $cypherType.$position112);
        $innerType = $cypherType.$sortedInnerTypes;
        $cypherType = new $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_1;
        $cypherType.$_0486 = $this;
        return oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $innerType, $cypherType);
    };
    $java.oncia_CypherTypeName__init_0 = function($this, $cypherType) {
        $this.$cypherType1 = $cypherType;
    };
    $java.oncia_CreateConstraint$checkPropertyTypes$lambda$_9_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0387 = null;
        a.$_1114 = null;
    };
    $java.oncia_CreateConstraint$checkPropertyTypes$lambda$_9_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            var$1 = var$1;
            var$2 = var$0.$_0387;
            var$3 = var$0.$_1114;
            if (var$1 !== null) {
                var$4 = var$1.$errors;
                if (sci_List_equals(sci_Nil$_MODULE$, var$4))
                    break a;
            }
            if (var$1 === null)
                $rt_throw(s_MatchError__init_(var$1));
            var$5 = var$1.$state;
            var$1 = new oncias_SemanticCheckResult;
            var$6 = new sci_$colon$colon;
            var$7 = new oncias_SemanticError;
            var$8 = var$3.$description();
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$4);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(1590)), var$2), $rt_s(1601)), var$8), $rt_s(1602));
            oncias_SemanticError__init_(var$7, jl_AbstractStringBuilder_toString(var$4), var$3.$position2());
            sci_$colon$colon__init_0(var$6, var$7, sci_Nil$_MODULE$);
            oncias_SemanticCheckResult__init_0(var$1, var$5, var$6);
        }
        return var$1;
    };
    function onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification() {
        var a = this; jl_Object.call(a);
        a.$position253 = null;
        a.$deprecated1 = null;
        a.$replacement4 = null;
    }
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification__init_ = function(var_0, var_1, var_2) {
        var var_3 = new onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification();
        onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification__init_(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productPrefix = function($this) {
        return $rt_s(2778);
    };
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productArity = function($this) {
        return 3;
    };
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position253;
            case 1:
                return $this.$deprecated1;
            case 2:
                return $this.$replacement4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position253;
                        var$3 = $x$1.$position253;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$deprecated1;
                        var$3 = $x$1.$deprecated1;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$replacement4;
                        $x$1 = $x$1.$replacement4;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    function onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification__init_($this, $position, $deprecated, $replacement) {
        $this.$position253 = $position;
        $this.$deprecated1 = $deprecated;
        $this.$replacement4 = $replacement;
    }
    var oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$$nestedInanonfun$find$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$$nestedInanonfun$find$1$1_applyOrElse = function($this, $x, $default) {
        var var$3, var$4, var$5, var$6;
        $x = $x;
        var$3 = new oncir_Deprecation;
        $default = s_None$_MODULE$;
        var$4 = new s_Some;
        var$5 = new $java.onciu_DeprecatedPropertyReferenceInCreate;
        var$6 = $x.$position0;
        $x = $x.$name4;
        var$5.$position254 = var$6;
        var$5.$varName = $x;
        s_Some__init_0(var$4, var$5);
        oncir_Deprecation__init_(var$3, $default, var$4);
        return var$3;
    };
    var oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_0_apply = function(var$0, var$1) {
        return var$1.$expected;
    };
    var oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_1 = $rt_classWithoutFields();
    $java.oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncius_package$_$callClinit();
        return jl_Boolean_valueOf($java.oncius_TypeSpec_containsAll($java.oncius_BooleanType_covariant(oncius_package$_CTBoolean(oncius_package$_MODULE$)), var$1));
    };
    $java.oncia_UnmappedUnion$$anonfun$dup$1$lambda$_13_0 = function() {
        jl_Object.call(this);
        this.$_0449 = null;
    };
    $java.oncia_UnmappedUnion$$anonfun$dup$1$lambda$_13_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$0.$_0449 !== var$1 ? 0 : 1);
    };
    $java.oncia_ExecutePrivilegeQualifier = $rt_classWithoutFields(0);
    $java.oncia_FunctionPrivilegeQualifier = $rt_classWithoutFields(0);
    function oncia_FunctionQualifier() {
        var a = this; jl_Object.call(a);
        a.$glob = null;
        a.$position255 = null;
    }
    $java.oncia_FunctionQualifier__init_ = function(var_0, var_1) {
        var var_2 = new oncia_FunctionQualifier();
        $java.oncia_FunctionQualifier__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_FunctionQualifier_productPrefix = function($this) {
        return $rt_s(2779);
    };
    $java.oncia_FunctionQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_FunctionQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$glob;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_FunctionQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_FunctionQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_FunctionQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_FunctionQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_FunctionQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$glob;
                        $x$1 = $x$1.$glob;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_FunctionQualifier_dup = function($this, $children) {
        return $java.oncia_FunctionQualifier__init_($children.$head(), $this.$position255);
    };
    $java.oncia_FunctionQualifier__init_0 = function($this, $glob, $position) {
        $this.$glob = $glob;
        $this.$position255 = $position;
    };
    $java.oncia_ProcedurePrivilegeQualifier = $rt_classWithoutFields(0);
    function oncia_ProcedureQualifier() {
        var a = this; jl_Object.call(a);
        a.$glob0 = null;
        a.$position256 = null;
    }
    $java.oncia_ProcedureQualifier__init_ = function(var_0, var_1) {
        var var_2 = new oncia_ProcedureQualifier();
        $java.oncia_ProcedureQualifier__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_ProcedureQualifier_productPrefix = function($this) {
        return $rt_s(2780);
    };
    $java.oncia_ProcedureQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_ProcedureQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$glob0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ProcedureQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ProcedureQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_ProcedureQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$glob0;
                        $x$1 = $x$1.$glob0;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_ProcedureQualifier_dup = function($this, $children) {
        return $java.oncia_ProcedureQualifier__init_($children.$head(), $this.$position256);
    };
    $java.oncia_ProcedureQualifier__init_0 = function($this, $glob, $position) {
        $this.$glob0 = $glob;
        $this.$position256 = $position;
    };
    $java.oncia_SettingPrivilegeQualifier = $rt_classWithoutFields(0);
    function oncia_SettingQualifier() {
        var a = this; jl_Object.call(a);
        a.$glob1 = null;
        a.$position257 = null;
    }
    $java.oncia_SettingQualifier__init_ = function(var_0, var_1) {
        var var_2 = new oncia_SettingQualifier();
        $java.oncia_SettingQualifier__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_SettingQualifier_productPrefix = function($this) {
        return $rt_s(2781);
    };
    $java.oncia_SettingQualifier_productArity = function($this) {
        return 1;
    };
    $java.oncia_SettingQualifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$glob1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_SettingQualifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SettingQualifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SettingQualifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_SettingQualifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncia_SettingQualifier) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$glob1;
                        $x$1 = $x$1.$glob1;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_SettingQualifier_dup = function($this, $children) {
        return $java.oncia_SettingQualifier__init_($children.$head(), $this.$position257);
    };
    $java.oncia_SettingQualifier__init_0 = function($this, $glob, $position) {
        $this.$glob1 = $glob;
        $this.$position257 = $position;
    };
    $java.oncie_ReduceExpression$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncie_ReduceExpression$$_clinit_$lambda$_0_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2782)), var$1), $rt_s(2783)), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    var oncias_OptionSemanticChecking$ = $rt_classWithoutFields();
    var oncias_OptionSemanticChecking$_MODULE$ = null;
    function oncias_OptionSemanticChecking$__clinit_() {
        oncias_OptionSemanticChecking$_MODULE$ = new oncias_OptionSemanticChecking$;
    }
    function oncias_OptionSemanticChecking$_foldSemanticCheck$extension($this, $$this, $check) {
        return s_Option_fold($$this, new $java.oncias_OptionSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0, $check);
    }
    $java.oncia_PrivilegeCommand$$anonfun$privilegeQualifierCheckForPropertyRules$1$lambda$_67_0 = function() {
        jl_Object.call(this);
        this.$_0455 = null;
    };
    $java.oncia_PrivilegeCommand$$anonfun$privilegeQualifierCheckForPropertyRules$1$lambda$_67_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0455;
        var$3 = oncias_package$_MODULE$;
        oncius_package$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_declareVariable$(var$2, var$1, (oncius_package$_CTNode(oncius_package$_MODULE$)).$invariant()));
    };
    var oncie_Expression$SemanticContext$Results$ = $rt_classWithoutFields();
    var oncie_Expression$SemanticContext$Results$_MODULE$ = null;
    function oncie_Expression$SemanticContext$Results$__clinit_() {
        oncie_Expression$SemanticContext$Results$_MODULE$ = new oncie_Expression$SemanticContext$Results$;
    }
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0 = function() {
        jl_Object.call(this);
        this.$_0487 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0__init_ = function(var_0) {
        var var_1 = new $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0();
        $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0__init_0 = function(var$0, var$1) {
        var$0.$_0487 = var$1;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0_apply = function(var$0) {
        return var$0.$_0487;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1 = function() {
        jl_Object.call(this);
        this.$_0488 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1__init_ = function(var_0) {
        var var_1 = new $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1();
        $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1__init_0 = function(var$0, var$1) {
        var$0.$_0488 = var$1;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0488.$appended(var$1);
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_0 = function() {
        jl_Object.call(this);
        this.$_0335 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_0_apply = function(var$0) {
        return var$0.$_0335;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_1 = function() {
        jl_Object.call(this);
        this.$_0336 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0336.$appended(var$1);
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$5$lambda$_47_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0480 = null;
        a.$_1153 = null;
        a.$_257 = null;
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$5$lambda$_47_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0480;
        var$3 = var$0.$_1153;
        var$4 = var$0.$_257;
        var$2 = oncias_Scope_symbol(var$2, var$3.$variableInRhsName);
        var$5 = new $java.oncia_Union$$anonfun$defineUnionVariables$6$lambda$_46_0;
        var$5.$_0489 = var$1;
        var$5.$_1155 = var$4;
        var$5.$_258 = var$3;
        return s_Option_map(var$2, var$5);
    };
    $java.srj_JFunction1$mcZI$sp = $rt_classWithoutFields(0);
    $java.srj_JFunction1$mcZI$sp_apply = function($this, $t) {
        return jl_Boolean_valueOf($this.$apply$mcZI$sp(sr_BoxesRunTime_unboxToInt($t)));
    };
    $java.oncia_WriteAdministrationCommand$numPrimaryGreaterThanZero$1$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncia_WriteAdministrationCommand$numPrimaryGreaterThanZero$1$lambda$_7_0_apply$mcZI$sp = function(var$0, var$1) {
        return var$1 >= 1 ? 0 : 1;
    };
    $java.oncia_WriteAdministrationCommand$numSecondaryPositive$1$lambda$_9_0 = $rt_classWithoutFields();
    $java.oncia_WriteAdministrationCommand$numSecondaryPositive$1$lambda$_9_0_apply$mcZI$sp = function(var$0, var$1) {
        return var$1 >= 0 ? 0 : 1;
    };
    $java.oncia_CreateConstraint$allowedTypesCheck$1$lambda$_20_0 = function() {
        jl_Object.call(this);
        this.$_0388 = null;
    };
    $java.oncia_CreateConstraint$allowedTypesCheck$1$lambda$_20_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0388.$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes();
        onciu_InputPosition$_$callClinit();
        return jl_Boolean_valueOf(sci_List_contains(var$2, var$1.$withPosition0(onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$))));
    };
    function oncias_SemanticTable$TypeGetter() {
        jl_Object.call(this);
        this.$typeInfo = null;
    }
    function oncias_SemanticTable$TypeGetter_isAnyOf($this, $cypherTypes) {
        var var$2;
        var$2 = new $java.oncias_SemanticTable$TypeGetter$isAnyOf$lambda$_3_0;
        var$2.$_0490 = $this;
        return sc_IterableOnceOps_exists$($cypherTypes, var$2);
    }
    function jus_Collectors$joining$lambda$_7_0() {
        jl_Object.call(this);
        this.$_0230 = null;
    }
    $java.jus_Collectors$joining$lambda$_7_0_accept = function(var$0, var$1, var$2) {
        var var$3;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = var$0.$_0230;
        if (var$1.$length0 > 0)
            jl_AbstractStringBuilder_append0(var$1, var$3);
        jl_AbstractStringBuilder_append0(var$1, var$2);
    };
    function jus_Collectors$joining$lambda$_7_1() {
        jl_Object.call(this);
        this.$_0231 = null;
    }
    var jus_Collectors$joining$lambda$_7_2 = $rt_classWithoutFields();
    $java.jus_Collectors$joining$lambda$_7_2_get = function(var$0) {
        var var$1;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        return var$1;
    };
    function jus_Collectors$joining$lambda$_7_3() {
        var a = this; jl_Object.call(a);
        a.$_0232 = null;
        a.$_162 = null;
    }
    $java.jus_Collectors$joining$lambda$_7_3_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0232;
        var$3 = var$0.$_162;
        jl_AbstractStringBuilder_insert4(var$1, 0, var$2, 0, jl_String_length(var$2));
        jl_AbstractStringBuilder_append0(var$1, var$3);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0 = $rt_classWithoutFields();
    $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0__init_ = function() {
        var var_0 = new $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0();
        $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0__init_0(var_0);
        return var_0;
    };
    $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0__init_0 = function(var$0) {};
    $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    $java.oncie_RightUnaryOperatorExpression = $rt_classWithoutFields(0);
    $java.oncie_RightUnaryOperatorExpression_asCanonicalStringVal$ = function($$this) {
        var var$2, var$3;
        var$2 = $$this.$canonicalOperatorSymbol();
        $$this = ($$this.$lhs0()).$asCanonicalStringVal();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        var$2 = jl_StringBuilder_append(var$3, var$2);
        jl_AbstractStringBuilder_append(var$2, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$2, $$this), 41);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    function oncie_IsNull() {
        var a = this; oncie_Expression.call(a);
        a.$lhs20 = null;
        a.$position258 = null;
        a.$signatures12 = null;
    }
    function oncie_IsNull__init_(var_0, var_1) {
        var var_2 = new oncie_IsNull();
        $java.oncie_IsNull__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_IsNull_asCanonicalStringVal = function($this) {
        return $java.oncie_RightUnaryOperatorExpression_asCanonicalStringVal$($this);
    };
    function oncie_IsNull_lhs($this) {
        return $this.$lhs20;
    }
    $java.oncie_IsNull_position = function($this) {
        return $this.$position258;
    };
    $java.oncie_IsNull_signatures = function($this) {
        return $this.$signatures12;
    };
    $java.oncie_IsNull_canonicalOperatorSymbol = function($this) {
        return $rt_s(2784);
    };
    $java.oncie_IsNull_productPrefix = function($this) {
        return $rt_s(2785);
    };
    $java.oncie_IsNull_productArity = function($this) {
        return 1;
    };
    $java.oncie_IsNull_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs20;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_IsNull_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IsNull_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IsNull_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IsNull_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_IsNull) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs20;
                        $x$1 = $x$1.$lhs20;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_IsNull))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_IsNull__init_ = function($this, $lhs, $position) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        $this.$lhs20 = $lhs;
        $this.$position258 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$3 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$5 = var$4.data;
        var$6 = $java.oncie_TypeSignature$_MODULE$;
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_AnyType, 1);
        var$9 = var$8.data;
        oncius_package$_$callClinit();
        var$9[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$5[0] = $java.oncie_TypeSignature$_apply(var$6, var$7.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$8)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures12 = var$3.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$4));
    };
    function oncie_IsNotNull() {
        var a = this; oncie_Expression.call(a);
        a.$lhs21 = null;
        a.$position259 = null;
        a.$signatures13 = null;
    }
    function oncie_IsNotNull__init_(var_0, var_1) {
        var var_2 = new oncie_IsNotNull();
        $java.oncie_IsNotNull__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_IsNotNull_asCanonicalStringVal = function($this) {
        return $java.oncie_RightUnaryOperatorExpression_asCanonicalStringVal$($this);
    };
    function oncie_IsNotNull_lhs($this) {
        return $this.$lhs21;
    }
    $java.oncie_IsNotNull_position = function($this) {
        return $this.$position259;
    };
    $java.oncie_IsNotNull_signatures = function($this) {
        return $this.$signatures13;
    };
    $java.oncie_IsNotNull_canonicalOperatorSymbol = function($this) {
        return $rt_s(1453);
    };
    $java.oncie_IsNotNull_productPrefix = function($this) {
        return $rt_s(2786);
    };
    $java.oncie_IsNotNull_productArity = function($this) {
        return 1;
    };
    $java.oncie_IsNotNull_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs21;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_IsNotNull_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IsNotNull_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IsNotNull_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IsNotNull_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_IsNotNull) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs21;
                        $x$1 = $x$1.$lhs21;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_IsNotNull))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_IsNotNull__init_ = function($this, $lhs, $position) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        $this.$lhs21 = $lhs;
        $this.$position259 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$3 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$5 = var$4.data;
        var$6 = $java.oncie_TypeSignature$_MODULE$;
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_AnyType, 1);
        var$9 = var$8.data;
        oncius_package$_$callClinit();
        var$9[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$5[0] = $java.oncie_TypeSignature$_apply(var$6, var$7.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$8)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures13 = var$3.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$4));
    };
    $java.oncia_Union$Mapping$2$ = function() {
        sr_AbstractFunction3.call(this);
        this.$$outer50 = null;
    };
    $java.oncia_Union$Mapping$2$__init_ = function(var_0) {
        var var_1 = new $java.oncia_Union$Mapping$2$();
        $java.oncia_Union$Mapping$2$__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Union$Mapping$2$_apply = function($this, $unionVariable, $variableInLhsName, $variableInRhsName) {
        var var$4, var$5;
        var$4 = new $java.oncia_Union$Mapping$1;
        var$5 = $this.$$outer50;
        var$4.$unionVariable0 = $unionVariable;
        var$4.$variableInLhsName = $variableInLhsName;
        var$4.$variableInRhsName = $variableInRhsName;
        if (var$5 === null)
            $rt_throw(null);
        var$4.$$outer49 = var$5;
        return var$4;
    };
    $java.oncia_Union$Mapping$2$__init_0 = function($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer50 = $$outer;
    };
    $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_0 = function() {
        jl_Object.call(this);
        this.$_0389 = null;
    };
    $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncia_CreateConstraint_anyPropertyValueType$1(var$0.$_0389, var$1));
    };
    $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_1 = $rt_classWithoutFields();
    $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(var$1));
    };
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_0 = $rt_classWithoutFields();
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncius_ListType);
    };
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_1 = $rt_classWithoutFields();
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncius_ListType);
    };
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_2 = $rt_classWithoutFields();
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_2_apply = function(var$0, var$1) {
        return $java.oncia_CreateConstraint_additionalErrorInfo$1(var$1);
    };
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_3 = $rt_classWithoutFields();
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_3_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        return jl_Boolean_valueOf(sc_StringOps$_nonEmpty$extension(var$2, var$1));
    };
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_4 = $rt_classWithoutFields();
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_4_apply = function(var$0) {
        return $rt_s(3);
    };
    $java.onciu_RewritableCompat$PROXY$7_102 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_102_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_102 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_102_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_103 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_103_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_103 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_103_paramsLength(var$1) {
        return (jl_Integer_valueOf(7)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_104 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_104_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_104 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_104_paramsLength(var$1) {
        return (jl_Integer_valueOf(7)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_105 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_105_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_105 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_105_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_106 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_106_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_106 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_106_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_107 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_107_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_107 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_107_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_108 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_108_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_108 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_108_paramsLength(var$1) {
        return (jl_Integer_valueOf(10)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_109 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_109_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_109 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_109_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_110 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_110_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_110 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_110_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_111 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_111_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_111 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_111_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_112 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_112_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_112 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_112_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_113 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_113_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_113 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_113_paramsLength(var$1) {
        return (jl_Integer_valueOf(11)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_114 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_114_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_114 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_114_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_115 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_115_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_115 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_115_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_116 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_116_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_116 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_116_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(10)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_117 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_117_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_117 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_117_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_118 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_118_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_118 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_118_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_119 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_119_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_119 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_119_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_120 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_120_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_120 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_120_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(11)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_121 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_121_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_121 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_121_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(10)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_122 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_122_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_122 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_122_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_123 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_123_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_123 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_123_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_124 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_124_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_124 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_124_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_125 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_125_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_125 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_125_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_126 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_126_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_126 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_126_paramsLength(var$1) {
        return (jl_Integer_valueOf(10)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_127 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_127_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_127 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_127_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_128 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_128_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_128 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_128_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_129 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_129_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_129 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_129_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(10)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_130 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_130_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_130 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_130_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_131 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_131_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_131 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_131_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(10)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_132 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_132_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_132 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_132_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_133 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_133_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_133 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_133_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_134 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_134_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_134 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_134_paramsLength(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_135 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_135_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_135 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_135_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_136 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_136_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_136 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_136_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_137 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_137_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_137 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_137_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_138 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_138_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_138 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_138_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_139 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_139_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_139 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_139_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_140 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_140_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_140 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_140_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_141 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_141_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_141 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_141_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_589 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_589_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_True_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_590 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_590_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_Null_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_591 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_591_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Ands__init_0(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_593 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_593_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_Infinity_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_594 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_594_copyConstructor(var$1, var$2, var$3) {
        return $java.oncie_NaN_copy(var$2, var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_599 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_599_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_PathConcatenation__init_(var$3[0], var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_142 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_142_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_142 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_142_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_143 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_143_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_143 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_143_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_144 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_144_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_144 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_144_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_145 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_145_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_145 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_145_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_146 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_146_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_146 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_146_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_603 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_603_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_MapExpression__init_(var$3[0], var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_147 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_147_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_147 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_147_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_608 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_608_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_DropPropertyUniquenessConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_609 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_609_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_DropNodeKeyConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_610 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_610_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_DropIndex_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_611 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_611_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_DropNodePropertyExistenceConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_612 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_612_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_DropConstraintOnName_copy(var$2, var$3[0], var$3[1].$value8, var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_613 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_613_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_DropRelationshipPropertyExistenceConstraint_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_614 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_614_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_DropIndexOnName_copy(var$2, var$3[0], var$3[1].$value8, var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_615 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_615_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CollectExpression_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_616 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_616_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_CountExpression_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_617 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_617_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_SignedOctalIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_618 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_618_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_MapProjection__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_619 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_619_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_PatternExpression_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_620 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_620_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_FunctionInvocation_copy(var$2, var$3[0], var$3[1], var$3[2].$value8, var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_621 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_621_copyConstructor(var$1, var$2, var$3) {
        return oncie_ShortestPathExpression__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_622 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_622_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_DecimalDoubleLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_623 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_623_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_SignedHexIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_624 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_624_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_PatternComprehension_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6]);
    }
    var onciu_RewritableCompat$PROXY$3_625 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_625_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_CaseExpression__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_626 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_626_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ExistsExpression_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_627 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_627_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_ListLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_148 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_148_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_148 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_148_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_149 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_149_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_149 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_149_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_150 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_150_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_150 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_150_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_151 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_151_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_151 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_151_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_152 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_152_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_152 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_152_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_153 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_153_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_153 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_153_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_154 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_154_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_154 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_154_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_155 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_155_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_155 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_155_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_156 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_156_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_156 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_156_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_157 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_157_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_157 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_157_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(7)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_158 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_158_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_158 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_158_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_159 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_159_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_159 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_159_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_160 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_160_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_160 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_160_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    function ju_LinkedHashMap$AbstractMapIterator() {
        var a = this; jl_Object.call(a);
        a.$expectedModCount = 0;
        a.$futureEntry = null;
        a.$currentEntry0 = null;
        a.$associatedMap0 = null;
    }
    $java.ju_LinkedHashMap$AbstractMapIterator__init_0 = function(var_0) {
        var var_1 = new ju_LinkedHashMap$AbstractMapIterator();
        $java.ju_LinkedHashMap$AbstractMapIterator__init_(var_1, var_0);
        return var_1;
    };
    $java.ju_LinkedHashMap$AbstractMapIterator__init_ = function($this, $map) {
        $this.$expectedModCount = $map.$modCount2;
        $this.$futureEntry = $map.$head2;
        $this.$associatedMap0 = $map;
    };
    function ju_LinkedHashMap$AbstractMapIterator_hasNext($this) {
        return $this.$futureEntry === null ? 0 : 1;
    }
    $java.ju_LinkedHashMap$AbstractMapIterator_checkConcurrentMod = function($this) {
        var var$1;
        if ($this.$expectedModCount == $this.$associatedMap0.$modCount2)
            return;
        var$1 = new ju_ConcurrentModificationException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    };
    $java.ju_LinkedHashMap$AbstractMapIterator_makeNext = function($this) {
        var var$1;
        $java.ju_LinkedHashMap$AbstractMapIterator_checkConcurrentMod($this);
        if (ju_LinkedHashMap$AbstractMapIterator_hasNext($this)) {
            var$1 = $this.$futureEntry;
            $this.$currentEntry0 = var$1;
            $this.$futureEntry = var$1.$chainForward;
            return;
        }
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    };
    var ju_LinkedHashMap$EntryIterator = $rt_classWithoutFields(ju_LinkedHashMap$AbstractMapIterator);
    function ju_LinkedHashMap$EntryIterator_next($this) {
        $java.ju_LinkedHashMap$AbstractMapIterator_makeNext($this);
        return $this.$currentEntry0;
    }
    $java.sci_Map$Map4$Map4Iterator = function() {
        var a = this; sc_AbstractIterator.call(a);
        a.$i5 = 0;
        a.$$outer51 = null;
    };
    $java.sci_Map$Map4$Map4Iterator_hasNext = function($this) {
        if ($this.$i5 >= 4)
            return 0;
        return 1;
    };
    $java.sci_Map$Map4$Map4Iterator_next = function($this) {
        var var$1, $result;
        a: {
            switch ($this.$i5) {
                case 0:
                    var$1 = $this.$$outer51;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map4$$key1, var$1.$scala$collection$immutable$Map$Map4$$value1);
                    break a;
                case 1:
                    var$1 = $this.$$outer51;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map4$$key2, var$1.$scala$collection$immutable$Map$Map4$$value2);
                    break a;
                case 2:
                    var$1 = $this.$$outer51;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map4$$key3, var$1.$scala$collection$immutable$Map$Map4$$value3);
                    break a;
                case 3:
                    var$1 = $this.$$outer51;
                    $result = $this.$nextResult(var$1.$scala$collection$immutable$Map$Map4$$key4, var$1.$scala$collection$immutable$Map$Map4$$value4);
                    break a;
                default:
            }
            $result = sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        }
        $this.$i5 = $this.$i5 + 1 | 0;
        return $result;
    };
    $java.sci_Map$Map4$Map4Iterator_scala$collection$immutable$Map$Map4$Map4Iterator$$$outer = function($this) {
        return $this.$$outer51;
    };
    $java.sci_Map$Map4$Map4Iterator__init_ = function($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer51 = $$outer;
        $this.$i5 = 0;
    };
    $java.sci_Map$Map4$$anon$7 = $rt_classWithoutFields($java.sci_Map$Map4$Map4Iterator);
    $java.sci_Map$Map4$$anon$7_nextResult = function($this, $k, $v) {
        return s_Tuple2__init_($k, $v);
    };
    $java.sci_Map$Map4$$anon$9 = $rt_classWithoutFields($java.sci_Map$Map4$Map4Iterator);
    $java.sci_Map$Map4$$anon$9_nextResult = function($this, $k, $v) {
        return $v;
    };
    $java.oncil_MultiOperatorLabelExpression = $rt_classWithoutFields(0);
    $java.oncil_MultiOperatorLabelExpression_flatten$ = function($$this) {
        return ($$this.$children2()).$flatMap(new $java.oncil_MultiOperatorLabelExpression$flatten$lambda$_2_0);
    };
    function oncil_LabelExpression$Disjunctions() {
        var a = this; jl_Object.call(a);
        a.$children = null;
        a.$containsIs0 = 0;
        a.$position260 = null;
    }
    $java.oncil_LabelExpression$Disjunctions__init_ = function(var_0, var_1, var_2) {
        var var_3 = new oncil_LabelExpression$Disjunctions();
        $java.oncil_LabelExpression$Disjunctions__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncil_LabelExpression$Disjunctions_flatten = function($this) {
        return $java.oncil_MultiOperatorLabelExpression_flatten$($this);
    };
    $java.oncil_LabelExpression$Disjunctions_containsGpmSpecificLabelExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$($this);
    };
    $java.oncil_LabelExpression$Disjunctions_containsGpmSpecificRelTypeExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$($this);
    };
    $java.oncil_LabelExpression$Disjunctions_replaceColonSyntax = function($this) {
        return $java.oncil_LabelExpression_replaceColonSyntax$($this);
    };
    $java.oncil_LabelExpression$Disjunctions_foldedOver = function($this) {
        return $this;
    };
    $java.oncil_LabelExpression$Disjunctions_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncil_LabelExpression$Disjunctions_children = function($this) {
        return $this.$children;
    };
    $java.oncil_LabelExpression$Disjunctions_containsIs = function($this) {
        return $this.$containsIs0;
    };
    $java.oncil_LabelExpression$Disjunctions_position = function($this) {
        return $this.$position260;
    };
    $java.oncil_LabelExpression$Disjunctions_unnestDisjunctions = function($this) {
        return $java.oncil_LabelExpression$Disjunctions_copy($this, $this.$children.$flatMap(new $java.oncil_LabelExpression$Disjunctions$unnestDisjunctions$lambda$_13_0), $this.$containsIs0, $this.$position260);
    };
    $java.oncil_LabelExpression$Disjunctions_copy = function($this, $children, $containsIs, $position) {
        return $java.oncil_LabelExpression$Disjunctions__init_($children, $containsIs, $position);
    };
    $java.oncil_LabelExpression$Disjunctions_productPrefix = function($this) {
        return $rt_s(2787);
    };
    $java.oncil_LabelExpression$Disjunctions_productArity = function($this) {
        return 2;
    };
    $java.oncil_LabelExpression$Disjunctions_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$children;
            case 1:
                return jl_Boolean_valueOf($this.$containsIs0);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpression$Disjunctions_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Disjunctions_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2787))), sr_Statics_anyHash($this.$children)), !$this.$containsIs0 ? 1237 : 1231), 2);
    };
    $java.oncil_LabelExpression$Disjunctions_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Disjunctions_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncil_LabelExpression$Disjunctions) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if ($this.$containsIs0 != $x$1.$containsIs0)
                            break b;
                        var$2 = $this.$children;
                        $x$1 = $x$1.$children;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncil_LabelExpression$Disjunctions_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncil_LabelExpression$Disjunctions__init_0 = function($this, $children, $containsIs, $position) {
        $this.$children = $children;
        $this.$containsIs0 = $containsIs;
        $this.$position260 = $position;
    };
    function onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_0() {
        jl_Object.call(this);
        this.$_051 = null;
    }
    $java.onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom(var$0.$_051, var$1);
    };
    function oncil_LabelExpression$Conjunctions() {
        var a = this; jl_Object.call(a);
        a.$children0 = null;
        a.$containsIs1 = 0;
        a.$position261 = null;
    }
    $java.oncil_LabelExpression$Conjunctions__init_ = function(var_0, var_1, var_2) {
        var var_3 = new oncil_LabelExpression$Conjunctions();
        $java.oncil_LabelExpression$Conjunctions__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncil_LabelExpression$Conjunctions_flatten = function($this) {
        return $java.oncil_MultiOperatorLabelExpression_flatten$($this);
    };
    $java.oncil_LabelExpression$Conjunctions_containsGpmSpecificLabelExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$($this);
    };
    $java.oncil_LabelExpression$Conjunctions_containsGpmSpecificRelTypeExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$($this);
    };
    $java.oncil_LabelExpression$Conjunctions_replaceColonSyntax = function($this) {
        return $java.oncil_LabelExpression_replaceColonSyntax$($this);
    };
    $java.oncil_LabelExpression$Conjunctions_foldedOver = function($this) {
        return $this;
    };
    $java.oncil_LabelExpression$Conjunctions_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncil_LabelExpression$Conjunctions_children = function($this) {
        return $this.$children0;
    };
    $java.oncil_LabelExpression$Conjunctions_containsIs = function($this) {
        return $this.$containsIs1;
    };
    $java.oncil_LabelExpression$Conjunctions_position = function($this) {
        return $this.$position261;
    };
    $java.oncil_LabelExpression$Conjunctions_unnestConjunctions = function($this) {
        return $java.oncil_LabelExpression$Conjunctions_copy($this, $this.$children0.$flatMap(new $java.oncil_LabelExpression$Conjunctions$unnestConjunctions$lambda$_13_0), $this.$containsIs1, $this.$position261);
    };
    $java.oncil_LabelExpression$Conjunctions_copy = function($this, $children, $containsIs, $position) {
        return $java.oncil_LabelExpression$Conjunctions__init_($children, $containsIs, $position);
    };
    $java.oncil_LabelExpression$Conjunctions_productPrefix = function($this) {
        return $rt_s(2788);
    };
    $java.oncil_LabelExpression$Conjunctions_productArity = function($this) {
        return 2;
    };
    $java.oncil_LabelExpression$Conjunctions_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$children0;
            case 1:
                return jl_Boolean_valueOf($this.$containsIs1);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpression$Conjunctions_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Conjunctions_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2788))), sr_Statics_anyHash($this.$children0)), !$this.$containsIs1 ? 1237 : 1231), 2);
    };
    $java.oncil_LabelExpression$Conjunctions_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Conjunctions_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncil_LabelExpression$Conjunctions) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsIs1 != $x$1.$containsIs1)
                        break b;
                    c: {
                        var$2 = $this.$children0;
                        $x$1 = $x$1.$children0;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncil_LabelExpression$Conjunctions))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncil_LabelExpression$Conjunctions_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncil_LabelExpression$Conjunctions__init_0 = function($this, $children, $containsIs, $position) {
        $this.$children0 = $children;
        $this.$containsIs1 = $containsIs;
        $this.$position261 = $position;
    };
    function oncil_LabelExpression$ColonConjunction() {
        var a = this; jl_Object.call(a);
        a.$lhs4 = null;
        a.$rhs4 = null;
        a.$containsIs2 = 0;
        a.$position262 = null;
    }
    function oncil_LabelExpression$ColonConjunction__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncil_LabelExpression$ColonConjunction();
        $java.oncil_LabelExpression$ColonConjunction__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncil_LabelExpression$ColonConjunction_flatten = function($this) {
        return $java.oncil_BinaryLabelExpression_flatten$($this);
    };
    $java.oncil_LabelExpression$ColonConjunction_containsGpmSpecificLabelExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$($this);
    };
    $java.oncil_LabelExpression$ColonConjunction_containsGpmSpecificRelTypeExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$($this);
    };
    $java.oncil_LabelExpression$ColonConjunction_replaceColonSyntax = function($this) {
        return $java.oncil_LabelExpression_replaceColonSyntax$($this);
    };
    $java.oncil_LabelExpression$ColonConjunction_foldedOver = function($this) {
        return $this;
    };
    $java.oncil_LabelExpression$ColonConjunction_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncil_LabelExpression$ColonConjunction_lhs = function($this) {
        return $this.$lhs4;
    };
    $java.oncil_LabelExpression$ColonConjunction_rhs = function($this) {
        return $this.$rhs4;
    };
    $java.oncil_LabelExpression$ColonConjunction_containsIs = function($this) {
        return $this.$containsIs2;
    };
    $java.oncil_LabelExpression$ColonConjunction_position = function($this) {
        return $this.$position262;
    };
    $java.oncil_LabelExpression$ColonConjunction_productPrefix = function($this) {
        return $rt_s(2789);
    };
    $java.oncil_LabelExpression$ColonConjunction_productArity = function($this) {
        return 3;
    };
    $java.oncil_LabelExpression$ColonConjunction_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs4;
            case 1:
                return $this.$rhs4;
            case 2:
                return jl_Boolean_valueOf($this.$containsIs2);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpression$ColonConjunction_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$ColonConjunction_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2789))), sr_Statics_anyHash($this.$lhs4)), sr_Statics_anyHash($this.$rhs4)), !$this.$containsIs2 ? 1237 : 1231), 3);
    };
    $java.oncil_LabelExpression$ColonConjunction_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$ColonConjunction_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncil_LabelExpression$ColonConjunction) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsIs2 != $x$1.$containsIs2)
                        break b;
                    c: {
                        var$2 = $this.$lhs4;
                        var$3 = $x$1.$lhs4;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs4;
                        $x$1 = $x$1.$rhs4;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncil_LabelExpression$ColonConjunction))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncil_LabelExpression$ColonConjunction_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncil_LabelExpression$ColonConjunction__init_ = function($this, $lhs, $rhs, $containsIs, $position) {
        $this.$lhs4 = $lhs;
        $this.$rhs4 = $rhs;
        $this.$containsIs2 = $containsIs;
        $this.$position262 = $position;
    };
    function onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_1() {
        jl_Object.call(this);
        this.$_052 = null;
    }
    $java.onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringifyLabelExpressionHalfAtom(var$0.$_052, var$1);
    };
    var oncief_UserDefinedFunctionInvocation = $rt_classWithoutFields(0);
    $java.oncie_FilteringExpression = $rt_classWithoutFields(0);
    function oncie_ListComprehension() {
        var a = this; oncie_Expression.call(a);
        a.$scope11 = null;
        a.$expression15 = null;
        a.$position263 = null;
        a.$name60 = null;
    }
    function oncie_ListComprehension__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_ListComprehension();
        $java.oncie_ListComprehension__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncie_ListComprehension_scope($this) {
        return $this.$scope11;
    }
    function oncie_ListComprehension_expression($this) {
        return $this.$expression15;
    }
    $java.oncie_ListComprehension_position = function($this) {
        return $this.$position263;
    };
    $java.oncie_ListComprehension_variable = function($this) {
        return $this.$scope11.$variable43;
    };
    $java.oncie_ListComprehension_innerPredicate = function($this) {
        return $this.$scope11.$innerPredicate1;
    };
    $java.oncie_ListComprehension_extractExpression = function($this) {
        return $this.$scope11.$extractExpression0;
    };
    $java.oncie_ListComprehension_productPrefix = function($this) {
        return $rt_s(2790);
    };
    $java.oncie_ListComprehension_productArity = function($this) {
        return 2;
    };
    $java.oncie_ListComprehension_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope11;
            case 1:
                return $this.$expression15;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ListComprehension_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListComprehension_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListComprehension_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListComprehension_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ListComprehension) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$scope11;
                        var$3 = $x$1.$scope11;
                        if (var$2 !== null) {
                            if (!$java.oncie_ExtractScope_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression15;
                        $x$1 = $x$1.$expression15;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ListComprehension))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ListComprehension__init_ = function($this, $scope, $expression, $position) {
        $this.$scope11 = $scope;
        $this.$expression15 = $expression;
        $this.$position263 = $position;
        $java.oncie_Expression__init_($this);
        $this.$name60 = $rt_s(2791);
    };
    function oncie_ExtractScope() {
        var a = this; oncie_Expression.call(a);
        a.$variable43 = null;
        a.$innerPredicate1 = null;
        a.$extractExpression0 = null;
        a.$position264 = null;
        a.$introducedVariables = null;
    }
    function oncie_ExtractScope__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncie_ExtractScope();
        $java.oncie_ExtractScope__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncie_ExtractScope_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    function oncie_ExtractScope_variable($this) {
        return $this.$variable43;
    }
    function oncie_ExtractScope_innerPredicate($this) {
        return $this.$innerPredicate1;
    }
    function oncie_ExtractScope_extractExpression($this) {
        return $this.$extractExpression0;
    }
    $java.oncie_ExtractScope_position = function($this) {
        return $this.$position264;
    };
    $java.oncie_ExtractScope_introducedVariables = function($this) {
        return $this.$introducedVariables;
    };
    $java.oncie_ExtractScope_scopeDependencies = function($this) {
        return ((s_Option_fold($this.$innerPredicate1, new $java.oncie_ExtractScope$scopeDependencies$lambda$_9_0, new $java.oncie_ExtractScope$scopeDependencies$lambda$_9_1)).$concat1(s_Option_fold($this.$extractExpression0, new $java.oncie_ExtractScope$scopeDependencies$lambda$_9_2, new $java.oncie_ExtractScope$scopeDependencies$lambda$_9_3))).$removedAll0($this.$introducedVariables);
    };
    $java.oncie_ExtractScope_productPrefix = function($this) {
        return $rt_s(2792);
    };
    $java.oncie_ExtractScope_productArity = function($this) {
        return 3;
    };
    $java.oncie_ExtractScope_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable43;
            case 1:
                return $this.$innerPredicate1;
            case 2:
                return $this.$extractExpression0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ExtractScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ExtractScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ExtractScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ExtractScope_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ExtractScope) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable43;
                        var$3 = $x$1.$variable43;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$innerPredicate1;
                        var$3 = $x$1.$innerPredicate1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$extractExpression0;
                        $x$1 = $x$1.$extractExpression0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ExtractScope))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ExtractScope__init_ = function($this, $variable, $innerPredicate, $extractExpression, $position) {
        var var$5;
        $this.$variable43 = $variable;
        $this.$innerPredicate1 = $innerPredicate;
        $this.$extractExpression0 = $extractExpression;
        $this.$position264 = $position;
        $java.oncie_Expression__init_($this);
        s_Predef$_$callClinit();
        $extractExpression = s_Predef$_Set(s_Predef$_MODULE$);
        $innerPredicate = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(oncie_LogicalVariable, 1);
        var$5.data[0] = $variable;
        $this.$introducedVariables = $extractExpression.$from0(sr_ScalaRunTime$_wrapRefArray($innerPredicate, var$5));
    };
    function oncie_ReduceExpression() {
        var a = this; oncie_Expression.call(a);
        a.$scope12 = null;
        a.$init2 = null;
        a.$list2 = null;
        a.$position265 = null;
    }
    function oncie_ReduceExpression__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncie_ReduceExpression();
        $java.oncie_ReduceExpression__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function oncie_ReduceExpression_scope($this) {
        return $this.$scope12;
    }
    function oncie_ReduceExpression_init($this) {
        return $this.$init2;
    }
    function oncie_ReduceExpression_list($this) {
        return $this.$list2;
    }
    $java.oncie_ReduceExpression_position = function($this) {
        return $this.$position265;
    };
    $java.oncie_ReduceExpression_expression = function($this) {
        return $this.$scope12.$expression17;
    };
    $java.oncie_ReduceExpression_productPrefix = function($this) {
        return $rt_s(2793);
    };
    $java.oncie_ReduceExpression_productArity = function($this) {
        return 3;
    };
    $java.oncie_ReduceExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope12;
            case 1:
                return $this.$init2;
            case 2:
                return $this.$list2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ReduceExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ReduceExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ReduceExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ReduceExpression_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ReduceExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$scope12;
                        var$3 = $x$1.$scope12;
                        if (var$2 !== null) {
                            if (!$java.oncie_ReduceScope_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$init2;
                        var$3 = $x$1.$init2;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$list2;
                        $x$1 = $x$1.$list2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ReduceExpression))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ReduceExpression__init_ = function($this, $scope, $init, $list, $position) {
        $this.$scope12 = $scope;
        $this.$init2 = $init;
        $this.$list2 = $list;
        $this.$position265 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_ReduceScope() {
        var a = this; oncie_Expression.call(a);
        a.$accumulator1 = null;
        a.$variable44 = null;
        a.$expression17 = null;
        a.$position266 = null;
        a.$introducedVariables0 = null;
    }
    function oncie_ReduceScope__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncie_ReduceScope();
        $java.oncie_ReduceScope__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    $java.oncie_ReduceScope_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    function oncie_ReduceScope_accumulator($this) {
        return $this.$accumulator1;
    }
    function oncie_ReduceScope_variable($this) {
        return $this.$variable44;
    }
    function oncie_ReduceScope_expression($this) {
        return $this.$expression17;
    }
    $java.oncie_ReduceScope_position = function($this) {
        return $this.$position266;
    };
    $java.oncie_ReduceScope_introducedVariables = function($this) {
        return $this.$introducedVariables0;
    };
    $java.oncie_ReduceScope_scopeDependencies = function($this) {
        return ($this.$expression17.$dependencies0()).$removedAll0($this.$introducedVariables0);
    };
    $java.oncie_ReduceScope_productPrefix = function($this) {
        return $rt_s(2794);
    };
    $java.oncie_ReduceScope_productArity = function($this) {
        return 3;
    };
    $java.oncie_ReduceScope_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$accumulator1;
            case 1:
                return $this.$variable44;
            case 2:
                return $this.$expression17;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ReduceScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ReduceScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ReduceScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ReduceScope_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ReduceScope) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$accumulator1;
                        var$3 = $x$1.$accumulator1;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$variable44;
                        var$3 = $x$1.$variable44;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$expression17;
                        $x$1 = $x$1.$expression17;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ReduceScope))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ReduceScope__init_ = function($this, $accumulator, $variable, $expression, $position) {
        $this.$accumulator1 = $accumulator;
        $this.$variable44 = $variable;
        $this.$expression17 = $expression;
        $this.$position266 = $position;
        $java.oncie_Expression__init_($this);
        s_Predef$_$callClinit();
        $this.$introducedVariables0 = (s_Predef$_Set(s_Predef$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncie_LogicalVariable, [$accumulator, $variable])));
    };
    $java.oncie_IterablePredicateExpression = $rt_classWithoutFields(0);
    $java.oncie_IterablePredicateExpression_variable$ = function($$this) {
        return ($$this.$scope()).$variable3;
    };
    $java.oncie_IterablePredicateExpression_innerPredicate$ = function($$this) {
        return ($$this.$scope()).$innerPredicate0;
    };
    $java.oncie_IterablePredicateExpression_asCanonicalStringVal$ = function($$this) {
        var var$2, var$3, var$4, var$5;
        var$2 = s_Option_getOrElse(s_Option_map($$this.$innerPredicate(), new $java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_0), new $java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_1);
        var$3 = $$this.$name3();
        var$4 = ($$this.$variable2()).$name4;
        $$this = ($$this.$expression1()).$asCanonicalStringVal();
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        var$3 = jl_StringBuilder_append(var$5, var$3);
        jl_AbstractStringBuilder_append(var$3, 40);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$4), $rt_s(2795)), $$this), var$2);
        return jl_AbstractStringBuilder_toString(var$5);
    };
    function oncie_AllIterablePredicate() {
        var a = this; oncie_Expression.call(a);
        a.$scope13 = null;
        a.$expression18 = null;
        a.$position267 = null;
        a.$name61 = null;
    }
    function oncie_AllIterablePredicate__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_AllIterablePredicate();
        $java.oncie_AllIterablePredicate__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_AllIterablePredicate_variable = function($this) {
        return $java.oncie_IterablePredicateExpression_variable$($this);
    };
    $java.oncie_AllIterablePredicate_innerPredicate = function($this) {
        return $java.oncie_IterablePredicateExpression_innerPredicate$($this);
    };
    $java.oncie_AllIterablePredicate_asCanonicalStringVal = function($this) {
        return $java.oncie_IterablePredicateExpression_asCanonicalStringVal$($this);
    };
    function oncie_AllIterablePredicate_scope($this) {
        return $this.$scope13;
    }
    function oncie_AllIterablePredicate_expression($this) {
        return $this.$expression18;
    }
    $java.oncie_AllIterablePredicate_position = function($this) {
        return $this.$position267;
    };
    $java.oncie_AllIterablePredicate_name = function($this) {
        return $this.$name61;
    };
    $java.oncie_AllIterablePredicate_productPrefix = function($this) {
        return $rt_s(2796);
    };
    $java.oncie_AllIterablePredicate_productArity = function($this) {
        return 2;
    };
    $java.oncie_AllIterablePredicate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope13;
            case 1:
                return $this.$expression18;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_AllIterablePredicate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AllIterablePredicate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AllIterablePredicate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AllIterablePredicate_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_AllIterablePredicate) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$scope13;
                        var$3 = $x$1.$scope13;
                        if (var$2 !== null) {
                            if (!$java.oncie_FilterScope_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression18;
                        $x$1 = $x$1.$expression18;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_AllIterablePredicate))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_AllIterablePredicate__init_ = function($this, $scope, $expression, $position) {
        $this.$scope13 = $scope;
        $this.$expression18 = $expression;
        $this.$position267 = $position;
        $java.oncie_Expression__init_($this);
        $this.$name61 = $java.oncie_AllIterablePredicate$_name;
    };
    function oncie_FilterScope() {
        var a = this; oncie_Expression.call(a);
        a.$variable3 = null;
        a.$innerPredicate0 = null;
        a.$position268 = null;
        a.$introducedVariables1 = null;
    }
    function oncie_FilterScope__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_FilterScope();
        $java.oncie_FilterScope__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_FilterScope_dependencies = function($this) {
        return $this.$scopeDependencies();
    };
    $java.oncie_FilterScope_position = function($this) {
        return $this.$position268;
    };
    $java.oncie_FilterScope_introducedVariables = function($this) {
        return $this.$introducedVariables1;
    };
    $java.oncie_FilterScope_scopeDependencies = function($this) {
        return (s_Option_fold($this.$innerPredicate0, new $java.oncie_FilterScope$scopeDependencies$lambda$_8_0, new $java.oncie_FilterScope$scopeDependencies$lambda$_8_1)).$removedAll0($this.$introducedVariables1);
    };
    $java.oncie_FilterScope_productPrefix = function($this) {
        return $rt_s(2797);
    };
    $java.oncie_FilterScope_productArity = function($this) {
        return 2;
    };
    $java.oncie_FilterScope_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$variable3;
            case 1:
                return $this.$innerPredicate0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_FilterScope_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FilterScope_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FilterScope_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FilterScope_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_FilterScope) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$variable3;
                        var$3 = $x$1.$variable3;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$innerPredicate0;
                        $x$1 = $x$1.$innerPredicate0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_FilterScope))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_FilterScope__init_ = function($this, $variable, $innerPredicate, $position) {
        var var$4;
        $this.$variable3 = $variable;
        $this.$innerPredicate0 = $innerPredicate;
        $this.$position268 = $position;
        $java.oncie_Expression__init_($this);
        s_Predef$_$callClinit();
        $position = s_Predef$_Set(s_Predef$_MODULE$);
        $innerPredicate = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray(oncie_LogicalVariable, 1);
        var$4.data[0] = $variable;
        $this.$introducedVariables1 = $position.$from0(sr_ScalaRunTime$_wrapRefArray($innerPredicate, var$4));
    };
    function oncie_AnyIterablePredicate() {
        var a = this; oncie_Expression.call(a);
        a.$scope14 = null;
        a.$expression19 = null;
        a.$position269 = null;
        a.$name62 = null;
    }
    function oncie_AnyIterablePredicate__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_AnyIterablePredicate();
        $java.oncie_AnyIterablePredicate__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_AnyIterablePredicate_variable = function($this) {
        return $java.oncie_IterablePredicateExpression_variable$($this);
    };
    $java.oncie_AnyIterablePredicate_innerPredicate = function($this) {
        return $java.oncie_IterablePredicateExpression_innerPredicate$($this);
    };
    $java.oncie_AnyIterablePredicate_asCanonicalStringVal = function($this) {
        return $java.oncie_IterablePredicateExpression_asCanonicalStringVal$($this);
    };
    function oncie_AnyIterablePredicate_scope($this) {
        return $this.$scope14;
    }
    function oncie_AnyIterablePredicate_expression($this) {
        return $this.$expression19;
    }
    $java.oncie_AnyIterablePredicate_position = function($this) {
        return $this.$position269;
    };
    $java.oncie_AnyIterablePredicate_name = function($this) {
        return $this.$name62;
    };
    $java.oncie_AnyIterablePredicate_productPrefix = function($this) {
        return $rt_s(2798);
    };
    $java.oncie_AnyIterablePredicate_productArity = function($this) {
        return 2;
    };
    $java.oncie_AnyIterablePredicate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope14;
            case 1:
                return $this.$expression19;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_AnyIterablePredicate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AnyIterablePredicate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AnyIterablePredicate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AnyIterablePredicate_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_AnyIterablePredicate) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$scope14;
                        var$3 = $x$1.$scope14;
                        if (var$2 !== null) {
                            if (!$java.oncie_FilterScope_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression19;
                        $x$1 = $x$1.$expression19;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_AnyIterablePredicate))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_AnyIterablePredicate__init_ = function($this, $scope, $expression, $position) {
        $this.$scope14 = $scope;
        $this.$expression19 = $expression;
        $this.$position269 = $position;
        $java.oncie_Expression__init_($this);
        $this.$name62 = $java.oncie_AnyIterablePredicate$_name;
    };
    function oncie_NoneIterablePredicate() {
        var a = this; oncie_Expression.call(a);
        a.$scope15 = null;
        a.$expression20 = null;
        a.$position270 = null;
        a.$name63 = null;
    }
    function oncie_NoneIterablePredicate__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_NoneIterablePredicate();
        $java.oncie_NoneIterablePredicate__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_NoneIterablePredicate_variable = function($this) {
        return $java.oncie_IterablePredicateExpression_variable$($this);
    };
    $java.oncie_NoneIterablePredicate_innerPredicate = function($this) {
        return $java.oncie_IterablePredicateExpression_innerPredicate$($this);
    };
    $java.oncie_NoneIterablePredicate_asCanonicalStringVal = function($this) {
        return $java.oncie_IterablePredicateExpression_asCanonicalStringVal$($this);
    };
    function oncie_NoneIterablePredicate_scope($this) {
        return $this.$scope15;
    }
    function oncie_NoneIterablePredicate_expression($this) {
        return $this.$expression20;
    }
    $java.oncie_NoneIterablePredicate_position = function($this) {
        return $this.$position270;
    };
    $java.oncie_NoneIterablePredicate_name = function($this) {
        return $this.$name63;
    };
    $java.oncie_NoneIterablePredicate_productPrefix = function($this) {
        return $rt_s(2799);
    };
    $java.oncie_NoneIterablePredicate_productArity = function($this) {
        return 2;
    };
    $java.oncie_NoneIterablePredicate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope15;
            case 1:
                return $this.$expression20;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_NoneIterablePredicate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NoneIterablePredicate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NoneIterablePredicate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NoneIterablePredicate_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_NoneIterablePredicate) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$scope15;
                        var$3 = $x$1.$scope15;
                        if (var$2 !== null) {
                            if (!$java.oncie_FilterScope_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression20;
                        $x$1 = $x$1.$expression20;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_NoneIterablePredicate))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_NoneIterablePredicate__init_ = function($this, $scope, $expression, $position) {
        $this.$scope15 = $scope;
        $this.$expression20 = $expression;
        $this.$position270 = $position;
        $java.oncie_Expression__init_($this);
        $this.$name63 = $java.oncie_NoneIterablePredicate$_name;
    };
    function oncie_SingleIterablePredicate() {
        var a = this; oncie_Expression.call(a);
        a.$scope16 = null;
        a.$expression21 = null;
        a.$position271 = null;
        a.$name64 = null;
    }
    function oncie_SingleIterablePredicate__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_SingleIterablePredicate();
        $java.oncie_SingleIterablePredicate__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_SingleIterablePredicate_variable = function($this) {
        return $java.oncie_IterablePredicateExpression_variable$($this);
    };
    $java.oncie_SingleIterablePredicate_innerPredicate = function($this) {
        return $java.oncie_IterablePredicateExpression_innerPredicate$($this);
    };
    $java.oncie_SingleIterablePredicate_asCanonicalStringVal = function($this) {
        return $java.oncie_IterablePredicateExpression_asCanonicalStringVal$($this);
    };
    function oncie_SingleIterablePredicate_scope($this) {
        return $this.$scope16;
    }
    function oncie_SingleIterablePredicate_expression($this) {
        return $this.$expression21;
    }
    $java.oncie_SingleIterablePredicate_position = function($this) {
        return $this.$position271;
    };
    $java.oncie_SingleIterablePredicate_name = function($this) {
        return $this.$name64;
    };
    $java.oncie_SingleIterablePredicate_productPrefix = function($this) {
        return $rt_s(2800);
    };
    $java.oncie_SingleIterablePredicate_productArity = function($this) {
        return 2;
    };
    $java.oncie_SingleIterablePredicate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$scope16;
            case 1:
                return $this.$expression21;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SingleIterablePredicate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SingleIterablePredicate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SingleIterablePredicate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SingleIterablePredicate_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_SingleIterablePredicate) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$scope16;
                        var$3 = $x$1.$scope16;
                        if (var$2 !== null) {
                            if (!$java.oncie_FilterScope_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$expression21;
                        $x$1 = $x$1.$expression21;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_SingleIterablePredicate))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_SingleIterablePredicate__init_ = function($this, $scope, $expression, $position) {
        $this.$scope16 = $scope;
        $this.$expression21 = $expression;
        $this.$position271 = $position;
        $java.oncie_Expression__init_($this);
        $this.$name64 = $java.oncie_SingleIterablePredicate$_name;
    };
    $java.oncias_OptionSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncias_OptionSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    var scm_HashMap$$anon$3 = $rt_classWithoutFields(scm_HashMap$HashMapIterator);
    $java.scm_HashMap$$anon$3_extract = function($this, $nd) {
        return $nd.$_value;
    };
    $java.oncie_containsAggregate$$anonfun$apply$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncie_containsAggregate$$anonfun$apply$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        sr_BoxesRunTime_unboxToBoolean(var$1);
        return $java.onciu_Foldable$SkipChildren__init_(jl_Boolean_valueOf(1));
    };
    $java.oncie_SignedOctalIntegerLiteral$$anon$3 = $rt_classWithoutFields(oncie_SignedOctalIntegerLiteral);
    $java.oncie_DecimalDoubleLiteral$$anon$5 = $rt_classWithoutFields(oncie_DecimalDoubleLiteral);
    $java.oncie_SignedHexIntegerLiteral$$anon$4 = $rt_classWithoutFields(oncie_SignedHexIntegerLiteral);
    function scm_TreeSet$$anon$1() {
        var a = this; jl_Object.call(a);
        a.$tree = null;
        a.$ordering$1 = null;
    }
    $java.scm_TreeSet$$anon$1_addAll = function($this, $xs) {
        return scm_Growable_addAll$($this, $xs);
    };
    function scm_TreeSet$$anon$1_result($this) {
        return scm_TreeSet__init_0($this.$tree, $this.$ordering$1);
    }
    $java.scm_TreeSet$$anon$1_addOne = function($this, $elem) {
        scm_RedBlackTree$_insert(scm_RedBlackTree$_MODULE$, $this.$tree, $elem, null, $this.$ordering$1);
        return $this;
    };
    $java.oncias_SemanticExpressionCheck$$check$lambda$_49_0 = function() {
        jl_Object.call(this);
        this.$_0466 = null;
    };
    $java.oncias_SemanticExpressionCheck$$check$lambda$_49_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0466;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticExpressionCheck$$check$lambda$_44_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0461 = null;
        a.$_1142 = null;
    };
    $java.oncias_SemanticExpressionCheck$$check$lambda$_44_0_apply = function(var$0) {
        return $java.oncias_SemanticExpressionCheck$_$anonfun$check$1(var$0.$_0461, var$0.$_1142);
    };
    function scm_HashMap$addAll$lambda$_42_0() {
        jl_Object.call(this);
        this.$_0165 = null;
    }
    function scm_HashMap$addAll$lambda$_42_0_apply(var$0, var$1, var$2, var$3) {
        scm_HashMap_$anonfun$addAll$1(var$0.$_0165, var$1, var$2, sr_BoxesRunTime_unboxToInt(var$3));
        return sr_BoxedUnit_UNIT;
    }
    function scm_HashMap$addAll$lambda$_42_1() {
        jl_Object.call(this);
        this.$_0164 = null;
    }
    $java.scm_HashMap$addAll$lambda$_42_1_apply = function(var$0, var$1, var$2) {
        var var$3, var$4;
        var$3 = var$0.$_0164;
        var$4 = sr_Statics_anyHash(var$1);
        return scm_HashMap_put0(var$3, var$1, var$2, var$4 ^ var$4 >>> 16, 0);
    };
    function onciu_Foldable$Folder$org$neo4j$cypher$internal$util$Foldable$Folder$$innerTreeFold$lambda$_4_0() {
        jl_Object.call(this);
        this.$_0271 = null;
    }
    $java.onciu_Foldable$Folder$org$neo4j$cypher$internal$util$Foldable$Folder$$innerTreeFold$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$0.$_0271.$apply(var$1);
        if (var$1 instanceof $java.onciu_Foldable$SkipChildren)
            var$1 = s_Tuple2__init_(var$1.$acc, s_None$_MODULE$);
        else if (var$1 instanceof $java.onciu_Foldable$TraverseChildren)
            var$1 = s_Tuple2__init_(var$1.$acc0, s_Some__init_(new $java.onciu_Foldable$Folder$$anonfun$innerTreeFold$1$lambda$_13_0));
        else {
            if (!(var$1 instanceof $java.onciu_Foldable$TraverseChildrenNewAccForSiblings))
                $rt_throw(s_MatchError__init_(var$1));
            var$1 = var$1;
            var$2 = var$1.$accumulatorForChildren;
            var$3 = var$1.$forSiblings;
            var$1 = s_Tuple2__init_(var$2, s_Some__init_(var$3));
        }
        return var$1;
    };
    var oncie_QuantifiedPath$ = $rt_classWithoutFields();
    $java.oncie_QuantifiedPath$_MODULE$ = null;
    function oncie_QuantifiedPath$__clinit_() {
        $java.oncie_QuantifiedPath$_MODULE$ = new oncie_QuantifiedPath$;
    }
    $java.oncie_MapProjectionElement = $rt_classWithoutFields(0);
    function oncie_LiteralEntry() {
        var a = this; oncie_Expression.call(a);
        a.$key3 = null;
        a.$exp0 = null;
        a.$position272 = null;
    }
    function oncie_LiteralEntry__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_LiteralEntry();
        $java.oncie_LiteralEntry__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncie_LiteralEntry_key($this) {
        return $this.$key3;
    }
    function oncie_LiteralEntry_exp($this) {
        return $this.$exp0;
    }
    $java.oncie_LiteralEntry_position = function($this) {
        return $this.$position272;
    };
    $java.oncie_LiteralEntry_productPrefix = function($this) {
        return $rt_s(2801);
    };
    $java.oncie_LiteralEntry_productArity = function($this) {
        return 2;
    };
    $java.oncie_LiteralEntry_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$key3;
            case 1:
                return $this.$exp0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_LiteralEntry_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LiteralEntry_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LiteralEntry_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_LiteralEntry_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_LiteralEntry) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$key3;
                        var$3 = $x$1.$key3;
                        if (var$2 !== null) {
                            if (!$java.oncie_PropertyKeyName_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$exp0;
                        $x$1 = $x$1.$exp0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_LiteralEntry))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_LiteralEntry__init_ = function($this, $key, $exp, $position) {
        $this.$key3 = $key;
        $this.$exp0 = $exp;
        $this.$position272 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_PropertySelector() {
        var a = this; oncie_Expression.call(a);
        a.$key4 = null;
        a.$position273 = null;
    }
    function oncie_PropertySelector__init_(var_0, var_1) {
        var var_2 = new oncie_PropertySelector();
        $java.oncie_PropertySelector__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_PropertySelector_key($this) {
        return $this.$key4;
    }
    $java.oncie_PropertySelector_position = function($this) {
        return $this.$position273;
    };
    $java.oncie_PropertySelector_productPrefix = function($this) {
        return $rt_s(2802);
    };
    $java.oncie_PropertySelector_productArity = function($this) {
        return 1;
    };
    $java.oncie_PropertySelector_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$key4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PropertySelector_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PropertySelector_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PropertySelector_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PropertySelector_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_PropertySelector) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$key4;
                        $x$1 = $x$1.$key4;
                        if (var$2 !== null) {
                            if (!$java.oncie_PropertyKeyName_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_PropertySelector))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_PropertySelector__init_ = function($this, $key, $position) {
        $this.$key4 = $key;
        $this.$position273 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_VariableSelector() {
        var a = this; oncie_Expression.call(a);
        a.$id2 = null;
        a.$position274 = null;
    }
    function oncie_VariableSelector__init_(var_0, var_1) {
        var var_2 = new oncie_VariableSelector();
        $java.oncie_VariableSelector__init_(var_2, var_0, var_1);
        return var_2;
    }
    function oncie_VariableSelector_id($this) {
        return $this.$id2;
    }
    $java.oncie_VariableSelector_position = function($this) {
        return $this.$position274;
    };
    $java.oncie_VariableSelector_productPrefix = function($this) {
        return $rt_s(2803);
    };
    $java.oncie_VariableSelector_productArity = function($this) {
        return 1;
    };
    $java.oncie_VariableSelector_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$id2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_VariableSelector_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_VariableSelector_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_VariableSelector_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_VariableSelector_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_VariableSelector) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$id2;
                        $x$1 = $x$1.$id2;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_VariableSelector))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_VariableSelector__init_ = function($this, $id, $position) {
        $this.$id2 = $id;
        $this.$position274 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_AllPropertiesSelector() {
        oncie_Expression.call(this);
        this.$position275 = null;
    }
    function oncie_AllPropertiesSelector__init_0(var_0) {
        var var_1 = new oncie_AllPropertiesSelector();
        oncie_AllPropertiesSelector__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_AllPropertiesSelector_position = function($this) {
        return $this.$position275;
    };
    $java.oncie_AllPropertiesSelector_productPrefix = function($this) {
        return $rt_s(2804);
    };
    $java.oncie_AllPropertiesSelector_productArity = function($this) {
        return 0;
    };
    $java.oncie_AllPropertiesSelector_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_AllPropertiesSelector_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AllPropertiesSelector_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AllPropertiesSelector_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_AllPropertiesSelector_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_AllPropertiesSelector) ? 0 : 1;
        return var$2 && $this instanceof oncie_AllPropertiesSelector ? 1 : 0;
    };
    function oncie_AllPropertiesSelector__init_($this, $position) {
        $this.$position275 = $position;
        $java.oncie_Expression__init_($this);
    }
    function oncie_Subtract() {
        var a = this; oncie_Expression.call(a);
        a.$lhs18 = null;
        a.$rhs19 = null;
        a.$position241 = null;
        a.$signatures14 = null;
    }
    function oncie_Subtract__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Subtract();
        $java.oncie_Subtract__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Subtract_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Subtract_lhs = function($this) {
        return $this.$lhs18;
    };
    $java.oncie_Subtract_rhs = function($this) {
        return $this.$rhs19;
    };
    $java.oncie_Subtract_position = function($this) {
        return $this.$position241;
    };
    $java.oncie_Subtract_signatures = function($this) {
        return $this.$signatures14;
    };
    $java.oncie_Subtract_canonicalOperatorSymbol = function($this) {
        return $rt_s(992);
    };
    $java.oncie_Subtract_productPrefix = function($this) {
        return $rt_s(2805);
    };
    $java.oncie_Subtract_productArity = function($this) {
        return 2;
    };
    $java.oncie_Subtract_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs18;
            case 1:
                return $this.$rhs19;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Subtract_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Subtract_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Subtract_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Subtract_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Subtract) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs18;
                        var$3 = $x$1.$lhs18;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs19;
                        $x$1 = $x$1.$rhs19;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Subtract))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Subtract__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs18 = $lhs;
        $this.$rhs19 = $rhs;
        $this.$position241 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 10);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        var$8 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_IntegerType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, var$8.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$9)), oncius_package$_CTInteger(oncius_package$_MODULE$));
        var$6[1] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[2] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_FloatType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[3] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[4] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_DurationType, [$java.oncius_package$_CTDuration0(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        var$6[5] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$));
        var$6[6] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTTime0(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTTime0(oncius_package$_MODULE$));
        var$6[7] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTDate0(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDate0(oncius_package$_MODULE$));
        var$6[8] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$));
        var$6[9] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTDateTime0(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$));
        $this.$signatures14 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncie_Add() {
        var a = this; oncie_Expression.call(a);
        a.$lhs17 = null;
        a.$rhs18 = null;
        a.$position240 = null;
    }
    function oncie_Add__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Add();
        $java.oncie_Add__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Add_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Add_lhs = function($this) {
        return $this.$lhs17;
    };
    $java.oncie_Add_rhs = function($this) {
        return $this.$rhs18;
    };
    $java.oncie_Add_position = function($this) {
        return $this.$position240;
    };
    $java.oncie_Add_canonicalOperatorSymbol = function($this) {
        return $rt_s(395);
    };
    $java.oncie_Add_productPrefix = function($this) {
        return $rt_s(2806);
    };
    $java.oncie_Add_productArity = function($this) {
        return 2;
    };
    $java.oncie_Add_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs17;
            case 1:
                return $this.$rhs18;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Add_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Add_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Add_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Add_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Add) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs17;
                        var$3 = $x$1.$lhs17;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs18;
                        $x$1 = $x$1.$rhs18;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Add))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Add__init_ = function($this, $lhs, $rhs, $position) {
        $this.$lhs17 = $lhs;
        $this.$rhs18 = $rhs;
        $this.$position240 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_RegexMatch() {
        var a = this; oncie_Expression.call(a);
        a.$lhs22 = null;
        a.$rhs22 = null;
        a.$position276 = null;
        a.$signatures15 = null;
    }
    function oncie_RegexMatch__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_RegexMatch();
        $java.oncie_RegexMatch__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_RegexMatch_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_RegexMatch_lhs = function($this) {
        return $this.$lhs22;
    };
    $java.oncie_RegexMatch_rhs = function($this) {
        return $this.$rhs22;
    };
    $java.oncie_RegexMatch_position = function($this) {
        return $this.$position276;
    };
    $java.oncie_RegexMatch_signatures = function($this) {
        return $this.$signatures15;
    };
    $java.oncie_RegexMatch_canonicalOperatorSymbol = function($this) {
        return $rt_s(997);
    };
    $java.oncie_RegexMatch_productPrefix = function($this) {
        return $rt_s(2807);
    };
    $java.oncie_RegexMatch_productArity = function($this) {
        return 2;
    };
    $java.oncie_RegexMatch_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs22;
            case 1:
                return $this.$rhs22;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_RegexMatch_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RegexMatch_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RegexMatch_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RegexMatch_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_RegexMatch) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs22;
                        var$3 = $x$1.$lhs22;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs22;
                        $x$1 = $x$1.$rhs22;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_RegexMatch))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_RegexMatch__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs22 = $lhs;
        $this.$rhs22 = $rhs;
        $this.$position276 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_StringType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTString(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures15 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncia_IsTyped() {
        var a = this; oncie_Expression.call(a);
        a.$lhs23 = null;
        a.$typeName1 = null;
        a.$position277 = null;
        a.$signatures16 = null;
    }
    function oncia_IsTyped__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_IsTyped();
        $java.oncia_IsTyped__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_IsTyped_asCanonicalStringVal = function($this) {
        return $java.oncie_RightUnaryOperatorExpression_asCanonicalStringVal$($this);
    };
    function oncia_IsTyped_lhs($this) {
        return $this.$lhs23;
    }
    function oncia_IsTyped_typeName($this) {
        return $this.$typeName1;
    }
    $java.oncia_IsTyped_position = function($this) {
        return $this.$position277;
    };
    $java.oncia_IsTyped_signatures = function($this) {
        return $this.$signatures16;
    };
    function oncia_IsTyped_canonicalOperatorSymbol($this) {
        return $rt_s(2808);
    }
    $java.oncia_IsTyped_productPrefix = function($this) {
        return $rt_s(2809);
    };
    $java.oncia_IsTyped_productArity = function($this) {
        return 2;
    };
    $java.oncia_IsTyped_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs23;
            case 1:
                return $this.$typeName1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_IsTyped_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IsTyped_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IsTyped_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IsTyped_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_IsTyped) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs23;
                        var$3 = $x$1.$lhs23;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$typeName1;
                        $x$1 = $x$1.$typeName1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_IsTyped))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_IsTyped__init_ = function($this, $lhs, $typeName, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs23 = $lhs;
        $this.$typeName1 = $typeName;
        $this.$position277 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures16 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncie_Contains() {
        var a = this; oncie_Expression.call(a);
        a.$lhs24 = null;
        a.$rhs23 = null;
        a.$position278 = null;
        a.$signatures17 = null;
    }
    function oncie_Contains__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Contains();
        $java.oncie_Contains__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Contains_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Contains_canonicalOperatorSymbol = function($this) {
        return $java.oncie_OperatorExpression_canonicalOperatorSymbol$($this);
    };
    $java.oncie_Contains_lhs = function($this) {
        return $this.$lhs24;
    };
    $java.oncie_Contains_rhs = function($this) {
        return $this.$rhs23;
    };
    $java.oncie_Contains_position = function($this) {
        return $this.$position278;
    };
    $java.oncie_Contains_signatures = function($this) {
        return $this.$signatures17;
    };
    $java.oncie_Contains_productPrefix = function($this) {
        return $rt_s(2810);
    };
    $java.oncie_Contains_productArity = function($this) {
        return 2;
    };
    $java.oncie_Contains_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs24;
            case 1:
                return $this.$rhs23;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Contains_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Contains_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Contains_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Contains_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Contains) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs24;
                        var$3 = $x$1.$lhs24;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs23;
                        $x$1 = $x$1.$rhs23;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Contains))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Contains__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs24 = $lhs;
        $this.$rhs23 = $rhs;
        $this.$position278 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures17 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncie_EndsWith() {
        var a = this; oncie_Expression.call(a);
        a.$lhs25 = null;
        a.$rhs24 = null;
        a.$position279 = null;
        a.$signatures18 = null;
    }
    function oncie_EndsWith__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_EndsWith();
        $java.oncie_EndsWith__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_EndsWith_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_EndsWith_lhs = function($this) {
        return $this.$lhs25;
    };
    $java.oncie_EndsWith_rhs = function($this) {
        return $this.$rhs24;
    };
    $java.oncie_EndsWith_position = function($this) {
        return $this.$position279;
    };
    $java.oncie_EndsWith_signatures = function($this) {
        return $this.$signatures18;
    };
    $java.oncie_EndsWith_canonicalOperatorSymbol = function($this) {
        return $rt_s(2811);
    };
    $java.oncie_EndsWith_productPrefix = function($this) {
        return $rt_s(2812);
    };
    $java.oncie_EndsWith_productArity = function($this) {
        return 2;
    };
    $java.oncie_EndsWith_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs25;
            case 1:
                return $this.$rhs24;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_EndsWith_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_EndsWith_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_EndsWith_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_EndsWith_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_EndsWith) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs25;
                        var$3 = $x$1.$lhs25;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs24;
                        $x$1 = $x$1.$rhs24;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_EndsWith))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_EndsWith__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs25 = $lhs;
        $this.$rhs24 = $rhs;
        $this.$position279 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures18 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncie_StartsWith() {
        var a = this; oncie_Expression.call(a);
        a.$lhs26 = null;
        a.$rhs25 = null;
        a.$position280 = null;
        a.$signatures19 = null;
    }
    function oncie_StartsWith__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_StartsWith();
        $java.oncie_StartsWith__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_StartsWith_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_StartsWith_lhs = function($this) {
        return $this.$lhs26;
    };
    $java.oncie_StartsWith_rhs = function($this) {
        return $this.$rhs25;
    };
    $java.oncie_StartsWith_position = function($this) {
        return $this.$position280;
    };
    $java.oncie_StartsWith_signatures = function($this) {
        return $this.$signatures19;
    };
    $java.oncie_StartsWith_canonicalOperatorSymbol = function($this) {
        return $rt_s(2813);
    };
    $java.oncie_StartsWith_productPrefix = function($this) {
        return $rt_s(2814);
    };
    $java.oncie_StartsWith_productArity = function($this) {
        return 2;
    };
    $java.oncie_StartsWith_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs26;
            case 1:
                return $this.$rhs25;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_StartsWith_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StartsWith_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StartsWith_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StartsWith_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_StartsWith) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs26;
                        var$3 = $x$1.$lhs26;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs25;
                        $x$1 = $x$1.$rhs25;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_StartsWith))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_StartsWith__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs26 = $lhs;
        $this.$rhs25 = $rhs;
        $this.$position280 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures19 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncia_IsNotTyped() {
        var a = this; oncie_Expression.call(a);
        a.$lhs27 = null;
        a.$typeName2 = null;
        a.$position281 = null;
        a.$signatures20 = null;
    }
    function oncia_IsNotTyped__init_(var_0, var_1, var_2) {
        var var_3 = new oncia_IsNotTyped();
        $java.oncia_IsNotTyped__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncia_IsNotTyped_asCanonicalStringVal = function($this) {
        return $java.oncie_RightUnaryOperatorExpression_asCanonicalStringVal$($this);
    };
    function oncia_IsNotTyped_lhs($this) {
        return $this.$lhs27;
    }
    function oncia_IsNotTyped_typeName($this) {
        return $this.$typeName2;
    }
    $java.oncia_IsNotTyped_position = function($this) {
        return $this.$position281;
    };
    $java.oncia_IsNotTyped_signatures = function($this) {
        return $this.$signatures20;
    };
    function oncia_IsNotTyped_canonicalOperatorSymbol($this) {
        return $rt_s(2815);
    }
    $java.oncia_IsNotTyped_productPrefix = function($this) {
        return $rt_s(2816);
    };
    $java.oncia_IsNotTyped_productArity = function($this) {
        return 2;
    };
    $java.oncia_IsNotTyped_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs27;
            case 1:
                return $this.$typeName2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_IsNotTyped_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IsNotTyped_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IsNotTyped_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_IsNotTyped_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncia_IsNotTyped) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs27;
                        var$3 = $x$1.$lhs27;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$typeName2;
                        $x$1 = $x$1.$typeName2;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_IsNotTyped))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_IsNotTyped__init_ = function($this, $lhs, $typeName, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs27 = $lhs;
        $this.$typeName2 = $typeName;
        $this.$position281 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_AnyType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTAny(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), oncius_package$_CTBoolean(oncius_package$_MODULE$));
        $this.$signatures20 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function jur_Pattern() {
        var a = this; jl_Object.call(a);
        a.$lexemes = null;
        a.$flags4 = 0;
        a.$backRefs = null;
        a.$needsBackRefReplacement = 0;
        a.$globalGroupIndex = 0;
        a.$compCount = 0;
        a.$consCount = 0;
        a.$start5 = null;
    }
    function jur_Pattern_matcher($this, $input) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        var$2 = new jur_Matcher;
        var$2.$leftBound = (-1);
        var$2.$rightBound = (-1);
        var$2.$pat = $this;
        var$2.$start6 = $this.$start5;
        var$2.$string = $input;
        var$2.$leftBound = 0;
        var$3 = jl_String_length($input);
        var$2.$rightBound = var$3;
        var$4 = new jur_MatchResultImpl;
        var$5 = var$2.$leftBound;
        var$6 = $this.$globalGroupIndex;
        var$7 = $this.$compCount + 1 | 0;
        var$8 = $this.$consCount + 1 | 0;
        var$4.$previousMatch = (-1);
        var$6 = var$6 + 1 | 0;
        var$4.$groupCount = var$6;
        var$4.$groupBounds = $rt_createIntArray(var$6 * 2 | 0);
        var$9 = $rt_createIntArray(var$8);
        var$4.$consumers = var$9;
        ju_Arrays_fill0(var$9, (-1));
        if (var$7 > 0)
            var$4.$compQuantCounters = $rt_createIntArray(var$7);
        ju_Arrays_fill0(var$4.$groupBounds, (-1));
        jur_MatchResultImpl_reset(var$4, $input, var$5, var$3);
        var$2.$matchResult = var$4;
        var$4.$anchoringBounds = 1;
        return var$2;
    }
    $java.jur_Pattern_pattern = function($this) {
        return $this.$lexemes.$orig;
    };
    $java.jur_Pattern_processExpression = function($this, $ch, $newFlags, $last) {
        var $children, $saveFlags, $saveChangedFlags, $fSet, $child, var$9;
        $children = ju_ArrayList__init_();
        $saveFlags = $this.$flags4;
        $saveChangedFlags = 0;
        if ($newFlags != $saveFlags)
            $this.$flags4 = $newFlags;
        a: {
            switch ($ch) {
                case -1073741784:
                    $fSet = new $java.jur_NonCapFSet;
                    $newFlags = $this.$consCount + 1 | 0;
                    $this.$consCount = $newFlags;
                    $java.jur_FSet__init_($fSet, $newFlags);
                    break a;
                case -536870872:
                case -268435416:
                    break;
                case -134217688:
                case -67108824:
                    $fSet = new $java.jur_BehindFSet;
                    $newFlags = $this.$consCount + 1 | 0;
                    $this.$consCount = $newFlags;
                    $java.jur_FSet__init_($fSet, $newFlags);
                    break a;
                case -33554392:
                    $fSet = new $java.jur_AtomicFSet;
                    $newFlags = $this.$consCount + 1 | 0;
                    $this.$consCount = $newFlags;
                    $java.jur_FSet__init_($fSet, $newFlags);
                    break a;
                default:
                    $newFlags = $this.$globalGroupIndex + 1 | 0;
                    $this.$globalGroupIndex = $newFlags;
                    if ($last !== null)
                        $fSet = $java.jur_FSet__init_0($newFlags);
                    else {
                        $fSet = new $java.jur_FinalSet;
                        $java.jur_FSet__init_($fSet, 0);
                        $saveChangedFlags = 1;
                    }
                    $newFlags = $this.$globalGroupIndex;
                    if ($newFlags <= (-1))
                        break a;
                    if ($newFlags >= 10)
                        break a;
                    $this.$backRefs.data[$newFlags] = $fSet;
                    break a;
            }
            $fSet = new $java.jur_AheadFSet;
            $java.jur_FSet__init_($fSet, (-1));
        }
        while (true) {
            if ($java.jur_Lexer_isLetter($this.$lexemes) && $this.$lexemes.$lookAhead == (-536870788)) {
                $last = $java.jur_CharClass__init_($java.jur_Pattern_hasFlag($this, 2), $java.jur_Pattern_hasFlag($this, 64));
                while (!$java.jur_Lexer_isEmpty($this.$lexemes) && $java.jur_Lexer_isLetter($this.$lexemes)) {
                    $child = $this.$lexemes;
                    var$9 = $child.$lookAhead;
                    if (var$9 && var$9 != (-536870788) && var$9 != (-536870871))
                        break;
                    $java.jur_CharClass_add($last, $java.jur_Lexer_next($child));
                    $child = $this.$lexemes;
                    if ($child.$ch != (-536870788))
                        continue;
                    $java.jur_Lexer_next($child);
                }
                $child = $java.jur_Pattern_processRangeSet($this, $last);
                $child.$setNext($fSet);
            } else if ($this.$lexemes.$ch == (-536870788)) {
                $child = $java.jur_EmptySet__init_($fSet);
                $java.jur_Lexer_next($this.$lexemes);
            } else {
                $child = $java.jur_Pattern_processSubExpression($this, $fSet);
                $last = $this.$lexemes;
                if ($last.$ch == (-536870788))
                    $java.jur_Lexer_next($last);
            }
            if ($child !== null)
                ju_ArrayList_add($children, $child);
            if ($java.jur_Lexer_isEmpty($this.$lexemes))
                break;
            if ($this.$lexemes.$ch == (-536870871))
                break;
        }
        if ($this.$lexemes.$lookBack == (-536870788))
            ju_ArrayList_add($children, $java.jur_EmptySet__init_($fSet));
        if ($this.$flags4 != $saveFlags && !$saveChangedFlags) {
            $this.$flags4 = $saveFlags;
            $last = $this.$lexemes;
            $last.$flags5 = $saveFlags;
            $last.$lookAhead = $last.$ch;
            $last.$lookAheadST = $last.$curST;
            var$9 = $last.$curToc;
            $last.$index6 = var$9 + 1 | 0;
            $last.$lookAheadToc = var$9;
            $java.jur_Lexer_movePointer($last);
        }
        switch ($ch) {
            case -1073741784:
                break;
            case -536870872:
                $last = new $java.jur_PositiveLookAhead;
                $java.jur_JointSet__init_($last, $children, $fSet);
                return $last;
            case -268435416:
                $last = new $java.jur_NegativeLookAhead;
                $java.jur_JointSet__init_($last, $children, $fSet);
                return $last;
            case -134217688:
                $last = new $java.jur_PositiveLookBehind;
                $java.jur_JointSet__init_($last, $children, $fSet);
                return $last;
            case -67108824:
                $last = new $java.jur_NegativeLookBehind;
                $java.jur_JointSet__init_($last, $children, $fSet);
                return $last;
            case -33554392:
                $last = new $java.jur_AtomicJointSet;
                $java.jur_JointSet__init_($last, $children, $fSet);
                return $last;
            default:
                switch ($children.$size2) {
                    case 0:
                        break;
                    case 1:
                        return $java.jur_SingleSet__init_(ju_ArrayList_get($children, 0), $fSet);
                    default:
                        return $java.jur_JointSet__init_0($children, $fSet);
                }
                return $java.jur_EmptySet__init_($fSet);
        }
        $last = new $java.jur_NonCapJointSet;
        $java.jur_JointSet__init_($last, $children, $fSet);
        return $last;
    };
    $java.jur_Pattern_processDecomposedChar = function($this) {
        var $codePoints, $curSymb, $curSymbIndex, $codePointsHangul, var$5, var$6, $readCodePoints;
        $codePoints = $rt_createIntArray(4);
        $curSymb = (-1);
        $curSymbIndex = (-1);
        if (!$java.jur_Lexer_isEmpty($this.$lexemes) && $java.jur_Lexer_isLetter($this.$lexemes)) {
            $codePointsHangul = $codePoints.data;
            $curSymb = $java.jur_Lexer_next($this.$lexemes);
            $codePointsHangul[0] = $curSymb;
            $curSymbIndex = $curSymb - 4352 | 0;
        }
        if ($curSymbIndex >= 0 && $curSymbIndex < 19) {
            $codePointsHangul = $rt_createCharArray(3);
            $codePoints = $codePointsHangul.data;
            $codePoints[0] = $curSymb & 65535;
            var$5 = $this.$lexemes;
            var$6 = var$5.$ch;
            $readCodePoints = var$6 - 4449 | 0;
            if ($readCodePoints >= 0 && $readCodePoints < 21) {
                $codePoints[1] = var$6 & 65535;
                $java.jur_Lexer_next(var$5);
                var$5 = $this.$lexemes;
                var$6 = var$5.$ch;
                $curSymb = var$6 - 4519 | 0;
                if ($curSymb >= 0 && $curSymb < 28) {
                    $codePoints[2] = var$6 & 65535;
                    $java.jur_Lexer_next(var$5);
                    return $java.jur_HangulDecomposedCharSet__init_($codePointsHangul, 3);
                }
                return $java.jur_HangulDecomposedCharSet__init_($codePointsHangul, 2);
            }
            if (!$java.jur_Pattern_hasFlag($this, 2))
                return $java.jur_CharSet__init_($codePoints[0]);
            if ($java.jur_Pattern_hasFlag($this, 64))
                return $java.jur_UCICharSet__init_($codePoints[0]);
            return $java.jur_CICharSet__init_($codePoints[0]);
        }
        $codePointsHangul = $codePoints.data;
        $curSymb = 1;
        while ($curSymb < 4 && !$java.jur_Lexer_isEmpty($this.$lexemes) && $java.jur_Lexer_isLetter($this.$lexemes)) {
            $readCodePoints = $curSymb + 1 | 0;
            $codePointsHangul[$curSymb] = $java.jur_Lexer_next($this.$lexemes);
            $curSymb = $readCodePoints;
        }
        if ($curSymb == 1) {
            $readCodePoints = $codePointsHangul[0];
            if (!($java.jur_Lexer_singleDecompTable.$get5($readCodePoints) == $java.jur_Lexer_singleDecompTableSize ? 0 : 1))
                return $java.jur_Pattern_processCharSet($this, $codePointsHangul[0]);
        }
        if (!$java.jur_Pattern_hasFlag($this, 2))
            return $java.jur_DecomposedCharSet__init_($codePoints, $curSymb);
        if ($java.jur_Pattern_hasFlag($this, 64)) {
            var$5 = new $java.jur_UCIDecomposedCharSet;
            $java.jur_DecomposedCharSet__init_0(var$5, $codePoints, $curSymb);
            return var$5;
        }
        var$5 = new $java.jur_CIDecomposedCharSet;
        $java.jur_DecomposedCharSet__init_0(var$5, $codePoints, $curSymb);
        return var$5;
    };
    $java.jur_Pattern_processSubExpression = function($this, $last) {
        var $cur, $term, var$4, $next, var$6, var$7, var$8;
        if ($java.jur_Lexer_isLetter($this.$lexemes) && !$java.jur_Lexer_isNextSpecial($this.$lexemes) && $java.jur_Lexer_isLetter0($this.$lexemes.$lookAhead)) {
            if ($java.jur_Pattern_hasFlag($this, 128)) {
                $cur = $java.jur_Pattern_processDecomposedChar($this);
                if (!$java.jur_Lexer_isEmpty($this.$lexemes)) {
                    $term = $this.$lexemes;
                    var$4 = $term.$ch;
                    if (!(var$4 == (-536870871) && !($last instanceof $java.jur_FinalSet)) && var$4 != (-536870788) && !$java.jur_Lexer_isLetter($term))
                        $cur = $java.jur_Pattern_processQuantifier($this, $last, $cur);
                }
            } else if (!$java.jur_Lexer_isHighSurrogate($this.$lexemes) && !$java.jur_Lexer_isLowSurrogate($this.$lexemes)) {
                $next = new jl_StringBuffer;
                jl_AbstractStringBuilder__init_($next);
                while (!$java.jur_Lexer_isEmpty($this.$lexemes) && $java.jur_Lexer_isLetter($this.$lexemes) && !$java.jur_Lexer_isHighSurrogate($this.$lexemes) && !$java.jur_Lexer_isLowSurrogate($this.$lexemes)) {
                    if (!(!$java.jur_Lexer_isNextSpecial($this.$lexemes) && !$this.$lexemes.$lookAhead) && !(!$java.jur_Lexer_isNextSpecial($this.$lexemes) && $java.jur_Lexer_isLetter0($this.$lexemes.$lookAhead))) {
                        var$6 = $this.$lexemes.$lookAhead;
                        if (var$6 != (-536870871) && (var$6 & (-2147418113)) != (-2147483608) && var$6 != (-536870788) && var$6 != (-536870876))
                            break;
                    }
                    var$4 = $java.jur_Lexer_next($this.$lexemes);
                    if (!jl_Character_isSupplementaryCodePoint(var$4))
                        jl_AbstractStringBuilder_append($next, var$4 & 65535);
                    else
                        jl_AbstractStringBuilder_append5($next, jl_Character_toChars(var$4));
                }
                if (!$java.jur_Pattern_hasFlag($this, 2)) {
                    $cur = new $java.jur_SequenceSet;
                    $java.jur_LeafSet__init_($cur);
                    $cur.$string2 = jl_AbstractStringBuilder_toString($next);
                    var$4 = $next.$length0;
                    $cur.$charCount = var$4;
                    $cur.$leftToRight0 = $java.jur_SequenceSet$IntHash__init_(var$4);
                    $cur.$rightToLeft = $java.jur_SequenceSet$IntHash__init_($cur.$charCount);
                    var$7 = 0;
                    while (var$7 < ($cur.$charCount - 1 | 0)) {
                        $java.jur_SequenceSet$IntHash_put($cur.$leftToRight0, jl_String_charAt($cur.$string2, var$7), ($cur.$charCount - var$7 | 0) - 1 | 0);
                        $java.jur_SequenceSet$IntHash_put($cur.$rightToLeft, jl_String_charAt($cur.$string2, ($cur.$charCount - var$7 | 0) - 1 | 0), ($cur.$charCount - var$7 | 0) - 1 | 0);
                        var$7 = var$7 + 1 | 0;
                    }
                } else if ($java.jur_Pattern_hasFlag($this, 64))
                    $cur = $java.jur_UCISequenceSet__init_($next);
                else {
                    $cur = new $java.jur_CISequenceSet;
                    $java.jur_LeafSet__init_($cur);
                    $cur.$string3 = jl_AbstractStringBuilder_toString($next);
                    $cur.$charCount = $next.$length0;
                }
            } else
                $cur = $java.jur_Pattern_processQuantifier($this, $last, $java.jur_Pattern_processTerminal($this, $last));
        } else {
            $term = $this.$lexemes;
            if ($term.$ch != (-536870871))
                $cur = $java.jur_Pattern_processQuantifier($this, $last, $java.jur_Pattern_processTerminal($this, $last));
            else {
                if ($last instanceof $java.jur_FinalSet)
                    $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $term.$orig, $java.jur_Lexer_getIndex($term)));
                $cur = $java.jur_EmptySet__init_($last);
            }
        }
        a: {
            if (!$java.jur_Lexer_isEmpty($this.$lexemes)) {
                var$4 = $this.$lexemes.$ch;
                if (!(var$4 == (-536870871) && !($last instanceof $java.jur_FinalSet)) && var$4 != (-536870788)) {
                    $next = $java.jur_Pattern_processSubExpression($this, $last);
                    if ($cur instanceof $java.jur_LeafQuantifierSet && !($cur instanceof $java.jur_CompositeQuantifierSet) && !($cur instanceof $java.jur_GroupQuantifierSet) && !($cur instanceof $java.jur_AltQuantifierSet)) {
                        var$8 = $cur;
                        if (!$next.$first4(var$8.$innerSet)) {
                            $cur = new $java.jur_UnifiedQuantifierSet;
                            $java.jur_LeafQuantifierSet__init_($cur, var$8.$innerSet, var$8.$next12, var$8.$type0);
                            $cur.$innerSet.$setNext($cur);
                        }
                    }
                    if (($next.$getType0() & 65535) != 43)
                        $cur.$setNext($next);
                    else
                        $cur.$setNext($next.$innerSet);
                    break a;
                }
            }
            if ($cur === null)
                return null;
            $cur.$setNext($last);
        }
        if (($cur.$getType0() & 65535) != 43)
            return $cur;
        return $cur.$innerSet;
    };
    $java.jur_Pattern_processQuantifier = function($this, $last, $term) {
        var $q, $quant, $leaf, var$6, $q_0;
        $q = $this.$lexemes;
        $quant = $q.$ch;
        if ($term !== null && !($term instanceof $java.jur_LeafSet)) {
            switch ($quant) {
                case -2147483606:
                    $java.jur_Lexer_next($q);
                    $q = new $java.jur_PossessiveGroupQuantifierSet;
                    $java.jur_QuantifierSet__init_($q, $term, $last, $quant);
                    $java.jur_FSet_$callClinit();
                    $term.$setNext($java.jur_FSet_posFSet);
                    return $q;
                case -2147483605:
                    $java.jur_Lexer_next($q);
                    $q = new $java.jur_PosPlusGroupQuantifierSet;
                    $java.jur_QuantifierSet__init_($q, $term, $last, (-2147483606));
                    $java.jur_FSet_$callClinit();
                    $term.$setNext($java.jur_FSet_posFSet);
                    return $q;
                case -2147483585:
                    $java.jur_Lexer_next($q);
                    $q = new $java.jur_PosAltGroupQuantifierSet;
                    $java.jur_QuantifierSet__init_($q, $term, $last, (-536870849));
                    $java.jur_FSet_$callClinit();
                    $term.$setNext($java.jur_FSet_posFSet);
                    return $q;
                case -2147483525:
                    $leaf = new $java.jur_PosCompositeGroupQuantifierSet;
                    $q = $java.jur_Lexer_nextSpecial($q);
                    var$6 = $this.$compCount + 1 | 0;
                    $this.$compCount = var$6;
                    $java.jur_CompositeGroupQuantifierSet__init_($leaf, $q, $term, $last, (-536870849), var$6);
                    $java.jur_FSet_$callClinit();
                    $term.$setNext($java.jur_FSet_posFSet);
                    return $leaf;
                case -1073741782:
                case -1073741781:
                    $java.jur_Lexer_next($q);
                    $q = new $java.jur_ReluctantGroupQuantifierSet;
                    $java.jur_QuantifierSet__init_($q, $term, $last, $quant);
                    $term.$setNext($q);
                    return $q;
                case -1073741761:
                    $java.jur_Lexer_next($q);
                    $q = new $java.jur_RelAltGroupQuantifierSet;
                    $java.jur_QuantifierSet__init_($q, $term, $last, (-536870849));
                    $term.$setNext($last);
                    return $q;
                case -1073741701:
                    $q_0 = new $java.jur_RelCompositeGroupQuantifierSet;
                    $q = $java.jur_Lexer_nextSpecial($q);
                    $quant = $this.$compCount + 1 | 0;
                    $this.$compCount = $quant;
                    $java.jur_CompositeGroupQuantifierSet__init_($q_0, $q, $term, $last, (-536870849), $quant);
                    $term.$setNext($q_0);
                    return $q_0;
                case -536870870:
                case -536870869:
                    $java.jur_Lexer_next($q);
                    if ($term.$getType0() != (-2147483602)) {
                        $q = new $java.jur_GroupQuantifierSet;
                        $java.jur_QuantifierSet__init_($q, $term, $last, $quant);
                    } else if ($java.jur_Pattern_hasFlag($this, 32)) {
                        $q = new $java.jur_DotAllQuantifierSet;
                        $java.jur_QuantifierSet__init_($q, $term, $last, $quant);
                    } else {
                        $q = new $java.jur_DotQuantifierSet;
                        $leaf = $java.jur_AbstractLineTerminator_getInstance($this.$flags4);
                        $java.jur_QuantifierSet__init_($q, $term, $last, $quant);
                        $q.$lt0 = $leaf;
                    }
                    $term.$setNext($q);
                    return $q;
                case -536870849:
                    $java.jur_Lexer_next($q);
                    $q = new $java.jur_AltGroupQuantifierSet;
                    $java.jur_QuantifierSet__init_($q, $term, $last, (-536870849));
                    $term.$setNext($last);
                    return $q;
                case -536870789:
                    $q_0 = new $java.jur_CompositeGroupQuantifierSet;
                    $q = $java.jur_Lexer_nextSpecial($q);
                    $quant = $this.$compCount + 1 | 0;
                    $this.$compCount = $quant;
                    $java.jur_CompositeGroupQuantifierSet__init_($q_0, $q, $term, $last, (-536870849), $quant);
                    $term.$setNext($q_0);
                    return $q_0;
                default:
            }
            return $term;
        }
        $leaf = null;
        if ($term !== null)
            $leaf = $term;
        switch ($quant) {
            case -2147483606:
            case -2147483605:
                $java.jur_Lexer_next($q);
                $q = new $java.jur_PossessiveQuantifierSet;
                $java.jur_LeafQuantifierSet__init_($q, $leaf, $last, $quant);
                $leaf.$next12 = $q;
                return $q;
            case -2147483585:
                $java.jur_Lexer_next($q);
                $term = new $java.jur_PossessiveAltQuantifierSet;
                $java.jur_LeafQuantifierSet__init_($term, $leaf, $last, (-2147483585));
                return $term;
            case -2147483525:
                $term = new $java.jur_PossessiveCompositeQuantifierSet;
                $java.jur_CompositeQuantifierSet__init_($term, $java.jur_Lexer_nextSpecial($q), $leaf, $last, (-2147483525));
                return $term;
            case -1073741782:
            case -1073741781:
                $java.jur_Lexer_next($q);
                $q = new $java.jur_ReluctantQuantifierSet;
                $java.jur_LeafQuantifierSet__init_($q, $leaf, $last, $quant);
                $leaf.$next12 = $q;
                return $q;
            case -1073741761:
                $java.jur_Lexer_next($q);
                $term = new $java.jur_ReluctantAltQuantifierSet;
                $java.jur_LeafQuantifierSet__init_($term, $leaf, $last, (-1073741761));
                return $term;
            case -1073741701:
                $term = new $java.jur_ReluctantCompositeQuantifierSet;
                $java.jur_CompositeQuantifierSet__init_($term, $java.jur_Lexer_nextSpecial($q), $leaf, $last, (-1073741701));
                return $term;
            case -536870870:
            case -536870869:
                $java.jur_Lexer_next($q);
                $q = $java.jur_LeafQuantifierSet__init_0($leaf, $last, $quant);
                $leaf.$next12 = $q;
                return $q;
            case -536870849:
                $java.jur_Lexer_next($q);
                $term = new $java.jur_AltQuantifierSet;
                $java.jur_LeafQuantifierSet__init_($term, $leaf, $last, (-536870849));
                return $term;
            case -536870789:
                return $java.jur_CompositeQuantifierSet__init_0($java.jur_Lexer_nextSpecial($q), $leaf, $last, (-536870789));
            default:
        }
        return $term;
    };
    $java.jur_Pattern_processTerminal = function($this, $last) {
        var $term, var$3, var$4, $ch, $newFlags, $number, $negative, $cc;
        $term = null;
        var$3 = $last instanceof $java.jur_FinalSet;
        while (true) {
            a: {
                var$4 = $this.$lexemes;
                $ch = var$4.$ch;
                if (($ch & (-2147418113)) == (-2147483608)) {
                    $java.jur_Lexer_next(var$4);
                    $newFlags = ($ch & 16711680) >> 16;
                    $ch = $ch & (-16711681);
                    if ($ch == (-16777176))
                        $this.$flags4 = $newFlags;
                    else {
                        if ($ch != (-1073741784))
                            $newFlags = $this.$flags4;
                        $term = $java.jur_Pattern_processExpression($this, $ch, $newFlags, $last);
                        var$4 = $this.$lexemes;
                        if (var$4.$ch != (-536870871))
                            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), var$4.$orig, var$4.$curToc));
                        $java.jur_Lexer_next(var$4);
                    }
                } else {
                    b: {
                        c: {
                            switch ($ch) {
                                case -2147483599:
                                case -2147483598:
                                case -2147483597:
                                case -2147483596:
                                case -2147483595:
                                case -2147483594:
                                case -2147483593:
                                case -2147483592:
                                case -2147483591:
                                    break c;
                                case -2147483583:
                                    break;
                                case -2147483582:
                                    $java.jur_Lexer_next(var$4);
                                    $term = $java.jur_WordBoundary__init_(0);
                                    break a;
                                case -2147483577:
                                    $java.jur_Lexer_next(var$4);
                                    $term = new $java.jur_PreviousMatch;
                                    $java.jur_AbstractSet__init_($term);
                                    break a;
                                case -2147483558:
                                    $java.jur_Lexer_next(var$4);
                                    $term = new $java.jur_EOLSet;
                                    $number = $this.$consCount + 1 | 0;
                                    $this.$consCount = $number;
                                    $java.jur_EOLSet__init_($term, $number);
                                    break a;
                                case -2147483550:
                                    $java.jur_Lexer_next(var$4);
                                    $term = $java.jur_WordBoundary__init_(1);
                                    break a;
                                case -2147483526:
                                    $java.jur_Lexer_next(var$4);
                                    $term = new $java.jur_EOISet;
                                    $java.jur_AbstractSet__init_($term);
                                    break a;
                                case -536870876:
                                    $java.jur_Lexer_next(var$4);
                                    $this.$consCount = $this.$consCount + 1 | 0;
                                    if ($java.jur_Pattern_hasFlag($this, 8)) {
                                        if ($java.jur_Pattern_hasFlag($this, 1)) {
                                            $term = $java.jur_UMultiLineEOLSet__init_($this.$consCount);
                                            break a;
                                        }
                                        $term = $java.jur_MultiLineEOLSet__init_($this.$consCount);
                                        break a;
                                    }
                                    if ($java.jur_Pattern_hasFlag($this, 1)) {
                                        $term = $java.jur_UEOLSet__init_($this.$consCount);
                                        break a;
                                    }
                                    $term = $java.jur_EOLSet__init_0($this.$consCount);
                                    break a;
                                case -536870866:
                                    $java.jur_Lexer_next(var$4);
                                    if ($java.jur_Pattern_hasFlag($this, 32)) {
                                        $term = $java.jur_DotAllSet__init_();
                                        break a;
                                    }
                                    $term = $java.jur_DotSet__init_($java.jur_AbstractLineTerminator_getInstance($this.$flags4));
                                    break a;
                                case -536870821:
                                    $java.jur_Lexer_next(var$4);
                                    $negative = 0;
                                    $term = $this.$lexemes;
                                    if ($term.$ch == (-536870818)) {
                                        $negative = 1;
                                        $java.jur_Lexer_next($term);
                                    }
                                    $term = $java.jur_Pattern_processRangeSet($this, $java.jur_Pattern_processRangeExpression($this, $negative));
                                    $term.$setNext($last);
                                    var$4 = $this.$lexemes;
                                    if (var$4.$ch != (-536870819))
                                        $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), var$4.$orig, var$4.$curToc));
                                    $java.jur_Lexer_setMode(var$4, 1);
                                    $java.jur_Lexer_next($this.$lexemes);
                                    break a;
                                case -536870818:
                                    $java.jur_Lexer_next(var$4);
                                    $this.$consCount = $this.$consCount + 1 | 0;
                                    if (!$java.jur_Pattern_hasFlag($this, 8)) {
                                        $term = new $java.jur_SOLSet;
                                        $java.jur_AbstractSet__init_($term);
                                        break a;
                                    }
                                    $term = new $java.jur_MultiLineSOLSet;
                                    var$4 = $java.jur_AbstractLineTerminator_getInstance($this.$flags4);
                                    $java.jur_AbstractSet__init_($term);
                                    $term.$lt1 = var$4;
                                    break a;
                                case 0:
                                    $cc = var$4.$curST;
                                    if ($cc !== null)
                                        $term = $java.jur_Pattern_processRangeSet($this, $cc);
                                    else {
                                        if ($java.jur_Lexer_isEmpty(var$4)) {
                                            $term = $java.jur_EmptySet__init_($last);
                                            break a;
                                        }
                                        $term = $java.jur_CharSet__init_($ch & 65535);
                                    }
                                    $java.jur_Lexer_next($this.$lexemes);
                                    break a;
                                default:
                                    break b;
                            }
                            $java.jur_Lexer_next(var$4);
                            $term = new $java.jur_SOLSet;
                            $java.jur_AbstractSet__init_($term);
                            break a;
                        }
                        $number = ($ch & 2147483647) - 48 | 0;
                        if ($this.$globalGroupIndex < $number)
                            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Lexer_toString(var$4), $java.jur_Lexer_getIndex($this.$lexemes)));
                        $java.jur_Lexer_next(var$4);
                        $this.$consCount = $this.$consCount + 1 | 0;
                        $term = !$java.jur_Pattern_hasFlag($this, 2) ? $java.jur_BackReferenceSet__init_($number, $this.$consCount) : $java.jur_Pattern_hasFlag($this, 64) ? $java.jur_UCIBackReferenceSet__init_($number, $this.$consCount) : $java.jur_CIBackReferenceSet__init_($number, $this.$consCount);
                        $this.$backRefs.data[$number].$isBackReferenced = 1;
                        $this.$needsBackRefReplacement = 1;
                        break a;
                    }
                    if ($ch >= 0 && !$java.jur_Lexer_isSpecial(var$4)) {
                        $term = $java.jur_Pattern_processCharSet($this, $ch);
                        $java.jur_Lexer_next($this.$lexemes);
                    } else if ($ch == (-536870788))
                        $term = $java.jur_EmptySet__init_($last);
                    else {
                        if ($ch != (-536870871)) {
                            $last = new $java.jur_PatternSyntaxException;
                            $term = !$java.jur_Lexer_isSpecial($this.$lexemes) ? jl_Character_toString0($ch & 65535) : $this.$lexemes.$curST.$toString();
                            var$4 = $this.$lexemes;
                            $java.jur_PatternSyntaxException__init_0($last, $term, var$4.$orig, var$4.$curToc);
                            $rt_throw($last);
                        }
                        if (var$3) {
                            $last = new $java.jur_PatternSyntaxException;
                            var$4 = $this.$lexemes;
                            $java.jur_PatternSyntaxException__init_0($last, $rt_s(3), var$4.$orig, var$4.$curToc);
                            $rt_throw($last);
                        }
                        $term = $java.jur_EmptySet__init_($last);
                    }
                }
            }
            if ($ch != (-16777176))
                break;
        }
        return $term;
    };
    $java.jur_Pattern_processRangeExpression = function($this, $alt) {
        var $res, $buffer, $intersection, $notClosed, $firstInClass, $cs, $cur, $negative, $$je;
        $res = $java.jur_CharClass__init_($java.jur_Pattern_hasFlag($this, 2), $java.jur_Pattern_hasFlag($this, 64));
        $java.jur_AbstractCharClass_setNegative($res, $alt);
        $buffer = (-1);
        $intersection = 0;
        $notClosed = 0;
        $firstInClass = 1;
        a: {
            b: {
                c: while (true) {
                    if ($java.jur_Lexer_isEmpty($this.$lexemes))
                        break a;
                    $cs = $this.$lexemes;
                    $alt = $cs.$ch;
                    $notClosed = $alt == (-536870819) && !$firstInClass ? 0 : 1;
                    if (!$notClosed)
                        break a;
                    d: {
                        switch ($alt) {
                            case -536870874:
                                if ($buffer >= 0)
                                    $java.jur_CharClass_add($res, $buffer);
                                $buffer = $java.jur_Lexer_next($this.$lexemes);
                                $cs = $this.$lexemes;
                                if ($cs.$ch != (-536870874)) {
                                    $buffer = 38;
                                    break d;
                                }
                                if ($cs.$lookAhead == (-536870821)) {
                                    $java.jur_Lexer_next($cs);
                                    $intersection = 1;
                                    $buffer = (-1);
                                    break d;
                                }
                                $java.jur_Lexer_next($cs);
                                if ($firstInClass) {
                                    $res = $java.jur_Pattern_processRangeExpression($this, 0);
                                    break d;
                                }
                                if ($this.$lexemes.$ch == (-536870819))
                                    break d;
                                $java.jur_CharClass_intersection($res, $java.jur_Pattern_processRangeExpression($this, 0));
                                break d;
                            case -536870867:
                                if (!$firstInClass) {
                                    $alt = $cs.$lookAhead;
                                    if ($alt != (-536870819) && $alt != (-536870821) && $buffer >= 0) {
                                        $java.jur_Lexer_next($cs);
                                        $cs = $this.$lexemes;
                                        $cur = $cs.$ch;
                                        if ($java.jur_Lexer_isSpecial($cs))
                                            break c;
                                        if ($cur < 0) {
                                            $negative = $this.$lexemes.$lookAhead;
                                            if ($negative != (-536870819) && $negative != (-536870821) && $buffer >= 0)
                                                break c;
                                        }
                                        e: {
                                            try {
                                                if ($java.jur_Lexer_isLetter0($cur))
                                                    break e;
                                                $cur = $cur & 65535;
                                                break e;
                                            } catch ($$e) {
                                                $$je = $rt_wrapException($$e);
                                                if ($$je instanceof jl_Exception) {
                                                    break b;
                                                } else {
                                                    throw $$e;
                                                }
                                            }
                                        }
                                        try {
                                            $java.jur_CharClass_add0($res, $buffer, $cur);
                                        } catch ($$e) {
                                            $$je = $rt_wrapException($$e);
                                            if ($$je instanceof jl_Exception) {
                                                break b;
                                            } else {
                                                throw $$e;
                                            }
                                        }
                                        $java.jur_Lexer_next($this.$lexemes);
                                        $buffer = (-1);
                                        break d;
                                    }
                                }
                                if ($buffer >= 0)
                                    $java.jur_CharClass_add($res, $buffer);
                                $buffer = 45;
                                $java.jur_Lexer_next($this.$lexemes);
                                break d;
                            case -536870821:
                                if ($buffer >= 0) {
                                    $java.jur_CharClass_add($res, $buffer);
                                    $buffer = (-1);
                                }
                                $java.jur_Lexer_next($this.$lexemes);
                                $negative = 0;
                                $cs = $this.$lexemes;
                                if ($cs.$ch == (-536870818)) {
                                    $java.jur_Lexer_next($cs);
                                    $negative = 1;
                                }
                                if (!$intersection)
                                    $java.jur_CharClass_union($res, $java.jur_Pattern_processRangeExpression($this, $negative));
                                else
                                    $java.jur_CharClass_intersection($res, $java.jur_Pattern_processRangeExpression($this, $negative));
                                $intersection = 0;
                                $java.jur_Lexer_next($this.$lexemes);
                                break d;
                            case -536870819:
                                if ($buffer >= 0)
                                    $java.jur_CharClass_add($res, $buffer);
                                $buffer = 93;
                                $java.jur_Lexer_next($this.$lexemes);
                                break d;
                            case -536870818:
                                if ($buffer >= 0)
                                    $java.jur_CharClass_add($res, $buffer);
                                $buffer = 94;
                                $java.jur_Lexer_next($this.$lexemes);
                                break d;
                            case 0:
                                if ($buffer >= 0)
                                    $java.jur_CharClass_add($res, $buffer);
                                $cs = $this.$lexemes.$curST;
                                if ($cs === null)
                                    $buffer = 0;
                                else {
                                    $java.jur_CharClass_add1($res, $cs);
                                    $buffer = (-1);
                                }
                                $java.jur_Lexer_next($this.$lexemes);
                                break d;
                            default:
                        }
                        if ($buffer >= 0)
                            $java.jur_CharClass_add($res, $buffer);
                        $buffer = $java.jur_Lexer_next($this.$lexemes);
                    }
                    $firstInClass = 0;
                }
                $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Pattern_pattern($this), $this.$lexemes.$curToc));
            }
            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Pattern_pattern($this), $this.$lexemes.$curToc));
        }
        if (!$notClosed) {
            if ($buffer >= 0)
                $java.jur_CharClass_add($res, $buffer);
            return $res;
        }
        $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Pattern_pattern($this), $this.$lexemes.$curToc - 1 | 0));
    };
    $java.jur_Pattern_processCharSet = function($this, $ch) {
        var $isSupplCodePoint, var$3, var$4;
        $isSupplCodePoint = jl_Character_isSupplementaryCodePoint($ch);
        if ($java.jur_Pattern_hasFlag($this, 2)) {
            a: {
                if (!($ch >= 97 && $ch <= 122)) {
                    if ($ch < 65)
                        break a;
                    if ($ch > 90)
                        break a;
                }
                return $java.jur_CICharSet__init_($ch & 65535);
            }
            if ($java.jur_Pattern_hasFlag($this, 64) && $ch > 128) {
                if ($isSupplCodePoint) {
                    var$3 = new $java.jur_UCISupplCharSet;
                    $java.jur_LeafSet__init_(var$3);
                    var$3.$charCount = 2;
                    var$3.$ch0 = jl_Character_toLowerCase0(jl_Character_toUpperCase($ch));
                    return var$3;
                }
                if ($java.jur_Lexer_isLowSurrogate0($ch))
                    return $java.jur_LowSurrogateCharSet__init_($ch & 65535);
                if (!$java.jur_Lexer_isHighSurrogate0($ch))
                    return $java.jur_UCICharSet__init_($ch & 65535);
                return $java.jur_HighSurrogateCharSet__init_($ch & 65535);
            }
        }
        if (!$isSupplCodePoint) {
            if ($java.jur_Lexer_isLowSurrogate0($ch))
                return $java.jur_LowSurrogateCharSet__init_($ch & 65535);
            if (!$java.jur_Lexer_isHighSurrogate0($ch))
                return $java.jur_CharSet__init_($ch & 65535);
            return $java.jur_HighSurrogateCharSet__init_($ch & 65535);
        }
        var$3 = new $java.jur_SupplCharSet;
        $java.jur_LeafSet__init_(var$3);
        var$3.$charCount = 2;
        var$3.$ch1 = $ch;
        var$4 = (jl_Character_toChars($ch)).data;
        var$3.$high = var$4[0];
        var$3.$low = var$4[1];
        return var$3;
    };
    $java.jur_Pattern_processRangeSet = function($this, $charClass) {
        var $surrogates, $lowHighSurrRangeSet, var$4;
        if (!$java.jur_AbstractCharClass_hasLowHighSurrogates($charClass)) {
            if (!$charClass.$mayContainSupplCodepoints) {
                if ($charClass.$hasUCI())
                    return $java.jur_UCIRangeSet__init_($charClass);
                return $java.jur_RangeSet__init_($charClass);
            }
            if (!$charClass.$hasUCI())
                return $java.jur_SupplRangeSet__init_($charClass);
            $surrogates = new $java.jur_UCISupplRangeSet;
            $java.jur_SupplRangeSet__init_0($surrogates, $charClass);
            return $surrogates;
        }
        $surrogates = $java.jur_AbstractCharClass_getSurrogates($charClass);
        $lowHighSurrRangeSet = new $java.jur_LowHighSurrogateRangeSet;
        $java.jur_AbstractSet__init_($lowHighSurrRangeSet);
        $lowHighSurrRangeSet.$surrChars = $surrogates;
        $lowHighSurrRangeSet.$alt = $surrogates.$alt0;
        if (!$charClass.$mayContainSupplCodepoints) {
            if ($charClass.$hasUCI())
                return $java.jur_CompositeRangeSet__init_($java.jur_UCIRangeSet__init_($java.jur_AbstractCharClass_getWithoutSurrogates($charClass)), $lowHighSurrRangeSet);
            return $java.jur_CompositeRangeSet__init_($java.jur_RangeSet__init_($java.jur_AbstractCharClass_getWithoutSurrogates($charClass)), $lowHighSurrRangeSet);
        }
        if (!$charClass.$hasUCI())
            return $java.jur_CompositeRangeSet__init_($java.jur_SupplRangeSet__init_($java.jur_AbstractCharClass_getWithoutSurrogates($charClass)), $lowHighSurrRangeSet);
        $surrogates = new $java.jur_CompositeRangeSet;
        var$4 = new $java.jur_UCISupplRangeSet;
        $java.jur_SupplRangeSet__init_0(var$4, $java.jur_AbstractCharClass_getWithoutSurrogates($charClass));
        $java.jur_CompositeRangeSet__init_0($surrogates, var$4, $lowHighSurrRangeSet);
        return $surrogates;
    };
    function jur_Pattern_compile($pattern) {
        var var$2, var$3, var$4, var$5;
        if ($pattern === null) {
            $pattern = new jl_NullPointerException;
            jl_Throwable__init_($pattern, $rt_s(2817));
            $rt_throw($pattern);
        }
        $java.jur_AbstractSet_counter = 1;
        var$2 = new jur_Pattern;
        var$2.$backRefs = $rt_createArray($java.jur_FSet, 10);
        var$2.$globalGroupIndex = (-1);
        var$2.$compCount = (-1);
        var$2.$consCount = (-1);
        var$3 = new $java.jur_Lexer;
        var$3.$mode0 = 1;
        var$3.$orig = $pattern;
        var$3.$pattern10 = $rt_createCharArray(jl_String_length($pattern) + 2 | 0);
        jl_System_arraycopy(jl_String_toCharArray($pattern), 0, var$3.$pattern10, 0, jl_String_length($pattern));
        var$4 = var$3.$pattern10.data;
        var$5 = var$4.length;
        var$4[var$5 - 1 | 0] = 0;
        var$4[var$5 - 2 | 0] = 0;
        var$3.$patternFullLength = var$5;
        var$3.$flags5 = 0;
        $java.jur_Lexer_movePointer(var$3);
        $java.jur_Lexer_movePointer(var$3);
        var$2.$lexemes = var$3;
        var$2.$flags4 = 0;
        var$2.$start5 = $java.jur_Pattern_processExpression(var$2, (-1), 0, null);
        if ($java.jur_Lexer_isEmpty(var$2.$lexemes)) {
            if (var$2.$needsBackRefReplacement)
                var$2.$start5.$processSecondPass();
            return var$2;
        }
        $pattern = new $java.jur_PatternSyntaxException;
        var$2 = var$2.$lexemes;
        $java.jur_PatternSyntaxException__init_0($pattern, $rt_s(3), var$2.$orig, var$2.$curToc);
        $rt_throw($pattern);
    }
    $java.jur_Pattern_getSupplement = function($ch) {
        if ($ch >= 97 && $ch <= 122)
            $ch = ($ch - 32 | 0) & 65535;
        else if ($ch >= 65 && $ch <= 90)
            $ch = ($ch + 32 | 0) & 65535;
        return $ch;
    };
    $java.jur_Pattern_hasFlag = function($this, $flag) {
        return ($this.$flags4 & $flag) != $flag ? 0 : 1;
    };
    var oncius_CypherTypeOrder$ = $rt_classWithoutFields(s_Enumeration);
    $java.oncius_CypherTypeOrder$_MODULE$ = null;
    $java.oncius_CypherTypeOrder$_NOTHING = null;
    $java.oncius_CypherTypeOrder$_NULL = null;
    $java.oncius_CypherTypeOrder$_BOOLEAN = null;
    $java.oncius_CypherTypeOrder$_STRING = null;
    $java.oncius_CypherTypeOrder$_INTEGER = null;
    $java.oncius_CypherTypeOrder$_FLOAT = null;
    $java.oncius_CypherTypeOrder$_DATE = null;
    $java.oncius_CypherTypeOrder$_LOCAL_TIME = null;
    $java.oncius_CypherTypeOrder$_ZONED_TIME = null;
    $java.oncius_CypherTypeOrder$_LOCAL_DATETIME = null;
    $java.oncius_CypherTypeOrder$_ZONED_DATETIME = null;
    $java.oncius_CypherTypeOrder$_DURATION = null;
    $java.oncius_CypherTypeOrder$_POINT0 = null;
    $java.oncius_CypherTypeOrder$_NODE = null;
    $java.oncius_CypherTypeOrder$_RELATIONSHIP = null;
    $java.oncius_CypherTypeOrder$_MAP = null;
    $java.oncius_CypherTypeOrder$_LIST = null;
    $java.oncius_CypherTypeOrder$_PATH = null;
    $java.oncius_CypherTypeOrder$_CLOSED_DYNAMIC_UNION0 = null;
    $java.oncius_CypherTypeOrder$_ANY = null;
    $java.oncius_CypherTypeOrder$_$callClinit = function() {
        $java.oncius_CypherTypeOrder$_$callClinit = $rt_eraseClinit(oncius_CypherTypeOrder$);
        $java.oncius_CypherTypeOrder$__clinit_();
    };
    $java.oncius_CypherTypeOrder$__clinit_ = function() {
        var var$1;
        var$1 = new oncius_CypherTypeOrder$;
        $java.oncius_CypherTypeOrder$_$callClinit();
        $java.s_Enumeration__init_(var$1);
        $java.oncius_CypherTypeOrder$_MODULE$ = var$1;
        $java.oncius_CypherTypeOrder$_NOTHING = $java.s_Enumeration_Value(var$1);
        $java.oncius_CypherTypeOrder$_NULL = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_BOOLEAN = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_STRING = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_INTEGER = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_FLOAT = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_DATE = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_LOCAL_TIME = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_ZONED_TIME = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_LOCAL_DATETIME = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_ZONED_DATETIME = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_DURATION = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_POINT0 = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_NODE = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_RELATIONSHIP = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_MAP = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_LIST = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_PATH = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_CLOSED_DYNAMIC_UNION0 = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
        $java.oncius_CypherTypeOrder$_ANY = $java.s_Enumeration_Value($java.oncius_CypherTypeOrder$_MODULE$);
    };
    $java.oncius_CypherTypeOrder$_POINT = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_POINT0;
    };
    $java.oncius_CypherTypeOrder$_CLOSED_DYNAMIC_UNION = function($this) {
        $java.oncius_CypherTypeOrder$_$callClinit();
        return $java.oncius_CypherTypeOrder$_CLOSED_DYNAMIC_UNION0;
    };
    var oncias_SemanticTable$typeFor$lambda$_18_0 = $rt_classWithoutFields();
    $java.oncias_SemanticTable$typeFor$lambda$_18_0_apply = function(var$0, var$1) {
        return oncias_ExpressionTypeInfo_actual(var$1);
    };
    function oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2() {
        sr_AbstractPartialFunction.call(this);
        this.$allSymbolDefinitions$1 = null;
    }
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2_applyOrElse = function($this, $x1, $default) {
        var $maybeVariable, $maybeProperties, $variable;
        if ($x1 instanceof oncie_NodePattern) {
            $x1 = $x1;
            $maybeVariable = $x1.$variable11;
            $maybeProperties = $x1.$properties4;
            $x1 = new $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_0;
            $x1.$_0491 = $this;
            $x1.$_1156 = $maybeVariable;
            $x1.$_259 = $maybeProperties;
            return $x1;
        }
        if (!($x1 instanceof oncie_RelationshipPattern)) {
            if (!($x1 instanceof oncie_NamedPatternPart))
                return s_PartialFunction$_fallback_fn;
            $variable = $x1.$variable10;
            $x1 = new $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_2;
            $x1.$_0492 = $variable;
            return $x1;
        }
        $x1 = $x1;
        $maybeVariable = $x1.$variable12;
        $maybeProperties = $x1.$properties5;
        $x1 = new $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_1;
        $x1.$_0493 = $this;
        $x1.$_1157 = $maybeVariable;
        $x1.$_260 = $maybeProperties;
        return $x1;
    };
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf($java.oncie_Expression_containsAggregate(var$1.$expression1()));
    };
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_1 = $rt_classWithoutFields();
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_1_apply = function(var$0, var$1) {
        return var$1.$expression1();
    };
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_2 = function() {
        jl_Object.call(this);
        this.$_0456 = null;
    };
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0456;
        var$3 = onciu_Foldable_folder$(var$1.$expression1());
        var$1 = new $java.oncie_Expression$TreeAcc;
        s_package$_$callClinit();
        $java.oncie_Expression$TreeAcc__init_(var$1, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), $java.oncie_Expression$TreeAcc$_apply$default$2($java.oncie_Expression$TreeAcc$_MODULE$));
        var$4 = new $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1;
        var$4.$aggregationGroupingExpressions$1 = var$2;
        return (onciu_Foldable$Folder_treeFold(var$3, var$1, var$4)).$data0;
    };
    var oncia_Order$ = $rt_classWithoutFields();
    $java.oncia_Order$_MODULE$ = null;
    function oncia_Order$__clinit_() {
        $java.oncia_Order$_MODULE$ = new oncia_Order$;
    }
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_3 = $rt_classWithoutFields();
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_3_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    var onciap_Prettifier$$extractTopology$lambda$_18_0 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$extractTopology$lambda$_18_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        a: {
            var$2 = sr_BoxesRunTime_unboxToInt(var$1);
            switch (var$2) {
                case 1:
                    break;
                default:
                    var$1 = new s_Some;
                    var$3 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$3);
                    jl_AbstractStringBuilder_append(var$3, 32);
                    jl_StringBuilder_append(jl_StringBuilder_append0(var$3, var$2), $rt_s(2818));
                    s_Some__init_0(var$1, jl_AbstractStringBuilder_toString(var$3));
                    break a;
            }
            var$1 = s_Some__init_($rt_s(2819));
        }
        return var$1;
    };
    var onciap_Prettifier$$extractTopology$lambda$_18_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$extractTopology$lambda$_18_1_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_Prettifier$$extractTopology$lambda$_18_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$extractTopology$lambda$_18_2_apply = function(var$0, var$1) {
        var var$2, var$3;
        a: {
            var$2 = sr_BoxesRunTime_unboxToInt(var$1);
            switch (var$2) {
                case 1:
                    break;
                default:
                    var$1 = new s_Some;
                    var$3 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$3);
                    jl_AbstractStringBuilder_append(var$3, 32);
                    jl_StringBuilder_append(jl_StringBuilder_append0(var$3, var$2), $rt_s(2820));
                    s_Some__init_0(var$1, jl_AbstractStringBuilder_toString(var$3));
                    break a;
            }
            var$1 = s_Some__init_($rt_s(2821));
        }
        return var$1;
    };
    var onciap_Prettifier$$extractTopology$lambda$_18_3 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$extractTopology$lambda$_18_3_apply = function(var$0) {
        return $rt_s(3);
    };
    $java.oncius_ListType$isSubtypeOf$lambda$_33_0 = function() {
        jl_Object.call(this);
        this.$_0394 = null;
    };
    $java.oncius_ListType$isSubtypeOf$lambda$_33_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0394.$innerTypes;
        var$3 = new $java.oncius_ListType$$anonfun$isSubtypeOf$1$lambda$_54_0;
        var$3.$_0494 = var$1;
        return jl_Boolean_valueOf(var$2.$exists(var$3));
    };
    $java.oncius_ListType$isSubtypeOf$lambda$_33_1 = function() {
        jl_Object.call(this);
        this.$_0393 = null;
    };
    $java.oncius_ListType$isSubtypeOf$lambda$_33_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncius_ListType_isSubtypeOf(var$0.$_0393, var$1));
    };
    $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0__init_ = function() {
        var var_0 = new $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0();
        $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0__init_0(var_0);
        return var_0;
    };
    $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0__init_0 = function(var$0) {};
    $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToChar(var$1) == 95 ? 0 : 1);
    };
    function oncil_LabelExpression$Negation() {
        var a = this; jl_Object.call(a);
        a.$e = null;
        a.$containsIs3 = 0;
        a.$position282 = null;
    }
    function oncil_LabelExpression$Negation__init_(var_0, var_1, var_2) {
        var var_3 = new oncil_LabelExpression$Negation();
        $java.oncil_LabelExpression$Negation__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncil_LabelExpression$Negation_containsGpmSpecificLabelExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$($this);
    };
    $java.oncil_LabelExpression$Negation_containsGpmSpecificRelTypeExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$($this);
    };
    $java.oncil_LabelExpression$Negation_replaceColonSyntax = function($this) {
        return $java.oncil_LabelExpression_replaceColonSyntax$($this);
    };
    $java.oncil_LabelExpression$Negation_foldedOver = function($this) {
        return $this;
    };
    $java.oncil_LabelExpression$Negation_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncil_LabelExpression$Negation_containsIs = function($this) {
        return $this.$containsIs3;
    };
    $java.oncil_LabelExpression$Negation_position = function($this) {
        return $this.$position282;
    };
    $java.oncil_LabelExpression$Negation_flatten = function($this) {
        var var$1;
        while (true) {
            var$1 = $this.$e;
            if (!(var$1 instanceof oncil_LabelExpression$Negation))
                break;
            $this = var$1;
        }
        return var$1.$flatten0();
    };
    $java.oncil_LabelExpression$Negation_productPrefix = function($this) {
        return $rt_s(2822);
    };
    $java.oncil_LabelExpression$Negation_productArity = function($this) {
        return 2;
    };
    $java.oncil_LabelExpression$Negation_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$e;
            case 1:
                return jl_Boolean_valueOf($this.$containsIs3);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpression$Negation_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Negation_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2822))), sr_Statics_anyHash($this.$e)), !$this.$containsIs3 ? 1237 : 1231), 2);
    };
    $java.oncil_LabelExpression$Negation_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Negation_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncil_LabelExpression$Negation) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsIs3 != $x$1.$containsIs3)
                        break b;
                    c: {
                        var$2 = $this.$e;
                        $x$1 = $x$1.$e;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncil_LabelExpression$Negation))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncil_LabelExpression$Negation_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncil_LabelExpression$Negation__init_ = function($this, $e, $containsIs, $position) {
        $this.$e = $e;
        $this.$containsIs3 = $containsIs;
        $this.$position282 = $position;
    };
    $java.jur_MatchResult = $rt_classWithoutFields(0);
    function jur_Matcher() {
        var a = this; jl_Object.call(a);
        a.$pat = null;
        a.$start6 = null;
        a.$string = null;
        a.$matchResult = null;
        a.$leftBound = 0;
        a.$rightBound = 0;
        a.$appendPos = 0;
        a.$replacement = null;
        a.$processedRepl = null;
        a.$replacementParts = null;
    }
    function jur_Matcher_processReplacement($this, $replacement) {
        var $res, $sb, $i, $repl, $index, $replacementPos, $nextBackSlashed, var$9, $group, $gr, $$je;
        $res = $this.$replacement;
        if ($res !== null && jl_String_equals($res, $replacement)) {
            if ($this.$replacementParts === null)
                return $this.$processedRepl;
            $sb = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($sb);
            $i = 0;
            while (true) {
                $replacement = $this.$replacementParts;
                if ($i >= $replacement.$size2)
                    break;
                jl_StringBuilder_append($sb, ju_ArrayList_get($replacement, $i));
                $i = $i + 1 | 0;
            }
            return jl_AbstractStringBuilder_toString($sb);
        }
        $this.$replacement = $replacement;
        $repl = jl_String_toCharArray($replacement);
        $res = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($res);
        $this.$replacementParts = null;
        $index = 0;
        $replacementPos = 0;
        $nextBackSlashed = 0;
        a: {
            b: while (true) {
                var$9 = $repl.data;
                $i = var$9.length;
                if ($index >= $i) {
                    $group = $this.$replacementParts;
                    if ($group !== null) {
                        $gr = $res.$length0;
                        if ($replacementPos != $gr)
                            ju_ArrayList_add($group, jl_StringBuilder_substring($res, $replacementPos, $gr));
                    }
                    return jl_AbstractStringBuilder_toString($res);
                }
                if (var$9[$index] == 92 && !$nextBackSlashed) {
                    $nextBackSlashed = 1;
                    $index = $index + 1 | 0;
                }
                c: {
                    if ($nextBackSlashed) {
                        if ($index >= $i)
                            break b;
                        jl_AbstractStringBuilder_append($res, var$9[$index]);
                        $nextBackSlashed = 0;
                    } else if (var$9[$index] != 36)
                        jl_AbstractStringBuilder_append($res, var$9[$index]);
                    else {
                        if ($this.$replacementParts === null)
                            $this.$replacementParts = ju_ArrayList__init_();
                        d: {
                            try {
                                $replacement = new jl_String;
                                $index = $index + 1 | 0;
                                jl_String__init_2($replacement, $repl, $index, 1);
                                $gr = jl_Integer_parseInt0($replacement);
                                if ($replacementPos == jl_StringBuilder_length($res))
                                    break d;
                                ju_ArrayList_add($this.$replacementParts, jl_StringBuilder_subSequence($res, $replacementPos, jl_StringBuilder_length($res)));
                                $replacementPos = jl_StringBuilder_length($res);
                                break d;
                            } catch ($$e) {
                                $$je = $rt_wrapException($$e);
                                if ($$je instanceof jl_Exception) {
                                    break a;
                                } else {
                                    throw $$e;
                                }
                            }
                        }
                        try {
                            ju_ArrayList_add($this.$replacementParts, $java.jur_Matcher$1__init_($this, $gr));
                            $group = $java.jur_Matcher_group($this, $gr);
                            $replacementPos = $replacementPos + jl_String_length($group) | 0;
                            jl_StringBuilder_append1($res, $group);
                            break c;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            if ($$je instanceof jl_Exception) {
                                break a;
                            } else {
                                throw $$e;
                            }
                        }
                    }
                }
                $index = $index + 1 | 0;
            }
            $replacement = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_0($replacement);
            $rt_throw($replacement);
        }
        $replacement = new jl_IllegalArgumentException;
        jl_Throwable__init_($replacement, $rt_s(3));
        $rt_throw($replacement);
    }
    $java.jur_Matcher_group = function($this, $group) {
        var var$2;
        var$2 = $this.$matchResult;
        return $java.jur_MatchResultImpl_start(var$2, $group) < 0 ? null : jl_String_substring0(var$2.$string4, $java.jur_MatchResultImpl_start(var$2, $group), $java.jur_MatchResultImpl_end(var$2, $group));
    };
    $java.jur_Matcher_find = function($this, $start) {
        var $stringLength, var$3;
        $stringLength = jl_String_length($this.$string);
        if ($start >= 0 && $start <= $stringLength) {
            $java.jur_MatchResultImpl_reset($this.$matchResult);
            var$3 = $this.$matchResult;
            var$3.$mode1 = 1;
            $java.jur_MatchResultImpl_setStartIndex(var$3, $start);
            $start = $this.$start6.$find1($start, $this.$string, $this.$matchResult);
            if ($start == (-1))
                $this.$matchResult.$hitEnd = 1;
            if ($start >= 0) {
                var$3 = $this.$matchResult;
                if (var$3.$valid) {
                    $java.jur_MatchResultImpl_finalizeMatch(var$3);
                    return 1;
                }
            }
            $this.$matchResult.$startIndex = (-1);
            return 0;
        }
        var$3 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_(var$3, jl_String_valueOf1($start));
        $rt_throw(var$3);
    };
    function jur_Matcher_find($this) {
        var $length, var$2, var$3;
        $length = jl_String_length($this.$string);
        var$2 = $this.$matchResult;
        if (!var$2.$transparentBounds)
            $length = $this.$rightBound;
        if (var$2.$startIndex >= 0 && var$2.$mode1 == 1) {
            var$2.$startIndex = $java.jur_MatchResultImpl_end0(var$2);
            if ($java.jur_MatchResultImpl_end0($this.$matchResult) == $java.jur_MatchResultImpl_start($this.$matchResult, 0)) {
                var$2 = $this.$matchResult;
                var$2.$startIndex = var$2.$startIndex + 1 | 0;
            }
            var$3 = $this.$matchResult.$startIndex;
            return var$3 <= $length && $java.jur_Matcher_find($this, var$3) ? 1 : 0;
        }
        return $java.jur_Matcher_find($this, $this.$leftBound);
    }
    function jur_Matcher_matches($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$leftBound;
        $java.jur_MatchResultImpl_reset($this.$matchResult);
        var$2 = $this.$matchResult;
        var$2.$mode1 = 2;
        $java.jur_MatchResultImpl_setStartIndex(var$2, var$1);
        var$2 = $this.$start6;
        var$3 = $this.$matchResult;
        if (var$2.$matches1(var$1, $this.$string, var$3) < 0)
            var$4 = 0;
        else {
            $java.jur_MatchResultImpl_finalizeMatch(var$3);
            var$4 = 1;
        }
        return var$4;
    }
    function jur_Matcher_start($this) {
        return $java.jur_MatchResultImpl_start($this.$matchResult, 0);
    }
    function jur_Matcher_end($this) {
        return $java.jur_MatchResultImpl_end($this.$matchResult, 0);
    }
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_0 = $rt_classWithoutFields();
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(!var$1.$isNullable() && !(var$1 instanceof oncius_NothingType) ? 0 : 1);
    };
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_1 = function() {
        jl_Object.call(this);
        this.$_0486 = null;
    };
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncia_CypherTypeName_cypherTypeSemanticCheck(var$0.$_0486, var$1);
    };
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_2 = $rt_classWithoutFields();
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_2_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isNullable() ? 0 : 1);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_0() {
        jl_Object.call(this);
        this.$_0495 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_0__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_0();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_0__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_0__init_ = function(var$0, var$1) {
        var$0.$_0495 = var$1;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0495, var$1);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_1() {
        var a = this; jl_Object.call(a);
        a.$_0496 = null;
        a.$_1158 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_1__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_1();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_1__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_1__init_ = function(var$0, var$1, var$2) {
        var$0.$_0496 = var$1;
        var$0.$_1158 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_inner(var$0.$_0496, var$0.$_1158, var$1);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_2() {
        jl_Object.call(this);
        this.$_0497 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_2__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_2();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_2__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_2__init_ = function(var$0, var$1) {
        var$0.$_0497 = var$1;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_2_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0497;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$3 = var$1.$_10;
        var$1 = var$1.$_20;
        var$3 = onciap_DefaultExpressionStringifier_apply0(var$2, var$3);
        var$2 = onciap_DefaultExpressionStringifier_stringify(var$2, var$1);
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, var$3), $rt_s(10)), var$2);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    var oncie_Parameter$ = $rt_classWithoutFields();
    var oncie_Parameter$_MODULE$ = null;
    function oncie_Parameter$__clinit_() {
        oncie_Parameter$_MODULE$ = new oncie_Parameter$;
    }
    function oncie_Parameter$_unapply($this, $p) {
        return s_Some__init_(s_Tuple3__init_($p.$name10, $p.$parameterType, $p.$sizeHint1));
    }
    function oncie_ContainerIndex() {
        var a = this; oncie_Expression.call(a);
        a.$expr4 = null;
        a.$idx0 = null;
        a.$position283 = null;
    }
    function oncie_ContainerIndex__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_ContainerIndex();
        $java.oncie_ContainerIndex__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    function oncie_ContainerIndex_expr($this) {
        return $this.$expr4;
    }
    function oncie_ContainerIndex_idx($this) {
        return $this.$idx0;
    }
    $java.oncie_ContainerIndex_position = function($this) {
        return $this.$position283;
    };
    $java.oncie_ContainerIndex_productPrefix = function($this) {
        return $rt_s(2823);
    };
    $java.oncie_ContainerIndex_productArity = function($this) {
        return 2;
    };
    $java.oncie_ContainerIndex_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$expr4;
            case 1:
                return $this.$idx0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ContainerIndex_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ContainerIndex_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ContainerIndex_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ContainerIndex_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ContainerIndex) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$expr4;
                        var$3 = $x$1.$expr4;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$idx0;
                        $x$1 = $x$1.$idx0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ContainerIndex))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ContainerIndex__init_ = function($this, $expr, $idx, $position) {
        $this.$expr4 = $expr;
        $this.$idx0 = $idx;
        $this.$position283 = $position;
        $java.oncie_Expression__init_($this);
    };
    function oncie_ListSlice() {
        var a = this; oncie_Expression.call(a);
        a.$list3 = null;
        a.$from14 = null;
        a.$to1 = null;
        a.$position284 = null;
    }
    function oncie_ListSlice__init_(var_0, var_1, var_2, var_3) {
        var var_4 = new oncie_ListSlice();
        $java.oncie_ListSlice__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    }
    function oncie_ListSlice_list($this) {
        return $this.$list3;
    }
    function oncie_ListSlice_from($this) {
        return $this.$from14;
    }
    function oncie_ListSlice_to($this) {
        return $this.$to1;
    }
    $java.oncie_ListSlice_position = function($this) {
        return $this.$position284;
    };
    $java.oncie_ListSlice_productPrefix = function($this) {
        return $rt_s(2824);
    };
    $java.oncie_ListSlice_productArity = function($this) {
        return 3;
    };
    $java.oncie_ListSlice_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$list3;
            case 1:
                return $this.$from14;
            case 2:
                return $this.$to1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_ListSlice_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListSlice_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListSlice_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_ListSlice_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_ListSlice) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$list3;
                        var$3 = $x$1.$list3;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$from14;
                        var$3 = $x$1.$from14;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$to1;
                        $x$1 = $x$1.$to1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_ListSlice))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_ListSlice__init_ = function($this, $list, $from, $to, $position) {
        $this.$list3 = $list;
        $this.$from14 = $from;
        $this.$to1 = $to;
        $this.$position284 = $position;
        $java.oncie_Expression__init_($this);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_3() {
        var a = this; jl_Object.call(a);
        a.$_0498 = null;
        a.$_1159 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_3__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_3();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_3__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_3__init_ = function(var$0, var$1, var$2) {
        var$0.$_0498 = var$1;
        var$0.$_1159 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_inner(var$0.$_0498, var$0.$_1159, var$1);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_4 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_4__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_4();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_4__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_4__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_4_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_5() {
        var a = this; jl_Object.call(a);
        a.$_0499 = null;
        a.$_1160 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_5__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_5();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_5__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_5__init_ = function(var$0, var$1, var$2) {
        var$0.$_0499 = var$1;
        var$0.$_1160 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_5_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_inner(var$0.$_0499, var$0.$_1160, var$1);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_6 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_6__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_6();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_6__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_6__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_6_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_7() {
        var a = this; jl_Object.call(a);
        a.$_0500 = null;
        a.$_1161 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_7__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_7();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_7__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_7__init_ = function(var$0, var$1, var$2) {
        var$0.$_0500 = var$1;
        var$0.$_1161 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_7_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$1 = onciap_DefaultExpressionStringifier_inner(var$0.$_0500, var$0.$_1161, var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2825)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_8 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_8__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_8();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_8__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_8__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_8_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_9() {
        var a = this; jl_Object.call(a);
        a.$_0501 = null;
        a.$_1162 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_9__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_9();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_9__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_9__init_ = function(var$0, var$1, var$2) {
        var$0.$_0501 = var$1;
        var$0.$_1162 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_9_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$1 = onciap_DefaultExpressionStringifier_inner(var$0.$_0501, var$0.$_1162, var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(155)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_10 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_10__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_10();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_10__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_10__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_10_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_11() {
        jl_Object.call(this);
        this.$_0502 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_11__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_11();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_11__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_11__init_ = function(var$0, var$1) {
        var$0.$_0502 = var$1;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_11_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0502, var$1);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_12 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_12__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_12();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_12__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_12__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_12_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$1), $rt_s(71));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_13 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_13__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_13();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_13__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_13__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_13_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_14() {
        var a = this; jl_Object.call(a);
        a.$_0503 = null;
        a.$_1163 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_14__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_14();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_14__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_14__init_ = function(var$0, var$1, var$2) {
        var$0.$_0503 = var$1;
        var$0.$_1163 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_14_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_inner(var$0.$_0503, var$0.$_1163, var$1);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_15 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_15__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_15();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_15__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_15__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_15_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2825)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_16 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_16__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_16();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_16__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_16__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_16_apply = function(var$0) {
        return $rt_s(3);
    };
    $java.oncie_LabelOrTypeCheckExpression = $rt_classWithoutFields(0);
    var oncie_HasLabelsOrTypes = $rt_classWithoutFields(oncie_Expression);
    $java.oncie_LabelCheckExpression = $rt_classWithoutFields(0);
    var oncie_HasLabels = $rt_classWithoutFields(oncie_Expression);
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_17() {
        jl_Object.call(this);
        this.$_0504 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_17__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_17();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_17__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_17__init_ = function(var$0, var$1) {
        var$0.$_0504 = var$1;
    };
    var oncie_HasTypes = $rt_classWithoutFields(oncie_Expression);
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_18() {
        jl_Object.call(this);
        this.$_0505 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_18__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_18();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_18__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_18__init_ = function(var$0, var$1) {
        var$0.$_0505 = var$1;
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_19() {
        jl_Object.call(this);
        this.$_0506 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_19__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_19();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_19__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_19__init_ = function(var$0, var$1) {
        var$0.$_0506 = var$1;
    };
    var oncie_DesugaredMapProjection = $rt_classWithoutFields(oncie_Expression);
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_20() {
        jl_Object.call(this);
        this.$_0507 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_20__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_20();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_20__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_20__init_ = function(var$0, var$1) {
        var$0.$_0507 = var$1;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_20_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0507, var$1);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_21() {
        jl_Object.call(this);
        this.$_0508 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_21__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_21();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_21__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_21__init_ = function(var$0, var$1) {
        var$0.$_0508 = var$1;
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_22() {
        var a = this; jl_Object.call(a);
        a.$_0509 = null;
        a.$_1164 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_22__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_22();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_22__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_22__init_ = function(var$0, var$1, var$2) {
        var$0.$_0509 = var$1;
        var$0.$_1164 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_22_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0509;
        var$3 = var$0.$_1164;
        return sci_List_map(sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_inner(var$2, var$3, var$1), sci_Nil$_MODULE$), new $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$23$lambda$_47_0);
    };
    var onciap_DefaultExpressionStringifier$stringify$lambda$_9_23 = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_23__init_() {
        var var_0 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_23();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_23__init_(var_0);
        return var_0;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_23__init_ = function(var$0) {};
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_23_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 === null ? 0 : 1);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_24() {
        var a = this; jl_Object.call(a);
        a.$_0510 = null;
        a.$_1165 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_24__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_24();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_24__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_24__init_ = function(var$0, var$1, var$2) {
        var$0.$_0510 = var$1;
        var$0.$_1165 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_24_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0510;
        var$3 = var$0.$_1165;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$4 = var$1.$_10;
        var$5 = var$1.$_20;
        return sci_List_map(sci_$colon$colon__init_($rt_s(2826), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_inner(var$2, var$3, var$4), sci_$colon$colon__init_($rt_s(2827), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_inner(var$2, var$3, var$5), sci_Nil$_MODULE$)))), new $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$26$lambda$_50_0);
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_25() {
        var a = this; jl_Object.call(a);
        a.$_0511 = null;
        a.$_1166 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_25__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_25();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_25__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_25__init_ = function(var$0, var$1, var$2) {
        var$0.$_0511 = var$1;
        var$0.$_1166 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_25_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0511;
        var$3 = var$0.$_1166;
        return sci_List_map(sci_$colon$colon__init_($rt_s(2828), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_inner(var$2, var$3, var$1), sci_Nil$_MODULE$)), new $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$28$lambda$_52_0);
    };
    var oncie_AndsReorderable = $rt_classWithoutFields(oncie_Expression);
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_26() {
        var a = this; jl_Object.call(a);
        a.$_0512 = null;
        a.$_1167 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_26__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_26();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_26__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_26__init_ = function(var$0, var$1, var$2) {
        var$0.$_0512 = var$1;
        var$0.$_1167 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_26_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0512;
        var$3 = var$0.$_1167;
        return sci_$colon$colon__init_(var$1.$canonicalOperatorSymbol(), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_inner(var$2, var$3, var$1.$rhs0()), sci_Nil$_MODULE$));
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_27() {
        var a = this; jl_Object.call(a);
        a.$_0513 = null;
        a.$_1168 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_27__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_27();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_27__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_27__init_ = function(var$0, var$1, var$2) {
        var$0.$_0513 = var$1;
        var$0.$_1168 = var$2;
    };
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_27_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_inner(var$0.$_0513, var$0.$_1168, var$1);
    };
    var oncie_AndedPropertyInequalities = $rt_classWithoutFields(oncie_Expression);
    var oncie_Ors = $rt_classWithoutFields(oncie_Expression);
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_28() {
        jl_Object.call(this);
        this.$_0514 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_28__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_28();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_28__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_28__init_ = function(var$0, var$1) {
        var$0.$_0514 = var$1;
    };
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_29() {
        var a = this; jl_Object.call(a);
        a.$_0515 = null;
        a.$_1169 = null;
    }
    function onciap_DefaultExpressionStringifier$stringify$lambda$_9_29__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$stringify$lambda$_9_29();
        $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_29__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_29__init_ = function(var$0, var$1, var$2) {
        var$0.$_0515 = var$1;
        var$0.$_1169 = var$2;
    };
    var oncie_PathExpression = $rt_classWithoutFields(oncie_Expression);
    function oncie_UnaryAdd() {
        var a = this; oncie_Expression.call(a);
        a.$rhs26 = null;
        a.$position285 = null;
        a.$signatures21 = null;
    }
    function oncie_UnaryAdd__init_(var_0, var_1) {
        var var_2 = new oncie_UnaryAdd();
        $java.oncie_UnaryAdd__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_UnaryAdd_asCanonicalStringVal = function($this) {
        return $java.oncie_LeftUnaryOperatorExpression_asCanonicalStringVal$($this);
    };
    function oncie_UnaryAdd_rhs($this) {
        return $this.$rhs26;
    }
    $java.oncie_UnaryAdd_position = function($this) {
        return $this.$position285;
    };
    $java.oncie_UnaryAdd_signatures = function($this) {
        return $this.$signatures21;
    };
    $java.oncie_UnaryAdd_canonicalOperatorSymbol = function($this) {
        return $rt_s(395);
    };
    $java.oncie_UnaryAdd_productPrefix = function($this) {
        return $rt_s(2829);
    };
    $java.oncie_UnaryAdd_productArity = function($this) {
        return 1;
    };
    $java.oncie_UnaryAdd_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$rhs26;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_UnaryAdd_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnaryAdd_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnaryAdd_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnaryAdd_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_UnaryAdd) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$rhs26;
                        $x$1 = $x$1.$rhs26;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_UnaryAdd))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_UnaryAdd__init_ = function($this, $rhs, $position) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$rhs26 = $rhs;
        $this.$position285 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$3 = s_package$_Vector0(s_package$_MODULE$);
        $rhs = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray($java.oncie_ExpressionTypeSignature, 2);
        var$5 = var$4.data;
        var$6 = $java.oncie_TypeSignature$_MODULE$;
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_IntegerType, 1);
        var$9 = var$8.data;
        oncius_package$_$callClinit();
        var$9[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$5[0] = $java.oncie_TypeSignature$_apply(var$6, var$7.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$8)), oncius_package$_CTInteger(oncius_package$_MODULE$));
        $position = $java.oncie_TypeSignature$_MODULE$;
        var$10 = s_package$_Vector0(s_package$_MODULE$);
        var$6 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_FloatType, 1);
        var$8.data[0] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$5[1] = $java.oncie_TypeSignature$_apply($position, var$10.$from0(sr_ScalaRunTime$_wrapRefArray(var$6, var$8)), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        $this.$signatures21 = var$3.$from0(sr_ScalaRunTime$_wrapRefArray($rhs, var$4));
    };
    function oncie_UnarySubtract() {
        var a = this; oncie_Expression.call(a);
        a.$rhs20 = null;
        a.$position242 = null;
        a.$signatures22 = null;
    }
    function oncie_UnarySubtract__init_(var_0, var_1) {
        var var_2 = new oncie_UnarySubtract();
        $java.oncie_UnarySubtract__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_UnarySubtract_asCanonicalStringVal = function($this) {
        return $java.oncie_LeftUnaryOperatorExpression_asCanonicalStringVal$($this);
    };
    function oncie_UnarySubtract_rhs($this) {
        return $this.$rhs20;
    }
    $java.oncie_UnarySubtract_position = function($this) {
        return $this.$position242;
    };
    $java.oncie_UnarySubtract_signatures = function($this) {
        return $this.$signatures22;
    };
    $java.oncie_UnarySubtract_canonicalOperatorSymbol = function($this) {
        return $rt_s(992);
    };
    $java.oncie_UnarySubtract_productPrefix = function($this) {
        return $rt_s(2830);
    };
    $java.oncie_UnarySubtract_productArity = function($this) {
        return 1;
    };
    $java.oncie_UnarySubtract_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$rhs20;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_UnarySubtract_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnarySubtract_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnarySubtract_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_UnarySubtract_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_UnarySubtract) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$rhs20;
                        $x$1 = $x$1.$rhs20;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_UnarySubtract))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_UnarySubtract__init_ = function($this, $rhs, $position) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$rhs20 = $rhs;
        $this.$position242 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$3 = s_package$_Vector0(s_package$_MODULE$);
        $rhs = sr_ScalaRunTime$_MODULE$;
        var$4 = $rt_createArray($java.oncie_ExpressionTypeSignature, 2);
        var$5 = var$4.data;
        var$6 = $java.oncie_TypeSignature$_MODULE$;
        var$7 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_IntegerType, 1);
        var$9 = var$8.data;
        oncius_package$_$callClinit();
        var$9[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$5[0] = $java.oncie_TypeSignature$_apply(var$6, var$7.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$8)), oncius_package$_CTInteger(oncius_package$_MODULE$));
        $position = $java.oncie_TypeSignature$_MODULE$;
        var$10 = s_package$_Vector0(s_package$_MODULE$);
        var$6 = sr_ScalaRunTime$_MODULE$;
        var$8 = $rt_createArray(oncius_FloatType, 1);
        var$8.data[0] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$5[1] = $java.oncie_TypeSignature$_apply($position, var$10.$from0(sr_ScalaRunTime$_wrapRefArray(var$6, var$8)), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        $this.$signatures22 = var$3.$from0(sr_ScalaRunTime$_wrapRefArray($rhs, var$4));
    };
    var oncie_CoerceTo = $rt_classWithoutFields(oncie_Expression);
    $java.oncias_SemanticCheckableExpression = $rt_classWithoutFields(0);
    var oncilp_CoerceToPredicate = $rt_classWithoutFields(oncie_Expression);
    var oncie_AssertIsNode = $rt_classWithoutFields(oncie_Expression);
    var oncie_ElementIdToLongId = $rt_classWithoutFields(oncie_Expression);
    $java.oncie_RelationshipUniquenessPredicate = $rt_classWithoutFields(0);
    var oncie_NoneOfRelationships = $rt_classWithoutFields(oncie_Expression);
    $java.oncie_EntityType = $rt_classWithoutFields(0);
    var oncie_NODE_TYPE$ = $rt_classWithoutFields();
    var oncie_NODE_TYPE$_MODULE$ = null;
    function oncie_NODE_TYPE$__clinit_() {
        oncie_NODE_TYPE$_MODULE$ = new oncie_NODE_TYPE$;
    }
    $java.oncie_NODE_TYPE$_productArity = function($this) {
        return 0;
    };
    $java.oncie_NODE_TYPE$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_NODE_TYPE$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_NODE_TYPE$_hashCode = function($this) {
        return (-1012987049);
    };
    $java.oncie_NODE_TYPE$_toString = function($this) {
        return $rt_s(2831);
    };
    $java.oncie_ElementIdToLongId$Mode = $rt_classWithoutFields(0);
    var oncie_ElementIdToLongId$Mode$Single$ = $rt_classWithoutFields();
    var oncie_ElementIdToLongId$Mode$Single$_MODULE$ = null;
    function oncie_ElementIdToLongId$Mode$Single$__clinit_() {
        oncie_ElementIdToLongId$Mode$Single$_MODULE$ = new oncie_ElementIdToLongId$Mode$Single$;
    }
    var oncie_ElementIdToLongId$Mode$Many$ = $rt_classWithoutFields();
    var oncie_ElementIdToLongId$Mode$Many$_MODULE$ = null;
    function oncie_ElementIdToLongId$Mode$Many$__clinit_() {
        oncie_ElementIdToLongId$Mode$Many$_MODULE$ = new oncie_ElementIdToLongId$Mode$Many$;
    }
    var oncie_RELATIONSHIP_TYPE$ = $rt_classWithoutFields();
    var oncie_RELATIONSHIP_TYPE$_MODULE$ = null;
    function oncie_RELATIONSHIP_TYPE$__clinit_() {
        oncie_RELATIONSHIP_TYPE$_MODULE$ = new oncie_RELATIONSHIP_TYPE$;
    }
    $java.oncie_RELATIONSHIP_TYPE$_productArity = function($this) {
        return 0;
    };
    $java.oncie_RELATIONSHIP_TYPE$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_RELATIONSHIP_TYPE$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_RELATIONSHIP_TYPE$_hashCode = function($this) {
        return 1809384673;
    };
    $java.oncie_RELATIONSHIP_TYPE$_toString = function($this) {
        return $rt_s(2832);
    };
    var oncie_DifferentRelationships = $rt_classWithoutFields(oncie_Expression);
    var oncie_Disjoint = $rt_classWithoutFields(oncie_Expression);
    var oncie_Unique = $rt_classWithoutFields(oncie_Expression);
    $java.oncie_VarLengthBound = $rt_classWithoutFields(oncie_Expression);
    var oncie_VarLengthLowerBound = $rt_classWithoutFields($java.oncie_VarLengthBound);
    var oncie_VarLengthUpperBound = $rt_classWithoutFields($java.oncie_VarLengthBound);
    var oncie_IsRepeatTrailUnique = $rt_classWithoutFields(oncie_Expression);
    function sum_Regex() {
        var a = this; jl_Object.call(a);
        a.$pattern4 = null;
        a.$scala$util$matching$Regex$$groupNames = null;
    }
    $java.sum_Regex_unapplySeq = function($this, $s) {
        var $m, var$3, var$4, $tabulate_b, $tabulate_i;
        $m = jur_Pattern_matcher($this.$pattern4, $s);
        if (!jur_Matcher_matches($m))
            return s_None$_MODULE$;
        var$3 = new s_Some;
        s_package$_$callClinit();
        $s = s_package$_List0(s_package$_MODULE$);
        var$4 = $m.$matchResult.$groupCount - 1 | 0;
        if ($s === null)
            $rt_throw(null);
        $tabulate_b = scm_ListBuffer__init_();
        $tabulate_i = 0;
        while ($tabulate_i < var$4) {
            $tabulate_i = $tabulate_i + 1 | 0;
            scm_ListBuffer_addOne($tabulate_b, $java.jur_Matcher_group($m, $tabulate_i));
        }
        s_Some__init_0(var$3, scm_ListBuffer_toList($tabulate_b));
        return var$3;
    };
    $java.oncia_SchemaCommand$checkOptionsMap$lambda$_12_0 = $rt_classWithoutFields();
    function oncil_LabelExpression$Leaf() {
        var a = this; jl_Object.call(a);
        a.$name8 = null;
        a.$containsIs4 = 0;
        a.$position286 = null;
    }
    function oncil_LabelExpression$Leaf__init_(var_0, var_1) {
        var var_2 = new oncil_LabelExpression$Leaf();
        $java.oncil_LabelExpression$Leaf__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncil_LabelExpression$Leaf_containsGpmSpecificLabelExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$($this);
    };
    $java.oncil_LabelExpression$Leaf_containsGpmSpecificRelTypeExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$($this);
    };
    $java.oncil_LabelExpression$Leaf_replaceColonSyntax = function($this) {
        return $java.oncil_LabelExpression_replaceColonSyntax$($this);
    };
    $java.oncil_LabelExpression$Leaf_foldedOver = function($this) {
        return $this;
    };
    $java.oncil_LabelExpression$Leaf_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncil_LabelExpression$Leaf_containsIs = function($this) {
        return $this.$containsIs4;
    };
    $java.oncil_LabelExpression$Leaf_position = function($this) {
        return $this.$position286;
    };
    $java.oncil_LabelExpression$Leaf_flatten = function($this) {
        return sci_$colon$colon__init_($this.$name8, sci_Nil$_MODULE$);
    };
    $java.oncil_LabelExpression$Leaf_productPrefix = function($this) {
        return $rt_s(1564);
    };
    $java.oncil_LabelExpression$Leaf_productArity = function($this) {
        return 2;
    };
    $java.oncil_LabelExpression$Leaf_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name8;
            case 1:
                return jl_Boolean_valueOf($this.$containsIs4);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpression$Leaf_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Leaf_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(1564))), sr_Statics_anyHash($this.$name8)), !$this.$containsIs4 ? 1237 : 1231), 2);
    };
    $java.oncil_LabelExpression$Leaf_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Leaf_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncil_LabelExpression$Leaf) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsIs4 != $x$1.$containsIs4)
                        break b;
                    c: {
                        var$2 = $this.$name8;
                        $x$1 = $x$1.$name8;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncil_LabelExpression$Leaf))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncil_LabelExpression$Leaf_dup = function($this, $children) {
        var var$2, var$3;
        a: {
            if ($children !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $children);
                if (!$children.$lengthCompare(3)) {
                    var$2 = $children.$apply1(0);
                    var$3 = $children.$apply1(1);
                    if ($children.$apply1(2) instanceof onciu_InputPosition) {
                        $children = onciu_ASTNode_dup$($this, sci_$colon$colon__init_(var$2, sci_$colon$colon__init_(var$3, sci_Nil$_MODULE$)));
                        break a;
                    }
                }
            }
            $children = onciu_ASTNode_dup$($this, $children);
        }
        return $children;
    };
    $java.oncil_LabelExpression$Leaf__init_ = function($this, $name, $containsIs) {
        $this.$name8 = $name;
        $this.$containsIs4 = $containsIs;
        $this.$position286 = $name.$position2();
    };
    function oncil_LabelExpression$Wildcard() {
        var a = this; jl_Object.call(a);
        a.$containsIs5 = 0;
        a.$position287 = null;
    }
    function oncil_LabelExpression$Wildcard__init_(var_0, var_1) {
        var var_2 = new oncil_LabelExpression$Wildcard();
        $java.oncil_LabelExpression$Wildcard__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncil_LabelExpression$Wildcard_containsGpmSpecificLabelExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificLabelExpression$($this);
    };
    $java.oncil_LabelExpression$Wildcard_containsGpmSpecificRelTypeExpression = function($this) {
        return $java.oncil_LabelExpression_containsGpmSpecificRelTypeExpression$($this);
    };
    $java.oncil_LabelExpression$Wildcard_replaceColonSyntax = function($this) {
        return $java.oncil_LabelExpression_replaceColonSyntax$($this);
    };
    $java.oncil_LabelExpression$Wildcard_foldedOver = function($this) {
        return $this;
    };
    $java.oncil_LabelExpression$Wildcard_folder = function($this) {
        return onciu_Foldable_folder$($this);
    };
    $java.oncil_LabelExpression$Wildcard_containsIs = function($this) {
        return $this.$containsIs5;
    };
    $java.oncil_LabelExpression$Wildcard_position = function($this) {
        return $this.$position287;
    };
    $java.oncil_LabelExpression$Wildcard_flatten = function($this) {
        s_package$_$callClinit();
        return sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
    };
    $java.oncil_LabelExpression$Wildcard_productPrefix = function($this) {
        return $rt_s(2833);
    };
    $java.oncil_LabelExpression$Wildcard_productArity = function($this) {
        return 1;
    };
    $java.oncil_LabelExpression$Wildcard_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Boolean_valueOf($this.$containsIs5);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_LabelExpression$Wildcard_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Wildcard_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2833))), !$this.$containsIs5 ? 1237 : 1231), 1);
    };
    $java.oncil_LabelExpression$Wildcard_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_LabelExpression$Wildcard_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncil_LabelExpression$Wildcard) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$containsIs5 != $x$1.$containsIs5)
                        break b;
                    if (!($this instanceof oncil_LabelExpression$Wildcard))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.oncil_LabelExpression$Wildcard_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncil_LabelExpression$Wildcard__init_ = function($this, $containsIs, $position) {
        $this.$containsIs5 = $containsIs;
        $this.$position287 = $position;
    };
    $java.sc_BufferedIterator = $rt_classWithoutFields(0);
    function sc_Iterator$$anon$1() {
        var a = this; sc_AbstractIterator.call(a);
        a.$hd = null;
        a.$hdDefined1 = 0;
        a.$$outer23 = null;
    }
    function sc_Iterator$$anon$1_hasNext($this) {
        if (!$this.$hdDefined1 && !$java.scc_JavaCollectionWrappers$JIteratorWrapper_hasNext($this.$$outer23))
            return 0;
        return 1;
    }
    function sc_Iterator$$anon$1_next($this) {
        if (!$this.$hdDefined1)
            return $java.scc_JavaCollectionWrappers$JIteratorWrapper_next($this.$$outer23);
        $this.$hdDefined1 = 0;
        return $this.$hd;
    }
    $java.oncirr_expandShowWhere$$$anonfun$addDefaultColumns$3$lambda$_21_0 = function() {
        jl_Object.call(this);
        this.$_0358 = null;
    };
    $java.oncirr_expandShowWhere$$$anonfun$addDefaultColumns$3$lambda$_21_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0358;
        oncirr_expandShowWhere$_$callClinit();
        return var$1;
    };
    $java.oncia_SchemaCommand$checkSingleProperty$lambda$_14_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0410 = null;
        a.$_1122 = null;
        a.$_246 = null;
    };
    $java.oncia_SchemaCommand$checkSingleProperty$lambda$_14_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0410;
        var$2 = var$0.$_1122;
        var$3 = var$0.$_246;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(2834)), var$2), $rt_s(2835));
        return oncias_SemanticAnalysisTooling_error$(var$1, jl_AbstractStringBuilder_toString(var$4), (sc_LinearSeqOps_apply$(var$3, 1)).$position31);
    };
    $java.oncias_Scope$$anonfun$dumpTree$1$lambda$_48_0 = $rt_classWithoutFields();
    $java.oncias_Scope$$anonfun$dumpTree$1$lambda$_48_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = s_Tuple2__1$mcI$sp(var$1);
        var$3 = var$1.$_20;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        var$4 = jl_StringBuilder_append0(var$1, var$2);
        jl_AbstractStringBuilder_append(var$4, 40);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$4, var$3), 41);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    var oncia_AmbiguousAggregation$ = $rt_classWithoutFields();
    $java.oncia_AmbiguousAggregation$_MODULE$ = null;
    function oncia_AmbiguousAggregation$__clinit_() {
        $java.oncia_AmbiguousAggregation$_MODULE$ = new oncia_AmbiguousAggregation$;
    }
    function jur_AbstractSet() {
        var a = this; jl_Object.call(a);
        a.$next12 = null;
        a.$isSecondPassVisited = 0;
        a.$index7 = null;
        a.$type0 = 0;
    }
    $java.jur_AbstractSet_counter = 0;
    $java.jur_AbstractSet__init_ = function($this) {
        var var$1, var$2;
        var$1 = new jl_Integer;
        var$2 = $java.jur_AbstractSet_counter;
        $java.jur_AbstractSet_counter = var$2 + 1 | 0;
        jl_Integer__init_0(var$1, var$2);
        $this.$index7 = jl_Integer_toString1(var$1);
    };
    $java.jur_AbstractSet__init_0 = function($this, $n) {
        var var$2, var$3;
        var$2 = new jl_Integer;
        var$3 = $java.jur_AbstractSet_counter;
        $java.jur_AbstractSet_counter = var$3 + 1 | 0;
        jl_Integer__init_0(var$2, var$3);
        $this.$index7 = jl_Integer_toString1(var$2);
        $this.$next12 = $n;
    };
    $java.jur_AbstractSet_find = function($this, $stringIndex, $testString, $matchResult) {
        var $length;
        $length = $matchResult.$rightBound0;
        while (true) {
            if ($stringIndex > $length)
                return (-1);
            if ($this.$matches1($stringIndex, $testString, $matchResult) >= 0)
                break;
            $stringIndex = $stringIndex + 1 | 0;
        }
        return $stringIndex;
    };
    $java.jur_AbstractSet_findBack = function($this, $stringIndex, $startSearch, $testString, $matchResult) {
        while (true) {
            if ($startSearch < $stringIndex)
                return (-1);
            if ($this.$matches1($startSearch, $testString, $matchResult) >= 0)
                break;
            $startSearch = $startSearch + (-1) | 0;
        }
        return $startSearch;
    };
    $java.jur_AbstractSet_setType = function($this, $type) {
        $this.$type0 = $type;
    };
    $java.jur_AbstractSet_getType = function($this) {
        return $this.$type0;
    };
    $java.jur_AbstractSet_getQualifiedName = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$index7;
        var$2 = $this.$getName();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_AbstractStringBuilder_append(var$3, 60);
        var$1 = jl_StringBuilder_append(var$3, var$1);
        jl_AbstractStringBuilder_append(var$1, 58);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$1, var$2), 62);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_AbstractSet_toString = function($this) {
        return $java.jur_AbstractSet_getQualifiedName($this);
    };
    $java.jur_AbstractSet_getNext = function($this) {
        return $this.$next12;
    };
    $java.jur_AbstractSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_AbstractSet_first = function($this, $set) {
        return 1;
    };
    $java.jur_AbstractSet_processBackRefReplacement = function($this) {
        return null;
    };
    $java.jur_AbstractSet_processSecondPass = function($this) {
        var $set;
        $this.$isSecondPassVisited = 1;
        $set = $this.$next12;
        if ($set !== null) {
            if (!$set.$isSecondPassVisited) {
                $set = $set.$processBackRefReplacement();
                if ($set !== null) {
                    $this.$next12.$isSecondPassVisited = 1;
                    $this.$next12 = $set;
                }
                $this.$next12.$processSecondPass();
            } else if ($set instanceof $java.jur_SingleSet && $set.$fSet.$isBackReferenced)
                $this.$next12 = $set.$next12;
        }
    };
    function jur_AbstractSet__clinit_() {
        $java.jur_AbstractSet_counter = 1;
    }
    function sc_StrictOptimizedSeqOps$intersect$lambda$_15_0() {
        var a = this; jl_Object.call(a);
        a.$_017 = null;
        a.$_14 = null;
    }
    $java.sc_StrictOptimizedSeqOps$intersect$lambda$_15_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_017;
        var$3 = var$0.$_14;
        var$4 = new $java.sc_StrictOptimizedSeqOps$$anonfun$intersect$1$lambda$_19_0;
        var$4.$_0516 = var$3;
        var$4.$_1170 = var$1;
        return scm_HashMap_updateWith(var$2, var$1, var$4);
    };
    var sc_SeqOps$distinct$lambda$_30_0 = $rt_classWithoutFields();
    function sc_SeqOps$distinct$lambda$_30_0_apply(var$0, var$1) {
        s_Predef$_$callClinit();
        return var$1;
    }
    var onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_0 = $rt_classWithoutFields();
    $java.onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_0_apply = function(var$0, var$1) {
        return var$1;
    };
    function onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_1() {
        var a = this; jl_Object.call(a);
        a.$_050 = null;
        a.$_114 = null;
    }
    $java.onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_050;
        var$3 = var$0.$_114;
        return sci_List_map(sci_$colon$colon__init_($rt_s(2836), sci_$colon$colon__init_(onciap_DefaultExpressionStringifier_inner(var$2, var$3, var$1), sci_Nil$_MODULE$)), new $java.onciap_DefaultExpressionStringifier$$anonfun$prettyScope$2$lambda$_63_0);
    };
    var onciap_DefaultExpressionStringifier$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.onciap_DefaultExpressionStringifier$$anonfun$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        if (!$rt_isInstance($x, $java.oncie_ChainableBinaryOperatorExpression))
            $x = sc_StrictOptimizedIterableOps$collect$lambda$_19_0_apply($default, $x);
        return $x;
    };
    $java.oncius_CypherType$isSubtypeOf$lambda$_19_0 = function() {
        jl_Object.call(this);
        this.$_0391 = null;
    };
    $java.oncius_CypherType$isSubtypeOf$lambda$_19_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$0.$_0391.$innerTypes.$contains0(var$1));
    };
    $java.oncias_package$$$anonfun$liftSemanticEitherFunc$1$lambda$_14_0 = function() {
        jl_Object.call(this);
        this.$_0225 = null;
    };
    $java.oncias_package$$$anonfun$liftSemanticEitherFunc$1$lambda$_14_1 = $rt_classWithoutFields();
    var oncius_TypeSpec$ = $rt_classWithoutFields();
    var oncius_TypeSpec$_MODULE$ = null;
    $java.oncius_TypeSpec$_all0 = null;
    $java.oncius_TypeSpec$_none = null;
    $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$simpleTypes = null;
    function oncius_TypeSpec$_$callClinit() {
        oncius_TypeSpec$_$callClinit = $rt_eraseClinit(oncius_TypeSpec$);
        $java.oncius_TypeSpec$__clinit_();
    }
    $java.oncius_TypeSpec$__clinit_ = function() {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = new oncius_TypeSpec$;
        oncius_TypeSpec$_$callClinit();
        oncius_TypeSpec$_MODULE$ = var$1;
        var$2 = new $java.oncius_TypeRange;
        oncius_package$_$callClinit();
        $java.oncius_TypeRange__init_(var$2, oncius_package$_CTAny(oncius_package$_MODULE$), s_None$_MODULE$);
        var$1 = new oncius_TypeSpec;
        s_package$_$callClinit();
        var$3 = s_package$_Vector0(s_package$_MODULE$);
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncius_TypeRange, 1);
        var$5.data[0] = var$2;
        $java.oncius_TypeSpec__init_(var$1, var$3.$from0(sr_ScalaRunTime$_wrapRefArray(var$4, var$5)));
        $java.oncius_TypeSpec$_all0 = var$1;
        $java.oncius_TypeSpec$_none = $java.oncius_TypeSpec__init_0(sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$)));
        $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$simpleTypes = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTAny(oncius_package$_MODULE$), oncius_package$_CTBoolean(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$), oncius_package$_CTMap(oncius_package$_MODULE$), oncius_package$_CTNode(oncius_package$_MODULE$),
        $java.oncius_package$_CTNumber(oncius_package$_MODULE$), $java.oncius_package$_CTPath0(oncius_package$_MODULE$), oncius_package$_CTRelationship(oncius_package$_MODULE$), $java.oncius_package$_CTPoint0(oncius_package$_MODULE$), $java.oncius_package$_CTGeometry, oncius_package$_CTString(oncius_package$_MODULE$), $java.oncius_package$_CTGraphRef, $java.oncius_package$_CTDuration0(oncius_package$_MODULE$), $java.oncius_package$_CTDate0(oncius_package$_MODULE$), $java.oncius_package$_CTTime0(oncius_package$_MODULE$),
        $java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$), $java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$), $java.oncius_package$_CTDateTime0(oncius_package$_MODULE$)])));
    };
    $java.oncius_TypeSpec$_exact = function($this, $iterableOnce) {
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply($this, ($iterableOnce.$iterator0()).$map7(new $java.oncius_TypeSpec$$exact$lambda$_4_0));
    };
    $java.oncius_TypeSpec$_all = function($this) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_all0;
    };
    function oncius_TypeSpec$_none($this) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_none;
    }
    $java.oncius_TypeSpec$_union = function($this, $typeSpecs) {
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply($this, $typeSpecs.$flatMap(new $java.oncius_TypeSpec$$union$lambda$_7_0));
    };
    $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$simpleTypes0 = function($this) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$simpleTypes;
    };
    $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply = function($this, $ranges) {
        var var$2, var$3;
        var$2 = new oncius_TypeSpec;
        var$3 = $ranges.$iterator0();
        s_package$_$callClinit();
        $java.oncius_TypeSpec__init_(var$2, var$3.$foldLeft(sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$)), new $java.oncius_TypeSpec$$minimalRanges$lambda$_12_0));
        return var$2;
    };
    $java.jur_FSet = function() {
        var a = this; jur_AbstractSet.call(a);
        a.$isBackReferenced = 0;
        a.$groupIndex = 0;
    };
    $java.jur_FSet_posFSet = null;
    $java.jur_FSet_$callClinit = function() {
        $java.jur_FSet_$callClinit = $rt_eraseClinit($java.jur_FSet);
        $java.jur_FSet__clinit_();
    };
    $java.jur_FSet__init_0 = function(var_0) {
        var var_1 = new $java.jur_FSet();
        $java.jur_FSet__init_(var_1, var_0);
        return var_1;
    };
    $java.jur_FSet__init_ = function($this, $groupIndex) {
        $java.jur_FSet_$callClinit();
        $java.jur_AbstractSet__init_($this);
        $this.$groupIndex = $groupIndex;
    };
    $java.jur_FSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $end, $shift;
        $end = $java.jur_MatchResultImpl_getEnd($matchResult, $this.$groupIndex);
        $java.jur_MatchResultImpl_setEnd($matchResult, $this.$groupIndex, $stringIndex);
        $shift = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        if ($shift < 0)
            $java.jur_MatchResultImpl_setEnd($matchResult, $this.$groupIndex, $end);
        return $shift;
    };
    $java.jur_FSet_getGroupIndex = function($this) {
        return $this.$groupIndex;
    };
    $java.jur_FSet_getName = function($this) {
        return $rt_s(2837);
    };
    $java.jur_FSet_hasConsumed = function($this, $mr) {
        return 0;
    };
    $java.jur_FSet__clinit_ = function() {
        var var$1;
        var$1 = new $java.jur_FSet$PossessiveFSet;
        $java.jur_AbstractSet__init_(var$1);
        $java.jur_FSet_posFSet = var$1;
    };
    $java.jur_Lexer = function() {
        var a = this; jl_Object.call(a);
        a.$pattern10 = null;
        a.$flags5 = 0;
        a.$mode0 = 0;
        a.$savedMode = 0;
        a.$lookBack = 0;
        a.$ch = 0;
        a.$lookAhead = 0;
        a.$patternFullLength = 0;
        a.$curST = null;
        a.$lookAheadST = null;
        a.$index6 = 0;
        a.$prevNW = 0;
        a.$curToc = 0;
        a.$lookAheadToc = 0;
        a.$orig = null;
    };
    $java.jur_Lexer_decompTable = null;
    $java.jur_Lexer_singleDecompTable = null;
    $java.jur_Lexer_singleDecompTableSize = 0;
    $java.jur_Lexer_setMode = function($this, $mode) {
        if ($mode > 0 && $mode < 3)
            $this.$mode0 = $mode;
        if ($mode == 1) {
            $this.$lookAhead = $this.$ch;
            $this.$lookAheadST = $this.$curST;
            $this.$index6 = $this.$lookAheadToc;
            $this.$lookAheadToc = $this.$curToc;
            $java.jur_Lexer_movePointer($this);
        }
    };
    $java.jur_Lexer_isSpecial = function($this) {
        return $this.$curST === null ? 0 : 1;
    };
    $java.jur_Lexer_isNextSpecial = function($this) {
        return $this.$lookAheadST === null ? 0 : 1;
    };
    $java.jur_Lexer_next = function($this) {
        $java.jur_Lexer_movePointer($this);
        return $this.$lookBack;
    };
    $java.jur_Lexer_nextSpecial = function($this) {
        var $res;
        $res = $this.$curST;
        $java.jur_Lexer_movePointer($this);
        return $res;
    };
    $java.jur_Lexer_movePointer = function($this) {
        var $reread, $nonCap, var$3, $behind, $mod, $cs, $negative, $$je;
        $this.$lookBack = $this.$ch;
        $this.$ch = $this.$lookAhead;
        $this.$curST = $this.$lookAheadST;
        $this.$curToc = $this.$lookAheadToc;
        $this.$lookAheadToc = $this.$index6;
        while (true) {
            $reread = 0;
            $nonCap = $this.$index6 >= $this.$pattern10.data.length ? 0 : $java.jur_Lexer_nextCodePoint($this);
            $this.$lookAhead = $nonCap;
            $this.$lookAheadST = null;
            if ($this.$mode0 == 4) {
                if ($nonCap != 92)
                    return;
                $nonCap = $this.$index6;
                var$3 = $this.$pattern10.data;
                $nonCap = $nonCap >= var$3.length ? 0 : var$3[$java.jur_Lexer_nextIndex($this)];
                $this.$lookAhead = $nonCap;
                switch ($nonCap) {
                    case 69:
                        break;
                    default:
                        $this.$lookAhead = 92;
                        $this.$index6 = $this.$prevNW;
                        return;
                }
                $this.$mode0 = $this.$savedMode;
                $this.$lookAhead = $this.$index6 > ($this.$pattern10.data.length - 2 | 0) ? 0 : $java.jur_Lexer_nextCodePoint($this);
            }
            a: {
                $nonCap = $this.$lookAhead;
                if ($nonCap != 92) {
                    $behind = $this.$mode0;
                    if ($behind == 1)
                        switch ($nonCap) {
                            case 36:
                                $this.$lookAhead = (-536870876);
                                break a;
                            case 40:
                                if ($this.$pattern10.data[$this.$index6] != 63) {
                                    $this.$lookAhead = (-2147483608);
                                    break a;
                                }
                                $java.jur_Lexer_nextIndex($this);
                                $nonCap = $this.$pattern10.data[$this.$index6];
                                $behind = 0;
                                while (true) {
                                    b: {
                                        if ($behind) {
                                            $behind = 0;
                                            switch ($nonCap) {
                                                case 33:
                                                    break;
                                                case 61:
                                                    $this.$lookAhead = (-134217688);
                                                    $java.jur_Lexer_nextIndex($this);
                                                    break b;
                                                default:
                                                    $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Lexer_toString($this), $this.$index6));
                                            }
                                            $this.$lookAhead = (-67108824);
                                            $java.jur_Lexer_nextIndex($this);
                                        } else {
                                            switch ($nonCap) {
                                                case 33:
                                                    break;
                                                case 60:
                                                    $java.jur_Lexer_nextIndex($this);
                                                    $nonCap = $this.$pattern10.data[$this.$index6];
                                                    $behind = 1;
                                                    break b;
                                                case 61:
                                                    $this.$lookAhead = (-536870872);
                                                    $java.jur_Lexer_nextIndex($this);
                                                    break b;
                                                case 62:
                                                    $this.$lookAhead = (-33554392);
                                                    $java.jur_Lexer_nextIndex($this);
                                                    break b;
                                                default:
                                                    $mod = $java.jur_Lexer_readFlags($this);
                                                    $this.$lookAhead = $mod;
                                                    if ($mod < 256) {
                                                        $this.$flags5 = $mod;
                                                        $mod = $mod << 16;
                                                        $this.$lookAhead = $mod;
                                                        $this.$lookAhead = (-1073741784) | $mod;
                                                        break b;
                                                    }
                                                    $mod = $mod & 255;
                                                    $this.$lookAhead = $mod;
                                                    $this.$flags5 = $mod;
                                                    $mod = $mod << 16;
                                                    $this.$lookAhead = $mod;
                                                    $this.$lookAhead = (-16777176) | $mod;
                                                    break b;
                                            }
                                            $this.$lookAhead = (-268435416);
                                            $java.jur_Lexer_nextIndex($this);
                                        }
                                    }
                                    if (!$behind)
                                        break;
                                }
                                break a;
                            case 41:
                                $this.$lookAhead = (-536870871);
                                break a;
                            case 42:
                            case 43:
                            case 63:
                                $behind = $this.$index6;
                                var$3 = $this.$pattern10.data;
                                switch ($behind >= var$3.length ? 42 : var$3[$behind]) {
                                    case 43:
                                        $this.$lookAhead = $nonCap | (-2147483648);
                                        $java.jur_Lexer_nextIndex($this);
                                        break a;
                                    case 63:
                                        $this.$lookAhead = $nonCap | (-1073741824);
                                        $java.jur_Lexer_nextIndex($this);
                                        break a;
                                    default:
                                }
                                $this.$lookAhead = $nonCap | (-536870912);
                                break a;
                            case 46:
                                $this.$lookAhead = (-536870866);
                                break a;
                            case 91:
                                $this.$lookAhead = (-536870821);
                                $java.jur_Lexer_setMode($this, 2);
                                break a;
                            case 93:
                                if ($behind != 2)
                                    break a;
                                $this.$lookAhead = (-536870819);
                                break a;
                            case 94:
                                $this.$lookAhead = (-536870818);
                                break a;
                            case 123:
                                $this.$lookAheadST = $java.jur_Lexer_processQuantifier($this, $nonCap);
                                break a;
                            case 124:
                                $this.$lookAhead = (-536870788);
                                break a;
                            default:
                        }
                    else if ($behind == 2)
                        switch ($nonCap) {
                            case 38:
                                $this.$lookAhead = (-536870874);
                                break a;
                            case 45:
                                $this.$lookAhead = (-536870867);
                                break a;
                            case 91:
                                $this.$lookAhead = (-536870821);
                                break a;
                            case 93:
                                $this.$lookAhead = (-536870819);
                                break a;
                            case 94:
                                $this.$lookAhead = (-536870818);
                                break a;
                            default:
                        }
                } else {
                    $nonCap = $this.$index6 >= ($this.$pattern10.data.length - 2 | 0) ? (-1) : $java.jur_Lexer_nextCodePoint($this);
                    c: {
                        $this.$lookAhead = $nonCap;
                        switch ($nonCap) {
                            case -1:
                                $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Lexer_toString($this), $this.$index6));
                            case 0:
                            case 1:
                            case 2:
                            case 3:
                            case 4:
                            case 5:
                            case 6:
                            case 7:
                            case 8:
                            case 9:
                            case 10:
                            case 11:
                            case 12:
                            case 13:
                            case 14:
                            case 15:
                            case 16:
                            case 17:
                            case 18:
                            case 19:
                            case 20:
                            case 21:
                            case 22:
                            case 23:
                            case 24:
                            case 25:
                            case 26:
                            case 27:
                            case 28:
                            case 29:
                            case 30:
                            case 31:
                            case 32:
                            case 33:
                            case 34:
                            case 35:
                            case 36:
                            case 37:
                            case 38:
                            case 39:
                            case 40:
                            case 41:
                            case 42:
                            case 43:
                            case 44:
                            case 45:
                            case 46:
                            case 47:
                            case 58:
                            case 59:
                            case 60:
                            case 61:
                            case 62:
                            case 63:
                            case 64:
                            case 91:
                            case 92:
                            case 93:
                            case 94:
                            case 95:
                            case 96:
                            case 118:
                                break;
                            case 48:
                                $this.$lookAhead = $java.jur_Lexer_readOctals($this);
                                break a;
                            case 49:
                            case 50:
                            case 51:
                            case 52:
                            case 53:
                            case 54:
                            case 55:
                            case 56:
                            case 57:
                                if ($this.$mode0 != 1)
                                    break a;
                                $this.$lookAhead = (-2147483648) | $nonCap;
                                break a;
                            case 65:
                                $this.$lookAhead = (-2147483583);
                                break a;
                            case 66:
                                $this.$lookAhead = (-2147483582);
                                break a;
                            case 67:
                            case 69:
                            case 70:
                            case 72:
                            case 73:
                            case 74:
                            case 75:
                            case 76:
                            case 77:
                            case 78:
                            case 79:
                            case 82:
                            case 84:
                            case 85:
                            case 86:
                            case 88:
                            case 89:
                            case 103:
                            case 104:
                            case 105:
                            case 106:
                            case 107:
                            case 108:
                            case 109:
                            case 111:
                            case 113:
                            case 121:
                                $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Lexer_toString($this), $this.$index6));
                            case 68:
                            case 83:
                            case 87:
                            case 100:
                            case 115:
                            case 119:
                                $this.$lookAheadST = $java.jur_AbstractCharClass_getPredefinedClass(jl_String__init_1($this.$pattern10, $this.$prevNW, 1), 0);
                                $this.$lookAhead = 0;
                                break a;
                            case 71:
                                $this.$lookAhead = (-2147483577);
                                break a;
                            case 80:
                            case 112:
                                break c;
                            case 81:
                                $this.$savedMode = $this.$mode0;
                                $this.$mode0 = 4;
                                $reread = 1;
                                break a;
                            case 90:
                                $this.$lookAhead = (-2147483558);
                                break a;
                            case 97:
                                $this.$lookAhead = 7;
                                break a;
                            case 98:
                                $this.$lookAhead = (-2147483550);
                                break a;
                            case 99:
                                $nonCap = $this.$index6;
                                var$3 = $this.$pattern10.data;
                                if ($nonCap >= (var$3.length - 2 | 0))
                                    $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Lexer_toString($this), $this.$index6));
                                $this.$lookAhead = var$3[$java.jur_Lexer_nextIndex($this)] & 31;
                                break a;
                            case 101:
                                $this.$lookAhead = 27;
                                break a;
                            case 102:
                                $this.$lookAhead = 12;
                                break a;
                            case 110:
                                $this.$lookAhead = 10;
                                break a;
                            case 114:
                                $this.$lookAhead = 13;
                                break a;
                            case 116:
                                $this.$lookAhead = 9;
                                break a;
                            case 117:
                                $this.$lookAhead = $java.jur_Lexer_readHex($this, 4);
                                break a;
                            case 120:
                                $this.$lookAhead = $java.jur_Lexer_readHex($this, 2);
                                break a;
                            case 122:
                                $this.$lookAhead = (-2147483526);
                                break a;
                            default:
                        }
                        break a;
                    }
                    $cs = $java.jur_Lexer_parseCharClassName($this);
                    $negative = 0;
                    if ($this.$lookAhead == 80)
                        $negative = 1;
                    try {
                        $this.$lookAheadST = $java.jur_AbstractCharClass_getPredefinedClass($cs, $negative);
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof $java.ju_MissingResourceException) {
                            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $java.jur_Lexer_toString($this), $this.$index6));
                        } else {
                            throw $$e;
                        }
                    }
                    $this.$lookAhead = 0;
                }
            }
            if ($reread)
                continue;
            else
                break;
        }
    };
    $java.jur_Lexer_parseCharClassName = function($this) {
        var $sb, $ch, var$3, var$4, $res, var$6;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($sb, 10);
        $ch = $this.$index6;
        var$3 = $this.$pattern10;
        var$4 = var$3.data;
        if ($ch < (var$4.length - 2 | 0)) {
            if (var$4[$ch] != 123) {
                $sb = jl_String__init_1(var$3, $java.jur_Lexer_nextIndex($this), 1);
                $res = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($res);
                jl_StringBuilder_append(jl_StringBuilder_append($res, $rt_s(2838)), $sb);
                return jl_AbstractStringBuilder_toString($res);
            }
            $java.jur_Lexer_nextIndex($this);
            $ch = 0;
            a: {
                while (true) {
                    var$6 = $this.$index6;
                    var$3 = $this.$pattern10.data;
                    if (var$6 >= (var$3.length - 2 | 0))
                        break;
                    $ch = var$3[$java.jur_Lexer_nextIndex($this)];
                    if ($ch == 125)
                        break a;
                    jl_AbstractStringBuilder_append($sb, $ch);
                }
            }
            if ($ch != 125)
                $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
        }
        if (!$sb.$length0)
            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
        $res = jl_AbstractStringBuilder_toString($sb);
        if (jl_String_length($res) == 1) {
            $sb = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($sb);
            jl_StringBuilder_append(jl_StringBuilder_append($sb, $rt_s(2838)), $res);
            return jl_AbstractStringBuilder_toString($sb);
        }
        b: {
            c: {
                if (jl_String_length($res) > 3) {
                    if (jl_String_startsWith0($res, $rt_s(2838)))
                        break c;
                    if (jl_String_startsWith0($res, $rt_s(1561)))
                        break c;
                }
                break b;
            }
            $res = jl_String_substring($res, 2);
        }
        return $res;
    };
    $java.jur_Lexer_processQuantifier = function($this, $ch) {
        var $sb, $min, $max, $mod, var$6, $$je;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($sb, 4);
        $min = (-1);
        $max = 2147483647;
        a: {
            while (true) {
                $mod = $this.$index6;
                var$6 = $this.$pattern10.data;
                if ($mod >= var$6.length)
                    break a;
                $ch = var$6[$java.jur_Lexer_nextIndex($this)];
                if ($ch == 125)
                    break a;
                if ($ch == 44 && $min < 0)
                    try {
                        $min = jl_Integer_parseInt(jl_StringBuilder_toString($sb), 10);
                        jl_StringBuilder_delete($sb, 0, jl_StringBuilder_length($sb));
                        continue;
                    } catch ($$e) {
                        $$je = $rt_wrapException($$e);
                        if ($$je instanceof jl_NumberFormatException) {
                            break;
                        } else {
                            throw $$e;
                        }
                    }
                jl_AbstractStringBuilder_append($sb, $ch & 65535);
            }
            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
        }
        if ($ch != 125)
            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
        if ($sb.$length0 > 0)
            b: {
                try {
                    $max = jl_Integer_parseInt(jl_StringBuilder_toString($sb), 10);
                    if ($min >= 0)
                        break b;
                    $min = $max;
                    break b;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    if ($$je instanceof jl_NumberFormatException) {
                    } else {
                        throw $$e;
                    }
                }
                $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
            }
        else if ($min < 0)
            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
        if (($min | $max | ($max - $min | 0)) < 0)
            $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
        $ch = $this.$index6;
        var$6 = $this.$pattern10.data;
        $mod = $ch >= var$6.length ? 42 : var$6[$ch];
        c: {
            switch ($mod) {
                case 43:
                    $this.$lookAhead = (-2147483525);
                    $java.jur_Lexer_nextIndex($this);
                    break c;
                case 63:
                    $this.$lookAhead = (-1073741701);
                    $java.jur_Lexer_nextIndex($this);
                    break c;
                default:
            }
            $this.$lookAhead = (-536870789);
        }
        $sb = new $java.jur_Quantifier;
        $sb.$min2 = $min;
        $sb.$max3 = $max;
        return $sb;
    };
    $java.jur_Lexer_toString = function($this) {
        return $this.$orig;
    };
    $java.jur_Lexer_isEmpty = function($this) {
        return !$this.$ch && !$this.$lookAhead && $this.$index6 == $this.$patternFullLength && !$java.jur_Lexer_isSpecial($this) ? 1 : 0;
    };
    $java.jur_Lexer_isLetter0 = function($ch) {
        return $ch < 0 ? 0 : 1;
    };
    $java.jur_Lexer_isLetter = function($this) {
        return !$java.jur_Lexer_isEmpty($this) && !$java.jur_Lexer_isSpecial($this) && $java.jur_Lexer_isLetter0($this.$ch) ? 1 : 0;
    };
    $java.jur_Lexer_isHighSurrogate = function($this) {
        var var$1;
        var$1 = $this.$ch;
        return var$1 <= 56319 && var$1 >= 55296 ? 1 : 0;
    };
    $java.jur_Lexer_isLowSurrogate = function($this) {
        var var$1;
        var$1 = $this.$ch;
        return var$1 <= 57343 && var$1 >= 56320 ? 1 : 0;
    };
    $java.jur_Lexer_isHighSurrogate0 = function($ch) {
        return $ch <= 56319 && $ch >= 55296 ? 1 : 0;
    };
    $java.jur_Lexer_isLowSurrogate0 = function($ch) {
        return $ch <= 57343 && $ch >= 56320 ? 1 : 0;
    };
    $java.jur_Lexer_readHex = function($this, $max) {
        var $st, $length, $i, var$5, $$je;
        $st = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($st, $max);
        $length = $this.$pattern10.data.length - 2 | 0;
        $i = 0;
        while (true) {
            var$5 = $rt_compare($i, $max);
            if (var$5 >= 0)
                break;
            if ($this.$index6 >= $length)
                break;
            jl_AbstractStringBuilder_append($st, $this.$pattern10.data[$java.jur_Lexer_nextIndex($this)]);
            $i = $i + 1 | 0;
        }
        if (!var$5)
            a: {
                try {
                    $max = jl_Integer_parseInt(jl_StringBuilder_toString($st), 16);
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    if ($$je instanceof jl_NumberFormatException) {
                        break a;
                    } else {
                        throw $$e;
                    }
                }
                return $max;
            }
        $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
    };
    $java.jur_Lexer_readOctals = function($this) {
        var $max, $i, var$3, $length, $res, var$6;
        $max = 3;
        $i = 1;
        var$3 = $this.$pattern10.data;
        $length = var$3.length - 2 | 0;
        $res = jl_Character_digit(var$3[$this.$index6], 8);
        switch ($res) {
            case -1:
                break;
            default:
                if ($res > 3)
                    $max = 2;
                $java.jur_Lexer_nextIndex($this);
                a: {
                    while (true) {
                        if ($i >= $max)
                            break a;
                        var$6 = $this.$index6;
                        if (var$6 >= $length)
                            break a;
                        var$6 = jl_Character_digit($this.$pattern10.data[var$6], 8);
                        if (var$6 < 0)
                            break;
                        $res = ($res * 8 | 0) + var$6 | 0;
                        $java.jur_Lexer_nextIndex($this);
                        $i = $i + 1 | 0;
                    }
                }
                return $res;
        }
        $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, $this.$index6));
    };
    $java.jur_Lexer_readFlags = function($this) {
        var $pos, $res, var$3, var$4;
        $pos = 1;
        $res = $this.$flags5;
        a: while (true) {
            var$3 = $this.$index6;
            var$4 = $this.$pattern10.data;
            if (var$3 >= var$4.length)
                $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, var$3));
            b: {
                c: {
                    switch (var$4[var$3]) {
                        case 41:
                            $java.jur_Lexer_nextIndex($this);
                            return $res | 256;
                        case 45:
                            if (!$pos)
                                $rt_throw($java.jur_PatternSyntaxException__init_($rt_s(3), $this.$orig, var$3));
                            $pos = 0;
                            break b;
                        case 58:
                            break a;
                        case 100:
                            break c;
                        case 105:
                            $res = $pos ? $res | 2 : ($res ^ 2) & $res;
                            break b;
                        case 109:
                            $res = $pos ? $res | 8 : ($res ^ 8) & $res;
                            break b;
                        case 115:
                            $res = $pos ? $res | 32 : ($res ^ 32) & $res;
                            break b;
                        case 117:
                            $res = $pos ? $res | 64 : ($res ^ 64) & $res;
                            break b;
                        case 120:
                            $res = $pos ? $res | 4 : ($res ^ 4) & $res;
                            break b;
                        default:
                    }
                    break b;
                }
                $res = $pos ? $res | 1 : ($res ^ 1) & $res;
            }
            $java.jur_Lexer_nextIndex($this);
        }
        $java.jur_Lexer_nextIndex($this);
        return $res;
    };
    $java.jur_Lexer_nextIndex = function($this) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = $this.$index6;
        $this.$prevNW = var$1;
        if (!($this.$flags5 & 4))
            $this.$index6 = var$1 + 1 | 0;
        else {
            var$2 = $this.$pattern10.data.length - 2 | 0;
            $this.$index6 = var$1 + 1 | 0;
            a: while (true) {
                var$3 = $this.$index6;
                if (var$3 < var$2 && jl_Character_isWhitespace($this.$pattern10.data[var$3])) {
                    $this.$index6 = $this.$index6 + 1 | 0;
                    continue;
                }
                var$3 = $this.$index6;
                if (var$3 >= var$2)
                    break;
                var$4 = $this.$pattern10.data;
                if (var$4[var$3] != 35)
                    break;
                $this.$index6 = var$3 + 1 | 0;
                while (true) {
                    var$5 = $this.$index6;
                    if (var$5 >= var$2)
                        continue a;
                    var$1 = var$4[var$5];
                    if (var$1 != 10 && var$1 != 13 && var$1 != 133 && (var$1 | 1) != 8233 ? 0 : 1)
                        continue a;
                    $this.$index6 = var$5 + 1 | 0;
                }
            }
        }
        return $this.$prevNW;
    };
    $java.jur_Lexer_getDecomposition = function($ch) {
        return $java.jur_Lexer_decompTable.$get6($ch);
    };
    $java.jur_Lexer_nextCodePoint = function($this) {
        var $high, $lowExpectedIndex, var$3, $low;
        $high = $this.$pattern10.data[$java.jur_Lexer_nextIndex($this)];
        if (jl_Character_isHighSurrogate($high)) {
            $lowExpectedIndex = $this.$prevNW + 1 | 0;
            var$3 = $this.$pattern10.data;
            if ($lowExpectedIndex < var$3.length) {
                $low = var$3[$lowExpectedIndex];
                if (jl_Character_isLowSurrogate($low)) {
                    $java.jur_Lexer_nextIndex($this);
                    return jl_Character_toCodePoint($high, $low);
                }
            }
        }
        return $high;
    };
    $java.jur_Lexer_getIndex = function($this) {
        return $this.$curToc;
    };
    $java.jur_PatternSyntaxException = function() {
        var a = this; jl_IllegalArgumentException.call(a);
        a.$desc = null;
        a.$pattern11 = null;
        a.$index8 = 0;
    };
    $java.jur_PatternSyntaxException__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.jur_PatternSyntaxException();
        $java.jur_PatternSyntaxException__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.jur_PatternSyntaxException__init_0 = function($this, $description, $pattern, $index) {
        jl_Throwable__init_0($this);
        $this.$index8 = (-1);
        $this.$desc = $description;
        $this.$pattern11 = $pattern;
        $this.$index8 = $index;
    };
    $java.jur_PatternSyntaxException_getMessage = function($this) {
        var $filler, var$2, $temp, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $filler = $rt_s(3);
        var$2 = $this.$index8;
        if (var$2 >= 1) {
            $temp = $rt_createCharArray(var$2);
            var$4 = $temp.data;
            var$2 = 0;
            var$5 = var$4.length;
            if (var$2 > var$5) {
                $filler = new jl_IllegalArgumentException;
                jl_Throwable__init_0($filler);
                $rt_throw($filler);
            }
            while (var$2 < var$5) {
                var$6 = var$2 + 1 | 0;
                var$4[var$2] = 32;
                var$2 = var$6;
            }
            $filler = jl_String__init_($temp);
        }
        var$7 = $this.$desc;
        var$8 = $this.$pattern11;
        if (var$8 !== null && jl_String_length(var$8)) {
            var$9 = $this.$index8;
            var$8 = $this.$pattern11;
            var$10 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$10);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append0(var$10, var$9), $rt_s(16)), var$8), $rt_s(16)), $filler);
            $filler = jl_AbstractStringBuilder_toString(var$10);
        } else
            $filler = $rt_s(3);
        var$8 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$8);
        jl_StringBuilder_append(jl_StringBuilder_append(var$8, var$7), $filler);
        return jl_AbstractStringBuilder_toString(var$8);
    };
    $java.onciap_DefaultExpressionStringifier$Binding = $rt_classWithoutFields(0);
    function onciap_DefaultExpressionStringifier$Precedence() {
        var a = this; jl_Object.call(a);
        a.$level = 0;
        a.$$outer52 = null;
    }
    function onciap_DefaultExpressionStringifier$Precedence__init_(var_0, var_1) {
        var var_2 = new onciap_DefaultExpressionStringifier$Precedence();
        $java.onciap_DefaultExpressionStringifier$Precedence__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciap_DefaultExpressionStringifier$Precedence_productPrefix = function($this) {
        return $rt_s(2839);
    };
    $java.onciap_DefaultExpressionStringifier$Precedence_productArity = function($this) {
        return 1;
    };
    $java.onciap_DefaultExpressionStringifier$Precedence_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return jl_Integer_valueOf($this.$level);
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciap_DefaultExpressionStringifier$Precedence_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciap_DefaultExpressionStringifier$Precedence_hashCode = function($this) {
        return sr_Statics_finalizeHash(sr_Statics_mix(sr_Statics_mix((-889275714), jl_String_hashCode($rt_s(2839))), $this.$level), 1);
    };
    $java.onciap_DefaultExpressionStringifier$Precedence_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciap_DefaultExpressionStringifier$Precedence_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!($x$1 instanceof onciap_DefaultExpressionStringifier$Precedence && $x$1.$$outer52 === $this.$$outer52 ? 1 : 0))
                        break b;
                    $x$1 = $x$1;
                    if ($this.$level != $x$1.$level)
                        break b;
                    if (!($this instanceof onciap_DefaultExpressionStringifier$Precedence))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.onciap_DefaultExpressionStringifier$Precedence__init_ = function($this, $$outer, $level) {
        $this.$level = $level;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer52 = $$outer;
    };
    var onciap_DefaultExpressionStringifier$formsChain$1$lambda$_55_0 = $rt_classWithoutFields();
    $java.onciap_DefaultExpressionStringifier$formsChain$1$lambda$_55_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = (sc_AbstractIterable_head(var$1)).$rhs0();
                    var$1 = (var$1.$last()).$lhs0();
                    if (var$2 !== null) {
                        if (!var$2.$equals(var$1))
                            break b;
                        else
                            break c;
                    }
                    if (var$1 !== null)
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return jl_Boolean_valueOf(var$3);
    };
    $java.jur_NonCapFSet = $rt_classWithoutFields($java.jur_FSet);
    $java.jur_NonCapFSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $gr;
        $gr = $this.$groupIndex;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $gr, $stringIndex - $java.jur_MatchResultImpl_getConsumed($matchResult, $gr) | 0);
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_NonCapFSet_getName = function($this) {
        return $rt_s(2840);
    };
    $java.jur_NonCapFSet_hasConsumed = function($this, $mr) {
        return 0;
    };
    $java.jur_AheadFSet = $rt_classWithoutFields($java.jur_FSet);
    $java.jur_AheadFSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        return $stringIndex;
    };
    $java.jur_AheadFSet_getName = function($this) {
        return $rt_s(2841);
    };
    $java.jur_BehindFSet = $rt_classWithoutFields($java.jur_FSet);
    $java.jur_BehindFSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        if ($java.jur_MatchResultImpl_getConsumed($matchResult, $this.$groupIndex) != $stringIndex)
            $stringIndex = (-1);
        return $stringIndex;
    };
    $java.jur_BehindFSet_getName = function($this) {
        return $rt_s(2842);
    };
    $java.jur_AtomicFSet = function() {
        $java.jur_FSet.call(this);
        this.$index9 = 0;
    };
    $java.jur_AtomicFSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $gr;
        $gr = $this.$groupIndex;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $gr, $stringIndex - $java.jur_MatchResultImpl_getConsumed($matchResult, $gr) | 0);
        $this.$index9 = $stringIndex;
        return $stringIndex;
    };
    $java.jur_AtomicFSet_getName = function($this) {
        return $rt_s(2843);
    };
    $java.jur_AtomicFSet_hasConsumed = function($this, $mr) {
        return 0;
    };
    $java.jur_FinalSet = $rt_classWithoutFields($java.jur_FSet);
    $java.jur_FinalSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        if ($matchResult.$mode1 != 1 && $stringIndex != $matchResult.$rightBound0)
            return (-1);
        $matchResult.$valid = 1;
        $java.jur_MatchResultImpl_setEnd($matchResult, 0, $stringIndex);
        return $stringIndex;
    };
    $java.jur_FinalSet_getName = function($this) {
        return $rt_s(2844);
    };
    $java.jur_LeafSet = function() {
        jur_AbstractSet.call(this);
        this.$charCount = 0;
    };
    $java.jur_LeafSet__init_ = function($this) {
        $java.jur_AbstractSet__init_($this);
        $this.$charCount = 1;
    };
    $java.jur_LeafSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $shift;
        if (($stringIndex + $this.$charCount0() | 0) > $matchResult.$rightBound0) {
            $matchResult.$hitEnd = 1;
            return (-1);
        }
        $shift = $this.$accepts($stringIndex, $testString);
        if ($shift < 0)
            return (-1);
        return $this.$next12.$matches1($stringIndex + $shift | 0, $testString, $matchResult);
    };
    $java.jur_LeafSet_charCount = function($this) {
        return $this.$charCount;
    };
    $java.jur_LeafSet_hasConsumed = function($this, $mr) {
        return 1;
    };
    $java.jur_EmptySet = $rt_classWithoutFields($java.jur_LeafSet);
    $java.jur_EmptySet__init_ = function(var_0) {
        var var_1 = new $java.jur_EmptySet();
        $java.jur_EmptySet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_EmptySet__init_0 = function($this, $next) {
        $java.jur_AbstractSet__init_0($this, $next);
        $this.$charCount = 1;
        $this.$type0 = 1;
        $this.$charCount = 0;
    };
    $java.jur_EmptySet_accepts = function($this, $stringIndex, $testString) {
        return 0;
    };
    $java.jur_EmptySet_find = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength, $startStr, $high;
        $strLength = $matchResult.$rightBound0;
        $startStr = $matchResult.$leftBound0;
        while (true) {
            $high = $rt_compare($stringIndex, $strLength);
            if ($high > 0)
                return (-1);
            if ($high < 0 && jl_Character_isLowSurrogate(jl_String_charAt($testString, $stringIndex)) && $stringIndex > $startStr && jl_Character_isHighSurrogate(jl_String_charAt($testString, $stringIndex - 1 | 0))) {
                $stringIndex = $stringIndex + 1 | 0;
                continue;
            }
            if ($this.$next12.$matches1($stringIndex, $testString, $matchResult) >= 0)
                break;
            $stringIndex = $stringIndex + 1 | 0;
        }
        return $stringIndex;
    };
    $java.jur_EmptySet_findBack = function($this, $stringIndex, $startSearch, $testString, $matchResult) {
        var $strLength, $startStr;
        $strLength = $matchResult.$rightBound0;
        $startStr = $matchResult.$leftBound0;
        while (true) {
            if ($startSearch < $stringIndex)
                return (-1);
            if ($startSearch < $strLength && jl_Character_isLowSurrogate(jl_String_charAt($testString, $startSearch)) && $startSearch > $startStr && jl_Character_isHighSurrogate(jl_String_charAt($testString, $startSearch - 1 | 0))) {
                $startSearch = $startSearch + (-1) | 0;
                continue;
            }
            if ($this.$next12.$matches1($startSearch, $testString, $matchResult) >= 0)
                break;
            $startSearch = $startSearch + (-1) | 0;
        }
        return $startSearch;
    };
    $java.jur_EmptySet_getName = function($this) {
        return $rt_s(2845);
    };
    $java.jur_EmptySet_hasConsumed = function($this, $mr) {
        return 0;
    };
    $java.jur_JointSet = function() {
        var a = this; jur_AbstractSet.call(a);
        a.$children3 = null;
        a.$fSet = null;
        a.$groupIndex0 = 0;
    };
    $java.jur_JointSet__init_0 = function(var_0, var_1) {
        var var_2 = new $java.jur_JointSet();
        $java.jur_JointSet__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_JointSet__init_ = function($this, $children, $fSet) {
        $java.jur_AbstractSet__init_($this);
        $this.$children3 = $children;
        $this.$fSet = $fSet;
        $this.$groupIndex0 = $fSet.$groupIndex;
    };
    $java.jur_JointSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $start, $size, $i, $shift;
        if ($this.$children3 === null)
            return (-1);
        $start = $java.jur_MatchResultImpl_getStart($matchResult, $this.$groupIndex0);
        $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $stringIndex);
        $size = $this.$children3.$size2;
        $i = 0;
        while (true) {
            if ($i >= $size) {
                $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $start);
                return (-1);
            }
            $shift = (ju_ArrayList_get($this.$children3, $i)).$matches1($stringIndex, $testString, $matchResult);
            if ($shift >= 0)
                break;
            $i = $i + 1 | 0;
        }
        return $shift;
    };
    $java.jur_JointSet_setNext = function($this, $next) {
        $this.$fSet.$next12 = $next;
    };
    $java.jur_JointSet_getName = function($this) {
        return $rt_s(2846);
    };
    $java.jur_JointSet_first = function($this, $set) {
        var $i;
        a: {
            $i = $this.$children3;
            if ($i !== null) {
                $i = ju_AbstractList_iterator($i);
                while (true) {
                    if (!ju_AbstractList$1_hasNext($i))
                        break a;
                    if (!(ju_AbstractList$1_next($i)).$first4($set))
                        continue;
                    else
                        return 1;
                }
            }
        }
        return 0;
    };
    $java.jur_JointSet_hasConsumed = function($this, $matchResult) {
        return $java.jur_MatchResultImpl_getEnd($matchResult, $this.$groupIndex0) >= 0 && $java.jur_MatchResultImpl_getStart($matchResult, $this.$groupIndex0) == $java.jur_MatchResultImpl_getEnd($matchResult, $this.$groupIndex0) ? 0 : 1;
    };
    $java.jur_JointSet_processSecondPass = function($this) {
        var $child, $childrenSize, $i, $set, var$5, var$6, var$7, var$8, var$9;
        $this.$isSecondPassVisited = 1;
        $child = $this.$fSet;
        if ($child !== null && !$child.$isSecondPassVisited)
            $java.jur_AbstractSet_processSecondPass($child);
        a: {
            b: {
                $child = $this.$children3;
                if ($child !== null) {
                    $childrenSize = $child.$size2;
                    $i = 0;
                    while (true) {
                        if ($i >= $childrenSize)
                            break b;
                        $child = ju_ArrayList_get($this.$children3, $i);
                        $set = $child.$processBackRefReplacement();
                        if ($set === null)
                            $set = $child;
                        else {
                            $child.$isSecondPassVisited = 1;
                            ju_ArrayList_remove($this.$children3, $i);
                            var$5 = $this.$children3;
                            if ($i < 0)
                                break a;
                            var$6 = var$5.$size2;
                            if ($i > var$6)
                                break a;
                            ju_ArrayList_ensureCapacity(var$5, var$6 + 1 | 0);
                            var$7 = var$5.$size2;
                            var$8 = var$7;
                            while (var$8 > $i) {
                                var$9 = var$5.$array.data;
                                var$9[var$8] = var$9[var$8 - 1 | 0];
                                var$8 = var$8 + (-1) | 0;
                            }
                            var$5.$array.data[$i] = $set;
                            var$5.$size2 = var$7 + 1 | 0;
                            var$5.$modCount = var$5.$modCount + 1 | 0;
                        }
                        if (!$set.$isSecondPassVisited)
                            $set.$processSecondPass();
                        $i = $i + 1 | 0;
                    }
                }
            }
            if ($this.$next12 !== null)
                $java.jur_AbstractSet_processSecondPass($this);
            return;
        }
        $child = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0($child);
        $rt_throw($child);
    };
    $java.jur_NonCapJointSet = $rt_classWithoutFields($java.jur_JointSet);
    $java.jur_NonCapJointSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $start, $size, $i, $shift;
        $start = $java.jur_MatchResultImpl_getConsumed($matchResult, $this.$groupIndex0);
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$groupIndex0, $stringIndex);
        $size = $this.$children3.$size2;
        $i = 0;
        while (true) {
            if ($i >= $size) {
                $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$groupIndex0, $start);
                return (-1);
            }
            $shift = (ju_ArrayList_get($this.$children3, $i)).$matches1($stringIndex, $testString, $matchResult);
            if ($shift >= 0)
                break;
            $i = $i + 1 | 0;
        }
        return $shift;
    };
    $java.jur_NonCapJointSet_getName = function($this) {
        return $rt_s(2847);
    };
    $java.jur_NonCapJointSet_hasConsumed = function($this, $matchResult) {
        return !$java.jur_MatchResultImpl_getConsumed($matchResult, $this.$groupIndex0) ? 0 : 1;
    };
    $java.jur_AtomicJointSet = $rt_classWithoutFields($java.jur_NonCapJointSet);
    $java.jur_AtomicJointSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $start, $size, $i;
        $start = $java.jur_MatchResultImpl_getConsumed($matchResult, $this.$groupIndex0);
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$groupIndex0, $stringIndex);
        $size = $this.$children3.$size2;
        $i = 0;
        while ($i < $size) {
            if ((ju_ArrayList_get($this.$children3, $i)).$matches1($stringIndex, $testString, $matchResult) >= 0)
                return $this.$next12.$matches1($this.$fSet.$index9, $testString, $matchResult);
            $i = $i + 1 | 0;
        }
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$groupIndex0, $start);
        return (-1);
    };
    $java.jur_AtomicJointSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_AtomicJointSet_getName = function($this) {
        return $rt_s(2847);
    };
    $java.jur_PositiveLookAhead = $rt_classWithoutFields($java.jur_AtomicJointSet);
    $java.jur_PositiveLookAhead_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $size, $i;
        $size = $this.$children3.$size2;
        $i = 0;
        while ($i < $size) {
            if ((ju_ArrayList_get($this.$children3, $i)).$matches1($stringIndex, $testString, $matchResult) >= 0)
                return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_PositiveLookAhead_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_PositiveLookAhead_getName = function($this) {
        return $rt_s(2848);
    };
    $java.jur_NegativeLookAhead = $rt_classWithoutFields($java.jur_AtomicJointSet);
    $java.jur_NegativeLookAhead_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $size, $i;
        $size = $this.$children3.$size2;
        $i = 0;
        while (true) {
            if ($i >= $size)
                return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            if ((ju_ArrayList_get($this.$children3, $i)).$matches1($stringIndex, $testString, $matchResult) >= 0)
                break;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_NegativeLookAhead_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_NegativeLookAhead_getName = function($this) {
        return $rt_s(2849);
    };
    $java.jur_PositiveLookBehind = $rt_classWithoutFields($java.jur_AtomicJointSet);
    $java.jur_PositiveLookBehind_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $size, $leftBound, $shift, $i;
        $size = $this.$children3.$size2;
        $leftBound = $matchResult.$transparentBounds ? 0 : $matchResult.$leftBound0;
        a: {
            $shift = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            if ($shift >= 0) {
                $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$groupIndex0, $stringIndex);
                $i = 0;
                while (true) {
                    if ($i >= $size)
                        break a;
                    if ((ju_ArrayList_get($this.$children3, $i)).$findBack($leftBound, $stringIndex, $testString, $matchResult) >= 0) {
                        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$groupIndex0, (-1));
                        return $shift;
                    }
                    $i = $i + 1 | 0;
                }
            }
        }
        return (-1);
    };
    $java.jur_PositiveLookBehind_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_PositiveLookBehind_getName = function($this) {
        return $rt_s(2850);
    };
    $java.jur_NegativeLookBehind = $rt_classWithoutFields($java.jur_AtomicJointSet);
    $java.jur_NegativeLookBehind_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $size, $i;
        $size = $this.$children3.$size2;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$groupIndex0, $stringIndex);
        $i = 0;
        while (true) {
            if ($i >= $size)
                return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            if ((ju_ArrayList_get($this.$children3, $i)).$findBack(0, $stringIndex, $testString, $matchResult) >= 0)
                break;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_NegativeLookBehind_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_NegativeLookBehind_getName = function($this) {
        return $rt_s(2851);
    };
    $java.jur_SingleSet = function() {
        $java.jur_JointSet.call(this);
        this.$kid = null;
    };
    $java.jur_SingleSet__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_SingleSet();
        $java.jur_SingleSet__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_SingleSet__init_0 = function($this, $child, $fSet) {
        $java.jur_AbstractSet__init_($this);
        $this.$kid = $child;
        $this.$fSet = $fSet;
        $this.$groupIndex0 = $fSet.$groupIndex;
    };
    $java.jur_SingleSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $start, $shift;
        $start = $java.jur_MatchResultImpl_getStart($matchResult, $this.$groupIndex0);
        $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $stringIndex);
        $shift = $this.$kid.$matches1($stringIndex, $testString, $matchResult);
        if ($shift >= 0)
            return $shift;
        $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $start);
        return (-1);
    };
    $java.jur_SingleSet_find = function($this, $stringIndex, $testString, $matchResult) {
        var $res;
        $res = $this.$kid.$find1($stringIndex, $testString, $matchResult);
        if ($res >= 0)
            $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $res);
        return $res;
    };
    $java.jur_SingleSet_findBack = function($this, $stringIndex, $lastIndex, $testString, $matchResult) {
        var $res;
        $res = $this.$kid.$findBack($stringIndex, $lastIndex, $testString, $matchResult);
        if ($res >= 0)
            $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $res);
        return $res;
    };
    $java.jur_SingleSet_first = function($this, $set) {
        return $this.$kid.$first4($set);
    };
    $java.jur_SingleSet_processBackRefReplacement = function($this) {
        var $set;
        $set = new $java.jur_BackReferencedSingleSet;
        $java.jur_SingleSet__init_0($set, $this.$kid, $this.$fSet);
        $this.$next12 = $set;
        return $set;
    };
    $java.jur_SingleSet_processSecondPass = function($this) {
        var $set;
        $this.$isSecondPassVisited = 1;
        $set = $this.$fSet;
        if ($set !== null && !$set.$isSecondPassVisited)
            $java.jur_AbstractSet_processSecondPass($set);
        $set = $this.$kid;
        if ($set !== null && !$set.$isSecondPassVisited) {
            $set = $set.$processBackRefReplacement();
            if ($set !== null) {
                $this.$kid.$isSecondPassVisited = 1;
                $this.$kid = $set;
            }
            $this.$kid.$processSecondPass();
        }
    };
    function oncie_Multiply() {
        var a = this; oncie_Expression.call(a);
        a.$lhs19 = null;
        a.$rhs21 = null;
        a.$position243 = null;
        a.$signatures23 = null;
    }
    function oncie_Multiply__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Multiply();
        $java.oncie_Multiply__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Multiply_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Multiply_lhs = function($this) {
        return $this.$lhs19;
    };
    $java.oncie_Multiply_rhs = function($this) {
        return $this.$rhs21;
    };
    $java.oncie_Multiply_position = function($this) {
        return $this.$position243;
    };
    $java.oncie_Multiply_signatures = function($this) {
        return $this.$signatures23;
    };
    $java.oncie_Multiply_canonicalOperatorSymbol = function($this) {
        return $rt_s(305);
    };
    $java.oncie_Multiply_productPrefix = function($this) {
        return $rt_s(2852);
    };
    $java.oncie_Multiply_productArity = function($this) {
        return 2;
    };
    $java.oncie_Multiply_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs19;
            case 1:
                return $this.$rhs21;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Multiply_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Multiply_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Multiply_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Multiply_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Multiply) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs19;
                        var$3 = $x$1.$lhs19;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs21;
                        $x$1 = $x$1.$rhs21;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Multiply))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Multiply__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs19 = $lhs;
        $this.$rhs21 = $rhs;
        $this.$position243 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 8);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        var$8 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_IntegerType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, var$8.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$9)), oncius_package$_CTInteger(oncius_package$_MODULE$));
        var$6[1] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[2] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_FloatType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[3] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[4] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTDuration0(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        var$6[5] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTDuration0(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        var$6[6] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        var$6[7] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        $this.$signatures23 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncie_Pow() {
        var a = this; oncie_Expression.call(a);
        a.$lhs28 = null;
        a.$rhs27 = null;
        a.$position288 = null;
        a.$signatures24 = null;
    }
    function oncie_Pow__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Pow();
        $java.oncie_Pow__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Pow_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Pow_lhs = function($this) {
        return $this.$lhs28;
    };
    $java.oncie_Pow_rhs = function($this) {
        return $this.$rhs27;
    };
    $java.oncie_Pow_position = function($this) {
        return $this.$position288;
    };
    $java.oncie_Pow_signatures = function($this) {
        return $this.$signatures24;
    };
    $java.oncie_Pow_canonicalOperatorSymbol = function($this) {
        return $rt_s(996);
    };
    $java.oncie_Pow_productPrefix = function($this) {
        return $rt_s(2853);
    };
    $java.oncie_Pow_productArity = function($this) {
        return 2;
    };
    $java.oncie_Pow_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs28;
            case 1:
                return $this.$rhs27;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Pow_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pow_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pow_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pow_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Pow) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs28;
                        var$3 = $x$1.$lhs28;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs27;
                        $x$1 = $x$1.$rhs27;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Pow))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Pow__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs28 = $lhs;
        $this.$rhs27 = $rhs;
        $this.$position288 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 1);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        $position = s_package$_Vector0(s_package$_MODULE$);
        var$8 = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_FloatType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$10[1] = $java.oncius_package$_CTFloat(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, $position.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9)), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        $this.$signatures24 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncie_Divide() {
        var a = this; oncie_Expression.call(a);
        a.$lhs29 = null;
        a.$rhs28 = null;
        a.$position289 = null;
        a.$signatures25 = null;
    }
    function oncie_Divide__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Divide();
        $java.oncie_Divide__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Divide_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Divide_lhs = function($this) {
        return $this.$lhs29;
    };
    $java.oncie_Divide_rhs = function($this) {
        return $this.$rhs28;
    };
    $java.oncie_Divide_position = function($this) {
        return $this.$position289;
    };
    $java.oncie_Divide_signatures = function($this) {
        return $this.$signatures25;
    };
    $java.oncie_Divide_canonicalOperatorSymbol = function($this) {
        return $rt_s(134);
    };
    $java.oncie_Divide_productPrefix = function($this) {
        return $rt_s(2854);
    };
    $java.oncie_Divide_productArity = function($this) {
        return 2;
    };
    $java.oncie_Divide_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs29;
            case 1:
                return $this.$rhs28;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Divide_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Divide_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Divide_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Divide_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Divide) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs29;
                        var$3 = $x$1.$lhs29;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs28;
                        $x$1 = $x$1.$rhs28;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Divide))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Divide__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs29 = $lhs;
        $this.$rhs28 = $rhs;
        $this.$position289 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 6);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        var$8 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_IntegerType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, var$8.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$9)), oncius_package$_CTInteger(oncius_package$_MODULE$));
        var$6[1] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[2] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_FloatType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[3] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[4] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTDuration0(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        var$6[5] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTDuration0(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)]))), $java.oncius_package$_CTDuration0(oncius_package$_MODULE$));
        $this.$signatures25 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    function oncie_Modulo() {
        var a = this; oncie_Expression.call(a);
        a.$lhs30 = null;
        a.$rhs29 = null;
        a.$position290 = null;
        a.$signatures26 = null;
    }
    function oncie_Modulo__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_Modulo();
        $java.oncie_Modulo__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_Modulo_asCanonicalStringVal = function($this) {
        return $java.oncie_BinaryOperatorExpression_asCanonicalStringVal$($this);
    };
    $java.oncie_Modulo_lhs = function($this) {
        return $this.$lhs30;
    };
    $java.oncie_Modulo_rhs = function($this) {
        return $this.$rhs29;
    };
    $java.oncie_Modulo_position = function($this) {
        return $this.$position290;
    };
    $java.oncie_Modulo_signatures = function($this) {
        return $this.$signatures26;
    };
    $java.oncie_Modulo_canonicalOperatorSymbol = function($this) {
        return $rt_s(192);
    };
    $java.oncie_Modulo_productPrefix = function($this) {
        return $rt_s(2855);
    };
    $java.oncie_Modulo_productArity = function($this) {
        return 2;
    };
    $java.oncie_Modulo_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lhs30;
            case 1:
                return $this.$rhs29;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Modulo_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Modulo_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Modulo_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Modulo_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_Modulo) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lhs30;
                        var$3 = $x$1.$lhs30;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$rhs29;
                        $x$1 = $x$1.$rhs29;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_Modulo))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Modulo__init_ = function($this, $lhs, $rhs, $position) {
        var var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        $this.$lhs30 = $lhs;
        $this.$rhs29 = $rhs;
        $this.$position290 = $position;
        $java.oncie_Expression__init_($this);
        s_package$_$callClinit();
        var$4 = s_package$_Vector0(s_package$_MODULE$);
        $lhs = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray($java.oncie_ExpressionTypeSignature, 4);
        var$6 = var$5.data;
        var$7 = $java.oncie_TypeSignature$_MODULE$;
        var$8 = s_package$_Vector0(s_package$_MODULE$);
        $position = sr_ScalaRunTime$_MODULE$;
        var$9 = $rt_createArray(oncius_IntegerType, 2);
        var$10 = var$9.data;
        oncius_package$_$callClinit();
        var$10[0] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$10[1] = oncius_package$_CTInteger(oncius_package$_MODULE$);
        var$6[0] = $java.oncie_TypeSignature$_apply(var$7, var$8.$from0(sr_ScalaRunTime$_wrapRefArray($position, var$9)), oncius_package$_CTInteger(oncius_package$_MODULE$));
        var$6[1] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [oncius_package$_CTInteger(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[2] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_CypherType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), oncius_package$_CTInteger(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        var$6[3] = $java.oncie_TypeSignature$_apply($java.oncie_TypeSignature$_MODULE$, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(oncius_FloatType, [$java.oncius_package$_CTFloat(oncius_package$_MODULE$), $java.oncius_package$_CTFloat(oncius_package$_MODULE$)]))), $java.oncius_package$_CTFloat(oncius_package$_MODULE$));
        $this.$signatures26 = var$4.$from0(sr_ScalaRunTime$_wrapRefArray($lhs, var$5));
    };
    $java.oncius_TypeRange = function() {
        var a = this; jl_Object.call(a);
        a.$hasDefiniteSize = 0;
        a.$lower1 = null;
        a.$upper1 = null;
        a.$bitmap$034 = 0;
    };
    $java.oncius_TypeRange__init_0 = function(var_0, var_1) {
        var var_2 = new $java.oncius_TypeRange();
        $java.oncius_TypeRange__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncius_TypeRange_lower = function($this) {
        return $this.$lower1;
    };
    $java.oncius_TypeRange_upper = function($this) {
        return $this.$upper1;
    };
    $java.oncius_TypeRange_contains = function($this, $that) {
        var var$2, var$3, var$4, var$5;
        a: {
            if ($this.$lower1.$isAssignableFrom0($that.$lower1)) {
                var$2 = $this.$upper1;
                var$3 = new $java.oncius_TypeRange$contains$lambda$_7_0;
                var$4 = new $java.oncius_TypeRange$contains$lambda$_7_1;
                var$4.$_0517 = $that;
                if (sr_BoxesRunTime_unboxToBoolean(s_Option_fold(var$2, var$3, var$4))) {
                    var$5 = 1;
                    break a;
                }
            }
            var$5 = 0;
        }
        return var$5;
    };
    $java.oncius_TypeRange_hasDefiniteSize = function($this) {
        var var$1, $$je;
        if ($this.$bitmap$034)
            return $this.$hasDefiniteSize;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$034)
                    break a;
                $this.$hasDefiniteSize = !s_Option_isDefined($java.oncius_TypeRange_upper($this)) && sr_BoxesRunTime_unboxToBoolean($java.oncius_TypeRange$checkForAny$lambda$_10_0_apply($java.oncius_TypeRange_checkForAny($this), $java.oncius_TypeRange_lower($this))) ? 0 : 1;
                $this.$bitmap$034 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$hasDefiniteSize;
    };
    $java.oncius_TypeRange_checkForAny = function($this) {
        var var$1;
        var$1 = new $java.oncius_TypeRange$checkForAny$lambda$_10_0;
        var$1.$_0518 = $this;
        return var$1;
    };
    $java.oncius_TypeRange_intersect = function($this, $that) {
        var var$2, var$3;
        var$2 = $this.$lower1.$greatestLowerBound($that.$lower1);
        var$3 = new $java.oncius_TypeRange$intersect$lambda$_12_0;
        var$3.$_0519 = $this;
        var$3.$_1171 = $that;
        return s_Option_flatMap(var$2, var$3);
    };
    $java.oncius_TypeRange_covariant = function($this) {
        var $x$1;
        $x$1 = s_None$_MODULE$;
        return $java.oncius_TypeRange__init_0($this.$lower1, $x$1);
    };
    $java.oncius_TypeRange_constrain = function($this, $aType) {
        return $java.oncius_TypeRange_intersect($this, $java.oncius_TypeRange__init_0($aType, s_None$_MODULE$));
    };
    $java.oncius_TypeRange_leastUpperBounds = function($this, $other) {
        var $newLower, $u2, $u1, $u2_0, var$6, $u1_0, var$8, var$9;
        $newLower = $this.$lower1.$leastUpperBound($other.$lower1);
        $u2 = s_Tuple2__init_($this.$upper1, $other.$upper1);
        $u1 = $u2.$_10;
        $u2_0 = $u2.$_20;
        var$6 = $u1 instanceof s_Some;
        if (var$6) {
            $u1_0 = $u1.$value5;
            if ($u2_0 instanceof s_Some) {
                $u2_0 = $u2_0.$value5;
                s_package$_$callClinit();
                $u1 = s_package$_Vector0(s_package$_MODULE$);
                var$8 = sr_ScalaRunTime$_MODULE$;
                var$9 = $rt_createArray($java.oncius_TypeRange, 1);
                var$9.data[0] = $java.oncius_TypeRange__init_0($newLower, s_Some__init_($u1_0.$leastUpperBound($u2_0)));
                return $u1.$from0(sr_ScalaRunTime$_wrapRefArray(var$8, var$9));
            }
        }
        if (var$6) {
            $u1 = $u1.$value5;
            if (jl_Object_equals(s_None$_MODULE$, $u2_0)) {
                if (!$u1.$isAssignableFrom0($other.$lower1) && !$other.$lower1.$isAssignableFrom0($u1)) {
                    s_package$_$callClinit();
                    $other = s_package$_Vector0(s_package$_MODULE$);
                    $u2 = sr_ScalaRunTime$_MODULE$;
                    var$9 = $rt_createArray($java.oncius_TypeRange, 1);
                    var$9.data[0] = $java.oncius_TypeRange__init_0($newLower, s_Some__init_($newLower));
                    return $other.$from0(sr_ScalaRunTime$_wrapRefArray($u2, var$9));
                }
                s_package$_$callClinit();
                $other = s_package$_Vector0(s_package$_MODULE$);
                $u2 = sr_ScalaRunTime$_MODULE$;
                var$9 = $rt_createArray($java.oncius_TypeRange, 1);
                var$9.data[0] = $java.oncius_TypeRange__init_0($newLower, s_Some__init_($u1));
                return $other.$from0(sr_ScalaRunTime$_wrapRefArray($u2, var$9));
            }
        }
        $u1 = $u2.$_10;
        $u2_0 = $u2.$_20;
        if (jl_Object_equals(s_None$_MODULE$, $u1) && $u2_0 instanceof s_Some) {
            $u2 = $u2_0.$value5;
            if (!$u2.$isAssignableFrom0($this.$lower1) && !$this.$lower1.$isAssignableFrom0($u2)) {
                s_package$_$callClinit();
                $other = s_package$_Vector0(s_package$_MODULE$);
                $u2 = sr_ScalaRunTime$_MODULE$;
                var$9 = $rt_createArray($java.oncius_TypeRange, 1);
                var$9.data[0] = $java.oncius_TypeRange__init_0($newLower, s_Some__init_($newLower));
                return $other.$from0(sr_ScalaRunTime$_wrapRefArray($u2, var$9));
            }
            s_package$_$callClinit();
            $other = s_package$_Vector0(s_package$_MODULE$);
            $u1 = sr_ScalaRunTime$_MODULE$;
            var$9 = $rt_createArray($java.oncius_TypeRange, 1);
            var$9.data[0] = $java.oncius_TypeRange__init_0($newLower, s_Some__init_($u2));
            return $other.$from0(sr_ScalaRunTime$_wrapRefArray($u1, var$9));
        }
        $u1 = $u2.$_10;
        $u2_0 = s_Tuple2__2($u2);
        if (jl_Object_equals(s_None$_MODULE$, $u1) && jl_Object_equals(s_None$_MODULE$, $u2_0)) {
            a: {
                b: {
                    $u2 = $java.oncius_TypeRange_lower($this);
                    $u1 = $java.oncius_TypeRange_lower($other);
                    if ($u2 !== null) {
                        if (!$u2.$equals($u1))
                            break a;
                        else
                            break b;
                    }
                    if ($u1 !== null)
                        break a;
                }
                s_package$_$callClinit();
                $other = s_package$_Vector0(s_package$_MODULE$);
                $u2 = sr_ScalaRunTime$_MODULE$;
                var$9 = $rt_createArray($java.oncius_TypeRange, 1);
                var$9.data[0] = $java.oncius_TypeRange__init_0($newLower, s_None$_MODULE$);
                return sci_Vector$_apply($other, sr_ScalaRunTime$_wrapRefArray($u2, var$9));
            }
            if (($java.oncius_TypeRange_lower($this)).$isAssignableFrom0($java.oncius_TypeRange_lower($other))) {
                s_package$_$callClinit();
                return sci_Vector$_apply(s_package$_Vector0(s_package$_MODULE$), sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData($java.oncius_TypeRange, [$java.oncius_TypeRange__init_0($newLower, s_Some__init_($java.oncius_TypeRange_lower($other))), $java.oncius_TypeRange__init_0($java.oncius_TypeRange_lower($other), s_None$_MODULE$)])));
            }
            if (!($java.oncius_TypeRange_lower($other)).$isAssignableFrom0($java.oncius_TypeRange_lower($this))) {
                s_package$_$callClinit();
                $other = s_package$_Vector0(s_package$_MODULE$);
                $u2 = sr_ScalaRunTime$_MODULE$;
                var$9 = $rt_createArray($java.oncius_TypeRange, 1);
                var$9.data[0] = $java.oncius_TypeRange__init_0($newLower, s_Some__init_($newLower));
                return sci_Vector$_apply($other, sr_ScalaRunTime$_wrapRefArray($u2, var$9));
            }
            s_package$_$callClinit();
            return sci_Vector$_apply(s_package$_Vector0(s_package$_MODULE$), sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData($java.oncius_TypeRange, [$java.oncius_TypeRange__init_0($newLower, s_Some__init_($java.oncius_TypeRange_lower($this))), $java.oncius_TypeRange__init_0($java.oncius_TypeRange_lower($this), s_None$_MODULE$)])));
        }
        $rt_throw(s_MatchError__init_($u2));
    };
    $java.oncius_TypeRange_reparent = function($this, $f) {
        return $java.oncius_TypeRange__init_0($f.$apply($this.$lower1), s_Option_map($this.$upper1, $f));
    };
    $java.oncius_TypeRange_productPrefix = function($this) {
        return $rt_s(2856);
    };
    $java.oncius_TypeRange_productArity = function($this) {
        return 2;
    };
    $java.oncius_TypeRange_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lower1;
            case 1:
                return $this.$upper1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncius_TypeRange_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_TypeRange_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_TypeRange_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncius_TypeRange_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncius_TypeRange) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lower1;
                        var$3 = $x$1.$lower1;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$upper1;
                        $x$1 = $x$1.$upper1;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncius_TypeRange))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncius_TypeRange__init_ = function($this, $lower, $upper) {
        $this.$lower1 = $lower;
        $this.$upper1 = $upper;
        s_Predef$_$callClinit();
        if (!s_Option_isEmpty($upper) && !$lower.$isAssignableFrom0($upper.$get0()) ? 0 : 1)
            return;
        $upper = new jl_AssertionError;
        $lower = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2($lower, 18);
        jl_AbstractStringBuilder_append1($lower, $rt_s(1038));
        jl_AssertionError__init_0($upper, jl_AbstractStringBuilder_toString(jl_StringBuilder_append($lower, $rt_s(2857))));
        $rt_throw($upper);
    };
    function oncius_TypeSpec() {
        jl_Object.call(this);
        this.$ranges = null;
    }
    $java.oncius_TypeSpec__init_0 = function(var_0) {
        var var_1 = new oncius_TypeSpec();
        $java.oncius_TypeSpec__init_(var_1, var_0);
        return var_1;
    };
    $java.oncius_TypeSpec_contains = function($this, $that) {
        return $java.oncius_TypeSpec_contains0($this, $that, $this.$ranges);
    };
    $java.oncius_TypeSpec_contains0 = function($this, $that, $rs) {
        var var$3;
        var$3 = new $java.oncius_TypeSpec$contains$lambda$_9_0;
        var$3.$_0520 = $that;
        return $rs.$exists(var$3);
    };
    $java.oncius_TypeSpec_containsAny = function($this, $that) {
        var var$2, var$3;
        var$2 = $this.$ranges;
        var$3 = new $java.oncius_TypeSpec$containsAny$lambda$_11_0;
        var$3.$_0521 = $that;
        return var$2.$exists(var$3);
    };
    $java.oncius_TypeSpec_containsAll = function($this, $that) {
        return oncius_TypeSpec_equals(oncius_TypeSpec_intersect($this, $that), $that);
    };
    $java.oncius_TypeSpec_union = function($this, $that) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(oncius_TypeSpec$_MODULE$, $this.$ranges.$concat0($that.$ranges));
    };
    $java.oncius_TypeSpec_$bar = function($this, $that) {
        return $java.oncius_TypeSpec_union($this, $that);
    };
    function oncius_TypeSpec_intersect($this, $that) {
        var var$2, var$3, var$4;
        oncius_TypeSpec$_$callClinit();
        var$2 = oncius_TypeSpec$_MODULE$;
        var$3 = $this.$ranges;
        var$4 = new $java.oncius_TypeSpec$intersect$lambda$_15_0;
        var$4.$_0522 = $that;
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(var$2, var$3.$flatMap(var$4));
    }
    $java.oncius_TypeSpec_coerceOrLeastUpperBound = function($this, $that) {
        var $coerced;
        $coerced = oncius_TypeSpec_intersect($java.oncius_TypeSpec_coercions($this), $that);
        if (oncius_TypeSpec_nonEmpty($coerced))
            return $coerced;
        return $java.oncius_TypeSpec_leastUpperBounds($this, $that);
    };
    $java.oncius_TypeSpec_without = function($this, $aType) {
        var var$2, var$3, var$4;
        oncius_TypeSpec$_$callClinit();
        var$2 = oncius_TypeSpec$_MODULE$;
        var$3 = $this.$ranges;
        var$4 = new $java.oncius_TypeSpec$without$lambda$_19_0;
        var$4.$_0523 = $aType;
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(var$2, var$3.$flatMap(var$4));
    };
    $java.oncius_TypeSpec_constrain = function($this, $that) {
        var var$2, var$3, var$4;
        oncius_TypeSpec$_$callClinit();
        var$2 = oncius_TypeSpec$_MODULE$;
        var$3 = $this.$ranges;
        var$4 = new $java.oncius_TypeSpec$constrain$lambda$_20_0;
        var$4.$_0524 = $that;
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(var$2, var$3.$flatMap(var$4));
    };
    $java.oncius_TypeSpec_leastUpperBounds = function($this, $that) {
        var var$2, var$3, var$4;
        oncius_TypeSpec$_$callClinit();
        var$2 = oncius_TypeSpec$_MODULE$;
        var$3 = $this.$ranges;
        var$4 = new $java.oncius_TypeSpec$leastUpperBounds$lambda$_22_0;
        var$4.$_0525 = $that;
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(var$2, var$3.$flatMap(var$4));
    };
    $java.oncius_TypeSpec_wrapInList = function($this) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(oncius_TypeSpec$_MODULE$, $this.$ranges.$map1(new $java.oncius_TypeSpec$wrapInList$lambda$_23_0));
    };
    $java.oncius_TypeSpec_covariant = function($this) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(oncius_TypeSpec$_MODULE$, $this.$ranges.$map1(new $java.oncius_TypeSpec$covariant$lambda$_25_0));
    };
    $java.oncius_TypeSpec_unwrapLists = function($this) {
        var $unwrapped;
        $unwrapped = $this.$ranges.$map1(new $java.oncius_TypeSpec$unwrapLists$lambda$_26_0);
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(oncius_TypeSpec$_MODULE$, $unwrapped);
    };
    $java.oncius_TypeSpec_coercions = function($this) {
        var $simpleCoercions;
        $simpleCoercions = $this.$ranges.$flatMap(new $java.oncius_TypeSpec$coercions$lambda$_28_0);
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_exact(oncius_TypeSpec$_MODULE$, $simpleCoercions);
    };
    function oncius_TypeSpec_nonEmpty($this) {
        return $this.$ranges.$isEmpty() ? 0 : 1;
    }
    $java.oncius_TypeSpec_toStream = function($this, $rs) {
        var var$2, var$3;
        if (($rs.$apply2()).$isEmpty()) {
            s_package$_$callClinit();
            return s_package$_Stream.$from0(sci_Nil$_MODULE$);
        }
        oncius_TypeSpec$_$callClinit();
        var$2 = $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$simpleTypes0(oncius_TypeSpec$_MODULE$);
        var$3 = new $java.oncius_TypeSpec$toStream$lambda$_34_0;
        var$3.$_0526 = $this;
        var$3.$_1172 = $rs;
        var$2 = sc_AbstractIterable_toStream(sc_StrictOptimizedIterableOps_filter$(var$2, var$3));
        var$3 = new $java.oncius_TypeSpec$toStream$lambda$_34_1;
        var$3.$_0527 = $this;
        var$3.$_1173 = $rs;
        return $java.sci_Stream_append(var$2, var$3);
    };
    $java.oncius_TypeSpec_hashCode = function($this) {
        return 41 * sc_AbstractSeq_hashCode($this.$ranges) | 0;
    };
    function oncius_TypeSpec_equals($this, $that) {
        var $infinite1, $finite2, $finite1, $infinite2, var$6;
        if (!($that instanceof oncius_TypeSpec))
            return 0;
        $that = $that;
        if ($this.$ranges.$isEmpty())
            return $that.$ranges.$isEmpty();
        a: {
            b: {
                c: {
                    if ($this instanceof oncius_TypeSpec) {
                        $infinite1 = $this.$ranges.$partition(new $java.oncius_TypeSpec$equals$lambda$_37_0);
                        if ($infinite1 === null)
                            $rt_throw(s_MatchError__init_($infinite1));
                        $finite2 = s_Tuple2__init_($infinite1.$_10, $infinite1.$_20);
                        $finite1 = $finite2.$_10;
                        $infinite1 = $finite2.$_20;
                        $that = $that.$ranges.$partition(new $java.oncius_TypeSpec$equals$lambda$_37_1);
                        if ($that === null)
                            $rt_throw(s_MatchError__init_($that));
                        d: {
                            $that = s_Tuple2__init_($that.$_10, $that.$_20);
                            $finite2 = $that.$_10;
                            $infinite2 = $that.$_20;
                            if ($infinite1 !== null) {
                                if (!$infinite1.$equals($infinite2))
                                    break c;
                                else
                                    break d;
                            }
                            if ($infinite2 !== null)
                                break c;
                        }
                        e: {
                            if ($finite1 !== null) {
                                if ($finite1.$equals($finite2))
                                    break b;
                                else
                                    break e;
                            }
                            if ($finite2 === null)
                                break b;
                        }
                        $that = new $java.oncius_TypeSpec$equals$lambda$_37_2;
                        $that.$_0528 = $finite1;
                        $infinite1 = $java.oncius_TypeSpec_toStream($this, $that);
                        $that = new $java.oncius_TypeSpec$equals$lambda$_37_3;
                        $that.$_0529 = $finite2;
                        $that = $java.oncius_TypeSpec_toStream($this, $that);
                        if ($infinite1 === null) {
                            if ($that === null)
                                break b;
                        } else if (sc_Seq_equals$($infinite1, $that))
                            break b;
                    }
                }
                var$6 = 0;
                break a;
            }
            var$6 = 1;
        }
        return var$6;
    }
    $java.oncius_TypeSpec_mkString = function($this, $sep) {
        return $java.oncius_TypeSpec_mkString0($this, $rt_s(3), $sep, $sep, $rt_s(3));
    };
    function oncius_TypeSpec_mkString($this, $sep, $lastSep) {
        return $java.oncius_TypeSpec_mkString0($this, $rt_s(3), $sep, $lastSep, $rt_s(3));
    }
    $java.oncius_TypeSpec_mkString0 = function($this, $start, $sep, $lastSep, $end) {
        var var$5, var$6, var$7, var$8, var$9, var$10;
        var$5 = scm_StringBuilder__init_();
        s_package$_$callClinit();
        var$6 = sci_Vector$_empty(s_package$_Vector0(s_package$_MODULE$));
        var$7 = $this.$ranges;
        var$8 = new $java.oncius_TypeSpec$toStrings$lambda$_39_0;
        a: {
            while (!var$7.$isEmpty()) {
                if (var$7.$exists(new $java.oncius_TypeSpec$toStrings$lambda$_40_0)) {
                    var$6 = var$6.$appended(var$8.$apply($rt_s(2858)));
                    break a;
                }
                oncius_TypeSpec$_$callClinit();
                var$9 = $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$simpleTypes0(oncius_TypeSpec$_MODULE$);
                var$10 = new $java.oncius_TypeSpec$toStrings$lambda$_40_1;
                var$10.$_0530 = $this;
                var$10.$_1174 = var$7;
                var$10 = sc_StrictOptimizedIterableOps_filter$(var$9, var$10);
                var$9 = new $java.oncius_TypeSpec$toStrings$lambda$_40_2;
                var$9.$_0531 = var$8;
                var$6 = var$6.$concat0(var$10.$map1(var$9));
                var$7 = $java.oncius_TypeSpec_innerTypeRanges($this, var$7);
                var$10 = new $java.oncius_TypeSpec$toStrings$lambda$_40_3;
                var$10.$_0532 = var$8;
                var$8 = var$10;
            }
        }
        return scm_StringBuilder_result(var$6.$length() <= 1 ? var$6.$addString(var$5, $start, $sep, $end) : scm_StringBuilder_append(scm_StringBuilder_append(scm_StringBuilder_append((var$6.$dropRight(1)).$addString(var$5, $start, $sep, $rt_s(3)), $lastSep), var$6.$last()), $end));
    };
    $java.oncius_TypeSpec_toString = function($this) {
        return $java.oncius_TypeSpec_mkString0($this, $rt_s(2859), $rt_s(16), $rt_s(16), $rt_s(25));
    };
    $java.oncius_TypeSpec_toShortString = function($this) {
        return $java.oncius_TypeSpec_mkString0($this, $rt_s(3), $rt_s(155), $rt_s(155), $rt_s(3));
    };
    $java.oncius_TypeSpec_innerTypeRanges = function($this, $rs) {
        return $rs.$flatMap(new $java.oncius_TypeSpec$innerTypeRanges$lambda$_48_0);
    };
    $java.oncius_TypeSpec__init_ = function($this, $ranges) {
        $this.$ranges = $ranges;
    };
    $java.jur_SpecialToken = $rt_classWithoutFields();
    function jur_AbstractCharClass() {
        var a = this; $java.jur_SpecialToken.call(a);
        a.$alt0 = 0;
        a.$altSurrogates = 0;
        a.$lowHighSurrogates = null;
        a.$charClassWithoutSurrogates = null;
        a.$charClassWithSurrogates = null;
        a.$mayContainSupplCodepoints = 0;
    }
    $java.jur_AbstractCharClass_charClasses = null;
    $java.jur_AbstractCharClass__init_ = function($this) {
        var var$1;
        var$1 = new $java.ju_BitSet;
        var$1.$data1 = $rt_createIntArray(64);
        $this.$lowHighSurrogates = var$1;
    };
    $java.jur_AbstractCharClass_getBits = function($this) {
        return null;
    };
    $java.jur_AbstractCharClass_getLowHighSurrogates = function($this) {
        return $this.$lowHighSurrogates;
    };
    $java.jur_AbstractCharClass_hasLowHighSurrogates = function($this) {
        var var$1, var$2, var$3, var$4, var$5;
        if (!$this.$altSurrogates)
            var$1 = $java.ju_BitSet_nextSetBit($this.$lowHighSurrogates, 0) >= 2048 ? 0 : 1;
        else {
            a: {
                var$2 = $this.$lowHighSurrogates;
                var$1 = 0;
                var$3 = var$2.$length7;
                if (var$1 < var$3) {
                    var$4 = var$2.$data1.data;
                    var$5 = (var$4[0] ^ (-1)) >>> 0;
                    if (var$5)
                        var$1 = jl_Integer_numberOfTrailingZeros(var$5) + var$1 | 0;
                    else {
                        var$1 = (var$3 + 31 | 0) / 32 | 0;
                        var$5 = 1;
                        while (var$5 < var$1) {
                            if (var$4[var$5] != (-1)) {
                                var$1 = (var$5 * 32 | 0) + jl_Integer_numberOfTrailingZeros(var$4[var$5] ^ (-1)) | 0;
                                break a;
                            }
                            var$5 = var$5 + 1 | 0;
                        }
                        var$1 = var$3;
                    }
                }
            }
            var$1 = var$1 >= 2048 ? 0 : 1;
        }
        return var$1;
    };
    $java.jur_AbstractCharClass_mayContainSupplCodepoints = function($this) {
        return $this.$mayContainSupplCodepoints;
    };
    $java.jur_AbstractCharClass_getInstance = function($this) {
        return $this;
    };
    $java.jur_AbstractCharClass_getSurrogates = function($this) {
        var $lHS, var$2;
        if ($this.$charClassWithSurrogates === null) {
            $lHS = $this.$getLowHighSurrogates();
            var$2 = new $java.jur_AbstractCharClass$1;
            var$2.$this$05 = $this;
            var$2.$val$lHS = $lHS;
            $java.jur_AbstractCharClass__init_(var$2);
            $this.$charClassWithSurrogates = var$2;
            $java.jur_AbstractCharClass_setNegative(var$2, $this.$altSurrogates);
        }
        return $this.$charClassWithSurrogates;
    };
    $java.jur_AbstractCharClass_getWithoutSurrogates = function($this) {
        var $lHS, var$2;
        if ($this.$charClassWithoutSurrogates === null) {
            $lHS = $this.$getLowHighSurrogates();
            var$2 = new $java.jur_AbstractCharClass$2;
            var$2.$this$06 = $this;
            var$2.$val$lHS0 = $lHS;
            var$2.$val$thisClass = $this;
            $java.jur_AbstractCharClass__init_(var$2);
            $this.$charClassWithoutSurrogates = var$2;
            $java.jur_AbstractCharClass_setNegative(var$2, $this.$alt0);
            $this.$charClassWithoutSurrogates.$mayContainSupplCodepoints = $this.$mayContainSupplCodepoints;
        }
        return $this.$charClassWithoutSurrogates;
    };
    $java.jur_AbstractCharClass_hasUCI = function($this) {
        return 0;
    };
    $java.jur_AbstractCharClass_setNegative = function($this, $value) {
        var var$2;
        var$2 = $this.$alt0;
        if (var$2 ^ $value) {
            $this.$alt0 = var$2 ? 0 : 1;
            $this.$altSurrogates = $this.$altSurrogates ? 0 : 1;
        }
        if (!$this.$mayContainSupplCodepoints)
            $this.$mayContainSupplCodepoints = 1;
        return $this;
    };
    $java.jur_AbstractCharClass_isNegative = function($this) {
        return $this.$alt0;
    };
    $java.jur_AbstractCharClass_intersects = function($cc1, $cc2) {
        var var$3, var$4;
        if ($cc1.$getBits() !== null && $cc2.$getBits() !== null) {
            $cc1 = $cc1.$getBits();
            $cc2 = $cc2.$getBits();
            var$3 = jl_Math_min($cc1.$data1.data.length, $cc2.$data1.data.length);
            var$4 = 0;
            a: {
                while (var$4 < var$3) {
                    if ($cc1.$data1.data[var$4] & $cc2.$data1.data[var$4]) {
                        var$3 = 1;
                        break a;
                    }
                    var$4 = var$4 + 1 | 0;
                }
                var$3 = 0;
            }
            return var$3;
        }
        return 1;
    };
    $java.jur_AbstractCharClass_getPredefinedClass = function($name, $negative) {
        var var$3, var$4, var$5;
        var$3 = 0;
        while (true) {
            var$4 = $java.jur_AbstractCharClass$PredefinedCharacterClasses_contents.data;
            if (var$3 >= var$4.length) {
                var$5 = new $java.ju_MissingResourceException;
                jl_Throwable__init_(var$5, $rt_s(3));
                var$5.$className0 = $rt_s(3);
                var$5.$key5 = $name;
                $rt_throw(var$5);
            }
            var$4 = var$4[var$3].data;
            if (jl_String_equals($name, var$4[0]))
                break;
            var$3 = var$3 + 1 | 0;
        }
        return $java.jur_AbstractCharClass$LazyCharClass_getValue(var$4[1], $negative);
    };
    function jur_AbstractCharClass__clinit_() {
        $java.jur_AbstractCharClass_charClasses = new jur_AbstractCharClass$PredefinedCharacterClasses;
    }
    $java.jur_CharClass = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$ci = 0;
        a.$uci = 0;
        a.$hasUCI0 = 0;
        a.$invertedSurrogates = 0;
        a.$inverted = 0;
        a.$hideBits = 0;
        a.$bits0 = null;
        a.$nonBitSet = null;
    };
    $java.jur_CharClass__init_0 = function() {
        var var_0 = new $java.jur_CharClass();
        $java.jur_CharClass__init_1(var_0);
        return var_0;
    };
    $java.jur_CharClass__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_CharClass();
        $java.jur_CharClass__init_2(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_CharClass__init_1 = function($this) {
        $java.jur_AbstractCharClass__init_($this);
        $this.$bits0 = $java.ju_BitSet__init_();
    };
    $java.jur_CharClass__init_2 = function($this, $ci, $uci) {
        $java.jur_AbstractCharClass__init_($this);
        $this.$bits0 = $java.ju_BitSet__init_();
        $this.$ci = $ci;
        $this.$uci = $uci;
    };
    $java.jur_CharClass_add = function($this, $ch) {
        a: {
            if ($this.$ci) {
                b: {
                    if (!($ch >= 97 && $ch <= 122)) {
                        if ($ch < 65)
                            break b;
                        if ($ch > 90)
                            break b;
                    }
                    if ($this.$inverted) {
                        $java.ju_BitSet_clear($this.$bits0, $java.jur_Pattern_getSupplement($ch & 65535));
                        break a;
                    }
                    $java.ju_BitSet_set($this.$bits0, $java.jur_Pattern_getSupplement($ch & 65535));
                    break a;
                }
                if ($this.$uci && $ch > 128) {
                    $this.$hasUCI0 = 1;
                    $ch = jl_Character_toLowerCase0(jl_Character_toUpperCase($ch));
                }
            }
        }
        if (!(!$java.jur_Lexer_isHighSurrogate0($ch) && !$java.jur_Lexer_isLowSurrogate0($ch))) {
            if ($this.$invertedSurrogates)
                $java.ju_BitSet_clear($this.$lowHighSurrogates, $ch - 55296 | 0);
            else
                $java.ju_BitSet_set($this.$lowHighSurrogates, $ch - 55296 | 0);
        }
        if ($this.$inverted)
            $java.ju_BitSet_clear($this.$bits0, $ch);
        else
            $java.ju_BitSet_set($this.$bits0, $ch);
        if (!$this.$mayContainSupplCodepoints && jl_Character_isSupplementaryCodePoint($ch))
            $this.$mayContainSupplCodepoints = 1;
        return $this;
    };
    $java.jur_CharClass_add1 = function($this, $cc) {
        var $curAlt, $nb, var$4;
        if (!$this.$mayContainSupplCodepoints && $cc.$mayContainSupplCodepoints)
            $this.$mayContainSupplCodepoints = 1;
        if ($this.$invertedSurrogates) {
            if (!$cc.$altSurrogates)
                $java.ju_BitSet_andNot($this.$lowHighSurrogates, $cc.$getLowHighSurrogates());
            else
                $java.ju_BitSet_and($this.$lowHighSurrogates, $cc.$getLowHighSurrogates());
        } else if (!$cc.$altSurrogates)
            $java.ju_BitSet_or($this.$lowHighSurrogates, $cc.$getLowHighSurrogates());
        else {
            $java.ju_BitSet_xor($this.$lowHighSurrogates, $cc.$getLowHighSurrogates());
            $java.ju_BitSet_and($this.$lowHighSurrogates, $cc.$getLowHighSurrogates());
            $this.$altSurrogates = $this.$altSurrogates ? 0 : 1;
            $this.$invertedSurrogates = 1;
        }
        if (!$this.$hideBits && $cc.$getBits() !== null) {
            if ($this.$inverted) {
                if (!$cc.$alt0)
                    $java.ju_BitSet_andNot($this.$bits0, $cc.$getBits());
                else
                    $java.ju_BitSet_and($this.$bits0, $cc.$getBits());
            } else if (!$cc.$alt0)
                $java.ju_BitSet_or($this.$bits0, $cc.$getBits());
            else {
                $java.ju_BitSet_xor($this.$bits0, $cc.$getBits());
                $java.ju_BitSet_and($this.$bits0, $cc.$getBits());
                $this.$alt0 = $this.$alt0 ? 0 : 1;
                $this.$inverted = 1;
            }
        } else {
            $curAlt = $this.$alt0;
            $nb = $this.$nonBitSet;
            if ($nb !== null) {
                if (!$curAlt) {
                    var$4 = new $java.jur_CharClass$5;
                    var$4.$this$07 = $this;
                    var$4.$val$curAlt = $curAlt;
                    var$4.$val$nb = $nb;
                    var$4.$val$cc = $cc;
                    $java.jur_AbstractCharClass__init_(var$4);
                    $this.$nonBitSet = var$4;
                } else {
                    var$4 = new $java.jur_CharClass$4;
                    var$4.$this$08 = $this;
                    var$4.$val$curAlt0 = $curAlt;
                    var$4.$val$nb0 = $nb;
                    var$4.$val$cc0 = $cc;
                    $java.jur_AbstractCharClass__init_(var$4);
                    $this.$nonBitSet = var$4;
                }
            } else {
                if ($curAlt && !$this.$inverted && $java.ju_BitSet_isEmpty($this.$bits0)) {
                    $nb = new $java.jur_CharClass$1;
                    $nb.$this$09 = $this;
                    $nb.$val$cc1 = $cc;
                    $java.jur_AbstractCharClass__init_($nb);
                    $this.$nonBitSet = $nb;
                } else if (!$curAlt) {
                    $nb = new $java.jur_CharClass$3;
                    $nb.$this$010 = $this;
                    $nb.$val$curAlt1 = $curAlt;
                    $nb.$val$cc2 = $cc;
                    $java.jur_AbstractCharClass__init_($nb);
                    $this.$nonBitSet = $nb;
                } else {
                    $nb = new $java.jur_CharClass$2;
                    $nb.$this$011 = $this;
                    $nb.$val$curAlt2 = $curAlt;
                    $nb.$val$cc3 = $cc;
                    $java.jur_AbstractCharClass__init_($nb);
                    $this.$nonBitSet = $nb;
                }
                $this.$hideBits = 1;
            }
        }
        return $this;
    };
    $java.jur_CharClass_add0 = function($this, $i, $end) {
        var var$3, var$4, var$5, var$6;
        if ($i > $end) {
            var$3 = new jl_IllegalArgumentException;
            jl_Throwable__init_0(var$3);
            $rt_throw(var$3);
        }
        a: {
            b: {
                if (!$this.$ci) {
                    if ($end < 55296)
                        break b;
                    if ($i > 57343)
                        break b;
                }
                $end = $end + 1 | 0;
                while (true) {
                    if ($i >= $end)
                        break a;
                    $java.jur_CharClass_add($this, $i);
                    $i = $i + 1 | 0;
                }
            }
            if (!$this.$inverted)
                $java.ju_BitSet_set0($this.$bits0, $i, $end + 1 | 0);
            else {
                var$3 = $this.$bits0;
                $end = $end + 1 | 0;
                if ($i > $end) {
                    var$3 = new jl_IndexOutOfBoundsException;
                    jl_Throwable__init_0(var$3);
                    $rt_throw(var$3);
                }
                var$4 = var$3.$length7;
                if ($i < var$4) {
                    var$4 = jl_Math_min(var$4, $end);
                    var$5 = $i / 32 | 0;
                    $end = var$4 / 32 | 0;
                    if (var$5 == $end) {
                        var$6 = var$3.$data1.data;
                        var$6[var$5] = var$6[var$5] & ($java.ju_BitSet_trailingOneBits(var$3, $i) | $java.ju_BitSet_trailingZeroBits(var$3, var$4));
                    } else {
                        var$6 = var$3.$data1.data;
                        var$6[var$5] = var$6[var$5] & $java.ju_BitSet_trailingOneBits(var$3, $i);
                        var$5 = var$5 + 1 | 0;
                        while (var$5 < $end) {
                            var$3.$data1.data[var$5] = 0;
                            var$5 = var$5 + 1 | 0;
                        }
                        if (var$4 & 31) {
                            var$6 = var$3.$data1.data;
                            var$6[$end] = var$6[$end] & $java.ju_BitSet_trailingZeroBits(var$3, var$4);
                        }
                    }
                    $java.ju_BitSet_recalculateLength(var$3);
                }
            }
        }
        return $this;
    };
    $java.jur_CharClass_union = function($this, $clazz) {
        var $curAlt, $nb, var$4;
        if (!$this.$mayContainSupplCodepoints && $clazz.$mayContainSupplCodepoints)
            $this.$mayContainSupplCodepoints = 1;
        if ($clazz.$hasUCI0)
            $this.$hasUCI0 = 1;
        $curAlt = $this.$altSurrogates;
        if (!($curAlt ^ $clazz.$altSurrogates)) {
            if (!$curAlt)
                $java.ju_BitSet_or($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
            else
                $java.ju_BitSet_and($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
        } else if ($curAlt)
            $java.ju_BitSet_andNot($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
        else {
            $java.ju_BitSet_xor($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
            $java.ju_BitSet_and($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
            $this.$altSurrogates = 1;
        }
        if (!$this.$hideBits && $java.jur_CharClass_getBits($clazz) !== null) {
            $curAlt = $this.$alt0;
            if (!($curAlt ^ $clazz.$alt0)) {
                if (!$curAlt)
                    $java.ju_BitSet_or($this.$bits0, $java.jur_CharClass_getBits($clazz));
                else
                    $java.ju_BitSet_and($this.$bits0, $java.jur_CharClass_getBits($clazz));
            } else if ($curAlt)
                $java.ju_BitSet_andNot($this.$bits0, $java.jur_CharClass_getBits($clazz));
            else {
                $java.ju_BitSet_xor($this.$bits0, $java.jur_CharClass_getBits($clazz));
                $java.ju_BitSet_and($this.$bits0, $java.jur_CharClass_getBits($clazz));
                $this.$alt0 = 1;
            }
        } else {
            $curAlt = $this.$alt0;
            $nb = $this.$nonBitSet;
            if ($nb !== null) {
                if (!$curAlt) {
                    var$4 = new $java.jur_CharClass$11;
                    var$4.$this$012 = $this;
                    var$4.$val$curAlt3 = $curAlt;
                    var$4.$val$nb1 = $nb;
                    var$4.$val$clazz = $clazz;
                    $java.jur_AbstractCharClass__init_(var$4);
                    $this.$nonBitSet = var$4;
                } else {
                    var$4 = new $java.jur_CharClass$10;
                    var$4.$this$013 = $this;
                    var$4.$val$curAlt4 = $curAlt;
                    var$4.$val$nb2 = $nb;
                    var$4.$val$clazz0 = $clazz;
                    $java.jur_AbstractCharClass__init_(var$4);
                    $this.$nonBitSet = var$4;
                }
            } else {
                if (!$this.$inverted && $java.ju_BitSet_isEmpty($this.$bits0)) {
                    if (!$curAlt) {
                        $nb = new $java.jur_CharClass$7;
                        $nb.$this$014 = $this;
                        $nb.$val$clazz1 = $clazz;
                        $java.jur_AbstractCharClass__init_($nb);
                        $this.$nonBitSet = $nb;
                    } else {
                        $nb = new $java.jur_CharClass$6;
                        $nb.$this$015 = $this;
                        $nb.$val$clazz2 = $clazz;
                        $java.jur_AbstractCharClass__init_($nb);
                        $this.$nonBitSet = $nb;
                    }
                } else if (!$curAlt) {
                    $nb = new $java.jur_CharClass$9;
                    $nb.$this$016 = $this;
                    $nb.$val$clazz3 = $clazz;
                    $nb.$val$curAlt5 = $curAlt;
                    $java.jur_AbstractCharClass__init_($nb);
                    $this.$nonBitSet = $nb;
                } else {
                    $nb = new $java.jur_CharClass$8;
                    $nb.$this$017 = $this;
                    $nb.$val$clazz4 = $clazz;
                    $nb.$val$curAlt6 = $curAlt;
                    $java.jur_AbstractCharClass__init_($nb);
                    $this.$nonBitSet = $nb;
                }
                $this.$hideBits = 1;
            }
        }
    };
    $java.jur_CharClass_intersection = function($this, $clazz) {
        var $curAlt, $nb, var$4;
        if (!$this.$mayContainSupplCodepoints && $clazz.$mayContainSupplCodepoints)
            $this.$mayContainSupplCodepoints = 1;
        if ($clazz.$hasUCI0)
            $this.$hasUCI0 = 1;
        $curAlt = $this.$altSurrogates;
        if (!($curAlt ^ $clazz.$altSurrogates)) {
            if (!$curAlt)
                $java.ju_BitSet_and($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
            else
                $java.ju_BitSet_or($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
        } else if (!$curAlt)
            $java.ju_BitSet_andNot($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
        else {
            $java.ju_BitSet_xor($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
            $java.ju_BitSet_and($this.$lowHighSurrogates, $clazz.$lowHighSurrogates);
            $this.$altSurrogates = 0;
        }
        if (!$this.$hideBits && $java.jur_CharClass_getBits($clazz) !== null) {
            $curAlt = $this.$alt0;
            if (!($curAlt ^ $clazz.$alt0)) {
                if (!$curAlt)
                    $java.ju_BitSet_and($this.$bits0, $java.jur_CharClass_getBits($clazz));
                else
                    $java.ju_BitSet_or($this.$bits0, $java.jur_CharClass_getBits($clazz));
            } else if (!$curAlt)
                $java.ju_BitSet_andNot($this.$bits0, $java.jur_CharClass_getBits($clazz));
            else {
                $java.ju_BitSet_xor($this.$bits0, $java.jur_CharClass_getBits($clazz));
                $java.ju_BitSet_and($this.$bits0, $java.jur_CharClass_getBits($clazz));
                $this.$alt0 = 0;
            }
        } else {
            $curAlt = $this.$alt0;
            $nb = $this.$nonBitSet;
            if ($nb !== null) {
                if (!$curAlt) {
                    var$4 = new $java.jur_CharClass$17;
                    var$4.$this$018 = $this;
                    var$4.$val$curAlt7 = $curAlt;
                    var$4.$val$nb3 = $nb;
                    var$4.$val$clazz5 = $clazz;
                    $java.jur_AbstractCharClass__init_(var$4);
                    $this.$nonBitSet = var$4;
                } else {
                    var$4 = new $java.jur_CharClass$16;
                    var$4.$this$019 = $this;
                    var$4.$val$curAlt8 = $curAlt;
                    var$4.$val$nb4 = $nb;
                    var$4.$val$clazz6 = $clazz;
                    $java.jur_AbstractCharClass__init_(var$4);
                    $this.$nonBitSet = var$4;
                }
            } else {
                if (!$this.$inverted && $java.ju_BitSet_isEmpty($this.$bits0)) {
                    if (!$curAlt) {
                        $nb = new $java.jur_CharClass$13;
                        $nb.$this$020 = $this;
                        $nb.$val$clazz7 = $clazz;
                        $java.jur_AbstractCharClass__init_($nb);
                        $this.$nonBitSet = $nb;
                    } else {
                        $nb = new $java.jur_CharClass$12;
                        $nb.$this$021 = $this;
                        $nb.$val$clazz8 = $clazz;
                        $java.jur_AbstractCharClass__init_($nb);
                        $this.$nonBitSet = $nb;
                    }
                } else if (!$curAlt) {
                    $nb = new $java.jur_CharClass$15;
                    $nb.$this$022 = $this;
                    $nb.$val$clazz9 = $clazz;
                    $nb.$val$curAlt9 = $curAlt;
                    $java.jur_AbstractCharClass__init_($nb);
                    $this.$nonBitSet = $nb;
                } else {
                    $nb = new $java.jur_CharClass$14;
                    $nb.$this$023 = $this;
                    $nb.$val$clazz10 = $clazz;
                    $nb.$val$curAlt10 = $curAlt;
                    $java.jur_AbstractCharClass__init_($nb);
                    $this.$nonBitSet = $nb;
                }
                $this.$hideBits = 1;
            }
        }
    };
    $java.jur_CharClass_contains = function($this, $ch) {
        var var$2;
        var$2 = $this.$nonBitSet;
        if (var$2 !== null)
            return $this.$alt0 ^ var$2.$contains2($ch);
        return $this.$alt0 ^ $java.ju_BitSet_get($this.$bits0, $ch);
    };
    $java.jur_CharClass_getBits = function($this) {
        if (!$this.$hideBits)
            return $this.$bits0;
        return null;
    };
    $java.jur_CharClass_getLowHighSurrogates = function($this) {
        return $this.$lowHighSurrogates;
    };
    $java.jur_CharClass_getInstance = function($this) {
        var $bs, $res;
        if ($this.$nonBitSet !== null)
            return $this;
        $bs = $java.jur_CharClass_getBits($this);
        $res = new $java.jur_CharClass$18;
        $res.$this$024 = $this;
        $res.$val$bs = $bs;
        $java.jur_AbstractCharClass__init_($res);
        return $java.jur_AbstractCharClass_setNegative($res, $this.$alt0);
    };
    $java.jur_CharClass_toString = function($this) {
        var $temp, $i, var$3;
        $temp = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($temp);
        $i = $java.ju_BitSet_nextSetBit($this.$bits0, 0);
        while ($i >= 0) {
            jl_AbstractStringBuilder_append5($temp, jl_Character_toChars($i));
            jl_AbstractStringBuilder_append($temp, 124);
            $i = $java.ju_BitSet_nextSetBit($this.$bits0, $i + 1 | 0);
        }
        var$3 = $temp.$length0;
        if (var$3 > 0)
            jl_StringBuilder_deleteCharAt($temp, var$3 - 1 | 0);
        return jl_AbstractStringBuilder_toString($temp);
    };
    $java.jur_CharClass_hasUCI = function($this) {
        return $this.$hasUCI0;
    };
    $java.ju_MissingResourceException = function() {
        var a = this; jl_RuntimeException.call(a);
        a.$className0 = null;
        a.$key5 = null;
    };
    $java.jur_QuantifierSet = function() {
        jur_AbstractSet.call(this);
        this.$innerSet = null;
    };
    $java.jur_QuantifierSet__init_ = function($this, $innerSet, $next, $type) {
        $java.jur_AbstractSet__init_0($this, $next);
        $this.$innerSet = $innerSet;
        $this.$type0 = $type;
    };
    $java.jur_QuantifierSet_getInnerSet = function($this) {
        return $this.$innerSet;
    };
    $java.jur_QuantifierSet_first = function($this, $set) {
        return !$this.$innerSet.$first4($set) && !$this.$next12.$first4($set) ? 0 : 1;
    };
    $java.jur_QuantifierSet_hasConsumed = function($this, $mr) {
        return 1;
    };
    $java.jur_QuantifierSet_processSecondPass = function($this) {
        var $set;
        $this.$isSecondPassVisited = 1;
        $set = $this.$next12;
        if ($set !== null && !$set.$isSecondPassVisited) {
            $set = $set.$processBackRefReplacement();
            if ($set !== null) {
                $this.$next12.$isSecondPassVisited = 1;
                $this.$next12 = $set;
            }
            $this.$next12.$processSecondPass();
        }
        $set = $this.$innerSet;
        if ($set !== null) {
            if (!$set.$isSecondPassVisited) {
                $set = $set.$processBackRefReplacement();
                if ($set !== null) {
                    $this.$innerSet.$isSecondPassVisited = 1;
                    $this.$innerSet = $set;
                }
                $this.$innerSet.$processSecondPass();
            } else if ($set instanceof $java.jur_SingleSet && $set.$fSet.$isBackReferenced)
                $this.$innerSet = $set.$next12;
        }
    };
    $java.jur_LeafQuantifierSet = function() {
        $java.jur_QuantifierSet.call(this);
        this.$leaf0 = null;
    };
    $java.jur_LeafQuantifierSet__init_0 = function(var_0, var_1, var_2) {
        var var_3 = new $java.jur_LeafQuantifierSet();
        $java.jur_LeafQuantifierSet__init_(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.jur_LeafQuantifierSet__init_ = function($this, $innerSet, $next, $type) {
        $java.jur_QuantifierSet__init_($this, $innerSet, $next, $type);
        $this.$leaf0 = $innerSet;
    };
    $java.jur_LeafQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $i, var$5;
        $i = 0;
        a: {
            while (($stringIndex + $this.$leaf0.$charCount0() | 0) <= $matchResult.$rightBound0) {
                var$5 = $this.$leaf0.$accepts($stringIndex, $testString);
                if (var$5 <= 0)
                    break a;
                $stringIndex = $stringIndex + var$5 | 0;
                $i = $i + 1 | 0;
            }
        }
        while (true) {
            if ($i < 0)
                return (-1);
            var$5 = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            if (var$5 >= 0)
                break;
            $stringIndex = $stringIndex - $this.$leaf0.$charCount0() | 0;
            $i = $i + (-1) | 0;
        }
        return var$5;
    };
    $java.jur_LeafQuantifierSet_getName = function($this) {
        return $rt_s(2860);
    };
    $java.jur_CompositeQuantifierSet = function() {
        $java.jur_LeafQuantifierSet.call(this);
        this.$quantifier0 = null;
    };
    $java.jur_CompositeQuantifierSet__init_0 = function(var_0, var_1, var_2, var_3) {
        var var_4 = new $java.jur_CompositeQuantifierSet();
        $java.jur_CompositeQuantifierSet__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    $java.jur_CompositeQuantifierSet__init_ = function($this, $quant, $innerSet, $next, $type) {
        $java.jur_LeafQuantifierSet__init_($this, $innerSet, $next, $type);
        $this.$quantifier0 = $quant;
    };
    $java.jur_CompositeQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var var$4, $min, $max, $i, $shift;
        var$4 = $this.$quantifier0;
        $min = var$4.$min2;
        $max = var$4.$max3;
        $i = 0;
        while (true) {
            if ($i >= $min) {
                a: {
                    while ($i < $max) {
                        if (($stringIndex + $this.$leaf0.$charCount0() | 0) > $matchResult.$rightBound0)
                            break a;
                        $shift = $this.$leaf0.$accepts($stringIndex, $testString);
                        if ($shift < 1)
                            break a;
                        $stringIndex = $stringIndex + $shift | 0;
                        $i = $i + 1 | 0;
                    }
                }
                while (true) {
                    if ($i < $min)
                        return (-1);
                    $shift = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
                    if ($shift >= 0)
                        break;
                    $stringIndex = $stringIndex - $this.$leaf0.$charCount0() | 0;
                    $i = $i + (-1) | 0;
                }
                return $shift;
            }
            if (($stringIndex + $this.$leaf0.$charCount0() | 0) > $matchResult.$rightBound0) {
                $matchResult.$hitEnd = 1;
                return (-1);
            }
            $shift = $this.$leaf0.$accepts($stringIndex, $testString);
            if ($shift < 1)
                break;
            $stringIndex = $stringIndex + $shift | 0;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_CompositeQuantifierSet_getName = function($this) {
        return $java.jur_Quantifier_toString($this.$quantifier0);
    };
    $java.jur_GroupQuantifierSet = $rt_classWithoutFields($java.jur_QuantifierSet);
    $java.jur_GroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $nextIndex;
        if (!$this.$innerSet.$hasConsumed($matchResult))
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        if ($nextIndex >= 0)
            return $nextIndex;
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_GroupQuantifierSet_getName = function($this) {
        return $rt_s(2861);
    };
    $java.jur_AltQuantifierSet = $rt_classWithoutFields($java.jur_LeafQuantifierSet);
    $java.jur_AltQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $shift;
        $shift = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        if ($shift < 0)
            $shift = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        return $shift;
    };
    $java.jur_AltQuantifierSet_setNext = function($this, $next) {
        $this.$next12 = $next;
        $this.$innerSet.$setNext($next);
    };
    $java.jur_UnifiedQuantifierSet = $rt_classWithoutFields($java.jur_LeafQuantifierSet);
    $java.jur_UnifiedQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        while (($stringIndex + $this.$leaf0.$charCount0() | 0) <= $matchResult.$rightBound0 && $this.$leaf0.$accepts($stringIndex, $testString) > 0) {
            $stringIndex = $stringIndex + $this.$leaf0.$charCount0() | 0;
        }
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_UnifiedQuantifierSet_find = function($this, $stringIndex, $testString, $matchResult) {
        var $startSearch, $newSearch, $newSearch_0;
        $startSearch = $this.$next12.$find1($stringIndex, $testString, $matchResult);
        if ($startSearch < 0)
            return (-1);
        $newSearch = $startSearch - $this.$leaf0.$charCount0() | 0;
        while ($newSearch >= $stringIndex && $this.$leaf0.$accepts($newSearch, $testString) > 0) {
            $newSearch_0 = $newSearch - $this.$leaf0.$charCount0() | 0;
            $startSearch = $newSearch;
            $newSearch = $newSearch_0;
        }
        return $startSearch;
    };
    $java.oncius_TypeRange$_init_$lambda$_43_0 = $rt_classWithoutFields();
    $java.jur_AbstractCharClass$LazyCharClass = function() {
        var a = this; jl_Object.call(a);
        a.$posValue = null;
        a.$negValue = null;
    };
    $java.jur_AbstractCharClass$LazyCharClass_getValue = function($this, $negative) {
        if (!$negative && $this.$posValue === null)
            $this.$posValue = $this.$computeValue0();
        else if ($negative && $this.$negValue === null)
            $this.$negValue = $java.jur_AbstractCharClass_setNegative($this.$computeValue0(), 1);
        if ($negative)
            return $this.$negValue;
        return $this.$posValue;
    };
    $java.jur_Quantifier = function() {
        var a = this; $java.jur_SpecialToken.call(a);
        a.$min2 = 0;
        a.$max3 = 0;
    };
    $java.jur_Quantifier_toString = function($this) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = $this.$min2;
        var$2 = $this.$max3;
        var$3 = var$2 == 2147483647 ? $rt_s(3) : jl_Integer_toString1(jl_Integer__init_(var$2));
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(var$4, 123);
        var$5 = jl_StringBuilder_append0(var$4, var$1);
        jl_AbstractStringBuilder_append(var$5, 44);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$5, var$3), 125);
        return jl_AbstractStringBuilder_toString(var$4);
    };
    $java.jur_FSet$PossessiveFSet = $rt_classWithoutFields(jur_AbstractSet);
    $java.jur_FSet$PossessiveFSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        return $stringIndex;
    };
    $java.jur_FSet$PossessiveFSet_getName = function($this) {
        return $rt_s(2862);
    };
    $java.jur_FSet$PossessiveFSet_hasConsumed = function($this, $mr) {
        return 0;
    };
    $java.ju_BitSet = function() {
        var a = this; jl_Object.call(a);
        a.$data1 = null;
        a.$length7 = 0;
    };
    $java.ju_BitSet__init_ = function() {
        var var_0 = new $java.ju_BitSet();
        $java.ju_BitSet__init_0(var_0);
        return var_0;
    };
    $java.ju_BitSet__init_0 = function($this) {
        $this.$data1 = $rt_createIntArray(0);
    };
    $java.ju_BitSet_set = function($this, $bitIndex) {
        var $index, var$3;
        $index = $bitIndex / 32 | 0;
        if ($bitIndex >= $this.$length7) {
            $java.ju_BitSet_ensureCapacity($this, $index + 1 | 0);
            $this.$length7 = $bitIndex + 1 | 0;
        }
        var$3 = $this.$data1.data;
        var$3[$index] = var$3[$index] | 1 << ($bitIndex % 32 | 0);
    };
    $java.ju_BitSet_set0 = function($this, $fromIndex, $toIndex) {
        var var$3, $fromDataIndex, $toDataIndex, var$6, $i;
        if ($fromIndex > $toIndex) {
            var$3 = new jl_IndexOutOfBoundsException;
            jl_Throwable__init_0(var$3);
            $rt_throw(var$3);
        }
        $fromDataIndex = $fromIndex / 32 | 0;
        $toDataIndex = $toIndex / 32 | 0;
        if ($toIndex > $this.$length7) {
            $java.ju_BitSet_ensureCapacity($this, $toDataIndex + 1 | 0);
            $this.$length7 = $toIndex;
        }
        if ($fromDataIndex == $toDataIndex) {
            var$6 = $this.$data1.data;
            var$6[$fromDataIndex] = var$6[$fromDataIndex] | $java.ju_BitSet_trailingZeroBits($this, $fromIndex) & $java.ju_BitSet_trailingOneBits($this, $toIndex);
        } else {
            var$6 = $this.$data1.data;
            var$6[$fromDataIndex] = var$6[$fromDataIndex] | $java.ju_BitSet_trailingZeroBits($this, $fromIndex);
            $i = $fromDataIndex + 1 | 0;
            while ($i < $toDataIndex) {
                $this.$data1.data[$i] = (-1);
                $i = $i + 1 | 0;
            }
            if ($toIndex & 31) {
                var$6 = $this.$data1.data;
                var$6[$toDataIndex] = var$6[$toDataIndex] | $java.ju_BitSet_trailingOneBits($this, $toIndex);
            }
        }
    };
    $java.ju_BitSet_trailingZeroBits = function($this, $num) {
        return (-1) << ($num % 32 | 0);
    };
    $java.ju_BitSet_trailingOneBits = function($this, $num) {
        $num = $num % 32 | 0;
        return !$num ? 0 : (-1) >>> (32 - $num | 0);
    };
    $java.ju_BitSet_clear = function($this, $bitIndex) {
        var $index, var$3;
        $index = $bitIndex / 32 | 0;
        var$3 = $this.$data1.data;
        if ($index < var$3.length) {
            var$3[$index] = var$3[$index] & jl_Integer_rotateLeft((-2), $bitIndex % 32 | 0);
            if ($bitIndex == ($this.$length7 - 1 | 0))
                $java.ju_BitSet_recalculateLength($this);
        }
    };
    $java.ju_BitSet_get = function($this, $bitIndex) {
        var $index, var$3;
        $index = $bitIndex / 32 | 0;
        var$3 = $this.$data1.data;
        return $index < var$3.length && var$3[$index] & 1 << ($bitIndex % 32 | 0) ? 1 : 0;
    };
    $java.ju_BitSet_nextSetBit = function($this, $fromIndex) {
        var $top, $index, var$4, $i;
        $top = $this.$length7;
        if ($fromIndex >= $top)
            return (-1);
        $index = $fromIndex / 32 | 0;
        var$4 = $this.$data1.data;
        $i = var$4[$index] >>> ($fromIndex % 32 | 0);
        if ($i)
            return jl_Integer_numberOfTrailingZeros($i) + $fromIndex | 0;
        $top = ($top + 31 | 0) / 32 | 0;
        $i = $index + 1 | 0;
        while ($i < $top) {
            if (var$4[$i])
                return ($i * 32 | 0) + jl_Integer_numberOfTrailingZeros(var$4[$i]) | 0;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.ju_BitSet_ensureCapacity = function($this, $capacity) {
        var $newArrayLength;
        $newArrayLength = $this.$data1.data.length;
        if ($newArrayLength >= $capacity)
            return;
        $newArrayLength = jl_Math_max(($capacity * 3 | 0) / 2 | 0, ($newArrayLength * 2 | 0) + 1 | 0);
        $this.$data1 = ju_Arrays_copyOf2($this.$data1, $newArrayLength);
    };
    $java.ju_BitSet_recalculateLength = function($this) {
        var $top, $i, $sz;
        $top = ($this.$length7 + 31 | 0) / 32 | 0;
        $this.$length7 = $top * 32 | 0;
        $i = $top - 1 | 0;
        a: {
            while (true) {
                if ($i < 0)
                    break a;
                $sz = jl_Integer_numberOfLeadingZeros($this.$data1.data[$i]);
                if ($sz < 32)
                    break;
                $i = $i + (-1) | 0;
                $this.$length7 = $this.$length7 - 32 | 0;
            }
            $this.$length7 = $this.$length7 - $sz | 0;
        }
    };
    $java.ju_BitSet_and = function($this, $set) {
        var $i, $i_0, var$4, var$5;
        $i = jl_Math_min($this.$data1.data.length, $set.$data1.data.length);
        $i_0 = 0;
        while ($i_0 < $i) {
            var$4 = $this.$data1.data;
            var$4[$i_0] = var$4[$i_0] & $set.$data1.data[$i_0];
            $i_0 = $i_0 + 1 | 0;
        }
        while (true) {
            var$5 = $this.$data1.data;
            if ($i >= var$5.length)
                break;
            var$5[$i] = 0;
            $i = $i + 1 | 0;
        }
        $this.$length7 = jl_Math_min($this.$length7, $set.$length7);
        $java.ju_BitSet_recalculateLength($this);
    };
    $java.ju_BitSet_andNot = function($this, $set) {
        var $sz, $i, var$4;
        $sz = jl_Math_min($this.$data1.data.length, $set.$data1.data.length);
        $i = 0;
        while ($i < $sz) {
            var$4 = $this.$data1.data;
            var$4[$i] = var$4[$i] & ($set.$data1.data[$i] ^ (-1));
            $i = $i + 1 | 0;
        }
        $java.ju_BitSet_recalculateLength($this);
    };
    $java.ju_BitSet_or = function($this, $set) {
        var $sz, $i, var$4;
        $sz = jl_Math_max($this.$length7, $set.$length7);
        $this.$length7 = $sz;
        $java.ju_BitSet_ensureCapacity($this, ($sz + 31 | 0) / 32 | 0);
        $sz = jl_Math_min($this.$data1.data.length, $set.$data1.data.length);
        $i = 0;
        while ($i < $sz) {
            var$4 = $this.$data1.data;
            var$4[$i] = var$4[$i] | $set.$data1.data[$i];
            $i = $i + 1 | 0;
        }
    };
    $java.ju_BitSet_xor = function($this, $set) {
        var $sz, $i, var$4;
        $sz = jl_Math_max($this.$length7, $set.$length7);
        $this.$length7 = $sz;
        $java.ju_BitSet_ensureCapacity($this, ($sz + 31 | 0) / 32 | 0);
        $sz = jl_Math_min($this.$data1.data.length, $set.$data1.data.length);
        $i = 0;
        while ($i < $sz) {
            var$4 = $this.$data1.data;
            var$4[$i] = var$4[$i] ^ $set.$data1.data[$i];
            $i = $i + 1 | 0;
        }
        $java.ju_BitSet_recalculateLength($this);
    };
    $java.ju_BitSet_isEmpty = function($this) {
        return $this.$length7 ? 0 : 1;
    };
    $java.jur_LowHighSurrogateRangeSet = function() {
        var a = this; $java.jur_JointSet.call(a);
        a.$surrChars = null;
        a.$alt = 0;
    };
    $java.jur_LowHighSurrogateRangeSet_getName = function($this) {
        var var$1, var$2, var$3;
        var$1 = !$this.$alt ? $rt_s(162) : $rt_s(2863);
        var$2 = $this.$surrChars.$toString();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2864)), var$1), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_CompositeRangeSet = function() {
        var a = this; $java.jur_JointSet.call(a);
        a.$withoutSurrogates = null;
        a.$withSurrogates = null;
    };
    $java.jur_CompositeRangeSet__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_CompositeRangeSet();
        $java.jur_CompositeRangeSet__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_CompositeRangeSet__init_0 = function($this, $withoutSurrogates, $withSurrogates) {
        $java.jur_AbstractSet__init_($this);
        $this.$withoutSurrogates = $withoutSurrogates;
        $this.$withSurrogates = $withSurrogates;
    };
    $java.jur_CompositeRangeSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $shift, var$5, var$6, var$7, var$8;
        $shift = $this.$withoutSurrogates.$matches1($stringIndex, $testString, $matchResult);
        if ($shift < 0)
            a: {
                var$5 = $this.$withSurrogates;
                var$6 = $matchResult.$leftBound0;
                $shift = $matchResult.$rightBound0;
                var$7 = $stringIndex + 1 | 0;
                $shift = $rt_compare(var$7, $shift);
                if ($shift > 0) {
                    $matchResult.$hitEnd = 1;
                    $shift = (-1);
                } else {
                    var$8 = jl_String_charAt($testString, $stringIndex);
                    if (!var$5.$surrChars.$contains2(var$8))
                        $shift = (-1);
                    else {
                        if (jl_Character_isHighSurrogate(var$8)) {
                            if ($shift < 0 && jl_Character_isLowSurrogate(jl_String_charAt($testString, var$7))) {
                                $shift = (-1);
                                break a;
                            }
                        } else if (jl_Character_isLowSurrogate(var$8) && $stringIndex > var$6 && jl_Character_isHighSurrogate(jl_String_charAt($testString, $stringIndex - 1 | 0))) {
                            $shift = (-1);
                            break a;
                        }
                        $shift = var$5.$next12.$matches1(var$7, $testString, $matchResult);
                    }
                }
            }
        if ($shift >= 0)
            return $shift;
        return (-1);
    };
    $java.jur_CompositeRangeSet_setNext = function($this, $next) {
        $this.$next12 = $next;
        $this.$withSurrogates.$next12 = $next;
        $this.$withoutSurrogates.$setNext($next);
    };
    $java.jur_CompositeRangeSet_getName = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$withoutSurrogates;
        var$2 = $this.$withSurrogates;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2865)), var$1), $rt_s(2866)), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_CompositeRangeSet_hasConsumed = function($this, $matchResult) {
        return 1;
    };
    $java.jur_CompositeRangeSet_first = function($this, $set) {
        return 1;
    };
    $java.jur_SupplRangeSet = function() {
        var a = this; $java.jur_JointSet.call(a);
        a.$chars = null;
        a.$alt1 = 0;
    };
    $java.jur_SupplRangeSet__init_ = function(var_0) {
        var var_1 = new $java.jur_SupplRangeSet();
        $java.jur_SupplRangeSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_SupplRangeSet__init_0 = function($this, $cc) {
        $java.jur_AbstractSet__init_($this);
        $this.$chars = $cc.$getInstance0();
        $this.$alt1 = $cc.$alt0;
    };
    $java.jur_SupplRangeSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength, $low, $high, $offset;
        $strLength = $matchResult.$rightBound0;
        if ($stringIndex < $strLength) {
            $low = $stringIndex + 1 | 0;
            $high = jl_String_charAt($testString, $stringIndex);
            if ($this.$contains2($high)) {
                $offset = $this.$next12.$matches1($low, $testString, $matchResult);
                if ($offset > 0)
                    return $offset;
            }
            if ($low < $strLength) {
                $stringIndex = $low + 1 | 0;
                $low = jl_String_charAt($testString, $low);
                if (jl_Character_isSurrogatePair($high, $low) && $this.$contains2(jl_Character_toCodePoint($high, $low)))
                    return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            }
        }
        return (-1);
    };
    $java.jur_SupplRangeSet_getName = function($this) {
        var var$1, var$2, var$3;
        var$1 = !$this.$alt1 ? $rt_s(162) : $rt_s(2863);
        var$2 = $this.$chars.$toString();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2864)), var$1), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_SupplRangeSet_contains = function($this, $ch) {
        return $this.$chars.$contains2($ch);
    };
    $java.jur_SupplRangeSet_first = function($this, $set) {
        if ($set instanceof $java.jur_SupplCharSet)
            return $this.$chars.$contains2($set.$ch1);
        if ($set instanceof $java.jur_CharSet)
            return $this.$chars.$contains2($set.$ch2);
        if ($set instanceof $java.jur_SupplRangeSet)
            return $java.jur_AbstractCharClass_intersects($this.$chars, $set.$chars);
        if (!($set instanceof $java.jur_RangeSet))
            return 1;
        return $java.jur_AbstractCharClass_intersects($this.$chars, $set.$chars0);
    };
    $java.jur_SupplRangeSet_getChars = function($this) {
        return $this.$chars;
    };
    $java.jur_SupplRangeSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_SupplRangeSet_hasConsumed = function($this, $mr) {
        return 1;
    };
    $java.jur_UCISupplRangeSet = $rt_classWithoutFields($java.jur_SupplRangeSet);
    $java.jur_UCISupplRangeSet_contains = function($this, $ch) {
        return $this.$chars.$contains2(jl_Character_toLowerCase0(jl_Character_toUpperCase($ch)));
    };
    $java.jur_UCISupplRangeSet_getName = function($this) {
        var var$1, var$2, var$3;
        var$1 = !$this.$alt1 ? $rt_s(162) : $rt_s(2863);
        var$2 = $this.$chars.$toString();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2867)), var$1), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_UCIRangeSet = function() {
        var a = this; $java.jur_LeafSet.call(a);
        a.$chars1 = null;
        a.$alt2 = 0;
    };
    $java.jur_UCIRangeSet__init_ = function(var_0) {
        var var_1 = new $java.jur_UCIRangeSet();
        $java.jur_UCIRangeSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_UCIRangeSet__init_0 = function($this, $cc) {
        $java.jur_LeafSet__init_($this);
        $this.$chars1 = $cc.$getInstance0();
        $this.$alt2 = $cc.$alt0;
    };
    $java.jur_UCIRangeSet_accepts = function($this, $strIndex, $testString) {
        return !$this.$chars1.$contains2(jl_Character_toLowerCase(jl_Character_toUpperCase0(jl_String_charAt($testString, $strIndex)))) ? (-1) : 1;
    };
    $java.jur_UCIRangeSet_getName = function($this) {
        var var$1, var$2, var$3;
        var$1 = !$this.$alt2 ? $rt_s(162) : $rt_s(2863);
        var$2 = $this.$chars1.$toString();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2867)), var$1), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_RangeSet = function() {
        var a = this; $java.jur_LeafSet.call(a);
        a.$chars0 = null;
        a.$alt3 = 0;
    };
    $java.jur_RangeSet__init_ = function(var_0) {
        var var_1 = new $java.jur_RangeSet();
        $java.jur_RangeSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_RangeSet__init_0 = function($this, $cc) {
        $java.jur_LeafSet__init_($this);
        $this.$chars0 = $cc.$getInstance0();
        $this.$alt3 = $cc.$alt0;
    };
    $java.jur_RangeSet_accepts = function($this, $strIndex, $testString) {
        return !$this.$chars0.$contains2(jl_String_charAt($testString, $strIndex)) ? (-1) : 1;
    };
    $java.jur_RangeSet_getName = function($this) {
        var var$1, var$2, var$3;
        var$1 = !$this.$alt3 ? $rt_s(162) : $rt_s(2863);
        var$2 = $this.$chars0.$toString();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2864)), var$1), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_RangeSet_first = function($this, $set) {
        if ($set instanceof $java.jur_CharSet)
            return $this.$chars0.$contains2($set.$ch2);
        if ($set instanceof $java.jur_RangeSet)
            return $java.jur_AbstractCharClass_intersects($this.$chars0, $set.$chars0);
        if (!($set instanceof $java.jur_SupplRangeSet)) {
            if (!($set instanceof $java.jur_SupplCharSet))
                return 1;
            return 0;
        }
        return $java.jur_AbstractCharClass_intersects($this.$chars0, $set.$chars);
    };
    $java.jur_HangulDecomposedCharSet = function() {
        var a = this; $java.jur_JointSet.call(a);
        a.$decomposedChar = null;
        a.$decomposedCharUTF16 = null;
        a.$decomposedCharLength = 0;
    };
    $java.jur_HangulDecomposedCharSet__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_HangulDecomposedCharSet();
        $java.jur_HangulDecomposedCharSet__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_HangulDecomposedCharSet__init_0 = function($this, $decomposedChar, $decomposedCharLength) {
        $java.jur_AbstractSet__init_($this);
        $this.$decomposedChar = $decomposedChar;
        $this.$decomposedCharLength = $decomposedCharLength;
    };
    $java.jur_HangulDecomposedCharSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_HangulDecomposedCharSet_getDecomposedChar = function($this) {
        if ($this.$decomposedCharUTF16 === null)
            $this.$decomposedCharUTF16 = jl_String__init_($this.$decomposedChar);
        return $this.$decomposedCharUTF16;
    };
    $java.jur_HangulDecomposedCharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $java.jur_HangulDecomposedCharSet_getDecomposedChar($this);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2868)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_HangulDecomposedCharSet_matches = function($this, $strIndex, $testString, $matchResult) {
        var $rightBound, $decompSyllable, $vIndex, $tIndex, var$8, $curSymb, $lIndex, $i, $decompCurSymb, $syllIndex;
        $rightBound = $matchResult.$rightBound0;
        $decompSyllable = $rt_createIntArray(3);
        $vIndex = (-1);
        $tIndex = (-1);
        if ($strIndex >= $rightBound)
            return (-1);
        var$8 = $strIndex + 1 | 0;
        $curSymb = jl_String_charAt($testString, $strIndex);
        $strIndex = $curSymb - 44032 | 0;
        if ($strIndex >= 0 && $strIndex < 11172) {
            $lIndex = 4352 + ($strIndex / 588 | 0) | 0;
            $i = 4449 + (($strIndex % 588 | 0) / 28 | 0) | 0;
            $strIndex = $strIndex % 28 | 0;
            $decompCurSymb = !$strIndex ? $rt_createIntArrayFromData([$lIndex, $i]) : $rt_createIntArrayFromData([$lIndex, $i, 4519 + $strIndex | 0]);
        } else
            $decompCurSymb = null;
        if ($decompCurSymb !== null) {
            $decompCurSymb = $decompCurSymb.data;
            $i = 0;
            $strIndex = $decompCurSymb.length;
            $syllIndex = $this.$decomposedCharLength;
            if ($strIndex != $syllIndex)
                return (-1);
            while (true) {
                if ($i >= $syllIndex)
                    return $this.$next12.$matches1(var$8, $testString, $matchResult);
                if ($decompCurSymb[$i] != $this.$decomposedChar.data[$i])
                    break;
                $i = $i + 1 | 0;
            }
            return (-1);
        }
        $decompSyllable = $decompSyllable.data;
        $decompSyllable[0] = $curSymb;
        $lIndex = $curSymb - 4352 | 0;
        if ($lIndex >= 0 && $lIndex < 19) {
            if (var$8 < $rightBound) {
                $curSymb = jl_String_charAt($testString, var$8);
                $vIndex = $curSymb - 4449 | 0;
            }
            if ($vIndex >= 0 && $vIndex < 21) {
                $lIndex = var$8 + 1 | 0;
                $decompSyllable[1] = $curSymb;
                if ($lIndex < $rightBound) {
                    $curSymb = jl_String_charAt($testString, $lIndex);
                    $tIndex = $curSymb - 4519 | 0;
                }
                if ($tIndex >= 0 && $tIndex < 28) {
                    a: {
                        $strIndex = $lIndex + 1 | 0;
                        $decompSyllable[2] = $curSymb;
                        if ($this.$decomposedCharLength == 3) {
                            $lIndex = $decompSyllable[0];
                            $decompCurSymb = $this.$decomposedChar.data;
                            if ($lIndex == $decompCurSymb[0] && $decompSyllable[1] == $decompCurSymb[1] && $decompSyllable[2] == $decompCurSymb[2]) {
                                $strIndex = $this.$next12.$matches1($strIndex, $testString, $matchResult);
                                break a;
                            }
                        }
                        $strIndex = (-1);
                    }
                    return $strIndex;
                }
                b: {
                    if ($this.$decomposedCharLength == 2) {
                        $strIndex = $decompSyllable[0];
                        $decompCurSymb = $this.$decomposedChar.data;
                        if ($strIndex == $decompCurSymb[0] && $decompSyllable[1] == $decompCurSymb[1]) {
                            $strIndex = $this.$next12.$matches1($lIndex, $testString, $matchResult);
                            break b;
                        }
                    }
                    $strIndex = (-1);
                }
                return $strIndex;
            }
            return (-1);
        }
        return (-1);
    };
    $java.jur_HangulDecomposedCharSet_first = function($this, $set) {
        return $set instanceof $java.jur_HangulDecomposedCharSet && !jl_String_equals($java.jur_HangulDecomposedCharSet_getDecomposedChar($set), $java.jur_HangulDecomposedCharSet_getDecomposedChar($this)) ? 0 : 1;
    };
    $java.jur_HangulDecomposedCharSet_hasConsumed = function($this, $matchResult) {
        return 1;
    };
    $java.jur_CharSet = function() {
        $java.jur_LeafSet.call(this);
        this.$ch2 = 0;
    };
    $java.jur_CharSet__init_ = function(var_0) {
        var var_1 = new $java.jur_CharSet();
        $java.jur_CharSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_CharSet__init_0 = function($this, $ch) {
        $java.jur_LeafSet__init_($this);
        $this.$ch2 = $ch;
    };
    $java.jur_CharSet_charCount = function($this) {
        return 1;
    };
    $java.jur_CharSet_accepts = function($this, $strIndex, $testString) {
        return $this.$ch2 != jl_String_charAt($testString, $strIndex) ? (-1) : 1;
    };
    $java.jur_CharSet_find = function($this, $strIndex, $testStr, $matchResult) {
        var $strLength, var$5, var$6;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_find($this, $strIndex, $testStr, $matchResult);
        $strLength = $matchResult.$rightBound0;
        while (true) {
            if ($strIndex >= $strLength)
                return (-1);
            var$5 = jl_String_indexOf($testStr, $this.$ch2, $strIndex);
            if (var$5 < 0)
                return (-1);
            var$6 = $this.$next12;
            $strIndex = var$5 + 1 | 0;
            if (var$6.$matches1($strIndex, $testStr, $matchResult) >= 0)
                break;
        }
        return var$5;
    };
    $java.jur_CharSet_findBack = function($this, $strIndex, $lastIndex, $testStr, $matchResult) {
        var var$5;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_findBack($this, $strIndex, $lastIndex, $testStr, $matchResult);
        a: {
            while (true) {
                if ($lastIndex < $strIndex)
                    return (-1);
                var$5 = jl_String_lastIndexOf0($testStr, $this.$ch2, $lastIndex);
                if (var$5 < 0)
                    break a;
                if (var$5 < $strIndex)
                    break a;
                if ($this.$next12.$matches1(var$5 + 1 | 0, $testStr, $matchResult) >= 0)
                    break;
                $lastIndex = var$5 + (-1) | 0;
            }
            return var$5;
        }
        return (-1);
    };
    $java.jur_CharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$ch2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_CharSet_first = function($this, $set) {
        if ($set instanceof $java.jur_CharSet)
            return $set.$ch2 != $this.$ch2 ? 0 : 1;
        if (!($set instanceof $java.jur_RangeSet)) {
            if ($set instanceof $java.jur_SupplRangeSet)
                return $set.$contains2($this.$ch2);
            if (!($set instanceof $java.jur_SupplCharSet))
                return 1;
            return 0;
        }
        return $java.jur_RangeSet_accepts($set, 0, jl_Character_toString0($this.$ch2)) <= 0 ? 0 : 1;
    };
    $java.jur_UCICharSet = function() {
        $java.jur_LeafSet.call(this);
        this.$ch3 = 0;
    };
    $java.jur_UCICharSet__init_ = function(var_0) {
        var var_1 = new $java.jur_UCICharSet();
        $java.jur_UCICharSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_UCICharSet__init_0 = function($this, $ch) {
        $java.jur_LeafSet__init_($this);
        $this.$ch3 = jl_Character_toLowerCase(jl_Character_toUpperCase0($ch));
    };
    $java.jur_UCICharSet_accepts = function($this, $strIndex, $testString) {
        return $this.$ch3 != jl_Character_toLowerCase(jl_Character_toUpperCase0(jl_String_charAt($testString, $strIndex))) ? (-1) : 1;
    };
    $java.jur_UCICharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$ch3;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2869)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_CICharSet = function() {
        var a = this; $java.jur_LeafSet.call(a);
        a.$ch4 = 0;
        a.$supplement = 0;
    };
    $java.jur_CICharSet__init_ = function(var_0) {
        var var_1 = new $java.jur_CICharSet();
        $java.jur_CICharSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_CICharSet__init_0 = function($this, $ch) {
        $java.jur_LeafSet__init_($this);
        $this.$ch4 = $ch;
        $this.$supplement = $java.jur_Pattern_getSupplement($ch);
    };
    $java.jur_CICharSet_accepts = function($this, $strIndex, $testString) {
        return $this.$ch4 != jl_String_charAt($testString, $strIndex) && $this.$supplement != jl_String_charAt($testString, $strIndex) ? (-1) : 1;
    };
    $java.jur_CICharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$ch4;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2870)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_DecomposedCharSet = function() {
        var a = this; $java.jur_JointSet.call(a);
        a.$readCharsForCodePoint = 0;
        a.$decomposedCharUTF160 = null;
        a.$decomposedChar0 = null;
        a.$decomposedCharLength0 = 0;
    };
    $java.jur_DecomposedCharSet__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_DecomposedCharSet();
        $java.jur_DecomposedCharSet__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_DecomposedCharSet__init_0 = function($this, $decomposedChar, $decomposedCharLength) {
        $java.jur_AbstractSet__init_($this);
        $this.$readCharsForCodePoint = 1;
        $this.$decomposedChar0 = $decomposedChar;
        $this.$decomposedCharLength0 = $decomposedCharLength;
    };
    $java.jur_DecomposedCharSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_DecomposedCharSet_matches = function($this, $strIndex, $testString, $matchResult) {
        var $decCodePoint, $rightBound, $curChar, var$7, $decCurCodePoint, var$9, var$10, $readCodePoints;
        $decCodePoint = $rt_createIntArray(4);
        $rightBound = $matchResult.$rightBound0;
        if ($strIndex >= $rightBound)
            return (-1);
        $curChar = $java.jur_DecomposedCharSet_codePointAt($this, $strIndex, $testString, $rightBound);
        var$7 = $strIndex + $this.$readCharsForCodePoint | 0;
        $decCurCodePoint = $java.jur_Lexer_getDecomposition($curChar);
        if ($decCurCodePoint === null) {
            $decCurCodePoint = $decCodePoint.data;
            $strIndex = 1;
            $decCurCodePoint[0] = $curChar;
        } else {
            $strIndex = $decCurCodePoint.data.length;
            jl_System_arraycopy($decCurCodePoint, 0, $decCodePoint, 0, $strIndex);
            $strIndex = 0 + $strIndex | 0;
        }
        a: {
            if (var$7 < $rightBound) {
                var$9 = $decCodePoint.data;
                $curChar = $java.jur_DecomposedCharSet_codePointAt($this, var$7, $testString, $rightBound);
                while ($strIndex < 4) {
                    if (!(($curChar != 832 ? 0 : 1) | ($curChar != 833 ? 0 : 1) | ($curChar != 835 ? 0 : 1) | ($curChar != 836 ? 0 : 1))) {
                        var$10 = $strIndex + 1 | 0;
                        var$9[$strIndex] = $curChar;
                    } else {
                        $decCurCodePoint = ($java.jur_Lexer_getDecomposition($curChar)).data;
                        if ($decCurCodePoint.length != 2) {
                            var$10 = $strIndex + 1 | 0;
                            var$9[$strIndex] = $decCurCodePoint[0];
                        } else {
                            $readCodePoints = $strIndex + 1 | 0;
                            var$9[$strIndex] = $decCurCodePoint[0];
                            var$10 = $readCodePoints + 1 | 0;
                            var$9[$readCodePoints] = $decCurCodePoint[1];
                        }
                    }
                    var$7 = var$7 + $this.$readCharsForCodePoint | 0;
                    if (var$7 >= $rightBound) {
                        $strIndex = var$10;
                        break a;
                    }
                    $curChar = $java.jur_DecomposedCharSet_codePointAt($this, var$7, $testString, $rightBound);
                    $strIndex = var$10;
                }
            }
        }
        if ($strIndex != $this.$decomposedCharLength0)
            return (-1);
        $decCurCodePoint = $decCodePoint.data;
        $curChar = 0;
        while (true) {
            if ($curChar >= $strIndex)
                return $this.$next12.$matches1(var$7, $testString, $matchResult);
            if ($decCurCodePoint[$curChar] != $this.$decomposedChar0.data[$curChar])
                break;
            $curChar = $curChar + 1 | 0;
        }
        return (-1);
    };
    $java.jur_DecomposedCharSet_getDecomposedChar = function($this) {
        var $strBuff, $i;
        if ($this.$decomposedCharUTF160 === null) {
            $strBuff = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_($strBuff);
            $i = 0;
            while ($i < $this.$decomposedCharLength0) {
                jl_AbstractStringBuilder_append5($strBuff, jl_Character_toChars($this.$decomposedChar0.data[$i]));
                $i = $i + 1 | 0;
            }
            $this.$decomposedCharUTF160 = jl_AbstractStringBuilder_toString($strBuff);
        }
        return $this.$decomposedCharUTF160;
    };
    $java.jur_DecomposedCharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $java.jur_DecomposedCharSet_getDecomposedChar($this);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2871)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_DecomposedCharSet_codePointAt = function($this, $strIndex, $testString, $rightBound) {
        var $curChar, $low, $curCodePointUTF16;
        $this.$readCharsForCodePoint = 1;
        if ($strIndex >= ($rightBound - 1 | 0))
            $curChar = jl_String_charAt($testString, $strIndex);
        else {
            $rightBound = $strIndex + 1 | 0;
            $curChar = jl_String_charAt($testString, $strIndex);
            $low = jl_String_charAt($testString, $rightBound);
            if (jl_Character_isSurrogatePair($curChar, $low)) {
                $curCodePointUTF16 = $rt_createCharArray(2).data;
                $curCodePointUTF16[0] = $curChar;
                $curCodePointUTF16[1] = $low;
                $curChar = 0 < ($curCodePointUTF16.length - 1 | 0) && jl_Character_isHighSurrogate($curCodePointUTF16[0]) && jl_Character_isLowSurrogate($curCodePointUTF16[1]) ? jl_Character_toCodePoint($curCodePointUTF16[0], $curCodePointUTF16[1]) : $curCodePointUTF16[0];
                $this.$readCharsForCodePoint = 2;
            }
        }
        return $curChar;
    };
    $java.jur_DecomposedCharSet_first = function($this, $set) {
        return $set instanceof $java.jur_DecomposedCharSet && !jl_String_equals($java.jur_DecomposedCharSet_getDecomposedChar($set), $java.jur_DecomposedCharSet_getDecomposedChar($this)) ? 0 : 1;
    };
    $java.jur_DecomposedCharSet_hasConsumed = function($this, $matchResult) {
        return 1;
    };
    $java.jur_UCIDecomposedCharSet = $rt_classWithoutFields($java.jur_DecomposedCharSet);
    $java.jur_CIDecomposedCharSet = $rt_classWithoutFields($java.jur_DecomposedCharSet);
    $java.jur_PossessiveGroupQuantifierSet = $rt_classWithoutFields($java.jur_GroupQuantifierSet);
    $java.jur_PossessiveGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $stringIndex_0;
        while (true) {
            $stringIndex_0 = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
            if ($stringIndex_0 <= 0)
                break;
            $stringIndex = $stringIndex_0;
        }
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_PosPlusGroupQuantifierSet = $rt_classWithoutFields($java.jur_GroupQuantifierSet);
    $java.jur_PosPlusGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $nextIndex;
        $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        if ($nextIndex < 0)
            return (-1);
        if ($nextIndex > $stringIndex) {
            while (true) {
                $stringIndex = $this.$innerSet.$matches1($nextIndex, $testString, $matchResult);
                if ($stringIndex <= $nextIndex)
                    break;
                $nextIndex = $stringIndex;
            }
            $stringIndex = $nextIndex;
        }
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_AltGroupQuantifierSet = $rt_classWithoutFields($java.jur_GroupQuantifierSet);
    $java.jur_AltGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $nextIndex;
        if (!$this.$innerSet.$hasConsumed($matchResult))
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        if ($nextIndex >= 0)
            return $nextIndex;
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_AltGroupQuantifierSet_setNext = function($this, $next) {
        $this.$next12 = $next;
        $this.$innerSet.$setNext($next);
    };
    $java.jur_PosAltGroupQuantifierSet = $rt_classWithoutFields($java.jur_AltGroupQuantifierSet);
    $java.jur_PosAltGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $nextIndex;
        $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        if ($nextIndex <= 0)
            $nextIndex = $stringIndex;
        return $this.$next12.$matches1($nextIndex, $testString, $matchResult);
    };
    $java.jur_PosAltGroupQuantifierSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_CompositeGroupQuantifierSet = function() {
        var a = this; $java.jur_GroupQuantifierSet.call(a);
        a.$quantifier1 = null;
        a.$setCounter = 0;
    };
    $java.jur_CompositeGroupQuantifierSet__init_0 = function(var_0, var_1, var_2, var_3, var_4) {
        var var_5 = new $java.jur_CompositeGroupQuantifierSet();
        $java.jur_CompositeGroupQuantifierSet__init_(var_5, var_0, var_1, var_2, var_3, var_4);
        return var_5;
    };
    $java.jur_CompositeGroupQuantifierSet__init_ = function($this, $quant, $innerSet, $next, $type, $setCounter) {
        $java.jur_QuantifierSet__init_($this, $innerSet, $next, $type);
        $this.$quantifier1 = $quant;
        $this.$setCounter = $setCounter;
    };
    $java.jur_CompositeGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $enterCounter, $nextIndex;
        $enterCounter = $java.jur_MatchResultImpl_getEnterCounter($matchResult, $this.$setCounter);
        if (!$this.$innerSet.$hasConsumed($matchResult))
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        if ($enterCounter >= $this.$quantifier1.$max3)
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        $nextIndex = $this.$setCounter;
        $enterCounter = $enterCounter + 1 | 0;
        $java.jur_MatchResultImpl_setEnterCounter($matchResult, $nextIndex, $enterCounter);
        $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        if ($nextIndex >= 0) {
            $java.jur_MatchResultImpl_setEnterCounter($matchResult, $this.$setCounter, 0);
            return $nextIndex;
        }
        $nextIndex = $this.$setCounter;
        $enterCounter = $enterCounter + (-1) | 0;
        $java.jur_MatchResultImpl_setEnterCounter($matchResult, $nextIndex, $enterCounter);
        if ($enterCounter >= $this.$quantifier1.$min2)
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        $java.jur_MatchResultImpl_setEnterCounter($matchResult, $this.$setCounter, 0);
        return (-1);
    };
    $java.jur_CompositeGroupQuantifierSet_getName = function($this) {
        return $java.jur_Quantifier_toString($this.$quantifier1);
    };
    $java.jur_PosCompositeGroupQuantifierSet = $rt_classWithoutFields($java.jur_CompositeGroupQuantifierSet);
    $java.jur_PosCompositeGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $counter, $max, $nextIndex;
        $counter = 0;
        $max = $this.$quantifier1.$max3;
        a: {
            while (true) {
                $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
                if ($nextIndex <= $stringIndex)
                    break a;
                if ($counter >= $max)
                    break;
                $counter = $counter + 1 | 0;
                $stringIndex = $nextIndex;
            }
        }
        if ($nextIndex < 0 && $counter < $this.$quantifier1.$min2)
            return (-1);
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_ReluctantGroupQuantifierSet = $rt_classWithoutFields($java.jur_GroupQuantifierSet);
    $java.jur_ReluctantGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $res;
        if (!$this.$innerSet.$hasConsumed($matchResult))
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        $res = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        if ($res >= 0)
            return $res;
        return $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_RelAltGroupQuantifierSet = $rt_classWithoutFields($java.jur_AltGroupQuantifierSet);
    $java.jur_RelAltGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $nextIndex;
        if (!$this.$innerSet.$hasConsumed($matchResult))
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        $nextIndex = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        if ($nextIndex < 0)
            $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        return $nextIndex;
    };
    $java.jur_RelCompositeGroupQuantifierSet = $rt_classWithoutFields($java.jur_CompositeGroupQuantifierSet);
    $java.jur_RelCompositeGroupQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $enterCounter, var$5, $nextIndex;
        $enterCounter = $java.jur_MatchResultImpl_getEnterCounter($matchResult, $this.$setCounter);
        if (!$this.$innerSet.$hasConsumed($matchResult))
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        var$5 = $this.$quantifier1;
        if ($enterCounter >= var$5.$max3) {
            $java.jur_MatchResultImpl_setEnterCounter($matchResult, $this.$setCounter, 0);
            return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        }
        if ($enterCounter < var$5.$min2) {
            $java.jur_MatchResultImpl_setEnterCounter($matchResult, $this.$setCounter, $enterCounter + 1 | 0);
            $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        } else {
            $nextIndex = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            if ($nextIndex >= 0) {
                $java.jur_MatchResultImpl_setEnterCounter($matchResult, $this.$setCounter, 0);
                return $nextIndex;
            }
            $java.jur_MatchResultImpl_setEnterCounter($matchResult, $this.$setCounter, $enterCounter + 1 | 0);
            $nextIndex = $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
        }
        return $nextIndex;
    };
    $java.jur_DotAllQuantifierSet = $rt_classWithoutFields($java.jur_QuantifierSet);
    $java.jur_DotAllQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength;
        $strLength = $matchResult.$rightBound0;
        if ($strLength > $stringIndex)
            return $this.$next12.$findBack($stringIndex, $strLength, $testString, $matchResult);
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_DotAllQuantifierSet_find = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength;
        $strLength = $matchResult.$rightBound0;
        if ($this.$next12.$findBack($stringIndex, $strLength, $testString, $matchResult) >= 0)
            return $stringIndex;
        return (-1);
    };
    $java.jur_DotAllQuantifierSet_getName = function($this) {
        return $rt_s(2872);
    };
    $java.jur_DotQuantifierSet = function() {
        $java.jur_QuantifierSet.call(this);
        this.$lt0 = null;
    };
    $java.jur_DotQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength, $startSearch;
        $strLength = $matchResult.$rightBound0;
        $startSearch = $java.jur_DotQuantifierSet_findLineTerminator($this, $stringIndex, $strLength, $testString);
        if ($startSearch >= 0)
            $strLength = $startSearch;
        if ($strLength > $stringIndex)
            return $this.$next12.$findBack($stringIndex, $strLength, $testString, $matchResult);
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_DotQuantifierSet_find = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength, $res, $nextSearch, $leftBound;
        $strLength = $matchResult.$rightBound0;
        $res = $this.$next12.$find1($stringIndex, $testString, $matchResult);
        if ($res < 0)
            return (-1);
        $nextSearch = $java.jur_DotQuantifierSet_findLineTerminator($this, $res, $strLength, $testString);
        if ($nextSearch >= 0)
            $strLength = $nextSearch;
        $nextSearch = jl_Math_max($res, $this.$next12.$findBack($res, $strLength, $testString, $matchResult));
        if ($nextSearch <= 0)
            $leftBound = $nextSearch ? (-1) : 0;
        else {
            $leftBound = $nextSearch - 1 | 0;
            a: {
                while (true) {
                    if ($leftBound < $stringIndex) {
                        $leftBound = (-1);
                        break a;
                    }
                    if ($this.$lt0.$isLineTerminator(jl_String_charAt($testString, $leftBound)))
                        break;
                    $leftBound = $leftBound + (-1) | 0;
                }
            }
        }
        if ($leftBound >= $stringIndex)
            $stringIndex = $leftBound >= $nextSearch ? $leftBound : $leftBound + 1 | 0;
        return $stringIndex;
    };
    $java.jur_DotQuantifierSet_findLineTerminator = function($this, $i, $to, $testString) {
        while (true) {
            if ($i >= $to)
                return (-1);
            if ($this.$lt0.$isLineTerminator(jl_String_charAt($testString, $i)))
                break;
            $i = $i + 1 | 0;
        }
        return $i;
    };
    $java.jur_DotQuantifierSet_getName = function($this) {
        return $rt_s(2873);
    };
    $java.jur_AbstractLineTerminator = $rt_classWithoutFields();
    $java.jur_AbstractLineTerminator_unixLT = null;
    $java.jur_AbstractLineTerminator_unicodeLT = null;
    $java.jur_AbstractLineTerminator_getInstance = function($flag) {
        var var$2;
        if (!($flag & 1)) {
            var$2 = $java.jur_AbstractLineTerminator_unicodeLT;
            if (var$2 !== null)
                return var$2;
            var$2 = new $java.jur_AbstractLineTerminator$2;
            $java.jur_AbstractLineTerminator_unicodeLT = var$2;
            return var$2;
        }
        var$2 = $java.jur_AbstractLineTerminator_unixLT;
        if (var$2 !== null)
            return var$2;
        var$2 = new $java.jur_AbstractLineTerminator$1;
        $java.jur_AbstractLineTerminator_unixLT = var$2;
        return var$2;
    };
    $java.jur_PossessiveQuantifierSet = $rt_classWithoutFields($java.jur_LeafQuantifierSet);
    $java.jur_PossessiveQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var var$4;
        a: {
            while (true) {
                if (($stringIndex + $this.$leaf0.$charCount0() | 0) > $matchResult.$rightBound0)
                    break a;
                var$4 = $this.$leaf0.$accepts($stringIndex, $testString);
                if (var$4 < 1)
                    break;
                $stringIndex = $stringIndex + var$4 | 0;
            }
        }
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_PossessiveAltQuantifierSet = $rt_classWithoutFields($java.jur_AltQuantifierSet);
    $java.jur_PossessiveAltQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var var$4;
        if (($stringIndex + $this.$leaf0.$charCount0() | 0) <= $matchResult.$rightBound0) {
            var$4 = $this.$leaf0.$accepts($stringIndex, $testString);
            if (var$4 >= 1)
                $stringIndex = $stringIndex + var$4 | 0;
        }
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_PossessiveCompositeQuantifierSet = $rt_classWithoutFields($java.jur_CompositeQuantifierSet);
    $java.jur_PossessiveCompositeQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var var$4, $min, $max, $i, $shift;
        var$4 = $this.$quantifier0;
        $min = var$4.$min2;
        $max = var$4.$max3;
        $i = 0;
        while (true) {
            if ($i >= $min) {
                a: {
                    while (true) {
                        if ($i >= $max)
                            break a;
                        if (($stringIndex + $this.$leaf0.$charCount0() | 0) > $matchResult.$rightBound0)
                            break a;
                        $shift = $this.$leaf0.$accepts($stringIndex, $testString);
                        if ($shift < 1)
                            break;
                        $stringIndex = $stringIndex + $shift | 0;
                        $i = $i + 1 | 0;
                    }
                }
                return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            }
            if (($stringIndex + $this.$leaf0.$charCount0() | 0) > $matchResult.$rightBound0) {
                $matchResult.$hitEnd = 1;
                return (-1);
            }
            $shift = $this.$leaf0.$accepts($stringIndex, $testString);
            if ($shift < 1)
                break;
            $stringIndex = $stringIndex + $shift | 0;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_ReluctantQuantifierSet = $rt_classWithoutFields($java.jur_LeafQuantifierSet);
    $java.jur_ReluctantQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var var$4;
        while (true) {
            var$4 = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            if (var$4 >= 0)
                break;
            if (($stringIndex + $this.$leaf0.$charCount0() | 0) <= $matchResult.$rightBound0) {
                var$4 = $this.$leaf0.$accepts($stringIndex, $testString);
                $stringIndex = $stringIndex + var$4 | 0;
            }
            if (var$4 < 1)
                return (-1);
        }
        return var$4;
    };
    $java.jur_ReluctantAltQuantifierSet = $rt_classWithoutFields($java.jur_AltQuantifierSet);
    $java.jur_ReluctantAltQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $shift;
        $shift = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
        if ($shift >= 0)
            return $shift;
        return $this.$innerSet.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_ReluctantCompositeQuantifierSet = $rt_classWithoutFields($java.jur_CompositeQuantifierSet);
    $java.jur_ReluctantCompositeQuantifierSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var var$4, $min, $max, $i, var$8, var$9;
        var$4 = $this.$quantifier0;
        $min = var$4.$min2;
        $max = var$4.$max3;
        $i = 0;
        while (true) {
            if ($i >= $min) {
                a: {
                    while (true) {
                        var$8 = $this.$next12.$matches1($stringIndex, $testString, $matchResult);
                        if (var$8 >= 0)
                            break;
                        if (($stringIndex + $this.$leaf0.$charCount0() | 0) <= $matchResult.$rightBound0) {
                            var$8 = $this.$leaf0.$accepts($stringIndex, $testString);
                            $stringIndex = $stringIndex + var$8 | 0;
                            $i = $i + 1 | 0;
                        }
                        if (var$8 < 1)
                            break a;
                        if ($i > $max)
                            break a;
                    }
                    return var$8;
                }
                return (-1);
            }
            if (($stringIndex + $this.$leaf0.$charCount0() | 0) > $matchResult.$rightBound0) {
                $matchResult.$hitEnd = 1;
                return (-1);
            }
            var$9 = $this.$leaf0.$accepts($stringIndex, $testString);
            if (var$9 < 1)
                break;
            $stringIndex = $stringIndex + var$9 | 0;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_SOLSet = $rt_classWithoutFields(jur_AbstractSet);
    $java.jur_SOLSet_matches = function($this, $strIndex, $testString, $matchResult) {
        if ($strIndex && !($matchResult.$anchoringBounds && $strIndex == $matchResult.$leftBound0))
            return (-1);
        return $this.$next12.$matches1($strIndex, $testString, $matchResult);
    };
    $java.jur_SOLSet_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_SOLSet_getName = function($this) {
        return $rt_s(2874);
    };
    $java.jur_WordBoundary = function() {
        jur_AbstractSet.call(this);
        this.$positive = 0;
    };
    $java.jur_WordBoundary__init_ = function(var_0) {
        var var_1 = new $java.jur_WordBoundary();
        $java.jur_WordBoundary__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_WordBoundary__init_0 = function($this, $positive) {
        $java.jur_AbstractSet__init_($this);
        $this.$positive = $positive;
    };
    $java.jur_WordBoundary_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $ch1, $ch2, $leftBound;
        $ch1 = $stringIndex < $matchResult.$rightBound0 ? jl_String_charAt($testString, $stringIndex) : 32;
        $ch2 = !$stringIndex ? 32 : jl_String_charAt($testString, $stringIndex - 1 | 0);
        $leftBound = $matchResult.$transparentBounds ? 0 : $matchResult.$leftBound0;
        return ($ch1 != 32 && !$java.jur_WordBoundary_isSpace($this, $ch1, $stringIndex, $leftBound, $testString) ? 0 : 1) ^ ($ch2 != 32 && !$java.jur_WordBoundary_isSpace($this, $ch2, $stringIndex - 1 | 0, $leftBound, $testString) ? 0 : 1) ^ $this.$positive ? (-1) : $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_WordBoundary_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_WordBoundary_getName = function($this) {
        return $rt_s(2875);
    };
    $java.jur_WordBoundary_isSpace = function($this, $ch, $index, $leftBound, $testString) {
        var var$5;
        if (!jl_Character_isLetterOrDigit($ch) && $ch != 95) {
            a: {
                if (jl_Character_getType($ch) == 6)
                    while (true) {
                        $index = $index + (-1) | 0;
                        if ($index < $leftBound)
                            break a;
                        var$5 = jl_String_charAt($testString, $index);
                        if (jl_Character_isLetterOrDigit(var$5))
                            return 0;
                        if (jl_Character_getType(var$5) != 6)
                            return 1;
                    }
            }
            return 1;
        }
        return 0;
    };
    $java.jur_PreviousMatch = $rt_classWithoutFields(jur_AbstractSet);
    $java.jur_PreviousMatch_matches = function($this, $stringIndex, $testString, $matchResult) {
        if ($stringIndex != $matchResult.$previousMatch)
            return (-1);
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_PreviousMatch_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_PreviousMatch_getName = function($this) {
        return $rt_s(2876);
    };
    $java.jur_EOLSet = function() {
        jur_AbstractSet.call(this);
        this.$consCounter = 0;
    };
    $java.jur_EOLSet__init_0 = function(var_0) {
        var var_1 = new $java.jur_EOLSet();
        $java.jur_EOLSet__init_(var_1, var_0);
        return var_1;
    };
    $java.jur_EOLSet__init_ = function($this, $counter) {
        $java.jur_AbstractSet__init_($this);
        $this.$consCounter = $counter;
    };
    $java.jur_EOLSet_matches = function($this, $strIndex, $testString, $matchResult) {
        var $rightBound, var$5, $ch;
        $rightBound = !$matchResult.$anchoringBounds ? jl_String_length($testString) : $matchResult.$rightBound0;
        if ($strIndex >= $rightBound) {
            $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter, 0);
            return $this.$next12.$matches1($strIndex, $testString, $matchResult);
        }
        var$5 = $rightBound - $strIndex | 0;
        if (var$5 == 2 && jl_String_charAt($testString, $strIndex) == 13 && jl_String_charAt($testString, $strIndex + 1 | 0) == 10) {
            $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter, 0);
            return $this.$next12.$matches1($strIndex, $testString, $matchResult);
        }
        a: {
            if (var$5 == 1) {
                $ch = jl_String_charAt($testString, $strIndex);
                if ($ch == 10)
                    break a;
                if ($ch == 13)
                    break a;
                if ($ch == 133)
                    break a;
                if (($ch | 1) == 8233)
                    break a;
            }
            return (-1);
        }
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter, 0);
        return $this.$next12.$matches1($strIndex, $testString, $matchResult);
    };
    $java.jur_EOLSet_hasConsumed = function($this, $matchResult) {
        var $res;
        $res = !$java.jur_MatchResultImpl_getConsumed($matchResult, $this.$consCounter) ? 0 : 1;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter, (-1));
        return $res;
    };
    $java.jur_EOLSet_getName = function($this) {
        return $rt_s(2877);
    };
    $java.jur_EOISet = $rt_classWithoutFields(jur_AbstractSet);
    $java.jur_EOISet_matches = function($this, $stringIndex, $testString, $matchResult) {
        if ($stringIndex < ($matchResult.$transparentBounds ? jl_String_length($testString) : $matchResult.$rightBound0))
            return (-1);
        $matchResult.$hitEnd = 1;
        $matchResult.$requireEnd = 1;
        return $this.$next12.$matches1($stringIndex, $testString, $matchResult);
    };
    $java.jur_EOISet_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_EOISet_getName = function($this) {
        return $rt_s(2878);
    };
    $java.jur_MultiLineSOLSet = function() {
        jur_AbstractSet.call(this);
        this.$lt1 = null;
    };
    $java.jur_MultiLineSOLSet_matches = function($this, $strIndex, $testString, $matchResult) {
        a: {
            if ($strIndex != $matchResult.$rightBound0) {
                if (!$strIndex)
                    break a;
                if ($matchResult.$anchoringBounds && $strIndex == $matchResult.$leftBound0)
                    break a;
                if ($this.$lt1.$isAfterLineTerminator(jl_String_charAt($testString, $strIndex - 1 | 0), jl_String_charAt($testString, $strIndex)))
                    break a;
            }
            return (-1);
        }
        return $this.$next12.$matches1($strIndex, $testString, $matchResult);
    };
    $java.jur_MultiLineSOLSet_hasConsumed = function($this, $matchResult) {
        return 0;
    };
    $java.jur_MultiLineSOLSet_getName = function($this) {
        return $rt_s(996);
    };
    $java.jur_DotAllSet = $rt_classWithoutFields($java.jur_JointSet);
    $java.jur_DotAllSet__init_ = function() {
        var var_0 = new $java.jur_DotAllSet();
        $java.jur_DotAllSet__init_0(var_0);
        return var_0;
    };
    $java.jur_DotAllSet__init_0 = function($this) {
        $java.jur_AbstractSet__init_($this);
    };
    $java.jur_DotAllSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength, var$5, $high, var$7;
        $strLength = $matchResult.$rightBound0;
        var$5 = $stringIndex + 1 | 0;
        if (var$5 > $strLength) {
            $matchResult.$hitEnd = 1;
            return (-1);
        }
        $high = jl_String_charAt($testString, $stringIndex);
        if (jl_Character_isHighSurrogate($high)) {
            var$7 = $stringIndex + 2 | 0;
            if (var$7 <= $strLength && jl_Character_isSurrogatePair($high, jl_String_charAt($testString, var$5)))
                return $this.$next12.$matches1(var$7, $testString, $matchResult);
        }
        return $this.$next12.$matches1(var$5, $testString, $matchResult);
    };
    $java.jur_DotAllSet_getName = function($this) {
        return $rt_s(2879);
    };
    $java.jur_DotAllSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_DotAllSet_getType = function($this) {
        return (-2147483602);
    };
    $java.jur_DotAllSet_hasConsumed = function($this, $matchResult) {
        return 1;
    };
    $java.jur_DotSet = function() {
        $java.jur_JointSet.call(this);
        this.$lt2 = null;
    };
    $java.jur_DotSet__init_ = function(var_0) {
        var var_1 = new $java.jur_DotSet();
        $java.jur_DotSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_DotSet__init_0 = function($this, $lt) {
        $java.jur_AbstractSet__init_($this);
        $this.$lt2 = $lt;
    };
    $java.jur_DotSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength, var$5, $high, $low;
        $strLength = $matchResult.$rightBound0;
        var$5 = $stringIndex + 1 | 0;
        if (var$5 > $strLength) {
            $matchResult.$hitEnd = 1;
            return (-1);
        }
        $high = jl_String_charAt($testString, $stringIndex);
        if (jl_Character_isHighSurrogate($high)) {
            $stringIndex = $stringIndex + 2 | 0;
            if ($stringIndex <= $strLength) {
                $low = jl_String_charAt($testString, var$5);
                if (jl_Character_isSurrogatePair($high, $low))
                    return $this.$lt2.$isLineTerminator(jl_Character_toCodePoint($high, $low)) ? (-1) : $this.$next12.$matches1($stringIndex, $testString, $matchResult);
            }
        }
        return $this.$lt2.$isLineTerminator($high) ? (-1) : $this.$next12.$matches1(var$5, $testString, $matchResult);
    };
    $java.jur_DotSet_getName = function($this) {
        return $rt_s(142);
    };
    $java.jur_DotSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_DotSet_getType = function($this) {
        return (-2147483602);
    };
    $java.jur_DotSet_hasConsumed = function($this, $matchResult) {
        return 1;
    };
    $java.jur_UEOLSet = function() {
        jur_AbstractSet.call(this);
        this.$consCounter0 = 0;
    };
    $java.jur_UEOLSet__init_ = function(var_0) {
        var var_1 = new $java.jur_UEOLSet();
        $java.jur_UEOLSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_UEOLSet__init_0 = function($this, $counter) {
        $java.jur_AbstractSet__init_($this);
        $this.$consCounter0 = $counter;
    };
    $java.jur_UEOLSet_matches = function($this, $strIndex, $testString, $matchResult) {
        var $rightBound;
        $rightBound = !$matchResult.$anchoringBounds ? jl_String_length($testString) : $matchResult.$rightBound0;
        if ($strIndex >= $rightBound) {
            $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter0, 0);
            return $this.$next12.$matches1($strIndex, $testString, $matchResult);
        }
        if (($rightBound - $strIndex | 0) == 1 && jl_String_charAt($testString, $strIndex) == 10) {
            $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter0, 1);
            return $this.$next12.$matches1($strIndex + 1 | 0, $testString, $matchResult);
        }
        return (-1);
    };
    $java.jur_UEOLSet_hasConsumed = function($this, $matchResult) {
        var $res;
        $res = !$java.jur_MatchResultImpl_getConsumed($matchResult, $this.$consCounter0) ? 0 : 1;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter0, (-1));
        return $res;
    };
    $java.jur_UEOLSet_getName = function($this) {
        return $rt_s(2877);
    };
    $java.jur_UMultiLineEOLSet = function() {
        jur_AbstractSet.call(this);
        this.$consCounter1 = 0;
    };
    $java.jur_UMultiLineEOLSet__init_ = function(var_0) {
        var var_1 = new $java.jur_UMultiLineEOLSet();
        $java.jur_UMultiLineEOLSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_UMultiLineEOLSet__init_0 = function($this, $counter) {
        $java.jur_AbstractSet__init_($this);
        $this.$consCounter1 = $counter;
    };
    $java.jur_UMultiLineEOLSet_matches = function($this, $strIndex, $testString, $matchResult) {
        if ((!$matchResult.$anchoringBounds ? jl_String_length($testString) - $strIndex | 0 : $matchResult.$rightBound0 - $strIndex | 0) <= 0) {
            $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter1, 0);
            return $this.$next12.$matches1($strIndex, $testString, $matchResult);
        }
        if (jl_String_charAt($testString, $strIndex) != 10)
            return (-1);
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter1, 1);
        return $this.$next12.$matches1($strIndex + 1 | 0, $testString, $matchResult);
    };
    $java.jur_UMultiLineEOLSet_hasConsumed = function($this, $matchResult) {
        var $res;
        $res = !$java.jur_MatchResultImpl_getConsumed($matchResult, $this.$consCounter1) ? 0 : 1;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter1, (-1));
        return $res;
    };
    $java.jur_UMultiLineEOLSet_getName = function($this) {
        return $rt_s(2880);
    };
    $java.jur_MultiLineEOLSet = function() {
        jur_AbstractSet.call(this);
        this.$consCounter2 = 0;
    };
    $java.jur_MultiLineEOLSet__init_ = function(var_0) {
        var var_1 = new $java.jur_MultiLineEOLSet();
        $java.jur_MultiLineEOLSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_MultiLineEOLSet__init_0 = function($this, $counter) {
        $java.jur_AbstractSet__init_($this);
        $this.$consCounter2 = $counter;
    };
    $java.jur_MultiLineEOLSet_matches = function($this, $strIndex, $testString, $matchResult) {
        var $strDif, $ch1, $ch2;
        $strDif = !$matchResult.$anchoringBounds ? jl_String_length($testString) - $strIndex | 0 : $matchResult.$rightBound0 - $strIndex | 0;
        if (!$strDif) {
            $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter2, 0);
            return $this.$next12.$matches1($strIndex, $testString, $matchResult);
        }
        if ($strDif < 2) {
            $ch1 = jl_String_charAt($testString, $strIndex);
            $ch2 = 97;
        } else {
            $ch1 = jl_String_charAt($testString, $strIndex);
            $ch2 = jl_String_charAt($testString, $strIndex + 1 | 0);
        }
        switch ($ch1) {
            case 10:
            case 133:
            case 8232:
            case 8233:
                $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter2, 0);
                return $this.$next12.$matches1($strIndex, $testString, $matchResult);
            case 13:
                if ($ch2 != 10) {
                    $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter2, 0);
                    return $this.$next12.$matches1($strIndex, $testString, $matchResult);
                }
                $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter2, 0);
                return $this.$next12.$matches1($strIndex, $testString, $matchResult);
            default:
        }
        return (-1);
    };
    $java.jur_MultiLineEOLSet_hasConsumed = function($this, $matchResult) {
        var $res;
        $res = !$java.jur_MatchResultImpl_getConsumed($matchResult, $this.$consCounter2) ? 0 : 1;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter2, (-1));
        return $res;
    };
    $java.jur_MultiLineEOLSet_getName = function($this) {
        return $rt_s(2881);
    };
    $java.jur_CIBackReferenceSet = function() {
        var a = this; $java.jur_JointSet.call(a);
        a.$referencedGroup = 0;
        a.$consCounter3 = 0;
    };
    $java.jur_CIBackReferenceSet__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_CIBackReferenceSet();
        $java.jur_CIBackReferenceSet__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_CIBackReferenceSet__init_0 = function($this, $groupIndex, $consCounter) {
        $java.jur_AbstractSet__init_($this);
        $this.$referencedGroup = $groupIndex;
        $this.$consCounter3 = $consCounter;
    };
    $java.jur_CIBackReferenceSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $group, $i, var$6, var$7;
        $group = $java.jur_CIBackReferenceSet_getString($this, $matchResult);
        if ($group !== null && ($stringIndex + jl_String_length($group) | 0) <= $matchResult.$rightBound0) {
            $i = 0;
            while (true) {
                if ($i >= jl_String_length($group)) {
                    $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter3, jl_String_length($group));
                    return $this.$next12.$matches1($stringIndex + jl_String_length($group) | 0, $testString, $matchResult);
                }
                var$6 = jl_String_charAt($group, $i);
                var$7 = $stringIndex + $i | 0;
                if (var$6 != jl_String_charAt($testString, var$7) && $java.jur_Pattern_getSupplement(jl_String_charAt($group, $i)) != jl_String_charAt($testString, var$7))
                    break;
                $i = $i + 1 | 0;
            }
            return (-1);
        }
        return (-1);
    };
    $java.jur_CIBackReferenceSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_CIBackReferenceSet_getString = function($this, $matchResult) {
        var var$2, var$3;
        var$2 = $this.$referencedGroup;
        var$3 = $java.jur_MatchResultImpl_getStart($matchResult, var$2);
        var$2 = $java.jur_MatchResultImpl_getEnd($matchResult, var$2);
        return (var$2 | var$3 | (var$2 - var$3 | 0)) >= 0 && var$2 <= jl_String_length($matchResult.$string4) ? jl_String_substring0($matchResult.$string4, var$3, var$2) : null;
    };
    $java.jur_CIBackReferenceSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$groupIndex0;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$2, $rt_s(2882)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_CIBackReferenceSet_hasConsumed = function($this, $matchResult) {
        var $res;
        $res = !$java.jur_MatchResultImpl_getConsumed($matchResult, $this.$consCounter3) ? 0 : 1;
        $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter3, (-1));
        return $res;
    };
    $java.jur_BackReferenceSet = $rt_classWithoutFields($java.jur_CIBackReferenceSet);
    $java.jur_BackReferenceSet__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_BackReferenceSet();
        $java.jur_BackReferenceSet__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_BackReferenceSet__init_0 = function($this, $groupIndex, $consCounter) {
        $java.jur_CIBackReferenceSet__init_0($this, $groupIndex, $consCounter);
    };
    $java.jur_BackReferenceSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $group, $shift;
        $group = $java.jur_CIBackReferenceSet_getString($this, $matchResult);
        if ($group !== null && ($stringIndex + jl_String_length($group) | 0) <= $matchResult.$rightBound0) {
            $shift = !jl_String_startsWith($testString, $group, $stringIndex) ? (-1) : jl_String_length($group);
            if ($shift < 0)
                return (-1);
            $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter3, $shift);
            return $this.$next12.$matches1($stringIndex + $shift | 0, $testString, $matchResult);
        }
        return (-1);
    };
    $java.jur_BackReferenceSet_find = function($this, $strIndex, $testString, $matchResult) {
        var $group, $strLength;
        $group = $java.jur_CIBackReferenceSet_getString($this, $matchResult);
        $strLength = $matchResult.$leftBound0;
        if ($group !== null && ($strIndex + jl_String_length($group) | 0) <= $strLength) {
            while (true) {
                if ($strIndex > $strLength)
                    return (-1);
                $strIndex = jl_String_indexOf1($testString, $group, $strIndex);
                if ($strIndex < 0)
                    return (-1);
                if ($this.$next12.$matches1($strIndex + jl_String_length($group) | 0, $testString, $matchResult) >= 0)
                    break;
                $strIndex = $strIndex + 1 | 0;
            }
            return $strIndex;
        }
        return (-1);
    };
    $java.jur_BackReferenceSet_findBack = function($this, $strIndex, $lastIndex, $testString, $matchResult) {
        var $group, var$6;
        $group = $java.jur_CIBackReferenceSet_getString($this, $matchResult);
        if ($group === null)
            return (-1);
        a: {
            while (true) {
                if ($lastIndex < $strIndex)
                    return (-1);
                var$6 = jl_Math_min($lastIndex, jl_String_length($testString) - jl_String_length($group) | 0);
                b: {
                    c: while (true) {
                        if (var$6 < 0) {
                            var$6 = (-1);
                            break b;
                        }
                        $lastIndex = 0;
                        while (true) {
                            if ($lastIndex >= jl_String_length($group))
                                break c;
                            if (jl_String_charAt($testString, var$6 + $lastIndex | 0) != jl_String_charAt($group, $lastIndex))
                                break;
                            $lastIndex = $lastIndex + 1 | 0;
                        }
                        var$6 = var$6 + (-1) | 0;
                    }
                }
                if (var$6 < 0)
                    break a;
                if (var$6 < $strIndex)
                    break a;
                if ($this.$next12.$matches1(var$6 + jl_String_length($group) | 0, $testString, $matchResult) >= 0)
                    break;
                $lastIndex = var$6 + (-1) | 0;
            }
            return var$6;
        }
        return (-1);
    };
    $java.jur_BackReferenceSet_first = function($this, $set) {
        return 1;
    };
    $java.jur_BackReferenceSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$groupIndex0;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$2, $rt_s(2883)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_UCIBackReferenceSet = function() {
        $java.jur_CIBackReferenceSet.call(this);
        this.$groupIndex1 = 0;
    };
    $java.jur_UCIBackReferenceSet__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_UCIBackReferenceSet();
        $java.jur_UCIBackReferenceSet__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_UCIBackReferenceSet__init_0 = function($this, $groupIndex, $consCounter) {
        $java.jur_CIBackReferenceSet__init_0($this, $groupIndex, $consCounter);
    };
    $java.jur_UCIBackReferenceSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $group, $i;
        $group = $java.jur_CIBackReferenceSet_getString($this, $matchResult);
        if ($group !== null && ($stringIndex + jl_String_length($group) | 0) <= $matchResult.$rightBound0) {
            $i = 0;
            while (true) {
                if ($i >= jl_String_length($group)) {
                    $java.jur_MatchResultImpl_setConsumed($matchResult, $this.$consCounter3, jl_String_length($group));
                    return $this.$next12.$matches1($stringIndex + jl_String_length($group) | 0, $testString, $matchResult);
                }
                if (jl_Character_toLowerCase(jl_Character_toUpperCase0(jl_String_charAt($group, $i))) != jl_Character_toLowerCase(jl_Character_toUpperCase0(jl_String_charAt($testString, $stringIndex + $i | 0))))
                    break;
                $i = $i + 1 | 0;
            }
            return (-1);
        }
        return (-1);
    };
    $java.jur_UCIBackReferenceSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$groupIndex1;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append0(jl_StringBuilder_append(var$2, $rt_s(2884)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var jl_StringBuffer = $rt_classWithoutFields(jl_AbstractStringBuilder);
    $java.jl_StringBuffer_insert = function($this, var$1, var$2, var$3, var$4) {
        jl_AbstractStringBuilder_insert5($this, var$1, var$2, var$3, var$4);
        return $this;
    };
    $java.jl_StringBuffer_append = function($this, var$1, var$2, var$3) {
        jl_AbstractStringBuilder_append4($this, var$1, var$2, var$3);
        return $this;
    };
    $java.jl_StringBuffer_insert0 = function($this, var$1, var$2, var$3, var$4) {
        jl_AbstractStringBuilder_insert4($this, var$1, var$2, var$3, var$4);
        return $this;
    };
    $java.jl_StringBuffer_append0 = function($this, var$1, var$2, var$3) {
        jl_AbstractStringBuilder_append3($this, var$1, var$2, var$3);
        return $this;
    };
    $java.jl_StringBuffer_ensureCapacity = function($this, var$1) {
        jl_AbstractStringBuilder_ensureCapacity($this, var$1);
    };
    $java.jl_StringBuffer_insert1 = function($this, var$1, var$2) {
        jl_AbstractStringBuilder_insert3($this, var$1, var$2);
        return $this;
    };
    $java.jl_StringBuffer_insert2 = function($this, var$1, var$2) {
        jl_AbstractStringBuilder_insert($this, var$1, var$2);
        return $this;
    };
    $java.jur_SequenceSet = function() {
        var a = this; $java.jur_LeafSet.call(a);
        a.$string2 = null;
        a.$leftToRight0 = null;
        a.$rightToLeft = null;
    };
    $java.jur_SequenceSet_accepts = function($this, $strIndex, $testString) {
        return !$java.jur_SequenceSet_startsWith($this, $testString, $strIndex) ? (-1) : $this.$charCount;
    };
    $java.jur_SequenceSet_find = function($this, $strIndex, $testString, $matchResult) {
        var $strLength, var$5, var$6;
        $strLength = $matchResult.$rightBound0;
        while (true) {
            if ($strIndex > $strLength)
                return (-1);
            var$5 = jl_String_charAt($this.$string2, $this.$charCount - 1 | 0);
            a: {
                while (true) {
                    var$6 = $this.$charCount;
                    if ($strIndex > ($strLength - var$6 | 0)) {
                        $strIndex = (-1);
                        break a;
                    }
                    var$6 = jl_String_charAt($testString, ($strIndex + var$6 | 0) - 1 | 0);
                    if (var$6 == var$5 && $java.jur_SequenceSet_startsWith($this, $testString, $strIndex))
                        break;
                    $strIndex = $strIndex + $java.jur_SequenceSet$IntHash_get($this.$leftToRight0, var$6) | 0;
                }
            }
            if ($strIndex < 0)
                return (-1);
            if ($this.$next12.$matches1($strIndex + $this.$charCount | 0, $testString, $matchResult) >= 0)
                break;
            $strIndex = $strIndex + 1 | 0;
        }
        return $strIndex;
    };
    $java.jur_SequenceSet_findBack = function($this, $strIndex, $lastIndex, $testString, $matchResult) {
        var var$5, var$6;
        while (true) {
            if ($lastIndex < $strIndex)
                return (-1);
            var$5 = jl_String_charAt($this.$string2, 0);
            var$6 = (jl_String_length($testString) - $lastIndex | 0) - $this.$charCount | 0;
            if (var$6 <= 0)
                $lastIndex = $lastIndex + var$6 | 0;
            a: {
                while (true) {
                    if ($lastIndex < $strIndex) {
                        $lastIndex = (-1);
                        break a;
                    }
                    var$6 = jl_String_charAt($testString, $lastIndex);
                    if (var$6 == var$5 && $java.jur_SequenceSet_startsWith($this, $testString, $lastIndex))
                        break;
                    $lastIndex = $lastIndex - $java.jur_SequenceSet$IntHash_get($this.$rightToLeft, var$6) | 0;
                }
            }
            if ($lastIndex < 0)
                return (-1);
            if ($this.$next12.$matches1($lastIndex + $this.$charCount | 0, $testString, $matchResult) >= 0)
                break;
            $lastIndex = $lastIndex + (-1) | 0;
        }
        return $lastIndex;
    };
    $java.jur_SequenceSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$string2;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2885)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_SequenceSet_first = function($this, $set) {
        var var$2;
        if ($set instanceof $java.jur_CharSet)
            return $set.$ch2 != jl_String_charAt($this.$string2, 0) ? 0 : 1;
        if ($set instanceof $java.jur_RangeSet)
            return $java.jur_RangeSet_accepts($set, 0, jl_String_substring0($this.$string2, 0, 1)) <= 0 ? 0 : 1;
        if (!($set instanceof $java.jur_SupplRangeSet)) {
            if (!($set instanceof $java.jur_SupplCharSet))
                return 1;
            return jl_String_length($this.$string2) > 1 && $set.$ch1 == jl_Character_toCodePoint(jl_String_charAt($this.$string2, 0), jl_String_charAt($this.$string2, 1)) ? 1 : 0;
        }
        a: {
            b: {
                $set = $set;
                if (!$set.$contains2(jl_String_charAt($this.$string2, 0))) {
                    if (jl_String_length($this.$string2) <= 1)
                        break b;
                    if (!$set.$contains2(jl_Character_toCodePoint(jl_String_charAt($this.$string2, 0), jl_String_charAt($this.$string2, 1))))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.jur_SequenceSet_startsWith = function($this, $str, $from) {
        var $i;
        $i = 0;
        while ($i < $this.$charCount) {
            if (jl_String_charAt($str, $i + $from | 0) != jl_String_charAt($this.$string2, $i))
                return 0;
            $i = $i + 1 | 0;
        }
        return 1;
    };
    $java.jur_UCISequenceSet = function() {
        $java.jur_LeafSet.call(this);
        this.$string5 = null;
    };
    $java.jur_UCISequenceSet__init_ = function(var_0) {
        var var_1 = new $java.jur_UCISequenceSet();
        $java.jur_UCISequenceSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_UCISequenceSet__init_0 = function($this, $substring) {
        var $res, $i;
        $java.jur_LeafSet__init_($this);
        $res = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($res);
        $i = 0;
        while ($i < $substring.$length0) {
            jl_AbstractStringBuilder_append($res, jl_Character_toLowerCase(jl_Character_toUpperCase0(jl_AbstractStringBuilder_charAt($substring, $i))));
            $i = $i + 1 | 0;
        }
        $this.$string5 = jl_AbstractStringBuilder_toString($res);
        $this.$charCount = $res.$length0;
    };
    $java.jur_UCISequenceSet_accepts = function($this, $strIndex, $testString) {
        var $i;
        $i = 0;
        while (true) {
            if ($i >= jl_String_length($this.$string5))
                return jl_String_length($this.$string5);
            if (jl_String_charAt($this.$string5, $i) != jl_Character_toLowerCase(jl_Character_toUpperCase0(jl_String_charAt($testString, $strIndex + $i | 0))))
                break;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_UCISequenceSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$string5;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2886)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_CISequenceSet = function() {
        $java.jur_LeafSet.call(this);
        this.$string3 = null;
    };
    $java.jur_CISequenceSet_accepts = function($this, $strIndex, $testString) {
        var $i, var$4, var$5;
        $i = 0;
        while (true) {
            if ($i >= jl_String_length($this.$string3))
                return jl_String_length($this.$string3);
            var$4 = jl_String_charAt($this.$string3, $i);
            var$5 = $strIndex + $i | 0;
            if (var$4 != jl_String_charAt($testString, var$5) && $java.jur_Pattern_getSupplement(jl_String_charAt($this.$string3, $i)) != jl_String_charAt($testString, var$5))
                break;
            $i = $i + 1 | 0;
        }
        return (-1);
    };
    $java.jur_CISequenceSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$string3;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2887)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var jur_AbstractCharClass$PredefinedCharacterClasses = $rt_classWithoutFields();
    $java.jur_AbstractCharClass$PredefinedCharacterClasses_space = null;
    $java.jur_AbstractCharClass$PredefinedCharacterClasses_digit = null;
    $java.jur_AbstractCharClass$PredefinedCharacterClasses_contents = null;
    function jur_AbstractCharClass$PredefinedCharacterClasses__clinit_() {
        $java.jur_AbstractCharClass$PredefinedCharacterClasses_space = $java.jur_AbstractCharClass$LazySpace__init_();
        $java.jur_AbstractCharClass$PredefinedCharacterClasses_digit = $java.jur_AbstractCharClass$LazyDigit__init_();
        $java.jur_AbstractCharClass$PredefinedCharacterClasses_contents = $rt_createArrayFromData($rt_arraycls(jl_Object), [$rt_createArrayFromData(jl_Object, [$rt_s(2888), $java.jur_AbstractCharClass$LazyLower__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2889), $java.jur_AbstractCharClass$LazyUpper__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2890), $java.jur_AbstractCharClass$LazyASCII__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2891), $java.jur_AbstractCharClass$LazyAlpha__init_()]),
        $rt_createArrayFromData(jl_Object, [$rt_s(2892), $java.jur_AbstractCharClass$PredefinedCharacterClasses_digit]), $rt_createArrayFromData(jl_Object, [$rt_s(2893), $java.jur_AbstractCharClass$LazyAlnum__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2894), $java.jur_AbstractCharClass$LazyPunct__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2895), $java.jur_AbstractCharClass$LazyGraph__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2896), $java.jur_AbstractCharClass$LazyPrint__init_()]),
        $rt_createArrayFromData(jl_Object, [$rt_s(2897), $java.jur_AbstractCharClass$LazyBlank__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2898), $java.jur_AbstractCharClass$LazyCntrl__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2899), $java.jur_AbstractCharClass$LazyXDigit__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2900), $java.jur_AbstractCharClass$LazyJavaLowerCase__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2901), $java.jur_AbstractCharClass$LazyJavaUpperCase__init_()]),
        $rt_createArrayFromData(jl_Object, [$rt_s(2902), $java.jur_AbstractCharClass$LazyJavaWhitespace__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2903), $java.jur_AbstractCharClass$LazyJavaMirrored__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2904), $java.jur_AbstractCharClass$LazyJavaDefined__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2905), $java.jur_AbstractCharClass$LazyJavaDigit__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2906), $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable__init_()]),
        $rt_createArrayFromData(jl_Object, [$rt_s(2907), $java.jur_AbstractCharClass$LazyJavaISOControl__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2908), $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2909), $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2910), $java.jur_AbstractCharClass$LazyJavaLetter__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2911), $java.jur_AbstractCharClass$LazyJavaLetterOrDigit__init_()]),
        $rt_createArrayFromData(jl_Object, [$rt_s(2912), $java.jur_AbstractCharClass$LazyJavaSpaceChar__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2913), $java.jur_AbstractCharClass$LazyJavaTitleCase__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2914), $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2915), $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2916), $java.jur_AbstractCharClass$PredefinedCharacterClasses_space]),
        $rt_createArrayFromData(jl_Object, [$rt_s(2917), $java.jur_AbstractCharClass$LazyWord__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2918), $java.jur_AbstractCharClass$LazyNonWord__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2919), $java.jur_AbstractCharClass$PredefinedCharacterClasses_space]), $rt_createArrayFromData(jl_Object, [$rt_s(2920), $java.jur_AbstractCharClass$LazyNonSpace__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2921), $java.jur_AbstractCharClass$PredefinedCharacterClasses_digit]),
        $rt_createArrayFromData(jl_Object, [$rt_s(2922), $java.jur_AbstractCharClass$LazyNonDigit__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(2923), $java.jur_AbstractCharClass$LazyRange__init_(0, 127)]), $rt_createArrayFromData(jl_Object, [$rt_s(2924), $java.jur_AbstractCharClass$LazyRange__init_(128, 255)]), $rt_createArrayFromData(jl_Object, [$rt_s(2925), $java.jur_AbstractCharClass$LazyRange__init_(256, 383)]), $rt_createArrayFromData(jl_Object, [$rt_s(2926), $java.jur_AbstractCharClass$LazyRange__init_(384,
        591)]), $rt_createArrayFromData(jl_Object, [$rt_s(2927), $java.jur_AbstractCharClass$LazyRange__init_(592, 687)]), $rt_createArrayFromData(jl_Object, [$rt_s(2928), $java.jur_AbstractCharClass$LazyRange__init_(688, 767)]), $rt_createArrayFromData(jl_Object, [$rt_s(2929), $java.jur_AbstractCharClass$LazyRange__init_(768, 879)]), $rt_createArrayFromData(jl_Object, [$rt_s(2930), $java.jur_AbstractCharClass$LazyRange__init_(880, 1023)]), $rt_createArrayFromData(jl_Object, [$rt_s(2931), $java.jur_AbstractCharClass$LazyRange__init_(1024,
        1279)]), $rt_createArrayFromData(jl_Object, [$rt_s(2932), $java.jur_AbstractCharClass$LazyRange__init_(1280, 1327)]), $rt_createArrayFromData(jl_Object, [$rt_s(2933), $java.jur_AbstractCharClass$LazyRange__init_(1328, 1423)]), $rt_createArrayFromData(jl_Object, [$rt_s(2934), $java.jur_AbstractCharClass$LazyRange__init_(1424, 1535)]), $rt_createArrayFromData(jl_Object, [$rt_s(2935), $java.jur_AbstractCharClass$LazyRange__init_(1536, 1791)]), $rt_createArrayFromData(jl_Object, [$rt_s(2936), $java.jur_AbstractCharClass$LazyRange__init_(1792,
        1871)]), $rt_createArrayFromData(jl_Object, [$rt_s(2937), $java.jur_AbstractCharClass$LazyRange__init_(1872, 1919)]), $rt_createArrayFromData(jl_Object, [$rt_s(2938), $java.jur_AbstractCharClass$LazyRange__init_(1920, 1983)]), $rt_createArrayFromData(jl_Object, [$rt_s(2939), $java.jur_AbstractCharClass$LazyRange__init_(2304, 2431)]), $rt_createArrayFromData(jl_Object, [$rt_s(2940), $java.jur_AbstractCharClass$LazyRange__init_(2432, 2559)]), $rt_createArrayFromData(jl_Object, [$rt_s(2941), $java.jur_AbstractCharClass$LazyRange__init_(2560,
        2687)]), $rt_createArrayFromData(jl_Object, [$rt_s(2942), $java.jur_AbstractCharClass$LazyRange__init_(2688, 2815)]), $rt_createArrayFromData(jl_Object, [$rt_s(2943), $java.jur_AbstractCharClass$LazyRange__init_(2816, 2943)]), $rt_createArrayFromData(jl_Object, [$rt_s(2944), $java.jur_AbstractCharClass$LazyRange__init_(2944, 3071)]), $rt_createArrayFromData(jl_Object, [$rt_s(2945), $java.jur_AbstractCharClass$LazyRange__init_(3072, 3199)]), $rt_createArrayFromData(jl_Object, [$rt_s(2946), $java.jur_AbstractCharClass$LazyRange__init_(3200,
        3327)]), $rt_createArrayFromData(jl_Object, [$rt_s(2947), $java.jur_AbstractCharClass$LazyRange__init_(3328, 3455)]), $rt_createArrayFromData(jl_Object, [$rt_s(2948), $java.jur_AbstractCharClass$LazyRange__init_(3456, 3583)]), $rt_createArrayFromData(jl_Object, [$rt_s(2949), $java.jur_AbstractCharClass$LazyRange__init_(3584, 3711)]), $rt_createArrayFromData(jl_Object, [$rt_s(2950), $java.jur_AbstractCharClass$LazyRange__init_(3712, 3839)]), $rt_createArrayFromData(jl_Object, [$rt_s(2951), $java.jur_AbstractCharClass$LazyRange__init_(3840,
        4095)]), $rt_createArrayFromData(jl_Object, [$rt_s(2952), $java.jur_AbstractCharClass$LazyRange__init_(4096, 4255)]), $rt_createArrayFromData(jl_Object, [$rt_s(2953), $java.jur_AbstractCharClass$LazyRange__init_(4256, 4351)]), $rt_createArrayFromData(jl_Object, [$rt_s(2954), $java.jur_AbstractCharClass$LazyRange__init_(4352, 4607)]), $rt_createArrayFromData(jl_Object, [$rt_s(2955), $java.jur_AbstractCharClass$LazyRange__init_(4608, 4991)]), $rt_createArrayFromData(jl_Object, [$rt_s(2956), $java.jur_AbstractCharClass$LazyRange__init_(4992,
        5023)]), $rt_createArrayFromData(jl_Object, [$rt_s(2957), $java.jur_AbstractCharClass$LazyRange__init_(5024, 5119)]), $rt_createArrayFromData(jl_Object, [$rt_s(2958), $java.jur_AbstractCharClass$LazyRange__init_(5120, 5759)]), $rt_createArrayFromData(jl_Object, [$rt_s(2959), $java.jur_AbstractCharClass$LazyRange__init_(5760, 5791)]), $rt_createArrayFromData(jl_Object, [$rt_s(2960), $java.jur_AbstractCharClass$LazyRange__init_(5792, 5887)]), $rt_createArrayFromData(jl_Object, [$rt_s(2961), $java.jur_AbstractCharClass$LazyRange__init_(5888,
        5919)]), $rt_createArrayFromData(jl_Object, [$rt_s(2962), $java.jur_AbstractCharClass$LazyRange__init_(5920, 5951)]), $rt_createArrayFromData(jl_Object, [$rt_s(2963), $java.jur_AbstractCharClass$LazyRange__init_(5952, 5983)]), $rt_createArrayFromData(jl_Object, [$rt_s(2964), $java.jur_AbstractCharClass$LazyRange__init_(5984, 6015)]), $rt_createArrayFromData(jl_Object, [$rt_s(2965), $java.jur_AbstractCharClass$LazyRange__init_(6016, 6143)]), $rt_createArrayFromData(jl_Object, [$rt_s(2966), $java.jur_AbstractCharClass$LazyRange__init_(6144,
        6319)]), $rt_createArrayFromData(jl_Object, [$rt_s(2967), $java.jur_AbstractCharClass$LazyRange__init_(6400, 6479)]), $rt_createArrayFromData(jl_Object, [$rt_s(2968), $java.jur_AbstractCharClass$LazyRange__init_(6480, 6527)]), $rt_createArrayFromData(jl_Object, [$rt_s(2969), $java.jur_AbstractCharClass$LazyRange__init_(6528, 6623)]), $rt_createArrayFromData(jl_Object, [$rt_s(2970), $java.jur_AbstractCharClass$LazyRange__init_(6624, 6655)]), $rt_createArrayFromData(jl_Object, [$rt_s(2971), $java.jur_AbstractCharClass$LazyRange__init_(6656,
        6687)]), $rt_createArrayFromData(jl_Object, [$rt_s(2972), $java.jur_AbstractCharClass$LazyRange__init_(7424, 7551)]), $rt_createArrayFromData(jl_Object, [$rt_s(2973), $java.jur_AbstractCharClass$LazyRange__init_(7552, 7615)]), $rt_createArrayFromData(jl_Object, [$rt_s(2974), $java.jur_AbstractCharClass$LazyRange__init_(7616, 7679)]), $rt_createArrayFromData(jl_Object, [$rt_s(2975), $java.jur_AbstractCharClass$LazyRange__init_(7680, 7935)]), $rt_createArrayFromData(jl_Object, [$rt_s(2976), $java.jur_AbstractCharClass$LazyRange__init_(7936,
        8191)]), $rt_createArrayFromData(jl_Object, [$rt_s(2977), $java.jur_AbstractCharClass$LazyRange__init_(8192, 8303)]), $rt_createArrayFromData(jl_Object, [$rt_s(2978), $java.jur_AbstractCharClass$LazyRange__init_(8304, 8351)]), $rt_createArrayFromData(jl_Object, [$rt_s(2979), $java.jur_AbstractCharClass$LazyRange__init_(8352, 8399)]), $rt_createArrayFromData(jl_Object, [$rt_s(2980), $java.jur_AbstractCharClass$LazyRange__init_(8400, 8447)]), $rt_createArrayFromData(jl_Object, [$rt_s(2981), $java.jur_AbstractCharClass$LazyRange__init_(8448,
        8527)]), $rt_createArrayFromData(jl_Object, [$rt_s(2982), $java.jur_AbstractCharClass$LazyRange__init_(8528, 8591)]), $rt_createArrayFromData(jl_Object, [$rt_s(2983), $java.jur_AbstractCharClass$LazyRange__init_(8592, 8703)]), $rt_createArrayFromData(jl_Object, [$rt_s(2984), $java.jur_AbstractCharClass$LazyRange__init_(8704, 8959)]), $rt_createArrayFromData(jl_Object, [$rt_s(2985), $java.jur_AbstractCharClass$LazyRange__init_(8960, 9215)]), $rt_createArrayFromData(jl_Object, [$rt_s(2986), $java.jur_AbstractCharClass$LazyRange__init_(9216,
        9279)]), $rt_createArrayFromData(jl_Object, [$rt_s(2987), $java.jur_AbstractCharClass$LazyRange__init_(9280, 9311)]), $rt_createArrayFromData(jl_Object, [$rt_s(2988), $java.jur_AbstractCharClass$LazyRange__init_(9312, 9471)]), $rt_createArrayFromData(jl_Object, [$rt_s(2989), $java.jur_AbstractCharClass$LazyRange__init_(9472, 9599)]), $rt_createArrayFromData(jl_Object, [$rt_s(2990), $java.jur_AbstractCharClass$LazyRange__init_(9600, 9631)]), $rt_createArrayFromData(jl_Object, [$rt_s(2991), $java.jur_AbstractCharClass$LazyRange__init_(9632,
        9727)]), $rt_createArrayFromData(jl_Object, [$rt_s(2992), $java.jur_AbstractCharClass$LazyRange__init_(9728, 9983)]), $rt_createArrayFromData(jl_Object, [$rt_s(2993), $java.jur_AbstractCharClass$LazyRange__init_(9984, 10175)]), $rt_createArrayFromData(jl_Object, [$rt_s(2994), $java.jur_AbstractCharClass$LazyRange__init_(10176, 10223)]), $rt_createArrayFromData(jl_Object, [$rt_s(2995), $java.jur_AbstractCharClass$LazyRange__init_(10224, 10239)]), $rt_createArrayFromData(jl_Object, [$rt_s(2996), $java.jur_AbstractCharClass$LazyRange__init_(10240,
        10495)]), $rt_createArrayFromData(jl_Object, [$rt_s(2997), $java.jur_AbstractCharClass$LazyRange__init_(10496, 10623)]), $rt_createArrayFromData(jl_Object, [$rt_s(2998), $java.jur_AbstractCharClass$LazyRange__init_(10624, 10751)]), $rt_createArrayFromData(jl_Object, [$rt_s(2999), $java.jur_AbstractCharClass$LazyRange__init_(10752, 11007)]), $rt_createArrayFromData(jl_Object, [$rt_s(3000), $java.jur_AbstractCharClass$LazyRange__init_(11008, 11263)]), $rt_createArrayFromData(jl_Object, [$rt_s(3001), $java.jur_AbstractCharClass$LazyRange__init_(11264,
        11359)]), $rt_createArrayFromData(jl_Object, [$rt_s(3002), $java.jur_AbstractCharClass$LazyRange__init_(11392, 11519)]), $rt_createArrayFromData(jl_Object, [$rt_s(3003), $java.jur_AbstractCharClass$LazyRange__init_(11520, 11567)]), $rt_createArrayFromData(jl_Object, [$rt_s(3004), $java.jur_AbstractCharClass$LazyRange__init_(11568, 11647)]), $rt_createArrayFromData(jl_Object, [$rt_s(3005), $java.jur_AbstractCharClass$LazyRange__init_(11648, 11743)]), $rt_createArrayFromData(jl_Object, [$rt_s(3006), $java.jur_AbstractCharClass$LazyRange__init_(11776,
        11903)]), $rt_createArrayFromData(jl_Object, [$rt_s(3007), $java.jur_AbstractCharClass$LazyRange__init_(11904, 12031)]), $rt_createArrayFromData(jl_Object, [$rt_s(3008), $java.jur_AbstractCharClass$LazyRange__init_(12032, 12255)]), $rt_createArrayFromData(jl_Object, [$rt_s(3009), $java.jur_AbstractCharClass$LazyRange__init_(12272, 12287)]), $rt_createArrayFromData(jl_Object, [$rt_s(3010), $java.jur_AbstractCharClass$LazyRange__init_(12288, 12351)]), $rt_createArrayFromData(jl_Object, [$rt_s(3011), $java.jur_AbstractCharClass$LazyRange__init_(12352,
        12447)]), $rt_createArrayFromData(jl_Object, [$rt_s(3012), $java.jur_AbstractCharClass$LazyRange__init_(12448, 12543)]), $rt_createArrayFromData(jl_Object, [$rt_s(3013), $java.jur_AbstractCharClass$LazyRange__init_(12544, 12591)]), $rt_createArrayFromData(jl_Object, [$rt_s(3014), $java.jur_AbstractCharClass$LazyRange__init_(12592, 12687)]), $rt_createArrayFromData(jl_Object, [$rt_s(3015), $java.jur_AbstractCharClass$LazyRange__init_(12688, 12703)]), $rt_createArrayFromData(jl_Object, [$rt_s(3016), $java.jur_AbstractCharClass$LazyRange__init_(12704,
        12735)]), $rt_createArrayFromData(jl_Object, [$rt_s(3017), $java.jur_AbstractCharClass$LazyRange__init_(12736, 12783)]), $rt_createArrayFromData(jl_Object, [$rt_s(3018), $java.jur_AbstractCharClass$LazyRange__init_(12784, 12799)]), $rt_createArrayFromData(jl_Object, [$rt_s(3019), $java.jur_AbstractCharClass$LazyRange__init_(12800, 13055)]), $rt_createArrayFromData(jl_Object, [$rt_s(3020), $java.jur_AbstractCharClass$LazyRange__init_(13056, 13311)]), $rt_createArrayFromData(jl_Object, [$rt_s(3021), $java.jur_AbstractCharClass$LazyRange__init_(13312,
        19893)]), $rt_createArrayFromData(jl_Object, [$rt_s(3022), $java.jur_AbstractCharClass$LazyRange__init_(19904, 19967)]), $rt_createArrayFromData(jl_Object, [$rt_s(3023), $java.jur_AbstractCharClass$LazyRange__init_(19968, 40959)]), $rt_createArrayFromData(jl_Object, [$rt_s(3024), $java.jur_AbstractCharClass$LazyRange__init_(40960, 42127)]), $rt_createArrayFromData(jl_Object, [$rt_s(3025), $java.jur_AbstractCharClass$LazyRange__init_(42128, 42191)]), $rt_createArrayFromData(jl_Object, [$rt_s(3026), $java.jur_AbstractCharClass$LazyRange__init_(42752,
        42783)]), $rt_createArrayFromData(jl_Object, [$rt_s(3027), $java.jur_AbstractCharClass$LazyRange__init_(43008, 43055)]), $rt_createArrayFromData(jl_Object, [$rt_s(3028), $java.jur_AbstractCharClass$LazyRange__init_(44032, 55203)]), $rt_createArrayFromData(jl_Object, [$rt_s(3029), $java.jur_AbstractCharClass$LazyRange__init_(55296, 56191)]), $rt_createArrayFromData(jl_Object, [$rt_s(3030), $java.jur_AbstractCharClass$LazyRange__init_(56192, 56319)]), $rt_createArrayFromData(jl_Object, [$rt_s(3031), $java.jur_AbstractCharClass$LazyRange__init_(56320,
        57343)]), $rt_createArrayFromData(jl_Object, [$rt_s(3032), $java.jur_AbstractCharClass$LazyRange__init_(57344, 63743)]), $rt_createArrayFromData(jl_Object, [$rt_s(3033), $java.jur_AbstractCharClass$LazyRange__init_(63744, 64255)]), $rt_createArrayFromData(jl_Object, [$rt_s(3034), $java.jur_AbstractCharClass$LazyRange__init_(64256, 64335)]), $rt_createArrayFromData(jl_Object, [$rt_s(3035), $java.jur_AbstractCharClass$LazyRange__init_(64336, 65023)]), $rt_createArrayFromData(jl_Object, [$rt_s(3036), $java.jur_AbstractCharClass$LazyRange__init_(65024,
        65039)]), $rt_createArrayFromData(jl_Object, [$rt_s(3037), $java.jur_AbstractCharClass$LazyRange__init_(65040, 65055)]), $rt_createArrayFromData(jl_Object, [$rt_s(3038), $java.jur_AbstractCharClass$LazyRange__init_(65056, 65071)]), $rt_createArrayFromData(jl_Object, [$rt_s(3039), $java.jur_AbstractCharClass$LazyRange__init_(65072, 65103)]), $rt_createArrayFromData(jl_Object, [$rt_s(3040), $java.jur_AbstractCharClass$LazyRange__init_(65104, 65135)]), $rt_createArrayFromData(jl_Object, [$rt_s(3041), $java.jur_AbstractCharClass$LazyRange__init_(65136,
        65279)]), $rt_createArrayFromData(jl_Object, [$rt_s(3042), $java.jur_AbstractCharClass$LazyRange__init_(65280, 65519)]), $rt_createArrayFromData(jl_Object, [$rt_s(156), $java.jur_AbstractCharClass$LazyRange__init_(0, 1114111)]), $rt_createArrayFromData(jl_Object, [$rt_s(3043), $java.jur_AbstractCharClass$LazySpecialsBlock__init_()]), $rt_createArrayFromData(jl_Object, [$rt_s(3044), $java.jur_AbstractCharClass$LazyCategory__init_(0, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3045), $java.jur_AbstractCharClass$LazyCategoryScope__init_(62,
        1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3046), $java.jur_AbstractCharClass$LazyCategory__init_(1, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3047), $java.jur_AbstractCharClass$LazyCategory__init_(2, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3048), $java.jur_AbstractCharClass$LazyCategory__init_(3, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3049), $java.jur_AbstractCharClass$LazyCategory__init_(4, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3050), $java.jur_AbstractCharClass$LazyCategory__init_(5,
        1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3051), $java.jur_AbstractCharClass$LazyCategoryScope__init_(448, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3052), $java.jur_AbstractCharClass$LazyCategory__init_(6, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3053), $java.jur_AbstractCharClass$LazyCategory__init_(7, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3054), $java.jur_AbstractCharClass$LazyCategory__init_(8, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3055), $java.jur_AbstractCharClass$LazyCategoryScope__init_(3584,
        1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3056), $java.jur_AbstractCharClass$LazyCategory__init_(9, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3057), $java.jur_AbstractCharClass$LazyCategory__init_(10, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3058), $java.jur_AbstractCharClass$LazyCategory__init_(11, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3059), $java.jur_AbstractCharClass$LazyCategoryScope__init_(28672, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3060), $java.jur_AbstractCharClass$LazyCategory__init_(12,
        0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3061), $java.jur_AbstractCharClass$LazyCategory__init_(13, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3062), $java.jur_AbstractCharClass$LazyCategory__init_(14, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3063), $java.jur_AbstractCharClass$LazyCategoryScope__init_0(983040, 1, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3064), $java.jur_AbstractCharClass$LazyCategory__init_(15, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3065), $java.jur_AbstractCharClass$LazyCategory__init_(16,
        1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3066), $java.jur_AbstractCharClass$LazyCategory__init_(18, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3067), $java.jur_AbstractCharClass$LazyCategory__init_0(19, 0, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3068), $java.jur_AbstractCharClass$LazyCategoryScope__init_(1643118592, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3069), $java.jur_AbstractCharClass$LazyCategory__init_(20, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3070), $java.jur_AbstractCharClass$LazyCategory__init_(21,
        0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3071), $java.jur_AbstractCharClass$LazyCategory__init_(22, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3072), $java.jur_AbstractCharClass$LazyCategory__init_(23, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3073), $java.jur_AbstractCharClass$LazyCategory__init_(24, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3074), $java.jur_AbstractCharClass$LazyCategoryScope__init_(2113929216, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3075), $java.jur_AbstractCharClass$LazyCategory__init_(25,
        1)]), $rt_createArrayFromData(jl_Object, [$rt_s(3076), $java.jur_AbstractCharClass$LazyCategory__init_(26, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3077), $java.jur_AbstractCharClass$LazyCategory__init_(27, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3078), $java.jur_AbstractCharClass$LazyCategory__init_(28, 1)]), $rt_createArrayFromData(jl_Object, [$rt_s(2463), $java.jur_AbstractCharClass$LazyCategory__init_(29, 0)]), $rt_createArrayFromData(jl_Object, [$rt_s(3079), $java.jur_AbstractCharClass$LazyCategory__init_(30,
        0)])]);
    }
    $java.jur_UCISupplCharSet = function() {
        $java.jur_LeafSet.call(this);
        this.$ch0 = 0;
    };
    $java.jur_UCISupplCharSet_accepts = function($this, $strIndex, $testString) {
        var $low, $high;
        $low = $strIndex + 1 | 0;
        $high = jl_String_charAt($testString, $strIndex);
        $low = jl_String_charAt($testString, $low);
        return $this.$ch0 != jl_Character_toLowerCase0(jl_Character_toUpperCase(jl_Character_toCodePoint($high, $low))) ? (-1) : 2;
    };
    $java.jur_UCISupplCharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = jl_String__init_(jl_Character_toChars($this.$ch0));
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(2869)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_LowSurrogateCharSet = function() {
        $java.jur_JointSet.call(this);
        this.$low0 = 0;
    };
    $java.jur_LowSurrogateCharSet__init_ = function(var_0) {
        var var_1 = new $java.jur_LowSurrogateCharSet();
        $java.jur_LowSurrogateCharSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_LowSurrogateCharSet__init_0 = function($this, $low) {
        $java.jur_AbstractSet__init_($this);
        $this.$low0 = $low;
    };
    $java.jur_LowSurrogateCharSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_LowSurrogateCharSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var var$4, $low;
        var$4 = $stringIndex + 1 | 0;
        if (var$4 > $matchResult.$rightBound0) {
            $matchResult.$hitEnd = 1;
            return (-1);
        }
        $low = jl_String_charAt($testString, $stringIndex);
        if ($stringIndex > $matchResult.$leftBound0 && jl_Character_isHighSurrogate(jl_String_charAt($testString, $stringIndex - 1 | 0)))
            return (-1);
        if ($this.$low0 != $low)
            return (-1);
        return $this.$next12.$matches1(var$4, $testString, $matchResult);
    };
    $java.jur_LowSurrogateCharSet_find = function($this, $strIndex, $testStr, $matchResult) {
        var $startStr, $strLength, var$6, var$7;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_find($this, $strIndex, $testStr, $matchResult);
        $startStr = $matchResult.$leftBound0;
        $strLength = $matchResult.$rightBound0;
        while (true) {
            if ($strIndex >= $strLength)
                return (-1);
            var$6 = jl_String_indexOf($testStr, $this.$low0, $strIndex);
            if (var$6 < 0)
                return (-1);
            if (var$6 > $startStr && jl_Character_isHighSurrogate(jl_String_charAt($testStr, var$6 - 1 | 0))) {
                $strIndex = var$6 + 1 | 0;
                continue;
            }
            var$7 = $this.$next12;
            $strIndex = var$6 + 1 | 0;
            if (var$7.$matches1($strIndex, $testStr, $matchResult) >= 0)
                break;
        }
        return var$6;
    };
    $java.jur_LowSurrogateCharSet_findBack = function($this, $strIndex, $lastIndex, $testStr, $matchResult) {
        var $startStr, var$6;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_findBack($this, $strIndex, $lastIndex, $testStr, $matchResult);
        $startStr = $matchResult.$leftBound0;
        a: {
            while (true) {
                if ($lastIndex < $strIndex)
                    return (-1);
                var$6 = jl_String_lastIndexOf0($testStr, $this.$low0, $lastIndex);
                if (var$6 < 0)
                    break a;
                if (var$6 < $strIndex)
                    break a;
                if (var$6 > $startStr && jl_Character_isHighSurrogate(jl_String_charAt($testStr, var$6 - 1 | 0))) {
                    $lastIndex = var$6 + (-2) | 0;
                    continue;
                }
                if ($this.$next12.$matches1(var$6 + 1 | 0, $testStr, $matchResult) >= 0)
                    break;
                $lastIndex = var$6 + (-1) | 0;
            }
            return var$6;
        }
        return (-1);
    };
    $java.jur_LowSurrogateCharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$low0;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_LowSurrogateCharSet_first = function($this, $set) {
        if ($set instanceof $java.jur_CharSet)
            return 0;
        if ($set instanceof $java.jur_RangeSet)
            return 0;
        if ($set instanceof $java.jur_SupplRangeSet)
            return 0;
        if ($set instanceof $java.jur_SupplCharSet)
            return 0;
        if ($set instanceof $java.jur_HighSurrogateCharSet)
            return 0;
        if (!($set instanceof $java.jur_LowSurrogateCharSet))
            return 1;
        return $set.$low0 != $this.$low0 ? 0 : 1;
    };
    $java.jur_LowSurrogateCharSet_hasConsumed = function($this, $matchResult) {
        return 1;
    };
    $java.jur_HighSurrogateCharSet = function() {
        $java.jur_JointSet.call(this);
        this.$high0 = 0;
    };
    $java.jur_HighSurrogateCharSet__init_ = function(var_0) {
        var var_1 = new $java.jur_HighSurrogateCharSet();
        $java.jur_HighSurrogateCharSet__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_HighSurrogateCharSet__init_0 = function($this, $high) {
        $java.jur_AbstractSet__init_($this);
        $this.$high0 = $high;
    };
    $java.jur_HighSurrogateCharSet_setNext = function($this, $next) {
        $this.$next12 = $next;
    };
    $java.jur_HighSurrogateCharSet_matches = function($this, $stringIndex, $testString, $matchResult) {
        var $strLength, var$5, $low, $high;
        $strLength = $matchResult.$rightBound0;
        var$5 = $stringIndex + 1 | 0;
        $low = $rt_compare(var$5, $strLength);
        if ($low > 0) {
            $matchResult.$hitEnd = 1;
            return (-1);
        }
        $high = jl_String_charAt($testString, $stringIndex);
        if ($low < 0 && jl_Character_isLowSurrogate(jl_String_charAt($testString, var$5)))
            return (-1);
        if ($this.$high0 != $high)
            return (-1);
        return $this.$next12.$matches1(var$5, $testString, $matchResult);
    };
    $java.jur_HighSurrogateCharSet_find = function($this, $strIndex, $testStr, $matchResult) {
        var $strLength, var$5;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_find($this, $strIndex, $testStr, $matchResult);
        $strLength = $matchResult.$rightBound0;
        while (true) {
            if ($strIndex >= $strLength)
                return (-1);
            var$5 = jl_String_indexOf($testStr, $this.$high0, $strIndex);
            if (var$5 < 0)
                return (-1);
            $strIndex = var$5 + 1 | 0;
            if ($strIndex < $strLength && jl_Character_isLowSurrogate(jl_String_charAt($testStr, $strIndex))) {
                $strIndex = var$5 + 2 | 0;
                continue;
            }
            if ($this.$next12.$matches1($strIndex, $testStr, $matchResult) >= 0)
                break;
        }
        return var$5;
    };
    $java.jur_HighSurrogateCharSet_findBack = function($this, $strIndex, $lastIndex, $testStr, $matchResult) {
        var $strLength, var$6;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_findBack($this, $strIndex, $lastIndex, $testStr, $matchResult);
        $strLength = $matchResult.$rightBound0;
        a: {
            while (true) {
                if ($lastIndex < $strIndex)
                    return (-1);
                var$6 = jl_String_lastIndexOf0($testStr, $this.$high0, $lastIndex);
                if (var$6 < 0)
                    break a;
                if (var$6 < $strIndex)
                    break a;
                $lastIndex = var$6 + 1 | 0;
                if ($lastIndex < $strLength && jl_Character_isLowSurrogate(jl_String_charAt($testStr, $lastIndex))) {
                    $lastIndex = var$6 + (-1) | 0;
                    continue;
                }
                if ($this.$next12.$matches1($lastIndex, $testStr, $matchResult) >= 0)
                    break;
                $lastIndex = var$6 + (-1) | 0;
            }
            return var$6;
        }
        return (-1);
    };
    $java.jur_HighSurrogateCharSet_getName = function($this) {
        var var$1, var$2;
        var$1 = $this.$high0;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_HighSurrogateCharSet_first = function($this, $set) {
        if ($set instanceof $java.jur_CharSet)
            return 0;
        if ($set instanceof $java.jur_RangeSet)
            return 0;
        if ($set instanceof $java.jur_SupplRangeSet)
            return 0;
        if ($set instanceof $java.jur_SupplCharSet)
            return 0;
        if ($set instanceof $java.jur_LowSurrogateCharSet)
            return 0;
        if (!($set instanceof $java.jur_HighSurrogateCharSet))
            return 1;
        return $set.$high0 != $this.$high0 ? 0 : 1;
    };
    $java.jur_HighSurrogateCharSet_hasConsumed = function($this, $matchResult) {
        return 1;
    };
    $java.jur_SupplCharSet = function() {
        var a = this; $java.jur_LeafSet.call(a);
        a.$high = 0;
        a.$low = 0;
        a.$ch1 = 0;
    };
    $java.jur_SupplCharSet_accepts = function($this, $strIndex, $testString) {
        var $low, $high;
        $low = $strIndex + 1 | 0;
        $high = jl_String_charAt($testString, $strIndex);
        $low = jl_String_charAt($testString, $low);
        return $this.$high == $high && $this.$low == $low ? 2 : (-1);
    };
    $java.jur_SupplCharSet_find = function($this, $strIndex, $testStr, $matchResult) {
        var $strLength, $ch;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_find($this, $strIndex, $testStr, $matchResult);
        $strLength = $matchResult.$rightBound0;
        while ($strIndex < $strLength) {
            $strIndex = jl_String_indexOf($testStr, $this.$high, $strIndex);
            if ($strIndex < 0)
                return (-1);
            $strIndex = $strIndex + 1 | 0;
            if ($strIndex >= $strLength)
                continue;
            $ch = jl_String_charAt($testStr, $strIndex);
            if ($this.$low == $ch && $this.$next12.$matches1($strIndex + 1 | 0, $testStr, $matchResult) >= 0)
                return $strIndex + (-1) | 0;
            $strIndex = $strIndex + 1 | 0;
        }
        return (-1);
    };
    $java.jur_SupplCharSet_findBack = function($this, $strIndex, $lastIndex, $testStr, $matchResult) {
        var var$5;
        if (!($testStr instanceof jl_String))
            return $java.jur_AbstractSet_findBack($this, $strIndex, $lastIndex, $testStr, $matchResult);
        a: {
            while (true) {
                if ($lastIndex < $strIndex)
                    return (-1);
                var$5 = jl_String_lastIndexOf0($testStr, $this.$low, $lastIndex) + (-1) | 0;
                if (var$5 < 0)
                    break a;
                if (var$5 < $strIndex)
                    break a;
                if ($this.$high == jl_String_charAt($testStr, var$5) && $this.$next12.$matches1(var$5 + 2 | 0, $testStr, $matchResult) >= 0)
                    break;
                $lastIndex = var$5 + (-1) | 0;
            }
            return var$5;
        }
        return (-1);
    };
    $java.jur_SupplCharSet_getName = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$high;
        var$2 = $this.$low;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_AbstractStringBuilder_append(var$3, var$1);
        jl_AbstractStringBuilder_append(var$3, var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.jur_SupplCharSet_first = function($this, $set) {
        if ($set instanceof $java.jur_SupplCharSet)
            return $set.$ch1 != $this.$ch1 ? 0 : 1;
        if ($set instanceof $java.jur_SupplRangeSet)
            return $set.$contains2($this.$ch1);
        if ($set instanceof $java.jur_CharSet)
            return 0;
        if (!($set instanceof $java.jur_RangeSet))
            return 1;
        return 0;
    };
    $java.jur_AbstractLineTerminator$1 = $rt_classWithoutFields($java.jur_AbstractLineTerminator);
    $java.jur_AbstractLineTerminator$1_isLineTerminator = function($this, $ch) {
        return $ch != 10 ? 0 : 1;
    };
    $java.jur_AbstractLineTerminator$1_isAfterLineTerminator = function($this, $ch, $ch2) {
        return $ch != 10 ? 0 : 1;
    };
    $java.jur_AbstractLineTerminator$2 = $rt_classWithoutFields($java.jur_AbstractLineTerminator);
    $java.jur_AbstractLineTerminator$2_isLineTerminator = function($this, $ch) {
        return $ch != 10 && $ch != 13 && $ch != 133 && ($ch | 1) != 8233 ? 0 : 1;
    };
    $java.jur_AbstractLineTerminator$2_isAfterLineTerminator = function($this, $ch, $ch2) {
        a: {
            b: {
                if ($ch != 10 && $ch != 133 && ($ch | 1) != 8233) {
                    if ($ch != 13)
                        break b;
                    if ($ch2 == 10)
                        break b;
                }
                $ch = 1;
                break a;
            }
            $ch = 0;
        }
        return $ch;
    };
    $java.jur_SequenceSet$IntHash = function() {
        var a = this; jl_Object.call(a);
        a.$table = null;
        a.$values1 = null;
        a.$mask = 0;
        a.$size11 = 0;
    };
    $java.jur_SequenceSet$IntHash__init_ = function(var_0) {
        var var_1 = new $java.jur_SequenceSet$IntHash();
        $java.jur_SequenceSet$IntHash__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_SequenceSet$IntHash__init_0 = function($this, $size) {
        var var$2, var$3;
        while (true) {
            var$2 = $this.$mask;
            if ($size < var$2)
                break;
            $this.$mask = var$2 << 1 | 1;
        }
        var$3 = var$2 << 1 | 1;
        $this.$mask = var$3;
        var$3 = var$3 + 1 | 0;
        $this.$table = $rt_createIntArray(var$3);
        $this.$values1 = $rt_createIntArray(var$3);
        $this.$size11 = $size;
    };
    $java.jur_SequenceSet$IntHash_put = function($this, $key, $value) {
        var $i, var$4, $hashCode, var$6;
        $i = 0;
        var$4 = $this.$mask;
        $hashCode = $key & var$4;
        while (true) {
            var$6 = $this.$table.data;
            if (!var$6[$hashCode])
                break;
            if (var$6[$hashCode] == $key)
                break;
            $i = ($i + 1 | 0) & var$4;
            $hashCode = ($hashCode + $i | 0) & var$4;
        }
        var$6[$hashCode] = $key;
        $this.$values1.data[$hashCode] = $value;
    };
    $java.jur_SequenceSet$IntHash_get = function($this, $key) {
        var var$2, $hashCode, $i, $storedKey;
        var$2 = $this.$mask;
        $hashCode = $key & var$2;
        $i = 0;
        while (true) {
            $storedKey = $this.$table.data[$hashCode];
            if (!$storedKey)
                break;
            if ($storedKey == $key)
                return $this.$values1.data[$hashCode];
            $i = ($i + 1 | 0) & var$2;
            $hashCode = ($hashCode + $i | 0) & var$2;
        }
        return $this.$size11;
    };
    $java.jur_IntHash = $rt_classWithoutFields();
    $java.jur_AbstractCharClass$LazySpace = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazySpace__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazySpace();
        $java.jur_AbstractCharClass$LazySpace__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazySpace__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazySpace_computeValue = function($this) {
        return $java.jur_CharClass_add($java.jur_CharClass_add0($java.jur_CharClass__init_0(), 9, 13), 32);
    };
    $java.jur_AbstractCharClass$LazyDigit = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyDigit__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyDigit();
        $java.jur_AbstractCharClass$LazyDigit__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyDigit__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyDigit_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass__init_0(), 48, 57);
    };
    $java.jur_AbstractCharClass$LazyLower = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyLower__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyLower();
        $java.jur_AbstractCharClass$LazyLower__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyLower__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyLower_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass__init_0(), 97, 122);
    };
    $java.jur_AbstractCharClass$LazyUpper = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyUpper__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyUpper();
        $java.jur_AbstractCharClass$LazyUpper__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyUpper__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyUpper_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass__init_0(), 65, 90);
    };
    $java.jur_AbstractCharClass$LazyASCII = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyASCII__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyASCII();
        $java.jur_AbstractCharClass$LazyASCII__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyASCII__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyASCII_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass__init_0(), 0, 127);
    };
    $java.jur_AbstractCharClass$LazyAlpha = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyAlpha__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyAlpha();
        $java.jur_AbstractCharClass$LazyAlpha__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyAlpha__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyAlpha_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass__init_0(), 97, 122), 65, 90);
    };
    $java.jur_AbstractCharClass$LazyAlnum = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyAlpha);
    $java.jur_AbstractCharClass$LazyAlnum__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyAlnum();
        $java.jur_AbstractCharClass$LazyAlnum__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyAlnum__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyAlnum_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_AbstractCharClass$LazyAlpha_computeValue($this), 48, 57);
    };
    $java.jur_AbstractCharClass$LazyPunct = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyPunct__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyPunct();
        $java.jur_AbstractCharClass$LazyPunct__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyPunct__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyPunct_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass__init_0(), 33, 64), 91, 96), 123, 126);
    };
    $java.jur_AbstractCharClass$LazyGraph = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyAlnum);
    $java.jur_AbstractCharClass$LazyGraph__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyGraph();
        $java.jur_AbstractCharClass$LazyGraph__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyGraph__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyGraph_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_AbstractCharClass$LazyAlnum_computeValue($this), 33, 64), 91, 96), 123, 126);
    };
    $java.jur_AbstractCharClass$LazyPrint = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyGraph);
    $java.jur_AbstractCharClass$LazyPrint__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyPrint();
        $java.jur_AbstractCharClass$LazyPrint__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyPrint__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyPrint_computeValue = function($this) {
        return $java.jur_CharClass_add($java.jur_AbstractCharClass$LazyGraph_computeValue($this), 32);
    };
    $java.jur_AbstractCharClass$LazyBlank = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyBlank__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyBlank();
        $java.jur_AbstractCharClass$LazyBlank__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyBlank__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyBlank_computeValue = function($this) {
        return $java.jur_CharClass_add($java.jur_CharClass_add($java.jur_CharClass__init_0(), 32), 9);
    };
    $java.jur_AbstractCharClass$LazyCntrl = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyCntrl__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyCntrl();
        $java.jur_AbstractCharClass$LazyCntrl__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyCntrl__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyCntrl_computeValue = function($this) {
        return $java.jur_CharClass_add($java.jur_CharClass_add0($java.jur_CharClass__init_0(), 0, 31), 127);
    };
    $java.jur_AbstractCharClass$LazyXDigit = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyXDigit__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyXDigit();
        $java.jur_AbstractCharClass$LazyXDigit__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyXDigit__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyXDigit_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass__init_0(), 48, 57), 97, 102), 65, 70);
    };
    $java.jur_AbstractCharClass$LazyJavaLowerCase = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaLowerCase__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaLowerCase();
        $java.jur_AbstractCharClass$LazyJavaLowerCase__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaLowerCase__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaLowerCase_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaLowerCase$1;
        $chCl.$this$025 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaUpperCase = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaUpperCase__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaUpperCase();
        $java.jur_AbstractCharClass$LazyJavaUpperCase__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaUpperCase__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaUpperCase_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaUpperCase$1;
        $chCl.$this$026 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaWhitespace = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaWhitespace__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaWhitespace();
        $java.jur_AbstractCharClass$LazyJavaWhitespace__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaWhitespace__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaWhitespace_computeValue = function($this) {
        var var$1;
        var$1 = new $java.jur_AbstractCharClass$LazyJavaWhitespace$1;
        var$1.$this$027 = $this;
        $java.jur_AbstractCharClass__init_(var$1);
        return var$1;
    };
    $java.jur_AbstractCharClass$LazyJavaMirrored = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaMirrored__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaMirrored();
        $java.jur_AbstractCharClass$LazyJavaMirrored__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaMirrored__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaMirrored_computeValue = function($this) {
        var var$1;
        var$1 = new $java.jur_AbstractCharClass$LazyJavaMirrored$1;
        var$1.$this$028 = $this;
        $java.jur_AbstractCharClass__init_(var$1);
        return var$1;
    };
    $java.jur_AbstractCharClass$LazyJavaDefined = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaDefined__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaDefined();
        $java.jur_AbstractCharClass$LazyJavaDefined__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaDefined__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaDefined_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaDefined$1;
        $chCl.$this$029 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $java.ju_BitSet_set0($chCl.$lowHighSurrogates, 0, 2048);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaDigit = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaDigit__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaDigit();
        $java.jur_AbstractCharClass$LazyJavaDigit__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaDigit__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaDigit_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaDigit$1;
        $chCl.$this$030 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable();
        $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable$1;
        $chCl.$this$031 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaISOControl = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaISOControl__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaISOControl();
        $java.jur_AbstractCharClass$LazyJavaISOControl__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaISOControl__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaISOControl_computeValue = function($this) {
        var var$1;
        var$1 = new $java.jur_AbstractCharClass$LazyJavaISOControl$1;
        var$1.$this$032 = $this;
        $java.jur_AbstractCharClass__init_(var$1);
        return var$1;
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart();
        $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart$1;
        $chCl.$this$033 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart();
        $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart$1;
        $chCl.$this$034 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaLetter = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaLetter__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaLetter();
        $java.jur_AbstractCharClass$LazyJavaLetter__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaLetter__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaLetter_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaLetter$1;
        $chCl.$this$035 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaLetterOrDigit();
        $java.jur_AbstractCharClass$LazyJavaLetterOrDigit__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaLetterOrDigit$1;
        $chCl.$this$036 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaSpaceChar = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaSpaceChar__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaSpaceChar();
        $java.jur_AbstractCharClass$LazyJavaSpaceChar__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaSpaceChar__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaSpaceChar_computeValue = function($this) {
        var var$1;
        var$1 = new $java.jur_AbstractCharClass$LazyJavaSpaceChar$1;
        var$1.$this$037 = $this;
        $java.jur_AbstractCharClass__init_(var$1);
        return var$1;
    };
    $java.jur_AbstractCharClass$LazyJavaTitleCase = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaTitleCase__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaTitleCase();
        $java.jur_AbstractCharClass$LazyJavaTitleCase__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaTitleCase__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaTitleCase_computeValue = function($this) {
        var var$1;
        var$1 = new $java.jur_AbstractCharClass$LazyJavaTitleCase$1;
        var$1.$this$038 = $this;
        $java.jur_AbstractCharClass__init_(var$1);
        return var$1;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart();
        $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart$1;
        $chCl.$this$039 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart();
        $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart$1;
        $chCl.$this$040 = $this;
        $java.jur_AbstractCharClass__init_($chCl);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyWord = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazyWord__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyWord();
        $java.jur_AbstractCharClass$LazyWord__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyWord__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyWord_computeValue = function($this) {
        return $java.jur_CharClass_add($java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass__init_0(), 97, 122), 65, 90), 48, 57), 95);
    };
    $java.jur_AbstractCharClass$LazyNonWord = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyWord);
    $java.jur_AbstractCharClass$LazyNonWord__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyNonWord();
        $java.jur_AbstractCharClass$LazyNonWord__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyNonWord__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyNonWord_computeValue = function($this) {
        var $chCl;
        $chCl = $java.jur_AbstractCharClass_setNegative($java.jur_AbstractCharClass$LazyWord_computeValue($this), 1);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyNonSpace = $rt_classWithoutFields($java.jur_AbstractCharClass$LazySpace);
    $java.jur_AbstractCharClass$LazyNonSpace__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyNonSpace();
        $java.jur_AbstractCharClass$LazyNonSpace__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyNonSpace__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyNonSpace_computeValue = function($this) {
        var $chCl;
        $chCl = $java.jur_AbstractCharClass_setNegative($java.jur_AbstractCharClass$LazySpace_computeValue($this), 1);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyNonDigit = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyDigit);
    $java.jur_AbstractCharClass$LazyNonDigit__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazyNonDigit();
        $java.jur_AbstractCharClass$LazyNonDigit__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazyNonDigit__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazyNonDigit_computeValue = function($this) {
        var $chCl;
        $chCl = $java.jur_AbstractCharClass_setNegative($java.jur_AbstractCharClass$LazyDigit_computeValue($this), 1);
        $chCl.$mayContainSupplCodepoints = 1;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyRange = function() {
        var a = this; $java.jur_AbstractCharClass$LazyCharClass.call(a);
        a.$start8 = 0;
        a.$end5 = 0;
    };
    $java.jur_AbstractCharClass$LazyRange__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_AbstractCharClass$LazyRange();
        $java.jur_AbstractCharClass$LazyRange__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_AbstractCharClass$LazyRange__init_0 = function($this, $start, $end) {
        $this.$start8 = $start;
        $this.$end5 = $end;
    };
    $java.jur_AbstractCharClass$LazyRange_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass__init_0(), $this.$start8, $this.$end5);
    };
    $java.jur_AbstractCharClass$LazySpecialsBlock = $rt_classWithoutFields($java.jur_AbstractCharClass$LazyCharClass);
    $java.jur_AbstractCharClass$LazySpecialsBlock__init_ = function() {
        var var_0 = new $java.jur_AbstractCharClass$LazySpecialsBlock();
        $java.jur_AbstractCharClass$LazySpecialsBlock__init_0(var_0);
        return var_0;
    };
    $java.jur_AbstractCharClass$LazySpecialsBlock__init_0 = function($this) {};
    $java.jur_AbstractCharClass$LazySpecialsBlock_computeValue = function($this) {
        return $java.jur_CharClass_add0($java.jur_CharClass_add0($java.jur_CharClass__init_0(), 65279, 65279), 65520, 65533);
    };
    $java.jur_AbstractCharClass$LazyCategory = function() {
        var a = this; $java.jur_AbstractCharClass$LazyCharClass.call(a);
        a.$category0 = 0;
        a.$mayContainSupplCodepoints0 = 0;
        a.$containsAllSurrogates = 0;
    };
    $java.jur_AbstractCharClass$LazyCategory__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_AbstractCharClass$LazyCategory();
        $java.jur_AbstractCharClass$LazyCategory__init_1(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_AbstractCharClass$LazyCategory__init_0 = function(var_0, var_1, var_2) {
        var var_3 = new $java.jur_AbstractCharClass$LazyCategory();
        $java.jur_AbstractCharClass$LazyCategory__init_2(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.jur_AbstractCharClass$LazyCategory__init_1 = function($this, $cat, $mayContainSupplCodepoints) {
        $this.$mayContainSupplCodepoints0 = $mayContainSupplCodepoints;
        $this.$category0 = $cat;
    };
    $java.jur_AbstractCharClass$LazyCategory__init_2 = function($this, $cat, $mayContainSupplCodepoints, $containsAllSurrogates) {
        $this.$containsAllSurrogates = $containsAllSurrogates;
        $this.$mayContainSupplCodepoints0 = $mayContainSupplCodepoints;
        $this.$category0 = $cat;
    };
    $java.jur_AbstractCharClass$LazyCategory_computeValue = function($this) {
        var $chCl;
        $chCl = $java.jur_UnicodeCategory__init_($this.$category0);
        if ($this.$containsAllSurrogates)
            $java.ju_BitSet_set0($chCl.$lowHighSurrogates, 0, 2048);
        $chCl.$mayContainSupplCodepoints = $this.$mayContainSupplCodepoints0;
        return $chCl;
    };
    $java.jur_AbstractCharClass$LazyCategoryScope = function() {
        var a = this; $java.jur_AbstractCharClass$LazyCharClass.call(a);
        a.$category1 = 0;
        a.$mayContainSupplCodepoints1 = 0;
        a.$containsAllSurrogates0 = 0;
    };
    $java.jur_AbstractCharClass$LazyCategoryScope__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_AbstractCharClass$LazyCategoryScope();
        $java.jur_AbstractCharClass$LazyCategoryScope__init_1(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_AbstractCharClass$LazyCategoryScope__init_0 = function(var_0, var_1, var_2) {
        var var_3 = new $java.jur_AbstractCharClass$LazyCategoryScope();
        $java.jur_AbstractCharClass$LazyCategoryScope__init_2(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.jur_AbstractCharClass$LazyCategoryScope__init_1 = function($this, $cat, $mayContainSupplCodepoints) {
        $this.$mayContainSupplCodepoints1 = $mayContainSupplCodepoints;
        $this.$category1 = $cat;
    };
    $java.jur_AbstractCharClass$LazyCategoryScope__init_2 = function($this, $cat, $mayContainSupplCodepoints, $containsAllSurrogates) {
        $this.$containsAllSurrogates0 = $containsAllSurrogates;
        $this.$mayContainSupplCodepoints1 = $mayContainSupplCodepoints;
        $this.$category1 = $cat;
    };
    $java.jur_AbstractCharClass$LazyCategoryScope_computeValue = function($this) {
        var $chCl;
        $chCl = new $java.jur_UnicodeCategoryScope;
        $java.jur_UnicodeCategory__init_0($chCl, $this.$category1);
        if ($this.$containsAllSurrogates0)
            $java.ju_BitSet_set0($chCl.$lowHighSurrogates, 0, 2048);
        $chCl.$mayContainSupplCodepoints = $this.$mayContainSupplCodepoints1;
        return $chCl;
    };
    function otciu_UnicodeHelper$Range() {
        var a = this; jl_Object.call(a);
        a.$start0 = 0;
        a.$end0 = 0;
        a.$data = null;
    }
    function otciu_UnicodeHelper$Range__init_(var_0, var_1, var_2) {
        var var_3 = new otciu_UnicodeHelper$Range();
        $java.otciu_UnicodeHelper$Range__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.otciu_UnicodeHelper$Range__init_ = function($this, $start, $end, $data) {
        $this.$start0 = $start;
        $this.$end0 = $end;
        $this.$data = $data;
    };
    $java.onciu_RewritableCompat$PROXY$7_161 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_161_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_161 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_161_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_162 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_162_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_162 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_162_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_163 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_163_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_163 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_163_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_164 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_164_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_164 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_164_paramsLength(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_165 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_165_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_165 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_165_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_166 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_166_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_166 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_166_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_167 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_167_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_167 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_167_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_168 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_168_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_168 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_168_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_169 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_169_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_169 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_169_paramsLength(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_170 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_170_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_170 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_170_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_171 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_171_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_171 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_171_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_172 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_172_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_172 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_172_paramsLength(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_173 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_173_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_173 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_173_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_174 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_174_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_174 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_174_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_175 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_175_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_175 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_175_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(9)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_176 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_176_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_176 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_176_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_177 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_177_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_177 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_177_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_178 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_178_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_178 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_178_paramsLength(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_179 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_179_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_179 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_179_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_180 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_180_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_180 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_180_paramsLength(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_181 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_181_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_181 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_181_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_182 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_182_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_182 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_182_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(9)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_183 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_183_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_183 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_183_paramsLength(var$1) {
        return (jl_Integer_valueOf(8)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_184 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_184_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_184 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_184_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_185 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_185_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_185 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_185_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_186 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_186_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_186 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_186_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_187 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_187_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_187 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_187_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_188 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_188_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_188 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_188_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_189 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_189_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_189 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_189_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_190 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_190_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_190 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_190_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_191 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_191_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_191 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_191_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_192 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_192_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_192 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_192_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_193 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_193_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_193 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_193_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_194 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_194_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_194 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_194_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_195 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_195_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_195 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_195_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_196 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_196_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_196 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_196_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_197 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_197_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_197 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_197_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_198 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_198_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_198 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_198_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_199 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_199_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_199 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_199_paramsLength(var$1) {
        return (jl_Integer_valueOf(9)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_200 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_200_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_200 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_200_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_201 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_201_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_201 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_201_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(6)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_202 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_202_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_202 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_202_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_701 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_701_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_NodePattern__init_(var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_702 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_702_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_FunctionName__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_709 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_709_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Subtract__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_713 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_713_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ParenthesizedPath__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_714 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_714_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_LiteralEntry__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_716 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_716_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_EndsWith__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_719 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_719_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_SignedHexIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_721 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_721_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_SignedOctalIntegerLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_727 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_727_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_RegexMatch__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_729 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_729_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Add__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_731 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_731_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_StartsWith__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_735 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_735_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_IsTyped__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_738 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_738_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Contains__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_742 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_742_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_IsNull__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_744 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_744_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_IsNotNull__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_745 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_745_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_In_copy(var$2, var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_747 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_747_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_DecimalDoubleLiteral_copy(var$2, var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_748 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_748_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncia_IsNotTyped__init_(var$3[0], var$3[1], var$3[2]);
    }
    $java.onciu_RewritableCompat$PROXY$7_203 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_203_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_203 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_203_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_204 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_204_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_204 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_204_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_750 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_750_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_PropertySelector__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_751 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_751_copyConstructor(var$1, var$2, var$3) {
        return oncie_AllPropertiesSelector__init_0(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_752 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_752_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_VariableSelector__init_(var$3[0], var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_205 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_205_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_205 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_205_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_206 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_206_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_206 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_206_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_207 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_207_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_207 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_207_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_208 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_208_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_208 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_208_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_209 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_209_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_209 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_209_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_210 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_210_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_210 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_210_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_211 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_211_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_211 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_211_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_212 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_212_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_212 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_212_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_213 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_213_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_213 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_213_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_214 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_214_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_214 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_214_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_215 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_215_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_215 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_215_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_216 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_216_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_216 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_216_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_217 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_217_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_217 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_217_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_218 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_218_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_218 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_218_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_219 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_219_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_219 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_219_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_220 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_220_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_220 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_220_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_221 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_221_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_221 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_221_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_222 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_222_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_222 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_222_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_754 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_754_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_NoneIterablePredicate__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_755 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_755_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ListComprehension__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_756 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_756_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ReduceExpression__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_757 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_757_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_AllIterablePredicate__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_758 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_758_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_AnyIterablePredicate__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_759 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_759_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_SingleIterablePredicate__init_(var$3[0], var$3[1], var$3[2]);
    }
    $java.onciu_RewritableCompat$PROXY$7_223 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_223_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_223 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_223_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_224 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_224_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_224 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_224_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_225 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_225_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_225 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_225_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_226 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_226_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_226 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_226_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_227 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_227_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_227 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_227_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_228 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_228_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_228 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_228_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    var onciu_NonEmptyList$IteratorConverter$asNonEmptyListOption$lambda$_1_0 = $rt_classWithoutFields();
    $java.onciu_NonEmptyList$IteratorConverter$asNonEmptyListOption$lambda$_1_0_apply = function(var$0, var$1) {
        return var$1.$reverse2();
    };
    $java.sci_Map$Map4$$anon$8 = $rt_classWithoutFields($java.sci_Map$Map4$Map4Iterator);
    $java.sci_Map$Map4$$anon$8_nextResult = function($this, $k, $v) {
        return $k;
    };
    var sci_MapKeyIterator = $rt_classWithoutFields(sci_ChampBaseIterator);
    $java.sci_MapKeyIterator_iterator = function($this) {
        return $this;
    };
    $java.sci_MapKeyIterator_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.sci_MapKeyIterator_filterImpl = function($this, $p, $isFlipped) {
        return sc_Iterator_filterImpl$($this, $p, $isFlipped);
    };
    $java.sci_MapKeyIterator_map = function($this, $f) {
        return sc_Iterator_map$($this, $f);
    };
    $java.sci_MapKeyIterator_toString = function($this) {
        return $rt_s(466);
    };
    $java.sci_MapKeyIterator_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.sci_MapKeyIterator_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.sci_MapKeyIterator_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.sci_MapKeyIterator_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.sci_MapKeyIterator_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.sci_MapKeyIterator_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.sci_MapKeyIterator_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.sci_MapKeyIterator_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.sci_MapKeyIterator_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.sci_MapKeyIterator_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.sci_MapKeyIterator_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.sci_MapKeyIterator_knownSize = function($this) {
        return (-1);
    };
    $java.sci_MapKeyIterator_next = function($this) {
        var $key;
        if (!sci_ChampBaseIterator_hasNext($this)) {
            $key = new ju_NoSuchElementException;
            jl_Throwable__init_0($key);
            $rt_throw($key);
        }
        $key = $this.$currentValueNode.$getKey($this.$currentValueCursor);
        $this.$currentValueCursor = $this.$currentValueCursor + 1 | 0;
        return $key;
    };
    $java.sci_Map$Map2$$anon$2 = $rt_classWithoutFields($java.sci_Map$Map2$Map2Iterator);
    $java.sci_Map$Map2$$anon$2_nextResult = function($this, $k, $v) {
        return $k;
    };
    $java.sci_Map$Map3$$anon$5 = $rt_classWithoutFields($java.sci_Map$Map3$Map3Iterator);
    $java.sci_Map$Map3$$anon$5_nextResult = function($this, $k, $v) {
        return $k;
    };
    $java.oncias_SemanticTable$TypeGetter$isAnyOf$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0490 = null;
    };
    $java.oncias_SemanticTable$TypeGetter$isAnyOf$lambda$_3_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(s_Option_contains(var$0.$_0490.$typeInfo, var$1.$invariant()));
    };
    function oncie_QuantifiedPath$$apply$lambda$_1_0() {
        jl_Object.call(this);
        this.$_0227 = null;
    }
    $java.oncie_QuantifiedPath$$apply$lambda$_1_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0227;
        return $java.oncie_VariableGrouping__init_(oncie_Variable_copyId(var$1), oncie_Variable_withPosition(var$1, var$2), var$2);
    };
    $java.oncie_Expression$TreeAcc = function() {
        var a = this; jl_Object.call(a);
        a.$data0 = null;
        a.$list4 = null;
    };
    $java.oncie_Expression$TreeAcc__init_0 = function(var_0, var_1) {
        var var_2 = new $java.oncie_Expression$TreeAcc();
        $java.oncie_Expression$TreeAcc__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncie_Expression$TreeAcc_mapData = function($this, $f) {
        return $java.oncie_Expression$TreeAcc_copy($this, $f.$apply($this.$data0), $this.$list4);
    };
    $java.oncie_Expression$TreeAcc_inScope = function($this, $variable) {
        var var$2, var$3;
        var$2 = $this.$list4;
        var$3 = new $java.oncie_Expression$TreeAcc$inScope$lambda$_4_0;
        var$3.$_0533 = $variable;
        return sci_List_exists(var$2, var$3);
    };
    $java.oncie_Expression$TreeAcc_copy = function($this, $data, $list) {
        return $java.oncie_Expression$TreeAcc__init_0($data, $list);
    };
    $java.oncie_Expression$TreeAcc_productPrefix = function($this) {
        return $rt_s(3080);
    };
    $java.oncie_Expression$TreeAcc_productArity = function($this) {
        return 2;
    };
    $java.oncie_Expression$TreeAcc_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$data0;
            case 1:
                return $this.$list4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Expression$TreeAcc_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Expression$TreeAcc_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Expression$TreeAcc_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Expression$TreeAcc_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncie_Expression$TreeAcc) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if (!sr_BoxesRunTime_equals($this.$data0, $x$1.$data0))
                            break b;
                        var$2 = $this.$list4;
                        $x$1 = $x$1.$list4;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_Expression$TreeAcc__init_ = function($this, $data, $list) {
        $this.$data0 = $data;
        $this.$list4 = $list;
    };
    var oncie_Expression$TreeAcc$ = $rt_classWithoutFields();
    $java.oncie_Expression$TreeAcc$_MODULE$ = null;
    function oncie_Expression$TreeAcc$__clinit_() {
        $java.oncie_Expression$TreeAcc$_MODULE$ = new oncie_Expression$TreeAcc$;
    }
    $java.oncie_Expression$TreeAcc$_apply$default$2 = function($this) {
        s_package$_$callClinit();
        s_package$_List0(s_package$_MODULE$);
        return sci_Nil$_MODULE$;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$variablesUsedForGrouping$1 = null;
        a.$nonNestedPropertiesUsedForGrouping$1 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1_applyOrElse = function($this, $x1, $default) {
        var var$3, $v;
        var$3 = 0;
        $default = null;
        if ($rt_isInstance($x1, $java.oncie_ScopeExpression)) {
            $x1 = $x1;
            $default = new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_0;
            $default.$_0534 = $x1;
            return $default;
        }
        if ($x1 !== null && !s_Option_isEmpty($java.oncie_IsAggregate$_unapply($java.oncie_IsAggregate$_MODULE$, $x1)))
            return new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_1;
        if ($x1 instanceof oncie_LogicalVariable) {
            $v = $x1;
            if (!$this.$variablesUsedForGrouping$1.$contains0($v)) {
                $x1 = new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_2;
                $x1.$_0535 = $v;
                return $x1;
            }
        }
        if ($x1 instanceof $java.oncie_LogicalProperty) {
            var$3 = 1;
            $default = $x1;
            if ($this.$nonNestedPropertiesUsedForGrouping$1.$contains0($default))
                return new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_3;
        }
        if (var$3) {
            $x1 = $java.oncie_LogicalProperty$_unapply($java.oncie_LogicalProperty$_MODULE$, $default);
            if (!s_Option_isEmpty($x1)) {
                $v = $x1.$value5.$_10;
                if ($v instanceof oncie_LogicalVariable) {
                    $x1 = $v;
                    $v = new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_4;
                    $v.$_0536 = $this;
                    $v.$_1175 = $x1;
                    $v.$_261 = $default;
                    return $v;
                }
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    var oncias_SemanticState$scope$lambda$_46_0 = $rt_classWithoutFields();
    $java.oncias_SemanticState$scope$lambda$_46_0_apply = function(var$0, var$1) {
        return var$1.$location.$elem;
    };
    function oncias_ExpressionTypeInfo() {
        var a = this; jl_Object.call(a);
        a.$actual0 = null;
        a.$specified = null;
        a.$expected = null;
        a.$bitmap$035 = 0;
    }
    $java.oncias_ExpressionTypeInfo_expected = function($this) {
        return $this.$expected;
    };
    function oncias_ExpressionTypeInfo_actual($this) {
        var var$1, $$je;
        if ($this.$bitmap$035)
            return $this.$actual0;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$035)
                    break a;
                $this.$actual0 = s_Option_fold($java.oncias_ExpressionTypeInfo_expected($this), $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0__init_($this), $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1__init_($this));
                $this.$bitmap$035 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        return $this.$actual0;
    }
    $java.oncias_ExpressionTypeInfo_productPrefix = function($this) {
        return $rt_s(3081);
    };
    $java.oncias_ExpressionTypeInfo_productArity = function($this) {
        return 2;
    };
    $java.oncias_ExpressionTypeInfo_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$specified;
            case 1:
                return $this.$expected;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncias_ExpressionTypeInfo_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_ExpressionTypeInfo_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_ExpressionTypeInfo_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncias_ExpressionTypeInfo_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof oncias_ExpressionTypeInfo) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$specified;
                            var$3 = $x$1.$specified;
                            if (var$2 !== null) {
                                if (!oncius_TypeSpec_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$expected;
                        $x$1 = $x$1.$expected;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.jusi_MappingStreamImpl$wrap$lambda$_1_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0433 = null;
        a.$_1130 = null;
    };
    $java.jusi_MappingStreamImpl$wrap$lambda$_1_0_test = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0433;
        return var$0.$_1130.$test(var$2.$mapper.$apply(var$1));
    };
    $java.jusi_StreamOverSpliterator$AdapterAction = function() {
        var a = this; jl_Object.call(a);
        a.$consumer = null;
        a.$wantsMore = 0;
    };
    $java.jusi_FilteringStreamImpl$wrap$lambda$_1_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0450 = null;
        a.$_1136 = null;
    };
    $java.jusi_FilteringStreamImpl$wrap$lambda$_1_0_test = function(var$0, var$1) {
        var var$2, var$3;
        var$2 = var$0.$_1136;
        var$3 = var$1;
        onciaf_HintIndexType_$callClinit();
        return (var$3 !== onciaf_HintIndexType_BTREE && var$3 !== onciaf_HintIndexType_ANY ? 1 : 0) ? var$2.$test(var$1) : 1;
    };
    $java.scm_ArraySeq$ofRef = function() {
        $java.scm_ArraySeq.call(this);
        this.$array9 = null;
    };
    $java.scm_ArraySeq$ofRef__init_ = function(var_0) {
        var var_1 = new $java.scm_ArraySeq$ofRef();
        $java.scm_ArraySeq$ofRef__init_0(var_1, var_0);
        return var_1;
    };
    $java.scm_ArraySeq$ofRef_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_apply(sr_ClassTag$_MODULE$, jl_Class_getComponentType(jl_Object_getClass($this.$array9)));
    };
    $java.scm_ArraySeq$ofRef_length = function($this) {
        return $this.$array9.data.length;
    };
    $java.scm_ArraySeq$ofRef_apply = function($this, $index) {
        return $this.$array9.data[$index];
    };
    $java.scm_ArraySeq$ofRef_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash(suh_MurmurHash3$_MODULE$, $this.$array9);
    };
    $java.scm_ArraySeq$ofRef_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofRef))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return s_Array$_equals(s_Array$_MODULE$, $this.$array9, $that.$array9);
    };
    $java.scm_ArraySeq$ofRef_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator__init_($this.$array9);
    };
    $java.scm_ArraySeq$ofRef_apply0 = function($this, $v1) {
        return $java.scm_ArraySeq$ofRef_apply($this, sr_BoxesRunTime_unboxToInt($v1));
    };
    $java.scm_ArraySeq$ofRef_array = function($this) {
        return $this.$array9;
    };
    $java.scm_ArraySeq$ofRef__init_0 = function($this, $array) {
        $this.$array9 = $array;
    };
    var scm_ArraySeq$ = $rt_classWithoutFields();
    $java.scm_ArraySeq$_MODULE$ = null;
    $java.scm_ArraySeq$_untagged = null;
    $java.scm_ArraySeq$_EmptyArraySeq = null;
    function scm_ArraySeq$__clinit_() {
        var var$1;
        var$1 = new scm_ArraySeq$;
        $java.scm_ArraySeq$_MODULE$ = var$1;
        $java.scm_ArraySeq$_untagged = sc_ClassTagSeqFactory$AnySeqDelegate__init_(var$1);
        $java.scm_ArraySeq$_EmptyArraySeq = $java.scm_ArraySeq$ofRef__init_($rt_createArray(jl_Object, 0));
    }
    $java.scm_ArraySeq$_newBuilder = function($this, $evidence$3) {
        var var$2;
        a: {
            var$2 = $evidence$3.$runtimeClass();
            if (jl_Object_equals($rt_cls($rt_bytecls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofByte;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_shortcls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofShort;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_charcls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofChar;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_intcls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofInt;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_longcls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofLong;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_floatcls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofFloat;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_doublecls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofDouble;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (jl_Object_equals($rt_cls($rt_booleancls()), var$2)) {
                var$2 = new scm_ArrayBuilder$ofBoolean;
                scm_ArrayBuilder__init_(var$2);
                break a;
            }
            if (!jl_Object_equals($rt_cls($rt_voidcls()), var$2)) {
                var$2 = scm_ArrayBuilder$ofRef__init_($evidence$3);
                break a;
            }
            var$2 = new scm_ArrayBuilder$ofUnit;
            scm_ArrayBuilder__init_(var$2);
        }
        return scm_Builder_mapResult$(var$2, new $java.scm_ArraySeq$$newBuilder$lambda$_21_0);
    };
    $java.scm_ArraySeq$_make = function($this, $x) {
        var var$2;
        if ($x === null)
            return null;
        if ($rt_isInstance($x, $rt_arraycls(jl_Object)))
            return $java.scm_ArraySeq$ofRef__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_intcls()))) {
            var$2 = $x;
            $x = new $java.scm_ArraySeq$ofInt;
            $x.$array10 = var$2;
            return $x;
        }
        if ($rt_isInstance($x, $rt_arraycls($rt_doublecls()))) {
            var$2 = $x;
            $x = new $java.scm_ArraySeq$ofDouble;
            $x.$array11 = var$2;
            return $x;
        }
        if ($rt_isInstance($x, $rt_arraycls($rt_longcls()))) {
            var$2 = $x;
            $x = new $java.scm_ArraySeq$ofLong;
            $x.$array12 = var$2;
            return $x;
        }
        if ($rt_isInstance($x, $rt_arraycls($rt_floatcls()))) {
            var$2 = $x;
            $x = new $java.scm_ArraySeq$ofFloat;
            $x.$array13 = var$2;
            return $x;
        }
        if ($rt_isInstance($x, $rt_arraycls($rt_charcls())))
            return scm_ArraySeq$ofChar__init_($x);
        if ($rt_isInstance($x, $rt_arraycls($rt_bytecls()))) {
            var$2 = $x;
            $x = new $java.scm_ArraySeq$ofByte;
            $x.$array14 = var$2;
            return $x;
        }
        if ($rt_isInstance($x, $rt_arraycls($rt_shortcls()))) {
            var$2 = $x;
            $x = new $java.scm_ArraySeq$ofShort;
            $x.$array15 = var$2;
            return $x;
        }
        if ($rt_isInstance($x, $rt_arraycls($rt_booleancls()))) {
            var$2 = $x;
            $x = new $java.scm_ArraySeq$ofBoolean;
            $x.$array16 = var$2;
            return $x;
        }
        if (!$rt_isInstance($x, $rt_arraycls(sr_BoxedUnit)))
            $rt_throw(s_MatchError__init_($x));
        var$2 = $x;
        $x = new $java.scm_ArraySeq$ofUnit;
        $x.$array17 = var$2;
        return $x;
    };
    $java.scm_ArraySeq$_newBuilder0 = function($this, $evidence$12) {
        return $java.scm_ArraySeq$_newBuilder($this, $evidence$12);
    };
    $java.scm_ArraySeq$_from = function($this, $it, $evidence$5) {
        return $java.scm_ArraySeq$_make($this, s_Array$_from(s_Array$_MODULE$, $it, $evidence$5));
    };
    $java.scm_ArraySeq$_empty = function($this, $evidence$6) {
        return $java.scm_ArraySeq$_EmptyArraySeq;
    };
    var oncipj_EntityType = $rt_classWithoutFields(jl_Enum);
    var oncipj_EntityType_NODE = null;
    var oncipj_EntityType_RELATIONSHIP = null;
    var oncipj_EntityType_NODE_OR_RELATIONSHIP = null;
    $java.oncipj_EntityType_$VALUES = null;
    function oncipj_EntityType_$callClinit() {
        oncipj_EntityType_$callClinit = $rt_eraseClinit(oncipj_EntityType);
        $java.oncipj_EntityType__clinit_();
    }
    $java.oncipj_EntityType__init_ = function(var_0, var_1) {
        var var_2 = new oncipj_EntityType();
        $java.oncipj_EntityType__init_0(var_2, var_0, var_1);
        return var_2;
    };
    function oncipj_EntityType_values() {
        oncipj_EntityType_$callClinit();
        return $java.oncipj_EntityType_$VALUES.$clone();
    }
    $java.oncipj_EntityType__init_0 = function($this, var$1, var$2) {
        oncipj_EntityType_$callClinit();
        jl_Enum__init_($this, var$1, var$2);
    };
    $java.oncipj_EntityType__clinit_ = function() {
        var var$1;
        oncipj_EntityType_NODE = $java.oncipj_EntityType__init_($rt_s(923), 0);
        oncipj_EntityType_RELATIONSHIP = $java.oncipj_EntityType__init_($rt_s(1551), 1);
        var$1 = $java.oncipj_EntityType__init_($rt_s(3082), 2);
        oncipj_EntityType_NODE_OR_RELATIONSHIP = var$1;
        $java.oncipj_EntityType_$VALUES = $rt_createArrayFromData(oncipj_EntityType, [oncipj_EntityType_NODE, oncipj_EntityType_RELATIONSHIP, var$1]);
    };
    function oncie_FixedQuantifier() {
        var a = this; jl_Object.call(a);
        a.$value15 = null;
        a.$position291 = null;
    }
    function oncie_FixedQuantifier__init_(var_0, var_1) {
        var var_2 = new oncie_FixedQuantifier();
        $java.oncie_FixedQuantifier__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.oncie_FixedQuantifier_position = function($this) {
        return $this.$position291;
    };
    $java.oncie_FixedQuantifier_canBeEmpty = function($this) {
        return !sr_BoxesRunTime_equalsNumObject($java.oncie_DecimalIntegerLiteral_value($this.$value15), jl_Integer_valueOf(0)) ? 0 : 1;
    };
    $java.oncie_FixedQuantifier_productPrefix = function($this) {
        return $rt_s(3083);
    };
    $java.oncie_FixedQuantifier_productArity = function($this) {
        return 1;
    };
    $java.oncie_FixedQuantifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value15;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_FixedQuantifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FixedQuantifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FixedQuantifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_FixedQuantifier_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_FixedQuantifier) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$value15;
                        $x$1 = $x$1.$value15;
                        if (var$2 !== null) {
                            if (!$java.oncie_UnsignedDecimalIntegerLiteral_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_FixedQuantifier))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncie_FixedQuantifier_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_FixedQuantifier__init_ = function($this, $value, $position) {
        $this.$value15 = $value;
        $this.$position291 = $position;
    };
    function oncie_PlusQuantifier() {
        jl_Object.call(this);
        this.$position292 = null;
    }
    function oncie_PlusQuantifier__init_(var_0) {
        var var_1 = new oncie_PlusQuantifier();
        $java.oncie_PlusQuantifier__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_PlusQuantifier_position = function($this) {
        return $this.$position292;
    };
    $java.oncie_PlusQuantifier_canBeEmpty = function($this) {
        return 0;
    };
    $java.oncie_PlusQuantifier_productPrefix = function($this) {
        return $rt_s(3084);
    };
    $java.oncie_PlusQuantifier_productArity = function($this) {
        return 0;
    };
    $java.oncie_PlusQuantifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_PlusQuantifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PlusQuantifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PlusQuantifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_PlusQuantifier_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_PlusQuantifier) ? 0 : 1;
        return var$2 && $this instanceof oncie_PlusQuantifier ? 1 : 0;
    };
    $java.oncie_PlusQuantifier_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_PlusQuantifier__init_ = function($this, $position) {
        $this.$position292 = $position;
    };
    function oncie_StarQuantifier() {
        jl_Object.call(this);
        this.$position293 = null;
    }
    function oncie_StarQuantifier__init_(var_0) {
        var var_1 = new oncie_StarQuantifier();
        $java.oncie_StarQuantifier__init_(var_1, var_0);
        return var_1;
    }
    $java.oncie_StarQuantifier_position = function($this) {
        return $this.$position293;
    };
    $java.oncie_StarQuantifier_canBeEmpty = function($this) {
        return 1;
    };
    $java.oncie_StarQuantifier_productPrefix = function($this) {
        return $rt_s(3085);
    };
    $java.oncie_StarQuantifier_productArity = function($this) {
        return 0;
    };
    $java.oncie_StarQuantifier_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_StarQuantifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StarQuantifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StarQuantifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_StarQuantifier_equals = function($this, $x$1) {
        var var$2;
        var$2 = !($x$1 instanceof oncie_StarQuantifier) ? 0 : 1;
        return var$2 && $this instanceof oncie_StarQuantifier ? 1 : 0;
    };
    $java.oncie_StarQuantifier_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_StarQuantifier__init_ = function($this, $position) {
        $this.$position293 = $position;
    };
    function oncie_IntervalQuantifier() {
        var a = this; jl_Object.call(a);
        a.$lower0 = null;
        a.$upper0 = null;
        a.$position294 = null;
    }
    function oncie_IntervalQuantifier__init_(var_0, var_1, var_2) {
        var var_3 = new oncie_IntervalQuantifier();
        $java.oncie_IntervalQuantifier__init_(var_3, var_0, var_1, var_2);
        return var_3;
    }
    $java.oncie_IntervalQuantifier_position = function($this) {
        return $this.$position294;
    };
    $java.oncie_IntervalQuantifier_canBeEmpty = function($this) {
        return Long_ne(sr_BoxesRunTime_unboxToLong(s_Option_getOrElse(s_Option_map($this.$lower0, new $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_0), new $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_1)), Long_ZERO) ? 0 : 1;
    };
    $java.oncie_IntervalQuantifier_productPrefix = function($this) {
        return $rt_s(3086);
    };
    $java.oncie_IntervalQuantifier_productArity = function($this) {
        return 2;
    };
    $java.oncie_IntervalQuantifier_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$lower0;
            case 1:
                return $this.$upper0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_IntervalQuantifier_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IntervalQuantifier_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IntervalQuantifier_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_IntervalQuantifier_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof oncie_IntervalQuantifier) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$lower0;
                        var$3 = $x$1.$lower0;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$upper0;
                        $x$1 = $x$1.$upper0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncie_IntervalQuantifier))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_IntervalQuantifier_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_IntervalQuantifier__init_ = function($this, $lower, $upper, $position) {
        $this.$lower0 = $lower;
        $this.$upper0 = $upper;
        $this.$position294 = $position;
    };
    $java.sci_HashCollisionMapNode$removed$lambda$_13_0 = function() {
        jl_Object.call(this);
        this.$_0319 = null;
    };
    $java.sci_HashCollisionMapNode$removed$lambda$_13_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0319;
        return jl_Boolean_valueOf(!sr_BoxesRunTime_equals(var$1.$_10, var$2) ? 0 : 1);
    };
    $java.sm_Ordering$LongOrdering = $rt_classWithoutFields(0);
    var sm_Ordering$Long$ = $rt_classWithoutFields();
    var sm_Ordering$Long$_MODULE$ = null;
    function sm_Ordering$Long$__clinit_() {
        sm_Ordering$Long$_MODULE$ = new sm_Ordering$Long$;
    }
    $java.sm_Ordering$CharOrdering = $rt_classWithoutFields(0);
    var sm_Ordering$Char$ = $rt_classWithoutFields();
    var sm_Ordering$Char$_MODULE$ = null;
    function sm_Ordering$Char$__clinit_() {
        sm_Ordering$Char$_MODULE$ = new sm_Ordering$Char$;
    }
    $java.sm_Ordering$ByteOrdering = $rt_classWithoutFields(0);
    var sm_Ordering$Byte$ = $rt_classWithoutFields();
    var sm_Ordering$Byte$_MODULE$ = null;
    function sm_Ordering$Byte$__clinit_() {
        sm_Ordering$Byte$_MODULE$ = new sm_Ordering$Byte$;
    }
    $java.sm_Ordering$ShortOrdering = $rt_classWithoutFields(0);
    var sm_Ordering$Short$ = $rt_classWithoutFields();
    var sm_Ordering$Short$_MODULE$ = null;
    function sm_Ordering$Short$__clinit_() {
        sm_Ordering$Short$_MODULE$ = new sm_Ordering$Short$;
    }
    $java.sm_Ordering$BooleanOrdering = $rt_classWithoutFields(0);
    var sm_Ordering$Boolean$ = $rt_classWithoutFields();
    var sm_Ordering$Boolean$_MODULE$ = null;
    function sm_Ordering$Boolean$__clinit_() {
        sm_Ordering$Boolean$_MODULE$ = new sm_Ordering$Boolean$;
    }
    $java.sm_Ordering$Boolean$_compare = function($this, $x, $y) {
        var var$3, var$4;
        a: {
            b: {
                var$3 = sr_BoxesRunTime_unboxToBoolean($x);
                var$4 = sr_BoxesRunTime_unboxToBoolean($y);
                if (!var$3) {
                    if (!var$4)
                        break b;
                    var$3 = (-1);
                    break a;
                }
                if (!var$4) {
                    var$3 = 1;
                    break a;
                }
            }
            var$3 = 0;
        }
        return var$3;
    };
    var su_Sorting$ = $rt_classWithoutFields();
    var su_Sorting$_MODULE$ = null;
    function su_Sorting$__clinit_() {
        su_Sorting$_MODULE$ = new su_Sorting$;
    }
    $java.su_Sorting$_scala$util$Sorting$$insertionSort = function($this, $a, $i0, $iN, $ord) {
        var $n, $temp, var$7, $m, $i, $next, $iB, var$12, $iB_0, $ix;
        $n = $iN - $i0 | 0;
        if ($n < 2)
            return;
        $temp = sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, $i0);
        var$7 = sr_ScalaRunTime$_MODULE$;
        $iN = $i0 + 1 | 0;
        if ($java.sm_Ordering$Boolean$_compare($ord, $temp, sr_ScalaRunTime$_array_apply(var$7, $a, $iN)) > 0) {
            $temp = sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, $i0);
            var$7 = sr_ScalaRunTime$_MODULE$;
            sr_ScalaRunTime$_array_update(var$7, $a, $i0, sr_ScalaRunTime$_array_apply(var$7, $a, $iN));
            sr_ScalaRunTime$_array_update(sr_ScalaRunTime$_MODULE$, $a, $iN, $temp);
        }
        $m = 2;
        while ($m < $n) {
            $temp = sr_ScalaRunTime$_MODULE$;
            $i = $i0 + $m | 0;
            $next = sr_ScalaRunTime$_array_apply($temp, $a, $i);
            $temp = sr_ScalaRunTime$_MODULE$;
            $iB = $i - 1 | 0;
            if ($java.sm_Ordering$Boolean$_compare($ord, $next, sr_ScalaRunTime$_array_apply($temp, $a, $iB)) < 0) {
                var$12 = $i0;
                while (($iB - var$12 | 0) > 1) {
                    $iB_0 = (var$12 + $iB | 0) >>> 1;
                    if ($java.sm_Ordering$Boolean$_compare($ord, $next, sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, $iB_0)) >= 0) {
                        var$12 = $iB_0;
                        continue;
                    }
                    $iB = $iB_0;
                }
                $ix = var$12 + ($java.sm_Ordering$Boolean$_compare($ord, $next, sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, var$12)) >= 0 ? 1 : 0) | 0;
                while ($i > $ix) {
                    $temp = sr_ScalaRunTime$_MODULE$;
                    sr_ScalaRunTime$_array_update($temp, $a, $i, sr_ScalaRunTime$_array_apply($temp, $a, $i - 1 | 0));
                    $i = $i + (-1) | 0;
                }
                sr_ScalaRunTime$_array_update(sr_ScalaRunTime$_MODULE$, $a, $ix, $next);
            }
            $m = $m + 1 | 0;
        }
    };
    $java.su_Sorting$_scala$util$Sorting$$mergeSort = function($this, $a, $i0, $iN, $ord, $sc, $evidence$2) {
        var $iK;
        if (($iN - $i0 | 0) < 32) {
            $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, $a, $i0, $iN, $ord);
            return;
        }
        $iK = ($i0 + $iN | 0) >>> 1;
        if ($sc === null)
            $sc = $evidence$2.$newArray($iK - $i0 | 0);
        $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, $a, $i0, $iK, $ord, $sc, $evidence$2);
        $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, $a, $iK, $iN, $ord, $sc, $evidence$2);
        $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, $a, $i0, $iK, $iN, $ord, $sc);
    };
    $java.su_Sorting$_scala$util$Sorting$$mergeSorted = function($this, $a, $i0, $iK, $iN, $ord, $scratch) {
        var $jN, $j, var$9, var$10, var$11, var$12;
        if ($java.sm_Ordering$Boolean$_compare($ord, sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, $iK - 1 | 0), sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, $iK)) <= 0)
            return;
        $jN = $iK - $i0 | 0;
        $j = 0;
        var$9 = $i0;
        while (var$9 < $iK) {
            var$10 = sr_ScalaRunTime$_MODULE$;
            sr_ScalaRunTime$_array_update(var$10, $scratch, $j, sr_ScalaRunTime$_array_apply(var$10, $a, var$9));
            var$9 = var$9 + 1 | 0;
            $j = $j + 1 | 0;
        }
        var$11 = 0;
        a: {
            while (var$9 < $iN) {
                if (var$11 >= $jN)
                    break a;
                if ($java.sm_Ordering$Boolean$_compare($ord, sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $a, var$9), sr_ScalaRunTime$_array_apply(sr_ScalaRunTime$_MODULE$, $scratch, var$11)) >= 0) {
                    var$12 = sr_ScalaRunTime$_MODULE$;
                    sr_ScalaRunTime$_array_update(var$12, $a, $i0, sr_ScalaRunTime$_array_apply(var$12, $scratch, var$11));
                    var$11 = var$11 + 1 | 0;
                } else {
                    var$10 = sr_ScalaRunTime$_MODULE$;
                    sr_ScalaRunTime$_array_update(var$10, $a, $i0, sr_ScalaRunTime$_array_apply(var$10, $a, var$9));
                    var$9 = var$9 + 1 | 0;
                }
                $i0 = $i0 + 1 | 0;
            }
        }
        while (var$11 < $jN) {
            $ord = sr_ScalaRunTime$_MODULE$;
            sr_ScalaRunTime$_array_update($ord, $a, $i0, sr_ScalaRunTime$_array_apply($ord, $scratch, var$11));
            var$11 = var$11 + 1 | 0;
            $i0 = $i0 + 1 | 0;
        }
    };
    $java.su_Sorting$_scala$util$Sorting$$booleanSort = function($this, $a, $from, $until) {
        var $n, var$5, var$6, var$7;
        $n = 0;
        var$5 = $from;
        while (var$5 < $until) {
            if (!$a.data[var$5])
                $n = $n + 1 | 0;
            var$5 = var$5 + 1 | 0;
        }
        var$6 = 0;
        while (var$6 < $n) {
            $a.data[$from + var$6 | 0] = 0;
            var$6 = var$6 + 1 | 0;
        }
        while (true) {
            var$7 = $from + var$6 | 0;
            if (var$7 >= $until)
                break;
            $a.data[var$7] = 1;
            var$6 = var$6 + 1 | 0;
        }
    };
    function su_Sorting$_stableSort($this, $a, $from, $until, $evidence$4) {
        var var$5, var$6, var$7, var$8, var$9, var$10;
        if ($rt_isInstance($a, $rt_arraycls(jl_Object))) {
            if (jlr_Array_getLength($a) > 1 && $evidence$4 === null) {
                $a = new jl_NullPointerException;
                jl_Throwable__init_($a, $rt_s(3087));
                $rt_throw($a);
            }
            var$5 = $a;
            var$6 = $rt_createArray(jl_Object, $until - $from | 0);
            var$7 = var$6.data;
            var$8 = $from;
            while (var$8 < $until) {
                var$7[var$8 - $from | 0] = var$5.data[var$8];
                var$8 = var$8 + 1 | 0;
            }
            ju_Arrays_sort(var$6, $evidence$4);
            var$8 = $from;
            while (var$8 < $until) {
                var$5.data[var$8] = var$7[var$8 - $from | 0];
                var$8 = var$8 + 1 | 0;
            }
            return;
        }
        if ($rt_isInstance($a, $rt_arraycls($rt_intcls()))) {
            var$7 = $a;
            sm_Ordering$Int$_$callClinit();
            if ($evidence$4 !== sm_Ordering$Int$_MODULE$) {
                sr_ClassTag$_$callClinit();
                $a = sr_ClassTag$_Int0(sr_ClassTag$_MODULE$);
                if (($until - $from | 0) < 32)
                    $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, var$7, $from, $until, $evidence$4);
                else {
                    var$8 = ($from + $until | 0) >>> 1;
                    var$5 = $rt_createIntArray(var$8 - $from | 0);
                    $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$7, $from, var$8, $evidence$4, var$5, $a);
                    $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$7, var$8, $until, $evidence$4, var$5, $a);
                    $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, var$7, $from, var$8, $until, $evidence$4, var$5);
                }
                return;
            }
            var$5 = $rt_createIntArray($until - $from | 0);
            var$9 = var$5.data;
            var$8 = $from;
            while (var$8 < $until) {
                var$9[var$8 - $from | 0] = var$7.data[var$8];
                var$8 = var$8 + 1 | 0;
            }
            ju_Arrays_sort0(var$5);
            var$8 = $from;
            while (var$8 < $until) {
                var$7.data[var$8] = var$9[var$8 - $from | 0];
                var$8 = var$8 + 1 | 0;
            }
            return;
        }
        if ($rt_isInstance($a, $rt_arraycls($rt_doublecls()))) {
            var$6 = $a;
            sr_ClassTag$_$callClinit();
            $a = sr_ClassTag$_Double0(sr_ClassTag$_MODULE$);
            if (($until - $from | 0) < 32)
                $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, var$6, $from, $until, $evidence$4);
            else {
                var$8 = ($from + $until | 0) >>> 1;
                var$5 = $rt_createDoubleArray(var$8 - $from | 0);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, $from, var$8, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, var$8, $until, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, var$6, $from, var$8, $until, $evidence$4, var$5);
            }
            return;
        }
        if ($rt_isInstance($a, $rt_arraycls($rt_longcls()))) {
            var$7 = $a;
            if ($evidence$4 !== sm_Ordering$Long$_MODULE$) {
                sr_ClassTag$_$callClinit();
                $a = sr_ClassTag$_Long0(sr_ClassTag$_MODULE$);
                if (($until - $from | 0) < 32)
                    $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, var$7, $from, $until, $evidence$4);
                else {
                    var$8 = ($from + $until | 0) >>> 1;
                    var$5 = $rt_createLongArray(var$8 - $from | 0);
                    $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$7, $from, var$8, $evidence$4, var$5, $a);
                    $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$7, var$8, $until, $evidence$4, var$5, $a);
                    $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, var$7, $from, var$8, $until, $evidence$4, var$5);
                }
                return;
            }
            var$5 = $rt_createLongArray($until - $from | 0);
            var$9 = var$5.data;
            var$8 = $from;
            while (var$8 < $until) {
                var$9[var$8 - $from | 0] = var$7.data[var$8];
                var$8 = var$8 + 1 | 0;
            }
            ju_Arrays_sort1(var$5);
            var$8 = $from;
            while (var$8 < $until) {
                var$7.data[var$8] = var$9[var$8 - $from | 0];
                var$8 = var$8 + 1 | 0;
            }
            return;
        }
        if ($rt_isInstance($a, $rt_arraycls($rt_floatcls()))) {
            var$6 = $a;
            sr_ClassTag$_$callClinit();
            $a = sr_ClassTag$_Float0(sr_ClassTag$_MODULE$);
            if (($until - $from | 0) < 32)
                $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, var$6, $from, $until, $evidence$4);
            else {
                var$8 = ($from + $until | 0) >>> 1;
                var$5 = $rt_createFloatArray(var$8 - $from | 0);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, $from, var$8, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, var$8, $until, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, var$6, $from, var$8, $until, $evidence$4, var$5);
            }
            return;
        }
        if ($rt_isInstance($a, $rt_arraycls($rt_charcls()))) {
            var$6 = $a;
            if ($evidence$4 === sm_Ordering$Char$_MODULE$) {
                ju_Arrays_sort4(var$6, $from, $until);
                return;
            }
            sr_ClassTag$_$callClinit();
            $a = sr_ClassTag$_Char0(sr_ClassTag$_MODULE$);
            if (($until - $from | 0) < 32)
                $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, var$6, $from, $until, $evidence$4);
            else {
                var$8 = ($from + $until | 0) >>> 1;
                var$5 = $rt_createCharArray(var$8 - $from | 0);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, $from, var$8, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, var$8, $until, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, var$6, $from, var$8, $until, $evidence$4, var$5);
            }
            return;
        }
        if ($rt_isInstance($a, $rt_arraycls($rt_bytecls()))) {
            var$6 = $a;
            if ($evidence$4 === sm_Ordering$Byte$_MODULE$) {
                ju_Arrays_sort6(var$6, $from, $until);
                return;
            }
            sr_ClassTag$_$callClinit();
            $a = sr_ClassTag$_Byte0(sr_ClassTag$_MODULE$);
            if (($until - $from | 0) < 32)
                $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, var$6, $from, $until, $evidence$4);
            else {
                var$8 = ($from + $until | 0) >>> 1;
                var$5 = $rt_createByteArray(var$8 - $from | 0);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, $from, var$8, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, var$6, var$8, $until, $evidence$4, var$5, $a);
                $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, var$6, $from, var$8, $until, $evidence$4, var$5);
            }
            return;
        }
        if ($rt_isInstance($a, $rt_arraycls($rt_shortcls()))) {
            var$5 = $a;
            if ($evidence$4 === sm_Ordering$Short$_MODULE$) {
                ju_Arrays_sort2(var$5, $from, $until);
                return;
            }
            $a = null;
            sr_ClassTag$_$callClinit();
            $java.su_Sorting$_scala$util$Sorting$$mergeSort$mSc$sp($this, var$5, $from, $until, $evidence$4, $a, sr_ClassTag$_Short0(sr_ClassTag$_MODULE$));
            return;
        }
        if (!$rt_isInstance($a, $rt_arraycls($rt_booleancls()))) {
            if ($a !== null)
                $rt_throw(s_MatchError__init_($a));
            $a = new jl_NullPointerException;
            jl_Throwable__init_0($a);
            $rt_throw($a);
        }
        if ($evidence$4 === sm_Ordering$Boolean$_MODULE$) {
            $java.su_Sorting$_scala$util$Sorting$$booleanSort($this, $a, $from, $until);
            return;
        }
        var$10 = null;
        sr_ClassTag$_$callClinit();
        $java.su_Sorting$_scala$util$Sorting$$mergeSort$mZc$sp($this, $a, $from, $until, $evidence$4, var$10, sr_ClassTag$_Boolean0(sr_ClassTag$_MODULE$));
    }
    $java.su_Sorting$_scala$util$Sorting$$mergeSort$mZc$sp = function($this, $a, $i0, $iN, $ord, $sc, $evidence$2) {
        var $iK;
        if (($iN - $i0 | 0) < 32) {
            $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, $a, $i0, $iN, $ord);
            return;
        }
        $iK = ($i0 + $iN | 0) >>> 1;
        if ($sc === null)
            $sc = $rt_createBooleanArray($iK - $i0 | 0);
        $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, $a, $i0, $iK, $ord, $sc, $evidence$2);
        $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, $a, $iK, $iN, $ord, $sc, $evidence$2);
        $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, $a, $i0, $iK, $iN, $ord, $sc);
    };
    $java.su_Sorting$_scala$util$Sorting$$mergeSort$mSc$sp = function($this, $a, $i0, $iN, $ord, $sc, $evidence$2) {
        var $iK;
        if (($iN - $i0 | 0) < 32) {
            $java.su_Sorting$_scala$util$Sorting$$insertionSort($this, $a, $i0, $iN, $ord);
            return;
        }
        $iK = ($i0 + $iN | 0) >>> 1;
        if ($sc === null)
            $sc = $rt_createShortArray($iK - $i0 | 0);
        $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, $a, $i0, $iK, $ord, $sc, $evidence$2);
        $java.su_Sorting$_scala$util$Sorting$$mergeSort($this, $a, $iK, $iN, $ord, $sc, $evidence$2);
        $java.su_Sorting$_scala$util$Sorting$$mergeSorted($this, $a, $i0, $iK, $iN, $ord, $sc);
    };
    var oncie_LogicalProperty$ = $rt_classWithoutFields();
    $java.oncie_LogicalProperty$_MODULE$ = null;
    function oncie_LogicalProperty$__clinit_() {
        $java.oncie_LogicalProperty$_MODULE$ = new oncie_LogicalProperty$;
    }
    $java.oncie_LogicalProperty$_unapply = function($this, $p) {
        return s_Some__init_(s_Tuple2__init_($p.$map11, $p.$propertyKey0));
    };
    var oncie_LogicalVariable$ = $rt_classWithoutFields();
    $java.oncie_LogicalVariable$_MODULE$ = null;
    function oncie_LogicalVariable$__clinit_() {
        $java.oncie_LogicalVariable$_MODULE$ = new oncie_LogicalVariable$;
    }
    function sci_WrappedString() {
        sci_AbstractSeq.call(this);
        this.$scala$collection$immutable$WrappedString$$self = null;
    }
    $java.sci_WrappedString_iterator = function($this) {
        return sc_IndexedSeqOps_iterator$($this);
    };
    $java.sci_WrappedString_knownSize = function($this) {
        return $this.$length();
    };
    $java.sci_WrappedString_length = function($this) {
        return jl_String_length($this.$scala$collection$immutable$WrappedString$$self);
    };
    $java.sci_WrappedString_view = function($this) {
        var var$1;
        var$1 = new $java.sc_StringView;
        var$1.$s0 = $this.$scala$collection$immutable$WrappedString$$self;
        return var$1;
    };
    function onciap_DefaultExpressionStringifier$apply$lambda$_7_0() {
        jl_Object.call(this);
        this.$_049 = null;
    }
    $java.onciap_DefaultExpressionStringifier$apply$lambda$_7_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_backtick(var$0.$_049, var$1);
    };
    $java.sm_Ordering$Tuple2Ordering = function() {
        var a = this; jl_Object.call(a);
        a.$ord1 = null;
        a.$ord2 = null;
    };
    $java.sm_Ordering$Tuple2Ordering_compare = function($this, $x, $y) {
        var var$3;
        $x = $x;
        $y = $y;
        var$3 = sm_Ordering$Int$_compare($this.$ord1, $x.$_10, $y.$_10);
        if (!var$3)
            var$3 = $java.sm_Ordering$String$_compare($this.$ord2, $x.$_20, $y.$_20);
        return var$3;
    };
    $java.oncie_FunctionInvocation$asCanonicalStringVal$lambda$_15_0 = $rt_classWithoutFields();
    $java.oncie_FunctionInvocation$asCanonicalStringVal$lambda$_15_0_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    $java.oncie_ListLiteral$asCanonicalStringVal$lambda$_5_0 = $rt_classWithoutFields();
    $java.oncie_ListLiteral$asCanonicalStringVal$lambda$_5_0_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    $java.oncie_MapExpression$asCanonicalStringVal$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncie_MapExpression$asCanonicalStringVal$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        var$3 = var$2.$name11;
        var$1 = var$1.$asCanonicalStringVal();
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$3), $rt_s(10)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.jur_AbstractCharClass$1 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$lHS = null;
        a.$this$05 = null;
    };
    $java.jur_AbstractCharClass$1_contains = function($this, $ch) {
        var $index;
        $index = $ch - 55296 | 0;
        return $index >= 0 && $index < 2048 ? $this.$altSurrogates ^ $java.ju_BitSet_get($this.$val$lHS, $index) : 0;
    };
    $java.jur_AbstractCharClass$2 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$lHS0 = null;
        a.$val$thisClass = null;
        a.$this$06 = null;
    };
    $java.jur_AbstractCharClass$2_contains = function($this, $ch) {
        var $index, $containslHS;
        $index = $ch - 55296 | 0;
        $containslHS = $index >= 0 && $index < 2048 ? $this.$altSurrogates ^ $java.ju_BitSet_get($this.$val$lHS0, $index) : 0;
        return $this.$val$thisClass.$contains2($ch) && !$containslHS ? 1 : 0;
    };
    $java.jur_CharClass$18 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$bs = null;
        a.$this$024 = null;
    };
    $java.jur_CharClass$18_contains = function($this, $ch) {
        return $this.$alt0 ^ $java.ju_BitSet_get($this.$val$bs, $ch);
    };
    $java.jur_CharClass$18_toString = function($this) {
        var $temp, $i, var$3;
        $temp = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($temp);
        $i = $java.ju_BitSet_nextSetBit($this.$val$bs, 0);
        while ($i >= 0) {
            jl_AbstractStringBuilder_append5($temp, jl_Character_toChars($i));
            jl_AbstractStringBuilder_append($temp, 124);
            $i = $java.ju_BitSet_nextSetBit($this.$val$bs, $i + 1 | 0);
        }
        var$3 = $temp.$length0;
        if (var$3 > 0)
            jl_StringBuilder_deleteCharAt($temp, var$3 - 1 | 0);
        return jl_AbstractStringBuilder_toString($temp);
    };
    $java.jur_CharClass$1 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$cc1 = null;
        a.$this$09 = null;
    };
    $java.jur_CharClass$1_contains = function($this, $ch) {
        return $this.$val$cc1.$contains2($ch);
    };
    $java.jur_CharClass$3 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt1 = 0;
        a.$val$cc2 = null;
        a.$this$010 = null;
    };
    $java.jur_CharClass$3_contains = function($this, $ch) {
        return !($this.$val$curAlt1 ^ $java.ju_BitSet_get($this.$this$010.$bits0, $ch)) && !($this.$val$curAlt1 ^ $this.$this$010.$inverted ^ $this.$val$cc2.$contains2($ch)) ? 0 : 1;
    };
    $java.jur_CharClass$2 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt2 = 0;
        a.$val$cc3 = null;
        a.$this$011 = null;
    };
    $java.jur_CharClass$2_contains = function($this, $ch) {
        return !($this.$val$curAlt2 ^ $java.ju_BitSet_get($this.$this$011.$bits0, $ch)) && !($this.$val$curAlt2 ^ $this.$this$011.$inverted ^ $this.$val$cc3.$contains2($ch)) ? 1 : 0;
    };
    $java.jur_CharClass$5 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt = 0;
        a.$val$nb = null;
        a.$val$cc = null;
        a.$this$07 = null;
    };
    $java.jur_CharClass$5_contains = function($this, $ch) {
        return $this.$val$curAlt ^ (!$this.$val$nb.$contains2($ch) && !$this.$val$cc.$contains2($ch) ? 0 : 1);
    };
    $java.jur_CharClass$4 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt0 = 0;
        a.$val$nb0 = null;
        a.$val$cc0 = null;
        a.$this$08 = null;
    };
    $java.jur_CharClass$4_contains = function($this, $ch) {
        return $this.$val$curAlt0 ^ (!$this.$val$nb0.$contains2($ch) && !$this.$val$cc0.$contains2($ch) ? 0 : 1) ? 0 : 1;
    };
    $java.jur_CharClass$7 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz1 = null;
        a.$this$014 = null;
    };
    $java.jur_CharClass$7_contains = function($this, $ch) {
        return $java.jur_CharClass_contains($this.$val$clazz1, $ch);
    };
    $java.jur_CharClass$6 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz2 = null;
        a.$this$015 = null;
    };
    $java.jur_CharClass$6_contains = function($this, $ch) {
        return $java.jur_CharClass_contains($this.$val$clazz2, $ch) ? 0 : 1;
    };
    $java.jur_CharClass$9 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz3 = null;
        a.$val$curAlt5 = 0;
        a.$this$016 = null;
    };
    $java.jur_CharClass$9_contains = function($this, $ch) {
        return !$java.jur_CharClass_contains($this.$val$clazz3, $ch) && !($this.$val$curAlt5 ^ $java.ju_BitSet_get($this.$this$016.$bits0, $ch)) ? 0 : 1;
    };
    $java.jur_CharClass$8 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz4 = null;
        a.$val$curAlt6 = 0;
        a.$this$017 = null;
    };
    $java.jur_CharClass$8_contains = function($this, $ch) {
        return !$java.jur_CharClass_contains($this.$val$clazz4, $ch) && !($this.$val$curAlt6 ^ $java.ju_BitSet_get($this.$this$017.$bits0, $ch)) ? 1 : 0;
    };
    $java.jur_CharClass$11 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt3 = 0;
        a.$val$nb1 = null;
        a.$val$clazz = null;
        a.$this$012 = null;
    };
    $java.jur_CharClass$11_contains = function($this, $ch) {
        return !($this.$val$curAlt3 ^ $this.$val$nb1.$contains2($ch)) && !$java.jur_CharClass_contains($this.$val$clazz, $ch) ? 0 : 1;
    };
    $java.jur_CharClass$10 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt4 = 0;
        a.$val$nb2 = null;
        a.$val$clazz0 = null;
        a.$this$013 = null;
    };
    $java.jur_CharClass$10_contains = function($this, $ch) {
        return !($this.$val$curAlt4 ^ $this.$val$nb2.$contains2($ch)) && !$java.jur_CharClass_contains($this.$val$clazz0, $ch) ? 1 : 0;
    };
    $java.jur_CharClass$13 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz7 = null;
        a.$this$020 = null;
    };
    $java.jur_CharClass$13_contains = function($this, $ch) {
        return $java.jur_CharClass_contains($this.$val$clazz7, $ch);
    };
    $java.jur_CharClass$12 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz8 = null;
        a.$this$021 = null;
    };
    $java.jur_CharClass$12_contains = function($this, $ch) {
        return $java.jur_CharClass_contains($this.$val$clazz8, $ch) ? 0 : 1;
    };
    $java.jur_CharClass$15 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz9 = null;
        a.$val$curAlt9 = 0;
        a.$this$022 = null;
    };
    $java.jur_CharClass$15_contains = function($this, $ch) {
        return $java.jur_CharClass_contains($this.$val$clazz9, $ch) && $this.$val$curAlt9 ^ $java.ju_BitSet_get($this.$this$022.$bits0, $ch) ? 1 : 0;
    };
    $java.jur_CharClass$14 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$clazz10 = null;
        a.$val$curAlt10 = 0;
        a.$this$023 = null;
    };
    $java.jur_CharClass$14_contains = function($this, $ch) {
        return $java.jur_CharClass_contains($this.$val$clazz10, $ch) && $this.$val$curAlt10 ^ $java.ju_BitSet_get($this.$this$023.$bits0, $ch) ? 0 : 1;
    };
    $java.jur_CharClass$17 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt7 = 0;
        a.$val$nb3 = null;
        a.$val$clazz5 = null;
        a.$this$018 = null;
    };
    $java.jur_CharClass$17_contains = function($this, $ch) {
        return $this.$val$curAlt7 ^ $this.$val$nb3.$contains2($ch) && $java.jur_CharClass_contains($this.$val$clazz5, $ch) ? 1 : 0;
    };
    $java.jur_CharClass$16 = function() {
        var a = this; jur_AbstractCharClass.call(a);
        a.$val$curAlt8 = 0;
        a.$val$nb4 = null;
        a.$val$clazz6 = null;
        a.$this$019 = null;
    };
    $java.jur_CharClass$16_contains = function($this, $ch) {
        return $this.$val$curAlt8 ^ $this.$val$nb4.$contains2($ch) && $java.jur_CharClass_contains($this.$val$clazz6, $ch) ? 0 : 1;
    };
    function jur_MatchResultImpl() {
        var a = this; jl_Object.call(a);
        a.$groupBounds = null;
        a.$consumers = null;
        a.$compQuantCounters = null;
        a.$string4 = null;
        a.$groupCount = 0;
        a.$valid = 0;
        a.$leftBound0 = 0;
        a.$rightBound0 = 0;
        a.$startIndex = 0;
        a.$transparentBounds = 0;
        a.$anchoringBounds = 0;
        a.$hitEnd = 0;
        a.$requireEnd = 0;
        a.$previousMatch = 0;
        a.$mode1 = 0;
    }
    $java.jur_MatchResultImpl_setConsumed = function($this, $counter, $value) {
        $this.$consumers.data[$counter] = $value;
    };
    $java.jur_MatchResultImpl_getConsumed = function($this, $counter) {
        return $this.$consumers.data[$counter];
    };
    $java.jur_MatchResultImpl_end0 = function($this) {
        return $java.jur_MatchResultImpl_end($this, 0);
    };
    $java.jur_MatchResultImpl_end = function($this, $group) {
        $java.jur_MatchResultImpl_checkGroup($this, $group);
        return $this.$groupBounds.data[($group * 2 | 0) + 1 | 0];
    };
    $java.jur_MatchResultImpl_setStart = function($this, $group, $offset) {
        $this.$groupBounds.data[$group * 2 | 0] = $offset;
    };
    $java.jur_MatchResultImpl_setEnd = function($this, $group, $offset) {
        $this.$groupBounds.data[($group * 2 | 0) + 1 | 0] = $offset;
    };
    $java.jur_MatchResultImpl_getStart = function($this, $group) {
        return $this.$groupBounds.data[$group * 2 | 0];
    };
    $java.jur_MatchResultImpl_getEnd = function($this, $group) {
        return $this.$groupBounds.data[($group * 2 | 0) + 1 | 0];
    };
    $java.jur_MatchResultImpl_start = function($this, $group) {
        $java.jur_MatchResultImpl_checkGroup($this, $group);
        return $this.$groupBounds.data[$group * 2 | 0];
    };
    $java.jur_MatchResultImpl_finalizeMatch = function($this) {
        var var$1, var$2;
        var$1 = $this.$groupBounds.data;
        if (var$1[0] == (-1)) {
            var$2 = $this.$startIndex;
            var$1[0] = var$2;
            var$1[1] = var$2;
        }
        $this.$previousMatch = $java.jur_MatchResultImpl_end0($this);
    };
    $java.jur_MatchResultImpl_getEnterCounter = function($this, $setCounter) {
        return $this.$compQuantCounters.data[$setCounter];
    };
    $java.jur_MatchResultImpl_setEnterCounter = function($this, $setCounter, $value) {
        $this.$compQuantCounters.data[$setCounter] = $value;
    };
    $java.jur_MatchResultImpl_checkGroup = function($this, $group) {
        var var$2;
        if (!$this.$valid) {
            var$2 = new jl_IllegalStateException;
            jl_Throwable__init_0(var$2);
            $rt_throw(var$2);
        }
        if ($group >= 0 && $group < $this.$groupCount)
            return;
        var$2 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_(var$2, jl_String_valueOf1($group));
        $rt_throw(var$2);
    };
    function jur_MatchResultImpl_reset($this, $newSequence, $leftBound, $rightBound) {
        $this.$valid = 0;
        $this.$mode1 = 2;
        ju_Arrays_fill0($this.$groupBounds, (-1));
        ju_Arrays_fill0($this.$consumers, (-1));
        if ($newSequence !== null)
            $this.$string4 = $newSequence;
        if ($leftBound >= 0) {
            $this.$leftBound0 = $leftBound;
            $this.$rightBound0 = $rightBound;
        }
        $this.$startIndex = $this.$leftBound0;
    }
    $java.jur_MatchResultImpl_reset = function($this) {
        jur_MatchResultImpl_reset($this, null, (-1), (-1));
    };
    $java.jur_MatchResultImpl_setStartIndex = function($this, $startIndex) {
        var var$2;
        $this.$startIndex = $startIndex;
        var$2 = $this.$previousMatch;
        if (var$2 >= 0)
            $startIndex = var$2;
        $this.$previousMatch = $startIndex;
    };
    var onciap_DefaultExpressionStringifier$Syntactic$ = $rt_classWithoutFields();
    function onciap_DefaultExpressionStringifier$Syntactic$__init_(var_0) {
        var var_1 = new onciap_DefaultExpressionStringifier$Syntactic$();
        $java.onciap_DefaultExpressionStringifier$Syntactic$__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_DefaultExpressionStringifier$Syntactic$_productArity = function($this) {
        return 0;
    };
    $java.onciap_DefaultExpressionStringifier$Syntactic$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.onciap_DefaultExpressionStringifier$Syntactic$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciap_DefaultExpressionStringifier$Syntactic$_hashCode = function($this) {
        return (-1308395040);
    };
    $java.onciap_DefaultExpressionStringifier$Syntactic$_toString = function($this) {
        return $rt_s(3088);
    };
    $java.onciap_DefaultExpressionStringifier$Syntactic$__init_ = function($this, $$outer) {};
    $java.oncia_CreateIndex$$anonfun$semanticCheck$1$lambda$_68_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0482 = null;
        a.$_1154 = null;
    };
    $java.oncia_CreateIndex$$anonfun$semanticCheck$1$lambda$_68_0_apply = function(var$0) {
        return oncias_SemanticAnalysisTooling_error$(var$0.$_0482, $rt_s(2741), var$0.$_1154.$position31);
    };
    function sc_SeqOps$occCounts$lambda$_124_0() {
        jl_Object.call(this);
        this.$_014 = null;
    }
    $java.sc_SeqOps$occCounts$lambda$_124_0_apply = function(var$0, var$1) {
        return scm_HashMap_updateWith(var$0.$_014, var$1, new $java.sc_SeqOps$$anonfun$occCounts$1$lambda$_141_0);
    };
    $java.sc_StrictOptimizedSeqOps$$anonfun$intersect$1$lambda$_19_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0516 = null;
        a.$_1170 = null;
    };
    $java.sc_StrictOptimizedSeqOps$$anonfun$intersect$1$lambda$_19_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0516;
        var$3 = var$0.$_1170;
        if (jl_Object_equals(s_None$_MODULE$, var$1))
            var$1 = s_None$_MODULE$;
        else {
            if (!(var$1 instanceof s_Some))
                $rt_throw(s_MatchError__init_(var$1));
            var$4 = sr_BoxesRunTime_unboxToInt(var$1.$value5);
            var$2.$addOne(var$3);
            var$1 = var$4 == 1 ? s_None$_MODULE$ : s_Some__init_(jl_Integer_valueOf(var$4 - 1 | 0));
        }
        return var$1;
    };
    $java.onciu_Foldable$FoldingBehavior = $rt_classWithoutFields(0);
    $java.onciu_Foldable$SkipChildren = function() {
        jl_Object.call(this);
        this.$acc = null;
    };
    $java.onciu_Foldable$SkipChildren__init_ = function(var_0) {
        var var_1 = new $java.onciu_Foldable$SkipChildren();
        $java.onciu_Foldable$SkipChildren__init_0(var_1, var_0);
        return var_1;
    };
    $java.onciu_Foldable$SkipChildren_productPrefix = function($this) {
        return $rt_s(3089);
    };
    $java.onciu_Foldable$SkipChildren_productArity = function($this) {
        return 1;
    };
    $java.onciu_Foldable$SkipChildren_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$acc;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_Foldable$SkipChildren_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Foldable$SkipChildren_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Foldable$SkipChildren__init_0 = function($this, $acc) {
        $this.$acc = $acc;
    };
    $java.onciu_Foldable$TraverseChildren = function() {
        jl_Object.call(this);
        this.$acc0 = null;
    };
    $java.onciu_Foldable$TraverseChildren__init_0 = function(var_0) {
        var var_1 = new $java.onciu_Foldable$TraverseChildren();
        $java.onciu_Foldable$TraverseChildren__init_(var_1, var_0);
        return var_1;
    };
    $java.onciu_Foldable$TraverseChildren_productPrefix = function($this) {
        return $rt_s(3090);
    };
    $java.onciu_Foldable$TraverseChildren_productArity = function($this) {
        return 1;
    };
    $java.onciu_Foldable$TraverseChildren_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$acc0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_Foldable$TraverseChildren_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Foldable$TraverseChildren_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Foldable$TraverseChildren__init_ = function($this, $acc) {
        $this.$acc0 = $acc;
    };
    $java.onciu_Foldable$TraverseChildrenNewAccForSiblings = function() {
        var a = this; jl_Object.call(a);
        a.$accumulatorForChildren = null;
        a.$forSiblings = null;
    };
    $java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productPrefix = function($this) {
        return $rt_s(3091);
    };
    $java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productArity = function($this) {
        return 2;
    };
    $java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$accumulatorForChildren;
            case 1:
                return $this.$forSiblings;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Foldable$TraverseChildrenNewAccForSiblings_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Foldable$Folder$$anonfun$innerTreeFold$1$lambda$_13_0 = $rt_classWithoutFields();
    $java.onciu_Foldable$Folder$$anonfun$innerTreeFold$1$lambda$_13_0_apply = function(var$0, var$1) {
        s_Predef$_$callClinit();
        return var$1;
    };
    $java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1.$asCanonicalStringVal();
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(3092)), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_1 = $rt_classWithoutFields();
    $java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_1_apply = function(var$0) {
        return $rt_s(3);
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$6$lambda$_46_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0489 = null;
        a.$_1155 = null;
        a.$_258 = null;
    };
    $java.oncia_Union$$anonfun$defineUnionVariables$6$lambda$_46_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0489;
        var$3 = var$0.$_1155;
        var$4 = var$0.$_258;
        var$1 = $java.oncius_TypeSpec_union(var$2.$types1, var$1.$types1);
        var$1 = oncias_SemanticState_declareVariable(var$3.$elem5.$state, var$4.$unionVariable0, var$1, s_None$_MODULE$, 0, 1);
        if (!(var$1 instanceof su_Left)) {
            if (!(var$1 instanceof su_Right))
                $rt_throw(s_MatchError__init_(var$1));
            var$2 = oncias_SemanticCheckResult__init_(var$1.$value10, var$3.$elem5.$errors);
        } else {
            var$1 = var$1.$value11;
            var$2 = new oncias_SemanticCheckResult;
            var$4 = var$3.$elem5;
            oncias_SemanticCheckResult__init_0(var$2, var$4.$state, var$4.$errors.$prepended(var$1));
        }
        var$3.$elem5 = var$2;
        return sr_BoxedUnit_UNIT;
    };
    var sc_IterableOnceOps$$anon$1 = $rt_classWithoutFields(sr_AbstractFunction1);
    $java.sc_IterableOnceOps$$anon$1_apply = function($this, $v1) {
        return $this;
    };
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$23$lambda$_47_0 = $rt_classWithoutFields();
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$23$lambda$_47_0_apply = function(var$0, var$1) {
        return var$1;
    };
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$28$lambda$_52_0 = $rt_classWithoutFields();
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$28$lambda$_52_0_apply = function(var$0, var$1) {
        return var$1;
    };
    $java.sc_MapView$FilterKeys = function() {
        var a = this; sc_AbstractMapView.call(a);
        a.$underlying27 = null;
        a.$p3 = null;
    };
    $java.sc_MapView$FilterKeys_iterator = function($this) {
        var var$1, var$2;
        var$1 = sc_MapView$Id_iterator($this.$underlying27);
        var$2 = new $java.sc_MapView$FilterKeys$iterator$lambda$_0_0;
        var$2.$_0537 = $this;
        return var$1.$filter(var$2);
    };
    $java.sc_MapView$FilterKeys_knownSize = function($this) {
        if (sc_MapView$Id_knownSize($this.$underlying27))
            return (-1);
        return 0;
    };
    $java.sc_MapView$FilterKeys_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($java.sc_MapView$FilterKeys_iterator($this));
    };
    $java.oncie_MultiOperatorExpression$asCanonicalStringVal$lambda$_2_0 = $rt_classWithoutFields();
    $java.oncie_MultiOperatorExpression$asCanonicalStringVal$lambda$_2_0_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    $java.oncia_CompositePropertyConstraintCommand$$anonfun$semanticCheck$4$lambda$_6_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0479 = null;
        a.$_1152 = null;
    };
    $java.oncia_CompositePropertyConstraintCommand$$anonfun$semanticCheck$4$lambda$_6_0_apply = function(var$0) {
        return var$0.$_0479.$error2($rt_s(2741), var$0.$_1152.$position31);
    };
    $java.onciap_DefaultExpressionStringifier$$anonfun$prettyScope$2$lambda$_63_0 = $rt_classWithoutFields();
    $java.onciap_DefaultExpressionStringifier$$anonfun$prettyScope$2$lambda$_63_0_apply = function(var$0, var$1) {
        return var$1;
    };
    $java.oncius_ListType$$anonfun$isSubtypeOf$1$lambda$_54_0 = function() {
        jl_Object.call(this);
        this.$_0494 = null;
    };
    $java.oncius_ListType$$anonfun$isSubtypeOf$1$lambda$_54_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$0.$_0494.$isSubtypeOf(var$1));
    };
    $java.onciu_RewritableCompat$PROXY$7_229 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_229_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_229 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_229_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_230 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_230_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_230 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_230_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_231 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_231_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_231 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_231_paramsLength(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_232 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_232_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_232 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_232_paramsLength(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_233 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_233_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_233 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_233_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_234 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_234_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_234 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_234_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_235 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_235_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_235 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_235_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_846 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_846_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_RelationshipsPattern__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_850 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_850_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Divide__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_851 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_851_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_QuantifiedPath_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4]);
    }
    var onciu_RewritableCompat$PROXY$3_853 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_853_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Multiply__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_854 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_854_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Modulo__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_855 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_855_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_GraphRefType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_856 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_856_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncius_GeometryType_copy(var$2, var$3[0].$value8, var$3[1]);
    }
    $java.onciu_RewritableCompat$PROXY$7_236 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_236_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_236 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_236_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_237 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_237_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_237 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_237_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(5)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_238 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_238_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_238 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_238_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_239 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_239_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_239 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_239_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_858 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_858_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ReduceScope__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_859 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_859_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ExtractScope__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_861 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_861_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_FilterScope__init_(var$3[0], var$3[1], var$3[2]);
    }
    $java.onciu_RewritableCompat$PROXY$7_240 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_240_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_240 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_240_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_241 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_241_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_241 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_241_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_242 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_242_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_242 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_242_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.jur_BackReferencedSingleSet = $rt_classWithoutFields($java.jur_SingleSet);
    $java.jur_BackReferencedSingleSet_find = function($this, $startSearch, $testString, $matchResult) {
        var $res, $lastIndex, $saveStart;
        $res = 0;
        $lastIndex = $matchResult.$rightBound0;
        a: {
            while (true) {
                if ($startSearch > $lastIndex) {
                    $startSearch = $res;
                    break a;
                }
                $saveStart = $java.jur_MatchResultImpl_getStart($matchResult, $this.$groupIndex0);
                $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $startSearch);
                $res = $this.$kid.$matches1($startSearch, $testString, $matchResult);
                if ($res >= 0)
                    break;
                $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $saveStart);
                $startSearch = $startSearch + 1 | 0;
            }
        }
        return $startSearch;
    };
    $java.jur_BackReferencedSingleSet_findBack = function($this, $stringIndex, $startSearch, $testString, $matchResult) {
        var $res, $saveStart;
        $res = 0;
        a: {
            while (true) {
                if ($startSearch < $stringIndex) {
                    $startSearch = $res;
                    break a;
                }
                $saveStart = $java.jur_MatchResultImpl_getStart($matchResult, $this.$groupIndex0);
                $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $startSearch);
                $res = $this.$kid.$matches1($startSearch, $testString, $matchResult);
                if ($res >= 0)
                    break;
                $java.jur_MatchResultImpl_setStart($matchResult, $this.$groupIndex0, $saveStart);
                $startSearch = $startSearch + (-1) | 0;
            }
        }
        return $startSearch;
    };
    $java.jur_BackReferencedSingleSet_processBackRefReplacement = function($this) {
        return null;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0491 = null;
        a.$_1156 = null;
        a.$_259 = null;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = var$1;
        var$2 = var$0.$_0491;
        var$3 = var$0.$_1156;
        var$4 = var$0.$_259;
        var$5 = new $java.onciu_Foldable$SkipChildren;
        var$6 = new s_Tuple2;
        var$7 = var$1.$_10;
        var$8 = new $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$2$lambda$_3_0;
        var$8.$_0538 = var$2;
        s_Tuple2__init_0(var$6, var$7.$concat1(s_Option_filter(var$3, var$8)), var$1.$_20.$concat1(oncir_Deprecations$semanticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$findAllVariables$1(var$4)));
        $java.onciu_Foldable$SkipChildren__init_0(var$5, var$6);
        return var$5;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0493 = null;
        a.$_1157 = null;
        a.$_260 = null;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = var$1;
        var$2 = var$0.$_0493;
        var$3 = var$0.$_1157;
        var$4 = var$0.$_260;
        var$5 = new $java.onciu_Foldable$SkipChildren;
        var$6 = new s_Tuple2;
        var$7 = var$1.$_10;
        var$8 = new $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$4$lambda$_5_0;
        var$8.$_0539 = var$2;
        s_Tuple2__init_0(var$6, var$7.$concat1(s_Option_filter(var$3, var$8)), var$1.$_20.$concat1(oncir_Deprecations$semanticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$findAllVariables$1(var$4)));
        $java.onciu_Foldable$SkipChildren__init_0(var$5, var$6);
        return var$5;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_2 = function() {
        jl_Object.call(this);
        this.$_0492 = null;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0492;
        return $java.onciu_Foldable$TraverseChildren__init_0(s_Tuple2__init_(var$1.$_10.$incl(var$2), var$1.$_20));
    };
    $java.oncie_PathStep = $rt_classWithoutFields(0);
    var oncie_SingleRelationshipPathStep = $rt_classWithoutFields(oncie_Expression);
    var oncie_NodePathStep = $rt_classWithoutFields(oncie_Expression);
    var oncie_MultiRelationshipPathStep = $rt_classWithoutFields(oncie_Expression);
    var oncie_RepeatPathStep = $rt_classWithoutFields(oncie_Expression);
    var oncie_NilPathStep = $rt_classWithoutFields(oncie_Expression);
    function onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_0() {
        jl_Object.call(this);
        this.$_082 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_dispatch(var$0.$_082, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        return jl_Boolean_valueOf(sc_StringOps$_nonEmpty$extension(var$2, var$1));
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0534 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0534.$introducedVariables2();
        var$2 = sci_List_$colon$colon(var$1.$list4, var$2);
        var$3 = $java.oncie_Expression$TreeAcc_copy(var$1, var$1.$data0, var$2);
        var$1 = new $java.onciu_Foldable$TraverseChildrenNewAccForSiblings;
        var$2 = new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$1$lambda$_3_0;
        var$1.$accumulatorForChildren = var$3;
        var$1.$forSiblings = var$2;
        return var$1;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_1 = $rt_classWithoutFields();
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_2 = function() {
        jl_Object.call(this);
        this.$_0535 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0535;
        if ($java.oncie_Expression$TreeAcc_inScope(var$1, var$2))
            var$3 = $java.onciu_Foldable$SkipChildren__init_(var$1);
        else {
            var$3 = new $java.onciu_Foldable$SkipChildren;
            var$4 = new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$4$lambda$_6_0;
            var$4.$_0540 = var$2;
            $java.onciu_Foldable$SkipChildren__init_0(var$3, $java.oncie_Expression$TreeAcc_mapData(var$1, var$4));
        }
        return var$3;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_3 = $rt_classWithoutFields();
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_3_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_4 = function() {
        var a = this; jl_Object.call(a);
        a.$_0536 = null;
        a.$_1175 = null;
        a.$_261 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_4_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0536;
        var$3 = var$0.$_1175;
        var$4 = var$0.$_261;
        if (!var$2.$variablesUsedForGrouping$1.$contains0(var$3) && !$java.oncie_Expression$TreeAcc_inScope(var$1, var$3)) {
            var$2 = new $java.onciu_Foldable$SkipChildren;
            var$3 = new $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$7$lambda$_9_0;
            var$3.$_0541 = var$4;
            $java.onciu_Foldable$SkipChildren__init_0(var$2, $java.oncie_Expression$TreeAcc_mapData(var$1, var$3));
        } else
            var$2 = $java.onciu_Foldable$SkipChildren__init_(var$1);
        return var$2;
    };
    function onciu_Last() {
        jl_Object.call(this);
        this.$head3 = null;
    }
    function onciu_Last__init_(var_0) {
        var var_1 = new onciu_Last();
        $java.onciu_Last__init_(var_1, var_0);
        return var_1;
    }
    $java.onciu_Last_map = function($this, $f) {
        return $java.onciu_NonEmptyList_map$($this, $f);
    };
    $java.onciu_Last_mapAndPrependReversedTo = function($this, $f, $acc) {
        return $java.onciu_NonEmptyList_mapAndPrependReversedTo$($this, $f, $acc);
    };
    $java.onciu_Last_foldLeft = function($this, $acc0, $f) {
        return $java.onciu_NonEmptyList_foldLeft$($this, $acc0, $f);
    };
    $java.onciu_Last_reduceLeft = function($this, $f) {
        return $java.onciu_NonEmptyList_reduceLeft$($this, $f);
    };
    $java.onciu_Last_reverse = function($this) {
        return $java.onciu_NonEmptyList_reverse$($this);
    };
    $java.onciu_Last_toIterable = function($this) {
        return $java.onciu_NonEmptyList_toIterable$($this);
    };
    $java.onciu_Last_toIndexedSeq = function($this) {
        return $java.onciu_NonEmptyList_toIndexedSeq$($this);
    };
    $java.onciu_Last_knownSize = function($this) {
        return (-1);
    };
    $java.onciu_Last_head = function($this) {
        return $this.$head3;
    };
    $java.onciu_Last_tailOption = function($this) {
        return s_None$_MODULE$;
    };
    $java.onciu_Last_toString = function($this) {
        return jl_String_valueOf($this.$head3.$toString());
    };
    $java.onciu_Last_iterator = function($this) {
        var var$1;
        var$1 = new $java.onciu_Last$$anon$3;
        var$1.$remaining0 = s_Some__init_($this);
        return var$1;
    };
    $java.onciu_Last_productPrefix = function($this) {
        return $rt_s(2433);
    };
    $java.onciu_Last_productArity = function($this) {
        return 1;
    };
    $java.onciu_Last_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$head3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_Last_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Last_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Last_equals = function($this, $x$1) {
        var var$2;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof onciu_Last) ? 0 : 1))
                        break b;
                    $x$1 = $x$1;
                    if (!sr_BoxesRunTime_equals($this.$head3, $x$1.$head3))
                        break b;
                }
                var$2 = 1;
                break a;
            }
            var$2 = 0;
        }
        return var$2;
    };
    $java.onciu_Last__init_ = function($this, $head) {
        $this.$head3 = $head;
    };
    $java.ju_LinkedHashMap$1 = function() {
        ju_AbstractSet.call(this);
        this.$this$03 = null;
    };
    function onciap_Prettifier$asString$lambda$_31_0() {
        jl_Object.call(this);
        this.$_0542 = null;
    }
    function onciap_Prettifier$asString$lambda$_31_0__init_(var_0) {
        var var_1 = new onciap_Prettifier$asString$lambda$_31_0();
        $java.onciap_Prettifier$asString$lambda$_31_0__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$asString$lambda$_31_0__init_ = function(var$0, var$1) {
        var$0.$_0542 = var$1;
    };
    function onciap_Prettifier$asString$lambda$_31_1() {
        jl_Object.call(this);
        this.$_0543 = null;
    }
    function onciap_Prettifier$asString$lambda$_31_1__init_(var_0) {
        var var_1 = new onciap_Prettifier$asString$lambda$_31_1();
        $java.onciap_Prettifier$asString$lambda$_31_1__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$asString$lambda$_31_1__init_ = function(var$0, var$1) {
        var$0.$_0543 = var$1;
    };
    function onciap_Prettifier$asString$lambda$_31_2() {
        jl_Object.call(this);
        this.$_0544 = null;
    }
    function onciap_Prettifier$asString$lambda$_31_2__init_(var_0) {
        var var_1 = new onciap_Prettifier$asString$lambda$_31_2();
        $java.onciap_Prettifier$asString$lambda$_31_2__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$asString$lambda$_31_2__init_ = function(var$0, var$1) {
        var$0.$_0544 = var$1;
    };
    $java.srj_JFunction0$mcZ$sp = $rt_classWithoutFields(0);
    $java.srj_JFunction0$mcZ$sp_apply = function($this) {
        return jl_Boolean_valueOf($this.$apply$mcZ$sp());
    };
    var onciap_Prettifier$asString$lambda$_32_0 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_0__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_0();
        $java.onciap_Prettifier$asString$lambda$_32_0__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_0__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_1 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_1__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_1();
        $java.onciap_Prettifier$asString$lambda$_32_1__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_1__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_2 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_2__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_2();
        $java.onciap_Prettifier$asString$lambda$_32_2__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_2__init_ = function(var$0) {};
    function onciap_Prettifier$asString$lambda$_32_3() {
        jl_Object.call(this);
        this.$_0545 = null;
    }
    function onciap_Prettifier$asString$lambda$_32_3__init_(var_0) {
        var var_1 = new onciap_Prettifier$asString$lambda$_32_3();
        $java.onciap_Prettifier$asString$lambda$_32_3__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$asString$lambda$_32_3__init_ = function(var$0, var$1) {
        var$0.$_0545 = var$1;
    };
    var onciap_Prettifier$asString$lambda$_32_4 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_4__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_4();
        $java.onciap_Prettifier$asString$lambda$_32_4__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_4__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_5 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_5__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_5();
        $java.onciap_Prettifier$asString$lambda$_32_5__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_5__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_6 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_6__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_6();
        $java.onciap_Prettifier$asString$lambda$_32_6__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_6__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_7 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_7__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_7();
        $java.onciap_Prettifier$asString$lambda$_32_7__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_7__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_8 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_8__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_8();
        $java.onciap_Prettifier$asString$lambda$_32_8__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_8__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_9 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_9__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_9();
        $java.onciap_Prettifier$asString$lambda$_32_9__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_9__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_10 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_10__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_10();
        $java.onciap_Prettifier$asString$lambda$_32_10__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_10__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_11 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_11__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_11();
        $java.onciap_Prettifier$asString$lambda$_32_11__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_11__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_12 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_12__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_12();
        $java.onciap_Prettifier$asString$lambda$_32_12__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_12__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_13 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_13__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_13();
        $java.onciap_Prettifier$asString$lambda$_32_13__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_13__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_14 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_14__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_14();
        $java.onciap_Prettifier$asString$lambda$_32_14__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_14__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_15 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_15__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_15();
        $java.onciap_Prettifier$asString$lambda$_32_15__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_15__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_16 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_16__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_16();
        $java.onciap_Prettifier$asString$lambda$_32_16__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_16__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_17 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_17__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_17();
        $java.onciap_Prettifier$asString$lambda$_32_17__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_17__init_ = function(var$0) {};
    function onciap_Prettifier$asString$lambda$_32_18() {
        jl_Object.call(this);
        this.$_0546 = null;
    }
    function onciap_Prettifier$asString$lambda$_32_18__init_(var_0) {
        var var_1 = new onciap_Prettifier$asString$lambda$_32_18();
        $java.onciap_Prettifier$asString$lambda$_32_18__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$asString$lambda$_32_18__init_ = function(var$0, var$1) {
        var$0.$_0546 = var$1;
    };
    var onciap_Prettifier$asString$lambda$_32_19 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_19__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_19();
        $java.onciap_Prettifier$asString$lambda$_32_19__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_19__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_20 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_20__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_20();
        $java.onciap_Prettifier$asString$lambda$_32_20__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_20__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_21 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_21__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_21();
        $java.onciap_Prettifier$asString$lambda$_32_21__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_21__init_ = function(var$0) {};
    var onciap_Prettifier$asString$lambda$_32_22 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_32_22__init_() {
        var var_0 = new onciap_Prettifier$asString$lambda$_32_22();
        $java.onciap_Prettifier$asString$lambda$_32_22__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$asString$lambda$_32_22__init_ = function(var$0) {};
    function onciap_Prettifier$asString$lambda$_32_23() {
        jl_Object.call(this);
        this.$_0547 = null;
    }
    function onciap_Prettifier$asString$lambda$_32_23__init_(var_0) {
        var var_1 = new onciap_Prettifier$asString$lambda$_32_23();
        $java.onciap_Prettifier$asString$lambda$_32_23__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$asString$lambda$_32_23__init_ = function(var$0, var$1) {
        var$0.$_0547 = var$1;
    };
    $java.oncius_TypeSpec$$exact$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$exact$lambda$_4_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeRange$_apply($java.oncius_TypeRange$_MODULE$, var$1, var$1);
    };
    $java.oncie_SemanticDirection = $rt_classWithoutFields(0);
    var oncie_SemanticDirection$INCOMING$ = $rt_classWithoutFields();
    var oncie_SemanticDirection$INCOMING$_MODULE$ = null;
    function oncie_SemanticDirection$INCOMING$__clinit_() {
        oncie_SemanticDirection$INCOMING$_MODULE$ = new oncie_SemanticDirection$INCOMING$;
    }
    $java.oncie_SemanticDirection$INCOMING$_productArity = function($this) {
        return 0;
    };
    $java.oncie_SemanticDirection$INCOMING$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SemanticDirection$INCOMING$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SemanticDirection$INCOMING$_hashCode = function($this) {
        return 875423782;
    };
    $java.oncie_SemanticDirection$INCOMING$_toString = function($this) {
        return $rt_s(3093);
    };
    var oncie_SemanticDirection$BOTH$ = $rt_classWithoutFields();
    var oncie_SemanticDirection$BOTH$_MODULE$ = null;
    function oncie_SemanticDirection$BOTH$__clinit_() {
        oncie_SemanticDirection$BOTH$_MODULE$ = new oncie_SemanticDirection$BOTH$;
    }
    $java.oncie_SemanticDirection$BOTH$_productArity = function($this) {
        return 0;
    };
    $java.oncie_SemanticDirection$BOTH$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SemanticDirection$BOTH$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SemanticDirection$BOTH$_hashCode = function($this) {
        return 2044801;
    };
    $java.oncie_SemanticDirection$BOTH$_toString = function($this) {
        return $rt_s(3094);
    };
    var oncie_SemanticDirection$OUTGOING$ = $rt_classWithoutFields();
    var oncie_SemanticDirection$OUTGOING$_MODULE$ = null;
    function oncie_SemanticDirection$OUTGOING$__clinit_() {
        oncie_SemanticDirection$OUTGOING$_MODULE$ = new oncie_SemanticDirection$OUTGOING$;
    }
    $java.oncie_SemanticDirection$OUTGOING$_productArity = function($this) {
        return 0;
    };
    $java.oncie_SemanticDirection$OUTGOING$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_SemanticDirection$OUTGOING$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_SemanticDirection$OUTGOING$_hashCode = function($this) {
        return 844309356;
    };
    $java.oncie_SemanticDirection$OUTGOING$_toString = function($this) {
        return $rt_s(3095);
    };
    function sci_ArraySeq$$newBuilder$lambda$_21_0() {
        jl_Object.call(this);
        this.$_053 = null;
    }
    $java.sci_ArraySeq$$newBuilder$lambda$_21_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_053;
        return sci_ArraySeq$_unsafeWrapArray(sci_ArraySeq$_MODULE$, sc_IterableOnceOps_toArray$(var$1, var$2));
    };
    function s_Enumeration$Value() {
        var a = this; jl_Object.call(a);
        a.$scala$Enumeration$$outerEnum = null;
        a.$$outer44 = null;
    }
    $java.s_Enumeration$Value_equals = function($this, $other) {
        if (!($other instanceof s_Enumeration$Value))
            return 0;
        $other = $other;
        if ($this.$scala$Enumeration$$outerEnum === $other.$scala$Enumeration$$outerEnum && $this.$i2 == $other.$i2)
            return 1;
        return 0;
    };
    $java.s_Enumeration$Value_hashCode = function($this) {
        return $this.$i2;
    };
    $java.s_Enumeration$Val = function() {
        var a = this; s_Enumeration$Value.call(a);
        a.$i2 = 0;
        a.$name58 = null;
    };
    $java.s_Enumeration$Val_toString = function($this) {
        var var$1, $$je;
        var$1 = $this.$name58;
        if (var$1 !== null)
            return var$1;
        a: {
            try {
                var$1 = $java.s_Enumeration_scala$Enumeration$$nameOf($java.s_Enumeration$Val_scala$Enumeration$Val$$$outer($this), $this.$i2);
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof ju_NoSuchElementException) {
                    break a;
                } else {
                    throw $$e;
                }
            }
            return var$1;
        }
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$1, 30);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(3096));
        var$1 = jl_StringBuilder_append0(var$1, $this.$i2);
        jl_AbstractStringBuilder_append1(var$1, $rt_s(398));
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.s_Enumeration$Val_scala$Enumeration$Val$$$outer = function($this) {
        return $this.$$outer44;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$aggregationGroupingExpressions$1 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1_applyOrElse = function($this, $x1, $default) {
        var $expr;
        if ($x1 instanceof oncie_Expression) {
            $default = $x1;
            if ($this.$aggregationGroupingExpressions$1.$contains0($default))
                return new $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_0;
        }
        if ($x1 !== null) {
            $x1 = $java.oncie_IsAggregate$_unapply($java.oncie_IsAggregate$_MODULE$, $x1);
            if (!s_Option_isEmpty($x1)) {
                $expr = $x1.$get0();
                if ($expr instanceof oncie_Expression) {
                    $x1 = $expr;
                    $default = new $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_1;
                    $default.$_0548 = $x1;
                    return $default;
                }
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    $java.ju_AbstractList$SubAbstractList = function() {
        var a = this; ju_AbstractList.call(a);
        a.$fullList = null;
        a.$offset3 = 0;
        a.$size12 = 0;
    };
    $java.ju_AbstractList$SubAbstractList__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.ju_AbstractList$SubAbstractList();
        $java.ju_AbstractList$SubAbstractList__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.ju_AbstractList$SubAbstractList__init_0 = function($this, $list, $start, $end) {
        $this.$fullList = $list;
        $this.$modCount = $list.$modCount;
        $this.$offset3 = $start;
        $this.$size12 = $end - $start | 0;
    };
    $java.ju_AbstractList$SubAbstractList_get = function($this, $location) {
        var var$2, var$3;
        var$2 = $this.$modCount;
        var$3 = $this.$fullList;
        if (var$2 != var$3.$modCount) {
            var$3 = new ju_ConcurrentModificationException;
            jl_Throwable__init_0(var$3);
            $rt_throw(var$3);
        }
        if (0 <= $location && $location < $this.$size12)
            return ju_ArrayList_get(var$3, $location + $this.$offset3 | 0);
        var$3 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$3);
        $rt_throw(var$3);
    };
    $java.ju_AbstractList$SubAbstractList_iterator = function($this) {
        return $java.ju_AbstractList$SubAbstractList_listIterator($this, 0);
    };
    $java.ju_AbstractList$SubAbstractList_listIterator = function($this, $location) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$2 = $this.$modCount;
        var$3 = $this.$fullList;
        var$4 = var$3.$modCount;
        if (var$2 != var$4) {
            var$3 = new ju_ConcurrentModificationException;
            jl_Throwable__init_0(var$3);
            $rt_throw(var$3);
        }
        if (0 <= $location) {
            var$2 = $this.$size12;
            if ($location <= var$2) {
                var$5 = new $java.ju_AbstractList$SubAbstractList$SubAbstractListIterator;
                var$6 = $this.$offset3;
                $location = $location + var$6 | 0;
                var$7 = new $java.ju_AbstractList$TListIteratorImpl;
                var$8 = var$3.$size2;
                var$7.$this$041 = var$3;
                var$7.$i6 = $location;
                var$7.$j = $location;
                var$7.$lastModCount = var$4;
                var$7.$sz = var$8;
                var$5.$iterator4 = var$7;
                var$5.$subList = $this;
                var$5.$start9 = var$6;
                var$5.$end6 = var$6 + var$2 | 0;
                return var$5;
            }
        }
        var$3 = new jl_IndexOutOfBoundsException;
        jl_Throwable__init_0(var$3);
        $rt_throw(var$3);
    };
    $java.ju_AbstractList$SubAbstractList_size = function($this) {
        var var$1;
        if ($this.$modCount == $this.$fullList.$modCount)
            return $this.$size12;
        var$1 = new ju_ConcurrentModificationException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    };
    $java.ju_AbstractList$SubAbstractListRandomAccess = $rt_classWithoutFields($java.ju_AbstractList$SubAbstractList);
    var oncias_SymbolUse$ = $rt_classWithoutFields();
    var oncias_SymbolUse$_MODULE$ = null;
    function oncias_SymbolUse$__clinit_() {
        oncias_SymbolUse$_MODULE$ = new oncias_SymbolUse$;
    }
    function oncias_SymbolUse$_apply($this, $variable) {
        var var$2;
        var$2 = new oncias_SymbolUse;
        var$2.$use = onciu_Ref$_apply(onciu_Ref$_MODULE$, $variable);
        return var$2;
    }
    function onciap_DefaultPathStepStringifier$relationshipPathStep$lambda$_1_0() {
        jl_Object.call(this);
        this.$_0153 = null;
    }
    var onciap_DefaultPathStepStringifier$relationshipPathStep$lambda$_1_1 = $rt_classWithoutFields();
    var onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_0 = $rt_classWithoutFields();
    var onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_1 = $rt_classWithoutFields();
    var onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_2 = $rt_classWithoutFields();
    function onciap_Prettifier$asString$lambda$_33_0() {
        jl_Object.call(this);
        this.$_071 = null;
    }
    function onciap_Prettifier$asString$lambda$_33_1() {
        jl_Object.call(this);
        this.$_072 = null;
    }
    var onciap_Prettifier$asString$lambda$_33_2 = $rt_classWithoutFields();
    function onciap_Prettifier$getStartOfCommand$1$lambda$_60_0() {
        jl_Object.call(this);
        this.$_077 = null;
    }
    var onciap_Prettifier$getStartOfCommand$1$lambda$_60_1 = $rt_classWithoutFields();
    function onciap_Prettifier$propertiesToString$1$lambda$_53_0() {
        jl_Object.call(this);
        this.$_075 = null;
    }
    function onciap_Prettifier$fulltextPropertiesToString$1$lambda$_55_0() {
        jl_Object.call(this);
        this.$_076 = null;
    }
    function onciap_Prettifier$showClausesAsString$1$lambda$_67_0() {
        jl_Object.call(this);
        this.$_078 = null;
    }
    function onciap_Prettifier$showClausesAsString$1$lambda$_67_1() {
        jl_Object.call(this);
        this.$_079 = null;
    }
    var onciap_Prettifier$showClausesAsString$1$lambda$_67_2 = $rt_classWithoutFields();
    function onciap_Prettifier$asIndividualOptions$lambda$_36_0() {
        jl_Object.call(this);
        this.$_074 = null;
    }
    var oncias_ExpressionTypeInfo$ = $rt_classWithoutFields();
    var oncias_ExpressionTypeInfo$_MODULE$ = null;
    function oncias_ExpressionTypeInfo$__clinit_() {
        oncias_ExpressionTypeInfo$_MODULE$ = new oncias_ExpressionTypeInfo$;
    }
    function oncias_ExpressionTypeInfo$_apply($this, $specified, $expected) {
        var var$3;
        var$3 = new oncias_ExpressionTypeInfo;
        var$3.$specified = $specified;
        var$3.$expected = $expected;
        return var$3;
    }
    $java.oncias_SemanticCheck$$anonfun$chain$1$lambda$_31_0 = function() {
        jl_Object.call(this);
        this.$_0402 = null;
    };
    $java.oncias_SemanticCheck$$anonfun$chain$1$lambda$_31_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0402;
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2.$errors.$concat0(var$1.$errors));
    };
    function onciap_Prettifier$optionsToString$lambda$_35_0() {
        jl_Object.call(this);
        this.$_073 = null;
    }
    $java.sc_SeqOps$$anonfun$occCounts$1$lambda$_141_0 = $rt_classWithoutFields();
    $java.sc_SeqOps$$anonfun$occCounts$1$lambda$_141_0_apply = function(var$0, var$1) {
        var var$2;
        if (jl_Object_equals(s_None$_MODULE$, var$1))
            var$1 = s_Some__init_(jl_Integer_valueOf(1));
        else {
            if (!(var$1 instanceof s_Some))
                $rt_throw(s_MatchError__init_(var$1));
            var$2 = sr_BoxesRunTime_unboxToInt(var$1.$value5);
            var$1 = s_Some__init_(jl_Integer_valueOf(var$2 + 1 | 0));
        }
        return var$1;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$$anonfun$applyOrElse$4$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0452 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$$anonfun$applyOrElse$4$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = s_Option_map((oncias_SemanticTable_typeFor(var$0.$_0452.$semanticTable$1, var$1)).$typeInfo, new $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$createError$lambda$_3_0);
        if (!(var$2 instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, var$2))
                $rt_throw(s_MatchError__init_(var$2));
            var$3 = var$1.$name4;
            var$4 = $rt_createArray(jl_Object, 1);
            var$4.data[0] = var$3;
            var$2 = jl_String_format($rt_s(3097), var$4);
        } else {
            var$2 = var$2.$value5;
            var$2 = jl_String_format($rt_s(3098), $rt_createArrayFromData(jl_Object, [var$2, var$1.$name4]));
        }
        return oncias_SemanticError__init_0(var$2, var$1.$position0);
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0453 = null;
        a.$_1137 = null;
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0453;
        var$3 = var$0.$_1137;
        return var$2.$merge$1.$apply0(var$1, var$3);
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_1 = function() {
        jl_Object.call(this);
        this.$_0454 = null;
    };
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_1_apply = function(var$0) {
        return var$0.$_0454;
    };
    $java.onciu_RewritableCompat$PROXY$7_243 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_243_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_243 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_243_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_866 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_866_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_Pow__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_873 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_873_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_RelationshipPattern_copy(var$2, var$3[0], var$3[1], var$3[2], var$3[3], var$3[4], var$3[5], var$3[6]);
    }
    $java.onciu_RewritableCompat$PROXY$7_244 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_244_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_244 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_244_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    var ju_LinkedHashMap$KeyIterator = $rt_classWithoutFields(ju_LinkedHashMap$AbstractMapIterator);
    function ju_LinkedHashMap$KeyIterator_next($this) {
        $java.ju_LinkedHashMap$AbstractMapIterator_makeNext($this);
        return $this.$currentEntry0.$key0;
    }
    $java.oncie_QuantifiedPath$allVariables$lambda$_9_0 = $rt_classWithoutFields();
    $java.oncie_QuantifiedPath$allVariables$lambda$_9_0_apply = function(var$0, var$1) {
        return var$1.$group0;
    };
    $java.oncie_PathConcatenation$allVariables$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncie_PathConcatenation$allVariables$lambda$_4_0_apply = function(var$0, var$1) {
        return var$1.$allVariables();
    };
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_1 = function() {
        jl_Object.call(this);
        this.$_0548 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0548;
        var$3 = new $java.onciu_Foldable$SkipChildren;
        var$4 = new $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$$anonfun$applyOrElse$10$lambda$_4_0;
        var$4.$_0549 = var$2;
        $java.onciu_Foldable$SkipChildren__init_0(var$3, $java.oncie_Expression$TreeAcc_mapData(var$1, var$4));
        return var$3;
    };
    $java.jur_AbstractCharClass$LazyJavaLowerCase$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$025 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaLowerCase$1_contains = function($this, $ch) {
        return jl_Character_getType($ch) != 2 ? 0 : 1;
    };
    $java.jur_AbstractCharClass$LazyJavaUpperCase$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$026 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaUpperCase$1_contains = function($this, $ch) {
        return jl_Character_getType($ch) != 1 ? 0 : 1;
    };
    $java.jur_AbstractCharClass$LazyJavaWhitespace$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$027 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaWhitespace$1_contains = function($this, $ch) {
        return jl_Character_isWhitespace($ch);
    };
    $java.jur_AbstractCharClass$LazyJavaMirrored$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$028 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaMirrored$1_contains = function($this, $ch) {
        return 0;
    };
    $java.jur_AbstractCharClass$LazyJavaDefined$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$029 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaDefined$1_contains = function($this, $ch) {
        return jl_Character_isDefined($ch);
    };
    $java.jur_AbstractCharClass$LazyJavaDigit$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$030 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaDigit$1_contains = function($this, $ch) {
        return jl_Character_getType($ch) != 9 ? 0 : 1;
    };
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$031 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable$1_contains = function($this, $ch) {
        return jl_Character_isIdentifierIgnorable($ch);
    };
    $java.jur_AbstractCharClass$LazyJavaISOControl$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$032 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaISOControl$1_contains = function($this, $ch) {
        return jl_Character_isISOControl($ch);
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$033 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart$1_contains = function($this, $ch) {
        a: {
            b: {
                switch (jl_Character_getType($ch)) {
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 8:
                    case 9:
                    case 10:
                    case 23:
                    case 26:
                        break;
                    case 7:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                    case 19:
                    case 20:
                    case 21:
                    case 22:
                    case 24:
                    case 25:
                        break b;
                    default:
                        break b;
                }
                $ch = 1;
                break a;
            }
            $ch = jl_Character_isIdentifierIgnorable($ch);
        }
        return $ch;
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$034 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart$1_contains = function($this, $ch) {
        a: {
            b: {
                switch (jl_Character_getType($ch)) {
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 10:
                    case 23:
                    case 26:
                        break;
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                    case 19:
                    case 20:
                    case 21:
                    case 22:
                    case 24:
                    case 25:
                        break b;
                    default:
                        break b;
                }
                $ch = 1;
                break a;
            }
            $ch = jl_Character_isIdentifierIgnorable($ch);
        }
        return $ch;
    };
    $java.jur_AbstractCharClass$LazyJavaLetter$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$035 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaLetter$1_contains = function($this, $ch) {
        a: {
            switch (jl_Character_getType($ch)) {
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                    break;
                default:
                    $ch = 0;
                    break a;
            }
            $ch = 1;
        }
        return $ch;
    };
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$036 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit$1_contains = function($this, $ch) {
        return jl_Character_isLetterOrDigit($ch);
    };
    $java.jur_AbstractCharClass$LazyJavaSpaceChar$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$037 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaSpaceChar$1_contains = function($this, $ch) {
        return jl_Character_isSpaceChar($ch);
    };
    $java.jur_AbstractCharClass$LazyJavaTitleCase$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$038 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaTitleCase$1_contains = function($this, $ch) {
        return jl_Character_getType($ch) != 3 ? 0 : 1;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$039 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart$1_contains = function($this, $ch) {
        a: {
            b: {
                switch (jl_Character_getType($ch)) {
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 8:
                    case 9:
                    case 10:
                    case 23:
                        break;
                    case 7:
                    case 11:
                    case 12:
                    case 13:
                    case 14:
                    case 15:
                    case 16:
                    case 17:
                    case 18:
                    case 19:
                    case 20:
                    case 21:
                    case 22:
                        break b;
                    default:
                        break b;
                }
                $ch = 1;
                break a;
            }
            $ch = jl_Character_isIdentifierIgnorable($ch);
        }
        return $ch;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart$1 = function() {
        jur_AbstractCharClass.call(this);
        this.$this$040 = null;
    };
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart$1_contains = function($this, $ch) {
        a: {
            b: {
                switch (jl_Character_getType($ch)) {
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 10:
                        break;
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                        break b;
                    default:
                        break b;
                }
                $ch = 1;
                break a;
            }
            $ch = jl_Character_isIdentifierIgnorable($ch);
        }
        return $ch;
    };
    $java.jur_UnicodeCategory = function() {
        jur_AbstractCharClass.call(this);
        this.$category2 = 0;
    };
    $java.jur_UnicodeCategory__init_ = function(var_0) {
        var var_1 = new $java.jur_UnicodeCategory();
        $java.jur_UnicodeCategory__init_0(var_1, var_0);
        return var_1;
    };
    $java.jur_UnicodeCategory__init_0 = function($this, $category) {
        $java.jur_AbstractCharClass__init_($this);
        $this.$category2 = $category;
    };
    $java.jur_UnicodeCategory_contains = function($this, $ch) {
        return $this.$alt0 ^ ($this.$category2 != jl_Character_getType($ch & 65535) ? 0 : 1);
    };
    $java.jur_UnicodeCategoryScope = $rt_classWithoutFields($java.jur_UnicodeCategory);
    $java.jur_UnicodeCategoryScope_contains = function($this, $ch) {
        return $this.$alt0 ^ (!($this.$category2 >> jl_Character_getType($ch & 65535) & 1) ? 0 : 1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_3_0() {
        jl_Object.call(this);
        this.$_0143 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_3_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0143.$expr1, var$1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_3_1() {
        jl_Object.call(this);
        this.$_0144 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_3_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0144;
        var$3 = !var$1.$containsIs6() ? $rt_s(136) : $rt_s(3099);
        var$1 = onciap_DefaultExpressionStringifier_stringifyLabelExpression(var$2.$expr1, var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$3), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_3_2() {
        jl_Object.call(this);
        this.$_0145 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_3_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0145.$expr1, var$1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_3_3() {
        jl_Object.call(this);
        this.$_0146 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_3_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultPatternStringifier_stringifyPredicate(var$0.$_0146, var$1);
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_3_4 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_3_4_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_5_0() {
        jl_Object.call(this);
        this.$_0147 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_5_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0147.$expr1, var$1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_5_1() {
        jl_Object.call(this);
        this.$_0148 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_5_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0148;
        var$3 = !var$1.$containsIs6() ? $rt_s(136) : $rt_s(3099);
        var$1 = onciap_DefaultExpressionStringifier_stringifyLabelExpression(var$2.$expr1, var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$3), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_5_2() {
        jl_Object.call(this);
        this.$_0149 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_5_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0149.$expr1, var$1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_5_3() {
        jl_Object.call(this);
        this.$_0150 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_5_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultPatternStringifier_stringifyPredicate(var$0.$_0150, var$1);
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_5_4 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_5_4_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_5_5 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_5_5_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 91);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$2, var$1), 93);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.scm_ArraySeq$$newBuilder$lambda$_21_0 = $rt_classWithoutFields();
    $java.scm_ArraySeq$$newBuilder$lambda$_21_0_apply = function(var$0, var$1) {
        return $java.scm_ArraySeq$_make($java.scm_ArraySeq$_MODULE$, var$1);
    };
    $java.sc_MapView$FilterKeys$iterator$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0537 = null;
    };
    $java.sc_MapView$FilterKeys$iterator$lambda$_0_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(null));
        var$1 = var$1.$_10;
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(jl_Boolean_valueOf(!jl_String_equalsIgnoreCase(var$1, $rt_s(1860)) && !jl_String_equalsIgnoreCase(var$1, $rt_s(3100)) ? 1 : 0)));
    };
    function onciu_Fby() {
        var a = this; jl_Object.call(a);
        a.$head4 = null;
        a.$tail6 = null;
    }
    function onciu_Fby__init_(var_0, var_1) {
        var var_2 = new onciu_Fby();
        $java.onciu_Fby__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.onciu_Fby_map = function($this, $f) {
        return $java.onciu_NonEmptyList_map$($this, $f);
    };
    $java.onciu_Fby_mapAndPrependReversedTo = function($this, $f, $acc) {
        return $java.onciu_NonEmptyList_mapAndPrependReversedTo$($this, $f, $acc);
    };
    $java.onciu_Fby_foldLeft = function($this, $acc0, $f) {
        return $java.onciu_NonEmptyList_foldLeft$($this, $acc0, $f);
    };
    $java.onciu_Fby_reduceLeft = function($this, $f) {
        return $java.onciu_NonEmptyList_reduceLeft$($this, $f);
    };
    $java.onciu_Fby_reverse = function($this) {
        return $java.onciu_NonEmptyList_reverse$($this);
    };
    $java.onciu_Fby_toIterable = function($this) {
        return $java.onciu_NonEmptyList_toIterable$($this);
    };
    $java.onciu_Fby_toIndexedSeq = function($this) {
        return $java.onciu_NonEmptyList_toIndexedSeq$($this);
    };
    $java.onciu_Fby_knownSize = function($this) {
        return (-1);
    };
    $java.onciu_Fby_head = function($this) {
        return $this.$head4;
    };
    $java.onciu_Fby_tailOption = function($this) {
        return s_Some__init_($this.$tail6);
    };
    $java.onciu_Fby_toString = function($this) {
        var var$1, var$2, var$3;
        var$1 = $this.$head4.$toString();
        var$2 = $this.$tail6.$toString();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$1), $rt_s(16)), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    $java.onciu_Fby_iterator = function($this) {
        var var$1;
        var$1 = new $java.onciu_Fby$$anon$2;
        var$1.$remaining1 = s_Some__init_($this);
        return var$1;
    };
    $java.onciu_Fby_productPrefix = function($this) {
        return $rt_s(3101);
    };
    $java.onciu_Fby_productArity = function($this) {
        return 2;
    };
    $java.onciu_Fby_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$head4;
            case 1:
                return $this.$tail6;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_Fby_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Fby_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_Fby_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof onciu_Fby) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        if (!sr_BoxesRunTime_equals($this.$head4, $x$1.$head4))
                            break b;
                        var$2 = $this.$tail6;
                        $x$1 = $x$1.$tail6;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.onciu_Fby__init_ = function($this, $head, $tail) {
        $this.$head4 = $head;
        $this.$tail6 = $tail;
    };
    var onciap_Prettifier$$escapeNames$lambda$_16_0 = $rt_classWithoutFields();
    var oncia_PropertyResource = $rt_classWithoutFields();
    var onciap_Prettifier$$prettifyGraphPrivilege$lambda$_7_0 = $rt_classWithoutFields();
    var oncia_LabelResource = $rt_classWithoutFields();
    var onciap_Prettifier$$prettifyGraphPrivilege$lambda$_7_1 = $rt_classWithoutFields();
    function onciap_Prettifier$$anonfun$prettifyLoadPrivilegeQualifier$1() {
        sr_AbstractPartialFunction.call(this);
        this.$expr$1 = null;
    }
    $java.onciap_Prettifier$$anonfun$prettifyLoadPrivilegeQualifier$1_applyOrElse = function($this, $x1, $default) {
        var var$3, $cidrParam, $urlString, $urlParam, $cidrString;
        var$3 = 0;
        $cidrParam = null;
        if ($x1 instanceof sci_$colon$colon) {
            var$3 = 1;
            $cidrParam = $x1;
            $urlString = $cidrParam.$head0;
            $urlParam = $cidrParam.$next0;
            if ($urlString instanceof oncia_LoadAllQualifier && sci_List_equals(sci_Nil$_MODULE$, $urlParam))
                return $rt_s(3102);
        }
        if (var$3) {
            $urlString = $cidrParam.$head0;
            $cidrString = $cidrParam.$next0;
            if ($urlString instanceof oncia_LoadUrlQualifier) {
                $urlString = $urlString.$url3;
                if ($urlString instanceof su_Left) {
                    $urlString = $urlString.$value11;
                    if (sci_List_equals(sci_Nil$_MODULE$, $cidrString)) {
                        $x1 = onciap_DefaultExpressionStringifier_quote($this.$expr$1, $urlString);
                        $default = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($default);
                        jl_StringBuilder_append(jl_StringBuilder_append($default, $rt_s(3103)), $x1);
                        return jl_AbstractStringBuilder_toString($default);
                    }
                }
            }
        }
        if (var$3) {
            $urlString = $cidrParam.$head0;
            $cidrString = $cidrParam.$next0;
            if ($urlString instanceof oncia_LoadUrlQualifier) {
                $urlString = $urlString.$url3;
                if ($urlString instanceof su_Right) {
                    $urlParam = $urlString.$value10;
                    if (sci_List_equals(sci_Nil$_MODULE$, $cidrString)) {
                        $urlString = onciap_DefaultExpressionStringifier_stringify($this.$expr$1, $urlParam);
                        $x1 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($x1);
                        jl_StringBuilder_append(jl_StringBuilder_append($x1, $rt_s(3103)), $urlString);
                        return jl_AbstractStringBuilder_toString($x1);
                    }
                }
            }
        }
        if (var$3) {
            $urlString = $cidrParam.$head0;
            $urlParam = $cidrParam.$next0;
            if ($urlString instanceof oncia_LoadCidrQualifier) {
                $urlString = $urlString.$cidr;
                if ($urlString instanceof su_Left) {
                    $cidrString = $urlString.$value11;
                    if (sci_List_equals(sci_Nil$_MODULE$, $urlParam)) {
                        $x1 = onciap_DefaultExpressionStringifier_quote($this.$expr$1, $cidrString);
                        $default = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($default);
                        jl_StringBuilder_append(jl_StringBuilder_append($default, $rt_s(3104)), $x1);
                        return jl_AbstractStringBuilder_toString($default);
                    }
                }
            }
        }
        if (var$3) {
            $urlString = $cidrParam.$head0;
            $urlParam = $cidrParam.$next0;
            if ($urlString instanceof oncia_LoadCidrQualifier) {
                $urlString = $urlString.$cidr;
                if ($urlString instanceof su_Right) {
                    $cidrParam = $urlString.$value10;
                    if (sci_List_equals(sci_Nil$_MODULE$, $urlParam)) {
                        $urlString = onciap_DefaultExpressionStringifier_stringify($this.$expr$1, $cidrParam);
                        $x1 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($x1);
                        jl_StringBuilder_append(jl_StringBuilder_append($x1, $rt_s(3104)), $urlString);
                        return jl_AbstractStringBuilder_toString($x1);
                    }
                }
            }
        }
        return s_PartialFunction$$anon$1_apply($default, $x1);
    };
    $java.onciap_Prettifier$$anonfun$prettifyLoadPrivilegeQualifier$1_applyOrElse0 = function($this, $x, $default) {
        return $java.onciap_Prettifier$$anonfun$prettifyLoadPrivilegeQualifier$1_applyOrElse($this, $x, $default);
    };
    function onciap_Prettifier$propertiesMapToString$lambda$_30_0() {
        jl_Object.call(this);
        this.$_070 = null;
    }
    var oncil_LabelExpression$Disjunctions$ = $rt_classWithoutFields();
    var oncil_LabelExpression$Disjunctions$_MODULE$ = null;
    function oncil_LabelExpression$Disjunctions$__clinit_() {
        oncil_LabelExpression$Disjunctions$_MODULE$ = new oncil_LabelExpression$Disjunctions$;
    }
    function oncil_LabelExpression$Disjunctions$_flat($this, $lhs, $rhs, $position, $containsIs) {
        var var$5;
        var$5 = new oncil_LabelExpression$Disjunctions;
        s_package$_$callClinit();
        $java.oncil_LabelExpression$Disjunctions__init_0(var$5, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData($java.oncil_LabelExpression, [$lhs, $rhs]))), $containsIs, $position);
        return $java.oncil_LabelExpression$Disjunctions_unnestDisjunctions(var$5);
    }
    $java.onciu_DeprecatedPropertyReferenceInCreate = function() {
        var a = this; jl_Object.call(a);
        a.$position254 = null;
        a.$varName = null;
    };
    $java.onciu_DeprecatedPropertyReferenceInCreate_productPrefix = function($this) {
        return $rt_s(3105);
    };
    $java.onciu_DeprecatedPropertyReferenceInCreate_productArity = function($this) {
        return 2;
    };
    $java.onciu_DeprecatedPropertyReferenceInCreate_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position254;
            case 1:
                return $this.$varName;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_DeprecatedPropertyReferenceInCreate_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedPropertyReferenceInCreate_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedPropertyReferenceInCreate_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_DeprecatedPropertyReferenceInCreate_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.onciu_DeprecatedPropertyReferenceInCreate) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position254;
                        var$3 = $x$1.$position254;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$varName;
                        $x$1 = $x$1.$varName;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.onciu_DeprecatedPropertyReferenceInCreate))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findSelfReferenceVariablesInPattern$lambda$_2_0 = function() {
        jl_Object.call(this);
        this.$_0451 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findSelfReferenceVariablesInPattern$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0451;
        var$3 = onciu_Foldable_folder$(var$1);
        var$1 = new s_Tuple2;
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        var$4 = sci_Set$EmptySet$_MODULE$;
        s_Predef$_Set(s_Predef$_MODULE$);
        s_Tuple2__init_0(var$1, var$4, sci_Set$EmptySet$_MODULE$);
        var$5 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1;
        var$5.$allSymbolDefinitions$10 = var$2;
        var$1 = onciu_Foldable$Folder_treeFold(var$3, var$1, var$5);
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        var$5 = s_Tuple2__init_(var$2, var$1);
        var$1 = var$5.$_10;
        return var$5.$_20.$intersect(var$1);
    };
    $java.jur_Matcher$1 = function() {
        var a = this; jl_Object.call(a);
        a.$grN = 0;
        a.$val$gr = 0;
        a.$this$042 = null;
    };
    $java.jur_Matcher$1__init_ = function(var_0, var_1) {
        var var_2 = new $java.jur_Matcher$1();
        $java.jur_Matcher$1__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.jur_Matcher$1__init_0 = function($this, $this$0, var$2) {
        $this.$this$042 = $this$0;
        $this.$val$gr = var$2;
        $this.$grN = var$2;
    };
    $java.jur_Matcher$1_toString = function($this) {
        return $java.jur_Matcher_group($this.$this$042, $this.$grN);
    };
    var onciap_DefaultPatternStringifier$concatenate$lambda$_9_0 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$concatenate$lambda$_9_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sc_IterableOnceOps_nonEmpty$(var$1));
    };
    function onciap_DefaultPatternStringifier$concatenate$lambda$_9_1() {
        jl_Object.call(this);
        this.$_0152 = null;
    }
    $java.onciap_DefaultPatternStringifier$concatenate$lambda$_9_1_apply = function(var$0, var$1) {
        return sc_AbstractIterable_mkString0(var$1, var$0.$_0152);
    };
    var onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_0 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_0_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_1 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_1_apply = function(var$0, var$1) {
        return var$1.$stringVal;
    };
    var onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_2 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_2_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_3 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_3_apply = function(var$0, var$1) {
        return var$1.$stringVal;
    };
    var oncia_ProcedureAllQualifier = $rt_classWithoutFields();
    var oncia_FunctionAllQualifier = $rt_classWithoutFields();
    var oncia_SettingAllQualifier = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$minimalRanges$lambda$_12_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$minimalRanges$lambda$_12_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$1 = var$1;
        var$2 = var$2;
        oncius_TypeSpec$_$callClinit();
        var$3 = s_Tuple2__init_(var$1, var$2);
        var$1 = var$3.$_10;
        var$2 = var$3.$_20;
        var$3 = new $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_0;
        var$3.$_0550 = var$2;
        if (!sc_IterableOnceOps_exists$(var$1, var$3)) {
            var$3 = new $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_1;
            var$3.$_0551 = var$2;
            var$1 = (sc_StrictOptimizedIterableOps_filterNot$(var$1, var$3)).$$colon$plus(var$2);
        }
        return var$1;
    };
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$26$lambda$_50_0 = $rt_classWithoutFields();
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$26$lambda$_50_0_apply = function(var$0, var$1) {
        return var$1;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$2$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0538 = null;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$2$lambda$_3_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(oncir_Deprecations$semanticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1(var$1, var$0.$_0538.$allSymbolDefinitions$1));
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$1$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$1$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$1.$list4.$tail();
        return $java.oncie_Expression$TreeAcc_copy(var$1, var$1.$data0, var$2);
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$4$lambda$_5_0 = function() {
        jl_Object.call(this);
        this.$_0539 = null;
    };
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$4$lambda$_5_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(oncir_Deprecations$semanticallyDeprecatedFeatures$_org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1(var$1, var$0.$_0539.$allSymbolDefinitions$1));
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$4$lambda$_6_0 = function() {
        jl_Object.call(this);
        this.$_0540 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$4$lambda$_6_0_apply = function(var$0, var$1) {
        return var$1.$appended(var$0.$_0540);
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$7$lambda$_9_0 = function() {
        jl_Object.call(this);
        this.$_0541 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$7$lambda$_9_0_apply = function(var$0, var$1) {
        return var$1.$appended(var$0.$_0541);
    };
    var onciap_Prettifier$$anonfun$stringify$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    var onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_0 = $rt_classWithoutFields();
    var onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(jl_String_equals(var$1, $rt_s(3)));
    };
    var onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_2_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 58);
        jl_StringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_3 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_3_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_4 = $rt_classWithoutFields();
    var onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6 = $rt_classWithoutFields();
    function onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6__init_() {
        var var_0 = new onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6();
        $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6__init_ = function(var$0) {};
    $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    var onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5 = $rt_classWithoutFields();
    function onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5__init_() {
        var var_0 = new onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5();
        $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5__init_(var_0);
        return var_0;
    }
    $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5__init_ = function(var$0) {};
    $java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    var oncius_TypeRange$ = $rt_classWithoutFields();
    $java.oncius_TypeRange$_MODULE$ = null;
    function oncius_TypeRange$__clinit_() {
        $java.oncius_TypeRange$_MODULE$ = new oncius_TypeRange$;
    }
    $java.oncius_TypeRange$_apply = function($this, $lower, $upper) {
        return $java.oncius_TypeRange__init_0($lower, s_Some__init_($upper));
    };
    function scm_Builder$$anon$1() {
        var a = this; jl_Object.call(a);
        a.$$outer53 = null;
        a.$f$11 = null;
    }
    function scm_Builder$$anon$1__init_(var_0, var_1) {
        var var_2 = new scm_Builder$$anon$1();
        $java.scm_Builder$$anon$1__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.scm_Builder$$anon$1_sizeHint = function($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    };
    $java.scm_Builder$$anon$1_sizeHint0 = function($this, $size) {
        $this.$$outer53.$sizeHint($size);
    };
    function scm_Builder$$anon$1_result($this) {
        return $this.$f$11.$apply($this.$$outer53.$result0());
    }
    $java.scm_Builder$$anon$1_addAll = function($this, $xs) {
        var var$2;
        var$2 = $this.$$outer53;
        if (var$2 !== null) {
            var$2.$addAll0($xs);
            return $this;
        }
        $rt_throw(null);
    };
    function scm_Builder$$anon$1_addOne($this, $elem) {
        var var$2;
        var$2 = $this.$$outer53;
        if (var$2 !== null) {
            var$2.$addOne($elem);
            return $this;
        }
        $rt_throw(null);
    }
    $java.scm_Builder$$anon$1__init_ = function($this, $$outer, $f$1) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer53 = $$outer;
        $this.$f$11 = $f$1;
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_0 = $rt_classWithoutFields();
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, oncias_SemanticState_newChildScope(var$1));
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_1 = function() {
        jl_Object.call(this);
        this.$_0483 = null;
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0483;
        var$3 = oncias_package$_MODULE$;
        var$4 = var$1.$variable34;
        oncius_package$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(var$3, var$2.$declareVariable(var$4, var$1.$cypherType.$invariant()));
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_2 = function() {
        jl_Object.call(this);
        this.$_0485 = null;
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0485;
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = new $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$9$lambda$_36_0;
        var$4.$_0552 = var$2;
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, var$1, var$4);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_all(oncius_TypeSpec$_MODULE$);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTRelationship(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTRelationship(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTRelationship(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return (oncius_package$_CTList(var$1, oncius_package$_CTRelationship(var$1))).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncie_PartialPredicate = $rt_classWithoutFields(0);
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTRelationship(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return sci_$colon$colon__init_(var$1.$_10, sci_$colon$colon__init_(var$1.$_20, sci_Nil$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18 = function() {
        jl_Object.call(this);
        this.$_0553 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18__init_0 = function(var$0, var$1) {
        var$0.$_0553 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0553;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = oncias_SemanticExpressionCheck$_MODULE$;
        oncius_package$_$callClinit();
        return oncias_SemanticAnalysisTooling_expectType$0(var$2, $java.oncius_BooleanType_covariant(oncius_package$_CTBoolean(oncius_package$_MODULE$)), var$1.$alternatives0.$map1(new $java.oncias_SemanticExpressionCheck$$$anonfun$check$20$lambda$_80_0));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_19 = function() {
        jl_Object.call(this);
        this.$_0554 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_19__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_19();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_19__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_19__init_0 = function(var$0, var$1) {
        var$0.$_0554 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_20 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_20__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_20();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_20__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_20__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21 = function() {
        jl_Object.call(this);
        this.$_0555 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21__init_0 = function(var$0, var$1) {
        var$0.$_0555 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0555;
        oncias_SemanticExpressionCheck$_$callClinit();
        return (var$1.$typ()).$covariant20();
    };
    $java.oncie_ASTCachedProperty = $rt_classWithoutFields(0);
    $java.oncie_CachedProperty = $rt_classWithoutFields($java.oncie_LogicalProperty);
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22 = function() {
        jl_Object.call(this);
        this.$_0556 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22__init_0 = function(var$0, var$1) {
        var$0.$_0556 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0556;
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23 = function() {
        jl_Object.call(this);
        this.$_0557 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23__init_0 = function(var$0, var$1) {
        var$0.$_0557 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    var$2 = var$0.$_0557;
                    oncias_SemanticExpressionCheck$_$callClinit();
                    oncius_package$_$callClinit();
                    var$3 = oncius_NodeType_invariant(oncius_package$_CTNode(oncius_package$_MODULE$));
                    if (var$3 !== null) {
                        if (!oncius_TypeSpec_equals(var$3, var$1))
                            break b;
                        else
                            break c;
                    }
                    if (var$1 !== null)
                        break b;
                }
                var$4 = 1;
                break a;
            }
            d: {
                e: {
                    var$3 = $java.oncius_RelationshipType_invariant(oncius_package$_CTRelationship(oncius_package$_MODULE$));
                    if (var$3 !== null) {
                        if (!oncius_TypeSpec_equals(var$3, var$1))
                            break d;
                        else
                            break e;
                    }
                    if (var$1 !== null)
                        break d;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return !var$4 ? $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_1, var$2)) : $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_0, var$2));
    };
    $java.oncie_CachedHasProperty = $rt_classWithoutFields($java.oncie_LogicalProperty);
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26 = function() {
        jl_Object.call(this);
        this.$_0558 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26__init_0 = function(var$0, var$1) {
        var$0.$_0558 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0558;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = oncias_SemanticState_ensureVariableDefined(var$1, var$2);
        if (var$3 instanceof su_Right) {
            var$1 = var$3.$value10;
            var$1 = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
        } else {
            if (!(var$3 instanceof su_Left))
                $rt_throw(s_MatchError__init_(var$3));
            var$3 = var$3.$value11;
            if (!var$1.$declareVariablesToSuppressDuplicateErrors)
                var$1 = oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, var$1, var$3);
            else {
                oncius_package$_$callClinit();
                var$2 = oncias_SemanticState_declareVariable(var$1, var$2, $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$)), s_None$_MODULE$, 0, 0);
                if (var$2 instanceof su_Right) {
                    var$1 = var$2.$value10;
                    var$1 = oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, var$1, var$3);
                } else {
                    if (!(var$2 instanceof su_Left))
                        $rt_throw(s_MatchError__init_(var$2));
                    var$2 = var$2.$value11;
                    var$1 = oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, var$1, var$2);
                }
            }
        }
        return var$1;
    };
    $java.oncie_GetDegree = $rt_classWithoutFields(oncie_Expression);
    var oncias_SemanticFunctionCheck$ = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$_MODULE$ = null;
    function oncias_SemanticFunctionCheck$__clinit_() {
        $java.oncias_SemanticFunctionCheck$_MODULE$ = new oncias_SemanticFunctionCheck$;
    }
    $java.oncias_SemanticFunctionCheck$_specifyType = function($this, $possibleTypes, $expression) {
        return oncias_SemanticAnalysisTooling_specifyType$0($this, $possibleTypes, $expression);
    };
    $java.oncias_SemanticFunctionCheck$_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncias_SemanticFunctionCheck$_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncias_SemanticFunctionCheck$_types = function($this, $expression) {
        return oncias_SemanticAnalysisTooling_types$($this, $expression);
    };
    $java.oncias_SemanticFunctionCheck$_check = function($this, $ctx, $invocation) {
        var var$3, var$4, var$5, var$6, var$7;
        var$3 = $invocation.$function0;
        if (!(var$3 instanceof $java.oncief_AggregatingFunction)) {
            $java.oncief_Reduce$_$callClinit();
            if (jl_Object_equals($java.oncief_Reduce$_MODULE$, var$3)) {
                var$3 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$3);
                jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(2492)), $rt_s(3106));
                return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$3), $invocation.$position7);
            }
            if (var$3 === null)
                $rt_throw(s_MatchError__init_(var$3));
            var$3 = oncias_SemanticCheck$_MODULE$;
            var$4 = $invocation.$distinct0;
            var$5 = new $java.oncias_SemanticFunctionCheck$$check$lambda$_40_1;
            var$5.$_0559 = $invocation;
            var$3 = oncias_SemanticCheck$_when(var$3, var$4, var$5);
            oncias_SemanticExpressionCheck$_$callClinit();
            return oncias_SemanticCheck_chain$(var$3.$chain($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx, $java.oncie_Expression_arguments($invocation))), $java.oncias_SemanticFunctionCheck$_semanticCheck($this, $ctx, $invocation));
        }
        a: {
            b: {
                c: {
                    var$3 = var$3;
                    var$5 = oncias_SemanticCheck$_MODULE$;
                    var$6 = $java.oncie_Expression$SemanticContext$Simple$_MODULE$;
                    if ($ctx !== null) {
                        if (!jl_Object_equals($ctx, var$6))
                            break b;
                        else
                            break c;
                    }
                    if (var$6 !== null)
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        var$6 = new $java.oncias_SemanticFunctionCheck$$check$lambda$_40_0;
        var$6.$_0560 = var$3;
        var$6.$_1176 = $invocation;
        var$7 = oncias_SemanticCheck$_when(var$5, var$4, var$6);
        var$3 = oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, sc_AbstractIterable_collectFirst($invocation.$args, new $java.oncias_SemanticFunctionCheck$$anonfun$checkNoNestedAggregateFunctions$1), new $java.oncias_SemanticFunctionCheck$$checkNoNestedAggregateFunctions$lambda$_41_0);
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$7.$chain(oncias_SemanticCheck_chain$(var$3.$chain($java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx, $java.oncie_Expression_arguments($invocation))), $java.oncias_SemanticFunctionCheck$_semanticCheck($this, $ctx, $invocation)));
    };
    $java.oncias_SemanticFunctionCheck$_semanticCheck = function($this, $ctx, $invocation) {
        var var$3, var$4, var$5;
        var$3 = 0;
        var$4 = $invocation.$function0;
        $java.oncief_Coalesce$_$callClinit();
        if (jl_Object_equals($java.oncief_Coalesce$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkMinArgs($this, $invocation, 1));
            oncius_package$_$callClinit();
            return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($ctx, oncias_SemanticAnalysisTooling_expectType$0($this, $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$)), $java.oncie_Expression_arguments($invocation))), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$($this, oncias_SemanticAnalysisTooling_unionOfTypes$($this, $java.oncie_Expression_arguments($invocation)), $invocation)));
        }
        $java.oncief_Collect$_$callClinit();
        if (jl_Object_equals($java.oncief_Collect$_MODULE$, var$4)) {
            $ctx = $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, $java.oncief_Collect$_MODULE$, $invocation);
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_0;
            var$5.$_0561 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_Exists$_$callClinit();
        if (jl_Object_equals($java.oncief_Exists$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 1));
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_1;
            var$5.$_0562 = $invocation;
            return oncias_SemanticCheck_chain$(oncias_SemanticCheck_ifOkChain$($ctx, var$5), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0($this, new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_2, $invocation)));
        }
        $java.oncief_Head$_$callClinit();
        if (jl_Object_equals($java.oncief_Head$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 1));
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_3;
            var$5.$_0563 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_Last$_$callClinit();
        if (jl_Object_equals($java.oncief_Last$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 1));
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_4;
            var$5.$_0564 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_Max$_$callClinit();
        if (jl_Object_equals($java.oncief_Max$_MODULE$, var$4)) {
            $ctx = $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, $java.oncief_Max$_MODULE$, $invocation);
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_5;
            var$5.$_0565 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_IsEmpty$_$callClinit();
        if (jl_Object_equals($java.oncief_IsEmpty$_MODULE$, var$4))
            return $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, $java.oncief_IsEmpty$_MODULE$, $invocation);
        $java.oncief_Min$_$callClinit();
        if (jl_Object_equals($java.oncief_Min$_MODULE$, var$4)) {
            $ctx = $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, $java.oncief_Min$_MODULE$, $invocation);
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_6;
            var$5.$_0566 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_PercentileCont$_$callClinit();
        if (jl_Object_equals($java.oncief_PercentileCont$_MODULE$, var$4)) {
            $ctx = $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, $java.oncief_PercentileCont$_MODULE$, $invocation);
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_7;
            var$5.$_0567 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_PercentileDisc$_$callClinit();
        if (jl_Object_equals($java.oncief_PercentileDisc$_MODULE$, var$4)) {
            $ctx = $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, $java.oncief_PercentileDisc$_MODULE$, $invocation);
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_8;
            var$5.$_0568 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_Point$_$callClinit();
        if (jl_Object_equals($java.oncief_Point$_MODULE$, var$4)) {
            $ctx = $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, $java.oncief_Point$_MODULE$, $invocation);
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_9;
            var$5.$_0569 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_Reverse$_$callClinit();
        if (jl_Object_equals($java.oncief_Reverse$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 1));
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_10;
            var$5.$_0570 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_Tail$_$callClinit();
        if (jl_Object_equals($java.oncief_Tail$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 1));
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_11;
            var$5.$_0571 = $invocation;
            return oncias_SemanticCheck_ifOkChain$($ctx, var$5);
        }
        $java.oncief_ToBoolean$_$callClinit();
        if (jl_Object_equals($java.oncief_ToBoolean$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 1));
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_12;
            var$5.$_0572 = $invocation;
            var$5 = oncias_SemanticCheck_ifOkChain$($ctx, var$5);
            $ctx = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_13;
            $ctx.$_0573 = $invocation;
            return oncias_SemanticCheck_ifOkChain$(var$5, $ctx);
        }
        $java.oncief_ToString$_$callClinit();
        if (jl_Object_equals($java.oncief_ToString$_MODULE$, var$4)) {
            $ctx = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 1));
            var$5 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_14;
            var$5.$_0574 = $invocation;
            return $java.oncias_SemanticCheck$FlatMap_ifOkChain(oncias_SemanticCheck_ifOkChain$($ctx, var$5), $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15__init_($invocation));
        }
        if (jl_Object_equals($java.oncief_UnresolvedFunction$_MODULE$, var$4)) {
            var$3 = 1;
            if (sci_List_isEmpty(oncie_Namespace_parts(oncie_FunctionInvocation_namespace($invocation)))) {
                var$5 = oncie_FunctionName_name(oncie_FunctionInvocation_functionName($invocation));
                $java.ju_Locale_$callClinit();
                var$5 = jl_String_toLowerCase0(var$5, $java.ju_Locale_ROOT);
                if (var$5 !== null && jl_String_equals(var$5, $rt_s(3107)))
                    return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3108), oncie_FunctionInvocation_position($invocation)));
            }
        }
        $java.oncief_Distance$_$callClinit();
        if (jl_Object_equals($java.oncief_Distance$_MODULE$, var$4))
            return $java.oncias_SemanticCheck$Leaf_ifOkChain($java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 2)), $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16__init_($invocation));
        $java.oncief_WithinBBox$_$callClinit();
        if (jl_Object_equals($java.oncief_WithinBBox$_MODULE$, var$4))
            return $java.oncias_SemanticCheck$Leaf_ifOkChain($java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkArgs($this, $invocation, 3)), $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17__init_($invocation));
        if (var$3)
            return $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
        if (var$4 !== null)
            return $java.oncias_SemanticFunctionCheck$_checkTypeSignatures($this, $ctx, var$4, $invocation);
        $rt_throw(s_MatchError__init_(var$4));
    };
    $java.oncias_SemanticFunctionCheck$_checkTypeSignatures = function($this, $ctx, $f, $invocation) {
        var var$4;
        $ctx = oncias_package$_MODULE$;
        var$4 = $java.oncief_Function_signatureLengths($f);
        sm_Ordering$Int$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticErrorDefOption($ctx, $java.oncias_SemanticFunctionCheck$_checkMinArgs($this, $invocation, sr_BoxesRunTime_unboxToInt(sc_AbstractIterable_min(var$4, sm_Ordering$Int$_MODULE$)))), $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticFunctionCheck$_checkMaxArgs($this, $invocation, sr_BoxesRunTime_unboxToInt(sc_AbstractIterable_max($java.oncief_Function_signatureLengths($f),
        sm_Ordering$Int$_MODULE$))))), oncias_SemanticAnalysisTooling_checkTypes$($this, $invocation, $f.$signatures2()));
    };
    $java.oncias_SemanticFunctionCheck$_checkArgs = function($this, $invocation, $n) {
        s_package$_$callClinit();
        $invocation = (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData(s_Option, [$java.oncias_SemanticFunctionCheck$_checkMinArgs($this, $invocation, $n), $java.oncias_SemanticFunctionCheck$_checkMaxArgs($this, $invocation, $n)])));
        s_Predef$_$callClinit();
        return ($invocation.$flatten(s_Predef$_$conforms(s_Predef$_MODULE$))).$headOption();
    };
    $java.oncias_SemanticFunctionCheck$_checkMaxArgs = function($this, $invocation, $n) {
        var var$3, var$4, var$5, var$6;
        if (($java.oncie_Expression_arguments($invocation)).$length() <= $n)
            return s_None$_MODULE$;
        var$3 = new s_Some;
        var$4 = new oncias_SemanticError;
        var$5 = $invocation.$function0.$name3();
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(3109)), var$5), 39);
        oncias_SemanticError__init_(var$4, jl_AbstractStringBuilder_toString(var$6), $invocation.$position7);
        s_Some__init_0(var$3, var$4);
        return var$3;
    };
    $java.oncias_SemanticFunctionCheck$_checkMinArgs = function($this, $invocation, $n) {
        var var$3, var$4, var$5, var$6;
        if (($java.oncie_Expression_arguments($invocation)).$length() >= $n)
            return s_None$_MODULE$;
        var$3 = new s_Some;
        var$4 = new oncias_SemanticError;
        var$5 = $invocation.$function0.$name3();
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(3110)), var$5), 39);
        oncias_SemanticError__init_(var$4, jl_AbstractStringBuilder_toString(var$6), $invocation.$position7);
        s_Some__init_0(var$3, var$4);
        return var$3;
    };
    $java.oncias_SemanticFunctionCheck$_checkPercentileRange = function($this, $expression) {
        var var$2, var$3, var$4, var$5;
        var$2 = 0;
        var$3 = null;
        if ($rt_isInstance($expression, $java.oncie_DoubleLiteral)) {
            var$2 = 1;
            var$3 = $expression;
            s_Predef$_$callClinit();
            if (sr_BoxesRunTime_unboxToDouble($java.oncie_DecimalDoubleLiteral_value(var$3)) >= 0.0 && sr_BoxesRunTime_unboxToDouble($java.oncie_DecimalDoubleLiteral_value(var$3)) <= 1.0)
                return oncias_SemanticCheck$_success;
        }
        if ($rt_isInstance($expression, $java.oncie_IntegerLiteral)) {
            var$4 = $expression;
            if (!(!sr_BoxesRunTime_equalsNumObject(var$4.$value26(), jl_Long_valueOf(Long_ZERO)) && !sr_BoxesRunTime_equalsNumObject(var$4.$value26(), jl_Long_valueOf(Long_fromInt(1)))))
                return oncias_SemanticCheck$_success;
        }
        if (var$2) {
            $expression = $java.oncie_DecimalDoubleLiteral_value(var$3);
            var$5 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$5);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(519)), $expression), $rt_s(3111));
            return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$5), var$3.$position250);
        }
        if (!$rt_isInstance($expression, oncie_Literal))
            return oncias_SemanticCheck$_success;
        $expression = $expression;
        var$3 = $expression.$asCanonicalStringVal();
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(519)), var$3), $rt_s(3111));
        return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$5), $expression.$position2());
    };
    $java.oncias_SemanticFunctionCheck$_withKey = function($this, $key, $kv) {
        var var$3;
        a: {
            b: {
                c: {
                    $kv = $kv.$_10.$name11;
                    if ($kv !== null) {
                        if (!jl_String_equals($kv, $key))
                            break b;
                        else
                            break c;
                    }
                    if ($key !== null)
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncias_SemanticFunctionCheck$_checkToSpecifiedTypeOfArgument = function($this, $invocation, $allowedTypes) {
        var var$3, var$4;
        var$3 = oncias_package$_MODULE$;
        var$4 = new $java.oncias_SemanticFunctionCheck$$checkToSpecifiedTypeOfArgument$lambda$_50_0;
        var$4.$_0575 = $invocation;
        var$4.$_1177 = $allowedTypes;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$3, var$4);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$)), $java.oncius_AnyType_invariant(oncius_package$_CTAny(oncius_package$_MODULE$)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncie_ImplicitProcedureArgument = $rt_classWithoutFields(oncie_Expression);
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29 = function() {
        jl_Object.call(this);
        this.$_0576 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29__init_0 = function(var$0, var$1) {
        var$0.$_0576 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0576;
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$1.$parameterType.$covariant20();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30 = function() {
        jl_Object.call(this);
        this.$_0577 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30__init_0 = function(var$0, var$1) {
        var$0.$_0577 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0577;
        oncias_SemanticExpressionCheck$_$callClinit();
        return (var$1.$parameterType0()).$covariant20();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32 = function() {
        jl_Object.call(this);
        this.$_0578 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32__init_0 = function(var$0, var$1) {
        var$0.$_0578 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0578;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncias_SemanticExpressionCheck$_checkLabelExpression(oncias_SemanticExpressionCheck$_MODULE$, s_None$_MODULE$, var$1.$labelExpression3);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    var oncias_SemanticExpressionCheck$FilteringExpressions$ = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$ = null;
    function oncias_SemanticExpressionCheck$FilteringExpressions$__clinit_() {
        $java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$ = new oncias_SemanticExpressionCheck$FilteringExpressions$;
    }
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$_semanticCheck = function($this, $ctx, $e) {
        var var$3, var$4, var$5;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = oncias_SemanticCheck_chain$(oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $ctx, $e.$expression1()), oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$FilteringExpressions$$semanticCheck$lambda$_1_0, $e.$expression1()));
        $ctx = $e.$innerPredicate();
        if (!($ctx instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, $ctx))
                $rt_throw(s_MatchError__init_($ctx));
            $ctx = oncias_SemanticCheck$_success;
        } else {
            $ctx = $ctx.$value5;
            var$4 = oncias_SemanticExpressionCheck$_MODULE$;
            var$5 = new $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkInnerPredicate$lambda$_5_0;
            var$5.$_0579 = $e;
            var$5.$_1178 = $ctx;
            $ctx = oncias_SemanticAnalysisTooling_withScopedState$(var$4, var$5);
        }
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$3, $ctx), $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$FilteringExpressions$_failIfAggregating($this, $e.$innerPredicate())));
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$_failIfAggregating = function($this, $expression) {
        return s_Option_flatMap($expression, new $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_2_0);
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$_failIfAggregating0 = function($this, $expression) {
        return s_Option_map($java.oncie_Expression_findAggregate($expression), new $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_3_0);
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$_checkPredicateDefined = function($this, $e) {
        var var$2, var$3, var$4;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = s_Option_isEmpty($e.$innerPredicate());
        var$4 = new $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkPredicateDefined$lambda$_4_0;
        var$4.$_0580 = $e;
        return oncias_SemanticCheck$_when(var$2, var$3, var$4);
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$_possibleInnerTypes = function($this, $e) {
        var var$2;
        var$2 = new $java.oncias_SemanticExpressionCheck$FilteringExpressions$$possibleInnerTypes$lambda$_6_0;
        var$2.$_0581 = $e;
        return var$2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40 = function() {
        jl_Object.call(this);
        this.$_0582 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40__init_0 = function(var$0, var$1) {
        var$0.$_0582 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0582;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_SemanticPatternCheck$_check1(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Match$_MODULE$, var$1.$pattern7), oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, var$1.$namedPath0, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_0)), oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$,
        var$1.$predicate2, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_1)), $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, var$1.$projection0));
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$2, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, var$1.$pattern7));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41 = function() {
        jl_Object.call(this);
        this.$_0583 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41__init_0 = function(var$0, var$1) {
        var$0.$_0583 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0583;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncius_TypeSpec_wrapInList($java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, var$2.$projection0), var$1));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTInteger(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return ($java.oncius_package$_CTPath0(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44 = function() {
        jl_Object.call(this);
        this.$_0584 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44__init_0 = function(var$0, var$1) {
        var$0.$_0584 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0584;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45 = function() {
        jl_Object.call(this);
        this.$_0585 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45__init_0 = function(var$0, var$1) {
        var$0.$_0585 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0585;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_46 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_46__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_46();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_46__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_46__init_0 = function(var$0) {};
    var oncias_SemanticPatternCheck$ = $rt_classWithoutFields();
    var oncias_SemanticPatternCheck$_MODULE$ = null;
    $java.oncias_SemanticPatternCheck$_stringifier = null;
    function oncias_SemanticPatternCheck$_$callClinit() {
        oncias_SemanticPatternCheck$_$callClinit = $rt_eraseClinit(oncias_SemanticPatternCheck$);
        $java.oncias_SemanticPatternCheck$__clinit_();
    }
    $java.oncias_SemanticPatternCheck$__clinit_ = function() {
        var var$1;
        var$1 = new oncias_SemanticPatternCheck$;
        oncias_SemanticPatternCheck$_$callClinit();
        oncias_SemanticPatternCheck$_MODULE$ = var$1;
        $java.oncias_SemanticPatternCheck$_stringifier = onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_ExpressionStringifier$_failingExtender, 0, 0, 0, 0);
    };
    $java.oncias_SemanticPatternCheck$_expectType = function($this, $possibleTypes, $expression) {
        return oncias_SemanticAnalysisTooling_expectType$1($this, $possibleTypes, $expression);
    };
    $java.oncias_SemanticPatternCheck$_expectType0 = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncias_SemanticPatternCheck$_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncias_SemanticPatternCheck$_withScopedStateWithVariablesFromRecordedScope = function($this, $astNode, $exclude, $check) {
        var var$4, var$5;
        oncias_SemanticAnalysisTooling$_$callClinit();
        var$4 = oncias_package$_MODULE$;
        var$5 = new oncias_SemanticAnalysisTooling$$org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScopeWithVariablesFromRecordedScope$lambda$_2_0;
        var$5.$_0283 = $astNode;
        var$5.$_185 = $exclude;
        var$4 = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5);
        $astNode = $check.$_0284;
        $exclude = $check.$_186;
        $check = $check.$_233;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$4, oncias_SemanticCheck_chain$((oncias_SemanticPatternCheck$_check(oncias_SemanticPatternCheck$_MODULE$, $astNode, $exclude)).$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $check.$optionalWhereExpression, new oncias_SemanticPatternCheck$$$anonfun$check$16$lambda$_97_0)), oncias_SemanticAnalysisTooling_recordCurrentScope$(oncias_SemanticPatternCheck$_MODULE$, $check))), oncias_SemanticAnalysisTooling$_org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$popStateScope(oncias_SemanticAnalysisTooling$_MODULE$));
    };
    $java.oncias_SemanticPatternCheck$_withScopedStateWithVariablesFromRecordedScope$default$2 = function($this) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    };
    $java.oncias_SemanticPatternCheck$_implicitVariable = function($this, $v, $possibleType) {
        var var$3;
        var$3 = new $java.oncias_SemanticAnalysisTooling$implicitVariable$lambda$_63_0;
        var$3.$_0586 = $v;
        var$3.$_1179 = $possibleType;
        return var$3;
    };
    $java.oncias_SemanticPatternCheck$_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncias_SemanticPatternCheck$_warn = function($this, $notification) {
        var var$2, var$3;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncias_SemanticCheck$$warn$lambda$_4_0;
        var$3.$_0587 = $notification;
        return $java.oncias_SemanticCheck$_fromFunction(var$2, var$3);
    };
    $java.oncias_SemanticPatternCheck$_check = function($this, $ctx, $pattern) {
        var var$3, var$4, var$5;
        var$3 = $pattern.$patternParts();
        var$4 = new $java.oncias_SemanticPatternCheck$$check$lambda$_40_0;
        var$4.$_0588 = $ctx;
        var$4 = oncias_SemanticAnalysisTooling_semanticCheckFold$($this, var$3, var$4);
        var$3 = $pattern.$patternParts();
        var$5 = new $java.oncias_SemanticPatternCheck$$check$lambda$_40_1;
        var$5.$_0589 = $ctx;
        var$4 = oncias_SemanticCheck_chain$(var$4.$chain(oncias_SemanticAnalysisTooling_semanticCheckFold$($this, var$3, var$5)), oncias_SemanticAnalysisTooling_semanticCheckFold$($this, $pattern.$patternParts(), new $java.oncias_SemanticPatternCheck$$check$lambda$_40_2));
        var$3 = new $java.oncias_SemanticPatternCheck$$check$lambda$_40_3;
        var$3.$_0590 = $ctx;
        var$3.$_1180 = $pattern;
        return oncias_SemanticCheck_ifOkChain$(var$4, var$3);
    };
    $java.oncias_SemanticPatternCheck$_check1 = function($this, $ctx, $pattern) {
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(($java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $pattern.$element5)).$chain($java.oncias_SemanticPatternCheck$_check0($this, $ctx, $pattern.$element5)), $java.oncias_SemanticPatternCheck$_ensureNoRepeatedRelationships($this, $pattern)), $java.oncias_SemanticPatternCheck$_ensureNoRepeatedVarLengthRelationships($this, $pattern));
    };
    $java.oncias_SemanticPatternCheck$_declareVariables = function($this, $ctx, $part) {
        var $n, var$4;
        while ($part instanceof oncie_PatternPartWithSelector) {
            $part = $part.$part;
        }
        if ($part instanceof oncie_NamedPatternPart) {
            $part = $part;
            $n = $java.oncias_SemanticPatternCheck$_declareVariables($this, $ctx, $part.$patternPart);
            var$4 = oncias_package$_MODULE$;
            $part = $part.$variable10;
            oncius_package$_$callClinit();
            return $n.$chain($java.oncias_package$_liftSemanticEitherFunc(var$4, oncias_SemanticAnalysisTooling_declareVariable$($this, $part, ($java.oncius_package$_CTPath0(oncius_package$_MODULE$)).$invariant())));
        }
        if (!($part instanceof oncie_PathPatternPart)) {
            if (!($part instanceof oncie_ShortestPathsPatternPart))
                $rt_throw(s_MatchError__init_($part));
            return $java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $part.$element3);
        }
        $part = $part;
        $n = s_Tuple2__init_($part.$element2, $ctx);
        var$4 = $n.$_20;
        if ($n.$_10 instanceof oncie_NodePattern && jl_Object_equals($java.oncie_Pattern$SemanticContext$Match$_MODULE$, var$4))
            return $java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $part.$element2);
        $n = $n.$_10;
        if (!($n instanceof oncie_NodePattern))
            return $java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $part.$element2);
        $part = $n;
        return (oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $part.$variable11, new $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_42_0)).$chain($java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $part));
    };
    function oncias_SemanticPatternCheck$_check($this, $ctx, $part) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        while (!($part instanceof oncie_PatternPartWithSelector)) {
            if (!($part instanceof oncie_NamedPatternPart)) {
                if ($part instanceof oncie_PathPatternPart)
                    return $java.oncias_SemanticPatternCheck$_check0($this, $ctx, $part.$element2);
                if (!($part instanceof oncie_ShortestPathsPatternPart))
                    $rt_throw(s_MatchError__init_($part));
                a: {
                    $part = $part;
                    var$3 = $part.$name13;
                    var$4 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$4);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$4, var$3), $rt_s(3112));
                    var$5 = $java.oncias_SemanticPatternCheck$_checkContext($this, $ctx, jl_AbstractStringBuilder_toString(var$4), $part.$position42);
                    var$3 = oncias_package$_MODULE$;
                    var$6 = onciu_Foldable_folder$($part.$element3);
                    var$4 = new $java.oncias_SemanticPatternCheck$$anonfun$checkNoQuantifiedPatterns$1$1;
                    var$4.$x5$1 = $part;
                    var$7 = oncias_SemanticCheck_chain$(var$5, $java.oncias_package$_liftSemanticErrorDefs(var$3, onciu_Foldable$Folder_treeCollect(var$6, var$4)));
                    var$3 = $part.$element3;
                    if (var$3 instanceof oncie_RelationshipChain) {
                        var$3 = var$3;
                        var$6 = var$3.$relationship1;
                        if (var$3.$element4 instanceof oncie_NodePattern && var$3.$rightNode !== null) {
                            var$3 = oncias_package$_MODULE$;
                            var$6 = var$6.$properties5;
                            var$4 = new $java.oncias_SemanticPatternCheck$$checkContainsSingle$1$lambda$_83_0;
                            var$4.$_0591 = $part;
                            var$3 = $java.oncias_package$_liftSemanticErrorDefOption(var$3, s_Option_map(var$6, var$4));
                            break a;
                        }
                    }
                    var$3 = oncias_package$_MODULE$;
                    var$4 = new oncias_SemanticError;
                    var$5 = $part.$name13;
                    var$6 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$6);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$6, var$5), $rt_s(3113));
                    oncias_SemanticError__init_(var$4, jl_AbstractStringBuilder_toString(var$6), $part.$position42);
                    var$3 = oncias_package$_liftSemanticErrorDef(var$3, var$4);
                }
                b: {
                    var$5 = oncias_SemanticCheck_chain$(var$7, var$3);
                    var$4 = s_Tuple2__init_($ctx, $part.$element3);
                    var$3 = var$4.$_10;
                    if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Match$_MODULE$, var$3))
                        var$3 = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
                    else {
                        var$3 = var$4.$_20;
                        if (var$3 instanceof oncie_RelationshipChain) {
                            var$4 = var$3;
                            var$3 = var$4.$element4;
                            var$4 = var$4.$rightNode;
                            if (var$3 instanceof oncie_NodePattern) {
                                var$3 = var$3;
                                if (var$4 !== null) {
                                    if (s_Option_isEmpty(var$3.$variable11)) {
                                        var$6 = oncias_package$_MODULE$;
                                        var$8 = new oncias_SemanticError;
                                        var$3 = $part.$name13;
                                        var$4 = new jl_StringBuilder;
                                        jl_AbstractStringBuilder__init_(var$4);
                                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3114)), var$3), $rt_s(3115));
                                        oncias_SemanticError__init_(var$8, jl_AbstractStringBuilder_toString(var$4), $part.$position42);
                                        var$3 = oncias_package$_liftSemanticErrorDef(var$6, var$8);
                                        break b;
                                    }
                                    if (!s_Option_isEmpty(var$4.$variable11)) {
                                        var$3 = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
                                        break b;
                                    }
                                    var$8 = oncias_package$_MODULE$;
                                    var$7 = new oncias_SemanticError;
                                    var$6 = $part.$name13;
                                    var$3 = new jl_StringBuilder;
                                    jl_AbstractStringBuilder__init_(var$3);
                                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(3114)), var$6), $rt_s(3115));
                                    oncias_SemanticError__init_(var$7, jl_AbstractStringBuilder_toString(var$3), $part.$position42);
                                    var$3 = oncias_package$_liftSemanticErrorDef(var$8, var$7);
                                    break b;
                                }
                            }
                        }
                        var$3 = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
                    }
                }
                var$6 = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$5, var$3), $java.oncias_SemanticPatternCheck$_checkLength$1($this, $part));
                var$3 = oncias_package$_MODULE$;
                var$4 = new $java.oncias_SemanticPatternCheck$$checkRelVariablesUnknown$1$lambda$_88_0;
                var$4.$_0592 = $part;
                return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$6, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$3, var$4)), $java.oncias_SemanticPatternCheck$_check0($this, $ctx, $part.$element3));
            }
            $part = $part.$patternPart;
        }
        c: {
            $part = $part;
            var$3 = oncias_SemanticPatternCheck$_check($this, $ctx, $part.$part);
            var$4 = oncias_SemanticCheck$_MODULE$;
            var$9 = $java.oncie_PatternPartWithSelector_isSelective($part);
            var$6 = new $java.oncias_SemanticPatternCheck$$check$lambda$_43_0;
            var$6.$_0593 = $ctx;
            var$6.$_1181 = $part;
            $ctx = var$3.$chain(oncias_SemanticCheck$_when(var$4, var$9, var$6));
            var$4 = $part.$selector;
            if (var$4 instanceof oncie_PatternPart$ShortestGroups) {
                var$3 = var$4.$count4;
                s_Predef$_$callClinit();
                if (Long_le(sr_BoxesRunTime_unboxToLong($java.oncie_DecimalIntegerLiteral_value(var$3)), Long_ZERO)) {
                    $part = oncias_SemanticAnalysisTooling_error$($this, $rt_s(3116), var$3.$position61);
                    break c;
                }
            }
            if ($rt_isInstance(var$4, $java.oncie_PatternPart$CountedSelector)) {
                $part = var$4;
                s_Predef$_$callClinit();
                if (Long_le(sr_BoxesRunTime_unboxToLong($java.oncie_DecimalIntegerLiteral_value($part.$count5())), Long_ZERO)) {
                    $part = oncias_SemanticAnalysisTooling_error$($this, $rt_s(3117), ($part.$count5()).$position61);
                    break c;
                }
            }
            $part = oncias_SemanticCheck$_success;
        }
        return oncias_SemanticCheck_chain$($ctx, $part);
    }
    $java.oncias_SemanticPatternCheck$_checkContext = function($this, $ctx, $name, $pos) {
        var var$4, var$5, var$6;
        if (!(jl_Object_equals($java.oncie_Pattern$SemanticContext$Merge$_MODULE$, $ctx) ? 1 : !jl_Object_equals($java.oncie_Pattern$SemanticContext$Create$_MODULE$, $ctx) ? 0 : 1))
            return oncias_SemanticCheck$_success;
        var$4 = oncias_package$_MODULE$;
        var$5 = new oncias_SemanticError;
        $ctx = $ctx.$description();
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $name), $rt_s(3118)), $ctx), $rt_s(3119));
        oncias_SemanticError__init_(var$5, jl_AbstractStringBuilder_toString(var$6), $pos);
        return oncias_package$_liftSemanticErrorDef(var$4, var$5);
    };
    $java.oncias_SemanticPatternCheck$_stringifier0 = function($this) {
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncias_SemanticPatternCheck$_stringifier;
    };
    $java.oncias_SemanticPatternCheck$_check0 = function($this, $ctx, $element) {
        var var$3, $variable, $factors, $pattern, $quantifier, $patternPart, $where, var$10, var$11, var$12, var$13;
        var$3 = 0;
        $variable = null;
        if (!($element instanceof oncie_RelationshipChain)) {
            if ($element instanceof oncie_NodePattern) {
                $element = $element;
                return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticPatternCheck$_checkNodeProperties($this, $ctx, $java.oncie_NodePattern_properties($element)), $java.oncias_SemanticPatternCheck$_checkLabelExpressions($this, $ctx, $java.oncie_NodePattern_labelExpression($element))), $java.oncias_SemanticPatternCheck$_checkIsKeyword($this, $ctx, $java.oncie_NodePattern_labelExpression($element))), $java.oncias_SemanticPatternCheck$_checkPredicate($this,
                $ctx, $element));
            }
            if ($element instanceof oncie_PathConcatenation) {
                $factors = $java.oncie_PathConcatenation_factors($element);
                return (sc_AbstractIterable_reduce($factors.$map1($java.oncias_SemanticPatternCheck$$check$lambda$_48_0__init_($ctx)), $java.oncias_SemanticPatternCheck$$check$lambda$_48_1__init_())).$chain($java.oncias_SemanticPatternCheck$_checkValidJuxtaposition($this, $factors));
            }
            if ($element instanceof oncie_QuantifiedPath) {
                $variable = $element;
                $pattern = $java.oncie_QuantifiedPath_part($variable);
                $quantifier = $java.oncie_QuantifiedPath_quantifier($variable);
                return $java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$FlatMap_chain($java.oncias_SemanticCheck$Leaf_chain($java.oncias_SemanticPatternCheck$_checkContext($this, $ctx, $rt_s(3120), $element.$position2()), $java.oncias_SemanticPatternCheck$_checkContainedPatterns$1($pattern)), $java.oncias_SemanticPatternCheck$_checkRelCount$1($pattern, $variable)), $java.oncias_SemanticPatternCheck$_checkQuantifier($this, $quantifier)), $java.oncias_SemanticPatternCheck$_withScopedStateWithVariablesFromRecordedScope($this,
                $variable, $java.oncias_SemanticPatternCheck$_withScopedStateWithVariablesFromRecordedScope$default$2($this), $java.oncias_SemanticPatternCheck$$check$lambda$_48_2__init_($ctx, $pattern, $variable)));
            }
            if ($element instanceof oncie_ParenthesizedPath) {
                var$3 = 1;
                $variable = $element;
                $patternPart = $java.oncie_ParenthesizedPath_part($variable);
                if ($patternPart instanceof oncie_NamedPatternPart)
                    return $java.oncias_SemanticPatternCheck$_error($this, $rt_s(3121), $java.oncie_Variable_position($java.oncie_NamedPatternPart_variable($patternPart)));
            }
            if (!var$3)
                $rt_throw(s_MatchError__init_($element));
            $patternPart = $java.oncie_ParenthesizedPath_part($variable);
            $where = $java.oncie_ParenthesizedPath_optionalWhereClause($variable);
            return $java.oncias_SemanticCheck$FlatMap_chain((oncias_SemanticPatternCheck$_check($this, $ctx, $patternPart)).$chain($java.oncias_SemanticPatternCheck$_checkContainedPatterns$2($patternPart)), oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, $where, $java.oncias_SemanticPatternCheck$$check$lambda$_48_3__init_()));
        }
        $element = $element;
        $variable = $java.oncias_SemanticPatternCheck$_check0($this, $ctx, $element.$element4);
        var$10 = $element.$relationship1;
        $patternPart = onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_ExpressionStringifier$_failingExtender, 0, 0, 0, 0);
        $where = oncias_SemanticCheck$_MODULE$;
        var$3 = s_Option_isEmpty(var$10.$length2) ? 0 : 1;
        $pattern = new $java.oncias_SemanticPatternCheck$$checkNoVarLengthWhenUpdating$1$lambda$_104_0;
        $pattern.$_0594 = $ctx;
        $pattern.$_1182 = var$10;
        var$11 = oncias_SemanticCheck$_when($where, var$3, $pattern);
        $factors = var$10.$variable12;
        $quantifier = var$10.$labelExpression2;
        var$12 = var$10.$length2;
        $pattern = var$10.$properties5;
        var$13 = var$10.$predicate1;
        if (jl_Object_equals(s_None$_MODULE$, var$12) && jl_Object_equals(s_None$_MODULE$, $pattern) && jl_Object_equals(s_None$_MODULE$, var$13) && !s_Option_exists($factors, new $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_0) && s_Option_forall($quantifier, new $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_1))
            $where = s_None$_MODULE$;
        else {
            $where = var$10.$labelExpression2;
            $where = !($where instanceof s_Some) ? s_None$_MODULE$ : s_Some__init_($where.$value5);
        }
        a: {
            $pattern = s_Option_flatMap($where, new $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_2);
            $quantifier = oncias_OptionSemanticChecking$_MODULE$;
            $factors = new $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_3;
            $factors.$_0595 = $patternPart;
            $factors.$_1183 = $where;
            $where = var$11.$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension($quantifier, $pattern, $factors));
            $pattern = var$10.$labelExpression2;
            $quantifier = var$10.$length2;
            if ($pattern instanceof s_Some) {
                $factors = $pattern.$value5;
                if ($quantifier instanceof s_Some && $factors.$containsGpmSpecificRelTypeExpression()) {
                    $pattern = sc_StringOps$_MODULE$;
                    s_Predef$_$callClinit();
                    $pattern = oncias_SemanticAnalysisTooling_error$($this, sc_StringOps$_stripMargin$extension($pattern, $rt_s(3122)), $factors.$position2());
                    break a;
                }
            }
            $pattern = oncias_SemanticCheck$_success;
        }
        $factors = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($where, $pattern), $java.oncias_checkNoParamMapsWhenMatching$_apply($java.oncias_checkNoParamMapsWhenMatching$_MODULE$, var$10.$properties5, $ctx));
        oncias_SemanticExpressionCheck$_$callClinit();
        $pattern = $java.oncias_SemanticExpressionCheck$_simple1(oncias_SemanticExpressionCheck$_MODULE$, var$10.$properties5);
        oncius_package$_$callClinit();
        $factors = oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($factors, $pattern.$chain(oncias_SemanticAnalysisTooling_expectType$($this, $java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$)), var$10.$properties5))), $java.oncias_checkValidPropertyKeyNamesInPattern$_apply($java.oncias_checkValidPropertyKeyNamesInPattern$_MODULE$, var$10.$properties5));
        $quantifier = var$10.$labelExpression2;
        $where = oncias_OptionSemanticChecking$_MODULE$;
        $pattern = new $java.oncias_SemanticPatternCheck$$checkLabelExpressions$1$lambda$_116_0;
        $pattern.$_0596 = $ctx;
        $pattern.$_1184 = $patternPart;
        $quantifier = oncias_SemanticCheck_chain$($factors, oncias_OptionSemanticChecking$_foldSemanticCheck$extension($where, $quantifier, $pattern));
        $patternPart = oncias_OptionSemanticChecking$_MODULE$;
        $pattern = var$10.$predicate1;
        $where = new $java.oncias_SemanticPatternCheck$$checkPredicate$1$lambda$_122_0;
        $where.$_0597 = $ctx;
        $where.$_1185 = var$10;
        return $java.oncias_SemanticCheck$FlatMap_chain(oncias_SemanticCheck_chain$($variable.$chain(oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($quantifier, oncias_OptionSemanticChecking$_foldSemanticCheck$extension($patternPart, $pattern, $where)), $java.oncias_SemanticPatternCheck$_checkNotUndirectedWhenCreating$1($this, $ctx, var$10))), $java.oncias_SemanticPatternCheck$_check0($this, $ctx, $element.$rightNode)), $java.oncias_SemanticPatternCheck$_checkIsKeyword($this, $ctx, $element.$relationship1.$labelExpression2));
    };
    $java.oncias_SemanticPatternCheck$_getTypeString = function($this, $factor) {
        if ($factor instanceof oncie_ParenthesizedPath)
            return $rt_s(3123);
        if ($factor instanceof oncie_QuantifiedPath)
            return $rt_s(3124);
        if ($factor instanceof oncie_RelationshipChain)
            return $rt_s(3125);
        if ($factor instanceof oncie_NodePattern)
            return $rt_s(3126);
        $rt_throw(s_MatchError__init_($factor));
    };
    $java.oncias_SemanticPatternCheck$_checkValidJuxtaposition = function($this, $factors) {
        return (sc_Iterator_map$(sc_AbstractIterable_sliding($factors, 2), new $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_0)).$reduceLeft(new $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_1);
    };
    $java.oncias_SemanticPatternCheck$_checkQuantifier = function($this, $quantifier) {
        var var$2, var$3, $upper, var$5, $lower;
        var$2 = 0;
        var$3 = null;
        if ($quantifier instanceof oncie_FixedQuantifier) {
            $upper = $quantifier.$value15;
            if ($upper instanceof oncie_UnsignedDecimalIntegerLiteral && jl_String_equals($rt_s(14), $upper.$stringVal))
                return oncias_SemanticAnalysisTooling_error$($this, $rt_s(3127), $quantifier.$position2());
        }
        if ($quantifier instanceof oncie_IntervalQuantifier) {
            var$2 = 1;
            var$3 = $quantifier;
            $upper = var$3.$lower0;
            var$5 = var$3.$upper0;
            if ($upper instanceof s_Some) {
                $lower = $upper.$value5;
                if (var$5 instanceof s_Some) {
                    $upper = var$5.$value5;
                    s_Predef$_$callClinit();
                    if (Long_lt(sr_BoxesRunTime_unboxToLong($java.oncie_DecimalIntegerLiteral_value($upper)), sr_BoxesRunTime_unboxToLong($java.oncie_DecimalIntegerLiteral_value($lower)))) {
                        var$5 = sc_StringOps$_MODULE$;
                        var$3 = $java.oncie_DecimalIntegerLiteral_value($lower);
                        $upper = $java.oncie_DecimalIntegerLiteral_value($upper);
                        $lower = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($lower);
                        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($lower, $rt_s(3128)), var$3), $rt_s(3129)), $upper), 46);
                        return oncias_SemanticAnalysisTooling_error$($this, sc_StringOps$_stripMargin$extension(var$5, jl_AbstractStringBuilder_toString($lower)), $quantifier.$position2());
                    }
                }
            }
        }
        if (var$2) {
            $upper = var$3.$upper0;
            if ($upper instanceof s_Some) {
                $upper = $upper.$value5;
                if ($upper instanceof oncie_UnsignedDecimalIntegerLiteral && jl_String_equals($rt_s(14), $upper.$stringVal))
                    return oncias_SemanticAnalysisTooling_error$($this, $rt_s(3127), $quantifier.$position2());
            }
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticPatternCheck$_legacyRelationshipDisjunctionError = function($this, $sanitizedLabelExpression, $containsIs, $isNode) {
        var $isOrColon, var$5, var$6;
        $isOrColon = !$containsIs ? $rt_s(136) : $rt_s(1073);
        if (!$isNode) {
            var$5 = sc_StringOps$_MODULE$;
            s_Predef$_$callClinit();
            var$6 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$6);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(3130)), $isOrColon), $sanitizedLabelExpression), $rt_s(3131));
            return sc_StringOps$_stripMargin$extension(var$5, jl_AbstractStringBuilder_toString(var$6));
        }
        var$5 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(3132)), $isOrColon), $sanitizedLabelExpression), $rt_s(3133));
        return sc_StringOps$_stripMargin$extension(var$5, jl_AbstractStringBuilder_toString(var$6));
    };
    $java.oncias_SemanticPatternCheck$_declareVariables0 = function($this, $ctx, $element) {
        var $pattern, var$4, $entityBindings, $factors, $pattern_0;
        if ($element instanceof oncie_RelationshipChain) {
            $element = $element;
            $pattern = $java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $element.$element4);
            var$4 = $element.$relationship1;
            $entityBindings = oncias_OptionSemanticChecking$_MODULE$;
            $factors = var$4.$variable12;
            $pattern_0 = new $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_59_0;
            $pattern_0.$_0598 = var$4;
            $pattern_0.$_1186 = $ctx;
            return oncias_SemanticCheck_chain$($pattern.$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension($entityBindings, $factors, $pattern_0)), $java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $element.$rightNode));
        }
        if ($element instanceof oncie_NodePattern) {
            $element = $element;
            $pattern = oncias_OptionSemanticChecking$_MODULE$;
            $entityBindings = $element.$variable11;
            $element = new $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_0;
            $element.$_0599 = $ctx;
            return oncias_OptionSemanticChecking$_foldSemanticCheck$extension($pattern, $entityBindings, $element);
        }
        if ($element instanceof oncie_PathConcatenation) {
            $factors = $element.$factors;
            $element = new $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_1;
            $element.$_0600 = $ctx;
            return ($factors.$map1($element)).$reduceLeft(new $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_2);
        }
        if ($element instanceof oncie_QuantifiedPath) {
            $element = $element;
            $pattern_0 = $element.$part1;
            $entityBindings = $element.$variableGroupings;
            $pattern = new $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_3;
            $pattern.$_0601 = $ctx;
            $pattern.$_1187 = $pattern_0;
            $pattern.$_262 = $entityBindings;
            $pattern.$_314 = $element;
            return oncias_SemanticCheck_chain$(oncias_SemanticAnalysisTooling_withScopedState$($this, $pattern), $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, $entityBindings, new $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_4));
        }
        if (!($element instanceof oncie_ParenthesizedPath))
            $rt_throw(s_MatchError__init_($element));
        $pattern = $element.$part0;
        $ctx = $java.oncias_SemanticPatternCheck$_declareVariables0($this, $ctx, $pattern.$element());
        if (!($pattern instanceof oncie_NamedPatternPart))
            $element = oncias_SemanticCheck$_success;
        else {
            $element = $pattern;
            $pattern = oncias_package$_MODULE$;
            $entityBindings = $element.$variable10;
            oncius_package$_$callClinit();
            $element = $java.oncias_package$_liftSemanticEitherFunc($pattern, $java.oncias_SemanticPatternCheck$_implicitVariable($this, $entityBindings, $java.oncius_package$_CTPath0(oncius_package$_MODULE$)));
        }
        return $ctx.$chain($element);
    };
    $java.oncias_SemanticPatternCheck$_ensureNoRepeatedRelationships = function($this, $astNode) {
        var $patternStringifier, $expressionStringifier, $pattern;
        $patternStringifier = onciap_ExpressionStringifier$_failingExtender;
        $expressionStringifier = onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, $patternStringifier, 0, 0, 1, 0);
        $patternStringifier = onciap_PatternStringifier$_apply(onciap_PatternStringifier$_MODULE$, $expressionStringifier);
        if ($rt_isInstance($astNode, $java.oncie_Pattern))
            $pattern = onciap_DefaultPatternStringifier_apply1($patternStringifier, $astNode);
        else {
            if (!($astNode instanceof oncie_RelationshipsPattern)) {
                $expressionStringifier = new jl_IllegalArgumentException;
                $astNode = jl_Object_getClass($astNode);
                $patternStringifier = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($patternStringifier);
                jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($patternStringifier, $rt_s(3134)), $astNode), 46);
                jl_Throwable__init_($expressionStringifier, jl_AbstractStringBuilder_toString($patternStringifier));
                $rt_throw($expressionStringifier);
            }
            $pattern = onciap_DefaultPatternStringifier_apply($patternStringifier, $astNode.$element5);
        }
        $expressionStringifier = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        $astNode = $java.oncias_SemanticPatternCheck$_findRepeatedRelationships($this, $astNode, 0);
        $patternStringifier = new $java.oncias_SemanticPatternCheck$$ensureNoRepeatedRelationships$lambda$_61_0;
        $patternStringifier.$_0602 = $pattern;
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($expressionStringifier, $astNode, $patternStringifier);
    };
    $java.oncias_SemanticPatternCheck$_ensureNoRepeatedVarLengthRelationships = function($this, $astNode) {
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, $java.oncias_SemanticPatternCheck$_findRepeatedRelationships($this, $astNode, 1), new $java.oncias_SemanticPatternCheck$$ensureNoRepeatedVarLengthRelationships$lambda$_62_0);
    };
    $java.oncias_SemanticPatternCheck$_findRepeatedRelationships = function($this, $treeNode, $varLength) {
        var $relVariables, $repetitions;
        $relVariables = $treeNode.$folder();
        s_Predef$_$callClinit();
        $treeNode = sci_AbstractMap_withDefaultValue(sci_Map$_from(s_Predef$_Map(s_Predef$_MODULE$), sci_Nil$_MODULE$), sci_Nil$_MODULE$);
        $repetitions = new $java.oncias_SemanticPatternCheck$$anonfun$2;
        $repetitions.$varLength$1 = $varLength;
        return ((sc_AbstractIterable_filter(sc_AbstractMap_values(onciu_Foldable$Folder_fold($relVariables, $treeNode, $repetitions)), new $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_0)).$map1(new $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_1)).$toSeq();
    };
    $java.oncias_SemanticPatternCheck$_checkNodeProperties = function($this, $ctx, $properties) {
        var var$3;
        var$3 = oncias_SemanticCheck_chain$($java.oncias_checkNoParamMapsWhenMatching$_apply($java.oncias_checkNoParamMapsWhenMatching$_MODULE$, $properties, $ctx), $java.oncias_checkValidPropertyKeyNamesInPattern$_apply($java.oncias_checkValidPropertyKeyNamesInPattern$_MODULE$, $properties));
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = oncias_SemanticCheck_chain$(var$3, $java.oncias_SemanticExpressionCheck$_simple1(oncias_SemanticExpressionCheck$_MODULE$, $properties));
        oncius_package$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, oncias_SemanticAnalysisTooling_expectType$($this, $java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$)), $properties));
    };
    $java.oncias_SemanticPatternCheck$_checkPredicate = function($this, $ctx, $pattern) {
        var var$3, var$4;
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = $pattern.$predicate0;
        $pattern = new $java.oncias_SemanticPatternCheck$$checkPredicate$lambda$_65_0;
        $pattern.$_0603 = $ctx;
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, var$4, $pattern);
    };
    $java.oncias_SemanticPatternCheck$_checkLabelExpressions = function($this, $ctx, $labelExpression) {
        var var$3, var$4;
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = new $java.oncias_SemanticPatternCheck$$checkLabelExpressions$lambda$_66_0;
        var$4.$_0604 = $ctx;
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, $labelExpression, var$4);
    };
    $java.oncias_SemanticPatternCheck$_checkIsKeyword = function($this, $ctx, $labelExpression) {
        var var$3, var$4;
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = new $java.oncias_SemanticPatternCheck$$checkIsKeyword$lambda$_67_0;
        var$4.$_0605 = $ctx;
        return oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, $labelExpression, var$4);
    };
    $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNamesInReturnItems = function($this, $returnItems) {
        $returnItems = $returnItems.$items.$collect0(new $java.oncias_SemanticPatternCheck$$anonfun$3);
        s_Predef$_$callClinit();
        return $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNames($this, $returnItems.$flatten(s_Predef$_$conforms(s_Predef$_MODULE$)));
    };
    $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNames = function($this, $propertyKeys) {
        var $error;
        $error = $propertyKeys.$collectFirst(new $java.oncias_SemanticPatternCheck$$anonfun$4);
        if (!s_Option_isDefined($error))
            return $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0(($error.$get0()).$_10, ($error.$get0()).$_20));
    };
    $java.oncias_SemanticPatternCheck$_checkValidLabels = function($this, $labelNames, $pos) {
        var var$3, var$4;
        var$3 = oncias_package$_MODULE$;
        $labelNames = (sc_AbstractIterable_flatMap($labelNames.$view1(), new $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_0)).$headOption();
        var$4 = new $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_1;
        var$4.$_0606 = $pos;
        return $java.oncias_package$_liftSemanticErrorDefOption(var$3, s_Option_map($labelNames, var$4));
    };
    $java.oncias_SemanticPatternCheck$_org$neo4j$cypher$internal$ast$semantics$SemanticPatternCheck$$checkValidTokenName = function($this, $name) {
        var var$2, var$3, var$4;
        if ($name !== null && !jl_String_isEmpty($name) && !jl_String_contains($name, $rt_s(3135)))
            return s_None$_MODULE$;
        var$2 = new s_Some;
        var$3 = $rt_createArray(jl_Object, 1);
        if ($name === null)
            $name = $rt_s(126);
        else {
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$4);
            jl_AbstractStringBuilder_append(var$4, 39);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$4, $name), 39);
            $name = jl_AbstractStringBuilder_toString(var$4);
        }
        var$3.data[0] = $name;
        s_Some__init_0(var$2, jl_String_format($rt_s(3136), var$3));
        return var$2;
    };
    $java.oncias_SemanticPatternCheck$_checkLength$1 = function($this, $x5$1) {
        var $rel, var$3, $expressionStringifier, $min, $pattern;
        $rel = $x5$1.$element3;
        if (!($rel instanceof oncie_RelationshipChain))
            return oncias_SemanticCheck$_success;
        $rel = $rel.$relationship1;
        var$3 = 0;
        $expressionStringifier = null;
        $rel = $rel.$length2;
        if ($rel instanceof s_Some) {
            var$3 = 1;
            $expressionStringifier = $rel;
            $rel = $expressionStringifier.$value5;
            if ($rel instanceof s_Some) {
                $rel = $rel.$value5;
                if ($rel !== null) {
                    $rel = $rel.$lower;
                    if ($rel instanceof s_Some) {
                        $min = $rel.$value5;
                        s_Predef$_$callClinit();
                        if (!(Long_ge(sr_BoxesRunTime_unboxToLong($java.oncie_DecimalIntegerLiteral_value($min)), Long_ZERO) && Long_le(sr_BoxesRunTime_unboxToLong($java.oncie_DecimalIntegerLiteral_value($min)), Long_fromInt(1)))) {
                            $rel = $x5$1.$name13;
                            $x5$1 = new jl_StringBuilder;
                            jl_AbstractStringBuilder__init_($x5$1);
                            jl_StringBuilder_append(jl_StringBuilder_append($x5$1, $rel), $rt_s(3137));
                            return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString($x5$1), $min.$position61);
                        }
                    }
                }
            }
        }
        if (var$3) {
            $rel = $expressionStringifier.$value5;
            if (jl_Object_equals(s_None$_MODULE$, $rel)) {
                $expressionStringifier = onciap_ExpressionStringifier$_failingExtender;
                $expressionStringifier = onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, $expressionStringifier, 0, 0, 1, 0);
                $pattern = onciap_DefaultPatternStringifier_apply2(onciap_PatternStringifier$_apply(onciap_PatternStringifier$_MODULE$, $expressionStringifier), $x5$1.$element3);
                $rel = new $java.onciu_UnboundedShortestPathNotification;
                $rel.$position295 = $x5$1.$element3.$position2();
                $rel.$pattern12 = $pattern;
                return $java.oncias_SemanticPatternCheck$_warn($this, $rel);
            }
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticPatternCheck$_checkContainedPatterns$1 = function($pattern$2) {
        oncias_SemanticPatternCheck$_$callClinit();
        return onciu_Foldable$Folder_treeFold(onciu_Foldable_folder$($pattern$2), oncias_SemanticCheck$_success, new $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1);
    };
    $java.oncias_SemanticPatternCheck$_checkRelCount$1 = function($pattern$2, $x5$2) {
        var var$3, var$4, var$5, var$6;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = onciu_Foldable_folder$($pattern$2);
        sr_ClassTag$_$callClinit();
        var$5 = s_Option_isEmpty(onciu_Foldable$Folder_treeFindByClass(var$4, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_RelationshipPattern))));
        var$6 = new $java.oncias_SemanticPatternCheck$$checkRelCount$1$lambda$_95_0;
        var$6.$_0607 = $x5$2;
        var$6.$_1188 = $pattern$2;
        return oncias_SemanticCheck$_when(var$3, var$5, var$6);
    };
    $java.oncias_SemanticPatternCheck$_checkContainedPatterns$2 = function($patternPart$1) {
        var var$2, var$3, var$4, var$5;
        oncias_SemanticPatternCheck$_$callClinit();
        if (!($patternPart$1 instanceof oncie_ShortestPathsPatternPart))
            return oncias_SemanticCheck$_success;
        var$2 = $patternPart$1;
        var$3 = oncias_package$_MODULE$;
        $patternPart$1 = new oncias_SemanticError;
        var$4 = var$2.$name13;
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        jl_StringBuilder_append(jl_StringBuilder_append(var$5, var$4), $rt_s(3138));
        oncias_SemanticError__init_($patternPart$1, jl_AbstractStringBuilder_toString(var$5), var$2.$position42);
        return oncias_package$_liftSemanticErrorDef(var$3, $patternPart$1);
    };
    $java.oncias_SemanticPatternCheck$_$anonfun$checkValidJuxtaposition$1 = function($x0$1) {
        var $a, $b, $aString, $aTypeString, $bString, $bTypeString, $inThisCase;
        oncias_SemanticPatternCheck$_$callClinit();
        if ($x0$1 !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $x0$1);
            if (!$x0$1.$lengthCompare(2) && $x0$1.$apply1(1) instanceof oncie_QuantifiedPath)
                return oncias_SemanticCheck$_success;
        }
        if ($x0$1 !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $x0$1);
            if (!$x0$1.$lengthCompare(2) && $x0$1.$apply1(0) instanceof oncie_QuantifiedPath)
                return oncias_SemanticCheck$_success;
        }
        if ($x0$1 !== null) {
            s_package$_$callClinit();
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $x0$1);
            if (!$x0$1.$lengthCompare(2)) {
                a: {
                    b: {
                        c: {
                            $a = $x0$1.$apply1(0);
                            $b = $x0$1.$apply1(1);
                            $aString = onciap_DefaultPatternStringifier_apply2(($java.oncias_SemanticPatternCheck$_stringifier0(oncias_SemanticPatternCheck$_MODULE$)).$patterns, $a);
                            $aTypeString = $java.oncias_SemanticPatternCheck$_getTypeString(oncias_SemanticPatternCheck$_MODULE$, $a);
                            $bString = onciap_DefaultPatternStringifier_apply2(($java.oncias_SemanticPatternCheck$_stringifier0(oncias_SemanticPatternCheck$_MODULE$)).$patterns, $b);
                            $bTypeString = $java.oncias_SemanticPatternCheck$_getTypeString(oncias_SemanticPatternCheck$_MODULE$, $b);
                            if ($aTypeString !== null) {
                                if (!jl_String_equals($aTypeString, $bTypeString))
                                    break b;
                                else
                                    break c;
                            }
                            if ($bTypeString !== null)
                                break b;
                        }
                        $x0$1 = new jl_StringBuilder;
                        jl_AbstractStringBuilder__init_($x0$1);
                        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($x0$1, $rt_s(3139)), $aString), $rt_s(64)), $bString), $rt_s(3140)), $aTypeString), $rt_s(3141));
                        $inThisCase = jl_AbstractStringBuilder_toString($x0$1);
                        break a;
                    }
                    $x0$1 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_($x0$1);
                    jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($x0$1, $rt_s(3142)), $aString), $rt_s(3143)), $aTypeString), $rt_s(64)), $bString), $rt_s(3143)), $bTypeString), 46);
                    $inThisCase = jl_AbstractStringBuilder_toString($x0$1);
                }
                $x0$1 = oncias_SemanticPatternCheck$_MODULE$;
                $a = sc_StringOps$_MODULE$;
                s_Predef$_$callClinit();
                $aString = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_($aString);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append($aString, $rt_s(3144)), $inThisCase), $rt_s(3145));
                return oncias_SemanticAnalysisTooling_error$($x0$1, sc_StringOps$_stripMargin$extension($a, jl_AbstractStringBuilder_toString($aString)), $b.$position2());
            }
        }
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticPatternCheck$_checkNotUndirectedWhenCreating$1 = function($this, $ctx$4, $x$23) {
        var var$3, var$4;
        a: {
            b: {
                if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Create$_MODULE$, $ctx$4)) {
                    var$3 = $x$23.$direction0;
                    var$4 = oncie_SemanticDirection$BOTH$_MODULE$;
                    if (var$3 !== null) {
                        if (!jl_Object_equals(var$3, var$4))
                            break b;
                        else
                            break a;
                    }
                    if (var$4 === null)
                        break a;
                }
            }
            return oncias_SemanticCheck$_success;
        }
        $ctx$4 = $java.oncie_Pattern$SemanticContext$_name($java.oncie_Pattern$SemanticContext$_MODULE$, $ctx$4);
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3146)), $ctx$4);
        return oncias_SemanticAnalysisTooling_error$($this, jl_AbstractStringBuilder_toString(var$4), $x$23.$position32);
    };
    $java.oncie_Pattern$SemanticContext = $rt_classWithoutFields(0);
    $java.oncie_Pattern$SemanticContext_name$ = function($$this) {
        return $java.oncie_Pattern$SemanticContext$_name($java.oncie_Pattern$SemanticContext$_MODULE$, $$this);
    };
    $java.oncie_Pattern$SemanticContext_description$ = function($$this) {
        if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Match$_MODULE$, $$this))
            $$this = $rt_s(3147);
        else if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Merge$_MODULE$, $$this))
            $$this = $rt_s(3148);
        else if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Create$_MODULE$, $$this))
            $$this = $rt_s(3149);
        else {
            if (!jl_Object_equals($java.oncie_Pattern$SemanticContext$Expression$_MODULE$, $$this))
                $rt_throw(s_MatchError__init_($$this));
            $$this = $rt_s(3150);
        }
        return $$this;
    };
    var oncie_Pattern$SemanticContext$Expression$ = $rt_classWithoutFields();
    $java.oncie_Pattern$SemanticContext$Expression$_MODULE$ = null;
    function oncie_Pattern$SemanticContext$Expression$__clinit_() {
        $java.oncie_Pattern$SemanticContext$Expression$_MODULE$ = new oncie_Pattern$SemanticContext$Expression$;
    }
    $java.oncie_Pattern$SemanticContext$Expression$_name = function($this) {
        return $java.oncie_Pattern$SemanticContext_name$($this);
    };
    $java.oncie_Pattern$SemanticContext$Expression$_description = function($this) {
        return $java.oncie_Pattern$SemanticContext_description$($this);
    };
    $java.oncie_Pattern$SemanticContext$Expression$_productArity = function($this) {
        return 0;
    };
    $java.oncie_Pattern$SemanticContext$Expression$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Pattern$SemanticContext$Expression$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$SemanticContext$Expression$_hashCode = function($this) {
        return 198012600;
    };
    $java.oncie_Pattern$SemanticContext$Expression$_toString = function($this) {
        return $rt_s(3151);
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1();
        $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1_applyOrElse = function($this, $x1, $default) {
        if (!($x1 instanceof oncie_NodePattern))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(s_Option_exists($x1.$labelExpression1, new $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0));
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1__init_0 = function($this) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47 = function() {
        jl_Object.call(this);
        this.$_0608 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47__init_0 = function(var$0, var$1) {
        var$0.$_0608 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0608;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticAnalysisTooling_error$(oncias_SemanticExpressionCheck$_MODULE$, $rt_s(3152), $java.oncie_ShortestPathExpression_position(var$1));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48 = function() {
        jl_Object.call(this);
        this.$_0609 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48__init_0 = function(var$0, var$1) {
        var$0.$_0609 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0609;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        if (var$1.$pattern8.$single0)
            var$1 = $java.oncius_package$_CTPath0(oncius_package$_MODULE$);
        else {
            var$1 = oncius_package$_MODULE$;
            var$1 = oncius_package$_CTList(var$1, $java.oncius_package$_CTPath0(var$1));
        }
        return var$1.$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49 = function() {
        jl_Object.call(this);
        this.$_0610 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49__init_0 = function(var$0, var$1) {
        var$0.$_0610 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0610;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = $java.oncias_SemanticPatternCheck$_check1(oncias_SemanticPatternCheck$_MODULE$, $java.oncie_Pattern$SemanticContext$Match$_MODULE$, var$1.$pattern6);
        var$3 = oncias_package$_MODULE$;
        var$4 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$56$lambda$_116_0;
        var$4.$_0611 = var$1;
        var$3 = oncias_SemanticCheck_chain$(var$2, oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$3, var$4));
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, var$1.$pattern6));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return (oncius_package$_CTList(var$1, $java.oncius_package$_CTPath0(var$1))).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53 = function() {
        jl_Object.call(this);
        this.$_0612 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53__init_0 = function(var$0, var$1) {
        var$0.$_0612 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0612;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$61$lambda$_121_0;
        var$2.$_0613 = var$1;
        var$3 = oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, var$1.$init2);
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0(oncias_SemanticExpressionCheck$_MODULE$, var$1.$scope12.$variable44, var$2, s_None$_MODULE$, 0)), $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0(oncias_SemanticExpressionCheck$_MODULE$, var$1.$scope12.$accumulator1, var$3, s_None$_MODULE$, 0))), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$,
        $java.oncie_Expression$SemanticContext$Simple$_MODULE$, $java.oncie_ReduceExpression_expression(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54 = function() {
        jl_Object.call(this);
        this.$_0614 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54__init_0 = function(var$0, var$1) {
        var$0.$_0614 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0614;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncius_TypeSpec_leastUpperBounds($java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, var$2.$init2), var$1), $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, $java.oncie_ReduceExpression_expression(var$2)), var$1));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56 = function() {
        jl_Object.call(this);
        this.$_0615 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56__init_0 = function(var$0, var$1) {
        var$0.$_0615 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0615;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3153), var$1.$position284));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57 = function() {
        jl_Object.call(this);
        this.$_0616 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57__init_0 = function(var$0, var$1) {
        var$0.$_0616 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_0616;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        if ($java.oncius_TypeSpec_contains(var$1, oncius_package$_CTAny(oncius_package$_MODULE$)))
            var$1 = oncias_SemanticCheck$_success;
        else {
            var$3 = oncias_SemanticExpressionCheck$_MODULE$;
            var$4 = var$2.$idx0;
            var$5 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$67$lambda$_138_0;
            var$5.$_0617 = var$1;
            var$5.$_1189 = var$2;
            var$1 = $java.oncias_SemanticExpressionCheck$_typeSwitch(var$3, var$4, var$5);
        }
        return var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$1.$_20;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTMap(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTMap(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61 = function() {
        jl_Object.call(this);
        this.$_0618 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61__init_0 = function(var$0, var$1) {
        var$0.$_0618 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0618;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTMap(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63 = function() {
        jl_Object.call(this);
        this.$_0619 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63__init_0 = function(var$0, var$1) {
        var$0.$_0619 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0619;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64 = function() {
        jl_Object.call(this);
        this.$_0620 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64__init_0 = function(var$0, var$1) {
        var$0.$_0620 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0620;
        oncias_SemanticExpressionCheck$_$callClinit();
        return !jl_String_matches(var$1.$stringVal1(), $rt_s(3154)) ? oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3155), var$1.$position2())) : oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3156), var$1.$position2()));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTInteger(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66 = function() {
        var a = this; jl_Object.call(a);
        a.$_0621 = null;
        a.$_1190 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66__init_0 = function(var$0, var$1, var$2) {
        var$0.$_0621 = var$1;
        var$0.$_1190 = var$2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0621;
        var$2 = var$0.$_1190;
        oncias_SemanticExpressionCheck$_$callClinit();
        return !jl_String_matches(var$1, $rt_s(3157)) ? oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3155), var$2.$position248)) : oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3156), var$2.$position248));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67 = function() {
        var a = this; jl_Object.call(a);
        a.$_0622 = null;
        a.$_1191 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67__init_0 = function(var$0, var$1, var$2) {
        var$0.$_0622 = var$1;
        var$0.$_1191 = var$2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0622;
        var$2 = var$0.$_1191;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = oncias_package$_MODULE$;
        var$4 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$88$lambda$_149_0;
        var$4.$_0623 = var$1;
        var$4.$_1192 = var$2;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$3, var$4);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTInteger(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69 = function() {
        var a = this; jl_Object.call(a);
        a.$_0624 = null;
        a.$_1193 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69__init_0 = function(var$0, var$1, var$2) {
        var$0.$_0624 = var$1;
        var$0.$_1193 = var$2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0624;
        var$2 = var$0.$_1193;
        oncias_SemanticExpressionCheck$_$callClinit();
        return !jl_String_matches(var$1, $rt_s(3158)) ? oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3155), var$2.$position249)) : oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3156), var$2.$position249));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70 = function() {
        var a = this; jl_Object.call(a);
        a.$_0625 = null;
        a.$_1194 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70__init_0 = function(var$0, var$1, var$2) {
        var$0.$_0625 = var$1;
        var$0.$_1194 = var$2;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0625;
        var$2 = var$0.$_1194;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = oncias_package$_MODULE$;
        var$4 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$92$lambda$_153_0;
        var$4.$_0626 = var$1;
        var$4.$_1195 = var$2;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$3, var$4);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTInteger(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72 = function() {
        jl_Object.call(this);
        this.$_0627 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72__init_0 = function(var$0, var$1) {
        var$0.$_0627 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0627;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3155), var$1.$position250));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73 = function() {
        jl_Object.call(this);
        this.$_0628 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73__init_0 = function(var$0, var$1) {
        var$0.$_0628 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0628;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = !$rt_globals.isFinite(($java.oncie_DecimalDoubleLiteral_value(var$1)).$value3) ? 1 : 0;
        var$4 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$96$lambda$_157_0;
        var$4.$_0629 = var$1;
        return oncias_SemanticCheck$_when(var$2, var$3, var$4);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return ($java.oncius_package$_CTFloat(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTString(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return ($java.oncius_package$_CTFloat(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return ($java.oncius_package$_CTFloat(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80 = function() {
        jl_Object.call(this);
        this.$_0630 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80__init_0 = function(var$0, var$1) {
        var$0.$_0630 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0630;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = var$1.$query3.$semanticCheckInSubqueryExpressionContext(1);
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = var$1.$query3.$containsUpdates();
        var$5 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$104$lambda$_165_0;
        var$5.$_0631 = var$1;
        var$6 = oncias_SemanticCheck_chain$(var$2, oncias_SemanticCheck$_when(var$3, var$4, var$5));
        var$3 = oncias_SemanticExpressionCheck$_MODULE$;
        var$5 = var$1.$query3.$folder();
        sr_ClassTag$_$callClinit();
        var$3 = oncias_SemanticCheck_chain$(var$6, $java.oncias_SemanticExpressionCheck$_checkForShadowedVariables(var$3, onciu_Foldable$Folder_findAllByClass(var$5, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncia_SubqueryCall)))));
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, var$1.$query3));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82 = function() {
        jl_Object.call(this);
        this.$_0632 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82__init_0 = function(var$0, var$1) {
        var$0.$_0632 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0632;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = var$1.$query4;
        var$2 = var$2.$semanticCheckInSubqueryExpressionContext(var$2 instanceof oncia_UnionDistinct ? 0 : 1);
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = var$1.$query4.$containsUpdates();
        var$5 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$107$lambda$_168_0;
        var$5.$_0633 = var$1;
        var$6 = oncias_SemanticCheck_chain$(var$2, oncias_SemanticCheck$_when(var$3, var$4, var$5));
        var$3 = oncias_SemanticExpressionCheck$_MODULE$;
        var$5 = var$1.$query4.$folder();
        sr_ClassTag$_$callClinit();
        var$3 = oncias_SemanticCheck_chain$(var$6, $java.oncias_SemanticExpressionCheck$_checkForShadowedVariables(var$3, onciu_Foldable$Folder_findAllByClass(var$5, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncia_SubqueryCall)))));
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, var$1.$query4));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return (oncius_package$_CTInteger(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84 = function() {
        jl_Object.call(this);
        this.$_0634 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84__init_0 = function(var$0, var$1) {
        var$0.$_0634 = var$1;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0634;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = var$1.$query5.$semanticCheckInSubqueryExpressionContext(0);
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = var$1.$query5.$containsUpdates();
        var$5 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_0;
        var$5.$_0635 = var$1;
        var$5 = oncias_SemanticCheck_chain$(var$2, oncias_SemanticCheck$_when(var$3, var$4, var$5));
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$4 = !(var$1.$query5.$returnVariables()).$includeExisting1 && (var$1.$query5.$returnColumns()).$length() == 1 ? 0 : 1;
        var$3 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_1;
        var$3.$_0636 = var$1;
        var$6 = oncias_SemanticCheck_chain$(var$5, oncias_SemanticCheck$_when(var$2, var$4, var$3));
        var$3 = oncias_SemanticExpressionCheck$_MODULE$;
        var$5 = var$1.$query5.$folder();
        sr_ClassTag$_$callClinit();
        var$3 = oncias_SemanticCheck_chain$(var$6, $java.oncias_SemanticExpressionCheck$_checkForShadowedVariables(var$3, onciu_Foldable$Folder_findAllByClass(var$5, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncia_SubqueryCall)))));
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, oncias_SemanticState$_recordCurrentScope(oncias_SemanticState$_MODULE$, var$1.$query5));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85__init_ = function() {
        var var_0 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85();
        $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85__init_0 = function(var$0) {};
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncia_SingleQuery$$anonfun$checkClauses$2$lambda$_139_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0447 = null;
        a.$_1134 = 0;
        a.$_252 = 0;
    };
    $java.oncia_SingleQuery$$anonfun$checkClauses$2$lambda$_139_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        a: {
            var$1 = var$1;
            var$2 = var$0.$_0447;
            var$3 = var$0.$_1134;
            var$4 = var$0.$_252;
            if ($rt_isInstance(var$2, $java.oncia_UpdateClause) && var$3 == var$4)
                var$2 = oncias_SemanticState_newSiblingScope(var$1.$state);
            else {
                if (var$2 instanceof $java.oncia_CallClause) {
                    var$2 = var$2;
                    if (($java.oncia_UnresolvedCall_returnVariables(var$2)).$explicitVariables.$isEmpty() && !var$2.$yieldAll && var$3 == var$4) {
                        var$2 = oncias_SemanticState_newSiblingScope(var$1.$state);
                        break a;
                    }
                }
                var$2 = var$1.$state;
            }
        }
        return oncias_SemanticCheckResult__init_(var$2, var$1.$errors);
    };
    function sc_IterableOnceOps$max$lambda$_81_0() {
        jl_Object.call(this);
        this.$_09 = null;
    }
    $java.sc_IterableOnceOps$max$lambda$_81_0_apply = function(var$0, var$1, var$2) {
        return var$0.$_09.$max0(var$1, var$2);
    };
    var onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_0 = $rt_classWithoutFields();
    var onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_1 = $rt_classWithoutFields();
    var onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_2_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    var onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_0 = $rt_classWithoutFields();
    var onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_1_apply = function(var$0, var$1) {
        return var$1.$asCanonicalStringVal();
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_ReadAdministrationCommand$$anonfun$1_applyOrElse = function($this, $x, $default) {
        return !$rt_isInstance($x, $java.oncie_SubqueryExpression) ? s_PartialFunction$_fallback_fn : jl_Boolean_valueOf(1);
    };
    $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_0 = function() {
        jl_Object.call(this);
        this.$_0484 = null;
    };
    $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0484;
        return var$1 instanceof oncia_ExistsExpression ? var$2.$error2($rt_s(3159), var$1.$position71) : var$1 instanceof oncia_CollectExpression ? var$2.$error2($rt_s(3160), var$1.$position73) : var$1 instanceof oncia_CountExpression ? var$2.$error2($rt_s(3161), var$1.$position72) : var$1 instanceof oncie_PatternExpression ? var$2.$error2($rt_s(3162), $java.oncie_PatternExpression_position(var$1)) : !(var$1 instanceof oncie_PatternComprehension) ? var$2.$error2($rt_s(3163), var$1.$position2()) : var$2.$error2($rt_s(3164),
        var$1.$position252);
    };
    $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_1 = $rt_classWithoutFields();
    $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_1_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticExpressionCheck$$infixAddRhsTypes$lambda$_56_0 = function() {
        jl_Object.call(this);
        this.$_0472 = null;
    };
    $java.oncias_SemanticExpressionCheck$$infixAddOutputTypes$lambda$_57_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0473 = null;
        a.$_1150 = null;
    };
    $java.oncias_SemanticExpressionCheck$$infixAddOutputTypes$lambda$_57_0_apply = function(var$0, var$1) {
        return $java.oncias_SemanticExpressionCheck$_$anonfun$infixAddOutputTypes$1(var$0.$_0473, var$0.$_1150, var$1);
    };
    var onciuh_Try$ = $rt_classWithoutFields();
    $java.onciuh_Try$_MODULE$ = null;
    function onciuh_Try$__clinit_() {
        $java.onciuh_Try$_MODULE$ = new onciuh_Try$;
    }
    $java.onciuh_Try$_apply = function($this, $value) {
        var var$2, $$je;
        a: {
            try {
                var$2 = $java.onciuh_Success__init_(srj_JFunction0$mcJ$sp_apply($value));
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_Throwable) {
                    $value = $$je;
                } else {
                    throw $$e;
                }
            }
            if (!($value instanceof $java.jl_VirtualMachineError ? 1 : $value instanceof $java.jl_InterruptedException ? 1 : $value instanceof jl_LinkageError ? 1 : !($value instanceof $java.suc_ControlThrowable) ? 0 : 1))
                $rt_throw($value);
            var$2 = $java.onciuh_Failure$_MODULE$;
        }
        return var$2;
    };
    $java.oncias_SemanticExpressionCheck$$checkAddBoundary$lambda$_52_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0468 = null;
        a.$_1147 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkAddBoundary$lambda$_52_0_apply$mcJ$sp = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$0.$_0468;
        var$2 = var$0.$_1147;
        oncias_SemanticExpressionCheck$_$callClinit();
        s_Predef$_$callClinit();
        var$3 = sr_BoxesRunTime_unboxToLong(var$1.$value26());
        var$4 = sr_BoxesRunTime_unboxToLong(var$2.$value26());
        var$5 = Long_add(var$3, var$4);
        var$6 = Long_ge(var$5, Long_ZERO) ? 0 : 1;
        var$7 = Long_ge(var$3, Long_ZERO) ? 0 : 1;
        if (var$6 != var$7 && var$6 != (Long_ge(var$4, Long_ZERO) ? 0 : 1)) {
            var$1 = new $java.jl_ArithmeticException;
            jl_Throwable__init_(var$1, $rt_s(3165));
            $rt_throw(var$1);
        }
        return var$5;
    };
    $java.oncias_SemanticExpressionCheck$$checkSubtractBoundary$lambda$_53_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0469 = null;
        a.$_1148 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkSubtractBoundary$lambda$_53_0_apply$mcJ$sp = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0469;
        var$2 = var$0.$_1148;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = $java.onciuh_Math$_MODULE$;
        s_Predef$_$callClinit();
        return $java.onciuh_Math$_subtractExact(var$3, sr_BoxesRunTime_unboxToLong(var$1.$value26()), sr_BoxesRunTime_unboxToLong(var$2.$value26()));
    };
    $java.oncias_SemanticExpressionCheck$$checkUnarySubtractBoundary$lambda$_54_0 = function() {
        jl_Object.call(this);
        this.$_0470 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkUnarySubtractBoundary$lambda$_54_0_apply$mcJ$sp = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0470;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = $java.onciuh_Math$_MODULE$;
        s_Predef$_$callClinit();
        return $java.onciuh_Math$_subtractExact(var$2, Long_ZERO, sr_BoxesRunTime_unboxToLong(var$1.$value26()));
    };
    $java.oncias_SemanticExpressionCheck$$checkMultiplyBoundary$lambda$_55_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0471 = null;
        a.$_1149 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkMultiplyBoundary$lambda$_55_0_apply$mcJ$sp = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0471;
        var$2 = var$0.$_1149;
        oncias_SemanticExpressionCheck$_$callClinit();
        s_Predef$_$callClinit();
        var$3 = sr_BoxesRunTime_unboxToLong(var$1.$value26());
        var$4 = sr_BoxesRunTime_unboxToLong(var$2.$value26());
        if (Long_gt(var$4, Long_ZERO))
            var$5 = Long_le(var$3, Long_div(Long_create(4294967295, 2147483647), var$4)) && Long_ge(var$3, Long_div(Long_create(0, 2147483648), var$4)) ? 0 : 1;
        else {
            var$5 = Long_compare(var$4, Long_fromInt(-1));
            var$5 = var$5 >= 0 ? (var$5 ? 0 : Long_ne(var$3, Long_create(0, 2147483648)) ? 0 : 1) : Long_le(var$3, Long_div(Long_create(0, 2147483648), var$4)) && Long_ge(var$3, Long_div(Long_create(4294967295, 2147483647), var$4)) ? 0 : 1;
        }
        if (!var$5)
            return Long_mul(var$3, var$4);
        var$1 = new $java.jl_ArithmeticException;
        jl_Throwable__init_(var$1, $rt_s(3165));
        $rt_throw(var$1);
    };
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0475 = null;
        a.$_1151 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0475;
        var$2 = var$0.$_1151;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncie_ListComprehension_variable(var$1), $java.oncias_SemanticExpressionCheck$FilteringExpressions$_possibleInnerTypes($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, var$1), s_None$_MODULE$, 0)), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $java.oncie_Expression$SemanticContext$Simple$_MODULE$,
        var$2));
    };
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_1 = function() {
        jl_Object.call(this);
        this.$_0476 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_1_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0476;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncius_TypeSpec_wrapInList($java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, var$2), var$1));
    };
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_2 = function() {
        jl_Object.call(this);
        this.$_0474 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_2_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0474;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0(oncias_SemanticExpressionCheck$_MODULE$, $java.oncie_ListComprehension_variable(var$1), $java.oncias_SemanticExpressionCheck$FilteringExpressions$_possibleInnerTypes($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, var$1), s_None$_MODULE$, 0));
    };
    $java.oncias_SemanticExpressionCheck$$possibleTypes$1$lambda$_124_0 = function() {
        jl_Object.call(this);
        this.$_0478 = null;
    };
    $java.oncias_SemanticExpressionCheck$$possibleTypes$1$lambda$_124_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        a: {
            var$2 = var$0.$_0478;
            oncias_SemanticExpressionCheck$_$callClinit();
            var$3 = var$2.$expressions1;
            if (var$3 !== null) {
                s_package$_$callClinit();
                s_package$_Seq(s_package$_MODULE$);
                sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, var$3);
                if (!var$3.$lengthCompare(0)) {
                    oncius_package$_$callClinit();
                    var$1 = oncius_package$_MODULE$;
                    var$1 = $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
                    break a;
                }
            }
            var$4 = oncias_SemanticExpressionCheck$_MODULE$;
            var$3 = var$2.$expressions1;
            if ((var$3.$iterator0()).$isEmpty())
                var$2 = new $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_1;
            else {
                var$2 = new $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_0;
                var$2.$_0637 = var$4;
                var$2.$_1196 = var$3;
            }
            var$1 = var$2.$apply(var$1);
            oncius_TypeSpec$_$callClinit();
            var$1 = $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(oncius_TypeSpec$_MODULE$, var$1.$ranges.$map1(new $java.oncius_TypeSpec$wrapInCovariantList$lambda$_24_0));
        }
        return var$1;
    };
    $java.oncia_SingleQuery$checkHorizon$lambda$_74_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0448 = null;
        a.$_1135 = null;
    };
    $java.oncia_SingleQuery$checkHorizon$lambda$_74_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0448;
        var$3 = var$0.$_1135;
        var$2 = var$2.$semanticCheckContinuation(var$1.$state.$currentScope.$elem, var$3);
        var$3 = new $java.oncia_SingleQuery$$anonfun$checkHorizon$1$lambda$_142_0;
        var$3.$_0638 = var$1;
        return var$2.$map12(var$3);
    };
    $java.onciu_RewritableCompat$PROXY$7_245 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_245_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_245 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_245_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_246 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_246_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_246 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_246_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_247 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_247_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_247 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_247_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_884 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_884_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_IntervalQuantifier__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_885 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_885_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_FixedQuantifier__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_886 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_886_copyConstructor(var$1, var$2, var$3) {
        return oncie_StarQuantifier__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_890 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_890_copyConstructor(var$1, var$2, var$3) {
        return oncie_PlusQuantifier__init_(var$3.data[0]);
    }
    var onciu_RewritableCompat$PROXY$3_893 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_893_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_UnaryAdd__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_894 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_894_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_UnarySubtract__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_895 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_895_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncil_LabelExpression$ColonDisjunction__init_(var$3[0], var$3[1], var$3[2].$value8, var$3[3]);
    }
    $java.onciu_RewritableCompat$PROXY$7_248 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_248_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_248 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_248_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_249 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_249_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_249 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_249_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    var oncie_SensitiveAutoParameter = $rt_classWithoutFields(0);
    $java.oncius_TypeSpec$constrain$lambda$_20_0 = function() {
        jl_Object.call(this);
        this.$_0524 = null;
    };
    $java.oncius_TypeSpec$constrain$lambda$_20_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeRange_constrain(var$1, var$0.$_0524);
    };
    $java.oncias_SemanticFunctionCheck$$check$lambda$_40_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0560 = null;
        a.$_1176 = null;
    };
    $java.oncias_SemanticFunctionCheck$$check$lambda$_40_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0560;
        var$2 = var$0.$_1176;
        var$3 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$1 = var$1.$name3();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3166)), var$1), $rt_s(3167));
        return oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position7);
    };
    $java.oncias_SemanticFunctionCheck$$check$lambda$_40_1 = function() {
        jl_Object.call(this);
        this.$_0559 = null;
    };
    $java.oncias_SemanticFunctionCheck$$check$lambda$_40_1_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0559;
        var$2 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$3 = var$1.$functionName0.$name6;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3168)), var$3), 39);
        return oncias_SemanticAnalysisTooling_error$(var$2, jl_AbstractStringBuilder_toString(var$4), var$1.$position7);
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$semanticCheck$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$semanticCheck$lambda$_1_0_apply = function(var$0) {
        var var$1;
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_2_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_2_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncias_SemanticExpressionCheck$FilteringExpressions$_failIfAggregating0($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, var$1);
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkPredicateDefined$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0580 = null;
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkPredicateDefined$lambda$_4_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0580;
        var$2 = oncias_package$_MODULE$;
        var$3 = new oncias_SemanticError;
        var$4 = var$1.$name3();
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        jl_StringBuilder_append(jl_StringBuilder_append(var$5, var$4), $rt_s(3169));
        oncias_SemanticError__init_(var$3, jl_AbstractStringBuilder_toString(var$5), var$1.$position2());
        return oncias_package$_liftSemanticErrorDef(var$2, var$3);
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_3_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticError__init_0($rt_s(3170), var$1.$position2());
    };
    var oncie_Pattern$SemanticContext$Match$ = $rt_classWithoutFields();
    $java.oncie_Pattern$SemanticContext$Match$_MODULE$ = null;
    function oncie_Pattern$SemanticContext$Match$__clinit_() {
        $java.oncie_Pattern$SemanticContext$Match$_MODULE$ = new oncie_Pattern$SemanticContext$Match$;
    }
    $java.oncie_Pattern$SemanticContext$Match$_name = function($this) {
        return $java.oncie_Pattern$SemanticContext_name$($this);
    };
    $java.oncie_Pattern$SemanticContext$Match$_description = function($this) {
        return $java.oncie_Pattern$SemanticContext_description$($this);
    };
    $java.oncie_Pattern$SemanticContext$Match$_productArity = function($this) {
        return 0;
    };
    $java.oncie_Pattern$SemanticContext$Match$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Pattern$SemanticContext$Match$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$SemanticContext$Match$_hashCode = function($this) {
        return 74115493;
    };
    $java.oncie_Pattern$SemanticContext$Match$_toString = function($this) {
        return $rt_s(2040);
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_42_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_42_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_package$_MODULE$;
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        oncius_package$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_declareVariable$(var$3, var$1, (oncius_package$_CTNode(oncius_package$_MODULE$)).$invariant()));
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_43_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0593 = null;
        a.$_1181 = null;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_43_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0593;
        var$2 = var$0.$_1181;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = var$2.$selector.$prettified();
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(530)), var$4), 96);
        var$1 = $java.oncias_SemanticPatternCheck$_checkContext(var$3, var$1, jl_AbstractStringBuilder_toString(var$5), var$2.$selector.$position2());
        var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_0;
        var$4 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_1;
        var$4.$_0639 = var$2;
        var$5 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_2;
        var$5.$_0640 = var$3;
        return oncias_SemanticCheck_chain$(var$1, oncias_SemanticAnalysisTooling_whenState$(oncias_SemanticPatternCheck$_MODULE$, var$3, var$4, var$5));
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_0 = function() {
        jl_Object.call(this);
        this.$_0641 = null;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_0__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticPatternCheck$$check$lambda$_48_0();
        $java.oncias_SemanticPatternCheck$$check$lambda$_48_0__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_0__init_0 = function(var$0, var$1) {
        var$0.$_0641 = var$1;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0641;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncias_SemanticPatternCheck$_check0(oncias_SemanticPatternCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_1 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_1__init_ = function() {
        var var_0 = new $java.oncias_SemanticPatternCheck$$check$lambda$_48_1();
        $java.oncias_SemanticPatternCheck$$check$lambda$_48_1__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_1__init_0 = function(var$0) {};
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_1_apply = function(var$0, var$1, var$2) {
        var$1 = var$1;
        var$2 = var$2;
        oncias_SemanticPatternCheck$_$callClinit();
        return var$1.$chain(var$2);
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0284 = null;
        a.$_186 = null;
        a.$_233 = null;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_2__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.oncias_SemanticPatternCheck$$check$lambda$_48_2();
        $java.oncias_SemanticPatternCheck$$check$lambda$_48_2__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_2__init_0 = function(var$0, var$1, var$2, var$3) {
        var$0.$_0284 = var$1;
        var$0.$_186 = var$2;
        var$0.$_233 = var$3;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_3 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_3__init_ = function() {
        var var_0 = new $java.oncias_SemanticPatternCheck$$check$lambda$_48_3();
        $java.oncias_SemanticPatternCheck$$check$lambda$_48_3__init_0(var_0);
        return var_0;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_3__init_0 = function(var$0) {};
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncia_Where$_checkExpression($java.oncia_Where$_MODULE$, var$1);
    };
    $java.onciuh_Try = $rt_classWithoutFields(0);
    $java.onciuh_Success = function() {
        jl_Object.call(this);
        this.$value36 = null;
    };
    $java.onciuh_Success__init_ = function(var_0) {
        var var_1 = new $java.onciuh_Success();
        $java.onciuh_Success__init_0(var_1, var_0);
        return var_1;
    };
    $java.onciuh_Success_isFailure = function($this) {
        return 0;
    };
    $java.onciuh_Success__init_0 = function($this, $value) {
        $this.$value36 = $value;
    };
    var onciuh_Failure$ = $rt_classWithoutFields();
    $java.onciuh_Failure$_MODULE$ = null;
    function onciuh_Failure$__clinit_() {
        $java.onciuh_Failure$_MODULE$ = new onciuh_Failure$;
    }
    $java.onciuh_Failure$_isFailure = function($this) {
        return 1;
    };
    $java.jl_InterruptedException = $rt_classWithoutFields(jl_Exception);
    $java.suc_ControlThrowable = $rt_classWithoutFields(jl_Throwable);
    $java.onciu_Fby$$anon$2 = function() {
        jl_Object.call(this);
        this.$remaining1 = null;
    };
    $java.onciu_Fby$$anon$2_iterator = function($this) {
        return $this;
    };
    $java.onciu_Fby$$anon$2_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.onciu_Fby$$anon$2_toString = function($this) {
        return $rt_s(466);
    };
    $java.onciu_Fby$$anon$2_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.onciu_Fby$$anon$2_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.onciu_Fby$$anon$2_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.onciu_Fby$$anon$2_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.onciu_Fby$$anon$2_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.onciu_Fby$$anon$2_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.onciu_Fby$$anon$2_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.onciu_Fby$$anon$2_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.onciu_Fby$$anon$2_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.onciu_Fby$$anon$2_to = function($this, $factory) {
        return $factory.$fromSpecific($this);
    };
    $java.onciu_Fby$$anon$2_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.onciu_Fby$$anon$2_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.onciu_Fby$$anon$2_knownSize = function($this) {
        return (-1);
    };
    $java.onciu_Fby$$anon$2_hasNext = function($this) {
        return s_Option_isDefined($this.$remaining1);
    };
    $java.onciu_Fby$$anon$2_next = function($this) {
        var $nel;
        $nel = $this.$remaining1;
        if ($nel instanceof s_Some) {
            $nel = $nel.$value5;
            $this.$remaining1 = $nel.$tailOption();
            return $nel.$head();
        }
        if (!jl_Object_equals(s_None$_MODULE$, $nel))
            $rt_throw(s_MatchError__init_($nel));
        $nel = new ju_NoSuchElementException;
        jl_Throwable__init_($nel, $rt_s(469));
        $rt_throw($nel);
    };
    $java.onciu_Last$$anon$3 = function() {
        jl_Object.call(this);
        this.$remaining0 = null;
    };
    $java.onciu_Last$$anon$3_iterator = function($this) {
        return $this;
    };
    $java.onciu_Last$$anon$3_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($this);
    };
    $java.onciu_Last$$anon$3_toString = function($this) {
        return $rt_s(466);
    };
    $java.onciu_Last$$anon$3_foreach = function($this, $f) {
        sc_IterableOnceOps_foreach$($this, $f);
    };
    $java.onciu_Last$$anon$3_exists = function($this, $p) {
        return sc_IterableOnceOps_exists$($this, $p);
    };
    $java.onciu_Last$$anon$3_find = function($this, $p) {
        return sc_IterableOnceOps_find$($this, $p);
    };
    $java.onciu_Last$$anon$3_foldLeft = function($this, $z, $op) {
        return sc_IterableOnceOps_foldLeft$($this, $z, $op);
    };
    $java.onciu_Last$$anon$3_nonEmpty = function($this) {
        return sc_IterableOnceOps_nonEmpty$($this);
    };
    $java.onciu_Last$$anon$3_size = function($this) {
        return sc_IterableOnceOps_size$($this);
    };
    $java.onciu_Last$$anon$3_copyToArray = function($this, $xs) {
        return sc_IterableOnceOps_copyToArray$($this, $xs);
    };
    $java.onciu_Last$$anon$3_copyToArray0 = function($this, $xs, $start) {
        return sc_IterableOnceOps_copyToArray$0($this, $xs, $start);
    };
    $java.onciu_Last$$anon$3_copyToArray1 = function($this, $xs, $start, $len) {
        return sc_IterableOnceOps_copyToArray$1($this, $xs, $start, $len);
    };
    $java.onciu_Last$$anon$3_to = function($this, $factory) {
        return $factory.$fromSpecific($this);
    };
    $java.onciu_Last$$anon$3_toSeq = function($this) {
        return sc_IterableOnceOps_toSeq$($this);
    };
    $java.onciu_Last$$anon$3_toArray = function($this, $evidence$2) {
        return sc_IterableOnceOps_toArray$($this, $evidence$2);
    };
    $java.onciu_Last$$anon$3_knownSize = function($this) {
        return (-1);
    };
    $java.onciu_Last$$anon$3_hasNext = function($this) {
        return s_Option_isDefined($this.$remaining0);
    };
    $java.onciu_Last$$anon$3_next = function($this) {
        var $nel;
        $nel = $this.$remaining0;
        if ($nel instanceof s_Some) {
            $nel = $nel.$value5;
            $this.$remaining0 = s_None$_MODULE$;
            return $nel.$head();
        }
        if (!jl_Object_equals(s_None$_MODULE$, $nel))
            $rt_throw(s_MatchError__init_($nel));
        $nel = new ju_NoSuchElementException;
        jl_Throwable__init_($nel, $rt_s(469));
        $rt_throw($nel);
    };
    $java.oncie_Expression$$anonfun$arguments$1 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$$outer31 = null;
    };
    $java.oncie_Expression$$anonfun$arguments$1_applyOrElse = function($this, $x1, $default) {
        a: {
            if ($x1 instanceof oncie_Expression)
                b: {
                    $x1 = $x1;
                    $default = $this.$$outer31;
                    if ($x1 !== null) {
                        if ($x1.$equals($default))
                            break b;
                        else
                            break a;
                    }
                    if ($default !== null)
                        break a;
                }
            return s_PartialFunction$_fallback_fn;
        }
        $default = new $java.oncie_Expression$$anonfun$arguments$1$applyOrElse$lambda$_0_0;
        $default.$_0642 = $x1;
        return $default;
    };
    $java.sc_StringView = function() {
        sc_AbstractIndexedSeqView.call(this);
        this.$s0 = null;
    };
    $java.sc_StringView_length = function($this) {
        return jl_String_length($this.$s0);
    };
    $java.sc_StringView_apply = function($this, $i) {
        return jl_Character_valueOf(jl_String_charAt($this.$s0, $i));
    };
    $java.ju_AbstractList$SubAbstractList$SubAbstractListIterator = function() {
        var a = this; jl_Object.call(a);
        a.$subList = null;
        a.$iterator4 = null;
        a.$start9 = 0;
        a.$end6 = 0;
    };
    $java.ju_AbstractList$SubAbstractList$SubAbstractListIterator_hasNext = function($this) {
        return $this.$iterator4.$i6 >= $this.$end6 ? 0 : 1;
    };
    $java.ju_AbstractList$SubAbstractList$SubAbstractListIterator_next = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$iterator4;
        var$2 = var$1.$i6;
        if (var$2 >= $this.$end6) {
            var$1 = new ju_NoSuchElementException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        var$3 = var$1.$lastModCount;
        var$4 = var$1.$this$041;
        if (var$3 < var$4.$modCount) {
            var$1 = new ju_ConcurrentModificationException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        if (var$2 != var$1.$sz) {
            var$1.$j = var$2;
            var$1.$i6 = var$2 + 1 | 0;
            return ju_ArrayList_get(var$4, var$2);
        }
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_0(var$1);
        $rt_throw(var$1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_6_0() {
        jl_Object.call(this);
        this.$_0141 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_6_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultPatternStringifier_apply2(var$0.$_0141, var$1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_7_0() {
        jl_Object.call(this);
        this.$_0151 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_7_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultPatternStringifier_stringifyPredicate(var$0.$_0151, var$1);
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_7_1 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_7_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 32);
        jl_StringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_7_2 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_7_2_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_7_3 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_7_3_apply = function(var$0, var$1) {
        return var$1.$stringVal;
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_7_4 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_7_4_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_7_5 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_7_5_apply = function(var$0, var$1) {
        return var$1.$stringVal;
    };
    var onciap_DefaultPatternStringifier$apply$lambda$_7_6 = $rt_classWithoutFields();
    $java.onciap_DefaultPatternStringifier$apply$lambda$_7_6_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_8_0() {
        jl_Object.call(this);
        this.$_0142 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_8_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultPatternStringifier_stringifyPredicate(var$0.$_0142, var$1);
    };
    $java.scm_ArraySeq$ofInt = function() {
        $java.scm_ArraySeq.call(this);
        this.$array10 = null;
    };
    $java.scm_ArraySeq$ofInt_length = function($this) {
        return $this.$array10.data.length;
    };
    $java.scm_ArraySeq$ofInt_apply = function($this, $index) {
        return $this.$array10.data[$index];
    };
    $java.scm_ArraySeq$ofInt_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mIc$sp(suh_MurmurHash3$_MODULE$, $this.$array10);
    };
    $java.scm_ArraySeq$ofInt_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofInt))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals0($this.$array10, $that.$array10);
    };
    $java.scm_ArraySeq$ofInt_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcI$sp__init_($this.$array10);
    };
    $java.scm_ArraySeq$ofInt_apply0 = function($this, $v1) {
        return jl_Integer_valueOf($java.scm_ArraySeq$ofInt_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofInt_apply1 = function($this, $i) {
        return jl_Integer_valueOf($java.scm_ArraySeq$ofInt_apply($this, $i));
    };
    $java.scm_ArraySeq$ofInt_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Int0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofInt_array = function($this) {
        return $this.$array10;
    };
    $java.scm_ArraySeq$ofDouble = function() {
        $java.scm_ArraySeq.call(this);
        this.$array11 = null;
    };
    $java.scm_ArraySeq$ofDouble_length = function($this) {
        return $this.$array11.data.length;
    };
    $java.scm_ArraySeq$ofDouble_apply = function($this, $index) {
        return $this.$array11.data[$index];
    };
    $java.scm_ArraySeq$ofDouble_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mDc$sp(suh_MurmurHash3$_MODULE$, $this.$array11);
    };
    $java.scm_ArraySeq$ofDouble_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofDouble))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals5($this.$array11, $that.$array11);
    };
    $java.scm_ArraySeq$ofDouble_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcD$sp__init_($this.$array11);
    };
    $java.scm_ArraySeq$ofDouble_apply0 = function($this, $v1) {
        return jl_Double_valueOf($java.scm_ArraySeq$ofDouble_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofDouble_apply1 = function($this, $i) {
        return jl_Double_valueOf($java.scm_ArraySeq$ofDouble_apply($this, $i));
    };
    $java.scm_ArraySeq$ofDouble_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Double0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofDouble_array = function($this) {
        return $this.$array11;
    };
    $java.scm_ArraySeq$ofLong = function() {
        $java.scm_ArraySeq.call(this);
        this.$array12 = null;
    };
    $java.scm_ArraySeq$ofLong_length = function($this) {
        return $this.$array12.data.length;
    };
    $java.scm_ArraySeq$ofLong_apply = function($this, $index) {
        return $this.$array12.data[$index];
    };
    $java.scm_ArraySeq$ofLong_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mJc$sp(suh_MurmurHash3$_MODULE$, $this.$array12);
    };
    $java.scm_ArraySeq$ofLong_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofLong))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals($this.$array12, $that.$array12);
    };
    $java.scm_ArraySeq$ofLong_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcJ$sp__init_($this.$array12);
    };
    $java.scm_ArraySeq$ofLong_apply0 = function($this, $v1) {
        return jl_Long_valueOf($java.scm_ArraySeq$ofLong_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofLong_apply1 = function($this, $i) {
        return jl_Long_valueOf($java.scm_ArraySeq$ofLong_apply($this, $i));
    };
    $java.scm_ArraySeq$ofLong_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Long0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofLong_array = function($this) {
        return $this.$array12;
    };
    $java.scm_ArraySeq$ofFloat = function() {
        $java.scm_ArraySeq.call(this);
        this.$array13 = null;
    };
    $java.scm_ArraySeq$ofFloat_length = function($this) {
        return $this.$array13.data.length;
    };
    $java.scm_ArraySeq$ofFloat_apply = function($this, $index) {
        return $this.$array13.data[$index];
    };
    $java.scm_ArraySeq$ofFloat_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mFc$sp(suh_MurmurHash3$_MODULE$, $this.$array13);
    };
    $java.scm_ArraySeq$ofFloat_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofFloat))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals4($this.$array13, $that.$array13);
    };
    $java.scm_ArraySeq$ofFloat_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcF$sp__init_($this.$array13);
    };
    $java.scm_ArraySeq$ofFloat_apply0 = function($this, $v1) {
        return jl_Float_valueOf($java.scm_ArraySeq$ofFloat_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofFloat_apply1 = function($this, $i) {
        return jl_Float_valueOf($java.scm_ArraySeq$ofFloat_apply($this, $i));
    };
    $java.scm_ArraySeq$ofFloat_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Float0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofFloat_array = function($this) {
        return $this.$array13;
    };
    $java.scm_ArraySeq$ofByte = function() {
        $java.scm_ArraySeq.call(this);
        this.$array14 = null;
    };
    $java.scm_ArraySeq$ofByte_length = function($this) {
        return $this.$array14.data.length;
    };
    $java.scm_ArraySeq$ofByte_apply = function($this, $index) {
        return $this.$array14.data[$index];
    };
    $java.scm_ArraySeq$ofByte_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mBc$sp(suh_MurmurHash3$_MODULE$, $this.$array14);
    };
    $java.scm_ArraySeq$ofByte_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofByte))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals3($this.$array14, $that.$array14);
    };
    $java.scm_ArraySeq$ofByte_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcB$sp__init_($this.$array14);
    };
    $java.scm_ArraySeq$ofByte_apply0 = function($this, $v1) {
        return jl_Byte_valueOf($java.scm_ArraySeq$ofByte_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofByte_apply1 = function($this, $i) {
        return jl_Byte_valueOf($java.scm_ArraySeq$ofByte_apply($this, $i));
    };
    $java.scm_ArraySeq$ofByte_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Byte0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofByte_array = function($this) {
        return $this.$array14;
    };
    $java.scm_ArraySeq$ofShort = function() {
        $java.scm_ArraySeq.call(this);
        this.$array15 = null;
    };
    $java.scm_ArraySeq$ofShort_length = function($this) {
        return $this.$array15.data.length;
    };
    $java.scm_ArraySeq$ofShort_apply = function($this, $index) {
        return $this.$array15.data[$index];
    };
    $java.scm_ArraySeq$ofShort_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mSc$sp(suh_MurmurHash3$_MODULE$, $this.$array15);
    };
    $java.scm_ArraySeq$ofShort_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofShort))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals1($this.$array15, $that.$array15);
    };
    $java.scm_ArraySeq$ofShort_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcS$sp__init_($this.$array15);
    };
    $java.scm_ArraySeq$ofShort_apply0 = function($this, $v1) {
        return jl_Short_valueOf($java.scm_ArraySeq$ofShort_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofShort_apply1 = function($this, $i) {
        return jl_Short_valueOf($java.scm_ArraySeq$ofShort_apply($this, $i));
    };
    $java.scm_ArraySeq$ofShort_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Short0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofShort_array = function($this) {
        return $this.$array15;
    };
    $java.scm_ArraySeq$ofBoolean = function() {
        $java.scm_ArraySeq.call(this);
        this.$array16 = null;
    };
    $java.scm_ArraySeq$ofBoolean_length = function($this) {
        return $this.$array16.data.length;
    };
    $java.scm_ArraySeq$ofBoolean_apply = function($this, $index) {
        return $this.$array16.data[$index];
    };
    $java.scm_ArraySeq$ofBoolean_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mZc$sp(suh_MurmurHash3$_MODULE$, $this.$array16);
    };
    $java.scm_ArraySeq$ofBoolean_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofBoolean))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        return ju_Arrays_equals6($this.$array16, $that.$array16);
    };
    $java.scm_ArraySeq$ofBoolean_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcZ$sp__init_($this.$array16);
    };
    $java.scm_ArraySeq$ofBoolean_apply0 = function($this, $v1) {
        return jl_Boolean_valueOf($java.scm_ArraySeq$ofBoolean_apply($this, sr_BoxesRunTime_unboxToInt($v1)));
    };
    $java.scm_ArraySeq$ofBoolean_apply1 = function($this, $i) {
        return jl_Boolean_valueOf($java.scm_ArraySeq$ofBoolean_apply($this, $i));
    };
    $java.scm_ArraySeq$ofBoolean_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Boolean0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofBoolean_array = function($this) {
        return $this.$array16;
    };
    $java.scm_ArraySeq$ofUnit = function() {
        $java.scm_ArraySeq.call(this);
        this.$array17 = null;
    };
    $java.scm_ArraySeq$ofUnit_length = function($this) {
        return $this.$array17.data.length;
    };
    $java.scm_ArraySeq$ofUnit_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_arraySeqHash$mVc$sp(suh_MurmurHash3$_MODULE$, $this.$array17);
    };
    $java.scm_ArraySeq$ofUnit_equals = function($this, $that) {
        if (!($that instanceof $java.scm_ArraySeq$ofUnit))
            return $java.scm_ArraySeq_equals($this, $that);
        $that = $that;
        if ($this.$array17.data.length != $that.$array17.data.length)
            return 0;
        return 1;
    };
    $java.scm_ArraySeq$ofUnit_iterator = function($this) {
        return sc_ArrayOps$ArrayIterator$mcV$sp__init_($this.$array17);
    };
    $java.scm_ArraySeq$ofUnit_apply = function($this, $v1) {
        sr_BoxesRunTime_unboxToInt($v1);
        return sr_BoxedUnit_UNIT;
    };
    $java.scm_ArraySeq$ofUnit_apply0 = function($this, $i) {
        return sr_BoxedUnit_UNIT;
    };
    $java.scm_ArraySeq$ofUnit_elemTag = function($this) {
        sr_ClassTag$_$callClinit();
        return sr_ClassTag$_Unit0(sr_ClassTag$_MODULE$);
    };
    $java.scm_ArraySeq$ofUnit_array = function($this) {
        return $this.$array17;
    };
    var oncia_SingleNamedGraphScope = $rt_classWithoutFields();
    var oncil_LabelExpression$Conjunctions$ = $rt_classWithoutFields();
    var oncil_LabelExpression$Conjunctions$_MODULE$ = null;
    function oncil_LabelExpression$Conjunctions$__clinit_() {
        oncil_LabelExpression$Conjunctions$_MODULE$ = new oncil_LabelExpression$Conjunctions$;
    }
    function oncil_LabelExpression$Conjunctions$_flat($this, $lhs, $rhs, $position, $containsIs) {
        var var$5;
        var$5 = new oncil_LabelExpression$Conjunctions;
        s_package$_$callClinit();
        $java.oncil_LabelExpression$Conjunctions__init_0(var$5, (s_package$_Vector0(s_package$_MODULE$)).$from0(sr_ScalaRunTime$_wrapRefArray(sr_ScalaRunTime$_MODULE$, $rt_createArrayFromData($java.oncil_LabelExpression, [$lhs, $rhs]))), $containsIs, $position);
        return $java.oncil_LabelExpression$Conjunctions_unnestConjunctions(var$5);
    }
    $java.oncie_Expression$TreeAcc$inScope$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0533 = null;
    };
    $java.oncie_Expression$TreeAcc$inScope$lambda$_4_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$contains0(var$0.$_0533));
    };
    $java.oncias_package$$liftSemanticErrorDef$lambda$_6_0 = function() {
        jl_Object.call(this);
        this.$_0372 = null;
    };
    $java.oncias_package$$liftSemanticErrorDef$lambda$_6_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0372;
        return oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, var$1, var$2);
    };
    $java.oncias_SemanticExpressionCheck$$check$lambda$_51_0 = function() {
        jl_Object.call(this);
        this.$_0467 = null;
    };
    $java.oncias_SemanticExpressionCheck$$check$lambda$_51_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0467;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpressionForLegacyRelationshipTypeDisjunction$lambda$_46_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0462 = null;
        a.$_1143 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpressionForLegacyRelationshipTypeDisjunction$lambda$_46_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0462;
        var$3 = var$0.$_1143;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$4 = oncias_package$_MODULE$;
        var$5 = new $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpressionForLegacyRelationshipTypeDisjunction$1$lambda$_176_0;
        var$5.$_0643 = var$2;
        var$5.$_1197 = var$3;
        var$5.$_263 = var$1;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$4, var$5);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$dispatch$lambda$_8_0() {
        jl_Object.call(this);
        this.$_0644 = null;
    }
    function onciap_Prettifier$IndentingQueryPrettifier$dispatch$lambda$_8_0__init_(var_0) {
        var var_1 = new onciap_Prettifier$IndentingQueryPrettifier$dispatch$lambda$_8_0();
        $java.onciap_Prettifier$IndentingQueryPrettifier$dispatch$lambda$_8_0__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$dispatch$lambda$_8_0__init_ = function(var$0, var$1) {
        var$0.$_0644 = var$1;
    };
    $java.oncie_VariableGrouping = function() {
        var a = this; jl_Object.call(a);
        a.$singleton = null;
        a.$group0 = null;
        a.$position296 = null;
    };
    $java.oncie_VariableGrouping__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.oncie_VariableGrouping();
        $java.oncie_VariableGrouping__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncie_VariableGrouping_position = function($this) {
        return $this.$position296;
    };
    $java.oncie_VariableGrouping_productPrefix = function($this) {
        return $rt_s(3171);
    };
    $java.oncie_VariableGrouping_productArity = function($this) {
        return 2;
    };
    $java.oncie_VariableGrouping_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$singleton;
            case 1:
                return $this.$group0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_VariableGrouping_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_VariableGrouping_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_VariableGrouping_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_VariableGrouping_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncie_VariableGrouping) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$singleton;
                        var$3 = $x$1.$singleton;
                        if (var$2 !== null) {
                            if (!$java.oncie_Variable_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$group0;
                        $x$1 = $x$1.$group0;
                        if (var$3 !== null) {
                            if (!$java.oncie_Variable_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncie_VariableGrouping))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_VariableGrouping_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncie_VariableGrouping__init_0 = function($this, $singleton, $group, $position) {
        $this.$singleton = $singleton;
        $this.$group0 = $group;
        $this.$position296 = $position;
    };
    $java.oncias_SemanticFunctionCheck$$anonfun$checkNoNestedAggregateFunctions$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncias_SemanticFunctionCheck$$anonfun$checkNoNestedAggregateFunctions$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        if ($java.oncie_Expression_containsAggregate($x))
            $default = ($java.oncie_Expression_findAggregate($x)).$get0();
        return $default;
    };
    $java.oncias_SemanticFunctionCheck$$checkNoNestedAggregateFunctions$lambda$_41_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$checkNoNestedAggregateFunctions$lambda$_41_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticAnalysisTooling_error$($java.oncias_SemanticFunctionCheck$_MODULE$, $rt_s(3172), var$1.$position2());
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkInnerPredicate$lambda$_5_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0579 = null;
        a.$_1178 = null;
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkInnerPredicate$lambda$_5_0_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0579;
        var$2 = var$0.$_1178;
        var$3 = oncias_package$_MODULE$;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_declareVariable$0(oncias_SemanticExpressionCheck$_MODULE$, var$1.$variable2(), $java.oncias_SemanticExpressionCheck$FilteringExpressions$_possibleInnerTypes($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, var$1), s_None$_MODULE$, 0)), oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, $java.oncie_Expression$SemanticContext$Simple$_MODULE$,
        var$2)), oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$FilteringExpressions$$$anonfun$checkInnerPredicate$1$lambda$_12_0, var$2));
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_0 = function() {
        jl_Object.call(this);
        this.$_0599 = null;
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0599;
        oncias_SemanticPatternCheck$_$callClinit();
        if (!jl_Object_equals($java.oncie_Pattern$SemanticContext$Expression$_MODULE$, var$2)) {
            var$3 = oncias_package$_MODULE$;
            var$4 = oncias_SemanticPatternCheck$_MODULE$;
            oncius_package$_$callClinit();
            var$1 = $java.oncias_package$_liftSemanticEitherFunc(var$3, $java.oncias_SemanticPatternCheck$_implicitVariable(var$4, var$1, oncius_package$_CTNode(oncius_package$_MODULE$)));
        } else
            var$1 = oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_ensureDefined$(oncias_SemanticPatternCheck$_MODULE$, var$1)), oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticPatternCheck$_MODULE$, new $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$2$lambda$_124_0, var$1));
        return var$1;
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_1 = function() {
        jl_Object.call(this);
        this.$_0600 = null;
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0600;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncias_SemanticPatternCheck$_declareVariables0(oncias_SemanticPatternCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_2 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_2_apply = function(var$0, var$1, var$2) {
        var$1 = var$1;
        var$2 = var$2;
        oncias_SemanticPatternCheck$_$callClinit();
        return var$1.$chain(var$2);
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_3 = function() {
        var a = this; jl_Object.call(a);
        a.$_0601 = null;
        a.$_1187 = null;
        a.$_262 = null;
        a.$_314 = null;
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_3_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0601;
        var$2 = var$0.$_1187;
        var$3 = var$0.$_262;
        var$4 = var$0.$_314;
        oncias_SemanticPatternCheck$_$callClinit();
        var$1 = $java.oncias_SemanticPatternCheck$_declareVariables0(oncias_SemanticPatternCheck$_MODULE$, var$1, var$2.$element());
        var$5 = oncias_SemanticPatternCheck$_MODULE$;
        var$1 = var$1.$chain(!(var$2 instanceof oncie_NamedPatternPart) ? oncias_SemanticCheck$_success : oncias_SemanticAnalysisTooling_error$(var$5, $rt_s(3173), var$2.$position188));
        var$2 = new $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$6$lambda$_129_0;
        var$2.$_0645 = var$3;
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_ifOkChain$(var$1, var$2), oncias_SemanticAnalysisTooling_recordCurrentScope$(oncias_SemanticPatternCheck$_MODULE$, var$4));
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_4 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_4_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_package$_MODULE$;
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = var$1.$group0;
        var$5 = new $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$9$lambda$_131_0;
        var$5.$_0646 = var$1;
        return $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_declareVariable$0(var$3, var$4, var$5, s_None$_MODULE$, 0));
    };
    var oncie_Pattern$SemanticContext$Merge$ = $rt_classWithoutFields();
    $java.oncie_Pattern$SemanticContext$Merge$_MODULE$ = null;
    function oncie_Pattern$SemanticContext$Merge$__clinit_() {
        $java.oncie_Pattern$SemanticContext$Merge$_MODULE$ = new oncie_Pattern$SemanticContext$Merge$;
    }
    $java.oncie_Pattern$SemanticContext$Merge$_name = function($this) {
        return $java.oncie_Pattern$SemanticContext_name$($this);
    };
    $java.oncie_Pattern$SemanticContext$Merge$_description = function($this) {
        return $java.oncie_Pattern$SemanticContext_description$($this);
    };
    $java.oncie_Pattern$SemanticContext$Merge$_productArity = function($this) {
        return 0;
    };
    $java.oncie_Pattern$SemanticContext$Merge$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Pattern$SemanticContext$Merge$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$SemanticContext$Merge$_hashCode = function($this) {
        return 74232856;
    };
    $java.oncie_Pattern$SemanticContext$Merge$_toString = function($this) {
        return $rt_s(2065);
    };
    var oncie_Pattern$SemanticContext$Create$ = $rt_classWithoutFields();
    $java.oncie_Pattern$SemanticContext$Create$_MODULE$ = null;
    function oncie_Pattern$SemanticContext$Create$__clinit_() {
        $java.oncie_Pattern$SemanticContext$Create$_MODULE$ = new oncie_Pattern$SemanticContext$Create$;
    }
    $java.oncie_Pattern$SemanticContext$Create$_name = function($this) {
        return $java.oncie_Pattern$SemanticContext_name$($this);
    };
    $java.oncie_Pattern$SemanticContext$Create$_description = function($this) {
        return $java.oncie_Pattern$SemanticContext_description$($this);
    };
    $java.oncie_Pattern$SemanticContext$Create$_productArity = function($this) {
        return 0;
    };
    $java.oncie_Pattern$SemanticContext$Create$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncie_Pattern$SemanticContext$Create$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncie_Pattern$SemanticContext$Create$_hashCode = function($this) {
        return 2026540316;
    };
    $java.oncie_Pattern$SemanticContext$Create$_toString = function($this) {
        return $rt_s(2035);
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkNoQuantifiedPatterns$1$1 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$x5$1 = null;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkNoQuantifiedPatterns$1$1_applyOrElse = function($this, $x1, $default) {
        var var$3, var$4;
        if (!($x1 instanceof oncie_QuantifiedPath))
            return s_PartialFunction$$anon$1_apply($default, $x1);
        $x1 = $x1;
        $default = new oncias_SemanticError;
        var$3 = $this.$x5$1.$name13;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(var$4, var$3), $rt_s(3174));
        oncias_SemanticError__init_($default, jl_AbstractStringBuilder_toString(var$4), $x1.$position228);
        return $default;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkNoQuantifiedPatterns$1$1_isDefinedAt = function($this, $x1) {
        if (!($x1 instanceof oncie_QuantifiedPath))
            return 0;
        return 1;
    };
    $java.oncias_SemanticPatternCheck$$checkContainsSingle$1$lambda$_83_0 = function() {
        jl_Object.call(this);
        this.$_0591 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkContainsSingle$1$lambda$_83_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0591;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = new oncias_SemanticError;
        var$4 = var$2.$name13;
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, var$4), $rt_s(3175)), var$1), $rt_s(3176));
        oncias_SemanticError__init_(var$3, jl_AbstractStringBuilder_toString(var$5), var$2.$position42);
        return var$3;
    };
    $java.onciu_UnboundedShortestPathNotification = function() {
        var a = this; jl_Object.call(a);
        a.$position295 = null;
        a.$pattern12 = null;
    };
    $java.onciu_UnboundedShortestPathNotification_productPrefix = function($this) {
        return $rt_s(3177);
    };
    $java.onciu_UnboundedShortestPathNotification_productArity = function($this) {
        return 2;
    };
    $java.onciu_UnboundedShortestPathNotification_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position295;
            case 1:
                return $this.$pattern12;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_UnboundedShortestPathNotification_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnboundedShortestPathNotification_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnboundedShortestPathNotification_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnboundedShortestPathNotification_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.onciu_UnboundedShortestPathNotification) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position295;
                        var$3 = $x$1.$position295;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$pattern12;
                        $x$1 = $x$1.$pattern12;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.onciu_UnboundedShortestPathNotification))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncias_SemanticPatternCheck$$checkRelVariablesUnknown$1$lambda$_88_0 = function() {
        jl_Object.call(this);
        this.$_0592 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkRelVariablesUnknown$1$lambda$_88_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0592;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = var$2.$element3;
        if (!(var$3 instanceof oncie_RelationshipChain))
            var$1 = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
        else {
            var$4 = var$3.$relationship1;
            var$5 = var$4.$variable12;
            var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$11$lambda$_87_0;
            var$3.$_0647 = var$1;
            var$3 = s_Option_flatMap(var$5, var$3);
            if (var$3 instanceof s_Some && ($java.oncias_Symbol_references(var$3.$value5)).$size() > 1) {
                var$5 = oncias_SemanticCheckResult$_MODULE$;
                var$3 = new oncias_SemanticError;
                var$6 = var$2.$name13;
                var$2 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$2);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(3178)), var$6), $rt_s(3112));
                oncias_SemanticError__init_(var$3, jl_AbstractStringBuilder_toString(var$2), var$4.$position32);
                var$1 = oncias_SemanticCheckResult$_error(var$5, var$1, var$3);
            } else
                var$1 = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
        }
        return var$1;
    };
    var oncias_checkNoParamMapsWhenMatching$ = $rt_classWithoutFields();
    $java.oncias_checkNoParamMapsWhenMatching$_MODULE$ = null;
    function oncias_checkNoParamMapsWhenMatching$__clinit_() {
        $java.oncias_checkNoParamMapsWhenMatching$_MODULE$ = new oncias_checkNoParamMapsWhenMatching$;
    }
    $java.oncias_checkNoParamMapsWhenMatching$_apply = function($this, $properties, $ctx) {
        var $e, var$4, var$5, var$6;
        a: {
            $e = s_Tuple2__init_($properties, $ctx);
            $properties = $e.$_10;
            $ctx = $e.$_20;
            if ($properties instanceof s_Some) {
                $e = $properties.$value5;
                if ($rt_isInstance($e, oncie_Parameter)) {
                    b: {
                        $properties = $e;
                        $e = $java.oncie_Pattern$SemanticContext$Match$_MODULE$;
                        if ($ctx !== null) {
                            if (jl_Object_equals($ctx, $e))
                                break a;
                            else
                                break b;
                        }
                        if ($e === null)
                            break a;
                    }
                    c: {
                        $e = $java.oncie_Pattern$SemanticContext$Merge$_MODULE$;
                        if ($ctx !== null) {
                            if (!jl_Object_equals($ctx, $e))
                                break c;
                            else
                                break a;
                        }
                        if ($e === null)
                            break a;
                    }
                }
            }
            return $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
        }
        $e = oncias_package$_MODULE$;
        var$4 = new oncias_SemanticError;
        $ctx = $ctx.$name3();
        var$5 = $properties.$name10;
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(3179)), $ctx), $rt_s(3180)), var$5), $rt_s(3181));
        oncias_SemanticError__init_(var$4, jl_AbstractStringBuilder_toString(var$6), $properties.$position14);
        return oncias_package$_liftSemanticErrorDef($e, var$4);
    };
    var oncias_checkValidPropertyKeyNamesInPattern$ = $rt_classWithoutFields();
    $java.oncias_checkValidPropertyKeyNamesInPattern$_MODULE$ = null;
    function oncias_checkValidPropertyKeyNamesInPattern$__clinit_() {
        $java.oncias_checkValidPropertyKeyNamesInPattern$_MODULE$ = new oncias_checkValidPropertyKeyNamesInPattern$;
    }
    $java.oncias_checkValidPropertyKeyNamesInPattern$_apply = function($this, $properties) {
        var $e;
        if ($properties instanceof s_Some) {
            $e = $properties.$value5;
            if ($e instanceof oncie_MapExpression) {
                $properties = $e;
                oncias_SemanticPatternCheck$_$callClinit();
                return $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNames(oncias_SemanticPatternCheck$_MODULE$, $properties.$items5.$map1(new $java.oncias_checkValidPropertyKeyNamesInPattern$$apply$lambda$_1_0));
            }
        }
        return $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
    };
    $java.oncias_SemanticPatternCheck$$checkIsKeyword$lambda$_67_0 = function() {
        jl_Object.call(this);
        this.$_0605 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkIsKeyword$lambda$_67_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0605;
                    oncias_SemanticPatternCheck$_$callClinit();
                    var$3 = oncias_SemanticCheck$_MODULE$;
                    if (var$1.$containsIs6()) {
                        d: {
                            var$4 = $java.oncie_Pattern$SemanticContext$Match$_MODULE$;
                            if (var$2 !== null) {
                                if (jl_Object_equals(var$2, var$4))
                                    break c;
                                else
                                    break d;
                            }
                            if (var$4 === null)
                                break c;
                        }
                        var$4 = $java.oncie_Pattern$SemanticContext$Expression$_MODULE$;
                        if (var$2 !== null) {
                            if (jl_Object_equals(var$2, var$4))
                                break c;
                            else
                                break b;
                        }
                        if (var$4 !== null)
                            break b;
                    }
                }
                var$5 = 0;
                break a;
            }
            var$5 = 1;
        }
        var$4 = new $java.oncias_SemanticPatternCheck$$$anonfun$checkIsKeyword$1$lambda$_152_0;
        var$4.$_0648 = var$2;
        var$4.$_1198 = var$1;
        return oncias_SemanticCheck$_when(var$3, var$5, var$4);
    };
    $java.oncias_SemanticPatternCheck$$checkLabelExpressions$lambda$_66_0 = function() {
        jl_Object.call(this);
        this.$_0604 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkLabelExpressions$lambda$_66_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0604;
                    oncias_SemanticPatternCheck$_$callClinit();
                    var$3 = oncias_SemanticCheck$_MODULE$;
                    if (var$1.$containsGpmSpecificLabelExpression()) {
                        d: {
                            var$4 = $java.oncie_Pattern$SemanticContext$Match$_MODULE$;
                            if (var$2 !== null) {
                                if (jl_Object_equals(var$2, var$4))
                                    break c;
                                else
                                    break d;
                            }
                            if (var$4 === null)
                                break c;
                        }
                        var$4 = $java.oncie_Pattern$SemanticContext$Expression$_MODULE$;
                        if (var$2 !== null) {
                            if (jl_Object_equals(var$2, var$4))
                                break c;
                            else
                                break b;
                        }
                        if (var$4 !== null)
                            break b;
                    }
                }
                var$5 = 0;
                break a;
            }
            var$5 = 1;
        }
        var$4 = new $java.oncias_SemanticPatternCheck$$$anonfun$checkLabelExpressions$1$lambda$_150_0;
        var$4.$_0649 = var$2;
        var$4.$_1199 = var$1;
        var$3 = oncias_SemanticCheck$_when(var$3, var$5, var$4);
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$3.$chain($java.oncias_SemanticExpressionCheck$_checkLabelExpression(oncias_SemanticExpressionCheck$_MODULE$, s_Some__init_(oncie_NODE_TYPE$_MODULE$), var$1));
    };
    $java.oncias_SemanticPatternCheck$$checkPredicate$lambda$_65_0 = function() {
        jl_Object.call(this);
        this.$_0603 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkPredicate$lambda$_65_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0603;
                    oncias_SemanticPatternCheck$_$callClinit();
                    var$3 = oncias_SemanticCheck$_MODULE$;
                    var$4 = $java.oncie_Pattern$SemanticContext$Match$_MODULE$;
                    if (var$2 !== null) {
                        if (jl_Object_equals(var$2, var$4))
                            break c;
                        else
                            break b;
                    }
                    if (var$4 !== null)
                        break b;
                }
                var$5 = 0;
                break a;
            }
            var$5 = 1;
        }
        var$4 = new $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_0;
        var$4.$_0650 = var$2;
        var$4.$_1200 = var$1;
        var$2 = oncias_SemanticCheck$_when(var$3, var$5, var$4);
        var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_1;
        var$3.$_0651 = var$1;
        return var$2.$ifOkChain(var$3);
    };
    $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_0_apply = function(var$0, var$1) {
        return $java.oncias_SemanticPatternCheck$_$anonfun$checkValidJuxtaposition$1(var$1);
    };
    $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_1 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_1_apply = function(var$0, var$1, var$2) {
        var$1 = var$1;
        var$2 = var$2;
        oncias_SemanticPatternCheck$_$callClinit();
        return var$1.$chain(var$2);
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1_applyOrElse = function($this, $x1, $default) {
        if ($x1 instanceof oncie_QuantifiedPath) {
            $x1 = $x1;
            $default = new $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_0;
            $default.$_0652 = $x1;
            return $default;
        }
        if ($x1 instanceof oncie_ShortestPathsPatternPart) {
            $x1 = $x1;
            $default = new $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_1;
            $default.$_0653 = $x1;
            return $default;
        }
        if ($x1 instanceof oncie_RelationshipPattern) {
            $default = $x1;
            if ($default.$length2 instanceof s_Some) {
                $x1 = new $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_2;
                $x1.$_0654 = $default;
                return $x1;
            }
        }
        if (!$rt_isInstance($x1, oncia_FullSubqueryExpression))
            return s_PartialFunction$_fallback_fn;
        return new $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_3;
    };
    $java.oncias_SemanticPatternCheck$$checkRelCount$1$lambda$_95_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0607 = null;
        a.$_1188 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkRelCount$1$lambda$_95_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        a: {
            var$1 = var$0.$_0607;
            var$2 = var$0.$_1188;
            oncias_SemanticPatternCheck$_$callClinit();
            var$3 = onciap_DefaultPatternStringifier_apply4(($java.oncias_SemanticPatternCheck$_stringifier0(oncias_SemanticPatternCheck$_MODULE$)).$patterns, var$1);
            var$4 = onciu_Foldable_folder$(var$2);
            sr_ClassTag$_$callClinit();
            switch ((onciu_Foldable$Folder_findAllByClass(var$4, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_NodePattern)))).$length()) {
                case 1:
                    break;
                default:
                    var$2 = $rt_s(2459);
                    break a;
            }
            var$2 = $rt_s(3182);
        }
        var$5 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(3183)), var$3), $rt_s(3184)), var$2), 46);
        return oncias_SemanticAnalysisTooling_error$(var$5, sc_StringOps$_stripMargin$extension(var$4, jl_AbstractStringBuilder_toString(var$6)), var$1.$position228);
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0 = function() {
        jl_Object.call(this);
        this.$_0655 = null;
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0__init_ = function(var_0) {
        var var_1 = new $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0();
        $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0__init_0 = function(var$0, var$1) {
        var$0.$_0655 = var$1;
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0_apply = function(var$0) {
        return var$0.$_0655.$specified;
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1 = function() {
        jl_Object.call(this);
        this.$_0656 = null;
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1__init_ = function(var_0) {
        var var_1 = new $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1();
        $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1__init_0 = function(var$0, var$1) {
        var$0.$_0656 = var$1;
    };
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0656.$specified;
        var$3 = oncius_TypeSpec_intersect(var$2, var$1);
        if (!oncius_TypeSpec_nonEmpty(var$3))
            var$3 = oncius_TypeSpec_intersect($java.oncius_TypeSpec_coercions(var$2), var$1);
        return var$3;
    };
    $java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0__init_ = function() {
        var var_0 = new $java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0();
        $java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0__init_0(var_0);
        return var_0;
    };
    $java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0__init_0 = function(var$0) {};
    $java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0_apply = function(var$0, var$1) {
        return var$1.$_20;
    };
    function oncias_ScopeTreeVerifier$$anonfun$$nestedInanonfun$verify$1$1() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$scope$1 = null;
        a.$root$1 = null;
    }
    $java.oncias_ScopeTreeVerifier$$anonfun$$nestedInanonfun$verify$1$1_applyOrElse = function($this, $x, $default) {
        var var$3, var$4, var$5, var$6;
        a: {
            b: {
                $x = $x;
                if ($x !== null)
                    c: {
                        var$3 = $x.$_10;
                        var$4 = $x.$_20;
                        var$5 = var$4.$name17;
                        if (var$3 !== null) {
                            if (jl_String_equals(var$3, var$5))
                                break c;
                            else
                                break b;
                        }
                        if (var$5 !== null)
                            break b;
                    }
                $x = $default.$apply($x);
                break a;
            }
            $x = onciu_Ref_toIdString(onciu_Ref$_apply(onciu_Ref$_MODULE$, $this.$scope$1));
            var$5 = $this.$root$1;
            var$6 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$6);
            jl_AbstractStringBuilder_append(var$6, 39);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, var$3), $rt_s(3185)), var$4), $rt_s(3186)), $x), $rt_s(3187)), $rt_s(66)), var$5);
            $x = jl_AbstractStringBuilder_toString(var$6);
        }
        return $x;
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_59_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0598 = null;
        a.$_1186 = null;
    };
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_59_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0598;
        var$3 = var$0.$_1186;
        oncias_SemanticPatternCheck$_$callClinit();
        if (s_Option_isEmpty(var$2.$length2)) {
            oncius_package$_$callClinit();
            var$2 = oncius_package$_CTRelationship(oncius_package$_MODULE$);
        } else {
            oncius_package$_$callClinit();
            var$2 = oncius_package$_MODULE$;
            var$2 = oncius_package$_CTList(var$2, oncius_package$_CTRelationship(var$2));
        }
        if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Match$_MODULE$, var$3))
            var$1 = $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, $java.oncias_SemanticPatternCheck$_implicitVariable(oncias_SemanticPatternCheck$_MODULE$, var$1, var$2));
        else if (!jl_Object_equals($java.oncie_Pattern$SemanticContext$Expression$_MODULE$, var$3)) {
            var$3 = oncias_package$_MODULE$;
            var$4 = oncias_SemanticPatternCheck$_MODULE$;
            oncius_package$_$callClinit();
            var$1 = $java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_declareVariable$(var$4, var$1, var$2.$invariant()));
        } else {
            var$3 = $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_ensureDefined$(oncias_SemanticPatternCheck$_MODULE$, var$1));
            var$4 = oncias_SemanticPatternCheck$_MODULE$;
            var$5 = new $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$11$lambda$_133_0;
            var$5.$_0657 = var$2;
            var$1 = oncias_SemanticCheck_chain$(var$3, oncias_SemanticAnalysisTooling_expectType$1(var$4, var$5, var$1));
        }
        return var$1;
    };
    $java.oncias_SemanticPatternCheck$$checkNoVarLengthWhenUpdating$1$lambda$_104_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0594 = null;
        a.$_1182 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkNoVarLengthWhenUpdating$1$lambda$_104_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0594;
        var$2 = var$0.$_1182;
        oncias_SemanticPatternCheck$_$callClinit();
        if (!(jl_Object_equals($java.oncie_Pattern$SemanticContext$Merge$_MODULE$, var$1) ? 1 : !jl_Object_equals($java.oncie_Pattern$SemanticContext$Create$_MODULE$, var$1) ? 0 : 1))
            var$1 = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
        else {
            var$3 = oncias_SemanticPatternCheck$_MODULE$;
            var$1 = $java.oncie_Pattern$SemanticContext$_name($java.oncie_Pattern$SemanticContext$_MODULE$, var$1);
            var$4 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$4);
            jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3188)), var$1);
            var$1 = oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position32);
        }
        return var$1;
    };
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        $java.onciu_AnonymousVariableNameGenerator$_$callClinit();
        return jl_Boolean_valueOf($java.onciu_AnonymousVariableNameGenerator$_isNamed($java.onciu_AnonymousVariableNameGenerator$_MODULE$, var$1.$name4));
    };
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_1 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return jl_Boolean_valueOf(var$1.$containsGpmSpecificRelTypeExpression() ? 0 : 1);
    };
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_2 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_2_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = var$1.$folder();
        sr_ClassTag$_$callClinit();
        return onciu_Foldable$Folder_treeFindByClass(var$2, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncil_LabelExpression$ColonDisjunction)));
    };
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_3 = function() {
        var a = this; jl_Object.call(a);
        a.$_0595 = null;
        a.$_1183 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_3_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0595;
        var$3 = var$0.$_1183;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = onciap_DefaultExpressionStringifier_stringifyLabelExpression(var$2, (var$3.$get0()).$replaceColonSyntax());
        var$4 = oncias_SemanticPatternCheck$_MODULE$;
        return oncias_SemanticAnalysisTooling_error$(var$4, $java.oncias_SemanticPatternCheck$_legacyRelationshipDisjunctionError(var$4, var$2, (var$3.$get0()).$containsIs6(), 0), var$1.$position217);
    };
    $java.oncias_SemanticPatternCheck$$checkLabelExpressions$1$lambda$_116_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0596 = null;
        a.$_1184 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkLabelExpressions$1$lambda$_116_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        a: {
            b: {
                c: {
                    d: {
                        var$1 = var$1;
                        var$2 = var$0.$_0596;
                        var$3 = var$0.$_1184;
                        oncias_SemanticPatternCheck$_$callClinit();
                        var$4 = oncias_SemanticCheck$_MODULE$;
                        var$5 = $java.oncie_Pattern$SemanticContext$Merge$_MODULE$;
                        if (var$2 !== null) {
                            if (jl_Object_equals(var$2, var$5))
                                break c;
                            else
                                break d;
                        }
                        if (var$5 === null)
                            break c;
                    }
                    var$5 = $java.oncie_Pattern$SemanticContext$Create$_MODULE$;
                    if (var$2 !== null) {
                        if (!jl_Object_equals(var$2, var$5))
                            break b;
                        else
                            break c;
                    }
                    if (var$5 !== null)
                        break b;
                }
                if (var$1.$containsGpmSpecificRelTypeExpression()) {
                    var$6 = 1;
                    break a;
                }
            }
            var$6 = 0;
        }
        var$5 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$25$lambda$_115_0;
        var$5.$_0658 = var$2;
        var$5.$_1201 = var$1;
        var$2 = oncias_SemanticCheck$_when(var$4, var$6, var$5);
        var$7 = $java.suc_TailCalls$TailRec_result($java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($java.oncil_SolvableLabelExpression$_MODULE$, var$1));
        var$6 = ((sc_AbstractIterable_toSet(var$7.$allLabels.$map1(new $java.oncil_SolvableLabelExpression$containsSolutionsForRelationship$lambda$_12_0))).$incl($java.oncil_NodeLabels$SomeUnknownLabels$_MODULE$)).$exists(var$7.$matches2);
        var$4 = oncias_SemanticCheck$_MODULE$;
        var$6 = var$6 ? 0 : 1;
        var$5 = new $java.oncias_SemanticPatternCheck$$unsatisfiableRelTypeExpression$1$lambda$_113_0;
        var$5.$_0659 = var$1;
        var$5.$_1202 = var$3;
        var$3 = var$2.$chain(oncias_SemanticCheck$_when(var$4, var$6, var$5));
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(var$3, $java.oncias_SemanticExpressionCheck$_checkLabelExpression(oncias_SemanticExpressionCheck$_MODULE$, s_Some__init_(oncie_RELATIONSHIP_TYPE$_MODULE$), var$1));
    };
    $java.oncias_SemanticPatternCheck$$checkPredicate$1$lambda$_122_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0597 = null;
        a.$_1185 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkPredicate$1$lambda$_122_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0597;
                    var$3 = var$0.$_1185;
                    oncias_SemanticPatternCheck$_$callClinit();
                    var$4 = oncias_SemanticCheck$_MODULE$;
                    var$5 = $java.oncie_Pattern$SemanticContext$Match$_MODULE$;
                    if (var$2 !== null) {
                        if (jl_Object_equals(var$2, var$5))
                            break c;
                        else
                            break b;
                    }
                    if (var$5 !== null)
                        break b;
                }
                var$6 = 0;
                break a;
            }
            var$6 = 1;
        }
        var$5 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_0;
        var$5.$_0660 = var$2;
        var$5.$_1203 = var$1;
        var$2 = oncias_SemanticCheck$_when(var$4, var$6, var$5);
        var$4 = oncias_OptionSemanticChecking$_MODULE$;
        var$5 = var$3.$length2;
        var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_1;
        var$3.$_0661 = var$1;
        var$2 = var$2.$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$4, var$5, var$3));
        var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_2;
        var$3.$_0662 = var$1;
        return oncias_SemanticCheck_ifOkChain$(var$2, var$3);
    };
    var oncie_Pattern$SemanticContext$ = $rt_classWithoutFields();
    $java.oncie_Pattern$SemanticContext$_MODULE$ = null;
    function oncie_Pattern$SemanticContext$__clinit_() {
        $java.oncie_Pattern$SemanticContext$_MODULE$ = new oncie_Pattern$SemanticContext$;
    }
    $java.oncie_Pattern$SemanticContext$_name = function($this, $ctx) {
        if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Match$_MODULE$, $ctx))
            return $rt_s(2039);
        if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Merge$_MODULE$, $ctx))
            return $rt_s(911);
        if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Create$_MODULE$, $ctx))
            return $rt_s(2026);
        if (jl_Object_equals($java.oncie_Pattern$SemanticContext$Expression$_MODULE$, $ctx))
            return $rt_s(3189);
        $rt_throw(s_MatchError__init_($ctx));
    };
    $java.onciu_NonEmptyList$reverse$lambda$_61_0 = $rt_classWithoutFields();
    $java.onciu_NonEmptyList$reverse$lambda$_61_0_apply = function(var$0, var$1) {
        s_Predef$_$callClinit();
        return var$1;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$$anonfun$applyOrElse$10$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0549 = null;
    };
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$$anonfun$applyOrElse$10$lambda$_4_0_apply = function(var$0, var$1) {
        return var$1.$appended(var$0.$_0549);
    };
    $java.oncil_LabelExpression$containsGpmSpecificRelTypeExpression$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncil_LabelExpression$containsGpmSpecificRelTypeExpression$lambda$_7_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$containsGpmSpecificRelTypeExpression());
    };
    $java.oncil_LabelExpression$replaceColonSyntax$lambda$_9_0 = $rt_classWithoutFields();
    $java.oncil_LabelExpression$replaceColonSyntax$lambda$_9_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        if (var$1 instanceof oncil_LabelExpression$ColonDisjunction) {
            var$1 = var$1;
            var$2 = var$1.$lhs3;
            var$3 = var$1.$rhs3;
            var$1 = oncil_LabelExpression$Disjunctions$_flat(oncil_LabelExpression$Disjunctions$_MODULE$, var$2, var$3, var$1.$position217, var$1.$containsIs);
        } else if (!(var$1 instanceof oncil_LabelExpression$ColonConjunction)) {
            if (var$1 instanceof oncil_LabelExpression$Disjunctions)
                var$1 = $java.oncil_LabelExpression$Disjunctions_unnestDisjunctions(var$1);
            else if (var$1 instanceof oncil_LabelExpression$Conjunctions)
                var$1 = $java.oncil_LabelExpression$Conjunctions_unnestConjunctions(var$1);
        } else {
            var$1 = var$1;
            var$2 = var$1.$lhs4;
            var$3 = var$1.$rhs4;
            var$1 = oncil_LabelExpression$Conjunctions$_flat(oncil_LabelExpression$Conjunctions$_MODULE$, var$2, var$3, var$1.$position262, var$1.$containsIs2);
        }
        return var$1;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$allSymbolDefinitions$10 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1_applyOrElse = function($this, $x1, $default) {
        var $maybeVariable, $maybeProperties, $variable;
        if ($x1 instanceof oncie_NodePattern) {
            $x1 = $x1;
            $maybeVariable = $x1.$variable11;
            $maybeProperties = $x1.$properties4;
            $x1 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_0;
            $x1.$_0663 = $this;
            $x1.$_1204 = $maybeVariable;
            $x1.$_264 = $maybeProperties;
            return $x1;
        }
        if (!($x1 instanceof oncie_RelationshipPattern)) {
            if (!($x1 instanceof oncie_NamedPatternPart))
                return s_PartialFunction$_fallback_fn;
            $variable = $x1.$variable10;
            $x1 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_2;
            $x1.$_0664 = $variable;
            return $x1;
        }
        $x1 = $x1;
        $maybeVariable = $x1.$variable12;
        $maybeProperties = $x1.$properties5;
        $x1 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_1;
        $x1.$_0665 = $this;
        $x1.$_1205 = $maybeVariable;
        $x1.$_265 = $maybeProperties;
        return $x1;
    };
    $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_0 = function() {
        jl_Object.call(this);
        this.$_0550 = null;
    };
    $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0550;
        oncius_TypeSpec$_$callClinit();
        return jl_Boolean_valueOf($java.oncius_TypeRange_contains(var$1, var$2));
    };
    $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_1 = function() {
        jl_Object.call(this);
        this.$_0551 = null;
    };
    $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0551;
        oncius_TypeSpec$_$callClinit();
        return jl_Boolean_valueOf($java.oncius_TypeRange_contains(var$2, var$1));
    };
    $java.oncie_ExpressionWithComputedDependencies$introducedVariables$lambda$_6_0 = $rt_classWithoutFields();
    $java.oncie_ExpressionWithComputedDependencies$introducedVariables$lambda$_6_0_apply = function(var$0) {
        var var$1;
        var$1 = new jl_IllegalStateException;
        jl_Throwable__init_(var$1, $rt_s(3190));
        $rt_throw(var$1);
    };
    var oncia_ReadAdministrationCommand$yields$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncia_ReadAdministrationCommand$yields$lambda$_11_0_apply = function(var$0, var$1) {
        return s_Option_map($java.su_Either$LeftProjection_toOption(su_Either_left(var$1)), new $java.oncia_ReadAdministrationCommand$$anonfun$yields$1$lambda$_23_0);
    };
    var oncia_ReadAdministrationCommand$returns$lambda$_13_0 = $rt_classWithoutFields();
    $java.oncia_ReadAdministrationCommand$returns$lambda$_13_0_apply = function(var$0, var$1) {
        return s_Option_flatMap($java.su_Either$LeftProjection_toOption(su_Either_left(var$1)), new $java.oncia_ReadAdministrationCommand$$anonfun$returns$1$lambda$_25_0);
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$9$lambda$_36_0 = function() {
        jl_Object.call(this);
        this.$_0552 = null;
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$9$lambda$_36_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0552;
        var$3 = var$1.$semanticCheck();
        var$4 = new $java.oncia_ReadAdministrationCommand$checkProjection$1$lambda$_32_0;
        var$4.$_0666 = var$1;
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_flatMap$(var$3, var$4), var$2.$recordCurrentScope(var$1));
    };
    function oncias_SemanticAnalysisTooling$expectType$lambda$_21_0() {
        var a = this; jl_Object.call(a);
        a.$_0279 = null;
        a.$_181 = null;
        a.$_230 = null;
    }
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_21_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0279;
        return var$2.$expectType3(var$1, var$0.$_181, var$0.$_230, var$2.$expectType$default$4());
    };
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_11_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0457 = null;
        a.$_1138 = null;
        a.$_253 = null;
    };
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_11_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0457;
        var$3 = var$0.$_1138;
        var$4 = var$0.$_253;
        var$5 = new $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$1$lambda$_87_0;
        var$5.$_0667 = var$3;
        var$5.$_1206 = var$1;
        return oncias_SemanticAnalysisTooling_expectType$2(var$2, var$1, var$5, var$4, oncias_SemanticAnalysisTooling_expectType$default$4$(var$2));
    };
    function oncias_SemanticAnalysisTooling$specifyType$lambda$_7_0() {
        var a = this; jl_Object.call(a);
        a.$_0275 = null;
        a.$_177 = null;
        a.$_228 = null;
    }
    $java.oncias_SemanticAnalysisTooling$specifyType$lambda$_7_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_0275;
        var$3 = var$0.$_177;
        var$4 = var$0.$_228;
        var$5 = new $java.oncias_SemanticAnalysisTooling$$anonfun$specifyType$1$lambda$_84_0;
        var$5.$_0668 = var$3;
        var$5.$_1207 = var$1;
        return $java.oncias_SemanticAnalysisTooling$specifyType$lambda$_9_0_apply(var$2.$specifyType0(var$5, var$4), var$1);
    };
    function oncias_SemanticAnalysisTooling$checkTypes$lambda$_29_0() {
        var a = this; jl_Object.call(a);
        a.$_0280 = null;
        a.$_182 = null;
        a.$_231 = null;
    }
    $java.oncias_SemanticAnalysisTooling$checkTypes$lambda$_29_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$0.$_0280;
        var$3 = var$0.$_182;
        var$4 = var$0.$_231;
        var$5 = new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_0;
        var$5.$_0669 = var$4;
        var$5 = var$3.$filter1(var$5);
        var$6 = $java.oncie_Expression_arguments(var$4);
        var$7 = s_Tuple2__init_(var$5, oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1));
        var$1 = new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_1;
        var$1.$_0670 = var$2;
        var$1 = var$6.$foldLeft(var$7, var$1);
        if (var$1 !== null) {
            var$3 = var$1.$_10;
            var$5 = var$1.$_20;
            if (var$3 !== null) {
                a: {
                    var$1 = s_Tuple2__init_(var$3, var$5);
                    var$3 = var$1.$_10;
                    var$1 = var$1.$_20;
                    if (var$3 !== null) {
                        s_package$_$callClinit();
                        s_package$_Seq(s_package$_MODULE$);
                        sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, var$3);
                        if (!var$3.$lengthCompare(0)) {
                            oncius_TypeSpec$_$callClinit();
                            var$3 = $java.oncius_TypeSpec$_all(oncius_TypeSpec$_MODULE$);
                            break a;
                        }
                    }
                    oncius_TypeSpec$_$callClinit();
                    var$3 = var$3.$foldLeft(oncius_TypeSpec$_none(oncius_TypeSpec$_MODULE$), new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_3);
                }
                var$5 = new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_2;
                var$5.$_0671 = var$3;
                var$2 = $java.oncias_SemanticAnalysisTooling$specifyType$lambda$_9_0_apply(var$2.$specifyType0(var$5, var$4), var$1.$state);
                if (!(var$2 instanceof su_Left)) {
                    if (!(var$2 instanceof su_Right))
                        $rt_throw(s_MatchError__init_(var$2));
                    var$2 = oncias_SemanticCheckResult__init_(var$2.$value10, var$1.$errors);
                } else {
                    var$3 = var$2.$value11;
                    var$2 = oncias_SemanticCheckResult__init_(var$1.$state, var$1.$errors.$appended(var$3));
                }
                return var$2;
            }
        }
        $rt_throw(s_MatchError__init_(var$1));
    };
    function oncias_SemanticAnalysisTooling$specifyType$lambda$_9_0() {
        var a = this; jl_Object.call(a);
        a.$_0276 = null;
        a.$_178 = null;
    }
    $java.oncias_SemanticAnalysisTooling$specifyType$lambda$_9_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0276;
        var$3 = var$0.$_178.$apply2();
        if (var$2 instanceof oncie_Variable)
            var$1 = oncias_SemanticState_implicitVariable(var$1, var$2, var$3);
        else {
            s_package$_$callClinit();
            var$4 = s_package$_Right(s_package$_MODULE$);
            var$2 = var$1.$typeTable.$updated1(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, var$2), oncias_ExpressionTypeInfo$_apply(oncias_ExpressionTypeInfo$_MODULE$, var$3, s_None$_MODULE$));
            var$1 = su_Right$_apply(var$4, oncias_SemanticState_copy(var$1, var$1.$currentScope, var$2, var$1.$recordedScopes, var$1.$notifications, var$1.$features1, var$1.$declareVariablesToSuppressDuplicateErrors, var$1.$semanticCheckHasRunOnce));
        }
        return var$1;
    };
    function oncias_SemanticAnalysisTooling$unionOfTypes$lambda$_37_0() {
        var a = this; jl_Object.call(a);
        a.$_0282 = null;
        a.$_184 = null;
    }
    $java.oncias_SemanticAnalysisTooling$unionOfTypes$lambda$_37_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_0282;
        var$3 = var$0.$_184;
        oncius_TypeSpec$_$callClinit();
        var$4 = oncius_TypeSpec$_MODULE$;
        var$3 = var$3.$iterator0();
        var$5 = new $java.oncias_SemanticAnalysisTooling$$anonfun$unionOfTypes$1$lambda$_108_0;
        var$5.$_0672 = var$2;
        var$5.$_1208 = var$1;
        return $java.oncius_TypeSpec$_union(var$4, sc_IterableOnceOps_toSeq$(var$3.$map7(var$5)));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$20$lambda$_80_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$20$lambda$_80_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$1.$_10;
    };
    $java.oncias_SemanticAnalysisTooling$typeSwitch$lambda$_47_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0460 = null;
        a.$_1141 = null;
    };
    $java.oncias_SemanticAnalysisTooling$typeSwitch$lambda$_47_0_apply = function(var$0, var$1) {
        return var$0.$_0460.$apply(oncias_ExpressionTypeInfo_actual(oncias_SemanticState_expressionType(var$1, var$0.$_1141)));
    };
    function oncias_SemanticCheck$ifOkChain$lambda$_19_0() {
        jl_Object.call(this);
        this.$_0257 = null;
    }
    $java.oncias_SemanticCheck$ifOkChain$lambda$_19_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0257;
        var$2 = oncias_SemanticCheck$_when(oncias_SemanticCheck$_MODULE$, var$1.$errors.$isEmpty(), var$2);
        var$3 = new $java.oncias_SemanticCheck$$anonfun$ifOkChain$1$lambda$_33_0;
        var$3.$_0673 = var$1;
        return var$2.$map12(var$3);
    };
    function oncias_SemanticAnalysisTooling$types$lambda$_77_0() {
        jl_Object.call(this);
        this.$_0290 = null;
    }
    $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply = function(var$0, var$1) {
        return oncias_ExpressionTypeInfo_actual(oncias_SemanticState_expressionType(var$1, var$0.$_0290));
    };
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_15_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0458 = null;
        a.$_1139 = null;
        a.$_254 = null;
        a.$_311 = null;
    };
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_15_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0458;
        var$3 = var$0.$_1139;
        var$4 = var$0.$_254;
        var$5 = var$0.$_311;
        var$6 = new $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$5$lambda$_91_0;
        var$6.$_0674 = var$3;
        var$6.$_1209 = var$1;
        return oncias_SemanticAnalysisTooling_expectType$2(var$2, var$1, var$6, var$4, var$5);
    };
    function oncias_SemanticAnalysisTooling$expectType$lambda$_13_0() {
        var a = this; jl_Object.call(a);
        a.$_0277 = null;
        a.$_179 = null;
    }
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_13_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0277;
        var$3 = var$0.$_179;
        var$4 = new $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$3$lambda$_89_0;
        var$4.$_0675 = var$3;
        return var$2.$expectType(var$4, var$1);
    };
    function oncias_SemanticAnalysisTooling$ensureDefined$lambda$_53_0() {
        jl_Object.call(this);
        this.$_0285 = null;
    }
    $java.oncias_SemanticAnalysisTooling$ensureDefined$lambda$_53_0_apply = function(var$0, var$1) {
        return oncias_SemanticState_ensureVariableDefined(var$1, var$0.$_0285);
    };
    $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_0 = $rt_classWithoutFields();
    $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_0_apply = function(var$0, var$1) {
        return var$1.$expression3;
    };
    $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_1 = function() {
        jl_Object.call(this);
        this.$_0382 = null;
    };
    $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_1_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = var$0.$_0382;
        return $java.oncias_SemanticCheckResult$_error0(oncias_SemanticCheckResult$_MODULE$, var$1, (var$2.$errorMessageProvider0()).$createMultipleGraphReferencesError(), (var$3.$apply1(1)).$position64);
    };
    function oncia_Clause$semanticCheck$lambda$_7_0() {
        jl_Object.call(this);
        this.$_0295 = null;
    }
    $java.oncia_Clause$semanticCheck$lambda$_7_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0295;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncia_Clause$$anonfun$semanticCheck$1$lambda$_17_0;
        var$3.$_0676 = var$1;
        var$2 = $java.oncias_SemanticCheck$_fromFunction(var$2, var$3);
        var$4 = var$1.$folder();
        s_package$_$callClinit();
        var$3 = onciu_Foldable$Folder_treeFold(var$4, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)), new $java.oncia_Clause$$anonfun$2);
        var$5 = sr_BoxesRunTime_unboxToBoolean(onciu_Foldable$Folder_treeFold(var$1.$folder(), jl_Boolean_valueOf(0), new $java.oncia_Clause$$anonfun$3));
        var$4 = oncias_SemanticCheck$_MODULE$;
        var$6 = new $java.oncia_Clause$checkIfMixingLegacyVarLengthWithQPPs$lambda$_14_0;
        var$6.$_0677 = var$1;
        var$6.$_1210 = var$3;
        return oncias_SemanticCheck_chain$(var$2, oncias_SemanticCheck$_when(var$4, var$5, var$6));
    };
    var oncir_Deprecations$semanticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1$lambda$_15_0 = $rt_classWithoutFields();
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1$lambda$_15_0_apply = function(var$0, var$1) {
        return var$1.$use;
    };
    $java.onciu_RewritableCompat$PROXY$7_250 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_250_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_250 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_250_paramsLength(var$1) {
        return (jl_Integer_valueOf(7)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_914 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_914_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncil_LabelExpression$ColonConjunction__init_(var$3[0], var$3[1], var$3[2].$value8, var$3[3]);
    }
    $java.oncius_ClosedDynamicUnionType$isAssignableFrom$lambda$_33_0 = function() {
        jl_Object.call(this);
        this.$_0398 = null;
    };
    $java.oncius_ClosedDynamicUnionType$isAssignableFrom$lambda$_33_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isAssignableFrom0(var$0.$_0398));
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_0() {
        jl_Object.call(this);
        this.$_0105 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString24(var$0.$_0105, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_1() {
        jl_Object.call(this);
        this.$_0106 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0106, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_3() {
        jl_Object.call(this);
        this.$_0107 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString23(var$0.$_0107, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_4() {
        jl_Object.call(this);
        this.$_0108 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_4_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0108, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_5 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_5_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_6() {
        jl_Object.call(this);
        this.$_0109 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_6_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString22(var$0.$_0109, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_7() {
        jl_Object.call(this);
        this.$_0110 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_7_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0110, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_8 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_8_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_9() {
        jl_Object.call(this);
        this.$_0111 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_9_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0111, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_10() {
        jl_Object.call(this);
        this.$_0112 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_10_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0112, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_11 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_11_apply = function(var$0) {
        return $rt_s(3);
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$containsGpmSpecificLabelExpression());
    };
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_0 = $rt_classWithoutFields();
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$features1.$contains0(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_MODULE$));
    };
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_1 = function() {
        jl_Object.call(this);
        this.$_0356 = null;
    };
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_1_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0356;
        var$2 = $java.oncia_UseGraph_checkGraphReference(var$1);
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = $java.oncia_UseGraph_graphReference(var$1);
        var$5 = new $java.oncia_UseGraph$checkDynamicGraphReference$lambda$_60_0;
        var$5.$_0678 = var$1;
        return var$2.$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, var$4, var$5));
    };
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_2 = function() {
        jl_Object.call(this);
        this.$_0357 = null;
    };
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_2_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0357;
        var$2 = new $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_0;
        var$3 = new $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_1;
        var$3.$_0679 = var$1;
        var$4 = new $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_2;
        var$4.$_0680 = var$1;
        return oncias_SemanticAnalysisTooling_whenState$(var$1, var$2, var$3, var$4);
    };
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_0 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, oncie_Expression$SemanticContext$Results$_MODULE$, var$1);
    };
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_1 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_1_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_2 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return ($java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, var$1.$items4, new $java.oncia_ProcedureResult$semanticCheck$lambda$_14_0)).$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension(oncias_OptionSemanticChecking$_MODULE$, var$1.$where9, new $java.oncia_ProcedureResult$semanticCheck$lambda$_14_1));
    };
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_3 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_3_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_4 = function() {
        jl_Object.call(this);
        this.$_0363 = null;
    };
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_4_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0363;
        var$3 = new $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_0;
        var$3.$_0681 = var$2;
        return (var$1.$map1(var$3)).$foldLeft(oncias_SemanticCheck$_success, new $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_1);
    };
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_5 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_5_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    $java.oncia_SubqueryCall$clauseSpecificSemanticCheck$lambda$_60_0 = function() {
        jl_Object.call(this);
        this.$_0376 = null;
    };
    $java.oncia_SubqueryCall$clauseSpecificSemanticCheck$lambda$_60_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0376;
        var$1 = $java.oncia_SubqueryCall$InTransactionsParameters_semanticCheck(var$1);
        var$3 = $java.oncia_SubqueryCall$_findTransactionalSubquery($java.oncia_SubqueryCall$_MODULE$, var$2.$innerQuery);
        var$4 = oncias_OptionSemanticChecking$_MODULE$;
        var$5 = new $java.oncia_SubqueryCall$checkNoNestedCallInTransactions$lambda$_67_0;
        var$5.$_0682 = var$2;
        return oncias_SemanticCheck_chain$(var$1, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$4, var$3, var$5));
    };
    var oncias_SemanticCheckableIterableOnce$ = $rt_classWithoutFields();
    $java.oncias_SemanticCheckableIterableOnce$_MODULE$ = null;
    function oncias_SemanticCheckableIterableOnce$__clinit_() {
        $java.oncias_SemanticCheckableIterableOnce$_MODULE$ = new oncias_SemanticCheckableIterableOnce$;
    }
    $java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension = function($this, $$this) {
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, $$this, new $java.oncias_SemanticCheckableIterableOnce$$semanticCheck$extension$lambda$_1_0);
    };
    var oncias_SemanticCheckableOption$ = $rt_classWithoutFields();
    var oncias_SemanticCheckableOption$_MODULE$ = null;
    function oncias_SemanticCheckableOption$__clinit_() {
        oncias_SemanticCheckableOption$_MODULE$ = new oncias_SemanticCheckableOption$;
    }
    function oncias_SemanticCheckableOption$_semanticCheck$extension($this, $$this) {
        return s_Option_fold($$this, new $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_0, new $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_1);
    }
    $java.oncia_Merge$clauseSpecificSemanticCheck$lambda$_65_0 = function() {
        jl_Object.call(this);
        this.$_0422 = null;
    };
    $java.oncia_Merge$clauseSpecificSemanticCheck$lambda$_65_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0422;
        if (var$1.$semanticCheckHasRunOnce)
            var$1 = oncias_SemanticCheck$_success;
        else
            a: {
                var$1 = onciu_Foldable$Folder_treeCollect(onciu_Foldable_folder$(onciu_Foldable$_FoldableAny(onciu_Foldable$_MODULE$, sci_$colon$colon__init_(var$2.$pattern3, sci_$colon$colon__init_(var$2.$actions, sci_Nil$_MODULE$)))), new $java.oncia_Merge$$anonfun$11);
                if (var$1 !== null) {
                    s_package$_$callClinit();
                    var$2 = var$1.$isEmpty() ? s_None$_MODULE$ : s_Some__init_(s_Tuple2__init_(var$1.$head(), var$1.$tail()));
                    if (!s_Option_isEmpty(var$2)) {
                        var$1 = (var$2.$get0()).$_10;
                        var$2 = oncias_SemanticCheck$_MODULE$;
                        var$3 = sr_ScalaRunTime$_MODULE$;
                        var$4 = $rt_createArray(oncias_SemanticErrorDef, 1);
                        var$4.data[0] = oncias_SemanticError__init_0($rt_s(3191), var$1.$position2());
                        var$1 = oncias_SemanticCheck$_error(var$2, sr_ScalaRunTime$_wrapRefArray(var$3, var$4));
                        break a;
                    }
                }
                var$1 = oncias_SemanticCheck$_success;
            }
        return var$1;
    };
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_0 = $rt_classWithoutFields();
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_0_apply = function(var$0) {
        var var$1;
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_TypeSpec_union($java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1))), $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$)));
    };
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_1 = function() {
        jl_Object.call(this);
        this.$_0423 = null;
    };
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_1_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0423;
        return $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, $java.oncias_SemanticExpressionCheck$FilteringExpressions$_failIfAggregating0($java.oncias_SemanticExpressionCheck$FilteringExpressions$_MODULE$, var$1.$expression7));
    };
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_2 = function() {
        jl_Object.call(this);
        this.$_0424 = null;
    };
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_2_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0424;
        var$1 = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(var$2, var$2.$expression7), var$1);
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_org$neo4j$cypher$internal$util$symbols$TypeSpec$$apply(oncius_TypeSpec$_MODULE$, var$1.$ranges.$map1(new $java.oncius_TypeSpec$unwrapPotentialLists$lambda$_27_0));
    };
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_0 = $rt_classWithoutFields();
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_0_apply = function(var$0) {
        var var$1;
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_1 = $rt_classWithoutFields();
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf($rt_isInstance(var$1, $java.oncia_UpdateClause) ? 0 : 1);
    };
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_2 = $rt_classWithoutFields();
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = new oncias_SemanticError;
        var$3 = var$1.$name3();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3192)), var$3), $rt_s(3193));
        oncias_SemanticError__init_(var$2, jl_AbstractStringBuilder_toString(var$4), var$1.$position2());
        return var$2;
    };
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_3 = function() {
        jl_Object.call(this);
        this.$_0425 = null;
    };
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_3_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0425;
        var$2 = new $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$13$lambda$_81_0;
        var$2.$_0683 = var$1;
        return oncias_SemanticAnalysisTooling_withScopedState$(var$1, var$2);
    };
    $java.oncia_LoadCSV$clauseSpecificSemanticCheck$lambda$_60_0 = $rt_classWithoutFields();
    $java.oncia_LoadCSV$clauseSpecificSemanticCheck$lambda$_60_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$));
    };
    $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_0 = function() {
        jl_Object.call(this);
        this.$_0436 = null;
    };
    $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0436;
        return oncias_SemanticAnalysisTooling_error$(var$1, $rt_s(3194), var$1.$position155);
    };
    $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_1 = function() {
        jl_Object.call(this);
        this.$_0437 = null;
    };
    $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_1_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0437;
        return oncias_SemanticAnalysisTooling_error$(var$1, $rt_s(3195), var$1.$wherePos.$get0());
    };
    $java.oncias_checkValidPropertyKeyNamesInPattern$$apply$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncias_checkValidPropertyKeyNamesInPattern$$apply$lambda$_1_0_apply = function(var$0, var$1) {
        return var$1.$_10;
    };
    $java.oncil_LabelExpression$Disjunctions$unnestDisjunctions$lambda$_13_0 = $rt_classWithoutFields();
    $java.oncil_LabelExpression$Disjunctions$unnestDisjunctions$lambda$_13_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        if (var$1 instanceof oncil_LabelExpression$Disjunctions)
            var$1 = var$1.$children;
        else {
            s_package$_$callClinit();
            var$2 = s_package$_Vector0(s_package$_MODULE$);
            var$3 = sr_ScalaRunTime$_MODULE$;
            var$4 = $rt_createArray($java.oncil_LabelExpression, 1);
            var$4.data[0] = var$1;
            var$1 = var$2.$from0(sr_ScalaRunTime$_wrapRefArray(var$3, var$4));
        }
        return var$1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_0 = function() {
        jl_Object.call(this);
        this.$_0561 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0561;
        var$2 = oncias_package$_MODULE$;
        var$3 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$4 = new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$1$lambda$_55_0;
        var$4.$_0684 = var$1;
        return $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_specifyType$(var$3, var$4, var$1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_1 = function() {
        jl_Object.call(this);
        this.$_0562 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_1_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$0.$_0562;
        var$2 = oncias_SemanticAnalysisTooling_expectType$1($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$3$lambda$_57_0, ($java.oncie_Expression_arguments(var$1)).$head());
        var$3 = ($java.oncie_Expression_arguments(var$1)).$head();
        if (var$3 instanceof oncie_PatternExpression)
            var$1 = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_None$_MODULE$);
        else if (var$3 instanceof oncie_Property ? 1 : !(var$3 instanceof oncie_ContainerIndex) ? 0 : 1)
            var$1 = $java.oncias_package$_liftSemanticErrorDefOption(oncias_package$_MODULE$, s_Some__init_(oncias_SemanticError__init_0($rt_s(3196), var$1.$position7)));
        else {
            var$4 = oncias_package$_MODULE$;
            var$5 = new s_Some;
            var$6 = new oncias_SemanticError;
            var$7 = var$1.$name22;
            var$1 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$1);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(3197)), var$7), $rt_s(3198));
            oncias_SemanticError__init_(var$6, jl_AbstractStringBuilder_toString(var$1), var$3.$position2());
            s_Some__init_0(var$5, var$6);
            var$1 = $java.oncias_package$_liftSemanticErrorDefOption(var$4, var$5);
        }
        return oncias_SemanticCheck_chain$(var$2, var$1);
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_2 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_2_apply = function(var$0) {
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_3 = function() {
        jl_Object.call(this);
        this.$_0563 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_3_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0563;
        var$2 = oncias_SemanticAnalysisTooling_expectType$1($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$6$lambda$_60_0, ($java.oncie_Expression_arguments(var$1)).$head());
        var$3 = oncias_package$_MODULE$;
        var$4 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$5 = ($java.oncie_Expression_arguments(var$1)).$head();
        var$6 = new $java.oncias_SemanticAnalysisTooling$possibleTypes$lambda$_75_0;
        var$6.$_0685 = var$4;
        var$6.$_1211 = var$5;
        return oncias_SemanticCheck_chain$(var$2, $java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_specifyType$(var$4, var$6, var$1)));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_4 = function() {
        jl_Object.call(this);
        this.$_0564 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_4_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0564;
        var$2 = oncias_SemanticAnalysisTooling_expectType$1($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$9$lambda$_64_0, ($java.oncie_Expression_arguments(var$1)).$head());
        var$3 = oncias_package$_MODULE$;
        var$4 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$5 = ($java.oncie_Expression_arguments(var$1)).$head();
        var$6 = new $java.oncias_SemanticFunctionCheck$$possibleTypes$1$lambda$_62_0;
        var$6.$_0686 = var$5;
        return oncias_SemanticCheck_chain$(var$2, $java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_specifyType$(var$4, var$6, var$1)));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_5 = function() {
        jl_Object.call(this);
        this.$_0565 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_5_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0565;
        var$2 = oncias_package$_MODULE$;
        var$3 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$4 = new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$11$lambda$_66_0;
        var$4.$_0687 = var$1;
        return $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_specifyType$(var$3, var$4, var$1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_6 = function() {
        jl_Object.call(this);
        this.$_0566 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_6_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0566;
        var$2 = oncias_package$_MODULE$;
        var$3 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$4 = new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$13$lambda$_68_0;
        var$4.$_0688 = var$1;
        return $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_specifyType$(var$3, var$4, var$1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_7 = function() {
        jl_Object.call(this);
        this.$_0567 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_7_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0567;
        return $java.oncias_SemanticFunctionCheck$_checkPercentileRange($java.oncias_SemanticFunctionCheck$_MODULE$, var$1.$args.$apply1(1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_8 = function() {
        jl_Object.call(this);
        this.$_0568 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_8_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0568;
        return $java.oncias_SemanticFunctionCheck$_checkPercentileRange($java.oncias_SemanticFunctionCheck$_MODULE$, var$1.$args.$apply1(1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_9 = function() {
        jl_Object.call(this);
        this.$_0569 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_9_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        a: {
            var$1 = var$0.$_0569;
            var$2 = $java.oncias_SemanticFunctionCheck$_MODULE$;
            var$1 = var$1.$args.$apply1(0);
            var$3 = 0;
            var$4 = null;
            if (var$1 instanceof oncie_MapExpression) {
                var$3 = 1;
                var$4 = var$1;
                if (var$4.$items5.$exists(new $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_0) && var$4.$items5.$exists(new $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_1)) {
                    var$1 = oncias_SemanticCheck$_success;
                    break a;
                }
            }
            if (var$3 && var$4.$items5.$exists(new $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_2) && var$4.$items5.$exists(new $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_3))
                var$1 = oncias_SemanticCheck$_success;
            else if (!var$3)
                var$1 = oncias_SemanticCheck$_success;
            else {
                var$1 = sc_AbstractIterable_mkString0(var$4.$items5.$map1(new $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_4), $rt_s(16));
                var$5 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$5);
                jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(3199)), var$1), $rt_s(3200));
                var$1 = oncias_SemanticAnalysisTooling_error$(var$2, jl_AbstractStringBuilder_toString(var$5), var$4.$position247);
            }
        }
        return var$1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_10 = function() {
        jl_Object.call(this);
        this.$_0570 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_10_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0570;
        var$2 = oncias_SemanticAnalysisTooling_expectType$1($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$18$lambda$_73_0, ($java.oncie_Expression_arguments(var$1)).$head());
        var$3 = oncias_package$_MODULE$;
        var$4 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        return oncias_SemanticCheck_chain$(var$2, $java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_specifyType$(var$4, oncias_SemanticAnalysisTooling_types$(var$4, ($java.oncie_Expression_arguments(var$1)).$head()), var$1)));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_11 = function() {
        jl_Object.call(this);
        this.$_0571 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_11_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0571;
        var$2 = oncias_SemanticAnalysisTooling_expectType$1($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$20$lambda$_75_0, ($java.oncie_Expression_arguments(var$1)).$apply1(0));
        var$3 = oncias_package$_MODULE$;
        var$4 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        return oncias_SemanticCheck_chain$(var$2, $java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_specifyType$(var$4, oncias_SemanticAnalysisTooling_types$(var$4, ($java.oncie_Expression_arguments(var$1)).$apply1(0)), var$1)));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_12 = function() {
        jl_Object.call(this);
        this.$_0572 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_12_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0572;
        var$2 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        var$3 = new sci_$colon$colon;
        oncius_package$_$callClinit();
        sci_$colon$colon__init_0(var$3, oncius_package$_CTString(oncius_package$_MODULE$), sci_$colon$colon__init_(oncius_package$_CTBoolean(oncius_package$_MODULE$), sci_$colon$colon__init_(oncius_package$_CTInteger(oncius_package$_MODULE$), sci_Nil$_MODULE$)));
        return $java.oncias_SemanticFunctionCheck$_checkToSpecifiedTypeOfArgument(var$2, var$1, var$3);
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_13 = function() {
        jl_Object.call(this);
        this.$_0573 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_13_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0573;
        return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$23$lambda$_78_0, var$1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_14 = function() {
        jl_Object.call(this);
        this.$_0574 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_14_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0574;
        var$2 = $java.oncias_SemanticFunctionCheck$_MODULE$;
        $java.oncief_ToString$_$callClinit();
        return $java.oncias_SemanticFunctionCheck$_checkToSpecifiedTypeOfArgument(var$2, var$1, $java.oncief_ToString$_validInputTypes);
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15 = function() {
        jl_Object.call(this);
        this.$_0689 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15();
        $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15__init_0 = function(var$0, var$1) {
        var$0.$_0689 = var$1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0689;
        return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$26$lambda$_81_0, var$1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16 = function() {
        jl_Object.call(this);
        this.$_0690 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16();
        $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16__init_0 = function(var$0, var$1) {
        var$0.$_0690 = var$1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0690;
        return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$28$lambda$_83_0, var$1));
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17 = function() {
        jl_Object.call(this);
        this.$_0691 = null;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17__init_ = function(var_0) {
        var var_1 = new $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17();
        $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17__init_0 = function(var$0, var$1) {
        var$0.$_0691 = var$1;
    };
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0691;
        return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_specifyType$0($java.oncias_SemanticFunctionCheck$_MODULE$, new $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$30$lambda$_85_0, var$1));
    };
    $java.oncius_TypeSpec$equals$lambda$_37_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$equals$lambda$_37_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf($java.oncius_TypeRange_hasDefiniteSize(var$1));
    };
    $java.oncius_TypeSpec$equals$lambda$_37_1 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$equals$lambda$_37_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf($java.oncius_TypeRange_hasDefiniteSize(var$1));
    };
    $java.oncius_TypeSpec$equals$lambda$_37_2 = function() {
        jl_Object.call(this);
        this.$_0528 = null;
    };
    $java.oncius_TypeSpec$equals$lambda$_37_2_apply = function(var$0) {
        return var$0.$_0528;
    };
    $java.oncius_TypeSpec$equals$lambda$_37_3 = function() {
        jl_Object.call(this);
        this.$_0529 = null;
    };
    $java.oncius_TypeSpec$equals$lambda$_37_3_apply = function(var$0) {
        return var$0.$_0529;
    };
    $java.oncie_Expression$$anonfun$arguments$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0642 = null;
    };
    $java.oncie_Expression$$anonfun$arguments$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0642;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.ju_AbstractList$TListIteratorImpl = function() {
        var a = this; jl_Object.call(a);
        a.$i6 = 0;
        a.$j = 0;
        a.$lastModCount = 0;
        a.$sz = 0;
        a.$this$041 = null;
    };
    function onciap_Prettifier$$escapeNames$lambda$_17_0() {
        jl_Object.call(this);
        this.$_080 = null;
    }
    $java.oncie_Expression$$anonfun$findAggregate$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncie_Expression$$anonfun$findAggregate$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return $x !== null && !s_Option_isEmpty($java.oncie_IsAggregate$_unapply($java.oncie_IsAggregate$_MODULE$, $x)) ? jl_Boolean_valueOf(1) : s_PartialFunction$_fallback_fn;
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_0() {
        jl_Object.call(this);
        this.$_083 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString24(var$0.$_083, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_1() {
        jl_Object.call(this);
        this.$_084 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_084, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_3() {
        jl_Object.call(this);
        this.$_085 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString23(var$0.$_085, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_4() {
        jl_Object.call(this);
        this.$_086 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_4_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_086, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_5 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_5_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_6() {
        jl_Object.call(this);
        this.$_087 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_6_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString22(var$0.$_087, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_7() {
        jl_Object.call(this);
        this.$_088 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_7_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_088, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_8 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_8_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_0() {
        jl_Object.call(this);
        this.$_089 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_089, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_1() {
        jl_Object.call(this);
        this.$_090 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_090, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_3() {
        jl_Object.call(this);
        this.$_091 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString21(var$0.$_091, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4() {
        jl_Object.call(this);
        this.$_0692 = null;
    }
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4__init_(var_0) {
        var var_1 = new onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4();
        $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4__init_(var_1, var_0);
        return var_1;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4__init_ = function(var$0, var$1) {
        var$0.$_0692 = var$1;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0692, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_0() {
        jl_Object.call(this);
        this.$_092 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString20(var$0.$_092, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_1_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_0() {
        jl_Object.call(this);
        this.$_099 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString24(var$0.$_099, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_1() {
        jl_Object.call(this);
        this.$_0100 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString22(var$0.$_0100, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_2() {
        jl_Object.call(this);
        this.$_0101 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString23(var$0.$_0101, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_3() {
        jl_Object.call(this);
        this.$_0102 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0102, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_4() {
        jl_Object.call(this);
        this.$_0104 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_4_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0104, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_5() {
        jl_Object.call(this);
        this.$_0103 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_5_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0103, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_0 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_0_apply = function(var$0, var$1) {
        return var$1.$filter1(new $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$81$lambda$_104_0);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_1() {
        jl_Object.call(this);
        this.$_0113 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0113;
        var$3 = new $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$83$lambda$_106_0;
        var$3.$_0693 = var$2;
        return sc_IterableOnceOps_mkString$(var$1.$map1(var$3), $rt_s(24), $rt_s(16), $rt_s(25));
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_2_apply = function(var$0) {
        return $rt_s(3);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_3 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_3_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sc_IterableOnceOps_nonEmpty$(var$1.$items4));
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_4() {
        jl_Object.call(this);
        this.$_0114 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_4_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0114;
        var$3 = var$1.$items4;
        var$4 = new $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_0;
        var$4.$_0694 = var$2;
        var$4 = sc_AbstractIterable_mkString0(var$3.$map1(var$4), $rt_s(16));
        var$3 = onciap_Prettifier$IndentingQueryPrettifier_indented(var$2);
        var$5 = var$1.$where9;
        var$1 = new $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_1;
        var$1.$_0695 = var$3;
        var$1 = s_Option_map(var$5, var$1);
        var$3 = new $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_2;
        var$3.$_0696 = var$2;
        var$1 = s_Option_getOrElse(s_Option_map(var$1, var$3), new $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_3);
        var$3 = var$2.$INDENT;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$3), $rt_s(365)), var$4), var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_5() {
        jl_Object.call(this);
        this.$_0115 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_5_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0115, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_6 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_6_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_0() {
        jl_Object.call(this);
        this.$_0116 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0116, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_1() {
        jl_Object.call(this);
        this.$_0117 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0117, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_0() {
        jl_Object.call(this);
        this.$_0118 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0118, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_1() {
        jl_Object.call(this);
        this.$_0119 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0119, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_0() {
        jl_Object.call(this);
        this.$_0120 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0120, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_1() {
        jl_Object.call(this);
        this.$_0121 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0121, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_0() {
        jl_Object.call(this);
        this.$_0122 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0122, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_1() {
        jl_Object.call(this);
        this.$_0123 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0123, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_0() {
        jl_Object.call(this);
        this.$_0124 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0124, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_1() {
        jl_Object.call(this);
        this.$_0125 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0125, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_0() {
        jl_Object.call(this);
        this.$_0128 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0128, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_1() {
        jl_Object.call(this);
        this.$_0129 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0129, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_2_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_40_0() {
        var a = this; jl_Object.call(a);
        a.$_0130 = null;
        a.$_122 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_40_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0130;
        var$3 = var$0.$_122;
        if (var$1 instanceof oncia_SetPropertyItem) {
            var$1 = var$1;
            var$4 = var$1.$property8;
            var$3 = var$1.$expression11;
            var$1 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$4);
            var$3 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$3);
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$1), $rt_s(71)), var$3);
            var$1 = jl_AbstractStringBuilder_toString(var$2);
        } else if (var$1 instanceof $java.oncia_SetPropertyItems) {
            var$1 = var$1;
            var$3 = var$1.$map4();
            var$1 = var$1.$items0();
            var$4 = new $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_0;
            var$4.$_0697 = var$2;
            var$4.$_1212 = var$3;
            var$1 = (var$1.$map1(var$4)).$mkString($rt_s(16));
        } else if (var$1 instanceof oncia_SetLabelItem) {
            var$1 = var$1;
            var$3 = var$1.$variable40;
            var$4 = var$1.$labels2;
            var$3 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$3);
            var$1 = new $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_1;
            var$1.$_0698 = var$2;
            var$1 = sc_AbstractIterable_mkString0(var$4.$map1(var$1), $rt_s(3));
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$3), var$1);
            var$1 = jl_AbstractStringBuilder_toString(var$2);
        } else if (var$1 instanceof oncia_SetIncludingPropertiesFromMapItem) {
            var$1 = var$1;
            var$4 = var$1.$variable0;
            var$3 = var$1.$expression0;
            var$1 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$4);
            var$3 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$3);
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$1), $rt_s(73)), var$3);
            var$1 = jl_AbstractStringBuilder_toString(var$2);
        } else if (!(var$1 instanceof oncia_SetExactPropertiesFromMapItem))
            var$1 = var$3.$toString();
        else {
            var$1 = var$1;
            var$4 = var$1.$variable;
            var$3 = var$1.$expression;
            var$1 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$4);
            var$3 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$3);
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$1), $rt_s(71)), var$3);
            var$1 = jl_AbstractStringBuilder_toString(var$2);
        }
        return var$1;
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_41_0() {
        var a = this; jl_Object.call(a);
        a.$_0131 = null;
        a.$_123 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_41_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0131;
        var$3 = var$0.$_123;
        if (var$1 instanceof oncia_RemovePropertyItem) {
            var$1 = var$1.$property7;
            var$1 = jl_String_valueOf(onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$1));
        } else if (!(var$1 instanceof oncia_RemoveLabelItem))
            var$1 = var$3.$toString();
        else {
            var$1 = var$1;
            var$3 = var$1.$variable39;
            var$4 = var$1.$labels1;
            var$3 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$3);
            var$1 = new $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$117$lambda$_143_0;
            var$1.$_0699 = var$2;
            var$1 = sc_AbstractIterable_mkString0(var$4.$map1(var$1), $rt_s(3));
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$3), var$1);
            var$1 = jl_AbstractStringBuilder_toString(var$2);
        }
        return var$1;
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_43_0() {
        jl_Object.call(this);
        this.$_0133 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_43_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0133.$$outer3.$expr2, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_0() {
        jl_Object.call(this);
        this.$_095 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_095;
        if (var$1 instanceof $java.oncia_OnMatch) {
            var$3 = var$1.$action3;
            var$1 = var$2.$INDENT;
            var$2 = onciap_Prettifier$IndentingQueryPrettifier_asString14(var$2, var$3);
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$1), $rt_s(3201)), var$2);
            var$1 = jl_AbstractStringBuilder_toString(var$3);
        } else {
            if (!(var$1 instanceof $java.oncia_OnCreate))
                $rt_throw(s_MatchError__init_(var$1));
            var$3 = var$1.$action4;
            var$1 = var$2.$INDENT;
            var$2 = onciap_Prettifier$IndentingQueryPrettifier_asString14(var$2, var$3);
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, var$1), $rt_s(3202)), var$2);
            var$1 = jl_AbstractStringBuilder_toString(var$3);
        }
        return var$1;
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_1() {
        jl_Object.call(this);
        this.$_096 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_096, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_0() {
        jl_Object.call(this);
        this.$_0132 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = onciap_DefaultExpressionStringifier_stringify(var$0.$_0132.$$outer3.$expr2, var$1);
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(3203)), var$2);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_1_apply = function(var$0) {
        return $rt_s(3);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_44_0() {
        jl_Object.call(this);
        this.$_0134 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_44_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_dispatch(var$0.$_0134, var$1);
    };
    function onciu_Foldable$Folder$$anonfun$treeCollect$1() {
        sr_AbstractPartialFunction.call(this);
        this.$f$10 = null;
    }
    $java.onciu_Foldable$Folder$$anonfun$treeCollect$1_applyOrElse = function($this, $x1, $default) {
        if (!$this.$f$10.$isDefinedAt($x1))
            return s_PartialFunction$_fallback_fn;
        $default = new $java.onciu_Foldable$Folder$$anonfun$treeCollect$1$applyOrElse$lambda$_0_0;
        $default.$_0700 = $this;
        $default.$_1213 = $x1;
        return $default;
    };
    $java.oncias_SemanticCheck$$fromFunctionWithContext$lambda$_10_0 = function() {
        jl_Object.call(this);
        this.$_0367 = null;
    };
    $java.oncias_SemanticCheck$$fromFunctionWithContext$lambda$_10_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0367;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = new $java.oncias_SemanticCheck$$$anonfun$fromFunctionWithContext$1$lambda$_21_0;
        var$4.$_0701 = var$2;
        var$4.$_1214 = var$1;
        return $java.oncias_SemanticCheck$_fromFunction(var$3, var$4);
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$createError$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$createError$lambda$_3_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeSpec_toShortString(var$1);
    };
    $java.oncias_Symbol$toString$lambda$_14_0 = $rt_classWithoutFields();
    $java.oncias_Symbol$toString$lambda$_14_0_apply = function(var$0, var$1) {
        return $java.oncias_SymbolUse_uniqueName(var$1);
    };
    $java.oncias_Symbol$positionsAndUniqueIdString$lambda$_13_0 = $rt_classWithoutFields();
    $java.oncias_Symbol$positionsAndUniqueIdString$lambda$_13_0_apply = function(var$0, var$1) {
        return $java.oncias_SymbolUse_positionsAndUniqueIdString(var$1);
    };
    $java.oncia_Return$checkVariableScope$lambda$_85_0 = function() {
        jl_Object.call(this);
        this.$_0353 = null;
    };
    $java.oncia_Return$checkVariableScope$lambda$_85_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$2 = var$0.$_0353;
        var$3 = var$2.$returnItems1;
        if (var$3 !== null && var$3.$includeExisting && var$1.$currentScope.$elem.$symbolTable.$isEmpty())
            var$1 = sci_$colon$colon__init_(oncias_SemanticError__init_0($rt_s(3204), var$2.$position40), sci_Nil$_MODULE$);
        else {
            s_package$_$callClinit();
            var$1 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        }
        return var$1;
    };
    $java.oncia_SubqueryCall$checkNoCallInTransactionsInsideRegularCall$lambda$_68_0 = function() {
        jl_Object.call(this);
        this.$_0377 = null;
    };
    $java.oncia_SubqueryCall$checkNoCallInTransactionsInsideRegularCall$lambda$_68_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticAnalysisTooling_error$(var$0.$_0377, $rt_s(3205), var$1.$position67);
    };
    $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_0 = $rt_classWithoutFields();
    $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncil_LabelExpressionPredicate);
    };
    $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_1 = $rt_classWithoutFields();
    $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticError__init_0($rt_s(3206), var$1.$position2());
    };
    $java.oncia_Match$noImplicitJoinsInQuantifiedPathPatterns$lambda$_62_0 = function() {
        jl_Object.call(this);
        this.$_0414 = null;
    };
    $java.oncia_Match$noImplicitJoinsInQuantifiedPathPatterns$lambda$_62_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = (var$0.$_0414.$pattern2.$patternParts1.$map1(new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_0)).$toList();
        var$3 = sci_Nil$_MODULE$;
        var$4 = var$3;
        while (true) {
            if (sci_List_equals(sci_Nil$_MODULE$, var$2)) {
                var$5 = s_Tuple2__init_(sci_List_reverse(var$3), sci_List_reverse(var$4));
                var$3 = s_Tuple2__init_(var$5.$_10, var$5.$_20);
                var$2 = var$3.$_10;
                var$4 = var$3.$_20;
                var$2 = sc_AbstractIterable_groupMap(sci_List_flatMap(var$2, new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_1), new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_2, new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_3);
                var$4 = sc_AbstractIterable_toSet(sci_List_flatMap(var$4, new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_4));
                var$3 = new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_5;
                var$3.$_0702 = var$4;
                var$3.$_1215 = var$1;
                var$1 = var$2.$flatMap(var$3);
                var$2 = oncias_SemanticCheck$_MODULE$;
                var$4 = new $java.oncias_SemanticCheck$$error$lambda$_3_0;
                var$4.$_0703 = var$1;
                return $java.oncias_SemanticCheck$_fromFunction(var$2, var$4);
            }
            if (!(var$2 instanceof sci_$colon$colon))
                $rt_throw(s_MatchError__init_(var$2));
            var$2 = var$2;
            var$5 = var$2.$head0;
            var$2 = var$2.$next0;
            if (var$5 instanceof oncie_PathConcatenation) {
                var$2 = (var$5.$factors.$toList()).$concat0(var$2);
                continue;
            }
            if (var$5 instanceof oncie_ParenthesizedPath) {
                var$2 = sci_List_$colon$colon(var$2, var$5.$part0.$element());
                continue;
            }
            if (var$5 instanceof oncie_QuantifiedPath) {
                var$3 = sci_List_$colon$colon(var$3, var$5);
                continue;
            }
            if (!(var$5 instanceof $java.oncie_SimplePattern))
                break;
            var$4 = sci_List_$colon$colon(var$4, var$5);
        }
        $rt_throw(s_MatchError__init_(var$5));
    };
    $java.oncia_Match$$anonfun$4 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_Match$$anonfun$4_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return !($x instanceof oncia_UsingJoinHint) ? $default.$apply($x) : $x.$variables.$toIndexedSeq();
    };
    $java.oncia_Match$uniqueHints$lambda$_66_0 = $rt_classWithoutFields();
    $java.oncia_Match$uniqueHints$lambda$_66_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        s_Predef$_$callClinit();
        return var$1;
    };
    $java.oncia_Match$$anonfun$5 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_Match$$anonfun$5_applyOrElse = function($this, $x, $default) {
        var var$3;
        a: {
            $x = $x;
            if ($x !== null) {
                var$3 = $x.$_10;
                if ($x.$_20.$length() > 1) {
                    $x = oncias_SemanticError__init_0($rt_s(3207), var$3.$position0);
                    break a;
                }
            }
            $x = sc_StrictOptimizedIterableOps$collect$lambda$_19_0_apply($default, $x);
        }
        return $x;
    };
    $java.oncia_Match$uniqueHints$lambda$_66_1 = function() {
        jl_Object.call(this);
        this.$_0415 = null;
    };
    $java.oncia_Match$uniqueHints$lambda$_66_1_apply = function(var$0, var$1) {
        return oncias_SemanticCheckResult__init_(var$1, var$0.$_0415);
    };
    $java.oncia_Match$checkMatchMode$lambda$_68_0 = $rt_classWithoutFields();
    $java.oncia_Match$checkMatchMode$lambda$_68_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$features1.$contains0(oncias_SemanticFeature$MatchModes$_MODULE$) ? 0 : 1);
    };
    $java.oncia_Match$checkMatchMode$lambda$_68_1 = function() {
        jl_Object.call(this);
        this.$_0416 = null;
    };
    $java.oncia_Match$checkMatchMode$lambda$_68_1_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0416;
        var$2 = var$1.$matchMode;
        if (var$2 instanceof oncie_MatchMode$DifferentRelationships && var$2.$implicitlyCreated)
            var$1 = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(oncias_package$_MODULE$, new $java.oncia_Match$$anonfun$checkMatchMode$2$lambda$_118_0);
        else {
            var$3 = var$2.$prettified();
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(3208)), var$3), $rt_s(3209));
            var$1 = oncias_SemanticAnalysisTooling_error$(var$1, jl_AbstractStringBuilder_toString(var$2), var$1.$matchMode.$position2());
        }
        return var$1;
    };
    $java.oncia_Match$checkMatchMode$lambda$_68_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0417 = null;
        a.$_1123 = null;
    };
    $java.oncia_Match$checkMatchMode$lambda$_68_2_apply = function(var$0) {
        return oncias_SemanticAnalysisTooling_whenState$default$3$(var$0.$_0417, var$0.$_1123);
    };
    $java.oncia_Match$checkMatchMode$lambda$_68_3 = function() {
        jl_Object.call(this);
        this.$_0418 = null;
    };
    $java.oncia_Match$checkMatchMode$lambda$_68_3_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0418;
        var$2 = var$1.$matchMode;
        if (var$2 instanceof oncie_MatchMode$RepeatableElements) {
            var$2 = oncias_package$_MODULE$;
            var$3 = new $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_0;
            var$3.$_0704 = var$1;
            var$1 = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$3);
        } else {
            if (!(var$2 instanceof oncie_MatchMode$DifferentRelationships))
                $rt_throw(s_MatchError__init_(var$2));
            var$2 = oncias_package$_MODULE$;
            var$3 = new $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_1;
            var$3.$_0705 = var$1;
            var$1 = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$3);
        }
        return var$1;
    };
    $java.oncia_Match$checkHints$lambda$_71_0 = function() {
        jl_Object.call(this);
        this.$_0419 = null;
    };
    $java.oncia_Match$checkHints$lambda$_71_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5;
        var$3 = var$0.$_0419;
        var$4 = var$3.$hints;
        var$5 = new $java.oncia_Match$$anonfun$7;
        var$5.$$outer54 = var$3;
        var$5.$semanticState$1 = var$1;
        var$5.$context$10 = var$2;
        var$2 = var$4.$collectFirst(var$5);
        return oncias_SemanticCheckResult__init_(var$1, (s_Option$_option2Iterable(s_Option$_MODULE$, var$2)).$toSeq());
    };
    $java.oncia_Match$checkForCartesianProducts$lambda$_67_0 = function() {
        jl_Object.call(this);
        this.$_0420 = null;
    };
    $java.oncia_Match$checkForCartesianProducts$lambda$_67_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = var$1;
        var$2 = var$0.$_0420;
        var$3 = onciap_ExpressionStringifier$_failingExtender;
        var$4 = onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, var$3, 0, 0, 1, 0);
        var$4 = onciap_DefaultPatternStringifier_apply1(onciap_PatternStringifier$_apply(onciap_PatternStringifier$_MODULE$, var$4), var$2.$pattern2);
        $java.oncia_connectedComponents$_$callClinit();
        var$3 = (var$2.$pattern2.$patternParts1.$map1(new $java.oncia_connectedComponents$$apply$lambda$_3_0)).$toIndexedSeq0();
        s_package$_$callClinit();
        var$5 = sc_SeqFactory$Delegate_empty(s_package$_IndexedSeq0(s_package$_MODULE$));
        while (!sc_SeqOps_isEmpty$(var$3)) {
            var$6 = var$3.$head();
            var$7 = var$5.$zipWithIndex();
            var$8 = new $java.oncia_connectedComponents$$anonfun$1;
            var$8.$part$1 = var$6;
            var$8.$connectedComponents$1 = var$5;
            var$8 = var$7.$collectFirst(var$8);
            var$7 = new $java.oncia_connectedComponents$$loop$1$lambda$_8_0;
            var$7.$_0706 = var$5;
            var$7.$_1216 = var$6;
            var$5 = s_Option_getOrElse(var$8, var$7);
            var$3 = var$3.$tail();
        }
        var$3 = var$5.$drop(1);
        var$5 = new $java.oncia_Match$$anonfun$checkForCartesianProducts$1$lambda$_115_0;
        var$5.$_0707 = var$2;
        var$5.$_1217 = var$4;
        return oncias_SemanticCheckResult__init_(var$3.$foldLeft(var$1, var$5), sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
    };
    var onciuh_Math$ = $rt_classWithoutFields();
    $java.onciuh_Math$_MODULE$ = null;
    function onciuh_Math$__clinit_() {
        $java.onciuh_Math$_MODULE$ = new onciuh_Math$;
    }
    $java.onciuh_Math$_subtractExact = function($this, $a, $b) {
        var $res, $resSgnBit, var$5, var$6;
        $res = Long_sub($a, $b);
        $resSgnBit = Long_ge($res, Long_ZERO) ? 0 : 1;
        var$5 = Long_ge($a, Long_ZERO) ? 0 : 1;
        if ($resSgnBit != var$5 && $resSgnBit != (Long_le($b, Long_ZERO) ? 0 : 1)) {
            var$6 = new $java.jl_ArithmeticException;
            jl_Throwable__init_(var$6, $rt_s(3165));
            $rt_throw(var$6);
        }
        return $res;
    };
    $java.oncius_TypeSpec$toStream$lambda$_34_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0526 = null;
        a.$_1172 = null;
    };
    $java.oncius_TypeSpec$toStream$lambda$_34_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncius_TypeSpec_contains0(var$0.$_0526, var$1, var$0.$_1172.$apply2()));
    };
    $java.oncius_TypeSpec$toStream$lambda$_34_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0527 = null;
        a.$_1173 = null;
    };
    $java.oncius_TypeSpec$toStream$lambda$_34_1_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0527;
        var$2 = var$0.$_1173;
        var$3 = new $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_0;
        var$3.$_0708 = var$1;
        var$3.$_1218 = var$2;
        return $java.sci_Stream_map($java.oncius_TypeSpec_toStream(var$1, var$3), new $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_1);
    };
    var sci_Stream = $rt_classWithoutFields(sci_AbstractSeq);
    $java.sci_Stream_stringPrefix = function($this) {
        return $rt_s(32);
    };
    $java.sci_Stream_scala$collection$LinearSeqOps$$super$sameElements = function($this, $that) {
        return sc_SeqOps_sameElements$($this, $that);
    };
    $java.sci_Stream_headOption = function($this) {
        return sc_LinearSeqOps_headOption$($this);
    };
    $java.sci_Stream_iterator = function($this) {
        var var$1, var$2, var$3;
        if (!$this.$knownSize())
            var$1 = sc_Iterator$_scala$collection$Iterator$$_empty;
        else {
            var$1 = new $java.sc_LinearSeqIterator;
            var$2 = new $java.sc_LinearSeqIterator$LazyCell;
            var$3 = new $java.sc_LinearSeqIterator$_init_$lambda$_4_0;
            var$3.$_0709 = $this;
            $java.sc_LinearSeqIterator$LazyCell__init_(var$2, var$1, var$3);
            var$1.$these = var$2;
        }
        return var$1;
    };
    $java.sci_Stream_length = function($this) {
        return sc_LinearSeqOps_length$($this);
    };
    $java.sci_Stream_last = function($this) {
        return sc_LinearSeqOps_last$($this);
    };
    $java.sci_Stream_lengthCompare = function($this, $len) {
        return sc_LinearSeqOps_lengthCompare$($this, $len);
    };
    $java.sci_Stream_apply = function($this, $n) {
        return sc_LinearSeqOps_apply$($this, $n);
    };
    $java.sci_Stream_forall = function($this, $p) {
        return sc_LinearSeqOps_forall$($this, $p);
    };
    $java.sci_Stream_exists = function($this, $p) {
        return sc_LinearSeqOps_exists$($this, $p);
    };
    $java.sci_Stream_contains = function($this, $elem) {
        return sc_LinearSeqOps_contains$($this, $elem);
    };
    $java.sci_Stream_sameElements = function($this, $that) {
        return sc_LinearSeqOps_sameElements$($this, $that);
    };
    $java.sci_Stream_indexWhere = function($this, $p, $from) {
        return sc_LinearSeqOps_indexWhere$($this, $p, $from);
    };
    $java.sci_Stream_iterableFactory = function($this) {
        return sci_Stream$_MODULE$;
    };
    $java.sci_Stream_className = function($this) {
        return $rt_s(3210);
    };
    $java.sci_Stream_foreach = function($this, $f) {
        while (!$this.$isEmpty()) {
            $f.$apply($this.$head());
            $this = $this.$tail();
        }
    };
    $java.sci_Stream_find = function($this, $p) {
        while (!$this.$isEmpty()) {
            if (sr_BoxesRunTime_unboxToBoolean($p.$apply($this.$head())))
                return s_Some__init_($this.$head());
            $this = $this.$tail();
        }
        return s_None$_MODULE$;
    };
    $java.sci_Stream_foldLeft = function($this, $z, $op) {
        var $this_0;
        while (!$this.$isEmpty()) {
            $this_0 = $this.$tail();
            $z = $op.$apply0($z, $this.$head());
            $this = $this_0;
        }
        return $z;
    };
    $java.sci_Stream_append = function($this, $rest) {
        var $lazyAppendedAll_apply_hd, $lazyAppendedAll_apply_tl;
        if ($this.$isEmpty())
            return sci_Stream$_from(sci_Stream$_MODULE$, $java.oncius_TypeSpec$toStream$lambda$_34_1_apply($rest));
        $lazyAppendedAll_apply_hd = $this.$head();
        $lazyAppendedAll_apply_tl = new $java.sci_Stream$append$lambda$_49_0;
        $lazyAppendedAll_apply_tl.$_0710 = $this;
        $lazyAppendedAll_apply_tl.$_1219 = $rest;
        return sci_Stream$Cons__init_0($lazyAppendedAll_apply_hd, $lazyAppendedAll_apply_tl);
    };
    $java.sci_Stream_reduceLeft = function($this, $f) {
        var $reducedRes, $left;
        if ($this.$isEmpty()) {
            $f = new jl_UnsupportedOperationException;
            jl_Throwable__init_($f, $rt_s(23));
            $rt_throw($f);
        }
        $reducedRes = $this.$head();
        $left = $this.$tail();
        while (!$left.$isEmpty()) {
            $reducedRes = $f.$apply0($reducedRes, $left.$head());
            $left = $left.$tail();
        }
        return $reducedRes;
    };
    $java.sci_Stream_partition = function($filterNot_filterImpl_rest, $p) {
        var var$2, $filter_pred, $filter_filterImpl_rest, $filter_filterImpl_filteredTail_apply_hd, $filter_filterImpl_filteredTail_apply_tl, $filterNot_pred, $filterNot_filterImpl_filteredTail_apply_hd, $filterNot_filterImpl_filteredTail_apply_tl;
        var$2 = new s_Tuple2;
        $filter_pred = new $java.sci_Stream$partition$lambda$_56_0;
        $filter_pred.$_0711 = $p;
        $filter_filterImpl_rest = $filterNot_filterImpl_rest;
        while (sc_IterableOnceOps_nonEmpty$($filter_filterImpl_rest) && !sr_BoxesRunTime_unboxToBoolean($p.$apply($filter_filterImpl_rest.$head()))) {
            $filter_filterImpl_rest = $filter_filterImpl_rest.$tail();
        }
        if (!sc_IterableOnceOps_nonEmpty$($filter_filterImpl_rest))
            $filter_pred = sci_Stream$Empty$_MODULE$;
        else {
            $filter_filterImpl_filteredTail_apply_hd = $filter_filterImpl_rest.$head();
            $filter_filterImpl_filteredTail_apply_tl = new $java.sci_Stream$partition$lambda$_56_1;
            $filter_filterImpl_filteredTail_apply_tl.$_0712 = $filter_filterImpl_rest;
            $filter_filterImpl_filteredTail_apply_tl.$_1220 = $filter_pred;
            $filter_filterImpl_filteredTail_apply_tl.$_266 = 0;
            $filter_pred = sci_Stream$Cons__init_0($filter_filterImpl_filteredTail_apply_hd, $filter_filterImpl_filteredTail_apply_tl);
        }
        $filterNot_pred = new $java.sci_Stream$partition$lambda$_56_2;
        $filterNot_pred.$_0713 = $p;
        while (sc_IterableOnceOps_nonEmpty$($filterNot_filterImpl_rest) && sr_BoxesRunTime_unboxToBoolean($p.$apply($filterNot_filterImpl_rest.$head())) == 1) {
            $filterNot_filterImpl_rest = $filterNot_filterImpl_rest.$tail();
        }
        if (!sc_IterableOnceOps_nonEmpty$($filterNot_filterImpl_rest))
            $p = sci_Stream$Empty$_MODULE$;
        else {
            $filterNot_filterImpl_filteredTail_apply_hd = $filterNot_filterImpl_rest.$head();
            $filterNot_filterImpl_filteredTail_apply_tl = new $java.sci_Stream$partition$lambda$_56_3;
            $filterNot_filterImpl_filteredTail_apply_tl.$_0714 = $filterNot_filterImpl_rest;
            $filterNot_filterImpl_filteredTail_apply_tl.$_1221 = $filterNot_pred;
            $filterNot_filterImpl_filteredTail_apply_tl.$_267 = 1;
            $p = sci_Stream$Cons__init_0($filterNot_filterImpl_filteredTail_apply_hd, $filterNot_filterImpl_filteredTail_apply_tl);
        }
        s_Tuple2__init_0(var$2, $filter_pred, $p);
        return var$2;
    };
    $java.sci_Stream_filter = function($filterImpl_rest, $pred) {
        var $filterImpl_filteredTail_apply_hd, $filterImpl_filteredTail_apply_tl;
        while (sc_IterableOnceOps_nonEmpty$($filterImpl_rest) && !sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_rest.$head()))) {
            $filterImpl_rest = $filterImpl_rest.$tail();
        }
        if (!sc_IterableOnceOps_nonEmpty$($filterImpl_rest))
            return sci_Stream$Empty$_MODULE$;
        $filterImpl_filteredTail_apply_hd = $filterImpl_rest.$head();
        $filterImpl_filteredTail_apply_tl = new $java.sci_Stream$filter$lambda$_57_0;
        $filterImpl_filteredTail_apply_tl.$_0715 = $filterImpl_rest;
        $filterImpl_filteredTail_apply_tl.$_1222 = $pred;
        $filterImpl_filteredTail_apply_tl.$_268 = 0;
        return sci_Stream$Cons__init_0($filterImpl_filteredTail_apply_hd, $filterImpl_filteredTail_apply_tl);
    };
    $java.sci_Stream_filterNot = function($filterImpl_rest, $pred) {
        var $filterImpl_filteredTail_apply_hd, $filterImpl_filteredTail_apply_tl;
        while (sc_IterableOnceOps_nonEmpty$($filterImpl_rest) && sr_BoxesRunTime_unboxToBoolean($pred.$apply($filterImpl_rest.$head())) == 1) {
            $filterImpl_rest = $filterImpl_rest.$tail();
        }
        if (!sc_IterableOnceOps_nonEmpty$($filterImpl_rest))
            return sci_Stream$Empty$_MODULE$;
        $filterImpl_filteredTail_apply_hd = $filterImpl_rest.$head();
        $filterImpl_filteredTail_apply_tl = new $java.sci_Stream$filterNot$lambda$_58_0;
        $filterImpl_filteredTail_apply_tl.$_0716 = $filterImpl_rest;
        $filterImpl_filteredTail_apply_tl.$_1223 = $pred;
        $filterImpl_filteredTail_apply_tl.$_269 = 1;
        return sci_Stream$Cons__init_0($filterImpl_filteredTail_apply_hd, $filterImpl_filteredTail_apply_tl);
    };
    $java.sci_Stream_prepended = function($this, $elem) {
        var $apply_tl;
        $apply_tl = new $java.sci_Stream$prepended$lambda$_61_0;
        $apply_tl.$_0717 = $this;
        return sci_Stream$Cons__init_0($elem, $apply_tl);
    };
    $java.sci_Stream_map = function($this, $f) {
        var $apply_hd, $apply_tl;
        if ($this.$isEmpty())
            return sci_Stream$Empty$_MODULE$;
        $apply_hd = $f.$apply($this.$head());
        $apply_tl = new $java.sci_Stream$map$lambda$_62_0;
        $apply_tl.$_0718 = $this;
        $apply_tl.$_1224 = $f;
        return sci_Stream$Cons__init_0($apply_hd, $apply_tl);
    };
    $java.sci_Stream_collect = function($this, $pf) {
        var $newHead, var$3;
        while (!$this.$isEmpty()) {
            $newHead = sr_ObjectRef__init_(null);
            var$3 = new $java.sci_Stream$collect$lambda$_63_0;
            var$3.$_0719 = $newHead;
            if (sr_BoxesRunTime_unboxToBoolean($java.s_PartialFunction$runWith$lambda$_22_0_apply(sr_AbstractPartialFunction_runWith($pf, var$3), $this.$head()))) {
                var$3 = $newHead.$elem5;
                $newHead = new $java.sci_Stream$$collectedTail$lambda$_30_0;
                $newHead.$_0720 = $this;
                $newHead.$_1225 = $pf;
                return sci_Stream$Cons__init_0(var$3, $newHead);
            }
            $this = $this.$tail();
        }
        return sci_Stream$Empty$_MODULE$;
    };
    $java.sci_Stream_collectFirst = function($this, $pf) {
        var $newHead, var$3;
        while (!$this.$isEmpty()) {
            $newHead = sr_ObjectRef__init_(null);
            var$3 = new $java.sci_Stream$collectFirst$lambda$_64_0;
            var$3.$_0721 = $newHead;
            if (sr_BoxesRunTime_unboxToBoolean($java.s_PartialFunction$runWith$lambda$_22_0_apply(sr_AbstractPartialFunction_runWith($pf, var$3), $this.$head())))
                return s_Some__init_($newHead.$elem5);
            $this = $this.$tail();
        }
        return s_None$_MODULE$;
    };
    $java.sci_Stream_flatMap = function($this, $f) {
        var $nonEmptyPrefix, $prefix, $from_this, $lazyAppendedAll_suffix, $lazyAppendedAll_apply_hd, $lazyAppendedAll_apply_tl, $$anonfun$flatMap$1_flatMap_this, $$anonfun$flatMap$1_flatMap_nonEmptyPrefix, $$anonfun$flatMap$1_flatMap_prefix, $$anonfun$flatMap$1_flatMap_lazyAppendedAll_suffix, $$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_hd, $$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_tl;
        if ($this.$isEmpty())
            return sci_Stream$Empty$_MODULE$;
        $nonEmptyPrefix = sr_ObjectRef__init_($this);
        $prefix = sci_Stream$_from(sci_Stream$_MODULE$, $f.$apply($nonEmptyPrefix.$elem5.$head()));
        while (!$nonEmptyPrefix.$elem5.$isEmpty() && $prefix.$isEmpty()) {
            $from_this = $nonEmptyPrefix.$elem5.$tail();
            $nonEmptyPrefix.$elem5 = $from_this;
            if ($from_this.$isEmpty())
                continue;
            $prefix = sci_Stream$_from(sci_Stream$_MODULE$, $f.$apply($nonEmptyPrefix.$elem5.$head()));
        }
        if ($nonEmptyPrefix.$elem5.$isEmpty())
            return sci_Stream$Empty$_MODULE$;
        $lazyAppendedAll_suffix = new $java.sci_Stream$flatMap$lambda$_65_0;
        $lazyAppendedAll_suffix.$_0722 = $nonEmptyPrefix;
        $lazyAppendedAll_suffix.$_1226 = $f;
        if ($prefix === null)
            $rt_throw(null);
        if (!$prefix.$isEmpty()) {
            $lazyAppendedAll_apply_hd = $prefix.$head();
            $lazyAppendedAll_apply_tl = new $java.sci_Stream$flatMap$lambda$_65_1;
            $lazyAppendedAll_apply_tl.$_0723 = $prefix;
            $lazyAppendedAll_apply_tl.$_1227 = $lazyAppendedAll_suffix;
            return sci_Stream$Cons__init_0($lazyAppendedAll_apply_hd, $lazyAppendedAll_apply_tl);
        }
        $from_this = sci_Stream$_MODULE$;
        $$anonfun$flatMap$1_flatMap_this = $nonEmptyPrefix.$elem5.$tail();
        if ($$anonfun$flatMap$1_flatMap_this === null)
            $rt_throw(null);
        if ($$anonfun$flatMap$1_flatMap_this.$isEmpty())
            $f = sci_Stream$Empty$_MODULE$;
        else {
            $$anonfun$flatMap$1_flatMap_nonEmptyPrefix = sr_ObjectRef__init_($$anonfun$flatMap$1_flatMap_this);
            $$anonfun$flatMap$1_flatMap_prefix = sci_Stream$_from(sci_Stream$_MODULE$, $f.$apply($$anonfun$flatMap$1_flatMap_nonEmptyPrefix.$elem5.$head()));
            while (!$$anonfun$flatMap$1_flatMap_nonEmptyPrefix.$elem5.$isEmpty() && $$anonfun$flatMap$1_flatMap_prefix.$isEmpty()) {
                $nonEmptyPrefix = $$anonfun$flatMap$1_flatMap_nonEmptyPrefix.$elem5.$tail();
                $$anonfun$flatMap$1_flatMap_nonEmptyPrefix.$elem5 = $nonEmptyPrefix;
                if ($nonEmptyPrefix.$isEmpty())
                    continue;
                $$anonfun$flatMap$1_flatMap_prefix = sci_Stream$_from(sci_Stream$_MODULE$, $f.$apply($$anonfun$flatMap$1_flatMap_nonEmptyPrefix.$elem5.$head()));
            }
            if ($$anonfun$flatMap$1_flatMap_nonEmptyPrefix.$elem5.$isEmpty())
                $f = sci_Stream$Empty$_MODULE$;
            else {
                $$anonfun$flatMap$1_flatMap_lazyAppendedAll_suffix = new $java.sci_Stream$flatMap$lambda$_65_2;
                $$anonfun$flatMap$1_flatMap_lazyAppendedAll_suffix.$_0724 = $$anonfun$flatMap$1_flatMap_nonEmptyPrefix;
                $$anonfun$flatMap$1_flatMap_lazyAppendedAll_suffix.$_1228 = $f;
                if ($$anonfun$flatMap$1_flatMap_prefix === null)
                    $rt_throw(null);
                if ($$anonfun$flatMap$1_flatMap_prefix.$isEmpty())
                    $f = sci_Stream$_from(sci_Stream$_MODULE$, $java.sci_Stream_$anonfun$flatMap$1($$anonfun$flatMap$1_flatMap_nonEmptyPrefix, $f));
                else {
                    $$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_hd = $$anonfun$flatMap$1_flatMap_prefix.$head();
                    $$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_tl = new $java.sci_Stream$flatMap$lambda$_65_3;
                    $$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_tl.$_0725 = $$anonfun$flatMap$1_flatMap_prefix;
                    $$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_tl.$_1229 = $$anonfun$flatMap$1_flatMap_lazyAppendedAll_suffix;
                    $f = sci_Stream$Cons__init_0($$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_hd, $$anonfun$flatMap$1_flatMap_lazyAppendedAll_apply_tl);
                }
            }
        }
        return sci_Stream$_from($from_this, $f);
    };
    $java.sci_Stream_zip = function($this, $thatIterable) {
        var var$2, $apply_hd, $apply_tl;
        if (!$this.$isEmpty()) {
            var$2 = $rt_isInstance($thatIterable, sc_Iterable);
            if (!(var$2 ? $thatIterable.$isEmpty() : ($thatIterable.$iterator0()).$isEmpty())) {
                if (!var$2) {
                    sci_LazyList$_$callClinit();
                    $thatIterable = sci_LazyList$_from(sci_LazyList$_MODULE$, $thatIterable);
                }
                $apply_hd = s_Tuple2__init_($this.$head(), $thatIterable.$head());
                $apply_tl = new $java.sci_Stream$zip$lambda$_66_0;
                $apply_tl.$_0726 = $this;
                $apply_tl.$_1230 = $thatIterable;
                return sci_Stream$Cons__init_0($apply_hd, $apply_tl);
            }
        }
        return sci_Stream$Empty$_MODULE$;
    };
    $java.sci_Stream_zipWithIndex = function($this) {
        sci_LazyList$_$callClinit();
        return $java.sci_Stream_zip($this, sci_LazyList$_from0(sci_LazyList$_MODULE$, 0, 1));
    };
    $java.sci_Stream_addString = function($this, $sb, $start, $sep, $end) {
        $this.$force0();
        $java.sci_Stream_addStringNoForce($this, $sb.$underlying, $start, $sep, $end);
        return $sb;
    };
    $java.sci_Stream_addStringNoForce = function($this, $b, $start, $sep, $end) {
        var $scout, var$6, $k;
        jl_AbstractStringBuilder_append1($b, $start);
        if (sc_IterableOnceOps_nonEmpty$($this)) {
            jl_StringBuilder_append($b, $this.$head());
            if ($this.$tailDefined()) {
                a: {
                    $scout = $this.$tail();
                    if ($this === $scout)
                        var$6 = $this;
                    else if (!$scout.$tailDefined())
                        var$6 = $scout;
                    else {
                        $start = $scout.$tail();
                        while ($scout !== $start) {
                            if (!$start.$tailDefined()) {
                                var$6 = $scout;
                                $scout = $start;
                                break a;
                            }
                            jl_AbstractStringBuilder_append1($b, $sep);
                            jl_StringBuilder_append($b, $scout.$head());
                            $scout = $scout.$tail();
                            $start = $start.$tail();
                            if (!$start.$tailDefined())
                                continue;
                            $start = $start.$tail();
                        }
                        var$6 = $scout;
                        $scout = $start;
                    }
                }
                if (!$scout.$tailDefined()) {
                    $this = var$6;
                    while ($this !== $scout) {
                        jl_AbstractStringBuilder_append1($b, $sep);
                        jl_StringBuilder_append($b, $this.$head());
                        $this = $this.$tail();
                    }
                    if (sc_IterableOnceOps_nonEmpty$($this)) {
                        jl_AbstractStringBuilder_append1($b, $sep);
                        jl_StringBuilder_append($b, $this.$head());
                    }
                } else {
                    $k = 0;
                    while ($this !== $scout) {
                        $this = $this.$tail();
                        $scout = $scout.$tail();
                        $k = $k + 1 | 0;
                    }
                    if (var$6 !== $scout)
                        $this = var$6;
                    else if ($k <= 0)
                        $this = var$6;
                    else {
                        jl_AbstractStringBuilder_append1($b, $sep);
                        jl_StringBuilder_append($b, var$6.$head());
                        $this = var$6.$tail();
                    }
                    while ($this !== $scout) {
                        jl_AbstractStringBuilder_append1($b, $sep);
                        jl_StringBuilder_append($b, $this.$head());
                        $this = $this.$tail();
                    }
                }
            }
            if (sc_IterableOnceOps_nonEmpty$($this)) {
                if ($this.$tailDefined()) {
                    jl_AbstractStringBuilder_append1($b, $sep);
                    jl_AbstractStringBuilder_append1($b, $rt_s(491));
                } else {
                    jl_AbstractStringBuilder_append1($b, $sep);
                    jl_AbstractStringBuilder_append1($b, $rt_s(490));
                }
            }
        }
        jl_AbstractStringBuilder_append1($b, $end);
        return $b;
    };
    $java.sci_Stream_toString = function($this) {
        return jl_AbstractStringBuilder_toString($java.sci_Stream_addStringNoForce($this, jl_StringBuilder__init_3($rt_s(3210)), $rt_s(24), $rt_s(16), $rt_s(25)));
    };
    $java.sci_Stream_apply0 = function($this, $v1) {
        return sc_LinearSeqOps_apply$($this, sr_BoxesRunTime_unboxToInt($v1));
    };
    $java.sci_Stream_zipWithIndex0 = function($this) {
        return $java.sci_Stream_zipWithIndex($this);
    };
    $java.sci_Stream_zip0 = function($this, $that) {
        return $java.sci_Stream_zip($this, $that);
    };
    $java.sci_Stream_flatMap0 = function($this, $f) {
        return $java.sci_Stream_flatMap($this, $f);
    };
    $java.sci_Stream_collect0 = function($this, $pf) {
        return $java.sci_Stream_collect($this, $pf);
    };
    $java.sci_Stream_map0 = function($this, $f) {
        return $java.sci_Stream_map($this, $f);
    };
    $java.sci_Stream_prepended0 = function($this, $elem) {
        return $java.sci_Stream_prepended($this, $elem);
    };
    $java.sci_Stream_filterNot0 = function($this, $pred) {
        return $java.sci_Stream_filterNot($this, $pred);
    };
    $java.sci_Stream_filter0 = function($this, $pred) {
        return $java.sci_Stream_filter($this, $pred);
    };
    $java.sci_Stream_iterableFactory0 = function($this) {
        return sci_Stream$_MODULE$;
    };
    $java.sci_Stream_$anonfun$lazyAppendedAll$1 = function($$this, $suffix$1) {
        var $lazyAppendedAll_this, $lazyAppendedAll_apply_hd, $lazyAppendedAll_apply_tl;
        $lazyAppendedAll_this = $$this.$tail();
        if ($lazyAppendedAll_this === null)
            $rt_throw(null);
        if ($lazyAppendedAll_this.$isEmpty())
            return sci_Stream$_from(sci_Stream$_MODULE$, $suffix$1.$apply2());
        $lazyAppendedAll_apply_hd = $lazyAppendedAll_this.$head();
        $lazyAppendedAll_apply_tl = new $java.sci_Stream$$anonfun$lazyAppendedAll$1$lambda$_90_0;
        $lazyAppendedAll_apply_tl.$_0727 = $lazyAppendedAll_this;
        $lazyAppendedAll_apply_tl.$_1231 = $suffix$1;
        return sci_Stream$Cons__init_0($lazyAppendedAll_apply_hd, $lazyAppendedAll_apply_tl);
    };
    $java.sci_Stream_$anonfun$map$1 = function($$this, $f$1) {
        var $map_this, $map_apply_hd, $map_apply_tl;
        $map_this = $$this.$tail();
        if ($map_this === null)
            $rt_throw(null);
        if ($map_this.$isEmpty())
            return sci_Stream$Empty$_MODULE$;
        $map_apply_hd = $f$1.$apply($map_this.$head());
        $map_apply_tl = new $java.sci_Stream$$anonfun$map$1$lambda$_95_0;
        $map_apply_tl.$_0728 = $map_this;
        $map_apply_tl.$_1232 = $f$1;
        return sci_Stream$Cons__init_0($map_apply_hd, $map_apply_tl);
    };
    $java.sci_Stream_$anonfun$flatMap$1 = function($nonEmptyPrefix$1, $f$2) {
        var $flatMap_this, $flatMap_nonEmptyPrefix, $flatMap_prefix, $flatMap_lazyAppendedAll_suffix, $flatMap_lazyAppendedAll_apply_hd, $flatMap_lazyAppendedAll_apply_tl;
        $flatMap_this = $nonEmptyPrefix$1.$elem5.$tail();
        if ($flatMap_this === null)
            $rt_throw(null);
        if ($flatMap_this.$isEmpty())
            return sci_Stream$Empty$_MODULE$;
        $flatMap_nonEmptyPrefix = sr_ObjectRef__init_($flatMap_this);
        $flatMap_prefix = sci_Stream$_from(sci_Stream$_MODULE$, $f$2.$apply($flatMap_nonEmptyPrefix.$elem5.$head()));
        while (!$flatMap_nonEmptyPrefix.$elem5.$isEmpty() && $flatMap_prefix.$isEmpty()) {
            $nonEmptyPrefix$1 = $flatMap_nonEmptyPrefix.$elem5.$tail();
            $flatMap_nonEmptyPrefix.$elem5 = $nonEmptyPrefix$1;
            if ($nonEmptyPrefix$1.$isEmpty())
                continue;
            $flatMap_prefix = sci_Stream$_from(sci_Stream$_MODULE$, $f$2.$apply($flatMap_nonEmptyPrefix.$elem5.$head()));
        }
        if ($flatMap_nonEmptyPrefix.$elem5.$isEmpty())
            return sci_Stream$Empty$_MODULE$;
        $flatMap_lazyAppendedAll_suffix = new $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_0;
        $flatMap_lazyAppendedAll_suffix.$_0729 = $flatMap_nonEmptyPrefix;
        $flatMap_lazyAppendedAll_suffix.$_1233 = $f$2;
        if ($flatMap_prefix === null)
            $rt_throw(null);
        if ($flatMap_prefix.$isEmpty())
            return sci_Stream$_from(sci_Stream$_MODULE$, $java.sci_Stream_$anonfun$flatMap$1($flatMap_nonEmptyPrefix, $f$2));
        $flatMap_lazyAppendedAll_apply_hd = $flatMap_prefix.$head();
        $flatMap_lazyAppendedAll_apply_tl = new $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_1;
        $flatMap_lazyAppendedAll_apply_tl.$_0730 = $flatMap_prefix;
        $flatMap_lazyAppendedAll_apply_tl.$_1234 = $flatMap_lazyAppendedAll_suffix;
        return sci_Stream$Cons__init_0($flatMap_lazyAppendedAll_apply_hd, $flatMap_lazyAppendedAll_apply_tl);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$namesAsString$lambda$_37_0() {
        jl_Object.call(this);
        this.$_0126 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$namesAsString$lambda$_37_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_quote(var$0.$_0126.$$outer3.$expr2, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$partialYieldAsString$lambda$_38_0() {
        jl_Object.call(this);
        this.$_0127 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$partialYieldAsString$lambda$_38_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0127;
        if (jl_String_equals(var$1.$aliasedVariable.$name4, var$1.$originalName))
            var$1 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$1.$aliasedVariable);
        else {
            var$3 = onciap_Prettifier_backtick(var$2.$$outer3, var$1.$originalName);
            var$2 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$1.$aliasedVariable);
            var$1 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$1);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$1, var$3), $rt_s(367)), var$2);
            var$1 = jl_AbstractStringBuilder_toString(var$1);
        }
        return var$1;
    };
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0__init_ = function() {
        var var_0 = new $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0();
        $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0__init_0(var_0);
        return var_0;
    };
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0__init_0 = function(var$0) {};
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToChar(var$1) == 95 ? 0 : 1);
    };
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2 = $rt_classWithoutFields();
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2__init_ = function() {
        var var_0 = new $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2();
        $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2__init_0(var_0);
        return var_0;
    };
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2__init_0 = function(var$0) {};
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToChar(var$1) == 111 ? 0 : 1);
    };
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1 = $rt_classWithoutFields();
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1__init_ = function() {
        var var_0 = new $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1();
        $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1__init_0(var_0);
        return var_0;
    };
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1__init_0 = function(var$0) {};
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToChar(var$1) == 111 ? 0 : 1);
    };
    $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0__init_ = function() {
        var var_0 = new $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0();
        $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0__init_0(var_0);
        return var_0;
    };
    $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0__init_0 = function(var$0) {};
    $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToChar(var$1) == 95 ? 0 : 1);
    };
    $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0 = $rt_classWithoutFields();
    $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0__init_ = function() {
        var var_0 = new $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0();
        $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0__init_0(var_0);
        return var_0;
    };
    $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0__init_0 = function(var$0) {};
    $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToChar(var$1) == 95 ? 0 : 1);
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$yields$1$lambda$_23_0 = $rt_classWithoutFields();
    $java.oncia_ReadAdministrationCommand$$anonfun$yields$1$lambda$_23_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        return var$1.$_10;
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$returns$1$lambda$_25_0 = $rt_classWithoutFields();
    $java.oncia_ReadAdministrationCommand$$anonfun$returns$1$lambda$_25_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        return var$1.$_20;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$56$lambda$_116_0 = function() {
        jl_Object.call(this);
        this.$_0611 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$56$lambda$_116_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0611;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$3 = sc_IterableOnceOps_toSeq$($java.oncie_RelationshipChain_allVariables(var$2.$pattern6.$element5));
        var$4 = new $java.oncias_SemanticExpressionCheck$$anonfun$1;
        var$4.$state$10 = var$1;
        var$4.$x66$1 = var$2;
        return oncias_SemanticCheckResult__init_(var$1, var$3.$collect0(var$4));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_0 = function() {
        jl_Object.call(this);
        this.$_0635 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0635;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3211), var$1.$position73));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_1 = function() {
        jl_Object.call(this);
        this.$_0636 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_1_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0636;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3212), var$1.$position73));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$61$lambda$_121_0 = function() {
        jl_Object.call(this);
        this.$_0613 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$61$lambda$_121_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0613;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, var$2.$list2), var$1);
        oncius_package$_$callClinit();
        var$2 = oncius_package$_MODULE$;
        return $java.oncius_TypeSpec_unwrapLists($java.oncius_TypeSpec_constrain(var$1, oncius_package$_CTList(var$2, oncius_package$_CTAny(var$2))));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$104$lambda$_165_0 = function() {
        jl_Object.call(this);
        this.$_0631 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$104$lambda$_165_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0631;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3213), var$1.$position71));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$107$lambda$_168_0 = function() {
        jl_Object.call(this);
        this.$_0633 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$107$lambda$_168_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0633;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3214), var$1.$position72));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = oncias_package$_MODULE$;
        var$3 = oncias_SemanticExpressionCheck$_MODULE$;
        oncius_package$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_declareVariable$(var$3, var$1, ($java.oncius_package$_CTPath0(oncius_package$_MODULE$)).$invariant()));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_1 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncia_Where$_checkExpression($java.oncia_Where$_MODULE$, var$1);
    };
    $java.oncias_SemanticCheck$$anonfun$ifOkChain$1$lambda$_33_0 = function() {
        jl_Object.call(this);
        this.$_0673 = null;
    };
    $java.oncias_SemanticCheck$$anonfun$ifOkChain$1$lambda$_33_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0673;
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2.$errors.$concat0(var$1.$errors));
    };
    $java.oncia_CommandClause$clauseSpecificSemanticCheck$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0359 = null;
    };
    $java.oncia_CommandClause$clauseSpecificSemanticCheck$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0359;
        var$3 = oncias_package$_MODULE$;
        var$4 = var$1.$variable34;
        oncius_package$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(var$3, var$2.$declareVariable(var$4, var$1.$cypherType.$invariant()));
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$specifyType$1$lambda$_84_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0668 = null;
        a.$_1207 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$specifyType$1$lambda$_84_0_apply = function(var$0) {
        return var$0.$_0668.$apply(var$0.$_1207);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_0_apply = function(var$0, var$1) {
        oncias_SemanticPatternCheck$_$callClinit();
        return jl_Boolean_valueOf(var$1.$features1.$contains0(oncias_SemanticFeature$GpmShortestPath$_MODULE$) ? 0 : 1);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_1 = function() {
        jl_Object.call(this);
        this.$_0639 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_1_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0639;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_SemanticPatternCheck$_MODULE$;
        var$3 = var$1.$selector.$prettified();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(530)), var$3), $rt_s(3215));
        return oncias_SemanticAnalysisTooling_error$(var$2, jl_AbstractStringBuilder_toString(var$4), var$1.$selector.$position2());
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_2 = function() {
        jl_Object.call(this);
        this.$_0640 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_2_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0640;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticAnalysisTooling_whenState$default$3$(oncias_SemanticPatternCheck$_MODULE$, var$1);
    };
    var oncia_Where$ = $rt_classWithoutFields();
    $java.oncia_Where$_MODULE$ = null;
    function oncia_Where$__clinit_() {
        $java.oncia_Where$_MODULE$ = new oncia_Where$;
    }
    $java.oncia_Where$_checkExpression = function($this, $expression) {
        var var$2, var$3, var$4;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$2 = $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $expression);
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = onciu_Foldable_folder$($expression);
        sr_ClassTag$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$2, $java.oncias_SemanticPatternCheck$_checkValidPropertyKeyNames(var$3, (onciu_Foldable$Folder_findAllByClass(var$4, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_Property)))).$map1(new $java.oncia_Where$$checkExpression$lambda$_5_0))), oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncia_Where$$checkExpression$lambda$_5_1, $expression));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpressionForLegacyRelationshipTypeDisjunction$1$lambda$_176_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0643 = null;
        a.$_1197 = null;
        a.$_263 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpressionForLegacyRelationshipTypeDisjunction$1$lambda$_176_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0643;
                    var$3 = var$0.$_1197;
                    var$4 = var$0.$_263;
                    oncias_SemanticExpressionCheck$_$callClinit();
                    var$2 = oncias_ExpressionTypeInfo_actual(oncias_SemanticState_expressionType(var$1, var$2));
                    oncius_package$_$callClinit();
                    var$5 = oncius_NodeType_invariant(oncius_package$_CTNode(oncius_package$_MODULE$));
                    if (var$2 !== null) {
                        if (!oncius_TypeSpec_equals(var$2, var$5))
                            break b;
                        else
                            break c;
                    }
                    if (var$5 !== null)
                        break b;
                }
                var$6 = 1;
                break a;
            }
            var$6 = 0;
        }
        var$2 = onciap_DefaultExpressionStringifier_stringifyLabelExpression($java.oncias_SemanticExpressionCheck$_stringifier0(oncias_SemanticExpressionCheck$_MODULE$), var$3.$replaceColonSyntax());
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = $java.oncias_SemanticPatternCheck$_legacyRelationshipDisjunctionError(oncias_SemanticPatternCheck$_MODULE$, var$2, var$3.$containsIs6(), var$6);
        return oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, var$1, oncias_SemanticError__init_0(var$2, var$4.$position217));
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$$anonfun$checkInnerPredicate$1$lambda$_12_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$$anonfun$checkInnerPredicate$1$lambda$_12_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_BooleanType_covariant(oncius_package$_CTBoolean(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$2$lambda$_124_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$2$lambda$_124_0_apply = function(var$0) {
        oncias_SemanticPatternCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$9$lambda$_131_0 = function() {
        jl_Object.call(this);
        this.$_0646 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$9$lambda$_131_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0646;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncius_TypeSpec_wrapInList(oncias_ExpressionTypeInfo_actual(oncias_SemanticState_expressionType(var$1, var$2.$singleton)));
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$11$lambda$_87_0 = function() {
        jl_Object.call(this);
        this.$_0647 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$11$lambda$_87_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0647;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticState_symbol(var$2, var$1.$name4);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkIsKeyword$1$lambda$_152_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0648 = null;
        a.$_1198 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkIsKeyword$1$lambda$_152_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0648;
        var$2 = var$0.$_1198;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$1 = var$1.$description();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3216)), var$1), $rt_s(3217));
        return oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position2());
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkLabelExpressions$1$lambda$_150_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0649 = null;
        a.$_1199 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkLabelExpressions$1$lambda$_150_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0649;
        var$2 = var$0.$_1199;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$1 = var$1.$description();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3218)), var$1), $rt_s(3217));
        return oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position2());
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0650 = null;
        a.$_1200 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0650;
        var$2 = var$0.$_1200;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$1 = var$1.$description();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3219)), var$1), $rt_s(3220));
        return oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position2());
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_1 = function() {
        jl_Object.call(this);
        this.$_0651 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_1_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0651;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_SemanticPatternCheck$_MODULE$;
        var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$3$lambda$_147_0;
        var$3.$_0731 = var$1;
        return oncias_SemanticAnalysisTooling_withScopedState$(var$2, var$3);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$11$lambda$_133_0 = function() {
        jl_Object.call(this);
        this.$_0657 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$11$lambda$_133_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0657;
        oncias_SemanticPatternCheck$_$callClinit();
        return var$1.$covariant20();
    };
    $java.oncias_SemanticAnalysisTooling$implicitVariable$lambda$_63_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0586 = null;
        a.$_1179 = null;
    };
    $java.oncias_SemanticAnalysisTooling$implicitVariable$lambda$_63_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$2 = var$0.$_0586;
        var$3 = var$0.$_1179;
        oncius_package$_$callClinit();
        return oncias_SemanticState_implicitVariable(var$1, var$2, var$3.$invariant());
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$1$lambda$_87_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0667 = null;
        a.$_1206 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$1$lambda$_87_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0667;
        var$2 = var$0.$_1206;
        return $java.oncias_SemanticExpressionCheck$_$anonfun$infixAddRhsTypes$1(var$1.$_0472, var$2);
    };
    function oncias_SemanticAnalysisTooling$expectType$lambda$_17_0() {
        var a = this; jl_Object.call(a);
        a.$_0278 = null;
        a.$_180 = null;
        a.$_229 = null;
    }
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_17_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0278;
        var$3 = var$0.$_180;
        var$4 = var$0.$_229;
        var$1 = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
        var$5 = new $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$7$lambda$_94_0;
        var$5.$_0732 = var$2;
        var$5.$_1235 = var$4;
        return var$3.$foldLeft(var$1, var$5);
    };
    $java.oncia_Clause$$anonfun$semanticCheck$1$lambda$_17_0 = function() {
        jl_Object.call(this);
        this.$_0676 = null;
    };
    $java.oncia_Clause$$anonfun$semanticCheck$1$lambda$_17_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = var$1;
        var$2 = var$0.$_0676;
        var$3 = var$2.$folder();
        var$4 = new oncia_Clause$LabelExpressionsPartition;
        var$2.$LabelExpressionsPartition();
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        var$5 = sci_Set$EmptySet$_MODULE$;
        var$2.$LabelExpressionsPartition();
        s_Predef$_Set(s_Predef$_MODULE$);
        var$6 = sci_Set$EmptySet$_MODULE$;
        var$2.$LabelExpressionsPartition();
        s_Predef$_Set(s_Predef$_MODULE$);
        $java.oncia_Clause$LabelExpressionsPartition__init_(var$4, var$2, var$5, var$6, sci_Set$EmptySet$_MODULE$);
        var$7 = new $java.oncia_Clause$$anonfun$1;
        var$7.$$outer55 = var$2;
        var$7.$state$11 = var$1;
        var$4 = onciu_Foldable$Folder_treeFold(var$3, var$4, var$7);
        var$8 = ((var$4.$gpm.$concat1(var$4.$legacy)).$concat1(var$4.$leaf)).$exists(new $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_0);
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$8 = !sc_IterableOnceOps_nonEmpty$(var$4.$gpm) && !var$8 ? 0 : 1;
        var$7 = new $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_1;
        var$7.$_0733 = var$2;
        var$7.$_1236 = var$4;
        return (oncias_SemanticCheck$_when(var$3, var$8, var$7)).$apply61(var$1);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0660 = null;
        a.$_1203 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0660;
        var$2 = var$0.$_1203;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$1 = var$1.$description();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3221)), var$1), $rt_s(3220));
        return oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position2());
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_1 = function() {
        jl_Object.call(this);
        this.$_0661 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_1_apply = function(var$0, var$1) {
        var$1 = var$0.$_0661;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticAnalysisTooling_error$(oncias_SemanticPatternCheck$_MODULE$, $rt_s(3222), var$1.$position2());
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_2 = function() {
        jl_Object.call(this);
        this.$_0662 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_2_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0662;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_SemanticPatternCheck$_MODULE$;
        var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$30$lambda$_120_0;
        var$3.$_0734 = var$1;
        return oncias_SemanticAnalysisTooling_withScopedState$(var$2, var$3);
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$3$lambda$_89_0 = function() {
        jl_Object.call(this);
        this.$_0675 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$3$lambda$_89_0_apply = function(var$0) {
        return var$0.$_0675;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$25$lambda$_115_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0658 = null;
        a.$_1201 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$25$lambda$_115_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0658;
        var$2 = var$0.$_1201;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$1 = var$1.$description();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3223)), var$1), $rt_s(3224));
        return oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position2());
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_0 = function() {
        jl_Object.call(this);
        this.$_0669 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0669;
        return jl_Boolean_valueOf(sci_Vector_length(var$1.$argumentTypes1()) != ($java.oncie_Expression_arguments(var$2)).$length() ? 0 : 1);
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_1 = function() {
        jl_Object.call(this);
        this.$_0670 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_1_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6, var$7;
        a: {
            var$1 = var$1;
            var$2 = var$2;
            var$3 = var$0.$_0670;
            var$4 = s_Tuple2__init_(var$1, var$2);
            var$1 = var$4.$_10;
            if (var$1 !== null) {
                var$2 = var$1.$_10;
                if (var$2 !== null) {
                    s_package$_$callClinit();
                    s_package$_Seq(s_package$_MODULE$);
                    sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, var$2);
                    if (!var$2.$lengthCompare(0))
                        break a;
                }
            }
            var$1 = var$4.$_10;
            var$2 = var$4.$_20;
            if (var$1 === null)
                $rt_throw(s_MatchError__init_(var$4));
            var$4 = var$1.$_10;
            var$5 = var$1.$_20;
            oncius_TypeSpec$_$callClinit();
            var$6 = var$4.$foldLeft(oncius_TypeSpec$_none(oncius_TypeSpec$_MODULE$), new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_0);
            var$1 = var$5.$state;
            var$7 = new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_1;
            var$7.$_0735 = var$6;
            var$6 = var$3.$expectType3(var$1, var$7, var$2, var$3.$expectType$default$4());
            var$2 = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(var$3.$types2(var$2), var$6.$state);
            var$1 = new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_2;
            var$1.$_0736 = var$2;
            var$3 = (var$4.$filter1(var$1)).$map1(new $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_3);
            var$1 = s_Tuple2__init_(var$3, oncias_SemanticCheckResult__init_(var$6.$state, var$5.$errors.$concat0(var$6.$errors)));
        }
        return var$1;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_2 = function() {
        jl_Object.call(this);
        this.$_0671 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_2_apply = function(var$0) {
        return var$0.$_0671;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_3 = $rt_classWithoutFields();
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_3_apply = function(var$0, var$1, var$2) {
        return $java.oncius_TypeSpec_union(var$1, (var$2.$outputType1()).$invariant());
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$5$lambda$_91_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0674 = null;
        a.$_1209 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$5$lambda$_91_0_apply = function(var$0) {
        return $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(var$0.$_0674, var$0.$_1209);
    };
    $java.oncias_SemanticExpressionCheck$$checkForShadowedVariables$lambda$_59_0 = function() {
        jl_Object.call(this);
        this.$_0477 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkForShadowedVariables$lambda$_59_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0477;
        oncias_SemanticExpressionCheck$_$callClinit();
        if (var$1.$semanticCheckHasRunOnce) {
            var$2 = new oncias_SemanticCheckResult;
            s_package$_$callClinit();
            oncias_SemanticCheckResult__init_0(var$2, var$1, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
        } else {
            var$3 = oncias_SemanticState$ScopeLocation$_MODULE$;
            var$3 = oncias_SemanticState$ScopeLocation$_parent$extension(var$3, ((oncias_SemanticState$ScopeLocation$_parent$extension(var$3, var$1.$currentScope)).$get0()).$location);
            if (!(var$3 instanceof s_Some)) {
                if (!jl_Object_equals(s_None$_MODULE$, var$3))
                    $rt_throw(s_MatchError__init_(var$3));
                var$3 = ((oncias_SemanticState$ScopeLocation$_parent$extension(oncias_SemanticState$ScopeLocation$_MODULE$, var$1.$currentScope)).$get0()).$location.$elem.$symbolTable;
            } else
                var$3 = var$3.$value5.$location.$elem.$symbolTable.$concat2(((oncias_SemanticState$ScopeLocation$_parent$extension(oncias_SemanticState$ScopeLocation$_MODULE$, var$1.$currentScope)).$get0()).$location.$elem.$symbolTable);
            var$4 = oncias_Scope_allSymbols(var$1.$currentScope.$elem);
            var$5 = var$1.$recordedScopes;
            var$6 = new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_0;
            var$6.$_0737 = var$2;
            var$2 = (var$5.$filter1(var$6)).$map1(new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_1);
            s_Predef$_$callClinit();
            var$2 = sc_AbstractIterable_groupMapReduce(var$2.$flatten(s_Predef$_$conforms(s_Predef$_MODULE$)), new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_2, new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_3, new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_4);
            var$6 = new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_5;
            var$6.$_0738 = var$2;
            var$2 = (var$4.$filterNot1(var$6)).$map14(new oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_6);
            var$4 = new $java.oncias_SemanticExpressionCheck$$anonfun$2;
            var$4.$innerDefinitions$1 = var$2;
            var$2 = oncias_SemanticCheckResult__init_(var$1, ((var$3.$collect1(var$4)).$map1(new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_7)).$toSeq());
        }
        return var$2;
    };
    $java.oncia_TransactionsCommandClause$checkYieldItems$lambda$_7_0 = function() {
        jl_Object.call(this);
        this.$_0360 = null;
    };
    $java.oncia_TransactionsCommandClause$checkYieldItems$lambda$_7_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = (var$0.$_0360.$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap1()).$get1(var$1.$originalName);
        var$3 = new $java.oncia_CommandResultItem$semanticCheck$lambda$_50_0;
        var$3.$_0739 = var$1;
        var$2 = s_Option_map(var$2, var$3);
        var$3 = new $java.oncia_CommandResultItem$semanticCheck$lambda$_50_1;
        var$3.$_0740 = var$1;
        return s_Option_getOrElse(var$2, var$3);
    };
    $java.onciu_AnonymousVariableNameGenerator$ = $rt_classWithoutFields();
    $java.onciu_AnonymousVariableNameGenerator$_MODULE$ = null;
    $java.onciu_AnonymousVariableNameGenerator$_generatorName = null;
    $java.onciu_AnonymousVariableNameGenerator$_org$neo4j$cypher$internal$util$AnonymousVariableNameGenerator$$prefix = null;
    $java.onciu_AnonymousVariableNameGenerator$_$callClinit = function() {
        $java.onciu_AnonymousVariableNameGenerator$_$callClinit = $rt_eraseClinit($java.onciu_AnonymousVariableNameGenerator$);
        $java.onciu_AnonymousVariableNameGenerator$__clinit_();
    };
    $java.onciu_AnonymousVariableNameGenerator$__clinit_ = function() {
        var var$1, var$2;
        var$1 = new $java.onciu_AnonymousVariableNameGenerator$;
        $java.onciu_AnonymousVariableNameGenerator$_$callClinit();
        $java.onciu_AnonymousVariableNameGenerator$_MODULE$ = var$1;
        $java.onciu_AnonymousVariableNameGenerator$_generatorName = $rt_s(3225);
        var$1 = $java.onciu_AnonymousVariableNameGenerator$_generatorName0(var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(384)), var$1);
        $java.onciu_AnonymousVariableNameGenerator$_org$neo4j$cypher$internal$util$AnonymousVariableNameGenerator$$prefix = jl_AbstractStringBuilder_toString(var$2);
    };
    $java.onciu_AnonymousVariableNameGenerator$_generatorName0 = function($this) {
        $java.onciu_AnonymousVariableNameGenerator$_$callClinit();
        return $java.onciu_AnonymousVariableNameGenerator$_generatorName;
    };
    $java.onciu_AnonymousVariableNameGenerator$_isNamed = function($this, $x) {
        $java.onciuh_NameDeduplicator$_$callClinit();
        return jur_Matcher_matches(jur_Pattern_matcher($java.onciuh_NameDeduplicator$_UNNAMED_PATTERN.$pattern4, $x)) ? 0 : 1;
    };
    $java.oncia_Clause$$anonfun$2 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_Clause$$anonfun$2_applyOrElse = function($this, $x1, $default) {
        if ($x1 instanceof oncie_RelationshipPattern) {
            $default = $x1;
            if ($default.$length2 instanceof s_Some) {
                $x1 = new $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_0;
                $x1.$_0741 = $default;
                return $x1;
            }
        }
        if (!($x1 instanceof oncia_SubqueryCall ? 1 : !$rt_isInstance($x1, oncia_FullSubqueryExpression) ? 0 : 1))
            return s_PartialFunction$_fallback_fn;
        return new $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_1;
    };
    $java.oncia_Clause$$anonfun$3 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_Clause$$anonfun$3_applyOrElse = function($this, $x2, $default) {
        if ($x2 instanceof oncie_QuantifiedPath)
            return new $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_0;
        if (!($x2 instanceof oncia_SubqueryCall ? 1 : !$rt_isInstance($x2, oncia_FullSubqueryExpression) ? 0 : 1))
            return new $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_2;
        return new $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_1;
    };
    $java.oncia_Clause$checkIfMixingLegacyVarLengthWithQPPs$lambda$_14_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0677 = null;
        a.$_1210 = null;
    };
    $java.oncia_Clause$checkIfMixingLegacyVarLengthWithQPPs$lambda$_14_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0677;
        var$2 = var$0.$_1210;
        var$3 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$4 = new $java.oncia_Clause$$anonfun$checkIfMixingLegacyVarLengthWithQPPs$1$lambda$_24_0;
        var$4.$_0742 = var$1;
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$3, var$2, var$4);
    };
    $java.oncia_ReadAdministrationCommand$checkProjection$1$lambda$_32_0 = function() {
        jl_Object.call(this);
        this.$_0666 = null;
    };
    $java.oncia_ReadAdministrationCommand$checkProjection$1$lambda$_32_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0666;
        var$2 = var$2.$semanticCheckContinuation(var$1.$state.$currentScope.$elem, var$2.$semanticCheckContinuation$default$2());
        var$3 = new $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$5$lambda$_31_0;
        var$3.$_0743 = var$1;
        return oncias_SemanticCheck_map$(var$2, var$3);
    };
    var oncil_SolvableLabelExpression$ = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$_MODULE$ = null;
    function oncil_SolvableLabelExpression$__clinit_() {
        $java.oncil_SolvableLabelExpression$_MODULE$ = new oncil_SolvableLabelExpression$;
    }
    $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec = function($this, $labelExpression) {
        var $label, $conjointExpressions, $lhs, $rhs, var$6, $not, $disjointExpressions;
        if ($labelExpression instanceof oncil_LabelExpression$Wildcard) {
            $labelExpression = $java.suc_TailCalls$_MODULE$;
            s_Predef$_$callClinit();
            s_Predef$_Set(s_Predef$_MODULE$);
            return $java.suc_TailCalls$_done($labelExpression, $java.oncil_SolvableLabelExpression$_build($this, sci_Set$EmptySet$_MODULE$, new $java.oncil_SolvableLabelExpression$$wildcard$lambda$_4_0));
        }
        if ($labelExpression instanceof oncil_LabelExpression$Leaf) {
            $label = $labelExpression.$name8;
            $labelExpression = $java.suc_TailCalls$_MODULE$;
            $conjointExpressions = $label.$name3();
            s_Predef$_$callClinit();
            $lhs = s_Predef$_Set(s_Predef$_MODULE$);
            $rhs = sr_ScalaRunTime$_MODULE$;
            var$6 = $rt_createArray(jl_String, 1);
            var$6.data[0] = $conjointExpressions;
            $rhs = $lhs.$from0(sr_ScalaRunTime$_wrapRefArray($rhs, var$6));
            $lhs = new $java.oncil_SolvableLabelExpression$$label$lambda$_5_0;
            $lhs.$_0744 = $conjointExpressions;
            return $java.suc_TailCalls$_done($labelExpression, $java.oncil_SolvableLabelExpression$_build($this, $rhs, $lhs));
        }
        if ($labelExpression instanceof oncil_LabelExpression$Negation) {
            $not = $labelExpression.$e;
            if ($not !== null) {
                $labelExpression = $java.suc_TailCalls$_MODULE$;
                $conjointExpressions = new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_0;
                $conjointExpressions.$_0745 = $not;
                return $java.suc_TailCalls$TailRec_map($java.suc_TailCalls$_tailcall($labelExpression, $conjointExpressions), new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_1);
            }
        }
        if ($labelExpression instanceof oncil_LabelExpression$ColonConjunction) {
            $conjointExpressions = $labelExpression;
            $lhs = $conjointExpressions.$lhs4;
            $rhs = $conjointExpressions.$rhs4;
            if ($lhs !== null && $rhs !== null)
                return $java.onciut_TailCallsUtil$_map2($java.onciut_TailCallsUtil$_MODULE$, $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($this, $lhs), $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($this, $rhs), new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_2);
        }
        if ($labelExpression instanceof oncil_LabelExpression$Conjunctions) {
            $conjointExpressions = $labelExpression.$children0;
            if ($conjointExpressions !== null)
                return $java.suc_TailCalls$TailRec_map($java.onciut_TailCallsUtil$_traverse($java.onciut_TailCallsUtil$_MODULE$, $conjointExpressions.$toList(), new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_3), new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_4);
        }
        if ($labelExpression instanceof oncil_LabelExpression$ColonDisjunction) {
            $conjointExpressions = $labelExpression;
            $lhs = $conjointExpressions.$lhs3;
            $rhs = $conjointExpressions.$rhs3;
            if ($lhs !== null && $rhs !== null)
                return $java.onciut_TailCallsUtil$_map2($java.onciut_TailCallsUtil$_MODULE$, $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($this, $lhs), $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($this, $rhs), new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_5);
        }
        if ($labelExpression instanceof oncil_LabelExpression$Disjunctions) {
            $disjointExpressions = $labelExpression.$children;
            if ($disjointExpressions !== null)
                return $java.suc_TailCalls$TailRec_map($java.onciut_TailCallsUtil$_traverse($java.onciut_TailCallsUtil$_MODULE$, $disjointExpressions.$toList(), new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_6), new $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_7);
        }
        $rt_throw(s_MatchError__init_($labelExpression));
    };
    $java.oncil_SolvableLabelExpression$_build = function($this, $labels, $matches) {
        var var$3;
        var$3 = new $java.oncil_SolvableLabelExpression;
        var$3.$allLabels = $labels;
        var$3.$matches2 = $matches;
        return var$3;
    };
    $java.oncias_SemanticPatternCheck$$unsatisfiableRelTypeExpression$1$lambda$_113_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0659 = null;
        a.$_1202 = null;
    };
    $java.oncias_SemanticPatternCheck$$unsatisfiableRelTypeExpression$1$lambda$_113_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0659;
        var$2 = var$0.$_1202;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = new $java.onciu_UnsatisfiableRelationshipTypeExpression;
        var$5 = var$1.$position2();
        var$1 = onciap_DefaultExpressionStringifier_stringifyLabelExpression(var$2, var$1);
        var$4.$position297 = var$5;
        var$4.$labelExpression4 = var$1;
        return $java.oncias_SemanticPatternCheck$_warn(var$3, var$4);
    };
    $java.oncil_SolvableLabelExpression = function() {
        var a = this; jl_Object.call(a);
        a.$allLabels = null;
        a.$matches2 = null;
    };
    $java.oncil_SolvableLabelExpression_binary = function($this, $rhs, $f) {
        var var$3, var$4, var$5;
        var$3 = $java.oncil_SolvableLabelExpression$_MODULE$;
        var$4 = $this.$allLabels.$concat1($rhs.$allLabels);
        var$5 = new $java.oncil_SolvableLabelExpression$binary$lambda$_14_0;
        var$5.$_0746 = $this;
        var$5.$_1237 = $f;
        var$5.$_270 = $rhs;
        return $java.oncil_SolvableLabelExpression$_build(var$3, var$4, var$5);
    };
    $java.oncil_SolvableLabelExpression_and = function($this, $rhs) {
        return $java.oncil_SolvableLabelExpression_binary($this, $rhs, new $java.oncil_SolvableLabelExpression$and$lambda$_15_0);
    };
    $java.oncil_SolvableLabelExpression_or = function($this, $rhs) {
        return $java.oncil_SolvableLabelExpression_binary($this, $rhs, new $java.oncil_SolvableLabelExpression$or$lambda$_16_0);
    };
    $java.oncil_SolvableLabelExpression_productPrefix = function($this) {
        return $rt_s(3226);
    };
    $java.oncil_SolvableLabelExpression_productArity = function($this) {
        return 2;
    };
    $java.oncil_SolvableLabelExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$allLabels;
            case 1:
                return $this.$matches2;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_SolvableLabelExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_SolvableLabelExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_SolvableLabelExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_SolvableLabelExpression_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncil_SolvableLabelExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$allLabels;
                        var$3 = $x$1.$allLabels;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$matches2;
                        $x$1 = $x$1.$matches2;
                        if (var$3 !== null) {
                            if (!jl_Object_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncil_SolvableLabelExpression))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.onciu_RewritableCompat$PROXY$7_251 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_251_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_251 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_251_paramsLength(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_252 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_252_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_252 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_252_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_253 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_253_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_253 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_253_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_254 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_254_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_254 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_254_paramsLength(var$1) {
        return (jl_Integer_valueOf(1)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_255 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_255_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_255 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_255_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    var onciu_RewritableCompat$PROXY$3_928 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_928_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncie_VariableGrouping__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_929 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_929_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncil_LabelExpression$Negation__init_(var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_930 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_930_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ListSlice__init_(var$3[0], var$3[1], var$3[2], var$3[3]);
    }
    var onciu_RewritableCompat$PROXY$3_931 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_931_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncie_ContainerIndex__init_(var$3[0], var$3[1], var$3[2]);
    }
    $java.onciu_RewritableCompat$PROXY$7_256 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_256_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_256 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_256_paramsLength(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_257 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_257_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_257 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_257_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    $java.s_Enumeration$scala$Enumeration$$nameOf$lambda$_23_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0441 = null;
        a.$_1131 = 0;
    };
    $java.s_Enumeration$scala$Enumeration$$nameOf$lambda$_23_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0441;
        var$2 = var$0.$_1131;
        $java.s_Enumeration_populateNameMap(var$1);
        return scm_HashMap_apply(var$1.$nmap, jl_Integer_valueOf(var$2));
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0663 = null;
        a.$_1204 = null;
        a.$_264 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = var$1;
        var$2 = var$0.$_0663;
        var$3 = var$0.$_1204;
        var$4 = var$0.$_264;
        var$5 = new $java.onciu_Foldable$SkipChildren;
        var$6 = new s_Tuple2;
        var$7 = var$1.$_10;
        var$8 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$6$lambda$_3_0;
        var$8.$_0747 = var$2;
        s_Tuple2__init_0(var$6, var$7.$concat1(s_Option_filter(var$3, var$8)), var$1.$_20.$concat1(oncifp_CreatePatternSelfReferenceCheck$_org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1(var$4, var$2.$allSymbolDefinitions$10)));
        $java.onciu_Foldable$SkipChildren__init_0(var$5, var$6);
        return var$5;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0665 = null;
        a.$_1205 = null;
        a.$_265 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$1 = var$1;
        var$2 = var$0.$_0665;
        var$3 = var$0.$_1205;
        var$4 = var$0.$_265;
        var$5 = new $java.onciu_Foldable$SkipChildren;
        var$6 = new s_Tuple2;
        var$7 = var$1.$_10;
        var$8 = new $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$8$lambda$_5_0;
        var$8.$_0748 = var$2;
        s_Tuple2__init_0(var$6, var$7.$concat1(s_Option_filter(var$3, var$8)), var$1.$_20.$concat1(oncifp_CreatePatternSelfReferenceCheck$_org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1(var$4, var$2.$allSymbolDefinitions$10)));
        $java.onciu_Foldable$SkipChildren__init_0(var$5, var$6);
        return var$5;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_2 = function() {
        jl_Object.call(this);
        this.$_0664 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0664;
        return $java.onciu_Foldable$TraverseChildren__init_0(s_Tuple2__init_(var$1.$_10.$incl(var$2), var$1.$_20));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0652 = null;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0652;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$chain(oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3227), var$2.$position228))));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_1 = function() {
        jl_Object.call(this);
        this.$_0653 = null;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0653;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$chain(oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3228), var$2.$position42))));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_2 = function() {
        jl_Object.call(this);
        this.$_0654 = null;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0654;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$chain(oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3229), var$2.$position32))));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_3 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_3_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    $java.onm_MessageUtil = $rt_classWithoutFields();
    $java.oncias_SemanticCheckableIterableOnce$$semanticCheck$extension$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncias_SemanticCheckableIterableOnce$$semanticCheck$extension$lambda$_1_0_apply = function(var$0, var$1) {
        return var$1.$semanticCheck();
    };
    $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_0 = $rt_classWithoutFields();
    $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_0_apply = function(var$0) {
        return oncias_SemanticCheck$_success;
    };
    $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_1 = $rt_classWithoutFields();
    $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_1_apply = function(var$0, var$1) {
        return var$1.$semanticCheck();
    };
    $java.jl_ArithmeticException = $rt_classWithoutFields(jl_RuntimeException);
    $java.oncia_Where$$checkExpression$lambda$_5_0 = $rt_classWithoutFields();
    $java.oncia_Where$$checkExpression$lambda$_5_0_apply = function(var$0, var$1) {
        return var$1.$propertyKey0;
    };
    $java.oncia_Where$$checkExpression$lambda$_5_1 = $rt_classWithoutFields();
    $java.oncia_Where$$checkExpression$lambda$_5_1_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_BooleanType_covariant(oncius_package$_CTBoolean(oncius_package$_MODULE$));
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_22_0() {
        jl_Object.call(this);
        this.$_098 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_22_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_098;
        if (!(var$1 instanceof oncia_AliasedReturnItem)) {
            if (!(var$1 instanceof oncia_UnaliasedReturnItem))
                $rt_throw(s_MatchError__init_(var$1));
            var$1 = var$1.$expression9;
            var$1 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$1);
        } else {
            var$1 = var$1;
            var$3 = var$1.$expression10;
            var$4 = var$1.$variable13;
            var$1 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$3);
            var$4 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$4);
            var$2 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$2);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$1), $rt_s(367)), var$4);
            var$1 = jl_AbstractStringBuilder_toString(var$2);
        }
        return var$1;
    };
    $java.oncia_ProjectionClause$$checkAliasedReturnItems$lambda$_2_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0351 = null;
        a.$_1105 = null;
    };
    $java.oncia_ProjectionClause$$checkAliasedReturnItems$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$0.$_0351;
        var$2 = var$0.$_1105;
        if (var$1 === null)
            var$1 = sci_Nil$_MODULE$;
        else {
            var$1 = var$1.$items.$filter1(new $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_0);
            var$3 = new $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_1;
            var$3.$_0749 = var$2;
            var$1 = var$1.$map1(var$3);
        }
        return var$1;
    };
    $java.oncias_package$$liftSemanticErrorDefsFunc$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0370 = null;
    };
    $java.oncias_package$$liftSemanticErrorDefsFunc$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0370;
        return oncias_SemanticCheckResult__init_(var$1, var$2.$apply(var$1));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$3 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncias_SemanticPatternCheck$$anonfun$3_applyOrElse = function($this, $x, $default) {
        var var$3;
        var$3 = onciu_Foldable_folder$($x.$expression1());
        sr_ClassTag$_$callClinit();
        return (onciu_Foldable$Folder_findAllByClass(var$3, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_Property)))).$map1(new $java.oncias_SemanticPatternCheck$$anonfun$3$applyOrElse$lambda$_0_0);
    };
    $java.oncia_SubqueryCall$checkSubquery$lambda$_62_0 = function() {
        jl_Object.call(this);
        this.$_0375 = null;
    };
    $java.oncia_SubqueryCall$checkSubquery$lambda$_62_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0375;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = var$1.$state;
        var$5 = oncias_SemanticState$ScopeLocation$_MODULE$;
        var$6 = var$4.$currentScope;
        oncias_SemanticState$_$callClinit();
        var$3 = $java.oncias_SemanticCheck$_setState(var$3, oncias_SemanticState_copy(var$4, oncias_SemanticState$ScopeLocation$_newChildScope$extension(var$5, onciuh_TreeZipper$Location_root(var$6)), var$4.$typeTable, var$4.$recordedScopes, var$4.$notifications, var$4.$features1, var$4.$declareVariablesToSuppressDuplicateErrors, var$4.$semanticCheckHasRunOnce));
        var$5 = new $java.oncia_SubqueryCall$$anonfun$checkSubquery$1$lambda$_90_0;
        var$5.$_0750 = var$2;
        var$5.$_1238 = var$1;
        return oncias_SemanticCheck_flatMap$(var$3, var$5);
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_0 = function() {
        jl_Object.call(this);
        this.$_0588 = null;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0588;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncias_SemanticPatternCheck$_declareVariables(oncias_SemanticPatternCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_1 = function() {
        jl_Object.call(this);
        this.$_0589 = null;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0589;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticPatternCheck$_check(oncias_SemanticPatternCheck$_MODULE$, var$2, var$1);
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_2 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = sr_BoxesRunTime_unboxToBoolean(onciu_Foldable$Folder_treeFold(onciu_Foldable_folder$(var$1.$element()), jl_Boolean_valueOf(1), new $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1));
        var$4 = new $java.oncias_SemanticPatternCheck$$checkMinimumNodeCount$lambda$_46_0;
        var$4.$_0751 = var$1;
        return oncias_SemanticCheck$_when(var$2, var$3, var$4);
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_3 = function() {
        var a = this; jl_Object.call(a);
        a.$_0590 = null;
        a.$_1180 = null;
    };
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_3_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        a: {
            b: {
                c: {
                    var$1 = var$0.$_0590;
                    var$2 = var$0.$_1180;
                    oncias_SemanticPatternCheck$_$callClinit();
                    var$3 = oncias_SemanticCheck$_MODULE$;
                    var$4 = $java.oncie_Pattern$SemanticContext$Create$_MODULE$;
                    if (var$1 !== null) {
                        if (jl_Object_equals(var$1, var$4))
                            break c;
                        else
                            break b;
                    }
                    if (var$4 !== null)
                        break b;
                }
                var$5 = 0;
                break a;
            }
            var$5 = 1;
        }
        var$1 = new $java.oncias_SemanticPatternCheck$$$anonfun$check$4$lambda$_76_0;
        var$1.$_0752 = var$2;
        return oncias_SemanticCheck$_when(var$3, var$5, var$1);
    };
    $java.oncil_LabelExpression$Conjunctions$unnestConjunctions$lambda$_13_0 = $rt_classWithoutFields();
    $java.oncil_LabelExpression$Conjunctions$unnestConjunctions$lambda$_13_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        if (var$1 instanceof oncil_LabelExpression$Conjunctions)
            var$1 = var$1.$children0;
        else {
            s_package$_$callClinit();
            var$2 = s_package$_Vector0(s_package$_MODULE$);
            var$3 = sr_ScalaRunTime$_MODULE$;
            var$4 = $rt_createArray($java.oncil_LabelExpression, 1);
            var$4.data[0] = var$1;
            var$1 = var$2.$from0(sr_ScalaRunTime$_wrapRefArray(var$3, var$4));
        }
        return var$1;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$4 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncias_SemanticPatternCheck$$anonfun$4_applyOrElse = function($this, $x, $default) {
        $x = $x;
        oncias_SemanticPatternCheck$_$callClinit();
        return !s_Option_isDefined($java.oncias_SemanticPatternCheck$_org$neo4j$cypher$internal$ast$semantics$SemanticPatternCheck$$checkValidTokenName(oncias_SemanticPatternCheck$_MODULE$, $x.$name11)) ? $default.$apply($x) : s_Tuple2__init_(($java.oncias_SemanticPatternCheck$_org$neo4j$cypher$internal$ast$semantics$SemanticPatternCheck$$checkValidTokenName(oncias_SemanticPatternCheck$_MODULE$, $x.$name11)).$get0(), $x.$position58);
    };
    $java.oncius_TypeSpec$intersect$lambda$_15_0 = function() {
        jl_Object.call(this);
        this.$_0522 = null;
    };
    $java.oncius_TypeSpec$intersect$lambda$_15_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0522.$ranges;
        var$3 = new $java.oncius_TypeSpec$$anonfun$intersect$1$lambda$_53_0;
        var$3.$_0753 = var$1;
        return var$2.$flatMap(var$3);
    };
    function sci_List$partition$lambda$_92_0() {
        var a = this; jl_Object.call(a);
        a.$_018 = null;
        a.$_15 = null;
        a.$_24 = null;
    }
    $java.sci_List$partition$lambda$_92_0_apply = function(var$0, var$1) {
        return sc_StrictOptimizedIterableOps_$anonfun$partition$1(var$0.$_018, var$0.$_15, var$0.$_24, var$1);
    };
    function onciap_DefaultPatternStringifier$apply$lambda$_0_0() {
        jl_Object.call(this);
        this.$_0140 = null;
    }
    $java.onciap_DefaultPatternStringifier$apply$lambda$_0_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultPatternStringifier_apply0(var$0.$_0140, var$1);
    };
    $java.onciu_Foldable$Folder$$anonfun$treeCollect$1$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0700 = null;
        a.$_1213 = null;
    };
    $java.onciu_Foldable$Folder$$anonfun$treeCollect$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0700;
        var$3 = var$0.$_1213;
        return var$1.$appended(sr_AbstractPartialFunction_apply(var$2.$f$10, var$3));
    };
    function sc_StringOps$$anon$1() {
        var a = this; sc_AbstractIterator.call(a);
        a.$scala$collection$StringOps$$anon$$len = 0;
        a.$scala$collection$StringOps$$anon$$index = 0;
        a.$$this$2 = null;
        a.$stripped$1 = 0;
    }
    $java.sc_StringOps$$anon$1_hasNext = function($this) {
        if ($this.$scala$collection$StringOps$$anon$$index < $this.$scala$collection$StringOps$$anon$$len ? 0 : 1)
            return 0;
        return 1;
    };
    $java.sc_StringOps$$anon$1_next = function($this) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = $this.$scala$collection$StringOps$$anon$$index;
        if (var$1 < $this.$scala$collection$StringOps$$anon$$len ? 0 : 1)
            var$2 = sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        else {
            while (true) {
                var$3 = $this.$scala$collection$StringOps$$anon$$index;
                if (var$3 < $this.$scala$collection$StringOps$$anon$$len ? 0 : 1)
                    break;
                var$3 = jl_String_charAt($this.$$this$2, var$3);
                if (var$3 != 13 && var$3 != 10 ? 0 : 1)
                    break;
                $this.$scala$collection$StringOps$$anon$$index = $this.$scala$collection$StringOps$$anon$$index + 1 | 0;
            }
            var$3 = $this.$scala$collection$StringOps$$anon$$index;
            if (!(var$3 < $this.$scala$collection$StringOps$$anon$$len ? 0 : 1)) {
                var$4 = jl_String_charAt($this.$$this$2, var$3);
                var$5 = $this.$scala$collection$StringOps$$anon$$index + 1 | 0;
                $this.$scala$collection$StringOps$$anon$$index = var$5;
                if (!(var$5 < $this.$scala$collection$StringOps$$anon$$len ? 0 : 1)) {
                    var$5 = jl_String_charAt($this.$$this$2, var$5);
                    if (var$4 == 13 && var$5 == 10 ? 1 : 0)
                        $this.$scala$collection$StringOps$$anon$$index = $this.$scala$collection$StringOps$$anon$$index + 1 | 0;
                }
                if (!$this.$stripped$1)
                    var$3 = $this.$scala$collection$StringOps$$anon$$index;
            }
            var$2 = jl_String_substring0($this.$$this$2, var$1, var$3);
        }
        return var$2;
    };
    function sc_StringOps$$stripMargin$extension$lambda$_68_0() {
        var a = this; jl_Object.call(a);
        a.$_0135 = 0;
        a.$_124 = null;
    }
    $java.sc_StringOps$$stripMargin$extension$lambda$_68_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0135;
        var$3 = var$0.$_124;
        var$4 = jl_String_length(var$1);
        var$5 = 0;
        while (true) {
            var$6 = $rt_compare(var$5, var$4);
            if (var$6 >= 0)
                break;
            if (jl_String_charAt(var$1, var$5) > 32)
                break;
            var$5 = var$5 + 1 | 0;
        }
        if (var$6 < 0 && jl_String_charAt(var$1, var$5) == var$2)
            var$1 = jl_String_substring(var$1, var$5 + 1 | 0);
        jl_AbstractStringBuilder_append1(var$3, var$1);
        return var$3;
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$possibleInnerTypes$lambda$_6_0 = function() {
        jl_Object.call(this);
        this.$_0581 = null;
    };
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$possibleInnerTypes$lambda$_6_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0581;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(oncias_SemanticExpressionCheck$_MODULE$, var$2.$expression1()), var$1);
        oncius_package$_$callClinit();
        var$2 = oncius_package$_MODULE$;
        return $java.oncius_TypeSpec_unwrapLists($java.oncius_TypeSpec_constrain(var$1, oncius_package$_CTList(var$2, oncius_package$_CTAny(var$2))));
    };
    $java.oncia_SingleQuery$semanticCheckInSubqueryExpressionContext$lambda$_65_0 = function() {
        jl_Object.call(this);
        this.$_0326 = null;
    };
    $java.oncia_SingleQuery$semanticCheckInSubqueryExpressionContext$lambda$_65_0_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_checkClauses(var$0.$_0326, var$1, s_None$_MODULE$);
    };
    $java.oncia_SingleQuery$containsUpdates$lambda$_51_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$containsUpdates$lambda$_51_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$1 instanceof oncia_SubqueryCall ? var$1.$innerQuery.$containsUpdates() : var$1 instanceof $java.oncia_CallClause ? 0 : !$rt_isInstance(var$1, $java.oncia_UpdateClause) ? 0 : 1);
    };
    function oncias_SemanticAnalysisTooling$$org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScopeWithVariablesFromRecordedScope$lambda$_2_0() {
        var a = this; jl_Object.call(a);
        a.$_0283 = null;
        a.$_185 = null;
    }
    $java.oncias_SemanticAnalysisTooling$$org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScopeWithVariablesFromRecordedScope$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0283;
        var$3 = var$0.$_185;
        oncias_SemanticAnalysisTooling$_$callClinit();
        var$4 = (var$1.$recordedScopes.$apply(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, var$2))).$location.$elem;
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, oncias_SemanticState_importValuesFromScope(oncias_SemanticState_newChildScope(var$1), var$4, var$3));
    };
    $java.oncias_SemanticCheck$$warn$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0587 = null;
    };
    $java.oncias_SemanticCheck$$warn$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$2 = oncias_SemanticState_addNotification(var$1, var$0.$_0587);
        var$3 = new oncias_SemanticCheckResult;
        s_package$_$callClinit();
        oncias_SemanticCheckResult__init_0(var$3, var$2, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
        return var$3;
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0463 = null;
        a.$_1144 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0463;
        var$2 = var$0.$_1144;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticAnalysisTooling_error$(oncias_SemanticExpressionCheck$_MODULE$, $rt_s(3230), (($java.oncias_SemanticExpressionCheck$_colonDisjunctions$1(var$1, var$2)).$head()).$position217);
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0464 = null;
        a.$_1145 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_1_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0464;
        var$2 = var$0.$_1145;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticAnalysisTooling_error$(oncias_SemanticExpressionCheck$_MODULE$, $rt_s(3231), (($java.oncias_SemanticExpressionCheck$_colonConjunctions$1(var$1, var$2)).$head()).$position262);
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0465 = null;
        a.$_1146 = null;
        a.$_256 = null;
        a.$_313 = null;
    };
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_2_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$0.$_0465;
        var$2 = var$0.$_1146;
        var$3 = var$0.$_256;
        var$4 = var$0.$_313;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$5 = oncias_SemanticCheck$_MODULE$;
        var$6 = sc_IterableOnceOps_nonEmpty$($java.oncias_SemanticExpressionCheck$_colonConjunctions$1(var$2, var$1)) && var$1.$containsGpmSpecificLabelExpression() ? 1 : 0;
        var$7 = new $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpression$3$lambda$_186_0;
        var$7.$_0754 = var$1;
        var$7.$_1239 = var$3;
        var$7.$_271 = var$2;
        var$7.$_315 = var$4;
        return oncias_SemanticCheck$_when(var$5, var$6, var$7);
    };
    var oncias_SemanticState$expressionType$lambda$_42_0 = $rt_classWithoutFields();
    $java.oncias_SemanticState$expressionType$lambda$_42_0_apply = function(var$0) {
        var var$1;
        var$1 = oncias_ExpressionTypeInfo$_MODULE$;
        oncius_TypeSpec$_$callClinit();
        return oncias_ExpressionTypeInfo$_apply(var$1, $java.oncius_TypeSpec$_all(oncius_TypeSpec$_MODULE$), s_None$_MODULE$);
    };
    $java.oncius_TypeRange$contains$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncius_TypeRange$contains$lambda$_7_0_apply$mcZ$sp = function(var$0) {
        return 1;
    };
    $java.oncius_TypeRange$contains$lambda$_7_1 = function() {
        jl_Object.call(this);
        this.$_0517 = null;
    };
    $java.oncius_TypeRange$contains$lambda$_7_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0517.$upper1;
        var$3 = new $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_0;
        var$4 = new $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_1;
        var$4.$_0755 = var$1;
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(s_Option_fold(var$2, var$3, var$4)));
    };
    $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0741 = null;
    };
    $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0741;
        return $java.onciu_Foldable$TraverseChildren__init_0(var$1.$appended(var$2));
    };
    $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_1 = $rt_classWithoutFields();
    $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        sr_BoxesRunTime_unboxToBoolean(var$1);
        return $java.onciu_Foldable$SkipChildren__init_(jl_Boolean_valueOf(1));
    };
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_2 = $rt_classWithoutFields();
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2;
        var$2 = sr_BoxesRunTime_unboxToBoolean(var$1);
        return !var$2 ? $java.onciu_Foldable$TraverseChildren__init_0(jl_Boolean_valueOf(var$2)) : $java.onciu_Foldable$SkipChildren__init_(jl_Boolean_valueOf(var$2));
    };
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_1 = $rt_classWithoutFields();
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2;
        var$2 = sr_BoxesRunTime_unboxToBoolean(var$1);
        return $java.onciu_Foldable$SkipChildren__init_(jl_Boolean_valueOf(var$2));
    };
    $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_0 = $rt_classWithoutFields();
    $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_0_apply = function(var$0, var$1) {
        return var$1.$name3();
    };
    $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_1 = $rt_classWithoutFields();
    $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_1_apply = function(var$0, var$1) {
        a: {
            var$1 = var$1;
            if (var$1 !== null) {
                var$1 = var$1.$_20;
                if (var$1.$length() > 1) {
                    var$1 = oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3232), (var$1.$head()).$position2()));
                    break a;
                }
            }
            var$1 = oncias_SemanticCheck$_success;
        }
        return var$1;
    };
    var suc_TailCalls$ = $rt_classWithoutFields();
    $java.suc_TailCalls$_MODULE$ = null;
    function suc_TailCalls$__clinit_() {
        $java.suc_TailCalls$_MODULE$ = new suc_TailCalls$;
    }
    $java.suc_TailCalls$_tailcall = function($this, $rest) {
        return $java.suc_TailCalls$Call__init_($rest);
    };
    $java.suc_TailCalls$_done = function($this, $result) {
        return $java.suc_TailCalls$Done__init_($result);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_0 = function() {
        jl_Object.call(this);
        this.$_0745 = null;
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0745;
        return $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($java.oncil_SolvableLabelExpression$_MODULE$, var$1);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_1 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = $java.oncil_SolvableLabelExpression$_MODULE$;
        var$3 = var$1.$allLabels;
        var$4 = new $java.oncil_SolvableLabelExpression$not$lambda$_13_0;
        var$4.$_0756 = var$1;
        return $java.oncil_SolvableLabelExpression$_build(var$2, var$3, var$4);
    };
    var onciut_TailCallsUtil$ = $rt_classWithoutFields();
    $java.onciut_TailCallsUtil$_MODULE$ = null;
    function onciut_TailCallsUtil$__clinit_() {
        $java.onciut_TailCallsUtil$_MODULE$ = new onciut_TailCallsUtil$;
    }
    $java.onciut_TailCallsUtil$_traverse = function($this, $as, $f) {
        var var$3, var$4;
        if (sci_List_isEmpty($as)) {
            $as = $java.suc_TailCalls$_MODULE$;
            $java.sc_Seq$_$callClinit();
            return $java.suc_TailCalls$_done($as, sc_SeqFactory$Delegate_empty($java.sc_Seq$_MODULE$));
        }
        var$3 = $java.suc_TailCalls$_MODULE$;
        var$4 = new $java.onciut_TailCallsUtil$$traverse$lambda$_1_0;
        var$4.$_0757 = $f;
        var$4.$_1240 = $as;
        var$3 = $java.suc_TailCalls$_tailcall(var$3, var$4);
        var$4 = new $java.onciut_TailCallsUtil$$traverse$lambda$_1_1;
        var$4.$_0758 = $as;
        var$4.$_1241 = $f;
        return $java.suc_TailCalls$TailRec_flatMap(var$3, var$4);
    };
    $java.onciut_TailCallsUtil$_map2 = function($this, $recA, $recB, $f) {
        var var$4;
        var$4 = new $java.onciut_TailCallsUtil$$map2$lambda$_2_0;
        var$4.$_0759 = $recB;
        var$4.$_1242 = $f;
        return $java.suc_TailCalls$TailRec_flatMap($recA, var$4);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_2 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_2_apply = function(var$0, var$1, var$2) {
        return $java.oncil_SolvableLabelExpression_and(var$1, var$2);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_3 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($java.oncil_SolvableLabelExpression$_MODULE$, var$1);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_4 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_4_apply = function(var$0, var$1) {
        return var$1.$reduceLeft(new $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$5$lambda$_15_0);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_5 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_5_apply = function(var$0, var$1, var$2) {
        return $java.oncil_SolvableLabelExpression_or(var$1, var$2);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_6 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_6_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncil_SolvableLabelExpression$_extractLabelExpressionRec($java.oncil_SolvableLabelExpression$_MODULE$, var$1);
    };
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_7 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_7_apply = function(var$0, var$1) {
        return var$1.$reduceLeft(new $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$9$lambda$_19_0);
    };
    $java.suc_TailCalls$TailRec = $rt_classWithoutFields();
    $java.suc_TailCalls$TailRec_map = function($this, $f) {
        var $flatMap_f, $flatMap_a, var$4, var$5;
        $flatMap_f = new $java.suc_TailCalls$TailRec$map$lambda$_0_0;
        $flatMap_f.$_0760 = $f;
        if ($this instanceof $java.suc_TailCalls$Done) {
            $flatMap_a = $this.$value37;
            $f = new $java.suc_TailCalls$Call;
            var$4 = new $java.suc_TailCalls$TailRec$map$lambda$_0_1;
            var$4.$_0761 = $flatMap_f;
            var$4.$_1243 = $flatMap_a;
            $java.suc_TailCalls$Call__init_0($f, var$4);
            return $f;
        }
        if ($this instanceof $java.suc_TailCalls$Call)
            return $java.suc_TailCalls$Cont__init_($this, $flatMap_f);
        if (!($this instanceof $java.suc_TailCalls$Cont))
            $rt_throw(s_MatchError__init_($this));
        $f = $this;
        var$4 = new $java.suc_TailCalls$Cont;
        var$5 = $f.$a0;
        $flatMap_a = new $java.suc_TailCalls$TailRec$map$lambda$_0_2;
        $flatMap_a.$_0762 = $f;
        $flatMap_a.$_1244 = $flatMap_f;
        $java.suc_TailCalls$Cont__init_0(var$4, var$5, $flatMap_a);
        return var$4;
    };
    $java.suc_TailCalls$TailRec_flatMap = function($this, $f) {
        var $a, var$3, var$4, var$5;
        if ($this instanceof $java.suc_TailCalls$Done) {
            $a = $this.$value37;
            var$3 = new $java.suc_TailCalls$Call;
            var$4 = new $java.suc_TailCalls$TailRec$flatMap$lambda$_1_0;
            var$4.$_0763 = $f;
            var$4.$_1245 = $a;
            $java.suc_TailCalls$Call__init_0(var$3, var$4);
            return var$3;
        }
        if ($this instanceof $java.suc_TailCalls$Call)
            return $java.suc_TailCalls$Cont__init_($this, $f);
        if (!($this instanceof $java.suc_TailCalls$Cont))
            $rt_throw(s_MatchError__init_($this));
        var$3 = $this;
        var$4 = new $java.suc_TailCalls$Cont;
        var$5 = var$3.$a0;
        $a = new $java.suc_TailCalls$TailRec$flatMap$lambda$_1_1;
        $a.$_0764 = var$3;
        $a.$_1246 = $f;
        $java.suc_TailCalls$Cont__init_0(var$4, var$5, $a);
        return var$4;
    };
    $java.suc_TailCalls$TailRec_result = function($this) {
        var $b, $a, $f, $flatMap_a, $g, $flatMap_f;
        while (true) {
            if ($this instanceof $java.suc_TailCalls$Done)
                return $this.$value37;
            if ($this instanceof $java.suc_TailCalls$Call) {
                $this = $this.$rest.$apply2();
                continue;
            }
            if (!($this instanceof $java.suc_TailCalls$Cont))
                $rt_throw(s_MatchError__init_($this));
            $b = $this;
            $a = $b.$a0;
            $f = $b.$f14;
            if ($a instanceof $java.suc_TailCalls$Done) {
                $this = $f.$apply($a.$value6());
                continue;
            }
            if ($a instanceof $java.suc_TailCalls$Call) {
                $this = $java.suc_TailCalls$TailRec_flatMap($a.$rest.$apply2(), $f);
                continue;
            }
            if (!($a instanceof $java.suc_TailCalls$Cont))
                $rt_throw(s_MatchError__init_($a));
            $flatMap_a = $a;
            $b = $flatMap_a.$a7();
            $g = $flatMap_a.$f15();
            $flatMap_f = new $java.suc_TailCalls$TailRec$result$lambda$_3_0;
            $flatMap_f.$_0765 = $g;
            $flatMap_f.$_1247 = $f;
            if ($b === null)
                break;
            if ($b instanceof $java.suc_TailCalls$Done) {
                $flatMap_a = $b.$value6();
                $this = new $java.suc_TailCalls$Call;
                $b = new $java.suc_TailCalls$TailRec$result$lambda$_3_1;
                $b.$_0766 = $flatMap_f;
                $b.$_1248 = $flatMap_a;
                $java.suc_TailCalls$Call__init_0($this, $b);
            } else if ($b instanceof $java.suc_TailCalls$Call)
                $this = $java.suc_TailCalls$Cont__init_($b, $flatMap_f);
            else {
                if (!($b instanceof $java.suc_TailCalls$Cont))
                    $rt_throw(s_MatchError__init_($b));
                $this = new $java.suc_TailCalls$Cont;
                $flatMap_a = $b.$a7();
                $g = new $java.suc_TailCalls$TailRec$result$lambda$_3_2;
                $g.$_0767 = $b;
                $g.$_1249 = $flatMap_f;
                $java.suc_TailCalls$Cont__init_0($this, $flatMap_a, $g);
            }
        }
        $rt_throw(null);
    };
    $java.suc_TailCalls$TailRec_$anonfun$flatMap$2 = function($x5$1, $f$2, $x) {
        var $flatMap_this, $flatMap_a;
        $flatMap_this = $x5$1.$f14.$apply($x);
        if ($flatMap_this === null)
            $rt_throw(null);
        if ($flatMap_this instanceof $java.suc_TailCalls$Done) {
            $flatMap_a = $flatMap_this.$value6();
            $x5$1 = new $java.suc_TailCalls$Call;
            $x = new $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_0;
            $x.$_0768 = $f$2;
            $x.$_1250 = $flatMap_a;
            $java.suc_TailCalls$Call__init_0($x5$1, $x);
            return $x5$1;
        }
        if ($flatMap_this instanceof $java.suc_TailCalls$Call)
            return $java.suc_TailCalls$Cont__init_($flatMap_this, $f$2);
        if (!($flatMap_this instanceof $java.suc_TailCalls$Cont))
            $rt_throw(s_MatchError__init_($flatMap_this));
        $x5$1 = $flatMap_this;
        $x = new $java.suc_TailCalls$Cont;
        $flatMap_a = $x5$1.$a0;
        $flatMap_this = new $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_1;
        $flatMap_this.$_0769 = $x5$1;
        $flatMap_this.$_1251 = $f$2;
        $java.suc_TailCalls$Cont__init_0($x, $flatMap_a, $flatMap_this);
        return $x;
    };
    $java.oncias_SemanticPatternCheck$$ensureNoRepeatedRelationships$lambda$_61_0 = function() {
        jl_Object.call(this);
        this.$_0602 = null;
    };
    $java.oncias_SemanticPatternCheck$$ensureNoRepeatedRelationships$lambda$_61_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0602;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = new $java.onciu_RepeatedRelationshipReference;
        var$5 = var$1.$position0;
        var$1 = var$1.$name4;
        var$4.$position298 = var$5;
        var$4.$relName0 = var$1;
        var$4.$pattern13 = var$2;
        return $java.oncias_SemanticPatternCheck$_warn(var$3, var$4);
    };
    $java.oncias_SemanticPatternCheck$$ensureNoRepeatedVarLengthRelationships$lambda$_62_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$ensureNoRepeatedVarLengthRelationships$lambda$_62_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = oncias_SemanticPatternCheck$_MODULE$;
        var$3 = new $java.onciu_RepeatedVarLengthRelationshipReference;
        var$4 = var$1.$position0;
        var$1 = var$1.$name4;
        var$3.$position299 = var$4;
        var$3.$relName1 = var$1;
        return $java.oncias_SemanticPatternCheck$_warn(var$2, var$3);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$6$lambda$_129_0 = function() {
        jl_Object.call(this);
        this.$_0645 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$6$lambda$_129_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0645;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, var$1, new $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$7$lambda$_128_0);
    };
    $java.oncia_SingleRelTypeCheck$checkRelTypes$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0413 = null;
    };
    $java.oncia_SingleRelTypeCheck$checkRelTypes$lambda$_3_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncia_SingleRelTypeCheck_checkRelTypes$(var$0.$_0413, var$1);
    };
    function oncias_SemanticAnalysisTooling$declareVariable$lambda$_57_0() {
        var a = this; jl_Object.call(a);
        a.$_0287 = null;
        a.$_188 = null;
        a.$_234 = null;
        a.$_39 = 0;
    }
    $java.oncias_SemanticAnalysisTooling$declareVariable$lambda$_57_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_0287;
        var$3 = var$0.$_188;
        var$4 = var$0.$_234;
        var$5 = var$0.$_39;
        return oncias_SemanticState_declareVariable(var$1, var$2, var$3.$apply(var$1), var$4, var$5, 0);
    };
    $java.jur_IntArrHash = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_0 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_0_apply = function(var$0, var$1) {
        return $java.oncie_PatternPartWithSelector_element(var$1);
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_1 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = $java.oncie_QuantifiedPath_allVariables(var$1);
        var$3 = new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$3$lambda$_101_0;
        var$3.$_0770 = var$1;
        return var$2.$map1(var$3);
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_2 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_3 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_4 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_4_apply = function(var$0, var$1) {
        return var$1.$allVariables();
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_5 = function() {
        var a = this; jl_Object.call(a);
        a.$_0702 = null;
        a.$_1215 = null;
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_5_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        var$1 = var$1;
        var$2 = var$0.$_0702;
        var$3 = var$0.$_1215;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$4 = var$1.$_10;
        var$1 = var$1.$_20;
        var$5 = new sci_$colon$colon;
        var$6 = s_Option$_MODULE$;
        var$7 = var$1.$length() <= 1 ? 0 : 1;
        var$1 = new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_0;
        var$1.$_0771 = var$4;
        var$8 = $java.s_Option$_when(var$6, var$7, var$1);
        var$9 = new sci_$colon$colon;
        var$1 = s_Option$_MODULE$;
        var$7 = var$2.$contains0(var$4);
        var$2 = new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_1;
        var$2.$_0772 = var$4;
        var$1 = $java.s_Option$_when(var$1, var$7, var$2);
        var$2 = new sci_$colon$colon;
        var$10 = s_Option$_MODULE$;
        var$7 = s_Option_isDefined(oncias_SemanticState_symbol(var$3, var$4.$name4));
        var$3 = new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_2;
        var$3.$_0773 = var$4;
        sci_$colon$colon__init_0(var$2, $java.s_Option$_when(var$10, var$7, var$3), sci_Nil$_MODULE$);
        sci_$colon$colon__init_0(var$9, var$1, var$2);
        sci_$colon$colon__init_0(var$5, var$8, var$9);
        s_Predef$_$callClinit();
        var$1 = sc_StrictOptimizedIterableOps_flatten$(var$5, s_Predef$_$conforms(s_Predef$_MODULE$));
        var$2 = new $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_3;
        var$2.$_0774 = var$4;
        return sci_List_map(var$1, var$2);
    };
    $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_0 = function() {
        jl_Object.call(this);
        this.$_0342 = 0;
    };
    $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0342;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = new $java.oncia_Union$$anonfun$semanticCheckInSubqueryExpressionContext$2$lambda$_34_0;
        var$4.$_0775 = var$1;
        var$4.$_1252 = var$2;
        return oncias_SemanticCheck$_nestedCheck(var$3, var$4);
    };
    $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_1 = function() {
        jl_Object.call(this);
        this.$_0343 = 0;
    };
    $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_1_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_semanticCheckInSubqueryExpressionContext(var$1, var$0.$_0343);
    };
    var oncias_SemanticPatternCheck$$$anonfun$check$16$lambda$_97_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$$anonfun$check$16$lambda$_97_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncia_Where$_checkExpression($java.oncia_Where$_MODULE$, var$1);
    };
    var oncie_Expression$ = $rt_classWithoutFields();
    $java.oncie_Expression$_MODULE$ = null;
    var oncie_Expression$_DefaultTypeMismatchMessageGenerator = null;
    function oncie_Expression$__clinit_() {
        $java.oncie_Expression$_MODULE$ = new oncie_Expression$;
        oncie_Expression$_DefaultTypeMismatchMessageGenerator = new $java.oncie_Expression$$_clinit_$lambda$_0_0;
    }
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_1 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_1_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_0_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        $java.oncius_StorableType$_$callClinit();
        return $java.oncius_StorableType$_storableType;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$67$lambda$_138_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0617 = null;
        a.$_1189 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$67$lambda$_138_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10, var$11, var$12;
        var$2 = var$0.$_0617;
        var$3 = var$0.$_1189;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$4 = oncius_package$_MODULE$;
        var$5 = oncius_TypeSpec_intersect($java.oncius_ListType_covariant(oncius_package$_CTList(var$4, oncius_package$_CTAny(var$4))), var$2);
        var$6 = oncius_TypeSpec_intersect($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), var$2);
        var$7 = oncius_TypeSpec_intersect($java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)), var$2);
        var$2 = oncius_TypeSpec_intersect($java.oncius_MapType_invariant(oncius_package$_CTMap(oncius_package$_MODULE$)), var$2);
        var$8 = oncius_TypeSpec_nonEmpty(var$5);
        var$9 = !oncius_TypeSpec_nonEmpty(var$6) && !oncius_TypeSpec_nonEmpty(var$7) ? 0 : 1;
        var$10 = oncius_TypeSpec_nonEmpty(var$2);
        var$11 = oncius_TypeSpec_nonEmpty(oncius_TypeSpec_intersect($java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$)), var$1));
        var$12 = oncius_TypeSpec_nonEmpty(oncius_TypeSpec_intersect($java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$)), var$1));
        if (var$8) {
            var$1 = oncias_package$_MODULE$;
            var$2 = oncias_SemanticExpressionCheck$_MODULE$;
            var$4 = new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_0;
            var$4.$_0776 = var$5;
            var$1 = oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(var$1, oncias_SemanticAnalysisTooling_specifyType$0(var$2, var$4, var$3)), $java.oncias_SemanticExpressionCheck$_expectType3(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_1, var$3.$idx0, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_2));
        } else
            var$1 = var$10 ? $java.oncias_SemanticExpressionCheck$_expectType3(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_3, var$3.$idx0, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_4) : var$9 ? $java.oncias_SemanticExpressionCheck$_expectType3(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_5, var$3.$idx0, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_6)
            : var$12 ? oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_7, var$3.$expr4) : !var$11 ? oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_8, var$3.$expr4) : oncias_SemanticAnalysisTooling_expectType$1(oncias_SemanticExpressionCheck$_MODULE$, new $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_9,
            var$3.$expr4);
        return var$1;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_0 = $rt_classWithoutFields();
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_0_apply = function(var$0, var$1, var$2) {
        return $java.oncius_TypeSpec_union(var$1, (sci_Vector_head(var$2.$argumentTypes1())).$covariant20());
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_1 = function() {
        jl_Object.call(this);
        this.$_0735 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_1_apply = function(var$0) {
        return var$0.$_0735;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_2 = function() {
        jl_Object.call(this);
        this.$_0736 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncius_TypeSpec_containsAny(var$0.$_0736, (sci_Vector_head(var$1.$argumentTypes1())).$covariant20()));
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_3 = $rt_classWithoutFields();
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_3_apply = function(var$0, var$1) {
        return var$1.$removeFirstArgumentType();
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$5$lambda$_31_0 = function() {
        jl_Object.call(this);
        this.$_0743 = null;
    };
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$5$lambda$_31_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0743;
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2.$errors.$concat0(var$1.$errors));
    };
    $java.oncia_SingleQuery$$anonfun$checkHorizon$1$lambda$_142_0 = function() {
        jl_Object.call(this);
        this.$_0638 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkHorizon$1$lambda$_142_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0638;
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2.$errors.$concat0(var$1.$errors));
    };
    $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_0 = function() {
        jl_Object.call(this);
        this.$_0681 = null;
    };
    $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$0.$_0681;
        if (!$java.oncie_Expression_containsAggregate(var$1))
            var$1 = oncias_SemanticCheck$_success;
        else {
            var$3 = oncias_SemanticCheck$_MODULE$;
            var$1 = sr_ScalaRunTime$_MODULE$;
            var$4 = $rt_createArray(oncias_SemanticErrorDef, 1);
            var$5 = var$4.data;
            var$6 = new oncias_SemanticError;
            var$7 = sc_StringOps$_MODULE$;
            s_Predef$_$callClinit();
            oncias_SemanticError__init_(var$6, sc_StringOps$_stripMargin$extension(var$7, $rt_s(3233)), var$2.$position53);
            var$5[0] = var$6;
            var$1 = oncias_SemanticCheck$_error(var$3, sr_ScalaRunTime$_wrapRefArray(var$1, var$4));
        }
        return var$1;
    };
    $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_1 = $rt_classWithoutFields();
    $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_1_apply = function(var$0, var$1, var$2) {
        return var$1.$chain(var$2);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$81$lambda$_104_0 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$81$lambda$_104_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$1 instanceof oncie_CoerceTo && var$1.$expr0() instanceof $java.oncie_ImplicitProcedureArgument ? 0 : !(var$1 instanceof $java.oncie_ImplicitProcedureArgument) ? 1 : 0);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$83$lambda$_106_0 = function() {
        jl_Object.call(this);
        this.$_0693 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$83$lambda$_106_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_0693.$$outer3.$expr2, var$1);
    };
    $java.oncia_SetPropertyItems = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0697 = null;
        a.$_1212 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_1 = function() {
        jl_Object.call(this);
        this.$_0698 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$1 = onciap_DefaultExpressionStringifier_apply0(var$0.$_0698.$$outer3.$expr2, var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 58);
        jl_StringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$117$lambda$_143_0 = function() {
        jl_Object.call(this);
        this.$_0699 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$117$lambda$_143_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$1 = onciap_DefaultExpressionStringifier_apply0(var$0.$_0699.$$outer3.$expr2, var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(var$2, 58);
        jl_StringBuilder_append(var$2, var$1);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncia_connectedComponents$ = $rt_classWithoutFields();
    $java.oncia_connectedComponents$_MODULE$ = null;
    $java.oncia_connectedComponents$_ComponentPart = null;
    $java.oncia_connectedComponents$_ConnectedComponent = null;
    $java.oncia_connectedComponents$_$callClinit = function() {
        $java.oncia_connectedComponents$_$callClinit = $rt_eraseClinit($java.oncia_connectedComponents$);
        $java.oncia_connectedComponents$__clinit_();
    };
    $java.oncia_connectedComponents$__clinit_ = function() {
        var var$1;
        var$1 = new $java.oncia_connectedComponents$;
        $java.oncia_connectedComponents$_$callClinit();
        $java.oncia_connectedComponents$_MODULE$ = var$1;
        s_Predef$_$callClinit();
        $java.oncia_connectedComponents$_ComponentPart = s_Predef$_Set(s_Predef$_MODULE$);
        $java.oncia_connectedComponents$_ConnectedComponent = s_Predef$_Set(s_Predef$_MODULE$);
    };
    $java.oncia_connectedComponents$_RichConnectedComponent = function($this, $connectedComponent) {
        var var$2;
        var$2 = new $java.oncia_connectedComponents$RichConnectedComponent;
        var$2.$connectedComponent = $connectedComponent;
        return var$2;
    };
    $java.oncia_Match$$anonfun$checkForCartesianProducts$1$lambda$_115_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0707 = null;
        a.$_1217 = null;
    };
    $java.oncia_Match$$anonfun$checkForCartesianProducts$1$lambda$_115_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = var$0.$_0707;
        var$4 = var$0.$_1217;
        var$5 = new $java.onciu_CartesianProductNotification;
        var$6 = var$3.$position54;
        $java.oncia_connectedComponents$_$callClinit();
        var$3 = ($java.oncia_connectedComponents$_RichConnectedComponent($java.oncia_connectedComponents$_MODULE$, var$2)).$connectedComponent;
        s_Predef$_$callClinit();
        var$2 = (var$3.$flatten(s_Predef$_$conforms(s_Predef$_MODULE$))).$map1(new $java.oncia_Match$$anonfun$checkForCartesianProducts$2$lambda$_114_0);
        var$5.$position300 = var$6;
        var$5.$isolatedVariables = var$2;
        var$5.$pattern14 = var$4;
        return oncias_SemanticState_addNotification(var$1, var$5);
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$3$lambda$_57_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$3$lambda$_57_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_covariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$20$lambda$_75_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$20$lambda$_75_0_apply = function(var$0) {
        var var$1;
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$6$lambda$_60_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$6$lambda$_60_0_apply = function(var$0) {
        var var$1;
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$30$lambda$_120_0 = function() {
        jl_Object.call(this);
        this.$_0734 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$30$lambda$_120_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0734;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncia_Where$_checkExpression($java.oncia_Where$_MODULE$, var$1);
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$26$lambda$_81_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$26$lambda$_81_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return (oncius_package$_CTString(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$9$lambda$_64_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$9$lambda$_64_0_apply = function(var$0) {
        var var$1;
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$3$lambda$_147_0 = function() {
        jl_Object.call(this);
        this.$_0731 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$3$lambda$_147_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0731;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncia_Where$_checkExpression($java.oncia_Where$_MODULE$, var$1);
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$23$lambda$_78_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$23$lambda$_78_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$18$lambda$_73_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$18$lambda$_73_0_apply = function(var$0) {
        var var$1;
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_TypeSpec_union($java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1))), (oncius_package$_CTString(oncius_package$_MODULE$)).$invariant());
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$88$lambda$_149_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0623 = null;
        a.$_1192 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$88$lambda$_149_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        var$1 = var$1;
        var$2 = var$0.$_0623;
        var$3 = var$0.$_1192;
        oncias_SemanticExpressionCheck$_$callClinit();
        if (jl_String_charAt(var$2, jl_String_indexOf0(var$2, 48) + 1 | 0) != 111 && jl_String_charAt(var$2, jl_String_indexOf0(var$2, 48) + 1 | 0) != 95) {
            s_Predef$_$callClinit();
            var$4 = jl_String_indexOf0(var$2, 48) + 1 | 0;
            var$5 = jl_String_length(var$2);
            var$6 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_2(var$6, (var$5 + jl_String_length($rt_s(3234)) | 0) - 0 | 0);
            var$7 = var$4 <= 0 ? 0 : jl_Math_min(var$4, var$5);
            if (var$7 > 0)
                jl_AbstractStringBuilder_append3(var$6, var$2, 0, var$7);
            jl_AbstractStringBuilder_append1(var$6, $rt_s(3234));
            var$7 = (var$5 - var$7 | 0) - 0 | 0;
            if (var$7 > 0)
                jl_AbstractStringBuilder_append3(var$6, var$2, var$5 - var$7 | 0, var$5);
            var$8 = jl_AbstractStringBuilder_toString(var$6);
            var$9 = new sci_$colon$colon;
            var$6 = new oncias_SemanticError;
            var$10 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$10);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$10, $rt_s(3235)), var$2), $rt_s(3236)), var$8), $rt_s(3133));
            oncias_SemanticError__init_(var$6, jl_AbstractStringBuilder_toString(var$10), var$3.$position248);
            sci_$colon$colon__init_0(var$9, var$6, sci_Nil$_MODULE$);
        } else {
            s_package$_$callClinit();
            var$9 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        }
        return oncias_SemanticCheckResult__init_(var$1, var$9);
    };
    $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$13$lambda$_81_0 = function() {
        jl_Object.call(this);
        this.$_0683 = null;
    };
    $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$13$lambda$_81_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0683;
        var$2 = new $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$14$lambda$_80_0;
        var$2.$_0777 = var$1;
        return oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0(var$1, var$1.$variable9, var$2, s_None$_MODULE$, 0)), $java.oncias_SemanticCheckableIterableOnce$_semanticCheck$extension($java.oncias_SemanticCheckableIterableOnce$_MODULE$, var$1.$updates));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$96$lambda$_157_0 = function() {
        jl_Object.call(this);
        this.$_0629 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$96$lambda$_157_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0629;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_package$_liftSemanticErrorDef(oncias_package$_MODULE$, oncias_SemanticError__init_0($rt_s(3237), var$1.$position250));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$92$lambda$_153_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0626 = null;
        a.$_1195 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$92$lambda$_153_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8, var$9, var$10;
        var$1 = var$1;
        var$2 = var$0.$_0626;
        var$3 = var$0.$_1195;
        oncias_SemanticExpressionCheck$_$callClinit();
        if (jl_String_charAt(var$2, jl_String_indexOf0(var$2, 48) + 1 | 0) != 88) {
            s_package$_$callClinit();
            var$4 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        } else {
            var$5 = $rt_createCharArray(jl_String_length(var$2));
            var$6 = var$5.data;
            var$7 = 0;
            while (var$7 < jl_String_length(var$2)) {
                var$6[var$7] = jl_String_charAt(var$2, var$7) != 88 ? jl_String_charAt(var$2, var$7) : 120;
                var$7 = var$7 + 1 | 0;
            }
            var$8 = jl_String__init_(var$5);
            var$4 = new sci_$colon$colon;
            var$9 = new oncias_SemanticError;
            var$10 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$10);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$10, $rt_s(3238)), var$2), $rt_s(3236)), var$8), $rt_s(3133));
            oncias_SemanticError__init_(var$9, jl_AbstractStringBuilder_toString(var$10), var$3.$position249);
            sci_$colon$colon__init_0(var$4, var$9, sci_Nil$_MODULE$);
        }
        return oncias_SemanticCheckResult__init_(var$1, var$4);
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$30$lambda$_85_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$30$lambda$_85_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return (oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$28$lambda$_83_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$28$lambda$_83_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return ($java.oncius_package$_CTFloat(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncia_Clause$$anonfun$checkIfMixingLegacyVarLengthWithQPPs$1$lambda$_24_0 = function() {
        jl_Object.call(this);
        this.$_0742 = null;
    };
    $java.oncia_Clause$$anonfun$checkIfMixingLegacyVarLengthWithQPPs$1$lambda$_24_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0742.$error2($rt_s(3239), var$1.$position32);
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression = function() {
        var a = this; jl_Object.call(a);
        a.$position297 = null;
        a.$labelExpression4 = null;
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression_productPrefix = function($this) {
        return $rt_s(3240);
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression_productArity = function($this) {
        return 2;
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position297;
            case 1:
                return $this.$labelExpression4;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_UnsatisfiableRelationshipTypeExpression_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.onciu_UnsatisfiableRelationshipTypeExpression) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position297;
                        var$3 = $x$1.$position297;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$labelExpression4;
                        $x$1 = $x$1.$labelExpression4;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.onciu_UnsatisfiableRelationshipTypeExpression))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_0 = function() {
        jl_Object.call(this);
        this.$_0737 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0737;
        oncias_SemanticExpressionCheck$_$callClinit();
        return jl_Boolean_valueOf(var$2.$contains0(var$1.$_10.$node2));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_1 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_20.$location;
        return s_Option_getOrElse(s_Option_map(oncias_SemanticState$ScopeLocation$_parent$extension(oncias_SemanticState$ScopeLocation$_MODULE$, var$2), new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_0), new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_2 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_3 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$1.$_20;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_4 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_5 = function() {
        jl_Object.call(this);
        this.$_0738 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_5_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0738;
        oncias_SemanticExpressionCheck$_$callClinit();
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$3 = var$1.$_10;
        var$1 = var$1.$_20;
        return jl_Boolean_valueOf(s_Option_contains(var$2.$get1(var$3), var$1));
    };
    var oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_6 = $rt_classWithoutFields();
    function oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_6_apply(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        return s_Tuple2__init_(var$2, (var$1.$filterNot1(new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_0)).$map1(new $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_1));
    }
    $java.oncias_SemanticExpressionCheck$$anonfun$2 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$innerDefinitions$1 = null;
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$2_applyOrElse = function($this, $x, $default) {
        var var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            $x = $x;
            if ($x !== null) {
                b: {
                    var$3 = $x.$_10;
                    var$4 = $x.$_20;
                    var$5 = $this.$innerDefinitions$1;
                    oncias_SemanticExpressionCheck$_$callClinit();
                    var$6 = var$4.$name17;
                    var$7 = s_Tuple2__1$mcI$sp($java.oncias_SymbolUse_positionsAndUniqueIdString(var$4.$definition));
                    if (var$5.$contains0(var$6)) {
                        var$8 = var$5.$apply(var$6);
                        var$6 = new $java.oncias_SemanticExpressionCheck$$org$neo4j$cypher$internal$ast$semantics$SemanticExpressionCheck$$isShadowed$1$lambda$_211_0;
                        var$6.$_0778 = var$7;
                        if (var$8.$exists(var$6)) {
                            var$7 = 1;
                            break b;
                        }
                    }
                    var$7 = 0;
                }
                if (var$7) {
                    $x = s_Predef$ArrowAssoc$_MODULE$;
                    s_Predef$_$callClinit();
                    $default = $this.$innerDefinitions$1.$apply(var$3);
                    var$8 = new $java.oncias_SemanticExpressionCheck$$anonfun$2$applyOrElse$lambda$_0_0;
                    var$8.$_0779 = var$4;
                    $x = s_Predef$ArrowAssoc$_$minus$greater$extension($x, var$3, ($java.oncias_SymbolUse_asVariable(($default.$find0(var$8)).$get0())).$position0);
                    break a;
                }
            }
            $x = $default.$apply($x);
        }
        return $x;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_7 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_7_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        var$3 = new oncias_SemanticError;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3241)), var$2), $rt_s(3242));
        oncias_SemanticError__init_(var$3, jl_AbstractStringBuilder_toString(var$4), var$1);
        return var$3;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$7$lambda$_94_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0732 = null;
        a.$_1235 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$7$lambda$_94_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = var$0.$_0732;
        var$4 = var$0.$_1235;
        var$5 = var$1.$state;
        var$6 = new $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$8$lambda$_93_0;
        var$6.$_0780 = var$4;
        var$2 = var$3.$expectType3(var$5, var$6, var$2, var$3.$expectType$default$4());
        return oncias_SemanticCheckResult__init_(var$2.$state, var$1.$errors.$concat0(var$2.$errors));
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$1 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$state$10 = null;
        a.$x66$1 = null;
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$1_applyOrElse = function($this, $x, $default) {
        var var$3, var$4;
        a: {
            $x = $x;
            if (s_Option_isEmpty(oncias_SemanticState$ScopeLocation$_symbol$extension(oncias_SemanticState$ScopeLocation$_MODULE$, ($this.$state$10.$recordedScopes.$apply(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $this.$x66$1))).$location, $x.$name4))) {
                oncias_SemanticPatternCheck$_$callClinit();
                $java.onciu_AnonymousVariableNameGenerator$_$callClinit();
                if (!($java.onciu_AnonymousVariableNameGenerator$_isNamed($java.onciu_AnonymousVariableNameGenerator$_MODULE$, $x.$name4) ? 0 : 1)) {
                    $default = new oncias_SemanticError;
                    var$3 = $x.$name4;
                    var$4 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$4);
                    jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3243)), var$3), $rt_s(1822));
                    oncias_SemanticError__init_($default, jl_AbstractStringBuilder_toString(var$4), $x.$position0);
                    break a;
                }
            }
            $default = $default.$apply($x);
        }
        return $default;
    };
    $java.oncia_Merge$$anonfun$11 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_Merge$$anonfun$11_applyOrElse = function($this, $x1, $default) {
        if (!$rt_isInstance($x1, oncia_FullSubqueryExpression))
            return s_PartialFunction$$anon$1_apply($default, $x1);
        return $x1;
    };
    $java.oncia_Merge$$anonfun$11_isDefinedAt = function($this, $x1) {
        if (!$rt_isInstance($x1, oncia_FullSubqueryExpression))
            return 0;
        return 1;
    };
    $java.oncia_SubqueryCall$checkNoNestedCallInTransactions$lambda$_67_0 = function() {
        jl_Object.call(this);
        this.$_0682 = null;
    };
    $java.oncia_SubqueryCall$checkNoNestedCallInTransactions$lambda$_67_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticAnalysisTooling_error$(var$0.$_0682, $rt_s(3244), var$1.$position67);
    };
    $java.oncias_SemanticFunctionCheck$$possibleTypes$1$lambda$_62_0 = function() {
        jl_Object.call(this);
        this.$_0686 = null;
    };
    $java.oncias_SemanticFunctionCheck$$possibleTypes$1$lambda$_62_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0686;
        var$1 = $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$($java.oncias_SemanticFunctionCheck$_MODULE$, var$2), var$1);
        oncius_package$_$callClinit();
        var$2 = oncius_package$_MODULE$;
        return $java.oncius_TypeSpec_unwrapLists($java.oncius_TypeSpec_constrain(var$1, oncius_package$_CTList(var$2, oncius_package$_CTAny(var$2))));
    };
    $java.oncias_SemanticFunctionCheck$$checkToSpecifiedTypeOfArgument$lambda$_50_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0575 = null;
        a.$_1177 = null;
    };
    $java.oncias_SemanticFunctionCheck$$checkToSpecifiedTypeOfArgument$lambda$_50_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$1;
        var$2 = var$0.$_0575;
        var$3 = var$0.$_1177;
        var$4 = var$2.$args.$head();
        var$5 = (oncias_SemanticState_expressionType(var$1, var$4)).$specified;
        var$6 = jl_Boolean_valueOf(0);
        var$7 = new $java.oncias_SemanticFunctionCheck$$$anonfun$checkToSpecifiedTypeOfArgument$1$lambda$_92_0;
        var$7.$_0781 = var$5;
        if (sr_BoxesRunTime_unboxToBoolean(var$3.$foldLeft(var$6, var$7)))
            var$1 = oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
        else {
            var$3 = var$2.$function0;
            $java.oncief_ToString$_$callClinit();
            if (jl_Object_equals($java.oncief_ToString$_MODULE$, var$3)) {
                var$2 = $java.oncius_TypeSpec_mkString(var$5, $rt_s(16));
                var$3 = new jl_StringBuilder;
                jl_AbstractStringBuilder__init_(var$3);
                jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(3245)), var$2);
                var$2 = jl_AbstractStringBuilder_toString(var$3);
            } else {
                $java.oncief_ToBoolean$_$callClinit();
                if (!jl_Object_equals($java.oncief_ToBoolean$_MODULE$, var$3)) {
                    var$2 = $java.oncius_TypeSpec_mkString(var$5, $rt_s(16));
                    var$3 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$3);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(3246)), var$2);
                    var$2 = jl_AbstractStringBuilder_toString(var$3);
                } else {
                    var$3 = $java.oncius_TypeSpec_mkString(var$5, $rt_s(16));
                    var$5 = new jl_StringBuilder;
                    jl_AbstractStringBuilder__init_(var$5);
                    jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(3247)), var$3);
                    var$2 = jl_AbstractStringBuilder_toString(var$5);
                }
            }
            var$1 = $java.oncias_SemanticCheckResult$_error0(oncias_SemanticCheckResult$_MODULE$, var$1, var$2, var$4.$position2());
        }
        return var$1;
    };
    function oncia_Clause$LabelExpressionsPartition() {
        var a = this; jl_Object.call(a);
        a.$legacy = null;
        a.$gpm = null;
        a.$leaf = null;
        a.$$outer56 = null;
    }
    $java.oncia_Clause$LabelExpressionsPartition__init_0 = function(var_0, var_1, var_2, var_3) {
        var var_4 = new oncia_Clause$LabelExpressionsPartition();
        $java.oncia_Clause$LabelExpressionsPartition__init_(var_4, var_0, var_1, var_2, var_3);
        return var_4;
    };
    function oncia_Clause$LabelExpressionsPartition_copy($this, $legacy, $gpm, $leaf) {
        return $java.oncia_Clause$LabelExpressionsPartition__init_0($this.$$outer56, $legacy, $gpm, $leaf);
    }
    $java.oncia_Clause$LabelExpressionsPartition_productPrefix = function($this) {
        return $rt_s(3248);
    };
    $java.oncia_Clause$LabelExpressionsPartition_productArity = function($this) {
        return 3;
    };
    $java.oncia_Clause$LabelExpressionsPartition_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$legacy;
            case 1:
                return $this.$gpm;
            case 2:
                return $this.$leaf;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_Clause$LabelExpressionsPartition_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Clause$LabelExpressionsPartition_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Clause$LabelExpressionsPartition_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_Clause$LabelExpressionsPartition_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!($x$1 instanceof oncia_Clause$LabelExpressionsPartition && $x$1.$$outer56 === $this.$$outer56 ? 1 : 0))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$legacy;
                        var$3 = $x$1.$legacy;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$gpm;
                        var$3 = $x$1.$gpm;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$leaf;
                        $x$1 = $x$1.$leaf;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof oncia_Clause$LabelExpressionsPartition))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Clause$LabelExpressionsPartition__init_ = function($this, $$outer, $legacy, $gpm, $leaf) {
        $this.$legacy = $legacy;
        $this.$gpm = $gpm;
        $this.$leaf = $leaf;
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer56 = $$outer;
    };
    $java.oncia_Clause$$anonfun$1 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer55 = null;
        a.$state$11 = null;
    };
    $java.oncia_Clause$$anonfun$1_applyOrElse = function($this, $x1, $default) {
        var $le, $entity;
        if ($x1 instanceof oncie_NodePattern) {
            $default = $x1.$labelExpression1;
            if ($default instanceof s_Some) {
                $le = $default.$value5;
                $x1 = new $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_0;
                $x1.$_0782 = $this;
                $x1.$_1253 = $le;
                return $x1;
            }
        }
        if ($x1 instanceof oncil_LabelExpressionPredicate) {
            $x1 = $x1;
            $entity = $x1.$entity0;
            $le = $x1.$labelExpression3;
            $x1 = new $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_1;
            $x1.$_0783 = $this;
            $x1.$_1254 = $le;
            $x1.$_272 = $entity;
            return $x1;
        }
        if ($x1 instanceof oncie_RelationshipPattern) {
            $default = $x1.$labelExpression2;
            if ($default instanceof s_Some) {
                $le = $default.$value5;
                $x1 = new $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_2;
                $x1.$_0784 = $this;
                $x1.$_1255 = $le;
                return $x1;
            }
        }
        if (!jl_Object_equals($java.oncil_LabelExpression$_MODULE$, $x1))
            return s_PartialFunction$_fallback_fn;
        $default = new jl_IllegalStateException;
        jl_Throwable__init_($default, $rt_s(3249));
        $rt_throw($default);
    };
    $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$containsIs6());
    };
    $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0733 = null;
        a.$_1236 = null;
    };
    $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_1_apply = function(var$0) {
        return oncia_Clause_$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2(var$0.$_0733, var$0.$_1236);
    };
    $java.oncie_Expression$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncie_Expression$$_clinit_$lambda$_0_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(3250)), var$1), $rt_s(3251)), var$2);
        return jl_AbstractStringBuilder_toString(var$3);
    };
    function oncia_Clause$LabelExpressionsPartition$() {
        sr_AbstractFunction3.call(this);
        this.$$outer57 = null;
    }
    function oncia_Clause$LabelExpressionsPartition$__init_(var_0) {
        var var_1 = new oncia_Clause$LabelExpressionsPartition$();
        $java.oncia_Clause$LabelExpressionsPartition$__init_(var_1, var_0);
        return var_1;
    }
    $java.oncia_Clause$LabelExpressionsPartition$__init_ = function($this, $$outer) {
        if ($$outer === null)
            $rt_throw(null);
        $this.$$outer57 = $$outer;
    };
    $java.onciu_RewritableCompat$PROXY$7_258 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_258_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_258 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_258_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(4)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_946 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_946_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncil_LabelExpressionPredicate__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_948 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_948_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncil_LabelExpression$Wildcard__init_(var$3[0].$value8, var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_949 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_949_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncil_LabelExpression$Disjunctions_copy(var$2, var$3[0], var$3[1].$value8, var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_950 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_950_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return oncil_LabelExpression$Leaf__init_(var$3[0], var$3[1].$value8);
    }
    $java.onciu_RewritableCompat$PROXY$7_259 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_259_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_259 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_259_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.suc_TailCalls$Done = function() {
        $java.suc_TailCalls$TailRec.call(this);
        this.$value37 = null;
    };
    $java.suc_TailCalls$Done__init_ = function(var_0) {
        var var_1 = new $java.suc_TailCalls$Done();
        $java.suc_TailCalls$Done__init_0(var_1, var_0);
        return var_1;
    };
    $java.suc_TailCalls$Done_productPrefix = function($this) {
        return $rt_s(3252);
    };
    $java.suc_TailCalls$Done_productArity = function($this) {
        return 1;
    };
    $java.suc_TailCalls$Done_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$value37;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.suc_TailCalls$Done_productIterator = function($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    };
    $java.suc_TailCalls$Done_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.suc_TailCalls$Done__init_0 = function($this, $value) {
        $this.$value37 = $value;
    };
    $java.suc_TailCalls$Call = function() {
        $java.suc_TailCalls$TailRec.call(this);
        this.$rest = null;
    };
    $java.suc_TailCalls$Call__init_ = function(var_0) {
        var var_1 = new $java.suc_TailCalls$Call();
        $java.suc_TailCalls$Call__init_0(var_1, var_0);
        return var_1;
    };
    $java.suc_TailCalls$Call_productPrefix = function($this) {
        return $rt_s(3253);
    };
    $java.suc_TailCalls$Call_productArity = function($this) {
        return 1;
    };
    $java.suc_TailCalls$Call_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$rest;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.suc_TailCalls$Call_productIterator = function($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    };
    $java.suc_TailCalls$Call_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    };
    $java.suc_TailCalls$Call_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.suc_TailCalls$Call_equals = function($this, $x$1) {
        var var$2;
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof $java.suc_TailCalls$Call) ? 0 : 1))
                    break a;
                b: {
                    $x$1 = $x$1;
                    var$2 = $this.$rest;
                    $x$1 = $x$1.$rest;
                    if (var$2 !== null) {
                        if (!jl_Object_equals(var$2, $x$1))
                            break a;
                        else
                            break b;
                    }
                    if ($x$1 !== null)
                        break a;
                }
                if (!($this instanceof $java.suc_TailCalls$Call))
                    break a;
            }
            return 1;
        }
        return 0;
    };
    $java.suc_TailCalls$Call__init_0 = function($this, $rest) {
        $this.$rest = $rest;
    };
    $java.onciut_TailCallsUtil$$map2$lambda$_2_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0759 = null;
        a.$_1242 = null;
    };
    $java.onciut_TailCallsUtil$$map2$lambda$_2_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0759;
        var$3 = var$0.$_1242;
        var$4 = new $java.onciut_TailCallsUtil$$$anonfun$map2$1$lambda$_8_0;
        var$4.$_0785 = var$3;
        var$4.$_1256 = var$1;
        return $java.suc_TailCalls$TailRec_map(var$2, var$4);
    };
    $java.onciut_TailCallsUtil$$traverse$lambda$_1_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0757 = null;
        a.$_1240 = null;
    };
    $java.onciut_TailCallsUtil$$traverse$lambda$_1_0_apply = function(var$0) {
        return var$0.$_0757.$apply(var$0.$_1240.$head());
    };
    $java.onciut_TailCallsUtil$$traverse$lambda$_1_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0758 = null;
        a.$_1241 = null;
    };
    $java.onciut_TailCallsUtil$$traverse$lambda$_1_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_0758;
        var$3 = var$0.$_1241;
        var$4 = $java.suc_TailCalls$_MODULE$;
        var$5 = new $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_0;
        var$5.$_0786 = var$2;
        var$5.$_1257 = var$3;
        var$2 = $java.suc_TailCalls$_tailcall(var$4, var$5);
        var$3 = new $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_1;
        var$3.$_0787 = var$1;
        return $java.suc_TailCalls$TailRec_map(var$2, var$3);
    };
    $java.sc_Seq$ = $rt_classWithoutFields(sc_SeqFactory$Delegate);
    $java.sc_Seq$_MODULE$ = null;
    $java.sc_Seq$_$callClinit = function() {
        $java.sc_Seq$_$callClinit = $rt_eraseClinit($java.sc_Seq$);
        $java.sc_Seq$__clinit_();
    };
    $java.sc_Seq$__clinit_ = function() {
        var var$1;
        var$1 = new $java.sc_Seq$;
        $java.sc_Seq$_$callClinit();
        sci_Seq$_$callClinit();
        sc_SeqFactory$Delegate__init_0(var$1, sci_Seq$_MODULE$);
        $java.sc_Seq$_MODULE$ = var$1;
    };
    $java.oncia_connectedComponents$$apply$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncia_connectedComponents$$apply$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        $java.oncia_connectedComponents$_$callClinit();
        var$2 = onciu_Foldable_folder$(var$1);
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return onciu_Foldable$Folder_fold(var$2, sci_Set$EmptySet$_MODULE$, new $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1);
    };
    $java.onciuh_NameDeduplicator$ = $rt_classWithoutFields();
    $java.onciuh_NameDeduplicator$_MODULE$ = null;
    $java.onciuh_NameDeduplicator$_UNNAMED_PATTERN = null;
    $java.onciuh_NameDeduplicator$_UNNAMED_PARAMS_PATTERN = null;
    $java.onciuh_NameDeduplicator$_DEDUP_PATTERN = null;
    $java.onciuh_NameDeduplicator$_deduplicateVariableNames = null;
    $java.onciuh_NameDeduplicator$_$callClinit = function() {
        $java.onciuh_NameDeduplicator$_$callClinit = $rt_eraseClinit($java.onciuh_NameDeduplicator$);
        $java.onciuh_NameDeduplicator$__clinit_();
    };
    $java.onciuh_NameDeduplicator$__clinit_ = function() {
        var var$1, var$2, var$3;
        var$1 = new $java.onciuh_NameDeduplicator$;
        $java.onciuh_NameDeduplicator$_$callClinit();
        $java.onciuh_NameDeduplicator$_MODULE$ = var$1;
        $java.onciu_AnonymousVariableNameGenerator$_$callClinit();
        var$1 = $java.onciu_AnonymousVariableNameGenerator$_generatorName0($java.onciu_AnonymousVariableNameGenerator$_MODULE$);
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(3254)), var$1), $rt_s(3255));
        $java.onciuh_NameDeduplicator$_UNNAMED_PATTERN = sc_StringOps$_r$extension(var$2, jl_AbstractStringBuilder_toString(var$3));
        $java.onciuh_NameDeduplicator$_UNNAMED_PARAMS_PATTERN = sc_StringOps$_r$extension(sc_StringOps$_MODULE$, $rt_s(3256));
        $java.onciuh_NameDeduplicator$_DEDUP_PATTERN = sc_StringOps$_r$extension(sc_StringOps$_MODULE$, $rt_s(3257));
        var$1 = new $java.onciuh_NameDeduplicator$$_clinit_$lambda$_0_0;
        var$2 = new $java.onciuh_fixedPoint$$apply$lambda$_1_0;
        var$2.$_0788 = var$1;
        $java.onciuh_NameDeduplicator$_deduplicateVariableNames = var$2;
    };
    $java.oncia_SingleQuery$checkImportingWith$lambda$_66_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$checkImportingWith$lambda$_66_0_apply = function(var$0, var$1) {
        return oncia_Clause_semanticCheck$(var$1);
    };
    $java.oncias_SemanticState$ScopeLocation$$symbol$extension$lambda$_10_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_021 = null;
        a.$_17 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        if (var$1 instanceof oncie_LabelName) {
            var$2 = var$1.$name25;
            var$1 = $java.oncias_SemanticPatternCheck$_org$neo4j$cypher$internal$ast$semantics$SemanticPatternCheck$$checkValidTokenName(oncias_SemanticPatternCheck$_MODULE$, var$2);
        } else if (var$1 instanceof oncie_RelTypeName) {
            var$2 = var$1.$name27;
            var$1 = $java.oncias_SemanticPatternCheck$_org$neo4j$cypher$internal$ast$semantics$SemanticPatternCheck$$checkValidTokenName(oncias_SemanticPatternCheck$_MODULE$, var$2);
        } else if (!(var$1 instanceof oncie_LabelOrRelTypeName))
            var$1 = s_None$_MODULE$;
        else {
            var$2 = var$1.$name56;
            var$1 = $java.oncias_SemanticPatternCheck$_org$neo4j$cypher$internal$ast$semantics$SemanticPatternCheck$$checkValidTokenName(oncias_SemanticPatternCheck$_MODULE$, var$2);
        }
        return var$1;
    };
    $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_1 = function() {
        jl_Object.call(this);
        this.$_0606 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0606;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SemanticError__init_0(var$1, var$2);
    };
    $java.oncius_TypeSpec$coercions$lambda$_28_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$coercions$lambda$_28_0_apply = function(var$0, var$1) {
        return var$1.$lower1.$coercibleTo0();
    };
    $java.oncil_SolvableLabelExpression$$wildcard$lambda$_4_0 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$wildcard$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        if (var$1 instanceof $java.oncil_NodeLabels$KnownLabels)
            var$2 = sc_IterableOnceOps_nonEmpty$(var$1.$labelNames);
        else {
            if (!jl_Object_equals($java.oncil_NodeLabels$SomeUnknownLabels$_MODULE$, var$1))
                $rt_throw(s_MatchError__init_(var$1));
            var$2 = 1;
        }
        return jl_Boolean_valueOf(var$2);
    };
    $java.oncil_SolvableLabelExpression$$label$lambda$_5_0 = function() {
        jl_Object.call(this);
        this.$_0744 = null;
    };
    $java.oncil_SolvableLabelExpression$$label$lambda$_5_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0744;
        if (var$1 instanceof $java.oncil_NodeLabels$KnownLabels)
            var$3 = var$1.$labelNames.$contains0(var$2);
        else {
            if (!jl_Object_equals($java.oncil_NodeLabels$SomeUnknownLabels$_MODULE$, var$1))
                $rt_throw(s_MatchError__init_(var$1));
            var$3 = 0;
        }
        return jl_Boolean_valueOf(var$3);
    };
    $java.oncias_SemanticPatternCheck$$anonfun$2 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$varLength$1 = 0;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$2_applyOrElse = function($this, $x1, $default) {
        var var$3, $rel, var$5;
        var$3 = 0;
        $default = null;
        if ($x1 instanceof oncie_RelationshipChain) {
            var$3 = 1;
            $default = $x1;
            $rel = $default.$relationship1;
            if ($rel !== null) {
                $x1 = $rel.$variable12;
                var$5 = $rel.$length2;
                if ($x1 instanceof s_Some) {
                    $rel = $x1.$value5;
                    if (jl_Object_equals(s_None$_MODULE$, var$5) && !$this.$varLength$1) {
                        $x1 = new $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_0;
                        $x1.$_0789 = $rel;
                        return $x1;
                    }
                }
            }
        }
        if (var$3) {
            $default = $default.$relationship1;
            if ($default !== null) {
                $x1 = $default.$variable12;
                $default = $default.$length2;
                if ($x1 instanceof s_Some) {
                    $rel = $x1.$value5;
                    if ($default instanceof s_Some && $this.$varLength$1) {
                        $x1 = new $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_1;
                        $x1.$_0790 = $rel;
                        return $x1;
                    }
                }
            }
        }
        return new $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_2;
    };
    $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return jl_Boolean_valueOf(var$1.$length() <= 1 ? 0 : 1);
    };
    $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_1 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = new $java.oncias_SemanticPatternCheck$$$anonfun$findRepeatedRelationships$2$lambda$_144_0;
        onciu_InputPosition$_$callClinit();
        return sc_AbstractIterable_minBy(var$1, var$2, onciu_InputPosition$_byOffset0(onciu_InputPosition$_MODULE$));
    };
    $java.oncias_SemanticCheck$$error$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0703 = null;
    };
    $java.oncias_SemanticCheck$$error$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0703;
        return $java.oncias_SemanticCheckResult$_error(oncias_SemanticCheckResult$_MODULE$, var$1, var$2);
    };
    $java.oncia_CommandResultItem$semanticCheck$lambda$_50_0 = function() {
        jl_Object.call(this);
        this.$_0739 = null;
    };
    $java.oncia_CommandResultItem$semanticCheck$lambda$_50_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0739;
        var$3 = oncias_package$_MODULE$;
        var$4 = var$2.$aliasedVariable;
        oncius_package$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(var$3, oncias_SemanticAnalysisTooling_declareVariable$(var$2, var$4, var$1.$invariant()));
    };
    $java.oncia_CommandResultItem$semanticCheck$lambda$_50_1 = function() {
        jl_Object.call(this);
        this.$_0740 = null;
    };
    $java.oncia_CommandResultItem$semanticCheck$lambda$_50_1_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0740;
        var$2 = var$1.$originalName;
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$3);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(3258)), var$2), 96);
        return oncias_SemanticAnalysisTooling_error$(var$1, jl_AbstractStringBuilder_toString(var$3), var$1.$position214);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_20_0() {
        jl_Object.call(this);
        this.$_097 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_20_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_097;
        if (var$1 instanceof oncia_AscSortItem) {
            var$1 = var$1.$expression12;
            var$2 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$1);
            var$1 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$1);
            jl_StringBuilder_append(jl_StringBuilder_append(var$1, var$2), $rt_s(3259));
            var$1 = jl_AbstractStringBuilder_toString(var$1);
        } else {
            if (!(var$1 instanceof oncia_DescSortItem))
                $rt_throw(s_MatchError__init_(var$1));
            var$1 = var$1.$expression13;
            var$2 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$1);
            var$1 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$1);
            jl_StringBuilder_append(jl_StringBuilder_append(var$1, var$2), $rt_s(3260));
            var$1 = jl_AbstractStringBuilder_toString(var$1);
        }
        return var$1;
    };
    $java.oncia_SubqueryCall$semanticCheckContinuation$lambda$_64_0 = function() {
        jl_Object.call(this);
        this.$_0378 = null;
    };
    $java.oncia_SubqueryCall$semanticCheckContinuation$lambda$_64_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0378;
        var$3 = new oncias_SemanticCheckResult;
        var$1 = oncias_SemanticState_importValuesFromScope(var$1, var$2, oncias_SemanticState_importValuesFromScope$default$2(var$1));
        s_package$_$callClinit();
        oncias_SemanticCheckResult__init_0(var$3, var$1, (s_package$_Vector0(s_package$_MODULE$)).$from0(sci_Nil$_MODULE$));
        return var$3;
    };
    $java.oncia_ProcedureResult$semanticCheck$lambda$_14_0 = $rt_classWithoutFields();
    $java.oncia_ProcedureResult$semanticCheck$lambda$_14_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = oncias_package$_MODULE$;
        var$3 = var$1.$variable41;
        oncius_TypeSpec$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(var$2, oncias_SemanticAnalysisTooling_declareVariable$(var$1, var$3, $java.oncius_TypeSpec$_all(oncius_TypeSpec$_MODULE$)));
    };
    $java.oncia_ProcedureResult$semanticCheck$lambda$_14_1 = $rt_classWithoutFields();
    $java.oncia_ProcedureResult$semanticCheck$lambda$_14_1_apply = function(var$0, var$1) {
        return $java.oncia_Where_semanticCheck(var$1);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_0 = $rt_classWithoutFields();
    $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_0_apply = function(var$0, var$1) {
        return $java.oncia_SubqueryCall$InTransactionsBatchParameters_semanticCheck(var$1);
    };
    $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_1 = $rt_classWithoutFields();
    $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_1_apply = function(var$0, var$1) {
        return $java.oncia_SubqueryCall$InTransactionsReportParameters_semanticCheck(var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_0() {
        jl_Object.call(this);
        this.$_094 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_apply0(var$0.$_094.$$outer3.$expr2, var$1);
    };
    function onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_1() {
        jl_Object.call(this);
        this.$_093 = null;
    }
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_DefaultExpressionStringifier_stringify(var$0.$_093.$$outer3.$expr2, var$1);
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_0 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_0_apply = function(var$0, var$1) {
        return var$1.$batchSize;
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_1_apply = function(var$0, var$1) {
        return var$1.$behaviour;
    };
    var onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_2 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_2_apply = function(var$0, var$1) {
        return var$1.$reportAs;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_0 = function() {
        jl_Object.call(this);
        this.$_0694 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0694;
        var$3 = var$1.$output2;
        var$4 = new $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_0;
        var$4.$_0791 = var$2;
        var$4 = s_Option_getOrElse(s_Option_map(var$3, var$4), new $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_1);
        var$2 = onciap_DefaultExpressionStringifier_stringify(var$2.$$outer3.$expr2, var$1.$variable41);
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(var$1, var$4), var$2);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_1 = function() {
        jl_Object.call(this);
        this.$_0695 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asString0(var$0.$_0695, var$1);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_2 = function() {
        jl_Object.call(this);
        this.$_0696 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return onciap_Prettifier$IndentingQueryPrettifier_asNewLine(var$0.$_0696, var$1);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_3 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_3_apply = function(var$0) {
        return $rt_s(3);
    };
    var oncias_Scope$allSymbols$lambda$_16_0 = $rt_classWithoutFields();
    $java.oncias_Scope$allSymbols$lambda$_16_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$1 = var$1;
        var$2 = var$2;
        var$3 = s_Tuple2__init_(var$1, var$2);
        var$1 = var$3.$_10;
        return sc_IterableOnceOps_foldLeft$(var$3.$_20.$symbolTable, var$1, new $java.oncias_Scope$$anonfun$allSymbols$1$lambda$_40_0);
    };
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0782 = null;
        a.$_1253 = null;
    };
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0782;
        var$3 = var$0.$_1253;
        return $java.onciu_Foldable$TraverseChildren__init_0(oncia_Clause_org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition(var$2.$$outer55, var$3, 1, var$1));
    };
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0783 = null;
        a.$_1254 = null;
        a.$_272 = null;
    };
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0783;
                    var$3 = var$0.$_1254;
                    var$4 = var$0.$_272;
                    var$5 = new $java.onciu_Foldable$SkipChildren;
                    var$6 = var$2.$$outer55;
                    var$2 = (oncias_SemanticState_expressionType(var$2.$state$11, var$4)).$specified;
                    oncius_package$_$callClinit();
                    var$4 = oncius_NodeType_invariant(oncius_package$_CTNode(oncius_package$_MODULE$));
                    if (var$2 !== null) {
                        if (!oncius_TypeSpec_equals(var$2, var$4))
                            break b;
                        else
                            break c;
                    }
                    if (var$4 !== null)
                        break b;
                }
                var$7 = 1;
                break a;
            }
            var$7 = 0;
        }
        $java.onciu_Foldable$SkipChildren__init_0(var$5, oncia_Clause_org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition(var$6, var$3, var$7, var$1));
        return var$5;
    };
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0784 = null;
        a.$_1255 = null;
    };
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0784;
        var$3 = var$0.$_1255;
        return $java.onciu_Foldable$TraverseChildren__init_0(oncia_Clause_org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition(var$2.$$outer55, var$3, 0, var$1));
    };
    var oncil_LabelExpression$ = $rt_classWithoutFields();
    $java.oncil_LabelExpression$_MODULE$ = null;
    function oncil_LabelExpression$__clinit_() {
        $java.oncil_LabelExpression$_MODULE$ = new oncil_LabelExpression$;
    }
    $java.oncius_TypeSpec$contains$lambda$_9_0 = function() {
        jl_Object.call(this);
        this.$_0520 = null;
    };
    $java.oncius_TypeSpec$contains$lambda$_9_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        a: {
            var$1 = var$1;
            var$2 = var$0.$_0520;
            if (var$1.$lower1.$isAssignableFrom0(var$2)) {
                var$3 = var$1.$upper1;
                var$1 = new $java.oncius_TypeRange$contains$lambda$_6_0;
                var$4 = new $java.oncius_TypeRange$contains$lambda$_6_1;
                var$4.$_0792 = var$2;
                if (sr_BoxesRunTime_unboxToBoolean(s_Option_fold(var$3, var$1, var$4))) {
                    var$5 = 1;
                    break a;
                }
            }
            var$5 = 0;
        }
        return jl_Boolean_valueOf(var$5);
    };
    $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0__init_ = function() {
        var var_0 = new $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0();
        $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0__init_0(var_0);
        return var_0;
    };
    $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0__init_0 = function(var$0) {};
    $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0_apply = function(var$0, var$1, var$2) {
        var$1 = var$1;
        var$2 = var$2;
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union(var$1, var$2.$invariant());
    };
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_0 = $rt_classWithoutFields();
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$features1.$contains0(oncias_SemanticFeature$UseAsSingleGraphSelector$_MODULE$));
    };
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_1 = function() {
        jl_Object.call(this);
        this.$_0679 = null;
    };
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_1_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0679;
        var$2 = $java.oncia_UseGraph_checkGraphReference(var$1);
        var$3 = oncias_OptionSemanticChecking$_MODULE$;
        var$4 = $java.oncia_UseGraph_graphReference(var$1);
        var$5 = new $java.oncia_UseGraph$checkStaticGraphReference$lambda$_64_0;
        var$5.$_0793 = var$1;
        return var$2.$chain(oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$3, var$4, var$5));
    };
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_2 = function() {
        jl_Object.call(this);
        this.$_0680 = null;
    };
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_2_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0680;
        var$2 = oncias_SemanticCheck$_MODULE$;
        var$3 = new $java.oncia_UseGraph$unsupported$lambda$_58_0;
        var$3.$_0794 = var$1;
        return $java.oncias_SemanticCheck$_fromFunctionWithContext(var$2, var$3);
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$8$lambda$_93_0 = function() {
        jl_Object.call(this);
        this.$_0780 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$8$lambda$_93_0_apply = function(var$0) {
        return var$0.$_0780;
    };
    $java.oncia_Match$$anonfun$checkMatchMode$2$lambda$_118_0 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$checkMatchMode$2$lambda$_118_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
    };
    $java.oncia_Union$$anonfun$semanticCheckInSubqueryExpressionContext$2$lambda$_34_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0775 = null;
        a.$_1252 = 0;
    };
    $java.oncia_Union$$anonfun$semanticCheckInSubqueryExpressionContext$2$lambda$_34_0_apply = function(var$0) {
        return var$0.$_0775.$semanticCheckInSubqueryExpressionContext(var$0.$_1252);
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$6$lambda$_3_0 = function() {
        jl_Object.call(this);
        this.$_0747 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$6$lambda$_3_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(oncifp_CreatePatternSelfReferenceCheck$_org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1(var$1, var$0.$_0747.$allSymbolDefinitions$10));
    };
    $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_0 = function() {
        jl_Object.call(this);
        this.$_0704 = null;
    };
    $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_0_apply = function(var$0, var$1) {
        return oncias_SemanticCheckResult__init_(var$1, var$0.$_0704.$pattern2.$patternParts1.$collect0(new $java.oncia_Match$$anonfun$6));
    };
    $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_1 = function() {
        jl_Object.call(this);
        this.$_0705 = null;
    };
    $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0705;
        if (var$2.$pattern2.$patternParts1.$length() <= 1) {
            s_package$_$callClinit();
            var$2 = sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
        } else {
            var$3 = s_Option$_MODULE$;
            var$2 = var$2.$pattern2.$patternParts1.$find0(new $java.oncia_Match$checkDifferentRelationships$lambda$_70_0);
            var$4 = new $java.oncia_Match$checkDifferentRelationships$lambda$_70_1;
            var$4.$_0795 = var$1;
            var$2 = (s_Option$_option2Iterable(var$3, s_Option_map(var$2, var$4))).$toSeq();
        }
        return oncias_SemanticCheckResult__init_(var$1, var$2);
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$8$lambda$_5_0 = function() {
        jl_Object.call(this);
        this.$_0748 = null;
    };
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$8$lambda$_5_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(oncifp_CreatePatternSelfReferenceCheck$_org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1(var$1, var$0.$_0748.$allSymbolDefinitions$10));
    };
    $java.oncil_MultiOperatorLabelExpression$flatten$lambda$_2_0 = $rt_classWithoutFields();
    $java.oncil_MultiOperatorLabelExpression$flatten$lambda$_2_0_apply = function(var$0, var$1) {
        return var$1.$flatten0();
    };
    var onciuh_fixedPoint$ = $rt_classWithoutFields();
    $java.onciuh_fixedPoint$_MODULE$ = null;
    function onciuh_fixedPoint$__clinit_() {
        $java.onciuh_fixedPoint$_MODULE$ = new onciuh_fixedPoint$;
    }
    $java.onciuh_NameDeduplicator$$_clinit_$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncia_Union$checkImportingWith$lambda$_13_0 = function() {
        jl_Object.call(this);
        this.$_0344 = null;
    };
    $java.oncia_Union$checkImportingWith$lambda$_13_0_apply = function(var$0) {
        return (var$0.$_0344.$lhs()).$checkImportingWith();
    };
    $java.onciu_RepeatedRelationshipReference = function() {
        var a = this; jl_Object.call(a);
        a.$position298 = null;
        a.$relName0 = null;
        a.$pattern13 = null;
    };
    $java.onciu_RepeatedRelationshipReference_productPrefix = function($this) {
        return $rt_s(3261);
    };
    $java.onciu_RepeatedRelationshipReference_productArity = function($this) {
        return 3;
    };
    $java.onciu_RepeatedRelationshipReference_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position298;
            case 1:
                return $this.$relName0;
            case 2:
                return $this.$pattern13;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_RepeatedRelationshipReference_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_RepeatedRelationshipReference_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_RepeatedRelationshipReference_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_RepeatedRelationshipReference_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.onciu_RepeatedRelationshipReference) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position298;
                        var$3 = $x$1.$position298;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$relName0;
                        var$3 = $x$1.$relName0;
                        if (var$2 !== null) {
                            if (!jl_String_equals(var$2, var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$pattern13;
                        $x$1 = $x$1.$pattern13;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.onciu_RepeatedRelationshipReference))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.onciu_RepeatedVarLengthRelationshipReference = function() {
        var a = this; jl_Object.call(a);
        a.$position299 = null;
        a.$relName1 = null;
    };
    $java.onciu_RepeatedVarLengthRelationshipReference_productPrefix = function($this) {
        return $rt_s(3262);
    };
    $java.onciu_RepeatedVarLengthRelationshipReference_productArity = function($this) {
        return 2;
    };
    $java.onciu_RepeatedVarLengthRelationshipReference_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position299;
            case 1:
                return $this.$relName1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_RepeatedVarLengthRelationshipReference_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_RepeatedVarLengthRelationshipReference_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_RepeatedVarLengthRelationshipReference_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_RepeatedVarLengthRelationshipReference_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.onciu_RepeatedVarLengthRelationshipReference) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position299;
                        var$3 = $x$1.$position299;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$relName1;
                        $x$1 = $x$1.$relName1;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.onciu_RepeatedVarLengthRelationshipReference))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$3$lambda$_101_0 = function() {
        jl_Object.call(this);
        this.$_0770 = null;
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$3$lambda$_101_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0770;
        var$3 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        return s_Predef$ArrowAssoc$_$minus$greater$extension(var$3, var$1, var$2);
    };
    function sc_IterableOps$groupMap$lambda$_74_0() {
        var a = this; jl_Object.call(a);
        a.$_06 = null;
        a.$_11 = null;
        a.$_21 = null;
        a.$_30 = null;
    }
    $java.sc_IterableOps$groupMap$lambda$_74_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_06;
        var$3 = var$0.$_21;
        var$4 = var$1;
        var$5 = var$4.$_10;
        var$1 = new $java.sc_IterableOps$$anonfun$groupMap$1$lambda$_126_0;
        var$1.$_0796 = var$2;
        var$1 = scm_HashMap_getOrElseUpdate(var$3, var$5, var$1);
        var$2 = var$4.$_20;
        if (var$1 === null)
            $rt_throw(null);
        return var$1.$addOne(var$2);
    };
    function sc_IterableOps$Result$1() {
        sr_AbstractFunction1.call(this);
        this.$built = null;
    }
    $java.sc_IterableOps$Result$1_apply = function($this, $v1) {
        $this.$built = $this.$built.$updated1($v1.$_10, $v1.$_20.$result0());
        return sr_BoxedUnit_UNIT;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_0 = function() {
        jl_Object.call(this);
        this.$_0776 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0776;
        oncias_SemanticExpressionCheck$_$callClinit();
        return $java.oncius_TypeSpec_unwrapLists(var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_1 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_1_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_2 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_2_apply = function(var$0, var$1, var$2) {
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(3263)), var$2);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_3 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_3_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_4 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_4_apply = function(var$0, var$1, var$2) {
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(3264)), var$2);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_5 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_5_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_StringType_covariant(oncius_package$_CTString(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_6 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_6_apply = function(var$0, var$1, var$2) {
        oncias_SemanticExpressionCheck$_$callClinit();
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(var$1, $rt_s(3265)), var$2);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_7 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_7_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        return $java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_8 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_8_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_TypeSpec$_$callClinit();
        var$1 = oncius_TypeSpec$_MODULE$;
        var$2 = sr_ScalaRunTime$_MODULE$;
        var$3 = $rt_createArray(oncius_TypeSpec, 2);
        var$4 = var$3.data;
        oncius_package$_$callClinit();
        var$4[0] = $java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$));
        var$5 = oncius_package$_MODULE$;
        var$4[1] = $java.oncius_ListType_covariant(oncius_package$_CTList(var$5, oncius_package$_CTAny(var$5)));
        return $java.oncius_TypeSpec$_union(var$1, sr_ScalaRunTime$_wrapRefArray(var$2, var$3));
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_9 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_9_apply = function(var$0) {
        var var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        oncius_package$_$callClinit();
        var$1 = oncius_package$_MODULE$;
        return $java.oncius_ListType_covariant(oncius_package$_CTList(var$1, oncius_package$_CTAny(var$1)));
    };
    function oncia_ProjectionClause$semanticCheckContinuation$lambda$_31_0() {
        var a = this; jl_Object.call(a);
        a.$_0297 = null;
        a.$_191 = null;
        a.$_236 = null;
    }
    $java.oncia_ProjectionClause$semanticCheckContinuation$lambda$_31_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        var$2 = var$0.$_0297;
        var$3 = var$0.$_191;
        var$4 = var$0.$_236;
        var$5 = !s_Option_isDefined(var$2.$orderBy2()) && !s_Option_isDefined(var$2.$where0()) ? 0 : 1;
        var$6 = !(!oncia_ReturnItems_containsAggregate(var$2.$returnItems0()) && !var$2.$distinct1() && !(var$2 instanceof oncia_Yield)) && !(var$2.$returnItems0()).$includeExisting ? 0 : 1;
        if (var$5 && var$6) {
            var$7 = $java.oncias_SemanticCheck$_setState(oncias_SemanticCheck$_MODULE$, oncias_SemanticState_newChildScope(var$1));
            var$8 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_0;
            var$8.$_0797 = var$2;
            var$8.$_1258 = var$3;
            var$8.$_273 = var$1;
            var$1 = oncias_SemanticCheck_flatMap$(var$7, var$8);
        } else if (!var$5) {
            var$8 = $java.oncias_SemanticCheck$_setState(oncias_SemanticCheck$_MODULE$, oncias_SemanticState_newSiblingScope(var$1));
            var$7 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_2;
            var$7.$_0798 = var$2;
            var$7.$_1259 = var$3;
            var$7.$_274 = var$1;
            var$1 = oncias_SemanticCheck_flatMap$(var$8, var$7);
        } else {
            var$7 = oncias_SemanticState_newChildScope(oncias_SemanticState_newSiblingScope(var$1));
            var$8 = $java.oncias_SemanticCheck$_setState(oncias_SemanticCheck$_MODULE$, var$7);
            var$7 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_3;
            var$7.$_0799 = var$2;
            var$7.$_1260 = var$3;
            var$7.$_275 = var$1;
            var$1 = oncias_SemanticCheck_flatMap$(var$8, var$7);
        }
        var$3 = s_Tuple2__init_(jl_Boolean_valueOf(var$2.$isReturn()), var$4);
        var$6 = s_Tuple2__1$mcZ$sp(var$3);
        var$3 = var$3.$_20;
        if (1 == var$6 && var$3 instanceof s_Some) {
            var$3 = var$3.$value5;
            var$7 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_1;
            var$7.$_0800 = var$2;
            var$7.$_1261 = var$3;
            var$1 = oncias_SemanticCheck_map$(var$1, var$7);
        }
        return var$1;
    };
    $java.oncias_SemanticAnalysisTooling$possibleTypes$lambda$_75_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0685 = null;
        a.$_1211 = null;
    };
    $java.oncias_SemanticAnalysisTooling$possibleTypes$lambda$_75_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeSpec_unwrapLists($java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(var$0.$_0685, var$0.$_1211), var$1));
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$unionOfTypes$1$lambda$_108_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0672 = null;
        a.$_1208 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$unionOfTypes$1$lambda$_108_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0672;
        var$3 = var$0.$_1208;
        return $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(var$2.$types2(var$1), var$3);
    };
    function sc_IterableOps$groupMapReduce$lambda$_76_0() {
        var a = this; jl_Object.call(a);
        a.$_07 = null;
        a.$_12 = null;
        a.$_22 = null;
        a.$_31 = null;
    }
    $java.sc_IterableOps$groupMapReduce$lambda$_76_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_12;
        var$3 = var$0.$_31;
        var$4 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$5 = var$4.$_10;
        var$4 = scm_HashMap_get(var$2, var$5);
        if (!(var$4 instanceof s_Some)) {
            if (!jl_Object_equals(s_None$_MODULE$, var$4))
                $rt_throw(s_MatchError__init_(var$4));
            var$1 = $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_3_apply(var$3, var$1);
        } else {
            var$4 = var$4.$value5;
            var$1 = $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_3_apply(var$3, var$1);
            var$1 = var$4.$concat1(var$1);
        }
        var$1 = scm_HashMap_put01(var$2, var$5, var$1, 1);
        if (var$1 === null)
            var$1 = s_None$_MODULE$;
        return var$1;
    };
    function sc_MapFactory$ToFactory() {
        jl_Object.call(this);
        this.$factory = null;
    }
    $java.sc_MapFactory$ToFactory_fromSpecific = function($this, $it) {
        return sci_Map$_from($this.$factory, $it);
    };
    var oncias_SemanticCheckContext$default$ = $rt_classWithoutFields();
    var oncias_SemanticCheckContext$default$_MODULE$ = null;
    function oncias_SemanticCheckContext$default$__clinit_() {
        oncias_SemanticCheckContext$default$_MODULE$ = new oncias_SemanticCheckContext$default$;
    }
    $java.oncias_SemanticCheckContext$default$_errorMessageProvider = function($this) {
        return $java.onciu_NotImplementedErrorMessageProvider$_MODULE$;
    };
    $java.oncius_TypeSpec$$anonfun$intersect$1$lambda$_53_0 = function() {
        jl_Object.call(this);
        this.$_0753 = null;
    };
    $java.oncius_TypeSpec$$anonfun$intersect$1$lambda$_53_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncius_TypeRange_intersect(var$0.$_0753, var$1);
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$1$lambda$_55_0 = function() {
        jl_Object.call(this);
        this.$_0684 = null;
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$1$lambda$_55_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0684;
        return $java.oncius_TypeSpec_wrapInList($java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$($java.oncias_SemanticFunctionCheck$_MODULE$, ($java.oncie_Expression_arguments(var$2)).$apply1(0)), var$1));
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$11$lambda$_66_0 = function() {
        jl_Object.call(this);
        this.$_0687 = null;
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$11$lambda$_66_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0687;
        return $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$($java.oncias_SemanticFunctionCheck$_MODULE$, ($java.oncie_Expression_arguments(var$2)).$apply1(0)), var$1);
    };
    $java.oncius_StorableType$ = $rt_classWithoutFields();
    $java.oncius_StorableType$_MODULE$ = null;
    $java.oncius_StorableType$_storableType = null;
    $java.oncius_StorableType$_$callClinit = function() {
        $java.oncius_StorableType$_$callClinit = $rt_eraseClinit($java.oncius_StorableType$);
        $java.oncius_StorableType$__clinit_();
    };
    $java.oncius_StorableType$__clinit_ = function() {
        var var$1, var$2;
        var$1 = new $java.oncius_StorableType$;
        $java.oncius_StorableType$_$callClinit();
        $java.oncius_StorableType$_MODULE$ = var$1;
        oncius_package$_$callClinit();
        var$2 = $java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union($java.oncius_TypeSpec_union((oncius_package$_CTBoolean(oncius_package$_MODULE$)).$invariant(), $java.oncius_NumberType_covariant($java.oncius_package$_CTNumber(oncius_package$_MODULE$))), ($java.oncius_package$_CTPoint0(oncius_package$_MODULE$)).$invariant()), (oncius_package$_CTString(oncius_package$_MODULE$)).$invariant()),
        ($java.oncius_package$_CTDuration0(oncius_package$_MODULE$)).$invariant()), ($java.oncius_package$_CTDate0(oncius_package$_MODULE$)).$invariant()), ($java.oncius_package$_CTTime0(oncius_package$_MODULE$)).$invariant()), ($java.oncius_package$_CTLocalTime0(oncius_package$_MODULE$)).$invariant()), ($java.oncius_package$_CTLocalDateTime0(oncius_package$_MODULE$)).$invariant()), ($java.oncius_package$_CTDateTime0(oncius_package$_MODULE$)).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, oncius_package$_CTBoolean(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTNumber(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, oncius_package$_CTInteger(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTFloat(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTPoint0(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, oncius_package$_CTString(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTDuration0(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTDate0(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTTime0(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTLocalTime0(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        var$2 = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTLocalDateTime0(var$1))).$invariant());
        var$1 = oncius_package$_MODULE$;
        $java.oncius_StorableType$_storableType = $java.oncius_TypeSpec_union(var$2, (oncius_package$_CTList(var$1, $java.oncius_package$_CTDateTime0(var$1))).$invariant());
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_0_apply = function(var$0, var$1) {
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_Scope_allSymbols(var$1.$location.$elem);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_1 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_1_apply = function(var$0) {
        oncias_SemanticExpressionCheck$_$callClinit();
        s_Predef$_$callClinit();
        s_Predef$_Map(s_Predef$_MODULE$);
        return sci_Map$EmptyMap$_MODULE$;
    };
    function oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_0() {
        jl_Object.call(this);
        this.$_0296 = null;
    }
    $java.oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0296;
        return s_Tuple3__init_(onciap_DefaultExpressionStringifier_stringifyLabelExpression(var$2.$org$neo4j$cypher$internal$ast$Clause$$stringifier21(), var$1.$replaceColonSyntax()), jl_Boolean_valueOf(var$1.$containsIs6()), var$1.$position2());
    };
    var oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_1 = $rt_classWithoutFields();
    $java.oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = !sr_BoxesRunTime_unboxToBoolean(var$1.$_212) ? $rt_s(136) : $rt_s(1073);
        var$3 = var$1.$_121;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_StringBuilder_append(jl_StringBuilder_append(var$1, var$2), var$3);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$checkToSpecifiedTypeOfArgument$1$lambda$_92_0 = function() {
        jl_Object.call(this);
        this.$_0781 = null;
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$checkToSpecifiedTypeOfArgument$1$lambda$_92_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4;
        var$2 = var$2;
        var$3 = var$0.$_0781;
        var$4 = sr_BoxesRunTime_unboxToBoolean(var$1);
        var$1 = s_Tuple2__init_(jl_Boolean_valueOf(var$4), var$2);
        var$4 = s_Tuple2__1$mcZ$sp(var$1);
        var$1 = var$1.$_20;
        return jl_Boolean_valueOf(!var$4 && !$java.oncius_TypeSpec_contains(var$3, var$1) ? 0 : 1);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpression$3$lambda$_186_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0754 = null;
        a.$_1239 = null;
        a.$_271 = null;
        a.$_315 = null;
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpression$3$lambda$_186_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7, $$je;
        var$1 = var$0.$_0754;
        var$2 = var$0.$_1239;
        var$3 = var$0.$_271;
        var$4 = var$0.$_315;
        oncias_SemanticExpressionCheck$_$callClinit();
        var$5 = onciap_DefaultExpressionStringifier_stringifyLabelExpression($java.oncias_SemanticExpressionCheck$_stringifier0(oncias_SemanticExpressionCheck$_MODULE$), var$1.$replaceColonSyntax());
        var$6 = oncias_SemanticExpressionCheck$_MODULE$;
        if (!var$1.$containsIs6()) {
            var$7 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$7);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$7, $rt_s(3266)), var$5), 46);
            var$7 = jl_AbstractStringBuilder_toString(var$7);
        } else {
            var$7 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$7);
            jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$7, $rt_s(3267)), var$5), 46);
            var$7 = jl_AbstractStringBuilder_toString(var$7);
        }
        if (var$2.$_initialized)
            var$1 = var$2.$_value0;
        else {
            jl_Object_monitorEnterSync(var$2);
            a: {
                try {
                    var$1 = $java.sr_LazyRef_initialized(var$2) ? $java.sr_LazyRef_value(var$2) : $java.sr_LazyRef_initialize(var$2, sc_AbstractIterable_$plus$plus($java.oncias_SemanticExpressionCheck$_colonConjunctions$1(var$3, var$1), $java.oncias_SemanticExpressionCheck$_colonDisjunctions$1(var$4, var$1)));
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync(var$2);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync(var$2);
        }
        return oncias_SemanticAnalysisTooling_error$(var$6, var$7, (var$1.$head()).$position2());
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$13$lambda$_68_0 = function() {
        jl_Object.call(this);
        this.$_0688 = null;
    };
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$13$lambda$_68_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0688;
        return $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$($java.oncias_SemanticFunctionCheck$_MODULE$, ($java.oncie_Expression_arguments(var$2)).$apply1(0)), var$1);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$7$lambda$_128_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$7$lambda$_128_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_ensureDefined$(oncias_SemanticPatternCheck$_MODULE$, var$1.$singleton));
    };
    function oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1$lambda$_6_0() {
        jl_Object.call(this);
        this.$_044 = null;
    }
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1$lambda$_6_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(oncifp_CreatePatternSelfReferenceCheck$_org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1(var$1, var$0.$_044) ? 0 : 1);
    };
    $java.jlr_AccessibleObject = $rt_classWithoutFields();
    $java.jlr_Member = $rt_classWithoutFields(0);
    function jlr_Method() {
        var a = this; $java.jlr_AccessibleObject.call(a);
        a.$declaringClass0 = null;
        a.$name1 = null;
        a.$flags = 0;
        a.$accessLevel0 = 0;
        a.$returnType = null;
        a.$parameterTypes = null;
        a.$callable = null;
    }
    function jlr_Method_getModifiers($this) {
        return $java.otcir_Flags_getModifiers($this.$flags, $this.$accessLevel0);
    }
    function jlr_Method_getParameterTypes($this) {
        return $this.$parameterTypes.$clone();
    }
    $java.jlr_Method_toString = function($this) {
        var $sb, $parameterTypes, var$3, $i;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        jl_AbstractStringBuilder_append1($sb, $java.jlr_Modifier_toString(jlr_Method_getModifiers($this)));
        if ($sb.$length0 > 0)
            jl_AbstractStringBuilder_append($sb, 32);
        a: {
            jl_AbstractStringBuilder_append1($sb, jl_Class_getName($this.$returnType));
            jl_AbstractStringBuilder_append($sb, 32);
            jl_AbstractStringBuilder_append1($sb, jl_Class_getName($this.$declaringClass0));
            jl_AbstractStringBuilder_append($sb, 46);
            jl_AbstractStringBuilder_append1($sb, $this.$name1);
            jl_AbstractStringBuilder_append($sb, 40);
            $parameterTypes = (jlr_Method_getParameterTypes($this)).data;
            var$3 = $parameterTypes.length;
            if (var$3 > 0) {
                jl_AbstractStringBuilder_append1($sb, jl_Class_getName($parameterTypes[0]));
                $i = 1;
                while (true) {
                    if ($i >= var$3)
                        break a;
                    jl_AbstractStringBuilder_append($sb, 44);
                    jl_AbstractStringBuilder_append1($sb, jl_Class_getName($parameterTypes[$i]));
                    $i = $i + 1 | 0;
                }
            }
        }
        jl_AbstractStringBuilder_append($sb, 41);
        return jl_AbstractStringBuilder_toString($sb);
    };
    $java.jlr_Method_invoke = function($this, $obj, $args) {
        var var$3, var$4, $i, $jsArgs, $result;
        if ($this.$callable === null) {
            $obj = new $java.jl_IllegalAccessException;
            jl_Throwable__init_0($obj);
            $rt_throw($obj);
        }
        var$3 = $args.data;
        var$4 = var$3.length;
        if (var$4 != $this.$parameterTypes.data.length) {
            $obj = new jl_IllegalArgumentException;
            jl_Throwable__init_0($obj);
            $rt_throw($obj);
        }
        if ($this.$flags & 512)
            $this.$declaringClass0.$platformClass.$clinit();
        else if (!jl_Class_isInstance($this.$declaringClass0, $obj)) {
            $obj = new jl_IllegalArgumentException;
            jl_Throwable__init_0($obj);
            $rt_throw($obj);
        }
        $i = 0;
        while (true) {
            if ($i >= var$4) {
                $jsArgs = $args.data;
                $result = $this.$callable;
                $obj = $obj;
                return $result.call($obj, $jsArgs);
            }
            if (!jl_Class_isPrimitive($this.$parameterTypes.data[$i]) && var$3[$i] !== null && !jl_Class_isInstance($this.$parameterTypes.data[$i], var$3[$i])) {
                $obj = new jl_IllegalArgumentException;
                jl_Throwable__init_0($obj);
                $rt_throw($obj);
            }
            if (jl_Class_isPrimitive($this.$parameterTypes.data[$i]) && var$3[$i] === null)
                break;
            $i = $i + 1 | 0;
        }
        $obj = new jl_IllegalArgumentException;
        jl_Throwable__init_0($obj);
        $rt_throw($obj);
    };
    $java.oncie_TypeSignatures$signatureLengths$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncie_TypeSignatures$signatureLengths$lambda$_3_0_apply = function(var$0, var$1) {
        return jl_Integer_valueOf(sci_Vector_length(var$1.$argumentTypes1()));
    };
    $java.oncia_TransactionsCommandClause$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$lambda$_6_0 = $rt_classWithoutFields();
    $java.oncia_TransactionsCommandClause$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$lambda$_6_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        return s_Predef$ArrowAssoc$_$minus$greater$extension(var$2, var$1.$name49, var$1.$cypherType0);
    };
    $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_0 = $rt_classWithoutFields();
    $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_0_apply$mcZ$sp = function(var$0) {
        return 0;
    };
    $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_1 = function() {
        jl_Object.call(this);
        this.$_0755 = null;
    };
    $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isAssignableFrom0(var$0.$_0755));
    };
    var oncia_Clause$SetExtractor$ = $rt_classWithoutFields();
    function oncia_Clause$SetExtractor$__init_(var_0) {
        var var_1 = new oncia_Clause$SetExtractor$();
        $java.oncia_Clause$SetExtractor$__init_(var_1, var_0);
        return var_1;
    }
    function oncia_Clause$SetExtractor$_unapplySeq($this, $s) {
        return s_Some__init_(sc_IterableOnceOps_toSeq$($s));
    }
    $java.oncia_Clause$SetExtractor$__init_ = function($this, $$outer) {};
    var oncia_GraphReference$ = $rt_classWithoutFields();
    $java.oncia_GraphReference$_MODULE$ = null;
    function oncia_GraphReference$__clinit_() {
        $java.oncia_GraphReference$_MODULE$ = new oncia_GraphReference$;
    }
    $java.oncia_GraphReference$_from = function($this, $expression) {
        var $name, $p, $name_0;
        $name = s_Tuple2__init_($expression, $java.oncia_GraphReference$_fqn$1($expression));
        $p = $name.$_10;
        $expression = $name.$_20;
        if ($p instanceof oncie_FunctionInvocation) {
            $name = $p;
            if ($expression instanceof s_Some) {
                $name_0 = $expression.$value5;
                return s_Some__init_($java.oncia_ViewRef__init_($java.oncia_CatalogName__init_($name_0), $name.$args, $name.$position7));
            }
        }
        if ($rt_isInstance($p, oncie_Parameter)) {
            $expression = $p;
            return s_Some__init_($java.oncia_GraphRefParameter__init_($expression, $expression.$position14));
        }
        if (!($expression instanceof s_Some))
            return s_None$_MODULE$;
        $name = $expression.$value5;
        return s_Some__init_($java.oncia_GraphRef__init_($java.oncia_CatalogName__init_($name), $p.$position2()));
    };
    $java.oncia_GraphReference$_checkNotEmpty = function($this, $gr, $pos) {
        var var$3, var$4;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = s_Option_isEmpty($gr);
        $gr = new $java.oncia_GraphReference$$checkNotEmpty$lambda$_41_0;
        $gr.$_0801 = $pos;
        return oncias_SemanticCheck$_when(var$3, var$4, $gr);
    };
    $java.oncia_GraphReference$_fqn$1 = function($expr) {
        var var$2, var$3;
        if ($expr instanceof oncie_Property) {
            $expr = $expr;
            var$2 = $java.oncia_GraphReference$_fqn$1($expr.$map11);
            var$3 = new $java.oncia_GraphReference$$fqn$1$lambda$_43_0;
            var$3.$_0802 = $expr;
            return s_Option_map(var$2, var$3);
        }
        if ($expr instanceof oncie_Variable) {
            $expr = $expr;
            return s_Some__init_(sci_$colon$colon__init_($expr.$name4, sci_Nil$_MODULE$));
        }
        if (!($expr instanceof oncie_FunctionInvocation))
            return s_None$_MODULE$;
        $expr = $expr;
        return s_Some__init_($expr.$namespace1.$parts0.$appended($expr.$functionName0.$name6));
    };
    $java.oncia_UseGraph$checkDynamicGraphReference$lambda$_60_0 = function() {
        jl_Object.call(this);
        this.$_0678 = null;
    };
    $java.oncia_UseGraph$checkDynamicGraphReference$lambda$_60_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0678;
        return var$1 instanceof $java.oncia_ViewRef ? $java.oncia_UseGraph_checkExpressions(var$2, var$1.$arguments0) : !(var$1 instanceof $java.oncia_GraphRefParameter) ? oncias_SemanticCheck$_success : $java.oncia_UseGraph_checkExpressions(var$2, sci_$colon$colon__init_(var$1.$parameter3, sci_Nil$_MODULE$));
    };
    function jlr_Field() {
        var a = this; $java.jlr_AccessibleObject.call(a);
        a.$declaringClass = null;
        a.$name0 = null;
        a.$modifiers = 0;
        a.$accessLevel = 0;
        a.$type = null;
        a.$getter = null;
        a.$setter = null;
    }
    $java.jlr_Field_toString = function($this) {
        var $sb;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        jl_AbstractStringBuilder_append1($sb, $java.jlr_Modifier_toString($java.otcir_Flags_getModifiers($this.$modifiers, $this.$accessLevel)));
        if ($sb.$length0 > 0)
            jl_AbstractStringBuilder_append($sb, 32);
        jl_AbstractStringBuilder_append1($sb, jl_Class_getName($this.$type));
        jl_AbstractStringBuilder_append($sb, 32);
        jl_AbstractStringBuilder_append1($sb, jl_Class_getName($this.$declaringClass));
        jl_AbstractStringBuilder_append1($sb, $rt_s(142));
        jl_AbstractStringBuilder_append1($sb, $this.$name0);
        return jl_AbstractStringBuilder_toString($sb);
    };
    $java.onciu_RewritableCompat$PROXY$7_260 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_260_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_260 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_260_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_261 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_261_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_261 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_261_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_963 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_963_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncil_LabelExpression$Conjunctions_copy(var$2, var$3[0], var$3[1].$value8, var$3[2]);
    }
    var s_Enumeration$ValueOrdering$ = $rt_classWithoutFields();
    $java.sc_SpecificIterableFactory = $rt_classWithoutFields(0);
    var s_Enumeration$ValueSet$ = $rt_classWithoutFields();
    var s_Enumeration$ValueSet = $rt_classWithoutFields(sci_AbstractSet);
    $java.suc_TailCalls$Cont = function() {
        var a = this; $java.suc_TailCalls$TailRec.call(a);
        a.$a0 = null;
        a.$f14 = null;
    };
    $java.suc_TailCalls$Cont__init_ = function(var_0, var_1) {
        var var_2 = new $java.suc_TailCalls$Cont();
        $java.suc_TailCalls$Cont__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.suc_TailCalls$Cont_productPrefix = function($this) {
        return $rt_s(3268);
    };
    $java.suc_TailCalls$Cont_productArity = function($this) {
        return 2;
    };
    $java.suc_TailCalls$Cont_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$a0;
            case 1:
                return $this.$f14;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.suc_TailCalls$Cont_productIterator = function($this) {
        return sr_ScalaRunTime$$anon$1__init_($this);
    };
    $java.suc_TailCalls$Cont_hashCode = function($this) {
        suh_MurmurHash3$_$callClinit();
        return suh_MurmurHash3$_productHash(suh_MurmurHash3$_MODULE$, $this);
    };
    $java.suc_TailCalls$Cont_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.suc_TailCalls$Cont_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            if ($this !== $x$1) {
                if (!(!($x$1 instanceof $java.suc_TailCalls$Cont) ? 0 : 1))
                    break a;
                b: {
                    $x$1 = $x$1;
                    var$2 = $this.$a0;
                    var$3 = $x$1.$a0;
                    if (var$2 !== null) {
                        if (!$java.suc_TailCalls$Call_equals(var$2, var$3))
                            break a;
                        else
                            break b;
                    }
                    if (var$3 !== null)
                        break a;
                }
                c: {
                    var$3 = $this.$f14;
                    $x$1 = $x$1.$f14;
                    if (var$3 !== null) {
                        if (!jl_Object_equals(var$3, $x$1))
                            break a;
                        else
                            break c;
                    }
                    if ($x$1 !== null)
                        break a;
                }
                if (!($this instanceof $java.suc_TailCalls$Cont))
                    break a;
            }
            return 1;
        }
        return 0;
    };
    $java.suc_TailCalls$Cont__init_0 = function($this, $a, $f) {
        $this.$a0 = $a;
        $this.$f14 = $f;
    };
    $java.suc_TailCalls$TailRec$result$lambda$_3_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0765 = null;
        a.$_1247 = null;
    };
    $java.suc_TailCalls$TailRec$result$lambda$_3_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$2 = var$0.$_0765;
        var$3 = var$0.$_1247;
        var$2 = var$2.$apply(var$1);
        if (var$2 === null)
            $rt_throw(null);
        if (var$2 instanceof $java.suc_TailCalls$Done) {
            var$2 = var$2.$value6();
            var$1 = new $java.suc_TailCalls$Call;
            var$4 = new $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_0;
            var$4.$_0803 = var$3;
            var$4.$_1262 = var$2;
            $java.suc_TailCalls$Call__init_0(var$1, var$4);
        } else if (var$2 instanceof $java.suc_TailCalls$Call)
            var$1 = $java.suc_TailCalls$Cont__init_(var$2, var$3);
        else {
            if (!(var$2 instanceof $java.suc_TailCalls$Cont))
                $rt_throw(s_MatchError__init_(var$2));
            var$1 = new $java.suc_TailCalls$Cont;
            var$4 = var$2.$a7();
            var$5 = new $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_1;
            var$5.$_0804 = var$2;
            var$5.$_1263 = var$3;
            $java.suc_TailCalls$Cont__init_0(var$1, var$4, var$5);
        }
        return var$1;
    };
    $java.suc_TailCalls$TailRec$result$lambda$_3_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0766 = null;
        a.$_1248 = null;
    };
    $java.suc_TailCalls$TailRec$result$lambda$_3_1_apply = function(var$0) {
        return var$0.$_0766.$apply(var$0.$_1248);
    };
    $java.suc_TailCalls$TailRec$result$lambda$_3_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0767 = null;
        a.$_1249 = null;
    };
    $java.suc_TailCalls$TailRec$result$lambda$_3_2_apply = function(var$0, var$1) {
        return $java.suc_TailCalls$TailRec_$anonfun$flatMap$2(var$0.$_0767, var$0.$_1249, var$1);
    };
    $java.suc_TailCalls$TailRec$flatMap$lambda$_1_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0763 = null;
        a.$_1245 = null;
    };
    $java.suc_TailCalls$TailRec$flatMap$lambda$_1_0_apply = function(var$0) {
        return var$0.$_0763.$apply(var$0.$_1245);
    };
    $java.suc_TailCalls$TailRec$flatMap$lambda$_1_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0764 = null;
        a.$_1246 = null;
    };
    $java.suc_TailCalls$TailRec$flatMap$lambda$_1_1_apply = function(var$0, var$1) {
        return $java.suc_TailCalls$TailRec_$anonfun$flatMap$2(var$0.$_0764, var$0.$_1246, var$1);
    };
    $java.suc_TailCalls$TailRec$map$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0760 = null;
    };
    $java.suc_TailCalls$TailRec$map$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0760;
        var$3 = new $java.suc_TailCalls$Call;
        var$4 = new $java.suc_TailCalls$TailRec$$anonfun$map$1$lambda$_5_0;
        var$4.$_0805 = var$2;
        var$4.$_1264 = var$1;
        $java.suc_TailCalls$Call__init_0(var$3, var$4);
        return var$3;
    };
    $java.suc_TailCalls$TailRec$map$lambda$_0_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0761 = null;
        a.$_1243 = null;
    };
    $java.suc_TailCalls$TailRec$map$lambda$_0_1_apply = function(var$0) {
        return var$0.$_0761.$apply(var$0.$_1243);
    };
    $java.suc_TailCalls$TailRec$map$lambda$_0_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0762 = null;
        a.$_1244 = null;
    };
    $java.suc_TailCalls$TailRec$map$lambda$_0_2_apply = function(var$0, var$1) {
        return $java.suc_TailCalls$TailRec_$anonfun$flatMap$2(var$0.$_0762, var$0.$_1244, var$1);
    };
    $java.onciuh_fixedPoint$$apply$lambda$_1_0 = function() {
        jl_Object.call(this);
        this.$_0788 = null;
    };
    $java.oncia_GraphReference$$checkNotEmpty$lambda$_41_0 = function() {
        jl_Object.call(this);
        this.$_0801 = null;
    };
    $java.oncia_GraphReference$$checkNotEmpty$lambda$_41_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0801;
        return oncias_SemanticAnalysisTooling_error$($java.oncia_GraphReference$_MODULE$, $rt_s(3269), var$1);
    };
    $java.oncia_GraphReference = $rt_classWithoutFields(0);
    $java.oncia_GraphReference_semanticCheck$ = function($$this) {
        return oncias_SemanticCheck$_success;
    };
    $java.oncia_ViewRef = function() {
        var a = this; jl_Object.call(a);
        a.$name66 = null;
        a.$arguments0 = null;
        a.$position301 = null;
    };
    $java.oncia_ViewRef__init_ = function(var_0, var_1, var_2) {
        var var_3 = new $java.oncia_ViewRef();
        $java.oncia_ViewRef__init_0(var_3, var_0, var_1, var_2);
        return var_3;
    };
    $java.oncia_ViewRef_position = function($this) {
        return $this.$position301;
    };
    $java.oncia_ViewRef_semanticCheck = function($this) {
        var var$1, var$2;
        var$1 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$2 = $this.$arguments0;
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$1, var$2.$zip2(var$2.$map1(new $java.oncia_ViewRef$argumentsAsGraphReferences$lambda$_51_0)), new $java.oncia_ViewRef$semanticCheck$lambda$_50_0);
    };
    $java.oncia_ViewRef_productPrefix = function($this) {
        return $rt_s(3270);
    };
    $java.oncia_ViewRef_productArity = function($this) {
        return 2;
    };
    $java.oncia_ViewRef_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name66;
            case 1:
                return $this.$arguments0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_ViewRef_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ViewRef_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ViewRef_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_ViewRef_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncia_ViewRef) ? 0 : 1))
                            break b;
                        d: {
                            $x$1 = $x$1;
                            var$2 = $this.$name66;
                            var$3 = $x$1.$name66;
                            if (var$2 !== null) {
                                if (!$java.oncia_CatalogName_equals(var$2, var$3))
                                    break b;
                                else
                                    break d;
                            }
                            if (var$3 !== null)
                                break b;
                        }
                        var$3 = $this.$arguments0;
                        $x$1 = $x$1.$arguments0;
                        if (var$3 !== null) {
                            if (!var$3.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_ViewRef_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_ViewRef__init_0 = function($this, $name, $arguments, $position) {
        $this.$name66 = $name;
        $this.$arguments0 = $arguments;
        $this.$position301 = $position;
    };
    $java.oncia_CatalogName = function() {
        jl_Object.call(this);
        this.$parts1 = null;
    };
    $java.oncia_CatalogName__init_ = function(var_0) {
        var var_1 = new $java.oncia_CatalogName();
        $java.oncia_CatalogName__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_CatalogName_productPrefix = function($this) {
        return $rt_s(3271);
    };
    $java.oncia_CatalogName_productArity = function($this) {
        return 1;
    };
    $java.oncia_CatalogName_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$parts1;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_CatalogName_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CatalogName_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CatalogName_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_CatalogName_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.oncia_CatalogName) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$parts1;
                        $x$1 = $x$1.$parts1;
                        if (var$2 !== null) {
                            if (!sci_List_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.oncia_CatalogName))
                        break b;
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_CatalogName__init_0 = function($this, $parts) {
        $this.$parts1 = $parts;
    };
    $java.oncia_GraphRefParameter = function() {
        var a = this; jl_Object.call(a);
        a.$parameter3 = null;
        a.$position302 = null;
    };
    $java.oncia_GraphRefParameter__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_GraphRefParameter();
        $java.oncia_GraphRefParameter__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_GraphRefParameter_semanticCheck = function($this) {
        return $java.oncia_GraphReference_semanticCheck$($this);
    };
    $java.oncia_GraphRefParameter_position = function($this) {
        return $this.$position302;
    };
    $java.oncia_GraphRefParameter_productPrefix = function($this) {
        return $rt_s(3272);
    };
    $java.oncia_GraphRefParameter_productArity = function($this) {
        return 1;
    };
    $java.oncia_GraphRefParameter_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$parameter3;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_GraphRefParameter_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphRefParameter_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphRefParameter_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphRefParameter_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncia_GraphRefParameter) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$parameter3;
                        $x$1 = $x$1.$parameter3;
                        if (var$2 !== null) {
                            if (!$java.oncie_ExplicitParameter_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_GraphRefParameter_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_GraphRefParameter__init_0 = function($this, $parameter, $position) {
        $this.$parameter3 = $parameter;
        $this.$position302 = $position;
    };
    $java.oncia_GraphRef = function() {
        var a = this; jl_Object.call(a);
        a.$name67 = null;
        a.$position303 = null;
    };
    $java.oncia_GraphRef__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_GraphRef();
        $java.oncia_GraphRef__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_GraphRef_semanticCheck = function($this) {
        return $java.oncia_GraphReference_semanticCheck$($this);
    };
    $java.oncia_GraphRef_position = function($this) {
        return $this.$position303;
    };
    $java.oncia_GraphRef_productPrefix = function($this) {
        return $rt_s(1786);
    };
    $java.oncia_GraphRef_productArity = function($this) {
        return 1;
    };
    $java.oncia_GraphRef_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$name67;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncia_GraphRef_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphRef_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphRef_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncia_GraphRef_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncia_GraphRef) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$name67;
                        $x$1 = $x$1.$name67;
                        if (var$2 !== null) {
                            if (!$java.oncia_CatalogName_equals(var$2, $x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncia_GraphRef_dup = function($this, $children) {
        return onciu_ASTNode_dup$($this, $children);
    };
    $java.oncia_GraphRef__init_0 = function($this, $name, $position) {
        $this.$name67 = $name;
        $this.$position303 = $position;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$3$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$anonfun$3$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return var$1.$propertyKey0;
    };
    $java.oncia_SingleQuery$$anonfun$importWith$2 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$$outer30 = null;
    };
    $java.oncia_SingleQuery$$anonfun$importWith$2_applyOrElse = function($this, $x, $default) {
        var var$3, var$4, var$5, var$6, var$7, var$8, var$9;
        a: {
            $x = $x;
            if ($x instanceof oncia_With) {
                b: {
                    $x = $x;
                    if ($x !== null) {
                        var$3 = $x.$distinct2;
                        var$4 = $x.$returnItems2;
                        var$5 = $x.$orderBy1;
                        var$6 = $x.$skip1;
                        var$7 = $x.$limit1;
                        var$8 = $x.$where2;
                        if (0 == var$3 && jl_Object_equals(s_None$_MODULE$, var$5) && jl_Object_equals(s_None$_MODULE$, var$6) && jl_Object_equals(s_None$_MODULE$, var$7) && jl_Object_equals(s_None$_MODULE$, var$8)) {
                            var$9 = var$4.$items.$forall(new $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$hasImportFormat$1$lambda$_93_0);
                            break b;
                        }
                    }
                    var$9 = 0;
                }
                if (var$9)
                    break a;
            }
            $x = s_PartialFunction$_fallback_fn;
        }
        return $x;
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$2$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0779 = null;
    };
    $java.oncias_SemanticExpressionCheck$$anonfun$2$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0779.$definition;
                    if (var$1 !== null) {
                        if ($java.oncias_SymbolUse_equals(var$1, var$2))
                            break c;
                        else
                            break b;
                    }
                    if (var$2 !== null)
                        break b;
                }
                var$3 = 0;
                break a;
            }
            var$3 = 1;
        }
        return jl_Boolean_valueOf(var$3);
    };
    var oncia_ASTSlicingPhrase$ = $rt_classWithoutFields();
    $java.oncia_ASTSlicingPhrase$_MODULE$ = null;
    function oncia_ASTSlicingPhrase$__clinit_() {
        $java.oncia_ASTSlicingPhrase$_MODULE$ = new oncia_ASTSlicingPhrase$;
    }
    $java.oncia_ASTSlicingPhrase$_expectType = function($this, $s, $possibleTypes, $expression, $messageGen) {
        return oncias_SemanticAnalysisTooling_expectType$2($this, $s, $possibleTypes, $expression, $messageGen);
    };
    $java.oncia_ASTSlicingPhrase$_expectType$default$4 = function($this) {
        return oncias_SemanticAnalysisTooling_expectType$default$4$($this);
    };
    $java.oncia_ASTSlicingPhrase$_error = function($this, $msg, $position) {
        return oncias_SemanticAnalysisTooling_error$($this, $msg, $position);
    };
    $java.oncia_ASTSlicingPhrase$_checkExpressionIsStaticInt = function($this, $expression, $name, $acceptsZero) {
        var var$4, var$5, var$6, var$7, var$8, $$je;
        var$4 = onciu_Foldable$Folder_treeExists(onciu_Foldable_folder$($expression), new $java.oncia_ASTSlicingPhrase$$anonfun$1);
        var$5 = oncias_SemanticCheck$_MODULE$;
        var$6 = new $java.oncia_ASTSlicingPhrase$$doesNotTouchTheGraph$lambda$_42_0;
        var$6.$_0806 = $name;
        var$6.$_1265 = $expression;
        var$5 = oncias_SemanticCheck$_when(var$5, var$4, var$6);
        var$6 = new $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_0;
        var$6.$_0807 = $expression;
        var$6.$_1266 = $name;
        var$7 = var$5.$ifOkChain(var$6);
        a: {
            try {
                b: {
                    var$4 = 0;
                    $name = null;
                    if ($expression instanceof oncie_UnsignedDecimalIntegerLiteral)
                        $name = $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
                    else {
                        if ($expression instanceof oncie_SignedDecimalIntegerLiteral) {
                            var$4 = 1;
                            $name = $expression;
                            s_Predef$_$callClinit();
                            if (Long_gt(s_Predef$_Long2long(s_Predef$_MODULE$, $java.oncie_DecimalIntegerLiteral_value($name)), Long_ZERO)) {
                                $name = $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
                                break b;
                            }
                        }
                        if (var$4 && sr_BoxesRunTime_equalsNumObject($java.oncie_DecimalIntegerLiteral_value($name), sr_BoxesRunTime_boxToInteger(0)) && $acceptsZero)
                            $name = $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
                        else if (!$rt_isInstance($expression, oncie_Literal))
                            $name = $java.oncias_SemanticCheck$_success(oncias_SemanticCheck$_MODULE$);
                        else {
                            $name = $expression;
                            var$5 = !$acceptsZero ? $rt_s(3273) : $rt_s(3274);
                            var$6 = $name.$asCanonicalStringVal();
                            var$8 = jl_StringBuilder__init_1();
                            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$8, $rt_s(3275)), var$6), $rt_s(3276)), var$5), $rt_s(3277));
                            $name = $java.oncia_ASTSlicingPhrase$_error($this, jl_StringBuilder_toString(var$8), $name.$position2());
                        }
                    }
                }
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                if ($$je instanceof jl_NumberFormatException) {
                } else {
                    throw $$e;
                }
            }
            $name = oncias_SemanticCheck$_success;
        }
        var$5 = oncias_SemanticCheck_chain$(var$7, $name);
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticCheck_chain$(oncias_SemanticCheck_chain$(var$5, $java.oncias_SemanticExpressionCheck$_simple(oncias_SemanticExpressionCheck$_MODULE$, $expression)), oncias_SemanticAnalysisTooling_expectType$1($this, new $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_1, $expression));
    };
    $java.oncia_SubqueryCall$InTransactionsReportParameters$semanticCheck$lambda$_47_0 = $rt_classWithoutFields();
    $java.oncia_SubqueryCall$InTransactionsReportParameters$semanticCheck$lambda$_47_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return (oncius_package$_CTMap(oncius_package$_MODULE$)).$invariant();
    };
    $java.oncia_UsingScanHint$semanticCheck$lambda$_51_0 = $rt_classWithoutFields();
    $java.oncia_UsingScanHint$semanticCheck$lambda$_51_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)));
    };
    $java.oncia_RemoveLabelItem$semanticCheck$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncia_RemoveLabelItem$semanticCheck$lambda$_11_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$));
    };
    $java.oncia_SetPropertyItem$semanticCheck$lambda$_50_0 = $rt_classWithoutFields();
    $java.oncia_SetPropertyItem$semanticCheck$lambda$_50_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)));
    };
    $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_0 = $rt_classWithoutFields();
    $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)));
    };
    $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_1 = $rt_classWithoutFields();
    $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_1_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$));
    };
    $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_0 = $rt_classWithoutFields();
    $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)));
    };
    $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_1 = $rt_classWithoutFields();
    $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_1_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_MapType_covariant(oncius_package$_CTMap(oncius_package$_MODULE$));
    };
    $java.oncia_SetLabelItem$semanticCheck$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncia_SetLabelItem$semanticCheck$lambda$_11_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$));
    };
    $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_0 = function() {
        jl_Object.call(this);
        this.$_0445 = null;
    };
    $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0445;
        return oncias_SemanticCheck_chain$($java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_ensureDefined$(var$2, var$1)), oncias_SemanticAnalysisTooling_expectType$1(var$2, new $java.oncia_UsingJoinHint$$anonfun$semanticCheck$3$lambda$_64_0, var$1));
    };
    $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_1 = $rt_classWithoutFields();
    $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_1_apply = function(var$0, var$1, var$2) {
        return var$1.$chain(var$2);
    };
    $java.oncia_UsingIndexHint$semanticCheck$lambda$_58_0 = $rt_classWithoutFields();
    $java.oncia_UsingIndexHint$semanticCheck$lambda$_58_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_TypeSpec_union($java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$)), $java.oncius_RelationshipType_covariant(oncius_package$_CTRelationship(oncius_package$_MODULE$)));
    };
    $java.oncius_TypeSpec$containsAny$lambda$_11_0 = function() {
        jl_Object.call(this);
        this.$_0521 = null;
    };
    $java.oncius_TypeSpec$containsAny$lambda$_11_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0521.$ranges;
        var$3 = new $java.oncius_TypeSpec$$anonfun$containsAny$1$lambda$_51_0;
        var$3.$_0808 = var$1;
        return jl_Boolean_valueOf(var$2.$exists(var$3));
    };
    $java.oncius_TypeSpec$wrapInList$lambda$_23_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$wrapInList$lambda$_23_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeRange_reparent(var$1, new $java.oncius_TypeSpec$$anonfun$wrapInList$1$lambda$_59_0);
    };
    $java.oncius_TypeSpec$leastUpperBounds$lambda$_22_0 = function() {
        jl_Object.call(this);
        this.$_0525 = null;
    };
    $java.oncius_TypeSpec$leastUpperBounds$lambda$_22_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0525.$ranges;
        var$3 = new $java.oncius_TypeSpec$$anonfun$leastUpperBounds$1$lambda$_57_0;
        var$3.$_0809 = var$1;
        return var$2.$flatMap(var$3);
    };
    $java.oncius_TypeSpec$unwrapLists$lambda$_26_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$unwrapLists$lambda$_26_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeRange_reparent(var$1, new $java.oncius_TypeSpec$$anonfun$unwrapLists$1$lambda$_64_0);
    };
    $java.oncius_TypeSpec$without$lambda$_19_0 = function() {
        jl_Object.call(this);
        this.$_0523 = null;
    };
    $java.oncius_TypeSpec$without$lambda$_19_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0523;
        if ($java.oncius_ListType_isAssignableFrom(var$2, var$1.$lower1))
            var$3 = s_None$_MODULE$;
        else if (!var$1.$lower1.$isAssignableFrom0(var$2))
            var$3 = s_Some__init_(var$1);
        else {
            var$4 = var$1.$upper1;
            if (jl_Object_equals(s_None$_MODULE$, var$4))
                var$3 = s_Some__init_($java.oncius_TypeRange$_apply($java.oncius_TypeRange$_MODULE$, var$1.$lower1, var$2.$parentType16));
            else {
                if (!(var$4 instanceof s_Some))
                    $rt_throw(s_MatchError__init_(var$4));
                var$3 = !$java.oncius_ListType_isAssignableFrom(var$2, var$4.$value5) ? s_Some__init_(var$1) : s_Some__init_($java.oncius_TypeRange$_apply($java.oncius_TypeRange$_MODULE$, var$1.$lower1, var$2.$parentType16));
            }
        }
        return var$3;
    };
    $java.oncius_TypeSpec$$union$lambda$_7_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$union$lambda$_7_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncius_TypeSpec$_$callClinit();
        return var$1.$ranges;
    };
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_0 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncias_SemanticFunctionCheck$_withKey($java.oncias_SemanticFunctionCheck$_MODULE$, $rt_s(2356), var$1));
    };
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_1 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncias_SemanticFunctionCheck$_withKey($java.oncias_SemanticFunctionCheck$_MODULE$, $rt_s(2355), var$1));
    };
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_2 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncias_SemanticFunctionCheck$_withKey($java.oncias_SemanticFunctionCheck$_MODULE$, $rt_s(3278), var$1));
    };
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_3 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_3_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncias_SemanticFunctionCheck$_withKey($java.oncias_SemanticFunctionCheck$_MODULE$, $rt_s(3279), var$1));
    };
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_4 = $rt_classWithoutFields();
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_4_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$1.$_10.$name11;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_AbstractStringBuilder_append(var$1, 39);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$1, var$2), 39);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.oncia_GraphReference$$fqn$1$lambda$_43_0 = function() {
        jl_Object.call(this);
        this.$_0802 = null;
    };
    $java.oncia_GraphReference$$fqn$1$lambda$_43_0_apply = function(var$0, var$1) {
        return var$1.$appended(var$0.$_0802.$propertyKey0.$name11);
    };
    $java.oncia_connectedComponents$$anonfun$1 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$part$1 = null;
        a.$connectedComponents$1 = null;
    };
    $java.oncia_connectedComponents$$anonfun$1_applyOrElse = function($this, $x, $default) {
        var var$3, var$4, var$5, var$6, var$7;
        a: {
            $x = $x;
            if ($x !== null) {
                var$3 = $x.$_10;
                var$4 = s_Tuple2__2$mcI$sp($x);
                $java.oncia_connectedComponents$_$callClinit();
                var$5 = $java.oncia_connectedComponents$_RichConnectedComponent($java.oncia_connectedComponents$_MODULE$, var$3);
                var$6 = $this.$part$1;
                var$5 = var$5.$connectedComponent;
                var$7 = new $java.oncia_connectedComponents$RichConnectedComponent$connectedTo$lambda$_0_0;
                var$7.$_0810 = var$6;
                if (var$5.$exists(var$7)) {
                    $x = $this.$connectedComponents$1.$updated7(var$4, var$3.$incl($this.$part$1));
                    break a;
                }
            }
            $x = $default.$apply($x);
        }
        return $x;
    };
    $java.oncia_connectedComponents$$loop$1$lambda$_8_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0706 = null;
        a.$_1216 = null;
    };
    $java.oncia_connectedComponents$$loop$1$lambda$_8_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0706;
        var$2 = var$0.$_1216;
        $java.oncia_connectedComponents$_$callClinit();
        var$3 = $java.oncia_connectedComponents$_ConnectedComponent;
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(sci_Set, 1);
        var$5.data[0] = var$2;
        return var$1.$appended(var$3.$from0(sr_ScalaRunTime$_wrapRefArray(var$4, var$5)));
    };
    $java.oncia_SingleQuery$clausesExceptLeadingFrom$lambda$_60_0 = function() {
        jl_Object.call(this);
        this.$_0321 = null;
    };
    $java.oncia_SingleQuery$clausesExceptLeadingFrom$lambda$_60_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Option_contains(var$0.$_0321, var$1));
    };
    $java.oncias_SemanticExpressionCheck$$org$neo4j$cypher$internal$ast$semantics$SemanticExpressionCheck$$isShadowed$1$lambda$_211_0 = function() {
        jl_Object.call(this);
        this.$_0778 = 0;
    };
    $java.oncias_SemanticExpressionCheck$$org$neo4j$cypher$internal$ast$semantics$SemanticExpressionCheck$$isShadowed$1$lambda$_211_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0778;
        oncias_SemanticExpressionCheck$_$callClinit();
        return jl_Boolean_valueOf(s_Tuple2__1$mcI$sp($java.oncias_SymbolUse_positionsAndUniqueIdString(var$1)) <= var$2 ? 0 : 1);
    };
    var jlr_Modifier = $rt_classWithoutFields();
    $java.jlr_Modifier_modifierNames = null;
    $java.jlr_Modifier_canonicalOrder = null;
    $java.jlr_Modifier_toString = function($mod) {
        var $sb, $modifierNames, $index, var$5, var$6, var$7;
        $sb = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_($sb);
        if ($java.jlr_Modifier_modifierNames === null)
            $java.jlr_Modifier_modifierNames = $rt_createArrayFromData(jl_String, [$rt_s(3280), $rt_s(3281), $rt_s(3282), $rt_s(3283), $rt_s(3284), $rt_s(3285), $rt_s(3286), $rt_s(3287), $rt_s(3288), $rt_s(3289), $rt_s(3290), $rt_s(3291)]);
        $modifierNames = $java.jlr_Modifier_modifierNames;
        $index = 0;
        var$5 = $java.jlr_Modifier_canonicalOrder.data;
        var$6 = var$5.length;
        var$7 = 0;
        while (var$7 < var$6) {
            if ($mod & var$5[var$7]) {
                if ($sb.$length0 > 0)
                    jl_AbstractStringBuilder_append($sb, 32);
                jl_AbstractStringBuilder_append1($sb, $modifierNames.data[$index]);
            }
            $index = $index + 1 | 0;
            var$7 = var$7 + 1 | 0;
        }
        return jl_AbstractStringBuilder_toString($sb);
    };
    function jlr_Modifier__clinit_() {
        $java.jlr_Modifier_canonicalOrder = $rt_createIntArrayFromData([1, 4, 2, 1024, 8, 16, 128, 64, 32, 256, 2048, 512]);
    }
    function jl_Class$MethodSignature() {
        var a = this; jl_Object.call(a);
        a.$name2 = null;
        a.$parameterTypes0 = null;
        a.$returnType0 = null;
    }
    $java.jl_Class$MethodSignature_equals = function($this, $o) {
        var $that, var$3, var$4, var$5, var$6;
        if ($this === $o)
            return 1;
        if (!($o instanceof jl_Class$MethodSignature))
            return 0;
        a: {
            $that = $o;
            if (ju_Objects_equals($this.$name2, $that.$name2)) {
                b: {
                    var$3 = $this.$parameterTypes0;
                    var$4 = $that.$parameterTypes0;
                    if (var$3 === var$4)
                        var$5 = 1;
                    else {
                        if (var$3 !== null && var$4 !== null) {
                            var$3 = var$3.data;
                            var$4 = var$4.data;
                            var$5 = var$3.length;
                            if (var$5 == var$4.length) {
                                var$6 = 0;
                                while (var$6 < var$5) {
                                    if (!ju_Objects_equals(var$3[var$6], var$4[var$6])) {
                                        var$5 = 0;
                                        break b;
                                    }
                                    var$6 = var$6 + 1 | 0;
                                }
                                var$5 = 1;
                                break b;
                            }
                        }
                        var$5 = 0;
                    }
                }
                if (var$5 && ju_Objects_equals($this.$returnType0, $that.$returnType0)) {
                    var$5 = 1;
                    break a;
                }
            }
            var$5 = 0;
        }
        return var$5;
    };
    $java.jl_Class$MethodSignature_hashCode = function($this) {
        return ju_Arrays_hashCode($rt_createArrayFromData(jl_Object, [$this.$name2, jl_Integer_valueOf(ju_Arrays_hashCode($this.$parameterTypes0)), $this.$returnType0]));
    };
    $java.oncias_SemanticCheck$$$anonfun$fromFunctionWithContext$1$lambda$_21_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0701 = null;
        a.$_1214 = null;
    };
    $java.oncias_SemanticCheck$$$anonfun$fromFunctionWithContext$1$lambda$_21_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0701.$apply0(var$1, var$0.$_1214);
    };
    $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$14$lambda$_80_0 = function() {
        jl_Object.call(this);
        this.$_0777 = null;
    };
    $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$14$lambda$_80_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$0.$_0777;
        return $java.oncius_TypeSpec_unwrapLists($java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(var$2, var$2.$expression8), var$1));
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$4$lambda$_76_0 = function() {
        jl_Object.call(this);
        this.$_0752 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$check$4$lambda$_76_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0752;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = (var$1.$patternParts()).$flatMap(new $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_0);
        var$3 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$4 = new $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_1;
        var$4.$_0811 = var$1;
        return oncias_SemanticCheck_chain$(($java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$3, var$2, var$4)).$chain($java.oncias_SemanticPatternCheck$_ensureNoRepeatedRelationships(oncias_SemanticPatternCheck$_MODULE$, var$1)), $java.oncias_SemanticPatternCheck$_ensureNoRepeatedVarLengthRelationships(oncias_SemanticPatternCheck$_MODULE$, var$1));
    };
    $java.oncia_SingleQuery$$anonfun$leadingGraphSelection$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_SingleQuery$$anonfun$leadingGraphSelection$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return $rt_isInstance($x, $java.oncia_GraphSelection) ? $x : s_PartialFunction$_fallback_fn;
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$1$lambda$_90_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0750 = null;
        a.$_1238 = null;
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$1$lambda$_90_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$0.$_0750;
        var$2 = var$0.$_1238;
        var$3 = var$1.$innerQuery.$semanticCheckInSubqueryContext(var$2.$state);
        var$4 = new $java.oncia_SubqueryCall$$anonfun$checkSubquery$2$lambda$_89_0;
        var$4.$_0812 = var$1;
        var$4.$_1267 = var$2;
        return oncias_SemanticCheck_flatMap$(var$3, var$4);
    };
    $java.onciu_NonEmptyList$toIndexedSeq$lambda$_72_0 = $rt_classWithoutFields();
    $java.onciu_NonEmptyList$toIndexedSeq$lambda$_72_0_apply = function(var$0, var$1, var$2) {
        return var$1.$appended(var$2);
    };
    $java.oncias_Scope$$anonfun$allSymbols$1$lambda$_40_0 = $rt_classWithoutFields();
    $java.oncias_Scope$$anonfun$allSymbols$1$lambda$_40_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4, var$5, var$6;
        a: {
            var$3 = s_Tuple2__init_(var$1, var$2);
            var$1 = var$3.$_10;
            var$2 = var$3.$_20;
            if (var$2 !== null) {
                var$4 = var$2.$_10;
                var$2 = var$2.$_20;
                if (var$1.$contains0(var$4)) {
                    var$1 = var$1.$updated1(var$4, (var$1.$apply(var$4)).$incl(var$2));
                    break a;
                }
            }
            var$1 = var$3.$_10;
            var$2 = var$3.$_20;
            if (var$2 === null)
                $rt_throw(s_MatchError__init_(var$3));
            var$3 = var$2.$_10;
            var$2 = var$2.$_20;
            s_Predef$_$callClinit();
            var$4 = s_Predef$_Set(s_Predef$_MODULE$);
            var$5 = sr_ScalaRunTime$_MODULE$;
            var$6 = $rt_createArray(oncias_Symbol, 1);
            var$6.data[0] = var$2;
            var$1 = var$1.$updated1(var$3, var$4.$from0(sr_ScalaRunTime$_wrapRefArray(var$5, var$6)));
        }
        return var$1;
    };
    $java.oncia_SortItem$semanticCheck$lambda$_2_0 = $rt_classWithoutFields();
    $java.oncia_SortItem$semanticCheck$lambda$_2_0_apply = function(var$0, var$1) {
        return var$1.$propertyKey0;
    };
    $java.sc_IterableOps$$anonfun$groupMap$1$lambda$_126_0 = function() {
        jl_Object.call(this);
        this.$_0796 = null;
    };
    $java.sc_IterableOps$$anonfun$groupMap$1$lambda$_126_0_apply = function(var$0) {
        return sci_List$_newBuilder(sci_List_iterableFactory(var$0.$_0796));
    };
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_23_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0459 = null;
        a.$_1140 = null;
        a.$_255 = null;
        a.$_312 = null;
    };
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_23_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return oncias_SemanticAnalysisTooling_expectType$2(var$0.$_0459, var$1, var$0.$_1140, var$0.$_255, var$0.$_312);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0797 = null;
        a.$_1258 = null;
        a.$_273 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$0.$_0797;
        var$2 = var$0.$_1258;
        var$3 = var$0.$_273;
        var$2 = oncia_ProjectionClause_runChecks$1(var$1, var$2);
        var$4 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$2$lambda$_42_0;
        var$4.$_0813 = var$1;
        var$4.$_1268 = var$3;
        return oncias_SemanticCheck_flatMap$(var$2, var$4);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0800 = null;
        a.$_1261 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0800;
        var$3 = oncias_Scope_symbolNames(var$0.$_1261);
        var$3 = (oncias_Scope_symbolNames(var$1.$state.$currentScope.$elem)).$intersect(var$3);
        var$4 = sc_AbstractIterable_toMap(($java.oncia_ReturnItems_returnVariables(var$2.$returnItems0())).$explicitVariables.$map1(new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_0), s_$less$colon$less$_singleton);
        var$5 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_1;
        var$5.$_0814 = var$2;
        var$5.$_1269 = var$4;
        var$2 = var$3.$map1(var$5);
        return oncias_SemanticCheckResult__init_(var$1.$state, var$1.$errors.$concat0(var$2));
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0798 = null;
        a.$_1259 = null;
        a.$_274 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$0.$_0798;
        var$2 = var$0.$_1259;
        var$3 = var$0.$_274;
        var$2 = oncia_ProjectionClause_runChecks$1(var$1, var$2);
        var$4 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$11$lambda$_50_0;
        var$4.$_0815 = var$1;
        var$4.$_1270 = var$3;
        return oncias_SemanticCheck_map$(var$2, var$4);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_3 = function() {
        var a = this; jl_Object.call(a);
        a.$_0799 = null;
        a.$_1260 = null;
        a.$_275 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_3_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0799;
        var$2 = var$0.$_1260;
        var$3 = var$0.$_275;
        var$4 = oncia_ProjectionClause_runChecks$1(var$1, var$2);
        var$5 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$6$lambda$_47_0;
        var$5.$_0816 = var$1;
        var$5.$_1271 = var$2;
        var$5.$_276 = var$3;
        return oncias_SemanticCheck_flatMap$(var$4, var$5);
    };
    $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0637 = null;
        a.$_1196 = null;
    };
    $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0637;
        var$3 = var$0.$_1196.$iterator0();
        var$4 = new $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_0;
        var$4.$_0817 = var$2;
        var$4.$_1272 = var$1;
        return (var$3.$map7(var$4)).$reduceLeft(new $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_1);
    };
    $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_1 = $rt_classWithoutFields();
    $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_1_apply = function(var$0, var$1) {
        oncius_package$_$callClinit();
        return $java.oncius_AnyType_invariant(oncius_package$_CTAny(oncius_package$_MODULE$));
    };
    $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_0 = $rt_classWithoutFields();
    $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Option_isEmpty(var$1.$alias()));
    };
    $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_1 = function() {
        jl_Object.call(this);
        this.$_0749 = null;
    };
    $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0749;
        var$3 = new oncias_SemanticError;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3292)), var$2), $rt_s(3293));
        oncias_SemanticError__init_(var$3, jl_AbstractStringBuilder_toString(var$4), var$1.$position2());
        return var$3;
    };
    $java.oncius_TypeRange$checkForAny$lambda$_10_0 = function() {
        jl_Object.call(this);
        this.$_0518 = null;
    };
    $java.oncius_TypeRange$checkForAny$lambda$_10_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$2 = var$0.$_0518;
        if (var$1 instanceof oncius_AnyType)
            var$3 = 1;
        else if (!(var$1 instanceof oncius_ListType))
            var$3 = 0;
        else {
            var$1 = var$1;
            var$3 = sr_BoxesRunTime_unboxToBoolean($java.oncius_TypeRange$checkForAny$lambda$_10_0_apply($java.oncius_TypeRange_checkForAny(var$2), var$1.$innerType0));
        }
        return jl_Boolean_valueOf(var$3);
    };
    $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1_applyOrElse = function($this, $x1, $default) {
        var $id;
        if ($x1 instanceof oncie_NodePattern) {
            $x1 = $x1.$variable11;
            if ($x1 instanceof s_Some) {
                $id = $x1.$value5;
                $x1 = new $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1$applyOrElse$lambda$_0_0;
                $x1.$_0818 = $id;
                return $x1;
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1_applyOrElse = function($this, $x1, $default) {
        if ($x1 instanceof oncie_QuantifiedPath && $x1.$quantifier.$canBeEmpty())
            return new $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_0;
        if (!$rt_isInstance($x1, $java.oncie_PathFactor))
            return s_PartialFunction$_fallback_fn;
        return new $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_1;
    };
    $java.oncias_SemanticPatternCheck$$checkMinimumNodeCount$lambda$_46_0 = function() {
        jl_Object.call(this);
        this.$_0751 = null;
    };
    $java.oncias_SemanticPatternCheck$$checkMinimumNodeCount$lambda$_46_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0751;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = new oncie_FixedQuantifier;
        var$3 = new oncie_UnsignedDecimalIntegerLiteral;
        onciu_InputPosition$_$callClinit();
        oncie_UnsignedDecimalIntegerLiteral__init_0(var$3, $rt_s(14), onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        $java.oncie_FixedQuantifier__init_(var$2, var$3, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        var$3 = var$1.$element();
        var$4 = onciu_topDown$_MODULE$;
        onciu_Rewriter$_$callClinit();
        var$5 = onciu_Rewriter$_MODULE$;
        var$6 = new $java.oncias_SemanticPatternCheck$$anonfun$1;
        var$6.$fixedZeroQuantifier$1 = var$2;
        var$2 = (onciu_topDown$_apply(var$4, onciu_Rewriter$_lift(var$5, var$6), onciu_topDown$_apply$default$2(onciu_topDown$_MODULE$), 1, onciu_CancellationChecker$NeverCancelled$_MODULE$)).$apply(var$3);
        var$2 = onciap_DefaultPatternStringifier_apply2(($java.oncias_SemanticPatternCheck$_stringifier0(oncias_SemanticPatternCheck$_MODULE$)).$patterns, var$2);
        var$3 = oncias_SemanticPatternCheck$_MODULE$;
        var$4 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        var$5 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$5);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(3294)), var$2), $rt_s(3295));
        return oncias_SemanticAnalysisTooling_error$(var$3, sc_StringOps$_stripMargin$extension(var$4, jl_AbstractStringBuilder_toString(var$5)), var$1.$position2());
    };
    $java.oncia_UseGraph$unsupported$lambda$_58_0 = function() {
        jl_Object.call(this);
        this.$_0794 = null;
    };
    $java.oncia_UseGraph$unsupported$lambda$_58_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = var$0.$_0794;
        return $java.oncias_SemanticCheckResult$_error0(oncias_SemanticCheckResult$_MODULE$, var$1, (var$2.$errorMessageProvider0()).$createUseClauseUnsupportedError(), var$3.$position64);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_0 = function() {
        jl_Object.call(this);
        this.$_0791 = null;
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$1 = onciap_DefaultExpressionStringifier_apply0(var$0.$_0791.$$outer3.$expr2, var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(var$2, var$1), $rt_s(367));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_1 = $rt_classWithoutFields();
    $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_1_apply = function(var$0) {
        return $rt_s(3);
    };
    $java.oncia_UseGraph$checkExpressions$lambda$_61_0 = $rt_classWithoutFields();
    $java.oncia_UseGraph$checkExpressions$lambda$_61_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return oncias_SemanticExpressionCheck$_check(oncias_SemanticExpressionCheck$_MODULE$, oncie_Expression$SemanticContext$Results$_MODULE$, var$1);
    };
    $java.oncia_Match$$anonfun$6 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_Match$$anonfun$6_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return (!$x.$part.$isBounded() && !$x.$selector.$isBounded() ? 0 : 1) ? $default.$apply($x) : oncias_SemanticError__init_0($rt_s(3296), oncie_PatternPartWithSelector_position($x));
    };
    $java.oncia_Match$checkDifferentRelationships$lambda$_70_0 = $rt_classWithoutFields();
    $java.oncia_Match$checkDifferentRelationships$lambda$_70_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf($java.oncie_PatternPartWithSelector_isSelective(var$1));
    };
    $java.oncia_Match$checkDifferentRelationships$lambda$_70_1 = function() {
        jl_Object.call(this);
        this.$_0795 = null;
    };
    $java.oncia_Match$checkDifferentRelationships$lambda$_70_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0795;
        return oncias_SemanticError__init_0(!var$2.$features1.$contains0(oncias_SemanticFeature$MatchModes$_MODULE$) ? $rt_s(3297) : $rt_s(3298), oncie_PatternPartWithSelector_position(var$1));
    };
    $java.oncia_UseGraph$checkStaticGraphReference$lambda$_64_0 = function() {
        jl_Object.call(this);
        this.$_0793 = null;
    };
    $java.oncia_UseGraph$checkStaticGraphReference$lambda$_64_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0793;
        if (var$1 instanceof $java.oncia_GraphRef)
            var$1 = oncias_SemanticCheck$_success;
        else {
            var$1 = oncias_SemanticCheck$_MODULE$;
            var$3 = new $java.oncia_UseGraph$dynamicGraphReferenceError$1$lambda$_90_0;
            var$3.$_0819 = var$2;
            var$1 = $java.oncias_SemanticCheck$_fromFunctionWithContext(var$1, var$3);
        }
        return var$1;
    };
    var oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1$lambda$_8_0 = $rt_classWithoutFields();
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1$lambda$_8_0_apply = function(var$0, var$1) {
        return var$1.$use;
    };
    $java.onciu_RewritableCompat$PROXY$7_262 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_262_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    var onciu_RewritableCompat$PROXY$5_262 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$5_262_paramsLength(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    }
    $java.onciu_RewritableCompat$PROXY$7_263 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_263_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(0)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_263 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_263_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_264 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_264_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_264 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_264_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    var onciu_RewritableCompat$PROXY$3_974 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_974_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_GraphRefParameter__init_(var$3[0], var$3[1]);
    }
    var onciu_RewritableCompat$PROXY$3_975 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_975_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_ViewRef__init_(var$3[0], var$3[1], var$3[2]);
    }
    var onciu_RewritableCompat$PROXY$3_977 = $rt_classWithoutFields();
    function onciu_RewritableCompat$PROXY$3_977_copyConstructor(var$1, var$2, var$3) {
        var$3 = var$3.data;
        return $java.oncia_GraphRef__init_(var$3[0], var$3[1]);
    }
    var jli_SerializedLambda = $rt_classWithoutFields();
    $java.oti_Structure = $rt_classWithoutFields();
    var otr_RuntimeObject = $rt_classWithoutFields($java.oti_Structure);
    $java.oncia_ViewRef$semanticCheck$lambda$_50_0 = $rt_classWithoutFields();
    $java.oncia_ViewRef$semanticCheck$lambda$_50_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$2 = var$1.$_10;
        var$1 = var$1.$_20;
        return $java.oncia_GraphReference$_checkNotEmpty($java.oncia_GraphReference$_MODULE$, var$1, var$2.$position2());
    };
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0789 = null;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0789;
        var$3 = var$2.$name4;
        return var$1.$updated1(var$3, sci_List_$colon$colon(var$1.$apply(var$3), var$2));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_1 = function() {
        jl_Object.call(this);
        this.$_0790 = null;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0790;
        var$3 = var$2.$name4;
        return var$1.$updated1(var$3, sci_List_$colon$colon(var$1.$apply(var$3), var$2));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_2 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        s_Predef$_$callClinit();
        return var$1;
    };
    $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0807 = null;
        a.$_1266 = null;
    };
    $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0807;
        var$2 = var$0.$_1266;
        var$3 = $java.oncia_ASTSlicingPhrase$_MODULE$;
        var$1 = var$1.$dependencies0();
        if (!sc_IterableOnceOps_nonEmpty$(var$1))
            var$1 = oncias_SemanticCheck$_success;
        else {
            var$4 = sc_IterableOnceOps_toSeq$(var$1);
            var$5 = new $java.oncia_ASTSlicingPhrase$$containsNoVariables$lambda$_41_0;
            onciu_InputPosition$_$callClinit();
            var$1 = sc_AbstractIterable_minBy(var$4, var$5, onciu_InputPosition$_byOffset0(onciu_InputPosition$_MODULE$));
            var$5 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$5);
            jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$5, $rt_s(3299)), var$2), $rt_s(3300)), var$2), $rt_s(3301));
            var$1 = oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$5), var$1.$position0);
        }
        return var$1;
    };
    $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_1 = $rt_classWithoutFields();
    $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_1_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_IntegerType_covariant(oncius_package$_CTInteger(oncius_package$_MODULE$));
    };
    $java.oncius_TypeSpec$toStrings$lambda$_39_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$toStrings$lambda$_39_0_apply = function(var$0, var$1) {
        s_Predef$_$callClinit();
        return var$1;
    };
    $java.oncius_TypeRange$intersect$lambda$_12_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0519 = null;
        a.$_1171 = null;
    };
    $java.oncius_TypeRange$intersect$lambda$_12_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0519;
        var$3 = var$0.$_1171;
        var$4 = var$2.$upper1;
        var$2 = new $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_0;
        var$2.$_0820 = var$3;
        var$5 = new $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_1;
        var$5.$_0821 = var$3;
        var$3 = s_Option_fold(var$4, var$2, var$5);
        return s_Option_isDefined(var$3) && !var$1.$isAssignableFrom0(var$3.$get0()) ? s_None$_MODULE$ : s_Some__init_($java.oncius_TypeRange__init_0(var$1, var$3));
    };
    $java.ju_HashMap$2 = function() {
        ju_AbstractCollection.call(this);
        this.$this$04 = null;
    };
    $java.ju_HashMap$2_size = function($this) {
        return $this.$this$04.$elementCount1;
    };
    $java.ju_HashMap$2_iterator = function($this) {
        var var$1, var$2;
        var$1 = new $java.ju_HashMap$ValueIterator;
        var$2 = $this.$this$04;
        var$1.$associatedMap1 = var$2;
        var$1.$expectedModCount0 = var$2.$modCount2;
        var$1.$futureEntry0 = null;
        return var$1;
    };
    var oncia_Clause$org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition$lambda$_13_0 = $rt_classWithoutFields();
    $java.oncia_Clause$org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition$lambda$_13_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1 instanceof oncil_LabelExpression$Leaf);
    };
    $java.oncias_SemanticCheck$$setState$lambda$_7_0 = function() {
        jl_Object.call(this);
        this.$_0365 = null;
    };
    $java.oncias_SemanticCheck$$setState$lambda$_7_0_apply = function(var$0, var$1) {
        var$1 = var$0.$_0365;
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
    };
    $java.oncius_TypeSpec$covariant$lambda$_25_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$covariant$lambda$_25_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeRange_covariant(var$1);
    };
    $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0818 = null;
    };
    $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return var$1.$incl(var$0.$_0818);
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = sr_BoxesRunTime_unboxToBoolean(var$1);
        return $java.onciu_Foldable$SkipChildren__init_(jl_Boolean_valueOf(var$2));
    };
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_1 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        sr_BoxesRunTime_unboxToBoolean(var$1);
        return $java.onciu_Foldable$SkipChildren__init_(jl_Boolean_valueOf(0));
    };
    $java.oncius_TypeRange$contains$lambda$_6_0 = $rt_classWithoutFields();
    $java.oncius_TypeRange$contains$lambda$_6_0_apply$mcZ$sp = function(var$0) {
        return 1;
    };
    $java.oncius_TypeRange$contains$lambda$_6_1 = function() {
        jl_Object.call(this);
        this.$_0792 = null;
    };
    $java.oncius_TypeRange$contains$lambda$_6_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$0.$_0792.$isAssignableFrom0(var$1));
    };
    $java.sci_Map$WithDefault$newSpecificBuilder$lambda$_13_0 = function() {
        jl_Object.call(this);
        this.$_0309 = null;
    };
    $java.sci_Map$WithDefault$newSpecificBuilder$lambda$_13_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0309;
        return $java.sci_Map$WithDefault__init_(var$1, var$2.$defaultValue);
    };
    $java.oncia_ASTSlicingPhrase$$anonfun$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_ASTSlicingPhrase$$anonfun$1_applyOrElse = function($this, $x1, $default) {
        if (!($rt_isInstance($x1, $java.oncie_SubqueryExpression) ? 1 : !($x1 instanceof oncie_PathExpression) ? 0 : 1))
            return s_PartialFunction$_fallback_fn;
        return jl_Boolean_valueOf(1);
    };
    $java.oncia_ASTSlicingPhrase$$doesNotTouchTheGraph$lambda$_42_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0806 = null;
        a.$_1265 = null;
    };
    $java.oncia_ASTSlicingPhrase$$doesNotTouchTheGraph$lambda$_42_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0806;
        var$2 = var$0.$_1265;
        var$3 = $java.oncia_ASTSlicingPhrase$_MODULE$;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(3302)), var$1), $rt_s(3300)), var$1), $rt_s(3301));
        return oncias_SemanticAnalysisTooling_error$(var$3, jl_AbstractStringBuilder_toString(var$4), var$2.$position2());
    };
    $java.oncius_TypeSpec$toStrings$lambda$_40_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$toStrings$lambda$_40_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        a: {
            var$1 = var$1;
            if (var$1 !== null) {
                var$2 = var$1.$upper1;
                if (var$1.$lower1 instanceof oncius_AnyType && jl_Object_equals(s_None$_MODULE$, var$2)) {
                    var$3 = 1;
                    break a;
                }
            }
            var$3 = 0;
        }
        return jl_Boolean_valueOf(var$3);
    };
    $java.oncius_TypeSpec$toStrings$lambda$_40_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0530 = null;
        a.$_1174 = null;
    };
    $java.oncius_TypeSpec$toStrings$lambda$_40_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncius_TypeSpec_contains0(var$0.$_0530, var$1, var$0.$_1174));
    };
    $java.oncius_TypeSpec$toStrings$lambda$_40_2 = function() {
        jl_Object.call(this);
        this.$_0531 = null;
    };
    $java.oncius_TypeSpec$toStrings$lambda$_40_2_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0531.$apply(var$1.$toString());
    };
    $java.oncius_TypeSpec$toStrings$lambda$_40_3 = function() {
        jl_Object.call(this);
        this.$_0532 = null;
    };
    $java.oncius_TypeSpec$toStrings$lambda$_40_3_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$0.$_0532.$apply(var$1);
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(1768)), var$1), 62);
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_0 = function() {
        jl_Object.call(this);
        this.$_0771 = null;
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0771.$name4;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(3241)), var$1), $rt_s(3303));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_1 = function() {
        jl_Object.call(this);
        this.$_0772 = null;
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_1_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0772.$name4;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(3241)), var$1), $rt_s(3304));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_2 = function() {
        jl_Object.call(this);
        this.$_0773 = null;
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_2_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0773.$name4;
        var$2 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$2);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$2, $rt_s(3241)), var$1), $rt_s(3305));
        return jl_AbstractStringBuilder_toString(var$2);
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_3 = function() {
        jl_Object.call(this);
        this.$_0774 = null;
    };
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_3_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0774;
        return oncias_SemanticError__init_0(var$1, var$2.$position0);
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0817 = null;
        a.$_1272 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0817;
        var$3 = var$0.$_1272;
        return $java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply(oncias_SemanticAnalysisTooling_types$(var$2, var$1), var$3);
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_1 = $rt_classWithoutFields();
    $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_1_apply = function(var$0, var$1, var$2) {
        return $java.oncius_TypeSpec_leastUpperBounds(var$1, var$2);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$findRepeatedRelationships$2$lambda$_144_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$$anonfun$findRepeatedRelationships$2$lambda$_144_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return var$1.$position0;
    };
    var sc_View$ = $rt_classWithoutFields();
    var sc_View$_MODULE$ = null;
    function sc_View$__clinit_() {
        sc_View$_MODULE$ = new sc_View$;
    }
    $java.sc_View$_from = function($this, $it) {
        var $view_this, $fromIteratorProvider_it;
        if ($rt_isInstance($it, sc_View))
            return $it;
        if (!$rt_isInstance($it, sc_Iterable)) {
            sci_LazyList$_$callClinit();
            $view_this = sci_LazyList$_from(sci_LazyList$_MODULE$, $it);
            if ($view_this === null)
                $rt_throw(null);
            return sc_SeqView$Id__init_($view_this);
        }
        $it = $it;
        $fromIteratorProvider_it = new $java.sc_View$$from$lambda$_18_0;
        $fromIteratorProvider_it.$_0822 = $it;
        $it = new $java.sc_View$$anon$1;
        $it.$it$1 = $fromIteratorProvider_it;
        return $it;
    };
    $java.sc_View$_newBuilder = function($this) {
        return scm_Builder_mapResult$(scm_ArrayBuffer$$anon$1__init_(), new $java.sc_View$$newBuilder$lambda$_20_0);
    };
    $java.sc_View$_from0 = function($this, $source) {
        return $java.sc_View$_from($this, $source);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_0 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return jl_Boolean_valueOf(var$1.$unionSymbol);
    };
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_1 = $rt_classWithoutFields();
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticExpressionCheck$_$callClinit();
        return var$1.$definition;
    };
    function oncias_SemanticState$ScopeLocation$$$anonfun$symbol$extension$1$lambda$_22_0() {
        jl_Object.call(this);
        this.$_022 = null;
    }
    $java.oncias_SemanticState$ScopeLocation$$$anonfun$symbol$extension$1$lambda$_22_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_022;
        var$3 = oncias_SemanticState$ScopeLocation$_MODULE$;
        oncias_SemanticState$_$callClinit();
        return oncias_SemanticState$ScopeLocation$_symbol$extension(var$3, var$1, var$2);
    };
    $java.oncius_TypeSpec$innerTypeRanges$lambda$_48_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$innerTypeRanges$lambda$_48_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        a: {
            var$1 = var$1;
            if (var$1 !== null) {
                var$2 = var$1.$lower1;
                var$3 = var$1.$upper1;
                if (var$2 instanceof oncius_ListType) {
                    var$2 = var$2;
                    if (var$3 instanceof s_Some) {
                        var$3 = var$3.$value5;
                        if (var$3 instanceof oncius_ListType) {
                            var$4 = var$3;
                            var$3 = s_Some__init_($java.oncius_TypeRange$_apply($java.oncius_TypeRange$_MODULE$, var$2.$innerType0, var$4.$innerType0));
                            break a;
                        }
                    }
                }
            }
            if (var$1 !== null) {
                var$3 = var$1.$lower1;
                var$4 = var$1.$upper1;
                if (var$3 instanceof oncius_ListType) {
                    var$2 = var$3;
                    if (jl_Object_equals(s_None$_MODULE$, var$4)) {
                        var$3 = s_Some__init_($java.oncius_TypeRange__init_0(var$2.$innerType0, s_None$_MODULE$));
                        break a;
                    }
                }
            }
            if (var$1 !== null) {
                var$2 = var$1.$upper1;
                if (var$1.$lower1 instanceof oncius_AnyType && var$2 instanceof s_Some) {
                    var$3 = var$2.$value5;
                    if (var$3 instanceof oncius_ListType) {
                        var$1 = var$3;
                        var$3 = new s_Some;
                        var$2 = $java.oncius_TypeRange$_MODULE$;
                        oncius_package$_$callClinit();
                        s_Some__init_0(var$3, $java.oncius_TypeRange$_apply(var$2, oncius_package$_CTAny(oncius_package$_MODULE$), var$1.$innerType0));
                        break a;
                    }
                }
            }
            if (var$1 !== null) {
                var$2 = var$1.$upper1;
                if (var$1.$lower1 instanceof oncius_AnyType && jl_Object_equals(s_None$_MODULE$, var$2)) {
                    var$3 = s_Some__init_(var$1);
                    break a;
                }
            }
            var$3 = s_None$_MODULE$;
        }
        return var$3;
    };
    $java.oncia_UsingJoinHint$$anonfun$semanticCheck$3$lambda$_64_0 = $rt_classWithoutFields();
    $java.oncia_UsingJoinHint$$anonfun$semanticCheck$3$lambda$_64_0_apply = function(var$0) {
        oncius_package$_$callClinit();
        return $java.oncius_NodeType_covariant(oncius_package$_CTNode(oncius_package$_MODULE$));
    };
    function sc_View$Drop() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying0 = null;
        a.$n = 0;
        a.$normN = 0;
    }
    $java.sc_View$Drop_iterator = function($this) {
        return ($this.$underlying0.$iterator0()).$drop1($this.$n);
    };
    $java.sc_View$Drop_knownSize = function($this) {
        var $size;
        $size = $this.$underlying0.$knownSize();
        if ($size < 0)
            return (-1);
        return jl_Math_max($size - $this.$normN | 0, 0);
    };
    $java.sc_View$Drop_isEmpty = function($this) {
        return ($java.sc_View$Drop_iterator($this)).$isEmpty();
    };
    $java.oncius_TypeSpec$$anonfun$wrapInList$1$lambda$_59_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$anonfun$wrapInList$1$lambda$_59_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncius_package$_$callClinit();
        return oncius_package$_CTList(oncius_package$_MODULE$, var$1);
    };
    $java.oncius_TypeSpec$$anonfun$unwrapLists$1$lambda$_64_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$anonfun$unwrapLists$1$lambda$_64_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        if (var$1 instanceof oncius_ListType)
            var$1 = var$1.$innerType0;
        return var$1;
    };
    function sc_MapOps$$anon$3() {
        sc_AbstractIterator.call(this);
        this.$iter0 = null;
    }
    $java.sc_MapOps$$anon$3_hasNext = function($this) {
        return $this.$iter0.$hasNext();
    };
    $java.sc_MapOps$$anon$3_next = function($this) {
        return ($this.$iter0.$next()).$_20;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$1 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$fixedZeroQuantifier$1 = null;
    };
    $java.oncias_SemanticPatternCheck$$anonfun$1_applyOrElse = function($this, $x2, $default) {
        var $x$1, var$4, var$5, var$6;
        if (!($x2 instanceof oncie_QuantifiedPath))
            return $default.$apply($x2);
        $x2 = $x2;
        $x$1 = $this.$fixedZeroQuantifier$1;
        var$4 = $x2.$part1;
        var$5 = $x2.$optionalWhereExpression;
        var$6 = $x2.$variableGroupings;
        onciu_InputPosition$_$callClinit();
        return $java.oncie_QuantifiedPath_copy($x2, var$4, $x$1, var$5, var$6, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
    };
    $java.oncius_TypeSpec$$anonfun$leastUpperBounds$1$lambda$_57_0 = function() {
        jl_Object.call(this);
        this.$_0809 = null;
    };
    $java.oncius_TypeSpec$$anonfun$leastUpperBounds$1$lambda$_57_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncius_TypeRange_leastUpperBounds(var$0.$_0809, var$1);
    };
    function sc_MapOps$$anon$2() {
        sc_AbstractIterator.call(this);
        this.$iter = null;
    }
    $java.sc_MapOps$$anon$2_hasNext = function($this) {
        return $this.$iter.$hasNext();
    };
    $java.sc_MapOps$$anon$2_next = function($this) {
        return ($this.$iter.$next()).$_10;
    };
    $java.oncius_TypeSpec$$anonfun$containsAny$1$lambda$_51_0 = function() {
        jl_Object.call(this);
        this.$_0808 = null;
    };
    $java.oncius_TypeSpec$$anonfun$containsAny$1$lambda$_51_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(s_Option_isDefined($java.oncius_TypeRange_constrain(var$0.$_0808, var$1.$lower1)));
    };
    $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        var$2 = onciu_Foldable_folder$(var$1.$element());
        sr_ClassTag$_$callClinit();
        return onciu_Foldable$Folder_findAllByClass(var$2, sr_ClassTag$_apply(sr_ClassTag$_MODULE$, $rt_cls(oncie_QuantifiedPath)));
    };
    $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_1 = function() {
        jl_Object.call(this);
        this.$_0811 = null;
    };
    $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0811;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = oncias_package$_MODULE$;
        var$4 = new $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$2$lambda$_139_0;
        var$4.$_0823 = var$1;
        var$4.$_1273 = var$2;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$3, var$4);
    };
    $java.oncia_UseGraph$dynamicGraphReferenceError$1$lambda$_90_0 = function() {
        jl_Object.call(this);
        this.$_0819 = null;
    };
    $java.oncia_UseGraph$dynamicGraphReferenceError$1$lambda$_90_0_apply = function(var$0, var$1, var$2) {
        var var$3;
        var$3 = var$0.$_0819;
        return $java.oncias_SemanticCheckResult$_error0(oncias_SemanticCheckResult$_MODULE$, var$1, (var$2.$errorMessageProvider0()).$createDynamicGraphReferenceUnsupportedError(), var$3.$position64);
    };
    $java.onciu_RewritableCompat$PROXY$7_265 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_265_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_265 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_265_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.oncil_SolvableLabelExpression$containsSolutionsForRelationship$lambda$_12_0 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$containsSolutionsForRelationship$lambda$_12_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = new $java.oncil_NodeLabels$KnownLabels;
        s_Predef$_$callClinit();
        var$3 = s_Predef$_Set(s_Predef$_MODULE$);
        var$4 = sr_ScalaRunTime$_MODULE$;
        var$5 = $rt_createArray(jl_String, 1);
        var$5.data[0] = var$1;
        var$2.$labelNames = var$3.$from0(sr_ScalaRunTime$_wrapRefArray(var$4, var$5));
        return var$2;
    };
    $java.oncil_NodeLabels = $rt_classWithoutFields(0);
    var oncil_NodeLabels$SomeUnknownLabels$ = $rt_classWithoutFields();
    $java.oncil_NodeLabels$SomeUnknownLabels$_MODULE$ = null;
    function oncil_NodeLabels$SomeUnknownLabels$__clinit_() {
        $java.oncil_NodeLabels$SomeUnknownLabels$_MODULE$ = new oncil_NodeLabels$SomeUnknownLabels$;
    }
    $java.oncil_NodeLabels$SomeUnknownLabels$_productArity = function($this) {
        return 0;
    };
    $java.oncil_NodeLabels$SomeUnknownLabels$_productElement = function($this, $x$1) {
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_NodeLabels$SomeUnknownLabels$_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_NodeLabels$SomeUnknownLabels$_hashCode = function($this) {
        return (-592101323);
    };
    $java.oncil_NodeLabels$SomeUnknownLabels$_toString = function($this) {
        return $rt_s(3306);
    };
    $java.ju_HashMap$AbstractMapIterator = function() {
        var a = this; jl_Object.call(a);
        a.$position304 = 0;
        a.$expectedModCount0 = 0;
        a.$futureEntry0 = null;
        a.$currentEntry1 = null;
        a.$prevEntry0 = null;
        a.$associatedMap1 = null;
    };
    $java.ju_HashMap$AbstractMapIterator_hasNext = function($this) {
        var var$1, var$2;
        if ($this.$futureEntry0 !== null)
            return 1;
        while (true) {
            var$1 = $this.$position304;
            var$2 = $this.$associatedMap1.$elementData1.data;
            if (var$1 >= var$2.length)
                break;
            if (var$2[var$1] !== null)
                return 1;
            $this.$position304 = var$1 + 1 | 0;
        }
        return 0;
    };
    $java.ju_HashMap$ValueIterator = $rt_classWithoutFields($java.ju_HashMap$AbstractMapIterator);
    $java.ju_HashMap$ValueIterator_next = function($this) {
        var var$1, var$2, var$3, var$4;
        if ($this.$expectedModCount0 != $this.$associatedMap1.$modCount2) {
            var$1 = new ju_ConcurrentModificationException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        if (!$java.ju_HashMap$AbstractMapIterator_hasNext($this)) {
            var$1 = new ju_NoSuchElementException;
            jl_Throwable__init_0(var$1);
            $rt_throw(var$1);
        }
        var$1 = $this.$futureEntry0;
        if (var$1 === null) {
            var$2 = $this.$associatedMap1.$elementData1.data;
            var$3 = $this.$position304;
            $this.$position304 = var$3 + 1 | 0;
            var$1 = var$2[var$3];
            $this.$currentEntry1 = var$1;
            $this.$futureEntry0 = var$1.$next10;
            $this.$prevEntry0 = null;
        } else {
            var$4 = $this.$currentEntry1;
            if (var$4 !== null)
                $this.$prevEntry0 = var$4;
            $this.$currentEntry1 = var$1;
            $this.$futureEntry0 = var$1.$next10;
        }
        return $this.$currentEntry1.$value12;
    };
    $java.otcir_Flags = $rt_classWithoutFields();
    $java.otcir_Flags_getModifiers = function($flags, $access) {
        var $modifiers;
        a: {
            $modifiers = 0;
            switch ($access) {
                case 1:
                    $modifiers = 2;
                    break a;
                case 2:
                    $modifiers = 4;
                    break a;
                case 3:
                    $modifiers = 1;
                    break a;
                default:
            }
        }
        $access = $flags >>> 6;
        return $modifiers | $access & 8 | $flags << 2 & 16 | $access & 32 | $flags >>> 8 & 64 | $flags >>> 5 & 128 | $flags & 256 | $flags << 8 & 512 | $flags << 10 & 1024 | $flags << 1 & 2048;
    };
    $java.oncius_TypeSpec$unwrapPotentialLists$lambda$_27_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$unwrapPotentialLists$lambda$_27_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeRange_reparent(var$1, new $java.oncius_TypeSpec$$anonfun$unwrapPotentialLists$1$lambda$_66_0);
    };
    $java.jl_IllegalAccessException = $rt_classWithoutFields(jl_ReflectiveOperationException);
    $java.otcir_Converter = $rt_classWithoutFields();
    $java.oncia_ViewRef$argumentsAsGraphReferences$lambda$_51_0 = $rt_classWithoutFields();
    $java.oncia_ViewRef$argumentsAsGraphReferences$lambda$_51_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncia_GraphReference$_from($java.oncia_GraphReference$_MODULE$, var$1);
    };
    var sci_Stream$Empty$ = $rt_classWithoutFields(sci_Stream);
    var sci_Stream$Empty$_MODULE$ = null;
    function sci_Stream$Empty$__clinit_() {
        sci_Stream$Empty$_MODULE$ = new sci_Stream$Empty$;
    }
    $java.sci_Stream$Empty$_isEmpty = function($this) {
        return 1;
    };
    $java.sci_Stream$Empty$_knownSize = function($this) {
        return 0;
    };
    $java.sci_Stream$Empty$_tailDefined = function($this) {
        return 0;
    };
    $java.sci_Stream$Empty$_force = function($this) {
        return $this;
    };
    $java.sci_Stream$Empty$_tail = function($this) {
        var var$1;
        var$1 = new jl_UnsupportedOperationException;
        jl_Throwable__init_(var$1, $rt_s(3307));
        $rt_throw(var$1);
    };
    $java.sci_Stream$Empty$_head = function($this) {
        var var$1;
        var$1 = new ju_NoSuchElementException;
        jl_Throwable__init_(var$1, $rt_s(3308));
        $rt_throw(var$1);
    };
    function sci_Stream$Cons() {
        var a = this; sci_Stream.call(a);
        a.$head5 = null;
        a.$tlVal = null;
        a.$tlGen = null;
    }
    function sci_Stream$Cons__init_0(var_0, var_1) {
        var var_2 = new sci_Stream$Cons();
        sci_Stream$Cons__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.sci_Stream$Cons_head = function($this) {
        return $this.$head5;
    };
    $java.sci_Stream$Cons_isEmpty = function($this) {
        return 0;
    };
    $java.sci_Stream$Cons_tailDefined = function($this) {
        if ($this.$tlGen !== null)
            return 0;
        return 1;
    };
    $java.sci_Stream$Cons_tail = function($this) {
        var var$1, $$je;
        if (!$java.sci_Stream$Cons_tailDefined($this)) {
            jl_Object_monitorEnterSync($this);
            a: {
                try {
                    if ($java.sci_Stream$Cons_tailDefined($this))
                        break a;
                    $this.$tlVal = $this.$tlGen.$apply2();
                    $this.$tlGen = null;
                    break a;
                } catch ($$e) {
                    $$je = $rt_wrapException($$e);
                    var$1 = $$je;

                }
                jl_Object_monitorExitSync($this);
                $rt_throw(var$1);
            }
            jl_Object_monitorExitSync($this);
        }
        return $this.$tlVal;
    };
    $java.sci_Stream$Cons_force = function($this) {
        var var$1, var$2;
        var$1 = $java.sci_Stream$Cons_tail($this);
        var$2 = $this;
        a: {
            while (var$2 !== var$1) {
                if (var$1.$isEmpty())
                    break a;
                var$1 = var$1.$tail();
                if (var$1.$isEmpty())
                    break a;
                var$1 = var$1.$tail();
                if (var$1 === var$2)
                    break a;
                var$2 = var$2.$tail();
            }
        }
        return $this;
    };
    $java.sci_Stream$Cons_tail0 = function($this) {
        return $java.sci_Stream$Cons_tail($this);
    };
    function sci_Stream$Cons__init_($this, $head, $tl) {
        $this.$head5 = $head;
        $this.$tlGen = $tl;
    }
    function sci_Stream$$fromIterator$lambda$_21_0() {
        jl_Object.call(this);
        this.$_0179 = null;
    }
    $java.sci_Stream$$fromIterator$lambda$_21_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0179;
        return sci_Stream$_fromIterator(sci_Stream$_MODULE$, var$1);
    };
    $java.oncius_ListType$greatestLowerBound$lambda$_38_0 = function() {
        jl_Object.call(this);
        this.$_0395 = null;
    };
    $java.oncius_ListType$greatestLowerBound$lambda$_38_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0395;
        return $java.oncius_ListType_copy(var$2, var$1, var$2.$isNullable15, var$2.$position108);
    };
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_4 = function() {
        var a = this; jl_Object.call(a);
        a.$_0399 = null;
        a.$_1115 = null;
    };
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_4_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        a: {
            var$1 = var$1;
            var$2 = var$0.$_0399;
            var$3 = var$0.$_1115;
            var$4 = 0;
            var$5 = null;
            var$6 = var$1.$greatestLowerBound(var$3);
            if (var$6 instanceof s_Some) {
                var$4 = 1;
                var$5 = var$6;
                var$7 = var$5.$value5;
                if (s_Option_isEmpty(var$2.$elem5)) {
                    var$1 = s_Some__init_(var$7);
                    break a;
                }
            }
            if (var$4) {
                var$1 = var$5.$value5;
                if (s_Option_isDefined((var$2.$elem5.$get0()).$greatestLowerBound(var$1))) {
                    var$1 = (var$2.$elem5.$get0()).$greatestLowerBound(var$1);
                    break a;
                }
            }
            if (var$4)
                var$1 = s_Some__init_(var$3);
            else {
                if (!jl_Object_equals(s_None$_MODULE$, var$6))
                    $rt_throw(s_MatchError__init_(var$6));
                var$1 = var$2.$elem5;
            }
        }
        var$2.$elem5 = var$1;
        return sr_BoxedUnit_UNIT;
    };
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0400 = null;
        a.$_1116 = null;
    };
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0400;
        var$3 = var$0.$_1116;
        var$4 = var$2.$innerTypes;
        var$2 = new $java.oncius_ClosedDynamicUnionType$$anonfun$greatestLowerBound$1$lambda$_62_0;
        var$2.$_0824 = var$3;
        var$2.$_1274 = var$1;
        var$4.$foreach(var$2);
        return sr_BoxedUnit_UNIT;
    };
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_1 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_1_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Option_isDefined(var$1));
    };
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_2 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_2_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Option_isDefined(var$1));
    };
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_3 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_3_apply = function(var$0, var$1) {
        return var$1.$get0();
    };
    $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_0 = $rt_classWithoutFields();
    $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_0_apply = function(var$0, var$1) {
        return jl_Long_valueOf(($java.oncie_DecimalIntegerLiteral_value(var$1)).$value2);
    };
    $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_1 = $rt_classWithoutFields();
    $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_1_apply$mcJ$sp = function(var$0) {
        return Long_ZERO;
    };
    $java.oncius_TypeSpec$wrapInCovariantList$lambda$_24_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$wrapInCovariantList$lambda$_24_0_apply = function(var$0, var$1) {
        return $java.oncius_TypeRange_reparent($java.oncius_TypeRange_covariant(var$1), new $java.oncius_TypeSpec$$anonfun$wrapInCovariantList$1$lambda$_61_0);
    };
    $java.oncia_connectedComponents$RichConnectedComponent = function() {
        jl_Object.call(this);
        this.$connectedComponent = null;
    };
    $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0768 = null;
        a.$_1250 = null;
    };
    $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_0_apply = function(var$0) {
        return var$0.$_0768.$apply(var$0.$_1250);
    };
    $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0769 = null;
        a.$_1251 = null;
    };
    $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_1_apply = function(var$0, var$1) {
        return $java.suc_TailCalls$TailRec_$anonfun$flatMap$2(var$0.$_0769, var$0.$_1251, var$1);
    };
    $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0803 = null;
        a.$_1262 = null;
    };
    $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_0_apply = function(var$0) {
        return var$0.$_0803.$apply(var$0.$_1262);
    };
    $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0804 = null;
        a.$_1263 = null;
    };
    $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_1_apply = function(var$0, var$1) {
        return $java.suc_TailCalls$TailRec_$anonfun$flatMap$2(var$0.$_0804, var$0.$_1263, var$1);
    };
    $java.suc_TailCalls$TailRec$$anonfun$map$1$lambda$_5_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0805 = null;
        a.$_1264 = null;
    };
    $java.suc_TailCalls$TailRec$$anonfun$map$1$lambda$_5_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0805;
        var$2 = var$0.$_1264;
        return $java.suc_TailCalls$Done__init_(var$1.$apply(var$2));
    };
    $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0786 = null;
        a.$_1257 = null;
    };
    $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0786;
        var$2 = var$0.$_1257;
        return $java.onciut_TailCallsUtil$_traverse($java.onciut_TailCallsUtil$_MODULE$, var$1.$tail(), var$2);
    };
    $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_1 = function() {
        jl_Object.call(this);
        this.$_0787 = null;
    };
    $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_1_apply = function(var$0, var$1) {
        return var$1.$prepended(var$0.$_0787);
    };
    $java.onciut_TailCallsUtil$$$anonfun$map2$1$lambda$_8_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0785 = null;
        a.$_1256 = null;
    };
    $java.onciut_TailCallsUtil$$$anonfun$map2$1$lambda$_8_0_apply = function(var$0, var$1) {
        return var$0.$_0785.$apply0(var$0.$_1256, var$1);
    };
    $java.oncius_CypherType$greatestLowerBound$lambda$_35_0 = function() {
        jl_Object.call(this);
        this.$_0392 = null;
    };
    $java.oncius_CypherType$greatestLowerBound$lambda$_35_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$0.$_0392.$isAssignableFrom0(var$1));
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$2$lambda$_89_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0812 = null;
        a.$_1267 = null;
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$2$lambda$_89_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0812;
        var$3 = var$0.$_1267;
        var$4 = var$3.$state.$currentScope;
        var$5 = oncias_SemanticCheck$_MODULE$;
        var$6 = new $java.oncia_SubqueryCall$returnToOuterScope$lambda$_63_0;
        var$6.$_0825 = var$4;
        var$6 = $java.oncias_SemanticCheck$_fromFunction(var$5, var$6);
        var$5 = new $java.oncia_SubqueryCall$$anonfun$checkSubquery$3$lambda$_88_0;
        var$5.$_0826 = var$2;
        var$5.$_1275 = var$1;
        var$5.$_277 = var$3;
        return oncias_SemanticCheck_flatMap$(var$6, var$5);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$2$lambda$_42_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0813 = null;
        a.$_1268 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$2$lambda$_42_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0813;
        var$3 = var$0.$_1268;
        var$4 = $java.oncias_SemanticCheck$_setState(oncias_SemanticCheck$_MODULE$, oncias_SemanticState_newSiblingScope(oncias_SemanticState_popScope(var$1.$state)));
        var$5 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$3$lambda$_41_0;
        var$5.$_0827 = var$2;
        var$5.$_1276 = var$3;
        var$5.$_278 = var$1;
        return oncias_SemanticCheck_flatMap$(var$4, var$5);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_0 = $rt_classWithoutFields();
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = s_Predef$ArrowAssoc$_MODULE$;
        s_Predef$_$callClinit();
        return s_Predef$ArrowAssoc$_$minus$greater$extension(var$2, var$1.$name4, var$1);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0814 = null;
        a.$_1269 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0814;
        var$3 = var$0.$_1269;
        var$4 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$16$lambda$_53_0;
        var$4.$_0828 = var$2;
        var$2 = (var$3.$getOrElse0(var$1, var$4)).$position2();
        var$3 = new oncias_SemanticError;
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(440)), var$1), $rt_s(3309));
        oncias_SemanticError__init_(var$3, jl_AbstractStringBuilder_toString(var$4), var$2);
        return var$3;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$11$lambda$_50_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0815 = null;
        a.$_1270 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$11$lambda$_50_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0815;
        var$3 = var$0.$_1270;
        var$4 = var$1.$errors;
        var$3 = $java.oncias_SemanticState$ScopeLocation$_symbolNames$extension(oncias_SemanticState$ScopeLocation$_MODULE$, var$3.$currentScope);
        var$5 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$12$lambda$_49_0;
        var$5.$_0829 = var$2;
        var$5.$_1277 = var$3;
        var$2 = var$4.$map1(var$5);
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$6$lambda$_47_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0816 = null;
        a.$_1271 = null;
        a.$_276 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$6$lambda$_47_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0816;
        var$3 = var$0.$_1271;
        var$4 = var$0.$_276;
        var$5 = $java.oncias_SemanticCheck$_setState(oncias_SemanticCheck$_MODULE$, oncias_SemanticState_popScope(var$1.$state));
        var$6 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$7$lambda$_46_0;
        var$6.$_0830 = var$2;
        var$6.$_1278 = var$3;
        var$6.$_279 = var$1;
        var$6.$_316 = var$4;
        return oncias_SemanticCheck_flatMap$(var$5, var$6);
    };
    $java.oncia_Match$$anonfun$7 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer54 = null;
        a.$semanticState$1 = null;
        a.$context$10 = null;
    };
    $java.oncia_Match$$anonfun$7_applyOrElse = function($this, $x, $default) {
        var var$3, var$4, var$5, var$6, var$7, $$je;
        a: {
            $x = $x;
            var$3 = 0;
            var$4 = null;
            if ($x instanceof oncia_UsingIndexHint) {
                var$3 = 1;
                var$4 = $x;
                var$5 = var$4.$variable6;
                var$6 = var$4.$labelOrRelType0;
                if (var$5 !== null) {
                    var$5 = var$5.$name4;
                    if (var$6 !== null) {
                        var$6 = var$6.$name56;
                        if (!$java.oncia_Match_containsLabelOrRelTypePredicate($this.$$outer54, var$5, var$6)) {
                            $x = oncias_SemanticError__init_0($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getMissingEntityKindError$1($this.$$outer54, var$5, var$6, var$4, $this.$semanticState$1, $this.$context$10), var$4.$position207);
                            break a;
                        }
                    }
                }
            }
            if (var$3) {
                var$5 = var$4.$variable6;
                var$6 = var$4.$labelOrRelType0;
                var$7 = var$4.$properties3;
                if (var$5 !== null) {
                    var$5 = var$5.$name4;
                    if (var$6 !== null) {
                        var$6 = $java.oncia_Match_getPropertyPredicates($this.$$outer54, var$5);
                        var$5 = new $java.oncia_Match$containsPropertyPredicates$lambda$_72_0;
                        var$5.$_0831 = var$6;
                        if (!var$7.$forall(var$5)) {
                            $x = oncias_SemanticError__init_0($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getMissingPropertyError$1($this.$$outer54, var$4, $this.$semanticState$1, $this.$context$10), var$4.$position207);
                            break a;
                        }
                    }
                }
            }
            if ($x instanceof oncia_UsingScanHint) {
                var$7 = $x;
                var$5 = var$7.$variable5;
                var$6 = var$7.$labelOrRelType;
                if (var$5 !== null) {
                    var$4 = var$5.$name4;
                    if (var$6 !== null) {
                        var$5 = var$6.$name56;
                        if (!$java.oncia_Match_containsLabelOrRelTypePredicate($this.$$outer54, var$4, var$5)) {
                            $x = oncias_SemanticError__init_0($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getMissingEntityKindError$1($this.$$outer54, var$4, var$5, var$7, $this.$semanticState$1, $this.$context$10), var$7.$position185);
                            break a;
                        }
                    }
                }
            }
            if ($x instanceof oncia_UsingJoinHint) {
                var$6 = $x;
                var$5 = $this.$$outer54.$pattern2;
                if (var$5.$bitmap$026)
                    var$3 = var$5.$length6;
                else {
                    jl_Object_monitorEnterSync(var$5);
                    b: {
                        try {
                            if (var$5.$bitmap$026)
                                break b;
                            var$5.$length6 = $java.oncie_Pattern_length$(var$5);
                            var$5.$bitmap$026 = 1;
                            break b;
                        } catch ($$e) {
                            $$je = $rt_wrapException($$e);
                            $x = $$je;

                        }
                        jl_Object_monitorExitSync(var$5);
                        $rt_throw($x);
                    }
                    jl_Object_monitorExitSync(var$5);
                    var$3 = var$5.$length6;
                }
                if (!var$3) {
                    $x = oncias_SemanticError__init_0($rt_s(3310), var$6.$position196);
                    break a;
                }
            }
            $x = $default.$apply($x);
        }
        return $x;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$2$lambda$_139_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0823 = null;
        a.$_1273 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$2$lambda$_139_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0823;
        var$3 = var$0.$_1273;
        oncias_SemanticPatternCheck$_$callClinit();
        var$4 = (var$1.$recordedScopes.$apply(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, var$2))).$location;
        var$5 = (oncias_SemanticState$ScopeLocation$_declarationsAndDependencies$extension(oncias_SemanticState$ScopeLocation$_MODULE$, var$4)).$dependencies;
        var$6 = (oncias_SemanticState$ScopeLocation$_declarationsAndDependencies$extension(oncias_SemanticState$ScopeLocation$_MODULE$, var$1.$currentScope)).$declarations;
        var$4 = sc_IterableOnceOps_toSeq$(var$5.$intersect(((sc_AbstractIterable_toSet((var$3.$patternParts()).$flatMap(new $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_0))).$map1(new $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_1)).$filter1(var$6)));
        var$3 = new $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_2;
        var$3.$_0832 = var$2;
        return oncias_SemanticCheckResult__init_(var$1, var$4.$map1(var$3));
    };
    $java.oncia_ASTSlicingPhrase$$containsNoVariables$lambda$_41_0 = $rt_classWithoutFields();
    $java.oncia_ASTSlicingPhrase$$containsNoVariables$lambda$_41_0_apply = function(var$0, var$1) {
        return var$1.$position0;
    };
    $java.onciu_RewritableCompat$PROXY$7_266 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_266_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_266 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_266_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_267 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_267_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_267 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_267_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(2)).$value;
    };
    $java.onciu_RewritableCompat$PROXY$7_268 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$7_268_lastParamIsPosition = function(var$1) {
        return (jl_Boolean_valueOf(1)).$value8;
    };
    $java.onciu_RewritableCompat$PROXY$5_268 = $rt_classWithoutFields();
    $java.onciu_RewritableCompat$PROXY$5_268_paramsLength = function(var$1) {
        return (jl_Integer_valueOf(3)).$value;
    };
    $java.sci_Stream$partition$lambda$_56_0 = function() {
        jl_Object.call(this);
        this.$_0711 = null;
    };
    $java.sci_Stream$partition$lambda$_56_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(var$0.$_0711.$apply(var$1)));
    };
    $java.sci_Stream$partition$lambda$_56_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0712 = null;
        a.$_1220 = null;
        a.$_266 = 0;
    };
    $java.sci_Stream$partition$lambda$_56_1_apply = function(var$0) {
        return sci_Stream$_$anonfun$filteredTail$1(var$0.$_0712, var$0.$_1220, var$0.$_266);
    };
    $java.sci_Stream$partition$lambda$_56_2 = function() {
        jl_Object.call(this);
        this.$_0713 = null;
    };
    $java.sci_Stream$partition$lambda$_56_2_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(var$0.$_0713.$apply(var$1)));
    };
    $java.sci_Stream$partition$lambda$_56_3 = function() {
        var a = this; jl_Object.call(a);
        a.$_0714 = null;
        a.$_1221 = null;
        a.$_267 = 0;
    };
    $java.sci_Stream$partition$lambda$_56_3_apply = function(var$0) {
        return sci_Stream$_$anonfun$filteredTail$1(var$0.$_0714, var$0.$_1221, var$0.$_267);
    };
    $java.sci_Stream$append$lambda$_49_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0710 = null;
        a.$_1219 = null;
    };
    $java.sci_Stream$append$lambda$_49_0_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$lazyAppendedAll$1(var$0.$_0710, var$0.$_1219);
    };
    $java.sci_Stream$collectFirst$lambda$_64_0 = function() {
        jl_Object.call(this);
        this.$_0721 = null;
    };
    $java.sci_Stream$collectFirst$lambda$_64_0_apply = function(var$0, var$1) {
        var$0.$_0721.$elem5 = var$1;
        return sr_BoxedUnit_UNIT;
    };
    $java.sc_View$$from$lambda$_18_0 = function() {
        jl_Object.call(this);
        this.$_0822 = null;
    };
    $java.sc_View$$anon$1 = function() {
        sc_AbstractView.call(this);
        this.$it$1 = null;
    };
    $java.sc_View$$anon$1_iterator = function($this) {
        return $this.$it$1.$_0822.$iterator0();
    };
    $java.oncia_SingleQuery$semanticCheckInSubqueryContext$lambda$_67_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0331 = null;
        a.$_1100 = null;
    };
    $java.oncia_SingleQuery$semanticCheckInSubqueryContext$lambda$_67_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$2 = var$0.$_0331;
        var$3 = var$0.$_1100;
        var$4 = oncias_OptionSemanticChecking$_MODULE$;
        var$5 = $java.oncia_SingleQuery_importWith(var$2);
        var$6 = new $java.oncia_SingleQuery$importVariables$1$lambda$_102_0;
        var$6.$_0833 = var$2;
        var$6.$_1279 = var$3;
        return (oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$4, var$5, var$6)).$chain($java.oncia_SingleQuery_checkClauses(var$2, var$1, s_Some__init_(var$3.$currentScope.$elem)));
    };
    var onciu_NotImplementedErrorMessageProvider$ = $rt_classWithoutFields();
    $java.onciu_NotImplementedErrorMessageProvider$_MODULE$ = null;
    function onciu_NotImplementedErrorMessageProvider$__clinit_() {
        $java.onciu_NotImplementedErrorMessageProvider$_MODULE$ = new onciu_NotImplementedErrorMessageProvider$;
    }
    $java.onciu_NotImplementedErrorMessageProvider$_createMissingPropertyLabelHintError = function($this, $operatorDescription, $hintStringification, $missingThingDescription, $foundThingsDescription, $entityDescription, $entityName, $additionalInfo) {
        s_Predef$_$callClinit();
        $rt_throw(s_Predef$_$qmark$qmark$qmark(s_Predef$_MODULE$));
    };
    $java.onciu_NotImplementedErrorMessageProvider$_createUseClauseUnsupportedError = function($this) {
        s_Predef$_$callClinit();
        $rt_throw(s_Predef$_$qmark$qmark$qmark(s_Predef$_MODULE$));
    };
    $java.onciu_NotImplementedErrorMessageProvider$_createDynamicGraphReferenceUnsupportedError = function($this) {
        s_Predef$_$callClinit();
        $rt_throw(s_Predef$_$qmark$qmark$qmark(s_Predef$_MODULE$));
    };
    $java.onciu_NotImplementedErrorMessageProvider$_createMultipleGraphReferencesError = function($this) {
        s_Predef$_$callClinit();
        $rt_throw(s_Predef$_$qmark$qmark$qmark(s_Predef$_MODULE$));
    };
    $java.oncia_ReturnItems$declareVariables$lambda$_60_0 = function() {
        jl_Object.call(this);
        this.$_0317 = null;
    };
    $java.oncia_ReturnItems$declareVariables$lambda$_60_0_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0317;
        var$2 = oncias_package$_MODULE$;
        var$3 = new $java.oncia_ReturnItems$$anonfun$declareVariables$1$lambda$_80_0;
        var$3.$_0834 = var$1;
        return oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(var$2, var$3);
    };
    $java.oncia_ReturnItems$declareVariables$lambda$_60_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0318 = null;
        a.$_195 = null;
    };
    $java.oncia_ReturnItems$declareVariables$lambda$_60_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7, var$8;
        a: {
            var$1 = var$1;
            var$2 = var$0.$_0318;
            var$3 = var$0.$_195;
            var$4 = 0;
            var$5 = null;
            var$6 = var$1.$alias();
            if (var$6 instanceof s_Some)
                b: {
                    c: {
                        var$4 = 1;
                        var$5 = var$6;
                        var$7 = var$5.$value5;
                        var$8 = var$1.$expression1();
                        if (var$8 !== null) {
                            if (!var$8.$equals(var$7))
                                break b;
                            else
                                break c;
                        }
                        if (var$7 !== null)
                            break b;
                    }
                    var$3 = oncias_Scope_symbol(var$3, var$7.$name4);
                    var$1 = $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0(var$2, var$7, oncias_SemanticAnalysisTooling_types$(var$2, var$1.$expression1()), var$3, 1));
                    break a;
                }
            if (!var$4) {
                if (!jl_Object_equals(s_None$_MODULE$, var$6))
                    $rt_throw(s_MatchError__init_(var$6));
                var$1 = oncias_package$_Convert$u0020function$u0020to$u0020SemanticCheck(oncias_package$_MODULE$, new $java.oncia_ReturnItems$$anonfun$declareVariables$3$lambda$_82_0);
            } else {
                var$3 = var$5.$value5;
                var$1 = $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$0(var$2, var$3, oncias_SemanticAnalysisTooling_types$(var$2, var$1.$expression1()), s_None$_MODULE$, 1));
            }
        }
        return var$1;
    };
    $java.oncie_Expression$$anonfun$dependencies$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncie_Expression$$anonfun$dependencies$1_applyOrElse = function($this, $x1, $default) {
        if ($rt_isInstance($x1, $java.oncie_ScopeExpression)) {
            $x1 = $x1;
            $default = new $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_0;
            $default.$_0835 = $x1;
            return $default;
        }
        if (!($x1 instanceof oncie_LogicalVariable))
            return s_PartialFunction$_fallback_fn;
        $x1 = $x1;
        $default = new $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_1;
        $default.$_0836 = $x1;
        return $default;
    };
    $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$hasImportFormat$1$lambda$_93_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$hasImportFormat$1$lambda$_93_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isPassThrough());
    };
    $java.oncia_SingleQuery$checkIllegalImportWith$lambda$_69_0 = function() {
        jl_Object.call(this);
        this.$_0327 = null;
    };
    $java.oncia_SingleQuery$checkIllegalImportWith$lambda$_69_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0327;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = new $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$1$lambda$_122_0;
        var$4.$_0837 = var$2;
        var$4.$_1280 = var$1;
        return oncias_SemanticCheck$_fromState(var$3, var$4);
    };
    $java.oncia_SingleQuery$clausesExceptLeadingFromAndImportWith$lambda$_61_0 = function() {
        jl_Object.call(this);
        this.$_0330 = null;
    };
    $java.oncia_SingleQuery$clausesExceptLeadingFromAndImportWith$lambda$_61_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(s_Option_contains(var$0.$_0330, var$1));
    };
    $java.oncia_SingleQuery$checkShadowedVariables$lambda$_76_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0332 = null;
        a.$_1101 = null;
    };
    $java.oncia_SingleQuery$checkShadowedVariables$lambda$_76_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0332;
        var$3 = var$0.$_1101.$currentScope.$elem.$symbolTable;
        var$4 = oncias_Scope_allSymbols(var$1.$currentScope.$elem);
        var$5 = new $java.oncia_SingleQuery$$anonfun$2;
        if (var$2 === null)
            $rt_throw(null);
        var$5.$$outer58 = var$2;
        var$5.$innerScopeSymbols$1 = var$4;
        var$1 = sc_IterableOnceOps_foldLeft$(var$3.$collect1(var$5), var$1, new $java.oncia_SingleQuery$$anonfun$checkShadowedVariables$1$lambda$_147_0);
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
    };
    $java.sc_LinearSeqIterator = function() {
        sc_AbstractIterator.call(this);
        this.$these = null;
    };
    $java.sc_LinearSeqIterator_hasNext = function($this) {
        return sc_IterableOnceOps_nonEmpty$($java.sc_LinearSeqIterator$LazyCell_v($this.$these));
    };
    $java.sc_LinearSeqIterator_next = function($this) {
        var $cur, $result, var$3, var$4;
        if (sc_Iterator_isEmpty$($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $cur = $java.sc_LinearSeqIterator$LazyCell_v($this.$these);
        $result = $cur.$head();
        var$3 = new $java.sc_LinearSeqIterator$LazyCell;
        var$4 = new $java.sc_LinearSeqIterator$next$lambda$_1_0;
        var$4.$_0838 = $cur;
        $java.sc_LinearSeqIterator$LazyCell__init_(var$3, $this, var$4);
        $this.$these = var$3;
        return $result;
    };
    $java.onciu_CartesianProductNotification = function() {
        var a = this; jl_Object.call(a);
        a.$position300 = null;
        a.$isolatedVariables = null;
        a.$pattern14 = null;
    };
    $java.onciu_CartesianProductNotification_productPrefix = function($this) {
        return $rt_s(3311);
    };
    $java.onciu_CartesianProductNotification_productArity = function($this) {
        return 3;
    };
    $java.onciu_CartesianProductNotification_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position300;
            case 1:
                return $this.$isolatedVariables;
            case 2:
                return $this.$pattern14;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_CartesianProductNotification_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_CartesianProductNotification_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_CartesianProductNotification_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_CartesianProductNotification_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.onciu_CartesianProductNotification) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position300;
                        var$3 = $x$1.$position300;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$2 = $this.$isolatedVariables;
                        var$3 = $x$1.$isolatedVariables;
                        if (var$2 !== null) {
                            if (!var$2.$equals(var$3))
                                break b;
                            else
                                break d;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    e: {
                        var$3 = $this.$pattern14;
                        $x$1 = $x$1.$pattern14;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break e;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.onciu_CartesianProductNotification))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncia_Match$$anonfun$checkForCartesianProducts$2$lambda$_114_0 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$checkForCartesianProducts$2$lambda$_114_0_apply = function(var$0, var$1) {
        return var$1.$name4;
    };
    $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_0 = function() {
        jl_Object.call(this);
        this.$_0820 = null;
    };
    $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_0_apply = function(var$0) {
        return var$0.$_0820.$upper1;
    };
    $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_1 = function() {
        jl_Object.call(this);
        this.$_0821 = null;
    };
    $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0821;
        var$3 = new s_Some;
        var$4 = var$2.$upper1;
        var$2 = new $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_0;
        var$2.$_0839 = var$1;
        var$5 = new $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_1;
        var$5.$_0840 = var$1;
        s_Some__init_0(var$3, s_Option_fold(var$4, var$2, var$5));
        return var$3;
    };
    function sc_View$Appended() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying31 = null;
        a.$elem9 = null;
    }
    function sc_View$Appended__init_(var_0, var_1) {
        var var_2 = new sc_View$Appended();
        sc_View$Appended__init_0(var_2, var_0, var_1);
        return var_2;
    }
    $java.sc_View$Appended_iterator = function($this) {
        var var$1, var$2, var$3;
        var$1 = new sc_View$Concat;
        var$2 = $this.$underlying31;
        var$3 = new $java.sc_View$Single;
        var$3.$a8 = $this.$elem9;
        sc_View$Concat__init_0(var$1, var$2, var$3);
        return sc_View$Concat_iterator(var$1);
    };
    $java.sc_View$Appended_knownSize = function($this) {
        var $size;
        $size = $this.$underlying31.$knownSize();
        if ($size < 0)
            return (-1);
        return $size + 1 | 0;
    };
    function sc_View$Appended__init_0($this, $underlying, $elem) {
        $this.$underlying31 = $underlying;
        $this.$elem9 = $elem;
    }
    function sc_View$DropRight() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying2 = null;
        a.$n0 = 0;
        a.$normN0 = 0;
    }
    $java.sc_View$DropRight_iterator = function($this) {
        var var$1, var$2, var$3, var$4;
        var$1 = $this.$underlying2.$iterator0();
        var$2 = $this.$n0;
        if (var$2 > 0) {
            var$3 = var$1.$knownSize();
            if (var$3 >= 0)
                var$1 = var$1.$take(var$3 - var$2 | 0);
            else {
                var$4 = new $java.sc_View$DropRightIterator;
                var$4.$underlying32 = var$1;
                var$4.$maxlen = var$2;
                var$4.$len4 = (-1);
                var$4.$pos4 = 0;
                var$1 = var$4;
            }
        }
        return var$1;
    };
    $java.sc_View$DropRight_knownSize = function($this) {
        var $size;
        $size = $this.$underlying2.$knownSize();
        if ($size < 0)
            return (-1);
        return jl_Math_max($size - $this.$normN0 | 0, 0);
    };
    $java.sc_View$DropRight_isEmpty = function($this) {
        if ($java.sc_View$DropRight_knownSize($this) < 0)
            return ($java.sc_View$DropRight_iterator($this)).$isEmpty();
        if ($java.sc_View$DropRight_knownSize($this))
            return 0;
        return 1;
    };
    function sc_View$DistinctBy() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying4 = null;
        a.$f1 = null;
    }
    $java.sc_View$DistinctBy_iterator = function($this) {
        return ($this.$underlying4.$iterator0()).$distinctBy0($this.$f1);
    };
    $java.sc_View$DistinctBy_knownSize = function($this) {
        if ($this.$underlying4.$knownSize())
            return (-1);
        return 0;
    };
    $java.sc_View$DistinctBy_isEmpty = function($this) {
        return $this.$underlying4.$isEmpty();
    };
    function sc_SeqOps$intersect$lambda$_118_0() {
        jl_Object.call(this);
        this.$_011 = null;
    }
    $java.sc_SeqOps$intersect$lambda$_118_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_011;
        var$3 = new $java.sr_BooleanRef;
        var$3.$elem13 = 1;
        var$4 = new $java.sc_SeqOps$$anonfun$intersect$1$lambda$_139_0;
        var$4.$_0841 = var$3;
        scm_HashMap_updateWith(var$2, var$1, var$4);
        return jl_Boolean_valueOf(var$3.$elem13);
    };
    $java.oncia_SingleQuery$$anonfun$leadingNonImportWith$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncia_SingleQuery$$anonfun$leadingNonImportWith$1_applyOrElse = function($this, $x, $default) {
        $x = $x;
        return $x instanceof oncia_With ? $x : s_PartialFunction$_fallback_fn;
    };
    $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_0 = function() {
        jl_Object.call(this);
        this.$_0345 = null;
    };
    $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_0345;
        var$3 = oncias_SemanticCheck$_MODULE$;
        var$4 = new $java.oncia_Union$$anonfun$semanticCheckInSubqueryContext$3$lambda$_38_0;
        var$4.$_0842 = var$1;
        var$4.$_1281 = var$2;
        return oncias_SemanticCheck$_nestedCheck(var$3, var$4);
    };
    $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_1 = function() {
        jl_Object.call(this);
        this.$_0346 = null;
    };
    $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_1_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_semanticCheckInSubqueryContext(var$1, var$0.$_0346);
    };
    $java.oncius_TypeSpec$$anonfun$unwrapPotentialLists$1$lambda$_66_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$anonfun$unwrapPotentialLists$1$lambda$_66_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        if (var$1 instanceof oncius_ListType)
            var$1 = var$1.$innerType0;
        else if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        return var$1;
    };
    $java.oncius_TypeSpec$$anonfun$wrapInCovariantList$1$lambda$_61_0 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$anonfun$wrapInCovariantList$1$lambda$_61_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncius_package$_$callClinit();
        return oncius_package$_CTList(oncius_package$_MODULE$, var$1);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$16$lambda$_53_0 = function() {
        jl_Object.call(this);
        this.$_0828 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$16$lambda$_53_0_apply = function(var$0) {
        return var$0.$_0828.$returnItems0();
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_0 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return var$1.$allVariables();
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_1 = $rt_classWithoutFields();
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        oncias_SemanticPatternCheck$_$callClinit();
        return oncias_SymbolUse$_apply(oncias_SymbolUse$_MODULE$, var$1);
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_2 = function() {
        jl_Object.call(this);
        this.$_0832 = null;
    };
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0832;
        oncias_SemanticPatternCheck$_$callClinit();
        var$3 = onciap_DefaultPatternStringifier_apply4(($java.oncias_SemanticPatternCheck$_stringifier0(oncias_SemanticPatternCheck$_MODULE$)).$patterns, var$2);
        var$4 = new oncias_SemanticError;
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        var$5 = $java.oncias_SymbolUse_name(var$1);
        var$6 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$6);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$6, $rt_s(3312)), var$5), $rt_s(3313)), var$3), 46);
        oncias_SemanticError__init_(var$4, sc_StringOps$_stripMargin$extension(var$2, jl_AbstractStringBuilder_toString(var$6)), ($java.oncias_SymbolUse_asVariable(var$1)).$position0);
        return var$4;
    };
    $java.sc_LinearSeqIterator$LazyCell = function() {
        var a = this; jl_Object.call(a);
        a.$v1 = null;
        a.$st = null;
        a.$bitmap$036 = 0;
    };
    $java.sc_LinearSeqIterator$LazyCell__init_0 = function(var_0, var_1) {
        var var_2 = new $java.sc_LinearSeqIterator$LazyCell();
        $java.sc_LinearSeqIterator$LazyCell__init_(var_2, var_0, var_1);
        return var_2;
    };
    $java.sc_LinearSeqIterator$LazyCell_v = function($this) {
        var var$1, $$je;
        if ($this.$bitmap$036)
            return $this.$v1;
        jl_Object_monitorEnterSync($this);
        a: {
            try {
                if ($this.$bitmap$036)
                    break a;
                $this.$v1 = $this.$st.$apply2();
                $this.$bitmap$036 = 1;
                break a;
            } catch ($$e) {
                $$je = $rt_wrapException($$e);
                var$1 = $$je;

            }
            jl_Object_monitorExitSync($this);
            $rt_throw(var$1);
        }
        jl_Object_monitorExitSync($this);
        $this.$st = null;
        return $this.$v1;
    };
    $java.sc_LinearSeqIterator$LazyCell__init_ = function($this, $$outer, $st) {
        $this.$st = $st;
    };
    $java.sc_LinearSeqIterator$_init_$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0709 = null;
    };
    $java.sc_LinearSeqIterator$_init_$lambda$_4_0_apply = function(var$0) {
        return var$0.$_0709;
    };
    $java.oncius_ClosedDynamicUnionType$$anonfun$greatestLowerBound$1$lambda$_62_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0824 = null;
        a.$_1274 = null;
    };
    $java.oncius_ClosedDynamicUnionType$$anonfun$greatestLowerBound$1$lambda$_62_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6;
        var$1 = var$1;
        var$2 = var$0.$_0824;
        var$3 = var$0.$_1274;
        s_Predef$_$callClinit();
        var$4 = s_Predef$_Set(s_Predef$_MODULE$);
        var$5 = sr_ScalaRunTime$_MODULE$;
        var$6 = $rt_createArray(s_Option, 1);
        var$6.data[0] = var$3.$greatestLowerBound(var$1);
        return var$2.$concat1(var$4.$from0(sr_ScalaRunTime$_wrapRefArray(var$5, var$6)));
    };
    $java.sc_View$$newBuilder$lambda$_20_0 = $rt_classWithoutFields();
    $java.sc_View$$newBuilder$lambda$_20_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.sc_View$_from(sc_View$_MODULE$, var$1);
    };
    $java.oncia_connectedComponents$RichConnectedComponent$connectedTo$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0810 = null;
    };
    $java.oncia_connectedComponents$RichConnectedComponent$connectedTo$lambda$_0_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(sc_IterableOnceOps_nonEmpty$(var$1.$intersect(var$0.$_0810)));
    };
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_0 = $rt_classWithoutFields();
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_0_apply = function(var$0) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    };
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_1 = $rt_classWithoutFields();
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_1_apply = function(var$0, var$1) {
        return var$1.$dependencies0();
    };
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_2 = $rt_classWithoutFields();
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_2_apply = function(var$0) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    };
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_3 = $rt_classWithoutFields();
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_3_apply = function(var$0, var$1) {
        return var$1.$dependencies0();
    };
    $java.oncie_FilterScope$scopeDependencies$lambda$_8_0 = $rt_classWithoutFields();
    $java.oncie_FilterScope$scopeDependencies$lambda$_8_0_apply = function(var$0) {
        s_Predef$_$callClinit();
        s_Predef$_Set(s_Predef$_MODULE$);
        return sci_Set$EmptySet$_MODULE$;
    };
    $java.oncie_FilterScope$scopeDependencies$lambda$_8_1 = $rt_classWithoutFields();
    $java.oncie_FilterScope$scopeDependencies$lambda$_8_1_apply = function(var$0, var$1) {
        return var$1.$dependencies0();
    };
    $java.sc_LinearSeqIterator$next$lambda$_1_0 = function() {
        jl_Object.call(this);
        this.$_0838 = null;
    };
    $java.sc_LinearSeqIterator$next$lambda$_1_0_apply = function(var$0) {
        return var$0.$_0838.$tail();
    };
    $java.sci_Stream$map$lambda$_62_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0718 = null;
        a.$_1224 = null;
    };
    $java.sci_Stream$map$lambda$_62_0_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$map$1(var$0.$_0718, var$0.$_1224);
    };
    $java.sci_Stream$flatMap$lambda$_65_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0722 = null;
        a.$_1226 = null;
    };
    $java.sci_Stream$flatMap$lambda$_65_0_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$flatMap$1(var$0.$_0722, var$0.$_1226);
    };
    $java.sci_Stream$flatMap$lambda$_65_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0723 = null;
        a.$_1227 = null;
    };
    $java.sci_Stream$flatMap$lambda$_65_1_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$lazyAppendedAll$1(var$0.$_0723, var$0.$_1227);
    };
    $java.sci_Stream$flatMap$lambda$_65_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0724 = null;
        a.$_1228 = null;
    };
    $java.sci_Stream$flatMap$lambda$_65_2_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$flatMap$1(var$0.$_0724, var$0.$_1228);
    };
    $java.sci_Stream$flatMap$lambda$_65_3 = function() {
        var a = this; jl_Object.call(a);
        a.$_0725 = null;
        a.$_1229 = null;
    };
    $java.sci_Stream$flatMap$lambda$_65_3_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$lazyAppendedAll$1(var$0.$_0725, var$0.$_1229);
    };
    $java.sci_Stream$prepended$lambda$_61_0 = function() {
        jl_Object.call(this);
        this.$_0717 = null;
    };
    $java.sci_Stream$prepended$lambda$_61_0_apply = function(var$0) {
        return var$0.$_0717;
    };
    $java.sci_Stream$collect$lambda$_63_0 = function() {
        jl_Object.call(this);
        this.$_0719 = null;
    };
    $java.sci_Stream$collect$lambda$_63_0_apply = function(var$0, var$1) {
        var$0.$_0719.$elem5 = var$1;
        return sr_BoxedUnit_UNIT;
    };
    $java.sci_Stream$filterNot$lambda$_58_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0716 = null;
        a.$_1223 = null;
        a.$_269 = 0;
    };
    $java.sci_Stream$filterNot$lambda$_58_0_apply = function(var$0) {
        return sci_Stream$_$anonfun$filteredTail$1(var$0.$_0716, var$0.$_1223, var$0.$_269);
    };
    $java.sci_Stream$filter$lambda$_57_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0715 = null;
        a.$_1222 = null;
        a.$_268 = 0;
    };
    $java.sci_Stream$filter$lambda$_57_0_apply = function(var$0) {
        return sci_Stream$_$anonfun$filteredTail$1(var$0.$_0715, var$0.$_1222, var$0.$_268);
    };
    var sc_IterableOnceExtensionMethods$ = $rt_classWithoutFields();
    $java.sc_IterableOnceExtensionMethods$_MODULE$ = null;
    function sc_IterableOnceExtensionMethods$__clinit_() {
        $java.sc_IterableOnceExtensionMethods$_MODULE$ = new sc_IterableOnceExtensionMethods$;
    }
    $java.sci_Stream$zip$lambda$_66_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0726 = null;
        a.$_1230 = null;
    };
    $java.sci_Stream$zip$lambda$_66_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0726;
        var$2 = var$0.$_1230;
        return $java.sci_Stream_zip(var$1.$tail(), var$2.$tail());
    };
    function sci_LazyList$$from$lambda$_25_0() {
        jl_Object.call(this);
        this.$_0182 = null;
    }
    $java.sci_LazyList$$from$lambda$_25_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0182;
        sci_LazyList$_$callClinit();
        return sci_LazyList$_scala$collection$immutable$LazyList$$stateFromIterator(sci_LazyList$_MODULE$, var$1.$iterator0());
    };
    $java.oncius_ClosedDynamicUnionType$leastUpperBound$lambda$_39_0 = $rt_classWithoutFields();
    $java.oncius_ClosedDynamicUnionType$leastUpperBound$lambda$_39_0_apply = function(var$0, var$1, var$2) {
        return var$1.$leastUpperBound(var$2);
    };
    $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0835 = null;
    };
    $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0835.$dependencies0();
        var$3 = new $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_0;
        var$3.$_0843 = var$1;
        var$2 = var$2.$filterNot1(var$3);
        var$3 = new $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_1;
        var$3.$_0844 = var$2;
        return $java.onciu_Foldable$SkipChildren__init_($java.oncie_Expression$TreeAcc_mapData(var$1, var$3));
    };
    $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_1 = function() {
        jl_Object.call(this);
        this.$_0836 = null;
    };
    $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0836;
        if (!$java.oncie_Expression$TreeAcc_inScope(var$1, var$2)) {
            var$3 = new $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$6$lambda$_6_0;
            var$3.$_0845 = var$2;
            var$1 = $java.oncie_Expression$TreeAcc_mapData(var$1, var$3);
        }
        return $java.onciu_Foldable$TraverseChildren__init_0(var$1);
    };
    function oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0() {
        jl_Object.call(this);
        this.$_0329 = null;
    }
    function oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(s_Option_contains($java.oncia_SingleQuery_importWith(var$0.$_0329), var$1) ? 0 : 1);
    }
    $java.sc_View$Single = function() {
        sc_AbstractView.call(this);
        this.$a8 = null;
    };
    $java.sc_View$Single_iterator = function($this) {
        return sc_Iterator$$anon$20__init_($this.$a8);
    };
    $java.sc_View$Single_knownSize = function($this) {
        return 1;
    };
    $java.sc_View$Single_isEmpty = function($this) {
        return 0;
    };
    $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0729 = null;
        a.$_1233 = null;
    };
    $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_0_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$flatMap$1(var$0.$_0729, var$0.$_1233);
    };
    $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0730 = null;
        a.$_1234 = null;
    };
    $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_1_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$lazyAppendedAll$1(var$0.$_0730, var$0.$_1234);
    };
    $java.oncie_ExpressionWithComputedDependencies$scopeDependencies$lambda$_8_0 = $rt_classWithoutFields();
    $java.oncie_ExpressionWithComputedDependencies$scopeDependencies$lambda$_8_0_apply = function(var$0) {
        var var$1;
        var$1 = new jl_IllegalStateException;
        jl_Throwable__init_(var$1, $rt_s(3314));
        $rt_throw(var$1);
    };
    $java.oncia_Union$$anonfun$semanticCheckInSubqueryContext$3$lambda$_38_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0842 = null;
        a.$_1281 = null;
    };
    $java.oncia_Union$$anonfun$semanticCheckInSubqueryContext$3$lambda$_38_0_apply = function(var$0) {
        return var$0.$_0842.$semanticCheckInSubqueryContext(var$0.$_1281);
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$3$lambda$_88_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0826 = null;
        a.$_1275 = null;
        a.$_277 = null;
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$3$lambda$_88_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$0.$_0826;
        var$2 = var$0.$_1275;
        var$3 = var$0.$_277;
        var$4 = var$2.$state.$currentScope.$elem;
        var$5 = oncias_SemanticCheck$_MODULE$;
        var$6 = var$1.$innerQuery.$isReturning();
        var$7 = new $java.oncia_SubqueryCall$declareOutputVariablesInOuterScope$lambda$_66_0;
        var$7.$_0846 = var$1;
        var$7.$_1282 = var$4;
        var$5 = oncias_SemanticCheck$_when(var$5, var$6, var$7);
        var$1 = new $java.oncia_SubqueryCall$$anonfun$checkSubquery$4$lambda$_87_0;
        var$1.$_0847 = var$3;
        var$1.$_1283 = var$2;
        return var$5.$map12(var$1);
    };
    $java.oncil_NodeLabels$KnownLabels = function() {
        jl_Object.call(this);
        this.$labelNames = null;
    };
    $java.oncil_NodeLabels$KnownLabels_productPrefix = function($this) {
        return $rt_s(3315);
    };
    $java.oncil_NodeLabels$KnownLabels_productArity = function($this) {
        return 1;
    };
    $java.oncil_NodeLabels$KnownLabels_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$labelNames;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.oncil_NodeLabels$KnownLabels_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_NodeLabels$KnownLabels_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_NodeLabels$KnownLabels_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.oncil_NodeLabels$KnownLabels_equals = function($this, $x$1) {
        var var$2, var$3;
        a: {
            b: {
                c: {
                    if ($this !== $x$1) {
                        if (!(!($x$1 instanceof $java.oncil_NodeLabels$KnownLabels) ? 0 : 1))
                            break b;
                        $x$1 = $x$1;
                        var$2 = $this.$labelNames;
                        $x$1 = $x$1.$labelNames;
                        if (var$2 !== null) {
                            if (!var$2.$equals($x$1))
                                break b;
                            else
                                break c;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                }
                var$3 = 1;
                break a;
            }
            var$3 = 0;
        }
        return var$3;
    };
    $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0708 = null;
        a.$_1218 = null;
    };
    $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_0_apply = function(var$0) {
        return $java.oncius_TypeSpec_innerTypeRanges(var$0.$_0708, var$0.$_1218.$apply2());
    };
    $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_1 = $rt_classWithoutFields();
    $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new oncius_ListType;
        onciu_InputPosition$_$callClinit();
        $java.oncius_ListType__init_(var$2, var$1, 1, onciu_InputPosition$_NONE(onciu_InputPosition$_MODULE$));
        return var$2;
    };
    function s_PartialFunction$runWith$lambda$_22_0() {
        var a = this; jl_Object.call(a);
        a.$_037 = null;
        a.$_112 = null;
    }
    $java.s_PartialFunction$runWith$lambda$_22_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$2 = var$0.$_037;
        var$3 = var$0.$_112;
        var$1 = var$2.$applyOrElse(var$1, s_PartialFunction$_fallback_fn);
        if (s_PartialFunction$_scala$PartialFunction$$fallbackOccurred(s_PartialFunction$_MODULE$, var$1))
            var$4 = 0;
        else {
            var$3.$apply(var$1);
            var$4 = 1;
        }
        return jl_Boolean_valueOf(var$4);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$3$lambda$_41_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0827 = null;
        a.$_1276 = null;
        a.$_278 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$3$lambda$_41_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$0.$_0827;
        var$2 = var$0.$_1276;
        var$3 = var$0.$_278;
        var$1 = oncia_ReturnItems_declareVariables(var$1.$returnItems0(), var$2.$currentScope.$elem);
        var$2 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$4$lambda$_40_0;
        var$2.$_0848 = var$3;
        return oncias_SemanticCheck_map$(var$1, var$2);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$12$lambda$_49_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0829 = null;
        a.$_1277 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$12$lambda$_49_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0829.$warnOnAccessToRestrictedVariableInOrderByOrWhere(var$0.$_1277, var$1);
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$7$lambda$_46_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0830 = null;
        a.$_1278 = null;
        a.$_279 = null;
        a.$_316 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$7$lambda$_46_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$0.$_0830;
        var$2 = var$0.$_1278;
        var$3 = var$0.$_279;
        var$4 = var$0.$_316;
        var$2 = oncia_ReturnItems_declareVariables(var$1.$returnItems0(), var$2);
        var$5 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$8$lambda$_45_0;
        var$5.$_0849 = var$1;
        var$5.$_1284 = var$3;
        var$5.$_280 = var$4;
        return oncias_SemanticCheck_map$(var$2, var$5);
    };
    $java.oncia_ReturnItems$$anonfun$declareVariables$3$lambda$_82_0 = $rt_classWithoutFields();
    $java.oncia_ReturnItems$$anonfun$declareVariables$3$lambda$_82_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = new oncias_SemanticCheckResult;
        s_package$_$callClinit();
        oncias_SemanticCheckResult__init_0(var$2, var$1, sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$)));
        return var$2;
    };
    $java.oncias_SemanticAnalysisTooling$withState$lambda$_5_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0328 = null;
        a.$_199 = null;
    };
    $java.oncias_SemanticAnalysisTooling$withState$lambda$_5_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0328;
        var$3 = var$0.$_199;
        var$2 = $java.oncias_SemanticCheck$_setState(oncias_SemanticCheck$_MODULE$, var$2);
        var$4 = new $java.oncias_SemanticAnalysisTooling$$anonfun$withState$1$lambda$_82_0;
        var$4.$_0850 = var$3;
        var$4.$_1285 = var$1;
        return oncias_SemanticCheck_flatMap$(var$2, var$4);
    };
    $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$5$lambda$_15_0 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$5$lambda$_15_0_apply = function(var$0, var$1, var$2) {
        return $java.oncil_SolvableLabelExpression_and(var$1, var$2);
    };
    $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$9$lambda$_19_0 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$9$lambda$_19_0_apply = function(var$0, var$1, var$2) {
        return $java.oncil_SolvableLabelExpression_or(var$1, var$2);
    };
    $java.sr_BooleanRef = function() {
        jl_Object.call(this);
        this.$elem13 = 0;
    };
    $java.sc_SeqOps$$anonfun$intersect$1$lambda$_139_0 = function() {
        jl_Object.call(this);
        this.$_0841 = null;
    };
    $java.sc_SeqOps$$anonfun$intersect$1$lambda$_139_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        a: {
            var$2 = var$0.$_0841;
            var$3 = 0;
            var$4 = null;
            if (jl_Object_equals(s_None$_MODULE$, var$1)) {
                var$2.$elem13 = 0;
                var$1 = s_None$_MODULE$;
            } else {
                if (var$1 instanceof s_Some) {
                    var$3 = 1;
                    var$4 = var$1;
                    if (1 == sr_BoxesRunTime_unboxToInt(var$4.$value5)) {
                        var$1 = s_None$_MODULE$;
                        break a;
                    }
                }
                if (!var$3)
                    $rt_throw(s_MatchError__init_(var$1));
                var$5 = sr_BoxesRunTime_unboxToInt(var$4.$value5);
                var$1 = s_Some__init_(jl_Integer_valueOf(var$5 - 1 | 0));
            }
        }
        return var$1;
    };
    $java.oncia_ReturnItems$$anonfun$declareVariables$1$lambda$_80_0 = function() {
        jl_Object.call(this);
        this.$_0834 = null;
    };
    $java.oncia_ReturnItems$$anonfun$declareVariables$1$lambda$_80_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0834;
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, oncias_SemanticState_importValuesFromScope(var$1, var$2, oncias_SemanticState_importValuesFromScope$default$2(var$1)));
    };
    $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_0 = function() {
        jl_Object.call(this);
        this.$_0839 = null;
    };
    $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_0_apply = function(var$0) {
        return var$0.$_0839;
    };
    $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_1 = function() {
        jl_Object.call(this);
        this.$_0840 = null;
    };
    $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_1_apply = function(var$0, var$1) {
        return var$1.$leastUpperBound(var$0.$_0840);
    };
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$1$lambda$_122_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0837 = null;
        a.$_1280 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$1$lambda$_122_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5, var$6, var$7;
        a: {
            var$2 = var$0.$_0837;
            var$3 = var$0.$_1280;
            var$1 = ($java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension($java.oncias_IterableOnceSemanticChecking$_MODULE$, var$3.$returnItems2.$items, new $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_0)).$apply61(var$1);
            var$4 = onciu_topDown$_MODULE$;
            onciu_Rewriter$_$callClinit();
            var$5 = onciu_Rewriter$_MODULE$;
            var$6 = new $java.oncia_SingleQuery$$anonfun$1;
            var$6.$resultState$1 = var$1;
            var$1 = onciu_topDown$_apply(var$4, onciu_Rewriter$_lift(var$5, var$6), onciu_topDown$_apply$default$2(onciu_topDown$_MODULE$), 1, onciu_CancellationChecker$NeverCancelled$_MODULE$);
            var$4 = var$3.$returnItems2;
            if (!var$4.$includeExisting) {
                var$5 = var$4.$items;
                var$4 = new $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_1;
                var$4.$_0851 = var$1;
                if (!var$5.$exists(var$4)) {
                    var$7 = 0;
                    break a;
                }
            }
            var$7 = 1;
        }
        var$1 = oncias_SemanticCheck$_MODULE$;
        var$4 = new $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_2;
        var$4.$_0852 = var$2;
        var$4.$_1286 = var$3;
        return oncias_SemanticCheck$_when(var$1, var$7, var$4);
    };
    $java.oncia_SingleQuery$$anonfun$2 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer58 = null;
        a.$innerScopeSymbols$1 = null;
    };
    $java.oncia_SingleQuery$$anonfun$2_applyOrElse = function($this, $x, $default) {
        var var$3, var$4, var$5, var$6;
        a: {
            $x = $x;
            if ($x !== null) {
                var$3 = $x.$_10;
                var$4 = $x.$_20;
                var$5 = $this.$innerScopeSymbols$1;
                if (var$5.$contains0(var$4.$name17) && !((var$5.$apply(var$4.$name17)).$map1(new $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$isShadowed$1$lambda$_145_0)).$contains0(var$4.$definition) ? 1 : 0) {
                    $x = s_Predef$ArrowAssoc$_MODULE$;
                    s_Predef$_$callClinit();
                    $default = $this.$innerScopeSymbols$1.$apply(var$3);
                    var$6 = new $java.oncia_SingleQuery$$anonfun$2$applyOrElse$lambda$_0_0;
                    var$6.$_0853 = var$4;
                    $x = s_Predef$ArrowAssoc$_$minus$greater$extension($x, var$3, ($java.oncias_SymbolUse_asVariable((($default.$find0(var$6)).$get0()).$definition)).$position0);
                    break a;
                }
            }
            $x = $default.$apply($x);
        }
        return $x;
    };
    $java.oncia_SingleQuery$$anonfun$checkShadowedVariables$1$lambda$_147_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$$anonfun$checkShadowedVariables$1$lambda$_147_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4;
        var$3 = s_Tuple2__init_(var$1, var$2);
        var$1 = var$3.$_10;
        var$2 = var$3.$_20;
        if (var$2 === null)
            $rt_throw(s_MatchError__init_(var$3));
        var$3 = var$2.$_10;
        var$2 = var$2.$_20;
        var$4 = new $java.onciu_SubqueryVariableShadowing;
        var$4.$position305 = var$2;
        var$4.$varName0 = var$3;
        return oncias_SemanticState_addNotification(var$1, var$4);
    };
    $java.oncia_SingleQuery$importVariables$1$lambda$_102_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0833 = null;
        a.$_1279 = null;
    };
    $java.oncia_SingleQuery$importVariables$1$lambda$_102_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0833;
        return oncias_SemanticCheck_chain$(oncia_ProjectionClause_semanticCheckContinuation$(var$1, var$0.$_1279.$currentScope.$elem, s_None$_MODULE$), oncias_SemanticAnalysisTooling_recordCurrentScope$(var$2, var$1));
    };
    $java.oncia_SubqueryCall$returnToOuterScope$lambda$_63_0 = function() {
        jl_Object.call(this);
        this.$_0825 = null;
    };
    $java.oncia_SubqueryCall$returnToOuterScope$lambda$_63_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0825;
        var$3 = var$1.$currentScope.$elem;
        var$1 = oncias_SemanticState_copy(var$1, var$2, var$1.$typeTable, var$1.$recordedScopes, var$1.$notifications, var$1.$features1, var$1.$declareVariablesToSuppressDuplicateErrors, var$1.$semanticCheckHasRunOnce);
        var$4 = var$1.$currentScope;
        oncias_SemanticState$_$callClinit();
        var$1 = oncias_SemanticState_newSiblingScope(oncias_SemanticState_copy(var$1, (onciuh_TreeZipper$Location_insertRight(var$4, var$3)).$get0(), var$1.$typeTable, var$1.$recordedScopes, var$1.$notifications, var$1.$features1, var$1.$declareVariablesToSuppressDuplicateErrors, var$1.$semanticCheckHasRunOnce));
        var$1 = oncias_SemanticState_importValuesFromScope(var$1, var$2.$elem, oncias_SemanticState_importValuesFromScope$default$2(var$1));
        return oncias_SemanticCheckResult$_success(oncias_SemanticCheckResult$_MODULE$, var$1);
    };
    var sci_Stream$$newBuilder$lambda$_23_0 = $rt_classWithoutFields();
    $java.sci_Stream$$newBuilder$lambda$_23_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return sci_Stream$_from(sci_Stream$_MODULE$, var$1);
    };
    function sci_LazyList$LazyIterator() {
        sc_AbstractIterator.call(this);
        this.$lazyList = null;
    }
    $java.sci_LazyList$LazyIterator_hasNext = function($this) {
        if (sci_LazyList_isEmpty($this.$lazyList))
            return 0;
        return 1;
    };
    $java.sci_LazyList$LazyIterator_next = function($this) {
        var $res;
        if (sci_LazyList_isEmpty($this.$lazyList))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $res = sci_LazyList_head($this.$lazyList);
        $this.$lazyList = sci_LazyList_tail($this.$lazyList);
        return $res;
    };
    var s_NotImplementedError = $rt_classWithoutFields(jl_Error);
    $java.sci_Stream$$collectedTail$lambda$_30_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0720 = null;
        a.$_1225 = null;
    };
    $java.sci_Stream$$collectedTail$lambda$_30_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0720;
        var$2 = var$0.$_1225;
        return $java.sci_Stream_collect(var$1.$tail(), var$2);
    };
    function sci_LazyList$$from$lambda$_32_0() {
        var a = this; jl_Object.call(a);
        a.$_0184 = 0;
        a.$_133 = 0;
    }
    $java.sci_LazyList$$from$lambda$_32_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0184;
        var$2 = var$0.$_133;
        sci_LazyList$_$callClinit();
        return sci_LazyList$State$Cons__init_(jl_Integer_valueOf(var$1), sci_LazyList$_from0(sci_LazyList$_MODULE$, var$1 + var$2 | 0, var$2));
    };
    $java.oncie_PathConcatenation$isBounded$lambda$_6_0 = $rt_classWithoutFields();
    $java.oncie_PathConcatenation$isBounded$lambda$_6_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isBounded());
    };
    var onciuh_StringHelper$RichString$ = $rt_classWithoutFields();
    $java.onciuh_StringHelper$RichString$_MODULE$ = null;
    function onciuh_StringHelper$RichString$__clinit_() {
        $java.onciuh_StringHelper$RichString$_MODULE$ = new onciuh_StringHelper$RichString$;
    }
    $java.onciuh_StringHelper$RichString$_stripLinesAndMargins$extension = function($this, $$this) {
        var var$2, var$3, var$4, var$5, var$6;
        s_Predef$_$callClinit();
        $$this = sc_StringOps$_stripMargin$extension(sc_StringOps$_MODULE$, $$this);
        var$2 = jl_String_length($$this);
        var$3 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_2(var$3, var$2);
        var$4 = 0;
        while (var$4 < var$2) {
            var$5 = jl_String_charAt($$this, var$4);
            var$6 = sr_BoxesRunTime_unboxToChar(jl_Character_valueOf(var$5));
            var$6 = jl_Character_isDefined(var$6) && !jl_Character_isISOControl(var$6) ? 1 : 0;
            if (sr_BoxesRunTime_unboxToBoolean(jl_Boolean_valueOf(var$6)))
                jl_AbstractStringBuilder_append(var$3, var$5);
            var$4 = var$4 + 1 | 0;
        }
        if (var$2 != var$3.$length0)
            $$this = jl_AbstractStringBuilder_toString(var$3);
        return $$this;
    };
    $java.onciuh_StringHelper$ = $rt_classWithoutFields();
    $java.onciuh_StringHelper$_MODULE$ = null;
    $java.onciuh_StringHelper$_org$neo4j$cypher$internal$util$helpers$StringHelper$$positionPattern = null;
    $java.onciuh_StringHelper$_$callClinit = function() {
        $java.onciuh_StringHelper$_$callClinit = $rt_eraseClinit($java.onciuh_StringHelper$);
        $java.onciuh_StringHelper$__clinit_();
    };
    $java.onciuh_StringHelper$__clinit_ = function() {
        var var$1, var$2;
        var$1 = new $java.onciuh_StringHelper$;
        $java.onciuh_StringHelper$_$callClinit();
        $java.onciuh_StringHelper$_MODULE$ = var$1;
        var$2 = sc_StringOps$_MODULE$;
        s_Predef$_$callClinit();
        $java.onciuh_StringHelper$_org$neo4j$cypher$internal$util$helpers$StringHelper$$positionPattern = sc_StringOps$_r$extension(var$2, $rt_s(3316));
    };
    $java.oncia_Match$containsPropertyPredicates$lambda$_72_0 = function() {
        jl_Object.call(this);
        this.$_0831 = null;
    };
    $java.oncia_Match$containsPropertyPredicates$lambda$_72_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(var$0.$_0831.$contains0(var$1.$name11));
    };
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getMissingPropertyError$1$lambda$_128_0 = $rt_classWithoutFields();
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getMissingPropertyError$1$lambda$_128_0_apply = function(var$0, var$1) {
        var var$2;
        var$2 = var$1.$name11;
        var$1 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$1);
        jl_AbstractStringBuilder_append(var$1, 96);
        jl_AbstractStringBuilder_append(jl_StringBuilder_append(var$1, var$2), 96);
        return jl_AbstractStringBuilder_toString(var$1);
    };
    $java.sc_View$DropRightIterator = function() {
        var a = this; sc_AbstractIterator.call(a);
        a.$underlying32 = null;
        a.$maxlen = 0;
        a.$len4 = 0;
        a.$pos4 = 0;
        a.$buf = null;
    };
    $java.sc_View$DropRightIterator_knownSize = function($this) {
        return $this.$len4;
    };
    $java.sc_View$DropRightIterator_hasNext = function($this) {
        if ($this.$buf === null) {
            $this.$buf = scm_ArrayBuffer__init_0($rt_createArray(jl_Object, jl_Math_max(jl_Math_min($this.$maxlen, 256), 1)), 0);
            while ($this.$pos4 < $this.$maxlen && $this.$underlying32.$hasNext()) {
                scm_ArrayBuffer_addOne($this.$buf, $this.$underlying32.$next());
                $this.$pos4 = $this.$pos4 + 1 | 0;
            }
            if (!$this.$underlying32.$hasNext())
                $this.$len4 = 0;
            $this.$pos4 = 0;
        }
        if (!$this.$len4)
            return 0;
        return 1;
    };
    $java.sc_View$DropRightIterator_next = function($this) {
        var $x, var$2, var$3;
        if (!$java.sc_View$DropRightIterator_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $x = scm_ArrayBuffer_apply($this.$buf, $this.$pos4);
        var$2 = $this.$len4;
        if (var$2 != (-1))
            $this.$len4 = var$2 - 1 | 0;
        else {
            scm_ArrayBuffer_update($this.$buf, $this.$pos4, $this.$underlying32.$next());
            if (!$this.$underlying32.$hasNext())
                $this.$len4 = 0;
        }
        var$3 = $this.$pos4 + 1 | 0;
        $this.$pos4 = var$3;
        if (var$3 == $this.$maxlen)
            $this.$pos4 = 0;
        return $x;
    };
    $java.oncil_SolvableLabelExpression$not$lambda$_13_0 = function() {
        jl_Object.call(this);
        this.$_0756 = null;
    };
    $java.oncil_SolvableLabelExpression$not$lambda$_13_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(var$0.$_0756.$matches2.$apply(var$1)) ? 0 : 1);
    };
    $java.oncia_Match$$anonfun$8 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer37 = null;
        a.$variable$4 = null;
    };
    $java.oncia_Match$$anonfun$8_applyOrElse = function($this, $x1, $default) {
        var $labelExpression, $id;
        if ($x1 instanceof oncie_RelationshipPattern) {
            $x1 = $x1;
            $labelExpression = $x1.$variable12;
            $default = $x1.$labelExpression2;
            if ($labelExpression instanceof s_Some) {
                $x1 = $labelExpression.$value5;
                if ($x1 instanceof oncie_Variable) {
                    $id = $x1.$name4;
                    if ($default instanceof s_Some)
                        a: {
                            b: {
                                $labelExpression = $default.$value5;
                                $x1 = $this.$variable$4;
                                if ($x1 !== null) {
                                    if (!jl_String_equals($x1, $id))
                                        break a;
                                    else
                                        break b;
                                }
                                if ($id !== null)
                                    break a;
                            }
                            $x1 = new $java.oncia_Match$$anonfun$8$applyOrElse$lambda$_0_0;
                            $x1.$_0854 = $this;
                            $x1.$_1287 = $labelExpression;
                            return $x1;
                        }
                }
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    $java.oncia_Match$$anonfun$9 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer38 = null;
        a.$variable$40 = null;
    };
    $java.oncia_Match$$anonfun$9_applyOrElse = function($this, $x2, $default) {
        var $labelExpression, $id;
        if ($x2 instanceof oncie_NodePattern) {
            $x2 = $x2;
            $labelExpression = $x2.$variable11;
            $default = $x2.$labelExpression1;
            if ($labelExpression instanceof s_Some) {
                $x2 = $labelExpression.$value5;
                if ($x2 instanceof oncie_Variable) {
                    $id = $x2.$name4;
                    if ($default instanceof s_Some)
                        a: {
                            b: {
                                $labelExpression = $default.$value5;
                                $x2 = $this.$variable$40;
                                if ($x2 !== null) {
                                    if (!jl_String_equals($x2, $id))
                                        break a;
                                    else
                                        break b;
                                }
                                if ($id !== null)
                                    break a;
                            }
                            $x2 = new $java.oncia_Match$$anonfun$9$applyOrElse$lambda$_0_0;
                            $x2.$_0855 = $this;
                            $x2.$_1288 = $labelExpression;
                            return $x2;
                        }
                }
            }
        }
        return s_PartialFunction$_fallback_fn;
    };
    $java.oncia_Match$$anonfun$10 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer39 = null;
        a.$variable$41 = null;
    };
    $java.oncia_Match$$anonfun$10_applyOrElse = function($this, $x3, $default) {
        var $id, $predicateLabels, $predicateRelTypes, $labelExpression;
        if ($x3 instanceof oncie_HasLabels) {
            $default = $x3;
            $id = $default.$expression1();
            $predicateLabels = $default.$labels();
            if ($id instanceof oncie_Variable)
                a: {
                    b: {
                        $id = $id.$name3();
                        $default = $this.$variable$41;
                        if ($id !== null) {
                            if (!$id.$equals($default))
                                break a;
                            else
                                break b;
                        }
                        if ($default !== null)
                            break a;
                    }
                    $x3 = new $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_0;
                    $x3.$_0856 = $predicateLabels;
                    return $x3;
                }
        }
        if ($x3 instanceof oncie_HasTypes) {
            $default = $x3;
            $id = $default.$expression1();
            $predicateRelTypes = $default.$types0();
            if ($id instanceof oncie_Variable)
                c: {
                    d: {
                        $id = $id.$name3();
                        $default = $this.$variable$41;
                        if ($id !== null) {
                            if (!$id.$equals($default))
                                break c;
                            else
                                break d;
                        }
                        if ($default !== null)
                            break c;
                    }
                    $x3 = new $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_1;
                    $x3.$_0857 = $predicateRelTypes;
                    return $x3;
                }
        }
        if ($x3 instanceof oncil_LabelExpressionPredicate) {
            $default = $x3;
            $id = $default.$entity0;
            $labelExpression = $default.$labelExpression3;
            if ($id instanceof oncie_Variable)
                e: {
                    f: {
                        $id = $id.$name4;
                        $default = $this.$variable$41;
                        if ($id !== null) {
                            if (!jl_String_equals($id, $default))
                                break e;
                            else
                                break f;
                        }
                        if ($default !== null)
                            break e;
                    }
                    $x3 = new $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_2;
                    $x3.$_0858 = $this;
                    $x3.$_1289 = $labelExpression;
                    return $x3;
                }
        }
        if (!($x3 instanceof oncia_Where ? 1 : $x3 instanceof oncie_And ? 1 : $x3 instanceof oncie_Ands ? 1 : $rt_isInstance($x3, sci_Set) ? 1 : $rt_isInstance($x3, sci_Seq) ? 1 : $x3 instanceof oncie_Or ? 1 : !($x3 instanceof oncie_Ors) ? 0 : 1))
            return new $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_4;
        return new $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_3;
    };
    $java.oncia_Match$getPropertyPredicates$lambda$_73_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0421 = null;
        a.$_1124 = null;
    };
    $java.oncia_Match$getPropertyPredicates$lambda$_73_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates(var$0.$_0421, var$0.$_1124, var$1.$expression4);
    };
    $java.oncia_Match$getPropertyPredicates$lambda$_73_1 = $rt_classWithoutFields();
    $java.oncia_Match$getPropertyPredicates$lambda$_73_1_apply = function(var$0) {
        s_package$_$callClinit();
        return sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer35 = null;
        a.$variable$2 = null;
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3_applyOrElse = function($this, $x1, $default) {
        var $id, $properties, $predicate;
        if ($x1 instanceof oncie_NodePattern) {
            $default = $x1;
            $id = $default.$variable11;
            $properties = $default.$properties4;
            $predicate = $default.$predicate0;
            if ($id instanceof s_Some) {
                $default = $id.$value5;
                if ($default instanceof oncie_Variable)
                    a: {
                        b: {
                            $id = $default.$name4;
                            $default = $this.$variable$2;
                            if ($default !== null) {
                                if (!jl_String_equals($default, $id))
                                    break a;
                                else
                                    break b;
                            }
                            if ($id !== null)
                                break a;
                        }
                        $x1 = new $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_0;
                        $x1.$_0859 = $this;
                        $x1.$_1290 = $properties;
                        $x1.$_281 = $predicate;
                        return $x1;
                    }
            }
        }
        c: {
            if ($x1 instanceof oncie_RelationshipPattern) {
                $x1 = $x1;
                $default = $x1.$variable12;
                $properties = $x1.$properties5;
                $predicate = $x1.$predicate1;
                if ($default instanceof s_Some) {
                    $x1 = $default.$value5;
                    if ($x1 instanceof oncie_Variable)
                        d: {
                            $id = $x1.$name4;
                            $x1 = $this.$variable$2;
                            if ($x1 !== null) {
                                if (!jl_String_equals($x1, $id))
                                    break d;
                                else
                                    break c;
                            }
                            if ($id === null)
                                break c;
                        }
                }
            }
            return s_PartialFunction$_fallback_fn;
        }
        $x1 = new $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_1;
        $x1.$_0860 = $this;
        $x1.$_1291 = $properties;
        $x1.$_282 = $predicate;
        return $x1;
    };
    $java.sci_Stream$$anonfun$map$1$lambda$_95_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0728 = null;
        a.$_1232 = null;
    };
    $java.sci_Stream$$anonfun$map$1$lambda$_95_0_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$map$1(var$0.$_0728, var$0.$_1232);
    };
    $java.sci_Stream$$anonfun$lazyAppendedAll$1$lambda$_90_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0727 = null;
        a.$_1231 = null;
    };
    $java.sci_Stream$$anonfun$lazyAppendedAll$1$lambda$_90_0_apply = function(var$0) {
        return $java.sci_Stream_$anonfun$lazyAppendedAll$1(var$0.$_0727, var$0.$_1231);
    };
    function sci_Stream$$$anonfun$filteredTail$1$lambda$_39_0() {
        var a = this; jl_Object.call(a);
        a.$_0180 = null;
        a.$_131 = null;
        a.$_218 = 0;
    }
    $java.sci_Stream$$$anonfun$filteredTail$1$lambda$_39_0_apply = function(var$0) {
        return sci_Stream$_$anonfun$filteredTail$1(var$0.$_0180, var$0.$_131, var$0.$_218);
    };
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0843 = null;
    };
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf($java.oncie_Expression$TreeAcc_inScope(var$0.$_0843, var$1));
    };
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_1 = function() {
        jl_Object.call(this);
        this.$_0844 = null;
    };
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_1_apply = function(var$0, var$1) {
        return var$1.$concat1(var$0.$_0844);
    };
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$6$lambda$_6_0 = function() {
        jl_Object.call(this);
        this.$_0845 = null;
    };
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$6$lambda$_6_0_apply = function(var$0, var$1) {
        return var$1.$incl(var$0.$_0845);
    };
    $java.oncia_Match$ = $rt_classWithoutFields();
    $java.oncia_Match$_MODULE$ = null;
    $java.oncia_Match$_hintPrettifier = null;
    $java.oncia_Match$_$callClinit = function() {
        $java.oncia_Match$_$callClinit = $rt_eraseClinit($java.oncia_Match$);
        $java.oncia_Match$__clinit_();
    };
    $java.oncia_Match$__clinit_ = function() {
        var var$1;
        var$1 = new $java.oncia_Match$;
        $java.oncia_Match$_$callClinit();
        $java.oncia_Match$_MODULE$ = var$1;
        $java.oncia_Match$_hintPrettifier = onciap_Prettifier__init_(onciap_ExpressionStringifier$_apply(onciap_ExpressionStringifier$_MODULE$, onciap_ExpressionStringifier$_failingExtender, 0, 0, 0, 0), onciap_Prettifier$EmptyExtension$_MODULE$, 1);
    };
    function sc_Iterator$$anon$8() {
        var a = this; sc_AbstractIterator.call(a);
        a.$traversedValues = null;
        a.$nextElementDefined = 0;
        a.$nextElement = null;
        a.$$outer9 = null;
        a.$f$1 = null;
    }
    $java.sc_Iterator$$anon$8_hasNext = function($this) {
        var $a;
        a: {
            while (true) {
                if ($this.$nextElementDefined)
                    break a;
                if (!$this.$$outer9.$hasNext())
                    break;
                $a = $this.$$outer9.$next();
                if (!scm_HashSet_add($this.$traversedValues, sc_SeqOps$distinct$lambda$_30_0_apply($this.$f$1, $a)))
                    continue;
                else {
                    $this.$nextElement = $a;
                    $this.$nextElementDefined = 1;
                    break a;
                }
            }
            return 0;
        }
        return 1;
    };
    $java.sc_Iterator$$anon$8_next = function($this) {
        if (!$java.sc_Iterator$$anon$8_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $this.$nextElementDefined = 0;
        return $this.$nextElement;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$4$lambda$_40_0 = function() {
        jl_Object.call(this);
        this.$_0848 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$4$lambda$_40_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0848;
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2.$errors.$concat0(var$1.$errors));
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$8$lambda$_45_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0849 = null;
        a.$_1284 = null;
        a.$_280 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$8$lambda$_45_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0849;
        var$3 = var$0.$_1284;
        var$4 = var$0.$_280;
        var$5 = var$3.$errors.$concat0(var$1.$errors);
        var$3 = $java.oncias_SemanticState$ScopeLocation$_symbolNames$extension(oncias_SemanticState$ScopeLocation$_MODULE$, var$4.$currentScope);
        var$4 = new $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$9$lambda$_44_0;
        var$4.$_0861 = var$2;
        var$4.$_1292 = var$3;
        var$2 = var$5.$map1(var$4);
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2);
    };
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_0_apply = function(var$0, var$1) {
        return var$1.$semanticCheck();
    };
    $java.oncia_SingleQuery$$anonfun$1 = function() {
        sr_AbstractPartialFunction.call(this);
        this.$resultState$1 = null;
    };
    $java.oncia_SingleQuery$$anonfun$1_applyOrElse = function($this, $x1, $default) {
        if (!$rt_isInstance($x1, oncie_ExpressionWithComputedDependencies))
            return $default.$apply($x1);
        $x1 = $x1;
        return $x1.$withComputedScopeDependencies((oncias_SemanticState$ScopeLocation$_declarationsAndDependencies$extension(oncias_SemanticState$ScopeLocation$_MODULE$, ($this.$resultState$1.$state.$recordedScopes.$apply(oncia_ASTAnnotationMap$PositionedNode$_astNodeToPositionedNodeConverter(oncia_ASTAnnotationMap$PositionedNode$_MODULE$, $x1.$subqueryAstNode()))).$location)).$dependencies.$map1(new $java.oncia_SingleQuery$$anonfun$1$applyOrElse$lambda$_0_0));
    };
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_1 = function() {
        jl_Object.call(this);
        this.$_0851 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_1_apply = function(var$0, var$1) {
        var$1 = var$1;
        return jl_Boolean_valueOf(sc_IterableOnceOps_nonEmpty$((onciu_topDown$TopDownRewriter_apply(var$0.$_0851, var$1.$expression1())).$dependencies0()));
    };
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0852 = null;
        a.$_1286 = null;
    };
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_2_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6, var$7;
        var$1 = var$0.$_0852;
        var$2 = var$0.$_1286;
        var$3 = var$2.$returnItems2.$items.$exists(new $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_0);
        var$4 = oncias_SemanticCheck$_MODULE$;
        var$5 = new $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_1;
        var$5.$_0862 = var$1;
        var$5.$_1293 = var$2;
        var$6 = oncias_SemanticCheck$_when(var$4, var$3, var$5);
        var$4 = oncias_SemanticCheck$_MODULE$;
        var$3 = var$2.$distinct2;
        var$5 = new $java.oncia_SingleQuery$checkDistinct$1$lambda$_109_0;
        var$5.$_0863 = var$1;
        var$5.$_1294 = var$2;
        var$4 = var$6.$chain(oncias_SemanticCheck$_when(var$4, var$3, var$5));
        var$5 = oncias_OptionSemanticChecking$_MODULE$;
        var$7 = var$2.$where2;
        var$6 = new $java.oncia_SingleQuery$checkWhere$1$lambda$_113_0;
        var$6.$_0864 = var$1;
        var$6.$_1295 = var$2;
        var$7 = oncias_SemanticCheck_chain$(var$4, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$5, var$7, var$6));
        var$4 = oncias_OptionSemanticChecking$_MODULE$;
        var$6 = var$2.$orderBy1;
        var$5 = new $java.oncia_SingleQuery$checkOrderBy$1$lambda$_111_0;
        var$5.$_0865 = var$1;
        var$5.$_1296 = var$2;
        var$7 = oncias_SemanticCheck_chain$(var$7, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$4, var$6, var$5));
        var$4 = oncias_OptionSemanticChecking$_MODULE$;
        var$6 = var$2.$skip1;
        var$5 = new $java.oncia_SingleQuery$checkSkip$1$lambda$_115_0;
        var$5.$_0866 = var$1;
        var$5.$_1297 = var$2;
        var$7 = oncias_SemanticCheck_chain$(var$7, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$4, var$6, var$5));
        var$4 = oncias_OptionSemanticChecking$_MODULE$;
        var$6 = var$2.$limit1;
        var$5 = new $java.oncia_SingleQuery$checkLimit$1$lambda$_117_0;
        var$5.$_0867 = var$1;
        var$5.$_1298 = var$2;
        return oncias_SemanticCheck_chain$(var$7, oncias_OptionSemanticChecking$_foldSemanticCheck$extension(var$4, var$6, var$5));
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$4$lambda$_87_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0847 = null;
        a.$_1283 = null;
    };
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$4$lambda$_87_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0847;
        var$3 = var$0.$_1283;
        var$2 = var$2.$errors.$concat0(!sc_IterableOnceOps_nonEmpty$(var$3.$errors) ? var$1.$errors : var$3.$errors);
        return oncias_SemanticCheckResult__init_(var$1.$state, var$2);
    };
    $java.onciu_SubqueryVariableShadowing = function() {
        var a = this; jl_Object.call(a);
        a.$position305 = null;
        a.$varName0 = null;
    };
    $java.onciu_SubqueryVariableShadowing_productPrefix = function($this) {
        return $rt_s(3317);
    };
    $java.onciu_SubqueryVariableShadowing_productArity = function($this) {
        return 2;
    };
    $java.onciu_SubqueryVariableShadowing_productElement = function($this, $x$1) {
        switch ($x$1) {
            case 0:
                return $this.$position305;
            case 1:
                return $this.$varName0;
            default:
        }
        return sr_Statics_ioobe($x$1);
    };
    $java.onciu_SubqueryVariableShadowing_productIterator = function($this) {
        return sr_ScalaRunTime$_typedProductIterator(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_SubqueryVariableShadowing_hashCode = function($this) {
        return sr_ScalaRunTime$__hashCode(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_SubqueryVariableShadowing_toString = function($this) {
        return sr_ScalaRunTime$__toString(sr_ScalaRunTime$_MODULE$, $this);
    };
    $java.onciu_SubqueryVariableShadowing_equals = function($this, $x$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                if ($this !== $x$1) {
                    if (!(!($x$1 instanceof $java.onciu_SubqueryVariableShadowing) ? 0 : 1))
                        break b;
                    c: {
                        $x$1 = $x$1;
                        var$2 = $this.$position305;
                        var$3 = $x$1.$position305;
                        if (var$2 !== null) {
                            if (!onciu_InputPosition_equals(var$2, var$3))
                                break b;
                            else
                                break c;
                        }
                        if (var$3 !== null)
                            break b;
                    }
                    d: {
                        var$3 = $this.$varName0;
                        $x$1 = $x$1.$varName0;
                        if (var$3 !== null) {
                            if (!jl_String_equals(var$3, $x$1))
                                break b;
                            else
                                break d;
                        }
                        if ($x$1 !== null)
                            break b;
                    }
                    if (!($this instanceof $java.onciu_SubqueryVariableShadowing))
                        break b;
                }
                var$4 = 1;
                break a;
            }
            var$4 = 0;
        }
        return var$4;
    };
    $java.oncie_Pattern$$anonfun$length$1 = $rt_classWithoutFields(sr_AbstractPartialFunction);
    $java.oncie_Pattern$$anonfun$length$1_applyOrElse = function($this, $x1, $default) {
        if (!($x1 instanceof oncie_RelationshipChain))
            return new $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_1;
        return new $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_0;
    };
    $java.oncia_SubqueryCall$declareOutputVariablesInOuterScope$lambda$_66_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0846 = null;
        a.$_1282 = null;
    };
    $java.oncia_SubqueryCall$declareOutputVariablesInOuterScope$lambda$_66_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0846;
        var$2 = var$0.$_1282;
        var$2 = sc_AbstractMap_values((var$1.$innerQuery.$finalScope(var$2)).$symbolTable);
        var$3 = $java.oncias_IterableOnceSemanticChecking$_MODULE$;
        var$4 = new $java.oncias_SemanticAnalysisTooling$declareVariables$lambda$_65_0;
        var$4.$_0868 = var$1;
        return $java.oncias_IterableOnceSemanticChecking$_foldSemanticCheck$extension(var$3, var$2, var$4);
    };
    $java.onciuh_StringHelper$RichString$$stripLinesAndMargins$extension$lambda$_1_0 = $rt_classWithoutFields();
    function sci_LazyList$SlidingIterator() {
        var a = this; sc_AbstractIterator.call(a);
        a.$lazyList0 = null;
        a.$size5 = 0;
        a.$step2 = 0;
        a.$minLen = 0;
        a.$first1 = 0;
    }
    $java.sci_LazyList$SlidingIterator_hasNext = function($this) {
        var var$1, var$2, var$3;
        if ($this.$first1) {
            if (sci_LazyList_isEmpty($this.$lazyList0))
                return 0;
            return 1;
        }
        var$1 = $this.$lazyList0;
        var$2 = $this.$minLen;
        a: {
            while (var$2 >= 0) {
                if (sci_LazyList_isEmpty(var$1)) {
                    var$3 = 0;
                    break a;
                }
                var$1 = sci_LazyList_tail(var$1);
                var$2 = var$2 - 1 | 0;
            }
            var$3 = 1;
        }
        return var$3;
    };
    $java.sci_LazyList$SlidingIterator_next = function($this) {
        var var$1, var$2, var$3;
        if (!$java.sci_LazyList$SlidingIterator_hasNext($this))
            var$1 = sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        else {
            $this.$first1 = 0;
            var$1 = $this.$lazyList0;
            $this.$lazyList0 = sci_LazyList_drop(var$1, $this.$step2);
            var$2 = $this.$size5;
            if (var$1.$scala$collection$immutable$LazyList$$stateEvaluated && (sci_LazyList_scala$collection$immutable$LazyList$$state(var$1) !== sci_LazyList$State$Empty$_MODULE$ ? 0 : 1) ? 1 : 0) {
                sci_LazyList$_$callClinit();
                var$1 = sci_LazyList$_empty(sci_LazyList$_MODULE$);
            } else if (var$2 <= 0) {
                sci_LazyList$_$callClinit();
                var$1 = sci_LazyList$_empty(sci_LazyList$_MODULE$);
            } else {
                var$3 = new $java.sci_LazyList$take$lambda$_89_0;
                var$3.$_0869 = var$1;
                var$3.$_1299 = var$2;
                var$1 = sci_LazyList__init_(var$3);
            }
        }
        return var$1;
    };
    $java.oncia_SingleQuery$$anonfun$2$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0853 = null;
    };
    $java.oncia_SingleQuery$$anonfun$2$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        a: {
            b: {
                c: {
                    var$1 = var$1;
                    var$2 = var$0.$_0853;
                    var$3 = var$1.$definition;
                    var$1 = var$2.$definition;
                    if (var$3 !== null) {
                        if ($java.oncias_SymbolUse_equals(var$3, var$1))
                            break c;
                        else
                            break b;
                    }
                    if (var$1 !== null)
                        break b;
                }
                var$4 = 0;
                break a;
            }
            var$4 = 1;
        }
        return jl_Boolean_valueOf(var$4);
    };
    $java.oncia_Match$$anonfun$8$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0854 = null;
        a.$_1287 = null;
    };
    $java.oncia_Match$$anonfun$8$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0854;
        var$3 = var$0.$_1287;
        return var$1.$concat0($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression(var$2.$$outer37, var$3));
    };
    $java.oncia_Match$$anonfun$9$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0855 = null;
        a.$_1288 = null;
    };
    $java.oncia_Match$$anonfun$9$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0855;
        var$3 = var$0.$_1288;
        return var$1.$concat0($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression(var$2.$$outer38, var$3));
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0859 = null;
        a.$_1290 = null;
        a.$_281 = null;
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0859;
        var$3 = var$0.$_1290;
        var$4 = var$0.$_281;
        var$5 = new $java.onciu_Foldable$SkipChildren;
        var$3 = var$1.$concat0($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap(var$2.$$outer35, var$3));
        var$1 = new $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_0;
        var$1.$_0870 = var$2;
        $java.onciu_Foldable$SkipChildren__init_0(var$5, var$3.$concat0(s_Option_getOrElse(s_Option_map(var$4, var$1), new $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_1)));
        return var$5;
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0860 = null;
        a.$_1291 = null;
        a.$_282 = null;
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3, var$4, var$5;
        var$1 = var$1;
        var$2 = var$0.$_0860;
        var$3 = var$0.$_1291;
        var$4 = var$0.$_282;
        var$5 = new $java.onciu_Foldable$SkipChildren;
        var$3 = var$1.$concat0($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap(var$2.$$outer35, var$3));
        var$1 = new $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_0;
        var$1.$_0871 = var$2;
        $java.onciu_Foldable$SkipChildren__init_0(var$5, var$3.$concat0(s_Option_getOrElse(s_Option_map(var$4, var$1), new $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_1)));
        return var$5;
    };
    function sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIterator$lambda$_28_0() {
        jl_Object.call(this);
        this.$_0183 = null;
    }
    $java.sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIterator$lambda$_28_0_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0183;
        sci_LazyList$_$callClinit();
        return sci_LazyList$_scala$collection$immutable$LazyList$$stateFromIterator(sci_LazyList$_MODULE$, var$1);
    };
    function sci_LazyList$State$Cons() {
        var a = this; jl_Object.call(a);
        a.$head6 = null;
        a.$tail8 = null;
    }
    function sci_LazyList$State$Cons__init_(var_0, var_1) {
        var var_2 = new sci_LazyList$State$Cons();
        $java.sci_LazyList$State$Cons__init_(var_2, var_0, var_1);
        return var_2;
    }
    $java.sci_LazyList$State$Cons_head = function($this) {
        return $this.$head6;
    };
    $java.sci_LazyList$State$Cons_tail = function($this) {
        return $this.$tail8;
    };
    $java.sci_LazyList$State$Cons__init_ = function($this, $head, $tail) {
        $this.$head6 = $head;
        $this.$tail8 = $tail;
    };
    $java.oncil_SolvableLabelExpression$and$lambda$_15_0 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$and$lambda$_15_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4;
        var$3 = sr_BoxesRunTime_unboxToBoolean(var$1);
        var$4 = sr_BoxesRunTime_unboxToBoolean(var$2);
        return jl_Boolean_valueOf(var$3 && var$4 ? 1 : 0);
    };
    $java.oncil_SolvableLabelExpression$or$lambda$_16_0 = $rt_classWithoutFields();
    $java.oncil_SolvableLabelExpression$or$lambda$_16_0_apply = function(var$0, var$1, var$2) {
        var var$3, var$4;
        var$3 = sr_BoxesRunTime_unboxToBoolean(var$1);
        var$4 = sr_BoxesRunTime_unboxToBoolean(var$2);
        return jl_Boolean_valueOf(!var$3 && !var$4 ? 0 : 1);
    };
    $java.oncia_SingleQuery$$anonfun$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$$anonfun$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        return $java.oncias_SymbolUse_asVariable(var$1);
    };
    $java.srj_JFunction1$mcII$sp = $rt_classWithoutFields(0);
    $java.srj_JFunction1$mcII$sp_apply = function($this, $t) {
        return jl_Integer_valueOf($this.$apply$mcII$sp(sr_BoxesRunTime_unboxToInt($t)));
    };
    $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_1 = $rt_classWithoutFields();
    $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_1_apply$mcII$sp = function(var$0, var$1) {
        s_Predef$_$callClinit();
        return sr_BoxesRunTime_unboxToInt(jl_Integer_valueOf(var$1));
    };
    $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_0 = $rt_classWithoutFields();
    $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_0_apply$mcII$sp = function(var$0, var$1) {
        return var$1 + 1 | 0;
    };
    $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$isShadowed$1$lambda$_145_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$isShadowed$1$lambda$_145_0_apply = function(var$0, var$1) {
        return var$1.$definition;
    };
    $java.oncil_SolvableLabelExpression$binary$lambda$_14_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0746 = null;
        a.$_1237 = null;
        a.$_270 = null;
    };
    $java.oncil_SolvableLabelExpression$binary$lambda$_14_0_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0746;
        var$3 = var$0.$_1237;
        var$4 = var$0.$_270;
        return jl_Boolean_valueOf(sr_BoxesRunTime_unboxToBoolean(var$3.$apply0(var$2.$matches2.$apply(var$1), var$4.$matches2.$apply(var$1))));
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$withState$1$lambda$_82_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0850 = null;
        a.$_1285 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$withState$1$lambda$_82_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$0.$_0850;
        var$2 = var$0.$_1285;
        var$3 = new $java.oncias_SemanticAnalysisTooling$$anonfun$withState$2$lambda$_81_0;
        var$3.$_0872 = var$2;
        return oncias_SemanticCheck_map$(var$1, var$3);
    };
    function sc_View$TakeWhile() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying1 = null;
        a.$p0 = null;
    }
    $java.sc_View$TakeWhile_iterator = function($this) {
        return ($this.$underlying1.$iterator0()).$takeWhile1($this.$p0);
    };
    $java.sc_View$TakeWhile_knownSize = function($this) {
        if ($this.$underlying1.$knownSize())
            return (-1);
        return 0;
    };
    $java.sc_View$TakeWhile_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($java.sc_View$TakeWhile_iterator($this));
    };
    function sc_View$DropWhile() {
        var a = this; sc_AbstractView.call(a);
        a.$underlying3 = null;
        a.$p1 = null;
    }
    $java.sc_View$DropWhile_iterator = function($this) {
        return ($this.$underlying3.$iterator0()).$dropWhile1($this.$p1);
    };
    $java.sc_View$DropWhile_knownSize = function($this) {
        if ($this.$underlying3.$knownSize())
            return (-1);
        return 0;
    };
    $java.sc_View$DropWhile_isEmpty = function($this) {
        return sc_Iterator_isEmpty$($java.sc_View$DropWhile_iterator($this));
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$9$lambda$_44_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0861 = null;
        a.$_1292 = null;
    };
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$9$lambda$_44_0_apply = function(var$0, var$1) {
        var$1 = var$1;
        return var$0.$_0861.$warnOnAccessToRestrictedVariableInOrderByOrWhere(var$0.$_1292, var$1);
    };
    function oncia_ProjectionClause$$anonfun$warnOnAccessToRestrictedVariableInOrderByOrWhere$1() {
        sr_AbstractPartialFunction.call(this);
        this.$error$1 = null;
    }
    $java.oncia_ProjectionClause$$anonfun$warnOnAccessToRestrictedVariableInOrderByOrWhere$1_applyOrElse = function($this, $x, $default) {
        var var$3, var$4;
        $x = $x;
        var$3 = $this.$error$1.$msg1();
        var$4 = new jl_StringBuilder;
        jl_AbstractStringBuilder__init_(var$4);
        jl_StringBuilder_append(jl_StringBuilder_append(jl_StringBuilder_append(var$4, $rt_s(440)), $x), $rt_s(446));
        if (jl_String_equals(var$3, jl_AbstractStringBuilder_toString(var$4))) {
            $default = $this.$error$1;
            var$3 = new jl_StringBuilder;
            jl_AbstractStringBuilder__init_(var$3);
            jl_StringBuilder_append(jl_StringBuilder_append(var$3, $rt_s(3318)), $x);
            $default = $default.$withMsg(jl_AbstractStringBuilder_toString(var$3));
        }
        return $default;
    };
    function oncia_ProjectionClause$warnOnAccessToRestrictedVariableInOrderByOrWhere$lambda$_35_0() {
        jl_Object.call(this);
        this.$_0298 = null;
    }
    $java.oncia_ProjectionClause$warnOnAccessToRestrictedVariableInOrderByOrWhere$lambda$_35_0_apply = function(var$0) {
        return var$0.$_0298;
    };
    $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_0 = $rt_classWithoutFields();
    $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_0_apply = function(var$0, var$1) {
        return jl_Boolean_valueOf(var$1.$isPassThrough() ? 0 : 1);
    };
    $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0862 = null;
        a.$_1293 = null;
    };
    $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_1_apply = function(var$0) {
        return $java.oncia_SingleQuery_err$1(var$0.$_0862, $rt_s(3319), var$0.$_1293);
    };
    $java.oncia_SingleQuery$checkDistinct$1$lambda$_109_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0863 = null;
        a.$_1294 = null;
    };
    $java.oncia_SingleQuery$checkDistinct$1$lambda$_109_0_apply = function(var$0) {
        return $java.oncia_SingleQuery_err$1(var$0.$_0863, $rt_s(3320), var$0.$_1294);
    };
    $java.oncia_SingleQuery$checkWhere$1$lambda$_113_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0864 = null;
        a.$_1295 = null;
    };
    $java.oncia_SingleQuery$checkWhere$1$lambda$_113_0_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_err$1(var$0.$_0864, $rt_s(3321), var$0.$_1295);
    };
    $java.oncia_SingleQuery$checkOrderBy$1$lambda$_111_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0865 = null;
        a.$_1296 = null;
    };
    $java.oncia_SingleQuery$checkOrderBy$1$lambda$_111_0_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_err$1(var$0.$_0865, $rt_s(3322), var$0.$_1296);
    };
    $java.oncia_SingleQuery$checkSkip$1$lambda$_115_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0866 = null;
        a.$_1297 = null;
    };
    $java.oncia_SingleQuery$checkSkip$1$lambda$_115_0_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_err$1(var$0.$_0866, $rt_s(3323), var$0.$_1297);
    };
    $java.oncia_SingleQuery$checkLimit$1$lambda$_117_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0867 = null;
        a.$_1298 = null;
    };
    $java.oncia_SingleQuery$checkLimit$1$lambda$_117_0_apply = function(var$0, var$1) {
        return $java.oncia_SingleQuery_err$1(var$0.$_0867, $rt_s(3324), var$0.$_1298);
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0856 = null;
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0856;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$3 = var$1.$_10;
        var$1 = var$1.$_20;
        return $java.onciu_Foldable$SkipChildren__init_(s_Tuple2__init_(var$3.$concat0(var$2.$map1(new $java.oncia_Match$$anonfun$10$$anonfun$applyOrElse$29$lambda$_3_0)), var$1));
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_1 = function() {
        jl_Object.call(this);
        this.$_0857 = null;
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2, var$3;
        var$1 = var$1;
        var$2 = var$0.$_0857;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$3 = var$1.$_10;
        var$1 = var$1.$_20;
        return $java.onciu_Foldable$SkipChildren__init_(s_Tuple2__init_(var$3, var$1.$concat0(var$2.$map1(new $java.oncia_Match$$anonfun$10$$anonfun$applyOrElse$31$lambda$_5_0))));
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0858 = null;
        a.$_1289 = null;
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0858;
        var$3 = var$0.$_1289;
        if (var$1 === null)
            $rt_throw(s_MatchError__init_(var$1));
        var$4 = var$1.$_10;
        var$1 = var$1.$_20;
        var$2 = $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression(var$2.$$outer39, var$3);
        return $java.onciu_Foldable$SkipChildren__init_(s_Tuple2__init_(var$4.$concat0(var$2), var$1.$concat0(var$2)));
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_4 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_4_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_3 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_3_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$TraverseChildren__init_0(var$1);
    };
    function sci_LazyList$map$lambda$_69_0() {
        var a = this; jl_Object.call(a);
        a.$_0198 = null;
        a.$_146 = null;
    }
    $java.sci_LazyList$map$lambda$_69_0_apply = function(var$0) {
        return sci_LazyList_$anonfun$mapImpl$1(var$0.$_0198, var$0.$_146);
    };
    function sci_LazyList$flatMap$lambda$_75_0() {
        var a = this; jl_Object.call(a);
        a.$_0197 = null;
        a.$_145 = null;
    }
    $java.sci_LazyList$flatMap$lambda$_75_0_apply = function(var$0) {
        return sci_LazyList$_$anonfun$flatMapImpl$1(var$0.$_0197, var$0.$_145);
    };
    function sci_LazyList$dropRight$lambda$_87_0() {
        var a = this; jl_Object.call(a);
        a.$_0194 = null;
        a.$_142 = 0;
    }
    $java.sci_LazyList$dropRight$lambda$_87_0_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0194;
        var$2 = var$0.$_142;
        var$3 = var$1;
        while (var$2 > 0 && !sci_LazyList_isEmpty(var$3)) {
            var$2 = var$2 + (-1) | 0;
            var$3 = sci_LazyList_tail(var$3);
        }
        return sci_LazyList_dropRightState(var$1, var$3);
    };
    function sci_LazyList$appended$lambda$_58_0() {
        jl_Object.call(this);
        this.$_0203 = null;
    }
    $java.sci_LazyList$appended$lambda$_58_0_apply = function(var$0) {
        return sc_Iterator$$anon$20__init_(var$0.$_0203);
    };
    function sci_LazyList$appended$lambda$_58_1() {
        var a = this; jl_Object.call(a);
        a.$_0204 = null;
        a.$_150 = null;
    }
    $java.sci_LazyList$appended$lambda$_58_1_apply = function(var$0) {
        return sci_LazyList_$anonfun$lazyAppendedAll$1(var$0.$_0204, var$0.$_150);
    };
    function sci_LazyList$appended$lambda$_58_2() {
        jl_Object.call(this);
        this.$_0202 = null;
    }
    $java.sci_LazyList$appended$lambda$_58_2_apply = function(var$0) {
        var var$1;
        var$1 = var$0.$_0202;
        sci_LazyList$_$callClinit();
        return sci_LazyList$State$Cons__init_(var$1, sci_LazyList$_empty(sci_LazyList$_MODULE$));
    };
    function sci_LazyList$prepended$lambda$_67_0() {
        var a = this; jl_Object.call(a);
        a.$_0199 = null;
        a.$_147 = null;
    }
    $java.sci_LazyList$prepended$lambda$_67_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0199;
        var$2 = var$0.$_147;
        sci_LazyList$_$callClinit();
        return sci_LazyList$State$Cons__init_(var$2, var$1);
    };
    function sci_LazyList$flatten$lambda$_76_0() {
        var a = this; jl_Object.call(a);
        a.$_0196 = null;
        a.$_144 = null;
    }
    $java.sci_LazyList$flatten$lambda$_76_0_apply = function(var$0) {
        return sci_LazyList$_$anonfun$flatMapImpl$1(var$0.$_0196, var$0.$_144);
    };
    function sci_LazyList$filter$lambda$_64_0() {
        var a = this; jl_Object.call(a);
        a.$_0201 = null;
        a.$_149 = null;
        a.$_222 = 0;
    }
    $java.sci_LazyList$filter$lambda$_64_0_apply = function(var$0) {
        return sci_LazyList$_$anonfun$filterImpl$1(var$0.$_0201, var$0.$_149, var$0.$_222);
    };
    function sci_LazyList$appendedAll$lambda$_57_0() {
        jl_Object.call(this);
        this.$_0205 = null;
    }
    $java.sci_LazyList$appendedAll$lambda$_57_0_apply = function(var$0) {
        return var$0.$_0205;
    };
    function sci_LazyList$appendedAll$lambda$_57_1() {
        var a = this; jl_Object.call(a);
        a.$_0206 = null;
        a.$_151 = null;
    }
    $java.sci_LazyList$appendedAll$lambda$_57_1_apply = function(var$0) {
        return sci_LazyList_$anonfun$lazyAppendedAll$1(var$0.$_0206, var$0.$_151);
    };
    function sci_LazyList$filterNot$lambda$_65_0() {
        var a = this; jl_Object.call(a);
        a.$_0200 = null;
        a.$_148 = null;
        a.$_221 = 0;
    }
    $java.sci_LazyList$filterNot$lambda$_65_0_apply = function(var$0) {
        return sci_LazyList$_$anonfun$filterImpl$1(var$0.$_0200, var$0.$_148, var$0.$_221);
    };
    function sci_LazyList$takeWhile$lambda$_91_0() {
        var a = this; jl_Object.call(a);
        a.$_0193 = null;
        a.$_141 = null;
    }
    $java.sci_LazyList$takeWhile$lambda$_91_0_apply = function(var$0) {
        return sci_LazyList_$anonfun$takeWhileImpl$1(var$0.$_0193, var$0.$_141);
    };
    function sci_LazyList$dropWhile$lambda$_86_0() {
        var a = this; jl_Object.call(a);
        a.$_0195 = null;
        a.$_143 = null;
    }
    $java.sci_LazyList$dropWhile$lambda$_86_0_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0195;
        var$2 = var$0.$_143;
        sci_LazyList$_$callClinit();
        var$3 = var$1.$elem5;
        while (!sci_LazyList_isEmpty(var$3) && sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply(var$2, sci_LazyList_head(var$3)))) {
            var$3 = sci_LazyList_tail(var$3);
            var$1.$elem5 = var$3;
        }
        return sci_LazyList_scala$collection$immutable$LazyList$$state(var$3);
    };
    function sci_LazyList$zip$lambda$_77_0() {
        var a = this; jl_Object.call(a);
        a.$_0189 = null;
        a.$_137 = null;
    }
    $java.sci_LazyList$zip$lambda$_77_0_apply = function(var$0) {
        return sci_LazyList_zipState(var$0.$_0189, var$0.$_137.$iterator0());
    };
    var oncias_SemanticState$symbolTypes$lambda$_27_0 = $rt_classWithoutFields();
    $java.oncias_SemanticState$symbolTypes$lambda$_27_0_apply = function(var$0, var$1) {
        return var$1.$types1;
    };
    var oncias_SemanticState$symbolTypes$lambda$_27_1 = $rt_classWithoutFields();
    $java.oncias_SemanticState$symbolTypes$lambda$_27_1_apply = function(var$0) {
        oncius_TypeSpec$_$callClinit();
        return $java.oncius_TypeSpec$_all(oncius_TypeSpec$_MODULE$);
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1 = function() {
        var a = this; sr_AbstractPartialFunction.call(a);
        a.$$outer36 = null;
        a.$variable$3 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1_applyOrElse = function($this, $x1, $default) {
        var var$3, $id, $other, $name, $namespace, $functionName;
        var$3 = 0;
        $default = null;
        if ($x1 instanceof oncie_Equals) {
            var$3 = 1;
            $default = $x1;
            $id = $java.oncie_Equals_lhs($default);
            $other = $java.oncie_Equals_rhs($default);
            if ($id instanceof oncie_Property) {
                $name = $id;
                $id = oncie_Property_map($name);
                $name = oncie_Property_propertyKey($name);
                if ($id instanceof oncie_Variable) {
                    $id = oncie_Variable_name($id);
                    if ($name !== null)
                        a: {
                            b: {
                                $name = $java.oncie_PropertyKeyName_name($name);
                                $namespace = $this.$variable$3;
                                if ($id !== null) {
                                    if (!jl_String_equals($id, $namespace))
                                        break a;
                                    else
                                        break b;
                                }
                                if ($namespace !== null)
                                    break a;
                            }
                            if ($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$applicable($this.$$outer36, $other))
                                return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10__init_($name);
                        }
                }
            }
        }
        if (var$3) {
            $other = $java.oncie_Equals_lhs($default);
            $default = $java.oncie_Equals_rhs($default);
            if ($default instanceof oncie_Property) {
                $default = $default;
                $id = oncie_Property_map($default);
                $default = oncie_Property_propertyKey($default);
                if ($id instanceof oncie_Variable) {
                    $id = oncie_Variable_name($id);
                    if ($default !== null)
                        c: {
                            d: {
                                $name = $java.oncie_PropertyKeyName_name($default);
                                $default = $this.$variable$3;
                                if ($id !== null) {
                                    if (!jl_String_equals($id, $default))
                                        break c;
                                    else
                                        break d;
                                }
                                if ($default !== null)
                                    break c;
                            }
                            if ($java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$applicable($this.$$outer36, $other))
                                return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9__init_($name);
                        }
                }
            }
        }
        if ($x1 instanceof oncie_In) {
            $default = $java.oncie_In_lhs($x1);
            if ($default instanceof oncie_Property) {
                $default = $default;
                $id = oncie_Property_map($default);
                $default = oncie_Property_propertyKey($default);
                if ($id instanceof oncie_Variable) {
                    $id = oncie_Variable_name($id);
                    if ($default !== null)
                        e: {
                            f: {
                                $name = $java.oncie_PropertyKeyName_name($default);
                                $default = $this.$variable$3;
                                if ($id !== null) {
                                    if (!jl_String_equals($id, $default))
                                        break e;
                                    else
                                        break f;
                                }
                                if ($default !== null)
                                    break e;
                            }
                            return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0__init_($name);
                        }
                }
            }
        }
        if ($x1 instanceof oncie_IsNotNull) {
            $default = oncie_IsNotNull_lhs($x1);
            if ($default instanceof oncie_Property) {
                $default = $default;
                $id = oncie_Property_map($default);
                $default = oncie_Property_propertyKey($default);
                if ($id instanceof oncie_Variable) {
                    $id = oncie_Variable_name($id);
                    if ($default !== null)
                        g: {
                            h: {
                                $name = $java.oncie_PropertyKeyName_name($default);
                                $default = $this.$variable$3;
                                if ($id !== null) {
                                    if (!jl_String_equals($id, $default))
                                        break g;
                                    else
                                        break h;
                                }
                                if ($default !== null)
                                    break g;
                            }
                            return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1__init_($name);
                        }
                }
            }
        }
        if ($x1 instanceof oncie_StartsWith) {
            $default = $java.oncie_StartsWith_lhs($x1);
            if ($default instanceof oncie_Property) {
                $default = $default;
                $id = oncie_Property_map($default);
                $default = oncie_Property_propertyKey($default);
                if ($id instanceof oncie_Variable) {
                    $id = oncie_Variable_name($id);
                    if ($default !== null)
                        i: {
                            j: {
                                $name = $java.oncie_PropertyKeyName_name($default);
                                $default = $this.$variable$3;
                                if ($id !== null) {
                                    if (!jl_String_equals($id, $default))
                                        break i;
                                    else
                                        break j;
                                }
                                if ($default !== null)
                                    break i;
                            }
                            return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2__init_($name);
                        }
                }
            }
        }
        if ($x1 instanceof oncie_EndsWith) {
            $default = $java.oncie_EndsWith_lhs($x1);
            if ($default instanceof oncie_Property) {
                $default = $default;
                $id = oncie_Property_map($default);
                $default = oncie_Property_propertyKey($default);
                if ($id instanceof oncie_Variable) {
                    $id = oncie_Variable_name($id);
                    if ($default !== null)
                        k: {
                            l: {
                                $name = $java.oncie_PropertyKeyName_name($default);
                                $default = $this.$variable$3;
                                if ($id !== null) {
                                    if (!jl_String_equals($id, $default))
                                        break k;
                                    else
                                        break l;
                                }
                                if ($default !== null)
                                    break k;
                            }
                            return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3__init_($name);
                        }
                }
            }
        }
        if ($x1 instanceof oncie_Contains) {
            $default = $java.oncie_Contains_lhs($x1);
            if ($default instanceof oncie_Property) {
                $default = $default;
                $id = oncie_Property_map($default);
                $default = oncie_Property_propertyKey($default);
                if ($id instanceof oncie_Variable) {
                    $id = oncie_Variable_name($id);
                    if ($default !== null)
                        m: {
                            n: {
                                $name = $java.oncie_PropertyKeyName_name($default);
                                $default = $this.$variable$3;
                                if ($id !== null) {
                                    if (!jl_String_equals($id, $default))
                                        break m;
                                    else
                                        break n;
                                }
                                if ($default !== null)
                                    break m;
                            }
                            return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4__init_($name);
                        }
                }
            }
        }
        if ($x1 instanceof oncie_FunctionInvocation) {
            $default = $x1;
            $id = oncie_FunctionInvocation_namespace($default);
            $other = oncie_FunctionInvocation_functionName($default);
            $name = oncie_FunctionInvocation_args($default);
            if ($id !== null) {
                $default = oncie_Namespace_parts($id);
                if ($default !== null) {
                    s_package$_$callClinit();
                    $id = sci_List$_unapplySeq(s_package$_List0(s_package$_MODULE$), $default);
                    if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $id)) {
                        sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $id));
                        $default = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                        if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($default, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($default, $id), 1)) {
                            $default = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                            $namespace = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($default, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($default, $id), 0);
                            if ($other !== null) {
                                $functionName = oncie_FunctionName_name($other);
                                if ($name !== null) {
                                    $default = sc_SeqFactory$Delegate_unapplySeq(s_package$_Seq(s_package$_MODULE$), $name);
                                    if (!sc_SeqFactory$UnapplySeqWrapper$_isEmpty$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $default)) {
                                        sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension(sc_SeqFactory$UnapplySeqWrapper$_MODULE$, $default));
                                        $id = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                        if (!sc_SeqFactory$UnapplySeqWrapper$_lengthCompare$extension($id, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($id, $default), 3)) {
                                            $id = sc_SeqFactory$UnapplySeqWrapper$_MODULE$;
                                            $default = $java.sc_SeqFactory$UnapplySeqWrapper$_apply$extension($id, $java.sc_SeqFactory$UnapplySeqWrapper$_get$extension($id, $default), 0);
                                            if ($default instanceof oncie_Property) {
                                                $default = $default;
                                                $id = oncie_Property_map($default);
                                                $default = oncie_Property_propertyKey($default);
                                                if ($id instanceof oncie_Variable) {
                                                    $id = oncie_Variable_name($id);
                                                    if ($default !== null)
                                                        o: {
                                                            p: {
                                                                $name = $java.oncie_PropertyKeyName_name($default);
                                                                $default = $this.$variable$3;
                                                                if ($id !== null) {
                                                                    if (!jl_String_equals($id, $default))
                                                                        break o;
                                                                    else
                                                                        break p;
                                                                }
                                                                if ($default !== null)
                                                                    break o;
                                                            }
                                                            if (jl_String_equalsIgnoreCase($namespace, $rt_s(2472)) && jl_String_equalsIgnoreCase($functionName, $rt_s(3325)))
                                                                return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8__init_($name);
                                                        }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        if ($rt_isInstance($x1, $java.oncie_InequalityExpression))
            return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5__init_($this, $x1);
        q: {
            if ($x1 instanceof oncia_Where) {
                var$3 = 1;
                break q;
            }
            if ($x1 instanceof oncie_And) {
                var$3 = 1;
                break q;
            }
            if ($x1 instanceof oncie_Ands) {
                var$3 = 1;
                break q;
            }
            if ($rt_isInstance($x1, sci_Set)) {
                var$3 = 1;
                break q;
            }
            if ($rt_isInstance($x1, sci_Seq)) {
                var$3 = 1;
                break q;
            }
            if ($x1 instanceof oncie_Or) {
                var$3 = 1;
                break q;
            }
            if ($x1 instanceof oncie_Ors) {
                var$3 = 1;
                break q;
            }
            if (!($x1 instanceof oncie_Not)) {
                var$3 = 0;
                break q;
            }
            var$3 = 1;
        }
        if (!var$3)
            return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7__init_();
        return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6__init_();
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1_$anonfun$applyOrElse$24 = function($$this, $acc, $expr) {
        var $name, $namespace, $functionName, $id, $name_0;
        if ($expr instanceof oncie_Property) {
            $name = $expr;
            $namespace = $name.$map11;
            $functionName = $name.$propertyKey0;
            if ($namespace instanceof oncie_Variable) {
                $id = $namespace.$name4;
                if ($functionName !== null)
                    a: {
                        b: {
                            $name_0 = $functionName.$name11;
                            $name = $$this.$variable$3;
                            if ($id !== null) {
                                if (!jl_String_equals($id, $name))
                                    break a;
                                else
                                    break b;
                            }
                            if ($name !== null)
                                break a;
                        }
                        return $acc.$appended($name_0);
                    }
            }
        }
        c: {
            if (!($expr instanceof oncie_FunctionInvocation))
                break c;
            $expr = $expr;
            $namespace = $expr.$namespace1;
            $functionName = $expr.$functionName0;
            $name = $expr.$args;
            if ($namespace === null)
                break c;
            $namespace = $namespace.$parts0;
            if ($namespace === null)
                break c;
            s_package$_$callClinit();
            s_package$_List0(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $namespace);
            if ($namespace.$lengthCompare(1))
                break c;
            $namespace = $namespace.$apply1(0);
            if ($functionName === null)
                break c;
            $functionName = $functionName.$name6;
            if ($name === null)
                break c;
            s_package$_Seq(s_package$_MODULE$);
            sc_SeqFactory$UnapplySeqWrapper__init_(new sc_SeqFactory$UnapplySeqWrapper, $name);
            if ($name.$lengthCompare(2))
                break c;
            $expr = $name.$apply1(0);
            if (!($expr instanceof oncie_Property))
                break c;
            $expr = $expr;
            $id = $expr.$map11;
            $name = $expr.$propertyKey0;
            if (!($id instanceof oncie_Variable))
                break c;
            $id = $id.$name4;
            if ($name === null)
                break c;
            d: {
                e: {
                    $name = $name.$name11;
                    $$this = $$this.$variable$3;
                    if ($id !== null) {
                        if (!jl_String_equals($id, $$this))
                            break d;
                        else
                            break e;
                    }
                    if ($$this !== null)
                        break d;
                }
                if (jl_String_equalsIgnoreCase($namespace, $rt_s(2472)) && jl_String_equalsIgnoreCase($functionName, $rt_s(3107)))
                    return $acc.$appended($name);
            }
        }
        return $acc;
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_0 = function() {
        jl_Object.call(this);
        this.$_0870 = null;
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0870;
        return $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates(var$2.$$outer35, var$2.$variable$2, var$1);
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_1 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_1_apply = function(var$0) {
        s_package$_$callClinit();
        return sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_0 = function() {
        jl_Object.call(this);
        this.$_0871 = null;
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0871;
        return $java.oncia_Match_org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates(var$2.$$outer35, var$2.$variable$2, var$1);
    };
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_1 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_1_apply = function(var$0) {
        s_package$_$callClinit();
        return sc_SeqFactory$Delegate_empty(s_package$_Seq(s_package$_MODULE$));
    };
    function sc_SeqView$Map() {
        var a = this; sc_View$Map.call(a);
        a.$underlying10 = null;
        a.$f4 = null;
    }
    $java.sc_SeqView$Map_stringPrefix = function($this) {
        return $rt_s(509);
    };
    $java.sc_SeqView$Map_scala$collection$SeqOps$$super$concat = function($this, $suffix) {
        return sc_IterableOps_concat$($this, $suffix);
    };
    $java.sc_SeqView$Map_scala$collection$SeqOps$$super$sizeCompare = function($this, $otherSize) {
        return sc_IterableOps_sizeCompare$($this, $otherSize);
    };
    $java.sc_SeqView$Map_$colon$plus = function($this, $elem) {
        return $this.$appended($elem);
    };
    $java.sc_SeqView$Map_appendedAll = function($this, $suffix) {
        return $this.$scala$collection$SeqOps$$super$concat($suffix);
    };
    $java.sc_SeqView$Map_concat = function($this, $suffix) {
        return $this.$appendedAll($suffix);
    };
    $java.sc_SeqView$Map_size = function($this) {
        return $this.$length();
    };
    $java.sc_SeqView$Map_distinct = function($this) {
        return sc_SeqOps_distinct$($this);
    };
    $java.sc_SeqView$Map_distinctBy = function($this, $f) {
        return sc_SeqOps_distinctBy$($this, $f);
    };
    $java.sc_SeqView$Map_lengthCompare = function($this, $len) {
        return $this.$scala$collection$SeqOps$$super$sizeCompare($len);
    };
    $java.sc_SeqView$Map_isEmpty = function($this) {
        return sc_SeqOps_isEmpty$($this);
    };
    $java.sc_SeqView$Map_apply = function($this, $idx) {
        return $this.$f4.$apply($this.$underlying10.$apply1($idx));
    };
    $java.sc_SeqView$Map_length = function($this) {
        return $this.$underlying10.$length();
    };
    $java.sc_SeqView$Map_appended = function($this, $elem) {
        return sc_SeqView_appended$($this, $elem);
    };
    $java.sc_SeqView$Map_map = function($this, $f) {
        return sc_SeqView_map$($this, $f);
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$withState$2$lambda$_81_0 = function() {
        jl_Object.call(this);
        this.$_0872 = null;
    };
    $java.oncias_SemanticAnalysisTooling$$anonfun$withState$2$lambda$_81_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0872;
        return oncias_SemanticCheckResult__init_(var$2.$state, var$1.$errors);
    };
    $java.oncias_SemanticAnalysisTooling$declareVariables$lambda$_65_0 = function() {
        jl_Object.call(this);
        this.$_0868 = null;
    };
    $java.oncias_SemanticAnalysisTooling$declareVariables$lambda$_65_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0868;
        return $java.oncias_package$_liftSemanticEitherFunc(oncias_package$_MODULE$, oncias_SemanticAnalysisTooling_declareVariable$(var$2, $java.oncias_SymbolUse_asVariable(var$1.$definition), var$1.$types1));
    };
    function sci_LazyList$LazyBuilder() {
        var a = this; jl_Object.call(a);
        a.$next5 = null;
        a.$list0 = null;
    }
    $java.sci_LazyList$LazyBuilder_sizeHint = function($this, $size) {};
    $java.sci_LazyList$LazyBuilder_sizeHint0 = function($this, $coll, $delta) {
        scm_Builder_sizeHint$($this, $coll, $delta);
    };
    $java.sci_LazyList$LazyBuilder_addAll = function($this, $xs) {
        var var$2, var$3, var$4;
        if ($xs.$length()) {
            var$2 = new sci_LazyList$LazyBuilder$DeferredState;
            var$3 = $this.$next5;
            var$4 = new $java.sci_LazyList$LazyBuilder$addAll$lambda$_12_0;
            var$4.$_0873 = $xs;
            var$4.$_1300 = var$2;
            $java.sci_LazyList$LazyBuilder$DeferredState_init(var$3, var$4);
            $this.$next5 = var$2;
        }
        return $this;
    };
    $java.sci_LazyList$LazyBuilder_addOne = function($this, $elem) {
        var var$2, var$3, var$4;
        var$2 = new sci_LazyList$LazyBuilder$DeferredState;
        var$3 = $this.$next5;
        var$4 = new $java.sci_LazyList$LazyBuilder$addOne$lambda$_11_0;
        var$4.$_0874 = $elem;
        var$4.$_1301 = var$2;
        $java.sci_LazyList$LazyBuilder$DeferredState_init(var$3, var$4);
        $this.$next5 = var$2;
        return $this;
    };
    $java.sci_LazyList$LazyBuilder_result = function($this) {
        $java.sci_LazyList$LazyBuilder$DeferredState_init($this.$next5, new $java.sci_LazyList$LazyBuilder$result$lambda$_10_0);
        return $this.$list0;
    };
    function sr_IntRef() {
        jl_Object.call(this);
        this.$elem6 = 0;
    }
    function sci_LazyList$$scala$collection$immutable$LazyList$$dropImpl$lambda$_21_0() {
        var a = this; jl_Object.call(a);
        a.$_0191 = null;
        a.$_139 = null;
    }
    $java.sci_LazyList$$scala$collection$immutable$LazyList$$dropImpl$lambda$_21_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0191;
        var$2 = var$0.$_139;
        sci_LazyList$_$callClinit();
        var$3 = var$1.$elem5;
        var$4 = var$2.$elem6;
        while (var$4 > 0 && !sci_LazyList_isEmpty(var$3)) {
            var$3 = sci_LazyList_tail(var$3);
            var$1.$elem5 = var$3;
            var$4 = var$4 + (-1) | 0;
            var$2.$elem6 = var$4;
        }
        return sci_LazyList_scala$collection$immutable$LazyList$$state(var$3);
    };
    function sci_LazyList$$scala$collection$immutable$LazyList$$collectImpl$lambda$_19_0() {
        var a = this; jl_Object.call(a);
        a.$_0181 = null;
        a.$_132 = null;
    }
    $java.sci_LazyList$$scala$collection$immutable$LazyList$$collectImpl$lambda$_19_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4, var$5, var$6;
        var$1 = var$0.$_0181;
        var$2 = var$0.$_132;
        sci_LazyList$_$callClinit();
        var$3 = sr_Statics_pfMarker;
        var$4 = sci_LazyList$_scala$collection$immutable$LazyList$$anyToMarker0(sci_LazyList$_MODULE$);
        var$5 = var$1.$elem5;
        var$6 = var$3;
        while (var$6 === var$3 && !sci_LazyList_isEmpty(var$5)) {
            var$6 = var$2.$applyOrElse(sci_LazyList_head(var$5), var$4);
            var$5 = sci_LazyList_tail(var$5);
            var$1.$elem5 = var$5;
        }
        return var$6 === var$3 ? sci_LazyList$State$Empty$_MODULE$ : sci_LazyList$State$Cons__init_(var$6, sci_LazyList$_scala$collection$immutable$LazyList$$collectImpl(sci_LazyList$_MODULE$, var$5, var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0 = function() {
        jl_Object.call(this);
        this.$_0875 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0__init_0 = function(var$0, var$1) {
        var$0.$_0875 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0875;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1 = function() {
        jl_Object.call(this);
        this.$_0876 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1__init_0 = function(var$0, var$1) {
        var$0.$_0876 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0876;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2 = function() {
        jl_Object.call(this);
        this.$_0877 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2__init_0 = function(var$0, var$1) {
        var$0.$_0877 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0877;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3 = function() {
        jl_Object.call(this);
        this.$_0878 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3__init_0 = function(var$0, var$1) {
        var$0.$_0878 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0878;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4 = function() {
        jl_Object.call(this);
        this.$_0879 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4__init_0 = function(var$0, var$1) {
        var$0.$_0879 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0879;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5 = function() {
        var a = this; jl_Object.call(a);
        a.$_0880 = null;
        a.$_1302 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5__init_ = function(var_0, var_1) {
        var var_2 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5__init_0(var_2, var_0, var_1);
        return var_2;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5__init_0 = function(var$0, var$1, var$2) {
        var$0.$_0880 = var$1;
        var$0.$_1302 = var$2;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5_apply = function(var$0, var$1) {
        var var$2, var$3, var$4;
        var$1 = var$1;
        var$2 = var$0.$_0880;
        var$3 = var$0.$_1302;
        var$4 = sci_$colon$colon__init_(var$3.$lhs0(), sci_$colon$colon__init_(var$3.$rhs0(), sci_Nil$_MODULE$));
        var$3 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$$anonfun$applyOrElse$23$lambda$_11_0;
        var$3.$_0881 = var$2;
        return $java.onciu_Foldable$SkipChildren__init_(sc_LinearSeqOps_foldLeft$(var$4, var$1, var$3));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7__init_ = function() {
        var var_0 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7__init_0(var_0);
        return var_0;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7__init_0 = function(var$0) {};
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$SkipChildren__init_(var$1);
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6__init_ = function() {
        var var_0 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6__init_0(var_0);
        return var_0;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6__init_0 = function(var$0) {};
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6_apply = function(var$0, var$1) {
        return $java.onciu_Foldable$TraverseChildren__init_0(var$1);
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8 = function() {
        jl_Object.call(this);
        this.$_0882 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8__init_0 = function(var$0, var$1) {
        var$0.$_0882 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0882;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9 = function() {
        jl_Object.call(this);
        this.$_0883 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9__init_0 = function(var$0, var$1) {
        var$0.$_0883 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0883;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10 = function() {
        jl_Object.call(this);
        this.$_0884 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10__init_ = function(var_0) {
        var var_1 = new $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10();
        $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10__init_0(var_1, var_0);
        return var_1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10__init_0 = function(var$0, var$1) {
        var$0.$_0884 = var$1;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10_apply = function(var$0, var$1) {
        var var$2;
        var$1 = var$1;
        var$2 = var$0.$_0884;
        return $java.onciu_Foldable$SkipChildren__init_(var$1.$appended(var$2));
    };
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression$lambda$_78_0 = $rt_classWithoutFields();
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression$lambda$_78_0_apply = function(var$0, var$1) {
        return var$1.$name3();
    };
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap$lambda$_74_0 = $rt_classWithoutFields();
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap$lambda$_74_0_apply = function(var$0, var$1) {
        return var$1.$_10.$name11;
    };
    function sci_LazyList$$anonfun$mapImpl$1$lambda$_161_0() {
        var a = this; jl_Object.call(a);
        a.$_0208 = null;
        a.$_153 = null;
    }
    $java.sci_LazyList$$anonfun$mapImpl$1$lambda$_161_0_apply = function(var$0) {
        return sci_LazyList_$anonfun$mapImpl$1(var$0.$_0208, var$0.$_153);
    };
    function sci_LazyList$$$anonfun$flatMapImpl$1$lambda$_52_0() {
        var a = this; jl_Object.call(a);
        a.$_0187 = null;
        a.$_135 = null;
        a.$_220 = null;
    }
    $java.sci_LazyList$$$anonfun$flatMapImpl$1$lambda$_52_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0187;
        var$2 = var$0.$_135;
        var$3 = var$0.$_220;
        sci_LazyList$_$callClinit();
        var$1 = var$1.$elem5;
        var$4 = new $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_0;
        var$4.$_0885 = var$2;
        var$4.$_1303 = var$3;
        if (var$1.$hasNext()) {
            var$2 = var$1.$next();
            var$3 = new $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_2;
            var$3.$_0886 = var$1;
            var$3.$_1304 = var$4;
            var$1 = sci_LazyList$State$Cons__init_(var$2, sci_LazyList__init_(var$3));
        } else {
            var$2 = sr_ObjectRef__init_(var$2.$elem5);
            var$1 = new $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_1;
            var$1.$_0887 = var$2;
            var$1.$_1305 = var$3;
            var$1 = sci_LazyList_scala$collection$immutable$LazyList$$state(sci_LazyList__init_(var$1));
        }
        return var$1;
    };
    function sci_LazyList$$anonfun$lazyAppendedAll$1$lambda$_147_0() {
        var a = this; jl_Object.call(a);
        a.$_0207 = null;
        a.$_152 = null;
    }
    $java.sci_LazyList$$anonfun$lazyAppendedAll$1$lambda$_147_0_apply = function(var$0) {
        return sci_LazyList_$anonfun$lazyAppendedAll$1(var$0.$_0207, var$0.$_152);
    };
    function sci_LazyList$$$anonfun$filterImpl$1$lambda$_48_0() {
        var a = this; jl_Object.call(a);
        a.$_0186 = null;
        a.$_134 = null;
        a.$_219 = 0;
    }
    $java.sci_LazyList$$$anonfun$filterImpl$1$lambda$_48_0_apply = function(var$0) {
        return sci_LazyList$_$anonfun$filterImpl$1(var$0.$_0186, var$0.$_134, var$0.$_219);
    };
    function sci_LazyList$$anonfun$takeWhileImpl$1$lambda$_179_0() {
        var a = this; jl_Object.call(a);
        a.$_0210 = null;
        a.$_155 = null;
    }
    $java.sci_LazyList$$anonfun$takeWhileImpl$1$lambda$_179_0_apply = function(var$0) {
        return sci_LazyList_$anonfun$takeWhileImpl$1(var$0.$_0210, var$0.$_155);
    };
    $java.oncia_Match$$anonfun$10$$anonfun$applyOrElse$29$lambda$_3_0 = $rt_classWithoutFields();
    $java.oncia_Match$$anonfun$10$$anonfun$applyOrElse$31$lambda$_5_0 = $rt_classWithoutFields();
    function sc_SeqView$Appended() {
        var a = this; sc_View$Appended.call(a);
        a.$underlying11 = null;
        a.$elem0 = null;
    }
    $java.sc_SeqView$Appended_stringPrefix = function($this) {
        return $rt_s(509);
    };
    $java.sc_SeqView$Appended_scala$collection$SeqOps$$super$concat = function($this, $suffix) {
        return sc_IterableOps_concat$($this, $suffix);
    };
    $java.sc_SeqView$Appended_scala$collection$SeqOps$$super$sizeCompare = function($this, $otherSize) {
        return sc_IterableOps_sizeCompare$($this, $otherSize);
    };
    $java.sc_SeqView$Appended_$colon$plus = function($this, $elem) {
        return $this.$appended($elem);
    };
    $java.sc_SeqView$Appended_appendedAll = function($this, $suffix) {
        return $this.$scala$collection$SeqOps$$super$concat($suffix);
    };
    $java.sc_SeqView$Appended_concat = function($this, $suffix) {
        return $this.$appendedAll($suffix);
    };
    $java.sc_SeqView$Appended_size = function($this) {
        return $this.$length();
    };
    $java.sc_SeqView$Appended_distinct = function($this) {
        return sc_SeqOps_distinct$($this);
    };
    $java.sc_SeqView$Appended_distinctBy = function($this, $f) {
        return sc_SeqOps_distinctBy$($this, $f);
    };
    $java.sc_SeqView$Appended_lengthCompare = function($this, $len) {
        return $this.$scala$collection$SeqOps$$super$sizeCompare($len);
    };
    $java.sc_SeqView$Appended_isEmpty = function($this) {
        return sc_SeqOps_isEmpty$($this);
    };
    $java.sc_SeqView$Appended_apply = function($this, $idx) {
        if ($idx == $this.$underlying11.$length())
            return $this.$elem0;
        return $this.$underlying11.$apply1($idx);
    };
    $java.sc_SeqView$Appended_length = function($this) {
        return $this.$underlying11.$length() + 1 | 0;
    };
    $java.sc_SeqView$Appended_appended = function($this, $elem) {
        return sc_SeqView_appended$($this, $elem);
    };
    $java.sc_SeqView$Appended_map = function($this, $f) {
        return sc_SeqView_map$($this, $f);
    };
    function sc_Iterator$$anon$11() {
        var a = this; sc_AbstractIterator.call(a);
        a.$hd2 = null;
        a.$hdDefined0 = 0;
        a.$tail2 = null;
        a.$p$2 = null;
    }
    $java.sc_Iterator$$anon$11_hasNext = function($this) {
        var var$1;
        a: {
            if (!$this.$hdDefined0) {
                if (!$this.$tail2.$hasNext())
                    break a;
                var$1 = $this.$tail2.$next();
                $this.$hd2 = var$1;
                if (!sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply($this.$p$2, var$1)))
                    $this.$tail2 = sc_Iterator$_scala$collection$Iterator$$_empty;
                else
                    $this.$hdDefined0 = 1;
                if (!$this.$hdDefined0)
                    break a;
            }
            return 1;
        }
        return 0;
    };
    $java.sc_Iterator$$anon$11_next = function($this) {
        if (!$java.sc_Iterator$$anon$11_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        $this.$hdDefined0 = 0;
        return $this.$hd2;
    };
    function sc_Iterator$$anon$12() {
        var a = this; sc_AbstractIterator.call(a);
        a.$status0 = 0;
        a.$fst = null;
        a.$$outer12 = null;
        a.$p$3 = null;
    }
    $java.sc_Iterator$$anon$12_hasNext = function($this) {
        var var$1, $a;
        var$1 = $this.$status0;
        if (var$1 == 1)
            return $this.$$outer12.$hasNext();
        if (!var$1)
            return 1;
        while ($this.$$outer12.$hasNext()) {
            $a = $this.$$outer12.$next();
            if (sr_BoxesRunTime_unboxToBoolean(oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0_apply($this.$p$3, $a)))
                continue;
            else {
                $this.$fst = $a;
                $this.$status0 = 0;
                return 1;
            }
        }
        $this.$status0 = 1;
        return 0;
    };
    $java.sc_Iterator$$anon$12_next = function($this) {
        if (!$java.sc_Iterator$$anon$12_hasNext($this))
            return sc_Iterator$$anon$19_next(sc_Iterator$_scala$collection$Iterator$$_empty);
        if ($this.$status0 == 1)
            return $this.$$outer12.$next();
        $this.$status0 = 1;
        return $this.$fst;
    };
    function sci_LazyList$dropRightState$lambda$_88_0() {
        var a = this; jl_Object.call(a);
        a.$_0192 = null;
        a.$_140 = null;
    }
    $java.sci_LazyList$dropRightState$lambda$_88_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0192;
        var$2 = var$0.$_140;
        return sci_LazyList_dropRightState(sci_LazyList_tail(var$1), sci_LazyList_tail(var$2));
    };
    function sci_LazyList$zipState$lambda$_78_0() {
        var a = this; jl_Object.call(a);
        a.$_0190 = null;
        a.$_138 = null;
    }
    $java.sci_LazyList$zipState$lambda$_78_0_apply = function(var$0) {
        var var$1, var$2;
        var$1 = var$0.$_0190;
        var$2 = var$0.$_138;
        return sci_LazyList_zipState(sci_LazyList_tail(var$1), var$2);
    };
    $java.sci_LazyList$take$lambda$_89_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0869 = null;
        a.$_1299 = 0;
    };
    $java.sci_LazyList$take$lambda$_89_0_apply = function(var$0) {
        return sci_LazyList_$anonfun$takeImpl$1(var$0.$_0869, var$0.$_1299);
    };
    function sci_LazyList$LazyBuilder$DeferredState() {
        jl_Object.call(this);
        this.$_state = null;
    }
    $java.sci_LazyList$LazyBuilder$DeferredState_eval = function($this) {
        var $state, var$2;
        $state = $this.$_state;
        if ($state !== null)
            return $state.$apply2();
        var$2 = new jl_IllegalStateException;
        jl_Throwable__init_(var$2, $rt_s(3326));
        $rt_throw(var$2);
    };
    $java.sci_LazyList$LazyBuilder$DeferredState_init = function($this, $state) {
        var var$2;
        if ($this.$_state === null) {
            $this.$_state = $state;
            return;
        }
        var$2 = new jl_IllegalStateException;
        jl_Throwable__init_(var$2, $rt_s(3327));
        $rt_throw(var$2);
    };
    function sci_LazyList$LazyBuilder$clear$lambda$_9_0() {
        jl_Object.call(this);
        this.$_0185 = null;
    }
    $java.sci_LazyList$LazyBuilder$clear$lambda$_9_0_apply = function(var$0) {
        return $java.sci_LazyList$LazyBuilder$DeferredState_eval(var$0.$_0185);
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0885 = null;
        a.$_1303 = null;
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_0_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0885;
        var$2 = var$0.$_1303;
        sci_LazyList$_$callClinit();
        var$1 = var$1.$elem5;
        var$3 = sr_ObjectRef__init_(var$1);
        var$1 = new $java.sci_LazyList$$$anonfun$flatMapImpl$3$lambda$_50_0;
        var$1.$_0888 = var$3;
        var$1.$_1306 = var$2;
        return sci_LazyList_scala$collection$immutable$LazyList$$state(sci_LazyList__init_(var$1));
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0887 = null;
        a.$_1305 = null;
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_1_apply = function(var$0) {
        return sci_LazyList$_$anonfun$flatMapImpl$1(var$0.$_0887, var$0.$_1305);
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_2 = function() {
        var a = this; jl_Object.call(a);
        a.$_0886 = null;
        a.$_1304 = null;
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_2_apply = function(var$0) {
        return sci_LazyList$_$anonfun$stateFromIteratorConcatSuffix$1(var$0.$_0886, var$0.$_1304);
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$$anonfun$applyOrElse$23$lambda$_11_0 = function() {
        jl_Object.call(this);
        this.$_0881 = null;
    };
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$$anonfun$applyOrElse$23$lambda$_11_0_apply = function(var$0, var$1, var$2) {
        var$1 = var$1;
        var$2 = var$2;
        return $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1_$anonfun$applyOrElse$24(var$0.$_0881, var$1, var$2);
    };
    $java.sci_LazyList$LazyBuilder$addAll$lambda$_12_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0873 = null;
        a.$_1300 = null;
    };
    $java.sci_LazyList$LazyBuilder$addAll$lambda$_12_0_apply = function(var$0) {
        var var$1, var$2, var$3, var$4;
        var$1 = var$0.$_0873;
        var$2 = var$0.$_1300;
        var$3 = sc_IndexedSeqOps_iterator$(var$1);
        var$1 = new $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_0;
        var$1.$_0889 = var$2;
        if (!var$3.$hasNext())
            var$1 = $java.sci_LazyList$LazyBuilder$DeferredState_eval(var$2);
        else {
            var$2 = sc_IndexedSeqView$IndexedSeqViewIterator_next(var$3);
            var$4 = new $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_1;
            var$4.$_0890 = var$3;
            var$4.$_1307 = var$1;
            var$1 = sci_LazyList$State$Cons__init_(var$2, sci_LazyList__init_(var$4));
        }
        return var$1;
    };
    $java.sci_LazyList$LazyBuilder$result$lambda$_10_0 = $rt_classWithoutFields();
    $java.sci_LazyList$LazyBuilder$result$lambda$_10_0_apply = function(var$0) {
        return sci_LazyList$State$Empty$_MODULE$;
    };
    $java.sci_LazyList$LazyBuilder$addOne$lambda$_11_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0874 = null;
        a.$_1301 = null;
    };
    $java.sci_LazyList$LazyBuilder$addOne$lambda$_11_0_apply = function(var$0) {
        var var$1, var$2, var$3;
        var$1 = var$0.$_0874;
        var$2 = var$0.$_1301;
        var$3 = new $java.sci_LazyList$LazyBuilder$$anonfun$addOne$1$lambda$_19_0;
        var$3.$_0891 = var$2;
        return sci_LazyList$State$Cons__init_(var$1, sci_LazyList__init_(var$3));
    };
    function sci_LazyList$takeImpl$lambda$_90_0() {
        var a = this; jl_Object.call(a);
        a.$_0209 = null;
        a.$_154 = 0;
    }
    $java.sci_LazyList$takeImpl$lambda$_90_0_apply = function(var$0) {
        return sci_LazyList_$anonfun$takeImpl$1(var$0.$_0209, var$0.$_154);
    };
    function sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIteratorConcatSuffix$lambda$_27_0() {
        var a = this; jl_Object.call(a);
        a.$_0188 = null;
        a.$_136 = null;
    }
    $java.sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIteratorConcatSuffix$lambda$_27_0_apply = function(var$0) {
        return sci_LazyList$_$anonfun$stateFromIteratorConcatSuffix$1(var$0.$_0188, var$0.$_136);
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$3$lambda$_50_0 = function() {
        var a = this; jl_Object.call(a);
        a.$_0888 = null;
        a.$_1306 = null;
    };
    $java.sci_LazyList$$$anonfun$flatMapImpl$3$lambda$_50_0_apply = function(var$0) {
        return sci_LazyList$_$anonfun$flatMapImpl$1(var$0.$_0888, var$0.$_1306);
    };
    $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_0 = function() {
        jl_Object.call(this);
        this.$_0889 = null;
    };
    $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_0_apply = function(var$0) {
        return $java.sci_LazyList$LazyBuilder$DeferredState_eval(var$0.$_0889);
    };
    $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_1 = function() {
        var a = this; jl_Object.call(a);
        a.$_0890 = null;
        a.$_1307 = null;
    };
    $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_1_apply = function(var$0) {
        return sci_LazyList$_$anonfun$stateFromIteratorConcatSuffix$1(var$0.$_0890, var$0.$_1307);
    };
    $java.sci_LazyList$LazyBuilder$$anonfun$addOne$1$lambda$_19_0 = function() {
        jl_Object.call(this);
        this.$_0891 = null;
    };
    $java.sci_LazyList$LazyBuilder$$anonfun$addOne$1$lambda$_19_0_apply = function(var$0) {
        return $java.sci_LazyList$LazyBuilder$DeferredState_eval(var$0.$_0891);
    };
    $rt_packages([-1, "java", 0, "util", 1, "regex", 1, "stream", 0, "text", 0, "math", 0, "lang", 6, "reflect", 6, "invoke", -1, "org", 9, "neo4j", 10, "cypher", 11, "internal", 12, "ast", 13, "factory", 14, "neo4j", 13, "prettifier", 13, "semantics", 12, "parser", 18, "javacc", 12, "util", 20, "helpers", 20, "tailrec", 20, "symbols", 12, "rewriting", 24, "rewriters", 24, "conditions", 12, "label_expressions", 12, "expressions", 28, "functions", 12, "frontend", 30, "phases", 9, "teavm", 32, "classlib", 33, "impl",
    34, "unicode", 32, "interop", 32, "runtime", -1, "scala", 38, "util", 39, "control", 38, "runtime", 38, "collection", 42, "immutable", 42, "mutable", 42, "convert"
    ]);
    $rt_metadata([jl_Object, "Object", 6, 0, [], 0, 3, [0,0,0], 0, ["$hashCode0", $rt_wrapFunction0(jl_Object_hashCode), "$equals", $rt_wrapFunction1(jl_Object_equals), "$toString", $rt_wrapFunction0(jl_Object_toString)],
    ons_MainNodejs, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jlr_AnnotatedElement, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jlr_Type, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_Class, "Class", 6, jl_Object, [jlr_AnnotatedElement, jlr_Type], 0, 3, [0,0,0], 0, ["$toString", $rt_wrapFunction0(jl_Class_toString)],
    otji_JS, 0, jl_Object, [], 4, 0, 0, 0, 0,
    otp_Platform, 0, jl_Object, [], 4, 3, 0, 0, 0,
    ji_Serializable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_Comparable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_CharSequence, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_String, "String", 6, jl_Object, [ji_Serializable, jl_Comparable, jl_CharSequence], 0, 3, [0,0,0], 0, ["$charAt", $rt_wrapFunction1(jl_String_charAt), "$length", $rt_wrapFunction0(jl_String_length), "$toString", $rt_wrapFunction0(jl_String_toString), "$equals", $rt_wrapFunction1(jl_String_equals), "$hashCode0", $rt_wrapFunction0(jl_String_hashCode)],
    jl_Throwable, 0, jl_Object, [], 0, 3, 0, 0, ["$getMessage", $rt_wrapFunction0(jl_Throwable_getMessage)],
    jl_Error, 0, jl_Throwable, [], 0, 3, 0, 0, 0,
    jl_LinkageError, 0, jl_Error, [], 0, 3, 0, 0, 0,
    jl_NoClassDefFoundError, 0, jl_LinkageError, [], 0, 3, 0, 0, 0,
    jl_Number, 0, jl_Object, [ji_Serializable], 1, 3, 0, 0, 0,
    jl_Integer, "Integer", 6, jl_Number, [jl_Comparable], 0, 3, 0, 0, ["$intValue", $rt_wrapFunction0(jl_Integer_intValue), "$longValue", $rt_wrapFunction0(jl_Integer_longValue), "$floatValue", $rt_wrapFunction0(jl_Integer_floatValue), "$doubleValue", $rt_wrapFunction0(jl_Integer_doubleValue), "$toString", $rt_wrapFunction0(jl_Integer_toString1), "$hashCode0", $rt_wrapFunction0(jl_Integer_hashCode), "$equals", $rt_wrapFunction1(jl_Integer_equals)],
    jl_AbstractStringBuilder, 0, jl_Object, [ji_Serializable, jl_CharSequence], 0, 0, 0, 0, ["$ensureCapacity", $rt_wrapFunction1(jl_AbstractStringBuilder_ensureCapacity), "$toString", $rt_wrapFunction0(jl_AbstractStringBuilder_toString)],
    jl_Appendable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_StringBuilder, 0, jl_AbstractStringBuilder, [jl_Appendable], 0, 3, 0, 0, ["$insert3", $rt_wrapFunction4(jl_StringBuilder_insert), "$append6", $rt_wrapFunction3(jl_StringBuilder_append7), "$insert2", $rt_wrapFunction4(jl_StringBuilder_insert0), "$append5", $rt_wrapFunction3(jl_StringBuilder_append8), "$charAt", $rt_wrapFunction1(jl_StringBuilder_charAt), "$length", $rt_wrapFunction0(jl_StringBuilder_length), "$toString", $rt_wrapFunction0(jl_StringBuilder_toString), "$ensureCapacity", $rt_wrapFunction1(jl_StringBuilder_ensureCapacity),
    "$insert1", $rt_wrapFunction2(jl_StringBuilder_insert1), "$insert", $rt_wrapFunction2(jl_StringBuilder_insert2)],
    jl_IncompatibleClassChangeError, 0, jl_LinkageError, [], 0, 3, 0, 0, 0,
    jl_NoSuchFieldError, 0, jl_IncompatibleClassChangeError, [], 0, 3, 0, 0, 0,
    jl_NoSuchMethodError, 0, jl_IncompatibleClassChangeError, [], 0, 3, 0, 0, 0,
    jl_Exception, 0, jl_Throwable, [], 0, 3, 0, 0, 0,
    jl_RuntimeException, 0, jl_Exception, [], 0, 3, 0, 0, 0,
    otci_IntegerUtil, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_SemanticAnalyzer, 0, jl_Object, [], 4, 3, 0, 0, 0,
    jl_Iterable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_Collection, 0, jl_Object, [jl_Iterable], 3, 3, 0, 0, 0,
    ju_AbstractCollection, 0, jl_Object, [ju_Collection], 1, 3, 0, 0, ["$isEmpty", $rt_wrapFunction0(ju_AbstractCollection_isEmpty), "$toString", $rt_wrapFunction0(ju_AbstractCollection_toString)],
    ju_List, 0, jl_Object, [ju_Collection], 3, 3, 0, 0, 0,
    ju_AbstractList, 0, ju_AbstractCollection, [ju_List], 1, 3, 0, 0, ["$add", $rt_wrapFunction1(ju_AbstractList_add), "$iterator", $rt_wrapFunction0(ju_AbstractList_iterator), "$hashCode0", $rt_wrapFunction0(ju_AbstractList_hashCode), "$equals", $rt_wrapFunction1(ju_AbstractList_equals)],
    jl_Cloneable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_RandomAccess, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_ArrayList, "ArrayList", 1, ju_AbstractList, [jl_Cloneable, ji_Serializable, ju_RandomAccess], 0, 3, 0, 0, ["$get", $rt_wrapFunction1(ju_ArrayList_get), "$size", $rt_wrapFunction0(ju_ArrayList_size), "$toString", $rt_wrapFunction0(ju_ArrayList_toString)],
    oncifp_SemanticAnalyzer$SemanticErrors, 0, jl_Object, [], 3, 3, 0, 0, 0,
    s_Equals, 0, jl_Object, [], 3, 3, 0, 0, 0,
    s_Product, "Product", 38, jl_Object, [s_Equals], 3, 3, [0,0,0], 0, 0,
    oncifp_SemanticAnalyzer$SomeErrors, 0, jl_Exception, [oncifp_SemanticAnalyzer$SemanticErrors, s_Product], 0, 3, 0, 0, 0,
    s_Function1, 0, jl_Object, [], 3, 3, 0, 0, ["$toString", $rt_wrapFunction0(s_Function1_toString)],
    ons_MainNodejs$analyzeQuery$lambda$_2_0, 0, jl_Object, [s_Function1], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(ons_MainNodejs$analyzeQuery$lambda$_2_0_apply)],
    ju_Comparator, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_String$_clinit_$lambda$_84_0, 0, jl_Object, [ju_Comparator], 0, 3, 0, 0, 0,
    jl_Character, "Character", 6, jl_Object, [jl_Comparable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(jl_Character_toString), "$equals", $rt_wrapFunction1(jl_Character_equals), "$hashCode0", $rt_wrapFunction0(jl_Character_hashCode)],
    oncifp_SemanticAnalyzer$, 0, jl_Object, [], 4, 3, 0, oncifp_SemanticAnalyzer$_$callClinit, 0,
    oncifp_CompilationPhases$, 0, jl_Object, [], 4, 3, 0, oncifp_CompilationPhases$_$callClinit, 0,
    oncifp_CompilationPhases$ParsingConfig, 0, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    s_Function3, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sr_AbstractFunction3, 0, jl_Object, [s_Function3], 1, 3, 0, 0, 0,
    oncifp_CompilationPhases$ParsingConfig$, 0, sr_AbstractFunction3, [ji_Serializable], 0, 3, 0, 0, 0]);
    $rt_metadata([oncifp_BaseContext, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncifp_SemanticAnalyzer$$anon$1, 0, jl_Object, [oncifp_BaseContext], 4, 3, 0, 0, 0,
    onciu_ErrorMessageProvider, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncm_MessageUtilProvider$, 0, jl_Object, [onciu_ErrorMessageProvider], 4, 3, 0, 0, ["$createMissingPropertyLabelHintError", function(var_1, var_2, var_3, var_4, var_5, var_6, var_7) { return oncm_MessageUtilProvider$_createMissingPropertyLabelHintError(this, var_1, var_2, var_3, var_4, var_5, var_6, var_7); }, "$createUseClauseUnsupportedError", $rt_wrapFunction0(oncm_MessageUtilProvider$_createUseClauseUnsupportedError), "$createDynamicGraphReferenceUnsupportedError", $rt_wrapFunction0(oncm_MessageUtilProvider$_createDynamicGraphReferenceUnsupportedError),
    "$createMultipleGraphReferencesError", $rt_wrapFunction0(oncm_MessageUtilProvider$_createMultipleGraphReferencesError)],
    sc_IterableOnce, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sc_IterableOnceOps, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sc_IterableOps, 0, jl_Object, [sc_IterableOnce, sc_IterableOnceOps], 3, 3, 0, 0, 0,
    sc_IterableFactoryDefaults, 0, jl_Object, [sc_IterableOps], 3, 3, 0, 0, 0,
    sc_Iterable, 0, jl_Object, [sc_IterableFactoryDefaults], 3, 3, 0, 0, 0,
    sc_AbstractIterable, 0, jl_Object, [sc_Iterable], 1, 3, 0, 0, ["$iterableFactory", $rt_wrapFunction0(sc_AbstractIterable_iterableFactory), "$className", $rt_wrapFunction0(sc_AbstractIterable_className), "$fromSpecific0", $rt_wrapFunction1(sc_AbstractIterable_fromSpecific), "$newSpecificBuilder", $rt_wrapFunction0(sc_AbstractIterable_newSpecificBuilder), "$empty1", $rt_wrapFunction0(sc_AbstractIterable_empty), "$head", $rt_wrapFunction0(sc_AbstractIterable_head), "$headOption", $rt_wrapFunction0(sc_AbstractIterable_headOption),
    "$last", $rt_wrapFunction0(sc_AbstractIterable_last), "$sizeCompare", $rt_wrapFunction1(sc_AbstractIterable_sizeCompare), "$filter1", $rt_wrapFunction1(sc_AbstractIterable_filter), "$filterNot1", $rt_wrapFunction1(sc_AbstractIterable_filterNot), "$partition", $rt_wrapFunction1(sc_AbstractIterable_partition), "$takeWhile", $rt_wrapFunction1(sc_AbstractIterable_takeWhile), "$span", $rt_wrapFunction1(sc_AbstractIterable_span), "$drop", $rt_wrapFunction1(sc_AbstractIterable_drop), "$dropRight", $rt_wrapFunction1(sc_AbstractIterable_dropRight),
    "$dropWhile", $rt_wrapFunction1(sc_AbstractIterable_dropWhile), "$sliding", $rt_wrapFunction2(sc_AbstractIterable_sliding0), "$tail", $rt_wrapFunction0(sc_AbstractIterable_tail), "$init1", $rt_wrapFunction0(sc_AbstractIterable_init), "$map1", $rt_wrapFunction1(sc_AbstractIterable_map), "$flatMap", $rt_wrapFunction1(sc_AbstractIterable_flatMap), "$flatten", $rt_wrapFunction1(sc_AbstractIterable_flatten), "$collect0", $rt_wrapFunction1(sc_AbstractIterable_collect), "$concat0", $rt_wrapFunction1(sc_AbstractIterable_concat),
    "$foreach", $rt_wrapFunction1(sc_AbstractIterable_foreach), "$forall", $rt_wrapFunction1(sc_AbstractIterable_forall), "$exists", $rt_wrapFunction1(sc_AbstractIterable_exists), "$find0", $rt_wrapFunction1(sc_AbstractIterable_find), "$foldLeft", $rt_wrapFunction2(sc_AbstractIterable_foldLeft), "$reduceLeft", $rt_wrapFunction1(sc_AbstractIterable_reduceLeft), "$isEmpty", $rt_wrapFunction0(sc_AbstractIterable_isEmpty), "$nonEmpty0", $rt_wrapFunction0(sc_AbstractIterable_nonEmpty), "$size", $rt_wrapFunction0(sc_AbstractIterable_size),
    "$copyToArray0", $rt_wrapFunction2(sc_AbstractIterable_copyToArray0), "$copyToArray", $rt_wrapFunction3(sc_AbstractIterable_copyToArray1), "$collectFirst", $rt_wrapFunction1(sc_AbstractIterable_collectFirst), "$addString", $rt_wrapFunction4(sc_AbstractIterable_addString), "$toList", $rt_wrapFunction0(sc_AbstractIterable_toList), "$toVector", $rt_wrapFunction0(sc_AbstractIterable_toVector), "$toMap", $rt_wrapFunction1(sc_AbstractIterable_toMap), "$toSeq", $rt_wrapFunction0(sc_AbstractIterable_toSeq), "$toIndexedSeq0",
    $rt_wrapFunction0(sc_AbstractIterable_toIndexedSeq), "$toArray", $rt_wrapFunction1(sc_AbstractIterable_toArray), "$reversed", $rt_wrapFunction0(sc_AbstractIterable_reversed), "$knownSize", $rt_wrapFunction0(sc_AbstractIterable_knownSize), "$empty", $rt_wrapFunction0(sc_AbstractIterable_empty0), "$fromSpecific", $rt_wrapFunction1(sc_AbstractIterable_fromSpecific0)],
    s_PartialFunction, 0, jl_Object, [s_Function1], 3, 3, 0, 0, 0,
    sc_SeqOps, 0, jl_Object, [sc_IterableOps], 3, 3, 0, 0, 0,
    sc_Seq, 0, jl_Object, [sc_Iterable, s_PartialFunction, sc_SeqOps, s_Equals], 3, 3, 0, 0, 0,
    sc_AbstractSeq, 0, sc_AbstractIterable, [sc_Seq], 1, 3, 0, 0, ["$canEqual", $rt_wrapFunction1(sc_AbstractSeq_canEqual), "$equals", $rt_wrapFunction1(sc_AbstractSeq_equals), "$hashCode0", $rt_wrapFunction0(sc_AbstractSeq_hashCode), "$toString", $rt_wrapFunction0(sc_AbstractSeq_toString), "$scala$collection$SeqOps$$super$concat", $rt_wrapFunction1(sc_AbstractSeq_scala$collection$SeqOps$$super$concat), "$scala$collection$SeqOps$$super$sizeCompare", $rt_wrapFunction1(sc_AbstractSeq_scala$collection$SeqOps$$super$sizeCompare),
    "$view1", $rt_wrapFunction0(sc_AbstractSeq_view), "$appended", $rt_wrapFunction1(sc_AbstractSeq_appended), "$$colon$plus", $rt_wrapFunction1(sc_AbstractSeq_$colon$plus), "$appendedAll", $rt_wrapFunction1(sc_AbstractSeq_appendedAll), "$concat0", $rt_wrapFunction1(sc_AbstractSeq_concat), "$size", $rt_wrapFunction0(sc_AbstractSeq_size), "$distinct3", $rt_wrapFunction0(sc_AbstractSeq_distinct), "$distinctBy", $rt_wrapFunction1(sc_AbstractSeq_distinctBy), "$reverseIterator", $rt_wrapFunction0(sc_AbstractSeq_reverseIterator),
    "$indexWhere", $rt_wrapFunction2(sc_AbstractSeq_indexWhere), "$contains0", $rt_wrapFunction1(sc_AbstractSeq_contains), "$sorted1", $rt_wrapFunction1(sc_AbstractSeq_sorted), "$sizeCompare", $rt_wrapFunction1(sc_AbstractSeq_sizeCompare), "$lengthCompare", $rt_wrapFunction1(sc_AbstractSeq_lengthCompare), "$isEmpty", $rt_wrapFunction0(sc_AbstractSeq_isEmpty), "$sameElements", $rt_wrapFunction1(sc_AbstractSeq_sameElements), "$intersect1", $rt_wrapFunction1(sc_AbstractSeq_intersect)],
    sci_Iterable, 0, jl_Object, [sc_Iterable], 3, 3, 0, 0, 0,
    sci_SeqOps, 0, jl_Object, [sc_SeqOps], 3, 3, 0, 0, 0,
    sci_Seq, 0, jl_Object, [sci_Iterable, sc_Seq, sci_SeqOps], 3, 3, 0, 0, 0,
    sci_AbstractSeq, 0, sc_AbstractSeq, [sci_Seq], 1, 3, 0, 0, ["$toSeq", $rt_wrapFunction0(sci_AbstractSeq_toSeq)],
    sc_LinearSeqOps, 0, jl_Object, [sc_SeqOps], 3, 3, 0, 0, 0,
    sc_LinearSeq, 0, jl_Object, [sc_Seq, sc_LinearSeqOps], 3, 3, 0, 0, 0,
    sci_LinearSeqOps, 0, jl_Object, [sci_SeqOps, sc_LinearSeqOps], 3, 3, 0, 0, 0,
    sci_LinearSeq, 0, jl_Object, [sci_Seq, sc_LinearSeq, sci_LinearSeqOps], 3, 3, 0, 0, 0,
    sc_StrictOptimizedIterableOps, 0, jl_Object, [sc_IterableOps], 3, 3, 0, 0, 0,
    sc_StrictOptimizedSeqOps, 0, jl_Object, [sc_SeqOps, sc_StrictOptimizedIterableOps], 3, 3, 0, 0, 0,
    sc_StrictOptimizedLinearSeqOps, 0, jl_Object, [sc_LinearSeqOps, sc_StrictOptimizedSeqOps], 3, 3, 0, 0, 0,
    sci_StrictOptimizedSeqOps, 0, jl_Object, [sci_SeqOps, sc_StrictOptimizedSeqOps], 3, 3, 0, 0, 0,
    scg_DefaultSerializable, 0, jl_Object, [ji_Serializable], 3, 3, 0, 0, 0,
    sci_List, 0, sci_AbstractSeq, [sci_LinearSeq, sc_StrictOptimizedLinearSeqOps, sci_StrictOptimizedSeqOps, scg_DefaultSerializable], 1, 3, 0, 0, ["$scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted", $rt_wrapFunction1(sci_List_scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted), "$distinctBy", $rt_wrapFunction1(sci_List_distinctBy), "$sorted1", $rt_wrapFunction1(sci_List_sorted), "$iterator0", $rt_wrapFunction0(sci_List_iterator), "$appended", $rt_wrapFunction1(sci_List_appended), "$intersect1",
    $rt_wrapFunction1(sci_List_intersect), "$flatten", $rt_wrapFunction1(sci_List_flatten), "$zip2", $rt_wrapFunction1(sci_List_zip), "$zipWithIndex", $rt_wrapFunction0(sci_List_zipWithIndex), "$dropRight", $rt_wrapFunction1(sci_List_dropRight), "$stringPrefix", $rt_wrapFunction0(sci_List_stringPrefix), "$scala$collection$LinearSeqOps$$super$sameElements", $rt_wrapFunction1(sci_List_scala$collection$LinearSeqOps$$super$sameElements), "$apply1", $rt_wrapFunction1(sci_List_apply), "$foldLeft", $rt_wrapFunction2(sci_List_foldLeft),
    "$sameElements", $rt_wrapFunction1(sci_List_sameElements), "$indexWhere", $rt_wrapFunction2(sci_List_indexWhere), "$isEmpty", $rt_wrapFunction0(sci_List_isEmpty), "$span", $rt_wrapFunction1(sci_List_span), "$foreach", $rt_wrapFunction1(sci_List_foreach), "$length", $rt_wrapFunction0(sci_List_length), "$lengthCompare", $rt_wrapFunction1(sci_List_lengthCompare), "$forall", $rt_wrapFunction1(sci_List_forall), "$exists", $rt_wrapFunction1(sci_List_exists), "$contains0", $rt_wrapFunction1(sci_List_contains), "$find0",
    $rt_wrapFunction1(sci_List_find), "$last", $rt_wrapFunction0(sci_List_last), "$className", $rt_wrapFunction0(sci_List_className), "$partition", $rt_wrapFunction1(sci_List_partition), "$toList", $rt_wrapFunction0(sci_List_toList), "$equals", $rt_wrapFunction1(sci_List_equals), "$apply", $rt_wrapFunction1(sci_List_apply0), "$dropWhile", $rt_wrapFunction1(sci_List_dropWhile0), "$drop", $rt_wrapFunction1(sci_List_drop0), "$filterNot1", $rt_wrapFunction1(sci_List_filterNot0), "$filter1", $rt_wrapFunction1(sci_List_filter0),
    "$takeWhile", $rt_wrapFunction1(sci_List_takeWhile0), "$flatMap", $rt_wrapFunction1(sci_List_flatMap0), "$collect0", $rt_wrapFunction1(sci_List_collect0), "$map1", $rt_wrapFunction1(sci_List_map0), "$appendedAll", $rt_wrapFunction1(sci_List_appendedAll0), "$prepended", $rt_wrapFunction1(sci_List_prepended0), "$iterableFactory", $rt_wrapFunction0(sci_List_iterableFactory0)],
    sci_$colon$colon, "$colon$colon", 43, sci_List, [s_Product], 4, 3, 0, 0, ["$head", $rt_wrapFunction0(sci_$colon$colon_head), "$productArity", $rt_wrapFunction0(sci_$colon$colon_productArity), "$productElement", $rt_wrapFunction1(sci_$colon$colon_productElement), "$productIterator", $rt_wrapFunction0(sci_$colon$colon_productIterator), "$tail", $rt_wrapFunction0(sci_$colon$colon_tail), "$headOption", $rt_wrapFunction0(sci_$colon$colon_headOption)],
    oncias_SemanticFeature, "SemanticFeature", 17, jl_Object, [s_Product], 3, 3, [0,0,0], 0, 0,
    oncias_FeatureToString, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncias_SemanticFeature$MultipleDatabases$, "SemanticFeature$MultipleDatabases$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$MultipleDatabases$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$MultipleDatabases$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$MultipleDatabases$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$MultipleDatabases$_productElement),
    "$productIterator", $rt_wrapFunction0(oncias_SemanticFeature$MultipleDatabases$_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$MultipleDatabases$_hashCode)],
    oncias_SemanticFeature$MultipleGraphs$, "SemanticFeature$MultipleGraphs$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$MultipleGraphs$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$MultipleGraphs$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$MultipleGraphs$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$MultipleGraphs$_productElement), "$productIterator",
    $rt_wrapFunction0(oncias_SemanticFeature$MultipleGraphs$_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$MultipleGraphs$_hashCode)],
    oncias_SemanticFeature$UseAsSingleGraphSelector$, "SemanticFeature$UseAsSingleGraphSelector$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$UseAsSingleGraphSelector$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$UseAsSingleGraphSelector$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$UseAsSingleGraphSelector$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$UseAsSingleGraphSelector$_productElement),
    "$productIterator", $rt_wrapFunction0(oncias_SemanticFeature$UseAsSingleGraphSelector$_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$UseAsSingleGraphSelector$_hashCode)],
    sci_Nil$, "Nil$", 43, sci_List, [s_Product], 4, 3, 0, 0, ["$knownSize", $rt_wrapFunction0(sci_Nil$_knownSize), "$iterator0", $rt_wrapFunction0(sci_Nil$_iterator), "$productArity", $rt_wrapFunction0(sci_Nil$_productArity), "$productElement", $rt_wrapFunction1(sci_Nil$_productElement), "$productIterator", $rt_wrapFunction0(sci_Nil$_productIterator), "$init1", $rt_wrapFunction0(sci_Nil$_init), "$last", $rt_wrapFunction0(sci_Nil$_last), "$tail", $rt_wrapFunction0(sci_Nil$_tail), "$headOption", $rt_wrapFunction0(sci_Nil$_headOption),
    "$head", $rt_wrapFunction0(sci_Nil$_head)],
    sr_Statics, 0, jl_Object, [], 4, 3, 0, 0, 0,
    s_Product2, 0, jl_Object, [s_Product], 3, 3, 0, 0, 0,
    s_Tuple2, "Tuple2", 38, jl_Object, [s_Product2, ji_Serializable], 0, 3, [0,0,0], 0, ["$productArity", $rt_wrapFunction0(s_Tuple2_productArity), "$productElement", $rt_wrapFunction1(s_Tuple2_productElement), "$_16", $rt_wrapFunction0(s_Tuple2__1), "$_25", $rt_wrapFunction0(s_Tuple2__2), "$toString", $rt_wrapFunction0(s_Tuple2_toString), "$productPrefix", $rt_wrapFunction0(s_Tuple2_productPrefix), "$productIterator", $rt_wrapFunction0(s_Tuple2_productIterator), "$hashCode0", $rt_wrapFunction0(s_Tuple2_hashCode),
    "$equals", $rt_wrapFunction1(s_Tuple2_equals)],
    oncifp_BaseState, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncifp_InitialState, "InitialState", 31, jl_Object, [oncifp_BaseState, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(oncifp_InitialState_productPrefix), "$productArity", $rt_wrapFunction0(oncifp_InitialState_productArity), "$productElement", $rt_wrapFunction1(oncifp_InitialState_productElement), "$productIterator", $rt_wrapFunction0(oncifp_InitialState_productIterator), "$hashCode0", $rt_wrapFunction0(oncifp_InitialState_hashCode), "$toString", $rt_wrapFunction0(oncifp_InitialState_toString),
    "$equals", $rt_wrapFunction1(oncifp_InitialState_equals)],
    s_Option, "Option", 38, jl_Object, [sc_IterableOnce, s_Product, ji_Serializable], 1, 3, [0,0,0], 0, ["$knownSize", $rt_wrapFunction0(s_Option_knownSize), "$iterator0", $rt_wrapFunction0(s_Option_iterator)],
    s_None$, "None$", 38, s_Option, [], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0(s_None$_productArity), "$productElement", $rt_wrapFunction1(s_None$_productElement), "$productIterator", $rt_wrapFunction0(s_None$_productIterator), "$hashCode0", $rt_wrapFunction0(s_None$_hashCode), "$toString", $rt_wrapFunction0(s_None$_toString), "$get0", $rt_wrapFunction0(s_None$_get)],
    oncif_PlannerName, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncifp_SemanticAnalyzer$IDPPlannerName$, "SemanticAnalyzer$IDPPlannerName$", 31, jl_Object, [oncif_PlannerName, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0(oncifp_SemanticAnalyzer$IDPPlannerName$_productArity), "$productElement", $rt_wrapFunction1(oncifp_SemanticAnalyzer$IDPPlannerName$_productElement), "$productIterator", $rt_wrapFunction0(oncifp_SemanticAnalyzer$IDPPlannerName$_productIterator), "$hashCode0", $rt_wrapFunction0(oncifp_SemanticAnalyzer$IDPPlannerName$_hashCode),
    "$toString", $rt_wrapFunction0(oncifp_SemanticAnalyzer$IDPPlannerName$_toString)],
    onciu_AnonymousVariableNameGenerator, "AnonymousVariableNameGenerator", 20, jl_Object, [], 0, 3, 0, 0, 0,
    s_Function12, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sr_AbstractFunction12, 0, jl_Object, [s_Function12], 1, 3, 0, 0, 0,
    oncifp_InitialState$, 0, sr_AbstractFunction12, [ji_Serializable], 4, 3, 0, 0, 0,
    oncifp_SemanticAnalyzer$NoErrors$, 0, jl_Exception, [oncifp_SemanticAnalyzer$SemanticErrors], 0, 3, 0, 0, 0,
    oncifp_Transformer, 0, jl_Object, [], 3, 3, 0, 0, 0]);
    $rt_metadata([oncifp_Phase, 0, jl_Object, [oncifp_Transformer], 3, 3, 0, 0, 0,
    onciu_StepSequencer$Step, "StepSequencer$Step", 20, jl_Object, [], 3, 3, [onciu_StepSequencer,0,"Step"], 0, 0,
    oncifpf_ParsePipelineTransformerFactory, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncifp_Parse$, 0, jl_Object, [oncifp_Phase, onciu_StepSequencer$Step, oncifpf_ParsePipelineTransformerFactory, s_Product, ji_Serializable], 4, 3, 0, oncifp_Parse$_$callClinit, ["$transform", $rt_wrapFunction2(oncifp_Parse$_transform), "$name3", $rt_wrapFunction0(oncifp_Parse$_name), "$checkConditions", $rt_wrapFunction2(oncifp_Parse$_checkConditions), "$phase", $rt_wrapFunction0(oncifp_Parse$_phase0), "$postConditions0", $rt_wrapFunction0(oncifp_Parse$_postConditions), "$productPrefix", $rt_wrapFunction0(oncifp_Parse$_productPrefix),
    "$process", $rt_wrapFunction2(oncifp_Parse$_process)],
    oncifp_SyntaxDeprecationWarningsAndReplacements, 0, jl_Object, [oncifp_Phase, onciu_StepSequencer$Step, oncifpf_ParsePipelineTransformerFactory, s_Product, ji_Serializable], 0, 3, 0, 0, ["$transform", $rt_wrapFunction2(oncifp_SyntaxDeprecationWarningsAndReplacements_transform), "$name3", $rt_wrapFunction0(oncifp_SyntaxDeprecationWarningsAndReplacements_name), "$checkConditions", $rt_wrapFunction2(oncifp_SyntaxDeprecationWarningsAndReplacements_checkConditions), "$postConditions0", $rt_wrapFunction0(oncifp_SyntaxDeprecationWarningsAndReplacements_postConditions),
    "$phase", $rt_wrapFunction0(oncifp_SyntaxDeprecationWarningsAndReplacements_phase), "$productPrefix", $rt_wrapFunction0(oncifp_SyntaxDeprecationWarningsAndReplacements_productPrefix), "$process", $rt_wrapFunction2(oncifp_SyntaxDeprecationWarningsAndReplacements_process)],
    oncir_Deprecations, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncir_SyntacticDeprecations, 0, jl_Object, [oncir_Deprecations], 3, 3, 0, 0, 0,
    oncir_Deprecations$syntacticallyDeprecatedFeatures$, "Deprecations$syntacticallyDeprecatedFeatures$", 24, jl_Object, [oncir_SyntacticDeprecations, s_Product, ji_Serializable], 0, 3, 0, oncir_Deprecations$syntacticallyDeprecatedFeatures$_$callClinit, ["$toString", $rt_wrapFunction0(oncir_Deprecations$syntacticallyDeprecatedFeatures$_toString)],
    oncifp_PreparatoryRewriting$, 0, jl_Object, [oncifp_Phase, onciu_StepSequencer$Step, oncifpf_ParsePipelineTransformerFactory, s_Product, ji_Serializable], 4, 3, 0, oncifp_PreparatoryRewriting$_$callClinit, ["$transform", $rt_wrapFunction2(oncifp_PreparatoryRewriting$_transform), "$name3", $rt_wrapFunction0(oncifp_PreparatoryRewriting$_name), "$checkConditions", $rt_wrapFunction2(oncifp_PreparatoryRewriting$_checkConditions), "$phase", $rt_wrapFunction0(oncifp_PreparatoryRewriting$_phase0), "$postConditions0",
    $rt_wrapFunction0(oncifp_PreparatoryRewriting$_postConditions), "$productPrefix", $rt_wrapFunction0(oncifp_PreparatoryRewriting$_productPrefix), "$process", $rt_wrapFunction2(oncifp_PreparatoryRewriting$_process)],
    oncifp_If, 0, jl_Object, [oncifp_Transformer, s_Product, ji_Serializable], 0, 3, 0, 0, ["$transform", $rt_wrapFunction2(oncifp_If_transform), "$name3", $rt_wrapFunction0(oncifp_If_name), "$postConditions0", $rt_wrapFunction0(oncifp_If_postConditions)],
    oncifp_CompilationPhases$$parsingBase$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncifp_extractSensitiveLiterals$, 0, jl_Object, [oncifp_Phase, onciu_StepSequencer$Step, s_Product, ji_Serializable], 4, 3, 0, 0, ["$name3", $rt_wrapFunction0(oncifp_extractSensitiveLiterals$_name), "$checkConditions", $rt_wrapFunction2(oncifp_extractSensitiveLiterals$_checkConditions), "$phase", $rt_wrapFunction0(oncifp_extractSensitiveLiterals$_phase), "$postConditions0", $rt_wrapFunction0(oncifp_extractSensitiveLiterals$_postConditions), "$productPrefix", $rt_wrapFunction0(oncifp_extractSensitiveLiterals$_productPrefix),
    "$process", $rt_wrapFunction2(oncifp_extractSensitiveLiterals$_process)],
    oncifp_SemanticAnalysis, 0, jl_Object, [oncifp_Phase, s_Product, ji_Serializable], 0, 3, 0, 0, ["$transform", $rt_wrapFunction2(oncifp_SemanticAnalysis_transform), "$name3", $rt_wrapFunction0(oncifp_SemanticAnalysis_name), "$checkConditions", $rt_wrapFunction2(oncifp_SemanticAnalysis_checkConditions), "$phase", $rt_wrapFunction0(oncifp_SemanticAnalysis_phase), "$postConditions0", $rt_wrapFunction0(oncifp_SemanticAnalysis_postConditions), "$productPrefix", $rt_wrapFunction0(oncifp_SemanticAnalysis_productPrefix),
    "$process", $rt_wrapFunction2(oncifp_SemanticAnalysis_process)],
    oncifp_VisitorPhase, 0, jl_Object, [oncifp_Phase], 3, 3, 0, 0, 0,
    oncifp_SemanticTypeCheck$, 0, jl_Object, [oncifp_VisitorPhase, onciu_StepSequencer$Step, oncifpf_ParsePipelineTransformerFactory, s_Product, ji_Serializable], 4, 3, 0, oncifp_SemanticTypeCheck$_$callClinit, ["$process", $rt_wrapFunction2(oncifp_SemanticTypeCheck$_process), "$transform", $rt_wrapFunction2(oncifp_SemanticTypeCheck$_transform), "$name3", $rt_wrapFunction0(oncifp_SemanticTypeCheck$_name), "$checkConditions", $rt_wrapFunction2(oncifp_SemanticTypeCheck$_checkConditions), "$phase", $rt_wrapFunction0(oncifp_SemanticTypeCheck$_phase0),
    "$postConditions0", $rt_wrapFunction0(oncifp_SemanticTypeCheck$_postConditions), "$productPrefix", $rt_wrapFunction0(oncifp_SemanticTypeCheck$_productPrefix), "$visit", $rt_wrapFunction2(oncifp_SemanticTypeCheck$_visit)],
    oncifp_AmbiguousAggregationAnalysis, 0, jl_Object, [oncifp_VisitorPhase, s_Product, ji_Serializable], 0, 3, 0, 0, ["$process", $rt_wrapFunction2(oncifp_AmbiguousAggregationAnalysis_process), "$postConditions0", $rt_wrapFunction0(oncifp_AmbiguousAggregationAnalysis_postConditions), "$transform", $rt_wrapFunction2(oncifp_AmbiguousAggregationAnalysis_transform), "$name3", $rt_wrapFunction0(oncifp_AmbiguousAggregationAnalysis_name), "$checkConditions", $rt_wrapFunction2(oncifp_AmbiguousAggregationAnalysis_checkConditions),
    "$phase", $rt_wrapFunction0(oncifp_AmbiguousAggregationAnalysis_phase), "$productPrefix", $rt_wrapFunction0(oncifp_AmbiguousAggregationAnalysis_productPrefix), "$visit", $rt_wrapFunction2(oncifp_AmbiguousAggregationAnalysis_visit)],
    oncir_SemanticDeprecations, 0, jl_Object, [oncir_Deprecations], 3, 3, 0, 0, 0,
    oncir_Deprecations$semanticallyDeprecatedFeatures$, "Deprecations$semanticallyDeprecatedFeatures$", 24, jl_Object, [oncir_SemanticDeprecations, s_Product, ji_Serializable], 0, 3, [oncir_Deprecations,0,"semanticallyDeprecatedFeatures$"], 0, ["$toString", $rt_wrapFunction0(oncir_Deprecations$semanticallyDeprecatedFeatures$_toString)],
    s_LowPriorityImplicits2, 0, jl_Object, [], 1, 3, 0, 0, 0,
    s_LowPriorityImplicits, 0, s_LowPriorityImplicits2, [], 1, 3, 0, 0, 0,
    s_Predef$, 0, s_LowPriorityImplicits, [], 4, 3, 0, s_Predef$_$callClinit, 0,
    jl_IndexOutOfBoundsException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    jl_StringIndexOutOfBoundsException, 0, jl_IndexOutOfBoundsException, [], 0, 3, 0, 0, 0,
    sc_MapFactory, 0, jl_Object, [ji_Serializable], 3, 3, 0, 0, 0,
    sci_Map$, 0, jl_Object, [sc_MapFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(sci_Map$_newBuilder), "$from0", $rt_wrapFunction1(sci_Map$_from0), "$empty", $rt_wrapFunction0(sci_Map$_empty)],
    jl_Enum, 0, jl_Object, [jl_Comparable, ji_Serializable], 1, 3, 0, 0, ["$toString", $rt_wrapFunction0(jl_Enum_toString), "$equals", $rt_wrapFunction1(jl_Enum_equals), "$hashCode0", $rt_wrapFunction0(jl_Enum_hashCode)],
    oncifp_CompilationPhaseTracer$CompilationPhase, "CompilationPhaseTracer$CompilationPhase", 31, jl_Enum, [], 12, 3, 0, oncifp_CompilationPhaseTracer$CompilationPhase_$callClinit, 0,
    onciap_ExpressionStringifier$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sr_AbstractPartialFunction, 0, jl_Object, [s_PartialFunction], 1, 3, 0, 0, ["$orElse", $rt_wrapFunction1(sr_AbstractPartialFunction_orElse), "$lift1", $rt_wrapFunction0(sr_AbstractPartialFunction_lift), "$apply", $rt_wrapFunction1(sr_AbstractPartialFunction_apply)],
    oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1_applyOrElse)],
    onciu_StepSequencer, 0, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    sr_ScalaRunTime$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncirrf_PreparatoryRewritingRewriterFactory, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncirr_normalizeWithAndReturnClauses$, "normalizeWithAndReturnClauses$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, 0, ["$getRewriter", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$_getRewriter), "$preConditions", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses$_invalidatedConditions),
    "$productArity", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses$_productArity), "$productElement", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses$_hashCode), "$toString", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses$_toString)],
    oncirr_insertWithBetweenOptionalMatchAndMatch$, "insertWithBetweenOptionalMatchAndMatch$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, oncirr_insertWithBetweenOptionalMatchAndMatch$_$callClinit, ["$preConditions", $rt_wrapFunction0(oncirr_insertWithBetweenOptionalMatchAndMatch$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_insertWithBetweenOptionalMatchAndMatch$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_insertWithBetweenOptionalMatchAndMatch$_invalidatedConditions),
    "$getRewriter", $rt_wrapFunction1(oncirr_insertWithBetweenOptionalMatchAndMatch$_getRewriter), "$productArity", $rt_wrapFunction0(oncirr_insertWithBetweenOptionalMatchAndMatch$_productArity), "$productElement", $rt_wrapFunction1(oncirr_insertWithBetweenOptionalMatchAndMatch$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_insertWithBetweenOptionalMatchAndMatch$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_insertWithBetweenOptionalMatchAndMatch$_hashCode), "$toString", $rt_wrapFunction0(oncirr_insertWithBetweenOptionalMatchAndMatch$_toString)],
    oncirr_expandCallWhere$, "expandCallWhere$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, oncirr_expandCallWhere$_$callClinit, ["$preConditions", $rt_wrapFunction0(oncirr_expandCallWhere$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_expandCallWhere$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_expandCallWhere$_invalidatedConditions), "$getRewriter", $rt_wrapFunction1(oncirr_expandCallWhere$_getRewriter),
    "$productArity", $rt_wrapFunction0(oncirr_expandCallWhere$_productArity), "$productElement", $rt_wrapFunction1(oncirr_expandCallWhere$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_expandCallWhere$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_expandCallWhere$_hashCode), "$toString", $rt_wrapFunction0(oncirr_expandCallWhere$_toString)],
    oncirr_expandShowWhere$, "expandShowWhere$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, oncirr_expandShowWhere$_$callClinit, ["$preConditions", $rt_wrapFunction0(oncirr_expandShowWhere$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_expandShowWhere$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_expandShowWhere$_invalidatedConditions), "$getRewriter", $rt_wrapFunction1(oncirr_expandShowWhere$_getRewriter),
    "$productArity", $rt_wrapFunction0(oncirr_expandShowWhere$_productArity), "$productElement", $rt_wrapFunction1(oncirr_expandShowWhere$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_expandShowWhere$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_expandShowWhere$_hashCode), "$toString", $rt_wrapFunction0(oncirr_expandShowWhere$_toString)],
    oncirr_rewriteShowQuery$, "rewriteShowQuery$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, oncirr_rewriteShowQuery$_$callClinit, ["$preConditions", $rt_wrapFunction0(oncirr_rewriteShowQuery$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_rewriteShowQuery$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_rewriteShowQuery$_invalidatedConditions), "$getRewriter", $rt_wrapFunction1(oncirr_rewriteShowQuery$_getRewriter),
    "$productArity", $rt_wrapFunction0(oncirr_rewriteShowQuery$_productArity), "$productElement", $rt_wrapFunction1(oncirr_rewriteShowQuery$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_rewriteShowQuery$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_rewriteShowQuery$_hashCode), "$toString", $rt_wrapFunction0(oncirr_rewriteShowQuery$_toString)],
    oncirr_mergeInPredicates$, "mergeInPredicates$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, oncirr_mergeInPredicates$_$callClinit, ["$preConditions", $rt_wrapFunction0(oncirr_mergeInPredicates$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_mergeInPredicates$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_mergeInPredicates$_invalidatedConditions), "$getRewriter", $rt_wrapFunction1(oncirr_mergeInPredicates$_getRewriter),
    "$productArity", $rt_wrapFunction0(oncirr_mergeInPredicates$_productArity), "$productElement", $rt_wrapFunction1(oncirr_mergeInPredicates$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_mergeInPredicates$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_mergeInPredicates$_hashCode), "$toString", $rt_wrapFunction0(oncirr_mergeInPredicates$_toString)],
    oncirr_timestampRewriter$, "timestampRewriter$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, oncirr_timestampRewriter$_$callClinit, ["$getRewriter", $rt_wrapFunction1(oncirr_timestampRewriter$_getRewriter), "$preConditions", $rt_wrapFunction0(oncirr_timestampRewriter$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_timestampRewriter$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_timestampRewriter$_invalidatedConditions),
    "$productArity", $rt_wrapFunction0(oncirr_timestampRewriter$_productArity), "$productElement", $rt_wrapFunction1(oncirr_timestampRewriter$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_timestampRewriter$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_timestampRewriter$_hashCode), "$toString", $rt_wrapFunction0(oncirr_timestampRewriter$_toString)],
    oncirr_rewriteShortestPathWithFixedLengthRelationship$, "rewriteShortestPathWithFixedLengthRelationship$", 25, jl_Object, [onciu_StepSequencer$Step, oncirrf_PreparatoryRewritingRewriterFactory, s_Product, ji_Serializable], 4, 3, 0, 0, ["$preConditions", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRelationship$_preConditions), "$postConditions0", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRelationship$_postConditions), "$invalidatedConditions", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRelationship$_invalidatedConditions),
    "$getRewriter", $rt_wrapFunction1(oncirr_rewriteShortestPathWithFixedLengthRelationship$_getRewriter), "$productArity", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRelationship$_productArity), "$productElement", $rt_wrapFunction1(oncirr_rewriteShortestPathWithFixedLengthRelationship$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRelationship$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRelationship$_hashCode),
    "$toString", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRelationship$_toString)],
    sc_SetOps, 0, jl_Object, [sc_IterableOps, s_Function1], 3, 3, 0, 0, 0,
    sc_Set, 0, jl_Object, [sc_Iterable, sc_SetOps, s_Equals], 3, 3, 0, 0, 0,
    sci_SetOps, 0, jl_Object, [sc_SetOps], 3, 3, 0, 0, 0,
    sci_Set, "Set", 43, jl_Object, [sci_Iterable, sc_Set, sci_SetOps], 3, 3, [0,0,0], 0, 0,
    s_MatchError, 0, jl_RuntimeException, [], 4, 3, 0, 0, ["$getMessage", $rt_wrapFunction0(s_MatchError_getMessage)],
    oncifp_ExpectedBooleanTypeCheck, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncifp_PatternExpressionInNonExistenceCheck$, 0, jl_Object, [oncifp_ExpectedBooleanTypeCheck], 4, 3, 0, 0, 0,
    oncifp_CreatePatternSelfReferenceCheck$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_ListCoercedToBooleanCheck$, 0, jl_Object, [oncifp_ExpectedBooleanTypeCheck], 4, 3, 0, 0, 0]);
    $rt_metadata([sc_IterableFactory, 0, jl_Object, [ji_Serializable], 3, 3, 0, 0, 0,
    sci_Set$, 0, jl_Object, [sc_IterableFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(sci_Set$_newBuilder), "$from0", $rt_wrapFunction1(sci_Set$_from0)],
    s_Tuple2$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sr_Manifest$, 0, jl_Object, [ji_Serializable], 4, 3, 0, sr_Manifest$_$callClinit, 0,
    sr_OptManifest, 0, jl_Object, [ji_Serializable], 3, 3, 0, 0, 0,
    sr_NoManifest$, 0, jl_Object, [sr_OptManifest], 4, 3, 0, 0, 0,
    onciu_StepSequencer$AccumulatedSteps, "StepSequencer$AccumulatedSteps", 20, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(onciu_StepSequencer$AccumulatedSteps_productPrefix), "$productArity", $rt_wrapFunction0(onciu_StepSequencer$AccumulatedSteps_productArity), "$productElement", $rt_wrapFunction1(onciu_StepSequencer$AccumulatedSteps_productElement), "$productIterator", $rt_wrapFunction0(onciu_StepSequencer$AccumulatedSteps_productIterator), "$toString", $rt_wrapFunction0(onciu_StepSequencer$AccumulatedSteps_toString)],
    onciap_ExpressionStringifier$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciap_ExpressionStringifier$$_clinit_$lambda$_0_0_apply)],
    onciu_topDown$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_Rewriter$, 0, jl_Object, [], 4, 3, 0, onciu_Rewriter$_$callClinit, 0,
    oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1_applyOrElse)],
    onciu_bottomUp$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncirr_expandCallWhere$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_expandCallWhere$$anonfun$1_applyOrElse)],
    oncirr_expandShowWhere$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_expandShowWhere$$anonfun$1_applyOrElse)],
    oncirr_rewriteShowQuery$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_rewriteShowQuery$$anonfun$1_applyOrElse)],
    oncirr_mergeInPredicates$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_mergeInPredicates$$anonfun$1_applyOrElse)],
    oncirr_timestampRewriter$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_timestampRewriter$$anonfun$1_applyOrElse)],
    sr_ManifestFactory$, 0, jl_Object, [], 4, 3, 0, sr_ManifestFactory$_$callClinit, 0,
    s_PartialFunction$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sr_ClassManifestDeprecatedApis, 0, jl_Object, [sr_OptManifest], 131, 3, 0, 0, 0,
    sr_ClassTag, 0, jl_Object, [sr_ClassManifestDeprecatedApis, s_Equals], 3, 3, 0, 0, 0,
    sr_Manifest, 0, jl_Object, [sr_ClassTag], 3, 3, 0, 0, 0,
    sr_AnyValManifest, 0, jl_Object, [sr_Manifest], 1, 3, 0, 0, ["$equals", $rt_wrapFunction1(sr_AnyValManifest_equals), "$hashCode0", $rt_wrapFunction0(sr_AnyValManifest_hashCode)],
    sr_ManifestFactory$ByteManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$ByteManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$ByteManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$ByteManifest_newArray)],
    sr_ManifestFactory$ShortManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$ShortManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$ShortManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$ShortManifest_newArray)],
    sr_ManifestFactory$CharManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$CharManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$CharManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$CharManifest_newArray)],
    sr_ManifestFactory$IntManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$IntManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$IntManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$IntManifest_newArray)],
    sr_ManifestFactory$LongManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$LongManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$LongManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$LongManifest_newArray)],
    sr_ManifestFactory$FloatManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$FloatManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$FloatManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$FloatManifest_newArray)],
    sr_ManifestFactory$DoubleManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$DoubleManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$DoubleManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$DoubleManifest_newArray)],
    sr_ManifestFactory$BooleanManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$BooleanManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$BooleanManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$BooleanManifest_newArray)],
    sr_ManifestFactory$UnitManifest, 0, sr_AnyValManifest, [], 4, 3, 0, 0, ["$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$UnitManifest_runtimeClass), "$unapply0", $rt_wrapFunction1(sr_ManifestFactory$UnitManifest_unapply), "$newArray", $rt_wrapFunction1(sr_ManifestFactory$UnitManifest_newArray)],
    sr_Nothing$, "Nothing$", 41, jl_Throwable, [], 1, 3, [0,0,0], 0, 0,
    sr_Null$, "Null$", 41, jl_Object, [], 1, 3, [0,0,0], 0, 0,
    sr_ManifestFactory$ClassTypeManifest, 0, jl_Object, [sr_Manifest], 0, 3, 0, 0, ["$unapply0", $rt_wrapFunction1(sr_ManifestFactory$ClassTypeManifest_unapply), "$runtimeClass", $rt_wrapFunction0(sr_ManifestFactory$ClassTypeManifest_runtimeClass)],
    sr_ManifestFactory$PhantomManifest, 0, sr_ManifestFactory$ClassTypeManifest, [], 1, 3, 0, 0, ["$equals", $rt_wrapFunction1(sr_ManifestFactory$PhantomManifest_equals), "$hashCode0", $rt_wrapFunction0(sr_ManifestFactory$PhantomManifest_hashCode)],
    sr_ManifestFactory$AnyManifest, 0, sr_ManifestFactory$PhantomManifest, [], 4, 3, 0, 0, ["$newArray", $rt_wrapFunction1(sr_ManifestFactory$AnyManifest_newArray)],
    sr_ManifestFactory$ObjectManifest, 0, sr_ManifestFactory$PhantomManifest, [], 4, 3, 0, 0, ["$newArray", $rt_wrapFunction1(sr_ManifestFactory$ObjectManifest_newArray)],
    sr_ManifestFactory$AnyValPhantomManifest, 0, sr_ManifestFactory$PhantomManifest, [], 4, 3, 0, 0, 0,
    sr_ManifestFactory$NullManifest, 0, sr_ManifestFactory$PhantomManifest, [], 4, 3, 0, 0, ["$newArray", $rt_wrapFunction1(sr_ManifestFactory$NullManifest_newArray)],
    sr_ManifestFactory$NothingManifest, 0, sr_ManifestFactory$PhantomManifest, [], 4, 3, 0, 0, ["$newArray", $rt_wrapFunction1(sr_ManifestFactory$NothingManifest_newArray)],
    s_PartialFunction$$_clinit_$lambda$_0_0, "PartialFunction$$<clinit>$lambda$_0_0", 38, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(s_PartialFunction$$_clinit_$lambda$_0_0_apply)],
    s_PartialFunction$$_clinit_$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    s_PartialFunction$$anon$1, 0, jl_Object, [s_PartialFunction, ji_Serializable], 4, 3, 0, 0, ["$orElse", $rt_wrapFunction1(s_PartialFunction$$anon$1_orElse)],
    jl_System, 0, jl_Object, [], 4, 3, 0, 0, 0,
    s_PartialFunction$$anon$1$_init_$lambda$_41_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_ExpressionStringifier, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier, 0, jl_Object, [onciap_ExpressionStringifier], 0, 3, 0, 0, 0,
    onciap_ExpressionStringifier$Extension$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sc_IndexedSeqOps, 0, jl_Object, [sc_SeqOps], 3, 3, 0, 0, 0]);
    $rt_metadata([sc_IndexedSeq, 0, jl_Object, [sc_Seq, sc_IndexedSeqOps], 3, 3, 0, 0, 0,
    sci_IndexedSeqOps, 0, jl_Object, [sci_SeqOps, sc_IndexedSeqOps], 3, 3, 0, 0, 0,
    sci_IndexedSeq, 0, jl_Object, [sci_Seq, sc_IndexedSeq, sci_IndexedSeqOps], 3, 3, 0, 0, 0,
    sc_EvidenceIterableFactoryDefaults, 0, jl_Object, [sc_IterableOps], 3, 3, 0, 0, 0,
    sci_ArraySeq, 0, sci_AbstractSeq, [sci_IndexedSeq, sci_StrictOptimizedSeqOps, sc_EvidenceIterableFactoryDefaults, ji_Serializable], 1, 3, 0, 0, ["$fromSpecific0", $rt_wrapFunction1(sci_ArraySeq_fromSpecific), "$newSpecificBuilder", $rt_wrapFunction0(sci_ArraySeq_newSpecificBuilder), "$empty1", $rt_wrapFunction0(sci_ArraySeq_empty), "$distinctBy", $rt_wrapFunction1(sci_ArraySeq_distinctBy), "$intersect1", $rt_wrapFunction1(sci_ArraySeq_intersect), "$span", $rt_wrapFunction1(sci_ArraySeq_span), "$flatMap", $rt_wrapFunction1(sci_ArraySeq_flatMap),
    "$collect0", $rt_wrapFunction1(sci_ArraySeq_collect), "$flatten", $rt_wrapFunction1(sci_ArraySeq_flatten), "$zipWithIndex", $rt_wrapFunction0(sci_ArraySeq_zipWithIndex), "$filter1", $rt_wrapFunction1(sci_ArraySeq_filter), "$filterNot1", $rt_wrapFunction1(sci_ArraySeq_filterNot), "$filterImpl", $rt_wrapFunction2(sci_ArraySeq_filterImpl), "$scala$collection$immutable$IndexedSeq$$super$canEqual", $rt_wrapFunction1(sci_ArraySeq_scala$collection$immutable$IndexedSeq$$super$canEqual), "$scala$collection$immutable$IndexedSeq$$super$sameElements",
    $rt_wrapFunction1(sci_ArraySeq_scala$collection$immutable$IndexedSeq$$super$sameElements), "$toIndexedSeq0", $rt_wrapFunction0(sci_ArraySeq_toIndexedSeq), "$canEqual", $rt_wrapFunction1(sci_ArraySeq_canEqual), "$sameElements", $rt_wrapFunction1(sci_ArraySeq_sameElements), "$stringPrefix", $rt_wrapFunction0(sci_ArraySeq_stringPrefix), "$reverseIterator", $rt_wrapFunction0(sci_ArraySeq_reverseIterator), "$view0", $rt_wrapFunction0(sci_ArraySeq_view), "$reversed", $rt_wrapFunction0(sci_ArraySeq_reversed), "$head",
    $rt_wrapFunction0(sci_ArraySeq_head), "$headOption", $rt_wrapFunction0(sci_ArraySeq_headOption), "$last", $rt_wrapFunction0(sci_ArraySeq_last), "$lengthCompare", $rt_wrapFunction1(sci_ArraySeq_lengthCompare), "$knownSize", $rt_wrapFunction0(sci_ArraySeq_knownSize), "$updated0", $rt_wrapFunction2(sci_ArraySeq_updated), "$prepended1", $rt_wrapFunction1(sci_ArraySeq_prepended), "$appended0", $rt_wrapFunction1(sci_ArraySeq_appended), "$foldLeft", $rt_wrapFunction2(sci_ArraySeq_foldLeft), "$className", $rt_wrapFunction0(sci_ArraySeq_className),
    "$copyToArray", $rt_wrapFunction3(sci_ArraySeq_copyToArray), "$applyPreferredMaxLength", $rt_wrapFunction0(sci_ArraySeq_applyPreferredMaxLength), "$sorted", $rt_wrapFunction1(sci_ArraySeq_sorted), "$view1", $rt_wrapFunction0(sci_ArraySeq_view0), "$empty", $rt_wrapFunction0(sci_ArraySeq_empty0), "$fromSpecific", $rt_wrapFunction1(sci_ArraySeq_fromSpecific0), "$sorted1", $rt_wrapFunction1(sci_ArraySeq_sorted0), "$tail", $rt_wrapFunction0(sci_ArraySeq_tail0), "$dropRight", $rt_wrapFunction1(sci_ArraySeq_dropRight0),
    "$drop", $rt_wrapFunction1(sci_ArraySeq_drop0), "$zip2", $rt_wrapFunction1(sci_ArraySeq_zip0), "$appendedAll", $rt_wrapFunction1(sci_ArraySeq_appendedAll0), "$appended", $rt_wrapFunction1(sci_ArraySeq_appended0), "$prepended", $rt_wrapFunction1(sci_ArraySeq_prepended0), "$map1", $rt_wrapFunction1(sci_ArraySeq_map0), "$updated7", $rt_wrapFunction2(sci_ArraySeq_updated0), "$iterableFactory", $rt_wrapFunction0(sci_ArraySeq_iterableFactory0)],
    sci_ArraySeq$ofRef, "ArraySeq$ofRef", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofRef_elemTag), "$length", $rt_wrapFunction0(sci_ArraySeq$ofRef_length), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofRef_apply), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofRef_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofRef_equals), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofRef_iterator), "$sorted1", $rt_wrapFunction1(sci_ArraySeq$ofRef_sorted0), "$sorted", $rt_wrapFunction1(sci_ArraySeq$ofRef_sorted1),
    "$apply", $rt_wrapFunction1(sci_ArraySeq$ofRef_apply0), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofRef_unsafeArray)],
    sc_EvidenceIterableFactory, 0, jl_Object, [ji_Serializable], 3, 3, 0, 0, 0,
    sc_ClassTagIterableFactory, 0, jl_Object, [sc_EvidenceIterableFactory], 3, 3, 0, 0, 0,
    sc_ClassTagSeqFactory, 0, jl_Object, [sc_ClassTagIterableFactory], 3, 3, 0, 0, 0,
    sc_StrictOptimizedClassTagSeqFactory, 0, jl_Object, [sc_ClassTagSeqFactory], 3, 3, 0, 0, 0,
    sci_ArraySeq$, 0, jl_Object, [sc_StrictOptimizedClassTagSeqFactory], 4, 3, 0, 0, ["$newBuilder0", $rt_wrapFunction1(sci_ArraySeq$_newBuilder), "$from6", $rt_wrapFunction2(sci_ArraySeq$_from), "$empty4", $rt_wrapFunction1(sci_ArraySeq$_empty0)],
    sr_ClassTag$, 0, jl_Object, [ji_Serializable], 4, 3, 0, sr_ClassTag$_$callClinit, 0,
    s_Function2, 0, jl_Object, [], 3, 3, 0, 0, ["$toString", $rt_wrapFunction0(s_Function2_toString)],
    oncifp_PatternExpressionInNonExistenceCheck$$patternExpressionInNonExistenceCheck$lambda$_2_0, "PatternExpressionInNonExistenceCheck$$patternExpressionInNonExistenceCheck$lambda$_2_0", 31, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2(oncifp_PatternExpressionInNonExistenceCheck$$patternExpressionInNonExistenceCheck$lambda$_2_0_apply)],
    oncifp_CreatePatternSelfReferenceCheck$$check$lambda$_1_0, "CreatePatternSelfReferenceCheck$$check$lambda$_1_0", 31, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2(oncifp_CreatePatternSelfReferenceCheck$$check$lambda$_1_0_apply)],
    oncifp_ListCoercedToBooleanCheck$$listCoercedToBooleanCheck$lambda$_3_0, "ListCoercedToBooleanCheck$$listCoercedToBooleanCheck$lambda$_3_0", 31, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2(oncifp_ListCoercedToBooleanCheck$$listCoercedToBooleanCheck$lambda$_3_0_apply)],
    onciu_topDown$TopDownRewriter, "topDown$TopDownRewriter", 20, jl_Object, [s_Function1], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(onciu_topDown$TopDownRewriter_toString), "$apply", $rt_wrapFunction1(onciu_topDown$TopDownRewriter_apply)],
    onciu_RewriterStopper$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_CancellationChecker, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_CancellationChecker$NeverCancelled$, 0, jl_Object, [onciu_CancellationChecker], 0, 3, 0, 0, 0,
    onciu_Rewriter$$anonfun$lift$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(onciu_Rewriter$$anonfun$lift$1_applyOrElse)],
    onciu_bottomUp$BottomUpRewriter, "bottomUp$BottomUpRewriter", 20, jl_Object, [s_Function1], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(onciu_bottomUp$BottomUpRewriter_toString), "$apply", $rt_wrapFunction1(onciu_bottomUp$BottomUpRewriter_apply)],
    onciu_StepSequencer$RepeatedSteps, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_StepSequencer$RepeatedSteps$Permitted$, "StepSequencer$RepeatedSteps$Permitted$", 20, jl_Object, [onciu_StepSequencer$RepeatedSteps], 0, 3, 0, 0, 0,
    onciu_StepSequencer$orderSteps$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciu_StepSequencer$orderSteps$lambda$_3_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_1_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_2_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_3_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_4_apply)],
    sc_MapOps, 0, jl_Object, [sc_IterableOps, s_PartialFunction], 3, 3, 0, 0, 0,
    onciu_StepSequencer$orderSteps$lambda$_3_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_5_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_6_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_7_apply)],
    s_$less$colon$less$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciu_StepSequencer$orderSteps$lambda$_3_8, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_8_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_9, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_9_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_10, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_10_apply)],
    onciu_StepSequencer$MutableDirectedGraph, "StepSequencer$MutableDirectedGraph", 20, jl_Object, [], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(onciu_StepSequencer$MutableDirectedGraph_toString)],
    onciu_StepSequencer$orderSteps$lambda$_3_11, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_11_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_12, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_12_apply)],
    onciu_StepSequencer$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciu_StepSequencer$orderSteps$lambda$_3_13, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2(onciu_StepSequencer$orderSteps$lambda$_3_13_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_14, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_14_apply)],
    onciu_StepSequencer$orderSteps$lambda$_3_15, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$orderSteps$lambda$_3_15_apply)],
    onciu_StepSequencer$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(onciu_StepSequencer$$anonfun$1_applyOrElse)],
    sc_MapFactoryDefaults, 0, jl_Object, [sc_MapOps], 3, 3, 0, 0, 0,
    sc_Map, 0, jl_Object, [sc_Iterable, sc_MapFactoryDefaults, s_Equals], 3, 3, 0, 0, 0,
    sci_MapOps, 0, jl_Object, [sc_MapOps], 3, 3, 0, 0, 0,
    sci_Map, 0, jl_Object, [sci_Iterable, sc_Map, sci_MapOps], 3, 3, 0, 0, 0,
    onciap_PatternStringifier$, 0, jl_Object, [], 4, 3, 0, 0, 0]);
    $rt_metadata([onciap_PathStepStringifier$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciap_Prettifier, 0, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sc_View, 0, jl_Object, [sc_Iterable, ji_Serializable], 3, 3, 0, 0, 0,
    sc_MapView, 0, jl_Object, [sc_MapOps, sc_View], 3, 3, 0, 0, 0,
    sc_MapFactory$Delegate, 0, jl_Object, [sc_MapFactory], 0, 3, 0, 0, 0,
    scm_Map$, 0, sc_MapFactory$Delegate, [], 4, 3, 0, scm_Map$_$callClinit, 0,
    scm_Iterable, 0, jl_Object, [sc_Iterable], 3, 3, 0, 0, 0,
    scm_Cloneable, 0, jl_Object, [jl_Cloneable], 3, 3, 0, 0, 0,
    scm_Clearable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    scm_Growable, 0, jl_Object, [scm_Clearable], 3, 3, 0, 0, 0,
    scm_Builder, 0, jl_Object, [scm_Growable], 3, 3, 0, 0, 0,
    scm_Shrinkable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    scm_MapOps, 0, jl_Object, [sc_MapOps, scm_Cloneable, scm_Builder, scm_Shrinkable], 3, 3, 0, 0, 0,
    scm_Map, "Map", 44, jl_Object, [scm_Iterable, sc_Map, scm_MapOps], 3, 3, 0, 0, 0,
    oncifp_PipeLine, 0, jl_Object, [oncifp_Transformer], 0, 3, 0, 0, ["$postConditions0", $rt_wrapFunction0(oncifp_PipeLine_postConditions), "$transform", $rt_wrapFunction2(oncifp_PipeLine_transform), "$name3", $rt_wrapFunction0(oncifp_PipeLine_name)],
    onciap_Prettifier$QueryPrettifier, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciap_Prettifier$IndentingQueryPrettifier, 0, jl_Object, [onciap_Prettifier$QueryPrettifier, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    sc_ClassTagIterableFactory$AnyIterableDelegate, 0, jl_Object, [sc_IterableFactory], 0, 3, 0, 0, ["$empty", $rt_wrapFunction0(sc_ClassTagIterableFactory$AnyIterableDelegate_empty), "$from0", $rt_wrapFunction1(sc_ClassTagIterableFactory$AnyIterableDelegate_from), "$newBuilder", $rt_wrapFunction0(sc_ClassTagIterableFactory$AnyIterableDelegate_newBuilder)],
    sc_SeqFactory, 0, jl_Object, [sc_IterableFactory], 3, 3, 0, 0, 0,
    sc_ClassTagSeqFactory$AnySeqDelegate, 0, sc_ClassTagIterableFactory$AnyIterableDelegate, [sc_SeqFactory], 0, 3, 0, 0, 0,
    jl_Boolean, "Boolean", 6, jl_Object, [ji_Serializable, jl_Comparable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(jl_Boolean_toString0), "$hashCode0", $rt_wrapFunction0(jl_Boolean_hashCode), "$equals", $rt_wrapFunction1(jl_Boolean_equals)],
    onciu_RewriterStopper, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_RewriterStopper$$_clinit_$lambda$_0_0, 0, jl_Object, [onciu_RewriterStopper], 0, 3, 0, 0, ["$shouldStop", $rt_wrapFunction1(onciu_RewriterStopper$$_clinit_$lambda$_0_0_shouldStop)],
    s_$less$colon$less, 0, jl_Object, [s_Function1, ji_Serializable], 1, 3, 0, 0, 0,
    s_$eq$colon$eq, 0, s_$less$colon$less, [], 1, 3, 0, 0, 0,
    s_$less$colon$less$$anon$1, 0, s_$eq$colon$eq, [], 4, 3, 0, 0, ["$apply", $rt_wrapFunction1(s_$less$colon$less$$anon$1_apply)],
    sr_AbstractFunction1, 0, jl_Object, [s_Function1], 1, 3, 0, 0, ["$toString", $rt_wrapFunction0(sr_AbstractFunction1_toString)],
    onciap_Prettifier$IndentingQueryPrettifier$, 0, sr_AbstractFunction1, [ji_Serializable], 0, 3, 0, 0, 0,
    sc_StringOps$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    scm_HashMap$, 0, jl_Object, [sc_MapFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(scm_HashMap$_newBuilder), "$from0", $rt_wrapFunction1(scm_HashMap$_from), "$empty", $rt_wrapFunction0(scm_HashMap$_empty)],
    sc_StringOps$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    ju_Dictionary, 0, jl_Object, [], 1, 3, 0, 0, 0,
    ju_Map, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_Hashtable, 0, ju_Dictionary, [ju_Map, jl_Cloneable, ji_Serializable], 0, 3, 0, 0, 0,
    ju_Properties, 0, ju_Hashtable, [], 0, 3, 0, 0, 0,
    jl_IllegalArgumentException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    ju_Enumeration, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_Hashtable$1, 0, jl_Object, [ju_Enumeration], 0, 0, 0, 0, 0,
    ju_Iterator, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_Hashtable$2, 0, jl_Object, [ju_Iterator], 0, 0, 0, 0, 0,
    ju_Map$Entry, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_MapEntry, 0, jl_Object, [ju_Map$Entry, jl_Cloneable], 0, 0, 0, 0, 0,
    ju_Hashtable$Entry, 0, ju_MapEntry, [], 0, 0, 0, 0, 0,
    sc_AbstractMap, 0, sc_AbstractIterable, [sc_Map], 1, 3, 0, 0, ["$equals", $rt_wrapFunction1(sc_AbstractMap_equals), "$hashCode0", $rt_wrapFunction0(sc_AbstractMap_hashCode), "$stringPrefix", $rt_wrapFunction0(sc_AbstractMap_stringPrefix), "$toString", $rt_wrapFunction0(sc_AbstractMap_toString), "$fromSpecific0", $rt_wrapFunction1(sc_AbstractMap_fromSpecific), "$newSpecificBuilder", $rt_wrapFunction0(sc_AbstractMap_newSpecificBuilder), "$getOrElse0", $rt_wrapFunction2(sc_AbstractMap_getOrElse), "$apply", $rt_wrapFunction1(sc_AbstractMap_apply),
    "$keysIterator", $rt_wrapFunction0(sc_AbstractMap_keysIterator), "$valuesIterator", $rt_wrapFunction0(sc_AbstractMap_valuesIterator), "$foreachEntry", $rt_wrapFunction1(sc_AbstractMap_foreachEntry), "$default0", $rt_wrapFunction1(sc_AbstractMap_default), "$contains0", $rt_wrapFunction1(sc_AbstractMap_contains), "$map14", $rt_wrapFunction1(sc_AbstractMap_map), "$collect1", $rt_wrapFunction1(sc_AbstractMap_collect), "$concat2", $rt_wrapFunction1(sc_AbstractMap_concat), "$addString", $rt_wrapFunction4(sc_AbstractMap_addString),
    "$fromSpecific", $rt_wrapFunction1(sc_AbstractMap_fromSpecific0)],
    sci_AbstractMap, 0, sc_AbstractMap, [sci_Map], 1, 3, 0, 0, ["$mapFactory", $rt_wrapFunction0(sci_AbstractMap_mapFactory), "$toMap", $rt_wrapFunction1(sci_AbstractMap_toMap), "$removedAll", $rt_wrapFunction1(sci_AbstractMap_removedAll), "$keySet0", $rt_wrapFunction0(sci_AbstractMap_keySet), "$iterableFactory", $rt_wrapFunction0(sci_AbstractMap_iterableFactory), "$keySet", $rt_wrapFunction0(sci_AbstractMap_keySet0)],
    sci_Map$EmptyMap$, "Map$EmptyMap$", 43, sci_AbstractMap, [ji_Serializable], 0, 3, 0, 0, ["$size", $rt_wrapFunction0(sci_Map$EmptyMap$_size), "$knownSize", $rt_wrapFunction0(sci_Map$EmptyMap$_knownSize), "$isEmpty", $rt_wrapFunction0(sci_Map$EmptyMap$_isEmpty), "$contains0", $rt_wrapFunction1(sci_Map$EmptyMap$_contains), "$get1", $rt_wrapFunction1(sci_Map$EmptyMap$_get), "$getOrElse0", $rt_wrapFunction2(sci_Map$EmptyMap$_getOrElse), "$iterator0", $rt_wrapFunction0(sci_Map$EmptyMap$_iterator), "$keysIterator",
    $rt_wrapFunction0(sci_Map$EmptyMap$_keysIterator), "$valuesIterator", $rt_wrapFunction0(sci_Map$EmptyMap$_valuesIterator), "$concat2", $rt_wrapFunction1(sci_Map$EmptyMap$_concat), "$removed", $rt_wrapFunction1(sci_Map$EmptyMap$_removed), "$updated1", $rt_wrapFunction2(sci_Map$EmptyMap$_updated), "$apply", $rt_wrapFunction1(sci_Map$EmptyMap$_apply)],
    onciap_ExpressionStringifier$Extension, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciap_ExpressionStringifier$Extension$$anon$1, 0, jl_Object, [onciap_ExpressionStringifier$Extension], 4, 3, 0, 0, 0,
    scm_SeqOps, 0, jl_Object, [sc_SeqOps, scm_Cloneable], 3, 3, 0, 0, 0]);
    $rt_metadata([scm_Seq, 0, jl_Object, [scm_Iterable, sc_Seq, scm_SeqOps], 3, 3, 0, 0, 0,
    scm_AbstractSeq, 0, sc_AbstractSeq, [scm_Seq], 1, 3, 0, 0, 0,
    scm_Buffer, 0, jl_Object, [scm_Seq, scm_Growable, scm_Shrinkable], 3, 3, 0, 0, 0,
    scm_AbstractBuffer, 0, scm_AbstractSeq, [scm_Buffer], 1, 3, 0, 0, 0,
    scm_IndexedSeqOps, 0, jl_Object, [sc_IndexedSeqOps, scm_SeqOps], 3, 3, 0, 0, 0,
    scm_IndexedSeq, 0, jl_Object, [scm_Seq, sc_IndexedSeq, scm_IndexedSeqOps], 3, 3, 0, 0, 0,
    scm_IndexedBuffer, 0, jl_Object, [scm_IndexedSeq, scm_Buffer], 3, 3, 0, 0, 0,
    scm_ArrayBuffer, "ArrayBuffer", 44, scm_AbstractBuffer, [scm_IndexedBuffer, sc_StrictOptimizedSeqOps, scg_DefaultSerializable], 0, 3, 0, 0, ["$distinctBy", $rt_wrapFunction1(scm_ArrayBuffer_distinctBy), "$prepended", $rt_wrapFunction1(scm_ArrayBuffer_prepended), "$appended", $rt_wrapFunction1(scm_ArrayBuffer_appended), "$appendedAll", $rt_wrapFunction1(scm_ArrayBuffer_appendedAll), "$map1", $rt_wrapFunction1(scm_ArrayBuffer_map), "$flatMap", $rt_wrapFunction1(scm_ArrayBuffer_flatMap), "$flatten", $rt_wrapFunction1(scm_ArrayBuffer_flatten),
    "$filter1", $rt_wrapFunction1(scm_ArrayBuffer_filter), "$filterNot1", $rt_wrapFunction1(scm_ArrayBuffer_filterNot), "$filterImpl", $rt_wrapFunction2(scm_ArrayBuffer_filterImpl), "$iterator0", $rt_wrapFunction0(scm_ArrayBuffer_iterator), "$reverseIterator", $rt_wrapFunction0(scm_ArrayBuffer_reverseIterator), "$reversed", $rt_wrapFunction0(scm_ArrayBuffer_reversed), "$head", $rt_wrapFunction0(scm_ArrayBuffer_head), "$headOption", $rt_wrapFunction0(scm_ArrayBuffer_headOption), "$lengthCompare", $rt_wrapFunction1(scm_ArrayBuffer_lengthCompare),
    "$knownSize", $rt_wrapFunction0(scm_ArrayBuffer_knownSize), "$apply1", $rt_wrapFunction1(scm_ArrayBuffer_apply), "$length", $rt_wrapFunction0(scm_ArrayBuffer_length), "$clear", $rt_wrapFunction0(scm_ArrayBuffer_clear), "$stringPrefix", $rt_wrapFunction0(scm_ArrayBuffer_stringPrefix), "$copyToArray", $rt_wrapFunction3(scm_ArrayBuffer_copyToArray), "$foldLeft", $rt_wrapFunction2(scm_ArrayBuffer_foldLeft), "$reduceLeft", $rt_wrapFunction1(scm_ArrayBuffer_reduceLeft), "$addAll0", $rt_wrapFunction1(scm_ArrayBuffer_addAll),
    "$addOne", $rt_wrapFunction1(scm_ArrayBuffer_addOne0), "$iterableFactory", $rt_wrapFunction0(scm_ArrayBuffer_iterableFactory), "$view0", $rt_wrapFunction0(scm_ArrayBuffer_view), "$apply", $rt_wrapFunction1(scm_ArrayBuffer_apply0)],
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_0_apply)],
    s_Some, "Some", 38, s_Option, [], 4, 3, 0, 0, ["$get0", $rt_wrapFunction0(s_Some_get), "$productPrefix", $rt_wrapFunction0(s_Some_productPrefix), "$productArity", $rt_wrapFunction0(s_Some_productArity), "$productElement", $rt_wrapFunction1(s_Some_productElement), "$productIterator", $rt_wrapFunction0(s_Some_productIterator), "$hashCode0", $rt_wrapFunction0(s_Some_hashCode), "$toString", $rt_wrapFunction0(s_Some_toString), "$equals", $rt_wrapFunction1(s_Some_equals)],
    sc_IterableFactory$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sc_IterableFactory$Delegate, 0, jl_Object, [sc_IterableFactory], 0, 3, 0, 0, ["$empty", $rt_wrapFunction0(sc_IterableFactory$Delegate_empty), "$from0", $rt_wrapFunction1(sc_IterableFactory$Delegate_from), "$newBuilder", $rt_wrapFunction0(sc_IterableFactory$Delegate_newBuilder)],
    scm_Set$, 0, sc_IterableFactory$Delegate, [], 4, 3, 0, scm_Set$_$callClinit, 0,
    scm_SetOps, 0, jl_Object, [sc_SetOps, scm_Cloneable, scm_Builder, scm_Shrinkable], 3, 3, 0, 0, 0,
    scm_Set, 0, jl_Object, [scm_Iterable, sc_Set, scm_SetOps], 3, 3, 0, 0, 0,
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_1_apply)],
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_2_apply)],
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$topologicalSort$lambda$_3_3_apply)],
    sm_Equiv, 0, jl_Object, [ji_Serializable], 3, 3, 0, 0, 0,
    sm_PartialOrdering, 0, jl_Object, [sm_Equiv], 3, 3, 0, 0, 0,
    sm_Ordering, 0, jl_Object, [ju_Comparator, sm_PartialOrdering], 3, 3, 0, 0, 0,
    sc_EvidenceIterableFactory$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sc_EvidenceIterableFactory$Delegate, 0, jl_Object, [sc_EvidenceIterableFactory], 0, 3, 0, 0, 0,
    sc_SortedIterableFactory, 0, jl_Object, [sc_EvidenceIterableFactory], 3, 3, 0, 0, 0,
    sc_SortedIterableFactory$Delegate, 0, sc_EvidenceIterableFactory$Delegate, [sc_SortedIterableFactory], 0, 3, 0, 0, 0,
    scm_SortedSet$, 0, sc_SortedIterableFactory$Delegate, [], 4, 3, 0, scm_SortedSet$_$callClinit, 0,
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_0_apply)],
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_1_apply)],
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_2_apply)],
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_3_apply)],
    sr_BoxesRunTime, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_StepSequencer$MutableDirectedGraph$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_4, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_4_apply)],
    onciu_AssertionRunner, 0, jl_Object, [], 0, 3, 0, onciu_AssertionRunner_$callClinit, 0,
    onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$org$neo4j$cypher$internal$util$StepSequencer$$sort$lambda$_2_5_apply)],
    jl_IllegalStateException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    onciap_PatternStringifier, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciap_DefaultPatternStringifier, 0, jl_Object, [onciap_PatternStringifier], 0, 3, 0, 0, 0,
    onciap_PathStepStringifier, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciap_DefaultPathStepStringifier, 0, jl_Object, [onciap_PathStepStringifier], 0, 3, 0, 0, 0,
    onciap_Prettifier$ClausePrettifier, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciap_Prettifier$EmptyExtension$, 0, jl_Object, [onciap_Prettifier$ClausePrettifier], 0, 3, 0, 0, 0,
    sc_AbstractSet, 0, sc_AbstractIterable, [sc_Set], 1, 3, 0, 0, ["$equals", $rt_wrapFunction1(sc_AbstractSet_equals), "$hashCode0", $rt_wrapFunction0(sc_AbstractSet_hashCode), "$stringPrefix", $rt_wrapFunction0(sc_AbstractSet_stringPrefix), "$toString", $rt_wrapFunction0(sc_AbstractSet_toString), "$subsetOf", $rt_wrapFunction1(sc_AbstractSet_subsetOf), "$intersect", $rt_wrapFunction1(sc_AbstractSet_intersect), "$concat1", $rt_wrapFunction1(sc_AbstractSet_concat), "$apply", $rt_wrapFunction1(sc_AbstractSet_apply0)],
    sci_AbstractSet, 0, sc_AbstractSet, [sci_Set], 1, 3, 0, 0, ["$iterableFactory", $rt_wrapFunction0(sci_AbstractSet_iterableFactory), "$removedAll0", $rt_wrapFunction1(sci_AbstractSet_removedAll)],
    sci_Set$EmptySet$, "Set$EmptySet$", 43, sci_AbstractSet, [ji_Serializable], 0, 3, 0, 0, ["$size", $rt_wrapFunction0(sci_Set$EmptySet$_size), "$isEmpty", $rt_wrapFunction0(sci_Set$EmptySet$_isEmpty), "$knownSize", $rt_wrapFunction0(sci_Set$EmptySet$_knownSize), "$subsetOf", $rt_wrapFunction1(sci_Set$EmptySet$_subsetOf), "$contains0", $rt_wrapFunction1(sci_Set$EmptySet$_contains), "$iterator0", $rt_wrapFunction0(sci_Set$EmptySet$_iterator), "$foreach", $rt_wrapFunction1(sci_Set$EmptySet$_foreach), "$excl", $rt_wrapFunction1(sci_Set$EmptySet$_excl),
    "$incl", $rt_wrapFunction1(sci_Set$EmptySet$_incl), "$intersect", $rt_wrapFunction1(sci_Set$EmptySet$_intersect), "$removedAll0", $rt_wrapFunction1(sci_Set$EmptySet$_removedAll), "$filterNot1", $rt_wrapFunction1(sci_Set$EmptySet$_filterNot), "$filter1", $rt_wrapFunction1(sci_Set$EmptySet$_filter)],
    si_AnsiColor, 0, jl_Object, [], 3, 3, 0, 0, 0,
    s_Console$, 0, jl_Object, [si_AnsiColor], 4, 3, 0, s_Console$_$callClinit, 0,
    jl_NullPointerException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    sc_Iterator, "Iterator", 42, jl_Object, [sc_IterableOnce, sc_IterableOnceOps], 3, 3, 0, 0, 0,
    s_Function0, 0, jl_Object, [], 3, 3, 0, 0, ["$toString", $rt_wrapFunction0(s_Function0_toString)]]);
    $rt_metadata([srj_JFunction0$mcJ$sp, 0, jl_Object, [s_Function0, ji_Serializable], 3, 3, 0, 0, ["$apply2", $rt_wrapFunction0(srj_JFunction0$mcJ$sp_apply)],
    onciu_StepSequencer$$heuristicStepOrdering$lambda$_1_0, 0, jl_Object, [srj_JFunction0$mcJ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(srj_JFunction0$mcJ$sp_apply), "$apply$mcJ$sp", $rt_wrapFunction0(onciu_StepSequencer$$heuristicStepOrdering$lambda$_1_0_apply$mcJ$sp)],
    su_Random, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    sc_BuildFromLowPriority2, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sc_BuildFromLowPriority1, 0, jl_Object, [sc_BuildFromLowPriority2], 3, 3, 0, 0, 0,
    sc_BuildFrom$, 0, jl_Object, [sc_BuildFromLowPriority1], 4, 3, 0, 0, 0,
    onciu_StepSequencer$$anonfun$heuristicStepOrdering$3, "StepSequencer$$anonfun$heuristicStepOrdering$3", 20, jl_Object, [sm_Ordering], 4, 3, 0, 0, 0,
    jl_AssertionError, 0, jl_Error, [], 0, 3, 0, 0, 0,
    jl_Math, 0, jl_Object, [], 4, 3, 0, 0, 0,
    ju_Arrays, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jl_Object$Monitor, "Object$Monitor", 6, jl_Object, [], 0, 0, 0, 0, 0,
    jl_Runnable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_Thread, "Thread", 6, jl_Object, [jl_Runnable], 0, 3, 0, jl_Thread_$callClinit, 0,
    jl_IllegalMonitorStateException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    jl_Long, "Long", 6, jl_Number, [jl_Comparable], 0, 3, 0, 0, ["$intValue", $rt_wrapFunction0(jl_Long_intValue), "$longValue", $rt_wrapFunction0(jl_Long_longValue), "$floatValue", $rt_wrapFunction0(jl_Long_floatValue), "$doubleValue", $rt_wrapFunction0(jl_Long_doubleValue), "$toString", $rt_wrapFunction0(jl_Long_toString0), "$hashCode0", $rt_wrapFunction0(jl_Long_hashCode0), "$equals", $rt_wrapFunction1(jl_Long_equals)],
    ju_Random, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    s_PartialFunction$OrElse, 0, sr_AbstractPartialFunction, [ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(s_PartialFunction$OrElse_apply), "$applyOrElse", $rt_wrapFunction2(s_PartialFunction$OrElse_applyOrElse)],
    su_DynamicVariable, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jl_AutoCloseable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ji_Closeable, 0, jl_Object, [jl_AutoCloseable], 3, 3, 0, 0, 0,
    ji_Reader, 0, jl_Object, [ji_Closeable], 1, 3, 0, 0, 0,
    ji_BufferedReader, 0, ji_Reader, [], 0, 3, 0, 0, 0,
    ji_InputStreamReader, 0, ji_Reader, [], 0, 3, 0, 0, 0,
    otj_JSObject, 0, jl_Object, [], 3, 3, 0, 0, 0,
    otp_PlatformQueue, 0, jl_Object, [otj_JSObject], 1, 3, 0, 0, 0,
    otp_PlatformRunnable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jl_Object$monitorExit$lambda$_8_0, 0, jl_Object, [otp_PlatformRunnable], 0, 3, 0, 0, 0,
    scm_HashSet$, 0, jl_Object, [sc_IterableFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(scm_HashSet$_newBuilder), "$empty", $rt_wrapFunction0(scm_HashSet$_empty), "$from0", $rt_wrapFunction1(scm_HashSet$_from)],
    scm_TreeSet$, 0, jl_Object, [sc_SortedIterableFactory], 4, 3, 0, 0, 0,
    sc_BuildFrom, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sc_BuildFrom$$anon$5, 0, jl_Object, [sc_BuildFrom], 4, 3, 0, 0, 0,
    sc_BuildFrom$$anon$6, 0, jl_Object, [sc_BuildFrom], 4, 3, 0, 0, 0,
    ji_Flushable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ji_OutputStream, 0, jl_Object, [ji_Closeable, ji_Flushable], 1, 3, 0, 0, 0,
    ji_FilterOutputStream, 0, ji_OutputStream, [], 0, 3, 0, 0, 0,
    ji_PrintStream, 0, ji_FilterOutputStream, [], 0, 3, 0, 0, 0,
    otcic_ConsoleOutputStream, 0, ji_OutputStream, [], 1, 3, 0, 0, 0,
    otcic_StdoutOutputStream, 0, otcic_ConsoleOutputStream, [], 0, 3, 0, 0, ["$write0", $rt_wrapFunction3(otcic_StdoutOutputStream_write)],
    jl_ThreadLocal, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jl_InheritableThreadLocal, 0, jl_ThreadLocal, [], 0, 3, 0, 0, 0,
    su_DynamicVariable$$anon$1, 0, jl_InheritableThreadLocal, [], 4, 3, 0, 0, 0,
    otcic_StderrOutputStream, 0, otcic_ConsoleOutputStream, [], 0, 3, 0, 0, ["$write0", $rt_wrapFunction3(otcic_StderrOutputStream_write)],
    ji_InputStream, 0, jl_Object, [ji_Closeable], 1, 3, 0, 0, 0,
    jl_ConsoleInputStream, 0, ji_InputStream, [], 0, 0, 0, 0, 0,
    jnc_Charset, 0, jl_Object, [jl_Comparable], 1, 3, 0, 0, 0,
    jnci_UTF8Charset, 0, jnc_Charset, [], 0, 3, 0, 0, 0,
    oti_AsyncCallback, "AsyncCallback", 36, jl_Object, [], 3, 3, 0, 0, 0,
    otpp_AsyncCallbackWrapper, 0, jl_Object, [oti_AsyncCallback], 0, 0, 0, 0, ["$complete", $rt_wrapFunction1(otpp_AsyncCallbackWrapper_complete), "$error", $rt_wrapFunction1(otpp_AsyncCallbackWrapper_error)],
    jl_Object$monitorEnterWait$lambda$_6_0, 0, jl_Object, [otp_PlatformRunnable], 0, 3, 0, 0, 0,
    jl_Thread$UncaughtExceptionHandler, 0, jl_Object, [], 3, 3, 0, 0, 0]);
    $rt_metadata([jl_DefaultUncaughtExceptionHandler, 0, jl_Object, [jl_Thread$UncaughtExceptionHandler], 0, 3, 0, 0, 0,
    jnc_CodingErrorAction, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jnc_CharsetDecoder, 0, jl_Object, [], 1, 3, 0, 0, 0,
    jn_Buffer, 0, jl_Object, [], 1, 3, 0, 0, 0,
    jn_ByteBuffer, 0, jn_Buffer, [jl_Comparable], 1, 3, 0, 0, 0,
    jl_Readable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jn_CharBuffer, 0, jn_Buffer, [jl_Comparable, jl_Appendable, jl_CharSequence, jl_Readable], 1, 3, 0, 0, 0,
    jn_ByteBufferImpl, 0, jn_ByteBuffer, [], 0, 0, 0, 0, 0,
    jn_CharBufferImpl, 0, jn_CharBuffer, [], 1, 0, 0, 0, 0,
    jn_CharBufferOverArray, 0, jn_CharBufferImpl, [], 0, 0, 0, 0, 0,
    jnc_IllegalCharsetNameException, 0, jl_IllegalArgumentException, [], 0, 3, 0, 0, 0,
    jl_CloneNotSupportedException, 0, jl_Exception, [], 0, 3, 0, 0, 0,
    jn_ByteOrder, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_0_apply)],
    onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$MutableDirectedGraph$toString$lambda$_7_1_apply)],
    sc_Factory, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sc_IterableFactory$ToFactory, 0, jl_Object, [sc_Factory, ji_Serializable], 0, 3, 0, 0, ["$fromSpecific", $rt_wrapFunction1(sc_IterableFactory$ToFactory_fromSpecific)],
    sc_EvidenceIterableFactory$ToFactory, 0, jl_Object, [sc_Factory, ji_Serializable], 0, 3, 0, 0, ["$fromSpecific", $rt_wrapFunction1(sc_EvidenceIterableFactory$ToFactory_fromSpecific)],
    onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_0_apply)],
    onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$MutableDirectedGraph$$copyOf$lambda$_1_1_apply)],
    jnci_BufferedDecoder, 0, jnc_CharsetDecoder, [], 1, 3, 0, 0, 0,
    jnci_UTF8Decoder, 0, jnci_BufferedDecoder, [], 0, 3, 0, 0, 0,
    onciu_StepSequencer$AdjacencyList, "StepSequencer$AdjacencyList", 20, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(onciu_StepSequencer$AdjacencyList_productPrefix), "$productArity", $rt_wrapFunction0(onciu_StepSequencer$AdjacencyList_productArity), "$productElement", $rt_wrapFunction1(onciu_StepSequencer$AdjacencyList_productElement), "$productIterator", $rt_wrapFunction0(onciu_StepSequencer$AdjacencyList_productIterator), "$hashCode0", $rt_wrapFunction0(onciu_StepSequencer$AdjacencyList_hashCode),
    "$toString", $rt_wrapFunction0(onciu_StepSequencer$AdjacencyList_toString), "$equals", $rt_wrapFunction1(onciu_StepSequencer$AdjacencyList_equals)],
    sci_Range, 0, sci_AbstractSeq, [sci_IndexedSeq, sci_StrictOptimizedSeqOps, ji_Serializable], 1, 3, 0, 0, 0,
    sci_Range$Inclusive, 0, sci_Range, [], 4, 3, 0, 0, ["$isInclusive", $rt_wrapFunction0(sci_Range$Inclusive_isInclusive)],
    otpp_ResourceAccessor, 0, jl_Object, [], 4, 0, 0, 0, 0,
    otciu_UnicodeHelper, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sc_AbstractView, 0, sc_AbstractIterable, [sc_View], 1, 3, 0, 0, ["$iterableFactory", $rt_wrapFunction0(sc_AbstractView_iterableFactory), "$toString", $rt_wrapFunction0(sc_AbstractView_toString), "$stringPrefix", $rt_wrapFunction0(sc_AbstractView_stringPrefix)],
    sc_View$Map, "View$Map", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_View$Map_iterator), "$knownSize", $rt_wrapFunction0(sc_View$Map_knownSize), "$isEmpty", $rt_wrapFunction0(sc_View$Map_isEmpty)],
    sc_BuildFromLowPriority2$$anon$11, 0, jl_Object, [sc_BuildFrom], 4, 3, 0, 0, 0,
    sr_BoxedUnit, "BoxedUnit", 41, jl_Object, [ji_Serializable], 4, 3, [0,0,0], 0, ["$equals", $rt_wrapFunction1(sr_BoxedUnit_equals), "$hashCode0", $rt_wrapFunction0(sr_BoxedUnit_hashCode), "$toString", $rt_wrapFunction0(sr_BoxedUnit_toString)],
    sc_SeqFactory$Delegate, 0, jl_Object, [sc_SeqFactory], 0, 3, 0, 0, ["$from0", $rt_wrapFunction1(sc_SeqFactory$Delegate_from0), "$empty", $rt_wrapFunction0(sc_SeqFactory$Delegate_empty0), "$apply24", $rt_wrapFunction1(sc_SeqFactory$Delegate_apply0)],
    sci_Seq$, 0, sc_SeqFactory$Delegate, [], 4, 3, 0, sci_Seq$_$callClinit, ["$from0", $rt_wrapFunction1(sci_Seq$_from0)],
    otci_CharFlow, 0, jl_Object, [], 0, 3, 0, 0, 0,
    otci_Base46, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_0_apply)],
    onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$dealWithInvalidatedConditions$1$lambda$_20_1_apply)],
    sc_StrictOptimizedSeqFactory, 0, jl_Object, [sc_SeqFactory], 3, 3, 0, 0, 0,
    sci_List$, 0, jl_Object, [sc_StrictOptimizedSeqFactory], 4, 3, 0, sci_List$_$callClinit, ["$apply24", $rt_wrapFunction1(sci_List$_apply), "$newBuilder", $rt_wrapFunction0(sci_List$_newBuilder), "$empty", $rt_wrapFunction0(sci_List$_empty0), "$from0", $rt_wrapFunction1(sci_List$_from)],
    sci_List$$anon$1, "List$$anon$1", 43, jl_Object, [s_Function1], 4, 3, 0, 0, ["$toString", $rt_wrapFunction0(sci_List$$anon$1_toString), "$apply", $rt_wrapFunction1(sci_List$$anon$1_apply)],
    onciu_StepSequencer$Condition, "StepSequencer$Condition", 20, jl_Object, [], 3, 3, [onciu_StepSequencer,0,"Condition"], 0, 0,
    oncir_ValidatingCondition, 0, jl_Object, [s_Function1, onciu_StepSequencer$Condition], 3, 3, 0, 0, 0,
    oncifp_BaseContains, "BaseContains", 31, jl_Object, [oncir_ValidatingCondition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncifp_BaseContains_toString), "$unary_$bang", $rt_wrapFunction0(oncifp_BaseContains_unary_$bang), "$name3", $rt_wrapFunction0(oncifp_BaseContains_name), "$hashCode0", $rt_wrapFunction0(oncifp_BaseContains_hashCode), "$equals", $rt_wrapFunction1(oncifp_BaseContains_equals), "$productArity", $rt_wrapFunction0(oncifp_BaseContains_productArity), "$productElement",
    $rt_wrapFunction1(oncifp_BaseContains_productElement), "$productIterator", $rt_wrapFunction0(oncifp_BaseContains_productIterator), "$apply", $rt_wrapFunction1(oncifp_BaseContains_apply)],
    onciu_Foldable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_RewritableUniversal, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_Rewritable, 0, jl_Object, [onciu_RewritableUniversal], 3, 3, 0, 0, 0,
    onciu_ASTNode, 0, jl_Object, [s_Product, onciu_Foldable, onciu_Rewritable], 3, 3, 0, 0, 0,
    oncia_Statement, "Statement", 13, jl_Object, [onciu_ASTNode], 3, 3, [0,0,0], 0, 0,
    oncifp_ValidSymbolicNamesInLabelExpressions$, "ValidSymbolicNamesInLabelExpressions$", 31, jl_Object, [oncir_ValidatingCondition], 4, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncifp_ValidSymbolicNamesInLabelExpressions$_toString), "$unary_$bang", $rt_wrapFunction0(oncifp_ValidSymbolicNamesInLabelExpressions$_unary_$bang), "$name3", $rt_wrapFunction0(oncifp_ValidSymbolicNamesInLabelExpressions$_name), "$apply", $rt_wrapFunction1(oncifp_ValidSymbolicNamesInLabelExpressions$_apply)],
    scm_AbstractMap, 0, sc_AbstractMap, [scm_Map], 1, 3, 0, 0, ["$iterableFactory", $rt_wrapFunction0(scm_AbstractMap_iterableFactory), "$result0", $rt_wrapFunction0(scm_AbstractMap_result)]]);
    $rt_metadata([sc_StrictOptimizedMapOps, 0, jl_Object, [sc_MapOps, sc_StrictOptimizedIterableOps], 3, 3, 0, 0, 0,
    scm_HashMap, "HashMap", 44, scm_AbstractMap, [sc_StrictOptimizedMapOps, ji_Serializable], 0, 3, 0, 0, ["$map1", $rt_wrapFunction1(scm_HashMap_map), "$flatMap", $rt_wrapFunction1(scm_HashMap_flatMap), "$flatten", $rt_wrapFunction1(scm_HashMap_flatten), "$filter1", $rt_wrapFunction1(scm_HashMap_filter), "$filterNot1", $rt_wrapFunction1(scm_HashMap_filterNot), "$filterImpl", $rt_wrapFunction2(scm_HashMap_filterImpl), "$size", $rt_wrapFunction0(scm_HashMap_size), "$iterator0", $rt_wrapFunction0(scm_HashMap_iterator),
    "$keysIterator", $rt_wrapFunction0(scm_HashMap_keysIterator), "$valuesIterator", $rt_wrapFunction0(scm_HashMap_valuesIterator), "$get1", $rt_wrapFunction1(scm_HashMap_get), "$apply", $rt_wrapFunction1(scm_HashMap_apply), "$getOrElse0", $rt_wrapFunction2(scm_HashMap_getOrElse), "$knownSize", $rt_wrapFunction0(scm_HashMap_knownSize), "$isEmpty", $rt_wrapFunction0(scm_HashMap_isEmpty), "$foreach", $rt_wrapFunction1(scm_HashMap_foreach), "$foreachEntry", $rt_wrapFunction1(scm_HashMap_foreachEntry), "$mapFactory",
    $rt_wrapFunction0(scm_HashMap_mapFactory), "$stringPrefix", $rt_wrapFunction0(scm_HashMap_stringPrefix), "$hashCode0", $rt_wrapFunction0(scm_HashMap_hashCode), "$subtractOne", $rt_wrapFunction1(scm_HashMap_subtractOne), "$addOne", $rt_wrapFunction1(scm_HashMap_addOne), "$addAll0", $rt_wrapFunction1(scm_HashMap_addAll0)],
    sc_SortedOps, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sc_SortedSetOps, 0, jl_Object, [sc_SetOps, sc_SortedOps], 3, 3, 0, 0, 0,
    sc_SortedSetFactoryDefaults, 0, jl_Object, [sc_SortedSetOps], 3, 3, 0, 0, 0,
    sc_SortedSet, 0, jl_Object, [sc_Set, sc_SortedSetFactoryDefaults], 3, 3, 0, 0, 0,
    sci_SortedSetOps, 0, jl_Object, [sci_SetOps, sc_SortedSetOps], 3, 3, 0, 0, 0,
    sci_SortedSet, 0, jl_Object, [sci_Set, sc_SortedSet, sci_SortedSetOps], 3, 3, 0, 0, 0,
    scm_ReusableBuilder, 0, jl_Object, [scm_Builder], 3, 3, 0, 0, 0,
    sci_SetBuilderImpl, "SetBuilderImpl", 43, jl_Object, [scm_ReusableBuilder], 4, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1(sci_SetBuilderImpl_sizeHint), "$sizeHint0", $rt_wrapFunction2(sci_SetBuilderImpl_sizeHint0), "$addAll0", $rt_wrapFunction1(sci_SetBuilderImpl_addAll0), "$addOne", $rt_wrapFunction1(sci_SetBuilderImpl_addOne), "$result0", $rt_wrapFunction0(sci_SetBuilderImpl_result)],
    oncias_SemanticState, "SemanticState", 17, jl_Object, [s_Product, ji_Serializable], 0, 3, [0,0,0], 0, ["$productPrefix", $rt_wrapFunction0(oncias_SemanticState_productPrefix), "$productArity", $rt_wrapFunction0(oncias_SemanticState_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticState_productElement), "$productIterator", $rt_wrapFunction0(oncias_SemanticState_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticState_hashCode), "$toString", $rt_wrapFunction0(oncias_SemanticState_toString),
    "$equals", $rt_wrapFunction1(oncias_SemanticState_equals)],
    oncias_SemanticTable, "SemanticTable", 17, jl_Object, [jl_Cloneable], 0, 3, [0,0,0], 0, 0,
    oncifp_Phase$transform$lambda$_2_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    oncifh_package$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_Transformer$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncifp_Transformer$$anonfun$1_applyOrElse)],
    scm_HashMap$Node, "HashMap$Node", 44, jl_Object, [], 4, 3, [scm_HashMap,0,"Node"], 0, ["$toString", $rt_wrapFunction0(scm_HashMap$Node_toString)],
    oncifh_package$$closing$default$3$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncifh_package$$closing$default$4$lambda$_3_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    oncifh_package$$closing$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    sr_ClassValueCompat$ClassValueInterface, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sr_ClassValueCompat, 0, jl_Object, [sr_ClassValueCompat$ClassValueInterface], 1, 3, 0, 0, 0,
    sr_ClassTag$cache$, 0, sr_ClassValueCompat, [], 0, 3, 0, sr_ClassTag$cache$_$callClinit, 0,
    jlr_Reference, 0, jl_Object, [], 1, 3, 0, 0, 0,
    jlr_WeakReference, 0, jlr_Reference, [], 0, 3, 0, 0, 0,
    oncifp_DeprecatedSyntaxReplaced$, "DeprecatedSyntaxReplaced$", 31, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncifp_DeprecatedSyntaxReplaced$_unary_$bang), "$productArity", $rt_wrapFunction0(oncifp_DeprecatedSyntaxReplaced$_productArity), "$productElement", $rt_wrapFunction1(oncifp_DeprecatedSyntaxReplaced$_productElement), "$productIterator", $rt_wrapFunction0(oncifp_DeprecatedSyntaxReplaced$_productIterator), "$hashCode0", $rt_wrapFunction0(oncifp_DeprecatedSyntaxReplaced$_hashCode),
    "$toString", $rt_wrapFunction0(oncifp_DeprecatedSyntaxReplaced$_toString)],
    oncifp_DeprecatedSemanticsReplaced$, "DeprecatedSemanticsReplaced$", 31, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncifp_DeprecatedSemanticsReplaced$_unary_$bang), "$productArity", $rt_wrapFunction0(oncifp_DeprecatedSemanticsReplaced$_productArity), "$productElement", $rt_wrapFunction1(oncifp_DeprecatedSemanticsReplaced$_productElement), "$productIterator", $rt_wrapFunction0(oncifp_DeprecatedSemanticsReplaced$_productIterator), "$hashCode0",
    $rt_wrapFunction0(oncifp_DeprecatedSemanticsReplaced$_hashCode), "$toString", $rt_wrapFunction0(oncifp_DeprecatedSemanticsReplaced$_toString)],
    oncifpf_PlanPipelineTransformerFactory, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncifp_SemanticAnalysis$, 0, jl_Object, [onciu_StepSequencer$Step, oncifpf_ParsePipelineTransformerFactory, oncifpf_PlanPipelineTransformerFactory, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    oncifp_PreparatoryRewriting$SemanticAnalysisPossible$, "PreparatoryRewriting$SemanticAnalysisPossible$", 31, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_unary_$bang), "$productArity", $rt_wrapFunction0(oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_productArity), "$productElement", $rt_wrapFunction1(oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_productElement), "$productIterator",
    $rt_wrapFunction0(oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_productIterator), "$hashCode0", $rt_wrapFunction0(oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_hashCode), "$toString", $rt_wrapFunction0(oncifp_PreparatoryRewriting$SemanticAnalysisPossible$_toString)],
    oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$, "SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$", 31, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_unary_$bang), "$productArity", $rt_wrapFunction0(oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_productArity), "$productElement", $rt_wrapFunction1(oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_productElement),
    "$productIterator", $rt_wrapFunction0(oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_productIterator), "$hashCode0", $rt_wrapFunction0(oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_hashCode), "$toString", $rt_wrapFunction0(oncifp_SemanticTypeCheck$AdditionalSemanticTypeChecksPerformed$_toString)],
    ju_NoSuchElementException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    s_Array$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sci_Range$Exclusive, 0, sci_Range, [], 4, 3, 0, 0, ["$isInclusive", $rt_wrapFunction0(sci_Range$Exclusive_isInclusive)],
    oncifp_CompilationPhaseTracer, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sci_HashSetBuilder, "HashSetBuilder", 43, jl_Object, [scm_ReusableBuilder], 4, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1(sci_HashSetBuilder_sizeHint), "$sizeHint0", $rt_wrapFunction2(sci_HashSetBuilder_sizeHint0), "$addAll0", $rt_wrapFunction1(sci_HashSetBuilder_addAll0), "$addOne", $rt_wrapFunction1(sci_HashSetBuilder_addOne0), "$result0", $rt_wrapFunction0(sci_HashSetBuilder_result0)],
    jl_Float, "Float", 6, jl_Number, [jl_Comparable], 0, 3, 0, 0, ["$intValue", $rt_wrapFunction0(jl_Float_intValue), "$longValue", $rt_wrapFunction0(jl_Float_longValue), "$floatValue", $rt_wrapFunction0(jl_Float_floatValue), "$doubleValue", $rt_wrapFunction0(jl_Float_doubleValue), "$toString", $rt_wrapFunction0(jl_Float_toString), "$equals", $rt_wrapFunction1(jl_Float_equals), "$hashCode0", $rt_wrapFunction0(jl_Float_hashCode0)],
    jl_AbstractStringBuilder$Constants, 0, jl_Object, [], 0, 0, 0, 0, 0,
    otcit_FloatAnalyzer, 0, jl_Object, [], 4, 3, 0, 0, 0,
    otcit_FloatAnalyzer$Result, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sc_MapOps$GenKeySet, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sc_MapOps$KeySet, 0, sc_AbstractSet, [sc_MapOps$GenKeySet, scg_DefaultSerializable], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_MapOps$KeySet_iterator), "$knownSize", $rt_wrapFunction0(sc_MapOps$KeySet_knownSize), "$scala$collection$MapOps$GenKeySet$$$outer", $rt_wrapFunction0(sc_MapOps$KeySet_scala$collection$MapOps$GenKeySet$$$outer)],
    jl_Double, "Double", 6, jl_Number, [jl_Comparable], 0, 3, 0, 0, ["$doubleValue", $rt_wrapFunction0(jl_Double_doubleValue), "$intValue", $rt_wrapFunction0(jl_Double_intValue), "$longValue", $rt_wrapFunction0(jl_Double_longValue), "$floatValue", $rt_wrapFunction0(jl_Double_floatValue), "$toString", $rt_wrapFunction0(jl_Double_toString), "$equals", $rt_wrapFunction1(jl_Double_equals), "$hashCode0", $rt_wrapFunction0(jl_Double_hashCode0)],
    scm_Buffer$, 0, sc_SeqFactory$Delegate, [], 4, 3, 0, scm_Buffer$_$callClinit, 0,
    oncifp_CompilationPhaseTracer$CompilationPhaseEvent, 0, jl_Object, [jl_AutoCloseable], 3, 3, 0, 0, 0,
    oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_0, 0, jl_Object, [oncifp_CompilationPhaseTracer$CompilationPhaseEvent], 0, 3, 0, 0, 0,
    oncifp_CompilationPhaseTracer$_clinit_$lambda$_3_1, 0, jl_Object, [oncifp_CompilationPhaseTracer], 0, 3, 0, 0, 0,
    otcit_DoubleAnalyzer$Result, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sr_ClassValueCompat$, 0, jl_Object, [], 4, 3, 0, sr_ClassValueCompat$_$callClinit, 0,
    sr_ClassValueCompat$FallbackClassValue, 0, jl_Object, [sr_ClassValueCompat$ClassValueInterface], 0, 3, 0, 0, ["$get2", $rt_wrapFunction1(sr_ClassValueCompat$FallbackClassValue_get)],
    jl_ClassValue, 0, jl_Object, [], 1, 3, 0, 0, ["$get2", $rt_wrapFunction1(jl_ClassValue_get)]]);
    $rt_metadata([sr_ClassValueCompat$JavaClassValue, 0, jl_ClassValue, [sr_ClassValueCompat$ClassValueInterface], 0, 3, 0, 0, 0,
    scm_ArrayBuffer$, 0, jl_Object, [sc_StrictOptimizedSeqFactory], 4, 3, 0, 0, ["$apply24", $rt_wrapFunction1(scm_ArrayBuffer$_apply), "$newBuilder", $rt_wrapFunction0(scm_ArrayBuffer$_newBuilder), "$empty", $rt_wrapFunction0(scm_ArrayBuffer$_empty), "$from0", $rt_wrapFunction1(scm_ArrayBuffer$_from)],
    jl_ReflectiveOperationException, 0, jl_Exception, [], 0, 3, 0, 0, 0,
    jl_ClassNotFoundException, 0, jl_ReflectiveOperationException, [], 0, 3, 0, 0, 0,
    sr_ClassTag$GenericClassTag, 0, jl_Object, [sr_ClassTag], 0, 3, 0, 0, ["$unapply0", $rt_wrapFunction1(sr_ClassTag$GenericClassTag_unapply), "$equals", $rt_wrapFunction1(sr_ClassTag$GenericClassTag_equals), "$hashCode0", $rt_wrapFunction0(sr_ClassTag$GenericClassTag_hashCode), "$runtimeClass", $rt_wrapFunction0(sr_ClassTag$GenericClassTag_runtimeClass), "$newArray", $rt_wrapFunction1(sr_ClassTag$GenericClassTag_newArray)],
    oncifp_StatementCondition, "StatementCondition", 31, jl_Object, [oncir_ValidatingCondition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncifp_StatementCondition_toString), "$unary_$bang", $rt_wrapFunction0(oncifp_StatementCondition_unary_$bang), "$name3", $rt_wrapFunction0(oncifp_StatementCondition_name), "$productPrefix", $rt_wrapFunction0(oncifp_StatementCondition_productPrefix), "$productArity", $rt_wrapFunction0(oncifp_StatementCondition_productArity), "$productElement", $rt_wrapFunction1(oncifp_StatementCondition_productElement),
    "$productIterator", $rt_wrapFunction0(oncifp_StatementCondition_productIterator), "$hashCode0", $rt_wrapFunction0(oncifp_StatementCondition_hashCode), "$equals", $rt_wrapFunction1(oncifp_StatementCondition_equals), "$apply", $rt_wrapFunction1(oncifp_StatementCondition_apply)],
    oncirc_containsNoNodesOfType, "containsNoNodesOfType", 26, jl_Object, [oncir_ValidatingCondition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncirc_containsNoNodesOfType_toString), "$unary_$bang", $rt_wrapFunction0(oncirc_containsNoNodesOfType_unary_$bang), "$name3", $rt_wrapFunction0(oncirc_containsNoNodesOfType_name), "$hashCode0", $rt_wrapFunction0(oncirc_containsNoNodesOfType_hashCode), "$equals", $rt_wrapFunction1(oncirc_containsNoNodesOfType_equals), "$productArity", $rt_wrapFunction0(oncirc_containsNoNodesOfType_productArity),
    "$productElement", $rt_wrapFunction1(oncirc_containsNoNodesOfType_productElement), "$productIterator", $rt_wrapFunction0(oncirc_containsNoNodesOfType_productIterator), "$apply", $rt_wrapFunction1(oncirc_containsNoNodesOfType_apply)],
    oncias_SemanticCheckable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_ReturnItem, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable], 3, 3, 0, 0, 0,
    oncia_UnaliasedReturnItem, "UnaliasedReturnItem", 13, jl_Object, [oncia_ReturnItem, ji_Serializable], 0, 3, [0,0,0], 0, ["$isPassThrough", $rt_wrapFunction0(oncia_UnaliasedReturnItem_isPassThrough), "$semanticCheck", $rt_wrapFunction0(oncia_UnaliasedReturnItem_semanticCheck), "$expression1", $rt_wrapFunction0(oncia_UnaliasedReturnItem_expression), "$position2", $rt_wrapFunction0(oncia_UnaliasedReturnItem_position), "$alias", $rt_wrapFunction0(oncia_UnaliasedReturnItem_alias), "$name3", $rt_wrapFunction0(oncia_UnaliasedReturnItem_name),
    "$productPrefix", $rt_wrapFunction0(oncia_UnaliasedReturnItem_productPrefix), "$productArity", $rt_wrapFunction0(oncia_UnaliasedReturnItem_productArity), "$productElement", $rt_wrapFunction1(oncia_UnaliasedReturnItem_productElement), "$productIterator", $rt_wrapFunction0(oncia_UnaliasedReturnItem_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_UnaliasedReturnItem_hashCode), "$toString", $rt_wrapFunction0(oncia_UnaliasedReturnItem_toString), "$equals", $rt_wrapFunction1(oncia_UnaliasedReturnItem_equals),
    "$dup", $rt_wrapFunction1(oncia_UnaliasedReturnItem_dup)],
    oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$, "computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_productArity), "$productElement",
    $rt_wrapFunction1(oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_hashCode), "$toString", $rt_wrapFunction0(oncirr_computeDependenciesForExpressions$ExpressionsHaveComputedDependencies$_toString)],
    oncirc_package$, 0, jl_Object, [], 4, 3, 0, oncirc_package$_$callClinit, 0,
    oncirc_package$SensitiveLiteralsExtracted$, "package$SensitiveLiteralsExtracted$", 26, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirc_package$SensitiveLiteralsExtracted$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirc_package$SensitiveLiteralsExtracted$_productArity), "$productElement", $rt_wrapFunction1(oncirc_package$SensitiveLiteralsExtracted$_productElement), "$productIterator", $rt_wrapFunction0(oncirc_package$SensitiveLiteralsExtracted$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirc_package$SensitiveLiteralsExtracted$_hashCode), "$toString", $rt_wrapFunction0(oncirc_package$SensitiveLiteralsExtracted$_toString)],
    scm_AbstractSet, 0, sc_AbstractSet, [scm_Set], 1, 3, 0, 0, ["$iterableFactory", $rt_wrapFunction0(scm_AbstractSet_iterableFactory), "$remove", $rt_wrapFunction1(scm_AbstractSet_remove), "$subtractAll", $rt_wrapFunction1(scm_AbstractSet_subtractAll), "$addAll0", $rt_wrapFunction1(scm_AbstractSet_addAll), "$result0", $rt_wrapFunction0(scm_AbstractSet_result0)],
    scm_HashSet, "HashSet", 44, scm_AbstractSet, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$map1", $rt_wrapFunction1(scm_HashSet_map), "$flatMap", $rt_wrapFunction1(scm_HashSet_flatMap), "$flatten", $rt_wrapFunction1(scm_HashSet_flatten), "$filter1", $rt_wrapFunction1(scm_HashSet_filter), "$filterNot1", $rt_wrapFunction1(scm_HashSet_filterNot), "$filterImpl", $rt_wrapFunction2(scm_HashSet_filterImpl), "$size", $rt_wrapFunction0(scm_HashSet_size), "$contains0", $rt_wrapFunction1(scm_HashSet_contains),
    "$remove", $rt_wrapFunction1(scm_HashSet_remove), "$iterator0", $rt_wrapFunction0(scm_HashSet_iterator), "$clear", $rt_wrapFunction0(scm_HashSet_clear), "$iterableFactory", $rt_wrapFunction0(scm_HashSet_iterableFactory), "$knownSize", $rt_wrapFunction0(scm_HashSet_knownSize), "$isEmpty", $rt_wrapFunction0(scm_HashSet_isEmpty), "$foreach", $rt_wrapFunction1(scm_HashSet_foreach), "$className", $rt_wrapFunction0(scm_HashSet_className), "$hashCode0", $rt_wrapFunction0(scm_HashSet_hashCode), "$subtractOne", $rt_wrapFunction1(scm_HashSet_subtractOne),
    "$addOne", $rt_wrapFunction1(scm_HashSet_addOne), "$subtractAll", $rt_wrapFunction1(scm_HashSet_subtractAll), "$addAll0", $rt_wrapFunction1(scm_HashSet_addAll0)],
    sc_AbstractIterator, 0, jl_Object, [sc_Iterator], 1, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_AbstractIterator_iterator), "$contains0", $rt_wrapFunction1(sc_AbstractIterator_contains), "$grouped", $rt_wrapFunction1(sc_AbstractIterator_grouped), "$sliding0", $rt_wrapFunction2(sc_AbstractIterator_sliding), "$indexWhere", $rt_wrapFunction2(sc_AbstractIterator_indexWhere), "$isEmpty", $rt_wrapFunction0(sc_AbstractIterator_isEmpty), "$filter", $rt_wrapFunction1(sc_AbstractIterator_filter), "$filterImpl0", $rt_wrapFunction2(sc_AbstractIterator_filterImpl),
    "$collect3", $rt_wrapFunction1(sc_AbstractIterator_collect), "$distinctBy0", $rt_wrapFunction1(sc_AbstractIterator_distinctBy), "$map7", $rt_wrapFunction1(sc_AbstractIterator_map), "$flatMap2", $rt_wrapFunction1(sc_AbstractIterator_flatMap), "$concat", $rt_wrapFunction1(sc_AbstractIterator_concat), "$take", $rt_wrapFunction1(sc_AbstractIterator_take), "$takeWhile1", $rt_wrapFunction1(sc_AbstractIterator_takeWhile), "$drop1", $rt_wrapFunction1(sc_AbstractIterator_drop), "$dropWhile1", $rt_wrapFunction1(sc_AbstractIterator_dropWhile),
    "$sliceIterator", $rt_wrapFunction2(sc_AbstractIterator_sliceIterator), "$sameElements", $rt_wrapFunction1(sc_AbstractIterator_sameElements), "$toString", $rt_wrapFunction0(sc_AbstractIterator_toString), "$foreach", $rt_wrapFunction1(sc_AbstractIterator_foreach), "$exists", $rt_wrapFunction1(sc_AbstractIterator_exists), "$find0", $rt_wrapFunction1(sc_AbstractIterator_find), "$foldLeft", $rt_wrapFunction2(sc_AbstractIterator_foldLeft), "$reduceLeft", $rt_wrapFunction1(sc_AbstractIterator_reduceLeft), "$nonEmpty0",
    $rt_wrapFunction0(sc_AbstractIterator_nonEmpty), "$size", $rt_wrapFunction0(sc_AbstractIterator_size), "$copyToArray1", $rt_wrapFunction1(sc_AbstractIterator_copyToArray), "$copyToArray0", $rt_wrapFunction2(sc_AbstractIterator_copyToArray0), "$copyToArray", $rt_wrapFunction3(sc_AbstractIterator_copyToArray1), "$addString", $rt_wrapFunction4(sc_AbstractIterator_addString), "$to0", $rt_wrapFunction1(sc_AbstractIterator_to), "$toList", $rt_wrapFunction0(sc_AbstractIterator_toList), "$toSeq", $rt_wrapFunction0(sc_AbstractIterator_toSeq),
    "$toArray", $rt_wrapFunction1(sc_AbstractIterator_toArray), "$knownSize", $rt_wrapFunction0(sc_AbstractIterator_knownSize)],
    sc_ArrayOps$ArrayIterator, "ArrayOps$ArrayIterator", 42, sc_AbstractIterator, [ji_Serializable], 0, 3, 0, 0, ["$knownSize", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator_knownSize), "$hasNext", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator_hasNext), "$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator_next), "$drop1", $rt_wrapFunction1(sc_ArrayOps$ArrayIterator_drop)],
    sc_Iterator$, 0, jl_Object, [sc_IterableFactory], 4, 3, 0, 0, 0,
    jl_ClassLoader, 0, jl_Object, [], 1, 3, 0, jl_ClassLoader_$callClinit, 0,
    jlr_Array, 0, jl_Object, [], 4, 3, 0, 0, 0,
    jl_ArrayStoreException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    oncirc_package$PatternExpressionsHaveSemanticInfo$, "package$PatternExpressionsHaveSemanticInfo$", 26, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirc_package$PatternExpressionsHaveSemanticInfo$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirc_package$PatternExpressionsHaveSemanticInfo$_productArity), "$productElement", $rt_wrapFunction1(oncirc_package$PatternExpressionsHaveSemanticInfo$_productElement), "$productIterator",
    $rt_wrapFunction0(oncirc_package$PatternExpressionsHaveSemanticInfo$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirc_package$PatternExpressionsHaveSemanticInfo$_hashCode), "$toString", $rt_wrapFunction0(oncirc_package$PatternExpressionsHaveSemanticInfo$_toString)],
    oncirr_ProjectionClausesHaveSemanticInfo$, "ProjectionClausesHaveSemanticInfo$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_ProjectionClausesHaveSemanticInfo$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_ProjectionClausesHaveSemanticInfo$_productArity), "$productElement", $rt_wrapFunction1(oncirr_ProjectionClausesHaveSemanticInfo$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_ProjectionClausesHaveSemanticInfo$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_ProjectionClausesHaveSemanticInfo$_hashCode), "$toString", $rt_wrapFunction0(oncirr_ProjectionClausesHaveSemanticInfo$_toString)],
    scm_HashSet$Node, "HashSet$Node", 44, jl_Object, [], 4, 3, [scm_HashSet,0,"Node"], 0, ["$toString", $rt_wrapFunction0(scm_HashSet$Node_toString)],
    sci_Set$Set1, "Set$Set1", 43, sci_AbstractSet, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$partition", $rt_wrapFunction1(sci_Set$Set1_partition), "$map1", $rt_wrapFunction1(sci_Set$Set1_map), "$flatMap", $rt_wrapFunction1(sci_Set$Set1_flatMap), "$collect0", $rt_wrapFunction1(sci_Set$Set1_collect), "$flatten", $rt_wrapFunction1(sci_Set$Set1_flatten), "$filter1", $rt_wrapFunction1(sci_Set$Set1_filter), "$filterNot1", $rt_wrapFunction1(sci_Set$Set1_filterNot), "$size", $rt_wrapFunction0(sci_Set$Set1_size),
    "$isEmpty", $rt_wrapFunction0(sci_Set$Set1_isEmpty), "$knownSize", $rt_wrapFunction0(sci_Set$Set1_knownSize), "$contains0", $rt_wrapFunction1(sci_Set$Set1_contains), "$iterator0", $rt_wrapFunction0(sci_Set$Set1_iterator), "$foreach", $rt_wrapFunction1(sci_Set$Set1_foreach), "$exists", $rt_wrapFunction1(sci_Set$Set1_exists), "$forall", $rt_wrapFunction1(sci_Set$Set1_forall), "$find0", $rt_wrapFunction1(sci_Set$Set1_find), "$head", $rt_wrapFunction0(sci_Set$Set1_head), "$tail", $rt_wrapFunction0(sci_Set$Set1_tail),
    "$filterImpl", $rt_wrapFunction2(sci_Set$Set1_filterImpl), "$excl", $rt_wrapFunction1(sci_Set$Set1_excl), "$incl", $rt_wrapFunction1(sci_Set$Set1_incl)],
    sci_Set$Set2, "Set$Set2", 43, sci_AbstractSet, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$partition", $rt_wrapFunction1(sci_Set$Set2_partition), "$map1", $rt_wrapFunction1(sci_Set$Set2_map), "$flatMap", $rt_wrapFunction1(sci_Set$Set2_flatMap), "$collect0", $rt_wrapFunction1(sci_Set$Set2_collect), "$flatten", $rt_wrapFunction1(sci_Set$Set2_flatten), "$filter1", $rt_wrapFunction1(sci_Set$Set2_filter), "$filterNot1", $rt_wrapFunction1(sci_Set$Set2_filterNot), "$size", $rt_wrapFunction0(sci_Set$Set2_size),
    "$isEmpty", $rt_wrapFunction0(sci_Set$Set2_isEmpty), "$knownSize", $rt_wrapFunction0(sci_Set$Set2_knownSize), "$contains0", $rt_wrapFunction1(sci_Set$Set2_contains), "$iterator0", $rt_wrapFunction0(sci_Set$Set2_iterator), "$foreach", $rt_wrapFunction1(sci_Set$Set2_foreach), "$exists", $rt_wrapFunction1(sci_Set$Set2_exists), "$forall", $rt_wrapFunction1(sci_Set$Set2_forall), "$find0", $rt_wrapFunction1(sci_Set$Set2_find), "$head", $rt_wrapFunction0(sci_Set$Set2_head), "$tail", $rt_wrapFunction0(sci_Set$Set2_tail),
    "$filterImpl", $rt_wrapFunction2(sci_Set$Set2_filterImpl), "$excl", $rt_wrapFunction1(sci_Set$Set2_excl), "$incl", $rt_wrapFunction1(sci_Set$Set2_incl)],
    sc_SetOps$concat$lambda$_23_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(sc_SetOps$concat$lambda$_23_0_apply)],
    sc_View$Concat, "View$Concat", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_View$Concat_iterator), "$knownSize", $rt_wrapFunction0(sc_View$Concat_knownSize), "$isEmpty", $rt_wrapFunction0(sc_View$Concat_isEmpty)],
    sci_Set$Set3, "Set$Set3", 43, sci_AbstractSet, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$partition", $rt_wrapFunction1(sci_Set$Set3_partition), "$map1", $rt_wrapFunction1(sci_Set$Set3_map), "$flatMap", $rt_wrapFunction1(sci_Set$Set3_flatMap), "$collect0", $rt_wrapFunction1(sci_Set$Set3_collect), "$flatten", $rt_wrapFunction1(sci_Set$Set3_flatten), "$filter1", $rt_wrapFunction1(sci_Set$Set3_filter), "$filterNot1", $rt_wrapFunction1(sci_Set$Set3_filterNot), "$size", $rt_wrapFunction0(sci_Set$Set3_size),
    "$isEmpty", $rt_wrapFunction0(sci_Set$Set3_isEmpty), "$knownSize", $rt_wrapFunction0(sci_Set$Set3_knownSize), "$contains0", $rt_wrapFunction1(sci_Set$Set3_contains), "$iterator0", $rt_wrapFunction0(sci_Set$Set3_iterator), "$foreach", $rt_wrapFunction1(sci_Set$Set3_foreach), "$exists", $rt_wrapFunction1(sci_Set$Set3_exists), "$forall", $rt_wrapFunction1(sci_Set$Set3_forall), "$find0", $rt_wrapFunction1(sci_Set$Set3_find), "$head", $rt_wrapFunction0(sci_Set$Set3_head), "$tail", $rt_wrapFunction0(sci_Set$Set3_tail),
    "$filterImpl", $rt_wrapFunction2(sci_Set$Set3_filterImpl), "$excl", $rt_wrapFunction1(sci_Set$Set3_excl), "$incl", $rt_wrapFunction1(sci_Set$Set3_incl)],
    sci_Set$Set4, "Set$Set4", 43, sci_AbstractSet, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$partition", $rt_wrapFunction1(sci_Set$Set4_partition), "$map1", $rt_wrapFunction1(sci_Set$Set4_map), "$flatMap", $rt_wrapFunction1(sci_Set$Set4_flatMap), "$collect0", $rt_wrapFunction1(sci_Set$Set4_collect), "$flatten", $rt_wrapFunction1(sci_Set$Set4_flatten), "$filter1", $rt_wrapFunction1(sci_Set$Set4_filter), "$filterNot1", $rt_wrapFunction1(sci_Set$Set4_filterNot), "$size", $rt_wrapFunction0(sci_Set$Set4_size),
    "$isEmpty", $rt_wrapFunction0(sci_Set$Set4_isEmpty), "$knownSize", $rt_wrapFunction0(sci_Set$Set4_knownSize), "$contains0", $rt_wrapFunction1(sci_Set$Set4_contains), "$iterator0", $rt_wrapFunction0(sci_Set$Set4_iterator), "$foreach", $rt_wrapFunction1(sci_Set$Set4_foreach), "$exists", $rt_wrapFunction1(sci_Set$Set4_exists), "$forall", $rt_wrapFunction1(sci_Set$Set4_forall), "$find0", $rt_wrapFunction1(sci_Set$Set4_find), "$head", $rt_wrapFunction0(sci_Set$Set4_head), "$tail", $rt_wrapFunction0(sci_Set$Set4_tail),
    "$filterImpl", $rt_wrapFunction2(sci_Set$Set4_filterImpl), "$excl", $rt_wrapFunction1(sci_Set$Set4_excl), "$incl", $rt_wrapFunction1(sci_Set$Set4_incl)],
    sc_Iterator$$anon$19, "Iterator$$anon$19", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(sc_Iterator$$anon$19_hasNext), "$knownSize", $rt_wrapFunction0(sc_Iterator$$anon$19_knownSize), "$sliceIterator", $rt_wrapFunction2(sc_Iterator$$anon$19_sliceIterator), "$next", $rt_wrapFunction0(sc_Iterator$$anon$19_next)],
    jl_SystemClassLoader, 0, jl_ClassLoader, [], 0, 0, 0, 0, 0,
    jl_ClassValue$Item, 0, jl_Object, [], 0, 0, 0, 0, 0,
    scm_ListBuffer, "ListBuffer", 44, scm_AbstractBuffer, [sc_StrictOptimizedSeqOps, scm_ReusableBuilder, scg_DefaultSerializable], 0, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1(scm_ListBuffer_sizeHint), "$sizeHint0", $rt_wrapFunction2(scm_ListBuffer_sizeHint0), "$distinctBy", $rt_wrapFunction1(scm_ListBuffer_distinctBy), "$prepended", $rt_wrapFunction1(scm_ListBuffer_prepended), "$appended", $rt_wrapFunction1(scm_ListBuffer_appended), "$appendedAll", $rt_wrapFunction1(scm_ListBuffer_appendedAll), "$map1", $rt_wrapFunction1(scm_ListBuffer_map),
    "$flatMap", $rt_wrapFunction1(scm_ListBuffer_flatMap), "$flatten", $rt_wrapFunction1(scm_ListBuffer_flatten), "$filter1", $rt_wrapFunction1(scm_ListBuffer_filter), "$filterNot1", $rt_wrapFunction1(scm_ListBuffer_filterNot), "$filterImpl", $rt_wrapFunction2(scm_ListBuffer_filterImpl), "$iterator0", $rt_wrapFunction0(scm_ListBuffer_iterator), "$apply1", $rt_wrapFunction1(scm_ListBuffer_apply), "$length", $rt_wrapFunction0(scm_ListBuffer_length), "$knownSize", $rt_wrapFunction0(scm_ListBuffer_knownSize), "$isEmpty",
    $rt_wrapFunction0(scm_ListBuffer_isEmpty), "$toList", $rt_wrapFunction0(scm_ListBuffer_toList), "$stringPrefix", $rt_wrapFunction0(scm_ListBuffer_stringPrefix), "$addAll0", $rt_wrapFunction1(scm_ListBuffer_addAll0), "$addOne", $rt_wrapFunction1(scm_ListBuffer_addOne), "$result0", $rt_wrapFunction0(scm_ListBuffer_result), "$apply", $rt_wrapFunction1(scm_ListBuffer_apply0), "$iterableFactory", $rt_wrapFunction0(scm_ListBuffer_iterableFactory)],
    jl_Byte, "Byte", 6, jl_Number, [jl_Comparable], 0, 3, 0, 0, ["$intValue", $rt_wrapFunction0(jl_Byte_intValue), "$longValue", $rt_wrapFunction0(jl_Byte_longValue), "$floatValue", $rt_wrapFunction0(jl_Byte_floatValue), "$doubleValue", $rt_wrapFunction0(jl_Byte_doubleValue), "$toString", $rt_wrapFunction0(jl_Byte_toString), "$equals", $rt_wrapFunction1(jl_Byte_equals), "$hashCode0", $rt_wrapFunction0(jl_Byte_hashCode)],
    jl_Short, "Short", 6, jl_Number, [jl_Comparable], 0, 3, 0, 0, ["$intValue", $rt_wrapFunction0(jl_Short_intValue), "$longValue", $rt_wrapFunction0(jl_Short_longValue), "$floatValue", $rt_wrapFunction0(jl_Short_floatValue), "$doubleValue", $rt_wrapFunction0(jl_Short_doubleValue), "$toString", $rt_wrapFunction0(jl_Short_toString), "$equals", $rt_wrapFunction1(jl_Short_equals), "$hashCode0", $rt_wrapFunction0(jl_Short_hashCode)],
    sci_Node, 0, jl_Object, [], 1, 3, 0, 0, 0,
    sci_SetNode, 0, sci_Node, [], 1, 3, 0, 0, 0,
    sci_BitmapIndexedSetNode, "BitmapIndexedSetNode", 43, sci_SetNode, [], 4, 3, 0, 0, ["$size", $rt_wrapFunction0(sci_BitmapIndexedSetNode_size), "$cachedJavaKeySetHashCode", $rt_wrapFunction0(sci_BitmapIndexedSetNode_cachedJavaKeySetHashCode), "$getPayload", $rt_wrapFunction1(sci_BitmapIndexedSetNode_getPayload), "$getHash", $rt_wrapFunction1(sci_BitmapIndexedSetNode_getHash), "$contains1", $rt_wrapFunction4(sci_BitmapIndexedSetNode_contains), "$hasPayload", $rt_wrapFunction0(sci_BitmapIndexedSetNode_hasPayload),
    "$payloadArity", $rt_wrapFunction0(sci_BitmapIndexedSetNode_payloadArity), "$hasNodes", $rt_wrapFunction0(sci_BitmapIndexedSetNode_hasNodes), "$nodeArity", $rt_wrapFunction0(sci_BitmapIndexedSetNode_nodeArity), "$foreach", $rt_wrapFunction1(sci_BitmapIndexedSetNode_foreach), "$equals", $rt_wrapFunction1(sci_BitmapIndexedSetNode_equals), "$hashCode0", $rt_wrapFunction0(sci_BitmapIndexedSetNode_hashCode), "$foreachWithHash0", $rt_wrapFunction1(sci_BitmapIndexedSetNode_foreachWithHash), "$foreachWithHashWhile",
    $rt_wrapFunction1(sci_BitmapIndexedSetNode_foreachWithHashWhile), "$concat3", $rt_wrapFunction2(sci_BitmapIndexedSetNode_concat0), "$copy20", $rt_wrapFunction0(sci_BitmapIndexedSetNode_copy0), "$diff", $rt_wrapFunction2(sci_BitmapIndexedSetNode_diff0), "$filterImpl1", $rt_wrapFunction2(sci_BitmapIndexedSetNode_filterImpl0), "$removed0", $rt_wrapFunction4(sci_BitmapIndexedSetNode_removed0), "$updated3", $rt_wrapFunction4(sci_BitmapIndexedSetNode_updated0), "$getNode1", $rt_wrapFunction1(sci_BitmapIndexedSetNode_getNode0)],
    sc_Iterator$$anon$9, "Iterator$$anon$9", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$knownSize", $rt_wrapFunction0(sc_Iterator$$anon$9_knownSize), "$hasNext", $rt_wrapFunction0(sc_Iterator$$anon$9_hasNext), "$next", $rt_wrapFunction0(sc_Iterator$$anon$9_next)],
    sc_Iterator$ConcatIterator, "Iterator$ConcatIterator", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(sc_Iterator$ConcatIterator_hasNext), "$next", $rt_wrapFunction0(sc_Iterator$ConcatIterator_next), "$concat", $rt_wrapFunction1(sc_Iterator$ConcatIterator_concat)],
    sc_StrictOptimizedSetOps, 0, jl_Object, [sc_SetOps, sc_StrictOptimizedIterableOps], 3, 3, 0, 0, 0,
    sci_StrictOptimizedSetOps, 0, jl_Object, [sci_SetOps, sc_StrictOptimizedSetOps], 3, 3, 0, 0, 0,
    sci_HashSet, "HashSet", 43, sci_AbstractSet, [sci_StrictOptimizedSetOps, scg_DefaultSerializable], 4, 3, 0, 0, ["$map1", $rt_wrapFunction1(sci_HashSet_map), "$flatMap", $rt_wrapFunction1(sci_HashSet_flatMap), "$collect0", $rt_wrapFunction1(sci_HashSet_collect), "$flatten", $rt_wrapFunction1(sci_HashSet_flatten), "$filter1", $rt_wrapFunction1(sci_HashSet_filter), "$filterNot1", $rt_wrapFunction1(sci_HashSet_filterNot), "$iterableFactory", $rt_wrapFunction0(sci_HashSet_iterableFactory), "$knownSize", $rt_wrapFunction0(sci_HashSet_knownSize),
    "$size", $rt_wrapFunction0(sci_HashSet_size), "$isEmpty", $rt_wrapFunction0(sci_HashSet_isEmpty), "$iterator0", $rt_wrapFunction0(sci_HashSet_iterator), "$contains0", $rt_wrapFunction1(sci_HashSet_contains), "$head", $rt_wrapFunction0(sci_HashSet_head), "$foreach", $rt_wrapFunction1(sci_HashSet_foreach), "$equals", $rt_wrapFunction1(sci_HashSet_equals), "$className", $rt_wrapFunction0(sci_HashSet_className), "$hashCode0", $rt_wrapFunction0(sci_HashSet_hashCode), "$partition", $rt_wrapFunction1(sci_HashSet_partition),
    "$drop", $rt_wrapFunction1(sci_HashSet_drop), "$intersect", $rt_wrapFunction1(sci_HashSet_intersect), "$filterImpl", $rt_wrapFunction2(sci_HashSet_filterImpl), "$removedAll0", $rt_wrapFunction1(sci_HashSet_removedAll), "$tail", $rt_wrapFunction0(sci_HashSet_tail), "$concat1", $rt_wrapFunction1(sci_HashSet_concat0), "$excl", $rt_wrapFunction1(sci_HashSet_excl0), "$incl", $rt_wrapFunction1(sci_HashSet_incl0)],
    sci_ChampBaseIterator, 0, jl_Object, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(sci_ChampBaseIterator_hasNext)],
    sci_HashSetBuilder$$anon$1, 0, sci_ChampBaseIterator, [], 4, 3, 0, 0, 0,
    sc_Hashing$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sci_HashSet$, 0, jl_Object, [sc_IterableFactory], 4, 3, 0, sci_HashSet$_$callClinit, ["$newBuilder", $rt_wrapFunction0(sci_HashSet$_newBuilder), "$from0", $rt_wrapFunction1(sci_HashSet$_from)],
    scm_HashSet$addAll$lambda$_52_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    scm_LinkedHashSet, 0, scm_AbstractSet, [sc_StrictOptimizedIterableOps, scg_DefaultSerializable], 0, 3, 0, 0, 0]);
    $rt_metadata([scm_HashSet$HashSetIterator, 0, sc_AbstractIterator, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(scm_HashSet$HashSetIterator_hasNext), "$next", $rt_wrapFunction0(scm_HashSet$HashSetIterator_next)],
    scm_HashSet$$anon$2, 0, scm_HashSet$HashSetIterator, [], 4, 3, 0, 0, ["$extract", $rt_wrapFunction1(scm_HashSet$$anon$2_extract)],
    scm_LinkedHashSet$Entry, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sc_Iterator$ConcatIteratorCell, 0, jl_Object, [], 4, 3, 0, 0, 0,
    scm_StringBuilder, 0, scm_AbstractSeq, [scm_ReusableBuilder, scm_IndexedSeq, jl_CharSequence, ji_Serializable], 4, 3, 0, 0, 0,
    sc_StrictOptimizedLinearSeqOps$$anon$1, "StrictOptimizedLinearSeqOps$$anon$1", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(sc_StrictOptimizedLinearSeqOps$$anon$1_hasNext), "$next", $rt_wrapFunction0(sc_StrictOptimizedLinearSeqOps$$anon$1_next)],
    sci_SetNode$, 0, jl_Object, [], 4, 3, 0, sci_SetNode$_$callClinit, 0,
    sc_IterableOps$concat$lambda$_94_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(sc_IterableOps$concat$lambda$_94_0_apply)],
    jnc_CharsetEncoder, 0, jl_Object, [], 1, 3, 0, 0, 0,
    jnc_CoderResult, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sc_SeqView, 0, jl_Object, [sc_SeqOps, sc_View], 3, 3, 0, 0, 0,
    sc_IndexedSeqView, 0, jl_Object, [sc_IndexedSeqOps, sc_SeqView], 3, 3, 0, 0, 0,
    sci_Node$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sm_ScalaNumber, 0, jl_Number, [], 1, 3, 0, 0, 0,
    scm_HashSet$$anon$1, "HashSet$$anon$1", 44, scm_HashSet$HashSetIterator, [], 4, 3, 0, 0, ["$extract", $rt_wrapFunction1(scm_HashSet$$anon$1_extract)],
    sc_View$Concat$iterator$lambda$_0_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(sc_View$Concat$iterator$lambda$_0_0_apply)],
    sc_Iterator$$anon$20, "Iterator$$anon$20", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(sc_Iterator$$anon$20_hasNext), "$next", $rt_wrapFunction0(sc_Iterator$$anon$20_next), "$sliceIterator", $rt_wrapFunction2(sc_Iterator$$anon$20_sliceIterator)],
    sci_SetIterator, "SetIterator", 43, sci_ChampBaseIterator, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sci_SetIterator_iterator), "$isEmpty", $rt_wrapFunction0(sci_SetIterator_isEmpty), "$filterImpl0", $rt_wrapFunction2(sci_SetIterator_filterImpl), "$collect3", $rt_wrapFunction1(sci_SetIterator_collect), "$map7", $rt_wrapFunction1(sci_SetIterator_map), "$flatMap2", $rt_wrapFunction1(sci_SetIterator_flatMap), "$concat", $rt_wrapFunction1(sci_SetIterator_concat), "$drop1", $rt_wrapFunction1(sci_SetIterator_drop),
    "$sliceIterator", $rt_wrapFunction2(sci_SetIterator_sliceIterator), "$toString", $rt_wrapFunction0(sci_SetIterator_toString), "$foreach", $rt_wrapFunction1(sci_SetIterator_foreach), "$exists", $rt_wrapFunction1(sci_SetIterator_exists), "$find0", $rt_wrapFunction1(sci_SetIterator_find), "$foldLeft", $rt_wrapFunction2(sci_SetIterator_foldLeft), "$nonEmpty0", $rt_wrapFunction0(sci_SetIterator_nonEmpty), "$size", $rt_wrapFunction0(sci_SetIterator_size), "$copyToArray1", $rt_wrapFunction1(sci_SetIterator_copyToArray),
    "$copyToArray0", $rt_wrapFunction2(sci_SetIterator_copyToArray0), "$copyToArray", $rt_wrapFunction3(sci_SetIterator_copyToArray1), "$to0", $rt_wrapFunction1(sci_SetIterator_to), "$toList", $rt_wrapFunction0(sci_SetIterator_toList), "$toSeq", $rt_wrapFunction0(sci_SetIterator_toSeq), "$toArray", $rt_wrapFunction1(sci_SetIterator_toArray), "$knownSize", $rt_wrapFunction0(sci_SetIterator_knownSize), "$next", $rt_wrapFunction0(sci_SetIterator_next)],
    sci_HashCollisionSetNode, "HashCollisionSetNode", 43, sci_SetNode, [], 4, 3, 0, 0, ["$contains1", $rt_wrapFunction4(sci_HashCollisionSetNode_contains), "$updated3", $rt_wrapFunction4(sci_HashCollisionSetNode_updated), "$removed0", $rt_wrapFunction4(sci_HashCollisionSetNode_removed), "$hasNodes", $rt_wrapFunction0(sci_HashCollisionSetNode_hasNodes), "$nodeArity", $rt_wrapFunction0(sci_HashCollisionSetNode_nodeArity), "$hasPayload", $rt_wrapFunction0(sci_HashCollisionSetNode_hasPayload), "$payloadArity", $rt_wrapFunction0(sci_HashCollisionSetNode_payloadArity),
    "$getPayload", $rt_wrapFunction1(sci_HashCollisionSetNode_getPayload), "$getHash", $rt_wrapFunction1(sci_HashCollisionSetNode_getHash), "$size", $rt_wrapFunction0(sci_HashCollisionSetNode_size), "$foreach", $rt_wrapFunction1(sci_HashCollisionSetNode_foreach), "$cachedJavaKeySetHashCode", $rt_wrapFunction0(sci_HashCollisionSetNode_cachedJavaKeySetHashCode), "$filterImpl1", $rt_wrapFunction2(sci_HashCollisionSetNode_filterImpl), "$diff", $rt_wrapFunction2(sci_HashCollisionSetNode_diff), "$equals", $rt_wrapFunction1(sci_HashCollisionSetNode_equals),
    "$hashCode0", $rt_wrapFunction0(sci_HashCollisionSetNode_hashCode), "$concat3", $rt_wrapFunction2(sci_HashCollisionSetNode_concat), "$foreachWithHash0", $rt_wrapFunction1(sci_HashCollisionSetNode_foreachWithHash), "$foreachWithHashWhile", $rt_wrapFunction1(sci_HashCollisionSetNode_foreachWithHashWhile), "$copy20", $rt_wrapFunction0(sci_HashCollisionSetNode_copy), "$getNode1", $rt_wrapFunction1(sci_HashCollisionSetNode_getNode)],
    jnci_BufferedEncoder, 0, jnc_CharsetEncoder, [], 1, 3, 0, 0, 0,
    jnci_UTF8Encoder, 0, jnci_BufferedEncoder, [], 0, 3, 0, 0, 0,
    ji_IOException, 0, jl_Exception, [], 0, 3, 0, 0, 0,
    sci_Vector, 0, sci_AbstractSeq, [sci_IndexedSeq, sci_StrictOptimizedSeqOps, scg_DefaultSerializable], 1, 3, 0, 0, ["$scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted", $rt_wrapFunction1(sci_Vector_scala$collection$immutable$StrictOptimizedSeqOps$$super$sorted), "$distinctBy", $rt_wrapFunction1(sci_Vector_distinctBy), "$sorted1", $rt_wrapFunction1(sci_Vector_sorted), "$intersect1", $rt_wrapFunction1(sci_Vector_intersect), "$partition", $rt_wrapFunction1(sci_Vector_partition), "$span", $rt_wrapFunction1(sci_Vector_span),
    "$flatMap", $rt_wrapFunction1(sci_Vector_flatMap), "$collect0", $rt_wrapFunction1(sci_Vector_collect), "$flatten", $rt_wrapFunction1(sci_Vector_flatten), "$zip2", $rt_wrapFunction1(sci_Vector_zip), "$zipWithIndex", $rt_wrapFunction0(sci_Vector_zipWithIndex), "$filter1", $rt_wrapFunction1(sci_Vector_filter), "$filterNot1", $rt_wrapFunction1(sci_Vector_filterNot), "$scala$collection$immutable$IndexedSeq$$super$canEqual", $rt_wrapFunction1(sci_Vector_scala$collection$immutable$IndexedSeq$$super$canEqual), "$scala$collection$immutable$IndexedSeq$$super$sameElements",
    $rt_wrapFunction1(sci_Vector_scala$collection$immutable$IndexedSeq$$super$sameElements), "$toIndexedSeq0", $rt_wrapFunction0(sci_Vector_toIndexedSeq), "$canEqual", $rt_wrapFunction1(sci_Vector_canEqual), "$sameElements", $rt_wrapFunction1(sci_Vector_sameElements), "$stringPrefix", $rt_wrapFunction0(sci_Vector_stringPrefix), "$reverseIterator", $rt_wrapFunction0(sci_Vector_reverseIterator), "$view0", $rt_wrapFunction0(sci_Vector_view), "$reversed", $rt_wrapFunction0(sci_Vector_reversed), "$headOption", $rt_wrapFunction0(sci_Vector_headOption),
    "$lengthCompare", $rt_wrapFunction1(sci_Vector_lengthCompare), "$knownSize", $rt_wrapFunction0(sci_Vector_knownSize), "$length", $rt_wrapFunction0(sci_Vector_length), "$iterator0", $rt_wrapFunction0(sci_Vector_iterator), "$className", $rt_wrapFunction0(sci_Vector_className), "$copyToArray", $rt_wrapFunction3(sci_Vector_copyToArray), "$toVector", $rt_wrapFunction0(sci_Vector_toVector), "$applyPreferredMaxLength", $rt_wrapFunction0(sci_Vector_applyPreferredMaxLength), "$head", $rt_wrapFunction0(sci_Vector_head),
    "$last", $rt_wrapFunction0(sci_Vector_last), "$foreach", $rt_wrapFunction1(sci_Vector_foreach), "$view1", $rt_wrapFunction0(sci_Vector_view0), "$dropRight", $rt_wrapFunction1(sci_Vector_dropRight0), "$drop", $rt_wrapFunction1(sci_Vector_drop0), "$appendedAll", $rt_wrapFunction1(sci_Vector_appendedAll1), "$filterImpl", $rt_wrapFunction2(sci_Vector_filterImpl0), "$iterableFactory", $rt_wrapFunction0(sci_Vector_iterableFactory0)],
    sc_Iterator$$anon$10, "Iterator$$anon$10", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(sc_Iterator$$anon$10_hasNext), "$next", $rt_wrapFunction0(sc_Iterator$$anon$10_next)],
    jl_ArrayIndexOutOfBoundsException, 0, jl_IndexOutOfBoundsException, [], 0, 3, 0, 0, 0,
    s_Predef$ArrowAssoc$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    s_package$, 0, jl_Object, [], 4, 3, 0, s_package$_$callClinit, 0,
    onciu_StepSequencer$ByInitialCondition$, "StepSequencer$ByInitialCondition$", 20, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0(onciu_StepSequencer$ByInitialCondition$_productArity), "$productElement", $rt_wrapFunction1(onciu_StepSequencer$ByInitialCondition$_productElement), "$productIterator", $rt_wrapFunction0(onciu_StepSequencer$ByInitialCondition$_productIterator), "$hashCode0", $rt_wrapFunction0(onciu_StepSequencer$ByInitialCondition$_hashCode), "$toString", $rt_wrapFunction0(onciu_StepSequencer$ByInitialCondition$_toString)],
    jl_NegativeArraySizeException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    su_Left$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    s_Specializable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    s_package$$anon$1, 0, jl_Object, [s_Specializable], 4, 3, 0, 0, 0,
    sc_Iterable$, 0, sc_IterableFactory$Delegate, [], 4, 3, 0, sc_Iterable$_$callClinit, 0,
    sci_IndexedSeq$, 0, sc_SeqFactory$Delegate, [], 4, 3, 0, sci_IndexedSeq$_$callClinit, 0,
    sci_$colon$colon$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sc_package$$plus$colon$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sc_package$$colon$plus$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sci_Stream$, 0, jl_Object, [sc_SeqFactory], 132, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(sci_Stream$_newBuilder), "$from0", $rt_wrapFunction1(sci_Stream$_from0)],
    sci_LazyList$, 0, jl_Object, [sc_SeqFactory], 4, 3, 0, sci_LazyList$_$callClinit, ["$newBuilder", $rt_wrapFunction0(sci_LazyList$_newBuilder), "$from0", $rt_wrapFunction1(sci_LazyList$_from1)],
    sci_Vector$, 0, jl_Object, [sc_StrictOptimizedSeqFactory], 4, 3, 0, sci_Vector$_$callClinit, ["$apply24", $rt_wrapFunction1(sci_Vector$_apply), "$newBuilder", $rt_wrapFunction0(sci_Vector$_newBuilder), "$from0", $rt_wrapFunction1(sci_Vector$_from0), "$empty", $rt_wrapFunction0(sci_Vector$_empty0)],
    scm_StringBuilder$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sci_Range$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sm_BigDecimal$, 0, jl_Object, [ji_Serializable], 4, 3, 0, sm_BigDecimal$_$callClinit, 0,
    sm_BigInt$, 0, jl_Object, [ji_Serializable], 4, 3, 0, sm_BigInt$_$callClinit, 0,
    sm_LowPriorityEquiv, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sm_Equiv$, 0, jl_Object, [sm_LowPriorityEquiv, ji_Serializable], 4, 3, 0, 0, 0,
    sm_Fractional$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sm_Integral$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sm_Numeric$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sm_Ordered$, 0, jl_Object, [], 4, 3, 0, 0, 0]);
    $rt_metadata([sm_LowPriorityOrderingImplicits, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sm_Ordering$, 0, jl_Object, [sm_LowPriorityOrderingImplicits, ji_Serializable], 4, 3, 0, 0, 0,
    su_Either$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    su_Right$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sci_LazyList$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(sci_LazyList$$_clinit_$lambda$_0_0_apply)],
    sci_LazyList, "LazyList", 43, sci_AbstractSeq, [sci_LinearSeq, ji_Serializable], 4, 3, 0, 0, ["$stringPrefix", $rt_wrapFunction0(sci_LazyList_stringPrefix), "$scala$collection$LinearSeqOps$$super$sameElements", $rt_wrapFunction1(sci_LazyList_scala$collection$LinearSeqOps$$super$sameElements), "$headOption", $rt_wrapFunction0(sci_LazyList_headOption), "$length", $rt_wrapFunction0(sci_LazyList_length), "$last", $rt_wrapFunction0(sci_LazyList_last), "$lengthCompare", $rt_wrapFunction1(sci_LazyList_lengthCompare),
    "$apply1", $rt_wrapFunction1(sci_LazyList_apply), "$forall", $rt_wrapFunction1(sci_LazyList_forall), "$exists", $rt_wrapFunction1(sci_LazyList_exists), "$contains0", $rt_wrapFunction1(sci_LazyList_contains), "$sameElements", $rt_wrapFunction1(sci_LazyList_sameElements), "$indexWhere", $rt_wrapFunction2(sci_LazyList_indexWhere), "$isEmpty", $rt_wrapFunction0(sci_LazyList_isEmpty), "$knownSize", $rt_wrapFunction0(sci_LazyList_knownSize), "$head", $rt_wrapFunction0(sci_LazyList_head), "$iterator0", $rt_wrapFunction0(sci_LazyList_iterator),
    "$foreach", $rt_wrapFunction1(sci_LazyList_foreach), "$foldLeft", $rt_wrapFunction2(sci_LazyList_foldLeft), "$className", $rt_wrapFunction0(sci_LazyList_className), "$reduceLeft", $rt_wrapFunction1(sci_LazyList_reduceLeft), "$collectFirst", $rt_wrapFunction1(sci_LazyList_collectFirst), "$find0", $rt_wrapFunction1(sci_LazyList_find), "$sliding", $rt_wrapFunction2(sci_LazyList_sliding), "$addString", $rt_wrapFunction4(sci_LazyList_addString), "$toString", $rt_wrapFunction0(sci_LazyList_toString), "$apply", $rt_wrapFunction1(sci_LazyList_apply0),
    "$intersect1", $rt_wrapFunction1(sci_LazyList_intersect), "$takeWhile", $rt_wrapFunction1(sci_LazyList_takeWhile), "$dropRight", $rt_wrapFunction1(sci_LazyList_dropRight), "$dropWhile", $rt_wrapFunction1(sci_LazyList_dropWhile), "$drop", $rt_wrapFunction1(sci_LazyList_drop0), "$zipWithIndex", $rt_wrapFunction0(sci_LazyList_zipWithIndex), "$zip2", $rt_wrapFunction1(sci_LazyList_zip0), "$flatten", $rt_wrapFunction1(sci_LazyList_flatten), "$flatMap", $rt_wrapFunction1(sci_LazyList_flatMap), "$collect0", $rt_wrapFunction1(sci_LazyList_collect),
    "$map1", $rt_wrapFunction1(sci_LazyList_map), "$prepended", $rt_wrapFunction1(sci_LazyList_prepended), "$filterNot1", $rt_wrapFunction1(sci_LazyList_filterNot), "$filter1", $rt_wrapFunction1(sci_LazyList_filter), "$appended", $rt_wrapFunction1(sci_LazyList_appended), "$appendedAll", $rt_wrapFunction1(sci_LazyList_appendedAll), "$tail", $rt_wrapFunction0(sci_LazyList_tail0), "$iterableFactory", $rt_wrapFunction0(sci_LazyList_iterableFactory)],
    sci_LazyList$$_clinit_$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sci_LazyList$$_clinit_$lambda$_0_1_apply)],
    sci_NewVectorIterator, "NewVectorIterator", 43, jl_Object, [sc_Iterator, jl_Cloneable], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sci_NewVectorIterator_iterator), "$grouped", $rt_wrapFunction1(sci_NewVectorIterator_grouped), "$sliding0", $rt_wrapFunction2(sci_NewVectorIterator_sliding), "$indexWhere", $rt_wrapFunction2(sci_NewVectorIterator_indexWhere), "$isEmpty", $rt_wrapFunction0(sci_NewVectorIterator_isEmpty), "$filter", $rt_wrapFunction1(sci_NewVectorIterator_filter), "$filterImpl0", $rt_wrapFunction2(sci_NewVectorIterator_filterImpl),
    "$distinctBy0", $rt_wrapFunction1(sci_NewVectorIterator_distinctBy), "$map7", $rt_wrapFunction1(sci_NewVectorIterator_map), "$flatMap2", $rt_wrapFunction1(sci_NewVectorIterator_flatMap), "$concat", $rt_wrapFunction1(sci_NewVectorIterator_concat), "$takeWhile1", $rt_wrapFunction1(sci_NewVectorIterator_takeWhile), "$dropWhile1", $rt_wrapFunction1(sci_NewVectorIterator_dropWhile), "$sameElements", $rt_wrapFunction1(sci_NewVectorIterator_sameElements), "$toString", $rt_wrapFunction0(sci_NewVectorIterator_toString),
    "$foreach", $rt_wrapFunction1(sci_NewVectorIterator_foreach), "$exists", $rt_wrapFunction1(sci_NewVectorIterator_exists), "$find0", $rt_wrapFunction1(sci_NewVectorIterator_find), "$foldLeft", $rt_wrapFunction2(sci_NewVectorIterator_foldLeft), "$nonEmpty0", $rt_wrapFunction0(sci_NewVectorIterator_nonEmpty), "$size", $rt_wrapFunction0(sci_NewVectorIterator_size), "$copyToArray1", $rt_wrapFunction1(sci_NewVectorIterator_copyToArray0), "$copyToArray0", $rt_wrapFunction2(sci_NewVectorIterator_copyToArray1), "$to0",
    $rt_wrapFunction1(sci_NewVectorIterator_to), "$toList", $rt_wrapFunction0(sci_NewVectorIterator_toList), "$toSeq", $rt_wrapFunction0(sci_NewVectorIterator_toSeq), "$toArray", $rt_wrapFunction1(sci_NewVectorIterator_toArray), "$knownSize", $rt_wrapFunction0(sci_NewVectorIterator_knownSize), "$hasNext", $rt_wrapFunction0(sci_NewVectorIterator_hasNext), "$next", $rt_wrapFunction0(sci_NewVectorIterator_next), "$drop1", $rt_wrapFunction1(sci_NewVectorIterator_drop), "$take", $rt_wrapFunction1(sci_NewVectorIterator_take),
    "$copyToArray", $rt_wrapFunction3(sci_NewVectorIterator_copyToArray)],
    sci_VectorImpl, 0, sci_Vector, [], 1, 3, 0, 0, 0,
    sci_BigVector, 0, sci_VectorImpl, [], 1, 3, 0, 0, 0,
    sci_Vector0$, "Vector0$", 43, sci_BigVector, [], 4, 3, 0, sci_Vector0$_$callClinit, ["$updated2", $rt_wrapFunction2(sci_Vector0$_updated), "$appended1", $rt_wrapFunction1(sci_Vector0$_appended), "$prepended2", $rt_wrapFunction1(sci_Vector0$_prepended), "$init0", $rt_wrapFunction0(sci_Vector0$_init), "$slice0", $rt_wrapFunction2(sci_Vector0$_slice0), "$vectorSliceCount", $rt_wrapFunction0(sci_Vector0$_vectorSliceCount), "$vectorSlice", $rt_wrapFunction1(sci_Vector0$_vectorSlice), "$equals", $rt_wrapFunction1(sci_Vector0$_equals),
    "$appendedAll00", $rt_wrapFunction2(sci_Vector0$_appendedAll0), "$init1", $rt_wrapFunction0(sci_Vector0$_init0), "$tail", $rt_wrapFunction0(sci_Vector0$_tail), "$map1", $rt_wrapFunction1(sci_Vector0$_map), "$prepended", $rt_wrapFunction1(sci_Vector0$_prepended0), "$appended", $rt_wrapFunction1(sci_Vector0$_appended0), "$updated7", $rt_wrapFunction2(sci_Vector0$_updated0), "$apply", $rt_wrapFunction1(sci_Vector0$_apply), "$apply1", $rt_wrapFunction1(sci_Vector0$_apply0)],
    jm_MathContext, 0, jl_Object, [ji_Serializable], 4, 3, 0, jm_MathContext_$callClinit, 0,
    jm_BigInteger, 0, jl_Number, [jl_Comparable, ji_Serializable], 0, 3, 0, jm_BigInteger_$callClinit, 0,
    sm_ScalaNumericAnyConversions, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sm_ScalaNumericConversions, 0, jl_Object, [sm_ScalaNumericAnyConversions], 3, 3, 0, 0, 0,
    sm_Ordered, 0, jl_Object, [jl_Comparable], 3, 3, 0, 0, 0,
    sm_BigInt, 0, sm_ScalaNumber, [sm_ScalaNumericConversions, sm_Ordered], 4, 3, 0, 0, 0,
    sci_Iterable$, 0, sc_IterableFactory$Delegate, [], 4, 3, 0, sci_Iterable$_$callClinit, ["$from0", $rt_wrapFunction1(sci_Iterable$_from)],
    jl_SecurityException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    jm_RoundingMode, "RoundingMode", 5, jl_Enum, [], 12, 3, 0, jm_RoundingMode_$callClinit, 0,
    jl_NumberFormatException, 0, jl_IllegalArgumentException, [], 0, 3, 0, 0, 0,
    sci_VectorStatics$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    scm_HashMap$HashMapIterator, 0, sc_AbstractIterator, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(scm_HashMap$HashMapIterator_hasNext), "$next", $rt_wrapFunction0(scm_HashMap$HashMapIterator_next)],
    scm_HashMap$$anon$2, "HashMap$$anon$2", 44, scm_HashMap$HashMapIterator, [], 4, 3, 0, 0, ["$extract0", $rt_wrapFunction1(scm_HashMap$$anon$2_extract)],
    suh_MurmurHash3, 0, jl_Object, [], 0, 3, 0, 0, 0,
    suh_MurmurHash3$, 0, suh_MurmurHash3, [], 4, 3, 0, suh_MurmurHash3$_$callClinit, 0,
    jl_UnsupportedOperationException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_0_apply)],
    oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_1_apply)],
    oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_2_apply)],
    oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_3_apply)],
    oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1_applyOrElse)],
    onciu_Rewritable$RewritableAny$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_Rewritable$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_4_apply)],
    oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SyntaxDeprecationWarningsAndReplacements$process$lambda$_9_5_apply)],
    onciafn_JavaCCParser$, 0, jl_Object, [s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    oncias_SemanticState$, 0, jl_Object, [ji_Serializable], 4, 3, 0, oncias_SemanticState$_$callClinit, 0,
    oncias_SemanticCheckContext, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncifp_SemanticAnalysis$$anon$1, 0, jl_Object, [oncias_SemanticCheckContext], 4, 3, 0, 0, ["$errorMessageProvider0", $rt_wrapFunction0(oncifp_SemanticAnalysis$$anon$1_errorMessageProvider)],
    oncias_SemanticChecker$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_SemanticAnalysis$process$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SemanticAnalysis$process$lambda$_13_0_apply)],
    oncifp_SemanticAnalysis$process$lambda$_13_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SemanticAnalysis$process$lambda$_13_1_apply)],
    oncirr_computeDependenciesForExpressions, 0, jl_Object, [s_Function1, s_Product, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_computeDependenciesForExpressions_apply)],
    oncias_SemanticTable$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_SemanticAnalysis$process$lambda$_13_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SemanticAnalysis$process$lambda$_13_2_apply)],
    oncifp_PreparatoryRewriting$$process$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_PreparatoryRewriting$$process$lambda$_9_0_apply)],
    onciu_inSequence$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_extractSensitiveLiterals$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncifp_extractSensitiveLiterals$$anonfun$1_applyOrElse)],
    otcic_Console, 0, jl_Object, [], 4, 3, 0, 0, 0]);
    $rt_metadata([sc_AbstractSeqView, 0, sc_AbstractView, [sc_SeqView], 1, 3, 0, 0, ["$stringPrefix", $rt_wrapFunction0(sc_AbstractSeqView_stringPrefix), "$scala$collection$SeqOps$$super$concat", $rt_wrapFunction1(sc_AbstractSeqView_scala$collection$SeqOps$$super$concat), "$scala$collection$SeqOps$$super$sizeCompare", $rt_wrapFunction1(sc_AbstractSeqView_scala$collection$SeqOps$$super$sizeCompare), "$$colon$plus", $rt_wrapFunction1(sc_AbstractSeqView_$colon$plus), "$appendedAll", $rt_wrapFunction1(sc_AbstractSeqView_appendedAll),
    "$concat0", $rt_wrapFunction1(sc_AbstractSeqView_concat), "$size", $rt_wrapFunction0(sc_AbstractSeqView_size), "$distinct3", $rt_wrapFunction0(sc_AbstractSeqView_distinct), "$distinctBy", $rt_wrapFunction1(sc_AbstractSeqView_distinctBy), "$lengthCompare", $rt_wrapFunction1(sc_AbstractSeqView_lengthCompare), "$appended", $rt_wrapFunction1(sc_AbstractSeqView_appended), "$map1", $rt_wrapFunction1(sc_AbstractSeqView_map)],
    sc_AbstractIndexedSeqView, 0, sc_AbstractSeqView, [sc_IndexedSeqView], 1, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_AbstractIndexedSeqView_iterator)],
    scm_ArrayBufferView, 0, sc_AbstractIndexedSeqView, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(scm_ArrayBufferView_apply), "$length", $rt_wrapFunction0(scm_ArrayBufferView_length), "$iterator0", $rt_wrapFunction0(scm_ArrayBufferView_iterator), "$reverseIterator", $rt_wrapFunction0(scm_ArrayBufferView_reverseIterator), "$reverse0", $rt_wrapFunction0(scm_ArrayBufferView_reverse)],
    srj_JFunction0$mcI$sp, 0, jl_Object, [s_Function0, ji_Serializable], 3, 3, 0, 0, 0,
    scm_ArrayBuffer$view$lambda$_88_0, 0, jl_Object, [srj_JFunction0$mcI$sp, ji_Serializable], 0, 3, 0, 0, 0,
    onciu_Foldable$Folder, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncias_SemanticCheckResult, "SemanticCheckResult", 17, jl_Object, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(oncias_SemanticCheckResult_productPrefix), "$productArity", $rt_wrapFunction0(oncias_SemanticCheckResult_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticCheckResult_productElement), "$productIterator", $rt_wrapFunction0(oncias_SemanticCheckResult_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticCheckResult_hashCode), "$toString", $rt_wrapFunction0(oncias_SemanticCheckResult_toString),
    "$equals", $rt_wrapFunction1(oncias_SemanticCheckResult_equals)],
    oncirr_computeDependenciesForExpressions$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_computeDependenciesForExpressions$$anonfun$1_applyOrElse)],
    onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_0_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$3$lambda$_22_1_apply)],
    sci_HashMap$, 0, jl_Object, [sc_MapFactory], 4, 3, 0, sci_HashMap$_$callClinit, ["$newBuilder", $rt_wrapFunction0(sci_HashMap$_newBuilder), "$from0", $rt_wrapFunction1(sci_HashMap$_from)],
    sc_IterableOps$groupBy$lambda$_72_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(sc_IterableOps$groupBy$lambda$_72_0_apply)],
    onciu_StepSequencer$MutableDirectedGraph$$$anonfun$copyOf$2$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$MutableDirectedGraph$$$anonfun$copyOf$2$lambda$_4_0_apply)],
    onciu_StepSequencer$MutableDirectedGraph$$anonfun$toString$2$lambda$_10_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$MutableDirectedGraph$$anonfun$toString$2$lambda$_10_0_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_0_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$12$lambda$_31_1_apply)],
    onciu_StepSequencer$$anonfun$$nestedInanonfun$sort$2$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(onciu_StepSequencer$$anonfun$$nestedInanonfun$sort$2$1_applyOrElse)],
    oncias_Scope$, 0, jl_Object, [ji_Serializable], 4, 3, 0, oncias_Scope$_$callClinit, 0,
    onciuh_TreeZipper, 0, jl_Object, [], 1, 3, 0, 0, 0,
    oncias_SemanticState$ScopeZipper$, 0, onciuh_TreeZipper, [], 0, 3, 0, oncias_SemanticState$ScopeZipper$_$callClinit, 0,
    oncia_ASTAnnotationMap$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sci_StrictOptimizedMapOps, 0, jl_Object, [sci_MapOps, sc_StrictOptimizedMapOps], 3, 3, 0, 0, 0,
    sci_HashMap, "HashMap", 43, sci_AbstractMap, [sci_StrictOptimizedMapOps, scg_DefaultSerializable], 4, 3, 0, 0, ["$map14", $rt_wrapFunction1(sci_HashMap_map), "$collect1", $rt_wrapFunction1(sci_HashMap_collect), "$map1", $rt_wrapFunction1(sci_HashMap_map0), "$flatMap", $rt_wrapFunction1(sci_HashMap_flatMap), "$collect0", $rt_wrapFunction1(sci_HashMap_collect0), "$flatten", $rt_wrapFunction1(sci_HashMap_flatten), "$filter1", $rt_wrapFunction1(sci_HashMap_filter), "$filterNot1", $rt_wrapFunction1(sci_HashMap_filterNot),
    "$mapFactory", $rt_wrapFunction0(sci_HashMap_mapFactory), "$knownSize", $rt_wrapFunction0(sci_HashMap_knownSize), "$size", $rt_wrapFunction0(sci_HashMap_size), "$isEmpty", $rt_wrapFunction0(sci_HashMap_isEmpty), "$keySet0", $rt_wrapFunction0(sci_HashMap_keySet), "$iterator0", $rt_wrapFunction0(sci_HashMap_iterator), "$keysIterator", $rt_wrapFunction0(sci_HashMap_keysIterator), "$valuesIterator", $rt_wrapFunction0(sci_HashMap_valuesIterator), "$contains0", $rt_wrapFunction1(sci_HashMap_contains), "$apply", $rt_wrapFunction1(sci_HashMap_apply),
    "$get1", $rt_wrapFunction1(sci_HashMap_get), "$getOrElse0", $rt_wrapFunction2(sci_HashMap_getOrElse), "$foreach", $rt_wrapFunction1(sci_HashMap_foreach), "$foreachEntry", $rt_wrapFunction1(sci_HashMap_foreachEntry), "$equals", $rt_wrapFunction1(sci_HashMap_equals), "$hashCode0", $rt_wrapFunction0(sci_HashMap_hashCode), "$className", $rt_wrapFunction0(sci_HashMap_className), "$removedAll", $rt_wrapFunction1(sci_HashMap_removedAll0), "$filterImpl", $rt_wrapFunction2(sci_HashMap_filterImpl0), "$head", $rt_wrapFunction0(sci_HashMap_head),
    "$concat2", $rt_wrapFunction1(sci_HashMap_concat0), "$removed", $rt_wrapFunction1(sci_HashMap_removed), "$updated1", $rt_wrapFunction2(sci_HashMap_updated0), "$keySet", $rt_wrapFunction0(sci_HashMap_keySet0)],
    onciu_StepSequencer$$anonfun$orderSteps$19$lambda$_39_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$19$lambda$_39_0_apply)],
    onciu_StepSequencer$RepeatedSteps$Forbidden$, 0, jl_Object, [onciu_StepSequencer$RepeatedSteps], 0, 3, 0, 0, 0,
    onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_0_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$25$lambda$_48_1_apply)],
    onciuh_TreeElem, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncias_Scope, "Scope", 17, jl_Object, [onciuh_TreeElem, s_Product, ji_Serializable], 4, 3, [0,0,0], 0, ["$toString", $rt_wrapFunction0(oncias_Scope_toString), "$productPrefix", $rt_wrapFunction0(oncias_Scope_productPrefix), "$productArity", $rt_wrapFunction0(oncias_Scope_productArity), "$productElement", $rt_wrapFunction1(oncias_Scope_productElement), "$productIterator", $rt_wrapFunction0(oncias_Scope_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_Scope_hashCode), "$equals", $rt_wrapFunction1(oncias_Scope_equals)],
    sci_MapNode$, 0, jl_Object, [], 4, 3, 0, sci_MapNode$_$callClinit, 0,
    sci_MapNode, 0, sci_Node, [], 1, 3, 0, 0, 0,
    sci_BitmapIndexedMapNode, "BitmapIndexedMapNode", 43, sci_MapNode, [], 4, 3, 0, 0, ["$size", $rt_wrapFunction0(sci_BitmapIndexedMapNode_size), "$cachedJavaKeySetHashCode", $rt_wrapFunction0(sci_BitmapIndexedMapNode_cachedJavaKeySetHashCode), "$getKey", $rt_wrapFunction1(sci_BitmapIndexedMapNode_getKey), "$getValue", $rt_wrapFunction1(sci_BitmapIndexedMapNode_getValue), "$getPayload0", $rt_wrapFunction1(sci_BitmapIndexedMapNode_getPayload), "$getHash", $rt_wrapFunction1(sci_BitmapIndexedMapNode_getHash), "$apply28",
    $rt_wrapFunction4(sci_BitmapIndexedMapNode_apply), "$get4", $rt_wrapFunction4(sci_BitmapIndexedMapNode_get), "$getOrElse1", function(var_1, var_2, var_3, var_4, var_5) { return sci_BitmapIndexedMapNode_getOrElse(this, var_1, var_2, var_3, var_4, var_5); }, "$containsKey0", $rt_wrapFunction4(sci_BitmapIndexedMapNode_containsKey), "$hasNodes", $rt_wrapFunction0(sci_BitmapIndexedMapNode_hasNodes), "$nodeArity", $rt_wrapFunction0(sci_BitmapIndexedMapNode_nodeArity), "$hasPayload", $rt_wrapFunction0(sci_BitmapIndexedMapNode_hasPayload),
    "$payloadArity", $rt_wrapFunction0(sci_BitmapIndexedMapNode_payloadArity), "$foreach", $rt_wrapFunction1(sci_BitmapIndexedMapNode_foreach), "$foreachEntry", $rt_wrapFunction1(sci_BitmapIndexedMapNode_foreachEntry), "$foreachWithHash", $rt_wrapFunction1(sci_BitmapIndexedMapNode_foreachWithHash), "$equals", $rt_wrapFunction1(sci_BitmapIndexedMapNode_equals), "$hashCode0", $rt_wrapFunction0(sci_BitmapIndexedMapNode_hashCode), "$filterImpl4", $rt_wrapFunction2(sci_BitmapIndexedMapNode_filterImpl0), "$copy21", $rt_wrapFunction0(sci_BitmapIndexedMapNode_copy0),
    "$concat8", $rt_wrapFunction2(sci_BitmapIndexedMapNode_concat0), "$removed3", $rt_wrapFunction4(sci_BitmapIndexedMapNode_removed0), "$updated6", function(var_1, var_2, var_3, var_4, var_5, var_6) { return sci_BitmapIndexedMapNode_updated0(this, var_1, var_2, var_3, var_4, var_5, var_6); }, "$getNode1", $rt_wrapFunction1(sci_BitmapIndexedMapNode_getNode0)],
    su_Either, 0, jl_Object, [s_Product, ji_Serializable], 1, 3, 0, 0, 0,
    su_Left, "Left", 39, su_Either, [], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(su_Left_productPrefix), "$productArity", $rt_wrapFunction0(su_Left_productArity), "$productElement", $rt_wrapFunction1(su_Left_productElement), "$productIterator", $rt_wrapFunction0(su_Left_productIterator), "$hashCode0", $rt_wrapFunction0(su_Left_hashCode), "$toString", $rt_wrapFunction0(su_Left_toString), "$equals", $rt_wrapFunction1(su_Left_equals)],
    sci_Set$SetNIterator, 0, sc_AbstractIterator, [ji_Serializable], 1, 3, 0, 0, ["$knownSize", $rt_wrapFunction0(sci_Set$SetNIterator_knownSize), "$hasNext", $rt_wrapFunction0(sci_Set$SetNIterator_hasNext), "$next", $rt_wrapFunction0(sci_Set$SetNIterator_next), "$drop1", $rt_wrapFunction1(sci_Set$SetNIterator_drop)],
    sci_Set$Set2$$anon$1, "Set$Set2$$anon$1", 43, sci_Set$SetNIterator, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Set$Set2$$anon$1_apply)],
    sc_IndexedSeqView$IndexedSeqViewIterator, "IndexedSeqView$IndexedSeqViewIterator", 42, sc_AbstractIterator, [ji_Serializable], 0, 3, 0, 0, ["$knownSize", $rt_wrapFunction0(sc_IndexedSeqView$IndexedSeqViewIterator_knownSize), "$hasNext", $rt_wrapFunction0(sc_IndexedSeqView$IndexedSeqViewIterator_hasNext), "$next", $rt_wrapFunction0(sc_IndexedSeqView$IndexedSeqViewIterator_next)],
    scm_CheckedIndexedSeqView$CheckedIterator, "CheckedIndexedSeqView$CheckedIterator", 44, sc_IndexedSeqView$IndexedSeqViewIterator, [], 0, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(scm_CheckedIndexedSeqView$CheckedIterator_hasNext)],
    oncipj_CharStream, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncipj_CypherCharStream, 0, jl_Object, [oncipj_CharStream], 0, 3, 0, 0, 0,
    onciaf_ASTExceptionFactory, 0, jl_Object, [], 3, 3, 0, 0, 0,
    scc_AsScalaConverters, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciafn_Neo4jASTExceptionFactory, 0, jl_Object, [onciaf_ASTExceptionFactory, scc_AsScalaConverters], 0, 3, 0, 0, 0,
    onciaf_ASTExpressionFactory, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciaf_ASTFactory, 0, jl_Object, [onciaf_ASTExpressionFactory], 3, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory, 0, jl_Object, [onciaf_ASTFactory], 0, 3, 0, 0, 0,
    oncipj_CypherConstants, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncipj_Cypher, 0, jl_Object, [oncipj_CypherConstants], 0, 3, 0, oncipj_Cypher_$callClinit, 0,
    onciu_InputPosition$, 0, jl_Object, [ji_Serializable], 4, 3, 0, onciu_InputPosition$_$callClinit, 0,
    oncias_SemanticFeature$, 0, jl_Object, [], 4, 3, 0, oncias_SemanticFeature$_$callClinit, 0]);
    $rt_metadata([oncias_ScopeTreeVerifier$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_inSequence$InSequenceRewriter, 0, jl_Object, [s_Function1], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_inSequence$InSequenceRewriter_apply)],
    oncirr_ReturnItemsAreAliased$, "ReturnItemsAreAliased$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_ReturnItemsAreAliased$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_ReturnItemsAreAliased$_productArity), "$productElement", $rt_wrapFunction1(oncirr_ReturnItemsAreAliased$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_ReturnItemsAreAliased$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_ReturnItemsAreAliased$_hashCode),
    "$toString", $rt_wrapFunction0(oncirr_ReturnItemsAreAliased$_toString)],
    oncirr_ExpressionsInOrderByAndWhereUseAliases$, "ExpressionsInOrderByAndWhereUseAliases$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_ExpressionsInOrderByAndWhereUseAliases$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_ExpressionsInOrderByAndWhereUseAliases$_productArity), "$productElement", $rt_wrapFunction1(oncirr_ExpressionsInOrderByAndWhereUseAliases$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_ExpressionsInOrderByAndWhereUseAliases$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_ExpressionsInOrderByAndWhereUseAliases$_hashCode), "$toString", $rt_wrapFunction0(oncirr_ExpressionsInOrderByAndWhereUseAliases$_toString)],
    oncirr_WithBetweenOptionalMatchAndMatchInserted$, "WithBetweenOptionalMatchAndMatchInserted$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_WithBetweenOptionalMatchAndMatchInserted$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_WithBetweenOptionalMatchAndMatchInserted$_productArity), "$productElement", $rt_wrapFunction1(oncirr_WithBetweenOptionalMatchAndMatchInserted$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_WithBetweenOptionalMatchAndMatchInserted$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_WithBetweenOptionalMatchAndMatchInserted$_hashCode), "$toString", $rt_wrapFunction0(oncirr_WithBetweenOptionalMatchAndMatchInserted$_toString)],
    oncirr_WithBetweenCallAndWhereInserted$, "WithBetweenCallAndWhereInserted$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_WithBetweenCallAndWhereInserted$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_WithBetweenCallAndWhereInserted$_productArity), "$productElement", $rt_wrapFunction1(oncirr_WithBetweenCallAndWhereInserted$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_WithBetweenCallAndWhereInserted$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_WithBetweenCallAndWhereInserted$_hashCode), "$toString", $rt_wrapFunction0(oncirr_WithBetweenCallAndWhereInserted$_toString)],
    oncirr_WithBetweenShowAndWhereInserted$, "WithBetweenShowAndWhereInserted$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_WithBetweenShowAndWhereInserted$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_WithBetweenShowAndWhereInserted$_productArity), "$productElement", $rt_wrapFunction1(oncirr_WithBetweenShowAndWhereInserted$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_WithBetweenShowAndWhereInserted$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_WithBetweenShowAndWhereInserted$_hashCode), "$toString", $rt_wrapFunction0(oncirr_WithBetweenShowAndWhereInserted$_toString)],
    oncirr_ShowRewrittenToShowYieldWhereReturn$, "ShowRewrittenToShowYieldWhereReturn$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_ShowRewrittenToShowYieldWhereReturn$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_ShowRewrittenToShowYieldWhereReturn$_productArity), "$productElement", $rt_wrapFunction1(oncirr_ShowRewrittenToShowYieldWhereReturn$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_ShowRewrittenToShowYieldWhereReturn$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_ShowRewrittenToShowYieldWhereReturn$_hashCode), "$toString", $rt_wrapFunction0(oncirr_ShowRewrittenToShowYieldWhereReturn$_toString)],
    oncirr_MultipleInPredicatesAreMerged$, "MultipleInPredicatesAreMerged$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_MultipleInPredicatesAreMerged$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_MultipleInPredicatesAreMerged$_productArity), "$productElement", $rt_wrapFunction1(oncirr_MultipleInPredicatesAreMerged$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_MultipleInPredicatesAreMerged$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_MultipleInPredicatesAreMerged$_hashCode), "$toString", $rt_wrapFunction0(oncirr_MultipleInPredicatesAreMerged$_toString)],
    oncirr_TimestampRewritten$, "TimestampRewritten$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_TimestampRewritten$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_TimestampRewritten$_productArity), "$productElement", $rt_wrapFunction1(oncirr_TimestampRewritten$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_TimestampRewritten$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_TimestampRewritten$_hashCode),
    "$toString", $rt_wrapFunction0(oncirr_TimestampRewritten$_toString)],
    oncirr_NoShortestPathWithFixedLength$, "NoShortestPathWithFixedLength$", 25, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirr_NoShortestPathWithFixedLength$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirr_NoShortestPathWithFixedLength$_productArity), "$productElement", $rt_wrapFunction1(oncirr_NoShortestPathWithFixedLength$_productElement), "$productIterator", $rt_wrapFunction0(oncirr_NoShortestPathWithFixedLength$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirr_NoShortestPathWithFixedLength$_hashCode), "$toString", $rt_wrapFunction0(oncirr_NoShortestPathWithFixedLength$_toString)],
    sci_VectorBuilder, "VectorBuilder", 43, jl_Object, [scm_ReusableBuilder], 4, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1(sci_VectorBuilder_sizeHint), "$sizeHint0", $rt_wrapFunction2(sci_VectorBuilder_sizeHint0), "$toString", $rt_wrapFunction0(sci_VectorBuilder_toString), "$result0", $rt_wrapFunction0(sci_VectorBuilder_result0), "$addAll0", $rt_wrapFunction1(sci_VectorBuilder_addAll0), "$addOne", $rt_wrapFunction1(sci_VectorBuilder_addOne0)],
    sci_Vector1, "Vector1", 43, sci_VectorImpl, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Vector1_apply), "$updated2", $rt_wrapFunction2(sci_Vector1_updated), "$appended1", $rt_wrapFunction1(sci_Vector1_appended), "$prepended2", $rt_wrapFunction1(sci_Vector1_prepended), "$slice0", $rt_wrapFunction2(sci_Vector1_slice0), "$init0", $rt_wrapFunction0(sci_Vector1_init), "$vectorSliceCount", $rt_wrapFunction0(sci_Vector1_vectorSliceCount), "$vectorSlice", $rt_wrapFunction1(sci_Vector1_vectorSlice), "$appendedAll00",
    $rt_wrapFunction2(sci_Vector1_appendedAll0), "$init1", $rt_wrapFunction0(sci_Vector1_init0), "$tail", $rt_wrapFunction0(sci_Vector1_tail), "$map1", $rt_wrapFunction1(sci_Vector1_map), "$prepended", $rt_wrapFunction1(sci_Vector1_prepended0), "$appended", $rt_wrapFunction1(sci_Vector1_appended0), "$updated7", $rt_wrapFunction2(sci_Vector1_updated0), "$apply", $rt_wrapFunction1(sci_Vector1_apply0)],
    oncifp_SemanticTypeCheck$$visit$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncifp_SemanticTypeCheck$$visit$lambda$_9_0_apply)],
    s_Function$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncir_Deprecations$semanticallyDeprecatedFeatures$$find$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciu_InternalNotificationLogger, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_devNullLogger$, 0, jl_Object, [onciu_InternalNotificationLogger, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    onciu_CypherExceptionFactory, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_OpenCypherExceptionFactory, "OpenCypherExceptionFactory", 20, jl_Object, [onciu_CypherExceptionFactory, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(onciu_OpenCypherExceptionFactory_productPrefix), "$productArity", $rt_wrapFunction0(onciu_OpenCypherExceptionFactory_productArity), "$productElement", $rt_wrapFunction1(onciu_OpenCypherExceptionFactory_productElement), "$productIterator", $rt_wrapFunction0(onciu_OpenCypherExceptionFactory_productIterator), "$hashCode0", $rt_wrapFunction0(onciu_OpenCypherExceptionFactory_hashCode),
    "$toString", $rt_wrapFunction0(onciu_OpenCypherExceptionFactory_toString), "$equals", $rt_wrapFunction1(onciu_OpenCypherExceptionFactory_equals)],
    oncifp_SemanticAnalyzer$$anon$1$errorHandler$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    scm_HashSet$subtractAll$lambda$_53_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    oncifp_AmbiguousAggregationAnalysis$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncifp_AmbiguousAggregationAnalysis$$anonfun$1_applyOrElse)],
    sci_LazyList$State, 0, jl_Object, [ji_Serializable], 3, 3, 0, 0, 0,
    sci_LazyList$State$Empty$, 0, jl_Object, [sci_LazyList$State], 0, 3, 0, 0, ["$tail4", $rt_wrapFunction0(sci_LazyList$State$Empty$_tail), "$head", $rt_wrapFunction0(sci_LazyList$State$Empty$_head)],
    scm_HashMap$$anon$1, "HashMap$$anon$1", 44, scm_HashMap$HashMapIterator, [], 4, 3, 0, 0, ["$extract0", $rt_wrapFunction1(scm_HashMap$$anon$1_extract)],
    sci_MapBuilderImpl, "MapBuilderImpl", 43, jl_Object, [scm_ReusableBuilder], 4, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1(sci_MapBuilderImpl_sizeHint), "$addAll0", $rt_wrapFunction1(sci_MapBuilderImpl_addAll0), "$addOne", $rt_wrapFunction1(sci_MapBuilderImpl_addOne), "$result0", $rt_wrapFunction0(sci_MapBuilderImpl_result)],
    oncirc_containsNoReturnAll$, "containsNoReturnAll$", 26, jl_Object, [oncir_ValidatingCondition, s_Product, ji_Serializable], 4, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncirc_containsNoReturnAll$_toString), "$unary_$bang", $rt_wrapFunction0(oncirc_containsNoReturnAll$_unary_$bang), "$name3", $rt_wrapFunction0(oncirc_containsNoReturnAll$_name), "$productArity", $rt_wrapFunction0(oncirc_containsNoReturnAll$_productArity), "$productElement", $rt_wrapFunction1(oncirc_containsNoReturnAll$_productElement), "$productIterator",
    $rt_wrapFunction0(oncirc_containsNoReturnAll$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirc_containsNoReturnAll$_hashCode), "$apply", $rt_wrapFunction1(oncirc_containsNoReturnAll$_apply)],
    oncirc_package$LiteralsExtracted$, "package$LiteralsExtracted$", 26, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirc_package$LiteralsExtracted$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirc_package$LiteralsExtracted$_productArity), "$productElement", $rt_wrapFunction1(oncirc_package$LiteralsExtracted$_productElement), "$productIterator", $rt_wrapFunction0(oncirc_package$LiteralsExtracted$_productIterator), "$hashCode0", $rt_wrapFunction0(oncirc_package$LiteralsExtracted$_hashCode),
    "$toString", $rt_wrapFunction0(oncirc_package$LiteralsExtracted$_toString)],
    oncirc_package$FunctionInvocationsResolved$, "package$FunctionInvocationsResolved$", 26, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$unary_$bang", $rt_wrapFunction0(oncirc_package$FunctionInvocationsResolved$_unary_$bang), "$productArity", $rt_wrapFunction0(oncirc_package$FunctionInvocationsResolved$_productArity), "$productElement", $rt_wrapFunction1(oncirc_package$FunctionInvocationsResolved$_productElement), "$productIterator", $rt_wrapFunction0(oncirc_package$FunctionInvocationsResolved$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncirc_package$FunctionInvocationsResolved$_hashCode), "$toString", $rt_wrapFunction0(oncirc_package$FunctionInvocationsResolved$_toString)],
    sci_HashCollisionSetNode$equals$lambda$_20_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sci_HashCollisionSetNode$equals$lambda$_20_0_apply)],
    oncias_SemanticCheck, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_Vector, 0, ju_AbstractList, [ju_List, ju_RandomAccess, jl_Cloneable, ji_Serializable], 0, 3, 0, 0, 0,
    ju_Stack, 0, ju_Vector, [], 0, 3, 0, 0, 0,
    oncipj_Cypher$JJCalls, 0, jl_Object, [], 4, 0, 0, 0, 0,
    oncipj_Cypher$LookaheadSuccess, 0, jl_IllegalStateException, [], 4, 0, 0, 0, 0,
    oncipj_CypherTokenManager, 0, jl_Object, [oncipj_CypherConstants], 0, 3, 0, 0, 0,
    oncipj_WithOffset, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncipj_Token, 0, oncipj_WithOffset, [ji_Serializable], 0, 3, 0, 0, 0,
    onciu_InputPosition$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    sm_Ordering$IntOrdering, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$CachedReverse, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$Int$, 0, jl_Object, [sm_Ordering$IntOrdering, sm_Ordering$CachedReverse], 0, 3, 0, sm_Ordering$Int$_$callClinit, ["$lteq", $rt_wrapFunction2(sm_Ordering$Int$_lteq), "$gteq", $rt_wrapFunction2(sm_Ordering$Int$_gteq), "$lt", $rt_wrapFunction2(sm_Ordering$Int$_lt), "$max0", $rt_wrapFunction2(sm_Ordering$Int$_max), "$min0", $rt_wrapFunction2(sm_Ordering$Int$_min), "$compare", $rt_wrapFunction2(sm_Ordering$Int$_compare)],
    onciu_InputPosition, "InputPosition", 20, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(onciu_InputPosition_toString), "$productArity", $rt_wrapFunction0(onciu_InputPosition_productArity), "$productElement", $rt_wrapFunction1(onciu_InputPosition_productElement), "$productIterator", $rt_wrapFunction0(onciu_InputPosition_productIterator), "$hashCode0", $rt_wrapFunction0(onciu_InputPosition_hashCode), "$equals", $rt_wrapFunction1(onciu_InputPosition_equals)],
    oncias_SemanticFeature$UseAsMultipleGraphsSelector$, "SemanticFeature$UseAsMultipleGraphsSelector$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_productElement),
    "$productIterator", $rt_wrapFunction0(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$UseAsMultipleGraphsSelector$_hashCode)],
    oncias_SemanticFeature$ShowSetting$, "SemanticFeature$ShowSetting$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$ShowSetting$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$ShowSetting$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$ShowSetting$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$ShowSetting$_productElement), "$productIterator", $rt_wrapFunction0(oncias_SemanticFeature$ShowSetting$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$ShowSetting$_hashCode)],
    oncias_SemanticFeature$GpmShortestPath$, "SemanticFeature$GpmShortestPath$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$GpmShortestPath$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$GpmShortestPath$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$GpmShortestPath$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$GpmShortestPath$_productElement),
    "$productIterator", $rt_wrapFunction0(oncias_SemanticFeature$GpmShortestPath$_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$GpmShortestPath$_hashCode)],
    oncias_SemanticFeature$MatchModes$, "SemanticFeature$MatchModes$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$MatchModes$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$MatchModes$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$MatchModes$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$MatchModes$_productElement), "$productIterator", $rt_wrapFunction0(oncias_SemanticFeature$MatchModes$_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$MatchModes$_hashCode)],
    oncias_SemanticFeature$PropertyValueAccessRules$, "SemanticFeature$PropertyValueAccessRules$", 17, jl_Object, [oncias_SemanticFeature, oncias_FeatureToString, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncias_SemanticFeature$PropertyValueAccessRules$_toString), "$name3", $rt_wrapFunction0(oncias_SemanticFeature$PropertyValueAccessRules$_name), "$productArity", $rt_wrapFunction0(oncias_SemanticFeature$PropertyValueAccessRules$_productArity), "$productElement", $rt_wrapFunction1(oncias_SemanticFeature$PropertyValueAccessRules$_productElement),
    "$productIterator", $rt_wrapFunction0(oncias_SemanticFeature$PropertyValueAccessRules$_productIterator), "$hashCode0", $rt_wrapFunction0(oncias_SemanticFeature$PropertyValueAccessRules$_hashCode)],
    oncifp_BaseState$statement$lambda$_13_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(oncifp_BaseState$statement$lambda$_13_0_apply)]]);
    $rt_metadata([scm_Shrinkable$subtractAll$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(scm_Shrinkable$subtractAll$lambda$_6_0_apply)],
    oncirc_containsNoMatchingNodes, 0, jl_Object, [s_Function1, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    oncirc_containsNoReturnAll$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirc_containsNoReturnAll$$anonfun$1_applyOrElse)],
    jnc_CoderMalfunctionError, 0, jl_Error, [], 0, 3, 0, 0, 0,
    scm_MutationTracker$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncias_SemanticState$withFeatures$lambda$_40_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2(oncias_SemanticState$withFeatures$lambda$_40_0_apply)],
    sci_Vector2, "Vector2", 43, sci_BigVector, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Vector2_apply), "$updated2", $rt_wrapFunction2(sci_Vector2_updated), "$appended1", $rt_wrapFunction1(sci_Vector2_appended), "$prepended2", $rt_wrapFunction1(sci_Vector2_prepended), "$slice0", $rt_wrapFunction2(sci_Vector2_slice0), "$init0", $rt_wrapFunction0(sci_Vector2_init), "$vectorSliceCount", $rt_wrapFunction0(sci_Vector2_vectorSliceCount), "$vectorSlice", $rt_wrapFunction1(sci_Vector2_vectorSlice), "$appendedAll00",
    $rt_wrapFunction2(sci_Vector2_appendedAll0), "$init1", $rt_wrapFunction0(sci_Vector2_init0), "$tail", $rt_wrapFunction0(sci_Vector2_tail), "$map1", $rt_wrapFunction1(sci_Vector2_map0), "$prepended", $rt_wrapFunction1(sci_Vector2_prepended0), "$appended", $rt_wrapFunction1(sci_Vector2_appended0), "$updated7", $rt_wrapFunction2(sci_Vector2_updated0), "$apply", $rt_wrapFunction1(sci_Vector2_apply0)],
    oncias_ScopeTreeVerifier$$verify$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncias_ScopeTreeVerifier$$verify$lambda$_1_0_apply)],
    s_PartialFunction$Lifted, 0, sr_AbstractFunction1, [ji_Serializable], 0, 3, 0, 0, 0,
    s_PartialFunction$Unlifted, 0, sr_AbstractPartialFunction, [ji_Serializable], 0, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(s_PartialFunction$Unlifted_applyOrElse)],
    oncipj_ParseException, 0, jl_Exception, [], 0, 3, 0, 0, 0,
    oncipj_InvalidUnicodeLiteral, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    oncipj_ParseExceptions, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    s_Product3, 0, jl_Object, [s_Product], 3, 3, 0, 0, 0,
    s_Tuple3, "Tuple3", 38, jl_Object, [s_Product3, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0(s_Tuple3_productArity), "$productElement", $rt_wrapFunction1(s_Tuple3_productElement), "$toString", $rt_wrapFunction0(s_Tuple3_toString), "$productPrefix", $rt_wrapFunction0(s_Tuple3_productPrefix), "$productIterator", $rt_wrapFunction0(s_Tuple3_productIterator), "$hashCode0", $rt_wrapFunction0(s_Tuple3_hashCode), "$equals", $rt_wrapFunction1(s_Tuple3_equals)],
    scm_Queue$, 0, jl_Object, [sc_StrictOptimizedSeqFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(scm_Queue$_newBuilder), "$from0", $rt_wrapFunction1(scm_Queue$_from)],
    sci_ArraySeq$ofInt, "ArraySeq$ofInt", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofInt_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofInt_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofInt_equals), "$sorted", $rt_wrapFunction1(sci_ArraySeq$ofInt_sorted), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofInt_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofInt_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofInt_appended), "$prepended1", $rt_wrapFunction1(sci_ArraySeq$ofInt_prepended),
    "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofInt_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofInt_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofInt_updated0), "$sorted1", $rt_wrapFunction1(sci_ArraySeq$ofInt_sorted0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofInt_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofInt_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofInt_elemTag), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofInt_unsafeArray)],
    sci_ArraySeq$ofDouble, "ArraySeq$ofDouble", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofDouble_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofDouble_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofDouble_equals), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofDouble_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofDouble_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofDouble_appended), "$prepended1", $rt_wrapFunction1(sci_ArraySeq$ofDouble_prepended),
    "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofDouble_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofDouble_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofDouble_updated0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofDouble_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofDouble_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofDouble_elemTag), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofDouble_unsafeArray)],
    sci_ArraySeq$ofLong, "ArraySeq$ofLong", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofLong_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofLong_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofLong_equals), "$sorted", $rt_wrapFunction1(sci_ArraySeq$ofLong_sorted), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofLong_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofLong_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofLong_appended), "$prepended1",
    $rt_wrapFunction1(sci_ArraySeq$ofLong_prepended), "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofLong_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofLong_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofLong_updated0), "$sorted1", $rt_wrapFunction1(sci_ArraySeq$ofLong_sorted0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofLong_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofLong_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofLong_elemTag), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofLong_unsafeArray)],
    sci_ArraySeq$ofFloat, "ArraySeq$ofFloat", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofFloat_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofFloat_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofFloat_equals), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofFloat_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofFloat_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofFloat_appended), "$prepended1", $rt_wrapFunction1(sci_ArraySeq$ofFloat_prepended),
    "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofFloat_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofFloat_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofFloat_updated0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofFloat_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofFloat_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofFloat_elemTag), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofFloat_unsafeArray)],
    sci_ArraySeq$ofChar, "ArraySeq$ofChar", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofChar_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofChar_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofChar_equals), "$sorted", $rt_wrapFunction1(sci_ArraySeq$ofChar_sorted), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofChar_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofChar_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofChar_appended), "$prepended1",
    $rt_wrapFunction1(sci_ArraySeq$ofChar_prepended), "$addString", $rt_wrapFunction4(sci_ArraySeq$ofChar_addString), "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofChar_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofChar_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofChar_updated0), "$sorted1", $rt_wrapFunction1(sci_ArraySeq$ofChar_sorted0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofChar_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofChar_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofChar_elemTag),
    "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofChar_unsafeArray)],
    sci_ArraySeq$ofByte, "ArraySeq$ofByte", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofByte_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofByte_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofByte_equals), "$sorted", $rt_wrapFunction1(sci_ArraySeq$ofByte_sorted), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofByte_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofByte_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofByte_appended), "$prepended1",
    $rt_wrapFunction1(sci_ArraySeq$ofByte_prepended), "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofByte_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofByte_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofByte_updated0), "$sorted1", $rt_wrapFunction1(sci_ArraySeq$ofByte_sorted0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofByte_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofByte_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofByte_elemTag), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofByte_unsafeArray)],
    sci_ArraySeq$ofShort, "ArraySeq$ofShort", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofShort_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofShort_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofShort_equals), "$sorted", $rt_wrapFunction1(sci_ArraySeq$ofShort_sorted), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofShort_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofShort_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofShort_appended), "$prepended1",
    $rt_wrapFunction1(sci_ArraySeq$ofShort_prepended), "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofShort_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofShort_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofShort_updated0), "$sorted1", $rt_wrapFunction1(sci_ArraySeq$ofShort_sorted0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofShort_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofShort_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofShort_elemTag), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofShort_unsafeArray)],
    sci_ArraySeq$ofBoolean, "ArraySeq$ofBoolean", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofBoolean_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofBoolean_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_equals), "$sorted", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_sorted), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofBoolean_iterator), "$updated0", $rt_wrapFunction2(sci_ArraySeq$ofBoolean_updated), "$appended0", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_appended),
    "$prepended1", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_prepended), "$prepended", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_prepended0), "$appended", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_appended0), "$updated7", $rt_wrapFunction2(sci_ArraySeq$ofBoolean_updated0), "$sorted1", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_sorted0), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_apply0), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofBoolean_apply1), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofBoolean_elemTag),
    "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofBoolean_unsafeArray)],
    sci_ArraySeq$ofUnit, "ArraySeq$ofUnit", 43, sci_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0(sci_ArraySeq$ofUnit_length), "$hashCode0", $rt_wrapFunction0(sci_ArraySeq$ofUnit_hashCode), "$equals", $rt_wrapFunction1(sci_ArraySeq$ofUnit_equals), "$iterator0", $rt_wrapFunction0(sci_ArraySeq$ofUnit_iterator), "$apply", $rt_wrapFunction1(sci_ArraySeq$ofUnit_apply), "$apply1", $rt_wrapFunction1(sci_ArraySeq$ofUnit_apply0), "$elemTag", $rt_wrapFunction0(sci_ArraySeq$ofUnit_elemTag), "$unsafeArray", $rt_wrapFunction0(sci_ArraySeq$ofUnit_unsafeArray)],
    scm_SortedSetOps, 0, jl_Object, [scm_SetOps, sc_SortedSetOps], 3, 3, 0, 0, 0,
    scm_SortedSet, 0, jl_Object, [scm_Set, sc_SortedSet, scm_SortedSetOps], 3, 3, 0, 0, 0,
    sc_StrictOptimizedSortedSetOps, 0, jl_Object, [sc_SortedSetOps, sc_StrictOptimizedSetOps], 3, 3, 0, 0, 0,
    scm_TreeSet, "TreeSet", 44, scm_AbstractSet, [scm_SortedSet, sc_StrictOptimizedSortedSetOps, scg_DefaultSerializable], 0, 3, 0, 0, ["$concat1", $rt_wrapFunction1(scm_TreeSet_concat), "$map1", $rt_wrapFunction1(scm_TreeSet_map), "$flatMap", $rt_wrapFunction1(scm_TreeSet_flatMap), "$filterNot1", $rt_wrapFunction1(scm_TreeSet_filterNot), "$filterImpl", $rt_wrapFunction2(scm_TreeSet_filterImpl), "$stringPrefix", $rt_wrapFunction0(scm_TreeSet_stringPrefix), "$equals", $rt_wrapFunction1(scm_TreeSet_equals), "$newSpecificBuilder",
    $rt_wrapFunction0(scm_TreeSet_newSpecificBuilder), "$iterator0", $rt_wrapFunction0(scm_TreeSet_iterator), "$contains0", $rt_wrapFunction1(scm_TreeSet_contains), "$className", $rt_wrapFunction0(scm_TreeSet_className), "$size", $rt_wrapFunction0(scm_TreeSet_size), "$knownSize", $rt_wrapFunction0(scm_TreeSet_knownSize), "$isEmpty", $rt_wrapFunction0(scm_TreeSet_isEmpty), "$head", $rt_wrapFunction0(scm_TreeSet_head), "$foreach", $rt_wrapFunction1(scm_TreeSet_foreach), "$fromSpecific", $rt_wrapFunction1(scm_TreeSet_fromSpecific0),
    "$fromSpecific0", $rt_wrapFunction1(scm_TreeSet_fromSpecific1), "$subtractOne", $rt_wrapFunction1(scm_TreeSet_subtractOne), "$addOne", $rt_wrapFunction1(scm_TreeSet_addOne)],
    scm_RedBlackTree$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    scm_RedBlackTree$Tree$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sci_VectorBuilder$addVector$lambda$_22_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sci_VectorBuilder$addVector$lambda$_22_0_apply)],
    scm_RedBlackTree$Tree, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sci_HashMapBuilder, "HashMapBuilder", 43, jl_Object, [scm_ReusableBuilder], 4, 3, 0, 0, ["$addOne", $rt_wrapFunction1(sci_HashMapBuilder_addOne), "$result0", $rt_wrapFunction0(sci_HashMapBuilder_result0)],
    sc_SeqOps$contains$lambda$_84_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sc_SeqOps$contains$lambda$_84_0_apply)],
    sc_StrictOptimizedIterableOps$collect$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sc_StrictOptimizedIterableOps$collect$lambda$_19_0_apply)],
    s_PartialFunction$AndThen, 0, jl_Object, [s_PartialFunction, ji_Serializable], 0, 3, 0, 0, ["$lift1", $rt_wrapFunction0(s_PartialFunction$AndThen_lift), "$applyOrElse", $rt_wrapFunction2(s_PartialFunction$AndThen_applyOrElse)],
    oncir_RewriterStep$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sc_View$Collect, 0, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_View$Collect_iterator)],
    sc_AbstractMapView, 0, sc_AbstractView, [sc_MapView], 1, 3, 0, 0, 0,
    sc_MapView$Id, 0, sc_AbstractMapView, [], 0, 3, 0, 0, 0,
    onciu_StepSequencer$NegatedCondition, "StepSequencer$NegatedCondition", 20, jl_Object, [onciu_StepSequencer$Condition, s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(onciu_StepSequencer$NegatedCondition_toString), "$unary_$bang", $rt_wrapFunction0(onciu_StepSequencer$NegatedCondition_unary_$bang), "$productPrefix", $rt_wrapFunction0(onciu_StepSequencer$NegatedCondition_productPrefix), "$productArity", $rt_wrapFunction0(onciu_StepSequencer$NegatedCondition_productArity), "$productElement",
    $rt_wrapFunction1(onciu_StepSequencer$NegatedCondition_productElement), "$productIterator", $rt_wrapFunction0(onciu_StepSequencer$NegatedCondition_productIterator), "$hashCode0", $rt_wrapFunction0(onciu_StepSequencer$NegatedCondition_hashCode), "$equals", $rt_wrapFunction1(onciu_StepSequencer$NegatedCondition_equals)],
    ju_Collections, 0, jl_Object, [], 0, 3, 0, 0, 0,
    scm_ArrayDequeOps, 0, jl_Object, [sc_StrictOptimizedSeqOps], 3, 3, 0, 0, 0,
    scm_ArrayDeque, 0, scm_AbstractBuffer, [scm_IndexedBuffer, scm_ArrayDequeOps, scg_DefaultSerializable], 0, 3, 0, 0, ["$distinctBy", $rt_wrapFunction1(scm_ArrayDeque_distinctBy), "$prepended", $rt_wrapFunction1(scm_ArrayDeque_prepended), "$appended", $rt_wrapFunction1(scm_ArrayDeque_appended), "$appendedAll", $rt_wrapFunction1(scm_ArrayDeque_appendedAll), "$map1", $rt_wrapFunction1(scm_ArrayDeque_map), "$flatMap", $rt_wrapFunction1(scm_ArrayDeque_flatMap), "$flatten", $rt_wrapFunction1(scm_ArrayDeque_flatten),
    "$filter1", $rt_wrapFunction1(scm_ArrayDeque_filter), "$filterNot1", $rt_wrapFunction1(scm_ArrayDeque_filterNot), "$filterImpl", $rt_wrapFunction2(scm_ArrayDeque_filterImpl), "$iterator0", $rt_wrapFunction0(scm_ArrayDeque_iterator), "$reverseIterator", $rt_wrapFunction0(scm_ArrayDeque_reverseIterator), "$view0", $rt_wrapFunction0(scm_ArrayDeque_view), "$reversed", $rt_wrapFunction0(scm_ArrayDeque_reversed), "$head", $rt_wrapFunction0(scm_ArrayDeque_head), "$headOption", $rt_wrapFunction0(scm_ArrayDeque_headOption),
    "$lengthCompare", $rt_wrapFunction1(scm_ArrayDeque_lengthCompare), "$knownSize", $rt_wrapFunction0(scm_ArrayDeque_knownSize), "$apply1", $rt_wrapFunction1(scm_ArrayDeque_apply), "$length", $rt_wrapFunction0(scm_ArrayDeque_length), "$isEmpty", $rt_wrapFunction0(scm_ArrayDeque_isEmpty), "$copyToArray", $rt_wrapFunction3(scm_ArrayDeque_copyToArray), "$toArray", $rt_wrapFunction1(scm_ArrayDeque_toArray), "$addAll0", $rt_wrapFunction1(scm_ArrayDeque_addAll0), "$addOne", $rt_wrapFunction1(scm_ArrayDeque_addOne0),
    "$apply", $rt_wrapFunction1(scm_ArrayDeque_apply0)],
    scm_Queue, "Queue", 44, scm_ArrayDeque, [], 0, 3, 0, 0, ["$stringPrefix", $rt_wrapFunction0(scm_Queue_stringPrefix), "$iterableFactory", $rt_wrapFunction0(scm_Queue_iterableFactory)],
    sc_View$FlatMap, "View$FlatMap", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_View$FlatMap_iterator), "$knownSize", $rt_wrapFunction0(sc_View$FlatMap_knownSize), "$isEmpty", $rt_wrapFunction0(sc_View$FlatMap_isEmpty)],
    sm_Ordering$Reverse, 0, jl_Object, [sm_Ordering], 4, 3, 0, 0, 0,
    jl_ClassCastException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    onciu_StepSequencer$$anonfun$orderSteps$20$lambda$_38_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$20$lambda$_38_0_apply)]]);
    $rt_metadata([onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_1_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_0_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_2_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$anonfun$orderSteps$27$lambda$_47_3_apply)],
    su_Right, "Right", 39, su_Either, [], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(su_Right_productPrefix), "$productArity", $rt_wrapFunction0(su_Right_productArity), "$productElement", $rt_wrapFunction1(su_Right_productElement), "$productIterator", $rt_wrapFunction0(su_Right_productIterator), "$hashCode0", $rt_wrapFunction0(su_Right_hashCode), "$toString", $rt_wrapFunction0(su_Right_toString), "$equals", $rt_wrapFunction1(su_Right_equals)],
    ju_Set, 0, jl_Object, [ju_Collection], 3, 3, 0, 0, 0,
    ju_AbstractSet, 0, ju_AbstractCollection, [ju_Set], 1, 3, 0, 0, ["$equals", $rt_wrapFunction1(ju_AbstractSet_equals), "$hashCode0", $rt_wrapFunction0(ju_AbstractSet_hashCode)],
    ju_TemplateCollections$AbstractImmutableSet, 0, ju_AbstractSet, [], 1, 0, 0, 0, 0,
    ju_Collections$1, 0, ju_TemplateCollections$AbstractImmutableSet, [], 0, 0, 0, 0, 0,
    ju_AbstractMap, 0, jl_Object, [ju_Map], 1, 3, 0, 0, ["$equals", $rt_wrapFunction1(ju_AbstractMap_equals), "$hashCode0", $rt_wrapFunction0(ju_AbstractMap_hashCode), "$toString", $rt_wrapFunction0(ju_AbstractMap_toString)],
    ju_TemplateCollections$AbstractImmutableMap, 0, ju_AbstractMap, [], 1, 0, 0, 0, 0,
    ju_Collections$2, 0, ju_TemplateCollections$AbstractImmutableMap, [], 0, 0, 0, 0, 0,
    ju_TemplateCollections$AbstractImmutableList, 0, ju_AbstractList, [ju_RandomAccess], 1, 0, 0, 0, 0,
    ju_Collections$3, 0, ju_TemplateCollections$AbstractImmutableList, [], 0, 0, 0, 0, ["$get", $rt_wrapFunction1(ju_Collections$3_get), "$size", $rt_wrapFunction0(ju_Collections$3_size), "$iterator", $rt_wrapFunction0(ju_Collections$3_iterator), "$isEmpty", $rt_wrapFunction0(ju_Collections$3_isEmpty)],
    ju_Collections$4, 0, jl_Object, [ju_Iterator], 0, 0, 0, 0, ["$hasNext", $rt_wrapFunction0(ju_Collections$4_hasNext), "$next", $rt_wrapFunction0(ju_Collections$4_next)],
    ju_ListIterator, 0, jl_Object, [ju_Iterator], 3, 3, 0, 0, 0,
    ju_Collections$5, 0, jl_Object, [ju_ListIterator], 0, 0, 0, 0, 0,
    ju_Collections$_clinit_$lambda$_58_0, 0, jl_Object, [ju_Comparator], 0, 3, 0, 0, 0,
    ju_Collections$_clinit_$lambda$_58_1, 0, jl_Object, [ju_Comparator], 0, 3, 0, 0, 0,
    oncipj_ExpectBar, "ExpectBar", 19, jl_Enum, [], 12, 3, 0, oncipj_ExpectBar_$callClinit, 0,
    sci_Set$Set3$$anon$2, "Set$Set3$$anon$2", 43, sci_Set$SetNIterator, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Set$Set3$$anon$2_apply)],
    sm_Ordering$$anon$5, 0, jl_Object, [sm_Ordering], 4, 3, 0, 0, ["$max0", $rt_wrapFunction2(sm_Ordering$$anon$5_max), "$min0", $rt_wrapFunction2(sm_Ordering$$anon$5_min), "$lt", $rt_wrapFunction2(sm_Ordering$$anon$5_lt), "$gteq", $rt_wrapFunction2(sm_Ordering$$anon$5_gteq), "$lteq", $rt_wrapFunction2(sm_Ordering$$anon$5_lteq)],
    ju_ConcurrentModificationException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    scm_RedBlackTree$Node, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncir_ValidatingRewriter, "ValidatingRewriter", 24, jl_Object, [s_Function1, s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncir_ValidatingRewriter_toString), "$apply", $rt_wrapFunction1(oncir_ValidatingRewriter_apply), "$productPrefix", $rt_wrapFunction0(oncir_ValidatingRewriter_productPrefix), "$productArity", $rt_wrapFunction0(oncir_ValidatingRewriter_productArity), "$productElement", $rt_wrapFunction1(oncir_ValidatingRewriter_productElement), "$productIterator", $rt_wrapFunction0(oncir_ValidatingRewriter_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncir_ValidatingRewriter_hashCode), "$equals", $rt_wrapFunction1(oncir_ValidatingRewriter_equals)],
    sci_Vector3, "Vector3", 43, sci_BigVector, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Vector3_apply), "$updated2", $rt_wrapFunction2(sci_Vector3_updated), "$appended1", $rt_wrapFunction1(sci_Vector3_appended), "$prepended2", $rt_wrapFunction1(sci_Vector3_prepended), "$slice0", $rt_wrapFunction2(sci_Vector3_slice0), "$init0", $rt_wrapFunction0(sci_Vector3_init), "$vectorSliceCount", $rt_wrapFunction0(sci_Vector3_vectorSliceCount), "$vectorSlice", $rt_wrapFunction1(sci_Vector3_vectorSlice), "$appendedAll00",
    $rt_wrapFunction2(sci_Vector3_appendedAll0), "$init1", $rt_wrapFunction0(sci_Vector3_init0), "$tail", $rt_wrapFunction0(sci_Vector3_tail), "$map1", $rt_wrapFunction1(sci_Vector3_map0), "$prepended", $rt_wrapFunction1(sci_Vector3_prepended0), "$appended", $rt_wrapFunction1(sci_Vector3_appended0), "$updated7", $rt_wrapFunction2(sci_Vector3_updated0), "$apply", $rt_wrapFunction1(sci_Vector3_apply0)],
    sc_ArrayOps$ArrayIterator$mcD$sp, "ArrayOps$ArrayIterator$mcD$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcD$sp_next)],
    sc_ArrayOps$ArrayIterator$mcF$sp, "ArrayOps$ArrayIterator$mcF$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcF$sp_next)],
    sc_ArrayOps$ArrayIterator$mcS$sp, "ArrayOps$ArrayIterator$mcS$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcS$sp_next)],
    sc_ArrayOps$ArrayIterator$mcZ$sp, "ArrayOps$ArrayIterator$mcZ$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcZ$sp_next)],
    sc_ArrayOps$ArrayIterator$mcV$sp, "ArrayOps$ArrayIterator$mcV$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcV$sp_next)],
    sc_ArrayOps$ArrayIterator$mcJ$sp, "ArrayOps$ArrayIterator$mcJ$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcJ$sp_next)],
    sc_ArrayOps$ArrayIterator$mcI$sp, "ArrayOps$ArrayIterator$mcI$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcI$sp_next)],
    sc_ArrayOps$ArrayIterator$mcB$sp, "ArrayOps$ArrayIterator$mcB$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcB$sp_next)],
    sc_ArrayOps$ArrayIterator$mcC$sp, "ArrayOps$ArrayIterator$mcC$sp", 42, sc_ArrayOps$ArrayIterator, [], 4, 3, 0, 0, ["$next", $rt_wrapFunction0(sc_ArrayOps$ArrayIterator$mcC$sp_next)],
    scm_RedBlackTree$TreeIterator, 0, sc_AbstractIterator, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(scm_RedBlackTree$TreeIterator_hasNext), "$next", $rt_wrapFunction0(scm_RedBlackTree$TreeIterator_next)],
    scm_RedBlackTree$KeysIterator, "RedBlackTree$KeysIterator", 44, scm_RedBlackTree$TreeIterator, [], 4, 3, 0, 0, 0,
    jnci_BufferedEncoder$Controller, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_CypherException, 0, jl_RuntimeException, [], 1, 3, 0, 0, 0,
    onciu_OpenCypherExceptionFactory$SyntaxException, 0, onciu_CypherException, [], 0, 3, 0, 0, ["$getMessage", $rt_wrapFunction0(onciu_OpenCypherExceptionFactory$SyntaxException_getMessage)],
    scm_Stack$, 0, jl_Object, [sc_StrictOptimizedSeqFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(scm_Stack$_newBuilder), "$from0", $rt_wrapFunction1(scm_Stack$_from)],
    scm_Stack, "Stack", 44, scm_ArrayDeque, [], 0, 3, 0, 0, ["$stringPrefix", $rt_wrapFunction0(scm_Stack_stringPrefix), "$iterableFactory", $rt_wrapFunction0(scm_Stack_iterableFactory)],
    onciafn_Neo4jASTExceptionFactory$syntaxException$lambda$_10_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciafn_Neo4jASTExceptionFactory$syntaxException$lambda$_10_0_apply)],
    sci_HashCollisionSetNode$filterImpl$lambda$_18_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sci_HashCollisionSetNode$filterImpl$lambda$_18_0_apply)],
    sci_HashCollisionSetNode$filterImpl$lambda$_18_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sci_HashCollisionSetNode$filterImpl$lambda$_18_1_apply)],
    sci_Vector4, "Vector4", 43, sci_BigVector, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Vector4_apply), "$updated2", $rt_wrapFunction2(sci_Vector4_updated), "$appended1", $rt_wrapFunction1(sci_Vector4_appended), "$prepended2", $rt_wrapFunction1(sci_Vector4_prepended), "$slice0", $rt_wrapFunction2(sci_Vector4_slice0), "$init0", $rt_wrapFunction0(sci_Vector4_init), "$vectorSliceCount", $rt_wrapFunction0(sci_Vector4_vectorSliceCount), "$vectorSlice", $rt_wrapFunction1(sci_Vector4_vectorSlice), "$appendedAll00",
    $rt_wrapFunction2(sci_Vector4_appendedAll0), "$init1", $rt_wrapFunction0(sci_Vector4_init0), "$tail", $rt_wrapFunction0(sci_Vector4_tail), "$map1", $rt_wrapFunction1(sci_Vector4_map0), "$prepended", $rt_wrapFunction1(sci_Vector4_prepended0), "$appended", $rt_wrapFunction1(sci_Vector4_appended0), "$updated7", $rt_wrapFunction2(sci_Vector4_updated0), "$apply", $rt_wrapFunction1(sci_Vector4_apply0)],
    sci_Vector5, "Vector5", 43, sci_BigVector, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Vector5_apply), "$updated2", $rt_wrapFunction2(sci_Vector5_updated), "$appended1", $rt_wrapFunction1(sci_Vector5_appended), "$prepended2", $rt_wrapFunction1(sci_Vector5_prepended), "$slice0", $rt_wrapFunction2(sci_Vector5_slice0), "$init0", $rt_wrapFunction0(sci_Vector5_init), "$vectorSliceCount", $rt_wrapFunction0(sci_Vector5_vectorSliceCount), "$vectorSlice", $rt_wrapFunction1(sci_Vector5_vectorSlice), "$appendedAll00",
    $rt_wrapFunction2(sci_Vector5_appendedAll0), "$init1", $rt_wrapFunction0(sci_Vector5_init0), "$tail", $rt_wrapFunction0(sci_Vector5_tail), "$map1", $rt_wrapFunction1(sci_Vector5_map0), "$prepended", $rt_wrapFunction1(sci_Vector5_prepended0), "$appended", $rt_wrapFunction1(sci_Vector5_appended0), "$updated7", $rt_wrapFunction2(sci_Vector5_updated0), "$apply", $rt_wrapFunction1(sci_Vector5_apply0)],
    sci_Vector6, "Vector6", 43, sci_BigVector, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1(sci_Vector6_apply), "$updated2", $rt_wrapFunction2(sci_Vector6_updated), "$appended1", $rt_wrapFunction1(sci_Vector6_appended), "$prepended2", $rt_wrapFunction1(sci_Vector6_prepended), "$slice0", $rt_wrapFunction2(sci_Vector6_slice0), "$init0", $rt_wrapFunction0(sci_Vector6_init), "$vectorSliceCount", $rt_wrapFunction0(sci_Vector6_vectorSliceCount), "$vectorSlice", $rt_wrapFunction1(sci_Vector6_vectorSlice), "$appendedAll00",
    $rt_wrapFunction2(sci_Vector6_appendedAll0), "$init1", $rt_wrapFunction0(sci_Vector6_init0), "$tail", $rt_wrapFunction0(sci_Vector6_tail), "$map1", $rt_wrapFunction1(sci_Vector6_map0), "$prepended", $rt_wrapFunction1(sci_Vector6_prepended0), "$appended", $rt_wrapFunction1(sci_Vector6_appended0), "$updated7", $rt_wrapFunction2(sci_Vector6_updated0), "$apply", $rt_wrapFunction1(sci_Vector6_apply0)],
    onciu_Foldable$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    scm_ListBuffer$, 0, jl_Object, [sc_StrictOptimizedSeqFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(scm_ListBuffer$_newBuilder), "$from0", $rt_wrapFunction1(scm_ListBuffer$_from)]]);
    $rt_metadata([oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1_applyOrElse)],
    oncipj_TokenMgrException, 0, jl_RuntimeException, [], 0, 3, 0, 0, ["$getMessage", $rt_wrapFunction0(oncipj_TokenMgrException_getMessage)],
    onciuh_TreeZipper$Location, "TreeZipper$Location", 21, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0(onciuh_TreeZipper$Location_productPrefix), "$productArity", $rt_wrapFunction0(onciuh_TreeZipper$Location_productArity), "$productElement", $rt_wrapFunction1(onciuh_TreeZipper$Location_productElement), "$productIterator", $rt_wrapFunction0(onciuh_TreeZipper$Location_productIterator), "$hashCode0", $rt_wrapFunction0(onciuh_TreeZipper$Location_hashCode), "$toString", $rt_wrapFunction0(onciuh_TreeZipper$Location_toString),
    "$equals", $rt_wrapFunction1(onciuh_TreeZipper$Location_equals)],
    oncirr_normalizeWithAndReturnClauses, "normalizeWithAndReturnClauses", 25, jl_Object, [s_Function1, s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses_toString), "$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses_apply), "$productPrefix", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses_productPrefix), "$productArity", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses_productArity), "$productElement", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses_productElement),
    "$productIterator", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses_productIterator), "$hashCode0", $rt_wrapFunction0(oncirr_normalizeWithAndReturnClauses_hashCode), "$equals", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses_equals)],
    oncirr_rewriteShortestPathWithFixedLengthRel$, "rewriteShortestPathWithFixedLengthRel$", 25, jl_Object, [s_Function1], 4, 3, 0, oncirr_rewriteShortestPathWithFixedLengthRel$_$callClinit, ["$toString", $rt_wrapFunction0(oncirr_rewriteShortestPathWithFixedLengthRel$_toString), "$apply", $rt_wrapFunction1(oncirr_rewriteShortestPathWithFixedLengthRel$_apply)],
    ju_AbstractList$1, 0, jl_Object, [ju_Iterator], 0, 0, 0, 0, ["$hasNext", $rt_wrapFunction0(ju_AbstractList$1_hasNext), "$next", $rt_wrapFunction0(ju_AbstractList$1_next)],
    ju_EmptyStackException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    scm_ArrayDeque$, 0, jl_Object, [sc_StrictOptimizedSeqFactory], 4, 3, 0, 0, 0,
    onciu_Foldable$TreeAny$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_Foldable$FoldableAny, 0, jl_Object, [onciu_Foldable], 0, 3, 0, 0, ["$foldedOver", $rt_wrapFunction0(onciu_Foldable$FoldableAny_foldedOver)],
    oncirr_normalizeWithAndReturnClauses$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_normalizeWithAndReturnClauses$$anonfun$1_applyOrElse)],
    s_PartialFunction$Combined, 0, jl_Object, [s_PartialFunction, ji_Serializable], 0, 3, 0, 0, ["$lift1", $rt_wrapFunction0(s_PartialFunction$Combined_lift), "$applyOrElse", $rt_wrapFunction2(s_PartialFunction$Combined_applyOrElse)],
    sc_MapView$MapValues, 0, sc_AbstractMapView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0(sc_MapView$MapValues_iterator), "$knownSize", $rt_wrapFunction0(sc_MapView$MapValues_knownSize)],
    sc_SeqOps$indexOf$lambda$_58_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncirr_rewriteShortestPathWithFixedLengthRel$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirr_rewriteShortestPathWithFixedLengthRel$$anonfun$1_applyOrElse)],
    onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_0_apply)],
    onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_1_apply)],
    onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_2_apply)],
    onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_3_apply)],
    onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_StepSequencer$$$anonfun$sort$6$lambda$_19_4_apply)],
    oncirc_containsNoMatchingNodes$$anonfun$apply$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2(oncirc_containsNoMatchingNodes$$anonfun$apply$1_applyOrElse)],
    oncirc_containsNoMatchingNodes$apply$lambda$_30_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirc_containsNoMatchingNodes$apply$lambda$_30_0_apply)],
    onciu_Foldable$TreeAny$$treeChildren$extension$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_Foldable$TreeAny$$treeChildren$extension$lambda$_1_0_apply)],
    sc_MapView$MapValues$iterator$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(sc_MapView$MapValues$iterator$lambda$_0_0_apply)],
    scm_MutationTracker$CheckedIterator, "MutationTracker$CheckedIterator", 44, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(scm_MutationTracker$CheckedIterator_hasNext), "$next", $rt_wrapFunction0(scm_MutationTracker$CheckedIterator_next)],
    scm_ListBuffer$iterator$lambda$_59_0, 0, jl_Object, [srj_JFunction0$mcI$sp, ji_Serializable], 0, 3, 0, 0, 0,
    jn_ReadOnlyBufferException, 0, jl_UnsupportedOperationException, [], 0, 3, 0, 0, 0,
    jn_BufferOverflowException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    jn_BufferUnderflowException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    oncias_SemanticAnalysisTooling, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_Query, 0, jl_Object, [oncia_Statement, oncias_SemanticCheckable, oncias_SemanticAnalysisTooling], 3, 3, 0, 0, 0,
    oncia_StatementWithGraph, 0, jl_Object, [oncia_Statement], 3, 3, 0, 0, 0,
    oncia_AdministrationCommand, 0, jl_Object, [oncia_StatementWithGraph, oncias_SemanticAnalysisTooling], 3, 3, 0, 0, 0,
    oncia_ReadAdministrationCommand, 0, jl_Object, [oncia_AdministrationCommand], 3, 3, 0, 0, 0,
    oncia_ShowPrivileges, "ShowPrivileges", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowPrivileges_yields), "$returns", $rt_wrapFunction0(oncia_ShowPrivileges_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowPrivileges_semanticCheckFold),
    "$declareVariable", $rt_wrapFunction2(oncia_ShowPrivileges_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowPrivileges_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowPrivileges_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowPrivileges_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowPrivileges_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowPrivileges_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1(oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowPrivileges_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowPrivileges_yieldOrWhere),
    "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowPrivileges_defaultColumnSet), "$position2", $rt_wrapFunction0(oncia_ShowPrivileges_position), "$name3", $rt_wrapFunction0(oncia_ShowPrivileges_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowPrivileges_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowPrivileges_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowPrivileges_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowPrivileges_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowPrivileges_productIterator),
    "$hashCode0", $rt_wrapFunction0(oncia_ShowPrivileges_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowPrivileges_toString), "$equals", $rt_wrapFunction1(oncia_ShowPrivileges_equals), "$dup", $rt_wrapFunction1(oncia_ShowPrivileges_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowPrivileges_withGraph0)],
    oncia_Clause, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, oncias_SemanticAnalysisTooling], 3, 3, 0, 0, 0,
    oncia_HorizonClause, 0, jl_Object, [oncia_Clause], 3, 3, 0, 0, 0,
    oncia_ProjectionClause, 0, jl_Object, [oncia_HorizonClause], 3, 3, 0, 0, 0,
    oncia_ClauseAllowedOnSystem, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_Yield, "Yield", 13, jl_Object, [oncia_ProjectionClause, oncia_ClauseAllowedOnSystem, ji_Serializable], 0, 3, [0,0,0], 0, ["$isReturn", $rt_wrapFunction0(oncia_Yield_isReturn), "$copyProjection", function(var_1, var_2, var_3, var_4, var_5, var_6) { return oncia_Yield_copyProjection(this, var_1, var_2, var_3, var_4, var_5, var_6); }, "$copyProjection$default$1", $rt_wrapFunction0(oncia_Yield_copyProjection$default$1), "$copyProjection$default$3", $rt_wrapFunction0(oncia_Yield_copyProjection$default$3), "$copyProjection$default$4",
    $rt_wrapFunction0(oncia_Yield_copyProjection$default$4), "$copyProjection$default$5", $rt_wrapFunction0(oncia_Yield_copyProjection$default$5), "$copyProjection$default$6", $rt_wrapFunction0(oncia_Yield_copyProjection$default$6), "$clauseSpecificSemanticCheck", $rt_wrapFunction0(oncia_Yield_clauseSpecificSemanticCheck), "$semanticCheckContinuation", $rt_wrapFunction2(oncia_Yield_semanticCheckContinuation), "$semanticCheckContinuation$default$2", $rt_wrapFunction0(oncia_Yield_semanticCheckContinuation$default$2),
    "$verifyOrderByAggregationUse", $rt_wrapFunction1(oncia_Yield_verifyOrderByAggregationUse), "$returnVariables", $rt_wrapFunction0(oncia_Yield_returnVariables), "$semanticCheck", $rt_wrapFunction0(oncia_Yield_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0(oncia_Yield_shouldRunGpmChecks), "$error2", $rt_wrapFunction2(oncia_Yield_error), "$asCanonicalStringVal", $rt_wrapFunction0(oncia_Yield_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0(oncia_Yield_foldedOver), "$folder", $rt_wrapFunction0(oncia_Yield_folder),
    "$LabelExpressionsPartition", $rt_wrapFunction0(oncia_Yield_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0(oncia_Yield_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0(oncia_Yield_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1(oncia_Yield_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$returnItems0", $rt_wrapFunction0(oncia_Yield_returnItems), "$orderBy2", $rt_wrapFunction0(oncia_Yield_orderBy), "$skip2", $rt_wrapFunction0(oncia_Yield_skip), "$limit3", $rt_wrapFunction0(oncia_Yield_limit), "$where0", $rt_wrapFunction0(oncia_Yield_where), "$position2", $rt_wrapFunction0(oncia_Yield_position), "$distinct1", $rt_wrapFunction0(oncia_Yield_distinct), "$name3", $rt_wrapFunction0(oncia_Yield_name), "$warnOnAccessToRestrictedVariableInOrderByOrWhere", $rt_wrapFunction2(oncia_Yield_warnOnAccessToRestrictedVariableInOrderByOrWhere),
    "$productPrefix", $rt_wrapFunction0(oncia_Yield_productPrefix), "$productArity", $rt_wrapFunction0(oncia_Yield_productArity), "$productElement", $rt_wrapFunction1(oncia_Yield_productElement), "$productIterator", $rt_wrapFunction0(oncia_Yield_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_Yield_hashCode), "$toString", $rt_wrapFunction0(oncia_Yield_toString), "$equals", $rt_wrapFunction1(oncia_Yield_equals), "$dup", $rt_wrapFunction1(oncia_Yield_dup)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_0_apply)],
    oncia_ShowPrivilegeCommands, "ShowPrivilegeCommands", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_yields), "$returns", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowPrivilegeCommands_semanticCheckFold),
    "$declareVariable", $rt_wrapFunction2(oncia_ShowPrivilegeCommands_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowPrivilegeCommands_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowPrivilegeCommands_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowPrivilegeCommands_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1(oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowPrivilegeCommands_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere",
    $rt_wrapFunction0(oncia_ShowPrivilegeCommands_yieldOrWhere), "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_defaultColumnSet), "$position2", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_position), "$name3", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_productArity),
    "$productElement", $rt_wrapFunction1(oncia_ShowPrivilegeCommands_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowPrivilegeCommands_toString), "$equals", $rt_wrapFunction1(oncia_ShowPrivilegeCommands_equals), "$dup", $rt_wrapFunction1(oncia_ShowPrivilegeCommands_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowPrivilegeCommands_withGraph0)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_1_apply)],
    oncia_ShowSupportedPrivilegeCommand, "ShowSupportedPrivilegeCommand", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_yields), "$returns", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_returns),
    "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowSupportedPrivilegeCommand_semanticCheckFold), "$declareVariable", $rt_wrapFunction2(oncia_ShowSupportedPrivilegeCommand_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowSupportedPrivilegeCommand_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowSupportedPrivilegeCommand_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowSupportedPrivilegeCommand_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_foldedOver),
    "$folder", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1(oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq",
    $rt_wrapFunction1(oncia_ShowSupportedPrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_yieldOrWhere), "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_defaultColumnSet), "$position2", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_position), "$name3", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_semanticCheck),
    "$productPrefix", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowSupportedPrivilegeCommand_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowSupportedPrivilegeCommand_toString),
    "$equals", $rt_wrapFunction1(oncia_ShowSupportedPrivilegeCommand_equals), "$dup", $rt_wrapFunction1(oncia_ShowSupportedPrivilegeCommand_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowSupportedPrivilegeCommand_withGraph0)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_2_apply)],
    oncia_ShowDatabase, "ShowDatabase", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowDatabase_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowDatabase_yields), "$returns", $rt_wrapFunction0(oncia_ShowDatabase_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowDatabase_semanticCheckFold),
    "$declareVariable", $rt_wrapFunction2(oncia_ShowDatabase_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowDatabase_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowDatabase_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowDatabase_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowDatabase_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowDatabase_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1(oncia_ShowDatabase_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowDatabase_yieldOrWhere), "$position2", $rt_wrapFunction0(oncia_ShowDatabase_position), "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowDatabase_defaultColumnSet),
    "$name3", $rt_wrapFunction0(oncia_ShowDatabase_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowDatabase_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowDatabase_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowDatabase_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowDatabase_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowDatabase_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowDatabase_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowDatabase_toString),
    "$equals", $rt_wrapFunction1(oncia_ShowDatabase_equals), "$dup", $rt_wrapFunction1(oncia_ShowDatabase_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowDatabase_withGraph0)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_3_apply)],
    oncia_ShowAliases, "ShowAliases", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowAliases_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowAliases_yields), "$returns", $rt_wrapFunction0(oncia_ShowAliases_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowAliases_semanticCheckFold), "$declareVariable",
    $rt_wrapFunction2(oncia_ShowAliases_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowAliases_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowAliases_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowAliases_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowAliases_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowAliases_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1(oncia_ShowAliases_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowAliases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowAliases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowAliases_yieldOrWhere), "$position2", $rt_wrapFunction0(oncia_ShowAliases_position), "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowAliases_defaultColumnSet),
    "$name3", $rt_wrapFunction0(oncia_ShowAliases_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowAliases_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowAliases_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowAliases_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowAliases_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowAliases_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowAliases_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowAliases_toString),
    "$equals", $rt_wrapFunction1(oncia_ShowAliases_equals), "$dup", $rt_wrapFunction1(oncia_ShowAliases_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowAliases_withGraph0)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_4_apply)],
    oncia_ShowCurrentUser, "ShowCurrentUser", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowCurrentUser_yields), "$returns", $rt_wrapFunction0(oncia_ShowCurrentUser_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowCurrentUser_semanticCheckFold),
    "$declareVariable", $rt_wrapFunction2(oncia_ShowCurrentUser_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowCurrentUser_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowCurrentUser_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowCurrentUser_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowCurrentUser_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowCurrentUser_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1(oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowCurrentUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowCurrentUser_yieldOrWhere),
    "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowCurrentUser_defaultColumnSet), "$position2", $rt_wrapFunction0(oncia_ShowCurrentUser_position), "$name3", $rt_wrapFunction0(oncia_ShowCurrentUser_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowCurrentUser_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowCurrentUser_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowCurrentUser_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowCurrentUser_productElement), "$productIterator",
    $rt_wrapFunction0(oncia_ShowCurrentUser_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowCurrentUser_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowCurrentUser_toString), "$equals", $rt_wrapFunction1(oncia_ShowCurrentUser_equals), "$dup", $rt_wrapFunction1(oncia_ShowCurrentUser_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowCurrentUser_withGraph0)]]);
    $rt_metadata([oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_5_apply)],
    oncia_ShowUsers, "ShowUsers", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowUsers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowUsers_yields), "$returns", $rt_wrapFunction0(oncia_ShowUsers_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowUsers_semanticCheckFold), "$declareVariable",
    $rt_wrapFunction2(oncia_ShowUsers_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowUsers_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowUsers_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowUsers_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowUsers_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowUsers_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1(oncia_ShowUsers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowUsers_yieldOrWhere), "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowUsers_defaultColumnSet), "$position2", $rt_wrapFunction0(oncia_ShowUsers_position),
    "$name3", $rt_wrapFunction0(oncia_ShowUsers_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowUsers_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowUsers_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowUsers_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowUsers_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowUsers_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowUsers_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowUsers_toString), "$equals",
    $rt_wrapFunction1(oncia_ShowUsers_equals), "$dup", $rt_wrapFunction1(oncia_ShowUsers_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowUsers_withGraph0)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_6_apply)],
    oncia_ShowRoles, "ShowRoles", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowRoles_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowRoles_yields), "$returns", $rt_wrapFunction0(oncia_ShowRoles_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowRoles_semanticCheckFold), "$declareVariable",
    $rt_wrapFunction2(oncia_ShowRoles_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowRoles_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowRoles_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowRoles_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowRoles_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowRoles_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1(oncia_ShowRoles_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowRoles_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowRoles_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowRoles_yieldOrWhere), "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowRoles_defaultColumnSet), "$position2", $rt_wrapFunction0(oncia_ShowRoles_position),
    "$name3", $rt_wrapFunction0(oncia_ShowRoles_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowRoles_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowRoles_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowRoles_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowRoles_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowRoles_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowRoles_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowRoles_toString), "$equals",
    $rt_wrapFunction1(oncia_ShowRoles_equals), "$dup", $rt_wrapFunction1(oncia_ShowRoles_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowRoles_withGraph0)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_7_apply)],
    oncia_ShowServers, "ShowServers", 13, jl_Object, [oncia_ReadAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck", $rt_wrapFunction0(oncia_ShowServers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$$super$semanticCheck), "$yields", $rt_wrapFunction0(oncia_ShowServers_yields), "$returns", $rt_wrapFunction0(oncia_ShowServers_returns), "$semanticCheckFold", $rt_wrapFunction2(oncia_ShowServers_semanticCheckFold), "$declareVariable",
    $rt_wrapFunction2(oncia_ShowServers_declareVariable), "$recordCurrentScope", $rt_wrapFunction1(oncia_ShowServers_recordCurrentScope), "$requireFeatureSupport", $rt_wrapFunction3(oncia_ShowServers_requireFeatureSupport), "$error2", $rt_wrapFunction2(oncia_ShowServers_error), "$foldedOver", $rt_wrapFunction0(oncia_ShowServers_foldedOver), "$folder", $rt_wrapFunction0(oncia_ShowServers_folder), "$org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1(oncia_ShowServers_org$neo4j$cypher$internal$ast$ReadAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0(oncia_ShowServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1(oncia_ShowServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$yieldOrWhere", $rt_wrapFunction0(oncia_ShowServers_yieldOrWhere), "$position2", $rt_wrapFunction0(oncia_ShowServers_position), "$defaultColumnSet", $rt_wrapFunction0(oncia_ShowServers_defaultColumnSet),
    "$name3", $rt_wrapFunction0(oncia_ShowServers_name), "$semanticCheck", $rt_wrapFunction0(oncia_ShowServers_semanticCheck), "$productPrefix", $rt_wrapFunction0(oncia_ShowServers_productPrefix), "$productArity", $rt_wrapFunction0(oncia_ShowServers_productArity), "$productElement", $rt_wrapFunction1(oncia_ShowServers_productElement), "$productIterator", $rt_wrapFunction0(oncia_ShowServers_productIterator), "$hashCode0", $rt_wrapFunction0(oncia_ShowServers_hashCode), "$toString", $rt_wrapFunction0(oncia_ShowServers_toString),
    "$equals", $rt_wrapFunction1(oncia_ShowServers_equals), "$dup", $rt_wrapFunction1(oncia_ShowServers_dup), "$withGraph", $rt_wrapFunction1(oncia_ShowServers_withGraph0)],
    oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncirr_normalizeWithAndReturnClauses$apply$lambda$_34_8_apply)],
    sr_ScalaRunTime$$anon$1, "ScalaRunTime$$anon$1", 41, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0(sr_ScalaRunTime$$anon$1_hasNext), "$next", $rt_wrapFunction0(sr_ScalaRunTime$$anon$1_next)],
    sci_ListSet, 0, sci_AbstractSet, [sci_StrictOptimizedSetOps, scg_DefaultSerializable], 0, 3, 0, 0, ["$partition", $rt_wrapFunction1(sci_ListSet_partition), "$map1", $rt_wrapFunction1(sci_ListSet_map), "$flatMap", $rt_wrapFunction1(sci_ListSet_flatMap), "$collect0", $rt_wrapFunction1(sci_ListSet_collect), "$flatten", $rt_wrapFunction1(sci_ListSet_flatten), "$filter1", $rt_wrapFunction1(sci_ListSet_filter), "$filterNot1", $rt_wrapFunction1(sci_ListSet_filterNot), "$filterImpl", $rt_wrapFunction2(sci_ListSet_filterImpl),
    "$dropRight", $rt_wrapFunction1(sci_ListSet_dropRight), "$className", $rt_wrapFunction0(sci_ListSet_className), "$size", $rt_wrapFunction0(sci_ListSet_size), "$isEmpty", $rt_wrapFunction0(sci_ListSet_isEmpty), "$contains0", $rt_wrapFunction1(sci_ListSet_contains), "$incl1", $rt_wrapFunction1(sci_ListSet_incl), "$excl1", $rt_wrapFunction1(sci_ListSet_excl), "$iterator0", $rt_wrapFunction0(sci_ListSet_iterator), "$elem7", $rt_wrapFunction0(sci_ListSet_elem), "$next7", $rt_wrapFunction0(sci_ListSet_next), "$iterableFactory",
    $rt_wrapFunction0(sci_ListSet_iterableFactory), "$concat1", $rt_wrapFunction1(sci_ListSet_concat0), "$excl", $rt_wrapFunction1(sci_ListSet_excl0), "$incl", $rt_wrapFunction1(sci_ListSet_incl0)],
    sci_ListSet$, 0, jl_Object, [sc_IterableFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0(sci_ListSet$_newBuilder), "$from0", $rt_wrapFunction1(sci_ListSet$_from0)],
    onciu_Rewritable$$dupAny$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(onciu_Rewritable$$dupAny$lambda$_2_0_apply)],
    onciu_RewritableCompat, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sci_SetHashIterator, "SetHashIterator", 43, sci_ChampBaseIterator, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sci_SetHashIterator_iterator), "$isEmpty", $rt_wrapFunction0($java.sci_SetHashIterator_isEmpty), "$toString", $rt_wrapFunction0($java.sci_SetHashIterator_toString), "$foreach", $rt_wrapFunction1($java.sci_SetHashIterator_foreach), "$exists", $rt_wrapFunction1($java.sci_SetHashIterator_exists), "$find0", $rt_wrapFunction1($java.sci_SetHashIterator_find), "$foldLeft", $rt_wrapFunction2($java.sci_SetHashIterator_foldLeft),
    "$nonEmpty0", $rt_wrapFunction0($java.sci_SetHashIterator_nonEmpty), "$size", $rt_wrapFunction0($java.sci_SetHashIterator_size), "$copyToArray1", $rt_wrapFunction1($java.sci_SetHashIterator_copyToArray), "$copyToArray0", $rt_wrapFunction2($java.sci_SetHashIterator_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.sci_SetHashIterator_copyToArray1), "$toSeq", $rt_wrapFunction0($java.sci_SetHashIterator_toSeq), "$toArray", $rt_wrapFunction1($java.sci_SetHashIterator_toArray), "$knownSize", $rt_wrapFunction0($java.sci_SetHashIterator_knownSize),
    "$hashCode0", $rt_wrapFunction0($java.sci_SetHashIterator_hashCode), "$next", $rt_wrapFunction0($java.sci_SetHashIterator_next)],
    oncir_ValidatingRewriter$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncir_ValidatingRewriter$$anonfun$1_applyOrElse)],
    oncir_ValidatingRewriter$validate$lambda$_34_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_ValidatingRewriter$validate$lambda$_34_0_apply)],
    otcit_DoubleAnalyzer, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.onciuh_TreeZipper$Context, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciuh_TreeZipper$Top$, "TreeZipper$Top$", 21, jl_Object, [$java.onciuh_TreeZipper$Context, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.onciuh_TreeZipper$Top$_productArity), "$productElement", $rt_wrapFunction1($java.onciuh_TreeZipper$Top$_productElement), "$productIterator", $rt_wrapFunction0($java.onciuh_TreeZipper$Top$_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciuh_TreeZipper$Top$_hashCode), "$toString", $rt_wrapFunction0($java.onciuh_TreeZipper$Top$_toString)],
    onciu_Rewritable$IteratorEq, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sci_Map$WithDefault, "Map$WithDefault", 43, sci_AbstractMap, [ji_Serializable], 0, 3, 0, 0, ["$get1", $rt_wrapFunction1($java.sci_Map$WithDefault_get), "$default0", $rt_wrapFunction1($java.sci_Map$WithDefault_default), "$iterableFactory", $rt_wrapFunction0($java.sci_Map$WithDefault_iterableFactory), "$iterator0", $rt_wrapFunction0($java.sci_Map$WithDefault_iterator), "$isEmpty", $rt_wrapFunction0($java.sci_Map$WithDefault_isEmpty), "$mapFactory", $rt_wrapFunction0($java.sci_Map$WithDefault_mapFactory), "$newSpecificBuilder",
    $rt_wrapFunction0($java.sci_Map$WithDefault_newSpecificBuilder), "$fromSpecific", $rt_wrapFunction1($java.sci_Map$WithDefault_fromSpecific0), "$fromSpecific0", $rt_wrapFunction1($java.sci_Map$WithDefault_fromSpecific1), "$updated1", $rt_wrapFunction2($java.sci_Map$WithDefault_updated), "$removed", $rt_wrapFunction1($java.sci_Map$WithDefault_removed), "$concat2", $rt_wrapFunction1($java.sci_Map$WithDefault_concat)],
    sci_Map$withDefaultValue$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    sc_Iterator$$anon$7, "Iterator$$anon$7", 42, sc_AbstractIterator, [s_Function1], 4, 3, 0, 0, ["$toString", $rt_wrapFunction0($java.sc_Iterator$$anon$7_toString), "$apply", $rt_wrapFunction1($java.sc_Iterator$$anon$7_apply), "$hasNext", $rt_wrapFunction0($java.sc_Iterator$$anon$7_hasNext), "$next", $rt_wrapFunction0($java.sc_Iterator$$anon$7_next)],
    oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_0_apply)],
    oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_ValidatingRewriter$buildErrorMessage$lambda$_35_1_apply)],
    oncirr_normalizeWithAndReturnClauses$aliasUnaliasedReturnItems$lambda$_39_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$aliasUnaliasedReturnItems$lambda$_39_0_apply)],
    $java.scc_JavaCollectionWrappers$IterableWrapperTrait, 0, jl_Object, [], 3, 3, 0, 0, 0,
    scc_JavaCollectionWrappers$MutableBufferWrapper, 0, ju_AbstractList, [$java.scc_JavaCollectionWrappers$IterableWrapperTrait, ji_Serializable], 0, 3, 0, 0, 0,
    scc_JavaCollectionWrappers$JListWrapper, 0, scm_AbstractBuffer, [sc_StrictOptimizedSeqOps, ji_Serializable], 0, 3, 0, 0, ["$knownSize", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JListWrapper_knownSize), "$iterator0", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JListWrapper_iterator), "$iterableFactory", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JListWrapper_iterableFactory)],
    oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1_applyOrElse)],
    oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1_applyOrElse)],
    oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1_applyOrElse)],
    oncia_ReturnItems, "ReturnItems", 13, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, oncias_SemanticAnalysisTooling, ji_Serializable], 4, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_ReturnItems_position), "$semanticCheck", $rt_wrapFunction0(oncia_ReturnItems_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_ReturnItems_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ReturnItems_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ReturnItems_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_ReturnItems_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ReturnItems_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ReturnItems_toString), "$equals", $rt_wrapFunction1(oncia_ReturnItems_equals), "$dup", $rt_wrapFunction1($java.oncia_ReturnItems_dup)],
    sci_MapKeyValueTupleIterator, "MapKeyValueTupleIterator", 43, sci_ChampBaseIterator, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_iterator), "$isEmpty", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_isEmpty), "$filter", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_filter), "$filterImpl0", $rt_wrapFunction2($java.sci_MapKeyValueTupleIterator_filterImpl), "$collect3", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_collect), "$map7", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_map),
    "$flatMap2", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_flatMap), "$concat", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_concat), "$toString", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_toString), "$foreach", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_foreach), "$exists", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_exists), "$find0", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_find), "$foldLeft", $rt_wrapFunction2($java.sci_MapKeyValueTupleIterator_foldLeft),
    "$nonEmpty0", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_nonEmpty), "$size", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_size), "$copyToArray1", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_copyToArray), "$copyToArray0", $rt_wrapFunction2($java.sci_MapKeyValueTupleIterator_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.sci_MapKeyValueTupleIterator_copyToArray1), "$to0", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_to), "$toSeq", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_toSeq),
    "$toArray", $rt_wrapFunction1($java.sci_MapKeyValueTupleIterator_toArray), "$knownSize", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_knownSize), "$next", $rt_wrapFunction0($java.sci_MapKeyValueTupleIterator_next)],
    sci_Set$Set4$$anon$3, "Set$Set4$$anon$3", 43, sci_Set$SetNIterator, [], 4, 3, 0, 0, ["$apply1", $rt_wrapFunction1($java.sci_Set$Set4$$anon$3_apply)],
    $java.scc_AsJavaExtensions, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.scc_AsScalaExtensions, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sj_CollectionConverters$, 0, jl_Object, [$java.scc_AsJavaExtensions, $java.scc_AsScalaExtensions], 4, 3, 0, 0, 0,
    scc_AsScalaExtensions$IteratorHasAsScala, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sci_HashCollisionMapNode, "HashCollisionMapNode", 43, sci_MapNode, [], 4, 3, 0, 0, ["$size", $rt_wrapFunction0($java.sci_HashCollisionMapNode_size), "$apply28", $rt_wrapFunction4($java.sci_HashCollisionMapNode_apply), "$get4", $rt_wrapFunction4($java.sci_HashCollisionMapNode_get), "$getOrElse1", function(var_1, var_2, var_3, var_4, var_5) { return $java.sci_HashCollisionMapNode_getOrElse(this, var_1, var_2, var_3, var_4, var_5); }, "$containsKey0", $rt_wrapFunction4($java.sci_HashCollisionMapNode_containsKey),
    "$updated6", function(var_1, var_2, var_3, var_4, var_5, var_6) { return $java.sci_HashCollisionMapNode_updated(this, var_1, var_2, var_3, var_4, var_5, var_6); }, "$removed3", $rt_wrapFunction4($java.sci_HashCollisionMapNode_removed), "$hasNodes", $rt_wrapFunction0($java.sci_HashCollisionMapNode_hasNodes), "$nodeArity", $rt_wrapFunction0($java.sci_HashCollisionMapNode_nodeArity), "$hasPayload", $rt_wrapFunction0($java.sci_HashCollisionMapNode_hasPayload), "$payloadArity", $rt_wrapFunction0($java.sci_HashCollisionMapNode_payloadArity),
    "$getKey", $rt_wrapFunction1($java.sci_HashCollisionMapNode_getKey), "$getValue", $rt_wrapFunction1($java.sci_HashCollisionMapNode_getValue), "$getPayload0", $rt_wrapFunction1($java.sci_HashCollisionMapNode_getPayload), "$getHash", $rt_wrapFunction1($java.sci_HashCollisionMapNode_getHash), "$foreach", $rt_wrapFunction1($java.sci_HashCollisionMapNode_foreach), "$foreachEntry", $rt_wrapFunction1($java.sci_HashCollisionMapNode_foreachEntry), "$foreachWithHash", $rt_wrapFunction1($java.sci_HashCollisionMapNode_foreachWithHash),
    "$equals", $rt_wrapFunction1($java.sci_HashCollisionMapNode_equals), "$filterImpl4", $rt_wrapFunction2($java.sci_HashCollisionMapNode_filterImpl), "$hashCode0", $rt_wrapFunction0($java.sci_HashCollisionMapNode_hashCode), "$cachedJavaKeySetHashCode", $rt_wrapFunction0($java.sci_HashCollisionMapNode_cachedJavaKeySetHashCode), "$copy21", $rt_wrapFunction0($java.sci_HashCollisionMapNode_copy), "$concat8", $rt_wrapFunction2($java.sci_HashCollisionMapNode_concat), "$getNode1", $rt_wrapFunction1($java.sci_HashCollisionMapNode_getNode)],
    oncias_SemanticErrorDef, "SemanticErrorDef", 17, jl_Object, [], 3, 3, [0,0,0], 0, 0,
    $java.sci_Map$Map4, "Map$Map4", 43, sci_AbstractMap, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$map1", $rt_wrapFunction1($java.sci_Map$Map4_map), "$flatMap", $rt_wrapFunction1($java.sci_Map$Map4_flatMap), "$collect0", $rt_wrapFunction1($java.sci_Map$Map4_collect), "$flatten", $rt_wrapFunction1($java.sci_Map$Map4_flatten), "$filter1", $rt_wrapFunction1($java.sci_Map$Map4_filter), "$filterNot1", $rt_wrapFunction1($java.sci_Map$Map4_filterNot), "$size", $rt_wrapFunction0($java.sci_Map$Map4_size),
    "$knownSize", $rt_wrapFunction0($java.sci_Map$Map4_knownSize), "$isEmpty", $rt_wrapFunction0($java.sci_Map$Map4_isEmpty), "$apply", $rt_wrapFunction1($java.sci_Map$Map4_apply), "$contains0", $rt_wrapFunction1($java.sci_Map$Map4_contains), "$get1", $rt_wrapFunction1($java.sci_Map$Map4_get), "$getOrElse0", $rt_wrapFunction2($java.sci_Map$Map4_getOrElse), "$iterator0", $rt_wrapFunction0($java.sci_Map$Map4_iterator), "$keysIterator", $rt_wrapFunction0($java.sci_Map$Map4_keysIterator), "$valuesIterator", $rt_wrapFunction0($java.sci_Map$Map4_valuesIterator),
    "$foreach", $rt_wrapFunction1($java.sci_Map$Map4_foreach), "$exists", $rt_wrapFunction1($java.sci_Map$Map4_exists), "$forall", $rt_wrapFunction1($java.sci_Map$Map4_forall), "$hashCode0", $rt_wrapFunction0($java.sci_Map$Map4_hashCode), "$filterImpl", $rt_wrapFunction2($java.sci_Map$Map4_filterImpl0), "$removed", $rt_wrapFunction1($java.sci_Map$Map4_removed), "$updated1", $rt_wrapFunction2($java.sci_Map$Map4_updated)],
    oncia_SingleQuery, "SingleQuery", 13, jl_Object, [oncia_Query, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnColumns", $rt_wrapFunction0($java.oncia_SingleQuery_returnColumns), "$whenState", $rt_wrapFunction3($java.oncia_SingleQuery_whenState), "$whenState$default$3", $rt_wrapFunction1($java.oncia_SingleQuery_whenState$default$3), "$foldedOver", $rt_wrapFunction0($java.oncia_SingleQuery_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_SingleQuery_folder), "$position2", $rt_wrapFunction0($java.oncia_SingleQuery_position),
    "$containsUpdates", $rt_wrapFunction0($java.oncia_SingleQuery_containsUpdates), "$returnVariables", $rt_wrapFunction0($java.oncia_SingleQuery_returnVariables), "$isReturning", $rt_wrapFunction0($java.oncia_SingleQuery_isReturning), "$semanticCheck", $rt_wrapFunction0($java.oncia_SingleQuery_semanticCheck), "$semanticCheckInSubqueryExpressionContext", $rt_wrapFunction1($java.oncia_SingleQuery_semanticCheckInSubqueryExpressionContext), "$checkImportingWith", $rt_wrapFunction0($java.oncia_SingleQuery_checkImportingWith),
    "$semanticCheckInSubqueryContext", $rt_wrapFunction1($java.oncia_SingleQuery_semanticCheckInSubqueryContext), "$finalScope", $rt_wrapFunction1($java.oncia_SingleQuery_finalScope), "$productPrefix", $rt_wrapFunction0($java.oncia_SingleQuery_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SingleQuery_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SingleQuery_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SingleQuery_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SingleQuery_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_SingleQuery_toString), "$equals", $rt_wrapFunction1($java.oncia_SingleQuery_equals), "$dup", $rt_wrapFunction1($java.oncia_SingleQuery_dup)],
    oncia_Union, 0, jl_Object, [oncia_Query], 3, 3, 0, 0, 0,
    $java.oncia_UnmappedUnion, 0, jl_Object, [oncia_Union], 3, 3, 0, 0, 0,
    oncia_UnionAll, "UnionAll", 13, jl_Object, [$java.oncia_UnmappedUnion, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$UnmappedUnion$$super$dup", $rt_wrapFunction1($java.oncia_UnionAll_org$neo4j$cypher$internal$ast$UnmappedUnion$$super$dup), "$unionMappings", $rt_wrapFunction0($java.oncia_UnionAll_unionMappings), "$checkColumnNamesAgree", $rt_wrapFunction0($java.oncia_UnionAll_checkColumnNamesAgree), "$returnVariables", $rt_wrapFunction0($java.oncia_UnionAll_returnVariables), "$containsUpdates",
    $rt_wrapFunction0($java.oncia_UnionAll_containsUpdates), "$semanticCheck", $rt_wrapFunction0($java.oncia_UnionAll_semanticCheck), "$semanticCheckInSubqueryExpressionContext", $rt_wrapFunction1($java.oncia_UnionAll_semanticCheckInSubqueryExpressionContext), "$checkImportingWith", $rt_wrapFunction0($java.oncia_UnionAll_checkImportingWith), "$isReturning", $rt_wrapFunction0($java.oncia_UnionAll_isReturning), "$semanticCheckInSubqueryContext", $rt_wrapFunction1($java.oncia_UnionAll_semanticCheckInSubqueryContext),
    "$finalScope", $rt_wrapFunction1($java.oncia_UnionAll_finalScope), "$returnColumns", $rt_wrapFunction0($java.oncia_UnionAll_returnColumns), "$checkUse", $rt_wrapFunction0($java.oncia_UnionAll_checkUse), "$whenState", $rt_wrapFunction3($java.oncia_UnionAll_whenState), "$whenState$default$3", $rt_wrapFunction1($java.oncia_UnionAll_whenState$default$3), "$withScopedState", $rt_wrapFunction1($java.oncia_UnionAll_withScopedState), "$error2", $rt_wrapFunction2($java.oncia_UnionAll_error), "$foldedOver", $rt_wrapFunction0($java.oncia_UnionAll_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_UnionAll_folder), "$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings0", $rt_wrapFunction0($java.oncia_UnionAll_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings), "$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq", $rt_wrapFunction1($java.oncia_UnionAll_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq), "$lhs", $rt_wrapFunction0(oncia_UnionAll_lhs), "$rhs", $rt_wrapFunction0(oncia_UnionAll_rhs), "$position2", $rt_wrapFunction0($java.oncia_UnionAll_position),
    "$productPrefix", $rt_wrapFunction0($java.oncia_UnionAll_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_UnionAll_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UnionAll_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UnionAll_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UnionAll_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UnionAll_toString), "$equals", $rt_wrapFunction1($java.oncia_UnionAll_equals), "$dup", $rt_wrapFunction1($java.oncia_UnionAll_dup)],
    oncia_UnionDistinct, "UnionDistinct", 13, jl_Object, [$java.oncia_UnmappedUnion, ji_Serializable], 4, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$UnmappedUnion$$super$dup", $rt_wrapFunction1($java.oncia_UnionDistinct_org$neo4j$cypher$internal$ast$UnmappedUnion$$super$dup), "$unionMappings", $rt_wrapFunction0($java.oncia_UnionDistinct_unionMappings), "$checkColumnNamesAgree", $rt_wrapFunction0($java.oncia_UnionDistinct_checkColumnNamesAgree), "$returnVariables", $rt_wrapFunction0($java.oncia_UnionDistinct_returnVariables),
    "$containsUpdates", $rt_wrapFunction0($java.oncia_UnionDistinct_containsUpdates), "$semanticCheck", $rt_wrapFunction0($java.oncia_UnionDistinct_semanticCheck), "$semanticCheckInSubqueryExpressionContext", $rt_wrapFunction1($java.oncia_UnionDistinct_semanticCheckInSubqueryExpressionContext), "$checkImportingWith", $rt_wrapFunction0($java.oncia_UnionDistinct_checkImportingWith), "$isReturning", $rt_wrapFunction0($java.oncia_UnionDistinct_isReturning), "$semanticCheckInSubqueryContext", $rt_wrapFunction1($java.oncia_UnionDistinct_semanticCheckInSubqueryContext),
    "$finalScope", $rt_wrapFunction1($java.oncia_UnionDistinct_finalScope), "$returnColumns", $rt_wrapFunction0($java.oncia_UnionDistinct_returnColumns), "$checkUse", $rt_wrapFunction0($java.oncia_UnionDistinct_checkUse), "$whenState", $rt_wrapFunction3($java.oncia_UnionDistinct_whenState), "$whenState$default$3", $rt_wrapFunction1($java.oncia_UnionDistinct_whenState$default$3), "$withScopedState", $rt_wrapFunction1($java.oncia_UnionDistinct_withScopedState), "$error2", $rt_wrapFunction2($java.oncia_UnionDistinct_error),
    "$foldedOver", $rt_wrapFunction0($java.oncia_UnionDistinct_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_UnionDistinct_folder), "$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings0", $rt_wrapFunction0($java.oncia_UnionDistinct_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings), "$org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq", $rt_wrapFunction1($java.oncia_UnionDistinct_org$neo4j$cypher$internal$ast$UnmappedUnion$$_unionMappings_$eq), "$lhs", $rt_wrapFunction0(oncia_UnionDistinct_lhs),
    "$rhs", $rt_wrapFunction0(oncia_UnionDistinct_rhs), "$position2", $rt_wrapFunction0($java.oncia_UnionDistinct_position), "$productPrefix", $rt_wrapFunction0($java.oncia_UnionDistinct_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_UnionDistinct_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UnionDistinct_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UnionDistinct_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UnionDistinct_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_UnionDistinct_toString), "$equals", $rt_wrapFunction1($java.oncia_UnionDistinct_equals), "$dup", $rt_wrapFunction1($java.oncia_UnionDistinct_dup)],
    oncia_ProjectingUnion, 0, jl_Object, [oncia_Union], 3, 3, 0, 0, 0,
    oncie_Expression, "Expression", 28, jl_Object, [onciu_ASTNode], 1, 3, [0,0,0], 0, ["$dup0", $rt_wrapFunction1($java.oncie_Expression_dup), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Expression_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncie_Expression_foldedOver), "$dependencies0", $rt_wrapFunction0($java.oncie_Expression_dependencies), "$dup", $rt_wrapFunction1($java.oncie_Expression_dup0)],
    s_Option$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncirc_containsNoNodesOfType$apply$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirc_containsNoNodesOfType$apply$lambda$_31_0_apply)]]);
    $rt_metadata([oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_insertWithBetweenOptionalMatchAndMatch$$anonfun$1$$anonfun$2_applyOrElse0)],
    oncirr_expandCallWhere$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandCallWhere$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    oncia_Where, "Where", 13, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_Where_foldedOver), "$position2", $rt_wrapFunction0($java.oncia_Where_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_Where_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Where_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Where_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Where_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_Where_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Where_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Where_toString), "$equals", $rt_wrapFunction1($java.oncia_Where_equals), "$dup", $rt_wrapFunction1($java.oncia_Where_dup)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_1_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_2_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_3_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_4_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_5_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_6_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_7_apply)],
    oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$anonfun$1$applyOrElse$lambda$_0_8_apply)],
    $java.oncie_BooleanExpression, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_OperatorExpression, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_BinaryOperatorExpression, 0, jl_Object, [$java.oncie_OperatorExpression], 3, 3, 0, 0, 0,
    oncie_And, "And", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_And_asCanonicalStringVal), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_And_canonicalOperatorSymbol), "$lhs0", $rt_wrapFunction0($java.oncie_And_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_And_rhs), "$position2", $rt_wrapFunction0($java.oncie_And_position), "$productPrefix", $rt_wrapFunction0($java.oncie_And_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_And_productArity), "$productElement", $rt_wrapFunction1($java.oncie_And_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_And_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_And_hashCode), "$toString", $rt_wrapFunction0($java.oncie_And_toString), "$equals", $rt_wrapFunction1($java.oncie_And_equals)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_1_apply)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_2_apply)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_3, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_3_apply)],
    oncie_Or, "Or", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Or_asCanonicalStringVal), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Or_canonicalOperatorSymbol), "$lhs0", $rt_wrapFunction0($java.oncie_Or_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Or_rhs), "$position2", $rt_wrapFunction0($java.oncie_Or_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Or_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Or_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Or_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Or_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Or_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Or_toString), "$equals", $rt_wrapFunction1($java.oncie_Or_equals)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_4, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_4_apply)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_5, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_5_apply)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_6, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_6_apply)],
    oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_7, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$1$applyOrElse$lambda$_0_7_apply)],
    oncie_FunctionInvocation, "FunctionInvocation", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0(oncie_FunctionInvocation_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_FunctionInvocation_asCanonicalStringVal), "$productPrefix", $rt_wrapFunction0($java.oncie_FunctionInvocation_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_FunctionInvocation_productArity), "$productElement", $rt_wrapFunction1($java.oncie_FunctionInvocation_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_FunctionInvocation_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_FunctionInvocation_hashCode), "$toString", $rt_wrapFunction0($java.oncie_FunctionInvocation_toString), "$equals", $rt_wrapFunction1($java.oncie_FunctionInvocation_equals)],
    oncie_SymbolicName, "SymbolicName", 28, jl_Object, [onciu_ASTNode], 3, 3, [0,0,0], 0, 0,
    oncie_FunctionName, "FunctionName", 28, jl_Object, [oncie_SymbolicName, ji_Serializable], 0, 3, [0,0,0], 0, ["$name3", $rt_wrapFunction0(oncie_FunctionName_name), "$position2", $rt_wrapFunction0($java.oncie_FunctionName_position), "$equals", $rt_wrapFunction1($java.oncie_FunctionName_equals), "$hashCode0", $rt_wrapFunction0($java.oncie_FunctionName_hashCode), "$productPrefix", $rt_wrapFunction0($java.oncie_FunctionName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_FunctionName_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_FunctionName_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_FunctionName_productIterator), "$toString", $rt_wrapFunction0($java.oncie_FunctionName_toString), "$dup", $rt_wrapFunction1($java.oncie_FunctionName_dup)],
    $java.oncie_LogicalProperty, 0, oncie_Expression, [], 1, 3, 0, 0, 0,
    oncie_Property, "Property", 28, $java.oncie_LogicalProperty, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_Property_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Property_asCanonicalStringVal), "$productPrefix", $rt_wrapFunction0($java.oncie_Property_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Property_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Property_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Property_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_Property_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Property_toString), "$equals", $rt_wrapFunction1($java.oncie_Property_equals)],
    oncie_PropertyKeyName, "PropertyKeyName", 28, jl_Object, [oncie_SymbolicName, ji_Serializable], 0, 3, [0,0,0], 0, ["$name3", $rt_wrapFunction0($java.oncie_PropertyKeyName_name), "$position2", $rt_wrapFunction0($java.oncie_PropertyKeyName_position), "$productPrefix", $rt_wrapFunction0($java.oncie_PropertyKeyName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PropertyKeyName_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PropertyKeyName_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PropertyKeyName_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_PropertyKeyName_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PropertyKeyName_toString), "$equals", $rt_wrapFunction1($java.oncie_PropertyKeyName_equals), "$dup", $rt_wrapFunction1($java.oncie_PropertyKeyName_dup)],
    onciu_Ref$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    oncie_Literal, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_ExpressionWithComputedDependencies, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncias_SemanticState$ScopeLocation$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncia_ASTAnnotationMap$PositionedNode$, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    oncias_SemanticState$ScopeLocation, "SemanticState$ScopeLocation", 17, jl_Object, [], 4, 3, 0, 0, ["$hashCode0", $rt_wrapFunction0($java.oncias_SemanticState$ScopeLocation_hashCode), "$equals", $rt_wrapFunction1($java.oncias_SemanticState$ScopeLocation_equals)],
    oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_computeDependenciesForExpressions$$anonfun$1$applyOrElse$lambda$_0_1_apply)],
    oncia_ProjectionClause$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.s_Product6, 0, jl_Object, [s_Product], 3, 3, 0, 0, 0,
    $java.s_Tuple6, "Tuple6", 38, jl_Object, [$java.s_Product6, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.s_Tuple6_productArity), "$productElement", $rt_wrapFunction1($java.s_Tuple6_productElement), "$toString", $rt_wrapFunction0($java.s_Tuple6_toString), "$productPrefix", $rt_wrapFunction0($java.s_Tuple6_productPrefix), "$productIterator", $rt_wrapFunction0($java.s_Tuple6_productIterator), "$hashCode0", $rt_wrapFunction0($java.s_Tuple6_hashCode), "$equals", $rt_wrapFunction1($java.s_Tuple6_equals)],
    $java.oncie_ScopeExpression, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_SubqueryExpression, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_FullSubqueryExpression, 0, jl_Object, [$java.oncie_ScopeExpression, $java.oncie_SubqueryExpression, oncie_ExpressionWithComputedDependencies], 3, 3, 0, 0, 0,
    oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    oncirr_normalizeWithAndReturnClauses$$anonfun$1$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_normalizeWithAndReturnClauses$$anonfun$1$$anonfun$2_applyOrElse)],
    oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_1_apply)],
    oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$$anonfun$1$applyOrElse$lambda$_0_2_apply)]]);
    $rt_metadata([$java.oncie_PatternPart, 0, jl_Object, [onciu_ASTNode], 1, 3, 0, 0, ["$dup0", $rt_wrapFunction1($java.oncie_PatternPart_dup), "$foldedOver", $rt_wrapFunction0($java.oncie_PatternPart_foldedOver), "$dup", $rt_wrapFunction1($java.oncie_PatternPart_dup0)],
    oncie_NonPrefixedPatternPart, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_AnonymousPatternPart, 0, jl_Object, [oncie_NonPrefixedPatternPart], 3, 3, 0, 0, 0,
    oncie_ShortestPathsPatternPart, "ShortestPathsPatternPart", 28, $java.oncie_PatternPart, [oncie_AnonymousPatternPart, ji_Serializable], 0, 3, [0,0,0], 0, ["$allVariables", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_allVariables), "$element", $rt_wrapFunction0(oncie_ShortestPathsPatternPart_element), "$position2", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_position), "$isBounded", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ShortestPathsPatternPart_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ShortestPathsPatternPart_toString), "$equals", $rt_wrapFunction1($java.oncie_ShortestPathsPatternPart_equals)],
    $java.oncie_PatternElement, 0, jl_Object, [onciu_ASTNode], 1, 3, 0, 0, ["$foldedOver", $rt_wrapFunction0($java.oncie_PatternElement_foldedOver), "$dup", $rt_wrapFunction1($java.oncie_PatternElement_dup0)],
    $java.oncie_PathFactor, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_SimplePattern, 0, $java.oncie_PatternElement, [$java.oncie_PathFactor], 1, 3, 0, 0, 0,
    oncie_RelationshipChain, "RelationshipChain", 28, $java.oncie_SimplePattern, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_RelationshipChain_position), "$allVariables", $rt_wrapFunction0($java.oncie_RelationshipChain_allVariables), "$isBounded", $rt_wrapFunction0($java.oncie_RelationshipChain_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_RelationshipChain_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_RelationshipChain_productArity), "$productElement",
    $rt_wrapFunction1($java.oncie_RelationshipChain_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_RelationshipChain_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_RelationshipChain_hashCode), "$toString", $rt_wrapFunction0($java.oncie_RelationshipChain_toString), "$equals", $rt_wrapFunction1($java.oncie_RelationshipChain_equals)],
    $java.oncie_PatternAtom, 0, jl_Object, [onciu_ASTNode], 3, 3, 0, 0, 0,
    oncie_NodePattern, "NodePattern", 28, $java.oncie_SimplePattern, [$java.oncie_PatternAtom, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_NodePattern_position), "$allVariables", $rt_wrapFunction0($java.oncie_NodePattern_allVariables), "$isBounded", $rt_wrapFunction0($java.oncie_NodePattern_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_NodePattern_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_NodePattern_productArity), "$productElement", $rt_wrapFunction1($java.oncie_NodePattern_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_NodePattern_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_NodePattern_hashCode), "$toString", $rt_wrapFunction0($java.oncie_NodePattern_toString), "$equals", $rt_wrapFunction1($java.oncie_NodePattern_equals)],
    $java.oncie_NumberLiteral, 0, jl_Object, [oncie_Literal], 3, 3, 0, 0, 0,
    $java.oncie_IntegerLiteral, 0, jl_Object, [$java.oncie_NumberLiteral], 3, 3, 0, 0, 0,
    $java.oncie_DecimalIntegerLiteral, 0, oncie_Expression, [$java.oncie_IntegerLiteral], 1, 3, 0, 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_DecimalIntegerLiteral_asCanonicalStringVal), "$value26", $rt_wrapFunction0($java.oncie_DecimalIntegerLiteral_value)],
    $java.oncie_UnsignedIntegerLiteral, 0, jl_Object, [$java.oncie_IntegerLiteral], 3, 3, 0, 0, 0,
    oncie_UnsignedDecimalIntegerLiteral, "UnsignedDecimalIntegerLiteral", 28, $java.oncie_DecimalIntegerLiteral, [$java.oncie_UnsignedIntegerLiteral, ji_Serializable], 0, 3, [0,0,0], 0, ["$stringVal1", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_stringVal), "$position2", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_position), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_productArity), "$productElement", $rt_wrapFunction1($java.oncie_UnsignedDecimalIntegerLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_hashCode), "$toString", $rt_wrapFunction0($java.oncie_UnsignedDecimalIntegerLiteral_toString), "$equals", $rt_wrapFunction1($java.oncie_UnsignedDecimalIntegerLiteral_equals)],
    oncie_Range, "Range", 28, jl_Object, [onciu_ASTNode, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_Range_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Range_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Range_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Range_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Range_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Range_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Range_toString),
    "$equals", $rt_wrapFunction1($java.oncie_Range_equals), "$dup", $rt_wrapFunction1($java.oncie_Range_dup)],
    onciu_Foldable$TreeAny$$reverseTreeChildren$extension$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_Foldable$TreeAny$$reverseTreeChildren$extension$lambda$_2_0_apply)],
    sr_ObjectRef, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sci_Vector$appendedAll0$lambda$_77_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Vector$appendedAll0$lambda$_77_0_apply)],
    sci_Vector$appendedAll0$lambda$_77_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Vector$appendedAll0$lambda$_77_1_apply)],
    oncirr_normalizeWithAndReturnClauses$rewriteTopLevelSingleQuery$lambda$_36_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$rewriteTopLevelSingleQuery$lambda$_36_0_apply)],
    oncie_Namespace, "Namespace", 28, jl_Object, [onciu_ASTNode, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_Namespace_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Namespace_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Namespace_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Namespace_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Namespace_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Namespace_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_Namespace_toString), "$equals", $rt_wrapFunction1($java.oncie_Namespace_equals), "$dup", $rt_wrapFunction1($java.oncie_Namespace_dup)],
    $java.oncias_Scope$DeclarationsAndDependencies, "Scope$DeclarationsAndDependencies", 17, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncias_Scope$DeclarationsAndDependencies_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_Scope$DeclarationsAndDependencies_productArity), "$productElement", $rt_wrapFunction1($java.oncias_Scope$DeclarationsAndDependencies_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_Scope$DeclarationsAndDependencies_productIterator),
    "$toString", $rt_wrapFunction0($java.oncias_Scope$DeclarationsAndDependencies_toString)],
    oncie_RelationshipPattern, "RelationshipPattern", 28, jl_Object, [$java.oncie_PatternAtom, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0(oncie_RelationshipPattern_position), "$productPrefix", $rt_wrapFunction0($java.oncie_RelationshipPattern_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_RelationshipPattern_productArity), "$productElement", $rt_wrapFunction1($java.oncie_RelationshipPattern_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_RelationshipPattern_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_RelationshipPattern_hashCode), "$toString", $rt_wrapFunction0($java.oncie_RelationshipPattern_toString), "$equals", $rt_wrapFunction1($java.oncie_RelationshipPattern_equals), "$dup", $rt_wrapFunction1($java.oncie_RelationshipPattern_dup)],
    sci_SetOps$removedAll$lambda$_9_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sci_SetOps$removedAll$lambda$_9_0_apply)],
    oncifp_BaseState$semanticTable$lambda$_19_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncifp_BaseState$semanticTable$lambda$_19_0_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$21$lambda$_37_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    sci_HashMapBuilder$$anon$1, 0, sci_ChampBaseIterator, [], 4, 3, 0, 0, 0,
    $java.sc_SeqMap, 0, jl_Object, [sc_Map], 3, 3, 0, 0, 0,
    $java.scm_SeqMap, 0, jl_Object, [scm_Map, $java.sc_SeqMap], 3, 3, 0, 0, 0,
    scm_LinkedHashMap, 0, scm_AbstractMap, [$java.scm_SeqMap, sc_StrictOptimizedMapOps, scg_DefaultSerializable], 0, 3, 0, 0, 0,
    scm_LinkedHashMap$LinkedEntry, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sci_HashMapBuilder$addAll$lambda$_25_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sci_HashMapBuilder$addAll$lambda$_25_0_apply)],
    $java.sc_Iterable$$anon$1, 0, sc_AbstractIterable, [], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_Iterable$$anon$1_iterator), "$knownSize", $rt_wrapFunction0($java.sc_Iterable$$anon$1_knownSize)],
    onciu_Ref, "Ref", 20, jl_Object, [], 4, 3, 0, 0, ["$toString", $rt_wrapFunction0($java.onciu_Ref_toString), "$hashCode0", $rt_wrapFunction0($java.onciu_Ref_hashCode), "$equals", $rt_wrapFunction1($java.onciu_Ref_equals)],
    $java.oncias_SemanticState$ScopeLocation$$declarationsAndDependencies$extension$lambda$_17_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticState$ScopeLocation$$declarationsAndDependencies$extension$lambda$_17_0_apply)],
    $java.oncia_ASTAnnotationMap$PositionedNode, "ASTAnnotationMap$PositionedNode", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0($java.oncia_ASTAnnotationMap$PositionedNode_toString), "$equals", $rt_wrapFunction1($java.oncia_ASTAnnotationMap$PositionedNode_equals), "$hashCode0", $rt_wrapFunction0($java.oncia_ASTAnnotationMap$PositionedNode_hashCode), "$productArity", $rt_wrapFunction0($java.oncia_ASTAnnotationMap$PositionedNode_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ASTAnnotationMap$PositionedNode_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_ASTAnnotationMap$PositionedNode_productIterator)],
    oncia_With, "With", 13, jl_Object, [oncia_ProjectionClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$isReturn", $rt_wrapFunction0($java.oncia_With_isReturn), "$copyProjection", function(var_1, var_2, var_3, var_4, var_5, var_6) { return $java.oncia_With_copyProjection(this, var_1, var_2, var_3, var_4, var_5, var_6); }, "$copyProjection$default$1", $rt_wrapFunction0($java.oncia_With_copyProjection$default$1), "$copyProjection$default$3", $rt_wrapFunction0($java.oncia_With_copyProjection$default$3), "$copyProjection$default$4",
    $rt_wrapFunction0($java.oncia_With_copyProjection$default$4), "$copyProjection$default$5", $rt_wrapFunction0($java.oncia_With_copyProjection$default$5), "$copyProjection$default$6", $rt_wrapFunction0($java.oncia_With_copyProjection$default$6), "$semanticCheckContinuation", $rt_wrapFunction2($java.oncia_With_semanticCheckContinuation), "$semanticCheckContinuation$default$2", $rt_wrapFunction0($java.oncia_With_semanticCheckContinuation$default$2), "$warnOnAccessToRestrictedVariableInOrderByOrWhere", $rt_wrapFunction2($java.oncia_With_warnOnAccessToRestrictedVariableInOrderByOrWhere),
    "$verifyOrderByAggregationUse", $rt_wrapFunction1($java.oncia_With_verifyOrderByAggregationUse), "$returnVariables", $rt_wrapFunction0($java.oncia_With_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_With_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_With_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_With_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_With_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_With_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_With_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_With_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_With_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_With_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_With_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$distinct1", $rt_wrapFunction0($java.oncia_With_distinct), "$returnItems0", $rt_wrapFunction0($java.oncia_With_returnItems), "$orderBy2", $rt_wrapFunction0($java.oncia_With_orderBy), "$skip2", $rt_wrapFunction0($java.oncia_With_skip), "$limit3", $rt_wrapFunction0($java.oncia_With_limit), "$where0", $rt_wrapFunction0($java.oncia_With_where), "$position2", $rt_wrapFunction0($java.oncia_With_position), "$name3", $rt_wrapFunction0($java.oncia_With_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_With_clauseSpecificSemanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_With_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_With_productArity), "$productElement", $rt_wrapFunction1($java.oncia_With_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_With_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_With_hashCode), "$toString", $rt_wrapFunction0($java.oncia_With_toString), "$equals", $rt_wrapFunction1($java.oncia_With_equals), "$dup", $rt_wrapFunction1($java.oncia_With_dup)],
    oncia_Return, "Return", 13, jl_Object, [oncia_ProjectionClause, oncia_ClauseAllowedOnSystem, ji_Serializable], 0, 3, [0,0,0], 0, ["$copyProjection", function(var_1, var_2, var_3, var_4, var_5, var_6) { return $java.oncia_Return_copyProjection(this, var_1, var_2, var_3, var_4, var_5, var_6); }, "$copyProjection$default$1", $rt_wrapFunction0($java.oncia_Return_copyProjection$default$1), "$copyProjection$default$3", $rt_wrapFunction0($java.oncia_Return_copyProjection$default$3), "$copyProjection$default$4", $rt_wrapFunction0($java.oncia_Return_copyProjection$default$4),
    "$copyProjection$default$5", $rt_wrapFunction0($java.oncia_Return_copyProjection$default$5), "$copyProjection$default$6", $rt_wrapFunction0($java.oncia_Return_copyProjection$default$6), "$semanticCheckContinuation", $rt_wrapFunction2($java.oncia_Return_semanticCheckContinuation), "$semanticCheckContinuation$default$2", $rt_wrapFunction0($java.oncia_Return_semanticCheckContinuation$default$2), "$warnOnAccessToRestrictedVariableInOrderByOrWhere", $rt_wrapFunction2($java.oncia_Return_warnOnAccessToRestrictedVariableInOrderByOrWhere),
    "$verifyOrderByAggregationUse", $rt_wrapFunction1($java.oncia_Return_verifyOrderByAggregationUse), "$semanticCheck", $rt_wrapFunction0($java.oncia_Return_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Return_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_Return_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Return_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Return_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_Return_folder),
    "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Return_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Return_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Return_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Return_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$distinct1", $rt_wrapFunction0($java.oncia_Return_distinct), "$returnItems0", $rt_wrapFunction0(oncia_Return_returnItems), "$orderBy2", $rt_wrapFunction0($java.oncia_Return_orderBy), "$skip2", $rt_wrapFunction0($java.oncia_Return_skip), "$limit3", $rt_wrapFunction0($java.oncia_Return_limit), "$position2", $rt_wrapFunction0($java.oncia_Return_position), "$name3", $rt_wrapFunction0($java.oncia_Return_name), "$isReturn", $rt_wrapFunction0($java.oncia_Return_isReturn), "$where0", $rt_wrapFunction0($java.oncia_Return_where),
    "$returnVariables", $rt_wrapFunction0($java.oncia_Return_returnVariables), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Return_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Return_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Return_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Return_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Return_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Return_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_Return_toString), "$equals", $rt_wrapFunction1($java.oncia_Return_equals), "$dup", $rt_wrapFunction1($java.oncia_Return_dup)],
    $java.oncia_SingleQuery$semanticCheck$lambda$_63_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$semanticCheck$lambda$_63_0_apply)],
    $java.scc_AsJavaConverters, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sjj_CollectionConverters$, 0, jl_Object, [$java.scc_AsJavaConverters, scc_AsScalaConverters], 4, 3, 0, 0, 0,
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionMapNode$filterImpl$lambda$_31_0_apply)],
    $java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionMapNode$filterImpl$lambda$_31_1_apply)],
    onciaf_CreateIndexTypes, "CreateIndexTypes", 14, jl_Enum, [], 12, 3, 0, onciaf_CreateIndexTypes_$callClinit, 0,
    onciaf_ConstraintVersion, "ConstraintVersion", 14, jl_Enum, [], 12, 3, 0, onciaf_ConstraintVersion_$callClinit, 0,
    onciaf_ConstraintType, "ConstraintType", 14, jl_Enum, [], 12, 3, 0, onciaf_ConstraintType_$callClinit, 0,
    onciaf_ASTFactory$StringPos, "ASTFactory$StringPos", 14, jl_Object, [], 0, 3, 0, 0, 0,
    ju_Optional, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_GraphSelection, 0, jl_Object, [oncia_Clause], 3, 3, 0, 0, 0]);
    $rt_metadata([oncia_UseGraph, "UseGraph", 13, jl_Object, [$java.oncia_GraphSelection, oncia_ClauseAllowedOnSystem, ji_Serializable], 4, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_UseGraph_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_UseGraph_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_UseGraph_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_UseGraph_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_UseGraph_asCanonicalStringVal),
    "$foldedOver", $rt_wrapFunction0($java.oncia_UseGraph_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_UseGraph_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_UseGraph_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_UseGraph_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_UseGraph_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq",
    $rt_wrapFunction1($java.oncia_UseGraph_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$position2", $rt_wrapFunction0($java.oncia_UseGraph_position), "$name3", $rt_wrapFunction0($java.oncia_UseGraph_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_UseGraph_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_UseGraph_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_UseGraph_productArity), "$productElement",
    $rt_wrapFunction1($java.oncia_UseGraph_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UseGraph_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UseGraph_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UseGraph_toString), "$equals", $rt_wrapFunction1($java.oncia_UseGraph_equals), "$dup", $rt_wrapFunction1($java.oncia_UseGraph_dup)],
    onciaf_ShowCommandFilterTypes, "ShowCommandFilterTypes", 14, jl_Enum, [], 12, 3, 0, onciaf_ShowCommandFilterTypes_$callClinit, 0,
    $java.scm_ImmutableBuilder, 0, jl_Object, [scm_ReusableBuilder], 1, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1($java.scm_ImmutableBuilder_sizeHint), "$sizeHint0", $rt_wrapFunction2($java.scm_ImmutableBuilder_sizeHint0), "$addAll0", $rt_wrapFunction1($java.scm_ImmutableBuilder_addAll), "$result0", $rt_wrapFunction0($java.scm_ImmutableBuilder_result)],
    sci_ListSet$$anon$1, "ListSet$$anon$1", 43, $java.scm_ImmutableBuilder, [], 4, 3, 0, 0, ["$addOne", $rt_wrapFunction1($java.sci_ListSet$$anon$1_addOne)],
    sci_ListSet$EmptyListSet$, "ListSet$EmptyListSet$", 43, sci_ListSet, [], 0, 3, 0, 0, ["$knownSize", $rt_wrapFunction0($java.sci_ListSet$EmptyListSet$_knownSize)],
    oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_0_apply)],
    oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_1_apply)],
    oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_expandShowWhere$$org$neo4j$cypher$internal$rewriting$rewriters$expandShowWhere$$addDefaultColumns$lambda$_8_2_apply)],
    oncia_CommandClause, 0, jl_Object, [oncia_Clause], 3, 3, 0, 0, 0,
    $java.oncia_CommandClauseAllowedOnSystem, 0, jl_Object, [oncia_ClauseAllowedOnSystem], 3, 3, 0, 0, 0,
    oncia_TransactionsCommandClause, 0, jl_Object, [oncia_CommandClause, $java.oncia_CommandClauseAllowedOnSystem], 3, 3, 0, 0, 0,
    oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNeitherOrsNorInnerScopes$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNeitherOrsNorInnerScopes$lambda$_7_0_apply)],
    oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containIns$lambda$_11_0_apply)],
    oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots$lambda$_10_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoNots$lambda$_10_0_apply)],
    oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNots$lambda$_9_0_apply)],
    oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoAnds$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$org$neo4j$cypher$internal$rewriting$rewriters$mergeInPredicates$$containNoAnds$lambda$_8_0_apply)],
    oncias_SymbolUse, "SymbolUse", 17, jl_Object, [s_Product, ji_Serializable], 4, 3, [0,0,0], 0, ["$toString", $rt_wrapFunction0($java.oncias_SymbolUse_toString), "$productPrefix", $rt_wrapFunction0($java.oncias_SymbolUse_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SymbolUse_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SymbolUse_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SymbolUse_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SymbolUse_hashCode),
    "$equals", $rt_wrapFunction1($java.oncias_SymbolUse_equals)],
    oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems$lambda$_40_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasImplicitlyAliasedReturnItems$lambda$_40_0_apply)],
    onciu_Foldable$TreeAny$$anon$1, "Foldable$TreeAny$$anon$1", 20, jl_Object, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_iterator), "$isEmpty", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_isEmpty), "$toString", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_toString), "$foreach", $rt_wrapFunction1($java.onciu_Foldable$TreeAny$$anon$1_foreach), "$exists", $rt_wrapFunction1($java.onciu_Foldable$TreeAny$$anon$1_exists), "$find0", $rt_wrapFunction1($java.onciu_Foldable$TreeAny$$anon$1_find),
    "$foldLeft", $rt_wrapFunction2($java.onciu_Foldable$TreeAny$$anon$1_foldLeft), "$nonEmpty0", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_nonEmpty), "$size", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_size), "$copyToArray1", $rt_wrapFunction1($java.onciu_Foldable$TreeAny$$anon$1_copyToArray), "$copyToArray0", $rt_wrapFunction2($java.onciu_Foldable$TreeAny$$anon$1_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.onciu_Foldable$TreeAny$$anon$1_copyToArray1), "$toList", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_toList),
    "$toSeq", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_toSeq), "$toArray", $rt_wrapFunction1($java.onciu_Foldable$TreeAny$$anon$1_toArray), "$knownSize", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_knownSize), "$hasNext", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_hasNext), "$next", $rt_wrapFunction0($java.onciu_Foldable$TreeAny$$anon$1_next)],
    sci_HashSet$removedAll$lambda$_62_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashSet$removedAll$lambda$_62_0_apply)],
    oncie_SensitiveLiteral, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_UnsignedDecimalIntegerLiteral$$anon$2, "UnsignedDecimalIntegerLiteral$$anon$2", 28, oncie_UnsignedDecimalIntegerLiteral, [oncie_SensitiveLiteral], 4, 3, [oncie_UnsignedDecimalIntegerLiteral,0,0], 0, 0,
    scm_HashSet$$anon$3, "HashSet$$anon$3", 44, scm_HashSet$HashSetIterator, [], 4, 3, 0, 0, ["$hashCode0", $rt_wrapFunction0($java.scm_HashSet$$anon$3_hashCode), "$extract", $rt_wrapFunction1($java.scm_HashSet$$anon$3_extract)],
    $java.oncia_SingleQuery$semanticCheckAbstract$lambda$_62_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SingleQuery$semanticCheckAbstract$lambda$_62_0_apply)],
    oncipj_AliasName, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncirr_rewriteShowQuery$$rewriteToWithAndReturn$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_rewriteShowQuery$$rewriteToWithAndReturn$lambda$_12_0_apply)],
    $java.oncia_WithType, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_AddedInRewrite$, "AddedInRewrite$", 13, jl_Object, [$java.oncia_WithType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AddedInRewrite$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AddedInRewrite$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AddedInRewrite$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AddedInRewrite$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AddedInRewrite$_toString)],
    oncirr_rewriteShowQuery$$rewriteWithYieldAndReturn$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_rewriteShowQuery$$rewriteWithYieldAndReturn$lambda$_11_0_apply)],
    oncirr_rewriteShowQuery$$anonfun$lastPosition$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_rewriteShowQuery$$anonfun$lastPosition$1_applyOrElse)],
    oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_0_apply)],
    oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncirr_rewriteShowQuery$$getDefaultOrderFromYieldOrCommand$lambda$_8_1_apply)],
    oncia_Return$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncirr_rewriteShowQuery$$updateDefaultOrderOnReturn$lambda$_9_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncirr_rewriteShowQuery$$updateDefaultOrderOnReturn$lambda$_9_0_apply)],
    oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_0_apply)],
    oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$collectInPredicates$lambda$_14_1_apply)],
    oncirr_mergeInPredicates$$anonfun$inRewriter$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$inRewriter$1_applyOrElse)],
    $java.sc_WithFilter, 0, jl_Object, [ji_Serializable], 1, 3, 0, 0, 0,
    sc_IterableOps$WithFilter, 0, $java.sc_WithFilter, [], 0, 3, 0, 0, 0,
    sc_SeqFactory$UnapplySeqWrapper$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    sc_SeqFactory$UnapplySeqWrapper, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_CallClause, 0, jl_Object, [oncia_Clause], 1, 3, 0, 0, ["$semanticCheck", $rt_wrapFunction0($java.oncia_CallClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_CallClause_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_CallClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_CallClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_CallClause_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CallClause_folder), "$LabelExpressionsPartition",
    $rt_wrapFunction0($java.oncia_CallClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_CallClause_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_CallClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_CallClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$name3", $rt_wrapFunction0($java.oncia_CallClause_name), "$dup", $rt_wrapFunction1($java.oncia_CallClause_dup)],
    oncia_UnresolvedCall, "UnresolvedCall", 13, $java.oncia_CallClause, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_UnresolvedCall_position), "$returnVariables", $rt_wrapFunction0($java.oncia_UnresolvedCall_returnVariables), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_UnresolvedCall_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_UnresolvedCall_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_UnresolvedCall_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_UnresolvedCall_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UnresolvedCall_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UnresolvedCall_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UnresolvedCall_toString), "$equals", $rt_wrapFunction1($java.oncia_UnresolvedCall_equals)],
    oncias_SemanticCheck$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_0_apply)],
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_1_apply)],
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_2_apply)],
    $java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SingleQuery$checkStandaloneCall$lambda$_70_3_apply)],
    oncias_package$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_SingleQuery$checkOrder$lambda$_71_0, "SingleQuery$checkOrder$lambda$_71_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkOrder$lambda$_71_0_apply)]]);
    $rt_metadata([$java.sr_LazyRef, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_SingleQuery$checkNoCallInTransactionsAfterWriteClause$lambda$_72_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_SingleQuery$checkNoCallInTransactionsAfterWriteClause$lambda$_72_0_apply)],
    $java.oncia_SingleQuery$Acc$1, "SingleQuery$Acc$1", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_SingleQuery$Acc$1_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SingleQuery$Acc$1_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SingleQuery$Acc$1_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SingleQuery$Acc$1_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SingleQuery$Acc$1_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_SingleQuery$Acc$1_toString), "$equals", $rt_wrapFunction1($java.oncia_SingleQuery$Acc$1_equals)],
    $java.oncia_SingleQuery$checkInputDataStream$lambda$_75_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkInputDataStream$lambda$_75_0_apply)],
    $java.oncia_InputDataStream, 0, jl_Object, [oncia_Clause, ji_Serializable], 0, 3, 0, 0, 0,
    sc_Map$equals$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_Map$equals$lambda$_7_0_apply)],
    $java.scc_JavaCollectionWrappers$IteratorWrapper, 0, jl_Object, [ju_Iterator, ju_Enumeration, ji_Serializable], 0, 3, 0, 0, 0,
    $java.scc_JavaCollectionWrappers$JIteratorWrapper, "JavaCollectionWrappers$JIteratorWrapper", 45, sc_AbstractIterator, [ji_Serializable], 0, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JIteratorWrapper_hasNext), "$next", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JIteratorWrapper_next)],
    ju_Formatter, 0, jl_Object, [ji_Closeable, ji_Flushable], 4, 3, 0, 0, 0,
    oncia_DefaultOrAllShowColumns, "DefaultOrAllShowColumns", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_DefaultOrAllShowColumns_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DefaultOrAllShowColumns_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DefaultOrAllShowColumns_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DefaultOrAllShowColumns_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DefaultOrAllShowColumns_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_DefaultOrAllShowColumns_toString), "$equals", $rt_wrapFunction1(oncia_DefaultOrAllShowColumns_equals)],
    $java.sr_AbstractFunction2, 0, jl_Object, [s_Function2], 1, 3, 0, 0, 0,
    $java.oncia_SingleQuery$Acc$2$, 0, $java.sr_AbstractFunction2, [ji_Serializable], 0, 3, 0, 0, 0,
    ju_Locale, 0, jl_Object, [jl_Cloneable, ji_Serializable], 4, 3, 0, $java.ju_Locale_$callClinit, 0,
    $java.oncias_SemanticCheck$$_clinit_$lambda$_0_0, "SemanticCheck$$<clinit>$lambda$_0_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$_clinit_$lambda$_0_0_apply)],
    $java.otciu_CLDRHelper, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_Foldable$Folder$$anonfun$treeFold$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncias_package$$liftSemanticErrorDefs$lambda$_5_0, "package$$liftSemanticErrorDefs$lambda$_5_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_package$$liftSemanticErrorDefs$lambda$_5_0_apply)],
    sci_ChampBaseReverseIterator, 0, jl_Object, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sci_ChampBaseReverseIterator_hasNext)],
    sci_MapKeyValueTupleHashIterator, "MapKeyValueTupleHashIterator", 43, sci_ChampBaseReverseIterator, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_iterator), "$isEmpty", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_isEmpty), "$toString", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_toString), "$foreach", $rt_wrapFunction1($java.sci_MapKeyValueTupleHashIterator_foreach), "$exists", $rt_wrapFunction1($java.sci_MapKeyValueTupleHashIterator_exists),
    "$find0", $rt_wrapFunction1($java.sci_MapKeyValueTupleHashIterator_find), "$foldLeft", $rt_wrapFunction2($java.sci_MapKeyValueTupleHashIterator_foldLeft), "$nonEmpty0", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_nonEmpty), "$size", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_size), "$copyToArray1", $rt_wrapFunction1($java.sci_MapKeyValueTupleHashIterator_copyToArray), "$copyToArray0", $rt_wrapFunction2($java.sci_MapKeyValueTupleHashIterator_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.sci_MapKeyValueTupleHashIterator_copyToArray1),
    "$toSeq", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_toSeq), "$toArray", $rt_wrapFunction1($java.sci_MapKeyValueTupleHashIterator_toArray), "$knownSize", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_knownSize), "$hashCode0", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_hashCode), "$next", $rt_wrapFunction0($java.sci_MapKeyValueTupleHashIterator_next)],
    onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_0_apply)],
    onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_Foldable$$org$neo4j$cypher$internal$util$Foldable$$foldAcc$lambda$_3_1_apply)],
    scm_GrowableBuilder, "GrowableBuilder", 44, jl_Object, [scm_Builder], 0, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1($java.scm_GrowableBuilder_sizeHint), "$sizeHint0", $rt_wrapFunction2($java.scm_GrowableBuilder_sizeHint0), "$addAll0", $rt_wrapFunction1($java.scm_GrowableBuilder_addAll0), "$addOne", $rt_wrapFunction1($java.scm_GrowableBuilder_addOne0), "$result0", $rt_wrapFunction0($java.scm_GrowableBuilder_result0)],
    scm_HashSet$$anon$4, "HashSet$$anon$4", 44, scm_GrowableBuilder, [], 4, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1($java.scm_HashSet$$anon$4_sizeHint)],
    $java.oncias_SemanticState$ScopeLocation$$parent$extension$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticState$ScopeLocation$$parent$extension$lambda$_4_0_apply)],
    $java.oncias_SemanticState$ScopeLocation$$availableSymbolDefinitions$extension$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticState$ScopeLocation$$availableSymbolDefinitions$extension$lambda$_12_0_apply)],
    sci_VectorSliceBuilder, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sci_Map$Map1, "Map$Map1", 43, sci_AbstractMap, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$map1", $rt_wrapFunction1($java.sci_Map$Map1_map), "$flatMap", $rt_wrapFunction1($java.sci_Map$Map1_flatMap), "$collect0", $rt_wrapFunction1($java.sci_Map$Map1_collect), "$flatten", $rt_wrapFunction1($java.sci_Map$Map1_flatten), "$filter1", $rt_wrapFunction1($java.sci_Map$Map1_filter), "$filterNot1", $rt_wrapFunction1($java.sci_Map$Map1_filterNot), "$size", $rt_wrapFunction0($java.sci_Map$Map1_size),
    "$knownSize", $rt_wrapFunction0($java.sci_Map$Map1_knownSize), "$isEmpty", $rt_wrapFunction0($java.sci_Map$Map1_isEmpty), "$apply", $rt_wrapFunction1($java.sci_Map$Map1_apply), "$contains0", $rt_wrapFunction1($java.sci_Map$Map1_contains), "$get1", $rt_wrapFunction1($java.sci_Map$Map1_get), "$getOrElse0", $rt_wrapFunction2($java.sci_Map$Map1_getOrElse), "$iterator0", $rt_wrapFunction0($java.sci_Map$Map1_iterator), "$keysIterator", $rt_wrapFunction0($java.sci_Map$Map1_keysIterator), "$valuesIterator", $rt_wrapFunction0($java.sci_Map$Map1_valuesIterator),
    "$foreach", $rt_wrapFunction1($java.sci_Map$Map1_foreach), "$exists", $rt_wrapFunction1($java.sci_Map$Map1_exists), "$forall", $rt_wrapFunction1($java.sci_Map$Map1_forall), "$hashCode0", $rt_wrapFunction0($java.sci_Map$Map1_hashCode), "$filterImpl", $rt_wrapFunction2($java.sci_Map$Map1_filterImpl), "$removed", $rt_wrapFunction1($java.sci_Map$Map1_removed), "$updated1", $rt_wrapFunction2($java.sci_Map$Map1_updated)],
    onciaf_ParameterType, "ParameterType", 14, jl_Enum, [], 12, 3, 0, onciaf_ParameterType_$callClinit, 0,
    onciaf_SimpleEither, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncia_DatabaseName, 0, jl_Object, [onciu_ASTNode], 3, 3, 0, 0, 0,
    oncia_WaitUntilComplete, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_LogicalVariable, "LogicalVariable", 28, oncie_Expression, [], 1, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_LogicalVariable_asCanonicalStringVal)],
    oncie_Variable, "Variable", 28, oncie_LogicalVariable, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_Variable_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Variable_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Variable_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Variable_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Variable_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Variable_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_Variable_toString), "$equals", $rt_wrapFunction1($java.oncie_Variable_equals)],
    onciaf_ParserCypherTypeName, "ParserCypherTypeName", 14, jl_Object, [], 0, 3, 0, 0, 0,
    ju_AbstractSequentialList, 0, ju_AbstractList, [], 1, 3, 0, 0, ["$get", $rt_wrapFunction1($java.ju_AbstractSequentialList_get), "$iterator", $rt_wrapFunction0($java.ju_AbstractSequentialList_iterator)],
    $java.ju_Queue, 0, jl_Object, [ju_Collection], 3, 3, 0, 0, 0,
    $java.ju_Deque, 0, jl_Object, [$java.ju_Queue], 3, 3, 0, 0, 0,
    ju_LinkedList, 0, ju_AbstractSequentialList, [$java.ju_Deque], 0, 3, 0, 0, ["$size", $rt_wrapFunction0($java.ju_LinkedList_size)],
    onciafn_Neo4jASTConstructionException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    onciaf_ASTFactory$MergeActionType, "ASTFactory$MergeActionType", 14, jl_Enum, [], 12, 3, 0, onciaf_ASTFactory$MergeActionType_$callClinit, 0,
    sci_HashSet$diff$lambda$_60_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashSet$diff$lambda$_60_0_apply)],
    oncie_In, "In", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_In_asCanonicalStringVal), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_In_canonicalOperatorSymbol), "$lhs0", $rt_wrapFunction0($java.oncie_In_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_In_rhs), "$position2", $rt_wrapFunction0($java.oncie_In_position), "$productPrefix", $rt_wrapFunction0($java.oncie_In_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_In_productArity), "$productElement", $rt_wrapFunction1($java.oncie_In_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_In_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_In_hashCode), "$toString", $rt_wrapFunction0($java.oncie_In_toString), "$equals", $rt_wrapFunction1($java.oncie_In_equals)],
    oncie_ListLiteral, "ListLiteral", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_ListLiteral_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_ListLiteral_asCanonicalStringVal), "$productPrefix", $rt_wrapFunction0($java.oncie_ListLiteral_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ListLiteral_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ListLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ListLiteral_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_ListLiteral_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ListLiteral_toString), "$equals", $rt_wrapFunction1($java.oncie_ListLiteral_equals)],
    $java.oncie_BooleanLiteral, 0, jl_Object, [oncie_Literal], 3, 3, 0, 0, 0,
    oncie_False, "False", 28, oncie_Expression, [$java.oncie_BooleanLiteral, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_False_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_False_asCanonicalStringVal), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_False_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_False_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_False_productArity), "$productElement", $rt_wrapFunction1($java.oncie_False_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_False_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_False_hashCode), "$toString", $rt_wrapFunction0($java.oncie_False_toString), "$equals", $rt_wrapFunction1($java.oncie_False_equals)],
    suh_MurmurHash3$accum$1, 0, jl_Object, [s_Function2], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.suh_MurmurHash3$accum$1_apply)],
    $java.oncias_SemanticCheck$Leaf, "SemanticCheck$Leaf", 17, jl_Object, [oncias_SemanticCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$run", $rt_wrapFunction2($java.oncias_SemanticCheck$Leaf_run), "$apply61", $rt_wrapFunction1($java.oncias_SemanticCheck$Leaf_apply), "$chain", $rt_wrapFunction1($java.oncias_SemanticCheck$Leaf_chain), "$ifOkChain", $rt_wrapFunction1($java.oncias_SemanticCheck$Leaf_ifOkChain), "$map12", $rt_wrapFunction1($java.oncias_SemanticCheck$Leaf_map), "$flatMap3", $rt_wrapFunction1($java.oncias_SemanticCheck$Leaf_flatMap),
    "$productPrefix", $rt_wrapFunction0($java.oncias_SemanticCheck$Leaf_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SemanticCheck$Leaf_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheck$Leaf_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheck$Leaf_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheck$Leaf_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheck$Leaf_toString), "$equals", $rt_wrapFunction1($java.oncias_SemanticCheck$Leaf_equals)],
    $java.onciaf_EitherImpl, "EitherImpl", 14, jl_Object, [onciaf_SimpleEither], 0, 0, 0, 0, 0,
    onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName, "ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName", 14, onciaf_ParserCypherTypeName, [], 0, 3, 0, 0, 0,
    ju_Objects, 0, jl_Object, [], 4, 3, 0, 0, 0]);
    $rt_metadata([scc_AsScalaExtensions$ListHasAsScala, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncia_ProjectionClause$verifyOrderByAggregationUse$lambda$_37_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$verifyOrderByAggregationUse$lambda$_37_0_apply)],
    $java.oncia_ProcedureResult, "ProcedureResult", 13, jl_Object, [onciu_ASTNode, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_ProcedureResult_position), "$productPrefix", $rt_wrapFunction0($java.oncia_ProcedureResult_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ProcedureResult_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ProcedureResult_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ProcedureResult_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_ProcedureResult_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ProcedureResult_toString), "$equals", $rt_wrapFunction1($java.oncia_ProcedureResult_equals), "$dup", $rt_wrapFunction1($java.oncia_ProcedureResult_dup)],
    oncia_ReturnItems$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_With$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sc_StrictOptimizedMapOps$collect$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_StrictOptimizedMapOps$collect$lambda$_7_0_apply)],
    sc_MapOps$addString$lambda$_49_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_MapOps$addString$lambda$_49_0_apply)],
    sc_SeqView$Id, "SeqView$Id", 42, sc_AbstractSeqView, [], 0, 3, 0, 0, ["$apply1", $rt_wrapFunction1($java.sc_SeqView$Id_apply), "$length", $rt_wrapFunction0($java.sc_SeqView$Id_length), "$iterator0", $rt_wrapFunction0($java.sc_SeqView$Id_iterator), "$knownSize", $rt_wrapFunction0($java.sc_SeqView$Id_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_SeqView$Id_isEmpty)],
    sc_IndexedSeqView$Id, 0, sc_SeqView$Id, [sc_IndexedSeqView], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_IndexedSeqView$Id_iterator), "$reverseIterator", $rt_wrapFunction0($java.sc_IndexedSeqView$Id_reverseIterator), "$reverse0", $rt_wrapFunction0($java.sc_IndexedSeqView$Id_reverse), "$knownSize", $rt_wrapFunction0($java.sc_IndexedSeqView$Id_knownSize)],
    oncia_SubqueryCall, "SubqueryCall", 13, jl_Object, [oncia_HorizonClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_SubqueryCall_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_SubqueryCall_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_SubqueryCall_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_SubqueryCall_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_SubqueryCall_asCanonicalStringVal), "$foldedOver",
    $rt_wrapFunction0($java.oncia_SubqueryCall_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_SubqueryCall_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_SubqueryCall_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_SubqueryCall_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_SubqueryCall_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq",
    $rt_wrapFunction1($java.oncia_SubqueryCall_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$position2", $rt_wrapFunction0($java.oncia_SubqueryCall_position), "$name3", $rt_wrapFunction0($java.oncia_SubqueryCall_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_SubqueryCall_clauseSpecificSemanticCheck), "$semanticCheckContinuation", $rt_wrapFunction2($java.oncia_SubqueryCall_semanticCheckContinuation), "$productPrefix", $rt_wrapFunction0($java.oncia_SubqueryCall_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SubqueryCall_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall_toString), "$equals", $rt_wrapFunction1($java.oncia_SubqueryCall_equals), "$dup", $rt_wrapFunction1($java.oncia_SubqueryCall_dup)],
    oncia_SubqueryCall$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncias_SemanticError, "SemanticError", 17, jl_Object, [oncias_SemanticErrorDef, s_Product, ji_Serializable], 4, 3, 0, 0, ["$msg1", $rt_wrapFunction0($java.oncias_SemanticError_msg), "$productPrefix", $rt_wrapFunction0($java.oncias_SemanticError_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SemanticError_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticError_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SemanticError_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncias_SemanticError_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticError_toString), "$equals", $rt_wrapFunction1($java.oncias_SemanticError_equals), "$withMsg", $rt_wrapFunction1($java.oncias_SemanticError_withMsg)],
    $java.oncia_SingleQuery$$anonfun$$nestedInanonfun$checkNoCallInTransactionsAfterWriteClause$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$$nestedInanonfun$checkNoCallInTransactionsAfterWriteClause$1$1_applyOrElse)],
    juf_Function, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName$_init_$lambda$_0_0, 0, jl_Object, [juf_Function], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciaf_ParserCypherTypeName$ClosedDynamicUnionParserCypherTypeName$_init_$lambda$_0_0_apply)],
    $java.oncia_UnmappedUnion$$init$$lambda$_16_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnmappedUnion$$init$$lambda$_16_0_apply)],
    oncias_SemanticAnalysisTooling$, 0, jl_Object, [], 4, 3, 0, oncias_SemanticAnalysisTooling$_$callClinit, 0,
    oncia_Query$checkUse$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Query$checkUse$lambda$_11_0_apply)],
    oncia_Query$checkUse$lambda$_11_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Query$checkUse$lambda$_11_1_apply)],
    oncia_Query$checkUse$lambda$_11_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Query$checkUse$lambda$_11_2_apply)],
    oncias_SemanticAnalysisTooling$recordCurrentScope$lambda$_67_0, "SemanticAnalysisTooling$recordCurrentScope$lambda$_67_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$recordCurrentScope$lambda$_67_0_apply)],
    $java.sc_SeqView$Reverse, 0, sc_AbstractSeqView, [], 0, 3, 0, 0, ["$apply1", $rt_wrapFunction1($java.sc_SeqView$Reverse_apply), "$length", $rt_wrapFunction0($java.sc_SeqView$Reverse_length)],
    sc_IndexedSeqView$Reverse, 0, $java.sc_SeqView$Reverse, [sc_IndexedSeqView], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_IndexedSeqView$Reverse_iterator), "$knownSize", $rt_wrapFunction0($java.sc_IndexedSeqView$Reverse_knownSize)],
    onciu_StepSequencer$$anonfun$orderSteps$16$lambda$_34_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_StepSequencer$$anonfun$orderSteps$16$lambda$_34_0_apply)],
    onciu_StepSequencer$$anonfun$orderSteps$8$lambda$_26_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_StepSequencer$$anonfun$orderSteps$8$lambda$_26_0_apply)],
    $java.sc_Map$, 0, sc_MapFactory$Delegate, [], 4, 3, 0, $java.sc_Map$_$callClinit, 0,
    $java.jus_BaseStream, 0, jl_Object, [jl_AutoCloseable], 3, 3, 0, 0, 0,
    jus_Stream, 0, jl_Object, [$java.jus_BaseStream], 3, 3, 0, 0, 0,
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNeitherOrsNorInnerScopes$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNeitherOrsNorInnerScopes$1$1_applyOrElse)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containIns$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containIns$1$1_applyOrElse)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoNots$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoNots$1$1_applyOrElse)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNots$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNots$1$1_applyOrElse)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoAnds$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$containNoAnds$1$1_applyOrElse)],
    $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_0, "SemanticAnalysisTooling$$<clinit>$lambda$_0_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_1, "SemanticAnalysisTooling$$<clinit>$lambda$_0_1", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$_clinit_$lambda$_0_1_apply)],
    $java.sc_Map$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sc_Map$$_clinit_$lambda$_0_0_apply)],
    $java.oncia_ReturnItems$containsAggregate$lambda$_63_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$containsAggregate$lambda$_63_0_apply)],
    oncir_Deprecation, "Deprecation", 24, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncir_Deprecation_productPrefix), "$productArity", $rt_wrapFunction0($java.oncir_Deprecation_productArity), "$productElement", $rt_wrapFunction1($java.oncir_Deprecation_productElement), "$productIterator", $rt_wrapFunction0($java.oncir_Deprecation_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncir_Deprecation_hashCode), "$toString", $rt_wrapFunction0($java.oncir_Deprecation_toString),
    "$equals", $rt_wrapFunction1($java.oncir_Deprecation_equals)],
    $java.onciu_InternalNotification, 0, jl_Object, [], 3, 3, 0, 0, 0,
    scm_ArrayDeque$addAll$lambda$_98_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.scm_ArrayDeque$addAll$lambda$_98_0_apply)],
    scm_ArrayDeque$addAll$lambda$_98_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.scm_ArrayDeque$addAll$lambda$_98_1_apply)],
    $java.oncie_False$$anon$11, "False$$anon$11", 28, oncie_False, [oncie_SensitiveLiteral], 4, 3, [oncie_False,0,0], 0, 0,
    oncia_DefaultWith$, "DefaultWith$", 13, jl_Object, [$java.oncia_WithType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DefaultWith$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DefaultWith$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DefaultWith$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DefaultWith$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DefaultWith$_toString)],
    sc_View$Filter, "View$Filter", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$Filter_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$Filter_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_View$Filter_isEmpty)],
    oncie_Parameter, 0, jl_Object, [], 3, 3, 0, 0, 0,
    ju_HashMap, 0, ju_AbstractMap, [jl_Cloneable, ji_Serializable], 0, 3, 0, 0, ["$newElementArray", $rt_wrapFunction1($java.ju_HashMap_newElementArray)],
    ju_LinkedHashMap, "LinkedHashMap", 1, ju_HashMap, [ju_Map], 0, 3, 0, 0, ["$newElementArray", $rt_wrapFunction1($java.ju_LinkedHashMap_newElementArray)],
    $java.oncia_WriteAdministrationCommand, 0, jl_Object, [oncia_AdministrationCommand], 3, 3, 0, 0, 0,
    oncia_CreateRemoteDatabaseAlias, "CreateRemoteDatabaseAlias", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_CreateRemoteDatabaseAlias_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_CreateRemoteDatabaseAlias_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_CreateRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_CreateRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_position), "$name3", $rt_wrapFunction0(oncia_CreateRemoteDatabaseAlias_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRemoteDatabaseAlias_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRemoteDatabaseAlias_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateRemoteDatabaseAlias_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateRemoteDatabaseAlias_dup), "$withGraph", $rt_wrapFunction1($java.oncia_CreateRemoteDatabaseAlias_withGraph)],
    $java.onciafn_DecorateTuple, 0, jl_Object, [], 3, 3, 0, 0, 0]);
    $rt_metadata([onciafn_TupleConverter$, 0, jl_Object, [$java.onciafn_DecorateTuple], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_0_apply)],
    onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createRemoteDatabaseAlias$lambda$_226_1_apply)],
    oncia_CreateLocalDatabaseAlias, "CreateLocalDatabaseAlias", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_CreateLocalDatabaseAlias_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_CreateLocalDatabaseAlias_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_CreateLocalDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_CreateLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_position), "$name3", $rt_wrapFunction0(oncia_CreateLocalDatabaseAlias_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateLocalDatabaseAlias_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateLocalDatabaseAlias_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateLocalDatabaseAlias_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateLocalDatabaseAlias_dup), "$withGraph", $rt_wrapFunction1($java.oncia_CreateLocalDatabaseAlias_withGraph)],
    onciafn_Neo4jASTFactory$createLocalDatabaseAlias$lambda$_225_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createLocalDatabaseAlias$lambda$_225_0_apply)],
    oncia_NoWait$, "NoWait$", 13, jl_Object, [oncia_WaitUntilComplete, s_Product, ji_Serializable], 4, 3, 0, oncia_NoWait$_$callClinit, ["$org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq", $rt_wrapFunction1($java.oncia_NoWait$_org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq), "$productArity", $rt_wrapFunction0($java.oncia_NoWait$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NoWait$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NoWait$_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_NoWait$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_NoWait$_toString)],
    oncia_IndefiniteWait$, "IndefiniteWait$", 13, jl_Object, [oncia_WaitUntilComplete, s_Product, ji_Serializable], 4, 3, 0, oncia_IndefiniteWait$_$callClinit, ["$org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq", $rt_wrapFunction1($java.oncia_IndefiniteWait$_org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq), "$productArity", $rt_wrapFunction0($java.oncia_IndefiniteWait$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_IndefiniteWait$_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_IndefiniteWait$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_IndefiniteWait$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_IndefiniteWait$_toString)],
    oncia_TimeoutAfter, "TimeoutAfter", 13, jl_Object, [oncia_WaitUntilComplete, s_Product, ji_Serializable], 0, 3, 0, 0, ["$org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq", $rt_wrapFunction1($java.oncia_TimeoutAfter_org$neo4j$cypher$internal$ast$WaitUntilComplete$_setter_$DEFAULT_TIMEOUT_$eq), "$productPrefix", $rt_wrapFunction0($java.oncia_TimeoutAfter_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_TimeoutAfter_productArity), "$productElement", $rt_wrapFunction1($java.oncia_TimeoutAfter_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_TimeoutAfter_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_TimeoutAfter_hashCode), "$toString", $rt_wrapFunction0($java.oncia_TimeoutAfter_toString), "$equals", $rt_wrapFunction1($java.oncia_TimeoutAfter_equals)],
    $java.oncia_WaitableAdministrationCommand, 0, jl_Object, [$java.oncia_WriteAdministrationCommand], 3, 3, 0, 0, 0,
    oncia_CreateCompositeDatabase, "CreateCompositeDatabase", 13, jl_Object, [$java.oncia_WaitableAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_CreateCompositeDatabase_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_CreateCompositeDatabase_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_CreateCompositeDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_CreateCompositeDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_position), "$name3", $rt_wrapFunction0(oncia_CreateCompositeDatabase_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateCompositeDatabase_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateCompositeDatabase_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateCompositeDatabase_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateCompositeDatabase_dup), "$withGraph", $rt_wrapFunction1($java.oncia_CreateCompositeDatabase_withGraph)],
    $java.oncia_Options, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncia_ConstraintVersion, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_ConstraintVersion0$, "ConstraintVersion0$", 13, jl_Object, [$java.oncia_ConstraintVersion, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ConstraintVersion0$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ConstraintVersion0$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ConstraintVersion0$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ConstraintVersion0$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ConstraintVersion0$_toString)],
    oncia_SchemaCommand, 0, jl_Object, [oncia_StatementWithGraph, oncias_SemanticAnalysisTooling], 3, 3, 0, 0, 0,
    $java.oncia_CompositePropertyConstraintCommand, 0, jl_Object, [oncia_SchemaCommand], 3, 3, 0, 0, 0,
    $java.oncia_NodeCompositePropertyConstraintCommand, 0, jl_Object, [$java.oncia_CompositePropertyConstraintCommand], 3, 3, 0, 0, 0,
    $java.oncia_CreateConstraint, 0, jl_Object, [oncia_SchemaCommand], 3, 3, 0, 0, 0,
    oncia_CreateNodePropertyUniquenessConstraint, "CreateNodePropertyUniquenessConstraint", 13, jl_Object, [$java.oncia_NodeCompositePropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateNodePropertyUniquenessConstraint_checkOptionsMap), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_CreateNodePropertyUniquenessConstraint_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateNodePropertyUniquenessConstraint_declareVariable),
    "$error2", $rt_wrapFunction2($java.oncia_CreateNodePropertyUniquenessConstraint_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq),
    "$org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_errorMessageOnRequire), "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_errorMessageForAssert), "$errorMessageOnAssert",
    $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_errorMessageOnAssert), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$variable4", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_variable), "$properties1", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_properties), "$position2", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_dup), "$entityType0", $rt_wrapFunction0($java.oncia_CreateNodePropertyUniquenessConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateNodePropertyUniquenessConstraint_withGraph)],
    $java.oncil_LabelExpressionLeafName, 0, jl_Object, [oncie_SymbolicName], 3, 3, 0, 0, 0,
    $java.oncie_ElementTypeName, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_LabelName, "LabelName", 28, jl_Object, [$java.oncil_LabelExpressionLeafName, $java.oncie_ElementTypeName, ji_Serializable], 0, 3, [0,0,0], 0, ["$name3", $rt_wrapFunction0($java.oncie_LabelName_name), "$position2", $rt_wrapFunction0($java.oncie_LabelName_position), "$productPrefix", $rt_wrapFunction0($java.oncie_LabelName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_LabelName_productArity), "$productElement", $rt_wrapFunction1($java.oncie_LabelName_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncie_LabelName_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_LabelName_hashCode), "$toString", $rt_wrapFunction0($java.oncie_LabelName_toString), "$equals", $rt_wrapFunction1($java.oncie_LabelName_equals), "$dup", $rt_wrapFunction1($java.oncie_LabelName_dup)],
    oncia_CreateNodePropertyUniquenessConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_RelationshipCompositePropertyConstraintCommand, 0, jl_Object, [$java.oncia_CompositePropertyConstraintCommand], 3, 3, 0, 0, 0,
    oncia_CreateRelationshipPropertyUniquenessConstraint, "CreateRelationshipPropertyUniquenessConstraint", 13, jl_Object, [$java.oncia_RelationshipCompositePropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyUniquenessConstraint_checkOptionsMap), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyUniquenessConstraint_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyUniquenessConstraint_declareVariable),
    "$error2", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyUniquenessConstraint_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq),
    "$org$neo4j$cypher$internal$ast$RelationshipCompositePropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$RelationshipCompositePropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_errorMessageOnRequire), "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_errorMessageForAssert),
    "$errorMessageOnAssert", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_errorMessageOnAssert), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$variable4", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_variable), "$properties1", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_properties), "$position2", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_dup), "$entityType0", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyUniquenessConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyUniquenessConstraint_withGraph)],
    oncie_RelTypeName, "RelTypeName", 28, jl_Object, [$java.oncil_LabelExpressionLeafName, $java.oncie_ElementTypeName, ji_Serializable], 0, 3, [0,0,0], 0, ["$name3", $rt_wrapFunction0($java.oncie_RelTypeName_name), "$position2", $rt_wrapFunction0($java.oncie_RelTypeName_position), "$productPrefix", $rt_wrapFunction0($java.oncie_RelTypeName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_RelTypeName_productArity), "$productElement", $rt_wrapFunction1($java.oncie_RelTypeName_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncie_RelTypeName_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_RelTypeName_hashCode), "$toString", $rt_wrapFunction0($java.oncie_RelTypeName_toString), "$equals", $rt_wrapFunction1($java.oncie_RelTypeName_equals), "$dup", $rt_wrapFunction1($java.oncie_RelTypeName_dup)],
    oncia_CreateRelationshipPropertyUniquenessConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateNodeKeyConstraint, "CreateNodeKeyConstraint", 13, jl_Object, [$java.oncia_NodeCompositePropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateNodeKeyConstraint_checkOptionsMap), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_CreateNodeKeyConstraint_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateNodeKeyConstraint_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_CreateNodeKeyConstraint_error),
    "$foldedOver", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq), "$org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq",
    $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_errorMessageOnRequire), "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_errorMessageForAssert), "$errorMessageOnAssert", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_errorMessageOnAssert), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq",
    $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$variable4", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_variable),
    "$properties1", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_properties), "$position2", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_dup), "$entityType0", $rt_wrapFunction0($java.oncia_CreateNodeKeyConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateNodeKeyConstraint_withGraph)],
    oncia_CreateNodeKeyConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateRelationshipKeyConstraint, "CreateRelationshipKeyConstraint", 13, jl_Object, [$java.oncia_RelationshipCompositePropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateRelationshipKeyConstraint_checkOptionsMap), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_CreateRelationshipKeyConstraint_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateRelationshipKeyConstraint_declareVariable),
    "$error2", $rt_wrapFunction2($java.oncia_CreateRelationshipKeyConstraint_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq),
    "$org$neo4j$cypher$internal$ast$RelationshipCompositePropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$RelationshipCompositePropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_errorMessageOnRequire), "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_errorMessageForAssert), "$errorMessageOnAssert",
    $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_errorMessageOnAssert), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$variable4", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_variable), "$properties1", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_properties), "$position2", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_semanticCheck), "$productPrefix",
    $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_toString),
    "$equals", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_dup), "$entityType0", $rt_wrapFunction0($java.oncia_CreateRelationshipKeyConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateRelationshipKeyConstraint_withGraph)],
    oncia_CreateRelationshipKeyConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_PropertyConstraintCommand, 0, jl_Object, [oncia_SchemaCommand], 3, 3, 0, 0, 0,
    $java.oncia_NodePropertyConstraintCommand, 0, jl_Object, [$java.oncia_PropertyConstraintCommand], 3, 3, 0, 0, 0,
    oncia_CreateNodePropertyExistenceConstraint, "CreateNodePropertyExistenceConstraint", 13, jl_Object, [$java.oncia_NodePropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateNodePropertyExistenceConstraint_checkOptionsMap), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateNodePropertyExistenceConstraint_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_CreateNodePropertyExistenceConstraint_error), "$foldedOver",
    $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq), "$org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq",
    $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_errorMessageOnRequire), "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_errorMessageForAssert), "$errorMessageForAssertExists", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_errorMessageForAssertExists),
    "$errorMessageOnAssert", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_errorMessageOnAssert), "$errorMessageOnAssertExists", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_errorMessageOnAssertExists), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq",
    $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$variable4", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_variable), "$property", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_property), "$position2", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_position),
    "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_dup), "$entityType0", $rt_wrapFunction0($java.oncia_CreateNodePropertyExistenceConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateNodePropertyExistenceConstraint_withGraph)],
    oncia_CreateNodePropertyExistenceConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_RelationshipPropertyConstraintCommand, 0, jl_Object, [$java.oncia_PropertyConstraintCommand], 3, 3, 0, 0, 0,
    oncia_CreateRelationshipPropertyExistenceConstraint, "CreateRelationshipPropertyExistenceConstraint", 13, jl_Object, [$java.oncia_RelationshipPropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyExistenceConstraint_checkOptionsMap), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyExistenceConstraint_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyExistenceConstraint_error),
    "$foldedOver", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq),
    "$org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageOnRequire), "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageForAssert),
    "$errorMessageForAssertExists", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageForAssertExists), "$errorMessageOnAssert", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageOnAssert), "$errorMessageOnAssertExists", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_errorMessageOnAssertExists), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq",
    $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$variable4", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_variable), "$property",
    $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_property), "$position2", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_equals),
    "$dup", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_dup), "$entityType0", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyExistenceConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyExistenceConstraint_withGraph)],
    oncia_CreateRelationshipPropertyExistenceConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateNodePropertyTypeConstraint, "CreateNodePropertyTypeConstraint", 13, jl_Object, [$java.oncia_NodePropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateNodePropertyTypeConstraint_checkOptionsMap), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateNodePropertyTypeConstraint_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_CreateNodePropertyTypeConstraint_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq),
    "$org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_errorMessageOnRequire), "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_errorMessageForAssert), "$errorMessageOnAssert", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_errorMessageOnAssert),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq),
    "$variable4", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_variable), "$property", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_property), "$position2", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_dup),
    "$entityType0", $rt_wrapFunction0($java.oncia_CreateNodePropertyTypeConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateNodePropertyTypeConstraint_withGraph)],
    oncia_CreateNodePropertyTypeConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateRelationshipPropertyTypeConstraint, "CreateRelationshipPropertyTypeConstraint", 13, jl_Object, [$java.oncia_RelationshipPropertyConstraintCommand, $java.oncia_CreateConstraint, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkOptionsMap", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyTypeConstraint_checkOptionsMap), "$declareVariable", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyTypeConstraint_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_CreateRelationshipPropertyTypeConstraint_error),
    "$foldedOver", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_folder), "$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes), "$org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq",
    $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$CreateConstraint$_setter_$org$neo4j$cypher$internal$ast$CreateConstraint$$allowedPropertyTypes_$eq), "$org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq), "$errorMessageOnRequire", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_errorMessageOnRequire),
    "$errorMessageForAssert", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_errorMessageForAssert), "$errorMessageOnAssert", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_errorMessageOnAssert), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq",
    $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$variable4", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_variable), "$property", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_property), "$position2", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_position),
    "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_dup), "$entityType0", $rt_wrapFunction0($java.oncia_CreateRelationshipPropertyTypeConstraint_entityType), "$withGraph", $rt_wrapFunction1($java.oncia_CreateRelationshipPropertyTypeConstraint_withGraph)],
    oncia_CreateRelationshipPropertyTypeConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_ConstraintVersion1$, "ConstraintVersion1$", 13, jl_Object, [$java.oncia_ConstraintVersion, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ConstraintVersion1$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ConstraintVersion1$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ConstraintVersion1$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ConstraintVersion1$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ConstraintVersion1$_toString)],
    oncia_ConstraintVersion2$, "ConstraintVersion2$", 13, jl_Object, [$java.oncia_ConstraintVersion, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ConstraintVersion2$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ConstraintVersion2$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ConstraintVersion2$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ConstraintVersion2$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ConstraintVersion2$_toString)],
    onciafn_Neo4jASTFactory$createDatabase$lambda$_214_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createDatabase$lambda$_214_0_apply)],
    onciafn_Neo4jASTFactory$createDatabase$lambda$_214_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createDatabase$lambda$_214_1_apply)],
    oncia_CreateDatabase, "CreateDatabase", 13, jl_Object, [$java.oncia_WaitableAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_CreateDatabase_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_CreateDatabase_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateDatabase_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateDatabase_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_CreateDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_CreateDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_CreateDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0(oncia_CreateDatabase_position),
    "$name3", $rt_wrapFunction0(oncia_CreateDatabase_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateDatabase_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateDatabase_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateDatabase_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateDatabase_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateDatabase_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateDatabase_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_CreateDatabase_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateDatabase_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateDatabase_dup), "$withGraph", $rt_wrapFunction1($java.oncia_CreateDatabase_withGraph)],
    oncia_Topology, "Topology", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_Topology_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Topology_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Topology_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Topology_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Topology_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Topology_toString), "$equals",
    $rt_wrapFunction1($java.oncia_Topology_equals)],
    oncia_CreateRole, "CreateRole", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_CreateRole_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_CreateRole_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateRole_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateRole_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_CreateRole_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_CreateRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_CreateRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_CreateRole_position), "$name3", $rt_wrapFunction0(oncia_CreateRole_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRole_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_CreateRole_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRole_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRole_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRole_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRole_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRole_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateRole_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateRole_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_CreateRole_withGraph)],
    onciafn_Neo4jASTFactory$createRole$lambda$_157_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createRole$lambda$_157_0_apply)],
    $java.oncia_HomeDatabaseAction, 0, jl_Object, [], 3, 3, 0, 0, 0]);
    $rt_metadata([oncia_SetHomeDatabaseAction, "SetHomeDatabaseAction", 13, jl_Object, [$java.oncia_HomeDatabaseAction, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_SetHomeDatabaseAction_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SetHomeDatabaseAction_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetHomeDatabaseAction_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetHomeDatabaseAction_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_SetHomeDatabaseAction_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetHomeDatabaseAction_toString), "$equals", $rt_wrapFunction1($java.oncia_SetHomeDatabaseAction_equals)],
    oncia_UserOptions, "UserOptions", 13, jl_Object, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_UserOptions_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_UserOptions_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UserOptions_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UserOptions_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UserOptions_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UserOptions_toString),
    "$equals", $rt_wrapFunction1($java.oncia_UserOptions_equals)],
    $java.oncia_EitherAsString, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_CreateUser, "CreateUser", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, $java.oncia_EitherAsString, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_CreateUser_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_CreateUser_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateUser_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateUser_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_CreateUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_CreateUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_CreateUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_CreateUser_position),
    "$name3", $rt_wrapFunction0(oncia_CreateUser_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateUser_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateUser_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateUser_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateUser_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateUser_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateUser_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateUser_toString),
    "$equals", $rt_wrapFunction1($java.oncia_CreateUser_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateUser_dup), "$withGraph", $rt_wrapFunction1($java.oncia_CreateUser_withGraph)],
    ju_HashSet, 0, ju_AbstractSet, [jl_Cloneable, ji_Serializable], 0, 3, 0, 0, ["$iterator", $rt_wrapFunction0(ju_HashSet_iterator)],
    ju_LinkedHashSet, "LinkedHashSet", 1, ju_HashSet, [ju_Set, jl_Cloneable, ji_Serializable], 0, 3, 0, 0, 0,
    onciaf_AccessType, "AccessType", 14, jl_Enum, [], 12, 3, 0, onciaf_AccessType_$callClinit, 0,
    onciaf_ActionType, "ActionType", 14, jl_Enum, [], 12, 3, 0, onciaf_ActionType_$callClinit, 0,
    onciafn_Privilege, 0, jl_Object, [s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_DatabaseScope, 0, jl_Object, [onciu_Rewritable], 3, 3, 0, 0, 0,
    onciaf_HintIndexType, "HintIndexType", 14, jl_Enum, [], 12, 3, 0, onciaf_HintIndexType_$callClinit, 0,
    $java.oncie_MatchMode$MatchMode, 0, jl_Object, [onciu_ASTNode], 3, 3, 0, 0, 0,
    oncia_SubqueryCall$InTransactionsParameters, "SubqueryCall$InTransactionsParameters", 13, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, ji_Serializable], 4, 3, [oncia_SubqueryCall,0,"InTransactionsParameters"], 0, ["$position2", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsParameters_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsParameters_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsParameters_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsParameters_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsParameters_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsParameters_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsParameters_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsParameters_toString), "$equals", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsParameters_equals),
    "$dup", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsParameters_dup)],
    sci_HashCollisionSetNode$removed$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionSetNode$removed$lambda$_6_0_apply)],
    ju_Formatter$FormatWriter, 0, jl_Object, [], 0, 0, 0, 0, 0,
    $java.oncias_SemanticCheck$$error$lambda$_2_0, "SemanticCheck$$error$lambda$_2_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$error$lambda$_2_0_apply)],
    s_Tuple2$mcZZ$sp, "Tuple2$mcZZ$sp", 38, s_Tuple2, [], 4, 3, 0, 0, ["$_25", $rt_wrapFunction0($java.s_Tuple2$mcZZ$sp__2), "$_16", $rt_wrapFunction0($java.s_Tuple2$mcZZ$sp__1)],
    $java.oncia_IfExistsDo, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_IfExistsInvalidSyntax$, "IfExistsInvalidSyntax$", 13, jl_Object, [$java.oncia_IfExistsDo, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_IfExistsInvalidSyntax$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_IfExistsInvalidSyntax$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_IfExistsInvalidSyntax$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_IfExistsInvalidSyntax$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_IfExistsInvalidSyntax$_toString)],
    oncia_IfExistsReplace$, "IfExistsReplace$", 13, jl_Object, [$java.oncia_IfExistsDo, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_IfExistsReplace$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_IfExistsReplace$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_IfExistsReplace$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_IfExistsReplace$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_IfExistsReplace$_toString)],
    oncia_IfExistsDoNothing$, "IfExistsDoNothing$", 13, jl_Object, [$java.oncia_IfExistsDo, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_IfExistsDoNothing$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_IfExistsDoNothing$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_IfExistsDoNothing$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_IfExistsDoNothing$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_IfExistsDoNothing$_toString)],
    oncia_IfExistsThrowError$, "IfExistsThrowError$", 13, jl_Object, [$java.oncia_IfExistsDo, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_IfExistsThrowError$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_IfExistsThrowError$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_IfExistsThrowError$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_IfExistsThrowError$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_IfExistsThrowError$_toString)],
    onciafn_DecorateTuple$AsScala, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$asOptionsAst$lambda$_234_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$asOptionsAst$lambda$_234_0_apply)],
    oncia_OptionsMap, "OptionsMap", 13, jl_Object, [$java.oncia_Options, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_OptionsMap_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_OptionsMap_productArity), "$productElement", $rt_wrapFunction1($java.oncia_OptionsMap_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_OptionsMap_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_OptionsMap_hashCode), "$toString", $rt_wrapFunction0($java.oncia_OptionsMap_toString),
    "$equals", $rt_wrapFunction1($java.oncia_OptionsMap_equals)],
    oncia_OptionsParam, "OptionsParam", 13, jl_Object, [$java.oncia_Options, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_OptionsParam_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_OptionsParam_productArity), "$productElement", $rt_wrapFunction1($java.oncia_OptionsParam_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_OptionsParam_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_OptionsParam_hashCode), "$toString", $rt_wrapFunction0($java.oncia_OptionsParam_toString),
    "$equals", $rt_wrapFunction1($java.oncia_OptionsParam_equals)],
    oncia_NoOptions$, "NoOptions$", 13, jl_Object, [$java.oncia_Options, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_NoOptions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NoOptions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NoOptions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_NoOptions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_NoOptions$_toString)],
    oncius_CypherType, "CypherType", 23, jl_Object, [onciu_ASTNode], 3, 3, [0,0,0], 0, 0,
    oncius_NothingType, "NothingType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$simplify", $rt_wrapFunction0($java.oncius_NothingType_simplify), "$coercibleTo0", $rt_wrapFunction0($java.oncius_NothingType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_NothingType_isAssignableFrom), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_NothingType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$position2", $rt_wrapFunction0($java.oncius_NothingType_position), "$parentType", $rt_wrapFunction0($java.oncius_NothingType_parentType), "$toString", $rt_wrapFunction0($java.oncius_NothingType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_NothingType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_NothingType_sortOrder), "$isNullable", $rt_wrapFunction0($java.oncius_NothingType_isNullable), "$description", $rt_wrapFunction0($java.oncius_NothingType_description), "$updateIsNullable",
    $rt_wrapFunction1($java.oncius_NothingType_updateIsNullable), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_NothingType_isSubtypeOf), "$withPosition0", $rt_wrapFunction1($java.oncius_NothingType_withPosition), "$covariant20", $rt_wrapFunction0($java.oncius_NothingType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_NothingType_invariant), "$leastUpperBound", $rt_wrapFunction1($java.oncius_NothingType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_NothingType_greatestLowerBound),
    "$productPrefix", $rt_wrapFunction0($java.oncius_NothingType_productPrefix), "$productArity", $rt_wrapFunction0($java.oncius_NothingType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_NothingType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_NothingType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_NothingType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_NothingType_equals), "$dup", $rt_wrapFunction1($java.oncius_NothingType_dup)],
    oncius_NullType, "NullType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_NullType_description), "$simplify", $rt_wrapFunction0($java.oncius_NullType_simplify), "$coercibleTo0", $rt_wrapFunction0($java.oncius_NullType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_NullType_isAssignableFrom), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_NullType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$position2", $rt_wrapFunction0($java.oncius_NullType_position), "$parentType", $rt_wrapFunction0($java.oncius_NullType_parentType), "$toString", $rt_wrapFunction0($java.oncius_NullType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_NullType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_NullType_sortOrder), "$isNullable", $rt_wrapFunction0($java.oncius_NullType_isNullable), "$updateIsNullable", $rt_wrapFunction1($java.oncius_NullType_updateIsNullable), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_NullType_isSubtypeOf),
    "$withPosition0", $rt_wrapFunction1($java.oncius_NullType_withPosition), "$covariant20", $rt_wrapFunction0($java.oncius_NullType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_NullType_invariant), "$leastUpperBound", $rt_wrapFunction1($java.oncius_NullType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_NullType_greatestLowerBound), "$productPrefix", $rt_wrapFunction0($java.oncius_NullType_productPrefix), "$productArity", $rt_wrapFunction0($java.oncius_NullType_productArity),
    "$productElement", $rt_wrapFunction1($java.oncius_NullType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_NullType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_NullType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_NullType_equals), "$dup", $rt_wrapFunction1($java.oncius_NullType_dup)],
    oncius_BooleanType, "BooleanType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_BooleanType_description), "$simplify", $rt_wrapFunction0($java.oncius_BooleanType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_BooleanType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_BooleanType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_BooleanType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_BooleanType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_BooleanType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_BooleanType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_BooleanType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_BooleanType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_BooleanType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable",
    $rt_wrapFunction0($java.oncius_BooleanType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_BooleanType_position), "$parentType", $rt_wrapFunction0($java.oncius_BooleanType_parentType), "$toString", $rt_wrapFunction0($java.oncius_BooleanType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_BooleanType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_BooleanType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_BooleanType_updateIsNullable), "$withPosition0",
    $rt_wrapFunction1($java.oncius_BooleanType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_BooleanType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_BooleanType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_BooleanType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_BooleanType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_BooleanType_equals), "$dup", $rt_wrapFunction1($java.oncius_BooleanType_dup)],
    oncius_StringType, "StringType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_StringType_description), "$simplify", $rt_wrapFunction0($java.oncius_StringType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_StringType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_StringType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_StringType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_StringType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_StringType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_StringType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_StringType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_StringType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_StringType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable",
    $rt_wrapFunction0($java.oncius_StringType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_StringType_position), "$parentType", $rt_wrapFunction0($java.oncius_StringType_parentType), "$toString", $rt_wrapFunction0($java.oncius_StringType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_StringType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_StringType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_StringType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_StringType_withPosition),
    "$productArity", $rt_wrapFunction0($java.oncius_StringType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_StringType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_StringType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_StringType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_StringType_equals), "$dup", $rt_wrapFunction1($java.oncius_StringType_dup)],
    oncius_IntegerType, "IntegerType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_IntegerType_description), "$simplify", $rt_wrapFunction0($java.oncius_IntegerType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_IntegerType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_IntegerType_isNullableSubtypeOf), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_IntegerType_isAssignableFrom), "$leastUpperBound",
    $rt_wrapFunction1($java.oncius_IntegerType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_IntegerType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_IntegerType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_IntegerType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_IntegerType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_IntegerType_isNullable),
    "$position2", $rt_wrapFunction0($java.oncius_IntegerType_position), "$parentType", $rt_wrapFunction0($java.oncius_IntegerType_parentType), "$coercibleTo0", $rt_wrapFunction0($java.oncius_IntegerType_coercibleTo), "$toString", $rt_wrapFunction0($java.oncius_IntegerType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_IntegerType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_IntegerType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_IntegerType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_IntegerType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_IntegerType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_IntegerType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_IntegerType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_IntegerType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_IntegerType_equals), "$dup", $rt_wrapFunction1($java.oncius_IntegerType_dup)],
    oncius_FloatType, "FloatType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_FloatType_description), "$simplify", $rt_wrapFunction0($java.oncius_FloatType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_FloatType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_FloatType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_FloatType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_FloatType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_FloatType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_FloatType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_FloatType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_FloatType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_FloatType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_FloatType_isNullable),
    "$position2", $rt_wrapFunction0($java.oncius_FloatType_position), "$parentType", $rt_wrapFunction0($java.oncius_FloatType_parentType), "$toString", $rt_wrapFunction0($java.oncius_FloatType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_FloatType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_FloatType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_FloatType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_FloatType_withPosition), "$productArity",
    $rt_wrapFunction0($java.oncius_FloatType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_FloatType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_FloatType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_FloatType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_FloatType_equals), "$dup", $rt_wrapFunction1($java.oncius_FloatType_dup)],
    oncius_DateType, "DateType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_DateType_description), "$simplify", $rt_wrapFunction0($java.oncius_DateType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_DateType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_DateType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_DateType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_DateType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_DateType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_DateType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_DateType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_DateType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_DateType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_DateType_isNullable),
    "$position2", $rt_wrapFunction0($java.oncius_DateType_position), "$parentType", $rt_wrapFunction0($java.oncius_DateType_parentType), "$toString", $rt_wrapFunction0($java.oncius_DateType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_DateType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_DateType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_DateType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_DateType_withPosition), "$productArity",
    $rt_wrapFunction0($java.oncius_DateType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_DateType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_DateType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_DateType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_DateType_equals), "$dup", $rt_wrapFunction1($java.oncius_DateType_dup)],
    oncius_LocalTimeType, "LocalTimeType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_LocalTimeType_description), "$simplify", $rt_wrapFunction0($java.oncius_LocalTimeType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_LocalTimeType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_LocalTimeType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_LocalTimeType_coercibleTo), "$isAssignableFrom0",
    $rt_wrapFunction1($java.oncius_LocalTimeType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_LocalTimeType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_LocalTimeType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_LocalTimeType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_LocalTimeType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_LocalTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_LocalTimeType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_LocalTimeType_position), "$parentType", $rt_wrapFunction0($java.oncius_LocalTimeType_parentType), "$toString", $rt_wrapFunction0($java.oncius_LocalTimeType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_LocalTimeType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_LocalTimeType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_LocalTimeType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_LocalTimeType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_LocalTimeType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_LocalTimeType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_LocalTimeType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_LocalTimeType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_LocalTimeType_equals), "$dup", $rt_wrapFunction1($java.oncius_LocalTimeType_dup)],
    oncius_ZonedTimeType, "ZonedTimeType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_ZonedTimeType_description), "$simplify", $rt_wrapFunction0($java.oncius_ZonedTimeType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_ZonedTimeType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_ZonedTimeType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_ZonedTimeType_coercibleTo), "$isAssignableFrom0",
    $rt_wrapFunction1($java.oncius_ZonedTimeType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_ZonedTimeType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_ZonedTimeType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_ZonedTimeType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_ZonedTimeType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_ZonedTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_ZonedTimeType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_ZonedTimeType_position), "$parentType", $rt_wrapFunction0($java.oncius_ZonedTimeType_parentType), "$toString", $rt_wrapFunction0($java.oncius_ZonedTimeType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_ZonedTimeType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_ZonedTimeType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_ZonedTimeType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_ZonedTimeType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_ZonedTimeType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_ZonedTimeType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_ZonedTimeType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_ZonedTimeType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_ZonedTimeType_equals), "$dup", $rt_wrapFunction1($java.oncius_ZonedTimeType_dup)],
    oncius_LocalDateTimeType, "LocalDateTimeType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_LocalDateTimeType_description), "$simplify", $rt_wrapFunction0($java.oncius_LocalDateTimeType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_LocalDateTimeType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_LocalDateTimeType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_LocalDateTimeType_coercibleTo),
    "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_LocalDateTimeType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_LocalDateTimeType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_LocalDateTimeType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_LocalDateTimeType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_LocalDateTimeType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_LocalDateTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_LocalDateTimeType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_LocalDateTimeType_position), "$parentType", $rt_wrapFunction0($java.oncius_LocalDateTimeType_parentType), "$toString", $rt_wrapFunction0($java.oncius_LocalDateTimeType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_LocalDateTimeType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_LocalDateTimeType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_LocalDateTimeType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_LocalDateTimeType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_LocalDateTimeType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_LocalDateTimeType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_LocalDateTimeType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_LocalDateTimeType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_LocalDateTimeType_equals), "$dup", $rt_wrapFunction1($java.oncius_LocalDateTimeType_dup)],
    oncius_ZonedDateTimeType, "ZonedDateTimeType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_description), "$simplify", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_ZonedDateTimeType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_coercibleTo),
    "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_position), "$parentType", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_parentType), "$toString", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_ZonedDateTimeType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_equals), "$dup", $rt_wrapFunction1($java.oncius_ZonedDateTimeType_dup)],
    oncius_DurationType, "DurationType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_DurationType_description), "$simplify", $rt_wrapFunction0($java.oncius_DurationType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_DurationType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_DurationType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_DurationType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_DurationType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_DurationType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_DurationType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_DurationType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_DurationType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_DurationType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable",
    $rt_wrapFunction0($java.oncius_DurationType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_DurationType_position), "$parentType", $rt_wrapFunction0($java.oncius_DurationType_parentType), "$toString", $rt_wrapFunction0($java.oncius_DurationType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_DurationType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_DurationType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_DurationType_updateIsNullable), "$withPosition0",
    $rt_wrapFunction1($java.oncius_DurationType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_DurationType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_DurationType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_DurationType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_DurationType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_DurationType_equals), "$dup", $rt_wrapFunction1($java.oncius_DurationType_dup)],
    oncius_PointType, "PointType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_PointType_description), "$simplify", $rt_wrapFunction0($java.oncius_PointType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_PointType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_PointType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_PointType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_PointType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_PointType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_PointType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_PointType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_PointType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_PointType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_PointType_isNullable),
    "$position2", $rt_wrapFunction0($java.oncius_PointType_position), "$parentType", $rt_wrapFunction0($java.oncius_PointType_parentType), "$toString", $rt_wrapFunction0($java.oncius_PointType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_PointType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_PointType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_PointType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_PointType_withPosition), "$productArity",
    $rt_wrapFunction0($java.oncius_PointType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_PointType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_PointType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_PointType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_PointType_equals), "$dup", $rt_wrapFunction1($java.oncius_PointType_dup)],
    oncius_NodeType, "NodeType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_NodeType_description), "$simplify", $rt_wrapFunction0($java.oncius_NodeType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_NodeType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_NodeType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_NodeType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_NodeType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_NodeType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_NodeType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_NodeType_covariant), "$invariant", $rt_wrapFunction0(oncius_NodeType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_NodeType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_NodeType_isNullable),
    "$position2", $rt_wrapFunction0($java.oncius_NodeType_position), "$parentType", $rt_wrapFunction0($java.oncius_NodeType_parentType), "$toString", $rt_wrapFunction0($java.oncius_NodeType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_NodeType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_NodeType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_NodeType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_NodeType_withPosition), "$productArity",
    $rt_wrapFunction0($java.oncius_NodeType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_NodeType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_NodeType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_NodeType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_NodeType_equals), "$dup", $rt_wrapFunction1($java.oncius_NodeType_dup)],
    oncius_RelationshipType, "RelationshipType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_RelationshipType_description), "$simplify", $rt_wrapFunction0($java.oncius_RelationshipType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_RelationshipType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_RelationshipType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_RelationshipType_coercibleTo),
    "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_RelationshipType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_RelationshipType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_RelationshipType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_RelationshipType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_RelationshipType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_RelationshipType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_RelationshipType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_RelationshipType_position), "$parentType", $rt_wrapFunction0($java.oncius_RelationshipType_parentType), "$toString", $rt_wrapFunction0($java.oncius_RelationshipType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_RelationshipType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_RelationshipType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_RelationshipType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_RelationshipType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_RelationshipType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_RelationshipType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_RelationshipType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_RelationshipType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_RelationshipType_equals), "$dup", $rt_wrapFunction1($java.oncius_RelationshipType_dup)],
    oncius_MapType, "MapType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_MapType_description), "$simplify", $rt_wrapFunction0($java.oncius_MapType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_MapType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_MapType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_MapType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_MapType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_MapType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_MapType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_MapType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_MapType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_MapType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_MapType_isNullable),
    "$position2", $rt_wrapFunction0($java.oncius_MapType_position), "$parentType", $rt_wrapFunction0($java.oncius_MapType_parentType), "$toString", $rt_wrapFunction0($java.oncius_MapType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_MapType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_MapType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_MapType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_MapType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_MapType_productArity),
    "$productElement", $rt_wrapFunction1($java.oncius_MapType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_MapType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_MapType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_MapType_equals), "$dup", $rt_wrapFunction1($java.oncius_MapType_dup)],
    onciaf_ParserCypherTypeName$ListParserCypherTypeName, "ParserCypherTypeName$ListParserCypherTypeName", 14, onciaf_ParserCypherTypeName, [], 0, 3, 0, 0, 0,
    oncius_ListType, "ListType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_ListType_description), "$covariant20", $rt_wrapFunction0($java.oncius_ListType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_ListType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_ListType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable",
    $rt_wrapFunction0($java.oncius_ListType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_ListType_position), "$parentType", $rt_wrapFunction0($java.oncius_ListType_parentType), "$coercibleTo0", $rt_wrapFunction0($java.oncius_ListType_coercibleTo), "$toString", $rt_wrapFunction0($java.oncius_ListType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_ListType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_ListType_sortOrder), "$simplify", $rt_wrapFunction0($java.oncius_ListType_simplify),
    "$isSubtypeOf", $rt_wrapFunction1($java.oncius_ListType_isSubtypeOf), "$updateIsNullable", $rt_wrapFunction1($java.oncius_ListType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_ListType_withPosition), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_ListType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_ListType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_ListType_greatestLowerBound), "$productArity", $rt_wrapFunction0($java.oncius_ListType_productArity),
    "$productElement", $rt_wrapFunction1($java.oncius_ListType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_ListType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_ListType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_ListType_equals), "$dup", $rt_wrapFunction1($java.oncius_ListType_dup)],
    oncius_PathType, "PathType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_PathType_description), "$simplify", $rt_wrapFunction0($java.oncius_PathType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_PathType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_PathType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_PathType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_PathType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_PathType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_PathType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_PathType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_PathType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_PathType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_PathType_isNullable),
    "$position2", $rt_wrapFunction0($java.oncius_PathType_position), "$parentType", $rt_wrapFunction0($java.oncius_PathType_parentType), "$toString", $rt_wrapFunction0($java.oncius_PathType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_PathType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_PathType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_PathType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_PathType_withPosition), "$productArity",
    $rt_wrapFunction0($java.oncius_PathType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_PathType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_PathType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_PathType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_PathType_equals), "$dup", $rt_wrapFunction1($java.oncius_PathType_dup)],
    oncius_PropertyValueType, "PropertyValueType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_PropertyValueType_description), "$simplify", $rt_wrapFunction0($java.oncius_PropertyValueType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_PropertyValueType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_PropertyValueType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_PropertyValueType_coercibleTo),
    "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_PropertyValueType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_PropertyValueType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_PropertyValueType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_PropertyValueType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_PropertyValueType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_PropertyValueType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_PropertyValueType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_PropertyValueType_position), "$parentType", $rt_wrapFunction0($java.oncius_PropertyValueType_parentType), "$toString", $rt_wrapFunction0($java.oncius_PropertyValueType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_PropertyValueType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_PropertyValueType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_PropertyValueType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_PropertyValueType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_PropertyValueType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_PropertyValueType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_PropertyValueType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_PropertyValueType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_PropertyValueType_equals), "$dup", $rt_wrapFunction1($java.oncius_PropertyValueType_dup)],
    oncius_AnyType, "AnyType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_AnyType_description), "$simplify", $rt_wrapFunction0($java.oncius_AnyType_simplify), "$coercibleTo0", $rt_wrapFunction0($java.oncius_AnyType_coercibleTo), "$leastUpperBound", $rt_wrapFunction1($java.oncius_AnyType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_AnyType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_AnyType_covariant),
    "$invariant", $rt_wrapFunction0($java.oncius_AnyType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_AnyType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable", $rt_wrapFunction0($java.oncius_AnyType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_AnyType_position), "$parentType", $rt_wrapFunction0($java.oncius_AnyType_parentType), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_AnyType_isAssignableFrom),
    "$toString", $rt_wrapFunction0($java.oncius_AnyType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_AnyType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_AnyType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_AnyType_updateIsNullable), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_AnyType_isSubtypeOf), "$withPosition0", $rt_wrapFunction1($java.oncius_AnyType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_AnyType_productArity), "$productElement",
    $rt_wrapFunction1($java.oncius_AnyType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_AnyType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_AnyType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_AnyType_equals), "$dup", $rt_wrapFunction1($java.oncius_AnyType_dup)],
    onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0, 0, jl_Object, [juf_Function], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$convertCypherType$lambda$_150_0_apply)]]);
    $rt_metadata([oncius_ClosedDynamicUnionType, "ClosedDynamicUnionType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$isSubtypeOf", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_ClosedDynamicUnionType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_coercibleTo), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$position2", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_position), "$parentType", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_parentType), "$toString", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_sortOrder), "$isNullable", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_isNullable), "$description",
    $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_description), "$simplify", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_simplify), "$updateIsNullable", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_withPosition), "$equals", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_equals), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_isAssignableFrom), "$covariant20", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_covariant),
    "$invariant", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_invariant), "$leastUpperBound", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_greatestLowerBound), "$productPrefix", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_productPrefix), "$productArity", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_ClosedDynamicUnionType_hashCode), "$dup", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType_dup)],
    oncius_CypherType$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncie_TypeSignature, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_ExpressionTypeSignature, "ExpressionTypeSignature", 28, jl_Object, [$java.oncie_TypeSignature, s_Product, ji_Serializable], 0, 3, [0,0,0], 0, ["$argumentTypes1", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_argumentTypes), "$outputType1", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_outputType), "$removeFirstArgumentType", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_removeFirstArgumentType), "$productPrefix", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ExpressionTypeSignature_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ExpressionTypeSignature_toString), "$equals", $rt_wrapFunction1($java.oncie_ExpressionTypeSignature_equals)],
    oncie_TypeSignature$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncius_package$, 0, jl_Object, [], 4, 3, 0, oncius_package$_$callClinit, 0,
    $java.ju_FormatterClosedException, 0, jl_IllegalStateException, [], 0, 3, 0, 0, 0,
    oncias_SemanticCheck$chain$lambda$_17_0, "SemanticCheck$chain$lambda$_17_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$chain$lambda$_17_0_apply)],
    sc_IndexedSeqView$IndexedSeqViewReverseIterator, "IndexedSeqView$IndexedSeqViewReverseIterator", 42, sc_AbstractIterator, [ji_Serializable], 0, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_IndexedSeqView$IndexedSeqViewReverseIterator_hasNext), "$next", $rt_wrapFunction0(sc_IndexedSeqView$IndexedSeqViewReverseIterator_next)],
    $java.oncia_Union$semanticCheck$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$semanticCheck$lambda$_9_0_apply)],
    $java.oncia_Union$semanticCheck$lambda$_9_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$semanticCheck$lambda$_9_1_apply)],
    scc_AsScalaExtensions$MapHasAsScala, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_0_apply)],
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_1_apply)],
    $java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$_init_$lambda$_67_2_apply)],
    sc_Iterator$SliceIterator, "Iterator$SliceIterator", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$knownSize", $rt_wrapFunction0($java.sc_Iterator$SliceIterator_knownSize), "$hasNext", $rt_wrapFunction0($java.sc_Iterator$SliceIterator_hasNext), "$next", $rt_wrapFunction0($java.sc_Iterator$SliceIterator_next)],
    sc_IterableOps$sliding$lambda$_64_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_IterableOps$sliding$lambda$_64_0_apply)],
    oncias_SemanticAnalysisTooling$whenState$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$whenState$lambda$_31_0_apply)],
    $java.oncia_Union$semanticCheckAbstract$lambda$_7_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Union$semanticCheckAbstract$lambda$_7_0_apply)],
    $java.oncia_Union$semanticCheckAbstract$lambda$_7_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Union$semanticCheckAbstract$lambda$_7_1_apply)],
    $java.oncius_CypherType$$anonfun$1, 0, jl_Object, [sm_Ordering], 4, 3, 0, 0, ["$compare", $rt_wrapFunction2($java.oncius_CypherType$$anonfun$1_compare)],
    $java.oncius_NumberType, "NumberType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_NumberType_description), "$simplify", $rt_wrapFunction0($java.oncius_NumberType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_NumberType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_NumberType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_NumberType_coercibleTo), "$isAssignableFrom0", $rt_wrapFunction1($java.oncius_NumberType_isAssignableFrom),
    "$leastUpperBound", $rt_wrapFunction1($java.oncius_NumberType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_NumberType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_NumberType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_NumberType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_NumberType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq), "$isNullable",
    $rt_wrapFunction0($java.oncius_NumberType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_NumberType_position), "$toString", $rt_wrapFunction0($java.oncius_NumberType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_NumberType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_NumberType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_NumberType_updateIsNullable), "$withPosition0", $rt_wrapFunction1($java.oncius_NumberType_withPosition), "$productArity",
    $rt_wrapFunction0($java.oncius_NumberType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_NumberType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_NumberType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_NumberType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_NumberType_equals), "$dup", $rt_wrapFunction1($java.oncius_NumberType_dup), "$parentType", $rt_wrapFunction0($java.oncius_NumberType_parentType)],
    $java.oncius_GeometryType, "GeometryType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_GeometryType_description), "$simplify", $rt_wrapFunction0($java.oncius_GeometryType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_GeometryType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_GeometryType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_GeometryType_coercibleTo), "$isAssignableFrom0",
    $rt_wrapFunction1($java.oncius_GeometryType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_GeometryType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_GeometryType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_GeometryType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_GeometryType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_GeometryType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_GeometryType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_GeometryType_position), "$parentType", $rt_wrapFunction0($java.oncius_GeometryType_parentType), "$toString", $rt_wrapFunction0($java.oncius_GeometryType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_GeometryType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_GeometryType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_GeometryType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_GeometryType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_GeometryType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_GeometryType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_GeometryType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_GeometryType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_GeometryType_equals), "$dup", $rt_wrapFunction1($java.oncius_GeometryType_dup)],
    $java.oncius_GraphRefType, "GraphRefType", 23, jl_Object, [oncius_CypherType, ji_Serializable], 0, 3, [0,0,0], 0, ["$description", $rt_wrapFunction0($java.oncius_GraphRefType_description), "$simplify", $rt_wrapFunction0($java.oncius_GraphRefType_simplify), "$isSubtypeOf", $rt_wrapFunction1($java.oncius_GraphRefType_isSubtypeOf), "$isNullableSubtypeOf", $rt_wrapFunction2($java.oncius_GraphRefType_isNullableSubtypeOf), "$coercibleTo0", $rt_wrapFunction0($java.oncius_GraphRefType_coercibleTo), "$isAssignableFrom0",
    $rt_wrapFunction1($java.oncius_GraphRefType_isAssignableFrom), "$leastUpperBound", $rt_wrapFunction1($java.oncius_GraphRefType_leastUpperBound), "$greatestLowerBound", $rt_wrapFunction1($java.oncius_GraphRefType_greatestLowerBound), "$covariant20", $rt_wrapFunction0($java.oncius_GraphRefType_covariant), "$invariant", $rt_wrapFunction0($java.oncius_GraphRefType_invariant), "$org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq", $rt_wrapFunction1($java.oncius_GraphRefType_org$neo4j$cypher$internal$util$symbols$CypherType$_setter_$isAbstract_$eq),
    "$isNullable", $rt_wrapFunction0($java.oncius_GraphRefType_isNullable), "$position2", $rt_wrapFunction0($java.oncius_GraphRefType_position), "$parentType", $rt_wrapFunction0($java.oncius_GraphRefType_parentType), "$toString", $rt_wrapFunction0($java.oncius_GraphRefType_toString), "$toCypherTypeString", $rt_wrapFunction0($java.oncius_GraphRefType_toCypherTypeString), "$sortOrder", $rt_wrapFunction0($java.oncius_GraphRefType_sortOrder), "$updateIsNullable", $rt_wrapFunction1($java.oncius_GraphRefType_updateIsNullable),
    "$withPosition0", $rt_wrapFunction1($java.oncius_GraphRefType_withPosition), "$productArity", $rt_wrapFunction0($java.oncius_GraphRefType_productArity), "$productElement", $rt_wrapFunction1($java.oncius_GraphRefType_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_GraphRefType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_GraphRefType_hashCode), "$equals", $rt_wrapFunction1($java.oncius_GraphRefType_equals), "$dup", $rt_wrapFunction1($java.oncius_GraphRefType_dup)],
    oncia_ProjectingUnionAll, 0, jl_Object, [oncia_ProjectingUnion, ji_Serializable], 4, 3, 0, 0, 0,
    oncia_ProjectingUnionDistinct, 0, jl_Object, [oncia_ProjectingUnion, ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_Union$defineUnionVariables$lambda$_20_0, "Union$defineUnionVariables$lambda$_20_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$defineUnionVariables$lambda$_20_0_apply)],
    $java.oncia_Union$checkInputDataStream$lambda$_24_0, "Union$checkInputDataStream$lambda$_24_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$checkInputDataStream$lambda$_24_0_apply)],
    $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_0_apply)],
    oncias_IterableOnceSemanticChecking$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$checkNoCallInTransactionInsideUnion$lambda$_26_1_apply)],
    scm_IndexedSeq$, 0, sc_SeqFactory$Delegate, [], 4, 3, 0, scm_IndexedSeq$_$callClinit, 0,
    jusi_SimpleStreamImpl, 0, jl_Object, [jus_Stream], 1, 3, 0, 0, 0,
    jusi_StreamOverSpliterator, 0, jusi_SimpleStreamImpl, [], 0, 3, 0, 0, ["$next9", $rt_wrapFunction1($java.jusi_StreamOverSpliterator_next), "$estimateSize", $rt_wrapFunction0($java.jusi_StreamOverSpliterator_estimateSize)],
    $java.ju_Spliterator, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncius_ClosedDynamicUnionType$simplify$lambda$_29_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$simplify$lambda$_29_0_apply)],
    $java.oncias_IterableOnceSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_IterableOnceSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0_apply)],
    oncia_OrderBy, "OrderBy", 13, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_OrderBy_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_OrderBy_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_OrderBy_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_OrderBy_productArity), "$productElement", $rt_wrapFunction1($java.oncia_OrderBy_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_OrderBy_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_OrderBy_hashCode), "$toString", $rt_wrapFunction0($java.oncia_OrderBy_toString), "$equals", $rt_wrapFunction1($java.oncia_OrderBy_equals), "$dup", $rt_wrapFunction1($java.oncia_OrderBy_dup)],
    $java.sci_Map$Map2, "Map$Map2", 43, sci_AbstractMap, [sc_StrictOptimizedIterableOps, ji_Serializable], 4, 3, 0, 0, ["$map1", $rt_wrapFunction1($java.sci_Map$Map2_map), "$flatMap", $rt_wrapFunction1($java.sci_Map$Map2_flatMap), "$collect0", $rt_wrapFunction1($java.sci_Map$Map2_collect), "$flatten", $rt_wrapFunction1($java.sci_Map$Map2_flatten), "$filter1", $rt_wrapFunction1($java.sci_Map$Map2_filter), "$filterNot1", $rt_wrapFunction1($java.sci_Map$Map2_filterNot), "$size", $rt_wrapFunction0($java.sci_Map$Map2_size),
    "$knownSize", $rt_wrapFunction0($java.sci_Map$Map2_knownSize), "$isEmpty", $rt_wrapFunction0($java.sci_Map$Map2_isEmpty), "$apply", $rt_wrapFunction1($java.sci_Map$Map2_apply), "$contains0", $rt_wrapFunction1($java.sci_Map$Map2_contains), "$get1", $rt_wrapFunction1($java.sci_Map$Map2_get), "$getOrElse0", $rt_wrapFunction2($java.sci_Map$Map2_getOrElse), "$iterator0", $rt_wrapFunction0($java.sci_Map$Map2_iterator), "$keysIterator", $rt_wrapFunction0($java.sci_Map$Map2_keysIterator), "$valuesIterator", $rt_wrapFunction0($java.sci_Map$Map2_valuesIterator),
    "$foreach", $rt_wrapFunction1($java.sci_Map$Map2_foreach), "$exists", $rt_wrapFunction1($java.sci_Map$Map2_exists), "$forall", $rt_wrapFunction1($java.sci_Map$Map2_forall), "$hashCode0", $rt_wrapFunction0($java.sci_Map$Map2_hashCode), "$filterImpl", $rt_wrapFunction2($java.sci_Map$Map2_filterImpl), "$removed", $rt_wrapFunction1($java.sci_Map$Map2_removed), "$updated1", $rt_wrapFunction2($java.sci_Map$Map2_updated)],
    $java.ju_LinkedList$SequentialListIterator, 0, jl_Object, [ju_ListIterator], 0, 0, 0, 0, ["$hasNext", $rt_wrapFunction0($java.ju_LinkedList$SequentialListIterator_hasNext), "$next", $rt_wrapFunction0($java.ju_LinkedList$SequentialListIterator_next)],
    $java.ju_LinkedList$Entry, 0, jl_Object, [], 0, 0, 0, 0, 0,
    oncie_ExplicitParameter, "ExplicitParameter", 28, oncie_Expression, [oncie_Parameter, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_ExplicitParameter_asCanonicalStringVal), "$position2", $rt_wrapFunction0($java.oncie_ExplicitParameter_position), "$hashCode0", $rt_wrapFunction0($java.oncie_ExplicitParameter_hashCode), "$equals", $rt_wrapFunction1($java.oncie_ExplicitParameter_equals), "$productPrefix", $rt_wrapFunction0($java.oncie_ExplicitParameter_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_ExplicitParameter_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ExplicitParameter_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ExplicitParameter_productIterator), "$toString", $rt_wrapFunction0($java.oncie_ExplicitParameter_toString)],
    $java.oncie_SensitiveParameter, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$$anon$3, "Neo4jASTFactory$$anon$3", 15, oncie_ExplicitParameter, [$java.oncie_SensitiveParameter], 4, 3, [onciafn_Neo4jASTFactory,0,0], 0, 0,
    oncie_SensitiveStringLiteral, "SensitiveStringLiteral", 28, oncie_Expression, [oncie_SensitiveLiteral, ji_Serializable], 4, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_SensitiveStringLiteral_position), "$equals", $rt_wrapFunction1($java.oncie_SensitiveStringLiteral_equals), "$hashCode0", $rt_wrapFunction0($java.oncie_SensitiveStringLiteral_hashCode), "$productPrefix", $rt_wrapFunction0($java.oncie_SensitiveStringLiteral_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_SensitiveStringLiteral_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_SensitiveStringLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SensitiveStringLiteral_productIterator), "$toString", $rt_wrapFunction0($java.oncie_SensitiveStringLiteral_toString)],
    jnc_StandardCharsets, 0, jl_Object, [], 4, 3, 0, jnc_StandardCharsets_$callClinit, 0,
    $java.ju_HashMap$HashEntry, 0, ju_MapEntry, [], 0, 0, 0, 0, 0,
    $java.ju_LinkedHashMap$LinkedHashMapEntry, 0, $java.ju_HashMap$HashEntry, [], 4, 0, 0, 0, 0,
    $java.oncia_CreateIndex, 0, jl_Object, [oncia_SchemaCommand], 1, 3, 0, 0, ["$error2", $rt_wrapFunction2($java.oncia_CreateIndex_error), "$foldedOver", $rt_wrapFunction0($java.oncia_CreateIndex_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateIndex_folder), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq",
    $rt_wrapFunction1($java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$dup", $rt_wrapFunction1($java.oncia_CreateIndex_dup0)],
    oncia_CreateRangeNodeIndex, "CreateRangeNodeIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreateRangeNodeIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRangeNodeIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateRangeNodeIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRangeNodeIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRangeNodeIndex_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreateRangeNodeIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRangeNodeIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRangeNodeIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateRangeNodeIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateRangeNodeIndex_withGraph)]]);
    $rt_metadata([oncia_CreateRangeNodeIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateRangeRelationshipIndex, "CreateRangeRelationshipIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreateRangeRelationshipIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateRangeRelationshipIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateRangeRelationshipIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateRangeRelationshipIndex_productArity), "$productElement",
    $rt_wrapFunction1($java.oncia_CreateRangeRelationshipIndex_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRangeRelationshipIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRangeRelationshipIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRangeRelationshipIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateRangeRelationshipIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateRangeRelationshipIndex_withGraph)],
    oncia_CreateRangeRelationshipIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateBtreeNodeIndex, "CreateBtreeNodeIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreateBtreeNodeIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateBtreeNodeIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateBtreeNodeIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateBtreeNodeIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateBtreeNodeIndex_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreateBtreeNodeIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateBtreeNodeIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateBtreeNodeIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateBtreeNodeIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateBtreeNodeIndex_withGraph)],
    oncia_CreateBtreeNodeIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateBtreeRelationshipIndex, "CreateBtreeRelationshipIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreateBtreeRelationshipIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateBtreeRelationshipIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateBtreeRelationshipIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateBtreeRelationshipIndex_productArity), "$productElement",
    $rt_wrapFunction1($java.oncia_CreateBtreeRelationshipIndex_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateBtreeRelationshipIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateBtreeRelationshipIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateBtreeRelationshipIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateBtreeRelationshipIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateBtreeRelationshipIndex_withGraph)],
    oncia_CreateBtreeRelationshipIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateTextNodeIndex, "CreateTextNodeIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0(oncia_CreateTextNodeIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateTextNodeIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateTextNodeIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateTextNodeIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateTextNodeIndex_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreateTextNodeIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateTextNodeIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateTextNodeIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateTextNodeIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateTextNodeIndex_withGraph)],
    oncia_CreateTextNodeIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateTextRelationshipIndex, "CreateTextRelationshipIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0(oncia_CreateTextRelationshipIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateTextRelationshipIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateTextRelationshipIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateTextRelationshipIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateTextRelationshipIndex_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreateTextRelationshipIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateTextRelationshipIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateTextRelationshipIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateTextRelationshipIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateTextRelationshipIndex_withGraph)],
    oncia_CreateTextRelationshipIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreatePointNodeIndex, "CreatePointNodeIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreatePointNodeIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreatePointNodeIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreatePointNodeIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreatePointNodeIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreatePointNodeIndex_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreatePointNodeIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreatePointNodeIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreatePointNodeIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreatePointNodeIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreatePointNodeIndex_withGraph)],
    oncia_CreatePointNodeIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreatePointRelationshipIndex, "CreatePointRelationshipIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreatePointRelationshipIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreatePointRelationshipIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreatePointRelationshipIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreatePointRelationshipIndex_productArity), "$productElement",
    $rt_wrapFunction1($java.oncia_CreatePointRelationshipIndex_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreatePointRelationshipIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreatePointRelationshipIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreatePointRelationshipIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreatePointRelationshipIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreatePointRelationshipIndex_withGraph)],
    oncia_CreatePointRelationshipIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_0_apply)],
    oncia_CreateFulltextRelationshipIndex, "CreateFulltextRelationshipIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreateFulltextRelationshipIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateFulltextRelationshipIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateFulltextRelationshipIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateFulltextRelationshipIndex_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_CreateFulltextRelationshipIndex_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateFulltextRelationshipIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateFulltextRelationshipIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateFulltextRelationshipIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateFulltextRelationshipIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateFulltextRelationshipIndex_withGraph)],
    oncia_CreateFulltextRelationshipIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createFulltextIndex$lambda$_154_1_apply)],
    oncia_CreateFulltextNodeIndex, "CreateFulltextNodeIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreateFulltextNodeIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateFulltextNodeIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateFulltextNodeIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateFulltextNodeIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateFulltextNodeIndex_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreateFulltextNodeIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateFulltextNodeIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateFulltextNodeIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateFulltextNodeIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateFulltextNodeIndex_withGraph)],
    oncia_CreateFulltextNodeIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncie_FunctionInvocation$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateLookupIndex, "CreateLookupIndex", 13, $java.oncia_CreateIndex, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CreateLookupIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateLookupIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateLookupIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateLookupIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateLookupIndex_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_CreateLookupIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateLookupIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateLookupIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateLookupIndex_equals), "$withGraph", $rt_wrapFunction1($java.oncia_CreateLookupIndex_withGraph)],
    oncia_CreateLookupIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CreateIndexOldSyntax, "CreateIndexOldSyntax", 13, jl_Object, [oncia_SchemaCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_folder), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq",
    $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$position2", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateIndexOldSyntax_toString), "$equals", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_equals), "$dup", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_dup), "$withGraph", $rt_wrapFunction1($java.oncia_CreateIndexOldSyntax_withGraph)],
    onciafn_Neo4jASTFactory$createIndexWithOldSyntax$lambda$_152_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createIndexWithOldSyntax$lambda$_152_0_apply)],
    oncia_CreateIndexOldSyntax$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciaf_ScopeType, "ScopeType", 14, jl_Enum, [], 12, 3, 0, onciaf_ScopeType_$callClinit, 0,
    $java.oncia_PrivilegeQualifier, 0, jl_Object, [onciu_Rewritable], 3, 3, 0, 0, 0,
    $java.oncia_GraphPrivilegeQualifier, 0, jl_Object, [$java.oncia_PrivilegeQualifier], 3, 3, 0, 0, 0,
    oncia_AllQualifier, "AllQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_AllQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AllQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllQualifier_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_AllQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_AllQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_AllQualifier_dup)],
    $java.oncia_AdministrationAction, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncia_PrivilegeCommand, 0, jl_Object, [$java.oncia_WriteAdministrationCommand], 1, 3, 0, 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_PrivilegeCommand_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_PrivilegeCommand_error), "$foldedOver", $rt_wrapFunction0($java.oncia_PrivilegeCommand_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_PrivilegeCommand_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_PrivilegeCommand_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_PrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_PrivilegeCommand_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$semanticCheck", $rt_wrapFunction0($java.oncia_PrivilegeCommand_semanticCheck), "$dup", $rt_wrapFunction1($java.oncia_PrivilegeCommand_dup0),
    "$withGraph", $rt_wrapFunction1($java.oncia_PrivilegeCommand_withGraph0)],
    oncia_DenyPrivilege, "DenyPrivilege", 13, $java.oncia_PrivilegeCommand, [ji_Serializable], 4, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_DenyPrivilege_position), "$name3", $rt_wrapFunction0(oncia_DenyPrivilege_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_DenyPrivilege_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DenyPrivilege_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DenyPrivilege_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DenyPrivilege_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_DenyPrivilege_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DenyPrivilege_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DenyPrivilege_toString), "$equals", $rt_wrapFunction1($java.oncia_DenyPrivilege_equals)],
    onciafn_Neo4jASTFactory$denyPrivilege$lambda$_178_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$denyPrivilege$lambda$_178_0_apply)],
    oncia_EnableServer, "EnableServer", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_EnableServer_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_EnableServer_error), "$foldedOver", $rt_wrapFunction0($java.oncia_EnableServer_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_EnableServer_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_EnableServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_EnableServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_EnableServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_EnableServer_position), "$name3", $rt_wrapFunction0(oncia_EnableServer_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_EnableServer_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_EnableServer_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_EnableServer_productArity), "$productElement", $rt_wrapFunction1($java.oncia_EnableServer_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_EnableServer_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_EnableServer_hashCode), "$toString", $rt_wrapFunction0($java.oncia_EnableServer_toString), "$equals", $rt_wrapFunction1($java.oncia_EnableServer_equals), "$dup",
    $rt_wrapFunction1($java.oncia_EnableServer_dup), "$withGraph", $rt_wrapFunction1($java.oncia_EnableServer_withGraph)],
    oncia_StartDatabase, "StartDatabase", 13, jl_Object, [$java.oncia_WaitableAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_StartDatabase_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_StartDatabase_error), "$foldedOver", $rt_wrapFunction0($java.oncia_StartDatabase_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_StartDatabase_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_StartDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_StartDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_StartDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_StartDatabase_position), "$name3", $rt_wrapFunction0(oncia_StartDatabase_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_StartDatabase_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_StartDatabase_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_StartDatabase_productArity), "$productElement", $rt_wrapFunction1($java.oncia_StartDatabase_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_StartDatabase_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_StartDatabase_hashCode), "$toString", $rt_wrapFunction0($java.oncia_StartDatabase_toString), "$equals", $rt_wrapFunction1($java.oncia_StartDatabase_equals),
    "$dup", $rt_wrapFunction1($java.oncia_StartDatabase_dup), "$withGraph", $rt_wrapFunction1($java.oncia_StartDatabase_withGraph)],
    oncia_StopDatabase, "StopDatabase", 13, jl_Object, [$java.oncia_WaitableAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_StopDatabase_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_StopDatabase_error), "$foldedOver", $rt_wrapFunction0($java.oncia_StopDatabase_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_StopDatabase_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_StopDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_StopDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_StopDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_StopDatabase_position), "$name3", $rt_wrapFunction0(oncia_StopDatabase_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_StopDatabase_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_StopDatabase_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_StopDatabase_productArity), "$productElement", $rt_wrapFunction1($java.oncia_StopDatabase_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_StopDatabase_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_StopDatabase_hashCode), "$toString", $rt_wrapFunction0($java.oncia_StopDatabase_toString), "$equals", $rt_wrapFunction1($java.oncia_StopDatabase_equals), "$dup",
    $rt_wrapFunction1($java.oncia_StopDatabase_dup), "$withGraph", $rt_wrapFunction1($java.oncia_StopDatabase_withGraph)],
    oncia_ShowAliases$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_ShowIndexType, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_AllIndexes$, "AllIndexes$", 13, jl_Object, [$java.oncia_ShowIndexType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_AllIndexes$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_AllIndexes$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllIndexes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllIndexes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllIndexes$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllIndexes$_toString)],
    oncia_ShowIndexesClause$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_BtreeIndexes$, "BtreeIndexes$", 13, jl_Object, [$java.oncia_ShowIndexType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_BtreeIndexes$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_BtreeIndexes$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_BtreeIndexes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_BtreeIndexes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_BtreeIndexes$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_BtreeIndexes$_toString)],
    oncia_RangeIndexes$, "RangeIndexes$", 13, jl_Object, [$java.oncia_ShowIndexType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_RangeIndexes$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_RangeIndexes$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RangeIndexes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RangeIndexes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RangeIndexes$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_RangeIndexes$_toString)],
    oncia_FulltextIndexes$, "FulltextIndexes$", 13, jl_Object, [$java.oncia_ShowIndexType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_FulltextIndexes$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_FulltextIndexes$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_FulltextIndexes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_FulltextIndexes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_FulltextIndexes$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_FulltextIndexes$_toString)],
    oncia_TextIndexes$, "TextIndexes$", 13, jl_Object, [$java.oncia_ShowIndexType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_TextIndexes$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_TextIndexes$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_TextIndexes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_TextIndexes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_TextIndexes$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_TextIndexes$_toString)],
    oncia_PointIndexes$, "PointIndexes$", 13, jl_Object, [$java.oncia_ShowIndexType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_PointIndexes$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_PointIndexes$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_PointIndexes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_PointIndexes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_PointIndexes$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_PointIndexes$_toString)],
    oncia_LookupIndexes$, "LookupIndexes$", 13, jl_Object, [$java.oncia_ShowIndexType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_LookupIndexes$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_LookupIndexes$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LookupIndexes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LookupIndexes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LookupIndexes$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_LookupIndexes$_toString)],
    $java.oncia_ShowFunctionType, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_AllFunctions$, "AllFunctions$", 13, jl_Object, [$java.oncia_ShowFunctionType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_AllFunctions$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_AllFunctions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllFunctions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllFunctions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllFunctions$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_AllFunctions$_toString)]]);
    $rt_metadata([$java.oncia_ExecutableBy, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_User, "User", 13, jl_Object, [$java.oncia_ExecutableBy, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_User_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_User_productArity), "$productElement", $rt_wrapFunction1($java.oncia_User_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_User_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_User_hashCode), "$toString", $rt_wrapFunction0($java.oncia_User_toString), "$equals",
    $rt_wrapFunction1($java.oncia_User_equals)],
    oncia_ShowFunctionsClause$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_CurrentUser$, "CurrentUser$", 13, jl_Object, [$java.oncia_ExecutableBy, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CurrentUser$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CurrentUser$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CurrentUser$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CurrentUser$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CurrentUser$_toString)],
    oncia_BuiltInFunctions$, "BuiltInFunctions$", 13, jl_Object, [$java.oncia_ShowFunctionType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_BuiltInFunctions$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_BuiltInFunctions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_BuiltInFunctions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_BuiltInFunctions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_BuiltInFunctions$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_BuiltInFunctions$_toString)],
    oncia_UserDefinedFunctions$, "UserDefinedFunctions$", 13, jl_Object, [$java.oncia_ShowFunctionType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_UserDefinedFunctions$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_UserDefinedFunctions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UserDefinedFunctions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UserDefinedFunctions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UserDefinedFunctions$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_UserDefinedFunctions$_toString)],
    $java.oncia_ShowConstraintType, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_AllConstraints$, "AllConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_AllConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_AllConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_AllConstraints$_toString)],
    oncia_ShowConstraintsClause$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_UniqueConstraints$, "UniqueConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_UniqueConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_UniqueConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UniqueConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UniqueConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UniqueConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_UniqueConstraints$_toString)],
    oncia_NodeUniqueConstraints$, "NodeUniqueConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_NodeUniqueConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_NodeUniqueConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NodeUniqueConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NodeUniqueConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_NodeUniqueConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_NodeUniqueConstraints$_toString)],
    oncia_RelUniqueConstraints$, "RelUniqueConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_RelUniqueConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_RelUniqueConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RelUniqueConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RelUniqueConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RelUniqueConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_RelUniqueConstraints$_toString)],
    oncia_KeyConstraints$, "KeyConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_KeyConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_KeyConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_KeyConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_KeyConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_KeyConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_KeyConstraints$_toString)],
    oncia_NodeKeyConstraints$, "NodeKeyConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_NodeKeyConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_NodeKeyConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NodeKeyConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NodeKeyConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_NodeKeyConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_NodeKeyConstraints$_toString)],
    oncia_RelKeyConstraints$, "RelKeyConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_RelKeyConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_RelKeyConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RelKeyConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RelKeyConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RelKeyConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_RelKeyConstraints$_toString)],
    oncia_ExistsConstraints, "ExistsConstraints", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 0, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_ExistsConstraints_prettyPrint), "$productPrefix", $rt_wrapFunction0($java.oncia_ExistsConstraints_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ExistsConstraints_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ExistsConstraints_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ExistsConstraints_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_ExistsConstraints_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ExistsConstraints_toString), "$equals", $rt_wrapFunction1($java.oncia_ExistsConstraints_equals)],
    $java.oncia_ExistenceConstraintSyntax, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_ValidSyntax$, "ValidSyntax$", 13, jl_Object, [$java.oncia_ExistenceConstraintSyntax, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ValidSyntax$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ValidSyntax$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ValidSyntax$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ValidSyntax$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ValidSyntax$_toString)],
    oncia_RemovedSyntax$, "RemovedSyntax$", 13, jl_Object, [$java.oncia_ExistenceConstraintSyntax, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_RemovedSyntax$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RemovedSyntax$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RemovedSyntax$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RemovedSyntax$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RemovedSyntax$_toString)],
    oncia_NodeExistsConstraints, "NodeExistsConstraints", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 0, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_NodeExistsConstraints_prettyPrint), "$productPrefix", $rt_wrapFunction0($java.oncia_NodeExistsConstraints_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_NodeExistsConstraints_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NodeExistsConstraints_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NodeExistsConstraints_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_NodeExistsConstraints_hashCode), "$toString", $rt_wrapFunction0($java.oncia_NodeExistsConstraints_toString), "$equals", $rt_wrapFunction1($java.oncia_NodeExistsConstraints_equals)],
    oncia_RelExistsConstraints, "RelExistsConstraints", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 0, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_RelExistsConstraints_prettyPrint), "$productPrefix", $rt_wrapFunction0($java.oncia_RelExistsConstraints_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RelExistsConstraints_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RelExistsConstraints_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RelExistsConstraints_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_RelExistsConstraints_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RelExistsConstraints_toString), "$equals", $rt_wrapFunction1($java.oncia_RelExistsConstraints_equals)],
    oncia_PropTypeConstraints$, "PropTypeConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_PropTypeConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_PropTypeConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_PropTypeConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_PropTypeConstraints$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_PropTypeConstraints$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_PropTypeConstraints$_toString)],
    oncia_NodePropTypeConstraints$, "NodePropTypeConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_NodePropTypeConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_NodePropTypeConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NodePropTypeConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NodePropTypeConstraints$_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_NodePropTypeConstraints$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_NodePropTypeConstraints$_toString)],
    oncia_RelPropTypeConstraints$, "RelPropTypeConstraints$", 13, jl_Object, [$java.oncia_ShowConstraintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$prettyPrint", $rt_wrapFunction0($java.oncia_RelPropTypeConstraints$_prettyPrint0), "$productArity", $rt_wrapFunction0($java.oncia_RelPropTypeConstraints$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RelPropTypeConstraints$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RelPropTypeConstraints$_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_RelPropTypeConstraints$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RelPropTypeConstraints$_toString)],
    oncia_ShowCurrentUser$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_SingleNamedDatabaseScope, "SingleNamedDatabaseScope", 13, jl_Object, [$java.oncia_DatabaseScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_SingleNamedDatabaseScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SingleNamedDatabaseScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SingleNamedDatabaseScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SingleNamedDatabaseScope_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_SingleNamedDatabaseScope_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SingleNamedDatabaseScope_toString), "$equals", $rt_wrapFunction1($java.oncia_SingleNamedDatabaseScope_equals), "$dup", $rt_wrapFunction1($java.oncia_SingleNamedDatabaseScope_dup)],
    oncia_DefaultDatabaseScope, "DefaultDatabaseScope", 13, jl_Object, [$java.oncia_DatabaseScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_DefaultDatabaseScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DefaultDatabaseScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DefaultDatabaseScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DefaultDatabaseScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DefaultDatabaseScope_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_DefaultDatabaseScope_toString), "$equals", $rt_wrapFunction1($java.oncia_DefaultDatabaseScope_equals), "$dup", $rt_wrapFunction1($java.oncia_DefaultDatabaseScope_dup)],
    oncia_AllDatabasesScope, "AllDatabasesScope", 13, jl_Object, [$java.oncia_DatabaseScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_AllDatabasesScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AllDatabasesScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllDatabasesScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllDatabasesScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllDatabasesScope_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_AllDatabasesScope_toString), "$equals", $rt_wrapFunction1($java.oncia_AllDatabasesScope_equals), "$dup", $rt_wrapFunction1($java.oncia_AllDatabasesScope_dup)],
    oncia_HomeDatabaseScope, "HomeDatabaseScope", 13, jl_Object, [$java.oncia_DatabaseScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_HomeDatabaseScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_HomeDatabaseScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_HomeDatabaseScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_HomeDatabaseScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_HomeDatabaseScope_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_HomeDatabaseScope_toString), "$equals", $rt_wrapFunction1($java.oncia_HomeDatabaseScope_equals), "$dup", $rt_wrapFunction1($java.oncia_HomeDatabaseScope_dup)],
    oncia_ShowDatabase$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$showDatabase$lambda$_218_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$showDatabase$lambda$_218_0_apply)],
    oncia_ShowPrivileges$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_ShowPrivilegeScope, 0, jl_Object, [onciu_Rewritable], 3, 3, 0, 0, 0,
    oncia_ShowAllPrivileges, "ShowAllPrivileges", 13, jl_Object, [$java.oncia_ShowPrivilegeScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ShowAllPrivileges_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowAllPrivileges_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowAllPrivileges_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowAllPrivileges_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowAllPrivileges_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ShowAllPrivileges_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowAllPrivileges_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowAllPrivileges_dup)],
    oncia_ShowPrivilegeCommands$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_ShowProceduresClause$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_ShowServers$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$showSettingsClause$lambda$_145_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$showSettingsClause$lambda$_145_0_apply)],
    oncia_ShowSettingsClause$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_ShowSupportedPrivilegeCommand$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$showTransactionsClause$lambda$_141_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$showTransactionsClause$lambda$_141_0_apply)],
    oncia_ShowTransactionsClause$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$turnYieldToWith$lambda$_144_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$turnYieldToWith$lambda$_144_0_apply)],
    oncia_ParsedAsYield$, "ParsedAsYield$", 13, jl_Object, [$java.oncia_WithType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ParsedAsYield$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ParsedAsYield$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ParsedAsYield$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ParsedAsYield$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ParsedAsYield$_toString)],
    oncia_ShowUsers$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_ShowRolesPrivileges, "ShowRolesPrivileges", 13, jl_Object, [$java.oncia_ShowPrivilegeScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ShowRolesPrivileges_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowRolesPrivileges_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowRolesPrivileges_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowRolesPrivileges_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowRolesPrivileges_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ShowRolesPrivileges_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowRolesPrivileges_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowRolesPrivileges_dup)],
    onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_0_apply)],
    onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$showRolePrivileges$lambda$_174_1_apply)],
    oncia_ShowRoles$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_0_apply)]]);
    $rt_metadata([oncia_TerminateTransactionsClause$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$terminateTransactionsClause$lambda$_142_1_apply)],
    onciafn_Neo4jASTFactory$createClause$lambda$_10_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createClause$lambda$_10_0_apply)],
    $java.oncia_UpdateClause, 0, jl_Object, [oncia_Clause], 3, 3, 0, 0, 0,
    $java.oncia_SingleRelTypeCheck, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_Create, "Create", 13, jl_Object, [$java.oncia_UpdateClause, $java.oncia_SingleRelTypeCheck, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkRelTypes0", $rt_wrapFunction1($java.oncia_Create_checkRelTypes), "$returnVariables", $rt_wrapFunction0($java.oncia_Create_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_Create_semanticCheck), "$error2", $rt_wrapFunction2($java.oncia_Create_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Create_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Create_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_Create_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Create_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Create_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Create_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Create_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_Create_position), "$name3", $rt_wrapFunction0($java.oncia_Create_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Create_clauseSpecificSemanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Create_shouldRunGpmChecks), "$productPrefix", $rt_wrapFunction0($java.oncia_Create_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Create_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Create_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_Create_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Create_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Create_toString), "$equals", $rt_wrapFunction1($java.oncia_Create_equals), "$dup", $rt_wrapFunction1($java.oncia_Create_dup)],
    $java.oncie_Pattern, 0, jl_Object, [onciu_ASTNode], 3, 3, 0, 0, 0,
    oncie_Pattern$ForUpdate, "Pattern$ForUpdate", 28, jl_Object, [$java.oncie_Pattern, ji_Serializable], 4, 3, [$java.oncie_Pattern,0,"ForUpdate"], 0, ["$foldedOver", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_foldedOver), "$folder", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_folder), "$patternParts", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_patternParts), "$position2", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Pattern$ForUpdate_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Pattern$ForUpdate_toString), "$equals", $rt_wrapFunction1($java.oncie_Pattern$ForUpdate_equals), "$dup", $rt_wrapFunction1($java.oncie_Pattern$ForUpdate_dup)],
    onciafn_Neo4jASTFactory$createClause$lambda$_10_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createClause$lambda$_10_1_apply)],
    onciafn_Neo4jASTFactory$createClause$lambda$_10_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$createClause$lambda$_10_2_apply)],
    oncia_Delete, "Delete", 13, jl_Object, [$java.oncia_UpdateClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_Delete_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_Delete_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Delete_shouldRunGpmChecks), "$expectType3", $rt_wrapFunction4($java.oncia_Delete_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_Delete_expectType$default$4), "$error2", $rt_wrapFunction2($java.oncia_Delete_error),
    "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Delete_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Delete_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_Delete_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Delete_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Delete_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Delete_SetExtractor),
    "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Delete_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$position2", $rt_wrapFunction0($java.oncia_Delete_position), "$name3", $rt_wrapFunction0($java.oncia_Delete_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Delete_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Delete_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_Delete_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Delete_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Delete_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Delete_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Delete_toString), "$equals", $rt_wrapFunction1($java.oncia_Delete_equals), "$dup", $rt_wrapFunction1($java.oncia_Delete_dup)],
    onciafn_Neo4jASTFactory$matchClause$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$matchClause$lambda$_11_0_apply)],
    oncie_MatchMode$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncia_Match, "Match", 13, jl_Object, [oncia_Clause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_Match_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_Match_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Match_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_Match_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Match_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Match_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_Match_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Match_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Match_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Match_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Match_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_Match_position), "$name3", $rt_wrapFunction0($java.oncia_Match_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Match_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Match_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Match_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Match_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Match_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Match_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_Match_toString), "$equals", $rt_wrapFunction1($java.oncia_Match_equals), "$dup", $rt_wrapFunction1($java.oncia_Match_dup)],
    oncie_Pattern$ForMatch, "Pattern$ForMatch", 28, jl_Object, [$java.oncie_Pattern, ji_Serializable], 4, 3, [$java.oncie_Pattern,0,"ForMatch"], 0, ["$foldedOver", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_foldedOver), "$folder", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_folder), "$patternParts", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_patternParts), "$position2", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Pattern$ForMatch_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Pattern$ForMatch_toString), "$equals", $rt_wrapFunction1($java.oncie_Pattern$ForMatch_equals), "$dup", $rt_wrapFunction1($java.oncie_Pattern$ForMatch_dup)],
    $java.oncie_PatternPart$Selector, 0, jl_Object, [onciu_ASTNode], 3, 3, 0, 0, 0,
    oncie_PatternPartWithSelector, "PatternPartWithSelector", 28, $java.oncie_PatternPart, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0(oncie_PatternPartWithSelector_position), "$allVariables", $rt_wrapFunction0($java.oncie_PatternPartWithSelector_allVariables), "$element", $rt_wrapFunction0($java.oncie_PatternPartWithSelector_element), "$productPrefix", $rt_wrapFunction0($java.oncie_PatternPartWithSelector_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PatternPartWithSelector_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_PatternPartWithSelector_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternPartWithSelector_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternPartWithSelector_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternPartWithSelector_toString), "$equals", $rt_wrapFunction1($java.oncie_PatternPartWithSelector_equals)],
    onciafn_Neo4jASTFactory$mergeClause$lambda$_28_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$mergeClause$lambda$_28_0_apply)],
    oncia_Merge, "Merge", 13, jl_Object, [$java.oncia_UpdateClause, $java.oncia_SingleRelTypeCheck, ji_Serializable], 0, 3, [0,0,0], 0, ["$checkRelTypes0", $rt_wrapFunction1($java.oncia_Merge_checkRelTypes), "$returnVariables", $rt_wrapFunction0($java.oncia_Merge_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_Merge_semanticCheck), "$error2", $rt_wrapFunction2($java.oncia_Merge_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Merge_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Merge_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_Merge_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Merge_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Merge_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Merge_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Merge_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_Merge_position), "$name3", $rt_wrapFunction0($java.oncia_Merge_name), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Merge_shouldRunGpmChecks), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Merge_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Merge_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Merge_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Merge_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_Merge_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Merge_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Merge_toString), "$equals", $rt_wrapFunction1($java.oncia_Merge_equals), "$dup", $rt_wrapFunction1($java.oncia_Merge_dup)],
    oncia_Merge$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_Remove, "Remove", 13, jl_Object, [$java.oncia_UpdateClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_Remove_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_Remove_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Remove_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_Remove_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Remove_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Remove_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_Remove_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Remove_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Remove_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Remove_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Remove_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_Remove_position), "$name3", $rt_wrapFunction0($java.oncia_Remove_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Remove_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Remove_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Remove_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Remove_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Remove_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_Remove_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Remove_toString), "$equals", $rt_wrapFunction1($java.oncia_Remove_equals), "$dup", $rt_wrapFunction1($java.oncia_Remove_dup)],
    oncia_SetClause, "SetClause", 13, jl_Object, [$java.oncia_UpdateClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_SetClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_SetClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_SetClause_shouldRunGpmChecks), "$error2", $rt_wrapFunction2($java.oncia_SetClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_SetClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_SetClause_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_SetClause_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_SetClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_SetClause_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_SetClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_SetClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_SetClause_position), "$name3", $rt_wrapFunction0($java.oncia_SetClause_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_SetClause_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_SetClause_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SetClause_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetClause_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetClause_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_SetClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetClause_toString), "$equals", $rt_wrapFunction1($java.oncia_SetClause_equals), "$dup", $rt_wrapFunction1($java.oncia_SetClause_dup)],
    oncia_Unwind, "Unwind", 13, jl_Object, [oncia_Clause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_Unwind_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_Unwind_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Unwind_shouldRunGpmChecks), "$expectType3", $rt_wrapFunction4($java.oncia_Unwind_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_Unwind_expectType$default$4), "$error2", $rt_wrapFunction2($java.oncia_Unwind_error),
    "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Unwind_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Unwind_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_Unwind_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Unwind_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Unwind_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Unwind_SetExtractor),
    "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Unwind_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$position2", $rt_wrapFunction0($java.oncia_Unwind_position), "$name3", $rt_wrapFunction0($java.oncia_Unwind_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Unwind_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Unwind_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_Unwind_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Unwind_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Unwind_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Unwind_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Unwind_toString), "$equals", $rt_wrapFunction1($java.oncia_Unwind_equals), "$dup", $rt_wrapFunction1($java.oncia_Unwind_dup)],
    oncie_ProcedureName, "ProcedureName", 28, jl_Object, [oncie_SymbolicName, ji_Serializable], 0, 3, [0,0,0], 0, ["$name3", $rt_wrapFunction0($java.oncie_ProcedureName_name), "$position2", $rt_wrapFunction0($java.oncie_ProcedureName_position), "$productPrefix", $rt_wrapFunction0($java.oncie_ProcedureName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ProcedureName_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ProcedureName_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ProcedureName_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_ProcedureName_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ProcedureName_toString), "$equals", $rt_wrapFunction1($java.oncie_ProcedureName_equals), "$dup", $rt_wrapFunction1($java.oncie_ProcedureName_dup)],
    onciafn_Neo4jASTFactory$callClause$lambda$_29_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$callClause$lambda$_29_0_apply)],
    oncia_SubqueryCall$InTransactionsBatchParameters, "SubqueryCall$InTransactionsBatchParameters", 13, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, ji_Serializable], 4, 3, [oncia_SubqueryCall,0,"InTransactionsBatchParameters"], 0, ["$position2", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsBatchParameters_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsBatchParameters_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsBatchParameters_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsBatchParameters_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsBatchParameters_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsBatchParameters_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsBatchParameters_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsBatchParameters_toString),
    "$equals", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsBatchParameters_equals), "$dup", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsBatchParameters_dup)],
    oncia_SubqueryCall$InTransactionsErrorParameters, "SubqueryCall$InTransactionsErrorParameters", 13, jl_Object, [onciu_ASTNode, ji_Serializable], 4, 3, [oncia_SubqueryCall,0,"InTransactionsErrorParameters"], 0, ["$position2", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsErrorParameters_position), "$productPrefix", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsErrorParameters_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsErrorParameters_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsErrorParameters_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsErrorParameters_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsErrorParameters_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsErrorParameters_toString), "$equals", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsErrorParameters_equals), "$dup",
    $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsErrorParameters_dup)],
    oncia_SubqueryCall$InTransactionsReportParameters, "SubqueryCall$InTransactionsReportParameters", 13, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, oncias_SemanticAnalysisTooling, ji_Serializable], 4, 3, [oncia_SubqueryCall,0,"InTransactionsReportParameters"], 0, ["$position2", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsReportParameters_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters_toString),
    "$equals", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsReportParameters_equals), "$dup", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsReportParameters_dup)],
    onciaf_CallInTxsOnErrorBehaviourType, "CallInTxsOnErrorBehaviourType", 14, jl_Enum, [], 12, 3, 0, onciaf_CallInTxsOnErrorBehaviourType_$callClinit, 0,
    oncia_Foreach, "Foreach", 13, jl_Object, [$java.oncia_UpdateClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_Foreach_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_Foreach_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_Foreach_shouldRunGpmChecks), "$expectType3", $rt_wrapFunction4($java.oncia_Foreach_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_Foreach_expectType$default$4), "$error2", $rt_wrapFunction2($java.oncia_Foreach_error),
    "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_Foreach_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_Foreach_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_Foreach_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_Foreach_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_Foreach_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_Foreach_SetExtractor),
    "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_Foreach_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$position2", $rt_wrapFunction0($java.oncia_Foreach_position), "$name3", $rt_wrapFunction0($java.oncia_Foreach_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_Foreach_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_Foreach_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_Foreach_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Foreach_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Foreach_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Foreach_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Foreach_toString), "$equals", $rt_wrapFunction1($java.oncia_Foreach_equals), "$dup", $rt_wrapFunction1($java.oncia_Foreach_dup)],
    oncia_LoadCSV, "LoadCSV", 13, jl_Object, [oncia_Clause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_LoadCSV_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_LoadCSV_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_LoadCSV_shouldRunGpmChecks), "$expectType3", $rt_wrapFunction4($java.oncia_LoadCSV_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_LoadCSV_expectType$default$4), "$error2", $rt_wrapFunction2($java.oncia_LoadCSV_error),
    "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_LoadCSV_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_LoadCSV_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_LoadCSV_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_LoadCSV_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_LoadCSV_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_LoadCSV_SetExtractor),
    "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_LoadCSV_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$position2", $rt_wrapFunction0($java.oncia_LoadCSV_position), "$name3", $rt_wrapFunction0($java.oncia_LoadCSV_name), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_LoadCSV_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_LoadCSV_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_LoadCSV_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LoadCSV_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LoadCSV_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LoadCSV_hashCode), "$toString", $rt_wrapFunction0($java.oncia_LoadCSV_toString), "$equals", $rt_wrapFunction1($java.oncia_LoadCSV_equals), "$dup", $rt_wrapFunction1($java.oncia_LoadCSV_dup)],
    onciafn_Neo4jASTFactory$loadCsvClause$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$loadCsvClause$lambda$_31_0_apply)],
    oncie_Xor, "Xor", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Xor_asCanonicalStringVal), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Xor_canonicalOperatorSymbol), "$lhs0", $rt_wrapFunction0($java.oncie_Xor_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Xor_rhs), "$position2", $rt_wrapFunction0($java.oncie_Xor_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Xor_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Xor_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Xor_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Xor_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Xor_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Xor_toString), "$equals", $rt_wrapFunction1($java.oncie_Xor_equals)],
    sci_HashCollisionSetNode$diff$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionSetNode$diff$lambda$_19_0_apply)],
    sci_HashCollisionSetNode$diff$lambda$_19_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionSetNode$diff$lambda$_19_1_apply)],
    sci_HashCollisionSetNode$diff$lambda$_19_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionSetNode$diff$lambda$_19_2_apply)],
    $java.sci_HashCollisionMapNode$foreachEntry$lambda$_24_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionMapNode$foreachEntry$lambda$_24_0_apply)],
    onciuh_TreeZipper$TreeContext, "TreeZipper$TreeContext", 21, jl_Object, [$java.onciuh_TreeZipper$Context, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciuh_TreeZipper$TreeContext_productPrefix), "$productArity", $rt_wrapFunction0($java.onciuh_TreeZipper$TreeContext_productArity), "$productElement", $rt_wrapFunction1($java.onciuh_TreeZipper$TreeContext_productElement), "$productIterator", $rt_wrapFunction0($java.onciuh_TreeZipper$TreeContext_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.onciuh_TreeZipper$TreeContext_hashCode), "$toString", $rt_wrapFunction0($java.onciuh_TreeZipper$TreeContext_toString), "$equals", $rt_wrapFunction1($java.onciuh_TreeZipper$TreeContext_equals)],
    $java.oncias_SemanticCheck$$fromState$lambda$_8_0, "SemanticCheck$$fromState$lambda$_8_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$fromState$lambda$_8_0_apply)],
    oncias_SemanticState$$recordCurrentScope$lambda$_7_0, "SemanticState$$recordCurrentScope$lambda$_7_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticState$$recordCurrentScope$lambda$_7_0_apply)],
    $java.oncias_package$$liftSemanticErrorDefOption$lambda$_7_0, "package$$liftSemanticErrorDefOption$lambda$_7_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_package$$liftSemanticErrorDefOption$lambda$_7_0_apply)],
    oncie_ExplicitParameter$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    su_Either$LeftProjection, 0, jl_Object, [s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_0_apply)],
    onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_1_apply)],
    onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciafn_Neo4jASTFactory$getYieldAllAndYieldItems$lambda$_143_2_apply)],
    oncia_ShowUserPrivileges, "ShowUserPrivileges", 13, jl_Object, [$java.oncia_ShowPrivilegeScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ShowUserPrivileges_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowUserPrivileges_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowUserPrivileges_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowUserPrivileges_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowUserPrivileges_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ShowUserPrivileges_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowUserPrivileges_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowUserPrivileges_dup)],
    oncia_ShowUsersPrivileges, "ShowUsersPrivileges", 13, jl_Object, [$java.oncia_ShowPrivilegeScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ShowUsersPrivileges_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowUsersPrivileges_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowUsersPrivileges_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowUsersPrivileges_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowUsersPrivileges_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ShowUsersPrivileges_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowUsersPrivileges_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowUsersPrivileges_dup)],
    onciafn_Neo4jASTFactory$userPrivilegeScope$lambda$_176_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$userPrivilegeScope$lambda$_176_0_apply)],
    $java.ju_IllegalFormatException, 0, jl_IllegalArgumentException, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.ju_UnknownFormatConversionException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    oncia_AliasedReturnItem, "AliasedReturnItem", 13, jl_Object, [oncia_ReturnItem, ji_Serializable], 0, 3, [0,0,0], 0, ["$isPassThrough", $rt_wrapFunction0($java.oncia_AliasedReturnItem_isPassThrough), "$semanticCheck", $rt_wrapFunction0($java.oncia_AliasedReturnItem_semanticCheck), "$expression1", $rt_wrapFunction0($java.oncia_AliasedReturnItem_expression), "$position2", $rt_wrapFunction0($java.oncia_AliasedReturnItem_position), "$alias", $rt_wrapFunction0($java.oncia_AliasedReturnItem_alias), "$name3", $rt_wrapFunction0($java.oncia_AliasedReturnItem_name),
    "$productPrefix", $rt_wrapFunction0($java.oncia_AliasedReturnItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AliasedReturnItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AliasedReturnItem_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AliasedReturnItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AliasedReturnItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AliasedReturnItem_toString), "$equals", $rt_wrapFunction1($java.oncia_AliasedReturnItem_equals),
    "$dup", $rt_wrapFunction1($java.oncia_AliasedReturnItem_dup)],
    $java.oncia_UnmappedUnion$checkColumnNamesAgree$lambda$_8_0, "UnmappedUnion$checkColumnNamesAgree$lambda$_8_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnmappedUnion$checkColumnNamesAgree$lambda$_8_0_apply)],
    $java.onciafn_DecorateTuple$asScalaEither$lambda$_1_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncius_CypherType$$normalize$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_0_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_1_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_2_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_3, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncius_CypherType$$normalize$lambda$_3_3_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_4_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_5_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_6_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_7_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_8, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_8_apply)],
    $java.oncius_CypherType$$normalize$lambda$_3_9, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$normalize$lambda$_3_9_apply)],
    $java.jnci_AsciiCharset, 0, jnc_Charset, [], 0, 3, 0, 0, 0,
    $java.jnci_Iso8859Charset, 0, jnc_Charset, [], 0, 3, 0, 0, 0,
    $java.jnci_UTF16Charset, 0, jnc_Charset, [], 0, 3, 0, 0, 0,
    ju_TemplateCollections$SingleElementList, 0, ju_TemplateCollections$AbstractImmutableList, [ju_RandomAccess], 0, 0, 0, 0, ["$size", $rt_wrapFunction0($java.ju_TemplateCollections$SingleElementList_size), "$get", $rt_wrapFunction1($java.ju_TemplateCollections$SingleElementList_get)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1_applyOrElse)],
    $java.ju_DuplicateFormatFlagsException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    $java.ju_IllegalFormatPrecisionException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    $java.ju_IllegalFormatCodePointException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    $java.ju_IllegalFormatConversionException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    $java.jt_DecimalFormatSymbols, 0, jl_Object, [jl_Cloneable], 0, 3, 0, 0, 0,
    $java.jt_Format, 0, jl_Object, [ji_Serializable, jl_Cloneable], 1, 3, 0, 0, 0,
    $java.jt_NumberFormat, 0, $java.jt_Format, [], 1, 3, 0, 0, 0,
    jt_DecimalFormat, 0, $java.jt_NumberFormat, [], 0, 3, 0, 0, 0,
    $java.ju_Formattable, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncias_SemanticCheck$FlatMap, "SemanticCheck$FlatMap", 17, jl_Object, [oncias_SemanticCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$run", $rt_wrapFunction2($java.oncias_SemanticCheck$FlatMap_run), "$apply61", $rt_wrapFunction1($java.oncias_SemanticCheck$FlatMap_apply), "$chain", $rt_wrapFunction1($java.oncias_SemanticCheck$FlatMap_chain), "$ifOkChain", $rt_wrapFunction1($java.oncias_SemanticCheck$FlatMap_ifOkChain), "$map12", $rt_wrapFunction1($java.oncias_SemanticCheck$FlatMap_map), "$flatMap3", $rt_wrapFunction1($java.oncias_SemanticCheck$FlatMap_flatMap),
    "$productPrefix", $rt_wrapFunction0($java.oncias_SemanticCheck$FlatMap_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SemanticCheck$FlatMap_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheck$FlatMap_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheck$FlatMap_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheck$FlatMap_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheck$FlatMap_toString), "$equals",
    $rt_wrapFunction1($java.oncias_SemanticCheck$FlatMap_equals)],
    sc_Iterator$GroupedIterator, "Iterator$GroupedIterator", 42, sc_AbstractIterator, [], 0, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_Iterator$GroupedIterator_hasNext), "$next", $rt_wrapFunction0($java.sc_Iterator$GroupedIterator_next)],
    $java.oncia_ReturnItems$ReturnVariables, 0, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncir_ValidatingRewriter$$anonfun$buildErrorMessage$2$lambda$_50_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_ValidatingRewriter$$anonfun$buildErrorMessage$2$lambda$_50_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$verifyOrderByAggregationUse$1$lambda$_58_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$verifyOrderByAggregationUse$1$lambda$_58_0_apply)],
    oncie_containsAggregate$, 0, jl_Object, [s_Function1], 4, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_containsAggregate$_apply)],
    $java.ju_FormatFlagsConversionMismatchException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    $java.ju_IllegalFormatFlagsException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    $java.ju_MissingFormatWidthException, 0, $java.ju_IllegalFormatException, [], 0, 3, 0, 0, 0,
    $java.oncia_SingleQuery$checkClauses$lambda$_73_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkClauses$lambda$_73_0_apply)],
    $java.jt_DecimalFormat$FormatField, "DecimalFormat$FormatField", 4, jl_Object, [], 3, 0, [jt_DecimalFormat,0,0], 0, 0,
    $java.jt_DecimalFormat$TextField, "DecimalFormat$TextField", 4, jl_Object, [$java.jt_DecimalFormat$FormatField], 0, 0, 0, 0, ["$equals", $rt_wrapFunction1($java.jt_DecimalFormat$TextField_equals), "$hashCode0", $rt_wrapFunction0($java.jt_DecimalFormat$TextField_hashCode)],
    $java.ju_Currency, "Currency", 1, jl_Object, [ji_Serializable], 4, 3, 0, 0, ["$toString", $rt_wrapFunction0($java.ju_Currency_toString)],
    $java.otcic_CurrencyHelper, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_124, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_126, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_128, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_129, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_130, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_132, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_133, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_134, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$3_136, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_137, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_138, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_139, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_141, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_142, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_147, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_150, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_154, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_157, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_161, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_162, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_163, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_164, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_165, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_166, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_167, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_168, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_169, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_170, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_171, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_173, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_174, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_181, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_182, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_183, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_184, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_185, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_186, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_187, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_188, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_189, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_190, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_193, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_197, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_199, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_200, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_201, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_202, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jusi_WrappingStreamImpl, 0, jusi_SimpleStreamImpl, [], 1, 3, 0, 0, ["$next9", $rt_wrapFunction1($java.jusi_WrappingStreamImpl_next), "$estimateSize", $rt_wrapFunction0($java.jusi_WrappingStreamImpl_estimateSize)],
    $java.jusi_MappingStreamImpl, 0, jusi_WrappingStreamImpl, [], 0, 3, 0, 0, ["$wrap2", $rt_wrapFunction1($java.jusi_MappingStreamImpl_wrap)],
    scm_ArrayBuffer$$anon$1, "ArrayBuffer$$anon$1", 44, scm_GrowableBuilder, [], 4, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1($java.scm_ArrayBuffer$$anon$1_sizeHint)],
    $java.sci_Map$Map2$Map2Iterator, 0, sc_AbstractIterator, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sci_Map$Map2$Map2Iterator_hasNext), "$next", $rt_wrapFunction0($java.sci_Map$Map2$Map2Iterator_next)],
    $java.sci_Map$Map2$$anon$1, "Map$Map2$$anon$1", 43, $java.sci_Map$Map2$Map2Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map2$$anon$1_nextResult)],
    oncias_Scope$allSymbolDefinitions$lambda$_15_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_Scope$allSymbolDefinitions$lambda$_15_0_apply)],
    oncias_Scope$symbolDefinitions$lambda$_17_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_Scope$symbolDefinitions$lambda$_17_0_apply)],
    scm_CheckedIndexedSeqView$CheckedReverseIterator, "CheckedIndexedSeqView$CheckedReverseIterator", 44, sc_IndexedSeqView$IndexedSeqViewReverseIterator, [], 0, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.scm_CheckedIndexedSeqView$CheckedReverseIterator_hasNext)],
    $java.scm_CheckedIndexedSeqView, 0, jl_Object, [sc_IndexedSeqView], 3, 3, 0, 0, 0,
    scm_CheckedIndexedSeqView$Reverse, 0, sc_IndexedSeqView$Reverse, [$java.scm_CheckedIndexedSeqView], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.scm_CheckedIndexedSeqView$Reverse_iterator)],
    oncie_Namespace$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0]);
    $rt_metadata([oncia_ShowColumn$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_DefaultOrAllShowColumns$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_ShowColumn, "ShowColumn", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, [0,0,0], 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ShowColumn_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowColumn_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowColumn_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowColumn_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowColumn_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowColumn_toString),
    "$equals", $rt_wrapFunction1($java.oncia_ShowColumn_equals)],
    oncia_ShowIndexesClause, "ShowIndexesClause", 13, jl_Object, [oncia_CommandClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_ShowIndexesClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_ShowIndexesClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_ShowIndexesClause_shouldRunGpmChecks), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_ShowIndexesClause_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_ShowIndexesClause_declareVariable),
    "$error2", $rt_wrapFunction2($java.oncia_ShowIndexesClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_ShowIndexesClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_ShowIndexesClause_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_ShowIndexesClause_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_ShowIndexesClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_ShowIndexesClause_org$neo4j$cypher$internal$ast$Clause$$stringifier),
    "$SetExtractor", $rt_wrapFunction0($java.oncia_ShowIndexesClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_ShowIndexesClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$unfilteredColumns", $rt_wrapFunction0($java.oncia_ShowIndexesClause_unfilteredColumns), "$where0", $rt_wrapFunction0($java.oncia_ShowIndexesClause_where), "$position2", $rt_wrapFunction0($java.oncia_ShowIndexesClause_position),
    "$name3", $rt_wrapFunction0($java.oncia_ShowIndexesClause_name), "$moveWhereToYield", $rt_wrapFunction0($java.oncia_ShowIndexesClause_moveWhereToYield), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_ShowIndexesClause_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_ShowIndexesClause_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowIndexesClause_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowIndexesClause_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_ShowIndexesClause_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowIndexesClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowIndexesClause_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowIndexesClause_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowIndexesClause_dup)],
    oncia_ShowFunctionsClause, "ShowFunctionsClause", 13, jl_Object, [oncia_CommandClause, $java.oncia_CommandClauseAllowedOnSystem, ji_Serializable], 0, 3, [0,0,0], 0, ["$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_clauseSpecificSemanticCheck), "$returnVariables", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_shouldRunGpmChecks),
    "$semanticCheckFold", $rt_wrapFunction2($java.oncia_ShowFunctionsClause_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_ShowFunctionsClause_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_ShowFunctionsClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_folder), "$LabelExpressionsPartition",
    $rt_wrapFunction0($java.oncia_ShowFunctionsClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_ShowFunctionsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$unfilteredColumns", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_unfilteredColumns), "$where0", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_where), "$position2", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_position), "$name3", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_name), "$moveWhereToYield", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_moveWhereToYield), "$productPrefix", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_ShowFunctionsClause_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowFunctionsClause_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowFunctionsClause_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowFunctionsClause_dup)],
    oncia_ShowConstraintsClause, "ShowConstraintsClause", 13, jl_Object, [oncia_CommandClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_shouldRunGpmChecks), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_ShowConstraintsClause_semanticCheckFold), "$declareVariable",
    $rt_wrapFunction2($java.oncia_ShowConstraintsClause_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_ShowConstraintsClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21",
    $rt_wrapFunction0($java.oncia_ShowConstraintsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_ShowConstraintsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$unfilteredColumns", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_unfilteredColumns),
    "$where0", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_where), "$position2", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_position), "$name3", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_name), "$moveWhereToYield", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_moveWhereToYield), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncia_ShowConstraintsClause_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowConstraintsClause_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowConstraintsClause_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowConstraintsClause_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowConstraintsClause_dup)],
    oncia_ShowProceduresClause, "ShowProceduresClause", 13, jl_Object, [oncia_CommandClause, $java.oncia_CommandClauseAllowedOnSystem, ji_Serializable], 0, 3, [0,0,0], 0, ["$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_ShowProceduresClause_clauseSpecificSemanticCheck), "$returnVariables", $rt_wrapFunction0($java.oncia_ShowProceduresClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_ShowProceduresClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_ShowProceduresClause_shouldRunGpmChecks),
    "$semanticCheckFold", $rt_wrapFunction2($java.oncia_ShowProceduresClause_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_ShowProceduresClause_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_ShowProceduresClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_ShowProceduresClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_ShowProceduresClause_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_ShowProceduresClause_folder), "$LabelExpressionsPartition",
    $rt_wrapFunction0($java.oncia_ShowProceduresClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_ShowProceduresClause_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_ShowProceduresClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_ShowProceduresClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq),
    "$unfilteredColumns", $rt_wrapFunction0($java.oncia_ShowProceduresClause_unfilteredColumns), "$where0", $rt_wrapFunction0($java.oncia_ShowProceduresClause_where), "$position2", $rt_wrapFunction0($java.oncia_ShowProceduresClause_position), "$name3", $rt_wrapFunction0($java.oncia_ShowProceduresClause_name), "$moveWhereToYield", $rt_wrapFunction0($java.oncia_ShowProceduresClause_moveWhereToYield), "$productPrefix", $rt_wrapFunction0($java.oncia_ShowProceduresClause_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowProceduresClause_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_ShowProceduresClause_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowProceduresClause_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowProceduresClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowProceduresClause_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowProceduresClause_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowProceduresClause_dup)],
    $java.oncia_ShowServers$$apply$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowServers$$apply$lambda$_1_0_apply)],
    $java.oncia_ShowServers$$apply$lambda$_1_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowServers$$apply$lambda$_1_1_apply)],
    $java.oncia_ShowServers$$apply$lambda$_1_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowServers$$apply$lambda$_1_2_apply)],
    oncia_ShowSettingsClause, "ShowSettingsClause", 13, jl_Object, [oncia_CommandClause, $java.oncia_CommandClauseAllowedOnSystem, ji_Serializable], 0, 3, [0,0,0], 0, ["$returnVariables", $rt_wrapFunction0($java.oncia_ShowSettingsClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_ShowSettingsClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_ShowSettingsClause_shouldRunGpmChecks), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_ShowSettingsClause_semanticCheckFold),
    "$declareVariable", $rt_wrapFunction2($java.oncia_ShowSettingsClause_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_ShowSettingsClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_ShowSettingsClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_ShowSettingsClause_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_ShowSettingsClause_folder), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_ShowSettingsClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21",
    $rt_wrapFunction0($java.oncia_ShowSettingsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_ShowSettingsClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_ShowSettingsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$unfilteredColumns", $rt_wrapFunction0($java.oncia_ShowSettingsClause_unfilteredColumns),
    "$where0", $rt_wrapFunction0($java.oncia_ShowSettingsClause_where), "$position2", $rt_wrapFunction0($java.oncia_ShowSettingsClause_position), "$name3", $rt_wrapFunction0($java.oncia_ShowSettingsClause_name), "$moveWhereToYield", $rt_wrapFunction0($java.oncia_ShowSettingsClause_moveWhereToYield), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_ShowSettingsClause_clauseSpecificSemanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_ShowSettingsClause_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowSettingsClause_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_ShowSettingsClause_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowSettingsClause_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowSettingsClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowSettingsClause_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowSettingsClause_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowSettingsClause_dup)],
    oncia_TransactionColumn, "TransactionColumn", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_TransactionColumn_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_TransactionColumn_productArity), "$productElement", $rt_wrapFunction1($java.oncia_TransactionColumn_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_TransactionColumn_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_TransactionColumn_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_TransactionColumn_toString), "$equals", $rt_wrapFunction1($java.oncia_TransactionColumn_equals)],
    oncia_TransactionColumn$, 0, $java.sr_AbstractFunction2, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowTransactionsClause$$apply$lambda$_1_0_apply)],
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowTransactionsClause$$apply$lambda$_1_1_apply)],
    $java.oncia_ShowTransactionsClause$$apply$lambda$_1_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowTransactionsClause$$apply$lambda$_1_2_apply)],
    oncia_ShowTransactionsClause, "ShowTransactionsClause", 13, jl_Object, [oncia_TransactionsCommandClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$super$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$super$clauseSpecificSemanticCheck), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_clauseSpecificSemanticCheck), "$returnVariables",
    $rt_wrapFunction0($java.oncia_ShowTransactionsClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_semanticCheck), "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_shouldRunGpmChecks), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_ShowTransactionsClause_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_ShowTransactionsClause_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_ShowTransactionsClause_error),
    "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_folder), "$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap1", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_LabelExpressionsPartition),
    "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier), "$SetExtractor", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_ShowTransactionsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$ids1",
    $rt_wrapFunction0($java.oncia_ShowTransactionsClause_ids), "$where0", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_where), "$yieldItems1", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_yieldItems), "$yieldAll2", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_yieldAll), "$position2", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_position), "$name3", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_name), "$transactionColumns", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_transactionColumns),
    "$unfilteredColumns", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_unfilteredColumns), "$moveWhereToYield", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_moveWhereToYield), "$productPrefix", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowTransactionsClause_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowTransactionsClause_toString), "$equals", $rt_wrapFunction1($java.oncia_ShowTransactionsClause_equals), "$dup", $rt_wrapFunction1($java.oncia_ShowTransactionsClause_dup)],
    oncia_TerminateTransactionsClause, "TerminateTransactionsClause", 13, jl_Object, [oncia_TransactionsCommandClause, ji_Serializable], 0, 3, [0,0,0], 0, ["$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$super$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$super$clauseSpecificSemanticCheck), "$returnVariables", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_returnVariables), "$semanticCheck", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_semanticCheck),
    "$shouldRunGpmChecks", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_shouldRunGpmChecks), "$semanticCheckFold", $rt_wrapFunction2($java.oncia_TerminateTransactionsClause_semanticCheckFold), "$declareVariable", $rt_wrapFunction2($java.oncia_TerminateTransactionsClause_declareVariable), "$error2", $rt_wrapFunction2($java.oncia_TerminateTransactionsClause_error), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_asCanonicalStringVal), "$foldedOver", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_foldedOver),
    "$folder", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_folder), "$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap1", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap), "$LabelExpressionsPartition", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_LabelExpressionsPartition), "$org$neo4j$cypher$internal$ast$Clause$$stringifier21", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$Clause$$stringifier),
    "$SetExtractor", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_SetExtractor), "$org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq", $rt_wrapFunction1($java.oncia_TerminateTransactionsClause_org$neo4j$cypher$internal$ast$Clause$_setter_$org$neo4j$cypher$internal$ast$Clause$$stringifier_$eq), "$transactionColumns", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_transactionColumns), "$ids1", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_ids),
    "$yieldItems1", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_yieldItems), "$yieldAll2", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_yieldAll), "$position2", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_position), "$name3", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_name), "$unfilteredColumns", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_unfilteredColumns), "$clauseSpecificSemanticCheck", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_clauseSpecificSemanticCheck),
    "$where0", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_where), "$moveWhereToYield", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_moveWhereToYield), "$productPrefix", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_productArity), "$productElement", $rt_wrapFunction1($java.oncia_TerminateTransactionsClause_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_hashCode), "$toString", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause_toString), "$equals", $rt_wrapFunction1($java.oncia_TerminateTransactionsClause_equals), "$dup", $rt_wrapFunction1($java.oncia_TerminateTransactionsClause_dup)],
    oncie_MatchMode$DifferentRelationships, "MatchMode$DifferentRelationships", 28, jl_Object, [$java.oncie_MatchMode$MatchMode, ji_Serializable], 0, 3, [$java.oncie_MatchMode,0,"DifferentRelationships"], 0, ["$position2", $rt_wrapFunction0($java.oncie_MatchMode$DifferentRelationships_position), "$prettified", $rt_wrapFunction0($java.oncie_MatchMode$DifferentRelationships_prettified), "$productPrefix", $rt_wrapFunction0($java.oncie_MatchMode$DifferentRelationships_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_MatchMode$DifferentRelationships_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_MatchMode$DifferentRelationships_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_MatchMode$DifferentRelationships_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_MatchMode$DifferentRelationships_hashCode), "$toString", $rt_wrapFunction0($java.oncie_MatchMode$DifferentRelationships_toString), "$equals", $rt_wrapFunction1($java.oncie_MatchMode$DifferentRelationships_equals), "$dup", $rt_wrapFunction1($java.oncie_MatchMode$DifferentRelationships_dup)],
    $java.onciu_BucketSize, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciu_UnknownSize$, "UnknownSize$", 20, jl_Object, [$java.onciu_BucketSize, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.onciu_UnknownSize$_productArity), "$productElement", $rt_wrapFunction1($java.onciu_UnknownSize$_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_UnknownSize$_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciu_UnknownSize$_hashCode), "$toString", $rt_wrapFunction0($java.onciu_UnknownSize$_toString)],
    jusi_SpliteratorOverCollection, 0, jl_Object, [$java.ju_Spliterator], 0, 3, 0, 0, 0,
    oncia_ParameterName, "ParameterName", 13, jl_Object, [$java.oncia_DatabaseName, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_ParameterName_position), "$productPrefix", $rt_wrapFunction0($java.oncia_ParameterName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ParameterName_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ParameterName_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ParameterName_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_ParameterName_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ParameterName_toString), "$equals", $rt_wrapFunction1($java.oncia_ParameterName_equals), "$dup", $rt_wrapFunction1($java.oncia_ParameterName_dup)],
    oncia_NamespacedName$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_AlterLocalDatabaseAlias, "AlterLocalDatabaseAlias", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_AlterLocalDatabaseAlias_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_AlterLocalDatabaseAlias_error), "$foldedOver", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_AlterLocalDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_AlterLocalDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_position), "$name3", $rt_wrapFunction0(oncia_AlterLocalDatabaseAlias_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterLocalDatabaseAlias_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterLocalDatabaseAlias_toString), "$equals", $rt_wrapFunction1($java.oncia_AlterLocalDatabaseAlias_equals), "$dup", $rt_wrapFunction1($java.oncia_AlterLocalDatabaseAlias_dup), "$withGraph", $rt_wrapFunction1($java.oncia_AlterLocalDatabaseAlias_withGraph)],
    onciafn_Neo4jASTFactory$alterLocalDatabaseAlias$lambda$_227_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterLocalDatabaseAlias$lambda$_227_0_apply)],
    oncia_AlterRemoteDatabaseAlias, "AlterRemoteDatabaseAlias", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_AlterRemoteDatabaseAlias_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_AlterRemoteDatabaseAlias_error), "$foldedOver", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_AlterRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_AlterRemoteDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_position), "$name3", $rt_wrapFunction0(oncia_AlterRemoteDatabaseAlias_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterRemoteDatabaseAlias_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterRemoteDatabaseAlias_toString), "$equals", $rt_wrapFunction1($java.oncia_AlterRemoteDatabaseAlias_equals), "$dup", $rt_wrapFunction1($java.oncia_AlterRemoteDatabaseAlias_dup), "$withGraph", $rt_wrapFunction1($java.oncia_AlterRemoteDatabaseAlias_withGraph)],
    onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_0_apply)],
    onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_1_apply)],
    onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_2_apply)],
    onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterRemoteDatabaseAlias$lambda$_228_3_apply)],
    oncia_SetOwnPassword, "SetOwnPassword", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_SetOwnPassword_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_SetOwnPassword_error), "$foldedOver", $rt_wrapFunction0($java.oncia_SetOwnPassword_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_SetOwnPassword_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_SetOwnPassword_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_SetOwnPassword_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_SetOwnPassword_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_SetOwnPassword_position),
    "$name3", $rt_wrapFunction0(oncia_SetOwnPassword_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_SetOwnPassword_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_SetOwnPassword_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SetOwnPassword_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetOwnPassword_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetOwnPassword_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetOwnPassword_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_SetOwnPassword_toString), "$equals", $rt_wrapFunction1($java.oncia_SetOwnPassword_equals), "$dup", $rt_wrapFunction1($java.oncia_SetOwnPassword_dup), "$withGraph", $rt_wrapFunction1($java.oncia_SetOwnPassword_withGraph)],
    onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_0_apply)],
    onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_1_apply)],
    onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$alterDatabase$lambda$_217_2_apply)],
    oncia_AlterDatabase, "AlterDatabase", 13, jl_Object, [$java.oncia_WaitableAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_AlterDatabase_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_AlterDatabase_error), "$foldedOver", $rt_wrapFunction0($java.oncia_AlterDatabase_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_AlterDatabase_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_AlterDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_AlterDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_AlterDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_AlterDatabase_position), "$name3", $rt_wrapFunction0(oncia_AlterDatabase_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_AlterDatabase_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_AlterDatabase_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AlterDatabase_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterDatabase_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AlterDatabase_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterDatabase_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterDatabase_toString), "$equals", $rt_wrapFunction1($java.oncia_AlterDatabase_equals),
    "$dup", $rt_wrapFunction1($java.oncia_AlterDatabase_dup), "$withGraph", $rt_wrapFunction1($java.oncia_AlterDatabase_withGraph)],
    oncia_AlterServer, "AlterServer", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_AlterServer_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_AlterServer_error), "$foldedOver", $rt_wrapFunction0($java.oncia_AlterServer_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_AlterServer_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_AlterServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_AlterServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_AlterServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_AlterServer_position), "$name3", $rt_wrapFunction0(oncia_AlterServer_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_AlterServer_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_AlterServer_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AlterServer_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterServer_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AlterServer_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterServer_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterServer_toString), "$equals", $rt_wrapFunction1($java.oncia_AlterServer_equals), "$dup", $rt_wrapFunction1($java.oncia_AlterServer_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_AlterServer_withGraph)],
    oncia_RemoveHomeDatabaseAction$, "RemoveHomeDatabaseAction$", 13, jl_Object, [$java.oncia_HomeDatabaseAction, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_RemoveHomeDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RemoveHomeDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RemoveHomeDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RemoveHomeDatabaseAction$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_RemoveHomeDatabaseAction$_toString)],
    oncia_AlterUser, "AlterUser", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_AlterUser_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_AlterUser_error), "$foldedOver", $rt_wrapFunction0($java.oncia_AlterUser_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_AlterUser_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_AlterUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_AlterUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_AlterUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_AlterUser_position), "$name3", $rt_wrapFunction0(oncia_AlterUser_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_AlterUser_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_AlterUser_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AlterUser_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterUser_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AlterUser_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterUser_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterUser_toString), "$equals", $rt_wrapFunction1($java.oncia_AlterUser_equals), "$dup", $rt_wrapFunction1($java.oncia_AlterUser_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_AlterUser_withGraph)],
    oncia_DeallocateServers, "DeallocateServers", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_DeallocateServers_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_DeallocateServers_error), "$foldedOver", $rt_wrapFunction0($java.oncia_DeallocateServers_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DeallocateServers_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_DeallocateServers_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_DeallocateServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_DeallocateServers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2",
    $rt_wrapFunction0($java.oncia_DeallocateServers_position), "$name3", $rt_wrapFunction0(oncia_DeallocateServers_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_DeallocateServers_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DeallocateServers_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DeallocateServers_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DeallocateServers_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DeallocateServers_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_DeallocateServers_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DeallocateServers_toString), "$equals", $rt_wrapFunction1($java.oncia_DeallocateServers_equals), "$dup", $rt_wrapFunction1($java.oncia_DeallocateServers_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DeallocateServers_withGraph)],
    onciafn_Neo4jASTFactory$deallocateServers$lambda$_212_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$deallocateServers$lambda$_212_0_apply)],
    oncia_ReallocateDatabases, "ReallocateDatabases", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_ReallocateDatabases_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_ReallocateDatabases_error), "$foldedOver", $rt_wrapFunction0($java.oncia_ReallocateDatabases_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_ReallocateDatabases_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_ReallocateDatabases_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_ReallocateDatabases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_ReallocateDatabases_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_ReallocateDatabases_position), "$name3", $rt_wrapFunction0(oncia_ReallocateDatabases_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_ReallocateDatabases_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_ReallocateDatabases_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ReallocateDatabases_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ReallocateDatabases_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ReallocateDatabases_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_ReallocateDatabases_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ReallocateDatabases_toString), "$equals", $rt_wrapFunction1($java.oncia_ReallocateDatabases_equals), "$dup", $rt_wrapFunction1($java.oncia_ReallocateDatabases_dup), "$withGraph", $rt_wrapFunction1($java.oncia_ReallocateDatabases_withGraph)],
    $java.oncia_DatabasePrivilegeQualifier, 0, jl_Object, [$java.oncia_PrivilegeQualifier], 3, 3, 0, 0, 0,
    oncia_AllDatabasesQualifier, "AllDatabasesQualifier", 13, jl_Object, [$java.oncia_DatabasePrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_AllDatabasesQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AllDatabasesQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllDatabasesQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllDatabasesQualifier_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_AllDatabasesQualifier_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllDatabasesQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_AllDatabasesQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_AllDatabasesQualifier_dup)],
    $java.juf_Consumer, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$userQualifier$lambda$_200_0, 0, jl_Object, [$java.juf_Consumer], 0, 3, 0, 0, ["$accept", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$userQualifier$lambda$_200_0_accept)],
    oncia_UserAllQualifier, "UserAllQualifier", 13, jl_Object, [$java.oncia_DatabasePrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_UserAllQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_UserAllQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UserAllQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UserAllQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UserAllQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_UserAllQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_UserAllQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_UserAllQualifier_dup)],
    $java.oncia_GraphScope, 0, jl_Object, [onciu_Rewritable], 3, 3, 0, 0, 0,
    $java.oncia_ActionResource, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncia_DatabaseAction, 0, jl_Object, [$java.oncia_AdministrationAction], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_DatabaseAction_name)]]);
    $rt_metadata([oncia_AllDatabaseAction$, "AllDatabaseAction$", 13, $java.oncia_DatabaseAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllDatabaseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllDatabaseAction$_toString)],
    oncia_AccessDatabaseAction$, "AccessDatabaseAction$", 13, $java.oncia_DatabaseAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AccessDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AccessDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AccessDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AccessDatabaseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AccessDatabaseAction$_toString)],
    oncia_StartDatabaseAction$, "StartDatabaseAction$", 13, $java.oncia_DatabaseAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_StartDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_StartDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_StartDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_StartDatabaseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_StartDatabaseAction$_toString)],
    oncia_StopDatabaseAction$, "StopDatabaseAction$", 13, $java.oncia_DatabaseAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_StopDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_StopDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_StopDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_StopDatabaseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_StopDatabaseAction$_toString)],
    $java.oncia_IndexManagementAction, 0, $java.oncia_DatabaseAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_IndexManagementAction_name)],
    oncia_AllIndexActions$, "AllIndexActions$", 13, $java.oncia_IndexManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllIndexActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllIndexActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllIndexActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllIndexActions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllIndexActions$_toString)],
    oncia_CreateIndexAction$, "CreateIndexAction$", 13, $java.oncia_IndexManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateIndexAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateIndexAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateIndexAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateIndexAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateIndexAction$_toString)],
    oncia_DropIndexAction$, "DropIndexAction$", 13, $java.oncia_IndexManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DropIndexAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropIndexAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropIndexAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropIndexAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropIndexAction$_toString)],
    oncia_ShowIndexAction$, "ShowIndexAction$", 13, $java.oncia_IndexManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowIndexAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowIndexAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowIndexAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowIndexAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowIndexAction$_toString)],
    $java.oncia_ConstraintManagementAction, 0, $java.oncia_DatabaseAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_ConstraintManagementAction_name)],
    oncia_AllConstraintActions$, "AllConstraintActions$", 13, $java.oncia_ConstraintManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllConstraintActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllConstraintActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllConstraintActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllConstraintActions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllConstraintActions$_toString)],
    oncia_CreateConstraintAction$, "CreateConstraintAction$", 13, $java.oncia_ConstraintManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateConstraintAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateConstraintAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateConstraintAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateConstraintAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateConstraintAction$_toString)],
    oncia_DropConstraintAction$, "DropConstraintAction$", 13, $java.oncia_ConstraintManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DropConstraintAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropConstraintAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropConstraintAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropConstraintAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropConstraintAction$_toString)],
    oncia_ShowConstraintAction$, "ShowConstraintAction$", 13, $java.oncia_ConstraintManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowConstraintAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowConstraintAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowConstraintAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowConstraintAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowConstraintAction$_toString)],
    $java.oncia_NameManagementAction, 0, $java.oncia_DatabaseAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_NameManagementAction_name)],
    oncia_AllTokenActions$, "AllTokenActions$", 13, $java.oncia_NameManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllTokenActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllTokenActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllTokenActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllTokenActions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllTokenActions$_toString)],
    oncia_CreatePropertyKeyAction$, "CreatePropertyKeyAction$", 13, $java.oncia_NameManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreatePropertyKeyAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreatePropertyKeyAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreatePropertyKeyAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreatePropertyKeyAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreatePropertyKeyAction$_toString)],
    oncia_CreateNodeLabelAction$, "CreateNodeLabelAction$", 13, $java.oncia_NameManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateNodeLabelAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateNodeLabelAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateNodeLabelAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateNodeLabelAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateNodeLabelAction$_toString)],
    oncia_CreateRelationshipTypeAction$, "CreateRelationshipTypeAction$", 13, $java.oncia_NameManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateRelationshipTypeAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRelationshipTypeAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRelationshipTypeAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRelationshipTypeAction$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_CreateRelationshipTypeAction$_toString)],
    $java.oncia_TransactionManagementAction, 0, $java.oncia_DatabaseAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_TransactionManagementAction_name)],
    oncia_AllTransactionActions$, "AllTransactionActions$", 13, $java.oncia_TransactionManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllTransactionActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllTransactionActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllTransactionActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllTransactionActions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllTransactionActions$_toString)],
    oncia_ShowTransactionAction$, "ShowTransactionAction$", 13, $java.oncia_TransactionManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowTransactionAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowTransactionAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowTransactionAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowTransactionAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowTransactionAction$_toString)],
    oncia_TerminateTransactionAction$, "TerminateTransactionAction$", 13, $java.oncia_TransactionManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_TerminateTransactionAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_TerminateTransactionAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_TerminateTransactionAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_TerminateTransactionAction$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_TerminateTransactionAction$_toString)],
    $java.oncia_DbmsAction, 0, jl_Object, [$java.oncia_AdministrationAction], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_DbmsAction_name)],
    oncia_AllDbmsAction$, "AllDbmsAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllDbmsAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllDbmsAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllDbmsAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllDbmsAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllDbmsAction$_toString)],
    $java.oncia_UserManagementAction, 0, $java.oncia_DbmsAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_UserManagementAction_name)],
    oncia_AllUserActions$, "AllUserActions$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllUserActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllUserActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllUserActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllUserActions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllUserActions$_toString)],
    oncia_ShowUserAction$, "ShowUserAction$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowUserAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowUserAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowUserAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowUserAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowUserAction$_toString)],
    oncia_AlterUserAction$, "AlterUserAction$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AlterUserAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterUserAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AlterUserAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterUserAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterUserAction$_toString)],
    oncia_CreateUserAction$, "CreateUserAction$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateUserAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateUserAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateUserAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateUserAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateUserAction$_toString)],
    oncia_DropUserAction$, "DropUserAction$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DropUserAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropUserAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropUserAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropUserAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropUserAction$_toString)],
    $java.oncia_RoleManagementAction, 0, $java.oncia_DbmsAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_RoleManagementAction_name)],
    oncia_RenameUserAction$, "RenameUserAction$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_RenameUserAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RenameUserAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RenameUserAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RenameUserAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RenameUserAction$_toString)],
    oncia_SetPasswordsAction$, "SetPasswordsAction$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SetPasswordsAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetPasswordsAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetPasswordsAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetPasswordsAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetPasswordsAction$_toString)],
    oncia_SetUserStatusAction$, "SetUserStatusAction$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SetUserStatusAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetUserStatusAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetUserStatusAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetUserStatusAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetUserStatusAction$_toString)],
    oncia_SetUserHomeDatabaseAction$, "SetUserHomeDatabaseAction$", 13, $java.oncia_UserManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SetUserHomeDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetUserHomeDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetUserHomeDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetUserHomeDatabaseAction$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_SetUserHomeDatabaseAction$_toString)],
    oncia_ImpersonateUserAction$, "ImpersonateUserAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ImpersonateUserAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ImpersonateUserAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ImpersonateUserAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ImpersonateUserAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ImpersonateUserAction$_toString)],
    oncia_AllRoleActions$, "AllRoleActions$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllRoleActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllRoleActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllRoleActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllRoleActions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllRoleActions$_toString)],
    oncia_ShowRoleAction$, "ShowRoleAction$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowRoleAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowRoleAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowRoleAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowRoleAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowRoleAction$_toString)],
    oncia_CreateRoleAction$, "CreateRoleAction$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateRoleAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateRoleAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateRoleAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateRoleAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateRoleAction$_toString)],
    oncia_DropRoleAction$, "DropRoleAction$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DropRoleAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropRoleAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropRoleAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropRoleAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropRoleAction$_toString)],
    oncia_RenameRoleAction$, "RenameRoleAction$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_RenameRoleAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RenameRoleAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RenameRoleAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RenameRoleAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RenameRoleAction$_toString)],
    oncia_AssignRoleAction$, "AssignRoleAction$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AssignRoleAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AssignRoleAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AssignRoleAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AssignRoleAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AssignRoleAction$_toString)],
    oncia_RemoveRoleAction$, "RemoveRoleAction$", 13, $java.oncia_RoleManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_RemoveRoleAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RemoveRoleAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RemoveRoleAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RemoveRoleAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RemoveRoleAction$_toString)],
    $java.oncia_DatabaseManagementAction, 0, $java.oncia_DbmsAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_DatabaseManagementAction_name)],
    oncia_AllDatabaseManagementActions$, "AllDatabaseManagementActions$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllDatabaseManagementActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllDatabaseManagementActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllDatabaseManagementActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllDatabaseManagementActions$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_AllDatabaseManagementActions$_toString)],
    oncia_CreateDatabaseAction$, "CreateDatabaseAction$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateDatabaseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateDatabaseAction$_toString)],
    oncia_DropDatabaseAction$, "DropDatabaseAction$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DropDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropDatabaseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropDatabaseAction$_toString)],
    oncia_CompositeDatabaseManagementActions$, "CompositeDatabaseManagementActions$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CompositeDatabaseManagementActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CompositeDatabaseManagementActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CompositeDatabaseManagementActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CompositeDatabaseManagementActions$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_CompositeDatabaseManagementActions$_toString)],
    oncia_CreateCompositeDatabaseAction$, "CreateCompositeDatabaseAction$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateCompositeDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateCompositeDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateCompositeDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateCompositeDatabaseAction$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_CreateCompositeDatabaseAction$_toString)]]);
    $rt_metadata([oncia_DropCompositeDatabaseAction$, "DropCompositeDatabaseAction$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DropCompositeDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropCompositeDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropCompositeDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropCompositeDatabaseAction$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_DropCompositeDatabaseAction$_toString)],
    oncia_AlterDatabaseAction$, "AlterDatabaseAction$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AlterDatabaseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterDatabaseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AlterDatabaseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterDatabaseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterDatabaseAction$_toString)],
    oncia_SetDatabaseAccessAction$, "SetDatabaseAccessAction$", 13, $java.oncia_DatabaseManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SetDatabaseAccessAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetDatabaseAccessAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetDatabaseAccessAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetDatabaseAccessAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetDatabaseAccessAction$_toString)],
    $java.oncia_AliasManagementAction, 0, $java.oncia_DbmsAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_AliasManagementAction_name)],
    oncia_AllAliasManagementActions$, "AllAliasManagementActions$", 13, $java.oncia_AliasManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllAliasManagementActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllAliasManagementActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllAliasManagementActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllAliasManagementActions$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_AllAliasManagementActions$_toString)],
    oncia_CreateAliasAction$, "CreateAliasAction$", 13, $java.oncia_AliasManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateAliasAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateAliasAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateAliasAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateAliasAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateAliasAction$_toString)],
    oncia_DropAliasAction$, "DropAliasAction$", 13, $java.oncia_AliasManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DropAliasAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropAliasAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropAliasAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropAliasAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropAliasAction$_toString)],
    oncia_AlterAliasAction$, "AlterAliasAction$", 13, $java.oncia_AliasManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AlterAliasAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AlterAliasAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AlterAliasAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AlterAliasAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AlterAliasAction$_toString)],
    oncia_ShowAliasAction$, "ShowAliasAction$", 13, $java.oncia_AliasManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowAliasAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowAliasAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowAliasAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowAliasAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowAliasAction$_toString)],
    $java.oncia_PrivilegeManagementAction, 0, $java.oncia_DbmsAction, [], 1, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncia_PrivilegeManagementAction_name)],
    oncia_AllPrivilegeActions$, "AllPrivilegeActions$", 13, $java.oncia_PrivilegeManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllPrivilegeActions$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllPrivilegeActions$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllPrivilegeActions$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllPrivilegeActions$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllPrivilegeActions$_toString)],
    oncia_AssignPrivilegeAction$, "AssignPrivilegeAction$", 13, $java.oncia_PrivilegeManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AssignPrivilegeAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AssignPrivilegeAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AssignPrivilegeAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AssignPrivilegeAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AssignPrivilegeAction$_toString)],
    oncia_RemovePrivilegeAction$, "RemovePrivilegeAction$", 13, $java.oncia_PrivilegeManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_RemovePrivilegeAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RemovePrivilegeAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RemovePrivilegeAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RemovePrivilegeAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RemovePrivilegeAction$_toString)],
    oncia_ShowPrivilegeAction$, "ShowPrivilegeAction$", 13, $java.oncia_PrivilegeManagementAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowPrivilegeAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowPrivilegeAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowPrivilegeAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowPrivilegeAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowPrivilegeAction$_toString)],
    oncia_ExecuteFunctionAction$, "ExecuteFunctionAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ExecuteFunctionAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ExecuteFunctionAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ExecuteFunctionAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ExecuteFunctionAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ExecuteFunctionAction$_toString)],
    oncia_ExecuteBoostedFunctionAction$, "ExecuteBoostedFunctionAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ExecuteBoostedFunctionAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ExecuteBoostedFunctionAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ExecuteBoostedFunctionAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ExecuteBoostedFunctionAction$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_ExecuteBoostedFunctionAction$_toString)],
    oncia_ExecuteProcedureAction$, "ExecuteProcedureAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ExecuteProcedureAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ExecuteProcedureAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ExecuteProcedureAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ExecuteProcedureAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ExecuteProcedureAction$_toString)],
    oncia_ExecuteBoostedProcedureAction$, "ExecuteBoostedProcedureAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ExecuteBoostedProcedureAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ExecuteBoostedProcedureAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ExecuteBoostedProcedureAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ExecuteBoostedProcedureAction$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ExecuteBoostedProcedureAction$_toString)],
    oncia_ExecuteAdminProcedureAction$, "ExecuteAdminProcedureAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ExecuteAdminProcedureAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ExecuteAdminProcedureAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ExecuteAdminProcedureAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ExecuteAdminProcedureAction$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_ExecuteAdminProcedureAction$_toString)],
    oncia_ShowServerAction$, "ShowServerAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowServerAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowServerAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowServerAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowServerAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowServerAction$_toString)],
    oncia_ServerManagementAction$, "ServerManagementAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ServerManagementAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ServerManagementAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ServerManagementAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ServerManagementAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ServerManagementAction$_toString)],
    oncia_ShowSettingAction$, "ShowSettingAction$", 13, $java.oncia_DbmsAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ShowSettingAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ShowSettingAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ShowSettingAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ShowSettingAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ShowSettingAction$_toString)],
    $java.oncia_GraphAction, 0, jl_Object, [$java.oncia_AdministrationAction], 1, 3, 0, 0, 0,
    oncia_AllGraphAction$, "AllGraphAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_AllGraphAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllGraphAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllGraphAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllGraphAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AllGraphAction$_toString)],
    oncia_WriteAction$, "WriteAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_WriteAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_WriteAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_WriteAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_WriteAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_WriteAction$_toString)],
    oncia_CreateElementAction$, "CreateElementAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_CreateElementAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CreateElementAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CreateElementAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CreateElementAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CreateElementAction$_toString)],
    oncia_MergeAdminAction$, "MergeAdminAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_MergeAdminAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_MergeAdminAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_MergeAdminAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_MergeAdminAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_MergeAdminAction$_toString)],
    oncia_DeleteElementAction$, "DeleteElementAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DeleteElementAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DeleteElementAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DeleteElementAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DeleteElementAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DeleteElementAction$_toString)],
    oncia_SetLabelAction$, "SetLabelAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SetLabelAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetLabelAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetLabelAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetLabelAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetLabelAction$_toString)],
    oncia_RemoveLabelAction$, "RemoveLabelAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_RemoveLabelAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RemoveLabelAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RemoveLabelAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RemoveLabelAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RemoveLabelAction$_toString)],
    oncia_SetPropertyAction$, "SetPropertyAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SetPropertyAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetPropertyAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetPropertyAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetPropertyAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetPropertyAction$_toString)],
    oncia_MatchAction$, "MatchAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_MatchAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_MatchAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_MatchAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_MatchAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_MatchAction$_toString)],
    oncia_ReadAction$, "ReadAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ReadAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ReadAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ReadAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ReadAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ReadAction$_toString)],
    oncia_TraverseAction$, "TraverseAction$", 13, $java.oncia_GraphAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_TraverseAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_TraverseAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_TraverseAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_TraverseAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_TraverseAction$_toString)],
    oncia_PrivilegeType, 0, jl_Object, [], 1, 3, 0, 0, 0,
    oncia_DbmsPrivilege, "DbmsPrivilege", 13, oncia_PrivilegeType, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_DbmsPrivilege_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DbmsPrivilege_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DbmsPrivilege_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DbmsPrivilege_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DbmsPrivilege_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DbmsPrivilege_toString),
    "$equals", $rt_wrapFunction1($java.oncia_DbmsPrivilege_equals)],
    oncia_DropDatabaseAlias, "DropDatabaseAlias", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_DropDatabaseAlias_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_DropDatabaseAlias_error), "$foldedOver", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_DropDatabaseAlias_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_DropDatabaseAlias_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2",
    $rt_wrapFunction0($java.oncia_DropDatabaseAlias_position), "$name3", $rt_wrapFunction0(oncia_DropDatabaseAlias_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropDatabaseAlias_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropDatabaseAlias_toString), "$equals", $rt_wrapFunction1($java.oncia_DropDatabaseAlias_equals), "$dup", $rt_wrapFunction1($java.oncia_DropDatabaseAlias_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropDatabaseAlias_withGraph)],
    $java.oncia_DropDatabaseAdditionalAction, 0, jl_Object, [], 1, 3, 0, 0, 0,
    oncia_DestroyData$, "DestroyData$", 13, $java.oncia_DropDatabaseAdditionalAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DestroyData$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DestroyData$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DestroyData$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DestroyData$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DestroyData$_toString)],
    oncia_DumpData$, "DumpData$", 13, $java.oncia_DropDatabaseAdditionalAction, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_DumpData$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DumpData$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DumpData$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DumpData$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DumpData$_toString)],
    oncia_DropDatabase, "DropDatabase", 13, jl_Object, [$java.oncia_WaitableAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_DropDatabase_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_DropDatabase_error), "$foldedOver", $rt_wrapFunction0($java.oncia_DropDatabase_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropDatabase_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_DropDatabase_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_DropDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_DropDatabase_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_DropDatabase_position), "$name3", $rt_wrapFunction0(oncia_DropDatabase_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropDatabase_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_DropDatabase_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropDatabase_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropDatabase_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropDatabase_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropDatabase_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropDatabase_toString), "$equals", $rt_wrapFunction1($java.oncia_DropDatabase_equals), "$dup",
    $rt_wrapFunction1($java.oncia_DropDatabase_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropDatabase_withGraph)],
    oncia_DropPropertyUniquenessConstraint, "DropPropertyUniquenessConstraint", 13, jl_Object, [$java.oncia_NodeCompositePropertyConstraintCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_folder), "$org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropPropertyUniquenessConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropPropertyUniquenessConstraint_withGraph)],
    oncia_DropPropertyUniquenessConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_DropNodeKeyConstraint, "DropNodeKeyConstraint", 13, jl_Object, [$java.oncia_NodeCompositePropertyConstraintCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_folder), "$org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$NodeCompositePropertyConstraintCommand$_setter_$entityType_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropNodeKeyConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropNodeKeyConstraint_withGraph)],
    oncia_DropNodeKeyConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_DropNodePropertyExistenceConstraint, "DropNodePropertyExistenceConstraint", 13, jl_Object, [$java.oncia_NodePropertyConstraintCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_folder), "$org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$NodePropertyConstraintCommand$_setter_$entityType_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropNodePropertyExistenceConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropNodePropertyExistenceConstraint_withGraph)],
    oncia_DropNodePropertyExistenceConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_DropRelationshipPropertyExistenceConstraint, "DropRelationshipPropertyExistenceConstraint", 13, jl_Object, [$java.oncia_RelationshipPropertyConstraintCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_folder), "$org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$RelationshipPropertyConstraintCommand$_setter_$entityType_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq",
    $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropRelationshipPropertyExistenceConstraint_toString), "$equals", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_equals), "$dup", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropRelationshipPropertyExistenceConstraint_withGraph)],
    oncia_DropRelationshipPropertyExistenceConstraint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_DropConstraintOnName, "DropConstraintOnName", 13, jl_Object, [oncia_SchemaCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_DropConstraintOnName_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropConstraintOnName_folder), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq",
    $rt_wrapFunction1($java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropConstraintOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$position2", $rt_wrapFunction0($java.oncia_DropConstraintOnName_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropConstraintOnName_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropConstraintOnName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropConstraintOnName_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_DropConstraintOnName_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropConstraintOnName_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropConstraintOnName_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropConstraintOnName_toString), "$equals", $rt_wrapFunction1($java.oncia_DropConstraintOnName_equals), "$dup", $rt_wrapFunction1($java.oncia_DropConstraintOnName_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropConstraintOnName_withGraph)]]);
    $rt_metadata([oncia_DropConstraintOnName$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciafn_Neo4jASTFactory$dropIndex$lambda$_156_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$dropIndex$lambda$_156_0_apply)],
    oncia_DropIndex, "DropIndex", 13, jl_Object, [oncia_SchemaCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_DropIndex_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropIndex_folder), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq",
    $rt_wrapFunction1($java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropIndex_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$position2", $rt_wrapFunction0($java.oncia_DropIndex_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropIndex_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropIndex_productArity), "$productElement",
    $rt_wrapFunction1($java.oncia_DropIndex_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropIndex_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropIndex_toString), "$equals", $rt_wrapFunction1($java.oncia_DropIndex_equals), "$dup", $rt_wrapFunction1($java.oncia_DropIndex_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropIndex_withGraph)],
    oncia_DropIndex$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_DropIndexOnName, "DropIndexOnName", 13, jl_Object, [oncia_SchemaCommand, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncia_DropIndexOnName_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropIndexOnName_folder), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq", $rt_wrapFunction1($java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnRequire_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq",
    $rt_wrapFunction1($java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssert_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageForAssertExists_$eq), "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq", $rt_wrapFunction1($java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssert_$eq),
    "$org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq", $rt_wrapFunction1($java.oncia_DropIndexOnName_org$neo4j$cypher$internal$ast$SchemaCommand$_setter_$errorMessageOnAssertExists_$eq), "$position2", $rt_wrapFunction0($java.oncia_DropIndexOnName_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropIndexOnName_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_DropIndexOnName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropIndexOnName_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_DropIndexOnName_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropIndexOnName_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropIndexOnName_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropIndexOnName_toString), "$equals", $rt_wrapFunction1($java.oncia_DropIndexOnName_equals), "$dup", $rt_wrapFunction1($java.oncia_DropIndexOnName_dup), "$withGraph", $rt_wrapFunction1($java.oncia_DropIndexOnName_withGraph)],
    oncia_DropIndexOnName$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncia_DropRole, "DropRole", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_DropRole_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_DropRole_error), "$foldedOver", $rt_wrapFunction0($java.oncia_DropRole_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropRole_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_DropRole_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_DropRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_DropRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_DropRole_position), "$name3", $rt_wrapFunction0(oncia_DropRole_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropRole_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_DropRole_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropRole_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropRole_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropRole_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropRole_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropRole_toString), "$equals", $rt_wrapFunction1($java.oncia_DropRole_equals), "$dup", $rt_wrapFunction1($java.oncia_DropRole_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_DropRole_withGraph)],
    oncia_DropServer, "DropServer", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_DropServer_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_DropServer_error), "$foldedOver", $rt_wrapFunction0($java.oncia_DropServer_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropServer_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_DropServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_DropServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_DropServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_DropServer_position), "$name3", $rt_wrapFunction0(oncia_DropServer_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropServer_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_DropServer_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropServer_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropServer_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropServer_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropServer_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropServer_toString), "$equals", $rt_wrapFunction1($java.oncia_DropServer_equals), "$dup", $rt_wrapFunction1($java.oncia_DropServer_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_DropServer_withGraph)],
    oncia_DropUser, "DropUser", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_DropUser_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_DropUser_error), "$foldedOver", $rt_wrapFunction0($java.oncia_DropUser_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_DropUser_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_DropUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_DropUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_DropUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_DropUser_position), "$name3", $rt_wrapFunction0(oncia_DropUser_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_DropUser_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_DropUser_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DropUser_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DropUser_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DropUser_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DropUser_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DropUser_toString), "$equals", $rt_wrapFunction1($java.oncia_DropUser_equals), "$dup", $rt_wrapFunction1($java.oncia_DropUser_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_DropUser_withGraph)],
    oncia_GrantPrivilege, "GrantPrivilege", 13, $java.oncia_PrivilegeCommand, [ji_Serializable], 4, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_GrantPrivilege_position), "$name3", $rt_wrapFunction0(oncia_GrantPrivilege_name), "$productPrefix", $rt_wrapFunction0($java.oncia_GrantPrivilege_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_GrantPrivilege_productArity), "$productElement", $rt_wrapFunction1($java.oncia_GrantPrivilege_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_GrantPrivilege_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_GrantPrivilege_hashCode), "$toString", $rt_wrapFunction0($java.oncia_GrantPrivilege_toString), "$equals", $rt_wrapFunction1($java.oncia_GrantPrivilege_equals)],
    onciafn_Neo4jASTFactory$grantPrivilege$lambda$_177_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$grantPrivilege$lambda$_177_0_apply)],
    oncia_GrantRolesToUsers, "GrantRolesToUsers", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_GrantRolesToUsers_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_GrantRolesToUsers_error), "$foldedOver", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_GrantRolesToUsers_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_GrantRolesToUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2",
    $rt_wrapFunction0($java.oncia_GrantRolesToUsers_position), "$name3", $rt_wrapFunction0(oncia_GrantRolesToUsers_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_productArity), "$productElement", $rt_wrapFunction1($java.oncia_GrantRolesToUsers_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_hashCode), "$toString", $rt_wrapFunction0($java.oncia_GrantRolesToUsers_toString), "$equals", $rt_wrapFunction1($java.oncia_GrantRolesToUsers_equals), "$dup", $rt_wrapFunction1($java.oncia_GrantRolesToUsers_dup), "$withGraph", $rt_wrapFunction1($java.oncia_GrantRolesToUsers_withGraph)],
    onciafn_Neo4jASTFactory$grantRoles$lambda$_161_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$grantRoles$lambda$_161_0_apply)],
    onciafn_Neo4jASTFactory$grantRoles$lambda$_161_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$grantRoles$lambda$_161_1_apply)],
    oncia_RenameRole, "RenameRole", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_RenameRole_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_RenameRole_error), "$foldedOver", $rt_wrapFunction0($java.oncia_RenameRole_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_RenameRole_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_RenameRole_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_RenameRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_RenameRole_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_RenameRole_position), "$name3", $rt_wrapFunction0(oncia_RenameRole_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_RenameRole_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_RenameRole_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RenameRole_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RenameRole_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RenameRole_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RenameRole_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RenameRole_toString), "$equals", $rt_wrapFunction1($java.oncia_RenameRole_equals), "$dup", $rt_wrapFunction1($java.oncia_RenameRole_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_RenameRole_withGraph)],
    oncia_RenameServer, "RenameServer", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_RenameServer_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_RenameServer_error), "$foldedOver", $rt_wrapFunction0($java.oncia_RenameServer_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_RenameServer_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_RenameServer_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_RenameServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_RenameServer_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_RenameServer_position), "$name3", $rt_wrapFunction0(oncia_RenameServer_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_RenameServer_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_RenameServer_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RenameServer_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RenameServer_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RenameServer_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RenameServer_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RenameServer_toString), "$equals", $rt_wrapFunction1($java.oncia_RenameServer_equals), "$dup",
    $rt_wrapFunction1($java.oncia_RenameServer_dup), "$withGraph", $rt_wrapFunction1($java.oncia_RenameServer_withGraph)],
    oncia_RenameUser, "RenameUser", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_RenameUser_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_RenameUser_error), "$foldedOver", $rt_wrapFunction0($java.oncia_RenameUser_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_RenameUser_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq", $rt_wrapFunction1($java.oncia_RenameUser_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq),
    "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_RenameUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_RenameUser_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq), "$position2", $rt_wrapFunction0($java.oncia_RenameUser_position), "$name3", $rt_wrapFunction0(oncia_RenameUser_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_RenameUser_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_RenameUser_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RenameUser_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RenameUser_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RenameUser_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RenameUser_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RenameUser_toString), "$equals", $rt_wrapFunction1($java.oncia_RenameUser_equals), "$dup", $rt_wrapFunction1($java.oncia_RenameUser_dup),
    "$withGraph", $rt_wrapFunction1($java.oncia_RenameUser_withGraph)],
    oncia_RevokePrivilege, "RevokePrivilege", 13, $java.oncia_PrivilegeCommand, [ji_Serializable], 4, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_RevokePrivilege_position), "$name3", $rt_wrapFunction0(oncia_RevokePrivilege_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_RevokePrivilege_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_RevokePrivilege_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RevokePrivilege_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RevokePrivilege_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_RevokePrivilege_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RevokePrivilege_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RevokePrivilege_toString), "$equals", $rt_wrapFunction1($java.oncia_RevokePrivilege_equals)],
    onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_0_apply)],
    oncia_RevokeType, 0, jl_Object, [], 1, 3, 0, 0, 0,
    oncia_RevokeGrantType, "RevokeGrantType", 13, oncia_RevokeType, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_RevokeGrantType_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RevokeGrantType_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RevokeGrantType_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RevokeGrantType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RevokeGrantType_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_RevokeGrantType_toString), "$equals", $rt_wrapFunction1($java.oncia_RevokeGrantType_equals)],
    onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_1_apply)],
    oncia_RevokeDenyType, "RevokeDenyType", 13, oncia_RevokeType, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_RevokeDenyType_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RevokeDenyType_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RevokeDenyType_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RevokeDenyType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RevokeDenyType_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RevokeDenyType_toString),
    "$equals", $rt_wrapFunction1($java.oncia_RevokeDenyType_equals)],
    onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$revokePrivilege$lambda$_179_2_apply)],
    oncia_RevokeBothType, "RevokeBothType", 13, oncia_RevokeType, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_RevokeBothType_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RevokeBothType_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RevokeBothType_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RevokeBothType_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RevokeBothType_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RevokeBothType_toString),
    "$equals", $rt_wrapFunction1($java.oncia_RevokeBothType_equals)],
    oncia_RevokeRolesFromUsers, "RevokeRolesFromUsers", 13, jl_Object, [$java.oncia_WriteAdministrationCommand, ji_Serializable], 4, 3, [0,0,0], 0, ["$requireFeatureSupport", $rt_wrapFunction3($java.oncia_RevokeRolesFromUsers_requireFeatureSupport), "$error2", $rt_wrapFunction2($java.oncia_RevokeRolesFromUsers_error), "$foldedOver", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_foldedOver), "$folder", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_folder), "$org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq",
    $rt_wrapFunction1($java.oncia_RevokeRolesFromUsers_org$neo4j$cypher$internal$ast$WriteAdministrationCommand$_setter_$isReadOnly_$eq), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar), "$org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq", $rt_wrapFunction1($java.oncia_RevokeRolesFromUsers_org$neo4j$cypher$internal$ast$AdministrationCommand$$useGraphVar_$eq),
    "$position2", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_position), "$name3", $rt_wrapFunction0(oncia_RevokeRolesFromUsers_name), "$semanticCheck", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RevokeRolesFromUsers_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RevokeRolesFromUsers_toString), "$equals", $rt_wrapFunction1($java.oncia_RevokeRolesFromUsers_equals), "$dup", $rt_wrapFunction1($java.oncia_RevokeRolesFromUsers_dup), "$withGraph", $rt_wrapFunction1($java.oncia_RevokeRolesFromUsers_withGraph)],
    onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_0_apply)],
    onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$revokeRoles$lambda$_162_1_apply)],
    onciafn_Neo4jASTFactory$yieldClause$lambda$_136_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_0_apply)],
    onciafn_Neo4jASTFactory$yieldClause$lambda$_136_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_1_apply)],
    onciafn_Neo4jASTFactory$yieldClause$lambda$_136_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_2_apply)],
    onciafn_Neo4jASTFactory$yieldClause$lambda$_136_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$yieldClause$lambda$_136_3_apply)],
    oncia_UsingJoinHint$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncia_Hint, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable, oncias_SemanticAnalysisTooling], 3, 3, 0, 0, 0,
    $java.oncia_UsingHint, 0, jl_Object, [$java.oncia_Hint], 3, 3, 0, 0, 0,
    $java.oncia_NodeHint, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_UsingScanHint, "UsingScanHint", 13, jl_Object, [$java.oncia_UsingHint, $java.oncia_NodeHint, ji_Serializable], 0, 3, [0,0,0], 0, ["$expectType3", $rt_wrapFunction4($java.oncia_UsingScanHint_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_UsingScanHint_expectType$default$4), "$position2", $rt_wrapFunction0($java.oncia_UsingScanHint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_UsingScanHint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_UsingScanHint_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_UsingScanHint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UsingScanHint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UsingScanHint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UsingScanHint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UsingScanHint_toString), "$equals", $rt_wrapFunction1($java.oncia_UsingScanHint_equals), "$dup", $rt_wrapFunction1($java.oncia_UsingScanHint_dup)],
    oncie_LabelOrRelTypeName, "LabelOrRelTypeName", 28, jl_Object, [$java.oncil_LabelExpressionLeafName, ji_Serializable], 0, 3, [0,0,0], 0, ["$name3", $rt_wrapFunction0($java.oncie_LabelOrRelTypeName_name), "$position2", $rt_wrapFunction0($java.oncie_LabelOrRelTypeName_position), "$productPrefix", $rt_wrapFunction0($java.oncie_LabelOrRelTypeName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_LabelOrRelTypeName_productArity), "$productElement", $rt_wrapFunction1($java.oncie_LabelOrRelTypeName_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_LabelOrRelTypeName_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_LabelOrRelTypeName_hashCode), "$toString", $rt_wrapFunction0($java.oncie_LabelOrRelTypeName_toString), "$equals", $rt_wrapFunction1($java.oncie_LabelOrRelTypeName_equals), "$dup", $rt_wrapFunction1($java.oncie_LabelOrRelTypeName_dup)],
    oncie_MatchMode$RepeatableElements, "MatchMode$RepeatableElements", 28, jl_Object, [$java.oncie_MatchMode$MatchMode, ji_Serializable], 0, 3, [$java.oncie_MatchMode,0,"RepeatableElements"], 0, ["$position2", $rt_wrapFunction0($java.oncie_MatchMode$RepeatableElements_position), "$prettified", $rt_wrapFunction0($java.oncie_MatchMode$RepeatableElements_prettified), "$productPrefix", $rt_wrapFunction0($java.oncie_MatchMode$RepeatableElements_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_MatchMode$RepeatableElements_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_MatchMode$RepeatableElements_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_MatchMode$RepeatableElements_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_MatchMode$RepeatableElements_hashCode), "$toString", $rt_wrapFunction0($java.oncie_MatchMode$RepeatableElements_toString), "$equals", $rt_wrapFunction1($java.oncie_MatchMode$RepeatableElements_equals), "$dup", $rt_wrapFunction1($java.oncie_MatchMode$RepeatableElements_dup)],
    oncie_MatchMode$DifferentRelationships$, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    oncie_NamedPatternPart, "NamedPatternPart", 28, $java.oncie_PatternPart, [oncie_NonPrefixedPatternPart, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_NamedPatternPart_position), "$element", $rt_wrapFunction0($java.oncie_NamedPatternPart_element), "$allVariables", $rt_wrapFunction0($java.oncie_NamedPatternPart_allVariables), "$isBounded", $rt_wrapFunction0($java.oncie_NamedPatternPart_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_NamedPatternPart_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_NamedPatternPart_productArity), "$productElement", $rt_wrapFunction1($java.oncie_NamedPatternPart_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_NamedPatternPart_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_NamedPatternPart_hashCode), "$toString", $rt_wrapFunction0($java.oncie_NamedPatternPart_toString), "$equals", $rt_wrapFunction1($java.oncie_NamedPatternPart_equals)],
    $java.oncia_RemoveItem, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable], 3, 3, 0, 0, 0,
    oncia_RemovePropertyItem, "RemovePropertyItem", 13, jl_Object, [$java.oncia_RemoveItem, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_RemovePropertyItem_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_RemovePropertyItem_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_RemovePropertyItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RemovePropertyItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RemovePropertyItem_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_RemovePropertyItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RemovePropertyItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RemovePropertyItem_toString), "$equals", $rt_wrapFunction1($java.oncia_RemovePropertyItem_equals), "$dup", $rt_wrapFunction1($java.oncia_RemovePropertyItem_dup)],
    oncia_RemoveLabelItem, "RemoveLabelItem", 13, jl_Object, [$java.oncia_RemoveItem, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_RemoveLabelItem_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_RemoveLabelItem_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_RemoveLabelItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RemoveLabelItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RemoveLabelItem_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_RemoveLabelItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RemoveLabelItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RemoveLabelItem_toString), "$equals", $rt_wrapFunction1($java.oncia_RemoveLabelItem_equals), "$dup", $rt_wrapFunction1($java.oncia_RemoveLabelItem_dup)],
    onciafn_Neo4jASTFactory$removeLabels$lambda$_25_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$removeLabels$lambda$_25_0_apply)],
    onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_0_apply)],
    onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$newReturnClause$lambda$_4_1_apply)],
    $java.oncia_SetItem, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable], 3, 3, 0, 0, 0,
    $java.oncia_SetProperty, 0, jl_Object, [$java.oncia_SetItem, oncias_SemanticAnalysisTooling], 3, 3, 0, 0, 0,
    oncia_SetPropertyItem, "SetPropertyItem", 13, jl_Object, [$java.oncia_SetProperty, ji_Serializable], 0, 3, [0,0,0], 0, ["$expectType3", $rt_wrapFunction4($java.oncia_SetPropertyItem_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_SetPropertyItem_expectType$default$4), "$position2", $rt_wrapFunction0($java.oncia_SetPropertyItem_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_SetPropertyItem_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_SetPropertyItem_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_SetPropertyItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetPropertyItem_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetPropertyItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetPropertyItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetPropertyItem_toString), "$equals", $rt_wrapFunction1($java.oncia_SetPropertyItem_equals), "$dup", $rt_wrapFunction1($java.oncia_SetPropertyItem_dup)]]);
    $rt_metadata([oncia_SetExactPropertiesFromMapItem, "SetExactPropertiesFromMapItem", 13, jl_Object, [$java.oncia_SetProperty, ji_Serializable], 0, 3, [0,0,0], 0, ["$expectType3", $rt_wrapFunction4($java.oncia_SetExactPropertiesFromMapItem_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_expectType$default$4), "$position2", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetExactPropertiesFromMapItem_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem_toString),
    "$equals", $rt_wrapFunction1($java.oncia_SetExactPropertiesFromMapItem_equals), "$dup", $rt_wrapFunction1($java.oncia_SetExactPropertiesFromMapItem_dup)],
    oncia_SetIncludingPropertiesFromMapItem, "SetIncludingPropertiesFromMapItem", 13, jl_Object, [$java.oncia_SetProperty, ji_Serializable], 0, 3, [0,0,0], 0, ["$expectType3", $rt_wrapFunction4($java.oncia_SetIncludingPropertiesFromMapItem_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_expectType$default$4), "$position2", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_semanticCheck),
    "$productPrefix", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetIncludingPropertiesFromMapItem_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem_toString),
    "$equals", $rt_wrapFunction1($java.oncia_SetIncludingPropertiesFromMapItem_equals), "$dup", $rt_wrapFunction1($java.oncia_SetIncludingPropertiesFromMapItem_dup)],
    oncia_SetLabelItem, "SetLabelItem", 13, jl_Object, [$java.oncia_SetItem, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_SetLabelItem_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_SetLabelItem_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_SetLabelItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SetLabelItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SetLabelItem_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SetLabelItem_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_SetLabelItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SetLabelItem_toString), "$equals", $rt_wrapFunction1($java.oncia_SetLabelItem_equals), "$dup", $rt_wrapFunction1($java.oncia_SetLabelItem_dup)],
    onciafn_Neo4jASTFactory$setLabels$lambda$_22_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$setLabels$lambda$_22_0_apply)],
    oncia_ProcedureResultItem$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncie_ProcedureOutput, "ProcedureOutput", 28, jl_Object, [oncie_SymbolicName, ji_Serializable], 0, 3, [0,0,0], 0, ["$name3", $rt_wrapFunction0($java.oncie_ProcedureOutput_name), "$position2", $rt_wrapFunction0($java.oncie_ProcedureOutput_position), "$productPrefix", $rt_wrapFunction0($java.oncie_ProcedureOutput_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ProcedureOutput_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ProcedureOutput_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ProcedureOutput_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_ProcedureOutput_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ProcedureOutput_toString), "$equals", $rt_wrapFunction1($java.oncie_ProcedureOutput_equals), "$dup", $rt_wrapFunction1($java.oncie_ProcedureOutput_dup)],
    oncia_SubqueryCall$InTransactionsParameters$, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasOrderBy$lambda$_42_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$aliasOrderBy$lambda$_42_0_apply)],
    $java.oncia_SubqueryCall$$anonfun$findTransactionalSubquery$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_SubqueryCall$$anonfun$findTransactionalSubquery$1_applyOrElse)],
    $java.jt_DecimalFormatParser, 0, jl_Object, [], 0, 0, 0, 0, 0,
    $java.sc_StringOps$$format$extension$lambda$_92_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_StringOps$$format$extension$lambda$_92_0_apply)],
    scm_HashMap$$anon$5, "HashMap$$anon$5", 44, scm_HashMap$HashMapIterator, [], 4, 3, 0, 0, ["$hashCode0", $rt_wrapFunction0($java.scm_HashMap$$anon$5_hashCode), "$extract0", $rt_wrapFunction1($java.scm_HashMap$$anon$5_extract)],
    $java.oncief_Function$, 0, jl_Object, [], 4, 3, 0, $java.oncief_Function$_$callClinit, 0,
    $java.oncie_FunctionInvocation$_init_$lambda$_34_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncie_FunctionInvocation$_init_$lambda$_34_0_apply)],
    $java.oncief_FunctionWithName, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_TypeSignatures, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncief_Function, "Function", 29, jl_Object, [$java.oncief_FunctionWithName, $java.oncie_TypeSignatures], 1, 3, [0,0,0], 0, ["$signatures2", $rt_wrapFunction0($java.oncief_Function_signatures)],
    $java.oncia_ShowTransactionsClause$_init_$lambda$_94_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowTransactionsClause$_init_$lambda$_94_0_apply)],
    $java.oncia_ShowTransactionsClause$_init_$lambda$_94_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ShowTransactionsClause$_init_$lambda$_94_1_apply)],
    $java.oncia_TerminateTransactionsClause$_init_$lambda$_91_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_TerminateTransactionsClause$_init_$lambda$_91_0_apply)],
    $java.scc_AsScalaExtensions$SetHasAsScala, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncirr_normalizeWithAndReturnClauses$$anonfun$3, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncirr_normalizeWithAndReturnClauses$$anonfun$3_applyOrElse)],
    oncirr_normalizeWithAndReturnClauses$aliasExpression$lambda$_45_0, 0, jl_Object, [onciu_RewriterStopper], 0, 3, 0, 0, ["$shouldStop", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$aliasExpression$lambda$_45_0_shouldStop)],
    $java.oncirr_rewriteShowQuery$$$anonfun$getDefaultOrderFromYieldOrCommand$1$lambda$_25_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_rewriteShowQuery$$$anonfun$getDefaultOrderFromYieldOrCommand$1$lambda$_25_0_apply)],
    $java.oncia_Union$returnVariables$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$returnVariables$lambda$_4_0_apply)],
    $java.oncirr_normalizeWithAndReturnClauses$$anonfun$aliasUnaliasedReturnItems$1$lambda$_68_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncirr_normalizeWithAndReturnClauses$$anonfun$aliasUnaliasedReturnItems$1$lambda$_68_0_apply)],
    $java.scc_JavaCollectionWrappers$MapWrapper, 0, ju_AbstractMap, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.scc_JavaCollectionWrappers$MutableMapWrapper, 0, $java.scc_JavaCollectionWrappers$MapWrapper, [], 0, 3, 0, 0, 0,
    $java.scc_JavaCollectionWrappers$JMapWrapperLike, 0, jl_Object, [scm_MapOps, sc_StrictOptimizedMapOps], 3, 3, 0, 0, 0,
    $java.scc_JavaCollectionWrappers$AbstractJMapWrapper, 0, scm_AbstractMap, [$java.scc_JavaCollectionWrappers$JMapWrapperLike, ji_Serializable], 1, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$AbstractJMapWrapper_iterator)],
    $java.scc_JavaCollectionWrappers$JMapWrapper, 0, $java.scc_JavaCollectionWrappers$AbstractJMapWrapper, [], 0, 3, 0, 0, ["$knownSize", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JMapWrapper_knownSize)],
    scm_ArrayBuilder, 0, jl_Object, [scm_ReusableBuilder, ji_Serializable], 1, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1(scm_ArrayBuilder_sizeHint), "$addAll13", $rt_wrapFunction3($java.scm_ArrayBuilder_addAll), "$addAll", $rt_wrapFunction1($java.scm_ArrayBuilder_addAll0), "$addAll0", $rt_wrapFunction1($java.scm_ArrayBuilder_addAll1)],
    scm_ArrayBuilder$ofByte, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofByte_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofByte_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofByte_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofByte_elems)],
    scm_ArrayBuilder$ofShort, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofShort_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofShort_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofShort_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofShort_elems)],
    scm_ArrayBuilder$ofChar, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofChar_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofChar_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofChar_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofChar_elems)],
    scm_ArrayBuilder$ofInt, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofInt_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofInt_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofInt_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofInt_elems)],
    scm_ArrayBuilder$ofLong, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofLong_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofLong_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofLong_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofLong_elems)],
    scm_ArrayBuilder$ofFloat, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofFloat_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofFloat_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofFloat_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofFloat_elems)],
    scm_ArrayBuilder$ofDouble, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofDouble_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofDouble_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofDouble_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofDouble_elems)],
    scm_ArrayBuilder$ofBoolean, 0, scm_ArrayBuilder, [], 0, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofBoolean_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofBoolean_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofBoolean_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofBoolean_elems)],
    scm_ArrayBuilder$ofUnit, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofUnit_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofUnit_result), "$addAll13", $rt_wrapFunction3($java.scm_ArrayBuilder$ofUnit_addAll0), "$addAll0", $rt_wrapFunction1($java.scm_ArrayBuilder$ofUnit_addAll1), "$addAll", $rt_wrapFunction1($java.scm_ArrayBuilder$ofUnit_addAll2), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofUnit_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofUnit_elems)],
    scm_ArrayBuilder$ofRef, 0, scm_ArrayBuilder, [], 4, 3, 0, 0, ["$resize", $rt_wrapFunction1($java.scm_ArrayBuilder$ofRef_resize), "$result0", $rt_wrapFunction0($java.scm_ArrayBuilder$ofRef_result), "$addOne", $rt_wrapFunction1($java.scm_ArrayBuilder$ofRef_addOne), "$elems4", $rt_wrapFunction0($java.scm_ArrayBuilder$ofRef_elems)],
    oncie_StringLiteral, "StringLiteral", 28, oncie_Expression, [oncie_Literal, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_StringLiteral_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_StringLiteral_asCanonicalStringVal), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_StringLiteral_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_StringLiteral_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_StringLiteral_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_StringLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_StringLiteral_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_StringLiteral_hashCode), "$toString", $rt_wrapFunction0($java.oncie_StringLiteral_toString), "$equals", $rt_wrapFunction1($java.oncie_StringLiteral_equals)],
    $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$2$lambda$_499_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$2$lambda$_499_0_apply)],
    oncias_SemanticAnalysisTooling$requireFeatureSupport$lambda$_69_0, "SemanticAnalysisTooling$requireFeatureSupport$lambda$_69_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$requireFeatureSupport$lambda$_69_0_apply)],
    $java.oncirr_mergeInPredicates$$$anonfun$collectInPredicates$2$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$$anonfun$collectInPredicates$2$lambda$_31_0_apply)],
    scm_Iterable$, 0, sc_IterableFactory$Delegate, [], 4, 3, 0, scm_Iterable$_$callClinit, 0,
    $java.oncia_MergeAction, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable], 3, 3, 0, 0, 0,
    $java.oncia_OnMatch, "OnMatch", 13, jl_Object, [$java.oncia_MergeAction, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_OnMatch_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_OnMatch_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_OnMatch_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_OnMatch_productArity), "$productElement", $rt_wrapFunction1($java.oncia_OnMatch_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_OnMatch_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_OnMatch_hashCode), "$toString", $rt_wrapFunction0($java.oncia_OnMatch_toString), "$equals", $rt_wrapFunction1($java.oncia_OnMatch_equals), "$dup", $rt_wrapFunction1($java.oncia_OnMatch_dup)],
    $java.oncia_OnCreate, "OnCreate", 13, jl_Object, [$java.oncia_MergeAction, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_OnCreate_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_OnCreate_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_OnCreate_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_OnCreate_productArity), "$productElement", $rt_wrapFunction1($java.oncia_OnCreate_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_OnCreate_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_OnCreate_hashCode), "$toString", $rt_wrapFunction0($java.oncia_OnCreate_toString), "$equals", $rt_wrapFunction1($java.oncia_OnCreate_equals), "$dup", $rt_wrapFunction1($java.oncia_OnCreate_dup)]]);
    $rt_metadata([$java.sm_Ordering$StringOrdering, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$String$, 0, jl_Object, [$java.sm_Ordering$StringOrdering], 0, 3, 0, 0, ["$compare", $rt_wrapFunction2($java.sm_Ordering$String$_compare)],
    oncias_Scope$dumpTree$lambda$_24_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_Scope$dumpTree$lambda$_24_0_apply)],
    oncias_Scope$dumpTree$lambda$_24_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_Scope$dumpTree$lambda$_24_1_apply)],
    $java.oncief_Abs$, "Abs$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Abs$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Abs$_name), "$productArity", $rt_wrapFunction0($java.oncief_Abs$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Abs$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Abs$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Abs$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Abs$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Abs$_signatures0)],
    $java.oncief_Acos$, "Acos$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Acos$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Acos$_name), "$productArity", $rt_wrapFunction0($java.oncief_Acos$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Acos$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Acos$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Acos$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Acos$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Acos$_signatures0)],
    $java.oncief_Asin$, "Asin$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Asin$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Asin$_name), "$productArity", $rt_wrapFunction0($java.oncief_Asin$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Asin$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Asin$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Asin$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Asin$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Asin$_signatures0)],
    $java.oncief_Atan$, "Atan$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Atan$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Atan$_name), "$productArity", $rt_wrapFunction0($java.oncief_Atan$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Atan$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Atan$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Atan$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Atan$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Atan$_signatures0)],
    $java.oncief_Atan2$, "Atan2$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Atan2$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Atan2$_name), "$productArity", $rt_wrapFunction0($java.oncief_Atan2$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Atan2$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Atan2$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Atan2$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Atan2$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Atan2$_signatures0)],
    $java.oncief_AggregatingFunction, 0, $java.oncief_Function, [], 1, 3, 0, 0, 0,
    $java.oncief_Avg$, "Avg$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Avg$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Avg$_name), "$productArity", $rt_wrapFunction0($java.oncief_Avg$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Avg$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Avg$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Avg$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Avg$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Avg$_signatures0)],
    $java.oncief_Ceil$, "Ceil$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Ceil$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Ceil$_name), "$productArity", $rt_wrapFunction0($java.oncief_Ceil$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Ceil$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Ceil$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Ceil$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Ceil$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Ceil$_signatures0)],
    $java.oncief_CharLength$, "CharLength$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_CharLength$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_CharLength$_name), "$productArity", $rt_wrapFunction0($java.oncief_CharLength$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_CharLength$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_CharLength$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_CharLength$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_CharLength$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_CharLength$_signatures0)],
    $java.oncief_CharacterLength$, "CharacterLength$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_CharacterLength$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_CharacterLength$_name), "$productArity", $rt_wrapFunction0($java.oncief_CharacterLength$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_CharacterLength$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_CharacterLength$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_CharacterLength$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_CharacterLength$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_CharacterLength$_signatures0)],
    $java.oncief_Coalesce$, "Coalesce$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Coalesce$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Coalesce$_name), "$productArity", $rt_wrapFunction0($java.oncief_Coalesce$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Coalesce$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Coalesce$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Coalesce$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Coalesce$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Coalesce$_signatures0)],
    $java.oncief_Collect$, "Collect$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Collect$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Collect$_name), "$productArity", $rt_wrapFunction0($java.oncief_Collect$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Collect$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Collect$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Collect$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Collect$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Collect$_signatures0)],
    $java.oncief_Cos$, "Cos$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Cos$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Cos$_name), "$productArity", $rt_wrapFunction0($java.oncief_Cos$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Cos$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Cos$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Cos$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Cos$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Cos$_signatures0)],
    $java.oncief_Cot$, "Cot$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Cot$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Cot$_name), "$productArity", $rt_wrapFunction0($java.oncief_Cot$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Cot$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Cot$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Cot$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Cot$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Cot$_signatures0)],
    $java.oncief_Count$, "Count$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Count$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Count$_name), "$productArity", $rt_wrapFunction0($java.oncief_Count$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Count$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Count$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Count$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Count$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Count$_signatures0)],
    $java.oncief_Degrees$, "Degrees$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Degrees$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Degrees$_name), "$productArity", $rt_wrapFunction0($java.oncief_Degrees$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Degrees$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Degrees$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Degrees$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Degrees$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Degrees$_signatures0)],
    $java.oncief_Distance$, "Distance$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Distance$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Distance$_name0), "$productArity", $rt_wrapFunction0($java.oncief_Distance$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Distance$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Distance$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Distance$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Distance$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Distance$_signatures0)],
    $java.oncief_E$, "E$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_E$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_E$_name), "$productArity", $rt_wrapFunction0($java.oncief_E$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_E$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_E$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_E$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_E$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_E$_signatures0)],
    $java.oncief_ElementId$, "ElementId$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ElementId$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ElementId$_name), "$productArity", $rt_wrapFunction0($java.oncief_ElementId$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ElementId$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ElementId$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ElementId$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_ElementId$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ElementId$_signatures0)],
    $java.oncief_EndNode$, "EndNode$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_EndNode$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_EndNode$_name), "$productArity", $rt_wrapFunction0($java.oncief_EndNode$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_EndNode$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_EndNode$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_EndNode$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_EndNode$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_EndNode$_signatures0)],
    $java.oncief_Exists$, "Exists$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Exists$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Exists$_name), "$productArity", $rt_wrapFunction0($java.oncief_Exists$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Exists$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Exists$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Exists$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Exists$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Exists$_signatures0)],
    $java.oncief_Exp$, "Exp$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Exp$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Exp$_name), "$productArity", $rt_wrapFunction0($java.oncief_Exp$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Exp$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Exp$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Exp$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Exp$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Exp$_signatures0)],
    $java.oncief_File$, "File$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_File$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_File$_name), "$productArity", $rt_wrapFunction0($java.oncief_File$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_File$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_File$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_File$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_File$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_File$_signatures0)],
    $java.oncief_Floor$, "Floor$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Floor$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Floor$_name), "$productArity", $rt_wrapFunction0($java.oncief_Floor$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Floor$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Floor$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Floor$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Floor$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Floor$_signatures0)],
    $java.oncief_Haversin$, "Haversin$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Haversin$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Haversin$_name), "$productArity", $rt_wrapFunction0($java.oncief_Haversin$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Haversin$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Haversin$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Haversin$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Haversin$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Haversin$_signatures0)],
    $java.oncief_Head$, "Head$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Head$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Head$_name0), "$productArity", $rt_wrapFunction0($java.oncief_Head$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Head$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Head$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Head$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Head$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Head$_signatures0)],
    $java.oncief_Id$, "Id$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Id$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Id$_name), "$productArity", $rt_wrapFunction0($java.oncief_Id$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Id$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Id$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Id$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Id$_toString), "$signatures2",
    $rt_wrapFunction0($java.oncief_Id$_signatures0)],
    $java.oncief_IsEmpty$, "IsEmpty$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_IsEmpty$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_IsEmpty$_name0), "$productArity", $rt_wrapFunction0($java.oncief_IsEmpty$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_IsEmpty$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_IsEmpty$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_IsEmpty$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_IsEmpty$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_IsEmpty$_signatures0)],
    $java.oncief_IsNaN$, "IsNaN$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_IsNaN$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_IsNaN$_name), "$productArity", $rt_wrapFunction0($java.oncief_IsNaN$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_IsNaN$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_IsNaN$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_IsNaN$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_IsNaN$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_IsNaN$_signatures0)],
    $java.oncief_Labels$, "Labels$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Labels$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Labels$_name), "$productArity", $rt_wrapFunction0($java.oncief_Labels$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Labels$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Labels$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Labels$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Labels$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Labels$_signatures0)],
    $java.oncief_Last$, "Last$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Last$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Last$_name), "$productArity", $rt_wrapFunction0($java.oncief_Last$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Last$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Last$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Last$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Last$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Last$_signatures0)],
    $java.oncief_Left$, "Left$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Left$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Left$_name), "$productArity", $rt_wrapFunction0($java.oncief_Left$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Left$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Left$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Left$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Left$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Left$_signatures0)],
    $java.oncief_Length$, "Length$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Length$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Length$_name), "$productArity", $rt_wrapFunction0($java.oncief_Length$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Length$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Length$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Length$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Length$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Length$_signatures0)],
    $java.oncief_Linenumber$, "Linenumber$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Linenumber$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Linenumber$_name), "$productArity", $rt_wrapFunction0($java.oncief_Linenumber$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Linenumber$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Linenumber$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Linenumber$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_Linenumber$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_Linenumber$_signatures0)],
    $java.oncief_Log$, "Log$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Log$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Log$_name), "$productArity", $rt_wrapFunction0($java.oncief_Log$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Log$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Log$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Log$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Log$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Log$_signatures0)],
    $java.oncief_Log10$, "Log10$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Log10$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Log10$_name), "$productArity", $rt_wrapFunction0($java.oncief_Log10$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Log10$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Log10$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Log10$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Log10$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Log10$_signatures0)],
    $java.oncief_LTrim$, "LTrim$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_LTrim$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_LTrim$_name), "$productArity", $rt_wrapFunction0($java.oncief_LTrim$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_LTrim$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_LTrim$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_LTrim$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_LTrim$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_LTrim$_signatures0)],
    $java.oncief_Max$, "Max$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Max$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Max$_name), "$productArity", $rt_wrapFunction0($java.oncief_Max$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Max$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Max$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Max$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Max$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Max$_signatures0)],
    $java.oncief_Min$, "Min$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Min$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Min$_name), "$productArity", $rt_wrapFunction0($java.oncief_Min$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Min$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Min$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Min$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Min$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Min$_signatures0)],
    $java.oncief_Nodes$, "Nodes$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Nodes$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Nodes$_name), "$productArity", $rt_wrapFunction0($java.oncief_Nodes$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Nodes$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Nodes$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Nodes$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Nodes$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Nodes$_signatures0)],
    $java.oncief_Pi$, "Pi$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Pi$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Pi$_name), "$productArity", $rt_wrapFunction0($java.oncief_Pi$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Pi$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Pi$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Pi$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Pi$_toString), "$signatures2",
    $rt_wrapFunction0($java.oncief_Pi$_signatures0)],
    $java.oncief_PercentileCont$, "PercentileCont$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_PercentileCont$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_PercentileCont$_name), "$productArity", $rt_wrapFunction0($java.oncief_PercentileCont$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_PercentileCont$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_PercentileCont$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_PercentileCont$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_PercentileCont$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_PercentileCont$_signatures0)],
    $java.oncief_PercentileDisc$, "PercentileDisc$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_PercentileDisc$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_PercentileDisc$_name), "$productArity", $rt_wrapFunction0($java.oncief_PercentileDisc$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_PercentileDisc$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_PercentileDisc$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_PercentileDisc$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_PercentileDisc$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_PercentileDisc$_signatures0)],
    $java.oncief_Point$, "Point$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Point$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Point$_name), "$productArity", $rt_wrapFunction0($java.oncief_Point$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Point$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Point$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Point$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Point$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Point$_signatures0)],
    $java.oncief_Keys$, "Keys$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Keys$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Keys$_name), "$productArity", $rt_wrapFunction0($java.oncief_Keys$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Keys$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Keys$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Keys$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Keys$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Keys$_signatures0)],
    $java.oncief_Radians$, "Radians$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Radians$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Radians$_name), "$productArity", $rt_wrapFunction0($java.oncief_Radians$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Radians$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Radians$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Radians$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Radians$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Radians$_signatures0)]]);
    $rt_metadata([$java.oncief_Rand$, "Rand$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Rand$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Rand$_name0), "$productArity", $rt_wrapFunction0($java.oncief_Rand$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Rand$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Rand$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Rand$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Rand$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Rand$_signatures0)],
    $java.oncief_RandomUUID$, "RandomUUID$", 29, $java.oncief_Function, [], 4, 3, 0, $java.oncief_RandomUUID$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_RandomUUID$_name), "$signatures2", $rt_wrapFunction0($java.oncief_RandomUUID$_signatures0)],
    $java.oncief_Range$, "Range$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Range$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Range$_name), "$productArity", $rt_wrapFunction0($java.oncief_Range$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Range$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Range$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Range$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Range$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Range$_signatures0)],
    $java.oncief_Reduce$, "Reduce$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Reduce$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Reduce$_name), "$productArity", $rt_wrapFunction0($java.oncief_Reduce$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Reduce$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Reduce$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Reduce$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Reduce$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Reduce$_signatures0)],
    $java.oncief_Relationships$, "Relationships$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Relationships$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Relationships$_name), "$productArity", $rt_wrapFunction0($java.oncief_Relationships$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Relationships$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Relationships$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Relationships$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_Relationships$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_Relationships$_signatures0)],
    $java.oncief_Replace$, "Replace$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Replace$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Replace$_name), "$productArity", $rt_wrapFunction0($java.oncief_Replace$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Replace$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Replace$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Replace$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Replace$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Replace$_signatures0)],
    $java.oncief_Reverse$, "Reverse$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Reverse$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Reverse$_name), "$productArity", $rt_wrapFunction0($java.oncief_Reverse$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Reverse$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Reverse$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Reverse$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Reverse$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Reverse$_signatures0)],
    $java.oncief_Right$, "Right$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Right$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Right$_name), "$productArity", $rt_wrapFunction0($java.oncief_Right$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Right$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Right$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Right$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Right$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Right$_signatures0)],
    $java.oncief_Round$, "Round$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Round$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Round$_name), "$productArity", $rt_wrapFunction0($java.oncief_Round$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Round$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Round$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Round$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Round$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Round$_signatures0)],
    $java.oncief_RTrim$, "RTrim$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_RTrim$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_RTrim$_name), "$productArity", $rt_wrapFunction0($java.oncief_RTrim$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_RTrim$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_RTrim$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_RTrim$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_RTrim$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_RTrim$_signatures0)],
    $java.oncief_Sign$, "Sign$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Sign$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Sign$_name), "$productArity", $rt_wrapFunction0($java.oncief_Sign$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Sign$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Sign$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Sign$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Sign$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Sign$_signatures0)],
    $java.oncief_Sin$, "Sin$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Sin$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Sin$_name), "$productArity", $rt_wrapFunction0($java.oncief_Sin$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Sin$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Sin$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Sin$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Sin$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Sin$_signatures0)],
    $java.oncief_Size$, "Size$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Size$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Size$_name), "$productArity", $rt_wrapFunction0($java.oncief_Size$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Size$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Size$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Size$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Size$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Size$_signatures0)],
    $java.oncief_Sqrt$, "Sqrt$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Sqrt$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Sqrt$_name), "$productArity", $rt_wrapFunction0($java.oncief_Sqrt$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Sqrt$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Sqrt$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Sqrt$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Sqrt$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Sqrt$_signatures0)],
    $java.oncief_Split$, "Split$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Split$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Split$_name), "$productArity", $rt_wrapFunction0($java.oncief_Split$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Split$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Split$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Split$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Split$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Split$_signatures0)],
    $java.oncief_StartNode$, "StartNode$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_StartNode$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_StartNode$_name), "$productArity", $rt_wrapFunction0($java.oncief_StartNode$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_StartNode$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_StartNode$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_StartNode$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_StartNode$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_StartNode$_signatures0)],
    $java.oncief_StdDev$, "StdDev$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_StdDev$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_StdDev$_name), "$productArity", $rt_wrapFunction0($java.oncief_StdDev$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_StdDev$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_StdDev$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_StdDev$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_StdDev$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_StdDev$_signatures0)],
    $java.oncief_StdDevP$, "StdDevP$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_StdDevP$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_StdDevP$_name), "$productArity", $rt_wrapFunction0($java.oncief_StdDevP$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_StdDevP$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_StdDevP$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_StdDevP$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_StdDevP$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_StdDevP$_signatures0)],
    $java.oncief_Substring$, "Substring$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Substring$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Substring$_name), "$productArity", $rt_wrapFunction0($java.oncief_Substring$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Substring$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Substring$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Substring$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_Substring$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_Substring$_signatures0)],
    $java.oncief_Sum$, "Sum$", 29, $java.oncief_AggregatingFunction, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Sum$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Sum$_name), "$productArity", $rt_wrapFunction0($java.oncief_Sum$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Sum$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Sum$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Sum$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Sum$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Sum$_signatures0)],
    $java.oncief_Tail$, "Tail$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Tail$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Tail$_name), "$productArity", $rt_wrapFunction0($java.oncief_Tail$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Tail$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Tail$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Tail$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Tail$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Tail$_signatures0)],
    $java.oncief_Tan$, "Tan$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Tan$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Tan$_name), "$productArity", $rt_wrapFunction0($java.oncief_Tan$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Tan$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Tan$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Tan$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Tan$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Tan$_signatures0)],
    $java.oncief_ToBoolean$, "ToBoolean$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToBoolean$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToBoolean$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToBoolean$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToBoolean$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToBoolean$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToBoolean$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_ToBoolean$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToBoolean$_signatures0)],
    $java.oncief_ToBooleanList$, "ToBooleanList$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToBooleanList$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToBooleanList$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToBooleanList$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToBooleanList$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToBooleanList$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToBooleanList$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToBooleanList$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToBooleanList$_signatures0)],
    $java.oncief_ToBooleanOrNull$, "ToBooleanOrNull$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToBooleanOrNull$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToBooleanOrNull$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToBooleanOrNull$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToBooleanOrNull$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToBooleanOrNull$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToBooleanOrNull$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToBooleanOrNull$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToBooleanOrNull$_signatures0)],
    $java.oncief_ToFloat$, "ToFloat$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToFloat$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToFloat$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToFloat$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToFloat$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToFloat$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToFloat$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_ToFloat$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_ToFloat$_signatures0)],
    $java.oncief_ToFloatList$, "ToFloatList$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToFloatList$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToFloatList$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToFloatList$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToFloatList$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToFloatList$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToFloatList$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToFloatList$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToFloatList$_signatures0)],
    $java.oncief_ToFloatOrNull$, "ToFloatOrNull$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToFloatOrNull$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToFloatOrNull$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToFloatOrNull$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToFloatOrNull$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToFloatOrNull$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToFloatOrNull$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToFloatOrNull$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToFloatOrNull$_signatures0)],
    $java.oncief_ToInteger$, "ToInteger$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToInteger$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToInteger$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToInteger$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToInteger$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToInteger$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToInteger$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_ToInteger$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToInteger$_signatures0)],
    $java.oncief_ToIntegerList$, "ToIntegerList$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToIntegerList$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToIntegerList$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToIntegerList$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToIntegerList$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToIntegerList$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToIntegerList$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToIntegerList$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToIntegerList$_signatures0)],
    $java.oncief_ToIntegerOrNull$, "ToIntegerOrNull$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToIntegerOrNull$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToIntegerOrNull$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToIntegerOrNull$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToIntegerOrNull$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToIntegerOrNull$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToIntegerOrNull$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToIntegerOrNull$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToIntegerOrNull$_signatures0)],
    $java.oncief_ToLower$, "ToLower$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToLower$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToLower$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToLower$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToLower$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToLower$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToLower$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_ToLower$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_ToLower$_signatures0)],
    $java.oncief_ToString$, "ToString$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToString$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToString$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToString$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToString$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToString$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToString$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_ToString$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_ToString$_signatures0)],
    $java.oncief_ToStringList$, "ToStringList$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToStringList$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToStringList$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToStringList$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToStringList$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToStringList$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToStringList$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToStringList$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToStringList$_signatures0)],
    $java.oncief_ToStringOrNull$, "ToStringOrNull$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToStringOrNull$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToStringOrNull$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToStringOrNull$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToStringOrNull$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToStringOrNull$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToStringOrNull$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_ToStringOrNull$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ToStringOrNull$_signatures0)],
    $java.oncief_ToUpper$, "ToUpper$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ToUpper$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ToUpper$_name), "$productArity", $rt_wrapFunction0($java.oncief_ToUpper$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ToUpper$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ToUpper$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ToUpper$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_ToUpper$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_ToUpper$_signatures0)],
    $java.oncief_Properties$, "Properties$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Properties$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Properties$_name), "$productArity", $rt_wrapFunction0($java.oncief_Properties$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Properties$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Properties$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Properties$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_Properties$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_Properties$_signatures0)],
    $java.oncief_Trim$, "Trim$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Trim$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Trim$_name), "$productArity", $rt_wrapFunction0($java.oncief_Trim$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Trim$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Trim$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Trim$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Trim$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Trim$_signatures0)],
    $java.oncief_Type$, "Type$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_Type$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_Type$_name), "$productArity", $rt_wrapFunction0($java.oncief_Type$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_Type$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_Type$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_Type$_hashCode), "$toString", $rt_wrapFunction0($java.oncief_Type$_toString),
    "$signatures2", $rt_wrapFunction0($java.oncief_Type$_signatures0)],
    $java.oncief_ValueType$, "ValueType$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_ValueType$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_ValueType$_name), "$productArity", $rt_wrapFunction0($java.oncief_ValueType$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_ValueType$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_ValueType$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_ValueType$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_ValueType$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_ValueType$_signatures0)],
    $java.oncief_WithinBBox$, "WithinBBox$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, $java.oncief_WithinBBox$_$callClinit, ["$name3", $rt_wrapFunction0($java.oncief_WithinBBox$_name0), "$productArity", $rt_wrapFunction0($java.oncief_WithinBBox$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_WithinBBox$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_WithinBBox$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_WithinBBox$_hashCode), "$toString",
    $rt_wrapFunction0($java.oncief_WithinBBox$_toString), "$signatures2", $rt_wrapFunction0($java.oncief_WithinBBox$_signatures0)],
    $java.oncie_FunctionTypeSignature, "FunctionTypeSignature", 28, jl_Object, [$java.oncie_TypeSignature, s_Product, ji_Serializable], 0, 3, [0,0,0], 0, ["$outputType1", $rt_wrapFunction0($java.oncie_FunctionTypeSignature_outputType), "$argumentTypes1", $rt_wrapFunction0($java.oncie_FunctionTypeSignature_argumentTypes), "$removeFirstArgumentType", $rt_wrapFunction0($java.oncie_FunctionTypeSignature_removeFirstArgumentType), "$productPrefix", $rt_wrapFunction0($java.oncie_FunctionTypeSignature_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncie_FunctionTypeSignature_productArity), "$productElement", $rt_wrapFunction1($java.oncie_FunctionTypeSignature_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_FunctionTypeSignature_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_FunctionTypeSignature_hashCode), "$toString", $rt_wrapFunction0($java.oncie_FunctionTypeSignature_toString), "$equals", $rt_wrapFunction1($java.oncie_FunctionTypeSignature_equals)],
    s_Enumeration, "Enumeration", 38, jl_Object, [ji_Serializable], 1, 3, 0, 0, 0,
    oncief_Category$, 0, s_Enumeration, [], 4, 3, 0, 0, 0,
    $java.s_Function9, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.sr_AbstractFunction9, 0, jl_Object, [$java.s_Function9], 1, 3, 0, 0, 0,
    oncie_FunctionTypeSignature$, 0, $java.sr_AbstractFunction9, [ji_Serializable], 4, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_211, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_214, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_215, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$3_216, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_217, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_218, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_219, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_221, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_222, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_223, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_224, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_225, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_226, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_227, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_228, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_229, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_230, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_231, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_232, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_233, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_234, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_235, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_236, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_237, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_238, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_239, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_240, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_241, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_242, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_243, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_249, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_251, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_254, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_255, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_256, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_257, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_259, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_290, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.ju_TemplateCollections$ImmutableArrayList, 0, ju_TemplateCollections$AbstractImmutableList, [ju_RandomAccess], 0, 3, 0, 0, ["$get", $rt_wrapFunction1($java.ju_TemplateCollections$ImmutableArrayList_get), "$size", $rt_wrapFunction0($java.ju_TemplateCollections$ImmutableArrayList_size)],
    $java.s_PartialFunction$Combined$applyOrElse$lambda$_36_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncil_LabelExpression, "LabelExpression", 27, jl_Object, [onciu_ASTNode], 3, 3, [0,0,0], 0, 0,
    oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_0_apply)],
    oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_1, "ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_1", 31, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_1_apply)],
    oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_2_apply)],
    oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_3, "ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_3", 31, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_3_apply)],
    oncil_LabelExpressionPredicate, "LabelExpressionPredicate", 27, oncie_Expression, [$java.oncie_BooleanExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncil_LabelExpressionPredicate_position), "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpressionPredicate_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpressionPredicate_productArity), "$productElement", $rt_wrapFunction1($java.oncil_LabelExpressionPredicate_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncil_LabelExpressionPredicate_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpressionPredicate_hashCode), "$toString", $rt_wrapFunction0($java.oncil_LabelExpressionPredicate_toString), "$equals", $rt_wrapFunction1($java.oncil_LabelExpressionPredicate_equals)],
    oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_4_apply)],
    oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_5, "ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_5", 31, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ValidSymbolicNamesInLabelExpressions$$anonfun$apply$1$applyOrElse$lambda$_0_5_apply)],
    $java.oncie_LeftUnaryOperatorExpression, 0, jl_Object, [$java.oncie_OperatorExpression], 3, 3, 0, 0, 0,
    oncie_Not, "Not", 28, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_LeftUnaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Not_asCanonicalStringVal), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Not_canonicalOperatorSymbol), "$rhs0", $rt_wrapFunction0(oncie_Not_rhs), "$position2", $rt_wrapFunction0($java.oncie_Not_position), "$productPrefix", $rt_wrapFunction0($java.oncie_Not_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Not_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_Not_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Not_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Not_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Not_toString), "$equals", $rt_wrapFunction1($java.oncie_Not_equals)],
    oncirc_containsNoMatchingNodes$$anonfun$apply$1$applyOrElse$lambda$_0_0, "containsNoMatchingNodes$$anonfun$apply$1$applyOrElse$lambda$_0_0", 26, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirc_containsNoMatchingNodes$$anonfun$apply$1$applyOrElse$lambda$_0_0_apply)],
    oncifp_AmbiguousAggregationAnalysis$$anonfun$1$applyOrElse$lambda$_0_0, "AmbiguousAggregationAnalysis$$anonfun$1$applyOrElse$lambda$_0_0", 31, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_AmbiguousAggregationAnalysis$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_0_apply)]]);
    $rt_metadata([$java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_1_apply)],
    $java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_DefaultOrAllShowColumns$$apply$lambda$_1_2_apply)],
    oncia_NamespacedName, "NamespacedName", 13, jl_Object, [$java.oncia_DatabaseName, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_NamespacedName_position), "$toString", $rt_wrapFunction0(oncia_NamespacedName_toString), "$productPrefix", $rt_wrapFunction0($java.oncia_NamespacedName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_NamespacedName_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NamespacedName_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NamespacedName_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_NamespacedName_hashCode), "$equals", $rt_wrapFunction1($java.oncia_NamespacedName_equals), "$dup", $rt_wrapFunction1($java.oncia_NamespacedName_dup)],
    $java.jl_VirtualMachineError, 0, jl_Error, [], 0, 3, 0, 0, 0,
    jl_InternalError, 0, $java.jl_VirtualMachineError, [], 0, 3, 0, 0, 0,
    oncia_UsingJoinHint, "UsingJoinHint", 13, jl_Object, [$java.oncia_UsingHint, $java.oncia_NodeHint, ji_Serializable], 0, 3, [0,0,0], 0, ["$expectType3", $rt_wrapFunction4($java.oncia_UsingJoinHint_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_UsingJoinHint_expectType$default$4), "$position2", $rt_wrapFunction0($java.oncia_UsingJoinHint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_UsingJoinHint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_UsingJoinHint_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_UsingJoinHint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UsingJoinHint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UsingJoinHint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UsingJoinHint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UsingJoinHint_toString), "$equals", $rt_wrapFunction1($java.oncia_UsingJoinHint_equals), "$dup", $rt_wrapFunction1($java.oncia_UsingJoinHint_dup)],
    onciu_NonEmptyList$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncia_UsingJoinHint$$apply$lambda$_1_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UsingJoinHint$$apply$lambda$_1_0_apply)],
    $java.onciu_NonEmptyList, 0, jl_Object, [sc_IterableOnce], 3, 3, 0, 0, 0,
    oncia_ProcedureResultItem, "ProcedureResultItem", 13, jl_Object, [onciu_ASTNode, oncias_SemanticAnalysisTooling, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_ProcedureResultItem_position), "$productPrefix", $rt_wrapFunction0($java.oncia_ProcedureResultItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ProcedureResultItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ProcedureResultItem_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ProcedureResultItem_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_ProcedureResultItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ProcedureResultItem_toString), "$equals", $rt_wrapFunction1($java.oncia_ProcedureResultItem_equals), "$dup", $rt_wrapFunction1($java.oncia_ProcedureResultItem_dup)],
    $java.oncie_StringLiteral$$anon$6, "StringLiteral$$anon$6", 28, oncie_StringLiteral, [oncie_SensitiveLiteral], 4, 3, [oncie_StringLiteral,0,0], 0, 0,
    s_DummyImplicit$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncia_AliasDriverSettingsCheck$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncia_ExistsExpression, "ExistsExpression", 13, oncie_Expression, [oncia_FullSubqueryExpression, $java.oncie_BooleanExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$introducedVariables2", $rt_wrapFunction0($java.oncia_ExistsExpression_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncia_ExistsExpression_scopeDependencies), "$dependencies0", $rt_wrapFunction0($java.oncia_ExistsExpression_dependencies), "$query1", $rt_wrapFunction0(oncia_ExistsExpression_query), "$position2", $rt_wrapFunction0($java.oncia_ExistsExpression_position),
    "$computedIntroducedVariables", $rt_wrapFunction0($java.oncia_ExistsExpression_computedIntroducedVariables), "$computedScopeDependencies", $rt_wrapFunction0($java.oncia_ExistsExpression_computedScopeDependencies), "$withQuery", $rt_wrapFunction1($java.oncia_ExistsExpression_withQuery), "$withComputedIntroducedVariables", $rt_wrapFunction1($java.oncia_ExistsExpression_withComputedIntroducedVariables), "$withComputedScopeDependencies", $rt_wrapFunction1($java.oncia_ExistsExpression_withComputedScopeDependencies),
    "$subqueryAstNode", $rt_wrapFunction0($java.oncia_ExistsExpression_subqueryAstNode), "$productPrefix", $rt_wrapFunction0($java.oncia_ExistsExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ExistsExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ExistsExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ExistsExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ExistsExpression_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ExistsExpression_toString),
    "$equals", $rt_wrapFunction1($java.oncia_ExistsExpression_equals), "$dup", $rt_wrapFunction1($java.oncia_ExistsExpression_dup0), "$dup0", $rt_wrapFunction1($java.oncia_ExistsExpression_dup1)],
    oncia_CountExpression, "CountExpression", 13, oncie_Expression, [oncia_FullSubqueryExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$introducedVariables2", $rt_wrapFunction0($java.oncia_CountExpression_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncia_CountExpression_scopeDependencies), "$dependencies0", $rt_wrapFunction0($java.oncia_CountExpression_dependencies), "$query1", $rt_wrapFunction0(oncia_CountExpression_query), "$position2", $rt_wrapFunction0($java.oncia_CountExpression_position),
    "$computedIntroducedVariables", $rt_wrapFunction0($java.oncia_CountExpression_computedIntroducedVariables), "$computedScopeDependencies", $rt_wrapFunction0($java.oncia_CountExpression_computedScopeDependencies), "$withQuery", $rt_wrapFunction1($java.oncia_CountExpression_withQuery), "$withComputedIntroducedVariables", $rt_wrapFunction1($java.oncia_CountExpression_withComputedIntroducedVariables), "$withComputedScopeDependencies", $rt_wrapFunction1($java.oncia_CountExpression_withComputedScopeDependencies), "$subqueryAstNode",
    $rt_wrapFunction0($java.oncia_CountExpression_subqueryAstNode), "$productPrefix", $rt_wrapFunction0($java.oncia_CountExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CountExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CountExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CountExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CountExpression_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CountExpression_toString),
    "$equals", $rt_wrapFunction1($java.oncia_CountExpression_equals), "$dup", $rt_wrapFunction1($java.oncia_CountExpression_dup0), "$dup0", $rt_wrapFunction1($java.oncia_CountExpression_dup1)],
    oncia_CollectExpression, "CollectExpression", 13, oncie_Expression, [oncia_FullSubqueryExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$introducedVariables2", $rt_wrapFunction0($java.oncia_CollectExpression_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncia_CollectExpression_scopeDependencies), "$dependencies0", $rt_wrapFunction0($java.oncia_CollectExpression_dependencies), "$query1", $rt_wrapFunction0(oncia_CollectExpression_query), "$position2", $rt_wrapFunction0($java.oncia_CollectExpression_position),
    "$computedIntroducedVariables", $rt_wrapFunction0($java.oncia_CollectExpression_computedIntroducedVariables), "$computedScopeDependencies", $rt_wrapFunction0($java.oncia_CollectExpression_computedScopeDependencies), "$withQuery", $rt_wrapFunction1($java.oncia_CollectExpression_withQuery), "$withComputedIntroducedVariables", $rt_wrapFunction1($java.oncia_CollectExpression_withComputedIntroducedVariables), "$withComputedScopeDependencies", $rt_wrapFunction1($java.oncia_CollectExpression_withComputedScopeDependencies),
    "$subqueryAstNode", $rt_wrapFunction0($java.oncia_CollectExpression_subqueryAstNode), "$productPrefix", $rt_wrapFunction0($java.oncia_CollectExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CollectExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CollectExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CollectExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CollectExpression_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CollectExpression_toString),
    "$equals", $rt_wrapFunction1($java.oncia_CollectExpression_equals), "$dup", $rt_wrapFunction1($java.oncia_CollectExpression_dup0), "$dup0", $rt_wrapFunction1($java.oncia_CollectExpression_dup1)],
    $java.oncia_UnresolvedCall$returnVariables$lambda$_14_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnresolvedCall$returnVariables$lambda$_14_0_apply)],
    $java.oncia_UnresolvedCall$returnVariables$lambda$_14_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UnresolvedCall$returnVariables$lambda$_14_1_apply)],
    sci_Vector$filterImpl$lambda$_70_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Vector$filterImpl$lambda$_70_0_apply)],
    sci_Vector$filterImpl$lambda$_70_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Vector$filterImpl$lambda$_70_1_apply)],
    $java.sci_Map$Map3, "Map$Map3", 43, sci_AbstractMap, [sc_StrictOptimizedIterableOps, ji_Serializable], 0, 3, 0, 0, ["$map1", $rt_wrapFunction1($java.sci_Map$Map3_map), "$flatMap", $rt_wrapFunction1($java.sci_Map$Map3_flatMap), "$collect0", $rt_wrapFunction1($java.sci_Map$Map3_collect), "$flatten", $rt_wrapFunction1($java.sci_Map$Map3_flatten), "$filter1", $rt_wrapFunction1($java.sci_Map$Map3_filter), "$filterNot1", $rt_wrapFunction1($java.sci_Map$Map3_filterNot), "$size", $rt_wrapFunction0($java.sci_Map$Map3_size),
    "$knownSize", $rt_wrapFunction0($java.sci_Map$Map3_knownSize), "$isEmpty", $rt_wrapFunction0($java.sci_Map$Map3_isEmpty), "$apply", $rt_wrapFunction1($java.sci_Map$Map3_apply), "$contains0", $rt_wrapFunction1($java.sci_Map$Map3_contains), "$get1", $rt_wrapFunction1($java.sci_Map$Map3_get), "$getOrElse0", $rt_wrapFunction2($java.sci_Map$Map3_getOrElse), "$iterator0", $rt_wrapFunction0($java.sci_Map$Map3_iterator), "$keysIterator", $rt_wrapFunction0($java.sci_Map$Map3_keysIterator), "$valuesIterator", $rt_wrapFunction0($java.sci_Map$Map3_valuesIterator),
    "$foreach", $rt_wrapFunction1($java.sci_Map$Map3_foreach), "$exists", $rt_wrapFunction1($java.sci_Map$Map3_exists), "$forall", $rt_wrapFunction1($java.sci_Map$Map3_forall), "$hashCode0", $rt_wrapFunction0($java.sci_Map$Map3_hashCode), "$filterImpl", $rt_wrapFunction2($java.sci_Map$Map3_filterImpl), "$removed", $rt_wrapFunction1($java.sci_Map$Map3_removed), "$updated1", $rt_wrapFunction2($java.sci_Map$Map3_updated)],
    oncias_Scope$allScopes$lambda$_20_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_Scope$allScopes$lambda$_20_0_apply)],
    sc_ArrayOps$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    jnc_CharacterCodingException, 0, ji_IOException, [], 0, 3, 0, 0, 0,
    oncia_DatabasePrivilege, "DatabasePrivilege", 13, oncia_PrivilegeType, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_DatabasePrivilege_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DatabasePrivilege_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DatabasePrivilege_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DatabasePrivilege_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DatabasePrivilege_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_DatabasePrivilege_toString), "$equals", $rt_wrapFunction1($java.oncia_DatabasePrivilege_equals)],
    oncia_NamedDatabasesScope, "NamedDatabasesScope", 13, jl_Object, [$java.oncia_DatabaseScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_NamedDatabasesScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_NamedDatabasesScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NamedDatabasesScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NamedDatabasesScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_NamedDatabasesScope_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_NamedDatabasesScope_toString), "$equals", $rt_wrapFunction1($java.oncia_NamedDatabasesScope_equals), "$dup", $rt_wrapFunction1($java.oncia_NamedDatabasesScope_dup)],
    oncia_AllGraphsScope, "AllGraphsScope", 13, jl_Object, [$java.oncia_GraphScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_AllGraphsScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AllGraphsScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllGraphsScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllGraphsScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllGraphsScope_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_AllGraphsScope_toString), "$equals", $rt_wrapFunction1($java.oncia_AllGraphsScope_equals), "$dup", $rt_wrapFunction1($java.oncia_AllGraphsScope_dup)],
    oncia_HomeGraphScope, "HomeGraphScope", 13, jl_Object, [$java.oncia_GraphScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_HomeGraphScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_HomeGraphScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_HomeGraphScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_HomeGraphScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_HomeGraphScope_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_HomeGraphScope_toString), "$equals", $rt_wrapFunction1($java.oncia_HomeGraphScope_equals), "$dup", $rt_wrapFunction1($java.oncia_HomeGraphScope_dup)],
    oncia_DefaultGraphScope, "DefaultGraphScope", 13, jl_Object, [$java.oncia_GraphScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_DefaultGraphScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DefaultGraphScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DefaultGraphScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_DefaultGraphScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DefaultGraphScope_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_DefaultGraphScope_toString), "$equals", $rt_wrapFunction1($java.oncia_DefaultGraphScope_equals), "$dup", $rt_wrapFunction1($java.oncia_DefaultGraphScope_dup)],
    oncia_NamedGraphsScope, "NamedGraphsScope", 13, jl_Object, [$java.oncia_GraphScope, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_NamedGraphsScope_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_NamedGraphsScope_productArity), "$productElement", $rt_wrapFunction1($java.oncia_NamedGraphsScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_NamedGraphsScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_NamedGraphsScope_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_NamedGraphsScope_toString), "$equals", $rt_wrapFunction1($java.oncia_NamedGraphsScope_equals), "$dup", $rt_wrapFunction1($java.oncia_NamedGraphsScope_dup)],
    oncia_GraphPrivilege, "GraphPrivilege", 13, oncia_PrivilegeType, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_GraphPrivilege_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_GraphPrivilege_productArity), "$productElement", $rt_wrapFunction1($java.oncia_GraphPrivilege_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_GraphPrivilege_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_GraphPrivilege_hashCode), "$toString", $rt_wrapFunction0($java.oncia_GraphPrivilege_toString),
    "$equals", $rt_wrapFunction1($java.oncia_GraphPrivilege_equals)],
    oncia_LoadPrivilege, "LoadPrivilege", 13, oncia_PrivilegeType, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_LoadPrivilege_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_LoadPrivilege_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LoadPrivilege_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LoadPrivilege_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LoadPrivilege_hashCode), "$toString", $rt_wrapFunction0($java.oncia_LoadPrivilege_toString),
    "$equals", $rt_wrapFunction1($java.oncia_LoadPrivilege_equals)],
    $java.oncia_DataExchangeAction, 0, jl_Object, [$java.oncia_AdministrationAction], 3, 3, 0, 0, 0,
    oncia_LoadAction$, "LoadAction$", 13, jl_Object, [$java.oncia_DataExchangeAction, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_LoadAction$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LoadAction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LoadAction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LoadAction$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_LoadAction$_toString)],
    oncia_FileResource, "FileResource", 13, jl_Object, [$java.oncia_ActionResource, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_FileResource_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_FileResource_productArity), "$productElement", $rt_wrapFunction1($java.oncia_FileResource_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_FileResource_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_FileResource_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_FileResource_toString), "$equals", $rt_wrapFunction1($java.oncia_FileResource_equals)],
    $java.oncia_LoadPrivilegeQualifier, 0, jl_Object, [$java.oncia_PrivilegeQualifier], 3, 3, 0, 0, 0,
    oncia_LoadUrlQualifier, "LoadUrlQualifier", 13, jl_Object, [$java.oncia_LoadPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_LoadUrlQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_LoadUrlQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LoadUrlQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LoadUrlQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LoadUrlQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_LoadUrlQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_LoadUrlQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_LoadUrlQualifier_dup)],
    oncia_LoadAllQualifier, "LoadAllQualifier", 13, jl_Object, [$java.oncia_LoadPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_LoadAllQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_LoadAllQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LoadAllQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LoadAllQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LoadAllQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_LoadAllQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_LoadAllQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_LoadAllQualifier_dup)],
    oncia_LoadCidrQualifier, "LoadCidrQualifier", 13, jl_Object, [$java.oncia_LoadPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_LoadCidrQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_LoadCidrQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LoadCidrQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LoadCidrQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LoadCidrQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_LoadCidrQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_LoadCidrQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_LoadCidrQualifier_dup)],
    oncia_LabelAllQualifier, "LabelAllQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_LabelAllQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_LabelAllQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LabelAllQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LabelAllQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LabelAllQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_LabelAllQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_LabelAllQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_LabelAllQualifier_dup)],
    oncia_ElementsAllQualifier, "ElementsAllQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ElementsAllQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ElementsAllQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ElementsAllQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ElementsAllQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ElementsAllQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ElementsAllQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_ElementsAllQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_ElementsAllQualifier_dup)],
    $java.oncia_SortItem, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable], 3, 3, 0, 0, 0,
    oncia_DescSortItem, "DescSortItem", 13, jl_Object, [$java.oncia_SortItem, ji_Serializable], 0, 3, [0,0,0], 0, ["$semanticCheck", $rt_wrapFunction0($java.oncia_DescSortItem_semanticCheck), "$expression1", $rt_wrapFunction0($java.oncia_DescSortItem_expression), "$position2", $rt_wrapFunction0($java.oncia_DescSortItem_position), "$productPrefix", $rt_wrapFunction0($java.oncia_DescSortItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_DescSortItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_DescSortItem_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_DescSortItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_DescSortItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_DescSortItem_toString), "$equals", $rt_wrapFunction1($java.oncia_DescSortItem_equals), "$dup", $rt_wrapFunction1($java.oncia_DescSortItem_dup)],
    oncia_AscSortItem, "AscSortItem", 13, jl_Object, [$java.oncia_SortItem, ji_Serializable], 0, 3, [0,0,0], 0, ["$semanticCheck", $rt_wrapFunction0($java.oncia_AscSortItem_semanticCheck), "$expression1", $rt_wrapFunction0($java.oncia_AscSortItem_expression), "$position2", $rt_wrapFunction0($java.oncia_AscSortItem_position), "$productPrefix", $rt_wrapFunction0($java.oncia_AscSortItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AscSortItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AscSortItem_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_AscSortItem_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AscSortItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_AscSortItem_toString), "$equals", $rt_wrapFunction1($java.oncia_AscSortItem_equals), "$dup", $rt_wrapFunction1($java.oncia_AscSortItem_dup)],
    $java.oncie_SignedIntegerLiteral, 0, jl_Object, [$java.oncie_IntegerLiteral], 3, 3, 0, 0, 0,
    oncie_SignedDecimalIntegerLiteral, "SignedDecimalIntegerLiteral", 28, $java.oncie_DecimalIntegerLiteral, [$java.oncie_SignedIntegerLiteral, ji_Serializable], 0, 3, [0,0,0], 0, ["$stringVal1", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_stringVal), "$position2", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_position), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_productArity), "$productElement", $rt_wrapFunction1($java.oncie_SignedDecimalIntegerLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_hashCode), "$toString", $rt_wrapFunction0($java.oncie_SignedDecimalIntegerLiteral_toString), "$equals", $rt_wrapFunction1($java.oncie_SignedDecimalIntegerLiteral_equals)],
    oncia_UsingIndexHint, "UsingIndexHint", 13, jl_Object, [$java.oncia_UsingHint, $java.oncia_NodeHint, ji_Serializable], 0, 3, [0,0,0], 0, ["$expectType3", $rt_wrapFunction4($java.oncia_UsingIndexHint_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_UsingIndexHint_expectType$default$4), "$position2", $rt_wrapFunction0($java.oncia_UsingIndexHint_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_UsingIndexHint_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_UsingIndexHint_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_UsingIndexHint_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UsingIndexHint_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UsingIndexHint_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UsingIndexHint_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UsingIndexHint_toString), "$equals", $rt_wrapFunction1($java.oncia_UsingIndexHint_equals), "$dup", $rt_wrapFunction1($java.oncia_UsingIndexHint_dup)],
    onciafn_Neo4jASTFactory$usingIndexHint$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$usingIndexHint$lambda$_12_0_apply)],
    $java.oncia_UsingIndexHintSpec, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_SeekOrScan$, "SeekOrScan$", 13, jl_Object, [$java.oncia_UsingIndexHintSpec, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SeekOrScan$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SeekOrScan$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SeekOrScan$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SeekOrScan$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SeekOrScan$_toString)]]);
    $rt_metadata([oncia_SeekOnly$, "SeekOnly$", 13, jl_Object, [$java.oncia_UsingIndexHintSpec, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SeekOnly$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SeekOnly$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SeekOnly$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SeekOnly$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SeekOnly$_toString)],
    $java.oncie_PatternPart$SelectiveSelector, 0, jl_Object, [$java.oncie_PatternPart$Selector], 3, 3, 0, 0, 0,
    $java.oncie_PatternPart$CountedSelector, 0, jl_Object, [$java.oncie_PatternPart$Selector], 3, 3, 0, 0, 0,
    oncie_PatternPart$AnyShortestPath, "PatternPart$AnyShortestPath", 28, jl_Object, [$java.oncie_PatternPart$SelectiveSelector, $java.oncie_PatternPart$CountedSelector, ji_Serializable], 0, 3, [$java.oncie_PatternPart,0,"AnyShortestPath"], 0, ["$count5", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_count), "$position2", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_position), "$prettified", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_prettified), "$isBounded", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_isBounded),
    "$productPrefix", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PatternPart$AnyShortestPath_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternPart$AnyShortestPath_toString),
    "$equals", $rt_wrapFunction1($java.oncie_PatternPart$AnyShortestPath_equals), "$dup", $rt_wrapFunction1($java.oncie_PatternPart$AnyShortestPath_dup)],
    oncie_PatternPart$AllShortestPaths, "PatternPart$AllShortestPaths", 28, jl_Object, [$java.oncie_PatternPart$SelectiveSelector, ji_Serializable], 0, 3, [$java.oncie_PatternPart,0,"AllShortestPaths"], 0, ["$position2", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_position), "$prettified", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_prettified), "$isBounded", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PatternPart$AllShortestPaths_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternPart$AllShortestPaths_toString), "$equals", $rt_wrapFunction1($java.oncie_PatternPart$AllShortestPaths_equals),
    "$dup", $rt_wrapFunction1($java.oncie_PatternPart$AllShortestPaths_dup)],
    oncie_PatternPart$AnyPath, "PatternPart$AnyPath", 28, jl_Object, [$java.oncie_PatternPart$SelectiveSelector, $java.oncie_PatternPart$CountedSelector, ji_Serializable], 0, 3, [$java.oncie_PatternPart,0,"AnyPath"], 0, ["$count5", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_count), "$position2", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_position), "$prettified", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_prettified), "$isBounded", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_isBounded),
    "$productPrefix", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PatternPart$AnyPath_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternPart$AnyPath_toString), "$equals", $rt_wrapFunction1($java.oncie_PatternPart$AnyPath_equals),
    "$dup", $rt_wrapFunction1($java.oncie_PatternPart$AnyPath_dup)],
    oncie_PatternPart$AllPaths, "PatternPart$AllPaths", 28, jl_Object, [$java.oncie_PatternPart$Selector, ji_Serializable], 0, 3, [$java.oncie_PatternPart,0,"AllPaths"], 0, ["$position2", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_position), "$prettified", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_prettified), "$isBounded", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_PatternPart$AllPaths_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternPart$AllPaths_toString), "$equals", $rt_wrapFunction1($java.oncie_PatternPart$AllPaths_equals), "$dup", $rt_wrapFunction1($java.oncie_PatternPart$AllPaths_dup)],
    oncie_PatternPart$ShortestGroups, "PatternPart$ShortestGroups", 28, jl_Object, [$java.oncie_PatternPart$SelectiveSelector, $java.oncie_PatternPart$CountedSelector, ji_Serializable], 0, 3, [$java.oncie_PatternPart,0,"ShortestGroups"], 0, ["$count5", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_count), "$position2", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_position), "$prettified", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_prettified), "$isBounded", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_isBounded),
    "$productPrefix", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PatternPart$ShortestGroups_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternPart$ShortestGroups_toString),
    "$equals", $rt_wrapFunction1($java.oncie_PatternPart$ShortestGroups_equals), "$dup", $rt_wrapFunction1($java.oncie_PatternPart$ShortestGroups_dup)],
    oncie_PathPatternPart, "PathPatternPart", 28, $java.oncie_PatternPart, [oncie_AnonymousPatternPart, ji_Serializable], 0, 3, [0,0,0], 0, ["$allVariables", $rt_wrapFunction0($java.oncie_PathPatternPart_allVariables), "$element", $rt_wrapFunction0($java.oncie_PathPatternPart_element), "$position2", $rt_wrapFunction0($java.oncie_PathPatternPart_position), "$isBounded", $rt_wrapFunction0($java.oncie_PathPatternPart_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_PathPatternPart_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncie_PathPatternPart_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PathPatternPart_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PathPatternPart_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PathPatternPart_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PathPatternPart_toString), "$equals", $rt_wrapFunction1($java.oncie_PathPatternPart_equals), "$dup", $rt_wrapFunction1($java.oncie_PathPatternPart_dup0), "$dup0", $rt_wrapFunction1($java.oncie_PathPatternPart_dup1)],
    $java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$, "SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$", 13, jl_Object, [$java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorContinue$_toString)],
    oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$, "SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$", 13, jl_Object, [$java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorBreak$_toString)],
    oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$, "SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$", 13, jl_Object, [$java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsOnErrorBehaviour$OnErrorFail$_toString)],
    $java.jt_DecimalFormat$MinusField, "DecimalFormat$MinusField", 4, jl_Object, [$java.jt_DecimalFormat$FormatField], 0, 0, 0, 0, ["$equals", $rt_wrapFunction1($java.jt_DecimalFormat$MinusField_equals), "$hashCode0", $rt_wrapFunction0($java.jt_DecimalFormat$MinusField_hashCode)],
    sci_ListSet$Node, "ListSet$Node", 43, sci_ListSet, [], 0, 3, 0, 0, ["$elem7", $rt_wrapFunction0($java.sci_ListSet$Node_elem), "$size", $rt_wrapFunction0($java.sci_ListSet$Node_size), "$knownSize", $rt_wrapFunction0($java.sci_ListSet$Node_knownSize), "$isEmpty", $rt_wrapFunction0($java.sci_ListSet$Node_isEmpty), "$contains0", $rt_wrapFunction1($java.sci_ListSet$Node_contains), "$incl1", $rt_wrapFunction1($java.sci_ListSet$Node_incl), "$excl1", $rt_wrapFunction1($java.sci_ListSet$Node_excl), "$next7", $rt_wrapFunction0($java.sci_ListSet$Node_next),
    "$last", $rt_wrapFunction0($java.sci_ListSet$Node_last), "$init1", $rt_wrapFunction0($java.sci_ListSet$Node_init), "$excl", $rt_wrapFunction1($java.sci_ListSet$Node_excl0), "$incl", $rt_wrapFunction1($java.sci_ListSet$Node_incl0)],
    sci_MapValueIterator, "MapValueIterator", 43, sci_ChampBaseIterator, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sci_MapValueIterator_iterator), "$contains0", $rt_wrapFunction1($java.sci_MapValueIterator_contains), "$isEmpty", $rt_wrapFunction0($java.sci_MapValueIterator_isEmpty), "$filterImpl0", $rt_wrapFunction2($java.sci_MapValueIterator_filterImpl), "$map7", $rt_wrapFunction1($java.sci_MapValueIterator_map), "$flatMap2", $rt_wrapFunction1($java.sci_MapValueIterator_flatMap), "$toString",
    $rt_wrapFunction0($java.sci_MapValueIterator_toString), "$foreach", $rt_wrapFunction1($java.sci_MapValueIterator_foreach), "$exists", $rt_wrapFunction1($java.sci_MapValueIterator_exists), "$find0", $rt_wrapFunction1($java.sci_MapValueIterator_find), "$foldLeft", $rt_wrapFunction2($java.sci_MapValueIterator_foldLeft), "$nonEmpty0", $rt_wrapFunction0($java.sci_MapValueIterator_nonEmpty), "$size", $rt_wrapFunction0($java.sci_MapValueIterator_size), "$copyToArray1", $rt_wrapFunction1($java.sci_MapValueIterator_copyToArray),
    "$copyToArray0", $rt_wrapFunction2($java.sci_MapValueIterator_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.sci_MapValueIterator_copyToArray1), "$toSeq", $rt_wrapFunction0($java.sci_MapValueIterator_toSeq), "$toArray", $rt_wrapFunction1($java.sci_MapValueIterator_toArray), "$knownSize", $rt_wrapFunction0($java.sci_MapValueIterator_knownSize), "$next", $rt_wrapFunction0($java.sci_MapValueIterator_next)],
    $java.sci_Map$Map2$$anon$3, "Map$Map2$$anon$3", 43, $java.sci_Map$Map2$Map2Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map2$$anon$3_nextResult)],
    scm_HashMap$$anon$4, 0, scm_HashMap$HashMapIterator, [], 4, 3, 0, 0, ["$extract0", $rt_wrapFunction1($java.scm_HashMap$$anon$4_extract)],
    sci_MapOps$ImmutableKeySet, 0, sci_AbstractSet, [sc_MapOps$GenKeySet, scg_DefaultSerializable], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sci_MapOps$ImmutableKeySet_iterator), "$contains0", $rt_wrapFunction1($java.sci_MapOps$ImmutableKeySet_contains), "$size", $rt_wrapFunction0($java.sci_MapOps$ImmutableKeySet_size), "$knownSize", $rt_wrapFunction0($java.sci_MapOps$ImmutableKeySet_knownSize), "$isEmpty", $rt_wrapFunction0($java.sci_MapOps$ImmutableKeySet_isEmpty), "$scala$collection$MapOps$GenKeySet$$$outer",
    $rt_wrapFunction0($java.sci_MapOps$ImmutableKeySet_scala$collection$MapOps$GenKeySet$$$outer)],
    sci_HashMap$HashKeySet, 0, sci_MapOps$ImmutableKeySet, [], 4, 3, 0, 0, ["$filter1", $rt_wrapFunction1($java.sci_HashMap$HashKeySet_filter0)],
    $java.onciu_NonEmptyList$IterableConverter, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncia_ProcedureResultItem$_init_$lambda$_72_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProcedureResultItem$_init_$lambda$_72_0_apply)],
    $java.oncia_ProcedureResultItem$_init_$lambda$_72_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ProcedureResultItem$_init_$lambda$_72_1_apply)],
    $java.oncief_Function$$lookup$lzycompute$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncief_Function$$lookup$lzycompute$lambda$_2_0_apply)],
    oncie_MapProjection, "MapProjection", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_MapProjection_position), "$productPrefix", $rt_wrapFunction0($java.oncie_MapProjection_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_MapProjection_productArity), "$productElement", $rt_wrapFunction1($java.oncie_MapProjection_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_MapProjection_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_MapProjection_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_MapProjection_toString), "$equals", $rt_wrapFunction1($java.oncie_MapProjection_equals)],
    oncia_UnaliasedReturnItem$_init_$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnaliasedReturnItem$_init_$lambda$_31_0_apply)],
    oncia_UnaliasedReturnItem$_init_$lambda$_31_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UnaliasedReturnItem$_init_$lambda$_31_1_apply)],
    $java.oncia_UsingIndexHintType, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_UsingAnyIndexType$, "UsingAnyIndexType$", 13, jl_Object, [$java.oncia_UsingIndexHintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_UsingAnyIndexType$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UsingAnyIndexType$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UsingAnyIndexType$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UsingAnyIndexType$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UsingAnyIndexType$_toString)],
    oncia_UsingTextIndexType$, "UsingTextIndexType$", 13, jl_Object, [$java.oncia_UsingIndexHintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_UsingTextIndexType$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UsingTextIndexType$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UsingTextIndexType$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UsingTextIndexType$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UsingTextIndexType$_toString)],
    oncia_UsingRangeIndexType$, "UsingRangeIndexType$", 13, jl_Object, [$java.oncia_UsingIndexHintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_UsingRangeIndexType$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UsingRangeIndexType$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UsingRangeIndexType$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UsingRangeIndexType$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UsingRangeIndexType$_toString)],
    oncia_UsingPointIndexType$, "UsingPointIndexType$", 13, jl_Object, [$java.oncia_UsingIndexHintType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_UsingPointIndexType$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UsingPointIndexType$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UsingPointIndexType$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UsingPointIndexType$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_UsingPointIndexType$_toString)],
    oncias_SemanticCheckInterpreter$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sc_Iterator$$anon$6, "Iterator$$anon$6", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_Iterator$$anon$6_hasNext), "$next", $rt_wrapFunction0($java.sc_Iterator$$anon$6_next)],
    sc_IterableOnceOps$Maximized, 0, $java.sr_AbstractFunction2, [], 0, 3, 0, 0, 0,
    sc_IterableOnceOps$minBy$lambda$_89_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    sc_IterableOnceOps$minBy$lambda$_89_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sc_IterableOnceOps$minBy$lambda$_89_1_apply)],
    $java.scc_JavaCollectionWrappers$JMapWrapperLike$$anon$5, "JavaCollectionWrappers$JMapWrapperLike$$anon$5", 45, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JMapWrapperLike$$anon$5_hasNext), "$next", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JMapWrapperLike$$anon$5_next)],
    oncia_AdministrationCommand$semanticCheck$lambda$_11_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_AdministrationCommand$semanticCheck$lambda$_11_0_apply)],
    $java.s_DummyImplicit, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncia_ReturnItems$ReturnVariables$, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.sc_ArrayOps$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.juf_Predicate, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_0, 0, jl_Object, [$java.juf_Predicate], 0, 3, 0, 0, 0,
    onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_1, 0, jl_Object, [juf_Function], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciaf_ASTExceptionFactory$invalidHintIndexType$lambda$_8_1_apply)],
    $java.jus_Collectors, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_Union$$anonfun$semanticCheck$2$lambda$_31_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Union$$anonfun$semanticCheck$2$lambda$_31_0_apply)],
    $java.oncia_SingleQuery$$anonfun$checkClauses$1$lambda$_140_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkClauses$1$lambda$_140_0_apply)],
    $java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$3$lambda$_498_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciafn_Neo4jASTFactory$$anonfun$getYieldAllAndYieldItems$3$lambda$_498_0_apply)],
    $java.oncia_CommandResultItem, "CommandResultItem", 13, jl_Object, [onciu_ASTNode, oncias_SemanticAnalysisTooling, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_CommandResultItem_position), "$productPrefix", $rt_wrapFunction0($java.oncia_CommandResultItem_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CommandResultItem_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CommandResultItem_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CommandResultItem_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_CommandResultItem_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CommandResultItem_toString), "$equals", $rt_wrapFunction1($java.oncia_CommandResultItem_equals), "$dup", $rt_wrapFunction1($java.oncia_CommandResultItem_dup)]]);
    $rt_metadata([$java.oncia_Access, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncia_ReadOnlyAccess$, "ReadOnlyAccess$", 13, jl_Object, [$java.oncia_Access, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ReadOnlyAccess$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ReadOnlyAccess$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ReadOnlyAccess$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ReadOnlyAccess$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ReadOnlyAccess$_toString)],
    oncia_ReadWriteAccess$, "ReadWriteAccess$", 13, jl_Object, [$java.oncia_Access, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncia_ReadWriteAccess$_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ReadWriteAccess$_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ReadWriteAccess$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ReadWriteAccess$_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ReadWriteAccess$_toString)],
    $java.oncia_ASTSlicingPhrase, 0, jl_Object, [oncias_SemanticCheckable, oncias_SemanticAnalysisTooling], 3, 3, 0, 0, 0,
    $java.oncia_Skip, "Skip", 13, jl_Object, [onciu_ASTNode, $java.oncia_ASTSlicingPhrase, ji_Serializable], 0, 3, [0,0,0], 0, ["$semanticCheck", $rt_wrapFunction0($java.oncia_Skip_semanticCheck), "$expression1", $rt_wrapFunction0($java.oncia_Skip_expression), "$position2", $rt_wrapFunction0($java.oncia_Skip_position), "$name3", $rt_wrapFunction0($java.oncia_Skip_name), "$productPrefix", $rt_wrapFunction0($java.oncia_Skip_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Skip_productArity), "$productElement",
    $rt_wrapFunction1($java.oncia_Skip_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Skip_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Skip_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Skip_toString), "$equals", $rt_wrapFunction1($java.oncia_Skip_equals), "$dup", $rt_wrapFunction1($java.oncia_Skip_dup)],
    $java.oncia_Limit, "Limit", 13, jl_Object, [onciu_ASTNode, $java.oncia_ASTSlicingPhrase, ji_Serializable], 0, 3, [0,0,0], 0, ["$semanticCheck", $rt_wrapFunction0($java.oncia_Limit_semanticCheck), "$expression1", $rt_wrapFunction0($java.oncia_Limit_expression), "$position2", $rt_wrapFunction0($java.oncia_Limit_position), "$name3", $rt_wrapFunction0($java.oncia_Limit_name), "$productPrefix", $rt_wrapFunction0($java.oncia_Limit_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Limit_productArity),
    "$productElement", $rt_wrapFunction1($java.oncia_Limit_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Limit_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Limit_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Limit_toString), "$equals", $rt_wrapFunction1($java.oncia_Limit_equals), "$dup", $rt_wrapFunction1($java.oncia_Limit_dup)],
    $java.oncia_UnmappedUnion$containTheSameInstances$1$lambda$_14_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnmappedUnion$containTheSameInstances$1$lambda$_14_0_apply)],
    jusi_ArrayStreamImpl, 0, jusi_SimpleStreamImpl, [], 0, 3, 0, 0, ["$next9", $rt_wrapFunction1($java.jusi_ArrayStreamImpl_next), "$estimateSize", $rt_wrapFunction0($java.jusi_ArrayStreamImpl_estimateSize)],
    $java.juf_Supplier, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jus_Collectors$toList$lambda$_2_0, 0, jl_Object, [$java.juf_Supplier], 0, 3, 0, 0, ["$get0", $rt_wrapFunction0($java.jus_Collectors$toList$lambda$_2_0_get)],
    onciaf_ASTExceptionFactory$joiningLastDelimiter$lambda$_9_0, 0, jl_Object, [juf_Function], 0, 3, 0, 0, 0,
    ju_EnumSet, 0, ju_AbstractSet, [jl_Cloneable, ji_Serializable], 1, 3, 0, 0, 0,
    jus_Collector$Characteristics, "Collector$Characteristics", 3, jl_Enum, [], 12, 3, 0, jus_Collector$Characteristics_$callClinit, 0,
    jus_Collector, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jus_CollectorImpl, 0, jl_Object, [jus_Collector], 0, 0, 0, 0, 0,
    $java.juf_BiConsumer, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jus_Collectors$toCollection$lambda$_1_0, 0, jl_Object, [$java.juf_BiConsumer], 0, 3, 0, 0, ["$accept0", $rt_wrapFunction2($java.jus_Collectors$toCollection$lambda$_1_0_accept)],
    $java.juf_BiFunction, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.juf_BinaryOperator, 0, jl_Object, [$java.juf_BiFunction], 3, 3, 0, 0, 0,
    jus_Collectors$toCollection$lambda$_1_1, 0, jl_Object, [$java.juf_BinaryOperator], 0, 3, 0, 0, 0,
    jus_Collector$of$lambda$_5_0, 0, jl_Object, [juf_Function], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.jus_Collector$of$lambda$_5_0_apply)],
    ju_GenericEnumSet, 0, ju_EnumSet, [], 0, 0, 0, 0, ["$add", $rt_wrapFunction1(ju_GenericEnumSet_add)],
    $java.ju_Arrays$ArrayAsList, 0, ju_AbstractList, [ju_RandomAccess], 0, 0, 0, 0, ["$get", $rt_wrapFunction1($java.ju_Arrays$ArrayAsList_get), "$size", $rt_wrapFunction0($java.ju_Arrays$ArrayAsList_size)],
    $java.onciu_RewritableCompat$PROXY$7_0, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_0, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_1, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_1, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_2, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_2, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_3, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_3, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_4, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_4, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_5, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_5, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_6, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_6, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_7, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_7, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_8, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_8, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_9, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_9, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_10, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_10, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_11, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_11, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_12, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_12, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_13, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$5_13, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_14, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_14, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_15, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_15, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_16, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_16, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_17, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_17, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_18, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_18, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_19, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_19, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_20, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_20, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_21, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_21, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_22, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_22, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_23, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_23, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_24, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_24, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_25, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_25, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_26, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_26, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_27, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_27, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_28, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_28, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_29, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_29, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_30, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_30, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_31, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_31, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_32, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_32, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_33, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_33, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_34, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_34, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_35, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_35, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_353, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_355, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_357, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_358, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_359, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$3_361, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_362, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_363, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_364, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_365, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_366, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_367, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_369, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_371, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_372, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_373, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_374, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_375, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_377, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_378, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_379, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_380, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_382, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_383, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_384, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_386, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_388, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_389, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_390, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_391, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_394, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_396, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_412, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_413, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_416, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_417, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_418, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_419, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_420, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_36, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_36, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_37, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_37, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_422, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncie_MatchMode, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_423, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_38, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_38, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_39, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_39, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_40, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_40, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_41, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_41, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_42, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$5_42, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_43, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_43, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_44, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_44, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_45, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_45, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_46, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_46, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_47, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_47, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_48, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_48, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_49, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_49, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_50, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_50, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_51, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_51, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_434, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_435, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_437, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_438, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_439, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.sci_Map$Map3$Map3Iterator, 0, sc_AbstractIterator, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sci_Map$Map3$Map3Iterator_hasNext), "$next", $rt_wrapFunction0($java.sci_Map$Map3$Map3Iterator_next)],
    $java.sci_Map$Map3$$anon$4, "Map$Map3$$anon$4", 43, $java.sci_Map$Map3$Map3Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map3$$anon$4_nextResult)],
    $java.sci_Map$Map3$$anon$6, "Map$Map3$$anon$6", 43, $java.sci_Map$Map3$Map3Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map3$$anon$6_nextResult)],
    $java.oncie_Expression$$anonfun$containsAggregate$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncie_Expression$$anonfun$containsAggregate$1_applyOrElse)],
    $java.oncia_AliasDriverSettingsCheck$$findInvalidDriverSettings$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AliasDriverSettingsCheck$$findInvalidDriverSettings$lambda$_5_0_apply)],
    jusi_FilteringStreamImpl, 0, jusi_WrappingStreamImpl, [], 0, 3, 0, 0, ["$wrap2", $rt_wrapFunction1($java.jusi_FilteringStreamImpl_wrap)],
    oncias_SemanticCheckResult$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncias_SemanticCheckInterpreter$ExecutableCheck$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncia_UnassignableAction, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_SignedDecimalIntegerLiteral$$anon$1, "SignedDecimalIntegerLiteral$$anon$1", 28, oncie_SignedDecimalIntegerLiteral, [oncie_SensitiveLiteral], 4, 3, [oncie_SignedDecimalIntegerLiteral,0,0], 0, 0,
    $java.juf_IntFunction, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.jusi_SimpleStreamImpl$toArray$lambda$_19_0, 0, jl_Object, [$java.juf_IntFunction], 0, 3, 0, 0, 0,
    oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$syntacticallyDeprecatedFeatures$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncil_BinaryLabelExpression, 0, jl_Object, [$java.oncil_LabelExpression], 3, 3, 0, 0, 0,
    oncil_LabelExpression$ColonDisjunction, "LabelExpression$ColonDisjunction", 27, jl_Object, [$java.oncil_BinaryLabelExpression, ji_Serializable], 0, 3, [$java.oncil_LabelExpression,0,"ColonDisjunction"], 0, ["$flatten0", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_flatten), "$containsGpmSpecificLabelExpression", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_containsGpmSpecificLabelExpression), "$containsGpmSpecificRelTypeExpression", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_containsGpmSpecificRelTypeExpression),
    "$replaceColonSyntax", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_replaceColonSyntax), "$foldedOver", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_foldedOver), "$folder", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_folder), "$lhs11", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_lhs), "$rhs12", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_rhs), "$containsIs6", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_containsIs),
    "$position2", $rt_wrapFunction0(oncil_LabelExpression$ColonDisjunction_position), "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_productArity), "$productElement", $rt_wrapFunction1($java.oncil_LabelExpression$ColonDisjunction_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_hashCode),
    "$toString", $rt_wrapFunction0($java.oncil_LabelExpression$ColonDisjunction_toString), "$equals", $rt_wrapFunction1($java.oncil_LabelExpression$ColonDisjunction_equals), "$dup", $rt_wrapFunction1($java.oncil_LabelExpression$ColonDisjunction_dup)],
    onciu_DeprecatedRelTypeSeparatorNotification, "DeprecatedRelTypeSeparatorNotification", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_DeprecatedRelTypeSeparatorNotification_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_DeprecatedRelTypeSeparatorNotification_productArity), "$productElement", $rt_wrapFunction1($java.onciu_DeprecatedRelTypeSeparatorNotification_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_DeprecatedRelTypeSeparatorNotification_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_DeprecatedRelTypeSeparatorNotification_hashCode), "$toString", $rt_wrapFunction0($java.onciu_DeprecatedRelTypeSeparatorNotification_toString), "$equals", $rt_wrapFunction1($java.onciu_DeprecatedRelTypeSeparatorNotification_equals)],
    oncir_Deprecations$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    onciu_UnionReturnItemsInDifferentOrder, "UnionReturnItemsInDifferentOrder", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_UnionReturnItemsInDifferentOrder_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_UnionReturnItemsInDifferentOrder_productArity), "$productElement", $rt_wrapFunction1($java.onciu_UnionReturnItemsInDifferentOrder_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_UnionReturnItemsInDifferentOrder_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_UnionReturnItemsInDifferentOrder_hashCode), "$toString", $rt_wrapFunction0($java.onciu_UnionReturnItemsInDifferentOrder_toString), "$equals", $rt_wrapFunction1($java.onciu_UnionReturnItemsInDifferentOrder_equals)],
    onciu_FixedLengthRelationshipInShortestPath, "FixedLengthRelationshipInShortestPath", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_FixedLengthRelationshipInShortestPath_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_FixedLengthRelationshipInShortestPath_productArity), "$productElement", $rt_wrapFunction1($java.onciu_FixedLengthRelationshipInShortestPath_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_FixedLengthRelationshipInShortestPath_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_FixedLengthRelationshipInShortestPath_hashCode), "$toString", $rt_wrapFunction0($java.onciu_FixedLengthRelationshipInShortestPath_toString), "$equals", $rt_wrapFunction1($java.onciu_FixedLengthRelationshipInShortestPath_equals)],
    onciu_DeprecatedDatabaseNameNotification, "DeprecatedDatabaseNameNotification", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_DeprecatedDatabaseNameNotification_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_DeprecatedDatabaseNameNotification_productArity), "$productElement", $rt_wrapFunction1($java.onciu_DeprecatedDatabaseNameNotification_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_DeprecatedDatabaseNameNotification_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_DeprecatedDatabaseNameNotification_hashCode), "$toString", $rt_wrapFunction0($java.onciu_DeprecatedDatabaseNameNotification_toString), "$equals", $rt_wrapFunction1($java.onciu_DeprecatedDatabaseNameNotification_equals)],
    onciu_DeprecatedTextIndexProvider, "DeprecatedTextIndexProvider", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_DeprecatedTextIndexProvider_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_DeprecatedTextIndexProvider_productArity), "$productElement", $rt_wrapFunction1($java.onciu_DeprecatedTextIndexProvider_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_DeprecatedTextIndexProvider_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_DeprecatedTextIndexProvider_hashCode), "$toString", $rt_wrapFunction0($java.onciu_DeprecatedTextIndexProvider_toString), "$equals", $rt_wrapFunction1($java.onciu_DeprecatedTextIndexProvider_equals)],
    onciu_DeprecatedFunctionNotification, "DeprecatedFunctionNotification", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_DeprecatedFunctionNotification_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_DeprecatedFunctionNotification_productArity), "$productElement", $rt_wrapFunction1($java.onciu_DeprecatedFunctionNotification_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_DeprecatedFunctionNotification_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_DeprecatedFunctionNotification_hashCode), "$toString", $rt_wrapFunction0($java.onciu_DeprecatedFunctionNotification_toString), "$equals", $rt_wrapFunction1($java.onciu_DeprecatedFunctionNotification_equals)],
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_0_apply)],
    oncie_PatternExpression, "PatternExpression", 28, oncie_Expression, [$java.oncie_ScopeExpression, oncie_ExpressionWithComputedDependencies, $java.oncie_SubqueryExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$introducedVariables2", $rt_wrapFunction0($java.oncie_PatternExpression_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncie_PatternExpression_scopeDependencies), "$dependencies0", $rt_wrapFunction0($java.oncie_PatternExpression_dependencies), "$computedIntroducedVariables", $rt_wrapFunction0($java.oncie_PatternExpression_computedIntroducedVariables),
    "$computedScopeDependencies", $rt_wrapFunction0($java.oncie_PatternExpression_computedScopeDependencies), "$position2", $rt_wrapFunction0($java.oncie_PatternExpression_position), "$withComputedIntroducedVariables", $rt_wrapFunction1($java.oncie_PatternExpression_withComputedIntroducedVariables), "$withComputedScopeDependencies", $rt_wrapFunction1($java.oncie_PatternExpression_withComputedScopeDependencies), "$subqueryAstNode", $rt_wrapFunction0($java.oncie_PatternExpression_subqueryAstNode), "$productPrefix",
    $rt_wrapFunction0($java.oncie_PatternExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PatternExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PatternExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternExpression_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternExpression_toString), "$equals", $rt_wrapFunction1($java.oncie_PatternExpression_equals),
    "$dup", $rt_wrapFunction1($java.oncie_PatternExpression_dup0), "$dup0", $rt_wrapFunction1($java.oncie_PatternExpression_dup1)],
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_1_apply)],
    $java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_PatternExpressionInNonExistenceCheck$$anonfun$$nestedInanonfun$patternExpressionInNonExistenceCheck$1$1$applyOrElse$lambda$_0_2_apply)]]);
    $rt_metadata([$java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ListCoercedToBooleanCheck$$anonfun$$nestedInanonfun$listCoercedToBooleanCheck$1$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncirr_rewriteShowQuery$$anonfun$lastPosition$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_rewriteShowQuery$$anonfun$lastPosition$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_ReturnItems$returnVariables$lambda$_62_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$returnVariables$lambda$_62_0_apply)],
    onciafn_Neo4jASTFactory$functionQualifier$lambda$_202_0, 0, jl_Object, [$java.juf_Consumer], 0, 3, 0, 0, ["$accept", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$functionQualifier$lambda$_202_0_accept)],
    onciafn_Neo4jASTFactory$procedureQualifier$lambda$_203_0, 0, jl_Object, [$java.juf_Consumer], 0, 3, 0, 0, ["$accept", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$procedureQualifier$lambda$_203_0_accept)],
    oncia_RelationshipQualifier, "RelationshipQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_RelationshipQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RelationshipQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RelationshipQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RelationshipQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_RelationshipQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_RelationshipQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_RelationshipQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_RelationshipQualifier_dup)],
    oncia_RelationshipAllQualifier, "RelationshipAllQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_RelationshipAllQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_RelationshipAllQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_RelationshipAllQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_RelationshipAllQualifier_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_RelationshipAllQualifier_hashCode), "$toString", $rt_wrapFunction0($java.oncia_RelationshipAllQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_RelationshipAllQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_RelationshipAllQualifier_dup)],
    oncia_LabelQualifier, "LabelQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_LabelQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_LabelQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LabelQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LabelQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LabelQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_LabelQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_LabelQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_LabelQualifier_dup)],
    oncia_PatternQualifier, "PatternQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_PatternQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_PatternQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_PatternQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_PatternQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_PatternQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_PatternQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_PatternQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_PatternQualifier_dup)],
    oncia_ElementQualifier, "ElementQualifier", 13, jl_Object, [$java.oncia_GraphPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ElementQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ElementQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ElementQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ElementQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ElementQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ElementQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_ElementQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_ElementQualifier_dup)],
    oncia_PropertiesResource, "PropertiesResource", 13, jl_Object, [$java.oncia_ActionResource, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_PropertiesResource_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_PropertiesResource_productArity), "$productElement", $rt_wrapFunction1($java.oncia_PropertiesResource_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_PropertiesResource_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_PropertiesResource_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_PropertiesResource_toString), "$equals", $rt_wrapFunction1($java.oncia_PropertiesResource_equals)],
    oncia_AllPropertyResource, "AllPropertyResource", 13, jl_Object, [$java.oncia_ActionResource, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_AllPropertyResource_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AllPropertyResource_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllPropertyResource_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllPropertyResource_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllPropertyResource_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_AllPropertyResource_toString), "$equals", $rt_wrapFunction1($java.oncia_AllPropertyResource_equals)],
    oncia_LabelsResource, "LabelsResource", 13, jl_Object, [$java.oncia_ActionResource, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_LabelsResource_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_LabelsResource_productArity), "$productElement", $rt_wrapFunction1($java.oncia_LabelsResource_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_LabelsResource_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_LabelsResource_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_LabelsResource_toString), "$equals", $rt_wrapFunction1($java.oncia_LabelsResource_equals)],
    oncia_AllLabelResource, "AllLabelResource", 13, jl_Object, [$java.oncia_ActionResource, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_AllLabelResource_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_AllLabelResource_productArity), "$productElement", $rt_wrapFunction1($java.oncia_AllLabelResource_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_AllLabelResource_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_AllLabelResource_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_AllLabelResource_toString), "$equals", $rt_wrapFunction1($java.oncia_AllLabelResource_equals)],
    onciafn_Neo4jASTFactory$settingQualifier$lambda$_204_0, 0, jl_Object, [$java.juf_Consumer], 0, 3, 0, 0, ["$accept", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$settingQualifier$lambda$_204_0_accept)],
    oncie_QuantifiedPath, "QuantifiedPath", 28, $java.oncie_PatternElement, [$java.oncie_PathFactor, $java.oncie_PatternAtom, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_QuantifiedPath_position), "$allVariables", $rt_wrapFunction0($java.oncie_QuantifiedPath_allVariables), "$isBounded", $rt_wrapFunction0($java.oncie_QuantifiedPath_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_QuantifiedPath_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_QuantifiedPath_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_QuantifiedPath_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_QuantifiedPath_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_QuantifiedPath_hashCode), "$toString", $rt_wrapFunction0($java.oncie_QuantifiedPath_toString), "$equals", $rt_wrapFunction1($java.oncie_QuantifiedPath_equals)],
    oncie_ParenthesizedPath, "ParenthesizedPath", 28, $java.oncie_PatternElement, [$java.oncie_PathFactor, $java.oncie_PatternAtom, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_ParenthesizedPath_position), "$allVariables", $rt_wrapFunction0($java.oncie_ParenthesizedPath_allVariables), "$isBounded", $rt_wrapFunction0($java.oncie_ParenthesizedPath_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_ParenthesizedPath_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ParenthesizedPath_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_ParenthesizedPath_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ParenthesizedPath_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ParenthesizedPath_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ParenthesizedPath_toString), "$equals", $rt_wrapFunction1($java.oncie_ParenthesizedPath_equals)],
    oncie_PathConcatenation, "PathConcatenation", 28, $java.oncie_PatternElement, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_PathConcatenation_position), "$allVariables", $rt_wrapFunction0($java.oncie_PathConcatenation_allVariables), "$isBounded", $rt_wrapFunction0($java.oncie_PathConcatenation_isBounded), "$productPrefix", $rt_wrapFunction0($java.oncie_PathConcatenation_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PathConcatenation_productArity), "$productElement",
    $rt_wrapFunction1($java.oncie_PathConcatenation_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PathConcatenation_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PathConcatenation_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PathConcatenation_toString), "$equals", $rt_wrapFunction1($java.oncie_PathConcatenation_equals)],
    oncie_NaN, "NaN", 28, oncie_Expression, [oncie_Literal, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_NaN_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_NaN_asCanonicalStringVal), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_NaN_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_NaN_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_NaN_productArity), "$productElement", $rt_wrapFunction1($java.oncie_NaN_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_NaN_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_NaN_hashCode), "$toString", $rt_wrapFunction0($java.oncie_NaN_toString), "$equals", $rt_wrapFunction1($java.oncie_NaN_equals)],
    oncie_True, "True", 28, oncie_Expression, [$java.oncie_BooleanLiteral, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_True_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_True_asCanonicalStringVal), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_True_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_True_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_True_productArity), "$productElement", $rt_wrapFunction1($java.oncie_True_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_True_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_True_hashCode), "$toString", $rt_wrapFunction0($java.oncie_True_toString), "$equals", $rt_wrapFunction1($java.oncie_True_equals)],
    oncie_Null, "Null", 28, oncie_Expression, [oncie_Literal, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_Null_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Null_asCanonicalStringVal), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_Null_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_Null_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Null_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Null_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_Null_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Null_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Null_toString), "$equals", $rt_wrapFunction1($java.oncie_Null_equals)],
    oncie_CountStar, "CountStar", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_CountStar_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_CountStar_asCanonicalStringVal), "$productPrefix", $rt_wrapFunction0($java.oncie_CountStar_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_CountStar_productArity), "$productElement", $rt_wrapFunction1($java.oncie_CountStar_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_CountStar_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_CountStar_hashCode), "$toString", $rt_wrapFunction0($java.oncie_CountStar_toString), "$equals", $rt_wrapFunction1($java.oncie_CountStar_equals)],
    oncie_Infinity, "Infinity", 28, oncie_Expression, [oncie_Literal, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_Infinity_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Infinity_asCanonicalStringVal), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_Infinity_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_Infinity_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Infinity_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Infinity_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_Infinity_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Infinity_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Infinity_toString), "$equals", $rt_wrapFunction1($java.oncie_Infinity_equals)],
    oncie_Ands$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncie_ChainableBinaryOperatorExpression, 0, jl_Object, [oncie_BinaryOperatorExpression], 3, 3, 0, 0, 0,
    oncie_Equals, "Equals", 28, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_ChainableBinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Equals_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_Equals_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Equals_rhs), "$position2", $rt_wrapFunction0($java.oncie_Equals_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Equals_canonicalOperatorSymbol), "$productPrefix",
    $rt_wrapFunction0($java.oncie_Equals_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Equals_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Equals_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Equals_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Equals_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Equals_toString), "$equals", $rt_wrapFunction1($java.oncie_Equals_equals)],
    $java.oncie_InequalityExpression, 0, jl_Object, [$java.oncie_BooleanExpression, $java.oncie_ChainableBinaryOperatorExpression], 3, 3, 0, 0, 0,
    oncie_GreaterThanOrEqual, "GreaterThanOrEqual", 28, oncie_Expression, [$java.oncie_InequalityExpression, ji_Serializable], 4, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_asCanonicalStringVal), "$org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq", $rt_wrapFunction1($java.oncie_GreaterThanOrEqual_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq), "$lhs0", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_lhs),
    "$rhs0", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_rhs), "$position2", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_productArity), "$productElement", $rt_wrapFunction1($java.oncie_GreaterThanOrEqual_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_hashCode), "$toString", $rt_wrapFunction0($java.oncie_GreaterThanOrEqual_toString), "$equals", $rt_wrapFunction1($java.oncie_GreaterThanOrEqual_equals)],
    oncie_GreaterThan, "GreaterThan", 28, oncie_Expression, [$java.oncie_InequalityExpression, ji_Serializable], 4, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_GreaterThan_asCanonicalStringVal), "$org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq", $rt_wrapFunction1($java.oncie_GreaterThan_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq), "$lhs0", $rt_wrapFunction0($java.oncie_GreaterThan_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_GreaterThan_rhs),
    "$position2", $rt_wrapFunction0($java.oncie_GreaterThan_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_GreaterThan_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_GreaterThan_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_GreaterThan_productArity), "$productElement", $rt_wrapFunction1($java.oncie_GreaterThan_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_GreaterThan_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_GreaterThan_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_GreaterThan_toString), "$equals", $rt_wrapFunction1($java.oncie_GreaterThan_equals)],
    oncie_LessThanOrEqual, "LessThanOrEqual", 28, oncie_Expression, [$java.oncie_InequalityExpression, ji_Serializable], 4, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_LessThanOrEqual_asCanonicalStringVal), "$org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq", $rt_wrapFunction1($java.oncie_LessThanOrEqual_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq), "$lhs0", $rt_wrapFunction0($java.oncie_LessThanOrEqual_lhs), "$rhs0",
    $rt_wrapFunction0($java.oncie_LessThanOrEqual_rhs), "$position2", $rt_wrapFunction0($java.oncie_LessThanOrEqual_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_LessThanOrEqual_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_LessThanOrEqual_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_LessThanOrEqual_productArity), "$productElement", $rt_wrapFunction1($java.oncie_LessThanOrEqual_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_LessThanOrEqual_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_LessThanOrEqual_hashCode), "$toString", $rt_wrapFunction0($java.oncie_LessThanOrEqual_toString), "$equals", $rt_wrapFunction1($java.oncie_LessThanOrEqual_equals)],
    oncie_LessThan, "LessThan", 28, oncie_Expression, [$java.oncie_InequalityExpression, ji_Serializable], 4, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_LessThan_asCanonicalStringVal), "$org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq", $rt_wrapFunction1($java.oncie_LessThan_org$neo4j$cypher$internal$expressions$InequalityExpression$_setter_$signatures_$eq), "$lhs0", $rt_wrapFunction0($java.oncie_LessThan_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_LessThan_rhs),
    "$position2", $rt_wrapFunction0($java.oncie_LessThan_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_LessThan_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_LessThan_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_LessThan_productArity), "$productElement", $rt_wrapFunction1($java.oncie_LessThan_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_LessThan_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_LessThan_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_LessThan_toString), "$equals", $rt_wrapFunction1($java.oncie_LessThan_equals)],
    oncie_InvalidNotEquals, "InvalidNotEquals", 28, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_ChainableBinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_InvalidNotEquals_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_InvalidNotEquals_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_InvalidNotEquals_rhs), "$position2", $rt_wrapFunction0($java.oncie_InvalidNotEquals_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_InvalidNotEquals_canonicalOperatorSymbol),
    "$productPrefix", $rt_wrapFunction0($java.oncie_InvalidNotEquals_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_InvalidNotEquals_productArity), "$productElement", $rt_wrapFunction1($java.oncie_InvalidNotEquals_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_InvalidNotEquals_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_InvalidNotEquals_hashCode), "$toString", $rt_wrapFunction0($java.oncie_InvalidNotEquals_toString), "$equals", $rt_wrapFunction1($java.oncie_InvalidNotEquals_equals)],
    oncie_NotEquals, "NotEquals", 28, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_ChainableBinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_NotEquals_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_NotEquals_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_NotEquals_rhs), "$position2", $rt_wrapFunction0($java.oncie_NotEquals_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_NotEquals_canonicalOperatorSymbol),
    "$productPrefix", $rt_wrapFunction0($java.oncie_NotEquals_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_NotEquals_productArity), "$productElement", $rt_wrapFunction1($java.oncie_NotEquals_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_NotEquals_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_NotEquals_hashCode), "$toString", $rt_wrapFunction0($java.oncie_NotEquals_toString), "$equals", $rt_wrapFunction1($java.oncie_NotEquals_equals)],
    $java.jt_DecimalFormat$PerMillField, "DecimalFormat$PerMillField", 4, jl_Object, [$java.jt_DecimalFormat$FormatField], 0, 0, 0, 0, ["$equals", $rt_wrapFunction1($java.jt_DecimalFormat$PerMillField_equals), "$hashCode0", $rt_wrapFunction0($java.jt_DecimalFormat$PerMillField_hashCode)],
    $java.jt_DecimalFormat$CurrencyField, "DecimalFormat$CurrencyField", 4, jl_Object, [$java.jt_DecimalFormat$FormatField], 0, 0, 0, 0, ["$equals", $rt_wrapFunction1($java.jt_DecimalFormat$CurrencyField_equals), "$hashCode0", $rt_wrapFunction0($java.jt_DecimalFormat$CurrencyField_hashCode)],
    $java.jt_DecimalFormat$PercentField, "DecimalFormat$PercentField", 4, jl_Object, [$java.jt_DecimalFormat$FormatField], 0, 0, 0, 0, ["$equals", $rt_wrapFunction1($java.jt_DecimalFormat$PercentField_equals), "$hashCode0", $rt_wrapFunction0($java.jt_DecimalFormat$PercentField_hashCode)],
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_0_apply)],
    $java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_normalizeWithAndReturnClauses$org$neo4j$cypher$internal$rewriting$rewriters$normalizeWithAndReturnClauses$$potentiallyRedefined$lambda$_46_1_apply)],
    $java.oncias_SemanticCheck$$nestedCheck$lambda$_11_0, "SemanticCheck$$nestedCheck$lambda$_11_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$nestedCheck$lambda$_11_0_apply)],
    $java.scm_ArraySeq, 0, scm_AbstractSeq, [scm_IndexedSeq, sc_StrictOptimizedSeqOps, ji_Serializable], 1, 3, 0, 0, ["$distinctBy", $rt_wrapFunction1($java.scm_ArraySeq_distinctBy), "$prepended", $rt_wrapFunction1($java.scm_ArraySeq_prepended), "$appended", $rt_wrapFunction1($java.scm_ArraySeq_appended), "$appendedAll", $rt_wrapFunction1($java.scm_ArraySeq_appendedAll), "$map1", $rt_wrapFunction1($java.scm_ArraySeq_map), "$flatMap", $rt_wrapFunction1($java.scm_ArraySeq_flatMap), "$flatten", $rt_wrapFunction1($java.scm_ArraySeq_flatten),
    "$filter1", $rt_wrapFunction1($java.scm_ArraySeq_filter), "$filterNot1", $rt_wrapFunction1($java.scm_ArraySeq_filterNot), "$filterImpl", $rt_wrapFunction2($java.scm_ArraySeq_filterImpl), "$stringPrefix", $rt_wrapFunction0($java.scm_ArraySeq_stringPrefix), "$reverseIterator", $rt_wrapFunction0($java.scm_ArraySeq_reverseIterator), "$view0", $rt_wrapFunction0($java.scm_ArraySeq_view), "$reversed", $rt_wrapFunction0($java.scm_ArraySeq_reversed), "$head", $rt_wrapFunction0($java.scm_ArraySeq_head), "$headOption",
    $rt_wrapFunction0($java.scm_ArraySeq_headOption), "$lengthCompare", $rt_wrapFunction1($java.scm_ArraySeq_lengthCompare), "$knownSize", $rt_wrapFunction0($java.scm_ArraySeq_knownSize), "$newSpecificBuilder", $rt_wrapFunction0($java.scm_ArraySeq_newSpecificBuilder), "$className", $rt_wrapFunction0($java.scm_ArraySeq_className), "$copyToArray", $rt_wrapFunction3($java.scm_ArraySeq_copyToArray), "$fromSpecific", $rt_wrapFunction1($java.scm_ArraySeq_fromSpecific0), "$fromSpecific0", $rt_wrapFunction1($java.scm_ArraySeq_fromSpecific1),
    "$iterableFactory", $rt_wrapFunction0($java.scm_ArraySeq_iterableFactory0)],
    scm_ArraySeq$ofChar, "ArraySeq$ofChar", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofChar_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofChar_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofChar_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofChar_iterator), "$addString", $rt_wrapFunction4(scm_ArraySeq$ofChar_addString), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofChar_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofChar_apply1),
    "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofChar_elemTag), "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofChar_array)],
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper, "SemanticCheckInterpreter$ExecutableCheck$Wrapper", 17, jl_Object, [$java.oncias_SemanticCheckInterpreter$ExecutableCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_toString), "$equals", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Wrapper_equals)],
    oncias_SemanticCheck$Map, "SemanticCheck$Map", 17, jl_Object, [oncias_SemanticCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$chain", $rt_wrapFunction1($java.oncias_SemanticCheck$Map_chain), "$map12", $rt_wrapFunction1($java.oncias_SemanticCheck$Map_map), "$flatMap3", $rt_wrapFunction1($java.oncias_SemanticCheck$Map_flatMap), "$productPrefix", $rt_wrapFunction0($java.oncias_SemanticCheck$Map_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SemanticCheck$Map_productArity), "$productElement",
    $rt_wrapFunction1($java.oncias_SemanticCheck$Map_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheck$Map_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheck$Map_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheck$Map_toString), "$equals", $rt_wrapFunction1($java.oncias_SemanticCheck$Map_equals)],
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map, "SemanticCheckInterpreter$ExecutableCheck$Map", 17, jl_Object, [$java.oncias_SemanticCheckInterpreter$ExecutableCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_toString), "$equals", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$Map_equals)],
    $java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap, "SemanticCheckInterpreter$ExecutableCheck$FlatMap", 17, jl_Object, [$java.oncias_SemanticCheckInterpreter$ExecutableCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_toString), "$equals", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$FlatMap_equals)],
    $java.oncias_SemanticCheck$CheckFromContext, "SemanticCheck$CheckFromContext", 17, jl_Object, [oncias_SemanticCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$chain", $rt_wrapFunction1($java.oncias_SemanticCheck$CheckFromContext_chain), "$map12", $rt_wrapFunction1($java.oncias_SemanticCheck$CheckFromContext_map), "$flatMap3", $rt_wrapFunction1($java.oncias_SemanticCheck$CheckFromContext_flatMap), "$productPrefix", $rt_wrapFunction0($java.oncias_SemanticCheck$CheckFromContext_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncias_SemanticCheck$CheckFromContext_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheck$CheckFromContext_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheck$CheckFromContext_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheck$CheckFromContext_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheck$CheckFromContext_toString), "$equals", $rt_wrapFunction1($java.oncias_SemanticCheck$CheckFromContext_equals)],
    $java.oncias_SemanticCheck$Annotated, 0, jl_Object, [oncias_SemanticCheck, s_Product, ji_Serializable], 4, 3, 0, 0, 0]);
    $rt_metadata([oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$, "SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$", 17, jl_Object, [$java.oncias_SemanticCheckInterpreter$ExecutableCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PopAnnotation$_toString)],
    oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$, "SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$", 17, jl_Object, [$java.oncias_SemanticCheckInterpreter$ExecutableCheck, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_productArity), "$productElement", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_hashCode), "$toString", $rt_wrapFunction0($java.oncias_SemanticCheckInterpreter$ExecutableCheck$PrintAnnotations$_toString)],
    $java.oncia_PrivilegeCommand$privilegeQualifierCheckForPropertyRules$lambda$_61_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_PrivilegeCommand$privilegeQualifierCheckForPropertyRules$lambda$_61_0_apply)],
    $java.sci_ListSet$Node$removeInternal$lambda$_9_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sci_ListSet$Node$removeInternal$lambda$_9_0_apply)],
    sc_MapOps$$anon$1, 0, sc_AbstractIterable, [scg_DefaultSerializable], 4, 3, 0, 0, ["$knownSize", $rt_wrapFunction0($java.sc_MapOps$$anon$1_knownSize), "$iterator0", $rt_wrapFunction0($java.sc_MapOps$$anon$1_iterator)],
    sc_Iterator$contains$lambda$_35_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_Iterator$contains$lambda$_35_0_apply)],
    oncief_UnresolvedFunction$, "UnresolvedFunction$", 29, $java.oncief_Function, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncief_UnresolvedFunction$_name), "$productArity", $rt_wrapFunction0($java.oncief_UnresolvedFunction$_productArity), "$productElement", $rt_wrapFunction1($java.oncief_UnresolvedFunction$_productElement), "$productIterator", $rt_wrapFunction0($java.oncief_UnresolvedFunction$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncief_UnresolvedFunction$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncief_UnresolvedFunction$_toString)],
    $java.scc_JavaCollectionWrappers$SetWrapper, 0, ju_AbstractSet, [ji_Serializable], 0, 3, 0, 0, 0,
    scc_JavaCollectionWrappers$MutableSetWrapper, 0, $java.scc_JavaCollectionWrappers$SetWrapper, [], 0, 3, 0, 0, 0,
    scc_JavaCollectionWrappers$JSetWrapper, 0, scm_AbstractSet, [sc_StrictOptimizedSetOps, ji_Serializable], 0, 3, 0, 0, ["$knownSize", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JSetWrapper_knownSize), "$iterator0", $rt_wrapFunction0($java.scc_JavaCollectionWrappers$JSetWrapper_iterator)],
    $java.oncias_SemanticCheckInterpreter$$printAnnotations$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheckInterpreter$$printAnnotations$lambda$_4_0_apply)],
    $java.oncifp_AmbiguousAggregationAnalysis$$anonfun$1$$anonfun$applyOrElse$1$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_AmbiguousAggregationAnalysis$$anonfun$1$$anonfun$applyOrElse$1$lambda$_3_0_apply)],
    sci_MapOps$removedAll$lambda$_7_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sci_MapOps$removedAll$lambda$_7_0_apply)],
    sc_MapOps$concat$lambda$_45_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sc_MapOps$concat$lambda$_45_0_apply)],
    oncias_SemanticExpressionCheck$, 0, jl_Object, [oncias_SemanticAnalysisTooling], 4, 3, 0, oncias_SemanticExpressionCheck$_$callClinit, ["$specifyType0", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$_specifyType0), "$expectType", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$_expectType2), "$expectType3", $rt_wrapFunction4($java.oncias_SemanticExpressionCheck$_expectType4), "$expectType$default$4", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$_expectType$default$4), "$types2", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$_types)],
    $java.oncia_CompositePropertyConstraintCommand$semanticCheck$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CompositePropertyConstraintCommand$semanticCheck$lambda$_4_0_apply)],
    $java.oncia_PropertyConstraintCommand$semanticCheck$lambda$_4_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_PropertyConstraintCommand$semanticCheck$lambda$_4_0_apply)],
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_0_apply)],
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_2, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$checkOrder$1$lambda$_134_2_apply)],
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_0_apply)],
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_1_apply)],
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_2_apply)],
    $java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$$anonfun$defineUnionVariables$1$lambda$_48_3_apply)],
    $java.oncias_UnsupportedOpenCypher, 0, jl_Object, [oncias_SemanticErrorDef], 3, 3, 0, 0, 0,
    $java.oncias_FeatureError, "FeatureError", 17, jl_Object, [$java.oncias_UnsupportedOpenCypher, s_Product, ji_Serializable], 4, 3, 0, 0, ["$msg1", $rt_wrapFunction0($java.oncias_FeatureError_msg), "$productPrefix", $rt_wrapFunction0($java.oncias_FeatureError_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_FeatureError_productArity), "$productElement", $rt_wrapFunction1($java.oncias_FeatureError_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_FeatureError_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncias_FeatureError_hashCode), "$toString", $rt_wrapFunction0($java.oncias_FeatureError_toString), "$equals", $rt_wrapFunction1($java.oncias_FeatureError_equals), "$withMsg", $rt_wrapFunction1($java.oncias_FeatureError_withMsg)],
    oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$1$lambda$_29_0, "SyntaxDeprecationWarningsAndReplacements$$anonfun$process$1$lambda$_29_0", 31, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$1$lambda$_29_0_apply)],
    oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$4$lambda$_32_0, "SyntaxDeprecationWarningsAndReplacements$$anonfun$process$4$lambda$_32_0", 31, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_SyntaxDeprecationWarningsAndReplacements$$anonfun$process$4$lambda$_32_0_apply)],
    $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_0_apply)],
    $java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_WriteAdministrationCommand$topologyCheck$lambda$_5_1_apply)],
    $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_0_apply)],
    $java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnmappedUnion$$anonfun$_unionMappings$1$lambda$_11_1_apply)],
    $java.oncias_Scope$$anonfun$allSymbolDefinitions$1$lambda$_38_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_Scope$$anonfun$allSymbolDefinitions$1$lambda$_38_0_apply)],
    oncia_UserQualifier, "UserQualifier", 13, jl_Object, [$java.oncia_DatabasePrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_UserQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_UserQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_UserQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_UserQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_UserQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_UserQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_UserQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_UserQualifier_dup)],
    $java.sci_SeqMap, 0, jl_Object, [sci_Map, $java.sc_SeqMap], 3, 3, 0, 0, 0,
    sci_TreeSeqMap, 0, sci_AbstractMap, [$java.sci_SeqMap, sci_StrictOptimizedMapOps], 4, 3, 0, 0, 0,
    sci_TreeSeqMap$, 0, jl_Object, [sc_MapFactory], 4, 3, 0, sci_TreeSeqMap$_$callClinit, 0,
    $java.oncius_CypherType$$$anonfun$normalize$4$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$$$anonfun$normalize$4$lambda$_12_0_apply)],
    sc_IterableOnceOps$min$lambda$_77_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sc_IterableOnceOps$min$lambda$_77_0_apply)],
    $java.oncius_ClosedDynamicUnionType$$anonfun$simplify$1$lambda$_55_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$$anonfun$simplify$1$lambda$_55_0_apply)],
    $java.oncia_UnresolvedCall$$anonfun$returnVariables$1$lambda$_33_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnresolvedCall$$anonfun$returnVariables$1$lambda$_33_0_apply)],
    $java.oncia_Union$checkSingleQuery$1$lambda$_50_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$checkSingleQuery$1$lambda$_50_0_apply)],
    $java.oncias_SemanticExpressionCheck$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    $java.sci_TreeSeqMap$Ordering, 0, jl_Object, [], 1, 3, 0, 0, 0,
    sci_TreeSeqMap$Ordering$Zero$, 0, $java.sci_TreeSeqMap$Ordering, [s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    $java.sci_TreeSeqMap$OrderBy, 0, jl_Object, [], 3, 3, 0, 0, 0,
    sci_TreeSeqMap$OrderBy$Insertion$, 0, jl_Object, [$java.sci_TreeSeqMap$OrderBy, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    sci_TreeSeqMap$OrderBy$Modification$, 0, jl_Object, [$java.sci_TreeSeqMap$OrderBy, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_52, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_52, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$7_53, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_53, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_54, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_54, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_55, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_55, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_56, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_56, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_57, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_57, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_58, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_58, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_59, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_59, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_60, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_60, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_61, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_61, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_62, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_62, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_63, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_63, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_64, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_64, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_65, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_65, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_66, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_66, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_67, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_67, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_68, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_68, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_69, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_69, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_70, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_70, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_71, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_71, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_72, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_72, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_73, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_73, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_74, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_74, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_75, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_75, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_76, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_76, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_77, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_77, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$7_78, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_78, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_79, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_79, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_80, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_80, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_81, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_81, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_82, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_82, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_83, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_83, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_84, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_84, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_85, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_85, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_86, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_86, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_87, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_87, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_461, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_463, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_464, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_466, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_467, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_468, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_469, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_470, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_472, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_476, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_477, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_485, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_493, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_496, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_497, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_498, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_514, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_515, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_516, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_525, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_526, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_529, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_88, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_88, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_89, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_89, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_90, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_90, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_91, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_91, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$7_92, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_92, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_93, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_93, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_94, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_94, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_95, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_95, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_96, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_96, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_97, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_97, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_98, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_98, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_99, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_99, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_100, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_100, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_101, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_101, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_533, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_534, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_535, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_536, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_537, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_538, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_539, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_540, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_541, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_542, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_543, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_544, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_545, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_546, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_547, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_548, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_549, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_550, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_551, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_552, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_553, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_554, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_555, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_556, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_557, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_558, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_559, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_560, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_561, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_562, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$3_563, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_564, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_584, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.jusi_SimpleStreamImpl$collect$lambda$_25_0, 0, jl_Object, [$java.juf_Predicate], 0, 3, 0, 0, ["$test", $rt_wrapFunction1($java.jusi_SimpleStreamImpl$collect$lambda$_25_0_test)],
    ju_GenericEnumSet$1, 0, jl_Object, [ju_Iterator], 0, 0, 0, 0, 0,
    $java.juf_Function$andThen$lambda$_2_0, 0, jl_Object, [juf_Function], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.juf_Function$andThen$lambda$_2_0_apply)],
    $java.ju_HashMap$HashMapEntrySet, 0, ju_AbstractSet, [], 0, 0, 0, 0, 0,
    ju_LinkedHashMap$LinkedHashMapEntrySet, 0, $java.ju_HashMap$HashMapEntrySet, [], 4, 0, 0, 0, 0,
    oncias_Symbol, "Symbol", 17, jl_Object, [s_Product, ji_Serializable], 4, 3, [0,0,0], 0, ["$toString", $rt_wrapFunction0($java.oncias_Symbol_toString), "$productArity", $rt_wrapFunction0($java.oncias_Symbol_productArity), "$productElement", $rt_wrapFunction1($java.oncias_Symbol_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_Symbol_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_Symbol_hashCode), "$equals", $rt_wrapFunction1($java.oncias_Symbol_equals)],
    $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_0_apply)],
    $java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$$org$neo4j$cypher$internal$rewriting$Deprecations$$unionReturnItemsInDifferentOrder$lambda$_2_1_apply)],
    $java.oncie_MultiOperatorExpression, 0, jl_Object, [$java.oncie_OperatorExpression], 3, 3, 0, 0, 0,
    oncie_Ands, "Ands", 28, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_MultiOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Ands_asCanonicalStringVal), "$position2", $rt_wrapFunction0($java.oncie_Ands_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Ands_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_Ands_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Ands_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_Ands_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Ands_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Ands_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Ands_toString), "$equals", $rt_wrapFunction1($java.oncie_Ands_equals)],
    $java.oncie_Expression$SemanticContext, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_Expression$SemanticContext$Simple$, 0, jl_Object, [$java.oncie_Expression$SemanticContext, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_Union$UnionMapping, "Union$UnionMapping", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_Union$UnionMapping_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Union$UnionMapping_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Union$UnionMapping_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Union$UnionMapping_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Union$UnionMapping_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_Union$UnionMapping_toString), "$equals", $rt_wrapFunction1($java.oncia_Union$UnionMapping_equals)],
    oncie_IsAggregate$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncie_Infinity$$anon$8, "Infinity$$anon$8", 28, oncie_Infinity, [oncie_SensitiveLiteral], 4, 3, [oncie_Infinity,0,0], 0, 0,
    $java.oncie_NaN$$anon$9, "NaN$$anon$9", 28, oncie_NaN, [oncie_SensitiveLiteral], 4, 3, [oncie_NaN,0,0], 0, 0,
    $java.oncie_Null$$anon$7, "Null$$anon$7", 28, oncie_Null, [oncie_SensitiveLiteral], 4, 3, [oncie_Null,0,0], 0, 0,
    $java.oncie_True$$anon$10, "True$$anon$10", 28, oncie_True, [oncie_SensitiveLiteral], 4, 3, [oncie_True,0,0], 0, 0,
    $java.oncie_containsAggregate$$anonfun$apply$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncie_containsAggregate$$anonfun$apply$1_applyOrElse)],
    $java.sci_HashMap$HashKeySet$filter$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashMap$HashKeySet$filter$lambda$_4_0_apply)],
    $java.jusi_SimpleStreamImpl$ArrayFillingConsumer, 0, jl_Object, [$java.juf_Predicate], 0, 0, 0, 0, ["$test", $rt_wrapFunction1($java.jusi_SimpleStreamImpl$ArrayFillingConsumer_test)],
    $java.jusi_SimpleStreamImpl$toArray$lambda$_20_0, 0, jl_Object, [$java.juf_Predicate], 0, 3, 0, 0, ["$test", $rt_wrapFunction1($java.jusi_SimpleStreamImpl$toArray$lambda$_20_0_test)],
    oncir_Deprecations$syntacticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$syntacticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$syntacticallyDeprecatedFeatures$$hasOldTextIndexProvider$lambda$_6_0_apply)],
    $java.oncifp_ListCoercedToBooleanCheck$$org$neo4j$cypher$internal$frontend$phases$ListCoercedToBooleanCheck$$isListCoercedToBoolean$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ListCoercedToBooleanCheck$$org$neo4j$cypher$internal$frontend$phases$ListCoercedToBooleanCheck$$isListCoercedToBoolean$lambda$_2_0_apply)],
    jnc_BufferUnderflowException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    jnc_BufferOverflowException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    jnc_MalformedInputException, 0, jnc_CharacterCodingException, [], 0, 3, 0, 0, ["$getMessage", $rt_wrapFunction0($java.jnc_MalformedInputException_getMessage)],
    jnc_UnmappableCharacterException, 0, jnc_CharacterCodingException, [], 0, 3, 0, 0, ["$getMessage", $rt_wrapFunction0($java.jnc_UnmappableCharacterException_getMessage)],
    oncie_MapExpression, "MapExpression", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_MapExpression_position), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_MapExpression_asCanonicalStringVal), "$productPrefix", $rt_wrapFunction0($java.oncie_MapExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_MapExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncie_MapExpression_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncie_MapExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_MapExpression_hashCode), "$toString", $rt_wrapFunction0($java.oncie_MapExpression_toString), "$equals", $rt_wrapFunction1($java.oncie_MapExpression_equals)],
    $java.oncie_GraphPatternQuantifier, 0, jl_Object, [onciu_ASTNode], 3, 3, 0, 0, 0,
    $java.oncie_OctalIntegerLiteral, 0, oncie_Expression, [$java.oncie_IntegerLiteral], 1, 3, 0, 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_OctalIntegerLiteral_asCanonicalStringVal), "$value26", $rt_wrapFunction0($java.oncie_OctalIntegerLiteral_value)],
    oncie_SignedOctalIntegerLiteral, "SignedOctalIntegerLiteral", 28, $java.oncie_OctalIntegerLiteral, [$java.oncie_SignedIntegerLiteral, ji_Serializable], 0, 3, [0,0,0], 0, ["$stringVal1", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_stringVal), "$position2", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_position), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_productArity), "$productElement", $rt_wrapFunction1($java.oncie_SignedOctalIntegerLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_hashCode), "$toString", $rt_wrapFunction0($java.oncie_SignedOctalIntegerLiteral_toString), "$equals", $rt_wrapFunction1($java.oncie_SignedOctalIntegerLiteral_equals)],
    $java.oncie_HexIntegerLiteral, 0, oncie_Expression, [$java.oncie_IntegerLiteral], 1, 3, 0, 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_HexIntegerLiteral_asCanonicalStringVal), "$value26", $rt_wrapFunction0($java.oncie_HexIntegerLiteral_value)],
    oncie_SignedHexIntegerLiteral, "SignedHexIntegerLiteral", 28, $java.oncie_HexIntegerLiteral, [$java.oncie_SignedIntegerLiteral, ji_Serializable], 0, 3, [0,0,0], 0, ["$stringVal1", $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_stringVal), "$position2", $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_position), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_productArity), "$productElement", $rt_wrapFunction1($java.oncie_SignedHexIntegerLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_hashCode), "$toString", $rt_wrapFunction0($java.oncie_SignedHexIntegerLiteral_toString), "$equals", $rt_wrapFunction1($java.oncie_SignedHexIntegerLiteral_equals)],
    $java.oncie_DoubleLiteral, 0, jl_Object, [$java.oncie_NumberLiteral], 3, 3, 0, 0, 0,
    oncie_DecimalDoubleLiteral, "DecimalDoubleLiteral", 28, oncie_Expression, [$java.oncie_DoubleLiteral, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_asCanonicalStringVal), "$stringVal1", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_stringVal), "$position2", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_position), "$asSensitiveLiteral", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_asSensitiveLiteral), "$productPrefix", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_productArity), "$productElement", $rt_wrapFunction1($java.oncie_DecimalDoubleLiteral_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_hashCode), "$toString", $rt_wrapFunction0($java.oncie_DecimalDoubleLiteral_toString), "$equals", $rt_wrapFunction1($java.oncie_DecimalDoubleLiteral_equals)],
    oncie_CaseExpression, "CaseExpression", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_CaseExpression_position), "$productPrefix", $rt_wrapFunction0($java.oncie_CaseExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_CaseExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncie_CaseExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_CaseExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_CaseExpression_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_CaseExpression_toString), "$equals", $rt_wrapFunction1($java.oncie_CaseExpression_equals)],
    oncie_ListComprehension$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncie_PatternComprehension, "PatternComprehension", 28, oncie_Expression, [$java.oncie_ScopeExpression, oncie_ExpressionWithComputedDependencies, $java.oncie_SubqueryExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$introducedVariables2", $rt_wrapFunction0($java.oncie_PatternComprehension_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncie_PatternComprehension_scopeDependencies), "$dependencies0", $rt_wrapFunction0($java.oncie_PatternComprehension_dependencies), "$position2", $rt_wrapFunction0($java.oncie_PatternComprehension_position),
    "$computedIntroducedVariables", $rt_wrapFunction0($java.oncie_PatternComprehension_computedIntroducedVariables), "$computedScopeDependencies", $rt_wrapFunction0($java.oncie_PatternComprehension_computedScopeDependencies), "$withComputedIntroducedVariables", $rt_wrapFunction1($java.oncie_PatternComprehension_withComputedIntroducedVariables), "$withComputedScopeDependencies", $rt_wrapFunction1($java.oncie_PatternComprehension_withComputedScopeDependencies), "$subqueryAstNode", $rt_wrapFunction0($java.oncie_PatternComprehension_subqueryAstNode),
    "$productPrefix", $rt_wrapFunction0($java.oncie_PatternComprehension_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PatternComprehension_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PatternComprehension_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PatternComprehension_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PatternComprehension_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PatternComprehension_toString), "$equals", $rt_wrapFunction1($java.oncie_PatternComprehension_equals),
    "$dup", $rt_wrapFunction1($java.oncie_PatternComprehension_dup0), "$dup0", $rt_wrapFunction1($java.oncie_PatternComprehension_dup1)],
    oncie_RelationshipsPattern, "RelationshipsPattern", 28, jl_Object, [onciu_ASTNode, ji_Serializable], 0, 3, [0,0,0], 0, ["$foldedOver", $rt_wrapFunction0($java.oncie_RelationshipsPattern_foldedOver), "$folder", $rt_wrapFunction0($java.oncie_RelationshipsPattern_folder), "$position2", $rt_wrapFunction0($java.oncie_RelationshipsPattern_position), "$productPrefix", $rt_wrapFunction0($java.oncie_RelationshipsPattern_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_RelationshipsPattern_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_RelationshipsPattern_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_RelationshipsPattern_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_RelationshipsPattern_hashCode), "$toString", $rt_wrapFunction0($java.oncie_RelationshipsPattern_toString), "$equals", $rt_wrapFunction1($java.oncie_RelationshipsPattern_equals), "$dup", $rt_wrapFunction1($java.oncie_RelationshipsPattern_dup)],
    oncie_ReduceExpression$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncie_IterableExpressionWithInfo, 0, jl_Object, [$java.oncief_FunctionWithName, $java.oncie_TypeSignatures], 3, 3, 0, 0, 0,
    oncie_AllIterablePredicate$, 0, jl_Object, [$java.oncie_IterableExpressionWithInfo, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_AnyIterablePredicate$, 0, jl_Object, [$java.oncie_IterableExpressionWithInfo, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_NoneIterablePredicate$, 0, jl_Object, [$java.oncie_IterableExpressionWithInfo, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_SingleIterablePredicate$, 0, jl_Object, [$java.oncie_IterableExpressionWithInfo, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_ShortestPathExpression, "ShortestPathExpression", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_ShortestPathExpression_position), "$productPrefix", $rt_wrapFunction0($java.oncie_ShortestPathExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ShortestPathExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ShortestPathExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ShortestPathExpression_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_ShortestPathExpression_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ShortestPathExpression_toString), "$equals", $rt_wrapFunction1($java.oncie_ShortestPathExpression_equals)]]);
    $rt_metadata([sci_HashMap$accum$1, 0, $java.sr_AbstractFunction2, [s_Function1], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sci_HashMap$accum$1_apply0), "$apply", $rt_wrapFunction1($java.sci_HashMap$accum$1_apply1)],
    sci_MapNodeRemoveAllSetNodeIterator, 0, sci_ChampBaseIterator, [], 4, 3, 0, 0, 0,
    oncifp_ValidSymbolicNamesInLabelExpressions$$org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ValidSymbolicNamesInLabelExpressions$$org$neo4j$cypher$internal$frontend$phases$ValidSymbolicNamesInLabelExpressions$$restrictSymbolicNames$lambda$_31_0_apply)],
    scm_HashMap$$anon$6, "HashMap$$anon$6", 44, scm_GrowableBuilder, [], 4, 3, 0, 0, 0,
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_0_apply)],
    $java.oncia_ReturnItems$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_ReturnItems$$anonfun$1_applyOrElse)],
    $java.oncia_ReturnItems$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_ReturnItems$$anonfun$2_applyOrElse)],
    $java.oncia_ReturnItems$$anonfun$3, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_ReturnItems$$anonfun$3_applyOrElse)],
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_1_apply)],
    $java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$$checkAmbiguousGrouping$lambda$_3_2_apply)],
    $java.oncias_package$$liftSemanticEitherFunc$lambda$_2_0, "package$$liftSemanticEitherFunc$lambda$_2_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_package$$liftSemanticEitherFunc$lambda$_2_0_apply)],
    $java.oncia_SubqueryCall$reportParams$lambda$_61_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$reportParams$lambda$_61_0_apply)],
    $java.oncia_Union$Mapping$1, "Union$Mapping$1", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_Union$Mapping$1_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Union$Mapping$1_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Union$Mapping$1_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Union$Mapping$1_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_Union$Mapping$1_hashCode), "$toString",
    $rt_wrapFunction0($java.oncia_Union$Mapping$1_toString), "$equals", $rt_wrapFunction1($java.oncia_Union$Mapping$1_equals)],
    $java.oncius_ClosedDynamicUnionType$updateIsNullable$lambda$_30_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$updateIsNullable$lambda$_30_0_apply)],
    $java.onciu_NonEmptyList$IteratorConverter, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncie_Ands$_init_$lambda$_23_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_CreateIndex$semanticCheck$lambda$_65_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateIndex$semanticCheck$lambda$_65_0_apply)],
    onciafn_Neo4jASTFactory$pretty$lambda$_236_0, 0, jl_Object, [juf_Function], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$pretty$lambda$_236_0_apply)],
    onciafn_Neo4jASTFactory$convertSubqueryExpressionToUnifiedExpression$lambda$_124_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciafn_Neo4jASTFactory$convertSubqueryExpressionToUnifiedExpression$lambda$_124_0_apply)],
    $java.s_Proxy, 0, jl_Object, [], 131, 3, 0, 0, 0,
    $java.s_Proxy$Typed, 0, jl_Object, [$java.s_Proxy], 131, 3, 0, 0, 0,
    $java.sr_OrderedProxy, 0, jl_Object, [sm_Ordered, $java.s_Proxy$Typed], 3, 3, 0, 0, 0,
    $java.sr_RichBoolean, 0, jl_Object, [$java.sr_OrderedProxy], 4, 3, 0, 0, ["$ord0", $rt_wrapFunction0($java.sr_RichBoolean_ord), "$self4", $rt_wrapFunction0($java.sr_RichBoolean_self)],
    $java.sr_ScalaNumberProxy, 0, jl_Object, [sm_ScalaNumericAnyConversions, $java.sr_OrderedProxy], 3, 3, 0, 0, 0,
    $java.sr_RangedProxy, 0, jl_Object, [$java.s_Proxy$Typed], 3, 3, 0, 0, 0,
    $java.sr_RichInt, 0, jl_Object, [$java.sr_ScalaNumberProxy, $java.sr_RangedProxy], 4, 3, 0, 0, ["$ord0", $rt_wrapFunction0($java.sr_RichInt_ord), "$self4", $rt_wrapFunction0($java.sr_RichInt_self)],
    oncias_SemanticAnalysisTooling$declareVariable$lambda$_55_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$declareVariable$lambda$_55_0_apply)],
    oncias_SemanticAnalysisTooling$semanticCheckFold$lambda$_1_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticAnalysisTooling$semanticCheckFold$lambda$_1_0_apply)],
    sc_StrictOptimizedIterableOps$partition$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_StrictOptimizedIterableOps$partition$lambda$_1_0_apply)],
    $java.oncia_AliasDriverSettingsCheck$$anonfun$$nestedInanonfun$findInvalidDriverSettings$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_AliasDriverSettingsCheck$$anonfun$$nestedInanonfun$findInvalidDriverSettings$1$1_applyOrElse)],
    oncia_ReadAdministrationCommand$semanticCheck$lambda$_18_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ReadAdministrationCommand$semanticCheck$lambda$_18_0_apply)],
    oncia_ReadAdministrationCommand$defaultColumnNames$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$defaultColumnNames$lambda$_7_0_apply)],
    $java.oncia_CypherTypeName, 0, jl_Object, [oncias_SemanticCheckable, oncias_SemanticAnalysisTooling, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_CreateConstraint$checkPropertyTypes$lambda$_9_0, "CreateConstraint$checkPropertyTypes$lambda$_9_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$checkPropertyTypes$lambda$_9_0_apply)],
    onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification, "DeprecatedNodesOrRelationshipsInSetClauseNotification", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productArity), "$productElement", $rt_wrapFunction1($java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productElement),
    "$productIterator", $rt_wrapFunction0($java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_hashCode), "$toString", $rt_wrapFunction0($java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_toString), "$equals", $rt_wrapFunction1($java.onciu_DeprecatedNodesOrRelationshipsInSetClauseNotification_equals)],
    oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$$nestedInanonfun$find$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$$nestedInanonfun$find$1$1_applyOrElse)],
    oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_0_apply)],
    oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_ExpectedBooleanTypeCheck$isExpectedTypeBoolean$lambda$_1_1_apply)],
    $java.oncia_UnmappedUnion$$anonfun$dup$1$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnmappedUnion$$anonfun$dup$1$lambda$_13_0_apply)],
    $java.oncia_ExecutePrivilegeQualifier, 0, jl_Object, [$java.oncia_PrivilegeQualifier], 3, 3, 0, 0, 0,
    $java.oncia_FunctionPrivilegeQualifier, 0, jl_Object, [$java.oncia_ExecutePrivilegeQualifier], 3, 3, 0, 0, 0,
    oncia_FunctionQualifier, "FunctionQualifier", 13, jl_Object, [$java.oncia_FunctionPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_FunctionQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_FunctionQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_FunctionQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_FunctionQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_FunctionQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_FunctionQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_FunctionQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_FunctionQualifier_dup)],
    $java.oncia_ProcedurePrivilegeQualifier, 0, jl_Object, [$java.oncia_ExecutePrivilegeQualifier], 3, 3, 0, 0, 0,
    oncia_ProcedureQualifier, "ProcedureQualifier", 13, jl_Object, [$java.oncia_ProcedurePrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_ProcedureQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ProcedureQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ProcedureQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_ProcedureQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ProcedureQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_ProcedureQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_ProcedureQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_ProcedureQualifier_dup)],
    $java.oncia_SettingPrivilegeQualifier, 0, jl_Object, [$java.oncia_PrivilegeQualifier], 3, 3, 0, 0, 0,
    oncia_SettingQualifier, "SettingQualifier", 13, jl_Object, [$java.oncia_SettingPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_SettingQualifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_SettingQualifier_productArity), "$productElement", $rt_wrapFunction1($java.oncia_SettingQualifier_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_SettingQualifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_SettingQualifier_hashCode),
    "$toString", $rt_wrapFunction0($java.oncia_SettingQualifier_toString), "$equals", $rt_wrapFunction1($java.oncia_SettingQualifier_equals), "$dup", $rt_wrapFunction1($java.oncia_SettingQualifier_dup)],
    $java.oncie_ReduceExpression$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncie_ReduceExpression$$_clinit_$lambda$_0_0_apply)],
    oncias_OptionSemanticChecking$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_PrivilegeCommand$$anonfun$privilegeQualifierCheckForPropertyRules$1$lambda$_67_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_PrivilegeCommand$$anonfun$privilegeQualifierCheckForPropertyRules$1$lambda$_67_0_apply)],
    oncie_Expression$SemanticContext$Results$, 0, jl_Object, [$java.oncie_Expression$SemanticContext, s_Product, ji_Serializable], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_0_apply)],
    $java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkOrder$2$lambda$_129_1_apply)],
    $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_0_apply)],
    $java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkOrder$6$lambda$_133_1_apply)],
    $java.oncia_Union$$anonfun$defineUnionVariables$5$lambda$_47_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$$anonfun$defineUnionVariables$5$lambda$_47_0_apply)],
    $java.srj_JFunction1$mcZI$sp, 0, jl_Object, [s_Function1, ji_Serializable], 3, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.srj_JFunction1$mcZI$sp_apply)],
    $java.oncia_WriteAdministrationCommand$numPrimaryGreaterThanZero$1$lambda$_7_0, 0, jl_Object, [$java.srj_JFunction1$mcZI$sp, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.srj_JFunction1$mcZI$sp_apply), "$apply$mcZI$sp", $rt_wrapFunction1($java.oncia_WriteAdministrationCommand$numPrimaryGreaterThanZero$1$lambda$_7_0_apply$mcZI$sp)],
    $java.oncia_WriteAdministrationCommand$numSecondaryPositive$1$lambda$_9_0, 0, jl_Object, [$java.srj_JFunction1$mcZI$sp, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.srj_JFunction1$mcZI$sp_apply), "$apply$mcZI$sp", $rt_wrapFunction1($java.oncia_WriteAdministrationCommand$numSecondaryPositive$1$lambda$_9_0_apply$mcZI$sp)],
    $java.oncia_CreateConstraint$allowedTypesCheck$1$lambda$_20_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$allowedTypesCheck$1$lambda$_20_0_apply)],
    oncias_SemanticTable$TypeGetter, 0, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    jus_Collectors$joining$lambda$_7_0, 0, jl_Object, [$java.juf_BiConsumer], 0, 3, 0, 0, ["$accept0", $rt_wrapFunction2($java.jus_Collectors$joining$lambda$_7_0_accept)],
    jus_Collectors$joining$lambda$_7_1, 0, jl_Object, [$java.juf_BinaryOperator], 0, 3, 0, 0, 0,
    jus_Collectors$joining$lambda$_7_2, 0, jl_Object, [$java.juf_Supplier], 0, 3, 0, 0, ["$get0", $rt_wrapFunction0($java.jus_Collectors$joining$lambda$_7_2_get)],
    jus_Collectors$joining$lambda$_7_3, 0, jl_Object, [juf_Function], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.jus_Collectors$joining$lambda$_7_3_apply)],
    $java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_PrivilegeCommand$checkExpression$lambda$_62_0_apply)],
    $java.oncie_RightUnaryOperatorExpression, 0, jl_Object, [$java.oncie_OperatorExpression], 3, 3, 0, 0, 0,
    oncie_IsNull, "IsNull", 28, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_RightUnaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_IsNull_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0(oncie_IsNull_lhs), "$position2", $rt_wrapFunction0($java.oncie_IsNull_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_IsNull_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_IsNull_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncie_IsNull_productArity), "$productElement", $rt_wrapFunction1($java.oncie_IsNull_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_IsNull_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_IsNull_hashCode), "$toString", $rt_wrapFunction0($java.oncie_IsNull_toString), "$equals", $rt_wrapFunction1($java.oncie_IsNull_equals)],
    oncie_IsNotNull, "IsNotNull", 28, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_RightUnaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_IsNotNull_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0(oncie_IsNotNull_lhs), "$position2", $rt_wrapFunction0($java.oncie_IsNotNull_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_IsNotNull_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_IsNotNull_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_IsNotNull_productArity), "$productElement", $rt_wrapFunction1($java.oncie_IsNotNull_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_IsNotNull_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_IsNotNull_hashCode), "$toString", $rt_wrapFunction0($java.oncie_IsNotNull_toString), "$equals", $rt_wrapFunction1($java.oncie_IsNotNull_equals)],
    $java.oncia_Union$Mapping$2$, 0, sr_AbstractFunction3, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_0_apply)],
    $java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$anyPropertyValueType$1$lambda$_12_1_apply)],
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_0_apply)],
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_1_apply)],
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_2_apply)],
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_3_apply)],
    $java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_CreateConstraint$additionalErrorInfo$1$lambda$_19_4_apply)],
    $java.onciu_RewritableCompat$PROXY$7_102, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_102, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_103, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_103, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_104, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_104, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_105, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_105, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_106, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_106, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_107, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_107, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_108, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_108, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_109, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_109, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_110, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_110, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_111, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_111, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_112, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_112, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_113, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_113, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$7_114, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_114, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_115, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_115, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_116, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_116, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_117, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_117, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_118, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_118, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_119, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_119, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_120, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_120, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_121, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_121, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_122, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_122, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_123, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_123, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_124, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_124, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_125, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_125, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_126, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_126, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_127, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_127, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_128, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_128, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_129, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_129, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_130, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_130, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_131, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_131, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_132, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_132, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_133, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_133, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_134, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_134, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_135, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_135, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_136, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_136, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_137, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_137, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_138, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_138, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$7_139, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_139, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_140, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_140, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_141, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_141, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_589, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_590, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_591, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_593, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_594, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_599, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_142, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_142, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_143, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_143, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_144, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_144, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_145, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_145, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_146, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_146, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_603, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_147, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_147, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_608, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_609, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_610, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_611, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_612, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_613, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_614, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_615, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_616, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_617, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_618, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_619, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_620, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_621, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_622, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_623, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_624, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_625, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_626, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_627, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_148, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_148, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_149, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_149, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_150, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$5_150, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_151, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_151, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_152, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_152, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_153, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_153, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_154, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_154, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_155, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_155, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_156, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_156, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_157, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_157, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_158, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_158, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_159, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_159, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_160, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_160, 0, jl_Object, [], 0, 3, 0, 0, 0,
    ju_LinkedHashMap$AbstractMapIterator, 0, jl_Object, [], 0, 0, 0, 0, ["$hasNext", $rt_wrapFunction0(ju_LinkedHashMap$AbstractMapIterator_hasNext)],
    ju_LinkedHashMap$EntryIterator, 0, ju_LinkedHashMap$AbstractMapIterator, [ju_Iterator], 0, 0, 0, 0, 0,
    $java.sci_Map$Map4$Map4Iterator, 0, sc_AbstractIterator, [], 1, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sci_Map$Map4$Map4Iterator_hasNext), "$next", $rt_wrapFunction0($java.sci_Map$Map4$Map4Iterator_next)],
    $java.sci_Map$Map4$$anon$7, "Map$Map4$$anon$7", 43, $java.sci_Map$Map4$Map4Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map4$$anon$7_nextResult)],
    $java.sci_Map$Map4$$anon$9, "Map$Map4$$anon$9", 43, $java.sci_Map$Map4$Map4Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map4$$anon$9_nextResult)],
    $java.oncil_MultiOperatorLabelExpression, 0, jl_Object, [$java.oncil_LabelExpression], 3, 3, 0, 0, 0,
    oncil_LabelExpression$Disjunctions, "LabelExpression$Disjunctions", 27, jl_Object, [$java.oncil_MultiOperatorLabelExpression, ji_Serializable], 4, 3, [$java.oncil_LabelExpression,0,"Disjunctions"], 0, ["$flatten0", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_flatten), "$containsGpmSpecificLabelExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_containsGpmSpecificLabelExpression), "$containsGpmSpecificRelTypeExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_containsGpmSpecificRelTypeExpression),
    "$replaceColonSyntax", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_replaceColonSyntax), "$foldedOver", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_foldedOver), "$folder", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_folder), "$children2", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_children), "$containsIs6", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_containsIs), "$position2", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_position),
    "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_productArity), "$productElement", $rt_wrapFunction1($java.oncil_LabelExpression$Disjunctions_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_hashCode), "$toString", $rt_wrapFunction0($java.oncil_LabelExpression$Disjunctions_toString),
    "$equals", $rt_wrapFunction1($java.oncil_LabelExpression$Disjunctions_equals), "$dup", $rt_wrapFunction1($java.oncil_LabelExpression$Disjunctions_dup)],
    onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_0_apply)],
    oncil_LabelExpression$Conjunctions, "LabelExpression$Conjunctions", 27, jl_Object, [$java.oncil_MultiOperatorLabelExpression, ji_Serializable], 0, 3, [$java.oncil_LabelExpression,0,"Conjunctions"], 0, ["$flatten0", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_flatten), "$containsGpmSpecificLabelExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_containsGpmSpecificLabelExpression), "$containsGpmSpecificRelTypeExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_containsGpmSpecificRelTypeExpression),
    "$replaceColonSyntax", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_replaceColonSyntax), "$foldedOver", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_foldedOver), "$folder", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_folder), "$children2", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_children), "$containsIs6", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_containsIs), "$position2", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_position),
    "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_productArity), "$productElement", $rt_wrapFunction1($java.oncil_LabelExpression$Conjunctions_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_hashCode), "$toString", $rt_wrapFunction0($java.oncil_LabelExpression$Conjunctions_toString),
    "$equals", $rt_wrapFunction1($java.oncil_LabelExpression$Conjunctions_equals), "$dup", $rt_wrapFunction1($java.oncil_LabelExpression$Conjunctions_dup)],
    oncil_LabelExpression$ColonConjunction, "LabelExpression$ColonConjunction", 27, jl_Object, [$java.oncil_BinaryLabelExpression, ji_Serializable], 0, 3, [$java.oncil_LabelExpression,0,"ColonConjunction"], 0, ["$flatten0", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_flatten), "$containsGpmSpecificLabelExpression", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_containsGpmSpecificLabelExpression), "$containsGpmSpecificRelTypeExpression", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_containsGpmSpecificRelTypeExpression),
    "$replaceColonSyntax", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_replaceColonSyntax), "$foldedOver", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_foldedOver), "$folder", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_folder), "$lhs11", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_lhs), "$rhs12", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_rhs), "$containsIs6", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_containsIs),
    "$position2", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_position), "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_productArity), "$productElement", $rt_wrapFunction1($java.oncil_LabelExpression$ColonConjunction_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_hashCode),
    "$toString", $rt_wrapFunction0($java.oncil_LabelExpression$ColonConjunction_toString), "$equals", $rt_wrapFunction1($java.oncil_LabelExpression$ColonConjunction_equals), "$dup", $rt_wrapFunction1($java.oncil_LabelExpression$ColonConjunction_dup)],
    onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringifyLabelExpression$lambda$_15_1_apply)],
    oncief_UserDefinedFunctionInvocation, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_FilteringExpression, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_ListComprehension, "ListComprehension", 28, oncie_Expression, [$java.oncie_FilteringExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$expression1", $rt_wrapFunction0(oncie_ListComprehension_expression), "$position2", $rt_wrapFunction0($java.oncie_ListComprehension_position), "$variable2", $rt_wrapFunction0($java.oncie_ListComprehension_variable), "$innerPredicate", $rt_wrapFunction0($java.oncie_ListComprehension_innerPredicate), "$productPrefix", $rt_wrapFunction0($java.oncie_ListComprehension_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_ListComprehension_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ListComprehension_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ListComprehension_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ListComprehension_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ListComprehension_toString), "$equals", $rt_wrapFunction1($java.oncie_ListComprehension_equals)],
    oncie_ExtractScope, "ExtractScope", 28, oncie_Expression, [$java.oncie_ScopeExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$dependencies0", $rt_wrapFunction0($java.oncie_ExtractScope_dependencies), "$position2", $rt_wrapFunction0($java.oncie_ExtractScope_position), "$introducedVariables2", $rt_wrapFunction0($java.oncie_ExtractScope_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncie_ExtractScope_scopeDependencies), "$productPrefix", $rt_wrapFunction0($java.oncie_ExtractScope_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_ExtractScope_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ExtractScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ExtractScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ExtractScope_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ExtractScope_toString), "$equals", $rt_wrapFunction1($java.oncie_ExtractScope_equals)],
    oncie_ReduceExpression, "ReduceExpression", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_ReduceExpression_position), "$productPrefix", $rt_wrapFunction0($java.oncie_ReduceExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ReduceExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ReduceExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ReduceExpression_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncie_ReduceExpression_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ReduceExpression_toString), "$equals", $rt_wrapFunction1($java.oncie_ReduceExpression_equals)],
    oncie_ReduceScope, "ReduceScope", 28, oncie_Expression, [$java.oncie_ScopeExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$dependencies0", $rt_wrapFunction0($java.oncie_ReduceScope_dependencies), "$position2", $rt_wrapFunction0($java.oncie_ReduceScope_position), "$introducedVariables2", $rt_wrapFunction0($java.oncie_ReduceScope_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncie_ReduceScope_scopeDependencies), "$productPrefix", $rt_wrapFunction0($java.oncie_ReduceScope_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_ReduceScope_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ReduceScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ReduceScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ReduceScope_hashCode), "$toString", $rt_wrapFunction0($java.oncie_ReduceScope_toString), "$equals", $rt_wrapFunction1($java.oncie_ReduceScope_equals)],
    $java.oncie_IterablePredicateExpression, 0, jl_Object, [$java.oncie_FilteringExpression, $java.oncie_BooleanExpression], 3, 3, 0, 0, 0,
    oncie_AllIterablePredicate, "AllIterablePredicate", 28, oncie_Expression, [$java.oncie_IterablePredicateExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$variable2", $rt_wrapFunction0($java.oncie_AllIterablePredicate_variable), "$innerPredicate", $rt_wrapFunction0($java.oncie_AllIterablePredicate_innerPredicate), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_AllIterablePredicate_asCanonicalStringVal), "$scope", $rt_wrapFunction0(oncie_AllIterablePredicate_scope), "$expression1", $rt_wrapFunction0(oncie_AllIterablePredicate_expression),
    "$position2", $rt_wrapFunction0($java.oncie_AllIterablePredicate_position), "$name3", $rt_wrapFunction0($java.oncie_AllIterablePredicate_name), "$productPrefix", $rt_wrapFunction0($java.oncie_AllIterablePredicate_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_AllIterablePredicate_productArity), "$productElement", $rt_wrapFunction1($java.oncie_AllIterablePredicate_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_AllIterablePredicate_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_AllIterablePredicate_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_AllIterablePredicate_toString), "$equals", $rt_wrapFunction1($java.oncie_AllIterablePredicate_equals)],
    oncie_FilterScope, "FilterScope", 28, oncie_Expression, [$java.oncie_ScopeExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$dependencies0", $rt_wrapFunction0($java.oncie_FilterScope_dependencies), "$position2", $rt_wrapFunction0($java.oncie_FilterScope_position), "$introducedVariables2", $rt_wrapFunction0($java.oncie_FilterScope_introducedVariables), "$scopeDependencies", $rt_wrapFunction0($java.oncie_FilterScope_scopeDependencies), "$productPrefix", $rt_wrapFunction0($java.oncie_FilterScope_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_FilterScope_productArity), "$productElement", $rt_wrapFunction1($java.oncie_FilterScope_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_FilterScope_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_FilterScope_hashCode), "$toString", $rt_wrapFunction0($java.oncie_FilterScope_toString), "$equals", $rt_wrapFunction1($java.oncie_FilterScope_equals)],
    oncie_AnyIterablePredicate, "AnyIterablePredicate", 28, oncie_Expression, [$java.oncie_IterablePredicateExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$variable2", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_variable), "$innerPredicate", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_innerPredicate), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_asCanonicalStringVal), "$scope", $rt_wrapFunction0(oncie_AnyIterablePredicate_scope), "$expression1", $rt_wrapFunction0(oncie_AnyIterablePredicate_expression),
    "$position2", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_position), "$name3", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_name), "$productPrefix", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_productArity), "$productElement", $rt_wrapFunction1($java.oncie_AnyIterablePredicate_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_AnyIterablePredicate_toString), "$equals", $rt_wrapFunction1($java.oncie_AnyIterablePredicate_equals)],
    oncie_NoneIterablePredicate, "NoneIterablePredicate", 28, oncie_Expression, [$java.oncie_IterablePredicateExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$variable2", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_variable), "$innerPredicate", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_innerPredicate), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_asCanonicalStringVal), "$scope", $rt_wrapFunction0(oncie_NoneIterablePredicate_scope), "$expression1", $rt_wrapFunction0(oncie_NoneIterablePredicate_expression),
    "$position2", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_position), "$name3", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_name), "$productPrefix", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_productArity), "$productElement", $rt_wrapFunction1($java.oncie_NoneIterablePredicate_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_NoneIterablePredicate_toString), "$equals", $rt_wrapFunction1($java.oncie_NoneIterablePredicate_equals)],
    oncie_SingleIterablePredicate, "SingleIterablePredicate", 28, oncie_Expression, [$java.oncie_IterablePredicateExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$variable2", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_variable), "$innerPredicate", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_innerPredicate), "$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_asCanonicalStringVal), "$scope", $rt_wrapFunction0(oncie_SingleIterablePredicate_scope), "$expression1", $rt_wrapFunction0(oncie_SingleIterablePredicate_expression),
    "$position2", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_position), "$name3", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_name), "$productPrefix", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_productArity), "$productElement", $rt_wrapFunction1($java.oncie_SingleIterablePredicate_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncie_SingleIterablePredicate_hashCode), "$toString", $rt_wrapFunction0($java.oncie_SingleIterablePredicate_toString), "$equals", $rt_wrapFunction1($java.oncie_SingleIterablePredicate_equals)],
    $java.oncias_OptionSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_OptionSemanticChecking$$foldSemanticCheck$extension$lambda$_1_0_apply)],
    scm_HashMap$$anon$3, "HashMap$$anon$3", 44, scm_HashMap$HashMapIterator, [], 4, 3, 0, 0, ["$extract0", $rt_wrapFunction1($java.scm_HashMap$$anon$3_extract)],
    $java.oncie_containsAggregate$$anonfun$apply$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_containsAggregate$$anonfun$apply$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncie_SignedOctalIntegerLiteral$$anon$3, "SignedOctalIntegerLiteral$$anon$3", 28, oncie_SignedOctalIntegerLiteral, [oncie_SensitiveLiteral], 4, 3, [oncie_SignedOctalIntegerLiteral,0,0], 0, 0,
    $java.oncie_DecimalDoubleLiteral$$anon$5, "DecimalDoubleLiteral$$anon$5", 28, oncie_DecimalDoubleLiteral, [oncie_SensitiveLiteral], 4, 3, [oncie_DecimalDoubleLiteral,0,0], 0, 0,
    $java.oncie_SignedHexIntegerLiteral$$anon$4, "SignedHexIntegerLiteral$$anon$4", 28, oncie_SignedHexIntegerLiteral, [oncie_SensitiveLiteral], 4, 3, [oncie_SignedHexIntegerLiteral,0,0], 0, 0]);
    $rt_metadata([scm_TreeSet$$anon$1, 0, jl_Object, [scm_ReusableBuilder], 4, 3, 0, 0, ["$addAll0", $rt_wrapFunction1($java.scm_TreeSet$$anon$1_addAll), "$result0", $rt_wrapFunction0(scm_TreeSet$$anon$1_result), "$addOne", $rt_wrapFunction1($java.scm_TreeSet$$anon$1_addOne)],
    $java.oncias_SemanticExpressionCheck$$check$lambda$_49_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$check$lambda$_49_0_apply)],
    $java.oncias_SemanticExpressionCheck$$check$lambda$_44_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$check$lambda$_44_0_apply)],
    scm_HashMap$addAll$lambda$_42_0, 0, jl_Object, [s_Function3, ji_Serializable], 0, 3, 0, 0, 0,
    scm_HashMap$addAll$lambda$_42_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.scm_HashMap$addAll$lambda$_42_1_apply)],
    onciu_Foldable$Folder$org$neo4j$cypher$internal$util$Foldable$Folder$$innerTreeFold$lambda$_4_0, "Foldable$Folder$org$neo4j$cypher$internal$util$Foldable$Folder$$innerTreeFold$lambda$_4_0", 20, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_Foldable$Folder$org$neo4j$cypher$internal$util$Foldable$Folder$$innerTreeFold$lambda$_4_0_apply)],
    oncie_QuantifiedPath$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncie_MapProjectionElement, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_LiteralEntry, "LiteralEntry", 28, oncie_Expression, [$java.oncie_MapProjectionElement, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_LiteralEntry_position), "$productPrefix", $rt_wrapFunction0($java.oncie_LiteralEntry_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_LiteralEntry_productArity), "$productElement", $rt_wrapFunction1($java.oncie_LiteralEntry_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_LiteralEntry_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncie_LiteralEntry_hashCode), "$toString", $rt_wrapFunction0($java.oncie_LiteralEntry_toString), "$equals", $rt_wrapFunction1($java.oncie_LiteralEntry_equals)],
    oncie_PropertySelector, "PropertySelector", 28, oncie_Expression, [$java.oncie_MapProjectionElement, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_PropertySelector_position), "$productPrefix", $rt_wrapFunction0($java.oncie_PropertySelector_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PropertySelector_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PropertySelector_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_PropertySelector_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_PropertySelector_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PropertySelector_toString), "$equals", $rt_wrapFunction1($java.oncie_PropertySelector_equals)],
    oncie_VariableSelector, "VariableSelector", 28, oncie_Expression, [$java.oncie_MapProjectionElement, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_VariableSelector_position), "$productPrefix", $rt_wrapFunction0($java.oncie_VariableSelector_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_VariableSelector_productArity), "$productElement", $rt_wrapFunction1($java.oncie_VariableSelector_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_VariableSelector_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_VariableSelector_hashCode), "$toString", $rt_wrapFunction0($java.oncie_VariableSelector_toString), "$equals", $rt_wrapFunction1($java.oncie_VariableSelector_equals)],
    oncie_AllPropertiesSelector, "AllPropertiesSelector", 28, oncie_Expression, [$java.oncie_MapProjectionElement, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_AllPropertiesSelector_position), "$productPrefix", $rt_wrapFunction0($java.oncie_AllPropertiesSelector_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_AllPropertiesSelector_productArity), "$productElement", $rt_wrapFunction1($java.oncie_AllPropertiesSelector_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_AllPropertiesSelector_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_AllPropertiesSelector_hashCode), "$toString", $rt_wrapFunction0($java.oncie_AllPropertiesSelector_toString), "$equals", $rt_wrapFunction1($java.oncie_AllPropertiesSelector_equals)],
    oncie_Subtract, "Subtract", 28, oncie_Expression, [oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Subtract_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_Subtract_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Subtract_rhs), "$position2", $rt_wrapFunction0($java.oncie_Subtract_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Subtract_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_Subtract_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Subtract_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Subtract_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Subtract_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Subtract_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Subtract_toString), "$equals", $rt_wrapFunction1($java.oncie_Subtract_equals)],
    oncie_Add, "Add", 28, oncie_Expression, [oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Add_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_Add_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Add_rhs), "$position2", $rt_wrapFunction0($java.oncie_Add_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Add_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_Add_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncie_Add_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Add_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Add_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Add_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Add_toString), "$equals", $rt_wrapFunction1($java.oncie_Add_equals)],
    oncie_RegexMatch, "RegexMatch", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_RegexMatch_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_RegexMatch_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_RegexMatch_rhs), "$position2", $rt_wrapFunction0($java.oncie_RegexMatch_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_RegexMatch_canonicalOperatorSymbol),
    "$productPrefix", $rt_wrapFunction0($java.oncie_RegexMatch_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_RegexMatch_productArity), "$productElement", $rt_wrapFunction1($java.oncie_RegexMatch_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_RegexMatch_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_RegexMatch_hashCode), "$toString", $rt_wrapFunction0($java.oncie_RegexMatch_toString), "$equals", $rt_wrapFunction1($java.oncie_RegexMatch_equals)],
    oncia_IsTyped, "IsTyped", 13, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_RightUnaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_IsTyped_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0(oncia_IsTyped_lhs), "$position2", $rt_wrapFunction0($java.oncia_IsTyped_position), "$canonicalOperatorSymbol", $rt_wrapFunction0(oncia_IsTyped_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncia_IsTyped_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_IsTyped_productArity), "$productElement", $rt_wrapFunction1($java.oncia_IsTyped_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_IsTyped_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_IsTyped_hashCode), "$toString", $rt_wrapFunction0($java.oncia_IsTyped_toString), "$equals", $rt_wrapFunction1($java.oncia_IsTyped_equals)],
    oncie_Contains, "Contains", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Contains_asCanonicalStringVal), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Contains_canonicalOperatorSymbol), "$lhs0", $rt_wrapFunction0($java.oncie_Contains_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Contains_rhs), "$position2", $rt_wrapFunction0($java.oncie_Contains_position), "$productPrefix",
    $rt_wrapFunction0($java.oncie_Contains_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Contains_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Contains_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Contains_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Contains_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Contains_toString), "$equals", $rt_wrapFunction1($java.oncie_Contains_equals)],
    oncie_EndsWith, "EndsWith", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_EndsWith_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_EndsWith_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_EndsWith_rhs), "$position2", $rt_wrapFunction0($java.oncie_EndsWith_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_EndsWith_canonicalOperatorSymbol), "$productPrefix",
    $rt_wrapFunction0($java.oncie_EndsWith_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_EndsWith_productArity), "$productElement", $rt_wrapFunction1($java.oncie_EndsWith_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_EndsWith_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_EndsWith_hashCode), "$toString", $rt_wrapFunction0($java.oncie_EndsWith_toString), "$equals", $rt_wrapFunction1($java.oncie_EndsWith_equals)],
    oncie_StartsWith, "StartsWith", 28, oncie_Expression, [$java.oncie_BooleanExpression, oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_StartsWith_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_StartsWith_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_StartsWith_rhs), "$position2", $rt_wrapFunction0($java.oncie_StartsWith_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_StartsWith_canonicalOperatorSymbol),
    "$productPrefix", $rt_wrapFunction0($java.oncie_StartsWith_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_StartsWith_productArity), "$productElement", $rt_wrapFunction1($java.oncie_StartsWith_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_StartsWith_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_StartsWith_hashCode), "$toString", $rt_wrapFunction0($java.oncie_StartsWith_toString), "$equals", $rt_wrapFunction1($java.oncie_StartsWith_equals)],
    oncia_IsNotTyped, "IsNotTyped", 13, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_RightUnaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncia_IsNotTyped_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0(oncia_IsNotTyped_lhs), "$position2", $rt_wrapFunction0($java.oncia_IsNotTyped_position), "$canonicalOperatorSymbol", $rt_wrapFunction0(oncia_IsNotTyped_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncia_IsNotTyped_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncia_IsNotTyped_productArity), "$productElement", $rt_wrapFunction1($java.oncia_IsNotTyped_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_IsNotTyped_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_IsNotTyped_hashCode), "$toString", $rt_wrapFunction0($java.oncia_IsNotTyped_toString), "$equals", $rt_wrapFunction1($java.oncia_IsNotTyped_equals)],
    jur_Pattern, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    oncius_CypherTypeOrder$, "CypherTypeOrder$", 23, s_Enumeration, [], 4, 3, 0, $java.oncius_CypherTypeOrder$_$callClinit, 0,
    oncias_SemanticTable$typeFor$lambda$_18_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticTable$typeFor$lambda$_18_0_apply)],
    oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2_applyOrElse)],
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_0_apply)],
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_1_apply)],
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_2_apply)],
    oncia_Order$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_OrderBy$checkIllegalOrdering$lambda$_11_3_apply)],
    onciap_Prettifier$$extractTopology$lambda$_18_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$extractTopology$lambda$_18_0_apply)],
    onciap_Prettifier$$extractTopology$lambda$_18_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$$extractTopology$lambda$_18_1_apply)],
    onciap_Prettifier$$extractTopology$lambda$_18_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$extractTopology$lambda$_18_2_apply)],
    onciap_Prettifier$$extractTopology$lambda$_18_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$$extractTopology$lambda$_18_3_apply)],
    $java.oncius_ListType$isSubtypeOf$lambda$_33_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ListType$isSubtypeOf$lambda$_33_0_apply)],
    $java.oncius_ListType$isSubtypeOf$lambda$_33_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ListType$isSubtypeOf$lambda$_33_1_apply)],
    $java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_DecimalIntegerLiteral$value$lzycompute$lambda$_4_0_apply)],
    oncil_LabelExpression$Negation, "LabelExpression$Negation", 27, jl_Object, [$java.oncil_LabelExpression, ji_Serializable], 0, 3, [$java.oncil_LabelExpression,0,"Negation"], 0, ["$containsGpmSpecificLabelExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_containsGpmSpecificLabelExpression), "$containsGpmSpecificRelTypeExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_containsGpmSpecificRelTypeExpression), "$replaceColonSyntax", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_replaceColonSyntax),
    "$foldedOver", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_foldedOver), "$folder", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_folder), "$containsIs6", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_containsIs), "$position2", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_position), "$flatten0", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_flatten), "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_productArity),
    "$productElement", $rt_wrapFunction1($java.oncil_LabelExpression$Negation_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_hashCode), "$toString", $rt_wrapFunction0($java.oncil_LabelExpression$Negation_toString), "$equals", $rt_wrapFunction1($java.oncil_LabelExpression$Negation_equals), "$dup", $rt_wrapFunction1($java.oncil_LabelExpression$Negation_dup)],
    $java.jur_MatchResult, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jur_Matcher, 0, jl_Object, [$java.jur_MatchResult], 4, 3, 0, 0, 0,
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_0_apply)],
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_1_apply)],
    $java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CypherTypeName$cypherTypeSemanticCheck$lambda$_46_2_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_0_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_1_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_2_apply)],
    oncie_Parameter$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncie_ContainerIndex, "ContainerIndex", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_ContainerIndex_position), "$productPrefix", $rt_wrapFunction0($java.oncie_ContainerIndex_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ContainerIndex_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ContainerIndex_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ContainerIndex_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ContainerIndex_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_ContainerIndex_toString), "$equals", $rt_wrapFunction1($java.oncie_ContainerIndex_equals)],
    oncie_ListSlice, "ListSlice", 28, oncie_Expression, [ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_ListSlice_position), "$productPrefix", $rt_wrapFunction0($java.oncie_ListSlice_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_ListSlice_productArity), "$productElement", $rt_wrapFunction1($java.oncie_ListSlice_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_ListSlice_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_ListSlice_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_ListSlice_toString), "$equals", $rt_wrapFunction1($java.oncie_ListSlice_equals)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_3_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_4_apply)]]);
    $rt_metadata([onciap_DefaultExpressionStringifier$stringify$lambda$_9_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_5_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_6, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_6_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_7_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_8, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_8_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_9, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_9_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_10, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_10_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_11, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_11_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_12, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_12_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_13, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_13_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_14, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_14_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_15, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_15_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_16, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_16_apply)],
    $java.oncie_LabelOrTypeCheckExpression, 0, jl_Object, [$java.oncie_BooleanExpression], 3, 3, 0, 0, 0,
    oncie_HasLabelsOrTypes, 0, oncie_Expression, [$java.oncie_LabelOrTypeCheckExpression, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncie_LabelCheckExpression, 0, jl_Object, [$java.oncie_BooleanExpression], 3, 3, 0, 0, 0,
    oncie_HasLabels, 0, oncie_Expression, [$java.oncie_LabelCheckExpression, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_17, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_HasTypes, 0, oncie_Expression, [$java.oncie_BooleanExpression, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_18, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_19, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_DesugaredMapProjection, 0, oncie_Expression, [ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_20, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_20_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_21, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_22, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_22_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_23, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_23_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_24, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_24_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_25, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_25_apply)],
    oncie_AndsReorderable, 0, oncie_Expression, [$java.oncie_BooleanExpression, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_26, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_26_apply)],
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_27, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$stringify$lambda$_9_27_apply)],
    oncie_AndedPropertyInequalities, 0, oncie_Expression, [$java.oncie_BooleanExpression, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_Ors, 0, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncie_MultiOperatorExpression, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_28, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$stringify$lambda$_9_29, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_PathExpression, 0, oncie_Expression, [ji_Serializable], 0, 3, 0, 0, 0,
    oncie_UnaryAdd, "UnaryAdd", 28, oncie_Expression, [$java.oncie_LeftUnaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_UnaryAdd_asCanonicalStringVal), "$rhs0", $rt_wrapFunction0(oncie_UnaryAdd_rhs), "$position2", $rt_wrapFunction0($java.oncie_UnaryAdd_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_UnaryAdd_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_UnaryAdd_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_UnaryAdd_productArity),
    "$productElement", $rt_wrapFunction1($java.oncie_UnaryAdd_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_UnaryAdd_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_UnaryAdd_hashCode), "$toString", $rt_wrapFunction0($java.oncie_UnaryAdd_toString), "$equals", $rt_wrapFunction1($java.oncie_UnaryAdd_equals)],
    oncie_UnarySubtract, "UnarySubtract", 28, oncie_Expression, [$java.oncie_LeftUnaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_UnarySubtract_asCanonicalStringVal), "$rhs0", $rt_wrapFunction0(oncie_UnarySubtract_rhs), "$position2", $rt_wrapFunction0($java.oncie_UnarySubtract_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_UnarySubtract_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_UnarySubtract_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_UnarySubtract_productArity), "$productElement", $rt_wrapFunction1($java.oncie_UnarySubtract_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_UnarySubtract_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_UnarySubtract_hashCode), "$toString", $rt_wrapFunction0($java.oncie_UnarySubtract_toString), "$equals", $rt_wrapFunction1($java.oncie_UnarySubtract_equals)],
    oncie_CoerceTo, 0, oncie_Expression, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticCheckableExpression, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncilp_CoerceToPredicate, 0, oncie_Expression, [$java.oncie_BooleanExpression, $java.oncias_SemanticCheckableExpression, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_AssertIsNode, 0, oncie_Expression, [$java.oncie_BooleanExpression, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_ElementIdToLongId, 0, oncie_Expression, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncie_RelationshipUniquenessPredicate, 0, jl_Object, [$java.oncie_BooleanExpression], 3, 3, 0, 0, 0,
    oncie_NoneOfRelationships, 0, oncie_Expression, [$java.oncie_RelationshipUniquenessPredicate, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncie_EntityType, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_NODE_TYPE$, "NODE_TYPE$", 28, jl_Object, [$java.oncie_EntityType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncie_NODE_TYPE$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_NODE_TYPE$_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_NODE_TYPE$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_NODE_TYPE$_hashCode), "$toString", $rt_wrapFunction0($java.oncie_NODE_TYPE$_toString)],
    $java.oncie_ElementIdToLongId$Mode, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_ElementIdToLongId$Mode$Single$, 0, jl_Object, [$java.oncie_ElementIdToLongId$Mode, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_ElementIdToLongId$Mode$Many$, 0, jl_Object, [$java.oncie_ElementIdToLongId$Mode, s_Product, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_RELATIONSHIP_TYPE$, "RELATIONSHIP_TYPE$", 28, jl_Object, [$java.oncie_EntityType, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncie_RELATIONSHIP_TYPE$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_RELATIONSHIP_TYPE$_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_RELATIONSHIP_TYPE$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_RELATIONSHIP_TYPE$_hashCode), "$toString", $rt_wrapFunction0($java.oncie_RELATIONSHIP_TYPE$_toString)]]);
    $rt_metadata([oncie_DifferentRelationships, 0, oncie_Expression, [$java.oncie_RelationshipUniquenessPredicate, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_Disjoint, 0, oncie_Expression, [$java.oncie_RelationshipUniquenessPredicate, ji_Serializable], 0, 3, 0, 0, 0,
    oncie_Unique, 0, oncie_Expression, [$java.oncie_RelationshipUniquenessPredicate, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncie_VarLengthBound, 0, oncie_Expression, [$java.oncie_BooleanExpression], 1, 3, 0, 0, 0,
    oncie_VarLengthLowerBound, 0, $java.oncie_VarLengthBound, [ji_Serializable], 0, 3, 0, 0, 0,
    oncie_VarLengthUpperBound, 0, $java.oncie_VarLengthBound, [ji_Serializable], 0, 3, 0, 0, 0,
    oncie_IsRepeatTrailUnique, 0, oncie_Expression, [$java.oncie_RelationshipUniquenessPredicate, ji_Serializable], 0, 3, 0, 0, 0,
    sum_Regex, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_SchemaCommand$checkOptionsMap$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncil_LabelExpression$Leaf, "LabelExpression$Leaf", 27, jl_Object, [$java.oncil_LabelExpression, ji_Serializable], 0, 3, [$java.oncil_LabelExpression,0,"Leaf"], 0, ["$containsGpmSpecificLabelExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_containsGpmSpecificLabelExpression), "$containsGpmSpecificRelTypeExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_containsGpmSpecificRelTypeExpression), "$replaceColonSyntax", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_replaceColonSyntax),
    "$foldedOver", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_foldedOver), "$folder", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_folder), "$containsIs6", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_containsIs), "$position2", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_position), "$flatten0", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_flatten), "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_productArity),
    "$productElement", $rt_wrapFunction1($java.oncil_LabelExpression$Leaf_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_hashCode), "$toString", $rt_wrapFunction0($java.oncil_LabelExpression$Leaf_toString), "$equals", $rt_wrapFunction1($java.oncil_LabelExpression$Leaf_equals), "$dup", $rt_wrapFunction1($java.oncil_LabelExpression$Leaf_dup)],
    oncil_LabelExpression$Wildcard, "LabelExpression$Wildcard", 27, jl_Object, [$java.oncil_LabelExpression, ji_Serializable], 0, 3, [$java.oncil_LabelExpression,0,"Wildcard"], 0, ["$containsGpmSpecificLabelExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_containsGpmSpecificLabelExpression), "$containsGpmSpecificRelTypeExpression", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_containsGpmSpecificRelTypeExpression), "$replaceColonSyntax", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_replaceColonSyntax),
    "$foldedOver", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_foldedOver), "$folder", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_folder), "$containsIs6", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_containsIs), "$position2", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_position), "$flatten0", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_flatten), "$productPrefix", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_productArity),
    "$productElement", $rt_wrapFunction1($java.oncil_LabelExpression$Wildcard_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_hashCode), "$toString", $rt_wrapFunction0($java.oncil_LabelExpression$Wildcard_toString), "$equals", $rt_wrapFunction1($java.oncil_LabelExpression$Wildcard_equals), "$dup", $rt_wrapFunction1($java.oncil_LabelExpression$Wildcard_dup)],
    $java.sc_BufferedIterator, 0, jl_Object, [sc_Iterator], 3, 3, 0, 0, 0,
    sc_Iterator$$anon$1, 0, sc_AbstractIterator, [$java.sc_BufferedIterator], 4, 3, 0, 0, 0,
    $java.oncirr_expandShowWhere$$$anonfun$addDefaultColumns$3$lambda$_21_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncirr_expandShowWhere$$$anonfun$addDefaultColumns$3$lambda$_21_0_apply)],
    $java.oncia_SchemaCommand$checkSingleProperty$lambda$_14_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SchemaCommand$checkSingleProperty$lambda$_14_0_apply)],
    $java.oncias_Scope$$anonfun$dumpTree$1$lambda$_48_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_Scope$$anonfun$dumpTree$1$lambda$_48_0_apply)],
    oncia_AmbiguousAggregation$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    jur_AbstractSet, 0, jl_Object, [], 1, 0, 0, 0, ["$find1", $rt_wrapFunction3($java.jur_AbstractSet_find), "$findBack", $rt_wrapFunction4($java.jur_AbstractSet_findBack), "$getType0", $rt_wrapFunction0($java.jur_AbstractSet_getType), "$toString", $rt_wrapFunction0($java.jur_AbstractSet_toString), "$setNext", $rt_wrapFunction1($java.jur_AbstractSet_setNext), "$first4", $rt_wrapFunction1($java.jur_AbstractSet_first), "$processBackRefReplacement", $rt_wrapFunction0($java.jur_AbstractSet_processBackRefReplacement),
    "$processSecondPass", $rt_wrapFunction0($java.jur_AbstractSet_processSecondPass)],
    sc_StrictOptimizedSeqOps$intersect$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_StrictOptimizedSeqOps$intersect$lambda$_15_0_apply)],
    sc_SeqOps$distinct$lambda$_30_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_0_apply)],
    onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$prettyScope$lambda$_10_1_apply)],
    onciap_DefaultExpressionStringifier$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.onciap_DefaultExpressionStringifier$$anonfun$1_applyOrElse)],
    $java.oncius_CypherType$isSubtypeOf$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$isSubtypeOf$lambda$_19_0_apply)],
    $java.oncias_package$$$anonfun$liftSemanticEitherFunc$1$lambda$_14_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_package$$$anonfun$liftSemanticEitherFunc$1$lambda$_14_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncius_TypeSpec$, 0, jl_Object, [], 4, 3, 0, oncius_TypeSpec$_$callClinit, 0,
    $java.jur_FSet, "FSet", 2, jur_AbstractSet, [], 0, 0, 0, $java.jur_FSet_$callClinit, ["$matches1", $rt_wrapFunction3($java.jur_FSet_matches), "$getName", $rt_wrapFunction0($java.jur_FSet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_FSet_hasConsumed)],
    $java.jur_Lexer, 0, jl_Object, [], 0, 0, 0, 0, 0,
    $java.jur_PatternSyntaxException, 0, jl_IllegalArgumentException, [], 0, 3, 0, 0, ["$getMessage", $rt_wrapFunction0($java.jur_PatternSyntaxException_getMessage)],
    $java.onciap_DefaultExpressionStringifier$Binding, 0, jl_Object, [], 3, 3, 0, 0, 0,
    onciap_DefaultExpressionStringifier$Precedence, "DefaultExpressionStringifier$Precedence", 16, jl_Object, [$java.onciap_DefaultExpressionStringifier$Binding, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Precedence_productPrefix), "$productArity", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Precedence_productArity), "$productElement", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$Precedence_productElement),
    "$productIterator", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Precedence_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Precedence_hashCode), "$toString", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Precedence_toString), "$equals", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$Precedence_equals)],
    onciap_DefaultExpressionStringifier$formsChain$1$lambda$_55_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$formsChain$1$lambda$_55_0_apply)],
    $java.jur_NonCapFSet, "NonCapFSet", 2, $java.jur_FSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_NonCapFSet_matches), "$getName", $rt_wrapFunction0($java.jur_NonCapFSet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_NonCapFSet_hasConsumed)],
    $java.jur_AheadFSet, "AheadFSet", 2, $java.jur_FSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_AheadFSet_matches), "$getName", $rt_wrapFunction0($java.jur_AheadFSet_getName)],
    $java.jur_BehindFSet, "BehindFSet", 2, $java.jur_FSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_BehindFSet_matches), "$getName", $rt_wrapFunction0($java.jur_BehindFSet_getName)],
    $java.jur_AtomicFSet, "AtomicFSet", 2, $java.jur_FSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_AtomicFSet_matches), "$getName", $rt_wrapFunction0($java.jur_AtomicFSet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_AtomicFSet_hasConsumed)],
    $java.jur_FinalSet, "FinalSet", 2, $java.jur_FSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_FinalSet_matches), "$getName", $rt_wrapFunction0($java.jur_FinalSet_getName)],
    $java.jur_LeafSet, 0, jur_AbstractSet, [], 1, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_LeafSet_matches), "$charCount0", $rt_wrapFunction0($java.jur_LeafSet_charCount), "$hasConsumed", $rt_wrapFunction1($java.jur_LeafSet_hasConsumed)],
    $java.jur_EmptySet, "EmptySet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_EmptySet_accepts), "$find1", $rt_wrapFunction3($java.jur_EmptySet_find), "$findBack", $rt_wrapFunction4($java.jur_EmptySet_findBack), "$getName", $rt_wrapFunction0($java.jur_EmptySet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_EmptySet_hasConsumed)],
    $java.jur_JointSet, "JointSet", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_JointSet_matches), "$setNext", $rt_wrapFunction1($java.jur_JointSet_setNext), "$getName", $rt_wrapFunction0($java.jur_JointSet_getName), "$first4", $rt_wrapFunction1($java.jur_JointSet_first), "$hasConsumed", $rt_wrapFunction1($java.jur_JointSet_hasConsumed), "$processSecondPass", $rt_wrapFunction0($java.jur_JointSet_processSecondPass)],
    $java.jur_NonCapJointSet, "NonCapJointSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_NonCapJointSet_matches), "$getName", $rt_wrapFunction0($java.jur_NonCapJointSet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_NonCapJointSet_hasConsumed)],
    $java.jur_AtomicJointSet, "AtomicJointSet", 2, $java.jur_NonCapJointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_AtomicJointSet_matches), "$setNext", $rt_wrapFunction1($java.jur_AtomicJointSet_setNext), "$getName", $rt_wrapFunction0($java.jur_AtomicJointSet_getName)],
    $java.jur_PositiveLookAhead, "PositiveLookAhead", 2, $java.jur_AtomicJointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PositiveLookAhead_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_PositiveLookAhead_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_PositiveLookAhead_getName)],
    $java.jur_NegativeLookAhead, "NegativeLookAhead", 2, $java.jur_AtomicJointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_NegativeLookAhead_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_NegativeLookAhead_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_NegativeLookAhead_getName)],
    $java.jur_PositiveLookBehind, "PositiveLookBehind", 2, $java.jur_AtomicJointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PositiveLookBehind_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_PositiveLookBehind_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_PositiveLookBehind_getName)],
    $java.jur_NegativeLookBehind, "NegativeLookBehind", 2, $java.jur_AtomicJointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_NegativeLookBehind_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_NegativeLookBehind_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_NegativeLookBehind_getName)],
    $java.jur_SingleSet, "SingleSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_SingleSet_matches), "$find1", $rt_wrapFunction3($java.jur_SingleSet_find), "$findBack", $rt_wrapFunction4($java.jur_SingleSet_findBack), "$first4", $rt_wrapFunction1($java.jur_SingleSet_first), "$processBackRefReplacement", $rt_wrapFunction0($java.jur_SingleSet_processBackRefReplacement), "$processSecondPass", $rt_wrapFunction0($java.jur_SingleSet_processSecondPass)],
    oncie_Multiply, "Multiply", 28, oncie_Expression, [oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Multiply_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_Multiply_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Multiply_rhs), "$position2", $rt_wrapFunction0($java.oncie_Multiply_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Multiply_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_Multiply_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Multiply_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Multiply_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Multiply_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Multiply_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Multiply_toString), "$equals", $rt_wrapFunction1($java.oncie_Multiply_equals)],
    oncie_Pow, "Pow", 28, oncie_Expression, [oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Pow_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_Pow_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Pow_rhs), "$position2", $rt_wrapFunction0($java.oncie_Pow_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Pow_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_Pow_productPrefix), "$productArity",
    $rt_wrapFunction0($java.oncie_Pow_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Pow_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Pow_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Pow_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Pow_toString), "$equals", $rt_wrapFunction1($java.oncie_Pow_equals)]]);
    $rt_metadata([oncie_Divide, "Divide", 28, oncie_Expression, [oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Divide_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_Divide_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Divide_rhs), "$position2", $rt_wrapFunction0($java.oncie_Divide_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Divide_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_Divide_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Divide_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Divide_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Divide_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Divide_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Divide_toString), "$equals", $rt_wrapFunction1($java.oncie_Divide_equals)],
    oncie_Modulo, "Modulo", 28, oncie_Expression, [oncie_BinaryOperatorExpression, ji_Serializable], 0, 3, [0,0,0], 0, ["$asCanonicalStringVal", $rt_wrapFunction0($java.oncie_Modulo_asCanonicalStringVal), "$lhs0", $rt_wrapFunction0($java.oncie_Modulo_lhs), "$rhs0", $rt_wrapFunction0($java.oncie_Modulo_rhs), "$position2", $rt_wrapFunction0($java.oncie_Modulo_position), "$canonicalOperatorSymbol", $rt_wrapFunction0($java.oncie_Modulo_canonicalOperatorSymbol), "$productPrefix", $rt_wrapFunction0($java.oncie_Modulo_productPrefix),
    "$productArity", $rt_wrapFunction0($java.oncie_Modulo_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Modulo_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Modulo_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Modulo_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Modulo_toString), "$equals", $rt_wrapFunction1($java.oncie_Modulo_equals)],
    $java.oncius_TypeRange, "TypeRange", 23, jl_Object, [s_Product, ji_Serializable], 0, 3, [0,0,0], 0, ["$productPrefix", $rt_wrapFunction0($java.oncius_TypeRange_productPrefix), "$productArity", $rt_wrapFunction0($java.oncius_TypeRange_productArity), "$productElement", $rt_wrapFunction1($java.oncius_TypeRange_productElement), "$productIterator", $rt_wrapFunction0($java.oncius_TypeRange_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncius_TypeRange_hashCode), "$toString", $rt_wrapFunction0($java.oncius_TypeRange_toString),
    "$equals", $rt_wrapFunction1($java.oncius_TypeRange_equals)],
    oncius_TypeSpec, "TypeSpec", 23, jl_Object, [s_Equals], 0, 3, [0,0,0], 0, ["$hashCode0", $rt_wrapFunction0($java.oncius_TypeSpec_hashCode), "$equals", $rt_wrapFunction1(oncius_TypeSpec_equals), "$toString", $rt_wrapFunction0($java.oncius_TypeSpec_toString)],
    $java.jur_SpecialToken, 0, jl_Object, [], 1, 0, 0, 0, 0,
    jur_AbstractCharClass, 0, $java.jur_SpecialToken, [], 1, 0, 0, 0, ["$getBits", $rt_wrapFunction0($java.jur_AbstractCharClass_getBits), "$getLowHighSurrogates", $rt_wrapFunction0($java.jur_AbstractCharClass_getLowHighSurrogates), "$getInstance0", $rt_wrapFunction0($java.jur_AbstractCharClass_getInstance), "$hasUCI", $rt_wrapFunction0($java.jur_AbstractCharClass_hasUCI)],
    $java.jur_CharClass, "CharClass", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass_contains), "$getBits", $rt_wrapFunction0($java.jur_CharClass_getBits), "$getLowHighSurrogates", $rt_wrapFunction0($java.jur_CharClass_getLowHighSurrogates), "$getInstance0", $rt_wrapFunction0($java.jur_CharClass_getInstance), "$toString", $rt_wrapFunction0($java.jur_CharClass_toString), "$hasUCI", $rt_wrapFunction0($java.jur_CharClass_hasUCI)],
    $java.ju_MissingResourceException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    $java.jur_QuantifierSet, 0, jur_AbstractSet, [], 1, 0, 0, 0, ["$first4", $rt_wrapFunction1($java.jur_QuantifierSet_first), "$hasConsumed", $rt_wrapFunction1($java.jur_QuantifierSet_hasConsumed), "$processSecondPass", $rt_wrapFunction0($java.jur_QuantifierSet_processSecondPass)],
    $java.jur_LeafQuantifierSet, "LeafQuantifierSet", 2, $java.jur_QuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_LeafQuantifierSet_matches), "$getName", $rt_wrapFunction0($java.jur_LeafQuantifierSet_getName)],
    $java.jur_CompositeQuantifierSet, "CompositeQuantifierSet", 2, $java.jur_LeafQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_CompositeQuantifierSet_matches), "$getName", $rt_wrapFunction0($java.jur_CompositeQuantifierSet_getName)],
    $java.jur_GroupQuantifierSet, "GroupQuantifierSet", 2, $java.jur_QuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_GroupQuantifierSet_matches), "$getName", $rt_wrapFunction0($java.jur_GroupQuantifierSet_getName)],
    $java.jur_AltQuantifierSet, "AltQuantifierSet", 2, $java.jur_LeafQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_AltQuantifierSet_matches), "$setNext", $rt_wrapFunction1($java.jur_AltQuantifierSet_setNext)],
    $java.jur_UnifiedQuantifierSet, "UnifiedQuantifierSet", 2, $java.jur_LeafQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_UnifiedQuantifierSet_matches), "$find1", $rt_wrapFunction3($java.jur_UnifiedQuantifierSet_find)],
    $java.oncius_TypeRange$_init_$lambda$_43_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    $java.jur_AbstractCharClass$LazyCharClass, 0, jl_Object, [], 1, 0, 0, 0, 0,
    $java.jur_Quantifier, "Quantifier", 2, $java.jur_SpecialToken, [jl_Cloneable], 0, 0, 0, 0, ["$toString", $rt_wrapFunction0($java.jur_Quantifier_toString)],
    $java.jur_FSet$PossessiveFSet, "FSet$PossessiveFSet", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_FSet$PossessiveFSet_matches), "$getName", $rt_wrapFunction0($java.jur_FSet$PossessiveFSet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_FSet$PossessiveFSet_hasConsumed)],
    $java.ju_BitSet, 0, jl_Object, [jl_Cloneable, ji_Serializable], 0, 3, 0, 0, 0,
    $java.jur_LowHighSurrogateRangeSet, "LowHighSurrogateRangeSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$getName", $rt_wrapFunction0($java.jur_LowHighSurrogateRangeSet_getName)],
    $java.jur_CompositeRangeSet, "CompositeRangeSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_CompositeRangeSet_matches), "$setNext", $rt_wrapFunction1($java.jur_CompositeRangeSet_setNext), "$getName", $rt_wrapFunction0($java.jur_CompositeRangeSet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_CompositeRangeSet_hasConsumed), "$first4", $rt_wrapFunction1($java.jur_CompositeRangeSet_first)],
    $java.jur_SupplRangeSet, "SupplRangeSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_SupplRangeSet_matches), "$getName", $rt_wrapFunction0($java.jur_SupplRangeSet_getName), "$contains2", $rt_wrapFunction1($java.jur_SupplRangeSet_contains), "$first4", $rt_wrapFunction1($java.jur_SupplRangeSet_first), "$setNext", $rt_wrapFunction1($java.jur_SupplRangeSet_setNext), "$hasConsumed", $rt_wrapFunction1($java.jur_SupplRangeSet_hasConsumed)],
    $java.jur_UCISupplRangeSet, "UCISupplRangeSet", 2, $java.jur_SupplRangeSet, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_UCISupplRangeSet_contains), "$getName", $rt_wrapFunction0($java.jur_UCISupplRangeSet_getName)],
    $java.jur_UCIRangeSet, "UCIRangeSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_UCIRangeSet_accepts), "$getName", $rt_wrapFunction0($java.jur_UCIRangeSet_getName)],
    $java.jur_RangeSet, "RangeSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_RangeSet_accepts), "$getName", $rt_wrapFunction0($java.jur_RangeSet_getName), "$first4", $rt_wrapFunction1($java.jur_RangeSet_first)],
    $java.jur_HangulDecomposedCharSet, "HangulDecomposedCharSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$setNext", $rt_wrapFunction1($java.jur_HangulDecomposedCharSet_setNext), "$getName", $rt_wrapFunction0($java.jur_HangulDecomposedCharSet_getName), "$matches1", $rt_wrapFunction3($java.jur_HangulDecomposedCharSet_matches), "$first4", $rt_wrapFunction1($java.jur_HangulDecomposedCharSet_first), "$hasConsumed", $rt_wrapFunction1($java.jur_HangulDecomposedCharSet_hasConsumed)],
    $java.jur_CharSet, "CharSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$charCount0", $rt_wrapFunction0($java.jur_CharSet_charCount), "$accepts", $rt_wrapFunction2($java.jur_CharSet_accepts), "$find1", $rt_wrapFunction3($java.jur_CharSet_find), "$findBack", $rt_wrapFunction4($java.jur_CharSet_findBack), "$getName", $rt_wrapFunction0($java.jur_CharSet_getName), "$first4", $rt_wrapFunction1($java.jur_CharSet_first)],
    $java.jur_UCICharSet, "UCICharSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_UCICharSet_accepts), "$getName", $rt_wrapFunction0($java.jur_UCICharSet_getName)],
    $java.jur_CICharSet, "CICharSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_CICharSet_accepts), "$getName", $rt_wrapFunction0($java.jur_CICharSet_getName)],
    $java.jur_DecomposedCharSet, "DecomposedCharSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$setNext", $rt_wrapFunction1($java.jur_DecomposedCharSet_setNext), "$matches1", $rt_wrapFunction3($java.jur_DecomposedCharSet_matches), "$getName", $rt_wrapFunction0($java.jur_DecomposedCharSet_getName), "$first4", $rt_wrapFunction1($java.jur_DecomposedCharSet_first), "$hasConsumed", $rt_wrapFunction1($java.jur_DecomposedCharSet_hasConsumed)],
    $java.jur_UCIDecomposedCharSet, "UCIDecomposedCharSet", 2, $java.jur_DecomposedCharSet, [], 0, 0, 0, 0, 0,
    $java.jur_CIDecomposedCharSet, "CIDecomposedCharSet", 2, $java.jur_DecomposedCharSet, [], 0, 0, 0, 0, 0,
    $java.jur_PossessiveGroupQuantifierSet, "PossessiveGroupQuantifierSet", 2, $java.jur_GroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PossessiveGroupQuantifierSet_matches)],
    $java.jur_PosPlusGroupQuantifierSet, "PosPlusGroupQuantifierSet", 2, $java.jur_GroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PosPlusGroupQuantifierSet_matches)],
    $java.jur_AltGroupQuantifierSet, "AltGroupQuantifierSet", 2, $java.jur_GroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_AltGroupQuantifierSet_matches), "$setNext", $rt_wrapFunction1($java.jur_AltGroupQuantifierSet_setNext)],
    $java.jur_PosAltGroupQuantifierSet, "PosAltGroupQuantifierSet", 2, $java.jur_AltGroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PosAltGroupQuantifierSet_matches), "$setNext", $rt_wrapFunction1($java.jur_PosAltGroupQuantifierSet_setNext)],
    $java.jur_CompositeGroupQuantifierSet, "CompositeGroupQuantifierSet", 2, $java.jur_GroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_CompositeGroupQuantifierSet_matches), "$getName", $rt_wrapFunction0($java.jur_CompositeGroupQuantifierSet_getName)],
    $java.jur_PosCompositeGroupQuantifierSet, "PosCompositeGroupQuantifierSet", 2, $java.jur_CompositeGroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PosCompositeGroupQuantifierSet_matches)],
    $java.jur_ReluctantGroupQuantifierSet, "ReluctantGroupQuantifierSet", 2, $java.jur_GroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_ReluctantGroupQuantifierSet_matches)],
    $java.jur_RelAltGroupQuantifierSet, "RelAltGroupQuantifierSet", 2, $java.jur_AltGroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_RelAltGroupQuantifierSet_matches)],
    $java.jur_RelCompositeGroupQuantifierSet, "RelCompositeGroupQuantifierSet", 2, $java.jur_CompositeGroupQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_RelCompositeGroupQuantifierSet_matches)],
    $java.jur_DotAllQuantifierSet, "DotAllQuantifierSet", 2, $java.jur_QuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_DotAllQuantifierSet_matches), "$find1", $rt_wrapFunction3($java.jur_DotAllQuantifierSet_find), "$getName", $rt_wrapFunction0($java.jur_DotAllQuantifierSet_getName)],
    $java.jur_DotQuantifierSet, "DotQuantifierSet", 2, $java.jur_QuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_DotQuantifierSet_matches), "$find1", $rt_wrapFunction3($java.jur_DotQuantifierSet_find), "$getName", $rt_wrapFunction0($java.jur_DotQuantifierSet_getName)],
    $java.jur_AbstractLineTerminator, 0, jl_Object, [], 1, 0, 0, 0, 0,
    $java.jur_PossessiveQuantifierSet, "PossessiveQuantifierSet", 2, $java.jur_LeafQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PossessiveQuantifierSet_matches)],
    $java.jur_PossessiveAltQuantifierSet, "PossessiveAltQuantifierSet", 2, $java.jur_AltQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PossessiveAltQuantifierSet_matches)],
    $java.jur_PossessiveCompositeQuantifierSet, "PossessiveCompositeQuantifierSet", 2, $java.jur_CompositeQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PossessiveCompositeQuantifierSet_matches)],
    $java.jur_ReluctantQuantifierSet, "ReluctantQuantifierSet", 2, $java.jur_LeafQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_ReluctantQuantifierSet_matches)],
    $java.jur_ReluctantAltQuantifierSet, "ReluctantAltQuantifierSet", 2, $java.jur_AltQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_ReluctantAltQuantifierSet_matches)],
    $java.jur_ReluctantCompositeQuantifierSet, "ReluctantCompositeQuantifierSet", 2, $java.jur_CompositeQuantifierSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_ReluctantCompositeQuantifierSet_matches)]]);
    $rt_metadata([$java.jur_SOLSet, "SOLSet", 2, jur_AbstractSet, [], 4, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_SOLSet_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_SOLSet_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_SOLSet_getName)],
    $java.jur_WordBoundary, "WordBoundary", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_WordBoundary_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_WordBoundary_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_WordBoundary_getName)],
    $java.jur_PreviousMatch, "PreviousMatch", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_PreviousMatch_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_PreviousMatch_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_PreviousMatch_getName)],
    $java.jur_EOLSet, "EOLSet", 2, jur_AbstractSet, [], 4, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_EOLSet_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_EOLSet_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_EOLSet_getName)],
    $java.jur_EOISet, "EOISet", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_EOISet_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_EOISet_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_EOISet_getName)],
    $java.jur_MultiLineSOLSet, "MultiLineSOLSet", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_MultiLineSOLSet_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_MultiLineSOLSet_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_MultiLineSOLSet_getName)],
    $java.jur_DotAllSet, "DotAllSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_DotAllSet_matches), "$getName", $rt_wrapFunction0($java.jur_DotAllSet_getName), "$setNext", $rt_wrapFunction1($java.jur_DotAllSet_setNext), "$getType0", $rt_wrapFunction0($java.jur_DotAllSet_getType), "$hasConsumed", $rt_wrapFunction1($java.jur_DotAllSet_hasConsumed)],
    $java.jur_DotSet, "DotSet", 2, $java.jur_JointSet, [], 4, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_DotSet_matches), "$getName", $rt_wrapFunction0($java.jur_DotSet_getName), "$setNext", $rt_wrapFunction1($java.jur_DotSet_setNext), "$getType0", $rt_wrapFunction0($java.jur_DotSet_getType), "$hasConsumed", $rt_wrapFunction1($java.jur_DotSet_hasConsumed)],
    $java.jur_UEOLSet, "UEOLSet", 2, jur_AbstractSet, [], 4, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_UEOLSet_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_UEOLSet_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_UEOLSet_getName)],
    $java.jur_UMultiLineEOLSet, "UMultiLineEOLSet", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_UMultiLineEOLSet_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_UMultiLineEOLSet_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_UMultiLineEOLSet_getName)],
    $java.jur_MultiLineEOLSet, "MultiLineEOLSet", 2, jur_AbstractSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_MultiLineEOLSet_matches), "$hasConsumed", $rt_wrapFunction1($java.jur_MultiLineEOLSet_hasConsumed), "$getName", $rt_wrapFunction0($java.jur_MultiLineEOLSet_getName)],
    $java.jur_CIBackReferenceSet, "CIBackReferenceSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_CIBackReferenceSet_matches), "$setNext", $rt_wrapFunction1($java.jur_CIBackReferenceSet_setNext), "$getName", $rt_wrapFunction0($java.jur_CIBackReferenceSet_getName), "$hasConsumed", $rt_wrapFunction1($java.jur_CIBackReferenceSet_hasConsumed)],
    $java.jur_BackReferenceSet, "BackReferenceSet", 2, $java.jur_CIBackReferenceSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_BackReferenceSet_matches), "$find1", $rt_wrapFunction3($java.jur_BackReferenceSet_find), "$findBack", $rt_wrapFunction4($java.jur_BackReferenceSet_findBack), "$first4", $rt_wrapFunction1($java.jur_BackReferenceSet_first), "$getName", $rt_wrapFunction0($java.jur_BackReferenceSet_getName)],
    $java.jur_UCIBackReferenceSet, "UCIBackReferenceSet", 2, $java.jur_CIBackReferenceSet, [], 0, 0, 0, 0, ["$matches1", $rt_wrapFunction3($java.jur_UCIBackReferenceSet_matches), "$getName", $rt_wrapFunction0($java.jur_UCIBackReferenceSet_getName)],
    jl_StringBuffer, 0, jl_AbstractStringBuilder, [jl_Appendable], 0, 3, 0, 0, ["$insert3", $rt_wrapFunction4($java.jl_StringBuffer_insert), "$append6", $rt_wrapFunction3($java.jl_StringBuffer_append), "$insert2", $rt_wrapFunction4($java.jl_StringBuffer_insert0), "$append5", $rt_wrapFunction3($java.jl_StringBuffer_append0), "$ensureCapacity", $rt_wrapFunction1($java.jl_StringBuffer_ensureCapacity), "$insert1", $rt_wrapFunction2($java.jl_StringBuffer_insert1), "$insert", $rt_wrapFunction2($java.jl_StringBuffer_insert2)],
    $java.jur_SequenceSet, "SequenceSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_SequenceSet_accepts), "$find1", $rt_wrapFunction3($java.jur_SequenceSet_find), "$findBack", $rt_wrapFunction4($java.jur_SequenceSet_findBack), "$getName", $rt_wrapFunction0($java.jur_SequenceSet_getName), "$first4", $rt_wrapFunction1($java.jur_SequenceSet_first)],
    $java.jur_UCISequenceSet, "UCISequenceSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_UCISequenceSet_accepts), "$getName", $rt_wrapFunction0($java.jur_UCISequenceSet_getName)],
    $java.jur_CISequenceSet, "CISequenceSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_CISequenceSet_accepts), "$getName", $rt_wrapFunction0($java.jur_CISequenceSet_getName)],
    jur_AbstractCharClass$PredefinedCharacterClasses, 0, jl_Object, [], 4, 0, 0, 0, 0,
    $java.jur_UCISupplCharSet, "UCISupplCharSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_UCISupplCharSet_accepts), "$getName", $rt_wrapFunction0($java.jur_UCISupplCharSet_getName)],
    $java.jur_LowSurrogateCharSet, "LowSurrogateCharSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$setNext", $rt_wrapFunction1($java.jur_LowSurrogateCharSet_setNext), "$matches1", $rt_wrapFunction3($java.jur_LowSurrogateCharSet_matches), "$find1", $rt_wrapFunction3($java.jur_LowSurrogateCharSet_find), "$findBack", $rt_wrapFunction4($java.jur_LowSurrogateCharSet_findBack), "$getName", $rt_wrapFunction0($java.jur_LowSurrogateCharSet_getName), "$first4", $rt_wrapFunction1($java.jur_LowSurrogateCharSet_first), "$hasConsumed",
    $rt_wrapFunction1($java.jur_LowSurrogateCharSet_hasConsumed)],
    $java.jur_HighSurrogateCharSet, "HighSurrogateCharSet", 2, $java.jur_JointSet, [], 0, 0, 0, 0, ["$setNext", $rt_wrapFunction1($java.jur_HighSurrogateCharSet_setNext), "$matches1", $rt_wrapFunction3($java.jur_HighSurrogateCharSet_matches), "$find1", $rt_wrapFunction3($java.jur_HighSurrogateCharSet_find), "$findBack", $rt_wrapFunction4($java.jur_HighSurrogateCharSet_findBack), "$getName", $rt_wrapFunction0($java.jur_HighSurrogateCharSet_getName), "$first4", $rt_wrapFunction1($java.jur_HighSurrogateCharSet_first),
    "$hasConsumed", $rt_wrapFunction1($java.jur_HighSurrogateCharSet_hasConsumed)],
    $java.jur_SupplCharSet, "SupplCharSet", 2, $java.jur_LeafSet, [], 0, 0, 0, 0, ["$accepts", $rt_wrapFunction2($java.jur_SupplCharSet_accepts), "$find1", $rt_wrapFunction3($java.jur_SupplCharSet_find), "$findBack", $rt_wrapFunction4($java.jur_SupplCharSet_findBack), "$getName", $rt_wrapFunction0($java.jur_SupplCharSet_getName), "$first4", $rt_wrapFunction1($java.jur_SupplCharSet_first)],
    $java.jur_AbstractLineTerminator$1, 0, $java.jur_AbstractLineTerminator, [], 0, 0, 0, 0, ["$isLineTerminator", $rt_wrapFunction1($java.jur_AbstractLineTerminator$1_isLineTerminator), "$isAfterLineTerminator", $rt_wrapFunction2($java.jur_AbstractLineTerminator$1_isAfterLineTerminator)],
    $java.jur_AbstractLineTerminator$2, 0, $java.jur_AbstractLineTerminator, [], 0, 0, 0, 0, ["$isLineTerminator", $rt_wrapFunction1($java.jur_AbstractLineTerminator$2_isLineTerminator), "$isAfterLineTerminator", $rt_wrapFunction2($java.jur_AbstractLineTerminator$2_isAfterLineTerminator)],
    $java.jur_SequenceSet$IntHash, 0, jl_Object, [], 0, 0, 0, 0, 0,
    $java.jur_IntHash, 0, jl_Object, [], 0, 0, 0, 0, 0,
    $java.jur_AbstractCharClass$LazySpace, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazySpace_computeValue)],
    $java.jur_AbstractCharClass$LazyDigit, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyDigit_computeValue)],
    $java.jur_AbstractCharClass$LazyLower, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyLower_computeValue)],
    $java.jur_AbstractCharClass$LazyUpper, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyUpper_computeValue)],
    $java.jur_AbstractCharClass$LazyASCII, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyASCII_computeValue)],
    $java.jur_AbstractCharClass$LazyAlpha, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyAlpha_computeValue)],
    $java.jur_AbstractCharClass$LazyAlnum, 0, $java.jur_AbstractCharClass$LazyAlpha, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyAlnum_computeValue)],
    $java.jur_AbstractCharClass$LazyPunct, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyPunct_computeValue)],
    $java.jur_AbstractCharClass$LazyGraph, 0, $java.jur_AbstractCharClass$LazyAlnum, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyGraph_computeValue)],
    $java.jur_AbstractCharClass$LazyPrint, 0, $java.jur_AbstractCharClass$LazyGraph, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyPrint_computeValue)],
    $java.jur_AbstractCharClass$LazyBlank, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyBlank_computeValue)],
    $java.jur_AbstractCharClass$LazyCntrl, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyCntrl_computeValue)],
    $java.jur_AbstractCharClass$LazyXDigit, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyXDigit_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaLowerCase, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaLowerCase_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaUpperCase, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaUpperCase_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaWhitespace, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaWhitespace_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaMirrored, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaMirrored_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaDefined, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaDefined_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaDigit, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaDigit_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaISOControl, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaISOControl_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart_computeValue)]]);
    $rt_metadata([$java.jur_AbstractCharClass$LazyJavaLetter, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaLetter_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaLetterOrDigit_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaSpaceChar, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaSpaceChar_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaTitleCase, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaTitleCase_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart_computeValue)],
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart_computeValue)],
    $java.jur_AbstractCharClass$LazyWord, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyWord_computeValue)],
    $java.jur_AbstractCharClass$LazyNonWord, 0, $java.jur_AbstractCharClass$LazyWord, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyNonWord_computeValue)],
    $java.jur_AbstractCharClass$LazyNonSpace, 0, $java.jur_AbstractCharClass$LazySpace, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyNonSpace_computeValue)],
    $java.jur_AbstractCharClass$LazyNonDigit, 0, $java.jur_AbstractCharClass$LazyDigit, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyNonDigit_computeValue)],
    $java.jur_AbstractCharClass$LazyRange, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyRange_computeValue)],
    $java.jur_AbstractCharClass$LazySpecialsBlock, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazySpecialsBlock_computeValue)],
    $java.jur_AbstractCharClass$LazyCategory, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyCategory_computeValue)],
    $java.jur_AbstractCharClass$LazyCategoryScope, 0, $java.jur_AbstractCharClass$LazyCharClass, [], 0, 0, 0, 0, ["$computeValue0", $rt_wrapFunction0($java.jur_AbstractCharClass$LazyCategoryScope_computeValue)],
    otciu_UnicodeHelper$Range, "UnicodeHelper$Range", 35, jl_Object, [], 0, 3, [otciu_UnicodeHelper,0,"Range"], 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_161, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_161, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_162, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_162, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_163, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_163, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_164, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_164, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_165, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_165, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_166, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_166, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_167, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_167, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_168, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_168, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_169, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_169, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_170, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_170, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_171, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_171, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_172, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_172, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_173, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_173, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_174, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_174, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_175, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_175, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_176, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_176, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_177, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_177, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_178, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$5_178, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_179, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_179, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_180, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_180, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_181, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_181, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_182, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_182, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_183, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_183, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_184, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_184, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_185, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_185, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_186, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_186, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_187, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_187, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_188, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_188, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_189, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_189, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_190, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_190, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_191, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_191, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_192, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_192, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_193, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_193, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_194, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_194, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_195, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_195, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_196, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_196, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_197, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_197, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_198, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_198, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_199, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_199, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_200, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_200, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_201, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_201, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_202, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_202, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_701, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$3_702, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_709, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_713, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_714, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_716, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_719, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_721, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_727, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_729, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_731, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_735, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_738, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_742, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_744, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_745, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_747, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_748, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_203, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_203, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_204, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_204, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_750, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_751, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_752, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_205, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_205, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_206, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_206, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_207, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_207, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_208, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_208, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_209, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_209, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_210, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_210, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_211, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_211, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_212, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_212, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_213, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_213, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_214, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_214, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_215, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_215, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_216, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_216, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_217, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_217, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.onciu_RewritableCompat$PROXY$7_218, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_218, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_219, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_219, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_220, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_220, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_221, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_221, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_222, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_222, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_754, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_755, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_756, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_757, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_758, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_759, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_223, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_223, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_224, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_224, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_225, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_225, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_226, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_226, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_227, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_227, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_228, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_228, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_NonEmptyList$IteratorConverter$asNonEmptyListOption$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_NonEmptyList$IteratorConverter$asNonEmptyListOption$lambda$_1_0_apply)],
    $java.sci_Map$Map4$$anon$8, "Map$Map4$$anon$8", 43, $java.sci_Map$Map4$Map4Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map4$$anon$8_nextResult)],
    sci_MapKeyIterator, "MapKeyIterator", 43, sci_ChampBaseIterator, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sci_MapKeyIterator_iterator), "$isEmpty", $rt_wrapFunction0($java.sci_MapKeyIterator_isEmpty), "$filterImpl0", $rt_wrapFunction2($java.sci_MapKeyIterator_filterImpl), "$map7", $rt_wrapFunction1($java.sci_MapKeyIterator_map), "$toString", $rt_wrapFunction0($java.sci_MapKeyIterator_toString), "$foreach", $rt_wrapFunction1($java.sci_MapKeyIterator_foreach), "$exists", $rt_wrapFunction1($java.sci_MapKeyIterator_exists),
    "$find0", $rt_wrapFunction1($java.sci_MapKeyIterator_find), "$foldLeft", $rt_wrapFunction2($java.sci_MapKeyIterator_foldLeft), "$nonEmpty0", $rt_wrapFunction0($java.sci_MapKeyIterator_nonEmpty), "$size", $rt_wrapFunction0($java.sci_MapKeyIterator_size), "$copyToArray1", $rt_wrapFunction1($java.sci_MapKeyIterator_copyToArray), "$copyToArray0", $rt_wrapFunction2($java.sci_MapKeyIterator_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.sci_MapKeyIterator_copyToArray1), "$toSeq", $rt_wrapFunction0($java.sci_MapKeyIterator_toSeq),
    "$toArray", $rt_wrapFunction1($java.sci_MapKeyIterator_toArray), "$knownSize", $rt_wrapFunction0($java.sci_MapKeyIterator_knownSize), "$next", $rt_wrapFunction0($java.sci_MapKeyIterator_next)],
    $java.sci_Map$Map2$$anon$2, "Map$Map2$$anon$2", 43, $java.sci_Map$Map2$Map2Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map2$$anon$2_nextResult)],
    $java.sci_Map$Map3$$anon$5, "Map$Map3$$anon$5", 43, $java.sci_Map$Map3$Map3Iterator, [], 4, 3, 0, 0, ["$nextResult", $rt_wrapFunction2($java.sci_Map$Map3$$anon$5_nextResult)],
    $java.oncias_SemanticTable$TypeGetter$isAnyOf$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticTable$TypeGetter$isAnyOf$lambda$_3_0_apply)],
    oncie_QuantifiedPath$$apply$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_QuantifiedPath$$apply$lambda$_1_0_apply)],
    $java.oncie_Expression$TreeAcc, "Expression$TreeAcc", 28, jl_Object, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncie_Expression$TreeAcc_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_Expression$TreeAcc_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Expression$TreeAcc_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_Expression$TreeAcc_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Expression$TreeAcc_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_Expression$TreeAcc_toString), "$equals", $rt_wrapFunction1($java.oncie_Expression$TreeAcc_equals)],
    oncie_Expression$TreeAcc$, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1_applyOrElse)],
    oncias_SemanticState$scope$lambda$_46_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticState$scope$lambda$_46_0_apply)],
    oncias_ExpressionTypeInfo, "ExpressionTypeInfo", 17, jl_Object, [s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncias_ExpressionTypeInfo_productPrefix), "$productArity", $rt_wrapFunction0($java.oncias_ExpressionTypeInfo_productArity), "$productElement", $rt_wrapFunction1($java.oncias_ExpressionTypeInfo_productElement), "$productIterator", $rt_wrapFunction0($java.oncias_ExpressionTypeInfo_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncias_ExpressionTypeInfo_hashCode),
    "$toString", $rt_wrapFunction0($java.oncias_ExpressionTypeInfo_toString), "$equals", $rt_wrapFunction1($java.oncias_ExpressionTypeInfo_equals)],
    $java.jusi_MappingStreamImpl$wrap$lambda$_1_0, 0, jl_Object, [$java.juf_Predicate], 0, 3, 0, 0, ["$test", $rt_wrapFunction1($java.jusi_MappingStreamImpl$wrap$lambda$_1_0_test)],
    $java.jusi_StreamOverSpliterator$AdapterAction, 0, jl_Object, [$java.juf_Consumer], 0, 0, 0, 0, 0,
    $java.jusi_FilteringStreamImpl$wrap$lambda$_1_0, 0, jl_Object, [$java.juf_Predicate], 0, 3, 0, 0, ["$test", $rt_wrapFunction1($java.jusi_FilteringStreamImpl$wrap$lambda$_1_0_test)],
    $java.scm_ArraySeq$ofRef, "ArraySeq$ofRef", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofRef_elemTag), "$length", $rt_wrapFunction0($java.scm_ArraySeq$ofRef_length), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofRef_apply), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofRef_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofRef_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofRef_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofRef_apply0),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofRef_array)],
    scm_ArraySeq$, 0, jl_Object, [sc_StrictOptimizedClassTagSeqFactory], 4, 3, 0, 0, ["$newBuilder0", $rt_wrapFunction1($java.scm_ArraySeq$_newBuilder0), "$from6", $rt_wrapFunction2($java.scm_ArraySeq$_from), "$empty4", $rt_wrapFunction1($java.scm_ArraySeq$_empty)],
    oncipj_EntityType, "EntityType", 19, jl_Enum, [], 12, 3, 0, oncipj_EntityType_$callClinit, 0,
    oncie_FixedQuantifier, "FixedQuantifier", 28, jl_Object, [$java.oncie_GraphPatternQuantifier, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_FixedQuantifier_position), "$canBeEmpty", $rt_wrapFunction0($java.oncie_FixedQuantifier_canBeEmpty), "$productPrefix", $rt_wrapFunction0($java.oncie_FixedQuantifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_FixedQuantifier_productArity), "$productElement", $rt_wrapFunction1($java.oncie_FixedQuantifier_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_FixedQuantifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_FixedQuantifier_hashCode), "$toString", $rt_wrapFunction0($java.oncie_FixedQuantifier_toString), "$equals", $rt_wrapFunction1($java.oncie_FixedQuantifier_equals), "$dup", $rt_wrapFunction1($java.oncie_FixedQuantifier_dup)],
    oncie_PlusQuantifier, "PlusQuantifier", 28, jl_Object, [$java.oncie_GraphPatternQuantifier, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_PlusQuantifier_position), "$canBeEmpty", $rt_wrapFunction0($java.oncie_PlusQuantifier_canBeEmpty), "$productPrefix", $rt_wrapFunction0($java.oncie_PlusQuantifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_PlusQuantifier_productArity), "$productElement", $rt_wrapFunction1($java.oncie_PlusQuantifier_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncie_PlusQuantifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_PlusQuantifier_hashCode), "$toString", $rt_wrapFunction0($java.oncie_PlusQuantifier_toString), "$equals", $rt_wrapFunction1($java.oncie_PlusQuantifier_equals), "$dup", $rt_wrapFunction1($java.oncie_PlusQuantifier_dup)],
    oncie_StarQuantifier, "StarQuantifier", 28, jl_Object, [$java.oncie_GraphPatternQuantifier, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_StarQuantifier_position), "$canBeEmpty", $rt_wrapFunction0($java.oncie_StarQuantifier_canBeEmpty), "$productPrefix", $rt_wrapFunction0($java.oncie_StarQuantifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_StarQuantifier_productArity), "$productElement", $rt_wrapFunction1($java.oncie_StarQuantifier_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncie_StarQuantifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_StarQuantifier_hashCode), "$toString", $rt_wrapFunction0($java.oncie_StarQuantifier_toString), "$equals", $rt_wrapFunction1($java.oncie_StarQuantifier_equals), "$dup", $rt_wrapFunction1($java.oncie_StarQuantifier_dup)],
    oncie_IntervalQuantifier, "IntervalQuantifier", 28, jl_Object, [$java.oncie_GraphPatternQuantifier, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_IntervalQuantifier_position), "$canBeEmpty", $rt_wrapFunction0($java.oncie_IntervalQuantifier_canBeEmpty), "$productPrefix", $rt_wrapFunction0($java.oncie_IntervalQuantifier_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_IntervalQuantifier_productArity), "$productElement", $rt_wrapFunction1($java.oncie_IntervalQuantifier_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_IntervalQuantifier_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_IntervalQuantifier_hashCode), "$toString", $rt_wrapFunction0($java.oncie_IntervalQuantifier_toString), "$equals", $rt_wrapFunction1($java.oncie_IntervalQuantifier_equals), "$dup", $rt_wrapFunction1($java.oncie_IntervalQuantifier_dup)]]);
    $rt_metadata([$java.sci_HashCollisionMapNode$removed$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_HashCollisionMapNode$removed$lambda$_13_0_apply)],
    $java.sm_Ordering$LongOrdering, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$Long$, 0, jl_Object, [$java.sm_Ordering$LongOrdering], 0, 3, 0, 0, 0,
    $java.sm_Ordering$CharOrdering, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$Char$, 0, jl_Object, [$java.sm_Ordering$CharOrdering], 0, 3, 0, 0, 0,
    $java.sm_Ordering$ByteOrdering, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$Byte$, 0, jl_Object, [$java.sm_Ordering$ByteOrdering], 0, 3, 0, 0, 0,
    $java.sm_Ordering$ShortOrdering, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$Short$, 0, jl_Object, [$java.sm_Ordering$ShortOrdering], 0, 3, 0, 0, 0,
    $java.sm_Ordering$BooleanOrdering, 0, jl_Object, [sm_Ordering], 3, 3, 0, 0, 0,
    sm_Ordering$Boolean$, 0, jl_Object, [$java.sm_Ordering$BooleanOrdering], 0, 3, 0, 0, ["$compare", $rt_wrapFunction2($java.sm_Ordering$Boolean$_compare)],
    su_Sorting$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncie_LogicalProperty$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncie_LogicalVariable$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sci_WrappedString, 0, sci_AbstractSeq, [sci_IndexedSeq, ji_Serializable], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sci_WrappedString_iterator), "$knownSize", $rt_wrapFunction0($java.sci_WrappedString_knownSize), "$length", $rt_wrapFunction0($java.sci_WrappedString_length), "$view0", $rt_wrapFunction0($java.sci_WrappedString_view)],
    onciap_DefaultExpressionStringifier$apply$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$apply$lambda$_7_0_apply)],
    $java.sm_Ordering$Tuple2Ordering, 0, jl_Object, [sm_Ordering], 4, 3, 0, 0, ["$compare", $rt_wrapFunction2($java.sm_Ordering$Tuple2Ordering_compare)],
    $java.oncie_FunctionInvocation$asCanonicalStringVal$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_FunctionInvocation$asCanonicalStringVal$lambda$_15_0_apply)],
    $java.oncie_ListLiteral$asCanonicalStringVal$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_ListLiteral$asCanonicalStringVal$lambda$_5_0_apply)],
    $java.oncie_MapExpression$asCanonicalStringVal$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_MapExpression$asCanonicalStringVal$lambda$_4_0_apply)],
    $java.jur_AbstractCharClass$1, "AbstractCharClass$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$1_contains)],
    $java.jur_AbstractCharClass$2, "AbstractCharClass$2", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$2_contains)],
    $java.jur_CharClass$18, "CharClass$18", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$18_contains), "$toString", $rt_wrapFunction0($java.jur_CharClass$18_toString)],
    $java.jur_CharClass$1, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$1_contains)],
    $java.jur_CharClass$3, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$3_contains)],
    $java.jur_CharClass$2, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$2_contains)],
    $java.jur_CharClass$5, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$5_contains)],
    $java.jur_CharClass$4, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$4_contains)],
    $java.jur_CharClass$7, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$7_contains)],
    $java.jur_CharClass$6, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$6_contains)],
    $java.jur_CharClass$9, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$9_contains)],
    $java.jur_CharClass$8, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$8_contains)],
    $java.jur_CharClass$11, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$11_contains)],
    $java.jur_CharClass$10, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$10_contains)],
    $java.jur_CharClass$13, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$13_contains)],
    $java.jur_CharClass$12, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$12_contains)],
    $java.jur_CharClass$15, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$15_contains)],
    $java.jur_CharClass$14, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$14_contains)],
    $java.jur_CharClass$17, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$17_contains)],
    $java.jur_CharClass$16, 0, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_CharClass$16_contains)],
    jur_MatchResultImpl, 0, jl_Object, [$java.jur_MatchResult], 0, 0, 0, 0, 0,
    onciap_DefaultExpressionStringifier$Syntactic$, "DefaultExpressionStringifier$Syntactic$", 16, jl_Object, [$java.onciap_DefaultExpressionStringifier$Binding, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Syntactic$_productArity), "$productElement", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$Syntactic$_productElement), "$productIterator", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Syntactic$_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Syntactic$_hashCode), "$toString", $rt_wrapFunction0($java.onciap_DefaultExpressionStringifier$Syntactic$_toString)],
    $java.oncia_CreateIndex$$anonfun$semanticCheck$1$lambda$_68_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_CreateIndex$$anonfun$semanticCheck$1$lambda$_68_0_apply)],
    sc_SeqOps$occCounts$lambda$_124_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_SeqOps$occCounts$lambda$_124_0_apply)],
    $java.sc_StrictOptimizedSeqOps$$anonfun$intersect$1$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_StrictOptimizedSeqOps$$anonfun$intersect$1$lambda$_19_0_apply)],
    $java.onciu_Foldable$FoldingBehavior, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.onciu_Foldable$SkipChildren, "Foldable$SkipChildren", 20, jl_Object, [$java.onciu_Foldable$FoldingBehavior, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_Foldable$SkipChildren_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_Foldable$SkipChildren_productArity), "$productElement", $rt_wrapFunction1($java.onciu_Foldable$SkipChildren_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_Foldable$SkipChildren_productIterator), "$toString",
    $rt_wrapFunction0($java.onciu_Foldable$SkipChildren_toString)],
    $java.onciu_Foldable$TraverseChildren, "Foldable$TraverseChildren", 20, jl_Object, [$java.onciu_Foldable$FoldingBehavior, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildren_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildren_productArity), "$productElement", $rt_wrapFunction1($java.onciu_Foldable$TraverseChildren_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildren_productIterator),
    "$toString", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildren_toString)],
    $java.onciu_Foldable$TraverseChildrenNewAccForSiblings, "Foldable$TraverseChildrenNewAccForSiblings", 20, jl_Object, [$java.onciu_Foldable$FoldingBehavior, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productArity), "$productElement", $rt_wrapFunction1($java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productElement),
    "$productIterator", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildrenNewAccForSiblings_productIterator), "$toString", $rt_wrapFunction0($java.onciu_Foldable$TraverseChildrenNewAccForSiblings_toString)],
    $java.onciu_Foldable$Folder$$anonfun$innerTreeFold$1$lambda$_13_0, "Foldable$Folder$$anonfun$innerTreeFold$1$lambda$_13_0", 20, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_Foldable$Folder$$anonfun$innerTreeFold$1$lambda$_13_0_apply)]]);
    $rt_metadata([$java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_0_apply)],
    $java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncie_IterablePredicateExpression$asCanonicalStringVal$lambda$_7_1_apply)],
    $java.oncia_Union$$anonfun$defineUnionVariables$6$lambda$_46_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$$anonfun$defineUnionVariables$6$lambda$_46_0_apply)],
    sc_IterableOnceOps$$anon$1, "IterableOnceOps$$anon$1", 42, sr_AbstractFunction1, [], 4, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_IterableOnceOps$$anon$1_apply)],
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$23$lambda$_47_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$$anonfun$stringify$23$lambda$_47_0_apply)],
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$28$lambda$_52_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$$anonfun$stringify$28$lambda$_52_0_apply)],
    $java.sc_MapView$FilterKeys, 0, sc_AbstractMapView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_MapView$FilterKeys_iterator), "$knownSize", $rt_wrapFunction0($java.sc_MapView$FilterKeys_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_MapView$FilterKeys_isEmpty)],
    $java.oncie_MultiOperatorExpression$asCanonicalStringVal$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_MultiOperatorExpression$asCanonicalStringVal$lambda$_2_0_apply)],
    $java.oncia_CompositePropertyConstraintCommand$$anonfun$semanticCheck$4$lambda$_6_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_CompositePropertyConstraintCommand$$anonfun$semanticCheck$4$lambda$_6_0_apply)],
    $java.onciap_DefaultExpressionStringifier$$anonfun$prettyScope$2$lambda$_63_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$$anonfun$prettyScope$2$lambda$_63_0_apply)],
    $java.oncius_ListType$$anonfun$isSubtypeOf$1$lambda$_54_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ListType$$anonfun$isSubtypeOf$1$lambda$_54_0_apply)],
    $java.onciu_RewritableCompat$PROXY$7_229, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_229, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_230, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_230, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_231, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_231, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_232, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_232, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_233, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_233, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_234, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_234, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_235, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_235, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_846, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_850, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_851, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_853, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_854, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_855, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_856, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_236, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_236, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_237, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_237, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_238, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_238, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_239, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_239, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_858, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_859, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_861, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_240, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_240, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_241, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_241, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_242, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_242, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.jur_BackReferencedSingleSet, "BackReferencedSingleSet", 2, $java.jur_SingleSet, [], 0, 0, 0, 0, ["$find1", $rt_wrapFunction3($java.jur_BackReferencedSingleSet_find), "$findBack", $rt_wrapFunction4($java.jur_BackReferencedSingleSet_findBack), "$processBackRefReplacement", $rt_wrapFunction0($java.jur_BackReferencedSingleSet_processBackRefReplacement)]]);
    $rt_metadata([$java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_0_apply)],
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_1_apply)],
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$applyOrElse$lambda$_0_2_apply)],
    $java.oncie_PathStep, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_SingleRelationshipPathStep, 0, oncie_Expression, [$java.oncie_PathStep, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_NodePathStep, 0, oncie_Expression, [$java.oncie_PathStep, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_MultiRelationshipPathStep, 0, oncie_Expression, [$java.oncie_PathStep, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_RepeatPathStep, 0, oncie_Expression, [$java.oncie_PathStep, ji_Serializable], 4, 3, 0, 0, 0,
    oncie_NilPathStep, 0, oncie_Expression, [$java.oncie_PathStep, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$query$lambda$_6_1_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_1_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_2_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_3_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$applyOrElse$lambda$_0_4_apply)],
    onciu_Last, "Last", 20, jl_Object, [$java.onciu_NonEmptyList, s_Product, ji_Serializable], 4, 3, 0, 0, ["$map5", $rt_wrapFunction1($java.onciu_Last_map), "$mapAndPrependReversedTo", $rt_wrapFunction2($java.onciu_Last_mapAndPrependReversedTo), "$foldLeft", $rt_wrapFunction2($java.onciu_Last_foldLeft), "$reduceLeft", $rt_wrapFunction1($java.onciu_Last_reduceLeft), "$reverse2", $rt_wrapFunction0($java.onciu_Last_reverse), "$toIterable", $rt_wrapFunction0($java.onciu_Last_toIterable), "$toIndexedSeq", $rt_wrapFunction0($java.onciu_Last_toIndexedSeq),
    "$knownSize", $rt_wrapFunction0($java.onciu_Last_knownSize), "$head", $rt_wrapFunction0($java.onciu_Last_head), "$tailOption", $rt_wrapFunction0($java.onciu_Last_tailOption), "$toString", $rt_wrapFunction0($java.onciu_Last_toString), "$iterator0", $rt_wrapFunction0($java.onciu_Last_iterator), "$productPrefix", $rt_wrapFunction0($java.onciu_Last_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_Last_productArity), "$productElement", $rt_wrapFunction1($java.onciu_Last_productElement), "$productIterator",
    $rt_wrapFunction0($java.onciu_Last_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciu_Last_hashCode), "$equals", $rt_wrapFunction1($java.onciu_Last_equals)],
    $java.ju_LinkedHashMap$1, 0, ju_AbstractSet, [], 0, 0, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_31_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_31_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.srj_JFunction0$mcZ$sp, 0, jl_Object, [s_Function0, ji_Serializable], 3, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.srj_JFunction0$mcZ$sp_apply)],
    onciap_Prettifier$asString$lambda$_32_0, 0, jl_Object, [$java.srj_JFunction0$mcZ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.srj_JFunction0$mcZ$sp_apply)],
    onciap_Prettifier$asString$lambda$_32_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_5, 0, jl_Object, [$java.srj_JFunction0$mcZ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.srj_JFunction0$mcZ$sp_apply)],
    onciap_Prettifier$asString$lambda$_32_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_7, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_8, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_9, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_10, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_11, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_12, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_13, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_14, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_15, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_16, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_17, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_18, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_19, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_20, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_21, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_22, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_32_23, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncius_TypeSpec$$exact$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$exact$lambda$_4_0_apply)],
    $java.oncie_SemanticDirection, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_SemanticDirection$INCOMING$, "SemanticDirection$INCOMING$", 28, jl_Object, [$java.oncie_SemanticDirection, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncie_SemanticDirection$INCOMING$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_SemanticDirection$INCOMING$_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SemanticDirection$INCOMING$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_SemanticDirection$INCOMING$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_SemanticDirection$INCOMING$_toString)],
    oncie_SemanticDirection$BOTH$, "SemanticDirection$BOTH$", 28, jl_Object, [$java.oncie_SemanticDirection, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncie_SemanticDirection$BOTH$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_SemanticDirection$BOTH$_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SemanticDirection$BOTH$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_SemanticDirection$BOTH$_hashCode), "$toString", $rt_wrapFunction0($java.oncie_SemanticDirection$BOTH$_toString)]]);
    $rt_metadata([oncie_SemanticDirection$OUTGOING$, "SemanticDirection$OUTGOING$", 28, jl_Object, [$java.oncie_SemanticDirection, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncie_SemanticDirection$OUTGOING$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_SemanticDirection$OUTGOING$_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_SemanticDirection$OUTGOING$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_SemanticDirection$OUTGOING$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncie_SemanticDirection$OUTGOING$_toString)],
    sci_ArraySeq$$newBuilder$lambda$_21_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_ArraySeq$$newBuilder$lambda$_21_0_apply)],
    s_Enumeration$Value, "Enumeration$Value", 38, jl_Object, [sm_Ordered, ji_Serializable], 1, 3, 0, 0, ["$equals", $rt_wrapFunction1($java.s_Enumeration$Value_equals), "$hashCode0", $rt_wrapFunction0($java.s_Enumeration$Value_hashCode)],
    $java.s_Enumeration$Val, "Enumeration$Val", 38, s_Enumeration$Value, [], 0, 3, 0, 0, ["$toString", $rt_wrapFunction0($java.s_Enumeration$Val_toString)],
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1_applyOrElse)],
    $java.ju_AbstractList$SubAbstractList, 0, ju_AbstractList, [], 0, 0, 0, 0, ["$get", $rt_wrapFunction1($java.ju_AbstractList$SubAbstractList_get), "$iterator", $rt_wrapFunction0($java.ju_AbstractList$SubAbstractList_iterator), "$size", $rt_wrapFunction0($java.ju_AbstractList$SubAbstractList_size)],
    $java.ju_AbstractList$SubAbstractListRandomAccess, 0, $java.ju_AbstractList$SubAbstractList, [ju_RandomAccess], 4, 0, 0, 0, 0,
    oncias_SymbolUse$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    onciap_DefaultPathStepStringifier$relationshipPathStep$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultPathStepStringifier$relationshipPathStep$lambda$_1_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_DefaultPathStepStringifier$repeatPathStep$lambda$_2_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_33_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_33_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asString$lambda$_33_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$getStartOfCommand$1$lambda$_60_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$getStartOfCommand$1$lambda$_60_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$propertiesToString$1$lambda$_53_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$fulltextPropertiesToString$1$lambda$_55_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$showClausesAsString$1$lambda$_67_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$showClausesAsString$1$lambda$_67_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$showClausesAsString$1$lambda$_67_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$asIndividualOptions$lambda$_36_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncias_ExpressionTypeInfo$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncias_SemanticCheck$$anonfun$chain$1$lambda$_31_0, "SemanticCheck$$anonfun$chain$1$lambda$_31_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$anonfun$chain$1$lambda$_31_0_apply)],
    onciap_Prettifier$optionsToString$lambda$_35_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.sc_SeqOps$$anonfun$occCounts$1$lambda$_141_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_SeqOps$$anonfun$occCounts$1$lambda$_141_0_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$$anonfun$applyOrElse$4$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$$nestedInanonfun$check$1$1$$anonfun$applyOrElse$4$lambda$_3_0_apply)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_0_apply)],
    $java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncirr_mergeInPredicates$$anonfun$$nestedInanonfun$collectInPredicates$1$1$$anonfun$applyOrElse$9$lambda$_4_1_apply)],
    $java.onciu_RewritableCompat$PROXY$7_243, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_243, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_866, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_873, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_244, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_244, 0, jl_Object, [], 0, 3, 0, 0, 0,
    ju_LinkedHashMap$KeyIterator, 0, ju_LinkedHashMap$AbstractMapIterator, [ju_Iterator], 0, 0, 0, 0, ["$next", $rt_wrapFunction0(ju_LinkedHashMap$KeyIterator_next)],
    $java.oncie_QuantifiedPath$allVariables$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_QuantifiedPath$allVariables$lambda$_9_0_apply)],
    $java.oncie_PathConcatenation$allVariables$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_PathConcatenation$allVariables$lambda$_4_0_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$applyOrElse$lambda$_0_1_apply)],
    $java.jur_AbstractCharClass$LazyJavaLowerCase$1, "AbstractCharClass$LazyJavaLowerCase$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaLowerCase$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaUpperCase$1, "AbstractCharClass$LazyJavaUpperCase$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaUpperCase$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaWhitespace$1, "AbstractCharClass$LazyJavaWhitespace$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaWhitespace$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaMirrored$1, "AbstractCharClass$LazyJavaMirrored$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaMirrored$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaDefined$1, "AbstractCharClass$LazyJavaDefined$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaDefined$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaDigit$1, "AbstractCharClass$LazyJavaDigit$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaDigit$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable$1, "AbstractCharClass$LazyJavaIdentifierIgnorable$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaIdentifierIgnorable$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaISOControl$1, "AbstractCharClass$LazyJavaISOControl$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaISOControl$1_contains)]]);
    $rt_metadata([$java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart$1, "AbstractCharClass$LazyJavaJavaIdentifierPart$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaJavaIdentifierPart$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart$1, "AbstractCharClass$LazyJavaJavaIdentifierStart$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaJavaIdentifierStart$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaLetter$1, "AbstractCharClass$LazyJavaLetter$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaLetter$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaLetterOrDigit$1, "AbstractCharClass$LazyJavaLetterOrDigit$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaLetterOrDigit$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaSpaceChar$1, "AbstractCharClass$LazyJavaSpaceChar$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaSpaceChar$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaTitleCase$1, "AbstractCharClass$LazyJavaTitleCase$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaTitleCase$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart$1, "AbstractCharClass$LazyJavaUnicodeIdentifierPart$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierPart$1_contains)],
    $java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart$1, "AbstractCharClass$LazyJavaUnicodeIdentifierStart$1", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_AbstractCharClass$LazyJavaUnicodeIdentifierStart$1_contains)],
    $java.jur_UnicodeCategory, "UnicodeCategory", 2, jur_AbstractCharClass, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_UnicodeCategory_contains)],
    $java.jur_UnicodeCategoryScope, "UnicodeCategoryScope", 2, $java.jur_UnicodeCategory, [], 0, 0, 0, 0, ["$contains2", $rt_wrapFunction1($java.jur_UnicodeCategoryScope_contains)],
    onciap_DefaultPatternStringifier$apply$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_3_0_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_3_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_3_1_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_3_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_3_2_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_3_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_3_3_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_3_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultPatternStringifier$apply$lambda$_3_4_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_5_0_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_5_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_5_1_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_5_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_5_2_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_5_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_5_3_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_5_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultPatternStringifier$apply$lambda$_5_4_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_5_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_5_5_apply)],
    $java.scm_ArraySeq$$newBuilder$lambda$_21_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.scm_ArraySeq$$newBuilder$lambda$_21_0_apply)],
    $java.sc_MapView$FilterKeys$iterator$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_MapView$FilterKeys$iterator$lambda$_0_0_apply)],
    onciu_Fby, "Fby", 20, jl_Object, [$java.onciu_NonEmptyList, s_Product, ji_Serializable], 4, 3, 0, 0, ["$map5", $rt_wrapFunction1($java.onciu_Fby_map), "$mapAndPrependReversedTo", $rt_wrapFunction2($java.onciu_Fby_mapAndPrependReversedTo), "$foldLeft", $rt_wrapFunction2($java.onciu_Fby_foldLeft), "$reduceLeft", $rt_wrapFunction1($java.onciu_Fby_reduceLeft), "$reverse2", $rt_wrapFunction0($java.onciu_Fby_reverse), "$toIterable", $rt_wrapFunction0($java.onciu_Fby_toIterable), "$toIndexedSeq", $rt_wrapFunction0($java.onciu_Fby_toIndexedSeq),
    "$knownSize", $rt_wrapFunction0($java.onciu_Fby_knownSize), "$head", $rt_wrapFunction0($java.onciu_Fby_head), "$tailOption", $rt_wrapFunction0($java.onciu_Fby_tailOption), "$toString", $rt_wrapFunction0($java.onciu_Fby_toString), "$iterator0", $rt_wrapFunction0($java.onciu_Fby_iterator), "$productPrefix", $rt_wrapFunction0($java.onciu_Fby_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_Fby_productArity), "$productElement", $rt_wrapFunction1($java.onciu_Fby_productElement), "$productIterator",
    $rt_wrapFunction0($java.onciu_Fby_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciu_Fby_hashCode), "$equals", $rt_wrapFunction1($java.onciu_Fby_equals)],
    onciap_Prettifier$$escapeNames$lambda$_16_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncia_PropertyResource, 0, jl_Object, [$java.oncia_ActionResource, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    onciap_Prettifier$$prettifyGraphPrivilege$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncia_LabelResource, 0, jl_Object, [$java.oncia_ActionResource, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    onciap_Prettifier$$prettifyGraphPrivilege$lambda$_7_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$$anonfun$prettifyLoadPrivilegeQualifier$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.onciap_Prettifier$$anonfun$prettifyLoadPrivilegeQualifier$1_applyOrElse0)],
    onciap_Prettifier$propertiesMapToString$lambda$_30_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncil_LabelExpression$Disjunctions$, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.onciu_DeprecatedPropertyReferenceInCreate, "DeprecatedPropertyReferenceInCreate", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_DeprecatedPropertyReferenceInCreate_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_DeprecatedPropertyReferenceInCreate_productArity), "$productElement", $rt_wrapFunction1($java.onciu_DeprecatedPropertyReferenceInCreate_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_DeprecatedPropertyReferenceInCreate_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_DeprecatedPropertyReferenceInCreate_hashCode), "$toString", $rt_wrapFunction0($java.onciu_DeprecatedPropertyReferenceInCreate_toString), "$equals", $rt_wrapFunction1($java.onciu_DeprecatedPropertyReferenceInCreate_equals)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findSelfReferenceVariablesInPattern$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findSelfReferenceVariablesInPattern$lambda$_2_0_apply)],
    $java.jur_Matcher$1, "Matcher$1", 2, jl_Object, [], 0, 0, 0, 0, ["$toString", $rt_wrapFunction0($java.jur_Matcher$1_toString)],
    onciap_DefaultPatternStringifier$concatenate$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$concatenate$lambda$_9_0_apply)],
    onciap_DefaultPatternStringifier$concatenate$lambda$_9_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$concatenate$lambda$_9_1_apply)],
    onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_0_apply)],
    onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_1_apply)],
    onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_2_apply)],
    onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$stringifyRange$lambda$_10_3_apply)],
    oncia_ProcedureAllQualifier, 0, jl_Object, [$java.oncia_ProcedurePrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    oncia_FunctionAllQualifier, 0, jl_Object, [$java.oncia_FunctionPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    oncia_SettingAllQualifier, 0, jl_Object, [$java.oncia_SettingPrivilegeQualifier, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncius_TypeSpec$$minimalRanges$lambda$_12_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncius_TypeSpec$$minimalRanges$lambda$_12_0_apply)],
    $java.onciap_DefaultExpressionStringifier$$anonfun$stringify$26$lambda$_50_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultExpressionStringifier$$anonfun$stringify$26$lambda$_50_0_apply)],
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$2$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$2$lambda$_3_0_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$1$lambda$_3_0, "AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$1$lambda$_3_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$1$lambda$_3_0_apply)],
    $java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$4$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$anonfun$2$$anonfun$applyOrElse$4$lambda$_5_0_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$4$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$4$lambda$_6_0_apply)]]);
    $rt_metadata([$java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$7$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$ambiguousExpressions$1$$anonfun$applyOrElse$7$lambda$_9_0_apply)],
    onciap_Prettifier$$anonfun$stringify$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, 0,
    onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_1_apply)],
    onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_2_apply)],
    onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_3_apply)],
    onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_6_apply)],
    onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$extractPropertyRuleExpression$1$lambda$_43_5_apply)],
    oncius_TypeRange$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    scm_Builder$$anon$1, "Builder$$anon$1", 44, jl_Object, [scm_Builder], 4, 3, 0, 0, ["$sizeHint0", $rt_wrapFunction2($java.scm_Builder$$anon$1_sizeHint), "$sizeHint", $rt_wrapFunction1($java.scm_Builder$$anon$1_sizeHint0), "$result0", $rt_wrapFunction0(scm_Builder$$anon$1_result), "$addAll0", $rt_wrapFunction1($java.scm_Builder$$anon$1_addAll), "$addOne", $rt_wrapFunction1(scm_Builder$$anon$1_addOne)],
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_0, "ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_0_apply)],
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_1_apply)],
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$2$lambda$_37_2_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_1_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_2_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_3_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_4_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_5_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_6_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_7_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_8_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_9_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_10_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_11_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_12_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_13_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_14_apply)],
    $java.oncie_PartialPredicate, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_15_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_16_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_17_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_18_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_19, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_20, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_21_apply)],
    $java.oncie_ASTCachedProperty, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.oncie_CachedProperty, 0, $java.oncie_LogicalProperty, [$java.oncie_ASTCachedProperty, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_22_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_23_apply)],
    $java.oncie_CachedHasProperty, 0, $java.oncie_LogicalProperty, [$java.oncie_ASTCachedProperty, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_24_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_25_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26, "SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_26_apply)],
    $java.oncie_GetDegree, 0, oncie_Expression, [ji_Serializable], 0, 3, 0, 0, 0,
    oncias_SemanticFunctionCheck$, 0, jl_Object, [oncias_SemanticAnalysisTooling], 4, 3, 0, 0, ["$specifyType0", $rt_wrapFunction2($java.oncias_SemanticFunctionCheck$_specifyType), "$expectType3", $rt_wrapFunction4($java.oncias_SemanticFunctionCheck$_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$_expectType$default$4), "$types2", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$_types)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_27_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_28_apply)],
    $java.oncie_ImplicitProcedureArgument, 0, oncie_Expression, [ji_Serializable], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_29_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_30_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_31_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_32_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_33_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_34_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_35_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_36_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_37_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_38_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_39_apply)],
    oncias_SemanticExpressionCheck$FilteringExpressions$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_40_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_41_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_42_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_43_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_44_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_45_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_46, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    oncias_SemanticPatternCheck$, 0, jl_Object, [oncias_SemanticAnalysisTooling], 4, 3, 0, oncias_SemanticPatternCheck$_$callClinit, ["$expectType", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$_expectType), "$expectType3", $rt_wrapFunction4($java.oncias_SemanticPatternCheck$_expectType0), "$expectType$default$4", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$_expectType$default$4)],
    $java.oncie_Pattern$SemanticContext, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncie_Pattern$SemanticContext$Expression$, "Pattern$SemanticContext$Expression$", 28, jl_Object, [$java.oncie_Pattern$SemanticContext, s_Product, ji_Serializable], 0, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Expression$_name), "$description", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Expression$_description), "$productArity", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Expression$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Pattern$SemanticContext$Expression$_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Expression$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Expression$_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Expression$_toString)],
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1_applyOrElse)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_47_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_48_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_49_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_50_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_51_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_52_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_53_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_54_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_55_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_56_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_57_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_58_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_59_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_60_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_61_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_62_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_63_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_64_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_65_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_66_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_67_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_68_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_69_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_70_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_71_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_72_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_73_apply)]]);
    $rt_metadata([$java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_74_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_75_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_76_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_77_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_78_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_79_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_80_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_81_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_82_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_83_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_84_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$1$lambda$_174_85_apply)],
    $java.oncia_SingleQuery$$anonfun$checkClauses$2$lambda$_139_0, "SingleQuery$$anonfun$checkClauses$2$lambda$_139_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkClauses$2$lambda$_139_0_apply)],
    sc_IterableOnceOps$max$lambda$_81_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.sc_IterableOnceOps$max$lambda$_81_0_apply)],
    onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$propertyInNodePrettifier$1$lambda$_40_2_apply)],
    onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$$propertyAndWherePrettifier$1$lambda$_36_1_apply)],
    $java.oncia_ReadAdministrationCommand$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_ReadAdministrationCommand$$anonfun$1_applyOrElse)],
    $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_0_apply)],
    $java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ReadAdministrationCommand$checkForSubquery$1$lambda$_29_1_apply)],
    $java.oncias_SemanticExpressionCheck$$infixAddRhsTypes$lambda$_56_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$infixAddOutputTypes$lambda$_57_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$infixAddOutputTypes$lambda$_57_0_apply)],
    onciuh_Try$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$checkAddBoundary$lambda$_52_0, 0, jl_Object, [srj_JFunction0$mcJ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(srj_JFunction0$mcJ$sp_apply), "$apply$mcJ$sp", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkAddBoundary$lambda$_52_0_apply$mcJ$sp)],
    $java.oncias_SemanticExpressionCheck$$checkSubtractBoundary$lambda$_53_0, 0, jl_Object, [srj_JFunction0$mcJ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(srj_JFunction0$mcJ$sp_apply), "$apply$mcJ$sp", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkSubtractBoundary$lambda$_53_0_apply$mcJ$sp)],
    $java.oncias_SemanticExpressionCheck$$checkUnarySubtractBoundary$lambda$_54_0, 0, jl_Object, [srj_JFunction0$mcJ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(srj_JFunction0$mcJ$sp_apply), "$apply$mcJ$sp", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkUnarySubtractBoundary$lambda$_54_0_apply$mcJ$sp)],
    $java.oncias_SemanticExpressionCheck$$checkMultiplyBoundary$lambda$_55_0, 0, jl_Object, [srj_JFunction0$mcJ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(srj_JFunction0$mcJ$sp_apply), "$apply$mcJ$sp", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkMultiplyBoundary$lambda$_55_0_apply$mcJ$sp)],
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_0_apply)],
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_1_apply)],
    $java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkInnerListComprehension$lambda$_58_2_apply)],
    $java.oncias_SemanticExpressionCheck$$possibleTypes$1$lambda$_124_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$possibleTypes$1$lambda$_124_0_apply)],
    $java.oncia_SingleQuery$checkHorizon$lambda$_74_0, "SingleQuery$checkHorizon$lambda$_74_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkHorizon$lambda$_74_0_apply)],
    $java.onciu_RewritableCompat$PROXY$7_245, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_245, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_246, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_246, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_247, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_247, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_884, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_885, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_886, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_890, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_893, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_894, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_895, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_248, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_248, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_249, 0, jl_Object, [], 0, 3, 0, 0, 0]);
    $rt_metadata([onciu_RewritableCompat$PROXY$5_249, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncie_SensitiveAutoParameter, 0, jl_Object, [$java.oncie_SensitiveParameter], 3, 3, 0, 0, 0,
    $java.oncius_TypeSpec$constrain$lambda$_20_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$constrain$lambda$_20_0_apply)],
    $java.oncias_SemanticFunctionCheck$$check$lambda$_40_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$check$lambda$_40_0_apply)],
    $java.oncias_SemanticFunctionCheck$$check$lambda$_40_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$check$lambda$_40_1_apply)],
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$semanticCheck$lambda$_1_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$FilteringExpressions$$semanticCheck$lambda$_1_0_apply)],
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_2_0_apply)],
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkPredicateDefined$lambda$_4_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkPredicateDefined$lambda$_4_0_apply)],
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$FilteringExpressions$$failIfAggregating$lambda$_3_0_apply)],
    oncie_Pattern$SemanticContext$Match$, "Pattern$SemanticContext$Match$", 28, jl_Object, [$java.oncie_Pattern$SemanticContext, s_Product, ji_Serializable], 0, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Match$_name), "$description", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Match$_description), "$productArity", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Match$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Pattern$SemanticContext$Match$_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Match$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Match$_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Match$_toString)],
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_42_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$declareVariables$lambda$_42_0_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_43_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$check$lambda$_43_0_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$check$lambda$_48_0_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$check$lambda$_48_1_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticPatternCheck$$check$lambda$_48_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$check$lambda$_48_3_apply)],
    $java.onciuh_Try, 0, jl_Object, [], 3, 3, 0, 0, 0,
    $java.onciuh_Success, 0, jl_Object, [$java.onciuh_Try, s_Product, ji_Serializable], 0, 3, 0, 0, ["$isFailure", $rt_wrapFunction0($java.onciuh_Success_isFailure)],
    onciuh_Failure$, 0, jl_Object, [$java.onciuh_Try], 4, 3, 0, 0, ["$isFailure", $rt_wrapFunction0($java.onciuh_Failure$_isFailure)],
    $java.jl_InterruptedException, 0, jl_Exception, [], 0, 3, 0, 0, 0,
    $java.suc_ControlThrowable, 0, jl_Throwable, [], 1, 3, 0, 0, 0,
    $java.onciu_Fby$$anon$2, "Fby$$anon$2", 20, jl_Object, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.onciu_Fby$$anon$2_iterator), "$isEmpty", $rt_wrapFunction0($java.onciu_Fby$$anon$2_isEmpty), "$toString", $rt_wrapFunction0($java.onciu_Fby$$anon$2_toString), "$foreach", $rt_wrapFunction1($java.onciu_Fby$$anon$2_foreach), "$exists", $rt_wrapFunction1($java.onciu_Fby$$anon$2_exists), "$find0", $rt_wrapFunction1($java.onciu_Fby$$anon$2_find), "$foldLeft", $rt_wrapFunction2($java.onciu_Fby$$anon$2_foldLeft),
    "$nonEmpty0", $rt_wrapFunction0($java.onciu_Fby$$anon$2_nonEmpty), "$size", $rt_wrapFunction0($java.onciu_Fby$$anon$2_size), "$copyToArray1", $rt_wrapFunction1($java.onciu_Fby$$anon$2_copyToArray), "$copyToArray0", $rt_wrapFunction2($java.onciu_Fby$$anon$2_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.onciu_Fby$$anon$2_copyToArray1), "$to0", $rt_wrapFunction1($java.onciu_Fby$$anon$2_to), "$toSeq", $rt_wrapFunction0($java.onciu_Fby$$anon$2_toSeq), "$toArray", $rt_wrapFunction1($java.onciu_Fby$$anon$2_toArray),
    "$knownSize", $rt_wrapFunction0($java.onciu_Fby$$anon$2_knownSize), "$hasNext", $rt_wrapFunction0($java.onciu_Fby$$anon$2_hasNext), "$next", $rt_wrapFunction0($java.onciu_Fby$$anon$2_next)],
    $java.onciu_Last$$anon$3, "Last$$anon$3", 20, jl_Object, [sc_Iterator], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.onciu_Last$$anon$3_iterator), "$isEmpty", $rt_wrapFunction0($java.onciu_Last$$anon$3_isEmpty), "$toString", $rt_wrapFunction0($java.onciu_Last$$anon$3_toString), "$foreach", $rt_wrapFunction1($java.onciu_Last$$anon$3_foreach), "$exists", $rt_wrapFunction1($java.onciu_Last$$anon$3_exists), "$find0", $rt_wrapFunction1($java.onciu_Last$$anon$3_find), "$foldLeft", $rt_wrapFunction2($java.onciu_Last$$anon$3_foldLeft),
    "$nonEmpty0", $rt_wrapFunction0($java.onciu_Last$$anon$3_nonEmpty), "$size", $rt_wrapFunction0($java.onciu_Last$$anon$3_size), "$copyToArray1", $rt_wrapFunction1($java.onciu_Last$$anon$3_copyToArray), "$copyToArray0", $rt_wrapFunction2($java.onciu_Last$$anon$3_copyToArray0), "$copyToArray", $rt_wrapFunction3($java.onciu_Last$$anon$3_copyToArray1), "$to0", $rt_wrapFunction1($java.onciu_Last$$anon$3_to), "$toSeq", $rt_wrapFunction0($java.onciu_Last$$anon$3_toSeq), "$toArray", $rt_wrapFunction1($java.onciu_Last$$anon$3_toArray),
    "$knownSize", $rt_wrapFunction0($java.onciu_Last$$anon$3_knownSize), "$hasNext", $rt_wrapFunction0($java.onciu_Last$$anon$3_hasNext), "$next", $rt_wrapFunction0($java.onciu_Last$$anon$3_next)],
    $java.oncie_Expression$$anonfun$arguments$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncie_Expression$$anonfun$arguments$1_applyOrElse)],
    $java.sc_StringView, 0, sc_AbstractIndexedSeqView, [s_Product], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.sc_StringView_length), "$apply1", $rt_wrapFunction1($java.sc_StringView_apply)],
    $java.ju_AbstractList$SubAbstractList$SubAbstractListIterator, 0, jl_Object, [ju_ListIterator], 4, 0, 0, 0, ["$hasNext", $rt_wrapFunction0($java.ju_AbstractList$SubAbstractList$SubAbstractListIterator_hasNext), "$next", $rt_wrapFunction0($java.ju_AbstractList$SubAbstractList$SubAbstractListIterator_next)],
    onciap_DefaultPatternStringifier$apply$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_6_0_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_7_0_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_7_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_7_1_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_7_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultPatternStringifier$apply$lambda$_7_2_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_7_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_7_3_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_7_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultPatternStringifier$apply$lambda$_7_4_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_7_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_7_5_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_7_6, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_DefaultPatternStringifier$apply$lambda$_7_6_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_8_0_apply)],
    $java.scm_ArraySeq$ofInt, "ArraySeq$ofInt", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofInt_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofInt_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofInt_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofInt_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofInt_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofInt_apply1), "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofInt_elemTag),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofInt_array)],
    $java.scm_ArraySeq$ofDouble, "ArraySeq$ofDouble", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofDouble_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofDouble_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofDouble_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofDouble_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofDouble_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofDouble_apply1), "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofDouble_elemTag),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofDouble_array)],
    $java.scm_ArraySeq$ofLong, "ArraySeq$ofLong", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofLong_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofLong_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofLong_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofLong_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofLong_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofLong_apply1), "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofLong_elemTag),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofLong_array)],
    $java.scm_ArraySeq$ofFloat, "ArraySeq$ofFloat", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofFloat_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofFloat_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofFloat_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofFloat_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofFloat_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofFloat_apply1), "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofFloat_elemTag),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofFloat_array)],
    $java.scm_ArraySeq$ofByte, "ArraySeq$ofByte", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofByte_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofByte_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofByte_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofByte_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofByte_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofByte_apply1), "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofByte_elemTag),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofByte_array)],
    $java.scm_ArraySeq$ofShort, "ArraySeq$ofShort", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofShort_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofShort_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofShort_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofShort_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofShort_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofShort_apply1), "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofShort_elemTag),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofShort_array)],
    $java.scm_ArraySeq$ofBoolean, "ArraySeq$ofBoolean", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofBoolean_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofBoolean_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofBoolean_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofBoolean_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofBoolean_apply0), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofBoolean_apply1), "$elemTag",
    $rt_wrapFunction0($java.scm_ArraySeq$ofBoolean_elemTag), "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofBoolean_array)],
    $java.scm_ArraySeq$ofUnit, "ArraySeq$ofUnit", 44, $java.scm_ArraySeq, [], 4, 3, 0, 0, ["$length", $rt_wrapFunction0($java.scm_ArraySeq$ofUnit_length), "$hashCode0", $rt_wrapFunction0($java.scm_ArraySeq$ofUnit_hashCode), "$equals", $rt_wrapFunction1($java.scm_ArraySeq$ofUnit_equals), "$iterator0", $rt_wrapFunction0($java.scm_ArraySeq$ofUnit_iterator), "$apply", $rt_wrapFunction1($java.scm_ArraySeq$ofUnit_apply), "$apply1", $rt_wrapFunction1($java.scm_ArraySeq$ofUnit_apply0), "$elemTag", $rt_wrapFunction0($java.scm_ArraySeq$ofUnit_elemTag),
    "$array7", $rt_wrapFunction0($java.scm_ArraySeq$ofUnit_array)],
    oncia_SingleNamedGraphScope, 0, jl_Object, [$java.oncia_GraphScope, s_Product, ji_Serializable], 4, 3, 0, 0, 0,
    oncil_LabelExpression$Conjunctions$, 0, jl_Object, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncie_Expression$TreeAcc$inScope$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_Expression$TreeAcc$inScope$lambda$_4_0_apply)],
    $java.oncias_package$$liftSemanticErrorDef$lambda$_6_0, "package$$liftSemanticErrorDef$lambda$_6_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_package$$liftSemanticErrorDef$lambda$_6_0_apply)],
    $java.oncias_SemanticExpressionCheck$$check$lambda$_51_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$check$lambda$_51_0_apply)],
    $java.oncias_SemanticExpressionCheck$$checkLabelExpressionForLegacyRelationshipTypeDisjunction$lambda$_46_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$checkLabelExpressionForLegacyRelationshipTypeDisjunction$lambda$_46_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$dispatch$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0]);
    $rt_metadata([$java.oncie_VariableGrouping, "VariableGrouping", 28, jl_Object, [onciu_ASTNode, ji_Serializable], 0, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncie_VariableGrouping_position), "$productPrefix", $rt_wrapFunction0($java.oncie_VariableGrouping_productPrefix), "$productArity", $rt_wrapFunction0($java.oncie_VariableGrouping_productArity), "$productElement", $rt_wrapFunction1($java.oncie_VariableGrouping_productElement), "$productIterator", $rt_wrapFunction0($java.oncie_VariableGrouping_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncie_VariableGrouping_hashCode), "$toString", $rt_wrapFunction0($java.oncie_VariableGrouping_toString), "$equals", $rt_wrapFunction1($java.oncie_VariableGrouping_equals), "$dup", $rt_wrapFunction1($java.oncie_VariableGrouping_dup)],
    $java.oncias_SemanticFunctionCheck$$anonfun$checkNoNestedAggregateFunctions$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticFunctionCheck$$anonfun$checkNoNestedAggregateFunctions$1_applyOrElse)],
    $java.oncias_SemanticFunctionCheck$$checkNoNestedAggregateFunctions$lambda$_41_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$checkNoNestedAggregateFunctions$lambda$_41_0_apply)],
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkInnerPredicate$lambda$_5_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$FilteringExpressions$$checkInnerPredicate$lambda$_5_0_apply)],
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_0_apply)],
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_1_apply)],
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_2, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_2_apply)],
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_3_apply)],
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$declareVariables$lambda$_56_4_apply)],
    oncie_Pattern$SemanticContext$Merge$, "Pattern$SemanticContext$Merge$", 28, jl_Object, [$java.oncie_Pattern$SemanticContext, s_Product, ji_Serializable], 0, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Merge$_name), "$description", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Merge$_description), "$productArity", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Merge$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Pattern$SemanticContext$Merge$_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Merge$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Merge$_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Merge$_toString)],
    oncie_Pattern$SemanticContext$Create$, "Pattern$SemanticContext$Create$", 28, jl_Object, [$java.oncie_Pattern$SemanticContext, s_Product, ji_Serializable], 0, 3, 0, 0, ["$name3", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Create$_name), "$description", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Create$_description), "$productArity", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Create$_productArity), "$productElement", $rt_wrapFunction1($java.oncie_Pattern$SemanticContext$Create$_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Create$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Create$_hashCode), "$toString", $rt_wrapFunction0($java.oncie_Pattern$SemanticContext$Create$_toString)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkNoQuantifiedPatterns$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$anonfun$checkNoQuantifiedPatterns$1$1_applyOrElse), "$isDefinedAt", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$checkNoQuantifiedPatterns$1$1_isDefinedAt)],
    $java.oncias_SemanticPatternCheck$$checkContainsSingle$1$lambda$_83_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkContainsSingle$1$lambda$_83_0_apply)],
    $java.onciu_UnboundedShortestPathNotification, "UnboundedShortestPathNotification", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_UnboundedShortestPathNotification_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_UnboundedShortestPathNotification_productArity), "$productElement", $rt_wrapFunction1($java.onciu_UnboundedShortestPathNotification_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_UnboundedShortestPathNotification_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_UnboundedShortestPathNotification_hashCode), "$toString", $rt_wrapFunction0($java.onciu_UnboundedShortestPathNotification_toString), "$equals", $rt_wrapFunction1($java.onciu_UnboundedShortestPathNotification_equals)],
    $java.oncias_SemanticPatternCheck$$checkRelVariablesUnknown$1$lambda$_88_0, "SemanticPatternCheck$$checkRelVariablesUnknown$1$lambda$_88_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkRelVariablesUnknown$1$lambda$_88_0_apply)],
    oncias_checkNoParamMapsWhenMatching$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncias_checkValidPropertyKeyNamesInPattern$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncias_SemanticPatternCheck$$checkIsKeyword$lambda$_67_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkIsKeyword$lambda$_67_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkLabelExpressions$lambda$_66_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkLabelExpressions$lambda$_66_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkPredicate$lambda$_65_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkPredicate$lambda$_65_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$checkValidJuxtaposition$lambda$_50_1_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1_applyOrElse)],
    $java.oncias_SemanticPatternCheck$$checkRelCount$1$lambda$_95_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$checkRelCount$1$lambda$_95_0_apply)],
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_0_apply)],
    $java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_ExpressionTypeInfo$actual$lzycompute$lambda$_6_1_apply)],
    $java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_CaseExpression$possibleExpressions$lzycompute$lambda$_7_0_apply)],
    oncias_ScopeTreeVerifier$$anonfun$$nestedInanonfun$verify$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_ScopeTreeVerifier$$anonfun$$nestedInanonfun$verify$1$1_applyOrElse)],
    $java.oncias_SemanticPatternCheck$$declareVariables$lambda$_59_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$declareVariables$lambda$_59_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkNoVarLengthWhenUpdating$1$lambda$_104_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$checkNoVarLengthWhenUpdating$1$lambda$_104_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_1_apply)],
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_2_apply)],
    $java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkForLegacyTypeSeparator$1$lambda$_110_3_apply)],
    $java.oncias_SemanticPatternCheck$$checkLabelExpressions$1$lambda$_116_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkLabelExpressions$1$lambda$_116_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkPredicate$1$lambda$_122_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkPredicate$1$lambda$_122_0_apply)],
    oncie_Pattern$SemanticContext$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_NonEmptyList$reverse$lambda$_61_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_NonEmptyList$reverse$lambda$_61_0_apply)],
    $java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$$anonfun$applyOrElse$10$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_AmbiguousAggregation$$anonfun$notProjectedAggregationExpression$1$$anonfun$applyOrElse$10$lambda$_4_0_apply)],
    $java.oncil_LabelExpression$containsGpmSpecificRelTypeExpression$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_LabelExpression$containsGpmSpecificRelTypeExpression$lambda$_7_0_apply)],
    $java.oncil_LabelExpression$replaceColonSyntax$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_LabelExpression$replaceColonSyntax$lambda$_9_0_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1_applyOrElse)],
    $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_0_apply)],
    $java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$$anonfun$minimalRanges$1$lambda$_23_1_apply)],
    $java.oncie_ExpressionWithComputedDependencies$introducedVariables$lambda$_6_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncie_ExpressionWithComputedDependencies$introducedVariables$lambda$_6_0_apply)],
    oncia_ReadAdministrationCommand$yields$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$yields$lambda$_11_0_apply)],
    oncia_ReadAdministrationCommand$returns$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$returns$lambda$_13_0_apply)],
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$9$lambda$_36_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$9$lambda$_36_0_apply)],
    oncias_SemanticAnalysisTooling$expectType$lambda$_21_0, "SemanticAnalysisTooling$expectType$lambda$_21_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$expectType$lambda$_21_0_apply)],
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_11_0, "SemanticAnalysisTooling$expectType$lambda$_11_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$expectType$lambda$_11_0_apply)]]);
    $rt_metadata([oncias_SemanticAnalysisTooling$specifyType$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$specifyType$lambda$_7_0_apply)],
    oncias_SemanticAnalysisTooling$checkTypes$lambda$_29_0, "SemanticAnalysisTooling$checkTypes$lambda$_29_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$checkTypes$lambda$_29_0_apply)],
    oncias_SemanticAnalysisTooling$specifyType$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$specifyType$lambda$_9_0_apply)],
    oncias_SemanticAnalysisTooling$unionOfTypes$lambda$_37_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$unionOfTypes$lambda$_37_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$20$lambda$_80_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$20$lambda$_80_0_apply)],
    $java.oncias_SemanticAnalysisTooling$typeSwitch$lambda$_47_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$typeSwitch$lambda$_47_0_apply)],
    oncias_SemanticCheck$ifOkChain$lambda$_19_0, "SemanticCheck$ifOkChain$lambda$_19_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$ifOkChain$lambda$_19_0_apply)],
    oncias_SemanticAnalysisTooling$types$lambda$_77_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$types$lambda$_77_0_apply)],
    $java.oncias_SemanticAnalysisTooling$expectType$lambda$_15_0, "SemanticAnalysisTooling$expectType$lambda$_15_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$expectType$lambda$_15_0_apply)],
    oncias_SemanticAnalysisTooling$expectType$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$expectType$lambda$_13_0_apply)],
    oncias_SemanticAnalysisTooling$ensureDefined$lambda$_53_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$ensureDefined$lambda$_53_0_apply)],
    $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Query$$anonfun$checkUse$2$lambda$_15_0_apply)],
    $java.oncia_Query$$anonfun$checkUse$2$lambda$_15_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_Query$$anonfun$checkUse$2$lambda$_15_1_apply)],
    oncia_Clause$semanticCheck$lambda$_7_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Clause$semanticCheck$lambda$_7_0_apply)],
    oncir_Deprecations$semanticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncir_Deprecations$semanticallyDeprecatedFeatures$$org$neo4j$cypher$internal$rewriting$Deprecations$semanticallyDeprecatedFeatures$$isDefinition$1$lambda$_15_0_apply)],
    $java.onciu_RewritableCompat$PROXY$7_250, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_250, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_914, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncius_ClosedDynamicUnionType$isAssignableFrom$lambda$_33_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$isAssignableFrom$lambda$_33_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_3_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_4_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_5, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_5_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_6_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_7_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_8, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_8_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_9, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_9_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_10, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_10_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_11, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_25_11_apply)],
    $java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$anonfun$$nestedInanonfun$check$1$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_0_apply)],
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_1_apply)],
    $java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UseGraph$clauseSpecificSemanticCheck$lambda$_57_2_apply)],
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_0_apply)],
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_1_apply)],
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_2_apply)],
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_3_apply)],
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_4_apply)],
    $java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_5, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UnresolvedCall$clauseSpecificSemanticCheck$lambda$_15_5_apply)],
    $java.oncia_SubqueryCall$clauseSpecificSemanticCheck$lambda$_60_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$clauseSpecificSemanticCheck$lambda$_60_0_apply)],
    oncias_SemanticCheckableIterableOnce$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    oncias_SemanticCheckableOption$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_Merge$clauseSpecificSemanticCheck$lambda$_65_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Merge$clauseSpecificSemanticCheck$lambda$_65_0_apply)],
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_0_apply)],
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_1_apply)],
    $java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Unwind$clauseSpecificSemanticCheck$lambda$_58_2_apply)],
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_0_apply)],
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_1_apply)]]);
    $rt_metadata([$java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_2_apply)],
    $java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Foreach$clauseSpecificSemanticCheck$lambda$_59_3_apply)],
    $java.oncia_LoadCSV$clauseSpecificSemanticCheck$lambda$_60_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_LoadCSV$clauseSpecificSemanticCheck$lambda$_60_0_apply)],
    $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_0_apply)],
    $java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_TerminateTransactionsClause$clauseSpecificSemanticCheck$lambda$_67_1_apply)],
    $java.oncias_checkValidPropertyKeyNamesInPattern$$apply$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_checkValidPropertyKeyNamesInPattern$$apply$lambda$_1_0_apply)],
    $java.oncil_LabelExpression$Disjunctions$unnestDisjunctions$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_LabelExpression$Disjunctions$unnestDisjunctions$lambda$_13_0_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_0_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_1_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_2_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_3_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_4, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_4_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_5, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_5_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_6, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_6_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_7, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_7_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_8, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_8_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_9, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_9_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_10, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_10_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_11, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_11_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_12, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_12_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_13, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_13_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_14, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_14_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_15_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_16_apply)],
    $java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$semanticCheck$lambda$_42_17_apply)],
    $java.oncius_TypeSpec$equals$lambda$_37_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$equals$lambda$_37_0_apply)],
    $java.oncius_TypeSpec$equals$lambda$_37_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$equals$lambda$_37_1_apply)],
    $java.oncius_TypeSpec$equals$lambda$_37_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncius_TypeSpec$equals$lambda$_37_2_apply)],
    $java.oncius_TypeSpec$equals$lambda$_37_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncius_TypeSpec$equals$lambda$_37_3_apply)],
    $java.oncie_Expression$$anonfun$arguments$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_Expression$$anonfun$arguments$1$applyOrElse$lambda$_0_0_apply)],
    $java.ju_AbstractList$TListIteratorImpl, 0, jl_Object, [ju_ListIterator], 0, 0, 0, 0, 0,
    onciap_Prettifier$$escapeNames$lambda$_17_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncie_Expression$$anonfun$findAggregate$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncie_Expression$$anonfun$findAggregate$1_applyOrElse)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_3_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_4_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_5, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_5_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_6_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_7_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_8, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_23_8_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_3_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_11_4_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_12_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_0_apply)]]);
    $rt_metadata([onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_3_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_4_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_24_5_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_3_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_4_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_5_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_6, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_28_6_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_30_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_31_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_32_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_33_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_35_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_39_2_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_40_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_40_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_41_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_41_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_43_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_43_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_17_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_42_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_44_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_44_0_apply)],
    onciu_Foldable$Folder$$anonfun$treeCollect$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.onciu_Foldable$Folder$$anonfun$treeCollect$1_applyOrElse)],
    $java.oncias_SemanticCheck$$fromFunctionWithContext$lambda$_10_0, "SemanticCheck$$fromFunctionWithContext$lambda$_10_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$fromFunctionWithContext$lambda$_10_0_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$createError$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$createError$lambda$_3_0_apply)],
    $java.oncias_Symbol$toString$lambda$_14_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_Symbol$toString$lambda$_14_0_apply)],
    $java.oncias_Symbol$positionsAndUniqueIdString$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_Symbol$positionsAndUniqueIdString$lambda$_13_0_apply)],
    $java.oncia_Return$checkVariableScope$lambda$_85_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Return$checkVariableScope$lambda$_85_0_apply)],
    $java.oncia_SubqueryCall$checkNoCallInTransactionsInsideRegularCall$lambda$_68_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$checkNoCallInTransactionsInsideRegularCall$lambda$_68_0_apply)],
    $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_0_apply)],
    $java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Delete$warnAboutDeletingLabels$lambda$_59_1_apply)],
    $java.oncia_Match$noImplicitJoinsInQuantifiedPathPatterns$lambda$_62_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$noImplicitJoinsInQuantifiedPathPatterns$lambda$_62_0_apply)],
    $java.oncia_Match$$anonfun$4, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$4_applyOrElse)],
    $java.oncia_Match$uniqueHints$lambda$_66_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$uniqueHints$lambda$_66_0_apply)]]);
    $rt_metadata([$java.oncia_Match$$anonfun$5, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$5_applyOrElse)],
    $java.oncia_Match$uniqueHints$lambda$_66_1, "Match$uniqueHints$lambda$_66_1", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$uniqueHints$lambda$_66_1_apply)],
    $java.oncia_Match$checkMatchMode$lambda$_68_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$checkMatchMode$lambda$_68_0_apply)],
    $java.oncia_Match$checkMatchMode$lambda$_68_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$checkMatchMode$lambda$_68_1_apply)],
    $java.oncia_Match$checkMatchMode$lambda$_68_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$checkMatchMode$lambda$_68_2_apply)],
    $java.oncia_Match$checkMatchMode$lambda$_68_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$checkMatchMode$lambda$_68_3_apply)],
    $java.oncia_Match$checkHints$lambda$_71_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_Match$checkHints$lambda$_71_0_apply)],
    $java.oncia_Match$checkForCartesianProducts$lambda$_67_0, "Match$checkForCartesianProducts$lambda$_67_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$checkForCartesianProducts$lambda$_67_0_apply)],
    onciuh_Math$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncius_TypeSpec$toStream$lambda$_34_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$toStream$lambda$_34_0_apply)],
    $java.oncius_TypeSpec$toStream$lambda$_34_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncius_TypeSpec$toStream$lambda$_34_1_apply)],
    sci_Stream, 0, sci_AbstractSeq, [sci_LinearSeq, ji_Serializable], 129, 3, 0, 0, ["$stringPrefix", $rt_wrapFunction0($java.sci_Stream_stringPrefix), "$scala$collection$LinearSeqOps$$super$sameElements", $rt_wrapFunction1($java.sci_Stream_scala$collection$LinearSeqOps$$super$sameElements), "$headOption", $rt_wrapFunction0($java.sci_Stream_headOption), "$iterator0", $rt_wrapFunction0($java.sci_Stream_iterator), "$length", $rt_wrapFunction0($java.sci_Stream_length), "$last", $rt_wrapFunction0($java.sci_Stream_last),
    "$lengthCompare", $rt_wrapFunction1($java.sci_Stream_lengthCompare), "$apply1", $rt_wrapFunction1($java.sci_Stream_apply), "$forall", $rt_wrapFunction1($java.sci_Stream_forall), "$exists", $rt_wrapFunction1($java.sci_Stream_exists), "$contains0", $rt_wrapFunction1($java.sci_Stream_contains), "$sameElements", $rt_wrapFunction1($java.sci_Stream_sameElements), "$indexWhere", $rt_wrapFunction2($java.sci_Stream_indexWhere), "$className", $rt_wrapFunction0($java.sci_Stream_className), "$foreach", $rt_wrapFunction1($java.sci_Stream_foreach),
    "$find0", $rt_wrapFunction1($java.sci_Stream_find), "$foldLeft", $rt_wrapFunction2($java.sci_Stream_foldLeft), "$reduceLeft", $rt_wrapFunction1($java.sci_Stream_reduceLeft), "$partition", $rt_wrapFunction1($java.sci_Stream_partition), "$collectFirst", $rt_wrapFunction1($java.sci_Stream_collectFirst), "$addString", $rt_wrapFunction4($java.sci_Stream_addString), "$toString", $rt_wrapFunction0($java.sci_Stream_toString), "$apply", $rt_wrapFunction1($java.sci_Stream_apply0), "$zipWithIndex", $rt_wrapFunction0($java.sci_Stream_zipWithIndex0),
    "$zip2", $rt_wrapFunction1($java.sci_Stream_zip0), "$flatMap", $rt_wrapFunction1($java.sci_Stream_flatMap0), "$collect0", $rt_wrapFunction1($java.sci_Stream_collect0), "$map1", $rt_wrapFunction1($java.sci_Stream_map0), "$prepended", $rt_wrapFunction1($java.sci_Stream_prepended0), "$filterNot1", $rt_wrapFunction1($java.sci_Stream_filterNot0), "$filter1", $rt_wrapFunction1($java.sci_Stream_filter0), "$iterableFactory", $rt_wrapFunction0($java.sci_Stream_iterableFactory0)],
    onciap_Prettifier$IndentingQueryPrettifier$namesAsString$lambda$_37_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$namesAsString$lambda$_37_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$partialYieldAsString$lambda$_38_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$partialYieldAsString$lambda$_38_0_apply)],
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_0_apply)],
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_2_apply)],
    $java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_OctalIntegerLiteral$value$lzycompute$lambda$_4_1_apply)],
    $java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_HexIntegerLiteral$value$lzycompute$lambda$_4_0_apply)],
    $java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_DecimalDoubleLiteral$value$lzycompute$lambda$_8_0_apply)],
    $java.oncia_ReadAdministrationCommand$$anonfun$yields$1$lambda$_23_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$$anonfun$yields$1$lambda$_23_0_apply)],
    $java.oncia_ReadAdministrationCommand$$anonfun$returns$1$lambda$_25_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$$anonfun$returns$1$lambda$_25_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$56$lambda$_116_0, "SemanticExpressionCheck$$$anonfun$check$56$lambda$_116_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$56$lambda$_116_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$110$lambda$_172_1_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$61$lambda$_121_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$61$lambda$_121_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$104$lambda$_165_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$104$lambda$_165_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$107$lambda$_168_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$107$lambda$_168_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$45$lambda$_106_1_apply)],
    $java.oncias_SemanticCheck$$anonfun$ifOkChain$1$lambda$_33_0, "SemanticCheck$$anonfun$ifOkChain$1$lambda$_33_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$anonfun$ifOkChain$1$lambda$_33_0_apply)],
    $java.oncia_CommandClause$clauseSpecificSemanticCheck$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CommandClause$clauseSpecificSemanticCheck$lambda$_3_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$specifyType$1$lambda$_84_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticAnalysisTooling$$anonfun$specifyType$1$lambda$_84_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_1_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$check$6$lambda$_81_2_apply)],
    oncia_Where$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpressionForLegacyRelationshipTypeDisjunction$1$lambda$_176_0, "SemanticExpressionCheck$$$anonfun$checkLabelExpressionForLegacyRelationshipTypeDisjunction$1$lambda$_176_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpressionForLegacyRelationshipTypeDisjunction$1$lambda$_176_0_apply)],
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$$anonfun$checkInnerPredicate$1$lambda$_12_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$FilteringExpressions$$$anonfun$checkInnerPredicate$1$lambda$_12_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$2$lambda$_124_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$2$lambda$_124_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$9$lambda$_131_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$9$lambda$_131_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$11$lambda$_87_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$check$11$lambda$_87_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$checkIsKeyword$1$lambda$_152_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$checkIsKeyword$1$lambda$_152_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$checkLabelExpressions$1$lambda$_150_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$checkLabelExpressions$1$lambda$_150_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$1$lambda$_148_1_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$11$lambda$_133_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$11$lambda$_133_0_apply)],
    $java.oncias_SemanticAnalysisTooling$implicitVariable$lambda$_63_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$implicitVariable$lambda$_63_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$1$lambda$_87_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticAnalysisTooling$$anonfun$expectType$1$lambda$_87_0_apply)],
    oncias_SemanticAnalysisTooling$expectType$lambda$_17_0, "SemanticAnalysisTooling$expectType$lambda$_17_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$expectType$lambda$_17_0_apply)],
    $java.oncia_Clause$$anonfun$semanticCheck$1$lambda$_17_0, "Clause$$anonfun$semanticCheck$1$lambda$_17_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$semanticCheck$1$lambda$_17_0_apply)]]);
    $rt_metadata([$java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_1_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$check$27$lambda$_121_2_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$3$lambda$_89_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticAnalysisTooling$$anonfun$expectType$3$lambda$_89_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$25$lambda$_115_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$check$25$lambda$_115_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_1_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_2_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_3, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$1$lambda$_105_3_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$5$lambda$_91_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticAnalysisTooling$$anonfun$expectType$5$lambda$_91_0_apply)],
    $java.oncias_SemanticExpressionCheck$$checkForShadowedVariables$lambda$_59_0, "SemanticExpressionCheck$$checkForShadowedVariables$lambda$_59_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$checkForShadowedVariables$lambda$_59_0_apply)],
    $java.oncia_TransactionsCommandClause$checkYieldItems$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_TransactionsCommandClause$checkYieldItems$lambda$_7_0_apply)],
    $java.onciu_AnonymousVariableNameGenerator$, 0, jl_Object, [], 4, 3, 0, $java.onciu_AnonymousVariableNameGenerator$_$callClinit, 0,
    $java.oncia_Clause$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Clause$$anonfun$2_applyOrElse)],
    $java.oncia_Clause$$anonfun$3, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Clause$$anonfun$3_applyOrElse)],
    $java.oncia_Clause$checkIfMixingLegacyVarLengthWithQPPs$lambda$_14_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Clause$checkIfMixingLegacyVarLengthWithQPPs$lambda$_14_0_apply)],
    $java.oncia_ReadAdministrationCommand$checkProjection$1$lambda$_32_0, "ReadAdministrationCommand$checkProjection$1$lambda$_32_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$checkProjection$1$lambda$_32_0_apply)],
    oncil_SolvableLabelExpression$, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oncias_SemanticPatternCheck$$unsatisfiableRelTypeExpression$1$lambda$_113_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$unsatisfiableRelTypeExpression$1$lambda$_113_0_apply)],
    $java.oncil_SolvableLabelExpression, "SolvableLabelExpression", 27, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncil_SolvableLabelExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_SolvableLabelExpression_productArity), "$productElement", $rt_wrapFunction1($java.oncil_SolvableLabelExpression_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_SolvableLabelExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_SolvableLabelExpression_hashCode),
    "$toString", $rt_wrapFunction0($java.oncil_SolvableLabelExpression_toString), "$equals", $rt_wrapFunction1($java.oncil_SolvableLabelExpression_equals)],
    $java.onciu_RewritableCompat$PROXY$7_251, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_251, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_252, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_252, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_253, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_253, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_254, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_254, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_255, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_255, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_928, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_929, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_930, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_931, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_256, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_256, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_257, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_257, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.s_Enumeration$scala$Enumeration$$nameOf$lambda$_23_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.s_Enumeration$scala$Enumeration$$nameOf$lambda$_23_0_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_1_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$applyOrElse$lambda$_0_2_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_1_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_2_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$checkContainedPatterns$1$1$applyOrElse$lambda$_0_3_apply)],
    $java.onm_MessageUtil, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncias_SemanticCheckableIterableOnce$$semanticCheck$extension$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheckableIterableOnce$$semanticCheck$extension$lambda$_1_0_apply)],
    $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_0_apply)],
    $java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheckableOption$$semanticCheck$extension$lambda$_1_1_apply)]]);
    $rt_metadata([$java.jl_ArithmeticException, 0, jl_RuntimeException, [], 0, 3, 0, 0, 0,
    $java.oncia_Where$$checkExpression$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Where$$checkExpression$lambda$_5_0_apply)],
    $java.oncia_Where$$checkExpression$lambda$_5_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Where$$checkExpression$lambda$_5_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_22_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_22_0_apply)],
    $java.oncia_ProjectionClause$$checkAliasedReturnItems$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$checkAliasedReturnItems$lambda$_2_0_apply)],
    $java.oncias_package$$liftSemanticErrorDefsFunc$lambda$_3_0, "package$$liftSemanticErrorDefsFunc$lambda$_3_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_package$$liftSemanticErrorDefsFunc$lambda$_3_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$3, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$anonfun$3_applyOrElse)],
    $java.oncia_SubqueryCall$checkSubquery$lambda$_62_0, "SubqueryCall$checkSubquery$lambda$_62_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$checkSubquery$lambda$_62_0_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$check$lambda$_40_0_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$check$lambda$_40_1_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$check$lambda$_40_2_apply)],
    $java.oncias_SemanticPatternCheck$$check$lambda$_40_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$check$lambda$_40_3_apply)],
    $java.oncil_LabelExpression$Conjunctions$unnestConjunctions$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_LabelExpression$Conjunctions$unnestConjunctions$lambda$_13_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$4, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$anonfun$4_applyOrElse)],
    $java.oncius_TypeSpec$intersect$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$intersect$lambda$_15_0_apply)],
    sci_List$partition$lambda$_92_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_List$partition$lambda$_92_0_apply)],
    onciap_DefaultPatternStringifier$apply$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_DefaultPatternStringifier$apply$lambda$_0_0_apply)],
    $java.onciu_Foldable$Folder$$anonfun$treeCollect$1$applyOrElse$lambda$_0_0, "Foldable$Folder$$anonfun$treeCollect$1$applyOrElse$lambda$_0_0", 20, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciu_Foldable$Folder$$anonfun$treeCollect$1$applyOrElse$lambda$_0_0_apply)],
    sc_StringOps$$anon$1, "StringOps$$anon$1", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_StringOps$$anon$1_hasNext), "$next", $rt_wrapFunction0($java.sc_StringOps$$anon$1_next)],
    sc_StringOps$$stripMargin$extension$lambda$_68_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_StringOps$$stripMargin$extension$lambda$_68_0_apply)],
    $java.oncias_SemanticExpressionCheck$FilteringExpressions$$possibleInnerTypes$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$FilteringExpressions$$possibleInnerTypes$lambda$_6_0_apply)],
    $java.oncia_SingleQuery$semanticCheckInSubqueryExpressionContext$lambda$_65_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$semanticCheckInSubqueryExpressionContext$lambda$_65_0_apply)],
    $java.oncia_SingleQuery$containsUpdates$lambda$_51_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$containsUpdates$lambda$_51_0_apply)],
    oncias_SemanticAnalysisTooling$$org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScopeWithVariablesFromRecordedScope$lambda$_2_0, "SemanticAnalysisTooling$$org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScopeWithVariablesFromRecordedScope$lambda$_2_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$org$neo4j$cypher$internal$ast$semantics$SemanticAnalysisTooling$$pushStateScopeWithVariablesFromRecordedScope$lambda$_2_0_apply)],
    $java.oncias_SemanticCheck$$warn$lambda$_4_0, "SemanticCheck$$warn$lambda$_4_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$warn$lambda$_4_0_apply)],
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_0_apply)],
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_1_apply)],
    $java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$checkLabelExpression$lambda$_47_2_apply)],
    oncias_SemanticState$expressionType$lambda$_42_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticState$expressionType$lambda$_42_0_apply)],
    $java.oncius_TypeRange$contains$lambda$_7_0, 0, jl_Object, [$java.srj_JFunction0$mcZ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.srj_JFunction0$mcZ$sp_apply), "$apply$mcZ$sp", $rt_wrapFunction0($java.oncius_TypeRange$contains$lambda$_7_0_apply$mcZ$sp)],
    $java.oncius_TypeRange$contains$lambda$_7_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeRange$contains$lambda$_7_1_apply)],
    $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$2$applyOrElse$lambda$_0_1_apply)],
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_2_apply)],
    $java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$3$applyOrElse$lambda$_0_1_apply)],
    $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_0_apply)],
    $java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$ensureProjectedToUniqueIds$lambda$_61_1_apply)],
    suc_TailCalls$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_0, "SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_0", 27, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_0_apply)],
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_1_apply)],
    onciut_TailCallsUtil$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_2, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_2_apply)],
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_3_apply)],
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_4_apply)],
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_5, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_5_apply)],
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_6_apply)],
    $java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$$extractLabelExpressionRec$lambda$_2_7_apply)],
    $java.suc_TailCalls$TailRec, 0, jl_Object, [], 1, 3, 0, 0, 0,
    $java.oncias_SemanticPatternCheck$$ensureNoRepeatedRelationships$lambda$_61_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$ensureNoRepeatedRelationships$lambda$_61_0_apply)]]);
    $rt_metadata([$java.oncias_SemanticPatternCheck$$ensureNoRepeatedVarLengthRelationships$lambda$_62_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$ensureNoRepeatedVarLengthRelationships$lambda$_62_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$6$lambda$_129_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$6$lambda$_129_0_apply)],
    $java.oncia_SingleRelTypeCheck$checkRelTypes$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleRelTypeCheck$checkRelTypes$lambda$_3_0_apply)],
    oncias_SemanticAnalysisTooling$declareVariable$lambda$_57_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$declareVariable$lambda$_57_0_apply)],
    $java.jur_IntArrHash, 0, jl_Object, [], 0, 0, 0, 0, 0,
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_0_apply)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_1_apply)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_4_apply)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$1$lambda$_110_5_apply)],
    $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_0_apply)],
    $java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$semanticCheckInSubqueryExpressionContext$lambda$_11_1_apply)],
    oncias_SemanticPatternCheck$$$anonfun$check$16$lambda$_97_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$check$16$lambda$_97_0_apply)],
    oncie_Expression$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_1_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$26$lambda$_87_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$67$lambda$_138_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$67$lambda$_138_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_1_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_2_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$anonfun$checkTypes$3$lambda$_102_3_apply)],
    $java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$5$lambda$_31_0, "ReadAdministrationCommand$$anonfun$semanticCheck$5$lambda$_31_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReadAdministrationCommand$$anonfun$semanticCheck$5$lambda$_31_0_apply)],
    $java.oncia_SingleQuery$$anonfun$checkHorizon$1$lambda$_142_0, "SingleQuery$$anonfun$checkHorizon$1$lambda$_142_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkHorizon$1$lambda$_142_0_apply)],
    $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_0_apply)],
    $java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_UnresolvedCall$$anonfun$clauseSpecificSemanticCheck$23$lambda$_41_1_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$81$lambda$_104_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$81$lambda$_104_0_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$83$lambda$_106_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$83$lambda$_106_0_apply)],
    $java.oncia_SetPropertyItems, 0, jl_Object, [$java.oncia_SetProperty, ji_Serializable], 0, 3, 0, 0, 0,
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$114$lambda$_141_1_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$117$lambda$_143_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$$anonfun$asString$117$lambda$_143_0_apply)],
    $java.oncia_connectedComponents$, 0, jl_Object, [], 4, 3, 0, $java.oncia_connectedComponents$_$callClinit, 0,
    $java.oncia_Match$$anonfun$checkForCartesianProducts$1$lambda$_115_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_Match$$anonfun$checkForCartesianProducts$1$lambda$_115_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$3$lambda$_57_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$3$lambda$_57_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$20$lambda$_75_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$20$lambda$_75_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$6$lambda$_60_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$6$lambda$_60_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$30$lambda$_120_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$check$30$lambda$_120_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$26$lambda$_81_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$26$lambda$_81_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$9$lambda$_64_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$9$lambda$_64_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$3$lambda$_147_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$checkPredicate$3$lambda$_147_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$23$lambda$_78_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$23$lambda$_78_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$18$lambda$_73_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$18$lambda$_73_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$88$lambda$_149_0, "SemanticExpressionCheck$$$anonfun$check$88$lambda$_149_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$88$lambda$_149_0_apply)],
    $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$13$lambda$_81_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$13$lambda$_81_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$96$lambda$_157_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$96$lambda$_157_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$92$lambda$_153_0, "SemanticExpressionCheck$$$anonfun$check$92$lambda$_153_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$check$92$lambda$_153_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$30$lambda$_85_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$30$lambda$_85_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$28$lambda$_83_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$28$lambda$_83_0_apply)],
    $java.oncia_Clause$$anonfun$checkIfMixingLegacyVarLengthWithQPPs$1$lambda$_24_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$checkIfMixingLegacyVarLengthWithQPPs$1$lambda$_24_0_apply)]]);
    $rt_metadata([$java.onciu_UnsatisfiableRelationshipTypeExpression, "UnsatisfiableRelationshipTypeExpression", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_UnsatisfiableRelationshipTypeExpression_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_UnsatisfiableRelationshipTypeExpression_productArity), "$productElement", $rt_wrapFunction1($java.onciu_UnsatisfiableRelationshipTypeExpression_productElement),
    "$productIterator", $rt_wrapFunction0($java.onciu_UnsatisfiableRelationshipTypeExpression_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciu_UnsatisfiableRelationshipTypeExpression_hashCode), "$toString", $rt_wrapFunction0($java.onciu_UnsatisfiableRelationshipTypeExpression_toString), "$equals", $rt_wrapFunction1($java.onciu_UnsatisfiableRelationshipTypeExpression_equals)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_1_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_4, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_5_apply)],
    oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1(oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_6_apply)],
    $java.oncias_SemanticExpressionCheck$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$$anonfun$2_applyOrElse)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$1$lambda$_213_7_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$7$lambda$_94_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticAnalysisTooling$$anonfun$expectType$7$lambda$_94_0_apply)],
    $java.oncias_SemanticExpressionCheck$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$$anonfun$1_applyOrElse)],
    $java.oncia_Merge$$anonfun$11, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Merge$$anonfun$11_applyOrElse), "$isDefinedAt", $rt_wrapFunction1($java.oncia_Merge$$anonfun$11_isDefinedAt)],
    $java.oncia_SubqueryCall$checkNoNestedCallInTransactions$lambda$_67_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$checkNoNestedCallInTransactions$lambda$_67_0_apply)],
    $java.oncias_SemanticFunctionCheck$$possibleTypes$1$lambda$_62_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$possibleTypes$1$lambda$_62_0_apply)],
    $java.oncias_SemanticFunctionCheck$$checkToSpecifiedTypeOfArgument$lambda$_50_0, "SemanticFunctionCheck$$checkToSpecifiedTypeOfArgument$lambda$_50_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$checkToSpecifiedTypeOfArgument$lambda$_50_0_apply)],
    oncia_Clause$LabelExpressionsPartition, "Clause$LabelExpressionsPartition", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_Clause$LabelExpressionsPartition_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_Clause$LabelExpressionsPartition_productArity), "$productElement", $rt_wrapFunction1($java.oncia_Clause$LabelExpressionsPartition_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_Clause$LabelExpressionsPartition_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_Clause$LabelExpressionsPartition_hashCode), "$toString", $rt_wrapFunction0($java.oncia_Clause$LabelExpressionsPartition_toString), "$equals", $rt_wrapFunction1($java.oncia_Clause$LabelExpressionsPartition_equals)],
    $java.oncia_Clause$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Clause$$anonfun$1_applyOrElse)],
    $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_0_apply)],
    $java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Clause$checkIfMixingLabelExpressionWithOldSyntax$lambda$_11_1_apply)],
    $java.oncie_Expression$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncie_Expression$$_clinit_$lambda$_0_0_apply)],
    oncia_Clause$LabelExpressionsPartition$, 0, sr_AbstractFunction3, [ji_Serializable], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_258, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_258, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_946, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_948, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_949, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_950, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_259, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_259, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.suc_TailCalls$Done, "TailCalls$Done", 40, $java.suc_TailCalls$TailRec, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.suc_TailCalls$Done_productPrefix), "$productArity", $rt_wrapFunction0($java.suc_TailCalls$Done_productArity), "$productElement", $rt_wrapFunction1($java.suc_TailCalls$Done_productElement), "$productIterator", $rt_wrapFunction0($java.suc_TailCalls$Done_productIterator), "$toString", $rt_wrapFunction0($java.suc_TailCalls$Done_toString)],
    $java.suc_TailCalls$Call, "TailCalls$Call", 40, $java.suc_TailCalls$TailRec, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.suc_TailCalls$Call_productPrefix), "$productArity", $rt_wrapFunction0($java.suc_TailCalls$Call_productArity), "$productElement", $rt_wrapFunction1($java.suc_TailCalls$Call_productElement), "$productIterator", $rt_wrapFunction0($java.suc_TailCalls$Call_productIterator), "$hashCode0", $rt_wrapFunction0($java.suc_TailCalls$Call_hashCode), "$toString",
    $rt_wrapFunction0($java.suc_TailCalls$Call_toString), "$equals", $rt_wrapFunction1($java.suc_TailCalls$Call_equals)],
    $java.onciut_TailCallsUtil$$map2$lambda$_2_0, "TailCallsUtil$$map2$lambda$_2_0", 22, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciut_TailCallsUtil$$map2$lambda$_2_0_apply)],
    $java.onciut_TailCallsUtil$$traverse$lambda$_1_0, "TailCallsUtil$$traverse$lambda$_1_0", 22, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciut_TailCallsUtil$$traverse$lambda$_1_0_apply)],
    $java.onciut_TailCallsUtil$$traverse$lambda$_1_1, "TailCallsUtil$$traverse$lambda$_1_1", 22, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciut_TailCallsUtil$$traverse$lambda$_1_1_apply)],
    $java.sc_Seq$, 0, sc_SeqFactory$Delegate, [], 4, 3, 0, $java.sc_Seq$_$callClinit, 0,
    $java.oncia_connectedComponents$$apply$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_connectedComponents$$apply$lambda$_3_0_apply)],
    $java.onciuh_NameDeduplicator$, 0, jl_Object, [], 4, 3, 0, $java.onciuh_NameDeduplicator$_$callClinit, 0,
    $java.oncia_SingleQuery$checkImportingWith$lambda$_66_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkImportingWith$lambda$_66_0_apply)],
    $java.oncias_SemanticState$ScopeLocation$$symbol$extension$lambda$_10_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_0_apply)],
    $java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$checkValidLabels$lambda$_70_1_apply)],
    $java.oncius_TypeSpec$coercions$lambda$_28_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$coercions$lambda$_28_0_apply)],
    $java.oncil_SolvableLabelExpression$$wildcard$lambda$_4_0, "SolvableLabelExpression$$wildcard$lambda$_4_0", 27, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$$wildcard$lambda$_4_0_apply)],
    $java.oncil_SolvableLabelExpression$$label$lambda$_5_0, "SolvableLabelExpression$$label$lambda$_5_0", 27, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$$label$lambda$_5_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$anonfun$2_applyOrElse)],
    $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_0_apply)],
    $java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$findRepeatedRelationships$lambda$_63_1_apply)],
    $java.oncias_SemanticCheck$$error$lambda$_3_0, "SemanticCheck$$error$lambda$_3_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$error$lambda$_3_0_apply)],
    $java.oncia_CommandResultItem$semanticCheck$lambda$_50_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_CommandResultItem$semanticCheck$lambda$_50_0_apply)]]);
    $rt_metadata([$java.oncia_CommandResultItem$semanticCheck$lambda$_50_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_CommandResultItem$semanticCheck$lambda$_50_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_20_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_20_0_apply)],
    $java.oncia_SubqueryCall$semanticCheckContinuation$lambda$_64_0, "SubqueryCall$semanticCheckContinuation$lambda$_64_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$semanticCheckContinuation$lambda$_64_0_apply)],
    $java.oncia_ProcedureResult$semanticCheck$lambda$_14_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProcedureResult$semanticCheck$lambda$_14_0_apply)],
    $java.oncia_ProcedureResult$semanticCheck$lambda$_14_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProcedureResult$semanticCheck$lambda$_14_1_apply)],
    $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_0_apply)],
    $java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$InTransactionsParameters$semanticCheck$lambda$_10_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_15_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_0_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_1_apply)],
    onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_13_2_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_0_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_1_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_2_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$asString$lambda$_29_3_apply)],
    oncias_Scope$allSymbols$lambda$_16_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_Scope$allSymbols$lambda$_16_0_apply)],
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_1_apply)],
    $java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$1$applyOrElse$lambda$_0_2_apply)],
    oncil_LabelExpression$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncius_TypeSpec$contains$lambda$_9_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$contains$lambda$_9_0_apply)],
    $java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncius_ClosedDynamicUnionType$covariant$lzycompute$lambda$_35_0_apply)],
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_0_apply)],
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_1_apply)],
    $java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UseGraph$$anonfun$clauseSpecificSemanticCheck$5$lambda$_85_2_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$expectType$8$lambda$_93_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticAnalysisTooling$$anonfun$expectType$8$lambda$_93_0_apply)],
    $java.oncia_Match$$anonfun$checkMatchMode$2$lambda$_118_0, "Match$$anonfun$checkMatchMode$2$lambda$_118_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$checkMatchMode$2$lambda$_118_0_apply)],
    $java.oncia_Union$$anonfun$semanticCheckInSubqueryExpressionContext$2$lambda$_34_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Union$$anonfun$semanticCheckInSubqueryExpressionContext$2$lambda$_34_0_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$6$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$6$lambda$_3_0_apply)],
    $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_0, "Match$$anonfun$checkMatchMode$5$lambda$_122_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_0_apply)],
    $java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_1, "Match$$anonfun$checkMatchMode$5$lambda$_122_1", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$checkMatchMode$5$lambda$_122_1_apply)],
    $java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$8$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$anonfun$1$$anonfun$applyOrElse$8$lambda$_5_0_apply)],
    $java.oncil_MultiOperatorLabelExpression$flatten$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_MultiOperatorLabelExpression$flatten$lambda$_2_0_apply)],
    onciuh_fixedPoint$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.onciuh_NameDeduplicator$$_clinit_$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_Union$checkImportingWith$lambda$_13_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Union$checkImportingWith$lambda$_13_0_apply)],
    $java.onciu_RepeatedRelationshipReference, "RepeatedRelationshipReference", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_RepeatedRelationshipReference_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_RepeatedRelationshipReference_productArity), "$productElement", $rt_wrapFunction1($java.onciu_RepeatedRelationshipReference_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_RepeatedRelationshipReference_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_RepeatedRelationshipReference_hashCode), "$toString", $rt_wrapFunction0($java.onciu_RepeatedRelationshipReference_toString), "$equals", $rt_wrapFunction1($java.onciu_RepeatedRelationshipReference_equals)],
    $java.onciu_RepeatedVarLengthRelationshipReference, "RepeatedVarLengthRelationshipReference", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_RepeatedVarLengthRelationshipReference_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_RepeatedVarLengthRelationshipReference_productArity), "$productElement", $rt_wrapFunction1($java.onciu_RepeatedVarLengthRelationshipReference_productElement), "$productIterator",
    $rt_wrapFunction0($java.onciu_RepeatedVarLengthRelationshipReference_productIterator), "$hashCode0", $rt_wrapFunction0($java.onciu_RepeatedVarLengthRelationshipReference_hashCode), "$toString", $rt_wrapFunction0($java.onciu_RepeatedVarLengthRelationshipReference_toString), "$equals", $rt_wrapFunction1($java.onciu_RepeatedVarLengthRelationshipReference_equals)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$3$lambda$_101_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$3$lambda$_101_0_apply)],
    sc_IterableOps$groupMap$lambda$_74_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_IterableOps$groupMap$lambda$_74_0_apply)],
    sc_IterableOps$Result$1, 0, sr_AbstractFunction1, [], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_IterableOps$Result$1_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_1_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_2, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_2_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_3_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_4, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_4_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_5, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_5_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_6, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_6_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_7, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_7_apply)]]);
    $rt_metadata([$java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_8, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_8_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_9, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$check$68$lambda$_137_9_apply)],
    oncia_ProjectionClause$semanticCheckContinuation$lambda$_31_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$semanticCheckContinuation$lambda$_31_0_apply)],
    $java.oncias_SemanticAnalysisTooling$possibleTypes$lambda$_75_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$possibleTypes$lambda$_75_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$unionOfTypes$1$lambda$_108_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$anonfun$unionOfTypes$1$lambda$_108_0_apply)],
    sc_IterableOps$groupMapReduce$lambda$_76_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_IterableOps$groupMapReduce$lambda$_76_0_apply)],
    sc_MapFactory$ToFactory, 0, jl_Object, [sc_Factory, ji_Serializable], 0, 3, 0, 0, ["$fromSpecific", $rt_wrapFunction1($java.sc_MapFactory$ToFactory_fromSpecific)],
    oncias_SemanticCheckContext$default$, 0, jl_Object, [oncias_SemanticCheckContext], 0, 3, 0, 0, ["$errorMessageProvider0", $rt_wrapFunction0($java.oncias_SemanticCheckContext$default$_errorMessageProvider)],
    $java.oncius_TypeSpec$$anonfun$intersect$1$lambda$_53_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$intersect$1$lambda$_53_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$1$lambda$_55_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$1$lambda$_55_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$11$lambda$_66_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$11$lambda$_66_0_apply)],
    $java.oncius_StorableType$, 0, jl_Object, [], 4, 3, 0, $java.oncius_StorableType$_$callClinit, 0,
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$3$lambda$_202_1_apply)],
    oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_0_apply)],
    oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$$anonfun$checkIfMixingLabelExpressionWithOldSyntax$2$lambda$_21_1_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$checkToSpecifiedTypeOfArgument$1$lambda$_92_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticFunctionCheck$$$anonfun$checkToSpecifiedTypeOfArgument$1$lambda$_92_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpression$3$lambda$_186_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticExpressionCheck$$$anonfun$checkLabelExpression$3$lambda$_186_0_apply)],
    $java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$13$lambda$_68_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$$anonfun$semanticCheck$13$lambda$_68_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$7$lambda$_128_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$declareVariables$7$lambda$_128_0_apply)],
    oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$findAllVariables$1$lambda$_6_0_apply)],
    $java.jlr_AccessibleObject, 0, jl_Object, [jlr_AnnotatedElement], 0, 3, 0, 0, 0,
    $java.jlr_Member, 0, jl_Object, [], 3, 3, 0, 0, 0,
    jlr_Method, "Method", 7, $java.jlr_AccessibleObject, [$java.jlr_Member], 0, 3, [0,0,0], 0, ["$toString", $rt_wrapFunction0($java.jlr_Method_toString)],
    $java.oncie_TypeSignatures$signatureLengths$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_TypeSignatures$signatureLengths$lambda$_3_0_apply)],
    $java.oncia_TransactionsCommandClause$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_TransactionsCommandClause$org$neo4j$cypher$internal$ast$TransactionsCommandClause$$columnsMap$lambda$_6_0_apply)],
    $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_0, 0, jl_Object, [$java.srj_JFunction0$mcZ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.srj_JFunction0$mcZ$sp_apply), "$apply$mcZ$sp", $rt_wrapFunction0($java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_0_apply$mcZ$sp)],
    $java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeRange$$anonfun$contains$4$lambda$_36_1_apply)],
    oncia_Clause$SetExtractor$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    oncia_GraphReference$, 0, jl_Object, [oncias_SemanticAnalysisTooling], 4, 3, 0, 0, 0,
    $java.oncia_UseGraph$checkDynamicGraphReference$lambda$_60_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UseGraph$checkDynamicGraphReference$lambda$_60_0_apply)],
    jlr_Field, "Field", 7, $java.jlr_AccessibleObject, [$java.jlr_Member], 0, 3, [0,0,0], 0, ["$toString", $rt_wrapFunction0($java.jlr_Field_toString)],
    $java.onciu_RewritableCompat$PROXY$7_260, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_260, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_261, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_261, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_963, 0, jl_Object, [], 0, 3, 0, 0, 0,
    s_Enumeration$ValueOrdering$, "Enumeration$ValueOrdering$", 38, jl_Object, [sm_Ordering], 0, 3, 0, 0, 0,
    $java.sc_SpecificIterableFactory, 0, jl_Object, [sc_Factory], 3, 3, 0, 0, 0,
    s_Enumeration$ValueSet$, "Enumeration$ValueSet$", 38, jl_Object, [$java.sc_SpecificIterableFactory, ji_Serializable], 0, 3, 0, 0, 0,
    s_Enumeration$ValueSet, "Enumeration$ValueSet", 38, sci_AbstractSet, [sci_SortedSet, sc_StrictOptimizedIterableOps, ji_Serializable], 0, 3, 0, 0, 0,
    $java.suc_TailCalls$Cont, "TailCalls$Cont", 40, $java.suc_TailCalls$TailRec, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.suc_TailCalls$Cont_productPrefix), "$productArity", $rt_wrapFunction0($java.suc_TailCalls$Cont_productArity), "$productElement", $rt_wrapFunction1($java.suc_TailCalls$Cont_productElement), "$productIterator", $rt_wrapFunction0($java.suc_TailCalls$Cont_productIterator), "$hashCode0", $rt_wrapFunction0($java.suc_TailCalls$Cont_hashCode), "$toString",
    $rt_wrapFunction0($java.suc_TailCalls$Cont_toString), "$equals", $rt_wrapFunction1($java.suc_TailCalls$Cont_equals)],
    $java.suc_TailCalls$TailRec$result$lambda$_3_0, "TailCalls$TailRec$result$lambda$_3_0", 40, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.suc_TailCalls$TailRec$result$lambda$_3_0_apply)],
    $java.suc_TailCalls$TailRec$result$lambda$_3_1, "TailCalls$TailRec$result$lambda$_3_1", 40, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.suc_TailCalls$TailRec$result$lambda$_3_1_apply)],
    $java.suc_TailCalls$TailRec$result$lambda$_3_2, "TailCalls$TailRec$result$lambda$_3_2", 40, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.suc_TailCalls$TailRec$result$lambda$_3_2_apply)],
    $java.suc_TailCalls$TailRec$flatMap$lambda$_1_0, "TailCalls$TailRec$flatMap$lambda$_1_0", 40, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.suc_TailCalls$TailRec$flatMap$lambda$_1_0_apply)],
    $java.suc_TailCalls$TailRec$flatMap$lambda$_1_1, "TailCalls$TailRec$flatMap$lambda$_1_1", 40, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.suc_TailCalls$TailRec$flatMap$lambda$_1_1_apply)],
    $java.suc_TailCalls$TailRec$map$lambda$_0_0, "TailCalls$TailRec$map$lambda$_0_0", 40, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.suc_TailCalls$TailRec$map$lambda$_0_0_apply)],
    $java.suc_TailCalls$TailRec$map$lambda$_0_1, "TailCalls$TailRec$map$lambda$_0_1", 40, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.suc_TailCalls$TailRec$map$lambda$_0_1_apply)],
    $java.suc_TailCalls$TailRec$map$lambda$_0_2, "TailCalls$TailRec$map$lambda$_0_2", 40, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.suc_TailCalls$TailRec$map$lambda$_0_2_apply)]]);
    $rt_metadata([$java.onciuh_fixedPoint$$apply$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_GraphReference$$checkNotEmpty$lambda$_41_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_GraphReference$$checkNotEmpty$lambda$_41_0_apply)],
    $java.oncia_GraphReference, 0, jl_Object, [onciu_ASTNode, oncias_SemanticCheckable], 3, 3, 0, 0, 0,
    $java.oncia_ViewRef, "ViewRef", 13, jl_Object, [$java.oncia_GraphReference, oncias_SemanticAnalysisTooling, ji_Serializable], 4, 3, [0,0,0], 0, ["$position2", $rt_wrapFunction0($java.oncia_ViewRef_position), "$semanticCheck", $rt_wrapFunction0($java.oncia_ViewRef_semanticCheck), "$productPrefix", $rt_wrapFunction0($java.oncia_ViewRef_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_ViewRef_productArity), "$productElement", $rt_wrapFunction1($java.oncia_ViewRef_productElement), "$productIterator",
    $rt_wrapFunction0($java.oncia_ViewRef_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_ViewRef_hashCode), "$toString", $rt_wrapFunction0($java.oncia_ViewRef_toString), "$equals", $rt_wrapFunction1($java.oncia_ViewRef_equals), "$dup", $rt_wrapFunction1($java.oncia_ViewRef_dup)],
    $java.oncia_CatalogName, "CatalogName", 13, jl_Object, [s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncia_CatalogName_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_CatalogName_productArity), "$productElement", $rt_wrapFunction1($java.oncia_CatalogName_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_CatalogName_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_CatalogName_hashCode), "$toString", $rt_wrapFunction0($java.oncia_CatalogName_toString),
    "$equals", $rt_wrapFunction1($java.oncia_CatalogName_equals)],
    $java.oncia_GraphRefParameter, "GraphRefParameter", 13, jl_Object, [$java.oncia_GraphReference, ji_Serializable], 4, 3, [0,0,0], 0, ["$semanticCheck", $rt_wrapFunction0($java.oncia_GraphRefParameter_semanticCheck), "$position2", $rt_wrapFunction0($java.oncia_GraphRefParameter_position), "$productPrefix", $rt_wrapFunction0($java.oncia_GraphRefParameter_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_GraphRefParameter_productArity), "$productElement", $rt_wrapFunction1($java.oncia_GraphRefParameter_productElement),
    "$productIterator", $rt_wrapFunction0($java.oncia_GraphRefParameter_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncia_GraphRefParameter_hashCode), "$toString", $rt_wrapFunction0($java.oncia_GraphRefParameter_toString), "$equals", $rt_wrapFunction1($java.oncia_GraphRefParameter_equals), "$dup", $rt_wrapFunction1($java.oncia_GraphRefParameter_dup)],
    $java.oncia_GraphRef, "GraphRef", 13, jl_Object, [$java.oncia_GraphReference, ji_Serializable], 4, 3, [0,0,0], 0, ["$semanticCheck", $rt_wrapFunction0($java.oncia_GraphRef_semanticCheck), "$position2", $rt_wrapFunction0($java.oncia_GraphRef_position), "$productPrefix", $rt_wrapFunction0($java.oncia_GraphRef_productPrefix), "$productArity", $rt_wrapFunction0($java.oncia_GraphRef_productArity), "$productElement", $rt_wrapFunction1($java.oncia_GraphRef_productElement), "$productIterator", $rt_wrapFunction0($java.oncia_GraphRef_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.oncia_GraphRef_hashCode), "$toString", $rt_wrapFunction0($java.oncia_GraphRef_toString), "$equals", $rt_wrapFunction1($java.oncia_GraphRef_equals), "$dup", $rt_wrapFunction1($java.oncia_GraphRef_dup)],
    $java.oncias_SemanticPatternCheck$$anonfun$3$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$3$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_SingleQuery$$anonfun$importWith$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$importWith$2_applyOrElse)],
    $java.oncias_SemanticExpressionCheck$$anonfun$2$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$anonfun$2$applyOrElse$lambda$_0_0_apply)],
    oncia_ASTSlicingPhrase$, 0, jl_Object, [oncias_SemanticAnalysisTooling], 4, 3, 0, 0, ["$expectType3", $rt_wrapFunction4($java.oncia_ASTSlicingPhrase$_expectType), "$expectType$default$4", $rt_wrapFunction0($java.oncia_ASTSlicingPhrase$_expectType$default$4)],
    $java.oncia_SubqueryCall$InTransactionsReportParameters$semanticCheck$lambda$_47_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SubqueryCall$InTransactionsReportParameters$semanticCheck$lambda$_47_0_apply)],
    $java.oncia_UsingScanHint$semanticCheck$lambda$_51_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UsingScanHint$semanticCheck$lambda$_51_0_apply)],
    $java.oncia_RemoveLabelItem$semanticCheck$lambda$_11_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_RemoveLabelItem$semanticCheck$lambda$_11_0_apply)],
    $java.oncia_SetPropertyItem$semanticCheck$lambda$_50_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SetPropertyItem$semanticCheck$lambda$_50_0_apply)],
    $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_0_apply)],
    $java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SetExactPropertiesFromMapItem$semanticCheck$lambda$_50_1_apply)],
    $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_0_apply)],
    $java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SetIncludingPropertiesFromMapItem$semanticCheck$lambda$_50_1_apply)],
    $java.oncia_SetLabelItem$semanticCheck$lambda$_11_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SetLabelItem$semanticCheck$lambda$_11_0_apply)],
    $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UsingJoinHint$semanticCheck$lambda$_50_0_apply)],
    $java.oncia_UsingJoinHint$semanticCheck$lambda$_50_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_UsingIndexHint$semanticCheck$lambda$_58_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UsingIndexHint$semanticCheck$lambda$_58_0_apply)],
    $java.oncius_TypeSpec$containsAny$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$containsAny$lambda$_11_0_apply)],
    $java.oncius_TypeSpec$wrapInList$lambda$_23_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$wrapInList$lambda$_23_0_apply)],
    $java.oncius_TypeSpec$leastUpperBounds$lambda$_22_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$leastUpperBounds$lambda$_22_0_apply)],
    $java.oncius_TypeSpec$unwrapLists$lambda$_26_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$unwrapLists$lambda$_26_0_apply)],
    $java.oncius_TypeSpec$without$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$without$lambda$_19_0_apply)],
    $java.oncius_TypeSpec$$union$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$union$lambda$_7_0_apply)],
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_0_apply)],
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_1_apply)],
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_2_apply)],
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_3_apply)],
    $java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticFunctionCheck$$checkPointMap$lambda$_48_4_apply)],
    $java.oncia_GraphReference$$fqn$1$lambda$_43_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_GraphReference$$fqn$1$lambda$_43_0_apply)],
    $java.oncia_connectedComponents$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_connectedComponents$$anonfun$1_applyOrElse)],
    $java.oncia_connectedComponents$$loop$1$lambda$_8_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_connectedComponents$$loop$1$lambda$_8_0_apply)],
    $java.oncia_SingleQuery$clausesExceptLeadingFrom$lambda$_60_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$clausesExceptLeadingFrom$lambda$_60_0_apply)],
    $java.oncias_SemanticExpressionCheck$$org$neo4j$cypher$internal$ast$semantics$SemanticExpressionCheck$$isShadowed$1$lambda$_211_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$org$neo4j$cypher$internal$ast$semantics$SemanticExpressionCheck$$isShadowed$1$lambda$_211_0_apply)],
    jlr_Modifier, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jl_Class$MethodSignature, "Class$MethodSignature", 6, jl_Object, [], 4, 0, 0, 0, ["$equals", $rt_wrapFunction1($java.jl_Class$MethodSignature_equals), "$hashCode0", $rt_wrapFunction0($java.jl_Class$MethodSignature_hashCode)],
    $java.oncias_SemanticCheck$$$anonfun$fromFunctionWithContext$1$lambda$_21_0, "SemanticCheck$$$anonfun$fromFunctionWithContext$1$lambda$_21_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$$anonfun$fromFunctionWithContext$1$lambda$_21_0_apply)],
    $java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$14$lambda$_80_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Foreach$$anonfun$clauseSpecificSemanticCheck$14$lambda$_80_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$check$4$lambda$_76_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$$anonfun$check$4$lambda$_76_0_apply)],
    $java.oncia_SingleQuery$$anonfun$leadingGraphSelection$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$leadingGraphSelection$1_applyOrElse)],
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$1$lambda$_90_0, "SubqueryCall$$anonfun$checkSubquery$1$lambda$_90_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$$anonfun$checkSubquery$1$lambda$_90_0_apply)],
    $java.onciu_NonEmptyList$toIndexedSeq$lambda$_72_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncias_Scope$$anonfun$allSymbols$1$lambda$_40_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_Scope$$anonfun$allSymbols$1$lambda$_40_0_apply)],
    $java.oncia_SortItem$semanticCheck$lambda$_2_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SortItem$semanticCheck$lambda$_2_0_apply)],
    $java.sc_IterableOps$$anonfun$groupMap$1$lambda$_126_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sc_IterableOps$$anonfun$groupMap$1$lambda$_126_0_apply)]]);
    $rt_metadata([$java.oncias_SemanticAnalysisTooling$expectType$lambda$_23_0, "SemanticAnalysisTooling$expectType$lambda$_23_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$expectType$lambda$_23_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_0, "ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_1, "ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_1", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_1_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_2, "ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_2", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_2_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_3, "ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_3", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$1$lambda$_55_3_apply)],
    $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_0_apply)],
    $java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$leastUpperBoundsOfTypes$lambda$_39_1_apply)],
    $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_0_apply)],
    $java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$$anonfun$checkAliasedReturnItems$1$lambda$_5_1_apply)],
    $java.oncius_TypeRange$checkForAny$lambda$_10_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1_applyOrElse)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1_applyOrElse)],
    $java.oncias_SemanticPatternCheck$$checkMinimumNodeCount$lambda$_46_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticPatternCheck$$checkMinimumNodeCount$lambda$_46_0_apply)],
    $java.oncia_UseGraph$unsupported$lambda$_58_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_UseGraph$unsupported$lambda$_58_0_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_0_apply)],
    $java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciap_Prettifier$IndentingQueryPrettifier$item$1$lambda$_114_1_apply)],
    $java.oncia_UseGraph$checkExpressions$lambda$_61_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UseGraph$checkExpressions$lambda$_61_0_apply)],
    $java.oncia_Match$$anonfun$6, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$6_applyOrElse)],
    $java.oncia_Match$checkDifferentRelationships$lambda$_70_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$checkDifferentRelationships$lambda$_70_0_apply)],
    $java.oncia_Match$checkDifferentRelationships$lambda$_70_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$checkDifferentRelationships$lambda$_70_1_apply)],
    $java.oncia_UseGraph$checkStaticGraphReference$lambda$_64_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_UseGraph$checkStaticGraphReference$lambda$_64_0_apply)],
    oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncifp_CreatePatternSelfReferenceCheck$$org$neo4j$cypher$internal$frontend$phases$CreatePatternSelfReferenceCheck$$isDefinition$1$lambda$_8_0_apply)],
    $java.onciu_RewritableCompat$PROXY$7_262, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$5_262, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_263, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_263, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_264, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_264, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_974, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_975, 0, jl_Object, [], 0, 3, 0, 0, 0,
    onciu_RewritableCompat$PROXY$3_977, 0, jl_Object, [], 0, 3, 0, 0, 0,
    jli_SerializedLambda, "SerializedLambda", 8, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.oti_Structure, 0, jl_Object, [], 0, 3, 0, 0, 0,
    otr_RuntimeObject, "RuntimeObject", 37, $java.oti_Structure, [], 0, 3, 0, 0, 0,
    $java.oncia_ViewRef$semanticCheck$lambda$_50_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ViewRef$semanticCheck$lambda$_50_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_0, "SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_1, "SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_1", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_1_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_2, "SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_2", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$2$applyOrElse$lambda$_0_2_apply)],
    $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_0_apply)],
    $java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ASTSlicingPhrase$$checkExpressionIsStaticInt$lambda$_40_1_apply)],
    $java.oncius_TypeSpec$toStrings$lambda$_39_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$toStrings$lambda$_39_0_apply)],
    $java.oncius_TypeRange$intersect$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeRange$intersect$lambda$_12_0_apply)],
    $java.ju_HashMap$2, 0, ju_AbstractCollection, [], 0, 0, 0, 0, ["$size", $rt_wrapFunction0($java.ju_HashMap$2_size), "$iterator", $rt_wrapFunction0($java.ju_HashMap$2_iterator)],
    oncia_Clause$org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Clause$org$neo4j$cypher$internal$ast$Clause$$sortLabelExpressionIntoPartition$lambda$_13_0_apply)],
    $java.oncias_SemanticCheck$$setState$lambda$_7_0, "SemanticCheck$$setState$lambda$_7_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticCheck$$setState$lambda$_7_0_apply)],
    $java.oncius_TypeSpec$covariant$lambda$_25_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$covariant$lambda$_25_0_apply)],
    $java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1$applyOrElse$lambda$_0_0, "connectedComponents$$anonfun$$nestedInanonfun$apply$1$1$applyOrElse$lambda$_0_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_connectedComponents$$anonfun$$nestedInanonfun$apply$1$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$anonfun$checkMinimumNodeCount$1$applyOrElse$lambda$_0_1_apply)],
    $java.oncius_TypeRange$contains$lambda$_6_0, 0, jl_Object, [$java.srj_JFunction0$mcZ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.srj_JFunction0$mcZ$sp_apply), "$apply$mcZ$sp", $rt_wrapFunction0($java.oncius_TypeRange$contains$lambda$_6_0_apply$mcZ$sp)]]);
    $rt_metadata([$java.oncius_TypeRange$contains$lambda$_6_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeRange$contains$lambda$_6_1_apply)],
    $java.sci_Map$WithDefault$newSpecificBuilder$lambda$_13_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Map$WithDefault$newSpecificBuilder$lambda$_13_0_apply)],
    $java.oncia_ASTSlicingPhrase$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_ASTSlicingPhrase$$anonfun$1_applyOrElse)],
    $java.oncia_ASTSlicingPhrase$$doesNotTouchTheGraph$lambda$_42_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ASTSlicingPhrase$$doesNotTouchTheGraph$lambda$_42_0_apply)],
    $java.oncius_TypeSpec$toStrings$lambda$_40_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$toStrings$lambda$_40_0_apply)],
    $java.oncius_TypeSpec$toStrings$lambda$_40_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$toStrings$lambda$_40_1_apply)],
    $java.oncius_TypeSpec$toStrings$lambda$_40_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$toStrings$lambda$_40_2_apply)],
    $java.oncius_TypeSpec$toStrings$lambda$_40_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$toStrings$lambda$_40_3_apply)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_0_apply)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_1_apply)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_2_apply)],
    $java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$noImplicitJoinsInQuantifiedPathPatterns$8$lambda$_109_3_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_1, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncias_SemanticAnalysisTooling$$anonfun$leastUpperBoundsOfTypes$2$lambda$_112_1_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$findRepeatedRelationships$2$lambda$_144_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$findRepeatedRelationships$2$lambda$_144_0_apply)],
    sc_View$, 0, jl_Object, [sc_IterableFactory], 4, 3, 0, 0, ["$newBuilder", $rt_wrapFunction0($java.sc_View$_newBuilder), "$from0", $rt_wrapFunction1($java.sc_View$_from0)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_0_apply)],
    $java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticExpressionCheck$$$anonfun$checkForShadowedVariables$10$lambda$_209_1_apply)],
    oncias_SemanticState$ScopeLocation$$$anonfun$symbol$extension$1$lambda$_22_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticState$ScopeLocation$$$anonfun$symbol$extension$1$lambda$_22_0_apply)],
    $java.oncius_TypeSpec$innerTypeRanges$lambda$_48_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$innerTypeRanges$lambda$_48_0_apply)],
    $java.oncia_UsingJoinHint$$anonfun$semanticCheck$3$lambda$_64_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_UsingJoinHint$$anonfun$semanticCheck$3$lambda$_64_0_apply)],
    sc_View$Drop, "View$Drop", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$Drop_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$Drop_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_View$Drop_isEmpty)],
    $java.oncius_TypeSpec$$anonfun$wrapInList$1$lambda$_59_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$wrapInList$1$lambda$_59_0_apply)],
    $java.oncius_TypeSpec$$anonfun$unwrapLists$1$lambda$_64_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$unwrapLists$1$lambda$_64_0_apply)],
    sc_MapOps$$anon$3, "MapOps$$anon$3", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_MapOps$$anon$3_hasNext), "$next", $rt_wrapFunction0($java.sc_MapOps$$anon$3_next)],
    $java.oncias_SemanticPatternCheck$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncias_SemanticPatternCheck$$anonfun$1_applyOrElse)],
    $java.oncius_TypeSpec$$anonfun$leastUpperBounds$1$lambda$_57_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$leastUpperBounds$1$lambda$_57_0_apply)],
    sc_MapOps$$anon$2, "MapOps$$anon$2", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_MapOps$$anon$2_hasNext), "$next", $rt_wrapFunction0($java.sc_MapOps$$anon$2_next)],
    $java.oncius_TypeSpec$$anonfun$containsAny$1$lambda$_51_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$containsAny$1$lambda$_51_0_apply)],
    $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_0_apply)],
    $java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$ensureNoReferencesOutFromQuantifiedPath$lambda$_60_1_apply)],
    $java.oncia_UseGraph$dynamicGraphReferenceError$1$lambda$_90_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_UseGraph$dynamicGraphReferenceError$1$lambda$_90_0_apply)],
    $java.onciu_RewritableCompat$PROXY$7_265, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_265, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.oncil_SolvableLabelExpression$containsSolutionsForRelationship$lambda$_12_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$containsSolutionsForRelationship$lambda$_12_0_apply)],
    $java.oncil_NodeLabels, 0, jl_Object, [], 3, 3, 0, 0, 0,
    oncil_NodeLabels$SomeUnknownLabels$, "NodeLabels$SomeUnknownLabels$", 27, jl_Object, [$java.oncil_NodeLabels, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productArity", $rt_wrapFunction0($java.oncil_NodeLabels$SomeUnknownLabels$_productArity), "$productElement", $rt_wrapFunction1($java.oncil_NodeLabels$SomeUnknownLabels$_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_NodeLabels$SomeUnknownLabels$_productIterator), "$hashCode0", $rt_wrapFunction0($java.oncil_NodeLabels$SomeUnknownLabels$_hashCode),
    "$toString", $rt_wrapFunction0($java.oncil_NodeLabels$SomeUnknownLabels$_toString)],
    $java.ju_HashMap$AbstractMapIterator, 0, jl_Object, [], 0, 0, 0, 0, ["$hasNext", $rt_wrapFunction0($java.ju_HashMap$AbstractMapIterator_hasNext)],
    $java.ju_HashMap$ValueIterator, 0, $java.ju_HashMap$AbstractMapIterator, [ju_Iterator], 0, 0, 0, 0, ["$next", $rt_wrapFunction0($java.ju_HashMap$ValueIterator_next)],
    $java.otcir_Flags, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncius_TypeSpec$unwrapPotentialLists$lambda$_27_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$unwrapPotentialLists$lambda$_27_0_apply)],
    $java.jl_IllegalAccessException, 0, jl_ReflectiveOperationException, [], 0, 3, 0, 0, 0,
    $java.otcir_Converter, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.oncia_ViewRef$argumentsAsGraphReferences$lambda$_51_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ViewRef$argumentsAsGraphReferences$lambda$_51_0_apply)],
    sci_Stream$Empty$, "Stream$Empty$", 43, sci_Stream, [], 0, 3, 0, 0, ["$isEmpty", $rt_wrapFunction0($java.sci_Stream$Empty$_isEmpty), "$knownSize", $rt_wrapFunction0($java.sci_Stream$Empty$_knownSize), "$tailDefined", $rt_wrapFunction0($java.sci_Stream$Empty$_tailDefined), "$force0", $rt_wrapFunction0($java.sci_Stream$Empty$_force), "$tail", $rt_wrapFunction0($java.sci_Stream$Empty$_tail), "$head", $rt_wrapFunction0($java.sci_Stream$Empty$_head)],
    sci_Stream$Cons, "Stream$Cons", 43, sci_Stream, [], 4, 3, 0, 0, ["$head", $rt_wrapFunction0($java.sci_Stream$Cons_head), "$isEmpty", $rt_wrapFunction0($java.sci_Stream$Cons_isEmpty), "$tailDefined", $rt_wrapFunction0($java.sci_Stream$Cons_tailDefined), "$force0", $rt_wrapFunction0($java.sci_Stream$Cons_force), "$tail", $rt_wrapFunction0($java.sci_Stream$Cons_tail0)],
    sci_Stream$$fromIterator$lambda$_21_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$$fromIterator$lambda$_21_0_apply)],
    $java.oncius_ListType$greatestLowerBound$lambda$_38_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ListType$greatestLowerBound$lambda$_38_0_apply)],
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_4_apply)],
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_0_apply)]]);
    $rt_metadata([$java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_1_apply)],
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_2_apply)],
    $java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$greatestLowerBound$lambda$_40_3_apply)],
    $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_0_apply)],
    $java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_1, 0, jl_Object, [srj_JFunction0$mcJ$sp, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0(srj_JFunction0$mcJ$sp_apply), "$apply$mcJ$sp", $rt_wrapFunction0($java.oncie_IntervalQuantifier$canBeEmpty$lambda$_11_1_apply$mcJ$sp)],
    $java.oncius_TypeSpec$wrapInCovariantList$lambda$_24_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$wrapInCovariantList$lambda$_24_0_apply)],
    $java.oncia_connectedComponents$RichConnectedComponent, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_0, "TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_0", 40, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_0_apply)],
    $java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_1, "TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_1", 40, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.suc_TailCalls$TailRec$$anonfun$flatMap$2$lambda$_7_1_apply)],
    $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_0, "TailCalls$TailRec$$anonfun$result$1$lambda$_10_0", 40, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_0_apply)],
    $java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_1, "TailCalls$TailRec$$anonfun$result$1$lambda$_10_1", 40, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.suc_TailCalls$TailRec$$anonfun$result$1$lambda$_10_1_apply)],
    $java.suc_TailCalls$TailRec$$anonfun$map$1$lambda$_5_0, "TailCalls$TailRec$$anonfun$map$1$lambda$_5_0", 40, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.suc_TailCalls$TailRec$$anonfun$map$1$lambda$_5_0_apply)],
    $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_0, "TailCallsUtil$$$anonfun$traverse$2$lambda$_6_0", 22, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_0_apply)],
    $java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciut_TailCallsUtil$$$anonfun$traverse$2$lambda$_6_1_apply)],
    $java.onciut_TailCallsUtil$$$anonfun$map2$1$lambda$_8_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.onciut_TailCallsUtil$$$anonfun$map2$1$lambda$_8_0_apply)],
    $java.oncius_CypherType$greatestLowerBound$lambda$_35_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_CypherType$greatestLowerBound$lambda$_35_0_apply)],
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$2$lambda$_89_0, "SubqueryCall$$anonfun$checkSubquery$2$lambda$_89_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$$anonfun$checkSubquery$2$lambda$_89_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$2$lambda$_42_0, "ProjectionClause$$anonfun$semanticCheckContinuation$2$lambda$_42_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$2$lambda$_42_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$14$lambda$_54_1_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$11$lambda$_50_0, "ProjectionClause$$anonfun$semanticCheckContinuation$11$lambda$_50_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$11$lambda$_50_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$6$lambda$_47_0, "ProjectionClause$$anonfun$semanticCheckContinuation$6$lambda$_47_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$6$lambda$_47_0_apply)],
    $java.oncia_Match$$anonfun$7, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$7_applyOrElse)],
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$2$lambda$_139_0, "SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$2$lambda$_139_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$2$lambda$_139_0_apply)],
    $java.oncia_ASTSlicingPhrase$$containsNoVariables$lambda$_41_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ASTSlicingPhrase$$containsNoVariables$lambda$_41_0_apply)],
    $java.onciu_RewritableCompat$PROXY$7_266, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_266, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_267, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_267, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$7_268, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciu_RewritableCompat$PROXY$5_268, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.sci_Stream$partition$lambda$_56_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Stream$partition$lambda$_56_0_apply)],
    $java.sci_Stream$partition$lambda$_56_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$partition$lambda$_56_1_apply)],
    $java.sci_Stream$partition$lambda$_56_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Stream$partition$lambda$_56_2_apply)],
    $java.sci_Stream$partition$lambda$_56_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$partition$lambda$_56_3_apply)],
    $java.sci_Stream$append$lambda$_49_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$append$lambda$_49_0_apply)],
    $java.sci_Stream$collectFirst$lambda$_64_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Stream$collectFirst$lambda$_64_0_apply)],
    $java.sc_View$$from$lambda$_18_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, 0,
    $java.sc_View$$anon$1, "View$$anon$1", 42, sc_AbstractView, [], 4, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$$anon$1_iterator)],
    $java.oncia_SingleQuery$semanticCheckInSubqueryContext$lambda$_67_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$semanticCheckInSubqueryContext$lambda$_67_0_apply)],
    onciu_NotImplementedErrorMessageProvider$, 0, jl_Object, [onciu_ErrorMessageProvider], 4, 3, 0, 0, ["$createMissingPropertyLabelHintError", function(var_1, var_2, var_3, var_4, var_5, var_6, var_7) { return $java.onciu_NotImplementedErrorMessageProvider$_createMissingPropertyLabelHintError(this, var_1, var_2, var_3, var_4, var_5, var_6, var_7); }, "$createUseClauseUnsupportedError", $rt_wrapFunction0($java.onciu_NotImplementedErrorMessageProvider$_createUseClauseUnsupportedError), "$createDynamicGraphReferenceUnsupportedError",
    $rt_wrapFunction0($java.onciu_NotImplementedErrorMessageProvider$_createDynamicGraphReferenceUnsupportedError), "$createMultipleGraphReferencesError", $rt_wrapFunction0($java.onciu_NotImplementedErrorMessageProvider$_createMultipleGraphReferencesError)],
    $java.oncia_ReturnItems$declareVariables$lambda$_60_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ReturnItems$declareVariables$lambda$_60_0_apply)],
    $java.oncia_ReturnItems$declareVariables$lambda$_60_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$declareVariables$lambda$_60_1_apply)],
    $java.oncie_Expression$$anonfun$dependencies$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncie_Expression$$anonfun$dependencies$1_applyOrElse)],
    $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$hasImportFormat$1$lambda$_93_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$hasImportFormat$1$lambda$_93_0_apply)],
    $java.oncia_SingleQuery$checkIllegalImportWith$lambda$_69_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkIllegalImportWith$lambda$_69_0_apply)],
    $java.oncia_SingleQuery$clausesExceptLeadingFromAndImportWith$lambda$_61_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$clausesExceptLeadingFromAndImportWith$lambda$_61_0_apply)],
    $java.oncia_SingleQuery$checkShadowedVariables$lambda$_76_0, "SingleQuery$checkShadowedVariables$lambda$_76_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkShadowedVariables$lambda$_76_0_apply)],
    $java.sc_LinearSeqIterator, "LinearSeqIterator", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_LinearSeqIterator_hasNext), "$next", $rt_wrapFunction0($java.sc_LinearSeqIterator_next)],
    $java.onciu_CartesianProductNotification, "CartesianProductNotification", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_CartesianProductNotification_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_CartesianProductNotification_productArity), "$productElement", $rt_wrapFunction1($java.onciu_CartesianProductNotification_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_CartesianProductNotification_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_CartesianProductNotification_hashCode), "$toString", $rt_wrapFunction0($java.onciu_CartesianProductNotification_toString), "$equals", $rt_wrapFunction1($java.onciu_CartesianProductNotification_equals)]]);
    $rt_metadata([$java.oncia_Match$$anonfun$checkForCartesianProducts$2$lambda$_114_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$checkForCartesianProducts$2$lambda$_114_0_apply)],
    $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_0_apply)],
    $java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeRange$$anonfun$intersect$1$lambda$_42_1_apply)],
    sc_View$Appended, 0, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$Appended_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$Appended_knownSize)],
    sc_View$DropRight, "View$DropRight", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$DropRight_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$DropRight_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_View$DropRight_isEmpty)],
    sc_View$DistinctBy, "View$DistinctBy", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$DistinctBy_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$DistinctBy_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_View$DistinctBy_isEmpty)],
    sc_SeqOps$intersect$lambda$_118_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_SeqOps$intersect$lambda$_118_0_apply)],
    $java.oncia_SingleQuery$$anonfun$leadingNonImportWith$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$leadingNonImportWith$1_applyOrElse)],
    $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_0_apply)],
    $java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Union$semanticCheckInSubqueryContext$lambda$_19_1_apply)],
    $java.oncius_TypeSpec$$anonfun$unwrapPotentialLists$1$lambda$_66_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$unwrapPotentialLists$1$lambda$_66_0_apply)],
    $java.oncius_TypeSpec$$anonfun$wrapInCovariantList$1$lambda$_61_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$wrapInCovariantList$1$lambda$_61_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$16$lambda$_53_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$16$lambda$_53_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_0_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_1_apply)],
    $java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticPatternCheck$$$anonfun$ensureNoReferencesOutFromQuantifiedPath$3$lambda$_138_2_apply)],
    $java.sc_LinearSeqIterator$LazyCell, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.sc_LinearSeqIterator$_init_$lambda$_4_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sc_LinearSeqIterator$_init_$lambda$_4_0_apply)],
    $java.oncius_ClosedDynamicUnionType$$anonfun$greatestLowerBound$1$lambda$_62_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_ClosedDynamicUnionType$$anonfun$greatestLowerBound$1$lambda$_62_0_apply)],
    $java.sc_View$$newBuilder$lambda$_20_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_View$$newBuilder$lambda$_20_0_apply)],
    $java.oncia_connectedComponents$RichConnectedComponent$connectedTo$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_connectedComponents$RichConnectedComponent$connectedTo$lambda$_0_0_apply)],
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncie_ExtractScope$scopeDependencies$lambda$_9_0_apply)],
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_ExtractScope$scopeDependencies$lambda$_9_1_apply)],
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncie_ExtractScope$scopeDependencies$lambda$_9_2_apply)],
    $java.oncie_ExtractScope$scopeDependencies$lambda$_9_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_ExtractScope$scopeDependencies$lambda$_9_3_apply)],
    $java.oncie_FilterScope$scopeDependencies$lambda$_8_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncie_FilterScope$scopeDependencies$lambda$_8_0_apply)],
    $java.oncie_FilterScope$scopeDependencies$lambda$_8_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_FilterScope$scopeDependencies$lambda$_8_1_apply)],
    $java.sc_LinearSeqIterator$next$lambda$_1_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sc_LinearSeqIterator$next$lambda$_1_0_apply)],
    $java.sci_Stream$map$lambda$_62_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$map$lambda$_62_0_apply)],
    $java.sci_Stream$flatMap$lambda$_65_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$flatMap$lambda$_65_0_apply)],
    $java.sci_Stream$flatMap$lambda$_65_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$flatMap$lambda$_65_1_apply)],
    $java.sci_Stream$flatMap$lambda$_65_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$flatMap$lambda$_65_2_apply)],
    $java.sci_Stream$flatMap$lambda$_65_3, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$flatMap$lambda$_65_3_apply)],
    $java.sci_Stream$prepended$lambda$_61_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$prepended$lambda$_61_0_apply)],
    $java.sci_Stream$collect$lambda$_63_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Stream$collect$lambda$_63_0_apply)],
    $java.sci_Stream$filterNot$lambda$_58_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$filterNot$lambda$_58_0_apply)],
    $java.sci_Stream$filter$lambda$_57_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$filter$lambda$_57_0_apply)],
    sc_IterableOnceExtensionMethods$, 0, jl_Object, [], 4, 3, 0, 0, 0,
    $java.sci_Stream$zip$lambda$_66_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$zip$lambda$_66_0_apply)],
    sci_LazyList$$from$lambda$_25_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$from$lambda$_25_0_apply)],
    $java.oncius_ClosedDynamicUnionType$leastUpperBound$lambda$_39_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncius_ClosedDynamicUnionType$leastUpperBound$lambda$_39_0_apply)],
    $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_Expression$$anonfun$dependencies$1$applyOrElse$lambda$_0_1_apply)],
    oncia_SingleQuery$clausesExceptLeadingImportWith$lambda$_59_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.sc_View$Single, 0, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$Single_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$Single_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_View$Single_isEmpty)],
    $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$$anonfun$flatMap$1$lambda$_98_0_apply)],
    $java.sci_Stream$$anonfun$flatMap$1$lambda$_98_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$$anonfun$flatMap$1$lambda$_98_1_apply)],
    $java.oncie_ExpressionWithComputedDependencies$scopeDependencies$lambda$_8_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncie_ExpressionWithComputedDependencies$scopeDependencies$lambda$_8_0_apply)],
    $java.oncia_Union$$anonfun$semanticCheckInSubqueryContext$3$lambda$_38_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Union$$anonfun$semanticCheckInSubqueryContext$3$lambda$_38_0_apply)],
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$3$lambda$_88_0, "SubqueryCall$$anonfun$checkSubquery$3$lambda$_88_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$$anonfun$checkSubquery$3$lambda$_88_0_apply)]]);
    $rt_metadata([$java.oncil_NodeLabels$KnownLabels, "NodeLabels$KnownLabels", 27, jl_Object, [$java.oncil_NodeLabels, s_Product, ji_Serializable], 4, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.oncil_NodeLabels$KnownLabels_productPrefix), "$productArity", $rt_wrapFunction0($java.oncil_NodeLabels$KnownLabels_productArity), "$productElement", $rt_wrapFunction1($java.oncil_NodeLabels$KnownLabels_productElement), "$productIterator", $rt_wrapFunction0($java.oncil_NodeLabels$KnownLabels_productIterator), "$hashCode0",
    $rt_wrapFunction0($java.oncil_NodeLabels$KnownLabels_hashCode), "$toString", $rt_wrapFunction0($java.oncil_NodeLabels$KnownLabels_toString), "$equals", $rt_wrapFunction1($java.oncil_NodeLabels$KnownLabels_equals)],
    $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_0_apply)],
    $java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeSpec$$anonfun$toStream$3$lambda$_73_1_apply)],
    s_PartialFunction$runWith$lambda$_22_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$3$lambda$_41_0, "ProjectionClause$$anonfun$semanticCheckContinuation$3$lambda$_41_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$3$lambda$_41_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$12$lambda$_49_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$12$lambda$_49_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$7$lambda$_46_0, "ProjectionClause$$anonfun$semanticCheckContinuation$7$lambda$_46_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$7$lambda$_46_0_apply)],
    $java.oncia_ReturnItems$$anonfun$declareVariables$3$lambda$_82_0, "ReturnItems$$anonfun$declareVariables$3$lambda$_82_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$$anonfun$declareVariables$3$lambda$_82_0_apply)],
    $java.oncias_SemanticAnalysisTooling$withState$lambda$_5_0, "SemanticAnalysisTooling$withState$lambda$_5_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$withState$lambda$_5_0_apply)],
    $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$5$lambda$_15_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$5$lambda$_15_0_apply)],
    $java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$9$lambda$_19_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncil_SolvableLabelExpression$$$anonfun$extractLabelExpressionRec$9$lambda$_19_0_apply)],
    $java.sr_BooleanRef, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    $java.sc_SeqOps$$anonfun$intersect$1$lambda$_139_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sc_SeqOps$$anonfun$intersect$1$lambda$_139_0_apply)],
    $java.oncia_ReturnItems$$anonfun$declareVariables$1$lambda$_80_0, "ReturnItems$$anonfun$declareVariables$1$lambda$_80_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ReturnItems$$anonfun$declareVariables$1$lambda$_80_0_apply)],
    $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_0_apply)],
    $java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncius_TypeRange$$anonfun$intersect$3$lambda$_41_1_apply)],
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$1$lambda$_122_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$1$lambda$_122_0_apply)],
    $java.oncia_SingleQuery$$anonfun$2, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$2_applyOrElse)],
    $java.oncia_SingleQuery$$anonfun$checkShadowedVariables$1$lambda$_147_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$checkShadowedVariables$1$lambda$_147_0_apply)],
    $java.oncia_SingleQuery$importVariables$1$lambda$_102_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$importVariables$1$lambda$_102_0_apply)],
    $java.oncia_SubqueryCall$returnToOuterScope$lambda$_63_0, "SubqueryCall$returnToOuterScope$lambda$_63_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$returnToOuterScope$lambda$_63_0_apply)],
    sci_Stream$$newBuilder$lambda$_23_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.sci_Stream$$newBuilder$lambda$_23_0_apply)],
    sci_LazyList$LazyIterator, "LazyList$LazyIterator", 43, sc_AbstractIterator, [], 0, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sci_LazyList$LazyIterator_hasNext), "$next", $rt_wrapFunction0($java.sci_LazyList$LazyIterator_next)],
    s_NotImplementedError, 0, jl_Error, [], 4, 3, 0, 0, 0,
    $java.sci_Stream$$collectedTail$lambda$_30_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$$collectedTail$lambda$_30_0_apply)],
    sci_LazyList$$from$lambda$_32_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$from$lambda$_32_0_apply)],
    $java.oncie_PathConcatenation$isBounded$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_PathConcatenation$isBounded$lambda$_6_0_apply)],
    onciuh_StringHelper$RichString$, 0, jl_Object, [], 0, 3, 0, 0, 0,
    $java.onciuh_StringHelper$, 0, jl_Object, [], 4, 3, 0, $java.onciuh_StringHelper$_$callClinit, 0,
    $java.oncia_Match$containsPropertyPredicates$lambda$_72_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$containsPropertyPredicates$lambda$_72_0_apply)],
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getMissingPropertyError$1$lambda$_128_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getMissingPropertyError$1$lambda$_128_0_apply)],
    $java.sc_View$DropRightIterator, "View$DropRightIterator", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$knownSize", $rt_wrapFunction0($java.sc_View$DropRightIterator_knownSize), "$hasNext", $rt_wrapFunction0($java.sc_View$DropRightIterator_hasNext), "$next", $rt_wrapFunction0($java.sc_View$DropRightIterator_next)],
    $java.oncil_SolvableLabelExpression$not$lambda$_13_0, "SolvableLabelExpression$not$lambda$_13_0", 27, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$not$lambda$_13_0_apply)],
    $java.oncia_Match$$anonfun$8, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$8_applyOrElse)],
    $java.oncia_Match$$anonfun$9, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$9_applyOrElse)],
    $java.oncia_Match$$anonfun$10, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$10_applyOrElse)],
    $java.oncia_Match$getPropertyPredicates$lambda$_73_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$getPropertyPredicates$lambda$_73_0_apply)],
    $java.oncia_Match$getPropertyPredicates$lambda$_73_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$getPropertyPredicates$lambda$_73_1_apply)],
    $java.oncia_Match$$anonfun$getPropertyPredicates$3, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$getPropertyPredicates$3_applyOrElse)],
    $java.sci_Stream$$anonfun$map$1$lambda$_95_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$$anonfun$map$1$lambda$_95_0_apply)],
    $java.sci_Stream$$anonfun$lazyAppendedAll$1$lambda$_90_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$$anonfun$lazyAppendedAll$1$lambda$_90_0_apply)],
    sci_Stream$$$anonfun$filteredTail$1$lambda$_39_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_Stream$$$anonfun$filteredTail$1$lambda$_39_0_apply)],
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_0_apply)],
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$3$lambda$_4_1_apply)],
    $java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$6$lambda$_6_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncie_Expression$$anonfun$dependencies$1$$anonfun$applyOrElse$6$lambda$_6_0_apply)],
    $java.oncia_Match$, 0, jl_Object, [ji_Serializable], 4, 3, 0, $java.oncia_Match$_$callClinit, 0,
    sc_Iterator$$anon$8, "Iterator$$anon$8", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_Iterator$$anon$8_hasNext), "$next", $rt_wrapFunction0($java.sc_Iterator$$anon$8_next)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$4$lambda$_40_0, "ProjectionClause$$anonfun$semanticCheckContinuation$4$lambda$_40_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$4$lambda$_40_0_apply)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$8$lambda$_45_0, "ProjectionClause$$anonfun$semanticCheckContinuation$8$lambda$_45_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$8$lambda$_45_0_apply)],
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_0_apply)]]);
    $rt_metadata([$java.oncia_SingleQuery$$anonfun$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_SingleQuery$$anonfun$1_applyOrElse)],
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_1_apply)],
    $java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SingleQuery$$anonfun$checkIllegalImportWith$9$lambda$_121_2_apply)],
    $java.oncia_SubqueryCall$$anonfun$checkSubquery$4$lambda$_87_0, "SubqueryCall$$anonfun$checkSubquery$4$lambda$_87_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SubqueryCall$$anonfun$checkSubquery$4$lambda$_87_0_apply)],
    $java.onciu_SubqueryVariableShadowing, "SubqueryVariableShadowing", 20, jl_Object, [$java.onciu_InternalNotification, s_Product, ji_Serializable], 0, 3, 0, 0, ["$productPrefix", $rt_wrapFunction0($java.onciu_SubqueryVariableShadowing_productPrefix), "$productArity", $rt_wrapFunction0($java.onciu_SubqueryVariableShadowing_productArity), "$productElement", $rt_wrapFunction1($java.onciu_SubqueryVariableShadowing_productElement), "$productIterator", $rt_wrapFunction0($java.onciu_SubqueryVariableShadowing_productIterator),
    "$hashCode0", $rt_wrapFunction0($java.onciu_SubqueryVariableShadowing_hashCode), "$toString", $rt_wrapFunction0($java.onciu_SubqueryVariableShadowing_toString), "$equals", $rt_wrapFunction1($java.onciu_SubqueryVariableShadowing_equals)],
    $java.oncie_Pattern$$anonfun$length$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncie_Pattern$$anonfun$length$1_applyOrElse)],
    $java.oncia_SubqueryCall$declareOutputVariablesInOuterScope$lambda$_66_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SubqueryCall$declareOutputVariablesInOuterScope$lambda$_66_0_apply)],
    $java.onciuh_StringHelper$RichString$$stripLinesAndMargins$extension$lambda$_1_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    sci_LazyList$SlidingIterator, "LazyList$SlidingIterator", 43, sc_AbstractIterator, [], 0, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sci_LazyList$SlidingIterator_hasNext), "$next", $rt_wrapFunction0($java.sci_LazyList$SlidingIterator_next)],
    $java.oncia_SingleQuery$$anonfun$2$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$2$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Match$$anonfun$8$applyOrElse$lambda$_0_0, "Match$$anonfun$8$applyOrElse$lambda$_0_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$8$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Match$$anonfun$9$applyOrElse$lambda$_0_0, "Match$$anonfun$9$applyOrElse$lambda$_0_0", 13, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$9$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$getPropertyPredicates$3$applyOrElse$lambda$_0_1_apply)],
    sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIterator$lambda$_28_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIterator$lambda$_28_0_apply)],
    sci_LazyList$State$Cons, 0, jl_Object, [sci_LazyList$State], 4, 3, 0, 0, ["$head", $rt_wrapFunction0($java.sci_LazyList$State$Cons_head), "$tail4", $rt_wrapFunction0($java.sci_LazyList$State$Cons_tail)],
    $java.oncil_SolvableLabelExpression$and$lambda$_15_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncil_SolvableLabelExpression$and$lambda$_15_0_apply)],
    $java.oncil_SolvableLabelExpression$or$lambda$_16_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncil_SolvableLabelExpression$or$lambda$_16_0_apply)],
    $java.oncia_SingleQuery$$anonfun$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$$anonfun$1$applyOrElse$lambda$_0_0_apply)],
    $java.srj_JFunction1$mcII$sp, 0, jl_Object, [s_Function1, ji_Serializable], 3, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.srj_JFunction1$mcII$sp_apply)],
    $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_1, "Pattern$$anonfun$length$1$applyOrElse$lambda$_0_1", 28, jl_Object, [$java.srj_JFunction1$mcII$sp, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.srj_JFunction1$mcII$sp_apply), "$apply$mcII$sp", $rt_wrapFunction1($java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_1_apply$mcII$sp)],
    $java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_0, "Pattern$$anonfun$length$1$applyOrElse$lambda$_0_0", 28, jl_Object, [$java.srj_JFunction1$mcII$sp, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.srj_JFunction1$mcII$sp_apply), "$apply$mcII$sp", $rt_wrapFunction1($java.oncie_Pattern$$anonfun$length$1$applyOrElse$lambda$_0_0_apply$mcII$sp)],
    $java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$isShadowed$1$lambda$_145_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$org$neo4j$cypher$internal$ast$SingleQuery$$isShadowed$1$lambda$_145_0_apply)],
    $java.oncil_SolvableLabelExpression$binary$lambda$_14_0, "SolvableLabelExpression$binary$lambda$_14_0", 27, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncil_SolvableLabelExpression$binary$lambda$_14_0_apply)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$withState$1$lambda$_82_0, "SemanticAnalysisTooling$$anonfun$withState$1$lambda$_82_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$anonfun$withState$1$lambda$_82_0_apply)],
    sc_View$TakeWhile, "View$TakeWhile", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$TakeWhile_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$TakeWhile_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_View$TakeWhile_isEmpty)],
    sc_View$DropWhile, "View$DropWhile", 42, sc_AbstractView, [], 0, 3, 0, 0, ["$iterator0", $rt_wrapFunction0($java.sc_View$DropWhile_iterator), "$knownSize", $rt_wrapFunction0($java.sc_View$DropWhile_knownSize), "$isEmpty", $rt_wrapFunction0($java.sc_View$DropWhile_isEmpty)],
    $java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$9$lambda$_44_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_ProjectionClause$$anonfun$semanticCheckContinuation$9$lambda$_44_0_apply)],
    oncia_ProjectionClause$$anonfun$warnOnAccessToRestrictedVariableInOrderByOrWhere$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_ProjectionClause$$anonfun$warnOnAccessToRestrictedVariableInOrderByOrWhere$1_applyOrElse)],
    oncia_ProjectionClause$warnOnAccessToRestrictedVariableInOrderByOrWhere$lambda$_35_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_ProjectionClause$warnOnAccessToRestrictedVariableInOrderByOrWhere$lambda$_35_0_apply)],
    $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_0_apply)],
    $java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SingleQuery$checkReturnItems$1$lambda$_107_1_apply)],
    $java.oncia_SingleQuery$checkDistinct$1$lambda$_109_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_SingleQuery$checkDistinct$1$lambda$_109_0_apply)],
    $java.oncia_SingleQuery$checkWhere$1$lambda$_113_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkWhere$1$lambda$_113_0_apply)],
    $java.oncia_SingleQuery$checkOrderBy$1$lambda$_111_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkOrderBy$1$lambda$_111_0_apply)],
    $java.oncia_SingleQuery$checkSkip$1$lambda$_115_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkSkip$1$lambda$_115_0_apply)],
    $java.oncia_SingleQuery$checkLimit$1$lambda$_117_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_SingleQuery$checkLimit$1$lambda$_117_0_apply)],
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_1_apply)],
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_2_apply)],
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_4_apply)],
    $java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$10$applyOrElse$lambda$_0_3_apply)],
    sci_LazyList$map$lambda$_69_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$map$lambda$_69_0_apply)],
    sci_LazyList$flatMap$lambda$_75_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$flatMap$lambda$_75_0_apply)],
    sci_LazyList$dropRight$lambda$_87_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$dropRight$lambda$_87_0_apply)],
    sci_LazyList$appended$lambda$_58_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$appended$lambda$_58_0_apply)],
    sci_LazyList$appended$lambda$_58_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$appended$lambda$_58_1_apply)],
    sci_LazyList$appended$lambda$_58_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$appended$lambda$_58_2_apply)],
    sci_LazyList$prepended$lambda$_67_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$prepended$lambda$_67_0_apply)],
    sci_LazyList$flatten$lambda$_76_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$flatten$lambda$_76_0_apply)]]);
    $rt_metadata([sci_LazyList$filter$lambda$_64_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$filter$lambda$_64_0_apply)],
    sci_LazyList$appendedAll$lambda$_57_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$appendedAll$lambda$_57_0_apply)],
    sci_LazyList$appendedAll$lambda$_57_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$appendedAll$lambda$_57_1_apply)],
    sci_LazyList$filterNot$lambda$_65_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$filterNot$lambda$_65_0_apply)],
    sci_LazyList$takeWhile$lambda$_91_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$takeWhile$lambda$_91_0_apply)],
    sci_LazyList$dropWhile$lambda$_86_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$dropWhile$lambda$_86_0_apply)],
    sci_LazyList$zip$lambda$_77_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$zip$lambda$_77_0_apply)],
    oncias_SemanticState$symbolTypes$lambda$_27_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticState$symbolTypes$lambda$_27_0_apply)],
    oncias_SemanticState$symbolTypes$lambda$_27_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncias_SemanticState$symbolTypes$lambda$_27_1_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1, 0, sr_AbstractPartialFunction, [ji_Serializable], 4, 3, 0, 0, ["$applyOrElse", $rt_wrapFunction2($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1_applyOrElse)],
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_0_apply)],
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$9$lambda$_4_1_apply)],
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_0_apply)],
    $java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.oncia_Match$$anonfun$getPropertyPredicates$3$$anonfun$applyOrElse$12$lambda$_7_1_apply)],
    sc_SeqView$Map, "SeqView$Map", 42, sc_View$Map, [sc_SeqView], 0, 3, 0, 0, ["$stringPrefix", $rt_wrapFunction0($java.sc_SeqView$Map_stringPrefix), "$scala$collection$SeqOps$$super$concat", $rt_wrapFunction1($java.sc_SeqView$Map_scala$collection$SeqOps$$super$concat), "$scala$collection$SeqOps$$super$sizeCompare", $rt_wrapFunction1($java.sc_SeqView$Map_scala$collection$SeqOps$$super$sizeCompare), "$$colon$plus", $rt_wrapFunction1($java.sc_SeqView$Map_$colon$plus), "$appendedAll", $rt_wrapFunction1($java.sc_SeqView$Map_appendedAll),
    "$concat0", $rt_wrapFunction1($java.sc_SeqView$Map_concat), "$size", $rt_wrapFunction0($java.sc_SeqView$Map_size), "$distinct3", $rt_wrapFunction0($java.sc_SeqView$Map_distinct), "$distinctBy", $rt_wrapFunction1($java.sc_SeqView$Map_distinctBy), "$lengthCompare", $rt_wrapFunction1($java.sc_SeqView$Map_lengthCompare), "$isEmpty", $rt_wrapFunction0($java.sc_SeqView$Map_isEmpty), "$apply1", $rt_wrapFunction1($java.sc_SeqView$Map_apply), "$length", $rt_wrapFunction0($java.sc_SeqView$Map_length), "$appended", $rt_wrapFunction1($java.sc_SeqView$Map_appended),
    "$map1", $rt_wrapFunction1($java.sc_SeqView$Map_map)],
    $java.oncias_SemanticAnalysisTooling$$anonfun$withState$2$lambda$_81_0, "SemanticAnalysisTooling$$anonfun$withState$2$lambda$_81_0", 17, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$$anonfun$withState$2$lambda$_81_0_apply)],
    $java.oncias_SemanticAnalysisTooling$declareVariables$lambda$_65_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncias_SemanticAnalysisTooling$declareVariables$lambda$_65_0_apply)],
    sci_LazyList$LazyBuilder, "LazyList$LazyBuilder", 43, jl_Object, [scm_ReusableBuilder], 4, 3, 0, 0, ["$sizeHint", $rt_wrapFunction1($java.sci_LazyList$LazyBuilder_sizeHint), "$sizeHint0", $rt_wrapFunction2($java.sci_LazyList$LazyBuilder_sizeHint0), "$addAll0", $rt_wrapFunction1($java.sci_LazyList$LazyBuilder_addAll), "$addOne", $rt_wrapFunction1($java.sci_LazyList$LazyBuilder_addOne), "$result0", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder_result)],
    sr_IntRef, 0, jl_Object, [ji_Serializable], 4, 3, 0, 0, 0,
    sci_LazyList$$scala$collection$immutable$LazyList$$dropImpl$lambda$_21_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$scala$collection$immutable$LazyList$$dropImpl$lambda$_21_0_apply)],
    sci_LazyList$$scala$collection$immutable$LazyList$$collectImpl$lambda$_19_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$scala$collection$immutable$LazyList$$collectImpl$lambda$_19_0_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_0_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_1_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_2_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_3_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_4_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_5_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_7_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_6_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_8_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_9_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$applyOrElse$lambda$_0_10_apply)],
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression$lambda$_78_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$getLabelsFromLabelExpression$lambda$_78_0_apply)],
    $java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap$lambda$_74_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, ["$apply", $rt_wrapFunction1($java.oncia_Match$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPropertyMap$lambda$_74_0_apply)],
    sci_LazyList$$anonfun$mapImpl$1$lambda$_161_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$anonfun$mapImpl$1$lambda$_161_0_apply)],
    sci_LazyList$$$anonfun$flatMapImpl$1$lambda$_52_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$$anonfun$flatMapImpl$1$lambda$_52_0_apply)],
    sci_LazyList$$anonfun$lazyAppendedAll$1$lambda$_147_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$anonfun$lazyAppendedAll$1$lambda$_147_0_apply)],
    sci_LazyList$$$anonfun$filterImpl$1$lambda$_48_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$$anonfun$filterImpl$1$lambda$_48_0_apply)],
    sci_LazyList$$anonfun$takeWhileImpl$1$lambda$_179_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$anonfun$takeWhileImpl$1$lambda$_179_0_apply)],
    $java.oncia_Match$$anonfun$10$$anonfun$applyOrElse$29$lambda$_3_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    $java.oncia_Match$$anonfun$10$$anonfun$applyOrElse$31$lambda$_5_0, 0, jl_Object, [s_Function1, ji_Serializable], 0, 3, 0, 0, 0,
    sc_SeqView$Appended, "SeqView$Appended", 42, sc_View$Appended, [sc_SeqView], 0, 3, 0, 0, ["$stringPrefix", $rt_wrapFunction0($java.sc_SeqView$Appended_stringPrefix), "$scala$collection$SeqOps$$super$concat", $rt_wrapFunction1($java.sc_SeqView$Appended_scala$collection$SeqOps$$super$concat), "$scala$collection$SeqOps$$super$sizeCompare", $rt_wrapFunction1($java.sc_SeqView$Appended_scala$collection$SeqOps$$super$sizeCompare), "$$colon$plus", $rt_wrapFunction1($java.sc_SeqView$Appended_$colon$plus), "$appendedAll",
    $rt_wrapFunction1($java.sc_SeqView$Appended_appendedAll), "$concat0", $rt_wrapFunction1($java.sc_SeqView$Appended_concat), "$size", $rt_wrapFunction0($java.sc_SeqView$Appended_size), "$distinct3", $rt_wrapFunction0($java.sc_SeqView$Appended_distinct), "$distinctBy", $rt_wrapFunction1($java.sc_SeqView$Appended_distinctBy), "$lengthCompare", $rt_wrapFunction1($java.sc_SeqView$Appended_lengthCompare), "$isEmpty", $rt_wrapFunction0($java.sc_SeqView$Appended_isEmpty), "$apply1", $rt_wrapFunction1($java.sc_SeqView$Appended_apply),
    "$length", $rt_wrapFunction0($java.sc_SeqView$Appended_length), "$appended", $rt_wrapFunction1($java.sc_SeqView$Appended_appended), "$map1", $rt_wrapFunction1($java.sc_SeqView$Appended_map)],
    sc_Iterator$$anon$11, "Iterator$$anon$11", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_Iterator$$anon$11_hasNext), "$next", $rt_wrapFunction0($java.sc_Iterator$$anon$11_next)],
    sc_Iterator$$anon$12, "Iterator$$anon$12", 42, sc_AbstractIterator, [], 4, 3, 0, 0, ["$hasNext", $rt_wrapFunction0($java.sc_Iterator$$anon$12_hasNext), "$next", $rt_wrapFunction0($java.sc_Iterator$$anon$12_next)],
    sci_LazyList$dropRightState$lambda$_88_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$dropRightState$lambda$_88_0_apply)],
    sci_LazyList$zipState$lambda$_78_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$zipState$lambda$_78_0_apply)],
    $java.sci_LazyList$take$lambda$_89_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$take$lambda$_89_0_apply)],
    sci_LazyList$LazyBuilder$DeferredState, 0, jl_Object, [], 4, 3, 0, 0, 0,
    sci_LazyList$LazyBuilder$clear$lambda$_9_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder$clear$lambda$_9_0_apply)],
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_0_apply)]]);
    $rt_metadata([$java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_1_apply)],
    $java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_2, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$$anonfun$flatMapImpl$2$lambda$_51_2_apply)],
    $java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$$anonfun$applyOrElse$23$lambda$_11_0, 0, jl_Object, [s_Function2, ji_Serializable], 0, 3, 0, 0, ["$apply0", $rt_wrapFunction2($java.oncia_Match$$anonfun$org$neo4j$cypher$internal$ast$Match$$collectPropertiesInPredicates$1$$anonfun$applyOrElse$23$lambda$_11_0_apply)],
    $java.sci_LazyList$LazyBuilder$addAll$lambda$_12_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder$addAll$lambda$_12_0_apply)],
    $java.sci_LazyList$LazyBuilder$result$lambda$_10_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder$result$lambda$_10_0_apply)],
    $java.sci_LazyList$LazyBuilder$addOne$lambda$_11_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder$addOne$lambda$_11_0_apply)],
    sci_LazyList$takeImpl$lambda$_90_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$takeImpl$lambda$_90_0_apply)],
    sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIteratorConcatSuffix$lambda$_27_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$scala$collection$immutable$LazyList$$stateFromIteratorConcatSuffix$lambda$_27_0_apply)],
    $java.sci_LazyList$$$anonfun$flatMapImpl$3$lambda$_50_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$$$anonfun$flatMapImpl$3$lambda$_50_0_apply)],
    $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_0_apply)],
    $java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_1, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder$$anonfun$addAll$1$lambda$_21_1_apply)],
    $java.sci_LazyList$LazyBuilder$$anonfun$addOne$1$lambda$_19_0, 0, jl_Object, [s_Function0, ji_Serializable], 0, 3, 0, 0, ["$apply2", $rt_wrapFunction0($java.sci_LazyList$LazyBuilder$$anonfun$addOne$1$lambda$_19_0_apply)]]);
    function $rt_array(cls, data) {
        this.$monitor = null;
        this.$id$ = 0;
        this.type = cls;
        this.data = data;
        this.constructor = $rt_arraycls(cls);
    }
    $rt_array.prototype = $rt_globals.Object.create(($rt_objcls()).prototype);
    $rt_array.prototype.toString = function() {
        var str = "[";
        for (var i = 0;i < this.data.length;++i) {
            if (i > 0) {
                str += ", ";
            }
            str += this.data[i].toString();
        }
        str += "]";
        return str;
    };
    $rt_setCloneMethod($rt_array.prototype, function() {
        var dataCopy;
        if ('slice' in this.data) {
            dataCopy = this.data.slice();
        } else {
            dataCopy = new this.data.constructor(this.data.length);
            for (var i = 0;i < dataCopy.length;++i) {
                dataCopy[i] = this.data[i];
            }
        }
        return new $rt_array(this.type, dataCopy);
    });
    $rt_stringPool(["Can\'t enter monitor from another thread synchronously", "interface ", "class ", "", "[]", "<init>", "<clinit>", "null", "String contains invalid digits: ", "String contains digits out of radix ", ": ", "The value is too big for int type: ", "String is null or empty", "Illegal radix: ", "0", "(this Collection)", ", ", "<function1>", "Cannot use %1$s hint `%2$s` in this context: %3$s", "Must use %1$s, that the hint is referring to, on %3$s either in the pattern or in supported predicates in `WHERE` (either directly or as part of a top-level `AND` or `OR`), but %2$s found. %5$s Note that %1$s must be specified on a non-optional %4$s.",
    "The USE clause is not available in embedded sessions. Try running the query using a Neo4j driver or the HTTP API.", "Dynamic graph references are supported only in composite databases.", "Multiple graph references in the same query is not supported on standard databases. This capability is supported on composite databases only.", "empty.reduceLeft", "(", ")", "empty.min", "empty.max", "minBy", "empty.", "empty.minBy", "LinearSeq.last", "LinearSeq", "List.last", "List", "multiple databases", "multiple graphs",
    "USE single graph selector", "init of empty list", "last of empty list", "tail of empty list", "head of empty list", " is out of bounds (min 0, max 1)", ",", "Tuple2", " not yet initialised", "InitialState", "None", "None.get", "IDP", "COST", "5.0", "IDPPlannerName", "Conditions started failing after running these phases: ", "Parse", "Expected exactly one statement per query but got: ", "Encountered \"<EOF>\"", "SyntaxDeprecationWarningsAndReplacements", "syntacticallyDeprecatedFeatures", "PreparatoryRewriting",
    "if(<f>) ", "extractSensitiveLiterals", "SemanticAnalysis", "Semantic features ", " and ", " are incompatible and cannot be enabled at the same time", "\n", "SemanticTypeCheck", "AmbiguousAggregationAnalysis", "semanticallyDeprecatedFeatures", "SET ", " = ", " = properties(", " += ", " += properties(", "assertion failed", "requirement failed", "an implementation is missing", "Index out of bounds", "PARSING", "DEPRECATION_WARNINGS", "ADDITION_ERRORS", "SEMANTIC_CHECK", "SEMANTIC_TYPE_CHECK", "AST_REWRITE", "LOGICAL_PLANNING",
    "CODE_GENERATION", "PIPE_BUILDING", "METADATA_COLLECTION", "`", "``", "1", "allShortestPaths(", "shortestPath(", "id", "normalizeWithAndReturnClauses", "insertWithBetweenOptionalMatchAndMatch", "expandCallWhere", "expandShowWhere", "rewriteShowQuery", "mergeInPredicates", "timestampRewriter", "rewriteShortestPathWithFixedLengthRelationship", "of class ", " (", "an instance ", "A pattern expression should only be used in order to test the existence of a pattern. It should therefore only be used in contexts that evaluate to a boolean, e.g. inside the function exists() or in a WHERE-clause. No other uses are allowed, instead they should be replaced by a pattern comprehension.",
    "A pattern expression should only be used in order to test the existence of a pattern. It can no longer be used inside the function size(), an alternative is to replace size() with COUNT {}.", "Coercion of list to boolean is not allowed. Please use `NOT isEmpty(...)` instead.", "AccumulatedSteps", "failed to pretty print ", "timestamp", "datetime", "epochMillis", "Byte", "Short", "Char", "Int", "Long", "Float", "Double", "Boolean", "Unit", "Any", "Object", "AnyVal", "Null", "Nothing", "Either src or dest is null",
    "java.version", "1.8", "os.name", "TeaVM", "file.separator", "/", "path.separator", ":", "line.separator", "java.io.tmpdir", "/tmp", "java.vm.version", "user.home", ".", "[", "]", "DISTINCT ", "{", "}", "count(*)", " IS NULL", " IS NOT NULL", "..", "any", "NOT ", " IN ", " | ", "all", "none", "single", ".*", "CASE", "END", " ", " AND ", " OR ", "reduce(", "EXISTS { ", " }", "COLLECT { ", "COUNT { ", "CoerceToPredicate(", "assertIsNode(", "disjoint(", "unique(", "size(", ") >= ", ") <= ", "isRepeatTrailUnique(",
    "elementIdToNodeId", "elementIdListToNodeIdList", "elementIdToRelationshipId", "elementIdListToRelationshipIdList", "IN", "\\\\", "\\\\\\\\", "\"", "\\\\\"", "\'******\'", "illegal password expression", "|", "|:", "&", "%", "IndexedSeq", "tail of empty array", "ArraySeq", "scala.reflect.classtag.cache.disable", "true", "<function2>", "Empty job", "No jobs", "Step ", " has no post-conditions. That is not allowed.", "Found same post-condition ", " in these steps: ", "digraph G {\n", "\n}", "The step sequence ",
    " did not include all steps from ", " did not lead to a state where all conditions ", " are met. Only meeting ", "There was a cycle in the graph: ", "Unknown statement: ", " {}", "RANGE INDEX", "INDEX", "FOR (", ") ON ", "FOR ()-[", "]-() ON ", "LOOKUP INDEX", "()-[", "]-()", "FOR ", " ON EACH ", "FULLTEXT INDEX", ") ON EACH ", "]-() ON EACH ", "TEXT INDEX", "POINT INDEX", " IF EXISTS", "DROP INDEX ", "CONSTRAINT", "FOR", "ON", "REQUIRE", "ASSERT", ") ", " IS NODE KEY", " ()-[", "]-() ", " IS RELATIONSHIP KEY",
    " IS UNIQUE", ") IS :: ", "Unknown command: ", "DROP CONSTRAINT ", " IF NOT EXISTS", "SET PASSWORD", "SET ENCRYPTED PASSWORD", " CHANGE ", "REQUIRED", "ACTIVE", "SUSPENDED", " SET STATUS ", " FROM ", " TO ", " WITH USERS", " AS COPY OF ", " IF NOT EXISTS AS COPY OF ", " ON DBMS TO ", " ON DBMS FROM ", "TO", "FROM", " ON ", "SHOW SUPPORTED PRIVILEGES", "SHOW ", " PRIVILEGES", " AS COMMANDS", " AS REVOKE COMMANDS", " DESTROY DATA", " IF EXISTS DESTROY DATA", " DUMP DATA", " IF EXISTS DUMP DATA", "PROPERTIES",
    " FOR DATABASE ", " IF NOT EXISTS FOR DATABASE ", "DRIVER", " AT ", " USER ", " PASSWORD ", " FOR DATABASE", " IF EXISTS FOR DATABASE", " SET DATABASE ", " IF EXISTS SET DATABASE ", " SET", "Unexpected command ", "DRYRUN ", " TARGET ", " SET DATABASE", " IF EXISTS SET DATABASE", " OPTIONS ", " OPTIONS {}", "Expected NoOptions or OptionsMap but was OptionsParam", ") IS NOT NULL", "exists(", "CREATE ", "IF NOT EXISTS ", "CREATE OR REPLACE ", "USER", "USER ", "USERS ", "<unknown>", "ALL", "ROLES ", "ROLE ", "*",
    "DEFAULT", "HOME", " DATABASE", "DATABASE ", "DATABASES ", " {", " {*}", " *", "Unknown resource: ", "GRAPH ", "GRAPH *", "DEFAULT GRAPH", "HOME GRAPH", "GRAPHS ", "WRITE", "SET LABEL", "REMOVE LABEL", "NODE ", "NODES ", "NODES *", "RELATIONSHIP ", "RELATIONSHIPS ", "RELATIONSHIPS *", "ELEMENTS ", "ELEMENTS *", "(*)", " TOPOLOGY", ") WHERE ", "Unknown expression: ", "UNION ALL", "UNION", "USE ", " DISTINCT", "RETURN", "OPTIONAL ", "MATCH ", "CALL {\n         |", "\n         |", " OF ", " ROWS", " ON ERROR BREAK",
    " ON ERROR CONTINUE", " ON ERROR FAIL", " REPORT STATUS AS ", " IN TRANSACTIONS", "WHERE ", "USING JOIN ON ", "USING SCAN ", "USING ", "INDEX ", "TEXT INDEX ", "RANGE INDEX ", "POINT INDEX ", "SEEK ", "MERGE ", "SKIP ", "LIMIT ", "ORDER BY ", "WITH", "YIELD ", "UNWIND ", " AS ", "YIELD *", "CALL ", " INDEXES", " CONSTRAINTS", "SHOW PROCEDURES", " FUNCTIONS", " EXECUTABLE BY CURRENT USER", " EXECUTABLE BY ", "SHOW TRANSACTIONS", "TERMINATE TRANSACTIONS", "SHOW SETTINGS", "REMOVE ", " WITH HEADERS", "LOAD CSV",
    "DETACH ", "DELETE ", "  ", "FOREACH ( ", " |", "false", "Map", "key not found: ", " is out of bounds (min 0, max ", "ArrayBuffer", "Some", "->", "<-", "+", "())* (", "<", ">", "-[", "]-", "Set", "�", "newAction must be non-null", "<function0>", "main", "The string does not represent a number", "The string represents a too big number", "Can\'t parse empty or null string", "Replacement preconditions do not hold", "UTF-8", "IGNORE", "REPLACE", "REPORT", "New position ", " is outside of range [0;", "Capacity is negative: ",
    "The last byte in src ", " is outside of array of size ", "Length ", " must be non-negative", "Offset ", "BIG_ENDIAN", "LITTLE_ENDIAN", "  \"", "\";", "AdjacencyList", "step cannot be 0.", "(<not computed>)", "View", "()", "BaseContains", "Unknown state: ", "Statement missing", "Semantic state missing", "Semantic table missing", "Valid symbolic names in label expressions", "new HashMap table size ", " exceeds maximum", "HashMap", "Variable `", "` already declared", " or ", "Type mismatch: ", " defined with conflicting type ",
    " (expected ", "` not defined", "SemanticState", "Node(", ") -> ", "DeprecatedSyntaxReplaced", "DeprecatedSemanticsReplaced", "SemanticAnalysisPossible", "AdditionalSemanticTypeChecksPerformed", " is not subtype of ", "Collections cannot have more than ", " elements", "Size of array-backed collection exceeds VM array size limit of ", "Copied ", " of ", "StatementCondition", "containsNoNodesOfType", "UnaliasedReturnItem", "ExpressionsHaveComputedDependencies", "SensitiveLiteralsExtracted", "HashSet", "<iterator>",
    "PatternExpressionsHaveSemanticInfo", "ProjectionClausesHaveSemanticInfo", "next on empty iterator", "ListBuffer", "BitmapIndexedSetNode diff HashCollisionSetNode", "Trie nodes do not support hashing.", "Cannot concatenate a HashCollisionSetNode with a BitmapIndexedSetNode", "Action must be non-null", "No sub-nodes present in hash-collision leaf node.", "The last char in dst ", "A non-empty VectorBuilder cannot be aligned retrospectively. Please call .reset() or use a new VectorBuilder.", "Vector", "empty.head",
    "empty.tail", "ByInitialCondition", "scala.collection.immutable.Vector.defaultApplyPreferredMaxLength", "250", "self-referential LazyList or a derivation thereof has no more elements", "LazyList", "requirement failed: ", "size=", " and step=", ", but both must be positive", "<not computed>", "<cycle>", "empty.init", " is out of bounds (empty vector)", "Digits < 0", "null RoundingMode", "UP", "DOWN", "CEILING", "FLOOR", "HALF_UP", "HALF_DOWN", "HALF_EVEN", "UNNECESSARY", "Seq", "Failed rewriting ", "\nTried using children: ",
    "Got semantic deprecations ", " but no SemanticTable", "SeqView", "SemanticCheckResult", " has a negated post-condition: ", ". That is not allowed.", "\" -> \"", " has an negated invalidated condition: ", "Scope", "Cannot concatenate a HashCollisionMapNode with a BitmapIndexedMapNode", "Left", "mutation occurred during iteration", "Invalid input \'", "\': expected four hexadecimal digits specifying a unicode character", "End of input", "\'%s\' does not allow relationship patterns", "\'%s\' does not allow node patterns",
    "Filter type %s is not defined for show %s command.", "Index type %s is not defined for create index command.", "\':", " expected", "quantified", "parenthesized", "Path selectors such as `", "` are not supported within ", " path patterns.", "` cannot be used in a ", " clause, but only in a MATCH clause.", "unknown parameter type: ", "constraints", "name", "type", "entityType", "labelsOrTypes", "properties", "ownedIndex", "propertyType", "options", "createStatement", "Unsupported drop constraint command: Please delete the constraint by name instead",
    "Constraint type \'%s\' does not allow multiple properties", "Unknown Cypher type: ", "Unexpected database name format", " WAIT ", " SECONDS", "GRANT", "GRANTED", "DENY", "DENIED", "value", "isDynamic", "defaultValue", "description", "startupValue", "isExplicitlySet", "validValues", "isDeprecated", "transactionId", "username", "message", "functions", "indexes", "Abbreviated patterns are not supported yet", "A valid Cypher query has to contain at least 1 clause", "<EOF>", "\"\\t\"", "\"\\n\"", "\"\\u000b\"",
    "\"\\f\"", "\"\\r\"", "\"\\u001c\"", "\"\\u001d\"", "\"\\u001e\"", "\"\\u001f\"", "\" \"", "\"\\u00a0\"", "\"\\u1680\"", "\"\\u2000\"", "\"\\u2001\"", "\"\\u2002\"", "\"\\u2003\"", "\"\\u2004\"", "\"\\u2005\"", "\"\\u2006\"", "\"\\u2007\"", "\"\\u2008\"", "\"\\u2009\"", "\"\\u200a\"", "\"\\u2028\"", "\"\\u2029\"", "\"\\u202f\"", "\"\\u205f\"", "\"\\u3000\"", "<SINGLE_LINE_COMMENT>", "<token of kind 30>", "\"/*\"", "\"*/\"", "<token of kind 34>", "<DECIMAL_DOUBLE>", "<UNSIGNED_DECIMAL_INTEGER>", "<DECIMAL_EXPONENT>",
    "<INTEGER_PART>", "<UNSIGNED_HEX_INTEGER>", "<UNSIGNED_OCTAL_INTEGER>", "\"\\\'\"", "\"\\\\\\\\\"", "\"\\\\\\\'\"", "\"\\\\\\\"\"", "\"\\\\b\"", "\"\\\\f\"", "\"\\\\n\"", "\"\\\\r\"", "\"\\\\t\"", "\"\\\\u[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]\"", "<token of kind 51>", "\"\\\"\"", "<token of kind 63>", "\"`\"", "<token of kind 66>", "\"``\"", "\"ACCESS\"", "\"ACTIVE\"", "\"ADMIN\"", "\"ADMINISTRATOR\"", "\"ALIAS\"", "\"ALIASES\"", "\"allShortestPaths\"", "\"ALL\"", "\"ALTER\"", "\"AND\"", "\"ANY\"", "\"ARRAY\"",
    "\"AS\"", "<ASC>", "\"ASSERT\"", "\"ASSIGN\"", "\"AT\"", "\"|\"", "\"BINDINGS\"", "\"BOOL\"", "\"BOOLEAN\"", "\"BOOSTED\"", "\"BREAK\"", "\"BRIEF\"", "\"BTREE\"", "\"BUILT\"", "\"BY\"", "\"CALL\"", "\"CASE\"", "\"CHANGE\"", "\"CIDR\"", "\"COLLECT\"", "\":\"", "\"::\"", "\",\"", "\"COMMAND\"", "\"COMMANDS\"", "\"COMMIT\"", "\"COMPOSITE\"", "\"CONSTRAINT\"", "\"CONSTRAINTS\"", "\"CONTAINS\"", "\"COPY\"", "\"CONTINUE\"", "\"COUNT\"", "\"CREATE\"", "\"CSV\"", "\"CURRENT\"", "\"DATA\"", "\"DATABASE\"", "\"DATABASES\"",
    "\"DATE\"", "\"DATETIME\"", "\"DBMS\"", "\"DEALLOCATE\"", "\"DEFAULT\"", "\"DEFINED\"", "\"DELETE\"", "\"DENY\"", "<DESC>", "\"DESTROY\"", "\"DETACH\"", "\"$\"", "\"DIFFERENT\"", "\"DISTINCT\"", "\"/\"", "\".\"", "\"..\"", "\"DRIVER\"", "\"DROP\"", "\"DRYRUN\"", "\"DUMP\"", "\"DURATION\"", "\"EACH\"", "\"EDGE\"", "\"ENABLE\"", "\"ELEMENT\"", "\"ELEMENTS\"", "\"ELSE\"", "\"ENCRYPTED\"", "\"END\"", "\"ENDS\"", "\"=\"", "\"EXECUTABLE\"", "\"EXECUTE\"", "\"EXIST\"", "\"EXISTENCE\"", "\"EXISTS\"", "\"ERROR\"", "\"FAIL\"",
    "\"false\"", "\"FIELDTERMINATOR\"", "\"FLOAT\"", "\"FOR\"", "\"FOREACH\"", "\"FROM\"", "\"FULLTEXT\"", "\"FUNCTION\"", "\"FUNCTIONS\"", "\">=\"", "\"GRANT\"", "\"GRAPH\"", "\"GRAPHS\"", "\"GROUP\"", "\"GROUPS\"", "\">\"", "\"HEADERS\"", "\"HOME\"", "\"IF\"", "\"IMPERSONATE\"", "\"IMMUTABLE\"", "\"IN\"", "\"INDEX\"", "\"INDEXES\"", "\"INF\"", "\"INFINITY\"", "\"INT\"", "\"INTEGER\"", "\"IS\"", "\"JOIN\"", "\"KEY\"", "\"LABEL\"", "\"LABELS\"", "\"&\"", "\"!\"", "\"[\"", "\"{\"", "\"<=\"", "\"LIMIT\"", "\"LIST\"",
    "\"LOAD\"", "\"LOCAL\"", "\"LOOKUP\"", "\"(\"", "\"<\"", "\"MANAGEMENT\"", "\"MAP\"", "\"MATCH\"", "\"MERGE\"", "\"-\"", "\"%\"", "\"!=\"", "\"<>\"", "\"NAME\"", "\"NAMES\"", "\"NAN\"", "\"NEW\"", "\"NODE\"", "\"NODES\"", "\"NONE\"", "\"NOT\"", "\"NOTHING\"", "\"NOWAIT\"", "\"null\"", "\"OF\"", "\"ON\"", "\"ONLY\"", "\"OPTIONAL\"", "\"OPTIONS\"", "\"OPTION\"", "\"OR\"", "\"ORDER\"", "\"OUTPUT\"", "\"PASSWORD\"", "\"PASSWORDS\"", "\"PATH\"", "\"PATHS\"", "\"PERIODIC\"", "\"PLAINTEXT\"", "\"+\"", "\"+=\"", "\"POINT\"",
    "\"POPULATED\"", "\"^\"", "\"REPEATABLE\"", "\"PRIMARY\"", "\"PRIMARIES\"", "\"PRIVILEGE\"", "\"PRIVILEGES\"", "\"PROCEDURE\"", "\"PROCEDURES\"", "\"PROPERTIES\"", "\"PROPERTY\"", "\"?\"", "\"RANGE\"", "\"]\"", "\"}\"", "\"READ\"", "\"REALLOCATE\"", "\"REDUCE\"", "\"RENAME\"", "\"=~\"", "\"REL\"", "\"RELATIONSHIP\"", "\"RELATIONSHIPS\"", "\"REMOVE\"", "\"REPLACE\"", "\"REPORT\"", "\"REQUIRE\"", "\"REQUIRED\"", "\"RETURN\"", "\"REVOKE\"", "\"ROLE\"", "\"ROLES\"", "\"ROW\"", "\"ROWS\"", "\")\"", "\"SCAN\"", "\"SEC\"",
    "\"SECOND\"", "\"SECONDARY\"", "\"SECONDARIES\"", "\"SECONDS\"", "\"SEEK\"", "\";\"", "\"SERVER\"", "\"SERVERS\"", "\"SET\"", "\"SETTING\"", "\"SETTINGS\"", "\"shortestPath\"", "\"SHORTEST\"", "\"SHOW\"", "\"SIGNED\"", "\"SINGLE\"", "\"SKIP\"", "\"START\"", "\"STARTS\"", "\"STATUS\"", "\"STOP\"", "\"STRING\"", "\"SUPPORTED\"", "\"SUSPENDED\"", "\"TARGET\"", "\"TERMINATE\"", "\"TEXT\"", "\"THEN\"", "\"TIME\"", "\"*\"", "\"TIMESTAMP\"", "\"TIMEZONE\"", "\"TO\"", "\"TOPOLOGY\"", "\"TRANSACTION\"", "\"TRANSACTIONS\"",
    "\"TRAVERSE\"", "\"true\"", "\"TYPE\"", "\"TYPED\"", "\"TYPES\"", "\"UNION\"", "\"UNIQUE\"", "\"UNIQUENESS\"", "\"UNWIND\"", "\"URL\"", "\"USE\"", "\"USER\"", "\"USERS\"", "\"USING\"", "\"VALUE\"", "\"VARCHAR\"", "\"VERBOSE\"", "\"VERTEX\"", "\"WAIT\"", "\"WHEN\"", "\"WHERE\"", "\"WITH\"", "\"WITHOUT\"", "\"WRITE\"", "\"XOR\"", "\"YIELD\"", "\"ZONED\"", "<IDENTIFIER>", "<LETTER>", "<PART_LETTER>", "<ARROW_LINE>", "<ARROW_LEFT_HEAD>", "<ARROW_RIGHT_HEAD>", "<UNKNOWN>", "Invalid input \'%s\': expected \"%s\"",
    "The PERIODIC COMMIT query hint is no longer supported. Please use CALL { ... } IN TRANSACTIONS instead.", "The Neo4j AST encodes Unions as a left-deep tree, so the rhs query must always be a SingleQuery. Got `", "Index type %s is not defined for USING index hint. Use %s instead.", "Index type %s is no longer supported for USING index hint. Use %s instead.", "MERGE", "Failed to parse the file expression. Please remember to use quotes for string literals.", "Duplicated OF ROWS parameter", "Duplicated ON ERROR parameter",
    "Duplicated REPORT STATUS parameter", "Expected a pattern without a selector, got: [", "]: ", "Case expressions have the same number of whens and thens, but got whens `", "` and thens `", "Map have the same number of keys and values, but got keys `", "` and values `", "\'REPLACE\' is not allowed for this index syntax", "NODE", "REL", "role", "member", "Duplicate SET PASSWORD clause", "Should never been thrown", "The last byte in dst ", "Duplicate SET PASSWORD CHANGE [NOT] REQUIRED clause", "Duplicate SET STATUS {SUSPENDED|ACTIVE} clause",
    "Duplicate SET HOME DATABASE clause", "user", "roles", "passwordChangeRequired", "suspended", "home", "DATABASE", "DBMS", "GRAPH", "Duplicate PRIMARY clause", "Duplicate SECONDARY clause", "Duplicate \'REMOVE OPTION ", "\' clause", "Duplicate SET ACCESS clause", "Duplicate SET TOPOLOGY clause", "Duplicate \'SET OPTION ", "Duplicate SET DATABASE %s clause", "?", "ReturnItemsAreAliased", "ExpressionsInOrderByAndWhereUseAliases", "WithBetweenOptionalMatchAndMatchInserted", "WithBetweenCallAndWhereInserted", "WithBetweenShowAndWhereInserted",
    "ShowRewrittenToShowYieldWhereReturn", "MultipleInPredicatesAreMerged", "TimestampRewritten", "NoShortestPathWithFixedLength", "exceeding 2^31 elements", "advance1(", "): a1=", ", a2=", ", a3=", ", a4=", ", a5=", ", a6=", ", depth=", "Vector cannot have negative size ", "VectorBuilder(len1=", ", lenRest=", ", offset=", "OpenCypherExceptionFactory", "tail of empty lazy list", "head of empty lazy list", "containsNoReturnAll", "LiteralsExtracted", "FunctionInvocationsResolved", "Internal Error", "Internal Error : Please send a bug report.",
    "\\", "\'", "\u0008", "\u000c", "\r", "\t", "::", "$", "=", ">=", "!", "<=", "-", "!=", "<>", "+=", "^", "=~", ";", "IN_FORMAL_COMMENT", "IN_MULTI_LINE_COMMENT", "IN_SINGLE_LINE_COMMENT", "STRING1", "STRING2", "ESC_SYMB_NAME", "line ", ", column ", " (offset: ", "InputPosition", "USE multiple graph selector", "show setting", "Shortest path as defined for GQL", "Match modes", "Property value access rules", "Statement", "ReturnItems(includeExisting = true, ...)", "...", "    ", "Encountered \"", "\\t", "\\n",
    "\\f", "\\r", "\\\"", "\\\'", "0000", "\\u", "\\b", " \"", "\" at line ", "Was expecting", " one of:", " is out of bounds (min 0, max 2)", "Tuple3", "SortedSet", "TreeSet", "ordering must not be null", "NegatedCondition", "assertion failed: ", "Array.length must be power of 2", "empty collection", "Queue", "There is no step introducing ", " has ", " as a pre-condition, but ", " is an initial condition. That is currently not allowed.", "Right", "(this Map)", "EXPECT_BAR", "DO_NOT_EXPECT_BAR", "Error during rewriting after ",
    ". The following conditions where violated: \n", "ValidatingRewriter", "Stack", "<EOF> ", "\" (", "), ", "Lexical error at line ", ".  Encountered: ", "after : \"", "Location", "Didn\'t expect ProjectingUnion, only SingleQuery, UnionAll, or UnionDistinct.", "Non-negative array size required", "ArrayDeque too big - cannot allocate ArrayDeque of length ", "Expected none but found ", " at position ", "\\s\\sAUTO(INT|STRING|DOUBLE|LIST)\\d+", "Type mismatch for parameter \'", "\': ", "The `", "` clause", "SHOW PRIVILEGE",
    "ShowPrivileges", "IS ", "This expression could be expressed as ", "These expressions could be expressed as ", "Mixing the IS keyword with colon (\':\') between labels is not allowed. ", "Mixing label expression symbols (\'|\', \'&\', \'!\', and \'%\') with colon (\':\') is not allowed. Please only use one set of symbols. ", "Cannot use aggregation in ORDER BY if there are no aggregate expressions in the preceding ", "YIELD", "Yield", "SHOW PRIVILEGE COMMANDS", "ShowPrivilegeCommands", "ShowSupportedPrivilegeCommand",
    "SHOW DATABASE", "SHOW DATABASES", "SHOW DEFAULT DATABASE", "SHOW HOME DATABASE", "ShowDatabase", "SHOW ALIASES", "SHOW ALIAS", "ShowAliases", "SHOW CURRENT USER", "ShowCurrentUser", "SHOW USERS", "ShowUsers", "SHOW POPULATED ROLES", "SHOW ALL ROLES", "ShowRoles", "SHOW SERVERS", "ShowServers", "ListSet", "elem of empty set", "next of empty set", "org.neo4j.cypher.internal.expressions.UnsignedDecimalIntegerLiteral", "org.neo4j.cypher.internal.expressions.NaN$$anon$9", "org.neo4j.cypher.internal.ast.AlterDatabase",
    "org.neo4j.cypher.internal.expressions.PlusQuantifier", "org.neo4j.cypher.internal.util.symbols.LocalDateTimeType", "org.neo4j.cypher.internal.expressions.In", "org.neo4j.cypher.internal.util.symbols.DurationType", "org.neo4j.cypher.internal.ast.CreateRelationshipPropertyUniquenessConstraint", "org.neo4j.cypher.internal.util.symbols.ZonedDateTimeType", "org.neo4j.cypher.internal.ast.CreateRelationshipPropertyExistenceConstraint", "org.neo4j.cypher.internal.expressions.Divide", "org.neo4j.cypher.internal.label_expressions.LabelExpression$ColonDisjunction",
    "org.neo4j.cypher.internal.ast.ShowSettingsClause", "org.neo4j.cypher.internal.ast.ShowPrivileges", "org.neo4j.cypher.internal.ast.SetPropertyItem", "org.neo4j.cypher.internal.ast.AscSortItem", "org.neo4j.cypher.internal.expressions.SignedOctalIntegerLiteral$$anon$3", "org.neo4j.cypher.internal.expressions.PropertySelector", "org.neo4j.cypher.internal.expressions.DecimalDoubleLiteral$$anon$5", "org.neo4j.cypher.internal.expressions.PathPatternPart", "org.neo4j.cypher.internal.expressions.Equals", "org.neo4j.cypher.internal.ast.ShowConstraintsClause",
    "org.neo4j.cypher.internal.expressions.PatternPart$AnyShortestPath", "org.neo4j.cypher.internal.expressions.Infinity$$anon$8", "org.neo4j.cypher.internal.expressions.False", "org.neo4j.cypher.internal.ast.CreateNodePropertyTypeConstraint", "org.neo4j.cypher.internal.expressions.UnarySubtract", "org.neo4j.cypher.internal.util.symbols.IntegerType", "org.neo4j.cypher.internal.ast.ShowProceduresClause", "org.neo4j.cypher.internal.ast.CreateCompositeDatabase", "org.neo4j.cypher.internal.expressions.PatternPart$ShortestGroups",
    "org.neo4j.cypher.internal.expressions.UnaryAdd", "org.neo4j.cypher.internal.ast.DropConstraintOnName", "org.neo4j.cypher.internal.ast.SetLabelItem", "org.neo4j.cypher.internal.expressions.SensitiveStringLiteral", "org.neo4j.cypher.internal.ast.StopDatabase", "org.neo4j.cypher.internal.expressions.Or", "org.neo4j.cypher.internal.expressions.Add", "org.neo4j.cypher.internal.util.symbols.NodeType", "org.neo4j.cypher.internal.ast.ShowTransactionsClause", "org.neo4j.cypher.internal.expressions.Ands", "org.neo4j.cypher.internal.ast.CreateBtreeNodeIndex",
    "org.neo4j.cypher.internal.util.symbols.GeometryType", "org.neo4j.cypher.internal.ast.UnionAll", "org.neo4j.cypher.internal.ast.ShowDatabase", "org.neo4j.cypher.internal.expressions.Null", "org.neo4j.cypher.internal.ast.Yield", "org.neo4j.cypher.internal.ast.UseGraph", "org.neo4j.cypher.internal.ast.SetOwnPassword", "org.neo4j.cypher.internal.expressions.EndsWith", "org.neo4j.cypher.internal.expressions.ContainerIndex", "org.neo4j.cypher.internal.expressions.Contains", "org.neo4j.cypher.internal.expressions.IntervalQuantifier",
    "org.neo4j.cypher.internal.ast.CreateFulltextNodeIndex", "org.neo4j.cypher.internal.ast.With", "org.neo4j.cypher.internal.expressions.MapExpression", "org.neo4j.cypher.internal.expressions.UnsignedDecimalIntegerLiteral$$anon$2", "org.neo4j.cypher.internal.ast.UsingIndexHint", "org.neo4j.cypher.internal.ast.IsNotTyped", "org.neo4j.cypher.internal.expressions.PatternPart$AllPaths", "org.neo4j.cypher.internal.expressions.StartsWith", "org.neo4j.cypher.internal.expressions.FunctionName", "org.neo4j.cypher.internal.util.symbols.ClosedDynamicUnionType",
    "org.neo4j.cypher.internal.ast.ReallocateDatabases", "org.neo4j.cypher.internal.expressions.LessThanOrEqual", "org.neo4j.cypher.internal.ast.Skip", "org.neo4j.cypher.internal.expressions.RelationshipPattern", "org.neo4j.cypher.internal.expressions.Infinity", "org.neo4j.cypher.internal.ast.RenameServer", "org.neo4j.cypher.internal.util.symbols.PropertyValueType", "org.neo4j.cypher.internal.ast.DropRelationshipPropertyExistenceConstraint", "org.neo4j.cypher.internal.expressions.SignedHexIntegerLiteral$$anon$4",
    "org.neo4j.cypher.internal.ast.RevokePrivilege", "org.neo4j.cypher.internal.expressions.ProcedureOutput", "org.neo4j.cypher.internal.ast.ParameterName", "org.neo4j.cypher.internal.expressions.NamedPatternPart", "org.neo4j.cypher.internal.expressions.Subtract", "org.neo4j.cypher.internal.util.symbols.NumberType", "org.neo4j.cypher.internal.ast.AlterRemoteDatabaseAlias", "org.neo4j.cypher.internal.label_expressions.LabelExpression$Wildcard", "org.neo4j.cypher.internal.ast.CreateBtreeRelationshipIndex", "org.neo4j.cypher.internal.util.symbols.LocalTimeType",
    "org.neo4j.cypher.internal.label_expressions.LabelExpression$ColonConjunction", "org.neo4j.cypher.internal.ast.EnableServer", "org.neo4j.cypher.internal.ast.LoadCSV", "org.neo4j.cypher.internal.ast.SetExactPropertiesFromMapItem", "org.neo4j.cypher.internal.ast.SetClause", "org.neo4j.cypher.internal.expressions.Null$$anon$7", "org.neo4j.cypher.internal.expressions.InvalidNotEquals", "org.neo4j.cypher.internal.util.symbols.ListType", "org.neo4j.cypher.internal.ast.CreateRole", "org.neo4j.cypher.internal.expressions.RelationshipsPattern",
    "org.neo4j.cypher.internal.ast.CreateDatabase", "org.neo4j.cypher.internal.expressions.Variable", "org.neo4j.cypher.internal.ast.DropRole", "org.neo4j.cypher.internal.ast.OrderBy", "org.neo4j.cypher.internal.util.symbols.NullType", "org.neo4j.cypher.internal.ast.ShowPrivilegeCommands", "org.neo4j.cypher.internal.ast.CreateRelationshipKeyConstraint", "org.neo4j.cypher.internal.expressions.GreaterThanOrEqual", "org.neo4j.cypher.internal.ast.RenameUser", "org.neo4j.cypher.internal.expressions.ExplicitParameter",
    "org.neo4j.cypher.internal.expressions.ShortestPathsPatternPart", "org.neo4j.cypher.internal.expressions.DecimalDoubleLiteral", "org.neo4j.cypher.internal.ast.DeallocateServers", "org.neo4j.cypher.internal.expressions.SingleIterablePredicate", "org.neo4j.cypher.internal.ast.CreateRemoteDatabaseAlias", "org.neo4j.cypher.internal.ast.SubqueryCall", "org.neo4j.cypher.internal.ast.ShowServers", "org.neo4j.cypher.internal.ast.AlterUser", "org.neo4j.cypher.internal.expressions.PatternComprehension", "org.neo4j.cypher.internal.ast.DropIndexOnName",
    "org.neo4j.cypher.internal.expressions.PatternPartWithSelector", "org.neo4j.cypher.internal.expressions.ProcedureName", "org.neo4j.cypher.internal.expressions.AllPropertiesSelector", "org.neo4j.cypher.internal.ast.DenyPrivilege", "org.neo4j.cypher.internal.expressions.QuantifiedPath", "org.neo4j.cypher.internal.ast.Create", "org.neo4j.cypher.internal.ast.CreateLocalDatabaseAlias", "org.neo4j.cypher.internal.ast.Limit", "org.neo4j.cypher.internal.expressions.VariableSelector", "org.neo4j.cypher.internal.ast.DropNodeKeyConstraint",
    "org.neo4j.cypher.internal.expressions.VariableGrouping", "org.neo4j.cypher.internal.expressions.ListSlice", "org.neo4j.cypher.internal.expressions.ShortestPathExpression", "org.neo4j.cypher.internal.ast.GraphRefParameter", "org.neo4j.cypher.internal.ast.CreateRelationshipPropertyTypeConstraint", "org.neo4j.cypher.internal.expressions.ReduceExpression", "org.neo4j.cypher.internal.expressions.GreaterThan", "org.neo4j.cypher.internal.util.symbols.MapType", "org.neo4j.cypher.internal.ast.TerminateTransactionsClause",
    "org.neo4j.cypher.internal.expressions.RegexMatch", "org.neo4j.cypher.internal.ast.RevokeRolesFromUsers", "org.neo4j.cypher.internal.ast.CreateRangeNodeIndex", "org.neo4j.cypher.internal.ast.CreateNodePropertyExistenceConstraint", "org.neo4j.cypher.internal.ast.DropIndex", "org.neo4j.cypher.internal.ast.ReturnItems", "org.neo4j.cypher.internal.ast.CreateTextRelationshipIndex", "org.neo4j.cypher.internal.util.symbols.FloatType", "org.neo4j.cypher.internal.ast.ViewRef", "org.neo4j.cypher.internal.util.symbols.PointType",
    "org.neo4j.cypher.internal.ast.ShowUsers", "org.neo4j.cypher.internal.ast.DescSortItem", "org.neo4j.cypher.internal.expressions.PatternPart$AllShortestPaths", "org.neo4j.cypher.internal.expressions.SignedDecimalIntegerLiteral$$anon$1", "org.neo4j.cypher.internal.ast.RenameRole", "org.neo4j.cypher.internal.util.symbols.DateType", "org.neo4j.cypher.internal.ast.CreateRangeRelationshipIndex", "org.neo4j.cypher.internal.expressions.Namespace", "org.neo4j.cypher.internal.expressions.StringLiteral$$anon$6", "org.neo4j.cypher.internal.expressions.RelationshipChain",
    "org.neo4j.cypher.internal.expressions.Pattern$ForUpdate", "org.neo4j.cypher.internal.util.symbols.AnyType", "org.neo4j.cypher.internal.ast.DropNodePropertyExistenceConstraint", "org.neo4j.cypher.internal.expressions.FilterScope", "org.neo4j.cypher.internal.ast.CreateUser", "org.neo4j.cypher.internal.ast.CreateTextNodeIndex", "org.neo4j.cypher.internal.ast.UnresolvedCall", "org.neo4j.cypher.internal.expressions.AllIterablePredicate", "org.neo4j.cypher.internal.ast.Match", "org.neo4j.cypher.internal.expressions.SignedHexIntegerLiteral",
    "org.neo4j.cypher.internal.expressions.CaseExpression", "org.neo4j.cypher.internal.ast.ExistsExpression", "org.neo4j.cypher.internal.ast.DropDatabase", "org.neo4j.cypher.internal.ast.AlterLocalDatabaseAlias", "org.neo4j.cypher.internal.ast.UnaliasedReturnItem", "org.neo4j.cypher.internal.ast.GrantPrivilege", "org.neo4j.cypher.internal.expressions.LabelOrRelTypeName", "org.neo4j.cypher.internal.expressions.SignedOctalIntegerLiteral", "org.neo4j.cypher.internal.ast.CreateIndexOldSyntax", "org.neo4j.cypher.internal.expressions.PatternExpression",
    "org.neo4j.cypher.internal.expressions.NodePattern", "org.neo4j.cypher.internal.expressions.FixedQuantifier", "org.neo4j.cypher.internal.ast.CommandResultItem", "org.neo4j.cypher.internal.expressions.Modulo", "org.neo4j.cypher.internal.ast.ShowAliases", "org.neo4j.cypher.internal.ast.GrantRolesToUsers", "org.neo4j.cypher.internal.expressions.NoneIterablePredicate", "org.neo4j.cypher.internal.ast.ProcedureResultItem", "org.neo4j.cypher.internal.ast.Merge", "org.neo4j.cypher.internal.expressions.NotEquals", "org.neo4j.cypher.internal.label_expressions.LabelExpression$Disjunctions",
    "org.neo4j.cypher.internal.expressions.IsNull", "org.neo4j.cypher.internal.expressions.True$$anon$10", "org.neo4j.cypher.internal.ast.UnionDistinct", "org.neo4j.cypher.internal.ast.factory.neo4j.Neo4jASTFactory$$anon$3", "org.neo4j.cypher.internal.expressions.ListComprehension", "org.neo4j.cypher.internal.ast.Foreach", "org.neo4j.cypher.internal.expressions.ExtractScope", "org.neo4j.cypher.internal.label_expressions.LabelExpression$Negation", "org.neo4j.cypher.internal.expressions.NaN", "org.neo4j.cypher.internal.expressions.ListLiteral",
    "org.neo4j.cypher.internal.ast.CreatePointRelationshipIndex", "org.neo4j.cypher.internal.expressions.StringLiteral", "org.neo4j.cypher.internal.ast.RemovePropertyItem", "org.neo4j.cypher.internal.expressions.Range", "org.neo4j.cypher.internal.expressions.Property", "org.neo4j.cypher.internal.expressions.LiteralEntry", "org.neo4j.cypher.internal.expressions.False$$anon$11", "org.neo4j.cypher.internal.ast.OnMatch", "org.neo4j.cypher.internal.expressions.PathConcatenation", "org.neo4j.cypher.internal.ast.DropServer",
    "org.neo4j.cypher.internal.expressions.Not", "org.neo4j.cypher.internal.util.symbols.StringType", "org.neo4j.cypher.internal.ast.UsingScanHint", "org.neo4j.cypher.internal.ast.RemoveLabelItem", "org.neo4j.cypher.internal.expressions.MatchMode$RepeatableElements", "org.neo4j.cypher.internal.ast.CollectExpression", "org.neo4j.cypher.internal.expressions.LessThan", "org.neo4j.cypher.internal.util.symbols.BooleanType", "org.neo4j.cypher.internal.ast.Delete", "org.neo4j.cypher.internal.expressions.RelTypeName", "org.neo4j.cypher.internal.util.symbols.ZonedTimeType",
    "org.neo4j.cypher.internal.util.symbols.NothingType", "org.neo4j.cypher.internal.expressions.LabelName", "org.neo4j.cypher.internal.ast.Remove", "org.neo4j.cypher.internal.expressions.Multiply", "org.neo4j.cypher.internal.ast.GraphRef", "org.neo4j.cypher.internal.ast.UsingJoinHint", "org.neo4j.cypher.internal.expressions.FunctionInvocation", "org.neo4j.cypher.internal.ast.SubqueryCall$InTransactionsErrorParameters", "org.neo4j.cypher.internal.ast.ShowCurrentUser", "org.neo4j.cypher.internal.ast.SingleQuery",
    "org.neo4j.cypher.internal.expressions.SignedDecimalIntegerLiteral", "org.neo4j.cypher.internal.ast.CreatePointNodeIndex", "org.neo4j.cypher.internal.expressions.Xor", "org.neo4j.cypher.internal.expressions.IsNotNull", "org.neo4j.cypher.internal.ast.SubqueryCall$InTransactionsReportParameters", "org.neo4j.cypher.internal.expressions.PropertyKeyName", "org.neo4j.cypher.internal.expressions.ParenthesizedPath", "org.neo4j.cypher.internal.ast.CreateFulltextRelationshipIndex", "org.neo4j.cypher.internal.util.symbols.PathType",
    "org.neo4j.cypher.internal.ast.CountExpression", "org.neo4j.cypher.internal.ast.StartDatabase", "org.neo4j.cypher.internal.ast.ProcedureResult", "org.neo4j.cypher.internal.expressions.Pow", "org.neo4j.cypher.internal.ast.ShowIndexesClause", "org.neo4j.cypher.internal.util.symbols.GraphRefType", "org.neo4j.cypher.internal.ast.Unwind", "org.neo4j.cypher.internal.ast.SetIncludingPropertiesFromMapItem", "org.neo4j.cypher.internal.ast.DropUser", "org.neo4j.cypher.internal.expressions.ReduceScope", "org.neo4j.cypher.internal.ast.SubqueryCall$InTransactionsBatchParameters",
    "org.neo4j.cypher.internal.label_expressions.LabelExpression$Conjunctions", "org.neo4j.cypher.internal.ast.AlterServer", "org.neo4j.cypher.internal.ast.NamespacedName", "org.neo4j.cypher.internal.ast.OnCreate", "org.neo4j.cypher.internal.ast.DropDatabaseAlias", "org.neo4j.cypher.internal.util.symbols.RelationshipType", "org.neo4j.cypher.internal.ast.CreateLookupIndex", "org.neo4j.cypher.internal.ast.ShowSupportedPrivilegeCommand", "org.neo4j.cypher.internal.expressions.PatternPart$AnyPath", "org.neo4j.cypher.internal.expressions.CountStar",
    "org.neo4j.cypher.internal.expressions.MapProjection", "org.neo4j.cypher.internal.expressions.MatchMode$DifferentRelationships", "org.neo4j.cypher.internal.ast.Where", "org.neo4j.cypher.internal.ast.DropPropertyUniquenessConstraint", "org.neo4j.cypher.internal.ast.Return", "org.neo4j.cypher.internal.ast.CreateNodeKeyConstraint", "org.neo4j.cypher.internal.label_expressions.LabelExpression$Leaf", "org.neo4j.cypher.internal.ast.ShowFunctionsClause", "org.neo4j.cypher.internal.ast.ShowRoles", "org.neo4j.cypher.internal.label_expressions.LabelExpressionPredicate",
    "org.neo4j.cypher.internal.expressions.True", "org.neo4j.cypher.internal.expressions.AnyIterablePredicate", "org.neo4j.cypher.internal.ast.AliasedReturnItem", "org.neo4j.cypher.internal.expressions.StarQuantifier", "org.neo4j.cypher.internal.ast.SubqueryCall$InTransactionsParameters", "org.neo4j.cypher.internal.expressions.Pattern$ForMatch", "org.neo4j.cypher.internal.ast.CreateNodePropertyUniquenessConstraint", "org.neo4j.cypher.internal.ast.IsTyped", "org.neo4j.cypher.internal.expressions.And", "Top", "\\.",
    "exists", "last of empty array", "size", "ReturnItems", "There can be only one INPUT DATA STREAM in a query", "INPUT DATA STREAM must be the first clause in a query", "Cannot use standalone call with WHERE (instead use: `CALL ... WITH * WHERE ... RETURN *`)", "SingleQuery", "Importing WITH should consist only of simple references to outside variables. ", " cannot follow OPTIONAL ", " (perhaps use a WITH clause between them)", " can only be used at the end of the query", "WITH is required between ", "When combining `",
    "` with other show and/or terminate commands, `YIELD *` isn\'t permitted.", "` with other show and/or terminate commands, `YIELD` is mandatory.", "When combining show and/or terminate commands, `RETURN` isn\'t optional.", "Query must conclude with ", "a RETURN clause, an update clause, a unit subquery call, or a procedure call with no YIELD", "Query cannot conclude with ", "CALL", " together with YIELD", " (must be ", "Invalid combination of UNION and UNION ALL", "INPUT DATA STREAM is not supported in UNION queries",
    "UnionAll", "UnionDistinct", "Where", "And", "Or", "FunctionInvocation", "FunctionName", "Property", "PropertyKeyName", "Attempt to instantiate Ref(null)", " is out of bounds (min 0, max 5)", "Tuple6", "ShortestPathsPatternPart", "allShortestPaths", "shortestPath", "RelationshipChain", "NodePattern", "-?\\d+((_\\d+)?)*", "UnsignedDecimalIntegerLiteral", "Range", "Namespace", "DeclarationsAndDependencies", "RelationshipPattern", "Semantic table", "Ref@", "PositionedNode(", "With", "CALL { RETURN ... }", "Return",
    "BTREE", "RANGE", "FULLTEXT", "LOOKUP", "TEXT", "POINT", "INVALID", "CONSTRAINT_VERSION_0", "CONSTRAINT_VERSION_1", "CONSTRAINT_VERSION_2", "NODE_UNIQUE", "IS NODE UNIQUE", "REL_UNIQUE", "IS RELATIONSHIP UNIQUE", "NODE_KEY", "IS NODE KEY", "REL_KEY", "IS RELATIONSHIP KEY", "NODE_EXISTS", "EXISTS", "NODE_IS_NOT_NULL", "IS NOT NULL", "REL_EXISTS", "REL_IS_NOT_NULL", "NODE_IS_TYPED", "IS TYPED", "REL_IS_TYPED", "USE GRAPH", "UseGraph", "UNIQUE", "UNIQUE[NESS]", "NODE UNIQUE[NESS]", "RELATIONSHIP_UNIQUE", "REL[ATIONSHIP] UNIQUE[NESS]",
    "KEY", "NODE KEY", "RELATIONSHIP_KEY", "REL[ATIONSHIP] KEY", "OLD_EXISTS", "OLD_EXIST", "EXIST", "[PROPERTY] EXIST[ENCE]", "NODE_OLD_EXISTS", "NODE EXISTS", "NODE_OLD_EXIST", "NODE EXIST", "NODE_EXIST", "NODE [PROPERTY] EXIST[ENCE]", "RELATIONSHIP_OLD_EXISTS", "RELATIONSHIP EXISTS", "RELATIONSHIP_OLD_EXIST", "RELATIONSHIP EXIST", "RELATIONSHIP_EXIST", "REL[ATIONSHIP] [PROPERTY] EXIST[ENCE]", "PROP_TYPE", "PROPERTY TYPE", "NODE_PROP_TYPE", "NODE PROPERTY TYPE", "RELATIONSHIP_PROP_TYPE", "REL[ATIONSHIP] PROPERTY TYPE",
    "BUILT_IN", "BUILT IN", "USER_DEFINED", "USER DEFINED", "SymbolUse(", "SymbolUse", "\'.\' is not a valid character in the remote alias name \'%s\'. Remote alias names using \'.\' must be quoted with backticks e.g. `remote.alias`.", "AddedInRewrite", "UnresolvedCall", "Cannot use `YIELD *` outside standalone call", "CALL { ... } IN TRANSACTIONS after a write clause is not supported", "Acc", "DefaultOrAllShowColumns", "en", "CA", "fr", "zh", "CN", "FR", "de", "DE", "it", "IT", "ja", "JP", "ko", "KR", "TW", "GB",
    "US", "ANY", "STRING", "MAP", "Variable", "Closed Dynamic Union Types can not be appended with `NOT NULL`, specify `NOT NULL` on all inner types instead.", "Unexpected type: %s", "NOTHING", "NULL", "BOOLEAN", "BOOLEAN NOT NULL", "STRING NOT NULL", "INTEGER", "INTEGER NOT NULL", "FLOAT", "FLOAT NOT NULL", "DATE", "DATE NOT NULL", "LOCAL TIME", "LOCAL TIME NOT NULL", "ZONED TIME", "ZONED TIME NOT NULL", "LOCAL DATETIME", "LOCAL DATETIME NOT NULL", "ZONED DATETIME", "ZONED DATETIME NOT NULL", "DURATION", "DURATION NOT NULL",
    "POINT NOT NULL", "NODE NOT NULL", "RELATIONSHIP", "RELATIONSHIP NOT NULL", "MAP NOT NULL", "PATH", "PATH NOT NULL", "ANY NOT NULL", "PROPERTY VALUE", "PROPERTY VALUE NOT NULL", "OnCreate", "OnMatch", "In", "ListLiteral", "False", "Leaf", "no value set for Either", "ProcedureResult", " -> ", "SubqueryCall", "SemanticError", "Deprecation", "DefaultWith", "CREATE ALIAS", "CREATE OR REPLACE ALIAS", "Failed to create the specified alias \'", "\': cannot have both `OR REPLACE` and `IF NOT EXISTS`.", "CreateRemoteDatabaseAlias",
    "\'.\' is not a valid character in the local alias name \'", "\'. Local alias names using \'.\' must be quoted with backticks when adding a local alias to a composite database e.g. `local.alias`.", "CreateLocalDatabaseAlias", "NoWait", " WAIT", "IndefiniteWait", "TimeoutAfter", "CREATE COMPOSITE DATABASE", "CREATE OR REPLACE COMPOSITE DATABASE", "Failed to create the specified composite database \'", "\': COMPOSITE DATABASE names cannot contain \".\". COMPOSITE DATABASE names using \'.\' must be quoted with backticks e.g. `composite.database`.",
    "CreateCompositeDatabase", "ConstraintVersion0", "Failed to create ", ": Invalid option provided, valid options are `indexProvider` and `indexConfig`.", "Invalid constraint syntax, ON should not be used in combination with REQUIRE. Replace ON with FOR.", "Invalid constraint syntax, FOR should not be used in combination with ASSERT. Replace ASSERT with REQUIRE.", "Invalid constraint syntax, FOR should not be used in combination with ASSERT EXISTS. Replace ASSERT EXISTS with REQUIRE ... IS NOT NULL.", "Invalid constraint syntax, ON and ASSERT should not be used. Replace ON with FOR and ASSERT with REQUIRE.",
    "Invalid constraint syntax, ON and ASSERT EXISTS should not be used. Replace ON with FOR and ASSERT EXISTS with REQUIRE ... IS NOT NULL.", " constraint: `OR REPLACE` cannot be used together with this command.", " constraint", " property existence constraint: `OR REPLACE` cannot be used together with this command.", " property existence constraint", " property type constraint: Invalid property type `", "`.", " Lists cannot have lists as an inner type.", " Lists cannot have a union of types as an inner type.",
    " Lists cannot have nullable inner types.", "uniqueness", "CreateNodePropertyUniquenessConstraint", "LabelName", "relationship uniqueness", "CreateRelationshipPropertyUniquenessConstraint", "RelTypeName", "node key", "CreateNodeKeyConstraint", "relationship key", "CreateRelationshipKeyConstraint", "node", "CreateNodePropertyExistenceConstraint", "relationship", "CreateRelationshipPropertyExistenceConstraint", "node property type", "CreateNodePropertyTypeConstraint", "relationship property type", "CreateRelationshipPropertyTypeConstraint",
    "ConstraintVersion1", "ConstraintVersion2", "CREATE DATABASE", "CREATE OR REPLACE DATABASE", "Failed to create the specified database \'", "CreateDatabase", "Topology", "CREATE ROLE", "CREATE OR REPLACE ROLE", "Failed to create the specified role \'", "CreateRole", "SetHomeDatabaseAction", "UserOptions", "CREATE USER", "CREATE OR REPLACE USER", "Failed to create the specified user \'", "CreateUser", "READ_ONLY", "READ_WRITE", "DATABASE_ALL", "DATABASE_START", "DATABASE_STOP", "ACCESS", "CREATE_TOKEN", "CREATE_PROPERTYKEY",
    "CREATE_LABEL", "CREATE_RELTYPE", "INDEX_ALL", "INDEX_CREATE", "INDEX_DROP", "INDEX_SHOW", "CONSTRAINT_ALL", "CONSTRAINT_CREATE", "CONSTRAINT_DROP", "CONSTRAINT_SHOW", "TRANSACTION_ALL", "TRANSACTION_SHOW", "TRANSACTION_TERMINATE", "DBMS_ALL", "USER_ALL", "USER_SHOW", "USER_CREATE", "USER_RENAME", "USER_ALTER", "USER_STATUS", "USER_PASSWORD", "USER_HOME", "USER_DROP", "USER_IMPERSONATE", "ROLE_ALL", "ROLE_SHOW", "ROLE_CREATE", "ROLE_RENAME", "ROLE_DROP", "ROLE_ASSIGN", "ROLE_REMOVE", "DATABASE_MANAGEMENT", "DATABASE_CREATE",
    "DATABASE_DROP", "DATABASE_COMPOSITE_MANAGEMENT", "DATABASE_COMPOSITE_CREATE", "DATABASE_COMPOSITE_DROP", "DATABASE_ALTER", "SET_DATABASE_ACCESS", "ALIAS_MANAGEMENT", "ALIAS_CREATE", "ALIAS_DROP", "ALIAS_ALTER", "ALIAS_SHOW", "PRIVILEGE_ALL", "PRIVILEGE_SHOW", "PRIVILEGE_ASSIGN", "PRIVILEGE_REMOVE", "EXECUTE_FUNCTION", "EXECUTE_BOOSTED_FUNCTION", "EXECUTE_PROCEDURE", "EXECUTE_BOOSTED_PROCEDURE", "EXECUTE_ADMIN_PROCEDURE", "SERVER_SHOW", "SERVER_MANAGEMENT", "SETTING_SHOW", "GRAPH_ALL", "GRAPH_WRITE", "GRAPH_CREATE",
    "GRAPH_MERGE", "GRAPH_DELETE", "GRAPH_LABEL_SET", "GRAPH_LABEL_REMOVE", "GRAPH_PROPERTY_SET", "GRAPH_MATCH", "GRAPH_READ", "GRAPH_TRAVERSE", "REPORT STATUS can only be used when specifying ON ERROR CONTINUE or ON ERROR BREAK", "InTransactionsParameters", "Can\'t convert code point ", " to char", "Currency not found: ", "0x", "+ ", "0-", "Missing format with for specifier ", "--#+ 0,(<", "Illegal format flags ", " for conversion ", "Duplicate format flags: ", "IfExistsInvalidSyntax", "IfExistsReplace", "IfExistsDoNothing",
    "IfExistsThrowError", "OptionsMap", "OptionsParam", "NoOptions", " NOT NULL", "NOTHING type is not supported for use in this context", "NothingType", "NULL type is not supported for use in this context", "NullType", "BooleanType", "StringType", "String", "IntegerType", "Integer", "FloatType", "DateType", "Date", "LocalTimeType", "LocalTime", "ZonedTimeType", "Time", "LocalDateTimeType", "LocalDateTime", "ZonedDateTimeType", "DateTime", "DurationType", "Duration", "PointType", "Point", "NodeType", "Node", "RelationshipType",
    "Relationship", "MapType", "LIST<%s>%s", "ListType", "List<", "LIST<", "PathType", "Path", "PropertyValueType", "Property Value", "AnyType", "ClosedDynamicUnionType", "ExpressionTypeSignature", "input", "NumberType", "Number", "NUMBER", "GeometryType", "Geometry", "GEOMETRY", "GraphRef is not a supported CypherType and therefore, cannot be ordered", "GraphRefType", "GraphRef", "GRAPHREF", "CALL { ... } IN TRANSACTIONS in a UNION is not supported", "OrderBy", "ExplicitParameter", "SensitiveStringLiteral", "US-ASCII",
    "ISO-8859-1", "UTF-16", "UTF-16BE", "UTF-16LE", "Failed to create index: `OR REPLACE` cannot be used together with this command.", "range node property index", "CreateRangeNodeIndex", "range relationship property index", "CreateRangeRelationshipIndex", "Invalid index type b-tree, use range, point or text index instead.", "CreateBtreeNodeIndex", "CreateBtreeRelationshipIndex", "text node index", "text indexes", "CreateTextNodeIndex", "text relationship index", "CreateTextRelationshipIndex", "point node index",
    "point indexes", "CreatePointNodeIndex", "point relationship index", "CreatePointRelationshipIndex", "fulltext relationship index", "CreateFulltextRelationshipIndex", "fulltext node index", "CreateFulltextNodeIndex", "labels", "Failed to create relationship lookup index: Function \'", "\' is not allowed, valid function is \'", "\'.", "Failed to create node lookup index: Function \'", "token lookup index", "CreateLookupIndex", "Invalid create index syntax, use `CREATE INDEX FOR ...` instead.", "CreateIndexOldSyntax",
    "NAMED", "AllQualifier", " IMMUTABLE", "NaN is not supported for property-based access control.", " = NULL always evaluates to NULL. Use IS NULL instead.", " <> NULL always evaluates to NULL. Use IS NOT NULL instead.", "Property rules can only contain one property.", ":NULL} always evaluates to NULL. Use WHERE syntax in combination with IS NULL instead.", "Only single literal-based predicate expressions are allowed for property-based access control. Expression: ", " is not supported.", "`GRANT`, `DENY` and `REVOKE` are not supported for `",
    "`ON DEFAULT GRAPH` is not supported. Use `ON HOME GRAPH` instead.", "`ON DEFAULT DATABASE` is not supported. Use `ON HOME DATABASE` instead.", "LOAD privileges with a CIDR range are not currently supported", "LOAD privileges with a URL pattern are not currently supported", "`DENY MERGE` is not supported. Use `DENY SET PROPERTY` and `DENY CREATE` instead.", "DenyPrivilege", "ENABLE SERVER", "EnableServer", "START DATABASE", "StartDatabase", "STOP DATABASE", "StopDatabase", "composite", "database", "location",
    "url", "driver", "allIndexes", "AllIndexes", "state", "populationPercent", "indexProvider", "owningConstraint", "lastRead", "readCount", "trackedSince", "failureMessage", "btreeIndexes", "BtreeIndexes", "rangeIndexes", "RangeIndexes", "fulltextIndexes", "FulltextIndexes", "textIndexes", "TextIndexes", "pointIndexes", "PointIndexes", "lookupIndexes", "LookupIndexes", "allFunctions", "AllFunctions", "User", "category", "signature", "isBuiltIn", "argumentDescription", "returnDescription", "aggregating", "rolesExecution",
    "rolesBoostedExecution", "CurrentUser", "builtInFunctions", "BuiltInFunctions", "userDefinedFunctions", "UserDefinedFunctions", "allConstraints", "AllConstraints", "UNIQUENESS", "uniquenessConstraints", "UniqueConstraints", "NODE UNIQUENESS", "nodeUniquenessConstraints", "NodeUniqueConstraints", "RELATIONSHIP_UNIQUENESS", "RELATIONSHIP UNIQUENESS", "relationshipUniquenessConstraints", "RelUniqueConstraints", "keyConstraints", "KeyConstraints", "nodeKeyConstraints", "NodeKeyConstraints", "RELATIONSHIP KEY", "relationshipKeyConstraints",
    "RelKeyConstraints", "ExistsConstraints", "PROPERTY_EXISTENCE", "PROPERTY EXISTENCE", "existenceConstraints", "ValidSyntax", "RemovedSyntax", "NodeExistsConstraints", "NODE_PROPERTY_EXISTENCE", "NODE PROPERTY EXISTENCE", "nodeExistenceConstraints", "RelExistsConstraints", "RELATIONSHIP_PROPERTY_EXISTENCE", "RELATIONSHIP PROPERTY EXISTENCE", "relationshipExistenceConstraints", "propertyTypeConstraints", "PropTypeConstraints", "NODE_PROPERTY_TYPE", "nodePropertyTypeConstraints", "NodePropTypeConstraints", "RELATIONSHIP_PROPERTY_TYPE",
    "RELATIONSHIP PROPERTY TYPE", "relationshipPropertyTypeConstraints", "RelPropTypeConstraints", "SingleNamedDatabaseScope", "DefaultDatabaseScope", "ShowDefaultDatabase", "AllDatabasesScope", "ShowDatabases", "HomeDatabaseScope", "ShowHomeDatabase", "aliases", "access", "databaseID", "serverID", "address", "writer", "currentStatus", "requestedStatus", "statusMessage", "default", "currentPrimariesCount", "currentSecondariesCount", "requestedPrimariesCount", "requestedSecondariesCount", "creationTime", "lastStartTime",
    "lastStopTime", "store", "lastCommittedTxn", "replicationLag", "constituents", "action", "resource", "graph", "segment", "immutable", "ShowAllPrivileges", "command", "mode", "worksOnSystem", "admin", "option", "serverId", "httpAddress", "httpsAddress", "health", "hosting", "requestedHosting", "tags", "allowedDatabases", "deniedDatabases", "modeConstraint", "version", "qualifier", "target", "scope", "currentQueryId", "outerTransactionId", "connectionId", "clientAddress", "metaData", "currentQuery", "parameters",
    "planner", "runtime", "startTime", "currentQueryStartTime", "protocol", "requestUri", "status", "currentQueryStatus", "statusDetails", "resourceInformation", "activeLockCount", "currentQueryActiveLockCount", "elapsedTime", "cpuTime", "waitTime", "idleTime", "currentQueryElapsedTime", "currentQueryCpuTime", "currentQueryWaitTime", "currentQueryIdleTime", "currentQueryAllocatedBytes", "allocatedDirectBytes", "estimatedUsedHeapMemory", "pageHits", "pageFaults", "currentQueryPageHits", "currentQueryPageFaults",
    "initializationStackTrace", "ParsedAsYield", "ShowRolesPrivileges", "CREATE", "Exactly one relationship type must be specified for ", ". Did you forget to prefix your relationship type with a \':\'?", "like `:", "` ", "plain ", "A single ", "relationship type ", "must be specified for ", "Create", "ForUpdate", "DELETE", "Delete", "MATCH", "Match", "relationship type", "label", "index", "join", " scan", "no ", " was", "only the ", " `", "` was", "`, `", "s `", "` were", "Predicates must include the ", " literal `",
    "`.\n            | That is, the function `", "()` is not compatible with indexes.", "none was", "only `", "property", "the ", "Supported predicates are:\n          | equality comparison, inequality (range) comparison, `STARTS WITH`,\n          | `IN` condition or checking property existence.\n          | The comparison cannot be performed between two property values.", "ForMatch", "PatternPartWithSelector", "Merge", "REMOVE", "Remove", "SET", "SetClause", "UNWIND", "Unwind", "ProcedureName", "OF ... ROWS", "InTransactionsBatchParameters",
    "InTransactionsErrorParameters", "InTransactionsReportParameters", "ON_ERROR_BREAK", "ON_ERROR_CONTINUE", "ON_ERROR_FAIL", "FOREACH", "Foreach", "CSV field terminator can only be one character wide", "LoadCSV", "Xor", "TreeContext", "ShowUserPrivileges", "ShowUsersPrivileges", "Unknown format conversion: ", "AliasedReturnItem", "All sub queries in an UNION must have the same return column names", "Illegal precision: ", "Can\'t format argument of ", " using ", " conversion", "This exception should not been thrown",
    "Positive number pattern not found in ", "Expected \';\' at ", " in ", "FlatMap", "size=%d and step=%d, but both must be positive", "Condition \'", "\' violated. ", "Illegal format flags: ", "ShowColumn", "SHOW INDEXES", "Invalid index type b-tree, please omit the `BTREE` filter.", "`SHOW INDEXES` no longer allows the `BRIEF` and `VERBOSE` keywords,\n          |please omit `BRIEF` and use `YIELD *` instead of `VERBOSE`.", "ShowIndexesClause", "SHOW FUNCTIONS", "ShowFunctionsClause", "SHOW CONSTRAINTS", "`SHOW CONSTRAINTS` no longer allows the `BRIEF` and `VERBOSE` keywords,\n          |please omit `BRIEF` and use `YIELD *` instead of `VERBOSE`.",
    "ShowConstraintsClause", "`SHOW CONSTRAINTS` no longer allows the `EXISTS` keyword, please use `EXIST` or `PROPERTY EXISTENCE` instead.", "ShowProceduresClause", "ShowSettingsClause", "TransactionColumn", "ShowTransactionsClause", "TerminateTransactionsClause", "DIFFERENT RELATIONSHIPS", "DifferentRelationships", "UnknownSize", "ParameterName", "ALTER ALIAS", "AlterLocalDatabaseAlias", "Failed to alter the specified database alias \'", "\': url needs to be defined to alter a remote alias target.", "AlterRemoteDatabaseAlias",
    "ALTER CURRENT USER SET PASSWORD", "SetOwnPassword", "ALTER DATABASE", "AlterDatabase", "ALTER SERVER", "AlterServer", "RemoveHomeDatabaseAction", "ALTER USER", "AlterUser", "DEALLOCATE DATABASES FROM SERVER", "DeallocateServers", "REALLOCATE DATABASES", "ReallocateDatabases", "AllDatabasesQualifier", "UserAllQualifier", "ALL DATABASE PRIVILEGES", "AllDatabaseAction", "AccessDatabaseAction", "START", "StartDatabaseAction", "STOP", "StopDatabaseAction", "INDEX MANAGEMENT", "AllIndexActions", "CREATE INDEX", "CreateIndexAction",
    "DROP INDEX", "DropIndexAction", "SHOW INDEX", "ShowIndexAction", "CONSTRAINT MANAGEMENT", "AllConstraintActions", "CREATE CONSTRAINT", "CreateConstraintAction", "DROP CONSTRAINT", "DropConstraintAction", "SHOW CONSTRAINT", "ShowConstraintAction", "NAME MANAGEMENT", "AllTokenActions", "CREATE NEW PROPERTY NAME", "CreatePropertyKeyAction", "CREATE NEW NODE LABEL", "CreateNodeLabelAction", "CREATE NEW RELATIONSHIP TYPE", "CreateRelationshipTypeAction", "TRANSACTION MANAGEMENT", "AllTransactionActions", "SHOW TRANSACTION",
    "ShowTransactionAction", "TERMINATE TRANSACTION", "TerminateTransactionAction", "ALL DBMS PRIVILEGES", "AllDbmsAction", "USER MANAGEMENT", "AllUserActions", "SHOW USER", "ShowUserAction", "AlterUserAction", "CreateUserAction", "DROP USER", "DropUserAction", "RENAME USER", "RenameUserAction", "SET PASSWORDS", "SetPasswordsAction", "SET USER STATUS", "SetUserStatusAction", "SET USER HOME DATABASE", "SetUserHomeDatabaseAction", "IMPERSONATE", "ImpersonateUserAction", "ROLE MANAGEMENT", "AllRoleActions", "SHOW ROLE",
    "ShowRoleAction", "CreateRoleAction", "DROP ROLE", "DropRoleAction", "RENAME ROLE", "RenameRoleAction", "ASSIGN ROLE", "AssignRoleAction", "REMOVE ROLE", "RemoveRoleAction", "DATABASE MANAGEMENT", "AllDatabaseManagementActions", "CreateDatabaseAction", "DROP DATABASE", "DropDatabaseAction", "COMPOSITE DATABASE MANAGEMENT", "CompositeDatabaseManagementActions", "CreateCompositeDatabaseAction", "DROP COMPOSITE DATABASE", "DropCompositeDatabaseAction", "AlterDatabaseAction", "SET DATABASE ACCESS", "SetDatabaseAccessAction",
    "ALIAS MANAGEMENT", "AllAliasManagementActions", "CreateAliasAction", "DROP ALIAS", "DropAliasAction", "AlterAliasAction", "ShowAliasAction", "PRIVILEGE MANAGEMENT", "AllPrivilegeActions", "ASSIGN PRIVILEGE", "AssignPrivilegeAction", "REMOVE PRIVILEGE", "RemovePrivilegeAction", "ShowPrivilegeAction", "EXECUTE USER DEFINED FUNCTION", "ExecuteFunctionAction", "EXECUTE BOOSTED USER DEFINED FUNCTION", "ExecuteBoostedFunctionAction", "EXECUTE PROCEDURE", "ExecuteProcedureAction", "EXECUTE BOOSTED PROCEDURE", "ExecuteBoostedProcedureAction",
    "EXECUTE ADMIN PROCEDURES", "ExecuteAdminProcedureAction", "ShowServerAction", "SERVER MANAGEMENT", "ServerManagementAction", "SHOW SETTING", "ShowSettingAction", "ALL GRAPH PRIVILEGES", "AllGraphPrivileges", "AllGraphAction", "Write", "WriteAction", "CreateElement", "CreateElementAction", "MergeAdminAction", "DeleteElement", "DeleteElementAction", "SetLabel", "SetLabelAction", "RemoveLabel", "RemoveLabelAction", "SET PROPERTY", "SetProperty", "SetPropertyAction", "MatchAction", "READ", "Read", "ReadAction",
    "TRAVERSE", "Traverse", "TraverseAction", "DbmsPrivilege", "DropDatabaseAlias", "DESTROY DATA", "DestroyData", "DUMP DATA", "DumpData", "DropDatabase", "Uniqueness constraints cannot be dropped by schema, please drop by name instead: DROP CONSTRAINT constraint_name. The constraint name can be found using SHOW CONSTRAINTS.", "DropPropertyUniquenessConstraint", "Node key constraints cannot be dropped by schema, please drop by name instead: DROP CONSTRAINT constraint_name. The constraint name can be found using SHOW CONSTRAINTS.",
    "DropNodeKeyConstraint", "Node property existence constraints cannot be dropped by schema, please drop by name instead: DROP CONSTRAINT constraint_name. The constraint name can be found using SHOW CONSTRAINTS.", "DropNodePropertyExistenceConstraint", "Relationship property existence constraints cannot be dropped by schema, please drop by name instead: DROP CONSTRAINT constraint_name. The constraint name can be found using SHOW CONSTRAINTS.", "DropRelationshipPropertyExistenceConstraint", "DropConstraintOnName",
    "Indexes cannot be dropped by schema, please drop by name instead: DROP INDEX index_name. The index name can be found using SHOW INDEXES.", "DropIndex", "DropIndexOnName", "DropRole", "DROP SERVER", "DropServer", "DropUser", "GrantPrivilege", "GRANT ROLE", "GrantRolesToUsers", "RenameRole", "RENAME SERVER", "RenameServer", "RenameUser", "REVOKE", "RevokePrivilege", "RevokeGrantType", "RevokeDenyType", "RevokeBothType", "REVOKE ROLE", "RevokeRolesFromUsers", "UsingScanHint", "LabelOrRelTypeName", "REPEATABLE ELEMENTS",
    "RepeatableElements", "NamedPatternPart", "RemovePropertyItem", "RemoveLabelItem", "SetPropertyItem", "SetExactPropertiesFromMapItem", "SetIncludingPropertiesFromMapItem", "SetLabelItem", "ProcedureOutput", "Prefix contains special character at ", "Quote opened at ", " was not closed in ", "Group separator found at fractional part at ", "Unexpected second decimal separator at ", "Unexpected \'0\' at optional digit part at ", "Unexpected char at exponent at ", "Pattern does not specify exponent digits at ", "Unexpected \'#\' at non-optional digit part at ",
    "Two group separators at ", "Pattern does not specify integer digits at ", "Group separator at the end of number at ", "StringLiteral", " is not available in this implementation of Cypher due to lack of support for ", "Returns the absolute value of an `INTEGER` or `FLOAT`.", "abs", "Abs", "Returns the arccosine of a `FLOAT` in radians.", "acos", "Acos", "Returns the arcsine of a `FLOAT` in radians.", "asin", "Asin", "Returns the arctangent of a `FLOAT` in radians.", "atan", "Atan", "y", "x", "Returns the arctangent2 of a set of coordinates in radians.",
    "atan2", "Atan2", "Returns the average of a set of `INTEGER`, `FLOAT` or `DURATION` values.", "avg", "Avg", "Returns the smallest `FLOAT` that is greater than or equal to a number and equal to an `INTEGER`.", "ceil", "Ceil", "Returns the number of Unicode characters in a `STRING`.", "char_length", "CharLength", "character_length", "CharacterLength", "Returns the first non-null value in a list of expressions.", "coalesce", "Coalesce", "Returns a list containing the values returned by an expression.", "collect",
    "Collect", "Returns the cosine of a `FLOAT`.", "cos", "Cos", "Returns the cotangent of a `FLOAT`.", "cot", "Cot", "Returns the number of values or rows.", "count", "Count", "Converts radians to degrees.", "degrees", "Degrees", "point.distance", "from", "to", "Returns a `FLOAT` representing the geodesic distance between any two points in the same CRS.", "Distance", "Returns the base of the natural logarithm, e.", "e", "E", "Returns the element id of a `NODE` or `RELATIONSHIP`.", "elementId", "ElementId", "Returns the end `NODE` of a `RELATIONSHIP`.",
    "endNode", "EndNode", "Returns true if a match for the pattern exists in the graph.", "Exists", "Returns e^n, where e is the base of the natural logarithm, and n is the value of the argument expression.", "exp", "Exp", "Returns the absolute path of the file that LOAD CSV is using.", "file", "File", "Returns the largest `FLOAT` that is less than or equal to a number and equal to an `INTEGER`.", "floor", "Floor", "Returns half the versine of a number.", "haversin", "Haversin", "head", "list", "Returns the first element in a `LIST<ANY>`.",
    "Head", "Returns the id of a `NODE` or `RELATIONSHIP`.", "Id", "isEmpty", "Checks whether a `STRING`, `MAP` or `LIST<ANY>` is empty.", "IsEmpty", "Returns whether the given `INTEGER` or `FLOAT` is NaN.", "isNaN", "IsNaN", "Returns a `LIST<STRING>` containing the `STRING` representations for all the labels of a `NODE`.", "Labels", "Returns the last element in a `LIST<ANY>`.", "last", "Last", "original", "length", "Returns a `STRING` containing the specified number (`INTEGER`) of leftmost characters in the given `STRING`.",
    "left", "Returns the length of a `PATH`.", "Length", "Returns the line number that LOAD CSV is currently using.", "linenumber", "Linenumber", "Returns the natural logarithm of a `FLOAT`.", "log", "Log", "Returns the common logarithm (base 10) of a `FLOAT`.", "log10", "Log10", "Returns the given `STRING` with leading whitespace removed.", "ltrim", "LTrim", "Returns the maximum value in a set of values.", "max", "Max", "Returns the minimum value in a set of values.", "min", "Min", "Returns a `LIST<NODE>` containing all the `NODE` values in a `PATH`.",
    "nodes", "Nodes", "Returns the mathematical constant pi.", "pi", "Pi", "percentile", "Returns the percentile of a value over a group using linear interpolation.", "percentileCont", "PercentileCont", "Returns the nearest `INTEGER` or `FLOAT` value to the given percentile over a group using a rounding method.", "percentileDisc", "PercentileDisc", "Returns a 2D or 3D point object, given two or respectively three coordinate values in the Cartesian coordinate system or WGS 84 geographic coordinate system.", "point",
    "Returns a `LIST<STRING>` containing the `STRING` representations for all the property names of a `NODE`, `RELATIONSHIP` or `MAP`.", "keys", "Keys", "Converts degrees to radians.", "radians", "Radians", "rand", "Returns a random `FLOAT` in the range from 0 (inclusive) to 1 (exclusive).", "Rand", "Generates a random UUID.", "randomUUID", "start", "end", "Returns a `LIST<INTEGER>` comprising all `INTEGER` values within a specified range.", "step", "Returns a `LIST<INTEGER>` comprising all `INTEGER` values within a specified range created with step length.",
    "range", "accumulator", "variable", "reduce", "(accumulator :: VARIABLE = initial :: ANY, variable :: VARIABLE IN list :: LIST<ANY> | expression :: ANY) :: ANY", "Runs an expression against individual elements of a `LIST<ANY>`, storing the result of the expression in an accumulator.", "Reduce", "Returns a `LIST<RELATIONSHIP>` containing all the `RELATIONSHIP` values in a `PATH`.", "relationships", "Relationships", "search", "replace", "Returns a `STRING` in which all occurrences of a specified search `STRING` in the given `STRING` have been replaced by another (specified) replacement `STRING`.",
    "Replace", "Returns a `STRING` or `LIST<ANY>` in which the order of all characters or elements in the given `STRING` or `LIST<ANY>` have been reversed.", "reverse", "Reverse", "Returns a `STRING` containing the specified number of rightmost characters in the given `STRING`.", "right", "Returns the value of a number rounded to the nearest `INTEGER`.", "precision", "Returns the value of a number rounded to the specified precision using rounding mode HALF_UP.", "Returns the value of a number rounded to the specified precision with the specified rounding mode.",
    "round", "Round", "Returns the given `STRING` with trailing whitespace removed.", "rtrim", "RTrim", "Returns the signum of an `INTEGER` or `FLOAT`: 0 if the number is 0, -1 for any negative number, and 1 for any positive number.", "sign", "Sign", "Returns the sine of a `FLOAT`.", "sin", "Sin", "Returns the number of items in a `LIST<ANY>` or the number of Unicode characters in a `STRING`.", "Size", "Returns the square root of a `FLOAT`.", "sqrt", "Sqrt", "splitDelimiters", "Returns a `LIST<STRING>` resulting from the splitting of the given `STRING` around matches of the given delimiter(s).",
    "split", "Split", "Returns the start `NODE` of a `RELATIONSHIP`.", "startNode", "StartNode", "Returns the standard deviation for the given value over a group for a sample of a population.", "stdev", "StdDev", "Returns the standard deviation for the given value over a group for an entire population.", "stdevp", "StdDevP", "Returns a substring of the given `STRING`, beginning with a 0-based index start.", "Returns a substring of a given `length` from the given `STRING`, beginning with a 0-based index start.",
    "substring", "Substring", "Returns the sum of a set of `INTEGER`, `FLOAT` or `DURATION` values", "sum", "Sum", "Returns all but the first element in a `LIST<ANY>`.", "tail", "Tail", "Returns the tangent of a `FLOAT`.", "tan", "Tan", "Converts a `BOOLEAN`, `STRING` or `INTEGER` value to a `BOOLEAN` value. For `INTEGER` values, 0 is defined to be false and any other `INTEGER` is defined to be true.", "toBoolean", "ToBoolean", "Converts a `LIST<ANY>` of values to a `LIST<BOOLEAN>` values. If any values are not convertible to `BOOLEAN` they will be null in the `LIST<BOOLEAN>` returned.",
    "toBooleanList", "ToBooleanList", "Converts a value to a `BOOLEAN` value, or null if the value cannot be converted.", "toBooleanOrNull", "ToBooleanOrNull", "Converts a `STRING`, `INTEGER` or `FLOAT` value to a `FLOAT` value.", "toFloat", "ToFloat", "Converts a `LIST<ANY>` to a `LIST<FLOAT>` values. If any values are not convertible to `FLOAT` they will be null in the `LIST<FLOAT>` returned.", "toFloatList", "ToFloatList", "Converts a value to a `FLOAT` value, or null if the value cannot be converted.", "toFloatOrNull",
    "ToFloatOrNull", "Converts a `BOOLEAN`, `STRING`, `INTEGER` or `FLOAT` value to an `INTEGER` value. For `BOOLEAN` values, true is defined to be 1 and false is defined to be 0.", "toInteger", "ToInteger", "Converts a `LIST<ANY>` to a `LIST<INTEGER>` values. If any values are not convertible to `INTEGER` they will be null in the `LIST<INTEGER>` returned.", "toIntegerList", "ToIntegerList", "Converts a value to an `INTEGER` value, or null if the value cannot be converted.", "toIntegerOrNull", "ToIntegerOrNull",
    "Returns the given `STRING` in lowercase.", "toLower", "ToLower", "Converts an `INTEGER`, `FLOAT`, `BOOLEAN`, `POINT` or temporal type (i.e. `DATE`, `ZONED TIME`, `LOCAL TIME`, `ZONED DATETIME`, `LOCAL DATETIME` or `DURATION`) value to a `STRING`.", "toString", "ToString", "Converts a `LIST<ANY>` to a `LIST<STRING>` values. If any values are not convertible to `STRING` they will be null in the `LIST<STRING>` returned.", "toStringList", "ToStringList", "Converts an `INTEGER`, `FLOAT`, `BOOLEAN`, `POINT` or temporal type (i.e. `DATE`, `ZONED TIME`, `LOCAL TIME`, `ZONED DATETIME`, `LOCAL DATETIME` or `DURATION`) value to a `STRING`, or null if the value cannot be converted.",
    "toStringOrNull", "ToStringOrNull", "Returns the given `STRING` in uppercase.", "toUpper", "ToUpper", "Returns a `MAP` containing all the properties of a `NODE`, `RELATIONSHIP` or `MAP`.", "Properties", "Returns the given `STRING` with leading and trailing whitespace removed.", "trim", "Trim", "Returns a `STRING` representation of the `RELATIONSHIP` type.", "Type", "Returns a `STRING` representation of the most precise value type that the given expression evaluates to.", "valueType", "ValueType", "point.withinBBox",
    "lowerLeft", "upperRight", "Returns true if the provided point is within the bounding box defined by the two provided points.", "WithinBBox", "FunctionTypeSignature", "Duplicate id: ", "Numeric", "Trigonometric", "Predicate", "Aggregating", "Scalar", "Temporal", "Logarithmic", "Spatial", "node pattern", "relationship pattern", "LabelExpressionPredicate", "label expression predicate", "Not", "Aggregation column contains implicit grouping expressions. For example, in \'RETURN n.a, n.a + n.b + count(*)\' the aggregation expression \'n.a + n.b + count(*)\' includes the implicit grouping key \'n.b\'. It may be possible to rewrite the query by extracting these grouping/aggregation expressions into a preceding WITH clause. Illegal expression(s): ",
    "NamespacedName", "UsingJoinHint", "Expected non-empty sequence of variables", "ProcedureResultItem", "The EXISTS expression is not valid in driver settings.", "The COUNT expression is not valid in driver settings.", "The COLLECT expression is not valid in driver settings.", "This expression is not valid in driver settings.", "ExistsExpression", "CountExpression", "CollectExpression", "DatabasePrivilege", "NamedDatabasesScope", "AllGraphsScope", "HomeGraphScope", "DefaultGraphScope", "NamedGraphsScope", "GraphPrivilege",
    "LoadPrivilege", "LOAD", "LoadAction", "FileResource", "LoadUrlQualifier", "LoadAllQualifier", "LoadCidrQualifier", "LabelAllQualifier", "ElementsAllQualifier", "DescSortItem", "AscSortItem", "SignedDecimalIntegerLiteral", "UsingIndexHint", "SeekOrScan", "SeekOnly", "SHORTEST ", " PATHS", "AnyShortestPath", "ALL SHORTEST PATHS", "AllShortestPaths", "ANY ", "AnyPath", "ALL PATHS", "AllPaths", " PATH GROUPS", "ShortestGroups", "PathPatternPart", "OnErrorContinue", "OnErrorBreak", "OnErrorFail", "MapProjection",
    "UsingAnyIndexType", "UsingTextIndexType", "UsingRangeIndexType", "UsingPointIndexType", "Annotations stack:", "The `USE` clause is not required for Administration Commands. Retry your query omitting the `USE` clause and it will be routed automatically.", "CommandResultItem", "ReadOnlyAccess", "ReadWriteAccess", "SKIP", "Skip", "LIMIT", "Limit", "CONCURRENT", "UNORDERED", "IDENTITY_FINISH", "ColonDisjunction", "DeprecatedRelTypeSeparatorNotification", "UnionReturnItemsInDifferentOrder", "FixedLengthRelationshipInShortestPath",
    "DeprecatedDatabaseNameNotification", "DeprecatedTextIndexProvider", "DeprecatedFunctionNotification", "PatternExpression", "RelationshipQualifier", "RelationshipAllQualifier", "LabelQualifier", "PatternQualifier", "ElementQualifier", "PropertiesResource", "AllPropertyResource", "LabelsResource", "AllLabelResource", "QuantifiedPath", "ParenthesizedPath", "PathConcatenation", "NaN", "True", "CountStar", "Infinity", "Equals", "GreaterThanOrEqual", "GreaterThan", "LessThanOrEqual", "LessThan", "InvalidNotEquals",
    "NotEquals", "Wrapper", "CheckFromContext", "PopAnnotation", "PrintAnnotations", "Not supported.", " is not supported for property value access rules.", "UNKNOWN", "UnresolvedFunction", "] ", "Illegal aggregation expression(s) in order by: ", ". If an aggregation expression is used in order by, it also needs to be a projection item on it\'s own. For example, in \'RETURN n.a, 1 + count(*) ORDER BY count(*) + 1\' the aggregation expression \'count(*) + 1\' is not a projection item on its own, but it could be rewritten to \'RETURN n.a, 1 + count(*) AS cnt ORDER BY 1 + count(*)\'.",
    "result of ", " + ", " cannot be represented as an integer", " - ", "result of -", " * ", "Unknown operation \'!=\' (you probably meant to use \'<>\', which is the operator for inequality testing)", "Cannot index nested properties", "FeatureError", "Failed to ", " with `", "`, PRIMARY must be greater than 0.", "`, SECONDARY must be a positive value.", "UserQualifier", "Error in semantic analysis: Unknown expression ", "): ", "Symbol", "AND", "( ", "Ands", "UnionMapping", "text-1.0", "Malformed input of length ",
    "Unmappable characters of length ", "MapExpression", "-?0o(_?[0-7]+)+", "SignedOctalIntegerLiteral", "-?0x(_?[0-9a-fA-F]+)+", "SignedHexIntegerLiteral", "-?(\\d+((_\\d+)?)*)?(\\.\\d+((_\\d+)?)*)?([eE]([+-])?\\d+((_\\d+)?)*)?", "DecimalDoubleLiteral", "CaseExpression", "PatternComprehension", "RelationshipsPattern", "Returns true if the predicate holds for all elements in the given `LIST<ANY>`.", "Returns true if the predicate holds for at least one element in the given `LIST<ANY>`.", "Returns true if the predicate holds for no element in the given `LIST<ANY>`.",
    "Returns true if the predicate holds for exactly one of the elements in the given `LIST<ANY>`.", "ShortestPathExpression", "Illegal symbolic name ", " inside a ", " at position: ", "Mapping", "All types in a Closed Dynamic Union must be nullable, or be appended with `NOT NULL`", "DeprecatedNodesOrRelationshipsInSetClauseNotification", "FunctionQualifier", "ProcedureQualifier", "SettingQualifier", "accumulator is ", " but expression has type ", "IS NULL", "IsNull", "IsNotNull", "Disjunctions", "Conjunctions",
    "ColonConjunction", "ListComprehension", "[...]", "ExtractScope", "ReduceExpression", "ReduceScope", ") in ", "AllIterablePredicate", "FilterScope", "AnyIterablePredicate", "NoneIterablePredicate", "SingleIterablePredicate", "LiteralEntry", "PropertySelector", "VariableSelector", "AllPropertiesSelector", "Subtract", "Add", "RegexMatch", "IS ::", "IsTyped", "Contains", "ENDS WITH", "EndsWith", "STARTS WITH", "StartsWith", "IS NOT ::", "IsNotTyped", "Patter is null", " PRIMARIES", " 1 PRIMARY", " SECONDARIES",
    " 1 SECONDARY", "Negation", "ContainerIndex", "ListSlice", " WHERE ", "WHEN", "THEN", "ELSE", "UnaryAdd", "UnarySubtract", "NODE_TYPE", "RELATIONSHIP_TYPE", "Wildcard", "Only single property ", " are supported", "WHERE", "fSet", "Is", "Precedence", "NonCapFSet", "AheadFSet", "BehindFSet", "AtomicFSet", "FinalSet", "<Empty set>", "JointSet", "NonCapJointSet", "PosLookaheadJointSet", "NegLookaheadJointSet", "PosBehindJointSet", "NegBehindJointSet", "Multiply", "Pow", "Divide", "Modulo", "TypeRange", "Incompatible TypeRange bounds",
    "T", "TypeSpec(", "<Quant>", "<GroupQuant>", "posFSet", "^ ", "range:", "CompositeRangeSet:  <nonsurrogate> ", " <surrogate> ", "UCI range:", "decomposed Hangul syllable:", "UCI ", "CI ", "decomposed char:", "<DotAllQuant>", "<DotQuant>", "<SOL>", "WordBoundary", "PreviousMatch", "<EOL>", "EOI", "DotAll", "<Unix MultiLine $>", "<MultiLine $>", "CI back reference: ", "back reference: ", "UCI back reference: ", "sequence: ", "UCI sequence: ", "CI sequence: ", "Lower", "Upper", "ASCII", "Alpha", "Digit", "Alnum",
    "Punct", "Graph", "Print", "Blank", "Cntrl", "XDigit", "javaLowerCase", "javaUpperCase", "javaWhitespace", "javaMirrored", "javaDefined", "javaDigit", "javaIdentifierIgnorable", "javaISOControl", "javaJavaIdentifierPart", "javaJavaIdentifierStart", "javaLetter", "javaLetterOrDigit", "javaSpaceChar", "javaTitleCase", "javaUnicodeIdentifierPart", "javaUnicodeIdentifierStart", "Space", "w", "W", "s", "S", "d", "D", "BasicLatin", "Latin-1Supplement", "LatinExtended-A", "LatinExtended-B", "IPAExtensions", "SpacingModifierLetters",
    "CombiningDiacriticalMarks", "Greek", "Cyrillic", "CyrillicSupplement", "Armenian", "Hebrew", "Arabic", "Syriac", "ArabicSupplement", "Thaana", "Devanagari", "Bengali", "Gurmukhi", "Gujarati", "Oriya", "Tamil", "Telugu", "Kannada", "Malayalam", "Sinhala", "Thai", "Lao", "Tibetan", "Myanmar", "Georgian", "HangulJamo", "Ethiopic", "EthiopicSupplement", "Cherokee", "UnifiedCanadianAboriginalSyllabics", "Ogham", "Runic", "Tagalog", "Hanunoo", "Buhid", "Tagbanwa", "Khmer", "Mongolian", "Limbu", "TaiLe", "NewTaiLue",
    "KhmerSymbols", "Buginese", "PhoneticExtensions", "PhoneticExtensionsSupplement", "CombiningDiacriticalMarksSupplement", "LatinExtendedAdditional", "GreekExtended", "GeneralPunctuation", "SuperscriptsandSubscripts", "CurrencySymbols", "CombiningMarksforSymbols", "LetterlikeSymbols", "NumberForms", "Arrows", "MathematicalOperators", "MiscellaneousTechnical", "ControlPictures", "OpticalCharacterRecognition", "EnclosedAlphanumerics", "BoxDrawing", "BlockElements", "GeometricShapes", "MiscellaneousSymbols", "Dingbats",
    "MiscellaneousMathematicalSymbols-A", "SupplementalArrows-A", "BraillePatterns", "SupplementalArrows-B", "MiscellaneousMathematicalSymbols-B", "SupplementalMathematicalOperators", "MiscellaneousSymbolsandArrows", "Glagolitic", "Coptic", "GeorgianSupplement", "Tifinagh", "EthiopicExtended", "SupplementalPunctuation", "CJKRadicalsSupplement", "KangxiRadicals", "IdeographicDescriptionCharacters", "CJKSymbolsandPunctuation", "Hiragana", "Katakana", "Bopomofo", "HangulCompatibilityJamo", "Kanbun", "BopomofoExtended",
    "CJKStrokes", "KatakanaPhoneticExtensions", "EnclosedCJKLettersandMonths", "CJKCompatibility", "CJKUnifiedIdeographsExtensionA", "YijingHexagramSymbols", "CJKUnifiedIdeographs", "YiSyllables", "YiRadicals", "ModifierToneLetters", "SylotiNagri", "HangulSyllables", "HighSurrogates", "HighPrivateUseSurrogates", "LowSurrogates", "PrivateUseArea", "CJKCompatibilityIdeographs", "AlphabeticPresentationForms", "ArabicPresentationForms-A", "VariationSelectors", "VerticalForms", "CombiningHalfMarks", "CJKCompatibilityForms",
    "SmallFormVariants", "ArabicPresentationForms-B", "HalfwidthandFullwidthForms", "Specials", "Cn", "IsL", "Lu", "Ll", "Lt", "Lm", "Lo", "IsM", "Mn", "Me", "Mc", "N", "Nd", "Nl", "No", "IsZ", "Zs", "Zl", "Zp", "IsC", "Cc", "Cf", "Co", "Cs", "IsP", "Pd", "Ps", "Pe", "Pc", "Po", "IsS", "Sm", "Sc", "Sk", "So", "Pf", "TreeAcc", "ExpressionTypeInfo", "NODE_OR_RELATIONSHIP", "FixedQuantifier", "PlusQuantifier", "StarQuantifier", "IntervalQuantifier", "Ordering", "Syntactic", "SkipChildren", "TraverseChildren", "TraverseChildrenNewAccForSiblings",
    " where ", "INCOMING", "BOTH", "OUTGOING", "<Invalid enum: no field for #", "The variable \'%1$s\' is referencing an entity that is created in the same CREATE clause which is not allowed. Please only reference variables created in earlier clauses.", "The %1$s variable \'%2$s\' is referencing a %1$s that is created in the same CREATE clause which is not allowed. Please only reference variables created in earlier clauses.", " IS ", "indexConfig", "Fby", "ALL DATA", "URL ", "CIDR ", "DeprecatedPropertyReferenceInCreate",
    "(...) requires \'| expression\' (an accumulation expression)", "distance", "\'distance\' has been replaced by \'point.distance\'", "Too many parameters for function \'", "Insufficient parameters for function \'", "\' is not a valid argument, must be a number in the range 0.0 to 1.0", "(...)", "(...) requires a pattern containing a single relationship", "A ", "(...) requires bound nodes when not part of a MATCH clause.", "The group count needs to be greater than 0.", "The path count needs to be greater than 0.",
    " cannot be used in ", ", but only in a MATCH clause.", "Quantified path patterns", "Sub-path assignment is currently not supported outside quantified path patterns.", "Variable length relationships must not use relationship type expressions.", "(non-quantified) parenthesized path pattern", "quantified path pattern", "simple path pattern", "single node", "A quantifier for a path pattern must not be limited by 0.", "A quantifier for a path pattern must not have a lower bound which exceeds its upper bound.\n             |In this case, the lower bound ",
    " is greater than the upper bound ", "The semantics of using colon in the separation of alternative relationship types in conjunction with\n         |the use of variable binding, inlined property predicates, or variable length is no longer supported.\n         |Please separate the relationships types using `", "` instead.", "Label expressions are not allowed to contain \'|:\'.\n         |If you want to express a disjunction of labels, please use `", "` instead", "Expected Pattern or RelationshipsPattern, but was ",
    "\u0000", "%s is not a valid token name. Token names cannot be empty or contain any null-bytes.", "(...) does not support a minimal length different from 0 or 1", "(...) is only allowed as a top-level element and not inside a parenthesized path pattern", "In this case, both ", " are ", "s.", "In this case, ", " is a ", "Juxtaposition is currently only supported for quantified path patterns.\n             |", "\n             |That is, neither of these is a quantified path pattern.", "Only directed relationships are supported in ",
    "a MATCH clause", "a MERGE clause", "a CREATE clause", "an expression", "Expression", "Label expressions in shortestPath are not allowed in an expression", "The start or end (or both) is required for a collection slice", "^-?[1-9][0-9]*$", "invalid literal number", "integer is too large", "^-?0o?[0-7]+$", "^-?0x[0-9a-fA-F]+$", "The EXISTS expression is not valid on SHOW commands.", "The COLLECT expression is not valid on SHOW commands.", "The COUNT expression is not valid on SHOW commands.", "Pattern expressions are not valid on SHOW commands.",
    "Subquery expressions are not valid on SHOW commands.", "Pattern comprehensions are not valid on SHOW commands.", "Long overflow", "Invalid use of aggregating function ", "(...) in this context", "Invalid use of DISTINCT with function \'", "(...) requires a WHERE predicate", "Can\'t use aggregating expressions inside of expressions executing over lists", "VariableGrouping", "Can\'t use aggregate functions inside of aggregate functions.", "Assigning a path in a quantified path pattern is not yet supported.",
    "(...) contains quantified pattern. This is currently not supported.", "(...) contains properties ", ". This is currently not supported.", "UnboundedShortestPathNotification", "Bound relationships not allowed in ", "Parameter maps cannot be used in `", "` patterns (use a literal map instead, e.g. `{id: $", ".id}`)", "one node", "A quantified path pattern needs to have at least one relationship.\n                 |In this case, the quantified path pattern ", " consists of only ", "\' points to symbol with different name \'",
    "\' in scope #", ". Scope tree:", "Variable length relationships cannot be used in ", "expression", "Introduced variables have not been computed yet", "Subquery expressions are not allowed in a MERGE clause.", "Invalid use of ", " inside FOREACH", "Missing transaction id to terminate, the transaction id can be found using `SHOW TRANSACTIONS`", "`WHERE` is not allowed by itself, please use `TERMINATE TRANSACTION ... YIELD ... WHERE ...` instead", "The property existence syntax `... exists(variable.property)` is no longer supported. Please use `variable.property IS NOT NULL` instead.",
    "Argument to ", "(...) is not a pattern", "A map with keys ", " is not describing a valid point, a point is described either by using cartesian coordinates e.g. {x: 2.3, y: 4.5, crs: \'cartesian\'} or using geographic coordinates e.g. {latitude: 12.78, longitude: 56.7, crs: \'WGS-84\'}.", "ON MATCH ", "ON CREATE ", " FIELDTERMINATOR ", "RETURN * is not allowed when there are no variables in scope", "CALL { ... } IN TRANSACTIONS nested in a regular CALL is not supported", "DELETE doesn\'t support removing labels from a node. Try REMOVE.",
    "Multiple join hints for same variable are not supported", "Match modes such as `", "` are not supported yet.", "Stream", "A Collect Expression cannot contain any updates", "A Collect Expression must end with a single return column.", "An Exists Expression cannot contain any updates", "A Count Expression cannot contain any updates", "` are not supported yet", "The IS keyword in patterns is not allowed in ", ", but only in a MATCH clause and in expressions", "Label expressions in patterns are not allowed in ",
    "Node pattern predicates are not allowed in ", ", but only in a MATCH clause or inside a pattern comprehension", "Relationship pattern predicates are not allowed in ", "Relationship pattern predicates are not supported for variable-length relationships.", "Relationship type expressions in patterns are not allowed in ", ", but only in a MATCH clause", "UNNAMED", "SolvableLabelExpression", "Quantified path patterns are not allowed to be nested.", "shortestPath(...) is only allowed as a top-level element and not inside a quantified path pattern",
    "Variable length relationships cannot be part of a quantified path pattern.", "Label expressions are not allowed to contain \'|:\'.", "Relationship types in a relationship type expressions may not be combined using \':\'", "Multiple result columns with the same name are not supported", "Procedure call cannot take an aggregating function as argument, please add a \'WITH\' to your statement.\n              |For example:\n              |    MATCH (n:Person) WITH collect(n.name) AS names CALL proc(names) YIELD value RETURN value",
    "o", "The octal integer literal syntax `", "` is no longer supported, please use `", "floating point number is too large", "The hex integer literal syntax `", "Mixing variable-length relationships (\'-[*]-\') with quantified relationships (\'()-->*()\') or quantified path patterns (\'(()-->())*\') is not allowed.", "UnsatisfiableRelationshipTypeExpression", "The variable `", "` is shadowing a variable with the same name from the outer scope and needs to be renamed", "PatternExpressions are not allowed to introduce new variables: \'",
    "Nested CALL { ... } IN TRANSACTIONS is not supported", "Type mismatch: expected Boolean, Float, Integer, Point, String, Duration, Date, Time, LocalTime, LocalDateTime or DateTime but was ", "Type mismatch: expected Boolean or String but was ", "Type mismatch: expected Boolean, Integer or String but was ", "LabelExpressionsPartition", "Missing a case for label expression location", "expected ", " but was ", "Done", "Call", " {2}(", ")(\\d+)", " {2}(AUTOINT|AUTODOUBLE|AUTOSTRING|AUTOLIST)(\\d+)", " {2}([^\\s]+)@\\d+(?:\\(.*?\\))?",
    "Trying to YIELD non-existing column: `", " ASCENDING", " DESCENDING", "RepeatedRelationshipReference", "RepeatedVarLengthRelationshipReference", "list index must be given as Integer, but was ", "map key must be given as String, but was ", "node or relationship property key must be given as String, but was ", "Mixing label expression symbols (\'|\', \'&\', \'!\', and \'%\') with colon (\':\') is not allowed. Please only use one set of symbols. This expression could be expressed as :", "Mixing the IS keyword with colon (\':\') between labels is not allowed. This expression could be expressed as IS ",
    "Cont", "Invalid graph reference", "ViewRef", "CatalogName", "GraphRefParameter", "positive", "non-negative", "Invalid input. \'", "\' is not a valid value. Must be a ", " integer.", "longitude", "latitude", "public", "protected", "private", "abstract", "static", "final", "transient", "volatile", "synchronized", "native", "strictfp", "interface", "Expression in ", " must be aliased (use AS)", "A top-level path pattern in a `MATCH` clause must be written such that it always evaluates to at least one node pattern.\n           |In this case, `",
    "` would result in an empty pattern.", "The pattern may yield an infinite number of rows under match mode REPEATABLE ELEMENTS, perhaps use a path selector or add an upper bound to your quantified path patterns.", "Multiple path patterns cannot be used in the same clause in combination with a selective path selector.", "Multiple path patterns cannot be used in the same clause in combination with a selective path selector. You may want to use multiple MATCH clauses, or you might want to consider using the REPEATABLE ELEMENTS match mode.",
    "It is not allowed to refer to variables in ", ", so that the value for ", " can be statically calculated.", "It is not allowed to use patterns in the expression for ", "` occurs in multiple quantified path patterns and needs to be renamed.", "` occurs both inside and outside a quantified path pattern and needs to be renamed.", "` is already defined in a previous clause, it cannot be referenced as a node or as a relationship variable inside of a quantified path pattern.", "SomeUnknownLabels", "tail of empty stream",
    "head of empty stream", "` already declared in outer scope", "Cannot use join hint for single node pattern.", "CartesianProductNotification", "From within a quantified path pattern, one may only reference variables, that are already bound in a previous `MATCH` clause.\n             |In this case, ", " is defined in the same `MATCH` clause as ", "Scope dependencies have not been computed yet", "KnownLabels", "\\(line (\\d+), column (\\d+) \\(offset: (\\d+)\\)\\)", "SubqueryVariableShadowing", "In a WITH/RETURN with DISTINCT or an aggregation, it is not possible to access variables declared before the WITH/RETURN: ",
    "Aliasing or expressions are not supported", "DISTINCT is not allowed", "WHERE is not allowed", "ORDER BY is not allowed", "SKIP is not allowed", "LIMIT is not allowed", "withinBBox", "uninitialized", "already initialized"]);
    jl_String.prototype.toString = function() {
        return $rt_ustr(this);
    };
    jl_String.prototype.valueOf = jl_String.prototype.toString;
    jl_Object.prototype.toString = function() {
        return $rt_ustr(jl_Object_toString(this));
    };
    jl_Object.prototype.__teavm_class__ = function() {
        return $dbg_class(this);
    };
    var Long_eq;
    var Long_ne;
    var Long_gt;
    var Long_ge;
    var Long_lt;
    var Long_le;
    var Long_compare;
    var Long_add;
    var Long_sub;
    var Long_inc;
    var Long_dec;
    var Long_mul;
    var Long_div;
    var Long_rem;
    var Long_udiv;
    var Long_urem;
    var Long_neg;
    var Long_and;
    var Long_or;
    var Long_xor;
    var Long_shl;
    var Long_shr;
    var Long_shru;
    var Long_not;
    if (typeof $rt_globals.BigInt !== 'function') {
        Long_eq = function(a, b) {
            return a.hi === b.hi && a.lo === b.lo;
        };
        Long_ne = function(a, b) {
            return a.hi !== b.hi || a.lo !== b.lo;
        };
        Long_gt = function(a, b) {
            if (a.hi < b.hi) {
                return false;
            }
            if (a.hi > b.hi) {
                return true;
            }
            var x = a.lo >>> 1;
            var y = b.lo >>> 1;
            if (x !== y) {
                return x > y;
            }
            return (a.lo & 1) > (b.lo & 1);
        };
        Long_ge = function(a, b) {
            if (a.hi < b.hi) {
                return false;
            }
            if (a.hi > b.hi) {
                return true;
            }
            var x = a.lo >>> 1;
            var y = b.lo >>> 1;
            if (x !== y) {
                return x >= y;
            }
            return (a.lo & 1) >= (b.lo & 1);
        };
        Long_lt = function(a, b) {
            if (a.hi > b.hi) {
                return false;
            }
            if (a.hi < b.hi) {
                return true;
            }
            var x = a.lo >>> 1;
            var y = b.lo >>> 1;
            if (x !== y) {
                return x < y;
            }
            return (a.lo & 1) < (b.lo & 1);
        };
        Long_le = function(a, b) {
            if (a.hi > b.hi) {
                return false;
            }
            if (a.hi < b.hi) {
                return true;
            }
            var x = a.lo >>> 1;
            var y = b.lo >>> 1;
            if (x !== y) {
                return x <= y;
            }
            return (a.lo & 1) <= (b.lo & 1);
        };
        Long_add = function(a, b) {
            if (a.hi === a.lo >> 31 && b.hi === b.lo >> 31) {
                return Long_fromNumber(a.lo + b.lo);
            } else if ($rt_globals.Math.abs(a.hi) < Long_MAX_NORMAL && $rt_globals.Math.abs(b.hi) < Long_MAX_NORMAL) {
                return Long_fromNumber(Long_toNumber(a) + Long_toNumber(b));
            }
            var a_lolo = a.lo & 0xFFFF;
            var a_lohi = a.lo >>> 16;
            var a_hilo = a.hi & 0xFFFF;
            var a_hihi = a.hi >>> 16;
            var b_lolo = b.lo & 0xFFFF;
            var b_lohi = b.lo >>> 16;
            var b_hilo = b.hi & 0xFFFF;
            var b_hihi = b.hi >>> 16;
            var lolo = a_lolo + b_lolo | 0;
            var lohi = a_lohi + b_lohi + (lolo >> 16) | 0;
            var hilo = a_hilo + b_hilo + (lohi >> 16) | 0;
            var hihi = a_hihi + b_hihi + (hilo >> 16) | 0;
            return new Long(lolo & 0xFFFF | (lohi & 0xFFFF) << 16, hilo & 0xFFFF | (hihi & 0xFFFF) << 16);
        };
        Long_inc = function(a) {
            var lo = a.lo + 1 | 0;
            var hi = a.hi;
            if (lo === 0) {
                hi = hi + 1 | 0;
            }
            return new Long(lo, hi);
        };
        Long_dec = function(a) {
            var lo = a.lo - 1 | 0;
            var hi = a.hi;
            if (lo ===  -1) {
                hi = hi - 1 | 0;
            }
            return new Long(lo, hi);
        };
        Long_neg = function(a) {
            return Long_inc(new Long(a.lo ^ 0xFFFFFFFF, a.hi ^ 0xFFFFFFFF));
        };
        Long_sub = function(a, b) {
            if (a.hi === a.lo >> 31 && b.hi === b.lo >> 31) {
                return Long_fromNumber(a.lo - b.lo);
            }
            var a_lolo = a.lo & 0xFFFF;
            var a_lohi = a.lo >>> 16;
            var a_hilo = a.hi & 0xFFFF;
            var a_hihi = a.hi >>> 16;
            var b_lolo = b.lo & 0xFFFF;
            var b_lohi = b.lo >>> 16;
            var b_hilo = b.hi & 0xFFFF;
            var b_hihi = b.hi >>> 16;
            var lolo = a_lolo - b_lolo | 0;
            var lohi = a_lohi - b_lohi + (lolo >> 16) | 0;
            var hilo = a_hilo - b_hilo + (lohi >> 16) | 0;
            var hihi = a_hihi - b_hihi + (hilo >> 16) | 0;
            return new Long(lolo & 0xFFFF | (lohi & 0xFFFF) << 16, hilo & 0xFFFF | (hihi & 0xFFFF) << 16);
        };
        Long_compare = function(a, b) {
            var r = a.hi - b.hi;
            if (r !== 0) {
                return r;
            }
            r = (a.lo >>> 1) - (b.lo >>> 1);
            if (r !== 0) {
                return r;
            }
            return (a.lo & 1) - (b.lo & 1);
        };
        Long_mul = function(a, b) {
            var positive = Long_isNegative(a) === Long_isNegative(b);
            if (Long_isNegative(a)) {
                a = Long_neg(a);
            }
            if (Long_isNegative(b)) {
                b = Long_neg(b);
            }
            var a_lolo = a.lo & 0xFFFF;
            var a_lohi = a.lo >>> 16;
            var a_hilo = a.hi & 0xFFFF;
            var a_hihi = a.hi >>> 16;
            var b_lolo = b.lo & 0xFFFF;
            var b_lohi = b.lo >>> 16;
            var b_hilo = b.hi & 0xFFFF;
            var b_hihi = b.hi >>> 16;
            var lolo = 0;
            var lohi = 0;
            var hilo = 0;
            var hihi = 0;
            lolo = a_lolo * b_lolo | 0;
            lohi = lolo >>> 16;
            lohi = (lohi & 0xFFFF) + a_lohi * b_lolo | 0;
            hilo = hilo + (lohi >>> 16) | 0;
            lohi = (lohi & 0xFFFF) + a_lolo * b_lohi | 0;
            hilo = hilo + (lohi >>> 16) | 0;
            hihi = hilo >>> 16;
            hilo = (hilo & 0xFFFF) + a_hilo * b_lolo | 0;
            hihi = hihi + (hilo >>> 16) | 0;
            hilo = (hilo & 0xFFFF) + a_lohi * b_lohi | 0;
            hihi = hihi + (hilo >>> 16) | 0;
            hilo = (hilo & 0xFFFF) + a_lolo * b_hilo | 0;
            hihi = hihi + (hilo >>> 16) | 0;
            hihi = hihi + a_hihi * b_lolo + a_hilo * b_lohi + a_lohi * b_hilo + a_lolo * b_hihi | 0;
            var result = new Long(lolo & 0xFFFF | lohi << 16, hilo & 0xFFFF | hihi << 16);
            return positive ? result : Long_neg(result);
        };
        Long_div = function(a, b) {
            if ($rt_globals.Math.abs(a.hi) < Long_MAX_NORMAL && $rt_globals.Math.abs(b.hi) < Long_MAX_NORMAL) {
                return Long_fromNumber(Long_toNumber(a) / Long_toNumber(b));
            }
            return (Long_divRem(a, b))[0];
        };
        Long_udiv = function(a, b) {
            if (a.hi >= 0 && a.hi < Long_MAX_NORMAL && b.hi >= 0 && b.hi < Long_MAX_NORMAL) {
                return Long_fromNumber(Long_toNumber(a) / Long_toNumber(b));
            }
            return (Long_udivRem(a, b))[0];
        };
        Long_rem = function(a, b) {
            if ($rt_globals.Math.abs(a.hi) < Long_MAX_NORMAL && $rt_globals.Math.abs(b.hi) < Long_MAX_NORMAL) {
                return Long_fromNumber(Long_toNumber(a) % Long_toNumber(b));
            }
            return (Long_divRem(a, b))[1];
        };
        Long_urem = function(a, b) {
            if (a.hi >= 0 && a.hi < Long_MAX_NORMAL && b.hi >= 0 && b.hi < Long_MAX_NORMAL) {
                return Long_fromNumber(Long_toNumber(a) / Long_toNumber(b));
            }
            return (Long_udivRem(a, b))[1];
        };
        function Long_divRem(a, b) {
            if (b.lo === 0 && b.hi === 0) {
                throw new $rt_globals.Error("Division by zero");
            }
            var positive = Long_isNegative(a) === Long_isNegative(b);
            if (Long_isNegative(a)) {
                a = Long_neg(a);
            }
            if (Long_isNegative(b)) {
                b = Long_neg(b);
            }
            a = new LongInt(a.lo, a.hi, 0);
            b = new LongInt(b.lo, b.hi, 0);
            var q = LongInt_div(a, b);
            a = new Long(a.lo, a.hi);
            q = new Long(q.lo, q.hi);
            return positive ? [q, a] : [Long_neg(q), Long_neg(a)];
        }
        function Long_udivRem(a, b) {
            if (b.lo === 0 && b.hi === 0) {
                throw new $rt_globals.Error("Division by zero");
            }
            a = new LongInt(a.lo, a.hi, 0);
            b = new LongInt(b.lo, b.hi, 0);
            var q = LongInt_div(a, b);
            a = new Long(a.lo, a.hi);
            q = new Long(q.lo, q.hi);
            return [q, a];
        }
        function Long_shiftLeft16(a) {
            return new Long(a.lo << 16, a.lo >>> 16 | a.hi << 16);
        }
        function Long_shiftRight16(a) {
            return new Long(a.lo >>> 16 | a.hi << 16, a.hi >>> 16);
        }
        Long_and = function(a, b) {
            return new Long(a.lo & b.lo, a.hi & b.hi);
        };
        Long_or = function(a, b) {
            return new Long(a.lo | b.lo, a.hi | b.hi);
        };
        Long_xor = function(a, b) {
            return new Long(a.lo ^ b.lo, a.hi ^ b.hi);
        };
        Long_shl = function(a, b) {
            b &= 63;
            if (b === 0) {
                return a;
            } else if (b < 32) {
                return new Long(a.lo << b, a.lo >>> 32 - b | a.hi << b);
            } else if (b === 32) {
                return new Long(0, a.lo);
            } else {
                return new Long(0, a.lo << b - 32);
            }
        };
        Long_shr = function(a, b) {
            b &= 63;
            if (b === 0) {
                return a;
            } else if (b < 32) {
                return new Long(a.lo >>> b | a.hi << 32 - b, a.hi >> b);
            } else if (b === 32) {
                return new Long(a.hi, a.hi >> 31);
            } else {
                return new Long(a.hi >> b - 32, a.hi >> 31);
            }
        };
        Long_shru = function(a, b) {
            b &= 63;
            if (b === 0) {
                return a;
            } else if (b < 32) {
                return new Long(a.lo >>> b | a.hi << 32 - b, a.hi >>> b);
            } else if (b === 32) {
                return new Long(a.hi, 0);
            } else {
                return new Long(a.hi >>> b - 32, 0);
            }
        };
        Long_not = function(a) {
            return new Long(~a.hi, ~a.lo);
        };
        function LongInt(lo, hi, sup) {
            this.lo = lo;
            this.hi = hi;
            this.sup = sup;
        }
        function LongInt_mul(a, b) {
            var a_lolo = (a.lo & 0xFFFF) * b | 0;
            var a_lohi = (a.lo >>> 16) * b | 0;
            var a_hilo = (a.hi & 0xFFFF) * b | 0;
            var a_hihi = (a.hi >>> 16) * b | 0;
            var sup = a.sup * b | 0;
            a_lohi = a_lohi + (a_lolo >>> 16) | 0;
            a_hilo = a_hilo + (a_lohi >>> 16) | 0;
            a_hihi = a_hihi + (a_hilo >>> 16) | 0;
            sup = sup + (a_hihi >>> 16) | 0;
            a.lo = a_lolo & 0xFFFF | a_lohi << 16;
            a.hi = a_hilo & 0xFFFF | a_hihi << 16;
            a.sup = sup & 0xFFFF;
        }
        function LongInt_sub(a, b) {
            var a_lolo = a.lo & 0xFFFF;
            var a_lohi = a.lo >>> 16;
            var a_hilo = a.hi & 0xFFFF;
            var a_hihi = a.hi >>> 16;
            var b_lolo = b.lo & 0xFFFF;
            var b_lohi = b.lo >>> 16;
            var b_hilo = b.hi & 0xFFFF;
            var b_hihi = b.hi >>> 16;
            a_lolo = a_lolo - b_lolo | 0;
            a_lohi = a_lohi - b_lohi + (a_lolo >> 16) | 0;
            a_hilo = a_hilo - b_hilo + (a_lohi >> 16) | 0;
            a_hihi = a_hihi - b_hihi + (a_hilo >> 16) | 0;
            var sup = a.sup - b.sup + (a_hihi >> 16) | 0;
            a.lo = a_lolo & 0xFFFF | a_lohi << 16;
            a.hi = a_hilo & 0xFFFF | a_hihi << 16;
            a.sup = sup;
        }
        function LongInt_add(a, b) {
            var a_lolo = a.lo & 0xFFFF;
            var a_lohi = a.lo >>> 16;
            var a_hilo = a.hi & 0xFFFF;
            var a_hihi = a.hi >>> 16;
            var b_lolo = b.lo & 0xFFFF;
            var b_lohi = b.lo >>> 16;
            var b_hilo = b.hi & 0xFFFF;
            var b_hihi = b.hi >>> 16;
            a_lolo = a_lolo + b_lolo | 0;
            a_lohi = a_lohi + b_lohi + (a_lolo >> 16) | 0;
            a_hilo = a_hilo + b_hilo + (a_lohi >> 16) | 0;
            a_hihi = a_hihi + b_hihi + (a_hilo >> 16) | 0;
            var sup = a.sup + b.sup + (a_hihi >> 16) | 0;
            a.lo = a_lolo & 0xFFFF | a_lohi << 16;
            a.hi = a_hilo & 0xFFFF | a_hihi << 16;
            a.sup = sup;
        }
        function LongInt_inc(a) {
            a.lo = a.lo + 1 | 0;
            if (a.lo === 0) {
                a.hi = a.hi + 1 | 0;
                if (a.hi === 0) {
                    a.sup = a.sup + 1 & 0xFFFF;
                }
            }
        }
        function LongInt_dec(a) {
            a.lo = a.lo - 1 | 0;
            if (a.lo ===  -1) {
                a.hi = a.hi - 1 | 0;
                if (a.hi ===  -1) {
                    a.sup = a.sup - 1 & 0xFFFF;
                }
            }
        }
        function LongInt_ucompare(a, b) {
            var r = a.sup - b.sup;
            if (r !== 0) {
                return r;
            }
            r = (a.hi >>> 1) - (b.hi >>> 1);
            if (r !== 0) {
                return r;
            }
            r = (a.hi & 1) - (b.hi & 1);
            if (r !== 0) {
                return r;
            }
            r = (a.lo >>> 1) - (b.lo >>> 1);
            if (r !== 0) {
                return r;
            }
            return (a.lo & 1) - (b.lo & 1);
        }
        function LongInt_numOfLeadingZeroBits(a) {
            var n = 0;
            var d = 16;
            while (d > 0) {
                if (a >>> d !== 0) {
                    a >>>= d;
                    n = n + d | 0;
                }
                d = d / 2 | 0;
            }
            return 31 - n;
        }
        function LongInt_shl(a, b) {
            if (b === 0) {
                return;
            }
            if (b < 32) {
                a.sup = (a.hi >>> 32 - b | a.sup << b) & 0xFFFF;
                a.hi = a.lo >>> 32 - b | a.hi << b;
                a.lo <<= b;
            } else if (b === 32) {
                a.sup = a.hi & 0xFFFF;
                a.hi = a.lo;
                a.lo = 0;
            } else if (b < 64) {
                a.sup = (a.lo >>> 64 - b | a.hi << b - 32) & 0xFFFF;
                a.hi = a.lo << b;
                a.lo = 0;
            } else if (b === 64) {
                a.sup = a.lo & 0xFFFF;
                a.hi = 0;
                a.lo = 0;
            } else {
                a.sup = a.lo << b - 64 & 0xFFFF;
                a.hi = 0;
                a.lo = 0;
            }
        }
        function LongInt_shr(a, b) {
            if (b === 0) {
                return;
            }
            if (b === 32) {
                a.lo = a.hi;
                a.hi = a.sup;
                a.sup = 0;
            } else if (b < 32) {
                a.lo = a.lo >>> b | a.hi << 32 - b;
                a.hi = a.hi >>> b | a.sup << 32 - b;
                a.sup >>>= b;
            } else if (b === 64) {
                a.lo = a.sup;
                a.hi = 0;
                a.sup = 0;
            } else if (b < 64) {
                a.lo = a.hi >>> b - 32 | a.sup << 64 - b;
                a.hi = a.sup >>> b - 32;
                a.sup = 0;
            } else {
                a.lo = a.sup >>> b - 64;
                a.hi = 0;
                a.sup = 0;
            }
        }
        function LongInt_copy(a) {
            return new LongInt(a.lo, a.hi, a.sup);
        }
        function LongInt_div(a, b) {
            var bits = b.hi !== 0 ? LongInt_numOfLeadingZeroBits(b.hi) : LongInt_numOfLeadingZeroBits(b.lo) + 32;
            var sz = 1 + (bits / 16 | 0);
            var dividentBits = bits % 16;
            LongInt_shl(b, bits);
            LongInt_shl(a, dividentBits);
            var q = new LongInt(0, 0, 0);
            while (sz-- > 0) {
                LongInt_shl(q, 16);
                var digitA = (a.hi >>> 16) + 0x10000 * a.sup;
                var digitB = b.hi >>> 16;
                var digit = digitA / digitB | 0;
                var t = LongInt_copy(b);
                LongInt_mul(t, digit);
                if (LongInt_ucompare(t, a) >= 0) {
                    while (LongInt_ucompare(t, a) > 0) {
                        LongInt_sub(t, b);
                        --digit;
                    }
                } else {
                    while (true) {
                        var nextT = LongInt_copy(t);
                        LongInt_add(nextT, b);
                        if (LongInt_ucompare(nextT, a) > 0) {
                            break;
                        }
                        t = nextT;
                        ++digit;
                    }
                }
                LongInt_sub(a, t);
                q.lo |= digit;
                LongInt_shl(a, 16);
            }
            LongInt_shr(a, bits + 16);
            return q;
        }
    } else {
        Long_eq = function(a, b) {
            return a === b;
        };
        Long_ne = function(a, b) {
            return a !== b;
        };
        Long_gt = function(a, b) {
            return a > b;
        };
        Long_ge = function(a, b) {
            return a >= b;
        };
        Long_lt = function(a, b) {
            return a < b;
        };
        Long_le = function(a, b) {
            return a <= b;
        };
        Long_add = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a + b);
        };
        Long_inc = function(a) {
            return $rt_globals.BigInt.asIntN(64, a + 1);
        };
        Long_dec = function(a) {
            return $rt_globals.BigInt.asIntN(64, a - 1);
        };
        Long_neg = function(a) {
            return $rt_globals.BigInt.asIntN(64,  -a);
        };
        Long_sub = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a - b);
        };
        Long_compare = function(a, b) {
            return a < b ?  -1 : a > b ? 1 : 0;
        };
        Long_mul = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a * b);
        };
        Long_div = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a / b);
        };
        Long_udiv = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, $rt_globals.BigInt.asUintN(64, a) / $rt_globals.BigInt.asUintN(64, b));
        };
        Long_rem = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a % b);
        };
        Long_urem = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, $rt_globals.BigInt.asUintN(64, a) % $rt_globals.BigInt.asUintN(64, b));
        };
        Long_and = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a & b);
        };
        Long_or = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a | b);
        };
        Long_xor = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a ^ b);
        };
        Long_shl = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a << $rt_globals.BigInt(b & 63));
        };
        Long_shr = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, a >> $rt_globals.BigInt(b & 63));
        };
        Long_shru = function(a, b) {
            return $rt_globals.BigInt.asIntN(64, $rt_globals.BigInt.asUintN(64, a) >> $rt_globals.BigInt(b & 63));
        };
        Long_not = function(a) {
            return $rt_globals.BigInt.asIntN(64, ~a);
        };
    }
    var Long_add = Long_add;

    var Long_sub = Long_sub;

    var Long_mul = Long_mul;

    var Long_div = Long_div;

    var Long_rem = Long_rem;

    var Long_or = Long_or;

    var Long_and = Long_and;

    var Long_xor = Long_xor;

    var Long_shl = Long_shl;

    var Long_shr = Long_shr;

    var Long_shru = Long_shru;

    var Long_compare = Long_compare;

    var Long_eq = Long_eq;

    var Long_ne = Long_ne;

    var Long_lt = Long_lt;

    var Long_le = Long_le;

    var Long_gt = Long_gt;

    var Long_ge = Long_ge;

    var Long_not = Long_not;

    var Long_neg = Long_neg;

    function $rt_startThread(runner, callback) {
        var result;
        try {
            result = runner();
        } catch (e){
            result = e;
        }
        if (typeof callback !== 'undefined') {
            callback(result);
        } else if (result instanceof $rt_globals.Error) {
            throw result;
        }
    }
    function $rt_suspending() {
        return false;
    }
    function $rt_resuming() {
        return false;
    }
    function $rt_nativeThread() {
        return null;
    }
    function $rt_invalidPointer() {
    }
    main = $rt_mainStarter(ons_MainNodejs_main);
    main.javaException = $rt_javaException;
    })(globalThis);

    return main([queryText])
}  